#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 6560
#define LARGE_STATE_COUNT 2739
#define SYMBOL_COUNT 483
#define ALIAS_COUNT 1
#define TOKEN_COUNT 236
#define EXTERNAL_TOKEN_COUNT 8
#define FIELD_COUNT 13
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 40

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym__bom = 2,
  anon_sym_POUND_BANG = 3,
  aux_sym_shebang_token1 = 4,
  aux_sym_htmlentity_token1 = 5,
  anon_sym_BSLASH_SQUOTE = 6,
  anon_sym_BSLASH_DQUOTE = 7,
  anon_sym_BSLASH_QMARK = 8,
  anon_sym_BSLASH_BSLASH = 9,
  anon_sym_BSLASHa = 10,
  anon_sym_BSLASHb = 11,
  anon_sym_BSLASHf = 12,
  anon_sym_BSLASHn = 13,
  anon_sym_BSLASHr = 14,
  anon_sym_BSLASHt = 15,
  anon_sym_BSLASHv = 16,
  aux_sym_escape_sequence_token1 = 17,
  aux_sym_escape_sequence_token2 = 18,
  aux_sym_escape_sequence_token3 = 19,
  aux_sym_escape_sequence_token4 = 20,
  anon_sym_q_LBRACE = 21,
  anon_sym_RBRACE = 22,
  anon_sym_LBRACE = 23,
  anon_sym_SLASH = 24,
  anon_sym_SLASH_EQ = 25,
  anon_sym_DOT = 26,
  anon_sym_DOT_DOT = 27,
  anon_sym_DOT_DOT_DOT = 28,
  anon_sym_AMP = 29,
  anon_sym_AMP_EQ = 30,
  anon_sym_AMP_AMP = 31,
  anon_sym_PIPE = 32,
  anon_sym_PIPE_EQ = 33,
  anon_sym_PIPE_PIPE = 34,
  anon_sym_DASH = 35,
  anon_sym_DASH_EQ = 36,
  anon_sym_DASH_DASH = 37,
  anon_sym_PLUS = 38,
  anon_sym_PLUS_EQ = 39,
  anon_sym_PLUS_PLUS = 40,
  anon_sym_LT = 41,
  anon_sym_LT_EQ = 42,
  anon_sym_LT_LT = 43,
  anon_sym_LT_LT_EQ = 44,
  anon_sym_GT = 45,
  anon_sym_GT_EQ = 46,
  anon_sym_GT_GT_EQ = 47,
  anon_sym_GT_GT_GT_EQ = 48,
  anon_sym_GT_GT = 49,
  anon_sym_GT_GT_GT = 50,
  anon_sym_BANG = 51,
  anon_sym_BANG_EQ = 52,
  anon_sym_LPAREN = 53,
  anon_sym_RPAREN = 54,
  anon_sym_LBRACK = 55,
  anon_sym_RBRACK = 56,
  anon_sym_QMARK = 57,
  anon_sym_COMMA = 58,
  anon_sym_SEMI = 59,
  anon_sym_COLON = 60,
  anon_sym_DOLLAR = 61,
  anon_sym_EQ = 62,
  anon_sym_EQ_EQ = 63,
  anon_sym_STAR = 64,
  anon_sym_STAR_EQ = 65,
  anon_sym_PERCENT = 66,
  anon_sym_PERCENT_EQ = 67,
  anon_sym_CARET = 68,
  anon_sym_CARET_EQ = 69,
  anon_sym_CARET_CARET = 70,
  anon_sym_CARET_CARET_EQ = 71,
  anon_sym_TILDE = 72,
  anon_sym_TILDE_EQ = 73,
  anon_sym_AT = 74,
  anon_sym_EQ_GT = 75,
  anon_sym_POUND = 76,
  sym_bool = 77,
  sym_byte = 78,
  sym_ubyte = 79,
  sym_char = 80,
  sym_short = 81,
  sym_ushort = 82,
  sym_int = 83,
  sym_uint = 84,
  sym_long = 85,
  sym_ulong = 86,
  sym_cent = 87,
  sym_ucent = 88,
  sym_wchar = 89,
  sym_dchar = 90,
  sym_float = 91,
  sym_double = 92,
  sym_real = 93,
  sym_ifloat = 94,
  sym_idouble = 95,
  sym_ireal = 96,
  sym_cfloat = 97,
  sym_cdouble = 98,
  sym_creal = 99,
  sym_size_t = 100,
  sym_ptrdiff_t = 101,
  sym_string = 102,
  sym_cstring = 103,
  sym_dstring = 104,
  sym_wstring = 105,
  sym_noreturn = 106,
  sym_true = 107,
  sym_false = 108,
  sym_null = 109,
  sym_super = 110,
  sym_this = 111,
  sym_abstract = 112,
  sym_alias = 113,
  sym_align = 114,
  sym_asm = 115,
  sym_assert = 116,
  sym_auto = 117,
  sym_break = 118,
  sym_case = 119,
  sym_cast = 120,
  sym_catch = 121,
  sym_class = 122,
  sym_const = 123,
  sym_continue = 124,
  sym_debug = 125,
  sym_default = 126,
  sym_delegate = 127,
  sym_delete = 128,
  sym_deprecated = 129,
  sym_do = 130,
  sym_else = 131,
  sym_enum = 132,
  sym_export = 133,
  sym_extern = 134,
  sym_final = 135,
  sym_finally = 136,
  sym_for = 137,
  sym_foreach = 138,
  sym_foreach_reverse = 139,
  sym_function = 140,
  sym_goto = 141,
  sym_if = 142,
  sym_immutable = 143,
  sym_import = 144,
  sym_in = 145,
  sym_inout = 146,
  sym_interface = 147,
  sym_invariant = 148,
  sym_is = 149,
  sym_lazy = 150,
  sym_mixin = 151,
  sym_module = 152,
  sym_new = 153,
  sym_nothrow = 154,
  sym_out = 155,
  sym_override = 156,
  sym_package = 157,
  sym_pragma = 158,
  sym_private = 159,
  sym_protected = 160,
  sym_public = 161,
  sym_pure = 162,
  sym_ref = 163,
  sym_return = 164,
  sym_scope = 165,
  sym_shared = 166,
  sym_static = 167,
  sym_struct = 168,
  sym_switch = 169,
  sym_synchronized = 170,
  sym_template = 171,
  sym_throw = 172,
  sym_try = 173,
  sym_typeid = 174,
  sym_typeof = 175,
  sym_union = 176,
  sym_unittest = 177,
  sym_version = 178,
  sym_while = 179,
  sym_with = 180,
  sym_parameters_ = 181,
  sym_gshared = 182,
  sym_traits = 183,
  sym_vector = 184,
  sym_void = 185,
  anon_sym_C = 186,
  anon_sym_D = 187,
  anon_sym_Windows = 188,
  anon_sym_System = 189,
  anon_sym_Objective = 190,
  anon_sym_BQUOTE = 191,
  aux_sym_raw_string_token1 = 192,
  aux_sym_raw_string_token2 = 193,
  anon_sym_r_DQUOTE = 194,
  aux_sym_raw_string_token3 = 195,
  aux_sym_raw_string_token4 = 196,
  anon_sym_x_DQUOTE = 197,
  aux_sym_hex_string_token1 = 198,
  anon_sym_DQUOTE = 199,
  aux_sym_quoted_string_token1 = 200,
  anon_sym_DOLLAR_LPAREN = 201,
  anon_sym_i_BQUOTE = 202,
  aux_sym_interpolated_raw_string_token1 = 203,
  aux_sym_interpolated_raw_string_token2 = 204,
  anon_sym_DOLLAR_BQUOTE = 205,
  sym_interpolated_escape = 206,
  anon_sym_i_DQUOTE = 207,
  aux_sym_interpolated_quoted_string_token1 = 208,
  aux_sym_interpolated_quoted_string_token2 = 209,
  anon_sym_DOLLAR_DQUOTE = 210,
  anon_sym_iq_LBRACE = 211,
  aux_sym_char_literal_token1 = 212,
  anon_sym_SQUOTE = 213,
  anon_sym___DATE__ = 214,
  anon_sym___FILE__ = 215,
  anon_sym___FILE_FULL_PATH__ = 216,
  anon_sym___FUNCTION__ = 217,
  anon_sym___LINE__ = 218,
  anon_sym___MODULE__ = 219,
  anon_sym___PRETTY_FUNCTION__ = 220,
  anon_sym___TIME__ = 221,
  anon_sym___TIMESTAMP__ = 222,
  anon_sym___VENDOR__ = 223,
  anon_sym___VERSION__ = 224,
  anon_sym_exit = 225,
  anon_sym_success = 226,
  anon_sym_failure = 227,
  sym_end_file = 228,
  sym_comment = 229,
  sym_directive = 230,
  sym_int_literal = 231,
  sym_float_literal = 232,
  sym__string = 233,
  sym_not_in = 234,
  sym_not_is = 235,
  sym_source_file = 236,
  sym_shebang = 237,
  sym_htmlentity = 238,
  sym_escape_sequence = 239,
  sym_token_string = 240,
  aux_sym__token_string_tokens = 241,
  sym__token_string_token = 242,
  sym__token_no_braces = 243,
  sym_keyword = 244,
  sym_dollar = 245,
  sym_module_def = 246,
  sym_module_declaration = 247,
  sym_module_fqn = 248,
  sym_import_declaration = 249,
  sym__import_list = 250,
  sym_imported = 251,
  sym_import_bind = 252,
  sym_mixin_declaration = 253,
  sym__declaration = 254,
  sym__declaration2 = 255,
  sym_variable_declaration = 256,
  sym_declarator = 257,
  sym_bitfield_declarator = 258,
  sym_manifest_constant = 259,
  sym_manifest_declarator = 260,
  sym_storage_class = 261,
  sym__initializer = 262,
  sym_auto_declaration = 263,
  sym__auto_assignment = 264,
  sym_alias_declaration = 265,
  sym_alias_initializer = 266,
  sym_alias_reassign = 267,
  sym_type = 268,
  sym_type_ctor = 269,
  sym__type2 = 270,
  sym_vector_type = 271,
  sym__builtin_type = 272,
  sym__type_suffix = 273,
  sym__qualified_id = 274,
  sym_typeof_expression = 275,
  sym_attribute_declaration = 276,
  sym_align_attribute = 277,
  sym_deprecated_attribute = 278,
  sym__attribute = 279,
  sym_at_attribute = 280,
  sym__function_attribute_kwd = 281,
  sym_linkage_attribute = 282,
  sym__argument_list = 283,
  sym_arguments = 284,
  sym_named_argument = 285,
  sym__named_argument_list = 286,
  sym_named_arguments = 287,
  sym_pragma_declaration = 288,
  sym_pragma_statement = 289,
  sym_pragma_expression = 290,
  sym_expression_list = 291,
  sym_expression = 292,
  sym__expr = 293,
  sym_ternary_expression = 294,
  sym_call_expression = 295,
  sym_primary_expression = 296,
  sym__primary_expr = 297,
  sym_index_expression = 298,
  sym_index = 299,
  sym_assignment_expression = 300,
  sym_binary_expression = 301,
  sym_logical_or_expression = 302,
  sym_logical_and_expression = 303,
  sym_or_expression = 304,
  sym_xor_expression = 305,
  sym_and_expression = 306,
  sym_equal_expression = 307,
  sym_rel_expression = 308,
  sym_identity_expression = 309,
  sym_add_expression = 310,
  sym_mul_expression = 311,
  sym_shift_expression = 312,
  sym_power_expression = 313,
  sym_postfix_expression = 314,
  sym_unary_expression = 315,
  sym__unary_expr = 316,
  sym_property_expression = 317,
  sym_cast_expression = 318,
  sym_cast_qualifier = 319,
  sym_delete_expression = 320,
  sym_throw_expression = 321,
  sym_assert_expression = 322,
  sym_assert_arguments = 323,
  sym_mixin_expression = 324,
  sym_import_expression = 325,
  sym_new_expression = 326,
  sym_typeid_expression = 327,
  sym_is_expression = 328,
  sym_type_specialization = 329,
  sym_raw_string = 330,
  sym_hex_string = 331,
  sym_quoted_string = 332,
  sym_interpolation_expression = 333,
  sym_interpolated_raw_string = 334,
  sym_interpolated_quoted_string = 335,
  sym_interpolated_token_string = 336,
  aux_sym__i_token_string_tokens = 337,
  sym_string_literal = 338,
  sym_char_literal = 339,
  sym_array_literal = 340,
  sym__array_member_init = 341,
  sym_function_literal = 342,
  sym__parameter_with_attributes = 343,
  sym__parameter_with_member_attributes = 344,
  sym_special_keyword = 345,
  sym__statement = 346,
  aux_sym__declarations_and_statements = 347,
  sym__declaration_or_statement = 348,
  sym_scope_statement = 349,
  sym__statement_no_case_no_default = 350,
  sym_labeled_statement = 351,
  sym_label = 352,
  sym_block_statement = 353,
  sym_expression_statement = 354,
  sym_if_statement = 355,
  sym_if_condition = 356,
  sym_while_statement = 357,
  sym_do_statement = 358,
  sym_for_statement = 359,
  sym__foreach = 360,
  sym_foreach_statement = 361,
  sym_foreach_type = 362,
  sym_switch_statement = 363,
  sym_case_statement = 364,
  sym_final_switch_statement = 365,
  sym_continue_statement = 366,
  sym_break_statement = 367,
  sym_return_statement = 368,
  sym_goto_statement = 369,
  sym_with_statement = 370,
  sym_synchronized_statement = 371,
  sym_try_statement = 372,
  sym_catch_statement = 373,
  sym_finally_statement = 374,
  sym_scope_guard_statement = 375,
  sym_asm_statement = 376,
  sym_asm_inline = 377,
  sym_struct_declaration = 378,
  sym_union_declaration = 379,
  sym_aggregate_body = 380,
  sym_aggregate_initializer = 381,
  sym_member_initializer = 382,
  sym_postblit = 383,
  sym_invariant_declaration = 384,
  sym_class_declaration = 385,
  sym__base_class_list = 386,
  sym_base_class = 387,
  sym_constructor = 388,
  sym_destructor = 389,
  sym_alias_this = 390,
  sym_interface_declaration = 391,
  sym_enum_declaration = 392,
  sym__enum_body = 393,
  sym__enum_member_attribute = 394,
  sym_enum_member = 395,
  sym_anonymous_enum_declaration = 396,
  sym_anonymous_enum_member = 397,
  sym_function_declaration = 398,
  sym_parameters = 399,
  sym__parameters = 400,
  sym_parameter = 401,
  sym_parameter_attribute = 402,
  sym_ellipses = 403,
  aux_sym__variadic_arguments_attributes = 404,
  sym_variadic_arguments_attribute = 405,
  sym__function_attribute = 406,
  sym_member_function_attribute = 407,
  sym_function_body = 408,
  sym__specified_function_body = 409,
  sym__function_contract = 410,
  aux_sym__in_out_contract_expressions = 411,
  sym__in_out_contract_expression = 412,
  sym__in_out_statement = 413,
  sym_in_contract_expression = 414,
  sym_out_contract_expression = 415,
  sym_in_statement = 416,
  sym_out_statement = 417,
  sym_template_declaration = 418,
  sym_template_instance = 419,
  sym_template_arguments = 420,
  sym_template_argument = 421,
  sym__template_argument_list = 422,
  sym__template_single_arg = 423,
  sym_template_parameter = 424,
  sym_template_parameters = 425,
  sym__template_parameter_list = 426,
  sym_constraint = 427,
  sym_mixin_template_declaration = 428,
  sym_template_mixin = 429,
  sym_conditional_declaration = 430,
  sym_conditional_statement = 431,
  sym_condition = 432,
  sym_version_condition = 433,
  sym_version_specification = 434,
  sym_debug_condition = 435,
  sym_debug_specification = 436,
  sym_static_if_condition = 437,
  sym_static_foreach_statement = 438,
  sym_static_foreach_declaration = 439,
  sym_static_assert = 440,
  sym_traits_expression = 441,
  sym_unittest_declaration = 442,
  aux_sym_source_file_repeat1 = 443,
  aux_sym_module_declaration_repeat1 = 444,
  aux_sym_module_fqn_repeat1 = 445,
  aux_sym__import_list_repeat1 = 446,
  aux_sym__declaration_repeat1 = 447,
  aux_sym_variable_declaration_repeat1 = 448,
  aux_sym_variable_declaration_repeat2 = 449,
  aux_sym__declarator_identifier_list_repeat1 = 450,
  aux_sym_manifest_constant_repeat1 = 451,
  aux_sym_auto_declaration_repeat1 = 452,
  aux_sym_alias_declaration_repeat1 = 453,
  aux_sym_alias_declaration_repeat2 = 454,
  aux_sym_type_repeat1 = 455,
  aux_sym_type_repeat2 = 456,
  aux_sym__type_suffix_repeat1 = 457,
  aux_sym__argument_list_repeat1 = 458,
  aux_sym__named_argument_list_repeat1 = 459,
  aux_sym_expression_list_repeat1 = 460,
  aux_sym_index_expression_repeat1 = 461,
  aux_sym_quoted_string_repeat1 = 462,
  aux_sym_interpolated_raw_string_repeat1 = 463,
  aux_sym_interpolated_quoted_string_repeat1 = 464,
  aux_sym_array_literal_repeat1 = 465,
  aux_sym_foreach_statement_repeat1 = 466,
  aux_sym_foreach_type_repeat1 = 467,
  aux_sym_case_statement_repeat1 = 468,
  aux_sym_try_statement_repeat1 = 469,
  aux_sym_asm_inline_repeat1 = 470,
  aux_sym_aggregate_initializer_repeat1 = 471,
  aux_sym__base_class_list_repeat1 = 472,
  aux_sym__enum_body_repeat1 = 473,
  aux_sym_enum_member_repeat1 = 474,
  aux_sym_anonymous_enum_declaration_repeat1 = 475,
  aux_sym_parameters_repeat1 = 476,
  aux_sym__parameters_repeat1 = 477,
  aux_sym__parameter_repeat1 = 478,
  aux_sym_function_body_repeat1 = 479,
  aux_sym__template_argument_list_repeat1 = 480,
  aux_sym__template_parameter_list_repeat1 = 481,
  aux_sym_template_mixin_repeat1 = 482,
  alias_sym_namespace_list = 483,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym__bom] = "_bom",
  [anon_sym_POUND_BANG] = "#!",
  [aux_sym_shebang_token1] = "shebang_token1",
  [aux_sym_htmlentity_token1] = "htmlentity_token1",
  [anon_sym_BSLASH_SQUOTE] = "\\'",
  [anon_sym_BSLASH_DQUOTE] = "\\\"",
  [anon_sym_BSLASH_QMARK] = "\\\?",
  [anon_sym_BSLASH_BSLASH] = "\\\\",
  [anon_sym_BSLASHa] = "\\a",
  [anon_sym_BSLASHb] = "\\b",
  [anon_sym_BSLASHf] = "\\f",
  [anon_sym_BSLASHn] = "\\n",
  [anon_sym_BSLASHr] = "\\r",
  [anon_sym_BSLASHt] = "\\t",
  [anon_sym_BSLASHv] = "\\v",
  [aux_sym_escape_sequence_token1] = "escape_sequence_token1",
  [aux_sym_escape_sequence_token2] = "escape_sequence_token2",
  [aux_sym_escape_sequence_token3] = "escape_sequence_token3",
  [aux_sym_escape_sequence_token4] = "escape_sequence_token4",
  [anon_sym_q_LBRACE] = "q{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACE] = "{",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_DOT] = ".",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_AMP] = "&",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS] = "+",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_BANG] = "!",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_QMARK] = "\?",
  [anon_sym_COMMA] = ",",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_EQ] = "=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET] = "^",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_CARET_CARET] = "^^",
  [anon_sym_CARET_CARET_EQ] = "^^=",
  [anon_sym_TILDE] = "~",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_AT] = "@",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_POUND] = "#",
  [sym_bool] = "bool",
  [sym_byte] = "byte",
  [sym_ubyte] = "ubyte",
  [sym_char] = "char",
  [sym_short] = "short",
  [sym_ushort] = "ushort",
  [sym_int] = "int",
  [sym_uint] = "uint",
  [sym_long] = "long",
  [sym_ulong] = "ulong",
  [sym_cent] = "cent",
  [sym_ucent] = "ucent",
  [sym_wchar] = "wchar",
  [sym_dchar] = "dchar",
  [sym_float] = "float",
  [sym_double] = "double",
  [sym_real] = "real",
  [sym_ifloat] = "ifloat",
  [sym_idouble] = "idouble",
  [sym_ireal] = "ireal",
  [sym_cfloat] = "cfloat",
  [sym_cdouble] = "cdouble",
  [sym_creal] = "creal",
  [sym_size_t] = "size_t",
  [sym_ptrdiff_t] = "ptrdiff_t",
  [sym_string] = "string",
  [sym_cstring] = "cstring",
  [sym_dstring] = "dstring",
  [sym_wstring] = "wstring",
  [sym_noreturn] = "noreturn",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_super] = "super",
  [sym_this] = "this",
  [sym_abstract] = "abstract",
  [sym_alias] = "alias",
  [sym_align] = "align",
  [sym_asm] = "asm",
  [sym_assert] = "assert",
  [sym_auto] = "auto",
  [sym_break] = "break",
  [sym_case] = "case",
  [sym_cast] = "cast",
  [sym_catch] = "catch",
  [sym_class] = "class",
  [sym_const] = "const",
  [sym_continue] = "continue",
  [sym_debug] = "debug",
  [sym_default] = "default",
  [sym_delegate] = "delegate",
  [sym_delete] = "delete",
  [sym_deprecated] = "deprecated",
  [sym_do] = "do",
  [sym_else] = "else",
  [sym_enum] = "enum",
  [sym_export] = "export",
  [sym_extern] = "extern",
  [sym_final] = "final",
  [sym_finally] = "finally",
  [sym_for] = "for",
  [sym_foreach] = "foreach",
  [sym_foreach_reverse] = "foreach_reverse",
  [sym_function] = "function",
  [sym_goto] = "goto",
  [sym_if] = "if",
  [sym_immutable] = "immutable",
  [sym_import] = "import",
  [sym_in] = "in",
  [sym_inout] = "inout",
  [sym_interface] = "interface",
  [sym_invariant] = "invariant",
  [sym_is] = "is",
  [sym_lazy] = "lazy",
  [sym_mixin] = "mixin",
  [sym_module] = "module",
  [sym_new] = "new",
  [sym_nothrow] = "nothrow",
  [sym_out] = "out",
  [sym_override] = "override",
  [sym_package] = "package",
  [sym_pragma] = "pragma",
  [sym_private] = "private",
  [sym_protected] = "protected",
  [sym_public] = "public",
  [sym_pure] = "pure",
  [sym_ref] = "ref",
  [sym_return] = "return",
  [sym_scope] = "scope",
  [sym_shared] = "shared",
  [sym_static] = "static",
  [sym_struct] = "struct",
  [sym_switch] = "switch",
  [sym_synchronized] = "synchronized",
  [sym_template] = "template",
  [sym_throw] = "throw",
  [sym_try] = "try",
  [sym_typeid] = "typeid",
  [sym_typeof] = "typeof",
  [sym_union] = "union",
  [sym_unittest] = "unittest",
  [sym_version] = "version",
  [sym_while] = "while",
  [sym_with] = "with",
  [sym_parameters_] = "parameters_",
  [sym_gshared] = "gshared",
  [sym_traits] = "traits",
  [sym_vector] = "vector",
  [sym_void] = "void",
  [anon_sym_C] = "C",
  [anon_sym_D] = "D",
  [anon_sym_Windows] = "Windows",
  [anon_sym_System] = "System",
  [anon_sym_Objective] = "Objective",
  [anon_sym_BQUOTE] = "`",
  [aux_sym_raw_string_token1] = "raw_string_token1",
  [aux_sym_raw_string_token2] = "raw_string_token2",
  [anon_sym_r_DQUOTE] = "r\"",
  [aux_sym_raw_string_token3] = "raw_string_token3",
  [aux_sym_raw_string_token4] = "raw_string_token4",
  [anon_sym_x_DQUOTE] = "x\"",
  [aux_sym_hex_string_token1] = "hex_string_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_quoted_string_token1] = "quoted_string_token1",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_i_BQUOTE] = "i`",
  [aux_sym_interpolated_raw_string_token1] = "interpolated_raw_string_token1",
  [aux_sym_interpolated_raw_string_token2] = "interpolated_raw_string_token2",
  [anon_sym_DOLLAR_BQUOTE] = "$`",
  [sym_interpolated_escape] = "interpolated_escape",
  [anon_sym_i_DQUOTE] = "i\"",
  [aux_sym_interpolated_quoted_string_token1] = "interpolated_quoted_string_token1",
  [aux_sym_interpolated_quoted_string_token2] = "interpolated_quoted_string_token2",
  [anon_sym_DOLLAR_DQUOTE] = "$\"",
  [anon_sym_iq_LBRACE] = "iq{",
  [aux_sym_char_literal_token1] = "char_literal_token1",
  [anon_sym_SQUOTE] = "'",
  [anon_sym___DATE__] = "__DATE__",
  [anon_sym___FILE__] = "__FILE__",
  [anon_sym___FILE_FULL_PATH__] = "__FILE_FULL_PATH__",
  [anon_sym___FUNCTION__] = "__FUNCTION__",
  [anon_sym___LINE__] = "__LINE__",
  [anon_sym___MODULE__] = "__MODULE__",
  [anon_sym___PRETTY_FUNCTION__] = "__PRETTY_FUNCTION__",
  [anon_sym___TIME__] = "__TIME__",
  [anon_sym___TIMESTAMP__] = "__TIMESTAMP__",
  [anon_sym___VENDOR__] = "__VENDOR__",
  [anon_sym___VERSION__] = "__VERSION__",
  [anon_sym_exit] = "exit",
  [anon_sym_success] = "success",
  [anon_sym_failure] = "failure",
  [sym_end_file] = "end_file",
  [sym_comment] = "comment",
  [sym_directive] = "directive",
  [sym_int_literal] = "int_literal",
  [sym_float_literal] = "float_literal",
  [sym__string] = "_string",
  [sym_not_in] = "not_in",
  [sym_not_is] = "not_is",
  [sym_source_file] = "source_file",
  [sym_shebang] = "shebang",
  [sym_htmlentity] = "htmlentity",
  [sym_escape_sequence] = "escape_sequence",
  [sym_token_string] = "token_string",
  [aux_sym__token_string_tokens] = "_token_string_tokens",
  [sym__token_string_token] = "_token_string_token",
  [sym__token_no_braces] = "_token_no_braces",
  [sym_keyword] = "keyword",
  [sym_dollar] = "dollar",
  [sym_module_def] = "module_def",
  [sym_module_declaration] = "module_declaration",
  [sym_module_fqn] = "module_fqn",
  [sym_import_declaration] = "import_declaration",
  [sym__import_list] = "_import_list",
  [sym_imported] = "imported",
  [sym_import_bind] = "import_bind",
  [sym_mixin_declaration] = "mixin_declaration",
  [sym__declaration] = "_declaration",
  [sym__declaration2] = "_declaration2",
  [sym_variable_declaration] = "variable_declaration",
  [sym_declarator] = "declarator",
  [sym_bitfield_declarator] = "bitfield_declarator",
  [sym_manifest_constant] = "manifest_constant",
  [sym_manifest_declarator] = "manifest_declarator",
  [sym_storage_class] = "storage_class",
  [sym__initializer] = "_initializer",
  [sym_auto_declaration] = "auto_declaration",
  [sym__auto_assignment] = "_auto_assignment",
  [sym_alias_declaration] = "alias_declaration",
  [sym_alias_initializer] = "alias_initializer",
  [sym_alias_reassign] = "alias_reassign",
  [sym_type] = "type",
  [sym_type_ctor] = "type_ctor",
  [sym__type2] = "_type2",
  [sym_vector_type] = "vector_type",
  [sym__builtin_type] = "_builtin_type",
  [sym__type_suffix] = "_type_suffix",
  [sym__qualified_id] = "_qualified_id",
  [sym_typeof_expression] = "typeof_expression",
  [sym_attribute_declaration] = "attribute_declaration",
  [sym_align_attribute] = "align_attribute",
  [sym_deprecated_attribute] = "deprecated_attribute",
  [sym__attribute] = "_attribute",
  [sym_at_attribute] = "at_attribute",
  [sym__function_attribute_kwd] = "_function_attribute_kwd",
  [sym_linkage_attribute] = "linkage_attribute",
  [sym__argument_list] = "_argument_list",
  [sym_arguments] = "arguments",
  [sym_named_argument] = "named_argument",
  [sym__named_argument_list] = "_named_argument_list",
  [sym_named_arguments] = "named_arguments",
  [sym_pragma_declaration] = "pragma_declaration",
  [sym_pragma_statement] = "pragma_statement",
  [sym_pragma_expression] = "pragma_expression",
  [sym_expression_list] = "expression_list",
  [sym_expression] = "expression",
  [sym__expr] = "_expr",
  [sym_ternary_expression] = "ternary_expression",
  [sym_call_expression] = "call_expression",
  [sym_primary_expression] = "primary_expression",
  [sym__primary_expr] = "_primary_expr",
  [sym_index_expression] = "index_expression",
  [sym_index] = "index",
  [sym_assignment_expression] = "assignment_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_logical_or_expression] = "logical_or_expression",
  [sym_logical_and_expression] = "logical_and_expression",
  [sym_or_expression] = "or_expression",
  [sym_xor_expression] = "xor_expression",
  [sym_and_expression] = "and_expression",
  [sym_equal_expression] = "equal_expression",
  [sym_rel_expression] = "rel_expression",
  [sym_identity_expression] = "identity_expression",
  [sym_add_expression] = "add_expression",
  [sym_mul_expression] = "mul_expression",
  [sym_shift_expression] = "shift_expression",
  [sym_power_expression] = "power_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_unary_expression] = "unary_expression",
  [sym__unary_expr] = "_unary_expr",
  [sym_property_expression] = "property_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_cast_qualifier] = "cast_qualifier",
  [sym_delete_expression] = "delete_expression",
  [sym_throw_expression] = "throw_expression",
  [sym_assert_expression] = "assert_expression",
  [sym_assert_arguments] = "assert_arguments",
  [sym_mixin_expression] = "mixin_expression",
  [sym_import_expression] = "import_expression",
  [sym_new_expression] = "new_expression",
  [sym_typeid_expression] = "typeid_expression",
  [sym_is_expression] = "is_expression",
  [sym_type_specialization] = "type_specialization",
  [sym_raw_string] = "raw_string",
  [sym_hex_string] = "hex_string",
  [sym_quoted_string] = "quoted_string",
  [sym_interpolation_expression] = "interpolation_expression",
  [sym_interpolated_raw_string] = "interpolated_raw_string",
  [sym_interpolated_quoted_string] = "interpolated_quoted_string",
  [sym_interpolated_token_string] = "interpolated_token_string",
  [aux_sym__i_token_string_tokens] = "_i_token_string_tokens",
  [sym_string_literal] = "string_literal",
  [sym_char_literal] = "char_literal",
  [sym_array_literal] = "array_literal",
  [sym__array_member_init] = "_array_member_init",
  [sym_function_literal] = "function_literal",
  [sym__parameter_with_attributes] = "_parameter_with_attributes",
  [sym__parameter_with_member_attributes] = "_parameter_with_member_attributes",
  [sym_special_keyword] = "special_keyword",
  [sym__statement] = "_statement",
  [aux_sym__declarations_and_statements] = "_declarations_and_statements",
  [sym__declaration_or_statement] = "_declaration_or_statement",
  [sym_scope_statement] = "scope_statement",
  [sym__statement_no_case_no_default] = "_statement_no_case_no_default",
  [sym_labeled_statement] = "labeled_statement",
  [sym_label] = "label",
  [sym_block_statement] = "block_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_if_condition] = "if_condition",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_for_statement] = "for_statement",
  [sym__foreach] = "_foreach",
  [sym_foreach_statement] = "foreach_statement",
  [sym_foreach_type] = "foreach_type",
  [sym_switch_statement] = "switch_statement",
  [sym_case_statement] = "case_statement",
  [sym_final_switch_statement] = "final_switch_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_return_statement] = "return_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_with_statement] = "with_statement",
  [sym_synchronized_statement] = "synchronized_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_statement] = "catch_statement",
  [sym_finally_statement] = "finally_statement",
  [sym_scope_guard_statement] = "scope_guard_statement",
  [sym_asm_statement] = "asm_statement",
  [sym_asm_inline] = "asm_inline",
  [sym_struct_declaration] = "struct_declaration",
  [sym_union_declaration] = "union_declaration",
  [sym_aggregate_body] = "aggregate_body",
  [sym_aggregate_initializer] = "aggregate_initializer",
  [sym_member_initializer] = "member_initializer",
  [sym_postblit] = "postblit",
  [sym_invariant_declaration] = "invariant_declaration",
  [sym_class_declaration] = "class_declaration",
  [sym__base_class_list] = "_base_class_list",
  [sym_base_class] = "base_class",
  [sym_constructor] = "constructor",
  [sym_destructor] = "destructor",
  [sym_alias_this] = "alias_this",
  [sym_interface_declaration] = "interface_declaration",
  [sym_enum_declaration] = "enum_declaration",
  [sym__enum_body] = "_enum_body",
  [sym__enum_member_attribute] = "_enum_member_attribute",
  [sym_enum_member] = "enum_member",
  [sym_anonymous_enum_declaration] = "anonymous_enum_declaration",
  [sym_anonymous_enum_member] = "anonymous_enum_member",
  [sym_function_declaration] = "function_declaration",
  [sym_parameters] = "parameters",
  [sym__parameters] = "_parameters",
  [sym_parameter] = "parameter",
  [sym_parameter_attribute] = "parameter_attribute",
  [sym_ellipses] = "ellipses",
  [aux_sym__variadic_arguments_attributes] = "_variadic_arguments_attributes",
  [sym_variadic_arguments_attribute] = "variadic_arguments_attribute",
  [sym__function_attribute] = "_function_attribute",
  [sym_member_function_attribute] = "member_function_attribute",
  [sym_function_body] = "function_body",
  [sym__specified_function_body] = "_specified_function_body",
  [sym__function_contract] = "_function_contract",
  [aux_sym__in_out_contract_expressions] = "_in_out_contract_expressions",
  [sym__in_out_contract_expression] = "_in_out_contract_expression",
  [sym__in_out_statement] = "_in_out_statement",
  [sym_in_contract_expression] = "in_contract_expression",
  [sym_out_contract_expression] = "out_contract_expression",
  [sym_in_statement] = "in_statement",
  [sym_out_statement] = "out_statement",
  [sym_template_declaration] = "template_declaration",
  [sym_template_instance] = "template_instance",
  [sym_template_arguments] = "template_arguments",
  [sym_template_argument] = "template_argument",
  [sym__template_argument_list] = "_template_argument_list",
  [sym__template_single_arg] = "_template_single_arg",
  [sym_template_parameter] = "template_parameter",
  [sym_template_parameters] = "template_parameters",
  [sym__template_parameter_list] = "_template_parameter_list",
  [sym_constraint] = "constraint",
  [sym_mixin_template_declaration] = "mixin_template_declaration",
  [sym_template_mixin] = "template_mixin",
  [sym_conditional_declaration] = "conditional_declaration",
  [sym_conditional_statement] = "conditional_statement",
  [sym_condition] = "condition",
  [sym_version_condition] = "version_condition",
  [sym_version_specification] = "version_specification",
  [sym_debug_condition] = "debug_condition",
  [sym_debug_specification] = "debug_specification",
  [sym_static_if_condition] = "static_if_condition",
  [sym_static_foreach_statement] = "static_foreach_statement",
  [sym_static_foreach_declaration] = "static_foreach_declaration",
  [sym_static_assert] = "static_assert",
  [sym_traits_expression] = "traits_expression",
  [sym_unittest_declaration] = "unittest_declaration",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_module_declaration_repeat1] = "module_declaration_repeat1",
  [aux_sym_module_fqn_repeat1] = "module_fqn_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym__declaration_repeat1] = "_declaration_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_variable_declaration_repeat2] = "variable_declaration_repeat2",
  [aux_sym__declarator_identifier_list_repeat1] = "_declarator_identifier_list_repeat1",
  [aux_sym_manifest_constant_repeat1] = "manifest_constant_repeat1",
  [aux_sym_auto_declaration_repeat1] = "auto_declaration_repeat1",
  [aux_sym_alias_declaration_repeat1] = "alias_declaration_repeat1",
  [aux_sym_alias_declaration_repeat2] = "alias_declaration_repeat2",
  [aux_sym_type_repeat1] = "type_repeat1",
  [aux_sym_type_repeat2] = "type_repeat2",
  [aux_sym__type_suffix_repeat1] = "_type_suffix_repeat1",
  [aux_sym__argument_list_repeat1] = "_argument_list_repeat1",
  [aux_sym__named_argument_list_repeat1] = "_named_argument_list_repeat1",
  [aux_sym_expression_list_repeat1] = "expression_list_repeat1",
  [aux_sym_index_expression_repeat1] = "index_expression_repeat1",
  [aux_sym_quoted_string_repeat1] = "quoted_string_repeat1",
  [aux_sym_interpolated_raw_string_repeat1] = "interpolated_raw_string_repeat1",
  [aux_sym_interpolated_quoted_string_repeat1] = "interpolated_quoted_string_repeat1",
  [aux_sym_array_literal_repeat1] = "array_literal_repeat1",
  [aux_sym_foreach_statement_repeat1] = "foreach_statement_repeat1",
  [aux_sym_foreach_type_repeat1] = "foreach_type_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_asm_inline_repeat1] = "asm_inline_repeat1",
  [aux_sym_aggregate_initializer_repeat1] = "aggregate_initializer_repeat1",
  [aux_sym__base_class_list_repeat1] = "_base_class_list_repeat1",
  [aux_sym__enum_body_repeat1] = "_enum_body_repeat1",
  [aux_sym_enum_member_repeat1] = "enum_member_repeat1",
  [aux_sym_anonymous_enum_declaration_repeat1] = "anonymous_enum_declaration_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym__parameter_repeat1] = "_parameter_repeat1",
  [aux_sym_function_body_repeat1] = "function_body_repeat1",
  [aux_sym__template_argument_list_repeat1] = "_template_argument_list_repeat1",
  [aux_sym__template_parameter_list_repeat1] = "_template_parameter_list_repeat1",
  [aux_sym_template_mixin_repeat1] = "template_mixin_repeat1",
  [alias_sym_namespace_list] = "namespace_list",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym__bom] = sym__bom,
  [anon_sym_POUND_BANG] = anon_sym_POUND_BANG,
  [aux_sym_shebang_token1] = aux_sym_shebang_token1,
  [aux_sym_htmlentity_token1] = aux_sym_htmlentity_token1,
  [anon_sym_BSLASH_SQUOTE] = anon_sym_BSLASH_SQUOTE,
  [anon_sym_BSLASH_DQUOTE] = anon_sym_BSLASH_DQUOTE,
  [anon_sym_BSLASH_QMARK] = anon_sym_BSLASH_QMARK,
  [anon_sym_BSLASH_BSLASH] = anon_sym_BSLASH_BSLASH,
  [anon_sym_BSLASHa] = anon_sym_BSLASHa,
  [anon_sym_BSLASHb] = anon_sym_BSLASHb,
  [anon_sym_BSLASHf] = anon_sym_BSLASHf,
  [anon_sym_BSLASHn] = anon_sym_BSLASHn,
  [anon_sym_BSLASHr] = anon_sym_BSLASHr,
  [anon_sym_BSLASHt] = anon_sym_BSLASHt,
  [anon_sym_BSLASHv] = anon_sym_BSLASHv,
  [aux_sym_escape_sequence_token1] = aux_sym_escape_sequence_token1,
  [aux_sym_escape_sequence_token2] = aux_sym_escape_sequence_token2,
  [aux_sym_escape_sequence_token3] = aux_sym_escape_sequence_token3,
  [aux_sym_escape_sequence_token4] = aux_sym_escape_sequence_token4,
  [anon_sym_q_LBRACE] = anon_sym_q_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_CARET_CARET] = anon_sym_CARET_CARET,
  [anon_sym_CARET_CARET_EQ] = anon_sym_CARET_CARET_EQ,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_POUND] = anon_sym_POUND,
  [sym_bool] = sym_bool,
  [sym_byte] = sym_byte,
  [sym_ubyte] = sym_ubyte,
  [sym_char] = sym_char,
  [sym_short] = sym_short,
  [sym_ushort] = sym_ushort,
  [sym_int] = sym_int,
  [sym_uint] = sym_uint,
  [sym_long] = sym_long,
  [sym_ulong] = sym_ulong,
  [sym_cent] = sym_cent,
  [sym_ucent] = sym_ucent,
  [sym_wchar] = sym_wchar,
  [sym_dchar] = sym_dchar,
  [sym_float] = sym_float,
  [sym_double] = sym_double,
  [sym_real] = sym_real,
  [sym_ifloat] = sym_ifloat,
  [sym_idouble] = sym_idouble,
  [sym_ireal] = sym_ireal,
  [sym_cfloat] = sym_cfloat,
  [sym_cdouble] = sym_cdouble,
  [sym_creal] = sym_creal,
  [sym_size_t] = sym_size_t,
  [sym_ptrdiff_t] = sym_ptrdiff_t,
  [sym_string] = sym_string,
  [sym_cstring] = sym_cstring,
  [sym_dstring] = sym_dstring,
  [sym_wstring] = sym_wstring,
  [sym_noreturn] = sym_noreturn,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_super] = sym_super,
  [sym_this] = sym_this,
  [sym_abstract] = sym_abstract,
  [sym_alias] = sym_alias,
  [sym_align] = sym_align,
  [sym_asm] = sym_asm,
  [sym_assert] = sym_assert,
  [sym_auto] = sym_auto,
  [sym_break] = sym_break,
  [sym_case] = sym_case,
  [sym_cast] = sym_cast,
  [sym_catch] = sym_catch,
  [sym_class] = sym_class,
  [sym_const] = sym_const,
  [sym_continue] = sym_continue,
  [sym_debug] = sym_debug,
  [sym_default] = sym_default,
  [sym_delegate] = sym_delegate,
  [sym_delete] = sym_delete,
  [sym_deprecated] = sym_deprecated,
  [sym_do] = sym_do,
  [sym_else] = sym_else,
  [sym_enum] = sym_enum,
  [sym_export] = sym_export,
  [sym_extern] = sym_extern,
  [sym_final] = sym_final,
  [sym_finally] = sym_finally,
  [sym_for] = sym_for,
  [sym_foreach] = sym_foreach,
  [sym_foreach_reverse] = sym_foreach_reverse,
  [sym_function] = sym_function,
  [sym_goto] = sym_goto,
  [sym_if] = sym_if,
  [sym_immutable] = sym_immutable,
  [sym_import] = sym_import,
  [sym_in] = sym_in,
  [sym_inout] = sym_inout,
  [sym_interface] = sym_interface,
  [sym_invariant] = sym_invariant,
  [sym_is] = sym_is,
  [sym_lazy] = sym_lazy,
  [sym_mixin] = sym_mixin,
  [sym_module] = sym_module,
  [sym_new] = sym_new,
  [sym_nothrow] = sym_nothrow,
  [sym_out] = sym_out,
  [sym_override] = sym_override,
  [sym_package] = sym_package,
  [sym_pragma] = sym_pragma,
  [sym_private] = sym_private,
  [sym_protected] = sym_protected,
  [sym_public] = sym_public,
  [sym_pure] = sym_pure,
  [sym_ref] = sym_ref,
  [sym_return] = sym_return,
  [sym_scope] = sym_scope,
  [sym_shared] = sym_shared,
  [sym_static] = sym_static,
  [sym_struct] = sym_struct,
  [sym_switch] = sym_switch,
  [sym_synchronized] = sym_synchronized,
  [sym_template] = sym_template,
  [sym_throw] = sym_throw,
  [sym_try] = sym_try,
  [sym_typeid] = sym_typeid,
  [sym_typeof] = sym_typeof,
  [sym_union] = sym_union,
  [sym_unittest] = sym_unittest,
  [sym_version] = sym_version,
  [sym_while] = sym_while,
  [sym_with] = sym_with,
  [sym_parameters_] = sym_parameters_,
  [sym_gshared] = sym_gshared,
  [sym_traits] = sym_traits,
  [sym_vector] = sym_vector,
  [sym_void] = sym_void,
  [anon_sym_C] = anon_sym_C,
  [anon_sym_D] = anon_sym_D,
  [anon_sym_Windows] = anon_sym_Windows,
  [anon_sym_System] = anon_sym_System,
  [anon_sym_Objective] = anon_sym_Objective,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym_raw_string_token1] = aux_sym_raw_string_token1,
  [aux_sym_raw_string_token2] = aux_sym_raw_string_token2,
  [anon_sym_r_DQUOTE] = anon_sym_r_DQUOTE,
  [aux_sym_raw_string_token3] = aux_sym_raw_string_token3,
  [aux_sym_raw_string_token4] = aux_sym_raw_string_token4,
  [anon_sym_x_DQUOTE] = anon_sym_x_DQUOTE,
  [aux_sym_hex_string_token1] = aux_sym_hex_string_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_quoted_string_token1] = aux_sym_quoted_string_token1,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_i_BQUOTE] = anon_sym_i_BQUOTE,
  [aux_sym_interpolated_raw_string_token1] = aux_sym_interpolated_raw_string_token1,
  [aux_sym_interpolated_raw_string_token2] = aux_sym_interpolated_raw_string_token2,
  [anon_sym_DOLLAR_BQUOTE] = anon_sym_DOLLAR_BQUOTE,
  [sym_interpolated_escape] = sym_interpolated_escape,
  [anon_sym_i_DQUOTE] = anon_sym_i_DQUOTE,
  [aux_sym_interpolated_quoted_string_token1] = aux_sym_interpolated_quoted_string_token1,
  [aux_sym_interpolated_quoted_string_token2] = aux_sym_interpolated_quoted_string_token2,
  [anon_sym_DOLLAR_DQUOTE] = anon_sym_DOLLAR_DQUOTE,
  [anon_sym_iq_LBRACE] = anon_sym_iq_LBRACE,
  [aux_sym_char_literal_token1] = aux_sym_char_literal_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym___DATE__] = anon_sym___DATE__,
  [anon_sym___FILE__] = anon_sym___FILE__,
  [anon_sym___FILE_FULL_PATH__] = anon_sym___FILE_FULL_PATH__,
  [anon_sym___FUNCTION__] = anon_sym___FUNCTION__,
  [anon_sym___LINE__] = anon_sym___LINE__,
  [anon_sym___MODULE__] = anon_sym___MODULE__,
  [anon_sym___PRETTY_FUNCTION__] = anon_sym___PRETTY_FUNCTION__,
  [anon_sym___TIME__] = anon_sym___TIME__,
  [anon_sym___TIMESTAMP__] = anon_sym___TIMESTAMP__,
  [anon_sym___VENDOR__] = anon_sym___VENDOR__,
  [anon_sym___VERSION__] = anon_sym___VERSION__,
  [anon_sym_exit] = anon_sym_exit,
  [anon_sym_success] = anon_sym_success,
  [anon_sym_failure] = anon_sym_failure,
  [sym_end_file] = sym_end_file,
  [sym_comment] = sym_comment,
  [sym_directive] = sym_directive,
  [sym_int_literal] = sym_int_literal,
  [sym_float_literal] = sym_float_literal,
  [sym__string] = sym__string,
  [sym_not_in] = sym_not_in,
  [sym_not_is] = sym_not_is,
  [sym_source_file] = sym_source_file,
  [sym_shebang] = sym_shebang,
  [sym_htmlentity] = sym_htmlentity,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_token_string] = sym_token_string,
  [aux_sym__token_string_tokens] = aux_sym__token_string_tokens,
  [sym__token_string_token] = sym__token_string_token,
  [sym__token_no_braces] = sym__token_no_braces,
  [sym_keyword] = sym_keyword,
  [sym_dollar] = sym_dollar,
  [sym_module_def] = sym_module_def,
  [sym_module_declaration] = sym_module_declaration,
  [sym_module_fqn] = sym_module_fqn,
  [sym_import_declaration] = sym_import_declaration,
  [sym__import_list] = sym__import_list,
  [sym_imported] = sym_imported,
  [sym_import_bind] = sym_import_bind,
  [sym_mixin_declaration] = sym_mixin_declaration,
  [sym__declaration] = sym__declaration,
  [sym__declaration2] = sym__declaration2,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_declarator] = sym_declarator,
  [sym_bitfield_declarator] = sym_bitfield_declarator,
  [sym_manifest_constant] = sym_manifest_constant,
  [sym_manifest_declarator] = sym_manifest_declarator,
  [sym_storage_class] = sym_storage_class,
  [sym__initializer] = sym__initializer,
  [sym_auto_declaration] = sym_auto_declaration,
  [sym__auto_assignment] = sym__auto_assignment,
  [sym_alias_declaration] = sym_alias_declaration,
  [sym_alias_initializer] = sym_alias_initializer,
  [sym_alias_reassign] = sym_alias_reassign,
  [sym_type] = sym_type,
  [sym_type_ctor] = sym_type_ctor,
  [sym__type2] = sym__type2,
  [sym_vector_type] = sym_vector_type,
  [sym__builtin_type] = sym__builtin_type,
  [sym__type_suffix] = sym__type_suffix,
  [sym__qualified_id] = sym__qualified_id,
  [sym_typeof_expression] = sym_typeof_expression,
  [sym_attribute_declaration] = sym_attribute_declaration,
  [sym_align_attribute] = sym_align_attribute,
  [sym_deprecated_attribute] = sym_deprecated_attribute,
  [sym__attribute] = sym__attribute,
  [sym_at_attribute] = sym_at_attribute,
  [sym__function_attribute_kwd] = sym__function_attribute_kwd,
  [sym_linkage_attribute] = sym_linkage_attribute,
  [sym__argument_list] = sym__argument_list,
  [sym_arguments] = sym_arguments,
  [sym_named_argument] = sym_named_argument,
  [sym__named_argument_list] = sym__named_argument_list,
  [sym_named_arguments] = sym_named_arguments,
  [sym_pragma_declaration] = sym_pragma_declaration,
  [sym_pragma_statement] = sym_pragma_statement,
  [sym_pragma_expression] = sym_pragma_expression,
  [sym_expression_list] = sym_expression_list,
  [sym_expression] = sym_expression,
  [sym__expr] = sym__expr,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym__primary_expr] = sym__primary_expr,
  [sym_index_expression] = sym_index_expression,
  [sym_index] = sym_index,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_logical_or_expression] = sym_logical_or_expression,
  [sym_logical_and_expression] = sym_logical_and_expression,
  [sym_or_expression] = sym_or_expression,
  [sym_xor_expression] = sym_xor_expression,
  [sym_and_expression] = sym_and_expression,
  [sym_equal_expression] = sym_equal_expression,
  [sym_rel_expression] = sym_rel_expression,
  [sym_identity_expression] = sym_identity_expression,
  [sym_add_expression] = sym_add_expression,
  [sym_mul_expression] = sym_mul_expression,
  [sym_shift_expression] = sym_shift_expression,
  [sym_power_expression] = sym_power_expression,
  [sym_postfix_expression] = sym_postfix_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym__unary_expr] = sym__unary_expr,
  [sym_property_expression] = sym_property_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_cast_qualifier] = sym_cast_qualifier,
  [sym_delete_expression] = sym_delete_expression,
  [sym_throw_expression] = sym_throw_expression,
  [sym_assert_expression] = sym_assert_expression,
  [sym_assert_arguments] = sym_assert_arguments,
  [sym_mixin_expression] = sym_mixin_expression,
  [sym_import_expression] = sym_import_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_typeid_expression] = sym_typeid_expression,
  [sym_is_expression] = sym_is_expression,
  [sym_type_specialization] = sym_type_specialization,
  [sym_raw_string] = sym_raw_string,
  [sym_hex_string] = sym_hex_string,
  [sym_quoted_string] = sym_quoted_string,
  [sym_interpolation_expression] = sym_interpolation_expression,
  [sym_interpolated_raw_string] = sym_interpolated_raw_string,
  [sym_interpolated_quoted_string] = sym_interpolated_quoted_string,
  [sym_interpolated_token_string] = sym_interpolated_token_string,
  [aux_sym__i_token_string_tokens] = aux_sym__i_token_string_tokens,
  [sym_string_literal] = sym_string_literal,
  [sym_char_literal] = sym_char_literal,
  [sym_array_literal] = sym_array_literal,
  [sym__array_member_init] = sym__array_member_init,
  [sym_function_literal] = sym_function_literal,
  [sym__parameter_with_attributes] = sym__parameter_with_attributes,
  [sym__parameter_with_member_attributes] = sym__parameter_with_member_attributes,
  [sym_special_keyword] = sym_special_keyword,
  [sym__statement] = sym__statement,
  [aux_sym__declarations_and_statements] = aux_sym__declarations_and_statements,
  [sym__declaration_or_statement] = sym__declaration_or_statement,
  [sym_scope_statement] = sym_scope_statement,
  [sym__statement_no_case_no_default] = sym__statement_no_case_no_default,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_label] = sym_label,
  [sym_block_statement] = sym_block_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_if_condition] = sym_if_condition,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_for_statement] = sym_for_statement,
  [sym__foreach] = sym__foreach,
  [sym_foreach_statement] = sym_foreach_statement,
  [sym_foreach_type] = sym_foreach_type,
  [sym_switch_statement] = sym_switch_statement,
  [sym_case_statement] = sym_case_statement,
  [sym_final_switch_statement] = sym_final_switch_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_synchronized_statement] = sym_synchronized_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_statement] = sym_catch_statement,
  [sym_finally_statement] = sym_finally_statement,
  [sym_scope_guard_statement] = sym_scope_guard_statement,
  [sym_asm_statement] = sym_asm_statement,
  [sym_asm_inline] = sym_asm_inline,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_union_declaration] = sym_union_declaration,
  [sym_aggregate_body] = sym_aggregate_body,
  [sym_aggregate_initializer] = sym_aggregate_initializer,
  [sym_member_initializer] = sym_member_initializer,
  [sym_postblit] = sym_postblit,
  [sym_invariant_declaration] = sym_invariant_declaration,
  [sym_class_declaration] = sym_class_declaration,
  [sym__base_class_list] = sym__base_class_list,
  [sym_base_class] = sym_base_class,
  [sym_constructor] = sym_constructor,
  [sym_destructor] = sym_destructor,
  [sym_alias_this] = sym_alias_this,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym__enum_body] = sym__enum_body,
  [sym__enum_member_attribute] = sym__enum_member_attribute,
  [sym_enum_member] = sym_enum_member,
  [sym_anonymous_enum_declaration] = sym_anonymous_enum_declaration,
  [sym_anonymous_enum_member] = sym_anonymous_enum_member,
  [sym_function_declaration] = sym_function_declaration,
  [sym_parameters] = sym_parameters,
  [sym__parameters] = sym__parameters,
  [sym_parameter] = sym_parameter,
  [sym_parameter_attribute] = sym_parameter_attribute,
  [sym_ellipses] = sym_ellipses,
  [aux_sym__variadic_arguments_attributes] = aux_sym__variadic_arguments_attributes,
  [sym_variadic_arguments_attribute] = sym_variadic_arguments_attribute,
  [sym__function_attribute] = sym__function_attribute,
  [sym_member_function_attribute] = sym_member_function_attribute,
  [sym_function_body] = sym_function_body,
  [sym__specified_function_body] = sym__specified_function_body,
  [sym__function_contract] = sym__function_contract,
  [aux_sym__in_out_contract_expressions] = aux_sym__in_out_contract_expressions,
  [sym__in_out_contract_expression] = sym__in_out_contract_expression,
  [sym__in_out_statement] = sym__in_out_statement,
  [sym_in_contract_expression] = sym_in_contract_expression,
  [sym_out_contract_expression] = sym_out_contract_expression,
  [sym_in_statement] = sym_in_statement,
  [sym_out_statement] = sym_out_statement,
  [sym_template_declaration] = sym_template_declaration,
  [sym_template_instance] = sym_template_instance,
  [sym_template_arguments] = sym_template_arguments,
  [sym_template_argument] = sym_template_argument,
  [sym__template_argument_list] = sym__template_argument_list,
  [sym__template_single_arg] = sym__template_single_arg,
  [sym_template_parameter] = sym_template_parameter,
  [sym_template_parameters] = sym_template_parameters,
  [sym__template_parameter_list] = sym__template_parameter_list,
  [sym_constraint] = sym_constraint,
  [sym_mixin_template_declaration] = sym_mixin_template_declaration,
  [sym_template_mixin] = sym_template_mixin,
  [sym_conditional_declaration] = sym_conditional_declaration,
  [sym_conditional_statement] = sym_conditional_statement,
  [sym_condition] = sym_condition,
  [sym_version_condition] = sym_version_condition,
  [sym_version_specification] = sym_version_specification,
  [sym_debug_condition] = sym_debug_condition,
  [sym_debug_specification] = sym_debug_specification,
  [sym_static_if_condition] = sym_static_if_condition,
  [sym_static_foreach_statement] = sym_static_foreach_statement,
  [sym_static_foreach_declaration] = sym_static_foreach_declaration,
  [sym_static_assert] = sym_static_assert,
  [sym_traits_expression] = sym_traits_expression,
  [sym_unittest_declaration] = sym_unittest_declaration,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_module_declaration_repeat1] = aux_sym_module_declaration_repeat1,
  [aux_sym_module_fqn_repeat1] = aux_sym_module_fqn_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym__declaration_repeat1] = aux_sym__declaration_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_variable_declaration_repeat2] = aux_sym_variable_declaration_repeat2,
  [aux_sym__declarator_identifier_list_repeat1] = aux_sym__declarator_identifier_list_repeat1,
  [aux_sym_manifest_constant_repeat1] = aux_sym_manifest_constant_repeat1,
  [aux_sym_auto_declaration_repeat1] = aux_sym_auto_declaration_repeat1,
  [aux_sym_alias_declaration_repeat1] = aux_sym_alias_declaration_repeat1,
  [aux_sym_alias_declaration_repeat2] = aux_sym_alias_declaration_repeat2,
  [aux_sym_type_repeat1] = aux_sym_type_repeat1,
  [aux_sym_type_repeat2] = aux_sym_type_repeat2,
  [aux_sym__type_suffix_repeat1] = aux_sym__type_suffix_repeat1,
  [aux_sym__argument_list_repeat1] = aux_sym__argument_list_repeat1,
  [aux_sym__named_argument_list_repeat1] = aux_sym__named_argument_list_repeat1,
  [aux_sym_expression_list_repeat1] = aux_sym_expression_list_repeat1,
  [aux_sym_index_expression_repeat1] = aux_sym_index_expression_repeat1,
  [aux_sym_quoted_string_repeat1] = aux_sym_quoted_string_repeat1,
  [aux_sym_interpolated_raw_string_repeat1] = aux_sym_interpolated_raw_string_repeat1,
  [aux_sym_interpolated_quoted_string_repeat1] = aux_sym_interpolated_quoted_string_repeat1,
  [aux_sym_array_literal_repeat1] = aux_sym_array_literal_repeat1,
  [aux_sym_foreach_statement_repeat1] = aux_sym_foreach_statement_repeat1,
  [aux_sym_foreach_type_repeat1] = aux_sym_foreach_type_repeat1,
  [aux_sym_case_statement_repeat1] = aux_sym_case_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_asm_inline_repeat1] = aux_sym_asm_inline_repeat1,
  [aux_sym_aggregate_initializer_repeat1] = aux_sym_aggregate_initializer_repeat1,
  [aux_sym__base_class_list_repeat1] = aux_sym__base_class_list_repeat1,
  [aux_sym__enum_body_repeat1] = aux_sym__enum_body_repeat1,
  [aux_sym_enum_member_repeat1] = aux_sym_enum_member_repeat1,
  [aux_sym_anonymous_enum_declaration_repeat1] = aux_sym_anonymous_enum_declaration_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym__parameter_repeat1] = aux_sym__parameter_repeat1,
  [aux_sym_function_body_repeat1] = aux_sym_function_body_repeat1,
  [aux_sym__template_argument_list_repeat1] = aux_sym__template_argument_list_repeat1,
  [aux_sym__template_parameter_list_repeat1] = aux_sym__template_parameter_list_repeat1,
  [aux_sym_template_mixin_repeat1] = aux_sym_template_mixin_repeat1,
  [alias_sym_namespace_list] = alias_sym_namespace_list,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__bom] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_POUND_BANG] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_shebang_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_htmlentity_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHa] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHv] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_q_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_ubyte] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_short] = {
    .visible = true,
    .named = true,
  },
  [sym_ushort] = {
    .visible = true,
    .named = true,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_uint] = {
    .visible = true,
    .named = true,
  },
  [sym_long] = {
    .visible = true,
    .named = true,
  },
  [sym_ulong] = {
    .visible = true,
    .named = true,
  },
  [sym_cent] = {
    .visible = true,
    .named = true,
  },
  [sym_ucent] = {
    .visible = true,
    .named = true,
  },
  [sym_wchar] = {
    .visible = true,
    .named = true,
  },
  [sym_dchar] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_double] = {
    .visible = true,
    .named = true,
  },
  [sym_real] = {
    .visible = true,
    .named = true,
  },
  [sym_ifloat] = {
    .visible = true,
    .named = true,
  },
  [sym_idouble] = {
    .visible = true,
    .named = true,
  },
  [sym_ireal] = {
    .visible = true,
    .named = true,
  },
  [sym_cfloat] = {
    .visible = true,
    .named = true,
  },
  [sym_cdouble] = {
    .visible = true,
    .named = true,
  },
  [sym_creal] = {
    .visible = true,
    .named = true,
  },
  [sym_size_t] = {
    .visible = true,
    .named = true,
  },
  [sym_ptrdiff_t] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_cstring] = {
    .visible = true,
    .named = true,
  },
  [sym_dstring] = {
    .visible = true,
    .named = true,
  },
  [sym_wstring] = {
    .visible = true,
    .named = true,
  },
  [sym_noreturn] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_align] = {
    .visible = true,
    .named = true,
  },
  [sym_asm] = {
    .visible = true,
    .named = true,
  },
  [sym_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_auto] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_cast] = {
    .visible = true,
    .named = true,
  },
  [sym_catch] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_const] = {
    .visible = true,
    .named = true,
  },
  [sym_continue] = {
    .visible = true,
    .named = true,
  },
  [sym_debug] = {
    .visible = true,
    .named = true,
  },
  [sym_default] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate] = {
    .visible = true,
    .named = true,
  },
  [sym_delete] = {
    .visible = true,
    .named = true,
  },
  [sym_deprecated] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_enum] = {
    .visible = true,
    .named = true,
  },
  [sym_export] = {
    .visible = true,
    .named = true,
  },
  [sym_extern] = {
    .visible = true,
    .named = true,
  },
  [sym_final] = {
    .visible = true,
    .named = true,
  },
  [sym_finally] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_reverse] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_goto] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_immutable] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym_inout] = {
    .visible = true,
    .named = true,
  },
  [sym_interface] = {
    .visible = true,
    .named = true,
  },
  [sym_invariant] = {
    .visible = true,
    .named = true,
  },
  [sym_is] = {
    .visible = true,
    .named = true,
  },
  [sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_new] = {
    .visible = true,
    .named = true,
  },
  [sym_nothrow] = {
    .visible = true,
    .named = true,
  },
  [sym_out] = {
    .visible = true,
    .named = true,
  },
  [sym_override] = {
    .visible = true,
    .named = true,
  },
  [sym_package] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym_private] = {
    .visible = true,
    .named = true,
  },
  [sym_protected] = {
    .visible = true,
    .named = true,
  },
  [sym_public] = {
    .visible = true,
    .named = true,
  },
  [sym_pure] = {
    .visible = true,
    .named = true,
  },
  [sym_ref] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_scope] = {
    .visible = true,
    .named = true,
  },
  [sym_shared] = {
    .visible = true,
    .named = true,
  },
  [sym_static] = {
    .visible = true,
    .named = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_switch] = {
    .visible = true,
    .named = true,
  },
  [sym_synchronized] = {
    .visible = true,
    .named = true,
  },
  [sym_template] = {
    .visible = true,
    .named = true,
  },
  [sym_throw] = {
    .visible = true,
    .named = true,
  },
  [sym_try] = {
    .visible = true,
    .named = true,
  },
  [sym_typeid] = {
    .visible = true,
    .named = true,
  },
  [sym_typeof] = {
    .visible = true,
    .named = true,
  },
  [sym_union] = {
    .visible = true,
    .named = true,
  },
  [sym_unittest] = {
    .visible = true,
    .named = true,
  },
  [sym_version] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_with] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters_] = {
    .visible = true,
    .named = true,
  },
  [sym_gshared] = {
    .visible = true,
    .named = true,
  },
  [sym_traits] = {
    .visible = true,
    .named = true,
  },
  [sym_vector] = {
    .visible = true,
    .named = true,
  },
  [sym_void] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_C] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_D] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Windows] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_System] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Objective] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_raw_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_raw_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_r_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_raw_string_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_raw_string_token4] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_x_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_hex_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quoted_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpolated_raw_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_raw_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_interpolated_escape] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_i_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_interpolated_quoted_string_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_quoted_string_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iq_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_char_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___DATE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___FILE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___FILE_FULL_PATH__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___FUNCTION__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___LINE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___MODULE__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___PRETTY_FUNCTION__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___TIME__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___TIMESTAMP__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___VENDOR__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___VERSION__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_success] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_failure] = {
    .visible = true,
    .named = false,
  },
  [sym_end_file] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym_not_in] = {
    .visible = true,
    .named = true,
  },
  [sym_not_is] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_shebang] = {
    .visible = true,
    .named = true,
  },
  [sym_htmlentity] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_token_string] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__token_string_tokens] = {
    .visible = false,
    .named = false,
  },
  [sym__token_string_token] = {
    .visible = false,
    .named = true,
  },
  [sym__token_no_braces] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_dollar] = {
    .visible = true,
    .named = true,
  },
  [sym_module_def] = {
    .visible = true,
    .named = true,
  },
  [sym_module_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_module_fqn] = {
    .visible = true,
    .named = true,
  },
  [sym_import_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_imported] = {
    .visible = true,
    .named = true,
  },
  [sym_import_bind] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration2] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_bitfield_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_manifest_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_manifest_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_storage_class] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_auto_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__auto_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_reassign] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_ctor] = {
    .visible = true,
    .named = true,
  },
  [sym__type2] = {
    .visible = false,
    .named = true,
  },
  [sym_vector_type] = {
    .visible = true,
    .named = true,
  },
  [sym__builtin_type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_suffix] = {
    .visible = false,
    .named = true,
  },
  [sym__qualified_id] = {
    .visible = false,
    .named = true,
  },
  [sym_typeof_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_align_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_deprecated_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute] = {
    .visible = false,
    .named = true,
  },
  [sym_at_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__function_attribute_kwd] = {
    .visible = false,
    .named = true,
  },
  [sym_linkage_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__named_argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym_named_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_or_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_and_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_or_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_xor_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_and_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_equal_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_rel_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_add_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_mul_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_shift_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_power_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__unary_expr] = {
    .visible = false,
    .named = true,
  },
  [sym_property_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typeid_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_specialization] = {
    .visible = true,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_string] = {
    .visible = true,
    .named = true,
  },
  [sym_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_raw_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_quoted_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_token_string] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__i_token_string_tokens] = {
    .visible = false,
    .named = false,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_array_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__array_member_init] = {
    .visible = false,
    .named = true,
  },
  [sym_function_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_with_attributes] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_with_member_attributes] = {
    .visible = false,
    .named = true,
  },
  [sym_special_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__declarations_and_statements] = {
    .visible = false,
    .named = false,
  },
  [sym__declaration_or_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_scope_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_no_case_no_default] = {
    .visible = false,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_block_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__foreach] = {
    .visible = false,
    .named = true,
  },
  [sym_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_type] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_final_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_synchronized_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_guard_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_asm_inline] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_union_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_aggregate_body] = {
    .visible = true,
    .named = true,
  },
  [sym_aggregate_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_member_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_postblit] = {
    .visible = true,
    .named = true,
  },
  [sym_invariant_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__base_class_list] = {
    .visible = false,
    .named = true,
  },
  [sym_base_class] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_destructor] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_this] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_body] = {
    .visible = false,
    .named = true,
  },
  [sym__enum_member_attribute] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_member] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_enum_member] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_ellipses] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__variadic_arguments_attributes] = {
    .visible = false,
    .named = false,
  },
  [sym_variadic_arguments_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__function_attribute] = {
    .visible = false,
    .named = true,
  },
  [sym_member_function_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym__specified_function_body] = {
    .visible = false,
    .named = true,
  },
  [sym__function_contract] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__in_out_contract_expressions] = {
    .visible = false,
    .named = false,
  },
  [sym__in_out_contract_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__in_out_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_in_contract_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_out_contract_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_out_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_template_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_template_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__template_argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym__template_single_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_template_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_template_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__template_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_template_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_template_mixin] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_version_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_version_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_debug_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_debug_specification] = {
    .visible = true,
    .named = true,
  },
  [sym_static_if_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_static_foreach_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_static_foreach_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_static_assert] = {
    .visible = true,
    .named = true,
  },
  [sym_traits_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unittest_declaration] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_module_fqn_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declarator_identifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_manifest_constant_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_auto_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alias_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alias_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_suffix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__named_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_index_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_quoted_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_raw_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_quoted_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_foreach_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_foreach_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_asm_inline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_aggregate_initializer_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__base_class_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_member_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_enum_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__template_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__template_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_mixin_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_namespace_list] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_body = 3,
  field_condition = 4,
  field_consequence = 5,
  field_init = 6,
  field_key = 7,
  field_operand = 8,
  field_operator = 9,
  field_step = 10,
  field_test = 11,
  field_value = 12,
  field_variable = 13,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_init] = "init",
  [field_key] = "key",
  [field_operand] = "operand",
  [field_operator] = "operator",
  [field_step] = "step",
  [field_test] = "test",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 1},
  [8] = {.index = 8, .length = 2},
  [9] = {.index = 10, .length = 4},
  [10] = {.index = 14, .length = 4},
  [11] = {.index = 18, .length = 2},
  [12] = {.index = 20, .length = 1},
  [13] = {.index = 21, .length = 1},
  [14] = {.index = 22, .length = 2},
  [15] = {.index = 24, .length = 2},
  [16] = {.index = 26, .length = 4},
  [17] = {.index = 30, .length = 4},
  [18] = {.index = 34, .length = 1},
  [19] = {.index = 35, .length = 2},
  [20] = {.index = 37, .length = 1},
  [21] = {.index = 38, .length = 3},
  [23] = {.index = 41, .length = 1},
  [24] = {.index = 42, .length = 2},
  [25] = {.index = 44, .length = 2},
  [26] = {.index = 46, .length = 2},
  [27] = {.index = 48, .length = 1},
  [28] = {.index = 49, .length = 2},
  [29] = {.index = 51, .length = 2},
  [30] = {.index = 53, .length = 3},
  [31] = {.index = 56, .length = 2},
  [32] = {.index = 58, .length = 2},
  [33] = {.index = 60, .length = 3},
  [34] = {.index = 63, .length = 3},
  [35] = {.index = 66, .length = 1},
  [36] = {.index = 67, .length = 3},
  [37] = {.index = 70, .length = 4},
  [38] = {.index = 74, .length = 1},
  [39] = {.index = 75, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_value, 1, .inherited = true},
    {field_variable, 1, .inherited = true},
  [2] =
    {field_operator, 0},
  [3] =
    {field_value, 0},
  [4] =
    {field_operator, 1},
  [5] =
    {field_alias, 0},
  [6] =
    {field_body, 1},
  [7] =
    {field_consequence, 1},
  [8] =
    {field_value, 2},
    {field_variable, 0},
  [10] =
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
    {field_variable, 1, .inherited = true},
    {field_variable, 2, .inherited = true},
  [14] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_variable, 0, .inherited = true},
    {field_variable, 1, .inherited = true},
  [18] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [20] =
    {field_consequence, 2},
  [21] =
    {field_body, 2},
  [22] =
    {field_value, 3},
    {field_variable, 0},
  [24] =
    {field_key, 0},
    {field_value, 2},
  [26] =
    {field_key, 1, .inherited = true},
    {field_key, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [30] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [34] =
    {field_operand, 3},
  [35] =
    {field_alternative, 3},
    {field_consequence, 1},
  [37] =
    {field_operand, 4},
  [38] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [41] =
    {field_body, 4},
  [42] =
    {field_body, 4},
    {field_init, 2},
  [44] =
    {field_alternative, 4},
    {field_consequence, 2},
  [46] =
    {field_body, 1},
    {field_condition, 4},
  [48] =
    {field_body, 5},
  [49] =
    {field_body, 5},
    {field_test, 3},
  [51] =
    {field_body, 5},
    {field_init, 2},
  [53] =
    {field_body, 5},
    {field_init, 2},
    {field_test, 3},
  [56] =
    {field_body, 6},
    {field_step, 4},
  [58] =
    {field_body, 6},
    {field_test, 3},
  [60] =
    {field_body, 6},
    {field_init, 2},
    {field_step, 4},
  [63] =
    {field_body, 6},
    {field_init, 2},
    {field_test, 3},
  [66] =
    {field_body, 6},
  [67] =
    {field_body, 7},
    {field_step, 5},
    {field_test, 3},
  [70] =
    {field_body, 7},
    {field_init, 2},
    {field_step, 5},
    {field_test, 3},
  [74] =
    {field_body, 7},
  [75] =
    {field_body, 8},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [22] = {
    [5] = alias_sym_namespace_list,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__argument_list, 2,
    sym__argument_list,
    alias_sym_namespace_list,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 6,
  [8] = 6,
  [9] = 9,
  [10] = 10,
  [11] = 6,
  [12] = 6,
  [13] = 5,
  [14] = 4,
  [15] = 6,
  [16] = 4,
  [17] = 10,
  [18] = 5,
  [19] = 9,
  [20] = 10,
  [21] = 6,
  [22] = 4,
  [23] = 6,
  [24] = 10,
  [25] = 9,
  [26] = 9,
  [27] = 10,
  [28] = 5,
  [29] = 6,
  [30] = 6,
  [31] = 4,
  [32] = 5,
  [33] = 6,
  [34] = 6,
  [35] = 9,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 44,
  [47] = 47,
  [48] = 45,
  [49] = 45,
  [50] = 45,
  [51] = 45,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 47,
  [57] = 45,
  [58] = 52,
  [59] = 53,
  [60] = 54,
  [61] = 55,
  [62] = 47,
  [63] = 41,
  [64] = 47,
  [65] = 47,
  [66] = 54,
  [67] = 53,
  [68] = 52,
  [69] = 52,
  [70] = 47,
  [71] = 45,
  [72] = 53,
  [73] = 54,
  [74] = 55,
  [75] = 54,
  [76] = 53,
  [77] = 55,
  [78] = 45,
  [79] = 47,
  [80] = 55,
  [81] = 54,
  [82] = 53,
  [83] = 52,
  [84] = 45,
  [85] = 52,
  [86] = 55,
  [87] = 47,
  [88] = 53,
  [89] = 54,
  [90] = 55,
  [91] = 43,
  [92] = 53,
  [93] = 54,
  [94] = 45,
  [95] = 55,
  [96] = 45,
  [97] = 47,
  [98] = 47,
  [99] = 55,
  [100] = 54,
  [101] = 53,
  [102] = 52,
  [103] = 103,
  [104] = 52,
  [105] = 52,
  [106] = 52,
  [107] = 54,
  [108] = 55,
  [109] = 52,
  [110] = 47,
  [111] = 53,
  [112] = 54,
  [113] = 55,
  [114] = 45,
  [115] = 45,
  [116] = 53,
  [117] = 47,
  [118] = 36,
  [119] = 53,
  [120] = 42,
  [121] = 37,
  [122] = 52,
  [123] = 38,
  [124] = 54,
  [125] = 55,
  [126] = 39,
  [127] = 40,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 137,
  [140] = 135,
  [141] = 134,
  [142] = 133,
  [143] = 132,
  [144] = 131,
  [145] = 145,
  [146] = 41,
  [147] = 40,
  [148] = 42,
  [149] = 149,
  [150] = 150,
  [151] = 145,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 43,
  [160] = 160,
  [161] = 161,
  [162] = 152,
  [163] = 135,
  [164] = 164,
  [165] = 153,
  [166] = 130,
  [167] = 167,
  [168] = 136,
  [169] = 169,
  [170] = 138,
  [171] = 171,
  [172] = 44,
  [173] = 154,
  [174] = 39,
  [175] = 155,
  [176] = 160,
  [177] = 149,
  [178] = 164,
  [179] = 179,
  [180] = 167,
  [181] = 156,
  [182] = 171,
  [183] = 158,
  [184] = 150,
  [185] = 161,
  [186] = 179,
  [187] = 38,
  [188] = 128,
  [189] = 189,
  [190] = 179,
  [191] = 171,
  [192] = 131,
  [193] = 134,
  [194] = 133,
  [195] = 132,
  [196] = 132,
  [197] = 133,
  [198] = 134,
  [199] = 135,
  [200] = 137,
  [201] = 149,
  [202] = 150,
  [203] = 145,
  [204] = 152,
  [205] = 131,
  [206] = 171,
  [207] = 153,
  [208] = 154,
  [209] = 128,
  [210] = 155,
  [211] = 179,
  [212] = 156,
  [213] = 158,
  [214] = 161,
  [215] = 130,
  [216] = 136,
  [217] = 138,
  [218] = 160,
  [219] = 164,
  [220] = 167,
  [221] = 221,
  [222] = 189,
  [223] = 221,
  [224] = 128,
  [225] = 37,
  [226] = 128,
  [227] = 189,
  [228] = 189,
  [229] = 229,
  [230] = 229,
  [231] = 167,
  [232] = 164,
  [233] = 221,
  [234] = 149,
  [235] = 221,
  [236] = 160,
  [237] = 138,
  [238] = 150,
  [239] = 136,
  [240] = 129,
  [241] = 130,
  [242] = 145,
  [243] = 152,
  [244] = 161,
  [245] = 128,
  [246] = 158,
  [247] = 156,
  [248] = 221,
  [249] = 155,
  [250] = 154,
  [251] = 153,
  [252] = 221,
  [253] = 189,
  [254] = 152,
  [255] = 145,
  [256] = 150,
  [257] = 149,
  [258] = 137,
  [259] = 135,
  [260] = 179,
  [261] = 171,
  [262] = 134,
  [263] = 131,
  [264] = 132,
  [265] = 133,
  [266] = 134,
  [267] = 135,
  [268] = 137,
  [269] = 133,
  [270] = 149,
  [271] = 132,
  [272] = 131,
  [273] = 150,
  [274] = 145,
  [275] = 171,
  [276] = 179,
  [277] = 167,
  [278] = 152,
  [279] = 153,
  [280] = 154,
  [281] = 155,
  [282] = 164,
  [283] = 160,
  [284] = 189,
  [285] = 156,
  [286] = 129,
  [287] = 157,
  [288] = 158,
  [289] = 161,
  [290] = 130,
  [291] = 136,
  [292] = 169,
  [293] = 138,
  [294] = 138,
  [295] = 169,
  [296] = 221,
  [297] = 136,
  [298] = 130,
  [299] = 161,
  [300] = 189,
  [301] = 160,
  [302] = 164,
  [303] = 167,
  [304] = 36,
  [305] = 153,
  [306] = 158,
  [307] = 157,
  [308] = 156,
  [309] = 155,
  [310] = 154,
  [311] = 229,
  [312] = 153,
  [313] = 167,
  [314] = 128,
  [315] = 164,
  [316] = 160,
  [317] = 154,
  [318] = 138,
  [319] = 129,
  [320] = 136,
  [321] = 155,
  [322] = 130,
  [323] = 129,
  [324] = 156,
  [325] = 152,
  [326] = 161,
  [327] = 145,
  [328] = 158,
  [329] = 150,
  [330] = 149,
  [331] = 156,
  [332] = 158,
  [333] = 161,
  [334] = 155,
  [335] = 154,
  [336] = 130,
  [337] = 153,
  [338] = 152,
  [339] = 221,
  [340] = 189,
  [341] = 136,
  [342] = 138,
  [343] = 160,
  [344] = 145,
  [345] = 179,
  [346] = 171,
  [347] = 131,
  [348] = 132,
  [349] = 133,
  [350] = 134,
  [351] = 135,
  [352] = 137,
  [353] = 149,
  [354] = 129,
  [355] = 150,
  [356] = 145,
  [357] = 152,
  [358] = 153,
  [359] = 154,
  [360] = 155,
  [361] = 156,
  [362] = 158,
  [363] = 161,
  [364] = 130,
  [365] = 150,
  [366] = 136,
  [367] = 138,
  [368] = 149,
  [369] = 160,
  [370] = 164,
  [371] = 167,
  [372] = 164,
  [373] = 137,
  [374] = 137,
  [375] = 135,
  [376] = 134,
  [377] = 133,
  [378] = 132,
  [379] = 167,
  [380] = 131,
  [381] = 135,
  [382] = 134,
  [383] = 133,
  [384] = 132,
  [385] = 129,
  [386] = 131,
  [387] = 171,
  [388] = 179,
  [389] = 189,
  [390] = 229,
  [391] = 128,
  [392] = 167,
  [393] = 164,
  [394] = 157,
  [395] = 221,
  [396] = 189,
  [397] = 129,
  [398] = 160,
  [399] = 138,
  [400] = 179,
  [401] = 171,
  [402] = 131,
  [403] = 132,
  [404] = 133,
  [405] = 134,
  [406] = 135,
  [407] = 137,
  [408] = 149,
  [409] = 150,
  [410] = 145,
  [411] = 152,
  [412] = 153,
  [413] = 136,
  [414] = 169,
  [415] = 130,
  [416] = 154,
  [417] = 161,
  [418] = 155,
  [419] = 156,
  [420] = 158,
  [421] = 161,
  [422] = 130,
  [423] = 136,
  [424] = 138,
  [425] = 158,
  [426] = 160,
  [427] = 164,
  [428] = 167,
  [429] = 156,
  [430] = 155,
  [431] = 154,
  [432] = 128,
  [433] = 153,
  [434] = 152,
  [435] = 137,
  [436] = 145,
  [437] = 150,
  [438] = 149,
  [439] = 128,
  [440] = 137,
  [441] = 135,
  [442] = 129,
  [443] = 221,
  [444] = 189,
  [445] = 128,
  [446] = 134,
  [447] = 157,
  [448] = 179,
  [449] = 133,
  [450] = 171,
  [451] = 132,
  [452] = 131,
  [453] = 132,
  [454] = 133,
  [455] = 134,
  [456] = 135,
  [457] = 137,
  [458] = 149,
  [459] = 129,
  [460] = 150,
  [461] = 145,
  [462] = 152,
  [463] = 169,
  [464] = 153,
  [465] = 154,
  [466] = 155,
  [467] = 156,
  [468] = 158,
  [469] = 161,
  [470] = 130,
  [471] = 171,
  [472] = 131,
  [473] = 136,
  [474] = 138,
  [475] = 160,
  [476] = 128,
  [477] = 164,
  [478] = 179,
  [479] = 167,
  [480] = 129,
  [481] = 171,
  [482] = 221,
  [483] = 221,
  [484] = 157,
  [485] = 169,
  [486] = 129,
  [487] = 179,
  [488] = 189,
  [489] = 489,
  [490] = 489,
  [491] = 44,
  [492] = 489,
  [493] = 489,
  [494] = 489,
  [495] = 39,
  [496] = 40,
  [497] = 43,
  [498] = 489,
  [499] = 41,
  [500] = 489,
  [501] = 42,
  [502] = 489,
  [503] = 37,
  [504] = 38,
  [505] = 489,
  [506] = 489,
  [507] = 489,
  [508] = 36,
  [509] = 489,
  [510] = 510,
  [511] = 510,
  [512] = 510,
  [513] = 510,
  [514] = 510,
  [515] = 510,
  [516] = 510,
  [517] = 510,
  [518] = 510,
  [519] = 510,
  [520] = 510,
  [521] = 510,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 524,
  [526] = 523,
  [527] = 523,
  [528] = 523,
  [529] = 523,
  [530] = 524,
  [531] = 524,
  [532] = 524,
  [533] = 523,
  [534] = 524,
  [535] = 524,
  [536] = 523,
  [537] = 524,
  [538] = 523,
  [539] = 523,
  [540] = 524,
  [541] = 523,
  [542] = 523,
  [543] = 523,
  [544] = 524,
  [545] = 524,
  [546] = 546,
  [547] = 524,
  [548] = 523,
  [549] = 524,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 558,
  [560] = 560,
  [561] = 561,
  [562] = 558,
  [563] = 560,
  [564] = 564,
  [565] = 560,
  [566] = 560,
  [567] = 558,
  [568] = 561,
  [569] = 560,
  [570] = 558,
  [571] = 558,
  [572] = 558,
  [573] = 560,
  [574] = 574,
  [575] = 560,
  [576] = 560,
  [577] = 560,
  [578] = 558,
  [579] = 564,
  [580] = 558,
  [581] = 558,
  [582] = 560,
  [583] = 558,
  [584] = 560,
  [585] = 558,
  [586] = 560,
  [587] = 558,
  [588] = 560,
  [589] = 555,
  [590] = 556,
  [591] = 591,
  [592] = 550,
  [593] = 593,
  [594] = 591,
  [595] = 593,
  [596] = 591,
  [597] = 593,
  [598] = 551,
  [599] = 553,
  [600] = 591,
  [601] = 557,
  [602] = 593,
  [603] = 554,
  [604] = 552,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 607,
  [609] = 607,
  [610] = 607,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 614,
  [633] = 625,
  [634] = 616,
  [635] = 628,
  [636] = 629,
  [637] = 631,
  [638] = 624,
  [639] = 623,
  [640] = 617,
  [641] = 619,
  [642] = 615,
  [643] = 612,
  [644] = 620,
  [645] = 626,
  [646] = 630,
  [647] = 627,
  [648] = 611,
  [649] = 622,
  [650] = 621,
  [651] = 618,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 659,
  [662] = 659,
  [663] = 656,
  [664] = 664,
  [665] = 664,
  [666] = 664,
  [667] = 664,
  [668] = 653,
  [669] = 664,
  [670] = 658,
  [671] = 664,
  [672] = 652,
  [673] = 654,
  [674] = 664,
  [675] = 664,
  [676] = 664,
  [677] = 659,
  [678] = 660,
  [679] = 664,
  [680] = 664,
  [681] = 655,
  [682] = 657,
  [683] = 664,
  [684] = 684,
  [685] = 684,
  [686] = 684,
  [687] = 687,
  [688] = 653,
  [689] = 689,
  [690] = 689,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 693,
  [695] = 695,
  [696] = 695,
  [697] = 691,
  [698] = 692,
  [699] = 691,
  [700] = 693,
  [701] = 701,
  [702] = 692,
  [703] = 703,
  [704] = 695,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 705,
  [709] = 707,
  [710] = 705,
  [711] = 707,
  [712] = 707,
  [713] = 713,
  [714] = 707,
  [715] = 715,
  [716] = 705,
  [717] = 717,
  [718] = 718,
  [719] = 707,
  [720] = 720,
  [721] = 607,
  [722] = 705,
  [723] = 723,
  [724] = 713,
  [725] = 723,
  [726] = 717,
  [727] = 723,
  [728] = 720,
  [729] = 706,
  [730] = 720,
  [731] = 705,
  [732] = 723,
  [733] = 707,
  [734] = 723,
  [735] = 735,
  [736] = 720,
  [737] = 713,
  [738] = 723,
  [739] = 717,
  [740] = 720,
  [741] = 741,
  [742] = 723,
  [743] = 707,
  [744] = 705,
  [745] = 723,
  [746] = 706,
  [747] = 723,
  [748] = 723,
  [749] = 723,
  [750] = 720,
  [751] = 705,
  [752] = 705,
  [753] = 707,
  [754] = 707,
  [755] = 705,
  [756] = 723,
  [757] = 707,
  [758] = 705,
  [759] = 759,
  [760] = 760,
  [761] = 760,
  [762] = 759,
  [763] = 763,
  [764] = 763,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 765,
  [772] = 772,
  [773] = 773,
  [774] = 768,
  [775] = 765,
  [776] = 763,
  [777] = 759,
  [778] = 765,
  [779] = 760,
  [780] = 780,
  [781] = 781,
  [782] = 763,
  [783] = 760,
  [784] = 784,
  [785] = 763,
  [786] = 786,
  [787] = 760,
  [788] = 768,
  [789] = 765,
  [790] = 767,
  [791] = 759,
  [792] = 760,
  [793] = 793,
  [794] = 772,
  [795] = 759,
  [796] = 796,
  [797] = 797,
  [798] = 763,
  [799] = 772,
  [800] = 760,
  [801] = 793,
  [802] = 765,
  [803] = 759,
  [804] = 766,
  [805] = 763,
  [806] = 786,
  [807] = 784,
  [808] = 808,
  [809] = 772,
  [810] = 763,
  [811] = 811,
  [812] = 812,
  [813] = 765,
  [814] = 768,
  [815] = 763,
  [816] = 816,
  [817] = 760,
  [818] = 759,
  [819] = 786,
  [820] = 767,
  [821] = 769,
  [822] = 784,
  [823] = 765,
  [824] = 824,
  [825] = 759,
  [826] = 826,
  [827] = 765,
  [828] = 765,
  [829] = 793,
  [830] = 793,
  [831] = 784,
  [832] = 786,
  [833] = 763,
  [834] = 834,
  [835] = 769,
  [836] = 769,
  [837] = 786,
  [838] = 786,
  [839] = 760,
  [840] = 759,
  [841] = 768,
  [842] = 842,
  [843] = 843,
  [844] = 759,
  [845] = 768,
  [846] = 759,
  [847] = 767,
  [848] = 768,
  [849] = 784,
  [850] = 760,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 766,
  [855] = 766,
  [856] = 766,
  [857] = 767,
  [858] = 759,
  [859] = 760,
  [860] = 760,
  [861] = 861,
  [862] = 763,
  [863] = 765,
  [864] = 768,
  [865] = 763,
  [866] = 866,
  [867] = 867,
  [868] = 816,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
  [873] = 869,
  [874] = 874,
  [875] = 875,
  [876] = 876,
  [877] = 870,
  [878] = 878,
  [879] = 879,
  [880] = 871,
  [881] = 881,
  [882] = 872,
  [883] = 869,
  [884] = 875,
  [885] = 885,
  [886] = 871,
  [887] = 876,
  [888] = 870,
  [889] = 874,
  [890] = 878,
  [891] = 869,
  [892] = 869,
  [893] = 893,
  [894] = 894,
  [895] = 875,
  [896] = 885,
  [897] = 894,
  [898] = 872,
  [899] = 871,
  [900] = 876,
  [901] = 901,
  [902] = 902,
  [903] = 870,
  [904] = 902,
  [905] = 878,
  [906] = 906,
  [907] = 907,
  [908] = 872,
  [909] = 869,
  [910] = 869,
  [911] = 875,
  [912] = 885,
  [913] = 875,
  [914] = 871,
  [915] = 871,
  [916] = 874,
  [917] = 876,
  [918] = 907,
  [919] = 870,
  [920] = 879,
  [921] = 878,
  [922] = 875,
  [923] = 878,
  [924] = 924,
  [925] = 872,
  [926] = 869,
  [927] = 875,
  [928] = 885,
  [929] = 885,
  [930] = 871,
  [931] = 876,
  [932] = 869,
  [933] = 870,
  [934] = 878,
  [935] = 906,
  [936] = 936,
  [937] = 872,
  [938] = 893,
  [939] = 872,
  [940] = 878,
  [941] = 869,
  [942] = 875,
  [943] = 894,
  [944] = 902,
  [945] = 885,
  [946] = 871,
  [947] = 871,
  [948] = 870,
  [949] = 893,
  [950] = 876,
  [951] = 876,
  [952] = 952,
  [953] = 953,
  [954] = 885,
  [955] = 870,
  [956] = 876,
  [957] = 902,
  [958] = 874,
  [959] = 906,
  [960] = 936,
  [961] = 952,
  [962] = 871,
  [963] = 963,
  [964] = 878,
  [965] = 893,
  [966] = 963,
  [967] = 952,
  [968] = 936,
  [969] = 906,
  [970] = 872,
  [971] = 879,
  [972] = 885,
  [973] = 924,
  [974] = 893,
  [975] = 902,
  [976] = 875,
  [977] = 953,
  [978] = 875,
  [979] = 876,
  [980] = 870,
  [981] = 879,
  [982] = 982,
  [983] = 885,
  [984] = 984,
  [985] = 871,
  [986] = 986,
  [987] = 874,
  [988] = 893,
  [989] = 879,
  [990] = 875,
  [991] = 879,
  [992] = 874,
  [993] = 902,
  [994] = 893,
  [995] = 924,
  [996] = 872,
  [997] = 986,
  [998] = 878,
  [999] = 878,
  [1000] = 879,
  [1001] = 878,
  [1002] = 870,
  [1003] = 907,
  [1004] = 876,
  [1005] = 1005,
  [1006] = 894,
  [1007] = 874,
  [1008] = 1008,
  [1009] = 902,
  [1010] = 879,
  [1011] = 902,
  [1012] = 893,
  [1013] = 924,
  [1014] = 906,
  [1015] = 885,
  [1016] = 870,
  [1017] = 902,
  [1018] = 872,
  [1019] = 902,
  [1020] = 902,
  [1021] = 876,
  [1022] = 876,
  [1023] = 902,
  [1024] = 870,
  [1025] = 878,
  [1026] = 894,
  [1027] = 885,
  [1028] = 871,
  [1029] = 1029,
  [1030] = 907,
  [1031] = 872,
  [1032] = 963,
  [1033] = 872,
  [1034] = 869,
  [1035] = 1035,
  [1036] = 869,
  [1037] = 875,
  [1038] = 885,
  [1039] = 1039,
  [1040] = 874,
  [1041] = 1041,
  [1042] = 1042,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1044,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1049,
  [1056] = 1056,
  [1057] = 1044,
  [1058] = 1058,
  [1059] = 1050,
  [1060] = 1053,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1063,
  [1064] = 1041,
  [1065] = 1065,
  [1066] = 1066,
  [1067] = 1066,
  [1068] = 1049,
  [1069] = 1050,
  [1070] = 1070,
  [1071] = 1071,
  [1072] = 1053,
  [1073] = 1054,
  [1074] = 1056,
  [1075] = 1058,
  [1076] = 1041,
  [1077] = 1066,
  [1078] = 1078,
  [1079] = 1065,
  [1080] = 1063,
  [1081] = 1062,
  [1082] = 1061,
  [1083] = 1065,
  [1084] = 1084,
  [1085] = 1041,
  [1086] = 1058,
  [1087] = 1045,
  [1088] = 1056,
  [1089] = 1054,
  [1090] = 1053,
  [1091] = 1050,
  [1092] = 1049,
  [1093] = 1054,
  [1094] = 1056,
  [1095] = 1058,
  [1096] = 1041,
  [1097] = 1063,
  [1098] = 1066,
  [1099] = 1065,
  [1100] = 1063,
  [1101] = 1062,
  [1102] = 1061,
  [1103] = 1062,
  [1104] = 1044,
  [1105] = 1050,
  [1106] = 1062,
  [1107] = 1061,
  [1108] = 1063,
  [1109] = 1047,
  [1110] = 1049,
  [1111] = 1065,
  [1112] = 1050,
  [1113] = 1066,
  [1114] = 1041,
  [1115] = 1051,
  [1116] = 1045,
  [1117] = 1051,
  [1118] = 1058,
  [1119] = 1056,
  [1120] = 1054,
  [1121] = 1053,
  [1122] = 1053,
  [1123] = 1054,
  [1124] = 1056,
  [1125] = 1058,
  [1126] = 1041,
  [1127] = 1049,
  [1128] = 1066,
  [1129] = 1129,
  [1130] = 1065,
  [1131] = 1063,
  [1132] = 1042,
  [1133] = 1044,
  [1134] = 1062,
  [1135] = 1061,
  [1136] = 1045,
  [1137] = 1137,
  [1138] = 1046,
  [1139] = 1048,
  [1140] = 1051,
  [1141] = 1141,
  [1142] = 1061,
  [1143] = 1043,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1046,
  [1147] = 1044,
  [1148] = 1046,
  [1149] = 1043,
  [1150] = 1048,
  [1151] = 1044,
  [1152] = 1047,
  [1153] = 1048,
  [1154] = 1047,
  [1155] = 1049,
  [1156] = 1048,
  [1157] = 1050,
  [1158] = 1053,
  [1159] = 1159,
  [1160] = 1045,
  [1161] = 1054,
  [1162] = 1056,
  [1163] = 1058,
  [1164] = 1061,
  [1165] = 1041,
  [1166] = 1066,
  [1167] = 1062,
  [1168] = 1063,
  [1169] = 1049,
  [1170] = 1061,
  [1171] = 1062,
  [1172] = 1063,
  [1173] = 1065,
  [1174] = 1050,
  [1175] = 1063,
  [1176] = 1062,
  [1177] = 1061,
  [1178] = 1045,
  [1179] = 1053,
  [1180] = 1065,
  [1181] = 1042,
  [1182] = 1048,
  [1183] = 1066,
  [1184] = 1184,
  [1185] = 1041,
  [1186] = 1054,
  [1187] = 1065,
  [1188] = 1056,
  [1189] = 1189,
  [1190] = 1058,
  [1191] = 1066,
  [1192] = 1058,
  [1193] = 1066,
  [1194] = 1041,
  [1195] = 1056,
  [1196] = 1054,
  [1197] = 1051,
  [1198] = 1053,
  [1199] = 1058,
  [1200] = 1056,
  [1201] = 1050,
  [1202] = 1049,
  [1203] = 1043,
  [1204] = 1054,
  [1205] = 1041,
  [1206] = 1066,
  [1207] = 1065,
  [1208] = 1053,
  [1209] = 1063,
  [1210] = 1062,
  [1211] = 1061,
  [1212] = 1045,
  [1213] = 1050,
  [1214] = 1214,
  [1215] = 1049,
  [1216] = 1216,
  [1217] = 1217,
  [1218] = 1048,
  [1219] = 1129,
  [1220] = 1047,
  [1221] = 1046,
  [1222] = 1061,
  [1223] = 1062,
  [1224] = 1063,
  [1225] = 1065,
  [1226] = 1226,
  [1227] = 1044,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1043,
  [1231] = 1066,
  [1232] = 1041,
  [1233] = 1058,
  [1234] = 1234,
  [1235] = 1056,
  [1236] = 1054,
  [1237] = 1053,
  [1238] = 1238,
  [1239] = 1050,
  [1240] = 1049,
  [1241] = 1061,
  [1242] = 1046,
  [1243] = 1243,
  [1244] = 1046,
  [1245] = 1245,
  [1246] = 1043,
  [1247] = 1062,
  [1248] = 1044,
  [1249] = 1044,
  [1250] = 1043,
  [1251] = 1063,
  [1252] = 1065,
  [1253] = 1253,
  [1254] = 1042,
  [1255] = 1047,
  [1256] = 1256,
  [1257] = 1047,
  [1258] = 1058,
  [1259] = 1056,
  [1260] = 1054,
  [1261] = 1053,
  [1262] = 1262,
  [1263] = 1042,
  [1264] = 1050,
  [1265] = 1044,
  [1266] = 1044,
  [1267] = 1267,
  [1268] = 1049,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1271,
  [1272] = 1271,
  [1273] = 1270,
  [1274] = 1274,
  [1275] = 1270,
  [1276] = 1271,
  [1277] = 1271,
  [1278] = 1270,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1279,
  [1282] = 1279,
  [1283] = 1283,
  [1284] = 1284,
  [1285] = 1285,
  [1286] = 1280,
  [1287] = 1287,
  [1288] = 1285,
  [1289] = 1289,
  [1290] = 1279,
  [1291] = 1289,
  [1292] = 1279,
  [1293] = 1279,
  [1294] = 1283,
  [1295] = 1284,
  [1296] = 1287,
  [1297] = 1283,
  [1298] = 1284,
  [1299] = 1287,
  [1300] = 1284,
  [1301] = 1280,
  [1302] = 1279,
  [1303] = 1303,
  [1304] = 1274,
  [1305] = 1287,
  [1306] = 1303,
  [1307] = 1279,
  [1308] = 1287,
  [1309] = 1279,
  [1310] = 1279,
  [1311] = 1280,
  [1312] = 1287,
  [1313] = 1279,
  [1314] = 1284,
  [1315] = 1289,
  [1316] = 1289,
  [1317] = 1303,
  [1318] = 1285,
  [1319] = 1289,
  [1320] = 1283,
  [1321] = 1285,
  [1322] = 1285,
  [1323] = 1303,
  [1324] = 1303,
  [1325] = 1279,
  [1326] = 1285,
  [1327] = 1284,
  [1328] = 1283,
  [1329] = 1303,
  [1330] = 1280,
  [1331] = 1289,
  [1332] = 1283,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1335,
  [1336] = 1336,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1356,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1369,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1382,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1386,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1397,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1419,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1430,
  [1431] = 1431,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1438,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1445,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1456,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1460,
  [1461] = 1461,
  [1462] = 1462,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1468,
  [1469] = 1469,
  [1470] = 1470,
  [1471] = 1471,
  [1472] = 660,
  [1473] = 658,
  [1474] = 655,
  [1475] = 1426,
  [1476] = 1476,
  [1477] = 1477,
  [1478] = 1478,
  [1479] = 1427,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1346,
  [1485] = 1485,
  [1486] = 1486,
  [1487] = 1487,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1494,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1497,
  [1498] = 1498,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1508,
  [1509] = 1370,
  [1510] = 1346,
  [1511] = 1485,
  [1512] = 1452,
  [1513] = 1466,
  [1514] = 1453,
  [1515] = 1443,
  [1516] = 1359,
  [1517] = 1363,
  [1518] = 1465,
  [1519] = 1454,
  [1520] = 1455,
  [1521] = 1456,
  [1522] = 1457,
  [1523] = 1458,
  [1524] = 1459,
  [1525] = 1451,
  [1526] = 1449,
  [1527] = 1430,
  [1528] = 1461,
  [1529] = 1462,
  [1530] = 1463,
  [1531] = 1444,
  [1532] = 1464,
  [1533] = 1394,
  [1534] = 1467,
  [1535] = 1428,
  [1536] = 1442,
  [1537] = 1447,
  [1538] = 1421,
  [1539] = 1468,
  [1540] = 1469,
  [1541] = 1448,
  [1542] = 1415,
  [1543] = 1470,
  [1544] = 1471,
  [1545] = 1427,
  [1546] = 1426,
  [1547] = 1406,
  [1548] = 1405,
  [1549] = 1404,
  [1550] = 1401,
  [1551] = 1505,
  [1552] = 1503,
  [1553] = 1438,
  [1554] = 1393,
  [1555] = 1392,
  [1556] = 1389,
  [1557] = 1502,
  [1558] = 1501,
  [1559] = 1358,
  [1560] = 1385,
  [1561] = 1383,
  [1562] = 1351,
  [1563] = 1381,
  [1564] = 1380,
  [1565] = 1379,
  [1566] = 1378,
  [1567] = 1350,
  [1568] = 1376,
  [1569] = 1497,
  [1570] = 1335,
  [1571] = 1460,
  [1572] = 1445,
  [1573] = 1440,
  [1574] = 1496,
  [1575] = 1439,
  [1576] = 1434,
  [1577] = 1433,
  [1578] = 1432,
  [1579] = 1420,
  [1580] = 1403,
  [1581] = 1476,
  [1582] = 1402,
  [1583] = 1397,
  [1584] = 1349,
  [1585] = 1390,
  [1586] = 1388,
  [1587] = 1477,
  [1588] = 1478,
  [1589] = 1386,
  [1590] = 1499,
  [1591] = 1408,
  [1592] = 1347,
  [1593] = 1412,
  [1594] = 1480,
  [1595] = 1481,
  [1596] = 1422,
  [1597] = 1482,
  [1598] = 1364,
  [1599] = 1483,
  [1600] = 1488,
  [1601] = 1489,
  [1602] = 1427,
  [1603] = 1490,
  [1604] = 1357,
  [1605] = 1336,
  [1606] = 1436,
  [1607] = 1494,
  [1608] = 1348,
  [1609] = 1395,
  [1610] = 1437,
  [1611] = 1352,
  [1612] = 1441,
  [1613] = 1398,
  [1614] = 1435,
  [1615] = 1345,
  [1616] = 1360,
  [1617] = 1365,
  [1618] = 1446,
  [1619] = 1429,
  [1620] = 1361,
  [1621] = 1362,
  [1622] = 1333,
  [1623] = 1334,
  [1624] = 1391,
  [1625] = 1343,
  [1626] = 1426,
  [1627] = 1425,
  [1628] = 1384,
  [1629] = 1423,
  [1630] = 1424,
  [1631] = 1382,
  [1632] = 1366,
  [1633] = 1377,
  [1634] = 1375,
  [1635] = 1495,
  [1636] = 1374,
  [1637] = 1486,
  [1638] = 1487,
  [1639] = 1373,
  [1640] = 1367,
  [1641] = 1498,
  [1642] = 1500,
  [1643] = 1419,
  [1644] = 1372,
  [1645] = 1504,
  [1646] = 1371,
  [1647] = 1506,
  [1648] = 1507,
  [1649] = 1369,
  [1650] = 1368,
  [1651] = 1418,
  [1652] = 1417,
  [1653] = 1416,
  [1654] = 1508,
  [1655] = 1396,
  [1656] = 1344,
  [1657] = 1493,
  [1658] = 1399,
  [1659] = 1492,
  [1660] = 1346,
  [1661] = 1450,
  [1662] = 660,
  [1663] = 1431,
  [1664] = 1414,
  [1665] = 1491,
  [1666] = 1337,
  [1667] = 1400,
  [1668] = 1413,
  [1669] = 1411,
  [1670] = 1410,
  [1671] = 1407,
  [1672] = 1338,
  [1673] = 1339,
  [1674] = 1340,
  [1675] = 655,
  [1676] = 1341,
  [1677] = 1342,
  [1678] = 658,
  [1679] = 1356,
  [1680] = 1355,
  [1681] = 1353,
  [1682] = 1354,
  [1683] = 1683,
  [1684] = 1683,
  [1685] = 1683,
  [1686] = 1683,
  [1687] = 1683,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 556,
  [1700] = 551,
  [1701] = 553,
  [1702] = 553,
  [1703] = 552,
  [1704] = 556,
  [1705] = 554,
  [1706] = 557,
  [1707] = 550,
  [1708] = 557,
  [1709] = 554,
  [1710] = 552,
  [1711] = 555,
  [1712] = 551,
  [1713] = 550,
  [1714] = 555,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1715,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1723,
  [1726] = 1724,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1718,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1721,
  [1736] = 1722,
  [1737] = 1720,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1720,
  [1742] = 1730,
  [1743] = 1716,
  [1744] = 1720,
  [1745] = 1734,
  [1746] = 1740,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1716,
  [1750] = 1732,
  [1751] = 1727,
  [1752] = 1724,
  [1753] = 1732,
  [1754] = 1715,
  [1755] = 1733,
  [1756] = 1733,
  [1757] = 1747,
  [1758] = 1720,
  [1759] = 1759,
  [1760] = 1732,
  [1761] = 1761,
  [1762] = 1718,
  [1763] = 1716,
  [1764] = 1731,
  [1765] = 1730,
  [1766] = 1740,
  [1767] = 1731,
  [1768] = 1748,
  [1769] = 1732,
  [1770] = 1717,
  [1771] = 1720,
  [1772] = 1722,
  [1773] = 1728,
  [1774] = 1724,
  [1775] = 1721,
  [1776] = 1776,
  [1777] = 1732,
  [1778] = 1722,
  [1779] = 1730,
  [1780] = 1731,
  [1781] = 1776,
  [1782] = 1727,
  [1783] = 1727,
  [1784] = 1721,
  [1785] = 1785,
  [1786] = 1786,
  [1787] = 1787,
  [1788] = 1747,
  [1789] = 1718,
  [1790] = 1715,
  [1791] = 1716,
  [1792] = 1785,
  [1793] = 1786,
  [1794] = 1748,
  [1795] = 1787,
  [1796] = 1761,
  [1797] = 1717,
  [1798] = 1734,
  [1799] = 1734,
  [1800] = 1717,
  [1801] = 1724,
  [1802] = 1715,
  [1803] = 1717,
  [1804] = 1804,
  [1805] = 1740,
  [1806] = 1747,
  [1807] = 1807,
  [1808] = 1776,
  [1809] = 1728,
  [1810] = 1738,
  [1811] = 1740,
  [1812] = 1739,
  [1813] = 1761,
  [1814] = 1807,
  [1815] = 1738,
  [1816] = 1740,
  [1817] = 1738,
  [1818] = 1739,
  [1819] = 1716,
  [1820] = 1723,
  [1821] = 1723,
  [1822] = 1723,
  [1823] = 1748,
  [1824] = 1761,
  [1825] = 1761,
  [1826] = 1724,
  [1827] = 1787,
  [1828] = 1740,
  [1829] = 1785,
  [1830] = 1830,
  [1831] = 1761,
  [1832] = 1732,
  [1833] = 1728,
  [1834] = 1834,
  [1835] = 1830,
  [1836] = 1830,
  [1837] = 1717,
  [1838] = 1787,
  [1839] = 1761,
  [1840] = 1734,
  [1841] = 1724,
  [1842] = 1716,
  [1843] = 1830,
  [1844] = 1739,
  [1845] = 1834,
  [1846] = 1733,
  [1847] = 1728,
  [1848] = 1807,
  [1849] = 1740,
  [1850] = 1715,
  [1851] = 1807,
  [1852] = 1786,
  [1853] = 1717,
  [1854] = 1776,
  [1855] = 1830,
  [1856] = 1720,
  [1857] = 1733,
  [1858] = 1738,
  [1859] = 1732,
  [1860] = 1787,
  [1861] = 1786,
  [1862] = 1785,
  [1863] = 1739,
  [1864] = 1723,
  [1865] = 1723,
  [1866] = 1715,
  [1867] = 1761,
  [1868] = 1715,
  [1869] = 1786,
  [1870] = 1716,
  [1871] = 1747,
  [1872] = 1872,
  [1873] = 1723,
  [1874] = 1834,
  [1875] = 1748,
  [1876] = 1876,
  [1877] = 1724,
  [1878] = 1717,
  [1879] = 1720,
  [1880] = 1731,
  [1881] = 1730,
  [1882] = 1722,
  [1883] = 1785,
  [1884] = 1834,
  [1885] = 1727,
  [1886] = 1721,
  [1887] = 1718,
  [1888] = 1776,
  [1889] = 1834,
  [1890] = 1807,
  [1891] = 1891,
  [1892] = 655,
  [1893] = 1893,
  [1894] = 659,
  [1895] = 1895,
  [1896] = 1893,
  [1897] = 1897,
  [1898] = 1895,
  [1899] = 659,
  [1900] = 1897,
  [1901] = 1893,
  [1902] = 1893,
  [1903] = 1897,
  [1904] = 1893,
  [1905] = 652,
  [1906] = 1893,
  [1907] = 1895,
  [1908] = 654,
  [1909] = 1897,
  [1910] = 1895,
  [1911] = 1895,
  [1912] = 1893,
  [1913] = 1891,
  [1914] = 1897,
  [1915] = 1897,
  [1916] = 1891,
  [1917] = 653,
  [1918] = 660,
  [1919] = 658,
  [1920] = 1897,
  [1921] = 1895,
  [1922] = 657,
  [1923] = 656,
  [1924] = 1895,
  [1925] = 1891,
  [1926] = 1895,
  [1927] = 1897,
  [1928] = 1893,
  [1929] = 1929,
  [1930] = 1929,
  [1931] = 1929,
  [1932] = 1929,
  [1933] = 1929,
  [1934] = 1929,
  [1935] = 1929,
  [1936] = 1929,
  [1937] = 659,
  [1938] = 659,
  [1939] = 1271,
  [1940] = 1270,
  [1941] = 1270,
  [1942] = 1271,
  [1943] = 1271,
  [1944] = 1270,
  [1945] = 1270,
  [1946] = 1271,
  [1947] = 1274,
  [1948] = 1274,
  [1949] = 1411,
  [1950] = 1432,
  [1951] = 1359,
  [1952] = 1357,
  [1953] = 1356,
  [1954] = 1355,
  [1955] = 1427,
  [1956] = 1363,
  [1957] = 1470,
  [1958] = 1438,
  [1959] = 1447,
  [1960] = 1348,
  [1961] = 1460,
  [1962] = 1352,
  [1963] = 1500,
  [1964] = 1468,
  [1965] = 1336,
  [1966] = 1467,
  [1967] = 1448,
  [1968] = 1360,
  [1969] = 1476,
  [1970] = 1464,
  [1971] = 1364,
  [1972] = 660,
  [1973] = 1463,
  [1974] = 1365,
  [1975] = 1477,
  [1976] = 1478,
  [1977] = 1499,
  [1978] = 1480,
  [1979] = 1462,
  [1980] = 1461,
  [1981] = 1346,
  [1982] = 1366,
  [1983] = 1367,
  [1984] = 1481,
  [1985] = 1361,
  [1986] = 1482,
  [1987] = 1483,
  [1988] = 1498,
  [1989] = 658,
  [1990] = 1488,
  [1991] = 1489,
  [1992] = 1490,
  [1993] = 1343,
  [1994] = 1459,
  [1995] = 1458,
  [1996] = 655,
  [1997] = 1334,
  [1998] = 1391,
  [1999] = 1384,
  [2000] = 1457,
  [2001] = 1456,
  [2002] = 1371,
  [2003] = 1427,
  [2004] = 1386,
  [2005] = 1455,
  [2006] = 1454,
  [2007] = 1354,
  [2008] = 1333,
  [2009] = 1443,
  [2010] = 1469,
  [2011] = 1426,
  [2012] = 1346,
  [2013] = 1453,
  [2014] = 1452,
  [2015] = 1440,
  [2016] = 1353,
  [2017] = 1487,
  [2018] = 1445,
  [2019] = 1345,
  [2020] = 1368,
  [2021] = 1439,
  [2022] = 1491,
  [2023] = 1492,
  [2024] = 1494,
  [2025] = 1495,
  [2026] = 1399,
  [2027] = 1409,
  [2028] = 1496,
  [2029] = 1342,
  [2030] = 1497,
  [2031] = 1501,
  [2032] = 1502,
  [2033] = 1382,
  [2034] = 1423,
  [2035] = 1347,
  [2036] = 1341,
  [2037] = 1503,
  [2038] = 1340,
  [2039] = 1505,
  [2040] = 1339,
  [2041] = 1349,
  [2042] = 1369,
  [2043] = 1442,
  [2044] = 1434,
  [2045] = 1433,
  [2046] = 1398,
  [2047] = 1403,
  [2048] = 1402,
  [2049] = 1338,
  [2050] = 1337,
  [2051] = 1387,
  [2052] = 1390,
  [2053] = 1388,
  [2054] = 1431,
  [2055] = 1444,
  [2056] = 1362,
  [2057] = 1375,
  [2058] = 1426,
  [2059] = 1450,
  [2060] = 1493,
  [2061] = 1486,
  [2062] = 1377,
  [2063] = 1449,
  [2064] = 1451,
  [2065] = 1429,
  [2066] = 1374,
  [2067] = 1465,
  [2068] = 1466,
  [2069] = 1344,
  [2070] = 1396,
  [2071] = 1485,
  [2072] = 1435,
  [2073] = 1394,
  [2074] = 1395,
  [2075] = 1508,
  [2076] = 1507,
  [2077] = 1506,
  [2078] = 1471,
  [2079] = 1504,
  [2080] = 1425,
  [2081] = 1424,
  [2082] = 1419,
  [2083] = 1418,
  [2084] = 1417,
  [2085] = 1416,
  [2086] = 1414,
  [2087] = 1373,
  [2088] = 1413,
  [2089] = 1430,
  [2090] = 1428,
  [2091] = 1421,
  [2092] = 1415,
  [2093] = 1406,
  [2094] = 1410,
  [2095] = 1407,
  [2096] = 1405,
  [2097] = 1372,
  [2098] = 1404,
  [2099] = 1401,
  [2100] = 1393,
  [2101] = 1392,
  [2102] = 1389,
  [2103] = 1358,
  [2104] = 1383,
  [2105] = 1381,
  [2106] = 1380,
  [2107] = 1351,
  [2108] = 1379,
  [2109] = 1378,
  [2110] = 1376,
  [2111] = 1335,
  [2112] = 1420,
  [2113] = 1397,
  [2114] = 1408,
  [2115] = 1412,
  [2116] = 1422,
  [2117] = 1385,
  [2118] = 1400,
  [2119] = 1370,
  [2120] = 1436,
  [2121] = 1437,
  [2122] = 1350,
  [2123] = 1441,
  [2124] = 1446,
  [2125] = 1371,
  [2126] = 1426,
  [2127] = 1346,
  [2128] = 1427,
  [2129] = 1346,
  [2130] = 1440,
  [2131] = 1426,
  [2132] = 1427,
  [2133] = 1469,
  [2134] = 2134,
  [2135] = 2135,
  [2136] = 2135,
  [2137] = 2135,
  [2138] = 2135,
  [2139] = 2135,
  [2140] = 2140,
  [2141] = 2141,
  [2142] = 2142,
  [2143] = 2143,
  [2144] = 615,
  [2145] = 631,
  [2146] = 630,
  [2147] = 2147,
  [2148] = 2148,
  [2149] = 629,
  [2150] = 612,
  [2151] = 2151,
  [2152] = 628,
  [2153] = 2153,
  [2154] = 623,
  [2155] = 625,
  [2156] = 621,
  [2157] = 618,
  [2158] = 616,
  [2159] = 617,
  [2160] = 2160,
  [2161] = 619,
  [2162] = 626,
  [2163] = 611,
  [2164] = 627,
  [2165] = 2165,
  [2166] = 2166,
  [2167] = 2167,
  [2168] = 2168,
  [2169] = 2169,
  [2170] = 2170,
  [2171] = 2170,
  [2172] = 2170,
  [2173] = 2170,
  [2174] = 658,
  [2175] = 2170,
  [2176] = 2170,
  [2177] = 2170,
  [2178] = 2170,
  [2179] = 660,
  [2180] = 2170,
  [2181] = 655,
  [2182] = 2170,
  [2183] = 2170,
  [2184] = 2170,
  [2185] = 1385,
  [2186] = 1448,
  [2187] = 1448,
  [2188] = 1447,
  [2189] = 2189,
  [2190] = 2189,
  [2191] = 2189,
  [2192] = 1499,
  [2193] = 1447,
  [2194] = 2189,
  [2195] = 2189,
  [2196] = 2189,
  [2197] = 2189,
  [2198] = 1385,
  [2199] = 1499,
  [2200] = 655,
  [2201] = 2189,
  [2202] = 1443,
  [2203] = 658,
  [2204] = 660,
  [2205] = 1443,
  [2206] = 2206,
  [2207] = 2207,
  [2208] = 1433,
  [2209] = 1406,
  [2210] = 1478,
  [2211] = 1438,
  [2212] = 1477,
  [2213] = 1452,
  [2214] = 1363,
  [2215] = 1481,
  [2216] = 1359,
  [2217] = 1357,
  [2218] = 1476,
  [2219] = 2219,
  [2220] = 1335,
  [2221] = 1356,
  [2222] = 1355,
  [2223] = 1420,
  [2224] = 1354,
  [2225] = 1397,
  [2226] = 1408,
  [2227] = 1353,
  [2228] = 1412,
  [2229] = 1364,
  [2230] = 1422,
  [2231] = 1453,
  [2232] = 1423,
  [2233] = 1404,
  [2234] = 1480,
  [2235] = 1683,
  [2236] = 1436,
  [2237] = 1365,
  [2238] = 1376,
  [2239] = 1342,
  [2240] = 1366,
  [2241] = 1341,
  [2242] = 1378,
  [2243] = 1367,
  [2244] = 1437,
  [2245] = 1379,
  [2246] = 1441,
  [2247] = 1454,
  [2248] = 1482,
  [2249] = 1380,
  [2250] = 1381,
  [2251] = 1483,
  [2252] = 1446,
  [2253] = 2219,
  [2254] = 1486,
  [2255] = 1339,
  [2256] = 1338,
  [2257] = 1337,
  [2258] = 1487,
  [2259] = 1498,
  [2260] = 1488,
  [2261] = 1489,
  [2262] = 1500,
  [2263] = 1444,
  [2264] = 1504,
  [2265] = 1506,
  [2266] = 1490,
  [2267] = 1507,
  [2268] = 1431,
  [2269] = 1508,
  [2270] = 1423,
  [2271] = 1383,
  [2272] = 1340,
  [2273] = 1450,
  [2274] = 1396,
  [2275] = 1344,
  [2276] = 1493,
  [2277] = 1382,
  [2278] = 1455,
  [2279] = 1358,
  [2280] = 1377,
  [2281] = 1493,
  [2282] = 1344,
  [2283] = 1374,
  [2284] = 1373,
  [2285] = 1396,
  [2286] = 1450,
  [2287] = 1430,
  [2288] = 1456,
  [2289] = 1431,
  [2290] = 1428,
  [2291] = 1389,
  [2292] = 1471,
  [2293] = 1392,
  [2294] = 1508,
  [2295] = 1337,
  [2296] = 1338,
  [2297] = 1507,
  [2298] = 1339,
  [2299] = 1340,
  [2300] = 1393,
  [2301] = 1683,
  [2302] = 1341,
  [2303] = 1342,
  [2304] = 1470,
  [2305] = 1457,
  [2306] = 1683,
  [2307] = 1415,
  [2308] = 1458,
  [2309] = 1459,
  [2310] = 1406,
  [2311] = 1386,
  [2312] = 1388,
  [2313] = 1390,
  [2314] = 1402,
  [2315] = 1403,
  [2316] = 1353,
  [2317] = 1432,
  [2318] = 1433,
  [2319] = 1434,
  [2320] = 1439,
  [2321] = 1354,
  [2322] = 1355,
  [2323] = 1506,
  [2324] = 1445,
  [2325] = 1356,
  [2326] = 1357,
  [2327] = 1359,
  [2328] = 1363,
  [2329] = 2219,
  [2330] = 1401,
  [2331] = 1438,
  [2332] = 1372,
  [2333] = 1364,
  [2334] = 1404,
  [2335] = 1436,
  [2336] = 1469,
  [2337] = 1500,
  [2338] = 1498,
  [2339] = 1468,
  [2340] = 2219,
  [2341] = 1452,
  [2342] = 2219,
  [2343] = 1453,
  [2344] = 1405,
  [2345] = 1487,
  [2346] = 1365,
  [2347] = 1454,
  [2348] = 1455,
  [2349] = 1456,
  [2350] = 1457,
  [2351] = 1458,
  [2352] = 1459,
  [2353] = 1405,
  [2354] = 1366,
  [2355] = 1367,
  [2356] = 1461,
  [2357] = 1462,
  [2358] = 1463,
  [2359] = 2219,
  [2360] = 1464,
  [2361] = 1401,
  [2362] = 1467,
  [2363] = 1486,
  [2364] = 1504,
  [2365] = 1397,
  [2366] = 2219,
  [2367] = 1467,
  [2368] = 1468,
  [2369] = 1371,
  [2370] = 1393,
  [2371] = 1415,
  [2372] = 1470,
  [2373] = 1471,
  [2374] = 1446,
  [2375] = 2219,
  [2376] = 2219,
  [2377] = 1392,
  [2378] = 2219,
  [2379] = 2219,
  [2380] = 1469,
  [2381] = 1440,
  [2382] = 1389,
  [2383] = 1421,
  [2384] = 1441,
  [2385] = 1683,
  [2386] = 1437,
  [2387] = 1384,
  [2388] = 1440,
  [2389] = 1428,
  [2390] = 2219,
  [2391] = 1358,
  [2392] = 1383,
  [2393] = 1464,
  [2394] = 1334,
  [2395] = 1391,
  [2396] = 1368,
  [2397] = 1381,
  [2398] = 1369,
  [2399] = 1370,
  [2400] = 1444,
  [2401] = 1421,
  [2402] = 1371,
  [2403] = 1476,
  [2404] = 1463,
  [2405] = 1462,
  [2406] = 1386,
  [2407] = 1368,
  [2408] = 1369,
  [2409] = 1477,
  [2410] = 1478,
  [2411] = 2411,
  [2412] = 1370,
  [2413] = 1445,
  [2414] = 1379,
  [2415] = 1388,
  [2416] = 1480,
  [2417] = 1481,
  [2418] = 1482,
  [2419] = 1483,
  [2420] = 1488,
  [2421] = 1489,
  [2422] = 1490,
  [2423] = 1422,
  [2424] = 1372,
  [2425] = 1430,
  [2426] = 1683,
  [2427] = 1461,
  [2428] = 1378,
  [2429] = 1380,
  [2430] = 1390,
  [2431] = 1412,
  [2432] = 1408,
  [2433] = 1402,
  [2434] = 1403,
  [2435] = 1373,
  [2436] = 1420,
  [2437] = 1439,
  [2438] = 1374,
  [2439] = 1334,
  [2440] = 1391,
  [2441] = 1335,
  [2442] = 1434,
  [2443] = 1384,
  [2444] = 1376,
  [2445] = 1432,
  [2446] = 1382,
  [2447] = 1377,
  [2448] = 2448,
  [2449] = 2449,
  [2450] = 2448,
  [2451] = 2451,
  [2452] = 2449,
  [2453] = 620,
  [2454] = 2448,
  [2455] = 2455,
  [2456] = 2448,
  [2457] = 2449,
  [2458] = 2458,
  [2459] = 2448,
  [2460] = 2448,
  [2461] = 2461,
  [2462] = 2449,
  [2463] = 2448,
  [2464] = 2464,
  [2465] = 2448,
  [2466] = 2448,
  [2467] = 2467,
  [2468] = 2448,
  [2469] = 2469,
  [2470] = 2448,
  [2471] = 2449,
  [2472] = 2472,
  [2473] = 2448,
  [2474] = 2449,
  [2475] = 2449,
  [2476] = 1692,
  [2477] = 2477,
  [2478] = 2478,
  [2479] = 1695,
  [2480] = 2480,
  [2481] = 2481,
  [2482] = 1689,
  [2483] = 2483,
  [2484] = 2477,
  [2485] = 2477,
  [2486] = 2486,
  [2487] = 2487,
  [2488] = 1691,
  [2489] = 1693,
  [2490] = 2490,
  [2491] = 2477,
  [2492] = 1694,
  [2493] = 2493,
  [2494] = 2494,
  [2495] = 2477,
  [2496] = 2496,
  [2497] = 2497,
  [2498] = 2498,
  [2499] = 2499,
  [2500] = 2500,
  [2501] = 2501,
  [2502] = 2502,
  [2503] = 2502,
  [2504] = 2502,
  [2505] = 2502,
  [2506] = 2502,
  [2507] = 2507,
  [2508] = 2508,
  [2509] = 2507,
  [2510] = 2507,
  [2511] = 2507,
  [2512] = 2508,
  [2513] = 2508,
  [2514] = 2507,
  [2515] = 2507,
  [2516] = 2508,
  [2517] = 2508,
  [2518] = 2507,
  [2519] = 2519,
  [2520] = 2519,
  [2521] = 2521,
  [2522] = 2521,
  [2523] = 2521,
  [2524] = 2524,
  [2525] = 2519,
  [2526] = 2524,
  [2527] = 2527,
  [2528] = 2524,
  [2529] = 2527,
  [2530] = 2521,
  [2531] = 2531,
  [2532] = 2521,
  [2533] = 2524,
  [2534] = 2519,
  [2535] = 2524,
  [2536] = 2527,
  [2537] = 2527,
  [2538] = 2527,
  [2539] = 2519,
  [2540] = 2527,
  [2541] = 2527,
  [2542] = 2542,
  [2543] = 2542,
  [2544] = 2542,
  [2545] = 2545,
  [2546] = 2542,
  [2547] = 2542,
  [2548] = 2542,
  [2549] = 2542,
  [2550] = 2550,
  [2551] = 2550,
  [2552] = 2550,
  [2553] = 2542,
  [2554] = 2550,
  [2555] = 2542,
  [2556] = 2542,
  [2557] = 2545,
  [2558] = 2545,
  [2559] = 2542,
  [2560] = 2148,
  [2561] = 2542,
  [2562] = 2545,
  [2563] = 2545,
  [2564] = 2550,
  [2565] = 2542,
  [2566] = 612,
  [2567] = 2165,
  [2568] = 2166,
  [2569] = 2168,
  [2570] = 2151,
  [2571] = 2143,
  [2572] = 618,
  [2573] = 2153,
  [2574] = 619,
  [2575] = 617,
  [2576] = 623,
  [2577] = 616,
  [2578] = 2167,
  [2579] = 2160,
  [2580] = 615,
  [2581] = 626,
  [2582] = 611,
  [2583] = 627,
  [2584] = 625,
  [2585] = 628,
  [2586] = 629,
  [2587] = 631,
  [2588] = 630,
  [2589] = 621,
  [2590] = 2590,
  [2591] = 2591,
  [2592] = 2591,
  [2593] = 2591,
  [2594] = 2590,
  [2595] = 2591,
  [2596] = 2590,
  [2597] = 2591,
  [2598] = 2590,
  [2599] = 2591,
  [2600] = 2590,
  [2601] = 2590,
  [2602] = 2590,
  [2603] = 2591,
  [2604] = 2604,
  [2605] = 2605,
  [2606] = 2605,
  [2607] = 2607,
  [2608] = 2608,
  [2609] = 2604,
  [2610] = 2604,
  [2611] = 2147,
  [2612] = 2608,
  [2613] = 2604,
  [2614] = 2608,
  [2615] = 2604,
  [2616] = 2604,
  [2617] = 2605,
  [2618] = 2605,
  [2619] = 2608,
  [2620] = 2605,
  [2621] = 2608,
  [2622] = 2608,
  [2623] = 2604,
  [2624] = 2605,
  [2625] = 2605,
  [2626] = 2608,
  [2627] = 2608,
  [2628] = 2604,
  [2629] = 2604,
  [2630] = 2608,
  [2631] = 2605,
  [2632] = 2605,
  [2633] = 2633,
  [2634] = 2634,
  [2635] = 2633,
  [2636] = 2636,
  [2637] = 2637,
  [2638] = 2638,
  [2639] = 2637,
  [2640] = 2633,
  [2641] = 2633,
  [2642] = 2636,
  [2643] = 2643,
  [2644] = 2634,
  [2645] = 2645,
  [2646] = 2636,
  [2647] = 2647,
  [2648] = 2633,
  [2649] = 2634,
  [2650] = 2650,
  [2651] = 2637,
  [2652] = 2637,
  [2653] = 2637,
  [2654] = 2634,
  [2655] = 2634,
  [2656] = 2637,
  [2657] = 2657,
  [2658] = 2634,
  [2659] = 2659,
  [2660] = 2636,
  [2661] = 2634,
  [2662] = 2636,
  [2663] = 2633,
  [2664] = 2637,
  [2665] = 2633,
  [2666] = 2636,
  [2667] = 2636,
  [2668] = 2668,
  [2669] = 620,
  [2670] = 2670,
  [2671] = 2170,
  [2672] = 2672,
  [2673] = 2673,
  [2674] = 2674,
  [2675] = 2147,
  [2676] = 2483,
  [2677] = 2673,
  [2678] = 2672,
  [2679] = 2486,
  [2680] = 2674,
  [2681] = 2494,
  [2682] = 2682,
  [2683] = 2490,
  [2684] = 2497,
  [2685] = 2670,
  [2686] = 2467,
  [2687] = 2687,
  [2688] = 2682,
  [2689] = 2481,
  [2690] = 2674,
  [2691] = 2691,
  [2692] = 2682,
  [2693] = 2693,
  [2694] = 2694,
  [2695] = 2673,
  [2696] = 2696,
  [2697] = 2697,
  [2698] = 2607,
  [2699] = 2670,
  [2700] = 2672,
  [2701] = 2701,
  [2702] = 2702,
  [2703] = 2148,
  [2704] = 2704,
  [2705] = 2147,
  [2706] = 2706,
  [2707] = 631,
  [2708] = 2166,
  [2709] = 623,
  [2710] = 2710,
  [2711] = 629,
  [2712] = 617,
  [2713] = 619,
  [2714] = 2165,
  [2715] = 628,
  [2716] = 2716,
  [2717] = 2168,
  [2718] = 2147,
  [2719] = 2719,
  [2720] = 2720,
  [2721] = 625,
  [2722] = 2722,
  [2723] = 2723,
  [2724] = 2724,
  [2725] = 2151,
  [2726] = 2167,
  [2727] = 630,
  [2728] = 616,
  [2729] = 2143,
  [2730] = 618,
  [2731] = 612,
  [2732] = 615,
  [2733] = 2160,
  [2734] = 621,
  [2735] = 627,
  [2736] = 2153,
  [2737] = 626,
  [2738] = 611,
  [2739] = 2739,
  [2740] = 2740,
  [2741] = 2741,
  [2742] = 2741,
  [2743] = 2739,
  [2744] = 2207,
  [2745] = 2739,
  [2746] = 2746,
  [2747] = 2741,
  [2748] = 2746,
  [2749] = 2746,
  [2750] = 2746,
  [2751] = 2739,
  [2752] = 2148,
  [2753] = 2740,
  [2754] = 2741,
  [2755] = 2740,
  [2756] = 2741,
  [2757] = 2740,
  [2758] = 2746,
  [2759] = 2740,
  [2760] = 2739,
  [2761] = 617,
  [2762] = 2148,
  [2763] = 2166,
  [2764] = 2764,
  [2765] = 2722,
  [2766] = 2153,
  [2767] = 2165,
  [2768] = 2724,
  [2769] = 2769,
  [2770] = 2160,
  [2771] = 2716,
  [2772] = 2167,
  [2773] = 2143,
  [2774] = 2774,
  [2775] = 2151,
  [2776] = 2764,
  [2777] = 618,
  [2778] = 2774,
  [2779] = 621,
  [2780] = 630,
  [2781] = 612,
  [2782] = 2774,
  [2783] = 631,
  [2784] = 2784,
  [2785] = 629,
  [2786] = 628,
  [2787] = 2710,
  [2788] = 2723,
  [2789] = 2720,
  [2790] = 2719,
  [2791] = 625,
  [2792] = 2764,
  [2793] = 2764,
  [2794] = 2774,
  [2795] = 2795,
  [2796] = 616,
  [2797] = 2168,
  [2798] = 2764,
  [2799] = 2774,
  [2800] = 619,
  [2801] = 2219,
  [2802] = 623,
  [2803] = 2803,
  [2804] = 627,
  [2805] = 611,
  [2806] = 626,
  [2807] = 615,
  [2808] = 2722,
  [2809] = 2449,
  [2810] = 2147,
  [2811] = 2724,
  [2812] = 618,
  [2813] = 621,
  [2814] = 630,
  [2815] = 2723,
  [2816] = 2160,
  [2817] = 623,
  [2818] = 612,
  [2819] = 631,
  [2820] = 2448,
  [2821] = 2472,
  [2822] = 619,
  [2823] = 2168,
  [2824] = 617,
  [2825] = 2720,
  [2826] = 2716,
  [2827] = 2710,
  [2828] = 2153,
  [2829] = 2167,
  [2830] = 2143,
  [2831] = 2687,
  [2832] = 629,
  [2833] = 628,
  [2834] = 625,
  [2835] = 2151,
  [2836] = 615,
  [2837] = 2411,
  [2838] = 616,
  [2839] = 626,
  [2840] = 2464,
  [2841] = 611,
  [2842] = 2719,
  [2843] = 2165,
  [2844] = 2166,
  [2845] = 627,
  [2846] = 2846,
  [2847] = 2847,
  [2848] = 2848,
  [2849] = 2849,
  [2850] = 2849,
  [2851] = 2849,
  [2852] = 2846,
  [2853] = 2846,
  [2854] = 2848,
  [2855] = 2848,
  [2856] = 2846,
  [2857] = 2846,
  [2858] = 2848,
  [2859] = 2848,
  [2860] = 2849,
  [2861] = 2769,
  [2862] = 2846,
  [2863] = 2848,
  [2864] = 2848,
  [2865] = 2480,
  [2866] = 2846,
  [2867] = 2795,
  [2868] = 2848,
  [2869] = 2702,
  [2870] = 2846,
  [2871] = 2496,
  [2872] = 2848,
  [2873] = 2848,
  [2874] = 2848,
  [2875] = 2849,
  [2876] = 2846,
  [2877] = 2704,
  [2878] = 2849,
  [2879] = 2846,
  [2880] = 2848,
  [2881] = 2846,
  [2882] = 2846,
  [2883] = 2803,
  [2884] = 2849,
  [2885] = 2849,
  [2886] = 2147,
  [2887] = 625,
  [2888] = 2148,
  [2889] = 611,
  [2890] = 618,
  [2891] = 621,
  [2892] = 630,
  [2893] = 627,
  [2894] = 612,
  [2895] = 631,
  [2896] = 2803,
  [2897] = 623,
  [2898] = 2143,
  [2899] = 2795,
  [2900] = 2151,
  [2901] = 2901,
  [2902] = 2160,
  [2903] = 616,
  [2904] = 2904,
  [2905] = 617,
  [2906] = 619,
  [2907] = 615,
  [2908] = 629,
  [2909] = 628,
  [2910] = 2153,
  [2911] = 626,
  [2912] = 2769,
  [2913] = 2720,
  [2914] = 2914,
  [2915] = 2915,
  [2916] = 2916,
  [2917] = 2719,
  [2918] = 2167,
  [2919] = 2915,
  [2920] = 2920,
  [2921] = 2914,
  [2922] = 2165,
  [2923] = 2923,
  [2924] = 2920,
  [2925] = 2166,
  [2926] = 2723,
  [2927] = 2927,
  [2928] = 2168,
  [2929] = 2722,
  [2930] = 2914,
  [2931] = 2915,
  [2932] = 2932,
  [2933] = 2920,
  [2934] = 2710,
  [2935] = 2724,
  [2936] = 2147,
  [2937] = 2937,
  [2938] = 660,
  [2939] = 2148,
  [2940] = 2940,
  [2941] = 658,
  [2942] = 2942,
  [2943] = 655,
  [2944] = 2944,
  [2945] = 2945,
  [2946] = 2946,
  [2947] = 2947,
  [2948] = 2948,
  [2949] = 2719,
  [2950] = 2950,
  [2951] = 2148,
  [2952] = 2952,
  [2953] = 2952,
  [2954] = 2151,
  [2955] = 2952,
  [2956] = 2143,
  [2957] = 2957,
  [2958] = 2923,
  [2959] = 2166,
  [2960] = 2960,
  [2961] = 2160,
  [2962] = 2720,
  [2963] = 2960,
  [2964] = 2952,
  [2965] = 2151,
  [2966] = 2966,
  [2967] = 2967,
  [2968] = 2968,
  [2969] = 2957,
  [2970] = 2153,
  [2971] = 619,
  [2972] = 617,
  [2973] = 623,
  [2974] = 2960,
  [2975] = 2143,
  [2976] = 619,
  [2977] = 617,
  [2978] = 623,
  [2979] = 2979,
  [2980] = 2957,
  [2981] = 2952,
  [2982] = 2982,
  [2983] = 2710,
  [2984] = 2167,
  [2985] = 2960,
  [2986] = 2986,
  [2987] = 2987,
  [2988] = 616,
  [2989] = 2724,
  [2990] = 615,
  [2991] = 626,
  [2992] = 611,
  [2993] = 627,
  [2994] = 616,
  [2995] = 2160,
  [2996] = 615,
  [2997] = 2165,
  [2998] = 626,
  [2999] = 2722,
  [3000] = 611,
  [3001] = 627,
  [3002] = 2952,
  [3003] = 618,
  [3004] = 621,
  [3005] = 625,
  [3006] = 630,
  [3007] = 628,
  [3008] = 629,
  [3009] = 631,
  [3010] = 612,
  [3011] = 630,
  [3012] = 621,
  [3013] = 618,
  [3014] = 2723,
  [3015] = 612,
  [3016] = 631,
  [3017] = 629,
  [3018] = 628,
  [3019] = 2168,
  [3020] = 2153,
  [3021] = 3021,
  [3022] = 625,
  [3023] = 2960,
  [3024] = 3024,
  [3025] = 3025,
  [3026] = 2168,
  [3027] = 2946,
  [3028] = 3028,
  [3029] = 2167,
  [3030] = 3030,
  [3031] = 3031,
  [3032] = 3032,
  [3033] = 2165,
  [3034] = 3034,
  [3035] = 2923,
  [3036] = 3036,
  [3037] = 3037,
  [3038] = 2166,
  [3039] = 3039,
  [3040] = 2724,
  [3041] = 2723,
  [3042] = 2947,
  [3043] = 3043,
  [3044] = 2722,
  [3045] = 3045,
  [3046] = 2710,
  [3047] = 3047,
  [3048] = 3048,
  [3049] = 3043,
  [3050] = 3050,
  [3051] = 2719,
  [3052] = 2720,
  [3053] = 2923,
  [3054] = 3054,
  [3055] = 3055,
  [3056] = 3056,
  [3057] = 2945,
  [3058] = 2937,
  [3059] = 2942,
  [3060] = 3060,
  [3061] = 3043,
  [3062] = 3062,
  [3063] = 2927,
  [3064] = 2923,
  [3065] = 3065,
  [3066] = 2948,
  [3067] = 3067,
  [3068] = 3068,
  [3069] = 2927,
  [3070] = 3070,
  [3071] = 2923,
  [3072] = 3072,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 3075,
  [3076] = 2948,
  [3077] = 3077,
  [3078] = 3078,
  [3079] = 3079,
  [3080] = 3075,
  [3081] = 3081,
  [3082] = 3082,
  [3083] = 3083,
  [3084] = 2923,
  [3085] = 3070,
  [3086] = 2945,
  [3087] = 2923,
  [3088] = 3075,
  [3089] = 3089,
  [3090] = 3068,
  [3091] = 2927,
  [3092] = 3092,
  [3093] = 3093,
  [3094] = 3094,
  [3095] = 3070,
  [3096] = 3096,
  [3097] = 2946,
  [3098] = 3098,
  [3099] = 3093,
  [3100] = 2947,
  [3101] = 3093,
  [3102] = 3079,
  [3103] = 3098,
  [3104] = 3104,
  [3105] = 3096,
  [3106] = 3073,
  [3107] = 2927,
  [3108] = 3096,
  [3109] = 3092,
  [3110] = 3094,
  [3111] = 3079,
  [3112] = 3093,
  [3113] = 3104,
  [3114] = 3114,
  [3115] = 3092,
  [3116] = 3081,
  [3117] = 3089,
  [3118] = 3098,
  [3119] = 3093,
  [3120] = 3120,
  [3121] = 2927,
  [3122] = 3073,
  [3123] = 3098,
  [3124] = 3075,
  [3125] = 2937,
  [3126] = 3070,
  [3127] = 2923,
  [3128] = 3128,
  [3129] = 3070,
  [3130] = 3089,
  [3131] = 3104,
  [3132] = 3068,
  [3133] = 2942,
  [3134] = 3092,
  [3135] = 3073,
  [3136] = 3096,
  [3137] = 3079,
  [3138] = 3075,
  [3139] = 3139,
  [3140] = 3092,
  [3141] = 3141,
  [3142] = 3068,
  [3143] = 3089,
  [3144] = 3094,
  [3145] = 3098,
  [3146] = 3081,
  [3147] = 3093,
  [3148] = 3079,
  [3149] = 3149,
  [3150] = 3096,
  [3151] = 3151,
  [3152] = 3151,
  [3153] = 3089,
  [3154] = 3070,
  [3155] = 3073,
  [3156] = 3104,
  [3157] = 3104,
  [3158] = 3158,
  [3159] = 3081,
  [3160] = 3160,
  [3161] = 2927,
  [3162] = 3162,
  [3163] = 3163,
  [3164] = 3068,
  [3165] = 3048,
  [3166] = 3166,
  [3167] = 3060,
  [3168] = 3168,
  [3169] = 3114,
  [3170] = 656,
  [3171] = 3171,
  [3172] = 3172,
  [3173] = 659,
  [3174] = 3174,
  [3175] = 3175,
  [3176] = 3176,
  [3177] = 3177,
  [3178] = 3178,
  [3179] = 3179,
  [3180] = 3045,
  [3181] = 3181,
  [3182] = 3182,
  [3183] = 653,
  [3184] = 1444,
  [3185] = 3065,
  [3186] = 659,
  [3187] = 3024,
  [3188] = 3047,
  [3189] = 3034,
  [3190] = 3190,
  [3191] = 2987,
  [3192] = 3114,
  [3193] = 3193,
  [3194] = 3194,
  [3195] = 2923,
  [3196] = 2987,
  [3197] = 3114,
  [3198] = 3198,
  [3199] = 3199,
  [3200] = 3190,
  [3201] = 3201,
  [3202] = 657,
  [3203] = 654,
  [3204] = 3204,
  [3205] = 3050,
  [3206] = 3206,
  [3207] = 652,
  [3208] = 3208,
  [3209] = 3209,
  [3210] = 3190,
  [3211] = 3211,
  [3212] = 3212,
  [3213] = 2927,
  [3214] = 3190,
  [3215] = 3215,
  [3216] = 3216,
  [3217] = 3217,
  [3218] = 3218,
  [3219] = 3039,
  [3220] = 2968,
  [3221] = 3221,
  [3222] = 3114,
  [3223] = 3223,
  [3224] = 3224,
  [3225] = 3225,
  [3226] = 3226,
  [3227] = 3227,
  [3228] = 3032,
  [3229] = 3190,
  [3230] = 2982,
  [3231] = 3190,
  [3232] = 2950,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 3021,
  [3236] = 3236,
  [3237] = 3237,
  [3238] = 3190,
  [3239] = 3223,
  [3240] = 3240,
  [3241] = 3056,
  [3242] = 3037,
  [3243] = 3062,
  [3244] = 2966,
  [3245] = 2966,
  [3246] = 2968,
  [3247] = 2986,
  [3248] = 2979,
  [3249] = 3190,
  [3250] = 3250,
  [3251] = 3251,
  [3252] = 3252,
  [3253] = 3253,
  [3254] = 3254,
  [3255] = 3255,
  [3256] = 2986,
  [3257] = 3055,
  [3258] = 3036,
  [3259] = 1423,
  [3260] = 2982,
  [3261] = 2950,
  [3262] = 3162,
  [3263] = 3263,
  [3264] = 3163,
  [3265] = 687,
  [3266] = 2979,
  [3267] = 2979,
  [3268] = 3047,
  [3269] = 3021,
  [3270] = 3062,
  [3271] = 3060,
  [3272] = 2979,
  [3273] = 2982,
  [3274] = 3032,
  [3275] = 3074,
  [3276] = 2950,
  [3277] = 3034,
  [3278] = 3151,
  [3279] = 3160,
  [3280] = 3036,
  [3281] = 3021,
  [3282] = 3021,
  [3283] = 3037,
  [3284] = 2982,
  [3285] = 3055,
  [3286] = 3039,
  [3287] = 3056,
  [3288] = 3288,
  [3289] = 3024,
  [3290] = 3290,
  [3291] = 3291,
  [3292] = 3292,
  [3293] = 2950,
  [3294] = 3021,
  [3295] = 3065,
  [3296] = 3045,
  [3297] = 3139,
  [3298] = 2982,
  [3299] = 2950,
  [3300] = 3300,
  [3301] = 3077,
  [3302] = 2979,
  [3303] = 2950,
  [3304] = 3078,
  [3305] = 2979,
  [3306] = 3306,
  [3307] = 3307,
  [3308] = 3308,
  [3309] = 3050,
  [3310] = 3310,
  [3311] = 3311,
  [3312] = 3312,
  [3313] = 3313,
  [3314] = 3314,
  [3315] = 3158,
  [3316] = 3151,
  [3317] = 3317,
  [3318] = 3048,
  [3319] = 3319,
  [3320] = 3320,
  [3321] = 2982,
  [3322] = 3322,
  [3323] = 3323,
  [3324] = 3021,
  [3325] = 3325,
  [3326] = 3326,
  [3327] = 3178,
  [3328] = 1423,
  [3329] = 3162,
  [3330] = 3160,
  [3331] = 3254,
  [3332] = 3240,
  [3333] = 3253,
  [3334] = 3163,
  [3335] = 3317,
  [3336] = 3317,
  [3337] = 3209,
  [3338] = 3252,
  [3339] = 3193,
  [3340] = 3212,
  [3341] = 3233,
  [3342] = 3217,
  [3343] = 3218,
  [3344] = 1444,
  [3345] = 3151,
  [3346] = 3168,
  [3347] = 3171,
  [3348] = 659,
  [3349] = 660,
  [3350] = 3224,
  [3351] = 3077,
  [3352] = 3175,
  [3353] = 3236,
  [3354] = 3176,
  [3355] = 3250,
  [3356] = 3177,
  [3357] = 3225,
  [3358] = 3172,
  [3359] = 3234,
  [3360] = 3215,
  [3361] = 3211,
  [3362] = 655,
  [3363] = 3194,
  [3364] = 3181,
  [3365] = 3158,
  [3366] = 3174,
  [3367] = 3226,
  [3368] = 3179,
  [3369] = 3208,
  [3370] = 3074,
  [3371] = 3371,
  [3372] = 658,
  [3373] = 3221,
  [3374] = 3317,
  [3375] = 3255,
  [3376] = 3198,
  [3377] = 3139,
  [3378] = 3227,
  [3379] = 3216,
  [3380] = 659,
  [3381] = 3078,
  [3382] = 3251,
  [3383] = 3317,
  [3384] = 3199,
  [3385] = 3021,
  [3386] = 3182,
  [3387] = 3166,
  [3388] = 2979,
  [3389] = 2982,
  [3390] = 3151,
  [3391] = 2950,
  [3392] = 3234,
  [3393] = 3313,
  [3394] = 3209,
  [3395] = 3208,
  [3396] = 3310,
  [3397] = 3181,
  [3398] = 1444,
  [3399] = 3307,
  [3400] = 658,
  [3401] = 3292,
  [3402] = 3311,
  [3403] = 3288,
  [3404] = 3221,
  [3405] = 3212,
  [3406] = 3312,
  [3407] = 1423,
  [3408] = 3233,
  [3409] = 3311,
  [3410] = 3216,
  [3411] = 3166,
  [3412] = 3215,
  [3413] = 3326,
  [3414] = 3291,
  [3415] = 3320,
  [3416] = 3322,
  [3417] = 3171,
  [3418] = 3308,
  [3419] = 3288,
  [3420] = 3322,
  [3421] = 3178,
  [3422] = 3168,
  [3423] = 3313,
  [3424] = 3300,
  [3425] = 3263,
  [3426] = 3325,
  [3427] = 3319,
  [3428] = 3325,
  [3429] = 3290,
  [3430] = 3263,
  [3431] = 3322,
  [3432] = 3325,
  [3433] = 3292,
  [3434] = 3174,
  [3435] = 3172,
  [3436] = 655,
  [3437] = 3323,
  [3438] = 3312,
  [3439] = 3236,
  [3440] = 3240,
  [3441] = 3326,
  [3442] = 3310,
  [3443] = 3443,
  [3444] = 3307,
  [3445] = 3291,
  [3446] = 3323,
  [3447] = 3177,
  [3448] = 3211,
  [3449] = 3326,
  [3450] = 3290,
  [3451] = 3225,
  [3452] = 3291,
  [3453] = 3179,
  [3454] = 660,
  [3455] = 3307,
  [3456] = 3250,
  [3457] = 3255,
  [3458] = 3308,
  [3459] = 3182,
  [3460] = 3300,
  [3461] = 3319,
  [3462] = 3175,
  [3463] = 3198,
  [3464] = 3226,
  [3465] = 3252,
  [3466] = 3292,
  [3467] = 3254,
  [3468] = 3319,
  [3469] = 3176,
  [3470] = 3290,
  [3471] = 3320,
  [3472] = 3227,
  [3473] = 3300,
  [3474] = 3311,
  [3475] = 3323,
  [3476] = 3312,
  [3477] = 3217,
  [3478] = 3313,
  [3479] = 3308,
  [3480] = 3218,
  [3481] = 3263,
  [3482] = 3199,
  [3483] = 3224,
  [3484] = 3310,
  [3485] = 3320,
  [3486] = 3288,
  [3487] = 3253,
  [3488] = 3193,
  [3489] = 3251,
  [3490] = 3194,
  [3491] = 3443,
  [3492] = 3320,
  [3493] = 3310,
  [3494] = 3312,
  [3495] = 3290,
  [3496] = 3325,
  [3497] = 3307,
  [3498] = 3498,
  [3499] = 3291,
  [3500] = 3311,
  [3501] = 3323,
  [3502] = 3322,
  [3503] = 3443,
  [3504] = 3292,
  [3505] = 3250,
  [3506] = 3326,
  [3507] = 3288,
  [3508] = 3263,
  [3509] = 3443,
  [3510] = 3443,
  [3511] = 3308,
  [3512] = 3313,
  [3513] = 3300,
  [3514] = 3319,
  [3515] = 3322,
  [3516] = 3326,
  [3517] = 3320,
  [3518] = 3313,
  [3519] = 3323,
  [3520] = 3311,
  [3521] = 3288,
  [3522] = 3291,
  [3523] = 3307,
  [3524] = 3292,
  [3525] = 3310,
  [3526] = 3319,
  [3527] = 3300,
  [3528] = 3312,
  [3529] = 3308,
  [3530] = 3325,
  [3531] = 3290,
  [3532] = 3263,
  [3533] = 3533,
  [3534] = 3325,
  [3535] = 3307,
  [3536] = 3536,
  [3537] = 3322,
  [3538] = 3323,
  [3539] = 3326,
  [3540] = 3308,
  [3541] = 3288,
  [3542] = 3310,
  [3543] = 3263,
  [3544] = 3313,
  [3545] = 3312,
  [3546] = 3319,
  [3547] = 3300,
  [3548] = 3548,
  [3549] = 3549,
  [3550] = 3550,
  [3551] = 3551,
  [3552] = 3552,
  [3553] = 3553,
  [3554] = 3554,
  [3555] = 3555,
  [3556] = 3556,
  [3557] = 3557,
  [3558] = 3558,
  [3559] = 3559,
  [3560] = 3560,
  [3561] = 3308,
  [3562] = 3562,
  [3563] = 3312,
  [3564] = 3323,
  [3565] = 3325,
  [3566] = 3308,
  [3567] = 3300,
  [3568] = 3307,
  [3569] = 3319,
  [3570] = 3552,
  [3571] = 3313,
  [3572] = 3263,
  [3573] = 3322,
  [3574] = 3326,
  [3575] = 3288,
  [3576] = 3322,
  [3577] = 3326,
  [3578] = 3578,
  [3579] = 3288,
  [3580] = 3308,
  [3581] = 3263,
  [3582] = 3300,
  [3583] = 3319,
  [3584] = 3313,
  [3585] = 3263,
  [3586] = 3326,
  [3587] = 3288,
  [3588] = 3323,
  [3589] = 3323,
  [3590] = 3590,
  [3591] = 3591,
  [3592] = 3556,
  [3593] = 3322,
  [3594] = 3313,
  [3595] = 3325,
  [3596] = 3312,
  [3597] = 3250,
  [3598] = 3310,
  [3599] = 3590,
  [3600] = 3319,
  [3601] = 3601,
  [3602] = 3300,
  [3603] = 3603,
  [3604] = 3604,
  [3605] = 3310,
  [3606] = 3310,
  [3607] = 3325,
  [3608] = 3307,
  [3609] = 3609,
  [3610] = 3312,
  [3611] = 3307,
  [3612] = 3612,
  [3613] = 3613,
  [3614] = 3614,
  [3615] = 3292,
  [3616] = 3616,
  [3617] = 3326,
  [3618] = 3300,
  [3619] = 3322,
  [3620] = 3620,
  [3621] = 3311,
  [3622] = 3622,
  [3623] = 3325,
  [3624] = 3624,
  [3625] = 3312,
  [3626] = 3290,
  [3627] = 3627,
  [3628] = 3628,
  [3629] = 3629,
  [3630] = 3310,
  [3631] = 3631,
  [3632] = 3627,
  [3633] = 3627,
  [3634] = 3307,
  [3635] = 3308,
  [3636] = 3636,
  [3637] = 3637,
  [3638] = 3614,
  [3639] = 3614,
  [3640] = 3556,
  [3641] = 3614,
  [3642] = 3642,
  [3643] = 3643,
  [3644] = 3644,
  [3645] = 3320,
  [3646] = 3562,
  [3647] = 3319,
  [3648] = 3313,
  [3649] = 3291,
  [3650] = 3650,
  [3651] = 3614,
  [3652] = 3263,
  [3653] = 3653,
  [3654] = 3654,
  [3655] = 3288,
  [3656] = 3323,
  [3657] = 3308,
  [3658] = 3556,
  [3659] = 3300,
  [3660] = 3660,
  [3661] = 3660,
  [3662] = 3660,
  [3663] = 3326,
  [3664] = 3322,
  [3665] = 3665,
  [3666] = 3660,
  [3667] = 3323,
  [3668] = 3310,
  [3669] = 3307,
  [3670] = 3319,
  [3671] = 3312,
  [3672] = 3313,
  [3673] = 3673,
  [3674] = 3673,
  [3675] = 3673,
  [3676] = 3673,
  [3677] = 3673,
  [3678] = 3263,
  [3679] = 3325,
  [3680] = 3288,
  [3681] = 3660,
  [3682] = 3682,
  [3683] = 3683,
  [3684] = 3684,
  [3685] = 3683,
  [3686] = 3682,
  [3687] = 3684,
  [3688] = 3688,
  [3689] = 3688,
  [3690] = 3684,
  [3691] = 3684,
  [3692] = 3683,
  [3693] = 3682,
  [3694] = 3683,
  [3695] = 3682,
  [3696] = 3682,
  [3697] = 3683,
  [3698] = 3688,
  [3699] = 3688,
  [3700] = 3684,
  [3701] = 3688,
  [3702] = 3684,
  [3703] = 3683,
  [3704] = 3688,
  [3705] = 3682,
  [3706] = 3683,
  [3707] = 3684,
  [3708] = 3688,
  [3709] = 3682,
  [3710] = 3710,
  [3711] = 3711,
  [3712] = 3712,
  [3713] = 3713,
  [3714] = 3714,
  [3715] = 3711,
  [3716] = 3716,
  [3717] = 3717,
  [3718] = 3718,
  [3719] = 3719,
  [3720] = 3710,
  [3721] = 3711,
  [3722] = 3722,
  [3723] = 3723,
  [3724] = 3722,
  [3725] = 3725,
  [3726] = 3719,
  [3727] = 3727,
  [3728] = 3714,
  [3729] = 3714,
  [3730] = 3716,
  [3731] = 3716,
  [3732] = 3725,
  [3733] = 3712,
  [3734] = 3723,
  [3735] = 3710,
  [3736] = 3714,
  [3737] = 3713,
  [3738] = 3727,
  [3739] = 3713,
  [3740] = 3712,
  [3741] = 3712,
  [3742] = 3725,
  [3743] = 3727,
  [3744] = 3744,
  [3745] = 3711,
  [3746] = 3727,
  [3747] = 3719,
  [3748] = 3748,
  [3749] = 3718,
  [3750] = 3748,
  [3751] = 3719,
  [3752] = 3722,
  [3753] = 3710,
  [3754] = 3748,
  [3755] = 3723,
  [3756] = 3756,
  [3757] = 3711,
  [3758] = 3717,
  [3759] = 3748,
  [3760] = 3710,
  [3761] = 3725,
  [3762] = 3725,
  [3763] = 3712,
  [3764] = 3716,
  [3765] = 3722,
  [3766] = 3714,
  [3767] = 3713,
  [3768] = 3727,
  [3769] = 3717,
  [3770] = 3756,
  [3771] = 3744,
  [3772] = 3713,
  [3773] = 3719,
  [3774] = 3718,
  [3775] = 3718,
  [3776] = 3719,
  [3777] = 3722,
  [3778] = 3714,
  [3779] = 3723,
  [3780] = 3710,
  [3781] = 3756,
  [3782] = 3744,
  [3783] = 3717,
  [3784] = 3727,
  [3785] = 3722,
  [3786] = 3717,
  [3787] = 3756,
  [3788] = 3744,
  [3789] = 3719,
  [3790] = 3718,
  [3791] = 3722,
  [3792] = 3725,
  [3793] = 3756,
  [3794] = 3744,
  [3795] = 3718,
  [3796] = 3723,
  [3797] = 3748,
  [3798] = 3717,
  [3799] = 3714,
  [3800] = 3713,
  [3801] = 3756,
  [3802] = 3725,
  [3803] = 3710,
  [3804] = 3712,
  [3805] = 3716,
  [3806] = 3727,
  [3807] = 3744,
  [3808] = 3723,
  [3809] = 3748,
  [3810] = 3711,
  [3811] = 3718,
  [3812] = 3711,
  [3813] = 3716,
  [3814] = 3744,
  [3815] = 3756,
  [3816] = 3712,
  [3817] = 3717,
  [3818] = 3748,
  [3819] = 3713,
  [3820] = 3716,
  [3821] = 3723,
  [3822] = 2722,
  [3823] = 2724,
  [3824] = 2716,
  [3825] = 2723,
  [3826] = 2719,
  [3827] = 2710,
  [3828] = 2720,
  [3829] = 3829,
  [3830] = 2670,
  [3831] = 3831,
  [3832] = 3829,
  [3833] = 3831,
  [3834] = 3829,
  [3835] = 3829,
  [3836] = 3831,
  [3837] = 3831,
  [3838] = 3831,
  [3839] = 2672,
  [3840] = 3829,
  [3841] = 3829,
  [3842] = 3829,
  [3843] = 3831,
  [3844] = 3829,
  [3845] = 3829,
  [3846] = 3831,
  [3847] = 3847,
  [3848] = 3831,
  [3849] = 3831,
  [3850] = 3829,
  [3851] = 2673,
  [3852] = 3831,
  [3853] = 3829,
  [3854] = 3829,
  [3855] = 3831,
  [3856] = 3831,
  [3857] = 3831,
  [3858] = 3829,
  [3859] = 629,
  [3860] = 625,
  [3861] = 627,
  [3862] = 618,
  [3863] = 2670,
  [3864] = 621,
  [3865] = 2151,
  [3866] = 611,
  [3867] = 630,
  [3868] = 616,
  [3869] = 623,
  [3870] = 615,
  [3871] = 619,
  [3872] = 2673,
  [3873] = 2160,
  [3874] = 617,
  [3875] = 2153,
  [3876] = 626,
  [3877] = 2147,
  [3878] = 628,
  [3879] = 612,
  [3880] = 2143,
  [3881] = 631,
  [3882] = 2672,
  [3883] = 2670,
  [3884] = 2673,
  [3885] = 2672,
  [3886] = 613,
  [3887] = 2147,
  [3888] = 2672,
  [3889] = 2670,
  [3890] = 3890,
  [3891] = 2148,
  [3892] = 2670,
  [3893] = 2672,
  [3894] = 2673,
  [3895] = 3895,
  [3896] = 2673,
  [3897] = 3897,
  [3898] = 3898,
  [3899] = 3898,
  [3900] = 3900,
  [3901] = 3898,
  [3902] = 3897,
  [3903] = 3898,
  [3904] = 3898,
  [3905] = 3897,
  [3906] = 3897,
  [3907] = 3898,
  [3908] = 3897,
  [3909] = 3897,
  [3910] = 2672,
  [3911] = 2166,
  [3912] = 3898,
  [3913] = 3897,
  [3914] = 3898,
  [3915] = 3898,
  [3916] = 3897,
  [3917] = 3897,
  [3918] = 2147,
  [3919] = 2168,
  [3920] = 2147,
  [3921] = 2167,
  [3922] = 3897,
  [3923] = 3898,
  [3924] = 3898,
  [3925] = 3898,
  [3926] = 2165,
  [3927] = 3897,
  [3928] = 3897,
  [3929] = 3898,
  [3930] = 3897,
  [3931] = 2769,
  [3932] = 2147,
  [3933] = 2795,
  [3934] = 2147,
  [3935] = 2148,
  [3936] = 2803,
  [3937] = 3937,
  [3938] = 2723,
  [3939] = 2710,
  [3940] = 2166,
  [3941] = 2720,
  [3942] = 2722,
  [3943] = 2719,
  [3944] = 2167,
  [3945] = 3945,
  [3946] = 2716,
  [3947] = 2724,
  [3948] = 2165,
  [3949] = 2168,
  [3950] = 3032,
  [3951] = 2968,
  [3952] = 3895,
  [3953] = 3890,
  [3954] = 3954,
  [3955] = 3036,
  [3956] = 3954,
  [3957] = 3954,
  [3958] = 3954,
  [3959] = 3954,
  [3960] = 3954,
  [3961] = 3954,
  [3962] = 3954,
  [3963] = 3954,
  [3964] = 3954,
  [3965] = 3060,
  [3966] = 3045,
  [3967] = 3037,
  [3968] = 3954,
  [3969] = 3954,
  [3970] = 2986,
  [3971] = 2987,
  [3972] = 2966,
  [3973] = 3039,
  [3974] = 3954,
  [3975] = 3062,
  [3976] = 3976,
  [3977] = 3977,
  [3978] = 2795,
  [3979] = 3979,
  [3980] = 2160,
  [3981] = 3981,
  [3982] = 3982,
  [3983] = 2153,
  [3984] = 3984,
  [3985] = 3985,
  [3986] = 3981,
  [3987] = 3984,
  [3988] = 619,
  [3989] = 617,
  [3990] = 623,
  [3991] = 3979,
  [3992] = 616,
  [3993] = 615,
  [3994] = 626,
  [3995] = 611,
  [3996] = 627,
  [3997] = 3976,
  [3998] = 3981,
  [3999] = 3977,
  [4000] = 4000,
  [4001] = 625,
  [4002] = 628,
  [4003] = 629,
  [4004] = 631,
  [4005] = 612,
  [4006] = 630,
  [4007] = 621,
  [4008] = 618,
  [4009] = 3982,
  [4010] = 4010,
  [4011] = 3985,
  [4012] = 3981,
  [4013] = 3979,
  [4014] = 3048,
  [4015] = 3976,
  [4016] = 3977,
  [4017] = 4010,
  [4018] = 4018,
  [4019] = 2151,
  [4020] = 4020,
  [4021] = 3985,
  [4022] = 3982,
  [4023] = 3982,
  [4024] = 4020,
  [4025] = 4018,
  [4026] = 3981,
  [4027] = 3982,
  [4028] = 2769,
  [4029] = 3979,
  [4030] = 3056,
  [4031] = 4010,
  [4032] = 3985,
  [4033] = 3977,
  [4034] = 4018,
  [4035] = 3981,
  [4036] = 4010,
  [4037] = 4018,
  [4038] = 3985,
  [4039] = 2803,
  [4040] = 4020,
  [4041] = 3976,
  [4042] = 3050,
  [4043] = 4018,
  [4044] = 4010,
  [4045] = 4020,
  [4046] = 3984,
  [4047] = 3984,
  [4048] = 2803,
  [4049] = 3984,
  [4050] = 3976,
  [4051] = 3985,
  [4052] = 3984,
  [4053] = 4010,
  [4054] = 3977,
  [4055] = 3976,
  [4056] = 3977,
  [4057] = 3976,
  [4058] = 3984,
  [4059] = 4010,
  [4060] = 3981,
  [4061] = 3982,
  [4062] = 3985,
  [4063] = 3979,
  [4064] = 3977,
  [4065] = 3979,
  [4066] = 2143,
  [4067] = 4018,
  [4068] = 4020,
  [4069] = 4020,
  [4070] = 3982,
  [4071] = 4018,
  [4072] = 4020,
  [4073] = 3979,
  [4074] = 626,
  [4075] = 630,
  [4076] = 2795,
  [4077] = 616,
  [4078] = 4078,
  [4079] = 2769,
  [4080] = 4080,
  [4081] = 619,
  [4082] = 2151,
  [4083] = 2143,
  [4084] = 611,
  [4085] = 2160,
  [4086] = 4086,
  [4087] = 615,
  [4088] = 617,
  [4089] = 4089,
  [4090] = 623,
  [4091] = 618,
  [4092] = 621,
  [4093] = 2153,
  [4094] = 612,
  [4095] = 631,
  [4096] = 4096,
  [4097] = 629,
  [4098] = 628,
  [4099] = 4099,
  [4100] = 625,
  [4101] = 2147,
  [4102] = 627,
  [4103] = 2948,
  [4104] = 4104,
  [4105] = 4105,
  [4106] = 4106,
  [4107] = 4107,
  [4108] = 4108,
  [4109] = 4109,
  [4110] = 4110,
  [4111] = 4110,
  [4112] = 4112,
  [4113] = 4113,
  [4114] = 4113,
  [4115] = 4110,
  [4116] = 4112,
  [4117] = 4117,
  [4118] = 4118,
  [4119] = 4104,
  [4120] = 4120,
  [4121] = 4121,
  [4122] = 4109,
  [4123] = 4121,
  [4124] = 4124,
  [4125] = 4125,
  [4126] = 4113,
  [4127] = 4127,
  [4128] = 4117,
  [4129] = 4125,
  [4130] = 4130,
  [4131] = 4105,
  [4132] = 4113,
  [4133] = 4120,
  [4134] = 4124,
  [4135] = 4105,
  [4136] = 4120,
  [4137] = 4113,
  [4138] = 4125,
  [4139] = 4130,
  [4140] = 4110,
  [4141] = 4109,
  [4142] = 4109,
  [4143] = 4118,
  [4144] = 4105,
  [4145] = 4124,
  [4146] = 4121,
  [4147] = 4124,
  [4148] = 4105,
  [4149] = 4104,
  [4150] = 4120,
  [4151] = 4125,
  [4152] = 4118,
  [4153] = 4124,
  [4154] = 4106,
  [4155] = 4124,
  [4156] = 2803,
  [4157] = 4108,
  [4158] = 4118,
  [4159] = 4117,
  [4160] = 4125,
  [4161] = 4127,
  [4162] = 4107,
  [4163] = 4108,
  [4164] = 4104,
  [4165] = 2795,
  [4166] = 4130,
  [4167] = 4118,
  [4168] = 4108,
  [4169] = 2769,
  [4170] = 4120,
  [4171] = 4117,
  [4172] = 4112,
  [4173] = 4107,
  [4174] = 4121,
  [4175] = 4117,
  [4176] = 4112,
  [4177] = 4127,
  [4178] = 4127,
  [4179] = 4117,
  [4180] = 4120,
  [4181] = 4117,
  [4182] = 4121,
  [4183] = 4106,
  [4184] = 4105,
  [4185] = 4106,
  [4186] = 4107,
  [4187] = 4110,
  [4188] = 4120,
  [4189] = 4108,
  [4190] = 4108,
  [4191] = 4112,
  [4192] = 4104,
  [4193] = 4109,
  [4194] = 4108,
  [4195] = 4124,
  [4196] = 4107,
  [4197] = 4105,
  [4198] = 4127,
  [4199] = 4106,
  [4200] = 2937,
  [4201] = 4201,
  [4202] = 4202,
  [4203] = 4203,
  [4204] = 2947,
  [4205] = 4202,
  [4206] = 4202,
  [4207] = 2948,
  [4208] = 4208,
  [4209] = 4209,
  [4210] = 4210,
  [4211] = 4211,
  [4212] = 4212,
  [4213] = 4202,
  [4214] = 4214,
  [4215] = 4202,
  [4216] = 4216,
  [4217] = 2946,
  [4218] = 2148,
  [4219] = 4219,
  [4220] = 4202,
  [4221] = 4221,
  [4222] = 2942,
  [4223] = 2945,
  [4224] = 4202,
  [4225] = 4225,
  [4226] = 4226,
  [4227] = 4227,
  [4228] = 4226,
  [4229] = 2710,
  [4230] = 4226,
  [4231] = 2722,
  [4232] = 4232,
  [4233] = 2724,
  [4234] = 4226,
  [4235] = 3024,
  [4236] = 2165,
  [4237] = 3047,
  [4238] = 4232,
  [4239] = 2167,
  [4240] = 2948,
  [4241] = 4226,
  [4242] = 3065,
  [4243] = 4232,
  [4244] = 4225,
  [4245] = 2166,
  [4246] = 4232,
  [4247] = 2168,
  [4248] = 4226,
  [4249] = 4226,
  [4250] = 2723,
  [4251] = 2720,
  [4252] = 2719,
  [4253] = 4253,
  [4254] = 2946,
  [4255] = 4253,
  [4256] = 2942,
  [4257] = 2947,
  [4258] = 4258,
  [4259] = 3047,
  [4260] = 4253,
  [4261] = 2937,
  [4262] = 3024,
  [4263] = 3065,
  [4264] = 2945,
  [4265] = 4265,
  [4266] = 4253,
  [4267] = 4267,
  [4268] = 4253,
  [4269] = 4269,
  [4270] = 2945,
  [4271] = 4269,
  [4272] = 4272,
  [4273] = 2968,
  [4274] = 3047,
  [4275] = 3024,
  [4276] = 4276,
  [4277] = 2937,
  [4278] = 4278,
  [4279] = 3062,
  [4280] = 4280,
  [4281] = 2947,
  [4282] = 3065,
  [4283] = 2942,
  [4284] = 2948,
  [4285] = 4276,
  [4286] = 2948,
  [4287] = 4287,
  [4288] = 2946,
  [4289] = 4289,
  [4290] = 2947,
  [4291] = 2946,
  [4292] = 4289,
  [4293] = 2937,
  [4294] = 4289,
  [4295] = 4289,
  [4296] = 2946,
  [4297] = 2945,
  [4298] = 4298,
  [4299] = 2947,
  [4300] = 4289,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 2937,
  [4304] = 2942,
  [4305] = 2945,
  [4306] = 2942,
  [4307] = 1448,
  [4308] = 4308,
  [4309] = 4309,
  [4310] = 4310,
  [4311] = 4311,
  [4312] = 3047,
  [4313] = 1385,
  [4314] = 4308,
  [4315] = 4315,
  [4316] = 4316,
  [4317] = 3024,
  [4318] = 3065,
  [4319] = 4319,
  [4320] = 4315,
  [4321] = 4310,
  [4322] = 4322,
  [4323] = 4309,
  [4324] = 4324,
  [4325] = 4316,
  [4326] = 660,
  [4327] = 4309,
  [4328] = 4309,
  [4329] = 4310,
  [4330] = 4310,
  [4331] = 1447,
  [4332] = 4315,
  [4333] = 4310,
  [4334] = 4334,
  [4335] = 4308,
  [4336] = 4315,
  [4337] = 4309,
  [4338] = 1443,
  [4339] = 4310,
  [4340] = 4315,
  [4341] = 4316,
  [4342] = 2968,
  [4343] = 4309,
  [4344] = 3062,
  [4345] = 4315,
  [4346] = 1499,
  [4347] = 4347,
  [4348] = 3024,
  [4349] = 4347,
  [4350] = 4316,
  [4351] = 4308,
  [4352] = 4309,
  [4353] = 4353,
  [4354] = 4315,
  [4355] = 4310,
  [4356] = 4310,
  [4357] = 3065,
  [4358] = 4315,
  [4359] = 4309,
  [4360] = 4347,
  [4361] = 4316,
  [4362] = 3047,
  [4363] = 4309,
  [4364] = 4315,
  [4365] = 4365,
  [4366] = 4366,
  [4367] = 4310,
  [4368] = 4308,
  [4369] = 655,
  [4370] = 658,
  [4371] = 4371,
  [4372] = 4372,
  [4373] = 4373,
  [4374] = 4374,
  [4375] = 4372,
  [4376] = 4376,
  [4377] = 2966,
  [4378] = 4376,
  [4379] = 4379,
  [4380] = 3048,
  [4381] = 3045,
  [4382] = 4373,
  [4383] = 4372,
  [4384] = 4372,
  [4385] = 4372,
  [4386] = 4371,
  [4387] = 3037,
  [4388] = 4372,
  [4389] = 3036,
  [4390] = 2987,
  [4391] = 3032,
  [4392] = 2986,
  [4393] = 4371,
  [4394] = 3056,
  [4395] = 4371,
  [4396] = 4376,
  [4397] = 4376,
  [4398] = 4373,
  [4399] = 4372,
  [4400] = 4373,
  [4401] = 3039,
  [4402] = 3050,
  [4403] = 4372,
  [4404] = 3060,
  [4405] = 4372,
  [4406] = 4372,
  [4407] = 4376,
  [4408] = 1271,
  [4409] = 4409,
  [4410] = 4410,
  [4411] = 4410,
  [4412] = 4412,
  [4413] = 4413,
  [4414] = 4410,
  [4415] = 4415,
  [4416] = 1270,
  [4417] = 4410,
  [4418] = 1270,
  [4419] = 4419,
  [4420] = 4409,
  [4421] = 4413,
  [4422] = 1271,
  [4423] = 4410,
  [4424] = 4276,
  [4425] = 4410,
  [4426] = 4413,
  [4427] = 4427,
  [4428] = 4409,
  [4429] = 4409,
  [4430] = 4409,
  [4431] = 4409,
  [4432] = 4432,
  [4433] = 4432,
  [4434] = 4434,
  [4435] = 4409,
  [4436] = 4409,
  [4437] = 4437,
  [4438] = 4434,
  [4439] = 4410,
  [4440] = 4432,
  [4441] = 4432,
  [4442] = 4410,
  [4443] = 4432,
  [4444] = 4410,
  [4445] = 4413,
  [4446] = 4409,
  [4447] = 4410,
  [4448] = 4409,
  [4449] = 4432,
  [4450] = 4450,
  [4451] = 4434,
  [4452] = 4413,
  [4453] = 4410,
  [4454] = 4434,
  [4455] = 4409,
  [4456] = 4434,
  [4457] = 4457,
  [4458] = 4410,
  [4459] = 4410,
  [4460] = 4409,
  [4461] = 4269,
  [4462] = 4409,
  [4463] = 4432,
  [4464] = 4464,
  [4465] = 4465,
  [4466] = 4466,
  [4467] = 4467,
  [4468] = 4468,
  [4469] = 4469,
  [4470] = 4470,
  [4471] = 4471,
  [4472] = 4472,
  [4473] = 4276,
  [4474] = 4474,
  [4475] = 4475,
  [4476] = 4476,
  [4477] = 4465,
  [4478] = 4469,
  [4479] = 4479,
  [4480] = 4472,
  [4481] = 4481,
  [4482] = 4475,
  [4483] = 4476,
  [4484] = 4466,
  [4485] = 4481,
  [4486] = 4486,
  [4487] = 4464,
  [4488] = 4488,
  [4489] = 4489,
  [4490] = 4490,
  [4491] = 4466,
  [4492] = 4492,
  [4493] = 4493,
  [4494] = 4465,
  [4495] = 4495,
  [4496] = 4481,
  [4497] = 4481,
  [4498] = 4498,
  [4499] = 4499,
  [4500] = 4468,
  [4501] = 4479,
  [4502] = 4479,
  [4503] = 4469,
  [4504] = 4465,
  [4505] = 4505,
  [4506] = 4495,
  [4507] = 4469,
  [4508] = 4465,
  [4509] = 4468,
  [4510] = 4495,
  [4511] = 4490,
  [4512] = 4470,
  [4513] = 4490,
  [4514] = 4488,
  [4515] = 4468,
  [4516] = 4469,
  [4517] = 4517,
  [4518] = 4479,
  [4519] = 4481,
  [4520] = 4520,
  [4521] = 4488,
  [4522] = 4489,
  [4523] = 4476,
  [4524] = 4475,
  [4525] = 4466,
  [4526] = 4470,
  [4527] = 4269,
  [4528] = 4528,
  [4529] = 4472,
  [4530] = 4495,
  [4531] = 4470,
  [4532] = 1274,
  [4533] = 4489,
  [4534] = 4476,
  [4535] = 1270,
  [4536] = 1271,
  [4537] = 4470,
  [4538] = 4495,
  [4539] = 4539,
  [4540] = 4488,
  [4541] = 4468,
  [4542] = 4489,
  [4543] = 4489,
  [4544] = 4490,
  [4545] = 4488,
  [4546] = 4546,
  [4547] = 4490,
  [4548] = 4548,
  [4549] = 4475,
  [4550] = 4550,
  [4551] = 1270,
  [4552] = 4464,
  [4553] = 4472,
  [4554] = 4479,
  [4555] = 1271,
  [4556] = 4464,
  [4557] = 4557,
  [4558] = 4558,
  [4559] = 4476,
  [4560] = 4475,
  [4561] = 4472,
  [4562] = 4562,
  [4563] = 4466,
  [4564] = 4564,
  [4565] = 4464,
  [4566] = 4566,
  [4567] = 4567,
  [4568] = 4567,
  [4569] = 4569,
  [4570] = 4570,
  [4571] = 4570,
  [4572] = 4569,
  [4573] = 613,
  [4574] = 4574,
  [4575] = 4575,
  [4576] = 4566,
  [4577] = 4566,
  [4578] = 4578,
  [4579] = 4567,
  [4580] = 4580,
  [4581] = 4581,
  [4582] = 4580,
  [4583] = 4570,
  [4584] = 4569,
  [4585] = 4567,
  [4586] = 4566,
  [4587] = 4587,
  [4588] = 4580,
  [4589] = 4589,
  [4590] = 4590,
  [4591] = 4569,
  [4592] = 4566,
  [4593] = 4574,
  [4594] = 4574,
  [4595] = 4567,
  [4596] = 4580,
  [4597] = 4597,
  [4598] = 4570,
  [4599] = 4580,
  [4600] = 4600,
  [4601] = 4601,
  [4602] = 4574,
  [4603] = 4574,
  [4604] = 4604,
  [4605] = 4605,
  [4606] = 4569,
  [4607] = 4570,
  [4608] = 1274,
  [4609] = 4581,
  [4610] = 4610,
  [4611] = 1413,
  [4612] = 1411,
  [4613] = 1410,
  [4614] = 1407,
  [4615] = 4615,
  [4616] = 4616,
  [4617] = 1399,
  [4618] = 1398,
  [4619] = 1395,
  [4620] = 1394,
  [4621] = 1375,
  [4622] = 4622,
  [4623] = 1362,
  [4624] = 1387,
  [4625] = 1361,
  [4626] = 4626,
  [4627] = 4622,
  [4628] = 1400,
  [4629] = 4629,
  [4630] = 4630,
  [4631] = 4631,
  [4632] = 4632,
  [4633] = 4633,
  [4634] = 1435,
  [4635] = 4635,
  [4636] = 1352,
  [4637] = 4637,
  [4638] = 1348,
  [4639] = 1336,
  [4640] = 4640,
  [4641] = 4641,
  [4642] = 1414,
  [4643] = 1449,
  [4644] = 4641,
  [4645] = 4645,
  [4646] = 1416,
  [4647] = 1451,
  [4648] = 4631,
  [4649] = 1465,
  [4650] = 1466,
  [4651] = 1485,
  [4652] = 1417,
  [4653] = 1418,
  [4654] = 4632,
  [4655] = 4655,
  [4656] = 4632,
  [4657] = 4657,
  [4658] = 4658,
  [4659] = 4659,
  [4660] = 4660,
  [4661] = 1409,
  [4662] = 4662,
  [4663] = 1343,
  [4664] = 4631,
  [4665] = 1419,
  [4666] = 1333,
  [4667] = 1345,
  [4668] = 4637,
  [4669] = 4635,
  [4670] = 4670,
  [4671] = 1347,
  [4672] = 1350,
  [4673] = 1351,
  [4674] = 4645,
  [4675] = 4641,
  [4676] = 1442,
  [4677] = 1505,
  [4678] = 1503,
  [4679] = 1502,
  [4680] = 4680,
  [4681] = 1501,
  [4682] = 1424,
  [4683] = 1497,
  [4684] = 1496,
  [4685] = 1425,
  [4686] = 1495,
  [4687] = 4687,
  [4688] = 1492,
  [4689] = 4689,
  [4690] = 1429,
  [4691] = 4691,
  [4692] = 1491,
  [4693] = 1349,
  [4694] = 4631,
  [4695] = 1360,
  [4696] = 4637,
  [4697] = 4697,
  [4698] = 4635,
  [4699] = 4699,
  [4700] = 4637,
  [4701] = 1460,
  [4702] = 4702,
  [4703] = 1426,
  [4704] = 4635,
  [4705] = 4632,
  [4706] = 4637,
  [4707] = 1494,
  [4708] = 4708,
  [4709] = 4615,
  [4710] = 1346,
  [4711] = 4645,
  [4712] = 4712,
  [4713] = 4657,
  [4714] = 4645,
  [4715] = 4715,
  [4716] = 4645,
  [4717] = 4717,
  [4718] = 4622,
  [4719] = 4719,
  [4720] = 1427,
  [4721] = 1440,
  [4722] = 1427,
  [4723] = 4632,
  [4724] = 4724,
  [4725] = 4615,
  [4726] = 4641,
  [4727] = 4637,
  [4728] = 1426,
  [4729] = 1469,
  [4730] = 4730,
  [4731] = 1371,
  [4732] = 1346,
  [4733] = 4641,
  [4734] = 4637,
  [4735] = 4631,
  [4736] = 4635,
  [4737] = 4737,
  [4738] = 4738,
  [4739] = 4739,
  [4740] = 4740,
  [4741] = 4741,
  [4742] = 4742,
  [4743] = 4743,
  [4744] = 4744,
  [4745] = 4745,
  [4746] = 4746,
  [4747] = 4747,
  [4748] = 4748,
  [4749] = 4749,
  [4750] = 4750,
  [4751] = 4751,
  [4752] = 4752,
  [4753] = 4753,
  [4754] = 4754,
  [4755] = 4755,
  [4756] = 4756,
  [4757] = 4757,
  [4758] = 4758,
  [4759] = 4759,
  [4760] = 4760,
  [4761] = 4761,
  [4762] = 4762,
  [4763] = 4763,
  [4764] = 4764,
  [4765] = 4765,
  [4766] = 4766,
  [4767] = 4740,
  [4768] = 4768,
  [4769] = 4761,
  [4770] = 4770,
  [4771] = 4771,
  [4772] = 4772,
  [4773] = 4757,
  [4774] = 4754,
  [4775] = 4753,
  [4776] = 4776,
  [4777] = 4759,
  [4778] = 4758,
  [4779] = 4779,
  [4780] = 4746,
  [4781] = 4751,
  [4782] = 4740,
  [4783] = 4783,
  [4784] = 4784,
  [4785] = 4785,
  [4786] = 4751,
  [4787] = 4787,
  [4788] = 4788,
  [4789] = 4789,
  [4790] = 4790,
  [4791] = 4742,
  [4792] = 4792,
  [4793] = 4743,
  [4794] = 4744,
  [4795] = 4795,
  [4796] = 4745,
  [4797] = 4759,
  [4798] = 4798,
  [4799] = 4799,
  [4800] = 4739,
  [4801] = 4801,
  [4802] = 4776,
  [4803] = 4803,
  [4804] = 4804,
  [4805] = 4741,
  [4806] = 4790,
  [4807] = 4807,
  [4808] = 4808,
  [4809] = 4809,
  [4810] = 4810,
  [4811] = 4788,
  [4812] = 4812,
  [4813] = 4813,
  [4814] = 4746,
  [4815] = 4815,
  [4816] = 4816,
  [4817] = 4817,
  [4818] = 4818,
  [4819] = 4819,
  [4820] = 4779,
  [4821] = 4808,
  [4822] = 4804,
  [4823] = 4823,
  [4824] = 4824,
  [4825] = 4825,
  [4826] = 4826,
  [4827] = 4750,
  [4828] = 4828,
  [4829] = 4829,
  [4830] = 4830,
  [4831] = 4801,
  [4832] = 4832,
  [4833] = 4833,
  [4834] = 4834,
  [4835] = 4835,
  [4836] = 4813,
  [4837] = 4837,
  [4838] = 4838,
  [4839] = 4839,
  [4840] = 4807,
  [4841] = 4841,
  [4842] = 4842,
  [4843] = 4843,
  [4844] = 4844,
  [4845] = 4804,
  [4846] = 4807,
  [4847] = 4739,
  [4848] = 4848,
  [4849] = 4808,
  [4850] = 4823,
  [4851] = 4851,
  [4852] = 4809,
  [4853] = 4787,
  [4854] = 4854,
  [4855] = 4810,
  [4856] = 4813,
  [4857] = 4857,
  [4858] = 4758,
  [4859] = 4759,
  [4860] = 4761,
  [4861] = 4861,
  [4862] = 4789,
  [4863] = 4863,
  [4864] = 4864,
  [4865] = 4787,
  [4866] = 4752,
  [4867] = 4864,
  [4868] = 4863,
  [4869] = 4764,
  [4870] = 4801,
  [4871] = 4803,
  [4872] = 4757,
  [4873] = 4753,
  [4874] = 4874,
  [4875] = 4801,
  [4876] = 4746,
  [4877] = 4808,
  [4878] = 4754,
  [4879] = 4789,
  [4880] = 4861,
  [4881] = 4881,
  [4882] = 4742,
  [4883] = 4815,
  [4884] = 4816,
  [4885] = 4764,
  [4886] = 4743,
  [4887] = 4744,
  [4888] = 4745,
  [4889] = 4757,
  [4890] = 4746,
  [4891] = 4801,
  [4892] = 4892,
  [4893] = 4750,
  [4894] = 4752,
  [4895] = 4753,
  [4896] = 4754,
  [4897] = 4739,
  [4898] = 4804,
  [4899] = 4818,
  [4900] = 4757,
  [4901] = 4762,
  [4902] = 4857,
  [4903] = 4788,
  [4904] = 4808,
  [4905] = 4763,
  [4906] = 4835,
  [4907] = 4817,
  [4908] = 4751,
  [4909] = 4909,
  [4910] = 4765,
  [4911] = 4766,
  [4912] = 4823,
  [4913] = 4630,
  [4914] = 4761,
  [4915] = 4784,
  [4916] = 4770,
  [4917] = 4771,
  [4918] = 4776,
  [4919] = 4919,
  [4920] = 4759,
  [4921] = 4758,
  [4922] = 4764,
  [4923] = 4739,
  [4924] = 4798,
  [4925] = 4844,
  [4926] = 4843,
  [4927] = 4842,
  [4928] = 4838,
  [4929] = 4837,
  [4930] = 4834,
  [4931] = 4833,
  [4932] = 4932,
  [4933] = 4832,
  [4934] = 4759,
  [4935] = 4787,
  [4936] = 4936,
  [4937] = 4864,
  [4938] = 4799,
  [4939] = 4740,
  [4940] = 4830,
  [4941] = 4804,
  [4942] = 4779,
  [4943] = 4757,
  [4944] = 4779,
  [4945] = 4808,
  [4946] = 4746,
  [4947] = 4829,
  [4948] = 4828,
  [4949] = 4788,
  [4950] = 4801,
  [4951] = 4832,
  [4952] = 4748,
  [4953] = 4762,
  [4954] = 4863,
  [4955] = 4790,
  [4956] = 4748,
  [4957] = 4784,
  [4958] = 4817,
  [4959] = 4835,
  [4960] = 4816,
  [4961] = 4788,
  [4962] = 4815,
  [4963] = 4963,
  [4964] = 4784,
  [4965] = 4739,
  [4966] = 4966,
  [4967] = 4804,
  [4968] = 4808,
  [4969] = 4969,
  [4970] = 4763,
  [4971] = 4844,
  [4972] = 4740,
  [4973] = 4973,
  [4974] = 4801,
  [4975] = 4740,
  [4976] = 4815,
  [4977] = 4816,
  [4978] = 4801,
  [4979] = 4979,
  [4980] = 4819,
  [4981] = 4981,
  [4982] = 4817,
  [4983] = 4798,
  [4984] = 4764,
  [4985] = 4784,
  [4986] = 4835,
  [4987] = 4987,
  [4988] = 4801,
  [4989] = 4989,
  [4990] = 4799,
  [4991] = 4765,
  [4992] = 4799,
  [4993] = 4993,
  [4994] = 4789,
  [4995] = 4803,
  [4996] = 4741,
  [4997] = 4766,
  [4998] = 4790,
  [4999] = 4759,
  [5000] = 4807,
  [5001] = 4779,
  [5002] = 4809,
  [5003] = 4810,
  [5004] = 4712,
  [5005] = 4813,
  [5006] = 4861,
  [5007] = 5007,
  [5008] = 4854,
  [5009] = 4746,
  [5010] = 4616,
  [5011] = 4798,
  [5012] = 4857,
  [5013] = 5013,
  [5014] = 4828,
  [5015] = 4815,
  [5016] = 4816,
  [5017] = 4817,
  [5018] = 4829,
  [5019] = 5019,
  [5020] = 4830,
  [5021] = 4761,
  [5022] = 4819,
  [5023] = 4779,
  [5024] = 4807,
  [5025] = 4818,
  [5026] = 4809,
  [5027] = 4739,
  [5028] = 4751,
  [5029] = 4810,
  [5030] = 4843,
  [5031] = 5031,
  [5032] = 4842,
  [5033] = 4838,
  [5034] = 4813,
  [5035] = 4826,
  [5036] = 5036,
  [5037] = 5037,
  [5038] = 5038,
  [5039] = 4828,
  [5040] = 4801,
  [5041] = 4788,
  [5042] = 4829,
  [5043] = 4830,
  [5044] = 4807,
  [5045] = 4809,
  [5046] = 4810,
  [5047] = 4813,
  [5048] = 4837,
  [5049] = 4697,
  [5050] = 4798,
  [5051] = 5051,
  [5052] = 4807,
  [5053] = 5053,
  [5054] = 4826,
  [5055] = 4809,
  [5056] = 5056,
  [5057] = 4810,
  [5058] = 4813,
  [5059] = 4640,
  [5060] = 4832,
  [5061] = 4759,
  [5062] = 4833,
  [5063] = 4834,
  [5064] = 4837,
  [5065] = 4838,
  [5066] = 4842,
  [5067] = 4843,
  [5068] = 4807,
  [5069] = 5069,
  [5070] = 4844,
  [5071] = 5071,
  [5072] = 4809,
  [5073] = 4810,
  [5074] = 4813,
  [5075] = 4739,
  [5076] = 4823,
  [5077] = 4801,
  [5078] = 4807,
  [5079] = 5079,
  [5080] = 4779,
  [5081] = 4833,
  [5082] = 4834,
  [5083] = 5083,
  [5084] = 4837,
  [5085] = 4758,
  [5086] = 4838,
  [5087] = 4842,
  [5088] = 4843,
  [5089] = 4759,
  [5090] = 5090,
  [5091] = 4828,
  [5092] = 4776,
  [5093] = 5093,
  [5094] = 4844,
  [5095] = 5095,
  [5096] = 4807,
  [5097] = 4854,
  [5098] = 4809,
  [5099] = 4810,
  [5100] = 4813,
  [5101] = 4771,
  [5102] = 4770,
  [5103] = 4809,
  [5104] = 5104,
  [5105] = 5105,
  [5106] = 4810,
  [5107] = 4857,
  [5108] = 4740,
  [5109] = 4861,
  [5110] = 4789,
  [5111] = 4761,
  [5112] = 4829,
  [5113] = 4759,
  [5114] = 4739,
  [5115] = 4834,
  [5116] = 4830,
  [5117] = 4810,
  [5118] = 4863,
  [5119] = 4813,
  [5120] = 4864,
  [5121] = 4804,
  [5122] = 4833,
  [5123] = 4787,
  [5124] = 4789,
  [5125] = 4807,
  [5126] = 4787,
  [5127] = 4835,
  [5128] = 5128,
  [5129] = 4809,
  [5130] = 4810,
  [5131] = 4813,
  [5132] = 4766,
  [5133] = 5133,
  [5134] = 4807,
  [5135] = 4823,
  [5136] = 4765,
  [5137] = 4809,
  [5138] = 4748,
  [5139] = 4759,
  [5140] = 5140,
  [5141] = 4810,
  [5142] = 4813,
  [5143] = 4804,
  [5144] = 4808,
  [5145] = 4809,
  [5146] = 4770,
  [5147] = 4771,
  [5148] = 4763,
  [5149] = 5149,
  [5150] = 4742,
  [5151] = 4743,
  [5152] = 4744,
  [5153] = 4745,
  [5154] = 4776,
  [5155] = 4762,
  [5156] = 4790,
  [5157] = 4757,
  [5158] = 4759,
  [5159] = 4746,
  [5160] = 4788,
  [5161] = 4750,
  [5162] = 4754,
  [5163] = 4752,
  [5164] = 4753,
  [5165] = 4754,
  [5166] = 4753,
  [5167] = 4759,
  [5168] = 4758,
  [5169] = 4751,
  [5170] = 4757,
  [5171] = 4752,
  [5172] = 5172,
  [5173] = 4750,
  [5174] = 4762,
  [5175] = 4788,
  [5176] = 4763,
  [5177] = 4801,
  [5178] = 4857,
  [5179] = 4761,
  [5180] = 4861,
  [5181] = 4765,
  [5182] = 4789,
  [5183] = 4766,
  [5184] = 4758,
  [5185] = 4761,
  [5186] = 4746,
  [5187] = 4751,
  [5188] = 5188,
  [5189] = 4770,
  [5190] = 4771,
  [5191] = 4776,
  [5192] = 4759,
  [5193] = 4758,
  [5194] = 4745,
  [5195] = 4759,
  [5196] = 4744,
  [5197] = 4832,
  [5198] = 4779,
  [5199] = 4863,
  [5200] = 4764,
  [5201] = 4743,
  [5202] = 4864,
  [5203] = 4787,
  [5204] = 4742,
  [5205] = 4799,
  [5206] = 5206,
  [5207] = 5207,
  [5208] = 1427,
  [5209] = 5209,
  [5210] = 5210,
  [5211] = 5211,
  [5212] = 5212,
  [5213] = 5213,
  [5214] = 5214,
  [5215] = 5207,
  [5216] = 5216,
  [5217] = 5217,
  [5218] = 5218,
  [5219] = 5219,
  [5220] = 5220,
  [5221] = 5221,
  [5222] = 5222,
  [5223] = 5223,
  [5224] = 5224,
  [5225] = 5225,
  [5226] = 5226,
  [5227] = 5223,
  [5228] = 5228,
  [5229] = 5229,
  [5230] = 5230,
  [5231] = 5231,
  [5232] = 5211,
  [5233] = 5233,
  [5234] = 5234,
  [5235] = 5235,
  [5236] = 5236,
  [5237] = 5218,
  [5238] = 5238,
  [5239] = 5239,
  [5240] = 5240,
  [5241] = 5241,
  [5242] = 5242,
  [5243] = 5239,
  [5244] = 5244,
  [5245] = 5245,
  [5246] = 5246,
  [5247] = 5209,
  [5248] = 5248,
  [5249] = 5222,
  [5250] = 5250,
  [5251] = 5211,
  [5252] = 5252,
  [5253] = 5253,
  [5254] = 5225,
  [5255] = 3211,
  [5256] = 5256,
  [5257] = 5225,
  [5258] = 5226,
  [5259] = 5259,
  [5260] = 5212,
  [5261] = 5261,
  [5262] = 5262,
  [5263] = 5263,
  [5264] = 5238,
  [5265] = 5242,
  [5266] = 5266,
  [5267] = 5244,
  [5268] = 3193,
  [5269] = 5269,
  [5270] = 5270,
  [5271] = 5241,
  [5272] = 5272,
  [5273] = 5229,
  [5274] = 5210,
  [5275] = 5275,
  [5276] = 5276,
  [5277] = 5261,
  [5278] = 5278,
  [5279] = 5229,
  [5280] = 5280,
  [5281] = 5281,
  [5282] = 5282,
  [5283] = 5283,
  [5284] = 5284,
  [5285] = 5285,
  [5286] = 5286,
  [5287] = 5229,
  [5288] = 5216,
  [5289] = 5289,
  [5290] = 5290,
  [5291] = 5291,
  [5292] = 5212,
  [5293] = 5213,
  [5294] = 3224,
  [5295] = 5229,
  [5296] = 5296,
  [5297] = 1346,
  [5298] = 3233,
  [5299] = 5209,
  [5300] = 5300,
  [5301] = 1426,
  [5302] = 1427,
  [5303] = 3172,
  [5304] = 3174,
  [5305] = 5223,
  [5306] = 5306,
  [5307] = 5211,
  [5308] = 5308,
  [5309] = 5261,
  [5310] = 5229,
  [5311] = 5212,
  [5312] = 5213,
  [5313] = 3182,
  [5314] = 5207,
  [5315] = 5250,
  [5316] = 5316,
  [5317] = 5283,
  [5318] = 5217,
  [5319] = 5218,
  [5320] = 5308,
  [5321] = 5280,
  [5322] = 5261,
  [5323] = 5316,
  [5324] = 5219,
  [5325] = 5229,
  [5326] = 5326,
  [5327] = 5248,
  [5328] = 5214,
  [5329] = 5224,
  [5330] = 5226,
  [5331] = 5240,
  [5332] = 5228,
  [5333] = 5230,
  [5334] = 5308,
  [5335] = 5233,
  [5336] = 5280,
  [5337] = 5261,
  [5338] = 5229,
  [5339] = 5234,
  [5340] = 5340,
  [5341] = 5207,
  [5342] = 3240,
  [5343] = 5235,
  [5344] = 5236,
  [5345] = 5240,
  [5346] = 5296,
  [5347] = 5347,
  [5348] = 5269,
  [5349] = 5291,
  [5350] = 5214,
  [5351] = 5308,
  [5352] = 5352,
  [5353] = 5239,
  [5354] = 5354,
  [5355] = 5207,
  [5356] = 5356,
  [5357] = 5280,
  [5358] = 5358,
  [5359] = 5286,
  [5360] = 5261,
  [5361] = 5361,
  [5362] = 5229,
  [5363] = 5225,
  [5364] = 5217,
  [5365] = 5270,
  [5366] = 5225,
  [5367] = 5290,
  [5368] = 5368,
  [5369] = 5250,
  [5370] = 5218,
  [5371] = 5358,
  [5372] = 5270,
  [5373] = 5252,
  [5374] = 5253,
  [5375] = 1371,
  [5376] = 5256,
  [5377] = 5259,
  [5378] = 5219,
  [5379] = 5379,
  [5380] = 5262,
  [5381] = 5266,
  [5382] = 5296,
  [5383] = 5236,
  [5384] = 5384,
  [5385] = 5308,
  [5386] = 5386,
  [5387] = 1426,
  [5388] = 5269,
  [5389] = 1469,
  [5390] = 1346,
  [5391] = 5391,
  [5392] = 5392,
  [5393] = 5393,
  [5394] = 5326,
  [5395] = 5206,
  [5396] = 5270,
  [5397] = 5397,
  [5398] = 5272,
  [5399] = 5207,
  [5400] = 1440,
  [5401] = 5401,
  [5402] = 5280,
  [5403] = 5261,
  [5404] = 5222,
  [5405] = 5229,
  [5406] = 5286,
  [5407] = 5275,
  [5408] = 5289,
  [5409] = 5409,
  [5410] = 5410,
  [5411] = 5290,
  [5412] = 5286,
  [5413] = 5269,
  [5414] = 5213,
  [5415] = 5212,
  [5416] = 5296,
  [5417] = 5226,
  [5418] = 5290,
  [5419] = 5286,
  [5420] = 5290,
  [5421] = 5421,
  [5422] = 5269,
  [5423] = 5296,
  [5424] = 5226,
  [5425] = 5425,
  [5426] = 5426,
  [5427] = 5290,
  [5428] = 5286,
  [5429] = 5269,
  [5430] = 5296,
  [5431] = 5431,
  [5432] = 5252,
  [5433] = 5209,
  [5434] = 5226,
  [5435] = 5225,
  [5436] = 5290,
  [5437] = 5286,
  [5438] = 5438,
  [5439] = 5439,
  [5440] = 5269,
  [5441] = 5245,
  [5442] = 5296,
  [5443] = 5220,
  [5444] = 5444,
  [5445] = 5226,
  [5446] = 5270,
  [5447] = 5225,
  [5448] = 5290,
  [5449] = 5449,
  [5450] = 5259,
  [5451] = 5290,
  [5452] = 5452,
  [5453] = 5286,
  [5454] = 5454,
  [5455] = 5269,
  [5456] = 5456,
  [5457] = 5296,
  [5458] = 5458,
  [5459] = 5235,
  [5460] = 5460,
  [5461] = 5223,
  [5462] = 5223,
  [5463] = 5316,
  [5464] = 5219,
  [5465] = 5289,
  [5466] = 5211,
  [5467] = 5467,
  [5468] = 5228,
  [5469] = 5236,
  [5470] = 5226,
  [5471] = 5225,
  [5472] = 5212,
  [5473] = 5213,
  [5474] = 5214,
  [5475] = 5248,
  [5476] = 5224,
  [5477] = 5207,
  [5478] = 5290,
  [5479] = 5286,
  [5480] = 5480,
  [5481] = 5358,
  [5482] = 5225,
  [5483] = 5269,
  [5484] = 5308,
  [5485] = 5218,
  [5486] = 5296,
  [5487] = 5218,
  [5488] = 5226,
  [5489] = 5207,
  [5490] = 5253,
  [5491] = 5219,
  [5492] = 5242,
  [5493] = 5213,
  [5494] = 5244,
  [5495] = 5212,
  [5496] = 5326,
  [5497] = 5210,
  [5498] = 5211,
  [5499] = 5316,
  [5500] = 5283,
  [5501] = 5216,
  [5502] = 5248,
  [5503] = 5503,
  [5504] = 5504,
  [5505] = 5224,
  [5506] = 5256,
  [5507] = 5291,
  [5508] = 5286,
  [5509] = 5228,
  [5510] = 5358,
  [5511] = 5259,
  [5512] = 5263,
  [5513] = 5226,
  [5514] = 5225,
  [5515] = 5228,
  [5516] = 5245,
  [5517] = 5517,
  [5518] = 5275,
  [5519] = 5230,
  [5520] = 5520,
  [5521] = 5233,
  [5522] = 5270,
  [5523] = 5206,
  [5524] = 5245,
  [5525] = 5525,
  [5526] = 5526,
  [5527] = 5216,
  [5528] = 5266,
  [5529] = 5262,
  [5530] = 5225,
  [5531] = 5531,
  [5532] = 5259,
  [5533] = 5226,
  [5534] = 5234,
  [5535] = 5210,
  [5536] = 5263,
  [5537] = 5244,
  [5538] = 5242,
  [5539] = 5263,
  [5540] = 5230,
  [5541] = 5275,
  [5542] = 5231,
  [5543] = 5252,
  [5544] = 5235,
  [5545] = 5290,
  [5546] = 5546,
  [5547] = 5286,
  [5548] = 5358,
  [5549] = 5236,
  [5550] = 5269,
  [5551] = 5296,
  [5552] = 5233,
  [5553] = 5291,
  [5554] = 5240,
  [5555] = 5555,
  [5556] = 5239,
  [5557] = 5326,
  [5558] = 5222,
  [5559] = 5316,
  [5560] = 5283,
  [5561] = 5262,
  [5562] = 5222,
  [5563] = 5291,
  [5564] = 5564,
  [5565] = 5263,
  [5566] = 5239,
  [5567] = 5240,
  [5568] = 5283,
  [5569] = 5226,
  [5570] = 5316,
  [5571] = 5236,
  [5572] = 5326,
  [5573] = 5234,
  [5574] = 5574,
  [5575] = 5225,
  [5576] = 5270,
  [5577] = 5245,
  [5578] = 5252,
  [5579] = 5579,
  [5580] = 5580,
  [5581] = 5259,
  [5582] = 5262,
  [5583] = 5266,
  [5584] = 5584,
  [5585] = 5296,
  [5586] = 5234,
  [5587] = 5269,
  [5588] = 5588,
  [5589] = 5216,
  [5590] = 5233,
  [5591] = 5210,
  [5592] = 5592,
  [5593] = 5593,
  [5594] = 5244,
  [5595] = 5595,
  [5596] = 5242,
  [5597] = 5358,
  [5598] = 5286,
  [5599] = 5230,
  [5600] = 5266,
  [5601] = 5272,
  [5602] = 5602,
  [5603] = 5296,
  [5604] = 5290,
  [5605] = 5228,
  [5606] = 5213,
  [5607] = 5212,
  [5608] = 5608,
  [5609] = 5609,
  [5610] = 5610,
  [5611] = 5611,
  [5612] = 5270,
  [5613] = 5211,
  [5614] = 5614,
  [5615] = 5223,
  [5616] = 5275,
  [5617] = 5219,
  [5618] = 5206,
  [5619] = 5218,
  [5620] = 5620,
  [5621] = 5269,
  [5622] = 5622,
  [5623] = 5623,
  [5624] = 5206,
  [5625] = 5625,
  [5626] = 5626,
  [5627] = 5627,
  [5628] = 5628,
  [5629] = 5629,
  [5630] = 5630,
  [5631] = 5631,
  [5632] = 5632,
  [5633] = 5633,
  [5634] = 5634,
  [5635] = 5635,
  [5636] = 5636,
  [5637] = 5637,
  [5638] = 5638,
  [5639] = 5639,
  [5640] = 5640,
  [5641] = 5641,
  [5642] = 5642,
  [5643] = 5643,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 5646,
  [5647] = 5647,
  [5648] = 5648,
  [5649] = 5625,
  [5650] = 5650,
  [5651] = 5651,
  [5652] = 5652,
  [5653] = 5652,
  [5654] = 5654,
  [5655] = 5655,
  [5656] = 5656,
  [5657] = 5657,
  [5658] = 5658,
  [5659] = 5659,
  [5660] = 5660,
  [5661] = 5661,
  [5662] = 5662,
  [5663] = 5663,
  [5664] = 5661,
  [5665] = 5665,
  [5666] = 5666,
  [5667] = 5667,
  [5668] = 5668,
  [5669] = 5669,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 5672,
  [5673] = 5673,
  [5674] = 5674,
  [5675] = 5675,
  [5676] = 5676,
  [5677] = 5677,
  [5678] = 5645,
  [5679] = 5679,
  [5680] = 5650,
  [5681] = 5671,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5684,
  [5685] = 5648,
  [5686] = 5686,
  [5687] = 5641,
  [5688] = 5688,
  [5689] = 5689,
  [5690] = 5627,
  [5691] = 5691,
  [5692] = 5692,
  [5693] = 5634,
  [5694] = 5694,
  [5695] = 5695,
  [5696] = 5696,
  [5697] = 5697,
  [5698] = 5698,
  [5699] = 5699,
  [5700] = 5700,
  [5701] = 5701,
  [5702] = 5702,
  [5703] = 5668,
  [5704] = 5704,
  [5705] = 5705,
  [5706] = 5706,
  [5707] = 5707,
  [5708] = 5708,
  [5709] = 5709,
  [5710] = 5710,
  [5711] = 5711,
  [5712] = 5712,
  [5713] = 5713,
  [5714] = 5714,
  [5715] = 5715,
  [5716] = 5679,
  [5717] = 5717,
  [5718] = 5718,
  [5719] = 5719,
  [5720] = 5720,
  [5721] = 5721,
  [5722] = 5722,
  [5723] = 5723,
  [5724] = 5679,
  [5725] = 5719,
  [5726] = 5713,
  [5727] = 5727,
  [5728] = 5728,
  [5729] = 5729,
  [5730] = 5723,
  [5731] = 5731,
  [5732] = 5722,
  [5733] = 5733,
  [5734] = 5720,
  [5735] = 5718,
  [5736] = 5701,
  [5737] = 5698,
  [5738] = 5696,
  [5739] = 5695,
  [5740] = 5677,
  [5741] = 5707,
  [5742] = 5712,
  [5743] = 5711,
  [5744] = 5675,
  [5745] = 5745,
  [5746] = 5746,
  [5747] = 5666,
  [5748] = 5710,
  [5749] = 5669,
  [5750] = 5670,
  [5751] = 5705,
  [5752] = 5702,
  [5753] = 5704,
  [5754] = 5628,
  [5755] = 5629,
  [5756] = 5697,
  [5757] = 5630,
  [5758] = 5632,
  [5759] = 5635,
  [5760] = 5636,
  [5761] = 5637,
  [5762] = 5762,
  [5763] = 5715,
  [5764] = 5667,
  [5765] = 5709,
  [5766] = 5708,
  [5767] = 5668,
  [5768] = 5768,
  [5769] = 5657,
  [5770] = 5714,
  [5771] = 5694,
  [5772] = 5659,
  [5773] = 5773,
  [5774] = 5634,
  [5775] = 5775,
  [5776] = 5776,
  [5777] = 5663,
  [5778] = 5778,
  [5779] = 5641,
  [5780] = 5648,
  [5781] = 5665,
  [5782] = 5762,
  [5783] = 5650,
  [5784] = 5709,
  [5785] = 5660,
  [5786] = 5666,
  [5787] = 5708,
  [5788] = 5706,
  [5789] = 5673,
  [5790] = 5688,
  [5791] = 5671,
  [5792] = 5676,
  [5793] = 5762,
  [5794] = 5677,
  [5795] = 5795,
  [5796] = 5652,
  [5797] = 5675,
  [5798] = 5682,
  [5799] = 5683,
  [5800] = 5684,
  [5801] = 5670,
  [5802] = 5686,
  [5803] = 5669,
  [5804] = 5706,
  [5805] = 5667,
  [5806] = 5661,
  [5807] = 5691,
  [5808] = 5692,
  [5809] = 5692,
  [5810] = 5778,
  [5811] = 5627,
  [5812] = 5691,
  [5813] = 5658,
  [5814] = 5656,
  [5815] = 5655,
  [5816] = 5706,
  [5817] = 5686,
  [5818] = 5708,
  [5819] = 5709,
  [5820] = 5820,
  [5821] = 5684,
  [5822] = 5683,
  [5823] = 5714,
  [5824] = 5715,
  [5825] = 5825,
  [5826] = 5826,
  [5827] = 5658,
  [5828] = 5682,
  [5829] = 5829,
  [5830] = 5830,
  [5831] = 5689,
  [5832] = 5719,
  [5833] = 5713,
  [5834] = 5826,
  [5835] = 5638,
  [5836] = 5676,
  [5837] = 5715,
  [5838] = 5639,
  [5839] = 5673,
  [5840] = 5840,
  [5841] = 5640,
  [5842] = 5842,
  [5843] = 5701,
  [5844] = 5698,
  [5845] = 5696,
  [5846] = 5695,
  [5847] = 5665,
  [5848] = 5643,
  [5849] = 5663,
  [5850] = 5850,
  [5851] = 5642,
  [5852] = 5642,
  [5853] = 5666,
  [5854] = 5640,
  [5855] = 5669,
  [5856] = 5643,
  [5857] = 5857,
  [5858] = 5667,
  [5859] = 5626,
  [5860] = 5628,
  [5861] = 5629,
  [5862] = 5659,
  [5863] = 5630,
  [5864] = 5632,
  [5865] = 5635,
  [5866] = 5636,
  [5867] = 5637,
  [5868] = 5644,
  [5869] = 5670,
  [5870] = 5870,
  [5871] = 5663,
  [5872] = 5677,
  [5873] = 5657,
  [5874] = 5874,
  [5875] = 5673,
  [5876] = 5876,
  [5877] = 5877,
  [5878] = 5682,
  [5879] = 5683,
  [5880] = 5684,
  [5881] = 5650,
  [5882] = 5686,
  [5883] = 5883,
  [5884] = 5651,
  [5885] = 5648,
  [5886] = 5641,
  [5887] = 5708,
  [5888] = 5709,
  [5889] = 5634,
  [5890] = 5714,
  [5891] = 5715,
  [5892] = 5668,
  [5893] = 5719,
  [5894] = 5694,
  [5895] = 5704,
  [5896] = 5896,
  [5897] = 5701,
  [5898] = 5698,
  [5899] = 5696,
  [5900] = 5695,
  [5901] = 5688,
  [5902] = 5902,
  [5903] = 5720,
  [5904] = 5718,
  [5905] = 5712,
  [5906] = 5628,
  [5907] = 5666,
  [5908] = 5629,
  [5909] = 5669,
  [5910] = 5711,
  [5911] = 5705,
  [5912] = 5912,
  [5913] = 5628,
  [5914] = 5629,
  [5915] = 5702,
  [5916] = 5632,
  [5917] = 5635,
  [5918] = 5636,
  [5919] = 5637,
  [5920] = 5658,
  [5921] = 5921,
  [5922] = 5682,
  [5923] = 5683,
  [5924] = 5684,
  [5925] = 5671,
  [5926] = 5630,
  [5927] = 5689,
  [5928] = 5928,
  [5929] = 5632,
  [5930] = 5930,
  [5931] = 5655,
  [5932] = 5661,
  [5933] = 5701,
  [5934] = 5698,
  [5935] = 5696,
  [5936] = 5695,
  [5937] = 5937,
  [5938] = 3234,
  [5939] = 5656,
  [5940] = 5694,
  [5941] = 5666,
  [5942] = 5762,
  [5943] = 5669,
  [5944] = 5944,
  [5945] = 5714,
  [5946] = 5628,
  [5947] = 5629,
  [5948] = 5902,
  [5949] = 5632,
  [5950] = 5635,
  [5951] = 5636,
  [5952] = 5637,
  [5953] = 5656,
  [5954] = 5682,
  [5955] = 5683,
  [5956] = 5684,
  [5957] = 5635,
  [5958] = 5636,
  [5959] = 5959,
  [5960] = 5960,
  [5961] = 5637,
  [5962] = 5962,
  [5963] = 5655,
  [5964] = 5701,
  [5965] = 5698,
  [5966] = 5696,
  [5967] = 5695,
  [5968] = 5968,
  [5969] = 5697,
  [5970] = 5970,
  [5971] = 5695,
  [5972] = 5666,
  [5973] = 5636,
  [5974] = 5669,
  [5975] = 5635,
  [5976] = 5870,
  [5977] = 5628,
  [5978] = 5629,
  [5979] = 5979,
  [5980] = 5632,
  [5981] = 5635,
  [5982] = 5636,
  [5983] = 5637,
  [5984] = 5984,
  [5985] = 5682,
  [5986] = 5683,
  [5987] = 5684,
  [5988] = 5988,
  [5989] = 5944,
  [5990] = 5696,
  [5991] = 5962,
  [5992] = 5655,
  [5993] = 5993,
  [5994] = 5701,
  [5995] = 5698,
  [5996] = 5696,
  [5997] = 5695,
  [5998] = 5632,
  [5999] = 5698,
  [6000] = 5637,
  [6001] = 5701,
  [6002] = 5666,
  [6003] = 6003,
  [6004] = 5669,
  [6005] = 6005,
  [6006] = 5699,
  [6007] = 5628,
  [6008] = 5629,
  [6009] = 6009,
  [6010] = 5632,
  [6011] = 5635,
  [6012] = 5636,
  [6013] = 5637,
  [6014] = 5638,
  [6015] = 5682,
  [6016] = 5683,
  [6017] = 5684,
  [6018] = 5629,
  [6019] = 6019,
  [6020] = 6020,
  [6021] = 6021,
  [6022] = 5701,
  [6023] = 5698,
  [6024] = 5696,
  [6025] = 5695,
  [6026] = 6026,
  [6027] = 5628,
  [6028] = 5959,
  [6029] = 5666,
  [6030] = 6030,
  [6031] = 5669,
  [6032] = 5692,
  [6033] = 5700,
  [6034] = 5628,
  [6035] = 5629,
  [6036] = 5642,
  [6037] = 5632,
  [6038] = 5635,
  [6039] = 5636,
  [6040] = 5637,
  [6041] = 5640,
  [6042] = 5682,
  [6043] = 5683,
  [6044] = 5684,
  [6045] = 6045,
  [6046] = 5656,
  [6047] = 5682,
  [6048] = 5683,
  [6049] = 5684,
  [6050] = 5704,
  [6051] = 5682,
  [6052] = 5683,
  [6053] = 5684,
  [6054] = 5648,
  [6055] = 5669,
  [6056] = 6056,
  [6057] = 6057,
  [6058] = 5691,
  [6059] = 5666,
  [6060] = 6060,
  [6061] = 6061,
  [6062] = 5641,
  [6063] = 6063,
  [6064] = 6064,
  [6065] = 6065,
  [6066] = 5660,
  [6067] = 5634,
  [6068] = 5663,
  [6069] = 6069,
  [6070] = 6070,
  [6071] = 6071,
  [6072] = 5639,
  [6073] = 6073,
  [6074] = 5668,
  [6075] = 6075,
  [6076] = 5673,
  [6077] = 6077,
  [6078] = 6078,
  [6079] = 5762,
  [6080] = 5704,
  [6081] = 6081,
  [6082] = 6082,
  [6083] = 6083,
  [6084] = 6084,
  [6085] = 5705,
  [6086] = 5661,
  [6087] = 5970,
  [6088] = 5795,
  [6089] = 5674,
  [6090] = 5704,
  [6091] = 5702,
  [6092] = 5778,
  [6093] = 5671,
  [6094] = 5850,
  [6095] = 5842,
  [6096] = 5768,
  [6097] = 5708,
  [6098] = 5709,
  [6099] = 5652,
  [6100] = 5661,
  [6101] = 6101,
  [6102] = 5714,
  [6103] = 5715,
  [6104] = 6104,
  [6105] = 5702,
  [6106] = 5645,
  [6107] = 5642,
  [6108] = 5640,
  [6109] = 5671,
  [6110] = 5637,
  [6111] = 5636,
  [6112] = 5719,
  [6113] = 5830,
  [6114] = 6114,
  [6115] = 5635,
  [6116] = 6116,
  [6117] = 6019,
  [6118] = 5650,
  [6119] = 5688,
  [6120] = 5646,
  [6121] = 5689,
  [6122] = 5694,
  [6123] = 5648,
  [6124] = 5697,
  [6125] = 5641,
  [6126] = 6126,
  [6127] = 5695,
  [6128] = 5696,
  [6129] = 5632,
  [6130] = 5698,
  [6131] = 5656,
  [6132] = 5640,
  [6133] = 5630,
  [6134] = 5701,
  [6135] = 5655,
  [6136] = 5699,
  [6137] = 5700,
  [6138] = 5702,
  [6139] = 5705,
  [6140] = 5710,
  [6141] = 6141,
  [6142] = 6142,
  [6143] = 5634,
  [6144] = 6144,
  [6145] = 5630,
  [6146] = 6146,
  [6147] = 5711,
  [6148] = 5642,
  [6149] = 6149,
  [6150] = 5629,
  [6151] = 5656,
  [6152] = 5655,
  [6153] = 5628,
  [6154] = 5643,
  [6155] = 5644,
  [6156] = 5712,
  [6157] = 6157,
  [6158] = 5902,
  [6159] = 5717,
  [6160] = 6056,
  [6161] = 5718,
  [6162] = 6061,
  [6163] = 5668,
  [6164] = 6063,
  [6165] = 6064,
  [6166] = 6070,
  [6167] = 6071,
  [6168] = 5720,
  [6169] = 6073,
  [6170] = 5762,
  [6171] = 6075,
  [6172] = 6077,
  [6173] = 5707,
  [6174] = 6081,
  [6175] = 6082,
  [6176] = 6083,
  [6177] = 6084,
  [6178] = 5640,
  [6179] = 5669,
  [6180] = 5970,
  [6181] = 5722,
  [6182] = 5666,
  [6183] = 5626,
  [6184] = 5723,
  [6185] = 5850,
  [6186] = 5842,
  [6187] = 5768,
  [6188] = 5727,
  [6189] = 6189,
  [6190] = 5728,
  [6191] = 5731,
  [6192] = 5733,
  [6193] = 5705,
  [6194] = 5702,
  [6195] = 5707,
  [6196] = 6116,
  [6197] = 6019,
  [6198] = 5671,
  [6199] = 5704,
  [6200] = 5646,
  [6201] = 5762,
  [6202] = 5650,
  [6203] = 5705,
  [6204] = 5874,
  [6205] = 5721,
  [6206] = 5668,
  [6207] = 5634,
  [6208] = 5641,
  [6209] = 5710,
  [6210] = 5648,
  [6211] = 5650,
  [6212] = 6116,
  [6213] = 6056,
  [6214] = 5679,
  [6215] = 6061,
  [6216] = 6216,
  [6217] = 6063,
  [6218] = 6064,
  [6219] = 6070,
  [6220] = 6071,
  [6221] = 5677,
  [6222] = 6073,
  [6223] = 5642,
  [6224] = 6075,
  [6225] = 6077,
  [6226] = 5694,
  [6227] = 6081,
  [6228] = 5642,
  [6229] = 5970,
  [6230] = 5675,
  [6231] = 6084,
  [6232] = 5768,
  [6233] = 5695,
  [6234] = 5670,
  [6235] = 5667,
  [6236] = 5696,
  [6237] = 5778,
  [6238] = 6083,
  [6239] = 5627,
  [6240] = 6019,
  [6241] = 5698,
  [6242] = 5826,
  [6243] = 5701,
  [6244] = 6082,
  [6245] = 6141,
  [6246] = 5959,
  [6247] = 5650,
  [6248] = 5686,
  [6249] = 6081,
  [6250] = 5638,
  [6251] = 6056,
  [6252] = 5639,
  [6253] = 6061,
  [6254] = 5648,
  [6255] = 6063,
  [6256] = 6064,
  [6257] = 6070,
  [6258] = 6071,
  [6259] = 5641,
  [6260] = 6073,
  [6261] = 5705,
  [6262] = 6075,
  [6263] = 5634,
  [6264] = 6081,
  [6265] = 5640,
  [6266] = 5970,
  [6267] = 5768,
  [6268] = 6142,
  [6269] = 5668,
  [6270] = 5642,
  [6271] = 5762,
  [6272] = 5643,
  [6273] = 5644,
  [6274] = 5704,
  [6275] = 5705,
  [6276] = 5713,
  [6277] = 5718,
  [6278] = 5684,
  [6279] = 5683,
  [6280] = 5682,
  [6281] = 5625,
  [6282] = 5651,
  [6283] = 6056,
  [6284] = 6061,
  [6285] = 5720,
  [6286] = 6064,
  [6287] = 5719,
  [6288] = 6075,
  [6289] = 6081,
  [6290] = 5768,
  [6291] = 5702,
  [6292] = 5671,
  [6293] = 6293,
  [6294] = 6146,
  [6295] = 6295,
  [6296] = 5661,
  [6297] = 5711,
  [6298] = 5635,
  [6299] = 5712,
  [6300] = 6300,
  [6301] = 5637,
  [6302] = 5962,
  [6303] = 5636,
  [6304] = 5648,
  [6305] = 5650,
  [6306] = 5944,
  [6307] = 6307,
  [6308] = 5655,
  [6309] = 5648,
  [6310] = 5641,
  [6311] = 5632,
  [6312] = 5634,
  [6313] = 5629,
  [6314] = 5628,
  [6315] = 5902,
  [6316] = 5668,
  [6317] = 5676,
  [6318] = 5762,
  [6319] = 6157,
  [6320] = 5656,
  [6321] = 5658,
  [6322] = 5705,
  [6323] = 6323,
  [6324] = 5669,
  [6325] = 6325,
  [6326] = 5625,
  [6327] = 6078,
  [6328] = 6077,
  [6329] = 5673,
  [6330] = 6075,
  [6331] = 5661,
  [6332] = 5715,
  [6333] = 5666,
  [6334] = 6334,
  [6335] = 6335,
  [6336] = 6336,
  [6337] = 5660,
  [6338] = 5714,
  [6339] = 6073,
  [6340] = 5713,
  [6341] = 5661,
  [6342] = 5674,
  [6343] = 5642,
  [6344] = 6344,
  [6345] = 5650,
  [6346] = 5651,
  [6347] = 5652,
  [6348] = 5648,
  [6349] = 5641,
  [6350] = 6307,
  [6351] = 5645,
  [6352] = 5634,
  [6353] = 5633,
  [6354] = 5631,
  [6355] = 6056,
  [6356] = 5667,
  [6357] = 5709,
  [6358] = 6358,
  [6359] = 5708,
  [6360] = 5671,
  [6361] = 5706,
  [6362] = 6075,
  [6363] = 6363,
  [6364] = 5668,
  [6365] = 5626,
  [6366] = 5762,
  [6367] = 5665,
  [6368] = 5850,
  [6369] = 5842,
  [6370] = 5768,
  [6371] = 5830,
  [6372] = 5717,
  [6373] = 6373,
  [6374] = 6374,
  [6375] = 5705,
  [6376] = 6026,
  [6377] = 5688,
  [6378] = 5979,
  [6379] = 5689,
  [6380] = 6071,
  [6381] = 5646,
  [6382] = 5694,
  [6383] = 5960,
  [6384] = 5718,
  [6385] = 5697,
  [6386] = 5695,
  [6387] = 5696,
  [6388] = 6070,
  [6389] = 5698,
  [6390] = 5870,
  [6391] = 5701,
  [6392] = 5663,
  [6393] = 5699,
  [6394] = 5959,
  [6395] = 6358,
  [6396] = 5700,
  [6397] = 5626,
  [6398] = 5857,
  [6399] = 5850,
  [6400] = 5842,
  [6401] = 5702,
  [6402] = 5705,
  [6403] = 6374,
  [6404] = 5710,
  [6405] = 6026,
  [6406] = 6116,
  [6407] = 5979,
  [6408] = 6141,
  [6409] = 6142,
  [6410] = 5720,
  [6411] = 6146,
  [6412] = 6412,
  [6413] = 6358,
  [6414] = 5711,
  [6415] = 5626,
  [6416] = 5712,
  [6417] = 5850,
  [6418] = 5842,
  [6419] = 6157,
  [6420] = 6374,
  [6421] = 5979,
  [6422] = 6363,
  [6423] = 5717,
  [6424] = 5718,
  [6425] = 5720,
  [6426] = 5719,
  [6427] = 6358,
  [6428] = 5722,
  [6429] = 5626,
  [6430] = 5723,
  [6431] = 5850,
  [6432] = 5842,
  [6433] = 6433,
  [6434] = 5979,
  [6435] = 5727,
  [6436] = 5728,
  [6437] = 5731,
  [6438] = 5641,
  [6439] = 6439,
  [6440] = 5626,
  [6441] = 5733,
  [6442] = 5850,
  [6443] = 5842,
  [6444] = 5634,
  [6445] = 5634,
  [6446] = 5692,
  [6447] = 5707,
  [6448] = 5691,
  [6449] = 5626,
  [6450] = 5704,
  [6451] = 5850,
  [6452] = 5842,
  [6453] = 5762,
  [6454] = 5643,
  [6455] = 5874,
  [6456] = 5721,
  [6457] = 5668,
  [6458] = 5626,
  [6459] = 5634,
  [6460] = 5850,
  [6461] = 5842,
  [6462] = 5641,
  [6463] = 5648,
  [6464] = 5650,
  [6465] = 5641,
  [6466] = 5626,
  [6467] = 6467,
  [6468] = 5850,
  [6469] = 5842,
  [6470] = 5679,
  [6471] = 5677,
  [6472] = 5665,
  [6473] = 5675,
  [6474] = 5626,
  [6475] = 6475,
  [6476] = 5850,
  [6477] = 5842,
  [6478] = 5746,
  [6479] = 5670,
  [6480] = 5667,
  [6481] = 5668,
  [6482] = 6064,
  [6483] = 6325,
  [6484] = 5731,
  [6485] = 6063,
  [6486] = 5686,
  [6487] = 5825,
  [6488] = 5883,
  [6489] = 6433,
  [6490] = 5778,
  [6491] = 5627,
  [6492] = 6026,
  [6493] = 5648,
  [6494] = 5979,
  [6495] = 5826,
  [6496] = 5659,
  [6497] = 5684,
  [6498] = 5683,
  [6499] = 6061,
  [6500] = 6358,
  [6501] = 5870,
  [6502] = 6325,
  [6503] = 5682,
  [6504] = 6060,
  [6505] = 5825,
  [6506] = 5883,
  [6507] = 6433,
  [6508] = 5663,
  [6509] = 5930,
  [6510] = 6374,
  [6511] = 6325,
  [6512] = 5722,
  [6513] = 5638,
  [6514] = 6020,
  [6515] = 6030,
  [6516] = 6325,
  [6517] = 5639,
  [6518] = 5657,
  [6519] = 6325,
  [6520] = 5640,
  [6521] = 5728,
  [6522] = 6325,
  [6523] = 5642,
  [6524] = 5727,
  [6525] = 5643,
  [6526] = 5644,
  [6527] = 5676,
  [6528] = 5723,
  [6529] = 5668,
  [6530] = 5673,
  [6531] = 5825,
  [6532] = 5625,
  [6533] = 5883,
  [6534] = 6433,
  [6535] = 5659,
  [6536] = 5651,
  [6537] = 5825,
  [6538] = 6433,
  [6539] = 5825,
  [6540] = 6433,
  [6541] = 5825,
  [6542] = 6433,
  [6543] = 5825,
  [6544] = 6433,
  [6545] = 5825,
  [6546] = 6433,
  [6547] = 5825,
  [6548] = 6433,
  [6549] = 5825,
  [6550] = 6433,
  [6551] = 5825,
  [6552] = 6433,
  [6553] = 6325,
  [6554] = 5657,
  [6555] = 6334,
  [6556] = 3895,
  [6557] = 6056,
  [6558] = 3890,
  [6559] = 5733,
};

static inline bool sym_identifier_character_set_1(int32_t c) {
  return (c < 43520
    ? (c < 4197
      ? (c < 2730
        ? (c < 2036
          ? (c < 1015
            ? (c < 750
              ? (c < 216
                ? (c < 181
                  ? (c < 170
                    ? (c >= 'A' && c <= 'z')
                    : c <= 170)
                  : (c <= 181 || (c < 192
                    ? c == 186
                    : c <= 214)))
                : (c <= 246 || (c < 736
                  ? (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)
                  : (c <= 740 || c == 748))))
              : (c <= 750 || (c < 902
                ? (c < 891
                  ? (c < 886
                    ? (c >= 880 && c <= 884)
                    : c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 910
                  ? (c < 908
                    ? (c >= 904 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c >= 931 && c <= 1013)))))))
            : (c <= 1153 || (c < 1749
              ? (c < 1488
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c >= 1376 && c <= 1416)))
                : (c <= 1514 || (c < 1646
                  ? (c < 1568
                    ? (c >= 1519 && c <= 1522)
                    : c <= 1610)
                  : (c <= 1647 || (c >= 1649 && c <= 1747)))))
              : (c <= 1749 || (c < 1808
                ? (c < 1786
                  ? (c < 1774
                    ? (c >= 1765 && c <= 1766)
                    : c <= 1775)
                  : (c <= 1788 || c == 1791))
                : (c <= 1808 || (c < 1969
                  ? (c < 1869
                    ? (c >= 1810 && c <= 1839)
                    : c <= 1957)
                  : (c <= 1969 || (c >= 1994 && c <= 2026)))))))))
          : (c <= 2037 || (c < 2486
            ? (c < 2308
              ? (c < 2112
                ? (c < 2074
                  ? (c < 2048
                    ? c == 2042
                    : c <= 2069)
                  : (c <= 2074 || (c < 2088
                    ? c == 2084
                    : c <= 2088)))
                : (c <= 2136 || (c < 2185
                  ? (c < 2160
                    ? (c >= 2144 && c <= 2154)
                    : c <= 2183)
                  : (c <= 2190 || (c >= 2208 && c <= 2249)))))
              : (c <= 2361 || (c < 2437
                ? (c < 2392
                  ? (c < 2384
                    ? c == 2365
                    : c <= 2384)
                  : (c <= 2401 || (c >= 2417 && c <= 2432)))
                : (c <= 2444 || (c < 2474
                  ? (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)
                  : (c <= 2480 || c == 2482))))))
            : (c <= 2489 || (c < 2602
              ? (c < 2544
                ? (c < 2524
                  ? (c < 2510
                    ? c == 2493
                    : c <= 2510)
                  : (c <= 2525 || (c >= 2527 && c <= 2529)))
                : (c <= 2545 || (c < 2575
                  ? (c < 2565
                    ? c == 2556
                    : c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))))
              : (c <= 2608 || (c < 2654
                ? (c < 2616
                  ? (c < 2613
                    ? (c >= 2610 && c <= 2611)
                    : c <= 2614)
                  : (c <= 2617 || (c >= 2649 && c <= 2652)))
                : (c <= 2654 || (c < 2703
                  ? (c < 2693
                    ? (c >= 2674 && c <= 2676)
                    : c <= 2701)
                  : (c <= 2705 || (c >= 2707 && c <= 2728)))))))))))
        : (c <= 2736 || (c < 3253
          ? (c < 2969
            ? (c < 2866
              ? (c < 2809
                ? (c < 2749
                  ? (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)
                  : (c <= 2749 || (c < 2784
                    ? c == 2768
                    : c <= 2785)))
                : (c <= 2809 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))))
              : (c <= 2867 || (c < 2929
                ? (c < 2908
                  ? (c < 2877
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2877)
                  : (c <= 2909 || (c >= 2911 && c <= 2913)))
                : (c <= 2929 || (c < 2958
                  ? (c < 2949
                    ? c == 2947
                    : c <= 2954)
                  : (c <= 2960 || (c >= 2962 && c <= 2965)))))))
            : (c <= 2970 || (c < 3114
              ? (c < 2990
                ? (c < 2979
                  ? (c < 2974
                    ? c == 2972
                    : c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))
                : (c <= 3001 || (c < 3086
                  ? (c < 3077
                    ? c == 3024
                    : c <= 3084)
                  : (c <= 3088 || (c >= 3090 && c <= 3112)))))
              : (c <= 3129 || (c < 3200
                ? (c < 3165
                  ? (c < 3160
                    ? c == 3133
                    : c <= 3162)
                  : (c <= 3165 || (c >= 3168 && c <= 3169)))
                : (c <= 3200 || (c < 3218
                  ? (c < 3214
                    ? (c >= 3205 && c <= 3212)
                    : c <= 3216)
                  : (c <= 3240 || (c >= 3242 && c <= 3251)))))))))
          : (c <= 3257 || (c < 3713
            ? (c < 3423
              ? (c < 3342
                ? (c < 3296
                  ? (c < 3293
                    ? c == 3261
                    : c <= 3294)
                  : (c <= 3297 || (c < 3332
                    ? (c >= 3313 && c <= 3314)
                    : c <= 3340)))
                : (c <= 3344 || (c < 3406
                  ? (c < 3389
                    ? (c >= 3346 && c <= 3386)
                    : c <= 3389)
                  : (c <= 3406 || (c >= 3412 && c <= 3414)))))
              : (c <= 3425 || (c < 3517
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3450 && c <= 3455)
                    : c <= 3478)
                  : (c <= 3505 || (c >= 3507 && c <= 3515)))
                : (c <= 3517 || (c < 3634
                  ? (c < 3585
                    ? (c >= 3520 && c <= 3526)
                    : c <= 3632)
                  : (c <= 3634 || (c >= 3648 && c <= 3654)))))))
            : (c <= 3714 || (c < 3804
              ? (c < 3751
                ? (c < 3724
                  ? (c < 3718
                    ? c == 3716
                    : c <= 3722)
                  : (c <= 3747 || c == 3749))
                : (c <= 3760 || (c < 3776
                  ? (c < 3773
                    ? c == 3762
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))
              : (c <= 3807 || (c < 4096
                ? (c < 3913
                  ? (c < 3904
                    ? c == 3840
                    : c <= 3911)
                  : (c <= 3948 || (c >= 3976 && c <= 3980)))
                : (c <= 4138 || (c < 4186
                  ? (c < 4176
                    ? c == 4159
                    : c <= 4181)
                  : (c <= 4189 || c == 4193))))))))))))
      : (c <= 4198 || (c < 8144
        ? (c < 6272
          ? (c < 4824
            ? (c < 4696
              ? (c < 4301
                ? (c < 4238
                  ? (c < 4213
                    ? (c >= 4206 && c <= 4208)
                    : c <= 4225)
                  : (c <= 4238 || (c < 4295
                    ? (c >= 4256 && c <= 4293)
                    : c <= 4295)))
                : (c <= 4301 || (c < 4682
                  ? (c < 4348
                    ? (c >= 4304 && c <= 4346)
                    : c <= 4680)
                  : (c <= 4685 || (c >= 4688 && c <= 4694)))))
              : (c <= 4696 || (c < 4786
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c >= 4808 && c <= 4822)))))))
            : (c <= 4880 || (c < 5870
              ? (c < 5112
                ? (c < 4992
                  ? (c < 4888
                    ? (c >= 4882 && c <= 4885)
                    : c <= 4954)
                  : (c <= 5007 || (c >= 5024 && c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c >= 5792 && c <= 5866)))))
              : (c <= 5880 || (c < 5998
                ? (c < 5952
                  ? (c < 5919
                    ? (c >= 5888 && c <= 5905)
                    : c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6108
                  ? (c < 6103
                    ? (c >= 6016 && c <= 6067)
                    : c <= 6103)
                  : (c <= 6108 || (c >= 6176 && c <= 6264)))))))))
          : (c <= 6312 || (c < 7357
            ? (c < 6917
              ? (c < 6528
                ? (c < 6400
                  ? (c < 6320
                    ? c == 6314
                    : c <= 6389)
                  : (c <= 6430 || (c < 6512
                    ? (c >= 6480 && c <= 6509)
                    : c <= 6516)))
                : (c <= 6571 || (c < 6688
                  ? (c < 6656
                    ? (c >= 6576 && c <= 6601)
                    : c <= 6678)
                  : (c <= 6740 || c == 6823))))
              : (c <= 6963 || (c < 7168
                ? (c < 7086
                  ? (c < 7043
                    ? (c >= 6981 && c <= 6988)
                    : c <= 7072)
                  : (c <= 7087 || (c >= 7098 && c <= 7141)))
                : (c <= 7203 || (c < 7296
                  ? (c < 7258
                    ? (c >= 7245 && c <= 7247)
                    : c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))))))
            : (c <= 7359 || (c < 8016
              ? (c < 7424
                ? (c < 7413
                  ? (c < 7406
                    ? (c >= 7401 && c <= 7404)
                    : c <= 7411)
                  : (c <= 7414 || c == 7418))
                : (c <= 7615 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7680 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c >= 8008 && c <= 8013)))))
              : (c <= 8023 || (c < 8064
                ? (c < 8029
                  ? (c < 8027
                    ? c == 8025
                    : c <= 8027)
                  : (c <= 8029 || (c >= 8031 && c <= 8061)))
                : (c <= 8116 || (c < 8130
                  ? (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)
                  : (c <= 8132 || (c >= 8134 && c <= 8140)))))))))))
        : (c <= 8147 || (c < 12344
          ? (c < 11264
            ? (c < 8469
              ? (c < 8319
                ? (c < 8178
                  ? (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)
                  : (c <= 8180 || (c < 8305
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8305)))
                : (c <= 8319 || (c < 8455
                  ? (c < 8450
                    ? (c >= 8336 && c <= 8348)
                    : c <= 8450)
                  : (c <= 8455 || (c >= 8458 && c <= 8467)))))
              : (c <= 8469 || (c < 8490
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || c == 8488))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c >= 8544 && c <= 8584)))))))
            : (c <= 11492 || (c < 11688
              ? (c < 11565
                ? (c < 11520
                  ? (c < 11506
                    ? (c >= 11499 && c <= 11502)
                    : c <= 11507)
                  : (c <= 11557 || c == 11559))
                : (c <= 11565 || (c < 11648
                  ? (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))))
              : (c <= 11694 || (c < 11728
                ? (c < 11712
                  ? (c < 11704
                    ? (c >= 11696 && c <= 11702)
                    : c <= 11710)
                  : (c <= 11718 || (c >= 11720 && c <= 11726)))
                : (c <= 11734 || (c < 12321
                  ? (c < 12293
                    ? (c >= 11736 && c <= 11742)
                    : c <= 12295)
                  : (c <= 12329 || (c >= 12337 && c <= 12341)))))))))
          : (c <= 12348 || (c < 42960
            ? (c < 42192
              ? (c < 12593
                ? (c < 12449
                  ? (c < 12445
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12447)
                  : (c <= 12538 || (c < 12549
                    ? (c >= 12540 && c <= 12543)
                    : c <= 12591)))
                : (c <= 12686 || (c < 13312
                  ? (c < 12784
                    ? (c >= 12704 && c <= 12735)
                    : c <= 12799)
                  : (c <= 19903 || (c >= 19968 && c <= 42124)))))
              : (c <= 42237 || (c < 42623
                ? (c < 42538
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42527)
                  : (c <= 42539 || (c >= 42560 && c <= 42606)))
                : (c <= 42653 || (c < 42786
                  ? (c < 42775
                    ? (c >= 42656 && c <= 42735)
                    : c <= 42783)
                  : (c <= 42888 || (c >= 42891 && c <= 42954)))))))
            : (c <= 42961 || (c < 43259
              ? (c < 43015
                ? (c < 42994
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42969)
                  : (c <= 43009 || (c >= 43011 && c <= 43013)))
                : (c <= 43018 || (c < 43138
                  ? (c < 43072
                    ? (c >= 43020 && c <= 43042)
                    : c <= 43123)
                  : (c <= 43187 || (c >= 43250 && c <= 43255)))))
              : (c <= 43259 || (c < 43396
                ? (c < 43312
                  ? (c < 43274
                    ? (c >= 43261 && c <= 43262)
                    : c <= 43301)
                  : (c <= 43334 || (c >= 43360 && c <= 43388)))
                : (c <= 43442 || (c < 43494
                  ? (c < 43488
                    ? c == 43471
                    : c <= 43492)
                  : (c <= 43503 || (c >= 43514 && c <= 43518)))))))))))))))
    : (c <= 43560 || (c < 70751
      ? (c < 66964
        ? (c < 65008
          ? (c < 43888
            ? (c < 43739
              ? (c < 43697
                ? (c < 43616
                  ? (c < 43588
                    ? (c >= 43584 && c <= 43586)
                    : c <= 43595)
                  : (c <= 43638 || (c < 43646
                    ? c == 43642
                    : c <= 43695)))
                : (c <= 43697 || (c < 43712
                  ? (c < 43705
                    ? (c >= 43701 && c <= 43702)
                    : c <= 43709)
                  : (c <= 43712 || c == 43714))))
              : (c <= 43741 || (c < 43793
                ? (c < 43777
                  ? (c < 43762
                    ? (c >= 43744 && c <= 43754)
                    : c <= 43764)
                  : (c <= 43782 || (c >= 43785 && c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))))))
            : (c <= 44002 || (c < 64298
              ? (c < 64112
                ? (c < 55243
                  ? (c < 55216
                    ? (c >= 44032 && c <= 55203)
                    : c <= 55238)
                  : (c <= 55291 || (c >= 63744 && c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64285 || (c >= 64287 && c <= 64296)))))
              : (c <= 64310 || (c < 64326
                ? (c < 64320
                  ? (c < 64318
                    ? (c >= 64312 && c <= 64316)
                    : c <= 64318)
                  : (c <= 64321 || (c >= 64323 && c <= 64324)))
                : (c <= 64433 || (c < 64848
                  ? (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)
                  : (c <= 64911 || (c >= 64914 && c <= 64967)))))))))
          : (c <= 65017 || (c < 65616
            ? (c < 65440
              ? (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65345
                  ? (c < 65313
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65338)
                  : (c <= 65370 || (c >= 65382 && c <= 65437)))))
              : (c <= 65470 || (c < 65536
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c >= 65498 && c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c >= 65599 && c <= 65613)))))))
            : (c <= 65629 || (c < 66504
              ? (c < 66304
                ? (c < 66176
                  ? (c < 65856
                    ? (c >= 65664 && c <= 65786)
                    : c <= 65908)
                  : (c <= 66204 || (c >= 66208 && c <= 66256)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66421)
                  : (c <= 66461 || (c >= 66464 && c <= 66499)))))
              : (c <= 66511 || (c < 66816
                ? (c < 66736
                  ? (c < 66560
                    ? (c >= 66513 && c <= 66517)
                    : c <= 66717)
                  : (c <= 66771 || (c >= 66776 && c <= 66811)))
                : (c <= 66855 || (c < 66940
                  ? (c < 66928
                    ? (c >= 66864 && c <= 66915)
                    : c <= 66938)
                  : (c <= 66954 || (c >= 66956 && c <= 66962)))))))))))
        : (c <= 66965 || (c < 69248
          ? (c < 67840
            ? (c < 67584
              ? (c < 67392
                ? (c < 66995
                  ? (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)
                  : (c <= 67001 || (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)))
                : (c <= 67413 || (c < 67463
                  ? (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)
                  : (c <= 67504 || (c >= 67506 && c <= 67514)))))
              : (c <= 67589 || (c < 67647
                ? (c < 67639
                  ? (c < 67594
                    ? c == 67592
                    : c <= 67637)
                  : (c <= 67640 || c == 67644))
                : (c <= 67669 || (c < 67808
                  ? (c < 67712
                    ? (c >= 67680 && c <= 67702)
                    : c <= 67742)
                  : (c <= 67826 || (c >= 67828 && c <= 67829)))))))
            : (c <= 67861 || (c < 68288
              ? (c < 68112
                ? (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || c == 68096))
                : (c <= 68115 || (c < 68192
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68220 || (c >= 68224 && c <= 68252)))))
              : (c <= 68295 || (c < 68480
                ? (c < 68416
                  ? (c < 68352
                    ? (c >= 68297 && c <= 68324)
                    : c <= 68405)
                  : (c <= 68437 || (c >= 68448 && c <= 68466)))
                : (c <= 68497 || (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c >= 68864 && c <= 68899)))))))))
          : (c <= 69289 || (c < 70108
            ? (c < 69763
              ? (c < 69552
                ? (c < 69415
                  ? (c < 69376
                    ? (c >= 69296 && c <= 69297)
                    : c <= 69404)
                  : (c <= 69415 || (c < 69488
                    ? (c >= 69424 && c <= 69445)
                    : c <= 69505)))
                : (c <= 69572 || (c < 69745
                  ? (c < 69635
                    ? (c >= 69600 && c <= 69622)
                    : c <= 69687)
                  : (c <= 69746 || c == 69749))))
              : (c <= 69807 || (c < 69968
                ? (c < 69956
                  ? (c < 69891
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69926)
                  : (c <= 69956 || c == 69959))
                : (c <= 70002 || (c < 70081
                  ? (c < 70019
                    ? c == 70006
                    : c <= 70066)
                  : (c <= 70084 || c == 70106))))))
            : (c <= 70108 || (c < 70415
              ? (c < 70282
                ? (c < 70272
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70187)
                  : (c <= 70278 || c == 70280))
                : (c <= 70285 || (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70366 || (c >= 70405 && c <= 70412)))))
              : (c <= 70416 || (c < 70461
                ? (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c >= 70453 && c <= 70457)))
                : (c <= 70461 || (c < 70656
                  ? (c < 70493
                    ? c == 70480
                    : c <= 70497)
                  : (c <= 70708 || (c >= 70727 && c <= 70730)))))))))))))
      : (c <= 70753 || (c < 119966
        ? (c < 73063
          ? (c < 72096
            ? (c < 71488
              ? (c < 71168
                ? (c < 70855
                  ? (c < 70852
                    ? (c >= 70784 && c <= 70831)
                    : c <= 70853)
                  : (c <= 70855 || (c < 71128
                    ? (c >= 71040 && c <= 71086)
                    : c <= 71131)))
                : (c <= 71215 || (c < 71352
                  ? (c < 71296
                    ? c == 71236
                    : c <= 71338)
                  : (c <= 71352 || (c >= 71424 && c <= 71450)))))
              : (c <= 71494 || (c < 71948
                ? (c < 71935
                  ? (c < 71840
                    ? (c >= 71680 && c <= 71723)
                    : c <= 71903)
                  : (c <= 71942 || c == 71945))
                : (c <= 71955 || (c < 71999
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71983)
                  : (c <= 71999 || c == 72001))))))
            : (c <= 72103 || (c < 72368
              ? (c < 72203
                ? (c < 72163
                  ? (c < 72161
                    ? (c >= 72106 && c <= 72144)
                    : c <= 72161)
                  : (c <= 72163 || c == 72192))
                : (c <= 72242 || (c < 72284
                  ? (c < 72272
                    ? c == 72250
                    : c <= 72272)
                  : (c <= 72329 || c == 72349))))
              : (c <= 72440 || (c < 72960
                ? (c < 72768
                  ? (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72750)
                  : (c <= 72768 || (c >= 72818 && c <= 72847)))
                : (c <= 72966 || (c < 73030
                  ? (c < 72971
                    ? (c >= 72968 && c <= 72969)
                    : c <= 73008)
                  : (c <= 73030 || (c >= 73056 && c <= 73061)))))))))
          : (c <= 73064 || (c < 94032
            ? (c < 92160
              ? (c < 74752
                ? (c < 73440
                  ? (c < 73112
                    ? (c >= 73066 && c <= 73097)
                    : c <= 73112)
                  : (c <= 73458 || (c < 73728
                    ? c == 73648
                    : c <= 74649)))
                : (c <= 74862 || (c < 77824
                  ? (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)
                  : (c <= 78894 || (c >= 82944 && c <= 83526)))))
              : (c <= 92728 || (c < 92992
                ? (c < 92880
                  ? (c < 92784
                    ? (c >= 92736 && c <= 92766)
                    : c <= 92862)
                  : (c <= 92909 || (c >= 92928 && c <= 92975)))
                : (c <= 92995 || (c < 93760
                  ? (c < 93053
                    ? (c >= 93027 && c <= 93047)
                    : c <= 93071)
                  : (c <= 93823 || (c >= 93952 && c <= 94026)))))))
            : (c <= 94032 || (c < 110592
              ? (c < 100352
                ? (c < 94179
                  ? (c < 94176
                    ? (c >= 94099 && c <= 94111)
                    : c <= 94177)
                  : (c <= 94179 || (c >= 94208 && c <= 100343)))
                : (c <= 101589 || (c < 110581
                  ? (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)
                  : (c <= 110587 || (c >= 110589 && c <= 110590)))))
              : (c <= 110882 || (c < 113776
                ? (c < 110960
                  ? (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)
                  : (c <= 111355 || (c >= 113664 && c <= 113770)))
                : (c <= 113788 || (c < 119808
                  ? (c < 113808
                    ? (c >= 113792 && c <= 113800)
                    : c <= 113817)
                  : (c <= 119892 || (c >= 119894 && c <= 119964)))))))))))
        : (c <= 119967 || (c < 126464
          ? (c < 120598
            ? (c < 120094
              ? (c < 119997
                ? (c < 119977
                  ? (c < 119973
                    ? c == 119970
                    : c <= 119974)
                  : (c <= 119980 || (c < 119995
                    ? (c >= 119982 && c <= 119993)
                    : c <= 119995)))
                : (c <= 120003 || (c < 120077
                  ? (c < 120071
                    ? (c >= 120005 && c <= 120069)
                    : c <= 120074)
                  : (c <= 120084 || (c >= 120086 && c <= 120092)))))
              : (c <= 120121 || (c < 120146
                ? (c < 120134
                  ? (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)
                  : (c <= 120134 || (c >= 120138 && c <= 120144)))
                : (c <= 120485 || (c < 120540
                  ? (c < 120514
                    ? (c >= 120488 && c <= 120512)
                    : c <= 120538)
                  : (c <= 120570 || (c >= 120572 && c <= 120596)))))))
            : (c <= 120628 || (c < 123214
              ? (c < 120746
                ? (c < 120688
                  ? (c < 120656
                    ? (c >= 120630 && c <= 120654)
                    : c <= 120686)
                  : (c <= 120712 || (c >= 120714 && c <= 120744)))
                : (c <= 120770 || (c < 123136
                  ? (c < 122624
                    ? (c >= 120772 && c <= 120779)
                    : c <= 122654)
                  : (c <= 123180 || (c >= 123191 && c <= 123197)))))
              : (c <= 123214 || (c < 124909
                ? (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123565)
                    : c <= 123627)
                  : (c <= 124902 || (c >= 124904 && c <= 124907)))
                : (c <= 124910 || (c < 125184
                  ? (c < 124928
                    ? (c >= 124912 && c <= 124926)
                    : c <= 125124)
                  : (c <= 125251 || c == 125259))))))))
          : (c <= 126467 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126500
                  ? (c < 126497
                    ? (c >= 126469 && c <= 126495)
                    : c <= 126498)
                  : (c <= 126500 || c == 126503))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_2(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 931
            ? (c < 748
              ? (c < 192
                ? (c < 170
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 'z')
                  : (c <= 170 || (c < 186
                    ? c == 181
                    : c <= 186)))
                : (c <= 214 || (c < 710
                  ? (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))))
              : (c <= 748 || (c < 895
                ? (c < 886
                  ? (c < 880
                    ? c == 750
                    : c <= 884)
                  : (c <= 887 || (c >= 891 && c <= 893)))
                : (c <= 895 || (c < 908
                  ? (c < 904
                    ? c == 902
                    : c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))))
            : (c <= 1013 || (c < 1649
              ? (c < 1376
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1015 && c <= 1153)
                    : c <= 1327)
                  : (c <= 1366 || c == 1369))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_3(int32_t c) {
  return (c < 43514
    ? (c < 4193
      ? (c < 2707
        ? (c < 1994
          ? (c < 910
            ? (c < 736
              ? (c < 186
                ? (c < 'a'
                  ? (c < '_'
                    ? (c >= 'A' && c <= 'Z')
                    : c <= '_')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 186 || (c < 248
                  ? (c < 216
                    ? (c >= 192 && c <= 214)
                    : c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))))
              : (c <= 740 || (c < 891
                ? (c < 880
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c >= 886 && c <= 887)))
                : (c <= 893 || (c < 904
                  ? (c < 902
                    ? c == 895
                    : c <= 902)
                  : (c <= 906 || c == 908))))))
            : (c <= 929 || (c < 1649
              ? (c < 1376
                ? (c < 1162
                  ? (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)
                  : (c <= 1327 || (c < 1369
                    ? (c >= 1329 && c <= 1366)
                    : c <= 1369)))
                : (c <= 1416 || (c < 1568
                  ? (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))))
              : (c <= 1747 || (c < 1791
                ? (c < 1774
                  ? (c < 1765
                    ? c == 1749
                    : c <= 1766)
                  : (c <= 1775 || (c >= 1786 && c <= 1788)))
                : (c <= 1791 || (c < 1869
                  ? (c < 1810
                    ? c == 1808
                    : c <= 1839)
                  : (c <= 1957 || c == 1969))))))))
          : (c <= 2026 || (c < 2482
            ? (c < 2208
              ? (c < 2088
                ? (c < 2048
                  ? (c < 2042
                    ? (c >= 2036 && c <= 2037)
                    : c <= 2042)
                  : (c <= 2069 || (c < 2084
                    ? c == 2074
                    : c <= 2084)))
                : (c <= 2088 || (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2136)
                    : c <= 2154)
                  : (c <= 2183 || (c >= 2185 && c <= 2190)))))
              : (c <= 2249 || (c < 2417
                ? (c < 2384
                  ? (c < 2365
                    ? (c >= 2308 && c <= 2361)
                    : c <= 2365)
                  : (c <= 2384 || (c >= 2392 && c <= 2401)))
                : (c <= 2432 || (c < 2451
                  ? (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)
                  : (c <= 2472 || (c >= 2474 && c <= 2480)))))))
            : (c <= 2482 || (c < 2579
              ? (c < 2527
                ? (c < 2510
                  ? (c < 2493
                    ? (c >= 2486 && c <= 2489)
                    : c <= 2493)
                  : (c <= 2510 || (c >= 2524 && c <= 2525)))
                : (c <= 2529 || (c < 2565
                  ? (c < 2556
                    ? (c >= 2544 && c <= 2545)
                    : c <= 2556)
                  : (c <= 2570 || (c >= 2575 && c <= 2576)))))
              : (c <= 2600 || (c < 2649
                ? (c < 2613
                  ? (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2652 || (c < 2693
                  ? (c < 2674
                    ? c == 2654
                    : c <= 2676)
                  : (c <= 2701 || (c >= 2703 && c <= 2705)))))))))))
        : (c <= 2728 || (c < 3242
          ? (c < 2962
            ? (c < 2858
              ? (c < 2784
                ? (c < 2741
                  ? (c < 2738
                    ? (c >= 2730 && c <= 2736)
                    : c <= 2739)
                  : (c <= 2745 || (c < 2768
                    ? c == 2749
                    : c <= 2768)))
                : (c <= 2785 || (c < 2831
                  ? (c < 2821
                    ? c == 2809
                    : c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))))
              : (c <= 2864 || (c < 2911
                ? (c < 2877
                  ? (c < 2869
                    ? (c >= 2866 && c <= 2867)
                    : c <= 2873)
                  : (c <= 2877 || (c >= 2908 && c <= 2909)))
                : (c <= 2913 || (c < 2949
                  ? (c < 2947
                    ? c == 2929
                    : c <= 2947)
                  : (c <= 2954 || (c >= 2958 && c <= 2960)))))))
            : (c <= 2965 || (c < 3090
              ? (c < 2984
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c >= 2979 && c <= 2980)))
                : (c <= 2986 || (c < 3077
                  ? (c < 3024
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3024)
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))))
              : (c <= 3112 || (c < 3168
                ? (c < 3160
                  ? (c < 3133
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3133)
                  : (c <= 3162 || c == 3165))
                : (c <= 3169 || (c < 3214
                  ? (c < 3205
                    ? c == 3200
                    : c <= 3212)
                  : (c <= 3216 || (c >= 3218 && c <= 3240)))))))))
          : (c <= 3251 || (c < 3648
            ? (c < 3412
              ? (c < 3332
                ? (c < 3293
                  ? (c < 3261
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3261)
                  : (c <= 3294 || (c < 3313
                    ? (c >= 3296 && c <= 3297)
                    : c <= 3314)))
                : (c <= 3340 || (c < 3389
                  ? (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3386)
                  : (c <= 3389 || c == 3406))))
              : (c <= 3414 || (c < 3507
                ? (c < 3461
                  ? (c < 3450
                    ? (c >= 3423 && c <= 3425)
                    : c <= 3455)
                  : (c <= 3478 || (c >= 3482 && c <= 3505)))
                : (c <= 3515 || (c < 3585
                  ? (c < 3520
                    ? c == 3517
                    : c <= 3526)
                  : (c <= 3632 || c == 3634))))))
            : (c <= 3654 || (c < 3782
              ? (c < 3749
                ? (c < 3718
                  ? (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)
                  : (c <= 3722 || (c >= 3724 && c <= 3747)))
                : (c <= 3749 || (c < 3773
                  ? (c < 3762
                    ? (c >= 3751 && c <= 3760)
                    : c <= 3762)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))
              : (c <= 3782 || (c < 3976
                ? (c < 3904
                  ? (c < 3840
                    ? (c >= 3804 && c <= 3807)
                    : c <= 3840)
                  : (c <= 3911 || (c >= 3913 && c <= 3948)))
                : (c <= 3980 || (c < 4176
                  ? (c < 4159
                    ? (c >= 4096 && c <= 4138)
                    : c <= 4159)
                  : (c <= 4181 || (c >= 4186 && c <= 4189)))))))))))))
      : (c <= 4193 || (c < 8134
        ? (c < 6176
          ? (c < 4808
            ? (c < 4688
              ? (c < 4295
                ? (c < 4213
                  ? (c < 4206
                    ? (c >= 4197 && c <= 4198)
                    : c <= 4208)
                  : (c <= 4225 || (c < 4256
                    ? c == 4238
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))))
              : (c <= 4694 || (c < 4752
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c >= 4746 && c <= 4749)))
                : (c <= 4784 || (c < 4800
                  ? (c < 4792
                    ? (c >= 4786 && c <= 4789)
                    : c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))))
            : (c <= 4822 || (c < 5792
              ? (c < 5024
                ? (c < 4888
                  ? (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)
                  : (c <= 4954 || (c >= 4992 && c <= 5007)))
                : (c <= 5109 || (c < 5743
                  ? (c < 5121
                    ? (c >= 5112 && c <= 5117)
                    : c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))))
              : (c <= 5866 || (c < 5984
                ? (c < 5919
                  ? (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5905)
                  : (c <= 5937 || (c >= 5952 && c <= 5969)))
                : (c <= 5996 || (c < 6103
                  ? (c < 6016
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6067)
                  : (c <= 6103 || c == 6108))))))))
          : (c <= 6264 || (c < 7312
            ? (c < 6823
              ? (c < 6512
                ? (c < 6320
                  ? (c < 6314
                    ? (c >= 6272 && c <= 6312)
                    : c <= 6314)
                  : (c <= 6389 || (c < 6480
                    ? (c >= 6400 && c <= 6430)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6656
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6678 || (c >= 6688 && c <= 6740)))))
              : (c <= 6823 || (c < 7098
                ? (c < 7043
                  ? (c < 6981
                    ? (c >= 6917 && c <= 6963)
                    : c <= 6988)
                  : (c <= 7072 || (c >= 7086 && c <= 7087)))
                : (c <= 7141 || (c < 7258
                  ? (c < 7245
                    ? (c >= 7168 && c <= 7203)
                    : c <= 7247)
                  : (c <= 7293 || (c >= 7296 && c <= 7304)))))))
            : (c <= 7354 || (c < 8008
              ? (c < 7418
                ? (c < 7406
                  ? (c < 7401
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7404)
                  : (c <= 7411 || (c >= 7413 && c <= 7414)))
                : (c <= 7418 || (c < 7960
                  ? (c < 7680
                    ? (c >= 7424 && c <= 7615)
                    : c <= 7957)
                  : (c <= 7965 || (c >= 7968 && c <= 8005)))))
              : (c <= 8013 || (c < 8031
                ? (c < 8027
                  ? (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8126
                  ? (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)
                  : (c <= 8126 || (c >= 8130 && c <= 8132)))))))))))
        : (c <= 8140 || (c < 12337
          ? (c < 8544
            ? (c < 8458
              ? (c < 8305
                ? (c < 8160
                  ? (c < 8150
                    ? (c >= 8144 && c <= 8147)
                    : c <= 8155)
                  : (c <= 8172 || (c < 8182
                    ? (c >= 8178 && c <= 8180)
                    : c <= 8188)))
                : (c <= 8305 || (c < 8450
                  ? (c < 8336
                    ? c == 8319
                    : c <= 8348)
                  : (c <= 8450 || c == 8455))))
              : (c <= 8467 || (c < 8488
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8517
                  ? (c < 8508
                    ? (c >= 8490 && c <= 8505)
                    : c <= 8511)
                  : (c <= 8521 || c == 8526))))))
            : (c <= 8584 || (c < 11680
              ? (c < 11559
                ? (c < 11506
                  ? (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11502)
                  : (c <= 11507 || (c >= 11520 && c <= 11557)))
                : (c <= 11559 || (c < 11631
                  ? (c < 11568
                    ? c == 11565
                    : c <= 11623)
                  : (c <= 11631 || (c >= 11648 && c <= 11670)))))
              : (c <= 11686 || (c < 11720
                ? (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c >= 11712 && c <= 11718)))
                : (c <= 11726 || (c < 12293
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 12295 || (c >= 12321 && c <= 12329)))))))))
          : (c <= 12341 || (c < 42891
            ? (c < 19968
              ? (c < 12549
                ? (c < 12445
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))
                : (c <= 12591 || (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c >= 13312 && c <= 19903)))))
              : (c <= 42124 || (c < 42560
                ? (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42527 || (c >= 42538 && c <= 42539)))
                : (c <= 42606 || (c < 42775
                  ? (c < 42656
                    ? (c >= 42623 && c <= 42653)
                    : c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))))))
            : (c <= 42954 || (c < 43250
              ? (c < 43011
                ? (c < 42965
                  ? (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)
                  : (c <= 42969 || (c >= 42994 && c <= 43009)))
                : (c <= 43013 || (c < 43072
                  ? (c < 43020
                    ? (c >= 43015 && c <= 43018)
                    : c <= 43042)
                  : (c <= 43123 || (c >= 43138 && c <= 43187)))))
              : (c <= 43255 || (c < 43360
                ? (c < 43274
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43488
                  ? (c < 43471
                    ? (c >= 43396 && c <= 43442)
                    : c <= 43471)
                  : (c <= 43492 || (c >= 43494 && c <= 43503)))))))))))))))
    : (c <= 43518 || (c < 70727
      ? (c < 66956
        ? (c < 64914
          ? (c < 43868
            ? (c < 43714
              ? (c < 43646
                ? (c < 43588
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43560)
                    : c <= 43586)
                  : (c <= 43595 || (c < 43642
                    ? (c >= 43616 && c <= 43638)
                    : c <= 43642)))
                : (c <= 43695 || (c < 43705
                  ? (c < 43701
                    ? c == 43697
                    : c <= 43702)
                  : (c <= 43709 || c == 43712))))
              : (c <= 43714 || (c < 43785
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43754)
                  : (c <= 43764 || (c >= 43777 && c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c >= 43824 && c <= 43866)))))))
            : (c <= 43881 || (c < 64287
              ? (c < 63744
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 43888 && c <= 44002)
                    : c <= 55203)
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || c == 64285))))
              : (c <= 64296 || (c < 64323
                ? (c < 64318
                  ? (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)
                  : (c <= 64318 || (c >= 64320 && c <= 64321)))
                : (c <= 64324 || (c < 64612
                  ? (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)
                  : (c <= 64829 || (c >= 64848 && c <= 64911)))))))))
          : (c <= 64967 || (c < 65599
            ? (c < 65382
              ? (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65008 && c <= 65017)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65313
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65338 || (c >= 65345 && c <= 65370)))))
              : (c <= 65437 || (c < 65498
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65440 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c >= 65490 && c <= 65495)))
                : (c <= 65500 || (c < 65576
                  ? (c < 65549
                    ? (c >= 65536 && c <= 65547)
                    : c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))))))
            : (c <= 65613 || (c < 66464
              ? (c < 66208
                ? (c < 65856
                  ? (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)
                  : (c <= 65908 || (c >= 66176 && c <= 66204)))
                : (c <= 66256 || (c < 66384
                  ? (c < 66349
                    ? (c >= 66304 && c <= 66335)
                    : c <= 66378)
                  : (c <= 66421 || (c >= 66432 && c <= 66461)))))
              : (c <= 66499 || (c < 66776
                ? (c < 66560
                  ? (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)
                  : (c <= 66717 || (c >= 66736 && c <= 66771)))
                : (c <= 66811 || (c < 66928
                  ? (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)
                  : (c <= 66938 || (c >= 66940 && c <= 66954)))))))))))
        : (c <= 66962 || (c < 68864
          ? (c < 67828
            ? (c < 67506
              ? (c < 67072
                ? (c < 66979
                  ? (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)
                  : (c <= 66993 || (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)))
                : (c <= 67382 || (c < 67456
                  ? (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)
                  : (c <= 67461 || (c >= 67463 && c <= 67504)))))
              : (c <= 67514 || (c < 67644
                ? (c < 67594
                  ? (c < 67592
                    ? (c >= 67584 && c <= 67589)
                    : c <= 67592)
                  : (c <= 67637 || (c >= 67639 && c <= 67640)))
                : (c <= 67644 || (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c >= 67808 && c <= 67826)))))))
            : (c <= 67829 || (c < 68224
              ? (c < 68096
                ? (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68096 || (c < 68121
                  ? (c < 68117
                    ? (c >= 68112 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c >= 68192 && c <= 68220)))))
              : (c <= 68252 || (c < 68448
                ? (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68324)
                  : (c <= 68405 || (c >= 68416 && c <= 68437)))
                : (c <= 68466 || (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c >= 68800 && c <= 68850)))))))))
          : (c <= 68899 || (c < 70106
            ? (c < 69749
              ? (c < 69488
                ? (c < 69376
                  ? (c < 69296
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69445)))
                : (c <= 69505 || (c < 69635
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69687 || (c >= 69745 && c <= 69746)))))
              : (c <= 69749 || (c < 69959
                ? (c < 69891
                  ? (c < 69840
                    ? (c >= 69763 && c <= 69807)
                    : c <= 69864)
                  : (c <= 69926 || c == 69956))
                : (c <= 69959 || (c < 70019
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70002)
                    : c <= 70006)
                  : (c <= 70066 || (c >= 70081 && c <= 70084)))))))
            : (c <= 70106 || (c < 70405
              ? (c < 70280
                ? (c < 70163
                  ? (c < 70144
                    ? c == 70108
                    : c <= 70161)
                  : (c <= 70187 || (c >= 70272 && c <= 70278)))
                : (c <= 70280 || (c < 70303
                  ? (c < 70287
                    ? (c >= 70282 && c <= 70285)
                    : c <= 70301)
                  : (c <= 70312 || (c >= 70320 && c <= 70366)))))
              : (c <= 70412 || (c < 70453
                ? (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c >= 70450 && c <= 70451)))
                : (c <= 70457 || (c < 70493
                  ? (c < 70480
                    ? c == 70461
                    : c <= 70480)
                  : (c <= 70497 || (c >= 70656 && c <= 70708)))))))))))))
      : (c <= 70730 || (c < 119894
        ? (c < 73056
          ? (c < 72001
            ? (c < 71424
              ? (c < 71128
                ? (c < 70852
                  ? (c < 70784
                    ? (c >= 70751 && c <= 70753)
                    : c <= 70831)
                  : (c <= 70853 || (c < 71040
                    ? c == 70855
                    : c <= 71086)))
                : (c <= 71131 || (c < 71296
                  ? (c < 71236
                    ? (c >= 71168 && c <= 71215)
                    : c <= 71236)
                  : (c <= 71338 || c == 71352))))
              : (c <= 71450 || (c < 71945
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71723)
                  : (c <= 71903 || (c >= 71935 && c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71983 || c == 71999))))))
            : (c <= 72001 || (c < 72349
              ? (c < 72192
                ? (c < 72161
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72144)
                  : (c <= 72161 || c == 72163))
                : (c <= 72192 || (c < 72272
                  ? (c < 72250
                    ? (c >= 72203 && c <= 72242)
                    : c <= 72250)
                  : (c <= 72272 || (c >= 72284 && c <= 72329)))))
              : (c <= 72349 || (c < 72818
                ? (c < 72714
                  ? (c < 72704
                    ? (c >= 72368 && c <= 72440)
                    : c <= 72712)
                  : (c <= 72750 || c == 72768))
                : (c <= 72847 || (c < 72971
                  ? (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)
                  : (c <= 73008 || c == 73030))))))))
          : (c <= 73061 || (c < 93952
            ? (c < 82944
              ? (c < 73728
                ? (c < 73112
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73097)
                  : (c <= 73112 || (c < 73648
                    ? (c >= 73440 && c <= 73458)
                    : c <= 73648)))
                : (c <= 74649 || (c < 77712
                  ? (c < 74880
                    ? (c >= 74752 && c <= 74862)
                    : c <= 75075)
                  : (c <= 77808 || (c >= 77824 && c <= 78894)))))
              : (c <= 83526 || (c < 92928
                ? (c < 92784
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92862 || (c >= 92880 && c <= 92909)))
                : (c <= 92975 || (c < 93053
                  ? (c < 93027
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93047)
                  : (c <= 93071 || (c >= 93760 && c <= 93823)))))))
            : (c <= 94026 || (c < 110589
              ? (c < 94208
                ? (c < 94176
                  ? (c < 94099
                    ? c == 94032
                    : c <= 94111)
                  : (c <= 94177 || c == 94179))
                : (c <= 100343 || (c < 110576
                  ? (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)
                  : (c <= 110579 || (c >= 110581 && c <= 110587)))))
              : (c <= 110590 || (c < 113664
                ? (c < 110948
                  ? (c < 110928
                    ? (c >= 110592 && c <= 110882)
                    : c <= 110930)
                  : (c <= 110951 || (c >= 110960 && c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c >= 119808 && c <= 119892)))))))))))
        : (c <= 119964 || (c < 125259
          ? (c < 120572
            ? (c < 120086
              ? (c < 119995
                ? (c < 119973
                  ? (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)
                  : (c <= 119974 || (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)))
                : (c <= 119995 || (c < 120071
                  ? (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)
                  : (c <= 120074 || (c >= 120077 && c <= 120084)))))
              : (c <= 120092 || (c < 120138
                ? (c < 120128
                  ? (c < 120123
                    ? (c >= 120094 && c <= 120121)
                    : c <= 120126)
                  : (c <= 120132 || c == 120134))
                : (c <= 120144 || (c < 120514
                  ? (c < 120488
                    ? (c >= 120146 && c <= 120485)
                    : c <= 120512)
                  : (c <= 120538 || (c >= 120540 && c <= 120570)))))))
            : (c <= 120596 || (c < 123191
              ? (c < 120714
                ? (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c >= 120688 && c <= 120712)))
                : (c <= 120744 || (c < 122624
                  ? (c < 120772
                    ? (c >= 120746 && c <= 120770)
                    : c <= 120779)
                  : (c <= 122654 || (c >= 123136 && c <= 123180)))))
              : (c <= 123197 || (c < 124904
                ? (c < 123584
                  ? (c < 123536
                    ? c == 123214
                    : c <= 123565)
                  : (c <= 123627 || (c >= 124896 && c <= 124902)))
                : (c <= 124907 || (c < 124928
                  ? (c < 124912
                    ? (c >= 124909 && c <= 124910)
                    : c <= 124926)
                  : (c <= 125124 || (c >= 125184 && c <= 125251)))))))))
          : (c <= 125259 || (c < 126559
            ? (c < 126535
              ? (c < 126505
                ? (c < 126497
                  ? (c < 126469
                    ? (c >= 126464 && c <= 126467)
                    : c <= 126495)
                  : (c <= 126498 || (c < 126503
                    ? c == 126500
                    : c <= 126503)))
                : (c <= 126514 || (c < 126523
                  ? (c < 126521
                    ? (c >= 126516 && c <= 126519)
                    : c <= 126521)
                  : (c <= 126523 || c == 126530))))
              : (c <= 126535 || (c < 126548
                ? (c < 126541
                  ? (c < 126539
                    ? c == 126537
                    : c <= 126539)
                  : (c <= 126543 || (c >= 126545 && c <= 126546)))
                : (c <= 126548 || (c < 126555
                  ? (c < 126553
                    ? c == 126551
                    : c <= 126553)
                  : (c <= 126555 || c == 126557))))))
            : (c <= 126559 || (c < 126625
              ? (c < 126580
                ? (c < 126567
                  ? (c < 126564
                    ? (c >= 126561 && c <= 126562)
                    : c <= 126564)
                  : (c <= 126570 || (c >= 126572 && c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c >= 126603 && c <= 126619)))))
              : (c <= 126627 || (c < 177984
                ? (c < 131072
                  ? (c < 126635
                    ? (c >= 126629 && c <= 126633)
                    : c <= 126651)
                  : (c <= 173791 || (c >= 173824 && c <= 177976)))
                : (c <= 178205 || (c < 194560
                  ? (c < 183984
                    ? (c >= 178208 && c <= 183969)
                    : c <= 191456)
                  : (c <= 195101 || (c >= 196608 && c <= 201546)))))))))))))))));
}

static inline bool sym_identifier_character_set_4(int32_t c) {
  return (c < 43642
    ? (c < 3784
      ? (c < 2759
        ? (c < 2048
          ? (c < 1155
            ? (c < 736
              ? (c < 183
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= 'z' || (c < 181
                    ? c == 170
                    : c <= 181)))
                : (c <= 183 || (c < 216
                  ? (c < 192
                    ? c == 186
                    : c <= 214)
                  : (c <= 246 || (c < 710
                    ? (c >= 248 && c <= 705)
                    : c <= 721)))))
              : (c <= 740 || (c < 895
                ? (c < 768
                  ? (c < 750
                    ? c == 748
                    : c <= 750)
                  : (c <= 884 || (c < 891
                    ? (c >= 886 && c <= 887)
                    : c <= 893)))
                : (c <= 895 || (c < 910
                  ? (c < 908
                    ? (c >= 902 && c <= 906)
                    : c <= 908)
                  : (c <= 929 || (c < 1015
                    ? (c >= 931 && c <= 1013)
                    : c <= 1153)))))))
            : (c <= 1159 || (c < 1552
              ? (c < 1471
                ? (c < 1369
                  ? (c < 1329
                    ? (c >= 1162 && c <= 1327)
                    : c <= 1366)
                  : (c <= 1369 || (c < 1425
                    ? (c >= 1376 && c <= 1416)
                    : c <= 1469)))
                : (c <= 1471 || (c < 1479
                  ? (c < 1476
                    ? (c >= 1473 && c <= 1474)
                    : c <= 1477)
                  : (c <= 1479 || (c < 1519
                    ? (c >= 1488 && c <= 1514)
                    : c <= 1522)))))
              : (c <= 1562 || (c < 1791
                ? (c < 1749
                  ? (c < 1646
                    ? (c >= 1568 && c <= 1641)
                    : c <= 1747)
                  : (c <= 1756 || (c < 1770
                    ? (c >= 1759 && c <= 1768)
                    : c <= 1788)))
                : (c <= 1791 || (c < 1984
                  ? (c < 1869
                    ? (c >= 1808 && c <= 1866)
                    : c <= 1969)
                  : (c <= 2037 || (c < 2045
                    ? c == 2042
                    : c <= 2045)))))))))
          : (c <= 2093 || (c < 2561
            ? (c < 2474
              ? (c < 2275
                ? (c < 2160
                  ? (c < 2144
                    ? (c >= 2112 && c <= 2139)
                    : c <= 2154)
                  : (c <= 2183 || (c < 2200
                    ? (c >= 2185 && c <= 2190)
                    : c <= 2273)))
                : (c <= 2403 || (c < 2437
                  ? (c < 2417
                    ? (c >= 2406 && c <= 2415)
                    : c <= 2435)
                  : (c <= 2444 || (c < 2451
                    ? (c >= 2447 && c <= 2448)
                    : c <= 2472)))))
              : (c <= 2480 || (c < 2519
                ? (c < 2492
                  ? (c < 2486
                    ? c == 2482
                    : c <= 2489)
                  : (c <= 2500 || (c < 2507
                    ? (c >= 2503 && c <= 2504)
                    : c <= 2510)))
                : (c <= 2519 || (c < 2534
                  ? (c < 2527
                    ? (c >= 2524 && c <= 2525)
                    : c <= 2531)
                  : (c <= 2545 || (c < 2558
                    ? c == 2556
                    : c <= 2558)))))))
            : (c <= 2563 || (c < 2641
              ? (c < 2613
                ? (c < 2579
                  ? (c < 2575
                    ? (c >= 2565 && c <= 2570)
                    : c <= 2576)
                  : (c <= 2600 || (c < 2610
                    ? (c >= 2602 && c <= 2608)
                    : c <= 2611)))
                : (c <= 2614 || (c < 2622
                  ? (c < 2620
                    ? (c >= 2616 && c <= 2617)
                    : c <= 2620)
                  : (c <= 2626 || (c < 2635
                    ? (c >= 2631 && c <= 2632)
                    : c <= 2637)))))
              : (c <= 2641 || (c < 2703
                ? (c < 2662
                  ? (c < 2654
                    ? (c >= 2649 && c <= 2652)
                    : c <= 2654)
                  : (c <= 2677 || (c < 2693
                    ? (c >= 2689 && c <= 2691)
                    : c <= 2701)))
                : (c <= 2705 || (c < 2738
                  ? (c < 2730
                    ? (c >= 2707 && c <= 2728)
                    : c <= 2736)
                  : (c <= 2739 || (c < 2748
                    ? (c >= 2741 && c <= 2745)
                    : c <= 2757)))))))))))
        : (c <= 2761 || (c < 3174
          ? (c < 2962
            ? (c < 2869
              ? (c < 2817
                ? (c < 2784
                  ? (c < 2768
                    ? (c >= 2763 && c <= 2765)
                    : c <= 2768)
                  : (c <= 2787 || (c < 2809
                    ? (c >= 2790 && c <= 2799)
                    : c <= 2815)))
                : (c <= 2819 || (c < 2835
                  ? (c < 2831
                    ? (c >= 2821 && c <= 2828)
                    : c <= 2832)
                  : (c <= 2856 || (c < 2866
                    ? (c >= 2858 && c <= 2864)
                    : c <= 2867)))))
              : (c <= 2873 || (c < 2911
                ? (c < 2891
                  ? (c < 2887
                    ? (c >= 2876 && c <= 2884)
                    : c <= 2888)
                  : (c <= 2893 || (c < 2908
                    ? (c >= 2901 && c <= 2903)
                    : c <= 2909)))
                : (c <= 2915 || (c < 2946
                  ? (c < 2929
                    ? (c >= 2918 && c <= 2927)
                    : c <= 2929)
                  : (c <= 2947 || (c < 2958
                    ? (c >= 2949 && c <= 2954)
                    : c <= 2960)))))))
            : (c <= 2965 || (c < 3046
              ? (c < 2990
                ? (c < 2974
                  ? (c < 2972
                    ? (c >= 2969 && c <= 2970)
                    : c <= 2972)
                  : (c <= 2975 || (c < 2984
                    ? (c >= 2979 && c <= 2980)
                    : c <= 2986)))
                : (c <= 3001 || (c < 3018
                  ? (c < 3014
                    ? (c >= 3006 && c <= 3010)
                    : c <= 3016)
                  : (c <= 3021 || (c < 3031
                    ? c == 3024
                    : c <= 3031)))))
              : (c <= 3055 || (c < 3142
                ? (c < 3090
                  ? (c < 3086
                    ? (c >= 3072 && c <= 3084)
                    : c <= 3088)
                  : (c <= 3112 || (c < 3132
                    ? (c >= 3114 && c <= 3129)
                    : c <= 3140)))
                : (c <= 3144 || (c < 3160
                  ? (c < 3157
                    ? (c >= 3146 && c <= 3149)
                    : c <= 3158)
                  : (c <= 3162 || (c < 3168
                    ? c == 3165
                    : c <= 3171)))))))))
          : (c <= 3183 || (c < 3457
            ? (c < 3296
              ? (c < 3253
                ? (c < 3214
                  ? (c < 3205
                    ? (c >= 3200 && c <= 3203)
                    : c <= 3212)
                  : (c <= 3216 || (c < 3242
                    ? (c >= 3218 && c <= 3240)
                    : c <= 3251)))
                : (c <= 3257 || (c < 3274
                  ? (c < 3270
                    ? (c >= 3260 && c <= 3268)
                    : c <= 3272)
                  : (c <= 3277 || (c < 3293
                    ? (c >= 3285 && c <= 3286)
                    : c <= 3294)))))
              : (c <= 3299 || (c < 3398
                ? (c < 3328
                  ? (c < 3313
                    ? (c >= 3302 && c <= 3311)
                    : c <= 3314)
                  : (c <= 3340 || (c < 3346
                    ? (c >= 3342 && c <= 3344)
                    : c <= 3396)))
                : (c <= 3400 || (c < 3423
                  ? (c < 3412
                    ? (c >= 3402 && c <= 3406)
                    : c <= 3415)
                  : (c <= 3427 || (c < 3450
                    ? (c >= 3430 && c <= 3439)
                    : c <= 3455)))))))
            : (c <= 3459 || (c < 3585
              ? (c < 3530
                ? (c < 3507
                  ? (c < 3482
                    ? (c >= 3461 && c <= 3478)
                    : c <= 3505)
                  : (c <= 3515 || (c < 3520
                    ? c == 3517
                    : c <= 3526)))
                : (c <= 3530 || (c < 3544
                  ? (c < 3542
                    ? (c >= 3535 && c <= 3540)
                    : c <= 3542)
                  : (c <= 3551 || (c < 3570
                    ? (c >= 3558 && c <= 3567)
                    : c <= 3571)))))
              : (c <= 3642 || (c < 3724
                ? (c < 3713
                  ? (c < 3664
                    ? (c >= 3648 && c <= 3662)
                    : c <= 3673)
                  : (c <= 3714 || (c < 3718
                    ? c == 3716
                    : c <= 3722)))
                : (c <= 3747 || (c < 3776
                  ? (c < 3751
                    ? c == 3749
                    : c <= 3773)
                  : (c <= 3780 || c == 3782))))))))))))
      : (c <= 3789 || (c < 8027
        ? (c < 5919
          ? (c < 4696
            ? (c < 3974
              ? (c < 3893
                ? (c < 3840
                  ? (c < 3804
                    ? (c >= 3792 && c <= 3801)
                    : c <= 3807)
                  : (c <= 3840 || (c < 3872
                    ? (c >= 3864 && c <= 3865)
                    : c <= 3881)))
                : (c <= 3893 || (c < 3902
                  ? (c < 3897
                    ? c == 3895
                    : c <= 3897)
                  : (c <= 3911 || (c < 3953
                    ? (c >= 3913 && c <= 3948)
                    : c <= 3972)))))
              : (c <= 3991 || (c < 4295
                ? (c < 4096
                  ? (c < 4038
                    ? (c >= 3993 && c <= 4028)
                    : c <= 4038)
                  : (c <= 4169 || (c < 4256
                    ? (c >= 4176 && c <= 4253)
                    : c <= 4293)))
                : (c <= 4295 || (c < 4348
                  ? (c < 4304
                    ? c == 4301
                    : c <= 4346)
                  : (c <= 4680 || (c < 4688
                    ? (c >= 4682 && c <= 4685)
                    : c <= 4694)))))))
            : (c <= 4696 || (c < 4888
              ? (c < 4792
                ? (c < 4746
                  ? (c < 4704
                    ? (c >= 4698 && c <= 4701)
                    : c <= 4744)
                  : (c <= 4749 || (c < 4786
                    ? (c >= 4752 && c <= 4784)
                    : c <= 4789)))
                : (c <= 4798 || (c < 4808
                  ? (c < 4802
                    ? c == 4800
                    : c <= 4805)
                  : (c <= 4822 || (c < 4882
                    ? (c >= 4824 && c <= 4880)
                    : c <= 4885)))))
              : (c <= 4954 || (c < 5121
                ? (c < 4992
                  ? (c < 4969
                    ? (c >= 4957 && c <= 4959)
                    : c <= 4977)
                  : (c <= 5007 || (c < 5112
                    ? (c >= 5024 && c <= 5109)
                    : c <= 5117)))
                : (c <= 5740 || (c < 5792
                  ? (c < 5761
                    ? (c >= 5743 && c <= 5759)
                    : c <= 5786)
                  : (c <= 5866 || (c < 5888
                    ? (c >= 5870 && c <= 5880)
                    : c <= 5909)))))))))
          : (c <= 5940 || (c < 6752
            ? (c < 6272
              ? (c < 6103
                ? (c < 5998
                  ? (c < 5984
                    ? (c >= 5952 && c <= 5971)
                    : c <= 5996)
                  : (c <= 6000 || (c < 6016
                    ? (c >= 6002 && c <= 6003)
                    : c <= 6099)))
                : (c <= 6103 || (c < 6155
                  ? (c < 6112
                    ? (c >= 6108 && c <= 6109)
                    : c <= 6121)
                  : (c <= 6157 || (c < 6176
                    ? (c >= 6159 && c <= 6169)
                    : c <= 6264)))))
              : (c <= 6314 || (c < 6512
                ? (c < 6432
                  ? (c < 6400
                    ? (c >= 6320 && c <= 6389)
                    : c <= 6430)
                  : (c <= 6443 || (c < 6470
                    ? (c >= 6448 && c <= 6459)
                    : c <= 6509)))
                : (c <= 6516 || (c < 6608
                  ? (c < 6576
                    ? (c >= 6528 && c <= 6571)
                    : c <= 6601)
                  : (c <= 6618 || (c < 6688
                    ? (c >= 6656 && c <= 6683)
                    : c <= 6750)))))))
            : (c <= 6780 || (c < 7245
              ? (c < 6912
                ? (c < 6823
                  ? (c < 6800
                    ? (c >= 6783 && c <= 6793)
                    : c <= 6809)
                  : (c <= 6823 || (c < 6847
                    ? (c >= 6832 && c <= 6845)
                    : c <= 6862)))
                : (c <= 6988 || (c < 7040
                  ? (c < 7019
                    ? (c >= 6992 && c <= 7001)
                    : c <= 7027)
                  : (c <= 7155 || (c < 7232
                    ? (c >= 7168 && c <= 7223)
                    : c <= 7241)))))
              : (c <= 7293 || (c < 7424
                ? (c < 7357
                  ? (c < 7312
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7354)
                  : (c <= 7359 || (c < 7380
                    ? (c >= 7376 && c <= 7378)
                    : c <= 7418)))
                : (c <= 7957 || (c < 8008
                  ? (c < 7968
                    ? (c >= 7960 && c <= 7965)
                    : c <= 8005)
                  : (c <= 8013 || (c < 8025
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8025)))))))))))
        : (c <= 8027 || (c < 11728
          ? (c < 8469
            ? (c < 8182
              ? (c < 8130
                ? (c < 8064
                  ? (c < 8031
                    ? c == 8029
                    : c <= 8061)
                  : (c <= 8116 || (c < 8126
                    ? (c >= 8118 && c <= 8124)
                    : c <= 8126)))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8140)
                    : c <= 8147)
                  : (c <= 8155 || (c < 8178
                    ? (c >= 8160 && c <= 8172)
                    : c <= 8180)))))
              : (c <= 8188 || (c < 8400
                ? (c < 8305
                  ? (c < 8276
                    ? (c >= 8255 && c <= 8256)
                    : c <= 8276)
                  : (c <= 8305 || (c < 8336
                    ? c == 8319
                    : c <= 8348)))
                : (c <= 8412 || (c < 8450
                  ? (c < 8421
                    ? c == 8417
                    : c <= 8432)
                  : (c <= 8450 || (c < 8458
                    ? c == 8455
                    : c <= 8467)))))))
            : (c <= 8469 || (c < 11520
              ? (c < 8508
                ? (c < 8486
                  ? (c < 8484
                    ? (c >= 8472 && c <= 8477)
                    : c <= 8484)
                  : (c <= 8486 || (c < 8490
                    ? c == 8488
                    : c <= 8505)))
                : (c <= 8511 || (c < 8544
                  ? (c < 8526
                    ? (c >= 8517 && c <= 8521)
                    : c <= 8526)
                  : (c <= 8584 || (c < 11499
                    ? (c >= 11264 && c <= 11492)
                    : c <= 11507)))))
              : (c <= 11557 || (c < 11680
                ? (c < 11568
                  ? (c < 11565
                    ? c == 11559
                    : c <= 11565)
                  : (c <= 11623 || (c < 11647
                    ? c == 11631
                    : c <= 11670)))
                : (c <= 11686 || (c < 11704
                  ? (c < 11696
                    ? (c >= 11688 && c <= 11694)
                    : c <= 11702)
                  : (c <= 11710 || (c < 11720
                    ? (c >= 11712 && c <= 11718)
                    : c <= 11726)))))))))
          : (c <= 11734 || (c < 42775
            ? (c < 12549
              ? (c < 12344
                ? (c < 12293
                  ? (c < 11744
                    ? (c >= 11736 && c <= 11742)
                    : c <= 11775)
                  : (c <= 12295 || (c < 12337
                    ? (c >= 12321 && c <= 12335)
                    : c <= 12341)))
                : (c <= 12348 || (c < 12445
                  ? (c < 12441
                    ? (c >= 12353 && c <= 12438)
                    : c <= 12442)
                  : (c <= 12447 || (c < 12540
                    ? (c >= 12449 && c <= 12538)
                    : c <= 12543)))))
              : (c <= 12591 || (c < 42192
                ? (c < 12784
                  ? (c < 12704
                    ? (c >= 12593 && c <= 12686)
                    : c <= 12735)
                  : (c <= 12799 || (c < 19968
                    ? (c >= 13312 && c <= 19903)
                    : c <= 42124)))
                : (c <= 42237 || (c < 42560
                  ? (c < 42512
                    ? (c >= 42240 && c <= 42508)
                    : c <= 42539)
                  : (c <= 42607 || (c < 42623
                    ? (c >= 42612 && c <= 42621)
                    : c <= 42737)))))))
            : (c <= 42783 || (c < 43259
              ? (c < 42994
                ? (c < 42960
                  ? (c < 42891
                    ? (c >= 42786 && c <= 42888)
                    : c <= 42954)
                  : (c <= 42961 || (c < 42965
                    ? c == 42963
                    : c <= 42969)))
                : (c <= 43047 || (c < 43136
                  ? (c < 43072
                    ? c == 43052
                    : c <= 43123)
                  : (c <= 43205 || (c < 43232
                    ? (c >= 43216 && c <= 43225)
                    : c <= 43255)))))
              : (c <= 43259 || (c < 43488
                ? (c < 43360
                  ? (c < 43312
                    ? (c >= 43261 && c <= 43309)
                    : c <= 43347)
                  : (c <= 43388 || (c < 43471
                    ? (c >= 43392 && c <= 43456)
                    : c <= 43481)))
                : (c <= 43518 || (c < 43600
                  ? (c < 43584
                    ? (c >= 43520 && c <= 43574)
                    : c <= 43597)
                  : (c <= 43609 || (c >= 43616 && c <= 43638)))))))))))))))
    : (c <= 43714 || (c < 71472
      ? (c < 67644
        ? (c < 65382
          ? (c < 64318
            ? (c < 44012
              ? (c < 43793
                ? (c < 43762
                  ? (c < 43744
                    ? (c >= 43739 && c <= 43741)
                    : c <= 43759)
                  : (c <= 43766 || (c < 43785
                    ? (c >= 43777 && c <= 43782)
                    : c <= 43790)))
                : (c <= 43798 || (c < 43824
                  ? (c < 43816
                    ? (c >= 43808 && c <= 43814)
                    : c <= 43822)
                  : (c <= 43866 || (c < 43888
                    ? (c >= 43868 && c <= 43881)
                    : c <= 44010)))))
              : (c <= 44013 || (c < 64112
                ? (c < 55216
                  ? (c < 44032
                    ? (c >= 44016 && c <= 44025)
                    : c <= 55203)
                  : (c <= 55238 || (c < 63744
                    ? (c >= 55243 && c <= 55291)
                    : c <= 64109)))
                : (c <= 64217 || (c < 64285
                  ? (c < 64275
                    ? (c >= 64256 && c <= 64262)
                    : c <= 64279)
                  : (c <= 64296 || (c < 64312
                    ? (c >= 64298 && c <= 64310)
                    : c <= 64316)))))))
            : (c <= 64318 || (c < 65101
              ? (c < 64848
                ? (c < 64326
                  ? (c < 64323
                    ? (c >= 64320 && c <= 64321)
                    : c <= 64324)
                  : (c <= 64433 || (c < 64612
                    ? (c >= 64467 && c <= 64605)
                    : c <= 64829)))
                : (c <= 64911 || (c < 65024
                  ? (c < 65008
                    ? (c >= 64914 && c <= 64967)
                    : c <= 65017)
                  : (c <= 65039 || (c < 65075
                    ? (c >= 65056 && c <= 65071)
                    : c <= 65076)))))
              : (c <= 65103 || (c < 65149
                ? (c < 65143
                  ? (c < 65139
                    ? c == 65137
                    : c <= 65139)
                  : (c <= 65143 || (c < 65147
                    ? c == 65145
                    : c <= 65147)))
                : (c <= 65149 || (c < 65313
                  ? (c < 65296
                    ? (c >= 65151 && c <= 65276)
                    : c <= 65305)
                  : (c <= 65338 || (c < 65345
                    ? c == 65343
                    : c <= 65370)))))))))
          : (c <= 65470 || (c < 66560
            ? (c < 65856
              ? (c < 65549
                ? (c < 65490
                  ? (c < 65482
                    ? (c >= 65474 && c <= 65479)
                    : c <= 65487)
                  : (c <= 65495 || (c < 65536
                    ? (c >= 65498 && c <= 65500)
                    : c <= 65547)))
                : (c <= 65574 || (c < 65599
                  ? (c < 65596
                    ? (c >= 65576 && c <= 65594)
                    : c <= 65597)
                  : (c <= 65613 || (c < 65664
                    ? (c >= 65616 && c <= 65629)
                    : c <= 65786)))))
              : (c <= 65908 || (c < 66349
                ? (c < 66208
                  ? (c < 66176
                    ? c == 66045
                    : c <= 66204)
                  : (c <= 66256 || (c < 66304
                    ? c == 66272
                    : c <= 66335)))
                : (c <= 66378 || (c < 66464
                  ? (c < 66432
                    ? (c >= 66384 && c <= 66426)
                    : c <= 66461)
                  : (c <= 66499 || (c < 66513
                    ? (c >= 66504 && c <= 66511)
                    : c <= 66517)))))))
            : (c <= 66717 || (c < 66995
              ? (c < 66928
                ? (c < 66776
                  ? (c < 66736
                    ? (c >= 66720 && c <= 66729)
                    : c <= 66771)
                  : (c <= 66811 || (c < 66864
                    ? (c >= 66816 && c <= 66855)
                    : c <= 66915)))
                : (c <= 66938 || (c < 66964
                  ? (c < 66956
                    ? (c >= 66940 && c <= 66954)
                    : c <= 66962)
                  : (c <= 66965 || (c < 66979
                    ? (c >= 66967 && c <= 66977)
                    : c <= 66993)))))
              : (c <= 67001 || (c < 67463
                ? (c < 67392
                  ? (c < 67072
                    ? (c >= 67003 && c <= 67004)
                    : c <= 67382)
                  : (c <= 67413 || (c < 67456
                    ? (c >= 67424 && c <= 67431)
                    : c <= 67461)))
                : (c <= 67504 || (c < 67592
                  ? (c < 67584
                    ? (c >= 67506 && c <= 67514)
                    : c <= 67589)
                  : (c <= 67592 || (c < 67639
                    ? (c >= 67594 && c <= 67637)
                    : c <= 67640)))))))))))
        : (c <= 67644 || (c < 69968
          ? (c < 68480
            ? (c < 68108
              ? (c < 67840
                ? (c < 67712
                  ? (c < 67680
                    ? (c >= 67647 && c <= 67669)
                    : c <= 67702)
                  : (c <= 67742 || (c < 67828
                    ? (c >= 67808 && c <= 67826)
                    : c <= 67829)))
                : (c <= 67861 || (c < 68030
                  ? (c < 67968
                    ? (c >= 67872 && c <= 67897)
                    : c <= 68023)
                  : (c <= 68031 || (c < 68101
                    ? (c >= 68096 && c <= 68099)
                    : c <= 68102)))))
              : (c <= 68115 || (c < 68224
                ? (c < 68152
                  ? (c < 68121
                    ? (c >= 68117 && c <= 68119)
                    : c <= 68149)
                  : (c <= 68154 || (c < 68192
                    ? c == 68159
                    : c <= 68220)))
                : (c <= 68252 || (c < 68352
                  ? (c < 68297
                    ? (c >= 68288 && c <= 68295)
                    : c <= 68326)
                  : (c <= 68405 || (c < 68448
                    ? (c >= 68416 && c <= 68437)
                    : c <= 68466)))))))
            : (c <= 68497 || (c < 69488
              ? (c < 69248
                ? (c < 68800
                  ? (c < 68736
                    ? (c >= 68608 && c <= 68680)
                    : c <= 68786)
                  : (c <= 68850 || (c < 68912
                    ? (c >= 68864 && c <= 68903)
                    : c <= 68921)))
                : (c <= 69289 || (c < 69376
                  ? (c < 69296
                    ? (c >= 69291 && c <= 69292)
                    : c <= 69297)
                  : (c <= 69404 || (c < 69424
                    ? c == 69415
                    : c <= 69456)))))
              : (c <= 69509 || (c < 69826
                ? (c < 69632
                  ? (c < 69600
                    ? (c >= 69552 && c <= 69572)
                    : c <= 69622)
                  : (c <= 69702 || (c < 69759
                    ? (c >= 69734 && c <= 69749)
                    : c <= 69818)))
                : (c <= 69826 || (c < 69888
                  ? (c < 69872
                    ? (c >= 69840 && c <= 69864)
                    : c <= 69881)
                  : (c <= 69940 || (c < 69956
                    ? (c >= 69942 && c <= 69951)
                    : c <= 69959)))))))))
          : (c <= 70003 || (c < 70471
            ? (c < 70287
              ? (c < 70144
                ? (c < 70089
                  ? (c < 70016
                    ? c == 70006
                    : c <= 70084)
                  : (c <= 70092 || (c < 70108
                    ? (c >= 70094 && c <= 70106)
                    : c <= 70108)))
                : (c <= 70161 || (c < 70272
                  ? (c < 70206
                    ? (c >= 70163 && c <= 70199)
                    : c <= 70206)
                  : (c <= 70278 || (c < 70282
                    ? c == 70280
                    : c <= 70285)))))
              : (c <= 70301 || (c < 70415
                ? (c < 70384
                  ? (c < 70320
                    ? (c >= 70303 && c <= 70312)
                    : c <= 70378)
                  : (c <= 70393 || (c < 70405
                    ? (c >= 70400 && c <= 70403)
                    : c <= 70412)))
                : (c <= 70416 || (c < 70450
                  ? (c < 70442
                    ? (c >= 70419 && c <= 70440)
                    : c <= 70448)
                  : (c <= 70451 || (c < 70459
                    ? (c >= 70453 && c <= 70457)
                    : c <= 70468)))))))
            : (c <= 70472 || (c < 70864
              ? (c < 70512
                ? (c < 70487
                  ? (c < 70480
                    ? (c >= 70475 && c <= 70477)
                    : c <= 70480)
                  : (c <= 70487 || (c < 70502
                    ? (c >= 70493 && c <= 70499)
                    : c <= 70508)))
                : (c <= 70516 || (c < 70750
                  ? (c < 70736
                    ? (c >= 70656 && c <= 70730)
                    : c <= 70745)
                  : (c <= 70753 || (c < 70855
                    ? (c >= 70784 && c <= 70853)
                    : c <= 70855)))))
              : (c <= 70873 || (c < 71248
                ? (c < 71128
                  ? (c < 71096
                    ? (c >= 71040 && c <= 71093)
                    : c <= 71104)
                  : (c <= 71133 || (c < 71236
                    ? (c >= 71168 && c <= 71232)
                    : c <= 71236)))
                : (c <= 71257 || (c < 71424
                  ? (c < 71360
                    ? (c >= 71296 && c <= 71352)
                    : c <= 71369)
                  : (c <= 71450 || (c >= 71453 && c <= 71467)))))))))))))
      : (c <= 71481 || (c < 119973
        ? (c < 82944
          ? (c < 72784
            ? (c < 72096
              ? (c < 71948
                ? (c < 71840
                  ? (c < 71680
                    ? (c >= 71488 && c <= 71494)
                    : c <= 71738)
                  : (c <= 71913 || (c < 71945
                    ? (c >= 71935 && c <= 71942)
                    : c <= 71945)))
                : (c <= 71955 || (c < 71991
                  ? (c < 71960
                    ? (c >= 71957 && c <= 71958)
                    : c <= 71989)
                  : (c <= 71992 || (c < 72016
                    ? (c >= 71995 && c <= 72003)
                    : c <= 72025)))))
              : (c <= 72103 || (c < 72272
                ? (c < 72163
                  ? (c < 72154
                    ? (c >= 72106 && c <= 72151)
                    : c <= 72161)
                  : (c <= 72164 || (c < 72263
                    ? (c >= 72192 && c <= 72254)
                    : c <= 72263)))
                : (c <= 72345 || (c < 72704
                  ? (c < 72368
                    ? c == 72349
                    : c <= 72440)
                  : (c <= 72712 || (c < 72760
                    ? (c >= 72714 && c <= 72758)
                    : c <= 72768)))))))
            : (c <= 72793 || (c < 73063
              ? (c < 72971
                ? (c < 72873
                  ? (c < 72850
                    ? (c >= 72818 && c <= 72847)
                    : c <= 72871)
                  : (c <= 72886 || (c < 72968
                    ? (c >= 72960 && c <= 72966)
                    : c <= 72969)))
                : (c <= 73014 || (c < 73023
                  ? (c < 73020
                    ? c == 73018
                    : c <= 73021)
                  : (c <= 73031 || (c < 73056
                    ? (c >= 73040 && c <= 73049)
                    : c <= 73061)))))
              : (c <= 73064 || (c < 73648
                ? (c < 73107
                  ? (c < 73104
                    ? (c >= 73066 && c <= 73102)
                    : c <= 73105)
                  : (c <= 73112 || (c < 73440
                    ? (c >= 73120 && c <= 73129)
                    : c <= 73462)))
                : (c <= 73648 || (c < 74880
                  ? (c < 74752
                    ? (c >= 73728 && c <= 74649)
                    : c <= 74862)
                  : (c <= 75075 || (c < 77824
                    ? (c >= 77712 && c <= 77808)
                    : c <= 78894)))))))))
          : (c <= 83526 || (c < 110581
            ? (c < 93053
              ? (c < 92880
                ? (c < 92768
                  ? (c < 92736
                    ? (c >= 92160 && c <= 92728)
                    : c <= 92766)
                  : (c <= 92777 || (c < 92864
                    ? (c >= 92784 && c <= 92862)
                    : c <= 92873)))
                : (c <= 92909 || (c < 92992
                  ? (c < 92928
                    ? (c >= 92912 && c <= 92916)
                    : c <= 92982)
                  : (c <= 92995 || (c < 93027
                    ? (c >= 93008 && c <= 93017)
                    : c <= 93047)))))
              : (c <= 93071 || (c < 94179
                ? (c < 94031
                  ? (c < 93952
                    ? (c >= 93760 && c <= 93823)
                    : c <= 94026)
                  : (c <= 94087 || (c < 94176
                    ? (c >= 94095 && c <= 94111)
                    : c <= 94177)))
                : (c <= 94180 || (c < 100352
                  ? (c < 94208
                    ? (c >= 94192 && c <= 94193)
                    : c <= 100343)
                  : (c <= 101589 || (c < 110576
                    ? (c >= 101632 && c <= 101640)
                    : c <= 110579)))))))
            : (c <= 110587 || (c < 118576
              ? (c < 113664
                ? (c < 110928
                  ? (c < 110592
                    ? (c >= 110589 && c <= 110590)
                    : c <= 110882)
                  : (c <= 110930 || (c < 110960
                    ? (c >= 110948 && c <= 110951)
                    : c <= 111355)))
                : (c <= 113770 || (c < 113808
                  ? (c < 113792
                    ? (c >= 113776 && c <= 113788)
                    : c <= 113800)
                  : (c <= 113817 || (c < 118528
                    ? (c >= 113821 && c <= 113822)
                    : c <= 118573)))))
              : (c <= 118598 || (c < 119362
                ? (c < 119163
                  ? (c < 119149
                    ? (c >= 119141 && c <= 119145)
                    : c <= 119154)
                  : (c <= 119170 || (c < 119210
                    ? (c >= 119173 && c <= 119179)
                    : c <= 119213)))
                : (c <= 119364 || (c < 119966
                  ? (c < 119894
                    ? (c >= 119808 && c <= 119892)
                    : c <= 119964)
                  : (c <= 119967 || c == 119970))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static inline bool sym_identifier_character_set_5(int32_t c) {
  return (c < 43616
    ? (c < 3782
      ? (c < 2748
        ? (c < 2045
          ? (c < 1015
            ? (c < 710
              ? (c < 181
                ? (c < '_'
                  ? (c < 'A'
                    ? (c >= '0' && c <= '9')
                    : c <= 'Z')
                  : (c <= '_' || (c < 170
                    ? (c >= 'a' && c <= 'z')
                    : c <= 170)))
                : (c <= 181 || (c < 192
                  ? (c < 186
                    ? c == 183
                    : c <= 186)
                  : (c <= 214 || (c < 248
                    ? (c >= 216 && c <= 246)
                    : c <= 705)))))
              : (c <= 721 || (c < 891
                ? (c < 750
                  ? (c < 748
                    ? (c >= 736 && c <= 740)
                    : c <= 748)
                  : (c <= 750 || (c < 886
                    ? (c >= 768 && c <= 884)
                    : c <= 887)))
                : (c <= 893 || (c < 908
                  ? (c < 902
                    ? c == 895
                    : c <= 906)
                  : (c <= 908 || (c < 931
                    ? (c >= 910 && c <= 929)
                    : c <= 1013)))))))
            : (c <= 1153 || (c < 1519
              ? (c < 1425
                ? (c < 1329
                  ? (c < 1162
                    ? (c >= 1155 && c <= 1159)
                    : c <= 1327)
                  : (c <= 1366 || (c < 1376
                    ? c == 1369
                    : c <= 1416)))
                : (c <= 1469 || (c < 1476
                  ? (c < 1473
                    ? c == 1471
                    : c <= 1474)
                  : (c <= 1477 || (c < 1488
                    ? c == 1479
                    : c <= 1514)))))
              : (c <= 1522 || (c < 1770
                ? (c < 1646
                  ? (c < 1568
                    ? (c >= 1552 && c <= 1562)
                    : c <= 1641)
                  : (c <= 1747 || (c < 1759
                    ? (c >= 1749 && c <= 1756)
                    : c <= 1768)))
                : (c <= 1788 || (c < 1869
                  ? (c < 1808
                    ? c == 1791
                    : c <= 1866)
                  : (c <= 1969 || (c < 2042
                    ? (c >= 1984 && c <= 2037)
                    : c <= 2042)))))))))
          : (c <= 2045 || (c < 2558
            ? (c < 2451
              ? (c < 2200
                ? (c < 2144
                  ? (c < 2112
                    ? (c >= 2048 && c <= 2093)
                    : c <= 2139)
                  : (c <= 2154 || (c < 2185
                    ? (c >= 2160 && c <= 2183)
                    : c <= 2190)))
                : (c <= 2273 || (c < 2417
                  ? (c < 2406
                    ? (c >= 2275 && c <= 2403)
                    : c <= 2415)
                  : (c <= 2435 || (c < 2447
                    ? (c >= 2437 && c <= 2444)
                    : c <= 2448)))))
              : (c <= 2472 || (c < 2507
                ? (c < 2486
                  ? (c < 2482
                    ? (c >= 2474 && c <= 2480)
                    : c <= 2482)
                  : (c <= 2489 || (c < 2503
                    ? (c >= 2492 && c <= 2500)
                    : c <= 2504)))
                : (c <= 2510 || (c < 2527
                  ? (c < 2524
                    ? c == 2519
                    : c <= 2525)
                  : (c <= 2531 || (c < 2556
                    ? (c >= 2534 && c <= 2545)
                    : c <= 2556)))))))
            : (c <= 2558 || (c < 2635
              ? (c < 2610
                ? (c < 2575
                  ? (c < 2565
                    ? (c >= 2561 && c <= 2563)
                    : c <= 2570)
                  : (c <= 2576 || (c < 2602
                    ? (c >= 2579 && c <= 2600)
                    : c <= 2608)))
                : (c <= 2611 || (c < 2620
                  ? (c < 2616
                    ? (c >= 2613 && c <= 2614)
                    : c <= 2617)
                  : (c <= 2620 || (c < 2631
                    ? (c >= 2622 && c <= 2626)
                    : c <= 2632)))))
              : (c <= 2637 || (c < 2693
                ? (c < 2654
                  ? (c < 2649
                    ? c == 2641
                    : c <= 2652)
                  : (c <= 2654 || (c < 2689
                    ? (c >= 2662 && c <= 2677)
                    : c <= 2691)))
                : (c <= 2701 || (c < 2730
                  ? (c < 2707
                    ? (c >= 2703 && c <= 2705)
                    : c <= 2728)
                  : (c <= 2736 || (c < 2741
                    ? (c >= 2738 && c <= 2739)
                    : c <= 2745)))))))))))
        : (c <= 2757 || (c < 3168
          ? (c < 2958
            ? (c < 2866
              ? (c < 2809
                ? (c < 2768
                  ? (c < 2763
                    ? (c >= 2759 && c <= 2761)
                    : c <= 2765)
                  : (c <= 2768 || (c < 2790
                    ? (c >= 2784 && c <= 2787)
                    : c <= 2799)))
                : (c <= 2815 || (c < 2831
                  ? (c < 2821
                    ? (c >= 2817 && c <= 2819)
                    : c <= 2828)
                  : (c <= 2832 || (c < 2858
                    ? (c >= 2835 && c <= 2856)
                    : c <= 2864)))))
              : (c <= 2867 || (c < 2908
                ? (c < 2887
                  ? (c < 2876
                    ? (c >= 2869 && c <= 2873)
                    : c <= 2884)
                  : (c <= 2888 || (c < 2901
                    ? (c >= 2891 && c <= 2893)
                    : c <= 2903)))
                : (c <= 2909 || (c < 2929
                  ? (c < 2918
                    ? (c >= 2911 && c <= 2915)
                    : c <= 2927)
                  : (c <= 2929 || (c < 2949
                    ? (c >= 2946 && c <= 2947)
                    : c <= 2954)))))))
            : (c <= 2960 || (c < 3031
              ? (c < 2984
                ? (c < 2972
                  ? (c < 2969
                    ? (c >= 2962 && c <= 2965)
                    : c <= 2970)
                  : (c <= 2972 || (c < 2979
                    ? (c >= 2974 && c <= 2975)
                    : c <= 2980)))
                : (c <= 2986 || (c < 3014
                  ? (c < 3006
                    ? (c >= 2990 && c <= 3001)
                    : c <= 3010)
                  : (c <= 3016 || (c < 3024
                    ? (c >= 3018 && c <= 3021)
                    : c <= 3024)))))
              : (c <= 3031 || (c < 3132
                ? (c < 3086
                  ? (c < 3072
                    ? (c >= 3046 && c <= 3055)
                    : c <= 3084)
                  : (c <= 3088 || (c < 3114
                    ? (c >= 3090 && c <= 3112)
                    : c <= 3129)))
                : (c <= 3140 || (c < 3157
                  ? (c < 3146
                    ? (c >= 3142 && c <= 3144)
                    : c <= 3149)
                  : (c <= 3158 || (c < 3165
                    ? (c >= 3160 && c <= 3162)
                    : c <= 3165)))))))))
          : (c <= 3171 || (c < 3450
            ? (c < 3293
              ? (c < 3242
                ? (c < 3205
                  ? (c < 3200
                    ? (c >= 3174 && c <= 3183)
                    : c <= 3203)
                  : (c <= 3212 || (c < 3218
                    ? (c >= 3214 && c <= 3216)
                    : c <= 3240)))
                : (c <= 3251 || (c < 3270
                  ? (c < 3260
                    ? (c >= 3253 && c <= 3257)
                    : c <= 3268)
                  : (c <= 3272 || (c < 3285
                    ? (c >= 3274 && c <= 3277)
                    : c <= 3286)))))
              : (c <= 3294 || (c < 3346
                ? (c < 3313
                  ? (c < 3302
                    ? (c >= 3296 && c <= 3299)
                    : c <= 3311)
                  : (c <= 3314 || (c < 3342
                    ? (c >= 3328 && c <= 3340)
                    : c <= 3344)))
                : (c <= 3396 || (c < 3412
                  ? (c < 3402
                    ? (c >= 3398 && c <= 3400)
                    : c <= 3406)
                  : (c <= 3415 || (c < 3430
                    ? (c >= 3423 && c <= 3427)
                    : c <= 3439)))))))
            : (c <= 3455 || (c < 3570
              ? (c < 3520
                ? (c < 3482
                  ? (c < 3461
                    ? (c >= 3457 && c <= 3459)
                    : c <= 3478)
                  : (c <= 3505 || (c < 3517
                    ? (c >= 3507 && c <= 3515)
                    : c <= 3517)))
                : (c <= 3526 || (c < 3542
                  ? (c < 3535
                    ? c == 3530
                    : c <= 3540)
                  : (c <= 3542 || (c < 3558
                    ? (c >= 3544 && c <= 3551)
                    : c <= 3567)))))
              : (c <= 3571 || (c < 3718
                ? (c < 3664
                  ? (c < 3648
                    ? (c >= 3585 && c <= 3642)
                    : c <= 3662)
                  : (c <= 3673 || (c < 3716
                    ? (c >= 3713 && c <= 3714)
                    : c <= 3716)))
                : (c <= 3722 || (c < 3751
                  ? (c < 3749
                    ? (c >= 3724 && c <= 3747)
                    : c <= 3749)
                  : (c <= 3773 || (c >= 3776 && c <= 3780)))))))))))))
      : (c <= 3782 || (c < 8025
        ? (c < 5888
          ? (c < 4688
            ? (c < 3953
              ? (c < 3872
                ? (c < 3804
                  ? (c < 3792
                    ? (c >= 3784 && c <= 3789)
                    : c <= 3801)
                  : (c <= 3807 || (c < 3864
                    ? c == 3840
                    : c <= 3865)))
                : (c <= 3881 || (c < 3897
                  ? (c < 3895
                    ? c == 3893
                    : c <= 3895)
                  : (c <= 3897 || (c < 3913
                    ? (c >= 3902 && c <= 3911)
                    : c <= 3948)))))
              : (c <= 3972 || (c < 4256
                ? (c < 4038
                  ? (c < 3993
                    ? (c >= 3974 && c <= 3991)
                    : c <= 4028)
                  : (c <= 4038 || (c < 4176
                    ? (c >= 4096 && c <= 4169)
                    : c <= 4253)))
                : (c <= 4293 || (c < 4304
                  ? (c < 4301
                    ? c == 4295
                    : c <= 4301)
                  : (c <= 4346 || (c < 4682
                    ? (c >= 4348 && c <= 4680)
                    : c <= 4685)))))))
            : (c <= 4694 || (c < 4882
              ? (c < 4786
                ? (c < 4704
                  ? (c < 4698
                    ? c == 4696
                    : c <= 4701)
                  : (c <= 4744 || (c < 4752
                    ? (c >= 4746 && c <= 4749)
                    : c <= 4784)))
                : (c <= 4789 || (c < 4802
                  ? (c < 4800
                    ? (c >= 4792 && c <= 4798)
                    : c <= 4800)
                  : (c <= 4805 || (c < 4824
                    ? (c >= 4808 && c <= 4822)
                    : c <= 4880)))))
              : (c <= 4885 || (c < 5112
                ? (c < 4969
                  ? (c < 4957
                    ? (c >= 4888 && c <= 4954)
                    : c <= 4959)
                  : (c <= 4977 || (c < 5024
                    ? (c >= 4992 && c <= 5007)
                    : c <= 5109)))
                : (c <= 5117 || (c < 5761
                  ? (c < 5743
                    ? (c >= 5121 && c <= 5740)
                    : c <= 5759)
                  : (c <= 5786 || (c < 5870
                    ? (c >= 5792 && c <= 5866)
                    : c <= 5880)))))))))
          : (c <= 5909 || (c < 6688
            ? (c < 6176
              ? (c < 6016
                ? (c < 5984
                  ? (c < 5952
                    ? (c >= 5919 && c <= 5940)
                    : c <= 5971)
                  : (c <= 5996 || (c < 6002
                    ? (c >= 5998 && c <= 6000)
                    : c <= 6003)))
                : (c <= 6099 || (c < 6112
                  ? (c < 6108
                    ? c == 6103
                    : c <= 6109)
                  : (c <= 6121 || (c < 6159
                    ? (c >= 6155 && c <= 6157)
                    : c <= 6169)))))
              : (c <= 6264 || (c < 6470
                ? (c < 6400
                  ? (c < 6320
                    ? (c >= 6272 && c <= 6314)
                    : c <= 6389)
                  : (c <= 6430 || (c < 6448
                    ? (c >= 6432 && c <= 6443)
                    : c <= 6459)))
                : (c <= 6509 || (c < 6576
                  ? (c < 6528
                    ? (c >= 6512 && c <= 6516)
                    : c <= 6571)
                  : (c <= 6601 || (c < 6656
                    ? (c >= 6608 && c <= 6618)
                    : c <= 6683)))))))
            : (c <= 6750 || (c < 7232
              ? (c < 6847
                ? (c < 6800
                  ? (c < 6783
                    ? (c >= 6752 && c <= 6780)
                    : c <= 6793)
                  : (c <= 6809 || (c < 6832
                    ? c == 6823
                    : c <= 6845)))
                : (c <= 6862 || (c < 7019
                  ? (c < 6992
                    ? (c >= 6912 && c <= 6988)
                    : c <= 7001)
                  : (c <= 7027 || (c < 7168
                    ? (c >= 7040 && c <= 7155)
                    : c <= 7223)))))
              : (c <= 7241 || (c < 7380
                ? (c < 7312
                  ? (c < 7296
                    ? (c >= 7245 && c <= 7293)
                    : c <= 7304)
                  : (c <= 7354 || (c < 7376
                    ? (c >= 7357 && c <= 7359)
                    : c <= 7378)))
                : (c <= 7418 || (c < 7968
                  ? (c < 7960
                    ? (c >= 7424 && c <= 7957)
                    : c <= 7965)
                  : (c <= 8005 || (c < 8016
                    ? (c >= 8008 && c <= 8013)
                    : c <= 8023)))))))))))
        : (c <= 8025 || (c < 11720
          ? (c < 8458
            ? (c < 8178
              ? (c < 8126
                ? (c < 8031
                  ? (c < 8029
                    ? c == 8027
                    : c <= 8029)
                  : (c <= 8061 || (c < 8118
                    ? (c >= 8064 && c <= 8116)
                    : c <= 8124)))
                : (c <= 8126 || (c < 8144
                  ? (c < 8134
                    ? (c >= 8130 && c <= 8132)
                    : c <= 8140)
                  : (c <= 8147 || (c < 8160
                    ? (c >= 8150 && c <= 8155)
                    : c <= 8172)))))
              : (c <= 8180 || (c < 8336
                ? (c < 8276
                  ? (c < 8255
                    ? (c >= 8182 && c <= 8188)
                    : c <= 8256)
                  : (c <= 8276 || (c < 8319
                    ? c == 8305
                    : c <= 8319)))
                : (c <= 8348 || (c < 8421
                  ? (c < 8417
                    ? (c >= 8400 && c <= 8412)
                    : c <= 8417)
                  : (c <= 8432 || (c < 8455
                    ? c == 8450
                    : c <= 8455)))))))
            : (c <= 8467 || (c < 11499
              ? (c < 8490
                ? (c < 8484
                  ? (c < 8472
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || (c < 8488
                    ? c == 8486
                    : c <= 8488)))
                : (c <= 8505 || (c < 8526
                  ? (c < 8517
                    ? (c >= 8508 && c <= 8511)
                    : c <= 8521)
                  : (c <= 8526 || (c < 11264
                    ? (c >= 8544 && c <= 8584)
                    : c <= 11492)))))
              : (c <= 11507 || (c < 11647
                ? (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || (c < 11631
                    ? (c >= 11568 && c <= 11623)
                    : c <= 11631)))
                : (c <= 11670 || (c < 11696
                  ? (c < 11688
                    ? (c >= 11680 && c <= 11686)
                    : c <= 11694)
                  : (c <= 11702 || (c < 11712
                    ? (c >= 11704 && c <= 11710)
                    : c <= 11718)))))))))
          : (c <= 11726 || (c < 42623
            ? (c < 12540
              ? (c < 12337
                ? (c < 11744
                  ? (c < 11736
                    ? (c >= 11728 && c <= 11734)
                    : c <= 11742)
                  : (c <= 11775 || (c < 12321
                    ? (c >= 12293 && c <= 12295)
                    : c <= 12335)))
                : (c <= 12341 || (c < 12441
                  ? (c < 12353
                    ? (c >= 12344 && c <= 12348)
                    : c <= 12438)
                  : (c <= 12442 || (c < 12449
                    ? (c >= 12445 && c <= 12447)
                    : c <= 12538)))))
              : (c <= 12543 || (c < 19968
                ? (c < 12704
                  ? (c < 12593
                    ? (c >= 12549 && c <= 12591)
                    : c <= 12686)
                  : (c <= 12735 || (c < 13312
                    ? (c >= 12784 && c <= 12799)
                    : c <= 19903)))
                : (c <= 42124 || (c < 42512
                  ? (c < 42240
                    ? (c >= 42192 && c <= 42237)
                    : c <= 42508)
                  : (c <= 42539 || (c < 42612
                    ? (c >= 42560 && c <= 42607)
                    : c <= 42621)))))))
            : (c <= 42737 || (c < 43232
              ? (c < 42965
                ? (c < 42891
                  ? (c < 42786
                    ? (c >= 42775 && c <= 42783)
                    : c <= 42888)
                  : (c <= 42954 || (c < 42963
                    ? (c >= 42960 && c <= 42961)
                    : c <= 42963)))
                : (c <= 42969 || (c < 43072
                  ? (c < 43052
                    ? (c >= 42994 && c <= 43047)
                    : c <= 43052)
                  : (c <= 43123 || (c < 43216
                    ? (c >= 43136 && c <= 43205)
                    : c <= 43225)))))
              : (c <= 43255 || (c < 43471
                ? (c < 43312
                  ? (c < 43261
                    ? c == 43259
                    : c <= 43309)
                  : (c <= 43347 || (c < 43392
                    ? (c >= 43360 && c <= 43388)
                    : c <= 43456)))
                : (c <= 43481 || (c < 43584
                  ? (c < 43520
                    ? (c >= 43488 && c <= 43518)
                    : c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))))))))))))))
    : (c <= 43638 || (c < 71453
      ? (c < 67639
        ? (c < 65345
          ? (c < 64312
            ? (c < 43888
              ? (c < 43785
                ? (c < 43744
                  ? (c < 43739
                    ? (c >= 43642 && c <= 43714)
                    : c <= 43741)
                  : (c <= 43759 || (c < 43777
                    ? (c >= 43762 && c <= 43766)
                    : c <= 43782)))
                : (c <= 43790 || (c < 43816
                  ? (c < 43808
                    ? (c >= 43793 && c <= 43798)
                    : c <= 43814)
                  : (c <= 43822 || (c < 43868
                    ? (c >= 43824 && c <= 43866)
                    : c <= 43881)))))
              : (c <= 44010 || (c < 63744
                ? (c < 44032
                  ? (c < 44016
                    ? (c >= 44012 && c <= 44013)
                    : c <= 44025)
                  : (c <= 55203 || (c < 55243
                    ? (c >= 55216 && c <= 55238)
                    : c <= 55291)))
                : (c <= 64109 || (c < 64275
                  ? (c < 64256
                    ? (c >= 64112 && c <= 64217)
                    : c <= 64262)
                  : (c <= 64279 || (c < 64298
                    ? (c >= 64285 && c <= 64296)
                    : c <= 64310)))))))
            : (c <= 64316 || (c < 65075
              ? (c < 64612
                ? (c < 64323
                  ? (c < 64320
                    ? c == 64318
                    : c <= 64321)
                  : (c <= 64324 || (c < 64467
                    ? (c >= 64326 && c <= 64433)
                    : c <= 64605)))
                : (c <= 64829 || (c < 65008
                  ? (c < 64914
                    ? (c >= 64848 && c <= 64911)
                    : c <= 64967)
                  : (c <= 65017 || (c < 65056
                    ? (c >= 65024 && c <= 65039)
                    : c <= 65071)))))
              : (c <= 65076 || (c < 65147
                ? (c < 65139
                  ? (c < 65137
                    ? (c >= 65101 && c <= 65103)
                    : c <= 65137)
                  : (c <= 65139 || (c < 65145
                    ? c == 65143
                    : c <= 65145)))
                : (c <= 65147 || (c < 65296
                  ? (c < 65151
                    ? c == 65149
                    : c <= 65276)
                  : (c <= 65305 || (c < 65343
                    ? (c >= 65313 && c <= 65338)
                    : c <= 65343)))))))))
          : (c <= 65370 || (c < 66513
            ? (c < 65664
              ? (c < 65536
                ? (c < 65482
                  ? (c < 65474
                    ? (c >= 65382 && c <= 65470)
                    : c <= 65479)
                  : (c <= 65487 || (c < 65498
                    ? (c >= 65490 && c <= 65495)
                    : c <= 65500)))
                : (c <= 65547 || (c < 65596
                  ? (c < 65576
                    ? (c >= 65549 && c <= 65574)
                    : c <= 65594)
                  : (c <= 65597 || (c < 65616
                    ? (c >= 65599 && c <= 65613)
                    : c <= 65629)))))
              : (c <= 65786 || (c < 66304
                ? (c < 66176
                  ? (c < 66045
                    ? (c >= 65856 && c <= 65908)
                    : c <= 66045)
                  : (c <= 66204 || (c < 66272
                    ? (c >= 66208 && c <= 66256)
                    : c <= 66272)))
                : (c <= 66335 || (c < 66432
                  ? (c < 66384
                    ? (c >= 66349 && c <= 66378)
                    : c <= 66426)
                  : (c <= 66461 || (c < 66504
                    ? (c >= 66464 && c <= 66499)
                    : c <= 66511)))))))
            : (c <= 66517 || (c < 66979
              ? (c < 66864
                ? (c < 66736
                  ? (c < 66720
                    ? (c >= 66560 && c <= 66717)
                    : c <= 66729)
                  : (c <= 66771 || (c < 66816
                    ? (c >= 66776 && c <= 66811)
                    : c <= 66855)))
                : (c <= 66915 || (c < 66956
                  ? (c < 66940
                    ? (c >= 66928 && c <= 66938)
                    : c <= 66954)
                  : (c <= 66962 || (c < 66967
                    ? (c >= 66964 && c <= 66965)
                    : c <= 66977)))))
              : (c <= 66993 || (c < 67456
                ? (c < 67072
                  ? (c < 67003
                    ? (c >= 66995 && c <= 67001)
                    : c <= 67004)
                  : (c <= 67382 || (c < 67424
                    ? (c >= 67392 && c <= 67413)
                    : c <= 67431)))
                : (c <= 67461 || (c < 67584
                  ? (c < 67506
                    ? (c >= 67463 && c <= 67504)
                    : c <= 67514)
                  : (c <= 67589 || (c < 67594
                    ? c == 67592
                    : c <= 67637)))))))))))
        : (c <= 67640 || (c < 69956
          ? (c < 68448
            ? (c < 68101
              ? (c < 67828
                ? (c < 67680
                  ? (c < 67647
                    ? c == 67644
                    : c <= 67669)
                  : (c <= 67702 || (c < 67808
                    ? (c >= 67712 && c <= 67742)
                    : c <= 67826)))
                : (c <= 67829 || (c < 67968
                  ? (c < 67872
                    ? (c >= 67840 && c <= 67861)
                    : c <= 67897)
                  : (c <= 68023 || (c < 68096
                    ? (c >= 68030 && c <= 68031)
                    : c <= 68099)))))
              : (c <= 68102 || (c < 68192
                ? (c < 68121
                  ? (c < 68117
                    ? (c >= 68108 && c <= 68115)
                    : c <= 68119)
                  : (c <= 68149 || (c < 68159
                    ? (c >= 68152 && c <= 68154)
                    : c <= 68159)))
                : (c <= 68220 || (c < 68297
                  ? (c < 68288
                    ? (c >= 68224 && c <= 68252)
                    : c <= 68295)
                  : (c <= 68326 || (c < 68416
                    ? (c >= 68352 && c <= 68405)
                    : c <= 68437)))))))
            : (c <= 68466 || (c < 69424
              ? (c < 68912
                ? (c < 68736
                  ? (c < 68608
                    ? (c >= 68480 && c <= 68497)
                    : c <= 68680)
                  : (c <= 68786 || (c < 68864
                    ? (c >= 68800 && c <= 68850)
                    : c <= 68903)))
                : (c <= 68921 || (c < 69296
                  ? (c < 69291
                    ? (c >= 69248 && c <= 69289)
                    : c <= 69292)
                  : (c <= 69297 || (c < 69415
                    ? (c >= 69376 && c <= 69404)
                    : c <= 69415)))))
              : (c <= 69456 || (c < 69759
                ? (c < 69600
                  ? (c < 69552
                    ? (c >= 69488 && c <= 69509)
                    : c <= 69572)
                  : (c <= 69622 || (c < 69734
                    ? (c >= 69632 && c <= 69702)
                    : c <= 69749)))
                : (c <= 69818 || (c < 69872
                  ? (c < 69840
                    ? c == 69826
                    : c <= 69864)
                  : (c <= 69881 || (c < 69942
                    ? (c >= 69888 && c <= 69940)
                    : c <= 69951)))))))))
          : (c <= 69959 || (c < 70459
            ? (c < 70282
              ? (c < 70108
                ? (c < 70016
                  ? (c < 70006
                    ? (c >= 69968 && c <= 70003)
                    : c <= 70006)
                  : (c <= 70084 || (c < 70094
                    ? (c >= 70089 && c <= 70092)
                    : c <= 70106)))
                : (c <= 70108 || (c < 70206
                  ? (c < 70163
                    ? (c >= 70144 && c <= 70161)
                    : c <= 70199)
                  : (c <= 70206 || (c < 70280
                    ? (c >= 70272 && c <= 70278)
                    : c <= 70280)))))
              : (c <= 70285 || (c < 70405
                ? (c < 70320
                  ? (c < 70303
                    ? (c >= 70287 && c <= 70301)
                    : c <= 70312)
                  : (c <= 70378 || (c < 70400
                    ? (c >= 70384 && c <= 70393)
                    : c <= 70403)))
                : (c <= 70412 || (c < 70442
                  ? (c < 70419
                    ? (c >= 70415 && c <= 70416)
                    : c <= 70440)
                  : (c <= 70448 || (c < 70453
                    ? (c >= 70450 && c <= 70451)
                    : c <= 70457)))))))
            : (c <= 70468 || (c < 70855
              ? (c < 70502
                ? (c < 70480
                  ? (c < 70475
                    ? (c >= 70471 && c <= 70472)
                    : c <= 70477)
                  : (c <= 70480 || (c < 70493
                    ? c == 70487
                    : c <= 70499)))
                : (c <= 70508 || (c < 70736
                  ? (c < 70656
                    ? (c >= 70512 && c <= 70516)
                    : c <= 70730)
                  : (c <= 70745 || (c < 70784
                    ? (c >= 70750 && c <= 70753)
                    : c <= 70853)))))
              : (c <= 70855 || (c < 71236
                ? (c < 71096
                  ? (c < 71040
                    ? (c >= 70864 && c <= 70873)
                    : c <= 71093)
                  : (c <= 71104 || (c < 71168
                    ? (c >= 71128 && c <= 71133)
                    : c <= 71232)))
                : (c <= 71236 || (c < 71360
                  ? (c < 71296
                    ? (c >= 71248 && c <= 71257)
                    : c <= 71352)
                  : (c <= 71369 || (c >= 71424 && c <= 71450)))))))))))))
      : (c <= 71467 || (c < 119973
        ? (c < 77824
          ? (c < 72760
            ? (c < 72016
              ? (c < 71945
                ? (c < 71680
                  ? (c < 71488
                    ? (c >= 71472 && c <= 71481)
                    : c <= 71494)
                  : (c <= 71738 || (c < 71935
                    ? (c >= 71840 && c <= 71913)
                    : c <= 71942)))
                : (c <= 71945 || (c < 71960
                  ? (c < 71957
                    ? (c >= 71948 && c <= 71955)
                    : c <= 71958)
                  : (c <= 71989 || (c < 71995
                    ? (c >= 71991 && c <= 71992)
                    : c <= 72003)))))
              : (c <= 72025 || (c < 72263
                ? (c < 72154
                  ? (c < 72106
                    ? (c >= 72096 && c <= 72103)
                    : c <= 72151)
                  : (c <= 72161 || (c < 72192
                    ? (c >= 72163 && c <= 72164)
                    : c <= 72254)))
                : (c <= 72263 || (c < 72368
                  ? (c < 72349
                    ? (c >= 72272 && c <= 72345)
                    : c <= 72349)
                  : (c <= 72440 || (c < 72714
                    ? (c >= 72704 && c <= 72712)
                    : c <= 72758)))))))
            : (c <= 72768 || (c < 73056
              ? (c < 72968
                ? (c < 72850
                  ? (c < 72818
                    ? (c >= 72784 && c <= 72793)
                    : c <= 72847)
                  : (c <= 72871 || (c < 72960
                    ? (c >= 72873 && c <= 72886)
                    : c <= 72966)))
                : (c <= 72969 || (c < 73020
                  ? (c < 73018
                    ? (c >= 72971 && c <= 73014)
                    : c <= 73018)
                  : (c <= 73021 || (c < 73040
                    ? (c >= 73023 && c <= 73031)
                    : c <= 73049)))))
              : (c <= 73061 || (c < 73440
                ? (c < 73104
                  ? (c < 73066
                    ? (c >= 73063 && c <= 73064)
                    : c <= 73102)
                  : (c <= 73105 || (c < 73120
                    ? (c >= 73107 && c <= 73112)
                    : c <= 73129)))
                : (c <= 73462 || (c < 74752
                  ? (c < 73728
                    ? c == 73648
                    : c <= 74649)
                  : (c <= 74862 || (c < 77712
                    ? (c >= 74880 && c <= 75075)
                    : c <= 77808)))))))))
          : (c <= 78894 || (c < 110576
            ? (c < 93027
              ? (c < 92864
                ? (c < 92736
                  ? (c < 92160
                    ? (c >= 82944 && c <= 83526)
                    : c <= 92728)
                  : (c <= 92766 || (c < 92784
                    ? (c >= 92768 && c <= 92777)
                    : c <= 92862)))
                : (c <= 92873 || (c < 92928
                  ? (c < 92912
                    ? (c >= 92880 && c <= 92909)
                    : c <= 92916)
                  : (c <= 92982 || (c < 93008
                    ? (c >= 92992 && c <= 92995)
                    : c <= 93017)))))
              : (c <= 93047 || (c < 94176
                ? (c < 93952
                  ? (c < 93760
                    ? (c >= 93053 && c <= 93071)
                    : c <= 93823)
                  : (c <= 94026 || (c < 94095
                    ? (c >= 94031 && c <= 94087)
                    : c <= 94111)))
                : (c <= 94177 || (c < 94208
                  ? (c < 94192
                    ? (c >= 94179 && c <= 94180)
                    : c <= 94193)
                  : (c <= 100343 || (c < 101632
                    ? (c >= 100352 && c <= 101589)
                    : c <= 101640)))))))
            : (c <= 110579 || (c < 118528
              ? (c < 110960
                ? (c < 110592
                  ? (c < 110589
                    ? (c >= 110581 && c <= 110587)
                    : c <= 110590)
                  : (c <= 110882 || (c < 110948
                    ? (c >= 110928 && c <= 110930)
                    : c <= 110951)))
                : (c <= 111355 || (c < 113792
                  ? (c < 113776
                    ? (c >= 113664 && c <= 113770)
                    : c <= 113788)
                  : (c <= 113800 || (c < 113821
                    ? (c >= 113808 && c <= 113817)
                    : c <= 113822)))))
              : (c <= 118573 || (c < 119210
                ? (c < 119149
                  ? (c < 119141
                    ? (c >= 118576 && c <= 118598)
                    : c <= 119145)
                  : (c <= 119154 || (c < 119173
                    ? (c >= 119163 && c <= 119170)
                    : c <= 119179)))
                : (c <= 119213 || (c < 119894
                  ? (c < 119808
                    ? (c >= 119362 && c <= 119364)
                    : c <= 119892)
                  : (c <= 119964 || (c < 119970
                    ? (c >= 119966 && c <= 119967)
                    : c <= 119970)))))))))))
        : (c <= 119974 || (c < 124912
          ? (c < 120746
            ? (c < 120134
              ? (c < 120071
                ? (c < 119995
                  ? (c < 119982
                    ? (c >= 119977 && c <= 119980)
                    : c <= 119993)
                  : (c <= 119995 || (c < 120005
                    ? (c >= 119997 && c <= 120003)
                    : c <= 120069)))
                : (c <= 120074 || (c < 120094
                  ? (c < 120086
                    ? (c >= 120077 && c <= 120084)
                    : c <= 120092)
                  : (c <= 120121 || (c < 120128
                    ? (c >= 120123 && c <= 120126)
                    : c <= 120132)))))
              : (c <= 120134 || (c < 120572
                ? (c < 120488
                  ? (c < 120146
                    ? (c >= 120138 && c <= 120144)
                    : c <= 120485)
                  : (c <= 120512 || (c < 120540
                    ? (c >= 120514 && c <= 120538)
                    : c <= 120570)))
                : (c <= 120596 || (c < 120656
                  ? (c < 120630
                    ? (c >= 120598 && c <= 120628)
                    : c <= 120654)
                  : (c <= 120686 || (c < 120714
                    ? (c >= 120688 && c <= 120712)
                    : c <= 120744)))))))
            : (c <= 120770 || (c < 122907
              ? (c < 121476
                ? (c < 121344
                  ? (c < 120782
                    ? (c >= 120772 && c <= 120779)
                    : c <= 120831)
                  : (c <= 121398 || (c < 121461
                    ? (c >= 121403 && c <= 121452)
                    : c <= 121461)))
                : (c <= 121476 || (c < 122624
                  ? (c < 121505
                    ? (c >= 121499 && c <= 121503)
                    : c <= 121519)
                  : (c <= 122654 || (c < 122888
                    ? (c >= 122880 && c <= 122886)
                    : c <= 122904)))))
              : (c <= 122913 || (c < 123214
                ? (c < 123136
                  ? (c < 122918
                    ? (c >= 122915 && c <= 122916)
                    : c <= 122922)
                  : (c <= 123180 || (c < 123200
                    ? (c >= 123184 && c <= 123197)
                    : c <= 123209)))
                : (c <= 123214 || (c < 124896
                  ? (c < 123584
                    ? (c >= 123536 && c <= 123566)
                    : c <= 123641)
                  : (c <= 124902 || (c < 124909
                    ? (c >= 124904 && c <= 124907)
                    : c <= 124910)))))))))
          : (c <= 124926 || (c < 126557
            ? (c < 126521
              ? (c < 126469
                ? (c < 125184
                  ? (c < 125136
                    ? (c >= 124928 && c <= 125124)
                    : c <= 125142)
                  : (c <= 125259 || (c < 126464
                    ? (c >= 125264 && c <= 125273)
                    : c <= 126467)))
                : (c <= 126495 || (c < 126503
                  ? (c < 126500
                    ? (c >= 126497 && c <= 126498)
                    : c <= 126500)
                  : (c <= 126503 || (c < 126516
                    ? (c >= 126505 && c <= 126514)
                    : c <= 126519)))))
              : (c <= 126521 || (c < 126541
                ? (c < 126535
                  ? (c < 126530
                    ? c == 126523
                    : c <= 126530)
                  : (c <= 126535 || (c < 126539
                    ? c == 126537
                    : c <= 126539)))
                : (c <= 126543 || (c < 126551
                  ? (c < 126548
                    ? (c >= 126545 && c <= 126546)
                    : c <= 126548)
                  : (c <= 126551 || (c < 126555
                    ? c == 126553
                    : c <= 126555)))))))
            : (c <= 126557 || (c < 126629
              ? (c < 126580
                ? (c < 126564
                  ? (c < 126561
                    ? c == 126559
                    : c <= 126562)
                  : (c <= 126564 || (c < 126572
                    ? (c >= 126567 && c <= 126570)
                    : c <= 126578)))
                : (c <= 126583 || (c < 126592
                  ? (c < 126590
                    ? (c >= 126585 && c <= 126588)
                    : c <= 126590)
                  : (c <= 126601 || (c < 126625
                    ? (c >= 126603 && c <= 126619)
                    : c <= 126627)))))
              : (c <= 126633 || (c < 178208
                ? (c < 131072
                  ? (c < 130032
                    ? (c >= 126635 && c <= 126651)
                    : c <= 130041)
                  : (c <= 173791 || (c < 177984
                    ? (c >= 173824 && c <= 177976)
                    : c <= 178205)))
                : (c <= 183969 || (c < 196608
                  ? (c < 194560
                    ? (c >= 183984 && c <= 191456)
                    : c <= 195101)
                  : (c <= 201546 || (c >= 917760 && c <= 917999)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(153);
      if (lookahead == '$') ADVANCE(133);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '\'') ADVANCE(182);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(20);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'q') ADVANCE(78);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == 65279) ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(49)
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(80);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1)
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(2);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(56);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(2);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(55);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(153);
      if (lookahead == '$') ADVANCE(132);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '\'') ADVANCE(182);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'q') ADVANCE(78);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(4)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(80);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '$') ADVANCE(132);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '\'') ADVANCE(182);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'q') ADVANCE(78);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(5)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(80);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(6)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(7)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(88);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(8)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(88);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(9)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(10)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(89);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(11)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(121);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '$') ADVANCE(132);
      if (lookahead == '&') ADVANCE(93);
      if (lookahead == '\'') ADVANCE(182);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'q') ADVANCE(78);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(12)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(80);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(121);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '$') ADVANCE(132);
      if (lookahead == '&') ADVANCE(93);
      if (lookahead == '\'') ADVANCE(182);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '+') ADVANCE(106);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(88);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'q') ADVANCE(78);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(13)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(80);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(121);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(14)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(121);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '.') ADVANCE(88);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(15)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(54);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(108);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(30);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(17)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(32);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(108);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(29);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(135);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(18)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '$') ADVANCE(23);
      if (lookahead == '\\') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(175);
      if (lookahead != 0) ADVANCE(176);
      END_STATE();
    case 20:
      if (lookahead == '"') ADVANCE(59);
      if (lookahead == '$') ADVANCE(173);
      if (lookahead == '&') ADVANCE(48);
      if (lookahead == '\'') ADVANCE(58);
      if (lookahead == '?') ADVANCE(60);
      if (lookahead == 'U') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'b') ADVANCE(63);
      if (lookahead == 'f') ADVANCE(64);
      if (lookahead == 'n') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'v') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      END_STATE();
    case 21:
      if (lookahead == '"') ADVANCE(59);
      if (lookahead == '&') ADVANCE(48);
      if (lookahead == '\'') ADVANCE(58);
      if (lookahead == '?') ADVANCE(60);
      if (lookahead == 'U') ADVANCE(47);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == 'a') ADVANCE(62);
      if (lookahead == 'b') ADVANCE(63);
      if (lookahead == 'f') ADVANCE(64);
      if (lookahead == 'n') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == 'u') ADVANCE(42);
      if (lookahead == 'v') ADVANCE(68);
      if (lookahead == 'x') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      END_STATE();
    case 22:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '\\') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(165);
      if (lookahead != 0) ADVANCE(166);
      END_STATE();
    case 23:
      if (lookahead == '"') ADVANCE(178);
      if (lookahead == '(') ADVANCE(167);
      if (lookahead != 0) ADVANCE(177);
      END_STATE();
    case 24:
      if (lookahead == '$') ADVANCE(27);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(169);
      if (lookahead != 0) ADVANCE(170);
      END_STATE();
    case 25:
      if (lookahead == '\'') ADVANCE(180);
      END_STATE();
    case 26:
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(26)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 27:
      if (lookahead == '(') ADVANCE(167);
      if (lookahead == '`') ADVANCE(172);
      if (lookahead != 0) ADVANCE(171);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(92);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 30:
      if (lookahead == '.') ADVANCE(90);
      END_STATE();
    case 31:
      if (lookahead == ';') ADVANCE(57);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(31);
      END_STATE();
    case 32:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 33:
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 48:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(31);
      END_STATE();
    case 49:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(122);
      if (lookahead == '"') ADVANCE(164);
      if (lookahead == '#') ADVANCE(153);
      if (lookahead == '$') ADVANCE(133);
      if (lookahead == '%') ADVANCE(142);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '\'') ADVANCE(182);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '+') ADVANCE(107);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(102);
      if (lookahead == '.') ADVANCE(87);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '<') ADVANCE(111);
      if (lookahead == '=') ADVANCE(136);
      if (lookahead == '>') ADVANCE(115);
      if (lookahead == '?') ADVANCE(128);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == '\\') ADVANCE(20);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '^') ADVANCE(144);
      if (lookahead == '`') ADVANCE(154);
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 'q') ADVANCE(78);
      if (lookahead == 'r') ADVANCE(76);
      if (lookahead == 'x') ADVANCE(77);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(97);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(149);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(49)
      if (sym_identifier_character_set_1(lookahead)) ADVANCE(80);
      END_STATE();
    case 50:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(121);
      if (lookahead == '"') ADVANCE(161);
      if (lookahead == '#') ADVANCE(16);
      if (lookahead == '\'') ADVANCE(181);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '`') ADVANCE(157);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == 65279) ADVANCE(53);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(51)
      if (sym_identifier_character_set_2(lookahead)) ADVANCE(80);
      END_STATE();
    case 51:
      if (eof) ADVANCE(52);
      if (lookahead == '!') ADVANCE(121);
      if (lookahead == '\'') ADVANCE(181);
      if (lookahead == '(') ADVANCE(124);
      if (lookahead == ')') ADVANCE(125);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == ',') ADVANCE(129);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '.') ADVANCE(86);
      if (lookahead == ':') ADVANCE(131);
      if (lookahead == ';') ADVANCE(130);
      if (lookahead == '=') ADVANCE(33);
      if (lookahead == '@') ADVANCE(151);
      if (lookahead == '[') ADVANCE(126);
      if (lookahead == ']') ADVANCE(127);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '}') ADVANCE(82);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(51)
      if (sym_identifier_character_set_3(lookahead)) ADVANCE(80);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym__bom);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_POUND_BANG);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_shebang_token1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(3);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_htmlentity_token1);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_BSLASH_SQUOTE);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BSLASH_DQUOTE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_BSLASH_QMARK);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_BSLASH_BSLASH);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_BSLASHa);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_BSLASHf);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_BSLASHn);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_BSLASHr);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_BSLASHt);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_BSLASHv);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token1);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token2);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token2);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token2);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(71);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token3);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token4);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(174);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == 'q') ADVANCE(79);
      if (sym_identifier_character_set_4(lookahead)) ADVANCE(80);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(158);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(80);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(162);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(80);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '{') ADVANCE(81);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(80);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '{') ADVANCE(179);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier);
      if (sym_identifier_character_set_5(lookahead)) ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_q_LBRACE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(91);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(28);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(96);
      if (lookahead == '=') ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(98);
      if (lookahead == '|') ADVANCE(99);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(110);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(110);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(113);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(116);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(117);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(') ADVANCE(167);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(145);
      if (lookahead == '^') ADVANCE(146);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_CARET_CARET);
      if (lookahead == '=') ADVANCE(147);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_CARET_CARET_EQ);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '=') ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_raw_string_token1);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_raw_string_token2);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_raw_string_token2);
      if (lookahead == 'c' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(156);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_r_DQUOTE);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_raw_string_token3);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(159);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_raw_string_token4);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_raw_string_token4);
      if (lookahead == 'c' ||
          lookahead == 'd' ||
          lookahead == 'w') ADVANCE(160);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_x_DQUOTE);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_hex_string_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(163);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(aux_sym_quoted_string_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(aux_sym_quoted_string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_i_BQUOTE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_interpolated_raw_string_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_interpolated_raw_string_token1);
      if (lookahead != 0 &&
          lookahead != '$' &&
          lookahead != '`') ADVANCE(170);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_interpolated_raw_string_token2);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_DOLLAR_BQUOTE);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_interpolated_escape);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_i_DQUOTE);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_interpolated_quoted_string_token1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) ADVANCE(175);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_interpolated_quoted_string_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\') ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_interpolated_quoted_string_token2);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_iq_LBRACE);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym_char_literal_token1);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(25);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'C') ADVANCE(1);
      if (lookahead == 'D') ADVANCE(2);
      if (lookahead == 'O') ADVANCE(3);
      if (lookahead == 'S') ADVANCE(4);
      if (lookahead == 'W') ADVANCE(5);
      if (lookahead == '_') ADVANCE(6);
      if (lookahead == 'a') ADVANCE(7);
      if (lookahead == 'b') ADVANCE(8);
      if (lookahead == 'c') ADVANCE(9);
      if (lookahead == 'd') ADVANCE(10);
      if (lookahead == 'e') ADVANCE(11);
      if (lookahead == 'f') ADVANCE(12);
      if (lookahead == 'g') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(14);
      if (lookahead == 'l') ADVANCE(15);
      if (lookahead == 'm') ADVANCE(16);
      if (lookahead == 'n') ADVANCE(17);
      if (lookahead == 'o') ADVANCE(18);
      if (lookahead == 'p') ADVANCE(19);
      if (lookahead == 'r') ADVANCE(20);
      if (lookahead == 's') ADVANCE(21);
      if (lookahead == 't') ADVANCE(22);
      if (lookahead == 'u') ADVANCE(23);
      if (lookahead == 'v') ADVANCE(24);
      if (lookahead == 'w') ADVANCE(25);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8232 ||
          lookahead == 8233) SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym_C);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_D);
      END_STATE();
    case 3:
      if (lookahead == 'b') ADVANCE(26);
      END_STATE();
    case 4:
      if (lookahead == 'y') ADVANCE(27);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == '_') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'b') ADVANCE(30);
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 's') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 8:
      if (lookahead == 'o') ADVANCE(34);
      if (lookahead == 'r') ADVANCE(35);
      if (lookahead == 'y') ADVANCE(36);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'd') ADVANCE(38);
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'h') ADVANCE(41);
      if (lookahead == 'l') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 10:
      if (lookahead == 'c') ADVANCE(46);
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'o') ADVANCE(48);
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(50);
      if (lookahead == 'n') ADVANCE(51);
      if (lookahead == 'x') ADVANCE(52);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'i') ADVANCE(54);
      if (lookahead == 'l') ADVANCE(55);
      if (lookahead == 'o') ADVANCE(56);
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 13:
      if (lookahead == 'o') ADVANCE(58);
      END_STATE();
    case 14:
      if (lookahead == 'd') ADVANCE(59);
      if (lookahead == 'f') ADVANCE(60);
      if (lookahead == 'm') ADVANCE(61);
      if (lookahead == 'n') ADVANCE(62);
      if (lookahead == 'r') ADVANCE(63);
      if (lookahead == 's') ADVANCE(64);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(67);
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(69);
      if (lookahead == 'o') ADVANCE(70);
      if (lookahead == 'u') ADVANCE(71);
      END_STATE();
    case 18:
      if (lookahead == 'u') ADVANCE(72);
      if (lookahead == 'v') ADVANCE(73);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(74);
      if (lookahead == 'r') ADVANCE(75);
      if (lookahead == 't') ADVANCE(76);
      if (lookahead == 'u') ADVANCE(77);
      END_STATE();
    case 20:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 21:
      if (lookahead == 'c') ADVANCE(79);
      if (lookahead == 'h') ADVANCE(80);
      if (lookahead == 'i') ADVANCE(81);
      if (lookahead == 't') ADVANCE(82);
      if (lookahead == 'u') ADVANCE(83);
      if (lookahead == 'w') ADVANCE(84);
      if (lookahead == 'y') ADVANCE(85);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(86);
      if (lookahead == 'h') ADVANCE(87);
      if (lookahead == 'r') ADVANCE(88);
      if (lookahead == 'y') ADVANCE(89);
      END_STATE();
    case 23:
      if (lookahead == 'b') ADVANCE(90);
      if (lookahead == 'c') ADVANCE(91);
      if (lookahead == 'i') ADVANCE(92);
      if (lookahead == 'l') ADVANCE(93);
      if (lookahead == 'n') ADVANCE(94);
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(96);
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 25:
      if (lookahead == 'c') ADVANCE(98);
      if (lookahead == 'h') ADVANCE(99);
      if (lookahead == 'i') ADVANCE(100);
      if (lookahead == 's') ADVANCE(101);
      END_STATE();
    case 26:
      if (lookahead == 'j') ADVANCE(102);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 29:
      if (lookahead == 'D') ADVANCE(105);
      if (lookahead == 'F') ADVANCE(106);
      if (lookahead == 'L') ADVANCE(107);
      if (lookahead == 'M') ADVANCE(108);
      if (lookahead == 'P') ADVANCE(109);
      if (lookahead == 'T') ADVANCE(110);
      if (lookahead == 'V') ADVANCE(111);
      if (lookahead == 'g') ADVANCE(112);
      if (lookahead == 'p') ADVANCE(113);
      if (lookahead == 't') ADVANCE(114);
      if (lookahead == 'v') ADVANCE(115);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 31:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(118);
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 34:
      if (lookahead == 'o') ADVANCE(121);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(122);
      END_STATE();
    case 36:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 37:
      if (lookahead == 's') ADVANCE(124);
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(126);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(127);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 42:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 43:
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(134);
      END_STATE();
    case 47:
      if (lookahead == 'b') ADVANCE(135);
      if (lookahead == 'f') ADVANCE(136);
      if (lookahead == 'l') ADVANCE(137);
      if (lookahead == 'p') ADVANCE(138);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_do);
      if (lookahead == 'u') ADVANCE(139);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 50:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 51:
      if (lookahead == 'u') ADVANCE(142);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(143);
      if (lookahead == 'p') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(146);
      if (lookahead == 'l') ADVANCE(147);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 55:
      if (lookahead == 'o') ADVANCE(149);
      END_STATE();
    case 56:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(151);
      END_STATE();
    case 58:
      if (lookahead == 't') ADVANCE(152);
      END_STATE();
    case 59:
      if (lookahead == 'o') ADVANCE(153);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_if);
      if (lookahead == 'l') ADVANCE(154);
      END_STATE();
    case 61:
      if (lookahead == 'm') ADVANCE(155);
      if (lookahead == 'p') ADVANCE(156);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_in);
      if (lookahead == 'o') ADVANCE(157);
      if (lookahead == 't') ADVANCE(158);
      if (lookahead == 'v') ADVANCE(159);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_is);
      END_STATE();
    case 65:
      if (lookahead == 'z') ADVANCE(161);
      END_STATE();
    case 66:
      if (lookahead == 'n') ADVANCE(162);
      END_STATE();
    case 67:
      if (lookahead == 'x') ADVANCE(163);
      END_STATE();
    case 68:
      if (lookahead == 'd') ADVANCE(164);
      END_STATE();
    case 69:
      if (lookahead == 'w') ADVANCE(165);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(166);
      if (lookahead == 't') ADVANCE(167);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(168);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 75:
      if (lookahead == 'a') ADVANCE(172);
      if (lookahead == 'i') ADVANCE(173);
      if (lookahead == 'o') ADVANCE(174);
      END_STATE();
    case 76:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(176);
      if (lookahead == 'r') ADVANCE(177);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(178);
      if (lookahead == 'f') ADVANCE(179);
      if (lookahead == 't') ADVANCE(180);
      END_STATE();
    case 79:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(182);
      if (lookahead == 'o') ADVANCE(183);
      END_STATE();
    case 81:
      if (lookahead == 'z') ADVANCE(184);
      END_STATE();
    case 82:
      if (lookahead == 'a') ADVANCE(185);
      if (lookahead == 'r') ADVANCE(186);
      END_STATE();
    case 83:
      if (lookahead == 'c') ADVANCE(187);
      if (lookahead == 'p') ADVANCE(188);
      END_STATE();
    case 84:
      if (lookahead == 'i') ADVANCE(189);
      END_STATE();
    case 85:
      if (lookahead == 'n') ADVANCE(190);
      END_STATE();
    case 86:
      if (lookahead == 'm') ADVANCE(191);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(192);
      if (lookahead == 'r') ADVANCE(193);
      END_STATE();
    case 88:
      if (lookahead == 'u') ADVANCE(194);
      if (lookahead == 'y') ADVANCE(195);
      END_STATE();
    case 89:
      if (lookahead == 'p') ADVANCE(196);
      END_STATE();
    case 90:
      if (lookahead == 'y') ADVANCE(197);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(198);
      END_STATE();
    case 92:
      if (lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 94:
      if (lookahead == 'i') ADVANCE(201);
      END_STATE();
    case 95:
      if (lookahead == 'h') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'r') ADVANCE(203);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 98:
      if (lookahead == 'h') ADVANCE(205);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(206);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(207);
      END_STATE();
    case 101:
      if (lookahead == 't') ADVANCE(208);
      END_STATE();
    case 102:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(210);
      END_STATE();
    case 104:
      if (lookahead == 'd') ADVANCE(211);
      END_STATE();
    case 105:
      if (lookahead == 'A') ADVANCE(212);
      END_STATE();
    case 106:
      if (lookahead == 'I') ADVANCE(213);
      if (lookahead == 'U') ADVANCE(214);
      END_STATE();
    case 107:
      if (lookahead == 'I') ADVANCE(215);
      END_STATE();
    case 108:
      if (lookahead == 'O') ADVANCE(216);
      END_STATE();
    case 109:
      if (lookahead == 'R') ADVANCE(217);
      END_STATE();
    case 110:
      if (lookahead == 'I') ADVANCE(218);
      END_STATE();
    case 111:
      if (lookahead == 'E') ADVANCE(219);
      END_STATE();
    case 112:
      if (lookahead == 's') ADVANCE(220);
      END_STATE();
    case 113:
      if (lookahead == 'a') ADVANCE(221);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(223);
      END_STATE();
    case 116:
      if (lookahead == 't') ADVANCE(224);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(225);
      if (lookahead == 'g') ADVANCE(226);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_asm);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(227);
      END_STATE();
    case 120:
      if (lookahead == 'o') ADVANCE(228);
      END_STATE();
    case 121:
      if (lookahead == 'l') ADVANCE(229);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(230);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(232);
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 125:
      if (lookahead == 'c') ADVANCE(234);
      END_STATE();
    case 126:
      if (lookahead == 'u') ADVANCE(235);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(236);
      END_STATE();
    case 128:
      if (lookahead == 'o') ADVANCE(237);
      END_STATE();
    case 129:
      if (lookahead == 'r') ADVANCE(238);
      END_STATE();
    case 130:
      if (lookahead == 's') ADVANCE(239);
      END_STATE();
    case 131:
      if (lookahead == 's') ADVANCE(240);
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(242);
      END_STATE();
    case 133:
      if (lookahead == 'r') ADVANCE(243);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(244);
      END_STATE();
    case 135:
      if (lookahead == 'u') ADVANCE(245);
      END_STATE();
    case 136:
      if (lookahead == 'a') ADVANCE(246);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(247);
      END_STATE();
    case 138:
      if (lookahead == 'r') ADVANCE(248);
      END_STATE();
    case 139:
      if (lookahead == 'b') ADVANCE(249);
      END_STATE();
    case 140:
      if (lookahead == 'r') ADVANCE(250);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 142:
      if (lookahead == 'm') ADVANCE(252);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 144:
      if (lookahead == 'o') ADVANCE(254);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(255);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(256);
      END_STATE();
    case 147:
      if (lookahead == 's') ADVANCE(257);
      END_STATE();
    case 148:
      if (lookahead == 'a') ADVANCE(258);
      END_STATE();
    case 149:
      if (lookahead == 'a') ADVANCE(259);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_for);
      if (lookahead == 'e') ADVANCE(260);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(261);
      END_STATE();
    case 152:
      if (lookahead == 'o') ADVANCE(262);
      END_STATE();
    case 153:
      if (lookahead == 'u') ADVANCE(263);
      END_STATE();
    case 154:
      if (lookahead == 'o') ADVANCE(264);
      END_STATE();
    case 155:
      if (lookahead == 'u') ADVANCE(265);
      END_STATE();
    case 156:
      if (lookahead == 'o') ADVANCE(266);
      END_STATE();
    case 157:
      if (lookahead == 'u') ADVANCE(267);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == 'e') ADVANCE(268);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(269);
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(270);
      END_STATE();
    case 161:
      if (lookahead == 'y') ADVANCE(271);
      END_STATE();
    case 162:
      if (lookahead == 'g') ADVANCE(272);
      END_STATE();
    case 163:
      if (lookahead == 'i') ADVANCE(273);
      END_STATE();
    case 164:
      if (lookahead == 'u') ADVANCE(274);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_new);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(275);
      END_STATE();
    case 167:
      if (lookahead == 'h') ADVANCE(276);
      END_STATE();
    case 168:
      if (lookahead == 'l') ADVANCE(277);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_out);
      END_STATE();
    case 170:
      if (lookahead == 'r') ADVANCE(278);
      END_STATE();
    case 171:
      if (lookahead == 'k') ADVANCE(279);
      END_STATE();
    case 172:
      if (lookahead == 'g') ADVANCE(280);
      END_STATE();
    case 173:
      if (lookahead == 'v') ADVANCE(281);
      END_STATE();
    case 174:
      if (lookahead == 't') ADVANCE(282);
      END_STATE();
    case 175:
      if (lookahead == 'd') ADVANCE(283);
      END_STATE();
    case 176:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 178:
      if (lookahead == 'l') ADVANCE(286);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_ref);
      END_STATE();
    case 180:
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 181:
      if (lookahead == 'p') ADVANCE(288);
      END_STATE();
    case 182:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 183:
      if (lookahead == 'r') ADVANCE(290);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(291);
      END_STATE();
    case 185:
      if (lookahead == 't') ADVANCE(292);
      END_STATE();
    case 186:
      if (lookahead == 'i') ADVANCE(293);
      if (lookahead == 'u') ADVANCE(294);
      END_STATE();
    case 187:
      if (lookahead == 'c') ADVANCE(295);
      END_STATE();
    case 188:
      if (lookahead == 'e') ADVANCE(296);
      END_STATE();
    case 189:
      if (lookahead == 't') ADVANCE(297);
      END_STATE();
    case 190:
      if (lookahead == 'c') ADVANCE(298);
      END_STATE();
    case 191:
      if (lookahead == 'p') ADVANCE(299);
      END_STATE();
    case 192:
      if (lookahead == 's') ADVANCE(300);
      END_STATE();
    case 193:
      if (lookahead == 'o') ADVANCE(301);
      END_STATE();
    case 194:
      if (lookahead == 'e') ADVANCE(302);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_try);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(303);
      END_STATE();
    case 197:
      if (lookahead == 't') ADVANCE(304);
      END_STATE();
    case 198:
      if (lookahead == 'n') ADVANCE(305);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(306);
      END_STATE();
    case 200:
      if (lookahead == 'n') ADVANCE(307);
      END_STATE();
    case 201:
      if (lookahead == 'o') ADVANCE(308);
      if (lookahead == 't') ADVANCE(309);
      END_STATE();
    case 202:
      if (lookahead == 'o') ADVANCE(310);
      END_STATE();
    case 203:
      if (lookahead == 's') ADVANCE(311);
      END_STATE();
    case 204:
      if (lookahead == 'd') ADVANCE(312);
      END_STATE();
    case 205:
      if (lookahead == 'a') ADVANCE(313);
      END_STATE();
    case 206:
      if (lookahead == 'l') ADVANCE(314);
      END_STATE();
    case 207:
      if (lookahead == 'h') ADVANCE(315);
      END_STATE();
    case 208:
      if (lookahead == 'r') ADVANCE(316);
      END_STATE();
    case 209:
      if (lookahead == 'c') ADVANCE(317);
      END_STATE();
    case 210:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 211:
      if (lookahead == 'o') ADVANCE(319);
      END_STATE();
    case 212:
      if (lookahead == 'T') ADVANCE(320);
      END_STATE();
    case 213:
      if (lookahead == 'L') ADVANCE(321);
      END_STATE();
    case 214:
      if (lookahead == 'N') ADVANCE(322);
      END_STATE();
    case 215:
      if (lookahead == 'N') ADVANCE(323);
      END_STATE();
    case 216:
      if (lookahead == 'D') ADVANCE(324);
      END_STATE();
    case 217:
      if (lookahead == 'E') ADVANCE(325);
      END_STATE();
    case 218:
      if (lookahead == 'M') ADVANCE(326);
      END_STATE();
    case 219:
      if (lookahead == 'N') ADVANCE(327);
      if (lookahead == 'R') ADVANCE(328);
      END_STATE();
    case 220:
      if (lookahead == 'h') ADVANCE(329);
      END_STATE();
    case 221:
      if (lookahead == 'r') ADVANCE(330);
      END_STATE();
    case 222:
      if (lookahead == 'a') ADVANCE(331);
      END_STATE();
    case 223:
      if (lookahead == 'c') ADVANCE(332);
      END_STATE();
    case 224:
      if (lookahead == 'r') ADVANCE(333);
      END_STATE();
    case 225:
      if (lookahead == 's') ADVANCE(334);
      END_STATE();
    case 226:
      if (lookahead == 'n') ADVANCE(335);
      END_STATE();
    case 227:
      if (lookahead == 'r') ADVANCE(336);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_auto);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_bool);
      END_STATE();
    case 230:
      if (lookahead == 'k') ADVANCE(337);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_byte);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_case);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_cast);
      END_STATE();
    case 234:
      if (lookahead == 'h') ADVANCE(338);
      END_STATE();
    case 235:
      if (lookahead == 'b') ADVANCE(339);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(sym_cent);
      END_STATE();
    case 237:
      if (lookahead == 'a') ADVANCE(340);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(sym_char);
      END_STATE();
    case 239:
      if (lookahead == 's') ADVANCE(341);
      END_STATE();
    case 240:
      if (lookahead == 't') ADVANCE(342);
      END_STATE();
    case 241:
      if (lookahead == 'i') ADVANCE(343);
      END_STATE();
    case 242:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 243:
      if (lookahead == 'i') ADVANCE(345);
      END_STATE();
    case 244:
      if (lookahead == 'r') ADVANCE(346);
      END_STATE();
    case 245:
      if (lookahead == 'g') ADVANCE(347);
      END_STATE();
    case 246:
      if (lookahead == 'u') ADVANCE(348);
      END_STATE();
    case 247:
      if (lookahead == 'g') ADVANCE(349);
      if (lookahead == 't') ADVANCE(350);
      END_STATE();
    case 248:
      if (lookahead == 'e') ADVANCE(351);
      END_STATE();
    case 249:
      if (lookahead == 'l') ADVANCE(352);
      END_STATE();
    case 250:
      if (lookahead == 'i') ADVANCE(353);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_else);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_enum);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_exit);
      END_STATE();
    case 254:
      if (lookahead == 'r') ADVANCE(354);
      END_STATE();
    case 255:
      if (lookahead == 'r') ADVANCE(355);
      END_STATE();
    case 256:
      if (lookahead == 'u') ADVANCE(356);
      END_STATE();
    case 257:
      if (lookahead == 'e') ADVANCE(357);
      END_STATE();
    case 258:
      if (lookahead == 'l') ADVANCE(358);
      END_STATE();
    case 259:
      if (lookahead == 't') ADVANCE(359);
      END_STATE();
    case 260:
      if (lookahead == 'a') ADVANCE(360);
      END_STATE();
    case 261:
      if (lookahead == 't') ADVANCE(361);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_goto);
      END_STATE();
    case 263:
      if (lookahead == 'b') ADVANCE(362);
      END_STATE();
    case 264:
      if (lookahead == 'a') ADVANCE(363);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 266:
      if (lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 267:
      if (lookahead == 't') ADVANCE(366);
      END_STATE();
    case 268:
      if (lookahead == 'r') ADVANCE(367);
      END_STATE();
    case 269:
      if (lookahead == 'r') ADVANCE(368);
      END_STATE();
    case 270:
      if (lookahead == 'l') ADVANCE(369);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_lazy);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_long);
      END_STATE();
    case 273:
      if (lookahead == 'n') ADVANCE(370);
      END_STATE();
    case 274:
      if (lookahead == 'l') ADVANCE(371);
      END_STATE();
    case 275:
      if (lookahead == 't') ADVANCE(372);
      END_STATE();
    case 276:
      if (lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 278:
      if (lookahead == 'r') ADVANCE(374);
      END_STATE();
    case 279:
      if (lookahead == 'a') ADVANCE(375);
      END_STATE();
    case 280:
      if (lookahead == 'm') ADVANCE(376);
      END_STATE();
    case 281:
      if (lookahead == 'a') ADVANCE(377);
      END_STATE();
    case 282:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 283:
      if (lookahead == 'i') ADVANCE(379);
      END_STATE();
    case 284:
      if (lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_pure);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_real);
      END_STATE();
    case 287:
      if (lookahead == 'r') ADVANCE(381);
      END_STATE();
    case 288:
      if (lookahead == 'e') ADVANCE(382);
      END_STATE();
    case 289:
      if (lookahead == 'e') ADVANCE(383);
      END_STATE();
    case 290:
      if (lookahead == 't') ADVANCE(384);
      END_STATE();
    case 291:
      if (lookahead == '_') ADVANCE(385);
      END_STATE();
    case 292:
      if (lookahead == 'i') ADVANCE(386);
      END_STATE();
    case 293:
      if (lookahead == 'n') ADVANCE(387);
      END_STATE();
    case 294:
      if (lookahead == 'c') ADVANCE(388);
      END_STATE();
    case 295:
      if (lookahead == 'e') ADVANCE(389);
      END_STATE();
    case 296:
      if (lookahead == 'r') ADVANCE(390);
      END_STATE();
    case 297:
      if (lookahead == 'c') ADVANCE(391);
      END_STATE();
    case 298:
      if (lookahead == 'h') ADVANCE(392);
      END_STATE();
    case 299:
      if (lookahead == 'l') ADVANCE(393);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 301:
      if (lookahead == 'w') ADVANCE(394);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 303:
      if (lookahead == 'i') ADVANCE(395);
      if (lookahead == 'o') ADVANCE(396);
      END_STATE();
    case 304:
      if (lookahead == 'e') ADVANCE(397);
      END_STATE();
    case 305:
      if (lookahead == 't') ADVANCE(398);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_uint);
      END_STATE();
    case 307:
      if (lookahead == 'g') ADVANCE(399);
      END_STATE();
    case 308:
      if (lookahead == 'n') ADVANCE(400);
      END_STATE();
    case 309:
      if (lookahead == 't') ADVANCE(401);
      END_STATE();
    case 310:
      if (lookahead == 'r') ADVANCE(402);
      END_STATE();
    case 311:
      if (lookahead == 'i') ADVANCE(403);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_void);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(404);
      END_STATE();
    case 314:
      if (lookahead == 'e') ADVANCE(405);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_with);
      END_STATE();
    case 316:
      if (lookahead == 'i') ADVANCE(406);
      END_STATE();
    case 317:
      if (lookahead == 't') ADVANCE(407);
      END_STATE();
    case 318:
      if (lookahead == 'm') ADVANCE(408);
      END_STATE();
    case 319:
      if (lookahead == 'w') ADVANCE(409);
      END_STATE();
    case 320:
      if (lookahead == 'E') ADVANCE(410);
      END_STATE();
    case 321:
      if (lookahead == 'E') ADVANCE(411);
      END_STATE();
    case 322:
      if (lookahead == 'C') ADVANCE(412);
      END_STATE();
    case 323:
      if (lookahead == 'E') ADVANCE(413);
      END_STATE();
    case 324:
      if (lookahead == 'U') ADVANCE(414);
      END_STATE();
    case 325:
      if (lookahead == 'T') ADVANCE(415);
      END_STATE();
    case 326:
      if (lookahead == 'E') ADVANCE(416);
      END_STATE();
    case 327:
      if (lookahead == 'D') ADVANCE(417);
      END_STATE();
    case 328:
      if (lookahead == 'S') ADVANCE(418);
      END_STATE();
    case 329:
      if (lookahead == 'a') ADVANCE(419);
      END_STATE();
    case 330:
      if (lookahead == 'a') ADVANCE(420);
      END_STATE();
    case 331:
      if (lookahead == 'i') ADVANCE(421);
      END_STATE();
    case 332:
      if (lookahead == 't') ADVANCE(422);
      END_STATE();
    case 333:
      if (lookahead == 'a') ADVANCE(423);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_alias);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_align);
      END_STATE();
    case 336:
      if (lookahead == 't') ADVANCE(424);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_break);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_catch);
      END_STATE();
    case 339:
      if (lookahead == 'l') ADVANCE(425);
      END_STATE();
    case 340:
      if (lookahead == 't') ADVANCE(426);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_class);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_const);
      END_STATE();
    case 343:
      if (lookahead == 'n') ADVANCE(427);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_creal);
      END_STATE();
    case 345:
      if (lookahead == 'n') ADVANCE(428);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_dchar);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_debug);
      END_STATE();
    case 348:
      if (lookahead == 'l') ADVANCE(429);
      END_STATE();
    case 349:
      if (lookahead == 'a') ADVANCE(430);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(431);
      END_STATE();
    case 351:
      if (lookahead == 'c') ADVANCE(432);
      END_STATE();
    case 352:
      if (lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 353:
      if (lookahead == 'n') ADVANCE(434);
      END_STATE();
    case 354:
      if (lookahead == 't') ADVANCE(435);
      END_STATE();
    case 355:
      if (lookahead == 'n') ADVANCE(436);
      END_STATE();
    case 356:
      if (lookahead == 'r') ADVANCE(437);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_final);
      if (lookahead == 'l') ADVANCE(438);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 360:
      if (lookahead == 'c') ADVANCE(439);
      END_STATE();
    case 361:
      if (lookahead == 'i') ADVANCE(440);
      END_STATE();
    case 362:
      if (lookahead == 'l') ADVANCE(441);
      END_STATE();
    case 363:
      if (lookahead == 't') ADVANCE(442);
      END_STATE();
    case 364:
      if (lookahead == 'a') ADVANCE(443);
      END_STATE();
    case 365:
      if (lookahead == 't') ADVANCE(444);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_inout);
      END_STATE();
    case 367:
      if (lookahead == 'f') ADVANCE(445);
      END_STATE();
    case 368:
      if (lookahead == 'i') ADVANCE(446);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_ireal);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_mixin);
      END_STATE();
    case 371:
      if (lookahead == 'e') ADVANCE(447);
      END_STATE();
    case 372:
      if (lookahead == 'u') ADVANCE(448);
      END_STATE();
    case 373:
      if (lookahead == 'o') ADVANCE(449);
      END_STATE();
    case 374:
      if (lookahead == 'i') ADVANCE(450);
      END_STATE();
    case 375:
      if (lookahead == 'g') ADVANCE(451);
      END_STATE();
    case 376:
      if (lookahead == 'a') ADVANCE(452);
      END_STATE();
    case 377:
      if (lookahead == 't') ADVANCE(453);
      END_STATE();
    case 378:
      if (lookahead == 'c') ADVANCE(454);
      END_STATE();
    case 379:
      if (lookahead == 'f') ADVANCE(455);
      END_STATE();
    case 380:
      if (lookahead == 'c') ADVANCE(456);
      END_STATE();
    case 381:
      if (lookahead == 'n') ADVANCE(457);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_scope);
      END_STATE();
    case 383:
      if (lookahead == 'd') ADVANCE(458);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_short);
      END_STATE();
    case 385:
      if (lookahead == 't') ADVANCE(459);
      END_STATE();
    case 386:
      if (lookahead == 'c') ADVANCE(460);
      END_STATE();
    case 387:
      if (lookahead == 'g') ADVANCE(461);
      END_STATE();
    case 388:
      if (lookahead == 't') ADVANCE(462);
      END_STATE();
    case 389:
      if (lookahead == 's') ADVANCE(463);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 391:
      if (lookahead == 'h') ADVANCE(464);
      END_STATE();
    case 392:
      if (lookahead == 'r') ADVANCE(465);
      END_STATE();
    case 393:
      if (lookahead == 'a') ADVANCE(466);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_throw);
      END_STATE();
    case 395:
      if (lookahead == 'd') ADVANCE(467);
      END_STATE();
    case 396:
      if (lookahead == 'f') ADVANCE(468);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_ubyte);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_ucent);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_ulong);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_union);
      END_STATE();
    case 401:
      if (lookahead == 'e') ADVANCE(469);
      END_STATE();
    case 402:
      if (lookahead == 't') ADVANCE(470);
      END_STATE();
    case 403:
      if (lookahead == 'o') ADVANCE(471);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_wchar);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_while);
      END_STATE();
    case 406:
      if (lookahead == 'n') ADVANCE(472);
      END_STATE();
    case 407:
      if (lookahead == 'i') ADVANCE(473);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_System);
      END_STATE();
    case 409:
      if (lookahead == 's') ADVANCE(474);
      END_STATE();
    case 410:
      if (lookahead == '_') ADVANCE(475);
      END_STATE();
    case 411:
      if (lookahead == '_') ADVANCE(476);
      END_STATE();
    case 412:
      if (lookahead == 'T') ADVANCE(477);
      END_STATE();
    case 413:
      if (lookahead == '_') ADVANCE(478);
      END_STATE();
    case 414:
      if (lookahead == 'L') ADVANCE(479);
      END_STATE();
    case 415:
      if (lookahead == 'T') ADVANCE(480);
      END_STATE();
    case 416:
      if (lookahead == 'S') ADVANCE(481);
      if (lookahead == '_') ADVANCE(482);
      END_STATE();
    case 417:
      if (lookahead == 'O') ADVANCE(483);
      END_STATE();
    case 418:
      if (lookahead == 'I') ADVANCE(484);
      END_STATE();
    case 419:
      if (lookahead == 'r') ADVANCE(485);
      END_STATE();
    case 420:
      if (lookahead == 'm') ADVANCE(486);
      END_STATE();
    case 421:
      if (lookahead == 't') ADVANCE(487);
      END_STATE();
    case 422:
      if (lookahead == 'o') ADVANCE(488);
      END_STATE();
    case 423:
      if (lookahead == 'c') ADVANCE(489);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_assert);
      END_STATE();
    case 425:
      if (lookahead == 'e') ADVANCE(490);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(sym_cfloat);
      END_STATE();
    case 427:
      if (lookahead == 'u') ADVANCE(491);
      END_STATE();
    case 428:
      if (lookahead == 'g') ADVANCE(492);
      END_STATE();
    case 429:
      if (lookahead == 't') ADVANCE(493);
      END_STATE();
    case 430:
      if (lookahead == 't') ADVANCE(494);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(sym_delete);
      END_STATE();
    case 432:
      if (lookahead == 'a') ADVANCE(495);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(sym_double);
      END_STATE();
    case 434:
      if (lookahead == 'g') ADVANCE(496);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(sym_export);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(sym_extern);
      END_STATE();
    case 437:
      if (lookahead == 'e') ADVANCE(497);
      END_STATE();
    case 438:
      if (lookahead == 'y') ADVANCE(498);
      END_STATE();
    case 439:
      if (lookahead == 'h') ADVANCE(499);
      END_STATE();
    case 440:
      if (lookahead == 'o') ADVANCE(500);
      END_STATE();
    case 441:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(sym_ifloat);
      END_STATE();
    case 443:
      if (lookahead == 'b') ADVANCE(502);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(sym_import);
      END_STATE();
    case 445:
      if (lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 446:
      if (lookahead == 'a') ADVANCE(504);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(sym_module);
      END_STATE();
    case 448:
      if (lookahead == 'r') ADVANCE(505);
      END_STATE();
    case 449:
      if (lookahead == 'w') ADVANCE(506);
      END_STATE();
    case 450:
      if (lookahead == 'd') ADVANCE(507);
      END_STATE();
    case 451:
      if (lookahead == 'e') ADVANCE(508);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(sym_pragma);
      END_STATE();
    case 453:
      if (lookahead == 'e') ADVANCE(509);
      END_STATE();
    case 454:
      if (lookahead == 't') ADVANCE(510);
      END_STATE();
    case 455:
      if (lookahead == 'f') ADVANCE(511);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(sym_public);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(sym_return);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(sym_shared);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(sym_size_t);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(sym_static);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(sym_struct);
      END_STATE();
    case 463:
      if (lookahead == 's') ADVANCE(512);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(sym_switch);
      END_STATE();
    case 465:
      if (lookahead == 'o') ADVANCE(513);
      END_STATE();
    case 466:
      if (lookahead == 't') ADVANCE(514);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(sym_typeid);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(sym_typeof);
      END_STATE();
    case 469:
      if (lookahead == 's') ADVANCE(515);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_ushort);
      END_STATE();
    case 471:
      if (lookahead == 'n') ADVANCE(516);
      END_STATE();
    case 472:
      if (lookahead == 'g') ADVANCE(517);
      END_STATE();
    case 473:
      if (lookahead == 'v') ADVANCE(518);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(anon_sym_Windows);
      END_STATE();
    case 475:
      if (lookahead == '_') ADVANCE(519);
      END_STATE();
    case 476:
      if (lookahead == 'F') ADVANCE(520);
      if (lookahead == '_') ADVANCE(521);
      END_STATE();
    case 477:
      if (lookahead == 'I') ADVANCE(522);
      END_STATE();
    case 478:
      if (lookahead == '_') ADVANCE(523);
      END_STATE();
    case 479:
      if (lookahead == 'E') ADVANCE(524);
      END_STATE();
    case 480:
      if (lookahead == 'Y') ADVANCE(525);
      END_STATE();
    case 481:
      if (lookahead == 'T') ADVANCE(526);
      END_STATE();
    case 482:
      if (lookahead == '_') ADVANCE(527);
      END_STATE();
    case 483:
      if (lookahead == 'R') ADVANCE(528);
      END_STATE();
    case 484:
      if (lookahead == 'O') ADVANCE(529);
      END_STATE();
    case 485:
      if (lookahead == 'e') ADVANCE(530);
      END_STATE();
    case 486:
      if (lookahead == 'e') ADVANCE(531);
      END_STATE();
    case 487:
      if (lookahead == 's') ADVANCE(532);
      END_STATE();
    case 488:
      if (lookahead == 'r') ADVANCE(533);
      END_STATE();
    case 489:
      if (lookahead == 't') ADVANCE(534);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(sym_cdouble);
      END_STATE();
    case 491:
      if (lookahead == 'e') ADVANCE(535);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_cstring);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(sym_default);
      END_STATE();
    case 494:
      if (lookahead == 'e') ADVANCE(536);
      END_STATE();
    case 495:
      if (lookahead == 't') ADVANCE(537);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_dstring);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_failure);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_finally);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_foreach);
      if (lookahead == '_') ADVANCE(538);
      END_STATE();
    case 500:
      if (lookahead == 'n') ADVANCE(539);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_idouble);
      END_STATE();
    case 502:
      if (lookahead == 'l') ADVANCE(540);
      END_STATE();
    case 503:
      if (lookahead == 'c') ADVANCE(541);
      END_STATE();
    case 504:
      if (lookahead == 'n') ADVANCE(542);
      END_STATE();
    case 505:
      if (lookahead == 'n') ADVANCE(543);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_nothrow);
      END_STATE();
    case 507:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_package);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_private);
      END_STATE();
    case 510:
      if (lookahead == 'e') ADVANCE(545);
      END_STATE();
    case 511:
      if (lookahead == '_') ADVANCE(546);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_success);
      END_STATE();
    case 513:
      if (lookahead == 'n') ADVANCE(547);
      END_STATE();
    case 514:
      if (lookahead == 'e') ADVANCE(548);
      END_STATE();
    case 515:
      if (lookahead == 't') ADVANCE(549);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_version);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_wstring);
      END_STATE();
    case 518:
      if (lookahead == 'e') ADVANCE(550);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym___DATE__);
      END_STATE();
    case 520:
      if (lookahead == 'U') ADVANCE(551);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym___FILE__);
      END_STATE();
    case 522:
      if (lookahead == 'O') ADVANCE(552);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym___LINE__);
      END_STATE();
    case 524:
      if (lookahead == '_') ADVANCE(553);
      END_STATE();
    case 525:
      if (lookahead == '_') ADVANCE(554);
      END_STATE();
    case 526:
      if (lookahead == 'A') ADVANCE(555);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym___TIME__);
      END_STATE();
    case 528:
      if (lookahead == '_') ADVANCE(556);
      END_STATE();
    case 529:
      if (lookahead == 'N') ADVANCE(557);
      END_STATE();
    case 530:
      if (lookahead == 'd') ADVANCE(558);
      END_STATE();
    case 531:
      if (lookahead == 't') ADVANCE(559);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_traits);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_vector);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_abstract);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_continue);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_delegate);
      END_STATE();
    case 537:
      if (lookahead == 'e') ADVANCE(560);
      END_STATE();
    case 538:
      if (lookahead == 'r') ADVANCE(561);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_function);
      END_STATE();
    case 540:
      if (lookahead == 'e') ADVANCE(562);
      END_STATE();
    case 541:
      if (lookahead == 'e') ADVANCE(563);
      END_STATE();
    case 542:
      if (lookahead == 't') ADVANCE(564);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(sym_noreturn);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(sym_override);
      END_STATE();
    case 545:
      if (lookahead == 'd') ADVANCE(565);
      END_STATE();
    case 546:
      if (lookahead == 't') ADVANCE(566);
      END_STATE();
    case 547:
      if (lookahead == 'i') ADVANCE(567);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(sym_template);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(sym_unittest);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_Objective);
      END_STATE();
    case 551:
      if (lookahead == 'L') ADVANCE(568);
      END_STATE();
    case 552:
      if (lookahead == 'N') ADVANCE(569);
      END_STATE();
    case 553:
      if (lookahead == '_') ADVANCE(570);
      END_STATE();
    case 554:
      if (lookahead == 'F') ADVANCE(571);
      END_STATE();
    case 555:
      if (lookahead == 'M') ADVANCE(572);
      END_STATE();
    case 556:
      if (lookahead == '_') ADVANCE(573);
      END_STATE();
    case 557:
      if (lookahead == '_') ADVANCE(574);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(sym_gshared);
      END_STATE();
    case 559:
      if (lookahead == 'e') ADVANCE(575);
      END_STATE();
    case 560:
      if (lookahead == 'd') ADVANCE(576);
      END_STATE();
    case 561:
      if (lookahead == 'e') ADVANCE(577);
      END_STATE();
    case 562:
      ACCEPT_TOKEN(sym_immutable);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(sym_interface);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(sym_invariant);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(sym_protected);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(sym_ptrdiff_t);
      END_STATE();
    case 567:
      if (lookahead == 'z') ADVANCE(578);
      END_STATE();
    case 568:
      if (lookahead == 'L') ADVANCE(579);
      END_STATE();
    case 569:
      if (lookahead == '_') ADVANCE(580);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym___MODULE__);
      END_STATE();
    case 571:
      if (lookahead == 'U') ADVANCE(581);
      END_STATE();
    case 572:
      if (lookahead == 'P') ADVANCE(582);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym___VENDOR__);
      END_STATE();
    case 574:
      if (lookahead == '_') ADVANCE(583);
      END_STATE();
    case 575:
      if (lookahead == 'r') ADVANCE(584);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(sym_deprecated);
      END_STATE();
    case 577:
      if (lookahead == 'v') ADVANCE(585);
      END_STATE();
    case 578:
      if (lookahead == 'e') ADVANCE(586);
      END_STATE();
    case 579:
      if (lookahead == '_') ADVANCE(587);
      END_STATE();
    case 580:
      if (lookahead == '_') ADVANCE(588);
      END_STATE();
    case 581:
      if (lookahead == 'N') ADVANCE(589);
      END_STATE();
    case 582:
      if (lookahead == '_') ADVANCE(590);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym___VERSION__);
      END_STATE();
    case 584:
      if (lookahead == 's') ADVANCE(591);
      END_STATE();
    case 585:
      if (lookahead == 'e') ADVANCE(592);
      END_STATE();
    case 586:
      if (lookahead == 'd') ADVANCE(593);
      END_STATE();
    case 587:
      if (lookahead == 'P') ADVANCE(594);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym___FUNCTION__);
      END_STATE();
    case 589:
      if (lookahead == 'C') ADVANCE(595);
      END_STATE();
    case 590:
      if (lookahead == '_') ADVANCE(596);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(sym_parameters_);
      END_STATE();
    case 592:
      if (lookahead == 'r') ADVANCE(597);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(sym_synchronized);
      END_STATE();
    case 594:
      if (lookahead == 'A') ADVANCE(598);
      END_STATE();
    case 595:
      if (lookahead == 'T') ADVANCE(599);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym___TIMESTAMP__);
      END_STATE();
    case 597:
      if (lookahead == 's') ADVANCE(600);
      END_STATE();
    case 598:
      if (lookahead == 'T') ADVANCE(601);
      END_STATE();
    case 599:
      if (lookahead == 'I') ADVANCE(602);
      END_STATE();
    case 600:
      if (lookahead == 'e') ADVANCE(603);
      END_STATE();
    case 601:
      if (lookahead == 'H') ADVANCE(604);
      END_STATE();
    case 602:
      if (lookahead == 'O') ADVANCE(605);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(sym_foreach_reverse);
      END_STATE();
    case 604:
      if (lookahead == '_') ADVANCE(606);
      END_STATE();
    case 605:
      if (lookahead == 'N') ADVANCE(607);
      END_STATE();
    case 606:
      if (lookahead == '_') ADVANCE(608);
      END_STATE();
    case 607:
      if (lookahead == '_') ADVANCE(609);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym___FILE_FULL_PATH__);
      END_STATE();
    case 609:
      if (lookahead == '_') ADVANCE(610);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym___PRETTY_FUNCTION__);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 50, .external_lex_state = 2},
  [2] = {.lex_state = 12, .external_lex_state = 3},
  [3] = {.lex_state = 12, .external_lex_state = 3},
  [4] = {.lex_state = 12, .external_lex_state = 3},
  [5] = {.lex_state = 12, .external_lex_state = 3},
  [6] = {.lex_state = 12, .external_lex_state = 3},
  [7] = {.lex_state = 12, .external_lex_state = 3},
  [8] = {.lex_state = 12, .external_lex_state = 3},
  [9] = {.lex_state = 12, .external_lex_state = 3},
  [10] = {.lex_state = 12, .external_lex_state = 3},
  [11] = {.lex_state = 12, .external_lex_state = 3},
  [12] = {.lex_state = 12, .external_lex_state = 3},
  [13] = {.lex_state = 12, .external_lex_state = 3},
  [14] = {.lex_state = 12, .external_lex_state = 3},
  [15] = {.lex_state = 12, .external_lex_state = 3},
  [16] = {.lex_state = 12, .external_lex_state = 3},
  [17] = {.lex_state = 12, .external_lex_state = 3},
  [18] = {.lex_state = 12, .external_lex_state = 3},
  [19] = {.lex_state = 12, .external_lex_state = 3},
  [20] = {.lex_state = 12, .external_lex_state = 3},
  [21] = {.lex_state = 12, .external_lex_state = 3},
  [22] = {.lex_state = 12, .external_lex_state = 3},
  [23] = {.lex_state = 12, .external_lex_state = 3},
  [24] = {.lex_state = 12, .external_lex_state = 3},
  [25] = {.lex_state = 12, .external_lex_state = 3},
  [26] = {.lex_state = 12, .external_lex_state = 3},
  [27] = {.lex_state = 12, .external_lex_state = 3},
  [28] = {.lex_state = 12, .external_lex_state = 3},
  [29] = {.lex_state = 12, .external_lex_state = 3},
  [30] = {.lex_state = 12, .external_lex_state = 3},
  [31] = {.lex_state = 12, .external_lex_state = 3},
  [32] = {.lex_state = 12, .external_lex_state = 3},
  [33] = {.lex_state = 12, .external_lex_state = 3},
  [34] = {.lex_state = 12, .external_lex_state = 3},
  [35] = {.lex_state = 12, .external_lex_state = 3},
  [36] = {.lex_state = 12, .external_lex_state = 3},
  [37] = {.lex_state = 12, .external_lex_state = 3},
  [38] = {.lex_state = 12, .external_lex_state = 3},
  [39] = {.lex_state = 12, .external_lex_state = 3},
  [40] = {.lex_state = 12, .external_lex_state = 3},
  [41] = {.lex_state = 12, .external_lex_state = 3},
  [42] = {.lex_state = 12, .external_lex_state = 3},
  [43] = {.lex_state = 12, .external_lex_state = 3},
  [44] = {.lex_state = 12, .external_lex_state = 3},
  [45] = {.lex_state = 12, .external_lex_state = 3},
  [46] = {.lex_state = 12, .external_lex_state = 3},
  [47] = {.lex_state = 12, .external_lex_state = 3},
  [48] = {.lex_state = 12, .external_lex_state = 3},
  [49] = {.lex_state = 12, .external_lex_state = 3},
  [50] = {.lex_state = 12, .external_lex_state = 3},
  [51] = {.lex_state = 12, .external_lex_state = 3},
  [52] = {.lex_state = 12, .external_lex_state = 3},
  [53] = {.lex_state = 12, .external_lex_state = 3},
  [54] = {.lex_state = 12, .external_lex_state = 3},
  [55] = {.lex_state = 12, .external_lex_state = 3},
  [56] = {.lex_state = 12, .external_lex_state = 3},
  [57] = {.lex_state = 12, .external_lex_state = 3},
  [58] = {.lex_state = 12, .external_lex_state = 3},
  [59] = {.lex_state = 12, .external_lex_state = 3},
  [60] = {.lex_state = 12, .external_lex_state = 3},
  [61] = {.lex_state = 12, .external_lex_state = 3},
  [62] = {.lex_state = 12, .external_lex_state = 3},
  [63] = {.lex_state = 12, .external_lex_state = 3},
  [64] = {.lex_state = 12, .external_lex_state = 3},
  [65] = {.lex_state = 12, .external_lex_state = 3},
  [66] = {.lex_state = 12, .external_lex_state = 3},
  [67] = {.lex_state = 12, .external_lex_state = 3},
  [68] = {.lex_state = 12, .external_lex_state = 3},
  [69] = {.lex_state = 12, .external_lex_state = 3},
  [70] = {.lex_state = 12, .external_lex_state = 3},
  [71] = {.lex_state = 12, .external_lex_state = 3},
  [72] = {.lex_state = 12, .external_lex_state = 3},
  [73] = {.lex_state = 12, .external_lex_state = 3},
  [74] = {.lex_state = 12, .external_lex_state = 3},
  [75] = {.lex_state = 12, .external_lex_state = 3},
  [76] = {.lex_state = 12, .external_lex_state = 3},
  [77] = {.lex_state = 12, .external_lex_state = 3},
  [78] = {.lex_state = 12, .external_lex_state = 3},
  [79] = {.lex_state = 12, .external_lex_state = 3},
  [80] = {.lex_state = 12, .external_lex_state = 3},
  [81] = {.lex_state = 12, .external_lex_state = 3},
  [82] = {.lex_state = 12, .external_lex_state = 3},
  [83] = {.lex_state = 12, .external_lex_state = 3},
  [84] = {.lex_state = 12, .external_lex_state = 3},
  [85] = {.lex_state = 12, .external_lex_state = 3},
  [86] = {.lex_state = 12, .external_lex_state = 3},
  [87] = {.lex_state = 12, .external_lex_state = 3},
  [88] = {.lex_state = 12, .external_lex_state = 3},
  [89] = {.lex_state = 12, .external_lex_state = 3},
  [90] = {.lex_state = 12, .external_lex_state = 3},
  [91] = {.lex_state = 12, .external_lex_state = 3},
  [92] = {.lex_state = 12, .external_lex_state = 3},
  [93] = {.lex_state = 12, .external_lex_state = 3},
  [94] = {.lex_state = 12, .external_lex_state = 3},
  [95] = {.lex_state = 12, .external_lex_state = 3},
  [96] = {.lex_state = 12, .external_lex_state = 3},
  [97] = {.lex_state = 12, .external_lex_state = 3},
  [98] = {.lex_state = 12, .external_lex_state = 3},
  [99] = {.lex_state = 12, .external_lex_state = 3},
  [100] = {.lex_state = 12, .external_lex_state = 3},
  [101] = {.lex_state = 12, .external_lex_state = 3},
  [102] = {.lex_state = 12, .external_lex_state = 3},
  [103] = {.lex_state = 12, .external_lex_state = 3},
  [104] = {.lex_state = 12, .external_lex_state = 3},
  [105] = {.lex_state = 12, .external_lex_state = 3},
  [106] = {.lex_state = 12, .external_lex_state = 3},
  [107] = {.lex_state = 12, .external_lex_state = 3},
  [108] = {.lex_state = 12, .external_lex_state = 3},
  [109] = {.lex_state = 12, .external_lex_state = 3},
  [110] = {.lex_state = 12, .external_lex_state = 3},
  [111] = {.lex_state = 12, .external_lex_state = 3},
  [112] = {.lex_state = 12, .external_lex_state = 3},
  [113] = {.lex_state = 12, .external_lex_state = 3},
  [114] = {.lex_state = 12, .external_lex_state = 3},
  [115] = {.lex_state = 12, .external_lex_state = 3},
  [116] = {.lex_state = 12, .external_lex_state = 3},
  [117] = {.lex_state = 12, .external_lex_state = 3},
  [118] = {.lex_state = 12, .external_lex_state = 3},
  [119] = {.lex_state = 12, .external_lex_state = 3},
  [120] = {.lex_state = 12, .external_lex_state = 3},
  [121] = {.lex_state = 12, .external_lex_state = 3},
  [122] = {.lex_state = 12, .external_lex_state = 3},
  [123] = {.lex_state = 12, .external_lex_state = 3},
  [124] = {.lex_state = 12, .external_lex_state = 3},
  [125] = {.lex_state = 12, .external_lex_state = 3},
  [126] = {.lex_state = 12, .external_lex_state = 3},
  [127] = {.lex_state = 12, .external_lex_state = 3},
  [128] = {.lex_state = 12, .external_lex_state = 3},
  [129] = {.lex_state = 12, .external_lex_state = 3},
  [130] = {.lex_state = 12, .external_lex_state = 3},
  [131] = {.lex_state = 12, .external_lex_state = 3},
  [132] = {.lex_state = 12, .external_lex_state = 3},
  [133] = {.lex_state = 12, .external_lex_state = 3},
  [134] = {.lex_state = 12, .external_lex_state = 3},
  [135] = {.lex_state = 12, .external_lex_state = 3},
  [136] = {.lex_state = 12, .external_lex_state = 3},
  [137] = {.lex_state = 12, .external_lex_state = 3},
  [138] = {.lex_state = 12, .external_lex_state = 3},
  [139] = {.lex_state = 12, .external_lex_state = 3},
  [140] = {.lex_state = 12, .external_lex_state = 3},
  [141] = {.lex_state = 12, .external_lex_state = 3},
  [142] = {.lex_state = 12, .external_lex_state = 3},
  [143] = {.lex_state = 12, .external_lex_state = 3},
  [144] = {.lex_state = 12, .external_lex_state = 3},
  [145] = {.lex_state = 12, .external_lex_state = 3},
  [146] = {.lex_state = 12, .external_lex_state = 3},
  [147] = {.lex_state = 12, .external_lex_state = 3},
  [148] = {.lex_state = 12, .external_lex_state = 3},
  [149] = {.lex_state = 12, .external_lex_state = 3},
  [150] = {.lex_state = 12, .external_lex_state = 3},
  [151] = {.lex_state = 12, .external_lex_state = 3},
  [152] = {.lex_state = 12, .external_lex_state = 3},
  [153] = {.lex_state = 12, .external_lex_state = 3},
  [154] = {.lex_state = 12, .external_lex_state = 3},
  [155] = {.lex_state = 12, .external_lex_state = 3},
  [156] = {.lex_state = 12, .external_lex_state = 3},
  [157] = {.lex_state = 12, .external_lex_state = 3},
  [158] = {.lex_state = 12, .external_lex_state = 3},
  [159] = {.lex_state = 12, .external_lex_state = 3},
  [160] = {.lex_state = 12, .external_lex_state = 3},
  [161] = {.lex_state = 12, .external_lex_state = 3},
  [162] = {.lex_state = 12, .external_lex_state = 3},
  [163] = {.lex_state = 12, .external_lex_state = 3},
  [164] = {.lex_state = 12, .external_lex_state = 3},
  [165] = {.lex_state = 12, .external_lex_state = 3},
  [166] = {.lex_state = 12, .external_lex_state = 3},
  [167] = {.lex_state = 12, .external_lex_state = 3},
  [168] = {.lex_state = 12, .external_lex_state = 3},
  [169] = {.lex_state = 12, .external_lex_state = 3},
  [170] = {.lex_state = 12, .external_lex_state = 3},
  [171] = {.lex_state = 12, .external_lex_state = 3},
  [172] = {.lex_state = 12, .external_lex_state = 3},
  [173] = {.lex_state = 12, .external_lex_state = 3},
  [174] = {.lex_state = 12, .external_lex_state = 3},
  [175] = {.lex_state = 12, .external_lex_state = 3},
  [176] = {.lex_state = 12, .external_lex_state = 3},
  [177] = {.lex_state = 12, .external_lex_state = 3},
  [178] = {.lex_state = 12, .external_lex_state = 3},
  [179] = {.lex_state = 12, .external_lex_state = 3},
  [180] = {.lex_state = 12, .external_lex_state = 3},
  [181] = {.lex_state = 12, .external_lex_state = 3},
  [182] = {.lex_state = 12, .external_lex_state = 3},
  [183] = {.lex_state = 12, .external_lex_state = 3},
  [184] = {.lex_state = 12, .external_lex_state = 3},
  [185] = {.lex_state = 12, .external_lex_state = 3},
  [186] = {.lex_state = 12, .external_lex_state = 3},
  [187] = {.lex_state = 12, .external_lex_state = 3},
  [188] = {.lex_state = 12, .external_lex_state = 3},
  [189] = {.lex_state = 12, .external_lex_state = 3},
  [190] = {.lex_state = 12, .external_lex_state = 3},
  [191] = {.lex_state = 12, .external_lex_state = 3},
  [192] = {.lex_state = 12, .external_lex_state = 3},
  [193] = {.lex_state = 12, .external_lex_state = 3},
  [194] = {.lex_state = 12, .external_lex_state = 3},
  [195] = {.lex_state = 12, .external_lex_state = 3},
  [196] = {.lex_state = 12, .external_lex_state = 3},
  [197] = {.lex_state = 12, .external_lex_state = 3},
  [198] = {.lex_state = 12, .external_lex_state = 3},
  [199] = {.lex_state = 12, .external_lex_state = 3},
  [200] = {.lex_state = 12, .external_lex_state = 3},
  [201] = {.lex_state = 12, .external_lex_state = 3},
  [202] = {.lex_state = 12, .external_lex_state = 3},
  [203] = {.lex_state = 12, .external_lex_state = 3},
  [204] = {.lex_state = 12, .external_lex_state = 3},
  [205] = {.lex_state = 12, .external_lex_state = 3},
  [206] = {.lex_state = 12, .external_lex_state = 3},
  [207] = {.lex_state = 12, .external_lex_state = 3},
  [208] = {.lex_state = 12, .external_lex_state = 3},
  [209] = {.lex_state = 12, .external_lex_state = 3},
  [210] = {.lex_state = 12, .external_lex_state = 3},
  [211] = {.lex_state = 12, .external_lex_state = 3},
  [212] = {.lex_state = 12, .external_lex_state = 3},
  [213] = {.lex_state = 12, .external_lex_state = 3},
  [214] = {.lex_state = 12, .external_lex_state = 3},
  [215] = {.lex_state = 12, .external_lex_state = 3},
  [216] = {.lex_state = 12, .external_lex_state = 3},
  [217] = {.lex_state = 12, .external_lex_state = 3},
  [218] = {.lex_state = 12, .external_lex_state = 3},
  [219] = {.lex_state = 12, .external_lex_state = 3},
  [220] = {.lex_state = 12, .external_lex_state = 3},
  [221] = {.lex_state = 12, .external_lex_state = 3},
  [222] = {.lex_state = 12, .external_lex_state = 3},
  [223] = {.lex_state = 12, .external_lex_state = 3},
  [224] = {.lex_state = 12, .external_lex_state = 3},
  [225] = {.lex_state = 12, .external_lex_state = 3},
  [226] = {.lex_state = 12, .external_lex_state = 3},
  [227] = {.lex_state = 12, .external_lex_state = 3},
  [228] = {.lex_state = 12, .external_lex_state = 3},
  [229] = {.lex_state = 12, .external_lex_state = 3},
  [230] = {.lex_state = 12, .external_lex_state = 3},
  [231] = {.lex_state = 12, .external_lex_state = 3},
  [232] = {.lex_state = 12, .external_lex_state = 3},
  [233] = {.lex_state = 12, .external_lex_state = 3},
  [234] = {.lex_state = 12, .external_lex_state = 3},
  [235] = {.lex_state = 12, .external_lex_state = 3},
  [236] = {.lex_state = 12, .external_lex_state = 3},
  [237] = {.lex_state = 12, .external_lex_state = 3},
  [238] = {.lex_state = 12, .external_lex_state = 3},
  [239] = {.lex_state = 12, .external_lex_state = 3},
  [240] = {.lex_state = 12, .external_lex_state = 3},
  [241] = {.lex_state = 12, .external_lex_state = 3},
  [242] = {.lex_state = 12, .external_lex_state = 3},
  [243] = {.lex_state = 12, .external_lex_state = 3},
  [244] = {.lex_state = 12, .external_lex_state = 3},
  [245] = {.lex_state = 12, .external_lex_state = 3},
  [246] = {.lex_state = 12, .external_lex_state = 3},
  [247] = {.lex_state = 12, .external_lex_state = 3},
  [248] = {.lex_state = 12, .external_lex_state = 3},
  [249] = {.lex_state = 12, .external_lex_state = 3},
  [250] = {.lex_state = 12, .external_lex_state = 3},
  [251] = {.lex_state = 12, .external_lex_state = 3},
  [252] = {.lex_state = 12, .external_lex_state = 3},
  [253] = {.lex_state = 12, .external_lex_state = 3},
  [254] = {.lex_state = 12, .external_lex_state = 3},
  [255] = {.lex_state = 12, .external_lex_state = 3},
  [256] = {.lex_state = 12, .external_lex_state = 3},
  [257] = {.lex_state = 12, .external_lex_state = 3},
  [258] = {.lex_state = 12, .external_lex_state = 3},
  [259] = {.lex_state = 12, .external_lex_state = 3},
  [260] = {.lex_state = 12, .external_lex_state = 3},
  [261] = {.lex_state = 12, .external_lex_state = 3},
  [262] = {.lex_state = 12, .external_lex_state = 3},
  [263] = {.lex_state = 12, .external_lex_state = 3},
  [264] = {.lex_state = 12, .external_lex_state = 3},
  [265] = {.lex_state = 12, .external_lex_state = 3},
  [266] = {.lex_state = 12, .external_lex_state = 3},
  [267] = {.lex_state = 12, .external_lex_state = 3},
  [268] = {.lex_state = 12, .external_lex_state = 3},
  [269] = {.lex_state = 12, .external_lex_state = 3},
  [270] = {.lex_state = 12, .external_lex_state = 3},
  [271] = {.lex_state = 12, .external_lex_state = 3},
  [272] = {.lex_state = 12, .external_lex_state = 3},
  [273] = {.lex_state = 12, .external_lex_state = 3},
  [274] = {.lex_state = 12, .external_lex_state = 3},
  [275] = {.lex_state = 12, .external_lex_state = 3},
  [276] = {.lex_state = 12, .external_lex_state = 3},
  [277] = {.lex_state = 12, .external_lex_state = 3},
  [278] = {.lex_state = 12, .external_lex_state = 3},
  [279] = {.lex_state = 12, .external_lex_state = 3},
  [280] = {.lex_state = 12, .external_lex_state = 3},
  [281] = {.lex_state = 12, .external_lex_state = 3},
  [282] = {.lex_state = 12, .external_lex_state = 3},
  [283] = {.lex_state = 12, .external_lex_state = 3},
  [284] = {.lex_state = 12, .external_lex_state = 3},
  [285] = {.lex_state = 12, .external_lex_state = 3},
  [286] = {.lex_state = 12, .external_lex_state = 3},
  [287] = {.lex_state = 12, .external_lex_state = 3},
  [288] = {.lex_state = 12, .external_lex_state = 3},
  [289] = {.lex_state = 12, .external_lex_state = 3},
  [290] = {.lex_state = 12, .external_lex_state = 3},
  [291] = {.lex_state = 12, .external_lex_state = 3},
  [292] = {.lex_state = 12, .external_lex_state = 3},
  [293] = {.lex_state = 12, .external_lex_state = 3},
  [294] = {.lex_state = 12, .external_lex_state = 3},
  [295] = {.lex_state = 12, .external_lex_state = 3},
  [296] = {.lex_state = 12, .external_lex_state = 3},
  [297] = {.lex_state = 12, .external_lex_state = 3},
  [298] = {.lex_state = 12, .external_lex_state = 3},
  [299] = {.lex_state = 12, .external_lex_state = 3},
  [300] = {.lex_state = 12, .external_lex_state = 3},
  [301] = {.lex_state = 12, .external_lex_state = 3},
  [302] = {.lex_state = 12, .external_lex_state = 3},
  [303] = {.lex_state = 12, .external_lex_state = 3},
  [304] = {.lex_state = 12, .external_lex_state = 3},
  [305] = {.lex_state = 12, .external_lex_state = 3},
  [306] = {.lex_state = 12, .external_lex_state = 3},
  [307] = {.lex_state = 12, .external_lex_state = 3},
  [308] = {.lex_state = 12, .external_lex_state = 3},
  [309] = {.lex_state = 12, .external_lex_state = 3},
  [310] = {.lex_state = 12, .external_lex_state = 3},
  [311] = {.lex_state = 12, .external_lex_state = 3},
  [312] = {.lex_state = 12, .external_lex_state = 3},
  [313] = {.lex_state = 12, .external_lex_state = 3},
  [314] = {.lex_state = 12, .external_lex_state = 3},
  [315] = {.lex_state = 12, .external_lex_state = 3},
  [316] = {.lex_state = 12, .external_lex_state = 3},
  [317] = {.lex_state = 12, .external_lex_state = 3},
  [318] = {.lex_state = 12, .external_lex_state = 3},
  [319] = {.lex_state = 12, .external_lex_state = 3},
  [320] = {.lex_state = 12, .external_lex_state = 3},
  [321] = {.lex_state = 12, .external_lex_state = 3},
  [322] = {.lex_state = 12, .external_lex_state = 3},
  [323] = {.lex_state = 12, .external_lex_state = 3},
  [324] = {.lex_state = 12, .external_lex_state = 3},
  [325] = {.lex_state = 12, .external_lex_state = 3},
  [326] = {.lex_state = 12, .external_lex_state = 3},
  [327] = {.lex_state = 12, .external_lex_state = 3},
  [328] = {.lex_state = 12, .external_lex_state = 3},
  [329] = {.lex_state = 12, .external_lex_state = 3},
  [330] = {.lex_state = 12, .external_lex_state = 3},
  [331] = {.lex_state = 12, .external_lex_state = 3},
  [332] = {.lex_state = 12, .external_lex_state = 3},
  [333] = {.lex_state = 12, .external_lex_state = 3},
  [334] = {.lex_state = 12, .external_lex_state = 3},
  [335] = {.lex_state = 12, .external_lex_state = 3},
  [336] = {.lex_state = 12, .external_lex_state = 3},
  [337] = {.lex_state = 12, .external_lex_state = 3},
  [338] = {.lex_state = 12, .external_lex_state = 3},
  [339] = {.lex_state = 12, .external_lex_state = 3},
  [340] = {.lex_state = 12, .external_lex_state = 3},
  [341] = {.lex_state = 12, .external_lex_state = 3},
  [342] = {.lex_state = 12, .external_lex_state = 3},
  [343] = {.lex_state = 12, .external_lex_state = 3},
  [344] = {.lex_state = 12, .external_lex_state = 3},
  [345] = {.lex_state = 12, .external_lex_state = 3},
  [346] = {.lex_state = 12, .external_lex_state = 3},
  [347] = {.lex_state = 12, .external_lex_state = 3},
  [348] = {.lex_state = 12, .external_lex_state = 3},
  [349] = {.lex_state = 12, .external_lex_state = 3},
  [350] = {.lex_state = 12, .external_lex_state = 3},
  [351] = {.lex_state = 12, .external_lex_state = 3},
  [352] = {.lex_state = 12, .external_lex_state = 3},
  [353] = {.lex_state = 12, .external_lex_state = 3},
  [354] = {.lex_state = 12, .external_lex_state = 3},
  [355] = {.lex_state = 12, .external_lex_state = 3},
  [356] = {.lex_state = 12, .external_lex_state = 3},
  [357] = {.lex_state = 12, .external_lex_state = 3},
  [358] = {.lex_state = 12, .external_lex_state = 3},
  [359] = {.lex_state = 12, .external_lex_state = 3},
  [360] = {.lex_state = 12, .external_lex_state = 3},
  [361] = {.lex_state = 12, .external_lex_state = 3},
  [362] = {.lex_state = 12, .external_lex_state = 3},
  [363] = {.lex_state = 12, .external_lex_state = 3},
  [364] = {.lex_state = 12, .external_lex_state = 3},
  [365] = {.lex_state = 12, .external_lex_state = 3},
  [366] = {.lex_state = 12, .external_lex_state = 3},
  [367] = {.lex_state = 12, .external_lex_state = 3},
  [368] = {.lex_state = 12, .external_lex_state = 3},
  [369] = {.lex_state = 12, .external_lex_state = 3},
  [370] = {.lex_state = 12, .external_lex_state = 3},
  [371] = {.lex_state = 12, .external_lex_state = 3},
  [372] = {.lex_state = 12, .external_lex_state = 3},
  [373] = {.lex_state = 12, .external_lex_state = 3},
  [374] = {.lex_state = 12, .external_lex_state = 3},
  [375] = {.lex_state = 12, .external_lex_state = 3},
  [376] = {.lex_state = 12, .external_lex_state = 3},
  [377] = {.lex_state = 12, .external_lex_state = 3},
  [378] = {.lex_state = 12, .external_lex_state = 3},
  [379] = {.lex_state = 12, .external_lex_state = 3},
  [380] = {.lex_state = 12, .external_lex_state = 3},
  [381] = {.lex_state = 12, .external_lex_state = 3},
  [382] = {.lex_state = 12, .external_lex_state = 3},
  [383] = {.lex_state = 12, .external_lex_state = 3},
  [384] = {.lex_state = 12, .external_lex_state = 3},
  [385] = {.lex_state = 12, .external_lex_state = 3},
  [386] = {.lex_state = 12, .external_lex_state = 3},
  [387] = {.lex_state = 12, .external_lex_state = 3},
  [388] = {.lex_state = 12, .external_lex_state = 3},
  [389] = {.lex_state = 12, .external_lex_state = 3},
  [390] = {.lex_state = 12, .external_lex_state = 3},
  [391] = {.lex_state = 12, .external_lex_state = 3},
  [392] = {.lex_state = 12, .external_lex_state = 3},
  [393] = {.lex_state = 12, .external_lex_state = 3},
  [394] = {.lex_state = 12, .external_lex_state = 3},
  [395] = {.lex_state = 12, .external_lex_state = 3},
  [396] = {.lex_state = 12, .external_lex_state = 3},
  [397] = {.lex_state = 12, .external_lex_state = 3},
  [398] = {.lex_state = 12, .external_lex_state = 3},
  [399] = {.lex_state = 12, .external_lex_state = 3},
  [400] = {.lex_state = 12, .external_lex_state = 3},
  [401] = {.lex_state = 12, .external_lex_state = 3},
  [402] = {.lex_state = 12, .external_lex_state = 3},
  [403] = {.lex_state = 12, .external_lex_state = 3},
  [404] = {.lex_state = 12, .external_lex_state = 3},
  [405] = {.lex_state = 12, .external_lex_state = 3},
  [406] = {.lex_state = 12, .external_lex_state = 3},
  [407] = {.lex_state = 12, .external_lex_state = 3},
  [408] = {.lex_state = 12, .external_lex_state = 3},
  [409] = {.lex_state = 12, .external_lex_state = 3},
  [410] = {.lex_state = 12, .external_lex_state = 3},
  [411] = {.lex_state = 12, .external_lex_state = 3},
  [412] = {.lex_state = 12, .external_lex_state = 3},
  [413] = {.lex_state = 12, .external_lex_state = 3},
  [414] = {.lex_state = 12, .external_lex_state = 3},
  [415] = {.lex_state = 12, .external_lex_state = 3},
  [416] = {.lex_state = 12, .external_lex_state = 3},
  [417] = {.lex_state = 12, .external_lex_state = 3},
  [418] = {.lex_state = 12, .external_lex_state = 3},
  [419] = {.lex_state = 12, .external_lex_state = 3},
  [420] = {.lex_state = 12, .external_lex_state = 3},
  [421] = {.lex_state = 12, .external_lex_state = 3},
  [422] = {.lex_state = 12, .external_lex_state = 3},
  [423] = {.lex_state = 12, .external_lex_state = 3},
  [424] = {.lex_state = 12, .external_lex_state = 3},
  [425] = {.lex_state = 12, .external_lex_state = 3},
  [426] = {.lex_state = 12, .external_lex_state = 3},
  [427] = {.lex_state = 12, .external_lex_state = 3},
  [428] = {.lex_state = 12, .external_lex_state = 3},
  [429] = {.lex_state = 12, .external_lex_state = 3},
  [430] = {.lex_state = 12, .external_lex_state = 3},
  [431] = {.lex_state = 12, .external_lex_state = 3},
  [432] = {.lex_state = 12, .external_lex_state = 3},
  [433] = {.lex_state = 12, .external_lex_state = 3},
  [434] = {.lex_state = 12, .external_lex_state = 3},
  [435] = {.lex_state = 12, .external_lex_state = 3},
  [436] = {.lex_state = 12, .external_lex_state = 3},
  [437] = {.lex_state = 12, .external_lex_state = 3},
  [438] = {.lex_state = 12, .external_lex_state = 3},
  [439] = {.lex_state = 12, .external_lex_state = 3},
  [440] = {.lex_state = 12, .external_lex_state = 3},
  [441] = {.lex_state = 12, .external_lex_state = 3},
  [442] = {.lex_state = 12, .external_lex_state = 3},
  [443] = {.lex_state = 12, .external_lex_state = 3},
  [444] = {.lex_state = 12, .external_lex_state = 3},
  [445] = {.lex_state = 12, .external_lex_state = 3},
  [446] = {.lex_state = 12, .external_lex_state = 3},
  [447] = {.lex_state = 12, .external_lex_state = 3},
  [448] = {.lex_state = 12, .external_lex_state = 3},
  [449] = {.lex_state = 12, .external_lex_state = 3},
  [450] = {.lex_state = 12, .external_lex_state = 3},
  [451] = {.lex_state = 12, .external_lex_state = 3},
  [452] = {.lex_state = 12, .external_lex_state = 3},
  [453] = {.lex_state = 12, .external_lex_state = 3},
  [454] = {.lex_state = 12, .external_lex_state = 3},
  [455] = {.lex_state = 12, .external_lex_state = 3},
  [456] = {.lex_state = 12, .external_lex_state = 3},
  [457] = {.lex_state = 12, .external_lex_state = 3},
  [458] = {.lex_state = 12, .external_lex_state = 3},
  [459] = {.lex_state = 12, .external_lex_state = 3},
  [460] = {.lex_state = 12, .external_lex_state = 3},
  [461] = {.lex_state = 12, .external_lex_state = 3},
  [462] = {.lex_state = 12, .external_lex_state = 3},
  [463] = {.lex_state = 12, .external_lex_state = 3},
  [464] = {.lex_state = 12, .external_lex_state = 3},
  [465] = {.lex_state = 12, .external_lex_state = 3},
  [466] = {.lex_state = 12, .external_lex_state = 3},
  [467] = {.lex_state = 12, .external_lex_state = 3},
  [468] = {.lex_state = 12, .external_lex_state = 3},
  [469] = {.lex_state = 12, .external_lex_state = 3},
  [470] = {.lex_state = 12, .external_lex_state = 3},
  [471] = {.lex_state = 12, .external_lex_state = 3},
  [472] = {.lex_state = 12, .external_lex_state = 3},
  [473] = {.lex_state = 12, .external_lex_state = 3},
  [474] = {.lex_state = 12, .external_lex_state = 3},
  [475] = {.lex_state = 12, .external_lex_state = 3},
  [476] = {.lex_state = 12, .external_lex_state = 3},
  [477] = {.lex_state = 12, .external_lex_state = 3},
  [478] = {.lex_state = 12, .external_lex_state = 3},
  [479] = {.lex_state = 12, .external_lex_state = 3},
  [480] = {.lex_state = 12, .external_lex_state = 3},
  [481] = {.lex_state = 12, .external_lex_state = 3},
  [482] = {.lex_state = 12, .external_lex_state = 3},
  [483] = {.lex_state = 12, .external_lex_state = 3},
  [484] = {.lex_state = 12, .external_lex_state = 3},
  [485] = {.lex_state = 12, .external_lex_state = 3},
  [486] = {.lex_state = 12, .external_lex_state = 3},
  [487] = {.lex_state = 12, .external_lex_state = 3},
  [488] = {.lex_state = 12, .external_lex_state = 3},
  [489] = {.lex_state = 12, .external_lex_state = 3},
  [490] = {.lex_state = 12, .external_lex_state = 3},
  [491] = {.lex_state = 12, .external_lex_state = 3},
  [492] = {.lex_state = 12, .external_lex_state = 3},
  [493] = {.lex_state = 12, .external_lex_state = 3},
  [494] = {.lex_state = 12, .external_lex_state = 3},
  [495] = {.lex_state = 12, .external_lex_state = 3},
  [496] = {.lex_state = 12, .external_lex_state = 3},
  [497] = {.lex_state = 12, .external_lex_state = 3},
  [498] = {.lex_state = 12, .external_lex_state = 3},
  [499] = {.lex_state = 12, .external_lex_state = 3},
  [500] = {.lex_state = 12, .external_lex_state = 3},
  [501] = {.lex_state = 12, .external_lex_state = 3},
  [502] = {.lex_state = 12, .external_lex_state = 3},
  [503] = {.lex_state = 12, .external_lex_state = 3},
  [504] = {.lex_state = 12, .external_lex_state = 3},
  [505] = {.lex_state = 12, .external_lex_state = 3},
  [506] = {.lex_state = 12, .external_lex_state = 3},
  [507] = {.lex_state = 12, .external_lex_state = 3},
  [508] = {.lex_state = 12, .external_lex_state = 3},
  [509] = {.lex_state = 12, .external_lex_state = 3},
  [510] = {.lex_state = 12, .external_lex_state = 3},
  [511] = {.lex_state = 12, .external_lex_state = 3},
  [512] = {.lex_state = 12, .external_lex_state = 3},
  [513] = {.lex_state = 12, .external_lex_state = 3},
  [514] = {.lex_state = 12, .external_lex_state = 3},
  [515] = {.lex_state = 12, .external_lex_state = 3},
  [516] = {.lex_state = 12, .external_lex_state = 3},
  [517] = {.lex_state = 12, .external_lex_state = 3},
  [518] = {.lex_state = 12, .external_lex_state = 3},
  [519] = {.lex_state = 12, .external_lex_state = 3},
  [520] = {.lex_state = 12, .external_lex_state = 3},
  [521] = {.lex_state = 12, .external_lex_state = 3},
  [522] = {.lex_state = 12, .external_lex_state = 3},
  [523] = {.lex_state = 0, .external_lex_state = 3},
  [524] = {.lex_state = 0, .external_lex_state = 3},
  [525] = {.lex_state = 0, .external_lex_state = 3},
  [526] = {.lex_state = 0, .external_lex_state = 3},
  [527] = {.lex_state = 0, .external_lex_state = 3},
  [528] = {.lex_state = 0, .external_lex_state = 3},
  [529] = {.lex_state = 0, .external_lex_state = 3},
  [530] = {.lex_state = 0, .external_lex_state = 3},
  [531] = {.lex_state = 0, .external_lex_state = 3},
  [532] = {.lex_state = 0, .external_lex_state = 3},
  [533] = {.lex_state = 0, .external_lex_state = 3},
  [534] = {.lex_state = 0, .external_lex_state = 3},
  [535] = {.lex_state = 0, .external_lex_state = 3},
  [536] = {.lex_state = 0, .external_lex_state = 3},
  [537] = {.lex_state = 0, .external_lex_state = 3},
  [538] = {.lex_state = 0, .external_lex_state = 3},
  [539] = {.lex_state = 0, .external_lex_state = 3},
  [540] = {.lex_state = 0, .external_lex_state = 3},
  [541] = {.lex_state = 0, .external_lex_state = 3},
  [542] = {.lex_state = 0, .external_lex_state = 3},
  [543] = {.lex_state = 0, .external_lex_state = 3},
  [544] = {.lex_state = 0, .external_lex_state = 3},
  [545] = {.lex_state = 0, .external_lex_state = 3},
  [546] = {.lex_state = 0, .external_lex_state = 3},
  [547] = {.lex_state = 0, .external_lex_state = 3},
  [548] = {.lex_state = 0, .external_lex_state = 3},
  [549] = {.lex_state = 0, .external_lex_state = 3},
  [550] = {.lex_state = 12, .external_lex_state = 3},
  [551] = {.lex_state = 12, .external_lex_state = 3},
  [552] = {.lex_state = 12, .external_lex_state = 3},
  [553] = {.lex_state = 12, .external_lex_state = 3},
  [554] = {.lex_state = 12, .external_lex_state = 3},
  [555] = {.lex_state = 12, .external_lex_state = 3},
  [556] = {.lex_state = 12, .external_lex_state = 3},
  [557] = {.lex_state = 12, .external_lex_state = 3},
  [558] = {.lex_state = 4, .external_lex_state = 3},
  [559] = {.lex_state = 4, .external_lex_state = 3},
  [560] = {.lex_state = 4, .external_lex_state = 3},
  [561] = {.lex_state = 4, .external_lex_state = 3},
  [562] = {.lex_state = 4, .external_lex_state = 3},
  [563] = {.lex_state = 4, .external_lex_state = 3},
  [564] = {.lex_state = 4, .external_lex_state = 3},
  [565] = {.lex_state = 4, .external_lex_state = 3},
  [566] = {.lex_state = 4, .external_lex_state = 3},
  [567] = {.lex_state = 4, .external_lex_state = 3},
  [568] = {.lex_state = 4, .external_lex_state = 3},
  [569] = {.lex_state = 4, .external_lex_state = 3},
  [570] = {.lex_state = 4, .external_lex_state = 3},
  [571] = {.lex_state = 4, .external_lex_state = 3},
  [572] = {.lex_state = 4, .external_lex_state = 3},
  [573] = {.lex_state = 4, .external_lex_state = 3},
  [574] = {.lex_state = 4, .external_lex_state = 3},
  [575] = {.lex_state = 4, .external_lex_state = 3},
  [576] = {.lex_state = 4, .external_lex_state = 3},
  [577] = {.lex_state = 4, .external_lex_state = 3},
  [578] = {.lex_state = 4, .external_lex_state = 3},
  [579] = {.lex_state = 4, .external_lex_state = 3},
  [580] = {.lex_state = 4, .external_lex_state = 3},
  [581] = {.lex_state = 4, .external_lex_state = 3},
  [582] = {.lex_state = 4, .external_lex_state = 3},
  [583] = {.lex_state = 4, .external_lex_state = 3},
  [584] = {.lex_state = 4, .external_lex_state = 3},
  [585] = {.lex_state = 4, .external_lex_state = 3},
  [586] = {.lex_state = 4, .external_lex_state = 3},
  [587] = {.lex_state = 4, .external_lex_state = 3},
  [588] = {.lex_state = 4, .external_lex_state = 3},
  [589] = {.lex_state = 12, .external_lex_state = 3},
  [590] = {.lex_state = 12, .external_lex_state = 3},
  [591] = {.lex_state = 4, .external_lex_state = 3},
  [592] = {.lex_state = 12, .external_lex_state = 3},
  [593] = {.lex_state = 4, .external_lex_state = 3},
  [594] = {.lex_state = 4, .external_lex_state = 3},
  [595] = {.lex_state = 4, .external_lex_state = 3},
  [596] = {.lex_state = 4, .external_lex_state = 3},
  [597] = {.lex_state = 4, .external_lex_state = 3},
  [598] = {.lex_state = 12, .external_lex_state = 3},
  [599] = {.lex_state = 12, .external_lex_state = 3},
  [600] = {.lex_state = 4, .external_lex_state = 3},
  [601] = {.lex_state = 12, .external_lex_state = 3},
  [602] = {.lex_state = 4, .external_lex_state = 3},
  [603] = {.lex_state = 12, .external_lex_state = 3},
  [604] = {.lex_state = 12, .external_lex_state = 3},
  [605] = {.lex_state = 4, .external_lex_state = 3},
  [606] = {.lex_state = 4, .external_lex_state = 3},
  [607] = {.lex_state = 12, .external_lex_state = 3},
  [608] = {.lex_state = 12, .external_lex_state = 3},
  [609] = {.lex_state = 12, .external_lex_state = 3},
  [610] = {.lex_state = 12, .external_lex_state = 3},
  [611] = {.lex_state = 0, .external_lex_state = 3},
  [612] = {.lex_state = 0, .external_lex_state = 3},
  [613] = {.lex_state = 0, .external_lex_state = 3},
  [614] = {.lex_state = 0, .external_lex_state = 3},
  [615] = {.lex_state = 0, .external_lex_state = 3},
  [616] = {.lex_state = 0, .external_lex_state = 3},
  [617] = {.lex_state = 0, .external_lex_state = 3},
  [618] = {.lex_state = 0, .external_lex_state = 3},
  [619] = {.lex_state = 0, .external_lex_state = 3},
  [620] = {.lex_state = 0, .external_lex_state = 3},
  [621] = {.lex_state = 0, .external_lex_state = 3},
  [622] = {.lex_state = 0, .external_lex_state = 3},
  [623] = {.lex_state = 0, .external_lex_state = 3},
  [624] = {.lex_state = 0, .external_lex_state = 3},
  [625] = {.lex_state = 0, .external_lex_state = 3},
  [626] = {.lex_state = 0, .external_lex_state = 3},
  [627] = {.lex_state = 0, .external_lex_state = 3},
  [628] = {.lex_state = 0, .external_lex_state = 3},
  [629] = {.lex_state = 0, .external_lex_state = 3},
  [630] = {.lex_state = 0, .external_lex_state = 3},
  [631] = {.lex_state = 0, .external_lex_state = 3},
  [632] = {.lex_state = 4, .external_lex_state = 3},
  [633] = {.lex_state = 4, .external_lex_state = 3},
  [634] = {.lex_state = 4, .external_lex_state = 3},
  [635] = {.lex_state = 4, .external_lex_state = 3},
  [636] = {.lex_state = 4, .external_lex_state = 3},
  [637] = {.lex_state = 4, .external_lex_state = 3},
  [638] = {.lex_state = 4, .external_lex_state = 3},
  [639] = {.lex_state = 4, .external_lex_state = 3},
  [640] = {.lex_state = 4, .external_lex_state = 3},
  [641] = {.lex_state = 4, .external_lex_state = 3},
  [642] = {.lex_state = 4, .external_lex_state = 3},
  [643] = {.lex_state = 4, .external_lex_state = 3},
  [644] = {.lex_state = 4, .external_lex_state = 3},
  [645] = {.lex_state = 4, .external_lex_state = 3},
  [646] = {.lex_state = 4, .external_lex_state = 3},
  [647] = {.lex_state = 4, .external_lex_state = 3},
  [648] = {.lex_state = 4, .external_lex_state = 3},
  [649] = {.lex_state = 4, .external_lex_state = 3},
  [650] = {.lex_state = 4, .external_lex_state = 3},
  [651] = {.lex_state = 4, .external_lex_state = 3},
  [652] = {.lex_state = 5, .external_lex_state = 1},
  [653] = {.lex_state = 5, .external_lex_state = 1},
  [654] = {.lex_state = 5, .external_lex_state = 1},
  [655] = {.lex_state = 5, .external_lex_state = 1},
  [656] = {.lex_state = 5, .external_lex_state = 1},
  [657] = {.lex_state = 5, .external_lex_state = 1},
  [658] = {.lex_state = 5, .external_lex_state = 1},
  [659] = {.lex_state = 5, .external_lex_state = 1},
  [660] = {.lex_state = 5, .external_lex_state = 1},
  [661] = {.lex_state = 5, .external_lex_state = 1},
  [662] = {.lex_state = 5, .external_lex_state = 1},
  [663] = {.lex_state = 5, .external_lex_state = 1},
  [664] = {.lex_state = 13, .external_lex_state = 3},
  [665] = {.lex_state = 13, .external_lex_state = 3},
  [666] = {.lex_state = 13, .external_lex_state = 3},
  [667] = {.lex_state = 13, .external_lex_state = 3},
  [668] = {.lex_state = 5, .external_lex_state = 1},
  [669] = {.lex_state = 13, .external_lex_state = 3},
  [670] = {.lex_state = 5, .external_lex_state = 1},
  [671] = {.lex_state = 13, .external_lex_state = 3},
  [672] = {.lex_state = 5, .external_lex_state = 1},
  [673] = {.lex_state = 5, .external_lex_state = 1},
  [674] = {.lex_state = 13, .external_lex_state = 3},
  [675] = {.lex_state = 13, .external_lex_state = 3},
  [676] = {.lex_state = 13, .external_lex_state = 3},
  [677] = {.lex_state = 5, .external_lex_state = 1},
  [678] = {.lex_state = 5, .external_lex_state = 1},
  [679] = {.lex_state = 13, .external_lex_state = 3},
  [680] = {.lex_state = 13, .external_lex_state = 3},
  [681] = {.lex_state = 5, .external_lex_state = 1},
  [682] = {.lex_state = 5, .external_lex_state = 1},
  [683] = {.lex_state = 13, .external_lex_state = 3},
  [684] = {.lex_state = 13, .external_lex_state = 3},
  [685] = {.lex_state = 13, .external_lex_state = 3},
  [686] = {.lex_state = 13, .external_lex_state = 3},
  [687] = {.lex_state = 5, .external_lex_state = 1},
  [688] = {.lex_state = 5, .external_lex_state = 1},
  [689] = {.lex_state = 12, .external_lex_state = 3},
  [690] = {.lex_state = 12, .external_lex_state = 3},
  [691] = {.lex_state = 12, .external_lex_state = 3},
  [692] = {.lex_state = 12, .external_lex_state = 3},
  [693] = {.lex_state = 12, .external_lex_state = 3},
  [694] = {.lex_state = 12, .external_lex_state = 3},
  [695] = {.lex_state = 12, .external_lex_state = 3},
  [696] = {.lex_state = 12, .external_lex_state = 3},
  [697] = {.lex_state = 12, .external_lex_state = 3},
  [698] = {.lex_state = 12, .external_lex_state = 3},
  [699] = {.lex_state = 12, .external_lex_state = 3},
  [700] = {.lex_state = 12, .external_lex_state = 3},
  [701] = {.lex_state = 12, .external_lex_state = 3},
  [702] = {.lex_state = 12, .external_lex_state = 3},
  [703] = {.lex_state = 12, .external_lex_state = 3},
  [704] = {.lex_state = 12, .external_lex_state = 3},
  [705] = {.lex_state = 12, .external_lex_state = 3},
  [706] = {.lex_state = 12, .external_lex_state = 3},
  [707] = {.lex_state = 12, .external_lex_state = 3},
  [708] = {.lex_state = 12, .external_lex_state = 3},
  [709] = {.lex_state = 12, .external_lex_state = 3},
  [710] = {.lex_state = 12, .external_lex_state = 3},
  [711] = {.lex_state = 12, .external_lex_state = 3},
  [712] = {.lex_state = 12, .external_lex_state = 3},
  [713] = {.lex_state = 12, .external_lex_state = 3},
  [714] = {.lex_state = 12, .external_lex_state = 3},
  [715] = {.lex_state = 12, .external_lex_state = 3},
  [716] = {.lex_state = 12, .external_lex_state = 3},
  [717] = {.lex_state = 12, .external_lex_state = 3},
  [718] = {.lex_state = 12, .external_lex_state = 3},
  [719] = {.lex_state = 12, .external_lex_state = 3},
  [720] = {.lex_state = 12, .external_lex_state = 3},
  [721] = {.lex_state = 12, .external_lex_state = 3},
  [722] = {.lex_state = 12, .external_lex_state = 3},
  [723] = {.lex_state = 12, .external_lex_state = 3},
  [724] = {.lex_state = 12, .external_lex_state = 3},
  [725] = {.lex_state = 12, .external_lex_state = 3},
  [726] = {.lex_state = 12, .external_lex_state = 3},
  [727] = {.lex_state = 12, .external_lex_state = 3},
  [728] = {.lex_state = 12, .external_lex_state = 3},
  [729] = {.lex_state = 12, .external_lex_state = 3},
  [730] = {.lex_state = 12, .external_lex_state = 3},
  [731] = {.lex_state = 12, .external_lex_state = 3},
  [732] = {.lex_state = 12, .external_lex_state = 3},
  [733] = {.lex_state = 12, .external_lex_state = 3},
  [734] = {.lex_state = 12, .external_lex_state = 3},
  [735] = {.lex_state = 12, .external_lex_state = 3},
  [736] = {.lex_state = 12, .external_lex_state = 3},
  [737] = {.lex_state = 12, .external_lex_state = 3},
  [738] = {.lex_state = 12, .external_lex_state = 3},
  [739] = {.lex_state = 12, .external_lex_state = 3},
  [740] = {.lex_state = 12, .external_lex_state = 3},
  [741] = {.lex_state = 12, .external_lex_state = 3},
  [742] = {.lex_state = 12, .external_lex_state = 3},
  [743] = {.lex_state = 12, .external_lex_state = 3},
  [744] = {.lex_state = 12, .external_lex_state = 3},
  [745] = {.lex_state = 12, .external_lex_state = 3},
  [746] = {.lex_state = 12, .external_lex_state = 3},
  [747] = {.lex_state = 12, .external_lex_state = 3},
  [748] = {.lex_state = 12, .external_lex_state = 3},
  [749] = {.lex_state = 12, .external_lex_state = 3},
  [750] = {.lex_state = 12, .external_lex_state = 3},
  [751] = {.lex_state = 12, .external_lex_state = 3},
  [752] = {.lex_state = 12, .external_lex_state = 3},
  [753] = {.lex_state = 12, .external_lex_state = 3},
  [754] = {.lex_state = 12, .external_lex_state = 3},
  [755] = {.lex_state = 12, .external_lex_state = 3},
  [756] = {.lex_state = 12, .external_lex_state = 3},
  [757] = {.lex_state = 12, .external_lex_state = 3},
  [758] = {.lex_state = 12, .external_lex_state = 3},
  [759] = {.lex_state = 12, .external_lex_state = 3},
  [760] = {.lex_state = 12, .external_lex_state = 3},
  [761] = {.lex_state = 12, .external_lex_state = 3},
  [762] = {.lex_state = 12, .external_lex_state = 3},
  [763] = {.lex_state = 12, .external_lex_state = 3},
  [764] = {.lex_state = 12, .external_lex_state = 3},
  [765] = {.lex_state = 12, .external_lex_state = 3},
  [766] = {.lex_state = 12, .external_lex_state = 3},
  [767] = {.lex_state = 12, .external_lex_state = 3},
  [768] = {.lex_state = 12, .external_lex_state = 3},
  [769] = {.lex_state = 12, .external_lex_state = 3},
  [770] = {.lex_state = 12, .external_lex_state = 3},
  [771] = {.lex_state = 12, .external_lex_state = 3},
  [772] = {.lex_state = 12, .external_lex_state = 3},
  [773] = {.lex_state = 12, .external_lex_state = 3},
  [774] = {.lex_state = 12, .external_lex_state = 3},
  [775] = {.lex_state = 12, .external_lex_state = 3},
  [776] = {.lex_state = 12, .external_lex_state = 3},
  [777] = {.lex_state = 12, .external_lex_state = 3},
  [778] = {.lex_state = 12, .external_lex_state = 3},
  [779] = {.lex_state = 12, .external_lex_state = 3},
  [780] = {.lex_state = 12, .external_lex_state = 3},
  [781] = {.lex_state = 12, .external_lex_state = 3},
  [782] = {.lex_state = 12, .external_lex_state = 3},
  [783] = {.lex_state = 12, .external_lex_state = 3},
  [784] = {.lex_state = 12, .external_lex_state = 3},
  [785] = {.lex_state = 12, .external_lex_state = 3},
  [786] = {.lex_state = 12, .external_lex_state = 3},
  [787] = {.lex_state = 12, .external_lex_state = 3},
  [788] = {.lex_state = 12, .external_lex_state = 3},
  [789] = {.lex_state = 12, .external_lex_state = 3},
  [790] = {.lex_state = 12, .external_lex_state = 3},
  [791] = {.lex_state = 12, .external_lex_state = 3},
  [792] = {.lex_state = 12, .external_lex_state = 3},
  [793] = {.lex_state = 12, .external_lex_state = 3},
  [794] = {.lex_state = 12, .external_lex_state = 3},
  [795] = {.lex_state = 12, .external_lex_state = 3},
  [796] = {.lex_state = 12, .external_lex_state = 3},
  [797] = {.lex_state = 12, .external_lex_state = 3},
  [798] = {.lex_state = 12, .external_lex_state = 3},
  [799] = {.lex_state = 12, .external_lex_state = 3},
  [800] = {.lex_state = 12, .external_lex_state = 3},
  [801] = {.lex_state = 12, .external_lex_state = 3},
  [802] = {.lex_state = 12, .external_lex_state = 3},
  [803] = {.lex_state = 12, .external_lex_state = 3},
  [804] = {.lex_state = 12, .external_lex_state = 3},
  [805] = {.lex_state = 12, .external_lex_state = 3},
  [806] = {.lex_state = 12, .external_lex_state = 3},
  [807] = {.lex_state = 12, .external_lex_state = 3},
  [808] = {.lex_state = 12, .external_lex_state = 3},
  [809] = {.lex_state = 12, .external_lex_state = 3},
  [810] = {.lex_state = 12, .external_lex_state = 3},
  [811] = {.lex_state = 12, .external_lex_state = 3},
  [812] = {.lex_state = 12, .external_lex_state = 3},
  [813] = {.lex_state = 12, .external_lex_state = 3},
  [814] = {.lex_state = 12, .external_lex_state = 3},
  [815] = {.lex_state = 12, .external_lex_state = 3},
  [816] = {.lex_state = 12, .external_lex_state = 3},
  [817] = {.lex_state = 12, .external_lex_state = 3},
  [818] = {.lex_state = 12, .external_lex_state = 3},
  [819] = {.lex_state = 12, .external_lex_state = 3},
  [820] = {.lex_state = 12, .external_lex_state = 3},
  [821] = {.lex_state = 12, .external_lex_state = 3},
  [822] = {.lex_state = 12, .external_lex_state = 3},
  [823] = {.lex_state = 12, .external_lex_state = 3},
  [824] = {.lex_state = 12, .external_lex_state = 3},
  [825] = {.lex_state = 12, .external_lex_state = 3},
  [826] = {.lex_state = 12, .external_lex_state = 3},
  [827] = {.lex_state = 12, .external_lex_state = 3},
  [828] = {.lex_state = 12, .external_lex_state = 3},
  [829] = {.lex_state = 12, .external_lex_state = 3},
  [830] = {.lex_state = 12, .external_lex_state = 3},
  [831] = {.lex_state = 12, .external_lex_state = 3},
  [832] = {.lex_state = 12, .external_lex_state = 3},
  [833] = {.lex_state = 12, .external_lex_state = 3},
  [834] = {.lex_state = 12, .external_lex_state = 3},
  [835] = {.lex_state = 12, .external_lex_state = 3},
  [836] = {.lex_state = 12, .external_lex_state = 3},
  [837] = {.lex_state = 12, .external_lex_state = 3},
  [838] = {.lex_state = 12, .external_lex_state = 3},
  [839] = {.lex_state = 12, .external_lex_state = 3},
  [840] = {.lex_state = 12, .external_lex_state = 3},
  [841] = {.lex_state = 12, .external_lex_state = 3},
  [842] = {.lex_state = 12, .external_lex_state = 3},
  [843] = {.lex_state = 12, .external_lex_state = 3},
  [844] = {.lex_state = 12, .external_lex_state = 3},
  [845] = {.lex_state = 12, .external_lex_state = 3},
  [846] = {.lex_state = 12, .external_lex_state = 3},
  [847] = {.lex_state = 12, .external_lex_state = 3},
  [848] = {.lex_state = 12, .external_lex_state = 3},
  [849] = {.lex_state = 12, .external_lex_state = 3},
  [850] = {.lex_state = 12, .external_lex_state = 3},
  [851] = {.lex_state = 12, .external_lex_state = 3},
  [852] = {.lex_state = 12, .external_lex_state = 3},
  [853] = {.lex_state = 12, .external_lex_state = 3},
  [854] = {.lex_state = 12, .external_lex_state = 3},
  [855] = {.lex_state = 12, .external_lex_state = 3},
  [856] = {.lex_state = 12, .external_lex_state = 3},
  [857] = {.lex_state = 12, .external_lex_state = 3},
  [858] = {.lex_state = 12, .external_lex_state = 3},
  [859] = {.lex_state = 12, .external_lex_state = 3},
  [860] = {.lex_state = 12, .external_lex_state = 3},
  [861] = {.lex_state = 12, .external_lex_state = 3},
  [862] = {.lex_state = 12, .external_lex_state = 3},
  [863] = {.lex_state = 12, .external_lex_state = 3},
  [864] = {.lex_state = 12, .external_lex_state = 3},
  [865] = {.lex_state = 12, .external_lex_state = 3},
  [866] = {.lex_state = 12, .external_lex_state = 3},
  [867] = {.lex_state = 12, .external_lex_state = 3},
  [868] = {.lex_state = 12, .external_lex_state = 3},
  [869] = {.lex_state = 12, .external_lex_state = 3},
  [870] = {.lex_state = 12, .external_lex_state = 3},
  [871] = {.lex_state = 12, .external_lex_state = 3},
  [872] = {.lex_state = 12, .external_lex_state = 3},
  [873] = {.lex_state = 12, .external_lex_state = 3},
  [874] = {.lex_state = 12, .external_lex_state = 3},
  [875] = {.lex_state = 12, .external_lex_state = 3},
  [876] = {.lex_state = 12, .external_lex_state = 3},
  [877] = {.lex_state = 12, .external_lex_state = 3},
  [878] = {.lex_state = 12, .external_lex_state = 3},
  [879] = {.lex_state = 12, .external_lex_state = 3},
  [880] = {.lex_state = 12, .external_lex_state = 3},
  [881] = {.lex_state = 12, .external_lex_state = 3},
  [882] = {.lex_state = 12, .external_lex_state = 3},
  [883] = {.lex_state = 12, .external_lex_state = 3},
  [884] = {.lex_state = 12, .external_lex_state = 3},
  [885] = {.lex_state = 12, .external_lex_state = 3},
  [886] = {.lex_state = 12, .external_lex_state = 3},
  [887] = {.lex_state = 12, .external_lex_state = 3},
  [888] = {.lex_state = 12, .external_lex_state = 3},
  [889] = {.lex_state = 12, .external_lex_state = 3},
  [890] = {.lex_state = 12, .external_lex_state = 3},
  [891] = {.lex_state = 12, .external_lex_state = 3},
  [892] = {.lex_state = 12, .external_lex_state = 3},
  [893] = {.lex_state = 12, .external_lex_state = 3},
  [894] = {.lex_state = 12, .external_lex_state = 3},
  [895] = {.lex_state = 12, .external_lex_state = 3},
  [896] = {.lex_state = 12, .external_lex_state = 3},
  [897] = {.lex_state = 12, .external_lex_state = 3},
  [898] = {.lex_state = 12, .external_lex_state = 3},
  [899] = {.lex_state = 12, .external_lex_state = 3},
  [900] = {.lex_state = 12, .external_lex_state = 3},
  [901] = {.lex_state = 12, .external_lex_state = 3},
  [902] = {.lex_state = 12, .external_lex_state = 3},
  [903] = {.lex_state = 12, .external_lex_state = 3},
  [904] = {.lex_state = 12, .external_lex_state = 3},
  [905] = {.lex_state = 12, .external_lex_state = 3},
  [906] = {.lex_state = 12, .external_lex_state = 3},
  [907] = {.lex_state = 12, .external_lex_state = 3},
  [908] = {.lex_state = 12, .external_lex_state = 3},
  [909] = {.lex_state = 12, .external_lex_state = 3},
  [910] = {.lex_state = 12, .external_lex_state = 3},
  [911] = {.lex_state = 12, .external_lex_state = 3},
  [912] = {.lex_state = 12, .external_lex_state = 3},
  [913] = {.lex_state = 12, .external_lex_state = 3},
  [914] = {.lex_state = 12, .external_lex_state = 3},
  [915] = {.lex_state = 12, .external_lex_state = 3},
  [916] = {.lex_state = 12, .external_lex_state = 3},
  [917] = {.lex_state = 12, .external_lex_state = 3},
  [918] = {.lex_state = 12, .external_lex_state = 3},
  [919] = {.lex_state = 12, .external_lex_state = 3},
  [920] = {.lex_state = 12, .external_lex_state = 3},
  [921] = {.lex_state = 12, .external_lex_state = 3},
  [922] = {.lex_state = 12, .external_lex_state = 3},
  [923] = {.lex_state = 12, .external_lex_state = 3},
  [924] = {.lex_state = 12, .external_lex_state = 3},
  [925] = {.lex_state = 12, .external_lex_state = 3},
  [926] = {.lex_state = 12, .external_lex_state = 3},
  [927] = {.lex_state = 12, .external_lex_state = 3},
  [928] = {.lex_state = 12, .external_lex_state = 3},
  [929] = {.lex_state = 12, .external_lex_state = 3},
  [930] = {.lex_state = 12, .external_lex_state = 3},
  [931] = {.lex_state = 12, .external_lex_state = 3},
  [932] = {.lex_state = 12, .external_lex_state = 3},
  [933] = {.lex_state = 12, .external_lex_state = 3},
  [934] = {.lex_state = 12, .external_lex_state = 3},
  [935] = {.lex_state = 12, .external_lex_state = 3},
  [936] = {.lex_state = 12, .external_lex_state = 3},
  [937] = {.lex_state = 12, .external_lex_state = 3},
  [938] = {.lex_state = 12, .external_lex_state = 3},
  [939] = {.lex_state = 12, .external_lex_state = 3},
  [940] = {.lex_state = 12, .external_lex_state = 3},
  [941] = {.lex_state = 12, .external_lex_state = 3},
  [942] = {.lex_state = 12, .external_lex_state = 3},
  [943] = {.lex_state = 12, .external_lex_state = 3},
  [944] = {.lex_state = 12, .external_lex_state = 3},
  [945] = {.lex_state = 12, .external_lex_state = 3},
  [946] = {.lex_state = 12, .external_lex_state = 3},
  [947] = {.lex_state = 12, .external_lex_state = 3},
  [948] = {.lex_state = 12, .external_lex_state = 3},
  [949] = {.lex_state = 12, .external_lex_state = 3},
  [950] = {.lex_state = 12, .external_lex_state = 3},
  [951] = {.lex_state = 12, .external_lex_state = 3},
  [952] = {.lex_state = 12, .external_lex_state = 3},
  [953] = {.lex_state = 12, .external_lex_state = 3},
  [954] = {.lex_state = 12, .external_lex_state = 3},
  [955] = {.lex_state = 12, .external_lex_state = 3},
  [956] = {.lex_state = 12, .external_lex_state = 3},
  [957] = {.lex_state = 12, .external_lex_state = 3},
  [958] = {.lex_state = 12, .external_lex_state = 3},
  [959] = {.lex_state = 12, .external_lex_state = 3},
  [960] = {.lex_state = 12, .external_lex_state = 3},
  [961] = {.lex_state = 12, .external_lex_state = 3},
  [962] = {.lex_state = 12, .external_lex_state = 3},
  [963] = {.lex_state = 12, .external_lex_state = 3},
  [964] = {.lex_state = 12, .external_lex_state = 3},
  [965] = {.lex_state = 12, .external_lex_state = 3},
  [966] = {.lex_state = 12, .external_lex_state = 3},
  [967] = {.lex_state = 12, .external_lex_state = 3},
  [968] = {.lex_state = 12, .external_lex_state = 3},
  [969] = {.lex_state = 12, .external_lex_state = 3},
  [970] = {.lex_state = 12, .external_lex_state = 3},
  [971] = {.lex_state = 12, .external_lex_state = 3},
  [972] = {.lex_state = 12, .external_lex_state = 3},
  [973] = {.lex_state = 12, .external_lex_state = 3},
  [974] = {.lex_state = 12, .external_lex_state = 3},
  [975] = {.lex_state = 12, .external_lex_state = 3},
  [976] = {.lex_state = 12, .external_lex_state = 3},
  [977] = {.lex_state = 12, .external_lex_state = 3},
  [978] = {.lex_state = 12, .external_lex_state = 3},
  [979] = {.lex_state = 12, .external_lex_state = 3},
  [980] = {.lex_state = 12, .external_lex_state = 3},
  [981] = {.lex_state = 12, .external_lex_state = 3},
  [982] = {.lex_state = 12, .external_lex_state = 3},
  [983] = {.lex_state = 12, .external_lex_state = 3},
  [984] = {.lex_state = 12, .external_lex_state = 3},
  [985] = {.lex_state = 12, .external_lex_state = 3},
  [986] = {.lex_state = 12, .external_lex_state = 3},
  [987] = {.lex_state = 12, .external_lex_state = 3},
  [988] = {.lex_state = 12, .external_lex_state = 3},
  [989] = {.lex_state = 12, .external_lex_state = 3},
  [990] = {.lex_state = 12, .external_lex_state = 3},
  [991] = {.lex_state = 12, .external_lex_state = 3},
  [992] = {.lex_state = 12, .external_lex_state = 3},
  [993] = {.lex_state = 12, .external_lex_state = 3},
  [994] = {.lex_state = 12, .external_lex_state = 3},
  [995] = {.lex_state = 12, .external_lex_state = 3},
  [996] = {.lex_state = 12, .external_lex_state = 3},
  [997] = {.lex_state = 12, .external_lex_state = 3},
  [998] = {.lex_state = 12, .external_lex_state = 3},
  [999] = {.lex_state = 12, .external_lex_state = 3},
  [1000] = {.lex_state = 12, .external_lex_state = 3},
  [1001] = {.lex_state = 12, .external_lex_state = 3},
  [1002] = {.lex_state = 12, .external_lex_state = 3},
  [1003] = {.lex_state = 12, .external_lex_state = 3},
  [1004] = {.lex_state = 12, .external_lex_state = 3},
  [1005] = {.lex_state = 12, .external_lex_state = 3},
  [1006] = {.lex_state = 12, .external_lex_state = 3},
  [1007] = {.lex_state = 12, .external_lex_state = 3},
  [1008] = {.lex_state = 12, .external_lex_state = 3},
  [1009] = {.lex_state = 12, .external_lex_state = 3},
  [1010] = {.lex_state = 12, .external_lex_state = 3},
  [1011] = {.lex_state = 12, .external_lex_state = 3},
  [1012] = {.lex_state = 12, .external_lex_state = 3},
  [1013] = {.lex_state = 12, .external_lex_state = 3},
  [1014] = {.lex_state = 12, .external_lex_state = 3},
  [1015] = {.lex_state = 12, .external_lex_state = 3},
  [1016] = {.lex_state = 12, .external_lex_state = 3},
  [1017] = {.lex_state = 12, .external_lex_state = 3},
  [1018] = {.lex_state = 12, .external_lex_state = 3},
  [1019] = {.lex_state = 12, .external_lex_state = 3},
  [1020] = {.lex_state = 12, .external_lex_state = 3},
  [1021] = {.lex_state = 12, .external_lex_state = 3},
  [1022] = {.lex_state = 12, .external_lex_state = 3},
  [1023] = {.lex_state = 12, .external_lex_state = 3},
  [1024] = {.lex_state = 12, .external_lex_state = 3},
  [1025] = {.lex_state = 12, .external_lex_state = 3},
  [1026] = {.lex_state = 12, .external_lex_state = 3},
  [1027] = {.lex_state = 12, .external_lex_state = 3},
  [1028] = {.lex_state = 12, .external_lex_state = 3},
  [1029] = {.lex_state = 12, .external_lex_state = 3},
  [1030] = {.lex_state = 12, .external_lex_state = 3},
  [1031] = {.lex_state = 12, .external_lex_state = 3},
  [1032] = {.lex_state = 12, .external_lex_state = 3},
  [1033] = {.lex_state = 12, .external_lex_state = 3},
  [1034] = {.lex_state = 12, .external_lex_state = 3},
  [1035] = {.lex_state = 12, .external_lex_state = 3},
  [1036] = {.lex_state = 12, .external_lex_state = 3},
  [1037] = {.lex_state = 12, .external_lex_state = 3},
  [1038] = {.lex_state = 12, .external_lex_state = 3},
  [1039] = {.lex_state = 12, .external_lex_state = 3},
  [1040] = {.lex_state = 12, .external_lex_state = 3},
  [1041] = {.lex_state = 12, .external_lex_state = 3},
  [1042] = {.lex_state = 12, .external_lex_state = 3},
  [1043] = {.lex_state = 12, .external_lex_state = 3},
  [1044] = {.lex_state = 12, .external_lex_state = 3},
  [1045] = {.lex_state = 12, .external_lex_state = 3},
  [1046] = {.lex_state = 12, .external_lex_state = 3},
  [1047] = {.lex_state = 12, .external_lex_state = 3},
  [1048] = {.lex_state = 12, .external_lex_state = 3},
  [1049] = {.lex_state = 12, .external_lex_state = 3},
  [1050] = {.lex_state = 12, .external_lex_state = 3},
  [1051] = {.lex_state = 12, .external_lex_state = 3},
  [1052] = {.lex_state = 12, .external_lex_state = 3},
  [1053] = {.lex_state = 12, .external_lex_state = 3},
  [1054] = {.lex_state = 12, .external_lex_state = 3},
  [1055] = {.lex_state = 12, .external_lex_state = 3},
  [1056] = {.lex_state = 12, .external_lex_state = 3},
  [1057] = {.lex_state = 12, .external_lex_state = 3},
  [1058] = {.lex_state = 12, .external_lex_state = 3},
  [1059] = {.lex_state = 12, .external_lex_state = 3},
  [1060] = {.lex_state = 12, .external_lex_state = 3},
  [1061] = {.lex_state = 12, .external_lex_state = 3},
  [1062] = {.lex_state = 12, .external_lex_state = 3},
  [1063] = {.lex_state = 12, .external_lex_state = 3},
  [1064] = {.lex_state = 12, .external_lex_state = 3},
  [1065] = {.lex_state = 12, .external_lex_state = 3},
  [1066] = {.lex_state = 12, .external_lex_state = 3},
  [1067] = {.lex_state = 12, .external_lex_state = 3},
  [1068] = {.lex_state = 12, .external_lex_state = 3},
  [1069] = {.lex_state = 12, .external_lex_state = 3},
  [1070] = {.lex_state = 12, .external_lex_state = 3},
  [1071] = {.lex_state = 12, .external_lex_state = 3},
  [1072] = {.lex_state = 12, .external_lex_state = 3},
  [1073] = {.lex_state = 12, .external_lex_state = 3},
  [1074] = {.lex_state = 12, .external_lex_state = 3},
  [1075] = {.lex_state = 12, .external_lex_state = 3},
  [1076] = {.lex_state = 12, .external_lex_state = 3},
  [1077] = {.lex_state = 12, .external_lex_state = 3},
  [1078] = {.lex_state = 12, .external_lex_state = 3},
  [1079] = {.lex_state = 12, .external_lex_state = 3},
  [1080] = {.lex_state = 12, .external_lex_state = 3},
  [1081] = {.lex_state = 12, .external_lex_state = 3},
  [1082] = {.lex_state = 12, .external_lex_state = 3},
  [1083] = {.lex_state = 12, .external_lex_state = 3},
  [1084] = {.lex_state = 12, .external_lex_state = 3},
  [1085] = {.lex_state = 12, .external_lex_state = 3},
  [1086] = {.lex_state = 12, .external_lex_state = 3},
  [1087] = {.lex_state = 12, .external_lex_state = 3},
  [1088] = {.lex_state = 12, .external_lex_state = 3},
  [1089] = {.lex_state = 12, .external_lex_state = 3},
  [1090] = {.lex_state = 12, .external_lex_state = 3},
  [1091] = {.lex_state = 12, .external_lex_state = 3},
  [1092] = {.lex_state = 12, .external_lex_state = 3},
  [1093] = {.lex_state = 12, .external_lex_state = 3},
  [1094] = {.lex_state = 12, .external_lex_state = 3},
  [1095] = {.lex_state = 12, .external_lex_state = 3},
  [1096] = {.lex_state = 12, .external_lex_state = 3},
  [1097] = {.lex_state = 12, .external_lex_state = 3},
  [1098] = {.lex_state = 12, .external_lex_state = 3},
  [1099] = {.lex_state = 12, .external_lex_state = 3},
  [1100] = {.lex_state = 12, .external_lex_state = 3},
  [1101] = {.lex_state = 12, .external_lex_state = 3},
  [1102] = {.lex_state = 12, .external_lex_state = 3},
  [1103] = {.lex_state = 12, .external_lex_state = 3},
  [1104] = {.lex_state = 12, .external_lex_state = 3},
  [1105] = {.lex_state = 12, .external_lex_state = 3},
  [1106] = {.lex_state = 12, .external_lex_state = 3},
  [1107] = {.lex_state = 12, .external_lex_state = 3},
  [1108] = {.lex_state = 12, .external_lex_state = 3},
  [1109] = {.lex_state = 12, .external_lex_state = 3},
  [1110] = {.lex_state = 12, .external_lex_state = 3},
  [1111] = {.lex_state = 12, .external_lex_state = 3},
  [1112] = {.lex_state = 12, .external_lex_state = 3},
  [1113] = {.lex_state = 12, .external_lex_state = 3},
  [1114] = {.lex_state = 12, .external_lex_state = 3},
  [1115] = {.lex_state = 12, .external_lex_state = 3},
  [1116] = {.lex_state = 12, .external_lex_state = 3},
  [1117] = {.lex_state = 12, .external_lex_state = 3},
  [1118] = {.lex_state = 12, .external_lex_state = 3},
  [1119] = {.lex_state = 12, .external_lex_state = 3},
  [1120] = {.lex_state = 12, .external_lex_state = 3},
  [1121] = {.lex_state = 12, .external_lex_state = 3},
  [1122] = {.lex_state = 12, .external_lex_state = 3},
  [1123] = {.lex_state = 12, .external_lex_state = 3},
  [1124] = {.lex_state = 12, .external_lex_state = 3},
  [1125] = {.lex_state = 12, .external_lex_state = 3},
  [1126] = {.lex_state = 12, .external_lex_state = 3},
  [1127] = {.lex_state = 12, .external_lex_state = 3},
  [1128] = {.lex_state = 12, .external_lex_state = 3},
  [1129] = {.lex_state = 12, .external_lex_state = 3},
  [1130] = {.lex_state = 12, .external_lex_state = 3},
  [1131] = {.lex_state = 12, .external_lex_state = 3},
  [1132] = {.lex_state = 12, .external_lex_state = 3},
  [1133] = {.lex_state = 12, .external_lex_state = 3},
  [1134] = {.lex_state = 12, .external_lex_state = 3},
  [1135] = {.lex_state = 12, .external_lex_state = 3},
  [1136] = {.lex_state = 12, .external_lex_state = 3},
  [1137] = {.lex_state = 12, .external_lex_state = 3},
  [1138] = {.lex_state = 12, .external_lex_state = 3},
  [1139] = {.lex_state = 12, .external_lex_state = 3},
  [1140] = {.lex_state = 12, .external_lex_state = 3},
  [1141] = {.lex_state = 12, .external_lex_state = 3},
  [1142] = {.lex_state = 12, .external_lex_state = 3},
  [1143] = {.lex_state = 12, .external_lex_state = 3},
  [1144] = {.lex_state = 12, .external_lex_state = 3},
  [1145] = {.lex_state = 12, .external_lex_state = 3},
  [1146] = {.lex_state = 12, .external_lex_state = 3},
  [1147] = {.lex_state = 12, .external_lex_state = 3},
  [1148] = {.lex_state = 12, .external_lex_state = 3},
  [1149] = {.lex_state = 12, .external_lex_state = 3},
  [1150] = {.lex_state = 12, .external_lex_state = 3},
  [1151] = {.lex_state = 12, .external_lex_state = 3},
  [1152] = {.lex_state = 12, .external_lex_state = 3},
  [1153] = {.lex_state = 12, .external_lex_state = 3},
  [1154] = {.lex_state = 12, .external_lex_state = 3},
  [1155] = {.lex_state = 12, .external_lex_state = 3},
  [1156] = {.lex_state = 12, .external_lex_state = 3},
  [1157] = {.lex_state = 12, .external_lex_state = 3},
  [1158] = {.lex_state = 12, .external_lex_state = 3},
  [1159] = {.lex_state = 12, .external_lex_state = 3},
  [1160] = {.lex_state = 12, .external_lex_state = 3},
  [1161] = {.lex_state = 12, .external_lex_state = 3},
  [1162] = {.lex_state = 12, .external_lex_state = 3},
  [1163] = {.lex_state = 12, .external_lex_state = 3},
  [1164] = {.lex_state = 12, .external_lex_state = 3},
  [1165] = {.lex_state = 12, .external_lex_state = 3},
  [1166] = {.lex_state = 12, .external_lex_state = 3},
  [1167] = {.lex_state = 12, .external_lex_state = 3},
  [1168] = {.lex_state = 12, .external_lex_state = 3},
  [1169] = {.lex_state = 12, .external_lex_state = 3},
  [1170] = {.lex_state = 12, .external_lex_state = 3},
  [1171] = {.lex_state = 12, .external_lex_state = 3},
  [1172] = {.lex_state = 12, .external_lex_state = 3},
  [1173] = {.lex_state = 12, .external_lex_state = 3},
  [1174] = {.lex_state = 12, .external_lex_state = 3},
  [1175] = {.lex_state = 12, .external_lex_state = 3},
  [1176] = {.lex_state = 12, .external_lex_state = 3},
  [1177] = {.lex_state = 12, .external_lex_state = 3},
  [1178] = {.lex_state = 12, .external_lex_state = 3},
  [1179] = {.lex_state = 12, .external_lex_state = 3},
  [1180] = {.lex_state = 12, .external_lex_state = 3},
  [1181] = {.lex_state = 12, .external_lex_state = 3},
  [1182] = {.lex_state = 12, .external_lex_state = 3},
  [1183] = {.lex_state = 12, .external_lex_state = 3},
  [1184] = {.lex_state = 12, .external_lex_state = 3},
  [1185] = {.lex_state = 12, .external_lex_state = 3},
  [1186] = {.lex_state = 12, .external_lex_state = 3},
  [1187] = {.lex_state = 12, .external_lex_state = 3},
  [1188] = {.lex_state = 12, .external_lex_state = 3},
  [1189] = {.lex_state = 12, .external_lex_state = 3},
  [1190] = {.lex_state = 12, .external_lex_state = 3},
  [1191] = {.lex_state = 12, .external_lex_state = 3},
  [1192] = {.lex_state = 12, .external_lex_state = 3},
  [1193] = {.lex_state = 12, .external_lex_state = 3},
  [1194] = {.lex_state = 12, .external_lex_state = 3},
  [1195] = {.lex_state = 12, .external_lex_state = 3},
  [1196] = {.lex_state = 12, .external_lex_state = 3},
  [1197] = {.lex_state = 12, .external_lex_state = 3},
  [1198] = {.lex_state = 12, .external_lex_state = 3},
  [1199] = {.lex_state = 12, .external_lex_state = 3},
  [1200] = {.lex_state = 12, .external_lex_state = 3},
  [1201] = {.lex_state = 12, .external_lex_state = 3},
  [1202] = {.lex_state = 12, .external_lex_state = 3},
  [1203] = {.lex_state = 12, .external_lex_state = 3},
  [1204] = {.lex_state = 12, .external_lex_state = 3},
  [1205] = {.lex_state = 12, .external_lex_state = 3},
  [1206] = {.lex_state = 12, .external_lex_state = 3},
  [1207] = {.lex_state = 12, .external_lex_state = 3},
  [1208] = {.lex_state = 12, .external_lex_state = 3},
  [1209] = {.lex_state = 12, .external_lex_state = 3},
  [1210] = {.lex_state = 12, .external_lex_state = 3},
  [1211] = {.lex_state = 12, .external_lex_state = 3},
  [1212] = {.lex_state = 12, .external_lex_state = 3},
  [1213] = {.lex_state = 12, .external_lex_state = 3},
  [1214] = {.lex_state = 12, .external_lex_state = 3},
  [1215] = {.lex_state = 12, .external_lex_state = 3},
  [1216] = {.lex_state = 12, .external_lex_state = 3},
  [1217] = {.lex_state = 12, .external_lex_state = 3},
  [1218] = {.lex_state = 12, .external_lex_state = 3},
  [1219] = {.lex_state = 12, .external_lex_state = 3},
  [1220] = {.lex_state = 12, .external_lex_state = 3},
  [1221] = {.lex_state = 12, .external_lex_state = 3},
  [1222] = {.lex_state = 12, .external_lex_state = 3},
  [1223] = {.lex_state = 12, .external_lex_state = 3},
  [1224] = {.lex_state = 12, .external_lex_state = 3},
  [1225] = {.lex_state = 12, .external_lex_state = 3},
  [1226] = {.lex_state = 12, .external_lex_state = 3},
  [1227] = {.lex_state = 12, .external_lex_state = 3},
  [1228] = {.lex_state = 12, .external_lex_state = 3},
  [1229] = {.lex_state = 12, .external_lex_state = 3},
  [1230] = {.lex_state = 12, .external_lex_state = 3},
  [1231] = {.lex_state = 12, .external_lex_state = 3},
  [1232] = {.lex_state = 12, .external_lex_state = 3},
  [1233] = {.lex_state = 12, .external_lex_state = 3},
  [1234] = {.lex_state = 12, .external_lex_state = 3},
  [1235] = {.lex_state = 12, .external_lex_state = 3},
  [1236] = {.lex_state = 12, .external_lex_state = 3},
  [1237] = {.lex_state = 12, .external_lex_state = 3},
  [1238] = {.lex_state = 12, .external_lex_state = 3},
  [1239] = {.lex_state = 12, .external_lex_state = 3},
  [1240] = {.lex_state = 12, .external_lex_state = 3},
  [1241] = {.lex_state = 12, .external_lex_state = 3},
  [1242] = {.lex_state = 12, .external_lex_state = 3},
  [1243] = {.lex_state = 12, .external_lex_state = 3},
  [1244] = {.lex_state = 12, .external_lex_state = 3},
  [1245] = {.lex_state = 12, .external_lex_state = 3},
  [1246] = {.lex_state = 12, .external_lex_state = 3},
  [1247] = {.lex_state = 12, .external_lex_state = 3},
  [1248] = {.lex_state = 12, .external_lex_state = 3},
  [1249] = {.lex_state = 12, .external_lex_state = 3},
  [1250] = {.lex_state = 12, .external_lex_state = 3},
  [1251] = {.lex_state = 12, .external_lex_state = 3},
  [1252] = {.lex_state = 12, .external_lex_state = 3},
  [1253] = {.lex_state = 12, .external_lex_state = 3},
  [1254] = {.lex_state = 12, .external_lex_state = 3},
  [1255] = {.lex_state = 12, .external_lex_state = 3},
  [1256] = {.lex_state = 12, .external_lex_state = 3},
  [1257] = {.lex_state = 12, .external_lex_state = 3},
  [1258] = {.lex_state = 12, .external_lex_state = 3},
  [1259] = {.lex_state = 12, .external_lex_state = 3},
  [1260] = {.lex_state = 12, .external_lex_state = 3},
  [1261] = {.lex_state = 12, .external_lex_state = 3},
  [1262] = {.lex_state = 12, .external_lex_state = 3},
  [1263] = {.lex_state = 12, .external_lex_state = 3},
  [1264] = {.lex_state = 12, .external_lex_state = 3},
  [1265] = {.lex_state = 12, .external_lex_state = 3},
  [1266] = {.lex_state = 12, .external_lex_state = 3},
  [1267] = {.lex_state = 12, .external_lex_state = 3},
  [1268] = {.lex_state = 12, .external_lex_state = 3},
  [1269] = {.lex_state = 12, .external_lex_state = 3},
  [1270] = {.lex_state = 12, .external_lex_state = 3},
  [1271] = {.lex_state = 12, .external_lex_state = 3},
  [1272] = {.lex_state = 12, .external_lex_state = 3},
  [1273] = {.lex_state = 12, .external_lex_state = 3},
  [1274] = {.lex_state = 12, .external_lex_state = 3},
  [1275] = {.lex_state = 12, .external_lex_state = 3},
  [1276] = {.lex_state = 12, .external_lex_state = 3},
  [1277] = {.lex_state = 12, .external_lex_state = 3},
  [1278] = {.lex_state = 12, .external_lex_state = 3},
  [1279] = {.lex_state = 12, .external_lex_state = 3},
  [1280] = {.lex_state = 12, .external_lex_state = 3},
  [1281] = {.lex_state = 12, .external_lex_state = 3},
  [1282] = {.lex_state = 12, .external_lex_state = 3},
  [1283] = {.lex_state = 12, .external_lex_state = 3},
  [1284] = {.lex_state = 12, .external_lex_state = 3},
  [1285] = {.lex_state = 12, .external_lex_state = 3},
  [1286] = {.lex_state = 12, .external_lex_state = 3},
  [1287] = {.lex_state = 12, .external_lex_state = 3},
  [1288] = {.lex_state = 12, .external_lex_state = 3},
  [1289] = {.lex_state = 12, .external_lex_state = 3},
  [1290] = {.lex_state = 12, .external_lex_state = 3},
  [1291] = {.lex_state = 12, .external_lex_state = 3},
  [1292] = {.lex_state = 12, .external_lex_state = 3},
  [1293] = {.lex_state = 12, .external_lex_state = 3},
  [1294] = {.lex_state = 12, .external_lex_state = 3},
  [1295] = {.lex_state = 12, .external_lex_state = 3},
  [1296] = {.lex_state = 12, .external_lex_state = 3},
  [1297] = {.lex_state = 12, .external_lex_state = 3},
  [1298] = {.lex_state = 12, .external_lex_state = 3},
  [1299] = {.lex_state = 12, .external_lex_state = 3},
  [1300] = {.lex_state = 12, .external_lex_state = 3},
  [1301] = {.lex_state = 12, .external_lex_state = 3},
  [1302] = {.lex_state = 12, .external_lex_state = 3},
  [1303] = {.lex_state = 12, .external_lex_state = 3},
  [1304] = {.lex_state = 12, .external_lex_state = 3},
  [1305] = {.lex_state = 12, .external_lex_state = 3},
  [1306] = {.lex_state = 12, .external_lex_state = 3},
  [1307] = {.lex_state = 12, .external_lex_state = 3},
  [1308] = {.lex_state = 12, .external_lex_state = 3},
  [1309] = {.lex_state = 12, .external_lex_state = 3},
  [1310] = {.lex_state = 12, .external_lex_state = 3},
  [1311] = {.lex_state = 12, .external_lex_state = 3},
  [1312] = {.lex_state = 12, .external_lex_state = 3},
  [1313] = {.lex_state = 12, .external_lex_state = 3},
  [1314] = {.lex_state = 12, .external_lex_state = 3},
  [1315] = {.lex_state = 12, .external_lex_state = 3},
  [1316] = {.lex_state = 12, .external_lex_state = 3},
  [1317] = {.lex_state = 12, .external_lex_state = 3},
  [1318] = {.lex_state = 12, .external_lex_state = 3},
  [1319] = {.lex_state = 12, .external_lex_state = 3},
  [1320] = {.lex_state = 12, .external_lex_state = 3},
  [1321] = {.lex_state = 12, .external_lex_state = 3},
  [1322] = {.lex_state = 12, .external_lex_state = 3},
  [1323] = {.lex_state = 12, .external_lex_state = 3},
  [1324] = {.lex_state = 12, .external_lex_state = 3},
  [1325] = {.lex_state = 12, .external_lex_state = 3},
  [1326] = {.lex_state = 12, .external_lex_state = 3},
  [1327] = {.lex_state = 12, .external_lex_state = 3},
  [1328] = {.lex_state = 12, .external_lex_state = 3},
  [1329] = {.lex_state = 12, .external_lex_state = 3},
  [1330] = {.lex_state = 12, .external_lex_state = 3},
  [1331] = {.lex_state = 12, .external_lex_state = 3},
  [1332] = {.lex_state = 12, .external_lex_state = 3},
  [1333] = {.lex_state = 12, .external_lex_state = 3},
  [1334] = {.lex_state = 12, .external_lex_state = 3},
  [1335] = {.lex_state = 12, .external_lex_state = 3},
  [1336] = {.lex_state = 12, .external_lex_state = 3},
  [1337] = {.lex_state = 12, .external_lex_state = 3},
  [1338] = {.lex_state = 12, .external_lex_state = 3},
  [1339] = {.lex_state = 12, .external_lex_state = 3},
  [1340] = {.lex_state = 12, .external_lex_state = 3},
  [1341] = {.lex_state = 12, .external_lex_state = 3},
  [1342] = {.lex_state = 12, .external_lex_state = 3},
  [1343] = {.lex_state = 12, .external_lex_state = 3},
  [1344] = {.lex_state = 12, .external_lex_state = 3},
  [1345] = {.lex_state = 12, .external_lex_state = 3},
  [1346] = {.lex_state = 12, .external_lex_state = 3},
  [1347] = {.lex_state = 12, .external_lex_state = 3},
  [1348] = {.lex_state = 12, .external_lex_state = 3},
  [1349] = {.lex_state = 12, .external_lex_state = 3},
  [1350] = {.lex_state = 12, .external_lex_state = 3},
  [1351] = {.lex_state = 12, .external_lex_state = 3},
  [1352] = {.lex_state = 12, .external_lex_state = 3},
  [1353] = {.lex_state = 12, .external_lex_state = 3},
  [1354] = {.lex_state = 12, .external_lex_state = 3},
  [1355] = {.lex_state = 12, .external_lex_state = 3},
  [1356] = {.lex_state = 12, .external_lex_state = 3},
  [1357] = {.lex_state = 12, .external_lex_state = 3},
  [1358] = {.lex_state = 12, .external_lex_state = 3},
  [1359] = {.lex_state = 12, .external_lex_state = 3},
  [1360] = {.lex_state = 12, .external_lex_state = 3},
  [1361] = {.lex_state = 12, .external_lex_state = 3},
  [1362] = {.lex_state = 12, .external_lex_state = 3},
  [1363] = {.lex_state = 12, .external_lex_state = 3},
  [1364] = {.lex_state = 12, .external_lex_state = 3},
  [1365] = {.lex_state = 12, .external_lex_state = 3},
  [1366] = {.lex_state = 12, .external_lex_state = 3},
  [1367] = {.lex_state = 12, .external_lex_state = 3},
  [1368] = {.lex_state = 12, .external_lex_state = 3},
  [1369] = {.lex_state = 12, .external_lex_state = 3},
  [1370] = {.lex_state = 12, .external_lex_state = 3},
  [1371] = {.lex_state = 12, .external_lex_state = 3},
  [1372] = {.lex_state = 12, .external_lex_state = 3},
  [1373] = {.lex_state = 12, .external_lex_state = 3},
  [1374] = {.lex_state = 12, .external_lex_state = 3},
  [1375] = {.lex_state = 12, .external_lex_state = 3},
  [1376] = {.lex_state = 12, .external_lex_state = 3},
  [1377] = {.lex_state = 12, .external_lex_state = 3},
  [1378] = {.lex_state = 12, .external_lex_state = 3},
  [1379] = {.lex_state = 12, .external_lex_state = 3},
  [1380] = {.lex_state = 12, .external_lex_state = 3},
  [1381] = {.lex_state = 12, .external_lex_state = 3},
  [1382] = {.lex_state = 12, .external_lex_state = 3},
  [1383] = {.lex_state = 12, .external_lex_state = 3},
  [1384] = {.lex_state = 12, .external_lex_state = 3},
  [1385] = {.lex_state = 12, .external_lex_state = 3},
  [1386] = {.lex_state = 12, .external_lex_state = 3},
  [1387] = {.lex_state = 12, .external_lex_state = 3},
  [1388] = {.lex_state = 12, .external_lex_state = 3},
  [1389] = {.lex_state = 12, .external_lex_state = 3},
  [1390] = {.lex_state = 12, .external_lex_state = 3},
  [1391] = {.lex_state = 12, .external_lex_state = 3},
  [1392] = {.lex_state = 12, .external_lex_state = 3},
  [1393] = {.lex_state = 12, .external_lex_state = 3},
  [1394] = {.lex_state = 12, .external_lex_state = 3},
  [1395] = {.lex_state = 12, .external_lex_state = 3},
  [1396] = {.lex_state = 12, .external_lex_state = 3},
  [1397] = {.lex_state = 12, .external_lex_state = 3},
  [1398] = {.lex_state = 12, .external_lex_state = 3},
  [1399] = {.lex_state = 12, .external_lex_state = 3},
  [1400] = {.lex_state = 12, .external_lex_state = 3},
  [1401] = {.lex_state = 12, .external_lex_state = 3},
  [1402] = {.lex_state = 12, .external_lex_state = 3},
  [1403] = {.lex_state = 12, .external_lex_state = 3},
  [1404] = {.lex_state = 12, .external_lex_state = 3},
  [1405] = {.lex_state = 12, .external_lex_state = 3},
  [1406] = {.lex_state = 12, .external_lex_state = 3},
  [1407] = {.lex_state = 12, .external_lex_state = 3},
  [1408] = {.lex_state = 12, .external_lex_state = 3},
  [1409] = {.lex_state = 12, .external_lex_state = 3},
  [1410] = {.lex_state = 12, .external_lex_state = 3},
  [1411] = {.lex_state = 12, .external_lex_state = 3},
  [1412] = {.lex_state = 12, .external_lex_state = 3},
  [1413] = {.lex_state = 12, .external_lex_state = 3},
  [1414] = {.lex_state = 12, .external_lex_state = 3},
  [1415] = {.lex_state = 12, .external_lex_state = 3},
  [1416] = {.lex_state = 12, .external_lex_state = 3},
  [1417] = {.lex_state = 12, .external_lex_state = 3},
  [1418] = {.lex_state = 12, .external_lex_state = 3},
  [1419] = {.lex_state = 12, .external_lex_state = 3},
  [1420] = {.lex_state = 12, .external_lex_state = 3},
  [1421] = {.lex_state = 12, .external_lex_state = 3},
  [1422] = {.lex_state = 12, .external_lex_state = 3},
  [1423] = {.lex_state = 12, .external_lex_state = 3},
  [1424] = {.lex_state = 12, .external_lex_state = 3},
  [1425] = {.lex_state = 12, .external_lex_state = 3},
  [1426] = {.lex_state = 12, .external_lex_state = 3},
  [1427] = {.lex_state = 12, .external_lex_state = 3},
  [1428] = {.lex_state = 12, .external_lex_state = 3},
  [1429] = {.lex_state = 12, .external_lex_state = 3},
  [1430] = {.lex_state = 12, .external_lex_state = 3},
  [1431] = {.lex_state = 12, .external_lex_state = 3},
  [1432] = {.lex_state = 12, .external_lex_state = 3},
  [1433] = {.lex_state = 12, .external_lex_state = 3},
  [1434] = {.lex_state = 12, .external_lex_state = 3},
  [1435] = {.lex_state = 12, .external_lex_state = 3},
  [1436] = {.lex_state = 12, .external_lex_state = 3},
  [1437] = {.lex_state = 12, .external_lex_state = 3},
  [1438] = {.lex_state = 12, .external_lex_state = 3},
  [1439] = {.lex_state = 12, .external_lex_state = 3},
  [1440] = {.lex_state = 12, .external_lex_state = 3},
  [1441] = {.lex_state = 12, .external_lex_state = 3},
  [1442] = {.lex_state = 12, .external_lex_state = 3},
  [1443] = {.lex_state = 12, .external_lex_state = 3},
  [1444] = {.lex_state = 12, .external_lex_state = 3},
  [1445] = {.lex_state = 12, .external_lex_state = 3},
  [1446] = {.lex_state = 12, .external_lex_state = 3},
  [1447] = {.lex_state = 12, .external_lex_state = 3},
  [1448] = {.lex_state = 12, .external_lex_state = 3},
  [1449] = {.lex_state = 12, .external_lex_state = 3},
  [1450] = {.lex_state = 12, .external_lex_state = 3},
  [1451] = {.lex_state = 12, .external_lex_state = 3},
  [1452] = {.lex_state = 12, .external_lex_state = 3},
  [1453] = {.lex_state = 12, .external_lex_state = 3},
  [1454] = {.lex_state = 12, .external_lex_state = 3},
  [1455] = {.lex_state = 12, .external_lex_state = 3},
  [1456] = {.lex_state = 12, .external_lex_state = 3},
  [1457] = {.lex_state = 12, .external_lex_state = 3},
  [1458] = {.lex_state = 12, .external_lex_state = 3},
  [1459] = {.lex_state = 12, .external_lex_state = 3},
  [1460] = {.lex_state = 12, .external_lex_state = 3},
  [1461] = {.lex_state = 12, .external_lex_state = 3},
  [1462] = {.lex_state = 12, .external_lex_state = 3},
  [1463] = {.lex_state = 12, .external_lex_state = 3},
  [1464] = {.lex_state = 12, .external_lex_state = 3},
  [1465] = {.lex_state = 12, .external_lex_state = 3},
  [1466] = {.lex_state = 12, .external_lex_state = 3},
  [1467] = {.lex_state = 12, .external_lex_state = 3},
  [1468] = {.lex_state = 12, .external_lex_state = 3},
  [1469] = {.lex_state = 12, .external_lex_state = 3},
  [1470] = {.lex_state = 12, .external_lex_state = 3},
  [1471] = {.lex_state = 12, .external_lex_state = 3},
  [1472] = {.lex_state = 12, .external_lex_state = 3},
  [1473] = {.lex_state = 12, .external_lex_state = 3},
  [1474] = {.lex_state = 12, .external_lex_state = 3},
  [1475] = {.lex_state = 12, .external_lex_state = 3},
  [1476] = {.lex_state = 12, .external_lex_state = 3},
  [1477] = {.lex_state = 12, .external_lex_state = 3},
  [1478] = {.lex_state = 12, .external_lex_state = 3},
  [1479] = {.lex_state = 12, .external_lex_state = 3},
  [1480] = {.lex_state = 12, .external_lex_state = 3},
  [1481] = {.lex_state = 12, .external_lex_state = 3},
  [1482] = {.lex_state = 12, .external_lex_state = 3},
  [1483] = {.lex_state = 12, .external_lex_state = 3},
  [1484] = {.lex_state = 12, .external_lex_state = 3},
  [1485] = {.lex_state = 12, .external_lex_state = 3},
  [1486] = {.lex_state = 12, .external_lex_state = 3},
  [1487] = {.lex_state = 12, .external_lex_state = 3},
  [1488] = {.lex_state = 12, .external_lex_state = 3},
  [1489] = {.lex_state = 12, .external_lex_state = 3},
  [1490] = {.lex_state = 12, .external_lex_state = 3},
  [1491] = {.lex_state = 12, .external_lex_state = 3},
  [1492] = {.lex_state = 12, .external_lex_state = 3},
  [1493] = {.lex_state = 12, .external_lex_state = 3},
  [1494] = {.lex_state = 12, .external_lex_state = 3},
  [1495] = {.lex_state = 12, .external_lex_state = 3},
  [1496] = {.lex_state = 12, .external_lex_state = 3},
  [1497] = {.lex_state = 12, .external_lex_state = 3},
  [1498] = {.lex_state = 12, .external_lex_state = 3},
  [1499] = {.lex_state = 12, .external_lex_state = 3},
  [1500] = {.lex_state = 12, .external_lex_state = 3},
  [1501] = {.lex_state = 12, .external_lex_state = 3},
  [1502] = {.lex_state = 12, .external_lex_state = 3},
  [1503] = {.lex_state = 12, .external_lex_state = 3},
  [1504] = {.lex_state = 12, .external_lex_state = 3},
  [1505] = {.lex_state = 12, .external_lex_state = 3},
  [1506] = {.lex_state = 12, .external_lex_state = 3},
  [1507] = {.lex_state = 12, .external_lex_state = 3},
  [1508] = {.lex_state = 12, .external_lex_state = 3},
  [1509] = {.lex_state = 12, .external_lex_state = 3},
  [1510] = {.lex_state = 12, .external_lex_state = 3},
  [1511] = {.lex_state = 12, .external_lex_state = 3},
  [1512] = {.lex_state = 12, .external_lex_state = 3},
  [1513] = {.lex_state = 12, .external_lex_state = 3},
  [1514] = {.lex_state = 12, .external_lex_state = 3},
  [1515] = {.lex_state = 12, .external_lex_state = 3},
  [1516] = {.lex_state = 12, .external_lex_state = 3},
  [1517] = {.lex_state = 12, .external_lex_state = 3},
  [1518] = {.lex_state = 12, .external_lex_state = 3},
  [1519] = {.lex_state = 12, .external_lex_state = 3},
  [1520] = {.lex_state = 12, .external_lex_state = 3},
  [1521] = {.lex_state = 12, .external_lex_state = 3},
  [1522] = {.lex_state = 12, .external_lex_state = 3},
  [1523] = {.lex_state = 12, .external_lex_state = 3},
  [1524] = {.lex_state = 12, .external_lex_state = 3},
  [1525] = {.lex_state = 12, .external_lex_state = 3},
  [1526] = {.lex_state = 12, .external_lex_state = 3},
  [1527] = {.lex_state = 12, .external_lex_state = 3},
  [1528] = {.lex_state = 12, .external_lex_state = 3},
  [1529] = {.lex_state = 12, .external_lex_state = 3},
  [1530] = {.lex_state = 12, .external_lex_state = 3},
  [1531] = {.lex_state = 12, .external_lex_state = 3},
  [1532] = {.lex_state = 12, .external_lex_state = 3},
  [1533] = {.lex_state = 12, .external_lex_state = 3},
  [1534] = {.lex_state = 12, .external_lex_state = 3},
  [1535] = {.lex_state = 12, .external_lex_state = 3},
  [1536] = {.lex_state = 12, .external_lex_state = 3},
  [1537] = {.lex_state = 12, .external_lex_state = 3},
  [1538] = {.lex_state = 12, .external_lex_state = 3},
  [1539] = {.lex_state = 12, .external_lex_state = 3},
  [1540] = {.lex_state = 12, .external_lex_state = 3},
  [1541] = {.lex_state = 12, .external_lex_state = 3},
  [1542] = {.lex_state = 12, .external_lex_state = 3},
  [1543] = {.lex_state = 12, .external_lex_state = 3},
  [1544] = {.lex_state = 12, .external_lex_state = 3},
  [1545] = {.lex_state = 12, .external_lex_state = 3},
  [1546] = {.lex_state = 12, .external_lex_state = 3},
  [1547] = {.lex_state = 12, .external_lex_state = 3},
  [1548] = {.lex_state = 12, .external_lex_state = 3},
  [1549] = {.lex_state = 12, .external_lex_state = 3},
  [1550] = {.lex_state = 12, .external_lex_state = 3},
  [1551] = {.lex_state = 12, .external_lex_state = 3},
  [1552] = {.lex_state = 12, .external_lex_state = 3},
  [1553] = {.lex_state = 12, .external_lex_state = 3},
  [1554] = {.lex_state = 12, .external_lex_state = 3},
  [1555] = {.lex_state = 12, .external_lex_state = 3},
  [1556] = {.lex_state = 12, .external_lex_state = 3},
  [1557] = {.lex_state = 12, .external_lex_state = 3},
  [1558] = {.lex_state = 12, .external_lex_state = 3},
  [1559] = {.lex_state = 12, .external_lex_state = 3},
  [1560] = {.lex_state = 12, .external_lex_state = 3},
  [1561] = {.lex_state = 12, .external_lex_state = 3},
  [1562] = {.lex_state = 12, .external_lex_state = 3},
  [1563] = {.lex_state = 12, .external_lex_state = 3},
  [1564] = {.lex_state = 12, .external_lex_state = 3},
  [1565] = {.lex_state = 12, .external_lex_state = 3},
  [1566] = {.lex_state = 12, .external_lex_state = 3},
  [1567] = {.lex_state = 12, .external_lex_state = 3},
  [1568] = {.lex_state = 12, .external_lex_state = 3},
  [1569] = {.lex_state = 12, .external_lex_state = 3},
  [1570] = {.lex_state = 12, .external_lex_state = 3},
  [1571] = {.lex_state = 12, .external_lex_state = 3},
  [1572] = {.lex_state = 12, .external_lex_state = 3},
  [1573] = {.lex_state = 12, .external_lex_state = 3},
  [1574] = {.lex_state = 12, .external_lex_state = 3},
  [1575] = {.lex_state = 12, .external_lex_state = 3},
  [1576] = {.lex_state = 12, .external_lex_state = 3},
  [1577] = {.lex_state = 12, .external_lex_state = 3},
  [1578] = {.lex_state = 12, .external_lex_state = 3},
  [1579] = {.lex_state = 12, .external_lex_state = 3},
  [1580] = {.lex_state = 12, .external_lex_state = 3},
  [1581] = {.lex_state = 12, .external_lex_state = 3},
  [1582] = {.lex_state = 12, .external_lex_state = 3},
  [1583] = {.lex_state = 12, .external_lex_state = 3},
  [1584] = {.lex_state = 12, .external_lex_state = 3},
  [1585] = {.lex_state = 12, .external_lex_state = 3},
  [1586] = {.lex_state = 12, .external_lex_state = 3},
  [1587] = {.lex_state = 12, .external_lex_state = 3},
  [1588] = {.lex_state = 12, .external_lex_state = 3},
  [1589] = {.lex_state = 12, .external_lex_state = 3},
  [1590] = {.lex_state = 12, .external_lex_state = 3},
  [1591] = {.lex_state = 12, .external_lex_state = 3},
  [1592] = {.lex_state = 12, .external_lex_state = 3},
  [1593] = {.lex_state = 12, .external_lex_state = 3},
  [1594] = {.lex_state = 12, .external_lex_state = 3},
  [1595] = {.lex_state = 12, .external_lex_state = 3},
  [1596] = {.lex_state = 12, .external_lex_state = 3},
  [1597] = {.lex_state = 12, .external_lex_state = 3},
  [1598] = {.lex_state = 12, .external_lex_state = 3},
  [1599] = {.lex_state = 12, .external_lex_state = 3},
  [1600] = {.lex_state = 12, .external_lex_state = 3},
  [1601] = {.lex_state = 12, .external_lex_state = 3},
  [1602] = {.lex_state = 12, .external_lex_state = 3},
  [1603] = {.lex_state = 12, .external_lex_state = 3},
  [1604] = {.lex_state = 12, .external_lex_state = 3},
  [1605] = {.lex_state = 12, .external_lex_state = 3},
  [1606] = {.lex_state = 12, .external_lex_state = 3},
  [1607] = {.lex_state = 12, .external_lex_state = 3},
  [1608] = {.lex_state = 12, .external_lex_state = 3},
  [1609] = {.lex_state = 12, .external_lex_state = 3},
  [1610] = {.lex_state = 12, .external_lex_state = 3},
  [1611] = {.lex_state = 12, .external_lex_state = 3},
  [1612] = {.lex_state = 12, .external_lex_state = 3},
  [1613] = {.lex_state = 12, .external_lex_state = 3},
  [1614] = {.lex_state = 12, .external_lex_state = 3},
  [1615] = {.lex_state = 12, .external_lex_state = 3},
  [1616] = {.lex_state = 12, .external_lex_state = 3},
  [1617] = {.lex_state = 12, .external_lex_state = 3},
  [1618] = {.lex_state = 12, .external_lex_state = 3},
  [1619] = {.lex_state = 12, .external_lex_state = 3},
  [1620] = {.lex_state = 12, .external_lex_state = 3},
  [1621] = {.lex_state = 12, .external_lex_state = 3},
  [1622] = {.lex_state = 12, .external_lex_state = 3},
  [1623] = {.lex_state = 12, .external_lex_state = 3},
  [1624] = {.lex_state = 12, .external_lex_state = 3},
  [1625] = {.lex_state = 12, .external_lex_state = 3},
  [1626] = {.lex_state = 12, .external_lex_state = 3},
  [1627] = {.lex_state = 12, .external_lex_state = 3},
  [1628] = {.lex_state = 12, .external_lex_state = 3},
  [1629] = {.lex_state = 12, .external_lex_state = 3},
  [1630] = {.lex_state = 12, .external_lex_state = 3},
  [1631] = {.lex_state = 12, .external_lex_state = 3},
  [1632] = {.lex_state = 12, .external_lex_state = 3},
  [1633] = {.lex_state = 12, .external_lex_state = 3},
  [1634] = {.lex_state = 12, .external_lex_state = 3},
  [1635] = {.lex_state = 12, .external_lex_state = 3},
  [1636] = {.lex_state = 12, .external_lex_state = 3},
  [1637] = {.lex_state = 12, .external_lex_state = 3},
  [1638] = {.lex_state = 12, .external_lex_state = 3},
  [1639] = {.lex_state = 12, .external_lex_state = 3},
  [1640] = {.lex_state = 12, .external_lex_state = 3},
  [1641] = {.lex_state = 12, .external_lex_state = 3},
  [1642] = {.lex_state = 12, .external_lex_state = 3},
  [1643] = {.lex_state = 12, .external_lex_state = 3},
  [1644] = {.lex_state = 12, .external_lex_state = 3},
  [1645] = {.lex_state = 12, .external_lex_state = 3},
  [1646] = {.lex_state = 12, .external_lex_state = 3},
  [1647] = {.lex_state = 12, .external_lex_state = 3},
  [1648] = {.lex_state = 12, .external_lex_state = 3},
  [1649] = {.lex_state = 12, .external_lex_state = 3},
  [1650] = {.lex_state = 12, .external_lex_state = 3},
  [1651] = {.lex_state = 12, .external_lex_state = 3},
  [1652] = {.lex_state = 12, .external_lex_state = 3},
  [1653] = {.lex_state = 12, .external_lex_state = 3},
  [1654] = {.lex_state = 12, .external_lex_state = 3},
  [1655] = {.lex_state = 12, .external_lex_state = 3},
  [1656] = {.lex_state = 12, .external_lex_state = 3},
  [1657] = {.lex_state = 12, .external_lex_state = 3},
  [1658] = {.lex_state = 12, .external_lex_state = 3},
  [1659] = {.lex_state = 12, .external_lex_state = 3},
  [1660] = {.lex_state = 12, .external_lex_state = 3},
  [1661] = {.lex_state = 12, .external_lex_state = 3},
  [1662] = {.lex_state = 12, .external_lex_state = 3},
  [1663] = {.lex_state = 12, .external_lex_state = 3},
  [1664] = {.lex_state = 12, .external_lex_state = 3},
  [1665] = {.lex_state = 12, .external_lex_state = 3},
  [1666] = {.lex_state = 12, .external_lex_state = 3},
  [1667] = {.lex_state = 12, .external_lex_state = 3},
  [1668] = {.lex_state = 12, .external_lex_state = 3},
  [1669] = {.lex_state = 12, .external_lex_state = 3},
  [1670] = {.lex_state = 12, .external_lex_state = 3},
  [1671] = {.lex_state = 12, .external_lex_state = 3},
  [1672] = {.lex_state = 12, .external_lex_state = 3},
  [1673] = {.lex_state = 12, .external_lex_state = 3},
  [1674] = {.lex_state = 12, .external_lex_state = 3},
  [1675] = {.lex_state = 12, .external_lex_state = 3},
  [1676] = {.lex_state = 12, .external_lex_state = 3},
  [1677] = {.lex_state = 12, .external_lex_state = 3},
  [1678] = {.lex_state = 12, .external_lex_state = 3},
  [1679] = {.lex_state = 12, .external_lex_state = 3},
  [1680] = {.lex_state = 12, .external_lex_state = 3},
  [1681] = {.lex_state = 12, .external_lex_state = 3},
  [1682] = {.lex_state = 12, .external_lex_state = 3},
  [1683] = {.lex_state = 12, .external_lex_state = 3},
  [1684] = {.lex_state = 12, .external_lex_state = 3},
  [1685] = {.lex_state = 12, .external_lex_state = 3},
  [1686] = {.lex_state = 12, .external_lex_state = 3},
  [1687] = {.lex_state = 12, .external_lex_state = 3},
  [1688] = {.lex_state = 12, .external_lex_state = 3},
  [1689] = {.lex_state = 12, .external_lex_state = 3},
  [1690] = {.lex_state = 12, .external_lex_state = 3},
  [1691] = {.lex_state = 12, .external_lex_state = 3},
  [1692] = {.lex_state = 12, .external_lex_state = 3},
  [1693] = {.lex_state = 12, .external_lex_state = 3},
  [1694] = {.lex_state = 12, .external_lex_state = 3},
  [1695] = {.lex_state = 12, .external_lex_state = 3},
  [1696] = {.lex_state = 12, .external_lex_state = 3},
  [1697] = {.lex_state = 12, .external_lex_state = 3},
  [1698] = {.lex_state = 50, .external_lex_state = 2},
  [1699] = {.lex_state = 50, .external_lex_state = 2},
  [1700] = {.lex_state = 50, .external_lex_state = 2},
  [1701] = {.lex_state = 50, .external_lex_state = 2},
  [1702] = {.lex_state = 50, .external_lex_state = 2},
  [1703] = {.lex_state = 50, .external_lex_state = 2},
  [1704] = {.lex_state = 50, .external_lex_state = 2},
  [1705] = {.lex_state = 50, .external_lex_state = 2},
  [1706] = {.lex_state = 50, .external_lex_state = 2},
  [1707] = {.lex_state = 50, .external_lex_state = 2},
  [1708] = {.lex_state = 50, .external_lex_state = 2},
  [1709] = {.lex_state = 50, .external_lex_state = 2},
  [1710] = {.lex_state = 50, .external_lex_state = 2},
  [1711] = {.lex_state = 50, .external_lex_state = 2},
  [1712] = {.lex_state = 50, .external_lex_state = 2},
  [1713] = {.lex_state = 50, .external_lex_state = 2},
  [1714] = {.lex_state = 50, .external_lex_state = 2},
  [1715] = {.lex_state = 50, .external_lex_state = 2},
  [1716] = {.lex_state = 50, .external_lex_state = 2},
  [1717] = {.lex_state = 50, .external_lex_state = 2},
  [1718] = {.lex_state = 50, .external_lex_state = 2},
  [1719] = {.lex_state = 50, .external_lex_state = 2},
  [1720] = {.lex_state = 50, .external_lex_state = 2},
  [1721] = {.lex_state = 50, .external_lex_state = 2},
  [1722] = {.lex_state = 50, .external_lex_state = 2},
  [1723] = {.lex_state = 50, .external_lex_state = 2},
  [1724] = {.lex_state = 50, .external_lex_state = 2},
  [1725] = {.lex_state = 50, .external_lex_state = 2},
  [1726] = {.lex_state = 50, .external_lex_state = 2},
  [1727] = {.lex_state = 50, .external_lex_state = 2},
  [1728] = {.lex_state = 50, .external_lex_state = 2},
  [1729] = {.lex_state = 50, .external_lex_state = 2},
  [1730] = {.lex_state = 50, .external_lex_state = 2},
  [1731] = {.lex_state = 50, .external_lex_state = 2},
  [1732] = {.lex_state = 50, .external_lex_state = 2},
  [1733] = {.lex_state = 50, .external_lex_state = 2},
  [1734] = {.lex_state = 50, .external_lex_state = 2},
  [1735] = {.lex_state = 50, .external_lex_state = 2},
  [1736] = {.lex_state = 50, .external_lex_state = 2},
  [1737] = {.lex_state = 50, .external_lex_state = 2},
  [1738] = {.lex_state = 50, .external_lex_state = 2},
  [1739] = {.lex_state = 50, .external_lex_state = 2},
  [1740] = {.lex_state = 50, .external_lex_state = 2},
  [1741] = {.lex_state = 50, .external_lex_state = 2},
  [1742] = {.lex_state = 50, .external_lex_state = 2},
  [1743] = {.lex_state = 50, .external_lex_state = 2},
  [1744] = {.lex_state = 50, .external_lex_state = 2},
  [1745] = {.lex_state = 50, .external_lex_state = 2},
  [1746] = {.lex_state = 50, .external_lex_state = 2},
  [1747] = {.lex_state = 50, .external_lex_state = 2},
  [1748] = {.lex_state = 50, .external_lex_state = 2},
  [1749] = {.lex_state = 50, .external_lex_state = 2},
  [1750] = {.lex_state = 50, .external_lex_state = 2},
  [1751] = {.lex_state = 50, .external_lex_state = 2},
  [1752] = {.lex_state = 50, .external_lex_state = 2},
  [1753] = {.lex_state = 50, .external_lex_state = 2},
  [1754] = {.lex_state = 50, .external_lex_state = 2},
  [1755] = {.lex_state = 50, .external_lex_state = 2},
  [1756] = {.lex_state = 50, .external_lex_state = 2},
  [1757] = {.lex_state = 50, .external_lex_state = 2},
  [1758] = {.lex_state = 50, .external_lex_state = 2},
  [1759] = {.lex_state = 50, .external_lex_state = 2},
  [1760] = {.lex_state = 50, .external_lex_state = 2},
  [1761] = {.lex_state = 50, .external_lex_state = 2},
  [1762] = {.lex_state = 50, .external_lex_state = 2},
  [1763] = {.lex_state = 50, .external_lex_state = 2},
  [1764] = {.lex_state = 50, .external_lex_state = 2},
  [1765] = {.lex_state = 50, .external_lex_state = 2},
  [1766] = {.lex_state = 50, .external_lex_state = 2},
  [1767] = {.lex_state = 50, .external_lex_state = 2},
  [1768] = {.lex_state = 50, .external_lex_state = 2},
  [1769] = {.lex_state = 50, .external_lex_state = 2},
  [1770] = {.lex_state = 50, .external_lex_state = 2},
  [1771] = {.lex_state = 50, .external_lex_state = 2},
  [1772] = {.lex_state = 50, .external_lex_state = 2},
  [1773] = {.lex_state = 50, .external_lex_state = 2},
  [1774] = {.lex_state = 50, .external_lex_state = 2},
  [1775] = {.lex_state = 50, .external_lex_state = 2},
  [1776] = {.lex_state = 50, .external_lex_state = 2},
  [1777] = {.lex_state = 50, .external_lex_state = 2},
  [1778] = {.lex_state = 50, .external_lex_state = 2},
  [1779] = {.lex_state = 50, .external_lex_state = 2},
  [1780] = {.lex_state = 50, .external_lex_state = 2},
  [1781] = {.lex_state = 50, .external_lex_state = 2},
  [1782] = {.lex_state = 50, .external_lex_state = 2},
  [1783] = {.lex_state = 50, .external_lex_state = 2},
  [1784] = {.lex_state = 50, .external_lex_state = 2},
  [1785] = {.lex_state = 50, .external_lex_state = 2},
  [1786] = {.lex_state = 50, .external_lex_state = 2},
  [1787] = {.lex_state = 50, .external_lex_state = 2},
  [1788] = {.lex_state = 50, .external_lex_state = 2},
  [1789] = {.lex_state = 50, .external_lex_state = 2},
  [1790] = {.lex_state = 50, .external_lex_state = 2},
  [1791] = {.lex_state = 50, .external_lex_state = 2},
  [1792] = {.lex_state = 50, .external_lex_state = 2},
  [1793] = {.lex_state = 50, .external_lex_state = 2},
  [1794] = {.lex_state = 50, .external_lex_state = 2},
  [1795] = {.lex_state = 50, .external_lex_state = 2},
  [1796] = {.lex_state = 50, .external_lex_state = 2},
  [1797] = {.lex_state = 50, .external_lex_state = 2},
  [1798] = {.lex_state = 50, .external_lex_state = 2},
  [1799] = {.lex_state = 50, .external_lex_state = 2},
  [1800] = {.lex_state = 50, .external_lex_state = 2},
  [1801] = {.lex_state = 50, .external_lex_state = 2},
  [1802] = {.lex_state = 50, .external_lex_state = 2},
  [1803] = {.lex_state = 50, .external_lex_state = 2},
  [1804] = {.lex_state = 50, .external_lex_state = 2},
  [1805] = {.lex_state = 50, .external_lex_state = 2},
  [1806] = {.lex_state = 50, .external_lex_state = 2},
  [1807] = {.lex_state = 50, .external_lex_state = 2},
  [1808] = {.lex_state = 50, .external_lex_state = 2},
  [1809] = {.lex_state = 50, .external_lex_state = 2},
  [1810] = {.lex_state = 50, .external_lex_state = 2},
  [1811] = {.lex_state = 50, .external_lex_state = 2},
  [1812] = {.lex_state = 50, .external_lex_state = 2},
  [1813] = {.lex_state = 50, .external_lex_state = 2},
  [1814] = {.lex_state = 50, .external_lex_state = 2},
  [1815] = {.lex_state = 50, .external_lex_state = 2},
  [1816] = {.lex_state = 50, .external_lex_state = 2},
  [1817] = {.lex_state = 50, .external_lex_state = 2},
  [1818] = {.lex_state = 50, .external_lex_state = 2},
  [1819] = {.lex_state = 50, .external_lex_state = 2},
  [1820] = {.lex_state = 50, .external_lex_state = 2},
  [1821] = {.lex_state = 50, .external_lex_state = 2},
  [1822] = {.lex_state = 50, .external_lex_state = 2},
  [1823] = {.lex_state = 50, .external_lex_state = 2},
  [1824] = {.lex_state = 50, .external_lex_state = 2},
  [1825] = {.lex_state = 50, .external_lex_state = 2},
  [1826] = {.lex_state = 50, .external_lex_state = 2},
  [1827] = {.lex_state = 50, .external_lex_state = 2},
  [1828] = {.lex_state = 50, .external_lex_state = 2},
  [1829] = {.lex_state = 50, .external_lex_state = 2},
  [1830] = {.lex_state = 50, .external_lex_state = 2},
  [1831] = {.lex_state = 50, .external_lex_state = 2},
  [1832] = {.lex_state = 50, .external_lex_state = 2},
  [1833] = {.lex_state = 50, .external_lex_state = 2},
  [1834] = {.lex_state = 50, .external_lex_state = 2},
  [1835] = {.lex_state = 50, .external_lex_state = 2},
  [1836] = {.lex_state = 50, .external_lex_state = 2},
  [1837] = {.lex_state = 50, .external_lex_state = 2},
  [1838] = {.lex_state = 50, .external_lex_state = 2},
  [1839] = {.lex_state = 50, .external_lex_state = 2},
  [1840] = {.lex_state = 50, .external_lex_state = 2},
  [1841] = {.lex_state = 50, .external_lex_state = 2},
  [1842] = {.lex_state = 50, .external_lex_state = 2},
  [1843] = {.lex_state = 50, .external_lex_state = 2},
  [1844] = {.lex_state = 50, .external_lex_state = 2},
  [1845] = {.lex_state = 50, .external_lex_state = 2},
  [1846] = {.lex_state = 50, .external_lex_state = 2},
  [1847] = {.lex_state = 50, .external_lex_state = 2},
  [1848] = {.lex_state = 50, .external_lex_state = 2},
  [1849] = {.lex_state = 50, .external_lex_state = 2},
  [1850] = {.lex_state = 50, .external_lex_state = 2},
  [1851] = {.lex_state = 50, .external_lex_state = 2},
  [1852] = {.lex_state = 50, .external_lex_state = 2},
  [1853] = {.lex_state = 50, .external_lex_state = 2},
  [1854] = {.lex_state = 50, .external_lex_state = 2},
  [1855] = {.lex_state = 50, .external_lex_state = 2},
  [1856] = {.lex_state = 50, .external_lex_state = 2},
  [1857] = {.lex_state = 50, .external_lex_state = 2},
  [1858] = {.lex_state = 50, .external_lex_state = 2},
  [1859] = {.lex_state = 50, .external_lex_state = 2},
  [1860] = {.lex_state = 50, .external_lex_state = 2},
  [1861] = {.lex_state = 50, .external_lex_state = 2},
  [1862] = {.lex_state = 50, .external_lex_state = 2},
  [1863] = {.lex_state = 50, .external_lex_state = 2},
  [1864] = {.lex_state = 50, .external_lex_state = 2},
  [1865] = {.lex_state = 50, .external_lex_state = 2},
  [1866] = {.lex_state = 50, .external_lex_state = 2},
  [1867] = {.lex_state = 50, .external_lex_state = 2},
  [1868] = {.lex_state = 50, .external_lex_state = 2},
  [1869] = {.lex_state = 50, .external_lex_state = 2},
  [1870] = {.lex_state = 50, .external_lex_state = 2},
  [1871] = {.lex_state = 50, .external_lex_state = 2},
  [1872] = {.lex_state = 50, .external_lex_state = 2},
  [1873] = {.lex_state = 50, .external_lex_state = 2},
  [1874] = {.lex_state = 50, .external_lex_state = 2},
  [1875] = {.lex_state = 50, .external_lex_state = 2},
  [1876] = {.lex_state = 50, .external_lex_state = 2},
  [1877] = {.lex_state = 50, .external_lex_state = 2},
  [1878] = {.lex_state = 50, .external_lex_state = 2},
  [1879] = {.lex_state = 50, .external_lex_state = 2},
  [1880] = {.lex_state = 50, .external_lex_state = 2},
  [1881] = {.lex_state = 50, .external_lex_state = 2},
  [1882] = {.lex_state = 50, .external_lex_state = 2},
  [1883] = {.lex_state = 50, .external_lex_state = 2},
  [1884] = {.lex_state = 50, .external_lex_state = 2},
  [1885] = {.lex_state = 50, .external_lex_state = 2},
  [1886] = {.lex_state = 50, .external_lex_state = 2},
  [1887] = {.lex_state = 50, .external_lex_state = 2},
  [1888] = {.lex_state = 50, .external_lex_state = 2},
  [1889] = {.lex_state = 50, .external_lex_state = 2},
  [1890] = {.lex_state = 50, .external_lex_state = 2},
  [1891] = {.lex_state = 50, .external_lex_state = 2},
  [1892] = {.lex_state = 5, .external_lex_state = 1},
  [1893] = {.lex_state = 50, .external_lex_state = 2},
  [1894] = {.lex_state = 5, .external_lex_state = 1},
  [1895] = {.lex_state = 50, .external_lex_state = 2},
  [1896] = {.lex_state = 50, .external_lex_state = 2},
  [1897] = {.lex_state = 50, .external_lex_state = 2},
  [1898] = {.lex_state = 50, .external_lex_state = 2},
  [1899] = {.lex_state = 5, .external_lex_state = 1},
  [1900] = {.lex_state = 50, .external_lex_state = 2},
  [1901] = {.lex_state = 50, .external_lex_state = 2},
  [1902] = {.lex_state = 50, .external_lex_state = 2},
  [1903] = {.lex_state = 50, .external_lex_state = 2},
  [1904] = {.lex_state = 50, .external_lex_state = 2},
  [1905] = {.lex_state = 5, .external_lex_state = 1},
  [1906] = {.lex_state = 50, .external_lex_state = 2},
  [1907] = {.lex_state = 50, .external_lex_state = 2},
  [1908] = {.lex_state = 5, .external_lex_state = 1},
  [1909] = {.lex_state = 50, .external_lex_state = 2},
  [1910] = {.lex_state = 50, .external_lex_state = 2},
  [1911] = {.lex_state = 50, .external_lex_state = 2},
  [1912] = {.lex_state = 50, .external_lex_state = 2},
  [1913] = {.lex_state = 50, .external_lex_state = 2},
  [1914] = {.lex_state = 50, .external_lex_state = 2},
  [1915] = {.lex_state = 50, .external_lex_state = 2},
  [1916] = {.lex_state = 50, .external_lex_state = 2},
  [1917] = {.lex_state = 5, .external_lex_state = 1},
  [1918] = {.lex_state = 5, .external_lex_state = 1},
  [1919] = {.lex_state = 5, .external_lex_state = 1},
  [1920] = {.lex_state = 50, .external_lex_state = 2},
  [1921] = {.lex_state = 50, .external_lex_state = 2},
  [1922] = {.lex_state = 5, .external_lex_state = 1},
  [1923] = {.lex_state = 5, .external_lex_state = 1},
  [1924] = {.lex_state = 50, .external_lex_state = 2},
  [1925] = {.lex_state = 50, .external_lex_state = 2},
  [1926] = {.lex_state = 50, .external_lex_state = 2},
  [1927] = {.lex_state = 50, .external_lex_state = 2},
  [1928] = {.lex_state = 50, .external_lex_state = 2},
  [1929] = {.lex_state = 50, .external_lex_state = 2},
  [1930] = {.lex_state = 50, .external_lex_state = 2},
  [1931] = {.lex_state = 50, .external_lex_state = 2},
  [1932] = {.lex_state = 50, .external_lex_state = 2},
  [1933] = {.lex_state = 50, .external_lex_state = 2},
  [1934] = {.lex_state = 50, .external_lex_state = 2},
  [1935] = {.lex_state = 50, .external_lex_state = 2},
  [1936] = {.lex_state = 50, .external_lex_state = 2},
  [1937] = {.lex_state = 5, .external_lex_state = 1},
  [1938] = {.lex_state = 5, .external_lex_state = 1},
  [1939] = {.lex_state = 12, .external_lex_state = 3},
  [1940] = {.lex_state = 12, .external_lex_state = 3},
  [1941] = {.lex_state = 12, .external_lex_state = 3},
  [1942] = {.lex_state = 12, .external_lex_state = 3},
  [1943] = {.lex_state = 12, .external_lex_state = 3},
  [1944] = {.lex_state = 12, .external_lex_state = 3},
  [1945] = {.lex_state = 12, .external_lex_state = 3},
  [1946] = {.lex_state = 12, .external_lex_state = 3},
  [1947] = {.lex_state = 12, .external_lex_state = 3},
  [1948] = {.lex_state = 12, .external_lex_state = 3},
  [1949] = {.lex_state = 12, .external_lex_state = 3},
  [1950] = {.lex_state = 12, .external_lex_state = 3},
  [1951] = {.lex_state = 12, .external_lex_state = 3},
  [1952] = {.lex_state = 12, .external_lex_state = 3},
  [1953] = {.lex_state = 12, .external_lex_state = 3},
  [1954] = {.lex_state = 12, .external_lex_state = 3},
  [1955] = {.lex_state = 12, .external_lex_state = 3},
  [1956] = {.lex_state = 12, .external_lex_state = 3},
  [1957] = {.lex_state = 12, .external_lex_state = 3},
  [1958] = {.lex_state = 12, .external_lex_state = 3},
  [1959] = {.lex_state = 12, .external_lex_state = 3},
  [1960] = {.lex_state = 12, .external_lex_state = 3},
  [1961] = {.lex_state = 12, .external_lex_state = 3},
  [1962] = {.lex_state = 12, .external_lex_state = 3},
  [1963] = {.lex_state = 12, .external_lex_state = 3},
  [1964] = {.lex_state = 12, .external_lex_state = 3},
  [1965] = {.lex_state = 12, .external_lex_state = 3},
  [1966] = {.lex_state = 12, .external_lex_state = 3},
  [1967] = {.lex_state = 12, .external_lex_state = 3},
  [1968] = {.lex_state = 12, .external_lex_state = 3},
  [1969] = {.lex_state = 12, .external_lex_state = 3},
  [1970] = {.lex_state = 12, .external_lex_state = 3},
  [1971] = {.lex_state = 12, .external_lex_state = 3},
  [1972] = {.lex_state = 12, .external_lex_state = 3},
  [1973] = {.lex_state = 12, .external_lex_state = 3},
  [1974] = {.lex_state = 12, .external_lex_state = 3},
  [1975] = {.lex_state = 12, .external_lex_state = 3},
  [1976] = {.lex_state = 12, .external_lex_state = 3},
  [1977] = {.lex_state = 12, .external_lex_state = 3},
  [1978] = {.lex_state = 12, .external_lex_state = 3},
  [1979] = {.lex_state = 12, .external_lex_state = 3},
  [1980] = {.lex_state = 12, .external_lex_state = 3},
  [1981] = {.lex_state = 12, .external_lex_state = 3},
  [1982] = {.lex_state = 12, .external_lex_state = 3},
  [1983] = {.lex_state = 12, .external_lex_state = 3},
  [1984] = {.lex_state = 12, .external_lex_state = 3},
  [1985] = {.lex_state = 12, .external_lex_state = 3},
  [1986] = {.lex_state = 12, .external_lex_state = 3},
  [1987] = {.lex_state = 12, .external_lex_state = 3},
  [1988] = {.lex_state = 12, .external_lex_state = 3},
  [1989] = {.lex_state = 12, .external_lex_state = 3},
  [1990] = {.lex_state = 12, .external_lex_state = 3},
  [1991] = {.lex_state = 12, .external_lex_state = 3},
  [1992] = {.lex_state = 12, .external_lex_state = 3},
  [1993] = {.lex_state = 12, .external_lex_state = 3},
  [1994] = {.lex_state = 12, .external_lex_state = 3},
  [1995] = {.lex_state = 12, .external_lex_state = 3},
  [1996] = {.lex_state = 12, .external_lex_state = 3},
  [1997] = {.lex_state = 12, .external_lex_state = 3},
  [1998] = {.lex_state = 12, .external_lex_state = 3},
  [1999] = {.lex_state = 12, .external_lex_state = 3},
  [2000] = {.lex_state = 12, .external_lex_state = 3},
  [2001] = {.lex_state = 12, .external_lex_state = 3},
  [2002] = {.lex_state = 12, .external_lex_state = 3},
  [2003] = {.lex_state = 12, .external_lex_state = 3},
  [2004] = {.lex_state = 12, .external_lex_state = 3},
  [2005] = {.lex_state = 12, .external_lex_state = 3},
  [2006] = {.lex_state = 12, .external_lex_state = 3},
  [2007] = {.lex_state = 12, .external_lex_state = 3},
  [2008] = {.lex_state = 12, .external_lex_state = 3},
  [2009] = {.lex_state = 12, .external_lex_state = 3},
  [2010] = {.lex_state = 12, .external_lex_state = 3},
  [2011] = {.lex_state = 12, .external_lex_state = 3},
  [2012] = {.lex_state = 12, .external_lex_state = 3},
  [2013] = {.lex_state = 12, .external_lex_state = 3},
  [2014] = {.lex_state = 12, .external_lex_state = 3},
  [2015] = {.lex_state = 12, .external_lex_state = 3},
  [2016] = {.lex_state = 12, .external_lex_state = 3},
  [2017] = {.lex_state = 12, .external_lex_state = 3},
  [2018] = {.lex_state = 12, .external_lex_state = 3},
  [2019] = {.lex_state = 12, .external_lex_state = 3},
  [2020] = {.lex_state = 12, .external_lex_state = 3},
  [2021] = {.lex_state = 12, .external_lex_state = 3},
  [2022] = {.lex_state = 12, .external_lex_state = 3},
  [2023] = {.lex_state = 12, .external_lex_state = 3},
  [2024] = {.lex_state = 12, .external_lex_state = 3},
  [2025] = {.lex_state = 12, .external_lex_state = 3},
  [2026] = {.lex_state = 12, .external_lex_state = 3},
  [2027] = {.lex_state = 12, .external_lex_state = 3},
  [2028] = {.lex_state = 12, .external_lex_state = 3},
  [2029] = {.lex_state = 12, .external_lex_state = 3},
  [2030] = {.lex_state = 12, .external_lex_state = 3},
  [2031] = {.lex_state = 12, .external_lex_state = 3},
  [2032] = {.lex_state = 12, .external_lex_state = 3},
  [2033] = {.lex_state = 12, .external_lex_state = 3},
  [2034] = {.lex_state = 12, .external_lex_state = 3},
  [2035] = {.lex_state = 12, .external_lex_state = 3},
  [2036] = {.lex_state = 12, .external_lex_state = 3},
  [2037] = {.lex_state = 12, .external_lex_state = 3},
  [2038] = {.lex_state = 12, .external_lex_state = 3},
  [2039] = {.lex_state = 12, .external_lex_state = 3},
  [2040] = {.lex_state = 12, .external_lex_state = 3},
  [2041] = {.lex_state = 12, .external_lex_state = 3},
  [2042] = {.lex_state = 12, .external_lex_state = 3},
  [2043] = {.lex_state = 12, .external_lex_state = 3},
  [2044] = {.lex_state = 12, .external_lex_state = 3},
  [2045] = {.lex_state = 12, .external_lex_state = 3},
  [2046] = {.lex_state = 12, .external_lex_state = 3},
  [2047] = {.lex_state = 12, .external_lex_state = 3},
  [2048] = {.lex_state = 12, .external_lex_state = 3},
  [2049] = {.lex_state = 12, .external_lex_state = 3},
  [2050] = {.lex_state = 12, .external_lex_state = 3},
  [2051] = {.lex_state = 12, .external_lex_state = 3},
  [2052] = {.lex_state = 12, .external_lex_state = 3},
  [2053] = {.lex_state = 12, .external_lex_state = 3},
  [2054] = {.lex_state = 12, .external_lex_state = 3},
  [2055] = {.lex_state = 12, .external_lex_state = 3},
  [2056] = {.lex_state = 12, .external_lex_state = 3},
  [2057] = {.lex_state = 12, .external_lex_state = 3},
  [2058] = {.lex_state = 12, .external_lex_state = 3},
  [2059] = {.lex_state = 12, .external_lex_state = 3},
  [2060] = {.lex_state = 12, .external_lex_state = 3},
  [2061] = {.lex_state = 12, .external_lex_state = 3},
  [2062] = {.lex_state = 12, .external_lex_state = 3},
  [2063] = {.lex_state = 12, .external_lex_state = 3},
  [2064] = {.lex_state = 12, .external_lex_state = 3},
  [2065] = {.lex_state = 12, .external_lex_state = 3},
  [2066] = {.lex_state = 12, .external_lex_state = 3},
  [2067] = {.lex_state = 12, .external_lex_state = 3},
  [2068] = {.lex_state = 12, .external_lex_state = 3},
  [2069] = {.lex_state = 12, .external_lex_state = 3},
  [2070] = {.lex_state = 12, .external_lex_state = 3},
  [2071] = {.lex_state = 12, .external_lex_state = 3},
  [2072] = {.lex_state = 12, .external_lex_state = 3},
  [2073] = {.lex_state = 12, .external_lex_state = 3},
  [2074] = {.lex_state = 12, .external_lex_state = 3},
  [2075] = {.lex_state = 12, .external_lex_state = 3},
  [2076] = {.lex_state = 12, .external_lex_state = 3},
  [2077] = {.lex_state = 12, .external_lex_state = 3},
  [2078] = {.lex_state = 12, .external_lex_state = 3},
  [2079] = {.lex_state = 12, .external_lex_state = 3},
  [2080] = {.lex_state = 12, .external_lex_state = 3},
  [2081] = {.lex_state = 12, .external_lex_state = 3},
  [2082] = {.lex_state = 12, .external_lex_state = 3},
  [2083] = {.lex_state = 12, .external_lex_state = 3},
  [2084] = {.lex_state = 12, .external_lex_state = 3},
  [2085] = {.lex_state = 12, .external_lex_state = 3},
  [2086] = {.lex_state = 12, .external_lex_state = 3},
  [2087] = {.lex_state = 12, .external_lex_state = 3},
  [2088] = {.lex_state = 12, .external_lex_state = 3},
  [2089] = {.lex_state = 12, .external_lex_state = 3},
  [2090] = {.lex_state = 12, .external_lex_state = 3},
  [2091] = {.lex_state = 12, .external_lex_state = 3},
  [2092] = {.lex_state = 12, .external_lex_state = 3},
  [2093] = {.lex_state = 12, .external_lex_state = 3},
  [2094] = {.lex_state = 12, .external_lex_state = 3},
  [2095] = {.lex_state = 12, .external_lex_state = 3},
  [2096] = {.lex_state = 12, .external_lex_state = 3},
  [2097] = {.lex_state = 12, .external_lex_state = 3},
  [2098] = {.lex_state = 12, .external_lex_state = 3},
  [2099] = {.lex_state = 12, .external_lex_state = 3},
  [2100] = {.lex_state = 12, .external_lex_state = 3},
  [2101] = {.lex_state = 12, .external_lex_state = 3},
  [2102] = {.lex_state = 12, .external_lex_state = 3},
  [2103] = {.lex_state = 12, .external_lex_state = 3},
  [2104] = {.lex_state = 12, .external_lex_state = 3},
  [2105] = {.lex_state = 12, .external_lex_state = 3},
  [2106] = {.lex_state = 12, .external_lex_state = 3},
  [2107] = {.lex_state = 12, .external_lex_state = 3},
  [2108] = {.lex_state = 12, .external_lex_state = 3},
  [2109] = {.lex_state = 12, .external_lex_state = 3},
  [2110] = {.lex_state = 12, .external_lex_state = 3},
  [2111] = {.lex_state = 12, .external_lex_state = 3},
  [2112] = {.lex_state = 12, .external_lex_state = 3},
  [2113] = {.lex_state = 12, .external_lex_state = 3},
  [2114] = {.lex_state = 12, .external_lex_state = 3},
  [2115] = {.lex_state = 12, .external_lex_state = 3},
  [2116] = {.lex_state = 12, .external_lex_state = 3},
  [2117] = {.lex_state = 12, .external_lex_state = 3},
  [2118] = {.lex_state = 12, .external_lex_state = 3},
  [2119] = {.lex_state = 12, .external_lex_state = 3},
  [2120] = {.lex_state = 12, .external_lex_state = 3},
  [2121] = {.lex_state = 12, .external_lex_state = 3},
  [2122] = {.lex_state = 12, .external_lex_state = 3},
  [2123] = {.lex_state = 12, .external_lex_state = 3},
  [2124] = {.lex_state = 12, .external_lex_state = 3},
  [2125] = {.lex_state = 12, .external_lex_state = 3},
  [2126] = {.lex_state = 12, .external_lex_state = 3},
  [2127] = {.lex_state = 12, .external_lex_state = 3},
  [2128] = {.lex_state = 12, .external_lex_state = 3},
  [2129] = {.lex_state = 12, .external_lex_state = 3},
  [2130] = {.lex_state = 12, .external_lex_state = 3},
  [2131] = {.lex_state = 12, .external_lex_state = 3},
  [2132] = {.lex_state = 12, .external_lex_state = 3},
  [2133] = {.lex_state = 12, .external_lex_state = 3},
  [2134] = {.lex_state = 50, .external_lex_state = 2},
  [2135] = {.lex_state = 50, .external_lex_state = 2},
  [2136] = {.lex_state = 50, .external_lex_state = 2},
  [2137] = {.lex_state = 50, .external_lex_state = 2},
  [2138] = {.lex_state = 50, .external_lex_state = 2},
  [2139] = {.lex_state = 50, .external_lex_state = 2},
  [2140] = {.lex_state = 50, .external_lex_state = 2},
  [2141] = {.lex_state = 50, .external_lex_state = 2},
  [2142] = {.lex_state = 50, .external_lex_state = 2},
  [2143] = {.lex_state = 50, .external_lex_state = 2},
  [2144] = {.lex_state = 50, .external_lex_state = 2},
  [2145] = {.lex_state = 50, .external_lex_state = 2},
  [2146] = {.lex_state = 50, .external_lex_state = 2},
  [2147] = {.lex_state = 50, .external_lex_state = 2},
  [2148] = {.lex_state = 50, .external_lex_state = 2},
  [2149] = {.lex_state = 50, .external_lex_state = 2},
  [2150] = {.lex_state = 50, .external_lex_state = 2},
  [2151] = {.lex_state = 50, .external_lex_state = 2},
  [2152] = {.lex_state = 50, .external_lex_state = 2},
  [2153] = {.lex_state = 50, .external_lex_state = 2},
  [2154] = {.lex_state = 50, .external_lex_state = 2},
  [2155] = {.lex_state = 50, .external_lex_state = 2},
  [2156] = {.lex_state = 50, .external_lex_state = 2},
  [2157] = {.lex_state = 50, .external_lex_state = 2},
  [2158] = {.lex_state = 50, .external_lex_state = 2},
  [2159] = {.lex_state = 50, .external_lex_state = 2},
  [2160] = {.lex_state = 50, .external_lex_state = 2},
  [2161] = {.lex_state = 50, .external_lex_state = 2},
  [2162] = {.lex_state = 50, .external_lex_state = 2},
  [2163] = {.lex_state = 50, .external_lex_state = 2},
  [2164] = {.lex_state = 50, .external_lex_state = 2},
  [2165] = {.lex_state = 50, .external_lex_state = 2},
  [2166] = {.lex_state = 50, .external_lex_state = 2},
  [2167] = {.lex_state = 50, .external_lex_state = 2},
  [2168] = {.lex_state = 50, .external_lex_state = 2},
  [2169] = {.lex_state = 50, .external_lex_state = 2},
  [2170] = {.lex_state = 50, .external_lex_state = 2},
  [2171] = {.lex_state = 50, .external_lex_state = 2},
  [2172] = {.lex_state = 50, .external_lex_state = 2},
  [2173] = {.lex_state = 50, .external_lex_state = 2},
  [2174] = {.lex_state = 50, .external_lex_state = 2},
  [2175] = {.lex_state = 50, .external_lex_state = 2},
  [2176] = {.lex_state = 50, .external_lex_state = 2},
  [2177] = {.lex_state = 50, .external_lex_state = 2},
  [2178] = {.lex_state = 50, .external_lex_state = 2},
  [2179] = {.lex_state = 50, .external_lex_state = 2},
  [2180] = {.lex_state = 50, .external_lex_state = 2},
  [2181] = {.lex_state = 50, .external_lex_state = 2},
  [2182] = {.lex_state = 50, .external_lex_state = 2},
  [2183] = {.lex_state = 50, .external_lex_state = 2},
  [2184] = {.lex_state = 50, .external_lex_state = 2},
  [2185] = {.lex_state = 50, .external_lex_state = 2},
  [2186] = {.lex_state = 50, .external_lex_state = 2},
  [2187] = {.lex_state = 50, .external_lex_state = 2},
  [2188] = {.lex_state = 50, .external_lex_state = 2},
  [2189] = {.lex_state = 50, .external_lex_state = 2},
  [2190] = {.lex_state = 50, .external_lex_state = 2},
  [2191] = {.lex_state = 50, .external_lex_state = 2},
  [2192] = {.lex_state = 50, .external_lex_state = 2},
  [2193] = {.lex_state = 50, .external_lex_state = 2},
  [2194] = {.lex_state = 50, .external_lex_state = 2},
  [2195] = {.lex_state = 50, .external_lex_state = 2},
  [2196] = {.lex_state = 50, .external_lex_state = 2},
  [2197] = {.lex_state = 50, .external_lex_state = 2},
  [2198] = {.lex_state = 50, .external_lex_state = 2},
  [2199] = {.lex_state = 50, .external_lex_state = 2},
  [2200] = {.lex_state = 50, .external_lex_state = 2},
  [2201] = {.lex_state = 50, .external_lex_state = 2},
  [2202] = {.lex_state = 50, .external_lex_state = 2},
  [2203] = {.lex_state = 50, .external_lex_state = 2},
  [2204] = {.lex_state = 50, .external_lex_state = 2},
  [2205] = {.lex_state = 50, .external_lex_state = 2},
  [2206] = {.lex_state = 50, .external_lex_state = 2},
  [2207] = {.lex_state = 50, .external_lex_state = 2},
  [2208] = {.lex_state = 50, .external_lex_state = 2},
  [2209] = {.lex_state = 50, .external_lex_state = 2},
  [2210] = {.lex_state = 50, .external_lex_state = 2},
  [2211] = {.lex_state = 50, .external_lex_state = 2},
  [2212] = {.lex_state = 50, .external_lex_state = 2},
  [2213] = {.lex_state = 50, .external_lex_state = 2},
  [2214] = {.lex_state = 50, .external_lex_state = 2},
  [2215] = {.lex_state = 50, .external_lex_state = 2},
  [2216] = {.lex_state = 50, .external_lex_state = 2},
  [2217] = {.lex_state = 50, .external_lex_state = 2},
  [2218] = {.lex_state = 50, .external_lex_state = 2},
  [2219] = {.lex_state = 50, .external_lex_state = 2},
  [2220] = {.lex_state = 50, .external_lex_state = 2},
  [2221] = {.lex_state = 50, .external_lex_state = 2},
  [2222] = {.lex_state = 50, .external_lex_state = 2},
  [2223] = {.lex_state = 50, .external_lex_state = 2},
  [2224] = {.lex_state = 50, .external_lex_state = 2},
  [2225] = {.lex_state = 50, .external_lex_state = 2},
  [2226] = {.lex_state = 50, .external_lex_state = 2},
  [2227] = {.lex_state = 50, .external_lex_state = 2},
  [2228] = {.lex_state = 50, .external_lex_state = 2},
  [2229] = {.lex_state = 50, .external_lex_state = 2},
  [2230] = {.lex_state = 50, .external_lex_state = 2},
  [2231] = {.lex_state = 50, .external_lex_state = 2},
  [2232] = {.lex_state = 50, .external_lex_state = 2},
  [2233] = {.lex_state = 50, .external_lex_state = 2},
  [2234] = {.lex_state = 50, .external_lex_state = 2},
  [2235] = {.lex_state = 14, .external_lex_state = 2},
  [2236] = {.lex_state = 50, .external_lex_state = 2},
  [2237] = {.lex_state = 50, .external_lex_state = 2},
  [2238] = {.lex_state = 50, .external_lex_state = 2},
  [2239] = {.lex_state = 50, .external_lex_state = 2},
  [2240] = {.lex_state = 50, .external_lex_state = 2},
  [2241] = {.lex_state = 50, .external_lex_state = 2},
  [2242] = {.lex_state = 50, .external_lex_state = 2},
  [2243] = {.lex_state = 50, .external_lex_state = 2},
  [2244] = {.lex_state = 50, .external_lex_state = 2},
  [2245] = {.lex_state = 50, .external_lex_state = 2},
  [2246] = {.lex_state = 50, .external_lex_state = 2},
  [2247] = {.lex_state = 50, .external_lex_state = 2},
  [2248] = {.lex_state = 50, .external_lex_state = 2},
  [2249] = {.lex_state = 50, .external_lex_state = 2},
  [2250] = {.lex_state = 50, .external_lex_state = 2},
  [2251] = {.lex_state = 50, .external_lex_state = 2},
  [2252] = {.lex_state = 50, .external_lex_state = 2},
  [2253] = {.lex_state = 50, .external_lex_state = 2},
  [2254] = {.lex_state = 50, .external_lex_state = 2},
  [2255] = {.lex_state = 50, .external_lex_state = 2},
  [2256] = {.lex_state = 50, .external_lex_state = 2},
  [2257] = {.lex_state = 50, .external_lex_state = 2},
  [2258] = {.lex_state = 50, .external_lex_state = 2},
  [2259] = {.lex_state = 50, .external_lex_state = 2},
  [2260] = {.lex_state = 50, .external_lex_state = 2},
  [2261] = {.lex_state = 50, .external_lex_state = 2},
  [2262] = {.lex_state = 50, .external_lex_state = 2},
  [2263] = {.lex_state = 50, .external_lex_state = 2},
  [2264] = {.lex_state = 50, .external_lex_state = 2},
  [2265] = {.lex_state = 50, .external_lex_state = 2},
  [2266] = {.lex_state = 50, .external_lex_state = 2},
  [2267] = {.lex_state = 50, .external_lex_state = 2},
  [2268] = {.lex_state = 50, .external_lex_state = 2},
  [2269] = {.lex_state = 50, .external_lex_state = 2},
  [2270] = {.lex_state = 50, .external_lex_state = 2},
  [2271] = {.lex_state = 50, .external_lex_state = 2},
  [2272] = {.lex_state = 50, .external_lex_state = 2},
  [2273] = {.lex_state = 50, .external_lex_state = 2},
  [2274] = {.lex_state = 50, .external_lex_state = 2},
  [2275] = {.lex_state = 50, .external_lex_state = 2},
  [2276] = {.lex_state = 50, .external_lex_state = 2},
  [2277] = {.lex_state = 50, .external_lex_state = 2},
  [2278] = {.lex_state = 50, .external_lex_state = 2},
  [2279] = {.lex_state = 50, .external_lex_state = 2},
  [2280] = {.lex_state = 50, .external_lex_state = 2},
  [2281] = {.lex_state = 50, .external_lex_state = 2},
  [2282] = {.lex_state = 50, .external_lex_state = 2},
  [2283] = {.lex_state = 50, .external_lex_state = 2},
  [2284] = {.lex_state = 50, .external_lex_state = 2},
  [2285] = {.lex_state = 50, .external_lex_state = 2},
  [2286] = {.lex_state = 50, .external_lex_state = 2},
  [2287] = {.lex_state = 50, .external_lex_state = 2},
  [2288] = {.lex_state = 50, .external_lex_state = 2},
  [2289] = {.lex_state = 50, .external_lex_state = 2},
  [2290] = {.lex_state = 50, .external_lex_state = 2},
  [2291] = {.lex_state = 50, .external_lex_state = 2},
  [2292] = {.lex_state = 50, .external_lex_state = 2},
  [2293] = {.lex_state = 50, .external_lex_state = 2},
  [2294] = {.lex_state = 50, .external_lex_state = 2},
  [2295] = {.lex_state = 50, .external_lex_state = 2},
  [2296] = {.lex_state = 50, .external_lex_state = 2},
  [2297] = {.lex_state = 50, .external_lex_state = 2},
  [2298] = {.lex_state = 50, .external_lex_state = 2},
  [2299] = {.lex_state = 50, .external_lex_state = 2},
  [2300] = {.lex_state = 50, .external_lex_state = 2},
  [2301] = {.lex_state = 14, .external_lex_state = 2},
  [2302] = {.lex_state = 50, .external_lex_state = 2},
  [2303] = {.lex_state = 50, .external_lex_state = 2},
  [2304] = {.lex_state = 50, .external_lex_state = 2},
  [2305] = {.lex_state = 50, .external_lex_state = 2},
  [2306] = {.lex_state = 14, .external_lex_state = 2},
  [2307] = {.lex_state = 50, .external_lex_state = 2},
  [2308] = {.lex_state = 50, .external_lex_state = 2},
  [2309] = {.lex_state = 50, .external_lex_state = 2},
  [2310] = {.lex_state = 50, .external_lex_state = 2},
  [2311] = {.lex_state = 50, .external_lex_state = 2},
  [2312] = {.lex_state = 50, .external_lex_state = 2},
  [2313] = {.lex_state = 50, .external_lex_state = 2},
  [2314] = {.lex_state = 50, .external_lex_state = 2},
  [2315] = {.lex_state = 50, .external_lex_state = 2},
  [2316] = {.lex_state = 50, .external_lex_state = 2},
  [2317] = {.lex_state = 50, .external_lex_state = 2},
  [2318] = {.lex_state = 50, .external_lex_state = 2},
  [2319] = {.lex_state = 50, .external_lex_state = 2},
  [2320] = {.lex_state = 50, .external_lex_state = 2},
  [2321] = {.lex_state = 50, .external_lex_state = 2},
  [2322] = {.lex_state = 50, .external_lex_state = 2},
  [2323] = {.lex_state = 50, .external_lex_state = 2},
  [2324] = {.lex_state = 50, .external_lex_state = 2},
  [2325] = {.lex_state = 50, .external_lex_state = 2},
  [2326] = {.lex_state = 50, .external_lex_state = 2},
  [2327] = {.lex_state = 50, .external_lex_state = 2},
  [2328] = {.lex_state = 50, .external_lex_state = 2},
  [2329] = {.lex_state = 50, .external_lex_state = 2},
  [2330] = {.lex_state = 50, .external_lex_state = 2},
  [2331] = {.lex_state = 50, .external_lex_state = 2},
  [2332] = {.lex_state = 50, .external_lex_state = 2},
  [2333] = {.lex_state = 50, .external_lex_state = 2},
  [2334] = {.lex_state = 50, .external_lex_state = 2},
  [2335] = {.lex_state = 50, .external_lex_state = 2},
  [2336] = {.lex_state = 50, .external_lex_state = 2},
  [2337] = {.lex_state = 50, .external_lex_state = 2},
  [2338] = {.lex_state = 50, .external_lex_state = 2},
  [2339] = {.lex_state = 50, .external_lex_state = 2},
  [2340] = {.lex_state = 50, .external_lex_state = 2},
  [2341] = {.lex_state = 50, .external_lex_state = 2},
  [2342] = {.lex_state = 50, .external_lex_state = 2},
  [2343] = {.lex_state = 50, .external_lex_state = 2},
  [2344] = {.lex_state = 50, .external_lex_state = 2},
  [2345] = {.lex_state = 50, .external_lex_state = 2},
  [2346] = {.lex_state = 50, .external_lex_state = 2},
  [2347] = {.lex_state = 50, .external_lex_state = 2},
  [2348] = {.lex_state = 50, .external_lex_state = 2},
  [2349] = {.lex_state = 50, .external_lex_state = 2},
  [2350] = {.lex_state = 50, .external_lex_state = 2},
  [2351] = {.lex_state = 50, .external_lex_state = 2},
  [2352] = {.lex_state = 50, .external_lex_state = 2},
  [2353] = {.lex_state = 50, .external_lex_state = 2},
  [2354] = {.lex_state = 50, .external_lex_state = 2},
  [2355] = {.lex_state = 50, .external_lex_state = 2},
  [2356] = {.lex_state = 50, .external_lex_state = 2},
  [2357] = {.lex_state = 50, .external_lex_state = 2},
  [2358] = {.lex_state = 50, .external_lex_state = 2},
  [2359] = {.lex_state = 50, .external_lex_state = 2},
  [2360] = {.lex_state = 50, .external_lex_state = 2},
  [2361] = {.lex_state = 50, .external_lex_state = 2},
  [2362] = {.lex_state = 50, .external_lex_state = 2},
  [2363] = {.lex_state = 50, .external_lex_state = 2},
  [2364] = {.lex_state = 50, .external_lex_state = 2},
  [2365] = {.lex_state = 50, .external_lex_state = 2},
  [2366] = {.lex_state = 50, .external_lex_state = 2},
  [2367] = {.lex_state = 50, .external_lex_state = 2},
  [2368] = {.lex_state = 50, .external_lex_state = 2},
  [2369] = {.lex_state = 50, .external_lex_state = 2},
  [2370] = {.lex_state = 50, .external_lex_state = 2},
  [2371] = {.lex_state = 50, .external_lex_state = 2},
  [2372] = {.lex_state = 50, .external_lex_state = 2},
  [2373] = {.lex_state = 50, .external_lex_state = 2},
  [2374] = {.lex_state = 50, .external_lex_state = 2},
  [2375] = {.lex_state = 50, .external_lex_state = 2},
  [2376] = {.lex_state = 50, .external_lex_state = 2},
  [2377] = {.lex_state = 50, .external_lex_state = 2},
  [2378] = {.lex_state = 50, .external_lex_state = 2},
  [2379] = {.lex_state = 50, .external_lex_state = 2},
  [2380] = {.lex_state = 50, .external_lex_state = 2},
  [2381] = {.lex_state = 50, .external_lex_state = 2},
  [2382] = {.lex_state = 50, .external_lex_state = 2},
  [2383] = {.lex_state = 50, .external_lex_state = 2},
  [2384] = {.lex_state = 50, .external_lex_state = 2},
  [2385] = {.lex_state = 14, .external_lex_state = 2},
  [2386] = {.lex_state = 50, .external_lex_state = 2},
  [2387] = {.lex_state = 50, .external_lex_state = 2},
  [2388] = {.lex_state = 50, .external_lex_state = 2},
  [2389] = {.lex_state = 50, .external_lex_state = 2},
  [2390] = {.lex_state = 50, .external_lex_state = 2},
  [2391] = {.lex_state = 50, .external_lex_state = 2},
  [2392] = {.lex_state = 50, .external_lex_state = 2},
  [2393] = {.lex_state = 50, .external_lex_state = 2},
  [2394] = {.lex_state = 50, .external_lex_state = 2},
  [2395] = {.lex_state = 50, .external_lex_state = 2},
  [2396] = {.lex_state = 50, .external_lex_state = 2},
  [2397] = {.lex_state = 50, .external_lex_state = 2},
  [2398] = {.lex_state = 50, .external_lex_state = 2},
  [2399] = {.lex_state = 50, .external_lex_state = 2},
  [2400] = {.lex_state = 50, .external_lex_state = 2},
  [2401] = {.lex_state = 50, .external_lex_state = 2},
  [2402] = {.lex_state = 50, .external_lex_state = 2},
  [2403] = {.lex_state = 50, .external_lex_state = 2},
  [2404] = {.lex_state = 50, .external_lex_state = 2},
  [2405] = {.lex_state = 50, .external_lex_state = 2},
  [2406] = {.lex_state = 50, .external_lex_state = 2},
  [2407] = {.lex_state = 50, .external_lex_state = 2},
  [2408] = {.lex_state = 50, .external_lex_state = 2},
  [2409] = {.lex_state = 50, .external_lex_state = 2},
  [2410] = {.lex_state = 50, .external_lex_state = 2},
  [2411] = {.lex_state = 50, .external_lex_state = 2},
  [2412] = {.lex_state = 50, .external_lex_state = 2},
  [2413] = {.lex_state = 50, .external_lex_state = 2},
  [2414] = {.lex_state = 50, .external_lex_state = 2},
  [2415] = {.lex_state = 50, .external_lex_state = 2},
  [2416] = {.lex_state = 50, .external_lex_state = 2},
  [2417] = {.lex_state = 50, .external_lex_state = 2},
  [2418] = {.lex_state = 50, .external_lex_state = 2},
  [2419] = {.lex_state = 50, .external_lex_state = 2},
  [2420] = {.lex_state = 50, .external_lex_state = 2},
  [2421] = {.lex_state = 50, .external_lex_state = 2},
  [2422] = {.lex_state = 50, .external_lex_state = 2},
  [2423] = {.lex_state = 50, .external_lex_state = 2},
  [2424] = {.lex_state = 50, .external_lex_state = 2},
  [2425] = {.lex_state = 50, .external_lex_state = 2},
  [2426] = {.lex_state = 14, .external_lex_state = 2},
  [2427] = {.lex_state = 50, .external_lex_state = 2},
  [2428] = {.lex_state = 50, .external_lex_state = 2},
  [2429] = {.lex_state = 50, .external_lex_state = 2},
  [2430] = {.lex_state = 50, .external_lex_state = 2},
  [2431] = {.lex_state = 50, .external_lex_state = 2},
  [2432] = {.lex_state = 50, .external_lex_state = 2},
  [2433] = {.lex_state = 50, .external_lex_state = 2},
  [2434] = {.lex_state = 50, .external_lex_state = 2},
  [2435] = {.lex_state = 50, .external_lex_state = 2},
  [2436] = {.lex_state = 50, .external_lex_state = 2},
  [2437] = {.lex_state = 50, .external_lex_state = 2},
  [2438] = {.lex_state = 50, .external_lex_state = 2},
  [2439] = {.lex_state = 50, .external_lex_state = 2},
  [2440] = {.lex_state = 50, .external_lex_state = 2},
  [2441] = {.lex_state = 50, .external_lex_state = 2},
  [2442] = {.lex_state = 50, .external_lex_state = 2},
  [2443] = {.lex_state = 50, .external_lex_state = 2},
  [2444] = {.lex_state = 50, .external_lex_state = 2},
  [2445] = {.lex_state = 50, .external_lex_state = 2},
  [2446] = {.lex_state = 50, .external_lex_state = 2},
  [2447] = {.lex_state = 50, .external_lex_state = 2},
  [2448] = {.lex_state = 50, .external_lex_state = 2},
  [2449] = {.lex_state = 50, .external_lex_state = 2},
  [2450] = {.lex_state = 50, .external_lex_state = 2},
  [2451] = {.lex_state = 50, .external_lex_state = 2},
  [2452] = {.lex_state = 50, .external_lex_state = 2},
  [2453] = {.lex_state = 50, .external_lex_state = 2},
  [2454] = {.lex_state = 50, .external_lex_state = 2},
  [2455] = {.lex_state = 50, .external_lex_state = 2},
  [2456] = {.lex_state = 50, .external_lex_state = 2},
  [2457] = {.lex_state = 50, .external_lex_state = 2},
  [2458] = {.lex_state = 50, .external_lex_state = 2},
  [2459] = {.lex_state = 50, .external_lex_state = 2},
  [2460] = {.lex_state = 50, .external_lex_state = 2},
  [2461] = {.lex_state = 50, .external_lex_state = 2},
  [2462] = {.lex_state = 50, .external_lex_state = 2},
  [2463] = {.lex_state = 50, .external_lex_state = 2},
  [2464] = {.lex_state = 50, .external_lex_state = 2},
  [2465] = {.lex_state = 50, .external_lex_state = 2},
  [2466] = {.lex_state = 50, .external_lex_state = 2},
  [2467] = {.lex_state = 50, .external_lex_state = 2},
  [2468] = {.lex_state = 50, .external_lex_state = 2},
  [2469] = {.lex_state = 50, .external_lex_state = 2},
  [2470] = {.lex_state = 50, .external_lex_state = 2},
  [2471] = {.lex_state = 50, .external_lex_state = 2},
  [2472] = {.lex_state = 50, .external_lex_state = 2},
  [2473] = {.lex_state = 50, .external_lex_state = 2},
  [2474] = {.lex_state = 50, .external_lex_state = 2},
  [2475] = {.lex_state = 50, .external_lex_state = 2},
  [2476] = {.lex_state = 50, .external_lex_state = 2},
  [2477] = {.lex_state = 50, .external_lex_state = 2},
  [2478] = {.lex_state = 50, .external_lex_state = 2},
  [2479] = {.lex_state = 50, .external_lex_state = 2},
  [2480] = {.lex_state = 50, .external_lex_state = 2},
  [2481] = {.lex_state = 50, .external_lex_state = 2},
  [2482] = {.lex_state = 50, .external_lex_state = 2},
  [2483] = {.lex_state = 50, .external_lex_state = 2},
  [2484] = {.lex_state = 50, .external_lex_state = 2},
  [2485] = {.lex_state = 50, .external_lex_state = 2},
  [2486] = {.lex_state = 50, .external_lex_state = 2},
  [2487] = {.lex_state = 50, .external_lex_state = 2},
  [2488] = {.lex_state = 50, .external_lex_state = 2},
  [2489] = {.lex_state = 50, .external_lex_state = 2},
  [2490] = {.lex_state = 50, .external_lex_state = 2},
  [2491] = {.lex_state = 50, .external_lex_state = 2},
  [2492] = {.lex_state = 50, .external_lex_state = 2},
  [2493] = {.lex_state = 50, .external_lex_state = 2},
  [2494] = {.lex_state = 50, .external_lex_state = 2},
  [2495] = {.lex_state = 50, .external_lex_state = 2},
  [2496] = {.lex_state = 50, .external_lex_state = 2},
  [2497] = {.lex_state = 50, .external_lex_state = 2},
  [2498] = {.lex_state = 50, .external_lex_state = 2},
  [2499] = {.lex_state = 50, .external_lex_state = 2},
  [2500] = {.lex_state = 50, .external_lex_state = 2},
  [2501] = {.lex_state = 50, .external_lex_state = 2},
  [2502] = {.lex_state = 50, .external_lex_state = 2},
  [2503] = {.lex_state = 50, .external_lex_state = 2},
  [2504] = {.lex_state = 50, .external_lex_state = 2},
  [2505] = {.lex_state = 50, .external_lex_state = 2},
  [2506] = {.lex_state = 50, .external_lex_state = 2},
  [2507] = {.lex_state = 50, .external_lex_state = 2},
  [2508] = {.lex_state = 50, .external_lex_state = 2},
  [2509] = {.lex_state = 50, .external_lex_state = 2},
  [2510] = {.lex_state = 50, .external_lex_state = 2},
  [2511] = {.lex_state = 50, .external_lex_state = 2},
  [2512] = {.lex_state = 50, .external_lex_state = 2},
  [2513] = {.lex_state = 50, .external_lex_state = 2},
  [2514] = {.lex_state = 50, .external_lex_state = 2},
  [2515] = {.lex_state = 50, .external_lex_state = 2},
  [2516] = {.lex_state = 50, .external_lex_state = 2},
  [2517] = {.lex_state = 50, .external_lex_state = 2},
  [2518] = {.lex_state = 50, .external_lex_state = 2},
  [2519] = {.lex_state = 50, .external_lex_state = 2},
  [2520] = {.lex_state = 50, .external_lex_state = 2},
  [2521] = {.lex_state = 50, .external_lex_state = 2},
  [2522] = {.lex_state = 50, .external_lex_state = 2},
  [2523] = {.lex_state = 50, .external_lex_state = 2},
  [2524] = {.lex_state = 50, .external_lex_state = 2},
  [2525] = {.lex_state = 50, .external_lex_state = 2},
  [2526] = {.lex_state = 50, .external_lex_state = 2},
  [2527] = {.lex_state = 9, .external_lex_state = 2},
  [2528] = {.lex_state = 50, .external_lex_state = 2},
  [2529] = {.lex_state = 9, .external_lex_state = 2},
  [2530] = {.lex_state = 50, .external_lex_state = 2},
  [2531] = {.lex_state = 9, .external_lex_state = 2},
  [2532] = {.lex_state = 50, .external_lex_state = 2},
  [2533] = {.lex_state = 50, .external_lex_state = 2},
  [2534] = {.lex_state = 50, .external_lex_state = 2},
  [2535] = {.lex_state = 50, .external_lex_state = 2},
  [2536] = {.lex_state = 9, .external_lex_state = 2},
  [2537] = {.lex_state = 9, .external_lex_state = 2},
  [2538] = {.lex_state = 9, .external_lex_state = 2},
  [2539] = {.lex_state = 50, .external_lex_state = 2},
  [2540] = {.lex_state = 9, .external_lex_state = 2},
  [2541] = {.lex_state = 9, .external_lex_state = 2},
  [2542] = {.lex_state = 0, .external_lex_state = 3},
  [2543] = {.lex_state = 0, .external_lex_state = 3},
  [2544] = {.lex_state = 0, .external_lex_state = 3},
  [2545] = {.lex_state = 50, .external_lex_state = 2},
  [2546] = {.lex_state = 0, .external_lex_state = 3},
  [2547] = {.lex_state = 0, .external_lex_state = 3},
  [2548] = {.lex_state = 0, .external_lex_state = 3},
  [2549] = {.lex_state = 0, .external_lex_state = 3},
  [2550] = {.lex_state = 50, .external_lex_state = 2},
  [2551] = {.lex_state = 50, .external_lex_state = 2},
  [2552] = {.lex_state = 50, .external_lex_state = 2},
  [2553] = {.lex_state = 0, .external_lex_state = 3},
  [2554] = {.lex_state = 50, .external_lex_state = 2},
  [2555] = {.lex_state = 0, .external_lex_state = 3},
  [2556] = {.lex_state = 0, .external_lex_state = 3},
  [2557] = {.lex_state = 50, .external_lex_state = 2},
  [2558] = {.lex_state = 50, .external_lex_state = 2},
  [2559] = {.lex_state = 0, .external_lex_state = 3},
  [2560] = {.lex_state = 14, .external_lex_state = 2},
  [2561] = {.lex_state = 0, .external_lex_state = 3},
  [2562] = {.lex_state = 50, .external_lex_state = 2},
  [2563] = {.lex_state = 50, .external_lex_state = 2},
  [2564] = {.lex_state = 50, .external_lex_state = 2},
  [2565] = {.lex_state = 0, .external_lex_state = 3},
  [2566] = {.lex_state = 14, .external_lex_state = 2},
  [2567] = {.lex_state = 14, .external_lex_state = 2},
  [2568] = {.lex_state = 14, .external_lex_state = 2},
  [2569] = {.lex_state = 14, .external_lex_state = 2},
  [2570] = {.lex_state = 14, .external_lex_state = 2},
  [2571] = {.lex_state = 14, .external_lex_state = 2},
  [2572] = {.lex_state = 14, .external_lex_state = 2},
  [2573] = {.lex_state = 14, .external_lex_state = 2},
  [2574] = {.lex_state = 14, .external_lex_state = 2},
  [2575] = {.lex_state = 14, .external_lex_state = 2},
  [2576] = {.lex_state = 14, .external_lex_state = 2},
  [2577] = {.lex_state = 14, .external_lex_state = 2},
  [2578] = {.lex_state = 14, .external_lex_state = 2},
  [2579] = {.lex_state = 14, .external_lex_state = 2},
  [2580] = {.lex_state = 14, .external_lex_state = 2},
  [2581] = {.lex_state = 14, .external_lex_state = 2},
  [2582] = {.lex_state = 14, .external_lex_state = 2},
  [2583] = {.lex_state = 14, .external_lex_state = 2},
  [2584] = {.lex_state = 14, .external_lex_state = 2},
  [2585] = {.lex_state = 14, .external_lex_state = 2},
  [2586] = {.lex_state = 14, .external_lex_state = 2},
  [2587] = {.lex_state = 14, .external_lex_state = 2},
  [2588] = {.lex_state = 14, .external_lex_state = 2},
  [2589] = {.lex_state = 14, .external_lex_state = 2},
  [2590] = {.lex_state = 50, .external_lex_state = 2},
  [2591] = {.lex_state = 50, .external_lex_state = 2},
  [2592] = {.lex_state = 50, .external_lex_state = 2},
  [2593] = {.lex_state = 50, .external_lex_state = 2},
  [2594] = {.lex_state = 50, .external_lex_state = 2},
  [2595] = {.lex_state = 50, .external_lex_state = 2},
  [2596] = {.lex_state = 50, .external_lex_state = 2},
  [2597] = {.lex_state = 50, .external_lex_state = 2},
  [2598] = {.lex_state = 50, .external_lex_state = 2},
  [2599] = {.lex_state = 50, .external_lex_state = 2},
  [2600] = {.lex_state = 50, .external_lex_state = 2},
  [2601] = {.lex_state = 50, .external_lex_state = 2},
  [2602] = {.lex_state = 50, .external_lex_state = 2},
  [2603] = {.lex_state = 50, .external_lex_state = 2},
  [2604] = {.lex_state = 9, .external_lex_state = 2},
  [2605] = {.lex_state = 9, .external_lex_state = 2},
  [2606] = {.lex_state = 9, .external_lex_state = 2},
  [2607] = {.lex_state = 50, .external_lex_state = 2},
  [2608] = {.lex_state = 9, .external_lex_state = 2},
  [2609] = {.lex_state = 9, .external_lex_state = 2},
  [2610] = {.lex_state = 9, .external_lex_state = 2},
  [2611] = {.lex_state = 50, .external_lex_state = 2},
  [2612] = {.lex_state = 9, .external_lex_state = 2},
  [2613] = {.lex_state = 9, .external_lex_state = 2},
  [2614] = {.lex_state = 9, .external_lex_state = 2},
  [2615] = {.lex_state = 9, .external_lex_state = 2},
  [2616] = {.lex_state = 9, .external_lex_state = 2},
  [2617] = {.lex_state = 9, .external_lex_state = 2},
  [2618] = {.lex_state = 9, .external_lex_state = 2},
  [2619] = {.lex_state = 9, .external_lex_state = 2},
  [2620] = {.lex_state = 9, .external_lex_state = 2},
  [2621] = {.lex_state = 9, .external_lex_state = 2},
  [2622] = {.lex_state = 9, .external_lex_state = 2},
  [2623] = {.lex_state = 9, .external_lex_state = 2},
  [2624] = {.lex_state = 9, .external_lex_state = 2},
  [2625] = {.lex_state = 9, .external_lex_state = 2},
  [2626] = {.lex_state = 9, .external_lex_state = 2},
  [2627] = {.lex_state = 9, .external_lex_state = 2},
  [2628] = {.lex_state = 9, .external_lex_state = 2},
  [2629] = {.lex_state = 9, .external_lex_state = 2},
  [2630] = {.lex_state = 9, .external_lex_state = 2},
  [2631] = {.lex_state = 9, .external_lex_state = 2},
  [2632] = {.lex_state = 9, .external_lex_state = 2},
  [2633] = {.lex_state = 50, .external_lex_state = 2},
  [2634] = {.lex_state = 50, .external_lex_state = 2},
  [2635] = {.lex_state = 50, .external_lex_state = 2},
  [2636] = {.lex_state = 50, .external_lex_state = 2},
  [2637] = {.lex_state = 50, .external_lex_state = 2},
  [2638] = {.lex_state = 9, .external_lex_state = 2},
  [2639] = {.lex_state = 50, .external_lex_state = 2},
  [2640] = {.lex_state = 50, .external_lex_state = 2},
  [2641] = {.lex_state = 50, .external_lex_state = 2},
  [2642] = {.lex_state = 50, .external_lex_state = 2},
  [2643] = {.lex_state = 9, .external_lex_state = 2},
  [2644] = {.lex_state = 50, .external_lex_state = 2},
  [2645] = {.lex_state = 9, .external_lex_state = 2},
  [2646] = {.lex_state = 50, .external_lex_state = 2},
  [2647] = {.lex_state = 9, .external_lex_state = 2},
  [2648] = {.lex_state = 50, .external_lex_state = 2},
  [2649] = {.lex_state = 50, .external_lex_state = 2},
  [2650] = {.lex_state = 9, .external_lex_state = 2},
  [2651] = {.lex_state = 50, .external_lex_state = 2},
  [2652] = {.lex_state = 50, .external_lex_state = 2},
  [2653] = {.lex_state = 50, .external_lex_state = 2},
  [2654] = {.lex_state = 50, .external_lex_state = 2},
  [2655] = {.lex_state = 50, .external_lex_state = 2},
  [2656] = {.lex_state = 50, .external_lex_state = 2},
  [2657] = {.lex_state = 9, .external_lex_state = 2},
  [2658] = {.lex_state = 50, .external_lex_state = 2},
  [2659] = {.lex_state = 9, .external_lex_state = 2},
  [2660] = {.lex_state = 50, .external_lex_state = 2},
  [2661] = {.lex_state = 50, .external_lex_state = 2},
  [2662] = {.lex_state = 50, .external_lex_state = 2},
  [2663] = {.lex_state = 50, .external_lex_state = 2},
  [2664] = {.lex_state = 50, .external_lex_state = 2},
  [2665] = {.lex_state = 50, .external_lex_state = 2},
  [2666] = {.lex_state = 50, .external_lex_state = 2},
  [2667] = {.lex_state = 50, .external_lex_state = 2},
  [2668] = {.lex_state = 9, .external_lex_state = 2},
  [2669] = {.lex_state = 50, .external_lex_state = 2},
  [2670] = {.lex_state = 7, .external_lex_state = 4},
  [2671] = {.lex_state = 50, .external_lex_state = 2},
  [2672] = {.lex_state = 7, .external_lex_state = 4},
  [2673] = {.lex_state = 7, .external_lex_state = 4},
  [2674] = {.lex_state = 50, .external_lex_state = 2},
  [2675] = {.lex_state = 7, .external_lex_state = 4},
  [2676] = {.lex_state = 50, .external_lex_state = 2},
  [2677] = {.lex_state = 11, .external_lex_state = 4},
  [2678] = {.lex_state = 11, .external_lex_state = 4},
  [2679] = {.lex_state = 50, .external_lex_state = 2},
  [2680] = {.lex_state = 50, .external_lex_state = 2},
  [2681] = {.lex_state = 50, .external_lex_state = 2},
  [2682] = {.lex_state = 50, .external_lex_state = 2},
  [2683] = {.lex_state = 50, .external_lex_state = 2},
  [2684] = {.lex_state = 50, .external_lex_state = 2},
  [2685] = {.lex_state = 11, .external_lex_state = 4},
  [2686] = {.lex_state = 50, .external_lex_state = 2},
  [2687] = {.lex_state = 50, .external_lex_state = 2},
  [2688] = {.lex_state = 50, .external_lex_state = 2},
  [2689] = {.lex_state = 50, .external_lex_state = 2},
  [2690] = {.lex_state = 50, .external_lex_state = 2},
  [2691] = {.lex_state = 50, .external_lex_state = 2},
  [2692] = {.lex_state = 50, .external_lex_state = 2},
  [2693] = {.lex_state = 50, .external_lex_state = 2},
  [2694] = {.lex_state = 50, .external_lex_state = 2},
  [2695] = {.lex_state = 9, .external_lex_state = 4},
  [2696] = {.lex_state = 50, .external_lex_state = 2},
  [2697] = {.lex_state = 50, .external_lex_state = 2},
  [2698] = {.lex_state = 50, .external_lex_state = 2},
  [2699] = {.lex_state = 9, .external_lex_state = 4},
  [2700] = {.lex_state = 9, .external_lex_state = 4},
  [2701] = {.lex_state = 50, .external_lex_state = 2},
  [2702] = {.lex_state = 50, .external_lex_state = 2},
  [2703] = {.lex_state = 7, .external_lex_state = 4},
  [2704] = {.lex_state = 50, .external_lex_state = 2},
  [2705] = {.lex_state = 11, .external_lex_state = 4},
  [2706] = {.lex_state = 50, .external_lex_state = 2},
  [2707] = {.lex_state = 7, .external_lex_state = 4},
  [2708] = {.lex_state = 7, .external_lex_state = 4},
  [2709] = {.lex_state = 7, .external_lex_state = 4},
  [2710] = {.lex_state = 7, .external_lex_state = 4},
  [2711] = {.lex_state = 7, .external_lex_state = 4},
  [2712] = {.lex_state = 7, .external_lex_state = 4},
  [2713] = {.lex_state = 7, .external_lex_state = 4},
  [2714] = {.lex_state = 7, .external_lex_state = 4},
  [2715] = {.lex_state = 7, .external_lex_state = 4},
  [2716] = {.lex_state = 7, .external_lex_state = 4},
  [2717] = {.lex_state = 7, .external_lex_state = 4},
  [2718] = {.lex_state = 9, .external_lex_state = 4},
  [2719] = {.lex_state = 7, .external_lex_state = 4},
  [2720] = {.lex_state = 7, .external_lex_state = 4},
  [2721] = {.lex_state = 7, .external_lex_state = 4},
  [2722] = {.lex_state = 7, .external_lex_state = 4},
  [2723] = {.lex_state = 7, .external_lex_state = 4},
  [2724] = {.lex_state = 7, .external_lex_state = 4},
  [2725] = {.lex_state = 7, .external_lex_state = 4},
  [2726] = {.lex_state = 7, .external_lex_state = 4},
  [2727] = {.lex_state = 7, .external_lex_state = 4},
  [2728] = {.lex_state = 7, .external_lex_state = 4},
  [2729] = {.lex_state = 7, .external_lex_state = 4},
  [2730] = {.lex_state = 7, .external_lex_state = 4},
  [2731] = {.lex_state = 7, .external_lex_state = 4},
  [2732] = {.lex_state = 7, .external_lex_state = 4},
  [2733] = {.lex_state = 7, .external_lex_state = 4},
  [2734] = {.lex_state = 7, .external_lex_state = 4},
  [2735] = {.lex_state = 7, .external_lex_state = 4},
  [2736] = {.lex_state = 7, .external_lex_state = 4},
  [2737] = {.lex_state = 7, .external_lex_state = 4},
  [2738] = {.lex_state = 7, .external_lex_state = 4},
  [2739] = {.lex_state = 50, .external_lex_state = 2},
  [2740] = {.lex_state = 50, .external_lex_state = 2},
  [2741] = {.lex_state = 50, .external_lex_state = 2},
  [2742] = {.lex_state = 50, .external_lex_state = 2},
  [2743] = {.lex_state = 50, .external_lex_state = 2},
  [2744] = {.lex_state = 50, .external_lex_state = 2},
  [2745] = {.lex_state = 50, .external_lex_state = 2},
  [2746] = {.lex_state = 50, .external_lex_state = 2},
  [2747] = {.lex_state = 50, .external_lex_state = 2},
  [2748] = {.lex_state = 50, .external_lex_state = 2},
  [2749] = {.lex_state = 50, .external_lex_state = 2},
  [2750] = {.lex_state = 50, .external_lex_state = 2},
  [2751] = {.lex_state = 50, .external_lex_state = 2},
  [2752] = {.lex_state = 11, .external_lex_state = 4},
  [2753] = {.lex_state = 50, .external_lex_state = 2},
  [2754] = {.lex_state = 50, .external_lex_state = 2},
  [2755] = {.lex_state = 50, .external_lex_state = 2},
  [2756] = {.lex_state = 50, .external_lex_state = 2},
  [2757] = {.lex_state = 50, .external_lex_state = 2},
  [2758] = {.lex_state = 50, .external_lex_state = 2},
  [2759] = {.lex_state = 50, .external_lex_state = 2},
  [2760] = {.lex_state = 50, .external_lex_state = 2},
  [2761] = {.lex_state = 11, .external_lex_state = 4},
  [2762] = {.lex_state = 9, .external_lex_state = 4},
  [2763] = {.lex_state = 11, .external_lex_state = 4},
  [2764] = {.lex_state = 50, .external_lex_state = 2},
  [2765] = {.lex_state = 11, .external_lex_state = 4},
  [2766] = {.lex_state = 11, .external_lex_state = 4},
  [2767] = {.lex_state = 11, .external_lex_state = 4},
  [2768] = {.lex_state = 11, .external_lex_state = 4},
  [2769] = {.lex_state = 7, .external_lex_state = 4},
  [2770] = {.lex_state = 11, .external_lex_state = 4},
  [2771] = {.lex_state = 11, .external_lex_state = 4},
  [2772] = {.lex_state = 11, .external_lex_state = 4},
  [2773] = {.lex_state = 11, .external_lex_state = 4},
  [2774] = {.lex_state = 50, .external_lex_state = 2},
  [2775] = {.lex_state = 11, .external_lex_state = 4},
  [2776] = {.lex_state = 50, .external_lex_state = 2},
  [2777] = {.lex_state = 11, .external_lex_state = 4},
  [2778] = {.lex_state = 50, .external_lex_state = 2},
  [2779] = {.lex_state = 11, .external_lex_state = 4},
  [2780] = {.lex_state = 11, .external_lex_state = 4},
  [2781] = {.lex_state = 11, .external_lex_state = 4},
  [2782] = {.lex_state = 50, .external_lex_state = 2},
  [2783] = {.lex_state = 11, .external_lex_state = 4},
  [2784] = {.lex_state = 50, .external_lex_state = 2},
  [2785] = {.lex_state = 11, .external_lex_state = 4},
  [2786] = {.lex_state = 11, .external_lex_state = 4},
  [2787] = {.lex_state = 11, .external_lex_state = 4},
  [2788] = {.lex_state = 11, .external_lex_state = 4},
  [2789] = {.lex_state = 11, .external_lex_state = 4},
  [2790] = {.lex_state = 11, .external_lex_state = 4},
  [2791] = {.lex_state = 11, .external_lex_state = 4},
  [2792] = {.lex_state = 50, .external_lex_state = 2},
  [2793] = {.lex_state = 50, .external_lex_state = 2},
  [2794] = {.lex_state = 50, .external_lex_state = 2},
  [2795] = {.lex_state = 7, .external_lex_state = 4},
  [2796] = {.lex_state = 11, .external_lex_state = 4},
  [2797] = {.lex_state = 11, .external_lex_state = 4},
  [2798] = {.lex_state = 50, .external_lex_state = 2},
  [2799] = {.lex_state = 50, .external_lex_state = 2},
  [2800] = {.lex_state = 11, .external_lex_state = 4},
  [2801] = {.lex_state = 50, .external_lex_state = 2},
  [2802] = {.lex_state = 11, .external_lex_state = 4},
  [2803] = {.lex_state = 7, .external_lex_state = 4},
  [2804] = {.lex_state = 11, .external_lex_state = 4},
  [2805] = {.lex_state = 11, .external_lex_state = 4},
  [2806] = {.lex_state = 11, .external_lex_state = 4},
  [2807] = {.lex_state = 11, .external_lex_state = 4},
  [2808] = {.lex_state = 9, .external_lex_state = 4},
  [2809] = {.lex_state = 50, .external_lex_state = 2},
  [2810] = {.lex_state = 7, .external_lex_state = 4},
  [2811] = {.lex_state = 9, .external_lex_state = 4},
  [2812] = {.lex_state = 9, .external_lex_state = 4},
  [2813] = {.lex_state = 9, .external_lex_state = 4},
  [2814] = {.lex_state = 9, .external_lex_state = 4},
  [2815] = {.lex_state = 9, .external_lex_state = 4},
  [2816] = {.lex_state = 9, .external_lex_state = 4},
  [2817] = {.lex_state = 9, .external_lex_state = 4},
  [2818] = {.lex_state = 9, .external_lex_state = 4},
  [2819] = {.lex_state = 9, .external_lex_state = 4},
  [2820] = {.lex_state = 50, .external_lex_state = 2},
  [2821] = {.lex_state = 50, .external_lex_state = 2},
  [2822] = {.lex_state = 9, .external_lex_state = 4},
  [2823] = {.lex_state = 9, .external_lex_state = 4},
  [2824] = {.lex_state = 9, .external_lex_state = 4},
  [2825] = {.lex_state = 9, .external_lex_state = 4},
  [2826] = {.lex_state = 9, .external_lex_state = 4},
  [2827] = {.lex_state = 9, .external_lex_state = 4},
  [2828] = {.lex_state = 9, .external_lex_state = 4},
  [2829] = {.lex_state = 9, .external_lex_state = 4},
  [2830] = {.lex_state = 9, .external_lex_state = 4},
  [2831] = {.lex_state = 50, .external_lex_state = 2},
  [2832] = {.lex_state = 9, .external_lex_state = 4},
  [2833] = {.lex_state = 9, .external_lex_state = 4},
  [2834] = {.lex_state = 9, .external_lex_state = 4},
  [2835] = {.lex_state = 9, .external_lex_state = 4},
  [2836] = {.lex_state = 9, .external_lex_state = 4},
  [2837] = {.lex_state = 50, .external_lex_state = 2},
  [2838] = {.lex_state = 9, .external_lex_state = 4},
  [2839] = {.lex_state = 9, .external_lex_state = 4},
  [2840] = {.lex_state = 50, .external_lex_state = 2},
  [2841] = {.lex_state = 9, .external_lex_state = 4},
  [2842] = {.lex_state = 9, .external_lex_state = 4},
  [2843] = {.lex_state = 9, .external_lex_state = 4},
  [2844] = {.lex_state = 9, .external_lex_state = 4},
  [2845] = {.lex_state = 9, .external_lex_state = 4},
  [2846] = {.lex_state = 50, .external_lex_state = 2},
  [2847] = {.lex_state = 50, .external_lex_state = 2},
  [2848] = {.lex_state = 50, .external_lex_state = 2},
  [2849] = {.lex_state = 50, .external_lex_state = 2},
  [2850] = {.lex_state = 50, .external_lex_state = 2},
  [2851] = {.lex_state = 50, .external_lex_state = 2},
  [2852] = {.lex_state = 50, .external_lex_state = 2},
  [2853] = {.lex_state = 50, .external_lex_state = 2},
  [2854] = {.lex_state = 50, .external_lex_state = 2},
  [2855] = {.lex_state = 50, .external_lex_state = 2},
  [2856] = {.lex_state = 50, .external_lex_state = 2},
  [2857] = {.lex_state = 50, .external_lex_state = 2},
  [2858] = {.lex_state = 50, .external_lex_state = 2},
  [2859] = {.lex_state = 50, .external_lex_state = 2},
  [2860] = {.lex_state = 50, .external_lex_state = 2},
  [2861] = {.lex_state = 11, .external_lex_state = 4},
  [2862] = {.lex_state = 50, .external_lex_state = 2},
  [2863] = {.lex_state = 50, .external_lex_state = 2},
  [2864] = {.lex_state = 50, .external_lex_state = 2},
  [2865] = {.lex_state = 50, .external_lex_state = 2},
  [2866] = {.lex_state = 50, .external_lex_state = 2},
  [2867] = {.lex_state = 11, .external_lex_state = 4},
  [2868] = {.lex_state = 50, .external_lex_state = 2},
  [2869] = {.lex_state = 50, .external_lex_state = 2},
  [2870] = {.lex_state = 50, .external_lex_state = 2},
  [2871] = {.lex_state = 50, .external_lex_state = 2},
  [2872] = {.lex_state = 50, .external_lex_state = 2},
  [2873] = {.lex_state = 50, .external_lex_state = 2},
  [2874] = {.lex_state = 50, .external_lex_state = 2},
  [2875] = {.lex_state = 50, .external_lex_state = 2},
  [2876] = {.lex_state = 50, .external_lex_state = 2},
  [2877] = {.lex_state = 50, .external_lex_state = 2},
  [2878] = {.lex_state = 50, .external_lex_state = 2},
  [2879] = {.lex_state = 50, .external_lex_state = 2},
  [2880] = {.lex_state = 50, .external_lex_state = 2},
  [2881] = {.lex_state = 50, .external_lex_state = 2},
  [2882] = {.lex_state = 50, .external_lex_state = 2},
  [2883] = {.lex_state = 11, .external_lex_state = 4},
  [2884] = {.lex_state = 50, .external_lex_state = 2},
  [2885] = {.lex_state = 50, .external_lex_state = 2},
  [2886] = {.lex_state = 11, .external_lex_state = 4},
  [2887] = {.lex_state = 7, .external_lex_state = 4},
  [2888] = {.lex_state = 7, .external_lex_state = 4},
  [2889] = {.lex_state = 7, .external_lex_state = 4},
  [2890] = {.lex_state = 7, .external_lex_state = 4},
  [2891] = {.lex_state = 7, .external_lex_state = 4},
  [2892] = {.lex_state = 7, .external_lex_state = 4},
  [2893] = {.lex_state = 7, .external_lex_state = 4},
  [2894] = {.lex_state = 7, .external_lex_state = 4},
  [2895] = {.lex_state = 7, .external_lex_state = 4},
  [2896] = {.lex_state = 9, .external_lex_state = 4},
  [2897] = {.lex_state = 7, .external_lex_state = 4},
  [2898] = {.lex_state = 7, .external_lex_state = 4},
  [2899] = {.lex_state = 9, .external_lex_state = 4},
  [2900] = {.lex_state = 7, .external_lex_state = 4},
  [2901] = {.lex_state = 50, .external_lex_state = 2},
  [2902] = {.lex_state = 7, .external_lex_state = 4},
  [2903] = {.lex_state = 7, .external_lex_state = 4},
  [2904] = {.lex_state = 50, .external_lex_state = 2},
  [2905] = {.lex_state = 7, .external_lex_state = 4},
  [2906] = {.lex_state = 7, .external_lex_state = 4},
  [2907] = {.lex_state = 7, .external_lex_state = 4},
  [2908] = {.lex_state = 7, .external_lex_state = 4},
  [2909] = {.lex_state = 7, .external_lex_state = 4},
  [2910] = {.lex_state = 7, .external_lex_state = 4},
  [2911] = {.lex_state = 7, .external_lex_state = 4},
  [2912] = {.lex_state = 9, .external_lex_state = 4},
  [2913] = {.lex_state = 7, .external_lex_state = 4},
  [2914] = {.lex_state = 50, .external_lex_state = 2},
  [2915] = {.lex_state = 50, .external_lex_state = 2},
  [2916] = {.lex_state = 50, .external_lex_state = 2},
  [2917] = {.lex_state = 7, .external_lex_state = 4},
  [2918] = {.lex_state = 7, .external_lex_state = 4},
  [2919] = {.lex_state = 50, .external_lex_state = 2},
  [2920] = {.lex_state = 50, .external_lex_state = 2},
  [2921] = {.lex_state = 50, .external_lex_state = 2},
  [2922] = {.lex_state = 7, .external_lex_state = 4},
  [2923] = {.lex_state = 6, .external_lex_state = 4},
  [2924] = {.lex_state = 50, .external_lex_state = 2},
  [2925] = {.lex_state = 7, .external_lex_state = 4},
  [2926] = {.lex_state = 7, .external_lex_state = 4},
  [2927] = {.lex_state = 7, .external_lex_state = 4},
  [2928] = {.lex_state = 7, .external_lex_state = 4},
  [2929] = {.lex_state = 7, .external_lex_state = 4},
  [2930] = {.lex_state = 50, .external_lex_state = 2},
  [2931] = {.lex_state = 50, .external_lex_state = 2},
  [2932] = {.lex_state = 50, .external_lex_state = 2},
  [2933] = {.lex_state = 50, .external_lex_state = 2},
  [2934] = {.lex_state = 7, .external_lex_state = 4},
  [2935] = {.lex_state = 7, .external_lex_state = 4},
  [2936] = {.lex_state = 9, .external_lex_state = 4},
  [2937] = {.lex_state = 7, .external_lex_state = 4},
  [2938] = {.lex_state = 7, .external_lex_state = 4},
  [2939] = {.lex_state = 11, .external_lex_state = 4},
  [2940] = {.lex_state = 50, .external_lex_state = 2},
  [2941] = {.lex_state = 7, .external_lex_state = 4},
  [2942] = {.lex_state = 7, .external_lex_state = 4},
  [2943] = {.lex_state = 7, .external_lex_state = 4},
  [2944] = {.lex_state = 6, .external_lex_state = 4},
  [2945] = {.lex_state = 7, .external_lex_state = 4},
  [2946] = {.lex_state = 7, .external_lex_state = 4},
  [2947] = {.lex_state = 7, .external_lex_state = 4},
  [2948] = {.lex_state = 7, .external_lex_state = 4},
  [2949] = {.lex_state = 11, .external_lex_state = 4},
  [2950] = {.lex_state = 7, .external_lex_state = 4},
  [2951] = {.lex_state = 9, .external_lex_state = 4},
  [2952] = {.lex_state = 50, .external_lex_state = 2},
  [2953] = {.lex_state = 50, .external_lex_state = 2},
  [2954] = {.lex_state = 9, .external_lex_state = 4},
  [2955] = {.lex_state = 50, .external_lex_state = 2},
  [2956] = {.lex_state = 9, .external_lex_state = 4},
  [2957] = {.lex_state = 50, .external_lex_state = 2},
  [2958] = {.lex_state = 8, .external_lex_state = 4},
  [2959] = {.lex_state = 11, .external_lex_state = 4},
  [2960] = {.lex_state = 6, .external_lex_state = 4},
  [2961] = {.lex_state = 9, .external_lex_state = 4},
  [2962] = {.lex_state = 11, .external_lex_state = 4},
  [2963] = {.lex_state = 6, .external_lex_state = 4},
  [2964] = {.lex_state = 50, .external_lex_state = 2},
  [2965] = {.lex_state = 11, .external_lex_state = 4},
  [2966] = {.lex_state = 7, .external_lex_state = 4},
  [2967] = {.lex_state = 50, .external_lex_state = 2},
  [2968] = {.lex_state = 7, .external_lex_state = 4},
  [2969] = {.lex_state = 50, .external_lex_state = 2},
  [2970] = {.lex_state = 9, .external_lex_state = 4},
  [2971] = {.lex_state = 11, .external_lex_state = 4},
  [2972] = {.lex_state = 11, .external_lex_state = 4},
  [2973] = {.lex_state = 11, .external_lex_state = 4},
  [2974] = {.lex_state = 6, .external_lex_state = 4},
  [2975] = {.lex_state = 11, .external_lex_state = 4},
  [2976] = {.lex_state = 9, .external_lex_state = 4},
  [2977] = {.lex_state = 9, .external_lex_state = 4},
  [2978] = {.lex_state = 9, .external_lex_state = 4},
  [2979] = {.lex_state = 7, .external_lex_state = 4},
  [2980] = {.lex_state = 50, .external_lex_state = 2},
  [2981] = {.lex_state = 50, .external_lex_state = 2},
  [2982] = {.lex_state = 7, .external_lex_state = 4},
  [2983] = {.lex_state = 11, .external_lex_state = 4},
  [2984] = {.lex_state = 11, .external_lex_state = 4},
  [2985] = {.lex_state = 6, .external_lex_state = 4},
  [2986] = {.lex_state = 7, .external_lex_state = 4},
  [2987] = {.lex_state = 7, .external_lex_state = 4},
  [2988] = {.lex_state = 9, .external_lex_state = 4},
  [2989] = {.lex_state = 11, .external_lex_state = 4},
  [2990] = {.lex_state = 9, .external_lex_state = 4},
  [2991] = {.lex_state = 9, .external_lex_state = 4},
  [2992] = {.lex_state = 9, .external_lex_state = 4},
  [2993] = {.lex_state = 9, .external_lex_state = 4},
  [2994] = {.lex_state = 11, .external_lex_state = 4},
  [2995] = {.lex_state = 11, .external_lex_state = 4},
  [2996] = {.lex_state = 11, .external_lex_state = 4},
  [2997] = {.lex_state = 11, .external_lex_state = 4},
  [2998] = {.lex_state = 11, .external_lex_state = 4},
  [2999] = {.lex_state = 11, .external_lex_state = 4},
  [3000] = {.lex_state = 11, .external_lex_state = 4},
  [3001] = {.lex_state = 11, .external_lex_state = 4},
  [3002] = {.lex_state = 50, .external_lex_state = 2},
  [3003] = {.lex_state = 11, .external_lex_state = 4},
  [3004] = {.lex_state = 11, .external_lex_state = 4},
  [3005] = {.lex_state = 9, .external_lex_state = 4},
  [3006] = {.lex_state = 11, .external_lex_state = 4},
  [3007] = {.lex_state = 9, .external_lex_state = 4},
  [3008] = {.lex_state = 9, .external_lex_state = 4},
  [3009] = {.lex_state = 9, .external_lex_state = 4},
  [3010] = {.lex_state = 9, .external_lex_state = 4},
  [3011] = {.lex_state = 9, .external_lex_state = 4},
  [3012] = {.lex_state = 9, .external_lex_state = 4},
  [3013] = {.lex_state = 9, .external_lex_state = 4},
  [3014] = {.lex_state = 11, .external_lex_state = 4},
  [3015] = {.lex_state = 11, .external_lex_state = 4},
  [3016] = {.lex_state = 11, .external_lex_state = 4},
  [3017] = {.lex_state = 11, .external_lex_state = 4},
  [3018] = {.lex_state = 11, .external_lex_state = 4},
  [3019] = {.lex_state = 11, .external_lex_state = 4},
  [3020] = {.lex_state = 11, .external_lex_state = 4},
  [3021] = {.lex_state = 7, .external_lex_state = 4},
  [3022] = {.lex_state = 11, .external_lex_state = 4},
  [3023] = {.lex_state = 6, .external_lex_state = 4},
  [3024] = {.lex_state = 7, .external_lex_state = 4},
  [3025] = {.lex_state = 50, .external_lex_state = 2},
  [3026] = {.lex_state = 9, .external_lex_state = 4},
  [3027] = {.lex_state = 11, .external_lex_state = 4},
  [3028] = {.lex_state = 50, .external_lex_state = 2},
  [3029] = {.lex_state = 9, .external_lex_state = 4},
  [3030] = {.lex_state = 50, .external_lex_state = 2},
  [3031] = {.lex_state = 6, .external_lex_state = 4},
  [3032] = {.lex_state = 7, .external_lex_state = 4},
  [3033] = {.lex_state = 9, .external_lex_state = 4},
  [3034] = {.lex_state = 7, .external_lex_state = 4},
  [3035] = {.lex_state = 6, .external_lex_state = 4},
  [3036] = {.lex_state = 7, .external_lex_state = 4},
  [3037] = {.lex_state = 7, .external_lex_state = 4},
  [3038] = {.lex_state = 9, .external_lex_state = 4},
  [3039] = {.lex_state = 7, .external_lex_state = 4},
  [3040] = {.lex_state = 9, .external_lex_state = 4},
  [3041] = {.lex_state = 9, .external_lex_state = 4},
  [3042] = {.lex_state = 11, .external_lex_state = 4},
  [3043] = {.lex_state = 50, .external_lex_state = 2},
  [3044] = {.lex_state = 9, .external_lex_state = 4},
  [3045] = {.lex_state = 7, .external_lex_state = 4},
  [3046] = {.lex_state = 9, .external_lex_state = 4},
  [3047] = {.lex_state = 7, .external_lex_state = 4},
  [3048] = {.lex_state = 7, .external_lex_state = 4},
  [3049] = {.lex_state = 50, .external_lex_state = 2},
  [3050] = {.lex_state = 7, .external_lex_state = 4},
  [3051] = {.lex_state = 9, .external_lex_state = 4},
  [3052] = {.lex_state = 9, .external_lex_state = 4},
  [3053] = {.lex_state = 8, .external_lex_state = 4},
  [3054] = {.lex_state = 6, .external_lex_state = 4},
  [3055] = {.lex_state = 7, .external_lex_state = 4},
  [3056] = {.lex_state = 7, .external_lex_state = 4},
  [3057] = {.lex_state = 11, .external_lex_state = 4},
  [3058] = {.lex_state = 11, .external_lex_state = 4},
  [3059] = {.lex_state = 11, .external_lex_state = 4},
  [3060] = {.lex_state = 7, .external_lex_state = 4},
  [3061] = {.lex_state = 50, .external_lex_state = 2},
  [3062] = {.lex_state = 7, .external_lex_state = 4},
  [3063] = {.lex_state = 9, .external_lex_state = 4},
  [3064] = {.lex_state = 10, .external_lex_state = 4},
  [3065] = {.lex_state = 7, .external_lex_state = 4},
  [3066] = {.lex_state = 11, .external_lex_state = 4},
  [3067] = {.lex_state = 50, .external_lex_state = 2},
  [3068] = {.lex_state = 50, .external_lex_state = 2},
  [3069] = {.lex_state = 7, .external_lex_state = 4},
  [3070] = {.lex_state = 50, .external_lex_state = 2},
  [3071] = {.lex_state = 6, .external_lex_state = 4},
  [3072] = {.lex_state = 50, .external_lex_state = 2},
  [3073] = {.lex_state = 50, .external_lex_state = 2},
  [3074] = {.lex_state = 7, .external_lex_state = 4},
  [3075] = {.lex_state = 50, .external_lex_state = 2},
  [3076] = {.lex_state = 9, .external_lex_state = 4},
  [3077] = {.lex_state = 7, .external_lex_state = 4},
  [3078] = {.lex_state = 7, .external_lex_state = 4},
  [3079] = {.lex_state = 50, .external_lex_state = 2},
  [3080] = {.lex_state = 50, .external_lex_state = 2},
  [3081] = {.lex_state = 50, .external_lex_state = 2},
  [3082] = {.lex_state = 50, .external_lex_state = 2},
  [3083] = {.lex_state = 9, .external_lex_state = 2},
  [3084] = {.lex_state = 10, .external_lex_state = 4},
  [3085] = {.lex_state = 50, .external_lex_state = 2},
  [3086] = {.lex_state = 9, .external_lex_state = 4},
  [3087] = {.lex_state = 6, .external_lex_state = 4},
  [3088] = {.lex_state = 50, .external_lex_state = 2},
  [3089] = {.lex_state = 50, .external_lex_state = 2},
  [3090] = {.lex_state = 50, .external_lex_state = 2},
  [3091] = {.lex_state = 11, .external_lex_state = 4},
  [3092] = {.lex_state = 50, .external_lex_state = 2},
  [3093] = {.lex_state = 50, .external_lex_state = 2},
  [3094] = {.lex_state = 50, .external_lex_state = 2},
  [3095] = {.lex_state = 50, .external_lex_state = 2},
  [3096] = {.lex_state = 50, .external_lex_state = 2},
  [3097] = {.lex_state = 9, .external_lex_state = 4},
  [3098] = {.lex_state = 50, .external_lex_state = 2},
  [3099] = {.lex_state = 50, .external_lex_state = 2},
  [3100] = {.lex_state = 9, .external_lex_state = 4},
  [3101] = {.lex_state = 50, .external_lex_state = 2},
  [3102] = {.lex_state = 50, .external_lex_state = 2},
  [3103] = {.lex_state = 50, .external_lex_state = 2},
  [3104] = {.lex_state = 50, .external_lex_state = 2},
  [3105] = {.lex_state = 50, .external_lex_state = 2},
  [3106] = {.lex_state = 50, .external_lex_state = 2},
  [3107] = {.lex_state = 11, .external_lex_state = 4},
  [3108] = {.lex_state = 50, .external_lex_state = 2},
  [3109] = {.lex_state = 50, .external_lex_state = 2},
  [3110] = {.lex_state = 50, .external_lex_state = 2},
  [3111] = {.lex_state = 50, .external_lex_state = 2},
  [3112] = {.lex_state = 50, .external_lex_state = 2},
  [3113] = {.lex_state = 50, .external_lex_state = 2},
  [3114] = {.lex_state = 7, .external_lex_state = 4},
  [3115] = {.lex_state = 50, .external_lex_state = 2},
  [3116] = {.lex_state = 50, .external_lex_state = 2},
  [3117] = {.lex_state = 50, .external_lex_state = 2},
  [3118] = {.lex_state = 50, .external_lex_state = 2},
  [3119] = {.lex_state = 50, .external_lex_state = 2},
  [3120] = {.lex_state = 50, .external_lex_state = 2},
  [3121] = {.lex_state = 9, .external_lex_state = 4},
  [3122] = {.lex_state = 50, .external_lex_state = 2},
  [3123] = {.lex_state = 50, .external_lex_state = 2},
  [3124] = {.lex_state = 50, .external_lex_state = 2},
  [3125] = {.lex_state = 9, .external_lex_state = 4},
  [3126] = {.lex_state = 50, .external_lex_state = 2},
  [3127] = {.lex_state = 10, .external_lex_state = 4},
  [3128] = {.lex_state = 50, .external_lex_state = 2},
  [3129] = {.lex_state = 50, .external_lex_state = 2},
  [3130] = {.lex_state = 50, .external_lex_state = 2},
  [3131] = {.lex_state = 50, .external_lex_state = 2},
  [3132] = {.lex_state = 50, .external_lex_state = 2},
  [3133] = {.lex_state = 9, .external_lex_state = 4},
  [3134] = {.lex_state = 50, .external_lex_state = 2},
  [3135] = {.lex_state = 50, .external_lex_state = 2},
  [3136] = {.lex_state = 50, .external_lex_state = 2},
  [3137] = {.lex_state = 50, .external_lex_state = 2},
  [3138] = {.lex_state = 50, .external_lex_state = 2},
  [3139] = {.lex_state = 7, .external_lex_state = 4},
  [3140] = {.lex_state = 50, .external_lex_state = 2},
  [3141] = {.lex_state = 50, .external_lex_state = 2},
  [3142] = {.lex_state = 50, .external_lex_state = 2},
  [3143] = {.lex_state = 50, .external_lex_state = 2},
  [3144] = {.lex_state = 50, .external_lex_state = 2},
  [3145] = {.lex_state = 50, .external_lex_state = 2},
  [3146] = {.lex_state = 50, .external_lex_state = 2},
  [3147] = {.lex_state = 50, .external_lex_state = 2},
  [3148] = {.lex_state = 50, .external_lex_state = 2},
  [3149] = {.lex_state = 50, .external_lex_state = 2},
  [3150] = {.lex_state = 50, .external_lex_state = 2},
  [3151] = {.lex_state = 7, .external_lex_state = 4},
  [3152] = {.lex_state = 7, .external_lex_state = 4},
  [3153] = {.lex_state = 50, .external_lex_state = 2},
  [3154] = {.lex_state = 50, .external_lex_state = 2},
  [3155] = {.lex_state = 50, .external_lex_state = 2},
  [3156] = {.lex_state = 50, .external_lex_state = 2},
  [3157] = {.lex_state = 50, .external_lex_state = 2},
  [3158] = {.lex_state = 7, .external_lex_state = 4},
  [3159] = {.lex_state = 50, .external_lex_state = 2},
  [3160] = {.lex_state = 7, .external_lex_state = 4},
  [3161] = {.lex_state = 7, .external_lex_state = 4},
  [3162] = {.lex_state = 7, .external_lex_state = 4},
  [3163] = {.lex_state = 7, .external_lex_state = 4},
  [3164] = {.lex_state = 50, .external_lex_state = 2},
  [3165] = {.lex_state = 11, .external_lex_state = 4},
  [3166] = {.lex_state = 7, .external_lex_state = 4},
  [3167] = {.lex_state = 11, .external_lex_state = 4},
  [3168] = {.lex_state = 7, .external_lex_state = 4},
  [3169] = {.lex_state = 7, .external_lex_state = 4},
  [3170] = {.lex_state = 7, .external_lex_state = 4},
  [3171] = {.lex_state = 7, .external_lex_state = 4},
  [3172] = {.lex_state = 7, .external_lex_state = 4},
  [3173] = {.lex_state = 7, .external_lex_state = 4},
  [3174] = {.lex_state = 7, .external_lex_state = 4},
  [3175] = {.lex_state = 7, .external_lex_state = 4},
  [3176] = {.lex_state = 7, .external_lex_state = 4},
  [3177] = {.lex_state = 7, .external_lex_state = 4},
  [3178] = {.lex_state = 7, .external_lex_state = 4},
  [3179] = {.lex_state = 7, .external_lex_state = 4},
  [3180] = {.lex_state = 11, .external_lex_state = 4},
  [3181] = {.lex_state = 7, .external_lex_state = 4},
  [3182] = {.lex_state = 7, .external_lex_state = 4},
  [3183] = {.lex_state = 7, .external_lex_state = 4},
  [3184] = {.lex_state = 7, .external_lex_state = 4},
  [3185] = {.lex_state = 11, .external_lex_state = 4},
  [3186] = {.lex_state = 7, .external_lex_state = 4},
  [3187] = {.lex_state = 11, .external_lex_state = 4},
  [3188] = {.lex_state = 11, .external_lex_state = 4},
  [3189] = {.lex_state = 11, .external_lex_state = 4},
  [3190] = {.lex_state = 50, .external_lex_state = 2},
  [3191] = {.lex_state = 11, .external_lex_state = 4},
  [3192] = {.lex_state = 7, .external_lex_state = 4},
  [3193] = {.lex_state = 7, .external_lex_state = 4},
  [3194] = {.lex_state = 7, .external_lex_state = 4},
  [3195] = {.lex_state = 6, .external_lex_state = 4},
  [3196] = {.lex_state = 9, .external_lex_state = 4},
  [3197] = {.lex_state = 7, .external_lex_state = 4},
  [3198] = {.lex_state = 7, .external_lex_state = 4},
  [3199] = {.lex_state = 7, .external_lex_state = 4},
  [3200] = {.lex_state = 50, .external_lex_state = 2},
  [3201] = {.lex_state = 50, .external_lex_state = 2},
  [3202] = {.lex_state = 7, .external_lex_state = 4},
  [3203] = {.lex_state = 7, .external_lex_state = 4},
  [3204] = {.lex_state = 9, .external_lex_state = 2},
  [3205] = {.lex_state = 11, .external_lex_state = 4},
  [3206] = {.lex_state = 50, .external_lex_state = 2},
  [3207] = {.lex_state = 7, .external_lex_state = 4},
  [3208] = {.lex_state = 7, .external_lex_state = 4},
  [3209] = {.lex_state = 7, .external_lex_state = 4},
  [3210] = {.lex_state = 50, .external_lex_state = 2},
  [3211] = {.lex_state = 7, .external_lex_state = 4},
  [3212] = {.lex_state = 7, .external_lex_state = 4},
  [3213] = {.lex_state = 7, .external_lex_state = 4},
  [3214] = {.lex_state = 50, .external_lex_state = 2},
  [3215] = {.lex_state = 7, .external_lex_state = 4},
  [3216] = {.lex_state = 7, .external_lex_state = 4},
  [3217] = {.lex_state = 7, .external_lex_state = 4},
  [3218] = {.lex_state = 7, .external_lex_state = 4},
  [3219] = {.lex_state = 11, .external_lex_state = 4},
  [3220] = {.lex_state = 9, .external_lex_state = 4},
  [3221] = {.lex_state = 7, .external_lex_state = 4},
  [3222] = {.lex_state = 7, .external_lex_state = 4},
  [3223] = {.lex_state = 50, .external_lex_state = 2},
  [3224] = {.lex_state = 7, .external_lex_state = 4},
  [3225] = {.lex_state = 7, .external_lex_state = 4},
  [3226] = {.lex_state = 7, .external_lex_state = 4},
  [3227] = {.lex_state = 7, .external_lex_state = 4},
  [3228] = {.lex_state = 11, .external_lex_state = 4},
  [3229] = {.lex_state = 50, .external_lex_state = 2},
  [3230] = {.lex_state = 9, .external_lex_state = 4},
  [3231] = {.lex_state = 50, .external_lex_state = 2},
  [3232] = {.lex_state = 9, .external_lex_state = 4},
  [3233] = {.lex_state = 7, .external_lex_state = 4},
  [3234] = {.lex_state = 7, .external_lex_state = 4},
  [3235] = {.lex_state = 9, .external_lex_state = 4},
  [3236] = {.lex_state = 7, .external_lex_state = 4},
  [3237] = {.lex_state = 50, .external_lex_state = 2},
  [3238] = {.lex_state = 50, .external_lex_state = 2},
  [3239] = {.lex_state = 50, .external_lex_state = 2},
  [3240] = {.lex_state = 7, .external_lex_state = 4},
  [3241] = {.lex_state = 11, .external_lex_state = 4},
  [3242] = {.lex_state = 11, .external_lex_state = 4},
  [3243] = {.lex_state = 11, .external_lex_state = 4},
  [3244] = {.lex_state = 11, .external_lex_state = 4},
  [3245] = {.lex_state = 9, .external_lex_state = 4},
  [3246] = {.lex_state = 11, .external_lex_state = 4},
  [3247] = {.lex_state = 11, .external_lex_state = 4},
  [3248] = {.lex_state = 9, .external_lex_state = 4},
  [3249] = {.lex_state = 50, .external_lex_state = 2},
  [3250] = {.lex_state = 7, .external_lex_state = 4},
  [3251] = {.lex_state = 7, .external_lex_state = 4},
  [3252] = {.lex_state = 7, .external_lex_state = 4},
  [3253] = {.lex_state = 7, .external_lex_state = 4},
  [3254] = {.lex_state = 7, .external_lex_state = 4},
  [3255] = {.lex_state = 7, .external_lex_state = 4},
  [3256] = {.lex_state = 9, .external_lex_state = 4},
  [3257] = {.lex_state = 11, .external_lex_state = 4},
  [3258] = {.lex_state = 11, .external_lex_state = 4},
  [3259] = {.lex_state = 7, .external_lex_state = 4},
  [3260] = {.lex_state = 9, .external_lex_state = 4},
  [3261] = {.lex_state = 7, .external_lex_state = 4},
  [3262] = {.lex_state = 11, .external_lex_state = 4},
  [3263] = {.lex_state = 7, .external_lex_state = 4},
  [3264] = {.lex_state = 11, .external_lex_state = 4},
  [3265] = {.lex_state = 7, .external_lex_state = 4},
  [3266] = {.lex_state = 11, .external_lex_state = 4},
  [3267] = {.lex_state = 7, .external_lex_state = 4},
  [3268] = {.lex_state = 9, .external_lex_state = 4},
  [3269] = {.lex_state = 11, .external_lex_state = 4},
  [3270] = {.lex_state = 9, .external_lex_state = 4},
  [3271] = {.lex_state = 9, .external_lex_state = 4},
  [3272] = {.lex_state = 11, .external_lex_state = 4},
  [3273] = {.lex_state = 7, .external_lex_state = 4},
  [3274] = {.lex_state = 9, .external_lex_state = 4},
  [3275] = {.lex_state = 11, .external_lex_state = 4},
  [3276] = {.lex_state = 11, .external_lex_state = 4},
  [3277] = {.lex_state = 9, .external_lex_state = 4},
  [3278] = {.lex_state = 11, .external_lex_state = 4},
  [3279] = {.lex_state = 11, .external_lex_state = 4},
  [3280] = {.lex_state = 9, .external_lex_state = 4},
  [3281] = {.lex_state = 11, .external_lex_state = 4},
  [3282] = {.lex_state = 9, .external_lex_state = 4},
  [3283] = {.lex_state = 9, .external_lex_state = 4},
  [3284] = {.lex_state = 11, .external_lex_state = 4},
  [3285] = {.lex_state = 9, .external_lex_state = 4},
  [3286] = {.lex_state = 9, .external_lex_state = 4},
  [3287] = {.lex_state = 9, .external_lex_state = 4},
  [3288] = {.lex_state = 7, .external_lex_state = 4},
  [3289] = {.lex_state = 9, .external_lex_state = 4},
  [3290] = {.lex_state = 7, .external_lex_state = 4},
  [3291] = {.lex_state = 7, .external_lex_state = 4},
  [3292] = {.lex_state = 7, .external_lex_state = 4},
  [3293] = {.lex_state = 11, .external_lex_state = 4},
  [3294] = {.lex_state = 7, .external_lex_state = 4},
  [3295] = {.lex_state = 9, .external_lex_state = 4},
  [3296] = {.lex_state = 9, .external_lex_state = 4},
  [3297] = {.lex_state = 11, .external_lex_state = 4},
  [3298] = {.lex_state = 7, .external_lex_state = 4},
  [3299] = {.lex_state = 7, .external_lex_state = 4},
  [3300] = {.lex_state = 7, .external_lex_state = 4},
  [3301] = {.lex_state = 11, .external_lex_state = 4},
  [3302] = {.lex_state = 7, .external_lex_state = 4},
  [3303] = {.lex_state = 9, .external_lex_state = 4},
  [3304] = {.lex_state = 11, .external_lex_state = 4},
  [3305] = {.lex_state = 9, .external_lex_state = 4},
  [3306] = {.lex_state = 50, .external_lex_state = 2},
  [3307] = {.lex_state = 7, .external_lex_state = 4},
  [3308] = {.lex_state = 7, .external_lex_state = 4},
  [3309] = {.lex_state = 9, .external_lex_state = 4},
  [3310] = {.lex_state = 7, .external_lex_state = 4},
  [3311] = {.lex_state = 7, .external_lex_state = 4},
  [3312] = {.lex_state = 7, .external_lex_state = 4},
  [3313] = {.lex_state = 7, .external_lex_state = 4},
  [3314] = {.lex_state = 50, .external_lex_state = 2},
  [3315] = {.lex_state = 11, .external_lex_state = 4},
  [3316] = {.lex_state = 11, .external_lex_state = 4},
  [3317] = {.lex_state = 7, .external_lex_state = 4},
  [3318] = {.lex_state = 9, .external_lex_state = 4},
  [3319] = {.lex_state = 7, .external_lex_state = 4},
  [3320] = {.lex_state = 7, .external_lex_state = 4},
  [3321] = {.lex_state = 11, .external_lex_state = 4},
  [3322] = {.lex_state = 7, .external_lex_state = 4},
  [3323] = {.lex_state = 7, .external_lex_state = 4},
  [3324] = {.lex_state = 7, .external_lex_state = 4},
  [3325] = {.lex_state = 7, .external_lex_state = 4},
  [3326] = {.lex_state = 7, .external_lex_state = 4},
  [3327] = {.lex_state = 11, .external_lex_state = 4},
  [3328] = {.lex_state = 11, .external_lex_state = 4},
  [3329] = {.lex_state = 9, .external_lex_state = 4},
  [3330] = {.lex_state = 9, .external_lex_state = 4},
  [3331] = {.lex_state = 11, .external_lex_state = 4},
  [3332] = {.lex_state = 11, .external_lex_state = 4},
  [3333] = {.lex_state = 11, .external_lex_state = 4},
  [3334] = {.lex_state = 9, .external_lex_state = 4},
  [3335] = {.lex_state = 7, .external_lex_state = 4},
  [3336] = {.lex_state = 7, .external_lex_state = 4},
  [3337] = {.lex_state = 11, .external_lex_state = 4},
  [3338] = {.lex_state = 11, .external_lex_state = 4},
  [3339] = {.lex_state = 11, .external_lex_state = 4},
  [3340] = {.lex_state = 11, .external_lex_state = 4},
  [3341] = {.lex_state = 11, .external_lex_state = 4},
  [3342] = {.lex_state = 11, .external_lex_state = 4},
  [3343] = {.lex_state = 11, .external_lex_state = 4},
  [3344] = {.lex_state = 11, .external_lex_state = 4},
  [3345] = {.lex_state = 9, .external_lex_state = 4},
  [3346] = {.lex_state = 11, .external_lex_state = 4},
  [3347] = {.lex_state = 11, .external_lex_state = 4},
  [3348] = {.lex_state = 7, .external_lex_state = 4},
  [3349] = {.lex_state = 11, .external_lex_state = 4},
  [3350] = {.lex_state = 11, .external_lex_state = 4},
  [3351] = {.lex_state = 9, .external_lex_state = 4},
  [3352] = {.lex_state = 11, .external_lex_state = 4},
  [3353] = {.lex_state = 11, .external_lex_state = 4},
  [3354] = {.lex_state = 11, .external_lex_state = 4},
  [3355] = {.lex_state = 11, .external_lex_state = 4},
  [3356] = {.lex_state = 11, .external_lex_state = 4},
  [3357] = {.lex_state = 11, .external_lex_state = 4},
  [3358] = {.lex_state = 11, .external_lex_state = 4},
  [3359] = {.lex_state = 11, .external_lex_state = 4},
  [3360] = {.lex_state = 11, .external_lex_state = 4},
  [3361] = {.lex_state = 11, .external_lex_state = 4},
  [3362] = {.lex_state = 11, .external_lex_state = 4},
  [3363] = {.lex_state = 11, .external_lex_state = 4},
  [3364] = {.lex_state = 11, .external_lex_state = 4},
  [3365] = {.lex_state = 9, .external_lex_state = 4},
  [3366] = {.lex_state = 11, .external_lex_state = 4},
  [3367] = {.lex_state = 11, .external_lex_state = 4},
  [3368] = {.lex_state = 11, .external_lex_state = 4},
  [3369] = {.lex_state = 11, .external_lex_state = 4},
  [3370] = {.lex_state = 9, .external_lex_state = 4},
  [3371] = {.lex_state = 7, .external_lex_state = 4},
  [3372] = {.lex_state = 11, .external_lex_state = 4},
  [3373] = {.lex_state = 11, .external_lex_state = 4},
  [3374] = {.lex_state = 7, .external_lex_state = 4},
  [3375] = {.lex_state = 11, .external_lex_state = 4},
  [3376] = {.lex_state = 11, .external_lex_state = 4},
  [3377] = {.lex_state = 9, .external_lex_state = 4},
  [3378] = {.lex_state = 11, .external_lex_state = 4},
  [3379] = {.lex_state = 11, .external_lex_state = 4},
  [3380] = {.lex_state = 7, .external_lex_state = 4},
  [3381] = {.lex_state = 9, .external_lex_state = 4},
  [3382] = {.lex_state = 11, .external_lex_state = 4},
  [3383] = {.lex_state = 7, .external_lex_state = 4},
  [3384] = {.lex_state = 11, .external_lex_state = 4},
  [3385] = {.lex_state = 7, .external_lex_state = 4},
  [3386] = {.lex_state = 11, .external_lex_state = 4},
  [3387] = {.lex_state = 11, .external_lex_state = 4},
  [3388] = {.lex_state = 7, .external_lex_state = 4},
  [3389] = {.lex_state = 7, .external_lex_state = 4},
  [3390] = {.lex_state = 9, .external_lex_state = 4},
  [3391] = {.lex_state = 7, .external_lex_state = 4},
  [3392] = {.lex_state = 9, .external_lex_state = 4},
  [3393] = {.lex_state = 9, .external_lex_state = 4},
  [3394] = {.lex_state = 9, .external_lex_state = 4},
  [3395] = {.lex_state = 9, .external_lex_state = 4},
  [3396] = {.lex_state = 9, .external_lex_state = 4},
  [3397] = {.lex_state = 9, .external_lex_state = 4},
  [3398] = {.lex_state = 9, .external_lex_state = 4},
  [3399] = {.lex_state = 9, .external_lex_state = 4},
  [3400] = {.lex_state = 9, .external_lex_state = 4},
  [3401] = {.lex_state = 11, .external_lex_state = 4},
  [3402] = {.lex_state = 7, .external_lex_state = 4},
  [3403] = {.lex_state = 9, .external_lex_state = 4},
  [3404] = {.lex_state = 9, .external_lex_state = 4},
  [3405] = {.lex_state = 9, .external_lex_state = 4},
  [3406] = {.lex_state = 7, .external_lex_state = 4},
  [3407] = {.lex_state = 9, .external_lex_state = 4},
  [3408] = {.lex_state = 9, .external_lex_state = 4},
  [3409] = {.lex_state = 11, .external_lex_state = 4},
  [3410] = {.lex_state = 9, .external_lex_state = 4},
  [3411] = {.lex_state = 9, .external_lex_state = 4},
  [3412] = {.lex_state = 9, .external_lex_state = 4},
  [3413] = {.lex_state = 11, .external_lex_state = 4},
  [3414] = {.lex_state = 7, .external_lex_state = 4},
  [3415] = {.lex_state = 7, .external_lex_state = 4},
  [3416] = {.lex_state = 9, .external_lex_state = 4},
  [3417] = {.lex_state = 9, .external_lex_state = 4},
  [3418] = {.lex_state = 11, .external_lex_state = 4},
  [3419] = {.lex_state = 7, .external_lex_state = 4},
  [3420] = {.lex_state = 11, .external_lex_state = 4},
  [3421] = {.lex_state = 9, .external_lex_state = 4},
  [3422] = {.lex_state = 9, .external_lex_state = 4},
  [3423] = {.lex_state = 11, .external_lex_state = 4},
  [3424] = {.lex_state = 11, .external_lex_state = 4},
  [3425] = {.lex_state = 9, .external_lex_state = 4},
  [3426] = {.lex_state = 11, .external_lex_state = 4},
  [3427] = {.lex_state = 11, .external_lex_state = 4},
  [3428] = {.lex_state = 7, .external_lex_state = 4},
  [3429] = {.lex_state = 11, .external_lex_state = 4},
  [3430] = {.lex_state = 11, .external_lex_state = 4},
  [3431] = {.lex_state = 7, .external_lex_state = 4},
  [3432] = {.lex_state = 9, .external_lex_state = 4},
  [3433] = {.lex_state = 7, .external_lex_state = 4},
  [3434] = {.lex_state = 9, .external_lex_state = 4},
  [3435] = {.lex_state = 9, .external_lex_state = 4},
  [3436] = {.lex_state = 9, .external_lex_state = 4},
  [3437] = {.lex_state = 9, .external_lex_state = 4},
  [3438] = {.lex_state = 11, .external_lex_state = 4},
  [3439] = {.lex_state = 9, .external_lex_state = 4},
  [3440] = {.lex_state = 9, .external_lex_state = 4},
  [3441] = {.lex_state = 9, .external_lex_state = 4},
  [3442] = {.lex_state = 11, .external_lex_state = 4},
  [3443] = {.lex_state = 7, .external_lex_state = 4},
  [3444] = {.lex_state = 11, .external_lex_state = 4},
  [3445] = {.lex_state = 9, .external_lex_state = 4},
  [3446] = {.lex_state = 11, .external_lex_state = 4},
  [3447] = {.lex_state = 9, .external_lex_state = 4},
  [3448] = {.lex_state = 9, .external_lex_state = 4},
  [3449] = {.lex_state = 7, .external_lex_state = 4},
  [3450] = {.lex_state = 9, .external_lex_state = 4},
  [3451] = {.lex_state = 9, .external_lex_state = 4},
  [3452] = {.lex_state = 11, .external_lex_state = 4},
  [3453] = {.lex_state = 9, .external_lex_state = 4},
  [3454] = {.lex_state = 9, .external_lex_state = 4},
  [3455] = {.lex_state = 7, .external_lex_state = 4},
  [3456] = {.lex_state = 9, .external_lex_state = 4},
  [3457] = {.lex_state = 9, .external_lex_state = 4},
  [3458] = {.lex_state = 7, .external_lex_state = 4},
  [3459] = {.lex_state = 9, .external_lex_state = 4},
  [3460] = {.lex_state = 7, .external_lex_state = 4},
  [3461] = {.lex_state = 9, .external_lex_state = 4},
  [3462] = {.lex_state = 9, .external_lex_state = 4},
  [3463] = {.lex_state = 9, .external_lex_state = 4},
  [3464] = {.lex_state = 9, .external_lex_state = 4},
  [3465] = {.lex_state = 9, .external_lex_state = 4},
  [3466] = {.lex_state = 9, .external_lex_state = 4},
  [3467] = {.lex_state = 9, .external_lex_state = 4},
  [3468] = {.lex_state = 7, .external_lex_state = 4},
  [3469] = {.lex_state = 9, .external_lex_state = 4},
  [3470] = {.lex_state = 7, .external_lex_state = 4},
  [3471] = {.lex_state = 11, .external_lex_state = 4},
  [3472] = {.lex_state = 9, .external_lex_state = 4},
  [3473] = {.lex_state = 9, .external_lex_state = 4},
  [3474] = {.lex_state = 9, .external_lex_state = 4},
  [3475] = {.lex_state = 7, .external_lex_state = 4},
  [3476] = {.lex_state = 9, .external_lex_state = 4},
  [3477] = {.lex_state = 9, .external_lex_state = 4},
  [3478] = {.lex_state = 7, .external_lex_state = 4},
  [3479] = {.lex_state = 9, .external_lex_state = 4},
  [3480] = {.lex_state = 9, .external_lex_state = 4},
  [3481] = {.lex_state = 7, .external_lex_state = 4},
  [3482] = {.lex_state = 9, .external_lex_state = 4},
  [3483] = {.lex_state = 9, .external_lex_state = 4},
  [3484] = {.lex_state = 7, .external_lex_state = 4},
  [3485] = {.lex_state = 9, .external_lex_state = 4},
  [3486] = {.lex_state = 11, .external_lex_state = 4},
  [3487] = {.lex_state = 9, .external_lex_state = 4},
  [3488] = {.lex_state = 9, .external_lex_state = 4},
  [3489] = {.lex_state = 9, .external_lex_state = 4},
  [3490] = {.lex_state = 9, .external_lex_state = 4},
  [3491] = {.lex_state = 7, .external_lex_state = 4},
  [3492] = {.lex_state = 11, .external_lex_state = 4},
  [3493] = {.lex_state = 11, .external_lex_state = 4},
  [3494] = {.lex_state = 11, .external_lex_state = 4},
  [3495] = {.lex_state = 11, .external_lex_state = 4},
  [3496] = {.lex_state = 11, .external_lex_state = 4},
  [3497] = {.lex_state = 11, .external_lex_state = 4},
  [3498] = {.lex_state = 50, .external_lex_state = 2},
  [3499] = {.lex_state = 11, .external_lex_state = 4},
  [3500] = {.lex_state = 11, .external_lex_state = 4},
  [3501] = {.lex_state = 11, .external_lex_state = 4},
  [3502] = {.lex_state = 11, .external_lex_state = 4},
  [3503] = {.lex_state = 7, .external_lex_state = 4},
  [3504] = {.lex_state = 11, .external_lex_state = 4},
  [3505] = {.lex_state = 17, .external_lex_state = 4},
  [3506] = {.lex_state = 11, .external_lex_state = 4},
  [3507] = {.lex_state = 11, .external_lex_state = 4},
  [3508] = {.lex_state = 11, .external_lex_state = 4},
  [3509] = {.lex_state = 7, .external_lex_state = 4},
  [3510] = {.lex_state = 7, .external_lex_state = 4},
  [3511] = {.lex_state = 11, .external_lex_state = 4},
  [3512] = {.lex_state = 11, .external_lex_state = 4},
  [3513] = {.lex_state = 11, .external_lex_state = 4},
  [3514] = {.lex_state = 11, .external_lex_state = 4},
  [3515] = {.lex_state = 7, .external_lex_state = 4},
  [3516] = {.lex_state = 7, .external_lex_state = 4},
  [3517] = {.lex_state = 7, .external_lex_state = 4},
  [3518] = {.lex_state = 7, .external_lex_state = 4},
  [3519] = {.lex_state = 7, .external_lex_state = 4},
  [3520] = {.lex_state = 7, .external_lex_state = 4},
  [3521] = {.lex_state = 7, .external_lex_state = 4},
  [3522] = {.lex_state = 7, .external_lex_state = 4},
  [3523] = {.lex_state = 7, .external_lex_state = 4},
  [3524] = {.lex_state = 7, .external_lex_state = 4},
  [3525] = {.lex_state = 7, .external_lex_state = 4},
  [3526] = {.lex_state = 7, .external_lex_state = 4},
  [3527] = {.lex_state = 7, .external_lex_state = 4},
  [3528] = {.lex_state = 7, .external_lex_state = 4},
  [3529] = {.lex_state = 7, .external_lex_state = 4},
  [3530] = {.lex_state = 7, .external_lex_state = 4},
  [3531] = {.lex_state = 7, .external_lex_state = 4},
  [3532] = {.lex_state = 7, .external_lex_state = 4},
  [3533] = {.lex_state = 50, .external_lex_state = 2},
  [3534] = {.lex_state = 17, .external_lex_state = 4},
  [3535] = {.lex_state = 17, .external_lex_state = 4},
  [3536] = {.lex_state = 18, .external_lex_state = 4},
  [3537] = {.lex_state = 17, .external_lex_state = 4},
  [3538] = {.lex_state = 17, .external_lex_state = 4},
  [3539] = {.lex_state = 17, .external_lex_state = 4},
  [3540] = {.lex_state = 17, .external_lex_state = 4},
  [3541] = {.lex_state = 17, .external_lex_state = 4},
  [3542] = {.lex_state = 17, .external_lex_state = 4},
  [3543] = {.lex_state = 17, .external_lex_state = 4},
  [3544] = {.lex_state = 17, .external_lex_state = 4},
  [3545] = {.lex_state = 17, .external_lex_state = 4},
  [3546] = {.lex_state = 17, .external_lex_state = 4},
  [3547] = {.lex_state = 17, .external_lex_state = 4},
  [3548] = {.lex_state = 18, .external_lex_state = 4},
  [3549] = {.lex_state = 18, .external_lex_state = 4},
  [3550] = {.lex_state = 18, .external_lex_state = 4},
  [3551] = {.lex_state = 18, .external_lex_state = 4},
  [3552] = {.lex_state = 17, .external_lex_state = 4},
  [3553] = {.lex_state = 18, .external_lex_state = 4},
  [3554] = {.lex_state = 18, .external_lex_state = 4},
  [3555] = {.lex_state = 50, .external_lex_state = 2},
  [3556] = {.lex_state = 17, .external_lex_state = 4},
  [3557] = {.lex_state = 18, .external_lex_state = 4},
  [3558] = {.lex_state = 18, .external_lex_state = 4},
  [3559] = {.lex_state = 18, .external_lex_state = 4},
  [3560] = {.lex_state = 17, .external_lex_state = 4},
  [3561] = {.lex_state = 17, .external_lex_state = 4},
  [3562] = {.lex_state = 17, .external_lex_state = 4},
  [3563] = {.lex_state = 17, .external_lex_state = 4},
  [3564] = {.lex_state = 17, .external_lex_state = 4},
  [3565] = {.lex_state = 17, .external_lex_state = 4},
  [3566] = {.lex_state = 17, .external_lex_state = 4},
  [3567] = {.lex_state = 17, .external_lex_state = 4},
  [3568] = {.lex_state = 17, .external_lex_state = 4},
  [3569] = {.lex_state = 17, .external_lex_state = 4},
  [3570] = {.lex_state = 17, .external_lex_state = 4},
  [3571] = {.lex_state = 17, .external_lex_state = 4},
  [3572] = {.lex_state = 17, .external_lex_state = 4},
  [3573] = {.lex_state = 17, .external_lex_state = 4},
  [3574] = {.lex_state = 18, .external_lex_state = 4},
  [3575] = {.lex_state = 18, .external_lex_state = 4},
  [3576] = {.lex_state = 17, .external_lex_state = 4},
  [3577] = {.lex_state = 17, .external_lex_state = 4},
  [3578] = {.lex_state = 17, .external_lex_state = 4},
  [3579] = {.lex_state = 17, .external_lex_state = 4},
  [3580] = {.lex_state = 18, .external_lex_state = 4},
  [3581] = {.lex_state = 18, .external_lex_state = 4},
  [3582] = {.lex_state = 17, .external_lex_state = 4},
  [3583] = {.lex_state = 17, .external_lex_state = 4},
  [3584] = {.lex_state = 17, .external_lex_state = 4},
  [3585] = {.lex_state = 17, .external_lex_state = 4},
  [3586] = {.lex_state = 17, .external_lex_state = 4},
  [3587] = {.lex_state = 17, .external_lex_state = 4},
  [3588] = {.lex_state = 17, .external_lex_state = 4},
  [3589] = {.lex_state = 18, .external_lex_state = 4},
  [3590] = {.lex_state = 17, .external_lex_state = 4},
  [3591] = {.lex_state = 17, .external_lex_state = 4},
  [3592] = {.lex_state = 17, .external_lex_state = 4},
  [3593] = {.lex_state = 18, .external_lex_state = 4},
  [3594] = {.lex_state = 18, .external_lex_state = 4},
  [3595] = {.lex_state = 18, .external_lex_state = 4},
  [3596] = {.lex_state = 18, .external_lex_state = 4},
  [3597] = {.lex_state = 18, .external_lex_state = 4},
  [3598] = {.lex_state = 18, .external_lex_state = 4},
  [3599] = {.lex_state = 17, .external_lex_state = 4},
  [3600] = {.lex_state = 18, .external_lex_state = 4},
  [3601] = {.lex_state = 50, .external_lex_state = 2},
  [3602] = {.lex_state = 18, .external_lex_state = 4},
  [3603] = {.lex_state = 50, .external_lex_state = 2},
  [3604] = {.lex_state = 50, .external_lex_state = 2},
  [3605] = {.lex_state = 17, .external_lex_state = 4},
  [3606] = {.lex_state = 17, .external_lex_state = 4},
  [3607] = {.lex_state = 17, .external_lex_state = 4},
  [3608] = {.lex_state = 18, .external_lex_state = 4},
  [3609] = {.lex_state = 50, .external_lex_state = 2},
  [3610] = {.lex_state = 17, .external_lex_state = 4},
  [3611] = {.lex_state = 17, .external_lex_state = 4},
  [3612] = {.lex_state = 17, .external_lex_state = 4},
  [3613] = {.lex_state = 17, .external_lex_state = 4},
  [3614] = {.lex_state = 50, .external_lex_state = 2},
  [3615] = {.lex_state = 17, .external_lex_state = 4},
  [3616] = {.lex_state = 17, .external_lex_state = 4},
  [3617] = {.lex_state = 17, .external_lex_state = 4},
  [3618] = {.lex_state = 17, .external_lex_state = 4},
  [3619] = {.lex_state = 17, .external_lex_state = 4},
  [3620] = {.lex_state = 17, .external_lex_state = 4},
  [3621] = {.lex_state = 17, .external_lex_state = 4},
  [3622] = {.lex_state = 17, .external_lex_state = 4},
  [3623] = {.lex_state = 17, .external_lex_state = 4},
  [3624] = {.lex_state = 17, .external_lex_state = 4},
  [3625] = {.lex_state = 17, .external_lex_state = 4},
  [3626] = {.lex_state = 17, .external_lex_state = 4},
  [3627] = {.lex_state = 50, .external_lex_state = 2},
  [3628] = {.lex_state = 17, .external_lex_state = 4},
  [3629] = {.lex_state = 17, .external_lex_state = 4},
  [3630] = {.lex_state = 17, .external_lex_state = 4},
  [3631] = {.lex_state = 17, .external_lex_state = 4},
  [3632] = {.lex_state = 50, .external_lex_state = 2},
  [3633] = {.lex_state = 50, .external_lex_state = 2},
  [3634] = {.lex_state = 17, .external_lex_state = 4},
  [3635] = {.lex_state = 17, .external_lex_state = 4},
  [3636] = {.lex_state = 17, .external_lex_state = 4},
  [3637] = {.lex_state = 17, .external_lex_state = 4},
  [3638] = {.lex_state = 50, .external_lex_state = 2},
  [3639] = {.lex_state = 50, .external_lex_state = 2},
  [3640] = {.lex_state = 17, .external_lex_state = 4},
  [3641] = {.lex_state = 50, .external_lex_state = 2},
  [3642] = {.lex_state = 17, .external_lex_state = 4},
  [3643] = {.lex_state = 17, .external_lex_state = 4},
  [3644] = {.lex_state = 17, .external_lex_state = 4},
  [3645] = {.lex_state = 17, .external_lex_state = 4},
  [3646] = {.lex_state = 17, .external_lex_state = 4},
  [3647] = {.lex_state = 17, .external_lex_state = 4},
  [3648] = {.lex_state = 17, .external_lex_state = 4},
  [3649] = {.lex_state = 17, .external_lex_state = 4},
  [3650] = {.lex_state = 17, .external_lex_state = 4},
  [3651] = {.lex_state = 50, .external_lex_state = 2},
  [3652] = {.lex_state = 17, .external_lex_state = 4},
  [3653] = {.lex_state = 17, .external_lex_state = 4},
  [3654] = {.lex_state = 17, .external_lex_state = 4},
  [3655] = {.lex_state = 17, .external_lex_state = 4},
  [3656] = {.lex_state = 17, .external_lex_state = 4},
  [3657] = {.lex_state = 17, .external_lex_state = 4},
  [3658] = {.lex_state = 17, .external_lex_state = 4},
  [3659] = {.lex_state = 17, .external_lex_state = 4},
  [3660] = {.lex_state = 17, .external_lex_state = 4},
  [3661] = {.lex_state = 17, .external_lex_state = 4},
  [3662] = {.lex_state = 17, .external_lex_state = 4},
  [3663] = {.lex_state = 17, .external_lex_state = 4},
  [3664] = {.lex_state = 17, .external_lex_state = 4},
  [3665] = {.lex_state = 17, .external_lex_state = 4},
  [3666] = {.lex_state = 17, .external_lex_state = 4},
  [3667] = {.lex_state = 17, .external_lex_state = 4},
  [3668] = {.lex_state = 17, .external_lex_state = 4},
  [3669] = {.lex_state = 17, .external_lex_state = 4},
  [3670] = {.lex_state = 17, .external_lex_state = 4},
  [3671] = {.lex_state = 17, .external_lex_state = 4},
  [3672] = {.lex_state = 17, .external_lex_state = 4},
  [3673] = {.lex_state = 17, .external_lex_state = 4},
  [3674] = {.lex_state = 17, .external_lex_state = 4},
  [3675] = {.lex_state = 17, .external_lex_state = 4},
  [3676] = {.lex_state = 17, .external_lex_state = 4},
  [3677] = {.lex_state = 17, .external_lex_state = 4},
  [3678] = {.lex_state = 17, .external_lex_state = 4},
  [3679] = {.lex_state = 17, .external_lex_state = 4},
  [3680] = {.lex_state = 17, .external_lex_state = 4},
  [3681] = {.lex_state = 17, .external_lex_state = 4},
  [3682] = {.lex_state = 50, .external_lex_state = 2},
  [3683] = {.lex_state = 50, .external_lex_state = 2},
  [3684] = {.lex_state = 50, .external_lex_state = 2},
  [3685] = {.lex_state = 50, .external_lex_state = 2},
  [3686] = {.lex_state = 50, .external_lex_state = 2},
  [3687] = {.lex_state = 50, .external_lex_state = 2},
  [3688] = {.lex_state = 50, .external_lex_state = 2},
  [3689] = {.lex_state = 50, .external_lex_state = 2},
  [3690] = {.lex_state = 50, .external_lex_state = 2},
  [3691] = {.lex_state = 50, .external_lex_state = 2},
  [3692] = {.lex_state = 50, .external_lex_state = 2},
  [3693] = {.lex_state = 50, .external_lex_state = 2},
  [3694] = {.lex_state = 50, .external_lex_state = 2},
  [3695] = {.lex_state = 50, .external_lex_state = 2},
  [3696] = {.lex_state = 50, .external_lex_state = 2},
  [3697] = {.lex_state = 50, .external_lex_state = 2},
  [3698] = {.lex_state = 50, .external_lex_state = 2},
  [3699] = {.lex_state = 50, .external_lex_state = 2},
  [3700] = {.lex_state = 50, .external_lex_state = 2},
  [3701] = {.lex_state = 50, .external_lex_state = 2},
  [3702] = {.lex_state = 50, .external_lex_state = 2},
  [3703] = {.lex_state = 50, .external_lex_state = 2},
  [3704] = {.lex_state = 50, .external_lex_state = 2},
  [3705] = {.lex_state = 50, .external_lex_state = 2},
  [3706] = {.lex_state = 50, .external_lex_state = 2},
  [3707] = {.lex_state = 50, .external_lex_state = 2},
  [3708] = {.lex_state = 50, .external_lex_state = 2},
  [3709] = {.lex_state = 50, .external_lex_state = 2},
  [3710] = {.lex_state = 50, .external_lex_state = 2},
  [3711] = {.lex_state = 50, .external_lex_state = 2},
  [3712] = {.lex_state = 50, .external_lex_state = 2},
  [3713] = {.lex_state = 50, .external_lex_state = 2},
  [3714] = {.lex_state = 50, .external_lex_state = 2},
  [3715] = {.lex_state = 50, .external_lex_state = 2},
  [3716] = {.lex_state = 50, .external_lex_state = 2},
  [3717] = {.lex_state = 50, .external_lex_state = 2},
  [3718] = {.lex_state = 50, .external_lex_state = 2},
  [3719] = {.lex_state = 50, .external_lex_state = 2},
  [3720] = {.lex_state = 50, .external_lex_state = 2},
  [3721] = {.lex_state = 50, .external_lex_state = 2},
  [3722] = {.lex_state = 50, .external_lex_state = 2},
  [3723] = {.lex_state = 50, .external_lex_state = 2},
  [3724] = {.lex_state = 50, .external_lex_state = 2},
  [3725] = {.lex_state = 50, .external_lex_state = 2},
  [3726] = {.lex_state = 50, .external_lex_state = 2},
  [3727] = {.lex_state = 50, .external_lex_state = 2},
  [3728] = {.lex_state = 50, .external_lex_state = 2},
  [3729] = {.lex_state = 50, .external_lex_state = 2},
  [3730] = {.lex_state = 50, .external_lex_state = 2},
  [3731] = {.lex_state = 50, .external_lex_state = 2},
  [3732] = {.lex_state = 50, .external_lex_state = 2},
  [3733] = {.lex_state = 50, .external_lex_state = 2},
  [3734] = {.lex_state = 50, .external_lex_state = 2},
  [3735] = {.lex_state = 50, .external_lex_state = 2},
  [3736] = {.lex_state = 50, .external_lex_state = 2},
  [3737] = {.lex_state = 50, .external_lex_state = 2},
  [3738] = {.lex_state = 50, .external_lex_state = 2},
  [3739] = {.lex_state = 50, .external_lex_state = 2},
  [3740] = {.lex_state = 50, .external_lex_state = 2},
  [3741] = {.lex_state = 50, .external_lex_state = 2},
  [3742] = {.lex_state = 50, .external_lex_state = 2},
  [3743] = {.lex_state = 50, .external_lex_state = 2},
  [3744] = {.lex_state = 50, .external_lex_state = 2},
  [3745] = {.lex_state = 50, .external_lex_state = 2},
  [3746] = {.lex_state = 50, .external_lex_state = 2},
  [3747] = {.lex_state = 50, .external_lex_state = 2},
  [3748] = {.lex_state = 50, .external_lex_state = 2},
  [3749] = {.lex_state = 50, .external_lex_state = 2},
  [3750] = {.lex_state = 50, .external_lex_state = 2},
  [3751] = {.lex_state = 50, .external_lex_state = 2},
  [3752] = {.lex_state = 50, .external_lex_state = 2},
  [3753] = {.lex_state = 50, .external_lex_state = 2},
  [3754] = {.lex_state = 50, .external_lex_state = 2},
  [3755] = {.lex_state = 50, .external_lex_state = 2},
  [3756] = {.lex_state = 50, .external_lex_state = 2},
  [3757] = {.lex_state = 50, .external_lex_state = 2},
  [3758] = {.lex_state = 50, .external_lex_state = 2},
  [3759] = {.lex_state = 50, .external_lex_state = 2},
  [3760] = {.lex_state = 50, .external_lex_state = 2},
  [3761] = {.lex_state = 50, .external_lex_state = 2},
  [3762] = {.lex_state = 50, .external_lex_state = 2},
  [3763] = {.lex_state = 50, .external_lex_state = 2},
  [3764] = {.lex_state = 50, .external_lex_state = 2},
  [3765] = {.lex_state = 50, .external_lex_state = 2},
  [3766] = {.lex_state = 50, .external_lex_state = 2},
  [3767] = {.lex_state = 50, .external_lex_state = 2},
  [3768] = {.lex_state = 50, .external_lex_state = 2},
  [3769] = {.lex_state = 50, .external_lex_state = 2},
  [3770] = {.lex_state = 50, .external_lex_state = 2},
  [3771] = {.lex_state = 50, .external_lex_state = 2},
  [3772] = {.lex_state = 50, .external_lex_state = 2},
  [3773] = {.lex_state = 50, .external_lex_state = 2},
  [3774] = {.lex_state = 50, .external_lex_state = 2},
  [3775] = {.lex_state = 50, .external_lex_state = 2},
  [3776] = {.lex_state = 50, .external_lex_state = 2},
  [3777] = {.lex_state = 50, .external_lex_state = 2},
  [3778] = {.lex_state = 50, .external_lex_state = 2},
  [3779] = {.lex_state = 50, .external_lex_state = 2},
  [3780] = {.lex_state = 50, .external_lex_state = 2},
  [3781] = {.lex_state = 50, .external_lex_state = 2},
  [3782] = {.lex_state = 50, .external_lex_state = 2},
  [3783] = {.lex_state = 50, .external_lex_state = 2},
  [3784] = {.lex_state = 50, .external_lex_state = 2},
  [3785] = {.lex_state = 50, .external_lex_state = 2},
  [3786] = {.lex_state = 50, .external_lex_state = 2},
  [3787] = {.lex_state = 50, .external_lex_state = 2},
  [3788] = {.lex_state = 50, .external_lex_state = 2},
  [3789] = {.lex_state = 50, .external_lex_state = 2},
  [3790] = {.lex_state = 50, .external_lex_state = 2},
  [3791] = {.lex_state = 50, .external_lex_state = 2},
  [3792] = {.lex_state = 50, .external_lex_state = 2},
  [3793] = {.lex_state = 50, .external_lex_state = 2},
  [3794] = {.lex_state = 50, .external_lex_state = 2},
  [3795] = {.lex_state = 50, .external_lex_state = 2},
  [3796] = {.lex_state = 50, .external_lex_state = 2},
  [3797] = {.lex_state = 50, .external_lex_state = 2},
  [3798] = {.lex_state = 50, .external_lex_state = 2},
  [3799] = {.lex_state = 50, .external_lex_state = 2},
  [3800] = {.lex_state = 50, .external_lex_state = 2},
  [3801] = {.lex_state = 50, .external_lex_state = 2},
  [3802] = {.lex_state = 50, .external_lex_state = 2},
  [3803] = {.lex_state = 50, .external_lex_state = 2},
  [3804] = {.lex_state = 50, .external_lex_state = 2},
  [3805] = {.lex_state = 50, .external_lex_state = 2},
  [3806] = {.lex_state = 50, .external_lex_state = 2},
  [3807] = {.lex_state = 50, .external_lex_state = 2},
  [3808] = {.lex_state = 50, .external_lex_state = 2},
  [3809] = {.lex_state = 50, .external_lex_state = 2},
  [3810] = {.lex_state = 50, .external_lex_state = 2},
  [3811] = {.lex_state = 50, .external_lex_state = 2},
  [3812] = {.lex_state = 50, .external_lex_state = 2},
  [3813] = {.lex_state = 50, .external_lex_state = 2},
  [3814] = {.lex_state = 50, .external_lex_state = 2},
  [3815] = {.lex_state = 50, .external_lex_state = 2},
  [3816] = {.lex_state = 50, .external_lex_state = 2},
  [3817] = {.lex_state = 50, .external_lex_state = 2},
  [3818] = {.lex_state = 50, .external_lex_state = 2},
  [3819] = {.lex_state = 50, .external_lex_state = 2},
  [3820] = {.lex_state = 50, .external_lex_state = 2},
  [3821] = {.lex_state = 50, .external_lex_state = 2},
  [3822] = {.lex_state = 50, .external_lex_state = 2},
  [3823] = {.lex_state = 50, .external_lex_state = 2},
  [3824] = {.lex_state = 50, .external_lex_state = 2},
  [3825] = {.lex_state = 50, .external_lex_state = 2},
  [3826] = {.lex_state = 50, .external_lex_state = 2},
  [3827] = {.lex_state = 50, .external_lex_state = 2},
  [3828] = {.lex_state = 50, .external_lex_state = 2},
  [3829] = {.lex_state = 19, .external_lex_state = 2},
  [3830] = {.lex_state = 50, .external_lex_state = 2},
  [3831] = {.lex_state = 19, .external_lex_state = 2},
  [3832] = {.lex_state = 19, .external_lex_state = 2},
  [3833] = {.lex_state = 19, .external_lex_state = 2},
  [3834] = {.lex_state = 19, .external_lex_state = 2},
  [3835] = {.lex_state = 19, .external_lex_state = 2},
  [3836] = {.lex_state = 19, .external_lex_state = 2},
  [3837] = {.lex_state = 19, .external_lex_state = 2},
  [3838] = {.lex_state = 19, .external_lex_state = 2},
  [3839] = {.lex_state = 50, .external_lex_state = 2},
  [3840] = {.lex_state = 19, .external_lex_state = 2},
  [3841] = {.lex_state = 19, .external_lex_state = 2},
  [3842] = {.lex_state = 19, .external_lex_state = 2},
  [3843] = {.lex_state = 19, .external_lex_state = 2},
  [3844] = {.lex_state = 19, .external_lex_state = 2},
  [3845] = {.lex_state = 19, .external_lex_state = 2},
  [3846] = {.lex_state = 19, .external_lex_state = 2},
  [3847] = {.lex_state = 19, .external_lex_state = 2},
  [3848] = {.lex_state = 19, .external_lex_state = 2},
  [3849] = {.lex_state = 19, .external_lex_state = 2},
  [3850] = {.lex_state = 19, .external_lex_state = 2},
  [3851] = {.lex_state = 50, .external_lex_state = 2},
  [3852] = {.lex_state = 19, .external_lex_state = 2},
  [3853] = {.lex_state = 19, .external_lex_state = 2},
  [3854] = {.lex_state = 19, .external_lex_state = 2},
  [3855] = {.lex_state = 19, .external_lex_state = 2},
  [3856] = {.lex_state = 19, .external_lex_state = 2},
  [3857] = {.lex_state = 19, .external_lex_state = 2},
  [3858] = {.lex_state = 19, .external_lex_state = 2},
  [3859] = {.lex_state = 15, .external_lex_state = 2},
  [3860] = {.lex_state = 15, .external_lex_state = 2},
  [3861] = {.lex_state = 15, .external_lex_state = 2},
  [3862] = {.lex_state = 15, .external_lex_state = 2},
  [3863] = {.lex_state = 15, .external_lex_state = 2},
  [3864] = {.lex_state = 15, .external_lex_state = 2},
  [3865] = {.lex_state = 15, .external_lex_state = 2},
  [3866] = {.lex_state = 15, .external_lex_state = 2},
  [3867] = {.lex_state = 15, .external_lex_state = 2},
  [3868] = {.lex_state = 15, .external_lex_state = 2},
  [3869] = {.lex_state = 15, .external_lex_state = 2},
  [3870] = {.lex_state = 15, .external_lex_state = 2},
  [3871] = {.lex_state = 15, .external_lex_state = 2},
  [3872] = {.lex_state = 15, .external_lex_state = 2},
  [3873] = {.lex_state = 15, .external_lex_state = 2},
  [3874] = {.lex_state = 15, .external_lex_state = 2},
  [3875] = {.lex_state = 15, .external_lex_state = 2},
  [3876] = {.lex_state = 15, .external_lex_state = 2},
  [3877] = {.lex_state = 50, .external_lex_state = 2},
  [3878] = {.lex_state = 15, .external_lex_state = 2},
  [3879] = {.lex_state = 15, .external_lex_state = 2},
  [3880] = {.lex_state = 15, .external_lex_state = 2},
  [3881] = {.lex_state = 15, .external_lex_state = 2},
  [3882] = {.lex_state = 15, .external_lex_state = 2},
  [3883] = {.lex_state = 50, .external_lex_state = 2},
  [3884] = {.lex_state = 50, .external_lex_state = 2},
  [3885] = {.lex_state = 50, .external_lex_state = 2},
  [3886] = {.lex_state = 19, .external_lex_state = 2},
  [3887] = {.lex_state = 15, .external_lex_state = 2},
  [3888] = {.lex_state = 14, .external_lex_state = 2},
  [3889] = {.lex_state = 50, .external_lex_state = 2},
  [3890] = {.lex_state = 19, .external_lex_state = 2},
  [3891] = {.lex_state = 50, .external_lex_state = 2},
  [3892] = {.lex_state = 14, .external_lex_state = 2},
  [3893] = {.lex_state = 50, .external_lex_state = 2},
  [3894] = {.lex_state = 14, .external_lex_state = 2},
  [3895] = {.lex_state = 19, .external_lex_state = 2},
  [3896] = {.lex_state = 50, .external_lex_state = 2},
  [3897] = {.lex_state = 22, .external_lex_state = 2},
  [3898] = {.lex_state = 22, .external_lex_state = 2},
  [3899] = {.lex_state = 22, .external_lex_state = 2},
  [3900] = {.lex_state = 22, .external_lex_state = 2},
  [3901] = {.lex_state = 22, .external_lex_state = 2},
  [3902] = {.lex_state = 22, .external_lex_state = 2},
  [3903] = {.lex_state = 22, .external_lex_state = 2},
  [3904] = {.lex_state = 22, .external_lex_state = 2},
  [3905] = {.lex_state = 22, .external_lex_state = 2},
  [3906] = {.lex_state = 22, .external_lex_state = 2},
  [3907] = {.lex_state = 22, .external_lex_state = 2},
  [3908] = {.lex_state = 22, .external_lex_state = 2},
  [3909] = {.lex_state = 22, .external_lex_state = 2},
  [3910] = {.lex_state = 50, .external_lex_state = 2},
  [3911] = {.lex_state = 50, .external_lex_state = 2},
  [3912] = {.lex_state = 22, .external_lex_state = 2},
  [3913] = {.lex_state = 22, .external_lex_state = 2},
  [3914] = {.lex_state = 22, .external_lex_state = 2},
  [3915] = {.lex_state = 22, .external_lex_state = 2},
  [3916] = {.lex_state = 22, .external_lex_state = 2},
  [3917] = {.lex_state = 22, .external_lex_state = 2},
  [3918] = {.lex_state = 50, .external_lex_state = 2},
  [3919] = {.lex_state = 50, .external_lex_state = 2},
  [3920] = {.lex_state = 50, .external_lex_state = 2},
  [3921] = {.lex_state = 50, .external_lex_state = 2},
  [3922] = {.lex_state = 22, .external_lex_state = 2},
  [3923] = {.lex_state = 22, .external_lex_state = 2},
  [3924] = {.lex_state = 22, .external_lex_state = 2},
  [3925] = {.lex_state = 22, .external_lex_state = 2},
  [3926] = {.lex_state = 50, .external_lex_state = 2},
  [3927] = {.lex_state = 22, .external_lex_state = 2},
  [3928] = {.lex_state = 22, .external_lex_state = 2},
  [3929] = {.lex_state = 22, .external_lex_state = 2},
  [3930] = {.lex_state = 22, .external_lex_state = 2},
  [3931] = {.lex_state = 50, .external_lex_state = 2},
  [3932] = {.lex_state = 50, .external_lex_state = 2},
  [3933] = {.lex_state = 50, .external_lex_state = 2},
  [3934] = {.lex_state = 14, .external_lex_state = 2},
  [3935] = {.lex_state = 15, .external_lex_state = 2},
  [3936] = {.lex_state = 50, .external_lex_state = 2},
  [3937] = {.lex_state = 50, .external_lex_state = 2},
  [3938] = {.lex_state = 15, .external_lex_state = 2},
  [3939] = {.lex_state = 15, .external_lex_state = 2},
  [3940] = {.lex_state = 15, .external_lex_state = 2},
  [3941] = {.lex_state = 15, .external_lex_state = 2},
  [3942] = {.lex_state = 15, .external_lex_state = 2},
  [3943] = {.lex_state = 15, .external_lex_state = 2},
  [3944] = {.lex_state = 15, .external_lex_state = 2},
  [3945] = {.lex_state = 50, .external_lex_state = 2},
  [3946] = {.lex_state = 15, .external_lex_state = 2},
  [3947] = {.lex_state = 15, .external_lex_state = 2},
  [3948] = {.lex_state = 15, .external_lex_state = 2},
  [3949] = {.lex_state = 15, .external_lex_state = 2},
  [3950] = {.lex_state = 15, .external_lex_state = 2},
  [3951] = {.lex_state = 50, .external_lex_state = 2},
  [3952] = {.lex_state = 22, .external_lex_state = 2},
  [3953] = {.lex_state = 22, .external_lex_state = 2},
  [3954] = {.lex_state = 0, .external_lex_state = 2},
  [3955] = {.lex_state = 15, .external_lex_state = 2},
  [3956] = {.lex_state = 0, .external_lex_state = 2},
  [3957] = {.lex_state = 0, .external_lex_state = 2},
  [3958] = {.lex_state = 0, .external_lex_state = 2},
  [3959] = {.lex_state = 0, .external_lex_state = 2},
  [3960] = {.lex_state = 0, .external_lex_state = 2},
  [3961] = {.lex_state = 0, .external_lex_state = 2},
  [3962] = {.lex_state = 0, .external_lex_state = 2},
  [3963] = {.lex_state = 0, .external_lex_state = 2},
  [3964] = {.lex_state = 0, .external_lex_state = 2},
  [3965] = {.lex_state = 15, .external_lex_state = 2},
  [3966] = {.lex_state = 15, .external_lex_state = 2},
  [3967] = {.lex_state = 15, .external_lex_state = 2},
  [3968] = {.lex_state = 0, .external_lex_state = 2},
  [3969] = {.lex_state = 0, .external_lex_state = 2},
  [3970] = {.lex_state = 15, .external_lex_state = 2},
  [3971] = {.lex_state = 15, .external_lex_state = 2},
  [3972] = {.lex_state = 15, .external_lex_state = 2},
  [3973] = {.lex_state = 15, .external_lex_state = 2},
  [3974] = {.lex_state = 0, .external_lex_state = 2},
  [3975] = {.lex_state = 50, .external_lex_state = 2},
  [3976] = {.lex_state = 50, .external_lex_state = 2},
  [3977] = {.lex_state = 50, .external_lex_state = 2},
  [3978] = {.lex_state = 15, .external_lex_state = 2},
  [3979] = {.lex_state = 50, .external_lex_state = 2},
  [3980] = {.lex_state = 50, .external_lex_state = 2},
  [3981] = {.lex_state = 50, .external_lex_state = 2},
  [3982] = {.lex_state = 50, .external_lex_state = 2},
  [3983] = {.lex_state = 50, .external_lex_state = 2},
  [3984] = {.lex_state = 50, .external_lex_state = 2},
  [3985] = {.lex_state = 50, .external_lex_state = 2},
  [3986] = {.lex_state = 50, .external_lex_state = 2},
  [3987] = {.lex_state = 50, .external_lex_state = 2},
  [3988] = {.lex_state = 50, .external_lex_state = 2},
  [3989] = {.lex_state = 50, .external_lex_state = 2},
  [3990] = {.lex_state = 50, .external_lex_state = 2},
  [3991] = {.lex_state = 50, .external_lex_state = 2},
  [3992] = {.lex_state = 50, .external_lex_state = 2},
  [3993] = {.lex_state = 50, .external_lex_state = 2},
  [3994] = {.lex_state = 50, .external_lex_state = 2},
  [3995] = {.lex_state = 50, .external_lex_state = 2},
  [3996] = {.lex_state = 50, .external_lex_state = 2},
  [3997] = {.lex_state = 50, .external_lex_state = 2},
  [3998] = {.lex_state = 50, .external_lex_state = 2},
  [3999] = {.lex_state = 50, .external_lex_state = 2},
  [4000] = {.lex_state = 26, .external_lex_state = 2},
  [4001] = {.lex_state = 50, .external_lex_state = 2},
  [4002] = {.lex_state = 50, .external_lex_state = 2},
  [4003] = {.lex_state = 50, .external_lex_state = 2},
  [4004] = {.lex_state = 50, .external_lex_state = 2},
  [4005] = {.lex_state = 50, .external_lex_state = 2},
  [4006] = {.lex_state = 50, .external_lex_state = 2},
  [4007] = {.lex_state = 50, .external_lex_state = 2},
  [4008] = {.lex_state = 50, .external_lex_state = 2},
  [4009] = {.lex_state = 50, .external_lex_state = 2},
  [4010] = {.lex_state = 50, .external_lex_state = 2},
  [4011] = {.lex_state = 50, .external_lex_state = 2},
  [4012] = {.lex_state = 50, .external_lex_state = 2},
  [4013] = {.lex_state = 50, .external_lex_state = 2},
  [4014] = {.lex_state = 15, .external_lex_state = 2},
  [4015] = {.lex_state = 50, .external_lex_state = 2},
  [4016] = {.lex_state = 50, .external_lex_state = 2},
  [4017] = {.lex_state = 50, .external_lex_state = 2},
  [4018] = {.lex_state = 50, .external_lex_state = 2},
  [4019] = {.lex_state = 50, .external_lex_state = 2},
  [4020] = {.lex_state = 50, .external_lex_state = 2},
  [4021] = {.lex_state = 50, .external_lex_state = 2},
  [4022] = {.lex_state = 50, .external_lex_state = 2},
  [4023] = {.lex_state = 50, .external_lex_state = 2},
  [4024] = {.lex_state = 50, .external_lex_state = 2},
  [4025] = {.lex_state = 50, .external_lex_state = 2},
  [4026] = {.lex_state = 50, .external_lex_state = 2},
  [4027] = {.lex_state = 50, .external_lex_state = 2},
  [4028] = {.lex_state = 15, .external_lex_state = 2},
  [4029] = {.lex_state = 50, .external_lex_state = 2},
  [4030] = {.lex_state = 15, .external_lex_state = 2},
  [4031] = {.lex_state = 50, .external_lex_state = 2},
  [4032] = {.lex_state = 50, .external_lex_state = 2},
  [4033] = {.lex_state = 50, .external_lex_state = 2},
  [4034] = {.lex_state = 50, .external_lex_state = 2},
  [4035] = {.lex_state = 50, .external_lex_state = 2},
  [4036] = {.lex_state = 50, .external_lex_state = 2},
  [4037] = {.lex_state = 50, .external_lex_state = 2},
  [4038] = {.lex_state = 50, .external_lex_state = 2},
  [4039] = {.lex_state = 15, .external_lex_state = 2},
  [4040] = {.lex_state = 50, .external_lex_state = 2},
  [4041] = {.lex_state = 50, .external_lex_state = 2},
  [4042] = {.lex_state = 15, .external_lex_state = 2},
  [4043] = {.lex_state = 50, .external_lex_state = 2},
  [4044] = {.lex_state = 50, .external_lex_state = 2},
  [4045] = {.lex_state = 50, .external_lex_state = 2},
  [4046] = {.lex_state = 50, .external_lex_state = 2},
  [4047] = {.lex_state = 50, .external_lex_state = 2},
  [4048] = {.lex_state = 50, .external_lex_state = 2},
  [4049] = {.lex_state = 50, .external_lex_state = 2},
  [4050] = {.lex_state = 50, .external_lex_state = 2},
  [4051] = {.lex_state = 50, .external_lex_state = 2},
  [4052] = {.lex_state = 50, .external_lex_state = 2},
  [4053] = {.lex_state = 50, .external_lex_state = 2},
  [4054] = {.lex_state = 50, .external_lex_state = 2},
  [4055] = {.lex_state = 50, .external_lex_state = 2},
  [4056] = {.lex_state = 50, .external_lex_state = 2},
  [4057] = {.lex_state = 50, .external_lex_state = 2},
  [4058] = {.lex_state = 50, .external_lex_state = 2},
  [4059] = {.lex_state = 50, .external_lex_state = 2},
  [4060] = {.lex_state = 50, .external_lex_state = 2},
  [4061] = {.lex_state = 50, .external_lex_state = 2},
  [4062] = {.lex_state = 50, .external_lex_state = 2},
  [4063] = {.lex_state = 50, .external_lex_state = 2},
  [4064] = {.lex_state = 50, .external_lex_state = 2},
  [4065] = {.lex_state = 50, .external_lex_state = 2},
  [4066] = {.lex_state = 50, .external_lex_state = 2},
  [4067] = {.lex_state = 50, .external_lex_state = 2},
  [4068] = {.lex_state = 50, .external_lex_state = 2},
  [4069] = {.lex_state = 50, .external_lex_state = 2},
  [4070] = {.lex_state = 50, .external_lex_state = 2},
  [4071] = {.lex_state = 50, .external_lex_state = 2},
  [4072] = {.lex_state = 50, .external_lex_state = 2},
  [4073] = {.lex_state = 50, .external_lex_state = 2},
  [4074] = {.lex_state = 50, .external_lex_state = 2},
  [4075] = {.lex_state = 50, .external_lex_state = 2},
  [4076] = {.lex_state = 50, .external_lex_state = 2},
  [4077] = {.lex_state = 50, .external_lex_state = 2},
  [4078] = {.lex_state = 50, .external_lex_state = 2},
  [4079] = {.lex_state = 50, .external_lex_state = 2},
  [4080] = {.lex_state = 50, .external_lex_state = 2},
  [4081] = {.lex_state = 50, .external_lex_state = 2},
  [4082] = {.lex_state = 50, .external_lex_state = 2},
  [4083] = {.lex_state = 50, .external_lex_state = 2},
  [4084] = {.lex_state = 50, .external_lex_state = 2},
  [4085] = {.lex_state = 50, .external_lex_state = 2},
  [4086] = {.lex_state = 50, .external_lex_state = 2},
  [4087] = {.lex_state = 50, .external_lex_state = 2},
  [4088] = {.lex_state = 50, .external_lex_state = 2},
  [4089] = {.lex_state = 50, .external_lex_state = 2},
  [4090] = {.lex_state = 50, .external_lex_state = 2},
  [4091] = {.lex_state = 50, .external_lex_state = 2},
  [4092] = {.lex_state = 50, .external_lex_state = 2},
  [4093] = {.lex_state = 50, .external_lex_state = 2},
  [4094] = {.lex_state = 50, .external_lex_state = 2},
  [4095] = {.lex_state = 50, .external_lex_state = 2},
  [4096] = {.lex_state = 50, .external_lex_state = 2},
  [4097] = {.lex_state = 50, .external_lex_state = 2},
  [4098] = {.lex_state = 50, .external_lex_state = 2},
  [4099] = {.lex_state = 50, .external_lex_state = 2},
  [4100] = {.lex_state = 50, .external_lex_state = 2},
  [4101] = {.lex_state = 50, .external_lex_state = 2},
  [4102] = {.lex_state = 50, .external_lex_state = 2},
  [4103] = {.lex_state = 50, .external_lex_state = 2},
  [4104] = {.lex_state = 50, .external_lex_state = 2},
  [4105] = {.lex_state = 50, .external_lex_state = 2},
  [4106] = {.lex_state = 50, .external_lex_state = 2},
  [4107] = {.lex_state = 50, .external_lex_state = 2},
  [4108] = {.lex_state = 50, .external_lex_state = 2},
  [4109] = {.lex_state = 50, .external_lex_state = 2},
  [4110] = {.lex_state = 50, .external_lex_state = 2},
  [4111] = {.lex_state = 50, .external_lex_state = 2},
  [4112] = {.lex_state = 14, .external_lex_state = 2},
  [4113] = {.lex_state = 50, .external_lex_state = 2},
  [4114] = {.lex_state = 50, .external_lex_state = 2},
  [4115] = {.lex_state = 50, .external_lex_state = 2},
  [4116] = {.lex_state = 14, .external_lex_state = 2},
  [4117] = {.lex_state = 50, .external_lex_state = 2},
  [4118] = {.lex_state = 50, .external_lex_state = 2},
  [4119] = {.lex_state = 50, .external_lex_state = 2},
  [4120] = {.lex_state = 50, .external_lex_state = 2},
  [4121] = {.lex_state = 50, .external_lex_state = 2},
  [4122] = {.lex_state = 50, .external_lex_state = 2},
  [4123] = {.lex_state = 50, .external_lex_state = 2},
  [4124] = {.lex_state = 50, .external_lex_state = 2},
  [4125] = {.lex_state = 50, .external_lex_state = 2},
  [4126] = {.lex_state = 50, .external_lex_state = 2},
  [4127] = {.lex_state = 50, .external_lex_state = 2},
  [4128] = {.lex_state = 50, .external_lex_state = 2},
  [4129] = {.lex_state = 50, .external_lex_state = 2},
  [4130] = {.lex_state = 50, .external_lex_state = 2},
  [4131] = {.lex_state = 50, .external_lex_state = 2},
  [4132] = {.lex_state = 50, .external_lex_state = 2},
  [4133] = {.lex_state = 50, .external_lex_state = 2},
  [4134] = {.lex_state = 50, .external_lex_state = 2},
  [4135] = {.lex_state = 50, .external_lex_state = 2},
  [4136] = {.lex_state = 50, .external_lex_state = 2},
  [4137] = {.lex_state = 50, .external_lex_state = 2},
  [4138] = {.lex_state = 50, .external_lex_state = 2},
  [4139] = {.lex_state = 50, .external_lex_state = 2},
  [4140] = {.lex_state = 50, .external_lex_state = 2},
  [4141] = {.lex_state = 50, .external_lex_state = 2},
  [4142] = {.lex_state = 50, .external_lex_state = 2},
  [4143] = {.lex_state = 50, .external_lex_state = 2},
  [4144] = {.lex_state = 50, .external_lex_state = 2},
  [4145] = {.lex_state = 50, .external_lex_state = 2},
  [4146] = {.lex_state = 50, .external_lex_state = 2},
  [4147] = {.lex_state = 50, .external_lex_state = 2},
  [4148] = {.lex_state = 50, .external_lex_state = 2},
  [4149] = {.lex_state = 50, .external_lex_state = 2},
  [4150] = {.lex_state = 50, .external_lex_state = 2},
  [4151] = {.lex_state = 50, .external_lex_state = 2},
  [4152] = {.lex_state = 50, .external_lex_state = 2},
  [4153] = {.lex_state = 50, .external_lex_state = 2},
  [4154] = {.lex_state = 50, .external_lex_state = 2},
  [4155] = {.lex_state = 50, .external_lex_state = 2},
  [4156] = {.lex_state = 14, .external_lex_state = 2},
  [4157] = {.lex_state = 50, .external_lex_state = 2},
  [4158] = {.lex_state = 50, .external_lex_state = 2},
  [4159] = {.lex_state = 50, .external_lex_state = 2},
  [4160] = {.lex_state = 50, .external_lex_state = 2},
  [4161] = {.lex_state = 50, .external_lex_state = 2},
  [4162] = {.lex_state = 50, .external_lex_state = 2},
  [4163] = {.lex_state = 50, .external_lex_state = 2},
  [4164] = {.lex_state = 50, .external_lex_state = 2},
  [4165] = {.lex_state = 14, .external_lex_state = 2},
  [4166] = {.lex_state = 50, .external_lex_state = 2},
  [4167] = {.lex_state = 50, .external_lex_state = 2},
  [4168] = {.lex_state = 50, .external_lex_state = 2},
  [4169] = {.lex_state = 14, .external_lex_state = 2},
  [4170] = {.lex_state = 50, .external_lex_state = 2},
  [4171] = {.lex_state = 50, .external_lex_state = 2},
  [4172] = {.lex_state = 14, .external_lex_state = 2},
  [4173] = {.lex_state = 50, .external_lex_state = 2},
  [4174] = {.lex_state = 50, .external_lex_state = 2},
  [4175] = {.lex_state = 50, .external_lex_state = 2},
  [4176] = {.lex_state = 14, .external_lex_state = 2},
  [4177] = {.lex_state = 50, .external_lex_state = 2},
  [4178] = {.lex_state = 50, .external_lex_state = 2},
  [4179] = {.lex_state = 50, .external_lex_state = 2},
  [4180] = {.lex_state = 50, .external_lex_state = 2},
  [4181] = {.lex_state = 50, .external_lex_state = 2},
  [4182] = {.lex_state = 50, .external_lex_state = 2},
  [4183] = {.lex_state = 50, .external_lex_state = 2},
  [4184] = {.lex_state = 50, .external_lex_state = 2},
  [4185] = {.lex_state = 50, .external_lex_state = 2},
  [4186] = {.lex_state = 50, .external_lex_state = 2},
  [4187] = {.lex_state = 50, .external_lex_state = 2},
  [4188] = {.lex_state = 50, .external_lex_state = 2},
  [4189] = {.lex_state = 50, .external_lex_state = 2},
  [4190] = {.lex_state = 50, .external_lex_state = 2},
  [4191] = {.lex_state = 14, .external_lex_state = 2},
  [4192] = {.lex_state = 50, .external_lex_state = 2},
  [4193] = {.lex_state = 50, .external_lex_state = 2},
  [4194] = {.lex_state = 50, .external_lex_state = 2},
  [4195] = {.lex_state = 50, .external_lex_state = 2},
  [4196] = {.lex_state = 50, .external_lex_state = 2},
  [4197] = {.lex_state = 50, .external_lex_state = 2},
  [4198] = {.lex_state = 50, .external_lex_state = 2},
  [4199] = {.lex_state = 50, .external_lex_state = 2},
  [4200] = {.lex_state = 50, .external_lex_state = 2},
  [4201] = {.lex_state = 50, .external_lex_state = 2},
  [4202] = {.lex_state = 50, .external_lex_state = 2},
  [4203] = {.lex_state = 50, .external_lex_state = 2},
  [4204] = {.lex_state = 50, .external_lex_state = 2},
  [4205] = {.lex_state = 50, .external_lex_state = 2},
  [4206] = {.lex_state = 50, .external_lex_state = 2},
  [4207] = {.lex_state = 50, .external_lex_state = 2},
  [4208] = {.lex_state = 50, .external_lex_state = 2},
  [4209] = {.lex_state = 50, .external_lex_state = 2},
  [4210] = {.lex_state = 50, .external_lex_state = 2},
  [4211] = {.lex_state = 50, .external_lex_state = 2},
  [4212] = {.lex_state = 50, .external_lex_state = 2},
  [4213] = {.lex_state = 50, .external_lex_state = 2},
  [4214] = {.lex_state = 50, .external_lex_state = 2},
  [4215] = {.lex_state = 50, .external_lex_state = 2},
  [4216] = {.lex_state = 50, .external_lex_state = 2},
  [4217] = {.lex_state = 50, .external_lex_state = 2},
  [4218] = {.lex_state = 50, .external_lex_state = 2},
  [4219] = {.lex_state = 50, .external_lex_state = 2},
  [4220] = {.lex_state = 50, .external_lex_state = 2},
  [4221] = {.lex_state = 50, .external_lex_state = 2},
  [4222] = {.lex_state = 50, .external_lex_state = 2},
  [4223] = {.lex_state = 50, .external_lex_state = 2},
  [4224] = {.lex_state = 50, .external_lex_state = 2},
  [4225] = {.lex_state = 15, .external_lex_state = 2},
  [4226] = {.lex_state = 14, .external_lex_state = 2},
  [4227] = {.lex_state = 50, .external_lex_state = 2},
  [4228] = {.lex_state = 14, .external_lex_state = 2},
  [4229] = {.lex_state = 50, .external_lex_state = 2},
  [4230] = {.lex_state = 14, .external_lex_state = 2},
  [4231] = {.lex_state = 50, .external_lex_state = 2},
  [4232] = {.lex_state = 50, .external_lex_state = 2},
  [4233] = {.lex_state = 50, .external_lex_state = 2},
  [4234] = {.lex_state = 14, .external_lex_state = 2},
  [4235] = {.lex_state = 50, .external_lex_state = 2},
  [4236] = {.lex_state = 50, .external_lex_state = 2},
  [4237] = {.lex_state = 50, .external_lex_state = 2},
  [4238] = {.lex_state = 50, .external_lex_state = 2},
  [4239] = {.lex_state = 50, .external_lex_state = 2},
  [4240] = {.lex_state = 15, .external_lex_state = 2},
  [4241] = {.lex_state = 14, .external_lex_state = 2},
  [4242] = {.lex_state = 50, .external_lex_state = 2},
  [4243] = {.lex_state = 50, .external_lex_state = 2},
  [4244] = {.lex_state = 15, .external_lex_state = 2},
  [4245] = {.lex_state = 50, .external_lex_state = 2},
  [4246] = {.lex_state = 50, .external_lex_state = 2},
  [4247] = {.lex_state = 50, .external_lex_state = 2},
  [4248] = {.lex_state = 14, .external_lex_state = 2},
  [4249] = {.lex_state = 14, .external_lex_state = 2},
  [4250] = {.lex_state = 50, .external_lex_state = 2},
  [4251] = {.lex_state = 50, .external_lex_state = 2},
  [4252] = {.lex_state = 50, .external_lex_state = 2},
  [4253] = {.lex_state = 14, .external_lex_state = 2},
  [4254] = {.lex_state = 15, .external_lex_state = 2},
  [4255] = {.lex_state = 14, .external_lex_state = 2},
  [4256] = {.lex_state = 15, .external_lex_state = 2},
  [4257] = {.lex_state = 15, .external_lex_state = 2},
  [4258] = {.lex_state = 14, .external_lex_state = 2},
  [4259] = {.lex_state = 50, .external_lex_state = 2},
  [4260] = {.lex_state = 14, .external_lex_state = 2},
  [4261] = {.lex_state = 15, .external_lex_state = 2},
  [4262] = {.lex_state = 50, .external_lex_state = 2},
  [4263] = {.lex_state = 50, .external_lex_state = 2},
  [4264] = {.lex_state = 15, .external_lex_state = 2},
  [4265] = {.lex_state = 50, .external_lex_state = 2},
  [4266] = {.lex_state = 14, .external_lex_state = 2},
  [4267] = {.lex_state = 50, .external_lex_state = 2},
  [4268] = {.lex_state = 14, .external_lex_state = 2},
  [4269] = {.lex_state = 15, .external_lex_state = 2},
  [4270] = {.lex_state = 50, .external_lex_state = 2},
  [4271] = {.lex_state = 14, .external_lex_state = 2},
  [4272] = {.lex_state = 14, .external_lex_state = 2},
  [4273] = {.lex_state = 15, .external_lex_state = 2},
  [4274] = {.lex_state = 15, .external_lex_state = 2},
  [4275] = {.lex_state = 15, .external_lex_state = 2},
  [4276] = {.lex_state = 14, .external_lex_state = 2},
  [4277] = {.lex_state = 50, .external_lex_state = 2},
  [4278] = {.lex_state = 14, .external_lex_state = 2},
  [4279] = {.lex_state = 15, .external_lex_state = 2},
  [4280] = {.lex_state = 50, .external_lex_state = 2},
  [4281] = {.lex_state = 50, .external_lex_state = 2},
  [4282] = {.lex_state = 15, .external_lex_state = 2},
  [4283] = {.lex_state = 50, .external_lex_state = 2},
  [4284] = {.lex_state = 50, .external_lex_state = 2},
  [4285] = {.lex_state = 15, .external_lex_state = 2},
  [4286] = {.lex_state = 14, .external_lex_state = 2},
  [4287] = {.lex_state = 50, .external_lex_state = 2},
  [4288] = {.lex_state = 50, .external_lex_state = 2},
  [4289] = {.lex_state = 14, .external_lex_state = 2},
  [4290] = {.lex_state = 14, .external_lex_state = 2},
  [4291] = {.lex_state = 14, .external_lex_state = 2},
  [4292] = {.lex_state = 14, .external_lex_state = 2},
  [4293] = {.lex_state = 50, .external_lex_state = 2},
  [4294] = {.lex_state = 14, .external_lex_state = 2},
  [4295] = {.lex_state = 14, .external_lex_state = 2},
  [4296] = {.lex_state = 50, .external_lex_state = 2},
  [4297] = {.lex_state = 50, .external_lex_state = 2},
  [4298] = {.lex_state = 14, .external_lex_state = 2},
  [4299] = {.lex_state = 50, .external_lex_state = 2},
  [4300] = {.lex_state = 14, .external_lex_state = 2},
  [4301] = {.lex_state = 50, .external_lex_state = 2},
  [4302] = {.lex_state = 50, .external_lex_state = 2},
  [4303] = {.lex_state = 14, .external_lex_state = 2},
  [4304] = {.lex_state = 50, .external_lex_state = 2},
  [4305] = {.lex_state = 14, .external_lex_state = 2},
  [4306] = {.lex_state = 14, .external_lex_state = 2},
  [4307] = {.lex_state = 50, .external_lex_state = 2},
  [4308] = {.lex_state = 50, .external_lex_state = 2},
  [4309] = {.lex_state = 9, .external_lex_state = 2},
  [4310] = {.lex_state = 9, .external_lex_state = 2},
  [4311] = {.lex_state = 9, .external_lex_state = 2},
  [4312] = {.lex_state = 50, .external_lex_state = 2},
  [4313] = {.lex_state = 50, .external_lex_state = 2},
  [4314] = {.lex_state = 50, .external_lex_state = 2},
  [4315] = {.lex_state = 9, .external_lex_state = 2},
  [4316] = {.lex_state = 50, .external_lex_state = 2},
  [4317] = {.lex_state = 14, .external_lex_state = 2},
  [4318] = {.lex_state = 14, .external_lex_state = 2},
  [4319] = {.lex_state = 9, .external_lex_state = 2},
  [4320] = {.lex_state = 9, .external_lex_state = 2},
  [4321] = {.lex_state = 9, .external_lex_state = 2},
  [4322] = {.lex_state = 9, .external_lex_state = 2},
  [4323] = {.lex_state = 9, .external_lex_state = 2},
  [4324] = {.lex_state = 9, .external_lex_state = 2},
  [4325] = {.lex_state = 50, .external_lex_state = 2},
  [4326] = {.lex_state = 50, .external_lex_state = 2},
  [4327] = {.lex_state = 9, .external_lex_state = 2},
  [4328] = {.lex_state = 9, .external_lex_state = 2},
  [4329] = {.lex_state = 9, .external_lex_state = 2},
  [4330] = {.lex_state = 9, .external_lex_state = 2},
  [4331] = {.lex_state = 50, .external_lex_state = 2},
  [4332] = {.lex_state = 9, .external_lex_state = 2},
  [4333] = {.lex_state = 9, .external_lex_state = 2},
  [4334] = {.lex_state = 9, .external_lex_state = 2},
  [4335] = {.lex_state = 50, .external_lex_state = 2},
  [4336] = {.lex_state = 9, .external_lex_state = 2},
  [4337] = {.lex_state = 9, .external_lex_state = 2},
  [4338] = {.lex_state = 50, .external_lex_state = 2},
  [4339] = {.lex_state = 9, .external_lex_state = 2},
  [4340] = {.lex_state = 9, .external_lex_state = 2},
  [4341] = {.lex_state = 50, .external_lex_state = 2},
  [4342] = {.lex_state = 14, .external_lex_state = 2},
  [4343] = {.lex_state = 9, .external_lex_state = 2},
  [4344] = {.lex_state = 14, .external_lex_state = 2},
  [4345] = {.lex_state = 9, .external_lex_state = 2},
  [4346] = {.lex_state = 50, .external_lex_state = 2},
  [4347] = {.lex_state = 15, .external_lex_state = 2},
  [4348] = {.lex_state = 50, .external_lex_state = 2},
  [4349] = {.lex_state = 15, .external_lex_state = 2},
  [4350] = {.lex_state = 50, .external_lex_state = 2},
  [4351] = {.lex_state = 50, .external_lex_state = 2},
  [4352] = {.lex_state = 9, .external_lex_state = 2},
  [4353] = {.lex_state = 9, .external_lex_state = 2},
  [4354] = {.lex_state = 9, .external_lex_state = 2},
  [4355] = {.lex_state = 9, .external_lex_state = 2},
  [4356] = {.lex_state = 9, .external_lex_state = 2},
  [4357] = {.lex_state = 50, .external_lex_state = 2},
  [4358] = {.lex_state = 9, .external_lex_state = 2},
  [4359] = {.lex_state = 9, .external_lex_state = 2},
  [4360] = {.lex_state = 15, .external_lex_state = 2},
  [4361] = {.lex_state = 50, .external_lex_state = 2},
  [4362] = {.lex_state = 14, .external_lex_state = 2},
  [4363] = {.lex_state = 9, .external_lex_state = 2},
  [4364] = {.lex_state = 9, .external_lex_state = 2},
  [4365] = {.lex_state = 9, .external_lex_state = 2},
  [4366] = {.lex_state = 9, .external_lex_state = 2},
  [4367] = {.lex_state = 9, .external_lex_state = 2},
  [4368] = {.lex_state = 50, .external_lex_state = 2},
  [4369] = {.lex_state = 50, .external_lex_state = 2},
  [4370] = {.lex_state = 50, .external_lex_state = 2},
  [4371] = {.lex_state = 50, .external_lex_state = 2},
  [4372] = {.lex_state = 50, .external_lex_state = 2},
  [4373] = {.lex_state = 50, .external_lex_state = 2},
  [4374] = {.lex_state = 9, .external_lex_state = 2},
  [4375] = {.lex_state = 50, .external_lex_state = 2},
  [4376] = {.lex_state = 50, .external_lex_state = 2},
  [4377] = {.lex_state = 50, .external_lex_state = 2},
  [4378] = {.lex_state = 50, .external_lex_state = 2},
  [4379] = {.lex_state = 50, .external_lex_state = 2},
  [4380] = {.lex_state = 50, .external_lex_state = 2},
  [4381] = {.lex_state = 50, .external_lex_state = 2},
  [4382] = {.lex_state = 50, .external_lex_state = 2},
  [4383] = {.lex_state = 50, .external_lex_state = 2},
  [4384] = {.lex_state = 50, .external_lex_state = 2},
  [4385] = {.lex_state = 50, .external_lex_state = 2},
  [4386] = {.lex_state = 50, .external_lex_state = 2},
  [4387] = {.lex_state = 50, .external_lex_state = 2},
  [4388] = {.lex_state = 50, .external_lex_state = 2},
  [4389] = {.lex_state = 50, .external_lex_state = 2},
  [4390] = {.lex_state = 50, .external_lex_state = 2},
  [4391] = {.lex_state = 50, .external_lex_state = 2},
  [4392] = {.lex_state = 50, .external_lex_state = 2},
  [4393] = {.lex_state = 50, .external_lex_state = 2},
  [4394] = {.lex_state = 50, .external_lex_state = 2},
  [4395] = {.lex_state = 50, .external_lex_state = 2},
  [4396] = {.lex_state = 50, .external_lex_state = 2},
  [4397] = {.lex_state = 50, .external_lex_state = 2},
  [4398] = {.lex_state = 50, .external_lex_state = 2},
  [4399] = {.lex_state = 50, .external_lex_state = 2},
  [4400] = {.lex_state = 50, .external_lex_state = 2},
  [4401] = {.lex_state = 50, .external_lex_state = 2},
  [4402] = {.lex_state = 50, .external_lex_state = 2},
  [4403] = {.lex_state = 50, .external_lex_state = 2},
  [4404] = {.lex_state = 50, .external_lex_state = 2},
  [4405] = {.lex_state = 50, .external_lex_state = 2},
  [4406] = {.lex_state = 50, .external_lex_state = 2},
  [4407] = {.lex_state = 50, .external_lex_state = 2},
  [4408] = {.lex_state = 50, .external_lex_state = 2},
  [4409] = {.lex_state = 24, .external_lex_state = 2},
  [4410] = {.lex_state = 24, .external_lex_state = 2},
  [4411] = {.lex_state = 24, .external_lex_state = 2},
  [4412] = {.lex_state = 50, .external_lex_state = 2},
  [4413] = {.lex_state = 50, .external_lex_state = 2},
  [4414] = {.lex_state = 24, .external_lex_state = 2},
  [4415] = {.lex_state = 24, .external_lex_state = 2},
  [4416] = {.lex_state = 50, .external_lex_state = 2},
  [4417] = {.lex_state = 24, .external_lex_state = 2},
  [4418] = {.lex_state = 50, .external_lex_state = 2},
  [4419] = {.lex_state = 50, .external_lex_state = 2},
  [4420] = {.lex_state = 24, .external_lex_state = 2},
  [4421] = {.lex_state = 50, .external_lex_state = 2},
  [4422] = {.lex_state = 50, .external_lex_state = 2},
  [4423] = {.lex_state = 24, .external_lex_state = 2},
  [4424] = {.lex_state = 50, .external_lex_state = 2},
  [4425] = {.lex_state = 24, .external_lex_state = 2},
  [4426] = {.lex_state = 50, .external_lex_state = 2},
  [4427] = {.lex_state = 50, .external_lex_state = 2},
  [4428] = {.lex_state = 24, .external_lex_state = 2},
  [4429] = {.lex_state = 24, .external_lex_state = 2},
  [4430] = {.lex_state = 24, .external_lex_state = 2},
  [4431] = {.lex_state = 24, .external_lex_state = 2},
  [4432] = {.lex_state = 12, .external_lex_state = 2},
  [4433] = {.lex_state = 12, .external_lex_state = 2},
  [4434] = {.lex_state = 50, .external_lex_state = 2},
  [4435] = {.lex_state = 24, .external_lex_state = 2},
  [4436] = {.lex_state = 24, .external_lex_state = 2},
  [4437] = {.lex_state = 15, .external_lex_state = 2},
  [4438] = {.lex_state = 50, .external_lex_state = 2},
  [4439] = {.lex_state = 24, .external_lex_state = 2},
  [4440] = {.lex_state = 12, .external_lex_state = 2},
  [4441] = {.lex_state = 12, .external_lex_state = 2},
  [4442] = {.lex_state = 24, .external_lex_state = 2},
  [4443] = {.lex_state = 12, .external_lex_state = 2},
  [4444] = {.lex_state = 24, .external_lex_state = 2},
  [4445] = {.lex_state = 50, .external_lex_state = 2},
  [4446] = {.lex_state = 24, .external_lex_state = 2},
  [4447] = {.lex_state = 24, .external_lex_state = 2},
  [4448] = {.lex_state = 24, .external_lex_state = 2},
  [4449] = {.lex_state = 12, .external_lex_state = 2},
  [4450] = {.lex_state = 50, .external_lex_state = 2},
  [4451] = {.lex_state = 50, .external_lex_state = 2},
  [4452] = {.lex_state = 50, .external_lex_state = 2},
  [4453] = {.lex_state = 24, .external_lex_state = 2},
  [4454] = {.lex_state = 50, .external_lex_state = 2},
  [4455] = {.lex_state = 24, .external_lex_state = 2},
  [4456] = {.lex_state = 50, .external_lex_state = 2},
  [4457] = {.lex_state = 15, .external_lex_state = 2},
  [4458] = {.lex_state = 24, .external_lex_state = 2},
  [4459] = {.lex_state = 24, .external_lex_state = 2},
  [4460] = {.lex_state = 24, .external_lex_state = 2},
  [4461] = {.lex_state = 50, .external_lex_state = 2},
  [4462] = {.lex_state = 24, .external_lex_state = 2},
  [4463] = {.lex_state = 12, .external_lex_state = 2},
  [4464] = {.lex_state = 50, .external_lex_state = 2},
  [4465] = {.lex_state = 50, .external_lex_state = 2},
  [4466] = {.lex_state = 0, .external_lex_state = 2},
  [4467] = {.lex_state = 50, .external_lex_state = 2},
  [4468] = {.lex_state = 50, .external_lex_state = 2},
  [4469] = {.lex_state = 50, .external_lex_state = 2},
  [4470] = {.lex_state = 50, .external_lex_state = 2},
  [4471] = {.lex_state = 50, .external_lex_state = 2},
  [4472] = {.lex_state = 50, .external_lex_state = 2},
  [4473] = {.lex_state = 50, .external_lex_state = 2},
  [4474] = {.lex_state = 15, .external_lex_state = 2},
  [4475] = {.lex_state = 50, .external_lex_state = 2},
  [4476] = {.lex_state = 50, .external_lex_state = 2},
  [4477] = {.lex_state = 50, .external_lex_state = 2},
  [4478] = {.lex_state = 50, .external_lex_state = 2},
  [4479] = {.lex_state = 0, .external_lex_state = 2},
  [4480] = {.lex_state = 50, .external_lex_state = 2},
  [4481] = {.lex_state = 0, .external_lex_state = 2},
  [4482] = {.lex_state = 50, .external_lex_state = 2},
  [4483] = {.lex_state = 50, .external_lex_state = 2},
  [4484] = {.lex_state = 0, .external_lex_state = 2},
  [4485] = {.lex_state = 0, .external_lex_state = 2},
  [4486] = {.lex_state = 50, .external_lex_state = 2},
  [4487] = {.lex_state = 50, .external_lex_state = 2},
  [4488] = {.lex_state = 50, .external_lex_state = 2},
  [4489] = {.lex_state = 50, .external_lex_state = 2},
  [4490] = {.lex_state = 0, .external_lex_state = 2},
  [4491] = {.lex_state = 0, .external_lex_state = 2},
  [4492] = {.lex_state = 15, .external_lex_state = 2},
  [4493] = {.lex_state = 14, .external_lex_state = 2},
  [4494] = {.lex_state = 50, .external_lex_state = 2},
  [4495] = {.lex_state = 50, .external_lex_state = 2},
  [4496] = {.lex_state = 0, .external_lex_state = 2},
  [4497] = {.lex_state = 0, .external_lex_state = 2},
  [4498] = {.lex_state = 13, .external_lex_state = 2},
  [4499] = {.lex_state = 12, .external_lex_state = 2},
  [4500] = {.lex_state = 50, .external_lex_state = 2},
  [4501] = {.lex_state = 0, .external_lex_state = 2},
  [4502] = {.lex_state = 0, .external_lex_state = 2},
  [4503] = {.lex_state = 50, .external_lex_state = 2},
  [4504] = {.lex_state = 50, .external_lex_state = 2},
  [4505] = {.lex_state = 13, .external_lex_state = 2},
  [4506] = {.lex_state = 50, .external_lex_state = 2},
  [4507] = {.lex_state = 50, .external_lex_state = 2},
  [4508] = {.lex_state = 50, .external_lex_state = 2},
  [4509] = {.lex_state = 50, .external_lex_state = 2},
  [4510] = {.lex_state = 50, .external_lex_state = 2},
  [4511] = {.lex_state = 0, .external_lex_state = 2},
  [4512] = {.lex_state = 50, .external_lex_state = 2},
  [4513] = {.lex_state = 0, .external_lex_state = 2},
  [4514] = {.lex_state = 50, .external_lex_state = 2},
  [4515] = {.lex_state = 50, .external_lex_state = 2},
  [4516] = {.lex_state = 50, .external_lex_state = 2},
  [4517] = {.lex_state = 50, .external_lex_state = 2},
  [4518] = {.lex_state = 0, .external_lex_state = 2},
  [4519] = {.lex_state = 0, .external_lex_state = 2},
  [4520] = {.lex_state = 15, .external_lex_state = 2},
  [4521] = {.lex_state = 50, .external_lex_state = 2},
  [4522] = {.lex_state = 50, .external_lex_state = 2},
  [4523] = {.lex_state = 50, .external_lex_state = 2},
  [4524] = {.lex_state = 50, .external_lex_state = 2},
  [4525] = {.lex_state = 0, .external_lex_state = 2},
  [4526] = {.lex_state = 50, .external_lex_state = 2},
  [4527] = {.lex_state = 50, .external_lex_state = 2},
  [4528] = {.lex_state = 50, .external_lex_state = 2},
  [4529] = {.lex_state = 50, .external_lex_state = 2},
  [4530] = {.lex_state = 50, .external_lex_state = 2},
  [4531] = {.lex_state = 50, .external_lex_state = 2},
  [4532] = {.lex_state = 50, .external_lex_state = 2},
  [4533] = {.lex_state = 50, .external_lex_state = 2},
  [4534] = {.lex_state = 50, .external_lex_state = 2},
  [4535] = {.lex_state = 50, .external_lex_state = 2},
  [4536] = {.lex_state = 50, .external_lex_state = 2},
  [4537] = {.lex_state = 50, .external_lex_state = 2},
  [4538] = {.lex_state = 50, .external_lex_state = 2},
  [4539] = {.lex_state = 15, .external_lex_state = 2},
  [4540] = {.lex_state = 50, .external_lex_state = 2},
  [4541] = {.lex_state = 50, .external_lex_state = 2},
  [4542] = {.lex_state = 50, .external_lex_state = 2},
  [4543] = {.lex_state = 50, .external_lex_state = 2},
  [4544] = {.lex_state = 0, .external_lex_state = 2},
  [4545] = {.lex_state = 50, .external_lex_state = 2},
  [4546] = {.lex_state = 50, .external_lex_state = 2},
  [4547] = {.lex_state = 0, .external_lex_state = 2},
  [4548] = {.lex_state = 12, .external_lex_state = 2},
  [4549] = {.lex_state = 50, .external_lex_state = 2},
  [4550] = {.lex_state = 50, .external_lex_state = 2},
  [4551] = {.lex_state = 50, .external_lex_state = 2},
  [4552] = {.lex_state = 50, .external_lex_state = 2},
  [4553] = {.lex_state = 50, .external_lex_state = 2},
  [4554] = {.lex_state = 0, .external_lex_state = 2},
  [4555] = {.lex_state = 50, .external_lex_state = 2},
  [4556] = {.lex_state = 50, .external_lex_state = 2},
  [4557] = {.lex_state = 13, .external_lex_state = 2},
  [4558] = {.lex_state = 50, .external_lex_state = 2},
  [4559] = {.lex_state = 50, .external_lex_state = 2},
  [4560] = {.lex_state = 50, .external_lex_state = 2},
  [4561] = {.lex_state = 50, .external_lex_state = 2},
  [4562] = {.lex_state = 9, .external_lex_state = 2},
  [4563] = {.lex_state = 0, .external_lex_state = 2},
  [4564] = {.lex_state = 15, .external_lex_state = 2},
  [4565] = {.lex_state = 50, .external_lex_state = 2},
  [4566] = {.lex_state = 50, .external_lex_state = 2},
  [4567] = {.lex_state = 50, .external_lex_state = 2},
  [4568] = {.lex_state = 50, .external_lex_state = 2},
  [4569] = {.lex_state = 0, .external_lex_state = 2},
  [4570] = {.lex_state = 0, .external_lex_state = 2},
  [4571] = {.lex_state = 0, .external_lex_state = 2},
  [4572] = {.lex_state = 0, .external_lex_state = 2},
  [4573] = {.lex_state = 24, .external_lex_state = 2},
  [4574] = {.lex_state = 50, .external_lex_state = 2},
  [4575] = {.lex_state = 13, .external_lex_state = 2},
  [4576] = {.lex_state = 50, .external_lex_state = 2},
  [4577] = {.lex_state = 50, .external_lex_state = 2},
  [4578] = {.lex_state = 12, .external_lex_state = 2},
  [4579] = {.lex_state = 50, .external_lex_state = 2},
  [4580] = {.lex_state = 50, .external_lex_state = 2},
  [4581] = {.lex_state = 50, .external_lex_state = 2},
  [4582] = {.lex_state = 50, .external_lex_state = 2},
  [4583] = {.lex_state = 0, .external_lex_state = 2},
  [4584] = {.lex_state = 0, .external_lex_state = 2},
  [4585] = {.lex_state = 50, .external_lex_state = 2},
  [4586] = {.lex_state = 50, .external_lex_state = 2},
  [4587] = {.lex_state = 50, .external_lex_state = 2},
  [4588] = {.lex_state = 50, .external_lex_state = 2},
  [4589] = {.lex_state = 50, .external_lex_state = 2},
  [4590] = {.lex_state = 12, .external_lex_state = 2},
  [4591] = {.lex_state = 0, .external_lex_state = 2},
  [4592] = {.lex_state = 50, .external_lex_state = 2},
  [4593] = {.lex_state = 50, .external_lex_state = 2},
  [4594] = {.lex_state = 50, .external_lex_state = 2},
  [4595] = {.lex_state = 50, .external_lex_state = 2},
  [4596] = {.lex_state = 50, .external_lex_state = 2},
  [4597] = {.lex_state = 50, .external_lex_state = 2},
  [4598] = {.lex_state = 0, .external_lex_state = 2},
  [4599] = {.lex_state = 50, .external_lex_state = 2},
  [4600] = {.lex_state = 13, .external_lex_state = 2},
  [4601] = {.lex_state = 13, .external_lex_state = 2},
  [4602] = {.lex_state = 50, .external_lex_state = 2},
  [4603] = {.lex_state = 50, .external_lex_state = 2},
  [4604] = {.lex_state = 14, .external_lex_state = 2},
  [4605] = {.lex_state = 50, .external_lex_state = 2},
  [4606] = {.lex_state = 0, .external_lex_state = 2},
  [4607] = {.lex_state = 0, .external_lex_state = 2},
  [4608] = {.lex_state = 50, .external_lex_state = 2},
  [4609] = {.lex_state = 50, .external_lex_state = 2},
  [4610] = {.lex_state = 13, .external_lex_state = 2},
  [4611] = {.lex_state = 50, .external_lex_state = 2},
  [4612] = {.lex_state = 50, .external_lex_state = 2},
  [4613] = {.lex_state = 50, .external_lex_state = 2},
  [4614] = {.lex_state = 50, .external_lex_state = 2},
  [4615] = {.lex_state = 50, .external_lex_state = 2},
  [4616] = {.lex_state = 50, .external_lex_state = 2},
  [4617] = {.lex_state = 50, .external_lex_state = 2},
  [4618] = {.lex_state = 50, .external_lex_state = 2},
  [4619] = {.lex_state = 50, .external_lex_state = 2},
  [4620] = {.lex_state = 50, .external_lex_state = 2},
  [4621] = {.lex_state = 50, .external_lex_state = 2},
  [4622] = {.lex_state = 50, .external_lex_state = 2},
  [4623] = {.lex_state = 50, .external_lex_state = 2},
  [4624] = {.lex_state = 50, .external_lex_state = 2},
  [4625] = {.lex_state = 50, .external_lex_state = 2},
  [4626] = {.lex_state = 0, .external_lex_state = 2},
  [4627] = {.lex_state = 50, .external_lex_state = 2},
  [4628] = {.lex_state = 50, .external_lex_state = 2},
  [4629] = {.lex_state = 0, .external_lex_state = 2},
  [4630] = {.lex_state = 50, .external_lex_state = 2},
  [4631] = {.lex_state = 50, .external_lex_state = 2},
  [4632] = {.lex_state = 50, .external_lex_state = 2},
  [4633] = {.lex_state = 0, .external_lex_state = 2},
  [4634] = {.lex_state = 50, .external_lex_state = 2},
  [4635] = {.lex_state = 50, .external_lex_state = 2},
  [4636] = {.lex_state = 50, .external_lex_state = 2},
  [4637] = {.lex_state = 50, .external_lex_state = 2},
  [4638] = {.lex_state = 50, .external_lex_state = 2},
  [4639] = {.lex_state = 50, .external_lex_state = 2},
  [4640] = {.lex_state = 50, .external_lex_state = 2},
  [4641] = {.lex_state = 50, .external_lex_state = 2},
  [4642] = {.lex_state = 50, .external_lex_state = 2},
  [4643] = {.lex_state = 50, .external_lex_state = 2},
  [4644] = {.lex_state = 50, .external_lex_state = 2},
  [4645] = {.lex_state = 50, .external_lex_state = 2},
  [4646] = {.lex_state = 50, .external_lex_state = 2},
  [4647] = {.lex_state = 50, .external_lex_state = 2},
  [4648] = {.lex_state = 50, .external_lex_state = 2},
  [4649] = {.lex_state = 50, .external_lex_state = 2},
  [4650] = {.lex_state = 50, .external_lex_state = 2},
  [4651] = {.lex_state = 50, .external_lex_state = 2},
  [4652] = {.lex_state = 50, .external_lex_state = 2},
  [4653] = {.lex_state = 50, .external_lex_state = 2},
  [4654] = {.lex_state = 50, .external_lex_state = 2},
  [4655] = {.lex_state = 0, .external_lex_state = 2},
  [4656] = {.lex_state = 50, .external_lex_state = 2},
  [4657] = {.lex_state = 50, .external_lex_state = 5},
  [4658] = {.lex_state = 0, .external_lex_state = 2},
  [4659] = {.lex_state = 50, .external_lex_state = 2},
  [4660] = {.lex_state = 50, .external_lex_state = 2},
  [4661] = {.lex_state = 50, .external_lex_state = 2},
  [4662] = {.lex_state = 50, .external_lex_state = 2},
  [4663] = {.lex_state = 50, .external_lex_state = 2},
  [4664] = {.lex_state = 50, .external_lex_state = 2},
  [4665] = {.lex_state = 50, .external_lex_state = 2},
  [4666] = {.lex_state = 50, .external_lex_state = 2},
  [4667] = {.lex_state = 50, .external_lex_state = 2},
  [4668] = {.lex_state = 50, .external_lex_state = 2},
  [4669] = {.lex_state = 50, .external_lex_state = 2},
  [4670] = {.lex_state = 12, .external_lex_state = 2},
  [4671] = {.lex_state = 50, .external_lex_state = 2},
  [4672] = {.lex_state = 50, .external_lex_state = 2},
  [4673] = {.lex_state = 50, .external_lex_state = 2},
  [4674] = {.lex_state = 50, .external_lex_state = 2},
  [4675] = {.lex_state = 50, .external_lex_state = 2},
  [4676] = {.lex_state = 50, .external_lex_state = 2},
  [4677] = {.lex_state = 50, .external_lex_state = 2},
  [4678] = {.lex_state = 50, .external_lex_state = 2},
  [4679] = {.lex_state = 50, .external_lex_state = 2},
  [4680] = {.lex_state = 50, .external_lex_state = 2},
  [4681] = {.lex_state = 50, .external_lex_state = 2},
  [4682] = {.lex_state = 50, .external_lex_state = 2},
  [4683] = {.lex_state = 50, .external_lex_state = 2},
  [4684] = {.lex_state = 50, .external_lex_state = 2},
  [4685] = {.lex_state = 50, .external_lex_state = 2},
  [4686] = {.lex_state = 50, .external_lex_state = 2},
  [4687] = {.lex_state = 12, .external_lex_state = 2},
  [4688] = {.lex_state = 50, .external_lex_state = 2},
  [4689] = {.lex_state = 0, .external_lex_state = 2},
  [4690] = {.lex_state = 50, .external_lex_state = 2},
  [4691] = {.lex_state = 0, .external_lex_state = 2},
  [4692] = {.lex_state = 50, .external_lex_state = 2},
  [4693] = {.lex_state = 50, .external_lex_state = 2},
  [4694] = {.lex_state = 50, .external_lex_state = 2},
  [4695] = {.lex_state = 50, .external_lex_state = 2},
  [4696] = {.lex_state = 50, .external_lex_state = 2},
  [4697] = {.lex_state = 0, .external_lex_state = 2},
  [4698] = {.lex_state = 50, .external_lex_state = 2},
  [4699] = {.lex_state = 50, .external_lex_state = 2},
  [4700] = {.lex_state = 50, .external_lex_state = 2},
  [4701] = {.lex_state = 50, .external_lex_state = 2},
  [4702] = {.lex_state = 50, .external_lex_state = 2},
  [4703] = {.lex_state = 50, .external_lex_state = 2},
  [4704] = {.lex_state = 50, .external_lex_state = 2},
  [4705] = {.lex_state = 50, .external_lex_state = 2},
  [4706] = {.lex_state = 50, .external_lex_state = 2},
  [4707] = {.lex_state = 50, .external_lex_state = 2},
  [4708] = {.lex_state = 50, .external_lex_state = 2},
  [4709] = {.lex_state = 50, .external_lex_state = 2},
  [4710] = {.lex_state = 50, .external_lex_state = 2},
  [4711] = {.lex_state = 50, .external_lex_state = 2},
  [4712] = {.lex_state = 0, .external_lex_state = 2},
  [4713] = {.lex_state = 50, .external_lex_state = 5},
  [4714] = {.lex_state = 50, .external_lex_state = 2},
  [4715] = {.lex_state = 12, .external_lex_state = 2},
  [4716] = {.lex_state = 50, .external_lex_state = 2},
  [4717] = {.lex_state = 50, .external_lex_state = 2},
  [4718] = {.lex_state = 50, .external_lex_state = 2},
  [4719] = {.lex_state = 0, .external_lex_state = 2},
  [4720] = {.lex_state = 50, .external_lex_state = 2},
  [4721] = {.lex_state = 50, .external_lex_state = 2},
  [4722] = {.lex_state = 50, .external_lex_state = 2},
  [4723] = {.lex_state = 50, .external_lex_state = 2},
  [4724] = {.lex_state = 50, .external_lex_state = 2},
  [4725] = {.lex_state = 50, .external_lex_state = 2},
  [4726] = {.lex_state = 50, .external_lex_state = 2},
  [4727] = {.lex_state = 50, .external_lex_state = 2},
  [4728] = {.lex_state = 50, .external_lex_state = 2},
  [4729] = {.lex_state = 50, .external_lex_state = 2},
  [4730] = {.lex_state = 0, .external_lex_state = 2},
  [4731] = {.lex_state = 50, .external_lex_state = 2},
  [4732] = {.lex_state = 50, .external_lex_state = 2},
  [4733] = {.lex_state = 50, .external_lex_state = 2},
  [4734] = {.lex_state = 50, .external_lex_state = 2},
  [4735] = {.lex_state = 50, .external_lex_state = 2},
  [4736] = {.lex_state = 50, .external_lex_state = 2},
  [4737] = {.lex_state = 0, .external_lex_state = 2},
  [4738] = {.lex_state = 0, .external_lex_state = 2},
  [4739] = {.lex_state = 0, .external_lex_state = 2},
  [4740] = {.lex_state = 0, .external_lex_state = 2},
  [4741] = {.lex_state = 0, .external_lex_state = 2},
  [4742] = {.lex_state = 0, .external_lex_state = 2},
  [4743] = {.lex_state = 0, .external_lex_state = 2},
  [4744] = {.lex_state = 0, .external_lex_state = 2},
  [4745] = {.lex_state = 0, .external_lex_state = 2},
  [4746] = {.lex_state = 0, .external_lex_state = 2},
  [4747] = {.lex_state = 0, .external_lex_state = 2},
  [4748] = {.lex_state = 50, .external_lex_state = 2},
  [4749] = {.lex_state = 0, .external_lex_state = 2},
  [4750] = {.lex_state = 0, .external_lex_state = 2},
  [4751] = {.lex_state = 0, .external_lex_state = 2},
  [4752] = {.lex_state = 0, .external_lex_state = 2},
  [4753] = {.lex_state = 0, .external_lex_state = 2},
  [4754] = {.lex_state = 0, .external_lex_state = 2},
  [4755] = {.lex_state = 0, .external_lex_state = 2},
  [4756] = {.lex_state = 0, .external_lex_state = 2},
  [4757] = {.lex_state = 50, .external_lex_state = 2},
  [4758] = {.lex_state = 50, .external_lex_state = 2},
  [4759] = {.lex_state = 50, .external_lex_state = 2},
  [4760] = {.lex_state = 0, .external_lex_state = 2},
  [4761] = {.lex_state = 50, .external_lex_state = 2},
  [4762] = {.lex_state = 0, .external_lex_state = 2},
  [4763] = {.lex_state = 0, .external_lex_state = 2},
  [4764] = {.lex_state = 0, .external_lex_state = 2},
  [4765] = {.lex_state = 0, .external_lex_state = 2},
  [4766] = {.lex_state = 0, .external_lex_state = 2},
  [4767] = {.lex_state = 0, .external_lex_state = 2},
  [4768] = {.lex_state = 0, .external_lex_state = 2},
  [4769] = {.lex_state = 50, .external_lex_state = 2},
  [4770] = {.lex_state = 50, .external_lex_state = 2},
  [4771] = {.lex_state = 50, .external_lex_state = 2},
  [4772] = {.lex_state = 0, .external_lex_state = 2},
  [4773] = {.lex_state = 50, .external_lex_state = 2},
  [4774] = {.lex_state = 0, .external_lex_state = 2},
  [4775] = {.lex_state = 0, .external_lex_state = 2},
  [4776] = {.lex_state = 0, .external_lex_state = 2},
  [4777] = {.lex_state = 50, .external_lex_state = 2},
  [4778] = {.lex_state = 50, .external_lex_state = 2},
  [4779] = {.lex_state = 50, .external_lex_state = 2},
  [4780] = {.lex_state = 0, .external_lex_state = 2},
  [4781] = {.lex_state = 0, .external_lex_state = 2},
  [4782] = {.lex_state = 0, .external_lex_state = 2},
  [4783] = {.lex_state = 0, .external_lex_state = 2},
  [4784] = {.lex_state = 0, .external_lex_state = 2},
  [4785] = {.lex_state = 0, .external_lex_state = 2},
  [4786] = {.lex_state = 0, .external_lex_state = 2},
  [4787] = {.lex_state = 12, .external_lex_state = 2},
  [4788] = {.lex_state = 50, .external_lex_state = 2},
  [4789] = {.lex_state = 12, .external_lex_state = 2},
  [4790] = {.lex_state = 0, .external_lex_state = 2},
  [4791] = {.lex_state = 0, .external_lex_state = 2},
  [4792] = {.lex_state = 12, .external_lex_state = 2},
  [4793] = {.lex_state = 0, .external_lex_state = 2},
  [4794] = {.lex_state = 0, .external_lex_state = 2},
  [4795] = {.lex_state = 0, .external_lex_state = 2},
  [4796] = {.lex_state = 0, .external_lex_state = 2},
  [4797] = {.lex_state = 50, .external_lex_state = 2},
  [4798] = {.lex_state = 0, .external_lex_state = 2},
  [4799] = {.lex_state = 0, .external_lex_state = 2},
  [4800] = {.lex_state = 0, .external_lex_state = 2},
  [4801] = {.lex_state = 50, .external_lex_state = 2},
  [4802] = {.lex_state = 0, .external_lex_state = 2},
  [4803] = {.lex_state = 0, .external_lex_state = 2},
  [4804] = {.lex_state = 0, .external_lex_state = 2},
  [4805] = {.lex_state = 0, .external_lex_state = 2},
  [4806] = {.lex_state = 0, .external_lex_state = 2},
  [4807] = {.lex_state = 0, .external_lex_state = 2},
  [4808] = {.lex_state = 0, .external_lex_state = 2},
  [4809] = {.lex_state = 0, .external_lex_state = 2},
  [4810] = {.lex_state = 0, .external_lex_state = 2},
  [4811] = {.lex_state = 50, .external_lex_state = 2},
  [4812] = {.lex_state = 0, .external_lex_state = 2},
  [4813] = {.lex_state = 0, .external_lex_state = 2},
  [4814] = {.lex_state = 0, .external_lex_state = 2},
  [4815] = {.lex_state = 0, .external_lex_state = 2},
  [4816] = {.lex_state = 0, .external_lex_state = 2},
  [4817] = {.lex_state = 0, .external_lex_state = 2},
  [4818] = {.lex_state = 0, .external_lex_state = 2},
  [4819] = {.lex_state = 0, .external_lex_state = 2},
  [4820] = {.lex_state = 50, .external_lex_state = 2},
  [4821] = {.lex_state = 0, .external_lex_state = 2},
  [4822] = {.lex_state = 0, .external_lex_state = 2},
  [4823] = {.lex_state = 0, .external_lex_state = 2},
  [4824] = {.lex_state = 12, .external_lex_state = 2},
  [4825] = {.lex_state = 0, .external_lex_state = 2},
  [4826] = {.lex_state = 0, .external_lex_state = 2},
  [4827] = {.lex_state = 0, .external_lex_state = 2},
  [4828] = {.lex_state = 0, .external_lex_state = 2},
  [4829] = {.lex_state = 0, .external_lex_state = 2},
  [4830] = {.lex_state = 0, .external_lex_state = 2},
  [4831] = {.lex_state = 50, .external_lex_state = 2},
  [4832] = {.lex_state = 0, .external_lex_state = 2},
  [4833] = {.lex_state = 0, .external_lex_state = 2},
  [4834] = {.lex_state = 0, .external_lex_state = 2},
  [4835] = {.lex_state = 50, .external_lex_state = 2},
  [4836] = {.lex_state = 0, .external_lex_state = 2},
  [4837] = {.lex_state = 0, .external_lex_state = 2},
  [4838] = {.lex_state = 0, .external_lex_state = 2},
  [4839] = {.lex_state = 0, .external_lex_state = 2},
  [4840] = {.lex_state = 0, .external_lex_state = 2},
  [4841] = {.lex_state = 0, .external_lex_state = 2},
  [4842] = {.lex_state = 0, .external_lex_state = 2},
  [4843] = {.lex_state = 0, .external_lex_state = 2},
  [4844] = {.lex_state = 0, .external_lex_state = 2},
  [4845] = {.lex_state = 0, .external_lex_state = 2},
  [4846] = {.lex_state = 0, .external_lex_state = 2},
  [4847] = {.lex_state = 0, .external_lex_state = 2},
  [4848] = {.lex_state = 0, .external_lex_state = 2},
  [4849] = {.lex_state = 0, .external_lex_state = 2},
  [4850] = {.lex_state = 0, .external_lex_state = 2},
  [4851] = {.lex_state = 50, .external_lex_state = 2},
  [4852] = {.lex_state = 0, .external_lex_state = 2},
  [4853] = {.lex_state = 12, .external_lex_state = 2},
  [4854] = {.lex_state = 0, .external_lex_state = 2},
  [4855] = {.lex_state = 0, .external_lex_state = 2},
  [4856] = {.lex_state = 0, .external_lex_state = 2},
  [4857] = {.lex_state = 0, .external_lex_state = 2},
  [4858] = {.lex_state = 50, .external_lex_state = 2},
  [4859] = {.lex_state = 50, .external_lex_state = 2},
  [4860] = {.lex_state = 50, .external_lex_state = 2},
  [4861] = {.lex_state = 0, .external_lex_state = 2},
  [4862] = {.lex_state = 12, .external_lex_state = 2},
  [4863] = {.lex_state = 0, .external_lex_state = 2},
  [4864] = {.lex_state = 0, .external_lex_state = 2},
  [4865] = {.lex_state = 12, .external_lex_state = 2},
  [4866] = {.lex_state = 0, .external_lex_state = 2},
  [4867] = {.lex_state = 0, .external_lex_state = 2},
  [4868] = {.lex_state = 0, .external_lex_state = 2},
  [4869] = {.lex_state = 0, .external_lex_state = 2},
  [4870] = {.lex_state = 50, .external_lex_state = 2},
  [4871] = {.lex_state = 0, .external_lex_state = 2},
  [4872] = {.lex_state = 50, .external_lex_state = 2},
  [4873] = {.lex_state = 0, .external_lex_state = 2},
  [4874] = {.lex_state = 0, .external_lex_state = 2},
  [4875] = {.lex_state = 50, .external_lex_state = 2},
  [4876] = {.lex_state = 0, .external_lex_state = 2},
  [4877] = {.lex_state = 0, .external_lex_state = 2},
  [4878] = {.lex_state = 0, .external_lex_state = 2},
  [4879] = {.lex_state = 12, .external_lex_state = 2},
  [4880] = {.lex_state = 0, .external_lex_state = 2},
  [4881] = {.lex_state = 0, .external_lex_state = 2},
  [4882] = {.lex_state = 0, .external_lex_state = 2},
  [4883] = {.lex_state = 0, .external_lex_state = 2},
  [4884] = {.lex_state = 0, .external_lex_state = 2},
  [4885] = {.lex_state = 0, .external_lex_state = 2},
  [4886] = {.lex_state = 0, .external_lex_state = 2},
  [4887] = {.lex_state = 0, .external_lex_state = 2},
  [4888] = {.lex_state = 0, .external_lex_state = 2},
  [4889] = {.lex_state = 50, .external_lex_state = 2},
  [4890] = {.lex_state = 0, .external_lex_state = 2},
  [4891] = {.lex_state = 50, .external_lex_state = 2},
  [4892] = {.lex_state = 0, .external_lex_state = 2},
  [4893] = {.lex_state = 0, .external_lex_state = 2},
  [4894] = {.lex_state = 0, .external_lex_state = 2},
  [4895] = {.lex_state = 0, .external_lex_state = 2},
  [4896] = {.lex_state = 0, .external_lex_state = 2},
  [4897] = {.lex_state = 0, .external_lex_state = 2},
  [4898] = {.lex_state = 0, .external_lex_state = 2},
  [4899] = {.lex_state = 0, .external_lex_state = 2},
  [4900] = {.lex_state = 50, .external_lex_state = 2},
  [4901] = {.lex_state = 0, .external_lex_state = 2},
  [4902] = {.lex_state = 0, .external_lex_state = 2},
  [4903] = {.lex_state = 50, .external_lex_state = 2},
  [4904] = {.lex_state = 0, .external_lex_state = 2},
  [4905] = {.lex_state = 0, .external_lex_state = 2},
  [4906] = {.lex_state = 50, .external_lex_state = 2},
  [4907] = {.lex_state = 0, .external_lex_state = 2},
  [4908] = {.lex_state = 0, .external_lex_state = 2},
  [4909] = {.lex_state = 0, .external_lex_state = 2},
  [4910] = {.lex_state = 0, .external_lex_state = 2},
  [4911] = {.lex_state = 0, .external_lex_state = 2},
  [4912] = {.lex_state = 0, .external_lex_state = 2},
  [4913] = {.lex_state = 0, .external_lex_state = 2},
  [4914] = {.lex_state = 50, .external_lex_state = 2},
  [4915] = {.lex_state = 0, .external_lex_state = 2},
  [4916] = {.lex_state = 50, .external_lex_state = 2},
  [4917] = {.lex_state = 50, .external_lex_state = 2},
  [4918] = {.lex_state = 0, .external_lex_state = 2},
  [4919] = {.lex_state = 0, .external_lex_state = 2},
  [4920] = {.lex_state = 50, .external_lex_state = 2},
  [4921] = {.lex_state = 50, .external_lex_state = 2},
  [4922] = {.lex_state = 0, .external_lex_state = 2},
  [4923] = {.lex_state = 0, .external_lex_state = 2},
  [4924] = {.lex_state = 0, .external_lex_state = 2},
  [4925] = {.lex_state = 0, .external_lex_state = 2},
  [4926] = {.lex_state = 0, .external_lex_state = 2},
  [4927] = {.lex_state = 0, .external_lex_state = 2},
  [4928] = {.lex_state = 0, .external_lex_state = 2},
  [4929] = {.lex_state = 0, .external_lex_state = 2},
  [4930] = {.lex_state = 0, .external_lex_state = 2},
  [4931] = {.lex_state = 0, .external_lex_state = 2},
  [4932] = {.lex_state = 0, .external_lex_state = 2},
  [4933] = {.lex_state = 0, .external_lex_state = 2},
  [4934] = {.lex_state = 50, .external_lex_state = 2},
  [4935] = {.lex_state = 12, .external_lex_state = 2},
  [4936] = {.lex_state = 0, .external_lex_state = 2},
  [4937] = {.lex_state = 0, .external_lex_state = 2},
  [4938] = {.lex_state = 0, .external_lex_state = 2},
  [4939] = {.lex_state = 0, .external_lex_state = 2},
  [4940] = {.lex_state = 0, .external_lex_state = 2},
  [4941] = {.lex_state = 0, .external_lex_state = 2},
  [4942] = {.lex_state = 50, .external_lex_state = 2},
  [4943] = {.lex_state = 50, .external_lex_state = 2},
  [4944] = {.lex_state = 50, .external_lex_state = 2},
  [4945] = {.lex_state = 0, .external_lex_state = 2},
  [4946] = {.lex_state = 0, .external_lex_state = 2},
  [4947] = {.lex_state = 0, .external_lex_state = 2},
  [4948] = {.lex_state = 0, .external_lex_state = 2},
  [4949] = {.lex_state = 50, .external_lex_state = 2},
  [4950] = {.lex_state = 50, .external_lex_state = 2},
  [4951] = {.lex_state = 0, .external_lex_state = 2},
  [4952] = {.lex_state = 50, .external_lex_state = 2},
  [4953] = {.lex_state = 0, .external_lex_state = 2},
  [4954] = {.lex_state = 0, .external_lex_state = 2},
  [4955] = {.lex_state = 0, .external_lex_state = 2},
  [4956] = {.lex_state = 50, .external_lex_state = 2},
  [4957] = {.lex_state = 0, .external_lex_state = 2},
  [4958] = {.lex_state = 0, .external_lex_state = 2},
  [4959] = {.lex_state = 50, .external_lex_state = 2},
  [4960] = {.lex_state = 0, .external_lex_state = 2},
  [4961] = {.lex_state = 50, .external_lex_state = 2},
  [4962] = {.lex_state = 0, .external_lex_state = 2},
  [4963] = {.lex_state = 12, .external_lex_state = 2},
  [4964] = {.lex_state = 0, .external_lex_state = 2},
  [4965] = {.lex_state = 0, .external_lex_state = 2},
  [4966] = {.lex_state = 0, .external_lex_state = 2},
  [4967] = {.lex_state = 0, .external_lex_state = 2},
  [4968] = {.lex_state = 0, .external_lex_state = 2},
  [4969] = {.lex_state = 12, .external_lex_state = 2},
  [4970] = {.lex_state = 0, .external_lex_state = 2},
  [4971] = {.lex_state = 0, .external_lex_state = 2},
  [4972] = {.lex_state = 0, .external_lex_state = 2},
  [4973] = {.lex_state = 0, .external_lex_state = 2},
  [4974] = {.lex_state = 50, .external_lex_state = 2},
  [4975] = {.lex_state = 0, .external_lex_state = 2},
  [4976] = {.lex_state = 0, .external_lex_state = 2},
  [4977] = {.lex_state = 0, .external_lex_state = 2},
  [4978] = {.lex_state = 50, .external_lex_state = 2},
  [4979] = {.lex_state = 0, .external_lex_state = 2},
  [4980] = {.lex_state = 0, .external_lex_state = 2},
  [4981] = {.lex_state = 11, .external_lex_state = 2},
  [4982] = {.lex_state = 0, .external_lex_state = 2},
  [4983] = {.lex_state = 0, .external_lex_state = 2},
  [4984] = {.lex_state = 0, .external_lex_state = 2},
  [4985] = {.lex_state = 0, .external_lex_state = 2},
  [4986] = {.lex_state = 50, .external_lex_state = 2},
  [4987] = {.lex_state = 0, .external_lex_state = 2},
  [4988] = {.lex_state = 50, .external_lex_state = 2},
  [4989] = {.lex_state = 0, .external_lex_state = 2},
  [4990] = {.lex_state = 0, .external_lex_state = 2},
  [4991] = {.lex_state = 0, .external_lex_state = 2},
  [4992] = {.lex_state = 0, .external_lex_state = 2},
  [4993] = {.lex_state = 0, .external_lex_state = 2},
  [4994] = {.lex_state = 12, .external_lex_state = 2},
  [4995] = {.lex_state = 0, .external_lex_state = 2},
  [4996] = {.lex_state = 0, .external_lex_state = 2},
  [4997] = {.lex_state = 0, .external_lex_state = 2},
  [4998] = {.lex_state = 0, .external_lex_state = 2},
  [4999] = {.lex_state = 50, .external_lex_state = 2},
  [5000] = {.lex_state = 0, .external_lex_state = 2},
  [5001] = {.lex_state = 50, .external_lex_state = 2},
  [5002] = {.lex_state = 0, .external_lex_state = 2},
  [5003] = {.lex_state = 0, .external_lex_state = 2},
  [5004] = {.lex_state = 0, .external_lex_state = 2},
  [5005] = {.lex_state = 0, .external_lex_state = 2},
  [5006] = {.lex_state = 0, .external_lex_state = 2},
  [5007] = {.lex_state = 50, .external_lex_state = 2},
  [5008] = {.lex_state = 0, .external_lex_state = 2},
  [5009] = {.lex_state = 0, .external_lex_state = 2},
  [5010] = {.lex_state = 0, .external_lex_state = 2},
  [5011] = {.lex_state = 0, .external_lex_state = 2},
  [5012] = {.lex_state = 0, .external_lex_state = 2},
  [5013] = {.lex_state = 0, .external_lex_state = 2},
  [5014] = {.lex_state = 0, .external_lex_state = 2},
  [5015] = {.lex_state = 0, .external_lex_state = 2},
  [5016] = {.lex_state = 0, .external_lex_state = 2},
  [5017] = {.lex_state = 0, .external_lex_state = 2},
  [5018] = {.lex_state = 0, .external_lex_state = 2},
  [5019] = {.lex_state = 0, .external_lex_state = 2},
  [5020] = {.lex_state = 0, .external_lex_state = 2},
  [5021] = {.lex_state = 50, .external_lex_state = 2},
  [5022] = {.lex_state = 0, .external_lex_state = 2},
  [5023] = {.lex_state = 50, .external_lex_state = 2},
  [5024] = {.lex_state = 0, .external_lex_state = 2},
  [5025] = {.lex_state = 0, .external_lex_state = 2},
  [5026] = {.lex_state = 0, .external_lex_state = 2},
  [5027] = {.lex_state = 0, .external_lex_state = 2},
  [5028] = {.lex_state = 0, .external_lex_state = 2},
  [5029] = {.lex_state = 0, .external_lex_state = 2},
  [5030] = {.lex_state = 0, .external_lex_state = 2},
  [5031] = {.lex_state = 12, .external_lex_state = 2},
  [5032] = {.lex_state = 0, .external_lex_state = 2},
  [5033] = {.lex_state = 0, .external_lex_state = 2},
  [5034] = {.lex_state = 0, .external_lex_state = 2},
  [5035] = {.lex_state = 0, .external_lex_state = 2},
  [5036] = {.lex_state = 0, .external_lex_state = 2},
  [5037] = {.lex_state = 0, .external_lex_state = 2},
  [5038] = {.lex_state = 0, .external_lex_state = 2},
  [5039] = {.lex_state = 0, .external_lex_state = 2},
  [5040] = {.lex_state = 50, .external_lex_state = 2},
  [5041] = {.lex_state = 50, .external_lex_state = 2},
  [5042] = {.lex_state = 0, .external_lex_state = 2},
  [5043] = {.lex_state = 0, .external_lex_state = 2},
  [5044] = {.lex_state = 0, .external_lex_state = 2},
  [5045] = {.lex_state = 0, .external_lex_state = 2},
  [5046] = {.lex_state = 0, .external_lex_state = 2},
  [5047] = {.lex_state = 0, .external_lex_state = 2},
  [5048] = {.lex_state = 0, .external_lex_state = 2},
  [5049] = {.lex_state = 0, .external_lex_state = 2},
  [5050] = {.lex_state = 0, .external_lex_state = 2},
  [5051] = {.lex_state = 0, .external_lex_state = 2},
  [5052] = {.lex_state = 0, .external_lex_state = 2},
  [5053] = {.lex_state = 50, .external_lex_state = 2},
  [5054] = {.lex_state = 0, .external_lex_state = 2},
  [5055] = {.lex_state = 0, .external_lex_state = 2},
  [5056] = {.lex_state = 0, .external_lex_state = 2},
  [5057] = {.lex_state = 0, .external_lex_state = 2},
  [5058] = {.lex_state = 0, .external_lex_state = 2},
  [5059] = {.lex_state = 0, .external_lex_state = 2},
  [5060] = {.lex_state = 0, .external_lex_state = 2},
  [5061] = {.lex_state = 50, .external_lex_state = 2},
  [5062] = {.lex_state = 0, .external_lex_state = 2},
  [5063] = {.lex_state = 0, .external_lex_state = 2},
  [5064] = {.lex_state = 0, .external_lex_state = 2},
  [5065] = {.lex_state = 0, .external_lex_state = 2},
  [5066] = {.lex_state = 0, .external_lex_state = 2},
  [5067] = {.lex_state = 0, .external_lex_state = 2},
  [5068] = {.lex_state = 0, .external_lex_state = 2},
  [5069] = {.lex_state = 0, .external_lex_state = 2},
  [5070] = {.lex_state = 0, .external_lex_state = 2},
  [5071] = {.lex_state = 0, .external_lex_state = 2},
  [5072] = {.lex_state = 0, .external_lex_state = 2},
  [5073] = {.lex_state = 0, .external_lex_state = 2},
  [5074] = {.lex_state = 0, .external_lex_state = 2},
  [5075] = {.lex_state = 0, .external_lex_state = 2},
  [5076] = {.lex_state = 0, .external_lex_state = 2},
  [5077] = {.lex_state = 50, .external_lex_state = 2},
  [5078] = {.lex_state = 0, .external_lex_state = 2},
  [5079] = {.lex_state = 0, .external_lex_state = 2},
  [5080] = {.lex_state = 50, .external_lex_state = 2},
  [5081] = {.lex_state = 0, .external_lex_state = 2},
  [5082] = {.lex_state = 0, .external_lex_state = 2},
  [5083] = {.lex_state = 12, .external_lex_state = 2},
  [5084] = {.lex_state = 0, .external_lex_state = 2},
  [5085] = {.lex_state = 50, .external_lex_state = 2},
  [5086] = {.lex_state = 0, .external_lex_state = 2},
  [5087] = {.lex_state = 0, .external_lex_state = 2},
  [5088] = {.lex_state = 0, .external_lex_state = 2},
  [5089] = {.lex_state = 50, .external_lex_state = 2},
  [5090] = {.lex_state = 0, .external_lex_state = 2},
  [5091] = {.lex_state = 0, .external_lex_state = 2},
  [5092] = {.lex_state = 0, .external_lex_state = 2},
  [5093] = {.lex_state = 0, .external_lex_state = 2},
  [5094] = {.lex_state = 0, .external_lex_state = 2},
  [5095] = {.lex_state = 12, .external_lex_state = 2},
  [5096] = {.lex_state = 0, .external_lex_state = 2},
  [5097] = {.lex_state = 0, .external_lex_state = 2},
  [5098] = {.lex_state = 0, .external_lex_state = 2},
  [5099] = {.lex_state = 0, .external_lex_state = 2},
  [5100] = {.lex_state = 0, .external_lex_state = 2},
  [5101] = {.lex_state = 50, .external_lex_state = 2},
  [5102] = {.lex_state = 50, .external_lex_state = 2},
  [5103] = {.lex_state = 0, .external_lex_state = 2},
  [5104] = {.lex_state = 0, .external_lex_state = 2},
  [5105] = {.lex_state = 0, .external_lex_state = 2},
  [5106] = {.lex_state = 0, .external_lex_state = 2},
  [5107] = {.lex_state = 0, .external_lex_state = 2},
  [5108] = {.lex_state = 0, .external_lex_state = 2},
  [5109] = {.lex_state = 0, .external_lex_state = 2},
  [5110] = {.lex_state = 12, .external_lex_state = 2},
  [5111] = {.lex_state = 50, .external_lex_state = 2},
  [5112] = {.lex_state = 0, .external_lex_state = 2},
  [5113] = {.lex_state = 50, .external_lex_state = 2},
  [5114] = {.lex_state = 0, .external_lex_state = 2},
  [5115] = {.lex_state = 0, .external_lex_state = 2},
  [5116] = {.lex_state = 0, .external_lex_state = 2},
  [5117] = {.lex_state = 0, .external_lex_state = 2},
  [5118] = {.lex_state = 0, .external_lex_state = 2},
  [5119] = {.lex_state = 0, .external_lex_state = 2},
  [5120] = {.lex_state = 0, .external_lex_state = 2},
  [5121] = {.lex_state = 0, .external_lex_state = 2},
  [5122] = {.lex_state = 0, .external_lex_state = 2},
  [5123] = {.lex_state = 12, .external_lex_state = 2},
  [5124] = {.lex_state = 12, .external_lex_state = 2},
  [5125] = {.lex_state = 0, .external_lex_state = 2},
  [5126] = {.lex_state = 12, .external_lex_state = 2},
  [5127] = {.lex_state = 50, .external_lex_state = 2},
  [5128] = {.lex_state = 0, .external_lex_state = 2},
  [5129] = {.lex_state = 0, .external_lex_state = 2},
  [5130] = {.lex_state = 0, .external_lex_state = 2},
  [5131] = {.lex_state = 0, .external_lex_state = 2},
  [5132] = {.lex_state = 0, .external_lex_state = 2},
  [5133] = {.lex_state = 0, .external_lex_state = 2},
  [5134] = {.lex_state = 0, .external_lex_state = 2},
  [5135] = {.lex_state = 0, .external_lex_state = 2},
  [5136] = {.lex_state = 0, .external_lex_state = 2},
  [5137] = {.lex_state = 0, .external_lex_state = 2},
  [5138] = {.lex_state = 50, .external_lex_state = 2},
  [5139] = {.lex_state = 50, .external_lex_state = 2},
  [5140] = {.lex_state = 12, .external_lex_state = 2},
  [5141] = {.lex_state = 0, .external_lex_state = 2},
  [5142] = {.lex_state = 0, .external_lex_state = 2},
  [5143] = {.lex_state = 0, .external_lex_state = 2},
  [5144] = {.lex_state = 0, .external_lex_state = 2},
  [5145] = {.lex_state = 0, .external_lex_state = 2},
  [5146] = {.lex_state = 50, .external_lex_state = 2},
  [5147] = {.lex_state = 50, .external_lex_state = 2},
  [5148] = {.lex_state = 0, .external_lex_state = 2},
  [5149] = {.lex_state = 0, .external_lex_state = 2},
  [5150] = {.lex_state = 0, .external_lex_state = 2},
  [5151] = {.lex_state = 0, .external_lex_state = 2},
  [5152] = {.lex_state = 0, .external_lex_state = 2},
  [5153] = {.lex_state = 0, .external_lex_state = 2},
  [5154] = {.lex_state = 0, .external_lex_state = 2},
  [5155] = {.lex_state = 0, .external_lex_state = 2},
  [5156] = {.lex_state = 0, .external_lex_state = 2},
  [5157] = {.lex_state = 50, .external_lex_state = 2},
  [5158] = {.lex_state = 50, .external_lex_state = 2},
  [5159] = {.lex_state = 0, .external_lex_state = 2},
  [5160] = {.lex_state = 50, .external_lex_state = 2},
  [5161] = {.lex_state = 0, .external_lex_state = 2},
  [5162] = {.lex_state = 0, .external_lex_state = 2},
  [5163] = {.lex_state = 0, .external_lex_state = 2},
  [5164] = {.lex_state = 0, .external_lex_state = 2},
  [5165] = {.lex_state = 0, .external_lex_state = 2},
  [5166] = {.lex_state = 0, .external_lex_state = 2},
  [5167] = {.lex_state = 50, .external_lex_state = 2},
  [5168] = {.lex_state = 50, .external_lex_state = 2},
  [5169] = {.lex_state = 0, .external_lex_state = 2},
  [5170] = {.lex_state = 50, .external_lex_state = 2},
  [5171] = {.lex_state = 0, .external_lex_state = 2},
  [5172] = {.lex_state = 0, .external_lex_state = 2},
  [5173] = {.lex_state = 0, .external_lex_state = 2},
  [5174] = {.lex_state = 0, .external_lex_state = 2},
  [5175] = {.lex_state = 50, .external_lex_state = 2},
  [5176] = {.lex_state = 0, .external_lex_state = 2},
  [5177] = {.lex_state = 50, .external_lex_state = 2},
  [5178] = {.lex_state = 0, .external_lex_state = 2},
  [5179] = {.lex_state = 50, .external_lex_state = 2},
  [5180] = {.lex_state = 0, .external_lex_state = 2},
  [5181] = {.lex_state = 0, .external_lex_state = 2},
  [5182] = {.lex_state = 12, .external_lex_state = 2},
  [5183] = {.lex_state = 0, .external_lex_state = 2},
  [5184] = {.lex_state = 50, .external_lex_state = 2},
  [5185] = {.lex_state = 50, .external_lex_state = 2},
  [5186] = {.lex_state = 0, .external_lex_state = 2},
  [5187] = {.lex_state = 0, .external_lex_state = 2},
  [5188] = {.lex_state = 0, .external_lex_state = 2},
  [5189] = {.lex_state = 50, .external_lex_state = 2},
  [5190] = {.lex_state = 50, .external_lex_state = 2},
  [5191] = {.lex_state = 0, .external_lex_state = 2},
  [5192] = {.lex_state = 50, .external_lex_state = 2},
  [5193] = {.lex_state = 50, .external_lex_state = 2},
  [5194] = {.lex_state = 0, .external_lex_state = 2},
  [5195] = {.lex_state = 50, .external_lex_state = 2},
  [5196] = {.lex_state = 0, .external_lex_state = 2},
  [5197] = {.lex_state = 0, .external_lex_state = 2},
  [5198] = {.lex_state = 50, .external_lex_state = 2},
  [5199] = {.lex_state = 0, .external_lex_state = 2},
  [5200] = {.lex_state = 0, .external_lex_state = 2},
  [5201] = {.lex_state = 0, .external_lex_state = 2},
  [5202] = {.lex_state = 0, .external_lex_state = 2},
  [5203] = {.lex_state = 12, .external_lex_state = 2},
  [5204] = {.lex_state = 0, .external_lex_state = 2},
  [5205] = {.lex_state = 0, .external_lex_state = 2},
  [5206] = {.lex_state = 50, .external_lex_state = 2},
  [5207] = {.lex_state = 11, .external_lex_state = 2},
  [5208] = {.lex_state = 50, .external_lex_state = 2},
  [5209] = {.lex_state = 0, .external_lex_state = 2},
  [5210] = {.lex_state = 50, .external_lex_state = 2},
  [5211] = {.lex_state = 0, .external_lex_state = 2},
  [5212] = {.lex_state = 0, .external_lex_state = 2},
  [5213] = {.lex_state = 0, .external_lex_state = 2},
  [5214] = {.lex_state = 0, .external_lex_state = 2},
  [5215] = {.lex_state = 11, .external_lex_state = 2},
  [5216] = {.lex_state = 50, .external_lex_state = 5},
  [5217] = {.lex_state = 0, .external_lex_state = 2},
  [5218] = {.lex_state = 50, .external_lex_state = 2},
  [5219] = {.lex_state = 0, .external_lex_state = 2},
  [5220] = {.lex_state = 0, .external_lex_state = 2},
  [5221] = {.lex_state = 50, .external_lex_state = 2},
  [5222] = {.lex_state = 50, .external_lex_state = 2},
  [5223] = {.lex_state = 0, .external_lex_state = 2},
  [5224] = {.lex_state = 50, .external_lex_state = 2},
  [5225] = {.lex_state = 0, .external_lex_state = 2},
  [5226] = {.lex_state = 0, .external_lex_state = 2},
  [5227] = {.lex_state = 0, .external_lex_state = 2},
  [5228] = {.lex_state = 0, .external_lex_state = 2},
  [5229] = {.lex_state = 12, .external_lex_state = 2},
  [5230] = {.lex_state = 50, .external_lex_state = 2},
  [5231] = {.lex_state = 0, .external_lex_state = 2},
  [5232] = {.lex_state = 0, .external_lex_state = 2},
  [5233] = {.lex_state = 0, .external_lex_state = 2},
  [5234] = {.lex_state = 11, .external_lex_state = 2},
  [5235] = {.lex_state = 0, .external_lex_state = 2},
  [5236] = {.lex_state = 0, .external_lex_state = 2},
  [5237] = {.lex_state = 50, .external_lex_state = 2},
  [5238] = {.lex_state = 50, .external_lex_state = 5},
  [5239] = {.lex_state = 0, .external_lex_state = 2},
  [5240] = {.lex_state = 0, .external_lex_state = 2},
  [5241] = {.lex_state = 0, .external_lex_state = 2},
  [5242] = {.lex_state = 50, .external_lex_state = 5},
  [5243] = {.lex_state = 0, .external_lex_state = 2},
  [5244] = {.lex_state = 50, .external_lex_state = 2},
  [5245] = {.lex_state = 50, .external_lex_state = 2},
  [5246] = {.lex_state = 0, .external_lex_state = 2},
  [5247] = {.lex_state = 0, .external_lex_state = 2},
  [5248] = {.lex_state = 50, .external_lex_state = 2},
  [5249] = {.lex_state = 50, .external_lex_state = 2},
  [5250] = {.lex_state = 0, .external_lex_state = 2},
  [5251] = {.lex_state = 0, .external_lex_state = 2},
  [5252] = {.lex_state = 50, .external_lex_state = 2},
  [5253] = {.lex_state = 50, .external_lex_state = 2},
  [5254] = {.lex_state = 0, .external_lex_state = 2},
  [5255] = {.lex_state = 0, .external_lex_state = 2},
  [5256] = {.lex_state = 0, .external_lex_state = 2},
  [5257] = {.lex_state = 0, .external_lex_state = 2},
  [5258] = {.lex_state = 0, .external_lex_state = 2},
  [5259] = {.lex_state = 0, .external_lex_state = 2},
  [5260] = {.lex_state = 0, .external_lex_state = 2},
  [5261] = {.lex_state = 50, .external_lex_state = 2},
  [5262] = {.lex_state = 0, .external_lex_state = 2},
  [5263] = {.lex_state = 50, .external_lex_state = 2},
  [5264] = {.lex_state = 50, .external_lex_state = 5},
  [5265] = {.lex_state = 50, .external_lex_state = 5},
  [5266] = {.lex_state = 0, .external_lex_state = 2},
  [5267] = {.lex_state = 50, .external_lex_state = 2},
  [5268] = {.lex_state = 0, .external_lex_state = 2},
  [5269] = {.lex_state = 0, .external_lex_state = 2},
  [5270] = {.lex_state = 11, .external_lex_state = 2},
  [5271] = {.lex_state = 0, .external_lex_state = 2},
  [5272] = {.lex_state = 0, .external_lex_state = 2},
  [5273] = {.lex_state = 12, .external_lex_state = 2},
  [5274] = {.lex_state = 50, .external_lex_state = 2},
  [5275] = {.lex_state = 0, .external_lex_state = 2},
  [5276] = {.lex_state = 50, .external_lex_state = 2},
  [5277] = {.lex_state = 50, .external_lex_state = 2},
  [5278] = {.lex_state = 0, .external_lex_state = 2},
  [5279] = {.lex_state = 12, .external_lex_state = 2},
  [5280] = {.lex_state = 0, .external_lex_state = 2},
  [5281] = {.lex_state = 50, .external_lex_state = 2},
  [5282] = {.lex_state = 0, .external_lex_state = 2},
  [5283] = {.lex_state = 50, .external_lex_state = 2},
  [5284] = {.lex_state = 0, .external_lex_state = 2},
  [5285] = {.lex_state = 0, .external_lex_state = 2},
  [5286] = {.lex_state = 11, .external_lex_state = 2},
  [5287] = {.lex_state = 12, .external_lex_state = 2},
  [5288] = {.lex_state = 50, .external_lex_state = 5},
  [5289] = {.lex_state = 0, .external_lex_state = 2},
  [5290] = {.lex_state = 11, .external_lex_state = 2},
  [5291] = {.lex_state = 0, .external_lex_state = 2},
  [5292] = {.lex_state = 0, .external_lex_state = 2},
  [5293] = {.lex_state = 0, .external_lex_state = 2},
  [5294] = {.lex_state = 0, .external_lex_state = 2},
  [5295] = {.lex_state = 12, .external_lex_state = 2},
  [5296] = {.lex_state = 0, .external_lex_state = 2},
  [5297] = {.lex_state = 50, .external_lex_state = 2},
  [5298] = {.lex_state = 0, .external_lex_state = 2},
  [5299] = {.lex_state = 0, .external_lex_state = 2},
  [5300] = {.lex_state = 0, .external_lex_state = 2},
  [5301] = {.lex_state = 50, .external_lex_state = 2},
  [5302] = {.lex_state = 50, .external_lex_state = 2},
  [5303] = {.lex_state = 0, .external_lex_state = 2},
  [5304] = {.lex_state = 0, .external_lex_state = 2},
  [5305] = {.lex_state = 0, .external_lex_state = 2},
  [5306] = {.lex_state = 0, .external_lex_state = 2},
  [5307] = {.lex_state = 0, .external_lex_state = 2},
  [5308] = {.lex_state = 50, .external_lex_state = 2},
  [5309] = {.lex_state = 50, .external_lex_state = 2},
  [5310] = {.lex_state = 12, .external_lex_state = 2},
  [5311] = {.lex_state = 0, .external_lex_state = 2},
  [5312] = {.lex_state = 0, .external_lex_state = 2},
  [5313] = {.lex_state = 0, .external_lex_state = 2},
  [5314] = {.lex_state = 11, .external_lex_state = 2},
  [5315] = {.lex_state = 0, .external_lex_state = 2},
  [5316] = {.lex_state = 0, .external_lex_state = 2},
  [5317] = {.lex_state = 50, .external_lex_state = 2},
  [5318] = {.lex_state = 0, .external_lex_state = 2},
  [5319] = {.lex_state = 50, .external_lex_state = 2},
  [5320] = {.lex_state = 50, .external_lex_state = 2},
  [5321] = {.lex_state = 0, .external_lex_state = 2},
  [5322] = {.lex_state = 50, .external_lex_state = 2},
  [5323] = {.lex_state = 0, .external_lex_state = 2},
  [5324] = {.lex_state = 0, .external_lex_state = 2},
  [5325] = {.lex_state = 12, .external_lex_state = 2},
  [5326] = {.lex_state = 0, .external_lex_state = 2},
  [5327] = {.lex_state = 50, .external_lex_state = 2},
  [5328] = {.lex_state = 0, .external_lex_state = 2},
  [5329] = {.lex_state = 50, .external_lex_state = 2},
  [5330] = {.lex_state = 0, .external_lex_state = 2},
  [5331] = {.lex_state = 0, .external_lex_state = 2},
  [5332] = {.lex_state = 0, .external_lex_state = 2},
  [5333] = {.lex_state = 50, .external_lex_state = 2},
  [5334] = {.lex_state = 50, .external_lex_state = 2},
  [5335] = {.lex_state = 0, .external_lex_state = 2},
  [5336] = {.lex_state = 0, .external_lex_state = 2},
  [5337] = {.lex_state = 50, .external_lex_state = 2},
  [5338] = {.lex_state = 12, .external_lex_state = 2},
  [5339] = {.lex_state = 11, .external_lex_state = 2},
  [5340] = {.lex_state = 0, .external_lex_state = 2},
  [5341] = {.lex_state = 11, .external_lex_state = 2},
  [5342] = {.lex_state = 0, .external_lex_state = 2},
  [5343] = {.lex_state = 0, .external_lex_state = 2},
  [5344] = {.lex_state = 0, .external_lex_state = 2},
  [5345] = {.lex_state = 0, .external_lex_state = 2},
  [5346] = {.lex_state = 0, .external_lex_state = 2},
  [5347] = {.lex_state = 0, .external_lex_state = 2},
  [5348] = {.lex_state = 0, .external_lex_state = 2},
  [5349] = {.lex_state = 0, .external_lex_state = 2},
  [5350] = {.lex_state = 0, .external_lex_state = 2},
  [5351] = {.lex_state = 50, .external_lex_state = 2},
  [5352] = {.lex_state = 50, .external_lex_state = 2},
  [5353] = {.lex_state = 0, .external_lex_state = 2},
  [5354] = {.lex_state = 0, .external_lex_state = 2},
  [5355] = {.lex_state = 11, .external_lex_state = 2},
  [5356] = {.lex_state = 0, .external_lex_state = 2},
  [5357] = {.lex_state = 0, .external_lex_state = 2},
  [5358] = {.lex_state = 50, .external_lex_state = 2},
  [5359] = {.lex_state = 11, .external_lex_state = 2},
  [5360] = {.lex_state = 50, .external_lex_state = 2},
  [5361] = {.lex_state = 0, .external_lex_state = 2},
  [5362] = {.lex_state = 12, .external_lex_state = 2},
  [5363] = {.lex_state = 0, .external_lex_state = 2},
  [5364] = {.lex_state = 0, .external_lex_state = 2},
  [5365] = {.lex_state = 11, .external_lex_state = 2},
  [5366] = {.lex_state = 0, .external_lex_state = 2},
  [5367] = {.lex_state = 11, .external_lex_state = 2},
  [5368] = {.lex_state = 0, .external_lex_state = 2},
  [5369] = {.lex_state = 0, .external_lex_state = 2},
  [5370] = {.lex_state = 50, .external_lex_state = 2},
  [5371] = {.lex_state = 50, .external_lex_state = 2},
  [5372] = {.lex_state = 11, .external_lex_state = 2},
  [5373] = {.lex_state = 50, .external_lex_state = 2},
  [5374] = {.lex_state = 50, .external_lex_state = 2},
  [5375] = {.lex_state = 50, .external_lex_state = 2},
  [5376] = {.lex_state = 0, .external_lex_state = 2},
  [5377] = {.lex_state = 0, .external_lex_state = 2},
  [5378] = {.lex_state = 0, .external_lex_state = 2},
  [5379] = {.lex_state = 0, .external_lex_state = 2},
  [5380] = {.lex_state = 0, .external_lex_state = 2},
  [5381] = {.lex_state = 0, .external_lex_state = 2},
  [5382] = {.lex_state = 0, .external_lex_state = 2},
  [5383] = {.lex_state = 0, .external_lex_state = 2},
  [5384] = {.lex_state = 0, .external_lex_state = 2},
  [5385] = {.lex_state = 50, .external_lex_state = 2},
  [5386] = {.lex_state = 0, .external_lex_state = 2},
  [5387] = {.lex_state = 50, .external_lex_state = 2},
  [5388] = {.lex_state = 0, .external_lex_state = 2},
  [5389] = {.lex_state = 50, .external_lex_state = 2},
  [5390] = {.lex_state = 50, .external_lex_state = 2},
  [5391] = {.lex_state = 50, .external_lex_state = 2},
  [5392] = {.lex_state = 0, .external_lex_state = 2},
  [5393] = {.lex_state = 0, .external_lex_state = 2},
  [5394] = {.lex_state = 0, .external_lex_state = 2},
  [5395] = {.lex_state = 50, .external_lex_state = 2},
  [5396] = {.lex_state = 11, .external_lex_state = 2},
  [5397] = {.lex_state = 0, .external_lex_state = 2},
  [5398] = {.lex_state = 0, .external_lex_state = 2},
  [5399] = {.lex_state = 11, .external_lex_state = 2},
  [5400] = {.lex_state = 50, .external_lex_state = 2},
  [5401] = {.lex_state = 0, .external_lex_state = 2},
  [5402] = {.lex_state = 0, .external_lex_state = 2},
  [5403] = {.lex_state = 50, .external_lex_state = 2},
  [5404] = {.lex_state = 50, .external_lex_state = 2},
  [5405] = {.lex_state = 12, .external_lex_state = 2},
  [5406] = {.lex_state = 11, .external_lex_state = 2},
  [5407] = {.lex_state = 0, .external_lex_state = 2},
  [5408] = {.lex_state = 0, .external_lex_state = 2},
  [5409] = {.lex_state = 0, .external_lex_state = 2},
  [5410] = {.lex_state = 50, .external_lex_state = 2},
  [5411] = {.lex_state = 11, .external_lex_state = 2},
  [5412] = {.lex_state = 11, .external_lex_state = 2},
  [5413] = {.lex_state = 0, .external_lex_state = 2},
  [5414] = {.lex_state = 0, .external_lex_state = 2},
  [5415] = {.lex_state = 0, .external_lex_state = 2},
  [5416] = {.lex_state = 0, .external_lex_state = 2},
  [5417] = {.lex_state = 0, .external_lex_state = 2},
  [5418] = {.lex_state = 11, .external_lex_state = 2},
  [5419] = {.lex_state = 11, .external_lex_state = 2},
  [5420] = {.lex_state = 11, .external_lex_state = 2},
  [5421] = {.lex_state = 50, .external_lex_state = 2},
  [5422] = {.lex_state = 0, .external_lex_state = 2},
  [5423] = {.lex_state = 0, .external_lex_state = 2},
  [5424] = {.lex_state = 0, .external_lex_state = 2},
  [5425] = {.lex_state = 0, .external_lex_state = 2},
  [5426] = {.lex_state = 0, .external_lex_state = 2},
  [5427] = {.lex_state = 11, .external_lex_state = 2},
  [5428] = {.lex_state = 11, .external_lex_state = 2},
  [5429] = {.lex_state = 0, .external_lex_state = 2},
  [5430] = {.lex_state = 0, .external_lex_state = 2},
  [5431] = {.lex_state = 50, .external_lex_state = 2},
  [5432] = {.lex_state = 50, .external_lex_state = 2},
  [5433] = {.lex_state = 0, .external_lex_state = 2},
  [5434] = {.lex_state = 0, .external_lex_state = 2},
  [5435] = {.lex_state = 0, .external_lex_state = 2},
  [5436] = {.lex_state = 11, .external_lex_state = 2},
  [5437] = {.lex_state = 11, .external_lex_state = 2},
  [5438] = {.lex_state = 0, .external_lex_state = 2},
  [5439] = {.lex_state = 0, .external_lex_state = 2},
  [5440] = {.lex_state = 0, .external_lex_state = 2},
  [5441] = {.lex_state = 50, .external_lex_state = 2},
  [5442] = {.lex_state = 0, .external_lex_state = 2},
  [5443] = {.lex_state = 0, .external_lex_state = 2},
  [5444] = {.lex_state = 0, .external_lex_state = 2},
  [5445] = {.lex_state = 0, .external_lex_state = 2},
  [5446] = {.lex_state = 11, .external_lex_state = 2},
  [5447] = {.lex_state = 0, .external_lex_state = 2},
  [5448] = {.lex_state = 11, .external_lex_state = 2},
  [5449] = {.lex_state = 50, .external_lex_state = 2},
  [5450] = {.lex_state = 0, .external_lex_state = 2},
  [5451] = {.lex_state = 11, .external_lex_state = 2},
  [5452] = {.lex_state = 0, .external_lex_state = 2},
  [5453] = {.lex_state = 11, .external_lex_state = 2},
  [5454] = {.lex_state = 50, .external_lex_state = 2},
  [5455] = {.lex_state = 0, .external_lex_state = 2},
  [5456] = {.lex_state = 50, .external_lex_state = 2},
  [5457] = {.lex_state = 0, .external_lex_state = 2},
  [5458] = {.lex_state = 0, .external_lex_state = 2},
  [5459] = {.lex_state = 0, .external_lex_state = 2},
  [5460] = {.lex_state = 0, .external_lex_state = 2},
  [5461] = {.lex_state = 0, .external_lex_state = 2},
  [5462] = {.lex_state = 0, .external_lex_state = 2},
  [5463] = {.lex_state = 0, .external_lex_state = 2},
  [5464] = {.lex_state = 0, .external_lex_state = 2},
  [5465] = {.lex_state = 0, .external_lex_state = 2},
  [5466] = {.lex_state = 0, .external_lex_state = 2},
  [5467] = {.lex_state = 0, .external_lex_state = 2},
  [5468] = {.lex_state = 0, .external_lex_state = 2},
  [5469] = {.lex_state = 0, .external_lex_state = 2},
  [5470] = {.lex_state = 0, .external_lex_state = 2},
  [5471] = {.lex_state = 0, .external_lex_state = 2},
  [5472] = {.lex_state = 0, .external_lex_state = 2},
  [5473] = {.lex_state = 0, .external_lex_state = 2},
  [5474] = {.lex_state = 0, .external_lex_state = 2},
  [5475] = {.lex_state = 50, .external_lex_state = 2},
  [5476] = {.lex_state = 50, .external_lex_state = 2},
  [5477] = {.lex_state = 11, .external_lex_state = 2},
  [5478] = {.lex_state = 11, .external_lex_state = 2},
  [5479] = {.lex_state = 11, .external_lex_state = 2},
  [5480] = {.lex_state = 0, .external_lex_state = 2},
  [5481] = {.lex_state = 50, .external_lex_state = 2},
  [5482] = {.lex_state = 0, .external_lex_state = 2},
  [5483] = {.lex_state = 0, .external_lex_state = 2},
  [5484] = {.lex_state = 50, .external_lex_state = 2},
  [5485] = {.lex_state = 50, .external_lex_state = 2},
  [5486] = {.lex_state = 0, .external_lex_state = 2},
  [5487] = {.lex_state = 50, .external_lex_state = 2},
  [5488] = {.lex_state = 0, .external_lex_state = 2},
  [5489] = {.lex_state = 11, .external_lex_state = 2},
  [5490] = {.lex_state = 50, .external_lex_state = 2},
  [5491] = {.lex_state = 0, .external_lex_state = 2},
  [5492] = {.lex_state = 50, .external_lex_state = 5},
  [5493] = {.lex_state = 0, .external_lex_state = 2},
  [5494] = {.lex_state = 50, .external_lex_state = 2},
  [5495] = {.lex_state = 0, .external_lex_state = 2},
  [5496] = {.lex_state = 0, .external_lex_state = 2},
  [5497] = {.lex_state = 50, .external_lex_state = 2},
  [5498] = {.lex_state = 0, .external_lex_state = 2},
  [5499] = {.lex_state = 0, .external_lex_state = 2},
  [5500] = {.lex_state = 50, .external_lex_state = 2},
  [5501] = {.lex_state = 50, .external_lex_state = 5},
  [5502] = {.lex_state = 50, .external_lex_state = 2},
  [5503] = {.lex_state = 0, .external_lex_state = 2},
  [5504] = {.lex_state = 0, .external_lex_state = 2},
  [5505] = {.lex_state = 50, .external_lex_state = 2},
  [5506] = {.lex_state = 0, .external_lex_state = 2},
  [5507] = {.lex_state = 0, .external_lex_state = 2},
  [5508] = {.lex_state = 11, .external_lex_state = 2},
  [5509] = {.lex_state = 0, .external_lex_state = 2},
  [5510] = {.lex_state = 50, .external_lex_state = 2},
  [5511] = {.lex_state = 0, .external_lex_state = 2},
  [5512] = {.lex_state = 50, .external_lex_state = 2},
  [5513] = {.lex_state = 0, .external_lex_state = 2},
  [5514] = {.lex_state = 0, .external_lex_state = 2},
  [5515] = {.lex_state = 0, .external_lex_state = 2},
  [5516] = {.lex_state = 50, .external_lex_state = 2},
  [5517] = {.lex_state = 0, .external_lex_state = 2},
  [5518] = {.lex_state = 0, .external_lex_state = 2},
  [5519] = {.lex_state = 50, .external_lex_state = 2},
  [5520] = {.lex_state = 0, .external_lex_state = 2},
  [5521] = {.lex_state = 0, .external_lex_state = 2},
  [5522] = {.lex_state = 11, .external_lex_state = 2},
  [5523] = {.lex_state = 50, .external_lex_state = 2},
  [5524] = {.lex_state = 50, .external_lex_state = 2},
  [5525] = {.lex_state = 0, .external_lex_state = 2},
  [5526] = {.lex_state = 0, .external_lex_state = 2},
  [5527] = {.lex_state = 50, .external_lex_state = 5},
  [5528] = {.lex_state = 0, .external_lex_state = 2},
  [5529] = {.lex_state = 0, .external_lex_state = 2},
  [5530] = {.lex_state = 0, .external_lex_state = 2},
  [5531] = {.lex_state = 50, .external_lex_state = 2},
  [5532] = {.lex_state = 0, .external_lex_state = 2},
  [5533] = {.lex_state = 0, .external_lex_state = 2},
  [5534] = {.lex_state = 11, .external_lex_state = 2},
  [5535] = {.lex_state = 50, .external_lex_state = 2},
  [5536] = {.lex_state = 50, .external_lex_state = 2},
  [5537] = {.lex_state = 50, .external_lex_state = 2},
  [5538] = {.lex_state = 50, .external_lex_state = 5},
  [5539] = {.lex_state = 50, .external_lex_state = 2},
  [5540] = {.lex_state = 50, .external_lex_state = 2},
  [5541] = {.lex_state = 0, .external_lex_state = 2},
  [5542] = {.lex_state = 0, .external_lex_state = 2},
  [5543] = {.lex_state = 50, .external_lex_state = 2},
  [5544] = {.lex_state = 0, .external_lex_state = 2},
  [5545] = {.lex_state = 11, .external_lex_state = 2},
  [5546] = {.lex_state = 0, .external_lex_state = 2},
  [5547] = {.lex_state = 11, .external_lex_state = 2},
  [5548] = {.lex_state = 50, .external_lex_state = 2},
  [5549] = {.lex_state = 0, .external_lex_state = 2},
  [5550] = {.lex_state = 0, .external_lex_state = 2},
  [5551] = {.lex_state = 0, .external_lex_state = 2},
  [5552] = {.lex_state = 0, .external_lex_state = 2},
  [5553] = {.lex_state = 0, .external_lex_state = 2},
  [5554] = {.lex_state = 0, .external_lex_state = 2},
  [5555] = {.lex_state = 0, .external_lex_state = 2},
  [5556] = {.lex_state = 0, .external_lex_state = 2},
  [5557] = {.lex_state = 0, .external_lex_state = 2},
  [5558] = {.lex_state = 50, .external_lex_state = 2},
  [5559] = {.lex_state = 0, .external_lex_state = 2},
  [5560] = {.lex_state = 50, .external_lex_state = 2},
  [5561] = {.lex_state = 0, .external_lex_state = 2},
  [5562] = {.lex_state = 50, .external_lex_state = 2},
  [5563] = {.lex_state = 0, .external_lex_state = 2},
  [5564] = {.lex_state = 0, .external_lex_state = 2},
  [5565] = {.lex_state = 50, .external_lex_state = 2},
  [5566] = {.lex_state = 0, .external_lex_state = 2},
  [5567] = {.lex_state = 0, .external_lex_state = 2},
  [5568] = {.lex_state = 50, .external_lex_state = 2},
  [5569] = {.lex_state = 0, .external_lex_state = 2},
  [5570] = {.lex_state = 0, .external_lex_state = 2},
  [5571] = {.lex_state = 0, .external_lex_state = 2},
  [5572] = {.lex_state = 0, .external_lex_state = 2},
  [5573] = {.lex_state = 11, .external_lex_state = 2},
  [5574] = {.lex_state = 0, .external_lex_state = 2},
  [5575] = {.lex_state = 0, .external_lex_state = 2},
  [5576] = {.lex_state = 11, .external_lex_state = 2},
  [5577] = {.lex_state = 50, .external_lex_state = 2},
  [5578] = {.lex_state = 50, .external_lex_state = 2},
  [5579] = {.lex_state = 0, .external_lex_state = 2},
  [5580] = {.lex_state = 0, .external_lex_state = 2},
  [5581] = {.lex_state = 0, .external_lex_state = 2},
  [5582] = {.lex_state = 0, .external_lex_state = 2},
  [5583] = {.lex_state = 0, .external_lex_state = 2},
  [5584] = {.lex_state = 0, .external_lex_state = 2},
  [5585] = {.lex_state = 0, .external_lex_state = 2},
  [5586] = {.lex_state = 11, .external_lex_state = 2},
  [5587] = {.lex_state = 0, .external_lex_state = 2},
  [5588] = {.lex_state = 0, .external_lex_state = 2},
  [5589] = {.lex_state = 50, .external_lex_state = 5},
  [5590] = {.lex_state = 0, .external_lex_state = 2},
  [5591] = {.lex_state = 50, .external_lex_state = 2},
  [5592] = {.lex_state = 50, .external_lex_state = 2},
  [5593] = {.lex_state = 0, .external_lex_state = 2},
  [5594] = {.lex_state = 50, .external_lex_state = 2},
  [5595] = {.lex_state = 0, .external_lex_state = 2},
  [5596] = {.lex_state = 50, .external_lex_state = 5},
  [5597] = {.lex_state = 50, .external_lex_state = 2},
  [5598] = {.lex_state = 11, .external_lex_state = 2},
  [5599] = {.lex_state = 50, .external_lex_state = 2},
  [5600] = {.lex_state = 0, .external_lex_state = 2},
  [5601] = {.lex_state = 0, .external_lex_state = 2},
  [5602] = {.lex_state = 0, .external_lex_state = 2},
  [5603] = {.lex_state = 0, .external_lex_state = 2},
  [5604] = {.lex_state = 11, .external_lex_state = 2},
  [5605] = {.lex_state = 0, .external_lex_state = 2},
  [5606] = {.lex_state = 0, .external_lex_state = 2},
  [5607] = {.lex_state = 0, .external_lex_state = 2},
  [5608] = {.lex_state = 0, .external_lex_state = 2},
  [5609] = {.lex_state = 0, .external_lex_state = 2},
  [5610] = {.lex_state = 50, .external_lex_state = 2},
  [5611] = {.lex_state = 0, .external_lex_state = 2},
  [5612] = {.lex_state = 11, .external_lex_state = 2},
  [5613] = {.lex_state = 0, .external_lex_state = 2},
  [5614] = {.lex_state = 0, .external_lex_state = 2},
  [5615] = {.lex_state = 0, .external_lex_state = 2},
  [5616] = {.lex_state = 0, .external_lex_state = 2},
  [5617] = {.lex_state = 0, .external_lex_state = 2},
  [5618] = {.lex_state = 50, .external_lex_state = 2},
  [5619] = {.lex_state = 50, .external_lex_state = 2},
  [5620] = {.lex_state = 0, .external_lex_state = 2},
  [5621] = {.lex_state = 0, .external_lex_state = 2},
  [5622] = {.lex_state = 0, .external_lex_state = 2},
  [5623] = {.lex_state = 0, .external_lex_state = 2},
  [5624] = {.lex_state = 50, .external_lex_state = 2},
  [5625] = {.lex_state = 0, .external_lex_state = 2},
  [5626] = {.lex_state = 0, .external_lex_state = 2},
  [5627] = {.lex_state = 0, .external_lex_state = 2},
  [5628] = {.lex_state = 0, .external_lex_state = 2},
  [5629] = {.lex_state = 0, .external_lex_state = 2},
  [5630] = {.lex_state = 0, .external_lex_state = 2},
  [5631] = {.lex_state = 0, .external_lex_state = 2},
  [5632] = {.lex_state = 0, .external_lex_state = 2},
  [5633] = {.lex_state = 0, .external_lex_state = 2},
  [5634] = {.lex_state = 50, .external_lex_state = 2},
  [5635] = {.lex_state = 0, .external_lex_state = 2},
  [5636] = {.lex_state = 0, .external_lex_state = 2},
  [5637] = {.lex_state = 0, .external_lex_state = 2},
  [5638] = {.lex_state = 0, .external_lex_state = 2},
  [5639] = {.lex_state = 0, .external_lex_state = 2},
  [5640] = {.lex_state = 0, .external_lex_state = 2},
  [5641] = {.lex_state = 50, .external_lex_state = 2},
  [5642] = {.lex_state = 0, .external_lex_state = 2},
  [5643] = {.lex_state = 0, .external_lex_state = 2},
  [5644] = {.lex_state = 0, .external_lex_state = 2},
  [5645] = {.lex_state = 0, .external_lex_state = 2},
  [5646] = {.lex_state = 50, .external_lex_state = 2},
  [5647] = {.lex_state = 12, .external_lex_state = 2},
  [5648] = {.lex_state = 50, .external_lex_state = 2},
  [5649] = {.lex_state = 0, .external_lex_state = 2},
  [5650] = {.lex_state = 0, .external_lex_state = 2},
  [5651] = {.lex_state = 0, .external_lex_state = 2},
  [5652] = {.lex_state = 0, .external_lex_state = 2},
  [5653] = {.lex_state = 0, .external_lex_state = 2},
  [5654] = {.lex_state = 0, .external_lex_state = 2},
  [5655] = {.lex_state = 0, .external_lex_state = 2},
  [5656] = {.lex_state = 0, .external_lex_state = 2},
  [5657] = {.lex_state = 50, .external_lex_state = 2},
  [5658] = {.lex_state = 0, .external_lex_state = 2},
  [5659] = {.lex_state = 50, .external_lex_state = 2},
  [5660] = {.lex_state = 0, .external_lex_state = 2},
  [5661] = {.lex_state = 0, .external_lex_state = 2},
  [5662] = {.lex_state = 0, .external_lex_state = 2},
  [5663] = {.lex_state = 0, .external_lex_state = 2},
  [5664] = {.lex_state = 0, .external_lex_state = 2},
  [5665] = {.lex_state = 50, .external_lex_state = 2},
  [5666] = {.lex_state = 0, .external_lex_state = 2},
  [5667] = {.lex_state = 0, .external_lex_state = 2},
  [5668] = {.lex_state = 50, .external_lex_state = 2},
  [5669] = {.lex_state = 0, .external_lex_state = 2},
  [5670] = {.lex_state = 0, .external_lex_state = 2},
  [5671] = {.lex_state = 0, .external_lex_state = 2},
  [5672] = {.lex_state = 0, .external_lex_state = 2},
  [5673] = {.lex_state = 0, .external_lex_state = 2},
  [5674] = {.lex_state = 50, .external_lex_state = 2},
  [5675] = {.lex_state = 0, .external_lex_state = 2},
  [5676] = {.lex_state = 50, .external_lex_state = 2},
  [5677] = {.lex_state = 0, .external_lex_state = 2},
  [5678] = {.lex_state = 0, .external_lex_state = 2},
  [5679] = {.lex_state = 0, .external_lex_state = 2},
  [5680] = {.lex_state = 0, .external_lex_state = 2},
  [5681] = {.lex_state = 0, .external_lex_state = 2},
  [5682] = {.lex_state = 155, .external_lex_state = 2},
  [5683] = {.lex_state = 159, .external_lex_state = 2},
  [5684] = {.lex_state = 163, .external_lex_state = 2},
  [5685] = {.lex_state = 50, .external_lex_state = 2},
  [5686] = {.lex_state = 0, .external_lex_state = 2},
  [5687] = {.lex_state = 50, .external_lex_state = 2},
  [5688] = {.lex_state = 0, .external_lex_state = 2},
  [5689] = {.lex_state = 0, .external_lex_state = 2},
  [5690] = {.lex_state = 0, .external_lex_state = 2},
  [5691] = {.lex_state = 50, .external_lex_state = 2},
  [5692] = {.lex_state = 50, .external_lex_state = 2},
  [5693] = {.lex_state = 50, .external_lex_state = 2},
  [5694] = {.lex_state = 0, .external_lex_state = 2},
  [5695] = {.lex_state = 0, .external_lex_state = 2},
  [5696] = {.lex_state = 0, .external_lex_state = 2},
  [5697] = {.lex_state = 0, .external_lex_state = 2},
  [5698] = {.lex_state = 0, .external_lex_state = 2},
  [5699] = {.lex_state = 0, .external_lex_state = 2},
  [5700] = {.lex_state = 0, .external_lex_state = 2},
  [5701] = {.lex_state = 0, .external_lex_state = 2},
  [5702] = {.lex_state = 0, .external_lex_state = 2},
  [5703] = {.lex_state = 50, .external_lex_state = 2},
  [5704] = {.lex_state = 0, .external_lex_state = 2},
  [5705] = {.lex_state = 0, .external_lex_state = 2},
  [5706] = {.lex_state = 0, .external_lex_state = 2},
  [5707] = {.lex_state = 0, .external_lex_state = 2},
  [5708] = {.lex_state = 0, .external_lex_state = 2},
  [5709] = {.lex_state = 0, .external_lex_state = 2},
  [5710] = {.lex_state = 0, .external_lex_state = 2},
  [5711] = {.lex_state = 0, .external_lex_state = 2},
  [5712] = {.lex_state = 0, .external_lex_state = 2},
  [5713] = {.lex_state = 0, .external_lex_state = 2},
  [5714] = {.lex_state = 50, .external_lex_state = 2},
  [5715] = {.lex_state = 50, .external_lex_state = 2},
  [5716] = {.lex_state = 0, .external_lex_state = 2},
  [5717] = {.lex_state = 0, .external_lex_state = 2},
  [5718] = {.lex_state = 0, .external_lex_state = 2},
  [5719] = {.lex_state = 0, .external_lex_state = 2},
  [5720] = {.lex_state = 0, .external_lex_state = 2},
  [5721] = {.lex_state = 0, .external_lex_state = 2},
  [5722] = {.lex_state = 0, .external_lex_state = 2},
  [5723] = {.lex_state = 0, .external_lex_state = 2},
  [5724] = {.lex_state = 0, .external_lex_state = 2},
  [5725] = {.lex_state = 0, .external_lex_state = 2},
  [5726] = {.lex_state = 0, .external_lex_state = 2},
  [5727] = {.lex_state = 0, .external_lex_state = 2},
  [5728] = {.lex_state = 0, .external_lex_state = 2},
  [5729] = {.lex_state = 0, .external_lex_state = 2},
  [5730] = {.lex_state = 0, .external_lex_state = 2},
  [5731] = {.lex_state = 0, .external_lex_state = 2},
  [5732] = {.lex_state = 0, .external_lex_state = 2},
  [5733] = {.lex_state = 0, .external_lex_state = 2},
  [5734] = {.lex_state = 0, .external_lex_state = 2},
  [5735] = {.lex_state = 0, .external_lex_state = 2},
  [5736] = {.lex_state = 0, .external_lex_state = 2},
  [5737] = {.lex_state = 0, .external_lex_state = 2},
  [5738] = {.lex_state = 0, .external_lex_state = 2},
  [5739] = {.lex_state = 0, .external_lex_state = 2},
  [5740] = {.lex_state = 0, .external_lex_state = 2},
  [5741] = {.lex_state = 0, .external_lex_state = 2},
  [5742] = {.lex_state = 0, .external_lex_state = 2},
  [5743] = {.lex_state = 0, .external_lex_state = 2},
  [5744] = {.lex_state = 0, .external_lex_state = 2},
  [5745] = {.lex_state = 0, .external_lex_state = 2},
  [5746] = {.lex_state = 0, .external_lex_state = 2},
  [5747] = {.lex_state = 0, .external_lex_state = 2},
  [5748] = {.lex_state = 0, .external_lex_state = 2},
  [5749] = {.lex_state = 0, .external_lex_state = 2},
  [5750] = {.lex_state = 0, .external_lex_state = 2},
  [5751] = {.lex_state = 0, .external_lex_state = 2},
  [5752] = {.lex_state = 0, .external_lex_state = 2},
  [5753] = {.lex_state = 0, .external_lex_state = 2},
  [5754] = {.lex_state = 0, .external_lex_state = 2},
  [5755] = {.lex_state = 0, .external_lex_state = 2},
  [5756] = {.lex_state = 0, .external_lex_state = 2},
  [5757] = {.lex_state = 0, .external_lex_state = 2},
  [5758] = {.lex_state = 0, .external_lex_state = 2},
  [5759] = {.lex_state = 0, .external_lex_state = 2},
  [5760] = {.lex_state = 0, .external_lex_state = 2},
  [5761] = {.lex_state = 0, .external_lex_state = 2},
  [5762] = {.lex_state = 0, .external_lex_state = 2},
  [5763] = {.lex_state = 50, .external_lex_state = 2},
  [5764] = {.lex_state = 0, .external_lex_state = 2},
  [5765] = {.lex_state = 0, .external_lex_state = 2},
  [5766] = {.lex_state = 0, .external_lex_state = 2},
  [5767] = {.lex_state = 50, .external_lex_state = 2},
  [5768] = {.lex_state = 50, .external_lex_state = 2},
  [5769] = {.lex_state = 50, .external_lex_state = 2},
  [5770] = {.lex_state = 50, .external_lex_state = 2},
  [5771] = {.lex_state = 0, .external_lex_state = 2},
  [5772] = {.lex_state = 50, .external_lex_state = 2},
  [5773] = {.lex_state = 0, .external_lex_state = 2},
  [5774] = {.lex_state = 50, .external_lex_state = 2},
  [5775] = {.lex_state = 0, .external_lex_state = 2},
  [5776] = {.lex_state = 0, .external_lex_state = 2},
  [5777] = {.lex_state = 0, .external_lex_state = 2},
  [5778] = {.lex_state = 0, .external_lex_state = 2},
  [5779] = {.lex_state = 50, .external_lex_state = 2},
  [5780] = {.lex_state = 50, .external_lex_state = 2},
  [5781] = {.lex_state = 50, .external_lex_state = 2},
  [5782] = {.lex_state = 0, .external_lex_state = 2},
  [5783] = {.lex_state = 0, .external_lex_state = 2},
  [5784] = {.lex_state = 0, .external_lex_state = 2},
  [5785] = {.lex_state = 0, .external_lex_state = 2},
  [5786] = {.lex_state = 0, .external_lex_state = 2},
  [5787] = {.lex_state = 0, .external_lex_state = 2},
  [5788] = {.lex_state = 0, .external_lex_state = 2},
  [5789] = {.lex_state = 0, .external_lex_state = 2},
  [5790] = {.lex_state = 0, .external_lex_state = 2},
  [5791] = {.lex_state = 0, .external_lex_state = 2},
  [5792] = {.lex_state = 50, .external_lex_state = 2},
  [5793] = {.lex_state = 0, .external_lex_state = 2},
  [5794] = {.lex_state = 0, .external_lex_state = 2},
  [5795] = {.lex_state = 50, .external_lex_state = 2},
  [5796] = {.lex_state = 0, .external_lex_state = 2},
  [5797] = {.lex_state = 0, .external_lex_state = 2},
  [5798] = {.lex_state = 155, .external_lex_state = 2},
  [5799] = {.lex_state = 159, .external_lex_state = 2},
  [5800] = {.lex_state = 163, .external_lex_state = 2},
  [5801] = {.lex_state = 0, .external_lex_state = 2},
  [5802] = {.lex_state = 0, .external_lex_state = 2},
  [5803] = {.lex_state = 0, .external_lex_state = 2},
  [5804] = {.lex_state = 0, .external_lex_state = 2},
  [5805] = {.lex_state = 0, .external_lex_state = 2},
  [5806] = {.lex_state = 0, .external_lex_state = 2},
  [5807] = {.lex_state = 50, .external_lex_state = 2},
  [5808] = {.lex_state = 50, .external_lex_state = 2},
  [5809] = {.lex_state = 50, .external_lex_state = 2},
  [5810] = {.lex_state = 0, .external_lex_state = 2},
  [5811] = {.lex_state = 0, .external_lex_state = 2},
  [5812] = {.lex_state = 50, .external_lex_state = 2},
  [5813] = {.lex_state = 0, .external_lex_state = 2},
  [5814] = {.lex_state = 0, .external_lex_state = 2},
  [5815] = {.lex_state = 0, .external_lex_state = 2},
  [5816] = {.lex_state = 0, .external_lex_state = 2},
  [5817] = {.lex_state = 0, .external_lex_state = 2},
  [5818] = {.lex_state = 0, .external_lex_state = 2},
  [5819] = {.lex_state = 0, .external_lex_state = 2},
  [5820] = {.lex_state = 0, .external_lex_state = 2},
  [5821] = {.lex_state = 163, .external_lex_state = 2},
  [5822] = {.lex_state = 159, .external_lex_state = 2},
  [5823] = {.lex_state = 50, .external_lex_state = 2},
  [5824] = {.lex_state = 50, .external_lex_state = 2},
  [5825] = {.lex_state = 0, .external_lex_state = 2},
  [5826] = {.lex_state = 0, .external_lex_state = 2},
  [5827] = {.lex_state = 0, .external_lex_state = 2},
  [5828] = {.lex_state = 155, .external_lex_state = 2},
  [5829] = {.lex_state = 0, .external_lex_state = 2},
  [5830] = {.lex_state = 0, .external_lex_state = 2},
  [5831] = {.lex_state = 0, .external_lex_state = 2},
  [5832] = {.lex_state = 0, .external_lex_state = 2},
  [5833] = {.lex_state = 0, .external_lex_state = 2},
  [5834] = {.lex_state = 0, .external_lex_state = 2},
  [5835] = {.lex_state = 0, .external_lex_state = 2},
  [5836] = {.lex_state = 50, .external_lex_state = 2},
  [5837] = {.lex_state = 50, .external_lex_state = 2},
  [5838] = {.lex_state = 0, .external_lex_state = 2},
  [5839] = {.lex_state = 0, .external_lex_state = 2},
  [5840] = {.lex_state = 0, .external_lex_state = 2},
  [5841] = {.lex_state = 0, .external_lex_state = 2},
  [5842] = {.lex_state = 0, .external_lex_state = 2},
  [5843] = {.lex_state = 0, .external_lex_state = 2},
  [5844] = {.lex_state = 0, .external_lex_state = 2},
  [5845] = {.lex_state = 0, .external_lex_state = 2},
  [5846] = {.lex_state = 0, .external_lex_state = 2},
  [5847] = {.lex_state = 50, .external_lex_state = 2},
  [5848] = {.lex_state = 0, .external_lex_state = 2},
  [5849] = {.lex_state = 0, .external_lex_state = 2},
  [5850] = {.lex_state = 0, .external_lex_state = 2},
  [5851] = {.lex_state = 0, .external_lex_state = 2},
  [5852] = {.lex_state = 0, .external_lex_state = 2},
  [5853] = {.lex_state = 0, .external_lex_state = 2},
  [5854] = {.lex_state = 0, .external_lex_state = 2},
  [5855] = {.lex_state = 0, .external_lex_state = 2},
  [5856] = {.lex_state = 0, .external_lex_state = 2},
  [5857] = {.lex_state = 0, .external_lex_state = 2},
  [5858] = {.lex_state = 0, .external_lex_state = 2},
  [5859] = {.lex_state = 0, .external_lex_state = 2},
  [5860] = {.lex_state = 0, .external_lex_state = 2},
  [5861] = {.lex_state = 0, .external_lex_state = 2},
  [5862] = {.lex_state = 50, .external_lex_state = 2},
  [5863] = {.lex_state = 0, .external_lex_state = 2},
  [5864] = {.lex_state = 0, .external_lex_state = 2},
  [5865] = {.lex_state = 0, .external_lex_state = 2},
  [5866] = {.lex_state = 0, .external_lex_state = 2},
  [5867] = {.lex_state = 0, .external_lex_state = 2},
  [5868] = {.lex_state = 0, .external_lex_state = 2},
  [5869] = {.lex_state = 0, .external_lex_state = 2},
  [5870] = {.lex_state = 0, .external_lex_state = 2},
  [5871] = {.lex_state = 0, .external_lex_state = 2},
  [5872] = {.lex_state = 0, .external_lex_state = 2},
  [5873] = {.lex_state = 50, .external_lex_state = 2},
  [5874] = {.lex_state = 50, .external_lex_state = 2},
  [5875] = {.lex_state = 0, .external_lex_state = 2},
  [5876] = {.lex_state = 0, .external_lex_state = 2},
  [5877] = {.lex_state = 12, .external_lex_state = 2},
  [5878] = {.lex_state = 155, .external_lex_state = 2},
  [5879] = {.lex_state = 159, .external_lex_state = 2},
  [5880] = {.lex_state = 163, .external_lex_state = 2},
  [5881] = {.lex_state = 0, .external_lex_state = 2},
  [5882] = {.lex_state = 0, .external_lex_state = 2},
  [5883] = {.lex_state = 0, .external_lex_state = 2},
  [5884] = {.lex_state = 0, .external_lex_state = 2},
  [5885] = {.lex_state = 50, .external_lex_state = 2},
  [5886] = {.lex_state = 50, .external_lex_state = 2},
  [5887] = {.lex_state = 0, .external_lex_state = 2},
  [5888] = {.lex_state = 0, .external_lex_state = 2},
  [5889] = {.lex_state = 50, .external_lex_state = 2},
  [5890] = {.lex_state = 50, .external_lex_state = 2},
  [5891] = {.lex_state = 50, .external_lex_state = 2},
  [5892] = {.lex_state = 50, .external_lex_state = 2},
  [5893] = {.lex_state = 0, .external_lex_state = 2},
  [5894] = {.lex_state = 0, .external_lex_state = 2},
  [5895] = {.lex_state = 0, .external_lex_state = 2},
  [5896] = {.lex_state = 0, .external_lex_state = 2},
  [5897] = {.lex_state = 0, .external_lex_state = 2},
  [5898] = {.lex_state = 0, .external_lex_state = 2},
  [5899] = {.lex_state = 0, .external_lex_state = 2},
  [5900] = {.lex_state = 0, .external_lex_state = 2},
  [5901] = {.lex_state = 0, .external_lex_state = 2},
  [5902] = {.lex_state = 0, .external_lex_state = 2},
  [5903] = {.lex_state = 0, .external_lex_state = 2},
  [5904] = {.lex_state = 0, .external_lex_state = 2},
  [5905] = {.lex_state = 0, .external_lex_state = 2},
  [5906] = {.lex_state = 0, .external_lex_state = 2},
  [5907] = {.lex_state = 0, .external_lex_state = 2},
  [5908] = {.lex_state = 0, .external_lex_state = 2},
  [5909] = {.lex_state = 0, .external_lex_state = 2},
  [5910] = {.lex_state = 0, .external_lex_state = 2},
  [5911] = {.lex_state = 0, .external_lex_state = 2},
  [5912] = {.lex_state = 50, .external_lex_state = 2},
  [5913] = {.lex_state = 0, .external_lex_state = 2},
  [5914] = {.lex_state = 0, .external_lex_state = 2},
  [5915] = {.lex_state = 0, .external_lex_state = 2},
  [5916] = {.lex_state = 0, .external_lex_state = 2},
  [5917] = {.lex_state = 0, .external_lex_state = 2},
  [5918] = {.lex_state = 0, .external_lex_state = 2},
  [5919] = {.lex_state = 0, .external_lex_state = 2},
  [5920] = {.lex_state = 0, .external_lex_state = 2},
  [5921] = {.lex_state = 50, .external_lex_state = 2},
  [5922] = {.lex_state = 155, .external_lex_state = 2},
  [5923] = {.lex_state = 159, .external_lex_state = 2},
  [5924] = {.lex_state = 163, .external_lex_state = 2},
  [5925] = {.lex_state = 0, .external_lex_state = 2},
  [5926] = {.lex_state = 0, .external_lex_state = 2},
  [5927] = {.lex_state = 0, .external_lex_state = 2},
  [5928] = {.lex_state = 50, .external_lex_state = 2},
  [5929] = {.lex_state = 0, .external_lex_state = 2},
  [5930] = {.lex_state = 0, .external_lex_state = 2},
  [5931] = {.lex_state = 0, .external_lex_state = 2},
  [5932] = {.lex_state = 0, .external_lex_state = 2},
  [5933] = {.lex_state = 0, .external_lex_state = 2},
  [5934] = {.lex_state = 0, .external_lex_state = 2},
  [5935] = {.lex_state = 0, .external_lex_state = 2},
  [5936] = {.lex_state = 0, .external_lex_state = 2},
  [5937] = {.lex_state = 0, .external_lex_state = 2},
  [5938] = {.lex_state = 0, .external_lex_state = 2},
  [5939] = {.lex_state = 0, .external_lex_state = 2},
  [5940] = {.lex_state = 0, .external_lex_state = 2},
  [5941] = {.lex_state = 0, .external_lex_state = 2},
  [5942] = {.lex_state = 0, .external_lex_state = 2},
  [5943] = {.lex_state = 0, .external_lex_state = 2},
  [5944] = {.lex_state = 0, .external_lex_state = 2},
  [5945] = {.lex_state = 50, .external_lex_state = 2},
  [5946] = {.lex_state = 0, .external_lex_state = 2},
  [5947] = {.lex_state = 0, .external_lex_state = 2},
  [5948] = {.lex_state = 0, .external_lex_state = 2},
  [5949] = {.lex_state = 0, .external_lex_state = 2},
  [5950] = {.lex_state = 0, .external_lex_state = 2},
  [5951] = {.lex_state = 0, .external_lex_state = 2},
  [5952] = {.lex_state = 0, .external_lex_state = 2},
  [5953] = {.lex_state = 0, .external_lex_state = 2},
  [5954] = {.lex_state = 155, .external_lex_state = 2},
  [5955] = {.lex_state = 159, .external_lex_state = 2},
  [5956] = {.lex_state = 163, .external_lex_state = 2},
  [5957] = {.lex_state = 0, .external_lex_state = 2},
  [5958] = {.lex_state = 0, .external_lex_state = 2},
  [5959] = {.lex_state = 0, .external_lex_state = 2},
  [5960] = {.lex_state = 0, .external_lex_state = 2},
  [5961] = {.lex_state = 0, .external_lex_state = 2},
  [5962] = {.lex_state = 0, .external_lex_state = 2},
  [5963] = {.lex_state = 0, .external_lex_state = 2},
  [5964] = {.lex_state = 0, .external_lex_state = 2},
  [5965] = {.lex_state = 0, .external_lex_state = 2},
  [5966] = {.lex_state = 0, .external_lex_state = 2},
  [5967] = {.lex_state = 0, .external_lex_state = 2},
  [5968] = {.lex_state = 0, .external_lex_state = 2},
  [5969] = {.lex_state = 0, .external_lex_state = 2},
  [5970] = {.lex_state = 0, .external_lex_state = 2},
  [5971] = {.lex_state = 0, .external_lex_state = 2},
  [5972] = {.lex_state = 0, .external_lex_state = 2},
  [5973] = {.lex_state = 0, .external_lex_state = 2},
  [5974] = {.lex_state = 0, .external_lex_state = 2},
  [5975] = {.lex_state = 0, .external_lex_state = 2},
  [5976] = {.lex_state = 0, .external_lex_state = 2},
  [5977] = {.lex_state = 0, .external_lex_state = 2},
  [5978] = {.lex_state = 0, .external_lex_state = 2},
  [5979] = {.lex_state = 0, .external_lex_state = 2},
  [5980] = {.lex_state = 0, .external_lex_state = 2},
  [5981] = {.lex_state = 0, .external_lex_state = 2},
  [5982] = {.lex_state = 0, .external_lex_state = 2},
  [5983] = {.lex_state = 0, .external_lex_state = 2},
  [5984] = {.lex_state = 50, .external_lex_state = 2},
  [5985] = {.lex_state = 155, .external_lex_state = 2},
  [5986] = {.lex_state = 159, .external_lex_state = 2},
  [5987] = {.lex_state = 163, .external_lex_state = 2},
  [5988] = {.lex_state = 50, .external_lex_state = 2},
  [5989] = {.lex_state = 0, .external_lex_state = 2},
  [5990] = {.lex_state = 0, .external_lex_state = 2},
  [5991] = {.lex_state = 0, .external_lex_state = 2},
  [5992] = {.lex_state = 0, .external_lex_state = 2},
  [5993] = {.lex_state = 12, .external_lex_state = 2},
  [5994] = {.lex_state = 0, .external_lex_state = 2},
  [5995] = {.lex_state = 0, .external_lex_state = 2},
  [5996] = {.lex_state = 0, .external_lex_state = 2},
  [5997] = {.lex_state = 0, .external_lex_state = 2},
  [5998] = {.lex_state = 0, .external_lex_state = 2},
  [5999] = {.lex_state = 0, .external_lex_state = 2},
  [6000] = {.lex_state = 0, .external_lex_state = 2},
  [6001] = {.lex_state = 0, .external_lex_state = 2},
  [6002] = {.lex_state = 0, .external_lex_state = 2},
  [6003] = {.lex_state = 0, .external_lex_state = 2},
  [6004] = {.lex_state = 0, .external_lex_state = 2},
  [6005] = {.lex_state = 0, .external_lex_state = 2},
  [6006] = {.lex_state = 0, .external_lex_state = 2},
  [6007] = {.lex_state = 0, .external_lex_state = 2},
  [6008] = {.lex_state = 0, .external_lex_state = 2},
  [6009] = {.lex_state = 0, .external_lex_state = 2},
  [6010] = {.lex_state = 0, .external_lex_state = 2},
  [6011] = {.lex_state = 0, .external_lex_state = 2},
  [6012] = {.lex_state = 0, .external_lex_state = 2},
  [6013] = {.lex_state = 0, .external_lex_state = 2},
  [6014] = {.lex_state = 0, .external_lex_state = 2},
  [6015] = {.lex_state = 155, .external_lex_state = 2},
  [6016] = {.lex_state = 159, .external_lex_state = 2},
  [6017] = {.lex_state = 163, .external_lex_state = 2},
  [6018] = {.lex_state = 0, .external_lex_state = 2},
  [6019] = {.lex_state = 0, .external_lex_state = 2},
  [6020] = {.lex_state = 0, .external_lex_state = 2},
  [6021] = {.lex_state = 0, .external_lex_state = 2},
  [6022] = {.lex_state = 0, .external_lex_state = 2},
  [6023] = {.lex_state = 0, .external_lex_state = 2},
  [6024] = {.lex_state = 0, .external_lex_state = 2},
  [6025] = {.lex_state = 0, .external_lex_state = 2},
  [6026] = {.lex_state = 11, .external_lex_state = 2},
  [6027] = {.lex_state = 0, .external_lex_state = 2},
  [6028] = {.lex_state = 0, .external_lex_state = 2},
  [6029] = {.lex_state = 0, .external_lex_state = 2},
  [6030] = {.lex_state = 0, .external_lex_state = 2},
  [6031] = {.lex_state = 0, .external_lex_state = 2},
  [6032] = {.lex_state = 50, .external_lex_state = 2},
  [6033] = {.lex_state = 0, .external_lex_state = 2},
  [6034] = {.lex_state = 0, .external_lex_state = 2},
  [6035] = {.lex_state = 0, .external_lex_state = 2},
  [6036] = {.lex_state = 0, .external_lex_state = 2},
  [6037] = {.lex_state = 0, .external_lex_state = 2},
  [6038] = {.lex_state = 0, .external_lex_state = 2},
  [6039] = {.lex_state = 0, .external_lex_state = 2},
  [6040] = {.lex_state = 0, .external_lex_state = 2},
  [6041] = {.lex_state = 0, .external_lex_state = 2},
  [6042] = {.lex_state = 155, .external_lex_state = 2},
  [6043] = {.lex_state = 159, .external_lex_state = 2},
  [6044] = {.lex_state = 163, .external_lex_state = 2},
  [6045] = {.lex_state = 50, .external_lex_state = 2},
  [6046] = {.lex_state = 0, .external_lex_state = 2},
  [6047] = {.lex_state = 155, .external_lex_state = 2},
  [6048] = {.lex_state = 159, .external_lex_state = 2},
  [6049] = {.lex_state = 163, .external_lex_state = 2},
  [6050] = {.lex_state = 0, .external_lex_state = 2},
  [6051] = {.lex_state = 155, .external_lex_state = 2},
  [6052] = {.lex_state = 159, .external_lex_state = 2},
  [6053] = {.lex_state = 163, .external_lex_state = 2},
  [6054] = {.lex_state = 50, .external_lex_state = 2},
  [6055] = {.lex_state = 0, .external_lex_state = 2},
  [6056] = {.lex_state = 50, .external_lex_state = 2},
  [6057] = {.lex_state = 0, .external_lex_state = 2},
  [6058] = {.lex_state = 50, .external_lex_state = 2},
  [6059] = {.lex_state = 0, .external_lex_state = 2},
  [6060] = {.lex_state = 0, .external_lex_state = 2},
  [6061] = {.lex_state = 0, .external_lex_state = 2},
  [6062] = {.lex_state = 50, .external_lex_state = 2},
  [6063] = {.lex_state = 0, .external_lex_state = 2},
  [6064] = {.lex_state = 0, .external_lex_state = 2},
  [6065] = {.lex_state = 0, .external_lex_state = 2},
  [6066] = {.lex_state = 0, .external_lex_state = 2},
  [6067] = {.lex_state = 50, .external_lex_state = 2},
  [6068] = {.lex_state = 0, .external_lex_state = 2},
  [6069] = {.lex_state = 12, .external_lex_state = 2},
  [6070] = {.lex_state = 12, .external_lex_state = 2},
  [6071] = {.lex_state = 0, .external_lex_state = 2},
  [6072] = {.lex_state = 0, .external_lex_state = 2},
  [6073] = {.lex_state = 50, .external_lex_state = 2},
  [6074] = {.lex_state = 50, .external_lex_state = 2},
  [6075] = {.lex_state = 50, .external_lex_state = 2},
  [6076] = {.lex_state = 0, .external_lex_state = 2},
  [6077] = {.lex_state = 0, .external_lex_state = 2},
  [6078] = {.lex_state = 0, .external_lex_state = 2},
  [6079] = {.lex_state = 0, .external_lex_state = 2},
  [6080] = {.lex_state = 0, .external_lex_state = 2},
  [6081] = {.lex_state = 50, .external_lex_state = 2},
  [6082] = {.lex_state = 0, .external_lex_state = 2},
  [6083] = {.lex_state = 0, .external_lex_state = 2},
  [6084] = {.lex_state = 0, .external_lex_state = 2},
  [6085] = {.lex_state = 0, .external_lex_state = 2},
  [6086] = {.lex_state = 0, .external_lex_state = 2},
  [6087] = {.lex_state = 0, .external_lex_state = 2},
  [6088] = {.lex_state = 50, .external_lex_state = 2},
  [6089] = {.lex_state = 50, .external_lex_state = 2},
  [6090] = {.lex_state = 0, .external_lex_state = 2},
  [6091] = {.lex_state = 0, .external_lex_state = 2},
  [6092] = {.lex_state = 0, .external_lex_state = 2},
  [6093] = {.lex_state = 0, .external_lex_state = 2},
  [6094] = {.lex_state = 0, .external_lex_state = 2},
  [6095] = {.lex_state = 0, .external_lex_state = 2},
  [6096] = {.lex_state = 50, .external_lex_state = 2},
  [6097] = {.lex_state = 0, .external_lex_state = 2},
  [6098] = {.lex_state = 0, .external_lex_state = 2},
  [6099] = {.lex_state = 0, .external_lex_state = 2},
  [6100] = {.lex_state = 0, .external_lex_state = 2},
  [6101] = {.lex_state = 0, .external_lex_state = 2},
  [6102] = {.lex_state = 50, .external_lex_state = 2},
  [6103] = {.lex_state = 50, .external_lex_state = 2},
  [6104] = {.lex_state = 0, .external_lex_state = 2},
  [6105] = {.lex_state = 0, .external_lex_state = 2},
  [6106] = {.lex_state = 0, .external_lex_state = 2},
  [6107] = {.lex_state = 0, .external_lex_state = 2},
  [6108] = {.lex_state = 0, .external_lex_state = 2},
  [6109] = {.lex_state = 0, .external_lex_state = 2},
  [6110] = {.lex_state = 0, .external_lex_state = 2},
  [6111] = {.lex_state = 0, .external_lex_state = 2},
  [6112] = {.lex_state = 0, .external_lex_state = 2},
  [6113] = {.lex_state = 0, .external_lex_state = 2},
  [6114] = {.lex_state = 0, .external_lex_state = 2},
  [6115] = {.lex_state = 0, .external_lex_state = 2},
  [6116] = {.lex_state = 0, .external_lex_state = 2},
  [6117] = {.lex_state = 0, .external_lex_state = 2},
  [6118] = {.lex_state = 0, .external_lex_state = 2},
  [6119] = {.lex_state = 0, .external_lex_state = 2},
  [6120] = {.lex_state = 50, .external_lex_state = 2},
  [6121] = {.lex_state = 0, .external_lex_state = 2},
  [6122] = {.lex_state = 0, .external_lex_state = 2},
  [6123] = {.lex_state = 50, .external_lex_state = 2},
  [6124] = {.lex_state = 0, .external_lex_state = 2},
  [6125] = {.lex_state = 50, .external_lex_state = 2},
  [6126] = {.lex_state = 0, .external_lex_state = 2},
  [6127] = {.lex_state = 0, .external_lex_state = 2},
  [6128] = {.lex_state = 0, .external_lex_state = 2},
  [6129] = {.lex_state = 0, .external_lex_state = 2},
  [6130] = {.lex_state = 0, .external_lex_state = 2},
  [6131] = {.lex_state = 0, .external_lex_state = 2},
  [6132] = {.lex_state = 0, .external_lex_state = 2},
  [6133] = {.lex_state = 0, .external_lex_state = 2},
  [6134] = {.lex_state = 0, .external_lex_state = 2},
  [6135] = {.lex_state = 0, .external_lex_state = 2},
  [6136] = {.lex_state = 0, .external_lex_state = 2},
  [6137] = {.lex_state = 0, .external_lex_state = 2},
  [6138] = {.lex_state = 0, .external_lex_state = 2},
  [6139] = {.lex_state = 0, .external_lex_state = 2},
  [6140] = {.lex_state = 0, .external_lex_state = 2},
  [6141] = {.lex_state = 0, .external_lex_state = 2},
  [6142] = {.lex_state = 0, .external_lex_state = 2},
  [6143] = {.lex_state = 50, .external_lex_state = 2},
  [6144] = {.lex_state = 50, .external_lex_state = 2},
  [6145] = {.lex_state = 0, .external_lex_state = 2},
  [6146] = {.lex_state = 0, .external_lex_state = 2},
  [6147] = {.lex_state = 0, .external_lex_state = 2},
  [6148] = {.lex_state = 0, .external_lex_state = 2},
  [6149] = {.lex_state = 50, .external_lex_state = 2},
  [6150] = {.lex_state = 0, .external_lex_state = 2},
  [6151] = {.lex_state = 0, .external_lex_state = 2},
  [6152] = {.lex_state = 0, .external_lex_state = 2},
  [6153] = {.lex_state = 0, .external_lex_state = 2},
  [6154] = {.lex_state = 0, .external_lex_state = 2},
  [6155] = {.lex_state = 0, .external_lex_state = 2},
  [6156] = {.lex_state = 0, .external_lex_state = 2},
  [6157] = {.lex_state = 0, .external_lex_state = 2},
  [6158] = {.lex_state = 0, .external_lex_state = 2},
  [6159] = {.lex_state = 0, .external_lex_state = 2},
  [6160] = {.lex_state = 50, .external_lex_state = 2},
  [6161] = {.lex_state = 0, .external_lex_state = 2},
  [6162] = {.lex_state = 0, .external_lex_state = 2},
  [6163] = {.lex_state = 50, .external_lex_state = 2},
  [6164] = {.lex_state = 0, .external_lex_state = 2},
  [6165] = {.lex_state = 0, .external_lex_state = 2},
  [6166] = {.lex_state = 12, .external_lex_state = 2},
  [6167] = {.lex_state = 0, .external_lex_state = 2},
  [6168] = {.lex_state = 0, .external_lex_state = 2},
  [6169] = {.lex_state = 50, .external_lex_state = 2},
  [6170] = {.lex_state = 0, .external_lex_state = 2},
  [6171] = {.lex_state = 50, .external_lex_state = 2},
  [6172] = {.lex_state = 0, .external_lex_state = 2},
  [6173] = {.lex_state = 0, .external_lex_state = 2},
  [6174] = {.lex_state = 50, .external_lex_state = 2},
  [6175] = {.lex_state = 0, .external_lex_state = 2},
  [6176] = {.lex_state = 0, .external_lex_state = 2},
  [6177] = {.lex_state = 0, .external_lex_state = 2},
  [6178] = {.lex_state = 0, .external_lex_state = 2},
  [6179] = {.lex_state = 0, .external_lex_state = 2},
  [6180] = {.lex_state = 0, .external_lex_state = 2},
  [6181] = {.lex_state = 0, .external_lex_state = 2},
  [6182] = {.lex_state = 0, .external_lex_state = 2},
  [6183] = {.lex_state = 0, .external_lex_state = 2},
  [6184] = {.lex_state = 0, .external_lex_state = 2},
  [6185] = {.lex_state = 0, .external_lex_state = 2},
  [6186] = {.lex_state = 0, .external_lex_state = 2},
  [6187] = {.lex_state = 50, .external_lex_state = 2},
  [6188] = {.lex_state = 0, .external_lex_state = 2},
  [6189] = {.lex_state = 50, .external_lex_state = 2},
  [6190] = {.lex_state = 0, .external_lex_state = 2},
  [6191] = {.lex_state = 0, .external_lex_state = 2},
  [6192] = {.lex_state = 0, .external_lex_state = 2},
  [6193] = {.lex_state = 0, .external_lex_state = 2},
  [6194] = {.lex_state = 0, .external_lex_state = 2},
  [6195] = {.lex_state = 0, .external_lex_state = 2},
  [6196] = {.lex_state = 0, .external_lex_state = 2},
  [6197] = {.lex_state = 0, .external_lex_state = 2},
  [6198] = {.lex_state = 0, .external_lex_state = 2},
  [6199] = {.lex_state = 0, .external_lex_state = 2},
  [6200] = {.lex_state = 50, .external_lex_state = 2},
  [6201] = {.lex_state = 0, .external_lex_state = 2},
  [6202] = {.lex_state = 0, .external_lex_state = 2},
  [6203] = {.lex_state = 0, .external_lex_state = 2},
  [6204] = {.lex_state = 50, .external_lex_state = 2},
  [6205] = {.lex_state = 0, .external_lex_state = 2},
  [6206] = {.lex_state = 50, .external_lex_state = 2},
  [6207] = {.lex_state = 50, .external_lex_state = 2},
  [6208] = {.lex_state = 50, .external_lex_state = 2},
  [6209] = {.lex_state = 0, .external_lex_state = 2},
  [6210] = {.lex_state = 50, .external_lex_state = 2},
  [6211] = {.lex_state = 0, .external_lex_state = 2},
  [6212] = {.lex_state = 0, .external_lex_state = 2},
  [6213] = {.lex_state = 50, .external_lex_state = 2},
  [6214] = {.lex_state = 0, .external_lex_state = 2},
  [6215] = {.lex_state = 0, .external_lex_state = 2},
  [6216] = {.lex_state = 0, .external_lex_state = 2},
  [6217] = {.lex_state = 0, .external_lex_state = 2},
  [6218] = {.lex_state = 0, .external_lex_state = 2},
  [6219] = {.lex_state = 12, .external_lex_state = 2},
  [6220] = {.lex_state = 0, .external_lex_state = 2},
  [6221] = {.lex_state = 0, .external_lex_state = 2},
  [6222] = {.lex_state = 50, .external_lex_state = 2},
  [6223] = {.lex_state = 0, .external_lex_state = 2},
  [6224] = {.lex_state = 50, .external_lex_state = 2},
  [6225] = {.lex_state = 0, .external_lex_state = 2},
  [6226] = {.lex_state = 0, .external_lex_state = 2},
  [6227] = {.lex_state = 50, .external_lex_state = 2},
  [6228] = {.lex_state = 0, .external_lex_state = 2},
  [6229] = {.lex_state = 0, .external_lex_state = 2},
  [6230] = {.lex_state = 0, .external_lex_state = 2},
  [6231] = {.lex_state = 0, .external_lex_state = 2},
  [6232] = {.lex_state = 50, .external_lex_state = 2},
  [6233] = {.lex_state = 0, .external_lex_state = 2},
  [6234] = {.lex_state = 0, .external_lex_state = 2},
  [6235] = {.lex_state = 0, .external_lex_state = 2},
  [6236] = {.lex_state = 0, .external_lex_state = 2},
  [6237] = {.lex_state = 0, .external_lex_state = 2},
  [6238] = {.lex_state = 0, .external_lex_state = 2},
  [6239] = {.lex_state = 0, .external_lex_state = 2},
  [6240] = {.lex_state = 0, .external_lex_state = 2},
  [6241] = {.lex_state = 0, .external_lex_state = 2},
  [6242] = {.lex_state = 0, .external_lex_state = 2},
  [6243] = {.lex_state = 0, .external_lex_state = 2},
  [6244] = {.lex_state = 0, .external_lex_state = 2},
  [6245] = {.lex_state = 0, .external_lex_state = 2},
  [6246] = {.lex_state = 0, .external_lex_state = 2},
  [6247] = {.lex_state = 0, .external_lex_state = 2},
  [6248] = {.lex_state = 0, .external_lex_state = 2},
  [6249] = {.lex_state = 50, .external_lex_state = 2},
  [6250] = {.lex_state = 0, .external_lex_state = 2},
  [6251] = {.lex_state = 50, .external_lex_state = 2},
  [6252] = {.lex_state = 0, .external_lex_state = 2},
  [6253] = {.lex_state = 0, .external_lex_state = 2},
  [6254] = {.lex_state = 50, .external_lex_state = 2},
  [6255] = {.lex_state = 0, .external_lex_state = 2},
  [6256] = {.lex_state = 0, .external_lex_state = 2},
  [6257] = {.lex_state = 12, .external_lex_state = 2},
  [6258] = {.lex_state = 0, .external_lex_state = 2},
  [6259] = {.lex_state = 50, .external_lex_state = 2},
  [6260] = {.lex_state = 50, .external_lex_state = 2},
  [6261] = {.lex_state = 0, .external_lex_state = 2},
  [6262] = {.lex_state = 50, .external_lex_state = 2},
  [6263] = {.lex_state = 50, .external_lex_state = 2},
  [6264] = {.lex_state = 50, .external_lex_state = 2},
  [6265] = {.lex_state = 0, .external_lex_state = 2},
  [6266] = {.lex_state = 0, .external_lex_state = 2},
  [6267] = {.lex_state = 50, .external_lex_state = 2},
  [6268] = {.lex_state = 0, .external_lex_state = 2},
  [6269] = {.lex_state = 50, .external_lex_state = 2},
  [6270] = {.lex_state = 0, .external_lex_state = 2},
  [6271] = {.lex_state = 0, .external_lex_state = 2},
  [6272] = {.lex_state = 0, .external_lex_state = 2},
  [6273] = {.lex_state = 0, .external_lex_state = 2},
  [6274] = {.lex_state = 0, .external_lex_state = 2},
  [6275] = {.lex_state = 0, .external_lex_state = 2},
  [6276] = {.lex_state = 0, .external_lex_state = 2},
  [6277] = {.lex_state = 0, .external_lex_state = 2},
  [6278] = {.lex_state = 163, .external_lex_state = 2},
  [6279] = {.lex_state = 159, .external_lex_state = 2},
  [6280] = {.lex_state = 155, .external_lex_state = 2},
  [6281] = {.lex_state = 0, .external_lex_state = 2},
  [6282] = {.lex_state = 0, .external_lex_state = 2},
  [6283] = {.lex_state = 50, .external_lex_state = 2},
  [6284] = {.lex_state = 0, .external_lex_state = 2},
  [6285] = {.lex_state = 0, .external_lex_state = 2},
  [6286] = {.lex_state = 0, .external_lex_state = 2},
  [6287] = {.lex_state = 0, .external_lex_state = 2},
  [6288] = {.lex_state = 50, .external_lex_state = 2},
  [6289] = {.lex_state = 50, .external_lex_state = 2},
  [6290] = {.lex_state = 50, .external_lex_state = 2},
  [6291] = {.lex_state = 0, .external_lex_state = 2},
  [6292] = {.lex_state = 0, .external_lex_state = 2},
  [6293] = {.lex_state = 0, .external_lex_state = 2},
  [6294] = {.lex_state = 0, .external_lex_state = 2},
  [6295] = {.lex_state = 12, .external_lex_state = 2},
  [6296] = {.lex_state = 0, .external_lex_state = 2},
  [6297] = {.lex_state = 0, .external_lex_state = 2},
  [6298] = {.lex_state = 0, .external_lex_state = 2},
  [6299] = {.lex_state = 0, .external_lex_state = 2},
  [6300] = {.lex_state = 0, .external_lex_state = 2},
  [6301] = {.lex_state = 0, .external_lex_state = 2},
  [6302] = {.lex_state = 0, .external_lex_state = 2},
  [6303] = {.lex_state = 0, .external_lex_state = 2},
  [6304] = {.lex_state = 50, .external_lex_state = 2},
  [6305] = {.lex_state = 0, .external_lex_state = 2},
  [6306] = {.lex_state = 0, .external_lex_state = 2},
  [6307] = {.lex_state = 50, .external_lex_state = 2},
  [6308] = {.lex_state = 0, .external_lex_state = 2},
  [6309] = {.lex_state = 50, .external_lex_state = 2},
  [6310] = {.lex_state = 50, .external_lex_state = 2},
  [6311] = {.lex_state = 0, .external_lex_state = 2},
  [6312] = {.lex_state = 50, .external_lex_state = 2},
  [6313] = {.lex_state = 0, .external_lex_state = 2},
  [6314] = {.lex_state = 0, .external_lex_state = 2},
  [6315] = {.lex_state = 0, .external_lex_state = 2},
  [6316] = {.lex_state = 50, .external_lex_state = 2},
  [6317] = {.lex_state = 50, .external_lex_state = 2},
  [6318] = {.lex_state = 0, .external_lex_state = 2},
  [6319] = {.lex_state = 0, .external_lex_state = 2},
  [6320] = {.lex_state = 0, .external_lex_state = 2},
  [6321] = {.lex_state = 0, .external_lex_state = 2},
  [6322] = {.lex_state = 0, .external_lex_state = 2},
  [6323] = {.lex_state = 12, .external_lex_state = 2},
  [6324] = {.lex_state = 0, .external_lex_state = 2},
  [6325] = {.lex_state = 0, .external_lex_state = 2},
  [6326] = {.lex_state = 0, .external_lex_state = 2},
  [6327] = {.lex_state = 0, .external_lex_state = 2},
  [6328] = {.lex_state = 0, .external_lex_state = 2},
  [6329] = {.lex_state = 0, .external_lex_state = 2},
  [6330] = {.lex_state = 50, .external_lex_state = 2},
  [6331] = {.lex_state = 0, .external_lex_state = 2},
  [6332] = {.lex_state = 50, .external_lex_state = 2},
  [6333] = {.lex_state = 0, .external_lex_state = 2},
  [6334] = {.lex_state = 50, .external_lex_state = 2},
  [6335] = {.lex_state = 0, .external_lex_state = 2},
  [6336] = {.lex_state = 0, .external_lex_state = 2},
  [6337] = {.lex_state = 0, .external_lex_state = 2},
  [6338] = {.lex_state = 50, .external_lex_state = 2},
  [6339] = {.lex_state = 50, .external_lex_state = 2},
  [6340] = {.lex_state = 0, .external_lex_state = 2},
  [6341] = {.lex_state = 0, .external_lex_state = 2},
  [6342] = {.lex_state = 50, .external_lex_state = 2},
  [6343] = {.lex_state = 0, .external_lex_state = 2},
  [6344] = {.lex_state = 50, .external_lex_state = 2},
  [6345] = {.lex_state = 0, .external_lex_state = 2},
  [6346] = {.lex_state = 0, .external_lex_state = 2},
  [6347] = {.lex_state = 0, .external_lex_state = 2},
  [6348] = {.lex_state = 50, .external_lex_state = 2},
  [6349] = {.lex_state = 50, .external_lex_state = 2},
  [6350] = {.lex_state = 50, .external_lex_state = 2},
  [6351] = {.lex_state = 0, .external_lex_state = 2},
  [6352] = {.lex_state = 50, .external_lex_state = 2},
  [6353] = {.lex_state = 0, .external_lex_state = 2},
  [6354] = {.lex_state = 0, .external_lex_state = 2},
  [6355] = {.lex_state = 50, .external_lex_state = 2},
  [6356] = {.lex_state = 0, .external_lex_state = 2},
  [6357] = {.lex_state = 0, .external_lex_state = 2},
  [6358] = {.lex_state = 50, .external_lex_state = 2},
  [6359] = {.lex_state = 0, .external_lex_state = 2},
  [6360] = {.lex_state = 0, .external_lex_state = 2},
  [6361] = {.lex_state = 0, .external_lex_state = 2},
  [6362] = {.lex_state = 50, .external_lex_state = 2},
  [6363] = {.lex_state = 0, .external_lex_state = 2},
  [6364] = {.lex_state = 50, .external_lex_state = 2},
  [6365] = {.lex_state = 0, .external_lex_state = 2},
  [6366] = {.lex_state = 0, .external_lex_state = 2},
  [6367] = {.lex_state = 50, .external_lex_state = 2},
  [6368] = {.lex_state = 0, .external_lex_state = 2},
  [6369] = {.lex_state = 0, .external_lex_state = 2},
  [6370] = {.lex_state = 50, .external_lex_state = 2},
  [6371] = {.lex_state = 0, .external_lex_state = 2},
  [6372] = {.lex_state = 0, .external_lex_state = 2},
  [6373] = {.lex_state = 0, .external_lex_state = 2},
  [6374] = {.lex_state = 50, .external_lex_state = 2},
  [6375] = {.lex_state = 0, .external_lex_state = 2},
  [6376] = {.lex_state = 11, .external_lex_state = 2},
  [6377] = {.lex_state = 0, .external_lex_state = 2},
  [6378] = {.lex_state = 0, .external_lex_state = 2},
  [6379] = {.lex_state = 0, .external_lex_state = 2},
  [6380] = {.lex_state = 0, .external_lex_state = 2},
  [6381] = {.lex_state = 50, .external_lex_state = 2},
  [6382] = {.lex_state = 0, .external_lex_state = 2},
  [6383] = {.lex_state = 0, .external_lex_state = 2},
  [6384] = {.lex_state = 0, .external_lex_state = 2},
  [6385] = {.lex_state = 0, .external_lex_state = 2},
  [6386] = {.lex_state = 0, .external_lex_state = 2},
  [6387] = {.lex_state = 0, .external_lex_state = 2},
  [6388] = {.lex_state = 12, .external_lex_state = 2},
  [6389] = {.lex_state = 0, .external_lex_state = 2},
  [6390] = {.lex_state = 0, .external_lex_state = 2},
  [6391] = {.lex_state = 0, .external_lex_state = 2},
  [6392] = {.lex_state = 0, .external_lex_state = 2},
  [6393] = {.lex_state = 0, .external_lex_state = 2},
  [6394] = {.lex_state = 0, .external_lex_state = 2},
  [6395] = {.lex_state = 50, .external_lex_state = 2},
  [6396] = {.lex_state = 0, .external_lex_state = 2},
  [6397] = {.lex_state = 0, .external_lex_state = 2},
  [6398] = {.lex_state = 0, .external_lex_state = 2},
  [6399] = {.lex_state = 0, .external_lex_state = 2},
  [6400] = {.lex_state = 0, .external_lex_state = 2},
  [6401] = {.lex_state = 0, .external_lex_state = 2},
  [6402] = {.lex_state = 0, .external_lex_state = 2},
  [6403] = {.lex_state = 50, .external_lex_state = 2},
  [6404] = {.lex_state = 0, .external_lex_state = 2},
  [6405] = {.lex_state = 11, .external_lex_state = 2},
  [6406] = {.lex_state = 0, .external_lex_state = 2},
  [6407] = {.lex_state = 0, .external_lex_state = 2},
  [6408] = {.lex_state = 0, .external_lex_state = 2},
  [6409] = {.lex_state = 0, .external_lex_state = 2},
  [6410] = {.lex_state = 0, .external_lex_state = 2},
  [6411] = {.lex_state = 0, .external_lex_state = 2},
  [6412] = {.lex_state = 0, .external_lex_state = 2},
  [6413] = {.lex_state = 50, .external_lex_state = 2},
  [6414] = {.lex_state = 0, .external_lex_state = 2},
  [6415] = {.lex_state = 0, .external_lex_state = 2},
  [6416] = {.lex_state = 0, .external_lex_state = 2},
  [6417] = {.lex_state = 0, .external_lex_state = 2},
  [6418] = {.lex_state = 0, .external_lex_state = 2},
  [6419] = {.lex_state = 0, .external_lex_state = 2},
  [6420] = {.lex_state = 50, .external_lex_state = 2},
  [6421] = {.lex_state = 0, .external_lex_state = 2},
  [6422] = {.lex_state = 0, .external_lex_state = 2},
  [6423] = {.lex_state = 0, .external_lex_state = 2},
  [6424] = {.lex_state = 0, .external_lex_state = 2},
  [6425] = {.lex_state = 0, .external_lex_state = 2},
  [6426] = {.lex_state = 0, .external_lex_state = 2},
  [6427] = {.lex_state = 50, .external_lex_state = 2},
  [6428] = {.lex_state = 0, .external_lex_state = 2},
  [6429] = {.lex_state = 0, .external_lex_state = 2},
  [6430] = {.lex_state = 0, .external_lex_state = 2},
  [6431] = {.lex_state = 0, .external_lex_state = 2},
  [6432] = {.lex_state = 0, .external_lex_state = 2},
  [6433] = {.lex_state = 0, .external_lex_state = 2},
  [6434] = {.lex_state = 0, .external_lex_state = 2},
  [6435] = {.lex_state = 0, .external_lex_state = 2},
  [6436] = {.lex_state = 0, .external_lex_state = 2},
  [6437] = {.lex_state = 0, .external_lex_state = 2},
  [6438] = {.lex_state = 50, .external_lex_state = 2},
  [6439] = {.lex_state = 1, .external_lex_state = 2},
  [6440] = {.lex_state = 0, .external_lex_state = 2},
  [6441] = {.lex_state = 0, .external_lex_state = 2},
  [6442] = {.lex_state = 0, .external_lex_state = 2},
  [6443] = {.lex_state = 0, .external_lex_state = 2},
  [6444] = {.lex_state = 50, .external_lex_state = 2},
  [6445] = {.lex_state = 50, .external_lex_state = 2},
  [6446] = {.lex_state = 50, .external_lex_state = 2},
  [6447] = {.lex_state = 0, .external_lex_state = 2},
  [6448] = {.lex_state = 50, .external_lex_state = 2},
  [6449] = {.lex_state = 0, .external_lex_state = 2},
  [6450] = {.lex_state = 0, .external_lex_state = 2},
  [6451] = {.lex_state = 0, .external_lex_state = 2},
  [6452] = {.lex_state = 0, .external_lex_state = 2},
  [6453] = {.lex_state = 0, .external_lex_state = 2},
  [6454] = {.lex_state = 0, .external_lex_state = 2},
  [6455] = {.lex_state = 50, .external_lex_state = 2},
  [6456] = {.lex_state = 0, .external_lex_state = 2},
  [6457] = {.lex_state = 50, .external_lex_state = 2},
  [6458] = {.lex_state = 0, .external_lex_state = 2},
  [6459] = {.lex_state = 50, .external_lex_state = 2},
  [6460] = {.lex_state = 0, .external_lex_state = 2},
  [6461] = {.lex_state = 0, .external_lex_state = 2},
  [6462] = {.lex_state = 50, .external_lex_state = 2},
  [6463] = {.lex_state = 50, .external_lex_state = 2},
  [6464] = {.lex_state = 0, .external_lex_state = 2},
  [6465] = {.lex_state = 50, .external_lex_state = 2},
  [6466] = {.lex_state = 0, .external_lex_state = 2},
  [6467] = {.lex_state = 0, .external_lex_state = 2},
  [6468] = {.lex_state = 0, .external_lex_state = 2},
  [6469] = {.lex_state = 0, .external_lex_state = 2},
  [6470] = {.lex_state = 0, .external_lex_state = 2},
  [6471] = {.lex_state = 0, .external_lex_state = 2},
  [6472] = {.lex_state = 50, .external_lex_state = 2},
  [6473] = {.lex_state = 0, .external_lex_state = 2},
  [6474] = {.lex_state = 0, .external_lex_state = 2},
  [6475] = {.lex_state = 0, .external_lex_state = 2},
  [6476] = {.lex_state = 0, .external_lex_state = 2},
  [6477] = {.lex_state = 0, .external_lex_state = 2},
  [6478] = {.lex_state = 0, .external_lex_state = 2},
  [6479] = {.lex_state = 0, .external_lex_state = 2},
  [6480] = {.lex_state = 0, .external_lex_state = 2},
  [6481] = {.lex_state = 50, .external_lex_state = 2},
  [6482] = {.lex_state = 0, .external_lex_state = 2},
  [6483] = {.lex_state = 0, .external_lex_state = 2},
  [6484] = {.lex_state = 0, .external_lex_state = 2},
  [6485] = {.lex_state = 0, .external_lex_state = 2},
  [6486] = {.lex_state = 0, .external_lex_state = 2},
  [6487] = {.lex_state = 0, .external_lex_state = 2},
  [6488] = {.lex_state = 0, .external_lex_state = 2},
  [6489] = {.lex_state = 0, .external_lex_state = 2},
  [6490] = {.lex_state = 0, .external_lex_state = 2},
  [6491] = {.lex_state = 0, .external_lex_state = 2},
  [6492] = {.lex_state = 11, .external_lex_state = 2},
  [6493] = {.lex_state = 50, .external_lex_state = 2},
  [6494] = {.lex_state = 0, .external_lex_state = 2},
  [6495] = {.lex_state = 0, .external_lex_state = 2},
  [6496] = {.lex_state = 50, .external_lex_state = 2},
  [6497] = {.lex_state = 163, .external_lex_state = 2},
  [6498] = {.lex_state = 159, .external_lex_state = 2},
  [6499] = {.lex_state = 0, .external_lex_state = 2},
  [6500] = {.lex_state = 50, .external_lex_state = 2},
  [6501] = {.lex_state = 0, .external_lex_state = 2},
  [6502] = {.lex_state = 0, .external_lex_state = 2},
  [6503] = {.lex_state = 155, .external_lex_state = 2},
  [6504] = {.lex_state = 0, .external_lex_state = 2},
  [6505] = {.lex_state = 0, .external_lex_state = 2},
  [6506] = {.lex_state = 0, .external_lex_state = 2},
  [6507] = {.lex_state = 0, .external_lex_state = 2},
  [6508] = {.lex_state = 0, .external_lex_state = 2},
  [6509] = {.lex_state = 0, .external_lex_state = 2},
  [6510] = {.lex_state = 50, .external_lex_state = 2},
  [6511] = {.lex_state = 0, .external_lex_state = 2},
  [6512] = {.lex_state = 0, .external_lex_state = 2},
  [6513] = {.lex_state = 0, .external_lex_state = 2},
  [6514] = {.lex_state = 0, .external_lex_state = 2},
  [6515] = {.lex_state = 0, .external_lex_state = 2},
  [6516] = {.lex_state = 0, .external_lex_state = 2},
  [6517] = {.lex_state = 0, .external_lex_state = 2},
  [6518] = {.lex_state = 50, .external_lex_state = 2},
  [6519] = {.lex_state = 0, .external_lex_state = 2},
  [6520] = {.lex_state = 0, .external_lex_state = 2},
  [6521] = {.lex_state = 0, .external_lex_state = 2},
  [6522] = {.lex_state = 0, .external_lex_state = 2},
  [6523] = {.lex_state = 0, .external_lex_state = 2},
  [6524] = {.lex_state = 0, .external_lex_state = 2},
  [6525] = {.lex_state = 0, .external_lex_state = 2},
  [6526] = {.lex_state = 0, .external_lex_state = 2},
  [6527] = {.lex_state = 50, .external_lex_state = 2},
  [6528] = {.lex_state = 0, .external_lex_state = 2},
  [6529] = {.lex_state = 50, .external_lex_state = 2},
  [6530] = {.lex_state = 0, .external_lex_state = 2},
  [6531] = {.lex_state = 0, .external_lex_state = 2},
  [6532] = {.lex_state = 0, .external_lex_state = 2},
  [6533] = {.lex_state = 0, .external_lex_state = 2},
  [6534] = {.lex_state = 0, .external_lex_state = 2},
  [6535] = {.lex_state = 50, .external_lex_state = 2},
  [6536] = {.lex_state = 0, .external_lex_state = 2},
  [6537] = {.lex_state = 0, .external_lex_state = 2},
  [6538] = {.lex_state = 0, .external_lex_state = 2},
  [6539] = {.lex_state = 0, .external_lex_state = 2},
  [6540] = {.lex_state = 0, .external_lex_state = 2},
  [6541] = {.lex_state = 0, .external_lex_state = 2},
  [6542] = {.lex_state = 0, .external_lex_state = 2},
  [6543] = {.lex_state = 0, .external_lex_state = 2},
  [6544] = {.lex_state = 0, .external_lex_state = 2},
  [6545] = {.lex_state = 0, .external_lex_state = 2},
  [6546] = {.lex_state = 0, .external_lex_state = 2},
  [6547] = {.lex_state = 0, .external_lex_state = 2},
  [6548] = {.lex_state = 0, .external_lex_state = 2},
  [6549] = {.lex_state = 0, .external_lex_state = 2},
  [6550] = {.lex_state = 0, .external_lex_state = 2},
  [6551] = {.lex_state = 0, .external_lex_state = 2},
  [6552] = {.lex_state = 0, .external_lex_state = 2},
  [6553] = {.lex_state = 0, .external_lex_state = 2},
  [6554] = {.lex_state = 50, .external_lex_state = 2},
  [6555] = {.lex_state = 50, .external_lex_state = 2},
  [6556] = {.lex_state = 50, .external_lex_state = 2},
  [6557] = {.lex_state = 50, .external_lex_state = 2},
  [6558] = {.lex_state = 50, .external_lex_state = 2},
  [6559] = {.lex_state = 0, .external_lex_state = 2},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym__bom] = ACTIONS(1),
    [aux_sym_htmlentity_token1] = ACTIONS(1),
    [anon_sym_BSLASH_SQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_DQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_QMARK] = ACTIONS(1),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1),
    [anon_sym_BSLASHa] = ACTIONS(1),
    [anon_sym_BSLASHb] = ACTIONS(1),
    [anon_sym_BSLASHf] = ACTIONS(1),
    [anon_sym_BSLASHn] = ACTIONS(1),
    [anon_sym_BSLASHr] = ACTIONS(1),
    [anon_sym_BSLASHt] = ACTIONS(1),
    [anon_sym_BSLASHv] = ACTIONS(1),
    [aux_sym_escape_sequence_token1] = ACTIONS(1),
    [aux_sym_escape_sequence_token2] = ACTIONS(1),
    [aux_sym_escape_sequence_token3] = ACTIONS(1),
    [aux_sym_escape_sequence_token4] = ACTIONS(1),
    [anon_sym_q_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_CARET_CARET] = ACTIONS(1),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [sym_bool] = ACTIONS(1),
    [sym_byte] = ACTIONS(1),
    [sym_ubyte] = ACTIONS(1),
    [sym_char] = ACTIONS(1),
    [sym_short] = ACTIONS(1),
    [sym_ushort] = ACTIONS(1),
    [sym_int] = ACTIONS(1),
    [sym_uint] = ACTIONS(1),
    [sym_long] = ACTIONS(1),
    [sym_ulong] = ACTIONS(1),
    [sym_cent] = ACTIONS(1),
    [sym_ucent] = ACTIONS(1),
    [sym_wchar] = ACTIONS(1),
    [sym_dchar] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_double] = ACTIONS(1),
    [sym_real] = ACTIONS(1),
    [sym_ifloat] = ACTIONS(1),
    [sym_idouble] = ACTIONS(1),
    [sym_ireal] = ACTIONS(1),
    [sym_cfloat] = ACTIONS(1),
    [sym_cdouble] = ACTIONS(1),
    [sym_creal] = ACTIONS(1),
    [sym_size_t] = ACTIONS(1),
    [sym_ptrdiff_t] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_cstring] = ACTIONS(1),
    [sym_dstring] = ACTIONS(1),
    [sym_wstring] = ACTIONS(1),
    [sym_noreturn] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_abstract] = ACTIONS(1),
    [sym_alias] = ACTIONS(1),
    [sym_align] = ACTIONS(1),
    [sym_asm] = ACTIONS(1),
    [sym_assert] = ACTIONS(1),
    [sym_auto] = ACTIONS(1),
    [sym_break] = ACTIONS(1),
    [sym_case] = ACTIONS(1),
    [sym_cast] = ACTIONS(1),
    [sym_catch] = ACTIONS(1),
    [sym_class] = ACTIONS(1),
    [sym_const] = ACTIONS(1),
    [sym_continue] = ACTIONS(1),
    [sym_debug] = ACTIONS(1),
    [sym_default] = ACTIONS(1),
    [sym_delegate] = ACTIONS(1),
    [sym_delete] = ACTIONS(1),
    [sym_deprecated] = ACTIONS(1),
    [sym_do] = ACTIONS(1),
    [sym_else] = ACTIONS(1),
    [sym_enum] = ACTIONS(1),
    [sym_export] = ACTIONS(1),
    [sym_extern] = ACTIONS(1),
    [sym_final] = ACTIONS(1),
    [sym_finally] = ACTIONS(1),
    [sym_for] = ACTIONS(1),
    [sym_foreach] = ACTIONS(1),
    [sym_foreach_reverse] = ACTIONS(1),
    [sym_function] = ACTIONS(1),
    [sym_goto] = ACTIONS(1),
    [sym_if] = ACTIONS(1),
    [sym_immutable] = ACTIONS(1),
    [sym_import] = ACTIONS(1),
    [sym_in] = ACTIONS(1),
    [sym_inout] = ACTIONS(1),
    [sym_interface] = ACTIONS(1),
    [sym_invariant] = ACTIONS(1),
    [sym_is] = ACTIONS(1),
    [sym_lazy] = ACTIONS(1),
    [sym_mixin] = ACTIONS(1),
    [sym_module] = ACTIONS(1),
    [sym_new] = ACTIONS(1),
    [sym_nothrow] = ACTIONS(1),
    [sym_out] = ACTIONS(1),
    [sym_override] = ACTIONS(1),
    [sym_package] = ACTIONS(1),
    [sym_pragma] = ACTIONS(1),
    [sym_private] = ACTIONS(1),
    [sym_protected] = ACTIONS(1),
    [sym_public] = ACTIONS(1),
    [sym_pure] = ACTIONS(1),
    [sym_ref] = ACTIONS(1),
    [sym_return] = ACTIONS(1),
    [sym_scope] = ACTIONS(1),
    [sym_shared] = ACTIONS(1),
    [sym_static] = ACTIONS(1),
    [sym_struct] = ACTIONS(1),
    [sym_switch] = ACTIONS(1),
    [sym_synchronized] = ACTIONS(1),
    [sym_template] = ACTIONS(1),
    [sym_throw] = ACTIONS(1),
    [sym_try] = ACTIONS(1),
    [sym_typeid] = ACTIONS(1),
    [sym_typeof] = ACTIONS(1),
    [sym_union] = ACTIONS(1),
    [sym_unittest] = ACTIONS(1),
    [sym_version] = ACTIONS(1),
    [sym_while] = ACTIONS(1),
    [sym_with] = ACTIONS(1),
    [sym_parameters_] = ACTIONS(1),
    [sym_gshared] = ACTIONS(1),
    [sym_traits] = ACTIONS(1),
    [sym_vector] = ACTIONS(1),
    [sym_void] = ACTIONS(1),
    [anon_sym_C] = ACTIONS(1),
    [anon_sym_D] = ACTIONS(1),
    [anon_sym_Windows] = ACTIONS(1),
    [anon_sym_System] = ACTIONS(1),
    [anon_sym_Objective] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_r_DQUOTE] = ACTIONS(1),
    [anon_sym_x_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_i_BQUOTE] = ACTIONS(1),
    [sym_interpolated_escape] = ACTIONS(1),
    [anon_sym_i_DQUOTE] = ACTIONS(1),
    [anon_sym_iq_LBRACE] = ACTIONS(1),
    [aux_sym_char_literal_token1] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym___DATE__] = ACTIONS(1),
    [anon_sym___FILE__] = ACTIONS(1),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(1),
    [anon_sym___FUNCTION__] = ACTIONS(1),
    [anon_sym___LINE__] = ACTIONS(1),
    [anon_sym___MODULE__] = ACTIONS(1),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(1),
    [anon_sym___TIME__] = ACTIONS(1),
    [anon_sym___TIMESTAMP__] = ACTIONS(1),
    [anon_sym___VENDOR__] = ACTIONS(1),
    [anon_sym___VERSION__] = ACTIONS(1),
    [anon_sym_exit] = ACTIONS(1),
    [anon_sym_success] = ACTIONS(1),
    [anon_sym_failure] = ACTIONS(1),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym__string] = ACTIONS(1),
    [sym_not_in] = ACTIONS(1),
    [sym_not_is] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(6475),
    [sym_shebang] = STATE(1698),
    [sym_module_def] = STATE(6467),
    [sym_module_declaration] = STATE(1872),
    [sym_import_declaration] = STATE(1804),
    [sym_mixin_declaration] = STATE(1804),
    [sym__declaration] = STATE(1804),
    [sym__declaration2] = STATE(1804),
    [sym_variable_declaration] = STATE(1804),
    [sym_manifest_constant] = STATE(1804),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1804),
    [sym_alias_declaration] = STATE(1804),
    [sym_alias_reassign] = STATE(1804),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1804),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2206),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2451),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1804),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1804),
    [sym_union_declaration] = STATE(1804),
    [sym_postblit] = STATE(1804),
    [sym_invariant_declaration] = STATE(1804),
    [sym_class_declaration] = STATE(1804),
    [sym_constructor] = STATE(1804),
    [sym_destructor] = STATE(1804),
    [sym_alias_this] = STATE(1804),
    [sym_interface_declaration] = STATE(1804),
    [sym_enum_declaration] = STATE(1804),
    [sym_anonymous_enum_declaration] = STATE(1804),
    [sym_function_declaration] = STATE(1804),
    [sym_template_declaration] = STATE(1804),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1804),
    [sym_template_mixin] = STATE(1804),
    [sym_conditional_declaration] = STATE(1804),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1804),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1804),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1804),
    [sym_static_assert] = STATE(1804),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1804),
    [aux_sym_source_file_repeat1] = STATE(1804),
    [aux_sym_module_declaration_repeat1] = STATE(4467),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym__bom] = ACTIONS(9),
    [anon_sym_POUND_BANG] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_module] = ACTIONS(53),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(113),
    [sym_mixin_declaration] = STATE(113),
    [sym__declaration] = STATE(113),
    [sym__declaration2] = STATE(113),
    [sym_variable_declaration] = STATE(113),
    [sym_manifest_constant] = STATE(113),
    [sym_storage_class] = STATE(2511),
    [sym__initializer] = STATE(5300),
    [sym_auto_declaration] = STATE(113),
    [sym_alias_declaration] = STATE(113),
    [sym_alias_reassign] = STATE(113),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(113),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(113),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3560),
    [sym_ternary_expression] = STATE(3560),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3560),
    [sym_binary_expression] = STATE(3560),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(688),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(113),
    [sym_union_declaration] = STATE(113),
    [sym_aggregate_initializer] = STATE(5300),
    [sym_member_initializer] = STATE(5056),
    [sym_postblit] = STATE(113),
    [sym_invariant_declaration] = STATE(113),
    [sym_class_declaration] = STATE(113),
    [sym_constructor] = STATE(113),
    [sym_destructor] = STATE(113),
    [sym_alias_this] = STATE(113),
    [sym_interface_declaration] = STATE(113),
    [sym_enum_declaration] = STATE(113),
    [sym_anonymous_enum_declaration] = STATE(113),
    [sym_function_declaration] = STATE(113),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(113),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(113),
    [sym_template_mixin] = STATE(113),
    [sym_conditional_declaration] = STATE(113),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(113),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(113),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(79),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(83),
    [anon_sym_LBRACE] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [3] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(95),
    [sym_mixin_declaration] = STATE(95),
    [sym__declaration] = STATE(95),
    [sym__declaration2] = STATE(95),
    [sym_variable_declaration] = STATE(95),
    [sym_manifest_constant] = STATE(95),
    [sym_storage_class] = STATE(2511),
    [sym__initializer] = STATE(5300),
    [sym_auto_declaration] = STATE(95),
    [sym_alias_declaration] = STATE(95),
    [sym_alias_reassign] = STATE(95),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(95),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(95),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3560),
    [sym_ternary_expression] = STATE(3560),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3560),
    [sym_binary_expression] = STATE(3560),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(688),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(95),
    [sym_union_declaration] = STATE(95),
    [sym_aggregate_initializer] = STATE(5300),
    [sym_member_initializer] = STATE(5056),
    [sym_postblit] = STATE(95),
    [sym_invariant_declaration] = STATE(95),
    [sym_class_declaration] = STATE(95),
    [sym_constructor] = STATE(95),
    [sym_destructor] = STATE(95),
    [sym_alias_this] = STATE(95),
    [sym_interface_declaration] = STATE(95),
    [sym_enum_declaration] = STATE(95),
    [sym_anonymous_enum_declaration] = STATE(95),
    [sym_function_declaration] = STATE(95),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(95),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(95),
    [sym_template_mixin] = STATE(95),
    [sym_conditional_declaration] = STATE(95),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(95),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(95),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(79),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(235),
    [anon_sym_LBRACE] = ACTIONS(85),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [4] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1880),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [5] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1886),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [6] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1746),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(249),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [7] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1816),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(251),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [8] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1828),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [9] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1718),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(255),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [10] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1798),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [11] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1740),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [12] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1849),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(261),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [13] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1721),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [14] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1731),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [15] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1740),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [16] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1767),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [17] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1840),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [18] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1735),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(273),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [19] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1729),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [20] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1799),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(257),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [21] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1849),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [22] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1764),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(241),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [23] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1805),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [24] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1745),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [25] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1887),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [26] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1789),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [27] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1734),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(285),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [28] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1784),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [29] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1816),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [30] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1805),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [31] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1780),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [32] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1775),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [33] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1828),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [34] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1746),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [35] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1690),
    [sym_mixin_declaration] = STATE(1690),
    [sym__declaration] = STATE(1690),
    [sym__declaration2] = STATE(1690),
    [sym_variable_declaration] = STATE(1690),
    [sym_manifest_constant] = STATE(1690),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1690),
    [sym_alias_declaration] = STATE(1690),
    [sym_alias_reassign] = STATE(1690),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1690),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(1690),
    [sym_union_declaration] = STATE(1690),
    [sym_postblit] = STATE(1690),
    [sym_invariant_declaration] = STATE(1690),
    [sym_class_declaration] = STATE(1690),
    [sym_constructor] = STATE(1690),
    [sym_destructor] = STATE(1690),
    [sym_alias_this] = STATE(1690),
    [sym_interface_declaration] = STATE(1690),
    [sym_enum_declaration] = STATE(1690),
    [sym_anonymous_enum_declaration] = STATE(1690),
    [sym_function_declaration] = STATE(1690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1690),
    [sym_template_mixin] = STATE(1690),
    [sym_conditional_declaration] = STATE(1690),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(1690),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1690),
    [aux_sym_source_file_repeat1] = STATE(1762),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(299),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [36] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(38),
    [sym_mixin_declaration] = STATE(38),
    [sym__declaration] = STATE(38),
    [sym__declaration2] = STATE(38),
    [sym_variable_declaration] = STATE(38),
    [sym_manifest_constant] = STATE(38),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(38),
    [sym_alias_declaration] = STATE(38),
    [sym_alias_reassign] = STATE(38),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(38),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(38),
    [sym_pragma_statement] = STATE(38),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(38),
    [sym_labeled_statement] = STATE(38),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(38),
    [sym_if_statement] = STATE(38),
    [sym_while_statement] = STATE(38),
    [sym_do_statement] = STATE(38),
    [sym_for_statement] = STATE(38),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(38),
    [sym_switch_statement] = STATE(38),
    [sym_final_switch_statement] = STATE(38),
    [sym_continue_statement] = STATE(38),
    [sym_break_statement] = STATE(38),
    [sym_return_statement] = STATE(38),
    [sym_goto_statement] = STATE(38),
    [sym_with_statement] = STATE(38),
    [sym_synchronized_statement] = STATE(38),
    [sym_try_statement] = STATE(38),
    [sym_scope_guard_statement] = STATE(38),
    [sym_asm_statement] = STATE(38),
    [sym_struct_declaration] = STATE(38),
    [sym_union_declaration] = STATE(38),
    [sym_postblit] = STATE(38),
    [sym_invariant_declaration] = STATE(38),
    [sym_class_declaration] = STATE(38),
    [sym_constructor] = STATE(38),
    [sym_destructor] = STATE(38),
    [sym_alias_this] = STATE(38),
    [sym_interface_declaration] = STATE(38),
    [sym_enum_declaration] = STATE(38),
    [sym_anonymous_enum_declaration] = STATE(38),
    [sym_function_declaration] = STATE(38),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(38),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(38),
    [sym_template_mixin] = STATE(38),
    [sym_conditional_declaration] = STATE(38),
    [sym_conditional_statement] = STATE(38),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(38),
    [sym_static_foreach_declaration] = STATE(38),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(38),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(38),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(307),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(319),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(319),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(319),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(319),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(319),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [37] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(40),
    [sym_mixin_declaration] = STATE(40),
    [sym__declaration] = STATE(40),
    [sym__declaration2] = STATE(40),
    [sym_variable_declaration] = STATE(40),
    [sym_manifest_constant] = STATE(40),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(40),
    [sym_alias_declaration] = STATE(40),
    [sym_alias_reassign] = STATE(40),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(40),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(40),
    [sym_pragma_statement] = STATE(40),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(40),
    [sym_labeled_statement] = STATE(40),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(40),
    [sym_if_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_do_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(40),
    [sym_switch_statement] = STATE(40),
    [sym_final_switch_statement] = STATE(40),
    [sym_continue_statement] = STATE(40),
    [sym_break_statement] = STATE(40),
    [sym_return_statement] = STATE(40),
    [sym_goto_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_synchronized_statement] = STATE(40),
    [sym_try_statement] = STATE(40),
    [sym_scope_guard_statement] = STATE(40),
    [sym_asm_statement] = STATE(40),
    [sym_struct_declaration] = STATE(40),
    [sym_union_declaration] = STATE(40),
    [sym_postblit] = STATE(40),
    [sym_invariant_declaration] = STATE(40),
    [sym_class_declaration] = STATE(40),
    [sym_constructor] = STATE(40),
    [sym_destructor] = STATE(40),
    [sym_alias_this] = STATE(40),
    [sym_interface_declaration] = STATE(40),
    [sym_enum_declaration] = STATE(40),
    [sym_anonymous_enum_declaration] = STATE(40),
    [sym_function_declaration] = STATE(40),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(40),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(40),
    [sym_template_mixin] = STATE(40),
    [sym_conditional_declaration] = STATE(40),
    [sym_conditional_statement] = STATE(40),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(40),
    [sym_static_foreach_declaration] = STATE(40),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(40),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(40),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(381),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(383),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(383),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(383),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [38] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(41),
    [sym_mixin_declaration] = STATE(41),
    [sym__declaration] = STATE(41),
    [sym__declaration2] = STATE(41),
    [sym_variable_declaration] = STATE(41),
    [sym_manifest_constant] = STATE(41),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_alias_reassign] = STATE(41),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(41),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(41),
    [sym_pragma_statement] = STATE(41),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_final_switch_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_synchronized_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_scope_guard_statement] = STATE(41),
    [sym_asm_statement] = STATE(41),
    [sym_struct_declaration] = STATE(41),
    [sym_union_declaration] = STATE(41),
    [sym_postblit] = STATE(41),
    [sym_invariant_declaration] = STATE(41),
    [sym_class_declaration] = STATE(41),
    [sym_constructor] = STATE(41),
    [sym_destructor] = STATE(41),
    [sym_alias_this] = STATE(41),
    [sym_interface_declaration] = STATE(41),
    [sym_enum_declaration] = STATE(41),
    [sym_anonymous_enum_declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(41),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(41),
    [sym_template_mixin] = STATE(41),
    [sym_conditional_declaration] = STATE(41),
    [sym_conditional_statement] = STATE(41),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(41),
    [sym_static_foreach_declaration] = STATE(41),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(41),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(41),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(383),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(383),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(383),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [39] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(42),
    [sym_mixin_declaration] = STATE(42),
    [sym__declaration] = STATE(42),
    [sym__declaration2] = STATE(42),
    [sym_variable_declaration] = STATE(42),
    [sym_manifest_constant] = STATE(42),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(42),
    [sym_alias_declaration] = STATE(42),
    [sym_alias_reassign] = STATE(42),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(42),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(42),
    [sym_pragma_statement] = STATE(42),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(42),
    [sym_labeled_statement] = STATE(42),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(42),
    [sym_if_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_do_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(42),
    [sym_switch_statement] = STATE(42),
    [sym_final_switch_statement] = STATE(42),
    [sym_continue_statement] = STATE(42),
    [sym_break_statement] = STATE(42),
    [sym_return_statement] = STATE(42),
    [sym_goto_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_synchronized_statement] = STATE(42),
    [sym_try_statement] = STATE(42),
    [sym_scope_guard_statement] = STATE(42),
    [sym_asm_statement] = STATE(42),
    [sym_struct_declaration] = STATE(42),
    [sym_union_declaration] = STATE(42),
    [sym_postblit] = STATE(42),
    [sym_invariant_declaration] = STATE(42),
    [sym_class_declaration] = STATE(42),
    [sym_constructor] = STATE(42),
    [sym_destructor] = STATE(42),
    [sym_alias_this] = STATE(42),
    [sym_interface_declaration] = STATE(42),
    [sym_enum_declaration] = STATE(42),
    [sym_anonymous_enum_declaration] = STATE(42),
    [sym_function_declaration] = STATE(42),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(42),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(42),
    [sym_template_mixin] = STATE(42),
    [sym_conditional_declaration] = STATE(42),
    [sym_conditional_statement] = STATE(42),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(42),
    [sym_static_foreach_declaration] = STATE(42),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(42),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(42),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(391),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(391),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(391),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [40] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(41),
    [sym_mixin_declaration] = STATE(41),
    [sym__declaration] = STATE(41),
    [sym__declaration2] = STATE(41),
    [sym_variable_declaration] = STATE(41),
    [sym_manifest_constant] = STATE(41),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_alias_reassign] = STATE(41),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(41),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(41),
    [sym_pragma_statement] = STATE(41),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_final_switch_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_synchronized_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_scope_guard_statement] = STATE(41),
    [sym_asm_statement] = STATE(41),
    [sym_struct_declaration] = STATE(41),
    [sym_union_declaration] = STATE(41),
    [sym_postblit] = STATE(41),
    [sym_invariant_declaration] = STATE(41),
    [sym_class_declaration] = STATE(41),
    [sym_constructor] = STATE(41),
    [sym_destructor] = STATE(41),
    [sym_alias_this] = STATE(41),
    [sym_interface_declaration] = STATE(41),
    [sym_enum_declaration] = STATE(41),
    [sym_anonymous_enum_declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(41),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(41),
    [sym_template_mixin] = STATE(41),
    [sym_conditional_declaration] = STATE(41),
    [sym_conditional_statement] = STATE(41),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(41),
    [sym_static_foreach_declaration] = STATE(41),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(41),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(41),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(391),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(391),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(391),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [41] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(41),
    [sym_mixin_declaration] = STATE(41),
    [sym__declaration] = STATE(41),
    [sym__declaration2] = STATE(41),
    [sym_variable_declaration] = STATE(41),
    [sym_manifest_constant] = STATE(41),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_alias_reassign] = STATE(41),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(41),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(41),
    [sym_pragma_statement] = STATE(41),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_final_switch_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_synchronized_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_scope_guard_statement] = STATE(41),
    [sym_asm_statement] = STATE(41),
    [sym_struct_declaration] = STATE(41),
    [sym_union_declaration] = STATE(41),
    [sym_postblit] = STATE(41),
    [sym_invariant_declaration] = STATE(41),
    [sym_class_declaration] = STATE(41),
    [sym_constructor] = STATE(41),
    [sym_destructor] = STATE(41),
    [sym_alias_this] = STATE(41),
    [sym_interface_declaration] = STATE(41),
    [sym_enum_declaration] = STATE(41),
    [sym_anonymous_enum_declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(41),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(41),
    [sym_template_mixin] = STATE(41),
    [sym_conditional_declaration] = STATE(41),
    [sym_conditional_statement] = STATE(41),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(41),
    [sym_static_foreach_declaration] = STATE(41),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(41),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(41),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_q_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(401),
    [anon_sym_DOT] = ACTIONS(404),
    [anon_sym_AMP] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(428),
    [sym_bool] = ACTIONS(431),
    [sym_byte] = ACTIONS(431),
    [sym_ubyte] = ACTIONS(431),
    [sym_char] = ACTIONS(431),
    [sym_short] = ACTIONS(431),
    [sym_ushort] = ACTIONS(431),
    [sym_int] = ACTIONS(431),
    [sym_uint] = ACTIONS(431),
    [sym_long] = ACTIONS(431),
    [sym_ulong] = ACTIONS(431),
    [sym_cent] = ACTIONS(431),
    [sym_ucent] = ACTIONS(431),
    [sym_wchar] = ACTIONS(431),
    [sym_dchar] = ACTIONS(431),
    [sym_float] = ACTIONS(431),
    [sym_double] = ACTIONS(431),
    [sym_real] = ACTIONS(431),
    [sym_ifloat] = ACTIONS(431),
    [sym_idouble] = ACTIONS(431),
    [sym_ireal] = ACTIONS(431),
    [sym_cfloat] = ACTIONS(431),
    [sym_cdouble] = ACTIONS(431),
    [sym_creal] = ACTIONS(431),
    [sym_size_t] = ACTIONS(431),
    [sym_ptrdiff_t] = ACTIONS(431),
    [sym_string] = ACTIONS(431),
    [sym_cstring] = ACTIONS(431),
    [sym_dstring] = ACTIONS(431),
    [sym_wstring] = ACTIONS(431),
    [sym_noreturn] = ACTIONS(431),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_super] = ACTIONS(434),
    [sym_this] = ACTIONS(437),
    [sym_abstract] = ACTIONS(440),
    [sym_alias] = ACTIONS(443),
    [sym_align] = ACTIONS(446),
    [sym_asm] = ACTIONS(449),
    [sym_assert] = ACTIONS(452),
    [sym_auto] = ACTIONS(455),
    [sym_break] = ACTIONS(458),
    [sym_case] = ACTIONS(461),
    [sym_cast] = ACTIONS(463),
    [sym_catch] = ACTIONS(461),
    [sym_class] = ACTIONS(466),
    [sym_const] = ACTIONS(469),
    [sym_continue] = ACTIONS(472),
    [sym_debug] = ACTIONS(475),
    [sym_default] = ACTIONS(461),
    [sym_delegate] = ACTIONS(478),
    [sym_delete] = ACTIONS(481),
    [sym_deprecated] = ACTIONS(484),
    [sym_do] = ACTIONS(487),
    [sym_else] = ACTIONS(461),
    [sym_enum] = ACTIONS(490),
    [sym_export] = ACTIONS(493),
    [sym_extern] = ACTIONS(496),
    [sym_final] = ACTIONS(499),
    [sym_finally] = ACTIONS(461),
    [sym_for] = ACTIONS(502),
    [sym_foreach] = ACTIONS(505),
    [sym_foreach_reverse] = ACTIONS(505),
    [sym_function] = ACTIONS(508),
    [sym_goto] = ACTIONS(511),
    [sym_if] = ACTIONS(514),
    [sym_immutable] = ACTIONS(469),
    [sym_import] = ACTIONS(517),
    [sym_in] = ACTIONS(520),
    [sym_inout] = ACTIONS(469),
    [sym_interface] = ACTIONS(523),
    [sym_invariant] = ACTIONS(526),
    [sym_is] = ACTIONS(529),
    [sym_mixin] = ACTIONS(532),
    [sym_new] = ACTIONS(535),
    [sym_nothrow] = ACTIONS(440),
    [sym_out] = ACTIONS(538),
    [sym_override] = ACTIONS(440),
    [sym_package] = ACTIONS(541),
    [sym_pragma] = ACTIONS(544),
    [sym_private] = ACTIONS(493),
    [sym_protected] = ACTIONS(493),
    [sym_public] = ACTIONS(493),
    [sym_pure] = ACTIONS(440),
    [sym_ref] = ACTIONS(547),
    [sym_return] = ACTIONS(550),
    [sym_scope] = ACTIONS(553),
    [sym_shared] = ACTIONS(556),
    [sym_static] = ACTIONS(559),
    [sym_struct] = ACTIONS(562),
    [sym_switch] = ACTIONS(565),
    [sym_synchronized] = ACTIONS(568),
    [sym_template] = ACTIONS(571),
    [sym_throw] = ACTIONS(574),
    [sym_try] = ACTIONS(577),
    [sym_typeid] = ACTIONS(580),
    [sym_typeof] = ACTIONS(583),
    [sym_union] = ACTIONS(586),
    [sym_unittest] = ACTIONS(589),
    [sym_version] = ACTIONS(592),
    [sym_while] = ACTIONS(595),
    [sym_with] = ACTIONS(598),
    [sym_gshared] = ACTIONS(440),
    [sym_traits] = ACTIONS(601),
    [sym_vector] = ACTIONS(604),
    [sym_void] = ACTIONS(431),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_r_DQUOTE] = ACTIONS(610),
    [anon_sym_x_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(616),
    [anon_sym_i_BQUOTE] = ACTIONS(619),
    [anon_sym_i_DQUOTE] = ACTIONS(622),
    [anon_sym_iq_LBRACE] = ACTIONS(625),
    [aux_sym_char_literal_token1] = ACTIONS(628),
    [anon_sym_SQUOTE] = ACTIONS(631),
    [anon_sym___DATE__] = ACTIONS(634),
    [anon_sym___FILE__] = ACTIONS(634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(634),
    [anon_sym___FUNCTION__] = ACTIONS(634),
    [anon_sym___LINE__] = ACTIONS(634),
    [anon_sym___MODULE__] = ACTIONS(634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(634),
    [anon_sym___TIME__] = ACTIONS(634),
    [anon_sym___TIMESTAMP__] = ACTIONS(634),
    [anon_sym___VENDOR__] = ACTIONS(634),
    [anon_sym___VERSION__] = ACTIONS(634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(637),
    [sym_float_literal] = ACTIONS(637),
    [sym__string] = ACTIONS(640),
  },
  [42] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(41),
    [sym_mixin_declaration] = STATE(41),
    [sym__declaration] = STATE(41),
    [sym__declaration2] = STATE(41),
    [sym_variable_declaration] = STATE(41),
    [sym_manifest_constant] = STATE(41),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_alias_reassign] = STATE(41),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(41),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(41),
    [sym_pragma_statement] = STATE(41),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_final_switch_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_synchronized_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_scope_guard_statement] = STATE(41),
    [sym_asm_statement] = STATE(41),
    [sym_struct_declaration] = STATE(41),
    [sym_union_declaration] = STATE(41),
    [sym_postblit] = STATE(41),
    [sym_invariant_declaration] = STATE(41),
    [sym_class_declaration] = STATE(41),
    [sym_constructor] = STATE(41),
    [sym_destructor] = STATE(41),
    [sym_alias_this] = STATE(41),
    [sym_interface_declaration] = STATE(41),
    [sym_enum_declaration] = STATE(41),
    [sym_anonymous_enum_declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(41),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(41),
    [sym_template_mixin] = STATE(41),
    [sym_conditional_declaration] = STATE(41),
    [sym_conditional_statement] = STATE(41),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(41),
    [sym_static_foreach_declaration] = STATE(41),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(41),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(41),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(645),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(645),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(645),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(645),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(645),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [43] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(44),
    [sym_mixin_declaration] = STATE(44),
    [sym__declaration] = STATE(44),
    [sym__declaration2] = STATE(44),
    [sym_variable_declaration] = STATE(44),
    [sym_manifest_constant] = STATE(44),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(44),
    [sym_alias_declaration] = STATE(44),
    [sym_alias_reassign] = STATE(44),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(44),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(44),
    [sym_pragma_statement] = STATE(44),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(44),
    [sym_labeled_statement] = STATE(44),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(44),
    [sym_if_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_do_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(44),
    [sym_switch_statement] = STATE(44),
    [sym_final_switch_statement] = STATE(44),
    [sym_continue_statement] = STATE(44),
    [sym_break_statement] = STATE(44),
    [sym_return_statement] = STATE(44),
    [sym_goto_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_synchronized_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_scope_guard_statement] = STATE(44),
    [sym_asm_statement] = STATE(44),
    [sym_struct_declaration] = STATE(44),
    [sym_union_declaration] = STATE(44),
    [sym_postblit] = STATE(44),
    [sym_invariant_declaration] = STATE(44),
    [sym_class_declaration] = STATE(44),
    [sym_constructor] = STATE(44),
    [sym_destructor] = STATE(44),
    [sym_alias_this] = STATE(44),
    [sym_interface_declaration] = STATE(44),
    [sym_enum_declaration] = STATE(44),
    [sym_anonymous_enum_declaration] = STATE(44),
    [sym_function_declaration] = STATE(44),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(44),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(44),
    [sym_template_mixin] = STATE(44),
    [sym_conditional_declaration] = STATE(44),
    [sym_conditional_statement] = STATE(44),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(44),
    [sym_static_foreach_declaration] = STATE(44),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(44),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(44),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(649),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(651),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(651),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(651),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(651),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(651),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [44] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(41),
    [sym_mixin_declaration] = STATE(41),
    [sym__declaration] = STATE(41),
    [sym__declaration2] = STATE(41),
    [sym_variable_declaration] = STATE(41),
    [sym_manifest_constant] = STATE(41),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(41),
    [sym_alias_declaration] = STATE(41),
    [sym_alias_reassign] = STATE(41),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(41),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(41),
    [sym_pragma_statement] = STATE(41),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(41),
    [sym_labeled_statement] = STATE(41),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(41),
    [sym_if_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_do_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(41),
    [sym_switch_statement] = STATE(41),
    [sym_final_switch_statement] = STATE(41),
    [sym_continue_statement] = STATE(41),
    [sym_break_statement] = STATE(41),
    [sym_return_statement] = STATE(41),
    [sym_goto_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_synchronized_statement] = STATE(41),
    [sym_try_statement] = STATE(41),
    [sym_scope_guard_statement] = STATE(41),
    [sym_asm_statement] = STATE(41),
    [sym_struct_declaration] = STATE(41),
    [sym_union_declaration] = STATE(41),
    [sym_postblit] = STATE(41),
    [sym_invariant_declaration] = STATE(41),
    [sym_class_declaration] = STATE(41),
    [sym_constructor] = STATE(41),
    [sym_destructor] = STATE(41),
    [sym_alias_this] = STATE(41),
    [sym_interface_declaration] = STATE(41),
    [sym_enum_declaration] = STATE(41),
    [sym_anonymous_enum_declaration] = STATE(41),
    [sym_function_declaration] = STATE(41),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(41),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(41),
    [sym_template_mixin] = STATE(41),
    [sym_conditional_declaration] = STATE(41),
    [sym_conditional_statement] = STATE(41),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(41),
    [sym_static_foreach_declaration] = STATE(41),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(41),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(41),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(385),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(655),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(655),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(655),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_else] = ACTIONS(655),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_finally] = ACTIONS(655),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [45] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2031),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(657),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(673),
    [sym_bool] = ACTIONS(676),
    [sym_byte] = ACTIONS(676),
    [sym_ubyte] = ACTIONS(676),
    [sym_char] = ACTIONS(676),
    [sym_short] = ACTIONS(676),
    [sym_ushort] = ACTIONS(676),
    [sym_int] = ACTIONS(676),
    [sym_uint] = ACTIONS(676),
    [sym_long] = ACTIONS(676),
    [sym_ulong] = ACTIONS(676),
    [sym_cent] = ACTIONS(676),
    [sym_ucent] = ACTIONS(676),
    [sym_wchar] = ACTIONS(676),
    [sym_dchar] = ACTIONS(676),
    [sym_float] = ACTIONS(676),
    [sym_double] = ACTIONS(676),
    [sym_real] = ACTIONS(676),
    [sym_ifloat] = ACTIONS(676),
    [sym_idouble] = ACTIONS(676),
    [sym_ireal] = ACTIONS(676),
    [sym_cfloat] = ACTIONS(676),
    [sym_cdouble] = ACTIONS(676),
    [sym_creal] = ACTIONS(676),
    [sym_size_t] = ACTIONS(676),
    [sym_ptrdiff_t] = ACTIONS(676),
    [sym_string] = ACTIONS(676),
    [sym_cstring] = ACTIONS(676),
    [sym_dstring] = ACTIONS(676),
    [sym_wstring] = ACTIONS(676),
    [sym_noreturn] = ACTIONS(676),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(681),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(686),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(691),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(698),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(705),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(710),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(715),
    [sym_final] = ACTIONS(718),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(698),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(698),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(735),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(681),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(681),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(681),
    [sym_ref] = ACTIONS(738),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(743),
    [sym_shared] = ACTIONS(746),
    [sym_static] = ACTIONS(749),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(756),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(763),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(681),
    [sym_traits] = ACTIONS(776),
    [sym_vector] = ACTIONS(779),
    [sym_void] = ACTIONS(676),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [46] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(63),
    [sym_mixin_declaration] = STATE(63),
    [sym__declaration] = STATE(63),
    [sym__declaration2] = STATE(63),
    [sym_variable_declaration] = STATE(63),
    [sym_manifest_constant] = STATE(63),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_alias_reassign] = STATE(63),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(63),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(63),
    [sym_pragma_statement] = STATE(63),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_final_switch_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_synchronized_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_scope_guard_statement] = STATE(63),
    [sym_asm_statement] = STATE(63),
    [sym_struct_declaration] = STATE(63),
    [sym_union_declaration] = STATE(63),
    [sym_postblit] = STATE(63),
    [sym_invariant_declaration] = STATE(63),
    [sym_class_declaration] = STATE(63),
    [sym_constructor] = STATE(63),
    [sym_destructor] = STATE(63),
    [sym_alias_this] = STATE(63),
    [sym_interface_declaration] = STATE(63),
    [sym_enum_declaration] = STATE(63),
    [sym_anonymous_enum_declaration] = STATE(63),
    [sym_function_declaration] = STATE(63),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(63),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(63),
    [sym_template_mixin] = STATE(63),
    [sym_conditional_declaration] = STATE(63),
    [sym_conditional_statement] = STATE(63),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(63),
    [sym_static_foreach_declaration] = STATE(63),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(63),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(655),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(655),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(655),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(655),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [47] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(86),
    [sym_mixin_declaration] = STATE(86),
    [sym__declaration] = STATE(86),
    [sym__declaration2] = STATE(86),
    [sym_variable_declaration] = STATE(86),
    [sym_manifest_constant] = STATE(86),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(86),
    [sym_alias_declaration] = STATE(86),
    [sym_alias_reassign] = STATE(86),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(86),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(86),
    [sym_pragma_statement] = STATE(86),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(86),
    [aux_sym__declarations_and_statements] = STATE(86),
    [sym__declaration_or_statement] = STATE(86),
    [sym__statement_no_case_no_default] = STATE(86),
    [sym_labeled_statement] = STATE(86),
    [sym_label] = STATE(66),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(86),
    [sym_if_statement] = STATE(86),
    [sym_while_statement] = STATE(86),
    [sym_do_statement] = STATE(86),
    [sym_for_statement] = STATE(86),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(86),
    [sym_switch_statement] = STATE(86),
    [sym_case_statement] = STATE(86),
    [sym_final_switch_statement] = STATE(86),
    [sym_continue_statement] = STATE(86),
    [sym_break_statement] = STATE(86),
    [sym_return_statement] = STATE(86),
    [sym_goto_statement] = STATE(86),
    [sym_with_statement] = STATE(86),
    [sym_synchronized_statement] = STATE(86),
    [sym_try_statement] = STATE(86),
    [sym_scope_guard_statement] = STATE(86),
    [sym_asm_statement] = STATE(86),
    [sym_struct_declaration] = STATE(86),
    [sym_union_declaration] = STATE(86),
    [sym_postblit] = STATE(86),
    [sym_invariant_declaration] = STATE(86),
    [sym_class_declaration] = STATE(86),
    [sym_constructor] = STATE(86),
    [sym_destructor] = STATE(86),
    [sym_alias_this] = STATE(86),
    [sym_interface_declaration] = STATE(86),
    [sym_enum_declaration] = STATE(86),
    [sym_anonymous_enum_declaration] = STATE(86),
    [sym_function_declaration] = STATE(86),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(86),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(86),
    [sym_template_mixin] = STATE(86),
    [sym_conditional_declaration] = STATE(86),
    [sym_conditional_statement] = STATE(86),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(86),
    [sym_static_foreach_declaration] = STATE(86),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(86),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(808),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [48] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4681),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(870),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(878),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(892),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(902),
    [sym_shared] = ACTIONS(906),
    [sym_static] = ACTIONS(910),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(916),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [49] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1501),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(940),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(944),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(952),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(956),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(960),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(964),
    [sym_shared] = ACTIONS(968),
    [sym_static] = ACTIONS(972),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(976),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [50] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4681),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(984),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(996),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1002),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1018),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1022),
    [sym_shared] = ACTIONS(1026),
    [sym_static] = ACTIONS(1030),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1038),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [51] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2031),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1060),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1062),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1066),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1076),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1080),
    [sym_shared] = ACTIONS(1084),
    [sym_static] = ACTIONS(1088),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1094),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [52] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1104),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [53] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4720),
    [sym_mixin_declaration] = STATE(4720),
    [sym__declaration] = STATE(4720),
    [sym__declaration2] = STATE(4720),
    [sym_variable_declaration] = STATE(4720),
    [sym_manifest_constant] = STATE(4720),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4720),
    [sym_alias_declaration] = STATE(4720),
    [sym_alias_reassign] = STATE(4720),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4720),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4720),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4703),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4720),
    [sym_union_declaration] = STATE(4720),
    [sym_postblit] = STATE(4720),
    [sym_invariant_declaration] = STATE(4720),
    [sym_class_declaration] = STATE(4720),
    [sym_constructor] = STATE(4720),
    [sym_destructor] = STATE(4720),
    [sym_alias_this] = STATE(4720),
    [sym_interface_declaration] = STATE(4720),
    [sym_enum_declaration] = STATE(4720),
    [sym_anonymous_enum_declaration] = STATE(4720),
    [sym_function_declaration] = STATE(4720),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4720),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4720),
    [sym_template_mixin] = STATE(4720),
    [sym_conditional_declaration] = STATE(4720),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4720),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4720),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1110),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1112),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [54] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [55] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(52),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [56] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(55),
    [sym_mixin_declaration] = STATE(55),
    [sym__declaration] = STATE(55),
    [sym__declaration2] = STATE(55),
    [sym_variable_declaration] = STATE(55),
    [sym_manifest_constant] = STATE(55),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(55),
    [sym_alias_declaration] = STATE(55),
    [sym_alias_reassign] = STATE(55),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(55),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(55),
    [sym_pragma_statement] = STATE(55),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(55),
    [aux_sym__declarations_and_statements] = STATE(55),
    [sym__declaration_or_statement] = STATE(55),
    [sym__statement_no_case_no_default] = STATE(55),
    [sym_labeled_statement] = STATE(55),
    [sym_label] = STATE(54),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(55),
    [sym_if_statement] = STATE(55),
    [sym_while_statement] = STATE(55),
    [sym_do_statement] = STATE(55),
    [sym_for_statement] = STATE(55),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(55),
    [sym_switch_statement] = STATE(55),
    [sym_case_statement] = STATE(55),
    [sym_final_switch_statement] = STATE(55),
    [sym_continue_statement] = STATE(55),
    [sym_break_statement] = STATE(55),
    [sym_return_statement] = STATE(55),
    [sym_goto_statement] = STATE(55),
    [sym_with_statement] = STATE(55),
    [sym_synchronized_statement] = STATE(55),
    [sym_try_statement] = STATE(55),
    [sym_scope_guard_statement] = STATE(55),
    [sym_asm_statement] = STATE(55),
    [sym_struct_declaration] = STATE(55),
    [sym_union_declaration] = STATE(55),
    [sym_postblit] = STATE(55),
    [sym_invariant_declaration] = STATE(55),
    [sym_class_declaration] = STATE(55),
    [sym_constructor] = STATE(55),
    [sym_destructor] = STATE(55),
    [sym_alias_this] = STATE(55),
    [sym_interface_declaration] = STATE(55),
    [sym_enum_declaration] = STATE(55),
    [sym_anonymous_enum_declaration] = STATE(55),
    [sym_function_declaration] = STATE(55),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(55),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(55),
    [sym_template_mixin] = STATE(55),
    [sym_conditional_declaration] = STATE(55),
    [sym_conditional_statement] = STATE(55),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(55),
    [sym_static_foreach_declaration] = STATE(55),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(55),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1134),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1136),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [57] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2031),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1138),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1062),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1140),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1076),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1150),
    [sym_shared] = ACTIONS(1084),
    [sym_static] = ACTIONS(1154),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1160),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [58] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [59] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1479),
    [sym_mixin_declaration] = STATE(1479),
    [sym__declaration] = STATE(1479),
    [sym__declaration2] = STATE(1479),
    [sym_variable_declaration] = STATE(1479),
    [sym_manifest_constant] = STATE(1479),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1479),
    [sym_alias_declaration] = STATE(1479),
    [sym_alias_reassign] = STATE(1479),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1479),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1479),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1475),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1479),
    [sym_union_declaration] = STATE(1479),
    [sym_postblit] = STATE(1479),
    [sym_invariant_declaration] = STATE(1479),
    [sym_class_declaration] = STATE(1479),
    [sym_constructor] = STATE(1479),
    [sym_destructor] = STATE(1479),
    [sym_alias_this] = STATE(1479),
    [sym_interface_declaration] = STATE(1479),
    [sym_enum_declaration] = STATE(1479),
    [sym_anonymous_enum_declaration] = STATE(1479),
    [sym_function_declaration] = STATE(1479),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1479),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1479),
    [sym_template_mixin] = STATE(1479),
    [sym_conditional_declaration] = STATE(1479),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1479),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1479),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1172),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1174),
    [anon_sym_COLON] = ACTIONS(1176),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [60] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [61] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(58),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [62] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(61),
    [sym_mixin_declaration] = STATE(61),
    [sym__declaration] = STATE(61),
    [sym__declaration2] = STATE(61),
    [sym_variable_declaration] = STATE(61),
    [sym_manifest_constant] = STATE(61),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(61),
    [sym_alias_declaration] = STATE(61),
    [sym_alias_reassign] = STATE(61),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(61),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(61),
    [sym_pragma_statement] = STATE(61),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(61),
    [aux_sym__declarations_and_statements] = STATE(61),
    [sym__declaration_or_statement] = STATE(61),
    [sym__statement_no_case_no_default] = STATE(61),
    [sym_labeled_statement] = STATE(61),
    [sym_label] = STATE(60),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(61),
    [sym_if_statement] = STATE(61),
    [sym_while_statement] = STATE(61),
    [sym_do_statement] = STATE(61),
    [sym_for_statement] = STATE(61),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(61),
    [sym_switch_statement] = STATE(61),
    [sym_case_statement] = STATE(61),
    [sym_final_switch_statement] = STATE(61),
    [sym_continue_statement] = STATE(61),
    [sym_break_statement] = STATE(61),
    [sym_return_statement] = STATE(61),
    [sym_goto_statement] = STATE(61),
    [sym_with_statement] = STATE(61),
    [sym_synchronized_statement] = STATE(61),
    [sym_try_statement] = STATE(61),
    [sym_scope_guard_statement] = STATE(61),
    [sym_asm_statement] = STATE(61),
    [sym_struct_declaration] = STATE(61),
    [sym_union_declaration] = STATE(61),
    [sym_postblit] = STATE(61),
    [sym_invariant_declaration] = STATE(61),
    [sym_class_declaration] = STATE(61),
    [sym_constructor] = STATE(61),
    [sym_destructor] = STATE(61),
    [sym_alias_this] = STATE(61),
    [sym_interface_declaration] = STATE(61),
    [sym_enum_declaration] = STATE(61),
    [sym_anonymous_enum_declaration] = STATE(61),
    [sym_function_declaration] = STATE(61),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(61),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(61),
    [sym_template_mixin] = STATE(61),
    [sym_conditional_declaration] = STATE(61),
    [sym_conditional_statement] = STATE(61),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(61),
    [sym_static_foreach_declaration] = STATE(61),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(61),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1182),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [63] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(63),
    [sym_mixin_declaration] = STATE(63),
    [sym__declaration] = STATE(63),
    [sym__declaration2] = STATE(63),
    [sym_variable_declaration] = STATE(63),
    [sym_manifest_constant] = STATE(63),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_alias_reassign] = STATE(63),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(63),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(63),
    [sym_pragma_statement] = STATE(63),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_final_switch_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_synchronized_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_scope_guard_statement] = STATE(63),
    [sym_asm_statement] = STATE(63),
    [sym_struct_declaration] = STATE(63),
    [sym_union_declaration] = STATE(63),
    [sym_postblit] = STATE(63),
    [sym_invariant_declaration] = STATE(63),
    [sym_class_declaration] = STATE(63),
    [sym_constructor] = STATE(63),
    [sym_destructor] = STATE(63),
    [sym_alias_this] = STATE(63),
    [sym_interface_declaration] = STATE(63),
    [sym_enum_declaration] = STATE(63),
    [sym_anonymous_enum_declaration] = STATE(63),
    [sym_function_declaration] = STATE(63),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(63),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(63),
    [sym_template_mixin] = STATE(63),
    [sym_conditional_declaration] = STATE(63),
    [sym_conditional_statement] = STATE(63),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(63),
    [sym_static_foreach_declaration] = STATE(63),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(63),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(393),
    [anon_sym_q_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(401),
    [anon_sym_DOT] = ACTIONS(404),
    [anon_sym_AMP] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(1184),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(425),
    [anon_sym_AT] = ACTIONS(428),
    [sym_bool] = ACTIONS(431),
    [sym_byte] = ACTIONS(431),
    [sym_ubyte] = ACTIONS(431),
    [sym_char] = ACTIONS(431),
    [sym_short] = ACTIONS(431),
    [sym_ushort] = ACTIONS(431),
    [sym_int] = ACTIONS(431),
    [sym_uint] = ACTIONS(431),
    [sym_long] = ACTIONS(431),
    [sym_ulong] = ACTIONS(431),
    [sym_cent] = ACTIONS(431),
    [sym_ucent] = ACTIONS(431),
    [sym_wchar] = ACTIONS(431),
    [sym_dchar] = ACTIONS(431),
    [sym_float] = ACTIONS(431),
    [sym_double] = ACTIONS(431),
    [sym_real] = ACTIONS(431),
    [sym_ifloat] = ACTIONS(431),
    [sym_idouble] = ACTIONS(431),
    [sym_ireal] = ACTIONS(431),
    [sym_cfloat] = ACTIONS(431),
    [sym_cdouble] = ACTIONS(431),
    [sym_creal] = ACTIONS(431),
    [sym_size_t] = ACTIONS(431),
    [sym_ptrdiff_t] = ACTIONS(431),
    [sym_string] = ACTIONS(431),
    [sym_cstring] = ACTIONS(431),
    [sym_dstring] = ACTIONS(431),
    [sym_wstring] = ACTIONS(431),
    [sym_noreturn] = ACTIONS(431),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_super] = ACTIONS(434),
    [sym_this] = ACTIONS(437),
    [sym_abstract] = ACTIONS(440),
    [sym_alias] = ACTIONS(443),
    [sym_align] = ACTIONS(446),
    [sym_asm] = ACTIONS(449),
    [sym_assert] = ACTIONS(452),
    [sym_auto] = ACTIONS(455),
    [sym_break] = ACTIONS(458),
    [sym_case] = ACTIONS(461),
    [sym_cast] = ACTIONS(463),
    [sym_catch] = ACTIONS(461),
    [sym_class] = ACTIONS(466),
    [sym_const] = ACTIONS(469),
    [sym_continue] = ACTIONS(472),
    [sym_debug] = ACTIONS(475),
    [sym_default] = ACTIONS(461),
    [sym_delegate] = ACTIONS(478),
    [sym_delete] = ACTIONS(481),
    [sym_deprecated] = ACTIONS(484),
    [sym_do] = ACTIONS(487),
    [sym_enum] = ACTIONS(490),
    [sym_export] = ACTIONS(493),
    [sym_extern] = ACTIONS(496),
    [sym_final] = ACTIONS(1187),
    [sym_finally] = ACTIONS(461),
    [sym_for] = ACTIONS(1190),
    [sym_foreach] = ACTIONS(1193),
    [sym_foreach_reverse] = ACTIONS(1193),
    [sym_function] = ACTIONS(508),
    [sym_goto] = ACTIONS(511),
    [sym_if] = ACTIONS(1196),
    [sym_immutable] = ACTIONS(469),
    [sym_import] = ACTIONS(517),
    [sym_in] = ACTIONS(520),
    [sym_inout] = ACTIONS(469),
    [sym_interface] = ACTIONS(523),
    [sym_invariant] = ACTIONS(526),
    [sym_is] = ACTIONS(529),
    [sym_mixin] = ACTIONS(532),
    [sym_new] = ACTIONS(535),
    [sym_nothrow] = ACTIONS(440),
    [sym_out] = ACTIONS(538),
    [sym_override] = ACTIONS(440),
    [sym_package] = ACTIONS(541),
    [sym_pragma] = ACTIONS(544),
    [sym_private] = ACTIONS(493),
    [sym_protected] = ACTIONS(493),
    [sym_public] = ACTIONS(493),
    [sym_pure] = ACTIONS(440),
    [sym_ref] = ACTIONS(547),
    [sym_return] = ACTIONS(550),
    [sym_scope] = ACTIONS(1199),
    [sym_shared] = ACTIONS(556),
    [sym_static] = ACTIONS(1202),
    [sym_struct] = ACTIONS(562),
    [sym_switch] = ACTIONS(1205),
    [sym_synchronized] = ACTIONS(1208),
    [sym_template] = ACTIONS(571),
    [sym_throw] = ACTIONS(574),
    [sym_try] = ACTIONS(1211),
    [sym_typeid] = ACTIONS(580),
    [sym_typeof] = ACTIONS(583),
    [sym_union] = ACTIONS(586),
    [sym_unittest] = ACTIONS(589),
    [sym_version] = ACTIONS(592),
    [sym_while] = ACTIONS(1214),
    [sym_with] = ACTIONS(1217),
    [sym_gshared] = ACTIONS(440),
    [sym_traits] = ACTIONS(601),
    [sym_vector] = ACTIONS(604),
    [sym_void] = ACTIONS(431),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_r_DQUOTE] = ACTIONS(610),
    [anon_sym_x_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(616),
    [anon_sym_i_BQUOTE] = ACTIONS(619),
    [anon_sym_i_DQUOTE] = ACTIONS(622),
    [anon_sym_iq_LBRACE] = ACTIONS(625),
    [aux_sym_char_literal_token1] = ACTIONS(628),
    [anon_sym_SQUOTE] = ACTIONS(631),
    [anon_sym___DATE__] = ACTIONS(634),
    [anon_sym___FILE__] = ACTIONS(634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(634),
    [anon_sym___FUNCTION__] = ACTIONS(634),
    [anon_sym___LINE__] = ACTIONS(634),
    [anon_sym___MODULE__] = ACTIONS(634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(634),
    [anon_sym___TIME__] = ACTIONS(634),
    [anon_sym___TIMESTAMP__] = ACTIONS(634),
    [anon_sym___VENDOR__] = ACTIONS(634),
    [anon_sym___VERSION__] = ACTIONS(634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(637),
    [sym_float_literal] = ACTIONS(637),
    [sym__string] = ACTIONS(640),
  },
  [64] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(74),
    [sym_mixin_declaration] = STATE(74),
    [sym__declaration] = STATE(74),
    [sym__declaration2] = STATE(74),
    [sym_variable_declaration] = STATE(74),
    [sym_manifest_constant] = STATE(74),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(74),
    [sym_alias_declaration] = STATE(74),
    [sym_alias_reassign] = STATE(74),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(74),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(74),
    [sym_pragma_statement] = STATE(74),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(74),
    [aux_sym__declarations_and_statements] = STATE(74),
    [sym__declaration_or_statement] = STATE(74),
    [sym__statement_no_case_no_default] = STATE(74),
    [sym_labeled_statement] = STATE(74),
    [sym_label] = STATE(75),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(74),
    [sym_if_statement] = STATE(74),
    [sym_while_statement] = STATE(74),
    [sym_do_statement] = STATE(74),
    [sym_for_statement] = STATE(74),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(74),
    [sym_switch_statement] = STATE(74),
    [sym_case_statement] = STATE(74),
    [sym_final_switch_statement] = STATE(74),
    [sym_continue_statement] = STATE(74),
    [sym_break_statement] = STATE(74),
    [sym_return_statement] = STATE(74),
    [sym_goto_statement] = STATE(74),
    [sym_with_statement] = STATE(74),
    [sym_synchronized_statement] = STATE(74),
    [sym_try_statement] = STATE(74),
    [sym_scope_guard_statement] = STATE(74),
    [sym_asm_statement] = STATE(74),
    [sym_struct_declaration] = STATE(74),
    [sym_union_declaration] = STATE(74),
    [sym_postblit] = STATE(74),
    [sym_invariant_declaration] = STATE(74),
    [sym_class_declaration] = STATE(74),
    [sym_constructor] = STATE(74),
    [sym_destructor] = STATE(74),
    [sym_alias_this] = STATE(74),
    [sym_interface_declaration] = STATE(74),
    [sym_enum_declaration] = STATE(74),
    [sym_anonymous_enum_declaration] = STATE(74),
    [sym_function_declaration] = STATE(74),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(74),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(74),
    [sym_template_mixin] = STATE(74),
    [sym_conditional_declaration] = STATE(74),
    [sym_conditional_statement] = STATE(74),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(74),
    [sym_static_foreach_declaration] = STATE(74),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(74),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1220),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [65] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(125),
    [sym_mixin_declaration] = STATE(125),
    [sym__declaration] = STATE(125),
    [sym__declaration2] = STATE(125),
    [sym_variable_declaration] = STATE(125),
    [sym_manifest_constant] = STATE(125),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(125),
    [sym_alias_declaration] = STATE(125),
    [sym_alias_reassign] = STATE(125),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(125),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(125),
    [sym_pragma_statement] = STATE(125),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(125),
    [aux_sym__declarations_and_statements] = STATE(125),
    [sym__declaration_or_statement] = STATE(125),
    [sym__statement_no_case_no_default] = STATE(125),
    [sym_labeled_statement] = STATE(125),
    [sym_label] = STATE(124),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(125),
    [sym_if_statement] = STATE(125),
    [sym_while_statement] = STATE(125),
    [sym_do_statement] = STATE(125),
    [sym_for_statement] = STATE(125),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(125),
    [sym_switch_statement] = STATE(125),
    [sym_case_statement] = STATE(125),
    [sym_final_switch_statement] = STATE(125),
    [sym_continue_statement] = STATE(125),
    [sym_break_statement] = STATE(125),
    [sym_return_statement] = STATE(125),
    [sym_goto_statement] = STATE(125),
    [sym_with_statement] = STATE(125),
    [sym_synchronized_statement] = STATE(125),
    [sym_try_statement] = STATE(125),
    [sym_scope_guard_statement] = STATE(125),
    [sym_asm_statement] = STATE(125),
    [sym_struct_declaration] = STATE(125),
    [sym_union_declaration] = STATE(125),
    [sym_postblit] = STATE(125),
    [sym_invariant_declaration] = STATE(125),
    [sym_class_declaration] = STATE(125),
    [sym_constructor] = STATE(125),
    [sym_destructor] = STATE(125),
    [sym_alias_this] = STATE(125),
    [sym_interface_declaration] = STATE(125),
    [sym_enum_declaration] = STATE(125),
    [sym_anonymous_enum_declaration] = STATE(125),
    [sym_function_declaration] = STATE(125),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(125),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(125),
    [sym_template_mixin] = STATE(125),
    [sym_conditional_declaration] = STATE(125),
    [sym_conditional_statement] = STATE(125),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(125),
    [sym_static_foreach_declaration] = STATE(125),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(125),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1224),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1226),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [66] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [67] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2003),
    [sym_mixin_declaration] = STATE(2003),
    [sym__declaration] = STATE(2003),
    [sym__declaration2] = STATE(2003),
    [sym_variable_declaration] = STATE(2003),
    [sym_manifest_constant] = STATE(2003),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2003),
    [sym_alias_declaration] = STATE(2003),
    [sym_alias_reassign] = STATE(2003),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2003),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2003),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2058),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2003),
    [sym_union_declaration] = STATE(2003),
    [sym_postblit] = STATE(2003),
    [sym_invariant_declaration] = STATE(2003),
    [sym_class_declaration] = STATE(2003),
    [sym_constructor] = STATE(2003),
    [sym_destructor] = STATE(2003),
    [sym_alias_this] = STATE(2003),
    [sym_interface_declaration] = STATE(2003),
    [sym_enum_declaration] = STATE(2003),
    [sym_anonymous_enum_declaration] = STATE(2003),
    [sym_function_declaration] = STATE(2003),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2003),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2003),
    [sym_template_mixin] = STATE(2003),
    [sym_conditional_declaration] = STATE(2003),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2003),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2003),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1232),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1234),
    [anon_sym_COLON] = ACTIONS(1176),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [68] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [69] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [70] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(80),
    [sym_mixin_declaration] = STATE(80),
    [sym__declaration] = STATE(80),
    [sym__declaration2] = STATE(80),
    [sym_variable_declaration] = STATE(80),
    [sym_manifest_constant] = STATE(80),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(80),
    [sym_alias_declaration] = STATE(80),
    [sym_alias_reassign] = STATE(80),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(80),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(80),
    [sym_pragma_statement] = STATE(80),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(80),
    [aux_sym__declarations_and_statements] = STATE(80),
    [sym__declaration_or_statement] = STATE(80),
    [sym__statement_no_case_no_default] = STATE(80),
    [sym_labeled_statement] = STATE(80),
    [sym_label] = STATE(81),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(80),
    [sym_if_statement] = STATE(80),
    [sym_while_statement] = STATE(80),
    [sym_do_statement] = STATE(80),
    [sym_for_statement] = STATE(80),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(80),
    [sym_switch_statement] = STATE(80),
    [sym_case_statement] = STATE(80),
    [sym_final_switch_statement] = STATE(80),
    [sym_continue_statement] = STATE(80),
    [sym_break_statement] = STATE(80),
    [sym_return_statement] = STATE(80),
    [sym_goto_statement] = STATE(80),
    [sym_with_statement] = STATE(80),
    [sym_synchronized_statement] = STATE(80),
    [sym_try_statement] = STATE(80),
    [sym_scope_guard_statement] = STATE(80),
    [sym_asm_statement] = STATE(80),
    [sym_struct_declaration] = STATE(80),
    [sym_union_declaration] = STATE(80),
    [sym_postblit] = STATE(80),
    [sym_invariant_declaration] = STATE(80),
    [sym_class_declaration] = STATE(80),
    [sym_constructor] = STATE(80),
    [sym_destructor] = STATE(80),
    [sym_alias_this] = STATE(80),
    [sym_interface_declaration] = STATE(80),
    [sym_enum_declaration] = STATE(80),
    [sym_anonymous_enum_declaration] = STATE(80),
    [sym_function_declaration] = STATE(80),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(80),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(80),
    [sym_template_mixin] = STATE(80),
    [sym_conditional_declaration] = STATE(80),
    [sym_conditional_statement] = STATE(80),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(80),
    [sym_static_foreach_declaration] = STATE(80),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(80),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1254),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1256),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [71] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1501),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(940),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(952),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1264),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(960),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(1268),
    [sym_shared] = ACTIONS(968),
    [sym_static] = ACTIONS(1272),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(1276),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [72] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2128),
    [sym_mixin_declaration] = STATE(2128),
    [sym__declaration] = STATE(2128),
    [sym__declaration2] = STATE(2128),
    [sym_variable_declaration] = STATE(2128),
    [sym_manifest_constant] = STATE(2128),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2128),
    [sym_alias_declaration] = STATE(2128),
    [sym_alias_reassign] = STATE(2128),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2128),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2128),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2131),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2128),
    [sym_union_declaration] = STATE(2128),
    [sym_postblit] = STATE(2128),
    [sym_invariant_declaration] = STATE(2128),
    [sym_class_declaration] = STATE(2128),
    [sym_constructor] = STATE(2128),
    [sym_destructor] = STATE(2128),
    [sym_alias_this] = STATE(2128),
    [sym_interface_declaration] = STATE(2128),
    [sym_enum_declaration] = STATE(2128),
    [sym_anonymous_enum_declaration] = STATE(2128),
    [sym_function_declaration] = STATE(2128),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2128),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2128),
    [sym_template_mixin] = STATE(2128),
    [sym_conditional_declaration] = STATE(2128),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2128),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2128),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1282),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [73] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [74] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(105),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [75] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [76] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1427),
    [sym_mixin_declaration] = STATE(1427),
    [sym__declaration] = STATE(1427),
    [sym__declaration2] = STATE(1427),
    [sym_variable_declaration] = STATE(1427),
    [sym_manifest_constant] = STATE(1427),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1427),
    [sym_alias_declaration] = STATE(1427),
    [sym_alias_reassign] = STATE(1427),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1427),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1427),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1426),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1427),
    [sym_union_declaration] = STATE(1427),
    [sym_postblit] = STATE(1427),
    [sym_invariant_declaration] = STATE(1427),
    [sym_class_declaration] = STATE(1427),
    [sym_constructor] = STATE(1427),
    [sym_destructor] = STATE(1427),
    [sym_alias_this] = STATE(1427),
    [sym_interface_declaration] = STATE(1427),
    [sym_enum_declaration] = STATE(1427),
    [sym_anonymous_enum_declaration] = STATE(1427),
    [sym_function_declaration] = STATE(1427),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1427),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1427),
    [sym_template_mixin] = STATE(1427),
    [sym_conditional_declaration] = STATE(1427),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1427),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1427),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1298),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1300),
    [anon_sym_COLON] = ACTIONS(1176),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [77] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(68),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [78] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2031),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1302),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1062),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1304),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1076),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1314),
    [sym_shared] = ACTIONS(1084),
    [sym_static] = ACTIONS(1318),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(1324),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [79] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(77),
    [sym_mixin_declaration] = STATE(77),
    [sym__declaration] = STATE(77),
    [sym__declaration2] = STATE(77),
    [sym_variable_declaration] = STATE(77),
    [sym_manifest_constant] = STATE(77),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(77),
    [sym_alias_declaration] = STATE(77),
    [sym_alias_reassign] = STATE(77),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(77),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(77),
    [sym_pragma_statement] = STATE(77),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(77),
    [aux_sym__declarations_and_statements] = STATE(77),
    [sym__declaration_or_statement] = STATE(77),
    [sym__statement_no_case_no_default] = STATE(77),
    [sym_labeled_statement] = STATE(77),
    [sym_label] = STATE(73),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(77),
    [sym_if_statement] = STATE(77),
    [sym_while_statement] = STATE(77),
    [sym_do_statement] = STATE(77),
    [sym_for_statement] = STATE(77),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(77),
    [sym_switch_statement] = STATE(77),
    [sym_case_statement] = STATE(77),
    [sym_final_switch_statement] = STATE(77),
    [sym_continue_statement] = STATE(77),
    [sym_break_statement] = STATE(77),
    [sym_return_statement] = STATE(77),
    [sym_goto_statement] = STATE(77),
    [sym_with_statement] = STATE(77),
    [sym_synchronized_statement] = STATE(77),
    [sym_try_statement] = STATE(77),
    [sym_scope_guard_statement] = STATE(77),
    [sym_asm_statement] = STATE(77),
    [sym_struct_declaration] = STATE(77),
    [sym_union_declaration] = STATE(77),
    [sym_postblit] = STATE(77),
    [sym_invariant_declaration] = STATE(77),
    [sym_class_declaration] = STATE(77),
    [sym_constructor] = STATE(77),
    [sym_destructor] = STATE(77),
    [sym_alias_this] = STATE(77),
    [sym_interface_declaration] = STATE(77),
    [sym_enum_declaration] = STATE(77),
    [sym_anonymous_enum_declaration] = STATE(77),
    [sym_function_declaration] = STATE(77),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(77),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(77),
    [sym_template_mixin] = STATE(77),
    [sym_conditional_declaration] = STATE(77),
    [sym_conditional_statement] = STATE(77),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(77),
    [sym_static_foreach_declaration] = STATE(77),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(77),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1336),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [80] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(83),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [81] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [82] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2132),
    [sym_mixin_declaration] = STATE(2132),
    [sym__declaration] = STATE(2132),
    [sym__declaration2] = STATE(2132),
    [sym_variable_declaration] = STATE(2132),
    [sym_manifest_constant] = STATE(2132),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2132),
    [sym_alias_declaration] = STATE(2132),
    [sym_alias_reassign] = STATE(2132),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2132),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2132),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2126),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2132),
    [sym_union_declaration] = STATE(2132),
    [sym_postblit] = STATE(2132),
    [sym_invariant_declaration] = STATE(2132),
    [sym_class_declaration] = STATE(2132),
    [sym_constructor] = STATE(2132),
    [sym_destructor] = STATE(2132),
    [sym_alias_this] = STATE(2132),
    [sym_interface_declaration] = STATE(2132),
    [sym_enum_declaration] = STATE(2132),
    [sym_anonymous_enum_declaration] = STATE(2132),
    [sym_function_declaration] = STATE(2132),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2132),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2132),
    [sym_template_mixin] = STATE(2132),
    [sym_conditional_declaration] = STATE(2132),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2132),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2132),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1340),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1342),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [83] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1344),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [84] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1558),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1350),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(1352),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1356),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1366),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1370),
    [sym_shared] = ACTIONS(1374),
    [sym_static] = ACTIONS(1378),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1384),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [85] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1394),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [86] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(69),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [87] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(99),
    [sym_mixin_declaration] = STATE(99),
    [sym__declaration] = STATE(99),
    [sym__declaration2] = STATE(99),
    [sym_variable_declaration] = STATE(99),
    [sym_manifest_constant] = STATE(99),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(99),
    [sym_alias_declaration] = STATE(99),
    [sym_alias_reassign] = STATE(99),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(99),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(99),
    [sym_pragma_statement] = STATE(99),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(99),
    [aux_sym__declarations_and_statements] = STATE(99),
    [sym__declaration_or_statement] = STATE(99),
    [sym__statement_no_case_no_default] = STATE(99),
    [sym_labeled_statement] = STATE(99),
    [sym_label] = STATE(100),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(99),
    [sym_if_statement] = STATE(99),
    [sym_while_statement] = STATE(99),
    [sym_do_statement] = STATE(99),
    [sym_for_statement] = STATE(99),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(99),
    [sym_switch_statement] = STATE(99),
    [sym_case_statement] = STATE(99),
    [sym_final_switch_statement] = STATE(99),
    [sym_continue_statement] = STATE(99),
    [sym_break_statement] = STATE(99),
    [sym_return_statement] = STATE(99),
    [sym_goto_statement] = STATE(99),
    [sym_with_statement] = STATE(99),
    [sym_synchronized_statement] = STATE(99),
    [sym_try_statement] = STATE(99),
    [sym_scope_guard_statement] = STATE(99),
    [sym_asm_statement] = STATE(99),
    [sym_struct_declaration] = STATE(99),
    [sym_union_declaration] = STATE(99),
    [sym_postblit] = STATE(99),
    [sym_invariant_declaration] = STATE(99),
    [sym_class_declaration] = STATE(99),
    [sym_constructor] = STATE(99),
    [sym_destructor] = STATE(99),
    [sym_alias_this] = STATE(99),
    [sym_interface_declaration] = STATE(99),
    [sym_enum_declaration] = STATE(99),
    [sym_anonymous_enum_declaration] = STATE(99),
    [sym_function_declaration] = STATE(99),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(99),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(99),
    [sym_template_mixin] = STATE(99),
    [sym_conditional_declaration] = STATE(99),
    [sym_conditional_statement] = STATE(99),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(99),
    [sym_static_foreach_declaration] = STATE(99),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(99),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1396),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1398),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [88] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1545),
    [sym_mixin_declaration] = STATE(1545),
    [sym__declaration] = STATE(1545),
    [sym__declaration2] = STATE(1545),
    [sym_variable_declaration] = STATE(1545),
    [sym_manifest_constant] = STATE(1545),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1545),
    [sym_alias_declaration] = STATE(1545),
    [sym_alias_reassign] = STATE(1545),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1545),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1545),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1546),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1545),
    [sym_union_declaration] = STATE(1545),
    [sym_postblit] = STATE(1545),
    [sym_invariant_declaration] = STATE(1545),
    [sym_class_declaration] = STATE(1545),
    [sym_constructor] = STATE(1545),
    [sym_destructor] = STATE(1545),
    [sym_alias_this] = STATE(1545),
    [sym_interface_declaration] = STATE(1545),
    [sym_enum_declaration] = STATE(1545),
    [sym_anonymous_enum_declaration] = STATE(1545),
    [sym_function_declaration] = STATE(1545),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1545),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1545),
    [sym_template_mixin] = STATE(1545),
    [sym_conditional_declaration] = STATE(1545),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1545),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1545),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1400),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1402),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [89] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [90] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(104),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1412),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [91] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(46),
    [sym_mixin_declaration] = STATE(46),
    [sym__declaration] = STATE(46),
    [sym__declaration2] = STATE(46),
    [sym_variable_declaration] = STATE(46),
    [sym_manifest_constant] = STATE(46),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(46),
    [sym_alias_declaration] = STATE(46),
    [sym_alias_reassign] = STATE(46),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(46),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(46),
    [sym_pragma_statement] = STATE(46),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(46),
    [sym_labeled_statement] = STATE(46),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(46),
    [sym_if_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_do_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(46),
    [sym_switch_statement] = STATE(46),
    [sym_final_switch_statement] = STATE(46),
    [sym_continue_statement] = STATE(46),
    [sym_break_statement] = STATE(46),
    [sym_return_statement] = STATE(46),
    [sym_goto_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_synchronized_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_scope_guard_statement] = STATE(46),
    [sym_asm_statement] = STATE(46),
    [sym_struct_declaration] = STATE(46),
    [sym_union_declaration] = STATE(46),
    [sym_postblit] = STATE(46),
    [sym_invariant_declaration] = STATE(46),
    [sym_class_declaration] = STATE(46),
    [sym_constructor] = STATE(46),
    [sym_destructor] = STATE(46),
    [sym_alias_this] = STATE(46),
    [sym_interface_declaration] = STATE(46),
    [sym_enum_declaration] = STATE(46),
    [sym_anonymous_enum_declaration] = STATE(46),
    [sym_function_declaration] = STATE(46),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(46),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(46),
    [sym_template_mixin] = STATE(46),
    [sym_conditional_declaration] = STATE(46),
    [sym_conditional_statement] = STATE(46),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(46),
    [sym_static_foreach_declaration] = STATE(46),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(46),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(46),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1414),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(651),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(651),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(651),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(651),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [92] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4722),
    [sym_mixin_declaration] = STATE(4722),
    [sym__declaration] = STATE(4722),
    [sym__declaration2] = STATE(4722),
    [sym_variable_declaration] = STATE(4722),
    [sym_manifest_constant] = STATE(4722),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4722),
    [sym_alias_declaration] = STATE(4722),
    [sym_alias_reassign] = STATE(4722),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4722),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4722),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4728),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4722),
    [sym_union_declaration] = STATE(4722),
    [sym_postblit] = STATE(4722),
    [sym_invariant_declaration] = STATE(4722),
    [sym_class_declaration] = STATE(4722),
    [sym_constructor] = STATE(4722),
    [sym_destructor] = STATE(4722),
    [sym_alias_this] = STATE(4722),
    [sym_interface_declaration] = STATE(4722),
    [sym_enum_declaration] = STATE(4722),
    [sym_anonymous_enum_declaration] = STATE(4722),
    [sym_function_declaration] = STATE(4722),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4722),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4722),
    [sym_template_mixin] = STATE(4722),
    [sym_conditional_declaration] = STATE(4722),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4722),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4722),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1416),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [93] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [94] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1558),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1346),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1422),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(1352),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1424),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1366),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1428),
    [sym_shared] = ACTIONS(1374),
    [sym_static] = ACTIONS(1432),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(1436),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [95] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(85),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [96] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2031),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1062),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1440),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1076),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1444),
    [sym_shared] = ACTIONS(1084),
    [sym_static] = ACTIONS(1448),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(1452),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [97] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(95),
    [sym_mixin_declaration] = STATE(95),
    [sym__declaration] = STATE(95),
    [sym__declaration2] = STATE(95),
    [sym_variable_declaration] = STATE(95),
    [sym_manifest_constant] = STATE(95),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(95),
    [sym_alias_declaration] = STATE(95),
    [sym_alias_reassign] = STATE(95),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(95),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(95),
    [sym_pragma_statement] = STATE(95),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(95),
    [aux_sym__declarations_and_statements] = STATE(95),
    [sym__declaration_or_statement] = STATE(95),
    [sym__statement_no_case_no_default] = STATE(95),
    [sym_labeled_statement] = STATE(95),
    [sym_label] = STATE(93),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(95),
    [sym_switch_statement] = STATE(95),
    [sym_case_statement] = STATE(95),
    [sym_final_switch_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_goto_statement] = STATE(95),
    [sym_with_statement] = STATE(95),
    [sym_synchronized_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_scope_guard_statement] = STATE(95),
    [sym_asm_statement] = STATE(95),
    [sym_struct_declaration] = STATE(95),
    [sym_union_declaration] = STATE(95),
    [sym_postblit] = STATE(95),
    [sym_invariant_declaration] = STATE(95),
    [sym_class_declaration] = STATE(95),
    [sym_constructor] = STATE(95),
    [sym_destructor] = STATE(95),
    [sym_alias_this] = STATE(95),
    [sym_interface_declaration] = STATE(95),
    [sym_enum_declaration] = STATE(95),
    [sym_anonymous_enum_declaration] = STATE(95),
    [sym_function_declaration] = STATE(95),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(95),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(95),
    [sym_template_mixin] = STATE(95),
    [sym_conditional_declaration] = STATE(95),
    [sym_conditional_statement] = STATE(95),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(95),
    [sym_static_foreach_declaration] = STATE(95),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(95),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1456),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(237),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [98] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(90),
    [sym_mixin_declaration] = STATE(90),
    [sym__declaration] = STATE(90),
    [sym__declaration2] = STATE(90),
    [sym_variable_declaration] = STATE(90),
    [sym_manifest_constant] = STATE(90),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(90),
    [sym_alias_declaration] = STATE(90),
    [sym_alias_reassign] = STATE(90),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(90),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(90),
    [sym_pragma_statement] = STATE(90),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(90),
    [aux_sym__declarations_and_statements] = STATE(90),
    [sym__declaration_or_statement] = STATE(90),
    [sym__statement_no_case_no_default] = STATE(90),
    [sym_labeled_statement] = STATE(90),
    [sym_label] = STATE(89),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(90),
    [sym_if_statement] = STATE(90),
    [sym_while_statement] = STATE(90),
    [sym_do_statement] = STATE(90),
    [sym_for_statement] = STATE(90),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(90),
    [sym_switch_statement] = STATE(90),
    [sym_case_statement] = STATE(90),
    [sym_final_switch_statement] = STATE(90),
    [sym_continue_statement] = STATE(90),
    [sym_break_statement] = STATE(90),
    [sym_return_statement] = STATE(90),
    [sym_goto_statement] = STATE(90),
    [sym_with_statement] = STATE(90),
    [sym_synchronized_statement] = STATE(90),
    [sym_try_statement] = STATE(90),
    [sym_scope_guard_statement] = STATE(90),
    [sym_asm_statement] = STATE(90),
    [sym_struct_declaration] = STATE(90),
    [sym_union_declaration] = STATE(90),
    [sym_postblit] = STATE(90),
    [sym_invariant_declaration] = STATE(90),
    [sym_class_declaration] = STATE(90),
    [sym_constructor] = STATE(90),
    [sym_destructor] = STATE(90),
    [sym_alias_this] = STATE(90),
    [sym_interface_declaration] = STATE(90),
    [sym_enum_declaration] = STATE(90),
    [sym_anonymous_enum_declaration] = STATE(90),
    [sym_function_declaration] = STATE(90),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(90),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(90),
    [sym_template_mixin] = STATE(90),
    [sym_conditional_declaration] = STATE(90),
    [sym_conditional_statement] = STATE(90),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(90),
    [sym_static_foreach_declaration] = STATE(90),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(90),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1460),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [99] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(102),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [100] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1462),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [101] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1955),
    [sym_mixin_declaration] = STATE(1955),
    [sym__declaration] = STATE(1955),
    [sym__declaration2] = STATE(1955),
    [sym_variable_declaration] = STATE(1955),
    [sym_manifest_constant] = STATE(1955),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(1955),
    [sym_alias_declaration] = STATE(1955),
    [sym_alias_reassign] = STATE(1955),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1955),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1955),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2011),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(1955),
    [sym_union_declaration] = STATE(1955),
    [sym_postblit] = STATE(1955),
    [sym_invariant_declaration] = STATE(1955),
    [sym_class_declaration] = STATE(1955),
    [sym_constructor] = STATE(1955),
    [sym_destructor] = STATE(1955),
    [sym_alias_this] = STATE(1955),
    [sym_interface_declaration] = STATE(1955),
    [sym_enum_declaration] = STATE(1955),
    [sym_anonymous_enum_declaration] = STATE(1955),
    [sym_function_declaration] = STATE(1955),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1955),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1955),
    [sym_template_mixin] = STATE(1955),
    [sym_conditional_declaration] = STATE(1955),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(1955),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1955),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1464),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1466),
    [anon_sym_COLON] = ACTIONS(1176),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [102] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [103] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1470),
    [anon_sym_q_LBRACE] = ACTIONS(1473),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1478),
    [anon_sym_DOT] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1484),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_DASH_DASH] = ACTIONS(1484),
    [anon_sym_PLUS] = ACTIONS(1487),
    [anon_sym_PLUS_PLUS] = ACTIONS(1484),
    [anon_sym_BANG] = ACTIONS(1484),
    [anon_sym_LPAREN] = ACTIONS(1490),
    [anon_sym_LBRACK] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1496),
    [anon_sym_DOLLAR] = ACTIONS(1499),
    [anon_sym_STAR] = ACTIONS(1484),
    [anon_sym_TILDE] = ACTIONS(1502),
    [anon_sym_AT] = ACTIONS(1505),
    [sym_bool] = ACTIONS(1508),
    [sym_byte] = ACTIONS(1508),
    [sym_ubyte] = ACTIONS(1508),
    [sym_char] = ACTIONS(1508),
    [sym_short] = ACTIONS(1508),
    [sym_ushort] = ACTIONS(1508),
    [sym_int] = ACTIONS(1508),
    [sym_uint] = ACTIONS(1508),
    [sym_long] = ACTIONS(1508),
    [sym_ulong] = ACTIONS(1508),
    [sym_cent] = ACTIONS(1508),
    [sym_ucent] = ACTIONS(1508),
    [sym_wchar] = ACTIONS(1508),
    [sym_dchar] = ACTIONS(1508),
    [sym_float] = ACTIONS(1508),
    [sym_double] = ACTIONS(1508),
    [sym_real] = ACTIONS(1508),
    [sym_ifloat] = ACTIONS(1508),
    [sym_idouble] = ACTIONS(1508),
    [sym_ireal] = ACTIONS(1508),
    [sym_cfloat] = ACTIONS(1508),
    [sym_cdouble] = ACTIONS(1508),
    [sym_creal] = ACTIONS(1508),
    [sym_size_t] = ACTIONS(1508),
    [sym_ptrdiff_t] = ACTIONS(1508),
    [sym_string] = ACTIONS(1508),
    [sym_cstring] = ACTIONS(1508),
    [sym_dstring] = ACTIONS(1508),
    [sym_wstring] = ACTIONS(1508),
    [sym_noreturn] = ACTIONS(1508),
    [sym_true] = ACTIONS(1511),
    [sym_false] = ACTIONS(1511),
    [sym_null] = ACTIONS(1511),
    [sym_super] = ACTIONS(1511),
    [sym_this] = ACTIONS(1514),
    [sym_abstract] = ACTIONS(1517),
    [sym_alias] = ACTIONS(1520),
    [sym_align] = ACTIONS(1523),
    [sym_asm] = ACTIONS(1526),
    [sym_assert] = ACTIONS(1529),
    [sym_auto] = ACTIONS(1532),
    [sym_break] = ACTIONS(1535),
    [sym_case] = ACTIONS(1538),
    [sym_cast] = ACTIONS(1541),
    [sym_class] = ACTIONS(1544),
    [sym_const] = ACTIONS(1547),
    [sym_continue] = ACTIONS(1550),
    [sym_debug] = ACTIONS(1553),
    [sym_default] = ACTIONS(1556),
    [sym_delegate] = ACTIONS(1559),
    [sym_delete] = ACTIONS(1562),
    [sym_deprecated] = ACTIONS(1565),
    [sym_do] = ACTIONS(1568),
    [sym_enum] = ACTIONS(1571),
    [sym_export] = ACTIONS(1574),
    [sym_extern] = ACTIONS(1577),
    [sym_final] = ACTIONS(1580),
    [sym_for] = ACTIONS(1583),
    [sym_foreach] = ACTIONS(1586),
    [sym_foreach_reverse] = ACTIONS(1586),
    [sym_function] = ACTIONS(1589),
    [sym_goto] = ACTIONS(1592),
    [sym_if] = ACTIONS(1595),
    [sym_immutable] = ACTIONS(1547),
    [sym_import] = ACTIONS(1598),
    [sym_in] = ACTIONS(1601),
    [sym_inout] = ACTIONS(1547),
    [sym_interface] = ACTIONS(1604),
    [sym_invariant] = ACTIONS(1607),
    [sym_is] = ACTIONS(1610),
    [sym_mixin] = ACTIONS(1613),
    [sym_new] = ACTIONS(1616),
    [sym_nothrow] = ACTIONS(1517),
    [sym_out] = ACTIONS(1619),
    [sym_override] = ACTIONS(1517),
    [sym_package] = ACTIONS(1622),
    [sym_pragma] = ACTIONS(1625),
    [sym_private] = ACTIONS(1574),
    [sym_protected] = ACTIONS(1574),
    [sym_public] = ACTIONS(1574),
    [sym_pure] = ACTIONS(1517),
    [sym_ref] = ACTIONS(1628),
    [sym_return] = ACTIONS(1631),
    [sym_scope] = ACTIONS(1634),
    [sym_shared] = ACTIONS(1637),
    [sym_static] = ACTIONS(1640),
    [sym_struct] = ACTIONS(1643),
    [sym_switch] = ACTIONS(1646),
    [sym_synchronized] = ACTIONS(1649),
    [sym_template] = ACTIONS(1652),
    [sym_throw] = ACTIONS(1655),
    [sym_try] = ACTIONS(1658),
    [sym_typeid] = ACTIONS(1661),
    [sym_typeof] = ACTIONS(1664),
    [sym_union] = ACTIONS(1667),
    [sym_unittest] = ACTIONS(1670),
    [sym_version] = ACTIONS(1673),
    [sym_while] = ACTIONS(1676),
    [sym_with] = ACTIONS(1679),
    [sym_gshared] = ACTIONS(1517),
    [sym_traits] = ACTIONS(1682),
    [sym_vector] = ACTIONS(1685),
    [sym_void] = ACTIONS(1508),
    [anon_sym_BQUOTE] = ACTIONS(1688),
    [anon_sym_r_DQUOTE] = ACTIONS(1691),
    [anon_sym_x_DQUOTE] = ACTIONS(1694),
    [anon_sym_DQUOTE] = ACTIONS(1697),
    [anon_sym_i_BQUOTE] = ACTIONS(1700),
    [anon_sym_i_DQUOTE] = ACTIONS(1703),
    [anon_sym_iq_LBRACE] = ACTIONS(1706),
    [aux_sym_char_literal_token1] = ACTIONS(1709),
    [anon_sym_SQUOTE] = ACTIONS(1712),
    [anon_sym___DATE__] = ACTIONS(1715),
    [anon_sym___FILE__] = ACTIONS(1715),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(1715),
    [anon_sym___FUNCTION__] = ACTIONS(1715),
    [anon_sym___LINE__] = ACTIONS(1715),
    [anon_sym___MODULE__] = ACTIONS(1715),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(1715),
    [anon_sym___TIME__] = ACTIONS(1715),
    [anon_sym___TIMESTAMP__] = ACTIONS(1715),
    [anon_sym___VENDOR__] = ACTIONS(1715),
    [anon_sym___VERSION__] = ACTIONS(1715),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(1718),
    [sym_float_literal] = ACTIONS(1718),
    [sym__string] = ACTIONS(1721),
  },
  [104] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1724),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [105] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1726),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [106] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [107] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [108] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(106),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1730),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [109] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [110] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(108),
    [sym_mixin_declaration] = STATE(108),
    [sym__declaration] = STATE(108),
    [sym__declaration2] = STATE(108),
    [sym_variable_declaration] = STATE(108),
    [sym_manifest_constant] = STATE(108),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(108),
    [sym_alias_declaration] = STATE(108),
    [sym_alias_reassign] = STATE(108),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(108),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(108),
    [sym_pragma_statement] = STATE(108),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(108),
    [aux_sym__declarations_and_statements] = STATE(108),
    [sym__declaration_or_statement] = STATE(108),
    [sym__statement_no_case_no_default] = STATE(108),
    [sym_labeled_statement] = STATE(108),
    [sym_label] = STATE(107),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(108),
    [sym_if_statement] = STATE(108),
    [sym_while_statement] = STATE(108),
    [sym_do_statement] = STATE(108),
    [sym_for_statement] = STATE(108),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(108),
    [sym_switch_statement] = STATE(108),
    [sym_case_statement] = STATE(108),
    [sym_final_switch_statement] = STATE(108),
    [sym_continue_statement] = STATE(108),
    [sym_break_statement] = STATE(108),
    [sym_return_statement] = STATE(108),
    [sym_goto_statement] = STATE(108),
    [sym_with_statement] = STATE(108),
    [sym_synchronized_statement] = STATE(108),
    [sym_try_statement] = STATE(108),
    [sym_scope_guard_statement] = STATE(108),
    [sym_asm_statement] = STATE(108),
    [sym_struct_declaration] = STATE(108),
    [sym_union_declaration] = STATE(108),
    [sym_postblit] = STATE(108),
    [sym_invariant_declaration] = STATE(108),
    [sym_class_declaration] = STATE(108),
    [sym_constructor] = STATE(108),
    [sym_destructor] = STATE(108),
    [sym_alias_this] = STATE(108),
    [sym_interface_declaration] = STATE(108),
    [sym_enum_declaration] = STATE(108),
    [sym_anonymous_enum_declaration] = STATE(108),
    [sym_function_declaration] = STATE(108),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(108),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(108),
    [sym_template_mixin] = STATE(108),
    [sym_conditional_declaration] = STATE(108),
    [sym_conditional_statement] = STATE(108),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(108),
    [sym_static_foreach_declaration] = STATE(108),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(108),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1734),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1736),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [111] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1602),
    [sym_mixin_declaration] = STATE(1602),
    [sym__declaration] = STATE(1602),
    [sym__declaration2] = STATE(1602),
    [sym_variable_declaration] = STATE(1602),
    [sym_manifest_constant] = STATE(1602),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1602),
    [sym_alias_declaration] = STATE(1602),
    [sym_alias_reassign] = STATE(1602),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1602),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1602),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1626),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1602),
    [sym_union_declaration] = STATE(1602),
    [sym_postblit] = STATE(1602),
    [sym_invariant_declaration] = STATE(1602),
    [sym_class_declaration] = STATE(1602),
    [sym_constructor] = STATE(1602),
    [sym_destructor] = STATE(1602),
    [sym_alias_this] = STATE(1602),
    [sym_interface_declaration] = STATE(1602),
    [sym_enum_declaration] = STATE(1602),
    [sym_anonymous_enum_declaration] = STATE(1602),
    [sym_function_declaration] = STATE(1602),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1602),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1602),
    [sym_template_mixin] = STATE(1602),
    [sym_conditional_declaration] = STATE(1602),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1602),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1602),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1738),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1740),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [112] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [113] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(109),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [114] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4681),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(980),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1744),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(996),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1746),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1018),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1756),
    [sym_shared] = ACTIONS(1026),
    [sym_static] = ACTIONS(1760),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1766),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [115] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4681),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(816),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(1776),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(826),
    [sym_bool] = ACTIONS(830),
    [sym_byte] = ACTIONS(830),
    [sym_ubyte] = ACTIONS(830),
    [sym_char] = ACTIONS(830),
    [sym_short] = ACTIONS(830),
    [sym_ushort] = ACTIONS(830),
    [sym_int] = ACTIONS(830),
    [sym_uint] = ACTIONS(830),
    [sym_long] = ACTIONS(830),
    [sym_ulong] = ACTIONS(830),
    [sym_cent] = ACTIONS(830),
    [sym_ucent] = ACTIONS(830),
    [sym_wchar] = ACTIONS(830),
    [sym_dchar] = ACTIONS(830),
    [sym_float] = ACTIONS(830),
    [sym_double] = ACTIONS(830),
    [sym_real] = ACTIONS(830),
    [sym_ifloat] = ACTIONS(830),
    [sym_idouble] = ACTIONS(830),
    [sym_ireal] = ACTIONS(830),
    [sym_cfloat] = ACTIONS(830),
    [sym_cdouble] = ACTIONS(830),
    [sym_creal] = ACTIONS(830),
    [sym_size_t] = ACTIONS(830),
    [sym_ptrdiff_t] = ACTIONS(830),
    [sym_string] = ACTIONS(830),
    [sym_cstring] = ACTIONS(830),
    [sym_dstring] = ACTIONS(830),
    [sym_wstring] = ACTIONS(830),
    [sym_noreturn] = ACTIONS(830),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(836),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(840),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(846),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(854),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(864),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(870),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(874),
    [sym_final] = ACTIONS(1778),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(854),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(854),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(892),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(836),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(836),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(836),
    [sym_ref] = ACTIONS(896),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1788),
    [sym_shared] = ACTIONS(906),
    [sym_static] = ACTIONS(1792),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1798),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(922),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(836),
    [sym_traits] = ACTIONS(932),
    [sym_vector] = ACTIONS(936),
    [sym_void] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [116] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(5302),
    [sym_mixin_declaration] = STATE(5302),
    [sym__declaration] = STATE(5302),
    [sym__declaration2] = STATE(5302),
    [sym_variable_declaration] = STATE(5302),
    [sym_manifest_constant] = STATE(5302),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(5302),
    [sym_alias_declaration] = STATE(5302),
    [sym_alias_reassign] = STATE(5302),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(5302),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(5302),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(5301),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(5302),
    [sym_union_declaration] = STATE(5302),
    [sym_postblit] = STATE(5302),
    [sym_invariant_declaration] = STATE(5302),
    [sym_class_declaration] = STATE(5302),
    [sym_constructor] = STATE(5302),
    [sym_destructor] = STATE(5302),
    [sym_alias_this] = STATE(5302),
    [sym_interface_declaration] = STATE(5302),
    [sym_enum_declaration] = STATE(5302),
    [sym_anonymous_enum_declaration] = STATE(5302),
    [sym_function_declaration] = STATE(5302),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(5302),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(5302),
    [sym_template_mixin] = STATE(5302),
    [sym_conditional_declaration] = STATE(5302),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(5302),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(5302),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1810),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1812),
    [anon_sym_COLON] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [117] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(113),
    [sym_mixin_declaration] = STATE(113),
    [sym__declaration] = STATE(113),
    [sym__declaration2] = STATE(113),
    [sym_variable_declaration] = STATE(113),
    [sym_manifest_constant] = STATE(113),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(113),
    [sym_alias_declaration] = STATE(113),
    [sym_alias_reassign] = STATE(113),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(113),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(113),
    [sym_pragma_statement] = STATE(113),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(113),
    [aux_sym__declarations_and_statements] = STATE(113),
    [sym__declaration_or_statement] = STATE(113),
    [sym__statement_no_case_no_default] = STATE(113),
    [sym_labeled_statement] = STATE(113),
    [sym_label] = STATE(112),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(113),
    [sym_if_statement] = STATE(113),
    [sym_while_statement] = STATE(113),
    [sym_do_statement] = STATE(113),
    [sym_for_statement] = STATE(113),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(113),
    [sym_switch_statement] = STATE(113),
    [sym_case_statement] = STATE(113),
    [sym_final_switch_statement] = STATE(113),
    [sym_continue_statement] = STATE(113),
    [sym_break_statement] = STATE(113),
    [sym_return_statement] = STATE(113),
    [sym_goto_statement] = STATE(113),
    [sym_with_statement] = STATE(113),
    [sym_synchronized_statement] = STATE(113),
    [sym_try_statement] = STATE(113),
    [sym_scope_guard_statement] = STATE(113),
    [sym_asm_statement] = STATE(113),
    [sym_struct_declaration] = STATE(113),
    [sym_union_declaration] = STATE(113),
    [sym_postblit] = STATE(113),
    [sym_invariant_declaration] = STATE(113),
    [sym_class_declaration] = STATE(113),
    [sym_constructor] = STATE(113),
    [sym_destructor] = STATE(113),
    [sym_alias_this] = STATE(113),
    [sym_interface_declaration] = STATE(113),
    [sym_enum_declaration] = STATE(113),
    [sym_anonymous_enum_declaration] = STATE(113),
    [sym_function_declaration] = STATE(113),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(113),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(113),
    [sym_template_mixin] = STATE(113),
    [sym_conditional_declaration] = STATE(113),
    [sym_conditional_statement] = STATE(113),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(113),
    [sym_static_foreach_declaration] = STATE(113),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(113),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1828),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [118] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(123),
    [sym_mixin_declaration] = STATE(123),
    [sym__declaration] = STATE(123),
    [sym__declaration2] = STATE(123),
    [sym_variable_declaration] = STATE(123),
    [sym_manifest_constant] = STATE(123),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(123),
    [sym_alias_declaration] = STATE(123),
    [sym_alias_reassign] = STATE(123),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(123),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(123),
    [sym_pragma_statement] = STATE(123),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(123),
    [sym_labeled_statement] = STATE(123),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(123),
    [sym_if_statement] = STATE(123),
    [sym_while_statement] = STATE(123),
    [sym_do_statement] = STATE(123),
    [sym_for_statement] = STATE(123),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(123),
    [sym_switch_statement] = STATE(123),
    [sym_final_switch_statement] = STATE(123),
    [sym_continue_statement] = STATE(123),
    [sym_break_statement] = STATE(123),
    [sym_return_statement] = STATE(123),
    [sym_goto_statement] = STATE(123),
    [sym_with_statement] = STATE(123),
    [sym_synchronized_statement] = STATE(123),
    [sym_try_statement] = STATE(123),
    [sym_scope_guard_statement] = STATE(123),
    [sym_asm_statement] = STATE(123),
    [sym_struct_declaration] = STATE(123),
    [sym_union_declaration] = STATE(123),
    [sym_postblit] = STATE(123),
    [sym_invariant_declaration] = STATE(123),
    [sym_class_declaration] = STATE(123),
    [sym_constructor] = STATE(123),
    [sym_destructor] = STATE(123),
    [sym_alias_this] = STATE(123),
    [sym_interface_declaration] = STATE(123),
    [sym_enum_declaration] = STATE(123),
    [sym_anonymous_enum_declaration] = STATE(123),
    [sym_function_declaration] = STATE(123),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(123),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(123),
    [sym_template_mixin] = STATE(123),
    [sym_conditional_declaration] = STATE(123),
    [sym_conditional_statement] = STATE(123),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(123),
    [sym_static_foreach_declaration] = STATE(123),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(123),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(123),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1830),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(319),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(319),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(319),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(319),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [119] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(5208),
    [sym_mixin_declaration] = STATE(5208),
    [sym__declaration] = STATE(5208),
    [sym__declaration2] = STATE(5208),
    [sym_variable_declaration] = STATE(5208),
    [sym_manifest_constant] = STATE(5208),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(5208),
    [sym_alias_declaration] = STATE(5208),
    [sym_alias_reassign] = STATE(5208),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(5208),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(5208),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(5387),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(5208),
    [sym_union_declaration] = STATE(5208),
    [sym_postblit] = STATE(5208),
    [sym_invariant_declaration] = STATE(5208),
    [sym_class_declaration] = STATE(5208),
    [sym_constructor] = STATE(5208),
    [sym_destructor] = STATE(5208),
    [sym_alias_this] = STATE(5208),
    [sym_interface_declaration] = STATE(5208),
    [sym_enum_declaration] = STATE(5208),
    [sym_anonymous_enum_declaration] = STATE(5208),
    [sym_function_declaration] = STATE(5208),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(5208),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(5208),
    [sym_template_mixin] = STATE(5208),
    [sym_conditional_declaration] = STATE(5208),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(5208),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(5208),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1832),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1834),
    [anon_sym_COLON] = ACTIONS(1814),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [120] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(63),
    [sym_mixin_declaration] = STATE(63),
    [sym__declaration] = STATE(63),
    [sym__declaration2] = STATE(63),
    [sym_variable_declaration] = STATE(63),
    [sym_manifest_constant] = STATE(63),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_alias_reassign] = STATE(63),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(63),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(63),
    [sym_pragma_statement] = STATE(63),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_final_switch_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_synchronized_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_scope_guard_statement] = STATE(63),
    [sym_asm_statement] = STATE(63),
    [sym_struct_declaration] = STATE(63),
    [sym_union_declaration] = STATE(63),
    [sym_postblit] = STATE(63),
    [sym_invariant_declaration] = STATE(63),
    [sym_class_declaration] = STATE(63),
    [sym_constructor] = STATE(63),
    [sym_destructor] = STATE(63),
    [sym_alias_this] = STATE(63),
    [sym_interface_declaration] = STATE(63),
    [sym_enum_declaration] = STATE(63),
    [sym_anonymous_enum_declaration] = STATE(63),
    [sym_function_declaration] = STATE(63),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(63),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(63),
    [sym_template_mixin] = STATE(63),
    [sym_conditional_declaration] = STATE(63),
    [sym_conditional_statement] = STATE(63),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(63),
    [sym_static_foreach_declaration] = STATE(63),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(63),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(645),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(645),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(645),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(645),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [121] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(127),
    [sym_mixin_declaration] = STATE(127),
    [sym__declaration] = STATE(127),
    [sym__declaration2] = STATE(127),
    [sym_variable_declaration] = STATE(127),
    [sym_manifest_constant] = STATE(127),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(127),
    [sym_alias_declaration] = STATE(127),
    [sym_alias_reassign] = STATE(127),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(127),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(127),
    [sym_pragma_statement] = STATE(127),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(127),
    [sym_labeled_statement] = STATE(127),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(127),
    [sym_if_statement] = STATE(127),
    [sym_while_statement] = STATE(127),
    [sym_do_statement] = STATE(127),
    [sym_for_statement] = STATE(127),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(127),
    [sym_switch_statement] = STATE(127),
    [sym_final_switch_statement] = STATE(127),
    [sym_continue_statement] = STATE(127),
    [sym_break_statement] = STATE(127),
    [sym_return_statement] = STATE(127),
    [sym_goto_statement] = STATE(127),
    [sym_with_statement] = STATE(127),
    [sym_synchronized_statement] = STATE(127),
    [sym_try_statement] = STATE(127),
    [sym_scope_guard_statement] = STATE(127),
    [sym_asm_statement] = STATE(127),
    [sym_struct_declaration] = STATE(127),
    [sym_union_declaration] = STATE(127),
    [sym_postblit] = STATE(127),
    [sym_invariant_declaration] = STATE(127),
    [sym_class_declaration] = STATE(127),
    [sym_constructor] = STATE(127),
    [sym_destructor] = STATE(127),
    [sym_alias_this] = STATE(127),
    [sym_interface_declaration] = STATE(127),
    [sym_enum_declaration] = STATE(127),
    [sym_anonymous_enum_declaration] = STATE(127),
    [sym_function_declaration] = STATE(127),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(127),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(127),
    [sym_template_mixin] = STATE(127),
    [sym_conditional_declaration] = STATE(127),
    [sym_conditional_statement] = STATE(127),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(127),
    [sym_static_foreach_declaration] = STATE(127),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(127),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(127),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1836),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(383),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(383),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [122] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [123] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(63),
    [sym_mixin_declaration] = STATE(63),
    [sym__declaration] = STATE(63),
    [sym__declaration2] = STATE(63),
    [sym_variable_declaration] = STATE(63),
    [sym_manifest_constant] = STATE(63),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_alias_reassign] = STATE(63),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(63),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(63),
    [sym_pragma_statement] = STATE(63),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_final_switch_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_synchronized_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_scope_guard_statement] = STATE(63),
    [sym_asm_statement] = STATE(63),
    [sym_struct_declaration] = STATE(63),
    [sym_union_declaration] = STATE(63),
    [sym_postblit] = STATE(63),
    [sym_invariant_declaration] = STATE(63),
    [sym_class_declaration] = STATE(63),
    [sym_constructor] = STATE(63),
    [sym_destructor] = STATE(63),
    [sym_alias_this] = STATE(63),
    [sym_interface_declaration] = STATE(63),
    [sym_enum_declaration] = STATE(63),
    [sym_anonymous_enum_declaration] = STATE(63),
    [sym_function_declaration] = STATE(63),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(63),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(63),
    [sym_template_mixin] = STATE(63),
    [sym_conditional_declaration] = STATE(63),
    [sym_conditional_statement] = STATE(63),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(63),
    [sym_static_foreach_declaration] = STATE(63),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(63),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(383),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(383),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [124] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [125] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(103),
    [sym_mixin_declaration] = STATE(103),
    [sym__declaration] = STATE(103),
    [sym__declaration2] = STATE(103),
    [sym_variable_declaration] = STATE(103),
    [sym_manifest_constant] = STATE(103),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(103),
    [sym_alias_declaration] = STATE(103),
    [sym_alias_reassign] = STATE(103),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(103),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(103),
    [sym_pragma_statement] = STATE(103),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(103),
    [aux_sym__declarations_and_statements] = STATE(103),
    [sym__declaration_or_statement] = STATE(103),
    [sym__statement_no_case_no_default] = STATE(103),
    [sym_labeled_statement] = STATE(103),
    [sym_label] = STATE(122),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(103),
    [sym_if_statement] = STATE(103),
    [sym_while_statement] = STATE(103),
    [sym_do_statement] = STATE(103),
    [sym_for_statement] = STATE(103),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(103),
    [sym_switch_statement] = STATE(103),
    [sym_case_statement] = STATE(103),
    [sym_final_switch_statement] = STATE(103),
    [sym_continue_statement] = STATE(103),
    [sym_break_statement] = STATE(103),
    [sym_return_statement] = STATE(103),
    [sym_goto_statement] = STATE(103),
    [sym_with_statement] = STATE(103),
    [sym_synchronized_statement] = STATE(103),
    [sym_try_statement] = STATE(103),
    [sym_scope_guard_statement] = STATE(103),
    [sym_asm_statement] = STATE(103),
    [sym_struct_declaration] = STATE(103),
    [sym_union_declaration] = STATE(103),
    [sym_postblit] = STATE(103),
    [sym_invariant_declaration] = STATE(103),
    [sym_class_declaration] = STATE(103),
    [sym_constructor] = STATE(103),
    [sym_destructor] = STATE(103),
    [sym_alias_this] = STATE(103),
    [sym_interface_declaration] = STATE(103),
    [sym_enum_declaration] = STATE(103),
    [sym_anonymous_enum_declaration] = STATE(103),
    [sym_function_declaration] = STATE(103),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(103),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(103),
    [sym_template_mixin] = STATE(103),
    [sym_conditional_declaration] = STATE(103),
    [sym_conditional_statement] = STATE(103),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(103),
    [sym_static_foreach_declaration] = STATE(103),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(103),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1132),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [126] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(120),
    [sym_mixin_declaration] = STATE(120),
    [sym__declaration] = STATE(120),
    [sym__declaration2] = STATE(120),
    [sym_variable_declaration] = STATE(120),
    [sym_manifest_constant] = STATE(120),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(120),
    [sym_alias_declaration] = STATE(120),
    [sym_alias_reassign] = STATE(120),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(120),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(120),
    [sym_pragma_statement] = STATE(120),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(120),
    [sym_labeled_statement] = STATE(120),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(120),
    [sym_if_statement] = STATE(120),
    [sym_while_statement] = STATE(120),
    [sym_do_statement] = STATE(120),
    [sym_for_statement] = STATE(120),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(120),
    [sym_switch_statement] = STATE(120),
    [sym_final_switch_statement] = STATE(120),
    [sym_continue_statement] = STATE(120),
    [sym_break_statement] = STATE(120),
    [sym_return_statement] = STATE(120),
    [sym_goto_statement] = STATE(120),
    [sym_with_statement] = STATE(120),
    [sym_synchronized_statement] = STATE(120),
    [sym_try_statement] = STATE(120),
    [sym_scope_guard_statement] = STATE(120),
    [sym_asm_statement] = STATE(120),
    [sym_struct_declaration] = STATE(120),
    [sym_union_declaration] = STATE(120),
    [sym_postblit] = STATE(120),
    [sym_invariant_declaration] = STATE(120),
    [sym_class_declaration] = STATE(120),
    [sym_constructor] = STATE(120),
    [sym_destructor] = STATE(120),
    [sym_alias_this] = STATE(120),
    [sym_interface_declaration] = STATE(120),
    [sym_enum_declaration] = STATE(120),
    [sym_anonymous_enum_declaration] = STATE(120),
    [sym_function_declaration] = STATE(120),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(120),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(120),
    [sym_template_mixin] = STATE(120),
    [sym_conditional_declaration] = STATE(120),
    [sym_conditional_statement] = STATE(120),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(120),
    [sym_static_foreach_declaration] = STATE(120),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(120),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(120),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1842),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(391),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(391),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [127] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(63),
    [sym_mixin_declaration] = STATE(63),
    [sym__declaration] = STATE(63),
    [sym__declaration2] = STATE(63),
    [sym_variable_declaration] = STATE(63),
    [sym_manifest_constant] = STATE(63),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(63),
    [sym_alias_declaration] = STATE(63),
    [sym_alias_reassign] = STATE(63),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(63),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(63),
    [sym_pragma_statement] = STATE(63),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(63),
    [sym_labeled_statement] = STATE(63),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_do_statement] = STATE(63),
    [sym_for_statement] = STATE(63),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(63),
    [sym_switch_statement] = STATE(63),
    [sym_final_switch_statement] = STATE(63),
    [sym_continue_statement] = STATE(63),
    [sym_break_statement] = STATE(63),
    [sym_return_statement] = STATE(63),
    [sym_goto_statement] = STATE(63),
    [sym_with_statement] = STATE(63),
    [sym_synchronized_statement] = STATE(63),
    [sym_try_statement] = STATE(63),
    [sym_scope_guard_statement] = STATE(63),
    [sym_asm_statement] = STATE(63),
    [sym_struct_declaration] = STATE(63),
    [sym_union_declaration] = STATE(63),
    [sym_postblit] = STATE(63),
    [sym_invariant_declaration] = STATE(63),
    [sym_class_declaration] = STATE(63),
    [sym_constructor] = STATE(63),
    [sym_destructor] = STATE(63),
    [sym_alias_this] = STATE(63),
    [sym_interface_declaration] = STATE(63),
    [sym_enum_declaration] = STATE(63),
    [sym_anonymous_enum_declaration] = STATE(63),
    [sym_function_declaration] = STATE(63),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(63),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(63),
    [sym_template_mixin] = STATE(63),
    [sym_conditional_declaration] = STATE(63),
    [sym_conditional_statement] = STATE(63),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(63),
    [sym_static_foreach_declaration] = STATE(63),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(63),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(63),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(782),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_catch] = ACTIONS(391),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_finally] = ACTIONS(391),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [128] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4676),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [129] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1940),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [130] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2084),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [131] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1352),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [132] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1435),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [133] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1360),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [134] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1361),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [135] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1362),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [136] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2083),
    [sym_mixin_declaration] = STATE(2083),
    [sym__declaration] = STATE(2083),
    [sym__declaration2] = STATE(2083),
    [sym_variable_declaration] = STATE(2083),
    [sym_manifest_constant] = STATE(2083),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2083),
    [sym_alias_declaration] = STATE(2083),
    [sym_alias_reassign] = STATE(2083),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2083),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2083),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2083),
    [sym_union_declaration] = STATE(2083),
    [sym_postblit] = STATE(2083),
    [sym_invariant_declaration] = STATE(2083),
    [sym_class_declaration] = STATE(2083),
    [sym_constructor] = STATE(2083),
    [sym_destructor] = STATE(2083),
    [sym_alias_this] = STATE(2083),
    [sym_interface_declaration] = STATE(2083),
    [sym_enum_declaration] = STATE(2083),
    [sym_anonymous_enum_declaration] = STATE(2083),
    [sym_function_declaration] = STATE(2083),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2083),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2083),
    [sym_template_mixin] = STATE(2083),
    [sym_conditional_declaration] = STATE(2083),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2083),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2083),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [137] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1375),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [138] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [139] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4621),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [140] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4623),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [141] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4625),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [142] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4695),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [143] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4634),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [144] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4636),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [145] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2026),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [146] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(146),
    [sym_mixin_declaration] = STATE(146),
    [sym__declaration] = STATE(146),
    [sym__declaration2] = STATE(146),
    [sym_variable_declaration] = STATE(146),
    [sym_manifest_constant] = STATE(146),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(146),
    [sym_alias_declaration] = STATE(146),
    [sym_alias_reassign] = STATE(146),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(146),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(146),
    [sym_pragma_statement] = STATE(146),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_final_switch_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym_with_statement] = STATE(146),
    [sym_synchronized_statement] = STATE(146),
    [sym_try_statement] = STATE(146),
    [sym_scope_guard_statement] = STATE(146),
    [sym_asm_statement] = STATE(146),
    [sym_struct_declaration] = STATE(146),
    [sym_union_declaration] = STATE(146),
    [sym_postblit] = STATE(146),
    [sym_invariant_declaration] = STATE(146),
    [sym_class_declaration] = STATE(146),
    [sym_constructor] = STATE(146),
    [sym_destructor] = STATE(146),
    [sym_alias_this] = STATE(146),
    [sym_interface_declaration] = STATE(146),
    [sym_enum_declaration] = STATE(146),
    [sym_anonymous_enum_declaration] = STATE(146),
    [sym_function_declaration] = STATE(146),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(146),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(146),
    [sym_template_mixin] = STATE(146),
    [sym_conditional_declaration] = STATE(146),
    [sym_conditional_statement] = STATE(146),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(146),
    [sym_static_foreach_declaration] = STATE(146),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(146),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(146),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1856),
    [anon_sym_q_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(404),
    [anon_sym_AMP] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(1862),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(1865),
    [anon_sym_AT] = ACTIONS(428),
    [sym_bool] = ACTIONS(431),
    [sym_byte] = ACTIONS(431),
    [sym_ubyte] = ACTIONS(431),
    [sym_char] = ACTIONS(431),
    [sym_short] = ACTIONS(431),
    [sym_ushort] = ACTIONS(431),
    [sym_int] = ACTIONS(431),
    [sym_uint] = ACTIONS(431),
    [sym_long] = ACTIONS(431),
    [sym_ulong] = ACTIONS(431),
    [sym_cent] = ACTIONS(431),
    [sym_ucent] = ACTIONS(431),
    [sym_wchar] = ACTIONS(431),
    [sym_dchar] = ACTIONS(431),
    [sym_float] = ACTIONS(431),
    [sym_double] = ACTIONS(431),
    [sym_real] = ACTIONS(431),
    [sym_ifloat] = ACTIONS(431),
    [sym_idouble] = ACTIONS(431),
    [sym_ireal] = ACTIONS(431),
    [sym_cfloat] = ACTIONS(431),
    [sym_cdouble] = ACTIONS(431),
    [sym_creal] = ACTIONS(431),
    [sym_size_t] = ACTIONS(431),
    [sym_ptrdiff_t] = ACTIONS(431),
    [sym_string] = ACTIONS(431),
    [sym_cstring] = ACTIONS(431),
    [sym_dstring] = ACTIONS(431),
    [sym_wstring] = ACTIONS(431),
    [sym_noreturn] = ACTIONS(431),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_super] = ACTIONS(434),
    [sym_this] = ACTIONS(1868),
    [sym_abstract] = ACTIONS(440),
    [sym_alias] = ACTIONS(1871),
    [sym_align] = ACTIONS(446),
    [sym_asm] = ACTIONS(1874),
    [sym_assert] = ACTIONS(452),
    [sym_auto] = ACTIONS(455),
    [sym_break] = ACTIONS(1877),
    [sym_case] = ACTIONS(461),
    [sym_cast] = ACTIONS(463),
    [sym_class] = ACTIONS(1880),
    [sym_const] = ACTIONS(469),
    [sym_continue] = ACTIONS(1883),
    [sym_debug] = ACTIONS(1886),
    [sym_default] = ACTIONS(461),
    [sym_delegate] = ACTIONS(478),
    [sym_delete] = ACTIONS(481),
    [sym_deprecated] = ACTIONS(484),
    [sym_do] = ACTIONS(1889),
    [sym_else] = ACTIONS(461),
    [sym_enum] = ACTIONS(1892),
    [sym_export] = ACTIONS(1895),
    [sym_extern] = ACTIONS(496),
    [sym_final] = ACTIONS(1898),
    [sym_for] = ACTIONS(1901),
    [sym_foreach] = ACTIONS(1904),
    [sym_foreach_reverse] = ACTIONS(1904),
    [sym_function] = ACTIONS(508),
    [sym_goto] = ACTIONS(1907),
    [sym_if] = ACTIONS(1910),
    [sym_immutable] = ACTIONS(469),
    [sym_import] = ACTIONS(1913),
    [sym_in] = ACTIONS(520),
    [sym_inout] = ACTIONS(469),
    [sym_interface] = ACTIONS(1916),
    [sym_invariant] = ACTIONS(1919),
    [sym_is] = ACTIONS(529),
    [sym_mixin] = ACTIONS(1922),
    [sym_new] = ACTIONS(535),
    [sym_nothrow] = ACTIONS(440),
    [sym_out] = ACTIONS(538),
    [sym_override] = ACTIONS(440),
    [sym_package] = ACTIONS(541),
    [sym_pragma] = ACTIONS(544),
    [sym_private] = ACTIONS(1895),
    [sym_protected] = ACTIONS(1895),
    [sym_public] = ACTIONS(1895),
    [sym_pure] = ACTIONS(440),
    [sym_ref] = ACTIONS(547),
    [sym_return] = ACTIONS(1925),
    [sym_scope] = ACTIONS(1928),
    [sym_shared] = ACTIONS(1931),
    [sym_static] = ACTIONS(1934),
    [sym_struct] = ACTIONS(1937),
    [sym_switch] = ACTIONS(1940),
    [sym_synchronized] = ACTIONS(1943),
    [sym_template] = ACTIONS(1946),
    [sym_throw] = ACTIONS(574),
    [sym_try] = ACTIONS(1949),
    [sym_typeid] = ACTIONS(580),
    [sym_typeof] = ACTIONS(583),
    [sym_union] = ACTIONS(1952),
    [sym_unittest] = ACTIONS(1955),
    [sym_version] = ACTIONS(1958),
    [sym_while] = ACTIONS(1961),
    [sym_with] = ACTIONS(1964),
    [sym_gshared] = ACTIONS(440),
    [sym_traits] = ACTIONS(601),
    [sym_vector] = ACTIONS(604),
    [sym_void] = ACTIONS(431),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_r_DQUOTE] = ACTIONS(610),
    [anon_sym_x_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(616),
    [anon_sym_i_BQUOTE] = ACTIONS(619),
    [anon_sym_i_DQUOTE] = ACTIONS(622),
    [anon_sym_iq_LBRACE] = ACTIONS(625),
    [aux_sym_char_literal_token1] = ACTIONS(628),
    [anon_sym_SQUOTE] = ACTIONS(631),
    [anon_sym___DATE__] = ACTIONS(634),
    [anon_sym___FILE__] = ACTIONS(634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(634),
    [anon_sym___FUNCTION__] = ACTIONS(634),
    [anon_sym___LINE__] = ACTIONS(634),
    [anon_sym___MODULE__] = ACTIONS(634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(634),
    [anon_sym___TIME__] = ACTIONS(634),
    [anon_sym___TIMESTAMP__] = ACTIONS(634),
    [anon_sym___VENDOR__] = ACTIONS(634),
    [anon_sym___VERSION__] = ACTIONS(634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(637),
    [sym_float_literal] = ACTIONS(637),
    [sym__string] = ACTIONS(640),
  },
  [147] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(146),
    [sym_mixin_declaration] = STATE(146),
    [sym__declaration] = STATE(146),
    [sym__declaration2] = STATE(146),
    [sym_variable_declaration] = STATE(146),
    [sym_manifest_constant] = STATE(146),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(146),
    [sym_alias_declaration] = STATE(146),
    [sym_alias_reassign] = STATE(146),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(146),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(146),
    [sym_pragma_statement] = STATE(146),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_final_switch_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym_with_statement] = STATE(146),
    [sym_synchronized_statement] = STATE(146),
    [sym_try_statement] = STATE(146),
    [sym_scope_guard_statement] = STATE(146),
    [sym_asm_statement] = STATE(146),
    [sym_struct_declaration] = STATE(146),
    [sym_union_declaration] = STATE(146),
    [sym_postblit] = STATE(146),
    [sym_invariant_declaration] = STATE(146),
    [sym_class_declaration] = STATE(146),
    [sym_constructor] = STATE(146),
    [sym_destructor] = STATE(146),
    [sym_alias_this] = STATE(146),
    [sym_interface_declaration] = STATE(146),
    [sym_enum_declaration] = STATE(146),
    [sym_anonymous_enum_declaration] = STATE(146),
    [sym_function_declaration] = STATE(146),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(146),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(146),
    [sym_template_mixin] = STATE(146),
    [sym_conditional_declaration] = STATE(146),
    [sym_conditional_statement] = STATE(146),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(146),
    [sym_static_foreach_declaration] = STATE(146),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(146),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(146),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(391),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [148] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(146),
    [sym_mixin_declaration] = STATE(146),
    [sym__declaration] = STATE(146),
    [sym__declaration2] = STATE(146),
    [sym_variable_declaration] = STATE(146),
    [sym_manifest_constant] = STATE(146),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(146),
    [sym_alias_declaration] = STATE(146),
    [sym_alias_reassign] = STATE(146),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(146),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(146),
    [sym_pragma_statement] = STATE(146),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_final_switch_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym_with_statement] = STATE(146),
    [sym_synchronized_statement] = STATE(146),
    [sym_try_statement] = STATE(146),
    [sym_scope_guard_statement] = STATE(146),
    [sym_asm_statement] = STATE(146),
    [sym_struct_declaration] = STATE(146),
    [sym_union_declaration] = STATE(146),
    [sym_postblit] = STATE(146),
    [sym_invariant_declaration] = STATE(146),
    [sym_class_declaration] = STATE(146),
    [sym_constructor] = STATE(146),
    [sym_destructor] = STATE(146),
    [sym_alias_this] = STATE(146),
    [sym_interface_declaration] = STATE(146),
    [sym_enum_declaration] = STATE(146),
    [sym_anonymous_enum_declaration] = STATE(146),
    [sym_function_declaration] = STATE(146),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(146),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(146),
    [sym_template_mixin] = STATE(146),
    [sym_conditional_declaration] = STATE(146),
    [sym_conditional_statement] = STATE(146),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(146),
    [sym_static_foreach_declaration] = STATE(146),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(146),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(146),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(645),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(645),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(645),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [149] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1395),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [150] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1398),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [151] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1399),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [152] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1400),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [153] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1407),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [154] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1410),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [155] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1411),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [156] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1413),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [157] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4624),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [158] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1414),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [159] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(172),
    [sym_mixin_declaration] = STATE(172),
    [sym__declaration] = STATE(172),
    [sym__declaration2] = STATE(172),
    [sym_variable_declaration] = STATE(172),
    [sym_manifest_constant] = STATE(172),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(172),
    [sym_alias_declaration] = STATE(172),
    [sym_alias_reassign] = STATE(172),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(172),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(172),
    [sym_pragma_statement] = STATE(172),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(172),
    [sym_labeled_statement] = STATE(172),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(172),
    [sym_if_statement] = STATE(172),
    [sym_while_statement] = STATE(172),
    [sym_do_statement] = STATE(172),
    [sym_for_statement] = STATE(172),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(172),
    [sym_switch_statement] = STATE(172),
    [sym_final_switch_statement] = STATE(172),
    [sym_continue_statement] = STATE(172),
    [sym_break_statement] = STATE(172),
    [sym_return_statement] = STATE(172),
    [sym_goto_statement] = STATE(172),
    [sym_with_statement] = STATE(172),
    [sym_synchronized_statement] = STATE(172),
    [sym_try_statement] = STATE(172),
    [sym_scope_guard_statement] = STATE(172),
    [sym_asm_statement] = STATE(172),
    [sym_struct_declaration] = STATE(172),
    [sym_union_declaration] = STATE(172),
    [sym_postblit] = STATE(172),
    [sym_invariant_declaration] = STATE(172),
    [sym_class_declaration] = STATE(172),
    [sym_constructor] = STATE(172),
    [sym_destructor] = STATE(172),
    [sym_alias_this] = STATE(172),
    [sym_interface_declaration] = STATE(172),
    [sym_enum_declaration] = STATE(172),
    [sym_anonymous_enum_declaration] = STATE(172),
    [sym_function_declaration] = STATE(172),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(172),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(172),
    [sym_template_mixin] = STATE(172),
    [sym_conditional_declaration] = STATE(172),
    [sym_conditional_statement] = STATE(172),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(172),
    [sym_static_foreach_declaration] = STATE(172),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(172),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(172),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(651),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(651),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(651),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [160] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2081),
    [sym_mixin_declaration] = STATE(2081),
    [sym__declaration] = STATE(2081),
    [sym__declaration2] = STATE(2081),
    [sym_variable_declaration] = STATE(2081),
    [sym_manifest_constant] = STATE(2081),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2081),
    [sym_alias_declaration] = STATE(2081),
    [sym_alias_reassign] = STATE(2081),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2081),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2081),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2081),
    [sym_union_declaration] = STATE(2081),
    [sym_postblit] = STATE(2081),
    [sym_invariant_declaration] = STATE(2081),
    [sym_class_declaration] = STATE(2081),
    [sym_constructor] = STATE(2081),
    [sym_destructor] = STATE(2081),
    [sym_alias_this] = STATE(2081),
    [sym_interface_declaration] = STATE(2081),
    [sym_enum_declaration] = STATE(2081),
    [sym_anonymous_enum_declaration] = STATE(2081),
    [sym_function_declaration] = STATE(2081),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2081),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2081),
    [sym_template_mixin] = STATE(2081),
    [sym_conditional_declaration] = STATE(2081),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2081),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2081),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1979),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [161] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1416),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [162] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2118),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [163] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2056),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [164] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [165] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2095),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [166] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1417),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [167] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2065),
    [sym_mixin_declaration] = STATE(2065),
    [sym__declaration] = STATE(2065),
    [sym__declaration2] = STATE(2065),
    [sym_variable_declaration] = STATE(2065),
    [sym_manifest_constant] = STATE(2065),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2065),
    [sym_alias_declaration] = STATE(2065),
    [sym_alias_reassign] = STATE(2065),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2065),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2065),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2065),
    [sym_union_declaration] = STATE(2065),
    [sym_postblit] = STATE(2065),
    [sym_invariant_declaration] = STATE(2065),
    [sym_class_declaration] = STATE(2065),
    [sym_constructor] = STATE(2065),
    [sym_destructor] = STATE(2065),
    [sym_alias_this] = STATE(2065),
    [sym_interface_declaration] = STATE(2065),
    [sym_enum_declaration] = STATE(2065),
    [sym_anonymous_enum_declaration] = STATE(2065),
    [sym_function_declaration] = STATE(2065),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2065),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2065),
    [sym_template_mixin] = STATE(2065),
    [sym_conditional_declaration] = STATE(2065),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2065),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2065),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [168] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1418),
    [sym_mixin_declaration] = STATE(1418),
    [sym__declaration] = STATE(1418),
    [sym__declaration2] = STATE(1418),
    [sym_variable_declaration] = STATE(1418),
    [sym_manifest_constant] = STATE(1418),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1418),
    [sym_alias_declaration] = STATE(1418),
    [sym_alias_reassign] = STATE(1418),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1418),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1418),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1414),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1418),
    [sym_union_declaration] = STATE(1418),
    [sym_postblit] = STATE(1418),
    [sym_invariant_declaration] = STATE(1418),
    [sym_class_declaration] = STATE(1418),
    [sym_constructor] = STATE(1418),
    [sym_destructor] = STATE(1418),
    [sym_alias_this] = STATE(1418),
    [sym_interface_declaration] = STATE(1418),
    [sym_enum_declaration] = STATE(1418),
    [sym_anonymous_enum_declaration] = STATE(1418),
    [sym_function_declaration] = STATE(1418),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1418),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1418),
    [sym_template_mixin] = STATE(1418),
    [sym_conditional_declaration] = STATE(1418),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1418),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1418),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [169] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4661),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [170] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1419),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [171] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4643),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [172] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(146),
    [sym_mixin_declaration] = STATE(146),
    [sym__declaration] = STATE(146),
    [sym__declaration2] = STATE(146),
    [sym_variable_declaration] = STATE(146),
    [sym_manifest_constant] = STATE(146),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(146),
    [sym_alias_declaration] = STATE(146),
    [sym_alias_reassign] = STATE(146),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(146),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(146),
    [sym_pragma_statement] = STATE(146),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_final_switch_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym_with_statement] = STATE(146),
    [sym_synchronized_statement] = STATE(146),
    [sym_try_statement] = STATE(146),
    [sym_scope_guard_statement] = STATE(146),
    [sym_asm_statement] = STATE(146),
    [sym_struct_declaration] = STATE(146),
    [sym_union_declaration] = STATE(146),
    [sym_postblit] = STATE(146),
    [sym_invariant_declaration] = STATE(146),
    [sym_class_declaration] = STATE(146),
    [sym_constructor] = STATE(146),
    [sym_destructor] = STATE(146),
    [sym_alias_this] = STATE(146),
    [sym_interface_declaration] = STATE(146),
    [sym_enum_declaration] = STATE(146),
    [sym_anonymous_enum_declaration] = STATE(146),
    [sym_function_declaration] = STATE(146),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(146),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(146),
    [sym_template_mixin] = STATE(146),
    [sym_conditional_declaration] = STATE(146),
    [sym_conditional_statement] = STATE(146),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(146),
    [sym_static_foreach_declaration] = STATE(146),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(146),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(146),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(655),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(655),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(655),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [173] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2094),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [174] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(148),
    [sym_mixin_declaration] = STATE(148),
    [sym__declaration] = STATE(148),
    [sym__declaration2] = STATE(148),
    [sym_variable_declaration] = STATE(148),
    [sym_manifest_constant] = STATE(148),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(148),
    [sym_alias_declaration] = STATE(148),
    [sym_alias_reassign] = STATE(148),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(148),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(148),
    [sym_pragma_statement] = STATE(148),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(148),
    [sym_labeled_statement] = STATE(148),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(148),
    [sym_if_statement] = STATE(148),
    [sym_while_statement] = STATE(148),
    [sym_do_statement] = STATE(148),
    [sym_for_statement] = STATE(148),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(148),
    [sym_switch_statement] = STATE(148),
    [sym_final_switch_statement] = STATE(148),
    [sym_continue_statement] = STATE(148),
    [sym_break_statement] = STATE(148),
    [sym_return_statement] = STATE(148),
    [sym_goto_statement] = STATE(148),
    [sym_with_statement] = STATE(148),
    [sym_synchronized_statement] = STATE(148),
    [sym_try_statement] = STATE(148),
    [sym_scope_guard_statement] = STATE(148),
    [sym_asm_statement] = STATE(148),
    [sym_struct_declaration] = STATE(148),
    [sym_union_declaration] = STATE(148),
    [sym_postblit] = STATE(148),
    [sym_invariant_declaration] = STATE(148),
    [sym_class_declaration] = STATE(148),
    [sym_constructor] = STATE(148),
    [sym_destructor] = STATE(148),
    [sym_alias_this] = STATE(148),
    [sym_interface_declaration] = STATE(148),
    [sym_enum_declaration] = STATE(148),
    [sym_anonymous_enum_declaration] = STATE(148),
    [sym_function_declaration] = STATE(148),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(148),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(148),
    [sym_template_mixin] = STATE(148),
    [sym_conditional_declaration] = STATE(148),
    [sym_conditional_statement] = STATE(148),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(148),
    [sym_static_foreach_declaration] = STATE(148),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(148),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(148),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(391),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [175] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1949),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [176] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1424),
    [sym_mixin_declaration] = STATE(1424),
    [sym__declaration] = STATE(1424),
    [sym__declaration2] = STATE(1424),
    [sym_variable_declaration] = STATE(1424),
    [sym_manifest_constant] = STATE(1424),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1424),
    [sym_alias_declaration] = STATE(1424),
    [sym_alias_reassign] = STATE(1424),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1424),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1424),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1419),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1424),
    [sym_union_declaration] = STATE(1424),
    [sym_postblit] = STATE(1424),
    [sym_invariant_declaration] = STATE(1424),
    [sym_class_declaration] = STATE(1424),
    [sym_constructor] = STATE(1424),
    [sym_destructor] = STATE(1424),
    [sym_alias_this] = STATE(1424),
    [sym_interface_declaration] = STATE(1424),
    [sym_enum_declaration] = STATE(1424),
    [sym_anonymous_enum_declaration] = STATE(1424),
    [sym_function_declaration] = STATE(1424),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1424),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1424),
    [sym_template_mixin] = STATE(1424),
    [sym_conditional_declaration] = STATE(1424),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1424),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1424),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [177] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2074),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [178] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1425),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [179] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4649),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [180] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1429),
    [sym_mixin_declaration] = STATE(1429),
    [sym__declaration] = STATE(1429),
    [sym__declaration2] = STATE(1429),
    [sym_variable_declaration] = STATE(1429),
    [sym_manifest_constant] = STATE(1429),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1429),
    [sym_alias_declaration] = STATE(1429),
    [sym_alias_reassign] = STATE(1429),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1429),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1429),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1425),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1429),
    [sym_union_declaration] = STATE(1429),
    [sym_postblit] = STATE(1429),
    [sym_invariant_declaration] = STATE(1429),
    [sym_class_declaration] = STATE(1429),
    [sym_constructor] = STATE(1429),
    [sym_destructor] = STATE(1429),
    [sym_alias_this] = STATE(1429),
    [sym_interface_declaration] = STATE(1429),
    [sym_enum_declaration] = STATE(1429),
    [sym_anonymous_enum_declaration] = STATE(1429),
    [sym_function_declaration] = STATE(1429),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1429),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1429),
    [sym_template_mixin] = STATE(1429),
    [sym_conditional_declaration] = STATE(1429),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1429),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1429),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [181] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2088),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [182] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1449),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [183] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [184] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2046),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [185] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2085),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [186] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1465),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [187] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(146),
    [sym_mixin_declaration] = STATE(146),
    [sym__declaration] = STATE(146),
    [sym__declaration2] = STATE(146),
    [sym_variable_declaration] = STATE(146),
    [sym_manifest_constant] = STATE(146),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(146),
    [sym_alias_declaration] = STATE(146),
    [sym_alias_reassign] = STATE(146),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(146),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(146),
    [sym_pragma_statement] = STATE(146),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(146),
    [sym_labeled_statement] = STATE(146),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(146),
    [sym_if_statement] = STATE(146),
    [sym_while_statement] = STATE(146),
    [sym_do_statement] = STATE(146),
    [sym_for_statement] = STATE(146),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(146),
    [sym_switch_statement] = STATE(146),
    [sym_final_switch_statement] = STATE(146),
    [sym_continue_statement] = STATE(146),
    [sym_break_statement] = STATE(146),
    [sym_return_statement] = STATE(146),
    [sym_goto_statement] = STATE(146),
    [sym_with_statement] = STATE(146),
    [sym_synchronized_statement] = STATE(146),
    [sym_try_statement] = STATE(146),
    [sym_scope_guard_statement] = STATE(146),
    [sym_asm_statement] = STATE(146),
    [sym_struct_declaration] = STATE(146),
    [sym_union_declaration] = STATE(146),
    [sym_postblit] = STATE(146),
    [sym_invariant_declaration] = STATE(146),
    [sym_class_declaration] = STATE(146),
    [sym_constructor] = STATE(146),
    [sym_destructor] = STATE(146),
    [sym_alias_this] = STATE(146),
    [sym_interface_declaration] = STATE(146),
    [sym_enum_declaration] = STATE(146),
    [sym_anonymous_enum_declaration] = STATE(146),
    [sym_function_declaration] = STATE(146),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(146),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(146),
    [sym_template_mixin] = STATE(146),
    [sym_conditional_declaration] = STATE(146),
    [sym_conditional_statement] = STATE(146),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(146),
    [sym_static_foreach_declaration] = STATE(146),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(146),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(146),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1967),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(383),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [188] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [189] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4663),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [190] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4649),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [191] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4643),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [192] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4636),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [193] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1985),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [194] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1968),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [195] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4634),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [196] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2072),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [197] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4695),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [198] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4625),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [199] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4623),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [200] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4621),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [201] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4619),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [202] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4618),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [203] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4617),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [204] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4628),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [205] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1962),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [206] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2063),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [207] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4614),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [208] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4613),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [209] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4676),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [210] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4612),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [211] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2067),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [212] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4611),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [213] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [214] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4646),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [215] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4652),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [216] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4653),
    [sym_mixin_declaration] = STATE(4653),
    [sym__declaration] = STATE(4653),
    [sym__declaration2] = STATE(4653),
    [sym_variable_declaration] = STATE(4653),
    [sym_manifest_constant] = STATE(4653),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4653),
    [sym_alias_declaration] = STATE(4653),
    [sym_alias_reassign] = STATE(4653),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4653),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4653),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4653),
    [sym_union_declaration] = STATE(4653),
    [sym_postblit] = STATE(4653),
    [sym_invariant_declaration] = STATE(4653),
    [sym_class_declaration] = STATE(4653),
    [sym_constructor] = STATE(4653),
    [sym_destructor] = STATE(4653),
    [sym_alias_this] = STATE(4653),
    [sym_interface_declaration] = STATE(4653),
    [sym_enum_declaration] = STATE(4653),
    [sym_anonymous_enum_declaration] = STATE(4653),
    [sym_function_declaration] = STATE(4653),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4653),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4653),
    [sym_template_mixin] = STATE(4653),
    [sym_conditional_declaration] = STATE(4653),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4653),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4653),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [217] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [218] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4682),
    [sym_mixin_declaration] = STATE(4682),
    [sym__declaration] = STATE(4682),
    [sym__declaration2] = STATE(4682),
    [sym_variable_declaration] = STATE(4682),
    [sym_manifest_constant] = STATE(4682),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4682),
    [sym_alias_declaration] = STATE(4682),
    [sym_alias_reassign] = STATE(4682),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4682),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4682),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4682),
    [sym_union_declaration] = STATE(4682),
    [sym_postblit] = STATE(4682),
    [sym_invariant_declaration] = STATE(4682),
    [sym_class_declaration] = STATE(4682),
    [sym_constructor] = STATE(4682),
    [sym_destructor] = STATE(4682),
    [sym_alias_this] = STATE(4682),
    [sym_interface_declaration] = STATE(4682),
    [sym_enum_declaration] = STATE(4682),
    [sym_anonymous_enum_declaration] = STATE(4682),
    [sym_function_declaration] = STATE(4682),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4682),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4682),
    [sym_template_mixin] = STATE(4682),
    [sym_conditional_declaration] = STATE(4682),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4682),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4682),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [219] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [220] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4690),
    [sym_mixin_declaration] = STATE(4690),
    [sym__declaration] = STATE(4690),
    [sym__declaration2] = STATE(4690),
    [sym_variable_declaration] = STATE(4690),
    [sym_manifest_constant] = STATE(4690),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4690),
    [sym_alias_declaration] = STATE(4690),
    [sym_alias_reassign] = STATE(4690),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4690),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4690),
    [sym_union_declaration] = STATE(4690),
    [sym_postblit] = STATE(4690),
    [sym_invariant_declaration] = STATE(4690),
    [sym_class_declaration] = STATE(4690),
    [sym_constructor] = STATE(4690),
    [sym_destructor] = STATE(4690),
    [sym_alias_this] = STATE(4690),
    [sym_interface_declaration] = STATE(4690),
    [sym_enum_declaration] = STATE(4690),
    [sym_anonymous_enum_declaration] = STATE(4690),
    [sym_function_declaration] = STATE(4690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4690),
    [sym_template_mixin] = STATE(4690),
    [sym_conditional_declaration] = STATE(4690),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4690),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4690),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [221] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2012),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [222] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4663),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [223] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(5297),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [224] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1536),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [225] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(147),
    [sym_mixin_declaration] = STATE(147),
    [sym__declaration] = STATE(147),
    [sym__declaration2] = STATE(147),
    [sym_variable_declaration] = STATE(147),
    [sym_manifest_constant] = STATE(147),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(147),
    [sym_alias_declaration] = STATE(147),
    [sym_alias_reassign] = STATE(147),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(147),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(147),
    [sym_pragma_statement] = STATE(147),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(147),
    [sym_labeled_statement] = STATE(147),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(147),
    [sym_if_statement] = STATE(147),
    [sym_while_statement] = STATE(147),
    [sym_do_statement] = STATE(147),
    [sym_for_statement] = STATE(147),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(147),
    [sym_switch_statement] = STATE(147),
    [sym_final_switch_statement] = STATE(147),
    [sym_continue_statement] = STATE(147),
    [sym_break_statement] = STATE(147),
    [sym_return_statement] = STATE(147),
    [sym_goto_statement] = STATE(147),
    [sym_with_statement] = STATE(147),
    [sym_synchronized_statement] = STATE(147),
    [sym_try_statement] = STATE(147),
    [sym_scope_guard_statement] = STATE(147),
    [sym_asm_statement] = STATE(147),
    [sym_struct_declaration] = STATE(147),
    [sym_union_declaration] = STATE(147),
    [sym_postblit] = STATE(147),
    [sym_invariant_declaration] = STATE(147),
    [sym_class_declaration] = STATE(147),
    [sym_constructor] = STATE(147),
    [sym_destructor] = STATE(147),
    [sym_alias_this] = STATE(147),
    [sym_interface_declaration] = STATE(147),
    [sym_enum_declaration] = STATE(147),
    [sym_anonymous_enum_declaration] = STATE(147),
    [sym_function_declaration] = STATE(147),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(147),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(147),
    [sym_template_mixin] = STATE(147),
    [sym_conditional_declaration] = STATE(147),
    [sym_conditional_statement] = STATE(147),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(147),
    [sym_static_foreach_declaration] = STATE(147),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(147),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(147),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2013),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(383),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [226] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2043),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [227] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1993),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [228] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1625),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [229] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(6420),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3371),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [230] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(6403),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3371),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [231] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2065),
    [sym_mixin_declaration] = STATE(2065),
    [sym__declaration] = STATE(2065),
    [sym__declaration2] = STATE(2065),
    [sym_variable_declaration] = STATE(2065),
    [sym_manifest_constant] = STATE(2065),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2065),
    [sym_alias_declaration] = STATE(2065),
    [sym_alias_reassign] = STATE(2065),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2065),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2065),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2065),
    [sym_union_declaration] = STATE(2065),
    [sym_postblit] = STATE(2065),
    [sym_invariant_declaration] = STATE(2065),
    [sym_class_declaration] = STATE(2065),
    [sym_constructor] = STATE(2065),
    [sym_destructor] = STATE(2065),
    [sym_alias_this] = STATE(2065),
    [sym_interface_declaration] = STATE(2065),
    [sym_enum_declaration] = STATE(2065),
    [sym_anonymous_enum_declaration] = STATE(2065),
    [sym_function_declaration] = STATE(2065),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2065),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2065),
    [sym_template_mixin] = STATE(2065),
    [sym_conditional_declaration] = STATE(2065),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2065),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2065),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [232] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [233] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(5390),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [234] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4619),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [235] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1510),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [236] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2081),
    [sym_mixin_declaration] = STATE(2081),
    [sym__declaration] = STATE(2081),
    [sym__declaration2] = STATE(2081),
    [sym_variable_declaration] = STATE(2081),
    [sym_manifest_constant] = STATE(2081),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2081),
    [sym_alias_declaration] = STATE(2081),
    [sym_alias_reassign] = STATE(2081),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2081),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2081),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2081),
    [sym_union_declaration] = STATE(2081),
    [sym_postblit] = STATE(2081),
    [sym_invariant_declaration] = STATE(2081),
    [sym_class_declaration] = STATE(2081),
    [sym_constructor] = STATE(2081),
    [sym_destructor] = STATE(2081),
    [sym_alias_this] = STATE(2081),
    [sym_interface_declaration] = STATE(2081),
    [sym_enum_declaration] = STATE(2081),
    [sym_anonymous_enum_declaration] = STATE(2081),
    [sym_function_declaration] = STATE(2081),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2081),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2081),
    [sym_template_mixin] = STATE(2081),
    [sym_conditional_declaration] = STATE(2081),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2081),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2081),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1979),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [237] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [238] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4618),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [239] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2083),
    [sym_mixin_declaration] = STATE(2083),
    [sym__declaration] = STATE(2083),
    [sym__declaration2] = STATE(2083),
    [sym_variable_declaration] = STATE(2083),
    [sym_manifest_constant] = STATE(2083),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2083),
    [sym_alias_declaration] = STATE(2083),
    [sym_alias_reassign] = STATE(2083),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2083),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2083),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2083),
    [sym_union_declaration] = STATE(2083),
    [sym_postblit] = STATE(2083),
    [sym_invariant_declaration] = STATE(2083),
    [sym_class_declaration] = STATE(2083),
    [sym_constructor] = STATE(2083),
    [sym_destructor] = STATE(2083),
    [sym_alias_this] = STATE(2083),
    [sym_interface_declaration] = STATE(2083),
    [sym_enum_declaration] = STATE(2083),
    [sym_anonymous_enum_declaration] = STATE(2083),
    [sym_function_declaration] = STATE(2083),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2083),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2083),
    [sym_template_mixin] = STATE(2083),
    [sym_conditional_declaration] = STATE(2083),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2083),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2083),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [240] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4535),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [241] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2084),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [242] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4617),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [243] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4628),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [244] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2085),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [245] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4676),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [246] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [247] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2088),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [248] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1660),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [249] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1949),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [250] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2094),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [251] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2095),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [252] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4732),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [253] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1625),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [254] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2118),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [255] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2026),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [256] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2046),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [257] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2074),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [258] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2057),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [259] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2056),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [260] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1518),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [261] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1526),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [262] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1985),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [263] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1611),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [264] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1614),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [265] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1616),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [266] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1620),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [267] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1621),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [268] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1634),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [269] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1968),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [270] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1609),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [271] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2072),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [272] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1962),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [273] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1613),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [274] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1658),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [275] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2063),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [276] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2067),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [277] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1619),
    [sym_mixin_declaration] = STATE(1619),
    [sym__declaration] = STATE(1619),
    [sym__declaration2] = STATE(1619),
    [sym_variable_declaration] = STATE(1619),
    [sym_manifest_constant] = STATE(1619),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1619),
    [sym_alias_declaration] = STATE(1619),
    [sym_alias_reassign] = STATE(1619),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1619),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1619),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1627),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1619),
    [sym_union_declaration] = STATE(1619),
    [sym_postblit] = STATE(1619),
    [sym_invariant_declaration] = STATE(1619),
    [sym_class_declaration] = STATE(1619),
    [sym_constructor] = STATE(1619),
    [sym_destructor] = STATE(1619),
    [sym_alias_this] = STATE(1619),
    [sym_interface_declaration] = STATE(1619),
    [sym_enum_declaration] = STATE(1619),
    [sym_anonymous_enum_declaration] = STATE(1619),
    [sym_function_declaration] = STATE(1619),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1619),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1619),
    [sym_template_mixin] = STATE(1619),
    [sym_conditional_declaration] = STATE(1619),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1619),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1619),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [278] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1667),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [279] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1671),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [280] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1670),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [281] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1669),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [282] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1627),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [283] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1630),
    [sym_mixin_declaration] = STATE(1630),
    [sym__declaration] = STATE(1630),
    [sym__declaration2] = STATE(1630),
    [sym_variable_declaration] = STATE(1630),
    [sym_manifest_constant] = STATE(1630),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1630),
    [sym_alias_declaration] = STATE(1630),
    [sym_alias_reassign] = STATE(1630),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1630),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1630),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1643),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1630),
    [sym_union_declaration] = STATE(1630),
    [sym_postblit] = STATE(1630),
    [sym_invariant_declaration] = STATE(1630),
    [sym_class_declaration] = STATE(1630),
    [sym_constructor] = STATE(1630),
    [sym_destructor] = STATE(1630),
    [sym_alias_this] = STATE(1630),
    [sym_interface_declaration] = STATE(1630),
    [sym_enum_declaration] = STATE(1630),
    [sym_anonymous_enum_declaration] = STATE(1630),
    [sym_function_declaration] = STATE(1630),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1630),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1630),
    [sym_template_mixin] = STATE(1630),
    [sym_conditional_declaration] = STATE(1630),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1630),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1630),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2027),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [284] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1343),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [285] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1668),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [286] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1275),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [287] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2051),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [288] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1664),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [289] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1653),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [290] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1652),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [291] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1651),
    [sym_mixin_declaration] = STATE(1651),
    [sym__declaration] = STATE(1651),
    [sym__declaration2] = STATE(1651),
    [sym_variable_declaration] = STATE(1651),
    [sym_manifest_constant] = STATE(1651),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1651),
    [sym_alias_declaration] = STATE(1651),
    [sym_alias_reassign] = STATE(1651),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1651),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1651),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1664),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1651),
    [sym_union_declaration] = STATE(1651),
    [sym_postblit] = STATE(1651),
    [sym_invariant_declaration] = STATE(1651),
    [sym_class_declaration] = STATE(1651),
    [sym_constructor] = STATE(1651),
    [sym_destructor] = STATE(1651),
    [sym_alias_this] = STATE(1651),
    [sym_interface_declaration] = STATE(1651),
    [sym_enum_declaration] = STATE(1651),
    [sym_anonymous_enum_declaration] = STATE(1651),
    [sym_function_declaration] = STATE(1651),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1651),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1651),
    [sym_template_mixin] = STATE(1651),
    [sym_conditional_declaration] = STATE(1651),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1651),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1651),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2031),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [292] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2027),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [293] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1643),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [294] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1643),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [295] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1409),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [296] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1346),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [297] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1651),
    [sym_mixin_declaration] = STATE(1651),
    [sym__declaration] = STATE(1651),
    [sym__declaration2] = STATE(1651),
    [sym_variable_declaration] = STATE(1651),
    [sym_manifest_constant] = STATE(1651),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1651),
    [sym_alias_declaration] = STATE(1651),
    [sym_alias_reassign] = STATE(1651),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1651),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1651),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1664),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1651),
    [sym_union_declaration] = STATE(1651),
    [sym_postblit] = STATE(1651),
    [sym_invariant_declaration] = STATE(1651),
    [sym_class_declaration] = STATE(1651),
    [sym_constructor] = STATE(1651),
    [sym_destructor] = STATE(1651),
    [sym_alias_this] = STATE(1651),
    [sym_interface_declaration] = STATE(1651),
    [sym_enum_declaration] = STATE(1651),
    [sym_anonymous_enum_declaration] = STATE(1651),
    [sym_function_declaration] = STATE(1651),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1651),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1651),
    [sym_template_mixin] = STATE(1651),
    [sym_conditional_declaration] = STATE(1651),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1651),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1651),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2031),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2033),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [298] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1652),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [299] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1653),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [300] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1993),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [301] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1630),
    [sym_mixin_declaration] = STATE(1630),
    [sym__declaration] = STATE(1630),
    [sym__declaration2] = STATE(1630),
    [sym_variable_declaration] = STATE(1630),
    [sym_manifest_constant] = STATE(1630),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1630),
    [sym_alias_declaration] = STATE(1630),
    [sym_alias_reassign] = STATE(1630),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1630),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1630),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1643),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1630),
    [sym_union_declaration] = STATE(1630),
    [sym_postblit] = STATE(1630),
    [sym_invariant_declaration] = STATE(1630),
    [sym_class_declaration] = STATE(1630),
    [sym_constructor] = STATE(1630),
    [sym_destructor] = STATE(1630),
    [sym_alias_this] = STATE(1630),
    [sym_interface_declaration] = STATE(1630),
    [sym_enum_declaration] = STATE(1630),
    [sym_anonymous_enum_declaration] = STATE(1630),
    [sym_function_declaration] = STATE(1630),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1630),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1630),
    [sym_template_mixin] = STATE(1630),
    [sym_conditional_declaration] = STATE(1630),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1630),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1630),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2027),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [302] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1627),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [303] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1619),
    [sym_mixin_declaration] = STATE(1619),
    [sym__declaration] = STATE(1619),
    [sym__declaration2] = STATE(1619),
    [sym_variable_declaration] = STATE(1619),
    [sym_manifest_constant] = STATE(1619),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1619),
    [sym_alias_declaration] = STATE(1619),
    [sym_alias_reassign] = STATE(1619),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1619),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1619),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1627),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1619),
    [sym_union_declaration] = STATE(1619),
    [sym_postblit] = STATE(1619),
    [sym_invariant_declaration] = STATE(1619),
    [sym_class_declaration] = STATE(1619),
    [sym_constructor] = STATE(1619),
    [sym_destructor] = STATE(1619),
    [sym_alias_this] = STATE(1619),
    [sym_interface_declaration] = STATE(1619),
    [sym_enum_declaration] = STATE(1619),
    [sym_anonymous_enum_declaration] = STATE(1619),
    [sym_function_declaration] = STATE(1619),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1619),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1619),
    [sym_template_mixin] = STATE(1619),
    [sym_conditional_declaration] = STATE(1619),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1619),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1619),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2023),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2025),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [304] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(187),
    [sym_mixin_declaration] = STATE(187),
    [sym__declaration] = STATE(187),
    [sym__declaration2] = STATE(187),
    [sym_variable_declaration] = STATE(187),
    [sym_manifest_constant] = STATE(187),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(187),
    [sym_alias_declaration] = STATE(187),
    [sym_alias_reassign] = STATE(187),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(187),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(187),
    [sym_pragma_statement] = STATE(187),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(187),
    [sym_labeled_statement] = STATE(187),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(187),
    [sym_if_statement] = STATE(187),
    [sym_while_statement] = STATE(187),
    [sym_do_statement] = STATE(187),
    [sym_for_statement] = STATE(187),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(187),
    [sym_switch_statement] = STATE(187),
    [sym_final_switch_statement] = STATE(187),
    [sym_continue_statement] = STATE(187),
    [sym_break_statement] = STATE(187),
    [sym_return_statement] = STATE(187),
    [sym_goto_statement] = STATE(187),
    [sym_with_statement] = STATE(187),
    [sym_synchronized_statement] = STATE(187),
    [sym_try_statement] = STATE(187),
    [sym_scope_guard_statement] = STATE(187),
    [sym_asm_statement] = STATE(187),
    [sym_struct_declaration] = STATE(187),
    [sym_union_declaration] = STATE(187),
    [sym_postblit] = STATE(187),
    [sym_invariant_declaration] = STATE(187),
    [sym_class_declaration] = STATE(187),
    [sym_constructor] = STATE(187),
    [sym_destructor] = STATE(187),
    [sym_alias_this] = STATE(187),
    [sym_interface_declaration] = STATE(187),
    [sym_enum_declaration] = STATE(187),
    [sym_anonymous_enum_declaration] = STATE(187),
    [sym_function_declaration] = STATE(187),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(187),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(187),
    [sym_template_mixin] = STATE(187),
    [sym_conditional_declaration] = STATE(187),
    [sym_conditional_statement] = STATE(187),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(187),
    [sym_static_foreach_declaration] = STATE(187),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(187),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(187),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2035),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(319),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(319),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_else] = ACTIONS(319),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [305] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4614),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [306] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1664),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [307] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1387),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [308] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1668),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [309] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1669),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [310] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1670),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [311] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(6510),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3371),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [312] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1671),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [313] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2065),
    [sym_mixin_declaration] = STATE(2065),
    [sym__declaration] = STATE(2065),
    [sym__declaration2] = STATE(2065),
    [sym_variable_declaration] = STATE(2065),
    [sym_manifest_constant] = STATE(2065),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2065),
    [sym_alias_declaration] = STATE(2065),
    [sym_alias_reassign] = STATE(2065),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2065),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2065),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2065),
    [sym_union_declaration] = STATE(2065),
    [sym_postblit] = STATE(2065),
    [sym_invariant_declaration] = STATE(2065),
    [sym_class_declaration] = STATE(2065),
    [sym_constructor] = STATE(2065),
    [sym_destructor] = STATE(2065),
    [sym_alias_this] = STATE(2065),
    [sym_interface_declaration] = STATE(2065),
    [sym_enum_declaration] = STATE(2065),
    [sym_anonymous_enum_declaration] = STATE(2065),
    [sym_function_declaration] = STATE(2065),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2065),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2065),
    [sym_template_mixin] = STATE(2065),
    [sym_conditional_declaration] = STATE(2065),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2065),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2065),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [314] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4676),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [315] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [316] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2081),
    [sym_mixin_declaration] = STATE(2081),
    [sym__declaration] = STATE(2081),
    [sym__declaration2] = STATE(2081),
    [sym_variable_declaration] = STATE(2081),
    [sym_manifest_constant] = STATE(2081),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2081),
    [sym_alias_declaration] = STATE(2081),
    [sym_alias_reassign] = STATE(2081),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2081),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2081),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2081),
    [sym_union_declaration] = STATE(2081),
    [sym_postblit] = STATE(2081),
    [sym_invariant_declaration] = STATE(2081),
    [sym_class_declaration] = STATE(2081),
    [sym_constructor] = STATE(2081),
    [sym_destructor] = STATE(2081),
    [sym_alias_this] = STATE(2081),
    [sym_interface_declaration] = STATE(2081),
    [sym_enum_declaration] = STATE(2081),
    [sym_anonymous_enum_declaration] = STATE(2081),
    [sym_function_declaration] = STATE(2081),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2081),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2081),
    [sym_template_mixin] = STATE(2081),
    [sym_conditional_declaration] = STATE(2081),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2081),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2081),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1979),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [317] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4613),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [318] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [319] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1945),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [320] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2083),
    [sym_mixin_declaration] = STATE(2083),
    [sym__declaration] = STATE(2083),
    [sym__declaration2] = STATE(2083),
    [sym_variable_declaration] = STATE(2083),
    [sym_manifest_constant] = STATE(2083),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2083),
    [sym_alias_declaration] = STATE(2083),
    [sym_alias_reassign] = STATE(2083),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2083),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2083),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2083),
    [sym_union_declaration] = STATE(2083),
    [sym_postblit] = STATE(2083),
    [sym_invariant_declaration] = STATE(2083),
    [sym_class_declaration] = STATE(2083),
    [sym_constructor] = STATE(2083),
    [sym_destructor] = STATE(2083),
    [sym_alias_this] = STATE(2083),
    [sym_interface_declaration] = STATE(2083),
    [sym_enum_declaration] = STATE(2083),
    [sym_anonymous_enum_declaration] = STATE(2083),
    [sym_function_declaration] = STATE(2083),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2083),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2083),
    [sym_template_mixin] = STATE(2083),
    [sym_conditional_declaration] = STATE(2083),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2083),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2083),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [321] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4612),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [322] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2084),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [323] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1278),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [324] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4611),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [325] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1667),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [326] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2085),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [327] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1658),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [328] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [329] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1613),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [330] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1609),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [331] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2088),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [332] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [333] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4646),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [334] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1949),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [335] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2094),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [336] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4652),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [337] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2095),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [338] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2118),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [339] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2129),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [340] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4663),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [341] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4653),
    [sym_mixin_declaration] = STATE(4653),
    [sym__declaration] = STATE(4653),
    [sym__declaration2] = STATE(4653),
    [sym_variable_declaration] = STATE(4653),
    [sym_manifest_constant] = STATE(4653),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4653),
    [sym_alias_declaration] = STATE(4653),
    [sym_alias_reassign] = STATE(4653),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4653),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4653),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4653),
    [sym_union_declaration] = STATE(4653),
    [sym_postblit] = STATE(4653),
    [sym_invariant_declaration] = STATE(4653),
    [sym_class_declaration] = STATE(4653),
    [sym_constructor] = STATE(4653),
    [sym_destructor] = STATE(4653),
    [sym_alias_this] = STATE(4653),
    [sym_interface_declaration] = STATE(4653),
    [sym_enum_declaration] = STATE(4653),
    [sym_anonymous_enum_declaration] = STATE(4653),
    [sym_function_declaration] = STATE(4653),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4653),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4653),
    [sym_template_mixin] = STATE(4653),
    [sym_conditional_declaration] = STATE(4653),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4653),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4653),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [342] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [343] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4682),
    [sym_mixin_declaration] = STATE(4682),
    [sym__declaration] = STATE(4682),
    [sym__declaration2] = STATE(4682),
    [sym_variable_declaration] = STATE(4682),
    [sym_manifest_constant] = STATE(4682),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4682),
    [sym_alias_declaration] = STATE(4682),
    [sym_alias_reassign] = STATE(4682),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4682),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4682),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4682),
    [sym_union_declaration] = STATE(4682),
    [sym_postblit] = STATE(4682),
    [sym_invariant_declaration] = STATE(4682),
    [sym_class_declaration] = STATE(4682),
    [sym_constructor] = STATE(4682),
    [sym_destructor] = STATE(4682),
    [sym_alias_this] = STATE(4682),
    [sym_interface_declaration] = STATE(4682),
    [sym_enum_declaration] = STATE(4682),
    [sym_anonymous_enum_declaration] = STATE(4682),
    [sym_function_declaration] = STATE(4682),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4682),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4682),
    [sym_template_mixin] = STATE(4682),
    [sym_conditional_declaration] = STATE(4682),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4682),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4682),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [344] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2026),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [345] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4649),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [346] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4643),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [347] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4636),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [348] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4634),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [349] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4695),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [350] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4625),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [351] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4623),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [352] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4621),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [353] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4619),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [354] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1941),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [355] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4618),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [356] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4617),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [357] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4628),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [358] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4614),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [359] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4613),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [360] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4612),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [361] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4611),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [362] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [363] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4646),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [364] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4652),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [365] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2046),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [366] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4653),
    [sym_mixin_declaration] = STATE(4653),
    [sym__declaration] = STATE(4653),
    [sym__declaration2] = STATE(4653),
    [sym_variable_declaration] = STATE(4653),
    [sym_manifest_constant] = STATE(4653),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4653),
    [sym_alias_declaration] = STATE(4653),
    [sym_alias_reassign] = STATE(4653),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4653),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4653),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4653),
    [sym_union_declaration] = STATE(4653),
    [sym_postblit] = STATE(4653),
    [sym_invariant_declaration] = STATE(4653),
    [sym_class_declaration] = STATE(4653),
    [sym_constructor] = STATE(4653),
    [sym_destructor] = STATE(4653),
    [sym_alias_this] = STATE(4653),
    [sym_interface_declaration] = STATE(4653),
    [sym_enum_declaration] = STATE(4653),
    [sym_anonymous_enum_declaration] = STATE(4653),
    [sym_function_declaration] = STATE(4653),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4653),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4653),
    [sym_template_mixin] = STATE(4653),
    [sym_conditional_declaration] = STATE(4653),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4653),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4653),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [367] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [368] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2074),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [369] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4682),
    [sym_mixin_declaration] = STATE(4682),
    [sym__declaration] = STATE(4682),
    [sym__declaration2] = STATE(4682),
    [sym_variable_declaration] = STATE(4682),
    [sym_manifest_constant] = STATE(4682),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4682),
    [sym_alias_declaration] = STATE(4682),
    [sym_alias_reassign] = STATE(4682),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4682),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4682),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4682),
    [sym_union_declaration] = STATE(4682),
    [sym_postblit] = STATE(4682),
    [sym_invariant_declaration] = STATE(4682),
    [sym_class_declaration] = STATE(4682),
    [sym_constructor] = STATE(4682),
    [sym_destructor] = STATE(4682),
    [sym_alias_this] = STATE(4682),
    [sym_interface_declaration] = STATE(4682),
    [sym_enum_declaration] = STATE(4682),
    [sym_anonymous_enum_declaration] = STATE(4682),
    [sym_function_declaration] = STATE(4682),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4682),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4682),
    [sym_template_mixin] = STATE(4682),
    [sym_conditional_declaration] = STATE(4682),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4682),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4682),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2039),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [370] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [371] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4690),
    [sym_mixin_declaration] = STATE(4690),
    [sym__declaration] = STATE(4690),
    [sym__declaration2] = STATE(4690),
    [sym_variable_declaration] = STATE(4690),
    [sym_manifest_constant] = STATE(4690),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4690),
    [sym_alias_declaration] = STATE(4690),
    [sym_alias_reassign] = STATE(4690),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4690),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4690),
    [sym_union_declaration] = STATE(4690),
    [sym_postblit] = STATE(4690),
    [sym_invariant_declaration] = STATE(4690),
    [sym_class_declaration] = STATE(4690),
    [sym_constructor] = STATE(4690),
    [sym_destructor] = STATE(4690),
    [sym_alias_this] = STATE(4690),
    [sym_interface_declaration] = STATE(4690),
    [sym_enum_declaration] = STATE(4690),
    [sym_anonymous_enum_declaration] = STATE(4690),
    [sym_function_declaration] = STATE(4690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4690),
    [sym_template_mixin] = STATE(4690),
    [sym_conditional_declaration] = STATE(4690),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4690),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4690),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [372] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [373] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2057),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [374] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1634),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [375] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1621),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [376] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1620),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [377] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1616),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [378] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1614),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [379] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4690),
    [sym_mixin_declaration] = STATE(4690),
    [sym__declaration] = STATE(4690),
    [sym__declaration2] = STATE(4690),
    [sym_variable_declaration] = STATE(4690),
    [sym_manifest_constant] = STATE(4690),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4690),
    [sym_alias_declaration] = STATE(4690),
    [sym_alias_reassign] = STATE(4690),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4690),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4690),
    [sym_union_declaration] = STATE(4690),
    [sym_postblit] = STATE(4690),
    [sym_invariant_declaration] = STATE(4690),
    [sym_class_declaration] = STATE(4690),
    [sym_constructor] = STATE(4690),
    [sym_destructor] = STATE(4690),
    [sym_alias_this] = STATE(4690),
    [sym_interface_declaration] = STATE(4690),
    [sym_enum_declaration] = STATE(4690),
    [sym_anonymous_enum_declaration] = STATE(4690),
    [sym_function_declaration] = STATE(4690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4690),
    [sym_template_mixin] = STATE(4690),
    [sym_conditional_declaration] = STATE(4690),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4690),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4690),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [380] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1611),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [381] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2056),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [382] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1985),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [383] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1968),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [384] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2072),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [385] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1273),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [386] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1962),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [387] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2063),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [388] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2067),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [389] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1993),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [390] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(6374),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3371),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [391] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2043),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [392] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4690),
    [sym_mixin_declaration] = STATE(4690),
    [sym__declaration] = STATE(4690),
    [sym__declaration2] = STATE(4690),
    [sym_variable_declaration] = STATE(4690),
    [sym_manifest_constant] = STATE(4690),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4690),
    [sym_alias_declaration] = STATE(4690),
    [sym_alias_reassign] = STATE(4690),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4690),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4690),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4690),
    [sym_union_declaration] = STATE(4690),
    [sym_postblit] = STATE(4690),
    [sym_invariant_declaration] = STATE(4690),
    [sym_class_declaration] = STATE(4690),
    [sym_constructor] = STATE(4690),
    [sym_destructor] = STATE(4690),
    [sym_alias_this] = STATE(4690),
    [sym_interface_declaration] = STATE(4690),
    [sym_enum_declaration] = STATE(4690),
    [sym_anonymous_enum_declaration] = STATE(4690),
    [sym_function_declaration] = STATE(4690),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4690),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4690),
    [sym_template_mixin] = STATE(4690),
    [sym_conditional_declaration] = STATE(4690),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4690),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4690),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2041),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2011),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [393] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4685),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [394] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1387),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [395] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1981),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [396] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1993),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [397] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4551),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [398] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4682),
    [sym_mixin_declaration] = STATE(4682),
    [sym__declaration] = STATE(4682),
    [sym__declaration2] = STATE(4682),
    [sym_variable_declaration] = STATE(4682),
    [sym_manifest_constant] = STATE(4682),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4682),
    [sym_alias_declaration] = STATE(4682),
    [sym_alias_reassign] = STATE(4682),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4682),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4682),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4682),
    [sym_union_declaration] = STATE(4682),
    [sym_postblit] = STATE(4682),
    [sym_invariant_declaration] = STATE(4682),
    [sym_class_declaration] = STATE(4682),
    [sym_constructor] = STATE(4682),
    [sym_destructor] = STATE(4682),
    [sym_alias_this] = STATE(4682),
    [sym_interface_declaration] = STATE(4682),
    [sym_enum_declaration] = STATE(4682),
    [sym_anonymous_enum_declaration] = STATE(4682),
    [sym_function_declaration] = STATE(4682),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4682),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4682),
    [sym_template_mixin] = STATE(4682),
    [sym_conditional_declaration] = STATE(4682),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4682),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4682),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2039),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2007),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [399] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4665),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [400] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2067),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [401] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2063),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [402] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1962),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [403] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2072),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [404] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1968),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [405] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1985),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [406] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2056),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [407] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2057),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [408] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2074),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [409] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2046),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [410] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2026),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [411] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2118),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [412] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2095),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [413] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4653),
    [sym_mixin_declaration] = STATE(4653),
    [sym__declaration] = STATE(4653),
    [sym__declaration2] = STATE(4653),
    [sym_variable_declaration] = STATE(4653),
    [sym_manifest_constant] = STATE(4653),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4653),
    [sym_alias_declaration] = STATE(4653),
    [sym_alias_reassign] = STATE(4653),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4653),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4653),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4653),
    [sym_union_declaration] = STATE(4653),
    [sym_postblit] = STATE(4653),
    [sym_invariant_declaration] = STATE(4653),
    [sym_class_declaration] = STATE(4653),
    [sym_constructor] = STATE(4653),
    [sym_destructor] = STATE(4653),
    [sym_alias_this] = STATE(4653),
    [sym_interface_declaration] = STATE(4653),
    [sym_enum_declaration] = STATE(4653),
    [sym_anonymous_enum_declaration] = STATE(4653),
    [sym_function_declaration] = STATE(4653),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4653),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4653),
    [sym_template_mixin] = STATE(4653),
    [sym_conditional_declaration] = STATE(4653),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4653),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4653),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2037),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [414] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1409),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [415] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4652),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [416] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2094),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [417] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4646),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [418] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1949),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [419] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2088),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [420] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [421] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2085),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [422] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2084),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [423] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2083),
    [sym_mixin_declaration] = STATE(2083),
    [sym__declaration] = STATE(2083),
    [sym__declaration2] = STATE(2083),
    [sym_variable_declaration] = STATE(2083),
    [sym_manifest_constant] = STATE(2083),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2083),
    [sym_alias_declaration] = STATE(2083),
    [sym_alias_reassign] = STATE(2083),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2083),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2083),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2086),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2083),
    [sym_union_declaration] = STATE(2083),
    [sym_postblit] = STATE(2083),
    [sym_invariant_declaration] = STATE(2083),
    [sym_class_declaration] = STATE(2083),
    [sym_constructor] = STATE(2083),
    [sym_destructor] = STATE(2083),
    [sym_alias_this] = STATE(2083),
    [sym_interface_declaration] = STATE(2083),
    [sym_enum_declaration] = STATE(2083),
    [sym_anonymous_enum_declaration] = STATE(2083),
    [sym_function_declaration] = STATE(2083),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2083),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2083),
    [sym_template_mixin] = STATE(2083),
    [sym_conditional_declaration] = STATE(2083),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2083),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2083),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1844),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1846),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [424] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [425] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4642),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [426] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2081),
    [sym_mixin_declaration] = STATE(2081),
    [sym__declaration] = STATE(2081),
    [sym__declaration2] = STATE(2081),
    [sym_variable_declaration] = STATE(2081),
    [sym_manifest_constant] = STATE(2081),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2081),
    [sym_alias_declaration] = STATE(2081),
    [sym_alias_reassign] = STATE(2081),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2081),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2081),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2082),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2081),
    [sym_union_declaration] = STATE(2081),
    [sym_postblit] = STATE(2081),
    [sym_invariant_declaration] = STATE(2081),
    [sym_class_declaration] = STATE(2081),
    [sym_constructor] = STATE(2081),
    [sym_destructor] = STATE(2081),
    [sym_alias_this] = STATE(2081),
    [sym_interface_declaration] = STATE(2081),
    [sym_enum_declaration] = STATE(2081),
    [sym_anonymous_enum_declaration] = STATE(2081),
    [sym_function_declaration] = STATE(2081),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2081),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2081),
    [sym_template_mixin] = STATE(2081),
    [sym_conditional_declaration] = STATE(2081),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2081),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2081),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1979),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [427] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [428] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2065),
    [sym_mixin_declaration] = STATE(2065),
    [sym__declaration] = STATE(2065),
    [sym__declaration2] = STATE(2065),
    [sym_variable_declaration] = STATE(2065),
    [sym_manifest_constant] = STATE(2065),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2065),
    [sym_alias_declaration] = STATE(2065),
    [sym_alias_reassign] = STATE(2065),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2065),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2065),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2080),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2065),
    [sym_union_declaration] = STATE(2065),
    [sym_postblit] = STATE(2065),
    [sym_invariant_declaration] = STATE(2065),
    [sym_class_declaration] = STATE(2065),
    [sym_constructor] = STATE(2065),
    [sym_destructor] = STATE(2065),
    [sym_alias_this] = STATE(2065),
    [sym_interface_declaration] = STATE(2065),
    [sym_enum_declaration] = STATE(2065),
    [sym_anonymous_enum_declaration] = STATE(2065),
    [sym_function_declaration] = STATE(2065),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2065),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2065),
    [sym_template_mixin] = STATE(2065),
    [sym_conditional_declaration] = STATE(2065),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2065),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2065),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1983),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [429] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4611),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [430] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4612),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [431] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4613),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [432] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1442),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [433] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4614),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [434] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4628),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [435] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2057),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [436] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4617),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [437] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4618),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [438] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4619),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [439] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2043),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [440] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4621),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [441] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4623),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [442] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4416),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [443] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1484),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [444] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1343),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [445] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1442),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [446] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4625),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [447] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4624),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [448] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1465),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [449] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4695),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [450] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1449),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [451] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4634),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [452] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1352),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [453] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1435),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [454] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1360),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [455] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1361),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [456] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1362),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [457] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1375),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [458] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1395),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [459] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1270),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [460] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1398),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [461] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1399),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [462] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1400),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [463] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4661),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [464] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1407),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [465] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1410),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [466] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1411),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [467] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1413),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [468] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1414),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [469] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1416),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [470] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1417),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [471] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1526),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [472] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4636),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [473] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1418),
    [sym_mixin_declaration] = STATE(1418),
    [sym__declaration] = STATE(1418),
    [sym__declaration2] = STATE(1418),
    [sym_variable_declaration] = STATE(1418),
    [sym_manifest_constant] = STATE(1418),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1418),
    [sym_alias_declaration] = STATE(1418),
    [sym_alias_reassign] = STATE(1418),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1418),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1418),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1414),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1418),
    [sym_union_declaration] = STATE(1418),
    [sym_postblit] = STATE(1418),
    [sym_invariant_declaration] = STATE(1418),
    [sym_class_declaration] = STATE(1418),
    [sym_constructor] = STATE(1418),
    [sym_destructor] = STATE(1418),
    [sym_alias_this] = STATE(1418),
    [sym_interface_declaration] = STATE(1418),
    [sym_enum_declaration] = STATE(1418),
    [sym_anonymous_enum_declaration] = STATE(1418),
    [sym_function_declaration] = STATE(1418),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1418),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1418),
    [sym_template_mixin] = STATE(1418),
    [sym_conditional_declaration] = STATE(1418),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1418),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1418),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1987),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [474] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1419),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [475] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1424),
    [sym_mixin_declaration] = STATE(1424),
    [sym__declaration] = STATE(1424),
    [sym__declaration2] = STATE(1424),
    [sym_variable_declaration] = STATE(1424),
    [sym_manifest_constant] = STATE(1424),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1424),
    [sym_alias_declaration] = STATE(1424),
    [sym_alias_reassign] = STATE(1424),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1424),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1424),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1419),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1424),
    [sym_union_declaration] = STATE(1424),
    [sym_postblit] = STATE(1424),
    [sym_invariant_declaration] = STATE(1424),
    [sym_class_declaration] = STATE(1424),
    [sym_constructor] = STATE(1424),
    [sym_destructor] = STATE(1424),
    [sym_alias_this] = STATE(1424),
    [sym_interface_declaration] = STATE(1424),
    [sym_enum_declaration] = STATE(1424),
    [sym_anonymous_enum_declaration] = STATE(1424),
    [sym_function_declaration] = STATE(1424),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1424),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1424),
    [sym_template_mixin] = STATE(1424),
    [sym_conditional_declaration] = STATE(1424),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1424),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1424),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [476] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2043),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [477] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1494),
    [sym_mixin_declaration] = STATE(1494),
    [sym__declaration] = STATE(1494),
    [sym__declaration2] = STATE(1494),
    [sym_variable_declaration] = STATE(1494),
    [sym_manifest_constant] = STATE(1494),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1494),
    [sym_alias_declaration] = STATE(1494),
    [sym_alias_reassign] = STATE(1494),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1494),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1494),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1425),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1494),
    [sym_union_declaration] = STATE(1494),
    [sym_postblit] = STATE(1494),
    [sym_invariant_declaration] = STATE(1494),
    [sym_class_declaration] = STATE(1494),
    [sym_constructor] = STATE(1494),
    [sym_destructor] = STATE(1494),
    [sym_alias_this] = STATE(1494),
    [sym_interface_declaration] = STATE(1494),
    [sym_enum_declaration] = STATE(1494),
    [sym_anonymous_enum_declaration] = STATE(1494),
    [sym_function_declaration] = STATE(1494),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1494),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1494),
    [sym_template_mixin] = STATE(1494),
    [sym_conditional_declaration] = STATE(1494),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1494),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1494),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(305),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(946),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [478] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1607),
    [sym_mixin_declaration] = STATE(1607),
    [sym__declaration] = STATE(1607),
    [sym__declaration2] = STATE(1607),
    [sym_variable_declaration] = STATE(1607),
    [sym_manifest_constant] = STATE(1607),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1607),
    [sym_alias_declaration] = STATE(1607),
    [sym_alias_reassign] = STATE(1607),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1607),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1607),
    [sym_pragma_statement] = STATE(1607),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1607),
    [sym__declaration_or_statement] = STATE(1607),
    [sym_scope_statement] = STATE(1518),
    [sym__statement_no_case_no_default] = STATE(1607),
    [sym_labeled_statement] = STATE(1607),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1607),
    [sym_if_statement] = STATE(1607),
    [sym_while_statement] = STATE(1607),
    [sym_do_statement] = STATE(1607),
    [sym_for_statement] = STATE(1607),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1607),
    [sym_switch_statement] = STATE(1607),
    [sym_case_statement] = STATE(1607),
    [sym_final_switch_statement] = STATE(1607),
    [sym_continue_statement] = STATE(1607),
    [sym_break_statement] = STATE(1607),
    [sym_return_statement] = STATE(1607),
    [sym_goto_statement] = STATE(1607),
    [sym_with_statement] = STATE(1607),
    [sym_synchronized_statement] = STATE(1607),
    [sym_try_statement] = STATE(1607),
    [sym_scope_guard_statement] = STATE(1607),
    [sym_asm_statement] = STATE(1607),
    [sym_struct_declaration] = STATE(1607),
    [sym_union_declaration] = STATE(1607),
    [sym_postblit] = STATE(1607),
    [sym_invariant_declaration] = STATE(1607),
    [sym_class_declaration] = STATE(1607),
    [sym_constructor] = STATE(1607),
    [sym_destructor] = STATE(1607),
    [sym_alias_this] = STATE(1607),
    [sym_interface_declaration] = STATE(1607),
    [sym_enum_declaration] = STATE(1607),
    [sym_anonymous_enum_declaration] = STATE(1607),
    [sym_function_declaration] = STATE(1607),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1607),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1607),
    [sym_template_mixin] = STATE(1607),
    [sym_conditional_declaration] = STATE(1607),
    [sym_conditional_statement] = STATE(1607),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1607),
    [sym_static_foreach_declaration] = STATE(1607),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1607),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [479] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1429),
    [sym_mixin_declaration] = STATE(1429),
    [sym__declaration] = STATE(1429),
    [sym__declaration2] = STATE(1429),
    [sym_variable_declaration] = STATE(1429),
    [sym_manifest_constant] = STATE(1429),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1429),
    [sym_alias_declaration] = STATE(1429),
    [sym_alias_reassign] = STATE(1429),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1429),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1429),
    [sym_pragma_statement] = STATE(1494),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1494),
    [sym__declaration_or_statement] = STATE(1494),
    [sym_scope_statement] = STATE(1425),
    [sym__statement_no_case_no_default] = STATE(1494),
    [sym_labeled_statement] = STATE(1494),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1494),
    [sym_if_statement] = STATE(1494),
    [sym_while_statement] = STATE(1494),
    [sym_do_statement] = STATE(1494),
    [sym_for_statement] = STATE(1494),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1494),
    [sym_switch_statement] = STATE(1494),
    [sym_case_statement] = STATE(1494),
    [sym_final_switch_statement] = STATE(1494),
    [sym_continue_statement] = STATE(1494),
    [sym_break_statement] = STATE(1494),
    [sym_return_statement] = STATE(1494),
    [sym_goto_statement] = STATE(1494),
    [sym_with_statement] = STATE(1494),
    [sym_synchronized_statement] = STATE(1494),
    [sym_try_statement] = STATE(1494),
    [sym_scope_guard_statement] = STATE(1494),
    [sym_asm_statement] = STATE(1494),
    [sym_struct_declaration] = STATE(1429),
    [sym_union_declaration] = STATE(1429),
    [sym_postblit] = STATE(1429),
    [sym_invariant_declaration] = STATE(1429),
    [sym_class_declaration] = STATE(1429),
    [sym_constructor] = STATE(1429),
    [sym_destructor] = STATE(1429),
    [sym_alias_this] = STATE(1429),
    [sym_interface_declaration] = STATE(1429),
    [sym_enum_declaration] = STATE(1429),
    [sym_anonymous_enum_declaration] = STATE(1429),
    [sym_function_declaration] = STATE(1429),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1429),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1429),
    [sym_template_mixin] = STATE(1429),
    [sym_conditional_declaration] = STATE(1429),
    [sym_conditional_statement] = STATE(1494),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1494),
    [sym_static_foreach_declaration] = STATE(1429),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1429),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(1999),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [480] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4418),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [481] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4643),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [482] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4710),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [483] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2127),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [484] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2051),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [485] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(2027),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [486] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2024),
    [sym_mixin_declaration] = STATE(2024),
    [sym__declaration] = STATE(2024),
    [sym__declaration2] = STATE(2024),
    [sym_variable_declaration] = STATE(2024),
    [sym_manifest_constant] = STATE(2024),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2024),
    [sym_alias_declaration] = STATE(2024),
    [sym_alias_reassign] = STATE(2024),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2024),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2024),
    [sym_pragma_statement] = STATE(2024),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2024),
    [sym__declaration_or_statement] = STATE(2024),
    [sym_scope_statement] = STATE(1944),
    [sym__statement_no_case_no_default] = STATE(2024),
    [sym_labeled_statement] = STATE(2024),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2024),
    [sym_if_statement] = STATE(2024),
    [sym_while_statement] = STATE(2024),
    [sym_do_statement] = STATE(2024),
    [sym_for_statement] = STATE(2024),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2024),
    [sym_switch_statement] = STATE(2024),
    [sym_case_statement] = STATE(2024),
    [sym_final_switch_statement] = STATE(2024),
    [sym_continue_statement] = STATE(2024),
    [sym_break_statement] = STATE(2024),
    [sym_return_statement] = STATE(2024),
    [sym_goto_statement] = STATE(2024),
    [sym_with_statement] = STATE(2024),
    [sym_synchronized_statement] = STATE(2024),
    [sym_try_statement] = STATE(2024),
    [sym_scope_guard_statement] = STATE(2024),
    [sym_asm_statement] = STATE(2024),
    [sym_struct_declaration] = STATE(2024),
    [sym_union_declaration] = STATE(2024),
    [sym_postblit] = STATE(2024),
    [sym_invariant_declaration] = STATE(2024),
    [sym_class_declaration] = STATE(2024),
    [sym_constructor] = STATE(2024),
    [sym_destructor] = STATE(2024),
    [sym_alias_this] = STATE(2024),
    [sym_interface_declaration] = STATE(2024),
    [sym_enum_declaration] = STATE(2024),
    [sym_anonymous_enum_declaration] = STATE(2024),
    [sym_function_declaration] = STATE(2024),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2024),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2024),
    [sym_template_mixin] = STATE(2024),
    [sym_conditional_declaration] = STATE(2024),
    [sym_conditional_statement] = STATE(2024),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2024),
    [sym_static_foreach_declaration] = STATE(2024),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2024),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(667),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [487] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4649),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [488] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(4707),
    [sym_mixin_declaration] = STATE(4707),
    [sym__declaration] = STATE(4707),
    [sym__declaration2] = STATE(4707),
    [sym_variable_declaration] = STATE(4707),
    [sym_manifest_constant] = STATE(4707),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4707),
    [sym_alias_declaration] = STATE(4707),
    [sym_alias_reassign] = STATE(4707),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(4707),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4707),
    [sym_pragma_statement] = STATE(4707),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4707),
    [sym__declaration_or_statement] = STATE(4707),
    [sym_scope_statement] = STATE(4663),
    [sym__statement_no_case_no_default] = STATE(4707),
    [sym_labeled_statement] = STATE(4707),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4707),
    [sym_if_statement] = STATE(4707),
    [sym_while_statement] = STATE(4707),
    [sym_do_statement] = STATE(4707),
    [sym_for_statement] = STATE(4707),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4707),
    [sym_switch_statement] = STATE(4707),
    [sym_case_statement] = STATE(4707),
    [sym_final_switch_statement] = STATE(4707),
    [sym_continue_statement] = STATE(4707),
    [sym_break_statement] = STATE(4707),
    [sym_return_statement] = STATE(4707),
    [sym_goto_statement] = STATE(4707),
    [sym_with_statement] = STATE(4707),
    [sym_synchronized_statement] = STATE(4707),
    [sym_try_statement] = STATE(4707),
    [sym_scope_guard_statement] = STATE(4707),
    [sym_asm_statement] = STATE(4707),
    [sym_struct_declaration] = STATE(4707),
    [sym_union_declaration] = STATE(4707),
    [sym_postblit] = STATE(4707),
    [sym_invariant_declaration] = STATE(4707),
    [sym_class_declaration] = STATE(4707),
    [sym_constructor] = STATE(4707),
    [sym_destructor] = STATE(4707),
    [sym_alias_this] = STATE(4707),
    [sym_interface_declaration] = STATE(4707),
    [sym_enum_declaration] = STATE(4707),
    [sym_anonymous_enum_declaration] = STATE(4707),
    [sym_function_declaration] = STATE(4707),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(4707),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(4707),
    [sym_template_mixin] = STATE(4707),
    [sym_conditional_declaration] = STATE(4707),
    [sym_conditional_statement] = STATE(4707),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4707),
    [sym_static_foreach_declaration] = STATE(4707),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(4707),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(822),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [489] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2319),
    [sym_mixin_declaration] = STATE(2319),
    [sym__declaration] = STATE(2319),
    [sym__declaration2] = STATE(2319),
    [sym_variable_declaration] = STATE(2319),
    [sym_manifest_constant] = STATE(2319),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2319),
    [sym_alias_declaration] = STATE(2319),
    [sym_alias_reassign] = STATE(2319),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2319),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2319),
    [sym_pragma_statement] = STATE(4678),
    [sym_pragma_expression] = STATE(489),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4678),
    [sym__statement_no_case_no_default] = STATE(4678),
    [sym_labeled_statement] = STATE(4678),
    [sym_label] = STATE(209),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4678),
    [sym_if_statement] = STATE(4678),
    [sym_while_statement] = STATE(4678),
    [sym_do_statement] = STATE(4678),
    [sym_for_statement] = STATE(4678),
    [sym__foreach] = STATE(6539),
    [sym_foreach_statement] = STATE(4678),
    [sym_switch_statement] = STATE(4678),
    [sym_case_statement] = STATE(4678),
    [sym_final_switch_statement] = STATE(4678),
    [sym_continue_statement] = STATE(4678),
    [sym_break_statement] = STATE(4678),
    [sym_return_statement] = STATE(4678),
    [sym_goto_statement] = STATE(4678),
    [sym_with_statement] = STATE(4678),
    [sym_synchronized_statement] = STATE(4678),
    [sym_try_statement] = STATE(4678),
    [sym_scope_guard_statement] = STATE(4678),
    [sym_asm_statement] = STATE(4678),
    [sym_struct_declaration] = STATE(2319),
    [sym_union_declaration] = STATE(2319),
    [sym_postblit] = STATE(2319),
    [sym_invariant_declaration] = STATE(2319),
    [sym_class_declaration] = STATE(2319),
    [sym_constructor] = STATE(2319),
    [sym_destructor] = STATE(2319),
    [sym_alias_this] = STATE(2319),
    [sym_interface_declaration] = STATE(2319),
    [sym_enum_declaration] = STATE(2319),
    [sym_anonymous_enum_declaration] = STATE(2319),
    [sym_function_declaration] = STATE(2319),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2319),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2319),
    [sym_template_mixin] = STATE(2319),
    [sym_conditional_declaration] = STATE(2319),
    [sym_conditional_statement] = STATE(4678),
    [sym_condition] = STATE(92),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4678),
    [sym_static_foreach_declaration] = STATE(2319),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2319),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1969),
    [sym_for] = ACTIONS(1750),
    [sym_foreach] = ACTIONS(1752),
    [sym_foreach_reverse] = ACTIONS(1752),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1754),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1971),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1973),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(1975),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1770),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1772),
    [sym_with] = ACTIONS(1774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [490] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1434),
    [sym_mixin_declaration] = STATE(1434),
    [sym__declaration] = STATE(1434),
    [sym__declaration2] = STATE(1434),
    [sym_variable_declaration] = STATE(1434),
    [sym_manifest_constant] = STATE(1434),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1434),
    [sym_alias_declaration] = STATE(1434),
    [sym_alias_reassign] = STATE(1434),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1434),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1434),
    [sym_pragma_statement] = STATE(1503),
    [sym_pragma_expression] = STATE(490),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1503),
    [sym__statement_no_case_no_default] = STATE(1503),
    [sym_labeled_statement] = STATE(1503),
    [sym_label] = STATE(432),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1503),
    [sym_if_statement] = STATE(1503),
    [sym_while_statement] = STATE(1503),
    [sym_do_statement] = STATE(1503),
    [sym_for_statement] = STATE(1503),
    [sym__foreach] = STATE(6543),
    [sym_foreach_statement] = STATE(1503),
    [sym_switch_statement] = STATE(1503),
    [sym_case_statement] = STATE(1503),
    [sym_final_switch_statement] = STATE(1503),
    [sym_continue_statement] = STATE(1503),
    [sym_break_statement] = STATE(1503),
    [sym_return_statement] = STATE(1503),
    [sym_goto_statement] = STATE(1503),
    [sym_with_statement] = STATE(1503),
    [sym_synchronized_statement] = STATE(1503),
    [sym_try_statement] = STATE(1503),
    [sym_scope_guard_statement] = STATE(1503),
    [sym_asm_statement] = STATE(1503),
    [sym_struct_declaration] = STATE(1434),
    [sym_union_declaration] = STATE(1434),
    [sym_postblit] = STATE(1434),
    [sym_invariant_declaration] = STATE(1434),
    [sym_class_declaration] = STATE(1434),
    [sym_constructor] = STATE(1434),
    [sym_destructor] = STATE(1434),
    [sym_alias_this] = STATE(1434),
    [sym_interface_declaration] = STATE(1434),
    [sym_enum_declaration] = STATE(1434),
    [sym_anonymous_enum_declaration] = STATE(1434),
    [sym_function_declaration] = STATE(1434),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1434),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1434),
    [sym_template_mixin] = STATE(1434),
    [sym_conditional_declaration] = STATE(1434),
    [sym_conditional_statement] = STATE(1503),
    [sym_condition] = STATE(59),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1503),
    [sym_static_foreach_declaration] = STATE(1434),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1434),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(333),
    [sym_for] = ACTIONS(335),
    [sym_foreach] = ACTIONS(337),
    [sym_foreach_reverse] = ACTIONS(337),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(341),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(353),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(357),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(363),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(367),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(375),
    [sym_with] = ACTIONS(377),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [491] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(499),
    [sym_mixin_declaration] = STATE(499),
    [sym__declaration] = STATE(499),
    [sym__declaration2] = STATE(499),
    [sym_variable_declaration] = STATE(499),
    [sym_manifest_constant] = STATE(499),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(499),
    [sym_alias_declaration] = STATE(499),
    [sym_alias_reassign] = STATE(499),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(499),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(499),
    [sym_pragma_statement] = STATE(499),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(499),
    [sym_labeled_statement] = STATE(499),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_do_statement] = STATE(499),
    [sym_for_statement] = STATE(499),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(499),
    [sym_switch_statement] = STATE(499),
    [sym_final_switch_statement] = STATE(499),
    [sym_continue_statement] = STATE(499),
    [sym_break_statement] = STATE(499),
    [sym_return_statement] = STATE(499),
    [sym_goto_statement] = STATE(499),
    [sym_with_statement] = STATE(499),
    [sym_synchronized_statement] = STATE(499),
    [sym_try_statement] = STATE(499),
    [sym_scope_guard_statement] = STATE(499),
    [sym_asm_statement] = STATE(499),
    [sym_struct_declaration] = STATE(499),
    [sym_union_declaration] = STATE(499),
    [sym_postblit] = STATE(499),
    [sym_invariant_declaration] = STATE(499),
    [sym_class_declaration] = STATE(499),
    [sym_constructor] = STATE(499),
    [sym_destructor] = STATE(499),
    [sym_alias_this] = STATE(499),
    [sym_interface_declaration] = STATE(499),
    [sym_enum_declaration] = STATE(499),
    [sym_anonymous_enum_declaration] = STATE(499),
    [sym_function_declaration] = STATE(499),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(499),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(499),
    [sym_template_mixin] = STATE(499),
    [sym_conditional_declaration] = STATE(499),
    [sym_conditional_statement] = STATE(499),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(499),
    [sym_static_foreach_declaration] = STATE(499),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(499),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(499),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(653),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(655),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(655),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [492] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2044),
    [sym_mixin_declaration] = STATE(2044),
    [sym__declaration] = STATE(2044),
    [sym__declaration2] = STATE(2044),
    [sym_variable_declaration] = STATE(2044),
    [sym_manifest_constant] = STATE(2044),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2044),
    [sym_alias_declaration] = STATE(2044),
    [sym_alias_reassign] = STATE(2044),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2044),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2044),
    [sym_pragma_statement] = STATE(2037),
    [sym_pragma_expression] = STATE(492),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2037),
    [sym__statement_no_case_no_default] = STATE(2037),
    [sym_labeled_statement] = STATE(2037),
    [sym_label] = STATE(226),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2037),
    [sym_if_statement] = STATE(2037),
    [sym_while_statement] = STATE(2037),
    [sym_do_statement] = STATE(2037),
    [sym_for_statement] = STATE(2037),
    [sym__foreach] = STATE(6547),
    [sym_foreach_statement] = STATE(2037),
    [sym_switch_statement] = STATE(2037),
    [sym_case_statement] = STATE(2037),
    [sym_final_switch_statement] = STATE(2037),
    [sym_continue_statement] = STATE(2037),
    [sym_break_statement] = STATE(2037),
    [sym_return_statement] = STATE(2037),
    [sym_goto_statement] = STATE(2037),
    [sym_with_statement] = STATE(2037),
    [sym_synchronized_statement] = STATE(2037),
    [sym_try_statement] = STATE(2037),
    [sym_scope_guard_statement] = STATE(2037),
    [sym_asm_statement] = STATE(2037),
    [sym_struct_declaration] = STATE(2044),
    [sym_union_declaration] = STATE(2044),
    [sym_postblit] = STATE(2044),
    [sym_invariant_declaration] = STATE(2044),
    [sym_class_declaration] = STATE(2044),
    [sym_constructor] = STATE(2044),
    [sym_destructor] = STATE(2044),
    [sym_alias_this] = STATE(2044),
    [sym_interface_declaration] = STATE(2044),
    [sym_enum_declaration] = STATE(2044),
    [sym_anonymous_enum_declaration] = STATE(2044),
    [sym_function_declaration] = STATE(2044),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2044),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2044),
    [sym_template_mixin] = STATE(2044),
    [sym_conditional_declaration] = STATE(2044),
    [sym_conditional_statement] = STATE(2037),
    [sym_condition] = STATE(67),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2037),
    [sym_static_foreach_declaration] = STATE(2044),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2044),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2015),
    [sym_for] = ACTIONS(1308),
    [sym_foreach] = ACTIONS(1310),
    [sym_foreach_reverse] = ACTIONS(1310),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1312),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2017),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2019),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(2021),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1328),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1330),
    [sym_with] = ACTIONS(1332),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [493] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1576),
    [sym_mixin_declaration] = STATE(1576),
    [sym__declaration] = STATE(1576),
    [sym__declaration2] = STATE(1576),
    [sym_variable_declaration] = STATE(1576),
    [sym_manifest_constant] = STATE(1576),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1576),
    [sym_alias_declaration] = STATE(1576),
    [sym_alias_reassign] = STATE(1576),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1576),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1576),
    [sym_pragma_statement] = STATE(1552),
    [sym_pragma_expression] = STATE(493),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1552),
    [sym__statement_no_case_no_default] = STATE(1552),
    [sym_labeled_statement] = STATE(1552),
    [sym_label] = STATE(188),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_do_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym__foreach] = STATE(6537),
    [sym_foreach_statement] = STATE(1552),
    [sym_switch_statement] = STATE(1552),
    [sym_case_statement] = STATE(1552),
    [sym_final_switch_statement] = STATE(1552),
    [sym_continue_statement] = STATE(1552),
    [sym_break_statement] = STATE(1552),
    [sym_return_statement] = STATE(1552),
    [sym_goto_statement] = STATE(1552),
    [sym_with_statement] = STATE(1552),
    [sym_synchronized_statement] = STATE(1552),
    [sym_try_statement] = STATE(1552),
    [sym_scope_guard_statement] = STATE(1552),
    [sym_asm_statement] = STATE(1552),
    [sym_struct_declaration] = STATE(1576),
    [sym_union_declaration] = STATE(1576),
    [sym_postblit] = STATE(1576),
    [sym_invariant_declaration] = STATE(1576),
    [sym_class_declaration] = STATE(1576),
    [sym_constructor] = STATE(1576),
    [sym_destructor] = STATE(1576),
    [sym_alias_this] = STATE(1576),
    [sym_interface_declaration] = STATE(1576),
    [sym_enum_declaration] = STATE(1576),
    [sym_anonymous_enum_declaration] = STATE(1576),
    [sym_function_declaration] = STATE(1576),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1576),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1576),
    [sym_template_mixin] = STATE(1576),
    [sym_conditional_declaration] = STATE(1576),
    [sym_conditional_statement] = STATE(1552),
    [sym_condition] = STATE(111),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1552),
    [sym_static_foreach_declaration] = STATE(1576),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1576),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1404),
    [sym_for] = ACTIONS(1360),
    [sym_foreach] = ACTIONS(1362),
    [sym_foreach_reverse] = ACTIONS(1362),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(1364),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(1406),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(1408),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(1410),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1388),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(1390),
    [sym_with] = ACTIONS(1392),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [494] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1434),
    [sym_mixin_declaration] = STATE(1434),
    [sym__declaration] = STATE(1434),
    [sym__declaration2] = STATE(1434),
    [sym_variable_declaration] = STATE(1434),
    [sym_manifest_constant] = STATE(1434),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1434),
    [sym_alias_declaration] = STATE(1434),
    [sym_alias_reassign] = STATE(1434),
    [sym_type] = STATE(4489),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1434),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1434),
    [sym_pragma_statement] = STATE(1503),
    [sym_pragma_expression] = STATE(494),
    [sym_expression_list] = STATE(6242),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3192),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1503),
    [sym__statement_no_case_no_default] = STATE(1503),
    [sym_labeled_statement] = STATE(1503),
    [sym_label] = STATE(445),
    [sym_block_statement] = STATE(653),
    [sym_expression_statement] = STATE(1503),
    [sym_if_statement] = STATE(1503),
    [sym_while_statement] = STATE(1503),
    [sym_do_statement] = STATE(1503),
    [sym_for_statement] = STATE(1503),
    [sym__foreach] = STATE(6531),
    [sym_foreach_statement] = STATE(1503),
    [sym_switch_statement] = STATE(1503),
    [sym_case_statement] = STATE(1503),
    [sym_final_switch_statement] = STATE(1503),
    [sym_continue_statement] = STATE(1503),
    [sym_break_statement] = STATE(1503),
    [sym_return_statement] = STATE(1503),
    [sym_goto_statement] = STATE(1503),
    [sym_with_statement] = STATE(1503),
    [sym_synchronized_statement] = STATE(1503),
    [sym_try_statement] = STATE(1503),
    [sym_scope_guard_statement] = STATE(1503),
    [sym_asm_statement] = STATE(1503),
    [sym_struct_declaration] = STATE(1434),
    [sym_union_declaration] = STATE(1434),
    [sym_postblit] = STATE(1434),
    [sym_invariant_declaration] = STATE(1434),
    [sym_class_declaration] = STATE(1434),
    [sym_constructor] = STATE(1434),
    [sym_destructor] = STATE(1434),
    [sym_alias_this] = STATE(1434),
    [sym_interface_declaration] = STATE(1434),
    [sym_enum_declaration] = STATE(1434),
    [sym_anonymous_enum_declaration] = STATE(1434),
    [sym_function_declaration] = STATE(1434),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1434),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1434),
    [sym_template_mixin] = STATE(1434),
    [sym_conditional_declaration] = STATE(1434),
    [sym_conditional_statement] = STATE(1503),
    [sym_condition] = STATE(76),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1460),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1460),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1503),
    [sym_static_foreach_declaration] = STATE(1434),
    [sym_static_assert] = STATE(1460),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1434),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(301),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2055),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2057),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(309),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(311),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(315),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(317),
    [sym_case] = ACTIONS(1260),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(323),
    [sym_debug] = ACTIONS(325),
    [sym_default] = ACTIONS(1262),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(327),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(784),
    [sym_for] = ACTIONS(786),
    [sym_foreach] = ACTIONS(788),
    [sym_foreach_reverse] = ACTIONS(788),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(339),
    [sym_if] = ACTIONS(790),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(343),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(349),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(351),
    [sym_scope] = ACTIONS(792),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(794),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(798),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(800),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(373),
    [sym_while] = ACTIONS(802),
    [sym_with] = ACTIONS(804),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [495] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(501),
    [sym_mixin_declaration] = STATE(501),
    [sym__declaration] = STATE(501),
    [sym__declaration2] = STATE(501),
    [sym_variable_declaration] = STATE(501),
    [sym_manifest_constant] = STATE(501),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(501),
    [sym_alias_declaration] = STATE(501),
    [sym_alias_reassign] = STATE(501),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(501),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(501),
    [sym_pragma_statement] = STATE(501),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(501),
    [sym_labeled_statement] = STATE(501),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(501),
    [sym_if_statement] = STATE(501),
    [sym_while_statement] = STATE(501),
    [sym_do_statement] = STATE(501),
    [sym_for_statement] = STATE(501),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(501),
    [sym_switch_statement] = STATE(501),
    [sym_final_switch_statement] = STATE(501),
    [sym_continue_statement] = STATE(501),
    [sym_break_statement] = STATE(501),
    [sym_return_statement] = STATE(501),
    [sym_goto_statement] = STATE(501),
    [sym_with_statement] = STATE(501),
    [sym_synchronized_statement] = STATE(501),
    [sym_try_statement] = STATE(501),
    [sym_scope_guard_statement] = STATE(501),
    [sym_asm_statement] = STATE(501),
    [sym_struct_declaration] = STATE(501),
    [sym_union_declaration] = STATE(501),
    [sym_postblit] = STATE(501),
    [sym_invariant_declaration] = STATE(501),
    [sym_class_declaration] = STATE(501),
    [sym_constructor] = STATE(501),
    [sym_destructor] = STATE(501),
    [sym_alias_this] = STATE(501),
    [sym_interface_declaration] = STATE(501),
    [sym_enum_declaration] = STATE(501),
    [sym_anonymous_enum_declaration] = STATE(501),
    [sym_function_declaration] = STATE(501),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(501),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(501),
    [sym_template_mixin] = STATE(501),
    [sym_conditional_declaration] = STATE(501),
    [sym_conditional_statement] = STATE(501),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(501),
    [sym_static_foreach_declaration] = STATE(501),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(501),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(501),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2069),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [496] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(499),
    [sym_mixin_declaration] = STATE(499),
    [sym__declaration] = STATE(499),
    [sym__declaration2] = STATE(499),
    [sym_variable_declaration] = STATE(499),
    [sym_manifest_constant] = STATE(499),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(499),
    [sym_alias_declaration] = STATE(499),
    [sym_alias_reassign] = STATE(499),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(499),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(499),
    [sym_pragma_statement] = STATE(499),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(499),
    [sym_labeled_statement] = STATE(499),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_do_statement] = STATE(499),
    [sym_for_statement] = STATE(499),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(499),
    [sym_switch_statement] = STATE(499),
    [sym_final_switch_statement] = STATE(499),
    [sym_continue_statement] = STATE(499),
    [sym_break_statement] = STATE(499),
    [sym_return_statement] = STATE(499),
    [sym_goto_statement] = STATE(499),
    [sym_with_statement] = STATE(499),
    [sym_synchronized_statement] = STATE(499),
    [sym_try_statement] = STATE(499),
    [sym_scope_guard_statement] = STATE(499),
    [sym_asm_statement] = STATE(499),
    [sym_struct_declaration] = STATE(499),
    [sym_union_declaration] = STATE(499),
    [sym_postblit] = STATE(499),
    [sym_invariant_declaration] = STATE(499),
    [sym_class_declaration] = STATE(499),
    [sym_constructor] = STATE(499),
    [sym_destructor] = STATE(499),
    [sym_alias_this] = STATE(499),
    [sym_interface_declaration] = STATE(499),
    [sym_enum_declaration] = STATE(499),
    [sym_anonymous_enum_declaration] = STATE(499),
    [sym_function_declaration] = STATE(499),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(499),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(499),
    [sym_template_mixin] = STATE(499),
    [sym_conditional_declaration] = STATE(499),
    [sym_conditional_statement] = STATE(499),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(499),
    [sym_static_foreach_declaration] = STATE(499),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(499),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(499),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(387),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(391),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(391),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [497] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(491),
    [sym_mixin_declaration] = STATE(491),
    [sym__declaration] = STATE(491),
    [sym__declaration2] = STATE(491),
    [sym_variable_declaration] = STATE(491),
    [sym_manifest_constant] = STATE(491),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(491),
    [sym_alias_declaration] = STATE(491),
    [sym_alias_reassign] = STATE(491),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(491),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(491),
    [sym_pragma_statement] = STATE(491),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(491),
    [sym_labeled_statement] = STATE(491),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(491),
    [sym_if_statement] = STATE(491),
    [sym_while_statement] = STATE(491),
    [sym_do_statement] = STATE(491),
    [sym_for_statement] = STATE(491),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(491),
    [sym_switch_statement] = STATE(491),
    [sym_final_switch_statement] = STATE(491),
    [sym_continue_statement] = STATE(491),
    [sym_break_statement] = STATE(491),
    [sym_return_statement] = STATE(491),
    [sym_goto_statement] = STATE(491),
    [sym_with_statement] = STATE(491),
    [sym_synchronized_statement] = STATE(491),
    [sym_try_statement] = STATE(491),
    [sym_scope_guard_statement] = STATE(491),
    [sym_asm_statement] = STATE(491),
    [sym_struct_declaration] = STATE(491),
    [sym_union_declaration] = STATE(491),
    [sym_postblit] = STATE(491),
    [sym_invariant_declaration] = STATE(491),
    [sym_class_declaration] = STATE(491),
    [sym_constructor] = STATE(491),
    [sym_destructor] = STATE(491),
    [sym_alias_this] = STATE(491),
    [sym_interface_declaration] = STATE(491),
    [sym_enum_declaration] = STATE(491),
    [sym_anonymous_enum_declaration] = STATE(491),
    [sym_function_declaration] = STATE(491),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(491),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(491),
    [sym_template_mixin] = STATE(491),
    [sym_conditional_declaration] = STATE(491),
    [sym_conditional_statement] = STATE(491),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(491),
    [sym_static_foreach_declaration] = STATE(491),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(491),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(491),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(647),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2071),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(651),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(651),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [498] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2442),
    [sym_mixin_declaration] = STATE(2442),
    [sym__declaration] = STATE(2442),
    [sym__declaration2] = STATE(2442),
    [sym_variable_declaration] = STATE(2442),
    [sym_manifest_constant] = STATE(2442),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2442),
    [sym_alias_declaration] = STATE(2442),
    [sym_alias_reassign] = STATE(2442),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2442),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2442),
    [sym_pragma_statement] = STATE(4678),
    [sym_pragma_expression] = STATE(498),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4678),
    [sym__statement_no_case_no_default] = STATE(4678),
    [sym_labeled_statement] = STATE(4678),
    [sym_label] = STATE(314),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4678),
    [sym_if_statement] = STATE(4678),
    [sym_while_statement] = STATE(4678),
    [sym_do_statement] = STATE(4678),
    [sym_for_statement] = STATE(4678),
    [sym__foreach] = STATE(6505),
    [sym_foreach_statement] = STATE(4678),
    [sym_switch_statement] = STATE(4678),
    [sym_case_statement] = STATE(4678),
    [sym_final_switch_statement] = STATE(4678),
    [sym_continue_statement] = STATE(4678),
    [sym_break_statement] = STATE(4678),
    [sym_return_statement] = STATE(4678),
    [sym_goto_statement] = STATE(4678),
    [sym_with_statement] = STATE(4678),
    [sym_synchronized_statement] = STATE(4678),
    [sym_try_statement] = STATE(4678),
    [sym_scope_guard_statement] = STATE(4678),
    [sym_asm_statement] = STATE(4678),
    [sym_struct_declaration] = STATE(2442),
    [sym_union_declaration] = STATE(2442),
    [sym_postblit] = STATE(2442),
    [sym_invariant_declaration] = STATE(2442),
    [sym_class_declaration] = STATE(2442),
    [sym_constructor] = STATE(2442),
    [sym_destructor] = STATE(2442),
    [sym_alias_this] = STATE(2442),
    [sym_interface_declaration] = STATE(2442),
    [sym_enum_declaration] = STATE(2442),
    [sym_anonymous_enum_declaration] = STATE(2442),
    [sym_function_declaration] = STATE(2442),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2442),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2442),
    [sym_template_mixin] = STATE(2442),
    [sym_conditional_declaration] = STATE(2442),
    [sym_conditional_statement] = STATE(4678),
    [sym_condition] = STATE(119),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4678),
    [sym_static_foreach_declaration] = STATE(2442),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2442),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1816),
    [sym_for] = ACTIONS(882),
    [sym_foreach] = ACTIONS(884),
    [sym_foreach_reverse] = ACTIONS(884),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(888),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1820),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1824),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(1826),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(920),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(928),
    [sym_with] = ACTIONS(930),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [499] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(499),
    [sym_mixin_declaration] = STATE(499),
    [sym__declaration] = STATE(499),
    [sym__declaration2] = STATE(499),
    [sym_variable_declaration] = STATE(499),
    [sym_manifest_constant] = STATE(499),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(499),
    [sym_alias_declaration] = STATE(499),
    [sym_alias_reassign] = STATE(499),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(499),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(499),
    [sym_pragma_statement] = STATE(499),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(499),
    [sym_labeled_statement] = STATE(499),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_do_statement] = STATE(499),
    [sym_for_statement] = STATE(499),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(499),
    [sym_switch_statement] = STATE(499),
    [sym_final_switch_statement] = STATE(499),
    [sym_continue_statement] = STATE(499),
    [sym_break_statement] = STATE(499),
    [sym_return_statement] = STATE(499),
    [sym_goto_statement] = STATE(499),
    [sym_with_statement] = STATE(499),
    [sym_synchronized_statement] = STATE(499),
    [sym_try_statement] = STATE(499),
    [sym_scope_guard_statement] = STATE(499),
    [sym_asm_statement] = STATE(499),
    [sym_struct_declaration] = STATE(499),
    [sym_union_declaration] = STATE(499),
    [sym_postblit] = STATE(499),
    [sym_invariant_declaration] = STATE(499),
    [sym_class_declaration] = STATE(499),
    [sym_constructor] = STATE(499),
    [sym_destructor] = STATE(499),
    [sym_alias_this] = STATE(499),
    [sym_interface_declaration] = STATE(499),
    [sym_enum_declaration] = STATE(499),
    [sym_anonymous_enum_declaration] = STATE(499),
    [sym_function_declaration] = STATE(499),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(499),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(499),
    [sym_template_mixin] = STATE(499),
    [sym_conditional_declaration] = STATE(499),
    [sym_conditional_statement] = STATE(499),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(499),
    [sym_static_foreach_declaration] = STATE(499),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(499),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(499),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1856),
    [anon_sym_q_LBRACE] = ACTIONS(396),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(404),
    [anon_sym_AMP] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_DASH_DASH] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(410),
    [anon_sym_PLUS_PLUS] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(413),
    [anon_sym_RPAREN] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_DOLLAR] = ACTIONS(422),
    [anon_sym_STAR] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(1865),
    [anon_sym_AT] = ACTIONS(428),
    [sym_bool] = ACTIONS(431),
    [sym_byte] = ACTIONS(431),
    [sym_ubyte] = ACTIONS(431),
    [sym_char] = ACTIONS(431),
    [sym_short] = ACTIONS(431),
    [sym_ushort] = ACTIONS(431),
    [sym_int] = ACTIONS(431),
    [sym_uint] = ACTIONS(431),
    [sym_long] = ACTIONS(431),
    [sym_ulong] = ACTIONS(431),
    [sym_cent] = ACTIONS(431),
    [sym_ucent] = ACTIONS(431),
    [sym_wchar] = ACTIONS(431),
    [sym_dchar] = ACTIONS(431),
    [sym_float] = ACTIONS(431),
    [sym_double] = ACTIONS(431),
    [sym_real] = ACTIONS(431),
    [sym_ifloat] = ACTIONS(431),
    [sym_idouble] = ACTIONS(431),
    [sym_ireal] = ACTIONS(431),
    [sym_cfloat] = ACTIONS(431),
    [sym_cdouble] = ACTIONS(431),
    [sym_creal] = ACTIONS(431),
    [sym_size_t] = ACTIONS(431),
    [sym_ptrdiff_t] = ACTIONS(431),
    [sym_string] = ACTIONS(431),
    [sym_cstring] = ACTIONS(431),
    [sym_dstring] = ACTIONS(431),
    [sym_wstring] = ACTIONS(431),
    [sym_noreturn] = ACTIONS(431),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_super] = ACTIONS(434),
    [sym_this] = ACTIONS(1868),
    [sym_abstract] = ACTIONS(440),
    [sym_alias] = ACTIONS(1871),
    [sym_align] = ACTIONS(446),
    [sym_asm] = ACTIONS(1874),
    [sym_assert] = ACTIONS(452),
    [sym_auto] = ACTIONS(455),
    [sym_break] = ACTIONS(1877),
    [sym_case] = ACTIONS(461),
    [sym_cast] = ACTIONS(463),
    [sym_class] = ACTIONS(1880),
    [sym_const] = ACTIONS(469),
    [sym_continue] = ACTIONS(1883),
    [sym_debug] = ACTIONS(1886),
    [sym_default] = ACTIONS(461),
    [sym_delegate] = ACTIONS(478),
    [sym_delete] = ACTIONS(481),
    [sym_deprecated] = ACTIONS(484),
    [sym_do] = ACTIONS(1889),
    [sym_enum] = ACTIONS(1892),
    [sym_export] = ACTIONS(1895),
    [sym_extern] = ACTIONS(496),
    [sym_final] = ACTIONS(2078),
    [sym_for] = ACTIONS(2081),
    [sym_foreach] = ACTIONS(2084),
    [sym_foreach_reverse] = ACTIONS(2084),
    [sym_function] = ACTIONS(508),
    [sym_goto] = ACTIONS(1907),
    [sym_if] = ACTIONS(2087),
    [sym_immutable] = ACTIONS(469),
    [sym_import] = ACTIONS(1913),
    [sym_in] = ACTIONS(520),
    [sym_inout] = ACTIONS(469),
    [sym_interface] = ACTIONS(1916),
    [sym_invariant] = ACTIONS(1919),
    [sym_is] = ACTIONS(529),
    [sym_mixin] = ACTIONS(1922),
    [sym_new] = ACTIONS(535),
    [sym_nothrow] = ACTIONS(440),
    [sym_out] = ACTIONS(538),
    [sym_override] = ACTIONS(440),
    [sym_package] = ACTIONS(541),
    [sym_pragma] = ACTIONS(544),
    [sym_private] = ACTIONS(1895),
    [sym_protected] = ACTIONS(1895),
    [sym_public] = ACTIONS(1895),
    [sym_pure] = ACTIONS(440),
    [sym_ref] = ACTIONS(547),
    [sym_return] = ACTIONS(1925),
    [sym_scope] = ACTIONS(2090),
    [sym_shared] = ACTIONS(1931),
    [sym_static] = ACTIONS(2093),
    [sym_struct] = ACTIONS(1937),
    [sym_switch] = ACTIONS(2096),
    [sym_synchronized] = ACTIONS(2099),
    [sym_template] = ACTIONS(1946),
    [sym_throw] = ACTIONS(574),
    [sym_try] = ACTIONS(2102),
    [sym_typeid] = ACTIONS(580),
    [sym_typeof] = ACTIONS(583),
    [sym_union] = ACTIONS(1952),
    [sym_unittest] = ACTIONS(1955),
    [sym_version] = ACTIONS(1958),
    [sym_while] = ACTIONS(2105),
    [sym_with] = ACTIONS(2108),
    [sym_gshared] = ACTIONS(440),
    [sym_traits] = ACTIONS(601),
    [sym_vector] = ACTIONS(604),
    [sym_void] = ACTIONS(431),
    [anon_sym_BQUOTE] = ACTIONS(607),
    [anon_sym_r_DQUOTE] = ACTIONS(610),
    [anon_sym_x_DQUOTE] = ACTIONS(613),
    [anon_sym_DQUOTE] = ACTIONS(616),
    [anon_sym_i_BQUOTE] = ACTIONS(619),
    [anon_sym_i_DQUOTE] = ACTIONS(622),
    [anon_sym_iq_LBRACE] = ACTIONS(625),
    [aux_sym_char_literal_token1] = ACTIONS(628),
    [anon_sym_SQUOTE] = ACTIONS(631),
    [anon_sym___DATE__] = ACTIONS(634),
    [anon_sym___FILE__] = ACTIONS(634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(634),
    [anon_sym___FUNCTION__] = ACTIONS(634),
    [anon_sym___LINE__] = ACTIONS(634),
    [anon_sym___MODULE__] = ACTIONS(634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(634),
    [anon_sym___TIME__] = ACTIONS(634),
    [anon_sym___TIMESTAMP__] = ACTIONS(634),
    [anon_sym___VENDOR__] = ACTIONS(634),
    [anon_sym___VERSION__] = ACTIONS(634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(637),
    [sym_float_literal] = ACTIONS(637),
    [sym__string] = ACTIONS(640),
  },
  [500] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2442),
    [sym_mixin_declaration] = STATE(2442),
    [sym__declaration] = STATE(2442),
    [sym__declaration2] = STATE(2442),
    [sym_variable_declaration] = STATE(2442),
    [sym_manifest_constant] = STATE(2442),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2442),
    [sym_alias_declaration] = STATE(2442),
    [sym_alias_reassign] = STATE(2442),
    [sym_type] = STATE(4533),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2442),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2442),
    [sym_pragma_statement] = STATE(4678),
    [sym_pragma_expression] = STATE(500),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3169),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4678),
    [sym__statement_no_case_no_default] = STATE(4678),
    [sym_labeled_statement] = STATE(4678),
    [sym_label] = STATE(245),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4678),
    [sym_if_statement] = STATE(4678),
    [sym_while_statement] = STATE(4678),
    [sym_do_statement] = STATE(4678),
    [sym_for_statement] = STATE(4678),
    [sym__foreach] = STATE(6487),
    [sym_foreach_statement] = STATE(4678),
    [sym_switch_statement] = STATE(4678),
    [sym_case_statement] = STATE(4678),
    [sym_final_switch_statement] = STATE(4678),
    [sym_continue_statement] = STATE(4678),
    [sym_break_statement] = STATE(4678),
    [sym_return_statement] = STATE(4678),
    [sym_goto_statement] = STATE(4678),
    [sym_with_statement] = STATE(4678),
    [sym_synchronized_statement] = STATE(4678),
    [sym_try_statement] = STATE(4678),
    [sym_scope_guard_statement] = STATE(4678),
    [sym_asm_statement] = STATE(4678),
    [sym_struct_declaration] = STATE(2442),
    [sym_union_declaration] = STATE(2442),
    [sym_postblit] = STATE(2442),
    [sym_invariant_declaration] = STATE(2442),
    [sym_class_declaration] = STATE(2442),
    [sym_constructor] = STATE(2442),
    [sym_destructor] = STATE(2442),
    [sym_alias_this] = STATE(2442),
    [sym_interface_declaration] = STATE(2442),
    [sym_enum_declaration] = STATE(2442),
    [sym_anonymous_enum_declaration] = STATE(2442),
    [sym_function_declaration] = STATE(2442),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2442),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2442),
    [sym_template_mixin] = STATE(2442),
    [sym_conditional_declaration] = STATE(2442),
    [sym_conditional_statement] = STATE(4678),
    [sym_condition] = STATE(116),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4678),
    [sym_static_foreach_declaration] = STATE(2442),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2442),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1808),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2073),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(834),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(860),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1848),
    [sym_for] = ACTIONS(1782),
    [sym_foreach] = ACTIONS(1784),
    [sym_foreach_reverse] = ACTIONS(1784),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1786),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(890),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1818),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1850),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(1852),
    [sym_struct] = ACTIONS(63),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(1854),
    [sym_template] = ACTIONS(65),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1802),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(926),
    [sym_while] = ACTIONS(1804),
    [sym_with] = ACTIONS(1806),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [501] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(499),
    [sym_mixin_declaration] = STATE(499),
    [sym__declaration] = STATE(499),
    [sym__declaration2] = STATE(499),
    [sym_variable_declaration] = STATE(499),
    [sym_manifest_constant] = STATE(499),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(499),
    [sym_alias_declaration] = STATE(499),
    [sym_alias_reassign] = STATE(499),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(499),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(499),
    [sym_pragma_statement] = STATE(499),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(499),
    [sym_labeled_statement] = STATE(499),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_do_statement] = STATE(499),
    [sym_for_statement] = STATE(499),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(499),
    [sym_switch_statement] = STATE(499),
    [sym_final_switch_statement] = STATE(499),
    [sym_continue_statement] = STATE(499),
    [sym_break_statement] = STATE(499),
    [sym_return_statement] = STATE(499),
    [sym_goto_statement] = STATE(499),
    [sym_with_statement] = STATE(499),
    [sym_synchronized_statement] = STATE(499),
    [sym_try_statement] = STATE(499),
    [sym_scope_guard_statement] = STATE(499),
    [sym_asm_statement] = STATE(499),
    [sym_struct_declaration] = STATE(499),
    [sym_union_declaration] = STATE(499),
    [sym_postblit] = STATE(499),
    [sym_invariant_declaration] = STATE(499),
    [sym_class_declaration] = STATE(499),
    [sym_constructor] = STATE(499),
    [sym_destructor] = STATE(499),
    [sym_alias_this] = STATE(499),
    [sym_interface_declaration] = STATE(499),
    [sym_enum_declaration] = STATE(499),
    [sym_anonymous_enum_declaration] = STATE(499),
    [sym_function_declaration] = STATE(499),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(499),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(499),
    [sym_template_mixin] = STATE(499),
    [sym_conditional_declaration] = STATE(499),
    [sym_conditional_statement] = STATE(499),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(499),
    [sym_static_foreach_declaration] = STATE(499),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(499),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(499),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(643),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(645),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(645),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [502] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(1576),
    [sym_mixin_declaration] = STATE(1576),
    [sym__declaration] = STATE(1576),
    [sym__declaration2] = STATE(1576),
    [sym_variable_declaration] = STATE(1576),
    [sym_manifest_constant] = STATE(1576),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1576),
    [sym_alias_declaration] = STATE(1576),
    [sym_alias_reassign] = STATE(1576),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(1576),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1576),
    [sym_pragma_statement] = STATE(1552),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(1552),
    [sym__statement_no_case_no_default] = STATE(1552),
    [sym_labeled_statement] = STATE(1552),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(1552),
    [sym_if_statement] = STATE(1552),
    [sym_while_statement] = STATE(1552),
    [sym_do_statement] = STATE(1552),
    [sym_for_statement] = STATE(1552),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(1552),
    [sym_switch_statement] = STATE(1552),
    [sym_case_statement] = STATE(1552),
    [sym_final_switch_statement] = STATE(1552),
    [sym_continue_statement] = STATE(1552),
    [sym_break_statement] = STATE(1552),
    [sym_return_statement] = STATE(1552),
    [sym_goto_statement] = STATE(1552),
    [sym_with_statement] = STATE(1552),
    [sym_synchronized_statement] = STATE(1552),
    [sym_try_statement] = STATE(1552),
    [sym_scope_guard_statement] = STATE(1552),
    [sym_asm_statement] = STATE(1552),
    [sym_struct_declaration] = STATE(1576),
    [sym_union_declaration] = STATE(1576),
    [sym_postblit] = STATE(1576),
    [sym_invariant_declaration] = STATE(1576),
    [sym_class_declaration] = STATE(1576),
    [sym_constructor] = STATE(1576),
    [sym_destructor] = STATE(1576),
    [sym_alias_this] = STATE(1576),
    [sym_interface_declaration] = STATE(1576),
    [sym_enum_declaration] = STATE(1576),
    [sym_anonymous_enum_declaration] = STATE(1576),
    [sym_function_declaration] = STATE(1576),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(1576),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(1576),
    [sym_template_mixin] = STATE(1576),
    [sym_conditional_declaration] = STATE(1576),
    [sym_conditional_statement] = STATE(1552),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(1552),
    [sym_static_foreach_declaration] = STATE(1576),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(1576),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2065),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2067),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [503] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(496),
    [sym_mixin_declaration] = STATE(496),
    [sym__declaration] = STATE(496),
    [sym__declaration2] = STATE(496),
    [sym_variable_declaration] = STATE(496),
    [sym_manifest_constant] = STATE(496),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(496),
    [sym_alias_declaration] = STATE(496),
    [sym_alias_reassign] = STATE(496),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(496),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(496),
    [sym_pragma_statement] = STATE(496),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(496),
    [sym_labeled_statement] = STATE(496),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(496),
    [sym_if_statement] = STATE(496),
    [sym_while_statement] = STATE(496),
    [sym_do_statement] = STATE(496),
    [sym_for_statement] = STATE(496),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(496),
    [sym_switch_statement] = STATE(496),
    [sym_final_switch_statement] = STATE(496),
    [sym_continue_statement] = STATE(496),
    [sym_break_statement] = STATE(496),
    [sym_return_statement] = STATE(496),
    [sym_goto_statement] = STATE(496),
    [sym_with_statement] = STATE(496),
    [sym_synchronized_statement] = STATE(496),
    [sym_try_statement] = STATE(496),
    [sym_scope_guard_statement] = STATE(496),
    [sym_asm_statement] = STATE(496),
    [sym_struct_declaration] = STATE(496),
    [sym_union_declaration] = STATE(496),
    [sym_postblit] = STATE(496),
    [sym_invariant_declaration] = STATE(496),
    [sym_class_declaration] = STATE(496),
    [sym_constructor] = STATE(496),
    [sym_destructor] = STATE(496),
    [sym_alias_this] = STATE(496),
    [sym_interface_declaration] = STATE(496),
    [sym_enum_declaration] = STATE(496),
    [sym_anonymous_enum_declaration] = STATE(496),
    [sym_function_declaration] = STATE(496),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(496),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(496),
    [sym_template_mixin] = STATE(496),
    [sym_conditional_declaration] = STATE(496),
    [sym_conditional_statement] = STATE(496),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(496),
    [sym_static_foreach_declaration] = STATE(496),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(496),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(496),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [504] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(499),
    [sym_mixin_declaration] = STATE(499),
    [sym__declaration] = STATE(499),
    [sym__declaration2] = STATE(499),
    [sym_variable_declaration] = STATE(499),
    [sym_manifest_constant] = STATE(499),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(499),
    [sym_alias_declaration] = STATE(499),
    [sym_alias_reassign] = STATE(499),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(499),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(499),
    [sym_pragma_statement] = STATE(499),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(499),
    [sym_labeled_statement] = STATE(499),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_do_statement] = STATE(499),
    [sym_for_statement] = STATE(499),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(499),
    [sym_switch_statement] = STATE(499),
    [sym_final_switch_statement] = STATE(499),
    [sym_continue_statement] = STATE(499),
    [sym_break_statement] = STATE(499),
    [sym_return_statement] = STATE(499),
    [sym_goto_statement] = STATE(499),
    [sym_with_statement] = STATE(499),
    [sym_synchronized_statement] = STATE(499),
    [sym_try_statement] = STATE(499),
    [sym_scope_guard_statement] = STATE(499),
    [sym_asm_statement] = STATE(499),
    [sym_struct_declaration] = STATE(499),
    [sym_union_declaration] = STATE(499),
    [sym_postblit] = STATE(499),
    [sym_invariant_declaration] = STATE(499),
    [sym_class_declaration] = STATE(499),
    [sym_constructor] = STATE(499),
    [sym_destructor] = STATE(499),
    [sym_alias_this] = STATE(499),
    [sym_interface_declaration] = STATE(499),
    [sym_enum_declaration] = STATE(499),
    [sym_anonymous_enum_declaration] = STATE(499),
    [sym_function_declaration] = STATE(499),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(499),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(499),
    [sym_template_mixin] = STATE(499),
    [sym_conditional_declaration] = STATE(499),
    [sym_conditional_statement] = STATE(499),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(499),
    [sym_static_foreach_declaration] = STATE(499),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(499),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(499),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(379),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(383),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(383),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [505] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2044),
    [sym_mixin_declaration] = STATE(2044),
    [sym__declaration] = STATE(2044),
    [sym__declaration2] = STATE(2044),
    [sym_variable_declaration] = STATE(2044),
    [sym_manifest_constant] = STATE(2044),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2044),
    [sym_alias_declaration] = STATE(2044),
    [sym_alias_reassign] = STATE(2044),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2044),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2044),
    [sym_pragma_statement] = STATE(2037),
    [sym_pragma_expression] = STATE(505),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2037),
    [sym__statement_no_case_no_default] = STATE(2037),
    [sym_labeled_statement] = STATE(2037),
    [sym_label] = STATE(439),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2037),
    [sym_if_statement] = STATE(2037),
    [sym_while_statement] = STATE(2037),
    [sym_do_statement] = STATE(2037),
    [sym_for_statement] = STATE(2037),
    [sym__foreach] = STATE(6549),
    [sym_foreach_statement] = STATE(2037),
    [sym_switch_statement] = STATE(2037),
    [sym_case_statement] = STATE(2037),
    [sym_final_switch_statement] = STATE(2037),
    [sym_continue_statement] = STATE(2037),
    [sym_break_statement] = STATE(2037),
    [sym_return_statement] = STATE(2037),
    [sym_goto_statement] = STATE(2037),
    [sym_with_statement] = STATE(2037),
    [sym_synchronized_statement] = STATE(2037),
    [sym_try_statement] = STATE(2037),
    [sym_scope_guard_statement] = STATE(2037),
    [sym_asm_statement] = STATE(2037),
    [sym_struct_declaration] = STATE(2044),
    [sym_union_declaration] = STATE(2044),
    [sym_postblit] = STATE(2044),
    [sym_invariant_declaration] = STATE(2044),
    [sym_class_declaration] = STATE(2044),
    [sym_constructor] = STATE(2044),
    [sym_destructor] = STATE(2044),
    [sym_alias_this] = STATE(2044),
    [sym_interface_declaration] = STATE(2044),
    [sym_enum_declaration] = STATE(2044),
    [sym_anonymous_enum_declaration] = STATE(2044),
    [sym_function_declaration] = STATE(2044),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2044),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2044),
    [sym_template_mixin] = STATE(2044),
    [sym_conditional_declaration] = STATE(2044),
    [sym_conditional_statement] = STATE(2037),
    [sym_condition] = STATE(82),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2037),
    [sym_static_foreach_declaration] = STATE(2044),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2044),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(852),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(862),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1286),
    [sym_for] = ACTIONS(1070),
    [sym_foreach] = ACTIONS(1072),
    [sym_foreach_reverse] = ACTIONS(1072),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1074),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1288),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1290),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(1292),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1098),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1100),
    [sym_with] = ACTIONS(1102),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [506] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2044),
    [sym_mixin_declaration] = STATE(2044),
    [sym__declaration] = STATE(2044),
    [sym__declaration2] = STATE(2044),
    [sym_variable_declaration] = STATE(2044),
    [sym_manifest_constant] = STATE(2044),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2044),
    [sym_alias_declaration] = STATE(2044),
    [sym_alias_reassign] = STATE(2044),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2044),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2044),
    [sym_pragma_statement] = STATE(2037),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2037),
    [sym__statement_no_case_no_default] = STATE(2037),
    [sym_labeled_statement] = STATE(2037),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2037),
    [sym_if_statement] = STATE(2037),
    [sym_while_statement] = STATE(2037),
    [sym_do_statement] = STATE(2037),
    [sym_for_statement] = STATE(2037),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(2037),
    [sym_switch_statement] = STATE(2037),
    [sym_case_statement] = STATE(2037),
    [sym_final_switch_statement] = STATE(2037),
    [sym_continue_statement] = STATE(2037),
    [sym_break_statement] = STATE(2037),
    [sym_return_statement] = STATE(2037),
    [sym_goto_statement] = STATE(2037),
    [sym_with_statement] = STATE(2037),
    [sym_synchronized_statement] = STATE(2037),
    [sym_try_statement] = STATE(2037),
    [sym_scope_guard_statement] = STATE(2037),
    [sym_asm_statement] = STATE(2037),
    [sym_struct_declaration] = STATE(2044),
    [sym_union_declaration] = STATE(2044),
    [sym_postblit] = STATE(2044),
    [sym_invariant_declaration] = STATE(2044),
    [sym_class_declaration] = STATE(2044),
    [sym_constructor] = STATE(2044),
    [sym_destructor] = STATE(2044),
    [sym_alias_this] = STATE(2044),
    [sym_interface_declaration] = STATE(2044),
    [sym_enum_declaration] = STATE(2044),
    [sym_anonymous_enum_declaration] = STATE(2044),
    [sym_function_declaration] = STATE(2044),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2044),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2044),
    [sym_template_mixin] = STATE(2044),
    [sym_conditional_declaration] = STATE(2044),
    [sym_conditional_statement] = STATE(2037),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2037),
    [sym_static_foreach_declaration] = STATE(2044),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2044),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(119),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(129),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(2043),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(2045),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(2047),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2049),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [507] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2319),
    [sym_mixin_declaration] = STATE(2319),
    [sym__declaration] = STATE(2319),
    [sym__declaration2] = STATE(2319),
    [sym_variable_declaration] = STATE(2319),
    [sym_manifest_constant] = STATE(2319),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2319),
    [sym_alias_declaration] = STATE(2319),
    [sym_alias_reassign] = STATE(2319),
    [sym_type] = STATE(4543),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2319),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2319),
    [sym_pragma_statement] = STATE(4678),
    [sym_pragma_expression] = STATE(507),
    [sym_expression_list] = STATE(6495),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3197),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(4678),
    [sym__statement_no_case_no_default] = STATE(4678),
    [sym_labeled_statement] = STATE(4678),
    [sym_label] = STATE(128),
    [sym_block_statement] = STATE(3183),
    [sym_expression_statement] = STATE(4678),
    [sym_if_statement] = STATE(4678),
    [sym_while_statement] = STATE(4678),
    [sym_do_statement] = STATE(4678),
    [sym_for_statement] = STATE(4678),
    [sym__foreach] = STATE(6545),
    [sym_foreach_statement] = STATE(4678),
    [sym_switch_statement] = STATE(4678),
    [sym_case_statement] = STATE(4678),
    [sym_final_switch_statement] = STATE(4678),
    [sym_continue_statement] = STATE(4678),
    [sym_break_statement] = STATE(4678),
    [sym_return_statement] = STATE(4678),
    [sym_goto_statement] = STATE(4678),
    [sym_with_statement] = STATE(4678),
    [sym_synchronized_statement] = STATE(4678),
    [sym_try_statement] = STATE(4678),
    [sym_scope_guard_statement] = STATE(4678),
    [sym_asm_statement] = STATE(4678),
    [sym_struct_declaration] = STATE(2319),
    [sym_union_declaration] = STATE(2319),
    [sym_postblit] = STATE(2319),
    [sym_invariant_declaration] = STATE(2319),
    [sym_class_declaration] = STATE(2319),
    [sym_constructor] = STATE(2319),
    [sym_destructor] = STATE(2319),
    [sym_alias_this] = STATE(2319),
    [sym_interface_declaration] = STATE(2319),
    [sym_enum_declaration] = STATE(2319),
    [sym_anonymous_enum_declaration] = STATE(2319),
    [sym_function_declaration] = STATE(2319),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2319),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2319),
    [sym_template_mixin] = STATE(2319),
    [sym_conditional_declaration] = STATE(2319),
    [sym_conditional_statement] = STATE(4678),
    [sym_condition] = STATE(53),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(4701),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(4701),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(4678),
    [sym_static_foreach_declaration] = STATE(2319),
    [sym_static_assert] = STATE(4701),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2319),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1108),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2051),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2053),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(986),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(988),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(844),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(850),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(858),
    [sym_debug] = ACTIONS(994),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(868),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1118),
    [sym_for] = ACTIONS(1006),
    [sym_foreach] = ACTIONS(1008),
    [sym_foreach_reverse] = ACTIONS(1008),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(886),
    [sym_if] = ACTIONS(1010),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(1012),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1120),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(900),
    [sym_scope] = ACTIONS(1122),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(1126),
    [sym_struct] = ACTIONS(1034),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(1128),
    [sym_template] = ACTIONS(1042),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1044),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(1050),
    [sym_while] = ACTIONS(1052),
    [sym_with] = ACTIONS(1054),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [508] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(504),
    [sym_mixin_declaration] = STATE(504),
    [sym__declaration] = STATE(504),
    [sym__declaration2] = STATE(504),
    [sym_variable_declaration] = STATE(504),
    [sym_manifest_constant] = STATE(504),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(504),
    [sym_alias_declaration] = STATE(504),
    [sym_alias_reassign] = STATE(504),
    [sym_type] = STATE(4522),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(504),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(504),
    [sym_pragma_statement] = STATE(504),
    [sym_pragma_expression] = STATE(502),
    [sym_expression_list] = STATE(5834),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3114),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(504),
    [sym_labeled_statement] = STATE(504),
    [sym_label] = STATE(224),
    [sym_block_statement] = STATE(668),
    [sym_expression_statement] = STATE(504),
    [sym_if_statement] = STATE(504),
    [sym_while_statement] = STATE(504),
    [sym_do_statement] = STATE(504),
    [sym_for_statement] = STATE(504),
    [sym__foreach] = STATE(5825),
    [sym_foreach_statement] = STATE(504),
    [sym_switch_statement] = STATE(504),
    [sym_final_switch_statement] = STATE(504),
    [sym_continue_statement] = STATE(504),
    [sym_break_statement] = STATE(504),
    [sym_return_statement] = STATE(504),
    [sym_goto_statement] = STATE(504),
    [sym_with_statement] = STATE(504),
    [sym_synchronized_statement] = STATE(504),
    [sym_try_statement] = STATE(504),
    [sym_scope_guard_statement] = STATE(504),
    [sym_asm_statement] = STATE(504),
    [sym_struct_declaration] = STATE(504),
    [sym_union_declaration] = STATE(504),
    [sym_postblit] = STATE(504),
    [sym_invariant_declaration] = STATE(504),
    [sym_class_declaration] = STATE(504),
    [sym_constructor] = STATE(504),
    [sym_destructor] = STATE(504),
    [sym_alias_this] = STATE(504),
    [sym_interface_declaration] = STATE(504),
    [sym_enum_declaration] = STATE(504),
    [sym_anonymous_enum_declaration] = STATE(504),
    [sym_function_declaration] = STATE(504),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(504),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(504),
    [sym_template_mixin] = STATE(504),
    [sym_conditional_declaration] = STATE(504),
    [sym_conditional_statement] = STATE(504),
    [sym_condition] = STATE(88),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1571),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1571),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(504),
    [sym_static_foreach_declaration] = STATE(504),
    [sym_static_assert] = STATE(1571),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(504),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_case_statement_repeat1] = STATE(504),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(239),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_LBRACE] = ACTIONS(243),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(303),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2113),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(107),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(111),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(117),
    [sym_case] = ACTIONS(319),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(125),
    [sym_debug] = ACTIONS(127),
    [sym_default] = ACTIONS(319),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(135),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(141),
    [sym_for] = ACTIONS(143),
    [sym_foreach] = ACTIONS(145),
    [sym_foreach_reverse] = ACTIONS(145),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(149),
    [sym_if] = ACTIONS(151),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(153),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(163),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(173),
    [sym_scope] = ACTIONS(175),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(179),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(185),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(191),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(201),
    [sym_while] = ACTIONS(203),
    [sym_with] = ACTIONS(205),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [509] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(2044),
    [sym_mixin_declaration] = STATE(2044),
    [sym__declaration] = STATE(2044),
    [sym__declaration2] = STATE(2044),
    [sym_variable_declaration] = STATE(2044),
    [sym_manifest_constant] = STATE(2044),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2044),
    [sym_alias_declaration] = STATE(2044),
    [sym_alias_reassign] = STATE(2044),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2472),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(2044),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2044),
    [sym_pragma_statement] = STATE(2037),
    [sym_pragma_expression] = STATE(509),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement] = STATE(2037),
    [sym__statement_no_case_no_default] = STATE(2037),
    [sym_labeled_statement] = STATE(2037),
    [sym_label] = STATE(476),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(2037),
    [sym_if_statement] = STATE(2037),
    [sym_while_statement] = STATE(2037),
    [sym_do_statement] = STATE(2037),
    [sym_for_statement] = STATE(2037),
    [sym__foreach] = STATE(6551),
    [sym_foreach_statement] = STATE(2037),
    [sym_switch_statement] = STATE(2037),
    [sym_case_statement] = STATE(2037),
    [sym_final_switch_statement] = STATE(2037),
    [sym_continue_statement] = STATE(2037),
    [sym_break_statement] = STATE(2037),
    [sym_return_statement] = STATE(2037),
    [sym_goto_statement] = STATE(2037),
    [sym_with_statement] = STATE(2037),
    [sym_synchronized_statement] = STATE(2037),
    [sym_try_statement] = STATE(2037),
    [sym_scope_guard_statement] = STATE(2037),
    [sym_asm_statement] = STATE(2037),
    [sym_struct_declaration] = STATE(2044),
    [sym_union_declaration] = STATE(2044),
    [sym_postblit] = STATE(2044),
    [sym_invariant_declaration] = STATE(2044),
    [sym_class_declaration] = STATE(2044),
    [sym_constructor] = STATE(2044),
    [sym_destructor] = STATE(2044),
    [sym_alias_this] = STATE(2044),
    [sym_interface_declaration] = STATE(2044),
    [sym_enum_declaration] = STATE(2044),
    [sym_anonymous_enum_declaration] = STATE(2044),
    [sym_function_declaration] = STATE(2044),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(2044),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(2044),
    [sym_template_mixin] = STATE(2044),
    [sym_conditional_declaration] = STATE(2044),
    [sym_conditional_statement] = STATE(2037),
    [sym_condition] = STATE(101),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(2037),
    [sym_static_foreach_declaration] = STATE(2044),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(2044),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2063),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(115),
    [sym_break] = ACTIONS(694),
    [sym_case] = ACTIONS(948),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_default] = ACTIONS(950),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(1238),
    [sym_for] = ACTIONS(1144),
    [sym_foreach] = ACTIONS(1146),
    [sym_foreach_reverse] = ACTIONS(1146),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(1148),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(171),
    [sym_return] = ACTIONS(741),
    [sym_scope] = ACTIONS(1242),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(1246),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(1248),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(1164),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(1166),
    [sym_with] = ACTIONS(1168),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [510] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(747),
    [sym_mixin_declaration] = STATE(747),
    [sym__declaration2] = STATE(747),
    [sym_variable_declaration] = STATE(747),
    [sym_manifest_constant] = STATE(747),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(747),
    [sym_alias_declaration] = STATE(747),
    [sym_alias_reassign] = STATE(747),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(747),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(747),
    [sym_pragma_statement] = STATE(747),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(747),
    [sym_labeled_statement] = STATE(747),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(747),
    [sym_if_statement] = STATE(747),
    [sym_while_statement] = STATE(747),
    [sym_do_statement] = STATE(747),
    [sym_for_statement] = STATE(747),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(747),
    [sym_switch_statement] = STATE(747),
    [sym_final_switch_statement] = STATE(747),
    [sym_continue_statement] = STATE(747),
    [sym_break_statement] = STATE(747),
    [sym_return_statement] = STATE(747),
    [sym_goto_statement] = STATE(747),
    [sym_with_statement] = STATE(747),
    [sym_synchronized_statement] = STATE(747),
    [sym_try_statement] = STATE(747),
    [sym_scope_guard_statement] = STATE(747),
    [sym_asm_statement] = STATE(747),
    [sym_struct_declaration] = STATE(747),
    [sym_union_declaration] = STATE(747),
    [sym_postblit] = STATE(747),
    [sym_invariant_declaration] = STATE(747),
    [sym_class_declaration] = STATE(747),
    [sym_constructor] = STATE(747),
    [sym_destructor] = STATE(747),
    [sym_alias_this] = STATE(747),
    [sym_interface_declaration] = STATE(747),
    [sym_enum_declaration] = STATE(747),
    [sym_anonymous_enum_declaration] = STATE(747),
    [sym_function_declaration] = STATE(747),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(747),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(747),
    [sym_template_mixin] = STATE(747),
    [sym_conditional_declaration] = STATE(747),
    [sym_conditional_statement] = STATE(747),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(747),
    [sym_static_foreach_declaration] = STATE(747),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(747),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2115),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [511] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(749),
    [sym_mixin_declaration] = STATE(749),
    [sym__declaration2] = STATE(749),
    [sym_variable_declaration] = STATE(749),
    [sym_manifest_constant] = STATE(749),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(749),
    [sym_alias_declaration] = STATE(749),
    [sym_alias_reassign] = STATE(749),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(749),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(749),
    [sym_pragma_statement] = STATE(749),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(749),
    [sym_labeled_statement] = STATE(749),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(749),
    [sym_if_statement] = STATE(749),
    [sym_while_statement] = STATE(749),
    [sym_do_statement] = STATE(749),
    [sym_for_statement] = STATE(749),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(749),
    [sym_switch_statement] = STATE(749),
    [sym_final_switch_statement] = STATE(749),
    [sym_continue_statement] = STATE(749),
    [sym_break_statement] = STATE(749),
    [sym_return_statement] = STATE(749),
    [sym_goto_statement] = STATE(749),
    [sym_with_statement] = STATE(749),
    [sym_synchronized_statement] = STATE(749),
    [sym_try_statement] = STATE(749),
    [sym_scope_guard_statement] = STATE(749),
    [sym_asm_statement] = STATE(749),
    [sym_struct_declaration] = STATE(749),
    [sym_union_declaration] = STATE(749),
    [sym_postblit] = STATE(749),
    [sym_invariant_declaration] = STATE(749),
    [sym_class_declaration] = STATE(749),
    [sym_constructor] = STATE(749),
    [sym_destructor] = STATE(749),
    [sym_alias_this] = STATE(749),
    [sym_interface_declaration] = STATE(749),
    [sym_enum_declaration] = STATE(749),
    [sym_anonymous_enum_declaration] = STATE(749),
    [sym_function_declaration] = STATE(749),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(749),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(749),
    [sym_template_mixin] = STATE(749),
    [sym_conditional_declaration] = STATE(749),
    [sym_conditional_statement] = STATE(749),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(749),
    [sym_static_foreach_declaration] = STATE(749),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(749),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [512] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(748),
    [sym_mixin_declaration] = STATE(748),
    [sym__declaration2] = STATE(748),
    [sym_variable_declaration] = STATE(748),
    [sym_manifest_constant] = STATE(748),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(748),
    [sym_alias_declaration] = STATE(748),
    [sym_alias_reassign] = STATE(748),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(748),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(748),
    [sym_pragma_statement] = STATE(748),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(748),
    [sym_labeled_statement] = STATE(748),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(748),
    [sym_if_statement] = STATE(748),
    [sym_while_statement] = STATE(748),
    [sym_do_statement] = STATE(748),
    [sym_for_statement] = STATE(748),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(748),
    [sym_switch_statement] = STATE(748),
    [sym_final_switch_statement] = STATE(748),
    [sym_continue_statement] = STATE(748),
    [sym_break_statement] = STATE(748),
    [sym_return_statement] = STATE(748),
    [sym_goto_statement] = STATE(748),
    [sym_with_statement] = STATE(748),
    [sym_synchronized_statement] = STATE(748),
    [sym_try_statement] = STATE(748),
    [sym_scope_guard_statement] = STATE(748),
    [sym_asm_statement] = STATE(748),
    [sym_struct_declaration] = STATE(748),
    [sym_union_declaration] = STATE(748),
    [sym_postblit] = STATE(748),
    [sym_invariant_declaration] = STATE(748),
    [sym_class_declaration] = STATE(748),
    [sym_constructor] = STATE(748),
    [sym_destructor] = STATE(748),
    [sym_alias_this] = STATE(748),
    [sym_interface_declaration] = STATE(748),
    [sym_enum_declaration] = STATE(748),
    [sym_anonymous_enum_declaration] = STATE(748),
    [sym_function_declaration] = STATE(748),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(748),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(748),
    [sym_template_mixin] = STATE(748),
    [sym_conditional_declaration] = STATE(748),
    [sym_conditional_statement] = STATE(748),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(748),
    [sym_static_foreach_declaration] = STATE(748),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(748),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2149),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [513] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(734),
    [sym_mixin_declaration] = STATE(734),
    [sym__declaration2] = STATE(734),
    [sym_variable_declaration] = STATE(734),
    [sym_manifest_constant] = STATE(734),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(734),
    [sym_alias_declaration] = STATE(734),
    [sym_alias_reassign] = STATE(734),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(734),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(734),
    [sym_pragma_statement] = STATE(734),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(734),
    [sym_labeled_statement] = STATE(734),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(734),
    [sym_if_statement] = STATE(734),
    [sym_while_statement] = STATE(734),
    [sym_do_statement] = STATE(734),
    [sym_for_statement] = STATE(734),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(734),
    [sym_switch_statement] = STATE(734),
    [sym_final_switch_statement] = STATE(734),
    [sym_continue_statement] = STATE(734),
    [sym_break_statement] = STATE(734),
    [sym_return_statement] = STATE(734),
    [sym_goto_statement] = STATE(734),
    [sym_with_statement] = STATE(734),
    [sym_synchronized_statement] = STATE(734),
    [sym_try_statement] = STATE(734),
    [sym_scope_guard_statement] = STATE(734),
    [sym_asm_statement] = STATE(734),
    [sym_struct_declaration] = STATE(734),
    [sym_union_declaration] = STATE(734),
    [sym_postblit] = STATE(734),
    [sym_invariant_declaration] = STATE(734),
    [sym_class_declaration] = STATE(734),
    [sym_constructor] = STATE(734),
    [sym_destructor] = STATE(734),
    [sym_alias_this] = STATE(734),
    [sym_interface_declaration] = STATE(734),
    [sym_enum_declaration] = STATE(734),
    [sym_anonymous_enum_declaration] = STATE(734),
    [sym_function_declaration] = STATE(734),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(734),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(734),
    [sym_template_mixin] = STATE(734),
    [sym_conditional_declaration] = STATE(734),
    [sym_conditional_statement] = STATE(734),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(734),
    [sym_static_foreach_declaration] = STATE(734),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(734),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [514] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(756),
    [sym_mixin_declaration] = STATE(756),
    [sym__declaration2] = STATE(756),
    [sym_variable_declaration] = STATE(756),
    [sym_manifest_constant] = STATE(756),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(756),
    [sym_alias_declaration] = STATE(756),
    [sym_alias_reassign] = STATE(756),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(756),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(756),
    [sym_pragma_statement] = STATE(756),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(756),
    [sym_labeled_statement] = STATE(756),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(756),
    [sym_if_statement] = STATE(756),
    [sym_while_statement] = STATE(756),
    [sym_do_statement] = STATE(756),
    [sym_for_statement] = STATE(756),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(756),
    [sym_switch_statement] = STATE(756),
    [sym_final_switch_statement] = STATE(756),
    [sym_continue_statement] = STATE(756),
    [sym_break_statement] = STATE(756),
    [sym_return_statement] = STATE(756),
    [sym_goto_statement] = STATE(756),
    [sym_with_statement] = STATE(756),
    [sym_synchronized_statement] = STATE(756),
    [sym_try_statement] = STATE(756),
    [sym_scope_guard_statement] = STATE(756),
    [sym_asm_statement] = STATE(756),
    [sym_struct_declaration] = STATE(756),
    [sym_union_declaration] = STATE(756),
    [sym_postblit] = STATE(756),
    [sym_invariant_declaration] = STATE(756),
    [sym_class_declaration] = STATE(756),
    [sym_constructor] = STATE(756),
    [sym_destructor] = STATE(756),
    [sym_alias_this] = STATE(756),
    [sym_interface_declaration] = STATE(756),
    [sym_enum_declaration] = STATE(756),
    [sym_anonymous_enum_declaration] = STATE(756),
    [sym_function_declaration] = STATE(756),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(756),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(756),
    [sym_template_mixin] = STATE(756),
    [sym_conditional_declaration] = STATE(756),
    [sym_conditional_statement] = STATE(756),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(756),
    [sym_static_foreach_declaration] = STATE(756),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(756),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [515] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(723),
    [sym_mixin_declaration] = STATE(723),
    [sym__declaration2] = STATE(723),
    [sym_variable_declaration] = STATE(723),
    [sym_manifest_constant] = STATE(723),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(723),
    [sym_alias_declaration] = STATE(723),
    [sym_alias_reassign] = STATE(723),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(723),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(723),
    [sym_pragma_statement] = STATE(723),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(723),
    [sym_labeled_statement] = STATE(723),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(723),
    [sym_if_statement] = STATE(723),
    [sym_while_statement] = STATE(723),
    [sym_do_statement] = STATE(723),
    [sym_for_statement] = STATE(723),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(723),
    [sym_switch_statement] = STATE(723),
    [sym_final_switch_statement] = STATE(723),
    [sym_continue_statement] = STATE(723),
    [sym_break_statement] = STATE(723),
    [sym_return_statement] = STATE(723),
    [sym_goto_statement] = STATE(723),
    [sym_with_statement] = STATE(723),
    [sym_synchronized_statement] = STATE(723),
    [sym_try_statement] = STATE(723),
    [sym_scope_guard_statement] = STATE(723),
    [sym_asm_statement] = STATE(723),
    [sym_struct_declaration] = STATE(723),
    [sym_union_declaration] = STATE(723),
    [sym_postblit] = STATE(723),
    [sym_invariant_declaration] = STATE(723),
    [sym_class_declaration] = STATE(723),
    [sym_constructor] = STATE(723),
    [sym_destructor] = STATE(723),
    [sym_alias_this] = STATE(723),
    [sym_interface_declaration] = STATE(723),
    [sym_enum_declaration] = STATE(723),
    [sym_anonymous_enum_declaration] = STATE(723),
    [sym_function_declaration] = STATE(723),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(723),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(723),
    [sym_template_mixin] = STATE(723),
    [sym_conditional_declaration] = STATE(723),
    [sym_conditional_statement] = STATE(723),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(723),
    [sym_static_foreach_declaration] = STATE(723),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(723),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [516] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(732),
    [sym_mixin_declaration] = STATE(732),
    [sym__declaration2] = STATE(732),
    [sym_variable_declaration] = STATE(732),
    [sym_manifest_constant] = STATE(732),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(732),
    [sym_alias_declaration] = STATE(732),
    [sym_alias_reassign] = STATE(732),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(732),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(732),
    [sym_pragma_statement] = STATE(732),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(732),
    [sym_labeled_statement] = STATE(732),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(732),
    [sym_if_statement] = STATE(732),
    [sym_while_statement] = STATE(732),
    [sym_do_statement] = STATE(732),
    [sym_for_statement] = STATE(732),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(732),
    [sym_switch_statement] = STATE(732),
    [sym_final_switch_statement] = STATE(732),
    [sym_continue_statement] = STATE(732),
    [sym_break_statement] = STATE(732),
    [sym_return_statement] = STATE(732),
    [sym_goto_statement] = STATE(732),
    [sym_with_statement] = STATE(732),
    [sym_synchronized_statement] = STATE(732),
    [sym_try_statement] = STATE(732),
    [sym_scope_guard_statement] = STATE(732),
    [sym_asm_statement] = STATE(732),
    [sym_struct_declaration] = STATE(732),
    [sym_union_declaration] = STATE(732),
    [sym_postblit] = STATE(732),
    [sym_invariant_declaration] = STATE(732),
    [sym_class_declaration] = STATE(732),
    [sym_constructor] = STATE(732),
    [sym_destructor] = STATE(732),
    [sym_alias_this] = STATE(732),
    [sym_interface_declaration] = STATE(732),
    [sym_enum_declaration] = STATE(732),
    [sym_anonymous_enum_declaration] = STATE(732),
    [sym_function_declaration] = STATE(732),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(732),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(732),
    [sym_template_mixin] = STATE(732),
    [sym_conditional_declaration] = STATE(732),
    [sym_conditional_statement] = STATE(732),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(732),
    [sym_static_foreach_declaration] = STATE(732),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(732),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [517] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(738),
    [sym_mixin_declaration] = STATE(738),
    [sym__declaration2] = STATE(738),
    [sym_variable_declaration] = STATE(738),
    [sym_manifest_constant] = STATE(738),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(738),
    [sym_alias_declaration] = STATE(738),
    [sym_alias_reassign] = STATE(738),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(738),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(738),
    [sym_pragma_statement] = STATE(738),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(738),
    [sym_labeled_statement] = STATE(738),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(738),
    [sym_if_statement] = STATE(738),
    [sym_while_statement] = STATE(738),
    [sym_do_statement] = STATE(738),
    [sym_for_statement] = STATE(738),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(738),
    [sym_switch_statement] = STATE(738),
    [sym_final_switch_statement] = STATE(738),
    [sym_continue_statement] = STATE(738),
    [sym_break_statement] = STATE(738),
    [sym_return_statement] = STATE(738),
    [sym_goto_statement] = STATE(738),
    [sym_with_statement] = STATE(738),
    [sym_synchronized_statement] = STATE(738),
    [sym_try_statement] = STATE(738),
    [sym_scope_guard_statement] = STATE(738),
    [sym_asm_statement] = STATE(738),
    [sym_struct_declaration] = STATE(738),
    [sym_union_declaration] = STATE(738),
    [sym_postblit] = STATE(738),
    [sym_invariant_declaration] = STATE(738),
    [sym_class_declaration] = STATE(738),
    [sym_constructor] = STATE(738),
    [sym_destructor] = STATE(738),
    [sym_alias_this] = STATE(738),
    [sym_interface_declaration] = STATE(738),
    [sym_enum_declaration] = STATE(738),
    [sym_anonymous_enum_declaration] = STATE(738),
    [sym_function_declaration] = STATE(738),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(738),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(738),
    [sym_template_mixin] = STATE(738),
    [sym_conditional_declaration] = STATE(738),
    [sym_conditional_statement] = STATE(738),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(738),
    [sym_static_foreach_declaration] = STATE(738),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(738),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2159),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [518] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(745),
    [sym_mixin_declaration] = STATE(745),
    [sym__declaration2] = STATE(745),
    [sym_variable_declaration] = STATE(745),
    [sym_manifest_constant] = STATE(745),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(745),
    [sym_alias_declaration] = STATE(745),
    [sym_alias_reassign] = STATE(745),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(745),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(745),
    [sym_pragma_statement] = STATE(745),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(745),
    [sym_labeled_statement] = STATE(745),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(745),
    [sym_if_statement] = STATE(745),
    [sym_while_statement] = STATE(745),
    [sym_do_statement] = STATE(745),
    [sym_for_statement] = STATE(745),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(745),
    [sym_switch_statement] = STATE(745),
    [sym_final_switch_statement] = STATE(745),
    [sym_continue_statement] = STATE(745),
    [sym_break_statement] = STATE(745),
    [sym_return_statement] = STATE(745),
    [sym_goto_statement] = STATE(745),
    [sym_with_statement] = STATE(745),
    [sym_synchronized_statement] = STATE(745),
    [sym_try_statement] = STATE(745),
    [sym_scope_guard_statement] = STATE(745),
    [sym_asm_statement] = STATE(745),
    [sym_struct_declaration] = STATE(745),
    [sym_union_declaration] = STATE(745),
    [sym_postblit] = STATE(745),
    [sym_invariant_declaration] = STATE(745),
    [sym_class_declaration] = STATE(745),
    [sym_constructor] = STATE(745),
    [sym_destructor] = STATE(745),
    [sym_alias_this] = STATE(745),
    [sym_interface_declaration] = STATE(745),
    [sym_enum_declaration] = STATE(745),
    [sym_anonymous_enum_declaration] = STATE(745),
    [sym_function_declaration] = STATE(745),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(745),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(745),
    [sym_template_mixin] = STATE(745),
    [sym_conditional_declaration] = STATE(745),
    [sym_conditional_statement] = STATE(745),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(745),
    [sym_static_foreach_declaration] = STATE(745),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(745),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2161),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [519] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(742),
    [sym_mixin_declaration] = STATE(742),
    [sym__declaration2] = STATE(742),
    [sym_variable_declaration] = STATE(742),
    [sym_manifest_constant] = STATE(742),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(742),
    [sym_alias_declaration] = STATE(742),
    [sym_alias_reassign] = STATE(742),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(742),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(742),
    [sym_pragma_statement] = STATE(742),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(742),
    [sym_labeled_statement] = STATE(742),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(742),
    [sym_if_statement] = STATE(742),
    [sym_while_statement] = STATE(742),
    [sym_do_statement] = STATE(742),
    [sym_for_statement] = STATE(742),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(742),
    [sym_switch_statement] = STATE(742),
    [sym_final_switch_statement] = STATE(742),
    [sym_continue_statement] = STATE(742),
    [sym_break_statement] = STATE(742),
    [sym_return_statement] = STATE(742),
    [sym_goto_statement] = STATE(742),
    [sym_with_statement] = STATE(742),
    [sym_synchronized_statement] = STATE(742),
    [sym_try_statement] = STATE(742),
    [sym_scope_guard_statement] = STATE(742),
    [sym_asm_statement] = STATE(742),
    [sym_struct_declaration] = STATE(742),
    [sym_union_declaration] = STATE(742),
    [sym_postblit] = STATE(742),
    [sym_invariant_declaration] = STATE(742),
    [sym_class_declaration] = STATE(742),
    [sym_constructor] = STATE(742),
    [sym_destructor] = STATE(742),
    [sym_alias_this] = STATE(742),
    [sym_interface_declaration] = STATE(742),
    [sym_enum_declaration] = STATE(742),
    [sym_anonymous_enum_declaration] = STATE(742),
    [sym_function_declaration] = STATE(742),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(742),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(742),
    [sym_template_mixin] = STATE(742),
    [sym_conditional_declaration] = STATE(742),
    [sym_conditional_statement] = STATE(742),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(742),
    [sym_static_foreach_declaration] = STATE(742),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(742),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [520] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(725),
    [sym_mixin_declaration] = STATE(725),
    [sym__declaration2] = STATE(725),
    [sym_variable_declaration] = STATE(725),
    [sym_manifest_constant] = STATE(725),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(725),
    [sym_alias_declaration] = STATE(725),
    [sym_alias_reassign] = STATE(725),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(725),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(725),
    [sym_pragma_statement] = STATE(725),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(725),
    [sym_labeled_statement] = STATE(725),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(725),
    [sym_if_statement] = STATE(725),
    [sym_while_statement] = STATE(725),
    [sym_do_statement] = STATE(725),
    [sym_for_statement] = STATE(725),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(725),
    [sym_switch_statement] = STATE(725),
    [sym_final_switch_statement] = STATE(725),
    [sym_continue_statement] = STATE(725),
    [sym_break_statement] = STATE(725),
    [sym_return_statement] = STATE(725),
    [sym_goto_statement] = STATE(725),
    [sym_with_statement] = STATE(725),
    [sym_synchronized_statement] = STATE(725),
    [sym_try_statement] = STATE(725),
    [sym_scope_guard_statement] = STATE(725),
    [sym_asm_statement] = STATE(725),
    [sym_struct_declaration] = STATE(725),
    [sym_union_declaration] = STATE(725),
    [sym_postblit] = STATE(725),
    [sym_invariant_declaration] = STATE(725),
    [sym_class_declaration] = STATE(725),
    [sym_constructor] = STATE(725),
    [sym_destructor] = STATE(725),
    [sym_alias_this] = STATE(725),
    [sym_interface_declaration] = STATE(725),
    [sym_enum_declaration] = STATE(725),
    [sym_anonymous_enum_declaration] = STATE(725),
    [sym_function_declaration] = STATE(725),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(725),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(725),
    [sym_template_mixin] = STATE(725),
    [sym_conditional_declaration] = STATE(725),
    [sym_conditional_statement] = STATE(725),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(725),
    [sym_static_foreach_declaration] = STATE(725),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(725),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2165),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [521] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_import_declaration] = STATE(727),
    [sym_mixin_declaration] = STATE(727),
    [sym__declaration2] = STATE(727),
    [sym_variable_declaration] = STATE(727),
    [sym_manifest_constant] = STATE(727),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(727),
    [sym_alias_declaration] = STATE(727),
    [sym_alias_reassign] = STATE(727),
    [sym_type] = STATE(4542),
    [sym_type_ctor] = STATE(2821),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_attribute_declaration] = STATE(727),
    [sym_align_attribute] = STATE(2871),
    [sym_deprecated_attribute] = STATE(6009),
    [sym__attribute] = STATE(6009),
    [sym_at_attribute] = STATE(2871),
    [sym__function_attribute_kwd] = STATE(2871),
    [sym_linkage_attribute] = STATE(2871),
    [sym_pragma_declaration] = STATE(727),
    [sym_pragma_statement] = STATE(727),
    [sym_pragma_expression] = STATE(506),
    [sym_expression_list] = STATE(5826),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3222),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym__statement_no_case_no_default] = STATE(727),
    [sym_labeled_statement] = STATE(727),
    [sym_label] = STATE(391),
    [sym_block_statement] = STATE(1917),
    [sym_expression_statement] = STATE(727),
    [sym_if_statement] = STATE(727),
    [sym_while_statement] = STATE(727),
    [sym_do_statement] = STATE(727),
    [sym_for_statement] = STATE(727),
    [sym__foreach] = STATE(6541),
    [sym_foreach_statement] = STATE(727),
    [sym_switch_statement] = STATE(727),
    [sym_final_switch_statement] = STATE(727),
    [sym_continue_statement] = STATE(727),
    [sym_break_statement] = STATE(727),
    [sym_return_statement] = STATE(727),
    [sym_goto_statement] = STATE(727),
    [sym_with_statement] = STATE(727),
    [sym_synchronized_statement] = STATE(727),
    [sym_try_statement] = STATE(727),
    [sym_scope_guard_statement] = STATE(727),
    [sym_asm_statement] = STATE(727),
    [sym_struct_declaration] = STATE(727),
    [sym_union_declaration] = STATE(727),
    [sym_postblit] = STATE(727),
    [sym_invariant_declaration] = STATE(727),
    [sym_class_declaration] = STATE(727),
    [sym_constructor] = STATE(727),
    [sym_destructor] = STATE(727),
    [sym_alias_this] = STATE(727),
    [sym_interface_declaration] = STATE(727),
    [sym_enum_declaration] = STATE(727),
    [sym_anonymous_enum_declaration] = STATE(727),
    [sym_function_declaration] = STATE(727),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_declaration] = STATE(727),
    [sym_template_instance] = STATE(2982),
    [sym_mixin_template_declaration] = STATE(727),
    [sym_template_mixin] = STATE(727),
    [sym_conditional_declaration] = STATE(727),
    [sym_conditional_statement] = STATE(727),
    [sym_condition] = STATE(72),
    [sym_version_condition] = STATE(1694),
    [sym_version_specification] = STATE(1961),
    [sym_debug_condition] = STATE(1694),
    [sym_debug_specification] = STATE(1961),
    [sym_static_if_condition] = STATE(1694),
    [sym_static_foreach_statement] = STATE(727),
    [sym_static_foreach_declaration] = STATE(727),
    [sym_static_assert] = STATE(1961),
    [sym_traits_expression] = STATE(2950),
    [sym_unittest_declaration] = STATE(727),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(1230),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(660),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(2167),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(679),
    [sym_abstract] = ACTIONS(2119),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(2121),
    [sym_asm] = ACTIONS(689),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(2123),
    [sym_break] = ACTIONS(694),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(2125),
    [sym_continue] = ACTIONS(701),
    [sym_debug] = ACTIONS(703),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(2127),
    [sym_do] = ACTIONS(708),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(2129),
    [sym_extern] = ACTIONS(2131),
    [sym_final] = ACTIONS(2133),
    [sym_for] = ACTIONS(721),
    [sym_foreach] = ACTIONS(723),
    [sym_foreach_reverse] = ACTIONS(723),
    [sym_function] = ACTIONS(147),
    [sym_goto] = ACTIONS(725),
    [sym_if] = ACTIONS(727),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(729),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(1240),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(2119),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(2119),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(169),
    [sym_private] = ACTIONS(2129),
    [sym_protected] = ACTIONS(2129),
    [sym_public] = ACTIONS(2129),
    [sym_pure] = ACTIONS(2119),
    [sym_ref] = ACTIONS(2135),
    [sym_return] = ACTIONS(2137),
    [sym_scope] = ACTIONS(2139),
    [sym_shared] = ACTIONS(2141),
    [sym_static] = ACTIONS(2143),
    [sym_struct] = ACTIONS(752),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(2145),
    [sym_template] = ACTIONS(759),
    [sym_throw] = ACTIONS(189),
    [sym_try] = ACTIONS(761),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(770),
    [sym_while] = ACTIONS(772),
    [sym_with] = ACTIONS(774),
    [sym_gshared] = ACTIONS(2119),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [522] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5608),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5608),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(2169),
    [anon_sym_q_LBRACE] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2177),
    [anon_sym_DOT] = ACTIONS(2180),
    [anon_sym_AMP] = ACTIONS(2183),
    [anon_sym_DASH] = ACTIONS(2186),
    [anon_sym_DASH_DASH] = ACTIONS(2183),
    [anon_sym_PLUS] = ACTIONS(2186),
    [anon_sym_PLUS_PLUS] = ACTIONS(2183),
    [anon_sym_BANG] = ACTIONS(2183),
    [anon_sym_LPAREN] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2192),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOLLAR] = ACTIONS(2195),
    [anon_sym_STAR] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(2183),
    [anon_sym_AT] = ACTIONS(2175),
    [sym_bool] = ACTIONS(2198),
    [sym_byte] = ACTIONS(2198),
    [sym_ubyte] = ACTIONS(2198),
    [sym_char] = ACTIONS(2198),
    [sym_short] = ACTIONS(2198),
    [sym_ushort] = ACTIONS(2198),
    [sym_int] = ACTIONS(2198),
    [sym_uint] = ACTIONS(2198),
    [sym_long] = ACTIONS(2198),
    [sym_ulong] = ACTIONS(2198),
    [sym_cent] = ACTIONS(2198),
    [sym_ucent] = ACTIONS(2198),
    [sym_wchar] = ACTIONS(2198),
    [sym_dchar] = ACTIONS(2198),
    [sym_float] = ACTIONS(2198),
    [sym_double] = ACTIONS(2198),
    [sym_real] = ACTIONS(2198),
    [sym_ifloat] = ACTIONS(2198),
    [sym_idouble] = ACTIONS(2198),
    [sym_ireal] = ACTIONS(2198),
    [sym_cfloat] = ACTIONS(2198),
    [sym_cdouble] = ACTIONS(2198),
    [sym_creal] = ACTIONS(2198),
    [sym_size_t] = ACTIONS(2198),
    [sym_ptrdiff_t] = ACTIONS(2198),
    [sym_string] = ACTIONS(2198),
    [sym_cstring] = ACTIONS(2198),
    [sym_dstring] = ACTIONS(2198),
    [sym_wstring] = ACTIONS(2198),
    [sym_noreturn] = ACTIONS(2198),
    [sym_true] = ACTIONS(2201),
    [sym_false] = ACTIONS(2201),
    [sym_null] = ACTIONS(2201),
    [sym_super] = ACTIONS(2201),
    [sym_this] = ACTIONS(2201),
    [sym_abstract] = ACTIONS(2204),
    [sym_alias] = ACTIONS(2204),
    [sym_align] = ACTIONS(2204),
    [sym_asm] = ACTIONS(2204),
    [sym_assert] = ACTIONS(2206),
    [sym_auto] = ACTIONS(2209),
    [sym_break] = ACTIONS(2204),
    [sym_case] = ACTIONS(2204),
    [sym_cast] = ACTIONS(2212),
    [sym_class] = ACTIONS(2204),
    [sym_const] = ACTIONS(2215),
    [sym_continue] = ACTIONS(2204),
    [sym_debug] = ACTIONS(2204),
    [sym_default] = ACTIONS(2204),
    [sym_delegate] = ACTIONS(2218),
    [sym_delete] = ACTIONS(2221),
    [sym_deprecated] = ACTIONS(2204),
    [sym_do] = ACTIONS(2224),
    [sym_enum] = ACTIONS(2204),
    [sym_export] = ACTIONS(2204),
    [sym_extern] = ACTIONS(2204),
    [sym_final] = ACTIONS(2204),
    [sym_for] = ACTIONS(2204),
    [sym_foreach] = ACTIONS(2204),
    [sym_foreach_reverse] = ACTIONS(2204),
    [sym_function] = ACTIONS(2227),
    [sym_goto] = ACTIONS(2204),
    [sym_if] = ACTIONS(2204),
    [sym_immutable] = ACTIONS(2215),
    [sym_import] = ACTIONS(2230),
    [sym_in] = ACTIONS(2233),
    [sym_inout] = ACTIONS(2215),
    [sym_interface] = ACTIONS(2204),
    [sym_invariant] = ACTIONS(2204),
    [sym_is] = ACTIONS(2236),
    [sym_mixin] = ACTIONS(2239),
    [sym_new] = ACTIONS(2242),
    [sym_nothrow] = ACTIONS(2204),
    [sym_out] = ACTIONS(2245),
    [sym_override] = ACTIONS(2204),
    [sym_package] = ACTIONS(2204),
    [sym_pragma] = ACTIONS(2204),
    [sym_private] = ACTIONS(2204),
    [sym_protected] = ACTIONS(2204),
    [sym_public] = ACTIONS(2204),
    [sym_pure] = ACTIONS(2204),
    [sym_ref] = ACTIONS(2248),
    [sym_return] = ACTIONS(2204),
    [sym_scope] = ACTIONS(2204),
    [sym_shared] = ACTIONS(2215),
    [sym_static] = ACTIONS(2204),
    [sym_struct] = ACTIONS(2204),
    [sym_switch] = ACTIONS(2204),
    [sym_synchronized] = ACTIONS(2204),
    [sym_template] = ACTIONS(2204),
    [sym_throw] = ACTIONS(2251),
    [sym_try] = ACTIONS(2204),
    [sym_typeid] = ACTIONS(2254),
    [sym_typeof] = ACTIONS(2257),
    [sym_union] = ACTIONS(2204),
    [sym_unittest] = ACTIONS(2204),
    [sym_version] = ACTIONS(2204),
    [sym_while] = ACTIONS(2204),
    [sym_with] = ACTIONS(2204),
    [sym_gshared] = ACTIONS(2204),
    [sym_traits] = ACTIONS(2260),
    [sym_vector] = ACTIONS(2263),
    [sym_void] = ACTIONS(2266),
    [anon_sym_BQUOTE] = ACTIONS(2269),
    [anon_sym_r_DQUOTE] = ACTIONS(2272),
    [anon_sym_x_DQUOTE] = ACTIONS(2275),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_i_BQUOTE] = ACTIONS(2281),
    [anon_sym_i_DQUOTE] = ACTIONS(2284),
    [anon_sym_iq_LBRACE] = ACTIONS(2287),
    [aux_sym_char_literal_token1] = ACTIONS(2290),
    [anon_sym_SQUOTE] = ACTIONS(2293),
    [anon_sym___DATE__] = ACTIONS(2296),
    [anon_sym___FILE__] = ACTIONS(2296),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2296),
    [anon_sym___FUNCTION__] = ACTIONS(2296),
    [anon_sym___LINE__] = ACTIONS(2296),
    [anon_sym___MODULE__] = ACTIONS(2296),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2296),
    [anon_sym___TIME__] = ACTIONS(2296),
    [anon_sym___TIMESTAMP__] = ACTIONS(2296),
    [anon_sym___VENDOR__] = ACTIONS(2296),
    [anon_sym___VERSION__] = ACTIONS(2296),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2299),
    [sym_float_literal] = ACTIONS(2299),
    [sym__string] = ACTIONS(2302),
  },
  [523] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(540),
    [sym__token_no_braces] = STATE(540),
    [sym_keyword] = STATE(540),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(540),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(540),
    [sym_string_literal] = STATE(540),
    [sym_char_literal] = STATE(540),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2305),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2309),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2305),
    [anon_sym_SLASH_EQ] = ACTIONS(2313),
    [anon_sym_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT] = ACTIONS(2305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2305),
    [anon_sym_AMP_EQ] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_PIPE_EQ] = ACTIONS(2313),
    [anon_sym_PIPE_PIPE] = ACTIONS(2313),
    [anon_sym_DASH] = ACTIONS(2305),
    [anon_sym_DASH_EQ] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2305),
    [anon_sym_PLUS_EQ] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2313),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_LT_LT_EQ] = ACTIONS(2313),
    [anon_sym_GT] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2305),
    [anon_sym_GT_GT_GT] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_LPAREN] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2313),
    [anon_sym_RBRACK] = ACTIONS(2313),
    [anon_sym_QMARK] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2313),
    [anon_sym_COLON] = ACTIONS(2313),
    [anon_sym_DOLLAR] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_STAR] = ACTIONS(2305),
    [anon_sym_STAR_EQ] = ACTIONS(2313),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_PERCENT_EQ] = ACTIONS(2313),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_CARET_EQ] = ACTIONS(2313),
    [anon_sym_CARET_CARET] = ACTIONS(2305),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2313),
    [anon_sym_TILDE] = ACTIONS(2305),
    [anon_sym_TILDE_EQ] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2313),
    [anon_sym_POUND] = ACTIONS(2313),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2313),
    [sym_float_literal] = ACTIONS(2313),
    [sym__string] = ACTIONS(2341),
  },
  [524] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [525] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2349),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [526] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(524),
    [sym__token_no_braces] = STATE(524),
    [sym_keyword] = STATE(524),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(524),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(524),
    [sym_string_literal] = STATE(524),
    [sym_char_literal] = STATE(524),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2351),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2353),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2351),
    [anon_sym_SLASH_EQ] = ACTIONS(2355),
    [anon_sym_DOT] = ACTIONS(2351),
    [anon_sym_DOT_DOT] = ACTIONS(2351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2355),
    [anon_sym_AMP] = ACTIONS(2351),
    [anon_sym_AMP_EQ] = ACTIONS(2355),
    [anon_sym_AMP_AMP] = ACTIONS(2355),
    [anon_sym_PIPE] = ACTIONS(2351),
    [anon_sym_PIPE_EQ] = ACTIONS(2355),
    [anon_sym_PIPE_PIPE] = ACTIONS(2355),
    [anon_sym_DASH] = ACTIONS(2351),
    [anon_sym_DASH_EQ] = ACTIONS(2355),
    [anon_sym_DASH_DASH] = ACTIONS(2355),
    [anon_sym_PLUS] = ACTIONS(2351),
    [anon_sym_PLUS_EQ] = ACTIONS(2355),
    [anon_sym_PLUS_PLUS] = ACTIONS(2355),
    [anon_sym_LT] = ACTIONS(2351),
    [anon_sym_LT_EQ] = ACTIONS(2355),
    [anon_sym_LT_LT] = ACTIONS(2351),
    [anon_sym_LT_LT_EQ] = ACTIONS(2355),
    [anon_sym_GT] = ACTIONS(2351),
    [anon_sym_GT_EQ] = ACTIONS(2355),
    [anon_sym_GT_GT_EQ] = ACTIONS(2355),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2355),
    [anon_sym_GT_GT] = ACTIONS(2351),
    [anon_sym_GT_GT_GT] = ACTIONS(2351),
    [anon_sym_BANG] = ACTIONS(2351),
    [anon_sym_BANG_EQ] = ACTIONS(2355),
    [anon_sym_LPAREN] = ACTIONS(2355),
    [anon_sym_RPAREN] = ACTIONS(2355),
    [anon_sym_LBRACK] = ACTIONS(2355),
    [anon_sym_RBRACK] = ACTIONS(2355),
    [anon_sym_QMARK] = ACTIONS(2355),
    [anon_sym_COMMA] = ACTIONS(2355),
    [anon_sym_SEMI] = ACTIONS(2355),
    [anon_sym_COLON] = ACTIONS(2355),
    [anon_sym_DOLLAR] = ACTIONS(2351),
    [anon_sym_EQ] = ACTIONS(2351),
    [anon_sym_EQ_EQ] = ACTIONS(2355),
    [anon_sym_STAR] = ACTIONS(2351),
    [anon_sym_STAR_EQ] = ACTIONS(2355),
    [anon_sym_PERCENT] = ACTIONS(2351),
    [anon_sym_PERCENT_EQ] = ACTIONS(2355),
    [anon_sym_CARET] = ACTIONS(2351),
    [anon_sym_CARET_EQ] = ACTIONS(2355),
    [anon_sym_CARET_CARET] = ACTIONS(2351),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2355),
    [anon_sym_TILDE] = ACTIONS(2351),
    [anon_sym_TILDE_EQ] = ACTIONS(2355),
    [anon_sym_AT] = ACTIONS(2355),
    [anon_sym_EQ_GT] = ACTIONS(2355),
    [anon_sym_POUND] = ACTIONS(2355),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2355),
    [sym_float_literal] = ACTIONS(2355),
    [sym__string] = ACTIONS(2341),
  },
  [527] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(531),
    [sym__token_no_braces] = STATE(531),
    [sym_keyword] = STATE(531),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(531),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(531),
    [sym_string_literal] = STATE(531),
    [sym_char_literal] = STATE(531),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2359),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2357),
    [anon_sym_SLASH_EQ] = ACTIONS(2361),
    [anon_sym_DOT] = ACTIONS(2357),
    [anon_sym_DOT_DOT] = ACTIONS(2357),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2361),
    [anon_sym_AMP] = ACTIONS(2357),
    [anon_sym_AMP_EQ] = ACTIONS(2361),
    [anon_sym_AMP_AMP] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(2357),
    [anon_sym_PIPE_EQ] = ACTIONS(2361),
    [anon_sym_PIPE_PIPE] = ACTIONS(2361),
    [anon_sym_DASH] = ACTIONS(2357),
    [anon_sym_DASH_EQ] = ACTIONS(2361),
    [anon_sym_DASH_DASH] = ACTIONS(2361),
    [anon_sym_PLUS] = ACTIONS(2357),
    [anon_sym_PLUS_EQ] = ACTIONS(2361),
    [anon_sym_PLUS_PLUS] = ACTIONS(2361),
    [anon_sym_LT] = ACTIONS(2357),
    [anon_sym_LT_EQ] = ACTIONS(2361),
    [anon_sym_LT_LT] = ACTIONS(2357),
    [anon_sym_LT_LT_EQ] = ACTIONS(2361),
    [anon_sym_GT] = ACTIONS(2357),
    [anon_sym_GT_EQ] = ACTIONS(2361),
    [anon_sym_GT_GT_EQ] = ACTIONS(2361),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2361),
    [anon_sym_GT_GT] = ACTIONS(2357),
    [anon_sym_GT_GT_GT] = ACTIONS(2357),
    [anon_sym_BANG] = ACTIONS(2357),
    [anon_sym_BANG_EQ] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(2361),
    [anon_sym_RPAREN] = ACTIONS(2361),
    [anon_sym_LBRACK] = ACTIONS(2361),
    [anon_sym_RBRACK] = ACTIONS(2361),
    [anon_sym_QMARK] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2361),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_COLON] = ACTIONS(2361),
    [anon_sym_DOLLAR] = ACTIONS(2357),
    [anon_sym_EQ] = ACTIONS(2357),
    [anon_sym_EQ_EQ] = ACTIONS(2361),
    [anon_sym_STAR] = ACTIONS(2357),
    [anon_sym_STAR_EQ] = ACTIONS(2361),
    [anon_sym_PERCENT] = ACTIONS(2357),
    [anon_sym_PERCENT_EQ] = ACTIONS(2361),
    [anon_sym_CARET] = ACTIONS(2357),
    [anon_sym_CARET_EQ] = ACTIONS(2361),
    [anon_sym_CARET_CARET] = ACTIONS(2357),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2361),
    [anon_sym_TILDE] = ACTIONS(2357),
    [anon_sym_TILDE_EQ] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(2361),
    [anon_sym_EQ_GT] = ACTIONS(2361),
    [anon_sym_POUND] = ACTIONS(2361),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2361),
    [sym_float_literal] = ACTIONS(2361),
    [sym__string] = ACTIONS(2341),
  },
  [528] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(547),
    [sym__token_no_braces] = STATE(547),
    [sym_keyword] = STATE(547),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(547),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(547),
    [sym_string_literal] = STATE(547),
    [sym_char_literal] = STATE(547),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2363),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2363),
    [anon_sym_SLASH_EQ] = ACTIONS(2367),
    [anon_sym_DOT] = ACTIONS(2363),
    [anon_sym_DOT_DOT] = ACTIONS(2363),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2367),
    [anon_sym_AMP] = ACTIONS(2363),
    [anon_sym_AMP_EQ] = ACTIONS(2367),
    [anon_sym_AMP_AMP] = ACTIONS(2367),
    [anon_sym_PIPE] = ACTIONS(2363),
    [anon_sym_PIPE_EQ] = ACTIONS(2367),
    [anon_sym_PIPE_PIPE] = ACTIONS(2367),
    [anon_sym_DASH] = ACTIONS(2363),
    [anon_sym_DASH_EQ] = ACTIONS(2367),
    [anon_sym_DASH_DASH] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2363),
    [anon_sym_PLUS_EQ] = ACTIONS(2367),
    [anon_sym_PLUS_PLUS] = ACTIONS(2367),
    [anon_sym_LT] = ACTIONS(2363),
    [anon_sym_LT_EQ] = ACTIONS(2367),
    [anon_sym_LT_LT] = ACTIONS(2363),
    [anon_sym_LT_LT_EQ] = ACTIONS(2367),
    [anon_sym_GT] = ACTIONS(2363),
    [anon_sym_GT_EQ] = ACTIONS(2367),
    [anon_sym_GT_GT_EQ] = ACTIONS(2367),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2367),
    [anon_sym_GT_GT] = ACTIONS(2363),
    [anon_sym_GT_GT_GT] = ACTIONS(2363),
    [anon_sym_BANG] = ACTIONS(2363),
    [anon_sym_BANG_EQ] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2367),
    [anon_sym_RPAREN] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2367),
    [anon_sym_RBRACK] = ACTIONS(2367),
    [anon_sym_QMARK] = ACTIONS(2367),
    [anon_sym_COMMA] = ACTIONS(2367),
    [anon_sym_SEMI] = ACTIONS(2367),
    [anon_sym_COLON] = ACTIONS(2367),
    [anon_sym_DOLLAR] = ACTIONS(2363),
    [anon_sym_EQ] = ACTIONS(2363),
    [anon_sym_EQ_EQ] = ACTIONS(2367),
    [anon_sym_STAR] = ACTIONS(2363),
    [anon_sym_STAR_EQ] = ACTIONS(2367),
    [anon_sym_PERCENT] = ACTIONS(2363),
    [anon_sym_PERCENT_EQ] = ACTIONS(2367),
    [anon_sym_CARET] = ACTIONS(2363),
    [anon_sym_CARET_EQ] = ACTIONS(2367),
    [anon_sym_CARET_CARET] = ACTIONS(2363),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2367),
    [anon_sym_TILDE] = ACTIONS(2363),
    [anon_sym_TILDE_EQ] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2367),
    [anon_sym_EQ_GT] = ACTIONS(2367),
    [anon_sym_POUND] = ACTIONS(2367),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2367),
    [sym_float_literal] = ACTIONS(2367),
    [sym__string] = ACTIONS(2341),
  },
  [529] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(532),
    [sym__token_no_braces] = STATE(532),
    [sym_keyword] = STATE(532),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(532),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(532),
    [sym_string_literal] = STATE(532),
    [sym_char_literal] = STATE(532),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2369),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2369),
    [anon_sym_SLASH_EQ] = ACTIONS(2373),
    [anon_sym_DOT] = ACTIONS(2369),
    [anon_sym_DOT_DOT] = ACTIONS(2369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2373),
    [anon_sym_AMP] = ACTIONS(2369),
    [anon_sym_AMP_EQ] = ACTIONS(2373),
    [anon_sym_AMP_AMP] = ACTIONS(2373),
    [anon_sym_PIPE] = ACTIONS(2369),
    [anon_sym_PIPE_EQ] = ACTIONS(2373),
    [anon_sym_PIPE_PIPE] = ACTIONS(2373),
    [anon_sym_DASH] = ACTIONS(2369),
    [anon_sym_DASH_EQ] = ACTIONS(2373),
    [anon_sym_DASH_DASH] = ACTIONS(2373),
    [anon_sym_PLUS] = ACTIONS(2369),
    [anon_sym_PLUS_EQ] = ACTIONS(2373),
    [anon_sym_PLUS_PLUS] = ACTIONS(2373),
    [anon_sym_LT] = ACTIONS(2369),
    [anon_sym_LT_EQ] = ACTIONS(2373),
    [anon_sym_LT_LT] = ACTIONS(2369),
    [anon_sym_LT_LT_EQ] = ACTIONS(2373),
    [anon_sym_GT] = ACTIONS(2369),
    [anon_sym_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2373),
    [anon_sym_GT_GT] = ACTIONS(2369),
    [anon_sym_GT_GT_GT] = ACTIONS(2369),
    [anon_sym_BANG] = ACTIONS(2369),
    [anon_sym_BANG_EQ] = ACTIONS(2373),
    [anon_sym_LPAREN] = ACTIONS(2373),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_LBRACK] = ACTIONS(2373),
    [anon_sym_RBRACK] = ACTIONS(2373),
    [anon_sym_QMARK] = ACTIONS(2373),
    [anon_sym_COMMA] = ACTIONS(2373),
    [anon_sym_SEMI] = ACTIONS(2373),
    [anon_sym_COLON] = ACTIONS(2373),
    [anon_sym_DOLLAR] = ACTIONS(2369),
    [anon_sym_EQ] = ACTIONS(2369),
    [anon_sym_EQ_EQ] = ACTIONS(2373),
    [anon_sym_STAR] = ACTIONS(2369),
    [anon_sym_STAR_EQ] = ACTIONS(2373),
    [anon_sym_PERCENT] = ACTIONS(2369),
    [anon_sym_PERCENT_EQ] = ACTIONS(2373),
    [anon_sym_CARET] = ACTIONS(2369),
    [anon_sym_CARET_EQ] = ACTIONS(2373),
    [anon_sym_CARET_CARET] = ACTIONS(2369),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2373),
    [anon_sym_TILDE] = ACTIONS(2369),
    [anon_sym_TILDE_EQ] = ACTIONS(2373),
    [anon_sym_AT] = ACTIONS(2373),
    [anon_sym_EQ_GT] = ACTIONS(2373),
    [anon_sym_POUND] = ACTIONS(2373),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2373),
    [sym_float_literal] = ACTIONS(2373),
    [sym__string] = ACTIONS(2341),
  },
  [530] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [531] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2377),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [532] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2379),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [533] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(535),
    [sym__token_no_braces] = STATE(535),
    [sym_keyword] = STATE(535),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(535),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(535),
    [sym_string_literal] = STATE(535),
    [sym_char_literal] = STATE(535),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2381),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2381),
    [anon_sym_SLASH_EQ] = ACTIONS(2385),
    [anon_sym_DOT] = ACTIONS(2381),
    [anon_sym_DOT_DOT] = ACTIONS(2381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2385),
    [anon_sym_AMP] = ACTIONS(2381),
    [anon_sym_AMP_EQ] = ACTIONS(2385),
    [anon_sym_AMP_AMP] = ACTIONS(2385),
    [anon_sym_PIPE] = ACTIONS(2381),
    [anon_sym_PIPE_EQ] = ACTIONS(2385),
    [anon_sym_PIPE_PIPE] = ACTIONS(2385),
    [anon_sym_DASH] = ACTIONS(2381),
    [anon_sym_DASH_EQ] = ACTIONS(2385),
    [anon_sym_DASH_DASH] = ACTIONS(2385),
    [anon_sym_PLUS] = ACTIONS(2381),
    [anon_sym_PLUS_EQ] = ACTIONS(2385),
    [anon_sym_PLUS_PLUS] = ACTIONS(2385),
    [anon_sym_LT] = ACTIONS(2381),
    [anon_sym_LT_EQ] = ACTIONS(2385),
    [anon_sym_LT_LT] = ACTIONS(2381),
    [anon_sym_LT_LT_EQ] = ACTIONS(2385),
    [anon_sym_GT] = ACTIONS(2381),
    [anon_sym_GT_EQ] = ACTIONS(2385),
    [anon_sym_GT_GT_EQ] = ACTIONS(2385),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2385),
    [anon_sym_GT_GT] = ACTIONS(2381),
    [anon_sym_GT_GT_GT] = ACTIONS(2381),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_BANG_EQ] = ACTIONS(2385),
    [anon_sym_LPAREN] = ACTIONS(2385),
    [anon_sym_RPAREN] = ACTIONS(2385),
    [anon_sym_LBRACK] = ACTIONS(2385),
    [anon_sym_RBRACK] = ACTIONS(2385),
    [anon_sym_QMARK] = ACTIONS(2385),
    [anon_sym_COMMA] = ACTIONS(2385),
    [anon_sym_SEMI] = ACTIONS(2385),
    [anon_sym_COLON] = ACTIONS(2385),
    [anon_sym_DOLLAR] = ACTIONS(2381),
    [anon_sym_EQ] = ACTIONS(2381),
    [anon_sym_EQ_EQ] = ACTIONS(2385),
    [anon_sym_STAR] = ACTIONS(2381),
    [anon_sym_STAR_EQ] = ACTIONS(2385),
    [anon_sym_PERCENT] = ACTIONS(2381),
    [anon_sym_PERCENT_EQ] = ACTIONS(2385),
    [anon_sym_CARET] = ACTIONS(2381),
    [anon_sym_CARET_EQ] = ACTIONS(2385),
    [anon_sym_CARET_CARET] = ACTIONS(2381),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2385),
    [anon_sym_TILDE] = ACTIONS(2381),
    [anon_sym_TILDE_EQ] = ACTIONS(2385),
    [anon_sym_AT] = ACTIONS(2385),
    [anon_sym_EQ_GT] = ACTIONS(2385),
    [anon_sym_POUND] = ACTIONS(2385),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2385),
    [sym_float_literal] = ACTIONS(2385),
    [sym__string] = ACTIONS(2341),
  },
  [534] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2387),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [535] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2389),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [536] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(544),
    [sym__token_no_braces] = STATE(544),
    [sym_keyword] = STATE(544),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(544),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(544),
    [sym_string_literal] = STATE(544),
    [sym_char_literal] = STATE(544),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2391),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2393),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2391),
    [anon_sym_SLASH_EQ] = ACTIONS(2395),
    [anon_sym_DOT] = ACTIONS(2391),
    [anon_sym_DOT_DOT] = ACTIONS(2391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2395),
    [anon_sym_AMP] = ACTIONS(2391),
    [anon_sym_AMP_EQ] = ACTIONS(2395),
    [anon_sym_AMP_AMP] = ACTIONS(2395),
    [anon_sym_PIPE] = ACTIONS(2391),
    [anon_sym_PIPE_EQ] = ACTIONS(2395),
    [anon_sym_PIPE_PIPE] = ACTIONS(2395),
    [anon_sym_DASH] = ACTIONS(2391),
    [anon_sym_DASH_EQ] = ACTIONS(2395),
    [anon_sym_DASH_DASH] = ACTIONS(2395),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_PLUS_EQ] = ACTIONS(2395),
    [anon_sym_PLUS_PLUS] = ACTIONS(2395),
    [anon_sym_LT] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2395),
    [anon_sym_LT_LT] = ACTIONS(2391),
    [anon_sym_LT_LT_EQ] = ACTIONS(2395),
    [anon_sym_GT] = ACTIONS(2391),
    [anon_sym_GT_EQ] = ACTIONS(2395),
    [anon_sym_GT_GT_EQ] = ACTIONS(2395),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2395),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_GT_GT_GT] = ACTIONS(2391),
    [anon_sym_BANG] = ACTIONS(2391),
    [anon_sym_BANG_EQ] = ACTIONS(2395),
    [anon_sym_LPAREN] = ACTIONS(2395),
    [anon_sym_RPAREN] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(2395),
    [anon_sym_RBRACK] = ACTIONS(2395),
    [anon_sym_QMARK] = ACTIONS(2395),
    [anon_sym_COMMA] = ACTIONS(2395),
    [anon_sym_SEMI] = ACTIONS(2395),
    [anon_sym_COLON] = ACTIONS(2395),
    [anon_sym_DOLLAR] = ACTIONS(2391),
    [anon_sym_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ] = ACTIONS(2395),
    [anon_sym_STAR] = ACTIONS(2391),
    [anon_sym_STAR_EQ] = ACTIONS(2395),
    [anon_sym_PERCENT] = ACTIONS(2391),
    [anon_sym_PERCENT_EQ] = ACTIONS(2395),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_CARET_EQ] = ACTIONS(2395),
    [anon_sym_CARET_CARET] = ACTIONS(2391),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2395),
    [anon_sym_TILDE] = ACTIONS(2391),
    [anon_sym_TILDE_EQ] = ACTIONS(2395),
    [anon_sym_AT] = ACTIONS(2395),
    [anon_sym_EQ_GT] = ACTIONS(2395),
    [anon_sym_POUND] = ACTIONS(2395),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2395),
    [sym_float_literal] = ACTIONS(2395),
    [sym__string] = ACTIONS(2341),
  },
  [537] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [538] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(545),
    [sym__token_no_braces] = STATE(545),
    [sym_keyword] = STATE(545),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(545),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(545),
    [sym_string_literal] = STATE(545),
    [sym_char_literal] = STATE(545),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2399),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2399),
    [anon_sym_SLASH_EQ] = ACTIONS(2403),
    [anon_sym_DOT] = ACTIONS(2399),
    [anon_sym_DOT_DOT] = ACTIONS(2399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2403),
    [anon_sym_AMP] = ACTIONS(2399),
    [anon_sym_AMP_EQ] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_PIPE_EQ] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_DASH] = ACTIONS(2399),
    [anon_sym_DASH_EQ] = ACTIONS(2403),
    [anon_sym_DASH_DASH] = ACTIONS(2403),
    [anon_sym_PLUS] = ACTIONS(2399),
    [anon_sym_PLUS_EQ] = ACTIONS(2403),
    [anon_sym_PLUS_PLUS] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_LT_EQ] = ACTIONS(2403),
    [anon_sym_LT_LT] = ACTIONS(2399),
    [anon_sym_LT_LT_EQ] = ACTIONS(2403),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_EQ] = ACTIONS(2403),
    [anon_sym_GT_GT_EQ] = ACTIONS(2403),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2403),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_GT_GT_GT] = ACTIONS(2399),
    [anon_sym_BANG] = ACTIONS(2399),
    [anon_sym_BANG_EQ] = ACTIONS(2403),
    [anon_sym_LPAREN] = ACTIONS(2403),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_LBRACK] = ACTIONS(2403),
    [anon_sym_RBRACK] = ACTIONS(2403),
    [anon_sym_QMARK] = ACTIONS(2403),
    [anon_sym_COMMA] = ACTIONS(2403),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_COLON] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_EQ] = ACTIONS(2399),
    [anon_sym_EQ_EQ] = ACTIONS(2403),
    [anon_sym_STAR] = ACTIONS(2399),
    [anon_sym_STAR_EQ] = ACTIONS(2403),
    [anon_sym_PERCENT] = ACTIONS(2399),
    [anon_sym_PERCENT_EQ] = ACTIONS(2403),
    [anon_sym_CARET] = ACTIONS(2399),
    [anon_sym_CARET_EQ] = ACTIONS(2403),
    [anon_sym_CARET_CARET] = ACTIONS(2399),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2403),
    [anon_sym_TILDE] = ACTIONS(2399),
    [anon_sym_TILDE_EQ] = ACTIONS(2403),
    [anon_sym_AT] = ACTIONS(2403),
    [anon_sym_EQ_GT] = ACTIONS(2403),
    [anon_sym_POUND] = ACTIONS(2403),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2403),
    [sym_float_literal] = ACTIONS(2403),
    [sym__string] = ACTIONS(2341),
  },
  [539] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(534),
    [sym__token_no_braces] = STATE(534),
    [sym_keyword] = STATE(534),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(534),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(534),
    [sym_string_literal] = STATE(534),
    [sym_char_literal] = STATE(534),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2405),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2405),
    [anon_sym_SLASH_EQ] = ACTIONS(2409),
    [anon_sym_DOT] = ACTIONS(2405),
    [anon_sym_DOT_DOT] = ACTIONS(2405),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2409),
    [anon_sym_AMP] = ACTIONS(2405),
    [anon_sym_AMP_EQ] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_PIPE_EQ] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_DASH] = ACTIONS(2405),
    [anon_sym_DASH_EQ] = ACTIONS(2409),
    [anon_sym_DASH_DASH] = ACTIONS(2409),
    [anon_sym_PLUS] = ACTIONS(2405),
    [anon_sym_PLUS_EQ] = ACTIONS(2409),
    [anon_sym_PLUS_PLUS] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_LT_EQ] = ACTIONS(2409),
    [anon_sym_LT_LT] = ACTIONS(2405),
    [anon_sym_LT_LT_EQ] = ACTIONS(2409),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_EQ] = ACTIONS(2409),
    [anon_sym_GT_GT_EQ] = ACTIONS(2409),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2409),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_GT_GT_GT] = ACTIONS(2405),
    [anon_sym_BANG] = ACTIONS(2405),
    [anon_sym_BANG_EQ] = ACTIONS(2409),
    [anon_sym_LPAREN] = ACTIONS(2409),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [anon_sym_LBRACK] = ACTIONS(2409),
    [anon_sym_RBRACK] = ACTIONS(2409),
    [anon_sym_QMARK] = ACTIONS(2409),
    [anon_sym_COMMA] = ACTIONS(2409),
    [anon_sym_SEMI] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_EQ] = ACTIONS(2405),
    [anon_sym_EQ_EQ] = ACTIONS(2409),
    [anon_sym_STAR] = ACTIONS(2405),
    [anon_sym_STAR_EQ] = ACTIONS(2409),
    [anon_sym_PERCENT] = ACTIONS(2405),
    [anon_sym_PERCENT_EQ] = ACTIONS(2409),
    [anon_sym_CARET] = ACTIONS(2405),
    [anon_sym_CARET_EQ] = ACTIONS(2409),
    [anon_sym_CARET_CARET] = ACTIONS(2405),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2409),
    [anon_sym_TILDE] = ACTIONS(2405),
    [anon_sym_TILDE_EQ] = ACTIONS(2409),
    [anon_sym_AT] = ACTIONS(2409),
    [anon_sym_EQ_GT] = ACTIONS(2409),
    [anon_sym_POUND] = ACTIONS(2409),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2409),
    [sym_float_literal] = ACTIONS(2409),
    [sym__string] = ACTIONS(2341),
  },
  [540] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2411),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [541] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(537),
    [sym__token_no_braces] = STATE(537),
    [sym_keyword] = STATE(537),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(537),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(537),
    [sym_string_literal] = STATE(537),
    [sym_char_literal] = STATE(537),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2413),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2415),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2413),
    [anon_sym_SLASH_EQ] = ACTIONS(2417),
    [anon_sym_DOT] = ACTIONS(2413),
    [anon_sym_DOT_DOT] = ACTIONS(2413),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2417),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_AMP_EQ] = ACTIONS(2417),
    [anon_sym_AMP_AMP] = ACTIONS(2417),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_PIPE_EQ] = ACTIONS(2417),
    [anon_sym_PIPE_PIPE] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(2413),
    [anon_sym_DASH_EQ] = ACTIONS(2417),
    [anon_sym_DASH_DASH] = ACTIONS(2417),
    [anon_sym_PLUS] = ACTIONS(2413),
    [anon_sym_PLUS_EQ] = ACTIONS(2417),
    [anon_sym_PLUS_PLUS] = ACTIONS(2417),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_LT_EQ] = ACTIONS(2417),
    [anon_sym_LT_LT] = ACTIONS(2413),
    [anon_sym_LT_LT_EQ] = ACTIONS(2417),
    [anon_sym_GT] = ACTIONS(2413),
    [anon_sym_GT_EQ] = ACTIONS(2417),
    [anon_sym_GT_GT_EQ] = ACTIONS(2417),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2417),
    [anon_sym_GT_GT] = ACTIONS(2413),
    [anon_sym_GT_GT_GT] = ACTIONS(2413),
    [anon_sym_BANG] = ACTIONS(2413),
    [anon_sym_BANG_EQ] = ACTIONS(2417),
    [anon_sym_LPAREN] = ACTIONS(2417),
    [anon_sym_RPAREN] = ACTIONS(2417),
    [anon_sym_LBRACK] = ACTIONS(2417),
    [anon_sym_RBRACK] = ACTIONS(2417),
    [anon_sym_QMARK] = ACTIONS(2417),
    [anon_sym_COMMA] = ACTIONS(2417),
    [anon_sym_SEMI] = ACTIONS(2417),
    [anon_sym_COLON] = ACTIONS(2417),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_EQ_EQ] = ACTIONS(2417),
    [anon_sym_STAR] = ACTIONS(2413),
    [anon_sym_STAR_EQ] = ACTIONS(2417),
    [anon_sym_PERCENT] = ACTIONS(2413),
    [anon_sym_PERCENT_EQ] = ACTIONS(2417),
    [anon_sym_CARET] = ACTIONS(2413),
    [anon_sym_CARET_EQ] = ACTIONS(2417),
    [anon_sym_CARET_CARET] = ACTIONS(2413),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2417),
    [anon_sym_TILDE] = ACTIONS(2413),
    [anon_sym_TILDE_EQ] = ACTIONS(2417),
    [anon_sym_AT] = ACTIONS(2417),
    [anon_sym_EQ_GT] = ACTIONS(2417),
    [anon_sym_POUND] = ACTIONS(2417),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2417),
    [sym_float_literal] = ACTIONS(2417),
    [sym__string] = ACTIONS(2341),
  },
  [542] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(549),
    [sym__token_no_braces] = STATE(549),
    [sym_keyword] = STATE(549),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(549),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(549),
    [sym_string_literal] = STATE(549),
    [sym_char_literal] = STATE(549),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2419),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2421),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2419),
    [anon_sym_SLASH_EQ] = ACTIONS(2423),
    [anon_sym_DOT] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_AMP] = ACTIONS(2419),
    [anon_sym_AMP_EQ] = ACTIONS(2423),
    [anon_sym_AMP_AMP] = ACTIONS(2423),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE_EQ] = ACTIONS(2423),
    [anon_sym_PIPE_PIPE] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(2419),
    [anon_sym_DASH_EQ] = ACTIONS(2423),
    [anon_sym_DASH_DASH] = ACTIONS(2423),
    [anon_sym_PLUS] = ACTIONS(2419),
    [anon_sym_PLUS_EQ] = ACTIONS(2423),
    [anon_sym_PLUS_PLUS] = ACTIONS(2423),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_LT_EQ] = ACTIONS(2423),
    [anon_sym_LT_LT] = ACTIONS(2419),
    [anon_sym_LT_LT_EQ] = ACTIONS(2423),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_GT_EQ] = ACTIONS(2423),
    [anon_sym_GT_GT_EQ] = ACTIONS(2423),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2423),
    [anon_sym_GT_GT] = ACTIONS(2419),
    [anon_sym_GT_GT_GT] = ACTIONS(2419),
    [anon_sym_BANG] = ACTIONS(2419),
    [anon_sym_BANG_EQ] = ACTIONS(2423),
    [anon_sym_LPAREN] = ACTIONS(2423),
    [anon_sym_RPAREN] = ACTIONS(2423),
    [anon_sym_LBRACK] = ACTIONS(2423),
    [anon_sym_RBRACK] = ACTIONS(2423),
    [anon_sym_QMARK] = ACTIONS(2423),
    [anon_sym_COMMA] = ACTIONS(2423),
    [anon_sym_SEMI] = ACTIONS(2423),
    [anon_sym_COLON] = ACTIONS(2423),
    [anon_sym_DOLLAR] = ACTIONS(2419),
    [anon_sym_EQ] = ACTIONS(2419),
    [anon_sym_EQ_EQ] = ACTIONS(2423),
    [anon_sym_STAR] = ACTIONS(2419),
    [anon_sym_STAR_EQ] = ACTIONS(2423),
    [anon_sym_PERCENT] = ACTIONS(2419),
    [anon_sym_PERCENT_EQ] = ACTIONS(2423),
    [anon_sym_CARET] = ACTIONS(2419),
    [anon_sym_CARET_EQ] = ACTIONS(2423),
    [anon_sym_CARET_CARET] = ACTIONS(2419),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2423),
    [anon_sym_TILDE] = ACTIONS(2419),
    [anon_sym_TILDE_EQ] = ACTIONS(2423),
    [anon_sym_AT] = ACTIONS(2423),
    [anon_sym_EQ_GT] = ACTIONS(2423),
    [anon_sym_POUND] = ACTIONS(2423),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2423),
    [sym_float_literal] = ACTIONS(2423),
    [sym__string] = ACTIONS(2341),
  },
  [543] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(525),
    [sym__token_no_braces] = STATE(525),
    [sym_keyword] = STATE(525),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(525),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(525),
    [sym_string_literal] = STATE(525),
    [sym_char_literal] = STATE(525),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2425),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2427),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2425),
    [anon_sym_SLASH_EQ] = ACTIONS(2429),
    [anon_sym_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT] = ACTIONS(2425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2429),
    [anon_sym_AMP] = ACTIONS(2425),
    [anon_sym_AMP_EQ] = ACTIONS(2429),
    [anon_sym_AMP_AMP] = ACTIONS(2429),
    [anon_sym_PIPE] = ACTIONS(2425),
    [anon_sym_PIPE_EQ] = ACTIONS(2429),
    [anon_sym_PIPE_PIPE] = ACTIONS(2429),
    [anon_sym_DASH] = ACTIONS(2425),
    [anon_sym_DASH_EQ] = ACTIONS(2429),
    [anon_sym_DASH_DASH] = ACTIONS(2429),
    [anon_sym_PLUS] = ACTIONS(2425),
    [anon_sym_PLUS_EQ] = ACTIONS(2429),
    [anon_sym_PLUS_PLUS] = ACTIONS(2429),
    [anon_sym_LT] = ACTIONS(2425),
    [anon_sym_LT_EQ] = ACTIONS(2429),
    [anon_sym_LT_LT] = ACTIONS(2425),
    [anon_sym_LT_LT_EQ] = ACTIONS(2429),
    [anon_sym_GT] = ACTIONS(2425),
    [anon_sym_GT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2425),
    [anon_sym_GT_GT_GT] = ACTIONS(2425),
    [anon_sym_BANG] = ACTIONS(2425),
    [anon_sym_BANG_EQ] = ACTIONS(2429),
    [anon_sym_LPAREN] = ACTIONS(2429),
    [anon_sym_RPAREN] = ACTIONS(2429),
    [anon_sym_LBRACK] = ACTIONS(2429),
    [anon_sym_RBRACK] = ACTIONS(2429),
    [anon_sym_QMARK] = ACTIONS(2429),
    [anon_sym_COMMA] = ACTIONS(2429),
    [anon_sym_SEMI] = ACTIONS(2429),
    [anon_sym_COLON] = ACTIONS(2429),
    [anon_sym_DOLLAR] = ACTIONS(2425),
    [anon_sym_EQ] = ACTIONS(2425),
    [anon_sym_EQ_EQ] = ACTIONS(2429),
    [anon_sym_STAR] = ACTIONS(2425),
    [anon_sym_STAR_EQ] = ACTIONS(2429),
    [anon_sym_PERCENT] = ACTIONS(2425),
    [anon_sym_PERCENT_EQ] = ACTIONS(2429),
    [anon_sym_CARET] = ACTIONS(2425),
    [anon_sym_CARET_EQ] = ACTIONS(2429),
    [anon_sym_CARET_CARET] = ACTIONS(2425),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2429),
    [anon_sym_TILDE] = ACTIONS(2425),
    [anon_sym_TILDE_EQ] = ACTIONS(2429),
    [anon_sym_AT] = ACTIONS(2429),
    [anon_sym_EQ_GT] = ACTIONS(2429),
    [anon_sym_POUND] = ACTIONS(2429),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2429),
    [sym_float_literal] = ACTIONS(2429),
    [sym__string] = ACTIONS(2341),
  },
  [544] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [545] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2433),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [546] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2435),
    [anon_sym_q_LBRACE] = ACTIONS(2438),
    [anon_sym_RBRACE] = ACTIONS(2441),
    [anon_sym_LBRACE] = ACTIONS(2443),
    [anon_sym_SLASH] = ACTIONS(2435),
    [anon_sym_SLASH_EQ] = ACTIONS(2446),
    [anon_sym_DOT] = ACTIONS(2435),
    [anon_sym_DOT_DOT] = ACTIONS(2435),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2446),
    [anon_sym_AMP] = ACTIONS(2435),
    [anon_sym_AMP_EQ] = ACTIONS(2446),
    [anon_sym_AMP_AMP] = ACTIONS(2446),
    [anon_sym_PIPE] = ACTIONS(2435),
    [anon_sym_PIPE_EQ] = ACTIONS(2446),
    [anon_sym_PIPE_PIPE] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2435),
    [anon_sym_DASH_EQ] = ACTIONS(2446),
    [anon_sym_DASH_DASH] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2435),
    [anon_sym_PLUS_EQ] = ACTIONS(2446),
    [anon_sym_PLUS_PLUS] = ACTIONS(2446),
    [anon_sym_LT] = ACTIONS(2435),
    [anon_sym_LT_EQ] = ACTIONS(2446),
    [anon_sym_LT_LT] = ACTIONS(2435),
    [anon_sym_LT_LT_EQ] = ACTIONS(2446),
    [anon_sym_GT] = ACTIONS(2435),
    [anon_sym_GT_EQ] = ACTIONS(2446),
    [anon_sym_GT_GT_EQ] = ACTIONS(2446),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2446),
    [anon_sym_GT_GT] = ACTIONS(2435),
    [anon_sym_GT_GT_GT] = ACTIONS(2435),
    [anon_sym_BANG] = ACTIONS(2435),
    [anon_sym_BANG_EQ] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2446),
    [anon_sym_RPAREN] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2446),
    [anon_sym_RBRACK] = ACTIONS(2446),
    [anon_sym_QMARK] = ACTIONS(2446),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2446),
    [anon_sym_COLON] = ACTIONS(2446),
    [anon_sym_DOLLAR] = ACTIONS(2435),
    [anon_sym_EQ] = ACTIONS(2435),
    [anon_sym_EQ_EQ] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2435),
    [anon_sym_STAR_EQ] = ACTIONS(2446),
    [anon_sym_PERCENT] = ACTIONS(2435),
    [anon_sym_PERCENT_EQ] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_CARET_EQ] = ACTIONS(2446),
    [anon_sym_CARET_CARET] = ACTIONS(2435),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2446),
    [anon_sym_TILDE] = ACTIONS(2435),
    [anon_sym_TILDE_EQ] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2446),
    [anon_sym_EQ_GT] = ACTIONS(2446),
    [anon_sym_POUND] = ACTIONS(2446),
    [sym_bool] = ACTIONS(2449),
    [sym_byte] = ACTIONS(2449),
    [sym_ubyte] = ACTIONS(2449),
    [sym_char] = ACTIONS(2449),
    [sym_short] = ACTIONS(2449),
    [sym_ushort] = ACTIONS(2449),
    [sym_int] = ACTIONS(2449),
    [sym_uint] = ACTIONS(2449),
    [sym_long] = ACTIONS(2449),
    [sym_ulong] = ACTIONS(2449),
    [sym_cent] = ACTIONS(2449),
    [sym_ucent] = ACTIONS(2449),
    [sym_wchar] = ACTIONS(2449),
    [sym_dchar] = ACTIONS(2449),
    [sym_float] = ACTIONS(2449),
    [sym_double] = ACTIONS(2449),
    [sym_real] = ACTIONS(2449),
    [sym_ifloat] = ACTIONS(2449),
    [sym_idouble] = ACTIONS(2449),
    [sym_ireal] = ACTIONS(2449),
    [sym_cfloat] = ACTIONS(2449),
    [sym_cdouble] = ACTIONS(2449),
    [sym_creal] = ACTIONS(2449),
    [sym_size_t] = ACTIONS(2449),
    [sym_ptrdiff_t] = ACTIONS(2449),
    [sym_string] = ACTIONS(2449),
    [sym_cstring] = ACTIONS(2449),
    [sym_dstring] = ACTIONS(2449),
    [sym_wstring] = ACTIONS(2449),
    [sym_noreturn] = ACTIONS(2449),
    [sym_true] = ACTIONS(2449),
    [sym_false] = ACTIONS(2449),
    [sym_null] = ACTIONS(2449),
    [sym_super] = ACTIONS(2449),
    [sym_this] = ACTIONS(2449),
    [sym_abstract] = ACTIONS(2449),
    [sym_alias] = ACTIONS(2449),
    [sym_align] = ACTIONS(2449),
    [sym_asm] = ACTIONS(2449),
    [sym_assert] = ACTIONS(2449),
    [sym_auto] = ACTIONS(2449),
    [sym_break] = ACTIONS(2449),
    [sym_case] = ACTIONS(2449),
    [sym_cast] = ACTIONS(2449),
    [sym_catch] = ACTIONS(2449),
    [sym_class] = ACTIONS(2449),
    [sym_const] = ACTIONS(2452),
    [sym_continue] = ACTIONS(2449),
    [sym_debug] = ACTIONS(2449),
    [sym_default] = ACTIONS(2449),
    [sym_delegate] = ACTIONS(2449),
    [sym_delete] = ACTIONS(2449),
    [sym_deprecated] = ACTIONS(2449),
    [sym_do] = ACTIONS(2449),
    [sym_else] = ACTIONS(2449),
    [sym_enum] = ACTIONS(2449),
    [sym_export] = ACTIONS(2449),
    [sym_extern] = ACTIONS(2449),
    [sym_final] = ACTIONS(2449),
    [sym_finally] = ACTIONS(2449),
    [sym_for] = ACTIONS(2449),
    [sym_foreach] = ACTIONS(2449),
    [sym_foreach_reverse] = ACTIONS(2449),
    [sym_function] = ACTIONS(2449),
    [sym_goto] = ACTIONS(2449),
    [sym_if] = ACTIONS(2449),
    [sym_immutable] = ACTIONS(2452),
    [sym_import] = ACTIONS(2449),
    [sym_in] = ACTIONS(2449),
    [sym_inout] = ACTIONS(2452),
    [sym_interface] = ACTIONS(2449),
    [sym_invariant] = ACTIONS(2449),
    [sym_is] = ACTIONS(2449),
    [sym_lazy] = ACTIONS(2449),
    [sym_mixin] = ACTIONS(2449),
    [sym_module] = ACTIONS(2449),
    [sym_new] = ACTIONS(2449),
    [sym_nothrow] = ACTIONS(2449),
    [sym_out] = ACTIONS(2449),
    [sym_override] = ACTIONS(2449),
    [sym_package] = ACTIONS(2449),
    [sym_pragma] = ACTIONS(2449),
    [sym_private] = ACTIONS(2449),
    [sym_protected] = ACTIONS(2449),
    [sym_public] = ACTIONS(2449),
    [sym_pure] = ACTIONS(2449),
    [sym_ref] = ACTIONS(2449),
    [sym_return] = ACTIONS(2449),
    [sym_scope] = ACTIONS(2449),
    [sym_shared] = ACTIONS(2452),
    [sym_static] = ACTIONS(2449),
    [sym_struct] = ACTIONS(2449),
    [sym_switch] = ACTIONS(2449),
    [sym_synchronized] = ACTIONS(2449),
    [sym_template] = ACTIONS(2449),
    [sym_throw] = ACTIONS(2449),
    [sym_try] = ACTIONS(2449),
    [sym_typeid] = ACTIONS(2449),
    [sym_typeof] = ACTIONS(2449),
    [sym_union] = ACTIONS(2449),
    [sym_unittest] = ACTIONS(2449),
    [sym_version] = ACTIONS(2449),
    [sym_while] = ACTIONS(2449),
    [sym_with] = ACTIONS(2449),
    [sym_parameters_] = ACTIONS(2449),
    [sym_gshared] = ACTIONS(2449),
    [sym_traits] = ACTIONS(2449),
    [sym_vector] = ACTIONS(2449),
    [sym_void] = ACTIONS(2449),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [anon_sym_r_DQUOTE] = ACTIONS(2458),
    [anon_sym_x_DQUOTE] = ACTIONS(2461),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2467),
    [anon_sym_i_BQUOTE] = ACTIONS(2470),
    [anon_sym_i_DQUOTE] = ACTIONS(2473),
    [anon_sym_iq_LBRACE] = ACTIONS(2476),
    [aux_sym_char_literal_token1] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym___DATE__] = ACTIONS(2485),
    [anon_sym___FILE__] = ACTIONS(2485),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2485),
    [anon_sym___FUNCTION__] = ACTIONS(2485),
    [anon_sym___LINE__] = ACTIONS(2485),
    [anon_sym___MODULE__] = ACTIONS(2485),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2485),
    [anon_sym___TIME__] = ACTIONS(2485),
    [anon_sym___TIMESTAMP__] = ACTIONS(2485),
    [anon_sym___VENDOR__] = ACTIONS(2485),
    [anon_sym___VERSION__] = ACTIONS(2485),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2446),
    [sym_float_literal] = ACTIONS(2446),
    [sym__string] = ACTIONS(2488),
  },
  [547] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [548] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(530),
    [sym__token_no_braces] = STATE(530),
    [sym_keyword] = STATE(530),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(530),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(530),
    [sym_string_literal] = STATE(530),
    [sym_char_literal] = STATE(530),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2493),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2493),
    [anon_sym_SLASH_EQ] = ACTIONS(2497),
    [anon_sym_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2497),
    [anon_sym_AMP] = ACTIONS(2493),
    [anon_sym_AMP_EQ] = ACTIONS(2497),
    [anon_sym_AMP_AMP] = ACTIONS(2497),
    [anon_sym_PIPE] = ACTIONS(2493),
    [anon_sym_PIPE_EQ] = ACTIONS(2497),
    [anon_sym_PIPE_PIPE] = ACTIONS(2497),
    [anon_sym_DASH] = ACTIONS(2493),
    [anon_sym_DASH_EQ] = ACTIONS(2497),
    [anon_sym_DASH_DASH] = ACTIONS(2497),
    [anon_sym_PLUS] = ACTIONS(2493),
    [anon_sym_PLUS_EQ] = ACTIONS(2497),
    [anon_sym_PLUS_PLUS] = ACTIONS(2497),
    [anon_sym_LT] = ACTIONS(2493),
    [anon_sym_LT_EQ] = ACTIONS(2497),
    [anon_sym_LT_LT] = ACTIONS(2493),
    [anon_sym_LT_LT_EQ] = ACTIONS(2497),
    [anon_sym_GT] = ACTIONS(2493),
    [anon_sym_GT_EQ] = ACTIONS(2497),
    [anon_sym_GT_GT_EQ] = ACTIONS(2497),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2497),
    [anon_sym_GT_GT] = ACTIONS(2493),
    [anon_sym_GT_GT_GT] = ACTIONS(2493),
    [anon_sym_BANG] = ACTIONS(2493),
    [anon_sym_BANG_EQ] = ACTIONS(2497),
    [anon_sym_LPAREN] = ACTIONS(2497),
    [anon_sym_RPAREN] = ACTIONS(2497),
    [anon_sym_LBRACK] = ACTIONS(2497),
    [anon_sym_RBRACK] = ACTIONS(2497),
    [anon_sym_QMARK] = ACTIONS(2497),
    [anon_sym_COMMA] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(2497),
    [anon_sym_COLON] = ACTIONS(2497),
    [anon_sym_DOLLAR] = ACTIONS(2493),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_EQ_EQ] = ACTIONS(2497),
    [anon_sym_STAR] = ACTIONS(2493),
    [anon_sym_STAR_EQ] = ACTIONS(2497),
    [anon_sym_PERCENT] = ACTIONS(2493),
    [anon_sym_PERCENT_EQ] = ACTIONS(2497),
    [anon_sym_CARET] = ACTIONS(2493),
    [anon_sym_CARET_EQ] = ACTIONS(2497),
    [anon_sym_CARET_CARET] = ACTIONS(2493),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2497),
    [anon_sym_TILDE] = ACTIONS(2493),
    [anon_sym_TILDE_EQ] = ACTIONS(2497),
    [anon_sym_AT] = ACTIONS(2497),
    [anon_sym_EQ_GT] = ACTIONS(2497),
    [anon_sym_POUND] = ACTIONS(2497),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2497),
    [sym_float_literal] = ACTIONS(2497),
    [sym__string] = ACTIONS(2341),
  },
  [549] = {
    [sym_token_string] = STATE(619),
    [sym__token_string_token] = STATE(546),
    [sym__token_no_braces] = STATE(546),
    [sym_keyword] = STATE(546),
    [sym_type_ctor] = STATE(622),
    [sym__builtin_type] = STATE(622),
    [sym_raw_string] = STATE(619),
    [sym_hex_string] = STATE(619),
    [sym_quoted_string] = STATE(619),
    [sym_interpolation_expression] = STATE(546),
    [sym_interpolated_raw_string] = STATE(619),
    [sym_interpolated_quoted_string] = STATE(619),
    [sym_interpolated_token_string] = STATE(619),
    [aux_sym__i_token_string_tokens] = STATE(546),
    [sym_string_literal] = STATE(546),
    [sym_char_literal] = STATE(546),
    [sym_special_keyword] = STATE(622),
    [sym_identifier] = ACTIONS(2343),
    [anon_sym_q_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2499),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_SLASH_EQ] = ACTIONS(2347),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT] = ACTIONS(2343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2347),
    [anon_sym_AMP] = ACTIONS(2343),
    [anon_sym_AMP_EQ] = ACTIONS(2347),
    [anon_sym_AMP_AMP] = ACTIONS(2347),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_PIPE_EQ] = ACTIONS(2347),
    [anon_sym_PIPE_PIPE] = ACTIONS(2347),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DASH_EQ] = ACTIONS(2347),
    [anon_sym_DASH_DASH] = ACTIONS(2347),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_PLUS_EQ] = ACTIONS(2347),
    [anon_sym_PLUS_PLUS] = ACTIONS(2347),
    [anon_sym_LT] = ACTIONS(2343),
    [anon_sym_LT_EQ] = ACTIONS(2347),
    [anon_sym_LT_LT] = ACTIONS(2343),
    [anon_sym_LT_LT_EQ] = ACTIONS(2347),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2347),
    [anon_sym_GT_GT] = ACTIONS(2343),
    [anon_sym_GT_GT_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_BANG_EQ] = ACTIONS(2347),
    [anon_sym_LPAREN] = ACTIONS(2347),
    [anon_sym_RPAREN] = ACTIONS(2347),
    [anon_sym_LBRACK] = ACTIONS(2347),
    [anon_sym_RBRACK] = ACTIONS(2347),
    [anon_sym_QMARK] = ACTIONS(2347),
    [anon_sym_COMMA] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_COLON] = ACTIONS(2347),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_EQ_EQ] = ACTIONS(2347),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_STAR_EQ] = ACTIONS(2347),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_PERCENT_EQ] = ACTIONS(2347),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym_CARET_EQ] = ACTIONS(2347),
    [anon_sym_CARET_CARET] = ACTIONS(2343),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2347),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_TILDE_EQ] = ACTIONS(2347),
    [anon_sym_AT] = ACTIONS(2347),
    [anon_sym_EQ_GT] = ACTIONS(2347),
    [anon_sym_POUND] = ACTIONS(2347),
    [sym_bool] = ACTIONS(2315),
    [sym_byte] = ACTIONS(2315),
    [sym_ubyte] = ACTIONS(2315),
    [sym_char] = ACTIONS(2315),
    [sym_short] = ACTIONS(2315),
    [sym_ushort] = ACTIONS(2315),
    [sym_int] = ACTIONS(2315),
    [sym_uint] = ACTIONS(2315),
    [sym_long] = ACTIONS(2315),
    [sym_ulong] = ACTIONS(2315),
    [sym_cent] = ACTIONS(2315),
    [sym_ucent] = ACTIONS(2315),
    [sym_wchar] = ACTIONS(2315),
    [sym_dchar] = ACTIONS(2315),
    [sym_float] = ACTIONS(2315),
    [sym_double] = ACTIONS(2315),
    [sym_real] = ACTIONS(2315),
    [sym_ifloat] = ACTIONS(2315),
    [sym_idouble] = ACTIONS(2315),
    [sym_ireal] = ACTIONS(2315),
    [sym_cfloat] = ACTIONS(2315),
    [sym_cdouble] = ACTIONS(2315),
    [sym_creal] = ACTIONS(2315),
    [sym_size_t] = ACTIONS(2315),
    [sym_ptrdiff_t] = ACTIONS(2315),
    [sym_string] = ACTIONS(2315),
    [sym_cstring] = ACTIONS(2315),
    [sym_dstring] = ACTIONS(2315),
    [sym_wstring] = ACTIONS(2315),
    [sym_noreturn] = ACTIONS(2315),
    [sym_true] = ACTIONS(2315),
    [sym_false] = ACTIONS(2315),
    [sym_null] = ACTIONS(2315),
    [sym_super] = ACTIONS(2315),
    [sym_this] = ACTIONS(2315),
    [sym_abstract] = ACTIONS(2315),
    [sym_alias] = ACTIONS(2315),
    [sym_align] = ACTIONS(2315),
    [sym_asm] = ACTIONS(2315),
    [sym_assert] = ACTIONS(2315),
    [sym_auto] = ACTIONS(2315),
    [sym_break] = ACTIONS(2315),
    [sym_case] = ACTIONS(2315),
    [sym_cast] = ACTIONS(2315),
    [sym_catch] = ACTIONS(2315),
    [sym_class] = ACTIONS(2315),
    [sym_const] = ACTIONS(2317),
    [sym_continue] = ACTIONS(2315),
    [sym_debug] = ACTIONS(2315),
    [sym_default] = ACTIONS(2315),
    [sym_delegate] = ACTIONS(2315),
    [sym_delete] = ACTIONS(2315),
    [sym_deprecated] = ACTIONS(2315),
    [sym_do] = ACTIONS(2315),
    [sym_else] = ACTIONS(2315),
    [sym_enum] = ACTIONS(2315),
    [sym_export] = ACTIONS(2315),
    [sym_extern] = ACTIONS(2315),
    [sym_final] = ACTIONS(2315),
    [sym_finally] = ACTIONS(2315),
    [sym_for] = ACTIONS(2315),
    [sym_foreach] = ACTIONS(2315),
    [sym_foreach_reverse] = ACTIONS(2315),
    [sym_function] = ACTIONS(2315),
    [sym_goto] = ACTIONS(2315),
    [sym_if] = ACTIONS(2315),
    [sym_immutable] = ACTIONS(2317),
    [sym_import] = ACTIONS(2315),
    [sym_in] = ACTIONS(2315),
    [sym_inout] = ACTIONS(2317),
    [sym_interface] = ACTIONS(2315),
    [sym_invariant] = ACTIONS(2315),
    [sym_is] = ACTIONS(2315),
    [sym_lazy] = ACTIONS(2315),
    [sym_mixin] = ACTIONS(2315),
    [sym_module] = ACTIONS(2315),
    [sym_new] = ACTIONS(2315),
    [sym_nothrow] = ACTIONS(2315),
    [sym_out] = ACTIONS(2315),
    [sym_override] = ACTIONS(2315),
    [sym_package] = ACTIONS(2315),
    [sym_pragma] = ACTIONS(2315),
    [sym_private] = ACTIONS(2315),
    [sym_protected] = ACTIONS(2315),
    [sym_public] = ACTIONS(2315),
    [sym_pure] = ACTIONS(2315),
    [sym_ref] = ACTIONS(2315),
    [sym_return] = ACTIONS(2315),
    [sym_scope] = ACTIONS(2315),
    [sym_shared] = ACTIONS(2317),
    [sym_static] = ACTIONS(2315),
    [sym_struct] = ACTIONS(2315),
    [sym_switch] = ACTIONS(2315),
    [sym_synchronized] = ACTIONS(2315),
    [sym_template] = ACTIONS(2315),
    [sym_throw] = ACTIONS(2315),
    [sym_try] = ACTIONS(2315),
    [sym_typeid] = ACTIONS(2315),
    [sym_typeof] = ACTIONS(2315),
    [sym_union] = ACTIONS(2315),
    [sym_unittest] = ACTIONS(2315),
    [sym_version] = ACTIONS(2315),
    [sym_while] = ACTIONS(2315),
    [sym_with] = ACTIONS(2315),
    [sym_parameters_] = ACTIONS(2315),
    [sym_gshared] = ACTIONS(2315),
    [sym_traits] = ACTIONS(2315),
    [sym_vector] = ACTIONS(2315),
    [sym_void] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_r_DQUOTE] = ACTIONS(2321),
    [anon_sym_x_DQUOTE] = ACTIONS(2323),
    [anon_sym_DQUOTE] = ACTIONS(2325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2327),
    [anon_sym_i_BQUOTE] = ACTIONS(2329),
    [anon_sym_i_DQUOTE] = ACTIONS(2331),
    [anon_sym_iq_LBRACE] = ACTIONS(2333),
    [aux_sym_char_literal_token1] = ACTIONS(2335),
    [anon_sym_SQUOTE] = ACTIONS(2337),
    [anon_sym___DATE__] = ACTIONS(2339),
    [anon_sym___FILE__] = ACTIONS(2339),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2339),
    [anon_sym___FUNCTION__] = ACTIONS(2339),
    [anon_sym___LINE__] = ACTIONS(2339),
    [anon_sym___MODULE__] = ACTIONS(2339),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2339),
    [anon_sym___TIME__] = ACTIONS(2339),
    [anon_sym___TIMESTAMP__] = ACTIONS(2339),
    [anon_sym___VENDOR__] = ACTIONS(2339),
    [anon_sym___VERSION__] = ACTIONS(2339),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2347),
    [sym_float_literal] = ACTIONS(2347),
    [sym__string] = ACTIONS(2341),
  },
  [550] = {
    [sym_import_declaration] = STATE(551),
    [sym_mixin_declaration] = STATE(551),
    [sym__declaration] = STATE(551),
    [sym__declaration2] = STATE(551),
    [sym_variable_declaration] = STATE(551),
    [sym_manifest_constant] = STATE(551),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(551),
    [sym_alias_declaration] = STATE(551),
    [sym_alias_reassign] = STATE(551),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(551),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(551),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(551),
    [sym_union_declaration] = STATE(551),
    [sym_postblit] = STATE(551),
    [sym_invariant_declaration] = STATE(551),
    [sym_class_declaration] = STATE(551),
    [sym_constructor] = STATE(551),
    [sym_destructor] = STATE(551),
    [sym_alias_this] = STATE(551),
    [sym_interface_declaration] = STATE(551),
    [sym_enum_declaration] = STATE(551),
    [sym_anonymous_enum_declaration] = STATE(551),
    [sym_function_declaration] = STATE(551),
    [sym_template_declaration] = STATE(551),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(551),
    [sym_template_mixin] = STATE(551),
    [sym_conditional_declaration] = STATE(551),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(551),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(551),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(551),
    [sym_static_assert] = STATE(551),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(551),
    [aux_sym_source_file_repeat1] = STATE(551),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2507),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2505),
    [sym_case] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2505),
    [sym_for] = ACTIONS(2505),
    [sym_foreach] = ACTIONS(2505),
    [sym_foreach_reverse] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_goto] = ACTIONS(2505),
    [sym_if] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2505),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2505),
    [sym_try] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2505),
    [sym_with] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [551] = {
    [sym_import_declaration] = STATE(552),
    [sym_mixin_declaration] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym__declaration2] = STATE(552),
    [sym_variable_declaration] = STATE(552),
    [sym_manifest_constant] = STATE(552),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(552),
    [sym_alias_declaration] = STATE(552),
    [sym_alias_reassign] = STATE(552),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(552),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(552),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(552),
    [sym_union_declaration] = STATE(552),
    [sym_postblit] = STATE(552),
    [sym_invariant_declaration] = STATE(552),
    [sym_class_declaration] = STATE(552),
    [sym_constructor] = STATE(552),
    [sym_destructor] = STATE(552),
    [sym_alias_this] = STATE(552),
    [sym_interface_declaration] = STATE(552),
    [sym_enum_declaration] = STATE(552),
    [sym_anonymous_enum_declaration] = STATE(552),
    [sym_function_declaration] = STATE(552),
    [sym_template_declaration] = STATE(552),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(552),
    [sym_template_mixin] = STATE(552),
    [sym_conditional_declaration] = STATE(552),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(552),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(552),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(552),
    [sym_static_assert] = STATE(552),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(552),
    [aux_sym_source_file_repeat1] = STATE(552),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2527),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2525),
    [sym_case] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_catch] = ACTIONS(2525),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2525),
    [sym_for] = ACTIONS(2525),
    [sym_foreach] = ACTIONS(2525),
    [sym_foreach_reverse] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_goto] = ACTIONS(2525),
    [sym_if] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2525),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2525),
    [sym_try] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2525),
    [sym_with] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [552] = {
    [sym_import_declaration] = STATE(552),
    [sym_mixin_declaration] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym__declaration2] = STATE(552),
    [sym_variable_declaration] = STATE(552),
    [sym_manifest_constant] = STATE(552),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(552),
    [sym_alias_declaration] = STATE(552),
    [sym_alias_reassign] = STATE(552),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(552),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(552),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(552),
    [sym_union_declaration] = STATE(552),
    [sym_postblit] = STATE(552),
    [sym_invariant_declaration] = STATE(552),
    [sym_class_declaration] = STATE(552),
    [sym_constructor] = STATE(552),
    [sym_destructor] = STATE(552),
    [sym_alias_this] = STATE(552),
    [sym_interface_declaration] = STATE(552),
    [sym_enum_declaration] = STATE(552),
    [sym_anonymous_enum_declaration] = STATE(552),
    [sym_function_declaration] = STATE(552),
    [sym_template_declaration] = STATE(552),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(552),
    [sym_template_mixin] = STATE(552),
    [sym_conditional_declaration] = STATE(552),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(552),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(552),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(552),
    [sym_static_assert] = STATE(552),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(552),
    [aux_sym_source_file_repeat1] = STATE(552),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2529),
    [anon_sym_q_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_DASH] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2539),
    [anon_sym_DOLLAR] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2542),
    [anon_sym_AT] = ACTIONS(2545),
    [sym_bool] = ACTIONS(2548),
    [sym_byte] = ACTIONS(2548),
    [sym_ubyte] = ACTIONS(2548),
    [sym_char] = ACTIONS(2548),
    [sym_short] = ACTIONS(2548),
    [sym_ushort] = ACTIONS(2548),
    [sym_int] = ACTIONS(2548),
    [sym_uint] = ACTIONS(2548),
    [sym_long] = ACTIONS(2548),
    [sym_ulong] = ACTIONS(2548),
    [sym_cent] = ACTIONS(2548),
    [sym_ucent] = ACTIONS(2548),
    [sym_wchar] = ACTIONS(2548),
    [sym_dchar] = ACTIONS(2548),
    [sym_float] = ACTIONS(2548),
    [sym_double] = ACTIONS(2548),
    [sym_real] = ACTIONS(2548),
    [sym_ifloat] = ACTIONS(2548),
    [sym_idouble] = ACTIONS(2548),
    [sym_ireal] = ACTIONS(2548),
    [sym_cfloat] = ACTIONS(2548),
    [sym_cdouble] = ACTIONS(2548),
    [sym_creal] = ACTIONS(2548),
    [sym_size_t] = ACTIONS(2548),
    [sym_ptrdiff_t] = ACTIONS(2548),
    [sym_string] = ACTIONS(2548),
    [sym_cstring] = ACTIONS(2548),
    [sym_dstring] = ACTIONS(2548),
    [sym_wstring] = ACTIONS(2548),
    [sym_noreturn] = ACTIONS(2548),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [sym_null] = ACTIONS(2537),
    [sym_super] = ACTIONS(2537),
    [sym_this] = ACTIONS(2551),
    [sym_abstract] = ACTIONS(2554),
    [sym_alias] = ACTIONS(2557),
    [sym_align] = ACTIONS(2560),
    [sym_asm] = ACTIONS(2537),
    [sym_assert] = ACTIONS(2537),
    [sym_auto] = ACTIONS(2554),
    [sym_break] = ACTIONS(2537),
    [sym_case] = ACTIONS(2537),
    [sym_cast] = ACTIONS(2537),
    [sym_catch] = ACTIONS(2537),
    [sym_class] = ACTIONS(2563),
    [sym_const] = ACTIONS(2566),
    [sym_continue] = ACTIONS(2537),
    [sym_debug] = ACTIONS(2569),
    [sym_default] = ACTIONS(2537),
    [sym_delegate] = ACTIONS(2537),
    [sym_delete] = ACTIONS(2537),
    [sym_deprecated] = ACTIONS(2572),
    [sym_do] = ACTIONS(2537),
    [sym_else] = ACTIONS(2537),
    [sym_enum] = ACTIONS(2575),
    [sym_export] = ACTIONS(2578),
    [sym_extern] = ACTIONS(2581),
    [sym_final] = ACTIONS(2554),
    [sym_finally] = ACTIONS(2537),
    [sym_for] = ACTIONS(2537),
    [sym_foreach] = ACTIONS(2537),
    [sym_foreach_reverse] = ACTIONS(2537),
    [sym_function] = ACTIONS(2537),
    [sym_goto] = ACTIONS(2537),
    [sym_if] = ACTIONS(2537),
    [sym_immutable] = ACTIONS(2566),
    [sym_import] = ACTIONS(2584),
    [sym_in] = ACTIONS(2537),
    [sym_inout] = ACTIONS(2566),
    [sym_interface] = ACTIONS(2587),
    [sym_invariant] = ACTIONS(2590),
    [sym_is] = ACTIONS(2537),
    [sym_mixin] = ACTIONS(2593),
    [sym_new] = ACTIONS(2537),
    [sym_nothrow] = ACTIONS(2554),
    [sym_out] = ACTIONS(2537),
    [sym_override] = ACTIONS(2554),
    [sym_package] = ACTIONS(2596),
    [sym_pragma] = ACTIONS(2599),
    [sym_private] = ACTIONS(2578),
    [sym_protected] = ACTIONS(2578),
    [sym_public] = ACTIONS(2578),
    [sym_pure] = ACTIONS(2554),
    [sym_ref] = ACTIONS(2554),
    [sym_return] = ACTIONS(2578),
    [sym_scope] = ACTIONS(2554),
    [sym_shared] = ACTIONS(2602),
    [sym_static] = ACTIONS(2605),
    [sym_struct] = ACTIONS(2608),
    [sym_switch] = ACTIONS(2537),
    [sym_synchronized] = ACTIONS(2554),
    [sym_template] = ACTIONS(2611),
    [sym_throw] = ACTIONS(2537),
    [sym_try] = ACTIONS(2537),
    [sym_typeid] = ACTIONS(2537),
    [sym_typeof] = ACTIONS(2614),
    [sym_union] = ACTIONS(2617),
    [sym_unittest] = ACTIONS(2620),
    [sym_version] = ACTIONS(2623),
    [sym_while] = ACTIONS(2537),
    [sym_with] = ACTIONS(2537),
    [sym_gshared] = ACTIONS(2554),
    [sym_traits] = ACTIONS(2626),
    [sym_vector] = ACTIONS(2629),
    [sym_void] = ACTIONS(2548),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [anon_sym_r_DQUOTE] = ACTIONS(2532),
    [anon_sym_x_DQUOTE] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_i_BQUOTE] = ACTIONS(2532),
    [anon_sym_i_DQUOTE] = ACTIONS(2532),
    [anon_sym_iq_LBRACE] = ACTIONS(2532),
    [aux_sym_char_literal_token1] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [anon_sym___DATE__] = ACTIONS(2537),
    [anon_sym___FILE__] = ACTIONS(2537),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2537),
    [anon_sym___FUNCTION__] = ACTIONS(2537),
    [anon_sym___LINE__] = ACTIONS(2537),
    [anon_sym___MODULE__] = ACTIONS(2537),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2537),
    [anon_sym___TIME__] = ACTIONS(2537),
    [anon_sym___TIMESTAMP__] = ACTIONS(2537),
    [anon_sym___VENDOR__] = ACTIONS(2537),
    [anon_sym___VERSION__] = ACTIONS(2537),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2532),
    [sym_float_literal] = ACTIONS(2532),
    [sym__string] = ACTIONS(2532),
  },
  [553] = {
    [sym_import_declaration] = STATE(552),
    [sym_mixin_declaration] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym__declaration2] = STATE(552),
    [sym_variable_declaration] = STATE(552),
    [sym_manifest_constant] = STATE(552),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(552),
    [sym_alias_declaration] = STATE(552),
    [sym_alias_reassign] = STATE(552),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(552),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(552),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(552),
    [sym_union_declaration] = STATE(552),
    [sym_postblit] = STATE(552),
    [sym_invariant_declaration] = STATE(552),
    [sym_class_declaration] = STATE(552),
    [sym_constructor] = STATE(552),
    [sym_destructor] = STATE(552),
    [sym_alias_this] = STATE(552),
    [sym_interface_declaration] = STATE(552),
    [sym_enum_declaration] = STATE(552),
    [sym_anonymous_enum_declaration] = STATE(552),
    [sym_function_declaration] = STATE(552),
    [sym_template_declaration] = STATE(552),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(552),
    [sym_template_mixin] = STATE(552),
    [sym_conditional_declaration] = STATE(552),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(552),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(552),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(552),
    [sym_static_assert] = STATE(552),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(552),
    [aux_sym_source_file_repeat1] = STATE(552),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2527),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2634),
    [sym_assert] = ACTIONS(2634),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2634),
    [sym_case] = ACTIONS(2634),
    [sym_cast] = ACTIONS(2634),
    [sym_catch] = ACTIONS(2634),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2634),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2634),
    [sym_delegate] = ACTIONS(2634),
    [sym_delete] = ACTIONS(2634),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2634),
    [sym_else] = ACTIONS(2634),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2634),
    [sym_for] = ACTIONS(2634),
    [sym_foreach] = ACTIONS(2634),
    [sym_foreach_reverse] = ACTIONS(2634),
    [sym_function] = ACTIONS(2634),
    [sym_goto] = ACTIONS(2634),
    [sym_if] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2634),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2634),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2634),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2634),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2634),
    [sym_try] = ACTIONS(2634),
    [sym_typeid] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2634),
    [sym_with] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_r_DQUOTE] = ACTIONS(2632),
    [anon_sym_x_DQUOTE] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_i_BQUOTE] = ACTIONS(2632),
    [anon_sym_i_DQUOTE] = ACTIONS(2632),
    [anon_sym_iq_LBRACE] = ACTIONS(2632),
    [aux_sym_char_literal_token1] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym___DATE__] = ACTIONS(2634),
    [anon_sym___FILE__] = ACTIONS(2634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2634),
    [anon_sym___FUNCTION__] = ACTIONS(2634),
    [anon_sym___LINE__] = ACTIONS(2634),
    [anon_sym___MODULE__] = ACTIONS(2634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2634),
    [anon_sym___TIME__] = ACTIONS(2634),
    [anon_sym___TIMESTAMP__] = ACTIONS(2634),
    [anon_sym___VENDOR__] = ACTIONS(2634),
    [anon_sym___VERSION__] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__string] = ACTIONS(2632),
  },
  [554] = {
    [sym_import_declaration] = STATE(552),
    [sym_mixin_declaration] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym__declaration2] = STATE(552),
    [sym_variable_declaration] = STATE(552),
    [sym_manifest_constant] = STATE(552),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(552),
    [sym_alias_declaration] = STATE(552),
    [sym_alias_reassign] = STATE(552),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(552),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(552),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(552),
    [sym_union_declaration] = STATE(552),
    [sym_postblit] = STATE(552),
    [sym_invariant_declaration] = STATE(552),
    [sym_class_declaration] = STATE(552),
    [sym_constructor] = STATE(552),
    [sym_destructor] = STATE(552),
    [sym_alias_this] = STATE(552),
    [sym_interface_declaration] = STATE(552),
    [sym_enum_declaration] = STATE(552),
    [sym_anonymous_enum_declaration] = STATE(552),
    [sym_function_declaration] = STATE(552),
    [sym_template_declaration] = STATE(552),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(552),
    [sym_template_mixin] = STATE(552),
    [sym_conditional_declaration] = STATE(552),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(552),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(552),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(552),
    [sym_static_assert] = STATE(552),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(552),
    [aux_sym_source_file_repeat1] = STATE(552),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2527),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2638),
    [sym_case] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_catch] = ACTIONS(2638),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2638),
    [sym_for] = ACTIONS(2638),
    [sym_foreach] = ACTIONS(2638),
    [sym_foreach_reverse] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_goto] = ACTIONS(2638),
    [sym_if] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2638),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2638),
    [sym_try] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2638),
    [sym_with] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [555] = {
    [sym_import_declaration] = STATE(552),
    [sym_mixin_declaration] = STATE(552),
    [sym__declaration] = STATE(552),
    [sym__declaration2] = STATE(552),
    [sym_variable_declaration] = STATE(552),
    [sym_manifest_constant] = STATE(552),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(552),
    [sym_alias_declaration] = STATE(552),
    [sym_alias_reassign] = STATE(552),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(552),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(552),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(552),
    [sym_union_declaration] = STATE(552),
    [sym_postblit] = STATE(552),
    [sym_invariant_declaration] = STATE(552),
    [sym_class_declaration] = STATE(552),
    [sym_constructor] = STATE(552),
    [sym_destructor] = STATE(552),
    [sym_alias_this] = STATE(552),
    [sym_interface_declaration] = STATE(552),
    [sym_enum_declaration] = STATE(552),
    [sym_anonymous_enum_declaration] = STATE(552),
    [sym_function_declaration] = STATE(552),
    [sym_template_declaration] = STATE(552),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(552),
    [sym_template_mixin] = STATE(552),
    [sym_conditional_declaration] = STATE(552),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(552),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(552),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(552),
    [sym_static_assert] = STATE(552),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(552),
    [aux_sym_source_file_repeat1] = STATE(552),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2527),
    [anon_sym_DOLLAR] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2642),
    [sym_assert] = ACTIONS(2642),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2642),
    [sym_case] = ACTIONS(2642),
    [sym_cast] = ACTIONS(2642),
    [sym_catch] = ACTIONS(2642),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2642),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2642),
    [sym_delegate] = ACTIONS(2642),
    [sym_delete] = ACTIONS(2642),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2642),
    [sym_for] = ACTIONS(2642),
    [sym_foreach] = ACTIONS(2642),
    [sym_foreach_reverse] = ACTIONS(2642),
    [sym_function] = ACTIONS(2642),
    [sym_goto] = ACTIONS(2642),
    [sym_if] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2642),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2642),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2642),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2642),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2642),
    [sym_try] = ACTIONS(2642),
    [sym_typeid] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2642),
    [sym_with] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [anon_sym_r_DQUOTE] = ACTIONS(2640),
    [anon_sym_x_DQUOTE] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_i_BQUOTE] = ACTIONS(2640),
    [anon_sym_i_DQUOTE] = ACTIONS(2640),
    [anon_sym_iq_LBRACE] = ACTIONS(2640),
    [aux_sym_char_literal_token1] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym___DATE__] = ACTIONS(2642),
    [anon_sym___FILE__] = ACTIONS(2642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2642),
    [anon_sym___FUNCTION__] = ACTIONS(2642),
    [anon_sym___LINE__] = ACTIONS(2642),
    [anon_sym___MODULE__] = ACTIONS(2642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2642),
    [anon_sym___TIME__] = ACTIONS(2642),
    [anon_sym___TIMESTAMP__] = ACTIONS(2642),
    [anon_sym___VENDOR__] = ACTIONS(2642),
    [anon_sym___VERSION__] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2640),
    [sym_float_literal] = ACTIONS(2640),
    [sym__string] = ACTIONS(2640),
  },
  [556] = {
    [sym_import_declaration] = STATE(554),
    [sym_mixin_declaration] = STATE(554),
    [sym__declaration] = STATE(554),
    [sym__declaration2] = STATE(554),
    [sym_variable_declaration] = STATE(554),
    [sym_manifest_constant] = STATE(554),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(554),
    [sym_alias_declaration] = STATE(554),
    [sym_alias_reassign] = STATE(554),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(554),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(554),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(554),
    [sym_union_declaration] = STATE(554),
    [sym_postblit] = STATE(554),
    [sym_invariant_declaration] = STATE(554),
    [sym_class_declaration] = STATE(554),
    [sym_constructor] = STATE(554),
    [sym_destructor] = STATE(554),
    [sym_alias_this] = STATE(554),
    [sym_interface_declaration] = STATE(554),
    [sym_enum_declaration] = STATE(554),
    [sym_anonymous_enum_declaration] = STATE(554),
    [sym_function_declaration] = STATE(554),
    [sym_template_declaration] = STATE(554),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(554),
    [sym_template_mixin] = STATE(554),
    [sym_conditional_declaration] = STATE(554),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(554),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(554),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(554),
    [sym_static_assert] = STATE(554),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(554),
    [aux_sym_source_file_repeat1] = STATE(554),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2644),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2525),
    [sym_case] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_catch] = ACTIONS(2525),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2525),
    [sym_for] = ACTIONS(2525),
    [sym_foreach] = ACTIONS(2525),
    [sym_foreach_reverse] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_goto] = ACTIONS(2525),
    [sym_if] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2525),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2525),
    [sym_try] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2525),
    [sym_with] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [557] = {
    [sym_import_declaration] = STATE(555),
    [sym_mixin_declaration] = STATE(555),
    [sym__declaration] = STATE(555),
    [sym__declaration2] = STATE(555),
    [sym_variable_declaration] = STATE(555),
    [sym_manifest_constant] = STATE(555),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(555),
    [sym_alias_declaration] = STATE(555),
    [sym_alias_reassign] = STATE(555),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(555),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(555),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(555),
    [sym_union_declaration] = STATE(555),
    [sym_postblit] = STATE(555),
    [sym_invariant_declaration] = STATE(555),
    [sym_class_declaration] = STATE(555),
    [sym_constructor] = STATE(555),
    [sym_destructor] = STATE(555),
    [sym_alias_this] = STATE(555),
    [sym_interface_declaration] = STATE(555),
    [sym_enum_declaration] = STATE(555),
    [sym_anonymous_enum_declaration] = STATE(555),
    [sym_function_declaration] = STATE(555),
    [sym_template_declaration] = STATE(555),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(555),
    [sym_template_mixin] = STATE(555),
    [sym_conditional_declaration] = STATE(555),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(555),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(555),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(555),
    [sym_static_assert] = STATE(555),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(555),
    [aux_sym_source_file_repeat1] = STATE(555),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2646),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2638),
    [sym_case] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_catch] = ACTIONS(2638),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2513),
    [sym_default] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2638),
    [sym_for] = ACTIONS(2638),
    [sym_foreach] = ACTIONS(2638),
    [sym_foreach_reverse] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_goto] = ACTIONS(2638),
    [sym_if] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2517),
    [sym_new] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2638),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_switch] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_throw] = ACTIONS(2638),
    [sym_try] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_while] = ACTIONS(2638),
    [sym_with] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [558] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [559] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2684),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [560] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(558),
    [sym__token_string_token] = STATE(558),
    [sym__token_no_braces] = STATE(558),
    [sym_keyword] = STATE(558),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(558),
    [sym_char_literal] = STATE(558),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2686),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2688),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2686),
    [anon_sym_SLASH_EQ] = ACTIONS(2690),
    [anon_sym_DOT] = ACTIONS(2686),
    [anon_sym_DOT_DOT] = ACTIONS(2686),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2690),
    [anon_sym_AMP] = ACTIONS(2686),
    [anon_sym_AMP_EQ] = ACTIONS(2690),
    [anon_sym_AMP_AMP] = ACTIONS(2690),
    [anon_sym_PIPE] = ACTIONS(2686),
    [anon_sym_PIPE_EQ] = ACTIONS(2690),
    [anon_sym_PIPE_PIPE] = ACTIONS(2690),
    [anon_sym_DASH] = ACTIONS(2686),
    [anon_sym_DASH_EQ] = ACTIONS(2690),
    [anon_sym_DASH_DASH] = ACTIONS(2690),
    [anon_sym_PLUS] = ACTIONS(2686),
    [anon_sym_PLUS_EQ] = ACTIONS(2690),
    [anon_sym_PLUS_PLUS] = ACTIONS(2690),
    [anon_sym_LT] = ACTIONS(2686),
    [anon_sym_LT_EQ] = ACTIONS(2690),
    [anon_sym_LT_LT] = ACTIONS(2686),
    [anon_sym_LT_LT_EQ] = ACTIONS(2690),
    [anon_sym_GT] = ACTIONS(2686),
    [anon_sym_GT_EQ] = ACTIONS(2690),
    [anon_sym_GT_GT_EQ] = ACTIONS(2690),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2690),
    [anon_sym_GT_GT] = ACTIONS(2686),
    [anon_sym_GT_GT_GT] = ACTIONS(2686),
    [anon_sym_BANG] = ACTIONS(2686),
    [anon_sym_BANG_EQ] = ACTIONS(2690),
    [anon_sym_LPAREN] = ACTIONS(2690),
    [anon_sym_RPAREN] = ACTIONS(2690),
    [anon_sym_LBRACK] = ACTIONS(2690),
    [anon_sym_RBRACK] = ACTIONS(2690),
    [anon_sym_QMARK] = ACTIONS(2690),
    [anon_sym_COMMA] = ACTIONS(2690),
    [anon_sym_SEMI] = ACTIONS(2690),
    [anon_sym_COLON] = ACTIONS(2690),
    [anon_sym_DOLLAR] = ACTIONS(2690),
    [anon_sym_EQ] = ACTIONS(2686),
    [anon_sym_EQ_EQ] = ACTIONS(2690),
    [anon_sym_STAR] = ACTIONS(2686),
    [anon_sym_STAR_EQ] = ACTIONS(2690),
    [anon_sym_PERCENT] = ACTIONS(2686),
    [anon_sym_PERCENT_EQ] = ACTIONS(2690),
    [anon_sym_CARET] = ACTIONS(2686),
    [anon_sym_CARET_EQ] = ACTIONS(2690),
    [anon_sym_CARET_CARET] = ACTIONS(2686),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2690),
    [anon_sym_TILDE] = ACTIONS(2686),
    [anon_sym_TILDE_EQ] = ACTIONS(2690),
    [anon_sym_AT] = ACTIONS(2690),
    [anon_sym_EQ_GT] = ACTIONS(2690),
    [anon_sym_POUND] = ACTIONS(2690),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2690),
    [sym_float_literal] = ACTIONS(2690),
    [sym__string] = ACTIONS(2682),
  },
  [561] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(564),
    [sym__token_string_token] = STATE(564),
    [sym__token_no_braces] = STATE(564),
    [sym_keyword] = STATE(564),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(564),
    [sym_char_literal] = STATE(564),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2692),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2694),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2692),
    [anon_sym_SLASH_EQ] = ACTIONS(2696),
    [anon_sym_DOT] = ACTIONS(2692),
    [anon_sym_DOT_DOT] = ACTIONS(2692),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2696),
    [anon_sym_AMP] = ACTIONS(2692),
    [anon_sym_AMP_EQ] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(2696),
    [anon_sym_PIPE] = ACTIONS(2692),
    [anon_sym_PIPE_EQ] = ACTIONS(2696),
    [anon_sym_PIPE_PIPE] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2692),
    [anon_sym_DASH_EQ] = ACTIONS(2696),
    [anon_sym_DASH_DASH] = ACTIONS(2696),
    [anon_sym_PLUS] = ACTIONS(2692),
    [anon_sym_PLUS_EQ] = ACTIONS(2696),
    [anon_sym_PLUS_PLUS] = ACTIONS(2696),
    [anon_sym_LT] = ACTIONS(2692),
    [anon_sym_LT_EQ] = ACTIONS(2696),
    [anon_sym_LT_LT] = ACTIONS(2692),
    [anon_sym_LT_LT_EQ] = ACTIONS(2696),
    [anon_sym_GT] = ACTIONS(2692),
    [anon_sym_GT_EQ] = ACTIONS(2696),
    [anon_sym_GT_GT_EQ] = ACTIONS(2696),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2696),
    [anon_sym_GT_GT] = ACTIONS(2692),
    [anon_sym_GT_GT_GT] = ACTIONS(2692),
    [anon_sym_BANG] = ACTIONS(2692),
    [anon_sym_BANG_EQ] = ACTIONS(2696),
    [anon_sym_LPAREN] = ACTIONS(2696),
    [anon_sym_RPAREN] = ACTIONS(2696),
    [anon_sym_LBRACK] = ACTIONS(2696),
    [anon_sym_RBRACK] = ACTIONS(2696),
    [anon_sym_QMARK] = ACTIONS(2696),
    [anon_sym_COMMA] = ACTIONS(2696),
    [anon_sym_SEMI] = ACTIONS(2696),
    [anon_sym_COLON] = ACTIONS(2696),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_EQ] = ACTIONS(2692),
    [anon_sym_EQ_EQ] = ACTIONS(2696),
    [anon_sym_STAR] = ACTIONS(2692),
    [anon_sym_STAR_EQ] = ACTIONS(2696),
    [anon_sym_PERCENT] = ACTIONS(2692),
    [anon_sym_PERCENT_EQ] = ACTIONS(2696),
    [anon_sym_CARET] = ACTIONS(2692),
    [anon_sym_CARET_EQ] = ACTIONS(2696),
    [anon_sym_CARET_CARET] = ACTIONS(2692),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2696),
    [anon_sym_TILDE] = ACTIONS(2692),
    [anon_sym_TILDE_EQ] = ACTIONS(2696),
    [anon_sym_AT] = ACTIONS(2696),
    [anon_sym_EQ_GT] = ACTIONS(2696),
    [anon_sym_POUND] = ACTIONS(2696),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2696),
    [sym_float_literal] = ACTIONS(2696),
    [sym__string] = ACTIONS(2682),
  },
  [562] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [563] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(570),
    [sym__token_string_token] = STATE(570),
    [sym__token_no_braces] = STATE(570),
    [sym_keyword] = STATE(570),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(570),
    [sym_char_literal] = STATE(570),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2700),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2702),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_SLASH_EQ] = ACTIONS(2704),
    [anon_sym_DOT] = ACTIONS(2700),
    [anon_sym_DOT_DOT] = ACTIONS(2700),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2704),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_AMP_EQ] = ACTIONS(2704),
    [anon_sym_AMP_AMP] = ACTIONS(2704),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_PIPE_EQ] = ACTIONS(2704),
    [anon_sym_PIPE_PIPE] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_DASH_EQ] = ACTIONS(2704),
    [anon_sym_DASH_DASH] = ACTIONS(2704),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_PLUS_EQ] = ACTIONS(2704),
    [anon_sym_PLUS_PLUS] = ACTIONS(2704),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2704),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_LT_LT_EQ] = ACTIONS(2704),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_GT_EQ] = ACTIONS(2704),
    [anon_sym_GT_GT_EQ] = ACTIONS(2704),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2704),
    [anon_sym_GT_GT] = ACTIONS(2700),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_BANG] = ACTIONS(2700),
    [anon_sym_BANG_EQ] = ACTIONS(2704),
    [anon_sym_LPAREN] = ACTIONS(2704),
    [anon_sym_RPAREN] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(2704),
    [anon_sym_RBRACK] = ACTIONS(2704),
    [anon_sym_QMARK] = ACTIONS(2704),
    [anon_sym_COMMA] = ACTIONS(2704),
    [anon_sym_SEMI] = ACTIONS(2704),
    [anon_sym_COLON] = ACTIONS(2704),
    [anon_sym_DOLLAR] = ACTIONS(2704),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2704),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_STAR_EQ] = ACTIONS(2704),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_PERCENT_EQ] = ACTIONS(2704),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_CARET_EQ] = ACTIONS(2704),
    [anon_sym_CARET_CARET] = ACTIONS(2700),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2700),
    [anon_sym_TILDE_EQ] = ACTIONS(2704),
    [anon_sym_AT] = ACTIONS(2704),
    [anon_sym_EQ_GT] = ACTIONS(2704),
    [anon_sym_POUND] = ACTIONS(2704),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2704),
    [sym_float_literal] = ACTIONS(2704),
    [sym__string] = ACTIONS(2682),
  },
  [564] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2706),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [565] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(581),
    [sym__token_string_token] = STATE(581),
    [sym__token_no_braces] = STATE(581),
    [sym_keyword] = STATE(581),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(581),
    [sym_char_literal] = STATE(581),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2708),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2710),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2708),
    [anon_sym_SLASH_EQ] = ACTIONS(2712),
    [anon_sym_DOT] = ACTIONS(2708),
    [anon_sym_DOT_DOT] = ACTIONS(2708),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2712),
    [anon_sym_AMP] = ACTIONS(2708),
    [anon_sym_AMP_EQ] = ACTIONS(2712),
    [anon_sym_AMP_AMP] = ACTIONS(2712),
    [anon_sym_PIPE] = ACTIONS(2708),
    [anon_sym_PIPE_EQ] = ACTIONS(2712),
    [anon_sym_PIPE_PIPE] = ACTIONS(2712),
    [anon_sym_DASH] = ACTIONS(2708),
    [anon_sym_DASH_EQ] = ACTIONS(2712),
    [anon_sym_DASH_DASH] = ACTIONS(2712),
    [anon_sym_PLUS] = ACTIONS(2708),
    [anon_sym_PLUS_EQ] = ACTIONS(2712),
    [anon_sym_PLUS_PLUS] = ACTIONS(2712),
    [anon_sym_LT] = ACTIONS(2708),
    [anon_sym_LT_EQ] = ACTIONS(2712),
    [anon_sym_LT_LT] = ACTIONS(2708),
    [anon_sym_LT_LT_EQ] = ACTIONS(2712),
    [anon_sym_GT] = ACTIONS(2708),
    [anon_sym_GT_EQ] = ACTIONS(2712),
    [anon_sym_GT_GT_EQ] = ACTIONS(2712),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2712),
    [anon_sym_GT_GT] = ACTIONS(2708),
    [anon_sym_GT_GT_GT] = ACTIONS(2708),
    [anon_sym_BANG] = ACTIONS(2708),
    [anon_sym_BANG_EQ] = ACTIONS(2712),
    [anon_sym_LPAREN] = ACTIONS(2712),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(2712),
    [anon_sym_RBRACK] = ACTIONS(2712),
    [anon_sym_QMARK] = ACTIONS(2712),
    [anon_sym_COMMA] = ACTIONS(2712),
    [anon_sym_SEMI] = ACTIONS(2712),
    [anon_sym_COLON] = ACTIONS(2712),
    [anon_sym_DOLLAR] = ACTIONS(2712),
    [anon_sym_EQ] = ACTIONS(2708),
    [anon_sym_EQ_EQ] = ACTIONS(2712),
    [anon_sym_STAR] = ACTIONS(2708),
    [anon_sym_STAR_EQ] = ACTIONS(2712),
    [anon_sym_PERCENT] = ACTIONS(2708),
    [anon_sym_PERCENT_EQ] = ACTIONS(2712),
    [anon_sym_CARET] = ACTIONS(2708),
    [anon_sym_CARET_EQ] = ACTIONS(2712),
    [anon_sym_CARET_CARET] = ACTIONS(2708),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2712),
    [anon_sym_TILDE] = ACTIONS(2708),
    [anon_sym_TILDE_EQ] = ACTIONS(2712),
    [anon_sym_AT] = ACTIONS(2712),
    [anon_sym_EQ_GT] = ACTIONS(2712),
    [anon_sym_POUND] = ACTIONS(2712),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2712),
    [sym_float_literal] = ACTIONS(2712),
    [sym__string] = ACTIONS(2682),
  },
  [566] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(562),
    [sym__token_string_token] = STATE(562),
    [sym__token_no_braces] = STATE(562),
    [sym_keyword] = STATE(562),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(562),
    [sym_char_literal] = STATE(562),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2714),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2714),
    [anon_sym_SLASH_EQ] = ACTIONS(2718),
    [anon_sym_DOT] = ACTIONS(2714),
    [anon_sym_DOT_DOT] = ACTIONS(2714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2718),
    [anon_sym_AMP] = ACTIONS(2714),
    [anon_sym_AMP_EQ] = ACTIONS(2718),
    [anon_sym_AMP_AMP] = ACTIONS(2718),
    [anon_sym_PIPE] = ACTIONS(2714),
    [anon_sym_PIPE_EQ] = ACTIONS(2718),
    [anon_sym_PIPE_PIPE] = ACTIONS(2718),
    [anon_sym_DASH] = ACTIONS(2714),
    [anon_sym_DASH_EQ] = ACTIONS(2718),
    [anon_sym_DASH_DASH] = ACTIONS(2718),
    [anon_sym_PLUS] = ACTIONS(2714),
    [anon_sym_PLUS_EQ] = ACTIONS(2718),
    [anon_sym_PLUS_PLUS] = ACTIONS(2718),
    [anon_sym_LT] = ACTIONS(2714),
    [anon_sym_LT_EQ] = ACTIONS(2718),
    [anon_sym_LT_LT] = ACTIONS(2714),
    [anon_sym_LT_LT_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(2714),
    [anon_sym_GT_EQ] = ACTIONS(2718),
    [anon_sym_GT_GT_EQ] = ACTIONS(2718),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2718),
    [anon_sym_GT_GT] = ACTIONS(2714),
    [anon_sym_GT_GT_GT] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_BANG_EQ] = ACTIONS(2718),
    [anon_sym_LPAREN] = ACTIONS(2718),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [anon_sym_LBRACK] = ACTIONS(2718),
    [anon_sym_RBRACK] = ACTIONS(2718),
    [anon_sym_QMARK] = ACTIONS(2718),
    [anon_sym_COMMA] = ACTIONS(2718),
    [anon_sym_SEMI] = ACTIONS(2718),
    [anon_sym_COLON] = ACTIONS(2718),
    [anon_sym_DOLLAR] = ACTIONS(2718),
    [anon_sym_EQ] = ACTIONS(2714),
    [anon_sym_EQ_EQ] = ACTIONS(2718),
    [anon_sym_STAR] = ACTIONS(2714),
    [anon_sym_STAR_EQ] = ACTIONS(2718),
    [anon_sym_PERCENT] = ACTIONS(2714),
    [anon_sym_PERCENT_EQ] = ACTIONS(2718),
    [anon_sym_CARET] = ACTIONS(2714),
    [anon_sym_CARET_EQ] = ACTIONS(2718),
    [anon_sym_CARET_CARET] = ACTIONS(2714),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2718),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_TILDE_EQ] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(2718),
    [anon_sym_EQ_GT] = ACTIONS(2718),
    [anon_sym_POUND] = ACTIONS(2718),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2718),
    [sym_float_literal] = ACTIONS(2718),
    [sym__string] = ACTIONS(2682),
  },
  [567] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2720),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [568] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(579),
    [sym__token_string_token] = STATE(579),
    [sym__token_no_braces] = STATE(579),
    [sym_keyword] = STATE(579),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(579),
    [sym_char_literal] = STATE(579),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2722),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2724),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2722),
    [anon_sym_SLASH_EQ] = ACTIONS(2726),
    [anon_sym_DOT] = ACTIONS(2722),
    [anon_sym_DOT_DOT] = ACTIONS(2722),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2726),
    [anon_sym_AMP] = ACTIONS(2722),
    [anon_sym_AMP_EQ] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(2726),
    [anon_sym_PIPE] = ACTIONS(2722),
    [anon_sym_PIPE_EQ] = ACTIONS(2726),
    [anon_sym_PIPE_PIPE] = ACTIONS(2726),
    [anon_sym_DASH] = ACTIONS(2722),
    [anon_sym_DASH_EQ] = ACTIONS(2726),
    [anon_sym_DASH_DASH] = ACTIONS(2726),
    [anon_sym_PLUS] = ACTIONS(2722),
    [anon_sym_PLUS_EQ] = ACTIONS(2726),
    [anon_sym_PLUS_PLUS] = ACTIONS(2726),
    [anon_sym_LT] = ACTIONS(2722),
    [anon_sym_LT_EQ] = ACTIONS(2726),
    [anon_sym_LT_LT] = ACTIONS(2722),
    [anon_sym_LT_LT_EQ] = ACTIONS(2726),
    [anon_sym_GT] = ACTIONS(2722),
    [anon_sym_GT_EQ] = ACTIONS(2726),
    [anon_sym_GT_GT_EQ] = ACTIONS(2726),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2726),
    [anon_sym_GT_GT] = ACTIONS(2722),
    [anon_sym_GT_GT_GT] = ACTIONS(2722),
    [anon_sym_BANG] = ACTIONS(2722),
    [anon_sym_BANG_EQ] = ACTIONS(2726),
    [anon_sym_LPAREN] = ACTIONS(2726),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [anon_sym_LBRACK] = ACTIONS(2726),
    [anon_sym_RBRACK] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2726),
    [anon_sym_COMMA] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2726),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_DOLLAR] = ACTIONS(2726),
    [anon_sym_EQ] = ACTIONS(2722),
    [anon_sym_EQ_EQ] = ACTIONS(2726),
    [anon_sym_STAR] = ACTIONS(2722),
    [anon_sym_STAR_EQ] = ACTIONS(2726),
    [anon_sym_PERCENT] = ACTIONS(2722),
    [anon_sym_PERCENT_EQ] = ACTIONS(2726),
    [anon_sym_CARET] = ACTIONS(2722),
    [anon_sym_CARET_EQ] = ACTIONS(2726),
    [anon_sym_CARET_CARET] = ACTIONS(2722),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2726),
    [anon_sym_TILDE] = ACTIONS(2722),
    [anon_sym_TILDE_EQ] = ACTIONS(2726),
    [anon_sym_AT] = ACTIONS(2726),
    [anon_sym_EQ_GT] = ACTIONS(2726),
    [anon_sym_POUND] = ACTIONS(2726),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2726),
    [sym_float_literal] = ACTIONS(2726),
    [sym__string] = ACTIONS(2682),
  },
  [569] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(571),
    [sym__token_string_token] = STATE(571),
    [sym__token_no_braces] = STATE(571),
    [sym_keyword] = STATE(571),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(571),
    [sym_char_literal] = STATE(571),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2728),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2730),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2728),
    [anon_sym_SLASH_EQ] = ACTIONS(2732),
    [anon_sym_DOT] = ACTIONS(2728),
    [anon_sym_DOT_DOT] = ACTIONS(2728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2732),
    [anon_sym_AMP] = ACTIONS(2728),
    [anon_sym_AMP_EQ] = ACTIONS(2732),
    [anon_sym_AMP_AMP] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(2728),
    [anon_sym_PIPE_EQ] = ACTIONS(2732),
    [anon_sym_PIPE_PIPE] = ACTIONS(2732),
    [anon_sym_DASH] = ACTIONS(2728),
    [anon_sym_DASH_EQ] = ACTIONS(2732),
    [anon_sym_DASH_DASH] = ACTIONS(2732),
    [anon_sym_PLUS] = ACTIONS(2728),
    [anon_sym_PLUS_EQ] = ACTIONS(2732),
    [anon_sym_PLUS_PLUS] = ACTIONS(2732),
    [anon_sym_LT] = ACTIONS(2728),
    [anon_sym_LT_EQ] = ACTIONS(2732),
    [anon_sym_LT_LT] = ACTIONS(2728),
    [anon_sym_LT_LT_EQ] = ACTIONS(2732),
    [anon_sym_GT] = ACTIONS(2728),
    [anon_sym_GT_EQ] = ACTIONS(2732),
    [anon_sym_GT_GT_EQ] = ACTIONS(2732),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2732),
    [anon_sym_GT_GT] = ACTIONS(2728),
    [anon_sym_GT_GT_GT] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2728),
    [anon_sym_BANG_EQ] = ACTIONS(2732),
    [anon_sym_LPAREN] = ACTIONS(2732),
    [anon_sym_RPAREN] = ACTIONS(2732),
    [anon_sym_LBRACK] = ACTIONS(2732),
    [anon_sym_RBRACK] = ACTIONS(2732),
    [anon_sym_QMARK] = ACTIONS(2732),
    [anon_sym_COMMA] = ACTIONS(2732),
    [anon_sym_SEMI] = ACTIONS(2732),
    [anon_sym_COLON] = ACTIONS(2732),
    [anon_sym_DOLLAR] = ACTIONS(2732),
    [anon_sym_EQ] = ACTIONS(2728),
    [anon_sym_EQ_EQ] = ACTIONS(2732),
    [anon_sym_STAR] = ACTIONS(2728),
    [anon_sym_STAR_EQ] = ACTIONS(2732),
    [anon_sym_PERCENT] = ACTIONS(2728),
    [anon_sym_PERCENT_EQ] = ACTIONS(2732),
    [anon_sym_CARET] = ACTIONS(2728),
    [anon_sym_CARET_EQ] = ACTIONS(2732),
    [anon_sym_CARET_CARET] = ACTIONS(2728),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2732),
    [anon_sym_TILDE] = ACTIONS(2728),
    [anon_sym_TILDE_EQ] = ACTIONS(2732),
    [anon_sym_AT] = ACTIONS(2732),
    [anon_sym_EQ_GT] = ACTIONS(2732),
    [anon_sym_POUND] = ACTIONS(2732),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2732),
    [sym_float_literal] = ACTIONS(2732),
    [sym__string] = ACTIONS(2682),
  },
  [570] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [571] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [572] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2738),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [573] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(572),
    [sym__token_string_token] = STATE(572),
    [sym__token_no_braces] = STATE(572),
    [sym_keyword] = STATE(572),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(572),
    [sym_char_literal] = STATE(572),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2740),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2742),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2740),
    [anon_sym_SLASH_EQ] = ACTIONS(2744),
    [anon_sym_DOT] = ACTIONS(2740),
    [anon_sym_DOT_DOT] = ACTIONS(2740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2744),
    [anon_sym_AMP] = ACTIONS(2740),
    [anon_sym_AMP_EQ] = ACTIONS(2744),
    [anon_sym_AMP_AMP] = ACTIONS(2744),
    [anon_sym_PIPE] = ACTIONS(2740),
    [anon_sym_PIPE_EQ] = ACTIONS(2744),
    [anon_sym_PIPE_PIPE] = ACTIONS(2744),
    [anon_sym_DASH] = ACTIONS(2740),
    [anon_sym_DASH_EQ] = ACTIONS(2744),
    [anon_sym_DASH_DASH] = ACTIONS(2744),
    [anon_sym_PLUS] = ACTIONS(2740),
    [anon_sym_PLUS_EQ] = ACTIONS(2744),
    [anon_sym_PLUS_PLUS] = ACTIONS(2744),
    [anon_sym_LT] = ACTIONS(2740),
    [anon_sym_LT_EQ] = ACTIONS(2744),
    [anon_sym_LT_LT] = ACTIONS(2740),
    [anon_sym_LT_LT_EQ] = ACTIONS(2744),
    [anon_sym_GT] = ACTIONS(2740),
    [anon_sym_GT_EQ] = ACTIONS(2744),
    [anon_sym_GT_GT_EQ] = ACTIONS(2744),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2744),
    [anon_sym_GT_GT] = ACTIONS(2740),
    [anon_sym_GT_GT_GT] = ACTIONS(2740),
    [anon_sym_BANG] = ACTIONS(2740),
    [anon_sym_BANG_EQ] = ACTIONS(2744),
    [anon_sym_LPAREN] = ACTIONS(2744),
    [anon_sym_RPAREN] = ACTIONS(2744),
    [anon_sym_LBRACK] = ACTIONS(2744),
    [anon_sym_RBRACK] = ACTIONS(2744),
    [anon_sym_QMARK] = ACTIONS(2744),
    [anon_sym_COMMA] = ACTIONS(2744),
    [anon_sym_SEMI] = ACTIONS(2744),
    [anon_sym_COLON] = ACTIONS(2744),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_EQ] = ACTIONS(2740),
    [anon_sym_EQ_EQ] = ACTIONS(2744),
    [anon_sym_STAR] = ACTIONS(2740),
    [anon_sym_STAR_EQ] = ACTIONS(2744),
    [anon_sym_PERCENT] = ACTIONS(2740),
    [anon_sym_PERCENT_EQ] = ACTIONS(2744),
    [anon_sym_CARET] = ACTIONS(2740),
    [anon_sym_CARET_EQ] = ACTIONS(2744),
    [anon_sym_CARET_CARET] = ACTIONS(2740),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2744),
    [anon_sym_TILDE] = ACTIONS(2740),
    [anon_sym_TILDE_EQ] = ACTIONS(2744),
    [anon_sym_AT] = ACTIONS(2744),
    [anon_sym_EQ_GT] = ACTIONS(2744),
    [anon_sym_POUND] = ACTIONS(2744),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2744),
    [sym_float_literal] = ACTIONS(2744),
    [sym__string] = ACTIONS(2682),
  },
  [574] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2746),
    [anon_sym_q_LBRACE] = ACTIONS(2749),
    [anon_sym_RBRACE] = ACTIONS(2752),
    [anon_sym_LBRACE] = ACTIONS(2754),
    [anon_sym_SLASH] = ACTIONS(2746),
    [anon_sym_SLASH_EQ] = ACTIONS(2757),
    [anon_sym_DOT] = ACTIONS(2746),
    [anon_sym_DOT_DOT] = ACTIONS(2746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2757),
    [anon_sym_AMP] = ACTIONS(2746),
    [anon_sym_AMP_EQ] = ACTIONS(2757),
    [anon_sym_AMP_AMP] = ACTIONS(2757),
    [anon_sym_PIPE] = ACTIONS(2746),
    [anon_sym_PIPE_EQ] = ACTIONS(2757),
    [anon_sym_PIPE_PIPE] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2746),
    [anon_sym_DASH_EQ] = ACTIONS(2757),
    [anon_sym_DASH_DASH] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2746),
    [anon_sym_PLUS_EQ] = ACTIONS(2757),
    [anon_sym_PLUS_PLUS] = ACTIONS(2757),
    [anon_sym_LT] = ACTIONS(2746),
    [anon_sym_LT_EQ] = ACTIONS(2757),
    [anon_sym_LT_LT] = ACTIONS(2746),
    [anon_sym_LT_LT_EQ] = ACTIONS(2757),
    [anon_sym_GT] = ACTIONS(2746),
    [anon_sym_GT_EQ] = ACTIONS(2757),
    [anon_sym_GT_GT_EQ] = ACTIONS(2757),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2757),
    [anon_sym_GT_GT] = ACTIONS(2746),
    [anon_sym_GT_GT_GT] = ACTIONS(2746),
    [anon_sym_BANG] = ACTIONS(2746),
    [anon_sym_BANG_EQ] = ACTIONS(2757),
    [anon_sym_LPAREN] = ACTIONS(2757),
    [anon_sym_RPAREN] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2757),
    [anon_sym_RBRACK] = ACTIONS(2757),
    [anon_sym_QMARK] = ACTIONS(2757),
    [anon_sym_COMMA] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2757),
    [anon_sym_COLON] = ACTIONS(2757),
    [anon_sym_DOLLAR] = ACTIONS(2757),
    [anon_sym_EQ] = ACTIONS(2746),
    [anon_sym_EQ_EQ] = ACTIONS(2757),
    [anon_sym_STAR] = ACTIONS(2746),
    [anon_sym_STAR_EQ] = ACTIONS(2757),
    [anon_sym_PERCENT] = ACTIONS(2746),
    [anon_sym_PERCENT_EQ] = ACTIONS(2757),
    [anon_sym_CARET] = ACTIONS(2746),
    [anon_sym_CARET_EQ] = ACTIONS(2757),
    [anon_sym_CARET_CARET] = ACTIONS(2746),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2757),
    [anon_sym_TILDE] = ACTIONS(2746),
    [anon_sym_TILDE_EQ] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2757),
    [anon_sym_EQ_GT] = ACTIONS(2757),
    [anon_sym_POUND] = ACTIONS(2757),
    [sym_bool] = ACTIONS(2760),
    [sym_byte] = ACTIONS(2760),
    [sym_ubyte] = ACTIONS(2760),
    [sym_char] = ACTIONS(2760),
    [sym_short] = ACTIONS(2760),
    [sym_ushort] = ACTIONS(2760),
    [sym_int] = ACTIONS(2760),
    [sym_uint] = ACTIONS(2760),
    [sym_long] = ACTIONS(2760),
    [sym_ulong] = ACTIONS(2760),
    [sym_cent] = ACTIONS(2760),
    [sym_ucent] = ACTIONS(2760),
    [sym_wchar] = ACTIONS(2760),
    [sym_dchar] = ACTIONS(2760),
    [sym_float] = ACTIONS(2760),
    [sym_double] = ACTIONS(2760),
    [sym_real] = ACTIONS(2760),
    [sym_ifloat] = ACTIONS(2760),
    [sym_idouble] = ACTIONS(2760),
    [sym_ireal] = ACTIONS(2760),
    [sym_cfloat] = ACTIONS(2760),
    [sym_cdouble] = ACTIONS(2760),
    [sym_creal] = ACTIONS(2760),
    [sym_size_t] = ACTIONS(2760),
    [sym_ptrdiff_t] = ACTIONS(2760),
    [sym_string] = ACTIONS(2760),
    [sym_cstring] = ACTIONS(2760),
    [sym_dstring] = ACTIONS(2760),
    [sym_wstring] = ACTIONS(2760),
    [sym_noreturn] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_null] = ACTIONS(2760),
    [sym_super] = ACTIONS(2760),
    [sym_this] = ACTIONS(2760),
    [sym_abstract] = ACTIONS(2760),
    [sym_alias] = ACTIONS(2760),
    [sym_align] = ACTIONS(2760),
    [sym_asm] = ACTIONS(2760),
    [sym_assert] = ACTIONS(2760),
    [sym_auto] = ACTIONS(2760),
    [sym_break] = ACTIONS(2760),
    [sym_case] = ACTIONS(2760),
    [sym_cast] = ACTIONS(2760),
    [sym_catch] = ACTIONS(2760),
    [sym_class] = ACTIONS(2760),
    [sym_const] = ACTIONS(2763),
    [sym_continue] = ACTIONS(2760),
    [sym_debug] = ACTIONS(2760),
    [sym_default] = ACTIONS(2760),
    [sym_delegate] = ACTIONS(2760),
    [sym_delete] = ACTIONS(2760),
    [sym_deprecated] = ACTIONS(2760),
    [sym_do] = ACTIONS(2760),
    [sym_else] = ACTIONS(2760),
    [sym_enum] = ACTIONS(2760),
    [sym_export] = ACTIONS(2760),
    [sym_extern] = ACTIONS(2760),
    [sym_final] = ACTIONS(2760),
    [sym_finally] = ACTIONS(2760),
    [sym_for] = ACTIONS(2760),
    [sym_foreach] = ACTIONS(2760),
    [sym_foreach_reverse] = ACTIONS(2760),
    [sym_function] = ACTIONS(2760),
    [sym_goto] = ACTIONS(2760),
    [sym_if] = ACTIONS(2760),
    [sym_immutable] = ACTIONS(2763),
    [sym_import] = ACTIONS(2760),
    [sym_in] = ACTIONS(2760),
    [sym_inout] = ACTIONS(2763),
    [sym_interface] = ACTIONS(2760),
    [sym_invariant] = ACTIONS(2760),
    [sym_is] = ACTIONS(2760),
    [sym_lazy] = ACTIONS(2760),
    [sym_mixin] = ACTIONS(2760),
    [sym_module] = ACTIONS(2760),
    [sym_new] = ACTIONS(2760),
    [sym_nothrow] = ACTIONS(2760),
    [sym_out] = ACTIONS(2760),
    [sym_override] = ACTIONS(2760),
    [sym_package] = ACTIONS(2760),
    [sym_pragma] = ACTIONS(2760),
    [sym_private] = ACTIONS(2760),
    [sym_protected] = ACTIONS(2760),
    [sym_public] = ACTIONS(2760),
    [sym_pure] = ACTIONS(2760),
    [sym_ref] = ACTIONS(2760),
    [sym_return] = ACTIONS(2760),
    [sym_scope] = ACTIONS(2760),
    [sym_shared] = ACTIONS(2763),
    [sym_static] = ACTIONS(2760),
    [sym_struct] = ACTIONS(2760),
    [sym_switch] = ACTIONS(2760),
    [sym_synchronized] = ACTIONS(2760),
    [sym_template] = ACTIONS(2760),
    [sym_throw] = ACTIONS(2760),
    [sym_try] = ACTIONS(2760),
    [sym_typeid] = ACTIONS(2760),
    [sym_typeof] = ACTIONS(2760),
    [sym_union] = ACTIONS(2760),
    [sym_unittest] = ACTIONS(2760),
    [sym_version] = ACTIONS(2760),
    [sym_while] = ACTIONS(2760),
    [sym_with] = ACTIONS(2760),
    [sym_parameters_] = ACTIONS(2760),
    [sym_gshared] = ACTIONS(2760),
    [sym_traits] = ACTIONS(2760),
    [sym_vector] = ACTIONS(2760),
    [sym_void] = ACTIONS(2760),
    [anon_sym_BQUOTE] = ACTIONS(2766),
    [anon_sym_r_DQUOTE] = ACTIONS(2769),
    [anon_sym_x_DQUOTE] = ACTIONS(2772),
    [anon_sym_DQUOTE] = ACTIONS(2775),
    [anon_sym_i_BQUOTE] = ACTIONS(2778),
    [anon_sym_i_DQUOTE] = ACTIONS(2781),
    [anon_sym_iq_LBRACE] = ACTIONS(2784),
    [aux_sym_char_literal_token1] = ACTIONS(2787),
    [anon_sym_SQUOTE] = ACTIONS(2790),
    [anon_sym___DATE__] = ACTIONS(2793),
    [anon_sym___FILE__] = ACTIONS(2793),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2793),
    [anon_sym___FUNCTION__] = ACTIONS(2793),
    [anon_sym___LINE__] = ACTIONS(2793),
    [anon_sym___MODULE__] = ACTIONS(2793),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2793),
    [anon_sym___TIME__] = ACTIONS(2793),
    [anon_sym___TIMESTAMP__] = ACTIONS(2793),
    [anon_sym___VENDOR__] = ACTIONS(2793),
    [anon_sym___VERSION__] = ACTIONS(2793),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2757),
    [sym_float_literal] = ACTIONS(2757),
    [sym__string] = ACTIONS(2796),
  },
  [575] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(567),
    [sym__token_string_token] = STATE(567),
    [sym__token_no_braces] = STATE(567),
    [sym_keyword] = STATE(567),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(567),
    [sym_char_literal] = STATE(567),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2799),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2801),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2799),
    [anon_sym_SLASH_EQ] = ACTIONS(2803),
    [anon_sym_DOT] = ACTIONS(2799),
    [anon_sym_DOT_DOT] = ACTIONS(2799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2803),
    [anon_sym_AMP] = ACTIONS(2799),
    [anon_sym_AMP_EQ] = ACTIONS(2803),
    [anon_sym_AMP_AMP] = ACTIONS(2803),
    [anon_sym_PIPE] = ACTIONS(2799),
    [anon_sym_PIPE_EQ] = ACTIONS(2803),
    [anon_sym_PIPE_PIPE] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2799),
    [anon_sym_DASH_EQ] = ACTIONS(2803),
    [anon_sym_DASH_DASH] = ACTIONS(2803),
    [anon_sym_PLUS] = ACTIONS(2799),
    [anon_sym_PLUS_EQ] = ACTIONS(2803),
    [anon_sym_PLUS_PLUS] = ACTIONS(2803),
    [anon_sym_LT] = ACTIONS(2799),
    [anon_sym_LT_EQ] = ACTIONS(2803),
    [anon_sym_LT_LT] = ACTIONS(2799),
    [anon_sym_LT_LT_EQ] = ACTIONS(2803),
    [anon_sym_GT] = ACTIONS(2799),
    [anon_sym_GT_EQ] = ACTIONS(2803),
    [anon_sym_GT_GT_EQ] = ACTIONS(2803),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2803),
    [anon_sym_GT_GT] = ACTIONS(2799),
    [anon_sym_GT_GT_GT] = ACTIONS(2799),
    [anon_sym_BANG] = ACTIONS(2799),
    [anon_sym_BANG_EQ] = ACTIONS(2803),
    [anon_sym_LPAREN] = ACTIONS(2803),
    [anon_sym_RPAREN] = ACTIONS(2803),
    [anon_sym_LBRACK] = ACTIONS(2803),
    [anon_sym_RBRACK] = ACTIONS(2803),
    [anon_sym_QMARK] = ACTIONS(2803),
    [anon_sym_COMMA] = ACTIONS(2803),
    [anon_sym_SEMI] = ACTIONS(2803),
    [anon_sym_COLON] = ACTIONS(2803),
    [anon_sym_DOLLAR] = ACTIONS(2803),
    [anon_sym_EQ] = ACTIONS(2799),
    [anon_sym_EQ_EQ] = ACTIONS(2803),
    [anon_sym_STAR] = ACTIONS(2799),
    [anon_sym_STAR_EQ] = ACTIONS(2803),
    [anon_sym_PERCENT] = ACTIONS(2799),
    [anon_sym_PERCENT_EQ] = ACTIONS(2803),
    [anon_sym_CARET] = ACTIONS(2799),
    [anon_sym_CARET_EQ] = ACTIONS(2803),
    [anon_sym_CARET_CARET] = ACTIONS(2799),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2799),
    [anon_sym_TILDE_EQ] = ACTIONS(2803),
    [anon_sym_AT] = ACTIONS(2803),
    [anon_sym_EQ_GT] = ACTIONS(2803),
    [anon_sym_POUND] = ACTIONS(2803),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2803),
    [sym_float_literal] = ACTIONS(2803),
    [sym__string] = ACTIONS(2682),
  },
  [576] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(578),
    [sym__token_string_token] = STATE(578),
    [sym__token_no_braces] = STATE(578),
    [sym_keyword] = STATE(578),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(578),
    [sym_char_literal] = STATE(578),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2805),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2805),
    [anon_sym_SLASH_EQ] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2805),
    [anon_sym_DOT_DOT] = ACTIONS(2805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2805),
    [anon_sym_AMP_EQ] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2805),
    [anon_sym_PIPE_EQ] = ACTIONS(2809),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2805),
    [anon_sym_DASH_EQ] = ACTIONS(2809),
    [anon_sym_DASH_DASH] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2805),
    [anon_sym_PLUS_EQ] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2805),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2805),
    [anon_sym_LT_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2805),
    [anon_sym_GT_EQ] = ACTIONS(2809),
    [anon_sym_GT_GT_EQ] = ACTIONS(2809),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2805),
    [anon_sym_GT_GT_GT] = ACTIONS(2805),
    [anon_sym_BANG] = ACTIONS(2805),
    [anon_sym_BANG_EQ] = ACTIONS(2809),
    [anon_sym_LPAREN] = ACTIONS(2809),
    [anon_sym_RPAREN] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2809),
    [anon_sym_RBRACK] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_COLON] = ACTIONS(2809),
    [anon_sym_DOLLAR] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2805),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2805),
    [anon_sym_STAR_EQ] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2805),
    [anon_sym_PERCENT_EQ] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2805),
    [anon_sym_CARET_EQ] = ACTIONS(2809),
    [anon_sym_CARET_CARET] = ACTIONS(2805),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2809),
    [anon_sym_TILDE] = ACTIONS(2805),
    [anon_sym_TILDE_EQ] = ACTIONS(2809),
    [anon_sym_AT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2809),
    [anon_sym_POUND] = ACTIONS(2809),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2809),
    [sym_float_literal] = ACTIONS(2809),
    [sym__string] = ACTIONS(2682),
  },
  [577] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(559),
    [sym__token_string_token] = STATE(559),
    [sym__token_no_braces] = STATE(559),
    [sym_keyword] = STATE(559),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(559),
    [sym_char_literal] = STATE(559),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2811),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_DOT] = ACTIONS(2811),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2815),
    [anon_sym_AMP] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_DASH] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2811),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_LT] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT] = ACTIONS(2811),
    [anon_sym_GT_GT_GT] = ACTIONS(2811),
    [anon_sym_BANG] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2815),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_DOLLAR] = ACTIONS(2815),
    [anon_sym_EQ] = ACTIONS(2811),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_STAR] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_CARET] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_CARET_CARET] = ACTIONS(2811),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2815),
    [anon_sym_TILDE] = ACTIONS(2811),
    [anon_sym_TILDE_EQ] = ACTIONS(2815),
    [anon_sym_AT] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_POUND] = ACTIONS(2815),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2815),
    [sym_float_literal] = ACTIONS(2815),
    [sym__string] = ACTIONS(2682),
  },
  [578] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [579] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [580] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2821),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [581] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [582] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(580),
    [sym__token_string_token] = STATE(580),
    [sym__token_no_braces] = STATE(580),
    [sym_keyword] = STATE(580),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(580),
    [sym_char_literal] = STATE(580),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2825),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_DOT_DOT] = ACTIONS(2825),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2829),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_GT_GT_GT] = ACTIONS(2825),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2829),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_DOLLAR] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_CARET_CARET] = ACTIONS(2825),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2829),
    [anon_sym_TILDE] = ACTIONS(2825),
    [anon_sym_TILDE_EQ] = ACTIONS(2829),
    [anon_sym_AT] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_POUND] = ACTIONS(2829),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2829),
    [sym_float_literal] = ACTIONS(2829),
    [sym__string] = ACTIONS(2682),
  },
  [583] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [584] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(583),
    [sym__token_string_token] = STATE(583),
    [sym__token_no_braces] = STATE(583),
    [sym_keyword] = STATE(583),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(583),
    [sym_char_literal] = STATE(583),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2833),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_SLASH_EQ] = ACTIONS(2837),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_DOT_DOT] = ACTIONS(2833),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2837),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_AMP_EQ] = ACTIONS(2837),
    [anon_sym_AMP_AMP] = ACTIONS(2837),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_PIPE_EQ] = ACTIONS(2837),
    [anon_sym_PIPE_PIPE] = ACTIONS(2837),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_DASH_EQ] = ACTIONS(2837),
    [anon_sym_DASH_DASH] = ACTIONS(2837),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2837),
    [anon_sym_PLUS_PLUS] = ACTIONS(2837),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_LT_EQ] = ACTIONS(2837),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_LT_LT_EQ] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2837),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(2837),
    [anon_sym_RPAREN] = ACTIONS(2837),
    [anon_sym_LBRACK] = ACTIONS(2837),
    [anon_sym_RBRACK] = ACTIONS(2837),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2837),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_COLON] = ACTIONS(2837),
    [anon_sym_DOLLAR] = ACTIONS(2837),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2837),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_STAR_EQ] = ACTIONS(2837),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_PERCENT_EQ] = ACTIONS(2837),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_CARET_EQ] = ACTIONS(2837),
    [anon_sym_CARET_CARET] = ACTIONS(2833),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2837),
    [anon_sym_TILDE] = ACTIONS(2833),
    [anon_sym_TILDE_EQ] = ACTIONS(2837),
    [anon_sym_AT] = ACTIONS(2837),
    [anon_sym_EQ_GT] = ACTIONS(2837),
    [anon_sym_POUND] = ACTIONS(2837),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2837),
    [sym_float_literal] = ACTIONS(2837),
    [sym__string] = ACTIONS(2682),
  },
  [585] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2839),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [586] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(587),
    [sym__token_string_token] = STATE(587),
    [sym__token_no_braces] = STATE(587),
    [sym_keyword] = STATE(587),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(587),
    [sym_char_literal] = STATE(587),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2841),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2843),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2841),
    [anon_sym_SLASH_EQ] = ACTIONS(2845),
    [anon_sym_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT] = ACTIONS(2841),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2845),
    [anon_sym_AMP] = ACTIONS(2841),
    [anon_sym_AMP_EQ] = ACTIONS(2845),
    [anon_sym_AMP_AMP] = ACTIONS(2845),
    [anon_sym_PIPE] = ACTIONS(2841),
    [anon_sym_PIPE_EQ] = ACTIONS(2845),
    [anon_sym_PIPE_PIPE] = ACTIONS(2845),
    [anon_sym_DASH] = ACTIONS(2841),
    [anon_sym_DASH_EQ] = ACTIONS(2845),
    [anon_sym_DASH_DASH] = ACTIONS(2845),
    [anon_sym_PLUS] = ACTIONS(2841),
    [anon_sym_PLUS_EQ] = ACTIONS(2845),
    [anon_sym_PLUS_PLUS] = ACTIONS(2845),
    [anon_sym_LT] = ACTIONS(2841),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_LT_LT] = ACTIONS(2841),
    [anon_sym_LT_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2841),
    [anon_sym_GT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2845),
    [anon_sym_GT_GT] = ACTIONS(2841),
    [anon_sym_GT_GT_GT] = ACTIONS(2841),
    [anon_sym_BANG] = ACTIONS(2841),
    [anon_sym_BANG_EQ] = ACTIONS(2845),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_RPAREN] = ACTIONS(2845),
    [anon_sym_LBRACK] = ACTIONS(2845),
    [anon_sym_RBRACK] = ACTIONS(2845),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_COMMA] = ACTIONS(2845),
    [anon_sym_SEMI] = ACTIONS(2845),
    [anon_sym_COLON] = ACTIONS(2845),
    [anon_sym_DOLLAR] = ACTIONS(2845),
    [anon_sym_EQ] = ACTIONS(2841),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_STAR] = ACTIONS(2841),
    [anon_sym_STAR_EQ] = ACTIONS(2845),
    [anon_sym_PERCENT] = ACTIONS(2841),
    [anon_sym_PERCENT_EQ] = ACTIONS(2845),
    [anon_sym_CARET] = ACTIONS(2841),
    [anon_sym_CARET_EQ] = ACTIONS(2845),
    [anon_sym_CARET_CARET] = ACTIONS(2841),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2841),
    [anon_sym_TILDE_EQ] = ACTIONS(2845),
    [anon_sym_AT] = ACTIONS(2845),
    [anon_sym_EQ_GT] = ACTIONS(2845),
    [anon_sym_POUND] = ACTIONS(2845),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2845),
    [sym_float_literal] = ACTIONS(2845),
    [sym__string] = ACTIONS(2682),
  },
  [587] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(574),
    [sym__token_string_token] = STATE(574),
    [sym__token_no_braces] = STATE(574),
    [sym_keyword] = STATE(574),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(574),
    [sym_char_literal] = STATE(574),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2648),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2648),
    [anon_sym_SLASH_EQ] = ACTIONS(2656),
    [anon_sym_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT] = ACTIONS(2648),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2656),
    [anon_sym_AMP] = ACTIONS(2648),
    [anon_sym_AMP_EQ] = ACTIONS(2656),
    [anon_sym_AMP_AMP] = ACTIONS(2656),
    [anon_sym_PIPE] = ACTIONS(2648),
    [anon_sym_PIPE_EQ] = ACTIONS(2656),
    [anon_sym_PIPE_PIPE] = ACTIONS(2656),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DASH_EQ] = ACTIONS(2656),
    [anon_sym_DASH_DASH] = ACTIONS(2656),
    [anon_sym_PLUS] = ACTIONS(2648),
    [anon_sym_PLUS_EQ] = ACTIONS(2656),
    [anon_sym_PLUS_PLUS] = ACTIONS(2656),
    [anon_sym_LT] = ACTIONS(2648),
    [anon_sym_LT_EQ] = ACTIONS(2656),
    [anon_sym_LT_LT] = ACTIONS(2648),
    [anon_sym_LT_LT_EQ] = ACTIONS(2656),
    [anon_sym_GT] = ACTIONS(2648),
    [anon_sym_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2656),
    [anon_sym_GT_GT] = ACTIONS(2648),
    [anon_sym_GT_GT_GT] = ACTIONS(2648),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_BANG_EQ] = ACTIONS(2656),
    [anon_sym_LPAREN] = ACTIONS(2656),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [anon_sym_LBRACK] = ACTIONS(2656),
    [anon_sym_RBRACK] = ACTIONS(2656),
    [anon_sym_QMARK] = ACTIONS(2656),
    [anon_sym_COMMA] = ACTIONS(2656),
    [anon_sym_SEMI] = ACTIONS(2656),
    [anon_sym_COLON] = ACTIONS(2656),
    [anon_sym_DOLLAR] = ACTIONS(2656),
    [anon_sym_EQ] = ACTIONS(2648),
    [anon_sym_EQ_EQ] = ACTIONS(2656),
    [anon_sym_STAR] = ACTIONS(2648),
    [anon_sym_STAR_EQ] = ACTIONS(2656),
    [anon_sym_PERCENT] = ACTIONS(2648),
    [anon_sym_PERCENT_EQ] = ACTIONS(2656),
    [anon_sym_CARET] = ACTIONS(2648),
    [anon_sym_CARET_EQ] = ACTIONS(2656),
    [anon_sym_CARET_CARET] = ACTIONS(2648),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2656),
    [anon_sym_TILDE] = ACTIONS(2648),
    [anon_sym_TILDE_EQ] = ACTIONS(2656),
    [anon_sym_AT] = ACTIONS(2656),
    [anon_sym_EQ_GT] = ACTIONS(2656),
    [anon_sym_POUND] = ACTIONS(2656),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2656),
    [sym_float_literal] = ACTIONS(2656),
    [sym__string] = ACTIONS(2682),
  },
  [588] = {
    [sym_token_string] = STATE(641),
    [aux_sym__token_string_tokens] = STATE(585),
    [sym__token_string_token] = STATE(585),
    [sym__token_no_braces] = STATE(585),
    [sym_keyword] = STATE(585),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(585),
    [sym_char_literal] = STATE(585),
    [sym_special_keyword] = STATE(649),
    [sym_identifier] = ACTIONS(2849),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2849),
    [anon_sym_SLASH_EQ] = ACTIONS(2853),
    [anon_sym_DOT] = ACTIONS(2849),
    [anon_sym_DOT_DOT] = ACTIONS(2849),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2853),
    [anon_sym_AMP] = ACTIONS(2849),
    [anon_sym_AMP_EQ] = ACTIONS(2853),
    [anon_sym_AMP_AMP] = ACTIONS(2853),
    [anon_sym_PIPE] = ACTIONS(2849),
    [anon_sym_PIPE_EQ] = ACTIONS(2853),
    [anon_sym_PIPE_PIPE] = ACTIONS(2853),
    [anon_sym_DASH] = ACTIONS(2849),
    [anon_sym_DASH_EQ] = ACTIONS(2853),
    [anon_sym_DASH_DASH] = ACTIONS(2853),
    [anon_sym_PLUS] = ACTIONS(2849),
    [anon_sym_PLUS_EQ] = ACTIONS(2853),
    [anon_sym_PLUS_PLUS] = ACTIONS(2853),
    [anon_sym_LT] = ACTIONS(2849),
    [anon_sym_LT_EQ] = ACTIONS(2853),
    [anon_sym_LT_LT] = ACTIONS(2849),
    [anon_sym_LT_LT_EQ] = ACTIONS(2853),
    [anon_sym_GT] = ACTIONS(2849),
    [anon_sym_GT_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2853),
    [anon_sym_GT_GT] = ACTIONS(2849),
    [anon_sym_GT_GT_GT] = ACTIONS(2849),
    [anon_sym_BANG] = ACTIONS(2849),
    [anon_sym_BANG_EQ] = ACTIONS(2853),
    [anon_sym_LPAREN] = ACTIONS(2853),
    [anon_sym_RPAREN] = ACTIONS(2853),
    [anon_sym_LBRACK] = ACTIONS(2853),
    [anon_sym_RBRACK] = ACTIONS(2853),
    [anon_sym_QMARK] = ACTIONS(2853),
    [anon_sym_COMMA] = ACTIONS(2853),
    [anon_sym_SEMI] = ACTIONS(2853),
    [anon_sym_COLON] = ACTIONS(2853),
    [anon_sym_DOLLAR] = ACTIONS(2853),
    [anon_sym_EQ] = ACTIONS(2849),
    [anon_sym_EQ_EQ] = ACTIONS(2853),
    [anon_sym_STAR] = ACTIONS(2849),
    [anon_sym_STAR_EQ] = ACTIONS(2853),
    [anon_sym_PERCENT] = ACTIONS(2849),
    [anon_sym_PERCENT_EQ] = ACTIONS(2853),
    [anon_sym_CARET] = ACTIONS(2849),
    [anon_sym_CARET_EQ] = ACTIONS(2853),
    [anon_sym_CARET_CARET] = ACTIONS(2849),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2853),
    [anon_sym_TILDE] = ACTIONS(2849),
    [anon_sym_TILDE_EQ] = ACTIONS(2853),
    [anon_sym_AT] = ACTIONS(2853),
    [anon_sym_EQ_GT] = ACTIONS(2853),
    [anon_sym_POUND] = ACTIONS(2853),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2853),
    [sym_float_literal] = ACTIONS(2853),
    [sym__string] = ACTIONS(2682),
  },
  [589] = {
    [sym_import_declaration] = STATE(604),
    [sym_mixin_declaration] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym__declaration2] = STATE(604),
    [sym_variable_declaration] = STATE(604),
    [sym_manifest_constant] = STATE(604),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(604),
    [sym_alias_declaration] = STATE(604),
    [sym_alias_reassign] = STATE(604),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(604),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(604),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(604),
    [sym_union_declaration] = STATE(604),
    [sym_postblit] = STATE(604),
    [sym_invariant_declaration] = STATE(604),
    [sym_class_declaration] = STATE(604),
    [sym_constructor] = STATE(604),
    [sym_destructor] = STATE(604),
    [sym_alias_this] = STATE(604),
    [sym_interface_declaration] = STATE(604),
    [sym_enum_declaration] = STATE(604),
    [sym_anonymous_enum_declaration] = STATE(604),
    [sym_function_declaration] = STATE(604),
    [sym_template_declaration] = STATE(604),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(604),
    [sym_template_mixin] = STATE(604),
    [sym_conditional_declaration] = STATE(604),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(604),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(604),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(604),
    [sym_static_assert] = STATE(604),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(604),
    [aux_sym_source_file_repeat1] = STATE(604),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2642),
    [sym_assert] = ACTIONS(2642),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2642),
    [sym_case] = ACTIONS(2642),
    [sym_cast] = ACTIONS(2642),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2642),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2642),
    [sym_delegate] = ACTIONS(2642),
    [sym_delete] = ACTIONS(2642),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2642),
    [sym_foreach] = ACTIONS(2642),
    [sym_foreach_reverse] = ACTIONS(2642),
    [sym_function] = ACTIONS(2642),
    [sym_goto] = ACTIONS(2642),
    [sym_if] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2642),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2642),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2642),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2642),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2642),
    [sym_try] = ACTIONS(2642),
    [sym_typeid] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2642),
    [sym_with] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [anon_sym_r_DQUOTE] = ACTIONS(2640),
    [anon_sym_x_DQUOTE] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_i_BQUOTE] = ACTIONS(2640),
    [anon_sym_i_DQUOTE] = ACTIONS(2640),
    [anon_sym_iq_LBRACE] = ACTIONS(2640),
    [aux_sym_char_literal_token1] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym___DATE__] = ACTIONS(2642),
    [anon_sym___FILE__] = ACTIONS(2642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2642),
    [anon_sym___FUNCTION__] = ACTIONS(2642),
    [anon_sym___LINE__] = ACTIONS(2642),
    [anon_sym___MODULE__] = ACTIONS(2642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2642),
    [anon_sym___TIME__] = ACTIONS(2642),
    [anon_sym___TIMESTAMP__] = ACTIONS(2642),
    [anon_sym___VENDOR__] = ACTIONS(2642),
    [anon_sym___VERSION__] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2640),
    [sym_float_literal] = ACTIONS(2640),
    [sym__string] = ACTIONS(2640),
  },
  [590] = {
    [sym_import_declaration] = STATE(603),
    [sym_mixin_declaration] = STATE(603),
    [sym__declaration] = STATE(603),
    [sym__declaration2] = STATE(603),
    [sym_variable_declaration] = STATE(603),
    [sym_manifest_constant] = STATE(603),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(603),
    [sym_alias_declaration] = STATE(603),
    [sym_alias_reassign] = STATE(603),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(603),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(603),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(603),
    [sym_union_declaration] = STATE(603),
    [sym_postblit] = STATE(603),
    [sym_invariant_declaration] = STATE(603),
    [sym_class_declaration] = STATE(603),
    [sym_constructor] = STATE(603),
    [sym_destructor] = STATE(603),
    [sym_alias_this] = STATE(603),
    [sym_interface_declaration] = STATE(603),
    [sym_enum_declaration] = STATE(603),
    [sym_anonymous_enum_declaration] = STATE(603),
    [sym_function_declaration] = STATE(603),
    [sym_template_declaration] = STATE(603),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(603),
    [sym_template_mixin] = STATE(603),
    [sym_conditional_declaration] = STATE(603),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(603),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(603),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(603),
    [sym_static_assert] = STATE(603),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(603),
    [aux_sym_source_file_repeat1] = STATE(603),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2873),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2525),
    [sym_case] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2525),
    [sym_foreach] = ACTIONS(2525),
    [sym_foreach_reverse] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_goto] = ACTIONS(2525),
    [sym_if] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2525),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2525),
    [sym_try] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2525),
    [sym_with] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [591] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(6396),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2877),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [592] = {
    [sym_import_declaration] = STATE(598),
    [sym_mixin_declaration] = STATE(598),
    [sym__declaration] = STATE(598),
    [sym__declaration2] = STATE(598),
    [sym_variable_declaration] = STATE(598),
    [sym_manifest_constant] = STATE(598),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(598),
    [sym_alias_declaration] = STATE(598),
    [sym_alias_reassign] = STATE(598),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(598),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(598),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(598),
    [sym_union_declaration] = STATE(598),
    [sym_postblit] = STATE(598),
    [sym_invariant_declaration] = STATE(598),
    [sym_class_declaration] = STATE(598),
    [sym_constructor] = STATE(598),
    [sym_destructor] = STATE(598),
    [sym_alias_this] = STATE(598),
    [sym_interface_declaration] = STATE(598),
    [sym_enum_declaration] = STATE(598),
    [sym_anonymous_enum_declaration] = STATE(598),
    [sym_function_declaration] = STATE(598),
    [sym_template_declaration] = STATE(598),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(598),
    [sym_template_mixin] = STATE(598),
    [sym_conditional_declaration] = STATE(598),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(598),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(598),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(598),
    [sym_static_assert] = STATE(598),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(598),
    [aux_sym_source_file_repeat1] = STATE(598),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2881),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2505),
    [sym_case] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2505),
    [sym_foreach] = ACTIONS(2505),
    [sym_foreach_reverse] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_goto] = ACTIONS(2505),
    [sym_if] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2505),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2505),
    [sym_try] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2505),
    [sym_with] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [593] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(6351),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2883),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [594] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(5700),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2885),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [595] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(5678),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2887),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [596] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(6137),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2889),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [597] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(5645),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2891),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [598] = {
    [sym_import_declaration] = STATE(604),
    [sym_mixin_declaration] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym__declaration2] = STATE(604),
    [sym_variable_declaration] = STATE(604),
    [sym_manifest_constant] = STATE(604),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(604),
    [sym_alias_declaration] = STATE(604),
    [sym_alias_reassign] = STATE(604),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(604),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(604),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(604),
    [sym_union_declaration] = STATE(604),
    [sym_postblit] = STATE(604),
    [sym_invariant_declaration] = STATE(604),
    [sym_class_declaration] = STATE(604),
    [sym_constructor] = STATE(604),
    [sym_destructor] = STATE(604),
    [sym_alias_this] = STATE(604),
    [sym_interface_declaration] = STATE(604),
    [sym_enum_declaration] = STATE(604),
    [sym_anonymous_enum_declaration] = STATE(604),
    [sym_function_declaration] = STATE(604),
    [sym_template_declaration] = STATE(604),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(604),
    [sym_template_mixin] = STATE(604),
    [sym_conditional_declaration] = STATE(604),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(604),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(604),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(604),
    [sym_static_assert] = STATE(604),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(604),
    [aux_sym_source_file_repeat1] = STATE(604),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2525),
    [sym_case] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2525),
    [sym_foreach] = ACTIONS(2525),
    [sym_foreach_reverse] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_goto] = ACTIONS(2525),
    [sym_if] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2525),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2525),
    [sym_try] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2525),
    [sym_with] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [599] = {
    [sym_import_declaration] = STATE(604),
    [sym_mixin_declaration] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym__declaration2] = STATE(604),
    [sym_variable_declaration] = STATE(604),
    [sym_manifest_constant] = STATE(604),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(604),
    [sym_alias_declaration] = STATE(604),
    [sym_alias_reassign] = STATE(604),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(604),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(604),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(604),
    [sym_union_declaration] = STATE(604),
    [sym_postblit] = STATE(604),
    [sym_invariant_declaration] = STATE(604),
    [sym_class_declaration] = STATE(604),
    [sym_constructor] = STATE(604),
    [sym_destructor] = STATE(604),
    [sym_alias_this] = STATE(604),
    [sym_interface_declaration] = STATE(604),
    [sym_enum_declaration] = STATE(604),
    [sym_anonymous_enum_declaration] = STATE(604),
    [sym_function_declaration] = STATE(604),
    [sym_template_declaration] = STATE(604),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(604),
    [sym_template_mixin] = STATE(604),
    [sym_conditional_declaration] = STATE(604),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(604),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(604),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(604),
    [sym_static_assert] = STATE(604),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(604),
    [aux_sym_source_file_repeat1] = STATE(604),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2634),
    [sym_assert] = ACTIONS(2634),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2634),
    [sym_case] = ACTIONS(2634),
    [sym_cast] = ACTIONS(2634),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2634),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2634),
    [sym_delegate] = ACTIONS(2634),
    [sym_delete] = ACTIONS(2634),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2634),
    [sym_else] = ACTIONS(2634),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2634),
    [sym_foreach] = ACTIONS(2634),
    [sym_foreach_reverse] = ACTIONS(2634),
    [sym_function] = ACTIONS(2634),
    [sym_goto] = ACTIONS(2634),
    [sym_if] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2634),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2634),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2634),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2634),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2634),
    [sym_try] = ACTIONS(2634),
    [sym_typeid] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2634),
    [sym_with] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_r_DQUOTE] = ACTIONS(2632),
    [anon_sym_x_DQUOTE] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_i_BQUOTE] = ACTIONS(2632),
    [anon_sym_i_DQUOTE] = ACTIONS(2632),
    [anon_sym_iq_LBRACE] = ACTIONS(2632),
    [aux_sym_char_literal_token1] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym___DATE__] = ACTIONS(2634),
    [anon_sym___FILE__] = ACTIONS(2634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2634),
    [anon_sym___FUNCTION__] = ACTIONS(2634),
    [anon_sym___LINE__] = ACTIONS(2634),
    [anon_sym___MODULE__] = ACTIONS(2634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2634),
    [anon_sym___TIME__] = ACTIONS(2634),
    [anon_sym___TIMESTAMP__] = ACTIONS(2634),
    [anon_sym___VENDOR__] = ACTIONS(2634),
    [anon_sym___VERSION__] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__string] = ACTIONS(2632),
  },
  [600] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(6033),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2893),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [601] = {
    [sym_import_declaration] = STATE(589),
    [sym_mixin_declaration] = STATE(589),
    [sym__declaration] = STATE(589),
    [sym__declaration2] = STATE(589),
    [sym_variable_declaration] = STATE(589),
    [sym_manifest_constant] = STATE(589),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(589),
    [sym_alias_declaration] = STATE(589),
    [sym_alias_reassign] = STATE(589),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(589),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(589),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(589),
    [sym_union_declaration] = STATE(589),
    [sym_postblit] = STATE(589),
    [sym_invariant_declaration] = STATE(589),
    [sym_class_declaration] = STATE(589),
    [sym_constructor] = STATE(589),
    [sym_destructor] = STATE(589),
    [sym_alias_this] = STATE(589),
    [sym_interface_declaration] = STATE(589),
    [sym_enum_declaration] = STATE(589),
    [sym_anonymous_enum_declaration] = STATE(589),
    [sym_function_declaration] = STATE(589),
    [sym_template_declaration] = STATE(589),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(589),
    [sym_template_mixin] = STATE(589),
    [sym_conditional_declaration] = STATE(589),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(589),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(589),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(589),
    [sym_static_assert] = STATE(589),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(589),
    [aux_sym_source_file_repeat1] = STATE(589),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2895),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2638),
    [sym_case] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2638),
    [sym_foreach] = ACTIONS(2638),
    [sym_foreach_reverse] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_goto] = ACTIONS(2638),
    [sym_if] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2638),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2638),
    [sym_try] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2638),
    [sym_with] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [602] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(606),
    [sym_keyword] = STATE(606),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(606),
    [sym_char_literal] = STATE(606),
    [sym_special_keyword] = STATE(649),
    [sym_asm_inline] = STATE(6106),
    [aux_sym_asm_inline_repeat1] = STATE(606),
    [sym_identifier] = ACTIONS(2875),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(2897),
    [anon_sym_SLASH] = ACTIONS(2875),
    [anon_sym_SLASH_EQ] = ACTIONS(2879),
    [anon_sym_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT] = ACTIONS(2875),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2879),
    [anon_sym_AMP] = ACTIONS(2875),
    [anon_sym_AMP_EQ] = ACTIONS(2879),
    [anon_sym_AMP_AMP] = ACTIONS(2879),
    [anon_sym_PIPE] = ACTIONS(2875),
    [anon_sym_PIPE_EQ] = ACTIONS(2879),
    [anon_sym_PIPE_PIPE] = ACTIONS(2879),
    [anon_sym_DASH] = ACTIONS(2875),
    [anon_sym_DASH_EQ] = ACTIONS(2879),
    [anon_sym_DASH_DASH] = ACTIONS(2879),
    [anon_sym_PLUS] = ACTIONS(2875),
    [anon_sym_PLUS_EQ] = ACTIONS(2879),
    [anon_sym_PLUS_PLUS] = ACTIONS(2879),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_LT_EQ] = ACTIONS(2879),
    [anon_sym_LT_LT] = ACTIONS(2875),
    [anon_sym_LT_LT_EQ] = ACTIONS(2879),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2879),
    [anon_sym_GT_GT] = ACTIONS(2875),
    [anon_sym_GT_GT_GT] = ACTIONS(2875),
    [anon_sym_BANG] = ACTIONS(2875),
    [anon_sym_BANG_EQ] = ACTIONS(2879),
    [anon_sym_LPAREN] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_LBRACK] = ACTIONS(2879),
    [anon_sym_RBRACK] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_COLON] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2879),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_EQ_EQ] = ACTIONS(2879),
    [anon_sym_STAR] = ACTIONS(2875),
    [anon_sym_STAR_EQ] = ACTIONS(2879),
    [anon_sym_PERCENT] = ACTIONS(2875),
    [anon_sym_PERCENT_EQ] = ACTIONS(2879),
    [anon_sym_CARET] = ACTIONS(2875),
    [anon_sym_CARET_EQ] = ACTIONS(2879),
    [anon_sym_CARET_CARET] = ACTIONS(2875),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2879),
    [anon_sym_TILDE] = ACTIONS(2875),
    [anon_sym_TILDE_EQ] = ACTIONS(2879),
    [anon_sym_AT] = ACTIONS(2879),
    [anon_sym_EQ_GT] = ACTIONS(2879),
    [anon_sym_POUND] = ACTIONS(2879),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2879),
    [sym_float_literal] = ACTIONS(2879),
    [sym__string] = ACTIONS(2682),
  },
  [603] = {
    [sym_import_declaration] = STATE(604),
    [sym_mixin_declaration] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym__declaration2] = STATE(604),
    [sym_variable_declaration] = STATE(604),
    [sym_manifest_constant] = STATE(604),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(604),
    [sym_alias_declaration] = STATE(604),
    [sym_alias_reassign] = STATE(604),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(604),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(604),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(604),
    [sym_union_declaration] = STATE(604),
    [sym_postblit] = STATE(604),
    [sym_invariant_declaration] = STATE(604),
    [sym_class_declaration] = STATE(604),
    [sym_constructor] = STATE(604),
    [sym_destructor] = STATE(604),
    [sym_alias_this] = STATE(604),
    [sym_interface_declaration] = STATE(604),
    [sym_enum_declaration] = STATE(604),
    [sym_anonymous_enum_declaration] = STATE(604),
    [sym_function_declaration] = STATE(604),
    [sym_template_declaration] = STATE(604),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(604),
    [sym_template_mixin] = STATE(604),
    [sym_conditional_declaration] = STATE(604),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(604),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(604),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(604),
    [sym_static_assert] = STATE(604),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(604),
    [aux_sym_source_file_repeat1] = STATE(604),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2857),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_asm] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(25),
    [sym_break] = ACTIONS(2638),
    [sym_case] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_continue] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2863),
    [sym_default] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(37),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_for] = ACTIONS(2638),
    [sym_foreach] = ACTIONS(2638),
    [sym_foreach_reverse] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_goto] = ACTIONS(2638),
    [sym_if] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2867),
    [sym_new] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(25),
    [sym_out] = ACTIONS(2638),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_switch] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_throw] = ACTIONS(2638),
    [sym_try] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_while] = ACTIONS(2638),
    [sym_with] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [604] = {
    [sym_import_declaration] = STATE(604),
    [sym_mixin_declaration] = STATE(604),
    [sym__declaration] = STATE(604),
    [sym__declaration2] = STATE(604),
    [sym_variable_declaration] = STATE(604),
    [sym_manifest_constant] = STATE(604),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(604),
    [sym_alias_declaration] = STATE(604),
    [sym_alias_reassign] = STATE(604),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(604),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(604),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(604),
    [sym_union_declaration] = STATE(604),
    [sym_postblit] = STATE(604),
    [sym_invariant_declaration] = STATE(604),
    [sym_class_declaration] = STATE(604),
    [sym_constructor] = STATE(604),
    [sym_destructor] = STATE(604),
    [sym_alias_this] = STATE(604),
    [sym_interface_declaration] = STATE(604),
    [sym_enum_declaration] = STATE(604),
    [sym_anonymous_enum_declaration] = STATE(604),
    [sym_function_declaration] = STATE(604),
    [sym_template_declaration] = STATE(604),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(604),
    [sym_template_mixin] = STATE(604),
    [sym_conditional_declaration] = STATE(604),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(604),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(604),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(604),
    [sym_static_assert] = STATE(604),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(604),
    [aux_sym_source_file_repeat1] = STATE(604),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2899),
    [anon_sym_q_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_DASH] = ACTIONS(2537),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_RPAREN] = ACTIONS(2532),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_SEMI] = ACTIONS(2902),
    [anon_sym_DOLLAR] = ACTIONS(2532),
    [anon_sym_STAR] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2905),
    [anon_sym_AT] = ACTIONS(2545),
    [sym_bool] = ACTIONS(2548),
    [sym_byte] = ACTIONS(2548),
    [sym_ubyte] = ACTIONS(2548),
    [sym_char] = ACTIONS(2548),
    [sym_short] = ACTIONS(2548),
    [sym_ushort] = ACTIONS(2548),
    [sym_int] = ACTIONS(2548),
    [sym_uint] = ACTIONS(2548),
    [sym_long] = ACTIONS(2548),
    [sym_ulong] = ACTIONS(2548),
    [sym_cent] = ACTIONS(2548),
    [sym_ucent] = ACTIONS(2548),
    [sym_wchar] = ACTIONS(2548),
    [sym_dchar] = ACTIONS(2548),
    [sym_float] = ACTIONS(2548),
    [sym_double] = ACTIONS(2548),
    [sym_real] = ACTIONS(2548),
    [sym_ifloat] = ACTIONS(2548),
    [sym_idouble] = ACTIONS(2548),
    [sym_ireal] = ACTIONS(2548),
    [sym_cfloat] = ACTIONS(2548),
    [sym_cdouble] = ACTIONS(2548),
    [sym_creal] = ACTIONS(2548),
    [sym_size_t] = ACTIONS(2548),
    [sym_ptrdiff_t] = ACTIONS(2548),
    [sym_string] = ACTIONS(2548),
    [sym_cstring] = ACTIONS(2548),
    [sym_dstring] = ACTIONS(2548),
    [sym_wstring] = ACTIONS(2548),
    [sym_noreturn] = ACTIONS(2548),
    [sym_true] = ACTIONS(2537),
    [sym_false] = ACTIONS(2537),
    [sym_null] = ACTIONS(2537),
    [sym_super] = ACTIONS(2537),
    [sym_this] = ACTIONS(2908),
    [sym_abstract] = ACTIONS(2554),
    [sym_alias] = ACTIONS(2911),
    [sym_align] = ACTIONS(2560),
    [sym_asm] = ACTIONS(2537),
    [sym_assert] = ACTIONS(2537),
    [sym_auto] = ACTIONS(2554),
    [sym_break] = ACTIONS(2537),
    [sym_case] = ACTIONS(2537),
    [sym_cast] = ACTIONS(2537),
    [sym_class] = ACTIONS(2914),
    [sym_const] = ACTIONS(2566),
    [sym_continue] = ACTIONS(2537),
    [sym_debug] = ACTIONS(2917),
    [sym_default] = ACTIONS(2537),
    [sym_delegate] = ACTIONS(2537),
    [sym_delete] = ACTIONS(2537),
    [sym_deprecated] = ACTIONS(2572),
    [sym_do] = ACTIONS(2537),
    [sym_else] = ACTIONS(2537),
    [sym_enum] = ACTIONS(2920),
    [sym_export] = ACTIONS(2923),
    [sym_extern] = ACTIONS(2581),
    [sym_final] = ACTIONS(2554),
    [sym_for] = ACTIONS(2537),
    [sym_foreach] = ACTIONS(2537),
    [sym_foreach_reverse] = ACTIONS(2537),
    [sym_function] = ACTIONS(2537),
    [sym_goto] = ACTIONS(2537),
    [sym_if] = ACTIONS(2537),
    [sym_immutable] = ACTIONS(2566),
    [sym_import] = ACTIONS(2926),
    [sym_in] = ACTIONS(2537),
    [sym_inout] = ACTIONS(2566),
    [sym_interface] = ACTIONS(2929),
    [sym_invariant] = ACTIONS(2932),
    [sym_is] = ACTIONS(2537),
    [sym_mixin] = ACTIONS(2935),
    [sym_new] = ACTIONS(2537),
    [sym_nothrow] = ACTIONS(2554),
    [sym_out] = ACTIONS(2537),
    [sym_override] = ACTIONS(2554),
    [sym_package] = ACTIONS(2596),
    [sym_pragma] = ACTIONS(2599),
    [sym_private] = ACTIONS(2923),
    [sym_protected] = ACTIONS(2923),
    [sym_public] = ACTIONS(2923),
    [sym_pure] = ACTIONS(2554),
    [sym_ref] = ACTIONS(2554),
    [sym_return] = ACTIONS(2923),
    [sym_scope] = ACTIONS(2554),
    [sym_shared] = ACTIONS(2938),
    [sym_static] = ACTIONS(2941),
    [sym_struct] = ACTIONS(2944),
    [sym_switch] = ACTIONS(2537),
    [sym_synchronized] = ACTIONS(2554),
    [sym_template] = ACTIONS(2947),
    [sym_throw] = ACTIONS(2537),
    [sym_try] = ACTIONS(2537),
    [sym_typeid] = ACTIONS(2537),
    [sym_typeof] = ACTIONS(2614),
    [sym_union] = ACTIONS(2950),
    [sym_unittest] = ACTIONS(2953),
    [sym_version] = ACTIONS(2956),
    [sym_while] = ACTIONS(2537),
    [sym_with] = ACTIONS(2537),
    [sym_gshared] = ACTIONS(2554),
    [sym_traits] = ACTIONS(2626),
    [sym_vector] = ACTIONS(2629),
    [sym_void] = ACTIONS(2548),
    [anon_sym_BQUOTE] = ACTIONS(2532),
    [anon_sym_r_DQUOTE] = ACTIONS(2532),
    [anon_sym_x_DQUOTE] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_i_BQUOTE] = ACTIONS(2532),
    [anon_sym_i_DQUOTE] = ACTIONS(2532),
    [anon_sym_iq_LBRACE] = ACTIONS(2532),
    [aux_sym_char_literal_token1] = ACTIONS(2532),
    [anon_sym_SQUOTE] = ACTIONS(2537),
    [anon_sym___DATE__] = ACTIONS(2537),
    [anon_sym___FILE__] = ACTIONS(2537),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2537),
    [anon_sym___FUNCTION__] = ACTIONS(2537),
    [anon_sym___LINE__] = ACTIONS(2537),
    [anon_sym___MODULE__] = ACTIONS(2537),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2537),
    [anon_sym___TIME__] = ACTIONS(2537),
    [anon_sym___TIMESTAMP__] = ACTIONS(2537),
    [anon_sym___VENDOR__] = ACTIONS(2537),
    [anon_sym___VERSION__] = ACTIONS(2537),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2532),
    [sym_float_literal] = ACTIONS(2532),
    [sym__string] = ACTIONS(2532),
  },
  [605] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(605),
    [sym_keyword] = STATE(605),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(605),
    [sym_char_literal] = STATE(605),
    [sym_special_keyword] = STATE(649),
    [aux_sym_asm_inline_repeat1] = STATE(605),
    [sym_identifier] = ACTIONS(2959),
    [anon_sym_q_LBRACE] = ACTIONS(2962),
    [anon_sym_RBRACE] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2959),
    [anon_sym_DOT_DOT] = ACTIONS(2959),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_DASH] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_LT] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2959),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2959),
    [anon_sym_GT_GT_GT] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2959),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2967),
    [anon_sym_DOLLAR] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_STAR] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_CARET_CARET] = ACTIONS(2959),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(2967),
    [anon_sym_TILDE] = ACTIONS(2959),
    [anon_sym_TILDE_EQ] = ACTIONS(2967),
    [anon_sym_AT] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_POUND] = ACTIONS(2967),
    [sym_bool] = ACTIONS(2970),
    [sym_byte] = ACTIONS(2970),
    [sym_ubyte] = ACTIONS(2970),
    [sym_char] = ACTIONS(2970),
    [sym_short] = ACTIONS(2970),
    [sym_ushort] = ACTIONS(2970),
    [sym_int] = ACTIONS(2970),
    [sym_uint] = ACTIONS(2970),
    [sym_long] = ACTIONS(2970),
    [sym_ulong] = ACTIONS(2970),
    [sym_cent] = ACTIONS(2970),
    [sym_ucent] = ACTIONS(2970),
    [sym_wchar] = ACTIONS(2970),
    [sym_dchar] = ACTIONS(2970),
    [sym_float] = ACTIONS(2970),
    [sym_double] = ACTIONS(2970),
    [sym_real] = ACTIONS(2970),
    [sym_ifloat] = ACTIONS(2970),
    [sym_idouble] = ACTIONS(2970),
    [sym_ireal] = ACTIONS(2970),
    [sym_cfloat] = ACTIONS(2970),
    [sym_cdouble] = ACTIONS(2970),
    [sym_creal] = ACTIONS(2970),
    [sym_size_t] = ACTIONS(2970),
    [sym_ptrdiff_t] = ACTIONS(2970),
    [sym_string] = ACTIONS(2970),
    [sym_cstring] = ACTIONS(2970),
    [sym_dstring] = ACTIONS(2970),
    [sym_wstring] = ACTIONS(2970),
    [sym_noreturn] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_null] = ACTIONS(2970),
    [sym_super] = ACTIONS(2970),
    [sym_this] = ACTIONS(2970),
    [sym_abstract] = ACTIONS(2970),
    [sym_alias] = ACTIONS(2970),
    [sym_align] = ACTIONS(2970),
    [sym_asm] = ACTIONS(2970),
    [sym_assert] = ACTIONS(2970),
    [sym_auto] = ACTIONS(2970),
    [sym_break] = ACTIONS(2970),
    [sym_case] = ACTIONS(2970),
    [sym_cast] = ACTIONS(2970),
    [sym_catch] = ACTIONS(2970),
    [sym_class] = ACTIONS(2970),
    [sym_const] = ACTIONS(2973),
    [sym_continue] = ACTIONS(2970),
    [sym_debug] = ACTIONS(2970),
    [sym_default] = ACTIONS(2970),
    [sym_delegate] = ACTIONS(2970),
    [sym_delete] = ACTIONS(2970),
    [sym_deprecated] = ACTIONS(2970),
    [sym_do] = ACTIONS(2970),
    [sym_else] = ACTIONS(2970),
    [sym_enum] = ACTIONS(2970),
    [sym_export] = ACTIONS(2970),
    [sym_extern] = ACTIONS(2970),
    [sym_final] = ACTIONS(2970),
    [sym_finally] = ACTIONS(2970),
    [sym_for] = ACTIONS(2970),
    [sym_foreach] = ACTIONS(2970),
    [sym_foreach_reverse] = ACTIONS(2970),
    [sym_function] = ACTIONS(2970),
    [sym_goto] = ACTIONS(2970),
    [sym_if] = ACTIONS(2970),
    [sym_immutable] = ACTIONS(2973),
    [sym_import] = ACTIONS(2970),
    [sym_in] = ACTIONS(2970),
    [sym_inout] = ACTIONS(2973),
    [sym_interface] = ACTIONS(2970),
    [sym_invariant] = ACTIONS(2970),
    [sym_is] = ACTIONS(2970),
    [sym_lazy] = ACTIONS(2970),
    [sym_mixin] = ACTIONS(2970),
    [sym_module] = ACTIONS(2970),
    [sym_new] = ACTIONS(2970),
    [sym_nothrow] = ACTIONS(2970),
    [sym_out] = ACTIONS(2970),
    [sym_override] = ACTIONS(2970),
    [sym_package] = ACTIONS(2970),
    [sym_pragma] = ACTIONS(2970),
    [sym_private] = ACTIONS(2970),
    [sym_protected] = ACTIONS(2970),
    [sym_public] = ACTIONS(2970),
    [sym_pure] = ACTIONS(2970),
    [sym_ref] = ACTIONS(2970),
    [sym_return] = ACTIONS(2970),
    [sym_scope] = ACTIONS(2970),
    [sym_shared] = ACTIONS(2973),
    [sym_static] = ACTIONS(2970),
    [sym_struct] = ACTIONS(2970),
    [sym_switch] = ACTIONS(2970),
    [sym_synchronized] = ACTIONS(2970),
    [sym_template] = ACTIONS(2970),
    [sym_throw] = ACTIONS(2970),
    [sym_try] = ACTIONS(2970),
    [sym_typeid] = ACTIONS(2970),
    [sym_typeof] = ACTIONS(2970),
    [sym_union] = ACTIONS(2970),
    [sym_unittest] = ACTIONS(2970),
    [sym_version] = ACTIONS(2970),
    [sym_while] = ACTIONS(2970),
    [sym_with] = ACTIONS(2970),
    [sym_parameters_] = ACTIONS(2970),
    [sym_gshared] = ACTIONS(2970),
    [sym_traits] = ACTIONS(2970),
    [sym_vector] = ACTIONS(2970),
    [sym_void] = ACTIONS(2970),
    [anon_sym_BQUOTE] = ACTIONS(2976),
    [anon_sym_r_DQUOTE] = ACTIONS(2979),
    [anon_sym_x_DQUOTE] = ACTIONS(2982),
    [anon_sym_DQUOTE] = ACTIONS(2985),
    [anon_sym_i_BQUOTE] = ACTIONS(2988),
    [anon_sym_i_DQUOTE] = ACTIONS(2991),
    [anon_sym_iq_LBRACE] = ACTIONS(2994),
    [aux_sym_char_literal_token1] = ACTIONS(2997),
    [anon_sym_SQUOTE] = ACTIONS(3000),
    [anon_sym___DATE__] = ACTIONS(3003),
    [anon_sym___FILE__] = ACTIONS(3003),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3003),
    [anon_sym___FUNCTION__] = ACTIONS(3003),
    [anon_sym___LINE__] = ACTIONS(3003),
    [anon_sym___MODULE__] = ACTIONS(3003),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3003),
    [anon_sym___TIME__] = ACTIONS(3003),
    [anon_sym___TIMESTAMP__] = ACTIONS(3003),
    [anon_sym___VENDOR__] = ACTIONS(3003),
    [anon_sym___VERSION__] = ACTIONS(3003),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2967),
    [sym_float_literal] = ACTIONS(2967),
    [sym__string] = ACTIONS(3006),
  },
  [606] = {
    [sym_token_string] = STATE(641),
    [sym__token_no_braces] = STATE(605),
    [sym_keyword] = STATE(605),
    [sym_type_ctor] = STATE(649),
    [sym__builtin_type] = STATE(649),
    [sym_raw_string] = STATE(641),
    [sym_hex_string] = STATE(641),
    [sym_quoted_string] = STATE(641),
    [sym_interpolated_raw_string] = STATE(641),
    [sym_interpolated_quoted_string] = STATE(641),
    [sym_interpolated_token_string] = STATE(641),
    [sym_string_literal] = STATE(605),
    [sym_char_literal] = STATE(605),
    [sym_special_keyword] = STATE(649),
    [aux_sym_asm_inline_repeat1] = STATE(605),
    [sym_identifier] = ACTIONS(3009),
    [anon_sym_q_LBRACE] = ACTIONS(2650),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_SLASH] = ACTIONS(3009),
    [anon_sym_SLASH_EQ] = ACTIONS(3013),
    [anon_sym_DOT] = ACTIONS(3009),
    [anon_sym_DOT_DOT] = ACTIONS(3009),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3013),
    [anon_sym_AMP] = ACTIONS(3009),
    [anon_sym_AMP_EQ] = ACTIONS(3013),
    [anon_sym_AMP_AMP] = ACTIONS(3013),
    [anon_sym_PIPE] = ACTIONS(3009),
    [anon_sym_PIPE_EQ] = ACTIONS(3013),
    [anon_sym_PIPE_PIPE] = ACTIONS(3013),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_DASH_EQ] = ACTIONS(3013),
    [anon_sym_DASH_DASH] = ACTIONS(3013),
    [anon_sym_PLUS] = ACTIONS(3009),
    [anon_sym_PLUS_EQ] = ACTIONS(3013),
    [anon_sym_PLUS_PLUS] = ACTIONS(3013),
    [anon_sym_LT] = ACTIONS(3009),
    [anon_sym_LT_EQ] = ACTIONS(3013),
    [anon_sym_LT_LT] = ACTIONS(3009),
    [anon_sym_LT_LT_EQ] = ACTIONS(3013),
    [anon_sym_GT] = ACTIONS(3009),
    [anon_sym_GT_EQ] = ACTIONS(3013),
    [anon_sym_GT_GT_EQ] = ACTIONS(3013),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3013),
    [anon_sym_GT_GT] = ACTIONS(3009),
    [anon_sym_GT_GT_GT] = ACTIONS(3009),
    [anon_sym_BANG] = ACTIONS(3009),
    [anon_sym_BANG_EQ] = ACTIONS(3013),
    [anon_sym_LPAREN] = ACTIONS(3013),
    [anon_sym_RPAREN] = ACTIONS(3013),
    [anon_sym_LBRACK] = ACTIONS(3013),
    [anon_sym_RBRACK] = ACTIONS(3013),
    [anon_sym_QMARK] = ACTIONS(3013),
    [anon_sym_COMMA] = ACTIONS(3013),
    [anon_sym_SEMI] = ACTIONS(3013),
    [anon_sym_COLON] = ACTIONS(3013),
    [anon_sym_DOLLAR] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_EQ_EQ] = ACTIONS(3013),
    [anon_sym_STAR] = ACTIONS(3009),
    [anon_sym_STAR_EQ] = ACTIONS(3013),
    [anon_sym_PERCENT] = ACTIONS(3009),
    [anon_sym_PERCENT_EQ] = ACTIONS(3013),
    [anon_sym_CARET] = ACTIONS(3009),
    [anon_sym_CARET_EQ] = ACTIONS(3013),
    [anon_sym_CARET_CARET] = ACTIONS(3009),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3013),
    [anon_sym_TILDE] = ACTIONS(3009),
    [anon_sym_TILDE_EQ] = ACTIONS(3013),
    [anon_sym_AT] = ACTIONS(3013),
    [anon_sym_EQ_GT] = ACTIONS(3013),
    [anon_sym_POUND] = ACTIONS(3013),
    [sym_bool] = ACTIONS(2658),
    [sym_byte] = ACTIONS(2658),
    [sym_ubyte] = ACTIONS(2658),
    [sym_char] = ACTIONS(2658),
    [sym_short] = ACTIONS(2658),
    [sym_ushort] = ACTIONS(2658),
    [sym_int] = ACTIONS(2658),
    [sym_uint] = ACTIONS(2658),
    [sym_long] = ACTIONS(2658),
    [sym_ulong] = ACTIONS(2658),
    [sym_cent] = ACTIONS(2658),
    [sym_ucent] = ACTIONS(2658),
    [sym_wchar] = ACTIONS(2658),
    [sym_dchar] = ACTIONS(2658),
    [sym_float] = ACTIONS(2658),
    [sym_double] = ACTIONS(2658),
    [sym_real] = ACTIONS(2658),
    [sym_ifloat] = ACTIONS(2658),
    [sym_idouble] = ACTIONS(2658),
    [sym_ireal] = ACTIONS(2658),
    [sym_cfloat] = ACTIONS(2658),
    [sym_cdouble] = ACTIONS(2658),
    [sym_creal] = ACTIONS(2658),
    [sym_size_t] = ACTIONS(2658),
    [sym_ptrdiff_t] = ACTIONS(2658),
    [sym_string] = ACTIONS(2658),
    [sym_cstring] = ACTIONS(2658),
    [sym_dstring] = ACTIONS(2658),
    [sym_wstring] = ACTIONS(2658),
    [sym_noreturn] = ACTIONS(2658),
    [sym_true] = ACTIONS(2658),
    [sym_false] = ACTIONS(2658),
    [sym_null] = ACTIONS(2658),
    [sym_super] = ACTIONS(2658),
    [sym_this] = ACTIONS(2658),
    [sym_abstract] = ACTIONS(2658),
    [sym_alias] = ACTIONS(2658),
    [sym_align] = ACTIONS(2658),
    [sym_asm] = ACTIONS(2658),
    [sym_assert] = ACTIONS(2658),
    [sym_auto] = ACTIONS(2658),
    [sym_break] = ACTIONS(2658),
    [sym_case] = ACTIONS(2658),
    [sym_cast] = ACTIONS(2658),
    [sym_catch] = ACTIONS(2658),
    [sym_class] = ACTIONS(2658),
    [sym_const] = ACTIONS(2660),
    [sym_continue] = ACTIONS(2658),
    [sym_debug] = ACTIONS(2658),
    [sym_default] = ACTIONS(2658),
    [sym_delegate] = ACTIONS(2658),
    [sym_delete] = ACTIONS(2658),
    [sym_deprecated] = ACTIONS(2658),
    [sym_do] = ACTIONS(2658),
    [sym_else] = ACTIONS(2658),
    [sym_enum] = ACTIONS(2658),
    [sym_export] = ACTIONS(2658),
    [sym_extern] = ACTIONS(2658),
    [sym_final] = ACTIONS(2658),
    [sym_finally] = ACTIONS(2658),
    [sym_for] = ACTIONS(2658),
    [sym_foreach] = ACTIONS(2658),
    [sym_foreach_reverse] = ACTIONS(2658),
    [sym_function] = ACTIONS(2658),
    [sym_goto] = ACTIONS(2658),
    [sym_if] = ACTIONS(2658),
    [sym_immutable] = ACTIONS(2660),
    [sym_import] = ACTIONS(2658),
    [sym_in] = ACTIONS(2658),
    [sym_inout] = ACTIONS(2660),
    [sym_interface] = ACTIONS(2658),
    [sym_invariant] = ACTIONS(2658),
    [sym_is] = ACTIONS(2658),
    [sym_lazy] = ACTIONS(2658),
    [sym_mixin] = ACTIONS(2658),
    [sym_module] = ACTIONS(2658),
    [sym_new] = ACTIONS(2658),
    [sym_nothrow] = ACTIONS(2658),
    [sym_out] = ACTIONS(2658),
    [sym_override] = ACTIONS(2658),
    [sym_package] = ACTIONS(2658),
    [sym_pragma] = ACTIONS(2658),
    [sym_private] = ACTIONS(2658),
    [sym_protected] = ACTIONS(2658),
    [sym_public] = ACTIONS(2658),
    [sym_pure] = ACTIONS(2658),
    [sym_ref] = ACTIONS(2658),
    [sym_return] = ACTIONS(2658),
    [sym_scope] = ACTIONS(2658),
    [sym_shared] = ACTIONS(2660),
    [sym_static] = ACTIONS(2658),
    [sym_struct] = ACTIONS(2658),
    [sym_switch] = ACTIONS(2658),
    [sym_synchronized] = ACTIONS(2658),
    [sym_template] = ACTIONS(2658),
    [sym_throw] = ACTIONS(2658),
    [sym_try] = ACTIONS(2658),
    [sym_typeid] = ACTIONS(2658),
    [sym_typeof] = ACTIONS(2658),
    [sym_union] = ACTIONS(2658),
    [sym_unittest] = ACTIONS(2658),
    [sym_version] = ACTIONS(2658),
    [sym_while] = ACTIONS(2658),
    [sym_with] = ACTIONS(2658),
    [sym_parameters_] = ACTIONS(2658),
    [sym_gshared] = ACTIONS(2658),
    [sym_traits] = ACTIONS(2658),
    [sym_vector] = ACTIONS(2658),
    [sym_void] = ACTIONS(2658),
    [anon_sym_BQUOTE] = ACTIONS(2662),
    [anon_sym_r_DQUOTE] = ACTIONS(2664),
    [anon_sym_x_DQUOTE] = ACTIONS(2666),
    [anon_sym_DQUOTE] = ACTIONS(2668),
    [anon_sym_i_BQUOTE] = ACTIONS(2670),
    [anon_sym_i_DQUOTE] = ACTIONS(2672),
    [anon_sym_iq_LBRACE] = ACTIONS(2674),
    [aux_sym_char_literal_token1] = ACTIONS(2676),
    [anon_sym_SQUOTE] = ACTIONS(2678),
    [anon_sym___DATE__] = ACTIONS(2680),
    [anon_sym___FILE__] = ACTIONS(2680),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2680),
    [anon_sym___FUNCTION__] = ACTIONS(2680),
    [anon_sym___LINE__] = ACTIONS(2680),
    [anon_sym___MODULE__] = ACTIONS(2680),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2680),
    [anon_sym___TIME__] = ACTIONS(2680),
    [anon_sym___TIMESTAMP__] = ACTIONS(2680),
    [anon_sym___VENDOR__] = ACTIONS(2680),
    [anon_sym___VERSION__] = ACTIONS(2680),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3013),
    [sym_float_literal] = ACTIONS(3013),
    [sym__string] = ACTIONS(2682),
  },
  [607] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5727),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(669),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(2125),
    [sym_debug] = ACTIONS(3019),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(3019),
    [sym_do] = ACTIONS(3023),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(3019),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [608] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6524),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3031),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(669),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(2125),
    [sym_debug] = ACTIONS(3019),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(3019),
    [sym_do] = ACTIONS(3023),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(3019),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [609] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6435),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(669),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(2125),
    [sym_debug] = ACTIONS(3019),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(3019),
    [sym_do] = ACTIONS(3023),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(3019),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [610] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6188),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3035),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(669),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(2125),
    [sym_debug] = ACTIONS(3019),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_deprecated] = ACTIONS(3019),
    [sym_do] = ACTIONS(3023),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_nothrow] = ACTIONS(3019),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [611] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_q_LBRACE] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_SLASH_EQ] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3037),
    [anon_sym_DOT_DOT] = ACTIONS(3037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3039),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_AMP_EQ] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE] = ACTIONS(3037),
    [anon_sym_PIPE_EQ] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_DASH_EQ] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_PLUS_EQ] = ACTIONS(3039),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_LT_LT] = ACTIONS(3037),
    [anon_sym_LT_LT_EQ] = ACTIONS(3039),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3037),
    [anon_sym_GT_GT_GT] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_DOLLAR] = ACTIONS(3037),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_EQ_EQ] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_STAR_EQ] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_PERCENT_EQ] = ACTIONS(3039),
    [anon_sym_CARET] = ACTIONS(3037),
    [anon_sym_CARET_EQ] = ACTIONS(3039),
    [anon_sym_CARET_CARET] = ACTIONS(3037),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_TILDE_EQ] = ACTIONS(3039),
    [anon_sym_AT] = ACTIONS(3039),
    [anon_sym_EQ_GT] = ACTIONS(3039),
    [anon_sym_POUND] = ACTIONS(3039),
    [sym_bool] = ACTIONS(3037),
    [sym_byte] = ACTIONS(3037),
    [sym_ubyte] = ACTIONS(3037),
    [sym_char] = ACTIONS(3037),
    [sym_short] = ACTIONS(3037),
    [sym_ushort] = ACTIONS(3037),
    [sym_int] = ACTIONS(3037),
    [sym_uint] = ACTIONS(3037),
    [sym_long] = ACTIONS(3037),
    [sym_ulong] = ACTIONS(3037),
    [sym_cent] = ACTIONS(3037),
    [sym_ucent] = ACTIONS(3037),
    [sym_wchar] = ACTIONS(3037),
    [sym_dchar] = ACTIONS(3037),
    [sym_float] = ACTIONS(3037),
    [sym_double] = ACTIONS(3037),
    [sym_real] = ACTIONS(3037),
    [sym_ifloat] = ACTIONS(3037),
    [sym_idouble] = ACTIONS(3037),
    [sym_ireal] = ACTIONS(3037),
    [sym_cfloat] = ACTIONS(3037),
    [sym_cdouble] = ACTIONS(3037),
    [sym_creal] = ACTIONS(3037),
    [sym_size_t] = ACTIONS(3037),
    [sym_ptrdiff_t] = ACTIONS(3037),
    [sym_string] = ACTIONS(3037),
    [sym_cstring] = ACTIONS(3037),
    [sym_dstring] = ACTIONS(3037),
    [sym_wstring] = ACTIONS(3037),
    [sym_noreturn] = ACTIONS(3037),
    [sym_true] = ACTIONS(3037),
    [sym_false] = ACTIONS(3037),
    [sym_null] = ACTIONS(3037),
    [sym_super] = ACTIONS(3037),
    [sym_this] = ACTIONS(3037),
    [sym_abstract] = ACTIONS(3037),
    [sym_alias] = ACTIONS(3037),
    [sym_align] = ACTIONS(3037),
    [sym_asm] = ACTIONS(3037),
    [sym_assert] = ACTIONS(3037),
    [sym_auto] = ACTIONS(3037),
    [sym_break] = ACTIONS(3037),
    [sym_case] = ACTIONS(3037),
    [sym_cast] = ACTIONS(3037),
    [sym_catch] = ACTIONS(3037),
    [sym_class] = ACTIONS(3037),
    [sym_const] = ACTIONS(3037),
    [sym_continue] = ACTIONS(3037),
    [sym_debug] = ACTIONS(3037),
    [sym_default] = ACTIONS(3037),
    [sym_delegate] = ACTIONS(3037),
    [sym_delete] = ACTIONS(3037),
    [sym_deprecated] = ACTIONS(3037),
    [sym_do] = ACTIONS(3037),
    [sym_else] = ACTIONS(3037),
    [sym_enum] = ACTIONS(3037),
    [sym_export] = ACTIONS(3037),
    [sym_extern] = ACTIONS(3037),
    [sym_final] = ACTIONS(3037),
    [sym_finally] = ACTIONS(3037),
    [sym_for] = ACTIONS(3037),
    [sym_foreach] = ACTIONS(3037),
    [sym_foreach_reverse] = ACTIONS(3037),
    [sym_function] = ACTIONS(3037),
    [sym_goto] = ACTIONS(3037),
    [sym_if] = ACTIONS(3037),
    [sym_immutable] = ACTIONS(3037),
    [sym_import] = ACTIONS(3037),
    [sym_in] = ACTIONS(3037),
    [sym_inout] = ACTIONS(3037),
    [sym_interface] = ACTIONS(3037),
    [sym_invariant] = ACTIONS(3037),
    [sym_is] = ACTIONS(3037),
    [sym_lazy] = ACTIONS(3037),
    [sym_mixin] = ACTIONS(3037),
    [sym_module] = ACTIONS(3037),
    [sym_new] = ACTIONS(3037),
    [sym_nothrow] = ACTIONS(3037),
    [sym_out] = ACTIONS(3037),
    [sym_override] = ACTIONS(3037),
    [sym_package] = ACTIONS(3037),
    [sym_pragma] = ACTIONS(3037),
    [sym_private] = ACTIONS(3037),
    [sym_protected] = ACTIONS(3037),
    [sym_public] = ACTIONS(3037),
    [sym_pure] = ACTIONS(3037),
    [sym_ref] = ACTIONS(3037),
    [sym_return] = ACTIONS(3037),
    [sym_scope] = ACTIONS(3037),
    [sym_shared] = ACTIONS(3037),
    [sym_static] = ACTIONS(3037),
    [sym_struct] = ACTIONS(3037),
    [sym_switch] = ACTIONS(3037),
    [sym_synchronized] = ACTIONS(3037),
    [sym_template] = ACTIONS(3037),
    [sym_throw] = ACTIONS(3037),
    [sym_try] = ACTIONS(3037),
    [sym_typeid] = ACTIONS(3037),
    [sym_typeof] = ACTIONS(3037),
    [sym_union] = ACTIONS(3037),
    [sym_unittest] = ACTIONS(3037),
    [sym_version] = ACTIONS(3037),
    [sym_while] = ACTIONS(3037),
    [sym_with] = ACTIONS(3037),
    [sym_parameters_] = ACTIONS(3037),
    [sym_gshared] = ACTIONS(3037),
    [sym_traits] = ACTIONS(3037),
    [sym_vector] = ACTIONS(3037),
    [sym_void] = ACTIONS(3037),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [anon_sym_r_DQUOTE] = ACTIONS(3039),
    [anon_sym_x_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3039),
    [anon_sym_i_BQUOTE] = ACTIONS(3039),
    [anon_sym_i_DQUOTE] = ACTIONS(3039),
    [anon_sym_iq_LBRACE] = ACTIONS(3039),
    [aux_sym_char_literal_token1] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym___DATE__] = ACTIONS(3037),
    [anon_sym___FILE__] = ACTIONS(3037),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3037),
    [anon_sym___FUNCTION__] = ACTIONS(3037),
    [anon_sym___LINE__] = ACTIONS(3037),
    [anon_sym___MODULE__] = ACTIONS(3037),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3037),
    [anon_sym___TIME__] = ACTIONS(3037),
    [anon_sym___TIMESTAMP__] = ACTIONS(3037),
    [anon_sym___VENDOR__] = ACTIONS(3037),
    [anon_sym___VERSION__] = ACTIONS(3037),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3039),
    [sym_float_literal] = ACTIONS(3039),
    [sym__string] = ACTIONS(3039),
  },
  [612] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_q_LBRACE] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_SLASH_EQ] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_AMP_EQ] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_PIPE_EQ] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_DASH_EQ] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_PLUS_EQ] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_LT_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_DOLLAR] = ACTIONS(3041),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_STAR_EQ] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_PERCENT_EQ] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_CARET_EQ] = ACTIONS(3043),
    [anon_sym_CARET_CARET] = ACTIONS(3041),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_TILDE_EQ] = ACTIONS(3043),
    [anon_sym_AT] = ACTIONS(3043),
    [anon_sym_EQ_GT] = ACTIONS(3043),
    [anon_sym_POUND] = ACTIONS(3043),
    [sym_bool] = ACTIONS(3041),
    [sym_byte] = ACTIONS(3041),
    [sym_ubyte] = ACTIONS(3041),
    [sym_char] = ACTIONS(3041),
    [sym_short] = ACTIONS(3041),
    [sym_ushort] = ACTIONS(3041),
    [sym_int] = ACTIONS(3041),
    [sym_uint] = ACTIONS(3041),
    [sym_long] = ACTIONS(3041),
    [sym_ulong] = ACTIONS(3041),
    [sym_cent] = ACTIONS(3041),
    [sym_ucent] = ACTIONS(3041),
    [sym_wchar] = ACTIONS(3041),
    [sym_dchar] = ACTIONS(3041),
    [sym_float] = ACTIONS(3041),
    [sym_double] = ACTIONS(3041),
    [sym_real] = ACTIONS(3041),
    [sym_ifloat] = ACTIONS(3041),
    [sym_idouble] = ACTIONS(3041),
    [sym_ireal] = ACTIONS(3041),
    [sym_cfloat] = ACTIONS(3041),
    [sym_cdouble] = ACTIONS(3041),
    [sym_creal] = ACTIONS(3041),
    [sym_size_t] = ACTIONS(3041),
    [sym_ptrdiff_t] = ACTIONS(3041),
    [sym_string] = ACTIONS(3041),
    [sym_cstring] = ACTIONS(3041),
    [sym_dstring] = ACTIONS(3041),
    [sym_wstring] = ACTIONS(3041),
    [sym_noreturn] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_null] = ACTIONS(3041),
    [sym_super] = ACTIONS(3041),
    [sym_this] = ACTIONS(3041),
    [sym_abstract] = ACTIONS(3041),
    [sym_alias] = ACTIONS(3041),
    [sym_align] = ACTIONS(3041),
    [sym_asm] = ACTIONS(3041),
    [sym_assert] = ACTIONS(3041),
    [sym_auto] = ACTIONS(3041),
    [sym_break] = ACTIONS(3041),
    [sym_case] = ACTIONS(3041),
    [sym_cast] = ACTIONS(3041),
    [sym_catch] = ACTIONS(3041),
    [sym_class] = ACTIONS(3041),
    [sym_const] = ACTIONS(3041),
    [sym_continue] = ACTIONS(3041),
    [sym_debug] = ACTIONS(3041),
    [sym_default] = ACTIONS(3041),
    [sym_delegate] = ACTIONS(3041),
    [sym_delete] = ACTIONS(3041),
    [sym_deprecated] = ACTIONS(3041),
    [sym_do] = ACTIONS(3041),
    [sym_else] = ACTIONS(3041),
    [sym_enum] = ACTIONS(3041),
    [sym_export] = ACTIONS(3041),
    [sym_extern] = ACTIONS(3041),
    [sym_final] = ACTIONS(3041),
    [sym_finally] = ACTIONS(3041),
    [sym_for] = ACTIONS(3041),
    [sym_foreach] = ACTIONS(3041),
    [sym_foreach_reverse] = ACTIONS(3041),
    [sym_function] = ACTIONS(3041),
    [sym_goto] = ACTIONS(3041),
    [sym_if] = ACTIONS(3041),
    [sym_immutable] = ACTIONS(3041),
    [sym_import] = ACTIONS(3041),
    [sym_in] = ACTIONS(3041),
    [sym_inout] = ACTIONS(3041),
    [sym_interface] = ACTIONS(3041),
    [sym_invariant] = ACTIONS(3041),
    [sym_is] = ACTIONS(3041),
    [sym_lazy] = ACTIONS(3041),
    [sym_mixin] = ACTIONS(3041),
    [sym_module] = ACTIONS(3041),
    [sym_new] = ACTIONS(3041),
    [sym_nothrow] = ACTIONS(3041),
    [sym_out] = ACTIONS(3041),
    [sym_override] = ACTIONS(3041),
    [sym_package] = ACTIONS(3041),
    [sym_pragma] = ACTIONS(3041),
    [sym_private] = ACTIONS(3041),
    [sym_protected] = ACTIONS(3041),
    [sym_public] = ACTIONS(3041),
    [sym_pure] = ACTIONS(3041),
    [sym_ref] = ACTIONS(3041),
    [sym_return] = ACTIONS(3041),
    [sym_scope] = ACTIONS(3041),
    [sym_shared] = ACTIONS(3041),
    [sym_static] = ACTIONS(3041),
    [sym_struct] = ACTIONS(3041),
    [sym_switch] = ACTIONS(3041),
    [sym_synchronized] = ACTIONS(3041),
    [sym_template] = ACTIONS(3041),
    [sym_throw] = ACTIONS(3041),
    [sym_try] = ACTIONS(3041),
    [sym_typeid] = ACTIONS(3041),
    [sym_typeof] = ACTIONS(3041),
    [sym_union] = ACTIONS(3041),
    [sym_unittest] = ACTIONS(3041),
    [sym_version] = ACTIONS(3041),
    [sym_while] = ACTIONS(3041),
    [sym_with] = ACTIONS(3041),
    [sym_parameters_] = ACTIONS(3041),
    [sym_gshared] = ACTIONS(3041),
    [sym_traits] = ACTIONS(3041),
    [sym_vector] = ACTIONS(3041),
    [sym_void] = ACTIONS(3041),
    [anon_sym_BQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [anon_sym_x_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3043),
    [anon_sym_i_BQUOTE] = ACTIONS(3043),
    [anon_sym_i_DQUOTE] = ACTIONS(3043),
    [anon_sym_iq_LBRACE] = ACTIONS(3043),
    [aux_sym_char_literal_token1] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym___DATE__] = ACTIONS(3041),
    [anon_sym___FILE__] = ACTIONS(3041),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3041),
    [anon_sym___FUNCTION__] = ACTIONS(3041),
    [anon_sym___LINE__] = ACTIONS(3041),
    [anon_sym___MODULE__] = ACTIONS(3041),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3041),
    [anon_sym___TIME__] = ACTIONS(3041),
    [anon_sym___TIMESTAMP__] = ACTIONS(3041),
    [anon_sym___VENDOR__] = ACTIONS(3041),
    [anon_sym___VERSION__] = ACTIONS(3041),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3043),
    [sym_float_literal] = ACTIONS(3043),
    [sym__string] = ACTIONS(3043),
  },
  [613] = {
    [sym_identifier] = ACTIONS(3045),
    [anon_sym_q_LBRACE] = ACTIONS(3047),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(3047),
    [anon_sym_SLASH] = ACTIONS(3045),
    [anon_sym_SLASH_EQ] = ACTIONS(3047),
    [anon_sym_DOT] = ACTIONS(3045),
    [anon_sym_DOT_DOT] = ACTIONS(3045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3047),
    [anon_sym_AMP] = ACTIONS(3045),
    [anon_sym_AMP_EQ] = ACTIONS(3047),
    [anon_sym_AMP_AMP] = ACTIONS(3047),
    [anon_sym_PIPE] = ACTIONS(3045),
    [anon_sym_PIPE_EQ] = ACTIONS(3047),
    [anon_sym_PIPE_PIPE] = ACTIONS(3047),
    [anon_sym_DASH] = ACTIONS(3045),
    [anon_sym_DASH_EQ] = ACTIONS(3047),
    [anon_sym_DASH_DASH] = ACTIONS(3047),
    [anon_sym_PLUS] = ACTIONS(3045),
    [anon_sym_PLUS_EQ] = ACTIONS(3047),
    [anon_sym_PLUS_PLUS] = ACTIONS(3047),
    [anon_sym_LT] = ACTIONS(3045),
    [anon_sym_LT_EQ] = ACTIONS(3047),
    [anon_sym_LT_LT] = ACTIONS(3045),
    [anon_sym_LT_LT_EQ] = ACTIONS(3047),
    [anon_sym_GT] = ACTIONS(3045),
    [anon_sym_GT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3047),
    [anon_sym_GT_GT] = ACTIONS(3045),
    [anon_sym_GT_GT_GT] = ACTIONS(3045),
    [anon_sym_BANG] = ACTIONS(3045),
    [anon_sym_BANG_EQ] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3047),
    [anon_sym_RPAREN] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(3047),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [anon_sym_QMARK] = ACTIONS(3047),
    [anon_sym_COMMA] = ACTIONS(3047),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_COLON] = ACTIONS(3047),
    [anon_sym_DOLLAR] = ACTIONS(3045),
    [anon_sym_EQ] = ACTIONS(3045),
    [anon_sym_EQ_EQ] = ACTIONS(3047),
    [anon_sym_STAR] = ACTIONS(3045),
    [anon_sym_STAR_EQ] = ACTIONS(3047),
    [anon_sym_PERCENT] = ACTIONS(3045),
    [anon_sym_PERCENT_EQ] = ACTIONS(3047),
    [anon_sym_CARET] = ACTIONS(3045),
    [anon_sym_CARET_EQ] = ACTIONS(3047),
    [anon_sym_CARET_CARET] = ACTIONS(3045),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3047),
    [anon_sym_TILDE] = ACTIONS(3045),
    [anon_sym_TILDE_EQ] = ACTIONS(3047),
    [anon_sym_AT] = ACTIONS(3047),
    [anon_sym_EQ_GT] = ACTIONS(3047),
    [anon_sym_POUND] = ACTIONS(3047),
    [sym_bool] = ACTIONS(3045),
    [sym_byte] = ACTIONS(3045),
    [sym_ubyte] = ACTIONS(3045),
    [sym_char] = ACTIONS(3045),
    [sym_short] = ACTIONS(3045),
    [sym_ushort] = ACTIONS(3045),
    [sym_int] = ACTIONS(3045),
    [sym_uint] = ACTIONS(3045),
    [sym_long] = ACTIONS(3045),
    [sym_ulong] = ACTIONS(3045),
    [sym_cent] = ACTIONS(3045),
    [sym_ucent] = ACTIONS(3045),
    [sym_wchar] = ACTIONS(3045),
    [sym_dchar] = ACTIONS(3045),
    [sym_float] = ACTIONS(3045),
    [sym_double] = ACTIONS(3045),
    [sym_real] = ACTIONS(3045),
    [sym_ifloat] = ACTIONS(3045),
    [sym_idouble] = ACTIONS(3045),
    [sym_ireal] = ACTIONS(3045),
    [sym_cfloat] = ACTIONS(3045),
    [sym_cdouble] = ACTIONS(3045),
    [sym_creal] = ACTIONS(3045),
    [sym_size_t] = ACTIONS(3045),
    [sym_ptrdiff_t] = ACTIONS(3045),
    [sym_string] = ACTIONS(3045),
    [sym_cstring] = ACTIONS(3045),
    [sym_dstring] = ACTIONS(3045),
    [sym_wstring] = ACTIONS(3045),
    [sym_noreturn] = ACTIONS(3045),
    [sym_true] = ACTIONS(3045),
    [sym_false] = ACTIONS(3045),
    [sym_null] = ACTIONS(3045),
    [sym_super] = ACTIONS(3045),
    [sym_this] = ACTIONS(3045),
    [sym_abstract] = ACTIONS(3045),
    [sym_alias] = ACTIONS(3045),
    [sym_align] = ACTIONS(3045),
    [sym_asm] = ACTIONS(3045),
    [sym_assert] = ACTIONS(3045),
    [sym_auto] = ACTIONS(3045),
    [sym_break] = ACTIONS(3045),
    [sym_case] = ACTIONS(3045),
    [sym_cast] = ACTIONS(3045),
    [sym_catch] = ACTIONS(3045),
    [sym_class] = ACTIONS(3045),
    [sym_const] = ACTIONS(3045),
    [sym_continue] = ACTIONS(3045),
    [sym_debug] = ACTIONS(3045),
    [sym_default] = ACTIONS(3045),
    [sym_delegate] = ACTIONS(3045),
    [sym_delete] = ACTIONS(3045),
    [sym_deprecated] = ACTIONS(3045),
    [sym_do] = ACTIONS(3045),
    [sym_else] = ACTIONS(3045),
    [sym_enum] = ACTIONS(3045),
    [sym_export] = ACTIONS(3045),
    [sym_extern] = ACTIONS(3045),
    [sym_final] = ACTIONS(3045),
    [sym_finally] = ACTIONS(3045),
    [sym_for] = ACTIONS(3045),
    [sym_foreach] = ACTIONS(3045),
    [sym_foreach_reverse] = ACTIONS(3045),
    [sym_function] = ACTIONS(3045),
    [sym_goto] = ACTIONS(3045),
    [sym_if] = ACTIONS(3045),
    [sym_immutable] = ACTIONS(3045),
    [sym_import] = ACTIONS(3045),
    [sym_in] = ACTIONS(3045),
    [sym_inout] = ACTIONS(3045),
    [sym_interface] = ACTIONS(3045),
    [sym_invariant] = ACTIONS(3045),
    [sym_is] = ACTIONS(3045),
    [sym_lazy] = ACTIONS(3045),
    [sym_mixin] = ACTIONS(3045),
    [sym_module] = ACTIONS(3045),
    [sym_new] = ACTIONS(3045),
    [sym_nothrow] = ACTIONS(3045),
    [sym_out] = ACTIONS(3045),
    [sym_override] = ACTIONS(3045),
    [sym_package] = ACTIONS(3045),
    [sym_pragma] = ACTIONS(3045),
    [sym_private] = ACTIONS(3045),
    [sym_protected] = ACTIONS(3045),
    [sym_public] = ACTIONS(3045),
    [sym_pure] = ACTIONS(3045),
    [sym_ref] = ACTIONS(3045),
    [sym_return] = ACTIONS(3045),
    [sym_scope] = ACTIONS(3045),
    [sym_shared] = ACTIONS(3045),
    [sym_static] = ACTIONS(3045),
    [sym_struct] = ACTIONS(3045),
    [sym_switch] = ACTIONS(3045),
    [sym_synchronized] = ACTIONS(3045),
    [sym_template] = ACTIONS(3045),
    [sym_throw] = ACTIONS(3045),
    [sym_try] = ACTIONS(3045),
    [sym_typeid] = ACTIONS(3045),
    [sym_typeof] = ACTIONS(3045),
    [sym_union] = ACTIONS(3045),
    [sym_unittest] = ACTIONS(3045),
    [sym_version] = ACTIONS(3045),
    [sym_while] = ACTIONS(3045),
    [sym_with] = ACTIONS(3045),
    [sym_parameters_] = ACTIONS(3045),
    [sym_gshared] = ACTIONS(3045),
    [sym_traits] = ACTIONS(3045),
    [sym_vector] = ACTIONS(3045),
    [sym_void] = ACTIONS(3045),
    [anon_sym_BQUOTE] = ACTIONS(3047),
    [anon_sym_r_DQUOTE] = ACTIONS(3047),
    [anon_sym_x_DQUOTE] = ACTIONS(3047),
    [anon_sym_DQUOTE] = ACTIONS(3047),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3047),
    [anon_sym_i_BQUOTE] = ACTIONS(3047),
    [anon_sym_i_DQUOTE] = ACTIONS(3047),
    [anon_sym_iq_LBRACE] = ACTIONS(3047),
    [aux_sym_char_literal_token1] = ACTIONS(3047),
    [anon_sym_SQUOTE] = ACTIONS(3045),
    [anon_sym___DATE__] = ACTIONS(3045),
    [anon_sym___FILE__] = ACTIONS(3045),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3045),
    [anon_sym___FUNCTION__] = ACTIONS(3045),
    [anon_sym___LINE__] = ACTIONS(3045),
    [anon_sym___MODULE__] = ACTIONS(3045),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3045),
    [anon_sym___TIME__] = ACTIONS(3045),
    [anon_sym___TIMESTAMP__] = ACTIONS(3045),
    [anon_sym___VENDOR__] = ACTIONS(3045),
    [anon_sym___VERSION__] = ACTIONS(3045),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3047),
    [sym_float_literal] = ACTIONS(3047),
    [sym__string] = ACTIONS(3047),
  },
  [614] = {
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_q_LBRACE] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_SLASH_EQ] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3051),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_AMP_EQ] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_PIPE_EQ] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_EQ] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_PLUS_EQ] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3051),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_LT_LT_EQ] = ACTIONS(3051),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_RBRACK] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_DOLLAR] = ACTIONS(3049),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_STAR_EQ] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_PERCENT_EQ] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_CARET_EQ] = ACTIONS(3051),
    [anon_sym_CARET_CARET] = ACTIONS(3049),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_TILDE_EQ] = ACTIONS(3051),
    [anon_sym_AT] = ACTIONS(3051),
    [anon_sym_EQ_GT] = ACTIONS(3051),
    [anon_sym_POUND] = ACTIONS(3051),
    [sym_bool] = ACTIONS(3049),
    [sym_byte] = ACTIONS(3049),
    [sym_ubyte] = ACTIONS(3049),
    [sym_char] = ACTIONS(3049),
    [sym_short] = ACTIONS(3049),
    [sym_ushort] = ACTIONS(3049),
    [sym_int] = ACTIONS(3049),
    [sym_uint] = ACTIONS(3049),
    [sym_long] = ACTIONS(3049),
    [sym_ulong] = ACTIONS(3049),
    [sym_cent] = ACTIONS(3049),
    [sym_ucent] = ACTIONS(3049),
    [sym_wchar] = ACTIONS(3049),
    [sym_dchar] = ACTIONS(3049),
    [sym_float] = ACTIONS(3049),
    [sym_double] = ACTIONS(3049),
    [sym_real] = ACTIONS(3049),
    [sym_ifloat] = ACTIONS(3049),
    [sym_idouble] = ACTIONS(3049),
    [sym_ireal] = ACTIONS(3049),
    [sym_cfloat] = ACTIONS(3049),
    [sym_cdouble] = ACTIONS(3049),
    [sym_creal] = ACTIONS(3049),
    [sym_size_t] = ACTIONS(3049),
    [sym_ptrdiff_t] = ACTIONS(3049),
    [sym_string] = ACTIONS(3049),
    [sym_cstring] = ACTIONS(3049),
    [sym_dstring] = ACTIONS(3049),
    [sym_wstring] = ACTIONS(3049),
    [sym_noreturn] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_super] = ACTIONS(3049),
    [sym_this] = ACTIONS(3049),
    [sym_abstract] = ACTIONS(3049),
    [sym_alias] = ACTIONS(3049),
    [sym_align] = ACTIONS(3049),
    [sym_asm] = ACTIONS(3049),
    [sym_assert] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [sym_break] = ACTIONS(3049),
    [sym_case] = ACTIONS(3049),
    [sym_cast] = ACTIONS(3049),
    [sym_catch] = ACTIONS(3049),
    [sym_class] = ACTIONS(3049),
    [sym_const] = ACTIONS(3049),
    [sym_continue] = ACTIONS(3049),
    [sym_debug] = ACTIONS(3049),
    [sym_default] = ACTIONS(3049),
    [sym_delegate] = ACTIONS(3049),
    [sym_delete] = ACTIONS(3049),
    [sym_deprecated] = ACTIONS(3049),
    [sym_do] = ACTIONS(3049),
    [sym_else] = ACTIONS(3049),
    [sym_enum] = ACTIONS(3049),
    [sym_export] = ACTIONS(3049),
    [sym_extern] = ACTIONS(3049),
    [sym_final] = ACTIONS(3049),
    [sym_finally] = ACTIONS(3049),
    [sym_for] = ACTIONS(3049),
    [sym_foreach] = ACTIONS(3049),
    [sym_foreach_reverse] = ACTIONS(3049),
    [sym_function] = ACTIONS(3049),
    [sym_goto] = ACTIONS(3049),
    [sym_if] = ACTIONS(3049),
    [sym_immutable] = ACTIONS(3049),
    [sym_import] = ACTIONS(3049),
    [sym_in] = ACTIONS(3049),
    [sym_inout] = ACTIONS(3049),
    [sym_interface] = ACTIONS(3049),
    [sym_invariant] = ACTIONS(3049),
    [sym_is] = ACTIONS(3049),
    [sym_lazy] = ACTIONS(3049),
    [sym_mixin] = ACTIONS(3049),
    [sym_module] = ACTIONS(3049),
    [sym_new] = ACTIONS(3049),
    [sym_nothrow] = ACTIONS(3049),
    [sym_out] = ACTIONS(3049),
    [sym_override] = ACTIONS(3049),
    [sym_package] = ACTIONS(3049),
    [sym_pragma] = ACTIONS(3049),
    [sym_private] = ACTIONS(3049),
    [sym_protected] = ACTIONS(3049),
    [sym_public] = ACTIONS(3049),
    [sym_pure] = ACTIONS(3049),
    [sym_ref] = ACTIONS(3049),
    [sym_return] = ACTIONS(3049),
    [sym_scope] = ACTIONS(3049),
    [sym_shared] = ACTIONS(3049),
    [sym_static] = ACTIONS(3049),
    [sym_struct] = ACTIONS(3049),
    [sym_switch] = ACTIONS(3049),
    [sym_synchronized] = ACTIONS(3049),
    [sym_template] = ACTIONS(3049),
    [sym_throw] = ACTIONS(3049),
    [sym_try] = ACTIONS(3049),
    [sym_typeid] = ACTIONS(3049),
    [sym_typeof] = ACTIONS(3049),
    [sym_union] = ACTIONS(3049),
    [sym_unittest] = ACTIONS(3049),
    [sym_version] = ACTIONS(3049),
    [sym_while] = ACTIONS(3049),
    [sym_with] = ACTIONS(3049),
    [sym_parameters_] = ACTIONS(3049),
    [sym_gshared] = ACTIONS(3049),
    [sym_traits] = ACTIONS(3049),
    [sym_vector] = ACTIONS(3049),
    [sym_void] = ACTIONS(3049),
    [anon_sym_BQUOTE] = ACTIONS(3051),
    [anon_sym_r_DQUOTE] = ACTIONS(3051),
    [anon_sym_x_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3051),
    [anon_sym_i_BQUOTE] = ACTIONS(3051),
    [anon_sym_i_DQUOTE] = ACTIONS(3051),
    [anon_sym_iq_LBRACE] = ACTIONS(3051),
    [aux_sym_char_literal_token1] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym___DATE__] = ACTIONS(3049),
    [anon_sym___FILE__] = ACTIONS(3049),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3049),
    [anon_sym___FUNCTION__] = ACTIONS(3049),
    [anon_sym___LINE__] = ACTIONS(3049),
    [anon_sym___MODULE__] = ACTIONS(3049),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3049),
    [anon_sym___TIME__] = ACTIONS(3049),
    [anon_sym___TIMESTAMP__] = ACTIONS(3049),
    [anon_sym___VENDOR__] = ACTIONS(3049),
    [anon_sym___VERSION__] = ACTIONS(3049),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3051),
    [sym_float_literal] = ACTIONS(3051),
    [sym__string] = ACTIONS(3051),
  },
  [615] = {
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_q_LBRACE] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3053),
    [anon_sym_SLASH_EQ] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_AMP_EQ] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3053),
    [anon_sym_PIPE_EQ] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_DASH_EQ] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3053),
    [anon_sym_LT_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3053),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3053),
    [anon_sym_GT_GT_GT] = ACTIONS(3053),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_RBRACK] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_DOLLAR] = ACTIONS(3053),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_STAR_EQ] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3053),
    [anon_sym_PERCENT_EQ] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_CARET_EQ] = ACTIONS(3055),
    [anon_sym_CARET_CARET] = ACTIONS(3053),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_TILDE_EQ] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [anon_sym_EQ_GT] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [sym_bool] = ACTIONS(3053),
    [sym_byte] = ACTIONS(3053),
    [sym_ubyte] = ACTIONS(3053),
    [sym_char] = ACTIONS(3053),
    [sym_short] = ACTIONS(3053),
    [sym_ushort] = ACTIONS(3053),
    [sym_int] = ACTIONS(3053),
    [sym_uint] = ACTIONS(3053),
    [sym_long] = ACTIONS(3053),
    [sym_ulong] = ACTIONS(3053),
    [sym_cent] = ACTIONS(3053),
    [sym_ucent] = ACTIONS(3053),
    [sym_wchar] = ACTIONS(3053),
    [sym_dchar] = ACTIONS(3053),
    [sym_float] = ACTIONS(3053),
    [sym_double] = ACTIONS(3053),
    [sym_real] = ACTIONS(3053),
    [sym_ifloat] = ACTIONS(3053),
    [sym_idouble] = ACTIONS(3053),
    [sym_ireal] = ACTIONS(3053),
    [sym_cfloat] = ACTIONS(3053),
    [sym_cdouble] = ACTIONS(3053),
    [sym_creal] = ACTIONS(3053),
    [sym_size_t] = ACTIONS(3053),
    [sym_ptrdiff_t] = ACTIONS(3053),
    [sym_string] = ACTIONS(3053),
    [sym_cstring] = ACTIONS(3053),
    [sym_dstring] = ACTIONS(3053),
    [sym_wstring] = ACTIONS(3053),
    [sym_noreturn] = ACTIONS(3053),
    [sym_true] = ACTIONS(3053),
    [sym_false] = ACTIONS(3053),
    [sym_null] = ACTIONS(3053),
    [sym_super] = ACTIONS(3053),
    [sym_this] = ACTIONS(3053),
    [sym_abstract] = ACTIONS(3053),
    [sym_alias] = ACTIONS(3053),
    [sym_align] = ACTIONS(3053),
    [sym_asm] = ACTIONS(3053),
    [sym_assert] = ACTIONS(3053),
    [sym_auto] = ACTIONS(3053),
    [sym_break] = ACTIONS(3053),
    [sym_case] = ACTIONS(3053),
    [sym_cast] = ACTIONS(3053),
    [sym_catch] = ACTIONS(3053),
    [sym_class] = ACTIONS(3053),
    [sym_const] = ACTIONS(3053),
    [sym_continue] = ACTIONS(3053),
    [sym_debug] = ACTIONS(3053),
    [sym_default] = ACTIONS(3053),
    [sym_delegate] = ACTIONS(3053),
    [sym_delete] = ACTIONS(3053),
    [sym_deprecated] = ACTIONS(3053),
    [sym_do] = ACTIONS(3053),
    [sym_else] = ACTIONS(3053),
    [sym_enum] = ACTIONS(3053),
    [sym_export] = ACTIONS(3053),
    [sym_extern] = ACTIONS(3053),
    [sym_final] = ACTIONS(3053),
    [sym_finally] = ACTIONS(3053),
    [sym_for] = ACTIONS(3053),
    [sym_foreach] = ACTIONS(3053),
    [sym_foreach_reverse] = ACTIONS(3053),
    [sym_function] = ACTIONS(3053),
    [sym_goto] = ACTIONS(3053),
    [sym_if] = ACTIONS(3053),
    [sym_immutable] = ACTIONS(3053),
    [sym_import] = ACTIONS(3053),
    [sym_in] = ACTIONS(3053),
    [sym_inout] = ACTIONS(3053),
    [sym_interface] = ACTIONS(3053),
    [sym_invariant] = ACTIONS(3053),
    [sym_is] = ACTIONS(3053),
    [sym_lazy] = ACTIONS(3053),
    [sym_mixin] = ACTIONS(3053),
    [sym_module] = ACTIONS(3053),
    [sym_new] = ACTIONS(3053),
    [sym_nothrow] = ACTIONS(3053),
    [sym_out] = ACTIONS(3053),
    [sym_override] = ACTIONS(3053),
    [sym_package] = ACTIONS(3053),
    [sym_pragma] = ACTIONS(3053),
    [sym_private] = ACTIONS(3053),
    [sym_protected] = ACTIONS(3053),
    [sym_public] = ACTIONS(3053),
    [sym_pure] = ACTIONS(3053),
    [sym_ref] = ACTIONS(3053),
    [sym_return] = ACTIONS(3053),
    [sym_scope] = ACTIONS(3053),
    [sym_shared] = ACTIONS(3053),
    [sym_static] = ACTIONS(3053),
    [sym_struct] = ACTIONS(3053),
    [sym_switch] = ACTIONS(3053),
    [sym_synchronized] = ACTIONS(3053),
    [sym_template] = ACTIONS(3053),
    [sym_throw] = ACTIONS(3053),
    [sym_try] = ACTIONS(3053),
    [sym_typeid] = ACTIONS(3053),
    [sym_typeof] = ACTIONS(3053),
    [sym_union] = ACTIONS(3053),
    [sym_unittest] = ACTIONS(3053),
    [sym_version] = ACTIONS(3053),
    [sym_while] = ACTIONS(3053),
    [sym_with] = ACTIONS(3053),
    [sym_parameters_] = ACTIONS(3053),
    [sym_gshared] = ACTIONS(3053),
    [sym_traits] = ACTIONS(3053),
    [sym_vector] = ACTIONS(3053),
    [sym_void] = ACTIONS(3053),
    [anon_sym_BQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [anon_sym_x_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3055),
    [anon_sym_i_BQUOTE] = ACTIONS(3055),
    [anon_sym_i_DQUOTE] = ACTIONS(3055),
    [anon_sym_iq_LBRACE] = ACTIONS(3055),
    [aux_sym_char_literal_token1] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [anon_sym___DATE__] = ACTIONS(3053),
    [anon_sym___FILE__] = ACTIONS(3053),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3053),
    [anon_sym___FUNCTION__] = ACTIONS(3053),
    [anon_sym___LINE__] = ACTIONS(3053),
    [anon_sym___MODULE__] = ACTIONS(3053),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3053),
    [anon_sym___TIME__] = ACTIONS(3053),
    [anon_sym___TIMESTAMP__] = ACTIONS(3053),
    [anon_sym___VENDOR__] = ACTIONS(3053),
    [anon_sym___VERSION__] = ACTIONS(3053),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym__string] = ACTIONS(3055),
  },
  [616] = {
    [sym_identifier] = ACTIONS(3057),
    [anon_sym_q_LBRACE] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_GT_GT_GT] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_DOLLAR] = ACTIONS(3057),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_CARET_CARET] = ACTIONS(3057),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_TILDE_EQ] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_EQ_GT] = ACTIONS(3059),
    [anon_sym_POUND] = ACTIONS(3059),
    [sym_bool] = ACTIONS(3057),
    [sym_byte] = ACTIONS(3057),
    [sym_ubyte] = ACTIONS(3057),
    [sym_char] = ACTIONS(3057),
    [sym_short] = ACTIONS(3057),
    [sym_ushort] = ACTIONS(3057),
    [sym_int] = ACTIONS(3057),
    [sym_uint] = ACTIONS(3057),
    [sym_long] = ACTIONS(3057),
    [sym_ulong] = ACTIONS(3057),
    [sym_cent] = ACTIONS(3057),
    [sym_ucent] = ACTIONS(3057),
    [sym_wchar] = ACTIONS(3057),
    [sym_dchar] = ACTIONS(3057),
    [sym_float] = ACTIONS(3057),
    [sym_double] = ACTIONS(3057),
    [sym_real] = ACTIONS(3057),
    [sym_ifloat] = ACTIONS(3057),
    [sym_idouble] = ACTIONS(3057),
    [sym_ireal] = ACTIONS(3057),
    [sym_cfloat] = ACTIONS(3057),
    [sym_cdouble] = ACTIONS(3057),
    [sym_creal] = ACTIONS(3057),
    [sym_size_t] = ACTIONS(3057),
    [sym_ptrdiff_t] = ACTIONS(3057),
    [sym_string] = ACTIONS(3057),
    [sym_cstring] = ACTIONS(3057),
    [sym_dstring] = ACTIONS(3057),
    [sym_wstring] = ACTIONS(3057),
    [sym_noreturn] = ACTIONS(3057),
    [sym_true] = ACTIONS(3057),
    [sym_false] = ACTIONS(3057),
    [sym_null] = ACTIONS(3057),
    [sym_super] = ACTIONS(3057),
    [sym_this] = ACTIONS(3057),
    [sym_abstract] = ACTIONS(3057),
    [sym_alias] = ACTIONS(3057),
    [sym_align] = ACTIONS(3057),
    [sym_asm] = ACTIONS(3057),
    [sym_assert] = ACTIONS(3057),
    [sym_auto] = ACTIONS(3057),
    [sym_break] = ACTIONS(3057),
    [sym_case] = ACTIONS(3057),
    [sym_cast] = ACTIONS(3057),
    [sym_catch] = ACTIONS(3057),
    [sym_class] = ACTIONS(3057),
    [sym_const] = ACTIONS(3057),
    [sym_continue] = ACTIONS(3057),
    [sym_debug] = ACTIONS(3057),
    [sym_default] = ACTIONS(3057),
    [sym_delegate] = ACTIONS(3057),
    [sym_delete] = ACTIONS(3057),
    [sym_deprecated] = ACTIONS(3057),
    [sym_do] = ACTIONS(3057),
    [sym_else] = ACTIONS(3057),
    [sym_enum] = ACTIONS(3057),
    [sym_export] = ACTIONS(3057),
    [sym_extern] = ACTIONS(3057),
    [sym_final] = ACTIONS(3057),
    [sym_finally] = ACTIONS(3057),
    [sym_for] = ACTIONS(3057),
    [sym_foreach] = ACTIONS(3057),
    [sym_foreach_reverse] = ACTIONS(3057),
    [sym_function] = ACTIONS(3057),
    [sym_goto] = ACTIONS(3057),
    [sym_if] = ACTIONS(3057),
    [sym_immutable] = ACTIONS(3057),
    [sym_import] = ACTIONS(3057),
    [sym_in] = ACTIONS(3057),
    [sym_inout] = ACTIONS(3057),
    [sym_interface] = ACTIONS(3057),
    [sym_invariant] = ACTIONS(3057),
    [sym_is] = ACTIONS(3057),
    [sym_lazy] = ACTIONS(3057),
    [sym_mixin] = ACTIONS(3057),
    [sym_module] = ACTIONS(3057),
    [sym_new] = ACTIONS(3057),
    [sym_nothrow] = ACTIONS(3057),
    [sym_out] = ACTIONS(3057),
    [sym_override] = ACTIONS(3057),
    [sym_package] = ACTIONS(3057),
    [sym_pragma] = ACTIONS(3057),
    [sym_private] = ACTIONS(3057),
    [sym_protected] = ACTIONS(3057),
    [sym_public] = ACTIONS(3057),
    [sym_pure] = ACTIONS(3057),
    [sym_ref] = ACTIONS(3057),
    [sym_return] = ACTIONS(3057),
    [sym_scope] = ACTIONS(3057),
    [sym_shared] = ACTIONS(3057),
    [sym_static] = ACTIONS(3057),
    [sym_struct] = ACTIONS(3057),
    [sym_switch] = ACTIONS(3057),
    [sym_synchronized] = ACTIONS(3057),
    [sym_template] = ACTIONS(3057),
    [sym_throw] = ACTIONS(3057),
    [sym_try] = ACTIONS(3057),
    [sym_typeid] = ACTIONS(3057),
    [sym_typeof] = ACTIONS(3057),
    [sym_union] = ACTIONS(3057),
    [sym_unittest] = ACTIONS(3057),
    [sym_version] = ACTIONS(3057),
    [sym_while] = ACTIONS(3057),
    [sym_with] = ACTIONS(3057),
    [sym_parameters_] = ACTIONS(3057),
    [sym_gshared] = ACTIONS(3057),
    [sym_traits] = ACTIONS(3057),
    [sym_vector] = ACTIONS(3057),
    [sym_void] = ACTIONS(3057),
    [anon_sym_BQUOTE] = ACTIONS(3059),
    [anon_sym_r_DQUOTE] = ACTIONS(3059),
    [anon_sym_x_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3059),
    [anon_sym_i_BQUOTE] = ACTIONS(3059),
    [anon_sym_i_DQUOTE] = ACTIONS(3059),
    [anon_sym_iq_LBRACE] = ACTIONS(3059),
    [aux_sym_char_literal_token1] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [anon_sym___DATE__] = ACTIONS(3057),
    [anon_sym___FILE__] = ACTIONS(3057),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3057),
    [anon_sym___FUNCTION__] = ACTIONS(3057),
    [anon_sym___LINE__] = ACTIONS(3057),
    [anon_sym___MODULE__] = ACTIONS(3057),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3057),
    [anon_sym___TIME__] = ACTIONS(3057),
    [anon_sym___TIMESTAMP__] = ACTIONS(3057),
    [anon_sym___VENDOR__] = ACTIONS(3057),
    [anon_sym___VERSION__] = ACTIONS(3057),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3059),
    [sym_float_literal] = ACTIONS(3059),
    [sym__string] = ACTIONS(3059),
  },
  [617] = {
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_q_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_SLASH_EQ] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_AMP_EQ] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_PIPE_EQ] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_DASH_EQ] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_PLUS_EQ] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_LT_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_DOLLAR] = ACTIONS(3061),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_STAR_EQ] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_PERCENT_EQ] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_CARET_EQ] = ACTIONS(3063),
    [anon_sym_CARET_CARET] = ACTIONS(3061),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_TILDE_EQ] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_EQ_GT] = ACTIONS(3063),
    [anon_sym_POUND] = ACTIONS(3063),
    [sym_bool] = ACTIONS(3061),
    [sym_byte] = ACTIONS(3061),
    [sym_ubyte] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_short] = ACTIONS(3061),
    [sym_ushort] = ACTIONS(3061),
    [sym_int] = ACTIONS(3061),
    [sym_uint] = ACTIONS(3061),
    [sym_long] = ACTIONS(3061),
    [sym_ulong] = ACTIONS(3061),
    [sym_cent] = ACTIONS(3061),
    [sym_ucent] = ACTIONS(3061),
    [sym_wchar] = ACTIONS(3061),
    [sym_dchar] = ACTIONS(3061),
    [sym_float] = ACTIONS(3061),
    [sym_double] = ACTIONS(3061),
    [sym_real] = ACTIONS(3061),
    [sym_ifloat] = ACTIONS(3061),
    [sym_idouble] = ACTIONS(3061),
    [sym_ireal] = ACTIONS(3061),
    [sym_cfloat] = ACTIONS(3061),
    [sym_cdouble] = ACTIONS(3061),
    [sym_creal] = ACTIONS(3061),
    [sym_size_t] = ACTIONS(3061),
    [sym_ptrdiff_t] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym_cstring] = ACTIONS(3061),
    [sym_dstring] = ACTIONS(3061),
    [sym_wstring] = ACTIONS(3061),
    [sym_noreturn] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_null] = ACTIONS(3061),
    [sym_super] = ACTIONS(3061),
    [sym_this] = ACTIONS(3061),
    [sym_abstract] = ACTIONS(3061),
    [sym_alias] = ACTIONS(3061),
    [sym_align] = ACTIONS(3061),
    [sym_asm] = ACTIONS(3061),
    [sym_assert] = ACTIONS(3061),
    [sym_auto] = ACTIONS(3061),
    [sym_break] = ACTIONS(3061),
    [sym_case] = ACTIONS(3061),
    [sym_cast] = ACTIONS(3061),
    [sym_catch] = ACTIONS(3061),
    [sym_class] = ACTIONS(3061),
    [sym_const] = ACTIONS(3061),
    [sym_continue] = ACTIONS(3061),
    [sym_debug] = ACTIONS(3061),
    [sym_default] = ACTIONS(3061),
    [sym_delegate] = ACTIONS(3061),
    [sym_delete] = ACTIONS(3061),
    [sym_deprecated] = ACTIONS(3061),
    [sym_do] = ACTIONS(3061),
    [sym_else] = ACTIONS(3061),
    [sym_enum] = ACTIONS(3061),
    [sym_export] = ACTIONS(3061),
    [sym_extern] = ACTIONS(3061),
    [sym_final] = ACTIONS(3061),
    [sym_finally] = ACTIONS(3061),
    [sym_for] = ACTIONS(3061),
    [sym_foreach] = ACTIONS(3061),
    [sym_foreach_reverse] = ACTIONS(3061),
    [sym_function] = ACTIONS(3061),
    [sym_goto] = ACTIONS(3061),
    [sym_if] = ACTIONS(3061),
    [sym_immutable] = ACTIONS(3061),
    [sym_import] = ACTIONS(3061),
    [sym_in] = ACTIONS(3061),
    [sym_inout] = ACTIONS(3061),
    [sym_interface] = ACTIONS(3061),
    [sym_invariant] = ACTIONS(3061),
    [sym_is] = ACTIONS(3061),
    [sym_lazy] = ACTIONS(3061),
    [sym_mixin] = ACTIONS(3061),
    [sym_module] = ACTIONS(3061),
    [sym_new] = ACTIONS(3061),
    [sym_nothrow] = ACTIONS(3061),
    [sym_out] = ACTIONS(3061),
    [sym_override] = ACTIONS(3061),
    [sym_package] = ACTIONS(3061),
    [sym_pragma] = ACTIONS(3061),
    [sym_private] = ACTIONS(3061),
    [sym_protected] = ACTIONS(3061),
    [sym_public] = ACTIONS(3061),
    [sym_pure] = ACTIONS(3061),
    [sym_ref] = ACTIONS(3061),
    [sym_return] = ACTIONS(3061),
    [sym_scope] = ACTIONS(3061),
    [sym_shared] = ACTIONS(3061),
    [sym_static] = ACTIONS(3061),
    [sym_struct] = ACTIONS(3061),
    [sym_switch] = ACTIONS(3061),
    [sym_synchronized] = ACTIONS(3061),
    [sym_template] = ACTIONS(3061),
    [sym_throw] = ACTIONS(3061),
    [sym_try] = ACTIONS(3061),
    [sym_typeid] = ACTIONS(3061),
    [sym_typeof] = ACTIONS(3061),
    [sym_union] = ACTIONS(3061),
    [sym_unittest] = ACTIONS(3061),
    [sym_version] = ACTIONS(3061),
    [sym_while] = ACTIONS(3061),
    [sym_with] = ACTIONS(3061),
    [sym_parameters_] = ACTIONS(3061),
    [sym_gshared] = ACTIONS(3061),
    [sym_traits] = ACTIONS(3061),
    [sym_vector] = ACTIONS(3061),
    [sym_void] = ACTIONS(3061),
    [anon_sym_BQUOTE] = ACTIONS(3063),
    [anon_sym_r_DQUOTE] = ACTIONS(3063),
    [anon_sym_x_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3063),
    [anon_sym_i_BQUOTE] = ACTIONS(3063),
    [anon_sym_i_DQUOTE] = ACTIONS(3063),
    [anon_sym_iq_LBRACE] = ACTIONS(3063),
    [aux_sym_char_literal_token1] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym___DATE__] = ACTIONS(3061),
    [anon_sym___FILE__] = ACTIONS(3061),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3061),
    [anon_sym___FUNCTION__] = ACTIONS(3061),
    [anon_sym___LINE__] = ACTIONS(3061),
    [anon_sym___MODULE__] = ACTIONS(3061),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3061),
    [anon_sym___TIME__] = ACTIONS(3061),
    [anon_sym___TIMESTAMP__] = ACTIONS(3061),
    [anon_sym___VENDOR__] = ACTIONS(3061),
    [anon_sym___VERSION__] = ACTIONS(3061),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3063),
    [sym_float_literal] = ACTIONS(3063),
    [sym__string] = ACTIONS(3063),
  },
  [618] = {
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_q_LBRACE] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_SLASH_EQ] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_AMP_EQ] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_PIPE_EQ] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_EQ] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_PLUS_EQ] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_LT_LT_EQ] = ACTIONS(3067),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_DOLLAR] = ACTIONS(3065),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_STAR_EQ] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_PERCENT_EQ] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_CARET_EQ] = ACTIONS(3067),
    [anon_sym_CARET_CARET] = ACTIONS(3065),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_TILDE_EQ] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_EQ_GT] = ACTIONS(3067),
    [anon_sym_POUND] = ACTIONS(3067),
    [sym_bool] = ACTIONS(3065),
    [sym_byte] = ACTIONS(3065),
    [sym_ubyte] = ACTIONS(3065),
    [sym_char] = ACTIONS(3065),
    [sym_short] = ACTIONS(3065),
    [sym_ushort] = ACTIONS(3065),
    [sym_int] = ACTIONS(3065),
    [sym_uint] = ACTIONS(3065),
    [sym_long] = ACTIONS(3065),
    [sym_ulong] = ACTIONS(3065),
    [sym_cent] = ACTIONS(3065),
    [sym_ucent] = ACTIONS(3065),
    [sym_wchar] = ACTIONS(3065),
    [sym_dchar] = ACTIONS(3065),
    [sym_float] = ACTIONS(3065),
    [sym_double] = ACTIONS(3065),
    [sym_real] = ACTIONS(3065),
    [sym_ifloat] = ACTIONS(3065),
    [sym_idouble] = ACTIONS(3065),
    [sym_ireal] = ACTIONS(3065),
    [sym_cfloat] = ACTIONS(3065),
    [sym_cdouble] = ACTIONS(3065),
    [sym_creal] = ACTIONS(3065),
    [sym_size_t] = ACTIONS(3065),
    [sym_ptrdiff_t] = ACTIONS(3065),
    [sym_string] = ACTIONS(3065),
    [sym_cstring] = ACTIONS(3065),
    [sym_dstring] = ACTIONS(3065),
    [sym_wstring] = ACTIONS(3065),
    [sym_noreturn] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_super] = ACTIONS(3065),
    [sym_this] = ACTIONS(3065),
    [sym_abstract] = ACTIONS(3065),
    [sym_alias] = ACTIONS(3065),
    [sym_align] = ACTIONS(3065),
    [sym_asm] = ACTIONS(3065),
    [sym_assert] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [sym_break] = ACTIONS(3065),
    [sym_case] = ACTIONS(3065),
    [sym_cast] = ACTIONS(3065),
    [sym_catch] = ACTIONS(3065),
    [sym_class] = ACTIONS(3065),
    [sym_const] = ACTIONS(3065),
    [sym_continue] = ACTIONS(3065),
    [sym_debug] = ACTIONS(3065),
    [sym_default] = ACTIONS(3065),
    [sym_delegate] = ACTIONS(3065),
    [sym_delete] = ACTIONS(3065),
    [sym_deprecated] = ACTIONS(3065),
    [sym_do] = ACTIONS(3065),
    [sym_else] = ACTIONS(3065),
    [sym_enum] = ACTIONS(3065),
    [sym_export] = ACTIONS(3065),
    [sym_extern] = ACTIONS(3065),
    [sym_final] = ACTIONS(3065),
    [sym_finally] = ACTIONS(3065),
    [sym_for] = ACTIONS(3065),
    [sym_foreach] = ACTIONS(3065),
    [sym_foreach_reverse] = ACTIONS(3065),
    [sym_function] = ACTIONS(3065),
    [sym_goto] = ACTIONS(3065),
    [sym_if] = ACTIONS(3065),
    [sym_immutable] = ACTIONS(3065),
    [sym_import] = ACTIONS(3065),
    [sym_in] = ACTIONS(3065),
    [sym_inout] = ACTIONS(3065),
    [sym_interface] = ACTIONS(3065),
    [sym_invariant] = ACTIONS(3065),
    [sym_is] = ACTIONS(3065),
    [sym_lazy] = ACTIONS(3065),
    [sym_mixin] = ACTIONS(3065),
    [sym_module] = ACTIONS(3065),
    [sym_new] = ACTIONS(3065),
    [sym_nothrow] = ACTIONS(3065),
    [sym_out] = ACTIONS(3065),
    [sym_override] = ACTIONS(3065),
    [sym_package] = ACTIONS(3065),
    [sym_pragma] = ACTIONS(3065),
    [sym_private] = ACTIONS(3065),
    [sym_protected] = ACTIONS(3065),
    [sym_public] = ACTIONS(3065),
    [sym_pure] = ACTIONS(3065),
    [sym_ref] = ACTIONS(3065),
    [sym_return] = ACTIONS(3065),
    [sym_scope] = ACTIONS(3065),
    [sym_shared] = ACTIONS(3065),
    [sym_static] = ACTIONS(3065),
    [sym_struct] = ACTIONS(3065),
    [sym_switch] = ACTIONS(3065),
    [sym_synchronized] = ACTIONS(3065),
    [sym_template] = ACTIONS(3065),
    [sym_throw] = ACTIONS(3065),
    [sym_try] = ACTIONS(3065),
    [sym_typeid] = ACTIONS(3065),
    [sym_typeof] = ACTIONS(3065),
    [sym_union] = ACTIONS(3065),
    [sym_unittest] = ACTIONS(3065),
    [sym_version] = ACTIONS(3065),
    [sym_while] = ACTIONS(3065),
    [sym_with] = ACTIONS(3065),
    [sym_parameters_] = ACTIONS(3065),
    [sym_gshared] = ACTIONS(3065),
    [sym_traits] = ACTIONS(3065),
    [sym_vector] = ACTIONS(3065),
    [sym_void] = ACTIONS(3065),
    [anon_sym_BQUOTE] = ACTIONS(3067),
    [anon_sym_r_DQUOTE] = ACTIONS(3067),
    [anon_sym_x_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3067),
    [anon_sym_i_BQUOTE] = ACTIONS(3067),
    [anon_sym_i_DQUOTE] = ACTIONS(3067),
    [anon_sym_iq_LBRACE] = ACTIONS(3067),
    [aux_sym_char_literal_token1] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym___DATE__] = ACTIONS(3065),
    [anon_sym___FILE__] = ACTIONS(3065),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3065),
    [anon_sym___FUNCTION__] = ACTIONS(3065),
    [anon_sym___LINE__] = ACTIONS(3065),
    [anon_sym___MODULE__] = ACTIONS(3065),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3065),
    [anon_sym___TIME__] = ACTIONS(3065),
    [anon_sym___TIMESTAMP__] = ACTIONS(3065),
    [anon_sym___VENDOR__] = ACTIONS(3065),
    [anon_sym___VERSION__] = ACTIONS(3065),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3067),
    [sym_float_literal] = ACTIONS(3067),
    [sym__string] = ACTIONS(3067),
  },
  [619] = {
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_q_LBRACE] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_SLASH_EQ] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_AMP_EQ] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_PIPE_EQ] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_DASH_EQ] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_LT_LT_EQ] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3069),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_STAR_EQ] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_PERCENT_EQ] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_CARET_EQ] = ACTIONS(3071),
    [anon_sym_CARET_CARET] = ACTIONS(3069),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_TILDE_EQ] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_EQ_GT] = ACTIONS(3071),
    [anon_sym_POUND] = ACTIONS(3071),
    [sym_bool] = ACTIONS(3069),
    [sym_byte] = ACTIONS(3069),
    [sym_ubyte] = ACTIONS(3069),
    [sym_char] = ACTIONS(3069),
    [sym_short] = ACTIONS(3069),
    [sym_ushort] = ACTIONS(3069),
    [sym_int] = ACTIONS(3069),
    [sym_uint] = ACTIONS(3069),
    [sym_long] = ACTIONS(3069),
    [sym_ulong] = ACTIONS(3069),
    [sym_cent] = ACTIONS(3069),
    [sym_ucent] = ACTIONS(3069),
    [sym_wchar] = ACTIONS(3069),
    [sym_dchar] = ACTIONS(3069),
    [sym_float] = ACTIONS(3069),
    [sym_double] = ACTIONS(3069),
    [sym_real] = ACTIONS(3069),
    [sym_ifloat] = ACTIONS(3069),
    [sym_idouble] = ACTIONS(3069),
    [sym_ireal] = ACTIONS(3069),
    [sym_cfloat] = ACTIONS(3069),
    [sym_cdouble] = ACTIONS(3069),
    [sym_creal] = ACTIONS(3069),
    [sym_size_t] = ACTIONS(3069),
    [sym_ptrdiff_t] = ACTIONS(3069),
    [sym_string] = ACTIONS(3069),
    [sym_cstring] = ACTIONS(3069),
    [sym_dstring] = ACTIONS(3069),
    [sym_wstring] = ACTIONS(3069),
    [sym_noreturn] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_null] = ACTIONS(3069),
    [sym_super] = ACTIONS(3069),
    [sym_this] = ACTIONS(3069),
    [sym_abstract] = ACTIONS(3069),
    [sym_alias] = ACTIONS(3069),
    [sym_align] = ACTIONS(3069),
    [sym_asm] = ACTIONS(3069),
    [sym_assert] = ACTIONS(3069),
    [sym_auto] = ACTIONS(3069),
    [sym_break] = ACTIONS(3069),
    [sym_case] = ACTIONS(3069),
    [sym_cast] = ACTIONS(3069),
    [sym_catch] = ACTIONS(3069),
    [sym_class] = ACTIONS(3069),
    [sym_const] = ACTIONS(3069),
    [sym_continue] = ACTIONS(3069),
    [sym_debug] = ACTIONS(3069),
    [sym_default] = ACTIONS(3069),
    [sym_delegate] = ACTIONS(3069),
    [sym_delete] = ACTIONS(3069),
    [sym_deprecated] = ACTIONS(3069),
    [sym_do] = ACTIONS(3069),
    [sym_else] = ACTIONS(3069),
    [sym_enum] = ACTIONS(3069),
    [sym_export] = ACTIONS(3069),
    [sym_extern] = ACTIONS(3069),
    [sym_final] = ACTIONS(3069),
    [sym_finally] = ACTIONS(3069),
    [sym_for] = ACTIONS(3069),
    [sym_foreach] = ACTIONS(3069),
    [sym_foreach_reverse] = ACTIONS(3069),
    [sym_function] = ACTIONS(3069),
    [sym_goto] = ACTIONS(3069),
    [sym_if] = ACTIONS(3069),
    [sym_immutable] = ACTIONS(3069),
    [sym_import] = ACTIONS(3069),
    [sym_in] = ACTIONS(3069),
    [sym_inout] = ACTIONS(3069),
    [sym_interface] = ACTIONS(3069),
    [sym_invariant] = ACTIONS(3069),
    [sym_is] = ACTIONS(3069),
    [sym_lazy] = ACTIONS(3069),
    [sym_mixin] = ACTIONS(3069),
    [sym_module] = ACTIONS(3069),
    [sym_new] = ACTIONS(3069),
    [sym_nothrow] = ACTIONS(3069),
    [sym_out] = ACTIONS(3069),
    [sym_override] = ACTIONS(3069),
    [sym_package] = ACTIONS(3069),
    [sym_pragma] = ACTIONS(3069),
    [sym_private] = ACTIONS(3069),
    [sym_protected] = ACTIONS(3069),
    [sym_public] = ACTIONS(3069),
    [sym_pure] = ACTIONS(3069),
    [sym_ref] = ACTIONS(3069),
    [sym_return] = ACTIONS(3069),
    [sym_scope] = ACTIONS(3069),
    [sym_shared] = ACTIONS(3069),
    [sym_static] = ACTIONS(3069),
    [sym_struct] = ACTIONS(3069),
    [sym_switch] = ACTIONS(3069),
    [sym_synchronized] = ACTIONS(3069),
    [sym_template] = ACTIONS(3069),
    [sym_throw] = ACTIONS(3069),
    [sym_try] = ACTIONS(3069),
    [sym_typeid] = ACTIONS(3069),
    [sym_typeof] = ACTIONS(3069),
    [sym_union] = ACTIONS(3069),
    [sym_unittest] = ACTIONS(3069),
    [sym_version] = ACTIONS(3069),
    [sym_while] = ACTIONS(3069),
    [sym_with] = ACTIONS(3069),
    [sym_parameters_] = ACTIONS(3069),
    [sym_gshared] = ACTIONS(3069),
    [sym_traits] = ACTIONS(3069),
    [sym_vector] = ACTIONS(3069),
    [sym_void] = ACTIONS(3069),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_r_DQUOTE] = ACTIONS(3071),
    [anon_sym_x_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3071),
    [anon_sym_i_BQUOTE] = ACTIONS(3071),
    [anon_sym_i_DQUOTE] = ACTIONS(3071),
    [anon_sym_iq_LBRACE] = ACTIONS(3071),
    [aux_sym_char_literal_token1] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym___DATE__] = ACTIONS(3069),
    [anon_sym___FILE__] = ACTIONS(3069),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3069),
    [anon_sym___FUNCTION__] = ACTIONS(3069),
    [anon_sym___LINE__] = ACTIONS(3069),
    [anon_sym___MODULE__] = ACTIONS(3069),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3069),
    [anon_sym___TIME__] = ACTIONS(3069),
    [anon_sym___TIMESTAMP__] = ACTIONS(3069),
    [anon_sym___VENDOR__] = ACTIONS(3069),
    [anon_sym___VERSION__] = ACTIONS(3069),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3071),
    [sym_float_literal] = ACTIONS(3071),
    [sym__string] = ACTIONS(3071),
  },
  [620] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_q_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_CARET_CARET] = ACTIONS(3073),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_TILDE_EQ] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_EQ_GT] = ACTIONS(3075),
    [anon_sym_POUND] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_null] = ACTIONS(3073),
    [sym_super] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_asm] = ACTIONS(3073),
    [sym_assert] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_break] = ACTIONS(3073),
    [sym_case] = ACTIONS(3073),
    [sym_cast] = ACTIONS(3073),
    [sym_catch] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_continue] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_default] = ACTIONS(3073),
    [sym_delegate] = ACTIONS(3073),
    [sym_delete] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_do] = ACTIONS(3073),
    [sym_else] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_finally] = ACTIONS(3073),
    [sym_for] = ACTIONS(3073),
    [sym_foreach] = ACTIONS(3073),
    [sym_foreach_reverse] = ACTIONS(3073),
    [sym_function] = ACTIONS(3073),
    [sym_goto] = ACTIONS(3073),
    [sym_if] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_in] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_is] = ACTIONS(3073),
    [sym_lazy] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_module] = ACTIONS(3073),
    [sym_new] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_out] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(3073),
    [sym_struct] = ACTIONS(3073),
    [sym_switch] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_throw] = ACTIONS(3073),
    [sym_try] = ACTIONS(3073),
    [sym_typeid] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_while] = ACTIONS(3073),
    [sym_with] = ACTIONS(3073),
    [sym_parameters_] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [anon_sym_BQUOTE] = ACTIONS(3075),
    [anon_sym_r_DQUOTE] = ACTIONS(3075),
    [anon_sym_x_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3075),
    [anon_sym_i_BQUOTE] = ACTIONS(3075),
    [anon_sym_i_DQUOTE] = ACTIONS(3075),
    [anon_sym_iq_LBRACE] = ACTIONS(3075),
    [aux_sym_char_literal_token1] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym___DATE__] = ACTIONS(3073),
    [anon_sym___FILE__] = ACTIONS(3073),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3073),
    [anon_sym___FUNCTION__] = ACTIONS(3073),
    [anon_sym___LINE__] = ACTIONS(3073),
    [anon_sym___MODULE__] = ACTIONS(3073),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3073),
    [anon_sym___TIME__] = ACTIONS(3073),
    [anon_sym___TIMESTAMP__] = ACTIONS(3073),
    [anon_sym___VENDOR__] = ACTIONS(3073),
    [anon_sym___VERSION__] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3075),
    [sym_float_literal] = ACTIONS(3075),
    [sym__string] = ACTIONS(3075),
  },
  [621] = {
    [sym_identifier] = ACTIONS(3077),
    [anon_sym_q_LBRACE] = ACTIONS(3079),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_SLASH] = ACTIONS(3077),
    [anon_sym_SLASH_EQ] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_AMP_EQ] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_PIPE] = ACTIONS(3077),
    [anon_sym_PIPE_EQ] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_DASH_EQ] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3077),
    [anon_sym_PLUS_EQ] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_LT_EQ] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3077),
    [anon_sym_LT_LT_EQ] = ACTIONS(3079),
    [anon_sym_GT] = ACTIONS(3077),
    [anon_sym_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT] = ACTIONS(3077),
    [anon_sym_GT_GT_GT] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_RBRACK] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_DOLLAR] = ACTIONS(3077),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_EQ_EQ] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_STAR_EQ] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3077),
    [anon_sym_PERCENT_EQ] = ACTIONS(3079),
    [anon_sym_CARET] = ACTIONS(3077),
    [anon_sym_CARET_EQ] = ACTIONS(3079),
    [anon_sym_CARET_CARET] = ACTIONS(3077),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_TILDE_EQ] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3079),
    [anon_sym_EQ_GT] = ACTIONS(3079),
    [anon_sym_POUND] = ACTIONS(3079),
    [sym_bool] = ACTIONS(3077),
    [sym_byte] = ACTIONS(3077),
    [sym_ubyte] = ACTIONS(3077),
    [sym_char] = ACTIONS(3077),
    [sym_short] = ACTIONS(3077),
    [sym_ushort] = ACTIONS(3077),
    [sym_int] = ACTIONS(3077),
    [sym_uint] = ACTIONS(3077),
    [sym_long] = ACTIONS(3077),
    [sym_ulong] = ACTIONS(3077),
    [sym_cent] = ACTIONS(3077),
    [sym_ucent] = ACTIONS(3077),
    [sym_wchar] = ACTIONS(3077),
    [sym_dchar] = ACTIONS(3077),
    [sym_float] = ACTIONS(3077),
    [sym_double] = ACTIONS(3077),
    [sym_real] = ACTIONS(3077),
    [sym_ifloat] = ACTIONS(3077),
    [sym_idouble] = ACTIONS(3077),
    [sym_ireal] = ACTIONS(3077),
    [sym_cfloat] = ACTIONS(3077),
    [sym_cdouble] = ACTIONS(3077),
    [sym_creal] = ACTIONS(3077),
    [sym_size_t] = ACTIONS(3077),
    [sym_ptrdiff_t] = ACTIONS(3077),
    [sym_string] = ACTIONS(3077),
    [sym_cstring] = ACTIONS(3077),
    [sym_dstring] = ACTIONS(3077),
    [sym_wstring] = ACTIONS(3077),
    [sym_noreturn] = ACTIONS(3077),
    [sym_true] = ACTIONS(3077),
    [sym_false] = ACTIONS(3077),
    [sym_null] = ACTIONS(3077),
    [sym_super] = ACTIONS(3077),
    [sym_this] = ACTIONS(3077),
    [sym_abstract] = ACTIONS(3077),
    [sym_alias] = ACTIONS(3077),
    [sym_align] = ACTIONS(3077),
    [sym_asm] = ACTIONS(3077),
    [sym_assert] = ACTIONS(3077),
    [sym_auto] = ACTIONS(3077),
    [sym_break] = ACTIONS(3077),
    [sym_case] = ACTIONS(3077),
    [sym_cast] = ACTIONS(3077),
    [sym_catch] = ACTIONS(3077),
    [sym_class] = ACTIONS(3077),
    [sym_const] = ACTIONS(3077),
    [sym_continue] = ACTIONS(3077),
    [sym_debug] = ACTIONS(3077),
    [sym_default] = ACTIONS(3077),
    [sym_delegate] = ACTIONS(3077),
    [sym_delete] = ACTIONS(3077),
    [sym_deprecated] = ACTIONS(3077),
    [sym_do] = ACTIONS(3077),
    [sym_else] = ACTIONS(3077),
    [sym_enum] = ACTIONS(3077),
    [sym_export] = ACTIONS(3077),
    [sym_extern] = ACTIONS(3077),
    [sym_final] = ACTIONS(3077),
    [sym_finally] = ACTIONS(3077),
    [sym_for] = ACTIONS(3077),
    [sym_foreach] = ACTIONS(3077),
    [sym_foreach_reverse] = ACTIONS(3077),
    [sym_function] = ACTIONS(3077),
    [sym_goto] = ACTIONS(3077),
    [sym_if] = ACTIONS(3077),
    [sym_immutable] = ACTIONS(3077),
    [sym_import] = ACTIONS(3077),
    [sym_in] = ACTIONS(3077),
    [sym_inout] = ACTIONS(3077),
    [sym_interface] = ACTIONS(3077),
    [sym_invariant] = ACTIONS(3077),
    [sym_is] = ACTIONS(3077),
    [sym_lazy] = ACTIONS(3077),
    [sym_mixin] = ACTIONS(3077),
    [sym_module] = ACTIONS(3077),
    [sym_new] = ACTIONS(3077),
    [sym_nothrow] = ACTIONS(3077),
    [sym_out] = ACTIONS(3077),
    [sym_override] = ACTIONS(3077),
    [sym_package] = ACTIONS(3077),
    [sym_pragma] = ACTIONS(3077),
    [sym_private] = ACTIONS(3077),
    [sym_protected] = ACTIONS(3077),
    [sym_public] = ACTIONS(3077),
    [sym_pure] = ACTIONS(3077),
    [sym_ref] = ACTIONS(3077),
    [sym_return] = ACTIONS(3077),
    [sym_scope] = ACTIONS(3077),
    [sym_shared] = ACTIONS(3077),
    [sym_static] = ACTIONS(3077),
    [sym_struct] = ACTIONS(3077),
    [sym_switch] = ACTIONS(3077),
    [sym_synchronized] = ACTIONS(3077),
    [sym_template] = ACTIONS(3077),
    [sym_throw] = ACTIONS(3077),
    [sym_try] = ACTIONS(3077),
    [sym_typeid] = ACTIONS(3077),
    [sym_typeof] = ACTIONS(3077),
    [sym_union] = ACTIONS(3077),
    [sym_unittest] = ACTIONS(3077),
    [sym_version] = ACTIONS(3077),
    [sym_while] = ACTIONS(3077),
    [sym_with] = ACTIONS(3077),
    [sym_parameters_] = ACTIONS(3077),
    [sym_gshared] = ACTIONS(3077),
    [sym_traits] = ACTIONS(3077),
    [sym_vector] = ACTIONS(3077),
    [sym_void] = ACTIONS(3077),
    [anon_sym_BQUOTE] = ACTIONS(3079),
    [anon_sym_r_DQUOTE] = ACTIONS(3079),
    [anon_sym_x_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3079),
    [anon_sym_i_BQUOTE] = ACTIONS(3079),
    [anon_sym_i_DQUOTE] = ACTIONS(3079),
    [anon_sym_iq_LBRACE] = ACTIONS(3079),
    [aux_sym_char_literal_token1] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym___DATE__] = ACTIONS(3077),
    [anon_sym___FILE__] = ACTIONS(3077),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3077),
    [anon_sym___FUNCTION__] = ACTIONS(3077),
    [anon_sym___LINE__] = ACTIONS(3077),
    [anon_sym___MODULE__] = ACTIONS(3077),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3077),
    [anon_sym___TIME__] = ACTIONS(3077),
    [anon_sym___TIMESTAMP__] = ACTIONS(3077),
    [anon_sym___VENDOR__] = ACTIONS(3077),
    [anon_sym___VERSION__] = ACTIONS(3077),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3079),
    [sym_float_literal] = ACTIONS(3079),
    [sym__string] = ACTIONS(3079),
  },
  [622] = {
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_q_LBRACE] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_SLASH] = ACTIONS(3081),
    [anon_sym_SLASH_EQ] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3081),
    [anon_sym_AMP_EQ] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_PIPE] = ACTIONS(3081),
    [anon_sym_PIPE_EQ] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3081),
    [anon_sym_DASH_EQ] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_PLUS_EQ] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_LT_EQ] = ACTIONS(3083),
    [anon_sym_LT_LT] = ACTIONS(3081),
    [anon_sym_LT_LT_EQ] = ACTIONS(3083),
    [anon_sym_GT] = ACTIONS(3081),
    [anon_sym_GT_EQ] = ACTIONS(3083),
    [anon_sym_GT_GT_EQ] = ACTIONS(3083),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3083),
    [anon_sym_GT_GT] = ACTIONS(3081),
    [anon_sym_GT_GT_GT] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_RBRACK] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(3081),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_EQ_EQ] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_STAR_EQ] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3081),
    [anon_sym_PERCENT_EQ] = ACTIONS(3083),
    [anon_sym_CARET] = ACTIONS(3081),
    [anon_sym_CARET_EQ] = ACTIONS(3083),
    [anon_sym_CARET_CARET] = ACTIONS(3081),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_TILDE_EQ] = ACTIONS(3083),
    [anon_sym_AT] = ACTIONS(3083),
    [anon_sym_EQ_GT] = ACTIONS(3083),
    [anon_sym_POUND] = ACTIONS(3083),
    [sym_bool] = ACTIONS(3081),
    [sym_byte] = ACTIONS(3081),
    [sym_ubyte] = ACTIONS(3081),
    [sym_char] = ACTIONS(3081),
    [sym_short] = ACTIONS(3081),
    [sym_ushort] = ACTIONS(3081),
    [sym_int] = ACTIONS(3081),
    [sym_uint] = ACTIONS(3081),
    [sym_long] = ACTIONS(3081),
    [sym_ulong] = ACTIONS(3081),
    [sym_cent] = ACTIONS(3081),
    [sym_ucent] = ACTIONS(3081),
    [sym_wchar] = ACTIONS(3081),
    [sym_dchar] = ACTIONS(3081),
    [sym_float] = ACTIONS(3081),
    [sym_double] = ACTIONS(3081),
    [sym_real] = ACTIONS(3081),
    [sym_ifloat] = ACTIONS(3081),
    [sym_idouble] = ACTIONS(3081),
    [sym_ireal] = ACTIONS(3081),
    [sym_cfloat] = ACTIONS(3081),
    [sym_cdouble] = ACTIONS(3081),
    [sym_creal] = ACTIONS(3081),
    [sym_size_t] = ACTIONS(3081),
    [sym_ptrdiff_t] = ACTIONS(3081),
    [sym_string] = ACTIONS(3081),
    [sym_cstring] = ACTIONS(3081),
    [sym_dstring] = ACTIONS(3081),
    [sym_wstring] = ACTIONS(3081),
    [sym_noreturn] = ACTIONS(3081),
    [sym_true] = ACTIONS(3081),
    [sym_false] = ACTIONS(3081),
    [sym_null] = ACTIONS(3081),
    [sym_super] = ACTIONS(3081),
    [sym_this] = ACTIONS(3081),
    [sym_abstract] = ACTIONS(3081),
    [sym_alias] = ACTIONS(3081),
    [sym_align] = ACTIONS(3081),
    [sym_asm] = ACTIONS(3081),
    [sym_assert] = ACTIONS(3081),
    [sym_auto] = ACTIONS(3081),
    [sym_break] = ACTIONS(3081),
    [sym_case] = ACTIONS(3081),
    [sym_cast] = ACTIONS(3081),
    [sym_catch] = ACTIONS(3081),
    [sym_class] = ACTIONS(3081),
    [sym_const] = ACTIONS(3081),
    [sym_continue] = ACTIONS(3081),
    [sym_debug] = ACTIONS(3081),
    [sym_default] = ACTIONS(3081),
    [sym_delegate] = ACTIONS(3081),
    [sym_delete] = ACTIONS(3081),
    [sym_deprecated] = ACTIONS(3081),
    [sym_do] = ACTIONS(3081),
    [sym_else] = ACTIONS(3081),
    [sym_enum] = ACTIONS(3081),
    [sym_export] = ACTIONS(3081),
    [sym_extern] = ACTIONS(3081),
    [sym_final] = ACTIONS(3081),
    [sym_finally] = ACTIONS(3081),
    [sym_for] = ACTIONS(3081),
    [sym_foreach] = ACTIONS(3081),
    [sym_foreach_reverse] = ACTIONS(3081),
    [sym_function] = ACTIONS(3081),
    [sym_goto] = ACTIONS(3081),
    [sym_if] = ACTIONS(3081),
    [sym_immutable] = ACTIONS(3081),
    [sym_import] = ACTIONS(3081),
    [sym_in] = ACTIONS(3081),
    [sym_inout] = ACTIONS(3081),
    [sym_interface] = ACTIONS(3081),
    [sym_invariant] = ACTIONS(3081),
    [sym_is] = ACTIONS(3081),
    [sym_lazy] = ACTIONS(3081),
    [sym_mixin] = ACTIONS(3081),
    [sym_module] = ACTIONS(3081),
    [sym_new] = ACTIONS(3081),
    [sym_nothrow] = ACTIONS(3081),
    [sym_out] = ACTIONS(3081),
    [sym_override] = ACTIONS(3081),
    [sym_package] = ACTIONS(3081),
    [sym_pragma] = ACTIONS(3081),
    [sym_private] = ACTIONS(3081),
    [sym_protected] = ACTIONS(3081),
    [sym_public] = ACTIONS(3081),
    [sym_pure] = ACTIONS(3081),
    [sym_ref] = ACTIONS(3081),
    [sym_return] = ACTIONS(3081),
    [sym_scope] = ACTIONS(3081),
    [sym_shared] = ACTIONS(3081),
    [sym_static] = ACTIONS(3081),
    [sym_struct] = ACTIONS(3081),
    [sym_switch] = ACTIONS(3081),
    [sym_synchronized] = ACTIONS(3081),
    [sym_template] = ACTIONS(3081),
    [sym_throw] = ACTIONS(3081),
    [sym_try] = ACTIONS(3081),
    [sym_typeid] = ACTIONS(3081),
    [sym_typeof] = ACTIONS(3081),
    [sym_union] = ACTIONS(3081),
    [sym_unittest] = ACTIONS(3081),
    [sym_version] = ACTIONS(3081),
    [sym_while] = ACTIONS(3081),
    [sym_with] = ACTIONS(3081),
    [sym_parameters_] = ACTIONS(3081),
    [sym_gshared] = ACTIONS(3081),
    [sym_traits] = ACTIONS(3081),
    [sym_vector] = ACTIONS(3081),
    [sym_void] = ACTIONS(3081),
    [anon_sym_BQUOTE] = ACTIONS(3083),
    [anon_sym_r_DQUOTE] = ACTIONS(3083),
    [anon_sym_x_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3083),
    [anon_sym_i_BQUOTE] = ACTIONS(3083),
    [anon_sym_i_DQUOTE] = ACTIONS(3083),
    [anon_sym_iq_LBRACE] = ACTIONS(3083),
    [aux_sym_char_literal_token1] = ACTIONS(3083),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym___DATE__] = ACTIONS(3081),
    [anon_sym___FILE__] = ACTIONS(3081),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3081),
    [anon_sym___FUNCTION__] = ACTIONS(3081),
    [anon_sym___LINE__] = ACTIONS(3081),
    [anon_sym___MODULE__] = ACTIONS(3081),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3081),
    [anon_sym___TIME__] = ACTIONS(3081),
    [anon_sym___TIMESTAMP__] = ACTIONS(3081),
    [anon_sym___VENDOR__] = ACTIONS(3081),
    [anon_sym___VERSION__] = ACTIONS(3081),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3083),
    [sym_float_literal] = ACTIONS(3083),
    [sym__string] = ACTIONS(3083),
  },
  [623] = {
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_q_LBRACE] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_GT_GT_GT] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_DOLLAR] = ACTIONS(3085),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_CARET_CARET] = ACTIONS(3085),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_TILDE_EQ] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3087),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_POUND] = ACTIONS(3087),
    [sym_bool] = ACTIONS(3085),
    [sym_byte] = ACTIONS(3085),
    [sym_ubyte] = ACTIONS(3085),
    [sym_char] = ACTIONS(3085),
    [sym_short] = ACTIONS(3085),
    [sym_ushort] = ACTIONS(3085),
    [sym_int] = ACTIONS(3085),
    [sym_uint] = ACTIONS(3085),
    [sym_long] = ACTIONS(3085),
    [sym_ulong] = ACTIONS(3085),
    [sym_cent] = ACTIONS(3085),
    [sym_ucent] = ACTIONS(3085),
    [sym_wchar] = ACTIONS(3085),
    [sym_dchar] = ACTIONS(3085),
    [sym_float] = ACTIONS(3085),
    [sym_double] = ACTIONS(3085),
    [sym_real] = ACTIONS(3085),
    [sym_ifloat] = ACTIONS(3085),
    [sym_idouble] = ACTIONS(3085),
    [sym_ireal] = ACTIONS(3085),
    [sym_cfloat] = ACTIONS(3085),
    [sym_cdouble] = ACTIONS(3085),
    [sym_creal] = ACTIONS(3085),
    [sym_size_t] = ACTIONS(3085),
    [sym_ptrdiff_t] = ACTIONS(3085),
    [sym_string] = ACTIONS(3085),
    [sym_cstring] = ACTIONS(3085),
    [sym_dstring] = ACTIONS(3085),
    [sym_wstring] = ACTIONS(3085),
    [sym_noreturn] = ACTIONS(3085),
    [sym_true] = ACTIONS(3085),
    [sym_false] = ACTIONS(3085),
    [sym_null] = ACTIONS(3085),
    [sym_super] = ACTIONS(3085),
    [sym_this] = ACTIONS(3085),
    [sym_abstract] = ACTIONS(3085),
    [sym_alias] = ACTIONS(3085),
    [sym_align] = ACTIONS(3085),
    [sym_asm] = ACTIONS(3085),
    [sym_assert] = ACTIONS(3085),
    [sym_auto] = ACTIONS(3085),
    [sym_break] = ACTIONS(3085),
    [sym_case] = ACTIONS(3085),
    [sym_cast] = ACTIONS(3085),
    [sym_catch] = ACTIONS(3085),
    [sym_class] = ACTIONS(3085),
    [sym_const] = ACTIONS(3085),
    [sym_continue] = ACTIONS(3085),
    [sym_debug] = ACTIONS(3085),
    [sym_default] = ACTIONS(3085),
    [sym_delegate] = ACTIONS(3085),
    [sym_delete] = ACTIONS(3085),
    [sym_deprecated] = ACTIONS(3085),
    [sym_do] = ACTIONS(3085),
    [sym_else] = ACTIONS(3085),
    [sym_enum] = ACTIONS(3085),
    [sym_export] = ACTIONS(3085),
    [sym_extern] = ACTIONS(3085),
    [sym_final] = ACTIONS(3085),
    [sym_finally] = ACTIONS(3085),
    [sym_for] = ACTIONS(3085),
    [sym_foreach] = ACTIONS(3085),
    [sym_foreach_reverse] = ACTIONS(3085),
    [sym_function] = ACTIONS(3085),
    [sym_goto] = ACTIONS(3085),
    [sym_if] = ACTIONS(3085),
    [sym_immutable] = ACTIONS(3085),
    [sym_import] = ACTIONS(3085),
    [sym_in] = ACTIONS(3085),
    [sym_inout] = ACTIONS(3085),
    [sym_interface] = ACTIONS(3085),
    [sym_invariant] = ACTIONS(3085),
    [sym_is] = ACTIONS(3085),
    [sym_lazy] = ACTIONS(3085),
    [sym_mixin] = ACTIONS(3085),
    [sym_module] = ACTIONS(3085),
    [sym_new] = ACTIONS(3085),
    [sym_nothrow] = ACTIONS(3085),
    [sym_out] = ACTIONS(3085),
    [sym_override] = ACTIONS(3085),
    [sym_package] = ACTIONS(3085),
    [sym_pragma] = ACTIONS(3085),
    [sym_private] = ACTIONS(3085),
    [sym_protected] = ACTIONS(3085),
    [sym_public] = ACTIONS(3085),
    [sym_pure] = ACTIONS(3085),
    [sym_ref] = ACTIONS(3085),
    [sym_return] = ACTIONS(3085),
    [sym_scope] = ACTIONS(3085),
    [sym_shared] = ACTIONS(3085),
    [sym_static] = ACTIONS(3085),
    [sym_struct] = ACTIONS(3085),
    [sym_switch] = ACTIONS(3085),
    [sym_synchronized] = ACTIONS(3085),
    [sym_template] = ACTIONS(3085),
    [sym_throw] = ACTIONS(3085),
    [sym_try] = ACTIONS(3085),
    [sym_typeid] = ACTIONS(3085),
    [sym_typeof] = ACTIONS(3085),
    [sym_union] = ACTIONS(3085),
    [sym_unittest] = ACTIONS(3085),
    [sym_version] = ACTIONS(3085),
    [sym_while] = ACTIONS(3085),
    [sym_with] = ACTIONS(3085),
    [sym_parameters_] = ACTIONS(3085),
    [sym_gshared] = ACTIONS(3085),
    [sym_traits] = ACTIONS(3085),
    [sym_vector] = ACTIONS(3085),
    [sym_void] = ACTIONS(3085),
    [anon_sym_BQUOTE] = ACTIONS(3087),
    [anon_sym_r_DQUOTE] = ACTIONS(3087),
    [anon_sym_x_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3087),
    [anon_sym_i_BQUOTE] = ACTIONS(3087),
    [anon_sym_i_DQUOTE] = ACTIONS(3087),
    [anon_sym_iq_LBRACE] = ACTIONS(3087),
    [aux_sym_char_literal_token1] = ACTIONS(3087),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym___DATE__] = ACTIONS(3085),
    [anon_sym___FILE__] = ACTIONS(3085),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3085),
    [anon_sym___FUNCTION__] = ACTIONS(3085),
    [anon_sym___LINE__] = ACTIONS(3085),
    [anon_sym___MODULE__] = ACTIONS(3085),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3085),
    [anon_sym___TIME__] = ACTIONS(3085),
    [anon_sym___TIMESTAMP__] = ACTIONS(3085),
    [anon_sym___VENDOR__] = ACTIONS(3085),
    [anon_sym___VERSION__] = ACTIONS(3085),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3087),
    [sym_float_literal] = ACTIONS(3087),
    [sym__string] = ACTIONS(3087),
  },
  [624] = {
    [sym_identifier] = ACTIONS(3089),
    [anon_sym_q_LBRACE] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_SLASH] = ACTIONS(3089),
    [anon_sym_SLASH_EQ] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_AMP_EQ] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE] = ACTIONS(3089),
    [anon_sym_PIPE_EQ] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_DASH_EQ] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_PLUS_EQ] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_LT_EQ] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3089),
    [anon_sym_LT_LT_EQ] = ACTIONS(3091),
    [anon_sym_GT] = ACTIONS(3089),
    [anon_sym_GT_EQ] = ACTIONS(3091),
    [anon_sym_GT_GT_EQ] = ACTIONS(3091),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3091),
    [anon_sym_GT_GT] = ACTIONS(3089),
    [anon_sym_GT_GT_GT] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_RBRACK] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3089),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_EQ_EQ] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_STAR_EQ] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3089),
    [anon_sym_PERCENT_EQ] = ACTIONS(3091),
    [anon_sym_CARET] = ACTIONS(3089),
    [anon_sym_CARET_EQ] = ACTIONS(3091),
    [anon_sym_CARET_CARET] = ACTIONS(3089),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_TILDE_EQ] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(3091),
    [anon_sym_POUND] = ACTIONS(3091),
    [sym_bool] = ACTIONS(3089),
    [sym_byte] = ACTIONS(3089),
    [sym_ubyte] = ACTIONS(3089),
    [sym_char] = ACTIONS(3089),
    [sym_short] = ACTIONS(3089),
    [sym_ushort] = ACTIONS(3089),
    [sym_int] = ACTIONS(3089),
    [sym_uint] = ACTIONS(3089),
    [sym_long] = ACTIONS(3089),
    [sym_ulong] = ACTIONS(3089),
    [sym_cent] = ACTIONS(3089),
    [sym_ucent] = ACTIONS(3089),
    [sym_wchar] = ACTIONS(3089),
    [sym_dchar] = ACTIONS(3089),
    [sym_float] = ACTIONS(3089),
    [sym_double] = ACTIONS(3089),
    [sym_real] = ACTIONS(3089),
    [sym_ifloat] = ACTIONS(3089),
    [sym_idouble] = ACTIONS(3089),
    [sym_ireal] = ACTIONS(3089),
    [sym_cfloat] = ACTIONS(3089),
    [sym_cdouble] = ACTIONS(3089),
    [sym_creal] = ACTIONS(3089),
    [sym_size_t] = ACTIONS(3089),
    [sym_ptrdiff_t] = ACTIONS(3089),
    [sym_string] = ACTIONS(3089),
    [sym_cstring] = ACTIONS(3089),
    [sym_dstring] = ACTIONS(3089),
    [sym_wstring] = ACTIONS(3089),
    [sym_noreturn] = ACTIONS(3089),
    [sym_true] = ACTIONS(3089),
    [sym_false] = ACTIONS(3089),
    [sym_null] = ACTIONS(3089),
    [sym_super] = ACTIONS(3089),
    [sym_this] = ACTIONS(3089),
    [sym_abstract] = ACTIONS(3089),
    [sym_alias] = ACTIONS(3089),
    [sym_align] = ACTIONS(3089),
    [sym_asm] = ACTIONS(3089),
    [sym_assert] = ACTIONS(3089),
    [sym_auto] = ACTIONS(3089),
    [sym_break] = ACTIONS(3089),
    [sym_case] = ACTIONS(3089),
    [sym_cast] = ACTIONS(3089),
    [sym_catch] = ACTIONS(3089),
    [sym_class] = ACTIONS(3089),
    [sym_const] = ACTIONS(3089),
    [sym_continue] = ACTIONS(3089),
    [sym_debug] = ACTIONS(3089),
    [sym_default] = ACTIONS(3089),
    [sym_delegate] = ACTIONS(3089),
    [sym_delete] = ACTIONS(3089),
    [sym_deprecated] = ACTIONS(3089),
    [sym_do] = ACTIONS(3089),
    [sym_else] = ACTIONS(3089),
    [sym_enum] = ACTIONS(3089),
    [sym_export] = ACTIONS(3089),
    [sym_extern] = ACTIONS(3089),
    [sym_final] = ACTIONS(3089),
    [sym_finally] = ACTIONS(3089),
    [sym_for] = ACTIONS(3089),
    [sym_foreach] = ACTIONS(3089),
    [sym_foreach_reverse] = ACTIONS(3089),
    [sym_function] = ACTIONS(3089),
    [sym_goto] = ACTIONS(3089),
    [sym_if] = ACTIONS(3089),
    [sym_immutable] = ACTIONS(3089),
    [sym_import] = ACTIONS(3089),
    [sym_in] = ACTIONS(3089),
    [sym_inout] = ACTIONS(3089),
    [sym_interface] = ACTIONS(3089),
    [sym_invariant] = ACTIONS(3089),
    [sym_is] = ACTIONS(3089),
    [sym_lazy] = ACTIONS(3089),
    [sym_mixin] = ACTIONS(3089),
    [sym_module] = ACTIONS(3089),
    [sym_new] = ACTIONS(3089),
    [sym_nothrow] = ACTIONS(3089),
    [sym_out] = ACTIONS(3089),
    [sym_override] = ACTIONS(3089),
    [sym_package] = ACTIONS(3089),
    [sym_pragma] = ACTIONS(3089),
    [sym_private] = ACTIONS(3089),
    [sym_protected] = ACTIONS(3089),
    [sym_public] = ACTIONS(3089),
    [sym_pure] = ACTIONS(3089),
    [sym_ref] = ACTIONS(3089),
    [sym_return] = ACTIONS(3089),
    [sym_scope] = ACTIONS(3089),
    [sym_shared] = ACTIONS(3089),
    [sym_static] = ACTIONS(3089),
    [sym_struct] = ACTIONS(3089),
    [sym_switch] = ACTIONS(3089),
    [sym_synchronized] = ACTIONS(3089),
    [sym_template] = ACTIONS(3089),
    [sym_throw] = ACTIONS(3089),
    [sym_try] = ACTIONS(3089),
    [sym_typeid] = ACTIONS(3089),
    [sym_typeof] = ACTIONS(3089),
    [sym_union] = ACTIONS(3089),
    [sym_unittest] = ACTIONS(3089),
    [sym_version] = ACTIONS(3089),
    [sym_while] = ACTIONS(3089),
    [sym_with] = ACTIONS(3089),
    [sym_parameters_] = ACTIONS(3089),
    [sym_gshared] = ACTIONS(3089),
    [sym_traits] = ACTIONS(3089),
    [sym_vector] = ACTIONS(3089),
    [sym_void] = ACTIONS(3089),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_r_DQUOTE] = ACTIONS(3091),
    [anon_sym_x_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3091),
    [anon_sym_i_BQUOTE] = ACTIONS(3091),
    [anon_sym_i_DQUOTE] = ACTIONS(3091),
    [anon_sym_iq_LBRACE] = ACTIONS(3091),
    [aux_sym_char_literal_token1] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym___DATE__] = ACTIONS(3089),
    [anon_sym___FILE__] = ACTIONS(3089),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3089),
    [anon_sym___FUNCTION__] = ACTIONS(3089),
    [anon_sym___LINE__] = ACTIONS(3089),
    [anon_sym___MODULE__] = ACTIONS(3089),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3089),
    [anon_sym___TIME__] = ACTIONS(3089),
    [anon_sym___TIMESTAMP__] = ACTIONS(3089),
    [anon_sym___VENDOR__] = ACTIONS(3089),
    [anon_sym___VERSION__] = ACTIONS(3089),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3091),
    [sym_float_literal] = ACTIONS(3091),
    [sym__string] = ACTIONS(3091),
  },
  [625] = {
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_q_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3093),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_LT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3093),
    [anon_sym_GT_GT_GT] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_DOLLAR] = ACTIONS(3093),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_EQ_EQ] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3093),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_CARET_CARET] = ACTIONS(3093),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_TILDE_EQ] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_POUND] = ACTIONS(3095),
    [sym_bool] = ACTIONS(3093),
    [sym_byte] = ACTIONS(3093),
    [sym_ubyte] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_short] = ACTIONS(3093),
    [sym_ushort] = ACTIONS(3093),
    [sym_int] = ACTIONS(3093),
    [sym_uint] = ACTIONS(3093),
    [sym_long] = ACTIONS(3093),
    [sym_ulong] = ACTIONS(3093),
    [sym_cent] = ACTIONS(3093),
    [sym_ucent] = ACTIONS(3093),
    [sym_wchar] = ACTIONS(3093),
    [sym_dchar] = ACTIONS(3093),
    [sym_float] = ACTIONS(3093),
    [sym_double] = ACTIONS(3093),
    [sym_real] = ACTIONS(3093),
    [sym_ifloat] = ACTIONS(3093),
    [sym_idouble] = ACTIONS(3093),
    [sym_ireal] = ACTIONS(3093),
    [sym_cfloat] = ACTIONS(3093),
    [sym_cdouble] = ACTIONS(3093),
    [sym_creal] = ACTIONS(3093),
    [sym_size_t] = ACTIONS(3093),
    [sym_ptrdiff_t] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym_cstring] = ACTIONS(3093),
    [sym_dstring] = ACTIONS(3093),
    [sym_wstring] = ACTIONS(3093),
    [sym_noreturn] = ACTIONS(3093),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [sym_null] = ACTIONS(3093),
    [sym_super] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
    [sym_abstract] = ACTIONS(3093),
    [sym_alias] = ACTIONS(3093),
    [sym_align] = ACTIONS(3093),
    [sym_asm] = ACTIONS(3093),
    [sym_assert] = ACTIONS(3093),
    [sym_auto] = ACTIONS(3093),
    [sym_break] = ACTIONS(3093),
    [sym_case] = ACTIONS(3093),
    [sym_cast] = ACTIONS(3093),
    [sym_catch] = ACTIONS(3093),
    [sym_class] = ACTIONS(3093),
    [sym_const] = ACTIONS(3093),
    [sym_continue] = ACTIONS(3093),
    [sym_debug] = ACTIONS(3093),
    [sym_default] = ACTIONS(3093),
    [sym_delegate] = ACTIONS(3093),
    [sym_delete] = ACTIONS(3093),
    [sym_deprecated] = ACTIONS(3093),
    [sym_do] = ACTIONS(3093),
    [sym_else] = ACTIONS(3093),
    [sym_enum] = ACTIONS(3093),
    [sym_export] = ACTIONS(3093),
    [sym_extern] = ACTIONS(3093),
    [sym_final] = ACTIONS(3093),
    [sym_finally] = ACTIONS(3093),
    [sym_for] = ACTIONS(3093),
    [sym_foreach] = ACTIONS(3093),
    [sym_foreach_reverse] = ACTIONS(3093),
    [sym_function] = ACTIONS(3093),
    [sym_goto] = ACTIONS(3093),
    [sym_if] = ACTIONS(3093),
    [sym_immutable] = ACTIONS(3093),
    [sym_import] = ACTIONS(3093),
    [sym_in] = ACTIONS(3093),
    [sym_inout] = ACTIONS(3093),
    [sym_interface] = ACTIONS(3093),
    [sym_invariant] = ACTIONS(3093),
    [sym_is] = ACTIONS(3093),
    [sym_lazy] = ACTIONS(3093),
    [sym_mixin] = ACTIONS(3093),
    [sym_module] = ACTIONS(3093),
    [sym_new] = ACTIONS(3093),
    [sym_nothrow] = ACTIONS(3093),
    [sym_out] = ACTIONS(3093),
    [sym_override] = ACTIONS(3093),
    [sym_package] = ACTIONS(3093),
    [sym_pragma] = ACTIONS(3093),
    [sym_private] = ACTIONS(3093),
    [sym_protected] = ACTIONS(3093),
    [sym_public] = ACTIONS(3093),
    [sym_pure] = ACTIONS(3093),
    [sym_ref] = ACTIONS(3093),
    [sym_return] = ACTIONS(3093),
    [sym_scope] = ACTIONS(3093),
    [sym_shared] = ACTIONS(3093),
    [sym_static] = ACTIONS(3093),
    [sym_struct] = ACTIONS(3093),
    [sym_switch] = ACTIONS(3093),
    [sym_synchronized] = ACTIONS(3093),
    [sym_template] = ACTIONS(3093),
    [sym_throw] = ACTIONS(3093),
    [sym_try] = ACTIONS(3093),
    [sym_typeid] = ACTIONS(3093),
    [sym_typeof] = ACTIONS(3093),
    [sym_union] = ACTIONS(3093),
    [sym_unittest] = ACTIONS(3093),
    [sym_version] = ACTIONS(3093),
    [sym_while] = ACTIONS(3093),
    [sym_with] = ACTIONS(3093),
    [sym_parameters_] = ACTIONS(3093),
    [sym_gshared] = ACTIONS(3093),
    [sym_traits] = ACTIONS(3093),
    [sym_vector] = ACTIONS(3093),
    [sym_void] = ACTIONS(3093),
    [anon_sym_BQUOTE] = ACTIONS(3095),
    [anon_sym_r_DQUOTE] = ACTIONS(3095),
    [anon_sym_x_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3095),
    [anon_sym_i_BQUOTE] = ACTIONS(3095),
    [anon_sym_i_DQUOTE] = ACTIONS(3095),
    [anon_sym_iq_LBRACE] = ACTIONS(3095),
    [aux_sym_char_literal_token1] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [anon_sym___DATE__] = ACTIONS(3093),
    [anon_sym___FILE__] = ACTIONS(3093),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3093),
    [anon_sym___FUNCTION__] = ACTIONS(3093),
    [anon_sym___LINE__] = ACTIONS(3093),
    [anon_sym___MODULE__] = ACTIONS(3093),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3093),
    [anon_sym___TIME__] = ACTIONS(3093),
    [anon_sym___TIMESTAMP__] = ACTIONS(3093),
    [anon_sym___VENDOR__] = ACTIONS(3093),
    [anon_sym___VERSION__] = ACTIONS(3093),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3095),
    [sym_float_literal] = ACTIONS(3095),
    [sym__string] = ACTIONS(3095),
  },
  [626] = {
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_q_LBRACE] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_SLASH_EQ] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_AMP_EQ] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_PIPE_EQ] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_DASH_EQ] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_PLUS_EQ] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_LT_EQ] = ACTIONS(3099),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_LT_LT_EQ] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_GT_GT_GT] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_DOLLAR] = ACTIONS(3097),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_STAR_EQ] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [anon_sym_PERCENT_EQ] = ACTIONS(3099),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_CARET_EQ] = ACTIONS(3099),
    [anon_sym_CARET_CARET] = ACTIONS(3097),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_TILDE_EQ] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3099),
    [anon_sym_EQ_GT] = ACTIONS(3099),
    [anon_sym_POUND] = ACTIONS(3099),
    [sym_bool] = ACTIONS(3097),
    [sym_byte] = ACTIONS(3097),
    [sym_ubyte] = ACTIONS(3097),
    [sym_char] = ACTIONS(3097),
    [sym_short] = ACTIONS(3097),
    [sym_ushort] = ACTIONS(3097),
    [sym_int] = ACTIONS(3097),
    [sym_uint] = ACTIONS(3097),
    [sym_long] = ACTIONS(3097),
    [sym_ulong] = ACTIONS(3097),
    [sym_cent] = ACTIONS(3097),
    [sym_ucent] = ACTIONS(3097),
    [sym_wchar] = ACTIONS(3097),
    [sym_dchar] = ACTIONS(3097),
    [sym_float] = ACTIONS(3097),
    [sym_double] = ACTIONS(3097),
    [sym_real] = ACTIONS(3097),
    [sym_ifloat] = ACTIONS(3097),
    [sym_idouble] = ACTIONS(3097),
    [sym_ireal] = ACTIONS(3097),
    [sym_cfloat] = ACTIONS(3097),
    [sym_cdouble] = ACTIONS(3097),
    [sym_creal] = ACTIONS(3097),
    [sym_size_t] = ACTIONS(3097),
    [sym_ptrdiff_t] = ACTIONS(3097),
    [sym_string] = ACTIONS(3097),
    [sym_cstring] = ACTIONS(3097),
    [sym_dstring] = ACTIONS(3097),
    [sym_wstring] = ACTIONS(3097),
    [sym_noreturn] = ACTIONS(3097),
    [sym_true] = ACTIONS(3097),
    [sym_false] = ACTIONS(3097),
    [sym_null] = ACTIONS(3097),
    [sym_super] = ACTIONS(3097),
    [sym_this] = ACTIONS(3097),
    [sym_abstract] = ACTIONS(3097),
    [sym_alias] = ACTIONS(3097),
    [sym_align] = ACTIONS(3097),
    [sym_asm] = ACTIONS(3097),
    [sym_assert] = ACTIONS(3097),
    [sym_auto] = ACTIONS(3097),
    [sym_break] = ACTIONS(3097),
    [sym_case] = ACTIONS(3097),
    [sym_cast] = ACTIONS(3097),
    [sym_catch] = ACTIONS(3097),
    [sym_class] = ACTIONS(3097),
    [sym_const] = ACTIONS(3097),
    [sym_continue] = ACTIONS(3097),
    [sym_debug] = ACTIONS(3097),
    [sym_default] = ACTIONS(3097),
    [sym_delegate] = ACTIONS(3097),
    [sym_delete] = ACTIONS(3097),
    [sym_deprecated] = ACTIONS(3097),
    [sym_do] = ACTIONS(3097),
    [sym_else] = ACTIONS(3097),
    [sym_enum] = ACTIONS(3097),
    [sym_export] = ACTIONS(3097),
    [sym_extern] = ACTIONS(3097),
    [sym_final] = ACTIONS(3097),
    [sym_finally] = ACTIONS(3097),
    [sym_for] = ACTIONS(3097),
    [sym_foreach] = ACTIONS(3097),
    [sym_foreach_reverse] = ACTIONS(3097),
    [sym_function] = ACTIONS(3097),
    [sym_goto] = ACTIONS(3097),
    [sym_if] = ACTIONS(3097),
    [sym_immutable] = ACTIONS(3097),
    [sym_import] = ACTIONS(3097),
    [sym_in] = ACTIONS(3097),
    [sym_inout] = ACTIONS(3097),
    [sym_interface] = ACTIONS(3097),
    [sym_invariant] = ACTIONS(3097),
    [sym_is] = ACTIONS(3097),
    [sym_lazy] = ACTIONS(3097),
    [sym_mixin] = ACTIONS(3097),
    [sym_module] = ACTIONS(3097),
    [sym_new] = ACTIONS(3097),
    [sym_nothrow] = ACTIONS(3097),
    [sym_out] = ACTIONS(3097),
    [sym_override] = ACTIONS(3097),
    [sym_package] = ACTIONS(3097),
    [sym_pragma] = ACTIONS(3097),
    [sym_private] = ACTIONS(3097),
    [sym_protected] = ACTIONS(3097),
    [sym_public] = ACTIONS(3097),
    [sym_pure] = ACTIONS(3097),
    [sym_ref] = ACTIONS(3097),
    [sym_return] = ACTIONS(3097),
    [sym_scope] = ACTIONS(3097),
    [sym_shared] = ACTIONS(3097),
    [sym_static] = ACTIONS(3097),
    [sym_struct] = ACTIONS(3097),
    [sym_switch] = ACTIONS(3097),
    [sym_synchronized] = ACTIONS(3097),
    [sym_template] = ACTIONS(3097),
    [sym_throw] = ACTIONS(3097),
    [sym_try] = ACTIONS(3097),
    [sym_typeid] = ACTIONS(3097),
    [sym_typeof] = ACTIONS(3097),
    [sym_union] = ACTIONS(3097),
    [sym_unittest] = ACTIONS(3097),
    [sym_version] = ACTIONS(3097),
    [sym_while] = ACTIONS(3097),
    [sym_with] = ACTIONS(3097),
    [sym_parameters_] = ACTIONS(3097),
    [sym_gshared] = ACTIONS(3097),
    [sym_traits] = ACTIONS(3097),
    [sym_vector] = ACTIONS(3097),
    [sym_void] = ACTIONS(3097),
    [anon_sym_BQUOTE] = ACTIONS(3099),
    [anon_sym_r_DQUOTE] = ACTIONS(3099),
    [anon_sym_x_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3099),
    [anon_sym_i_BQUOTE] = ACTIONS(3099),
    [anon_sym_i_DQUOTE] = ACTIONS(3099),
    [anon_sym_iq_LBRACE] = ACTIONS(3099),
    [aux_sym_char_literal_token1] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [anon_sym___DATE__] = ACTIONS(3097),
    [anon_sym___FILE__] = ACTIONS(3097),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3097),
    [anon_sym___FUNCTION__] = ACTIONS(3097),
    [anon_sym___LINE__] = ACTIONS(3097),
    [anon_sym___MODULE__] = ACTIONS(3097),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3097),
    [anon_sym___TIME__] = ACTIONS(3097),
    [anon_sym___TIMESTAMP__] = ACTIONS(3097),
    [anon_sym___VENDOR__] = ACTIONS(3097),
    [anon_sym___VERSION__] = ACTIONS(3097),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3099),
    [sym_float_literal] = ACTIONS(3099),
    [sym__string] = ACTIONS(3099),
  },
  [627] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_q_LBRACE] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_SLASH] = ACTIONS(3101),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_PIPE] = ACTIONS(3101),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_LT_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT] = ACTIONS(3101),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT] = ACTIONS(3101),
    [anon_sym_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT] = ACTIONS(3101),
    [anon_sym_GT_GT_GT] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_DOLLAR] = ACTIONS(3101),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_EQ_EQ] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3101),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_CARET] = ACTIONS(3101),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_CARET_CARET] = ACTIONS(3101),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_TILDE_EQ] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3103),
    [anon_sym_EQ_GT] = ACTIONS(3103),
    [anon_sym_POUND] = ACTIONS(3103),
    [sym_bool] = ACTIONS(3101),
    [sym_byte] = ACTIONS(3101),
    [sym_ubyte] = ACTIONS(3101),
    [sym_char] = ACTIONS(3101),
    [sym_short] = ACTIONS(3101),
    [sym_ushort] = ACTIONS(3101),
    [sym_int] = ACTIONS(3101),
    [sym_uint] = ACTIONS(3101),
    [sym_long] = ACTIONS(3101),
    [sym_ulong] = ACTIONS(3101),
    [sym_cent] = ACTIONS(3101),
    [sym_ucent] = ACTIONS(3101),
    [sym_wchar] = ACTIONS(3101),
    [sym_dchar] = ACTIONS(3101),
    [sym_float] = ACTIONS(3101),
    [sym_double] = ACTIONS(3101),
    [sym_real] = ACTIONS(3101),
    [sym_ifloat] = ACTIONS(3101),
    [sym_idouble] = ACTIONS(3101),
    [sym_ireal] = ACTIONS(3101),
    [sym_cfloat] = ACTIONS(3101),
    [sym_cdouble] = ACTIONS(3101),
    [sym_creal] = ACTIONS(3101),
    [sym_size_t] = ACTIONS(3101),
    [sym_ptrdiff_t] = ACTIONS(3101),
    [sym_string] = ACTIONS(3101),
    [sym_cstring] = ACTIONS(3101),
    [sym_dstring] = ACTIONS(3101),
    [sym_wstring] = ACTIONS(3101),
    [sym_noreturn] = ACTIONS(3101),
    [sym_true] = ACTIONS(3101),
    [sym_false] = ACTIONS(3101),
    [sym_null] = ACTIONS(3101),
    [sym_super] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
    [sym_abstract] = ACTIONS(3101),
    [sym_alias] = ACTIONS(3101),
    [sym_align] = ACTIONS(3101),
    [sym_asm] = ACTIONS(3101),
    [sym_assert] = ACTIONS(3101),
    [sym_auto] = ACTIONS(3101),
    [sym_break] = ACTIONS(3101),
    [sym_case] = ACTIONS(3101),
    [sym_cast] = ACTIONS(3101),
    [sym_catch] = ACTIONS(3101),
    [sym_class] = ACTIONS(3101),
    [sym_const] = ACTIONS(3101),
    [sym_continue] = ACTIONS(3101),
    [sym_debug] = ACTIONS(3101),
    [sym_default] = ACTIONS(3101),
    [sym_delegate] = ACTIONS(3101),
    [sym_delete] = ACTIONS(3101),
    [sym_deprecated] = ACTIONS(3101),
    [sym_do] = ACTIONS(3101),
    [sym_else] = ACTIONS(3101),
    [sym_enum] = ACTIONS(3101),
    [sym_export] = ACTIONS(3101),
    [sym_extern] = ACTIONS(3101),
    [sym_final] = ACTIONS(3101),
    [sym_finally] = ACTIONS(3101),
    [sym_for] = ACTIONS(3101),
    [sym_foreach] = ACTIONS(3101),
    [sym_foreach_reverse] = ACTIONS(3101),
    [sym_function] = ACTIONS(3101),
    [sym_goto] = ACTIONS(3101),
    [sym_if] = ACTIONS(3101),
    [sym_immutable] = ACTIONS(3101),
    [sym_import] = ACTIONS(3101),
    [sym_in] = ACTIONS(3101),
    [sym_inout] = ACTIONS(3101),
    [sym_interface] = ACTIONS(3101),
    [sym_invariant] = ACTIONS(3101),
    [sym_is] = ACTIONS(3101),
    [sym_lazy] = ACTIONS(3101),
    [sym_mixin] = ACTIONS(3101),
    [sym_module] = ACTIONS(3101),
    [sym_new] = ACTIONS(3101),
    [sym_nothrow] = ACTIONS(3101),
    [sym_out] = ACTIONS(3101),
    [sym_override] = ACTIONS(3101),
    [sym_package] = ACTIONS(3101),
    [sym_pragma] = ACTIONS(3101),
    [sym_private] = ACTIONS(3101),
    [sym_protected] = ACTIONS(3101),
    [sym_public] = ACTIONS(3101),
    [sym_pure] = ACTIONS(3101),
    [sym_ref] = ACTIONS(3101),
    [sym_return] = ACTIONS(3101),
    [sym_scope] = ACTIONS(3101),
    [sym_shared] = ACTIONS(3101),
    [sym_static] = ACTIONS(3101),
    [sym_struct] = ACTIONS(3101),
    [sym_switch] = ACTIONS(3101),
    [sym_synchronized] = ACTIONS(3101),
    [sym_template] = ACTIONS(3101),
    [sym_throw] = ACTIONS(3101),
    [sym_try] = ACTIONS(3101),
    [sym_typeid] = ACTIONS(3101),
    [sym_typeof] = ACTIONS(3101),
    [sym_union] = ACTIONS(3101),
    [sym_unittest] = ACTIONS(3101),
    [sym_version] = ACTIONS(3101),
    [sym_while] = ACTIONS(3101),
    [sym_with] = ACTIONS(3101),
    [sym_parameters_] = ACTIONS(3101),
    [sym_gshared] = ACTIONS(3101),
    [sym_traits] = ACTIONS(3101),
    [sym_vector] = ACTIONS(3101),
    [sym_void] = ACTIONS(3101),
    [anon_sym_BQUOTE] = ACTIONS(3103),
    [anon_sym_r_DQUOTE] = ACTIONS(3103),
    [anon_sym_x_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3103),
    [anon_sym_i_BQUOTE] = ACTIONS(3103),
    [anon_sym_i_DQUOTE] = ACTIONS(3103),
    [anon_sym_iq_LBRACE] = ACTIONS(3103),
    [aux_sym_char_literal_token1] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [anon_sym___DATE__] = ACTIONS(3101),
    [anon_sym___FILE__] = ACTIONS(3101),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3101),
    [anon_sym___FUNCTION__] = ACTIONS(3101),
    [anon_sym___LINE__] = ACTIONS(3101),
    [anon_sym___MODULE__] = ACTIONS(3101),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3101),
    [anon_sym___TIME__] = ACTIONS(3101),
    [anon_sym___TIMESTAMP__] = ACTIONS(3101),
    [anon_sym___VENDOR__] = ACTIONS(3101),
    [anon_sym___VERSION__] = ACTIONS(3101),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3103),
    [sym_float_literal] = ACTIONS(3103),
    [sym__string] = ACTIONS(3103),
  },
  [628] = {
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_q_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3105),
    [anon_sym_SLASH_EQ] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_AMP_EQ] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_PIPE] = ACTIONS(3105),
    [anon_sym_PIPE_EQ] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_DASH_EQ] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_PLUS_EQ] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_LT_EQ] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_LT_LT_EQ] = ACTIONS(3107),
    [anon_sym_GT] = ACTIONS(3105),
    [anon_sym_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT] = ACTIONS(3105),
    [anon_sym_GT_GT_GT] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_RBRACK] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_DOLLAR] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_EQ_EQ] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_STAR_EQ] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_PERCENT_EQ] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_CARET_EQ] = ACTIONS(3107),
    [anon_sym_CARET_CARET] = ACTIONS(3105),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_TILDE_EQ] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_EQ_GT] = ACTIONS(3107),
    [anon_sym_POUND] = ACTIONS(3107),
    [sym_bool] = ACTIONS(3105),
    [sym_byte] = ACTIONS(3105),
    [sym_ubyte] = ACTIONS(3105),
    [sym_char] = ACTIONS(3105),
    [sym_short] = ACTIONS(3105),
    [sym_ushort] = ACTIONS(3105),
    [sym_int] = ACTIONS(3105),
    [sym_uint] = ACTIONS(3105),
    [sym_long] = ACTIONS(3105),
    [sym_ulong] = ACTIONS(3105),
    [sym_cent] = ACTIONS(3105),
    [sym_ucent] = ACTIONS(3105),
    [sym_wchar] = ACTIONS(3105),
    [sym_dchar] = ACTIONS(3105),
    [sym_float] = ACTIONS(3105),
    [sym_double] = ACTIONS(3105),
    [sym_real] = ACTIONS(3105),
    [sym_ifloat] = ACTIONS(3105),
    [sym_idouble] = ACTIONS(3105),
    [sym_ireal] = ACTIONS(3105),
    [sym_cfloat] = ACTIONS(3105),
    [sym_cdouble] = ACTIONS(3105),
    [sym_creal] = ACTIONS(3105),
    [sym_size_t] = ACTIONS(3105),
    [sym_ptrdiff_t] = ACTIONS(3105),
    [sym_string] = ACTIONS(3105),
    [sym_cstring] = ACTIONS(3105),
    [sym_dstring] = ACTIONS(3105),
    [sym_wstring] = ACTIONS(3105),
    [sym_noreturn] = ACTIONS(3105),
    [sym_true] = ACTIONS(3105),
    [sym_false] = ACTIONS(3105),
    [sym_null] = ACTIONS(3105),
    [sym_super] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
    [sym_abstract] = ACTIONS(3105),
    [sym_alias] = ACTIONS(3105),
    [sym_align] = ACTIONS(3105),
    [sym_asm] = ACTIONS(3105),
    [sym_assert] = ACTIONS(3105),
    [sym_auto] = ACTIONS(3105),
    [sym_break] = ACTIONS(3105),
    [sym_case] = ACTIONS(3105),
    [sym_cast] = ACTIONS(3105),
    [sym_catch] = ACTIONS(3105),
    [sym_class] = ACTIONS(3105),
    [sym_const] = ACTIONS(3105),
    [sym_continue] = ACTIONS(3105),
    [sym_debug] = ACTIONS(3105),
    [sym_default] = ACTIONS(3105),
    [sym_delegate] = ACTIONS(3105),
    [sym_delete] = ACTIONS(3105),
    [sym_deprecated] = ACTIONS(3105),
    [sym_do] = ACTIONS(3105),
    [sym_else] = ACTIONS(3105),
    [sym_enum] = ACTIONS(3105),
    [sym_export] = ACTIONS(3105),
    [sym_extern] = ACTIONS(3105),
    [sym_final] = ACTIONS(3105),
    [sym_finally] = ACTIONS(3105),
    [sym_for] = ACTIONS(3105),
    [sym_foreach] = ACTIONS(3105),
    [sym_foreach_reverse] = ACTIONS(3105),
    [sym_function] = ACTIONS(3105),
    [sym_goto] = ACTIONS(3105),
    [sym_if] = ACTIONS(3105),
    [sym_immutable] = ACTIONS(3105),
    [sym_import] = ACTIONS(3105),
    [sym_in] = ACTIONS(3105),
    [sym_inout] = ACTIONS(3105),
    [sym_interface] = ACTIONS(3105),
    [sym_invariant] = ACTIONS(3105),
    [sym_is] = ACTIONS(3105),
    [sym_lazy] = ACTIONS(3105),
    [sym_mixin] = ACTIONS(3105),
    [sym_module] = ACTIONS(3105),
    [sym_new] = ACTIONS(3105),
    [sym_nothrow] = ACTIONS(3105),
    [sym_out] = ACTIONS(3105),
    [sym_override] = ACTIONS(3105),
    [sym_package] = ACTIONS(3105),
    [sym_pragma] = ACTIONS(3105),
    [sym_private] = ACTIONS(3105),
    [sym_protected] = ACTIONS(3105),
    [sym_public] = ACTIONS(3105),
    [sym_pure] = ACTIONS(3105),
    [sym_ref] = ACTIONS(3105),
    [sym_return] = ACTIONS(3105),
    [sym_scope] = ACTIONS(3105),
    [sym_shared] = ACTIONS(3105),
    [sym_static] = ACTIONS(3105),
    [sym_struct] = ACTIONS(3105),
    [sym_switch] = ACTIONS(3105),
    [sym_synchronized] = ACTIONS(3105),
    [sym_template] = ACTIONS(3105),
    [sym_throw] = ACTIONS(3105),
    [sym_try] = ACTIONS(3105),
    [sym_typeid] = ACTIONS(3105),
    [sym_typeof] = ACTIONS(3105),
    [sym_union] = ACTIONS(3105),
    [sym_unittest] = ACTIONS(3105),
    [sym_version] = ACTIONS(3105),
    [sym_while] = ACTIONS(3105),
    [sym_with] = ACTIONS(3105),
    [sym_parameters_] = ACTIONS(3105),
    [sym_gshared] = ACTIONS(3105),
    [sym_traits] = ACTIONS(3105),
    [sym_vector] = ACTIONS(3105),
    [sym_void] = ACTIONS(3105),
    [anon_sym_BQUOTE] = ACTIONS(3107),
    [anon_sym_r_DQUOTE] = ACTIONS(3107),
    [anon_sym_x_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3107),
    [anon_sym_i_BQUOTE] = ACTIONS(3107),
    [anon_sym_i_DQUOTE] = ACTIONS(3107),
    [anon_sym_iq_LBRACE] = ACTIONS(3107),
    [aux_sym_char_literal_token1] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [anon_sym___DATE__] = ACTIONS(3105),
    [anon_sym___FILE__] = ACTIONS(3105),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3105),
    [anon_sym___FUNCTION__] = ACTIONS(3105),
    [anon_sym___LINE__] = ACTIONS(3105),
    [anon_sym___MODULE__] = ACTIONS(3105),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3105),
    [anon_sym___TIME__] = ACTIONS(3105),
    [anon_sym___TIMESTAMP__] = ACTIONS(3105),
    [anon_sym___VENDOR__] = ACTIONS(3105),
    [anon_sym___VERSION__] = ACTIONS(3105),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3107),
    [sym_float_literal] = ACTIONS(3107),
    [sym__string] = ACTIONS(3107),
  },
  [629] = {
    [sym_identifier] = ACTIONS(3109),
    [anon_sym_q_LBRACE] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_SLASH] = ACTIONS(3109),
    [anon_sym_SLASH_EQ] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_AMP_EQ] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_PIPE] = ACTIONS(3109),
    [anon_sym_PIPE_EQ] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_DASH_EQ] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_PLUS_EQ] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_LT_EQ] = ACTIONS(3111),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [anon_sym_LT_LT_EQ] = ACTIONS(3111),
    [anon_sym_GT] = ACTIONS(3109),
    [anon_sym_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_GT_GT_GT] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_RBRACK] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_DOLLAR] = ACTIONS(3109),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_EQ_EQ] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_STAR_EQ] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3109),
    [anon_sym_PERCENT_EQ] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3109),
    [anon_sym_CARET_EQ] = ACTIONS(3111),
    [anon_sym_CARET_CARET] = ACTIONS(3109),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_TILDE_EQ] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_POUND] = ACTIONS(3111),
    [sym_bool] = ACTIONS(3109),
    [sym_byte] = ACTIONS(3109),
    [sym_ubyte] = ACTIONS(3109),
    [sym_char] = ACTIONS(3109),
    [sym_short] = ACTIONS(3109),
    [sym_ushort] = ACTIONS(3109),
    [sym_int] = ACTIONS(3109),
    [sym_uint] = ACTIONS(3109),
    [sym_long] = ACTIONS(3109),
    [sym_ulong] = ACTIONS(3109),
    [sym_cent] = ACTIONS(3109),
    [sym_ucent] = ACTIONS(3109),
    [sym_wchar] = ACTIONS(3109),
    [sym_dchar] = ACTIONS(3109),
    [sym_float] = ACTIONS(3109),
    [sym_double] = ACTIONS(3109),
    [sym_real] = ACTIONS(3109),
    [sym_ifloat] = ACTIONS(3109),
    [sym_idouble] = ACTIONS(3109),
    [sym_ireal] = ACTIONS(3109),
    [sym_cfloat] = ACTIONS(3109),
    [sym_cdouble] = ACTIONS(3109),
    [sym_creal] = ACTIONS(3109),
    [sym_size_t] = ACTIONS(3109),
    [sym_ptrdiff_t] = ACTIONS(3109),
    [sym_string] = ACTIONS(3109),
    [sym_cstring] = ACTIONS(3109),
    [sym_dstring] = ACTIONS(3109),
    [sym_wstring] = ACTIONS(3109),
    [sym_noreturn] = ACTIONS(3109),
    [sym_true] = ACTIONS(3109),
    [sym_false] = ACTIONS(3109),
    [sym_null] = ACTIONS(3109),
    [sym_super] = ACTIONS(3109),
    [sym_this] = ACTIONS(3109),
    [sym_abstract] = ACTIONS(3109),
    [sym_alias] = ACTIONS(3109),
    [sym_align] = ACTIONS(3109),
    [sym_asm] = ACTIONS(3109),
    [sym_assert] = ACTIONS(3109),
    [sym_auto] = ACTIONS(3109),
    [sym_break] = ACTIONS(3109),
    [sym_case] = ACTIONS(3109),
    [sym_cast] = ACTIONS(3109),
    [sym_catch] = ACTIONS(3109),
    [sym_class] = ACTIONS(3109),
    [sym_const] = ACTIONS(3109),
    [sym_continue] = ACTIONS(3109),
    [sym_debug] = ACTIONS(3109),
    [sym_default] = ACTIONS(3109),
    [sym_delegate] = ACTIONS(3109),
    [sym_delete] = ACTIONS(3109),
    [sym_deprecated] = ACTIONS(3109),
    [sym_do] = ACTIONS(3109),
    [sym_else] = ACTIONS(3109),
    [sym_enum] = ACTIONS(3109),
    [sym_export] = ACTIONS(3109),
    [sym_extern] = ACTIONS(3109),
    [sym_final] = ACTIONS(3109),
    [sym_finally] = ACTIONS(3109),
    [sym_for] = ACTIONS(3109),
    [sym_foreach] = ACTIONS(3109),
    [sym_foreach_reverse] = ACTIONS(3109),
    [sym_function] = ACTIONS(3109),
    [sym_goto] = ACTIONS(3109),
    [sym_if] = ACTIONS(3109),
    [sym_immutable] = ACTIONS(3109),
    [sym_import] = ACTIONS(3109),
    [sym_in] = ACTIONS(3109),
    [sym_inout] = ACTIONS(3109),
    [sym_interface] = ACTIONS(3109),
    [sym_invariant] = ACTIONS(3109),
    [sym_is] = ACTIONS(3109),
    [sym_lazy] = ACTIONS(3109),
    [sym_mixin] = ACTIONS(3109),
    [sym_module] = ACTIONS(3109),
    [sym_new] = ACTIONS(3109),
    [sym_nothrow] = ACTIONS(3109),
    [sym_out] = ACTIONS(3109),
    [sym_override] = ACTIONS(3109),
    [sym_package] = ACTIONS(3109),
    [sym_pragma] = ACTIONS(3109),
    [sym_private] = ACTIONS(3109),
    [sym_protected] = ACTIONS(3109),
    [sym_public] = ACTIONS(3109),
    [sym_pure] = ACTIONS(3109),
    [sym_ref] = ACTIONS(3109),
    [sym_return] = ACTIONS(3109),
    [sym_scope] = ACTIONS(3109),
    [sym_shared] = ACTIONS(3109),
    [sym_static] = ACTIONS(3109),
    [sym_struct] = ACTIONS(3109),
    [sym_switch] = ACTIONS(3109),
    [sym_synchronized] = ACTIONS(3109),
    [sym_template] = ACTIONS(3109),
    [sym_throw] = ACTIONS(3109),
    [sym_try] = ACTIONS(3109),
    [sym_typeid] = ACTIONS(3109),
    [sym_typeof] = ACTIONS(3109),
    [sym_union] = ACTIONS(3109),
    [sym_unittest] = ACTIONS(3109),
    [sym_version] = ACTIONS(3109),
    [sym_while] = ACTIONS(3109),
    [sym_with] = ACTIONS(3109),
    [sym_parameters_] = ACTIONS(3109),
    [sym_gshared] = ACTIONS(3109),
    [sym_traits] = ACTIONS(3109),
    [sym_vector] = ACTIONS(3109),
    [sym_void] = ACTIONS(3109),
    [anon_sym_BQUOTE] = ACTIONS(3111),
    [anon_sym_r_DQUOTE] = ACTIONS(3111),
    [anon_sym_x_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3111),
    [anon_sym_i_BQUOTE] = ACTIONS(3111),
    [anon_sym_i_DQUOTE] = ACTIONS(3111),
    [anon_sym_iq_LBRACE] = ACTIONS(3111),
    [aux_sym_char_literal_token1] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [anon_sym___DATE__] = ACTIONS(3109),
    [anon_sym___FILE__] = ACTIONS(3109),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3109),
    [anon_sym___FUNCTION__] = ACTIONS(3109),
    [anon_sym___LINE__] = ACTIONS(3109),
    [anon_sym___MODULE__] = ACTIONS(3109),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3109),
    [anon_sym___TIME__] = ACTIONS(3109),
    [anon_sym___TIMESTAMP__] = ACTIONS(3109),
    [anon_sym___VENDOR__] = ACTIONS(3109),
    [anon_sym___VERSION__] = ACTIONS(3109),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3111),
    [sym_float_literal] = ACTIONS(3111),
    [sym__string] = ACTIONS(3111),
  },
  [630] = {
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_q_LBRACE] = ACTIONS(3115),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3113),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_PLUS_EQ] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_LT_EQ] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3113),
    [anon_sym_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT] = ACTIONS(3113),
    [anon_sym_GT_GT_GT] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_DOLLAR] = ACTIONS(3113),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3115),
    [anon_sym_CARET_CARET] = ACTIONS(3113),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_TILDE_EQ] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3115),
    [anon_sym_EQ_GT] = ACTIONS(3115),
    [anon_sym_POUND] = ACTIONS(3115),
    [sym_bool] = ACTIONS(3113),
    [sym_byte] = ACTIONS(3113),
    [sym_ubyte] = ACTIONS(3113),
    [sym_char] = ACTIONS(3113),
    [sym_short] = ACTIONS(3113),
    [sym_ushort] = ACTIONS(3113),
    [sym_int] = ACTIONS(3113),
    [sym_uint] = ACTIONS(3113),
    [sym_long] = ACTIONS(3113),
    [sym_ulong] = ACTIONS(3113),
    [sym_cent] = ACTIONS(3113),
    [sym_ucent] = ACTIONS(3113),
    [sym_wchar] = ACTIONS(3113),
    [sym_dchar] = ACTIONS(3113),
    [sym_float] = ACTIONS(3113),
    [sym_double] = ACTIONS(3113),
    [sym_real] = ACTIONS(3113),
    [sym_ifloat] = ACTIONS(3113),
    [sym_idouble] = ACTIONS(3113),
    [sym_ireal] = ACTIONS(3113),
    [sym_cfloat] = ACTIONS(3113),
    [sym_cdouble] = ACTIONS(3113),
    [sym_creal] = ACTIONS(3113),
    [sym_size_t] = ACTIONS(3113),
    [sym_ptrdiff_t] = ACTIONS(3113),
    [sym_string] = ACTIONS(3113),
    [sym_cstring] = ACTIONS(3113),
    [sym_dstring] = ACTIONS(3113),
    [sym_wstring] = ACTIONS(3113),
    [sym_noreturn] = ACTIONS(3113),
    [sym_true] = ACTIONS(3113),
    [sym_false] = ACTIONS(3113),
    [sym_null] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_this] = ACTIONS(3113),
    [sym_abstract] = ACTIONS(3113),
    [sym_alias] = ACTIONS(3113),
    [sym_align] = ACTIONS(3113),
    [sym_asm] = ACTIONS(3113),
    [sym_assert] = ACTIONS(3113),
    [sym_auto] = ACTIONS(3113),
    [sym_break] = ACTIONS(3113),
    [sym_case] = ACTIONS(3113),
    [sym_cast] = ACTIONS(3113),
    [sym_catch] = ACTIONS(3113),
    [sym_class] = ACTIONS(3113),
    [sym_const] = ACTIONS(3113),
    [sym_continue] = ACTIONS(3113),
    [sym_debug] = ACTIONS(3113),
    [sym_default] = ACTIONS(3113),
    [sym_delegate] = ACTIONS(3113),
    [sym_delete] = ACTIONS(3113),
    [sym_deprecated] = ACTIONS(3113),
    [sym_do] = ACTIONS(3113),
    [sym_else] = ACTIONS(3113),
    [sym_enum] = ACTIONS(3113),
    [sym_export] = ACTIONS(3113),
    [sym_extern] = ACTIONS(3113),
    [sym_final] = ACTIONS(3113),
    [sym_finally] = ACTIONS(3113),
    [sym_for] = ACTIONS(3113),
    [sym_foreach] = ACTIONS(3113),
    [sym_foreach_reverse] = ACTIONS(3113),
    [sym_function] = ACTIONS(3113),
    [sym_goto] = ACTIONS(3113),
    [sym_if] = ACTIONS(3113),
    [sym_immutable] = ACTIONS(3113),
    [sym_import] = ACTIONS(3113),
    [sym_in] = ACTIONS(3113),
    [sym_inout] = ACTIONS(3113),
    [sym_interface] = ACTIONS(3113),
    [sym_invariant] = ACTIONS(3113),
    [sym_is] = ACTIONS(3113),
    [sym_lazy] = ACTIONS(3113),
    [sym_mixin] = ACTIONS(3113),
    [sym_module] = ACTIONS(3113),
    [sym_new] = ACTIONS(3113),
    [sym_nothrow] = ACTIONS(3113),
    [sym_out] = ACTIONS(3113),
    [sym_override] = ACTIONS(3113),
    [sym_package] = ACTIONS(3113),
    [sym_pragma] = ACTIONS(3113),
    [sym_private] = ACTIONS(3113),
    [sym_protected] = ACTIONS(3113),
    [sym_public] = ACTIONS(3113),
    [sym_pure] = ACTIONS(3113),
    [sym_ref] = ACTIONS(3113),
    [sym_return] = ACTIONS(3113),
    [sym_scope] = ACTIONS(3113),
    [sym_shared] = ACTIONS(3113),
    [sym_static] = ACTIONS(3113),
    [sym_struct] = ACTIONS(3113),
    [sym_switch] = ACTIONS(3113),
    [sym_synchronized] = ACTIONS(3113),
    [sym_template] = ACTIONS(3113),
    [sym_throw] = ACTIONS(3113),
    [sym_try] = ACTIONS(3113),
    [sym_typeid] = ACTIONS(3113),
    [sym_typeof] = ACTIONS(3113),
    [sym_union] = ACTIONS(3113),
    [sym_unittest] = ACTIONS(3113),
    [sym_version] = ACTIONS(3113),
    [sym_while] = ACTIONS(3113),
    [sym_with] = ACTIONS(3113),
    [sym_parameters_] = ACTIONS(3113),
    [sym_gshared] = ACTIONS(3113),
    [sym_traits] = ACTIONS(3113),
    [sym_vector] = ACTIONS(3113),
    [sym_void] = ACTIONS(3113),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_r_DQUOTE] = ACTIONS(3115),
    [anon_sym_x_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3115),
    [anon_sym_i_BQUOTE] = ACTIONS(3115),
    [anon_sym_i_DQUOTE] = ACTIONS(3115),
    [anon_sym_iq_LBRACE] = ACTIONS(3115),
    [aux_sym_char_literal_token1] = ACTIONS(3115),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym___DATE__] = ACTIONS(3113),
    [anon_sym___FILE__] = ACTIONS(3113),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3113),
    [anon_sym___FUNCTION__] = ACTIONS(3113),
    [anon_sym___LINE__] = ACTIONS(3113),
    [anon_sym___MODULE__] = ACTIONS(3113),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3113),
    [anon_sym___TIME__] = ACTIONS(3113),
    [anon_sym___TIMESTAMP__] = ACTIONS(3113),
    [anon_sym___VENDOR__] = ACTIONS(3113),
    [anon_sym___VERSION__] = ACTIONS(3113),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3115),
    [sym_float_literal] = ACTIONS(3115),
    [sym__string] = ACTIONS(3115),
  },
  [631] = {
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_q_LBRACE] = ACTIONS(3119),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3117),
    [anon_sym_DOT_DOT] = ACTIONS(3117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3119),
    [anon_sym_DASH_DASH] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT] = ACTIONS(3117),
    [anon_sym_GT_GT_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_DOLLAR] = ACTIONS(3117),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3119),
    [anon_sym_CARET_CARET] = ACTIONS(3117),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_TILDE_EQ] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3119),
    [anon_sym_POUND] = ACTIONS(3119),
    [sym_bool] = ACTIONS(3117),
    [sym_byte] = ACTIONS(3117),
    [sym_ubyte] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_short] = ACTIONS(3117),
    [sym_ushort] = ACTIONS(3117),
    [sym_int] = ACTIONS(3117),
    [sym_uint] = ACTIONS(3117),
    [sym_long] = ACTIONS(3117),
    [sym_ulong] = ACTIONS(3117),
    [sym_cent] = ACTIONS(3117),
    [sym_ucent] = ACTIONS(3117),
    [sym_wchar] = ACTIONS(3117),
    [sym_dchar] = ACTIONS(3117),
    [sym_float] = ACTIONS(3117),
    [sym_double] = ACTIONS(3117),
    [sym_real] = ACTIONS(3117),
    [sym_ifloat] = ACTIONS(3117),
    [sym_idouble] = ACTIONS(3117),
    [sym_ireal] = ACTIONS(3117),
    [sym_cfloat] = ACTIONS(3117),
    [sym_cdouble] = ACTIONS(3117),
    [sym_creal] = ACTIONS(3117),
    [sym_size_t] = ACTIONS(3117),
    [sym_ptrdiff_t] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym_cstring] = ACTIONS(3117),
    [sym_dstring] = ACTIONS(3117),
    [sym_wstring] = ACTIONS(3117),
    [sym_noreturn] = ACTIONS(3117),
    [sym_true] = ACTIONS(3117),
    [sym_false] = ACTIONS(3117),
    [sym_null] = ACTIONS(3117),
    [sym_super] = ACTIONS(3117),
    [sym_this] = ACTIONS(3117),
    [sym_abstract] = ACTIONS(3117),
    [sym_alias] = ACTIONS(3117),
    [sym_align] = ACTIONS(3117),
    [sym_asm] = ACTIONS(3117),
    [sym_assert] = ACTIONS(3117),
    [sym_auto] = ACTIONS(3117),
    [sym_break] = ACTIONS(3117),
    [sym_case] = ACTIONS(3117),
    [sym_cast] = ACTIONS(3117),
    [sym_catch] = ACTIONS(3117),
    [sym_class] = ACTIONS(3117),
    [sym_const] = ACTIONS(3117),
    [sym_continue] = ACTIONS(3117),
    [sym_debug] = ACTIONS(3117),
    [sym_default] = ACTIONS(3117),
    [sym_delegate] = ACTIONS(3117),
    [sym_delete] = ACTIONS(3117),
    [sym_deprecated] = ACTIONS(3117),
    [sym_do] = ACTIONS(3117),
    [sym_else] = ACTIONS(3117),
    [sym_enum] = ACTIONS(3117),
    [sym_export] = ACTIONS(3117),
    [sym_extern] = ACTIONS(3117),
    [sym_final] = ACTIONS(3117),
    [sym_finally] = ACTIONS(3117),
    [sym_for] = ACTIONS(3117),
    [sym_foreach] = ACTIONS(3117),
    [sym_foreach_reverse] = ACTIONS(3117),
    [sym_function] = ACTIONS(3117),
    [sym_goto] = ACTIONS(3117),
    [sym_if] = ACTIONS(3117),
    [sym_immutable] = ACTIONS(3117),
    [sym_import] = ACTIONS(3117),
    [sym_in] = ACTIONS(3117),
    [sym_inout] = ACTIONS(3117),
    [sym_interface] = ACTIONS(3117),
    [sym_invariant] = ACTIONS(3117),
    [sym_is] = ACTIONS(3117),
    [sym_lazy] = ACTIONS(3117),
    [sym_mixin] = ACTIONS(3117),
    [sym_module] = ACTIONS(3117),
    [sym_new] = ACTIONS(3117),
    [sym_nothrow] = ACTIONS(3117),
    [sym_out] = ACTIONS(3117),
    [sym_override] = ACTIONS(3117),
    [sym_package] = ACTIONS(3117),
    [sym_pragma] = ACTIONS(3117),
    [sym_private] = ACTIONS(3117),
    [sym_protected] = ACTIONS(3117),
    [sym_public] = ACTIONS(3117),
    [sym_pure] = ACTIONS(3117),
    [sym_ref] = ACTIONS(3117),
    [sym_return] = ACTIONS(3117),
    [sym_scope] = ACTIONS(3117),
    [sym_shared] = ACTIONS(3117),
    [sym_static] = ACTIONS(3117),
    [sym_struct] = ACTIONS(3117),
    [sym_switch] = ACTIONS(3117),
    [sym_synchronized] = ACTIONS(3117),
    [sym_template] = ACTIONS(3117),
    [sym_throw] = ACTIONS(3117),
    [sym_try] = ACTIONS(3117),
    [sym_typeid] = ACTIONS(3117),
    [sym_typeof] = ACTIONS(3117),
    [sym_union] = ACTIONS(3117),
    [sym_unittest] = ACTIONS(3117),
    [sym_version] = ACTIONS(3117),
    [sym_while] = ACTIONS(3117),
    [sym_with] = ACTIONS(3117),
    [sym_parameters_] = ACTIONS(3117),
    [sym_gshared] = ACTIONS(3117),
    [sym_traits] = ACTIONS(3117),
    [sym_vector] = ACTIONS(3117),
    [sym_void] = ACTIONS(3117),
    [anon_sym_BQUOTE] = ACTIONS(3119),
    [anon_sym_r_DQUOTE] = ACTIONS(3119),
    [anon_sym_x_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3119),
    [anon_sym_i_BQUOTE] = ACTIONS(3119),
    [anon_sym_i_DQUOTE] = ACTIONS(3119),
    [anon_sym_iq_LBRACE] = ACTIONS(3119),
    [aux_sym_char_literal_token1] = ACTIONS(3119),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym___DATE__] = ACTIONS(3117),
    [anon_sym___FILE__] = ACTIONS(3117),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3117),
    [anon_sym___FUNCTION__] = ACTIONS(3117),
    [anon_sym___LINE__] = ACTIONS(3117),
    [anon_sym___MODULE__] = ACTIONS(3117),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3117),
    [anon_sym___TIME__] = ACTIONS(3117),
    [anon_sym___TIMESTAMP__] = ACTIONS(3117),
    [anon_sym___VENDOR__] = ACTIONS(3117),
    [anon_sym___VERSION__] = ACTIONS(3117),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3119),
    [sym_float_literal] = ACTIONS(3119),
    [sym__string] = ACTIONS(3119),
  },
  [632] = {
    [sym_identifier] = ACTIONS(3049),
    [anon_sym_q_LBRACE] = ACTIONS(3051),
    [anon_sym_RBRACE] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(3051),
    [anon_sym_SLASH] = ACTIONS(3049),
    [anon_sym_SLASH_EQ] = ACTIONS(3051),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_DOT_DOT] = ACTIONS(3049),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3051),
    [anon_sym_AMP] = ACTIONS(3049),
    [anon_sym_AMP_EQ] = ACTIONS(3051),
    [anon_sym_AMP_AMP] = ACTIONS(3051),
    [anon_sym_PIPE] = ACTIONS(3049),
    [anon_sym_PIPE_EQ] = ACTIONS(3051),
    [anon_sym_PIPE_PIPE] = ACTIONS(3051),
    [anon_sym_DASH] = ACTIONS(3049),
    [anon_sym_DASH_EQ] = ACTIONS(3051),
    [anon_sym_DASH_DASH] = ACTIONS(3051),
    [anon_sym_PLUS] = ACTIONS(3049),
    [anon_sym_PLUS_EQ] = ACTIONS(3051),
    [anon_sym_PLUS_PLUS] = ACTIONS(3051),
    [anon_sym_LT] = ACTIONS(3049),
    [anon_sym_LT_EQ] = ACTIONS(3051),
    [anon_sym_LT_LT] = ACTIONS(3049),
    [anon_sym_LT_LT_EQ] = ACTIONS(3051),
    [anon_sym_GT] = ACTIONS(3049),
    [anon_sym_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3051),
    [anon_sym_GT_GT] = ACTIONS(3049),
    [anon_sym_GT_GT_GT] = ACTIONS(3049),
    [anon_sym_BANG] = ACTIONS(3049),
    [anon_sym_BANG_EQ] = ACTIONS(3051),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_RPAREN] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3051),
    [anon_sym_RBRACK] = ACTIONS(3051),
    [anon_sym_QMARK] = ACTIONS(3051),
    [anon_sym_COMMA] = ACTIONS(3051),
    [anon_sym_SEMI] = ACTIONS(3051),
    [anon_sym_COLON] = ACTIONS(3051),
    [anon_sym_DOLLAR] = ACTIONS(3051),
    [anon_sym_EQ] = ACTIONS(3049),
    [anon_sym_EQ_EQ] = ACTIONS(3051),
    [anon_sym_STAR] = ACTIONS(3049),
    [anon_sym_STAR_EQ] = ACTIONS(3051),
    [anon_sym_PERCENT] = ACTIONS(3049),
    [anon_sym_PERCENT_EQ] = ACTIONS(3051),
    [anon_sym_CARET] = ACTIONS(3049),
    [anon_sym_CARET_EQ] = ACTIONS(3051),
    [anon_sym_CARET_CARET] = ACTIONS(3049),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3051),
    [anon_sym_TILDE] = ACTIONS(3049),
    [anon_sym_TILDE_EQ] = ACTIONS(3051),
    [anon_sym_AT] = ACTIONS(3051),
    [anon_sym_EQ_GT] = ACTIONS(3051),
    [anon_sym_POUND] = ACTIONS(3051),
    [sym_bool] = ACTIONS(3049),
    [sym_byte] = ACTIONS(3049),
    [sym_ubyte] = ACTIONS(3049),
    [sym_char] = ACTIONS(3049),
    [sym_short] = ACTIONS(3049),
    [sym_ushort] = ACTIONS(3049),
    [sym_int] = ACTIONS(3049),
    [sym_uint] = ACTIONS(3049),
    [sym_long] = ACTIONS(3049),
    [sym_ulong] = ACTIONS(3049),
    [sym_cent] = ACTIONS(3049),
    [sym_ucent] = ACTIONS(3049),
    [sym_wchar] = ACTIONS(3049),
    [sym_dchar] = ACTIONS(3049),
    [sym_float] = ACTIONS(3049),
    [sym_double] = ACTIONS(3049),
    [sym_real] = ACTIONS(3049),
    [sym_ifloat] = ACTIONS(3049),
    [sym_idouble] = ACTIONS(3049),
    [sym_ireal] = ACTIONS(3049),
    [sym_cfloat] = ACTIONS(3049),
    [sym_cdouble] = ACTIONS(3049),
    [sym_creal] = ACTIONS(3049),
    [sym_size_t] = ACTIONS(3049),
    [sym_ptrdiff_t] = ACTIONS(3049),
    [sym_string] = ACTIONS(3049),
    [sym_cstring] = ACTIONS(3049),
    [sym_dstring] = ACTIONS(3049),
    [sym_wstring] = ACTIONS(3049),
    [sym_noreturn] = ACTIONS(3049),
    [sym_true] = ACTIONS(3049),
    [sym_false] = ACTIONS(3049),
    [sym_null] = ACTIONS(3049),
    [sym_super] = ACTIONS(3049),
    [sym_this] = ACTIONS(3049),
    [sym_abstract] = ACTIONS(3049),
    [sym_alias] = ACTIONS(3049),
    [sym_align] = ACTIONS(3049),
    [sym_asm] = ACTIONS(3049),
    [sym_assert] = ACTIONS(3049),
    [sym_auto] = ACTIONS(3049),
    [sym_break] = ACTIONS(3049),
    [sym_case] = ACTIONS(3049),
    [sym_cast] = ACTIONS(3049),
    [sym_catch] = ACTIONS(3049),
    [sym_class] = ACTIONS(3049),
    [sym_const] = ACTIONS(3049),
    [sym_continue] = ACTIONS(3049),
    [sym_debug] = ACTIONS(3049),
    [sym_default] = ACTIONS(3049),
    [sym_delegate] = ACTIONS(3049),
    [sym_delete] = ACTIONS(3049),
    [sym_deprecated] = ACTIONS(3049),
    [sym_do] = ACTIONS(3049),
    [sym_else] = ACTIONS(3049),
    [sym_enum] = ACTIONS(3049),
    [sym_export] = ACTIONS(3049),
    [sym_extern] = ACTIONS(3049),
    [sym_final] = ACTIONS(3049),
    [sym_finally] = ACTIONS(3049),
    [sym_for] = ACTIONS(3049),
    [sym_foreach] = ACTIONS(3049),
    [sym_foreach_reverse] = ACTIONS(3049),
    [sym_function] = ACTIONS(3049),
    [sym_goto] = ACTIONS(3049),
    [sym_if] = ACTIONS(3049),
    [sym_immutable] = ACTIONS(3049),
    [sym_import] = ACTIONS(3049),
    [sym_in] = ACTIONS(3049),
    [sym_inout] = ACTIONS(3049),
    [sym_interface] = ACTIONS(3049),
    [sym_invariant] = ACTIONS(3049),
    [sym_is] = ACTIONS(3049),
    [sym_lazy] = ACTIONS(3049),
    [sym_mixin] = ACTIONS(3049),
    [sym_module] = ACTIONS(3049),
    [sym_new] = ACTIONS(3049),
    [sym_nothrow] = ACTIONS(3049),
    [sym_out] = ACTIONS(3049),
    [sym_override] = ACTIONS(3049),
    [sym_package] = ACTIONS(3049),
    [sym_pragma] = ACTIONS(3049),
    [sym_private] = ACTIONS(3049),
    [sym_protected] = ACTIONS(3049),
    [sym_public] = ACTIONS(3049),
    [sym_pure] = ACTIONS(3049),
    [sym_ref] = ACTIONS(3049),
    [sym_return] = ACTIONS(3049),
    [sym_scope] = ACTIONS(3049),
    [sym_shared] = ACTIONS(3049),
    [sym_static] = ACTIONS(3049),
    [sym_struct] = ACTIONS(3049),
    [sym_switch] = ACTIONS(3049),
    [sym_synchronized] = ACTIONS(3049),
    [sym_template] = ACTIONS(3049),
    [sym_throw] = ACTIONS(3049),
    [sym_try] = ACTIONS(3049),
    [sym_typeid] = ACTIONS(3049),
    [sym_typeof] = ACTIONS(3049),
    [sym_union] = ACTIONS(3049),
    [sym_unittest] = ACTIONS(3049),
    [sym_version] = ACTIONS(3049),
    [sym_while] = ACTIONS(3049),
    [sym_with] = ACTIONS(3049),
    [sym_parameters_] = ACTIONS(3049),
    [sym_gshared] = ACTIONS(3049),
    [sym_traits] = ACTIONS(3049),
    [sym_vector] = ACTIONS(3049),
    [sym_void] = ACTIONS(3049),
    [anon_sym_BQUOTE] = ACTIONS(3051),
    [anon_sym_r_DQUOTE] = ACTIONS(3051),
    [anon_sym_x_DQUOTE] = ACTIONS(3051),
    [anon_sym_DQUOTE] = ACTIONS(3051),
    [anon_sym_i_BQUOTE] = ACTIONS(3051),
    [anon_sym_i_DQUOTE] = ACTIONS(3051),
    [anon_sym_iq_LBRACE] = ACTIONS(3051),
    [aux_sym_char_literal_token1] = ACTIONS(3051),
    [anon_sym_SQUOTE] = ACTIONS(3049),
    [anon_sym___DATE__] = ACTIONS(3049),
    [anon_sym___FILE__] = ACTIONS(3049),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3049),
    [anon_sym___FUNCTION__] = ACTIONS(3049),
    [anon_sym___LINE__] = ACTIONS(3049),
    [anon_sym___MODULE__] = ACTIONS(3049),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3049),
    [anon_sym___TIME__] = ACTIONS(3049),
    [anon_sym___TIMESTAMP__] = ACTIONS(3049),
    [anon_sym___VENDOR__] = ACTIONS(3049),
    [anon_sym___VERSION__] = ACTIONS(3049),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3051),
    [sym_float_literal] = ACTIONS(3051),
    [sym__string] = ACTIONS(3051),
  },
  [633] = {
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_q_LBRACE] = ACTIONS(3095),
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3093),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3093),
    [anon_sym_DOT_DOT] = ACTIONS(3093),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_LT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3093),
    [anon_sym_GT_GT_GT] = ACTIONS(3093),
    [anon_sym_BANG] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_DOLLAR] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_EQ_EQ] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3093),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_CARET_CARET] = ACTIONS(3093),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_TILDE_EQ] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3095),
    [anon_sym_EQ_GT] = ACTIONS(3095),
    [anon_sym_POUND] = ACTIONS(3095),
    [sym_bool] = ACTIONS(3093),
    [sym_byte] = ACTIONS(3093),
    [sym_ubyte] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_short] = ACTIONS(3093),
    [sym_ushort] = ACTIONS(3093),
    [sym_int] = ACTIONS(3093),
    [sym_uint] = ACTIONS(3093),
    [sym_long] = ACTIONS(3093),
    [sym_ulong] = ACTIONS(3093),
    [sym_cent] = ACTIONS(3093),
    [sym_ucent] = ACTIONS(3093),
    [sym_wchar] = ACTIONS(3093),
    [sym_dchar] = ACTIONS(3093),
    [sym_float] = ACTIONS(3093),
    [sym_double] = ACTIONS(3093),
    [sym_real] = ACTIONS(3093),
    [sym_ifloat] = ACTIONS(3093),
    [sym_idouble] = ACTIONS(3093),
    [sym_ireal] = ACTIONS(3093),
    [sym_cfloat] = ACTIONS(3093),
    [sym_cdouble] = ACTIONS(3093),
    [sym_creal] = ACTIONS(3093),
    [sym_size_t] = ACTIONS(3093),
    [sym_ptrdiff_t] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym_cstring] = ACTIONS(3093),
    [sym_dstring] = ACTIONS(3093),
    [sym_wstring] = ACTIONS(3093),
    [sym_noreturn] = ACTIONS(3093),
    [sym_true] = ACTIONS(3093),
    [sym_false] = ACTIONS(3093),
    [sym_null] = ACTIONS(3093),
    [sym_super] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
    [sym_abstract] = ACTIONS(3093),
    [sym_alias] = ACTIONS(3093),
    [sym_align] = ACTIONS(3093),
    [sym_asm] = ACTIONS(3093),
    [sym_assert] = ACTIONS(3093),
    [sym_auto] = ACTIONS(3093),
    [sym_break] = ACTIONS(3093),
    [sym_case] = ACTIONS(3093),
    [sym_cast] = ACTIONS(3093),
    [sym_catch] = ACTIONS(3093),
    [sym_class] = ACTIONS(3093),
    [sym_const] = ACTIONS(3093),
    [sym_continue] = ACTIONS(3093),
    [sym_debug] = ACTIONS(3093),
    [sym_default] = ACTIONS(3093),
    [sym_delegate] = ACTIONS(3093),
    [sym_delete] = ACTIONS(3093),
    [sym_deprecated] = ACTIONS(3093),
    [sym_do] = ACTIONS(3093),
    [sym_else] = ACTIONS(3093),
    [sym_enum] = ACTIONS(3093),
    [sym_export] = ACTIONS(3093),
    [sym_extern] = ACTIONS(3093),
    [sym_final] = ACTIONS(3093),
    [sym_finally] = ACTIONS(3093),
    [sym_for] = ACTIONS(3093),
    [sym_foreach] = ACTIONS(3093),
    [sym_foreach_reverse] = ACTIONS(3093),
    [sym_function] = ACTIONS(3093),
    [sym_goto] = ACTIONS(3093),
    [sym_if] = ACTIONS(3093),
    [sym_immutable] = ACTIONS(3093),
    [sym_import] = ACTIONS(3093),
    [sym_in] = ACTIONS(3093),
    [sym_inout] = ACTIONS(3093),
    [sym_interface] = ACTIONS(3093),
    [sym_invariant] = ACTIONS(3093),
    [sym_is] = ACTIONS(3093),
    [sym_lazy] = ACTIONS(3093),
    [sym_mixin] = ACTIONS(3093),
    [sym_module] = ACTIONS(3093),
    [sym_new] = ACTIONS(3093),
    [sym_nothrow] = ACTIONS(3093),
    [sym_out] = ACTIONS(3093),
    [sym_override] = ACTIONS(3093),
    [sym_package] = ACTIONS(3093),
    [sym_pragma] = ACTIONS(3093),
    [sym_private] = ACTIONS(3093),
    [sym_protected] = ACTIONS(3093),
    [sym_public] = ACTIONS(3093),
    [sym_pure] = ACTIONS(3093),
    [sym_ref] = ACTIONS(3093),
    [sym_return] = ACTIONS(3093),
    [sym_scope] = ACTIONS(3093),
    [sym_shared] = ACTIONS(3093),
    [sym_static] = ACTIONS(3093),
    [sym_struct] = ACTIONS(3093),
    [sym_switch] = ACTIONS(3093),
    [sym_synchronized] = ACTIONS(3093),
    [sym_template] = ACTIONS(3093),
    [sym_throw] = ACTIONS(3093),
    [sym_try] = ACTIONS(3093),
    [sym_typeid] = ACTIONS(3093),
    [sym_typeof] = ACTIONS(3093),
    [sym_union] = ACTIONS(3093),
    [sym_unittest] = ACTIONS(3093),
    [sym_version] = ACTIONS(3093),
    [sym_while] = ACTIONS(3093),
    [sym_with] = ACTIONS(3093),
    [sym_parameters_] = ACTIONS(3093),
    [sym_gshared] = ACTIONS(3093),
    [sym_traits] = ACTIONS(3093),
    [sym_vector] = ACTIONS(3093),
    [sym_void] = ACTIONS(3093),
    [anon_sym_BQUOTE] = ACTIONS(3095),
    [anon_sym_r_DQUOTE] = ACTIONS(3095),
    [anon_sym_x_DQUOTE] = ACTIONS(3095),
    [anon_sym_DQUOTE] = ACTIONS(3095),
    [anon_sym_i_BQUOTE] = ACTIONS(3095),
    [anon_sym_i_DQUOTE] = ACTIONS(3095),
    [anon_sym_iq_LBRACE] = ACTIONS(3095),
    [aux_sym_char_literal_token1] = ACTIONS(3095),
    [anon_sym_SQUOTE] = ACTIONS(3093),
    [anon_sym___DATE__] = ACTIONS(3093),
    [anon_sym___FILE__] = ACTIONS(3093),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3093),
    [anon_sym___FUNCTION__] = ACTIONS(3093),
    [anon_sym___LINE__] = ACTIONS(3093),
    [anon_sym___MODULE__] = ACTIONS(3093),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3093),
    [anon_sym___TIME__] = ACTIONS(3093),
    [anon_sym___TIMESTAMP__] = ACTIONS(3093),
    [anon_sym___VENDOR__] = ACTIONS(3093),
    [anon_sym___VERSION__] = ACTIONS(3093),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3095),
    [sym_float_literal] = ACTIONS(3095),
    [sym__string] = ACTIONS(3095),
  },
  [634] = {
    [sym_identifier] = ACTIONS(3057),
    [anon_sym_q_LBRACE] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3057),
    [anon_sym_DOT_DOT] = ACTIONS(3057),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_GT_GT_GT] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_DOLLAR] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_CARET_CARET] = ACTIONS(3057),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_TILDE_EQ] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_EQ_GT] = ACTIONS(3059),
    [anon_sym_POUND] = ACTIONS(3059),
    [sym_bool] = ACTIONS(3057),
    [sym_byte] = ACTIONS(3057),
    [sym_ubyte] = ACTIONS(3057),
    [sym_char] = ACTIONS(3057),
    [sym_short] = ACTIONS(3057),
    [sym_ushort] = ACTIONS(3057),
    [sym_int] = ACTIONS(3057),
    [sym_uint] = ACTIONS(3057),
    [sym_long] = ACTIONS(3057),
    [sym_ulong] = ACTIONS(3057),
    [sym_cent] = ACTIONS(3057),
    [sym_ucent] = ACTIONS(3057),
    [sym_wchar] = ACTIONS(3057),
    [sym_dchar] = ACTIONS(3057),
    [sym_float] = ACTIONS(3057),
    [sym_double] = ACTIONS(3057),
    [sym_real] = ACTIONS(3057),
    [sym_ifloat] = ACTIONS(3057),
    [sym_idouble] = ACTIONS(3057),
    [sym_ireal] = ACTIONS(3057),
    [sym_cfloat] = ACTIONS(3057),
    [sym_cdouble] = ACTIONS(3057),
    [sym_creal] = ACTIONS(3057),
    [sym_size_t] = ACTIONS(3057),
    [sym_ptrdiff_t] = ACTIONS(3057),
    [sym_string] = ACTIONS(3057),
    [sym_cstring] = ACTIONS(3057),
    [sym_dstring] = ACTIONS(3057),
    [sym_wstring] = ACTIONS(3057),
    [sym_noreturn] = ACTIONS(3057),
    [sym_true] = ACTIONS(3057),
    [sym_false] = ACTIONS(3057),
    [sym_null] = ACTIONS(3057),
    [sym_super] = ACTIONS(3057),
    [sym_this] = ACTIONS(3057),
    [sym_abstract] = ACTIONS(3057),
    [sym_alias] = ACTIONS(3057),
    [sym_align] = ACTIONS(3057),
    [sym_asm] = ACTIONS(3057),
    [sym_assert] = ACTIONS(3057),
    [sym_auto] = ACTIONS(3057),
    [sym_break] = ACTIONS(3057),
    [sym_case] = ACTIONS(3057),
    [sym_cast] = ACTIONS(3057),
    [sym_catch] = ACTIONS(3057),
    [sym_class] = ACTIONS(3057),
    [sym_const] = ACTIONS(3057),
    [sym_continue] = ACTIONS(3057),
    [sym_debug] = ACTIONS(3057),
    [sym_default] = ACTIONS(3057),
    [sym_delegate] = ACTIONS(3057),
    [sym_delete] = ACTIONS(3057),
    [sym_deprecated] = ACTIONS(3057),
    [sym_do] = ACTIONS(3057),
    [sym_else] = ACTIONS(3057),
    [sym_enum] = ACTIONS(3057),
    [sym_export] = ACTIONS(3057),
    [sym_extern] = ACTIONS(3057),
    [sym_final] = ACTIONS(3057),
    [sym_finally] = ACTIONS(3057),
    [sym_for] = ACTIONS(3057),
    [sym_foreach] = ACTIONS(3057),
    [sym_foreach_reverse] = ACTIONS(3057),
    [sym_function] = ACTIONS(3057),
    [sym_goto] = ACTIONS(3057),
    [sym_if] = ACTIONS(3057),
    [sym_immutable] = ACTIONS(3057),
    [sym_import] = ACTIONS(3057),
    [sym_in] = ACTIONS(3057),
    [sym_inout] = ACTIONS(3057),
    [sym_interface] = ACTIONS(3057),
    [sym_invariant] = ACTIONS(3057),
    [sym_is] = ACTIONS(3057),
    [sym_lazy] = ACTIONS(3057),
    [sym_mixin] = ACTIONS(3057),
    [sym_module] = ACTIONS(3057),
    [sym_new] = ACTIONS(3057),
    [sym_nothrow] = ACTIONS(3057),
    [sym_out] = ACTIONS(3057),
    [sym_override] = ACTIONS(3057),
    [sym_package] = ACTIONS(3057),
    [sym_pragma] = ACTIONS(3057),
    [sym_private] = ACTIONS(3057),
    [sym_protected] = ACTIONS(3057),
    [sym_public] = ACTIONS(3057),
    [sym_pure] = ACTIONS(3057),
    [sym_ref] = ACTIONS(3057),
    [sym_return] = ACTIONS(3057),
    [sym_scope] = ACTIONS(3057),
    [sym_shared] = ACTIONS(3057),
    [sym_static] = ACTIONS(3057),
    [sym_struct] = ACTIONS(3057),
    [sym_switch] = ACTIONS(3057),
    [sym_synchronized] = ACTIONS(3057),
    [sym_template] = ACTIONS(3057),
    [sym_throw] = ACTIONS(3057),
    [sym_try] = ACTIONS(3057),
    [sym_typeid] = ACTIONS(3057),
    [sym_typeof] = ACTIONS(3057),
    [sym_union] = ACTIONS(3057),
    [sym_unittest] = ACTIONS(3057),
    [sym_version] = ACTIONS(3057),
    [sym_while] = ACTIONS(3057),
    [sym_with] = ACTIONS(3057),
    [sym_parameters_] = ACTIONS(3057),
    [sym_gshared] = ACTIONS(3057),
    [sym_traits] = ACTIONS(3057),
    [sym_vector] = ACTIONS(3057),
    [sym_void] = ACTIONS(3057),
    [anon_sym_BQUOTE] = ACTIONS(3059),
    [anon_sym_r_DQUOTE] = ACTIONS(3059),
    [anon_sym_x_DQUOTE] = ACTIONS(3059),
    [anon_sym_DQUOTE] = ACTIONS(3059),
    [anon_sym_i_BQUOTE] = ACTIONS(3059),
    [anon_sym_i_DQUOTE] = ACTIONS(3059),
    [anon_sym_iq_LBRACE] = ACTIONS(3059),
    [aux_sym_char_literal_token1] = ACTIONS(3059),
    [anon_sym_SQUOTE] = ACTIONS(3057),
    [anon_sym___DATE__] = ACTIONS(3057),
    [anon_sym___FILE__] = ACTIONS(3057),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3057),
    [anon_sym___FUNCTION__] = ACTIONS(3057),
    [anon_sym___LINE__] = ACTIONS(3057),
    [anon_sym___MODULE__] = ACTIONS(3057),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3057),
    [anon_sym___TIME__] = ACTIONS(3057),
    [anon_sym___TIMESTAMP__] = ACTIONS(3057),
    [anon_sym___VENDOR__] = ACTIONS(3057),
    [anon_sym___VERSION__] = ACTIONS(3057),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3059),
    [sym_float_literal] = ACTIONS(3059),
    [sym__string] = ACTIONS(3059),
  },
  [635] = {
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_q_LBRACE] = ACTIONS(3107),
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3105),
    [anon_sym_SLASH_EQ] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3105),
    [anon_sym_DOT_DOT] = ACTIONS(3105),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_AMP_EQ] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_PIPE] = ACTIONS(3105),
    [anon_sym_PIPE_EQ] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_DASH_EQ] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_PLUS_EQ] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_LT_EQ] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_LT_LT_EQ] = ACTIONS(3107),
    [anon_sym_GT] = ACTIONS(3105),
    [anon_sym_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT] = ACTIONS(3105),
    [anon_sym_GT_GT_GT] = ACTIONS(3105),
    [anon_sym_BANG] = ACTIONS(3105),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_RBRACK] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_EQ_EQ] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_STAR_EQ] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_PERCENT_EQ] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_CARET_EQ] = ACTIONS(3107),
    [anon_sym_CARET_CARET] = ACTIONS(3105),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_TILDE_EQ] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [anon_sym_EQ_GT] = ACTIONS(3107),
    [anon_sym_POUND] = ACTIONS(3107),
    [sym_bool] = ACTIONS(3105),
    [sym_byte] = ACTIONS(3105),
    [sym_ubyte] = ACTIONS(3105),
    [sym_char] = ACTIONS(3105),
    [sym_short] = ACTIONS(3105),
    [sym_ushort] = ACTIONS(3105),
    [sym_int] = ACTIONS(3105),
    [sym_uint] = ACTIONS(3105),
    [sym_long] = ACTIONS(3105),
    [sym_ulong] = ACTIONS(3105),
    [sym_cent] = ACTIONS(3105),
    [sym_ucent] = ACTIONS(3105),
    [sym_wchar] = ACTIONS(3105),
    [sym_dchar] = ACTIONS(3105),
    [sym_float] = ACTIONS(3105),
    [sym_double] = ACTIONS(3105),
    [sym_real] = ACTIONS(3105),
    [sym_ifloat] = ACTIONS(3105),
    [sym_idouble] = ACTIONS(3105),
    [sym_ireal] = ACTIONS(3105),
    [sym_cfloat] = ACTIONS(3105),
    [sym_cdouble] = ACTIONS(3105),
    [sym_creal] = ACTIONS(3105),
    [sym_size_t] = ACTIONS(3105),
    [sym_ptrdiff_t] = ACTIONS(3105),
    [sym_string] = ACTIONS(3105),
    [sym_cstring] = ACTIONS(3105),
    [sym_dstring] = ACTIONS(3105),
    [sym_wstring] = ACTIONS(3105),
    [sym_noreturn] = ACTIONS(3105),
    [sym_true] = ACTIONS(3105),
    [sym_false] = ACTIONS(3105),
    [sym_null] = ACTIONS(3105),
    [sym_super] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
    [sym_abstract] = ACTIONS(3105),
    [sym_alias] = ACTIONS(3105),
    [sym_align] = ACTIONS(3105),
    [sym_asm] = ACTIONS(3105),
    [sym_assert] = ACTIONS(3105),
    [sym_auto] = ACTIONS(3105),
    [sym_break] = ACTIONS(3105),
    [sym_case] = ACTIONS(3105),
    [sym_cast] = ACTIONS(3105),
    [sym_catch] = ACTIONS(3105),
    [sym_class] = ACTIONS(3105),
    [sym_const] = ACTIONS(3105),
    [sym_continue] = ACTIONS(3105),
    [sym_debug] = ACTIONS(3105),
    [sym_default] = ACTIONS(3105),
    [sym_delegate] = ACTIONS(3105),
    [sym_delete] = ACTIONS(3105),
    [sym_deprecated] = ACTIONS(3105),
    [sym_do] = ACTIONS(3105),
    [sym_else] = ACTIONS(3105),
    [sym_enum] = ACTIONS(3105),
    [sym_export] = ACTIONS(3105),
    [sym_extern] = ACTIONS(3105),
    [sym_final] = ACTIONS(3105),
    [sym_finally] = ACTIONS(3105),
    [sym_for] = ACTIONS(3105),
    [sym_foreach] = ACTIONS(3105),
    [sym_foreach_reverse] = ACTIONS(3105),
    [sym_function] = ACTIONS(3105),
    [sym_goto] = ACTIONS(3105),
    [sym_if] = ACTIONS(3105),
    [sym_immutable] = ACTIONS(3105),
    [sym_import] = ACTIONS(3105),
    [sym_in] = ACTIONS(3105),
    [sym_inout] = ACTIONS(3105),
    [sym_interface] = ACTIONS(3105),
    [sym_invariant] = ACTIONS(3105),
    [sym_is] = ACTIONS(3105),
    [sym_lazy] = ACTIONS(3105),
    [sym_mixin] = ACTIONS(3105),
    [sym_module] = ACTIONS(3105),
    [sym_new] = ACTIONS(3105),
    [sym_nothrow] = ACTIONS(3105),
    [sym_out] = ACTIONS(3105),
    [sym_override] = ACTIONS(3105),
    [sym_package] = ACTIONS(3105),
    [sym_pragma] = ACTIONS(3105),
    [sym_private] = ACTIONS(3105),
    [sym_protected] = ACTIONS(3105),
    [sym_public] = ACTIONS(3105),
    [sym_pure] = ACTIONS(3105),
    [sym_ref] = ACTIONS(3105),
    [sym_return] = ACTIONS(3105),
    [sym_scope] = ACTIONS(3105),
    [sym_shared] = ACTIONS(3105),
    [sym_static] = ACTIONS(3105),
    [sym_struct] = ACTIONS(3105),
    [sym_switch] = ACTIONS(3105),
    [sym_synchronized] = ACTIONS(3105),
    [sym_template] = ACTIONS(3105),
    [sym_throw] = ACTIONS(3105),
    [sym_try] = ACTIONS(3105),
    [sym_typeid] = ACTIONS(3105),
    [sym_typeof] = ACTIONS(3105),
    [sym_union] = ACTIONS(3105),
    [sym_unittest] = ACTIONS(3105),
    [sym_version] = ACTIONS(3105),
    [sym_while] = ACTIONS(3105),
    [sym_with] = ACTIONS(3105),
    [sym_parameters_] = ACTIONS(3105),
    [sym_gshared] = ACTIONS(3105),
    [sym_traits] = ACTIONS(3105),
    [sym_vector] = ACTIONS(3105),
    [sym_void] = ACTIONS(3105),
    [anon_sym_BQUOTE] = ACTIONS(3107),
    [anon_sym_r_DQUOTE] = ACTIONS(3107),
    [anon_sym_x_DQUOTE] = ACTIONS(3107),
    [anon_sym_DQUOTE] = ACTIONS(3107),
    [anon_sym_i_BQUOTE] = ACTIONS(3107),
    [anon_sym_i_DQUOTE] = ACTIONS(3107),
    [anon_sym_iq_LBRACE] = ACTIONS(3107),
    [aux_sym_char_literal_token1] = ACTIONS(3107),
    [anon_sym_SQUOTE] = ACTIONS(3105),
    [anon_sym___DATE__] = ACTIONS(3105),
    [anon_sym___FILE__] = ACTIONS(3105),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3105),
    [anon_sym___FUNCTION__] = ACTIONS(3105),
    [anon_sym___LINE__] = ACTIONS(3105),
    [anon_sym___MODULE__] = ACTIONS(3105),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3105),
    [anon_sym___TIME__] = ACTIONS(3105),
    [anon_sym___TIMESTAMP__] = ACTIONS(3105),
    [anon_sym___VENDOR__] = ACTIONS(3105),
    [anon_sym___VERSION__] = ACTIONS(3105),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3107),
    [sym_float_literal] = ACTIONS(3107),
    [sym__string] = ACTIONS(3107),
  },
  [636] = {
    [sym_identifier] = ACTIONS(3109),
    [anon_sym_q_LBRACE] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_SLASH] = ACTIONS(3109),
    [anon_sym_SLASH_EQ] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3109),
    [anon_sym_DOT_DOT] = ACTIONS(3109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_AMP_EQ] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_PIPE] = ACTIONS(3109),
    [anon_sym_PIPE_EQ] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_DASH_EQ] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_PLUS_EQ] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_LT_EQ] = ACTIONS(3111),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [anon_sym_LT_LT_EQ] = ACTIONS(3111),
    [anon_sym_GT] = ACTIONS(3109),
    [anon_sym_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_GT_GT_GT] = ACTIONS(3109),
    [anon_sym_BANG] = ACTIONS(3109),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_RBRACK] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_DOLLAR] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_EQ_EQ] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_STAR_EQ] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3109),
    [anon_sym_PERCENT_EQ] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3109),
    [anon_sym_CARET_EQ] = ACTIONS(3111),
    [anon_sym_CARET_CARET] = ACTIONS(3109),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_TILDE_EQ] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(3111),
    [anon_sym_EQ_GT] = ACTIONS(3111),
    [anon_sym_POUND] = ACTIONS(3111),
    [sym_bool] = ACTIONS(3109),
    [sym_byte] = ACTIONS(3109),
    [sym_ubyte] = ACTIONS(3109),
    [sym_char] = ACTIONS(3109),
    [sym_short] = ACTIONS(3109),
    [sym_ushort] = ACTIONS(3109),
    [sym_int] = ACTIONS(3109),
    [sym_uint] = ACTIONS(3109),
    [sym_long] = ACTIONS(3109),
    [sym_ulong] = ACTIONS(3109),
    [sym_cent] = ACTIONS(3109),
    [sym_ucent] = ACTIONS(3109),
    [sym_wchar] = ACTIONS(3109),
    [sym_dchar] = ACTIONS(3109),
    [sym_float] = ACTIONS(3109),
    [sym_double] = ACTIONS(3109),
    [sym_real] = ACTIONS(3109),
    [sym_ifloat] = ACTIONS(3109),
    [sym_idouble] = ACTIONS(3109),
    [sym_ireal] = ACTIONS(3109),
    [sym_cfloat] = ACTIONS(3109),
    [sym_cdouble] = ACTIONS(3109),
    [sym_creal] = ACTIONS(3109),
    [sym_size_t] = ACTIONS(3109),
    [sym_ptrdiff_t] = ACTIONS(3109),
    [sym_string] = ACTIONS(3109),
    [sym_cstring] = ACTIONS(3109),
    [sym_dstring] = ACTIONS(3109),
    [sym_wstring] = ACTIONS(3109),
    [sym_noreturn] = ACTIONS(3109),
    [sym_true] = ACTIONS(3109),
    [sym_false] = ACTIONS(3109),
    [sym_null] = ACTIONS(3109),
    [sym_super] = ACTIONS(3109),
    [sym_this] = ACTIONS(3109),
    [sym_abstract] = ACTIONS(3109),
    [sym_alias] = ACTIONS(3109),
    [sym_align] = ACTIONS(3109),
    [sym_asm] = ACTIONS(3109),
    [sym_assert] = ACTIONS(3109),
    [sym_auto] = ACTIONS(3109),
    [sym_break] = ACTIONS(3109),
    [sym_case] = ACTIONS(3109),
    [sym_cast] = ACTIONS(3109),
    [sym_catch] = ACTIONS(3109),
    [sym_class] = ACTIONS(3109),
    [sym_const] = ACTIONS(3109),
    [sym_continue] = ACTIONS(3109),
    [sym_debug] = ACTIONS(3109),
    [sym_default] = ACTIONS(3109),
    [sym_delegate] = ACTIONS(3109),
    [sym_delete] = ACTIONS(3109),
    [sym_deprecated] = ACTIONS(3109),
    [sym_do] = ACTIONS(3109),
    [sym_else] = ACTIONS(3109),
    [sym_enum] = ACTIONS(3109),
    [sym_export] = ACTIONS(3109),
    [sym_extern] = ACTIONS(3109),
    [sym_final] = ACTIONS(3109),
    [sym_finally] = ACTIONS(3109),
    [sym_for] = ACTIONS(3109),
    [sym_foreach] = ACTIONS(3109),
    [sym_foreach_reverse] = ACTIONS(3109),
    [sym_function] = ACTIONS(3109),
    [sym_goto] = ACTIONS(3109),
    [sym_if] = ACTIONS(3109),
    [sym_immutable] = ACTIONS(3109),
    [sym_import] = ACTIONS(3109),
    [sym_in] = ACTIONS(3109),
    [sym_inout] = ACTIONS(3109),
    [sym_interface] = ACTIONS(3109),
    [sym_invariant] = ACTIONS(3109),
    [sym_is] = ACTIONS(3109),
    [sym_lazy] = ACTIONS(3109),
    [sym_mixin] = ACTIONS(3109),
    [sym_module] = ACTIONS(3109),
    [sym_new] = ACTIONS(3109),
    [sym_nothrow] = ACTIONS(3109),
    [sym_out] = ACTIONS(3109),
    [sym_override] = ACTIONS(3109),
    [sym_package] = ACTIONS(3109),
    [sym_pragma] = ACTIONS(3109),
    [sym_private] = ACTIONS(3109),
    [sym_protected] = ACTIONS(3109),
    [sym_public] = ACTIONS(3109),
    [sym_pure] = ACTIONS(3109),
    [sym_ref] = ACTIONS(3109),
    [sym_return] = ACTIONS(3109),
    [sym_scope] = ACTIONS(3109),
    [sym_shared] = ACTIONS(3109),
    [sym_static] = ACTIONS(3109),
    [sym_struct] = ACTIONS(3109),
    [sym_switch] = ACTIONS(3109),
    [sym_synchronized] = ACTIONS(3109),
    [sym_template] = ACTIONS(3109),
    [sym_throw] = ACTIONS(3109),
    [sym_try] = ACTIONS(3109),
    [sym_typeid] = ACTIONS(3109),
    [sym_typeof] = ACTIONS(3109),
    [sym_union] = ACTIONS(3109),
    [sym_unittest] = ACTIONS(3109),
    [sym_version] = ACTIONS(3109),
    [sym_while] = ACTIONS(3109),
    [sym_with] = ACTIONS(3109),
    [sym_parameters_] = ACTIONS(3109),
    [sym_gshared] = ACTIONS(3109),
    [sym_traits] = ACTIONS(3109),
    [sym_vector] = ACTIONS(3109),
    [sym_void] = ACTIONS(3109),
    [anon_sym_BQUOTE] = ACTIONS(3111),
    [anon_sym_r_DQUOTE] = ACTIONS(3111),
    [anon_sym_x_DQUOTE] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(3111),
    [anon_sym_i_BQUOTE] = ACTIONS(3111),
    [anon_sym_i_DQUOTE] = ACTIONS(3111),
    [anon_sym_iq_LBRACE] = ACTIONS(3111),
    [aux_sym_char_literal_token1] = ACTIONS(3111),
    [anon_sym_SQUOTE] = ACTIONS(3109),
    [anon_sym___DATE__] = ACTIONS(3109),
    [anon_sym___FILE__] = ACTIONS(3109),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3109),
    [anon_sym___FUNCTION__] = ACTIONS(3109),
    [anon_sym___LINE__] = ACTIONS(3109),
    [anon_sym___MODULE__] = ACTIONS(3109),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3109),
    [anon_sym___TIME__] = ACTIONS(3109),
    [anon_sym___TIMESTAMP__] = ACTIONS(3109),
    [anon_sym___VENDOR__] = ACTIONS(3109),
    [anon_sym___VERSION__] = ACTIONS(3109),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3111),
    [sym_float_literal] = ACTIONS(3111),
    [sym__string] = ACTIONS(3111),
  },
  [637] = {
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_q_LBRACE] = ACTIONS(3119),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3117),
    [anon_sym_DOT_DOT] = ACTIONS(3117),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3119),
    [anon_sym_DASH_DASH] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT] = ACTIONS(3117),
    [anon_sym_GT_GT_GT] = ACTIONS(3117),
    [anon_sym_BANG] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_DOLLAR] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3119),
    [anon_sym_CARET_CARET] = ACTIONS(3117),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_TILDE_EQ] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [anon_sym_EQ_GT] = ACTIONS(3119),
    [anon_sym_POUND] = ACTIONS(3119),
    [sym_bool] = ACTIONS(3117),
    [sym_byte] = ACTIONS(3117),
    [sym_ubyte] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_short] = ACTIONS(3117),
    [sym_ushort] = ACTIONS(3117),
    [sym_int] = ACTIONS(3117),
    [sym_uint] = ACTIONS(3117),
    [sym_long] = ACTIONS(3117),
    [sym_ulong] = ACTIONS(3117),
    [sym_cent] = ACTIONS(3117),
    [sym_ucent] = ACTIONS(3117),
    [sym_wchar] = ACTIONS(3117),
    [sym_dchar] = ACTIONS(3117),
    [sym_float] = ACTIONS(3117),
    [sym_double] = ACTIONS(3117),
    [sym_real] = ACTIONS(3117),
    [sym_ifloat] = ACTIONS(3117),
    [sym_idouble] = ACTIONS(3117),
    [sym_ireal] = ACTIONS(3117),
    [sym_cfloat] = ACTIONS(3117),
    [sym_cdouble] = ACTIONS(3117),
    [sym_creal] = ACTIONS(3117),
    [sym_size_t] = ACTIONS(3117),
    [sym_ptrdiff_t] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym_cstring] = ACTIONS(3117),
    [sym_dstring] = ACTIONS(3117),
    [sym_wstring] = ACTIONS(3117),
    [sym_noreturn] = ACTIONS(3117),
    [sym_true] = ACTIONS(3117),
    [sym_false] = ACTIONS(3117),
    [sym_null] = ACTIONS(3117),
    [sym_super] = ACTIONS(3117),
    [sym_this] = ACTIONS(3117),
    [sym_abstract] = ACTIONS(3117),
    [sym_alias] = ACTIONS(3117),
    [sym_align] = ACTIONS(3117),
    [sym_asm] = ACTIONS(3117),
    [sym_assert] = ACTIONS(3117),
    [sym_auto] = ACTIONS(3117),
    [sym_break] = ACTIONS(3117),
    [sym_case] = ACTIONS(3117),
    [sym_cast] = ACTIONS(3117),
    [sym_catch] = ACTIONS(3117),
    [sym_class] = ACTIONS(3117),
    [sym_const] = ACTIONS(3117),
    [sym_continue] = ACTIONS(3117),
    [sym_debug] = ACTIONS(3117),
    [sym_default] = ACTIONS(3117),
    [sym_delegate] = ACTIONS(3117),
    [sym_delete] = ACTIONS(3117),
    [sym_deprecated] = ACTIONS(3117),
    [sym_do] = ACTIONS(3117),
    [sym_else] = ACTIONS(3117),
    [sym_enum] = ACTIONS(3117),
    [sym_export] = ACTIONS(3117),
    [sym_extern] = ACTIONS(3117),
    [sym_final] = ACTIONS(3117),
    [sym_finally] = ACTIONS(3117),
    [sym_for] = ACTIONS(3117),
    [sym_foreach] = ACTIONS(3117),
    [sym_foreach_reverse] = ACTIONS(3117),
    [sym_function] = ACTIONS(3117),
    [sym_goto] = ACTIONS(3117),
    [sym_if] = ACTIONS(3117),
    [sym_immutable] = ACTIONS(3117),
    [sym_import] = ACTIONS(3117),
    [sym_in] = ACTIONS(3117),
    [sym_inout] = ACTIONS(3117),
    [sym_interface] = ACTIONS(3117),
    [sym_invariant] = ACTIONS(3117),
    [sym_is] = ACTIONS(3117),
    [sym_lazy] = ACTIONS(3117),
    [sym_mixin] = ACTIONS(3117),
    [sym_module] = ACTIONS(3117),
    [sym_new] = ACTIONS(3117),
    [sym_nothrow] = ACTIONS(3117),
    [sym_out] = ACTIONS(3117),
    [sym_override] = ACTIONS(3117),
    [sym_package] = ACTIONS(3117),
    [sym_pragma] = ACTIONS(3117),
    [sym_private] = ACTIONS(3117),
    [sym_protected] = ACTIONS(3117),
    [sym_public] = ACTIONS(3117),
    [sym_pure] = ACTIONS(3117),
    [sym_ref] = ACTIONS(3117),
    [sym_return] = ACTIONS(3117),
    [sym_scope] = ACTIONS(3117),
    [sym_shared] = ACTIONS(3117),
    [sym_static] = ACTIONS(3117),
    [sym_struct] = ACTIONS(3117),
    [sym_switch] = ACTIONS(3117),
    [sym_synchronized] = ACTIONS(3117),
    [sym_template] = ACTIONS(3117),
    [sym_throw] = ACTIONS(3117),
    [sym_try] = ACTIONS(3117),
    [sym_typeid] = ACTIONS(3117),
    [sym_typeof] = ACTIONS(3117),
    [sym_union] = ACTIONS(3117),
    [sym_unittest] = ACTIONS(3117),
    [sym_version] = ACTIONS(3117),
    [sym_while] = ACTIONS(3117),
    [sym_with] = ACTIONS(3117),
    [sym_parameters_] = ACTIONS(3117),
    [sym_gshared] = ACTIONS(3117),
    [sym_traits] = ACTIONS(3117),
    [sym_vector] = ACTIONS(3117),
    [sym_void] = ACTIONS(3117),
    [anon_sym_BQUOTE] = ACTIONS(3119),
    [anon_sym_r_DQUOTE] = ACTIONS(3119),
    [anon_sym_x_DQUOTE] = ACTIONS(3119),
    [anon_sym_DQUOTE] = ACTIONS(3119),
    [anon_sym_i_BQUOTE] = ACTIONS(3119),
    [anon_sym_i_DQUOTE] = ACTIONS(3119),
    [anon_sym_iq_LBRACE] = ACTIONS(3119),
    [aux_sym_char_literal_token1] = ACTIONS(3119),
    [anon_sym_SQUOTE] = ACTIONS(3117),
    [anon_sym___DATE__] = ACTIONS(3117),
    [anon_sym___FILE__] = ACTIONS(3117),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3117),
    [anon_sym___FUNCTION__] = ACTIONS(3117),
    [anon_sym___LINE__] = ACTIONS(3117),
    [anon_sym___MODULE__] = ACTIONS(3117),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3117),
    [anon_sym___TIME__] = ACTIONS(3117),
    [anon_sym___TIMESTAMP__] = ACTIONS(3117),
    [anon_sym___VENDOR__] = ACTIONS(3117),
    [anon_sym___VERSION__] = ACTIONS(3117),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3119),
    [sym_float_literal] = ACTIONS(3119),
    [sym__string] = ACTIONS(3119),
  },
  [638] = {
    [sym_identifier] = ACTIONS(3089),
    [anon_sym_q_LBRACE] = ACTIONS(3091),
    [anon_sym_RBRACE] = ACTIONS(3091),
    [anon_sym_LBRACE] = ACTIONS(3091),
    [anon_sym_SLASH] = ACTIONS(3089),
    [anon_sym_SLASH_EQ] = ACTIONS(3091),
    [anon_sym_DOT] = ACTIONS(3089),
    [anon_sym_DOT_DOT] = ACTIONS(3089),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3091),
    [anon_sym_AMP] = ACTIONS(3089),
    [anon_sym_AMP_EQ] = ACTIONS(3091),
    [anon_sym_AMP_AMP] = ACTIONS(3091),
    [anon_sym_PIPE] = ACTIONS(3089),
    [anon_sym_PIPE_EQ] = ACTIONS(3091),
    [anon_sym_PIPE_PIPE] = ACTIONS(3091),
    [anon_sym_DASH] = ACTIONS(3089),
    [anon_sym_DASH_EQ] = ACTIONS(3091),
    [anon_sym_DASH_DASH] = ACTIONS(3091),
    [anon_sym_PLUS] = ACTIONS(3089),
    [anon_sym_PLUS_EQ] = ACTIONS(3091),
    [anon_sym_PLUS_PLUS] = ACTIONS(3091),
    [anon_sym_LT] = ACTIONS(3089),
    [anon_sym_LT_EQ] = ACTIONS(3091),
    [anon_sym_LT_LT] = ACTIONS(3089),
    [anon_sym_LT_LT_EQ] = ACTIONS(3091),
    [anon_sym_GT] = ACTIONS(3089),
    [anon_sym_GT_EQ] = ACTIONS(3091),
    [anon_sym_GT_GT_EQ] = ACTIONS(3091),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3091),
    [anon_sym_GT_GT] = ACTIONS(3089),
    [anon_sym_GT_GT_GT] = ACTIONS(3089),
    [anon_sym_BANG] = ACTIONS(3089),
    [anon_sym_BANG_EQ] = ACTIONS(3091),
    [anon_sym_LPAREN] = ACTIONS(3091),
    [anon_sym_RPAREN] = ACTIONS(3091),
    [anon_sym_LBRACK] = ACTIONS(3091),
    [anon_sym_RBRACK] = ACTIONS(3091),
    [anon_sym_QMARK] = ACTIONS(3091),
    [anon_sym_COMMA] = ACTIONS(3091),
    [anon_sym_SEMI] = ACTIONS(3091),
    [anon_sym_COLON] = ACTIONS(3091),
    [anon_sym_DOLLAR] = ACTIONS(3091),
    [anon_sym_EQ] = ACTIONS(3089),
    [anon_sym_EQ_EQ] = ACTIONS(3091),
    [anon_sym_STAR] = ACTIONS(3089),
    [anon_sym_STAR_EQ] = ACTIONS(3091),
    [anon_sym_PERCENT] = ACTIONS(3089),
    [anon_sym_PERCENT_EQ] = ACTIONS(3091),
    [anon_sym_CARET] = ACTIONS(3089),
    [anon_sym_CARET_EQ] = ACTIONS(3091),
    [anon_sym_CARET_CARET] = ACTIONS(3089),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3091),
    [anon_sym_TILDE] = ACTIONS(3089),
    [anon_sym_TILDE_EQ] = ACTIONS(3091),
    [anon_sym_AT] = ACTIONS(3091),
    [anon_sym_EQ_GT] = ACTIONS(3091),
    [anon_sym_POUND] = ACTIONS(3091),
    [sym_bool] = ACTIONS(3089),
    [sym_byte] = ACTIONS(3089),
    [sym_ubyte] = ACTIONS(3089),
    [sym_char] = ACTIONS(3089),
    [sym_short] = ACTIONS(3089),
    [sym_ushort] = ACTIONS(3089),
    [sym_int] = ACTIONS(3089),
    [sym_uint] = ACTIONS(3089),
    [sym_long] = ACTIONS(3089),
    [sym_ulong] = ACTIONS(3089),
    [sym_cent] = ACTIONS(3089),
    [sym_ucent] = ACTIONS(3089),
    [sym_wchar] = ACTIONS(3089),
    [sym_dchar] = ACTIONS(3089),
    [sym_float] = ACTIONS(3089),
    [sym_double] = ACTIONS(3089),
    [sym_real] = ACTIONS(3089),
    [sym_ifloat] = ACTIONS(3089),
    [sym_idouble] = ACTIONS(3089),
    [sym_ireal] = ACTIONS(3089),
    [sym_cfloat] = ACTIONS(3089),
    [sym_cdouble] = ACTIONS(3089),
    [sym_creal] = ACTIONS(3089),
    [sym_size_t] = ACTIONS(3089),
    [sym_ptrdiff_t] = ACTIONS(3089),
    [sym_string] = ACTIONS(3089),
    [sym_cstring] = ACTIONS(3089),
    [sym_dstring] = ACTIONS(3089),
    [sym_wstring] = ACTIONS(3089),
    [sym_noreturn] = ACTIONS(3089),
    [sym_true] = ACTIONS(3089),
    [sym_false] = ACTIONS(3089),
    [sym_null] = ACTIONS(3089),
    [sym_super] = ACTIONS(3089),
    [sym_this] = ACTIONS(3089),
    [sym_abstract] = ACTIONS(3089),
    [sym_alias] = ACTIONS(3089),
    [sym_align] = ACTIONS(3089),
    [sym_asm] = ACTIONS(3089),
    [sym_assert] = ACTIONS(3089),
    [sym_auto] = ACTIONS(3089),
    [sym_break] = ACTIONS(3089),
    [sym_case] = ACTIONS(3089),
    [sym_cast] = ACTIONS(3089),
    [sym_catch] = ACTIONS(3089),
    [sym_class] = ACTIONS(3089),
    [sym_const] = ACTIONS(3089),
    [sym_continue] = ACTIONS(3089),
    [sym_debug] = ACTIONS(3089),
    [sym_default] = ACTIONS(3089),
    [sym_delegate] = ACTIONS(3089),
    [sym_delete] = ACTIONS(3089),
    [sym_deprecated] = ACTIONS(3089),
    [sym_do] = ACTIONS(3089),
    [sym_else] = ACTIONS(3089),
    [sym_enum] = ACTIONS(3089),
    [sym_export] = ACTIONS(3089),
    [sym_extern] = ACTIONS(3089),
    [sym_final] = ACTIONS(3089),
    [sym_finally] = ACTIONS(3089),
    [sym_for] = ACTIONS(3089),
    [sym_foreach] = ACTIONS(3089),
    [sym_foreach_reverse] = ACTIONS(3089),
    [sym_function] = ACTIONS(3089),
    [sym_goto] = ACTIONS(3089),
    [sym_if] = ACTIONS(3089),
    [sym_immutable] = ACTIONS(3089),
    [sym_import] = ACTIONS(3089),
    [sym_in] = ACTIONS(3089),
    [sym_inout] = ACTIONS(3089),
    [sym_interface] = ACTIONS(3089),
    [sym_invariant] = ACTIONS(3089),
    [sym_is] = ACTIONS(3089),
    [sym_lazy] = ACTIONS(3089),
    [sym_mixin] = ACTIONS(3089),
    [sym_module] = ACTIONS(3089),
    [sym_new] = ACTIONS(3089),
    [sym_nothrow] = ACTIONS(3089),
    [sym_out] = ACTIONS(3089),
    [sym_override] = ACTIONS(3089),
    [sym_package] = ACTIONS(3089),
    [sym_pragma] = ACTIONS(3089),
    [sym_private] = ACTIONS(3089),
    [sym_protected] = ACTIONS(3089),
    [sym_public] = ACTIONS(3089),
    [sym_pure] = ACTIONS(3089),
    [sym_ref] = ACTIONS(3089),
    [sym_return] = ACTIONS(3089),
    [sym_scope] = ACTIONS(3089),
    [sym_shared] = ACTIONS(3089),
    [sym_static] = ACTIONS(3089),
    [sym_struct] = ACTIONS(3089),
    [sym_switch] = ACTIONS(3089),
    [sym_synchronized] = ACTIONS(3089),
    [sym_template] = ACTIONS(3089),
    [sym_throw] = ACTIONS(3089),
    [sym_try] = ACTIONS(3089),
    [sym_typeid] = ACTIONS(3089),
    [sym_typeof] = ACTIONS(3089),
    [sym_union] = ACTIONS(3089),
    [sym_unittest] = ACTIONS(3089),
    [sym_version] = ACTIONS(3089),
    [sym_while] = ACTIONS(3089),
    [sym_with] = ACTIONS(3089),
    [sym_parameters_] = ACTIONS(3089),
    [sym_gshared] = ACTIONS(3089),
    [sym_traits] = ACTIONS(3089),
    [sym_vector] = ACTIONS(3089),
    [sym_void] = ACTIONS(3089),
    [anon_sym_BQUOTE] = ACTIONS(3091),
    [anon_sym_r_DQUOTE] = ACTIONS(3091),
    [anon_sym_x_DQUOTE] = ACTIONS(3091),
    [anon_sym_DQUOTE] = ACTIONS(3091),
    [anon_sym_i_BQUOTE] = ACTIONS(3091),
    [anon_sym_i_DQUOTE] = ACTIONS(3091),
    [anon_sym_iq_LBRACE] = ACTIONS(3091),
    [aux_sym_char_literal_token1] = ACTIONS(3091),
    [anon_sym_SQUOTE] = ACTIONS(3089),
    [anon_sym___DATE__] = ACTIONS(3089),
    [anon_sym___FILE__] = ACTIONS(3089),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3089),
    [anon_sym___FUNCTION__] = ACTIONS(3089),
    [anon_sym___LINE__] = ACTIONS(3089),
    [anon_sym___MODULE__] = ACTIONS(3089),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3089),
    [anon_sym___TIME__] = ACTIONS(3089),
    [anon_sym___TIMESTAMP__] = ACTIONS(3089),
    [anon_sym___VENDOR__] = ACTIONS(3089),
    [anon_sym___VERSION__] = ACTIONS(3089),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3091),
    [sym_float_literal] = ACTIONS(3091),
    [sym__string] = ACTIONS(3091),
  },
  [639] = {
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_q_LBRACE] = ACTIONS(3087),
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3085),
    [anon_sym_DOT_DOT] = ACTIONS(3085),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_GT_GT_GT] = ACTIONS(3085),
    [anon_sym_BANG] = ACTIONS(3085),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_DOLLAR] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_CARET_CARET] = ACTIONS(3085),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_TILDE_EQ] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3087),
    [anon_sym_EQ_GT] = ACTIONS(3087),
    [anon_sym_POUND] = ACTIONS(3087),
    [sym_bool] = ACTIONS(3085),
    [sym_byte] = ACTIONS(3085),
    [sym_ubyte] = ACTIONS(3085),
    [sym_char] = ACTIONS(3085),
    [sym_short] = ACTIONS(3085),
    [sym_ushort] = ACTIONS(3085),
    [sym_int] = ACTIONS(3085),
    [sym_uint] = ACTIONS(3085),
    [sym_long] = ACTIONS(3085),
    [sym_ulong] = ACTIONS(3085),
    [sym_cent] = ACTIONS(3085),
    [sym_ucent] = ACTIONS(3085),
    [sym_wchar] = ACTIONS(3085),
    [sym_dchar] = ACTIONS(3085),
    [sym_float] = ACTIONS(3085),
    [sym_double] = ACTIONS(3085),
    [sym_real] = ACTIONS(3085),
    [sym_ifloat] = ACTIONS(3085),
    [sym_idouble] = ACTIONS(3085),
    [sym_ireal] = ACTIONS(3085),
    [sym_cfloat] = ACTIONS(3085),
    [sym_cdouble] = ACTIONS(3085),
    [sym_creal] = ACTIONS(3085),
    [sym_size_t] = ACTIONS(3085),
    [sym_ptrdiff_t] = ACTIONS(3085),
    [sym_string] = ACTIONS(3085),
    [sym_cstring] = ACTIONS(3085),
    [sym_dstring] = ACTIONS(3085),
    [sym_wstring] = ACTIONS(3085),
    [sym_noreturn] = ACTIONS(3085),
    [sym_true] = ACTIONS(3085),
    [sym_false] = ACTIONS(3085),
    [sym_null] = ACTIONS(3085),
    [sym_super] = ACTIONS(3085),
    [sym_this] = ACTIONS(3085),
    [sym_abstract] = ACTIONS(3085),
    [sym_alias] = ACTIONS(3085),
    [sym_align] = ACTIONS(3085),
    [sym_asm] = ACTIONS(3085),
    [sym_assert] = ACTIONS(3085),
    [sym_auto] = ACTIONS(3085),
    [sym_break] = ACTIONS(3085),
    [sym_case] = ACTIONS(3085),
    [sym_cast] = ACTIONS(3085),
    [sym_catch] = ACTIONS(3085),
    [sym_class] = ACTIONS(3085),
    [sym_const] = ACTIONS(3085),
    [sym_continue] = ACTIONS(3085),
    [sym_debug] = ACTIONS(3085),
    [sym_default] = ACTIONS(3085),
    [sym_delegate] = ACTIONS(3085),
    [sym_delete] = ACTIONS(3085),
    [sym_deprecated] = ACTIONS(3085),
    [sym_do] = ACTIONS(3085),
    [sym_else] = ACTIONS(3085),
    [sym_enum] = ACTIONS(3085),
    [sym_export] = ACTIONS(3085),
    [sym_extern] = ACTIONS(3085),
    [sym_final] = ACTIONS(3085),
    [sym_finally] = ACTIONS(3085),
    [sym_for] = ACTIONS(3085),
    [sym_foreach] = ACTIONS(3085),
    [sym_foreach_reverse] = ACTIONS(3085),
    [sym_function] = ACTIONS(3085),
    [sym_goto] = ACTIONS(3085),
    [sym_if] = ACTIONS(3085),
    [sym_immutable] = ACTIONS(3085),
    [sym_import] = ACTIONS(3085),
    [sym_in] = ACTIONS(3085),
    [sym_inout] = ACTIONS(3085),
    [sym_interface] = ACTIONS(3085),
    [sym_invariant] = ACTIONS(3085),
    [sym_is] = ACTIONS(3085),
    [sym_lazy] = ACTIONS(3085),
    [sym_mixin] = ACTIONS(3085),
    [sym_module] = ACTIONS(3085),
    [sym_new] = ACTIONS(3085),
    [sym_nothrow] = ACTIONS(3085),
    [sym_out] = ACTIONS(3085),
    [sym_override] = ACTIONS(3085),
    [sym_package] = ACTIONS(3085),
    [sym_pragma] = ACTIONS(3085),
    [sym_private] = ACTIONS(3085),
    [sym_protected] = ACTIONS(3085),
    [sym_public] = ACTIONS(3085),
    [sym_pure] = ACTIONS(3085),
    [sym_ref] = ACTIONS(3085),
    [sym_return] = ACTIONS(3085),
    [sym_scope] = ACTIONS(3085),
    [sym_shared] = ACTIONS(3085),
    [sym_static] = ACTIONS(3085),
    [sym_struct] = ACTIONS(3085),
    [sym_switch] = ACTIONS(3085),
    [sym_synchronized] = ACTIONS(3085),
    [sym_template] = ACTIONS(3085),
    [sym_throw] = ACTIONS(3085),
    [sym_try] = ACTIONS(3085),
    [sym_typeid] = ACTIONS(3085),
    [sym_typeof] = ACTIONS(3085),
    [sym_union] = ACTIONS(3085),
    [sym_unittest] = ACTIONS(3085),
    [sym_version] = ACTIONS(3085),
    [sym_while] = ACTIONS(3085),
    [sym_with] = ACTIONS(3085),
    [sym_parameters_] = ACTIONS(3085),
    [sym_gshared] = ACTIONS(3085),
    [sym_traits] = ACTIONS(3085),
    [sym_vector] = ACTIONS(3085),
    [sym_void] = ACTIONS(3085),
    [anon_sym_BQUOTE] = ACTIONS(3087),
    [anon_sym_r_DQUOTE] = ACTIONS(3087),
    [anon_sym_x_DQUOTE] = ACTIONS(3087),
    [anon_sym_DQUOTE] = ACTIONS(3087),
    [anon_sym_i_BQUOTE] = ACTIONS(3087),
    [anon_sym_i_DQUOTE] = ACTIONS(3087),
    [anon_sym_iq_LBRACE] = ACTIONS(3087),
    [aux_sym_char_literal_token1] = ACTIONS(3087),
    [anon_sym_SQUOTE] = ACTIONS(3085),
    [anon_sym___DATE__] = ACTIONS(3085),
    [anon_sym___FILE__] = ACTIONS(3085),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3085),
    [anon_sym___FUNCTION__] = ACTIONS(3085),
    [anon_sym___LINE__] = ACTIONS(3085),
    [anon_sym___MODULE__] = ACTIONS(3085),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3085),
    [anon_sym___TIME__] = ACTIONS(3085),
    [anon_sym___TIMESTAMP__] = ACTIONS(3085),
    [anon_sym___VENDOR__] = ACTIONS(3085),
    [anon_sym___VERSION__] = ACTIONS(3085),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3087),
    [sym_float_literal] = ACTIONS(3087),
    [sym__string] = ACTIONS(3087),
  },
  [640] = {
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_q_LBRACE] = ACTIONS(3063),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_SLASH_EQ] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3061),
    [anon_sym_DOT_DOT] = ACTIONS(3061),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_AMP_EQ] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_PIPE_EQ] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_DASH_EQ] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_PLUS_EQ] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_LT_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_BANG] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_DOLLAR] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_STAR_EQ] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_PERCENT_EQ] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_CARET_EQ] = ACTIONS(3063),
    [anon_sym_CARET_CARET] = ACTIONS(3061),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_TILDE_EQ] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [anon_sym_EQ_GT] = ACTIONS(3063),
    [anon_sym_POUND] = ACTIONS(3063),
    [sym_bool] = ACTIONS(3061),
    [sym_byte] = ACTIONS(3061),
    [sym_ubyte] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_short] = ACTIONS(3061),
    [sym_ushort] = ACTIONS(3061),
    [sym_int] = ACTIONS(3061),
    [sym_uint] = ACTIONS(3061),
    [sym_long] = ACTIONS(3061),
    [sym_ulong] = ACTIONS(3061),
    [sym_cent] = ACTIONS(3061),
    [sym_ucent] = ACTIONS(3061),
    [sym_wchar] = ACTIONS(3061),
    [sym_dchar] = ACTIONS(3061),
    [sym_float] = ACTIONS(3061),
    [sym_double] = ACTIONS(3061),
    [sym_real] = ACTIONS(3061),
    [sym_ifloat] = ACTIONS(3061),
    [sym_idouble] = ACTIONS(3061),
    [sym_ireal] = ACTIONS(3061),
    [sym_cfloat] = ACTIONS(3061),
    [sym_cdouble] = ACTIONS(3061),
    [sym_creal] = ACTIONS(3061),
    [sym_size_t] = ACTIONS(3061),
    [sym_ptrdiff_t] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym_cstring] = ACTIONS(3061),
    [sym_dstring] = ACTIONS(3061),
    [sym_wstring] = ACTIONS(3061),
    [sym_noreturn] = ACTIONS(3061),
    [sym_true] = ACTIONS(3061),
    [sym_false] = ACTIONS(3061),
    [sym_null] = ACTIONS(3061),
    [sym_super] = ACTIONS(3061),
    [sym_this] = ACTIONS(3061),
    [sym_abstract] = ACTIONS(3061),
    [sym_alias] = ACTIONS(3061),
    [sym_align] = ACTIONS(3061),
    [sym_asm] = ACTIONS(3061),
    [sym_assert] = ACTIONS(3061),
    [sym_auto] = ACTIONS(3061),
    [sym_break] = ACTIONS(3061),
    [sym_case] = ACTIONS(3061),
    [sym_cast] = ACTIONS(3061),
    [sym_catch] = ACTIONS(3061),
    [sym_class] = ACTIONS(3061),
    [sym_const] = ACTIONS(3061),
    [sym_continue] = ACTIONS(3061),
    [sym_debug] = ACTIONS(3061),
    [sym_default] = ACTIONS(3061),
    [sym_delegate] = ACTIONS(3061),
    [sym_delete] = ACTIONS(3061),
    [sym_deprecated] = ACTIONS(3061),
    [sym_do] = ACTIONS(3061),
    [sym_else] = ACTIONS(3061),
    [sym_enum] = ACTIONS(3061),
    [sym_export] = ACTIONS(3061),
    [sym_extern] = ACTIONS(3061),
    [sym_final] = ACTIONS(3061),
    [sym_finally] = ACTIONS(3061),
    [sym_for] = ACTIONS(3061),
    [sym_foreach] = ACTIONS(3061),
    [sym_foreach_reverse] = ACTIONS(3061),
    [sym_function] = ACTIONS(3061),
    [sym_goto] = ACTIONS(3061),
    [sym_if] = ACTIONS(3061),
    [sym_immutable] = ACTIONS(3061),
    [sym_import] = ACTIONS(3061),
    [sym_in] = ACTIONS(3061),
    [sym_inout] = ACTIONS(3061),
    [sym_interface] = ACTIONS(3061),
    [sym_invariant] = ACTIONS(3061),
    [sym_is] = ACTIONS(3061),
    [sym_lazy] = ACTIONS(3061),
    [sym_mixin] = ACTIONS(3061),
    [sym_module] = ACTIONS(3061),
    [sym_new] = ACTIONS(3061),
    [sym_nothrow] = ACTIONS(3061),
    [sym_out] = ACTIONS(3061),
    [sym_override] = ACTIONS(3061),
    [sym_package] = ACTIONS(3061),
    [sym_pragma] = ACTIONS(3061),
    [sym_private] = ACTIONS(3061),
    [sym_protected] = ACTIONS(3061),
    [sym_public] = ACTIONS(3061),
    [sym_pure] = ACTIONS(3061),
    [sym_ref] = ACTIONS(3061),
    [sym_return] = ACTIONS(3061),
    [sym_scope] = ACTIONS(3061),
    [sym_shared] = ACTIONS(3061),
    [sym_static] = ACTIONS(3061),
    [sym_struct] = ACTIONS(3061),
    [sym_switch] = ACTIONS(3061),
    [sym_synchronized] = ACTIONS(3061),
    [sym_template] = ACTIONS(3061),
    [sym_throw] = ACTIONS(3061),
    [sym_try] = ACTIONS(3061),
    [sym_typeid] = ACTIONS(3061),
    [sym_typeof] = ACTIONS(3061),
    [sym_union] = ACTIONS(3061),
    [sym_unittest] = ACTIONS(3061),
    [sym_version] = ACTIONS(3061),
    [sym_while] = ACTIONS(3061),
    [sym_with] = ACTIONS(3061),
    [sym_parameters_] = ACTIONS(3061),
    [sym_gshared] = ACTIONS(3061),
    [sym_traits] = ACTIONS(3061),
    [sym_vector] = ACTIONS(3061),
    [sym_void] = ACTIONS(3061),
    [anon_sym_BQUOTE] = ACTIONS(3063),
    [anon_sym_r_DQUOTE] = ACTIONS(3063),
    [anon_sym_x_DQUOTE] = ACTIONS(3063),
    [anon_sym_DQUOTE] = ACTIONS(3063),
    [anon_sym_i_BQUOTE] = ACTIONS(3063),
    [anon_sym_i_DQUOTE] = ACTIONS(3063),
    [anon_sym_iq_LBRACE] = ACTIONS(3063),
    [aux_sym_char_literal_token1] = ACTIONS(3063),
    [anon_sym_SQUOTE] = ACTIONS(3061),
    [anon_sym___DATE__] = ACTIONS(3061),
    [anon_sym___FILE__] = ACTIONS(3061),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3061),
    [anon_sym___FUNCTION__] = ACTIONS(3061),
    [anon_sym___LINE__] = ACTIONS(3061),
    [anon_sym___MODULE__] = ACTIONS(3061),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3061),
    [anon_sym___TIME__] = ACTIONS(3061),
    [anon_sym___TIMESTAMP__] = ACTIONS(3061),
    [anon_sym___VENDOR__] = ACTIONS(3061),
    [anon_sym___VERSION__] = ACTIONS(3061),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3063),
    [sym_float_literal] = ACTIONS(3063),
    [sym__string] = ACTIONS(3063),
  },
  [641] = {
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_q_LBRACE] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_SLASH_EQ] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_DOT_DOT] = ACTIONS(3069),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_AMP_EQ] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_PIPE_EQ] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_DASH_EQ] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_LT_LT_EQ] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_BANG] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_STAR_EQ] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_PERCENT_EQ] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_CARET_EQ] = ACTIONS(3071),
    [anon_sym_CARET_CARET] = ACTIONS(3069),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_TILDE_EQ] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_EQ_GT] = ACTIONS(3071),
    [anon_sym_POUND] = ACTIONS(3071),
    [sym_bool] = ACTIONS(3069),
    [sym_byte] = ACTIONS(3069),
    [sym_ubyte] = ACTIONS(3069),
    [sym_char] = ACTIONS(3069),
    [sym_short] = ACTIONS(3069),
    [sym_ushort] = ACTIONS(3069),
    [sym_int] = ACTIONS(3069),
    [sym_uint] = ACTIONS(3069),
    [sym_long] = ACTIONS(3069),
    [sym_ulong] = ACTIONS(3069),
    [sym_cent] = ACTIONS(3069),
    [sym_ucent] = ACTIONS(3069),
    [sym_wchar] = ACTIONS(3069),
    [sym_dchar] = ACTIONS(3069),
    [sym_float] = ACTIONS(3069),
    [sym_double] = ACTIONS(3069),
    [sym_real] = ACTIONS(3069),
    [sym_ifloat] = ACTIONS(3069),
    [sym_idouble] = ACTIONS(3069),
    [sym_ireal] = ACTIONS(3069),
    [sym_cfloat] = ACTIONS(3069),
    [sym_cdouble] = ACTIONS(3069),
    [sym_creal] = ACTIONS(3069),
    [sym_size_t] = ACTIONS(3069),
    [sym_ptrdiff_t] = ACTIONS(3069),
    [sym_string] = ACTIONS(3069),
    [sym_cstring] = ACTIONS(3069),
    [sym_dstring] = ACTIONS(3069),
    [sym_wstring] = ACTIONS(3069),
    [sym_noreturn] = ACTIONS(3069),
    [sym_true] = ACTIONS(3069),
    [sym_false] = ACTIONS(3069),
    [sym_null] = ACTIONS(3069),
    [sym_super] = ACTIONS(3069),
    [sym_this] = ACTIONS(3069),
    [sym_abstract] = ACTIONS(3069),
    [sym_alias] = ACTIONS(3069),
    [sym_align] = ACTIONS(3069),
    [sym_asm] = ACTIONS(3069),
    [sym_assert] = ACTIONS(3069),
    [sym_auto] = ACTIONS(3069),
    [sym_break] = ACTIONS(3069),
    [sym_case] = ACTIONS(3069),
    [sym_cast] = ACTIONS(3069),
    [sym_catch] = ACTIONS(3069),
    [sym_class] = ACTIONS(3069),
    [sym_const] = ACTIONS(3069),
    [sym_continue] = ACTIONS(3069),
    [sym_debug] = ACTIONS(3069),
    [sym_default] = ACTIONS(3069),
    [sym_delegate] = ACTIONS(3069),
    [sym_delete] = ACTIONS(3069),
    [sym_deprecated] = ACTIONS(3069),
    [sym_do] = ACTIONS(3069),
    [sym_else] = ACTIONS(3069),
    [sym_enum] = ACTIONS(3069),
    [sym_export] = ACTIONS(3069),
    [sym_extern] = ACTIONS(3069),
    [sym_final] = ACTIONS(3069),
    [sym_finally] = ACTIONS(3069),
    [sym_for] = ACTIONS(3069),
    [sym_foreach] = ACTIONS(3069),
    [sym_foreach_reverse] = ACTIONS(3069),
    [sym_function] = ACTIONS(3069),
    [sym_goto] = ACTIONS(3069),
    [sym_if] = ACTIONS(3069),
    [sym_immutable] = ACTIONS(3069),
    [sym_import] = ACTIONS(3069),
    [sym_in] = ACTIONS(3069),
    [sym_inout] = ACTIONS(3069),
    [sym_interface] = ACTIONS(3069),
    [sym_invariant] = ACTIONS(3069),
    [sym_is] = ACTIONS(3069),
    [sym_lazy] = ACTIONS(3069),
    [sym_mixin] = ACTIONS(3069),
    [sym_module] = ACTIONS(3069),
    [sym_new] = ACTIONS(3069),
    [sym_nothrow] = ACTIONS(3069),
    [sym_out] = ACTIONS(3069),
    [sym_override] = ACTIONS(3069),
    [sym_package] = ACTIONS(3069),
    [sym_pragma] = ACTIONS(3069),
    [sym_private] = ACTIONS(3069),
    [sym_protected] = ACTIONS(3069),
    [sym_public] = ACTIONS(3069),
    [sym_pure] = ACTIONS(3069),
    [sym_ref] = ACTIONS(3069),
    [sym_return] = ACTIONS(3069),
    [sym_scope] = ACTIONS(3069),
    [sym_shared] = ACTIONS(3069),
    [sym_static] = ACTIONS(3069),
    [sym_struct] = ACTIONS(3069),
    [sym_switch] = ACTIONS(3069),
    [sym_synchronized] = ACTIONS(3069),
    [sym_template] = ACTIONS(3069),
    [sym_throw] = ACTIONS(3069),
    [sym_try] = ACTIONS(3069),
    [sym_typeid] = ACTIONS(3069),
    [sym_typeof] = ACTIONS(3069),
    [sym_union] = ACTIONS(3069),
    [sym_unittest] = ACTIONS(3069),
    [sym_version] = ACTIONS(3069),
    [sym_while] = ACTIONS(3069),
    [sym_with] = ACTIONS(3069),
    [sym_parameters_] = ACTIONS(3069),
    [sym_gshared] = ACTIONS(3069),
    [sym_traits] = ACTIONS(3069),
    [sym_vector] = ACTIONS(3069),
    [sym_void] = ACTIONS(3069),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_r_DQUOTE] = ACTIONS(3071),
    [anon_sym_x_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_i_BQUOTE] = ACTIONS(3071),
    [anon_sym_i_DQUOTE] = ACTIONS(3071),
    [anon_sym_iq_LBRACE] = ACTIONS(3071),
    [aux_sym_char_literal_token1] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3069),
    [anon_sym___DATE__] = ACTIONS(3069),
    [anon_sym___FILE__] = ACTIONS(3069),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3069),
    [anon_sym___FUNCTION__] = ACTIONS(3069),
    [anon_sym___LINE__] = ACTIONS(3069),
    [anon_sym___MODULE__] = ACTIONS(3069),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3069),
    [anon_sym___TIME__] = ACTIONS(3069),
    [anon_sym___TIMESTAMP__] = ACTIONS(3069),
    [anon_sym___VENDOR__] = ACTIONS(3069),
    [anon_sym___VERSION__] = ACTIONS(3069),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3071),
    [sym_float_literal] = ACTIONS(3071),
    [sym__string] = ACTIONS(3071),
  },
  [642] = {
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_q_LBRACE] = ACTIONS(3055),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3053),
    [anon_sym_SLASH_EQ] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3053),
    [anon_sym_DOT_DOT] = ACTIONS(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_AMP_EQ] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3053),
    [anon_sym_PIPE_EQ] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_DASH_EQ] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3053),
    [anon_sym_LT_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3053),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3053),
    [anon_sym_GT_GT_GT] = ACTIONS(3053),
    [anon_sym_BANG] = ACTIONS(3053),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_RBRACK] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_DOLLAR] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_STAR_EQ] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3053),
    [anon_sym_PERCENT_EQ] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_CARET_EQ] = ACTIONS(3055),
    [anon_sym_CARET_CARET] = ACTIONS(3053),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_TILDE_EQ] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [anon_sym_EQ_GT] = ACTIONS(3055),
    [anon_sym_POUND] = ACTIONS(3055),
    [sym_bool] = ACTIONS(3053),
    [sym_byte] = ACTIONS(3053),
    [sym_ubyte] = ACTIONS(3053),
    [sym_char] = ACTIONS(3053),
    [sym_short] = ACTIONS(3053),
    [sym_ushort] = ACTIONS(3053),
    [sym_int] = ACTIONS(3053),
    [sym_uint] = ACTIONS(3053),
    [sym_long] = ACTIONS(3053),
    [sym_ulong] = ACTIONS(3053),
    [sym_cent] = ACTIONS(3053),
    [sym_ucent] = ACTIONS(3053),
    [sym_wchar] = ACTIONS(3053),
    [sym_dchar] = ACTIONS(3053),
    [sym_float] = ACTIONS(3053),
    [sym_double] = ACTIONS(3053),
    [sym_real] = ACTIONS(3053),
    [sym_ifloat] = ACTIONS(3053),
    [sym_idouble] = ACTIONS(3053),
    [sym_ireal] = ACTIONS(3053),
    [sym_cfloat] = ACTIONS(3053),
    [sym_cdouble] = ACTIONS(3053),
    [sym_creal] = ACTIONS(3053),
    [sym_size_t] = ACTIONS(3053),
    [sym_ptrdiff_t] = ACTIONS(3053),
    [sym_string] = ACTIONS(3053),
    [sym_cstring] = ACTIONS(3053),
    [sym_dstring] = ACTIONS(3053),
    [sym_wstring] = ACTIONS(3053),
    [sym_noreturn] = ACTIONS(3053),
    [sym_true] = ACTIONS(3053),
    [sym_false] = ACTIONS(3053),
    [sym_null] = ACTIONS(3053),
    [sym_super] = ACTIONS(3053),
    [sym_this] = ACTIONS(3053),
    [sym_abstract] = ACTIONS(3053),
    [sym_alias] = ACTIONS(3053),
    [sym_align] = ACTIONS(3053),
    [sym_asm] = ACTIONS(3053),
    [sym_assert] = ACTIONS(3053),
    [sym_auto] = ACTIONS(3053),
    [sym_break] = ACTIONS(3053),
    [sym_case] = ACTIONS(3053),
    [sym_cast] = ACTIONS(3053),
    [sym_catch] = ACTIONS(3053),
    [sym_class] = ACTIONS(3053),
    [sym_const] = ACTIONS(3053),
    [sym_continue] = ACTIONS(3053),
    [sym_debug] = ACTIONS(3053),
    [sym_default] = ACTIONS(3053),
    [sym_delegate] = ACTIONS(3053),
    [sym_delete] = ACTIONS(3053),
    [sym_deprecated] = ACTIONS(3053),
    [sym_do] = ACTIONS(3053),
    [sym_else] = ACTIONS(3053),
    [sym_enum] = ACTIONS(3053),
    [sym_export] = ACTIONS(3053),
    [sym_extern] = ACTIONS(3053),
    [sym_final] = ACTIONS(3053),
    [sym_finally] = ACTIONS(3053),
    [sym_for] = ACTIONS(3053),
    [sym_foreach] = ACTIONS(3053),
    [sym_foreach_reverse] = ACTIONS(3053),
    [sym_function] = ACTIONS(3053),
    [sym_goto] = ACTIONS(3053),
    [sym_if] = ACTIONS(3053),
    [sym_immutable] = ACTIONS(3053),
    [sym_import] = ACTIONS(3053),
    [sym_in] = ACTIONS(3053),
    [sym_inout] = ACTIONS(3053),
    [sym_interface] = ACTIONS(3053),
    [sym_invariant] = ACTIONS(3053),
    [sym_is] = ACTIONS(3053),
    [sym_lazy] = ACTIONS(3053),
    [sym_mixin] = ACTIONS(3053),
    [sym_module] = ACTIONS(3053),
    [sym_new] = ACTIONS(3053),
    [sym_nothrow] = ACTIONS(3053),
    [sym_out] = ACTIONS(3053),
    [sym_override] = ACTIONS(3053),
    [sym_package] = ACTIONS(3053),
    [sym_pragma] = ACTIONS(3053),
    [sym_private] = ACTIONS(3053),
    [sym_protected] = ACTIONS(3053),
    [sym_public] = ACTIONS(3053),
    [sym_pure] = ACTIONS(3053),
    [sym_ref] = ACTIONS(3053),
    [sym_return] = ACTIONS(3053),
    [sym_scope] = ACTIONS(3053),
    [sym_shared] = ACTIONS(3053),
    [sym_static] = ACTIONS(3053),
    [sym_struct] = ACTIONS(3053),
    [sym_switch] = ACTIONS(3053),
    [sym_synchronized] = ACTIONS(3053),
    [sym_template] = ACTIONS(3053),
    [sym_throw] = ACTIONS(3053),
    [sym_try] = ACTIONS(3053),
    [sym_typeid] = ACTIONS(3053),
    [sym_typeof] = ACTIONS(3053),
    [sym_union] = ACTIONS(3053),
    [sym_unittest] = ACTIONS(3053),
    [sym_version] = ACTIONS(3053),
    [sym_while] = ACTIONS(3053),
    [sym_with] = ACTIONS(3053),
    [sym_parameters_] = ACTIONS(3053),
    [sym_gshared] = ACTIONS(3053),
    [sym_traits] = ACTIONS(3053),
    [sym_vector] = ACTIONS(3053),
    [sym_void] = ACTIONS(3053),
    [anon_sym_BQUOTE] = ACTIONS(3055),
    [anon_sym_r_DQUOTE] = ACTIONS(3055),
    [anon_sym_x_DQUOTE] = ACTIONS(3055),
    [anon_sym_DQUOTE] = ACTIONS(3055),
    [anon_sym_i_BQUOTE] = ACTIONS(3055),
    [anon_sym_i_DQUOTE] = ACTIONS(3055),
    [anon_sym_iq_LBRACE] = ACTIONS(3055),
    [aux_sym_char_literal_token1] = ACTIONS(3055),
    [anon_sym_SQUOTE] = ACTIONS(3053),
    [anon_sym___DATE__] = ACTIONS(3053),
    [anon_sym___FILE__] = ACTIONS(3053),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3053),
    [anon_sym___FUNCTION__] = ACTIONS(3053),
    [anon_sym___LINE__] = ACTIONS(3053),
    [anon_sym___MODULE__] = ACTIONS(3053),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3053),
    [anon_sym___TIME__] = ACTIONS(3053),
    [anon_sym___TIMESTAMP__] = ACTIONS(3053),
    [anon_sym___VENDOR__] = ACTIONS(3053),
    [anon_sym___VERSION__] = ACTIONS(3053),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3055),
    [sym_float_literal] = ACTIONS(3055),
    [sym__string] = ACTIONS(3055),
  },
  [643] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_q_LBRACE] = ACTIONS(3043),
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_SLASH_EQ] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3041),
    [anon_sym_DOT_DOT] = ACTIONS(3041),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_AMP_EQ] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_PIPE_EQ] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_DASH_EQ] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_PLUS_EQ] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_LT_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_BANG] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_DOLLAR] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_STAR_EQ] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_PERCENT_EQ] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_CARET_EQ] = ACTIONS(3043),
    [anon_sym_CARET_CARET] = ACTIONS(3041),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_TILDE_EQ] = ACTIONS(3043),
    [anon_sym_AT] = ACTIONS(3043),
    [anon_sym_EQ_GT] = ACTIONS(3043),
    [anon_sym_POUND] = ACTIONS(3043),
    [sym_bool] = ACTIONS(3041),
    [sym_byte] = ACTIONS(3041),
    [sym_ubyte] = ACTIONS(3041),
    [sym_char] = ACTIONS(3041),
    [sym_short] = ACTIONS(3041),
    [sym_ushort] = ACTIONS(3041),
    [sym_int] = ACTIONS(3041),
    [sym_uint] = ACTIONS(3041),
    [sym_long] = ACTIONS(3041),
    [sym_ulong] = ACTIONS(3041),
    [sym_cent] = ACTIONS(3041),
    [sym_ucent] = ACTIONS(3041),
    [sym_wchar] = ACTIONS(3041),
    [sym_dchar] = ACTIONS(3041),
    [sym_float] = ACTIONS(3041),
    [sym_double] = ACTIONS(3041),
    [sym_real] = ACTIONS(3041),
    [sym_ifloat] = ACTIONS(3041),
    [sym_idouble] = ACTIONS(3041),
    [sym_ireal] = ACTIONS(3041),
    [sym_cfloat] = ACTIONS(3041),
    [sym_cdouble] = ACTIONS(3041),
    [sym_creal] = ACTIONS(3041),
    [sym_size_t] = ACTIONS(3041),
    [sym_ptrdiff_t] = ACTIONS(3041),
    [sym_string] = ACTIONS(3041),
    [sym_cstring] = ACTIONS(3041),
    [sym_dstring] = ACTIONS(3041),
    [sym_wstring] = ACTIONS(3041),
    [sym_noreturn] = ACTIONS(3041),
    [sym_true] = ACTIONS(3041),
    [sym_false] = ACTIONS(3041),
    [sym_null] = ACTIONS(3041),
    [sym_super] = ACTIONS(3041),
    [sym_this] = ACTIONS(3041),
    [sym_abstract] = ACTIONS(3041),
    [sym_alias] = ACTIONS(3041),
    [sym_align] = ACTIONS(3041),
    [sym_asm] = ACTIONS(3041),
    [sym_assert] = ACTIONS(3041),
    [sym_auto] = ACTIONS(3041),
    [sym_break] = ACTIONS(3041),
    [sym_case] = ACTIONS(3041),
    [sym_cast] = ACTIONS(3041),
    [sym_catch] = ACTIONS(3041),
    [sym_class] = ACTIONS(3041),
    [sym_const] = ACTIONS(3041),
    [sym_continue] = ACTIONS(3041),
    [sym_debug] = ACTIONS(3041),
    [sym_default] = ACTIONS(3041),
    [sym_delegate] = ACTIONS(3041),
    [sym_delete] = ACTIONS(3041),
    [sym_deprecated] = ACTIONS(3041),
    [sym_do] = ACTIONS(3041),
    [sym_else] = ACTIONS(3041),
    [sym_enum] = ACTIONS(3041),
    [sym_export] = ACTIONS(3041),
    [sym_extern] = ACTIONS(3041),
    [sym_final] = ACTIONS(3041),
    [sym_finally] = ACTIONS(3041),
    [sym_for] = ACTIONS(3041),
    [sym_foreach] = ACTIONS(3041),
    [sym_foreach_reverse] = ACTIONS(3041),
    [sym_function] = ACTIONS(3041),
    [sym_goto] = ACTIONS(3041),
    [sym_if] = ACTIONS(3041),
    [sym_immutable] = ACTIONS(3041),
    [sym_import] = ACTIONS(3041),
    [sym_in] = ACTIONS(3041),
    [sym_inout] = ACTIONS(3041),
    [sym_interface] = ACTIONS(3041),
    [sym_invariant] = ACTIONS(3041),
    [sym_is] = ACTIONS(3041),
    [sym_lazy] = ACTIONS(3041),
    [sym_mixin] = ACTIONS(3041),
    [sym_module] = ACTIONS(3041),
    [sym_new] = ACTIONS(3041),
    [sym_nothrow] = ACTIONS(3041),
    [sym_out] = ACTIONS(3041),
    [sym_override] = ACTIONS(3041),
    [sym_package] = ACTIONS(3041),
    [sym_pragma] = ACTIONS(3041),
    [sym_private] = ACTIONS(3041),
    [sym_protected] = ACTIONS(3041),
    [sym_public] = ACTIONS(3041),
    [sym_pure] = ACTIONS(3041),
    [sym_ref] = ACTIONS(3041),
    [sym_return] = ACTIONS(3041),
    [sym_scope] = ACTIONS(3041),
    [sym_shared] = ACTIONS(3041),
    [sym_static] = ACTIONS(3041),
    [sym_struct] = ACTIONS(3041),
    [sym_switch] = ACTIONS(3041),
    [sym_synchronized] = ACTIONS(3041),
    [sym_template] = ACTIONS(3041),
    [sym_throw] = ACTIONS(3041),
    [sym_try] = ACTIONS(3041),
    [sym_typeid] = ACTIONS(3041),
    [sym_typeof] = ACTIONS(3041),
    [sym_union] = ACTIONS(3041),
    [sym_unittest] = ACTIONS(3041),
    [sym_version] = ACTIONS(3041),
    [sym_while] = ACTIONS(3041),
    [sym_with] = ACTIONS(3041),
    [sym_parameters_] = ACTIONS(3041),
    [sym_gshared] = ACTIONS(3041),
    [sym_traits] = ACTIONS(3041),
    [sym_vector] = ACTIONS(3041),
    [sym_void] = ACTIONS(3041),
    [anon_sym_BQUOTE] = ACTIONS(3043),
    [anon_sym_r_DQUOTE] = ACTIONS(3043),
    [anon_sym_x_DQUOTE] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3043),
    [anon_sym_i_BQUOTE] = ACTIONS(3043),
    [anon_sym_i_DQUOTE] = ACTIONS(3043),
    [anon_sym_iq_LBRACE] = ACTIONS(3043),
    [aux_sym_char_literal_token1] = ACTIONS(3043),
    [anon_sym_SQUOTE] = ACTIONS(3041),
    [anon_sym___DATE__] = ACTIONS(3041),
    [anon_sym___FILE__] = ACTIONS(3041),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3041),
    [anon_sym___FUNCTION__] = ACTIONS(3041),
    [anon_sym___LINE__] = ACTIONS(3041),
    [anon_sym___MODULE__] = ACTIONS(3041),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3041),
    [anon_sym___TIME__] = ACTIONS(3041),
    [anon_sym___TIMESTAMP__] = ACTIONS(3041),
    [anon_sym___VENDOR__] = ACTIONS(3041),
    [anon_sym___VERSION__] = ACTIONS(3041),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3043),
    [sym_float_literal] = ACTIONS(3043),
    [sym__string] = ACTIONS(3043),
  },
  [644] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_q_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_SLASH] = ACTIONS(3073),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3073),
    [anon_sym_DOT_DOT] = ACTIONS(3073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3073),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE] = ACTIONS(3073),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_DASH] = ACTIONS(3073),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3073),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_LT] = ACTIONS(3073),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT] = ACTIONS(3073),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3073),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT] = ACTIONS(3073),
    [anon_sym_GT_GT_GT] = ACTIONS(3073),
    [anon_sym_BANG] = ACTIONS(3073),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3073),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_STAR] = ACTIONS(3073),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT] = ACTIONS(3073),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_CARET] = ACTIONS(3073),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_CARET_CARET] = ACTIONS(3073),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3073),
    [anon_sym_TILDE_EQ] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_EQ_GT] = ACTIONS(3075),
    [anon_sym_POUND] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_true] = ACTIONS(3073),
    [sym_false] = ACTIONS(3073),
    [sym_null] = ACTIONS(3073),
    [sym_super] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_asm] = ACTIONS(3073),
    [sym_assert] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_break] = ACTIONS(3073),
    [sym_case] = ACTIONS(3073),
    [sym_cast] = ACTIONS(3073),
    [sym_catch] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_continue] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_default] = ACTIONS(3073),
    [sym_delegate] = ACTIONS(3073),
    [sym_delete] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_do] = ACTIONS(3073),
    [sym_else] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_finally] = ACTIONS(3073),
    [sym_for] = ACTIONS(3073),
    [sym_foreach] = ACTIONS(3073),
    [sym_foreach_reverse] = ACTIONS(3073),
    [sym_function] = ACTIONS(3073),
    [sym_goto] = ACTIONS(3073),
    [sym_if] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_in] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_is] = ACTIONS(3073),
    [sym_lazy] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_module] = ACTIONS(3073),
    [sym_new] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_out] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(3073),
    [sym_struct] = ACTIONS(3073),
    [sym_switch] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_throw] = ACTIONS(3073),
    [sym_try] = ACTIONS(3073),
    [sym_typeid] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_while] = ACTIONS(3073),
    [sym_with] = ACTIONS(3073),
    [sym_parameters_] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [anon_sym_BQUOTE] = ACTIONS(3075),
    [anon_sym_r_DQUOTE] = ACTIONS(3075),
    [anon_sym_x_DQUOTE] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3075),
    [anon_sym_i_BQUOTE] = ACTIONS(3075),
    [anon_sym_i_DQUOTE] = ACTIONS(3075),
    [anon_sym_iq_LBRACE] = ACTIONS(3075),
    [aux_sym_char_literal_token1] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3073),
    [anon_sym___DATE__] = ACTIONS(3073),
    [anon_sym___FILE__] = ACTIONS(3073),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3073),
    [anon_sym___FUNCTION__] = ACTIONS(3073),
    [anon_sym___LINE__] = ACTIONS(3073),
    [anon_sym___MODULE__] = ACTIONS(3073),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3073),
    [anon_sym___TIME__] = ACTIONS(3073),
    [anon_sym___TIMESTAMP__] = ACTIONS(3073),
    [anon_sym___VENDOR__] = ACTIONS(3073),
    [anon_sym___VERSION__] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3075),
    [sym_float_literal] = ACTIONS(3075),
    [sym__string] = ACTIONS(3075),
  },
  [645] = {
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_q_LBRACE] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_SLASH_EQ] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT] = ACTIONS(3097),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_AMP_EQ] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_PIPE_EQ] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_DASH_EQ] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_PLUS_EQ] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_LT_EQ] = ACTIONS(3099),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_LT_LT_EQ] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_GT_GT_GT] = ACTIONS(3097),
    [anon_sym_BANG] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_DOLLAR] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_STAR_EQ] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [anon_sym_PERCENT_EQ] = ACTIONS(3099),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_CARET_EQ] = ACTIONS(3099),
    [anon_sym_CARET_CARET] = ACTIONS(3097),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_TILDE_EQ] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3099),
    [anon_sym_EQ_GT] = ACTIONS(3099),
    [anon_sym_POUND] = ACTIONS(3099),
    [sym_bool] = ACTIONS(3097),
    [sym_byte] = ACTIONS(3097),
    [sym_ubyte] = ACTIONS(3097),
    [sym_char] = ACTIONS(3097),
    [sym_short] = ACTIONS(3097),
    [sym_ushort] = ACTIONS(3097),
    [sym_int] = ACTIONS(3097),
    [sym_uint] = ACTIONS(3097),
    [sym_long] = ACTIONS(3097),
    [sym_ulong] = ACTIONS(3097),
    [sym_cent] = ACTIONS(3097),
    [sym_ucent] = ACTIONS(3097),
    [sym_wchar] = ACTIONS(3097),
    [sym_dchar] = ACTIONS(3097),
    [sym_float] = ACTIONS(3097),
    [sym_double] = ACTIONS(3097),
    [sym_real] = ACTIONS(3097),
    [sym_ifloat] = ACTIONS(3097),
    [sym_idouble] = ACTIONS(3097),
    [sym_ireal] = ACTIONS(3097),
    [sym_cfloat] = ACTIONS(3097),
    [sym_cdouble] = ACTIONS(3097),
    [sym_creal] = ACTIONS(3097),
    [sym_size_t] = ACTIONS(3097),
    [sym_ptrdiff_t] = ACTIONS(3097),
    [sym_string] = ACTIONS(3097),
    [sym_cstring] = ACTIONS(3097),
    [sym_dstring] = ACTIONS(3097),
    [sym_wstring] = ACTIONS(3097),
    [sym_noreturn] = ACTIONS(3097),
    [sym_true] = ACTIONS(3097),
    [sym_false] = ACTIONS(3097),
    [sym_null] = ACTIONS(3097),
    [sym_super] = ACTIONS(3097),
    [sym_this] = ACTIONS(3097),
    [sym_abstract] = ACTIONS(3097),
    [sym_alias] = ACTIONS(3097),
    [sym_align] = ACTIONS(3097),
    [sym_asm] = ACTIONS(3097),
    [sym_assert] = ACTIONS(3097),
    [sym_auto] = ACTIONS(3097),
    [sym_break] = ACTIONS(3097),
    [sym_case] = ACTIONS(3097),
    [sym_cast] = ACTIONS(3097),
    [sym_catch] = ACTIONS(3097),
    [sym_class] = ACTIONS(3097),
    [sym_const] = ACTIONS(3097),
    [sym_continue] = ACTIONS(3097),
    [sym_debug] = ACTIONS(3097),
    [sym_default] = ACTIONS(3097),
    [sym_delegate] = ACTIONS(3097),
    [sym_delete] = ACTIONS(3097),
    [sym_deprecated] = ACTIONS(3097),
    [sym_do] = ACTIONS(3097),
    [sym_else] = ACTIONS(3097),
    [sym_enum] = ACTIONS(3097),
    [sym_export] = ACTIONS(3097),
    [sym_extern] = ACTIONS(3097),
    [sym_final] = ACTIONS(3097),
    [sym_finally] = ACTIONS(3097),
    [sym_for] = ACTIONS(3097),
    [sym_foreach] = ACTIONS(3097),
    [sym_foreach_reverse] = ACTIONS(3097),
    [sym_function] = ACTIONS(3097),
    [sym_goto] = ACTIONS(3097),
    [sym_if] = ACTIONS(3097),
    [sym_immutable] = ACTIONS(3097),
    [sym_import] = ACTIONS(3097),
    [sym_in] = ACTIONS(3097),
    [sym_inout] = ACTIONS(3097),
    [sym_interface] = ACTIONS(3097),
    [sym_invariant] = ACTIONS(3097),
    [sym_is] = ACTIONS(3097),
    [sym_lazy] = ACTIONS(3097),
    [sym_mixin] = ACTIONS(3097),
    [sym_module] = ACTIONS(3097),
    [sym_new] = ACTIONS(3097),
    [sym_nothrow] = ACTIONS(3097),
    [sym_out] = ACTIONS(3097),
    [sym_override] = ACTIONS(3097),
    [sym_package] = ACTIONS(3097),
    [sym_pragma] = ACTIONS(3097),
    [sym_private] = ACTIONS(3097),
    [sym_protected] = ACTIONS(3097),
    [sym_public] = ACTIONS(3097),
    [sym_pure] = ACTIONS(3097),
    [sym_ref] = ACTIONS(3097),
    [sym_return] = ACTIONS(3097),
    [sym_scope] = ACTIONS(3097),
    [sym_shared] = ACTIONS(3097),
    [sym_static] = ACTIONS(3097),
    [sym_struct] = ACTIONS(3097),
    [sym_switch] = ACTIONS(3097),
    [sym_synchronized] = ACTIONS(3097),
    [sym_template] = ACTIONS(3097),
    [sym_throw] = ACTIONS(3097),
    [sym_try] = ACTIONS(3097),
    [sym_typeid] = ACTIONS(3097),
    [sym_typeof] = ACTIONS(3097),
    [sym_union] = ACTIONS(3097),
    [sym_unittest] = ACTIONS(3097),
    [sym_version] = ACTIONS(3097),
    [sym_while] = ACTIONS(3097),
    [sym_with] = ACTIONS(3097),
    [sym_parameters_] = ACTIONS(3097),
    [sym_gshared] = ACTIONS(3097),
    [sym_traits] = ACTIONS(3097),
    [sym_vector] = ACTIONS(3097),
    [sym_void] = ACTIONS(3097),
    [anon_sym_BQUOTE] = ACTIONS(3099),
    [anon_sym_r_DQUOTE] = ACTIONS(3099),
    [anon_sym_x_DQUOTE] = ACTIONS(3099),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_i_BQUOTE] = ACTIONS(3099),
    [anon_sym_i_DQUOTE] = ACTIONS(3099),
    [anon_sym_iq_LBRACE] = ACTIONS(3099),
    [aux_sym_char_literal_token1] = ACTIONS(3099),
    [anon_sym_SQUOTE] = ACTIONS(3097),
    [anon_sym___DATE__] = ACTIONS(3097),
    [anon_sym___FILE__] = ACTIONS(3097),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3097),
    [anon_sym___FUNCTION__] = ACTIONS(3097),
    [anon_sym___LINE__] = ACTIONS(3097),
    [anon_sym___MODULE__] = ACTIONS(3097),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3097),
    [anon_sym___TIME__] = ACTIONS(3097),
    [anon_sym___TIMESTAMP__] = ACTIONS(3097),
    [anon_sym___VENDOR__] = ACTIONS(3097),
    [anon_sym___VERSION__] = ACTIONS(3097),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3099),
    [sym_float_literal] = ACTIONS(3099),
    [sym__string] = ACTIONS(3099),
  },
  [646] = {
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_q_LBRACE] = ACTIONS(3115),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3113),
    [anon_sym_DOT_DOT] = ACTIONS(3113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_PLUS_EQ] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_LT_EQ] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3113),
    [anon_sym_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT] = ACTIONS(3113),
    [anon_sym_GT_GT_GT] = ACTIONS(3113),
    [anon_sym_BANG] = ACTIONS(3113),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_DOLLAR] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3115),
    [anon_sym_CARET_CARET] = ACTIONS(3113),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_TILDE_EQ] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3115),
    [anon_sym_EQ_GT] = ACTIONS(3115),
    [anon_sym_POUND] = ACTIONS(3115),
    [sym_bool] = ACTIONS(3113),
    [sym_byte] = ACTIONS(3113),
    [sym_ubyte] = ACTIONS(3113),
    [sym_char] = ACTIONS(3113),
    [sym_short] = ACTIONS(3113),
    [sym_ushort] = ACTIONS(3113),
    [sym_int] = ACTIONS(3113),
    [sym_uint] = ACTIONS(3113),
    [sym_long] = ACTIONS(3113),
    [sym_ulong] = ACTIONS(3113),
    [sym_cent] = ACTIONS(3113),
    [sym_ucent] = ACTIONS(3113),
    [sym_wchar] = ACTIONS(3113),
    [sym_dchar] = ACTIONS(3113),
    [sym_float] = ACTIONS(3113),
    [sym_double] = ACTIONS(3113),
    [sym_real] = ACTIONS(3113),
    [sym_ifloat] = ACTIONS(3113),
    [sym_idouble] = ACTIONS(3113),
    [sym_ireal] = ACTIONS(3113),
    [sym_cfloat] = ACTIONS(3113),
    [sym_cdouble] = ACTIONS(3113),
    [sym_creal] = ACTIONS(3113),
    [sym_size_t] = ACTIONS(3113),
    [sym_ptrdiff_t] = ACTIONS(3113),
    [sym_string] = ACTIONS(3113),
    [sym_cstring] = ACTIONS(3113),
    [sym_dstring] = ACTIONS(3113),
    [sym_wstring] = ACTIONS(3113),
    [sym_noreturn] = ACTIONS(3113),
    [sym_true] = ACTIONS(3113),
    [sym_false] = ACTIONS(3113),
    [sym_null] = ACTIONS(3113),
    [sym_super] = ACTIONS(3113),
    [sym_this] = ACTIONS(3113),
    [sym_abstract] = ACTIONS(3113),
    [sym_alias] = ACTIONS(3113),
    [sym_align] = ACTIONS(3113),
    [sym_asm] = ACTIONS(3113),
    [sym_assert] = ACTIONS(3113),
    [sym_auto] = ACTIONS(3113),
    [sym_break] = ACTIONS(3113),
    [sym_case] = ACTIONS(3113),
    [sym_cast] = ACTIONS(3113),
    [sym_catch] = ACTIONS(3113),
    [sym_class] = ACTIONS(3113),
    [sym_const] = ACTIONS(3113),
    [sym_continue] = ACTIONS(3113),
    [sym_debug] = ACTIONS(3113),
    [sym_default] = ACTIONS(3113),
    [sym_delegate] = ACTIONS(3113),
    [sym_delete] = ACTIONS(3113),
    [sym_deprecated] = ACTIONS(3113),
    [sym_do] = ACTIONS(3113),
    [sym_else] = ACTIONS(3113),
    [sym_enum] = ACTIONS(3113),
    [sym_export] = ACTIONS(3113),
    [sym_extern] = ACTIONS(3113),
    [sym_final] = ACTIONS(3113),
    [sym_finally] = ACTIONS(3113),
    [sym_for] = ACTIONS(3113),
    [sym_foreach] = ACTIONS(3113),
    [sym_foreach_reverse] = ACTIONS(3113),
    [sym_function] = ACTIONS(3113),
    [sym_goto] = ACTIONS(3113),
    [sym_if] = ACTIONS(3113),
    [sym_immutable] = ACTIONS(3113),
    [sym_import] = ACTIONS(3113),
    [sym_in] = ACTIONS(3113),
    [sym_inout] = ACTIONS(3113),
    [sym_interface] = ACTIONS(3113),
    [sym_invariant] = ACTIONS(3113),
    [sym_is] = ACTIONS(3113),
    [sym_lazy] = ACTIONS(3113),
    [sym_mixin] = ACTIONS(3113),
    [sym_module] = ACTIONS(3113),
    [sym_new] = ACTIONS(3113),
    [sym_nothrow] = ACTIONS(3113),
    [sym_out] = ACTIONS(3113),
    [sym_override] = ACTIONS(3113),
    [sym_package] = ACTIONS(3113),
    [sym_pragma] = ACTIONS(3113),
    [sym_private] = ACTIONS(3113),
    [sym_protected] = ACTIONS(3113),
    [sym_public] = ACTIONS(3113),
    [sym_pure] = ACTIONS(3113),
    [sym_ref] = ACTIONS(3113),
    [sym_return] = ACTIONS(3113),
    [sym_scope] = ACTIONS(3113),
    [sym_shared] = ACTIONS(3113),
    [sym_static] = ACTIONS(3113),
    [sym_struct] = ACTIONS(3113),
    [sym_switch] = ACTIONS(3113),
    [sym_synchronized] = ACTIONS(3113),
    [sym_template] = ACTIONS(3113),
    [sym_throw] = ACTIONS(3113),
    [sym_try] = ACTIONS(3113),
    [sym_typeid] = ACTIONS(3113),
    [sym_typeof] = ACTIONS(3113),
    [sym_union] = ACTIONS(3113),
    [sym_unittest] = ACTIONS(3113),
    [sym_version] = ACTIONS(3113),
    [sym_while] = ACTIONS(3113),
    [sym_with] = ACTIONS(3113),
    [sym_parameters_] = ACTIONS(3113),
    [sym_gshared] = ACTIONS(3113),
    [sym_traits] = ACTIONS(3113),
    [sym_vector] = ACTIONS(3113),
    [sym_void] = ACTIONS(3113),
    [anon_sym_BQUOTE] = ACTIONS(3115),
    [anon_sym_r_DQUOTE] = ACTIONS(3115),
    [anon_sym_x_DQUOTE] = ACTIONS(3115),
    [anon_sym_DQUOTE] = ACTIONS(3115),
    [anon_sym_i_BQUOTE] = ACTIONS(3115),
    [anon_sym_i_DQUOTE] = ACTIONS(3115),
    [anon_sym_iq_LBRACE] = ACTIONS(3115),
    [aux_sym_char_literal_token1] = ACTIONS(3115),
    [anon_sym_SQUOTE] = ACTIONS(3113),
    [anon_sym___DATE__] = ACTIONS(3113),
    [anon_sym___FILE__] = ACTIONS(3113),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3113),
    [anon_sym___FUNCTION__] = ACTIONS(3113),
    [anon_sym___LINE__] = ACTIONS(3113),
    [anon_sym___MODULE__] = ACTIONS(3113),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3113),
    [anon_sym___TIME__] = ACTIONS(3113),
    [anon_sym___TIMESTAMP__] = ACTIONS(3113),
    [anon_sym___VENDOR__] = ACTIONS(3113),
    [anon_sym___VERSION__] = ACTIONS(3113),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3115),
    [sym_float_literal] = ACTIONS(3115),
    [sym__string] = ACTIONS(3115),
  },
  [647] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_q_LBRACE] = ACTIONS(3103),
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_SLASH] = ACTIONS(3101),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3101),
    [anon_sym_DOT_DOT] = ACTIONS(3101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_PIPE] = ACTIONS(3101),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_LT_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT] = ACTIONS(3101),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT] = ACTIONS(3101),
    [anon_sym_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT] = ACTIONS(3101),
    [anon_sym_GT_GT_GT] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_DOLLAR] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_EQ_EQ] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3101),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_CARET] = ACTIONS(3101),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_CARET_CARET] = ACTIONS(3101),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_TILDE_EQ] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3103),
    [anon_sym_EQ_GT] = ACTIONS(3103),
    [anon_sym_POUND] = ACTIONS(3103),
    [sym_bool] = ACTIONS(3101),
    [sym_byte] = ACTIONS(3101),
    [sym_ubyte] = ACTIONS(3101),
    [sym_char] = ACTIONS(3101),
    [sym_short] = ACTIONS(3101),
    [sym_ushort] = ACTIONS(3101),
    [sym_int] = ACTIONS(3101),
    [sym_uint] = ACTIONS(3101),
    [sym_long] = ACTIONS(3101),
    [sym_ulong] = ACTIONS(3101),
    [sym_cent] = ACTIONS(3101),
    [sym_ucent] = ACTIONS(3101),
    [sym_wchar] = ACTIONS(3101),
    [sym_dchar] = ACTIONS(3101),
    [sym_float] = ACTIONS(3101),
    [sym_double] = ACTIONS(3101),
    [sym_real] = ACTIONS(3101),
    [sym_ifloat] = ACTIONS(3101),
    [sym_idouble] = ACTIONS(3101),
    [sym_ireal] = ACTIONS(3101),
    [sym_cfloat] = ACTIONS(3101),
    [sym_cdouble] = ACTIONS(3101),
    [sym_creal] = ACTIONS(3101),
    [sym_size_t] = ACTIONS(3101),
    [sym_ptrdiff_t] = ACTIONS(3101),
    [sym_string] = ACTIONS(3101),
    [sym_cstring] = ACTIONS(3101),
    [sym_dstring] = ACTIONS(3101),
    [sym_wstring] = ACTIONS(3101),
    [sym_noreturn] = ACTIONS(3101),
    [sym_true] = ACTIONS(3101),
    [sym_false] = ACTIONS(3101),
    [sym_null] = ACTIONS(3101),
    [sym_super] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
    [sym_abstract] = ACTIONS(3101),
    [sym_alias] = ACTIONS(3101),
    [sym_align] = ACTIONS(3101),
    [sym_asm] = ACTIONS(3101),
    [sym_assert] = ACTIONS(3101),
    [sym_auto] = ACTIONS(3101),
    [sym_break] = ACTIONS(3101),
    [sym_case] = ACTIONS(3101),
    [sym_cast] = ACTIONS(3101),
    [sym_catch] = ACTIONS(3101),
    [sym_class] = ACTIONS(3101),
    [sym_const] = ACTIONS(3101),
    [sym_continue] = ACTIONS(3101),
    [sym_debug] = ACTIONS(3101),
    [sym_default] = ACTIONS(3101),
    [sym_delegate] = ACTIONS(3101),
    [sym_delete] = ACTIONS(3101),
    [sym_deprecated] = ACTIONS(3101),
    [sym_do] = ACTIONS(3101),
    [sym_else] = ACTIONS(3101),
    [sym_enum] = ACTIONS(3101),
    [sym_export] = ACTIONS(3101),
    [sym_extern] = ACTIONS(3101),
    [sym_final] = ACTIONS(3101),
    [sym_finally] = ACTIONS(3101),
    [sym_for] = ACTIONS(3101),
    [sym_foreach] = ACTIONS(3101),
    [sym_foreach_reverse] = ACTIONS(3101),
    [sym_function] = ACTIONS(3101),
    [sym_goto] = ACTIONS(3101),
    [sym_if] = ACTIONS(3101),
    [sym_immutable] = ACTIONS(3101),
    [sym_import] = ACTIONS(3101),
    [sym_in] = ACTIONS(3101),
    [sym_inout] = ACTIONS(3101),
    [sym_interface] = ACTIONS(3101),
    [sym_invariant] = ACTIONS(3101),
    [sym_is] = ACTIONS(3101),
    [sym_lazy] = ACTIONS(3101),
    [sym_mixin] = ACTIONS(3101),
    [sym_module] = ACTIONS(3101),
    [sym_new] = ACTIONS(3101),
    [sym_nothrow] = ACTIONS(3101),
    [sym_out] = ACTIONS(3101),
    [sym_override] = ACTIONS(3101),
    [sym_package] = ACTIONS(3101),
    [sym_pragma] = ACTIONS(3101),
    [sym_private] = ACTIONS(3101),
    [sym_protected] = ACTIONS(3101),
    [sym_public] = ACTIONS(3101),
    [sym_pure] = ACTIONS(3101),
    [sym_ref] = ACTIONS(3101),
    [sym_return] = ACTIONS(3101),
    [sym_scope] = ACTIONS(3101),
    [sym_shared] = ACTIONS(3101),
    [sym_static] = ACTIONS(3101),
    [sym_struct] = ACTIONS(3101),
    [sym_switch] = ACTIONS(3101),
    [sym_synchronized] = ACTIONS(3101),
    [sym_template] = ACTIONS(3101),
    [sym_throw] = ACTIONS(3101),
    [sym_try] = ACTIONS(3101),
    [sym_typeid] = ACTIONS(3101),
    [sym_typeof] = ACTIONS(3101),
    [sym_union] = ACTIONS(3101),
    [sym_unittest] = ACTIONS(3101),
    [sym_version] = ACTIONS(3101),
    [sym_while] = ACTIONS(3101),
    [sym_with] = ACTIONS(3101),
    [sym_parameters_] = ACTIONS(3101),
    [sym_gshared] = ACTIONS(3101),
    [sym_traits] = ACTIONS(3101),
    [sym_vector] = ACTIONS(3101),
    [sym_void] = ACTIONS(3101),
    [anon_sym_BQUOTE] = ACTIONS(3103),
    [anon_sym_r_DQUOTE] = ACTIONS(3103),
    [anon_sym_x_DQUOTE] = ACTIONS(3103),
    [anon_sym_DQUOTE] = ACTIONS(3103),
    [anon_sym_i_BQUOTE] = ACTIONS(3103),
    [anon_sym_i_DQUOTE] = ACTIONS(3103),
    [anon_sym_iq_LBRACE] = ACTIONS(3103),
    [aux_sym_char_literal_token1] = ACTIONS(3103),
    [anon_sym_SQUOTE] = ACTIONS(3101),
    [anon_sym___DATE__] = ACTIONS(3101),
    [anon_sym___FILE__] = ACTIONS(3101),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3101),
    [anon_sym___FUNCTION__] = ACTIONS(3101),
    [anon_sym___LINE__] = ACTIONS(3101),
    [anon_sym___MODULE__] = ACTIONS(3101),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3101),
    [anon_sym___TIME__] = ACTIONS(3101),
    [anon_sym___TIMESTAMP__] = ACTIONS(3101),
    [anon_sym___VENDOR__] = ACTIONS(3101),
    [anon_sym___VERSION__] = ACTIONS(3101),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3103),
    [sym_float_literal] = ACTIONS(3103),
    [sym__string] = ACTIONS(3103),
  },
  [648] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_q_LBRACE] = ACTIONS(3039),
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_SLASH_EQ] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3037),
    [anon_sym_DOT_DOT] = ACTIONS(3037),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3039),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_AMP_EQ] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE] = ACTIONS(3037),
    [anon_sym_PIPE_EQ] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_DASH_EQ] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_PLUS_EQ] = ACTIONS(3039),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_LT_LT] = ACTIONS(3037),
    [anon_sym_LT_LT_EQ] = ACTIONS(3039),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3037),
    [anon_sym_GT_GT_GT] = ACTIONS(3037),
    [anon_sym_BANG] = ACTIONS(3037),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_DOLLAR] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_EQ_EQ] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_STAR_EQ] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_PERCENT_EQ] = ACTIONS(3039),
    [anon_sym_CARET] = ACTIONS(3037),
    [anon_sym_CARET_EQ] = ACTIONS(3039),
    [anon_sym_CARET_CARET] = ACTIONS(3037),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_TILDE_EQ] = ACTIONS(3039),
    [anon_sym_AT] = ACTIONS(3039),
    [anon_sym_EQ_GT] = ACTIONS(3039),
    [anon_sym_POUND] = ACTIONS(3039),
    [sym_bool] = ACTIONS(3037),
    [sym_byte] = ACTIONS(3037),
    [sym_ubyte] = ACTIONS(3037),
    [sym_char] = ACTIONS(3037),
    [sym_short] = ACTIONS(3037),
    [sym_ushort] = ACTIONS(3037),
    [sym_int] = ACTIONS(3037),
    [sym_uint] = ACTIONS(3037),
    [sym_long] = ACTIONS(3037),
    [sym_ulong] = ACTIONS(3037),
    [sym_cent] = ACTIONS(3037),
    [sym_ucent] = ACTIONS(3037),
    [sym_wchar] = ACTIONS(3037),
    [sym_dchar] = ACTIONS(3037),
    [sym_float] = ACTIONS(3037),
    [sym_double] = ACTIONS(3037),
    [sym_real] = ACTIONS(3037),
    [sym_ifloat] = ACTIONS(3037),
    [sym_idouble] = ACTIONS(3037),
    [sym_ireal] = ACTIONS(3037),
    [sym_cfloat] = ACTIONS(3037),
    [sym_cdouble] = ACTIONS(3037),
    [sym_creal] = ACTIONS(3037),
    [sym_size_t] = ACTIONS(3037),
    [sym_ptrdiff_t] = ACTIONS(3037),
    [sym_string] = ACTIONS(3037),
    [sym_cstring] = ACTIONS(3037),
    [sym_dstring] = ACTIONS(3037),
    [sym_wstring] = ACTIONS(3037),
    [sym_noreturn] = ACTIONS(3037),
    [sym_true] = ACTIONS(3037),
    [sym_false] = ACTIONS(3037),
    [sym_null] = ACTIONS(3037),
    [sym_super] = ACTIONS(3037),
    [sym_this] = ACTIONS(3037),
    [sym_abstract] = ACTIONS(3037),
    [sym_alias] = ACTIONS(3037),
    [sym_align] = ACTIONS(3037),
    [sym_asm] = ACTIONS(3037),
    [sym_assert] = ACTIONS(3037),
    [sym_auto] = ACTIONS(3037),
    [sym_break] = ACTIONS(3037),
    [sym_case] = ACTIONS(3037),
    [sym_cast] = ACTIONS(3037),
    [sym_catch] = ACTIONS(3037),
    [sym_class] = ACTIONS(3037),
    [sym_const] = ACTIONS(3037),
    [sym_continue] = ACTIONS(3037),
    [sym_debug] = ACTIONS(3037),
    [sym_default] = ACTIONS(3037),
    [sym_delegate] = ACTIONS(3037),
    [sym_delete] = ACTIONS(3037),
    [sym_deprecated] = ACTIONS(3037),
    [sym_do] = ACTIONS(3037),
    [sym_else] = ACTIONS(3037),
    [sym_enum] = ACTIONS(3037),
    [sym_export] = ACTIONS(3037),
    [sym_extern] = ACTIONS(3037),
    [sym_final] = ACTIONS(3037),
    [sym_finally] = ACTIONS(3037),
    [sym_for] = ACTIONS(3037),
    [sym_foreach] = ACTIONS(3037),
    [sym_foreach_reverse] = ACTIONS(3037),
    [sym_function] = ACTIONS(3037),
    [sym_goto] = ACTIONS(3037),
    [sym_if] = ACTIONS(3037),
    [sym_immutable] = ACTIONS(3037),
    [sym_import] = ACTIONS(3037),
    [sym_in] = ACTIONS(3037),
    [sym_inout] = ACTIONS(3037),
    [sym_interface] = ACTIONS(3037),
    [sym_invariant] = ACTIONS(3037),
    [sym_is] = ACTIONS(3037),
    [sym_lazy] = ACTIONS(3037),
    [sym_mixin] = ACTIONS(3037),
    [sym_module] = ACTIONS(3037),
    [sym_new] = ACTIONS(3037),
    [sym_nothrow] = ACTIONS(3037),
    [sym_out] = ACTIONS(3037),
    [sym_override] = ACTIONS(3037),
    [sym_package] = ACTIONS(3037),
    [sym_pragma] = ACTIONS(3037),
    [sym_private] = ACTIONS(3037),
    [sym_protected] = ACTIONS(3037),
    [sym_public] = ACTIONS(3037),
    [sym_pure] = ACTIONS(3037),
    [sym_ref] = ACTIONS(3037),
    [sym_return] = ACTIONS(3037),
    [sym_scope] = ACTIONS(3037),
    [sym_shared] = ACTIONS(3037),
    [sym_static] = ACTIONS(3037),
    [sym_struct] = ACTIONS(3037),
    [sym_switch] = ACTIONS(3037),
    [sym_synchronized] = ACTIONS(3037),
    [sym_template] = ACTIONS(3037),
    [sym_throw] = ACTIONS(3037),
    [sym_try] = ACTIONS(3037),
    [sym_typeid] = ACTIONS(3037),
    [sym_typeof] = ACTIONS(3037),
    [sym_union] = ACTIONS(3037),
    [sym_unittest] = ACTIONS(3037),
    [sym_version] = ACTIONS(3037),
    [sym_while] = ACTIONS(3037),
    [sym_with] = ACTIONS(3037),
    [sym_parameters_] = ACTIONS(3037),
    [sym_gshared] = ACTIONS(3037),
    [sym_traits] = ACTIONS(3037),
    [sym_vector] = ACTIONS(3037),
    [sym_void] = ACTIONS(3037),
    [anon_sym_BQUOTE] = ACTIONS(3039),
    [anon_sym_r_DQUOTE] = ACTIONS(3039),
    [anon_sym_x_DQUOTE] = ACTIONS(3039),
    [anon_sym_DQUOTE] = ACTIONS(3039),
    [anon_sym_i_BQUOTE] = ACTIONS(3039),
    [anon_sym_i_DQUOTE] = ACTIONS(3039),
    [anon_sym_iq_LBRACE] = ACTIONS(3039),
    [aux_sym_char_literal_token1] = ACTIONS(3039),
    [anon_sym_SQUOTE] = ACTIONS(3037),
    [anon_sym___DATE__] = ACTIONS(3037),
    [anon_sym___FILE__] = ACTIONS(3037),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3037),
    [anon_sym___FUNCTION__] = ACTIONS(3037),
    [anon_sym___LINE__] = ACTIONS(3037),
    [anon_sym___MODULE__] = ACTIONS(3037),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3037),
    [anon_sym___TIME__] = ACTIONS(3037),
    [anon_sym___TIMESTAMP__] = ACTIONS(3037),
    [anon_sym___VENDOR__] = ACTIONS(3037),
    [anon_sym___VERSION__] = ACTIONS(3037),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3039),
    [sym_float_literal] = ACTIONS(3039),
    [sym__string] = ACTIONS(3039),
  },
  [649] = {
    [sym_identifier] = ACTIONS(3081),
    [anon_sym_q_LBRACE] = ACTIONS(3083),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_LBRACE] = ACTIONS(3083),
    [anon_sym_SLASH] = ACTIONS(3081),
    [anon_sym_SLASH_EQ] = ACTIONS(3083),
    [anon_sym_DOT] = ACTIONS(3081),
    [anon_sym_DOT_DOT] = ACTIONS(3081),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3083),
    [anon_sym_AMP] = ACTIONS(3081),
    [anon_sym_AMP_EQ] = ACTIONS(3083),
    [anon_sym_AMP_AMP] = ACTIONS(3083),
    [anon_sym_PIPE] = ACTIONS(3081),
    [anon_sym_PIPE_EQ] = ACTIONS(3083),
    [anon_sym_PIPE_PIPE] = ACTIONS(3083),
    [anon_sym_DASH] = ACTIONS(3081),
    [anon_sym_DASH_EQ] = ACTIONS(3083),
    [anon_sym_DASH_DASH] = ACTIONS(3083),
    [anon_sym_PLUS] = ACTIONS(3081),
    [anon_sym_PLUS_EQ] = ACTIONS(3083),
    [anon_sym_PLUS_PLUS] = ACTIONS(3083),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_LT_EQ] = ACTIONS(3083),
    [anon_sym_LT_LT] = ACTIONS(3081),
    [anon_sym_LT_LT_EQ] = ACTIONS(3083),
    [anon_sym_GT] = ACTIONS(3081),
    [anon_sym_GT_EQ] = ACTIONS(3083),
    [anon_sym_GT_GT_EQ] = ACTIONS(3083),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3083),
    [anon_sym_GT_GT] = ACTIONS(3081),
    [anon_sym_GT_GT_GT] = ACTIONS(3081),
    [anon_sym_BANG] = ACTIONS(3081),
    [anon_sym_BANG_EQ] = ACTIONS(3083),
    [anon_sym_LPAREN] = ACTIONS(3083),
    [anon_sym_RPAREN] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(3083),
    [anon_sym_RBRACK] = ACTIONS(3083),
    [anon_sym_QMARK] = ACTIONS(3083),
    [anon_sym_COMMA] = ACTIONS(3083),
    [anon_sym_SEMI] = ACTIONS(3083),
    [anon_sym_COLON] = ACTIONS(3083),
    [anon_sym_DOLLAR] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_EQ_EQ] = ACTIONS(3083),
    [anon_sym_STAR] = ACTIONS(3081),
    [anon_sym_STAR_EQ] = ACTIONS(3083),
    [anon_sym_PERCENT] = ACTIONS(3081),
    [anon_sym_PERCENT_EQ] = ACTIONS(3083),
    [anon_sym_CARET] = ACTIONS(3081),
    [anon_sym_CARET_EQ] = ACTIONS(3083),
    [anon_sym_CARET_CARET] = ACTIONS(3081),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3083),
    [anon_sym_TILDE] = ACTIONS(3081),
    [anon_sym_TILDE_EQ] = ACTIONS(3083),
    [anon_sym_AT] = ACTIONS(3083),
    [anon_sym_EQ_GT] = ACTIONS(3083),
    [anon_sym_POUND] = ACTIONS(3083),
    [sym_bool] = ACTIONS(3081),
    [sym_byte] = ACTIONS(3081),
    [sym_ubyte] = ACTIONS(3081),
    [sym_char] = ACTIONS(3081),
    [sym_short] = ACTIONS(3081),
    [sym_ushort] = ACTIONS(3081),
    [sym_int] = ACTIONS(3081),
    [sym_uint] = ACTIONS(3081),
    [sym_long] = ACTIONS(3081),
    [sym_ulong] = ACTIONS(3081),
    [sym_cent] = ACTIONS(3081),
    [sym_ucent] = ACTIONS(3081),
    [sym_wchar] = ACTIONS(3081),
    [sym_dchar] = ACTIONS(3081),
    [sym_float] = ACTIONS(3081),
    [sym_double] = ACTIONS(3081),
    [sym_real] = ACTIONS(3081),
    [sym_ifloat] = ACTIONS(3081),
    [sym_idouble] = ACTIONS(3081),
    [sym_ireal] = ACTIONS(3081),
    [sym_cfloat] = ACTIONS(3081),
    [sym_cdouble] = ACTIONS(3081),
    [sym_creal] = ACTIONS(3081),
    [sym_size_t] = ACTIONS(3081),
    [sym_ptrdiff_t] = ACTIONS(3081),
    [sym_string] = ACTIONS(3081),
    [sym_cstring] = ACTIONS(3081),
    [sym_dstring] = ACTIONS(3081),
    [sym_wstring] = ACTIONS(3081),
    [sym_noreturn] = ACTIONS(3081),
    [sym_true] = ACTIONS(3081),
    [sym_false] = ACTIONS(3081),
    [sym_null] = ACTIONS(3081),
    [sym_super] = ACTIONS(3081),
    [sym_this] = ACTIONS(3081),
    [sym_abstract] = ACTIONS(3081),
    [sym_alias] = ACTIONS(3081),
    [sym_align] = ACTIONS(3081),
    [sym_asm] = ACTIONS(3081),
    [sym_assert] = ACTIONS(3081),
    [sym_auto] = ACTIONS(3081),
    [sym_break] = ACTIONS(3081),
    [sym_case] = ACTIONS(3081),
    [sym_cast] = ACTIONS(3081),
    [sym_catch] = ACTIONS(3081),
    [sym_class] = ACTIONS(3081),
    [sym_const] = ACTIONS(3081),
    [sym_continue] = ACTIONS(3081),
    [sym_debug] = ACTIONS(3081),
    [sym_default] = ACTIONS(3081),
    [sym_delegate] = ACTIONS(3081),
    [sym_delete] = ACTIONS(3081),
    [sym_deprecated] = ACTIONS(3081),
    [sym_do] = ACTIONS(3081),
    [sym_else] = ACTIONS(3081),
    [sym_enum] = ACTIONS(3081),
    [sym_export] = ACTIONS(3081),
    [sym_extern] = ACTIONS(3081),
    [sym_final] = ACTIONS(3081),
    [sym_finally] = ACTIONS(3081),
    [sym_for] = ACTIONS(3081),
    [sym_foreach] = ACTIONS(3081),
    [sym_foreach_reverse] = ACTIONS(3081),
    [sym_function] = ACTIONS(3081),
    [sym_goto] = ACTIONS(3081),
    [sym_if] = ACTIONS(3081),
    [sym_immutable] = ACTIONS(3081),
    [sym_import] = ACTIONS(3081),
    [sym_in] = ACTIONS(3081),
    [sym_inout] = ACTIONS(3081),
    [sym_interface] = ACTIONS(3081),
    [sym_invariant] = ACTIONS(3081),
    [sym_is] = ACTIONS(3081),
    [sym_lazy] = ACTIONS(3081),
    [sym_mixin] = ACTIONS(3081),
    [sym_module] = ACTIONS(3081),
    [sym_new] = ACTIONS(3081),
    [sym_nothrow] = ACTIONS(3081),
    [sym_out] = ACTIONS(3081),
    [sym_override] = ACTIONS(3081),
    [sym_package] = ACTIONS(3081),
    [sym_pragma] = ACTIONS(3081),
    [sym_private] = ACTIONS(3081),
    [sym_protected] = ACTIONS(3081),
    [sym_public] = ACTIONS(3081),
    [sym_pure] = ACTIONS(3081),
    [sym_ref] = ACTIONS(3081),
    [sym_return] = ACTIONS(3081),
    [sym_scope] = ACTIONS(3081),
    [sym_shared] = ACTIONS(3081),
    [sym_static] = ACTIONS(3081),
    [sym_struct] = ACTIONS(3081),
    [sym_switch] = ACTIONS(3081),
    [sym_synchronized] = ACTIONS(3081),
    [sym_template] = ACTIONS(3081),
    [sym_throw] = ACTIONS(3081),
    [sym_try] = ACTIONS(3081),
    [sym_typeid] = ACTIONS(3081),
    [sym_typeof] = ACTIONS(3081),
    [sym_union] = ACTIONS(3081),
    [sym_unittest] = ACTIONS(3081),
    [sym_version] = ACTIONS(3081),
    [sym_while] = ACTIONS(3081),
    [sym_with] = ACTIONS(3081),
    [sym_parameters_] = ACTIONS(3081),
    [sym_gshared] = ACTIONS(3081),
    [sym_traits] = ACTIONS(3081),
    [sym_vector] = ACTIONS(3081),
    [sym_void] = ACTIONS(3081),
    [anon_sym_BQUOTE] = ACTIONS(3083),
    [anon_sym_r_DQUOTE] = ACTIONS(3083),
    [anon_sym_x_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_i_BQUOTE] = ACTIONS(3083),
    [anon_sym_i_DQUOTE] = ACTIONS(3083),
    [anon_sym_iq_LBRACE] = ACTIONS(3083),
    [aux_sym_char_literal_token1] = ACTIONS(3083),
    [anon_sym_SQUOTE] = ACTIONS(3081),
    [anon_sym___DATE__] = ACTIONS(3081),
    [anon_sym___FILE__] = ACTIONS(3081),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3081),
    [anon_sym___FUNCTION__] = ACTIONS(3081),
    [anon_sym___LINE__] = ACTIONS(3081),
    [anon_sym___MODULE__] = ACTIONS(3081),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3081),
    [anon_sym___TIME__] = ACTIONS(3081),
    [anon_sym___TIMESTAMP__] = ACTIONS(3081),
    [anon_sym___VENDOR__] = ACTIONS(3081),
    [anon_sym___VERSION__] = ACTIONS(3081),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3083),
    [sym_float_literal] = ACTIONS(3083),
    [sym__string] = ACTIONS(3083),
  },
  [650] = {
    [sym_identifier] = ACTIONS(3077),
    [anon_sym_q_LBRACE] = ACTIONS(3079),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_SLASH] = ACTIONS(3077),
    [anon_sym_SLASH_EQ] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3077),
    [anon_sym_DOT_DOT] = ACTIONS(3077),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_AMP_EQ] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_PIPE] = ACTIONS(3077),
    [anon_sym_PIPE_EQ] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_DASH_EQ] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3077),
    [anon_sym_PLUS_EQ] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_LT_EQ] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3077),
    [anon_sym_LT_LT_EQ] = ACTIONS(3079),
    [anon_sym_GT] = ACTIONS(3077),
    [anon_sym_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT] = ACTIONS(3077),
    [anon_sym_GT_GT_GT] = ACTIONS(3077),
    [anon_sym_BANG] = ACTIONS(3077),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_RBRACK] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_DOLLAR] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_EQ_EQ] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_STAR_EQ] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3077),
    [anon_sym_PERCENT_EQ] = ACTIONS(3079),
    [anon_sym_CARET] = ACTIONS(3077),
    [anon_sym_CARET_EQ] = ACTIONS(3079),
    [anon_sym_CARET_CARET] = ACTIONS(3077),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_TILDE_EQ] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3079),
    [anon_sym_EQ_GT] = ACTIONS(3079),
    [anon_sym_POUND] = ACTIONS(3079),
    [sym_bool] = ACTIONS(3077),
    [sym_byte] = ACTIONS(3077),
    [sym_ubyte] = ACTIONS(3077),
    [sym_char] = ACTIONS(3077),
    [sym_short] = ACTIONS(3077),
    [sym_ushort] = ACTIONS(3077),
    [sym_int] = ACTIONS(3077),
    [sym_uint] = ACTIONS(3077),
    [sym_long] = ACTIONS(3077),
    [sym_ulong] = ACTIONS(3077),
    [sym_cent] = ACTIONS(3077),
    [sym_ucent] = ACTIONS(3077),
    [sym_wchar] = ACTIONS(3077),
    [sym_dchar] = ACTIONS(3077),
    [sym_float] = ACTIONS(3077),
    [sym_double] = ACTIONS(3077),
    [sym_real] = ACTIONS(3077),
    [sym_ifloat] = ACTIONS(3077),
    [sym_idouble] = ACTIONS(3077),
    [sym_ireal] = ACTIONS(3077),
    [sym_cfloat] = ACTIONS(3077),
    [sym_cdouble] = ACTIONS(3077),
    [sym_creal] = ACTIONS(3077),
    [sym_size_t] = ACTIONS(3077),
    [sym_ptrdiff_t] = ACTIONS(3077),
    [sym_string] = ACTIONS(3077),
    [sym_cstring] = ACTIONS(3077),
    [sym_dstring] = ACTIONS(3077),
    [sym_wstring] = ACTIONS(3077),
    [sym_noreturn] = ACTIONS(3077),
    [sym_true] = ACTIONS(3077),
    [sym_false] = ACTIONS(3077),
    [sym_null] = ACTIONS(3077),
    [sym_super] = ACTIONS(3077),
    [sym_this] = ACTIONS(3077),
    [sym_abstract] = ACTIONS(3077),
    [sym_alias] = ACTIONS(3077),
    [sym_align] = ACTIONS(3077),
    [sym_asm] = ACTIONS(3077),
    [sym_assert] = ACTIONS(3077),
    [sym_auto] = ACTIONS(3077),
    [sym_break] = ACTIONS(3077),
    [sym_case] = ACTIONS(3077),
    [sym_cast] = ACTIONS(3077),
    [sym_catch] = ACTIONS(3077),
    [sym_class] = ACTIONS(3077),
    [sym_const] = ACTIONS(3077),
    [sym_continue] = ACTIONS(3077),
    [sym_debug] = ACTIONS(3077),
    [sym_default] = ACTIONS(3077),
    [sym_delegate] = ACTIONS(3077),
    [sym_delete] = ACTIONS(3077),
    [sym_deprecated] = ACTIONS(3077),
    [sym_do] = ACTIONS(3077),
    [sym_else] = ACTIONS(3077),
    [sym_enum] = ACTIONS(3077),
    [sym_export] = ACTIONS(3077),
    [sym_extern] = ACTIONS(3077),
    [sym_final] = ACTIONS(3077),
    [sym_finally] = ACTIONS(3077),
    [sym_for] = ACTIONS(3077),
    [sym_foreach] = ACTIONS(3077),
    [sym_foreach_reverse] = ACTIONS(3077),
    [sym_function] = ACTIONS(3077),
    [sym_goto] = ACTIONS(3077),
    [sym_if] = ACTIONS(3077),
    [sym_immutable] = ACTIONS(3077),
    [sym_import] = ACTIONS(3077),
    [sym_in] = ACTIONS(3077),
    [sym_inout] = ACTIONS(3077),
    [sym_interface] = ACTIONS(3077),
    [sym_invariant] = ACTIONS(3077),
    [sym_is] = ACTIONS(3077),
    [sym_lazy] = ACTIONS(3077),
    [sym_mixin] = ACTIONS(3077),
    [sym_module] = ACTIONS(3077),
    [sym_new] = ACTIONS(3077),
    [sym_nothrow] = ACTIONS(3077),
    [sym_out] = ACTIONS(3077),
    [sym_override] = ACTIONS(3077),
    [sym_package] = ACTIONS(3077),
    [sym_pragma] = ACTIONS(3077),
    [sym_private] = ACTIONS(3077),
    [sym_protected] = ACTIONS(3077),
    [sym_public] = ACTIONS(3077),
    [sym_pure] = ACTIONS(3077),
    [sym_ref] = ACTIONS(3077),
    [sym_return] = ACTIONS(3077),
    [sym_scope] = ACTIONS(3077),
    [sym_shared] = ACTIONS(3077),
    [sym_static] = ACTIONS(3077),
    [sym_struct] = ACTIONS(3077),
    [sym_switch] = ACTIONS(3077),
    [sym_synchronized] = ACTIONS(3077),
    [sym_template] = ACTIONS(3077),
    [sym_throw] = ACTIONS(3077),
    [sym_try] = ACTIONS(3077),
    [sym_typeid] = ACTIONS(3077),
    [sym_typeof] = ACTIONS(3077),
    [sym_union] = ACTIONS(3077),
    [sym_unittest] = ACTIONS(3077),
    [sym_version] = ACTIONS(3077),
    [sym_while] = ACTIONS(3077),
    [sym_with] = ACTIONS(3077),
    [sym_parameters_] = ACTIONS(3077),
    [sym_gshared] = ACTIONS(3077),
    [sym_traits] = ACTIONS(3077),
    [sym_vector] = ACTIONS(3077),
    [sym_void] = ACTIONS(3077),
    [anon_sym_BQUOTE] = ACTIONS(3079),
    [anon_sym_r_DQUOTE] = ACTIONS(3079),
    [anon_sym_x_DQUOTE] = ACTIONS(3079),
    [anon_sym_DQUOTE] = ACTIONS(3079),
    [anon_sym_i_BQUOTE] = ACTIONS(3079),
    [anon_sym_i_DQUOTE] = ACTIONS(3079),
    [anon_sym_iq_LBRACE] = ACTIONS(3079),
    [aux_sym_char_literal_token1] = ACTIONS(3079),
    [anon_sym_SQUOTE] = ACTIONS(3077),
    [anon_sym___DATE__] = ACTIONS(3077),
    [anon_sym___FILE__] = ACTIONS(3077),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3077),
    [anon_sym___FUNCTION__] = ACTIONS(3077),
    [anon_sym___LINE__] = ACTIONS(3077),
    [anon_sym___MODULE__] = ACTIONS(3077),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3077),
    [anon_sym___TIME__] = ACTIONS(3077),
    [anon_sym___TIMESTAMP__] = ACTIONS(3077),
    [anon_sym___VENDOR__] = ACTIONS(3077),
    [anon_sym___VERSION__] = ACTIONS(3077),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3079),
    [sym_float_literal] = ACTIONS(3079),
    [sym__string] = ACTIONS(3079),
  },
  [651] = {
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_q_LBRACE] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_SLASH_EQ] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_DOT_DOT] = ACTIONS(3065),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_AMP_EQ] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_PIPE_EQ] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_EQ] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_PLUS_EQ] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_LT_LT_EQ] = ACTIONS(3067),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_BANG] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_DOLLAR] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_STAR_EQ] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_PERCENT_EQ] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_CARET_EQ] = ACTIONS(3067),
    [anon_sym_CARET_CARET] = ACTIONS(3065),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_TILDE_EQ] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_EQ_GT] = ACTIONS(3067),
    [anon_sym_POUND] = ACTIONS(3067),
    [sym_bool] = ACTIONS(3065),
    [sym_byte] = ACTIONS(3065),
    [sym_ubyte] = ACTIONS(3065),
    [sym_char] = ACTIONS(3065),
    [sym_short] = ACTIONS(3065),
    [sym_ushort] = ACTIONS(3065),
    [sym_int] = ACTIONS(3065),
    [sym_uint] = ACTIONS(3065),
    [sym_long] = ACTIONS(3065),
    [sym_ulong] = ACTIONS(3065),
    [sym_cent] = ACTIONS(3065),
    [sym_ucent] = ACTIONS(3065),
    [sym_wchar] = ACTIONS(3065),
    [sym_dchar] = ACTIONS(3065),
    [sym_float] = ACTIONS(3065),
    [sym_double] = ACTIONS(3065),
    [sym_real] = ACTIONS(3065),
    [sym_ifloat] = ACTIONS(3065),
    [sym_idouble] = ACTIONS(3065),
    [sym_ireal] = ACTIONS(3065),
    [sym_cfloat] = ACTIONS(3065),
    [sym_cdouble] = ACTIONS(3065),
    [sym_creal] = ACTIONS(3065),
    [sym_size_t] = ACTIONS(3065),
    [sym_ptrdiff_t] = ACTIONS(3065),
    [sym_string] = ACTIONS(3065),
    [sym_cstring] = ACTIONS(3065),
    [sym_dstring] = ACTIONS(3065),
    [sym_wstring] = ACTIONS(3065),
    [sym_noreturn] = ACTIONS(3065),
    [sym_true] = ACTIONS(3065),
    [sym_false] = ACTIONS(3065),
    [sym_null] = ACTIONS(3065),
    [sym_super] = ACTIONS(3065),
    [sym_this] = ACTIONS(3065),
    [sym_abstract] = ACTIONS(3065),
    [sym_alias] = ACTIONS(3065),
    [sym_align] = ACTIONS(3065),
    [sym_asm] = ACTIONS(3065),
    [sym_assert] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [sym_break] = ACTIONS(3065),
    [sym_case] = ACTIONS(3065),
    [sym_cast] = ACTIONS(3065),
    [sym_catch] = ACTIONS(3065),
    [sym_class] = ACTIONS(3065),
    [sym_const] = ACTIONS(3065),
    [sym_continue] = ACTIONS(3065),
    [sym_debug] = ACTIONS(3065),
    [sym_default] = ACTIONS(3065),
    [sym_delegate] = ACTIONS(3065),
    [sym_delete] = ACTIONS(3065),
    [sym_deprecated] = ACTIONS(3065),
    [sym_do] = ACTIONS(3065),
    [sym_else] = ACTIONS(3065),
    [sym_enum] = ACTIONS(3065),
    [sym_export] = ACTIONS(3065),
    [sym_extern] = ACTIONS(3065),
    [sym_final] = ACTIONS(3065),
    [sym_finally] = ACTIONS(3065),
    [sym_for] = ACTIONS(3065),
    [sym_foreach] = ACTIONS(3065),
    [sym_foreach_reverse] = ACTIONS(3065),
    [sym_function] = ACTIONS(3065),
    [sym_goto] = ACTIONS(3065),
    [sym_if] = ACTIONS(3065),
    [sym_immutable] = ACTIONS(3065),
    [sym_import] = ACTIONS(3065),
    [sym_in] = ACTIONS(3065),
    [sym_inout] = ACTIONS(3065),
    [sym_interface] = ACTIONS(3065),
    [sym_invariant] = ACTIONS(3065),
    [sym_is] = ACTIONS(3065),
    [sym_lazy] = ACTIONS(3065),
    [sym_mixin] = ACTIONS(3065),
    [sym_module] = ACTIONS(3065),
    [sym_new] = ACTIONS(3065),
    [sym_nothrow] = ACTIONS(3065),
    [sym_out] = ACTIONS(3065),
    [sym_override] = ACTIONS(3065),
    [sym_package] = ACTIONS(3065),
    [sym_pragma] = ACTIONS(3065),
    [sym_private] = ACTIONS(3065),
    [sym_protected] = ACTIONS(3065),
    [sym_public] = ACTIONS(3065),
    [sym_pure] = ACTIONS(3065),
    [sym_ref] = ACTIONS(3065),
    [sym_return] = ACTIONS(3065),
    [sym_scope] = ACTIONS(3065),
    [sym_shared] = ACTIONS(3065),
    [sym_static] = ACTIONS(3065),
    [sym_struct] = ACTIONS(3065),
    [sym_switch] = ACTIONS(3065),
    [sym_synchronized] = ACTIONS(3065),
    [sym_template] = ACTIONS(3065),
    [sym_throw] = ACTIONS(3065),
    [sym_try] = ACTIONS(3065),
    [sym_typeid] = ACTIONS(3065),
    [sym_typeof] = ACTIONS(3065),
    [sym_union] = ACTIONS(3065),
    [sym_unittest] = ACTIONS(3065),
    [sym_version] = ACTIONS(3065),
    [sym_while] = ACTIONS(3065),
    [sym_with] = ACTIONS(3065),
    [sym_parameters_] = ACTIONS(3065),
    [sym_gshared] = ACTIONS(3065),
    [sym_traits] = ACTIONS(3065),
    [sym_vector] = ACTIONS(3065),
    [sym_void] = ACTIONS(3065),
    [anon_sym_BQUOTE] = ACTIONS(3067),
    [anon_sym_r_DQUOTE] = ACTIONS(3067),
    [anon_sym_x_DQUOTE] = ACTIONS(3067),
    [anon_sym_DQUOTE] = ACTIONS(3067),
    [anon_sym_i_BQUOTE] = ACTIONS(3067),
    [anon_sym_i_DQUOTE] = ACTIONS(3067),
    [anon_sym_iq_LBRACE] = ACTIONS(3067),
    [aux_sym_char_literal_token1] = ACTIONS(3067),
    [anon_sym_SQUOTE] = ACTIONS(3065),
    [anon_sym___DATE__] = ACTIONS(3065),
    [anon_sym___FILE__] = ACTIONS(3065),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3065),
    [anon_sym___FUNCTION__] = ACTIONS(3065),
    [anon_sym___LINE__] = ACTIONS(3065),
    [anon_sym___MODULE__] = ACTIONS(3065),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3065),
    [anon_sym___TIME__] = ACTIONS(3065),
    [anon_sym___TIMESTAMP__] = ACTIONS(3065),
    [anon_sym___VENDOR__] = ACTIONS(3065),
    [anon_sym___VERSION__] = ACTIONS(3065),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3067),
    [sym_float_literal] = ACTIONS(3067),
    [sym__string] = ACTIONS(3067),
  },
  [652] = {
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_q_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3121),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3124),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym_DOLLAR] = ACTIONS(3124),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3124),
    [sym_bool] = ACTIONS(3121),
    [sym_byte] = ACTIONS(3121),
    [sym_ubyte] = ACTIONS(3121),
    [sym_char] = ACTIONS(3121),
    [sym_short] = ACTIONS(3121),
    [sym_ushort] = ACTIONS(3121),
    [sym_int] = ACTIONS(3121),
    [sym_uint] = ACTIONS(3121),
    [sym_long] = ACTIONS(3121),
    [sym_ulong] = ACTIONS(3121),
    [sym_cent] = ACTIONS(3121),
    [sym_ucent] = ACTIONS(3121),
    [sym_wchar] = ACTIONS(3121),
    [sym_dchar] = ACTIONS(3121),
    [sym_float] = ACTIONS(3121),
    [sym_double] = ACTIONS(3121),
    [sym_real] = ACTIONS(3121),
    [sym_ifloat] = ACTIONS(3121),
    [sym_idouble] = ACTIONS(3121),
    [sym_ireal] = ACTIONS(3121),
    [sym_cfloat] = ACTIONS(3121),
    [sym_cdouble] = ACTIONS(3121),
    [sym_creal] = ACTIONS(3121),
    [sym_size_t] = ACTIONS(3121),
    [sym_ptrdiff_t] = ACTIONS(3121),
    [sym_string] = ACTIONS(3121),
    [sym_cstring] = ACTIONS(3121),
    [sym_dstring] = ACTIONS(3121),
    [sym_wstring] = ACTIONS(3121),
    [sym_noreturn] = ACTIONS(3121),
    [sym_true] = ACTIONS(3121),
    [sym_false] = ACTIONS(3121),
    [sym_null] = ACTIONS(3121),
    [sym_super] = ACTIONS(3121),
    [sym_this] = ACTIONS(3121),
    [sym_abstract] = ACTIONS(3121),
    [sym_alias] = ACTIONS(3121),
    [sym_align] = ACTIONS(3121),
    [sym_asm] = ACTIONS(3121),
    [sym_assert] = ACTIONS(3121),
    [sym_auto] = ACTIONS(3121),
    [sym_break] = ACTIONS(3121),
    [sym_case] = ACTIONS(3121),
    [sym_cast] = ACTIONS(3121),
    [sym_catch] = ACTIONS(3121),
    [sym_class] = ACTIONS(3121),
    [sym_const] = ACTIONS(3121),
    [sym_continue] = ACTIONS(3121),
    [sym_debug] = ACTIONS(3121),
    [sym_default] = ACTIONS(3121),
    [sym_delegate] = ACTIONS(3121),
    [sym_delete] = ACTIONS(3121),
    [sym_deprecated] = ACTIONS(3121),
    [sym_do] = ACTIONS(3121),
    [sym_else] = ACTIONS(3121),
    [sym_enum] = ACTIONS(3121),
    [sym_export] = ACTIONS(3121),
    [sym_extern] = ACTIONS(3121),
    [sym_final] = ACTIONS(3121),
    [sym_finally] = ACTIONS(3121),
    [sym_for] = ACTIONS(3121),
    [sym_foreach] = ACTIONS(3121),
    [sym_foreach_reverse] = ACTIONS(3121),
    [sym_function] = ACTIONS(3121),
    [sym_goto] = ACTIONS(3121),
    [sym_if] = ACTIONS(3121),
    [sym_immutable] = ACTIONS(3121),
    [sym_import] = ACTIONS(3121),
    [sym_in] = ACTIONS(3121),
    [sym_inout] = ACTIONS(3121),
    [sym_interface] = ACTIONS(3121),
    [sym_invariant] = ACTIONS(3121),
    [sym_is] = ACTIONS(3121),
    [sym_mixin] = ACTIONS(3121),
    [sym_new] = ACTIONS(3121),
    [sym_nothrow] = ACTIONS(3121),
    [sym_out] = ACTIONS(3121),
    [sym_override] = ACTIONS(3121),
    [sym_package] = ACTIONS(3121),
    [sym_pragma] = ACTIONS(3121),
    [sym_private] = ACTIONS(3121),
    [sym_protected] = ACTIONS(3121),
    [sym_public] = ACTIONS(3121),
    [sym_pure] = ACTIONS(3121),
    [sym_ref] = ACTIONS(3121),
    [sym_return] = ACTIONS(3121),
    [sym_scope] = ACTIONS(3121),
    [sym_shared] = ACTIONS(3121),
    [sym_static] = ACTIONS(3121),
    [sym_struct] = ACTIONS(3121),
    [sym_switch] = ACTIONS(3121),
    [sym_synchronized] = ACTIONS(3121),
    [sym_template] = ACTIONS(3121),
    [sym_throw] = ACTIONS(3121),
    [sym_try] = ACTIONS(3121),
    [sym_typeid] = ACTIONS(3121),
    [sym_typeof] = ACTIONS(3121),
    [sym_union] = ACTIONS(3121),
    [sym_unittest] = ACTIONS(3121),
    [sym_version] = ACTIONS(3121),
    [sym_while] = ACTIONS(3121),
    [sym_with] = ACTIONS(3121),
    [sym_gshared] = ACTIONS(3121),
    [sym_traits] = ACTIONS(3121),
    [sym_vector] = ACTIONS(3121),
    [sym_void] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_r_DQUOTE] = ACTIONS(3124),
    [anon_sym_x_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [anon_sym_i_BQUOTE] = ACTIONS(3124),
    [anon_sym_i_DQUOTE] = ACTIONS(3124),
    [anon_sym_iq_LBRACE] = ACTIONS(3124),
    [aux_sym_char_literal_token1] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [anon_sym___DATE__] = ACTIONS(3121),
    [anon_sym___FILE__] = ACTIONS(3121),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3121),
    [anon_sym___FUNCTION__] = ACTIONS(3121),
    [anon_sym___LINE__] = ACTIONS(3121),
    [anon_sym___MODULE__] = ACTIONS(3121),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3121),
    [anon_sym___TIME__] = ACTIONS(3121),
    [anon_sym___TIMESTAMP__] = ACTIONS(3121),
    [anon_sym___VENDOR__] = ACTIONS(3121),
    [anon_sym___VERSION__] = ACTIONS(3121),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3124),
    [sym_float_literal] = ACTIONS(3124),
    [sym__string] = ACTIONS(3124),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [653] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_q_LBRACE] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_SLASH] = ACTIONS(3135),
    [anon_sym_SLASH_EQ] = ACTIONS(3137),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_AMP_EQ] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PIPE_EQ] = ACTIONS(3137),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_DASH_EQ] = ACTIONS(3137),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_PLUS_EQ] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_LT_EQ] = ACTIONS(3137),
    [anon_sym_LT_LT] = ACTIONS(3135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3135),
    [anon_sym_GT_GT_GT] = ACTIONS(3135),
    [anon_sym_BANG] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(3133),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_EQ_EQ] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_STAR_EQ] = ACTIONS(3137),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3137),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_CARET_EQ] = ACTIONS(3137),
    [anon_sym_CARET_CARET] = ACTIONS(3135),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_TILDE_EQ] = ACTIONS(3137),
    [anon_sym_AT] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_byte] = ACTIONS(3131),
    [sym_ubyte] = ACTIONS(3131),
    [sym_char] = ACTIONS(3131),
    [sym_short] = ACTIONS(3131),
    [sym_ushort] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_uint] = ACTIONS(3131),
    [sym_long] = ACTIONS(3131),
    [sym_ulong] = ACTIONS(3131),
    [sym_cent] = ACTIONS(3131),
    [sym_ucent] = ACTIONS(3131),
    [sym_wchar] = ACTIONS(3131),
    [sym_dchar] = ACTIONS(3131),
    [sym_float] = ACTIONS(3131),
    [sym_double] = ACTIONS(3131),
    [sym_real] = ACTIONS(3131),
    [sym_ifloat] = ACTIONS(3131),
    [sym_idouble] = ACTIONS(3131),
    [sym_ireal] = ACTIONS(3131),
    [sym_cfloat] = ACTIONS(3131),
    [sym_cdouble] = ACTIONS(3131),
    [sym_creal] = ACTIONS(3131),
    [sym_size_t] = ACTIONS(3131),
    [sym_ptrdiff_t] = ACTIONS(3131),
    [sym_string] = ACTIONS(3131),
    [sym_cstring] = ACTIONS(3131),
    [sym_dstring] = ACTIONS(3131),
    [sym_wstring] = ACTIONS(3131),
    [sym_noreturn] = ACTIONS(3131),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_super] = ACTIONS(3131),
    [sym_this] = ACTIONS(3131),
    [sym_abstract] = ACTIONS(3131),
    [sym_alias] = ACTIONS(3131),
    [sym_align] = ACTIONS(3131),
    [sym_asm] = ACTIONS(3131),
    [sym_assert] = ACTIONS(3131),
    [sym_auto] = ACTIONS(3131),
    [sym_break] = ACTIONS(3131),
    [sym_case] = ACTIONS(3131),
    [sym_cast] = ACTIONS(3131),
    [sym_catch] = ACTIONS(3131),
    [sym_class] = ACTIONS(3131),
    [sym_const] = ACTIONS(3131),
    [sym_continue] = ACTIONS(3131),
    [sym_debug] = ACTIONS(3131),
    [sym_default] = ACTIONS(3131),
    [sym_delegate] = ACTIONS(3131),
    [sym_delete] = ACTIONS(3131),
    [sym_deprecated] = ACTIONS(3131),
    [sym_do] = ACTIONS(3131),
    [sym_else] = ACTIONS(3131),
    [sym_enum] = ACTIONS(3131),
    [sym_export] = ACTIONS(3131),
    [sym_extern] = ACTIONS(3131),
    [sym_final] = ACTIONS(3131),
    [sym_finally] = ACTIONS(3131),
    [sym_for] = ACTIONS(3131),
    [sym_foreach] = ACTIONS(3131),
    [sym_foreach_reverse] = ACTIONS(3131),
    [sym_function] = ACTIONS(3131),
    [sym_goto] = ACTIONS(3131),
    [sym_if] = ACTIONS(3131),
    [sym_immutable] = ACTIONS(3131),
    [sym_import] = ACTIONS(3131),
    [sym_in] = ACTIONS(3142),
    [sym_inout] = ACTIONS(3131),
    [sym_interface] = ACTIONS(3131),
    [sym_invariant] = ACTIONS(3131),
    [sym_is] = ACTIONS(3142),
    [sym_mixin] = ACTIONS(3131),
    [sym_new] = ACTIONS(3131),
    [sym_nothrow] = ACTIONS(3131),
    [sym_out] = ACTIONS(3131),
    [sym_override] = ACTIONS(3131),
    [sym_package] = ACTIONS(3131),
    [sym_pragma] = ACTIONS(3131),
    [sym_private] = ACTIONS(3131),
    [sym_protected] = ACTIONS(3131),
    [sym_public] = ACTIONS(3131),
    [sym_pure] = ACTIONS(3131),
    [sym_ref] = ACTIONS(3131),
    [sym_return] = ACTIONS(3131),
    [sym_scope] = ACTIONS(3131),
    [sym_shared] = ACTIONS(3131),
    [sym_static] = ACTIONS(3131),
    [sym_struct] = ACTIONS(3131),
    [sym_switch] = ACTIONS(3131),
    [sym_synchronized] = ACTIONS(3131),
    [sym_template] = ACTIONS(3131),
    [sym_throw] = ACTIONS(3131),
    [sym_try] = ACTIONS(3131),
    [sym_typeid] = ACTIONS(3131),
    [sym_typeof] = ACTIONS(3131),
    [sym_union] = ACTIONS(3131),
    [sym_unittest] = ACTIONS(3131),
    [sym_version] = ACTIONS(3131),
    [sym_while] = ACTIONS(3131),
    [sym_with] = ACTIONS(3131),
    [sym_gshared] = ACTIONS(3131),
    [sym_traits] = ACTIONS(3131),
    [sym_vector] = ACTIONS(3131),
    [sym_void] = ACTIONS(3131),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [anon_sym_r_DQUOTE] = ACTIONS(3133),
    [anon_sym_x_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE] = ACTIONS(3133),
    [anon_sym_i_BQUOTE] = ACTIONS(3133),
    [anon_sym_i_DQUOTE] = ACTIONS(3133),
    [anon_sym_iq_LBRACE] = ACTIONS(3133),
    [aux_sym_char_literal_token1] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3131),
    [anon_sym___DATE__] = ACTIONS(3131),
    [anon_sym___FILE__] = ACTIONS(3131),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3131),
    [anon_sym___FUNCTION__] = ACTIONS(3131),
    [anon_sym___LINE__] = ACTIONS(3131),
    [anon_sym___MODULE__] = ACTIONS(3131),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3131),
    [anon_sym___TIME__] = ACTIONS(3131),
    [anon_sym___TIMESTAMP__] = ACTIONS(3131),
    [anon_sym___VENDOR__] = ACTIONS(3131),
    [anon_sym___VERSION__] = ACTIONS(3131),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3133),
    [sym_float_literal] = ACTIONS(3133),
    [sym__string] = ACTIONS(3133),
    [sym_not_in] = ACTIONS(3137),
    [sym_not_is] = ACTIONS(3137),
  },
  [654] = {
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_q_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3145),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_DOLLAR] = ACTIONS(3148),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3148),
    [sym_bool] = ACTIONS(3145),
    [sym_byte] = ACTIONS(3145),
    [sym_ubyte] = ACTIONS(3145),
    [sym_char] = ACTIONS(3145),
    [sym_short] = ACTIONS(3145),
    [sym_ushort] = ACTIONS(3145),
    [sym_int] = ACTIONS(3145),
    [sym_uint] = ACTIONS(3145),
    [sym_long] = ACTIONS(3145),
    [sym_ulong] = ACTIONS(3145),
    [sym_cent] = ACTIONS(3145),
    [sym_ucent] = ACTIONS(3145),
    [sym_wchar] = ACTIONS(3145),
    [sym_dchar] = ACTIONS(3145),
    [sym_float] = ACTIONS(3145),
    [sym_double] = ACTIONS(3145),
    [sym_real] = ACTIONS(3145),
    [sym_ifloat] = ACTIONS(3145),
    [sym_idouble] = ACTIONS(3145),
    [sym_ireal] = ACTIONS(3145),
    [sym_cfloat] = ACTIONS(3145),
    [sym_cdouble] = ACTIONS(3145),
    [sym_creal] = ACTIONS(3145),
    [sym_size_t] = ACTIONS(3145),
    [sym_ptrdiff_t] = ACTIONS(3145),
    [sym_string] = ACTIONS(3145),
    [sym_cstring] = ACTIONS(3145),
    [sym_dstring] = ACTIONS(3145),
    [sym_wstring] = ACTIONS(3145),
    [sym_noreturn] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_abstract] = ACTIONS(3145),
    [sym_alias] = ACTIONS(3145),
    [sym_align] = ACTIONS(3145),
    [sym_asm] = ACTIONS(3145),
    [sym_assert] = ACTIONS(3145),
    [sym_auto] = ACTIONS(3145),
    [sym_break] = ACTIONS(3145),
    [sym_case] = ACTIONS(3145),
    [sym_cast] = ACTIONS(3145),
    [sym_catch] = ACTIONS(3145),
    [sym_class] = ACTIONS(3145),
    [sym_const] = ACTIONS(3145),
    [sym_continue] = ACTIONS(3145),
    [sym_debug] = ACTIONS(3145),
    [sym_default] = ACTIONS(3145),
    [sym_delegate] = ACTIONS(3145),
    [sym_delete] = ACTIONS(3145),
    [sym_deprecated] = ACTIONS(3145),
    [sym_do] = ACTIONS(3145),
    [sym_else] = ACTIONS(3145),
    [sym_enum] = ACTIONS(3145),
    [sym_export] = ACTIONS(3145),
    [sym_extern] = ACTIONS(3145),
    [sym_final] = ACTIONS(3145),
    [sym_finally] = ACTIONS(3145),
    [sym_for] = ACTIONS(3145),
    [sym_foreach] = ACTIONS(3145),
    [sym_foreach_reverse] = ACTIONS(3145),
    [sym_function] = ACTIONS(3145),
    [sym_goto] = ACTIONS(3145),
    [sym_if] = ACTIONS(3145),
    [sym_immutable] = ACTIONS(3145),
    [sym_import] = ACTIONS(3145),
    [sym_in] = ACTIONS(3145),
    [sym_inout] = ACTIONS(3145),
    [sym_interface] = ACTIONS(3145),
    [sym_invariant] = ACTIONS(3145),
    [sym_is] = ACTIONS(3145),
    [sym_mixin] = ACTIONS(3145),
    [sym_new] = ACTIONS(3145),
    [sym_nothrow] = ACTIONS(3145),
    [sym_out] = ACTIONS(3145),
    [sym_override] = ACTIONS(3145),
    [sym_package] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3145),
    [sym_private] = ACTIONS(3145),
    [sym_protected] = ACTIONS(3145),
    [sym_public] = ACTIONS(3145),
    [sym_pure] = ACTIONS(3145),
    [sym_ref] = ACTIONS(3145),
    [sym_return] = ACTIONS(3145),
    [sym_scope] = ACTIONS(3145),
    [sym_shared] = ACTIONS(3145),
    [sym_static] = ACTIONS(3145),
    [sym_struct] = ACTIONS(3145),
    [sym_switch] = ACTIONS(3145),
    [sym_synchronized] = ACTIONS(3145),
    [sym_template] = ACTIONS(3145),
    [sym_throw] = ACTIONS(3145),
    [sym_try] = ACTIONS(3145),
    [sym_typeid] = ACTIONS(3145),
    [sym_typeof] = ACTIONS(3145),
    [sym_union] = ACTIONS(3145),
    [sym_unittest] = ACTIONS(3145),
    [sym_version] = ACTIONS(3145),
    [sym_while] = ACTIONS(3145),
    [sym_with] = ACTIONS(3145),
    [sym_gshared] = ACTIONS(3145),
    [sym_traits] = ACTIONS(3145),
    [sym_vector] = ACTIONS(3145),
    [sym_void] = ACTIONS(3145),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [anon_sym_r_DQUOTE] = ACTIONS(3148),
    [anon_sym_x_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_i_BQUOTE] = ACTIONS(3148),
    [anon_sym_i_DQUOTE] = ACTIONS(3148),
    [anon_sym_iq_LBRACE] = ACTIONS(3148),
    [aux_sym_char_literal_token1] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym___DATE__] = ACTIONS(3145),
    [anon_sym___FILE__] = ACTIONS(3145),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3145),
    [anon_sym___FUNCTION__] = ACTIONS(3145),
    [anon_sym___LINE__] = ACTIONS(3145),
    [anon_sym___MODULE__] = ACTIONS(3145),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3145),
    [anon_sym___TIME__] = ACTIONS(3145),
    [anon_sym___TIMESTAMP__] = ACTIONS(3145),
    [anon_sym___VENDOR__] = ACTIONS(3145),
    [anon_sym___VERSION__] = ACTIONS(3145),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3148),
    [sym_float_literal] = ACTIONS(3148),
    [sym__string] = ACTIONS(3148),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [655] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3127),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3127),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_asm] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_break] = ACTIONS(3127),
    [sym_case] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_catch] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_continue] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_default] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_finally] = ACTIONS(3127),
    [sym_for] = ACTIONS(3127),
    [sym_foreach] = ACTIONS(3127),
    [sym_foreach_reverse] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_goto] = ACTIONS(3127),
    [sym_if] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_switch] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_try] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_with] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [656] = {
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_q_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3151),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3151),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3151),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3151),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3154),
    [sym_bool] = ACTIONS(3151),
    [sym_byte] = ACTIONS(3151),
    [sym_ubyte] = ACTIONS(3151),
    [sym_char] = ACTIONS(3151),
    [sym_short] = ACTIONS(3151),
    [sym_ushort] = ACTIONS(3151),
    [sym_int] = ACTIONS(3151),
    [sym_uint] = ACTIONS(3151),
    [sym_long] = ACTIONS(3151),
    [sym_ulong] = ACTIONS(3151),
    [sym_cent] = ACTIONS(3151),
    [sym_ucent] = ACTIONS(3151),
    [sym_wchar] = ACTIONS(3151),
    [sym_dchar] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_double] = ACTIONS(3151),
    [sym_real] = ACTIONS(3151),
    [sym_ifloat] = ACTIONS(3151),
    [sym_idouble] = ACTIONS(3151),
    [sym_ireal] = ACTIONS(3151),
    [sym_cfloat] = ACTIONS(3151),
    [sym_cdouble] = ACTIONS(3151),
    [sym_creal] = ACTIONS(3151),
    [sym_size_t] = ACTIONS(3151),
    [sym_ptrdiff_t] = ACTIONS(3151),
    [sym_string] = ACTIONS(3151),
    [sym_cstring] = ACTIONS(3151),
    [sym_dstring] = ACTIONS(3151),
    [sym_wstring] = ACTIONS(3151),
    [sym_noreturn] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_super] = ACTIONS(3151),
    [sym_this] = ACTIONS(3151),
    [sym_abstract] = ACTIONS(3151),
    [sym_alias] = ACTIONS(3151),
    [sym_align] = ACTIONS(3151),
    [sym_asm] = ACTIONS(3151),
    [sym_assert] = ACTIONS(3151),
    [sym_auto] = ACTIONS(3151),
    [sym_break] = ACTIONS(3151),
    [sym_case] = ACTIONS(3151),
    [sym_cast] = ACTIONS(3151),
    [sym_catch] = ACTIONS(3151),
    [sym_class] = ACTIONS(3151),
    [sym_const] = ACTIONS(3151),
    [sym_continue] = ACTIONS(3151),
    [sym_debug] = ACTIONS(3151),
    [sym_default] = ACTIONS(3151),
    [sym_delegate] = ACTIONS(3151),
    [sym_delete] = ACTIONS(3151),
    [sym_deprecated] = ACTIONS(3151),
    [sym_do] = ACTIONS(3151),
    [sym_else] = ACTIONS(3151),
    [sym_enum] = ACTIONS(3151),
    [sym_export] = ACTIONS(3151),
    [sym_extern] = ACTIONS(3151),
    [sym_final] = ACTIONS(3151),
    [sym_finally] = ACTIONS(3151),
    [sym_for] = ACTIONS(3151),
    [sym_foreach] = ACTIONS(3151),
    [sym_foreach_reverse] = ACTIONS(3151),
    [sym_function] = ACTIONS(3151),
    [sym_goto] = ACTIONS(3151),
    [sym_if] = ACTIONS(3151),
    [sym_immutable] = ACTIONS(3151),
    [sym_import] = ACTIONS(3151),
    [sym_in] = ACTIONS(3151),
    [sym_inout] = ACTIONS(3151),
    [sym_interface] = ACTIONS(3151),
    [sym_invariant] = ACTIONS(3151),
    [sym_is] = ACTIONS(3151),
    [sym_mixin] = ACTIONS(3151),
    [sym_new] = ACTIONS(3151),
    [sym_nothrow] = ACTIONS(3151),
    [sym_out] = ACTIONS(3151),
    [sym_override] = ACTIONS(3151),
    [sym_package] = ACTIONS(3151),
    [sym_pragma] = ACTIONS(3151),
    [sym_private] = ACTIONS(3151),
    [sym_protected] = ACTIONS(3151),
    [sym_public] = ACTIONS(3151),
    [sym_pure] = ACTIONS(3151),
    [sym_ref] = ACTIONS(3151),
    [sym_return] = ACTIONS(3151),
    [sym_scope] = ACTIONS(3151),
    [sym_shared] = ACTIONS(3151),
    [sym_static] = ACTIONS(3151),
    [sym_struct] = ACTIONS(3151),
    [sym_switch] = ACTIONS(3151),
    [sym_synchronized] = ACTIONS(3151),
    [sym_template] = ACTIONS(3151),
    [sym_throw] = ACTIONS(3151),
    [sym_try] = ACTIONS(3151),
    [sym_typeid] = ACTIONS(3151),
    [sym_typeof] = ACTIONS(3151),
    [sym_union] = ACTIONS(3151),
    [sym_unittest] = ACTIONS(3151),
    [sym_version] = ACTIONS(3151),
    [sym_while] = ACTIONS(3151),
    [sym_with] = ACTIONS(3151),
    [sym_gshared] = ACTIONS(3151),
    [sym_traits] = ACTIONS(3151),
    [sym_vector] = ACTIONS(3151),
    [sym_void] = ACTIONS(3151),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [anon_sym_r_DQUOTE] = ACTIONS(3154),
    [anon_sym_x_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_i_BQUOTE] = ACTIONS(3154),
    [anon_sym_i_DQUOTE] = ACTIONS(3154),
    [anon_sym_iq_LBRACE] = ACTIONS(3154),
    [aux_sym_char_literal_token1] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3151),
    [anon_sym___DATE__] = ACTIONS(3151),
    [anon_sym___FILE__] = ACTIONS(3151),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3151),
    [anon_sym___FUNCTION__] = ACTIONS(3151),
    [anon_sym___LINE__] = ACTIONS(3151),
    [anon_sym___MODULE__] = ACTIONS(3151),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3151),
    [anon_sym___TIME__] = ACTIONS(3151),
    [anon_sym___TIMESTAMP__] = ACTIONS(3151),
    [anon_sym___VENDOR__] = ACTIONS(3151),
    [anon_sym___VERSION__] = ACTIONS(3151),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3154),
    [sym_float_literal] = ACTIONS(3154),
    [sym__string] = ACTIONS(3154),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [657] = {
    [sym_identifier] = ACTIONS(3157),
    [anon_sym_q_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_RPAREN] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_DOLLAR] = ACTIONS(3160),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3160),
    [sym_bool] = ACTIONS(3157),
    [sym_byte] = ACTIONS(3157),
    [sym_ubyte] = ACTIONS(3157),
    [sym_char] = ACTIONS(3157),
    [sym_short] = ACTIONS(3157),
    [sym_ushort] = ACTIONS(3157),
    [sym_int] = ACTIONS(3157),
    [sym_uint] = ACTIONS(3157),
    [sym_long] = ACTIONS(3157),
    [sym_ulong] = ACTIONS(3157),
    [sym_cent] = ACTIONS(3157),
    [sym_ucent] = ACTIONS(3157),
    [sym_wchar] = ACTIONS(3157),
    [sym_dchar] = ACTIONS(3157),
    [sym_float] = ACTIONS(3157),
    [sym_double] = ACTIONS(3157),
    [sym_real] = ACTIONS(3157),
    [sym_ifloat] = ACTIONS(3157),
    [sym_idouble] = ACTIONS(3157),
    [sym_ireal] = ACTIONS(3157),
    [sym_cfloat] = ACTIONS(3157),
    [sym_cdouble] = ACTIONS(3157),
    [sym_creal] = ACTIONS(3157),
    [sym_size_t] = ACTIONS(3157),
    [sym_ptrdiff_t] = ACTIONS(3157),
    [sym_string] = ACTIONS(3157),
    [sym_cstring] = ACTIONS(3157),
    [sym_dstring] = ACTIONS(3157),
    [sym_wstring] = ACTIONS(3157),
    [sym_noreturn] = ACTIONS(3157),
    [sym_true] = ACTIONS(3157),
    [sym_false] = ACTIONS(3157),
    [sym_null] = ACTIONS(3157),
    [sym_super] = ACTIONS(3157),
    [sym_this] = ACTIONS(3157),
    [sym_abstract] = ACTIONS(3157),
    [sym_alias] = ACTIONS(3157),
    [sym_align] = ACTIONS(3157),
    [sym_asm] = ACTIONS(3157),
    [sym_assert] = ACTIONS(3157),
    [sym_auto] = ACTIONS(3157),
    [sym_break] = ACTIONS(3157),
    [sym_case] = ACTIONS(3157),
    [sym_cast] = ACTIONS(3157),
    [sym_catch] = ACTIONS(3157),
    [sym_class] = ACTIONS(3157),
    [sym_const] = ACTIONS(3157),
    [sym_continue] = ACTIONS(3157),
    [sym_debug] = ACTIONS(3157),
    [sym_default] = ACTIONS(3157),
    [sym_delegate] = ACTIONS(3157),
    [sym_delete] = ACTIONS(3157),
    [sym_deprecated] = ACTIONS(3157),
    [sym_do] = ACTIONS(3157),
    [sym_else] = ACTIONS(3157),
    [sym_enum] = ACTIONS(3157),
    [sym_export] = ACTIONS(3157),
    [sym_extern] = ACTIONS(3157),
    [sym_final] = ACTIONS(3157),
    [sym_finally] = ACTIONS(3157),
    [sym_for] = ACTIONS(3157),
    [sym_foreach] = ACTIONS(3157),
    [sym_foreach_reverse] = ACTIONS(3157),
    [sym_function] = ACTIONS(3157),
    [sym_goto] = ACTIONS(3157),
    [sym_if] = ACTIONS(3157),
    [sym_immutable] = ACTIONS(3157),
    [sym_import] = ACTIONS(3157),
    [sym_in] = ACTIONS(3157),
    [sym_inout] = ACTIONS(3157),
    [sym_interface] = ACTIONS(3157),
    [sym_invariant] = ACTIONS(3157),
    [sym_is] = ACTIONS(3157),
    [sym_mixin] = ACTIONS(3157),
    [sym_new] = ACTIONS(3157),
    [sym_nothrow] = ACTIONS(3157),
    [sym_out] = ACTIONS(3157),
    [sym_override] = ACTIONS(3157),
    [sym_package] = ACTIONS(3157),
    [sym_pragma] = ACTIONS(3157),
    [sym_private] = ACTIONS(3157),
    [sym_protected] = ACTIONS(3157),
    [sym_public] = ACTIONS(3157),
    [sym_pure] = ACTIONS(3157),
    [sym_ref] = ACTIONS(3157),
    [sym_return] = ACTIONS(3157),
    [sym_scope] = ACTIONS(3157),
    [sym_shared] = ACTIONS(3157),
    [sym_static] = ACTIONS(3157),
    [sym_struct] = ACTIONS(3157),
    [sym_switch] = ACTIONS(3157),
    [sym_synchronized] = ACTIONS(3157),
    [sym_template] = ACTIONS(3157),
    [sym_throw] = ACTIONS(3157),
    [sym_try] = ACTIONS(3157),
    [sym_typeid] = ACTIONS(3157),
    [sym_typeof] = ACTIONS(3157),
    [sym_union] = ACTIONS(3157),
    [sym_unittest] = ACTIONS(3157),
    [sym_version] = ACTIONS(3157),
    [sym_while] = ACTIONS(3157),
    [sym_with] = ACTIONS(3157),
    [sym_gshared] = ACTIONS(3157),
    [sym_traits] = ACTIONS(3157),
    [sym_vector] = ACTIONS(3157),
    [sym_void] = ACTIONS(3157),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [anon_sym_r_DQUOTE] = ACTIONS(3160),
    [anon_sym_x_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_i_BQUOTE] = ACTIONS(3160),
    [anon_sym_i_DQUOTE] = ACTIONS(3160),
    [anon_sym_iq_LBRACE] = ACTIONS(3160),
    [aux_sym_char_literal_token1] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3157),
    [anon_sym___DATE__] = ACTIONS(3157),
    [anon_sym___FILE__] = ACTIONS(3157),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3157),
    [anon_sym___FUNCTION__] = ACTIONS(3157),
    [anon_sym___LINE__] = ACTIONS(3157),
    [anon_sym___MODULE__] = ACTIONS(3157),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3157),
    [anon_sym___TIME__] = ACTIONS(3157),
    [anon_sym___TIMESTAMP__] = ACTIONS(3157),
    [anon_sym___VENDOR__] = ACTIONS(3157),
    [anon_sym___VERSION__] = ACTIONS(3157),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3160),
    [sym_float_literal] = ACTIONS(3160),
    [sym__string] = ACTIONS(3160),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [658] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_q_LBRACE] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_LT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_GT_GT_GT] = ACTIONS(3163),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_CARET_CARET] = ACTIONS(3163),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_TILDE_EQ] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_abstract] = ACTIONS(3163),
    [sym_alias] = ACTIONS(3163),
    [sym_align] = ACTIONS(3163),
    [sym_asm] = ACTIONS(3163),
    [sym_assert] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_break] = ACTIONS(3163),
    [sym_case] = ACTIONS(3163),
    [sym_cast] = ACTIONS(3163),
    [sym_catch] = ACTIONS(3163),
    [sym_class] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_continue] = ACTIONS(3163),
    [sym_debug] = ACTIONS(3163),
    [sym_default] = ACTIONS(3163),
    [sym_delegate] = ACTIONS(3163),
    [sym_delete] = ACTIONS(3163),
    [sym_deprecated] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_enum] = ACTIONS(3163),
    [sym_export] = ACTIONS(3163),
    [sym_extern] = ACTIONS(3163),
    [sym_final] = ACTIONS(3163),
    [sym_finally] = ACTIONS(3163),
    [sym_for] = ACTIONS(3163),
    [sym_foreach] = ACTIONS(3163),
    [sym_foreach_reverse] = ACTIONS(3163),
    [sym_function] = ACTIONS(3163),
    [sym_goto] = ACTIONS(3163),
    [sym_if] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_interface] = ACTIONS(3163),
    [sym_invariant] = ACTIONS(3163),
    [sym_is] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_new] = ACTIONS(3163),
    [sym_nothrow] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_override] = ACTIONS(3163),
    [sym_package] = ACTIONS(3163),
    [sym_pragma] = ACTIONS(3163),
    [sym_private] = ACTIONS(3163),
    [sym_protected] = ACTIONS(3163),
    [sym_public] = ACTIONS(3163),
    [sym_pure] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_return] = ACTIONS(3163),
    [sym_scope] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_static] = ACTIONS(3163),
    [sym_struct] = ACTIONS(3163),
    [sym_switch] = ACTIONS(3163),
    [sym_synchronized] = ACTIONS(3163),
    [sym_template] = ACTIONS(3163),
    [sym_throw] = ACTIONS(3163),
    [sym_try] = ACTIONS(3163),
    [sym_typeid] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_union] = ACTIONS(3163),
    [sym_unittest] = ACTIONS(3163),
    [sym_version] = ACTIONS(3163),
    [sym_while] = ACTIONS(3163),
    [sym_with] = ACTIONS(3163),
    [sym_gshared] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [anon_sym_r_DQUOTE] = ACTIONS(3165),
    [anon_sym_x_DQUOTE] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_i_BQUOTE] = ACTIONS(3165),
    [anon_sym_i_DQUOTE] = ACTIONS(3165),
    [anon_sym_iq_LBRACE] = ACTIONS(3165),
    [aux_sym_char_literal_token1] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym___DATE__] = ACTIONS(3163),
    [anon_sym___FILE__] = ACTIONS(3163),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3163),
    [anon_sym___FUNCTION__] = ACTIONS(3163),
    [anon_sym___LINE__] = ACTIONS(3163),
    [anon_sym___MODULE__] = ACTIONS(3163),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3163),
    [anon_sym___TIME__] = ACTIONS(3163),
    [anon_sym___TIMESTAMP__] = ACTIONS(3163),
    [anon_sym___VENDOR__] = ACTIONS(3163),
    [anon_sym___VERSION__] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym__string] = ACTIONS(3165),
    [sym_not_in] = ACTIONS(3165),
    [sym_not_is] = ACTIONS(3165),
  },
  [659] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3170),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_abstract] = ACTIONS(3167),
    [sym_alias] = ACTIONS(3167),
    [sym_align] = ACTIONS(3167),
    [sym_asm] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_break] = ACTIONS(3167),
    [sym_case] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_catch] = ACTIONS(3167),
    [sym_class] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_continue] = ACTIONS(3167),
    [sym_debug] = ACTIONS(3167),
    [sym_default] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_deprecated] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(3173),
    [sym_enum] = ACTIONS(3167),
    [sym_export] = ACTIONS(3167),
    [sym_extern] = ACTIONS(3167),
    [sym_final] = ACTIONS(3167),
    [sym_finally] = ACTIONS(3167),
    [sym_for] = ACTIONS(3167),
    [sym_foreach] = ACTIONS(3167),
    [sym_foreach_reverse] = ACTIONS(3167),
    [sym_function] = ACTIONS(3167),
    [sym_goto] = ACTIONS(3167),
    [sym_if] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_interface] = ACTIONS(3167),
    [sym_invariant] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_nothrow] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_override] = ACTIONS(3167),
    [sym_package] = ACTIONS(3167),
    [sym_pragma] = ACTIONS(3167),
    [sym_private] = ACTIONS(3167),
    [sym_protected] = ACTIONS(3167),
    [sym_public] = ACTIONS(3167),
    [sym_pure] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_return] = ACTIONS(3167),
    [sym_scope] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_static] = ACTIONS(3167),
    [sym_struct] = ACTIONS(3167),
    [sym_switch] = ACTIONS(3167),
    [sym_synchronized] = ACTIONS(3167),
    [sym_template] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_try] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_union] = ACTIONS(3167),
    [sym_unittest] = ACTIONS(3167),
    [sym_version] = ACTIONS(3167),
    [sym_while] = ACTIONS(3167),
    [sym_with] = ACTIONS(3167),
    [sym_gshared] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [660] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_q_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_PLUS_EQ] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_LT_EQ] = ACTIONS(3178),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3178),
    [anon_sym_GT] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT] = ACTIONS(3176),
    [anon_sym_GT_GT_GT] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3178),
    [anon_sym_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3178),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3178),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3178),
    [anon_sym_CARET_CARET] = ACTIONS(3176),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_TILDE_EQ] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_abstract] = ACTIONS(3176),
    [sym_alias] = ACTIONS(3176),
    [sym_align] = ACTIONS(3176),
    [sym_asm] = ACTIONS(3176),
    [sym_assert] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_break] = ACTIONS(3176),
    [sym_case] = ACTIONS(3176),
    [sym_cast] = ACTIONS(3176),
    [sym_catch] = ACTIONS(3176),
    [sym_class] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_continue] = ACTIONS(3176),
    [sym_debug] = ACTIONS(3176),
    [sym_default] = ACTIONS(3176),
    [sym_delegate] = ACTIONS(3176),
    [sym_delete] = ACTIONS(3176),
    [sym_deprecated] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_enum] = ACTIONS(3176),
    [sym_export] = ACTIONS(3176),
    [sym_extern] = ACTIONS(3176),
    [sym_final] = ACTIONS(3176),
    [sym_finally] = ACTIONS(3176),
    [sym_for] = ACTIONS(3176),
    [sym_foreach] = ACTIONS(3176),
    [sym_foreach_reverse] = ACTIONS(3176),
    [sym_function] = ACTIONS(3176),
    [sym_goto] = ACTIONS(3176),
    [sym_if] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_interface] = ACTIONS(3176),
    [sym_invariant] = ACTIONS(3176),
    [sym_is] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_new] = ACTIONS(3176),
    [sym_nothrow] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_override] = ACTIONS(3176),
    [sym_package] = ACTIONS(3176),
    [sym_pragma] = ACTIONS(3176),
    [sym_private] = ACTIONS(3176),
    [sym_protected] = ACTIONS(3176),
    [sym_public] = ACTIONS(3176),
    [sym_pure] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_return] = ACTIONS(3176),
    [sym_scope] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_static] = ACTIONS(3176),
    [sym_struct] = ACTIONS(3176),
    [sym_switch] = ACTIONS(3176),
    [sym_synchronized] = ACTIONS(3176),
    [sym_template] = ACTIONS(3176),
    [sym_throw] = ACTIONS(3176),
    [sym_try] = ACTIONS(3176),
    [sym_typeid] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_union] = ACTIONS(3176),
    [sym_unittest] = ACTIONS(3176),
    [sym_version] = ACTIONS(3176),
    [sym_while] = ACTIONS(3176),
    [sym_with] = ACTIONS(3176),
    [sym_gshared] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_r_DQUOTE] = ACTIONS(3178),
    [anon_sym_x_DQUOTE] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_i_BQUOTE] = ACTIONS(3178),
    [anon_sym_i_DQUOTE] = ACTIONS(3178),
    [anon_sym_iq_LBRACE] = ACTIONS(3178),
    [aux_sym_char_literal_token1] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym___DATE__] = ACTIONS(3176),
    [anon_sym___FILE__] = ACTIONS(3176),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3176),
    [anon_sym___FUNCTION__] = ACTIONS(3176),
    [anon_sym___LINE__] = ACTIONS(3176),
    [anon_sym___MODULE__] = ACTIONS(3176),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3176),
    [anon_sym___TIME__] = ACTIONS(3176),
    [anon_sym___TIMESTAMP__] = ACTIONS(3176),
    [anon_sym___VENDOR__] = ACTIONS(3176),
    [anon_sym___VERSION__] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3178),
    [sym_float_literal] = ACTIONS(3178),
    [sym__string] = ACTIONS(3178),
    [sym_not_in] = ACTIONS(3178),
    [sym_not_is] = ACTIONS(3178),
  },
  [661] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3170),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_abstract] = ACTIONS(3167),
    [sym_alias] = ACTIONS(3167),
    [sym_align] = ACTIONS(3167),
    [sym_asm] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_break] = ACTIONS(3167),
    [sym_case] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_catch] = ACTIONS(3167),
    [sym_class] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_continue] = ACTIONS(3167),
    [sym_debug] = ACTIONS(3167),
    [sym_default] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_deprecated] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(3180),
    [sym_enum] = ACTIONS(3167),
    [sym_export] = ACTIONS(3167),
    [sym_extern] = ACTIONS(3167),
    [sym_final] = ACTIONS(3167),
    [sym_finally] = ACTIONS(3167),
    [sym_for] = ACTIONS(3167),
    [sym_foreach] = ACTIONS(3167),
    [sym_foreach_reverse] = ACTIONS(3167),
    [sym_function] = ACTIONS(3167),
    [sym_goto] = ACTIONS(3167),
    [sym_if] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_interface] = ACTIONS(3167),
    [sym_invariant] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_nothrow] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_override] = ACTIONS(3167),
    [sym_package] = ACTIONS(3167),
    [sym_pragma] = ACTIONS(3167),
    [sym_private] = ACTIONS(3167),
    [sym_protected] = ACTIONS(3167),
    [sym_public] = ACTIONS(3167),
    [sym_pure] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_return] = ACTIONS(3167),
    [sym_scope] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_static] = ACTIONS(3167),
    [sym_struct] = ACTIONS(3167),
    [sym_switch] = ACTIONS(3167),
    [sym_synchronized] = ACTIONS(3167),
    [sym_template] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_try] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_union] = ACTIONS(3167),
    [sym_unittest] = ACTIONS(3167),
    [sym_version] = ACTIONS(3167),
    [sym_while] = ACTIONS(3167),
    [sym_with] = ACTIONS(3167),
    [sym_gshared] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [662] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3170),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_abstract] = ACTIONS(3167),
    [sym_alias] = ACTIONS(3167),
    [sym_align] = ACTIONS(3167),
    [sym_asm] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_break] = ACTIONS(3167),
    [sym_case] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_class] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_continue] = ACTIONS(3167),
    [sym_debug] = ACTIONS(3167),
    [sym_default] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_deprecated] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(3184),
    [sym_enum] = ACTIONS(3167),
    [sym_export] = ACTIONS(3167),
    [sym_extern] = ACTIONS(3167),
    [sym_final] = ACTIONS(3167),
    [sym_for] = ACTIONS(3167),
    [sym_foreach] = ACTIONS(3167),
    [sym_foreach_reverse] = ACTIONS(3167),
    [sym_function] = ACTIONS(3167),
    [sym_goto] = ACTIONS(3167),
    [sym_if] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_interface] = ACTIONS(3167),
    [sym_invariant] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_nothrow] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_override] = ACTIONS(3167),
    [sym_package] = ACTIONS(3167),
    [sym_pragma] = ACTIONS(3167),
    [sym_private] = ACTIONS(3167),
    [sym_protected] = ACTIONS(3167),
    [sym_public] = ACTIONS(3167),
    [sym_pure] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_return] = ACTIONS(3167),
    [sym_scope] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_static] = ACTIONS(3167),
    [sym_struct] = ACTIONS(3167),
    [sym_switch] = ACTIONS(3167),
    [sym_synchronized] = ACTIONS(3167),
    [sym_template] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_try] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_union] = ACTIONS(3167),
    [sym_unittest] = ACTIONS(3167),
    [sym_version] = ACTIONS(3167),
    [sym_while] = ACTIONS(3167),
    [sym_with] = ACTIONS(3167),
    [sym_gshared] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [663] = {
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_q_LBRACE] = ACTIONS(3154),
    [anon_sym_RBRACE] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3151),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3151),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3151),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3151),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3154),
    [sym_bool] = ACTIONS(3151),
    [sym_byte] = ACTIONS(3151),
    [sym_ubyte] = ACTIONS(3151),
    [sym_char] = ACTIONS(3151),
    [sym_short] = ACTIONS(3151),
    [sym_ushort] = ACTIONS(3151),
    [sym_int] = ACTIONS(3151),
    [sym_uint] = ACTIONS(3151),
    [sym_long] = ACTIONS(3151),
    [sym_ulong] = ACTIONS(3151),
    [sym_cent] = ACTIONS(3151),
    [sym_ucent] = ACTIONS(3151),
    [sym_wchar] = ACTIONS(3151),
    [sym_dchar] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_double] = ACTIONS(3151),
    [sym_real] = ACTIONS(3151),
    [sym_ifloat] = ACTIONS(3151),
    [sym_idouble] = ACTIONS(3151),
    [sym_ireal] = ACTIONS(3151),
    [sym_cfloat] = ACTIONS(3151),
    [sym_cdouble] = ACTIONS(3151),
    [sym_creal] = ACTIONS(3151),
    [sym_size_t] = ACTIONS(3151),
    [sym_ptrdiff_t] = ACTIONS(3151),
    [sym_string] = ACTIONS(3151),
    [sym_cstring] = ACTIONS(3151),
    [sym_dstring] = ACTIONS(3151),
    [sym_wstring] = ACTIONS(3151),
    [sym_noreturn] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_super] = ACTIONS(3151),
    [sym_this] = ACTIONS(3151),
    [sym_abstract] = ACTIONS(3151),
    [sym_alias] = ACTIONS(3151),
    [sym_align] = ACTIONS(3151),
    [sym_asm] = ACTIONS(3151),
    [sym_assert] = ACTIONS(3151),
    [sym_auto] = ACTIONS(3151),
    [sym_break] = ACTIONS(3151),
    [sym_case] = ACTIONS(3151),
    [sym_cast] = ACTIONS(3151),
    [sym_class] = ACTIONS(3151),
    [sym_const] = ACTIONS(3151),
    [sym_continue] = ACTIONS(3151),
    [sym_debug] = ACTIONS(3151),
    [sym_default] = ACTIONS(3151),
    [sym_delegate] = ACTIONS(3151),
    [sym_delete] = ACTIONS(3151),
    [sym_deprecated] = ACTIONS(3151),
    [sym_do] = ACTIONS(3151),
    [sym_else] = ACTIONS(3151),
    [sym_enum] = ACTIONS(3151),
    [sym_export] = ACTIONS(3151),
    [sym_extern] = ACTIONS(3151),
    [sym_final] = ACTIONS(3151),
    [sym_for] = ACTIONS(3151),
    [sym_foreach] = ACTIONS(3151),
    [sym_foreach_reverse] = ACTIONS(3151),
    [sym_function] = ACTIONS(3151),
    [sym_goto] = ACTIONS(3151),
    [sym_if] = ACTIONS(3151),
    [sym_immutable] = ACTIONS(3151),
    [sym_import] = ACTIONS(3151),
    [sym_in] = ACTIONS(3151),
    [sym_inout] = ACTIONS(3151),
    [sym_interface] = ACTIONS(3151),
    [sym_invariant] = ACTIONS(3151),
    [sym_is] = ACTIONS(3151),
    [sym_mixin] = ACTIONS(3151),
    [sym_new] = ACTIONS(3151),
    [sym_nothrow] = ACTIONS(3151),
    [sym_out] = ACTIONS(3151),
    [sym_override] = ACTIONS(3151),
    [sym_package] = ACTIONS(3151),
    [sym_pragma] = ACTIONS(3151),
    [sym_private] = ACTIONS(3151),
    [sym_protected] = ACTIONS(3151),
    [sym_public] = ACTIONS(3151),
    [sym_pure] = ACTIONS(3151),
    [sym_ref] = ACTIONS(3151),
    [sym_return] = ACTIONS(3151),
    [sym_scope] = ACTIONS(3151),
    [sym_shared] = ACTIONS(3151),
    [sym_static] = ACTIONS(3151),
    [sym_struct] = ACTIONS(3151),
    [sym_switch] = ACTIONS(3151),
    [sym_synchronized] = ACTIONS(3151),
    [sym_template] = ACTIONS(3151),
    [sym_throw] = ACTIONS(3151),
    [sym_try] = ACTIONS(3151),
    [sym_typeid] = ACTIONS(3151),
    [sym_typeof] = ACTIONS(3151),
    [sym_union] = ACTIONS(3151),
    [sym_unittest] = ACTIONS(3151),
    [sym_version] = ACTIONS(3151),
    [sym_while] = ACTIONS(3151),
    [sym_with] = ACTIONS(3151),
    [sym_gshared] = ACTIONS(3151),
    [sym_traits] = ACTIONS(3151),
    [sym_vector] = ACTIONS(3151),
    [sym_void] = ACTIONS(3151),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [anon_sym_r_DQUOTE] = ACTIONS(3154),
    [anon_sym_x_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_i_BQUOTE] = ACTIONS(3154),
    [anon_sym_i_DQUOTE] = ACTIONS(3154),
    [anon_sym_iq_LBRACE] = ACTIONS(3154),
    [aux_sym_char_literal_token1] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3151),
    [anon_sym___DATE__] = ACTIONS(3151),
    [anon_sym___FILE__] = ACTIONS(3151),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3151),
    [anon_sym___FUNCTION__] = ACTIONS(3151),
    [anon_sym___LINE__] = ACTIONS(3151),
    [anon_sym___MODULE__] = ACTIONS(3151),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3151),
    [anon_sym___TIME__] = ACTIONS(3151),
    [anon_sym___TIMESTAMP__] = ACTIONS(3151),
    [anon_sym___VENDOR__] = ACTIONS(3151),
    [anon_sym___VERSION__] = ACTIONS(3151),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3154),
    [sym_float_literal] = ACTIONS(3154),
    [sym__string] = ACTIONS(3154),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [664] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5935),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [665] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5966),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [666] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5738),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [667] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5899),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [668] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_q_LBRACE] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_SLASH] = ACTIONS(3135),
    [anon_sym_SLASH_EQ] = ACTIONS(3137),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_AMP_EQ] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PIPE_EQ] = ACTIONS(3137),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_DASH_EQ] = ACTIONS(3137),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_PLUS_EQ] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_LT_EQ] = ACTIONS(3137),
    [anon_sym_LT_LT] = ACTIONS(3135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3135),
    [anon_sym_GT_GT_GT] = ACTIONS(3135),
    [anon_sym_BANG] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(3133),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_EQ_EQ] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_STAR_EQ] = ACTIONS(3137),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3137),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_CARET_EQ] = ACTIONS(3137),
    [anon_sym_CARET_CARET] = ACTIONS(3135),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_TILDE_EQ] = ACTIONS(3137),
    [anon_sym_AT] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_byte] = ACTIONS(3131),
    [sym_ubyte] = ACTIONS(3131),
    [sym_char] = ACTIONS(3131),
    [sym_short] = ACTIONS(3131),
    [sym_ushort] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_uint] = ACTIONS(3131),
    [sym_long] = ACTIONS(3131),
    [sym_ulong] = ACTIONS(3131),
    [sym_cent] = ACTIONS(3131),
    [sym_ucent] = ACTIONS(3131),
    [sym_wchar] = ACTIONS(3131),
    [sym_dchar] = ACTIONS(3131),
    [sym_float] = ACTIONS(3131),
    [sym_double] = ACTIONS(3131),
    [sym_real] = ACTIONS(3131),
    [sym_ifloat] = ACTIONS(3131),
    [sym_idouble] = ACTIONS(3131),
    [sym_ireal] = ACTIONS(3131),
    [sym_cfloat] = ACTIONS(3131),
    [sym_cdouble] = ACTIONS(3131),
    [sym_creal] = ACTIONS(3131),
    [sym_size_t] = ACTIONS(3131),
    [sym_ptrdiff_t] = ACTIONS(3131),
    [sym_string] = ACTIONS(3131),
    [sym_cstring] = ACTIONS(3131),
    [sym_dstring] = ACTIONS(3131),
    [sym_wstring] = ACTIONS(3131),
    [sym_noreturn] = ACTIONS(3131),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_super] = ACTIONS(3131),
    [sym_this] = ACTIONS(3131),
    [sym_abstract] = ACTIONS(3131),
    [sym_alias] = ACTIONS(3131),
    [sym_align] = ACTIONS(3131),
    [sym_asm] = ACTIONS(3131),
    [sym_assert] = ACTIONS(3131),
    [sym_auto] = ACTIONS(3131),
    [sym_break] = ACTIONS(3131),
    [sym_case] = ACTIONS(3131),
    [sym_cast] = ACTIONS(3131),
    [sym_class] = ACTIONS(3131),
    [sym_const] = ACTIONS(3131),
    [sym_continue] = ACTIONS(3131),
    [sym_debug] = ACTIONS(3131),
    [sym_default] = ACTIONS(3131),
    [sym_delegate] = ACTIONS(3131),
    [sym_delete] = ACTIONS(3131),
    [sym_deprecated] = ACTIONS(3131),
    [sym_do] = ACTIONS(3131),
    [sym_else] = ACTIONS(3131),
    [sym_enum] = ACTIONS(3131),
    [sym_export] = ACTIONS(3131),
    [sym_extern] = ACTIONS(3131),
    [sym_final] = ACTIONS(3131),
    [sym_for] = ACTIONS(3131),
    [sym_foreach] = ACTIONS(3131),
    [sym_foreach_reverse] = ACTIONS(3131),
    [sym_function] = ACTIONS(3131),
    [sym_goto] = ACTIONS(3131),
    [sym_if] = ACTIONS(3131),
    [sym_immutable] = ACTIONS(3131),
    [sym_import] = ACTIONS(3131),
    [sym_in] = ACTIONS(3142),
    [sym_inout] = ACTIONS(3131),
    [sym_interface] = ACTIONS(3131),
    [sym_invariant] = ACTIONS(3131),
    [sym_is] = ACTIONS(3142),
    [sym_mixin] = ACTIONS(3131),
    [sym_new] = ACTIONS(3131),
    [sym_nothrow] = ACTIONS(3131),
    [sym_out] = ACTIONS(3131),
    [sym_override] = ACTIONS(3131),
    [sym_package] = ACTIONS(3131),
    [sym_pragma] = ACTIONS(3131),
    [sym_private] = ACTIONS(3131),
    [sym_protected] = ACTIONS(3131),
    [sym_public] = ACTIONS(3131),
    [sym_pure] = ACTIONS(3131),
    [sym_ref] = ACTIONS(3131),
    [sym_return] = ACTIONS(3131),
    [sym_scope] = ACTIONS(3131),
    [sym_shared] = ACTIONS(3131),
    [sym_static] = ACTIONS(3131),
    [sym_struct] = ACTIONS(3131),
    [sym_switch] = ACTIONS(3131),
    [sym_synchronized] = ACTIONS(3131),
    [sym_template] = ACTIONS(3131),
    [sym_throw] = ACTIONS(3131),
    [sym_try] = ACTIONS(3131),
    [sym_typeid] = ACTIONS(3131),
    [sym_typeof] = ACTIONS(3131),
    [sym_union] = ACTIONS(3131),
    [sym_unittest] = ACTIONS(3131),
    [sym_version] = ACTIONS(3131),
    [sym_while] = ACTIONS(3131),
    [sym_with] = ACTIONS(3131),
    [sym_gshared] = ACTIONS(3131),
    [sym_traits] = ACTIONS(3131),
    [sym_vector] = ACTIONS(3131),
    [sym_void] = ACTIONS(3131),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [anon_sym_r_DQUOTE] = ACTIONS(3133),
    [anon_sym_x_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE] = ACTIONS(3133),
    [anon_sym_i_BQUOTE] = ACTIONS(3133),
    [anon_sym_i_DQUOTE] = ACTIONS(3133),
    [anon_sym_iq_LBRACE] = ACTIONS(3133),
    [aux_sym_char_literal_token1] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3131),
    [anon_sym___DATE__] = ACTIONS(3131),
    [anon_sym___FILE__] = ACTIONS(3131),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3131),
    [anon_sym___FUNCTION__] = ACTIONS(3131),
    [anon_sym___LINE__] = ACTIONS(3131),
    [anon_sym___MODULE__] = ACTIONS(3131),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3131),
    [anon_sym___TIME__] = ACTIONS(3131),
    [anon_sym___TIMESTAMP__] = ACTIONS(3131),
    [anon_sym___VENDOR__] = ACTIONS(3131),
    [anon_sym___VERSION__] = ACTIONS(3131),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3133),
    [sym_float_literal] = ACTIONS(3133),
    [sym__string] = ACTIONS(3133),
    [sym_not_in] = ACTIONS(3137),
    [sym_not_is] = ACTIONS(3137),
  },
  [669] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(6024),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [670] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_q_LBRACE] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_LT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_GT_GT_GT] = ACTIONS(3163),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_CARET_CARET] = ACTIONS(3163),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_TILDE_EQ] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_abstract] = ACTIONS(3163),
    [sym_alias] = ACTIONS(3163),
    [sym_align] = ACTIONS(3163),
    [sym_asm] = ACTIONS(3163),
    [sym_assert] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_break] = ACTIONS(3163),
    [sym_case] = ACTIONS(3163),
    [sym_cast] = ACTIONS(3163),
    [sym_class] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_continue] = ACTIONS(3163),
    [sym_debug] = ACTIONS(3163),
    [sym_default] = ACTIONS(3163),
    [sym_delegate] = ACTIONS(3163),
    [sym_delete] = ACTIONS(3163),
    [sym_deprecated] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_enum] = ACTIONS(3163),
    [sym_export] = ACTIONS(3163),
    [sym_extern] = ACTIONS(3163),
    [sym_final] = ACTIONS(3163),
    [sym_for] = ACTIONS(3163),
    [sym_foreach] = ACTIONS(3163),
    [sym_foreach_reverse] = ACTIONS(3163),
    [sym_function] = ACTIONS(3163),
    [sym_goto] = ACTIONS(3163),
    [sym_if] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_interface] = ACTIONS(3163),
    [sym_invariant] = ACTIONS(3163),
    [sym_is] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_new] = ACTIONS(3163),
    [sym_nothrow] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_override] = ACTIONS(3163),
    [sym_package] = ACTIONS(3163),
    [sym_pragma] = ACTIONS(3163),
    [sym_private] = ACTIONS(3163),
    [sym_protected] = ACTIONS(3163),
    [sym_public] = ACTIONS(3163),
    [sym_pure] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_return] = ACTIONS(3163),
    [sym_scope] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_static] = ACTIONS(3163),
    [sym_struct] = ACTIONS(3163),
    [sym_switch] = ACTIONS(3163),
    [sym_synchronized] = ACTIONS(3163),
    [sym_template] = ACTIONS(3163),
    [sym_throw] = ACTIONS(3163),
    [sym_try] = ACTIONS(3163),
    [sym_typeid] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_union] = ACTIONS(3163),
    [sym_unittest] = ACTIONS(3163),
    [sym_version] = ACTIONS(3163),
    [sym_while] = ACTIONS(3163),
    [sym_with] = ACTIONS(3163),
    [sym_gshared] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [anon_sym_r_DQUOTE] = ACTIONS(3165),
    [anon_sym_x_DQUOTE] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_i_BQUOTE] = ACTIONS(3165),
    [anon_sym_i_DQUOTE] = ACTIONS(3165),
    [anon_sym_iq_LBRACE] = ACTIONS(3165),
    [aux_sym_char_literal_token1] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym___DATE__] = ACTIONS(3163),
    [anon_sym___FILE__] = ACTIONS(3163),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3163),
    [anon_sym___FUNCTION__] = ACTIONS(3163),
    [anon_sym___LINE__] = ACTIONS(3163),
    [anon_sym___MODULE__] = ACTIONS(3163),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3163),
    [anon_sym___TIME__] = ACTIONS(3163),
    [anon_sym___TIMESTAMP__] = ACTIONS(3163),
    [anon_sym___VENDOR__] = ACTIONS(3163),
    [anon_sym___VERSION__] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym__string] = ACTIONS(3165),
    [sym_not_in] = ACTIONS(3165),
    [sym_not_is] = ACTIONS(3165),
  },
  [671] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(6387),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [672] = {
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_q_LBRACE] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3121),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3124),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym_DOLLAR] = ACTIONS(3124),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3124),
    [sym_bool] = ACTIONS(3121),
    [sym_byte] = ACTIONS(3121),
    [sym_ubyte] = ACTIONS(3121),
    [sym_char] = ACTIONS(3121),
    [sym_short] = ACTIONS(3121),
    [sym_ushort] = ACTIONS(3121),
    [sym_int] = ACTIONS(3121),
    [sym_uint] = ACTIONS(3121),
    [sym_long] = ACTIONS(3121),
    [sym_ulong] = ACTIONS(3121),
    [sym_cent] = ACTIONS(3121),
    [sym_ucent] = ACTIONS(3121),
    [sym_wchar] = ACTIONS(3121),
    [sym_dchar] = ACTIONS(3121),
    [sym_float] = ACTIONS(3121),
    [sym_double] = ACTIONS(3121),
    [sym_real] = ACTIONS(3121),
    [sym_ifloat] = ACTIONS(3121),
    [sym_idouble] = ACTIONS(3121),
    [sym_ireal] = ACTIONS(3121),
    [sym_cfloat] = ACTIONS(3121),
    [sym_cdouble] = ACTIONS(3121),
    [sym_creal] = ACTIONS(3121),
    [sym_size_t] = ACTIONS(3121),
    [sym_ptrdiff_t] = ACTIONS(3121),
    [sym_string] = ACTIONS(3121),
    [sym_cstring] = ACTIONS(3121),
    [sym_dstring] = ACTIONS(3121),
    [sym_wstring] = ACTIONS(3121),
    [sym_noreturn] = ACTIONS(3121),
    [sym_true] = ACTIONS(3121),
    [sym_false] = ACTIONS(3121),
    [sym_null] = ACTIONS(3121),
    [sym_super] = ACTIONS(3121),
    [sym_this] = ACTIONS(3121),
    [sym_abstract] = ACTIONS(3121),
    [sym_alias] = ACTIONS(3121),
    [sym_align] = ACTIONS(3121),
    [sym_asm] = ACTIONS(3121),
    [sym_assert] = ACTIONS(3121),
    [sym_auto] = ACTIONS(3121),
    [sym_break] = ACTIONS(3121),
    [sym_case] = ACTIONS(3121),
    [sym_cast] = ACTIONS(3121),
    [sym_class] = ACTIONS(3121),
    [sym_const] = ACTIONS(3121),
    [sym_continue] = ACTIONS(3121),
    [sym_debug] = ACTIONS(3121),
    [sym_default] = ACTIONS(3121),
    [sym_delegate] = ACTIONS(3121),
    [sym_delete] = ACTIONS(3121),
    [sym_deprecated] = ACTIONS(3121),
    [sym_do] = ACTIONS(3121),
    [sym_else] = ACTIONS(3121),
    [sym_enum] = ACTIONS(3121),
    [sym_export] = ACTIONS(3121),
    [sym_extern] = ACTIONS(3121),
    [sym_final] = ACTIONS(3121),
    [sym_for] = ACTIONS(3121),
    [sym_foreach] = ACTIONS(3121),
    [sym_foreach_reverse] = ACTIONS(3121),
    [sym_function] = ACTIONS(3121),
    [sym_goto] = ACTIONS(3121),
    [sym_if] = ACTIONS(3121),
    [sym_immutable] = ACTIONS(3121),
    [sym_import] = ACTIONS(3121),
    [sym_in] = ACTIONS(3121),
    [sym_inout] = ACTIONS(3121),
    [sym_interface] = ACTIONS(3121),
    [sym_invariant] = ACTIONS(3121),
    [sym_is] = ACTIONS(3121),
    [sym_mixin] = ACTIONS(3121),
    [sym_new] = ACTIONS(3121),
    [sym_nothrow] = ACTIONS(3121),
    [sym_out] = ACTIONS(3121),
    [sym_override] = ACTIONS(3121),
    [sym_package] = ACTIONS(3121),
    [sym_pragma] = ACTIONS(3121),
    [sym_private] = ACTIONS(3121),
    [sym_protected] = ACTIONS(3121),
    [sym_public] = ACTIONS(3121),
    [sym_pure] = ACTIONS(3121),
    [sym_ref] = ACTIONS(3121),
    [sym_return] = ACTIONS(3121),
    [sym_scope] = ACTIONS(3121),
    [sym_shared] = ACTIONS(3121),
    [sym_static] = ACTIONS(3121),
    [sym_struct] = ACTIONS(3121),
    [sym_switch] = ACTIONS(3121),
    [sym_synchronized] = ACTIONS(3121),
    [sym_template] = ACTIONS(3121),
    [sym_throw] = ACTIONS(3121),
    [sym_try] = ACTIONS(3121),
    [sym_typeid] = ACTIONS(3121),
    [sym_typeof] = ACTIONS(3121),
    [sym_union] = ACTIONS(3121),
    [sym_unittest] = ACTIONS(3121),
    [sym_version] = ACTIONS(3121),
    [sym_while] = ACTIONS(3121),
    [sym_with] = ACTIONS(3121),
    [sym_gshared] = ACTIONS(3121),
    [sym_traits] = ACTIONS(3121),
    [sym_vector] = ACTIONS(3121),
    [sym_void] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_r_DQUOTE] = ACTIONS(3124),
    [anon_sym_x_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [anon_sym_i_BQUOTE] = ACTIONS(3124),
    [anon_sym_i_DQUOTE] = ACTIONS(3124),
    [anon_sym_iq_LBRACE] = ACTIONS(3124),
    [aux_sym_char_literal_token1] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [anon_sym___DATE__] = ACTIONS(3121),
    [anon_sym___FILE__] = ACTIONS(3121),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3121),
    [anon_sym___FUNCTION__] = ACTIONS(3121),
    [anon_sym___LINE__] = ACTIONS(3121),
    [anon_sym___MODULE__] = ACTIONS(3121),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3121),
    [anon_sym___TIME__] = ACTIONS(3121),
    [anon_sym___TIMESTAMP__] = ACTIONS(3121),
    [anon_sym___VENDOR__] = ACTIONS(3121),
    [anon_sym___VERSION__] = ACTIONS(3121),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3124),
    [sym_float_literal] = ACTIONS(3124),
    [sym__string] = ACTIONS(3124),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [673] = {
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_q_LBRACE] = ACTIONS(3148),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3145),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_DOLLAR] = ACTIONS(3148),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3148),
    [sym_bool] = ACTIONS(3145),
    [sym_byte] = ACTIONS(3145),
    [sym_ubyte] = ACTIONS(3145),
    [sym_char] = ACTIONS(3145),
    [sym_short] = ACTIONS(3145),
    [sym_ushort] = ACTIONS(3145),
    [sym_int] = ACTIONS(3145),
    [sym_uint] = ACTIONS(3145),
    [sym_long] = ACTIONS(3145),
    [sym_ulong] = ACTIONS(3145),
    [sym_cent] = ACTIONS(3145),
    [sym_ucent] = ACTIONS(3145),
    [sym_wchar] = ACTIONS(3145),
    [sym_dchar] = ACTIONS(3145),
    [sym_float] = ACTIONS(3145),
    [sym_double] = ACTIONS(3145),
    [sym_real] = ACTIONS(3145),
    [sym_ifloat] = ACTIONS(3145),
    [sym_idouble] = ACTIONS(3145),
    [sym_ireal] = ACTIONS(3145),
    [sym_cfloat] = ACTIONS(3145),
    [sym_cdouble] = ACTIONS(3145),
    [sym_creal] = ACTIONS(3145),
    [sym_size_t] = ACTIONS(3145),
    [sym_ptrdiff_t] = ACTIONS(3145),
    [sym_string] = ACTIONS(3145),
    [sym_cstring] = ACTIONS(3145),
    [sym_dstring] = ACTIONS(3145),
    [sym_wstring] = ACTIONS(3145),
    [sym_noreturn] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_abstract] = ACTIONS(3145),
    [sym_alias] = ACTIONS(3145),
    [sym_align] = ACTIONS(3145),
    [sym_asm] = ACTIONS(3145),
    [sym_assert] = ACTIONS(3145),
    [sym_auto] = ACTIONS(3145),
    [sym_break] = ACTIONS(3145),
    [sym_case] = ACTIONS(3145),
    [sym_cast] = ACTIONS(3145),
    [sym_class] = ACTIONS(3145),
    [sym_const] = ACTIONS(3145),
    [sym_continue] = ACTIONS(3145),
    [sym_debug] = ACTIONS(3145),
    [sym_default] = ACTIONS(3145),
    [sym_delegate] = ACTIONS(3145),
    [sym_delete] = ACTIONS(3145),
    [sym_deprecated] = ACTIONS(3145),
    [sym_do] = ACTIONS(3145),
    [sym_else] = ACTIONS(3145),
    [sym_enum] = ACTIONS(3145),
    [sym_export] = ACTIONS(3145),
    [sym_extern] = ACTIONS(3145),
    [sym_final] = ACTIONS(3145),
    [sym_for] = ACTIONS(3145),
    [sym_foreach] = ACTIONS(3145),
    [sym_foreach_reverse] = ACTIONS(3145),
    [sym_function] = ACTIONS(3145),
    [sym_goto] = ACTIONS(3145),
    [sym_if] = ACTIONS(3145),
    [sym_immutable] = ACTIONS(3145),
    [sym_import] = ACTIONS(3145),
    [sym_in] = ACTIONS(3145),
    [sym_inout] = ACTIONS(3145),
    [sym_interface] = ACTIONS(3145),
    [sym_invariant] = ACTIONS(3145),
    [sym_is] = ACTIONS(3145),
    [sym_mixin] = ACTIONS(3145),
    [sym_new] = ACTIONS(3145),
    [sym_nothrow] = ACTIONS(3145),
    [sym_out] = ACTIONS(3145),
    [sym_override] = ACTIONS(3145),
    [sym_package] = ACTIONS(3145),
    [sym_pragma] = ACTIONS(3145),
    [sym_private] = ACTIONS(3145),
    [sym_protected] = ACTIONS(3145),
    [sym_public] = ACTIONS(3145),
    [sym_pure] = ACTIONS(3145),
    [sym_ref] = ACTIONS(3145),
    [sym_return] = ACTIONS(3145),
    [sym_scope] = ACTIONS(3145),
    [sym_shared] = ACTIONS(3145),
    [sym_static] = ACTIONS(3145),
    [sym_struct] = ACTIONS(3145),
    [sym_switch] = ACTIONS(3145),
    [sym_synchronized] = ACTIONS(3145),
    [sym_template] = ACTIONS(3145),
    [sym_throw] = ACTIONS(3145),
    [sym_try] = ACTIONS(3145),
    [sym_typeid] = ACTIONS(3145),
    [sym_typeof] = ACTIONS(3145),
    [sym_union] = ACTIONS(3145),
    [sym_unittest] = ACTIONS(3145),
    [sym_version] = ACTIONS(3145),
    [sym_while] = ACTIONS(3145),
    [sym_with] = ACTIONS(3145),
    [sym_gshared] = ACTIONS(3145),
    [sym_traits] = ACTIONS(3145),
    [sym_vector] = ACTIONS(3145),
    [sym_void] = ACTIONS(3145),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [anon_sym_r_DQUOTE] = ACTIONS(3148),
    [anon_sym_x_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_i_BQUOTE] = ACTIONS(3148),
    [anon_sym_i_DQUOTE] = ACTIONS(3148),
    [anon_sym_iq_LBRACE] = ACTIONS(3148),
    [aux_sym_char_literal_token1] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym___DATE__] = ACTIONS(3145),
    [anon_sym___FILE__] = ACTIONS(3145),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3145),
    [anon_sym___FUNCTION__] = ACTIONS(3145),
    [anon_sym___LINE__] = ACTIONS(3145),
    [anon_sym___MODULE__] = ACTIONS(3145),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3145),
    [anon_sym___TIME__] = ACTIONS(3145),
    [anon_sym___TIMESTAMP__] = ACTIONS(3145),
    [anon_sym___VENDOR__] = ACTIONS(3145),
    [anon_sym___VERSION__] = ACTIONS(3145),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3148),
    [sym_float_literal] = ACTIONS(3148),
    [sym__string] = ACTIONS(3148),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [674] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(6236),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [675] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(6128),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [676] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5696),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [677] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_RBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3170),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_abstract] = ACTIONS(3167),
    [sym_alias] = ACTIONS(3167),
    [sym_align] = ACTIONS(3167),
    [sym_asm] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_break] = ACTIONS(3167),
    [sym_case] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_class] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_continue] = ACTIONS(3167),
    [sym_debug] = ACTIONS(3167),
    [sym_default] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_deprecated] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(3220),
    [sym_enum] = ACTIONS(3167),
    [sym_export] = ACTIONS(3167),
    [sym_extern] = ACTIONS(3167),
    [sym_final] = ACTIONS(3167),
    [sym_for] = ACTIONS(3167),
    [sym_foreach] = ACTIONS(3167),
    [sym_foreach_reverse] = ACTIONS(3167),
    [sym_function] = ACTIONS(3167),
    [sym_goto] = ACTIONS(3167),
    [sym_if] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_interface] = ACTIONS(3167),
    [sym_invariant] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_nothrow] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_override] = ACTIONS(3167),
    [sym_package] = ACTIONS(3167),
    [sym_pragma] = ACTIONS(3167),
    [sym_private] = ACTIONS(3167),
    [sym_protected] = ACTIONS(3167),
    [sym_public] = ACTIONS(3167),
    [sym_pure] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_return] = ACTIONS(3167),
    [sym_scope] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_static] = ACTIONS(3167),
    [sym_struct] = ACTIONS(3167),
    [sym_switch] = ACTIONS(3167),
    [sym_synchronized] = ACTIONS(3167),
    [sym_template] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_try] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_union] = ACTIONS(3167),
    [sym_unittest] = ACTIONS(3167),
    [sym_version] = ACTIONS(3167),
    [sym_while] = ACTIONS(3167),
    [sym_with] = ACTIONS(3167),
    [sym_gshared] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [678] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_q_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_PLUS_EQ] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_LT_EQ] = ACTIONS(3178),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3178),
    [anon_sym_GT] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT] = ACTIONS(3176),
    [anon_sym_GT_GT_GT] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3178),
    [anon_sym_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3178),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3178),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3178),
    [anon_sym_CARET_CARET] = ACTIONS(3176),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_TILDE_EQ] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_abstract] = ACTIONS(3176),
    [sym_alias] = ACTIONS(3176),
    [sym_align] = ACTIONS(3176),
    [sym_asm] = ACTIONS(3176),
    [sym_assert] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_break] = ACTIONS(3176),
    [sym_case] = ACTIONS(3176),
    [sym_cast] = ACTIONS(3176),
    [sym_class] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_continue] = ACTIONS(3176),
    [sym_debug] = ACTIONS(3176),
    [sym_default] = ACTIONS(3176),
    [sym_delegate] = ACTIONS(3176),
    [sym_delete] = ACTIONS(3176),
    [sym_deprecated] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_enum] = ACTIONS(3176),
    [sym_export] = ACTIONS(3176),
    [sym_extern] = ACTIONS(3176),
    [sym_final] = ACTIONS(3176),
    [sym_for] = ACTIONS(3176),
    [sym_foreach] = ACTIONS(3176),
    [sym_foreach_reverse] = ACTIONS(3176),
    [sym_function] = ACTIONS(3176),
    [sym_goto] = ACTIONS(3176),
    [sym_if] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_interface] = ACTIONS(3176),
    [sym_invariant] = ACTIONS(3176),
    [sym_is] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_new] = ACTIONS(3176),
    [sym_nothrow] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_override] = ACTIONS(3176),
    [sym_package] = ACTIONS(3176),
    [sym_pragma] = ACTIONS(3176),
    [sym_private] = ACTIONS(3176),
    [sym_protected] = ACTIONS(3176),
    [sym_public] = ACTIONS(3176),
    [sym_pure] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_return] = ACTIONS(3176),
    [sym_scope] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_static] = ACTIONS(3176),
    [sym_struct] = ACTIONS(3176),
    [sym_switch] = ACTIONS(3176),
    [sym_synchronized] = ACTIONS(3176),
    [sym_template] = ACTIONS(3176),
    [sym_throw] = ACTIONS(3176),
    [sym_try] = ACTIONS(3176),
    [sym_typeid] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_union] = ACTIONS(3176),
    [sym_unittest] = ACTIONS(3176),
    [sym_version] = ACTIONS(3176),
    [sym_while] = ACTIONS(3176),
    [sym_with] = ACTIONS(3176),
    [sym_gshared] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_r_DQUOTE] = ACTIONS(3178),
    [anon_sym_x_DQUOTE] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_i_BQUOTE] = ACTIONS(3178),
    [anon_sym_i_DQUOTE] = ACTIONS(3178),
    [anon_sym_iq_LBRACE] = ACTIONS(3178),
    [aux_sym_char_literal_token1] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym___DATE__] = ACTIONS(3176),
    [anon_sym___FILE__] = ACTIONS(3176),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3176),
    [anon_sym___FUNCTION__] = ACTIONS(3176),
    [anon_sym___LINE__] = ACTIONS(3176),
    [anon_sym___MODULE__] = ACTIONS(3176),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3176),
    [anon_sym___TIME__] = ACTIONS(3176),
    [anon_sym___TIMESTAMP__] = ACTIONS(3176),
    [anon_sym___VENDOR__] = ACTIONS(3176),
    [anon_sym___VERSION__] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3178),
    [sym_float_literal] = ACTIONS(3178),
    [sym__string] = ACTIONS(3178),
    [sym_not_in] = ACTIONS(3178),
    [sym_not_is] = ACTIONS(3178),
  },
  [679] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5845),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [680] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5990),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [681] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3127),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3127),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_asm] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_break] = ACTIONS(3127),
    [sym_case] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_continue] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_default] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_for] = ACTIONS(3127),
    [sym_foreach] = ACTIONS(3127),
    [sym_foreach_reverse] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_goto] = ACTIONS(3127),
    [sym_if] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_switch] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_try] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_with] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [682] = {
    [sym_identifier] = ACTIONS(3157),
    [anon_sym_q_LBRACE] = ACTIONS(3160),
    [anon_sym_RBRACE] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_RPAREN] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_DOLLAR] = ACTIONS(3160),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3160),
    [sym_bool] = ACTIONS(3157),
    [sym_byte] = ACTIONS(3157),
    [sym_ubyte] = ACTIONS(3157),
    [sym_char] = ACTIONS(3157),
    [sym_short] = ACTIONS(3157),
    [sym_ushort] = ACTIONS(3157),
    [sym_int] = ACTIONS(3157),
    [sym_uint] = ACTIONS(3157),
    [sym_long] = ACTIONS(3157),
    [sym_ulong] = ACTIONS(3157),
    [sym_cent] = ACTIONS(3157),
    [sym_ucent] = ACTIONS(3157),
    [sym_wchar] = ACTIONS(3157),
    [sym_dchar] = ACTIONS(3157),
    [sym_float] = ACTIONS(3157),
    [sym_double] = ACTIONS(3157),
    [sym_real] = ACTIONS(3157),
    [sym_ifloat] = ACTIONS(3157),
    [sym_idouble] = ACTIONS(3157),
    [sym_ireal] = ACTIONS(3157),
    [sym_cfloat] = ACTIONS(3157),
    [sym_cdouble] = ACTIONS(3157),
    [sym_creal] = ACTIONS(3157),
    [sym_size_t] = ACTIONS(3157),
    [sym_ptrdiff_t] = ACTIONS(3157),
    [sym_string] = ACTIONS(3157),
    [sym_cstring] = ACTIONS(3157),
    [sym_dstring] = ACTIONS(3157),
    [sym_wstring] = ACTIONS(3157),
    [sym_noreturn] = ACTIONS(3157),
    [sym_true] = ACTIONS(3157),
    [sym_false] = ACTIONS(3157),
    [sym_null] = ACTIONS(3157),
    [sym_super] = ACTIONS(3157),
    [sym_this] = ACTIONS(3157),
    [sym_abstract] = ACTIONS(3157),
    [sym_alias] = ACTIONS(3157),
    [sym_align] = ACTIONS(3157),
    [sym_asm] = ACTIONS(3157),
    [sym_assert] = ACTIONS(3157),
    [sym_auto] = ACTIONS(3157),
    [sym_break] = ACTIONS(3157),
    [sym_case] = ACTIONS(3157),
    [sym_cast] = ACTIONS(3157),
    [sym_class] = ACTIONS(3157),
    [sym_const] = ACTIONS(3157),
    [sym_continue] = ACTIONS(3157),
    [sym_debug] = ACTIONS(3157),
    [sym_default] = ACTIONS(3157),
    [sym_delegate] = ACTIONS(3157),
    [sym_delete] = ACTIONS(3157),
    [sym_deprecated] = ACTIONS(3157),
    [sym_do] = ACTIONS(3157),
    [sym_else] = ACTIONS(3157),
    [sym_enum] = ACTIONS(3157),
    [sym_export] = ACTIONS(3157),
    [sym_extern] = ACTIONS(3157),
    [sym_final] = ACTIONS(3157),
    [sym_for] = ACTIONS(3157),
    [sym_foreach] = ACTIONS(3157),
    [sym_foreach_reverse] = ACTIONS(3157),
    [sym_function] = ACTIONS(3157),
    [sym_goto] = ACTIONS(3157),
    [sym_if] = ACTIONS(3157),
    [sym_immutable] = ACTIONS(3157),
    [sym_import] = ACTIONS(3157),
    [sym_in] = ACTIONS(3157),
    [sym_inout] = ACTIONS(3157),
    [sym_interface] = ACTIONS(3157),
    [sym_invariant] = ACTIONS(3157),
    [sym_is] = ACTIONS(3157),
    [sym_mixin] = ACTIONS(3157),
    [sym_new] = ACTIONS(3157),
    [sym_nothrow] = ACTIONS(3157),
    [sym_out] = ACTIONS(3157),
    [sym_override] = ACTIONS(3157),
    [sym_package] = ACTIONS(3157),
    [sym_pragma] = ACTIONS(3157),
    [sym_private] = ACTIONS(3157),
    [sym_protected] = ACTIONS(3157),
    [sym_public] = ACTIONS(3157),
    [sym_pure] = ACTIONS(3157),
    [sym_ref] = ACTIONS(3157),
    [sym_return] = ACTIONS(3157),
    [sym_scope] = ACTIONS(3157),
    [sym_shared] = ACTIONS(3157),
    [sym_static] = ACTIONS(3157),
    [sym_struct] = ACTIONS(3157),
    [sym_switch] = ACTIONS(3157),
    [sym_synchronized] = ACTIONS(3157),
    [sym_template] = ACTIONS(3157),
    [sym_throw] = ACTIONS(3157),
    [sym_try] = ACTIONS(3157),
    [sym_typeid] = ACTIONS(3157),
    [sym_typeof] = ACTIONS(3157),
    [sym_union] = ACTIONS(3157),
    [sym_unittest] = ACTIONS(3157),
    [sym_version] = ACTIONS(3157),
    [sym_while] = ACTIONS(3157),
    [sym_with] = ACTIONS(3157),
    [sym_gshared] = ACTIONS(3157),
    [sym_traits] = ACTIONS(3157),
    [sym_vector] = ACTIONS(3157),
    [sym_void] = ACTIONS(3157),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [anon_sym_r_DQUOTE] = ACTIONS(3160),
    [anon_sym_x_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_i_BQUOTE] = ACTIONS(3160),
    [anon_sym_i_DQUOTE] = ACTIONS(3160),
    [anon_sym_iq_LBRACE] = ACTIONS(3160),
    [aux_sym_char_literal_token1] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3157),
    [anon_sym___DATE__] = ACTIONS(3157),
    [anon_sym___FILE__] = ACTIONS(3157),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3157),
    [anon_sym___FUNCTION__] = ACTIONS(3157),
    [anon_sym___LINE__] = ACTIONS(3157),
    [anon_sym___MODULE__] = ACTIONS(3157),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3157),
    [anon_sym___TIME__] = ACTIONS(3157),
    [anon_sym___TIMESTAMP__] = ACTIONS(3157),
    [anon_sym___VENDOR__] = ACTIONS(3157),
    [anon_sym___VERSION__] = ACTIONS(3157),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3160),
    [sym_float_literal] = ACTIONS(3160),
    [sym__string] = ACTIONS(3160),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [683] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym_expression] = STATE(5996),
    [sym__expr] = STATE(3599),
    [sym_ternary_expression] = STATE(3599),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3599),
    [sym_binary_expression] = STATE(3599),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [684] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4360),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6205),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [685] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4347),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(6456),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [686] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4349),
    [sym_type_ctor] = STATE(3237),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4285),
    [sym__builtin_type] = STATE(4285),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(3248),
    [sym_at_attribute] = STATE(3306),
    [sym_expression_list] = STATE(5721),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3232),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3230),
    [sym_traits_expression] = STATE(3232),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3188),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(3196),
    [sym_byte] = ACTIONS(3196),
    [sym_ubyte] = ACTIONS(3196),
    [sym_char] = ACTIONS(3196),
    [sym_short] = ACTIONS(3196),
    [sym_ushort] = ACTIONS(3196),
    [sym_int] = ACTIONS(3196),
    [sym_uint] = ACTIONS(3196),
    [sym_long] = ACTIONS(3196),
    [sym_ulong] = ACTIONS(3196),
    [sym_cent] = ACTIONS(3196),
    [sym_ucent] = ACTIONS(3196),
    [sym_wchar] = ACTIONS(3196),
    [sym_dchar] = ACTIONS(3196),
    [sym_float] = ACTIONS(3196),
    [sym_double] = ACTIONS(3196),
    [sym_real] = ACTIONS(3196),
    [sym_ifloat] = ACTIONS(3196),
    [sym_idouble] = ACTIONS(3196),
    [sym_ireal] = ACTIONS(3196),
    [sym_cfloat] = ACTIONS(3196),
    [sym_cdouble] = ACTIONS(3196),
    [sym_creal] = ACTIONS(3196),
    [sym_size_t] = ACTIONS(3196),
    [sym_ptrdiff_t] = ACTIONS(3196),
    [sym_string] = ACTIONS(3196),
    [sym_cstring] = ACTIONS(3196),
    [sym_dstring] = ACTIONS(3196),
    [sym_wstring] = ACTIONS(3196),
    [sym_noreturn] = ACTIONS(3196),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3198),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(3200),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_final] = ACTIONS(3202),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(3200),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(3204),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(3208),
    [sym_ref] = ACTIONS(3210),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [687] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3223),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3223),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3127),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3127),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_asm] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_break] = ACTIONS(3127),
    [sym_case] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_continue] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_default] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_for] = ACTIONS(3127),
    [sym_foreach] = ACTIONS(3127),
    [sym_foreach_reverse] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_goto] = ACTIONS(3127),
    [sym_if] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_switch] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_try] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_with] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [688] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_q_LBRACE] = ACTIONS(3133),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_SLASH] = ACTIONS(3135),
    [anon_sym_SLASH_EQ] = ACTIONS(3137),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_AMP_EQ] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PIPE_EQ] = ACTIONS(3137),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_DASH_EQ] = ACTIONS(3137),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_PLUS_EQ] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_LT_EQ] = ACTIONS(3137),
    [anon_sym_LT_LT] = ACTIONS(3135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3135),
    [anon_sym_GT_GT_GT] = ACTIONS(3135),
    [anon_sym_BANG] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(3133),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_EQ_EQ] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_STAR_EQ] = ACTIONS(3137),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3137),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_CARET_EQ] = ACTIONS(3137),
    [anon_sym_CARET_CARET] = ACTIONS(3135),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_TILDE_EQ] = ACTIONS(3137),
    [anon_sym_AT] = ACTIONS(3133),
    [sym_bool] = ACTIONS(3131),
    [sym_byte] = ACTIONS(3131),
    [sym_ubyte] = ACTIONS(3131),
    [sym_char] = ACTIONS(3131),
    [sym_short] = ACTIONS(3131),
    [sym_ushort] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_uint] = ACTIONS(3131),
    [sym_long] = ACTIONS(3131),
    [sym_ulong] = ACTIONS(3131),
    [sym_cent] = ACTIONS(3131),
    [sym_ucent] = ACTIONS(3131),
    [sym_wchar] = ACTIONS(3131),
    [sym_dchar] = ACTIONS(3131),
    [sym_float] = ACTIONS(3131),
    [sym_double] = ACTIONS(3131),
    [sym_real] = ACTIONS(3131),
    [sym_ifloat] = ACTIONS(3131),
    [sym_idouble] = ACTIONS(3131),
    [sym_ireal] = ACTIONS(3131),
    [sym_cfloat] = ACTIONS(3131),
    [sym_cdouble] = ACTIONS(3131),
    [sym_creal] = ACTIONS(3131),
    [sym_size_t] = ACTIONS(3131),
    [sym_ptrdiff_t] = ACTIONS(3131),
    [sym_string] = ACTIONS(3131),
    [sym_cstring] = ACTIONS(3131),
    [sym_dstring] = ACTIONS(3131),
    [sym_wstring] = ACTIONS(3131),
    [sym_noreturn] = ACTIONS(3131),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_super] = ACTIONS(3131),
    [sym_this] = ACTIONS(3131),
    [sym_abstract] = ACTIONS(3131),
    [sym_alias] = ACTIONS(3131),
    [sym_align] = ACTIONS(3131),
    [sym_asm] = ACTIONS(3131),
    [sym_assert] = ACTIONS(3131),
    [sym_auto] = ACTIONS(3131),
    [sym_break] = ACTIONS(3131),
    [sym_case] = ACTIONS(3131),
    [sym_cast] = ACTIONS(3131),
    [sym_class] = ACTIONS(3131),
    [sym_const] = ACTIONS(3131),
    [sym_continue] = ACTIONS(3131),
    [sym_debug] = ACTIONS(3131),
    [sym_default] = ACTIONS(3131),
    [sym_delegate] = ACTIONS(3131),
    [sym_delete] = ACTIONS(3131),
    [sym_deprecated] = ACTIONS(3131),
    [sym_do] = ACTIONS(3131),
    [sym_enum] = ACTIONS(3131),
    [sym_export] = ACTIONS(3131),
    [sym_extern] = ACTIONS(3131),
    [sym_final] = ACTIONS(3131),
    [sym_for] = ACTIONS(3131),
    [sym_foreach] = ACTIONS(3131),
    [sym_foreach_reverse] = ACTIONS(3131),
    [sym_function] = ACTIONS(3131),
    [sym_goto] = ACTIONS(3131),
    [sym_if] = ACTIONS(3131),
    [sym_immutable] = ACTIONS(3131),
    [sym_import] = ACTIONS(3131),
    [sym_in] = ACTIONS(3142),
    [sym_inout] = ACTIONS(3131),
    [sym_interface] = ACTIONS(3131),
    [sym_invariant] = ACTIONS(3131),
    [sym_is] = ACTIONS(3142),
    [sym_mixin] = ACTIONS(3131),
    [sym_new] = ACTIONS(3131),
    [sym_nothrow] = ACTIONS(3131),
    [sym_out] = ACTIONS(3131),
    [sym_override] = ACTIONS(3131),
    [sym_package] = ACTIONS(3131),
    [sym_pragma] = ACTIONS(3131),
    [sym_private] = ACTIONS(3131),
    [sym_protected] = ACTIONS(3131),
    [sym_public] = ACTIONS(3131),
    [sym_pure] = ACTIONS(3131),
    [sym_ref] = ACTIONS(3131),
    [sym_return] = ACTIONS(3131),
    [sym_scope] = ACTIONS(3131),
    [sym_shared] = ACTIONS(3131),
    [sym_static] = ACTIONS(3131),
    [sym_struct] = ACTIONS(3131),
    [sym_switch] = ACTIONS(3131),
    [sym_synchronized] = ACTIONS(3131),
    [sym_template] = ACTIONS(3131),
    [sym_throw] = ACTIONS(3131),
    [sym_try] = ACTIONS(3131),
    [sym_typeid] = ACTIONS(3131),
    [sym_typeof] = ACTIONS(3131),
    [sym_union] = ACTIONS(3131),
    [sym_unittest] = ACTIONS(3131),
    [sym_version] = ACTIONS(3131),
    [sym_while] = ACTIONS(3131),
    [sym_with] = ACTIONS(3131),
    [sym_gshared] = ACTIONS(3131),
    [sym_traits] = ACTIONS(3131),
    [sym_vector] = ACTIONS(3131),
    [sym_void] = ACTIONS(3131),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [anon_sym_r_DQUOTE] = ACTIONS(3133),
    [anon_sym_x_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE] = ACTIONS(3133),
    [anon_sym_i_BQUOTE] = ACTIONS(3133),
    [anon_sym_i_DQUOTE] = ACTIONS(3133),
    [anon_sym_iq_LBRACE] = ACTIONS(3133),
    [aux_sym_char_literal_token1] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3131),
    [anon_sym___DATE__] = ACTIONS(3131),
    [anon_sym___FILE__] = ACTIONS(3131),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3131),
    [anon_sym___FUNCTION__] = ACTIONS(3131),
    [anon_sym___LINE__] = ACTIONS(3131),
    [anon_sym___MODULE__] = ACTIONS(3131),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3131),
    [anon_sym___TIME__] = ACTIONS(3131),
    [anon_sym___TIMESTAMP__] = ACTIONS(3131),
    [anon_sym___VENDOR__] = ACTIONS(3131),
    [anon_sym___VERSION__] = ACTIONS(3131),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3133),
    [sym_float_literal] = ACTIONS(3133),
    [sym__string] = ACTIONS(3133),
    [sym_not_in] = ACTIONS(3137),
    [sym_not_is] = ACTIONS(3137),
  },
  [689] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6353),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3226),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(3228),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_struct] = ACTIONS(3228),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [690] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5633),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_class] = ACTIONS(3232),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_struct] = ACTIONS(3232),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [691] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3244),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [692] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3260),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [693] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_named_argument] = STATE(5013),
    [sym__named_argument_list] = STATE(6408),
    [sym_expression] = STATE(5340),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [694] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_named_argument] = STATE(5013),
    [sym__named_argument_list] = STATE(6141),
    [sym_expression] = STATE(5340),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3266),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [695] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5097),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3268),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [696] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5008),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3270),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [697] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3272),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [698] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3274),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [699] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3276),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [700] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_named_argument] = STATE(5013),
    [sym__named_argument_list] = STATE(6245),
    [sym_expression] = STATE(5340),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3278),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [701] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5300),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5300),
    [sym_member_initializer] = STATE(5609),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(3282),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [702] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3284),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [703] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5300),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5300),
    [sym_member_initializer] = STATE(5609),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_RBRACE] = ACTIONS(3286),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [704] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(4854),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_RBRACK] = ACTIONS(3288),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [705] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5762),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3290),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [706] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3308),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [707] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5650),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3376),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [708] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6366),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3378),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [709] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6345),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3380),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [710] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6201),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [711] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6202),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [712] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6211),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [713] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3388),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [714] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5783),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [715] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_named_argument] = STATE(5593),
    [sym_expression] = STATE(5340),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [716] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6079),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [717] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(4980),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3396),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [718] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5300),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5300),
    [sym_member_initializer] = STATE(5609),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3280),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [719] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6118),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [720] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5706),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [721] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5727),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3017),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [722] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6170),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [723] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5483),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3406),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [724] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3408),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [725] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5269),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3410),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3412),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [726] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(4819),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3414),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [727] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5621),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3416),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3418),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [728] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5816),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3420),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [729] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3422),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [730] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5706),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3424),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [731] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5782),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3426),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [732] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5388),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3428),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3430),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [733] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5680),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3432),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [734] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5348),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3436),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [735] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_named_argument] = STATE(5593),
    [sym_expression] = STATE(5340),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [736] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5804),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [737] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3442),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [738] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5455),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [739] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5022),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3448),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [740] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5788),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3450),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [741] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression] = STATE(5745),
    [sym__expr] = STATE(3578),
    [sym_ternary_expression] = STATE(3578),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3578),
    [sym_binary_expression] = STATE(3578),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym__array_member_init] = STATE(5504),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5546),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [742] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5413),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [743] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6247),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [744] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6271),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [745] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5550),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3462),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [746] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3464),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [747] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5587),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3468),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [748] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5440),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3472),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [749] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5422),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3474),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [750] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(6361),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [751] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5793),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [752] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5942),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3482),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [753] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6464),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [754] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5881),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [755] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6453),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [756] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5429),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3490),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3492),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [757] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6305),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3494),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [758] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6318),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3496),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [759] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6018),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3498),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [760] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5977),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [761] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5628),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [762] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5978),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [763] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5803),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3506),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [764] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5974),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3508),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [765] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6148),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [766] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5199),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5586),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3514),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [767] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5689),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [768] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5171),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5489),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3516),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [769] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6006),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [770] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5246),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5246),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [771] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6223),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [772] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5717),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [773] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5306),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5306),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [774] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4866),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5215),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3520),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [775] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6107),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [776] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5669),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [777] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5947),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [778] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6523),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [779] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5946),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3526),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [780] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5480),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [781] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5347),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3530),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [782] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5943),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [783] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6027),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3534),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [784] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6490),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [785] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6004),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [786] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6479),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3538),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [787] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6007),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3540),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [788] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4866),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5399),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3520),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [789] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6036),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [790] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6121),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [791] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5914),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [792] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5913),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [793] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5247),
    [sym_expression] = STATE(6488),
    [sym__expr] = STATE(3590),
    [sym_ternary_expression] = STATE(3590),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3590),
    [sym_binary_expression] = STATE(3590),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [794] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(6423),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [795] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6008),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3546),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [796] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5820),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [797] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5574),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3624),
    [sym_ternary_expression] = STATE(3624),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3624),
    [sym_binary_expression] = STATE(3624),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5574),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [798] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5749),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3548),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [799] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(6159),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [800] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5754),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3550),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [801] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5433),
    [sym_expression] = STATE(6506),
    [sym__expr] = STATE(3590),
    [sym_ternary_expression] = STATE(3590),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3590),
    [sym_binary_expression] = STATE(3590),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [802] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6228),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [803] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5755),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3552),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [804] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5118),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5234),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3554),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [805] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6031),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [806] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6234),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3558),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [807] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6237),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [808] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5480),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3560),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [809] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(6372),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [810] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5909),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [811] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5397),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5397),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [812] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(6293),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [813] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6270),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [814] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4866),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5207),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3520),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [815] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6055),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3564),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [816] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6383),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [817] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6034),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3566),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [818] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6035),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3568),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [819] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5869),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3570),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [820] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(6379),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [821] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6393),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3572),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [822] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5778),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [823] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6343),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [824] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(4839),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [825] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5629),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3576),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [826] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5467),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5467),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [827] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5642),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [828] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5851),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [829] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5299),
    [sym_expression] = STATE(6533),
    [sym__expr] = STATE(3590),
    [sym_ternary_expression] = STATE(3590),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3590),
    [sym_binary_expression] = STATE(3590),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [830] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5209),
    [sym_expression] = STATE(5883),
    [sym__expr] = STATE(3590),
    [sym_ternary_expression] = STATE(3590),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3590),
    [sym_binary_expression] = STATE(3590),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [831] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(6092),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [832] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5670),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3578),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [833] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6179),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [834] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5347),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3582),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [835] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6136),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3584),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [836] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5699),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_SEMI] = ACTIONS(3586),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [837] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5750),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3588),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [838] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5801),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_return] = ACTIONS(3590),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [839] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6153),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3592),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [840] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5861),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3594),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [841] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4894),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5477),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3596),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [842] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_expression] = STATE(4981),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_index] = STATE(5580),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [843] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_named_argument] = STATE(5593),
    [sym_expression] = STATE(5340),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3262),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [844] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6150),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [845] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5163),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5314),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3600),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [846] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5908),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [847] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5831),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [848] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4752),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5355),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [849] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5810),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [850] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5860),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3606),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [851] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5520),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_assert_arguments] = STATE(5662),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [852] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5452),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5452),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [853] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5608),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5608),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [854] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4863),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5339),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3608),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [855] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4954),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5573),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [856] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4868),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5534),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3612),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [857] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5128),
    [sym__template_argument_list] = STATE(5927),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [858] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6313),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [859] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5906),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3616),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [860] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6314),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3618),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [861] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5347),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [862] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(6324),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3622),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [863] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5852),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [864] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(4866),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5341),
    [sym__expr] = STATE(3592),
    [sym_ternary_expression] = STATE(3592),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3592),
    [sym_binary_expression] = STATE(3592),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3510),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3520),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [865] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression_list] = STATE(5855),
    [sym__expr] = STATE(3552),
    [sym_ternary_expression] = STATE(3552),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3552),
    [sym_binary_expression] = STATE(3552),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3624),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [866] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5347),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3626),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [867] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym__initializer] = STATE(5282),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3591),
    [sym_ternary_expression] = STATE(3591),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3591),
    [sym_binary_expression] = STATE(3591),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5282),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(209),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [868] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__argument_list] = STATE(5960),
    [sym_expression] = STATE(4825),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [869] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5632),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [870] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6025),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [871] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5761),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [872] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5290),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [873] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6311),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [874] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6308),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [875] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6298),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [876] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5844),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [877] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5846),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [878] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5479),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [879] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5814),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [880] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6301),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [881] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5775),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [882] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5478),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [883] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5864),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [884] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5865),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [885] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5866),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [886] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5867),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [887] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5898),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [888] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5900),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [889] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5931),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [890] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5453),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [891] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5916),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [892] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5929),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [893] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5522),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [894] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6119),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [895] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5917),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [896] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5918),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [897] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5790),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [898] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5448),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [899] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5919),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [900] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5934),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [901] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5876),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [902] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6203),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [903] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5936),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [904] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5751),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [905] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5437),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [906] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5748),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [907] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(5902),
    [sym__expr] = STATE(3658),
    [sym_ternary_expression] = STATE(3658),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3658),
    [sym_binary_expression] = STATE(3658),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [908] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5436),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [909] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6037),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [910] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5949),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [911] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5950),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [912] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5951),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [913] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5759),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [914] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5952),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [915] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6110),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [916] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5815),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [917] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5965),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [918] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(6315),
    [sym__expr] = STATE(3658),
    [sym_ternary_expression] = STATE(3658),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3658),
    [sym_binary_expression] = STATE(3658),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [919] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5967),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [920] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6320),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [921] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5286),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [922] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5957),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [923] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5428),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [924] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6337),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [925] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5427),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [926] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5980),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [927] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5981),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [928] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5982),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [929] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5958),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [930] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5983),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [931] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5995),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [932] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5758),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [933] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5997),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [934] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5419),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [935] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6209),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [936] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4899),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(6268),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [937] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5418),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [938] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5270),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [939] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5545),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [940] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5547),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [941] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6010),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [942] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6011),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [943] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6377),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [944] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5911),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [945] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6012),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [946] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6000),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [947] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6013),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [948] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6386),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [949] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5446),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [950] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6389),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [951] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6023),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [952] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6294),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [953] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6363),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [954] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5760),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [955] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5739),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [956] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5737),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [957] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6402),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [958] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5655),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [959] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6404),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [960] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5025),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(6409),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [961] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6411),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [962] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5637),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [963] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6419),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [964] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5412),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [965] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5576),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [966] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6157),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [967] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6146),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [968] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4818),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(6142),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [969] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6140),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [970] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5411),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [971] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5656),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [972] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5636),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [973] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5660),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [974] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5612),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [975] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6139),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [976] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5635),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [977] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6422),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [978] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6038),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [979] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6130),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [980] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6127),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [981] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5939),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [982] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4629),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3631),
    [sym_ternary_expression] = STATE(3631),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3631),
    [sym_binary_expression] = STATE(3631),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_template_argument] = STATE(5480),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [983] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6039),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [984] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6005),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [985] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6040),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [986] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6030),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [987] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5963),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [988] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5372),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [989] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5953),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [990] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5975),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [991] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6131),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [992] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6135),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [993] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6085),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [994] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5396),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [995] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6066),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [996] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5604),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [997] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6515),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [998] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5406),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [999] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5598),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1000] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6046),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1001] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5508),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1002] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5695),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1003] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(5948),
    [sym__expr] = STATE(3658),
    [sym_ternary_expression] = STATE(3658),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3658),
    [sym_binary_expression] = STATE(3658),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1004] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5698),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1005] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3642),
    [sym_ternary_expression] = STATE(3642),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3642),
    [sym_binary_expression] = STATE(3642),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym_aggregate_initializer] = STATE(5503),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1006] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5688),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1007] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6152),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1008] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4851),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3665),
    [sym_ternary_expression] = STATE(3665),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3665),
    [sym_binary_expression] = STATE(3665),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3201),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3668),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_scope] = ACTIONS(3670),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1009] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(5705),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1010] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6151),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1011] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6193),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1012] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5365),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1013] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5785),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1014] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5710),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1015] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6303),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1016] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5971),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1017] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6275),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1018] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5451),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1019] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6322),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1020] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6375),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1021] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6241),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1022] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5999),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1023] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_expression_list] = STATE(6261),
    [sym__expr] = STATE(3570),
    [sym_ternary_expression] = STATE(3570),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3570),
    [sym_binary_expression] = STATE(3570),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1024] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6233),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1025] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5359),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1026] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5901),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1027] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5973),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1028] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5961),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1029] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5595),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1030] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_expression] = STATE(6158),
    [sym__expr] = STATE(3658),
    [sym_ternary_expression] = STATE(3658),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3658),
    [sym_binary_expression] = STATE(3658),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1031] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5420),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1032] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6319),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1033] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_expression] = STATE(5367),
    [sym__expr] = STATE(3640),
    [sym_ternary_expression] = STATE(3640),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3640),
    [sym_binary_expression] = STATE(3640),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1034] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6129),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1035] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5347),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1036] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5998),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1037] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6115),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1038] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(6111),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1039] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5588),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1040] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_expression] = STATE(5992),
    [sym__expr] = STATE(3556),
    [sym_ternary_expression] = STATE(3556),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3556),
    [sym_binary_expression] = STATE(3556),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1041] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3586),
    [sym_ternary_expression] = STATE(3586),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3586),
    [sym_binary_expression] = STATE(3586),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1042] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3676),
    [sym_ternary_expression] = STATE(3676),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3676),
    [sym_binary_expression] = STATE(3676),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1043] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3492),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3492),
    [sym_ternary_expression] = STATE(3492),
    [sym_call_expression] = STATE(3492),
    [sym_primary_expression] = STATE(3492),
    [sym__primary_expr] = STATE(3492),
    [sym_index_expression] = STATE(3492),
    [sym_assignment_expression] = STATE(3492),
    [sym_binary_expression] = STATE(3492),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3492),
    [sym_unary_expression] = STATE(3492),
    [sym__unary_expr] = STATE(3492),
    [sym_property_expression] = STATE(3492),
    [sym_cast_expression] = STATE(3492),
    [sym_delete_expression] = STATE(3492),
    [sym_throw_expression] = STATE(3492),
    [sym_assert_expression] = STATE(3492),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3492),
    [sym_new_expression] = STATE(3492),
    [sym_typeid_expression] = STATE(3492),
    [sym_is_expression] = STATE(3492),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3492),
    [sym_char_literal] = STATE(3492),
    [sym_array_literal] = STATE(3492),
    [sym_function_literal] = STATE(3492),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3492),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3672),
    [sym_false] = ACTIONS(3672),
    [sym_null] = ACTIONS(3672),
    [sym_super] = ACTIONS(3672),
    [sym_this] = ACTIONS(3672),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3674),
    [sym_float_literal] = ACTIONS(3674),
    [sym__string] = ACTIONS(3370),
  },
  [1044] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3656),
    [sym_ternary_expression] = STATE(3656),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3656),
    [sym_binary_expression] = STATE(3656),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1045] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3621),
    [sym_ternary_expression] = STATE(3621),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3621),
    [sym_binary_expression] = STATE(3621),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1046] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3499),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3499),
    [sym_ternary_expression] = STATE(3499),
    [sym_call_expression] = STATE(3499),
    [sym_primary_expression] = STATE(3499),
    [sym__primary_expr] = STATE(3499),
    [sym_index_expression] = STATE(3499),
    [sym_assignment_expression] = STATE(3499),
    [sym_binary_expression] = STATE(3499),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3499),
    [sym_unary_expression] = STATE(3499),
    [sym__unary_expr] = STATE(3499),
    [sym_property_expression] = STATE(3499),
    [sym_cast_expression] = STATE(3499),
    [sym_delete_expression] = STATE(3499),
    [sym_throw_expression] = STATE(3499),
    [sym_assert_expression] = STATE(3499),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3499),
    [sym_new_expression] = STATE(3499),
    [sym_typeid_expression] = STATE(3499),
    [sym_is_expression] = STATE(3499),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3499),
    [sym_char_literal] = STATE(3499),
    [sym_array_literal] = STATE(3499),
    [sym_function_literal] = STATE(3499),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3499),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3676),
    [sym_false] = ACTIONS(3676),
    [sym_null] = ACTIONS(3676),
    [sym_super] = ACTIONS(3676),
    [sym_this] = ACTIONS(3676),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3678),
    [sym_float_literal] = ACTIONS(3678),
    [sym__string] = ACTIONS(3370),
  },
  [1047] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3504),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3504),
    [sym_ternary_expression] = STATE(3504),
    [sym_call_expression] = STATE(3504),
    [sym_primary_expression] = STATE(3504),
    [sym__primary_expr] = STATE(3504),
    [sym_index_expression] = STATE(3504),
    [sym_assignment_expression] = STATE(3504),
    [sym_binary_expression] = STATE(3504),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3504),
    [sym_unary_expression] = STATE(3504),
    [sym__unary_expr] = STATE(3504),
    [sym_property_expression] = STATE(3504),
    [sym_cast_expression] = STATE(3504),
    [sym_delete_expression] = STATE(3504),
    [sym_throw_expression] = STATE(3504),
    [sym_assert_expression] = STATE(3504),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3504),
    [sym_new_expression] = STATE(3504),
    [sym_typeid_expression] = STATE(3504),
    [sym_is_expression] = STATE(3504),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3504),
    [sym_char_literal] = STATE(3504),
    [sym_array_literal] = STATE(3504),
    [sym_function_literal] = STATE(3504),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3504),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3680),
    [sym_false] = ACTIONS(3680),
    [sym_null] = ACTIONS(3680),
    [sym_super] = ACTIONS(3680),
    [sym_this] = ACTIONS(3680),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3682),
    [sym_float_literal] = ACTIONS(3682),
    [sym__string] = ACTIONS(3370),
  },
  [1048] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3495),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3495),
    [sym_ternary_expression] = STATE(3495),
    [sym_call_expression] = STATE(3495),
    [sym_primary_expression] = STATE(3495),
    [sym__primary_expr] = STATE(3495),
    [sym_index_expression] = STATE(3495),
    [sym_assignment_expression] = STATE(3495),
    [sym_binary_expression] = STATE(3495),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3495),
    [sym_unary_expression] = STATE(3495),
    [sym__unary_expr] = STATE(3495),
    [sym_property_expression] = STATE(3495),
    [sym_cast_expression] = STATE(3495),
    [sym_delete_expression] = STATE(3495),
    [sym_throw_expression] = STATE(3495),
    [sym_assert_expression] = STATE(3495),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3495),
    [sym_new_expression] = STATE(3495),
    [sym_typeid_expression] = STATE(3495),
    [sym_is_expression] = STATE(3495),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3495),
    [sym_char_literal] = STATE(3495),
    [sym_array_literal] = STATE(3495),
    [sym_function_literal] = STATE(3495),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3495),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3684),
    [sym_false] = ACTIONS(3684),
    [sym_null] = ACTIONS(3684),
    [sym_super] = ACTIONS(3684),
    [sym_this] = ACTIONS(3684),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3686),
    [sym_float_literal] = ACTIONS(3686),
    [sym__string] = ACTIONS(3370),
  },
  [1049] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3655),
    [sym_ternary_expression] = STATE(3655),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3655),
    [sym_binary_expression] = STATE(3655),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1050] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3652),
    [sym_ternary_expression] = STATE(3652),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3652),
    [sym_binary_expression] = STATE(3652),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1051] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3662),
    [sym_ternary_expression] = STATE(3662),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3662),
    [sym_binary_expression] = STATE(3662),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1052] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3501),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3501),
    [sym_ternary_expression] = STATE(3501),
    [sym_call_expression] = STATE(3501),
    [sym_primary_expression] = STATE(3501),
    [sym__primary_expr] = STATE(3501),
    [sym_index_expression] = STATE(3501),
    [sym_assignment_expression] = STATE(3501),
    [sym_binary_expression] = STATE(3501),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3501),
    [sym_unary_expression] = STATE(3501),
    [sym__unary_expr] = STATE(3501),
    [sym_property_expression] = STATE(3501),
    [sym_cast_expression] = STATE(3501),
    [sym_delete_expression] = STATE(3501),
    [sym_throw_expression] = STATE(3501),
    [sym_assert_expression] = STATE(3501),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3501),
    [sym_new_expression] = STATE(3501),
    [sym_typeid_expression] = STATE(3501),
    [sym_is_expression] = STATE(3501),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3501),
    [sym_char_literal] = STATE(3501),
    [sym_array_literal] = STATE(3501),
    [sym_function_literal] = STATE(3501),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3501),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3688),
    [sym_false] = ACTIONS(3688),
    [sym_null] = ACTIONS(3688),
    [sym_super] = ACTIONS(3688),
    [sym_this] = ACTIONS(3688),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3690),
    [sym_float_literal] = ACTIONS(3690),
    [sym__string] = ACTIONS(3370),
  },
  [1053] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3648),
    [sym_ternary_expression] = STATE(3648),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3648),
    [sym_binary_expression] = STATE(3648),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1054] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3647),
    [sym_ternary_expression] = STATE(3647),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3647),
    [sym_binary_expression] = STATE(3647),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1055] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3507),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3507),
    [sym_ternary_expression] = STATE(3507),
    [sym_call_expression] = STATE(3507),
    [sym_primary_expression] = STATE(3507),
    [sym__primary_expr] = STATE(3507),
    [sym_index_expression] = STATE(3507),
    [sym_assignment_expression] = STATE(3507),
    [sym_binary_expression] = STATE(3507),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3507),
    [sym_unary_expression] = STATE(3507),
    [sym__unary_expr] = STATE(3507),
    [sym_property_expression] = STATE(3507),
    [sym_cast_expression] = STATE(3507),
    [sym_delete_expression] = STATE(3507),
    [sym_throw_expression] = STATE(3507),
    [sym_assert_expression] = STATE(3507),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3507),
    [sym_new_expression] = STATE(3507),
    [sym_typeid_expression] = STATE(3507),
    [sym_is_expression] = STATE(3507),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3507),
    [sym_char_literal] = STATE(3507),
    [sym_array_literal] = STATE(3507),
    [sym_function_literal] = STATE(3507),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3507),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3692),
    [sym_false] = ACTIONS(3692),
    [sym_null] = ACTIONS(3692),
    [sym_super] = ACTIONS(3692),
    [sym_this] = ACTIONS(3692),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3694),
    [sym_float_literal] = ACTIONS(3694),
    [sym__string] = ACTIONS(3370),
  },
  [1056] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3618),
    [sym_ternary_expression] = STATE(3618),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3618),
    [sym_binary_expression] = STATE(3618),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1057] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3564),
    [sym_ternary_expression] = STATE(3564),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3564),
    [sym_binary_expression] = STATE(3564),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1058] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3635),
    [sym_ternary_expression] = STATE(3635),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3635),
    [sym_binary_expression] = STATE(3635),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1059] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3508),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3508),
    [sym_ternary_expression] = STATE(3508),
    [sym_call_expression] = STATE(3508),
    [sym_primary_expression] = STATE(3508),
    [sym__primary_expr] = STATE(3508),
    [sym_index_expression] = STATE(3508),
    [sym_assignment_expression] = STATE(3508),
    [sym_binary_expression] = STATE(3508),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3508),
    [sym_unary_expression] = STATE(3508),
    [sym__unary_expr] = STATE(3508),
    [sym_property_expression] = STATE(3508),
    [sym_cast_expression] = STATE(3508),
    [sym_delete_expression] = STATE(3508),
    [sym_throw_expression] = STATE(3508),
    [sym_assert_expression] = STATE(3508),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3508),
    [sym_new_expression] = STATE(3508),
    [sym_typeid_expression] = STATE(3508),
    [sym_is_expression] = STATE(3508),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3508),
    [sym_char_literal] = STATE(3508),
    [sym_array_literal] = STATE(3508),
    [sym_function_literal] = STATE(3508),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3508),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3696),
    [sym_false] = ACTIONS(3696),
    [sym_null] = ACTIONS(3696),
    [sym_super] = ACTIONS(3696),
    [sym_this] = ACTIONS(3696),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3698),
    [sym_float_literal] = ACTIONS(3698),
    [sym__string] = ACTIONS(3370),
  },
  [1060] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3512),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3512),
    [sym_ternary_expression] = STATE(3512),
    [sym_call_expression] = STATE(3512),
    [sym_primary_expression] = STATE(3512),
    [sym__primary_expr] = STATE(3512),
    [sym_index_expression] = STATE(3512),
    [sym_assignment_expression] = STATE(3512),
    [sym_binary_expression] = STATE(3512),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3512),
    [sym_unary_expression] = STATE(3512),
    [sym__unary_expr] = STATE(3512),
    [sym_property_expression] = STATE(3512),
    [sym_cast_expression] = STATE(3512),
    [sym_delete_expression] = STATE(3512),
    [sym_throw_expression] = STATE(3512),
    [sym_assert_expression] = STATE(3512),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3512),
    [sym_new_expression] = STATE(3512),
    [sym_typeid_expression] = STATE(3512),
    [sym_is_expression] = STATE(3512),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3512),
    [sym_char_literal] = STATE(3512),
    [sym_array_literal] = STATE(3512),
    [sym_function_literal] = STATE(3512),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3512),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3700),
    [sym_false] = ACTIONS(3700),
    [sym_null] = ACTIONS(3700),
    [sym_super] = ACTIONS(3700),
    [sym_this] = ACTIONS(3700),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3702),
    [sym_float_literal] = ACTIONS(3702),
    [sym__string] = ACTIONS(3370),
  },
  [1061] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3535),
    [sym_ternary_expression] = STATE(3535),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3535),
    [sym_binary_expression] = STATE(3535),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1062] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3542),
    [sym_ternary_expression] = STATE(3542),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3542),
    [sym_binary_expression] = STATE(3542),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1063] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3545),
    [sym_ternary_expression] = STATE(3545),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3545),
    [sym_binary_expression] = STATE(3545),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1064] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3617),
    [sym_ternary_expression] = STATE(3617),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3617),
    [sym_binary_expression] = STATE(3617),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1065] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3534),
    [sym_ternary_expression] = STATE(3534),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3534),
    [sym_binary_expression] = STATE(3534),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1066] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3619),
    [sym_ternary_expression] = STATE(3619),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3619),
    [sym_binary_expression] = STATE(3619),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1067] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3537),
    [sym_ternary_expression] = STATE(3537),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3537),
    [sym_binary_expression] = STATE(3537),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1068] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3575),
    [sym_ternary_expression] = STATE(3575),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3575),
    [sym_binary_expression] = STATE(3575),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1069] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3581),
    [sym_ternary_expression] = STATE(3581),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3581),
    [sym_binary_expression] = STATE(3581),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1070] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4578),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4305),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4305),
    [sym_typeof_expression] = STATE(3388),
    [sym__expr] = STATE(3643),
    [sym_ternary_expression] = STATE(3643),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3643),
    [sym_binary_expression] = STATE(3643),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3391),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3389),
    [sym_traits_expression] = STATE(3391),
    [aux_sym_type_repeat1] = STATE(3210),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3776),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(3780),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1071] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4655),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3653),
    [sym_ternary_expression] = STATE(3653),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3653),
    [sym_binary_expression] = STATE(3653),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1072] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3594),
    [sym_ternary_expression] = STATE(3594),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3594),
    [sym_binary_expression] = STATE(3594),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1073] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3600),
    [sym_ternary_expression] = STATE(3600),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3600),
    [sym_binary_expression] = STATE(3600),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1074] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3602),
    [sym_ternary_expression] = STATE(3602),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3602),
    [sym_binary_expression] = STATE(3602),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1075] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3580),
    [sym_ternary_expression] = STATE(3580),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3580),
    [sym_binary_expression] = STATE(3580),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1076] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3574),
    [sym_ternary_expression] = STATE(3574),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3574),
    [sym_binary_expression] = STATE(3574),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1077] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3593),
    [sym_ternary_expression] = STATE(3593),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3593),
    [sym_binary_expression] = STATE(3593),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1078] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3558),
    [sym_ternary_expression] = STATE(3558),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3558),
    [sym_binary_expression] = STATE(3558),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1079] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3595),
    [sym_ternary_expression] = STATE(3595),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3595),
    [sym_binary_expression] = STATE(3595),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1080] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3596),
    [sym_ternary_expression] = STATE(3596),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3596),
    [sym_binary_expression] = STATE(3596),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1081] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3598),
    [sym_ternary_expression] = STATE(3598),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3598),
    [sym_binary_expression] = STATE(3598),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1082] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3608),
    [sym_ternary_expression] = STATE(3608),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3608),
    [sym_binary_expression] = STATE(3608),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1083] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3623),
    [sym_ternary_expression] = STATE(3623),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3623),
    [sym_binary_expression] = STATE(3623),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1084] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3628),
    [sym_ternary_expression] = STATE(3628),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3628),
    [sym_binary_expression] = STATE(3628),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1085] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3539),
    [sym_ternary_expression] = STATE(3539),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3539),
    [sym_binary_expression] = STATE(3539),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1086] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3540),
    [sym_ternary_expression] = STATE(3540),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3540),
    [sym_binary_expression] = STATE(3540),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1087] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3474),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3474),
    [sym_ternary_expression] = STATE(3474),
    [sym_call_expression] = STATE(3474),
    [sym_primary_expression] = STATE(3474),
    [sym__primary_expr] = STATE(3474),
    [sym_index_expression] = STATE(3474),
    [sym_assignment_expression] = STATE(3474),
    [sym_binary_expression] = STATE(3474),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3474),
    [sym_unary_expression] = STATE(3474),
    [sym__unary_expr] = STATE(3474),
    [sym_property_expression] = STATE(3474),
    [sym_cast_expression] = STATE(3474),
    [sym_delete_expression] = STATE(3474),
    [sym_throw_expression] = STATE(3474),
    [sym_assert_expression] = STATE(3474),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3474),
    [sym_new_expression] = STATE(3474),
    [sym_typeid_expression] = STATE(3474),
    [sym_is_expression] = STATE(3474),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3474),
    [sym_char_literal] = STATE(3474),
    [sym_array_literal] = STATE(3474),
    [sym_function_literal] = STATE(3474),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3474),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3782),
    [sym_false] = ACTIONS(3782),
    [sym_null] = ACTIONS(3782),
    [sym_super] = ACTIONS(3782),
    [sym_this] = ACTIONS(3782),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3784),
    [sym_float_literal] = ACTIONS(3784),
    [sym__string] = ACTIONS(3774),
  },
  [1088] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3547),
    [sym_ternary_expression] = STATE(3547),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3547),
    [sym_binary_expression] = STATE(3547),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1089] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3546),
    [sym_ternary_expression] = STATE(3546),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3546),
    [sym_binary_expression] = STATE(3546),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1090] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3544),
    [sym_ternary_expression] = STATE(3544),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3544),
    [sym_binary_expression] = STATE(3544),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1091] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3543),
    [sym_ternary_expression] = STATE(3543),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3543),
    [sym_binary_expression] = STATE(3543),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1092] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3541),
    [sym_ternary_expression] = STATE(3541),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3541),
    [sym_binary_expression] = STATE(3541),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1093] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3514),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3514),
    [sym_ternary_expression] = STATE(3514),
    [sym_call_expression] = STATE(3514),
    [sym_primary_expression] = STATE(3514),
    [sym__primary_expr] = STATE(3514),
    [sym_index_expression] = STATE(3514),
    [sym_assignment_expression] = STATE(3514),
    [sym_binary_expression] = STATE(3514),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3514),
    [sym_unary_expression] = STATE(3514),
    [sym__unary_expr] = STATE(3514),
    [sym_property_expression] = STATE(3514),
    [sym_cast_expression] = STATE(3514),
    [sym_delete_expression] = STATE(3514),
    [sym_throw_expression] = STATE(3514),
    [sym_assert_expression] = STATE(3514),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3514),
    [sym_new_expression] = STATE(3514),
    [sym_typeid_expression] = STATE(3514),
    [sym_is_expression] = STATE(3514),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3514),
    [sym_char_literal] = STATE(3514),
    [sym_array_literal] = STATE(3514),
    [sym_function_literal] = STATE(3514),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3514),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3786),
    [sym_false] = ACTIONS(3786),
    [sym_null] = ACTIONS(3786),
    [sym_super] = ACTIONS(3786),
    [sym_this] = ACTIONS(3786),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3788),
    [sym_float_literal] = ACTIONS(3788),
    [sym__string] = ACTIONS(3370),
  },
  [1094] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3513),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3513),
    [sym_ternary_expression] = STATE(3513),
    [sym_call_expression] = STATE(3513),
    [sym_primary_expression] = STATE(3513),
    [sym__primary_expr] = STATE(3513),
    [sym_index_expression] = STATE(3513),
    [sym_assignment_expression] = STATE(3513),
    [sym_binary_expression] = STATE(3513),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3513),
    [sym_unary_expression] = STATE(3513),
    [sym__unary_expr] = STATE(3513),
    [sym_property_expression] = STATE(3513),
    [sym_cast_expression] = STATE(3513),
    [sym_delete_expression] = STATE(3513),
    [sym_throw_expression] = STATE(3513),
    [sym_assert_expression] = STATE(3513),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3513),
    [sym_new_expression] = STATE(3513),
    [sym_typeid_expression] = STATE(3513),
    [sym_is_expression] = STATE(3513),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3513),
    [sym_char_literal] = STATE(3513),
    [sym_array_literal] = STATE(3513),
    [sym_function_literal] = STATE(3513),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3513),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3790),
    [sym_false] = ACTIONS(3790),
    [sym_null] = ACTIONS(3790),
    [sym_super] = ACTIONS(3790),
    [sym_this] = ACTIONS(3790),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3792),
    [sym_float_literal] = ACTIONS(3792),
    [sym__string] = ACTIONS(3370),
  },
  [1095] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3511),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3511),
    [sym_ternary_expression] = STATE(3511),
    [sym_call_expression] = STATE(3511),
    [sym_primary_expression] = STATE(3511),
    [sym__primary_expr] = STATE(3511),
    [sym_index_expression] = STATE(3511),
    [sym_assignment_expression] = STATE(3511),
    [sym_binary_expression] = STATE(3511),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3511),
    [sym_unary_expression] = STATE(3511),
    [sym__unary_expr] = STATE(3511),
    [sym_property_expression] = STATE(3511),
    [sym_cast_expression] = STATE(3511),
    [sym_delete_expression] = STATE(3511),
    [sym_throw_expression] = STATE(3511),
    [sym_assert_expression] = STATE(3511),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3511),
    [sym_new_expression] = STATE(3511),
    [sym_typeid_expression] = STATE(3511),
    [sym_is_expression] = STATE(3511),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3511),
    [sym_char_literal] = STATE(3511),
    [sym_array_literal] = STATE(3511),
    [sym_function_literal] = STATE(3511),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3511),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3794),
    [sym_false] = ACTIONS(3794),
    [sym_null] = ACTIONS(3794),
    [sym_super] = ACTIONS(3794),
    [sym_this] = ACTIONS(3794),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3796),
    [sym_float_literal] = ACTIONS(3796),
    [sym__string] = ACTIONS(3370),
  },
  [1096] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3506),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3506),
    [sym_ternary_expression] = STATE(3506),
    [sym_call_expression] = STATE(3506),
    [sym_primary_expression] = STATE(3506),
    [sym__primary_expr] = STATE(3506),
    [sym_index_expression] = STATE(3506),
    [sym_assignment_expression] = STATE(3506),
    [sym_binary_expression] = STATE(3506),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3506),
    [sym_unary_expression] = STATE(3506),
    [sym__unary_expr] = STATE(3506),
    [sym_property_expression] = STATE(3506),
    [sym_cast_expression] = STATE(3506),
    [sym_delete_expression] = STATE(3506),
    [sym_throw_expression] = STATE(3506),
    [sym_assert_expression] = STATE(3506),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3506),
    [sym_new_expression] = STATE(3506),
    [sym_typeid_expression] = STATE(3506),
    [sym_is_expression] = STATE(3506),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3506),
    [sym_char_literal] = STATE(3506),
    [sym_array_literal] = STATE(3506),
    [sym_function_literal] = STATE(3506),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3506),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3798),
    [sym_false] = ACTIONS(3798),
    [sym_null] = ACTIONS(3798),
    [sym_super] = ACTIONS(3798),
    [sym_this] = ACTIONS(3798),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3800),
    [sym_float_literal] = ACTIONS(3800),
    [sym__string] = ACTIONS(3370),
  },
  [1097] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3625),
    [sym_ternary_expression] = STATE(3625),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3625),
    [sym_binary_expression] = STATE(3625),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1098] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3502),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3502),
    [sym_ternary_expression] = STATE(3502),
    [sym_call_expression] = STATE(3502),
    [sym_primary_expression] = STATE(3502),
    [sym__primary_expr] = STATE(3502),
    [sym_index_expression] = STATE(3502),
    [sym_assignment_expression] = STATE(3502),
    [sym_binary_expression] = STATE(3502),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3502),
    [sym_unary_expression] = STATE(3502),
    [sym__unary_expr] = STATE(3502),
    [sym_property_expression] = STATE(3502),
    [sym_cast_expression] = STATE(3502),
    [sym_delete_expression] = STATE(3502),
    [sym_throw_expression] = STATE(3502),
    [sym_assert_expression] = STATE(3502),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3502),
    [sym_new_expression] = STATE(3502),
    [sym_typeid_expression] = STATE(3502),
    [sym_is_expression] = STATE(3502),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3502),
    [sym_char_literal] = STATE(3502),
    [sym_array_literal] = STATE(3502),
    [sym_function_literal] = STATE(3502),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3502),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3802),
    [sym_false] = ACTIONS(3802),
    [sym_null] = ACTIONS(3802),
    [sym_super] = ACTIONS(3802),
    [sym_this] = ACTIONS(3802),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3804),
    [sym_float_literal] = ACTIONS(3804),
    [sym__string] = ACTIONS(3370),
  },
  [1099] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3496),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3496),
    [sym_ternary_expression] = STATE(3496),
    [sym_call_expression] = STATE(3496),
    [sym_primary_expression] = STATE(3496),
    [sym__primary_expr] = STATE(3496),
    [sym_index_expression] = STATE(3496),
    [sym_assignment_expression] = STATE(3496),
    [sym_binary_expression] = STATE(3496),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3496),
    [sym_unary_expression] = STATE(3496),
    [sym__unary_expr] = STATE(3496),
    [sym_property_expression] = STATE(3496),
    [sym_cast_expression] = STATE(3496),
    [sym_delete_expression] = STATE(3496),
    [sym_throw_expression] = STATE(3496),
    [sym_assert_expression] = STATE(3496),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3496),
    [sym_new_expression] = STATE(3496),
    [sym_typeid_expression] = STATE(3496),
    [sym_is_expression] = STATE(3496),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3496),
    [sym_char_literal] = STATE(3496),
    [sym_array_literal] = STATE(3496),
    [sym_function_literal] = STATE(3496),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3496),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3806),
    [sym_false] = ACTIONS(3806),
    [sym_null] = ACTIONS(3806),
    [sym_super] = ACTIONS(3806),
    [sym_this] = ACTIONS(3806),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3808),
    [sym_float_literal] = ACTIONS(3808),
    [sym__string] = ACTIONS(3370),
  },
  [1100] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3494),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3494),
    [sym_ternary_expression] = STATE(3494),
    [sym_call_expression] = STATE(3494),
    [sym_primary_expression] = STATE(3494),
    [sym__primary_expr] = STATE(3494),
    [sym_index_expression] = STATE(3494),
    [sym_assignment_expression] = STATE(3494),
    [sym_binary_expression] = STATE(3494),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3494),
    [sym_unary_expression] = STATE(3494),
    [sym__unary_expr] = STATE(3494),
    [sym_property_expression] = STATE(3494),
    [sym_cast_expression] = STATE(3494),
    [sym_delete_expression] = STATE(3494),
    [sym_throw_expression] = STATE(3494),
    [sym_assert_expression] = STATE(3494),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3494),
    [sym_new_expression] = STATE(3494),
    [sym_typeid_expression] = STATE(3494),
    [sym_is_expression] = STATE(3494),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3494),
    [sym_char_literal] = STATE(3494),
    [sym_array_literal] = STATE(3494),
    [sym_function_literal] = STATE(3494),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3494),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3810),
    [sym_false] = ACTIONS(3810),
    [sym_null] = ACTIONS(3810),
    [sym_super] = ACTIONS(3810),
    [sym_this] = ACTIONS(3810),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3812),
    [sym_float_literal] = ACTIONS(3812),
    [sym__string] = ACTIONS(3370),
  },
  [1101] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3493),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3493),
    [sym_ternary_expression] = STATE(3493),
    [sym_call_expression] = STATE(3493),
    [sym_primary_expression] = STATE(3493),
    [sym__primary_expr] = STATE(3493),
    [sym_index_expression] = STATE(3493),
    [sym_assignment_expression] = STATE(3493),
    [sym_binary_expression] = STATE(3493),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3493),
    [sym_unary_expression] = STATE(3493),
    [sym__unary_expr] = STATE(3493),
    [sym_property_expression] = STATE(3493),
    [sym_cast_expression] = STATE(3493),
    [sym_delete_expression] = STATE(3493),
    [sym_throw_expression] = STATE(3493),
    [sym_assert_expression] = STATE(3493),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3493),
    [sym_new_expression] = STATE(3493),
    [sym_typeid_expression] = STATE(3493),
    [sym_is_expression] = STATE(3493),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3493),
    [sym_char_literal] = STATE(3493),
    [sym_array_literal] = STATE(3493),
    [sym_function_literal] = STATE(3493),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3493),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3814),
    [sym_false] = ACTIONS(3814),
    [sym_null] = ACTIONS(3814),
    [sym_super] = ACTIONS(3814),
    [sym_this] = ACTIONS(3814),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3816),
    [sym_float_literal] = ACTIONS(3816),
    [sym__string] = ACTIONS(3370),
  },
  [1102] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3497),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3497),
    [sym_ternary_expression] = STATE(3497),
    [sym_call_expression] = STATE(3497),
    [sym_primary_expression] = STATE(3497),
    [sym__primary_expr] = STATE(3497),
    [sym_index_expression] = STATE(3497),
    [sym_assignment_expression] = STATE(3497),
    [sym_binary_expression] = STATE(3497),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3497),
    [sym_unary_expression] = STATE(3497),
    [sym__unary_expr] = STATE(3497),
    [sym_property_expression] = STATE(3497),
    [sym_cast_expression] = STATE(3497),
    [sym_delete_expression] = STATE(3497),
    [sym_throw_expression] = STATE(3497),
    [sym_assert_expression] = STATE(3497),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3497),
    [sym_new_expression] = STATE(3497),
    [sym_typeid_expression] = STATE(3497),
    [sym_is_expression] = STATE(3497),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3497),
    [sym_char_literal] = STATE(3497),
    [sym_array_literal] = STATE(3497),
    [sym_function_literal] = STATE(3497),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3497),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3818),
    [sym_false] = ACTIONS(3818),
    [sym_null] = ACTIONS(3818),
    [sym_super] = ACTIONS(3818),
    [sym_this] = ACTIONS(3818),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3820),
    [sym_float_literal] = ACTIONS(3820),
    [sym__string] = ACTIONS(3370),
  },
  [1103] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3630),
    [sym_ternary_expression] = STATE(3630),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3630),
    [sym_binary_expression] = STATE(3630),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1104] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3437),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3437),
    [sym_ternary_expression] = STATE(3437),
    [sym_call_expression] = STATE(3437),
    [sym_primary_expression] = STATE(3437),
    [sym__primary_expr] = STATE(3437),
    [sym_index_expression] = STATE(3437),
    [sym_assignment_expression] = STATE(3437),
    [sym_binary_expression] = STATE(3437),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3437),
    [sym_unary_expression] = STATE(3437),
    [sym__unary_expr] = STATE(3437),
    [sym_property_expression] = STATE(3437),
    [sym_cast_expression] = STATE(3437),
    [sym_delete_expression] = STATE(3437),
    [sym_throw_expression] = STATE(3437),
    [sym_assert_expression] = STATE(3437),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3437),
    [sym_new_expression] = STATE(3437),
    [sym_typeid_expression] = STATE(3437),
    [sym_is_expression] = STATE(3437),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3437),
    [sym_char_literal] = STATE(3437),
    [sym_array_literal] = STATE(3437),
    [sym_function_literal] = STATE(3437),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3437),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3822),
    [sym_false] = ACTIONS(3822),
    [sym_null] = ACTIONS(3822),
    [sym_super] = ACTIONS(3822),
    [sym_this] = ACTIONS(3822),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3824),
    [sym_float_literal] = ACTIONS(3824),
    [sym__string] = ACTIONS(3774),
  },
  [1105] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3678),
    [sym_ternary_expression] = STATE(3678),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3678),
    [sym_binary_expression] = STATE(3678),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1106] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3668),
    [sym_ternary_expression] = STATE(3668),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3668),
    [sym_binary_expression] = STATE(3668),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1107] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3634),
    [sym_ternary_expression] = STATE(3634),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3634),
    [sym_binary_expression] = STATE(3634),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1108] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3671),
    [sym_ternary_expression] = STATE(3671),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3671),
    [sym_binary_expression] = STATE(3671),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1109] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3401),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3401),
    [sym_ternary_expression] = STATE(3401),
    [sym_call_expression] = STATE(3401),
    [sym_primary_expression] = STATE(3401),
    [sym__primary_expr] = STATE(3401),
    [sym_index_expression] = STATE(3401),
    [sym_assignment_expression] = STATE(3401),
    [sym_binary_expression] = STATE(3401),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3401),
    [sym_unary_expression] = STATE(3401),
    [sym__unary_expr] = STATE(3401),
    [sym_property_expression] = STATE(3401),
    [sym_cast_expression] = STATE(3401),
    [sym_delete_expression] = STATE(3401),
    [sym_throw_expression] = STATE(3401),
    [sym_assert_expression] = STATE(3401),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3401),
    [sym_new_expression] = STATE(3401),
    [sym_typeid_expression] = STATE(3401),
    [sym_is_expression] = STATE(3401),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3401),
    [sym_char_literal] = STATE(3401),
    [sym_array_literal] = STATE(3401),
    [sym_function_literal] = STATE(3401),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3401),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3826),
    [sym_false] = ACTIONS(3826),
    [sym_null] = ACTIONS(3826),
    [sym_super] = ACTIONS(3826),
    [sym_this] = ACTIONS(3826),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3828),
    [sym_float_literal] = ACTIONS(3828),
    [sym__string] = ACTIONS(3370),
  },
  [1110] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3403),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3403),
    [sym_ternary_expression] = STATE(3403),
    [sym_call_expression] = STATE(3403),
    [sym_primary_expression] = STATE(3403),
    [sym__primary_expr] = STATE(3403),
    [sym_index_expression] = STATE(3403),
    [sym_assignment_expression] = STATE(3403),
    [sym_binary_expression] = STATE(3403),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3403),
    [sym_unary_expression] = STATE(3403),
    [sym__unary_expr] = STATE(3403),
    [sym_property_expression] = STATE(3403),
    [sym_cast_expression] = STATE(3403),
    [sym_delete_expression] = STATE(3403),
    [sym_throw_expression] = STATE(3403),
    [sym_assert_expression] = STATE(3403),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3403),
    [sym_new_expression] = STATE(3403),
    [sym_typeid_expression] = STATE(3403),
    [sym_is_expression] = STATE(3403),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3403),
    [sym_char_literal] = STATE(3403),
    [sym_array_literal] = STATE(3403),
    [sym_function_literal] = STATE(3403),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3403),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3830),
    [sym_false] = ACTIONS(3830),
    [sym_null] = ACTIONS(3830),
    [sym_super] = ACTIONS(3830),
    [sym_this] = ACTIONS(3830),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3832),
    [sym_float_literal] = ACTIONS(3832),
    [sym__string] = ACTIONS(3774),
  },
  [1111] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3679),
    [sym_ternary_expression] = STATE(3679),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3679),
    [sym_binary_expression] = STATE(3679),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1112] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3425),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3425),
    [sym_ternary_expression] = STATE(3425),
    [sym_call_expression] = STATE(3425),
    [sym_primary_expression] = STATE(3425),
    [sym__primary_expr] = STATE(3425),
    [sym_index_expression] = STATE(3425),
    [sym_assignment_expression] = STATE(3425),
    [sym_binary_expression] = STATE(3425),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3425),
    [sym_unary_expression] = STATE(3425),
    [sym__unary_expr] = STATE(3425),
    [sym_property_expression] = STATE(3425),
    [sym_cast_expression] = STATE(3425),
    [sym_delete_expression] = STATE(3425),
    [sym_throw_expression] = STATE(3425),
    [sym_assert_expression] = STATE(3425),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3425),
    [sym_new_expression] = STATE(3425),
    [sym_typeid_expression] = STATE(3425),
    [sym_is_expression] = STATE(3425),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3425),
    [sym_char_literal] = STATE(3425),
    [sym_array_literal] = STATE(3425),
    [sym_function_literal] = STATE(3425),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3425),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3834),
    [sym_false] = ACTIONS(3834),
    [sym_null] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [sym_this] = ACTIONS(3834),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3836),
    [sym_float_literal] = ACTIONS(3836),
    [sym__string] = ACTIONS(3774),
  },
  [1113] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3664),
    [sym_ternary_expression] = STATE(3664),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3664),
    [sym_binary_expression] = STATE(3664),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1114] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3663),
    [sym_ternary_expression] = STATE(3663),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3663),
    [sym_binary_expression] = STATE(3663),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1115] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3681),
    [sym_ternary_expression] = STATE(3681),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3681),
    [sym_binary_expression] = STATE(3681),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1116] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3500),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym__expr] = STATE(3500),
    [sym_ternary_expression] = STATE(3500),
    [sym_call_expression] = STATE(3500),
    [sym_primary_expression] = STATE(3500),
    [sym__primary_expr] = STATE(3500),
    [sym_index_expression] = STATE(3500),
    [sym_assignment_expression] = STATE(3500),
    [sym_binary_expression] = STATE(3500),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3500),
    [sym_unary_expression] = STATE(3500),
    [sym__unary_expr] = STATE(3500),
    [sym_property_expression] = STATE(3500),
    [sym_cast_expression] = STATE(3500),
    [sym_delete_expression] = STATE(3500),
    [sym_throw_expression] = STATE(3500),
    [sym_assert_expression] = STATE(3500),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3500),
    [sym_new_expression] = STATE(3500),
    [sym_typeid_expression] = STATE(3500),
    [sym_is_expression] = STATE(3500),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3500),
    [sym_char_literal] = STATE(3500),
    [sym_array_literal] = STATE(3500),
    [sym_function_literal] = STATE(3500),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3500),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3838),
    [sym_false] = ACTIONS(3838),
    [sym_null] = ACTIONS(3838),
    [sym_super] = ACTIONS(3838),
    [sym_this] = ACTIONS(3838),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3840),
    [sym_float_literal] = ACTIONS(3840),
    [sym__string] = ACTIONS(3370),
  },
  [1117] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3666),
    [sym_ternary_expression] = STATE(3666),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3666),
    [sym_binary_expression] = STATE(3666),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1118] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3657),
    [sym_ternary_expression] = STATE(3657),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3657),
    [sym_binary_expression] = STATE(3657),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1119] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3659),
    [sym_ternary_expression] = STATE(3659),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3659),
    [sym_binary_expression] = STATE(3659),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1120] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3670),
    [sym_ternary_expression] = STATE(3670),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3670),
    [sym_binary_expression] = STATE(3670),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1121] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3393),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3393),
    [sym_ternary_expression] = STATE(3393),
    [sym_call_expression] = STATE(3393),
    [sym_primary_expression] = STATE(3393),
    [sym__primary_expr] = STATE(3393),
    [sym_index_expression] = STATE(3393),
    [sym_assignment_expression] = STATE(3393),
    [sym_binary_expression] = STATE(3393),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3393),
    [sym_unary_expression] = STATE(3393),
    [sym__unary_expr] = STATE(3393),
    [sym_property_expression] = STATE(3393),
    [sym_cast_expression] = STATE(3393),
    [sym_delete_expression] = STATE(3393),
    [sym_throw_expression] = STATE(3393),
    [sym_assert_expression] = STATE(3393),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3393),
    [sym_new_expression] = STATE(3393),
    [sym_typeid_expression] = STATE(3393),
    [sym_is_expression] = STATE(3393),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3393),
    [sym_char_literal] = STATE(3393),
    [sym_array_literal] = STATE(3393),
    [sym_function_literal] = STATE(3393),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3393),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3842),
    [sym_false] = ACTIONS(3842),
    [sym_null] = ACTIONS(3842),
    [sym_super] = ACTIONS(3842),
    [sym_this] = ACTIONS(3842),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3844),
    [sym_float_literal] = ACTIONS(3844),
    [sym__string] = ACTIONS(3774),
  },
  [1122] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3672),
    [sym_ternary_expression] = STATE(3672),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3672),
    [sym_binary_expression] = STATE(3672),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1123] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3461),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3461),
    [sym_ternary_expression] = STATE(3461),
    [sym_call_expression] = STATE(3461),
    [sym_primary_expression] = STATE(3461),
    [sym__primary_expr] = STATE(3461),
    [sym_index_expression] = STATE(3461),
    [sym_assignment_expression] = STATE(3461),
    [sym_binary_expression] = STATE(3461),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3461),
    [sym_unary_expression] = STATE(3461),
    [sym__unary_expr] = STATE(3461),
    [sym_property_expression] = STATE(3461),
    [sym_cast_expression] = STATE(3461),
    [sym_delete_expression] = STATE(3461),
    [sym_throw_expression] = STATE(3461),
    [sym_assert_expression] = STATE(3461),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3461),
    [sym_new_expression] = STATE(3461),
    [sym_typeid_expression] = STATE(3461),
    [sym_is_expression] = STATE(3461),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3461),
    [sym_char_literal] = STATE(3461),
    [sym_array_literal] = STATE(3461),
    [sym_function_literal] = STATE(3461),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3461),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3846),
    [sym_false] = ACTIONS(3846),
    [sym_null] = ACTIONS(3846),
    [sym_super] = ACTIONS(3846),
    [sym_this] = ACTIONS(3846),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3848),
    [sym_float_literal] = ACTIONS(3848),
    [sym__string] = ACTIONS(3774),
  },
  [1124] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3473),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3473),
    [sym_ternary_expression] = STATE(3473),
    [sym_call_expression] = STATE(3473),
    [sym_primary_expression] = STATE(3473),
    [sym__primary_expr] = STATE(3473),
    [sym_index_expression] = STATE(3473),
    [sym_assignment_expression] = STATE(3473),
    [sym_binary_expression] = STATE(3473),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3473),
    [sym_unary_expression] = STATE(3473),
    [sym__unary_expr] = STATE(3473),
    [sym_property_expression] = STATE(3473),
    [sym_cast_expression] = STATE(3473),
    [sym_delete_expression] = STATE(3473),
    [sym_throw_expression] = STATE(3473),
    [sym_assert_expression] = STATE(3473),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3473),
    [sym_new_expression] = STATE(3473),
    [sym_typeid_expression] = STATE(3473),
    [sym_is_expression] = STATE(3473),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3473),
    [sym_char_literal] = STATE(3473),
    [sym_array_literal] = STATE(3473),
    [sym_function_literal] = STATE(3473),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3473),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3850),
    [sym_false] = ACTIONS(3850),
    [sym_null] = ACTIONS(3850),
    [sym_super] = ACTIONS(3850),
    [sym_this] = ACTIONS(3850),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3852),
    [sym_float_literal] = ACTIONS(3852),
    [sym__string] = ACTIONS(3774),
  },
  [1125] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3479),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3479),
    [sym_ternary_expression] = STATE(3479),
    [sym_call_expression] = STATE(3479),
    [sym_primary_expression] = STATE(3479),
    [sym__primary_expr] = STATE(3479),
    [sym_index_expression] = STATE(3479),
    [sym_assignment_expression] = STATE(3479),
    [sym_binary_expression] = STATE(3479),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3479),
    [sym_unary_expression] = STATE(3479),
    [sym__unary_expr] = STATE(3479),
    [sym_property_expression] = STATE(3479),
    [sym_cast_expression] = STATE(3479),
    [sym_delete_expression] = STATE(3479),
    [sym_throw_expression] = STATE(3479),
    [sym_assert_expression] = STATE(3479),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3479),
    [sym_new_expression] = STATE(3479),
    [sym_typeid_expression] = STATE(3479),
    [sym_is_expression] = STATE(3479),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3479),
    [sym_char_literal] = STATE(3479),
    [sym_array_literal] = STATE(3479),
    [sym_function_literal] = STATE(3479),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3479),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3854),
    [sym_false] = ACTIONS(3854),
    [sym_null] = ACTIONS(3854),
    [sym_super] = ACTIONS(3854),
    [sym_this] = ACTIONS(3854),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3856),
    [sym_float_literal] = ACTIONS(3856),
    [sym__string] = ACTIONS(3774),
  },
  [1126] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3441),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3441),
    [sym_ternary_expression] = STATE(3441),
    [sym_call_expression] = STATE(3441),
    [sym_primary_expression] = STATE(3441),
    [sym__primary_expr] = STATE(3441),
    [sym_index_expression] = STATE(3441),
    [sym_assignment_expression] = STATE(3441),
    [sym_binary_expression] = STATE(3441),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3441),
    [sym_unary_expression] = STATE(3441),
    [sym__unary_expr] = STATE(3441),
    [sym_property_expression] = STATE(3441),
    [sym_cast_expression] = STATE(3441),
    [sym_delete_expression] = STATE(3441),
    [sym_throw_expression] = STATE(3441),
    [sym_assert_expression] = STATE(3441),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3441),
    [sym_new_expression] = STATE(3441),
    [sym_typeid_expression] = STATE(3441),
    [sym_is_expression] = STATE(3441),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3441),
    [sym_char_literal] = STATE(3441),
    [sym_array_literal] = STATE(3441),
    [sym_function_literal] = STATE(3441),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3441),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3858),
    [sym_false] = ACTIONS(3858),
    [sym_null] = ACTIONS(3858),
    [sym_super] = ACTIONS(3858),
    [sym_this] = ACTIONS(3858),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3860),
    [sym_float_literal] = ACTIONS(3860),
    [sym__string] = ACTIONS(3774),
  },
  [1127] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3680),
    [sym_ternary_expression] = STATE(3680),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3680),
    [sym_binary_expression] = STATE(3680),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1128] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3416),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3416),
    [sym_ternary_expression] = STATE(3416),
    [sym_call_expression] = STATE(3416),
    [sym_primary_expression] = STATE(3416),
    [sym__primary_expr] = STATE(3416),
    [sym_index_expression] = STATE(3416),
    [sym_assignment_expression] = STATE(3416),
    [sym_binary_expression] = STATE(3416),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3416),
    [sym_unary_expression] = STATE(3416),
    [sym__unary_expr] = STATE(3416),
    [sym_property_expression] = STATE(3416),
    [sym_cast_expression] = STATE(3416),
    [sym_delete_expression] = STATE(3416),
    [sym_throw_expression] = STATE(3416),
    [sym_assert_expression] = STATE(3416),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3416),
    [sym_new_expression] = STATE(3416),
    [sym_typeid_expression] = STATE(3416),
    [sym_is_expression] = STATE(3416),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3416),
    [sym_char_literal] = STATE(3416),
    [sym_array_literal] = STATE(3416),
    [sym_function_literal] = STATE(3416),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3416),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3862),
    [sym_false] = ACTIONS(3862),
    [sym_null] = ACTIONS(3862),
    [sym_super] = ACTIONS(3862),
    [sym_this] = ACTIONS(3862),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3864),
    [sym_float_literal] = ACTIONS(3864),
    [sym__string] = ACTIONS(3774),
  },
  [1129] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3562),
    [sym_ternary_expression] = STATE(3562),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3562),
    [sym_binary_expression] = STATE(3562),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1130] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3432),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3432),
    [sym_ternary_expression] = STATE(3432),
    [sym_call_expression] = STATE(3432),
    [sym_primary_expression] = STATE(3432),
    [sym__primary_expr] = STATE(3432),
    [sym_index_expression] = STATE(3432),
    [sym_assignment_expression] = STATE(3432),
    [sym_binary_expression] = STATE(3432),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3432),
    [sym_unary_expression] = STATE(3432),
    [sym__unary_expr] = STATE(3432),
    [sym_property_expression] = STATE(3432),
    [sym_cast_expression] = STATE(3432),
    [sym_delete_expression] = STATE(3432),
    [sym_throw_expression] = STATE(3432),
    [sym_assert_expression] = STATE(3432),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3432),
    [sym_new_expression] = STATE(3432),
    [sym_typeid_expression] = STATE(3432),
    [sym_is_expression] = STATE(3432),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3432),
    [sym_char_literal] = STATE(3432),
    [sym_array_literal] = STATE(3432),
    [sym_function_literal] = STATE(3432),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3432),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3866),
    [sym_false] = ACTIONS(3866),
    [sym_null] = ACTIONS(3866),
    [sym_super] = ACTIONS(3866),
    [sym_this] = ACTIONS(3866),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3868),
    [sym_float_literal] = ACTIONS(3868),
    [sym__string] = ACTIONS(3774),
  },
  [1131] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3476),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3476),
    [sym_ternary_expression] = STATE(3476),
    [sym_call_expression] = STATE(3476),
    [sym_primary_expression] = STATE(3476),
    [sym__primary_expr] = STATE(3476),
    [sym_index_expression] = STATE(3476),
    [sym_assignment_expression] = STATE(3476),
    [sym_binary_expression] = STATE(3476),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3476),
    [sym_unary_expression] = STATE(3476),
    [sym__unary_expr] = STATE(3476),
    [sym_property_expression] = STATE(3476),
    [sym_cast_expression] = STATE(3476),
    [sym_delete_expression] = STATE(3476),
    [sym_throw_expression] = STATE(3476),
    [sym_assert_expression] = STATE(3476),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3476),
    [sym_new_expression] = STATE(3476),
    [sym_typeid_expression] = STATE(3476),
    [sym_is_expression] = STATE(3476),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3476),
    [sym_char_literal] = STATE(3476),
    [sym_array_literal] = STATE(3476),
    [sym_function_literal] = STATE(3476),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3476),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3870),
    [sym_false] = ACTIONS(3870),
    [sym_null] = ACTIONS(3870),
    [sym_super] = ACTIONS(3870),
    [sym_this] = ACTIONS(3870),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3872),
    [sym_float_literal] = ACTIONS(3872),
    [sym__string] = ACTIONS(3774),
  },
  [1132] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3673),
    [sym_ternary_expression] = STATE(3673),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3673),
    [sym_binary_expression] = STATE(3673),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1133] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3667),
    [sym_ternary_expression] = STATE(3667),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3667),
    [sym_binary_expression] = STATE(3667),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1134] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3396),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3396),
    [sym_ternary_expression] = STATE(3396),
    [sym_call_expression] = STATE(3396),
    [sym_primary_expression] = STATE(3396),
    [sym__primary_expr] = STATE(3396),
    [sym_index_expression] = STATE(3396),
    [sym_assignment_expression] = STATE(3396),
    [sym_binary_expression] = STATE(3396),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3396),
    [sym_unary_expression] = STATE(3396),
    [sym__unary_expr] = STATE(3396),
    [sym_property_expression] = STATE(3396),
    [sym_cast_expression] = STATE(3396),
    [sym_delete_expression] = STATE(3396),
    [sym_throw_expression] = STATE(3396),
    [sym_assert_expression] = STATE(3396),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3396),
    [sym_new_expression] = STATE(3396),
    [sym_typeid_expression] = STATE(3396),
    [sym_is_expression] = STATE(3396),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3396),
    [sym_char_literal] = STATE(3396),
    [sym_array_literal] = STATE(3396),
    [sym_function_literal] = STATE(3396),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3396),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3874),
    [sym_false] = ACTIONS(3874),
    [sym_null] = ACTIONS(3874),
    [sym_super] = ACTIONS(3874),
    [sym_this] = ACTIONS(3874),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3876),
    [sym_float_literal] = ACTIONS(3876),
    [sym__string] = ACTIONS(3774),
  },
  [1135] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3399),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3399),
    [sym_ternary_expression] = STATE(3399),
    [sym_call_expression] = STATE(3399),
    [sym_primary_expression] = STATE(3399),
    [sym__primary_expr] = STATE(3399),
    [sym_index_expression] = STATE(3399),
    [sym_assignment_expression] = STATE(3399),
    [sym_binary_expression] = STATE(3399),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3399),
    [sym_unary_expression] = STATE(3399),
    [sym__unary_expr] = STATE(3399),
    [sym_property_expression] = STATE(3399),
    [sym_cast_expression] = STATE(3399),
    [sym_delete_expression] = STATE(3399),
    [sym_throw_expression] = STATE(3399),
    [sym_assert_expression] = STATE(3399),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3399),
    [sym_new_expression] = STATE(3399),
    [sym_typeid_expression] = STATE(3399),
    [sym_is_expression] = STATE(3399),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3399),
    [sym_char_literal] = STATE(3399),
    [sym_array_literal] = STATE(3399),
    [sym_function_literal] = STATE(3399),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3399),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3878),
    [sym_false] = ACTIONS(3878),
    [sym_null] = ACTIONS(3878),
    [sym_super] = ACTIONS(3878),
    [sym_this] = ACTIONS(3878),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3880),
    [sym_float_literal] = ACTIONS(3880),
    [sym__string] = ACTIONS(3774),
  },
  [1136] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3409),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3409),
    [sym_ternary_expression] = STATE(3409),
    [sym_call_expression] = STATE(3409),
    [sym_primary_expression] = STATE(3409),
    [sym__primary_expr] = STATE(3409),
    [sym_index_expression] = STATE(3409),
    [sym_assignment_expression] = STATE(3409),
    [sym_binary_expression] = STATE(3409),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3409),
    [sym_unary_expression] = STATE(3409),
    [sym__unary_expr] = STATE(3409),
    [sym_property_expression] = STATE(3409),
    [sym_cast_expression] = STATE(3409),
    [sym_delete_expression] = STATE(3409),
    [sym_throw_expression] = STATE(3409),
    [sym_assert_expression] = STATE(3409),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3409),
    [sym_new_expression] = STATE(3409),
    [sym_typeid_expression] = STATE(3409),
    [sym_is_expression] = STATE(3409),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3409),
    [sym_char_literal] = STATE(3409),
    [sym_array_literal] = STATE(3409),
    [sym_function_literal] = STATE(3409),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3409),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3882),
    [sym_false] = ACTIONS(3882),
    [sym_null] = ACTIONS(3882),
    [sym_super] = ACTIONS(3882),
    [sym_this] = ACTIONS(3882),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3884),
    [sym_float_literal] = ACTIONS(3884),
    [sym__string] = ACTIONS(3370),
  },
  [1137] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3548),
    [sym_ternary_expression] = STATE(3548),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3548),
    [sym_binary_expression] = STATE(3548),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1138] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3291),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3291),
    [sym_ternary_expression] = STATE(3291),
    [sym_call_expression] = STATE(3291),
    [sym_primary_expression] = STATE(3291),
    [sym__primary_expr] = STATE(3291),
    [sym_index_expression] = STATE(3291),
    [sym_assignment_expression] = STATE(3291),
    [sym_binary_expression] = STATE(3291),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3291),
    [sym_unary_expression] = STATE(3291),
    [sym__unary_expr] = STATE(3291),
    [sym_property_expression] = STATE(3291),
    [sym_cast_expression] = STATE(3291),
    [sym_delete_expression] = STATE(3291),
    [sym_throw_expression] = STATE(3291),
    [sym_assert_expression] = STATE(3291),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3291),
    [sym_new_expression] = STATE(3291),
    [sym_typeid_expression] = STATE(3291),
    [sym_is_expression] = STATE(3291),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3291),
    [sym_char_literal] = STATE(3291),
    [sym_array_literal] = STATE(3291),
    [sym_function_literal] = STATE(3291),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3291),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3886),
    [sym_false] = ACTIONS(3886),
    [sym_null] = ACTIONS(3886),
    [sym_super] = ACTIONS(3886),
    [sym_this] = ACTIONS(3886),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3888),
    [sym_float_literal] = ACTIONS(3888),
    [sym__string] = ACTIONS(233),
  },
  [1139] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3429),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3429),
    [sym_ternary_expression] = STATE(3429),
    [sym_call_expression] = STATE(3429),
    [sym_primary_expression] = STATE(3429),
    [sym__primary_expr] = STATE(3429),
    [sym_index_expression] = STATE(3429),
    [sym_assignment_expression] = STATE(3429),
    [sym_binary_expression] = STATE(3429),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3429),
    [sym_unary_expression] = STATE(3429),
    [sym__unary_expr] = STATE(3429),
    [sym_property_expression] = STATE(3429),
    [sym_cast_expression] = STATE(3429),
    [sym_delete_expression] = STATE(3429),
    [sym_throw_expression] = STATE(3429),
    [sym_assert_expression] = STATE(3429),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3429),
    [sym_new_expression] = STATE(3429),
    [sym_typeid_expression] = STATE(3429),
    [sym_is_expression] = STATE(3429),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3429),
    [sym_char_literal] = STATE(3429),
    [sym_array_literal] = STATE(3429),
    [sym_function_literal] = STATE(3429),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3429),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3890),
    [sym_false] = ACTIONS(3890),
    [sym_null] = ACTIONS(3890),
    [sym_super] = ACTIONS(3890),
    [sym_this] = ACTIONS(3890),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3892),
    [sym_float_literal] = ACTIONS(3892),
    [sym__string] = ACTIONS(3370),
  },
  [1140] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3661),
    [sym_ternary_expression] = STATE(3661),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3661),
    [sym_binary_expression] = STATE(3661),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1141] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3612),
    [sym_ternary_expression] = STATE(3612),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3612),
    [sym_binary_expression] = STATE(3612),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1142] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3669),
    [sym_ternary_expression] = STATE(3669),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3669),
    [sym_binary_expression] = STATE(3669),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1143] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3320),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3320),
    [sym_ternary_expression] = STATE(3320),
    [sym_call_expression] = STATE(3320),
    [sym_primary_expression] = STATE(3320),
    [sym__primary_expr] = STATE(3320),
    [sym_index_expression] = STATE(3320),
    [sym_assignment_expression] = STATE(3320),
    [sym_binary_expression] = STATE(3320),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3320),
    [sym_unary_expression] = STATE(3320),
    [sym__unary_expr] = STATE(3320),
    [sym_property_expression] = STATE(3320),
    [sym_cast_expression] = STATE(3320),
    [sym_delete_expression] = STATE(3320),
    [sym_throw_expression] = STATE(3320),
    [sym_assert_expression] = STATE(3320),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3320),
    [sym_new_expression] = STATE(3320),
    [sym_typeid_expression] = STATE(3320),
    [sym_is_expression] = STATE(3320),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3320),
    [sym_char_literal] = STATE(3320),
    [sym_array_literal] = STATE(3320),
    [sym_function_literal] = STATE(3320),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3320),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3894),
    [sym_false] = ACTIONS(3894),
    [sym_null] = ACTIONS(3894),
    [sym_super] = ACTIONS(3894),
    [sym_this] = ACTIONS(3894),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3896),
    [sym_float_literal] = ACTIONS(3896),
    [sym__string] = ACTIONS(233),
  },
  [1144] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3654),
    [sym_ternary_expression] = STATE(3654),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3654),
    [sym_binary_expression] = STATE(3654),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1145] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3536),
    [sym_ternary_expression] = STATE(3536),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3536),
    [sym_binary_expression] = STATE(3536),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1146] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3445),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3445),
    [sym_ternary_expression] = STATE(3445),
    [sym_call_expression] = STATE(3445),
    [sym_primary_expression] = STATE(3445),
    [sym__primary_expr] = STATE(3445),
    [sym_index_expression] = STATE(3445),
    [sym_assignment_expression] = STATE(3445),
    [sym_binary_expression] = STATE(3445),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3445),
    [sym_unary_expression] = STATE(3445),
    [sym__unary_expr] = STATE(3445),
    [sym_property_expression] = STATE(3445),
    [sym_cast_expression] = STATE(3445),
    [sym_delete_expression] = STATE(3445),
    [sym_throw_expression] = STATE(3445),
    [sym_assert_expression] = STATE(3445),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3445),
    [sym_new_expression] = STATE(3445),
    [sym_typeid_expression] = STATE(3445),
    [sym_is_expression] = STATE(3445),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3445),
    [sym_char_literal] = STATE(3445),
    [sym_array_literal] = STATE(3445),
    [sym_function_literal] = STATE(3445),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3445),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3898),
    [sym_false] = ACTIONS(3898),
    [sym_null] = ACTIONS(3898),
    [sym_super] = ACTIONS(3898),
    [sym_this] = ACTIONS(3898),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3900),
    [sym_float_literal] = ACTIONS(3900),
    [sym__string] = ACTIONS(3774),
  },
  [1147] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3588),
    [sym_ternary_expression] = STATE(3588),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3588),
    [sym_binary_expression] = STATE(3588),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1148] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3522),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3522),
    [sym_ternary_expression] = STATE(3522),
    [sym_call_expression] = STATE(3522),
    [sym_primary_expression] = STATE(3522),
    [sym__primary_expr] = STATE(3522),
    [sym_index_expression] = STATE(3522),
    [sym_assignment_expression] = STATE(3522),
    [sym_binary_expression] = STATE(3522),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3522),
    [sym_unary_expression] = STATE(3522),
    [sym__unary_expr] = STATE(3522),
    [sym_property_expression] = STATE(3522),
    [sym_cast_expression] = STATE(3522),
    [sym_delete_expression] = STATE(3522),
    [sym_throw_expression] = STATE(3522),
    [sym_assert_expression] = STATE(3522),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3522),
    [sym_new_expression] = STATE(3522),
    [sym_typeid_expression] = STATE(3522),
    [sym_is_expression] = STATE(3522),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3522),
    [sym_char_literal] = STATE(3522),
    [sym_array_literal] = STATE(3522),
    [sym_function_literal] = STATE(3522),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3522),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3902),
    [sym_false] = ACTIONS(3902),
    [sym_null] = ACTIONS(3902),
    [sym_super] = ACTIONS(3902),
    [sym_this] = ACTIONS(3902),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3904),
    [sym_float_literal] = ACTIONS(3904),
    [sym__string] = ACTIONS(233),
  },
  [1149] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3517),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3517),
    [sym_ternary_expression] = STATE(3517),
    [sym_call_expression] = STATE(3517),
    [sym_primary_expression] = STATE(3517),
    [sym__primary_expr] = STATE(3517),
    [sym_index_expression] = STATE(3517),
    [sym_assignment_expression] = STATE(3517),
    [sym_binary_expression] = STATE(3517),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3517),
    [sym_unary_expression] = STATE(3517),
    [sym__unary_expr] = STATE(3517),
    [sym_property_expression] = STATE(3517),
    [sym_cast_expression] = STATE(3517),
    [sym_delete_expression] = STATE(3517),
    [sym_throw_expression] = STATE(3517),
    [sym_assert_expression] = STATE(3517),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3517),
    [sym_new_expression] = STATE(3517),
    [sym_typeid_expression] = STATE(3517),
    [sym_is_expression] = STATE(3517),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3517),
    [sym_char_literal] = STATE(3517),
    [sym_array_literal] = STATE(3517),
    [sym_function_literal] = STATE(3517),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3517),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3906),
    [sym_false] = ACTIONS(3906),
    [sym_null] = ACTIONS(3906),
    [sym_super] = ACTIONS(3906),
    [sym_this] = ACTIONS(3906),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3908),
    [sym_float_literal] = ACTIONS(3908),
    [sym__string] = ACTIONS(233),
  },
  [1150] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3626),
    [sym_ternary_expression] = STATE(3626),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3626),
    [sym_binary_expression] = STATE(3626),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1151] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3475),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3475),
    [sym_ternary_expression] = STATE(3475),
    [sym_call_expression] = STATE(3475),
    [sym_primary_expression] = STATE(3475),
    [sym__primary_expr] = STATE(3475),
    [sym_index_expression] = STATE(3475),
    [sym_assignment_expression] = STATE(3475),
    [sym_binary_expression] = STATE(3475),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3475),
    [sym_unary_expression] = STATE(3475),
    [sym__unary_expr] = STATE(3475),
    [sym_property_expression] = STATE(3475),
    [sym_cast_expression] = STATE(3475),
    [sym_delete_expression] = STATE(3475),
    [sym_throw_expression] = STATE(3475),
    [sym_assert_expression] = STATE(3475),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3475),
    [sym_new_expression] = STATE(3475),
    [sym_typeid_expression] = STATE(3475),
    [sym_is_expression] = STATE(3475),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3475),
    [sym_char_literal] = STATE(3475),
    [sym_array_literal] = STATE(3475),
    [sym_function_literal] = STATE(3475),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3475),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3910),
    [sym_false] = ACTIONS(3910),
    [sym_null] = ACTIONS(3910),
    [sym_super] = ACTIONS(3910),
    [sym_this] = ACTIONS(3910),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3912),
    [sym_float_literal] = ACTIONS(3912),
    [sym__string] = ACTIONS(233),
  },
  [1152] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3524),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3524),
    [sym_ternary_expression] = STATE(3524),
    [sym_call_expression] = STATE(3524),
    [sym_primary_expression] = STATE(3524),
    [sym__primary_expr] = STATE(3524),
    [sym_index_expression] = STATE(3524),
    [sym_assignment_expression] = STATE(3524),
    [sym_binary_expression] = STATE(3524),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3524),
    [sym_unary_expression] = STATE(3524),
    [sym__unary_expr] = STATE(3524),
    [sym_property_expression] = STATE(3524),
    [sym_cast_expression] = STATE(3524),
    [sym_delete_expression] = STATE(3524),
    [sym_throw_expression] = STATE(3524),
    [sym_assert_expression] = STATE(3524),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3524),
    [sym_new_expression] = STATE(3524),
    [sym_typeid_expression] = STATE(3524),
    [sym_is_expression] = STATE(3524),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3524),
    [sym_char_literal] = STATE(3524),
    [sym_array_literal] = STATE(3524),
    [sym_function_literal] = STATE(3524),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3524),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3914),
    [sym_false] = ACTIONS(3914),
    [sym_null] = ACTIONS(3914),
    [sym_super] = ACTIONS(3914),
    [sym_this] = ACTIONS(3914),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3916),
    [sym_float_literal] = ACTIONS(3916),
    [sym__string] = ACTIONS(233),
  },
  [1153] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3531),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3531),
    [sym_ternary_expression] = STATE(3531),
    [sym_call_expression] = STATE(3531),
    [sym_primary_expression] = STATE(3531),
    [sym__primary_expr] = STATE(3531),
    [sym_index_expression] = STATE(3531),
    [sym_assignment_expression] = STATE(3531),
    [sym_binary_expression] = STATE(3531),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3531),
    [sym_unary_expression] = STATE(3531),
    [sym__unary_expr] = STATE(3531),
    [sym_property_expression] = STATE(3531),
    [sym_cast_expression] = STATE(3531),
    [sym_delete_expression] = STATE(3531),
    [sym_throw_expression] = STATE(3531),
    [sym_assert_expression] = STATE(3531),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3531),
    [sym_new_expression] = STATE(3531),
    [sym_typeid_expression] = STATE(3531),
    [sym_is_expression] = STATE(3531),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3531),
    [sym_char_literal] = STATE(3531),
    [sym_array_literal] = STATE(3531),
    [sym_function_literal] = STATE(3531),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3531),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3918),
    [sym_false] = ACTIONS(3918),
    [sym_null] = ACTIONS(3918),
    [sym_super] = ACTIONS(3918),
    [sym_this] = ACTIONS(3918),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3920),
    [sym_float_literal] = ACTIONS(3920),
    [sym__string] = ACTIONS(233),
  },
  [1154] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3292),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3292),
    [sym_ternary_expression] = STATE(3292),
    [sym_call_expression] = STATE(3292),
    [sym_primary_expression] = STATE(3292),
    [sym__primary_expr] = STATE(3292),
    [sym_index_expression] = STATE(3292),
    [sym_assignment_expression] = STATE(3292),
    [sym_binary_expression] = STATE(3292),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3292),
    [sym_unary_expression] = STATE(3292),
    [sym__unary_expr] = STATE(3292),
    [sym_property_expression] = STATE(3292),
    [sym_cast_expression] = STATE(3292),
    [sym_delete_expression] = STATE(3292),
    [sym_throw_expression] = STATE(3292),
    [sym_assert_expression] = STATE(3292),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3292),
    [sym_new_expression] = STATE(3292),
    [sym_typeid_expression] = STATE(3292),
    [sym_is_expression] = STATE(3292),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3292),
    [sym_char_literal] = STATE(3292),
    [sym_array_literal] = STATE(3292),
    [sym_function_literal] = STATE(3292),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3292),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3922),
    [sym_false] = ACTIONS(3922),
    [sym_null] = ACTIONS(3922),
    [sym_super] = ACTIONS(3922),
    [sym_this] = ACTIONS(3922),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3924),
    [sym_float_literal] = ACTIONS(3924),
    [sym__string] = ACTIONS(233),
  },
  [1155] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3419),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3419),
    [sym_ternary_expression] = STATE(3419),
    [sym_call_expression] = STATE(3419),
    [sym_primary_expression] = STATE(3419),
    [sym__primary_expr] = STATE(3419),
    [sym_index_expression] = STATE(3419),
    [sym_assignment_expression] = STATE(3419),
    [sym_binary_expression] = STATE(3419),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3419),
    [sym_unary_expression] = STATE(3419),
    [sym__unary_expr] = STATE(3419),
    [sym_property_expression] = STATE(3419),
    [sym_cast_expression] = STATE(3419),
    [sym_delete_expression] = STATE(3419),
    [sym_throw_expression] = STATE(3419),
    [sym_assert_expression] = STATE(3419),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3419),
    [sym_new_expression] = STATE(3419),
    [sym_typeid_expression] = STATE(3419),
    [sym_is_expression] = STATE(3419),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3419),
    [sym_char_literal] = STATE(3419),
    [sym_array_literal] = STATE(3419),
    [sym_function_literal] = STATE(3419),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3419),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3926),
    [sym_false] = ACTIONS(3926),
    [sym_null] = ACTIONS(3926),
    [sym_super] = ACTIONS(3926),
    [sym_this] = ACTIONS(3926),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3928),
    [sym_float_literal] = ACTIONS(3928),
    [sym__string] = ACTIONS(233),
  },
  [1156] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3290),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3290),
    [sym_ternary_expression] = STATE(3290),
    [sym_call_expression] = STATE(3290),
    [sym_primary_expression] = STATE(3290),
    [sym__primary_expr] = STATE(3290),
    [sym_index_expression] = STATE(3290),
    [sym_assignment_expression] = STATE(3290),
    [sym_binary_expression] = STATE(3290),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3290),
    [sym_unary_expression] = STATE(3290),
    [sym__unary_expr] = STATE(3290),
    [sym_property_expression] = STATE(3290),
    [sym_cast_expression] = STATE(3290),
    [sym_delete_expression] = STATE(3290),
    [sym_throw_expression] = STATE(3290),
    [sym_assert_expression] = STATE(3290),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3290),
    [sym_new_expression] = STATE(3290),
    [sym_typeid_expression] = STATE(3290),
    [sym_is_expression] = STATE(3290),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3290),
    [sym_char_literal] = STATE(3290),
    [sym_array_literal] = STATE(3290),
    [sym_function_literal] = STATE(3290),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3290),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3930),
    [sym_false] = ACTIONS(3930),
    [sym_null] = ACTIONS(3930),
    [sym_super] = ACTIONS(3930),
    [sym_this] = ACTIONS(3930),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3932),
    [sym_float_literal] = ACTIONS(3932),
    [sym__string] = ACTIONS(233),
  },
  [1157] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3481),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3481),
    [sym_ternary_expression] = STATE(3481),
    [sym_call_expression] = STATE(3481),
    [sym_primary_expression] = STATE(3481),
    [sym__primary_expr] = STATE(3481),
    [sym_index_expression] = STATE(3481),
    [sym_assignment_expression] = STATE(3481),
    [sym_binary_expression] = STATE(3481),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3481),
    [sym_unary_expression] = STATE(3481),
    [sym__unary_expr] = STATE(3481),
    [sym_property_expression] = STATE(3481),
    [sym_cast_expression] = STATE(3481),
    [sym_delete_expression] = STATE(3481),
    [sym_throw_expression] = STATE(3481),
    [sym_assert_expression] = STATE(3481),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3481),
    [sym_new_expression] = STATE(3481),
    [sym_typeid_expression] = STATE(3481),
    [sym_is_expression] = STATE(3481),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3481),
    [sym_char_literal] = STATE(3481),
    [sym_array_literal] = STATE(3481),
    [sym_function_literal] = STATE(3481),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3481),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_null] = ACTIONS(3934),
    [sym_super] = ACTIONS(3934),
    [sym_this] = ACTIONS(3934),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3936),
    [sym_float_literal] = ACTIONS(3936),
    [sym__string] = ACTIONS(233),
  },
  [1158] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3478),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3478),
    [sym_ternary_expression] = STATE(3478),
    [sym_call_expression] = STATE(3478),
    [sym_primary_expression] = STATE(3478),
    [sym__primary_expr] = STATE(3478),
    [sym_index_expression] = STATE(3478),
    [sym_assignment_expression] = STATE(3478),
    [sym_binary_expression] = STATE(3478),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3478),
    [sym_unary_expression] = STATE(3478),
    [sym__unary_expr] = STATE(3478),
    [sym_property_expression] = STATE(3478),
    [sym_cast_expression] = STATE(3478),
    [sym_delete_expression] = STATE(3478),
    [sym_throw_expression] = STATE(3478),
    [sym_assert_expression] = STATE(3478),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3478),
    [sym_new_expression] = STATE(3478),
    [sym_typeid_expression] = STATE(3478),
    [sym_is_expression] = STATE(3478),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3478),
    [sym_char_literal] = STATE(3478),
    [sym_array_literal] = STATE(3478),
    [sym_function_literal] = STATE(3478),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3478),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3938),
    [sym_false] = ACTIONS(3938),
    [sym_null] = ACTIONS(3938),
    [sym_super] = ACTIONS(3938),
    [sym_this] = ACTIONS(3938),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3940),
    [sym_float_literal] = ACTIONS(3940),
    [sym__string] = ACTIONS(233),
  },
  [1159] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3550),
    [sym_ternary_expression] = STATE(3550),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3550),
    [sym_binary_expression] = STATE(3550),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1160] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3402),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3402),
    [sym_ternary_expression] = STATE(3402),
    [sym_call_expression] = STATE(3402),
    [sym_primary_expression] = STATE(3402),
    [sym__primary_expr] = STATE(3402),
    [sym_index_expression] = STATE(3402),
    [sym_assignment_expression] = STATE(3402),
    [sym_binary_expression] = STATE(3402),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3402),
    [sym_unary_expression] = STATE(3402),
    [sym__unary_expr] = STATE(3402),
    [sym_property_expression] = STATE(3402),
    [sym_cast_expression] = STATE(3402),
    [sym_delete_expression] = STATE(3402),
    [sym_throw_expression] = STATE(3402),
    [sym_assert_expression] = STATE(3402),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3402),
    [sym_new_expression] = STATE(3402),
    [sym_typeid_expression] = STATE(3402),
    [sym_is_expression] = STATE(3402),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3402),
    [sym_char_literal] = STATE(3402),
    [sym_array_literal] = STATE(3402),
    [sym_function_literal] = STATE(3402),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3402),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3942),
    [sym_false] = ACTIONS(3942),
    [sym_null] = ACTIONS(3942),
    [sym_super] = ACTIONS(3942),
    [sym_this] = ACTIONS(3942),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3944),
    [sym_float_literal] = ACTIONS(3944),
    [sym__string] = ACTIONS(233),
  },
  [1161] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3468),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3468),
    [sym_ternary_expression] = STATE(3468),
    [sym_call_expression] = STATE(3468),
    [sym_primary_expression] = STATE(3468),
    [sym__primary_expr] = STATE(3468),
    [sym_index_expression] = STATE(3468),
    [sym_assignment_expression] = STATE(3468),
    [sym_binary_expression] = STATE(3468),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3468),
    [sym_unary_expression] = STATE(3468),
    [sym__unary_expr] = STATE(3468),
    [sym_property_expression] = STATE(3468),
    [sym_cast_expression] = STATE(3468),
    [sym_delete_expression] = STATE(3468),
    [sym_throw_expression] = STATE(3468),
    [sym_assert_expression] = STATE(3468),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3468),
    [sym_new_expression] = STATE(3468),
    [sym_typeid_expression] = STATE(3468),
    [sym_is_expression] = STATE(3468),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3468),
    [sym_char_literal] = STATE(3468),
    [sym_array_literal] = STATE(3468),
    [sym_function_literal] = STATE(3468),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3468),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3946),
    [sym_false] = ACTIONS(3946),
    [sym_null] = ACTIONS(3946),
    [sym_super] = ACTIONS(3946),
    [sym_this] = ACTIONS(3946),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3948),
    [sym_float_literal] = ACTIONS(3948),
    [sym__string] = ACTIONS(233),
  },
  [1162] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3460),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3460),
    [sym_ternary_expression] = STATE(3460),
    [sym_call_expression] = STATE(3460),
    [sym_primary_expression] = STATE(3460),
    [sym__primary_expr] = STATE(3460),
    [sym_index_expression] = STATE(3460),
    [sym_assignment_expression] = STATE(3460),
    [sym_binary_expression] = STATE(3460),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3460),
    [sym_unary_expression] = STATE(3460),
    [sym__unary_expr] = STATE(3460),
    [sym_property_expression] = STATE(3460),
    [sym_cast_expression] = STATE(3460),
    [sym_delete_expression] = STATE(3460),
    [sym_throw_expression] = STATE(3460),
    [sym_assert_expression] = STATE(3460),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3460),
    [sym_new_expression] = STATE(3460),
    [sym_typeid_expression] = STATE(3460),
    [sym_is_expression] = STATE(3460),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3460),
    [sym_char_literal] = STATE(3460),
    [sym_array_literal] = STATE(3460),
    [sym_function_literal] = STATE(3460),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3460),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3950),
    [sym_false] = ACTIONS(3950),
    [sym_null] = ACTIONS(3950),
    [sym_super] = ACTIONS(3950),
    [sym_this] = ACTIONS(3950),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3952),
    [sym_float_literal] = ACTIONS(3952),
    [sym__string] = ACTIONS(233),
  },
  [1163] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3458),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3458),
    [sym_ternary_expression] = STATE(3458),
    [sym_call_expression] = STATE(3458),
    [sym_primary_expression] = STATE(3458),
    [sym__primary_expr] = STATE(3458),
    [sym_index_expression] = STATE(3458),
    [sym_assignment_expression] = STATE(3458),
    [sym_binary_expression] = STATE(3458),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3458),
    [sym_unary_expression] = STATE(3458),
    [sym__unary_expr] = STATE(3458),
    [sym_property_expression] = STATE(3458),
    [sym_cast_expression] = STATE(3458),
    [sym_delete_expression] = STATE(3458),
    [sym_throw_expression] = STATE(3458),
    [sym_assert_expression] = STATE(3458),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3458),
    [sym_new_expression] = STATE(3458),
    [sym_typeid_expression] = STATE(3458),
    [sym_is_expression] = STATE(3458),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3458),
    [sym_char_literal] = STATE(3458),
    [sym_array_literal] = STATE(3458),
    [sym_function_literal] = STATE(3458),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3458),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3954),
    [sym_false] = ACTIONS(3954),
    [sym_null] = ACTIONS(3954),
    [sym_super] = ACTIONS(3954),
    [sym_this] = ACTIONS(3954),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3956),
    [sym_float_literal] = ACTIONS(3956),
    [sym__string] = ACTIONS(233),
  },
  [1164] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3307),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3307),
    [sym_ternary_expression] = STATE(3307),
    [sym_call_expression] = STATE(3307),
    [sym_primary_expression] = STATE(3307),
    [sym__primary_expr] = STATE(3307),
    [sym_index_expression] = STATE(3307),
    [sym_assignment_expression] = STATE(3307),
    [sym_binary_expression] = STATE(3307),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3307),
    [sym_unary_expression] = STATE(3307),
    [sym__unary_expr] = STATE(3307),
    [sym_property_expression] = STATE(3307),
    [sym_cast_expression] = STATE(3307),
    [sym_delete_expression] = STATE(3307),
    [sym_throw_expression] = STATE(3307),
    [sym_assert_expression] = STATE(3307),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3307),
    [sym_new_expression] = STATE(3307),
    [sym_typeid_expression] = STATE(3307),
    [sym_is_expression] = STATE(3307),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3307),
    [sym_char_literal] = STATE(3307),
    [sym_array_literal] = STATE(3307),
    [sym_function_literal] = STATE(3307),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3307),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3958),
    [sym_false] = ACTIONS(3958),
    [sym_null] = ACTIONS(3958),
    [sym_super] = ACTIONS(3958),
    [sym_this] = ACTIONS(3958),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3960),
    [sym_float_literal] = ACTIONS(3960),
    [sym__string] = ACTIONS(233),
  },
  [1165] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3449),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3449),
    [sym_ternary_expression] = STATE(3449),
    [sym_call_expression] = STATE(3449),
    [sym_primary_expression] = STATE(3449),
    [sym__primary_expr] = STATE(3449),
    [sym_index_expression] = STATE(3449),
    [sym_assignment_expression] = STATE(3449),
    [sym_binary_expression] = STATE(3449),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3449),
    [sym_unary_expression] = STATE(3449),
    [sym__unary_expr] = STATE(3449),
    [sym_property_expression] = STATE(3449),
    [sym_cast_expression] = STATE(3449),
    [sym_delete_expression] = STATE(3449),
    [sym_throw_expression] = STATE(3449),
    [sym_assert_expression] = STATE(3449),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3449),
    [sym_new_expression] = STATE(3449),
    [sym_typeid_expression] = STATE(3449),
    [sym_is_expression] = STATE(3449),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3449),
    [sym_char_literal] = STATE(3449),
    [sym_array_literal] = STATE(3449),
    [sym_function_literal] = STATE(3449),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3449),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3962),
    [sym_false] = ACTIONS(3962),
    [sym_null] = ACTIONS(3962),
    [sym_super] = ACTIONS(3962),
    [sym_this] = ACTIONS(3962),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3964),
    [sym_float_literal] = ACTIONS(3964),
    [sym__string] = ACTIONS(233),
  },
  [1166] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3431),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3431),
    [sym_ternary_expression] = STATE(3431),
    [sym_call_expression] = STATE(3431),
    [sym_primary_expression] = STATE(3431),
    [sym__primary_expr] = STATE(3431),
    [sym_index_expression] = STATE(3431),
    [sym_assignment_expression] = STATE(3431),
    [sym_binary_expression] = STATE(3431),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3431),
    [sym_unary_expression] = STATE(3431),
    [sym__unary_expr] = STATE(3431),
    [sym_property_expression] = STATE(3431),
    [sym_cast_expression] = STATE(3431),
    [sym_delete_expression] = STATE(3431),
    [sym_throw_expression] = STATE(3431),
    [sym_assert_expression] = STATE(3431),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3431),
    [sym_new_expression] = STATE(3431),
    [sym_typeid_expression] = STATE(3431),
    [sym_is_expression] = STATE(3431),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3431),
    [sym_char_literal] = STATE(3431),
    [sym_array_literal] = STATE(3431),
    [sym_function_literal] = STATE(3431),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3431),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3966),
    [sym_false] = ACTIONS(3966),
    [sym_null] = ACTIONS(3966),
    [sym_super] = ACTIONS(3966),
    [sym_this] = ACTIONS(3966),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3968),
    [sym_float_literal] = ACTIONS(3968),
    [sym__string] = ACTIONS(233),
  },
  [1167] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3310),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3310),
    [sym_ternary_expression] = STATE(3310),
    [sym_call_expression] = STATE(3310),
    [sym_primary_expression] = STATE(3310),
    [sym__primary_expr] = STATE(3310),
    [sym_index_expression] = STATE(3310),
    [sym_assignment_expression] = STATE(3310),
    [sym_binary_expression] = STATE(3310),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3310),
    [sym_unary_expression] = STATE(3310),
    [sym__unary_expr] = STATE(3310),
    [sym_property_expression] = STATE(3310),
    [sym_cast_expression] = STATE(3310),
    [sym_delete_expression] = STATE(3310),
    [sym_throw_expression] = STATE(3310),
    [sym_assert_expression] = STATE(3310),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3310),
    [sym_new_expression] = STATE(3310),
    [sym_typeid_expression] = STATE(3310),
    [sym_is_expression] = STATE(3310),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3310),
    [sym_char_literal] = STATE(3310),
    [sym_array_literal] = STATE(3310),
    [sym_function_literal] = STATE(3310),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3310),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3970),
    [sym_false] = ACTIONS(3970),
    [sym_null] = ACTIONS(3970),
    [sym_super] = ACTIONS(3970),
    [sym_this] = ACTIONS(3970),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3972),
    [sym_float_literal] = ACTIONS(3972),
    [sym__string] = ACTIONS(233),
  },
  [1168] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3312),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3312),
    [sym_ternary_expression] = STATE(3312),
    [sym_call_expression] = STATE(3312),
    [sym_primary_expression] = STATE(3312),
    [sym__primary_expr] = STATE(3312),
    [sym_index_expression] = STATE(3312),
    [sym_assignment_expression] = STATE(3312),
    [sym_binary_expression] = STATE(3312),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3312),
    [sym_unary_expression] = STATE(3312),
    [sym__unary_expr] = STATE(3312),
    [sym_property_expression] = STATE(3312),
    [sym_cast_expression] = STATE(3312),
    [sym_delete_expression] = STATE(3312),
    [sym_throw_expression] = STATE(3312),
    [sym_assert_expression] = STATE(3312),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3312),
    [sym_new_expression] = STATE(3312),
    [sym_typeid_expression] = STATE(3312),
    [sym_is_expression] = STATE(3312),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3312),
    [sym_char_literal] = STATE(3312),
    [sym_array_literal] = STATE(3312),
    [sym_function_literal] = STATE(3312),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3312),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3974),
    [sym_false] = ACTIONS(3974),
    [sym_null] = ACTIONS(3974),
    [sym_super] = ACTIONS(3974),
    [sym_this] = ACTIONS(3974),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3976),
    [sym_float_literal] = ACTIONS(3976),
    [sym__string] = ACTIONS(233),
  },
  [1169] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3587),
    [sym_ternary_expression] = STATE(3587),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3587),
    [sym_binary_expression] = STATE(3587),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1170] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3444),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3444),
    [sym_ternary_expression] = STATE(3444),
    [sym_call_expression] = STATE(3444),
    [sym_primary_expression] = STATE(3444),
    [sym__primary_expr] = STATE(3444),
    [sym_index_expression] = STATE(3444),
    [sym_assignment_expression] = STATE(3444),
    [sym_binary_expression] = STATE(3444),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3444),
    [sym_unary_expression] = STATE(3444),
    [sym__unary_expr] = STATE(3444),
    [sym_property_expression] = STATE(3444),
    [sym_cast_expression] = STATE(3444),
    [sym_delete_expression] = STATE(3444),
    [sym_throw_expression] = STATE(3444),
    [sym_assert_expression] = STATE(3444),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3444),
    [sym_new_expression] = STATE(3444),
    [sym_typeid_expression] = STATE(3444),
    [sym_is_expression] = STATE(3444),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3444),
    [sym_char_literal] = STATE(3444),
    [sym_array_literal] = STATE(3444),
    [sym_function_literal] = STATE(3444),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3444),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3978),
    [sym_false] = ACTIONS(3978),
    [sym_null] = ACTIONS(3978),
    [sym_super] = ACTIONS(3978),
    [sym_this] = ACTIONS(3978),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3980),
    [sym_float_literal] = ACTIONS(3980),
    [sym__string] = ACTIONS(3370),
  },
  [1171] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3442),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3442),
    [sym_ternary_expression] = STATE(3442),
    [sym_call_expression] = STATE(3442),
    [sym_primary_expression] = STATE(3442),
    [sym__primary_expr] = STATE(3442),
    [sym_index_expression] = STATE(3442),
    [sym_assignment_expression] = STATE(3442),
    [sym_binary_expression] = STATE(3442),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3442),
    [sym_unary_expression] = STATE(3442),
    [sym__unary_expr] = STATE(3442),
    [sym_property_expression] = STATE(3442),
    [sym_cast_expression] = STATE(3442),
    [sym_delete_expression] = STATE(3442),
    [sym_throw_expression] = STATE(3442),
    [sym_assert_expression] = STATE(3442),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3442),
    [sym_new_expression] = STATE(3442),
    [sym_typeid_expression] = STATE(3442),
    [sym_is_expression] = STATE(3442),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3442),
    [sym_char_literal] = STATE(3442),
    [sym_array_literal] = STATE(3442),
    [sym_function_literal] = STATE(3442),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3442),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3982),
    [sym_false] = ACTIONS(3982),
    [sym_null] = ACTIONS(3982),
    [sym_super] = ACTIONS(3982),
    [sym_this] = ACTIONS(3982),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3984),
    [sym_float_literal] = ACTIONS(3984),
    [sym__string] = ACTIONS(3370),
  },
  [1172] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3438),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3438),
    [sym_ternary_expression] = STATE(3438),
    [sym_call_expression] = STATE(3438),
    [sym_primary_expression] = STATE(3438),
    [sym__primary_expr] = STATE(3438),
    [sym_index_expression] = STATE(3438),
    [sym_assignment_expression] = STATE(3438),
    [sym_binary_expression] = STATE(3438),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3438),
    [sym_unary_expression] = STATE(3438),
    [sym__unary_expr] = STATE(3438),
    [sym_property_expression] = STATE(3438),
    [sym_cast_expression] = STATE(3438),
    [sym_delete_expression] = STATE(3438),
    [sym_throw_expression] = STATE(3438),
    [sym_assert_expression] = STATE(3438),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3438),
    [sym_new_expression] = STATE(3438),
    [sym_typeid_expression] = STATE(3438),
    [sym_is_expression] = STATE(3438),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3438),
    [sym_char_literal] = STATE(3438),
    [sym_array_literal] = STATE(3438),
    [sym_function_literal] = STATE(3438),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3438),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3986),
    [sym_false] = ACTIONS(3986),
    [sym_null] = ACTIONS(3986),
    [sym_super] = ACTIONS(3986),
    [sym_this] = ACTIONS(3986),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3988),
    [sym_float_literal] = ACTIONS(3988),
    [sym__string] = ACTIONS(3370),
  },
  [1173] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3428),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3428),
    [sym_ternary_expression] = STATE(3428),
    [sym_call_expression] = STATE(3428),
    [sym_primary_expression] = STATE(3428),
    [sym__primary_expr] = STATE(3428),
    [sym_index_expression] = STATE(3428),
    [sym_assignment_expression] = STATE(3428),
    [sym_binary_expression] = STATE(3428),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3428),
    [sym_unary_expression] = STATE(3428),
    [sym__unary_expr] = STATE(3428),
    [sym_property_expression] = STATE(3428),
    [sym_cast_expression] = STATE(3428),
    [sym_delete_expression] = STATE(3428),
    [sym_throw_expression] = STATE(3428),
    [sym_assert_expression] = STATE(3428),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3428),
    [sym_new_expression] = STATE(3428),
    [sym_typeid_expression] = STATE(3428),
    [sym_is_expression] = STATE(3428),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3428),
    [sym_char_literal] = STATE(3428),
    [sym_array_literal] = STATE(3428),
    [sym_function_literal] = STATE(3428),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3428),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3990),
    [sym_false] = ACTIONS(3990),
    [sym_null] = ACTIONS(3990),
    [sym_super] = ACTIONS(3990),
    [sym_this] = ACTIONS(3990),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3992),
    [sym_float_literal] = ACTIONS(3992),
    [sym__string] = ACTIONS(233),
  },
  [1174] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3585),
    [sym_ternary_expression] = STATE(3585),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3585),
    [sym_binary_expression] = STATE(3585),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1175] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3406),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3406),
    [sym_ternary_expression] = STATE(3406),
    [sym_call_expression] = STATE(3406),
    [sym_primary_expression] = STATE(3406),
    [sym__primary_expr] = STATE(3406),
    [sym_index_expression] = STATE(3406),
    [sym_assignment_expression] = STATE(3406),
    [sym_binary_expression] = STATE(3406),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3406),
    [sym_unary_expression] = STATE(3406),
    [sym__unary_expr] = STATE(3406),
    [sym_property_expression] = STATE(3406),
    [sym_cast_expression] = STATE(3406),
    [sym_delete_expression] = STATE(3406),
    [sym_throw_expression] = STATE(3406),
    [sym_assert_expression] = STATE(3406),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3406),
    [sym_new_expression] = STATE(3406),
    [sym_typeid_expression] = STATE(3406),
    [sym_is_expression] = STATE(3406),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3406),
    [sym_char_literal] = STATE(3406),
    [sym_array_literal] = STATE(3406),
    [sym_function_literal] = STATE(3406),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3406),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3994),
    [sym_false] = ACTIONS(3994),
    [sym_null] = ACTIONS(3994),
    [sym_super] = ACTIONS(3994),
    [sym_this] = ACTIONS(3994),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3996),
    [sym_float_literal] = ACTIONS(3996),
    [sym__string] = ACTIONS(233),
  },
  [1176] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3484),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3484),
    [sym_ternary_expression] = STATE(3484),
    [sym_call_expression] = STATE(3484),
    [sym_primary_expression] = STATE(3484),
    [sym__primary_expr] = STATE(3484),
    [sym_index_expression] = STATE(3484),
    [sym_assignment_expression] = STATE(3484),
    [sym_binary_expression] = STATE(3484),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3484),
    [sym_unary_expression] = STATE(3484),
    [sym__unary_expr] = STATE(3484),
    [sym_property_expression] = STATE(3484),
    [sym_cast_expression] = STATE(3484),
    [sym_delete_expression] = STATE(3484),
    [sym_throw_expression] = STATE(3484),
    [sym_assert_expression] = STATE(3484),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3484),
    [sym_new_expression] = STATE(3484),
    [sym_typeid_expression] = STATE(3484),
    [sym_is_expression] = STATE(3484),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3484),
    [sym_char_literal] = STATE(3484),
    [sym_array_literal] = STATE(3484),
    [sym_function_literal] = STATE(3484),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3484),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(3998),
    [sym_false] = ACTIONS(3998),
    [sym_null] = ACTIONS(3998),
    [sym_super] = ACTIONS(3998),
    [sym_this] = ACTIONS(3998),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4000),
    [sym_float_literal] = ACTIONS(4000),
    [sym__string] = ACTIONS(233),
  },
  [1177] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3455),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3455),
    [sym_ternary_expression] = STATE(3455),
    [sym_call_expression] = STATE(3455),
    [sym_primary_expression] = STATE(3455),
    [sym__primary_expr] = STATE(3455),
    [sym_index_expression] = STATE(3455),
    [sym_assignment_expression] = STATE(3455),
    [sym_binary_expression] = STATE(3455),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3455),
    [sym_unary_expression] = STATE(3455),
    [sym__unary_expr] = STATE(3455),
    [sym_property_expression] = STATE(3455),
    [sym_cast_expression] = STATE(3455),
    [sym_delete_expression] = STATE(3455),
    [sym_throw_expression] = STATE(3455),
    [sym_assert_expression] = STATE(3455),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3455),
    [sym_new_expression] = STATE(3455),
    [sym_typeid_expression] = STATE(3455),
    [sym_is_expression] = STATE(3455),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3455),
    [sym_char_literal] = STATE(3455),
    [sym_array_literal] = STATE(3455),
    [sym_function_literal] = STATE(3455),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3455),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4002),
    [sym_false] = ACTIONS(4002),
    [sym_null] = ACTIONS(4002),
    [sym_super] = ACTIONS(4002),
    [sym_this] = ACTIONS(4002),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4004),
    [sym_float_literal] = ACTIONS(4004),
    [sym__string] = ACTIONS(233),
  },
  [1178] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3520),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3520),
    [sym_ternary_expression] = STATE(3520),
    [sym_call_expression] = STATE(3520),
    [sym_primary_expression] = STATE(3520),
    [sym__primary_expr] = STATE(3520),
    [sym_index_expression] = STATE(3520),
    [sym_assignment_expression] = STATE(3520),
    [sym_binary_expression] = STATE(3520),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3520),
    [sym_unary_expression] = STATE(3520),
    [sym__unary_expr] = STATE(3520),
    [sym_property_expression] = STATE(3520),
    [sym_cast_expression] = STATE(3520),
    [sym_delete_expression] = STATE(3520),
    [sym_throw_expression] = STATE(3520),
    [sym_assert_expression] = STATE(3520),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3520),
    [sym_new_expression] = STATE(3520),
    [sym_typeid_expression] = STATE(3520),
    [sym_is_expression] = STATE(3520),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3520),
    [sym_char_literal] = STATE(3520),
    [sym_array_literal] = STATE(3520),
    [sym_function_literal] = STATE(3520),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3520),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4006),
    [sym_false] = ACTIONS(4006),
    [sym_null] = ACTIONS(4006),
    [sym_super] = ACTIONS(4006),
    [sym_this] = ACTIONS(4006),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4008),
    [sym_float_literal] = ACTIONS(4008),
    [sym__string] = ACTIONS(233),
  },
  [1179] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3584),
    [sym_ternary_expression] = STATE(3584),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3584),
    [sym_binary_expression] = STATE(3584),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1180] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3426),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3426),
    [sym_ternary_expression] = STATE(3426),
    [sym_call_expression] = STATE(3426),
    [sym_primary_expression] = STATE(3426),
    [sym__primary_expr] = STATE(3426),
    [sym_index_expression] = STATE(3426),
    [sym_assignment_expression] = STATE(3426),
    [sym_binary_expression] = STATE(3426),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3426),
    [sym_unary_expression] = STATE(3426),
    [sym__unary_expr] = STATE(3426),
    [sym_property_expression] = STATE(3426),
    [sym_cast_expression] = STATE(3426),
    [sym_delete_expression] = STATE(3426),
    [sym_throw_expression] = STATE(3426),
    [sym_assert_expression] = STATE(3426),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3426),
    [sym_new_expression] = STATE(3426),
    [sym_typeid_expression] = STATE(3426),
    [sym_is_expression] = STATE(3426),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3426),
    [sym_char_literal] = STATE(3426),
    [sym_array_literal] = STATE(3426),
    [sym_function_literal] = STATE(3426),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3426),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4010),
    [sym_false] = ACTIONS(4010),
    [sym_null] = ACTIONS(4010),
    [sym_super] = ACTIONS(4010),
    [sym_this] = ACTIONS(4010),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4012),
    [sym_float_literal] = ACTIONS(4012),
    [sym__string] = ACTIONS(3370),
  },
  [1181] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3677),
    [sym_ternary_expression] = STATE(3677),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3677),
    [sym_binary_expression] = STATE(3677),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1182] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3450),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3450),
    [sym_ternary_expression] = STATE(3450),
    [sym_call_expression] = STATE(3450),
    [sym_primary_expression] = STATE(3450),
    [sym__primary_expr] = STATE(3450),
    [sym_index_expression] = STATE(3450),
    [sym_assignment_expression] = STATE(3450),
    [sym_binary_expression] = STATE(3450),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3450),
    [sym_unary_expression] = STATE(3450),
    [sym__unary_expr] = STATE(3450),
    [sym_property_expression] = STATE(3450),
    [sym_cast_expression] = STATE(3450),
    [sym_delete_expression] = STATE(3450),
    [sym_throw_expression] = STATE(3450),
    [sym_assert_expression] = STATE(3450),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3450),
    [sym_new_expression] = STATE(3450),
    [sym_typeid_expression] = STATE(3450),
    [sym_is_expression] = STATE(3450),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3450),
    [sym_char_literal] = STATE(3450),
    [sym_array_literal] = STATE(3450),
    [sym_function_literal] = STATE(3450),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3450),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4014),
    [sym_false] = ACTIONS(4014),
    [sym_null] = ACTIONS(4014),
    [sym_super] = ACTIONS(4014),
    [sym_this] = ACTIONS(4014),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4016),
    [sym_float_literal] = ACTIONS(4016),
    [sym__string] = ACTIONS(3774),
  },
  [1183] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3420),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3420),
    [sym_ternary_expression] = STATE(3420),
    [sym_call_expression] = STATE(3420),
    [sym_primary_expression] = STATE(3420),
    [sym__primary_expr] = STATE(3420),
    [sym_index_expression] = STATE(3420),
    [sym_assignment_expression] = STATE(3420),
    [sym_binary_expression] = STATE(3420),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3420),
    [sym_unary_expression] = STATE(3420),
    [sym__unary_expr] = STATE(3420),
    [sym_property_expression] = STATE(3420),
    [sym_cast_expression] = STATE(3420),
    [sym_delete_expression] = STATE(3420),
    [sym_throw_expression] = STATE(3420),
    [sym_assert_expression] = STATE(3420),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3420),
    [sym_new_expression] = STATE(3420),
    [sym_typeid_expression] = STATE(3420),
    [sym_is_expression] = STATE(3420),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3420),
    [sym_char_literal] = STATE(3420),
    [sym_array_literal] = STATE(3420),
    [sym_function_literal] = STATE(3420),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3420),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4018),
    [sym_false] = ACTIONS(4018),
    [sym_null] = ACTIONS(4018),
    [sym_super] = ACTIONS(4018),
    [sym_this] = ACTIONS(4018),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4020),
    [sym_float_literal] = ACTIONS(4020),
    [sym__string] = ACTIONS(3370),
  },
  [1184] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3553),
    [sym_ternary_expression] = STATE(3553),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3553),
    [sym_binary_expression] = STATE(3553),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1185] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3413),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3413),
    [sym_ternary_expression] = STATE(3413),
    [sym_call_expression] = STATE(3413),
    [sym_primary_expression] = STATE(3413),
    [sym__primary_expr] = STATE(3413),
    [sym_index_expression] = STATE(3413),
    [sym_assignment_expression] = STATE(3413),
    [sym_binary_expression] = STATE(3413),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3413),
    [sym_unary_expression] = STATE(3413),
    [sym__unary_expr] = STATE(3413),
    [sym_property_expression] = STATE(3413),
    [sym_cast_expression] = STATE(3413),
    [sym_delete_expression] = STATE(3413),
    [sym_throw_expression] = STATE(3413),
    [sym_assert_expression] = STATE(3413),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3413),
    [sym_new_expression] = STATE(3413),
    [sym_typeid_expression] = STATE(3413),
    [sym_is_expression] = STATE(3413),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3413),
    [sym_char_literal] = STATE(3413),
    [sym_array_literal] = STATE(3413),
    [sym_function_literal] = STATE(3413),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3413),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4022),
    [sym_false] = ACTIONS(4022),
    [sym_null] = ACTIONS(4022),
    [sym_super] = ACTIONS(4022),
    [sym_this] = ACTIONS(4022),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4024),
    [sym_float_literal] = ACTIONS(4024),
    [sym__string] = ACTIONS(3370),
  },
  [1186] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3583),
    [sym_ternary_expression] = STATE(3583),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3583),
    [sym_binary_expression] = STATE(3583),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1187] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3325),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3325),
    [sym_ternary_expression] = STATE(3325),
    [sym_call_expression] = STATE(3325),
    [sym_primary_expression] = STATE(3325),
    [sym__primary_expr] = STATE(3325),
    [sym_index_expression] = STATE(3325),
    [sym_assignment_expression] = STATE(3325),
    [sym_binary_expression] = STATE(3325),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3325),
    [sym_unary_expression] = STATE(3325),
    [sym__unary_expr] = STATE(3325),
    [sym_property_expression] = STATE(3325),
    [sym_cast_expression] = STATE(3325),
    [sym_delete_expression] = STATE(3325),
    [sym_throw_expression] = STATE(3325),
    [sym_assert_expression] = STATE(3325),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3325),
    [sym_new_expression] = STATE(3325),
    [sym_typeid_expression] = STATE(3325),
    [sym_is_expression] = STATE(3325),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3325),
    [sym_char_literal] = STATE(3325),
    [sym_array_literal] = STATE(3325),
    [sym_function_literal] = STATE(3325),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3325),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4026),
    [sym_false] = ACTIONS(4026),
    [sym_null] = ACTIONS(4026),
    [sym_super] = ACTIONS(4026),
    [sym_this] = ACTIONS(4026),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4028),
    [sym_float_literal] = ACTIONS(4028),
    [sym__string] = ACTIONS(233),
  },
  [1188] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3582),
    [sym_ternary_expression] = STATE(3582),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3582),
    [sym_binary_expression] = STATE(3582),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1189] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3549),
    [sym_ternary_expression] = STATE(3549),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3549),
    [sym_binary_expression] = STATE(3549),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1190] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3561),
    [sym_ternary_expression] = STATE(3561),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3561),
    [sym_binary_expression] = STATE(3561),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1191] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3573),
    [sym_ternary_expression] = STATE(3573),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3573),
    [sym_binary_expression] = STATE(3573),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1192] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3418),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3418),
    [sym_ternary_expression] = STATE(3418),
    [sym_call_expression] = STATE(3418),
    [sym_primary_expression] = STATE(3418),
    [sym__primary_expr] = STATE(3418),
    [sym_index_expression] = STATE(3418),
    [sym_assignment_expression] = STATE(3418),
    [sym_binary_expression] = STATE(3418),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3418),
    [sym_unary_expression] = STATE(3418),
    [sym__unary_expr] = STATE(3418),
    [sym_property_expression] = STATE(3418),
    [sym_cast_expression] = STATE(3418),
    [sym_delete_expression] = STATE(3418),
    [sym_throw_expression] = STATE(3418),
    [sym_assert_expression] = STATE(3418),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3418),
    [sym_new_expression] = STATE(3418),
    [sym_typeid_expression] = STATE(3418),
    [sym_is_expression] = STATE(3418),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3418),
    [sym_char_literal] = STATE(3418),
    [sym_array_literal] = STATE(3418),
    [sym_function_literal] = STATE(3418),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3418),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4030),
    [sym_false] = ACTIONS(4030),
    [sym_null] = ACTIONS(4030),
    [sym_super] = ACTIONS(4030),
    [sym_this] = ACTIONS(4030),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4032),
    [sym_float_literal] = ACTIONS(4032),
    [sym__string] = ACTIONS(3370),
  },
  [1193] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3322),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3322),
    [sym_ternary_expression] = STATE(3322),
    [sym_call_expression] = STATE(3322),
    [sym_primary_expression] = STATE(3322),
    [sym__primary_expr] = STATE(3322),
    [sym_index_expression] = STATE(3322),
    [sym_assignment_expression] = STATE(3322),
    [sym_binary_expression] = STATE(3322),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3322),
    [sym_unary_expression] = STATE(3322),
    [sym__unary_expr] = STATE(3322),
    [sym_property_expression] = STATE(3322),
    [sym_cast_expression] = STATE(3322),
    [sym_delete_expression] = STATE(3322),
    [sym_throw_expression] = STATE(3322),
    [sym_assert_expression] = STATE(3322),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3322),
    [sym_new_expression] = STATE(3322),
    [sym_typeid_expression] = STATE(3322),
    [sym_is_expression] = STATE(3322),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3322),
    [sym_char_literal] = STATE(3322),
    [sym_array_literal] = STATE(3322),
    [sym_function_literal] = STATE(3322),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3322),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4034),
    [sym_false] = ACTIONS(4034),
    [sym_null] = ACTIONS(4034),
    [sym_super] = ACTIONS(4034),
    [sym_this] = ACTIONS(4034),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4036),
    [sym_float_literal] = ACTIONS(4036),
    [sym__string] = ACTIONS(233),
  },
  [1194] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3326),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3326),
    [sym_ternary_expression] = STATE(3326),
    [sym_call_expression] = STATE(3326),
    [sym_primary_expression] = STATE(3326),
    [sym__primary_expr] = STATE(3326),
    [sym_index_expression] = STATE(3326),
    [sym_assignment_expression] = STATE(3326),
    [sym_binary_expression] = STATE(3326),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3326),
    [sym_unary_expression] = STATE(3326),
    [sym__unary_expr] = STATE(3326),
    [sym_property_expression] = STATE(3326),
    [sym_cast_expression] = STATE(3326),
    [sym_delete_expression] = STATE(3326),
    [sym_throw_expression] = STATE(3326),
    [sym_assert_expression] = STATE(3326),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3326),
    [sym_new_expression] = STATE(3326),
    [sym_typeid_expression] = STATE(3326),
    [sym_is_expression] = STATE(3326),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3326),
    [sym_char_literal] = STATE(3326),
    [sym_array_literal] = STATE(3326),
    [sym_function_literal] = STATE(3326),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3326),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4038),
    [sym_false] = ACTIONS(4038),
    [sym_null] = ACTIONS(4038),
    [sym_super] = ACTIONS(4038),
    [sym_this] = ACTIONS(4038),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4040),
    [sym_float_literal] = ACTIONS(4040),
    [sym__string] = ACTIONS(233),
  },
  [1195] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3424),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3424),
    [sym_ternary_expression] = STATE(3424),
    [sym_call_expression] = STATE(3424),
    [sym_primary_expression] = STATE(3424),
    [sym__primary_expr] = STATE(3424),
    [sym_index_expression] = STATE(3424),
    [sym_assignment_expression] = STATE(3424),
    [sym_binary_expression] = STATE(3424),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3424),
    [sym_unary_expression] = STATE(3424),
    [sym__unary_expr] = STATE(3424),
    [sym_property_expression] = STATE(3424),
    [sym_cast_expression] = STATE(3424),
    [sym_delete_expression] = STATE(3424),
    [sym_throw_expression] = STATE(3424),
    [sym_assert_expression] = STATE(3424),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3424),
    [sym_new_expression] = STATE(3424),
    [sym_typeid_expression] = STATE(3424),
    [sym_is_expression] = STATE(3424),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3424),
    [sym_char_literal] = STATE(3424),
    [sym_array_literal] = STATE(3424),
    [sym_function_literal] = STATE(3424),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3424),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4042),
    [sym_false] = ACTIONS(4042),
    [sym_null] = ACTIONS(4042),
    [sym_super] = ACTIONS(4042),
    [sym_this] = ACTIONS(4042),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4044),
    [sym_float_literal] = ACTIONS(4044),
    [sym__string] = ACTIONS(3370),
  },
  [1196] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3427),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3427),
    [sym_ternary_expression] = STATE(3427),
    [sym_call_expression] = STATE(3427),
    [sym_primary_expression] = STATE(3427),
    [sym__primary_expr] = STATE(3427),
    [sym_index_expression] = STATE(3427),
    [sym_assignment_expression] = STATE(3427),
    [sym_binary_expression] = STATE(3427),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3427),
    [sym_unary_expression] = STATE(3427),
    [sym__unary_expr] = STATE(3427),
    [sym_property_expression] = STATE(3427),
    [sym_cast_expression] = STATE(3427),
    [sym_delete_expression] = STATE(3427),
    [sym_throw_expression] = STATE(3427),
    [sym_assert_expression] = STATE(3427),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3427),
    [sym_new_expression] = STATE(3427),
    [sym_typeid_expression] = STATE(3427),
    [sym_is_expression] = STATE(3427),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3427),
    [sym_char_literal] = STATE(3427),
    [sym_array_literal] = STATE(3427),
    [sym_function_literal] = STATE(3427),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3427),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4046),
    [sym_false] = ACTIONS(4046),
    [sym_null] = ACTIONS(4046),
    [sym_super] = ACTIONS(4046),
    [sym_this] = ACTIONS(4046),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4048),
    [sym_float_literal] = ACTIONS(4048),
    [sym__string] = ACTIONS(3370),
  },
  [1197] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3660),
    [sym_ternary_expression] = STATE(3660),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3660),
    [sym_binary_expression] = STATE(3660),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1198] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3423),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3423),
    [sym_ternary_expression] = STATE(3423),
    [sym_call_expression] = STATE(3423),
    [sym_primary_expression] = STATE(3423),
    [sym__primary_expr] = STATE(3423),
    [sym_index_expression] = STATE(3423),
    [sym_assignment_expression] = STATE(3423),
    [sym_binary_expression] = STATE(3423),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3423),
    [sym_unary_expression] = STATE(3423),
    [sym__unary_expr] = STATE(3423),
    [sym_property_expression] = STATE(3423),
    [sym_cast_expression] = STATE(3423),
    [sym_delete_expression] = STATE(3423),
    [sym_throw_expression] = STATE(3423),
    [sym_assert_expression] = STATE(3423),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3423),
    [sym_new_expression] = STATE(3423),
    [sym_typeid_expression] = STATE(3423),
    [sym_is_expression] = STATE(3423),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3423),
    [sym_char_literal] = STATE(3423),
    [sym_array_literal] = STATE(3423),
    [sym_function_literal] = STATE(3423),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3423),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4050),
    [sym_false] = ACTIONS(4050),
    [sym_null] = ACTIONS(4050),
    [sym_super] = ACTIONS(4050),
    [sym_this] = ACTIONS(4050),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4052),
    [sym_float_literal] = ACTIONS(4052),
    [sym__string] = ACTIONS(3370),
  },
  [1199] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3308),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3308),
    [sym_ternary_expression] = STATE(3308),
    [sym_call_expression] = STATE(3308),
    [sym_primary_expression] = STATE(3308),
    [sym__primary_expr] = STATE(3308),
    [sym_index_expression] = STATE(3308),
    [sym_assignment_expression] = STATE(3308),
    [sym_binary_expression] = STATE(3308),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3308),
    [sym_unary_expression] = STATE(3308),
    [sym__unary_expr] = STATE(3308),
    [sym_property_expression] = STATE(3308),
    [sym_cast_expression] = STATE(3308),
    [sym_delete_expression] = STATE(3308),
    [sym_throw_expression] = STATE(3308),
    [sym_assert_expression] = STATE(3308),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3308),
    [sym_new_expression] = STATE(3308),
    [sym_typeid_expression] = STATE(3308),
    [sym_is_expression] = STATE(3308),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3308),
    [sym_char_literal] = STATE(3308),
    [sym_array_literal] = STATE(3308),
    [sym_function_literal] = STATE(3308),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3308),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4054),
    [sym_false] = ACTIONS(4054),
    [sym_null] = ACTIONS(4054),
    [sym_super] = ACTIONS(4054),
    [sym_this] = ACTIONS(4054),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4056),
    [sym_float_literal] = ACTIONS(4056),
    [sym__string] = ACTIONS(233),
  },
  [1200] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3300),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3300),
    [sym_ternary_expression] = STATE(3300),
    [sym_call_expression] = STATE(3300),
    [sym_primary_expression] = STATE(3300),
    [sym__primary_expr] = STATE(3300),
    [sym_index_expression] = STATE(3300),
    [sym_assignment_expression] = STATE(3300),
    [sym_binary_expression] = STATE(3300),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3300),
    [sym_unary_expression] = STATE(3300),
    [sym__unary_expr] = STATE(3300),
    [sym_property_expression] = STATE(3300),
    [sym_cast_expression] = STATE(3300),
    [sym_delete_expression] = STATE(3300),
    [sym_throw_expression] = STATE(3300),
    [sym_assert_expression] = STATE(3300),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3300),
    [sym_new_expression] = STATE(3300),
    [sym_typeid_expression] = STATE(3300),
    [sym_is_expression] = STATE(3300),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3300),
    [sym_char_literal] = STATE(3300),
    [sym_array_literal] = STATE(3300),
    [sym_function_literal] = STATE(3300),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3300),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4058),
    [sym_false] = ACTIONS(4058),
    [sym_null] = ACTIONS(4058),
    [sym_super] = ACTIONS(4058),
    [sym_this] = ACTIONS(4058),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4060),
    [sym_float_literal] = ACTIONS(4060),
    [sym__string] = ACTIONS(233),
  },
  [1201] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3430),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3430),
    [sym_ternary_expression] = STATE(3430),
    [sym_call_expression] = STATE(3430),
    [sym_primary_expression] = STATE(3430),
    [sym__primary_expr] = STATE(3430),
    [sym_index_expression] = STATE(3430),
    [sym_assignment_expression] = STATE(3430),
    [sym_binary_expression] = STATE(3430),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3430),
    [sym_unary_expression] = STATE(3430),
    [sym__unary_expr] = STATE(3430),
    [sym_property_expression] = STATE(3430),
    [sym_cast_expression] = STATE(3430),
    [sym_delete_expression] = STATE(3430),
    [sym_throw_expression] = STATE(3430),
    [sym_assert_expression] = STATE(3430),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3430),
    [sym_new_expression] = STATE(3430),
    [sym_typeid_expression] = STATE(3430),
    [sym_is_expression] = STATE(3430),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3430),
    [sym_char_literal] = STATE(3430),
    [sym_array_literal] = STATE(3430),
    [sym_function_literal] = STATE(3430),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3430),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4062),
    [sym_false] = ACTIONS(4062),
    [sym_null] = ACTIONS(4062),
    [sym_super] = ACTIONS(4062),
    [sym_this] = ACTIONS(4062),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4064),
    [sym_float_literal] = ACTIONS(4064),
    [sym__string] = ACTIONS(3370),
  },
  [1202] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3486),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3486),
    [sym_ternary_expression] = STATE(3486),
    [sym_call_expression] = STATE(3486),
    [sym_primary_expression] = STATE(3486),
    [sym__primary_expr] = STATE(3486),
    [sym_index_expression] = STATE(3486),
    [sym_assignment_expression] = STATE(3486),
    [sym_binary_expression] = STATE(3486),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3486),
    [sym_unary_expression] = STATE(3486),
    [sym__unary_expr] = STATE(3486),
    [sym_property_expression] = STATE(3486),
    [sym_cast_expression] = STATE(3486),
    [sym_delete_expression] = STATE(3486),
    [sym_throw_expression] = STATE(3486),
    [sym_assert_expression] = STATE(3486),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3486),
    [sym_new_expression] = STATE(3486),
    [sym_typeid_expression] = STATE(3486),
    [sym_is_expression] = STATE(3486),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3486),
    [sym_char_literal] = STATE(3486),
    [sym_array_literal] = STATE(3486),
    [sym_function_literal] = STATE(3486),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3486),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4066),
    [sym_false] = ACTIONS(4066),
    [sym_null] = ACTIONS(4066),
    [sym_super] = ACTIONS(4066),
    [sym_this] = ACTIONS(4066),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4068),
    [sym_float_literal] = ACTIONS(4068),
    [sym__string] = ACTIONS(3370),
  },
  [1203] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3471),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3471),
    [sym_ternary_expression] = STATE(3471),
    [sym_call_expression] = STATE(3471),
    [sym_primary_expression] = STATE(3471),
    [sym__primary_expr] = STATE(3471),
    [sym_index_expression] = STATE(3471),
    [sym_assignment_expression] = STATE(3471),
    [sym_binary_expression] = STATE(3471),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3471),
    [sym_unary_expression] = STATE(3471),
    [sym__unary_expr] = STATE(3471),
    [sym_property_expression] = STATE(3471),
    [sym_cast_expression] = STATE(3471),
    [sym_delete_expression] = STATE(3471),
    [sym_throw_expression] = STATE(3471),
    [sym_assert_expression] = STATE(3471),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3471),
    [sym_new_expression] = STATE(3471),
    [sym_typeid_expression] = STATE(3471),
    [sym_is_expression] = STATE(3471),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3471),
    [sym_char_literal] = STATE(3471),
    [sym_array_literal] = STATE(3471),
    [sym_function_literal] = STATE(3471),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3471),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4070),
    [sym_false] = ACTIONS(4070),
    [sym_null] = ACTIONS(4070),
    [sym_super] = ACTIONS(4070),
    [sym_this] = ACTIONS(4070),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4072),
    [sym_float_literal] = ACTIONS(4072),
    [sym__string] = ACTIONS(3370),
  },
  [1204] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3319),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3319),
    [sym_ternary_expression] = STATE(3319),
    [sym_call_expression] = STATE(3319),
    [sym_primary_expression] = STATE(3319),
    [sym__primary_expr] = STATE(3319),
    [sym_index_expression] = STATE(3319),
    [sym_assignment_expression] = STATE(3319),
    [sym_binary_expression] = STATE(3319),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3319),
    [sym_unary_expression] = STATE(3319),
    [sym__unary_expr] = STATE(3319),
    [sym_property_expression] = STATE(3319),
    [sym_cast_expression] = STATE(3319),
    [sym_delete_expression] = STATE(3319),
    [sym_throw_expression] = STATE(3319),
    [sym_assert_expression] = STATE(3319),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3319),
    [sym_new_expression] = STATE(3319),
    [sym_typeid_expression] = STATE(3319),
    [sym_is_expression] = STATE(3319),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3319),
    [sym_char_literal] = STATE(3319),
    [sym_array_literal] = STATE(3319),
    [sym_function_literal] = STATE(3319),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3319),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4074),
    [sym_false] = ACTIONS(4074),
    [sym_null] = ACTIONS(4074),
    [sym_super] = ACTIONS(4074),
    [sym_this] = ACTIONS(4074),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4076),
    [sym_float_literal] = ACTIONS(4076),
    [sym__string] = ACTIONS(233),
  },
  [1205] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3577),
    [sym_ternary_expression] = STATE(3577),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3577),
    [sym_binary_expression] = STATE(3577),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1206] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3576),
    [sym_ternary_expression] = STATE(3576),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3576),
    [sym_binary_expression] = STATE(3576),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1207] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3607),
    [sym_ternary_expression] = STATE(3607),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3607),
    [sym_binary_expression] = STATE(3607),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1208] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3313),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3313),
    [sym_ternary_expression] = STATE(3313),
    [sym_call_expression] = STATE(3313),
    [sym_primary_expression] = STATE(3313),
    [sym__primary_expr] = STATE(3313),
    [sym_index_expression] = STATE(3313),
    [sym_assignment_expression] = STATE(3313),
    [sym_binary_expression] = STATE(3313),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3313),
    [sym_unary_expression] = STATE(3313),
    [sym__unary_expr] = STATE(3313),
    [sym_property_expression] = STATE(3313),
    [sym_cast_expression] = STATE(3313),
    [sym_delete_expression] = STATE(3313),
    [sym_throw_expression] = STATE(3313),
    [sym_assert_expression] = STATE(3313),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3313),
    [sym_new_expression] = STATE(3313),
    [sym_typeid_expression] = STATE(3313),
    [sym_is_expression] = STATE(3313),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3313),
    [sym_char_literal] = STATE(3313),
    [sym_array_literal] = STATE(3313),
    [sym_function_literal] = STATE(3313),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3313),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4078),
    [sym_false] = ACTIONS(4078),
    [sym_null] = ACTIONS(4078),
    [sym_super] = ACTIONS(4078),
    [sym_this] = ACTIONS(4078),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4080),
    [sym_float_literal] = ACTIONS(4080),
    [sym__string] = ACTIONS(233),
  },
  [1209] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3610),
    [sym_ternary_expression] = STATE(3610),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3610),
    [sym_binary_expression] = STATE(3610),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1210] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3606),
    [sym_ternary_expression] = STATE(3606),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3606),
    [sym_binary_expression] = STATE(3606),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1211] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3611),
    [sym_ternary_expression] = STATE(3611),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3611),
    [sym_binary_expression] = STATE(3611),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1212] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3311),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3311),
    [sym_ternary_expression] = STATE(3311),
    [sym_call_expression] = STATE(3311),
    [sym_primary_expression] = STATE(3311),
    [sym__primary_expr] = STATE(3311),
    [sym_index_expression] = STATE(3311),
    [sym_assignment_expression] = STATE(3311),
    [sym_binary_expression] = STATE(3311),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3311),
    [sym_unary_expression] = STATE(3311),
    [sym__unary_expr] = STATE(3311),
    [sym_property_expression] = STATE(3311),
    [sym_cast_expression] = STATE(3311),
    [sym_delete_expression] = STATE(3311),
    [sym_throw_expression] = STATE(3311),
    [sym_assert_expression] = STATE(3311),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3311),
    [sym_new_expression] = STATE(3311),
    [sym_typeid_expression] = STATE(3311),
    [sym_is_expression] = STATE(3311),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3311),
    [sym_char_literal] = STATE(3311),
    [sym_array_literal] = STATE(3311),
    [sym_function_literal] = STATE(3311),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3311),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4082),
    [sym_false] = ACTIONS(4082),
    [sym_null] = ACTIONS(4082),
    [sym_super] = ACTIONS(4082),
    [sym_this] = ACTIONS(4082),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4084),
    [sym_float_literal] = ACTIONS(4084),
    [sym__string] = ACTIONS(233),
  },
  [1213] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3263),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3263),
    [sym_ternary_expression] = STATE(3263),
    [sym_call_expression] = STATE(3263),
    [sym_primary_expression] = STATE(3263),
    [sym__primary_expr] = STATE(3263),
    [sym_index_expression] = STATE(3263),
    [sym_assignment_expression] = STATE(3263),
    [sym_binary_expression] = STATE(3263),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3263),
    [sym_unary_expression] = STATE(3263),
    [sym__unary_expr] = STATE(3263),
    [sym_property_expression] = STATE(3263),
    [sym_cast_expression] = STATE(3263),
    [sym_delete_expression] = STATE(3263),
    [sym_throw_expression] = STATE(3263),
    [sym_assert_expression] = STATE(3263),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3263),
    [sym_new_expression] = STATE(3263),
    [sym_typeid_expression] = STATE(3263),
    [sym_is_expression] = STATE(3263),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3263),
    [sym_char_literal] = STATE(3263),
    [sym_array_literal] = STATE(3263),
    [sym_function_literal] = STATE(3263),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3263),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4086),
    [sym_false] = ACTIONS(4086),
    [sym_null] = ACTIONS(4086),
    [sym_super] = ACTIONS(4086),
    [sym_this] = ACTIONS(4086),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4088),
    [sym_float_literal] = ACTIONS(4088),
    [sym__string] = ACTIONS(233),
  },
  [1214] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4590),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4305),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4305),
    [sym_typeof_expression] = STATE(3388),
    [sym__expr] = STATE(3629),
    [sym_ternary_expression] = STATE(3629),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3629),
    [sym_binary_expression] = STATE(3629),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3391),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3389),
    [sym_traits_expression] = STATE(3391),
    [aux_sym_type_repeat1] = STATE(3210),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3776),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3778),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(3780),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1215] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3288),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3288),
    [sym_ternary_expression] = STATE(3288),
    [sym_call_expression] = STATE(3288),
    [sym_primary_expression] = STATE(3288),
    [sym__primary_expr] = STATE(3288),
    [sym_index_expression] = STATE(3288),
    [sym_assignment_expression] = STATE(3288),
    [sym_binary_expression] = STATE(3288),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3288),
    [sym_unary_expression] = STATE(3288),
    [sym__unary_expr] = STATE(3288),
    [sym_property_expression] = STATE(3288),
    [sym_cast_expression] = STATE(3288),
    [sym_delete_expression] = STATE(3288),
    [sym_throw_expression] = STATE(3288),
    [sym_assert_expression] = STATE(3288),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3288),
    [sym_new_expression] = STATE(3288),
    [sym_typeid_expression] = STATE(3288),
    [sym_is_expression] = STATE(3288),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3288),
    [sym_char_literal] = STATE(3288),
    [sym_array_literal] = STATE(3288),
    [sym_function_literal] = STATE(3288),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3288),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4090),
    [sym_false] = ACTIONS(4090),
    [sym_null] = ACTIONS(4090),
    [sym_super] = ACTIONS(4090),
    [sym_this] = ACTIONS(4090),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4092),
    [sym_float_literal] = ACTIONS(4092),
    [sym__string] = ACTIONS(233),
  },
  [1216] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4719),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3644),
    [sym_ternary_expression] = STATE(3644),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3644),
    [sym_binary_expression] = STATE(3644),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1217] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4719),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3650),
    [sym_ternary_expression] = STATE(3650),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3650),
    [sym_binary_expression] = STATE(3650),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1218] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3470),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3470),
    [sym_ternary_expression] = STATE(3470),
    [sym_call_expression] = STATE(3470),
    [sym_primary_expression] = STATE(3470),
    [sym__primary_expr] = STATE(3470),
    [sym_index_expression] = STATE(3470),
    [sym_assignment_expression] = STATE(3470),
    [sym_binary_expression] = STATE(3470),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3470),
    [sym_unary_expression] = STATE(3470),
    [sym__unary_expr] = STATE(3470),
    [sym_property_expression] = STATE(3470),
    [sym_cast_expression] = STATE(3470),
    [sym_delete_expression] = STATE(3470),
    [sym_throw_expression] = STATE(3470),
    [sym_assert_expression] = STATE(3470),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3470),
    [sym_new_expression] = STATE(3470),
    [sym_typeid_expression] = STATE(3470),
    [sym_is_expression] = STATE(3470),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3470),
    [sym_char_literal] = STATE(3470),
    [sym_array_literal] = STATE(3470),
    [sym_function_literal] = STATE(3470),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3470),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4094),
    [sym_false] = ACTIONS(4094),
    [sym_null] = ACTIONS(4094),
    [sym_super] = ACTIONS(4094),
    [sym_this] = ACTIONS(4094),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4096),
    [sym_float_literal] = ACTIONS(4096),
    [sym__string] = ACTIONS(233),
  },
  [1219] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3646),
    [sym_ternary_expression] = STATE(3646),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3646),
    [sym_binary_expression] = STATE(3646),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1220] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3433),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3433),
    [sym_ternary_expression] = STATE(3433),
    [sym_call_expression] = STATE(3433),
    [sym_primary_expression] = STATE(3433),
    [sym__primary_expr] = STATE(3433),
    [sym_index_expression] = STATE(3433),
    [sym_assignment_expression] = STATE(3433),
    [sym_binary_expression] = STATE(3433),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3433),
    [sym_unary_expression] = STATE(3433),
    [sym__unary_expr] = STATE(3433),
    [sym_property_expression] = STATE(3433),
    [sym_cast_expression] = STATE(3433),
    [sym_delete_expression] = STATE(3433),
    [sym_throw_expression] = STATE(3433),
    [sym_assert_expression] = STATE(3433),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3433),
    [sym_new_expression] = STATE(3433),
    [sym_typeid_expression] = STATE(3433),
    [sym_is_expression] = STATE(3433),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3433),
    [sym_char_literal] = STATE(3433),
    [sym_array_literal] = STATE(3433),
    [sym_function_literal] = STATE(3433),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3433),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4098),
    [sym_false] = ACTIONS(4098),
    [sym_null] = ACTIONS(4098),
    [sym_super] = ACTIONS(4098),
    [sym_this] = ACTIONS(4098),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4100),
    [sym_float_literal] = ACTIONS(4100),
    [sym__string] = ACTIONS(233),
  },
  [1221] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3649),
    [sym_ternary_expression] = STATE(3649),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3649),
    [sym_binary_expression] = STATE(3649),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1222] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3523),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3523),
    [sym_ternary_expression] = STATE(3523),
    [sym_call_expression] = STATE(3523),
    [sym_primary_expression] = STATE(3523),
    [sym__primary_expr] = STATE(3523),
    [sym_index_expression] = STATE(3523),
    [sym_assignment_expression] = STATE(3523),
    [sym_binary_expression] = STATE(3523),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3523),
    [sym_unary_expression] = STATE(3523),
    [sym__unary_expr] = STATE(3523),
    [sym_property_expression] = STATE(3523),
    [sym_cast_expression] = STATE(3523),
    [sym_delete_expression] = STATE(3523),
    [sym_throw_expression] = STATE(3523),
    [sym_assert_expression] = STATE(3523),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3523),
    [sym_new_expression] = STATE(3523),
    [sym_typeid_expression] = STATE(3523),
    [sym_is_expression] = STATE(3523),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3523),
    [sym_char_literal] = STATE(3523),
    [sym_array_literal] = STATE(3523),
    [sym_function_literal] = STATE(3523),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3523),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4102),
    [sym_false] = ACTIONS(4102),
    [sym_null] = ACTIONS(4102),
    [sym_super] = ACTIONS(4102),
    [sym_this] = ACTIONS(4102),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4104),
    [sym_float_literal] = ACTIONS(4104),
    [sym__string] = ACTIONS(233),
  },
  [1223] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3525),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3525),
    [sym_ternary_expression] = STATE(3525),
    [sym_call_expression] = STATE(3525),
    [sym_primary_expression] = STATE(3525),
    [sym__primary_expr] = STATE(3525),
    [sym_index_expression] = STATE(3525),
    [sym_assignment_expression] = STATE(3525),
    [sym_binary_expression] = STATE(3525),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3525),
    [sym_unary_expression] = STATE(3525),
    [sym__unary_expr] = STATE(3525),
    [sym_property_expression] = STATE(3525),
    [sym_cast_expression] = STATE(3525),
    [sym_delete_expression] = STATE(3525),
    [sym_throw_expression] = STATE(3525),
    [sym_assert_expression] = STATE(3525),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3525),
    [sym_new_expression] = STATE(3525),
    [sym_typeid_expression] = STATE(3525),
    [sym_is_expression] = STATE(3525),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3525),
    [sym_char_literal] = STATE(3525),
    [sym_array_literal] = STATE(3525),
    [sym_function_literal] = STATE(3525),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3525),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4106),
    [sym_false] = ACTIONS(4106),
    [sym_null] = ACTIONS(4106),
    [sym_super] = ACTIONS(4106),
    [sym_this] = ACTIONS(4106),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4108),
    [sym_float_literal] = ACTIONS(4108),
    [sym__string] = ACTIONS(233),
  },
  [1224] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3528),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3528),
    [sym_ternary_expression] = STATE(3528),
    [sym_call_expression] = STATE(3528),
    [sym_primary_expression] = STATE(3528),
    [sym__primary_expr] = STATE(3528),
    [sym_index_expression] = STATE(3528),
    [sym_assignment_expression] = STATE(3528),
    [sym_binary_expression] = STATE(3528),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3528),
    [sym_unary_expression] = STATE(3528),
    [sym__unary_expr] = STATE(3528),
    [sym_property_expression] = STATE(3528),
    [sym_cast_expression] = STATE(3528),
    [sym_delete_expression] = STATE(3528),
    [sym_throw_expression] = STATE(3528),
    [sym_assert_expression] = STATE(3528),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3528),
    [sym_new_expression] = STATE(3528),
    [sym_typeid_expression] = STATE(3528),
    [sym_is_expression] = STATE(3528),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3528),
    [sym_char_literal] = STATE(3528),
    [sym_array_literal] = STATE(3528),
    [sym_function_literal] = STATE(3528),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3528),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4110),
    [sym_false] = ACTIONS(4110),
    [sym_null] = ACTIONS(4110),
    [sym_super] = ACTIONS(4110),
    [sym_this] = ACTIONS(4110),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4112),
    [sym_float_literal] = ACTIONS(4112),
    [sym__string] = ACTIONS(233),
  },
  [1225] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3530),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3530),
    [sym_ternary_expression] = STATE(3530),
    [sym_call_expression] = STATE(3530),
    [sym_primary_expression] = STATE(3530),
    [sym__primary_expr] = STATE(3530),
    [sym_index_expression] = STATE(3530),
    [sym_assignment_expression] = STATE(3530),
    [sym_binary_expression] = STATE(3530),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3530),
    [sym_unary_expression] = STATE(3530),
    [sym__unary_expr] = STATE(3530),
    [sym_property_expression] = STATE(3530),
    [sym_cast_expression] = STATE(3530),
    [sym_delete_expression] = STATE(3530),
    [sym_throw_expression] = STATE(3530),
    [sym_assert_expression] = STATE(3530),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3530),
    [sym_new_expression] = STATE(3530),
    [sym_typeid_expression] = STATE(3530),
    [sym_is_expression] = STATE(3530),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3530),
    [sym_char_literal] = STATE(3530),
    [sym_array_literal] = STATE(3530),
    [sym_function_literal] = STATE(3530),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3530),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4114),
    [sym_false] = ACTIONS(4114),
    [sym_null] = ACTIONS(4114),
    [sym_super] = ACTIONS(4114),
    [sym_this] = ACTIONS(4114),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4116),
    [sym_float_literal] = ACTIONS(4116),
    [sym__string] = ACTIONS(233),
  },
  [1226] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4691),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3628),
    [sym_ternary_expression] = STATE(3628),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3628),
    [sym_binary_expression] = STATE(3628),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1227] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3323),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3323),
    [sym_ternary_expression] = STATE(3323),
    [sym_call_expression] = STATE(3323),
    [sym_primary_expression] = STATE(3323),
    [sym__primary_expr] = STATE(3323),
    [sym_index_expression] = STATE(3323),
    [sym_assignment_expression] = STATE(3323),
    [sym_binary_expression] = STATE(3323),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3323),
    [sym_unary_expression] = STATE(3323),
    [sym__unary_expr] = STATE(3323),
    [sym_property_expression] = STATE(3323),
    [sym_cast_expression] = STATE(3323),
    [sym_delete_expression] = STATE(3323),
    [sym_throw_expression] = STATE(3323),
    [sym_assert_expression] = STATE(3323),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3323),
    [sym_new_expression] = STATE(3323),
    [sym_typeid_expression] = STATE(3323),
    [sym_is_expression] = STATE(3323),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3323),
    [sym_char_literal] = STATE(3323),
    [sym_array_literal] = STATE(3323),
    [sym_function_literal] = STATE(3323),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3323),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4118),
    [sym_false] = ACTIONS(4118),
    [sym_null] = ACTIONS(4118),
    [sym_super] = ACTIONS(4118),
    [sym_this] = ACTIONS(4118),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4120),
    [sym_float_literal] = ACTIONS(4120),
    [sym__string] = ACTIONS(233),
  },
  [1228] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4737),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3636),
    [sym_ternary_expression] = STATE(3636),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3636),
    [sym_binary_expression] = STATE(3636),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1229] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(4737),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3637),
    [sym_ternary_expression] = STATE(3637),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1230] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3415),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3415),
    [sym_ternary_expression] = STATE(3415),
    [sym_call_expression] = STATE(3415),
    [sym_primary_expression] = STATE(3415),
    [sym__primary_expr] = STATE(3415),
    [sym_index_expression] = STATE(3415),
    [sym_assignment_expression] = STATE(3415),
    [sym_binary_expression] = STATE(3415),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3415),
    [sym_unary_expression] = STATE(3415),
    [sym__unary_expr] = STATE(3415),
    [sym_property_expression] = STATE(3415),
    [sym_cast_expression] = STATE(3415),
    [sym_delete_expression] = STATE(3415),
    [sym_throw_expression] = STATE(3415),
    [sym_assert_expression] = STATE(3415),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3415),
    [sym_new_expression] = STATE(3415),
    [sym_typeid_expression] = STATE(3415),
    [sym_is_expression] = STATE(3415),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3415),
    [sym_char_literal] = STATE(3415),
    [sym_array_literal] = STATE(3415),
    [sym_function_literal] = STATE(3415),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3415),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4122),
    [sym_false] = ACTIONS(4122),
    [sym_null] = ACTIONS(4122),
    [sym_super] = ACTIONS(4122),
    [sym_this] = ACTIONS(4122),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4124),
    [sym_float_literal] = ACTIONS(4124),
    [sym__string] = ACTIONS(233),
  },
  [1231] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3515),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3515),
    [sym_ternary_expression] = STATE(3515),
    [sym_call_expression] = STATE(3515),
    [sym_primary_expression] = STATE(3515),
    [sym__primary_expr] = STATE(3515),
    [sym_index_expression] = STATE(3515),
    [sym_assignment_expression] = STATE(3515),
    [sym_binary_expression] = STATE(3515),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3515),
    [sym_unary_expression] = STATE(3515),
    [sym__unary_expr] = STATE(3515),
    [sym_property_expression] = STATE(3515),
    [sym_cast_expression] = STATE(3515),
    [sym_delete_expression] = STATE(3515),
    [sym_throw_expression] = STATE(3515),
    [sym_assert_expression] = STATE(3515),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3515),
    [sym_new_expression] = STATE(3515),
    [sym_typeid_expression] = STATE(3515),
    [sym_is_expression] = STATE(3515),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3515),
    [sym_char_literal] = STATE(3515),
    [sym_array_literal] = STATE(3515),
    [sym_function_literal] = STATE(3515),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3515),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4126),
    [sym_false] = ACTIONS(4126),
    [sym_null] = ACTIONS(4126),
    [sym_super] = ACTIONS(4126),
    [sym_this] = ACTIONS(4126),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4128),
    [sym_float_literal] = ACTIONS(4128),
    [sym__string] = ACTIONS(233),
  },
  [1232] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3516),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3516),
    [sym_ternary_expression] = STATE(3516),
    [sym_call_expression] = STATE(3516),
    [sym_primary_expression] = STATE(3516),
    [sym__primary_expr] = STATE(3516),
    [sym_index_expression] = STATE(3516),
    [sym_assignment_expression] = STATE(3516),
    [sym_binary_expression] = STATE(3516),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3516),
    [sym_unary_expression] = STATE(3516),
    [sym__unary_expr] = STATE(3516),
    [sym_property_expression] = STATE(3516),
    [sym_cast_expression] = STATE(3516),
    [sym_delete_expression] = STATE(3516),
    [sym_throw_expression] = STATE(3516),
    [sym_assert_expression] = STATE(3516),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3516),
    [sym_new_expression] = STATE(3516),
    [sym_typeid_expression] = STATE(3516),
    [sym_is_expression] = STATE(3516),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3516),
    [sym_char_literal] = STATE(3516),
    [sym_array_literal] = STATE(3516),
    [sym_function_literal] = STATE(3516),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3516),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4130),
    [sym_false] = ACTIONS(4130),
    [sym_null] = ACTIONS(4130),
    [sym_super] = ACTIONS(4130),
    [sym_this] = ACTIONS(4130),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4132),
    [sym_float_literal] = ACTIONS(4132),
    [sym__string] = ACTIONS(233),
  },
  [1233] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3529),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3529),
    [sym_ternary_expression] = STATE(3529),
    [sym_call_expression] = STATE(3529),
    [sym_primary_expression] = STATE(3529),
    [sym__primary_expr] = STATE(3529),
    [sym_index_expression] = STATE(3529),
    [sym_assignment_expression] = STATE(3529),
    [sym_binary_expression] = STATE(3529),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3529),
    [sym_unary_expression] = STATE(3529),
    [sym__unary_expr] = STATE(3529),
    [sym_property_expression] = STATE(3529),
    [sym_cast_expression] = STATE(3529),
    [sym_delete_expression] = STATE(3529),
    [sym_throw_expression] = STATE(3529),
    [sym_assert_expression] = STATE(3529),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3529),
    [sym_new_expression] = STATE(3529),
    [sym_typeid_expression] = STATE(3529),
    [sym_is_expression] = STATE(3529),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3529),
    [sym_char_literal] = STATE(3529),
    [sym_array_literal] = STATE(3529),
    [sym_function_literal] = STATE(3529),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3529),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4134),
    [sym_false] = ACTIONS(4134),
    [sym_null] = ACTIONS(4134),
    [sym_super] = ACTIONS(4134),
    [sym_this] = ACTIONS(4134),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4136),
    [sym_float_literal] = ACTIONS(4136),
    [sym__string] = ACTIONS(233),
  },
  [1234] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3637),
    [sym_ternary_expression] = STATE(3637),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3637),
    [sym_binary_expression] = STATE(3637),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1235] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3527),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3527),
    [sym_ternary_expression] = STATE(3527),
    [sym_call_expression] = STATE(3527),
    [sym_primary_expression] = STATE(3527),
    [sym__primary_expr] = STATE(3527),
    [sym_index_expression] = STATE(3527),
    [sym_assignment_expression] = STATE(3527),
    [sym_binary_expression] = STATE(3527),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3527),
    [sym_unary_expression] = STATE(3527),
    [sym__unary_expr] = STATE(3527),
    [sym_property_expression] = STATE(3527),
    [sym_cast_expression] = STATE(3527),
    [sym_delete_expression] = STATE(3527),
    [sym_throw_expression] = STATE(3527),
    [sym_assert_expression] = STATE(3527),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3527),
    [sym_new_expression] = STATE(3527),
    [sym_typeid_expression] = STATE(3527),
    [sym_is_expression] = STATE(3527),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3527),
    [sym_char_literal] = STATE(3527),
    [sym_array_literal] = STATE(3527),
    [sym_function_literal] = STATE(3527),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3527),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4138),
    [sym_false] = ACTIONS(4138),
    [sym_null] = ACTIONS(4138),
    [sym_super] = ACTIONS(4138),
    [sym_this] = ACTIONS(4138),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4140),
    [sym_float_literal] = ACTIONS(4140),
    [sym__string] = ACTIONS(233),
  },
  [1236] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3526),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3526),
    [sym_ternary_expression] = STATE(3526),
    [sym_call_expression] = STATE(3526),
    [sym_primary_expression] = STATE(3526),
    [sym__primary_expr] = STATE(3526),
    [sym_index_expression] = STATE(3526),
    [sym_assignment_expression] = STATE(3526),
    [sym_binary_expression] = STATE(3526),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3526),
    [sym_unary_expression] = STATE(3526),
    [sym__unary_expr] = STATE(3526),
    [sym_property_expression] = STATE(3526),
    [sym_cast_expression] = STATE(3526),
    [sym_delete_expression] = STATE(3526),
    [sym_throw_expression] = STATE(3526),
    [sym_assert_expression] = STATE(3526),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3526),
    [sym_new_expression] = STATE(3526),
    [sym_typeid_expression] = STATE(3526),
    [sym_is_expression] = STATE(3526),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3526),
    [sym_char_literal] = STATE(3526),
    [sym_array_literal] = STATE(3526),
    [sym_function_literal] = STATE(3526),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3526),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4142),
    [sym_false] = ACTIONS(4142),
    [sym_null] = ACTIONS(4142),
    [sym_super] = ACTIONS(4142),
    [sym_this] = ACTIONS(4142),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4144),
    [sym_float_literal] = ACTIONS(4144),
    [sym__string] = ACTIONS(233),
  },
  [1237] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3518),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3518),
    [sym_ternary_expression] = STATE(3518),
    [sym_call_expression] = STATE(3518),
    [sym_primary_expression] = STATE(3518),
    [sym__primary_expr] = STATE(3518),
    [sym_index_expression] = STATE(3518),
    [sym_assignment_expression] = STATE(3518),
    [sym_binary_expression] = STATE(3518),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3518),
    [sym_unary_expression] = STATE(3518),
    [sym__unary_expr] = STATE(3518),
    [sym_property_expression] = STATE(3518),
    [sym_cast_expression] = STATE(3518),
    [sym_delete_expression] = STATE(3518),
    [sym_throw_expression] = STATE(3518),
    [sym_assert_expression] = STATE(3518),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3518),
    [sym_new_expression] = STATE(3518),
    [sym_typeid_expression] = STATE(3518),
    [sym_is_expression] = STATE(3518),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3518),
    [sym_char_literal] = STATE(3518),
    [sym_array_literal] = STATE(3518),
    [sym_function_literal] = STATE(3518),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3518),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4146),
    [sym_false] = ACTIONS(4146),
    [sym_null] = ACTIONS(4146),
    [sym_super] = ACTIONS(4146),
    [sym_this] = ACTIONS(4146),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4148),
    [sym_float_literal] = ACTIONS(4148),
    [sym__string] = ACTIONS(233),
  },
  [1238] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3622),
    [sym_ternary_expression] = STATE(3622),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3622),
    [sym_binary_expression] = STATE(3622),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1239] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3532),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3532),
    [sym_ternary_expression] = STATE(3532),
    [sym_call_expression] = STATE(3532),
    [sym_primary_expression] = STATE(3532),
    [sym__primary_expr] = STATE(3532),
    [sym_index_expression] = STATE(3532),
    [sym_assignment_expression] = STATE(3532),
    [sym_binary_expression] = STATE(3532),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3532),
    [sym_unary_expression] = STATE(3532),
    [sym__unary_expr] = STATE(3532),
    [sym_property_expression] = STATE(3532),
    [sym_cast_expression] = STATE(3532),
    [sym_delete_expression] = STATE(3532),
    [sym_throw_expression] = STATE(3532),
    [sym_assert_expression] = STATE(3532),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3532),
    [sym_new_expression] = STATE(3532),
    [sym_typeid_expression] = STATE(3532),
    [sym_is_expression] = STATE(3532),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3532),
    [sym_char_literal] = STATE(3532),
    [sym_array_literal] = STATE(3532),
    [sym_function_literal] = STATE(3532),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3532),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4150),
    [sym_false] = ACTIONS(4150),
    [sym_null] = ACTIONS(4150),
    [sym_super] = ACTIONS(4150),
    [sym_this] = ACTIONS(4150),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4152),
    [sym_float_literal] = ACTIONS(4152),
    [sym__string] = ACTIONS(233),
  },
  [1240] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3521),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3521),
    [sym_ternary_expression] = STATE(3521),
    [sym_call_expression] = STATE(3521),
    [sym_primary_expression] = STATE(3521),
    [sym__primary_expr] = STATE(3521),
    [sym_index_expression] = STATE(3521),
    [sym_assignment_expression] = STATE(3521),
    [sym_binary_expression] = STATE(3521),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3521),
    [sym_unary_expression] = STATE(3521),
    [sym__unary_expr] = STATE(3521),
    [sym_property_expression] = STATE(3521),
    [sym_cast_expression] = STATE(3521),
    [sym_delete_expression] = STATE(3521),
    [sym_throw_expression] = STATE(3521),
    [sym_assert_expression] = STATE(3521),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3521),
    [sym_new_expression] = STATE(3521),
    [sym_typeid_expression] = STATE(3521),
    [sym_is_expression] = STATE(3521),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3521),
    [sym_char_literal] = STATE(3521),
    [sym_array_literal] = STATE(3521),
    [sym_function_literal] = STATE(3521),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3521),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4154),
    [sym_false] = ACTIONS(4154),
    [sym_null] = ACTIONS(4154),
    [sym_super] = ACTIONS(4154),
    [sym_this] = ACTIONS(4154),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4156),
    [sym_float_literal] = ACTIONS(4156),
    [sym__string] = ACTIONS(233),
  },
  [1241] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3568),
    [sym_ternary_expression] = STATE(3568),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3568),
    [sym_binary_expression] = STATE(3568),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1242] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3414),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym__expr] = STATE(3414),
    [sym_ternary_expression] = STATE(3414),
    [sym_call_expression] = STATE(3414),
    [sym_primary_expression] = STATE(3414),
    [sym__primary_expr] = STATE(3414),
    [sym_index_expression] = STATE(3414),
    [sym_assignment_expression] = STATE(3414),
    [sym_binary_expression] = STATE(3414),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3414),
    [sym_unary_expression] = STATE(3414),
    [sym__unary_expr] = STATE(3414),
    [sym_property_expression] = STATE(3414),
    [sym_cast_expression] = STATE(3414),
    [sym_delete_expression] = STATE(3414),
    [sym_throw_expression] = STATE(3414),
    [sym_assert_expression] = STATE(3414),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3414),
    [sym_new_expression] = STATE(3414),
    [sym_typeid_expression] = STATE(3414),
    [sym_is_expression] = STATE(3414),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3414),
    [sym_char_literal] = STATE(3414),
    [sym_array_literal] = STATE(3414),
    [sym_function_literal] = STATE(3414),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3414),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4158),
    [sym_false] = ACTIONS(4158),
    [sym_null] = ACTIONS(4158),
    [sym_super] = ACTIONS(4158),
    [sym_this] = ACTIONS(4158),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4160),
    [sym_float_literal] = ACTIONS(4160),
    [sym__string] = ACTIONS(233),
  },
  [1243] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3559),
    [sym_ternary_expression] = STATE(3559),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3559),
    [sym_binary_expression] = STATE(3559),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1244] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3452),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3452),
    [sym_ternary_expression] = STATE(3452),
    [sym_call_expression] = STATE(3452),
    [sym_primary_expression] = STATE(3452),
    [sym__primary_expr] = STATE(3452),
    [sym_index_expression] = STATE(3452),
    [sym_assignment_expression] = STATE(3452),
    [sym_binary_expression] = STATE(3452),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3452),
    [sym_unary_expression] = STATE(3452),
    [sym__unary_expr] = STATE(3452),
    [sym_property_expression] = STATE(3452),
    [sym_cast_expression] = STATE(3452),
    [sym_delete_expression] = STATE(3452),
    [sym_throw_expression] = STATE(3452),
    [sym_assert_expression] = STATE(3452),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3452),
    [sym_new_expression] = STATE(3452),
    [sym_typeid_expression] = STATE(3452),
    [sym_is_expression] = STATE(3452),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3452),
    [sym_char_literal] = STATE(3452),
    [sym_array_literal] = STATE(3452),
    [sym_function_literal] = STATE(3452),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3452),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4162),
    [sym_false] = ACTIONS(4162),
    [sym_null] = ACTIONS(4162),
    [sym_super] = ACTIONS(4162),
    [sym_this] = ACTIONS(4162),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4164),
    [sym_float_literal] = ACTIONS(4164),
    [sym__string] = ACTIONS(3370),
  },
  [1245] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3557),
    [sym_ternary_expression] = STATE(3557),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3557),
    [sym_binary_expression] = STATE(3557),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1246] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3645),
    [sym_ternary_expression] = STATE(3645),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3645),
    [sym_binary_expression] = STATE(3645),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1247] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3605),
    [sym_ternary_expression] = STATE(3605),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3605),
    [sym_binary_expression] = STATE(3605),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1248] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3446),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3446),
    [sym_ternary_expression] = STATE(3446),
    [sym_call_expression] = STATE(3446),
    [sym_primary_expression] = STATE(3446),
    [sym__primary_expr] = STATE(3446),
    [sym_index_expression] = STATE(3446),
    [sym_assignment_expression] = STATE(3446),
    [sym_binary_expression] = STATE(3446),
    [sym_logical_or_expression] = STATE(3355),
    [sym_logical_and_expression] = STATE(3355),
    [sym_or_expression] = STATE(3355),
    [sym_xor_expression] = STATE(3355),
    [sym_and_expression] = STATE(3355),
    [sym_equal_expression] = STATE(3355),
    [sym_rel_expression] = STATE(3355),
    [sym_identity_expression] = STATE(3355),
    [sym_add_expression] = STATE(3355),
    [sym_mul_expression] = STATE(3355),
    [sym_shift_expression] = STATE(3355),
    [sym_power_expression] = STATE(3355),
    [sym_postfix_expression] = STATE(3446),
    [sym_unary_expression] = STATE(3446),
    [sym__unary_expr] = STATE(3446),
    [sym_property_expression] = STATE(3446),
    [sym_cast_expression] = STATE(3446),
    [sym_delete_expression] = STATE(3446),
    [sym_throw_expression] = STATE(3446),
    [sym_assert_expression] = STATE(3446),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3446),
    [sym_new_expression] = STATE(3446),
    [sym_typeid_expression] = STATE(3446),
    [sym_is_expression] = STATE(3446),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3446),
    [sym_char_literal] = STATE(3446),
    [sym_array_literal] = STATE(3446),
    [sym_function_literal] = STATE(3446),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3446),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4166),
    [sym_false] = ACTIONS(4166),
    [sym_null] = ACTIONS(4166),
    [sym_super] = ACTIONS(4166),
    [sym_this] = ACTIONS(4166),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4168),
    [sym_float_literal] = ACTIONS(4168),
    [sym__string] = ACTIONS(3370),
  },
  [1249] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3519),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym__expr] = STATE(3519),
    [sym_ternary_expression] = STATE(3519),
    [sym_call_expression] = STATE(3519),
    [sym_primary_expression] = STATE(3519),
    [sym__primary_expr] = STATE(3519),
    [sym_index_expression] = STATE(3519),
    [sym_assignment_expression] = STATE(3519),
    [sym_binary_expression] = STATE(3519),
    [sym_logical_or_expression] = STATE(3250),
    [sym_logical_and_expression] = STATE(3250),
    [sym_or_expression] = STATE(3250),
    [sym_xor_expression] = STATE(3250),
    [sym_and_expression] = STATE(3250),
    [sym_equal_expression] = STATE(3250),
    [sym_rel_expression] = STATE(3250),
    [sym_identity_expression] = STATE(3250),
    [sym_add_expression] = STATE(3250),
    [sym_mul_expression] = STATE(3250),
    [sym_shift_expression] = STATE(3250),
    [sym_power_expression] = STATE(3250),
    [sym_postfix_expression] = STATE(3519),
    [sym_unary_expression] = STATE(3519),
    [sym__unary_expr] = STATE(3519),
    [sym_property_expression] = STATE(3519),
    [sym_cast_expression] = STATE(3519),
    [sym_delete_expression] = STATE(3519),
    [sym_throw_expression] = STATE(3519),
    [sym_assert_expression] = STATE(3519),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3519),
    [sym_new_expression] = STATE(3519),
    [sym_typeid_expression] = STATE(3519),
    [sym_is_expression] = STATE(3519),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3519),
    [sym_char_literal] = STATE(3519),
    [sym_array_literal] = STATE(3519),
    [sym_function_literal] = STATE(3519),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3519),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4170),
    [sym_false] = ACTIONS(4170),
    [sym_null] = ACTIONS(4170),
    [sym_super] = ACTIONS(4170),
    [sym_this] = ACTIONS(4170),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4172),
    [sym_float_literal] = ACTIONS(4172),
    [sym__string] = ACTIONS(233),
  },
  [1250] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3485),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3485),
    [sym_ternary_expression] = STATE(3485),
    [sym_call_expression] = STATE(3485),
    [sym_primary_expression] = STATE(3485),
    [sym__primary_expr] = STATE(3485),
    [sym_index_expression] = STATE(3485),
    [sym_assignment_expression] = STATE(3485),
    [sym_binary_expression] = STATE(3485),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3485),
    [sym_unary_expression] = STATE(3485),
    [sym__unary_expr] = STATE(3485),
    [sym_property_expression] = STATE(3485),
    [sym_cast_expression] = STATE(3485),
    [sym_delete_expression] = STATE(3485),
    [sym_throw_expression] = STATE(3485),
    [sym_assert_expression] = STATE(3485),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3485),
    [sym_new_expression] = STATE(3485),
    [sym_typeid_expression] = STATE(3485),
    [sym_is_expression] = STATE(3485),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3485),
    [sym_char_literal] = STATE(3485),
    [sym_array_literal] = STATE(3485),
    [sym_function_literal] = STATE(3485),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3485),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4174),
    [sym_false] = ACTIONS(4174),
    [sym_null] = ACTIONS(4174),
    [sym_super] = ACTIONS(4174),
    [sym_this] = ACTIONS(4174),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4176),
    [sym_float_literal] = ACTIONS(4176),
    [sym__string] = ACTIONS(3774),
  },
  [1251] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3563),
    [sym_ternary_expression] = STATE(3563),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3563),
    [sym_binary_expression] = STATE(3563),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1252] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3565),
    [sym_ternary_expression] = STATE(3565),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3565),
    [sym_binary_expression] = STATE(3565),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1253] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3554),
    [sym_ternary_expression] = STATE(3554),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3554),
    [sym_binary_expression] = STATE(3554),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1254] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3675),
    [sym_ternary_expression] = STATE(3675),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3675),
    [sym_binary_expression] = STATE(3675),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1255] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3466),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3466),
    [sym_ternary_expression] = STATE(3466),
    [sym_call_expression] = STATE(3466),
    [sym_primary_expression] = STATE(3466),
    [sym__primary_expr] = STATE(3466),
    [sym_index_expression] = STATE(3466),
    [sym_assignment_expression] = STATE(3466),
    [sym_binary_expression] = STATE(3466),
    [sym_logical_or_expression] = STATE(3456),
    [sym_logical_and_expression] = STATE(3456),
    [sym_or_expression] = STATE(3456),
    [sym_xor_expression] = STATE(3456),
    [sym_and_expression] = STATE(3456),
    [sym_equal_expression] = STATE(3456),
    [sym_rel_expression] = STATE(3456),
    [sym_identity_expression] = STATE(3456),
    [sym_add_expression] = STATE(3456),
    [sym_mul_expression] = STATE(3456),
    [sym_shift_expression] = STATE(3456),
    [sym_power_expression] = STATE(3456),
    [sym_postfix_expression] = STATE(3466),
    [sym_unary_expression] = STATE(3466),
    [sym__unary_expr] = STATE(3466),
    [sym_property_expression] = STATE(3466),
    [sym_cast_expression] = STATE(3466),
    [sym_delete_expression] = STATE(3466),
    [sym_throw_expression] = STATE(3466),
    [sym_assert_expression] = STATE(3466),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3466),
    [sym_new_expression] = STATE(3466),
    [sym_typeid_expression] = STATE(3466),
    [sym_is_expression] = STATE(3466),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3466),
    [sym_char_literal] = STATE(3466),
    [sym_array_literal] = STATE(3466),
    [sym_function_literal] = STATE(3466),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3466),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4178),
    [sym_false] = ACTIONS(4178),
    [sym_null] = ACTIONS(4178),
    [sym_super] = ACTIONS(4178),
    [sym_this] = ACTIONS(4178),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4180),
    [sym_float_literal] = ACTIONS(4180),
    [sym__string] = ACTIONS(3774),
  },
  [1256] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3613),
    [sym_ternary_expression] = STATE(3613),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3613),
    [sym_binary_expression] = STATE(3613),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1257] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3615),
    [sym_ternary_expression] = STATE(3615),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3615),
    [sym_binary_expression] = STATE(3615),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1258] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3566),
    [sym_ternary_expression] = STATE(3566),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3566),
    [sym_binary_expression] = STATE(3566),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1259] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3567),
    [sym_ternary_expression] = STATE(3567),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3567),
    [sym_binary_expression] = STATE(3567),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1260] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3569),
    [sym_ternary_expression] = STATE(3569),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3569),
    [sym_binary_expression] = STATE(3569),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1261] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3571),
    [sym_ternary_expression] = STATE(3571),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3571),
    [sym_binary_expression] = STATE(3571),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1262] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3551),
    [sym_ternary_expression] = STATE(3551),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3551),
    [sym_binary_expression] = STATE(3551),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1263] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3674),
    [sym_ternary_expression] = STATE(3674),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3674),
    [sym_binary_expression] = STATE(3674),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1264] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3572),
    [sym_ternary_expression] = STATE(3572),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3572),
    [sym_binary_expression] = STATE(3572),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1265] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3370),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym__expr] = STATE(3589),
    [sym_ternary_expression] = STATE(3589),
    [sym_call_expression] = STATE(3370),
    [sym_primary_expression] = STATE(3370),
    [sym__primary_expr] = STATE(3370),
    [sym_index_expression] = STATE(3370),
    [sym_assignment_expression] = STATE(3589),
    [sym_binary_expression] = STATE(3589),
    [sym_logical_or_expression] = STATE(3597),
    [sym_logical_and_expression] = STATE(3597),
    [sym_or_expression] = STATE(3597),
    [sym_xor_expression] = STATE(3597),
    [sym_and_expression] = STATE(3597),
    [sym_equal_expression] = STATE(3597),
    [sym_rel_expression] = STATE(3597),
    [sym_identity_expression] = STATE(3597),
    [sym_add_expression] = STATE(3597),
    [sym_mul_expression] = STATE(3597),
    [sym_shift_expression] = STATE(3597),
    [sym_power_expression] = STATE(3597),
    [sym_postfix_expression] = STATE(3370),
    [sym_unary_expression] = STATE(3370),
    [sym__unary_expr] = STATE(3370),
    [sym_property_expression] = STATE(3370),
    [sym_cast_expression] = STATE(3370),
    [sym_delete_expression] = STATE(3370),
    [sym_throw_expression] = STATE(3370),
    [sym_assert_expression] = STATE(3370),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3370),
    [sym_new_expression] = STATE(3370),
    [sym_typeid_expression] = STATE(3370),
    [sym_is_expression] = STATE(3370),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3370),
    [sym_char_literal] = STATE(3370),
    [sym_array_literal] = STATE(3370),
    [sym_function_literal] = STATE(3370),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3370),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(3724),
    [sym_false] = ACTIONS(3724),
    [sym_null] = ACTIONS(3724),
    [sym_super] = ACTIONS(3724),
    [sym_this] = ACTIONS(3724),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3772),
    [sym_float_literal] = ACTIONS(3772),
    [sym__string] = ACTIONS(3774),
  },
  [1266] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3538),
    [sym_ternary_expression] = STATE(3538),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3538),
    [sym_binary_expression] = STATE(3538),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1267] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3616),
    [sym_ternary_expression] = STATE(3616),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3616),
    [sym_binary_expression] = STATE(3616),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1268] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3275),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym__expr] = STATE(3579),
    [sym_ternary_expression] = STATE(3579),
    [sym_call_expression] = STATE(3275),
    [sym_primary_expression] = STATE(3275),
    [sym__primary_expr] = STATE(3275),
    [sym_index_expression] = STATE(3275),
    [sym_assignment_expression] = STATE(3579),
    [sym_binary_expression] = STATE(3579),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3275),
    [sym_unary_expression] = STATE(3275),
    [sym__unary_expr] = STATE(3275),
    [sym_property_expression] = STATE(3275),
    [sym_cast_expression] = STATE(3275),
    [sym_delete_expression] = STATE(3275),
    [sym_throw_expression] = STATE(3275),
    [sym_assert_expression] = STATE(3275),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3275),
    [sym_new_expression] = STATE(3275),
    [sym_typeid_expression] = STATE(3275),
    [sym_is_expression] = STATE(3275),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3275),
    [sym_char_literal] = STATE(3275),
    [sym_array_literal] = STATE(3275),
    [sym_function_literal] = STATE(3275),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3275),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(3314),
    [sym_false] = ACTIONS(3314),
    [sym_null] = ACTIONS(3314),
    [sym_super] = ACTIONS(3314),
    [sym_this] = ACTIONS(3314),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3368),
    [sym_float_literal] = ACTIONS(3368),
    [sym__string] = ACTIONS(3370),
  },
  [1269] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3074),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym__expr] = STATE(3620),
    [sym_ternary_expression] = STATE(3620),
    [sym_call_expression] = STATE(3074),
    [sym_primary_expression] = STATE(3074),
    [sym__primary_expr] = STATE(3074),
    [sym_index_expression] = STATE(3074),
    [sym_assignment_expression] = STATE(3620),
    [sym_binary_expression] = STATE(3620),
    [sym_logical_or_expression] = STATE(3505),
    [sym_logical_and_expression] = STATE(3505),
    [sym_or_expression] = STATE(3505),
    [sym_xor_expression] = STATE(3505),
    [sym_and_expression] = STATE(3505),
    [sym_equal_expression] = STATE(3505),
    [sym_rel_expression] = STATE(3505),
    [sym_identity_expression] = STATE(3505),
    [sym_add_expression] = STATE(3505),
    [sym_mul_expression] = STATE(3505),
    [sym_shift_expression] = STATE(3505),
    [sym_power_expression] = STATE(3505),
    [sym_postfix_expression] = STATE(3074),
    [sym_unary_expression] = STATE(3074),
    [sym__unary_expr] = STATE(3074),
    [sym_property_expression] = STATE(3074),
    [sym_cast_expression] = STATE(3074),
    [sym_delete_expression] = STATE(3074),
    [sym_throw_expression] = STATE(3074),
    [sym_assert_expression] = STATE(3074),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3074),
    [sym_new_expression] = STATE(3074),
    [sym_typeid_expression] = STATE(3074),
    [sym_is_expression] = STATE(3074),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3074),
    [sym_char_literal] = STATE(3074),
    [sym_array_literal] = STATE(3074),
    [sym_function_literal] = STATE(3074),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3074),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(105),
    [sym_false] = ACTIONS(105),
    [sym_null] = ACTIONS(105),
    [sym_super] = ACTIONS(105),
    [sym_this] = ACTIONS(105),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(231),
    [sym_float_literal] = ACTIONS(231),
    [sym__string] = ACTIONS(233),
  },
  [1270] = {
    [sym_catch_statement] = STATE(1272),
    [sym_finally_statement] = STATE(1622),
    [aux_sym_try_statement_repeat1] = STATE(1272),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [anon_sym_AT] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_abstract] = ACTIONS(4182),
    [sym_alias] = ACTIONS(4182),
    [sym_align] = ACTIONS(4182),
    [sym_asm] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_break] = ACTIONS(4182),
    [sym_case] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(4186),
    [sym_class] = ACTIONS(4182),
    [sym_const] = ACTIONS(4182),
    [sym_continue] = ACTIONS(4182),
    [sym_debug] = ACTIONS(4182),
    [sym_default] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_deprecated] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_else] = ACTIONS(4182),
    [sym_enum] = ACTIONS(4182),
    [sym_export] = ACTIONS(4182),
    [sym_extern] = ACTIONS(4182),
    [sym_final] = ACTIONS(4182),
    [sym_finally] = ACTIONS(4188),
    [sym_for] = ACTIONS(4182),
    [sym_foreach] = ACTIONS(4182),
    [sym_foreach_reverse] = ACTIONS(4182),
    [sym_function] = ACTIONS(4182),
    [sym_goto] = ACTIONS(4182),
    [sym_if] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_interface] = ACTIONS(4182),
    [sym_invariant] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_nothrow] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_override] = ACTIONS(4182),
    [sym_package] = ACTIONS(4182),
    [sym_pragma] = ACTIONS(4182),
    [sym_private] = ACTIONS(4182),
    [sym_protected] = ACTIONS(4182),
    [sym_public] = ACTIONS(4182),
    [sym_pure] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_return] = ACTIONS(4182),
    [sym_scope] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_static] = ACTIONS(4182),
    [sym_struct] = ACTIONS(4182),
    [sym_switch] = ACTIONS(4182),
    [sym_synchronized] = ACTIONS(4182),
    [sym_template] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_try] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_union] = ACTIONS(4182),
    [sym_unittest] = ACTIONS(4182),
    [sym_version] = ACTIONS(4182),
    [sym_while] = ACTIONS(4182),
    [sym_with] = ACTIONS(4182),
    [sym_gshared] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1271] = {
    [sym_catch_statement] = STATE(1274),
    [sym_finally_statement] = STATE(1451),
    [aux_sym_try_statement_repeat1] = STATE(1274),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_abstract] = ACTIONS(4190),
    [sym_alias] = ACTIONS(4190),
    [sym_align] = ACTIONS(4190),
    [sym_asm] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_break] = ACTIONS(4190),
    [sym_case] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(4186),
    [sym_class] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_continue] = ACTIONS(4190),
    [sym_debug] = ACTIONS(4190),
    [sym_default] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_deprecated] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_enum] = ACTIONS(4190),
    [sym_export] = ACTIONS(4190),
    [sym_extern] = ACTIONS(4190),
    [sym_final] = ACTIONS(4190),
    [sym_finally] = ACTIONS(4194),
    [sym_for] = ACTIONS(4190),
    [sym_foreach] = ACTIONS(4190),
    [sym_foreach_reverse] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_goto] = ACTIONS(4190),
    [sym_if] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_interface] = ACTIONS(4190),
    [sym_invariant] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_nothrow] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_override] = ACTIONS(4190),
    [sym_package] = ACTIONS(4190),
    [sym_pragma] = ACTIONS(4190),
    [sym_private] = ACTIONS(4190),
    [sym_protected] = ACTIONS(4190),
    [sym_public] = ACTIONS(4190),
    [sym_pure] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_return] = ACTIONS(4190),
    [sym_scope] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_static] = ACTIONS(4190),
    [sym_struct] = ACTIONS(4190),
    [sym_switch] = ACTIONS(4190),
    [sym_synchronized] = ACTIONS(4190),
    [sym_template] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_try] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_union] = ACTIONS(4190),
    [sym_unittest] = ACTIONS(4190),
    [sym_version] = ACTIONS(4190),
    [sym_while] = ACTIONS(4190),
    [sym_with] = ACTIONS(4190),
    [sym_gshared] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1272] = {
    [sym_catch_statement] = STATE(1274),
    [sym_finally_statement] = STATE(1525),
    [aux_sym_try_statement_repeat1] = STATE(1274),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_abstract] = ACTIONS(4190),
    [sym_alias] = ACTIONS(4190),
    [sym_align] = ACTIONS(4190),
    [sym_asm] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_break] = ACTIONS(4190),
    [sym_case] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(4186),
    [sym_class] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_continue] = ACTIONS(4190),
    [sym_debug] = ACTIONS(4190),
    [sym_default] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_deprecated] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_enum] = ACTIONS(4190),
    [sym_export] = ACTIONS(4190),
    [sym_extern] = ACTIONS(4190),
    [sym_final] = ACTIONS(4190),
    [sym_finally] = ACTIONS(4188),
    [sym_for] = ACTIONS(4190),
    [sym_foreach] = ACTIONS(4190),
    [sym_foreach_reverse] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_goto] = ACTIONS(4190),
    [sym_if] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_interface] = ACTIONS(4190),
    [sym_invariant] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_nothrow] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_override] = ACTIONS(4190),
    [sym_package] = ACTIONS(4190),
    [sym_pragma] = ACTIONS(4190),
    [sym_private] = ACTIONS(4190),
    [sym_protected] = ACTIONS(4190),
    [sym_public] = ACTIONS(4190),
    [sym_pure] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_return] = ACTIONS(4190),
    [sym_scope] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_static] = ACTIONS(4190),
    [sym_struct] = ACTIONS(4190),
    [sym_switch] = ACTIONS(4190),
    [sym_synchronized] = ACTIONS(4190),
    [sym_template] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_try] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_union] = ACTIONS(4190),
    [sym_unittest] = ACTIONS(4190),
    [sym_version] = ACTIONS(4190),
    [sym_while] = ACTIONS(4190),
    [sym_with] = ACTIONS(4190),
    [sym_gshared] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1273] = {
    [sym_catch_statement] = STATE(1271),
    [sym_finally_statement] = STATE(1333),
    [aux_sym_try_statement_repeat1] = STATE(1271),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [anon_sym_AT] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_abstract] = ACTIONS(4182),
    [sym_alias] = ACTIONS(4182),
    [sym_align] = ACTIONS(4182),
    [sym_asm] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_break] = ACTIONS(4182),
    [sym_case] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(4186),
    [sym_class] = ACTIONS(4182),
    [sym_const] = ACTIONS(4182),
    [sym_continue] = ACTIONS(4182),
    [sym_debug] = ACTIONS(4182),
    [sym_default] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_deprecated] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_else] = ACTIONS(4182),
    [sym_enum] = ACTIONS(4182),
    [sym_export] = ACTIONS(4182),
    [sym_extern] = ACTIONS(4182),
    [sym_final] = ACTIONS(4182),
    [sym_finally] = ACTIONS(4194),
    [sym_for] = ACTIONS(4182),
    [sym_foreach] = ACTIONS(4182),
    [sym_foreach_reverse] = ACTIONS(4182),
    [sym_function] = ACTIONS(4182),
    [sym_goto] = ACTIONS(4182),
    [sym_if] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_interface] = ACTIONS(4182),
    [sym_invariant] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_nothrow] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_override] = ACTIONS(4182),
    [sym_package] = ACTIONS(4182),
    [sym_pragma] = ACTIONS(4182),
    [sym_private] = ACTIONS(4182),
    [sym_protected] = ACTIONS(4182),
    [sym_public] = ACTIONS(4182),
    [sym_pure] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_return] = ACTIONS(4182),
    [sym_scope] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_static] = ACTIONS(4182),
    [sym_struct] = ACTIONS(4182),
    [sym_switch] = ACTIONS(4182),
    [sym_synchronized] = ACTIONS(4182),
    [sym_template] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_try] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_union] = ACTIONS(4182),
    [sym_unittest] = ACTIONS(4182),
    [sym_version] = ACTIONS(4182),
    [sym_while] = ACTIONS(4182),
    [sym_with] = ACTIONS(4182),
    [sym_gshared] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1274] = {
    [sym_catch_statement] = STATE(1274),
    [aux_sym_try_statement_repeat1] = STATE(1274),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_q_LBRACE] = ACTIONS(4198),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_DOT] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_DOLLAR] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [anon_sym_AT] = ACTIONS(4198),
    [sym_bool] = ACTIONS(4196),
    [sym_byte] = ACTIONS(4196),
    [sym_ubyte] = ACTIONS(4196),
    [sym_char] = ACTIONS(4196),
    [sym_short] = ACTIONS(4196),
    [sym_ushort] = ACTIONS(4196),
    [sym_int] = ACTIONS(4196),
    [sym_uint] = ACTIONS(4196),
    [sym_long] = ACTIONS(4196),
    [sym_ulong] = ACTIONS(4196),
    [sym_cent] = ACTIONS(4196),
    [sym_ucent] = ACTIONS(4196),
    [sym_wchar] = ACTIONS(4196),
    [sym_dchar] = ACTIONS(4196),
    [sym_float] = ACTIONS(4196),
    [sym_double] = ACTIONS(4196),
    [sym_real] = ACTIONS(4196),
    [sym_ifloat] = ACTIONS(4196),
    [sym_idouble] = ACTIONS(4196),
    [sym_ireal] = ACTIONS(4196),
    [sym_cfloat] = ACTIONS(4196),
    [sym_cdouble] = ACTIONS(4196),
    [sym_creal] = ACTIONS(4196),
    [sym_size_t] = ACTIONS(4196),
    [sym_ptrdiff_t] = ACTIONS(4196),
    [sym_string] = ACTIONS(4196),
    [sym_cstring] = ACTIONS(4196),
    [sym_dstring] = ACTIONS(4196),
    [sym_wstring] = ACTIONS(4196),
    [sym_noreturn] = ACTIONS(4196),
    [sym_true] = ACTIONS(4196),
    [sym_false] = ACTIONS(4196),
    [sym_null] = ACTIONS(4196),
    [sym_super] = ACTIONS(4196),
    [sym_this] = ACTIONS(4196),
    [sym_abstract] = ACTIONS(4196),
    [sym_alias] = ACTIONS(4196),
    [sym_align] = ACTIONS(4196),
    [sym_asm] = ACTIONS(4196),
    [sym_assert] = ACTIONS(4196),
    [sym_auto] = ACTIONS(4196),
    [sym_break] = ACTIONS(4196),
    [sym_case] = ACTIONS(4196),
    [sym_cast] = ACTIONS(4196),
    [sym_catch] = ACTIONS(4200),
    [sym_class] = ACTIONS(4196),
    [sym_const] = ACTIONS(4196),
    [sym_continue] = ACTIONS(4196),
    [sym_debug] = ACTIONS(4196),
    [sym_default] = ACTIONS(4196),
    [sym_delegate] = ACTIONS(4196),
    [sym_delete] = ACTIONS(4196),
    [sym_deprecated] = ACTIONS(4196),
    [sym_do] = ACTIONS(4196),
    [sym_else] = ACTIONS(4196),
    [sym_enum] = ACTIONS(4196),
    [sym_export] = ACTIONS(4196),
    [sym_extern] = ACTIONS(4196),
    [sym_final] = ACTIONS(4196),
    [sym_finally] = ACTIONS(4196),
    [sym_for] = ACTIONS(4196),
    [sym_foreach] = ACTIONS(4196),
    [sym_foreach_reverse] = ACTIONS(4196),
    [sym_function] = ACTIONS(4196),
    [sym_goto] = ACTIONS(4196),
    [sym_if] = ACTIONS(4196),
    [sym_immutable] = ACTIONS(4196),
    [sym_import] = ACTIONS(4196),
    [sym_in] = ACTIONS(4196),
    [sym_inout] = ACTIONS(4196),
    [sym_interface] = ACTIONS(4196),
    [sym_invariant] = ACTIONS(4196),
    [sym_is] = ACTIONS(4196),
    [sym_mixin] = ACTIONS(4196),
    [sym_new] = ACTIONS(4196),
    [sym_nothrow] = ACTIONS(4196),
    [sym_out] = ACTIONS(4196),
    [sym_override] = ACTIONS(4196),
    [sym_package] = ACTIONS(4196),
    [sym_pragma] = ACTIONS(4196),
    [sym_private] = ACTIONS(4196),
    [sym_protected] = ACTIONS(4196),
    [sym_public] = ACTIONS(4196),
    [sym_pure] = ACTIONS(4196),
    [sym_ref] = ACTIONS(4196),
    [sym_return] = ACTIONS(4196),
    [sym_scope] = ACTIONS(4196),
    [sym_shared] = ACTIONS(4196),
    [sym_static] = ACTIONS(4196),
    [sym_struct] = ACTIONS(4196),
    [sym_switch] = ACTIONS(4196),
    [sym_synchronized] = ACTIONS(4196),
    [sym_template] = ACTIONS(4196),
    [sym_throw] = ACTIONS(4196),
    [sym_try] = ACTIONS(4196),
    [sym_typeid] = ACTIONS(4196),
    [sym_typeof] = ACTIONS(4196),
    [sym_union] = ACTIONS(4196),
    [sym_unittest] = ACTIONS(4196),
    [sym_version] = ACTIONS(4196),
    [sym_while] = ACTIONS(4196),
    [sym_with] = ACTIONS(4196),
    [sym_gshared] = ACTIONS(4196),
    [sym_traits] = ACTIONS(4196),
    [sym_vector] = ACTIONS(4196),
    [sym_void] = ACTIONS(4196),
    [anon_sym_BQUOTE] = ACTIONS(4198),
    [anon_sym_r_DQUOTE] = ACTIONS(4198),
    [anon_sym_x_DQUOTE] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(4198),
    [anon_sym_i_BQUOTE] = ACTIONS(4198),
    [anon_sym_i_DQUOTE] = ACTIONS(4198),
    [anon_sym_iq_LBRACE] = ACTIONS(4198),
    [aux_sym_char_literal_token1] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4196),
    [anon_sym___DATE__] = ACTIONS(4196),
    [anon_sym___FILE__] = ACTIONS(4196),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4196),
    [anon_sym___FUNCTION__] = ACTIONS(4196),
    [anon_sym___LINE__] = ACTIONS(4196),
    [anon_sym___MODULE__] = ACTIONS(4196),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4196),
    [anon_sym___TIME__] = ACTIONS(4196),
    [anon_sym___TIMESTAMP__] = ACTIONS(4196),
    [anon_sym___VENDOR__] = ACTIONS(4196),
    [anon_sym___VERSION__] = ACTIONS(4196),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4198),
    [sym_float_literal] = ACTIONS(4198),
    [sym__string] = ACTIONS(4198),
  },
  [1275] = {
    [sym_catch_statement] = STATE(1277),
    [sym_finally_statement] = STATE(1333),
    [aux_sym_try_statement_repeat1] = STATE(1277),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [anon_sym_AT] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_abstract] = ACTIONS(4182),
    [sym_alias] = ACTIONS(4182),
    [sym_align] = ACTIONS(4182),
    [sym_asm] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_break] = ACTIONS(4182),
    [sym_case] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(4203),
    [sym_class] = ACTIONS(4182),
    [sym_const] = ACTIONS(4182),
    [sym_continue] = ACTIONS(4182),
    [sym_debug] = ACTIONS(4182),
    [sym_default] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_deprecated] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_enum] = ACTIONS(4182),
    [sym_export] = ACTIONS(4182),
    [sym_extern] = ACTIONS(4182),
    [sym_final] = ACTIONS(4182),
    [sym_finally] = ACTIONS(4205),
    [sym_for] = ACTIONS(4182),
    [sym_foreach] = ACTIONS(4182),
    [sym_foreach_reverse] = ACTIONS(4182),
    [sym_function] = ACTIONS(4182),
    [sym_goto] = ACTIONS(4182),
    [sym_if] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_interface] = ACTIONS(4182),
    [sym_invariant] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_nothrow] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_override] = ACTIONS(4182),
    [sym_package] = ACTIONS(4182),
    [sym_pragma] = ACTIONS(4182),
    [sym_private] = ACTIONS(4182),
    [sym_protected] = ACTIONS(4182),
    [sym_public] = ACTIONS(4182),
    [sym_pure] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_return] = ACTIONS(4182),
    [sym_scope] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_static] = ACTIONS(4182),
    [sym_struct] = ACTIONS(4182),
    [sym_switch] = ACTIONS(4182),
    [sym_synchronized] = ACTIONS(4182),
    [sym_template] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_try] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_union] = ACTIONS(4182),
    [sym_unittest] = ACTIONS(4182),
    [sym_version] = ACTIONS(4182),
    [sym_while] = ACTIONS(4182),
    [sym_with] = ACTIONS(4182),
    [sym_gshared] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1276] = {
    [sym_catch_statement] = STATE(1304),
    [sym_finally_statement] = STATE(1525),
    [aux_sym_try_statement_repeat1] = STATE(1304),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_abstract] = ACTIONS(4190),
    [sym_alias] = ACTIONS(4190),
    [sym_align] = ACTIONS(4190),
    [sym_asm] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_break] = ACTIONS(4190),
    [sym_case] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(4203),
    [sym_class] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_continue] = ACTIONS(4190),
    [sym_debug] = ACTIONS(4190),
    [sym_default] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_deprecated] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_enum] = ACTIONS(4190),
    [sym_export] = ACTIONS(4190),
    [sym_extern] = ACTIONS(4190),
    [sym_final] = ACTIONS(4190),
    [sym_finally] = ACTIONS(4207),
    [sym_for] = ACTIONS(4190),
    [sym_foreach] = ACTIONS(4190),
    [sym_foreach_reverse] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_goto] = ACTIONS(4190),
    [sym_if] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_interface] = ACTIONS(4190),
    [sym_invariant] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_nothrow] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_override] = ACTIONS(4190),
    [sym_package] = ACTIONS(4190),
    [sym_pragma] = ACTIONS(4190),
    [sym_private] = ACTIONS(4190),
    [sym_protected] = ACTIONS(4190),
    [sym_public] = ACTIONS(4190),
    [sym_pure] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_return] = ACTIONS(4190),
    [sym_scope] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_static] = ACTIONS(4190),
    [sym_struct] = ACTIONS(4190),
    [sym_switch] = ACTIONS(4190),
    [sym_synchronized] = ACTIONS(4190),
    [sym_template] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_try] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_union] = ACTIONS(4190),
    [sym_unittest] = ACTIONS(4190),
    [sym_version] = ACTIONS(4190),
    [sym_while] = ACTIONS(4190),
    [sym_with] = ACTIONS(4190),
    [sym_gshared] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1277] = {
    [sym_catch_statement] = STATE(1304),
    [sym_finally_statement] = STATE(1451),
    [aux_sym_try_statement_repeat1] = STATE(1304),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_abstract] = ACTIONS(4190),
    [sym_alias] = ACTIONS(4190),
    [sym_align] = ACTIONS(4190),
    [sym_asm] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_break] = ACTIONS(4190),
    [sym_case] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(4203),
    [sym_class] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_continue] = ACTIONS(4190),
    [sym_debug] = ACTIONS(4190),
    [sym_default] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_deprecated] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_enum] = ACTIONS(4190),
    [sym_export] = ACTIONS(4190),
    [sym_extern] = ACTIONS(4190),
    [sym_final] = ACTIONS(4190),
    [sym_finally] = ACTIONS(4205),
    [sym_for] = ACTIONS(4190),
    [sym_foreach] = ACTIONS(4190),
    [sym_foreach_reverse] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_goto] = ACTIONS(4190),
    [sym_if] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_interface] = ACTIONS(4190),
    [sym_invariant] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_nothrow] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_override] = ACTIONS(4190),
    [sym_package] = ACTIONS(4190),
    [sym_pragma] = ACTIONS(4190),
    [sym_private] = ACTIONS(4190),
    [sym_protected] = ACTIONS(4190),
    [sym_public] = ACTIONS(4190),
    [sym_pure] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_return] = ACTIONS(4190),
    [sym_scope] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_static] = ACTIONS(4190),
    [sym_struct] = ACTIONS(4190),
    [sym_switch] = ACTIONS(4190),
    [sym_synchronized] = ACTIONS(4190),
    [sym_template] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_try] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_union] = ACTIONS(4190),
    [sym_unittest] = ACTIONS(4190),
    [sym_version] = ACTIONS(4190),
    [sym_while] = ACTIONS(4190),
    [sym_with] = ACTIONS(4190),
    [sym_gshared] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1278] = {
    [sym_catch_statement] = STATE(1276),
    [sym_finally_statement] = STATE(1622),
    [aux_sym_try_statement_repeat1] = STATE(1276),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [anon_sym_AT] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_abstract] = ACTIONS(4182),
    [sym_alias] = ACTIONS(4182),
    [sym_align] = ACTIONS(4182),
    [sym_asm] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_break] = ACTIONS(4182),
    [sym_case] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(4203),
    [sym_class] = ACTIONS(4182),
    [sym_const] = ACTIONS(4182),
    [sym_continue] = ACTIONS(4182),
    [sym_debug] = ACTIONS(4182),
    [sym_default] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_deprecated] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_enum] = ACTIONS(4182),
    [sym_export] = ACTIONS(4182),
    [sym_extern] = ACTIONS(4182),
    [sym_final] = ACTIONS(4182),
    [sym_finally] = ACTIONS(4207),
    [sym_for] = ACTIONS(4182),
    [sym_foreach] = ACTIONS(4182),
    [sym_foreach_reverse] = ACTIONS(4182),
    [sym_function] = ACTIONS(4182),
    [sym_goto] = ACTIONS(4182),
    [sym_if] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_interface] = ACTIONS(4182),
    [sym_invariant] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_nothrow] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_override] = ACTIONS(4182),
    [sym_package] = ACTIONS(4182),
    [sym_pragma] = ACTIONS(4182),
    [sym_private] = ACTIONS(4182),
    [sym_protected] = ACTIONS(4182),
    [sym_public] = ACTIONS(4182),
    [sym_pure] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_return] = ACTIONS(4182),
    [sym_scope] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_static] = ACTIONS(4182),
    [sym_struct] = ACTIONS(4182),
    [sym_switch] = ACTIONS(4182),
    [sym_synchronized] = ACTIONS(4182),
    [sym_template] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_try] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_union] = ACTIONS(4182),
    [sym_unittest] = ACTIONS(4182),
    [sym_version] = ACTIONS(4182),
    [sym_while] = ACTIONS(4182),
    [sym_with] = ACTIONS(4182),
    [sym_gshared] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1279] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3152),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3152),
    [sym_primary_expression] = STATE(3152),
    [sym__primary_expr] = STATE(3152),
    [sym_index_expression] = STATE(3152),
    [sym_postfix_expression] = STATE(3152),
    [sym_unary_expression] = STATE(3152),
    [sym__unary_expr] = STATE(3152),
    [sym_property_expression] = STATE(3152),
    [sym_cast_expression] = STATE(3152),
    [sym_delete_expression] = STATE(3152),
    [sym_throw_expression] = STATE(3152),
    [sym_assert_expression] = STATE(3152),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3152),
    [sym_new_expression] = STATE(3152),
    [sym_typeid_expression] = STATE(3152),
    [sym_is_expression] = STATE(3152),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3152),
    [sym_char_literal] = STATE(3152),
    [sym_array_literal] = STATE(3152),
    [sym_function_literal] = STATE(3152),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3152),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4209),
    [sym_false] = ACTIONS(4209),
    [sym_null] = ACTIONS(4209),
    [sym_super] = ACTIONS(4209),
    [sym_this] = ACTIONS(4209),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4211),
    [sym_float_literal] = ACTIONS(4211),
    [sym__string] = ACTIONS(233),
  },
  [1280] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4215),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1281] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3316),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3316),
    [sym_primary_expression] = STATE(3316),
    [sym__primary_expr] = STATE(3316),
    [sym_index_expression] = STATE(3316),
    [sym_postfix_expression] = STATE(3316),
    [sym_unary_expression] = STATE(3316),
    [sym__unary_expr] = STATE(3316),
    [sym_property_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_throw_expression] = STATE(3316),
    [sym_assert_expression] = STATE(3316),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_typeid_expression] = STATE(3316),
    [sym_is_expression] = STATE(3316),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3316),
    [sym_char_literal] = STATE(3316),
    [sym_array_literal] = STATE(3316),
    [sym_function_literal] = STATE(3316),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3316),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4219),
    [sym_false] = ACTIONS(4219),
    [sym_null] = ACTIONS(4219),
    [sym_super] = ACTIONS(4219),
    [sym_this] = ACTIONS(4219),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4221),
    [sym_float_literal] = ACTIONS(4221),
    [sym__string] = ACTIONS(3370),
  },
  [1282] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3278),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3278),
    [sym_primary_expression] = STATE(3278),
    [sym__primary_expr] = STATE(3278),
    [sym_index_expression] = STATE(3278),
    [sym_postfix_expression] = STATE(3278),
    [sym_unary_expression] = STATE(3278),
    [sym__unary_expr] = STATE(3278),
    [sym_property_expression] = STATE(3278),
    [sym_cast_expression] = STATE(3278),
    [sym_delete_expression] = STATE(3278),
    [sym_throw_expression] = STATE(3278),
    [sym_assert_expression] = STATE(3278),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3278),
    [sym_new_expression] = STATE(3278),
    [sym_typeid_expression] = STATE(3278),
    [sym_is_expression] = STATE(3278),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3278),
    [sym_char_literal] = STATE(3278),
    [sym_array_literal] = STATE(3278),
    [sym_function_literal] = STATE(3278),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3278),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4223),
    [sym_false] = ACTIONS(4223),
    [sym_null] = ACTIONS(4223),
    [sym_super] = ACTIONS(4223),
    [sym_this] = ACTIONS(4223),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4225),
    [sym_float_literal] = ACTIONS(4225),
    [sym__string] = ACTIONS(3370),
  },
  [1283] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3163),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3163),
    [sym_primary_expression] = STATE(3163),
    [sym__primary_expr] = STATE(3163),
    [sym_index_expression] = STATE(3163),
    [sym_postfix_expression] = STATE(3163),
    [sym_unary_expression] = STATE(3163),
    [sym__unary_expr] = STATE(3163),
    [sym_property_expression] = STATE(3163),
    [sym_cast_expression] = STATE(3163),
    [sym_delete_expression] = STATE(3163),
    [sym_throw_expression] = STATE(3163),
    [sym_assert_expression] = STATE(3163),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3163),
    [sym_new_expression] = STATE(3163),
    [sym_typeid_expression] = STATE(3163),
    [sym_is_expression] = STATE(3163),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3163),
    [sym_char_literal] = STATE(3163),
    [sym_array_literal] = STATE(3163),
    [sym_function_literal] = STATE(3163),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3163),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4227),
    [sym_false] = ACTIONS(4227),
    [sym_null] = ACTIONS(4227),
    [sym_super] = ACTIONS(4227),
    [sym_this] = ACTIONS(4227),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4229),
    [sym_float_literal] = ACTIONS(4229),
    [sym__string] = ACTIONS(233),
  },
  [1284] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3160),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3160),
    [sym_primary_expression] = STATE(3160),
    [sym__primary_expr] = STATE(3160),
    [sym_index_expression] = STATE(3160),
    [sym_postfix_expression] = STATE(3160),
    [sym_unary_expression] = STATE(3160),
    [sym__unary_expr] = STATE(3160),
    [sym_property_expression] = STATE(3160),
    [sym_cast_expression] = STATE(3160),
    [sym_delete_expression] = STATE(3160),
    [sym_throw_expression] = STATE(3160),
    [sym_assert_expression] = STATE(3160),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3160),
    [sym_new_expression] = STATE(3160),
    [sym_typeid_expression] = STATE(3160),
    [sym_is_expression] = STATE(3160),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3160),
    [sym_char_literal] = STATE(3160),
    [sym_array_literal] = STATE(3160),
    [sym_function_literal] = STATE(3160),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3160),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4231),
    [sym_false] = ACTIONS(4231),
    [sym_null] = ACTIONS(4231),
    [sym_super] = ACTIONS(4231),
    [sym_this] = ACTIONS(4231),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4233),
    [sym_float_literal] = ACTIONS(4233),
    [sym__string] = ACTIONS(233),
  },
  [1285] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3381),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3381),
    [sym_primary_expression] = STATE(3381),
    [sym__primary_expr] = STATE(3381),
    [sym_index_expression] = STATE(3381),
    [sym_postfix_expression] = STATE(3381),
    [sym_unary_expression] = STATE(3381),
    [sym__unary_expr] = STATE(3381),
    [sym_property_expression] = STATE(3381),
    [sym_cast_expression] = STATE(3381),
    [sym_delete_expression] = STATE(3381),
    [sym_throw_expression] = STATE(3381),
    [sym_assert_expression] = STATE(3381),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3381),
    [sym_new_expression] = STATE(3381),
    [sym_typeid_expression] = STATE(3381),
    [sym_is_expression] = STATE(3381),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3381),
    [sym_char_literal] = STATE(3381),
    [sym_array_literal] = STATE(3381),
    [sym_function_literal] = STATE(3381),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3381),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4235),
    [sym_false] = ACTIONS(4235),
    [sym_null] = ACTIONS(4235),
    [sym_super] = ACTIONS(4235),
    [sym_this] = ACTIONS(4235),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4237),
    [sym_float_literal] = ACTIONS(4237),
    [sym__string] = ACTIONS(3774),
  },
  [1286] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4239),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1287] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4213),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1288] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3078),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3078),
    [sym_primary_expression] = STATE(3078),
    [sym__primary_expr] = STATE(3078),
    [sym_index_expression] = STATE(3078),
    [sym_postfix_expression] = STATE(3078),
    [sym_unary_expression] = STATE(3078),
    [sym__unary_expr] = STATE(3078),
    [sym_property_expression] = STATE(3078),
    [sym_cast_expression] = STATE(3078),
    [sym_delete_expression] = STATE(3078),
    [sym_throw_expression] = STATE(3078),
    [sym_assert_expression] = STATE(3078),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3078),
    [sym_new_expression] = STATE(3078),
    [sym_typeid_expression] = STATE(3078),
    [sym_is_expression] = STATE(3078),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3078),
    [sym_char_literal] = STATE(3078),
    [sym_array_literal] = STATE(3078),
    [sym_function_literal] = STATE(3078),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3078),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4241),
    [sym_false] = ACTIONS(4241),
    [sym_null] = ACTIONS(4241),
    [sym_super] = ACTIONS(4241),
    [sym_this] = ACTIONS(4241),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4243),
    [sym_float_literal] = ACTIONS(4243),
    [sym__string] = ACTIONS(233),
  },
  [1289] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3077),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3077),
    [sym_primary_expression] = STATE(3077),
    [sym__primary_expr] = STATE(3077),
    [sym_index_expression] = STATE(3077),
    [sym_postfix_expression] = STATE(3077),
    [sym_unary_expression] = STATE(3077),
    [sym__unary_expr] = STATE(3077),
    [sym_property_expression] = STATE(3077),
    [sym_cast_expression] = STATE(3077),
    [sym_delete_expression] = STATE(3077),
    [sym_throw_expression] = STATE(3077),
    [sym_assert_expression] = STATE(3077),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3077),
    [sym_new_expression] = STATE(3077),
    [sym_typeid_expression] = STATE(3077),
    [sym_is_expression] = STATE(3077),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3077),
    [sym_char_literal] = STATE(3077),
    [sym_array_literal] = STATE(3077),
    [sym_function_literal] = STATE(3077),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3077),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4245),
    [sym_false] = ACTIONS(4245),
    [sym_null] = ACTIONS(4245),
    [sym_super] = ACTIONS(4245),
    [sym_this] = ACTIONS(4245),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4247),
    [sym_float_literal] = ACTIONS(4247),
    [sym__string] = ACTIONS(233),
  },
  [1290] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3345),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3345),
    [sym_primary_expression] = STATE(3345),
    [sym__primary_expr] = STATE(3345),
    [sym_index_expression] = STATE(3345),
    [sym_postfix_expression] = STATE(3345),
    [sym_unary_expression] = STATE(3345),
    [sym__unary_expr] = STATE(3345),
    [sym_property_expression] = STATE(3345),
    [sym_cast_expression] = STATE(3345),
    [sym_delete_expression] = STATE(3345),
    [sym_throw_expression] = STATE(3345),
    [sym_assert_expression] = STATE(3345),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3345),
    [sym_new_expression] = STATE(3345),
    [sym_typeid_expression] = STATE(3345),
    [sym_is_expression] = STATE(3345),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3345),
    [sym_char_literal] = STATE(3345),
    [sym_array_literal] = STATE(3345),
    [sym_function_literal] = STATE(3345),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3345),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4249),
    [sym_false] = ACTIONS(4249),
    [sym_null] = ACTIONS(4249),
    [sym_super] = ACTIONS(4249),
    [sym_this] = ACTIONS(4249),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4251),
    [sym_float_literal] = ACTIONS(4251),
    [sym__string] = ACTIONS(3774),
  },
  [1291] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3351),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3351),
    [sym_primary_expression] = STATE(3351),
    [sym__primary_expr] = STATE(3351),
    [sym_index_expression] = STATE(3351),
    [sym_postfix_expression] = STATE(3351),
    [sym_unary_expression] = STATE(3351),
    [sym__unary_expr] = STATE(3351),
    [sym_property_expression] = STATE(3351),
    [sym_cast_expression] = STATE(3351),
    [sym_delete_expression] = STATE(3351),
    [sym_throw_expression] = STATE(3351),
    [sym_assert_expression] = STATE(3351),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3351),
    [sym_new_expression] = STATE(3351),
    [sym_typeid_expression] = STATE(3351),
    [sym_is_expression] = STATE(3351),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3351),
    [sym_char_literal] = STATE(3351),
    [sym_array_literal] = STATE(3351),
    [sym_function_literal] = STATE(3351),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3351),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4253),
    [sym_false] = ACTIONS(4253),
    [sym_null] = ACTIONS(4253),
    [sym_super] = ACTIONS(4253),
    [sym_this] = ACTIONS(4253),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4255),
    [sym_float_literal] = ACTIONS(4255),
    [sym__string] = ACTIONS(3774),
  },
  [1292] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3152),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3152),
    [sym_primary_expression] = STATE(3152),
    [sym__primary_expr] = STATE(3152),
    [sym_index_expression] = STATE(3152),
    [sym_postfix_expression] = STATE(3152),
    [sym_unary_expression] = STATE(3152),
    [sym__unary_expr] = STATE(3152),
    [sym_property_expression] = STATE(3152),
    [sym_cast_expression] = STATE(3152),
    [sym_delete_expression] = STATE(3152),
    [sym_throw_expression] = STATE(3152),
    [sym_assert_expression] = STATE(3152),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3152),
    [sym_new_expression] = STATE(3152),
    [sym_typeid_expression] = STATE(3152),
    [sym_is_expression] = STATE(3152),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3152),
    [sym_char_literal] = STATE(3152),
    [sym_array_literal] = STATE(3152),
    [sym_function_literal] = STATE(3152),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3152),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4209),
    [sym_false] = ACTIONS(4209),
    [sym_null] = ACTIONS(4209),
    [sym_super] = ACTIONS(4209),
    [sym_this] = ACTIONS(4209),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4211),
    [sym_float_literal] = ACTIONS(4211),
    [sym__string] = ACTIONS(233),
  },
  [1293] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3390),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3390),
    [sym_primary_expression] = STATE(3390),
    [sym__primary_expr] = STATE(3390),
    [sym_index_expression] = STATE(3390),
    [sym_postfix_expression] = STATE(3390),
    [sym_unary_expression] = STATE(3390),
    [sym__unary_expr] = STATE(3390),
    [sym_property_expression] = STATE(3390),
    [sym_cast_expression] = STATE(3390),
    [sym_delete_expression] = STATE(3390),
    [sym_throw_expression] = STATE(3390),
    [sym_assert_expression] = STATE(3390),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3390),
    [sym_new_expression] = STATE(3390),
    [sym_typeid_expression] = STATE(3390),
    [sym_is_expression] = STATE(3390),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3390),
    [sym_char_literal] = STATE(3390),
    [sym_array_literal] = STATE(3390),
    [sym_function_literal] = STATE(3390),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3390),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4257),
    [sym_false] = ACTIONS(4257),
    [sym_null] = ACTIONS(4257),
    [sym_super] = ACTIONS(4257),
    [sym_this] = ACTIONS(4257),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4259),
    [sym_float_literal] = ACTIONS(4259),
    [sym__string] = ACTIONS(3774),
  },
  [1294] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3334),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3334),
    [sym_primary_expression] = STATE(3334),
    [sym__primary_expr] = STATE(3334),
    [sym_index_expression] = STATE(3334),
    [sym_postfix_expression] = STATE(3334),
    [sym_unary_expression] = STATE(3334),
    [sym__unary_expr] = STATE(3334),
    [sym_property_expression] = STATE(3334),
    [sym_cast_expression] = STATE(3334),
    [sym_delete_expression] = STATE(3334),
    [sym_throw_expression] = STATE(3334),
    [sym_assert_expression] = STATE(3334),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3334),
    [sym_new_expression] = STATE(3334),
    [sym_typeid_expression] = STATE(3334),
    [sym_is_expression] = STATE(3334),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3334),
    [sym_char_literal] = STATE(3334),
    [sym_array_literal] = STATE(3334),
    [sym_function_literal] = STATE(3334),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3334),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4261),
    [sym_false] = ACTIONS(4261),
    [sym_null] = ACTIONS(4261),
    [sym_super] = ACTIONS(4261),
    [sym_this] = ACTIONS(4261),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4263),
    [sym_float_literal] = ACTIONS(4263),
    [sym__string] = ACTIONS(3774),
  },
  [1295] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3330),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3330),
    [sym_primary_expression] = STATE(3330),
    [sym__primary_expr] = STATE(3330),
    [sym_index_expression] = STATE(3330),
    [sym_postfix_expression] = STATE(3330),
    [sym_unary_expression] = STATE(3330),
    [sym__unary_expr] = STATE(3330),
    [sym_property_expression] = STATE(3330),
    [sym_cast_expression] = STATE(3330),
    [sym_delete_expression] = STATE(3330),
    [sym_throw_expression] = STATE(3330),
    [sym_assert_expression] = STATE(3330),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3330),
    [sym_new_expression] = STATE(3330),
    [sym_typeid_expression] = STATE(3330),
    [sym_is_expression] = STATE(3330),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3330),
    [sym_char_literal] = STATE(3330),
    [sym_array_literal] = STATE(3330),
    [sym_function_literal] = STATE(3330),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3330),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4265),
    [sym_false] = ACTIONS(4265),
    [sym_null] = ACTIONS(4265),
    [sym_super] = ACTIONS(4265),
    [sym_this] = ACTIONS(4265),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4267),
    [sym_float_literal] = ACTIONS(4267),
    [sym__string] = ACTIONS(3774),
  },
  [1296] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3365),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3365),
    [sym_primary_expression] = STATE(3365),
    [sym__primary_expr] = STATE(3365),
    [sym_index_expression] = STATE(3365),
    [sym_postfix_expression] = STATE(3365),
    [sym_unary_expression] = STATE(3365),
    [sym__unary_expr] = STATE(3365),
    [sym_property_expression] = STATE(3365),
    [sym_cast_expression] = STATE(3365),
    [sym_delete_expression] = STATE(3365),
    [sym_throw_expression] = STATE(3365),
    [sym_assert_expression] = STATE(3365),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3365),
    [sym_new_expression] = STATE(3365),
    [sym_typeid_expression] = STATE(3365),
    [sym_is_expression] = STATE(3365),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3365),
    [sym_char_literal] = STATE(3365),
    [sym_array_literal] = STATE(3365),
    [sym_function_literal] = STATE(3365),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3365),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4269),
    [sym_false] = ACTIONS(4269),
    [sym_null] = ACTIONS(4269),
    [sym_super] = ACTIONS(4269),
    [sym_this] = ACTIONS(4269),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4271),
    [sym_float_literal] = ACTIONS(4271),
    [sym__string] = ACTIONS(3774),
  },
  [1297] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3264),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3264),
    [sym_primary_expression] = STATE(3264),
    [sym__primary_expr] = STATE(3264),
    [sym_index_expression] = STATE(3264),
    [sym_postfix_expression] = STATE(3264),
    [sym_unary_expression] = STATE(3264),
    [sym__unary_expr] = STATE(3264),
    [sym_property_expression] = STATE(3264),
    [sym_cast_expression] = STATE(3264),
    [sym_delete_expression] = STATE(3264),
    [sym_throw_expression] = STATE(3264),
    [sym_assert_expression] = STATE(3264),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3264),
    [sym_new_expression] = STATE(3264),
    [sym_typeid_expression] = STATE(3264),
    [sym_is_expression] = STATE(3264),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3264),
    [sym_char_literal] = STATE(3264),
    [sym_array_literal] = STATE(3264),
    [sym_function_literal] = STATE(3264),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3264),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4273),
    [sym_false] = ACTIONS(4273),
    [sym_null] = ACTIONS(4273),
    [sym_super] = ACTIONS(4273),
    [sym_this] = ACTIONS(4273),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4275),
    [sym_float_literal] = ACTIONS(4275),
    [sym__string] = ACTIONS(3370),
  },
  [1298] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3279),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3279),
    [sym_primary_expression] = STATE(3279),
    [sym__primary_expr] = STATE(3279),
    [sym_index_expression] = STATE(3279),
    [sym_postfix_expression] = STATE(3279),
    [sym_unary_expression] = STATE(3279),
    [sym__unary_expr] = STATE(3279),
    [sym_property_expression] = STATE(3279),
    [sym_cast_expression] = STATE(3279),
    [sym_delete_expression] = STATE(3279),
    [sym_throw_expression] = STATE(3279),
    [sym_assert_expression] = STATE(3279),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3279),
    [sym_new_expression] = STATE(3279),
    [sym_typeid_expression] = STATE(3279),
    [sym_is_expression] = STATE(3279),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3279),
    [sym_char_literal] = STATE(3279),
    [sym_array_literal] = STATE(3279),
    [sym_function_literal] = STATE(3279),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3279),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4277),
    [sym_false] = ACTIONS(4277),
    [sym_null] = ACTIONS(4277),
    [sym_super] = ACTIONS(4277),
    [sym_this] = ACTIONS(4277),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4279),
    [sym_float_literal] = ACTIONS(4279),
    [sym__string] = ACTIONS(3370),
  },
  [1299] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3315),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3315),
    [sym_primary_expression] = STATE(3315),
    [sym__primary_expr] = STATE(3315),
    [sym_index_expression] = STATE(3315),
    [sym_postfix_expression] = STATE(3315),
    [sym_unary_expression] = STATE(3315),
    [sym__unary_expr] = STATE(3315),
    [sym_property_expression] = STATE(3315),
    [sym_cast_expression] = STATE(3315),
    [sym_delete_expression] = STATE(3315),
    [sym_throw_expression] = STATE(3315),
    [sym_assert_expression] = STATE(3315),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3315),
    [sym_new_expression] = STATE(3315),
    [sym_typeid_expression] = STATE(3315),
    [sym_is_expression] = STATE(3315),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3315),
    [sym_char_literal] = STATE(3315),
    [sym_array_literal] = STATE(3315),
    [sym_function_literal] = STATE(3315),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3315),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4281),
    [sym_false] = ACTIONS(4281),
    [sym_null] = ACTIONS(4281),
    [sym_super] = ACTIONS(4281),
    [sym_this] = ACTIONS(4281),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4283),
    [sym_float_literal] = ACTIONS(4283),
    [sym__string] = ACTIONS(3370),
  },
  [1300] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3160),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3160),
    [sym_primary_expression] = STATE(3160),
    [sym__primary_expr] = STATE(3160),
    [sym_index_expression] = STATE(3160),
    [sym_postfix_expression] = STATE(3160),
    [sym_unary_expression] = STATE(3160),
    [sym__unary_expr] = STATE(3160),
    [sym_property_expression] = STATE(3160),
    [sym_cast_expression] = STATE(3160),
    [sym_delete_expression] = STATE(3160),
    [sym_throw_expression] = STATE(3160),
    [sym_assert_expression] = STATE(3160),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3160),
    [sym_new_expression] = STATE(3160),
    [sym_typeid_expression] = STATE(3160),
    [sym_is_expression] = STATE(3160),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3160),
    [sym_char_literal] = STATE(3160),
    [sym_array_literal] = STATE(3160),
    [sym_function_literal] = STATE(3160),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3160),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4231),
    [sym_false] = ACTIONS(4231),
    [sym_null] = ACTIONS(4231),
    [sym_super] = ACTIONS(4231),
    [sym_this] = ACTIONS(4231),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4233),
    [sym_float_literal] = ACTIONS(4233),
    [sym__string] = ACTIONS(233),
  },
  [1301] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4285),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1302] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3316),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3316),
    [sym_primary_expression] = STATE(3316),
    [sym__primary_expr] = STATE(3316),
    [sym_index_expression] = STATE(3316),
    [sym_postfix_expression] = STATE(3316),
    [sym_unary_expression] = STATE(3316),
    [sym__unary_expr] = STATE(3316),
    [sym_property_expression] = STATE(3316),
    [sym_cast_expression] = STATE(3316),
    [sym_delete_expression] = STATE(3316),
    [sym_throw_expression] = STATE(3316),
    [sym_assert_expression] = STATE(3316),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3316),
    [sym_new_expression] = STATE(3316),
    [sym_typeid_expression] = STATE(3316),
    [sym_is_expression] = STATE(3316),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3316),
    [sym_char_literal] = STATE(3316),
    [sym_array_literal] = STATE(3316),
    [sym_function_literal] = STATE(3316),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3316),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4219),
    [sym_false] = ACTIONS(4219),
    [sym_null] = ACTIONS(4219),
    [sym_super] = ACTIONS(4219),
    [sym_this] = ACTIONS(4219),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4221),
    [sym_float_literal] = ACTIONS(4221),
    [sym__string] = ACTIONS(3370),
  },
  [1303] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3297),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3297),
    [sym_primary_expression] = STATE(3297),
    [sym__primary_expr] = STATE(3297),
    [sym_index_expression] = STATE(3297),
    [sym_postfix_expression] = STATE(3297),
    [sym_unary_expression] = STATE(3297),
    [sym__unary_expr] = STATE(3297),
    [sym_property_expression] = STATE(3297),
    [sym_cast_expression] = STATE(3297),
    [sym_delete_expression] = STATE(3297),
    [sym_throw_expression] = STATE(3297),
    [sym_assert_expression] = STATE(3297),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3297),
    [sym_new_expression] = STATE(3297),
    [sym_typeid_expression] = STATE(3297),
    [sym_is_expression] = STATE(3297),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3297),
    [sym_char_literal] = STATE(3297),
    [sym_array_literal] = STATE(3297),
    [sym_function_literal] = STATE(3297),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3297),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4287),
    [sym_false] = ACTIONS(4287),
    [sym_null] = ACTIONS(4287),
    [sym_super] = ACTIONS(4287),
    [sym_this] = ACTIONS(4287),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4289),
    [sym_float_literal] = ACTIONS(4289),
    [sym__string] = ACTIONS(3370),
  },
  [1304] = {
    [sym_catch_statement] = STATE(1304),
    [aux_sym_try_statement_repeat1] = STATE(1304),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_q_LBRACE] = ACTIONS(4198),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_DOT] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_DOLLAR] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [anon_sym_AT] = ACTIONS(4198),
    [sym_bool] = ACTIONS(4196),
    [sym_byte] = ACTIONS(4196),
    [sym_ubyte] = ACTIONS(4196),
    [sym_char] = ACTIONS(4196),
    [sym_short] = ACTIONS(4196),
    [sym_ushort] = ACTIONS(4196),
    [sym_int] = ACTIONS(4196),
    [sym_uint] = ACTIONS(4196),
    [sym_long] = ACTIONS(4196),
    [sym_ulong] = ACTIONS(4196),
    [sym_cent] = ACTIONS(4196),
    [sym_ucent] = ACTIONS(4196),
    [sym_wchar] = ACTIONS(4196),
    [sym_dchar] = ACTIONS(4196),
    [sym_float] = ACTIONS(4196),
    [sym_double] = ACTIONS(4196),
    [sym_real] = ACTIONS(4196),
    [sym_ifloat] = ACTIONS(4196),
    [sym_idouble] = ACTIONS(4196),
    [sym_ireal] = ACTIONS(4196),
    [sym_cfloat] = ACTIONS(4196),
    [sym_cdouble] = ACTIONS(4196),
    [sym_creal] = ACTIONS(4196),
    [sym_size_t] = ACTIONS(4196),
    [sym_ptrdiff_t] = ACTIONS(4196),
    [sym_string] = ACTIONS(4196),
    [sym_cstring] = ACTIONS(4196),
    [sym_dstring] = ACTIONS(4196),
    [sym_wstring] = ACTIONS(4196),
    [sym_noreturn] = ACTIONS(4196),
    [sym_true] = ACTIONS(4196),
    [sym_false] = ACTIONS(4196),
    [sym_null] = ACTIONS(4196),
    [sym_super] = ACTIONS(4196),
    [sym_this] = ACTIONS(4196),
    [sym_abstract] = ACTIONS(4196),
    [sym_alias] = ACTIONS(4196),
    [sym_align] = ACTIONS(4196),
    [sym_asm] = ACTIONS(4196),
    [sym_assert] = ACTIONS(4196),
    [sym_auto] = ACTIONS(4196),
    [sym_break] = ACTIONS(4196),
    [sym_case] = ACTIONS(4196),
    [sym_cast] = ACTIONS(4196),
    [sym_catch] = ACTIONS(4291),
    [sym_class] = ACTIONS(4196),
    [sym_const] = ACTIONS(4196),
    [sym_continue] = ACTIONS(4196),
    [sym_debug] = ACTIONS(4196),
    [sym_default] = ACTIONS(4196),
    [sym_delegate] = ACTIONS(4196),
    [sym_delete] = ACTIONS(4196),
    [sym_deprecated] = ACTIONS(4196),
    [sym_do] = ACTIONS(4196),
    [sym_enum] = ACTIONS(4196),
    [sym_export] = ACTIONS(4196),
    [sym_extern] = ACTIONS(4196),
    [sym_final] = ACTIONS(4196),
    [sym_finally] = ACTIONS(4196),
    [sym_for] = ACTIONS(4196),
    [sym_foreach] = ACTIONS(4196),
    [sym_foreach_reverse] = ACTIONS(4196),
    [sym_function] = ACTIONS(4196),
    [sym_goto] = ACTIONS(4196),
    [sym_if] = ACTIONS(4196),
    [sym_immutable] = ACTIONS(4196),
    [sym_import] = ACTIONS(4196),
    [sym_in] = ACTIONS(4196),
    [sym_inout] = ACTIONS(4196),
    [sym_interface] = ACTIONS(4196),
    [sym_invariant] = ACTIONS(4196),
    [sym_is] = ACTIONS(4196),
    [sym_mixin] = ACTIONS(4196),
    [sym_new] = ACTIONS(4196),
    [sym_nothrow] = ACTIONS(4196),
    [sym_out] = ACTIONS(4196),
    [sym_override] = ACTIONS(4196),
    [sym_package] = ACTIONS(4196),
    [sym_pragma] = ACTIONS(4196),
    [sym_private] = ACTIONS(4196),
    [sym_protected] = ACTIONS(4196),
    [sym_public] = ACTIONS(4196),
    [sym_pure] = ACTIONS(4196),
    [sym_ref] = ACTIONS(4196),
    [sym_return] = ACTIONS(4196),
    [sym_scope] = ACTIONS(4196),
    [sym_shared] = ACTIONS(4196),
    [sym_static] = ACTIONS(4196),
    [sym_struct] = ACTIONS(4196),
    [sym_switch] = ACTIONS(4196),
    [sym_synchronized] = ACTIONS(4196),
    [sym_template] = ACTIONS(4196),
    [sym_throw] = ACTIONS(4196),
    [sym_try] = ACTIONS(4196),
    [sym_typeid] = ACTIONS(4196),
    [sym_typeof] = ACTIONS(4196),
    [sym_union] = ACTIONS(4196),
    [sym_unittest] = ACTIONS(4196),
    [sym_version] = ACTIONS(4196),
    [sym_while] = ACTIONS(4196),
    [sym_with] = ACTIONS(4196),
    [sym_gshared] = ACTIONS(4196),
    [sym_traits] = ACTIONS(4196),
    [sym_vector] = ACTIONS(4196),
    [sym_void] = ACTIONS(4196),
    [anon_sym_BQUOTE] = ACTIONS(4198),
    [anon_sym_r_DQUOTE] = ACTIONS(4198),
    [anon_sym_x_DQUOTE] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(4198),
    [anon_sym_i_BQUOTE] = ACTIONS(4198),
    [anon_sym_i_DQUOTE] = ACTIONS(4198),
    [anon_sym_iq_LBRACE] = ACTIONS(4198),
    [aux_sym_char_literal_token1] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4196),
    [anon_sym___DATE__] = ACTIONS(4196),
    [anon_sym___FILE__] = ACTIONS(4196),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4196),
    [anon_sym___FUNCTION__] = ACTIONS(4196),
    [anon_sym___LINE__] = ACTIONS(4196),
    [anon_sym___MODULE__] = ACTIONS(4196),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4196),
    [anon_sym___TIME__] = ACTIONS(4196),
    [anon_sym___TIMESTAMP__] = ACTIONS(4196),
    [anon_sym___VENDOR__] = ACTIONS(4196),
    [anon_sym___VERSION__] = ACTIONS(4196),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4198),
    [sym_float_literal] = ACTIONS(4198),
    [sym__string] = ACTIONS(4198),
  },
  [1305] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3315),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3315),
    [sym_primary_expression] = STATE(3315),
    [sym__primary_expr] = STATE(3315),
    [sym_index_expression] = STATE(3315),
    [sym_postfix_expression] = STATE(3315),
    [sym_unary_expression] = STATE(3315),
    [sym__unary_expr] = STATE(3315),
    [sym_property_expression] = STATE(3315),
    [sym_cast_expression] = STATE(3315),
    [sym_delete_expression] = STATE(3315),
    [sym_throw_expression] = STATE(3315),
    [sym_assert_expression] = STATE(3315),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3315),
    [sym_new_expression] = STATE(3315),
    [sym_typeid_expression] = STATE(3315),
    [sym_is_expression] = STATE(3315),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3315),
    [sym_char_literal] = STATE(3315),
    [sym_array_literal] = STATE(3315),
    [sym_function_literal] = STATE(3315),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3315),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4281),
    [sym_false] = ACTIONS(4281),
    [sym_null] = ACTIONS(4281),
    [sym_super] = ACTIONS(4281),
    [sym_this] = ACTIONS(4281),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4283),
    [sym_float_literal] = ACTIONS(4283),
    [sym__string] = ACTIONS(3370),
  },
  [1306] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3297),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3297),
    [sym_primary_expression] = STATE(3297),
    [sym__primary_expr] = STATE(3297),
    [sym_index_expression] = STATE(3297),
    [sym_postfix_expression] = STATE(3297),
    [sym_unary_expression] = STATE(3297),
    [sym__unary_expr] = STATE(3297),
    [sym_property_expression] = STATE(3297),
    [sym_cast_expression] = STATE(3297),
    [sym_delete_expression] = STATE(3297),
    [sym_throw_expression] = STATE(3297),
    [sym_assert_expression] = STATE(3297),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3297),
    [sym_new_expression] = STATE(3297),
    [sym_typeid_expression] = STATE(3297),
    [sym_is_expression] = STATE(3297),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3297),
    [sym_char_literal] = STATE(3297),
    [sym_array_literal] = STATE(3297),
    [sym_function_literal] = STATE(3297),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3297),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4287),
    [sym_false] = ACTIONS(4287),
    [sym_null] = ACTIONS(4287),
    [sym_super] = ACTIONS(4287),
    [sym_this] = ACTIONS(4287),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4289),
    [sym_float_literal] = ACTIONS(4289),
    [sym__string] = ACTIONS(3370),
  },
  [1307] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3151),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3151),
    [sym_primary_expression] = STATE(3151),
    [sym__primary_expr] = STATE(3151),
    [sym_index_expression] = STATE(3151),
    [sym_postfix_expression] = STATE(3151),
    [sym_unary_expression] = STATE(3151),
    [sym__unary_expr] = STATE(3151),
    [sym_property_expression] = STATE(3151),
    [sym_cast_expression] = STATE(3151),
    [sym_delete_expression] = STATE(3151),
    [sym_throw_expression] = STATE(3151),
    [sym_assert_expression] = STATE(3151),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3151),
    [sym_new_expression] = STATE(3151),
    [sym_typeid_expression] = STATE(3151),
    [sym_is_expression] = STATE(3151),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3151),
    [sym_char_literal] = STATE(3151),
    [sym_array_literal] = STATE(3151),
    [sym_function_literal] = STATE(3151),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3151),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4294),
    [sym_false] = ACTIONS(4294),
    [sym_null] = ACTIONS(4294),
    [sym_super] = ACTIONS(4294),
    [sym_this] = ACTIONS(4294),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4296),
    [sym_float_literal] = ACTIONS(4296),
    [sym__string] = ACTIONS(233),
  },
  [1308] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4213),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1309] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3151),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3151),
    [sym_primary_expression] = STATE(3151),
    [sym__primary_expr] = STATE(3151),
    [sym_index_expression] = STATE(3151),
    [sym_postfix_expression] = STATE(3151),
    [sym_unary_expression] = STATE(3151),
    [sym__unary_expr] = STATE(3151),
    [sym_property_expression] = STATE(3151),
    [sym_cast_expression] = STATE(3151),
    [sym_delete_expression] = STATE(3151),
    [sym_throw_expression] = STATE(3151),
    [sym_assert_expression] = STATE(3151),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3151),
    [sym_new_expression] = STATE(3151),
    [sym_typeid_expression] = STATE(3151),
    [sym_is_expression] = STATE(3151),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3151),
    [sym_char_literal] = STATE(3151),
    [sym_array_literal] = STATE(3151),
    [sym_function_literal] = STATE(3151),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3151),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4294),
    [sym_false] = ACTIONS(4294),
    [sym_null] = ACTIONS(4294),
    [sym_super] = ACTIONS(4294),
    [sym_this] = ACTIONS(4294),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4296),
    [sym_float_literal] = ACTIONS(4296),
    [sym__string] = ACTIONS(233),
  },
  [1310] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3278),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3278),
    [sym_primary_expression] = STATE(3278),
    [sym__primary_expr] = STATE(3278),
    [sym_index_expression] = STATE(3278),
    [sym_postfix_expression] = STATE(3278),
    [sym_unary_expression] = STATE(3278),
    [sym__unary_expr] = STATE(3278),
    [sym_property_expression] = STATE(3278),
    [sym_cast_expression] = STATE(3278),
    [sym_delete_expression] = STATE(3278),
    [sym_throw_expression] = STATE(3278),
    [sym_assert_expression] = STATE(3278),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3278),
    [sym_new_expression] = STATE(3278),
    [sym_typeid_expression] = STATE(3278),
    [sym_is_expression] = STATE(3278),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3278),
    [sym_char_literal] = STATE(3278),
    [sym_array_literal] = STATE(3278),
    [sym_function_literal] = STATE(3278),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3278),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4223),
    [sym_false] = ACTIONS(4223),
    [sym_null] = ACTIONS(4223),
    [sym_super] = ACTIONS(4223),
    [sym_this] = ACTIONS(4223),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4225),
    [sym_float_literal] = ACTIONS(4225),
    [sym__string] = ACTIONS(3370),
  },
  [1311] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4298),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1312] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4213),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1313] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3152),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3152),
    [sym_primary_expression] = STATE(3152),
    [sym__primary_expr] = STATE(3152),
    [sym_index_expression] = STATE(3152),
    [sym_postfix_expression] = STATE(3152),
    [sym_unary_expression] = STATE(3152),
    [sym__unary_expr] = STATE(3152),
    [sym_property_expression] = STATE(3152),
    [sym_cast_expression] = STATE(3152),
    [sym_delete_expression] = STATE(3152),
    [sym_throw_expression] = STATE(3152),
    [sym_assert_expression] = STATE(3152),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3152),
    [sym_new_expression] = STATE(3152),
    [sym_typeid_expression] = STATE(3152),
    [sym_is_expression] = STATE(3152),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3152),
    [sym_char_literal] = STATE(3152),
    [sym_array_literal] = STATE(3152),
    [sym_function_literal] = STATE(3152),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3152),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4209),
    [sym_false] = ACTIONS(4209),
    [sym_null] = ACTIONS(4209),
    [sym_super] = ACTIONS(4209),
    [sym_this] = ACTIONS(4209),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4211),
    [sym_float_literal] = ACTIONS(4211),
    [sym__string] = ACTIONS(233),
  },
  [1314] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3279),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3279),
    [sym_primary_expression] = STATE(3279),
    [sym__primary_expr] = STATE(3279),
    [sym_index_expression] = STATE(3279),
    [sym_postfix_expression] = STATE(3279),
    [sym_unary_expression] = STATE(3279),
    [sym__unary_expr] = STATE(3279),
    [sym_property_expression] = STATE(3279),
    [sym_cast_expression] = STATE(3279),
    [sym_delete_expression] = STATE(3279),
    [sym_throw_expression] = STATE(3279),
    [sym_assert_expression] = STATE(3279),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3279),
    [sym_new_expression] = STATE(3279),
    [sym_typeid_expression] = STATE(3279),
    [sym_is_expression] = STATE(3279),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3279),
    [sym_char_literal] = STATE(3279),
    [sym_array_literal] = STATE(3279),
    [sym_function_literal] = STATE(3279),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3279),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4277),
    [sym_false] = ACTIONS(4277),
    [sym_null] = ACTIONS(4277),
    [sym_super] = ACTIONS(4277),
    [sym_this] = ACTIONS(4277),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4279),
    [sym_float_literal] = ACTIONS(4279),
    [sym__string] = ACTIONS(3370),
  },
  [1315] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3077),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3077),
    [sym_primary_expression] = STATE(3077),
    [sym__primary_expr] = STATE(3077),
    [sym_index_expression] = STATE(3077),
    [sym_postfix_expression] = STATE(3077),
    [sym_unary_expression] = STATE(3077),
    [sym__unary_expr] = STATE(3077),
    [sym_property_expression] = STATE(3077),
    [sym_cast_expression] = STATE(3077),
    [sym_delete_expression] = STATE(3077),
    [sym_throw_expression] = STATE(3077),
    [sym_assert_expression] = STATE(3077),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3077),
    [sym_new_expression] = STATE(3077),
    [sym_typeid_expression] = STATE(3077),
    [sym_is_expression] = STATE(3077),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3077),
    [sym_char_literal] = STATE(3077),
    [sym_array_literal] = STATE(3077),
    [sym_function_literal] = STATE(3077),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3077),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4245),
    [sym_false] = ACTIONS(4245),
    [sym_null] = ACTIONS(4245),
    [sym_super] = ACTIONS(4245),
    [sym_this] = ACTIONS(4245),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4247),
    [sym_float_literal] = ACTIONS(4247),
    [sym__string] = ACTIONS(233),
  },
  [1316] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3301),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3301),
    [sym_primary_expression] = STATE(3301),
    [sym__primary_expr] = STATE(3301),
    [sym_index_expression] = STATE(3301),
    [sym_postfix_expression] = STATE(3301),
    [sym_unary_expression] = STATE(3301),
    [sym__unary_expr] = STATE(3301),
    [sym_property_expression] = STATE(3301),
    [sym_cast_expression] = STATE(3301),
    [sym_delete_expression] = STATE(3301),
    [sym_throw_expression] = STATE(3301),
    [sym_assert_expression] = STATE(3301),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3301),
    [sym_new_expression] = STATE(3301),
    [sym_typeid_expression] = STATE(3301),
    [sym_is_expression] = STATE(3301),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3301),
    [sym_char_literal] = STATE(3301),
    [sym_array_literal] = STATE(3301),
    [sym_function_literal] = STATE(3301),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3301),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4300),
    [sym_false] = ACTIONS(4300),
    [sym_null] = ACTIONS(4300),
    [sym_super] = ACTIONS(4300),
    [sym_this] = ACTIONS(4300),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4302),
    [sym_float_literal] = ACTIONS(4302),
    [sym__string] = ACTIONS(3370),
  },
  [1317] = {
    [sym_token_string] = STATE(2976),
    [sym_dollar] = STATE(3377),
    [sym_type] = STATE(5318),
    [sym_type_ctor] = STATE(3632),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4473),
    [sym__builtin_type] = STATE(4473),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3305),
    [sym_call_expression] = STATE(3377),
    [sym_primary_expression] = STATE(3377),
    [sym__primary_expr] = STATE(3377),
    [sym_index_expression] = STATE(3377),
    [sym_postfix_expression] = STATE(3377),
    [sym_unary_expression] = STATE(3377),
    [sym__unary_expr] = STATE(3377),
    [sym_property_expression] = STATE(3377),
    [sym_cast_expression] = STATE(3377),
    [sym_delete_expression] = STATE(3377),
    [sym_throw_expression] = STATE(3377),
    [sym_assert_expression] = STATE(3377),
    [sym_mixin_expression] = STATE(3303),
    [sym_import_expression] = STATE(3377),
    [sym_new_expression] = STATE(3377),
    [sym_typeid_expression] = STATE(3377),
    [sym_is_expression] = STATE(3377),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(3377),
    [sym_char_literal] = STATE(3377),
    [sym_array_literal] = STATE(3377),
    [sym_function_literal] = STATE(3377),
    [sym__parameter_with_member_attributes] = STATE(4171),
    [sym_special_keyword] = STATE(3377),
    [sym_block_statement] = STATE(3440),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3440),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(3260),
    [sym_traits_expression] = STATE(3303),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(3704),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(3710),
    [anon_sym_AMP] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3714),
    [anon_sym_DASH_DASH] = ACTIONS(3712),
    [anon_sym_PLUS] = ACTIONS(3714),
    [anon_sym_PLUS_PLUS] = ACTIONS(3712),
    [anon_sym_BANG] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_LBRACK] = ACTIONS(3718),
    [anon_sym_DOLLAR] = ACTIONS(3720),
    [anon_sym_STAR] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [sym_bool] = ACTIONS(3722),
    [sym_byte] = ACTIONS(3722),
    [sym_ubyte] = ACTIONS(3722),
    [sym_char] = ACTIONS(3722),
    [sym_short] = ACTIONS(3722),
    [sym_ushort] = ACTIONS(3722),
    [sym_int] = ACTIONS(3722),
    [sym_uint] = ACTIONS(3722),
    [sym_long] = ACTIONS(3722),
    [sym_ulong] = ACTIONS(3722),
    [sym_cent] = ACTIONS(3722),
    [sym_ucent] = ACTIONS(3722),
    [sym_wchar] = ACTIONS(3722),
    [sym_dchar] = ACTIONS(3722),
    [sym_float] = ACTIONS(3722),
    [sym_double] = ACTIONS(3722),
    [sym_real] = ACTIONS(3722),
    [sym_ifloat] = ACTIONS(3722),
    [sym_idouble] = ACTIONS(3722),
    [sym_ireal] = ACTIONS(3722),
    [sym_cfloat] = ACTIONS(3722),
    [sym_cdouble] = ACTIONS(3722),
    [sym_creal] = ACTIONS(3722),
    [sym_size_t] = ACTIONS(3722),
    [sym_ptrdiff_t] = ACTIONS(3722),
    [sym_string] = ACTIONS(3722),
    [sym_cstring] = ACTIONS(3722),
    [sym_dstring] = ACTIONS(3722),
    [sym_wstring] = ACTIONS(3722),
    [sym_noreturn] = ACTIONS(3722),
    [sym_true] = ACTIONS(4304),
    [sym_false] = ACTIONS(4304),
    [sym_null] = ACTIONS(4304),
    [sym_super] = ACTIONS(4304),
    [sym_this] = ACTIONS(4304),
    [sym_assert] = ACTIONS(3726),
    [sym_auto] = ACTIONS(3728),
    [sym_cast] = ACTIONS(3730),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3732),
    [sym_delete] = ACTIONS(3734),
    [sym_do] = ACTIONS(3736),
    [sym_function] = ACTIONS(3738),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3740),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3742),
    [sym_mixin] = ACTIONS(3206),
    [sym_new] = ACTIONS(3744),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3746),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3748),
    [sym_typeid] = ACTIONS(3750),
    [sym_typeof] = ACTIONS(3214),
    [sym_traits] = ACTIONS(3216),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3722),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4306),
    [sym_float_literal] = ACTIONS(4306),
    [sym__string] = ACTIONS(3774),
  },
  [1318] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3078),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3078),
    [sym_primary_expression] = STATE(3078),
    [sym__primary_expr] = STATE(3078),
    [sym_index_expression] = STATE(3078),
    [sym_postfix_expression] = STATE(3078),
    [sym_unary_expression] = STATE(3078),
    [sym__unary_expr] = STATE(3078),
    [sym_property_expression] = STATE(3078),
    [sym_cast_expression] = STATE(3078),
    [sym_delete_expression] = STATE(3078),
    [sym_throw_expression] = STATE(3078),
    [sym_assert_expression] = STATE(3078),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3078),
    [sym_new_expression] = STATE(3078),
    [sym_typeid_expression] = STATE(3078),
    [sym_is_expression] = STATE(3078),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3078),
    [sym_char_literal] = STATE(3078),
    [sym_array_literal] = STATE(3078),
    [sym_function_literal] = STATE(3078),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3078),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4241),
    [sym_false] = ACTIONS(4241),
    [sym_null] = ACTIONS(4241),
    [sym_super] = ACTIONS(4241),
    [sym_this] = ACTIONS(4241),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4243),
    [sym_float_literal] = ACTIONS(4243),
    [sym__string] = ACTIONS(233),
  },
  [1319] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3077),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3077),
    [sym_primary_expression] = STATE(3077),
    [sym__primary_expr] = STATE(3077),
    [sym_index_expression] = STATE(3077),
    [sym_postfix_expression] = STATE(3077),
    [sym_unary_expression] = STATE(3077),
    [sym__unary_expr] = STATE(3077),
    [sym_property_expression] = STATE(3077),
    [sym_cast_expression] = STATE(3077),
    [sym_delete_expression] = STATE(3077),
    [sym_throw_expression] = STATE(3077),
    [sym_assert_expression] = STATE(3077),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3077),
    [sym_new_expression] = STATE(3077),
    [sym_typeid_expression] = STATE(3077),
    [sym_is_expression] = STATE(3077),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3077),
    [sym_char_literal] = STATE(3077),
    [sym_array_literal] = STATE(3077),
    [sym_function_literal] = STATE(3077),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3077),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4245),
    [sym_false] = ACTIONS(4245),
    [sym_null] = ACTIONS(4245),
    [sym_super] = ACTIONS(4245),
    [sym_this] = ACTIONS(4245),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4247),
    [sym_float_literal] = ACTIONS(4247),
    [sym__string] = ACTIONS(233),
  },
  [1320] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3264),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3264),
    [sym_primary_expression] = STATE(3264),
    [sym__primary_expr] = STATE(3264),
    [sym_index_expression] = STATE(3264),
    [sym_postfix_expression] = STATE(3264),
    [sym_unary_expression] = STATE(3264),
    [sym__unary_expr] = STATE(3264),
    [sym_property_expression] = STATE(3264),
    [sym_cast_expression] = STATE(3264),
    [sym_delete_expression] = STATE(3264),
    [sym_throw_expression] = STATE(3264),
    [sym_assert_expression] = STATE(3264),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3264),
    [sym_new_expression] = STATE(3264),
    [sym_typeid_expression] = STATE(3264),
    [sym_is_expression] = STATE(3264),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3264),
    [sym_char_literal] = STATE(3264),
    [sym_array_literal] = STATE(3264),
    [sym_function_literal] = STATE(3264),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3264),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4273),
    [sym_false] = ACTIONS(4273),
    [sym_null] = ACTIONS(4273),
    [sym_super] = ACTIONS(4273),
    [sym_this] = ACTIONS(4273),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4275),
    [sym_float_literal] = ACTIONS(4275),
    [sym__string] = ACTIONS(3370),
  },
  [1321] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3304),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3272),
    [sym_call_expression] = STATE(3304),
    [sym_primary_expression] = STATE(3304),
    [sym__primary_expr] = STATE(3304),
    [sym_index_expression] = STATE(3304),
    [sym_postfix_expression] = STATE(3304),
    [sym_unary_expression] = STATE(3304),
    [sym__unary_expr] = STATE(3304),
    [sym_property_expression] = STATE(3304),
    [sym_cast_expression] = STATE(3304),
    [sym_delete_expression] = STATE(3304),
    [sym_throw_expression] = STATE(3304),
    [sym_assert_expression] = STATE(3304),
    [sym_mixin_expression] = STATE(3293),
    [sym_import_expression] = STATE(3304),
    [sym_new_expression] = STATE(3304),
    [sym_typeid_expression] = STATE(3304),
    [sym_is_expression] = STATE(3304),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3304),
    [sym_char_literal] = STATE(3304),
    [sym_array_literal] = STATE(3304),
    [sym_function_literal] = STATE(3304),
    [sym__parameter_with_member_attributes] = STATE(4175),
    [sym_special_keyword] = STATE(3304),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3284),
    [sym_traits_expression] = STATE(3293),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3628),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3630),
    [anon_sym_DASH] = ACTIONS(3632),
    [anon_sym_DASH_DASH] = ACTIONS(3630),
    [anon_sym_PLUS] = ACTIONS(3632),
    [anon_sym_PLUS_PLUS] = ACTIONS(3630),
    [anon_sym_BANG] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3630),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4308),
    [sym_false] = ACTIONS(4308),
    [sym_null] = ACTIONS(4308),
    [sym_super] = ACTIONS(4308),
    [sym_this] = ACTIONS(4308),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3634),
    [sym_cast] = ACTIONS(3636),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3638),
    [sym_delete] = ACTIONS(3640),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3642),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3644),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3646),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4310),
    [sym_float_literal] = ACTIONS(4310),
    [sym__string] = ACTIONS(3370),
  },
  [1322] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3304),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3304),
    [sym_primary_expression] = STATE(3304),
    [sym__primary_expr] = STATE(3304),
    [sym_index_expression] = STATE(3304),
    [sym_postfix_expression] = STATE(3304),
    [sym_unary_expression] = STATE(3304),
    [sym__unary_expr] = STATE(3304),
    [sym_property_expression] = STATE(3304),
    [sym_cast_expression] = STATE(3304),
    [sym_delete_expression] = STATE(3304),
    [sym_throw_expression] = STATE(3304),
    [sym_assert_expression] = STATE(3304),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3304),
    [sym_new_expression] = STATE(3304),
    [sym_typeid_expression] = STATE(3304),
    [sym_is_expression] = STATE(3304),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3304),
    [sym_char_literal] = STATE(3304),
    [sym_array_literal] = STATE(3304),
    [sym_function_literal] = STATE(3304),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3304),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4308),
    [sym_false] = ACTIONS(4308),
    [sym_null] = ACTIONS(4308),
    [sym_super] = ACTIONS(4308),
    [sym_this] = ACTIONS(4308),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4310),
    [sym_float_literal] = ACTIONS(4310),
    [sym__string] = ACTIONS(3370),
  },
  [1323] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3139),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3139),
    [sym_primary_expression] = STATE(3139),
    [sym__primary_expr] = STATE(3139),
    [sym_index_expression] = STATE(3139),
    [sym_postfix_expression] = STATE(3139),
    [sym_unary_expression] = STATE(3139),
    [sym__unary_expr] = STATE(3139),
    [sym_property_expression] = STATE(3139),
    [sym_cast_expression] = STATE(3139),
    [sym_delete_expression] = STATE(3139),
    [sym_throw_expression] = STATE(3139),
    [sym_assert_expression] = STATE(3139),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3139),
    [sym_new_expression] = STATE(3139),
    [sym_typeid_expression] = STATE(3139),
    [sym_is_expression] = STATE(3139),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3139),
    [sym_char_literal] = STATE(3139),
    [sym_array_literal] = STATE(3139),
    [sym_function_literal] = STATE(3139),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3139),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4312),
    [sym_false] = ACTIONS(4312),
    [sym_null] = ACTIONS(4312),
    [sym_super] = ACTIONS(4312),
    [sym_this] = ACTIONS(4312),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4314),
    [sym_float_literal] = ACTIONS(4314),
    [sym__string] = ACTIONS(233),
  },
  [1324] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3139),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3139),
    [sym_primary_expression] = STATE(3139),
    [sym__primary_expr] = STATE(3139),
    [sym_index_expression] = STATE(3139),
    [sym_postfix_expression] = STATE(3139),
    [sym_unary_expression] = STATE(3139),
    [sym__unary_expr] = STATE(3139),
    [sym_property_expression] = STATE(3139),
    [sym_cast_expression] = STATE(3139),
    [sym_delete_expression] = STATE(3139),
    [sym_throw_expression] = STATE(3139),
    [sym_assert_expression] = STATE(3139),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3139),
    [sym_new_expression] = STATE(3139),
    [sym_typeid_expression] = STATE(3139),
    [sym_is_expression] = STATE(3139),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3139),
    [sym_char_literal] = STATE(3139),
    [sym_array_literal] = STATE(3139),
    [sym_function_literal] = STATE(3139),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3139),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4312),
    [sym_false] = ACTIONS(4312),
    [sym_null] = ACTIONS(4312),
    [sym_super] = ACTIONS(4312),
    [sym_this] = ACTIONS(4312),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4314),
    [sym_float_literal] = ACTIONS(4314),
    [sym__string] = ACTIONS(233),
  },
  [1325] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3151),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3151),
    [sym_primary_expression] = STATE(3151),
    [sym__primary_expr] = STATE(3151),
    [sym_index_expression] = STATE(3151),
    [sym_postfix_expression] = STATE(3151),
    [sym_unary_expression] = STATE(3151),
    [sym__unary_expr] = STATE(3151),
    [sym_property_expression] = STATE(3151),
    [sym_cast_expression] = STATE(3151),
    [sym_delete_expression] = STATE(3151),
    [sym_throw_expression] = STATE(3151),
    [sym_assert_expression] = STATE(3151),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3151),
    [sym_new_expression] = STATE(3151),
    [sym_typeid_expression] = STATE(3151),
    [sym_is_expression] = STATE(3151),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3151),
    [sym_char_literal] = STATE(3151),
    [sym_array_literal] = STATE(3151),
    [sym_function_literal] = STATE(3151),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3151),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4294),
    [sym_false] = ACTIONS(4294),
    [sym_null] = ACTIONS(4294),
    [sym_super] = ACTIONS(4294),
    [sym_this] = ACTIONS(4294),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4296),
    [sym_float_literal] = ACTIONS(4296),
    [sym__string] = ACTIONS(233),
  },
  [1326] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3078),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3078),
    [sym_primary_expression] = STATE(3078),
    [sym__primary_expr] = STATE(3078),
    [sym_index_expression] = STATE(3078),
    [sym_postfix_expression] = STATE(3078),
    [sym_unary_expression] = STATE(3078),
    [sym__unary_expr] = STATE(3078),
    [sym_property_expression] = STATE(3078),
    [sym_cast_expression] = STATE(3078),
    [sym_delete_expression] = STATE(3078),
    [sym_throw_expression] = STATE(3078),
    [sym_assert_expression] = STATE(3078),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3078),
    [sym_new_expression] = STATE(3078),
    [sym_typeid_expression] = STATE(3078),
    [sym_is_expression] = STATE(3078),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3078),
    [sym_char_literal] = STATE(3078),
    [sym_array_literal] = STATE(3078),
    [sym_function_literal] = STATE(3078),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3078),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4241),
    [sym_false] = ACTIONS(4241),
    [sym_null] = ACTIONS(4241),
    [sym_super] = ACTIONS(4241),
    [sym_this] = ACTIONS(4241),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4243),
    [sym_float_literal] = ACTIONS(4243),
    [sym__string] = ACTIONS(233),
  },
  [1327] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3160),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3160),
    [sym_primary_expression] = STATE(3160),
    [sym__primary_expr] = STATE(3160),
    [sym_index_expression] = STATE(3160),
    [sym_postfix_expression] = STATE(3160),
    [sym_unary_expression] = STATE(3160),
    [sym__unary_expr] = STATE(3160),
    [sym_property_expression] = STATE(3160),
    [sym_cast_expression] = STATE(3160),
    [sym_delete_expression] = STATE(3160),
    [sym_throw_expression] = STATE(3160),
    [sym_assert_expression] = STATE(3160),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3160),
    [sym_new_expression] = STATE(3160),
    [sym_typeid_expression] = STATE(3160),
    [sym_is_expression] = STATE(3160),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3160),
    [sym_char_literal] = STATE(3160),
    [sym_array_literal] = STATE(3160),
    [sym_function_literal] = STATE(3160),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3160),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4231),
    [sym_false] = ACTIONS(4231),
    [sym_null] = ACTIONS(4231),
    [sym_super] = ACTIONS(4231),
    [sym_this] = ACTIONS(4231),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4233),
    [sym_float_literal] = ACTIONS(4233),
    [sym__string] = ACTIONS(233),
  },
  [1328] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3163),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3302),
    [sym_call_expression] = STATE(3163),
    [sym_primary_expression] = STATE(3163),
    [sym__primary_expr] = STATE(3163),
    [sym_index_expression] = STATE(3163),
    [sym_postfix_expression] = STATE(3163),
    [sym_unary_expression] = STATE(3163),
    [sym__unary_expr] = STATE(3163),
    [sym_property_expression] = STATE(3163),
    [sym_cast_expression] = STATE(3163),
    [sym_delete_expression] = STATE(3163),
    [sym_throw_expression] = STATE(3163),
    [sym_assert_expression] = STATE(3163),
    [sym_mixin_expression] = STATE(3299),
    [sym_import_expression] = STATE(3163),
    [sym_new_expression] = STATE(3163),
    [sym_typeid_expression] = STATE(3163),
    [sym_is_expression] = STATE(3163),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3163),
    [sym_char_literal] = STATE(3163),
    [sym_array_literal] = STATE(3163),
    [sym_function_literal] = STATE(3163),
    [sym__parameter_with_member_attributes] = STATE(4159),
    [sym_special_keyword] = STATE(3163),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3298),
    [sym_traits_expression] = STATE(3299),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3234),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_AMP] = ACTIONS(3240),
    [anon_sym_DASH] = ACTIONS(3242),
    [anon_sym_DASH_DASH] = ACTIONS(3240),
    [anon_sym_PLUS] = ACTIONS(3242),
    [anon_sym_PLUS_PLUS] = ACTIONS(3240),
    [anon_sym_BANG] = ACTIONS(3240),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3240),
    [anon_sym_TILDE] = ACTIONS(3240),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4227),
    [sym_false] = ACTIONS(4227),
    [sym_null] = ACTIONS(4227),
    [sym_super] = ACTIONS(4227),
    [sym_this] = ACTIONS(4227),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3246),
    [sym_cast] = ACTIONS(3248),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3250),
    [sym_delete] = ACTIONS(3252),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3254),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3256),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3258),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4229),
    [sym_float_literal] = ACTIONS(4229),
    [sym__string] = ACTIONS(233),
  },
  [1329] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3139),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3139),
    [sym_primary_expression] = STATE(3139),
    [sym__primary_expr] = STATE(3139),
    [sym_index_expression] = STATE(3139),
    [sym_postfix_expression] = STATE(3139),
    [sym_unary_expression] = STATE(3139),
    [sym__unary_expr] = STATE(3139),
    [sym_property_expression] = STATE(3139),
    [sym_cast_expression] = STATE(3139),
    [sym_delete_expression] = STATE(3139),
    [sym_throw_expression] = STATE(3139),
    [sym_assert_expression] = STATE(3139),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3139),
    [sym_new_expression] = STATE(3139),
    [sym_typeid_expression] = STATE(3139),
    [sym_is_expression] = STATE(3139),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3139),
    [sym_char_literal] = STATE(3139),
    [sym_array_literal] = STATE(3139),
    [sym_function_literal] = STATE(3139),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3139),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4312),
    [sym_false] = ACTIONS(4312),
    [sym_null] = ACTIONS(4312),
    [sym_super] = ACTIONS(4312),
    [sym_this] = ACTIONS(4312),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4314),
    [sym_float_literal] = ACTIONS(4314),
    [sym__string] = ACTIONS(233),
  },
  [1330] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3158),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(2979),
    [sym_call_expression] = STATE(3158),
    [sym_primary_expression] = STATE(3158),
    [sym__primary_expr] = STATE(3158),
    [sym_index_expression] = STATE(3158),
    [sym_postfix_expression] = STATE(3158),
    [sym_unary_expression] = STATE(3158),
    [sym__unary_expr] = STATE(3158),
    [sym_property_expression] = STATE(3158),
    [sym_cast_expression] = STATE(3158),
    [sym_delete_expression] = STATE(3158),
    [sym_throw_expression] = STATE(3158),
    [sym_assert_expression] = STATE(3158),
    [sym_mixin_expression] = STATE(2950),
    [sym_import_expression] = STATE(3158),
    [sym_new_expression] = STATE(3158),
    [sym_typeid_expression] = STATE(3158),
    [sym_is_expression] = STATE(3158),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3158),
    [sym_char_literal] = STATE(3158),
    [sym_array_literal] = STATE(3158),
    [sym_function_literal] = STATE(3158),
    [sym__parameter_with_member_attributes] = STATE(4128),
    [sym_special_keyword] = STATE(3158),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(2982),
    [sym_traits_expression] = STATE(2950),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3015),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(87),
    [anon_sym_AMP] = ACTIONS(89),
    [anon_sym_DASH] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(89),
    [anon_sym_BANG] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(89),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4213),
    [sym_false] = ACTIONS(4213),
    [sym_null] = ACTIONS(4213),
    [sym_super] = ACTIONS(4213),
    [sym_this] = ACTIONS(4316),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3021),
    [sym_cast] = ACTIONS(121),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(131),
    [sym_delete] = ACTIONS(133),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(147),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3029),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(189),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4217),
    [sym_float_literal] = ACTIONS(4217),
    [sym__string] = ACTIONS(233),
  },
  [1331] = {
    [sym_token_string] = STATE(2971),
    [sym_dollar] = STATE(3301),
    [sym_type] = STATE(5217),
    [sym_type_ctor] = STATE(3627),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4424),
    [sym__builtin_type] = STATE(4424),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3266),
    [sym_call_expression] = STATE(3301),
    [sym_primary_expression] = STATE(3301),
    [sym__primary_expr] = STATE(3301),
    [sym_index_expression] = STATE(3301),
    [sym_postfix_expression] = STATE(3301),
    [sym_unary_expression] = STATE(3301),
    [sym__unary_expr] = STATE(3301),
    [sym_property_expression] = STATE(3301),
    [sym_cast_expression] = STATE(3301),
    [sym_delete_expression] = STATE(3301),
    [sym_throw_expression] = STATE(3301),
    [sym_assert_expression] = STATE(3301),
    [sym_mixin_expression] = STATE(3276),
    [sym_import_expression] = STATE(3301),
    [sym_new_expression] = STATE(3301),
    [sym_typeid_expression] = STATE(3301),
    [sym_is_expression] = STATE(3301),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(3301),
    [sym_char_literal] = STATE(3301),
    [sym_array_literal] = STATE(3301),
    [sym_function_literal] = STATE(3301),
    [sym__parameter_with_member_attributes] = STATE(4117),
    [sym_special_keyword] = STATE(3301),
    [sym_block_statement] = STATE(3332),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3332),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(3321),
    [sym_traits_expression] = STATE(3276),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(3292),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(3298),
    [anon_sym_AMP] = ACTIONS(3300),
    [anon_sym_DASH] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3300),
    [anon_sym_PLUS] = ACTIONS(3302),
    [anon_sym_PLUS_PLUS] = ACTIONS(3300),
    [anon_sym_BANG] = ACTIONS(3300),
    [anon_sym_LPAREN] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_DOLLAR] = ACTIONS(3310),
    [anon_sym_STAR] = ACTIONS(3300),
    [anon_sym_TILDE] = ACTIONS(3300),
    [sym_bool] = ACTIONS(3312),
    [sym_byte] = ACTIONS(3312),
    [sym_ubyte] = ACTIONS(3312),
    [sym_char] = ACTIONS(3312),
    [sym_short] = ACTIONS(3312),
    [sym_ushort] = ACTIONS(3312),
    [sym_int] = ACTIONS(3312),
    [sym_uint] = ACTIONS(3312),
    [sym_long] = ACTIONS(3312),
    [sym_ulong] = ACTIONS(3312),
    [sym_cent] = ACTIONS(3312),
    [sym_ucent] = ACTIONS(3312),
    [sym_wchar] = ACTIONS(3312),
    [sym_dchar] = ACTIONS(3312),
    [sym_float] = ACTIONS(3312),
    [sym_double] = ACTIONS(3312),
    [sym_real] = ACTIONS(3312),
    [sym_ifloat] = ACTIONS(3312),
    [sym_idouble] = ACTIONS(3312),
    [sym_ireal] = ACTIONS(3312),
    [sym_cfloat] = ACTIONS(3312),
    [sym_cdouble] = ACTIONS(3312),
    [sym_creal] = ACTIONS(3312),
    [sym_size_t] = ACTIONS(3312),
    [sym_ptrdiff_t] = ACTIONS(3312),
    [sym_string] = ACTIONS(3312),
    [sym_cstring] = ACTIONS(3312),
    [sym_dstring] = ACTIONS(3312),
    [sym_wstring] = ACTIONS(3312),
    [sym_noreturn] = ACTIONS(3312),
    [sym_true] = ACTIONS(4300),
    [sym_false] = ACTIONS(4300),
    [sym_null] = ACTIONS(4300),
    [sym_super] = ACTIONS(4300),
    [sym_this] = ACTIONS(4300),
    [sym_assert] = ACTIONS(3316),
    [sym_auto] = ACTIONS(3318),
    [sym_cast] = ACTIONS(3320),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3322),
    [sym_delete] = ACTIONS(3324),
    [sym_do] = ACTIONS(3326),
    [sym_function] = ACTIONS(3328),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3330),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(3332),
    [sym_mixin] = ACTIONS(3334),
    [sym_new] = ACTIONS(3336),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3338),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3340),
    [sym_typeid] = ACTIONS(3342),
    [sym_typeof] = ACTIONS(3344),
    [sym_traits] = ACTIONS(3346),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(3312),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4302),
    [sym_float_literal] = ACTIONS(4302),
    [sym__string] = ACTIONS(3370),
  },
  [1332] = {
    [sym_token_string] = STATE(2906),
    [sym_dollar] = STATE(3163),
    [sym_type] = STATE(5364),
    [sym_type_ctor] = STATE(3633),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4276),
    [sym__builtin_type] = STATE(4276),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(3267),
    [sym_call_expression] = STATE(3163),
    [sym_primary_expression] = STATE(3163),
    [sym__primary_expr] = STATE(3163),
    [sym_index_expression] = STATE(3163),
    [sym_postfix_expression] = STATE(3163),
    [sym_unary_expression] = STATE(3163),
    [sym__unary_expr] = STATE(3163),
    [sym_property_expression] = STATE(3163),
    [sym_cast_expression] = STATE(3163),
    [sym_delete_expression] = STATE(3163),
    [sym_throw_expression] = STATE(3163),
    [sym_assert_expression] = STATE(3163),
    [sym_mixin_expression] = STATE(3261),
    [sym_import_expression] = STATE(3163),
    [sym_new_expression] = STATE(3163),
    [sym_typeid_expression] = STATE(3163),
    [sym_is_expression] = STATE(3163),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(3163),
    [sym_char_literal] = STATE(3163),
    [sym_array_literal] = STATE(3163),
    [sym_function_literal] = STATE(3163),
    [sym__parameter_with_member_attributes] = STATE(4181),
    [sym_special_keyword] = STATE(3163),
    [sym_block_statement] = STATE(3240),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3240),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(3273),
    [sym_traits_expression] = STATE(3261),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(3648),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(3374),
    [anon_sym_AMP] = ACTIONS(3650),
    [anon_sym_DASH] = ACTIONS(3652),
    [anon_sym_DASH_DASH] = ACTIONS(3650),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_PLUS_PLUS] = ACTIONS(3650),
    [anon_sym_BANG] = ACTIONS(3650),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_DOLLAR] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(3650),
    [anon_sym_TILDE] = ACTIONS(3650),
    [sym_bool] = ACTIONS(103),
    [sym_byte] = ACTIONS(103),
    [sym_ubyte] = ACTIONS(103),
    [sym_char] = ACTIONS(103),
    [sym_short] = ACTIONS(103),
    [sym_ushort] = ACTIONS(103),
    [sym_int] = ACTIONS(103),
    [sym_uint] = ACTIONS(103),
    [sym_long] = ACTIONS(103),
    [sym_ulong] = ACTIONS(103),
    [sym_cent] = ACTIONS(103),
    [sym_ucent] = ACTIONS(103),
    [sym_wchar] = ACTIONS(103),
    [sym_dchar] = ACTIONS(103),
    [sym_float] = ACTIONS(103),
    [sym_double] = ACTIONS(103),
    [sym_real] = ACTIONS(103),
    [sym_ifloat] = ACTIONS(103),
    [sym_idouble] = ACTIONS(103),
    [sym_ireal] = ACTIONS(103),
    [sym_cfloat] = ACTIONS(103),
    [sym_cdouble] = ACTIONS(103),
    [sym_creal] = ACTIONS(103),
    [sym_size_t] = ACTIONS(103),
    [sym_ptrdiff_t] = ACTIONS(103),
    [sym_string] = ACTIONS(103),
    [sym_cstring] = ACTIONS(103),
    [sym_dstring] = ACTIONS(103),
    [sym_wstring] = ACTIONS(103),
    [sym_noreturn] = ACTIONS(103),
    [sym_true] = ACTIONS(4227),
    [sym_false] = ACTIONS(4227),
    [sym_null] = ACTIONS(4227),
    [sym_super] = ACTIONS(4227),
    [sym_this] = ACTIONS(4227),
    [sym_assert] = ACTIONS(113),
    [sym_auto] = ACTIONS(3654),
    [sym_cast] = ACTIONS(3656),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(3658),
    [sym_delete] = ACTIONS(3660),
    [sym_do] = ACTIONS(3023),
    [sym_function] = ACTIONS(3662),
    [sym_immutable] = ACTIONS(2125),
    [sym_import] = ACTIONS(3025),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_is] = ACTIONS(161),
    [sym_mixin] = ACTIONS(3027),
    [sym_new] = ACTIONS(165),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(3664),
    [sym_shared] = ACTIONS(2125),
    [sym_throw] = ACTIONS(3666),
    [sym_typeid] = ACTIONS(193),
    [sym_typeof] = ACTIONS(195),
    [sym_traits] = ACTIONS(207),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(103),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4229),
    [sym_float_literal] = ACTIONS(4229),
    [sym__string] = ACTIONS(233),
  },
  [1333] = {
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_abstract] = ACTIONS(4190),
    [sym_alias] = ACTIONS(4190),
    [sym_align] = ACTIONS(4190),
    [sym_asm] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_break] = ACTIONS(4190),
    [sym_case] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(4190),
    [sym_class] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_continue] = ACTIONS(4190),
    [sym_debug] = ACTIONS(4190),
    [sym_default] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_deprecated] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_enum] = ACTIONS(4190),
    [sym_export] = ACTIONS(4190),
    [sym_extern] = ACTIONS(4190),
    [sym_final] = ACTIONS(4190),
    [sym_finally] = ACTIONS(4190),
    [sym_for] = ACTIONS(4190),
    [sym_foreach] = ACTIONS(4190),
    [sym_foreach_reverse] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_goto] = ACTIONS(4190),
    [sym_if] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_interface] = ACTIONS(4190),
    [sym_invariant] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_nothrow] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_override] = ACTIONS(4190),
    [sym_package] = ACTIONS(4190),
    [sym_pragma] = ACTIONS(4190),
    [sym_private] = ACTIONS(4190),
    [sym_protected] = ACTIONS(4190),
    [sym_public] = ACTIONS(4190),
    [sym_pure] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_return] = ACTIONS(4190),
    [sym_scope] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_static] = ACTIONS(4190),
    [sym_struct] = ACTIONS(4190),
    [sym_switch] = ACTIONS(4190),
    [sym_synchronized] = ACTIONS(4190),
    [sym_template] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_try] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_union] = ACTIONS(4190),
    [sym_unittest] = ACTIONS(4190),
    [sym_version] = ACTIONS(4190),
    [sym_while] = ACTIONS(4190),
    [sym_with] = ACTIONS(4190),
    [sym_gshared] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1334] = {
    [sym_identifier] = ACTIONS(4318),
    [anon_sym_q_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(4320),
    [anon_sym_AMP] = ACTIONS(4320),
    [anon_sym_DASH] = ACTIONS(4318),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(4318),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_BANG] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_DOLLAR] = ACTIONS(4320),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_TILDE] = ACTIONS(4320),
    [anon_sym_AT] = ACTIONS(4320),
    [sym_bool] = ACTIONS(4318),
    [sym_byte] = ACTIONS(4318),
    [sym_ubyte] = ACTIONS(4318),
    [sym_char] = ACTIONS(4318),
    [sym_short] = ACTIONS(4318),
    [sym_ushort] = ACTIONS(4318),
    [sym_int] = ACTIONS(4318),
    [sym_uint] = ACTIONS(4318),
    [sym_long] = ACTIONS(4318),
    [sym_ulong] = ACTIONS(4318),
    [sym_cent] = ACTIONS(4318),
    [sym_ucent] = ACTIONS(4318),
    [sym_wchar] = ACTIONS(4318),
    [sym_dchar] = ACTIONS(4318),
    [sym_float] = ACTIONS(4318),
    [sym_double] = ACTIONS(4318),
    [sym_real] = ACTIONS(4318),
    [sym_ifloat] = ACTIONS(4318),
    [sym_idouble] = ACTIONS(4318),
    [sym_ireal] = ACTIONS(4318),
    [sym_cfloat] = ACTIONS(4318),
    [sym_cdouble] = ACTIONS(4318),
    [sym_creal] = ACTIONS(4318),
    [sym_size_t] = ACTIONS(4318),
    [sym_ptrdiff_t] = ACTIONS(4318),
    [sym_string] = ACTIONS(4318),
    [sym_cstring] = ACTIONS(4318),
    [sym_dstring] = ACTIONS(4318),
    [sym_wstring] = ACTIONS(4318),
    [sym_noreturn] = ACTIONS(4318),
    [sym_true] = ACTIONS(4318),
    [sym_false] = ACTIONS(4318),
    [sym_null] = ACTIONS(4318),
    [sym_super] = ACTIONS(4318),
    [sym_this] = ACTIONS(4318),
    [sym_abstract] = ACTIONS(4318),
    [sym_alias] = ACTIONS(4318),
    [sym_align] = ACTIONS(4318),
    [sym_asm] = ACTIONS(4318),
    [sym_assert] = ACTIONS(4318),
    [sym_auto] = ACTIONS(4318),
    [sym_break] = ACTIONS(4318),
    [sym_case] = ACTIONS(4318),
    [sym_cast] = ACTIONS(4318),
    [sym_catch] = ACTIONS(4318),
    [sym_class] = ACTIONS(4318),
    [sym_const] = ACTIONS(4318),
    [sym_continue] = ACTIONS(4318),
    [sym_debug] = ACTIONS(4318),
    [sym_default] = ACTIONS(4318),
    [sym_delegate] = ACTIONS(4318),
    [sym_delete] = ACTIONS(4318),
    [sym_deprecated] = ACTIONS(4318),
    [sym_do] = ACTIONS(4318),
    [sym_else] = ACTIONS(4318),
    [sym_enum] = ACTIONS(4318),
    [sym_export] = ACTIONS(4318),
    [sym_extern] = ACTIONS(4318),
    [sym_final] = ACTIONS(4318),
    [sym_finally] = ACTIONS(4318),
    [sym_for] = ACTIONS(4318),
    [sym_foreach] = ACTIONS(4318),
    [sym_foreach_reverse] = ACTIONS(4318),
    [sym_function] = ACTIONS(4318),
    [sym_goto] = ACTIONS(4318),
    [sym_if] = ACTIONS(4318),
    [sym_immutable] = ACTIONS(4318),
    [sym_import] = ACTIONS(4318),
    [sym_in] = ACTIONS(4318),
    [sym_inout] = ACTIONS(4318),
    [sym_interface] = ACTIONS(4318),
    [sym_invariant] = ACTIONS(4318),
    [sym_is] = ACTIONS(4318),
    [sym_mixin] = ACTIONS(4318),
    [sym_new] = ACTIONS(4318),
    [sym_nothrow] = ACTIONS(4318),
    [sym_out] = ACTIONS(4318),
    [sym_override] = ACTIONS(4318),
    [sym_package] = ACTIONS(4318),
    [sym_pragma] = ACTIONS(4318),
    [sym_private] = ACTIONS(4318),
    [sym_protected] = ACTIONS(4318),
    [sym_public] = ACTIONS(4318),
    [sym_pure] = ACTIONS(4318),
    [sym_ref] = ACTIONS(4318),
    [sym_return] = ACTIONS(4318),
    [sym_scope] = ACTIONS(4318),
    [sym_shared] = ACTIONS(4318),
    [sym_static] = ACTIONS(4318),
    [sym_struct] = ACTIONS(4318),
    [sym_switch] = ACTIONS(4318),
    [sym_synchronized] = ACTIONS(4318),
    [sym_template] = ACTIONS(4318),
    [sym_throw] = ACTIONS(4318),
    [sym_try] = ACTIONS(4318),
    [sym_typeid] = ACTIONS(4318),
    [sym_typeof] = ACTIONS(4318),
    [sym_union] = ACTIONS(4318),
    [sym_unittest] = ACTIONS(4318),
    [sym_version] = ACTIONS(4318),
    [sym_while] = ACTIONS(4318),
    [sym_with] = ACTIONS(4318),
    [sym_gshared] = ACTIONS(4318),
    [sym_traits] = ACTIONS(4318),
    [sym_vector] = ACTIONS(4318),
    [sym_void] = ACTIONS(4318),
    [anon_sym_BQUOTE] = ACTIONS(4320),
    [anon_sym_r_DQUOTE] = ACTIONS(4320),
    [anon_sym_x_DQUOTE] = ACTIONS(4320),
    [anon_sym_DQUOTE] = ACTIONS(4320),
    [anon_sym_i_BQUOTE] = ACTIONS(4320),
    [anon_sym_i_DQUOTE] = ACTIONS(4320),
    [anon_sym_iq_LBRACE] = ACTIONS(4320),
    [aux_sym_char_literal_token1] = ACTIONS(4320),
    [anon_sym_SQUOTE] = ACTIONS(4318),
    [anon_sym___DATE__] = ACTIONS(4318),
    [anon_sym___FILE__] = ACTIONS(4318),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4318),
    [anon_sym___FUNCTION__] = ACTIONS(4318),
    [anon_sym___LINE__] = ACTIONS(4318),
    [anon_sym___MODULE__] = ACTIONS(4318),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4318),
    [anon_sym___TIME__] = ACTIONS(4318),
    [anon_sym___TIMESTAMP__] = ACTIONS(4318),
    [anon_sym___VENDOR__] = ACTIONS(4318),
    [anon_sym___VERSION__] = ACTIONS(4318),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4320),
    [sym_float_literal] = ACTIONS(4320),
    [sym__string] = ACTIONS(4320),
  },
  [1335] = {
    [sym_identifier] = ACTIONS(4322),
    [anon_sym_q_LBRACE] = ACTIONS(4324),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4324),
    [anon_sym_DOT] = ACTIONS(4324),
    [anon_sym_AMP] = ACTIONS(4324),
    [anon_sym_DASH] = ACTIONS(4322),
    [anon_sym_DASH_DASH] = ACTIONS(4324),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_PLUS_PLUS] = ACTIONS(4324),
    [anon_sym_BANG] = ACTIONS(4324),
    [anon_sym_LPAREN] = ACTIONS(4324),
    [anon_sym_RPAREN] = ACTIONS(4324),
    [anon_sym_LBRACK] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_DOLLAR] = ACTIONS(4324),
    [anon_sym_STAR] = ACTIONS(4324),
    [anon_sym_TILDE] = ACTIONS(4324),
    [anon_sym_AT] = ACTIONS(4324),
    [sym_bool] = ACTIONS(4322),
    [sym_byte] = ACTIONS(4322),
    [sym_ubyte] = ACTIONS(4322),
    [sym_char] = ACTIONS(4322),
    [sym_short] = ACTIONS(4322),
    [sym_ushort] = ACTIONS(4322),
    [sym_int] = ACTIONS(4322),
    [sym_uint] = ACTIONS(4322),
    [sym_long] = ACTIONS(4322),
    [sym_ulong] = ACTIONS(4322),
    [sym_cent] = ACTIONS(4322),
    [sym_ucent] = ACTIONS(4322),
    [sym_wchar] = ACTIONS(4322),
    [sym_dchar] = ACTIONS(4322),
    [sym_float] = ACTIONS(4322),
    [sym_double] = ACTIONS(4322),
    [sym_real] = ACTIONS(4322),
    [sym_ifloat] = ACTIONS(4322),
    [sym_idouble] = ACTIONS(4322),
    [sym_ireal] = ACTIONS(4322),
    [sym_cfloat] = ACTIONS(4322),
    [sym_cdouble] = ACTIONS(4322),
    [sym_creal] = ACTIONS(4322),
    [sym_size_t] = ACTIONS(4322),
    [sym_ptrdiff_t] = ACTIONS(4322),
    [sym_string] = ACTIONS(4322),
    [sym_cstring] = ACTIONS(4322),
    [sym_dstring] = ACTIONS(4322),
    [sym_wstring] = ACTIONS(4322),
    [sym_noreturn] = ACTIONS(4322),
    [sym_true] = ACTIONS(4322),
    [sym_false] = ACTIONS(4322),
    [sym_null] = ACTIONS(4322),
    [sym_super] = ACTIONS(4322),
    [sym_this] = ACTIONS(4322),
    [sym_abstract] = ACTIONS(4322),
    [sym_alias] = ACTIONS(4322),
    [sym_align] = ACTIONS(4322),
    [sym_asm] = ACTIONS(4322),
    [sym_assert] = ACTIONS(4322),
    [sym_auto] = ACTIONS(4322),
    [sym_break] = ACTIONS(4322),
    [sym_case] = ACTIONS(4322),
    [sym_cast] = ACTIONS(4322),
    [sym_catch] = ACTIONS(4322),
    [sym_class] = ACTIONS(4322),
    [sym_const] = ACTIONS(4322),
    [sym_continue] = ACTIONS(4322),
    [sym_debug] = ACTIONS(4322),
    [sym_default] = ACTIONS(4322),
    [sym_delegate] = ACTIONS(4322),
    [sym_delete] = ACTIONS(4322),
    [sym_deprecated] = ACTIONS(4322),
    [sym_do] = ACTIONS(4322),
    [sym_else] = ACTIONS(4322),
    [sym_enum] = ACTIONS(4322),
    [sym_export] = ACTIONS(4322),
    [sym_extern] = ACTIONS(4322),
    [sym_final] = ACTIONS(4322),
    [sym_finally] = ACTIONS(4322),
    [sym_for] = ACTIONS(4322),
    [sym_foreach] = ACTIONS(4322),
    [sym_foreach_reverse] = ACTIONS(4322),
    [sym_function] = ACTIONS(4322),
    [sym_goto] = ACTIONS(4322),
    [sym_if] = ACTIONS(4322),
    [sym_immutable] = ACTIONS(4322),
    [sym_import] = ACTIONS(4322),
    [sym_in] = ACTIONS(4322),
    [sym_inout] = ACTIONS(4322),
    [sym_interface] = ACTIONS(4322),
    [sym_invariant] = ACTIONS(4322),
    [sym_is] = ACTIONS(4322),
    [sym_mixin] = ACTIONS(4322),
    [sym_new] = ACTIONS(4322),
    [sym_nothrow] = ACTIONS(4322),
    [sym_out] = ACTIONS(4322),
    [sym_override] = ACTIONS(4322),
    [sym_package] = ACTIONS(4322),
    [sym_pragma] = ACTIONS(4322),
    [sym_private] = ACTIONS(4322),
    [sym_protected] = ACTIONS(4322),
    [sym_public] = ACTIONS(4322),
    [sym_pure] = ACTIONS(4322),
    [sym_ref] = ACTIONS(4322),
    [sym_return] = ACTIONS(4322),
    [sym_scope] = ACTIONS(4322),
    [sym_shared] = ACTIONS(4322),
    [sym_static] = ACTIONS(4322),
    [sym_struct] = ACTIONS(4322),
    [sym_switch] = ACTIONS(4322),
    [sym_synchronized] = ACTIONS(4322),
    [sym_template] = ACTIONS(4322),
    [sym_throw] = ACTIONS(4322),
    [sym_try] = ACTIONS(4322),
    [sym_typeid] = ACTIONS(4322),
    [sym_typeof] = ACTIONS(4322),
    [sym_union] = ACTIONS(4322),
    [sym_unittest] = ACTIONS(4322),
    [sym_version] = ACTIONS(4322),
    [sym_while] = ACTIONS(4322),
    [sym_with] = ACTIONS(4322),
    [sym_gshared] = ACTIONS(4322),
    [sym_traits] = ACTIONS(4322),
    [sym_vector] = ACTIONS(4322),
    [sym_void] = ACTIONS(4322),
    [anon_sym_BQUOTE] = ACTIONS(4324),
    [anon_sym_r_DQUOTE] = ACTIONS(4324),
    [anon_sym_x_DQUOTE] = ACTIONS(4324),
    [anon_sym_DQUOTE] = ACTIONS(4324),
    [anon_sym_i_BQUOTE] = ACTIONS(4324),
    [anon_sym_i_DQUOTE] = ACTIONS(4324),
    [anon_sym_iq_LBRACE] = ACTIONS(4324),
    [aux_sym_char_literal_token1] = ACTIONS(4324),
    [anon_sym_SQUOTE] = ACTIONS(4322),
    [anon_sym___DATE__] = ACTIONS(4322),
    [anon_sym___FILE__] = ACTIONS(4322),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4322),
    [anon_sym___FUNCTION__] = ACTIONS(4322),
    [anon_sym___LINE__] = ACTIONS(4322),
    [anon_sym___MODULE__] = ACTIONS(4322),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4322),
    [anon_sym___TIME__] = ACTIONS(4322),
    [anon_sym___TIMESTAMP__] = ACTIONS(4322),
    [anon_sym___VENDOR__] = ACTIONS(4322),
    [anon_sym___VERSION__] = ACTIONS(4322),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4324),
    [sym_float_literal] = ACTIONS(4324),
    [sym__string] = ACTIONS(4324),
  },
  [1336] = {
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_q_LBRACE] = ACTIONS(4328),
    [anon_sym_RBRACE] = ACTIONS(4328),
    [anon_sym_LBRACE] = ACTIONS(4328),
    [anon_sym_DOT] = ACTIONS(4328),
    [anon_sym_AMP] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4328),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_PLUS_PLUS] = ACTIONS(4328),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_LPAREN] = ACTIONS(4328),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(4328),
    [anon_sym_SEMI] = ACTIONS(4328),
    [anon_sym_DOLLAR] = ACTIONS(4328),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_AT] = ACTIONS(4328),
    [sym_bool] = ACTIONS(4326),
    [sym_byte] = ACTIONS(4326),
    [sym_ubyte] = ACTIONS(4326),
    [sym_char] = ACTIONS(4326),
    [sym_short] = ACTIONS(4326),
    [sym_ushort] = ACTIONS(4326),
    [sym_int] = ACTIONS(4326),
    [sym_uint] = ACTIONS(4326),
    [sym_long] = ACTIONS(4326),
    [sym_ulong] = ACTIONS(4326),
    [sym_cent] = ACTIONS(4326),
    [sym_ucent] = ACTIONS(4326),
    [sym_wchar] = ACTIONS(4326),
    [sym_dchar] = ACTIONS(4326),
    [sym_float] = ACTIONS(4326),
    [sym_double] = ACTIONS(4326),
    [sym_real] = ACTIONS(4326),
    [sym_ifloat] = ACTIONS(4326),
    [sym_idouble] = ACTIONS(4326),
    [sym_ireal] = ACTIONS(4326),
    [sym_cfloat] = ACTIONS(4326),
    [sym_cdouble] = ACTIONS(4326),
    [sym_creal] = ACTIONS(4326),
    [sym_size_t] = ACTIONS(4326),
    [sym_ptrdiff_t] = ACTIONS(4326),
    [sym_string] = ACTIONS(4326),
    [sym_cstring] = ACTIONS(4326),
    [sym_dstring] = ACTIONS(4326),
    [sym_wstring] = ACTIONS(4326),
    [sym_noreturn] = ACTIONS(4326),
    [sym_true] = ACTIONS(4326),
    [sym_false] = ACTIONS(4326),
    [sym_null] = ACTIONS(4326),
    [sym_super] = ACTIONS(4326),
    [sym_this] = ACTIONS(4326),
    [sym_abstract] = ACTIONS(4326),
    [sym_alias] = ACTIONS(4326),
    [sym_align] = ACTIONS(4326),
    [sym_asm] = ACTIONS(4326),
    [sym_assert] = ACTIONS(4326),
    [sym_auto] = ACTIONS(4326),
    [sym_break] = ACTIONS(4326),
    [sym_case] = ACTIONS(4326),
    [sym_cast] = ACTIONS(4326),
    [sym_catch] = ACTIONS(4326),
    [sym_class] = ACTIONS(4326),
    [sym_const] = ACTIONS(4326),
    [sym_continue] = ACTIONS(4326),
    [sym_debug] = ACTIONS(4326),
    [sym_default] = ACTIONS(4326),
    [sym_delegate] = ACTIONS(4326),
    [sym_delete] = ACTIONS(4326),
    [sym_deprecated] = ACTIONS(4326),
    [sym_do] = ACTIONS(4326),
    [sym_else] = ACTIONS(4326),
    [sym_enum] = ACTIONS(4326),
    [sym_export] = ACTIONS(4326),
    [sym_extern] = ACTIONS(4326),
    [sym_final] = ACTIONS(4326),
    [sym_finally] = ACTIONS(4326),
    [sym_for] = ACTIONS(4326),
    [sym_foreach] = ACTIONS(4326),
    [sym_foreach_reverse] = ACTIONS(4326),
    [sym_function] = ACTIONS(4326),
    [sym_goto] = ACTIONS(4326),
    [sym_if] = ACTIONS(4326),
    [sym_immutable] = ACTIONS(4326),
    [sym_import] = ACTIONS(4326),
    [sym_in] = ACTIONS(4326),
    [sym_inout] = ACTIONS(4326),
    [sym_interface] = ACTIONS(4326),
    [sym_invariant] = ACTIONS(4326),
    [sym_is] = ACTIONS(4326),
    [sym_mixin] = ACTIONS(4326),
    [sym_new] = ACTIONS(4326),
    [sym_nothrow] = ACTIONS(4326),
    [sym_out] = ACTIONS(4326),
    [sym_override] = ACTIONS(4326),
    [sym_package] = ACTIONS(4326),
    [sym_pragma] = ACTIONS(4326),
    [sym_private] = ACTIONS(4326),
    [sym_protected] = ACTIONS(4326),
    [sym_public] = ACTIONS(4326),
    [sym_pure] = ACTIONS(4326),
    [sym_ref] = ACTIONS(4326),
    [sym_return] = ACTIONS(4326),
    [sym_scope] = ACTIONS(4326),
    [sym_shared] = ACTIONS(4326),
    [sym_static] = ACTIONS(4326),
    [sym_struct] = ACTIONS(4326),
    [sym_switch] = ACTIONS(4326),
    [sym_synchronized] = ACTIONS(4326),
    [sym_template] = ACTIONS(4326),
    [sym_throw] = ACTIONS(4326),
    [sym_try] = ACTIONS(4326),
    [sym_typeid] = ACTIONS(4326),
    [sym_typeof] = ACTIONS(4326),
    [sym_union] = ACTIONS(4326),
    [sym_unittest] = ACTIONS(4326),
    [sym_version] = ACTIONS(4326),
    [sym_while] = ACTIONS(4326),
    [sym_with] = ACTIONS(4326),
    [sym_gshared] = ACTIONS(4326),
    [sym_traits] = ACTIONS(4326),
    [sym_vector] = ACTIONS(4326),
    [sym_void] = ACTIONS(4326),
    [anon_sym_BQUOTE] = ACTIONS(4328),
    [anon_sym_r_DQUOTE] = ACTIONS(4328),
    [anon_sym_x_DQUOTE] = ACTIONS(4328),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_i_BQUOTE] = ACTIONS(4328),
    [anon_sym_i_DQUOTE] = ACTIONS(4328),
    [anon_sym_iq_LBRACE] = ACTIONS(4328),
    [aux_sym_char_literal_token1] = ACTIONS(4328),
    [anon_sym_SQUOTE] = ACTIONS(4326),
    [anon_sym___DATE__] = ACTIONS(4326),
    [anon_sym___FILE__] = ACTIONS(4326),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4326),
    [anon_sym___FUNCTION__] = ACTIONS(4326),
    [anon_sym___LINE__] = ACTIONS(4326),
    [anon_sym___MODULE__] = ACTIONS(4326),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4326),
    [anon_sym___TIME__] = ACTIONS(4326),
    [anon_sym___TIMESTAMP__] = ACTIONS(4326),
    [anon_sym___VENDOR__] = ACTIONS(4326),
    [anon_sym___VERSION__] = ACTIONS(4326),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4328),
    [sym_float_literal] = ACTIONS(4328),
    [sym__string] = ACTIONS(4328),
  },
  [1337] = {
    [sym_identifier] = ACTIONS(4330),
    [anon_sym_q_LBRACE] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_DOT] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [anon_sym_RPAREN] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_DOLLAR] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_AT] = ACTIONS(4332),
    [sym_bool] = ACTIONS(4330),
    [sym_byte] = ACTIONS(4330),
    [sym_ubyte] = ACTIONS(4330),
    [sym_char] = ACTIONS(4330),
    [sym_short] = ACTIONS(4330),
    [sym_ushort] = ACTIONS(4330),
    [sym_int] = ACTIONS(4330),
    [sym_uint] = ACTIONS(4330),
    [sym_long] = ACTIONS(4330),
    [sym_ulong] = ACTIONS(4330),
    [sym_cent] = ACTIONS(4330),
    [sym_ucent] = ACTIONS(4330),
    [sym_wchar] = ACTIONS(4330),
    [sym_dchar] = ACTIONS(4330),
    [sym_float] = ACTIONS(4330),
    [sym_double] = ACTIONS(4330),
    [sym_real] = ACTIONS(4330),
    [sym_ifloat] = ACTIONS(4330),
    [sym_idouble] = ACTIONS(4330),
    [sym_ireal] = ACTIONS(4330),
    [sym_cfloat] = ACTIONS(4330),
    [sym_cdouble] = ACTIONS(4330),
    [sym_creal] = ACTIONS(4330),
    [sym_size_t] = ACTIONS(4330),
    [sym_ptrdiff_t] = ACTIONS(4330),
    [sym_string] = ACTIONS(4330),
    [sym_cstring] = ACTIONS(4330),
    [sym_dstring] = ACTIONS(4330),
    [sym_wstring] = ACTIONS(4330),
    [sym_noreturn] = ACTIONS(4330),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_super] = ACTIONS(4330),
    [sym_this] = ACTIONS(4330),
    [sym_abstract] = ACTIONS(4330),
    [sym_alias] = ACTIONS(4330),
    [sym_align] = ACTIONS(4330),
    [sym_asm] = ACTIONS(4330),
    [sym_assert] = ACTIONS(4330),
    [sym_auto] = ACTIONS(4330),
    [sym_break] = ACTIONS(4330),
    [sym_case] = ACTIONS(4330),
    [sym_cast] = ACTIONS(4330),
    [sym_catch] = ACTIONS(4330),
    [sym_class] = ACTIONS(4330),
    [sym_const] = ACTIONS(4330),
    [sym_continue] = ACTIONS(4330),
    [sym_debug] = ACTIONS(4330),
    [sym_default] = ACTIONS(4330),
    [sym_delegate] = ACTIONS(4330),
    [sym_delete] = ACTIONS(4330),
    [sym_deprecated] = ACTIONS(4330),
    [sym_do] = ACTIONS(4330),
    [sym_else] = ACTIONS(4330),
    [sym_enum] = ACTIONS(4330),
    [sym_export] = ACTIONS(4330),
    [sym_extern] = ACTIONS(4330),
    [sym_final] = ACTIONS(4330),
    [sym_finally] = ACTIONS(4330),
    [sym_for] = ACTIONS(4330),
    [sym_foreach] = ACTIONS(4330),
    [sym_foreach_reverse] = ACTIONS(4330),
    [sym_function] = ACTIONS(4330),
    [sym_goto] = ACTIONS(4330),
    [sym_if] = ACTIONS(4330),
    [sym_immutable] = ACTIONS(4330),
    [sym_import] = ACTIONS(4330),
    [sym_in] = ACTIONS(4330),
    [sym_inout] = ACTIONS(4330),
    [sym_interface] = ACTIONS(4330),
    [sym_invariant] = ACTIONS(4330),
    [sym_is] = ACTIONS(4330),
    [sym_mixin] = ACTIONS(4330),
    [sym_new] = ACTIONS(4330),
    [sym_nothrow] = ACTIONS(4330),
    [sym_out] = ACTIONS(4330),
    [sym_override] = ACTIONS(4330),
    [sym_package] = ACTIONS(4330),
    [sym_pragma] = ACTIONS(4330),
    [sym_private] = ACTIONS(4330),
    [sym_protected] = ACTIONS(4330),
    [sym_public] = ACTIONS(4330),
    [sym_pure] = ACTIONS(4330),
    [sym_ref] = ACTIONS(4330),
    [sym_return] = ACTIONS(4330),
    [sym_scope] = ACTIONS(4330),
    [sym_shared] = ACTIONS(4330),
    [sym_static] = ACTIONS(4330),
    [sym_struct] = ACTIONS(4330),
    [sym_switch] = ACTIONS(4330),
    [sym_synchronized] = ACTIONS(4330),
    [sym_template] = ACTIONS(4330),
    [sym_throw] = ACTIONS(4330),
    [sym_try] = ACTIONS(4330),
    [sym_typeid] = ACTIONS(4330),
    [sym_typeof] = ACTIONS(4330),
    [sym_union] = ACTIONS(4330),
    [sym_unittest] = ACTIONS(4330),
    [sym_version] = ACTIONS(4330),
    [sym_while] = ACTIONS(4330),
    [sym_with] = ACTIONS(4330),
    [sym_gshared] = ACTIONS(4330),
    [sym_traits] = ACTIONS(4330),
    [sym_vector] = ACTIONS(4330),
    [sym_void] = ACTIONS(4330),
    [anon_sym_BQUOTE] = ACTIONS(4332),
    [anon_sym_r_DQUOTE] = ACTIONS(4332),
    [anon_sym_x_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4332),
    [anon_sym_i_BQUOTE] = ACTIONS(4332),
    [anon_sym_i_DQUOTE] = ACTIONS(4332),
    [anon_sym_iq_LBRACE] = ACTIONS(4332),
    [aux_sym_char_literal_token1] = ACTIONS(4332),
    [anon_sym_SQUOTE] = ACTIONS(4330),
    [anon_sym___DATE__] = ACTIONS(4330),
    [anon_sym___FILE__] = ACTIONS(4330),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4330),
    [anon_sym___FUNCTION__] = ACTIONS(4330),
    [anon_sym___LINE__] = ACTIONS(4330),
    [anon_sym___MODULE__] = ACTIONS(4330),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4330),
    [anon_sym___TIME__] = ACTIONS(4330),
    [anon_sym___TIMESTAMP__] = ACTIONS(4330),
    [anon_sym___VENDOR__] = ACTIONS(4330),
    [anon_sym___VERSION__] = ACTIONS(4330),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4332),
    [sym_float_literal] = ACTIONS(4332),
    [sym__string] = ACTIONS(4332),
  },
  [1338] = {
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_q_LBRACE] = ACTIONS(4336),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4334),
    [anon_sym_DASH_DASH] = ACTIONS(4336),
    [anon_sym_PLUS] = ACTIONS(4334),
    [anon_sym_PLUS_PLUS] = ACTIONS(4336),
    [anon_sym_BANG] = ACTIONS(4336),
    [anon_sym_LPAREN] = ACTIONS(4336),
    [anon_sym_RPAREN] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_DOLLAR] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4336),
    [anon_sym_AT] = ACTIONS(4336),
    [sym_bool] = ACTIONS(4334),
    [sym_byte] = ACTIONS(4334),
    [sym_ubyte] = ACTIONS(4334),
    [sym_char] = ACTIONS(4334),
    [sym_short] = ACTIONS(4334),
    [sym_ushort] = ACTIONS(4334),
    [sym_int] = ACTIONS(4334),
    [sym_uint] = ACTIONS(4334),
    [sym_long] = ACTIONS(4334),
    [sym_ulong] = ACTIONS(4334),
    [sym_cent] = ACTIONS(4334),
    [sym_ucent] = ACTIONS(4334),
    [sym_wchar] = ACTIONS(4334),
    [sym_dchar] = ACTIONS(4334),
    [sym_float] = ACTIONS(4334),
    [sym_double] = ACTIONS(4334),
    [sym_real] = ACTIONS(4334),
    [sym_ifloat] = ACTIONS(4334),
    [sym_idouble] = ACTIONS(4334),
    [sym_ireal] = ACTIONS(4334),
    [sym_cfloat] = ACTIONS(4334),
    [sym_cdouble] = ACTIONS(4334),
    [sym_creal] = ACTIONS(4334),
    [sym_size_t] = ACTIONS(4334),
    [sym_ptrdiff_t] = ACTIONS(4334),
    [sym_string] = ACTIONS(4334),
    [sym_cstring] = ACTIONS(4334),
    [sym_dstring] = ACTIONS(4334),
    [sym_wstring] = ACTIONS(4334),
    [sym_noreturn] = ACTIONS(4334),
    [sym_true] = ACTIONS(4334),
    [sym_false] = ACTIONS(4334),
    [sym_null] = ACTIONS(4334),
    [sym_super] = ACTIONS(4334),
    [sym_this] = ACTIONS(4334),
    [sym_abstract] = ACTIONS(4334),
    [sym_alias] = ACTIONS(4334),
    [sym_align] = ACTIONS(4334),
    [sym_asm] = ACTIONS(4334),
    [sym_assert] = ACTIONS(4334),
    [sym_auto] = ACTIONS(4334),
    [sym_break] = ACTIONS(4334),
    [sym_case] = ACTIONS(4334),
    [sym_cast] = ACTIONS(4334),
    [sym_catch] = ACTIONS(4334),
    [sym_class] = ACTIONS(4334),
    [sym_const] = ACTIONS(4334),
    [sym_continue] = ACTIONS(4334),
    [sym_debug] = ACTIONS(4334),
    [sym_default] = ACTIONS(4334),
    [sym_delegate] = ACTIONS(4334),
    [sym_delete] = ACTIONS(4334),
    [sym_deprecated] = ACTIONS(4334),
    [sym_do] = ACTIONS(4334),
    [sym_else] = ACTIONS(4334),
    [sym_enum] = ACTIONS(4334),
    [sym_export] = ACTIONS(4334),
    [sym_extern] = ACTIONS(4334),
    [sym_final] = ACTIONS(4334),
    [sym_finally] = ACTIONS(4334),
    [sym_for] = ACTIONS(4334),
    [sym_foreach] = ACTIONS(4334),
    [sym_foreach_reverse] = ACTIONS(4334),
    [sym_function] = ACTIONS(4334),
    [sym_goto] = ACTIONS(4334),
    [sym_if] = ACTIONS(4334),
    [sym_immutable] = ACTIONS(4334),
    [sym_import] = ACTIONS(4334),
    [sym_in] = ACTIONS(4334),
    [sym_inout] = ACTIONS(4334),
    [sym_interface] = ACTIONS(4334),
    [sym_invariant] = ACTIONS(4334),
    [sym_is] = ACTIONS(4334),
    [sym_mixin] = ACTIONS(4334),
    [sym_new] = ACTIONS(4334),
    [sym_nothrow] = ACTIONS(4334),
    [sym_out] = ACTIONS(4334),
    [sym_override] = ACTIONS(4334),
    [sym_package] = ACTIONS(4334),
    [sym_pragma] = ACTIONS(4334),
    [sym_private] = ACTIONS(4334),
    [sym_protected] = ACTIONS(4334),
    [sym_public] = ACTIONS(4334),
    [sym_pure] = ACTIONS(4334),
    [sym_ref] = ACTIONS(4334),
    [sym_return] = ACTIONS(4334),
    [sym_scope] = ACTIONS(4334),
    [sym_shared] = ACTIONS(4334),
    [sym_static] = ACTIONS(4334),
    [sym_struct] = ACTIONS(4334),
    [sym_switch] = ACTIONS(4334),
    [sym_synchronized] = ACTIONS(4334),
    [sym_template] = ACTIONS(4334),
    [sym_throw] = ACTIONS(4334),
    [sym_try] = ACTIONS(4334),
    [sym_typeid] = ACTIONS(4334),
    [sym_typeof] = ACTIONS(4334),
    [sym_union] = ACTIONS(4334),
    [sym_unittest] = ACTIONS(4334),
    [sym_version] = ACTIONS(4334),
    [sym_while] = ACTIONS(4334),
    [sym_with] = ACTIONS(4334),
    [sym_gshared] = ACTIONS(4334),
    [sym_traits] = ACTIONS(4334),
    [sym_vector] = ACTIONS(4334),
    [sym_void] = ACTIONS(4334),
    [anon_sym_BQUOTE] = ACTIONS(4336),
    [anon_sym_r_DQUOTE] = ACTIONS(4336),
    [anon_sym_x_DQUOTE] = ACTIONS(4336),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_i_BQUOTE] = ACTIONS(4336),
    [anon_sym_i_DQUOTE] = ACTIONS(4336),
    [anon_sym_iq_LBRACE] = ACTIONS(4336),
    [aux_sym_char_literal_token1] = ACTIONS(4336),
    [anon_sym_SQUOTE] = ACTIONS(4334),
    [anon_sym___DATE__] = ACTIONS(4334),
    [anon_sym___FILE__] = ACTIONS(4334),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4334),
    [anon_sym___FUNCTION__] = ACTIONS(4334),
    [anon_sym___LINE__] = ACTIONS(4334),
    [anon_sym___MODULE__] = ACTIONS(4334),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4334),
    [anon_sym___TIME__] = ACTIONS(4334),
    [anon_sym___TIMESTAMP__] = ACTIONS(4334),
    [anon_sym___VENDOR__] = ACTIONS(4334),
    [anon_sym___VERSION__] = ACTIONS(4334),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4336),
    [sym_float_literal] = ACTIONS(4336),
    [sym__string] = ACTIONS(4336),
  },
  [1339] = {
    [sym_identifier] = ACTIONS(4338),
    [anon_sym_q_LBRACE] = ACTIONS(4340),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_LBRACE] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4340),
    [anon_sym_DASH] = ACTIONS(4338),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_BANG] = ACTIONS(4340),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_RPAREN] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_DOLLAR] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4340),
    [anon_sym_TILDE] = ACTIONS(4340),
    [anon_sym_AT] = ACTIONS(4340),
    [sym_bool] = ACTIONS(4338),
    [sym_byte] = ACTIONS(4338),
    [sym_ubyte] = ACTIONS(4338),
    [sym_char] = ACTIONS(4338),
    [sym_short] = ACTIONS(4338),
    [sym_ushort] = ACTIONS(4338),
    [sym_int] = ACTIONS(4338),
    [sym_uint] = ACTIONS(4338),
    [sym_long] = ACTIONS(4338),
    [sym_ulong] = ACTIONS(4338),
    [sym_cent] = ACTIONS(4338),
    [sym_ucent] = ACTIONS(4338),
    [sym_wchar] = ACTIONS(4338),
    [sym_dchar] = ACTIONS(4338),
    [sym_float] = ACTIONS(4338),
    [sym_double] = ACTIONS(4338),
    [sym_real] = ACTIONS(4338),
    [sym_ifloat] = ACTIONS(4338),
    [sym_idouble] = ACTIONS(4338),
    [sym_ireal] = ACTIONS(4338),
    [sym_cfloat] = ACTIONS(4338),
    [sym_cdouble] = ACTIONS(4338),
    [sym_creal] = ACTIONS(4338),
    [sym_size_t] = ACTIONS(4338),
    [sym_ptrdiff_t] = ACTIONS(4338),
    [sym_string] = ACTIONS(4338),
    [sym_cstring] = ACTIONS(4338),
    [sym_dstring] = ACTIONS(4338),
    [sym_wstring] = ACTIONS(4338),
    [sym_noreturn] = ACTIONS(4338),
    [sym_true] = ACTIONS(4338),
    [sym_false] = ACTIONS(4338),
    [sym_null] = ACTIONS(4338),
    [sym_super] = ACTIONS(4338),
    [sym_this] = ACTIONS(4338),
    [sym_abstract] = ACTIONS(4338),
    [sym_alias] = ACTIONS(4338),
    [sym_align] = ACTIONS(4338),
    [sym_asm] = ACTIONS(4338),
    [sym_assert] = ACTIONS(4338),
    [sym_auto] = ACTIONS(4338),
    [sym_break] = ACTIONS(4338),
    [sym_case] = ACTIONS(4338),
    [sym_cast] = ACTIONS(4338),
    [sym_catch] = ACTIONS(4338),
    [sym_class] = ACTIONS(4338),
    [sym_const] = ACTIONS(4338),
    [sym_continue] = ACTIONS(4338),
    [sym_debug] = ACTIONS(4338),
    [sym_default] = ACTIONS(4338),
    [sym_delegate] = ACTIONS(4338),
    [sym_delete] = ACTIONS(4338),
    [sym_deprecated] = ACTIONS(4338),
    [sym_do] = ACTIONS(4338),
    [sym_else] = ACTIONS(4338),
    [sym_enum] = ACTIONS(4338),
    [sym_export] = ACTIONS(4338),
    [sym_extern] = ACTIONS(4338),
    [sym_final] = ACTIONS(4338),
    [sym_finally] = ACTIONS(4338),
    [sym_for] = ACTIONS(4338),
    [sym_foreach] = ACTIONS(4338),
    [sym_foreach_reverse] = ACTIONS(4338),
    [sym_function] = ACTIONS(4338),
    [sym_goto] = ACTIONS(4338),
    [sym_if] = ACTIONS(4338),
    [sym_immutable] = ACTIONS(4338),
    [sym_import] = ACTIONS(4338),
    [sym_in] = ACTIONS(4338),
    [sym_inout] = ACTIONS(4338),
    [sym_interface] = ACTIONS(4338),
    [sym_invariant] = ACTIONS(4338),
    [sym_is] = ACTIONS(4338),
    [sym_mixin] = ACTIONS(4338),
    [sym_new] = ACTIONS(4338),
    [sym_nothrow] = ACTIONS(4338),
    [sym_out] = ACTIONS(4338),
    [sym_override] = ACTIONS(4338),
    [sym_package] = ACTIONS(4338),
    [sym_pragma] = ACTIONS(4338),
    [sym_private] = ACTIONS(4338),
    [sym_protected] = ACTIONS(4338),
    [sym_public] = ACTIONS(4338),
    [sym_pure] = ACTIONS(4338),
    [sym_ref] = ACTIONS(4338),
    [sym_return] = ACTIONS(4338),
    [sym_scope] = ACTIONS(4338),
    [sym_shared] = ACTIONS(4338),
    [sym_static] = ACTIONS(4338),
    [sym_struct] = ACTIONS(4338),
    [sym_switch] = ACTIONS(4338),
    [sym_synchronized] = ACTIONS(4338),
    [sym_template] = ACTIONS(4338),
    [sym_throw] = ACTIONS(4338),
    [sym_try] = ACTIONS(4338),
    [sym_typeid] = ACTIONS(4338),
    [sym_typeof] = ACTIONS(4338),
    [sym_union] = ACTIONS(4338),
    [sym_unittest] = ACTIONS(4338),
    [sym_version] = ACTIONS(4338),
    [sym_while] = ACTIONS(4338),
    [sym_with] = ACTIONS(4338),
    [sym_gshared] = ACTIONS(4338),
    [sym_traits] = ACTIONS(4338),
    [sym_vector] = ACTIONS(4338),
    [sym_void] = ACTIONS(4338),
    [anon_sym_BQUOTE] = ACTIONS(4340),
    [anon_sym_r_DQUOTE] = ACTIONS(4340),
    [anon_sym_x_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [anon_sym_i_BQUOTE] = ACTIONS(4340),
    [anon_sym_i_DQUOTE] = ACTIONS(4340),
    [anon_sym_iq_LBRACE] = ACTIONS(4340),
    [aux_sym_char_literal_token1] = ACTIONS(4340),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym___DATE__] = ACTIONS(4338),
    [anon_sym___FILE__] = ACTIONS(4338),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4338),
    [anon_sym___FUNCTION__] = ACTIONS(4338),
    [anon_sym___LINE__] = ACTIONS(4338),
    [anon_sym___MODULE__] = ACTIONS(4338),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4338),
    [anon_sym___TIME__] = ACTIONS(4338),
    [anon_sym___TIMESTAMP__] = ACTIONS(4338),
    [anon_sym___VENDOR__] = ACTIONS(4338),
    [anon_sym___VERSION__] = ACTIONS(4338),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4340),
    [sym_float_literal] = ACTIONS(4340),
    [sym__string] = ACTIONS(4340),
  },
  [1340] = {
    [sym_identifier] = ACTIONS(4342),
    [anon_sym_q_LBRACE] = ACTIONS(4344),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_LBRACE] = ACTIONS(4344),
    [anon_sym_DOT] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(4344),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4344),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_PLUS_PLUS] = ACTIONS(4344),
    [anon_sym_BANG] = ACTIONS(4344),
    [anon_sym_LPAREN] = ACTIONS(4344),
    [anon_sym_RPAREN] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(4344),
    [anon_sym_SEMI] = ACTIONS(4344),
    [anon_sym_DOLLAR] = ACTIONS(4344),
    [anon_sym_STAR] = ACTIONS(4344),
    [anon_sym_TILDE] = ACTIONS(4344),
    [anon_sym_AT] = ACTIONS(4344),
    [sym_bool] = ACTIONS(4342),
    [sym_byte] = ACTIONS(4342),
    [sym_ubyte] = ACTIONS(4342),
    [sym_char] = ACTIONS(4342),
    [sym_short] = ACTIONS(4342),
    [sym_ushort] = ACTIONS(4342),
    [sym_int] = ACTIONS(4342),
    [sym_uint] = ACTIONS(4342),
    [sym_long] = ACTIONS(4342),
    [sym_ulong] = ACTIONS(4342),
    [sym_cent] = ACTIONS(4342),
    [sym_ucent] = ACTIONS(4342),
    [sym_wchar] = ACTIONS(4342),
    [sym_dchar] = ACTIONS(4342),
    [sym_float] = ACTIONS(4342),
    [sym_double] = ACTIONS(4342),
    [sym_real] = ACTIONS(4342),
    [sym_ifloat] = ACTIONS(4342),
    [sym_idouble] = ACTIONS(4342),
    [sym_ireal] = ACTIONS(4342),
    [sym_cfloat] = ACTIONS(4342),
    [sym_cdouble] = ACTIONS(4342),
    [sym_creal] = ACTIONS(4342),
    [sym_size_t] = ACTIONS(4342),
    [sym_ptrdiff_t] = ACTIONS(4342),
    [sym_string] = ACTIONS(4342),
    [sym_cstring] = ACTIONS(4342),
    [sym_dstring] = ACTIONS(4342),
    [sym_wstring] = ACTIONS(4342),
    [sym_noreturn] = ACTIONS(4342),
    [sym_true] = ACTIONS(4342),
    [sym_false] = ACTIONS(4342),
    [sym_null] = ACTIONS(4342),
    [sym_super] = ACTIONS(4342),
    [sym_this] = ACTIONS(4342),
    [sym_abstract] = ACTIONS(4342),
    [sym_alias] = ACTIONS(4342),
    [sym_align] = ACTIONS(4342),
    [sym_asm] = ACTIONS(4342),
    [sym_assert] = ACTIONS(4342),
    [sym_auto] = ACTIONS(4342),
    [sym_break] = ACTIONS(4342),
    [sym_case] = ACTIONS(4342),
    [sym_cast] = ACTIONS(4342),
    [sym_catch] = ACTIONS(4342),
    [sym_class] = ACTIONS(4342),
    [sym_const] = ACTIONS(4342),
    [sym_continue] = ACTIONS(4342),
    [sym_debug] = ACTIONS(4342),
    [sym_default] = ACTIONS(4342),
    [sym_delegate] = ACTIONS(4342),
    [sym_delete] = ACTIONS(4342),
    [sym_deprecated] = ACTIONS(4342),
    [sym_do] = ACTIONS(4342),
    [sym_else] = ACTIONS(4342),
    [sym_enum] = ACTIONS(4342),
    [sym_export] = ACTIONS(4342),
    [sym_extern] = ACTIONS(4342),
    [sym_final] = ACTIONS(4342),
    [sym_finally] = ACTIONS(4342),
    [sym_for] = ACTIONS(4342),
    [sym_foreach] = ACTIONS(4342),
    [sym_foreach_reverse] = ACTIONS(4342),
    [sym_function] = ACTIONS(4342),
    [sym_goto] = ACTIONS(4342),
    [sym_if] = ACTIONS(4342),
    [sym_immutable] = ACTIONS(4342),
    [sym_import] = ACTIONS(4342),
    [sym_in] = ACTIONS(4342),
    [sym_inout] = ACTIONS(4342),
    [sym_interface] = ACTIONS(4342),
    [sym_invariant] = ACTIONS(4342),
    [sym_is] = ACTIONS(4342),
    [sym_mixin] = ACTIONS(4342),
    [sym_new] = ACTIONS(4342),
    [sym_nothrow] = ACTIONS(4342),
    [sym_out] = ACTIONS(4342),
    [sym_override] = ACTIONS(4342),
    [sym_package] = ACTIONS(4342),
    [sym_pragma] = ACTIONS(4342),
    [sym_private] = ACTIONS(4342),
    [sym_protected] = ACTIONS(4342),
    [sym_public] = ACTIONS(4342),
    [sym_pure] = ACTIONS(4342),
    [sym_ref] = ACTIONS(4342),
    [sym_return] = ACTIONS(4342),
    [sym_scope] = ACTIONS(4342),
    [sym_shared] = ACTIONS(4342),
    [sym_static] = ACTIONS(4342),
    [sym_struct] = ACTIONS(4342),
    [sym_switch] = ACTIONS(4342),
    [sym_synchronized] = ACTIONS(4342),
    [sym_template] = ACTIONS(4342),
    [sym_throw] = ACTIONS(4342),
    [sym_try] = ACTIONS(4342),
    [sym_typeid] = ACTIONS(4342),
    [sym_typeof] = ACTIONS(4342),
    [sym_union] = ACTIONS(4342),
    [sym_unittest] = ACTIONS(4342),
    [sym_version] = ACTIONS(4342),
    [sym_while] = ACTIONS(4342),
    [sym_with] = ACTIONS(4342),
    [sym_gshared] = ACTIONS(4342),
    [sym_traits] = ACTIONS(4342),
    [sym_vector] = ACTIONS(4342),
    [sym_void] = ACTIONS(4342),
    [anon_sym_BQUOTE] = ACTIONS(4344),
    [anon_sym_r_DQUOTE] = ACTIONS(4344),
    [anon_sym_x_DQUOTE] = ACTIONS(4344),
    [anon_sym_DQUOTE] = ACTIONS(4344),
    [anon_sym_i_BQUOTE] = ACTIONS(4344),
    [anon_sym_i_DQUOTE] = ACTIONS(4344),
    [anon_sym_iq_LBRACE] = ACTIONS(4344),
    [aux_sym_char_literal_token1] = ACTIONS(4344),
    [anon_sym_SQUOTE] = ACTIONS(4342),
    [anon_sym___DATE__] = ACTIONS(4342),
    [anon_sym___FILE__] = ACTIONS(4342),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4342),
    [anon_sym___FUNCTION__] = ACTIONS(4342),
    [anon_sym___LINE__] = ACTIONS(4342),
    [anon_sym___MODULE__] = ACTIONS(4342),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4342),
    [anon_sym___TIME__] = ACTIONS(4342),
    [anon_sym___TIMESTAMP__] = ACTIONS(4342),
    [anon_sym___VENDOR__] = ACTIONS(4342),
    [anon_sym___VERSION__] = ACTIONS(4342),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4344),
    [sym_float_literal] = ACTIONS(4344),
    [sym__string] = ACTIONS(4344),
  },
  [1341] = {
    [sym_identifier] = ACTIONS(4346),
    [anon_sym_q_LBRACE] = ACTIONS(4348),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_LBRACE] = ACTIONS(4348),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_DASH] = ACTIONS(4346),
    [anon_sym_DASH_DASH] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(4348),
    [anon_sym_BANG] = ACTIONS(4348),
    [anon_sym_LPAREN] = ACTIONS(4348),
    [anon_sym_RPAREN] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_DOLLAR] = ACTIONS(4348),
    [anon_sym_STAR] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4348),
    [anon_sym_AT] = ACTIONS(4348),
    [sym_bool] = ACTIONS(4346),
    [sym_byte] = ACTIONS(4346),
    [sym_ubyte] = ACTIONS(4346),
    [sym_char] = ACTIONS(4346),
    [sym_short] = ACTIONS(4346),
    [sym_ushort] = ACTIONS(4346),
    [sym_int] = ACTIONS(4346),
    [sym_uint] = ACTIONS(4346),
    [sym_long] = ACTIONS(4346),
    [sym_ulong] = ACTIONS(4346),
    [sym_cent] = ACTIONS(4346),
    [sym_ucent] = ACTIONS(4346),
    [sym_wchar] = ACTIONS(4346),
    [sym_dchar] = ACTIONS(4346),
    [sym_float] = ACTIONS(4346),
    [sym_double] = ACTIONS(4346),
    [sym_real] = ACTIONS(4346),
    [sym_ifloat] = ACTIONS(4346),
    [sym_idouble] = ACTIONS(4346),
    [sym_ireal] = ACTIONS(4346),
    [sym_cfloat] = ACTIONS(4346),
    [sym_cdouble] = ACTIONS(4346),
    [sym_creal] = ACTIONS(4346),
    [sym_size_t] = ACTIONS(4346),
    [sym_ptrdiff_t] = ACTIONS(4346),
    [sym_string] = ACTIONS(4346),
    [sym_cstring] = ACTIONS(4346),
    [sym_dstring] = ACTIONS(4346),
    [sym_wstring] = ACTIONS(4346),
    [sym_noreturn] = ACTIONS(4346),
    [sym_true] = ACTIONS(4346),
    [sym_false] = ACTIONS(4346),
    [sym_null] = ACTIONS(4346),
    [sym_super] = ACTIONS(4346),
    [sym_this] = ACTIONS(4346),
    [sym_abstract] = ACTIONS(4346),
    [sym_alias] = ACTIONS(4346),
    [sym_align] = ACTIONS(4346),
    [sym_asm] = ACTIONS(4346),
    [sym_assert] = ACTIONS(4346),
    [sym_auto] = ACTIONS(4346),
    [sym_break] = ACTIONS(4346),
    [sym_case] = ACTIONS(4346),
    [sym_cast] = ACTIONS(4346),
    [sym_catch] = ACTIONS(4346),
    [sym_class] = ACTIONS(4346),
    [sym_const] = ACTIONS(4346),
    [sym_continue] = ACTIONS(4346),
    [sym_debug] = ACTIONS(4346),
    [sym_default] = ACTIONS(4346),
    [sym_delegate] = ACTIONS(4346),
    [sym_delete] = ACTIONS(4346),
    [sym_deprecated] = ACTIONS(4346),
    [sym_do] = ACTIONS(4346),
    [sym_else] = ACTIONS(4346),
    [sym_enum] = ACTIONS(4346),
    [sym_export] = ACTIONS(4346),
    [sym_extern] = ACTIONS(4346),
    [sym_final] = ACTIONS(4346),
    [sym_finally] = ACTIONS(4346),
    [sym_for] = ACTIONS(4346),
    [sym_foreach] = ACTIONS(4346),
    [sym_foreach_reverse] = ACTIONS(4346),
    [sym_function] = ACTIONS(4346),
    [sym_goto] = ACTIONS(4346),
    [sym_if] = ACTIONS(4346),
    [sym_immutable] = ACTIONS(4346),
    [sym_import] = ACTIONS(4346),
    [sym_in] = ACTIONS(4346),
    [sym_inout] = ACTIONS(4346),
    [sym_interface] = ACTIONS(4346),
    [sym_invariant] = ACTIONS(4346),
    [sym_is] = ACTIONS(4346),
    [sym_mixin] = ACTIONS(4346),
    [sym_new] = ACTIONS(4346),
    [sym_nothrow] = ACTIONS(4346),
    [sym_out] = ACTIONS(4346),
    [sym_override] = ACTIONS(4346),
    [sym_package] = ACTIONS(4346),
    [sym_pragma] = ACTIONS(4346),
    [sym_private] = ACTIONS(4346),
    [sym_protected] = ACTIONS(4346),
    [sym_public] = ACTIONS(4346),
    [sym_pure] = ACTIONS(4346),
    [sym_ref] = ACTIONS(4346),
    [sym_return] = ACTIONS(4346),
    [sym_scope] = ACTIONS(4346),
    [sym_shared] = ACTIONS(4346),
    [sym_static] = ACTIONS(4346),
    [sym_struct] = ACTIONS(4346),
    [sym_switch] = ACTIONS(4346),
    [sym_synchronized] = ACTIONS(4346),
    [sym_template] = ACTIONS(4346),
    [sym_throw] = ACTIONS(4346),
    [sym_try] = ACTIONS(4346),
    [sym_typeid] = ACTIONS(4346),
    [sym_typeof] = ACTIONS(4346),
    [sym_union] = ACTIONS(4346),
    [sym_unittest] = ACTIONS(4346),
    [sym_version] = ACTIONS(4346),
    [sym_while] = ACTIONS(4346),
    [sym_with] = ACTIONS(4346),
    [sym_gshared] = ACTIONS(4346),
    [sym_traits] = ACTIONS(4346),
    [sym_vector] = ACTIONS(4346),
    [sym_void] = ACTIONS(4346),
    [anon_sym_BQUOTE] = ACTIONS(4348),
    [anon_sym_r_DQUOTE] = ACTIONS(4348),
    [anon_sym_x_DQUOTE] = ACTIONS(4348),
    [anon_sym_DQUOTE] = ACTIONS(4348),
    [anon_sym_i_BQUOTE] = ACTIONS(4348),
    [anon_sym_i_DQUOTE] = ACTIONS(4348),
    [anon_sym_iq_LBRACE] = ACTIONS(4348),
    [aux_sym_char_literal_token1] = ACTIONS(4348),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym___DATE__] = ACTIONS(4346),
    [anon_sym___FILE__] = ACTIONS(4346),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4346),
    [anon_sym___FUNCTION__] = ACTIONS(4346),
    [anon_sym___LINE__] = ACTIONS(4346),
    [anon_sym___MODULE__] = ACTIONS(4346),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4346),
    [anon_sym___TIME__] = ACTIONS(4346),
    [anon_sym___TIMESTAMP__] = ACTIONS(4346),
    [anon_sym___VENDOR__] = ACTIONS(4346),
    [anon_sym___VERSION__] = ACTIONS(4346),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4348),
    [sym_float_literal] = ACTIONS(4348),
    [sym__string] = ACTIONS(4348),
  },
  [1342] = {
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_q_LBRACE] = ACTIONS(4352),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_LBRACE] = ACTIONS(4352),
    [anon_sym_DOT] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_DASH] = ACTIONS(4350),
    [anon_sym_DASH_DASH] = ACTIONS(4352),
    [anon_sym_PLUS] = ACTIONS(4350),
    [anon_sym_PLUS_PLUS] = ACTIONS(4352),
    [anon_sym_BANG] = ACTIONS(4352),
    [anon_sym_LPAREN] = ACTIONS(4352),
    [anon_sym_RPAREN] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4352),
    [anon_sym_STAR] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4352),
    [anon_sym_AT] = ACTIONS(4352),
    [sym_bool] = ACTIONS(4350),
    [sym_byte] = ACTIONS(4350),
    [sym_ubyte] = ACTIONS(4350),
    [sym_char] = ACTIONS(4350),
    [sym_short] = ACTIONS(4350),
    [sym_ushort] = ACTIONS(4350),
    [sym_int] = ACTIONS(4350),
    [sym_uint] = ACTIONS(4350),
    [sym_long] = ACTIONS(4350),
    [sym_ulong] = ACTIONS(4350),
    [sym_cent] = ACTIONS(4350),
    [sym_ucent] = ACTIONS(4350),
    [sym_wchar] = ACTIONS(4350),
    [sym_dchar] = ACTIONS(4350),
    [sym_float] = ACTIONS(4350),
    [sym_double] = ACTIONS(4350),
    [sym_real] = ACTIONS(4350),
    [sym_ifloat] = ACTIONS(4350),
    [sym_idouble] = ACTIONS(4350),
    [sym_ireal] = ACTIONS(4350),
    [sym_cfloat] = ACTIONS(4350),
    [sym_cdouble] = ACTIONS(4350),
    [sym_creal] = ACTIONS(4350),
    [sym_size_t] = ACTIONS(4350),
    [sym_ptrdiff_t] = ACTIONS(4350),
    [sym_string] = ACTIONS(4350),
    [sym_cstring] = ACTIONS(4350),
    [sym_dstring] = ACTIONS(4350),
    [sym_wstring] = ACTIONS(4350),
    [sym_noreturn] = ACTIONS(4350),
    [sym_true] = ACTIONS(4350),
    [sym_false] = ACTIONS(4350),
    [sym_null] = ACTIONS(4350),
    [sym_super] = ACTIONS(4350),
    [sym_this] = ACTIONS(4350),
    [sym_abstract] = ACTIONS(4350),
    [sym_alias] = ACTIONS(4350),
    [sym_align] = ACTIONS(4350),
    [sym_asm] = ACTIONS(4350),
    [sym_assert] = ACTIONS(4350),
    [sym_auto] = ACTIONS(4350),
    [sym_break] = ACTIONS(4350),
    [sym_case] = ACTIONS(4350),
    [sym_cast] = ACTIONS(4350),
    [sym_catch] = ACTIONS(4350),
    [sym_class] = ACTIONS(4350),
    [sym_const] = ACTIONS(4350),
    [sym_continue] = ACTIONS(4350),
    [sym_debug] = ACTIONS(4350),
    [sym_default] = ACTIONS(4350),
    [sym_delegate] = ACTIONS(4350),
    [sym_delete] = ACTIONS(4350),
    [sym_deprecated] = ACTIONS(4350),
    [sym_do] = ACTIONS(4350),
    [sym_else] = ACTIONS(4350),
    [sym_enum] = ACTIONS(4350),
    [sym_export] = ACTIONS(4350),
    [sym_extern] = ACTIONS(4350),
    [sym_final] = ACTIONS(4350),
    [sym_finally] = ACTIONS(4350),
    [sym_for] = ACTIONS(4350),
    [sym_foreach] = ACTIONS(4350),
    [sym_foreach_reverse] = ACTIONS(4350),
    [sym_function] = ACTIONS(4350),
    [sym_goto] = ACTIONS(4350),
    [sym_if] = ACTIONS(4350),
    [sym_immutable] = ACTIONS(4350),
    [sym_import] = ACTIONS(4350),
    [sym_in] = ACTIONS(4350),
    [sym_inout] = ACTIONS(4350),
    [sym_interface] = ACTIONS(4350),
    [sym_invariant] = ACTIONS(4350),
    [sym_is] = ACTIONS(4350),
    [sym_mixin] = ACTIONS(4350),
    [sym_new] = ACTIONS(4350),
    [sym_nothrow] = ACTIONS(4350),
    [sym_out] = ACTIONS(4350),
    [sym_override] = ACTIONS(4350),
    [sym_package] = ACTIONS(4350),
    [sym_pragma] = ACTIONS(4350),
    [sym_private] = ACTIONS(4350),
    [sym_protected] = ACTIONS(4350),
    [sym_public] = ACTIONS(4350),
    [sym_pure] = ACTIONS(4350),
    [sym_ref] = ACTIONS(4350),
    [sym_return] = ACTIONS(4350),
    [sym_scope] = ACTIONS(4350),
    [sym_shared] = ACTIONS(4350),
    [sym_static] = ACTIONS(4350),
    [sym_struct] = ACTIONS(4350),
    [sym_switch] = ACTIONS(4350),
    [sym_synchronized] = ACTIONS(4350),
    [sym_template] = ACTIONS(4350),
    [sym_throw] = ACTIONS(4350),
    [sym_try] = ACTIONS(4350),
    [sym_typeid] = ACTIONS(4350),
    [sym_typeof] = ACTIONS(4350),
    [sym_union] = ACTIONS(4350),
    [sym_unittest] = ACTIONS(4350),
    [sym_version] = ACTIONS(4350),
    [sym_while] = ACTIONS(4350),
    [sym_with] = ACTIONS(4350),
    [sym_gshared] = ACTIONS(4350),
    [sym_traits] = ACTIONS(4350),
    [sym_vector] = ACTIONS(4350),
    [sym_void] = ACTIONS(4350),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_r_DQUOTE] = ACTIONS(4352),
    [anon_sym_x_DQUOTE] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_i_BQUOTE] = ACTIONS(4352),
    [anon_sym_i_DQUOTE] = ACTIONS(4352),
    [anon_sym_iq_LBRACE] = ACTIONS(4352),
    [aux_sym_char_literal_token1] = ACTIONS(4352),
    [anon_sym_SQUOTE] = ACTIONS(4350),
    [anon_sym___DATE__] = ACTIONS(4350),
    [anon_sym___FILE__] = ACTIONS(4350),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4350),
    [anon_sym___FUNCTION__] = ACTIONS(4350),
    [anon_sym___LINE__] = ACTIONS(4350),
    [anon_sym___MODULE__] = ACTIONS(4350),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4350),
    [anon_sym___TIME__] = ACTIONS(4350),
    [anon_sym___TIMESTAMP__] = ACTIONS(4350),
    [anon_sym___VENDOR__] = ACTIONS(4350),
    [anon_sym___VERSION__] = ACTIONS(4350),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4352),
    [sym_float_literal] = ACTIONS(4352),
    [sym__string] = ACTIONS(4352),
  },
  [1343] = {
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_q_LBRACE] = ACTIONS(4356),
    [anon_sym_RBRACE] = ACTIONS(4356),
    [anon_sym_LBRACE] = ACTIONS(4356),
    [anon_sym_DOT] = ACTIONS(4356),
    [anon_sym_AMP] = ACTIONS(4356),
    [anon_sym_DASH] = ACTIONS(4354),
    [anon_sym_DASH_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4354),
    [anon_sym_PLUS_PLUS] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4356),
    [anon_sym_LPAREN] = ACTIONS(4356),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(4356),
    [anon_sym_SEMI] = ACTIONS(4356),
    [anon_sym_DOLLAR] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4356),
    [anon_sym_AT] = ACTIONS(4356),
    [sym_bool] = ACTIONS(4354),
    [sym_byte] = ACTIONS(4354),
    [sym_ubyte] = ACTIONS(4354),
    [sym_char] = ACTIONS(4354),
    [sym_short] = ACTIONS(4354),
    [sym_ushort] = ACTIONS(4354),
    [sym_int] = ACTIONS(4354),
    [sym_uint] = ACTIONS(4354),
    [sym_long] = ACTIONS(4354),
    [sym_ulong] = ACTIONS(4354),
    [sym_cent] = ACTIONS(4354),
    [sym_ucent] = ACTIONS(4354),
    [sym_wchar] = ACTIONS(4354),
    [sym_dchar] = ACTIONS(4354),
    [sym_float] = ACTIONS(4354),
    [sym_double] = ACTIONS(4354),
    [sym_real] = ACTIONS(4354),
    [sym_ifloat] = ACTIONS(4354),
    [sym_idouble] = ACTIONS(4354),
    [sym_ireal] = ACTIONS(4354),
    [sym_cfloat] = ACTIONS(4354),
    [sym_cdouble] = ACTIONS(4354),
    [sym_creal] = ACTIONS(4354),
    [sym_size_t] = ACTIONS(4354),
    [sym_ptrdiff_t] = ACTIONS(4354),
    [sym_string] = ACTIONS(4354),
    [sym_cstring] = ACTIONS(4354),
    [sym_dstring] = ACTIONS(4354),
    [sym_wstring] = ACTIONS(4354),
    [sym_noreturn] = ACTIONS(4354),
    [sym_true] = ACTIONS(4354),
    [sym_false] = ACTIONS(4354),
    [sym_null] = ACTIONS(4354),
    [sym_super] = ACTIONS(4354),
    [sym_this] = ACTIONS(4354),
    [sym_abstract] = ACTIONS(4354),
    [sym_alias] = ACTIONS(4354),
    [sym_align] = ACTIONS(4354),
    [sym_asm] = ACTIONS(4354),
    [sym_assert] = ACTIONS(4354),
    [sym_auto] = ACTIONS(4354),
    [sym_break] = ACTIONS(4354),
    [sym_case] = ACTIONS(4354),
    [sym_cast] = ACTIONS(4354),
    [sym_catch] = ACTIONS(4354),
    [sym_class] = ACTIONS(4354),
    [sym_const] = ACTIONS(4354),
    [sym_continue] = ACTIONS(4354),
    [sym_debug] = ACTIONS(4354),
    [sym_default] = ACTIONS(4354),
    [sym_delegate] = ACTIONS(4354),
    [sym_delete] = ACTIONS(4354),
    [sym_deprecated] = ACTIONS(4354),
    [sym_do] = ACTIONS(4354),
    [sym_else] = ACTIONS(4354),
    [sym_enum] = ACTIONS(4354),
    [sym_export] = ACTIONS(4354),
    [sym_extern] = ACTIONS(4354),
    [sym_final] = ACTIONS(4354),
    [sym_finally] = ACTIONS(4354),
    [sym_for] = ACTIONS(4354),
    [sym_foreach] = ACTIONS(4354),
    [sym_foreach_reverse] = ACTIONS(4354),
    [sym_function] = ACTIONS(4354),
    [sym_goto] = ACTIONS(4354),
    [sym_if] = ACTIONS(4354),
    [sym_immutable] = ACTIONS(4354),
    [sym_import] = ACTIONS(4354),
    [sym_in] = ACTIONS(4354),
    [sym_inout] = ACTIONS(4354),
    [sym_interface] = ACTIONS(4354),
    [sym_invariant] = ACTIONS(4354),
    [sym_is] = ACTIONS(4354),
    [sym_mixin] = ACTIONS(4354),
    [sym_new] = ACTIONS(4354),
    [sym_nothrow] = ACTIONS(4354),
    [sym_out] = ACTIONS(4354),
    [sym_override] = ACTIONS(4354),
    [sym_package] = ACTIONS(4354),
    [sym_pragma] = ACTIONS(4354),
    [sym_private] = ACTIONS(4354),
    [sym_protected] = ACTIONS(4354),
    [sym_public] = ACTIONS(4354),
    [sym_pure] = ACTIONS(4354),
    [sym_ref] = ACTIONS(4354),
    [sym_return] = ACTIONS(4354),
    [sym_scope] = ACTIONS(4354),
    [sym_shared] = ACTIONS(4354),
    [sym_static] = ACTIONS(4354),
    [sym_struct] = ACTIONS(4354),
    [sym_switch] = ACTIONS(4354),
    [sym_synchronized] = ACTIONS(4354),
    [sym_template] = ACTIONS(4354),
    [sym_throw] = ACTIONS(4354),
    [sym_try] = ACTIONS(4354),
    [sym_typeid] = ACTIONS(4354),
    [sym_typeof] = ACTIONS(4354),
    [sym_union] = ACTIONS(4354),
    [sym_unittest] = ACTIONS(4354),
    [sym_version] = ACTIONS(4354),
    [sym_while] = ACTIONS(4354),
    [sym_with] = ACTIONS(4354),
    [sym_gshared] = ACTIONS(4354),
    [sym_traits] = ACTIONS(4354),
    [sym_vector] = ACTIONS(4354),
    [sym_void] = ACTIONS(4354),
    [anon_sym_BQUOTE] = ACTIONS(4356),
    [anon_sym_r_DQUOTE] = ACTIONS(4356),
    [anon_sym_x_DQUOTE] = ACTIONS(4356),
    [anon_sym_DQUOTE] = ACTIONS(4356),
    [anon_sym_i_BQUOTE] = ACTIONS(4356),
    [anon_sym_i_DQUOTE] = ACTIONS(4356),
    [anon_sym_iq_LBRACE] = ACTIONS(4356),
    [aux_sym_char_literal_token1] = ACTIONS(4356),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym___DATE__] = ACTIONS(4354),
    [anon_sym___FILE__] = ACTIONS(4354),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4354),
    [anon_sym___FUNCTION__] = ACTIONS(4354),
    [anon_sym___LINE__] = ACTIONS(4354),
    [anon_sym___MODULE__] = ACTIONS(4354),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4354),
    [anon_sym___TIME__] = ACTIONS(4354),
    [anon_sym___TIMESTAMP__] = ACTIONS(4354),
    [anon_sym___VENDOR__] = ACTIONS(4354),
    [anon_sym___VERSION__] = ACTIONS(4354),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4356),
    [sym_float_literal] = ACTIONS(4356),
    [sym__string] = ACTIONS(4356),
  },
  [1344] = {
    [sym_identifier] = ACTIONS(4358),
    [anon_sym_q_LBRACE] = ACTIONS(4360),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_LBRACE] = ACTIONS(4360),
    [anon_sym_DOT] = ACTIONS(4360),
    [anon_sym_AMP] = ACTIONS(4360),
    [anon_sym_DASH] = ACTIONS(4358),
    [anon_sym_DASH_DASH] = ACTIONS(4360),
    [anon_sym_PLUS] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4360),
    [anon_sym_BANG] = ACTIONS(4360),
    [anon_sym_LPAREN] = ACTIONS(4360),
    [anon_sym_RPAREN] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(4360),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_DOLLAR] = ACTIONS(4360),
    [anon_sym_STAR] = ACTIONS(4360),
    [anon_sym_TILDE] = ACTIONS(4360),
    [anon_sym_AT] = ACTIONS(4360),
    [sym_bool] = ACTIONS(4358),
    [sym_byte] = ACTIONS(4358),
    [sym_ubyte] = ACTIONS(4358),
    [sym_char] = ACTIONS(4358),
    [sym_short] = ACTIONS(4358),
    [sym_ushort] = ACTIONS(4358),
    [sym_int] = ACTIONS(4358),
    [sym_uint] = ACTIONS(4358),
    [sym_long] = ACTIONS(4358),
    [sym_ulong] = ACTIONS(4358),
    [sym_cent] = ACTIONS(4358),
    [sym_ucent] = ACTIONS(4358),
    [sym_wchar] = ACTIONS(4358),
    [sym_dchar] = ACTIONS(4358),
    [sym_float] = ACTIONS(4358),
    [sym_double] = ACTIONS(4358),
    [sym_real] = ACTIONS(4358),
    [sym_ifloat] = ACTIONS(4358),
    [sym_idouble] = ACTIONS(4358),
    [sym_ireal] = ACTIONS(4358),
    [sym_cfloat] = ACTIONS(4358),
    [sym_cdouble] = ACTIONS(4358),
    [sym_creal] = ACTIONS(4358),
    [sym_size_t] = ACTIONS(4358),
    [sym_ptrdiff_t] = ACTIONS(4358),
    [sym_string] = ACTIONS(4358),
    [sym_cstring] = ACTIONS(4358),
    [sym_dstring] = ACTIONS(4358),
    [sym_wstring] = ACTIONS(4358),
    [sym_noreturn] = ACTIONS(4358),
    [sym_true] = ACTIONS(4358),
    [sym_false] = ACTIONS(4358),
    [sym_null] = ACTIONS(4358),
    [sym_super] = ACTIONS(4358),
    [sym_this] = ACTIONS(4358),
    [sym_abstract] = ACTIONS(4358),
    [sym_alias] = ACTIONS(4358),
    [sym_align] = ACTIONS(4358),
    [sym_asm] = ACTIONS(4358),
    [sym_assert] = ACTIONS(4358),
    [sym_auto] = ACTIONS(4358),
    [sym_break] = ACTIONS(4358),
    [sym_case] = ACTIONS(4358),
    [sym_cast] = ACTIONS(4358),
    [sym_catch] = ACTIONS(4358),
    [sym_class] = ACTIONS(4358),
    [sym_const] = ACTIONS(4358),
    [sym_continue] = ACTIONS(4358),
    [sym_debug] = ACTIONS(4358),
    [sym_default] = ACTIONS(4358),
    [sym_delegate] = ACTIONS(4358),
    [sym_delete] = ACTIONS(4358),
    [sym_deprecated] = ACTIONS(4358),
    [sym_do] = ACTIONS(4358),
    [sym_else] = ACTIONS(4358),
    [sym_enum] = ACTIONS(4358),
    [sym_export] = ACTIONS(4358),
    [sym_extern] = ACTIONS(4358),
    [sym_final] = ACTIONS(4358),
    [sym_finally] = ACTIONS(4358),
    [sym_for] = ACTIONS(4358),
    [sym_foreach] = ACTIONS(4358),
    [sym_foreach_reverse] = ACTIONS(4358),
    [sym_function] = ACTIONS(4358),
    [sym_goto] = ACTIONS(4358),
    [sym_if] = ACTIONS(4358),
    [sym_immutable] = ACTIONS(4358),
    [sym_import] = ACTIONS(4358),
    [sym_in] = ACTIONS(4358),
    [sym_inout] = ACTIONS(4358),
    [sym_interface] = ACTIONS(4358),
    [sym_invariant] = ACTIONS(4358),
    [sym_is] = ACTIONS(4358),
    [sym_mixin] = ACTIONS(4358),
    [sym_new] = ACTIONS(4358),
    [sym_nothrow] = ACTIONS(4358),
    [sym_out] = ACTIONS(4358),
    [sym_override] = ACTIONS(4358),
    [sym_package] = ACTIONS(4358),
    [sym_pragma] = ACTIONS(4358),
    [sym_private] = ACTIONS(4358),
    [sym_protected] = ACTIONS(4358),
    [sym_public] = ACTIONS(4358),
    [sym_pure] = ACTIONS(4358),
    [sym_ref] = ACTIONS(4358),
    [sym_return] = ACTIONS(4358),
    [sym_scope] = ACTIONS(4358),
    [sym_shared] = ACTIONS(4358),
    [sym_static] = ACTIONS(4358),
    [sym_struct] = ACTIONS(4358),
    [sym_switch] = ACTIONS(4358),
    [sym_synchronized] = ACTIONS(4358),
    [sym_template] = ACTIONS(4358),
    [sym_throw] = ACTIONS(4358),
    [sym_try] = ACTIONS(4358),
    [sym_typeid] = ACTIONS(4358),
    [sym_typeof] = ACTIONS(4358),
    [sym_union] = ACTIONS(4358),
    [sym_unittest] = ACTIONS(4358),
    [sym_version] = ACTIONS(4358),
    [sym_while] = ACTIONS(4358),
    [sym_with] = ACTIONS(4358),
    [sym_gshared] = ACTIONS(4358),
    [sym_traits] = ACTIONS(4358),
    [sym_vector] = ACTIONS(4358),
    [sym_void] = ACTIONS(4358),
    [anon_sym_BQUOTE] = ACTIONS(4360),
    [anon_sym_r_DQUOTE] = ACTIONS(4360),
    [anon_sym_x_DQUOTE] = ACTIONS(4360),
    [anon_sym_DQUOTE] = ACTIONS(4360),
    [anon_sym_i_BQUOTE] = ACTIONS(4360),
    [anon_sym_i_DQUOTE] = ACTIONS(4360),
    [anon_sym_iq_LBRACE] = ACTIONS(4360),
    [aux_sym_char_literal_token1] = ACTIONS(4360),
    [anon_sym_SQUOTE] = ACTIONS(4358),
    [anon_sym___DATE__] = ACTIONS(4358),
    [anon_sym___FILE__] = ACTIONS(4358),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4358),
    [anon_sym___FUNCTION__] = ACTIONS(4358),
    [anon_sym___LINE__] = ACTIONS(4358),
    [anon_sym___MODULE__] = ACTIONS(4358),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4358),
    [anon_sym___TIME__] = ACTIONS(4358),
    [anon_sym___TIMESTAMP__] = ACTIONS(4358),
    [anon_sym___VENDOR__] = ACTIONS(4358),
    [anon_sym___VERSION__] = ACTIONS(4358),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4360),
    [sym_float_literal] = ACTIONS(4360),
    [sym__string] = ACTIONS(4360),
  },
  [1345] = {
    [sym_identifier] = ACTIONS(4362),
    [anon_sym_q_LBRACE] = ACTIONS(4364),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_DOT] = ACTIONS(4364),
    [anon_sym_AMP] = ACTIONS(4364),
    [anon_sym_DASH] = ACTIONS(4362),
    [anon_sym_DASH_DASH] = ACTIONS(4364),
    [anon_sym_PLUS] = ACTIONS(4362),
    [anon_sym_PLUS_PLUS] = ACTIONS(4364),
    [anon_sym_BANG] = ACTIONS(4364),
    [anon_sym_LPAREN] = ACTIONS(4364),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_DOLLAR] = ACTIONS(4364),
    [anon_sym_STAR] = ACTIONS(4364),
    [anon_sym_TILDE] = ACTIONS(4364),
    [anon_sym_AT] = ACTIONS(4364),
    [sym_bool] = ACTIONS(4362),
    [sym_byte] = ACTIONS(4362),
    [sym_ubyte] = ACTIONS(4362),
    [sym_char] = ACTIONS(4362),
    [sym_short] = ACTIONS(4362),
    [sym_ushort] = ACTIONS(4362),
    [sym_int] = ACTIONS(4362),
    [sym_uint] = ACTIONS(4362),
    [sym_long] = ACTIONS(4362),
    [sym_ulong] = ACTIONS(4362),
    [sym_cent] = ACTIONS(4362),
    [sym_ucent] = ACTIONS(4362),
    [sym_wchar] = ACTIONS(4362),
    [sym_dchar] = ACTIONS(4362),
    [sym_float] = ACTIONS(4362),
    [sym_double] = ACTIONS(4362),
    [sym_real] = ACTIONS(4362),
    [sym_ifloat] = ACTIONS(4362),
    [sym_idouble] = ACTIONS(4362),
    [sym_ireal] = ACTIONS(4362),
    [sym_cfloat] = ACTIONS(4362),
    [sym_cdouble] = ACTIONS(4362),
    [sym_creal] = ACTIONS(4362),
    [sym_size_t] = ACTIONS(4362),
    [sym_ptrdiff_t] = ACTIONS(4362),
    [sym_string] = ACTIONS(4362),
    [sym_cstring] = ACTIONS(4362),
    [sym_dstring] = ACTIONS(4362),
    [sym_wstring] = ACTIONS(4362),
    [sym_noreturn] = ACTIONS(4362),
    [sym_true] = ACTIONS(4362),
    [sym_false] = ACTIONS(4362),
    [sym_null] = ACTIONS(4362),
    [sym_super] = ACTIONS(4362),
    [sym_this] = ACTIONS(4362),
    [sym_abstract] = ACTIONS(4362),
    [sym_alias] = ACTIONS(4362),
    [sym_align] = ACTIONS(4362),
    [sym_asm] = ACTIONS(4362),
    [sym_assert] = ACTIONS(4362),
    [sym_auto] = ACTIONS(4362),
    [sym_break] = ACTIONS(4362),
    [sym_case] = ACTIONS(4362),
    [sym_cast] = ACTIONS(4362),
    [sym_catch] = ACTIONS(4362),
    [sym_class] = ACTIONS(4362),
    [sym_const] = ACTIONS(4362),
    [sym_continue] = ACTIONS(4362),
    [sym_debug] = ACTIONS(4362),
    [sym_default] = ACTIONS(4362),
    [sym_delegate] = ACTIONS(4362),
    [sym_delete] = ACTIONS(4362),
    [sym_deprecated] = ACTIONS(4362),
    [sym_do] = ACTIONS(4362),
    [sym_else] = ACTIONS(4362),
    [sym_enum] = ACTIONS(4362),
    [sym_export] = ACTIONS(4362),
    [sym_extern] = ACTIONS(4362),
    [sym_final] = ACTIONS(4362),
    [sym_finally] = ACTIONS(4362),
    [sym_for] = ACTIONS(4362),
    [sym_foreach] = ACTIONS(4362),
    [sym_foreach_reverse] = ACTIONS(4362),
    [sym_function] = ACTIONS(4362),
    [sym_goto] = ACTIONS(4362),
    [sym_if] = ACTIONS(4362),
    [sym_immutable] = ACTIONS(4362),
    [sym_import] = ACTIONS(4362),
    [sym_in] = ACTIONS(4362),
    [sym_inout] = ACTIONS(4362),
    [sym_interface] = ACTIONS(4362),
    [sym_invariant] = ACTIONS(4362),
    [sym_is] = ACTIONS(4362),
    [sym_mixin] = ACTIONS(4362),
    [sym_new] = ACTIONS(4362),
    [sym_nothrow] = ACTIONS(4362),
    [sym_out] = ACTIONS(4362),
    [sym_override] = ACTIONS(4362),
    [sym_package] = ACTIONS(4362),
    [sym_pragma] = ACTIONS(4362),
    [sym_private] = ACTIONS(4362),
    [sym_protected] = ACTIONS(4362),
    [sym_public] = ACTIONS(4362),
    [sym_pure] = ACTIONS(4362),
    [sym_ref] = ACTIONS(4362),
    [sym_return] = ACTIONS(4362),
    [sym_scope] = ACTIONS(4362),
    [sym_shared] = ACTIONS(4362),
    [sym_static] = ACTIONS(4362),
    [sym_struct] = ACTIONS(4362),
    [sym_switch] = ACTIONS(4362),
    [sym_synchronized] = ACTIONS(4362),
    [sym_template] = ACTIONS(4362),
    [sym_throw] = ACTIONS(4362),
    [sym_try] = ACTIONS(4362),
    [sym_typeid] = ACTIONS(4362),
    [sym_typeof] = ACTIONS(4362),
    [sym_union] = ACTIONS(4362),
    [sym_unittest] = ACTIONS(4362),
    [sym_version] = ACTIONS(4362),
    [sym_while] = ACTIONS(4362),
    [sym_with] = ACTIONS(4362),
    [sym_gshared] = ACTIONS(4362),
    [sym_traits] = ACTIONS(4362),
    [sym_vector] = ACTIONS(4362),
    [sym_void] = ACTIONS(4362),
    [anon_sym_BQUOTE] = ACTIONS(4364),
    [anon_sym_r_DQUOTE] = ACTIONS(4364),
    [anon_sym_x_DQUOTE] = ACTIONS(4364),
    [anon_sym_DQUOTE] = ACTIONS(4364),
    [anon_sym_i_BQUOTE] = ACTIONS(4364),
    [anon_sym_i_DQUOTE] = ACTIONS(4364),
    [anon_sym_iq_LBRACE] = ACTIONS(4364),
    [aux_sym_char_literal_token1] = ACTIONS(4364),
    [anon_sym_SQUOTE] = ACTIONS(4362),
    [anon_sym___DATE__] = ACTIONS(4362),
    [anon_sym___FILE__] = ACTIONS(4362),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4362),
    [anon_sym___FUNCTION__] = ACTIONS(4362),
    [anon_sym___LINE__] = ACTIONS(4362),
    [anon_sym___MODULE__] = ACTIONS(4362),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4362),
    [anon_sym___TIME__] = ACTIONS(4362),
    [anon_sym___TIMESTAMP__] = ACTIONS(4362),
    [anon_sym___VENDOR__] = ACTIONS(4362),
    [anon_sym___VERSION__] = ACTIONS(4362),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4364),
    [sym_float_literal] = ACTIONS(4364),
    [sym__string] = ACTIONS(4364),
  },
  [1346] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [anon_sym_AT] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_abstract] = ACTIONS(4366),
    [sym_alias] = ACTIONS(4366),
    [sym_align] = ACTIONS(4366),
    [sym_asm] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_break] = ACTIONS(4366),
    [sym_case] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_catch] = ACTIONS(4366),
    [sym_class] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_continue] = ACTIONS(4366),
    [sym_debug] = ACTIONS(4366),
    [sym_default] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_deprecated] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(4370),
    [sym_enum] = ACTIONS(4366),
    [sym_export] = ACTIONS(4366),
    [sym_extern] = ACTIONS(4366),
    [sym_final] = ACTIONS(4366),
    [sym_finally] = ACTIONS(4366),
    [sym_for] = ACTIONS(4366),
    [sym_foreach] = ACTIONS(4366),
    [sym_foreach_reverse] = ACTIONS(4366),
    [sym_function] = ACTIONS(4366),
    [sym_goto] = ACTIONS(4366),
    [sym_if] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_interface] = ACTIONS(4366),
    [sym_invariant] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_nothrow] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_override] = ACTIONS(4366),
    [sym_package] = ACTIONS(4366),
    [sym_pragma] = ACTIONS(4366),
    [sym_private] = ACTIONS(4366),
    [sym_protected] = ACTIONS(4366),
    [sym_public] = ACTIONS(4366),
    [sym_pure] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_return] = ACTIONS(4366),
    [sym_scope] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_static] = ACTIONS(4366),
    [sym_struct] = ACTIONS(4366),
    [sym_switch] = ACTIONS(4366),
    [sym_synchronized] = ACTIONS(4366),
    [sym_template] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_try] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_union] = ACTIONS(4366),
    [sym_unittest] = ACTIONS(4366),
    [sym_version] = ACTIONS(4366),
    [sym_while] = ACTIONS(4366),
    [sym_with] = ACTIONS(4366),
    [sym_gshared] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [1347] = {
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_q_LBRACE] = ACTIONS(4374),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_LBRACE] = ACTIONS(4374),
    [anon_sym_DOT] = ACTIONS(4374),
    [anon_sym_AMP] = ACTIONS(4374),
    [anon_sym_DASH] = ACTIONS(4372),
    [anon_sym_DASH_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_PLUS_PLUS] = ACTIONS(4374),
    [anon_sym_BANG] = ACTIONS(4374),
    [anon_sym_LPAREN] = ACTIONS(4374),
    [anon_sym_RPAREN] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_SEMI] = ACTIONS(4374),
    [anon_sym_DOLLAR] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4374),
    [anon_sym_TILDE] = ACTIONS(4374),
    [anon_sym_AT] = ACTIONS(4374),
    [sym_bool] = ACTIONS(4372),
    [sym_byte] = ACTIONS(4372),
    [sym_ubyte] = ACTIONS(4372),
    [sym_char] = ACTIONS(4372),
    [sym_short] = ACTIONS(4372),
    [sym_ushort] = ACTIONS(4372),
    [sym_int] = ACTIONS(4372),
    [sym_uint] = ACTIONS(4372),
    [sym_long] = ACTIONS(4372),
    [sym_ulong] = ACTIONS(4372),
    [sym_cent] = ACTIONS(4372),
    [sym_ucent] = ACTIONS(4372),
    [sym_wchar] = ACTIONS(4372),
    [sym_dchar] = ACTIONS(4372),
    [sym_float] = ACTIONS(4372),
    [sym_double] = ACTIONS(4372),
    [sym_real] = ACTIONS(4372),
    [sym_ifloat] = ACTIONS(4372),
    [sym_idouble] = ACTIONS(4372),
    [sym_ireal] = ACTIONS(4372),
    [sym_cfloat] = ACTIONS(4372),
    [sym_cdouble] = ACTIONS(4372),
    [sym_creal] = ACTIONS(4372),
    [sym_size_t] = ACTIONS(4372),
    [sym_ptrdiff_t] = ACTIONS(4372),
    [sym_string] = ACTIONS(4372),
    [sym_cstring] = ACTIONS(4372),
    [sym_dstring] = ACTIONS(4372),
    [sym_wstring] = ACTIONS(4372),
    [sym_noreturn] = ACTIONS(4372),
    [sym_true] = ACTIONS(4372),
    [sym_false] = ACTIONS(4372),
    [sym_null] = ACTIONS(4372),
    [sym_super] = ACTIONS(4372),
    [sym_this] = ACTIONS(4372),
    [sym_abstract] = ACTIONS(4372),
    [sym_alias] = ACTIONS(4372),
    [sym_align] = ACTIONS(4372),
    [sym_asm] = ACTIONS(4372),
    [sym_assert] = ACTIONS(4372),
    [sym_auto] = ACTIONS(4372),
    [sym_break] = ACTIONS(4372),
    [sym_case] = ACTIONS(4372),
    [sym_cast] = ACTIONS(4372),
    [sym_catch] = ACTIONS(4372),
    [sym_class] = ACTIONS(4372),
    [sym_const] = ACTIONS(4372),
    [sym_continue] = ACTIONS(4372),
    [sym_debug] = ACTIONS(4372),
    [sym_default] = ACTIONS(4372),
    [sym_delegate] = ACTIONS(4372),
    [sym_delete] = ACTIONS(4372),
    [sym_deprecated] = ACTIONS(4372),
    [sym_do] = ACTIONS(4372),
    [sym_else] = ACTIONS(4372),
    [sym_enum] = ACTIONS(4372),
    [sym_export] = ACTIONS(4372),
    [sym_extern] = ACTIONS(4372),
    [sym_final] = ACTIONS(4372),
    [sym_finally] = ACTIONS(4372),
    [sym_for] = ACTIONS(4372),
    [sym_foreach] = ACTIONS(4372),
    [sym_foreach_reverse] = ACTIONS(4372),
    [sym_function] = ACTIONS(4372),
    [sym_goto] = ACTIONS(4372),
    [sym_if] = ACTIONS(4372),
    [sym_immutable] = ACTIONS(4372),
    [sym_import] = ACTIONS(4372),
    [sym_in] = ACTIONS(4372),
    [sym_inout] = ACTIONS(4372),
    [sym_interface] = ACTIONS(4372),
    [sym_invariant] = ACTIONS(4372),
    [sym_is] = ACTIONS(4372),
    [sym_mixin] = ACTIONS(4372),
    [sym_new] = ACTIONS(4372),
    [sym_nothrow] = ACTIONS(4372),
    [sym_out] = ACTIONS(4372),
    [sym_override] = ACTIONS(4372),
    [sym_package] = ACTIONS(4372),
    [sym_pragma] = ACTIONS(4372),
    [sym_private] = ACTIONS(4372),
    [sym_protected] = ACTIONS(4372),
    [sym_public] = ACTIONS(4372),
    [sym_pure] = ACTIONS(4372),
    [sym_ref] = ACTIONS(4372),
    [sym_return] = ACTIONS(4372),
    [sym_scope] = ACTIONS(4372),
    [sym_shared] = ACTIONS(4372),
    [sym_static] = ACTIONS(4372),
    [sym_struct] = ACTIONS(4372),
    [sym_switch] = ACTIONS(4372),
    [sym_synchronized] = ACTIONS(4372),
    [sym_template] = ACTIONS(4372),
    [sym_throw] = ACTIONS(4372),
    [sym_try] = ACTIONS(4372),
    [sym_typeid] = ACTIONS(4372),
    [sym_typeof] = ACTIONS(4372),
    [sym_union] = ACTIONS(4372),
    [sym_unittest] = ACTIONS(4372),
    [sym_version] = ACTIONS(4372),
    [sym_while] = ACTIONS(4372),
    [sym_with] = ACTIONS(4372),
    [sym_gshared] = ACTIONS(4372),
    [sym_traits] = ACTIONS(4372),
    [sym_vector] = ACTIONS(4372),
    [sym_void] = ACTIONS(4372),
    [anon_sym_BQUOTE] = ACTIONS(4374),
    [anon_sym_r_DQUOTE] = ACTIONS(4374),
    [anon_sym_x_DQUOTE] = ACTIONS(4374),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [anon_sym_i_BQUOTE] = ACTIONS(4374),
    [anon_sym_i_DQUOTE] = ACTIONS(4374),
    [anon_sym_iq_LBRACE] = ACTIONS(4374),
    [aux_sym_char_literal_token1] = ACTIONS(4374),
    [anon_sym_SQUOTE] = ACTIONS(4372),
    [anon_sym___DATE__] = ACTIONS(4372),
    [anon_sym___FILE__] = ACTIONS(4372),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4372),
    [anon_sym___FUNCTION__] = ACTIONS(4372),
    [anon_sym___LINE__] = ACTIONS(4372),
    [anon_sym___MODULE__] = ACTIONS(4372),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4372),
    [anon_sym___TIME__] = ACTIONS(4372),
    [anon_sym___TIMESTAMP__] = ACTIONS(4372),
    [anon_sym___VENDOR__] = ACTIONS(4372),
    [anon_sym___VERSION__] = ACTIONS(4372),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4374),
    [sym_float_literal] = ACTIONS(4374),
    [sym__string] = ACTIONS(4374),
  },
  [1348] = {
    [sym_identifier] = ACTIONS(4376),
    [anon_sym_q_LBRACE] = ACTIONS(4378),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_LBRACE] = ACTIONS(4378),
    [anon_sym_DOT] = ACTIONS(4378),
    [anon_sym_AMP] = ACTIONS(4378),
    [anon_sym_DASH] = ACTIONS(4376),
    [anon_sym_DASH_DASH] = ACTIONS(4378),
    [anon_sym_PLUS] = ACTIONS(4376),
    [anon_sym_PLUS_PLUS] = ACTIONS(4378),
    [anon_sym_BANG] = ACTIONS(4378),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_RPAREN] = ACTIONS(4378),
    [anon_sym_LBRACK] = ACTIONS(4378),
    [anon_sym_SEMI] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(4378),
    [anon_sym_TILDE] = ACTIONS(4378),
    [anon_sym_AT] = ACTIONS(4378),
    [sym_bool] = ACTIONS(4376),
    [sym_byte] = ACTIONS(4376),
    [sym_ubyte] = ACTIONS(4376),
    [sym_char] = ACTIONS(4376),
    [sym_short] = ACTIONS(4376),
    [sym_ushort] = ACTIONS(4376),
    [sym_int] = ACTIONS(4376),
    [sym_uint] = ACTIONS(4376),
    [sym_long] = ACTIONS(4376),
    [sym_ulong] = ACTIONS(4376),
    [sym_cent] = ACTIONS(4376),
    [sym_ucent] = ACTIONS(4376),
    [sym_wchar] = ACTIONS(4376),
    [sym_dchar] = ACTIONS(4376),
    [sym_float] = ACTIONS(4376),
    [sym_double] = ACTIONS(4376),
    [sym_real] = ACTIONS(4376),
    [sym_ifloat] = ACTIONS(4376),
    [sym_idouble] = ACTIONS(4376),
    [sym_ireal] = ACTIONS(4376),
    [sym_cfloat] = ACTIONS(4376),
    [sym_cdouble] = ACTIONS(4376),
    [sym_creal] = ACTIONS(4376),
    [sym_size_t] = ACTIONS(4376),
    [sym_ptrdiff_t] = ACTIONS(4376),
    [sym_string] = ACTIONS(4376),
    [sym_cstring] = ACTIONS(4376),
    [sym_dstring] = ACTIONS(4376),
    [sym_wstring] = ACTIONS(4376),
    [sym_noreturn] = ACTIONS(4376),
    [sym_true] = ACTIONS(4376),
    [sym_false] = ACTIONS(4376),
    [sym_null] = ACTIONS(4376),
    [sym_super] = ACTIONS(4376),
    [sym_this] = ACTIONS(4376),
    [sym_abstract] = ACTIONS(4376),
    [sym_alias] = ACTIONS(4376),
    [sym_align] = ACTIONS(4376),
    [sym_asm] = ACTIONS(4376),
    [sym_assert] = ACTIONS(4376),
    [sym_auto] = ACTIONS(4376),
    [sym_break] = ACTIONS(4376),
    [sym_case] = ACTIONS(4376),
    [sym_cast] = ACTIONS(4376),
    [sym_catch] = ACTIONS(4376),
    [sym_class] = ACTIONS(4376),
    [sym_const] = ACTIONS(4376),
    [sym_continue] = ACTIONS(4376),
    [sym_debug] = ACTIONS(4376),
    [sym_default] = ACTIONS(4376),
    [sym_delegate] = ACTIONS(4376),
    [sym_delete] = ACTIONS(4376),
    [sym_deprecated] = ACTIONS(4376),
    [sym_do] = ACTIONS(4376),
    [sym_else] = ACTIONS(4376),
    [sym_enum] = ACTIONS(4376),
    [sym_export] = ACTIONS(4376),
    [sym_extern] = ACTIONS(4376),
    [sym_final] = ACTIONS(4376),
    [sym_finally] = ACTIONS(4376),
    [sym_for] = ACTIONS(4376),
    [sym_foreach] = ACTIONS(4376),
    [sym_foreach_reverse] = ACTIONS(4376),
    [sym_function] = ACTIONS(4376),
    [sym_goto] = ACTIONS(4376),
    [sym_if] = ACTIONS(4376),
    [sym_immutable] = ACTIONS(4376),
    [sym_import] = ACTIONS(4376),
    [sym_in] = ACTIONS(4376),
    [sym_inout] = ACTIONS(4376),
    [sym_interface] = ACTIONS(4376),
    [sym_invariant] = ACTIONS(4376),
    [sym_is] = ACTIONS(4376),
    [sym_mixin] = ACTIONS(4376),
    [sym_new] = ACTIONS(4376),
    [sym_nothrow] = ACTIONS(4376),
    [sym_out] = ACTIONS(4376),
    [sym_override] = ACTIONS(4376),
    [sym_package] = ACTIONS(4376),
    [sym_pragma] = ACTIONS(4376),
    [sym_private] = ACTIONS(4376),
    [sym_protected] = ACTIONS(4376),
    [sym_public] = ACTIONS(4376),
    [sym_pure] = ACTIONS(4376),
    [sym_ref] = ACTIONS(4376),
    [sym_return] = ACTIONS(4376),
    [sym_scope] = ACTIONS(4376),
    [sym_shared] = ACTIONS(4376),
    [sym_static] = ACTIONS(4376),
    [sym_struct] = ACTIONS(4376),
    [sym_switch] = ACTIONS(4376),
    [sym_synchronized] = ACTIONS(4376),
    [sym_template] = ACTIONS(4376),
    [sym_throw] = ACTIONS(4376),
    [sym_try] = ACTIONS(4376),
    [sym_typeid] = ACTIONS(4376),
    [sym_typeof] = ACTIONS(4376),
    [sym_union] = ACTIONS(4376),
    [sym_unittest] = ACTIONS(4376),
    [sym_version] = ACTIONS(4376),
    [sym_while] = ACTIONS(4376),
    [sym_with] = ACTIONS(4376),
    [sym_gshared] = ACTIONS(4376),
    [sym_traits] = ACTIONS(4376),
    [sym_vector] = ACTIONS(4376),
    [sym_void] = ACTIONS(4376),
    [anon_sym_BQUOTE] = ACTIONS(4378),
    [anon_sym_r_DQUOTE] = ACTIONS(4378),
    [anon_sym_x_DQUOTE] = ACTIONS(4378),
    [anon_sym_DQUOTE] = ACTIONS(4378),
    [anon_sym_i_BQUOTE] = ACTIONS(4378),
    [anon_sym_i_DQUOTE] = ACTIONS(4378),
    [anon_sym_iq_LBRACE] = ACTIONS(4378),
    [aux_sym_char_literal_token1] = ACTIONS(4378),
    [anon_sym_SQUOTE] = ACTIONS(4376),
    [anon_sym___DATE__] = ACTIONS(4376),
    [anon_sym___FILE__] = ACTIONS(4376),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4376),
    [anon_sym___FUNCTION__] = ACTIONS(4376),
    [anon_sym___LINE__] = ACTIONS(4376),
    [anon_sym___MODULE__] = ACTIONS(4376),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4376),
    [anon_sym___TIME__] = ACTIONS(4376),
    [anon_sym___TIMESTAMP__] = ACTIONS(4376),
    [anon_sym___VENDOR__] = ACTIONS(4376),
    [anon_sym___VERSION__] = ACTIONS(4376),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4378),
    [sym_float_literal] = ACTIONS(4378),
    [sym__string] = ACTIONS(4378),
  },
  [1349] = {
    [sym_identifier] = ACTIONS(4380),
    [anon_sym_q_LBRACE] = ACTIONS(4382),
    [anon_sym_RBRACE] = ACTIONS(4382),
    [anon_sym_LBRACE] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_DASH] = ACTIONS(4380),
    [anon_sym_DASH_DASH] = ACTIONS(4382),
    [anon_sym_PLUS] = ACTIONS(4380),
    [anon_sym_PLUS_PLUS] = ACTIONS(4382),
    [anon_sym_BANG] = ACTIONS(4382),
    [anon_sym_LPAREN] = ACTIONS(4382),
    [anon_sym_RPAREN] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(4382),
    [anon_sym_SEMI] = ACTIONS(4382),
    [anon_sym_DOLLAR] = ACTIONS(4382),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_TILDE] = ACTIONS(4382),
    [anon_sym_AT] = ACTIONS(4382),
    [sym_bool] = ACTIONS(4380),
    [sym_byte] = ACTIONS(4380),
    [sym_ubyte] = ACTIONS(4380),
    [sym_char] = ACTIONS(4380),
    [sym_short] = ACTIONS(4380),
    [sym_ushort] = ACTIONS(4380),
    [sym_int] = ACTIONS(4380),
    [sym_uint] = ACTIONS(4380),
    [sym_long] = ACTIONS(4380),
    [sym_ulong] = ACTIONS(4380),
    [sym_cent] = ACTIONS(4380),
    [sym_ucent] = ACTIONS(4380),
    [sym_wchar] = ACTIONS(4380),
    [sym_dchar] = ACTIONS(4380),
    [sym_float] = ACTIONS(4380),
    [sym_double] = ACTIONS(4380),
    [sym_real] = ACTIONS(4380),
    [sym_ifloat] = ACTIONS(4380),
    [sym_idouble] = ACTIONS(4380),
    [sym_ireal] = ACTIONS(4380),
    [sym_cfloat] = ACTIONS(4380),
    [sym_cdouble] = ACTIONS(4380),
    [sym_creal] = ACTIONS(4380),
    [sym_size_t] = ACTIONS(4380),
    [sym_ptrdiff_t] = ACTIONS(4380),
    [sym_string] = ACTIONS(4380),
    [sym_cstring] = ACTIONS(4380),
    [sym_dstring] = ACTIONS(4380),
    [sym_wstring] = ACTIONS(4380),
    [sym_noreturn] = ACTIONS(4380),
    [sym_true] = ACTIONS(4380),
    [sym_false] = ACTIONS(4380),
    [sym_null] = ACTIONS(4380),
    [sym_super] = ACTIONS(4380),
    [sym_this] = ACTIONS(4380),
    [sym_abstract] = ACTIONS(4380),
    [sym_alias] = ACTIONS(4380),
    [sym_align] = ACTIONS(4380),
    [sym_asm] = ACTIONS(4380),
    [sym_assert] = ACTIONS(4380),
    [sym_auto] = ACTIONS(4380),
    [sym_break] = ACTIONS(4380),
    [sym_case] = ACTIONS(4380),
    [sym_cast] = ACTIONS(4380),
    [sym_catch] = ACTIONS(4380),
    [sym_class] = ACTIONS(4380),
    [sym_const] = ACTIONS(4380),
    [sym_continue] = ACTIONS(4380),
    [sym_debug] = ACTIONS(4380),
    [sym_default] = ACTIONS(4380),
    [sym_delegate] = ACTIONS(4380),
    [sym_delete] = ACTIONS(4380),
    [sym_deprecated] = ACTIONS(4380),
    [sym_do] = ACTIONS(4380),
    [sym_else] = ACTIONS(4380),
    [sym_enum] = ACTIONS(4380),
    [sym_export] = ACTIONS(4380),
    [sym_extern] = ACTIONS(4380),
    [sym_final] = ACTIONS(4380),
    [sym_finally] = ACTIONS(4380),
    [sym_for] = ACTIONS(4380),
    [sym_foreach] = ACTIONS(4380),
    [sym_foreach_reverse] = ACTIONS(4380),
    [sym_function] = ACTIONS(4380),
    [sym_goto] = ACTIONS(4380),
    [sym_if] = ACTIONS(4380),
    [sym_immutable] = ACTIONS(4380),
    [sym_import] = ACTIONS(4380),
    [sym_in] = ACTIONS(4380),
    [sym_inout] = ACTIONS(4380),
    [sym_interface] = ACTIONS(4380),
    [sym_invariant] = ACTIONS(4380),
    [sym_is] = ACTIONS(4380),
    [sym_mixin] = ACTIONS(4380),
    [sym_new] = ACTIONS(4380),
    [sym_nothrow] = ACTIONS(4380),
    [sym_out] = ACTIONS(4380),
    [sym_override] = ACTIONS(4380),
    [sym_package] = ACTIONS(4380),
    [sym_pragma] = ACTIONS(4380),
    [sym_private] = ACTIONS(4380),
    [sym_protected] = ACTIONS(4380),
    [sym_public] = ACTIONS(4380),
    [sym_pure] = ACTIONS(4380),
    [sym_ref] = ACTIONS(4380),
    [sym_return] = ACTIONS(4380),
    [sym_scope] = ACTIONS(4380),
    [sym_shared] = ACTIONS(4380),
    [sym_static] = ACTIONS(4380),
    [sym_struct] = ACTIONS(4380),
    [sym_switch] = ACTIONS(4380),
    [sym_synchronized] = ACTIONS(4380),
    [sym_template] = ACTIONS(4380),
    [sym_throw] = ACTIONS(4380),
    [sym_try] = ACTIONS(4380),
    [sym_typeid] = ACTIONS(4380),
    [sym_typeof] = ACTIONS(4380),
    [sym_union] = ACTIONS(4380),
    [sym_unittest] = ACTIONS(4380),
    [sym_version] = ACTIONS(4380),
    [sym_while] = ACTIONS(4380),
    [sym_with] = ACTIONS(4380),
    [sym_gshared] = ACTIONS(4380),
    [sym_traits] = ACTIONS(4380),
    [sym_vector] = ACTIONS(4380),
    [sym_void] = ACTIONS(4380),
    [anon_sym_BQUOTE] = ACTIONS(4382),
    [anon_sym_r_DQUOTE] = ACTIONS(4382),
    [anon_sym_x_DQUOTE] = ACTIONS(4382),
    [anon_sym_DQUOTE] = ACTIONS(4382),
    [anon_sym_i_BQUOTE] = ACTIONS(4382),
    [anon_sym_i_DQUOTE] = ACTIONS(4382),
    [anon_sym_iq_LBRACE] = ACTIONS(4382),
    [aux_sym_char_literal_token1] = ACTIONS(4382),
    [anon_sym_SQUOTE] = ACTIONS(4380),
    [anon_sym___DATE__] = ACTIONS(4380),
    [anon_sym___FILE__] = ACTIONS(4380),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4380),
    [anon_sym___FUNCTION__] = ACTIONS(4380),
    [anon_sym___LINE__] = ACTIONS(4380),
    [anon_sym___MODULE__] = ACTIONS(4380),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4380),
    [anon_sym___TIME__] = ACTIONS(4380),
    [anon_sym___TIMESTAMP__] = ACTIONS(4380),
    [anon_sym___VENDOR__] = ACTIONS(4380),
    [anon_sym___VERSION__] = ACTIONS(4380),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4382),
    [sym_float_literal] = ACTIONS(4382),
    [sym__string] = ACTIONS(4382),
  },
  [1350] = {
    [sym_identifier] = ACTIONS(4384),
    [anon_sym_q_LBRACE] = ACTIONS(4386),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_LBRACE] = ACTIONS(4386),
    [anon_sym_DOT] = ACTIONS(4386),
    [anon_sym_AMP] = ACTIONS(4386),
    [anon_sym_DASH] = ACTIONS(4384),
    [anon_sym_DASH_DASH] = ACTIONS(4386),
    [anon_sym_PLUS] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4386),
    [anon_sym_LPAREN] = ACTIONS(4386),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_LBRACK] = ACTIONS(4386),
    [anon_sym_SEMI] = ACTIONS(4386),
    [anon_sym_DOLLAR] = ACTIONS(4386),
    [anon_sym_STAR] = ACTIONS(4386),
    [anon_sym_TILDE] = ACTIONS(4386),
    [anon_sym_AT] = ACTIONS(4386),
    [sym_bool] = ACTIONS(4384),
    [sym_byte] = ACTIONS(4384),
    [sym_ubyte] = ACTIONS(4384),
    [sym_char] = ACTIONS(4384),
    [sym_short] = ACTIONS(4384),
    [sym_ushort] = ACTIONS(4384),
    [sym_int] = ACTIONS(4384),
    [sym_uint] = ACTIONS(4384),
    [sym_long] = ACTIONS(4384),
    [sym_ulong] = ACTIONS(4384),
    [sym_cent] = ACTIONS(4384),
    [sym_ucent] = ACTIONS(4384),
    [sym_wchar] = ACTIONS(4384),
    [sym_dchar] = ACTIONS(4384),
    [sym_float] = ACTIONS(4384),
    [sym_double] = ACTIONS(4384),
    [sym_real] = ACTIONS(4384),
    [sym_ifloat] = ACTIONS(4384),
    [sym_idouble] = ACTIONS(4384),
    [sym_ireal] = ACTIONS(4384),
    [sym_cfloat] = ACTIONS(4384),
    [sym_cdouble] = ACTIONS(4384),
    [sym_creal] = ACTIONS(4384),
    [sym_size_t] = ACTIONS(4384),
    [sym_ptrdiff_t] = ACTIONS(4384),
    [sym_string] = ACTIONS(4384),
    [sym_cstring] = ACTIONS(4384),
    [sym_dstring] = ACTIONS(4384),
    [sym_wstring] = ACTIONS(4384),
    [sym_noreturn] = ACTIONS(4384),
    [sym_true] = ACTIONS(4384),
    [sym_false] = ACTIONS(4384),
    [sym_null] = ACTIONS(4384),
    [sym_super] = ACTIONS(4384),
    [sym_this] = ACTIONS(4384),
    [sym_abstract] = ACTIONS(4384),
    [sym_alias] = ACTIONS(4384),
    [sym_align] = ACTIONS(4384),
    [sym_asm] = ACTIONS(4384),
    [sym_assert] = ACTIONS(4384),
    [sym_auto] = ACTIONS(4384),
    [sym_break] = ACTIONS(4384),
    [sym_case] = ACTIONS(4384),
    [sym_cast] = ACTIONS(4384),
    [sym_catch] = ACTIONS(4384),
    [sym_class] = ACTIONS(4384),
    [sym_const] = ACTIONS(4384),
    [sym_continue] = ACTIONS(4384),
    [sym_debug] = ACTIONS(4384),
    [sym_default] = ACTIONS(4384),
    [sym_delegate] = ACTIONS(4384),
    [sym_delete] = ACTIONS(4384),
    [sym_deprecated] = ACTIONS(4384),
    [sym_do] = ACTIONS(4384),
    [sym_else] = ACTIONS(4384),
    [sym_enum] = ACTIONS(4384),
    [sym_export] = ACTIONS(4384),
    [sym_extern] = ACTIONS(4384),
    [sym_final] = ACTIONS(4384),
    [sym_finally] = ACTIONS(4384),
    [sym_for] = ACTIONS(4384),
    [sym_foreach] = ACTIONS(4384),
    [sym_foreach_reverse] = ACTIONS(4384),
    [sym_function] = ACTIONS(4384),
    [sym_goto] = ACTIONS(4384),
    [sym_if] = ACTIONS(4384),
    [sym_immutable] = ACTIONS(4384),
    [sym_import] = ACTIONS(4384),
    [sym_in] = ACTIONS(4384),
    [sym_inout] = ACTIONS(4384),
    [sym_interface] = ACTIONS(4384),
    [sym_invariant] = ACTIONS(4384),
    [sym_is] = ACTIONS(4384),
    [sym_mixin] = ACTIONS(4384),
    [sym_new] = ACTIONS(4384),
    [sym_nothrow] = ACTIONS(4384),
    [sym_out] = ACTIONS(4384),
    [sym_override] = ACTIONS(4384),
    [sym_package] = ACTIONS(4384),
    [sym_pragma] = ACTIONS(4384),
    [sym_private] = ACTIONS(4384),
    [sym_protected] = ACTIONS(4384),
    [sym_public] = ACTIONS(4384),
    [sym_pure] = ACTIONS(4384),
    [sym_ref] = ACTIONS(4384),
    [sym_return] = ACTIONS(4384),
    [sym_scope] = ACTIONS(4384),
    [sym_shared] = ACTIONS(4384),
    [sym_static] = ACTIONS(4384),
    [sym_struct] = ACTIONS(4384),
    [sym_switch] = ACTIONS(4384),
    [sym_synchronized] = ACTIONS(4384),
    [sym_template] = ACTIONS(4384),
    [sym_throw] = ACTIONS(4384),
    [sym_try] = ACTIONS(4384),
    [sym_typeid] = ACTIONS(4384),
    [sym_typeof] = ACTIONS(4384),
    [sym_union] = ACTIONS(4384),
    [sym_unittest] = ACTIONS(4384),
    [sym_version] = ACTIONS(4384),
    [sym_while] = ACTIONS(4384),
    [sym_with] = ACTIONS(4384),
    [sym_gshared] = ACTIONS(4384),
    [sym_traits] = ACTIONS(4384),
    [sym_vector] = ACTIONS(4384),
    [sym_void] = ACTIONS(4384),
    [anon_sym_BQUOTE] = ACTIONS(4386),
    [anon_sym_r_DQUOTE] = ACTIONS(4386),
    [anon_sym_x_DQUOTE] = ACTIONS(4386),
    [anon_sym_DQUOTE] = ACTIONS(4386),
    [anon_sym_i_BQUOTE] = ACTIONS(4386),
    [anon_sym_i_DQUOTE] = ACTIONS(4386),
    [anon_sym_iq_LBRACE] = ACTIONS(4386),
    [aux_sym_char_literal_token1] = ACTIONS(4386),
    [anon_sym_SQUOTE] = ACTIONS(4384),
    [anon_sym___DATE__] = ACTIONS(4384),
    [anon_sym___FILE__] = ACTIONS(4384),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4384),
    [anon_sym___FUNCTION__] = ACTIONS(4384),
    [anon_sym___LINE__] = ACTIONS(4384),
    [anon_sym___MODULE__] = ACTIONS(4384),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4384),
    [anon_sym___TIME__] = ACTIONS(4384),
    [anon_sym___TIMESTAMP__] = ACTIONS(4384),
    [anon_sym___VENDOR__] = ACTIONS(4384),
    [anon_sym___VERSION__] = ACTIONS(4384),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4386),
    [sym_float_literal] = ACTIONS(4386),
    [sym__string] = ACTIONS(4386),
  },
  [1351] = {
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_q_LBRACE] = ACTIONS(4390),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_LBRACE] = ACTIONS(4390),
    [anon_sym_DOT] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4388),
    [anon_sym_DASH_DASH] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4388),
    [anon_sym_PLUS_PLUS] = ACTIONS(4390),
    [anon_sym_BANG] = ACTIONS(4390),
    [anon_sym_LPAREN] = ACTIONS(4390),
    [anon_sym_RPAREN] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4390),
    [anon_sym_DOLLAR] = ACTIONS(4390),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_TILDE] = ACTIONS(4390),
    [anon_sym_AT] = ACTIONS(4390),
    [sym_bool] = ACTIONS(4388),
    [sym_byte] = ACTIONS(4388),
    [sym_ubyte] = ACTIONS(4388),
    [sym_char] = ACTIONS(4388),
    [sym_short] = ACTIONS(4388),
    [sym_ushort] = ACTIONS(4388),
    [sym_int] = ACTIONS(4388),
    [sym_uint] = ACTIONS(4388),
    [sym_long] = ACTIONS(4388),
    [sym_ulong] = ACTIONS(4388),
    [sym_cent] = ACTIONS(4388),
    [sym_ucent] = ACTIONS(4388),
    [sym_wchar] = ACTIONS(4388),
    [sym_dchar] = ACTIONS(4388),
    [sym_float] = ACTIONS(4388),
    [sym_double] = ACTIONS(4388),
    [sym_real] = ACTIONS(4388),
    [sym_ifloat] = ACTIONS(4388),
    [sym_idouble] = ACTIONS(4388),
    [sym_ireal] = ACTIONS(4388),
    [sym_cfloat] = ACTIONS(4388),
    [sym_cdouble] = ACTIONS(4388),
    [sym_creal] = ACTIONS(4388),
    [sym_size_t] = ACTIONS(4388),
    [sym_ptrdiff_t] = ACTIONS(4388),
    [sym_string] = ACTIONS(4388),
    [sym_cstring] = ACTIONS(4388),
    [sym_dstring] = ACTIONS(4388),
    [sym_wstring] = ACTIONS(4388),
    [sym_noreturn] = ACTIONS(4388),
    [sym_true] = ACTIONS(4388),
    [sym_false] = ACTIONS(4388),
    [sym_null] = ACTIONS(4388),
    [sym_super] = ACTIONS(4388),
    [sym_this] = ACTIONS(4388),
    [sym_abstract] = ACTIONS(4388),
    [sym_alias] = ACTIONS(4388),
    [sym_align] = ACTIONS(4388),
    [sym_asm] = ACTIONS(4388),
    [sym_assert] = ACTIONS(4388),
    [sym_auto] = ACTIONS(4388),
    [sym_break] = ACTIONS(4388),
    [sym_case] = ACTIONS(4388),
    [sym_cast] = ACTIONS(4388),
    [sym_catch] = ACTIONS(4388),
    [sym_class] = ACTIONS(4388),
    [sym_const] = ACTIONS(4388),
    [sym_continue] = ACTIONS(4388),
    [sym_debug] = ACTIONS(4388),
    [sym_default] = ACTIONS(4388),
    [sym_delegate] = ACTIONS(4388),
    [sym_delete] = ACTIONS(4388),
    [sym_deprecated] = ACTIONS(4388),
    [sym_do] = ACTIONS(4388),
    [sym_else] = ACTIONS(4388),
    [sym_enum] = ACTIONS(4388),
    [sym_export] = ACTIONS(4388),
    [sym_extern] = ACTIONS(4388),
    [sym_final] = ACTIONS(4388),
    [sym_finally] = ACTIONS(4388),
    [sym_for] = ACTIONS(4388),
    [sym_foreach] = ACTIONS(4388),
    [sym_foreach_reverse] = ACTIONS(4388),
    [sym_function] = ACTIONS(4388),
    [sym_goto] = ACTIONS(4388),
    [sym_if] = ACTIONS(4388),
    [sym_immutable] = ACTIONS(4388),
    [sym_import] = ACTIONS(4388),
    [sym_in] = ACTIONS(4388),
    [sym_inout] = ACTIONS(4388),
    [sym_interface] = ACTIONS(4388),
    [sym_invariant] = ACTIONS(4388),
    [sym_is] = ACTIONS(4388),
    [sym_mixin] = ACTIONS(4388),
    [sym_new] = ACTIONS(4388),
    [sym_nothrow] = ACTIONS(4388),
    [sym_out] = ACTIONS(4388),
    [sym_override] = ACTIONS(4388),
    [sym_package] = ACTIONS(4388),
    [sym_pragma] = ACTIONS(4388),
    [sym_private] = ACTIONS(4388),
    [sym_protected] = ACTIONS(4388),
    [sym_public] = ACTIONS(4388),
    [sym_pure] = ACTIONS(4388),
    [sym_ref] = ACTIONS(4388),
    [sym_return] = ACTIONS(4388),
    [sym_scope] = ACTIONS(4388),
    [sym_shared] = ACTIONS(4388),
    [sym_static] = ACTIONS(4388),
    [sym_struct] = ACTIONS(4388),
    [sym_switch] = ACTIONS(4388),
    [sym_synchronized] = ACTIONS(4388),
    [sym_template] = ACTIONS(4388),
    [sym_throw] = ACTIONS(4388),
    [sym_try] = ACTIONS(4388),
    [sym_typeid] = ACTIONS(4388),
    [sym_typeof] = ACTIONS(4388),
    [sym_union] = ACTIONS(4388),
    [sym_unittest] = ACTIONS(4388),
    [sym_version] = ACTIONS(4388),
    [sym_while] = ACTIONS(4388),
    [sym_with] = ACTIONS(4388),
    [sym_gshared] = ACTIONS(4388),
    [sym_traits] = ACTIONS(4388),
    [sym_vector] = ACTIONS(4388),
    [sym_void] = ACTIONS(4388),
    [anon_sym_BQUOTE] = ACTIONS(4390),
    [anon_sym_r_DQUOTE] = ACTIONS(4390),
    [anon_sym_x_DQUOTE] = ACTIONS(4390),
    [anon_sym_DQUOTE] = ACTIONS(4390),
    [anon_sym_i_BQUOTE] = ACTIONS(4390),
    [anon_sym_i_DQUOTE] = ACTIONS(4390),
    [anon_sym_iq_LBRACE] = ACTIONS(4390),
    [aux_sym_char_literal_token1] = ACTIONS(4390),
    [anon_sym_SQUOTE] = ACTIONS(4388),
    [anon_sym___DATE__] = ACTIONS(4388),
    [anon_sym___FILE__] = ACTIONS(4388),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4388),
    [anon_sym___FUNCTION__] = ACTIONS(4388),
    [anon_sym___LINE__] = ACTIONS(4388),
    [anon_sym___MODULE__] = ACTIONS(4388),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4388),
    [anon_sym___TIME__] = ACTIONS(4388),
    [anon_sym___TIMESTAMP__] = ACTIONS(4388),
    [anon_sym___VENDOR__] = ACTIONS(4388),
    [anon_sym___VERSION__] = ACTIONS(4388),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4390),
    [sym_float_literal] = ACTIONS(4390),
    [sym__string] = ACTIONS(4390),
  },
  [1352] = {
    [sym_identifier] = ACTIONS(4392),
    [anon_sym_q_LBRACE] = ACTIONS(4394),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_LBRACE] = ACTIONS(4394),
    [anon_sym_DOT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_DASH] = ACTIONS(4392),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS] = ACTIONS(4392),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_BANG] = ACTIONS(4394),
    [anon_sym_LPAREN] = ACTIONS(4394),
    [anon_sym_RPAREN] = ACTIONS(4394),
    [anon_sym_LBRACK] = ACTIONS(4394),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_DOLLAR] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(4394),
    [anon_sym_TILDE] = ACTIONS(4394),
    [anon_sym_AT] = ACTIONS(4394),
    [sym_bool] = ACTIONS(4392),
    [sym_byte] = ACTIONS(4392),
    [sym_ubyte] = ACTIONS(4392),
    [sym_char] = ACTIONS(4392),
    [sym_short] = ACTIONS(4392),
    [sym_ushort] = ACTIONS(4392),
    [sym_int] = ACTIONS(4392),
    [sym_uint] = ACTIONS(4392),
    [sym_long] = ACTIONS(4392),
    [sym_ulong] = ACTIONS(4392),
    [sym_cent] = ACTIONS(4392),
    [sym_ucent] = ACTIONS(4392),
    [sym_wchar] = ACTIONS(4392),
    [sym_dchar] = ACTIONS(4392),
    [sym_float] = ACTIONS(4392),
    [sym_double] = ACTIONS(4392),
    [sym_real] = ACTIONS(4392),
    [sym_ifloat] = ACTIONS(4392),
    [sym_idouble] = ACTIONS(4392),
    [sym_ireal] = ACTIONS(4392),
    [sym_cfloat] = ACTIONS(4392),
    [sym_cdouble] = ACTIONS(4392),
    [sym_creal] = ACTIONS(4392),
    [sym_size_t] = ACTIONS(4392),
    [sym_ptrdiff_t] = ACTIONS(4392),
    [sym_string] = ACTIONS(4392),
    [sym_cstring] = ACTIONS(4392),
    [sym_dstring] = ACTIONS(4392),
    [sym_wstring] = ACTIONS(4392),
    [sym_noreturn] = ACTIONS(4392),
    [sym_true] = ACTIONS(4392),
    [sym_false] = ACTIONS(4392),
    [sym_null] = ACTIONS(4392),
    [sym_super] = ACTIONS(4392),
    [sym_this] = ACTIONS(4392),
    [sym_abstract] = ACTIONS(4392),
    [sym_alias] = ACTIONS(4392),
    [sym_align] = ACTIONS(4392),
    [sym_asm] = ACTIONS(4392),
    [sym_assert] = ACTIONS(4392),
    [sym_auto] = ACTIONS(4392),
    [sym_break] = ACTIONS(4392),
    [sym_case] = ACTIONS(4392),
    [sym_cast] = ACTIONS(4392),
    [sym_catch] = ACTIONS(4392),
    [sym_class] = ACTIONS(4392),
    [sym_const] = ACTIONS(4392),
    [sym_continue] = ACTIONS(4392),
    [sym_debug] = ACTIONS(4392),
    [sym_default] = ACTIONS(4392),
    [sym_delegate] = ACTIONS(4392),
    [sym_delete] = ACTIONS(4392),
    [sym_deprecated] = ACTIONS(4392),
    [sym_do] = ACTIONS(4392),
    [sym_else] = ACTIONS(4392),
    [sym_enum] = ACTIONS(4392),
    [sym_export] = ACTIONS(4392),
    [sym_extern] = ACTIONS(4392),
    [sym_final] = ACTIONS(4392),
    [sym_finally] = ACTIONS(4392),
    [sym_for] = ACTIONS(4392),
    [sym_foreach] = ACTIONS(4392),
    [sym_foreach_reverse] = ACTIONS(4392),
    [sym_function] = ACTIONS(4392),
    [sym_goto] = ACTIONS(4392),
    [sym_if] = ACTIONS(4392),
    [sym_immutable] = ACTIONS(4392),
    [sym_import] = ACTIONS(4392),
    [sym_in] = ACTIONS(4392),
    [sym_inout] = ACTIONS(4392),
    [sym_interface] = ACTIONS(4392),
    [sym_invariant] = ACTIONS(4392),
    [sym_is] = ACTIONS(4392),
    [sym_mixin] = ACTIONS(4392),
    [sym_new] = ACTIONS(4392),
    [sym_nothrow] = ACTIONS(4392),
    [sym_out] = ACTIONS(4392),
    [sym_override] = ACTIONS(4392),
    [sym_package] = ACTIONS(4392),
    [sym_pragma] = ACTIONS(4392),
    [sym_private] = ACTIONS(4392),
    [sym_protected] = ACTIONS(4392),
    [sym_public] = ACTIONS(4392),
    [sym_pure] = ACTIONS(4392),
    [sym_ref] = ACTIONS(4392),
    [sym_return] = ACTIONS(4392),
    [sym_scope] = ACTIONS(4392),
    [sym_shared] = ACTIONS(4392),
    [sym_static] = ACTIONS(4392),
    [sym_struct] = ACTIONS(4392),
    [sym_switch] = ACTIONS(4392),
    [sym_synchronized] = ACTIONS(4392),
    [sym_template] = ACTIONS(4392),
    [sym_throw] = ACTIONS(4392),
    [sym_try] = ACTIONS(4392),
    [sym_typeid] = ACTIONS(4392),
    [sym_typeof] = ACTIONS(4392),
    [sym_union] = ACTIONS(4392),
    [sym_unittest] = ACTIONS(4392),
    [sym_version] = ACTIONS(4392),
    [sym_while] = ACTIONS(4392),
    [sym_with] = ACTIONS(4392),
    [sym_gshared] = ACTIONS(4392),
    [sym_traits] = ACTIONS(4392),
    [sym_vector] = ACTIONS(4392),
    [sym_void] = ACTIONS(4392),
    [anon_sym_BQUOTE] = ACTIONS(4394),
    [anon_sym_r_DQUOTE] = ACTIONS(4394),
    [anon_sym_x_DQUOTE] = ACTIONS(4394),
    [anon_sym_DQUOTE] = ACTIONS(4394),
    [anon_sym_i_BQUOTE] = ACTIONS(4394),
    [anon_sym_i_DQUOTE] = ACTIONS(4394),
    [anon_sym_iq_LBRACE] = ACTIONS(4394),
    [aux_sym_char_literal_token1] = ACTIONS(4394),
    [anon_sym_SQUOTE] = ACTIONS(4392),
    [anon_sym___DATE__] = ACTIONS(4392),
    [anon_sym___FILE__] = ACTIONS(4392),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4392),
    [anon_sym___FUNCTION__] = ACTIONS(4392),
    [anon_sym___LINE__] = ACTIONS(4392),
    [anon_sym___MODULE__] = ACTIONS(4392),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4392),
    [anon_sym___TIME__] = ACTIONS(4392),
    [anon_sym___TIMESTAMP__] = ACTIONS(4392),
    [anon_sym___VENDOR__] = ACTIONS(4392),
    [anon_sym___VERSION__] = ACTIONS(4392),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4394),
    [sym_float_literal] = ACTIONS(4394),
    [sym__string] = ACTIONS(4394),
  },
  [1353] = {
    [sym_identifier] = ACTIONS(4396),
    [anon_sym_q_LBRACE] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4398),
    [anon_sym_DASH] = ACTIONS(4396),
    [anon_sym_DASH_DASH] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4398),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_DOLLAR] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4398),
    [anon_sym_TILDE] = ACTIONS(4398),
    [anon_sym_AT] = ACTIONS(4398),
    [sym_bool] = ACTIONS(4396),
    [sym_byte] = ACTIONS(4396),
    [sym_ubyte] = ACTIONS(4396),
    [sym_char] = ACTIONS(4396),
    [sym_short] = ACTIONS(4396),
    [sym_ushort] = ACTIONS(4396),
    [sym_int] = ACTIONS(4396),
    [sym_uint] = ACTIONS(4396),
    [sym_long] = ACTIONS(4396),
    [sym_ulong] = ACTIONS(4396),
    [sym_cent] = ACTIONS(4396),
    [sym_ucent] = ACTIONS(4396),
    [sym_wchar] = ACTIONS(4396),
    [sym_dchar] = ACTIONS(4396),
    [sym_float] = ACTIONS(4396),
    [sym_double] = ACTIONS(4396),
    [sym_real] = ACTIONS(4396),
    [sym_ifloat] = ACTIONS(4396),
    [sym_idouble] = ACTIONS(4396),
    [sym_ireal] = ACTIONS(4396),
    [sym_cfloat] = ACTIONS(4396),
    [sym_cdouble] = ACTIONS(4396),
    [sym_creal] = ACTIONS(4396),
    [sym_size_t] = ACTIONS(4396),
    [sym_ptrdiff_t] = ACTIONS(4396),
    [sym_string] = ACTIONS(4396),
    [sym_cstring] = ACTIONS(4396),
    [sym_dstring] = ACTIONS(4396),
    [sym_wstring] = ACTIONS(4396),
    [sym_noreturn] = ACTIONS(4396),
    [sym_true] = ACTIONS(4396),
    [sym_false] = ACTIONS(4396),
    [sym_null] = ACTIONS(4396),
    [sym_super] = ACTIONS(4396),
    [sym_this] = ACTIONS(4396),
    [sym_abstract] = ACTIONS(4396),
    [sym_alias] = ACTIONS(4396),
    [sym_align] = ACTIONS(4396),
    [sym_asm] = ACTIONS(4396),
    [sym_assert] = ACTIONS(4396),
    [sym_auto] = ACTIONS(4396),
    [sym_break] = ACTIONS(4396),
    [sym_case] = ACTIONS(4396),
    [sym_cast] = ACTIONS(4396),
    [sym_catch] = ACTIONS(4396),
    [sym_class] = ACTIONS(4396),
    [sym_const] = ACTIONS(4396),
    [sym_continue] = ACTIONS(4396),
    [sym_debug] = ACTIONS(4396),
    [sym_default] = ACTIONS(4396),
    [sym_delegate] = ACTIONS(4396),
    [sym_delete] = ACTIONS(4396),
    [sym_deprecated] = ACTIONS(4396),
    [sym_do] = ACTIONS(4396),
    [sym_else] = ACTIONS(4396),
    [sym_enum] = ACTIONS(4396),
    [sym_export] = ACTIONS(4396),
    [sym_extern] = ACTIONS(4396),
    [sym_final] = ACTIONS(4396),
    [sym_finally] = ACTIONS(4396),
    [sym_for] = ACTIONS(4396),
    [sym_foreach] = ACTIONS(4396),
    [sym_foreach_reverse] = ACTIONS(4396),
    [sym_function] = ACTIONS(4396),
    [sym_goto] = ACTIONS(4396),
    [sym_if] = ACTIONS(4396),
    [sym_immutable] = ACTIONS(4396),
    [sym_import] = ACTIONS(4396),
    [sym_in] = ACTIONS(4396),
    [sym_inout] = ACTIONS(4396),
    [sym_interface] = ACTIONS(4396),
    [sym_invariant] = ACTIONS(4396),
    [sym_is] = ACTIONS(4396),
    [sym_mixin] = ACTIONS(4396),
    [sym_new] = ACTIONS(4396),
    [sym_nothrow] = ACTIONS(4396),
    [sym_out] = ACTIONS(4396),
    [sym_override] = ACTIONS(4396),
    [sym_package] = ACTIONS(4396),
    [sym_pragma] = ACTIONS(4396),
    [sym_private] = ACTIONS(4396),
    [sym_protected] = ACTIONS(4396),
    [sym_public] = ACTIONS(4396),
    [sym_pure] = ACTIONS(4396),
    [sym_ref] = ACTIONS(4396),
    [sym_return] = ACTIONS(4396),
    [sym_scope] = ACTIONS(4396),
    [sym_shared] = ACTIONS(4396),
    [sym_static] = ACTIONS(4396),
    [sym_struct] = ACTIONS(4396),
    [sym_switch] = ACTIONS(4396),
    [sym_synchronized] = ACTIONS(4396),
    [sym_template] = ACTIONS(4396),
    [sym_throw] = ACTIONS(4396),
    [sym_try] = ACTIONS(4396),
    [sym_typeid] = ACTIONS(4396),
    [sym_typeof] = ACTIONS(4396),
    [sym_union] = ACTIONS(4396),
    [sym_unittest] = ACTIONS(4396),
    [sym_version] = ACTIONS(4396),
    [sym_while] = ACTIONS(4396),
    [sym_with] = ACTIONS(4396),
    [sym_gshared] = ACTIONS(4396),
    [sym_traits] = ACTIONS(4396),
    [sym_vector] = ACTIONS(4396),
    [sym_void] = ACTIONS(4396),
    [anon_sym_BQUOTE] = ACTIONS(4398),
    [anon_sym_r_DQUOTE] = ACTIONS(4398),
    [anon_sym_x_DQUOTE] = ACTIONS(4398),
    [anon_sym_DQUOTE] = ACTIONS(4398),
    [anon_sym_i_BQUOTE] = ACTIONS(4398),
    [anon_sym_i_DQUOTE] = ACTIONS(4398),
    [anon_sym_iq_LBRACE] = ACTIONS(4398),
    [aux_sym_char_literal_token1] = ACTIONS(4398),
    [anon_sym_SQUOTE] = ACTIONS(4396),
    [anon_sym___DATE__] = ACTIONS(4396),
    [anon_sym___FILE__] = ACTIONS(4396),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4396),
    [anon_sym___FUNCTION__] = ACTIONS(4396),
    [anon_sym___LINE__] = ACTIONS(4396),
    [anon_sym___MODULE__] = ACTIONS(4396),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4396),
    [anon_sym___TIME__] = ACTIONS(4396),
    [anon_sym___TIMESTAMP__] = ACTIONS(4396),
    [anon_sym___VENDOR__] = ACTIONS(4396),
    [anon_sym___VERSION__] = ACTIONS(4396),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4398),
    [sym_float_literal] = ACTIONS(4398),
    [sym__string] = ACTIONS(4398),
  },
  [1354] = {
    [sym_identifier] = ACTIONS(4400),
    [anon_sym_q_LBRACE] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_LPAREN] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_DOLLAR] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4402),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_AT] = ACTIONS(4402),
    [sym_bool] = ACTIONS(4400),
    [sym_byte] = ACTIONS(4400),
    [sym_ubyte] = ACTIONS(4400),
    [sym_char] = ACTIONS(4400),
    [sym_short] = ACTIONS(4400),
    [sym_ushort] = ACTIONS(4400),
    [sym_int] = ACTIONS(4400),
    [sym_uint] = ACTIONS(4400),
    [sym_long] = ACTIONS(4400),
    [sym_ulong] = ACTIONS(4400),
    [sym_cent] = ACTIONS(4400),
    [sym_ucent] = ACTIONS(4400),
    [sym_wchar] = ACTIONS(4400),
    [sym_dchar] = ACTIONS(4400),
    [sym_float] = ACTIONS(4400),
    [sym_double] = ACTIONS(4400),
    [sym_real] = ACTIONS(4400),
    [sym_ifloat] = ACTIONS(4400),
    [sym_idouble] = ACTIONS(4400),
    [sym_ireal] = ACTIONS(4400),
    [sym_cfloat] = ACTIONS(4400),
    [sym_cdouble] = ACTIONS(4400),
    [sym_creal] = ACTIONS(4400),
    [sym_size_t] = ACTIONS(4400),
    [sym_ptrdiff_t] = ACTIONS(4400),
    [sym_string] = ACTIONS(4400),
    [sym_cstring] = ACTIONS(4400),
    [sym_dstring] = ACTIONS(4400),
    [sym_wstring] = ACTIONS(4400),
    [sym_noreturn] = ACTIONS(4400),
    [sym_true] = ACTIONS(4400),
    [sym_false] = ACTIONS(4400),
    [sym_null] = ACTIONS(4400),
    [sym_super] = ACTIONS(4400),
    [sym_this] = ACTIONS(4400),
    [sym_abstract] = ACTIONS(4400),
    [sym_alias] = ACTIONS(4400),
    [sym_align] = ACTIONS(4400),
    [sym_asm] = ACTIONS(4400),
    [sym_assert] = ACTIONS(4400),
    [sym_auto] = ACTIONS(4400),
    [sym_break] = ACTIONS(4400),
    [sym_case] = ACTIONS(4400),
    [sym_cast] = ACTIONS(4400),
    [sym_catch] = ACTIONS(4400),
    [sym_class] = ACTIONS(4400),
    [sym_const] = ACTIONS(4400),
    [sym_continue] = ACTIONS(4400),
    [sym_debug] = ACTIONS(4400),
    [sym_default] = ACTIONS(4400),
    [sym_delegate] = ACTIONS(4400),
    [sym_delete] = ACTIONS(4400),
    [sym_deprecated] = ACTIONS(4400),
    [sym_do] = ACTIONS(4400),
    [sym_else] = ACTIONS(4400),
    [sym_enum] = ACTIONS(4400),
    [sym_export] = ACTIONS(4400),
    [sym_extern] = ACTIONS(4400),
    [sym_final] = ACTIONS(4400),
    [sym_finally] = ACTIONS(4400),
    [sym_for] = ACTIONS(4400),
    [sym_foreach] = ACTIONS(4400),
    [sym_foreach_reverse] = ACTIONS(4400),
    [sym_function] = ACTIONS(4400),
    [sym_goto] = ACTIONS(4400),
    [sym_if] = ACTIONS(4400),
    [sym_immutable] = ACTIONS(4400),
    [sym_import] = ACTIONS(4400),
    [sym_in] = ACTIONS(4400),
    [sym_inout] = ACTIONS(4400),
    [sym_interface] = ACTIONS(4400),
    [sym_invariant] = ACTIONS(4400),
    [sym_is] = ACTIONS(4400),
    [sym_mixin] = ACTIONS(4400),
    [sym_new] = ACTIONS(4400),
    [sym_nothrow] = ACTIONS(4400),
    [sym_out] = ACTIONS(4400),
    [sym_override] = ACTIONS(4400),
    [sym_package] = ACTIONS(4400),
    [sym_pragma] = ACTIONS(4400),
    [sym_private] = ACTIONS(4400),
    [sym_protected] = ACTIONS(4400),
    [sym_public] = ACTIONS(4400),
    [sym_pure] = ACTIONS(4400),
    [sym_ref] = ACTIONS(4400),
    [sym_return] = ACTIONS(4400),
    [sym_scope] = ACTIONS(4400),
    [sym_shared] = ACTIONS(4400),
    [sym_static] = ACTIONS(4400),
    [sym_struct] = ACTIONS(4400),
    [sym_switch] = ACTIONS(4400),
    [sym_synchronized] = ACTIONS(4400),
    [sym_template] = ACTIONS(4400),
    [sym_throw] = ACTIONS(4400),
    [sym_try] = ACTIONS(4400),
    [sym_typeid] = ACTIONS(4400),
    [sym_typeof] = ACTIONS(4400),
    [sym_union] = ACTIONS(4400),
    [sym_unittest] = ACTIONS(4400),
    [sym_version] = ACTIONS(4400),
    [sym_while] = ACTIONS(4400),
    [sym_with] = ACTIONS(4400),
    [sym_gshared] = ACTIONS(4400),
    [sym_traits] = ACTIONS(4400),
    [sym_vector] = ACTIONS(4400),
    [sym_void] = ACTIONS(4400),
    [anon_sym_BQUOTE] = ACTIONS(4402),
    [anon_sym_r_DQUOTE] = ACTIONS(4402),
    [anon_sym_x_DQUOTE] = ACTIONS(4402),
    [anon_sym_DQUOTE] = ACTIONS(4402),
    [anon_sym_i_BQUOTE] = ACTIONS(4402),
    [anon_sym_i_DQUOTE] = ACTIONS(4402),
    [anon_sym_iq_LBRACE] = ACTIONS(4402),
    [aux_sym_char_literal_token1] = ACTIONS(4402),
    [anon_sym_SQUOTE] = ACTIONS(4400),
    [anon_sym___DATE__] = ACTIONS(4400),
    [anon_sym___FILE__] = ACTIONS(4400),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4400),
    [anon_sym___FUNCTION__] = ACTIONS(4400),
    [anon_sym___LINE__] = ACTIONS(4400),
    [anon_sym___MODULE__] = ACTIONS(4400),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4400),
    [anon_sym___TIME__] = ACTIONS(4400),
    [anon_sym___TIMESTAMP__] = ACTIONS(4400),
    [anon_sym___VENDOR__] = ACTIONS(4400),
    [anon_sym___VERSION__] = ACTIONS(4400),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4402),
    [sym_float_literal] = ACTIONS(4402),
    [sym__string] = ACTIONS(4402),
  },
  [1355] = {
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_q_LBRACE] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4406),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_AT] = ACTIONS(4406),
    [sym_bool] = ACTIONS(4404),
    [sym_byte] = ACTIONS(4404),
    [sym_ubyte] = ACTIONS(4404),
    [sym_char] = ACTIONS(4404),
    [sym_short] = ACTIONS(4404),
    [sym_ushort] = ACTIONS(4404),
    [sym_int] = ACTIONS(4404),
    [sym_uint] = ACTIONS(4404),
    [sym_long] = ACTIONS(4404),
    [sym_ulong] = ACTIONS(4404),
    [sym_cent] = ACTIONS(4404),
    [sym_ucent] = ACTIONS(4404),
    [sym_wchar] = ACTIONS(4404),
    [sym_dchar] = ACTIONS(4404),
    [sym_float] = ACTIONS(4404),
    [sym_double] = ACTIONS(4404),
    [sym_real] = ACTIONS(4404),
    [sym_ifloat] = ACTIONS(4404),
    [sym_idouble] = ACTIONS(4404),
    [sym_ireal] = ACTIONS(4404),
    [sym_cfloat] = ACTIONS(4404),
    [sym_cdouble] = ACTIONS(4404),
    [sym_creal] = ACTIONS(4404),
    [sym_size_t] = ACTIONS(4404),
    [sym_ptrdiff_t] = ACTIONS(4404),
    [sym_string] = ACTIONS(4404),
    [sym_cstring] = ACTIONS(4404),
    [sym_dstring] = ACTIONS(4404),
    [sym_wstring] = ACTIONS(4404),
    [sym_noreturn] = ACTIONS(4404),
    [sym_true] = ACTIONS(4404),
    [sym_false] = ACTIONS(4404),
    [sym_null] = ACTIONS(4404),
    [sym_super] = ACTIONS(4404),
    [sym_this] = ACTIONS(4404),
    [sym_abstract] = ACTIONS(4404),
    [sym_alias] = ACTIONS(4404),
    [sym_align] = ACTIONS(4404),
    [sym_asm] = ACTIONS(4404),
    [sym_assert] = ACTIONS(4404),
    [sym_auto] = ACTIONS(4404),
    [sym_break] = ACTIONS(4404),
    [sym_case] = ACTIONS(4404),
    [sym_cast] = ACTIONS(4404),
    [sym_catch] = ACTIONS(4404),
    [sym_class] = ACTIONS(4404),
    [sym_const] = ACTIONS(4404),
    [sym_continue] = ACTIONS(4404),
    [sym_debug] = ACTIONS(4404),
    [sym_default] = ACTIONS(4404),
    [sym_delegate] = ACTIONS(4404),
    [sym_delete] = ACTIONS(4404),
    [sym_deprecated] = ACTIONS(4404),
    [sym_do] = ACTIONS(4404),
    [sym_else] = ACTIONS(4404),
    [sym_enum] = ACTIONS(4404),
    [sym_export] = ACTIONS(4404),
    [sym_extern] = ACTIONS(4404),
    [sym_final] = ACTIONS(4404),
    [sym_finally] = ACTIONS(4404),
    [sym_for] = ACTIONS(4404),
    [sym_foreach] = ACTIONS(4404),
    [sym_foreach_reverse] = ACTIONS(4404),
    [sym_function] = ACTIONS(4404),
    [sym_goto] = ACTIONS(4404),
    [sym_if] = ACTIONS(4404),
    [sym_immutable] = ACTIONS(4404),
    [sym_import] = ACTIONS(4404),
    [sym_in] = ACTIONS(4404),
    [sym_inout] = ACTIONS(4404),
    [sym_interface] = ACTIONS(4404),
    [sym_invariant] = ACTIONS(4404),
    [sym_is] = ACTIONS(4404),
    [sym_mixin] = ACTIONS(4404),
    [sym_new] = ACTIONS(4404),
    [sym_nothrow] = ACTIONS(4404),
    [sym_out] = ACTIONS(4404),
    [sym_override] = ACTIONS(4404),
    [sym_package] = ACTIONS(4404),
    [sym_pragma] = ACTIONS(4404),
    [sym_private] = ACTIONS(4404),
    [sym_protected] = ACTIONS(4404),
    [sym_public] = ACTIONS(4404),
    [sym_pure] = ACTIONS(4404),
    [sym_ref] = ACTIONS(4404),
    [sym_return] = ACTIONS(4404),
    [sym_scope] = ACTIONS(4404),
    [sym_shared] = ACTIONS(4404),
    [sym_static] = ACTIONS(4404),
    [sym_struct] = ACTIONS(4404),
    [sym_switch] = ACTIONS(4404),
    [sym_synchronized] = ACTIONS(4404),
    [sym_template] = ACTIONS(4404),
    [sym_throw] = ACTIONS(4404),
    [sym_try] = ACTIONS(4404),
    [sym_typeid] = ACTIONS(4404),
    [sym_typeof] = ACTIONS(4404),
    [sym_union] = ACTIONS(4404),
    [sym_unittest] = ACTIONS(4404),
    [sym_version] = ACTIONS(4404),
    [sym_while] = ACTIONS(4404),
    [sym_with] = ACTIONS(4404),
    [sym_gshared] = ACTIONS(4404),
    [sym_traits] = ACTIONS(4404),
    [sym_vector] = ACTIONS(4404),
    [sym_void] = ACTIONS(4404),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_r_DQUOTE] = ACTIONS(4406),
    [anon_sym_x_DQUOTE] = ACTIONS(4406),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [anon_sym_i_BQUOTE] = ACTIONS(4406),
    [anon_sym_i_DQUOTE] = ACTIONS(4406),
    [anon_sym_iq_LBRACE] = ACTIONS(4406),
    [aux_sym_char_literal_token1] = ACTIONS(4406),
    [anon_sym_SQUOTE] = ACTIONS(4404),
    [anon_sym___DATE__] = ACTIONS(4404),
    [anon_sym___FILE__] = ACTIONS(4404),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4404),
    [anon_sym___FUNCTION__] = ACTIONS(4404),
    [anon_sym___LINE__] = ACTIONS(4404),
    [anon_sym___MODULE__] = ACTIONS(4404),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4404),
    [anon_sym___TIME__] = ACTIONS(4404),
    [anon_sym___TIMESTAMP__] = ACTIONS(4404),
    [anon_sym___VENDOR__] = ACTIONS(4404),
    [anon_sym___VERSION__] = ACTIONS(4404),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4406),
    [sym_float_literal] = ACTIONS(4406),
    [sym__string] = ACTIONS(4406),
  },
  [1356] = {
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_q_LBRACE] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4410),
    [anon_sym_LPAREN] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_AT] = ACTIONS(4410),
    [sym_bool] = ACTIONS(4408),
    [sym_byte] = ACTIONS(4408),
    [sym_ubyte] = ACTIONS(4408),
    [sym_char] = ACTIONS(4408),
    [sym_short] = ACTIONS(4408),
    [sym_ushort] = ACTIONS(4408),
    [sym_int] = ACTIONS(4408),
    [sym_uint] = ACTIONS(4408),
    [sym_long] = ACTIONS(4408),
    [sym_ulong] = ACTIONS(4408),
    [sym_cent] = ACTIONS(4408),
    [sym_ucent] = ACTIONS(4408),
    [sym_wchar] = ACTIONS(4408),
    [sym_dchar] = ACTIONS(4408),
    [sym_float] = ACTIONS(4408),
    [sym_double] = ACTIONS(4408),
    [sym_real] = ACTIONS(4408),
    [sym_ifloat] = ACTIONS(4408),
    [sym_idouble] = ACTIONS(4408),
    [sym_ireal] = ACTIONS(4408),
    [sym_cfloat] = ACTIONS(4408),
    [sym_cdouble] = ACTIONS(4408),
    [sym_creal] = ACTIONS(4408),
    [sym_size_t] = ACTIONS(4408),
    [sym_ptrdiff_t] = ACTIONS(4408),
    [sym_string] = ACTIONS(4408),
    [sym_cstring] = ACTIONS(4408),
    [sym_dstring] = ACTIONS(4408),
    [sym_wstring] = ACTIONS(4408),
    [sym_noreturn] = ACTIONS(4408),
    [sym_true] = ACTIONS(4408),
    [sym_false] = ACTIONS(4408),
    [sym_null] = ACTIONS(4408),
    [sym_super] = ACTIONS(4408),
    [sym_this] = ACTIONS(4408),
    [sym_abstract] = ACTIONS(4408),
    [sym_alias] = ACTIONS(4408),
    [sym_align] = ACTIONS(4408),
    [sym_asm] = ACTIONS(4408),
    [sym_assert] = ACTIONS(4408),
    [sym_auto] = ACTIONS(4408),
    [sym_break] = ACTIONS(4408),
    [sym_case] = ACTIONS(4408),
    [sym_cast] = ACTIONS(4408),
    [sym_catch] = ACTIONS(4408),
    [sym_class] = ACTIONS(4408),
    [sym_const] = ACTIONS(4408),
    [sym_continue] = ACTIONS(4408),
    [sym_debug] = ACTIONS(4408),
    [sym_default] = ACTIONS(4408),
    [sym_delegate] = ACTIONS(4408),
    [sym_delete] = ACTIONS(4408),
    [sym_deprecated] = ACTIONS(4408),
    [sym_do] = ACTIONS(4408),
    [sym_else] = ACTIONS(4408),
    [sym_enum] = ACTIONS(4408),
    [sym_export] = ACTIONS(4408),
    [sym_extern] = ACTIONS(4408),
    [sym_final] = ACTIONS(4408),
    [sym_finally] = ACTIONS(4408),
    [sym_for] = ACTIONS(4408),
    [sym_foreach] = ACTIONS(4408),
    [sym_foreach_reverse] = ACTIONS(4408),
    [sym_function] = ACTIONS(4408),
    [sym_goto] = ACTIONS(4408),
    [sym_if] = ACTIONS(4408),
    [sym_immutable] = ACTIONS(4408),
    [sym_import] = ACTIONS(4408),
    [sym_in] = ACTIONS(4408),
    [sym_inout] = ACTIONS(4408),
    [sym_interface] = ACTIONS(4408),
    [sym_invariant] = ACTIONS(4408),
    [sym_is] = ACTIONS(4408),
    [sym_mixin] = ACTIONS(4408),
    [sym_new] = ACTIONS(4408),
    [sym_nothrow] = ACTIONS(4408),
    [sym_out] = ACTIONS(4408),
    [sym_override] = ACTIONS(4408),
    [sym_package] = ACTIONS(4408),
    [sym_pragma] = ACTIONS(4408),
    [sym_private] = ACTIONS(4408),
    [sym_protected] = ACTIONS(4408),
    [sym_public] = ACTIONS(4408),
    [sym_pure] = ACTIONS(4408),
    [sym_ref] = ACTIONS(4408),
    [sym_return] = ACTIONS(4408),
    [sym_scope] = ACTIONS(4408),
    [sym_shared] = ACTIONS(4408),
    [sym_static] = ACTIONS(4408),
    [sym_struct] = ACTIONS(4408),
    [sym_switch] = ACTIONS(4408),
    [sym_synchronized] = ACTIONS(4408),
    [sym_template] = ACTIONS(4408),
    [sym_throw] = ACTIONS(4408),
    [sym_try] = ACTIONS(4408),
    [sym_typeid] = ACTIONS(4408),
    [sym_typeof] = ACTIONS(4408),
    [sym_union] = ACTIONS(4408),
    [sym_unittest] = ACTIONS(4408),
    [sym_version] = ACTIONS(4408),
    [sym_while] = ACTIONS(4408),
    [sym_with] = ACTIONS(4408),
    [sym_gshared] = ACTIONS(4408),
    [sym_traits] = ACTIONS(4408),
    [sym_vector] = ACTIONS(4408),
    [sym_void] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_r_DQUOTE] = ACTIONS(4410),
    [anon_sym_x_DQUOTE] = ACTIONS(4410),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [anon_sym_i_BQUOTE] = ACTIONS(4410),
    [anon_sym_i_DQUOTE] = ACTIONS(4410),
    [anon_sym_iq_LBRACE] = ACTIONS(4410),
    [aux_sym_char_literal_token1] = ACTIONS(4410),
    [anon_sym_SQUOTE] = ACTIONS(4408),
    [anon_sym___DATE__] = ACTIONS(4408),
    [anon_sym___FILE__] = ACTIONS(4408),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4408),
    [anon_sym___FUNCTION__] = ACTIONS(4408),
    [anon_sym___LINE__] = ACTIONS(4408),
    [anon_sym___MODULE__] = ACTIONS(4408),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4408),
    [anon_sym___TIME__] = ACTIONS(4408),
    [anon_sym___TIMESTAMP__] = ACTIONS(4408),
    [anon_sym___VENDOR__] = ACTIONS(4408),
    [anon_sym___VERSION__] = ACTIONS(4408),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4410),
    [sym_float_literal] = ACTIONS(4410),
    [sym__string] = ACTIONS(4410),
  },
  [1357] = {
    [sym_identifier] = ACTIONS(4412),
    [anon_sym_q_LBRACE] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_LBRACE] = ACTIONS(4414),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_PLUS_PLUS] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_LPAREN] = ACTIONS(4414),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_DOLLAR] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_AT] = ACTIONS(4414),
    [sym_bool] = ACTIONS(4412),
    [sym_byte] = ACTIONS(4412),
    [sym_ubyte] = ACTIONS(4412),
    [sym_char] = ACTIONS(4412),
    [sym_short] = ACTIONS(4412),
    [sym_ushort] = ACTIONS(4412),
    [sym_int] = ACTIONS(4412),
    [sym_uint] = ACTIONS(4412),
    [sym_long] = ACTIONS(4412),
    [sym_ulong] = ACTIONS(4412),
    [sym_cent] = ACTIONS(4412),
    [sym_ucent] = ACTIONS(4412),
    [sym_wchar] = ACTIONS(4412),
    [sym_dchar] = ACTIONS(4412),
    [sym_float] = ACTIONS(4412),
    [sym_double] = ACTIONS(4412),
    [sym_real] = ACTIONS(4412),
    [sym_ifloat] = ACTIONS(4412),
    [sym_idouble] = ACTIONS(4412),
    [sym_ireal] = ACTIONS(4412),
    [sym_cfloat] = ACTIONS(4412),
    [sym_cdouble] = ACTIONS(4412),
    [sym_creal] = ACTIONS(4412),
    [sym_size_t] = ACTIONS(4412),
    [sym_ptrdiff_t] = ACTIONS(4412),
    [sym_string] = ACTIONS(4412),
    [sym_cstring] = ACTIONS(4412),
    [sym_dstring] = ACTIONS(4412),
    [sym_wstring] = ACTIONS(4412),
    [sym_noreturn] = ACTIONS(4412),
    [sym_true] = ACTIONS(4412),
    [sym_false] = ACTIONS(4412),
    [sym_null] = ACTIONS(4412),
    [sym_super] = ACTIONS(4412),
    [sym_this] = ACTIONS(4412),
    [sym_abstract] = ACTIONS(4412),
    [sym_alias] = ACTIONS(4412),
    [sym_align] = ACTIONS(4412),
    [sym_asm] = ACTIONS(4412),
    [sym_assert] = ACTIONS(4412),
    [sym_auto] = ACTIONS(4412),
    [sym_break] = ACTIONS(4412),
    [sym_case] = ACTIONS(4412),
    [sym_cast] = ACTIONS(4412),
    [sym_catch] = ACTIONS(4412),
    [sym_class] = ACTIONS(4412),
    [sym_const] = ACTIONS(4412),
    [sym_continue] = ACTIONS(4412),
    [sym_debug] = ACTIONS(4412),
    [sym_default] = ACTIONS(4412),
    [sym_delegate] = ACTIONS(4412),
    [sym_delete] = ACTIONS(4412),
    [sym_deprecated] = ACTIONS(4412),
    [sym_do] = ACTIONS(4412),
    [sym_else] = ACTIONS(4412),
    [sym_enum] = ACTIONS(4412),
    [sym_export] = ACTIONS(4412),
    [sym_extern] = ACTIONS(4412),
    [sym_final] = ACTIONS(4412),
    [sym_finally] = ACTIONS(4412),
    [sym_for] = ACTIONS(4412),
    [sym_foreach] = ACTIONS(4412),
    [sym_foreach_reverse] = ACTIONS(4412),
    [sym_function] = ACTIONS(4412),
    [sym_goto] = ACTIONS(4412),
    [sym_if] = ACTIONS(4412),
    [sym_immutable] = ACTIONS(4412),
    [sym_import] = ACTIONS(4412),
    [sym_in] = ACTIONS(4412),
    [sym_inout] = ACTIONS(4412),
    [sym_interface] = ACTIONS(4412),
    [sym_invariant] = ACTIONS(4412),
    [sym_is] = ACTIONS(4412),
    [sym_mixin] = ACTIONS(4412),
    [sym_new] = ACTIONS(4412),
    [sym_nothrow] = ACTIONS(4412),
    [sym_out] = ACTIONS(4412),
    [sym_override] = ACTIONS(4412),
    [sym_package] = ACTIONS(4412),
    [sym_pragma] = ACTIONS(4412),
    [sym_private] = ACTIONS(4412),
    [sym_protected] = ACTIONS(4412),
    [sym_public] = ACTIONS(4412),
    [sym_pure] = ACTIONS(4412),
    [sym_ref] = ACTIONS(4412),
    [sym_return] = ACTIONS(4412),
    [sym_scope] = ACTIONS(4412),
    [sym_shared] = ACTIONS(4412),
    [sym_static] = ACTIONS(4412),
    [sym_struct] = ACTIONS(4412),
    [sym_switch] = ACTIONS(4412),
    [sym_synchronized] = ACTIONS(4412),
    [sym_template] = ACTIONS(4412),
    [sym_throw] = ACTIONS(4412),
    [sym_try] = ACTIONS(4412),
    [sym_typeid] = ACTIONS(4412),
    [sym_typeof] = ACTIONS(4412),
    [sym_union] = ACTIONS(4412),
    [sym_unittest] = ACTIONS(4412),
    [sym_version] = ACTIONS(4412),
    [sym_while] = ACTIONS(4412),
    [sym_with] = ACTIONS(4412),
    [sym_gshared] = ACTIONS(4412),
    [sym_traits] = ACTIONS(4412),
    [sym_vector] = ACTIONS(4412),
    [sym_void] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4414),
    [anon_sym_r_DQUOTE] = ACTIONS(4414),
    [anon_sym_x_DQUOTE] = ACTIONS(4414),
    [anon_sym_DQUOTE] = ACTIONS(4414),
    [anon_sym_i_BQUOTE] = ACTIONS(4414),
    [anon_sym_i_DQUOTE] = ACTIONS(4414),
    [anon_sym_iq_LBRACE] = ACTIONS(4414),
    [aux_sym_char_literal_token1] = ACTIONS(4414),
    [anon_sym_SQUOTE] = ACTIONS(4412),
    [anon_sym___DATE__] = ACTIONS(4412),
    [anon_sym___FILE__] = ACTIONS(4412),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4412),
    [anon_sym___FUNCTION__] = ACTIONS(4412),
    [anon_sym___LINE__] = ACTIONS(4412),
    [anon_sym___MODULE__] = ACTIONS(4412),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4412),
    [anon_sym___TIME__] = ACTIONS(4412),
    [anon_sym___TIMESTAMP__] = ACTIONS(4412),
    [anon_sym___VENDOR__] = ACTIONS(4412),
    [anon_sym___VERSION__] = ACTIONS(4412),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4414),
    [sym_float_literal] = ACTIONS(4414),
    [sym__string] = ACTIONS(4414),
  },
  [1358] = {
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_q_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(4418),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_PLUS_PLUS] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(4418),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym_DOLLAR] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4418),
    [anon_sym_TILDE] = ACTIONS(4418),
    [anon_sym_AT] = ACTIONS(4418),
    [sym_bool] = ACTIONS(4416),
    [sym_byte] = ACTIONS(4416),
    [sym_ubyte] = ACTIONS(4416),
    [sym_char] = ACTIONS(4416),
    [sym_short] = ACTIONS(4416),
    [sym_ushort] = ACTIONS(4416),
    [sym_int] = ACTIONS(4416),
    [sym_uint] = ACTIONS(4416),
    [sym_long] = ACTIONS(4416),
    [sym_ulong] = ACTIONS(4416),
    [sym_cent] = ACTIONS(4416),
    [sym_ucent] = ACTIONS(4416),
    [sym_wchar] = ACTIONS(4416),
    [sym_dchar] = ACTIONS(4416),
    [sym_float] = ACTIONS(4416),
    [sym_double] = ACTIONS(4416),
    [sym_real] = ACTIONS(4416),
    [sym_ifloat] = ACTIONS(4416),
    [sym_idouble] = ACTIONS(4416),
    [sym_ireal] = ACTIONS(4416),
    [sym_cfloat] = ACTIONS(4416),
    [sym_cdouble] = ACTIONS(4416),
    [sym_creal] = ACTIONS(4416),
    [sym_size_t] = ACTIONS(4416),
    [sym_ptrdiff_t] = ACTIONS(4416),
    [sym_string] = ACTIONS(4416),
    [sym_cstring] = ACTIONS(4416),
    [sym_dstring] = ACTIONS(4416),
    [sym_wstring] = ACTIONS(4416),
    [sym_noreturn] = ACTIONS(4416),
    [sym_true] = ACTIONS(4416),
    [sym_false] = ACTIONS(4416),
    [sym_null] = ACTIONS(4416),
    [sym_super] = ACTIONS(4416),
    [sym_this] = ACTIONS(4416),
    [sym_abstract] = ACTIONS(4416),
    [sym_alias] = ACTIONS(4416),
    [sym_align] = ACTIONS(4416),
    [sym_asm] = ACTIONS(4416),
    [sym_assert] = ACTIONS(4416),
    [sym_auto] = ACTIONS(4416),
    [sym_break] = ACTIONS(4416),
    [sym_case] = ACTIONS(4416),
    [sym_cast] = ACTIONS(4416),
    [sym_catch] = ACTIONS(4416),
    [sym_class] = ACTIONS(4416),
    [sym_const] = ACTIONS(4416),
    [sym_continue] = ACTIONS(4416),
    [sym_debug] = ACTIONS(4416),
    [sym_default] = ACTIONS(4416),
    [sym_delegate] = ACTIONS(4416),
    [sym_delete] = ACTIONS(4416),
    [sym_deprecated] = ACTIONS(4416),
    [sym_do] = ACTIONS(4416),
    [sym_else] = ACTIONS(4416),
    [sym_enum] = ACTIONS(4416),
    [sym_export] = ACTIONS(4416),
    [sym_extern] = ACTIONS(4416),
    [sym_final] = ACTIONS(4416),
    [sym_finally] = ACTIONS(4416),
    [sym_for] = ACTIONS(4416),
    [sym_foreach] = ACTIONS(4416),
    [sym_foreach_reverse] = ACTIONS(4416),
    [sym_function] = ACTIONS(4416),
    [sym_goto] = ACTIONS(4416),
    [sym_if] = ACTIONS(4416),
    [sym_immutable] = ACTIONS(4416),
    [sym_import] = ACTIONS(4416),
    [sym_in] = ACTIONS(4416),
    [sym_inout] = ACTIONS(4416),
    [sym_interface] = ACTIONS(4416),
    [sym_invariant] = ACTIONS(4416),
    [sym_is] = ACTIONS(4416),
    [sym_mixin] = ACTIONS(4416),
    [sym_new] = ACTIONS(4416),
    [sym_nothrow] = ACTIONS(4416),
    [sym_out] = ACTIONS(4416),
    [sym_override] = ACTIONS(4416),
    [sym_package] = ACTIONS(4416),
    [sym_pragma] = ACTIONS(4416),
    [sym_private] = ACTIONS(4416),
    [sym_protected] = ACTIONS(4416),
    [sym_public] = ACTIONS(4416),
    [sym_pure] = ACTIONS(4416),
    [sym_ref] = ACTIONS(4416),
    [sym_return] = ACTIONS(4416),
    [sym_scope] = ACTIONS(4416),
    [sym_shared] = ACTIONS(4416),
    [sym_static] = ACTIONS(4416),
    [sym_struct] = ACTIONS(4416),
    [sym_switch] = ACTIONS(4416),
    [sym_synchronized] = ACTIONS(4416),
    [sym_template] = ACTIONS(4416),
    [sym_throw] = ACTIONS(4416),
    [sym_try] = ACTIONS(4416),
    [sym_typeid] = ACTIONS(4416),
    [sym_typeof] = ACTIONS(4416),
    [sym_union] = ACTIONS(4416),
    [sym_unittest] = ACTIONS(4416),
    [sym_version] = ACTIONS(4416),
    [sym_while] = ACTIONS(4416),
    [sym_with] = ACTIONS(4416),
    [sym_gshared] = ACTIONS(4416),
    [sym_traits] = ACTIONS(4416),
    [sym_vector] = ACTIONS(4416),
    [sym_void] = ACTIONS(4416),
    [anon_sym_BQUOTE] = ACTIONS(4418),
    [anon_sym_r_DQUOTE] = ACTIONS(4418),
    [anon_sym_x_DQUOTE] = ACTIONS(4418),
    [anon_sym_DQUOTE] = ACTIONS(4418),
    [anon_sym_i_BQUOTE] = ACTIONS(4418),
    [anon_sym_i_DQUOTE] = ACTIONS(4418),
    [anon_sym_iq_LBRACE] = ACTIONS(4418),
    [aux_sym_char_literal_token1] = ACTIONS(4418),
    [anon_sym_SQUOTE] = ACTIONS(4416),
    [anon_sym___DATE__] = ACTIONS(4416),
    [anon_sym___FILE__] = ACTIONS(4416),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4416),
    [anon_sym___FUNCTION__] = ACTIONS(4416),
    [anon_sym___LINE__] = ACTIONS(4416),
    [anon_sym___MODULE__] = ACTIONS(4416),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4416),
    [anon_sym___TIME__] = ACTIONS(4416),
    [anon_sym___TIMESTAMP__] = ACTIONS(4416),
    [anon_sym___VENDOR__] = ACTIONS(4416),
    [anon_sym___VERSION__] = ACTIONS(4416),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4418),
    [sym_float_literal] = ACTIONS(4418),
    [sym__string] = ACTIONS(4418),
  },
  [1359] = {
    [sym_identifier] = ACTIONS(4420),
    [anon_sym_q_LBRACE] = ACTIONS(4422),
    [anon_sym_RBRACE] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(4422),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4422),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_PLUS_PLUS] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_LPAREN] = ACTIONS(4422),
    [anon_sym_RPAREN] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_DOLLAR] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4422),
    [anon_sym_TILDE] = ACTIONS(4422),
    [anon_sym_AT] = ACTIONS(4422),
    [sym_bool] = ACTIONS(4420),
    [sym_byte] = ACTIONS(4420),
    [sym_ubyte] = ACTIONS(4420),
    [sym_char] = ACTIONS(4420),
    [sym_short] = ACTIONS(4420),
    [sym_ushort] = ACTIONS(4420),
    [sym_int] = ACTIONS(4420),
    [sym_uint] = ACTIONS(4420),
    [sym_long] = ACTIONS(4420),
    [sym_ulong] = ACTIONS(4420),
    [sym_cent] = ACTIONS(4420),
    [sym_ucent] = ACTIONS(4420),
    [sym_wchar] = ACTIONS(4420),
    [sym_dchar] = ACTIONS(4420),
    [sym_float] = ACTIONS(4420),
    [sym_double] = ACTIONS(4420),
    [sym_real] = ACTIONS(4420),
    [sym_ifloat] = ACTIONS(4420),
    [sym_idouble] = ACTIONS(4420),
    [sym_ireal] = ACTIONS(4420),
    [sym_cfloat] = ACTIONS(4420),
    [sym_cdouble] = ACTIONS(4420),
    [sym_creal] = ACTIONS(4420),
    [sym_size_t] = ACTIONS(4420),
    [sym_ptrdiff_t] = ACTIONS(4420),
    [sym_string] = ACTIONS(4420),
    [sym_cstring] = ACTIONS(4420),
    [sym_dstring] = ACTIONS(4420),
    [sym_wstring] = ACTIONS(4420),
    [sym_noreturn] = ACTIONS(4420),
    [sym_true] = ACTIONS(4420),
    [sym_false] = ACTIONS(4420),
    [sym_null] = ACTIONS(4420),
    [sym_super] = ACTIONS(4420),
    [sym_this] = ACTIONS(4420),
    [sym_abstract] = ACTIONS(4420),
    [sym_alias] = ACTIONS(4420),
    [sym_align] = ACTIONS(4420),
    [sym_asm] = ACTIONS(4420),
    [sym_assert] = ACTIONS(4420),
    [sym_auto] = ACTIONS(4420),
    [sym_break] = ACTIONS(4420),
    [sym_case] = ACTIONS(4420),
    [sym_cast] = ACTIONS(4420),
    [sym_catch] = ACTIONS(4420),
    [sym_class] = ACTIONS(4420),
    [sym_const] = ACTIONS(4420),
    [sym_continue] = ACTIONS(4420),
    [sym_debug] = ACTIONS(4420),
    [sym_default] = ACTIONS(4420),
    [sym_delegate] = ACTIONS(4420),
    [sym_delete] = ACTIONS(4420),
    [sym_deprecated] = ACTIONS(4420),
    [sym_do] = ACTIONS(4420),
    [sym_else] = ACTIONS(4420),
    [sym_enum] = ACTIONS(4420),
    [sym_export] = ACTIONS(4420),
    [sym_extern] = ACTIONS(4420),
    [sym_final] = ACTIONS(4420),
    [sym_finally] = ACTIONS(4420),
    [sym_for] = ACTIONS(4420),
    [sym_foreach] = ACTIONS(4420),
    [sym_foreach_reverse] = ACTIONS(4420),
    [sym_function] = ACTIONS(4420),
    [sym_goto] = ACTIONS(4420),
    [sym_if] = ACTIONS(4420),
    [sym_immutable] = ACTIONS(4420),
    [sym_import] = ACTIONS(4420),
    [sym_in] = ACTIONS(4420),
    [sym_inout] = ACTIONS(4420),
    [sym_interface] = ACTIONS(4420),
    [sym_invariant] = ACTIONS(4420),
    [sym_is] = ACTIONS(4420),
    [sym_mixin] = ACTIONS(4420),
    [sym_new] = ACTIONS(4420),
    [sym_nothrow] = ACTIONS(4420),
    [sym_out] = ACTIONS(4420),
    [sym_override] = ACTIONS(4420),
    [sym_package] = ACTIONS(4420),
    [sym_pragma] = ACTIONS(4420),
    [sym_private] = ACTIONS(4420),
    [sym_protected] = ACTIONS(4420),
    [sym_public] = ACTIONS(4420),
    [sym_pure] = ACTIONS(4420),
    [sym_ref] = ACTIONS(4420),
    [sym_return] = ACTIONS(4420),
    [sym_scope] = ACTIONS(4420),
    [sym_shared] = ACTIONS(4420),
    [sym_static] = ACTIONS(4420),
    [sym_struct] = ACTIONS(4420),
    [sym_switch] = ACTIONS(4420),
    [sym_synchronized] = ACTIONS(4420),
    [sym_template] = ACTIONS(4420),
    [sym_throw] = ACTIONS(4420),
    [sym_try] = ACTIONS(4420),
    [sym_typeid] = ACTIONS(4420),
    [sym_typeof] = ACTIONS(4420),
    [sym_union] = ACTIONS(4420),
    [sym_unittest] = ACTIONS(4420),
    [sym_version] = ACTIONS(4420),
    [sym_while] = ACTIONS(4420),
    [sym_with] = ACTIONS(4420),
    [sym_gshared] = ACTIONS(4420),
    [sym_traits] = ACTIONS(4420),
    [sym_vector] = ACTIONS(4420),
    [sym_void] = ACTIONS(4420),
    [anon_sym_BQUOTE] = ACTIONS(4422),
    [anon_sym_r_DQUOTE] = ACTIONS(4422),
    [anon_sym_x_DQUOTE] = ACTIONS(4422),
    [anon_sym_DQUOTE] = ACTIONS(4422),
    [anon_sym_i_BQUOTE] = ACTIONS(4422),
    [anon_sym_i_DQUOTE] = ACTIONS(4422),
    [anon_sym_iq_LBRACE] = ACTIONS(4422),
    [aux_sym_char_literal_token1] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4420),
    [anon_sym___DATE__] = ACTIONS(4420),
    [anon_sym___FILE__] = ACTIONS(4420),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4420),
    [anon_sym___FUNCTION__] = ACTIONS(4420),
    [anon_sym___LINE__] = ACTIONS(4420),
    [anon_sym___MODULE__] = ACTIONS(4420),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4420),
    [anon_sym___TIME__] = ACTIONS(4420),
    [anon_sym___TIMESTAMP__] = ACTIONS(4420),
    [anon_sym___VENDOR__] = ACTIONS(4420),
    [anon_sym___VERSION__] = ACTIONS(4420),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4422),
    [sym_float_literal] = ACTIONS(4422),
    [sym__string] = ACTIONS(4422),
  },
  [1360] = {
    [sym_identifier] = ACTIONS(4424),
    [anon_sym_q_LBRACE] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_PLUS_PLUS] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_LPAREN] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOLLAR] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_TILDE] = ACTIONS(4426),
    [anon_sym_AT] = ACTIONS(4426),
    [sym_bool] = ACTIONS(4424),
    [sym_byte] = ACTIONS(4424),
    [sym_ubyte] = ACTIONS(4424),
    [sym_char] = ACTIONS(4424),
    [sym_short] = ACTIONS(4424),
    [sym_ushort] = ACTIONS(4424),
    [sym_int] = ACTIONS(4424),
    [sym_uint] = ACTIONS(4424),
    [sym_long] = ACTIONS(4424),
    [sym_ulong] = ACTIONS(4424),
    [sym_cent] = ACTIONS(4424),
    [sym_ucent] = ACTIONS(4424),
    [sym_wchar] = ACTIONS(4424),
    [sym_dchar] = ACTIONS(4424),
    [sym_float] = ACTIONS(4424),
    [sym_double] = ACTIONS(4424),
    [sym_real] = ACTIONS(4424),
    [sym_ifloat] = ACTIONS(4424),
    [sym_idouble] = ACTIONS(4424),
    [sym_ireal] = ACTIONS(4424),
    [sym_cfloat] = ACTIONS(4424),
    [sym_cdouble] = ACTIONS(4424),
    [sym_creal] = ACTIONS(4424),
    [sym_size_t] = ACTIONS(4424),
    [sym_ptrdiff_t] = ACTIONS(4424),
    [sym_string] = ACTIONS(4424),
    [sym_cstring] = ACTIONS(4424),
    [sym_dstring] = ACTIONS(4424),
    [sym_wstring] = ACTIONS(4424),
    [sym_noreturn] = ACTIONS(4424),
    [sym_true] = ACTIONS(4424),
    [sym_false] = ACTIONS(4424),
    [sym_null] = ACTIONS(4424),
    [sym_super] = ACTIONS(4424),
    [sym_this] = ACTIONS(4424),
    [sym_abstract] = ACTIONS(4424),
    [sym_alias] = ACTIONS(4424),
    [sym_align] = ACTIONS(4424),
    [sym_asm] = ACTIONS(4424),
    [sym_assert] = ACTIONS(4424),
    [sym_auto] = ACTIONS(4424),
    [sym_break] = ACTIONS(4424),
    [sym_case] = ACTIONS(4424),
    [sym_cast] = ACTIONS(4424),
    [sym_catch] = ACTIONS(4424),
    [sym_class] = ACTIONS(4424),
    [sym_const] = ACTIONS(4424),
    [sym_continue] = ACTIONS(4424),
    [sym_debug] = ACTIONS(4424),
    [sym_default] = ACTIONS(4424),
    [sym_delegate] = ACTIONS(4424),
    [sym_delete] = ACTIONS(4424),
    [sym_deprecated] = ACTIONS(4424),
    [sym_do] = ACTIONS(4424),
    [sym_else] = ACTIONS(4424),
    [sym_enum] = ACTIONS(4424),
    [sym_export] = ACTIONS(4424),
    [sym_extern] = ACTIONS(4424),
    [sym_final] = ACTIONS(4424),
    [sym_finally] = ACTIONS(4424),
    [sym_for] = ACTIONS(4424),
    [sym_foreach] = ACTIONS(4424),
    [sym_foreach_reverse] = ACTIONS(4424),
    [sym_function] = ACTIONS(4424),
    [sym_goto] = ACTIONS(4424),
    [sym_if] = ACTIONS(4424),
    [sym_immutable] = ACTIONS(4424),
    [sym_import] = ACTIONS(4424),
    [sym_in] = ACTIONS(4424),
    [sym_inout] = ACTIONS(4424),
    [sym_interface] = ACTIONS(4424),
    [sym_invariant] = ACTIONS(4424),
    [sym_is] = ACTIONS(4424),
    [sym_mixin] = ACTIONS(4424),
    [sym_new] = ACTIONS(4424),
    [sym_nothrow] = ACTIONS(4424),
    [sym_out] = ACTIONS(4424),
    [sym_override] = ACTIONS(4424),
    [sym_package] = ACTIONS(4424),
    [sym_pragma] = ACTIONS(4424),
    [sym_private] = ACTIONS(4424),
    [sym_protected] = ACTIONS(4424),
    [sym_public] = ACTIONS(4424),
    [sym_pure] = ACTIONS(4424),
    [sym_ref] = ACTIONS(4424),
    [sym_return] = ACTIONS(4424),
    [sym_scope] = ACTIONS(4424),
    [sym_shared] = ACTIONS(4424),
    [sym_static] = ACTIONS(4424),
    [sym_struct] = ACTIONS(4424),
    [sym_switch] = ACTIONS(4424),
    [sym_synchronized] = ACTIONS(4424),
    [sym_template] = ACTIONS(4424),
    [sym_throw] = ACTIONS(4424),
    [sym_try] = ACTIONS(4424),
    [sym_typeid] = ACTIONS(4424),
    [sym_typeof] = ACTIONS(4424),
    [sym_union] = ACTIONS(4424),
    [sym_unittest] = ACTIONS(4424),
    [sym_version] = ACTIONS(4424),
    [sym_while] = ACTIONS(4424),
    [sym_with] = ACTIONS(4424),
    [sym_gshared] = ACTIONS(4424),
    [sym_traits] = ACTIONS(4424),
    [sym_vector] = ACTIONS(4424),
    [sym_void] = ACTIONS(4424),
    [anon_sym_BQUOTE] = ACTIONS(4426),
    [anon_sym_r_DQUOTE] = ACTIONS(4426),
    [anon_sym_x_DQUOTE] = ACTIONS(4426),
    [anon_sym_DQUOTE] = ACTIONS(4426),
    [anon_sym_i_BQUOTE] = ACTIONS(4426),
    [anon_sym_i_DQUOTE] = ACTIONS(4426),
    [anon_sym_iq_LBRACE] = ACTIONS(4426),
    [aux_sym_char_literal_token1] = ACTIONS(4426),
    [anon_sym_SQUOTE] = ACTIONS(4424),
    [anon_sym___DATE__] = ACTIONS(4424),
    [anon_sym___FILE__] = ACTIONS(4424),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4424),
    [anon_sym___FUNCTION__] = ACTIONS(4424),
    [anon_sym___LINE__] = ACTIONS(4424),
    [anon_sym___MODULE__] = ACTIONS(4424),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4424),
    [anon_sym___TIME__] = ACTIONS(4424),
    [anon_sym___TIMESTAMP__] = ACTIONS(4424),
    [anon_sym___VENDOR__] = ACTIONS(4424),
    [anon_sym___VERSION__] = ACTIONS(4424),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4426),
    [sym_float_literal] = ACTIONS(4426),
    [sym__string] = ACTIONS(4426),
  },
  [1361] = {
    [sym_identifier] = ACTIONS(4428),
    [anon_sym_q_LBRACE] = ACTIONS(4430),
    [anon_sym_RBRACE] = ACTIONS(4430),
    [anon_sym_LBRACE] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4430),
    [anon_sym_PLUS] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4430),
    [anon_sym_BANG] = ACTIONS(4430),
    [anon_sym_LPAREN] = ACTIONS(4430),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym_DOLLAR] = ACTIONS(4430),
    [anon_sym_STAR] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(4430),
    [anon_sym_AT] = ACTIONS(4430),
    [sym_bool] = ACTIONS(4428),
    [sym_byte] = ACTIONS(4428),
    [sym_ubyte] = ACTIONS(4428),
    [sym_char] = ACTIONS(4428),
    [sym_short] = ACTIONS(4428),
    [sym_ushort] = ACTIONS(4428),
    [sym_int] = ACTIONS(4428),
    [sym_uint] = ACTIONS(4428),
    [sym_long] = ACTIONS(4428),
    [sym_ulong] = ACTIONS(4428),
    [sym_cent] = ACTIONS(4428),
    [sym_ucent] = ACTIONS(4428),
    [sym_wchar] = ACTIONS(4428),
    [sym_dchar] = ACTIONS(4428),
    [sym_float] = ACTIONS(4428),
    [sym_double] = ACTIONS(4428),
    [sym_real] = ACTIONS(4428),
    [sym_ifloat] = ACTIONS(4428),
    [sym_idouble] = ACTIONS(4428),
    [sym_ireal] = ACTIONS(4428),
    [sym_cfloat] = ACTIONS(4428),
    [sym_cdouble] = ACTIONS(4428),
    [sym_creal] = ACTIONS(4428),
    [sym_size_t] = ACTIONS(4428),
    [sym_ptrdiff_t] = ACTIONS(4428),
    [sym_string] = ACTIONS(4428),
    [sym_cstring] = ACTIONS(4428),
    [sym_dstring] = ACTIONS(4428),
    [sym_wstring] = ACTIONS(4428),
    [sym_noreturn] = ACTIONS(4428),
    [sym_true] = ACTIONS(4428),
    [sym_false] = ACTIONS(4428),
    [sym_null] = ACTIONS(4428),
    [sym_super] = ACTIONS(4428),
    [sym_this] = ACTIONS(4428),
    [sym_abstract] = ACTIONS(4428),
    [sym_alias] = ACTIONS(4428),
    [sym_align] = ACTIONS(4428),
    [sym_asm] = ACTIONS(4428),
    [sym_assert] = ACTIONS(4428),
    [sym_auto] = ACTIONS(4428),
    [sym_break] = ACTIONS(4428),
    [sym_case] = ACTIONS(4428),
    [sym_cast] = ACTIONS(4428),
    [sym_catch] = ACTIONS(4428),
    [sym_class] = ACTIONS(4428),
    [sym_const] = ACTIONS(4428),
    [sym_continue] = ACTIONS(4428),
    [sym_debug] = ACTIONS(4428),
    [sym_default] = ACTIONS(4428),
    [sym_delegate] = ACTIONS(4428),
    [sym_delete] = ACTIONS(4428),
    [sym_deprecated] = ACTIONS(4428),
    [sym_do] = ACTIONS(4428),
    [sym_else] = ACTIONS(4428),
    [sym_enum] = ACTIONS(4428),
    [sym_export] = ACTIONS(4428),
    [sym_extern] = ACTIONS(4428),
    [sym_final] = ACTIONS(4428),
    [sym_finally] = ACTIONS(4428),
    [sym_for] = ACTIONS(4428),
    [sym_foreach] = ACTIONS(4428),
    [sym_foreach_reverse] = ACTIONS(4428),
    [sym_function] = ACTIONS(4428),
    [sym_goto] = ACTIONS(4428),
    [sym_if] = ACTIONS(4428),
    [sym_immutable] = ACTIONS(4428),
    [sym_import] = ACTIONS(4428),
    [sym_in] = ACTIONS(4428),
    [sym_inout] = ACTIONS(4428),
    [sym_interface] = ACTIONS(4428),
    [sym_invariant] = ACTIONS(4428),
    [sym_is] = ACTIONS(4428),
    [sym_mixin] = ACTIONS(4428),
    [sym_new] = ACTIONS(4428),
    [sym_nothrow] = ACTIONS(4428),
    [sym_out] = ACTIONS(4428),
    [sym_override] = ACTIONS(4428),
    [sym_package] = ACTIONS(4428),
    [sym_pragma] = ACTIONS(4428),
    [sym_private] = ACTIONS(4428),
    [sym_protected] = ACTIONS(4428),
    [sym_public] = ACTIONS(4428),
    [sym_pure] = ACTIONS(4428),
    [sym_ref] = ACTIONS(4428),
    [sym_return] = ACTIONS(4428),
    [sym_scope] = ACTIONS(4428),
    [sym_shared] = ACTIONS(4428),
    [sym_static] = ACTIONS(4428),
    [sym_struct] = ACTIONS(4428),
    [sym_switch] = ACTIONS(4428),
    [sym_synchronized] = ACTIONS(4428),
    [sym_template] = ACTIONS(4428),
    [sym_throw] = ACTIONS(4428),
    [sym_try] = ACTIONS(4428),
    [sym_typeid] = ACTIONS(4428),
    [sym_typeof] = ACTIONS(4428),
    [sym_union] = ACTIONS(4428),
    [sym_unittest] = ACTIONS(4428),
    [sym_version] = ACTIONS(4428),
    [sym_while] = ACTIONS(4428),
    [sym_with] = ACTIONS(4428),
    [sym_gshared] = ACTIONS(4428),
    [sym_traits] = ACTIONS(4428),
    [sym_vector] = ACTIONS(4428),
    [sym_void] = ACTIONS(4428),
    [anon_sym_BQUOTE] = ACTIONS(4430),
    [anon_sym_r_DQUOTE] = ACTIONS(4430),
    [anon_sym_x_DQUOTE] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4430),
    [anon_sym_i_BQUOTE] = ACTIONS(4430),
    [anon_sym_i_DQUOTE] = ACTIONS(4430),
    [anon_sym_iq_LBRACE] = ACTIONS(4430),
    [aux_sym_char_literal_token1] = ACTIONS(4430),
    [anon_sym_SQUOTE] = ACTIONS(4428),
    [anon_sym___DATE__] = ACTIONS(4428),
    [anon_sym___FILE__] = ACTIONS(4428),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4428),
    [anon_sym___FUNCTION__] = ACTIONS(4428),
    [anon_sym___LINE__] = ACTIONS(4428),
    [anon_sym___MODULE__] = ACTIONS(4428),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4428),
    [anon_sym___TIME__] = ACTIONS(4428),
    [anon_sym___TIMESTAMP__] = ACTIONS(4428),
    [anon_sym___VENDOR__] = ACTIONS(4428),
    [anon_sym___VERSION__] = ACTIONS(4428),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4430),
    [sym_float_literal] = ACTIONS(4430),
    [sym__string] = ACTIONS(4430),
  },
  [1362] = {
    [sym_identifier] = ACTIONS(4432),
    [anon_sym_q_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4434),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_BANG] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_TILDE] = ACTIONS(4434),
    [anon_sym_AT] = ACTIONS(4434),
    [sym_bool] = ACTIONS(4432),
    [sym_byte] = ACTIONS(4432),
    [sym_ubyte] = ACTIONS(4432),
    [sym_char] = ACTIONS(4432),
    [sym_short] = ACTIONS(4432),
    [sym_ushort] = ACTIONS(4432),
    [sym_int] = ACTIONS(4432),
    [sym_uint] = ACTIONS(4432),
    [sym_long] = ACTIONS(4432),
    [sym_ulong] = ACTIONS(4432),
    [sym_cent] = ACTIONS(4432),
    [sym_ucent] = ACTIONS(4432),
    [sym_wchar] = ACTIONS(4432),
    [sym_dchar] = ACTIONS(4432),
    [sym_float] = ACTIONS(4432),
    [sym_double] = ACTIONS(4432),
    [sym_real] = ACTIONS(4432),
    [sym_ifloat] = ACTIONS(4432),
    [sym_idouble] = ACTIONS(4432),
    [sym_ireal] = ACTIONS(4432),
    [sym_cfloat] = ACTIONS(4432),
    [sym_cdouble] = ACTIONS(4432),
    [sym_creal] = ACTIONS(4432),
    [sym_size_t] = ACTIONS(4432),
    [sym_ptrdiff_t] = ACTIONS(4432),
    [sym_string] = ACTIONS(4432),
    [sym_cstring] = ACTIONS(4432),
    [sym_dstring] = ACTIONS(4432),
    [sym_wstring] = ACTIONS(4432),
    [sym_noreturn] = ACTIONS(4432),
    [sym_true] = ACTIONS(4432),
    [sym_false] = ACTIONS(4432),
    [sym_null] = ACTIONS(4432),
    [sym_super] = ACTIONS(4432),
    [sym_this] = ACTIONS(4432),
    [sym_abstract] = ACTIONS(4432),
    [sym_alias] = ACTIONS(4432),
    [sym_align] = ACTIONS(4432),
    [sym_asm] = ACTIONS(4432),
    [sym_assert] = ACTIONS(4432),
    [sym_auto] = ACTIONS(4432),
    [sym_break] = ACTIONS(4432),
    [sym_case] = ACTIONS(4432),
    [sym_cast] = ACTIONS(4432),
    [sym_catch] = ACTIONS(4432),
    [sym_class] = ACTIONS(4432),
    [sym_const] = ACTIONS(4432),
    [sym_continue] = ACTIONS(4432),
    [sym_debug] = ACTIONS(4432),
    [sym_default] = ACTIONS(4432),
    [sym_delegate] = ACTIONS(4432),
    [sym_delete] = ACTIONS(4432),
    [sym_deprecated] = ACTIONS(4432),
    [sym_do] = ACTIONS(4432),
    [sym_else] = ACTIONS(4432),
    [sym_enum] = ACTIONS(4432),
    [sym_export] = ACTIONS(4432),
    [sym_extern] = ACTIONS(4432),
    [sym_final] = ACTIONS(4432),
    [sym_finally] = ACTIONS(4432),
    [sym_for] = ACTIONS(4432),
    [sym_foreach] = ACTIONS(4432),
    [sym_foreach_reverse] = ACTIONS(4432),
    [sym_function] = ACTIONS(4432),
    [sym_goto] = ACTIONS(4432),
    [sym_if] = ACTIONS(4432),
    [sym_immutable] = ACTIONS(4432),
    [sym_import] = ACTIONS(4432),
    [sym_in] = ACTIONS(4432),
    [sym_inout] = ACTIONS(4432),
    [sym_interface] = ACTIONS(4432),
    [sym_invariant] = ACTIONS(4432),
    [sym_is] = ACTIONS(4432),
    [sym_mixin] = ACTIONS(4432),
    [sym_new] = ACTIONS(4432),
    [sym_nothrow] = ACTIONS(4432),
    [sym_out] = ACTIONS(4432),
    [sym_override] = ACTIONS(4432),
    [sym_package] = ACTIONS(4432),
    [sym_pragma] = ACTIONS(4432),
    [sym_private] = ACTIONS(4432),
    [sym_protected] = ACTIONS(4432),
    [sym_public] = ACTIONS(4432),
    [sym_pure] = ACTIONS(4432),
    [sym_ref] = ACTIONS(4432),
    [sym_return] = ACTIONS(4432),
    [sym_scope] = ACTIONS(4432),
    [sym_shared] = ACTIONS(4432),
    [sym_static] = ACTIONS(4432),
    [sym_struct] = ACTIONS(4432),
    [sym_switch] = ACTIONS(4432),
    [sym_synchronized] = ACTIONS(4432),
    [sym_template] = ACTIONS(4432),
    [sym_throw] = ACTIONS(4432),
    [sym_try] = ACTIONS(4432),
    [sym_typeid] = ACTIONS(4432),
    [sym_typeof] = ACTIONS(4432),
    [sym_union] = ACTIONS(4432),
    [sym_unittest] = ACTIONS(4432),
    [sym_version] = ACTIONS(4432),
    [sym_while] = ACTIONS(4432),
    [sym_with] = ACTIONS(4432),
    [sym_gshared] = ACTIONS(4432),
    [sym_traits] = ACTIONS(4432),
    [sym_vector] = ACTIONS(4432),
    [sym_void] = ACTIONS(4432),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [anon_sym_r_DQUOTE] = ACTIONS(4434),
    [anon_sym_x_DQUOTE] = ACTIONS(4434),
    [anon_sym_DQUOTE] = ACTIONS(4434),
    [anon_sym_i_BQUOTE] = ACTIONS(4434),
    [anon_sym_i_DQUOTE] = ACTIONS(4434),
    [anon_sym_iq_LBRACE] = ACTIONS(4434),
    [aux_sym_char_literal_token1] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4432),
    [anon_sym___DATE__] = ACTIONS(4432),
    [anon_sym___FILE__] = ACTIONS(4432),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4432),
    [anon_sym___FUNCTION__] = ACTIONS(4432),
    [anon_sym___LINE__] = ACTIONS(4432),
    [anon_sym___MODULE__] = ACTIONS(4432),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4432),
    [anon_sym___TIME__] = ACTIONS(4432),
    [anon_sym___TIMESTAMP__] = ACTIONS(4432),
    [anon_sym___VENDOR__] = ACTIONS(4432),
    [anon_sym___VERSION__] = ACTIONS(4432),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4434),
    [sym_float_literal] = ACTIONS(4434),
    [sym__string] = ACTIONS(4434),
  },
  [1363] = {
    [sym_identifier] = ACTIONS(4436),
    [anon_sym_q_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4438),
    [anon_sym_AMP] = ACTIONS(4438),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_BANG] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_DOLLAR] = ACTIONS(4438),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_TILDE] = ACTIONS(4438),
    [anon_sym_AT] = ACTIONS(4438),
    [sym_bool] = ACTIONS(4436),
    [sym_byte] = ACTIONS(4436),
    [sym_ubyte] = ACTIONS(4436),
    [sym_char] = ACTIONS(4436),
    [sym_short] = ACTIONS(4436),
    [sym_ushort] = ACTIONS(4436),
    [sym_int] = ACTIONS(4436),
    [sym_uint] = ACTIONS(4436),
    [sym_long] = ACTIONS(4436),
    [sym_ulong] = ACTIONS(4436),
    [sym_cent] = ACTIONS(4436),
    [sym_ucent] = ACTIONS(4436),
    [sym_wchar] = ACTIONS(4436),
    [sym_dchar] = ACTIONS(4436),
    [sym_float] = ACTIONS(4436),
    [sym_double] = ACTIONS(4436),
    [sym_real] = ACTIONS(4436),
    [sym_ifloat] = ACTIONS(4436),
    [sym_idouble] = ACTIONS(4436),
    [sym_ireal] = ACTIONS(4436),
    [sym_cfloat] = ACTIONS(4436),
    [sym_cdouble] = ACTIONS(4436),
    [sym_creal] = ACTIONS(4436),
    [sym_size_t] = ACTIONS(4436),
    [sym_ptrdiff_t] = ACTIONS(4436),
    [sym_string] = ACTIONS(4436),
    [sym_cstring] = ACTIONS(4436),
    [sym_dstring] = ACTIONS(4436),
    [sym_wstring] = ACTIONS(4436),
    [sym_noreturn] = ACTIONS(4436),
    [sym_true] = ACTIONS(4436),
    [sym_false] = ACTIONS(4436),
    [sym_null] = ACTIONS(4436),
    [sym_super] = ACTIONS(4436),
    [sym_this] = ACTIONS(4436),
    [sym_abstract] = ACTIONS(4436),
    [sym_alias] = ACTIONS(4436),
    [sym_align] = ACTIONS(4436),
    [sym_asm] = ACTIONS(4436),
    [sym_assert] = ACTIONS(4436),
    [sym_auto] = ACTIONS(4436),
    [sym_break] = ACTIONS(4436),
    [sym_case] = ACTIONS(4436),
    [sym_cast] = ACTIONS(4436),
    [sym_catch] = ACTIONS(4436),
    [sym_class] = ACTIONS(4436),
    [sym_const] = ACTIONS(4436),
    [sym_continue] = ACTIONS(4436),
    [sym_debug] = ACTIONS(4436),
    [sym_default] = ACTIONS(4436),
    [sym_delegate] = ACTIONS(4436),
    [sym_delete] = ACTIONS(4436),
    [sym_deprecated] = ACTIONS(4436),
    [sym_do] = ACTIONS(4436),
    [sym_else] = ACTIONS(4436),
    [sym_enum] = ACTIONS(4436),
    [sym_export] = ACTIONS(4436),
    [sym_extern] = ACTIONS(4436),
    [sym_final] = ACTIONS(4436),
    [sym_finally] = ACTIONS(4436),
    [sym_for] = ACTIONS(4436),
    [sym_foreach] = ACTIONS(4436),
    [sym_foreach_reverse] = ACTIONS(4436),
    [sym_function] = ACTIONS(4436),
    [sym_goto] = ACTIONS(4436),
    [sym_if] = ACTIONS(4436),
    [sym_immutable] = ACTIONS(4436),
    [sym_import] = ACTIONS(4436),
    [sym_in] = ACTIONS(4436),
    [sym_inout] = ACTIONS(4436),
    [sym_interface] = ACTIONS(4436),
    [sym_invariant] = ACTIONS(4436),
    [sym_is] = ACTIONS(4436),
    [sym_mixin] = ACTIONS(4436),
    [sym_new] = ACTIONS(4436),
    [sym_nothrow] = ACTIONS(4436),
    [sym_out] = ACTIONS(4436),
    [sym_override] = ACTIONS(4436),
    [sym_package] = ACTIONS(4436),
    [sym_pragma] = ACTIONS(4436),
    [sym_private] = ACTIONS(4436),
    [sym_protected] = ACTIONS(4436),
    [sym_public] = ACTIONS(4436),
    [sym_pure] = ACTIONS(4436),
    [sym_ref] = ACTIONS(4436),
    [sym_return] = ACTIONS(4436),
    [sym_scope] = ACTIONS(4436),
    [sym_shared] = ACTIONS(4436),
    [sym_static] = ACTIONS(4436),
    [sym_struct] = ACTIONS(4436),
    [sym_switch] = ACTIONS(4436),
    [sym_synchronized] = ACTIONS(4436),
    [sym_template] = ACTIONS(4436),
    [sym_throw] = ACTIONS(4436),
    [sym_try] = ACTIONS(4436),
    [sym_typeid] = ACTIONS(4436),
    [sym_typeof] = ACTIONS(4436),
    [sym_union] = ACTIONS(4436),
    [sym_unittest] = ACTIONS(4436),
    [sym_version] = ACTIONS(4436),
    [sym_while] = ACTIONS(4436),
    [sym_with] = ACTIONS(4436),
    [sym_gshared] = ACTIONS(4436),
    [sym_traits] = ACTIONS(4436),
    [sym_vector] = ACTIONS(4436),
    [sym_void] = ACTIONS(4436),
    [anon_sym_BQUOTE] = ACTIONS(4438),
    [anon_sym_r_DQUOTE] = ACTIONS(4438),
    [anon_sym_x_DQUOTE] = ACTIONS(4438),
    [anon_sym_DQUOTE] = ACTIONS(4438),
    [anon_sym_i_BQUOTE] = ACTIONS(4438),
    [anon_sym_i_DQUOTE] = ACTIONS(4438),
    [anon_sym_iq_LBRACE] = ACTIONS(4438),
    [aux_sym_char_literal_token1] = ACTIONS(4438),
    [anon_sym_SQUOTE] = ACTIONS(4436),
    [anon_sym___DATE__] = ACTIONS(4436),
    [anon_sym___FILE__] = ACTIONS(4436),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4436),
    [anon_sym___FUNCTION__] = ACTIONS(4436),
    [anon_sym___LINE__] = ACTIONS(4436),
    [anon_sym___MODULE__] = ACTIONS(4436),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4436),
    [anon_sym___TIME__] = ACTIONS(4436),
    [anon_sym___TIMESTAMP__] = ACTIONS(4436),
    [anon_sym___VENDOR__] = ACTIONS(4436),
    [anon_sym___VERSION__] = ACTIONS(4436),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4438),
    [sym_float_literal] = ACTIONS(4438),
    [sym__string] = ACTIONS(4438),
  },
  [1364] = {
    [sym_identifier] = ACTIONS(4440),
    [anon_sym_q_LBRACE] = ACTIONS(4442),
    [anon_sym_RBRACE] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [anon_sym_DOT] = ACTIONS(4442),
    [anon_sym_AMP] = ACTIONS(4442),
    [anon_sym_DASH] = ACTIONS(4440),
    [anon_sym_DASH_DASH] = ACTIONS(4442),
    [anon_sym_PLUS] = ACTIONS(4440),
    [anon_sym_PLUS_PLUS] = ACTIONS(4442),
    [anon_sym_BANG] = ACTIONS(4442),
    [anon_sym_LPAREN] = ACTIONS(4442),
    [anon_sym_RPAREN] = ACTIONS(4442),
    [anon_sym_LBRACK] = ACTIONS(4442),
    [anon_sym_SEMI] = ACTIONS(4442),
    [anon_sym_DOLLAR] = ACTIONS(4442),
    [anon_sym_STAR] = ACTIONS(4442),
    [anon_sym_TILDE] = ACTIONS(4442),
    [anon_sym_AT] = ACTIONS(4442),
    [sym_bool] = ACTIONS(4440),
    [sym_byte] = ACTIONS(4440),
    [sym_ubyte] = ACTIONS(4440),
    [sym_char] = ACTIONS(4440),
    [sym_short] = ACTIONS(4440),
    [sym_ushort] = ACTIONS(4440),
    [sym_int] = ACTIONS(4440),
    [sym_uint] = ACTIONS(4440),
    [sym_long] = ACTIONS(4440),
    [sym_ulong] = ACTIONS(4440),
    [sym_cent] = ACTIONS(4440),
    [sym_ucent] = ACTIONS(4440),
    [sym_wchar] = ACTIONS(4440),
    [sym_dchar] = ACTIONS(4440),
    [sym_float] = ACTIONS(4440),
    [sym_double] = ACTIONS(4440),
    [sym_real] = ACTIONS(4440),
    [sym_ifloat] = ACTIONS(4440),
    [sym_idouble] = ACTIONS(4440),
    [sym_ireal] = ACTIONS(4440),
    [sym_cfloat] = ACTIONS(4440),
    [sym_cdouble] = ACTIONS(4440),
    [sym_creal] = ACTIONS(4440),
    [sym_size_t] = ACTIONS(4440),
    [sym_ptrdiff_t] = ACTIONS(4440),
    [sym_string] = ACTIONS(4440),
    [sym_cstring] = ACTIONS(4440),
    [sym_dstring] = ACTIONS(4440),
    [sym_wstring] = ACTIONS(4440),
    [sym_noreturn] = ACTIONS(4440),
    [sym_true] = ACTIONS(4440),
    [sym_false] = ACTIONS(4440),
    [sym_null] = ACTIONS(4440),
    [sym_super] = ACTIONS(4440),
    [sym_this] = ACTIONS(4440),
    [sym_abstract] = ACTIONS(4440),
    [sym_alias] = ACTIONS(4440),
    [sym_align] = ACTIONS(4440),
    [sym_asm] = ACTIONS(4440),
    [sym_assert] = ACTIONS(4440),
    [sym_auto] = ACTIONS(4440),
    [sym_break] = ACTIONS(4440),
    [sym_case] = ACTIONS(4440),
    [sym_cast] = ACTIONS(4440),
    [sym_catch] = ACTIONS(4440),
    [sym_class] = ACTIONS(4440),
    [sym_const] = ACTIONS(4440),
    [sym_continue] = ACTIONS(4440),
    [sym_debug] = ACTIONS(4440),
    [sym_default] = ACTIONS(4440),
    [sym_delegate] = ACTIONS(4440),
    [sym_delete] = ACTIONS(4440),
    [sym_deprecated] = ACTIONS(4440),
    [sym_do] = ACTIONS(4440),
    [sym_else] = ACTIONS(4440),
    [sym_enum] = ACTIONS(4440),
    [sym_export] = ACTIONS(4440),
    [sym_extern] = ACTIONS(4440),
    [sym_final] = ACTIONS(4440),
    [sym_finally] = ACTIONS(4440),
    [sym_for] = ACTIONS(4440),
    [sym_foreach] = ACTIONS(4440),
    [sym_foreach_reverse] = ACTIONS(4440),
    [sym_function] = ACTIONS(4440),
    [sym_goto] = ACTIONS(4440),
    [sym_if] = ACTIONS(4440),
    [sym_immutable] = ACTIONS(4440),
    [sym_import] = ACTIONS(4440),
    [sym_in] = ACTIONS(4440),
    [sym_inout] = ACTIONS(4440),
    [sym_interface] = ACTIONS(4440),
    [sym_invariant] = ACTIONS(4440),
    [sym_is] = ACTIONS(4440),
    [sym_mixin] = ACTIONS(4440),
    [sym_new] = ACTIONS(4440),
    [sym_nothrow] = ACTIONS(4440),
    [sym_out] = ACTIONS(4440),
    [sym_override] = ACTIONS(4440),
    [sym_package] = ACTIONS(4440),
    [sym_pragma] = ACTIONS(4440),
    [sym_private] = ACTIONS(4440),
    [sym_protected] = ACTIONS(4440),
    [sym_public] = ACTIONS(4440),
    [sym_pure] = ACTIONS(4440),
    [sym_ref] = ACTIONS(4440),
    [sym_return] = ACTIONS(4440),
    [sym_scope] = ACTIONS(4440),
    [sym_shared] = ACTIONS(4440),
    [sym_static] = ACTIONS(4440),
    [sym_struct] = ACTIONS(4440),
    [sym_switch] = ACTIONS(4440),
    [sym_synchronized] = ACTIONS(4440),
    [sym_template] = ACTIONS(4440),
    [sym_throw] = ACTIONS(4440),
    [sym_try] = ACTIONS(4440),
    [sym_typeid] = ACTIONS(4440),
    [sym_typeof] = ACTIONS(4440),
    [sym_union] = ACTIONS(4440),
    [sym_unittest] = ACTIONS(4440),
    [sym_version] = ACTIONS(4440),
    [sym_while] = ACTIONS(4440),
    [sym_with] = ACTIONS(4440),
    [sym_gshared] = ACTIONS(4440),
    [sym_traits] = ACTIONS(4440),
    [sym_vector] = ACTIONS(4440),
    [sym_void] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_r_DQUOTE] = ACTIONS(4442),
    [anon_sym_x_DQUOTE] = ACTIONS(4442),
    [anon_sym_DQUOTE] = ACTIONS(4442),
    [anon_sym_i_BQUOTE] = ACTIONS(4442),
    [anon_sym_i_DQUOTE] = ACTIONS(4442),
    [anon_sym_iq_LBRACE] = ACTIONS(4442),
    [aux_sym_char_literal_token1] = ACTIONS(4442),
    [anon_sym_SQUOTE] = ACTIONS(4440),
    [anon_sym___DATE__] = ACTIONS(4440),
    [anon_sym___FILE__] = ACTIONS(4440),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4440),
    [anon_sym___FUNCTION__] = ACTIONS(4440),
    [anon_sym___LINE__] = ACTIONS(4440),
    [anon_sym___MODULE__] = ACTIONS(4440),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4440),
    [anon_sym___TIME__] = ACTIONS(4440),
    [anon_sym___TIMESTAMP__] = ACTIONS(4440),
    [anon_sym___VENDOR__] = ACTIONS(4440),
    [anon_sym___VERSION__] = ACTIONS(4440),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4442),
    [sym_float_literal] = ACTIONS(4442),
    [sym__string] = ACTIONS(4442),
  },
  [1365] = {
    [sym_identifier] = ACTIONS(4444),
    [anon_sym_q_LBRACE] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(4446),
    [anon_sym_DASH] = ACTIONS(4444),
    [anon_sym_DASH_DASH] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(4444),
    [anon_sym_PLUS_PLUS] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOLLAR] = ACTIONS(4446),
    [anon_sym_STAR] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_AT] = ACTIONS(4446),
    [sym_bool] = ACTIONS(4444),
    [sym_byte] = ACTIONS(4444),
    [sym_ubyte] = ACTIONS(4444),
    [sym_char] = ACTIONS(4444),
    [sym_short] = ACTIONS(4444),
    [sym_ushort] = ACTIONS(4444),
    [sym_int] = ACTIONS(4444),
    [sym_uint] = ACTIONS(4444),
    [sym_long] = ACTIONS(4444),
    [sym_ulong] = ACTIONS(4444),
    [sym_cent] = ACTIONS(4444),
    [sym_ucent] = ACTIONS(4444),
    [sym_wchar] = ACTIONS(4444),
    [sym_dchar] = ACTIONS(4444),
    [sym_float] = ACTIONS(4444),
    [sym_double] = ACTIONS(4444),
    [sym_real] = ACTIONS(4444),
    [sym_ifloat] = ACTIONS(4444),
    [sym_idouble] = ACTIONS(4444),
    [sym_ireal] = ACTIONS(4444),
    [sym_cfloat] = ACTIONS(4444),
    [sym_cdouble] = ACTIONS(4444),
    [sym_creal] = ACTIONS(4444),
    [sym_size_t] = ACTIONS(4444),
    [sym_ptrdiff_t] = ACTIONS(4444),
    [sym_string] = ACTIONS(4444),
    [sym_cstring] = ACTIONS(4444),
    [sym_dstring] = ACTIONS(4444),
    [sym_wstring] = ACTIONS(4444),
    [sym_noreturn] = ACTIONS(4444),
    [sym_true] = ACTIONS(4444),
    [sym_false] = ACTIONS(4444),
    [sym_null] = ACTIONS(4444),
    [sym_super] = ACTIONS(4444),
    [sym_this] = ACTIONS(4444),
    [sym_abstract] = ACTIONS(4444),
    [sym_alias] = ACTIONS(4444),
    [sym_align] = ACTIONS(4444),
    [sym_asm] = ACTIONS(4444),
    [sym_assert] = ACTIONS(4444),
    [sym_auto] = ACTIONS(4444),
    [sym_break] = ACTIONS(4444),
    [sym_case] = ACTIONS(4444),
    [sym_cast] = ACTIONS(4444),
    [sym_catch] = ACTIONS(4444),
    [sym_class] = ACTIONS(4444),
    [sym_const] = ACTIONS(4444),
    [sym_continue] = ACTIONS(4444),
    [sym_debug] = ACTIONS(4444),
    [sym_default] = ACTIONS(4444),
    [sym_delegate] = ACTIONS(4444),
    [sym_delete] = ACTIONS(4444),
    [sym_deprecated] = ACTIONS(4444),
    [sym_do] = ACTIONS(4444),
    [sym_else] = ACTIONS(4444),
    [sym_enum] = ACTIONS(4444),
    [sym_export] = ACTIONS(4444),
    [sym_extern] = ACTIONS(4444),
    [sym_final] = ACTIONS(4444),
    [sym_finally] = ACTIONS(4444),
    [sym_for] = ACTIONS(4444),
    [sym_foreach] = ACTIONS(4444),
    [sym_foreach_reverse] = ACTIONS(4444),
    [sym_function] = ACTIONS(4444),
    [sym_goto] = ACTIONS(4444),
    [sym_if] = ACTIONS(4444),
    [sym_immutable] = ACTIONS(4444),
    [sym_import] = ACTIONS(4444),
    [sym_in] = ACTIONS(4444),
    [sym_inout] = ACTIONS(4444),
    [sym_interface] = ACTIONS(4444),
    [sym_invariant] = ACTIONS(4444),
    [sym_is] = ACTIONS(4444),
    [sym_mixin] = ACTIONS(4444),
    [sym_new] = ACTIONS(4444),
    [sym_nothrow] = ACTIONS(4444),
    [sym_out] = ACTIONS(4444),
    [sym_override] = ACTIONS(4444),
    [sym_package] = ACTIONS(4444),
    [sym_pragma] = ACTIONS(4444),
    [sym_private] = ACTIONS(4444),
    [sym_protected] = ACTIONS(4444),
    [sym_public] = ACTIONS(4444),
    [sym_pure] = ACTIONS(4444),
    [sym_ref] = ACTIONS(4444),
    [sym_return] = ACTIONS(4444),
    [sym_scope] = ACTIONS(4444),
    [sym_shared] = ACTIONS(4444),
    [sym_static] = ACTIONS(4444),
    [sym_struct] = ACTIONS(4444),
    [sym_switch] = ACTIONS(4444),
    [sym_synchronized] = ACTIONS(4444),
    [sym_template] = ACTIONS(4444),
    [sym_throw] = ACTIONS(4444),
    [sym_try] = ACTIONS(4444),
    [sym_typeid] = ACTIONS(4444),
    [sym_typeof] = ACTIONS(4444),
    [sym_union] = ACTIONS(4444),
    [sym_unittest] = ACTIONS(4444),
    [sym_version] = ACTIONS(4444),
    [sym_while] = ACTIONS(4444),
    [sym_with] = ACTIONS(4444),
    [sym_gshared] = ACTIONS(4444),
    [sym_traits] = ACTIONS(4444),
    [sym_vector] = ACTIONS(4444),
    [sym_void] = ACTIONS(4444),
    [anon_sym_BQUOTE] = ACTIONS(4446),
    [anon_sym_r_DQUOTE] = ACTIONS(4446),
    [anon_sym_x_DQUOTE] = ACTIONS(4446),
    [anon_sym_DQUOTE] = ACTIONS(4446),
    [anon_sym_i_BQUOTE] = ACTIONS(4446),
    [anon_sym_i_DQUOTE] = ACTIONS(4446),
    [anon_sym_iq_LBRACE] = ACTIONS(4446),
    [aux_sym_char_literal_token1] = ACTIONS(4446),
    [anon_sym_SQUOTE] = ACTIONS(4444),
    [anon_sym___DATE__] = ACTIONS(4444),
    [anon_sym___FILE__] = ACTIONS(4444),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4444),
    [anon_sym___FUNCTION__] = ACTIONS(4444),
    [anon_sym___LINE__] = ACTIONS(4444),
    [anon_sym___MODULE__] = ACTIONS(4444),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4444),
    [anon_sym___TIME__] = ACTIONS(4444),
    [anon_sym___TIMESTAMP__] = ACTIONS(4444),
    [anon_sym___VENDOR__] = ACTIONS(4444),
    [anon_sym___VERSION__] = ACTIONS(4444),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4446),
    [sym_float_literal] = ACTIONS(4446),
    [sym__string] = ACTIONS(4446),
  },
  [1366] = {
    [sym_identifier] = ACTIONS(4448),
    [anon_sym_q_LBRACE] = ACTIONS(4450),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(4450),
    [anon_sym_DOT] = ACTIONS(4450),
    [anon_sym_AMP] = ACTIONS(4450),
    [anon_sym_DASH] = ACTIONS(4448),
    [anon_sym_DASH_DASH] = ACTIONS(4450),
    [anon_sym_PLUS] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4450),
    [anon_sym_BANG] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(4450),
    [anon_sym_RPAREN] = ACTIONS(4450),
    [anon_sym_LBRACK] = ACTIONS(4450),
    [anon_sym_SEMI] = ACTIONS(4450),
    [anon_sym_DOLLAR] = ACTIONS(4450),
    [anon_sym_STAR] = ACTIONS(4450),
    [anon_sym_TILDE] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4450),
    [sym_bool] = ACTIONS(4448),
    [sym_byte] = ACTIONS(4448),
    [sym_ubyte] = ACTIONS(4448),
    [sym_char] = ACTIONS(4448),
    [sym_short] = ACTIONS(4448),
    [sym_ushort] = ACTIONS(4448),
    [sym_int] = ACTIONS(4448),
    [sym_uint] = ACTIONS(4448),
    [sym_long] = ACTIONS(4448),
    [sym_ulong] = ACTIONS(4448),
    [sym_cent] = ACTIONS(4448),
    [sym_ucent] = ACTIONS(4448),
    [sym_wchar] = ACTIONS(4448),
    [sym_dchar] = ACTIONS(4448),
    [sym_float] = ACTIONS(4448),
    [sym_double] = ACTIONS(4448),
    [sym_real] = ACTIONS(4448),
    [sym_ifloat] = ACTIONS(4448),
    [sym_idouble] = ACTIONS(4448),
    [sym_ireal] = ACTIONS(4448),
    [sym_cfloat] = ACTIONS(4448),
    [sym_cdouble] = ACTIONS(4448),
    [sym_creal] = ACTIONS(4448),
    [sym_size_t] = ACTIONS(4448),
    [sym_ptrdiff_t] = ACTIONS(4448),
    [sym_string] = ACTIONS(4448),
    [sym_cstring] = ACTIONS(4448),
    [sym_dstring] = ACTIONS(4448),
    [sym_wstring] = ACTIONS(4448),
    [sym_noreturn] = ACTIONS(4448),
    [sym_true] = ACTIONS(4448),
    [sym_false] = ACTIONS(4448),
    [sym_null] = ACTIONS(4448),
    [sym_super] = ACTIONS(4448),
    [sym_this] = ACTIONS(4448),
    [sym_abstract] = ACTIONS(4448),
    [sym_alias] = ACTIONS(4448),
    [sym_align] = ACTIONS(4448),
    [sym_asm] = ACTIONS(4448),
    [sym_assert] = ACTIONS(4448),
    [sym_auto] = ACTIONS(4448),
    [sym_break] = ACTIONS(4448),
    [sym_case] = ACTIONS(4448),
    [sym_cast] = ACTIONS(4448),
    [sym_catch] = ACTIONS(4448),
    [sym_class] = ACTIONS(4448),
    [sym_const] = ACTIONS(4448),
    [sym_continue] = ACTIONS(4448),
    [sym_debug] = ACTIONS(4448),
    [sym_default] = ACTIONS(4448),
    [sym_delegate] = ACTIONS(4448),
    [sym_delete] = ACTIONS(4448),
    [sym_deprecated] = ACTIONS(4448),
    [sym_do] = ACTIONS(4448),
    [sym_else] = ACTIONS(4448),
    [sym_enum] = ACTIONS(4448),
    [sym_export] = ACTIONS(4448),
    [sym_extern] = ACTIONS(4448),
    [sym_final] = ACTIONS(4448),
    [sym_finally] = ACTIONS(4448),
    [sym_for] = ACTIONS(4448),
    [sym_foreach] = ACTIONS(4448),
    [sym_foreach_reverse] = ACTIONS(4448),
    [sym_function] = ACTIONS(4448),
    [sym_goto] = ACTIONS(4448),
    [sym_if] = ACTIONS(4448),
    [sym_immutable] = ACTIONS(4448),
    [sym_import] = ACTIONS(4448),
    [sym_in] = ACTIONS(4448),
    [sym_inout] = ACTIONS(4448),
    [sym_interface] = ACTIONS(4448),
    [sym_invariant] = ACTIONS(4448),
    [sym_is] = ACTIONS(4448),
    [sym_mixin] = ACTIONS(4448),
    [sym_new] = ACTIONS(4448),
    [sym_nothrow] = ACTIONS(4448),
    [sym_out] = ACTIONS(4448),
    [sym_override] = ACTIONS(4448),
    [sym_package] = ACTIONS(4448),
    [sym_pragma] = ACTIONS(4448),
    [sym_private] = ACTIONS(4448),
    [sym_protected] = ACTIONS(4448),
    [sym_public] = ACTIONS(4448),
    [sym_pure] = ACTIONS(4448),
    [sym_ref] = ACTIONS(4448),
    [sym_return] = ACTIONS(4448),
    [sym_scope] = ACTIONS(4448),
    [sym_shared] = ACTIONS(4448),
    [sym_static] = ACTIONS(4448),
    [sym_struct] = ACTIONS(4448),
    [sym_switch] = ACTIONS(4448),
    [sym_synchronized] = ACTIONS(4448),
    [sym_template] = ACTIONS(4448),
    [sym_throw] = ACTIONS(4448),
    [sym_try] = ACTIONS(4448),
    [sym_typeid] = ACTIONS(4448),
    [sym_typeof] = ACTIONS(4448),
    [sym_union] = ACTIONS(4448),
    [sym_unittest] = ACTIONS(4448),
    [sym_version] = ACTIONS(4448),
    [sym_while] = ACTIONS(4448),
    [sym_with] = ACTIONS(4448),
    [sym_gshared] = ACTIONS(4448),
    [sym_traits] = ACTIONS(4448),
    [sym_vector] = ACTIONS(4448),
    [sym_void] = ACTIONS(4448),
    [anon_sym_BQUOTE] = ACTIONS(4450),
    [anon_sym_r_DQUOTE] = ACTIONS(4450),
    [anon_sym_x_DQUOTE] = ACTIONS(4450),
    [anon_sym_DQUOTE] = ACTIONS(4450),
    [anon_sym_i_BQUOTE] = ACTIONS(4450),
    [anon_sym_i_DQUOTE] = ACTIONS(4450),
    [anon_sym_iq_LBRACE] = ACTIONS(4450),
    [aux_sym_char_literal_token1] = ACTIONS(4450),
    [anon_sym_SQUOTE] = ACTIONS(4448),
    [anon_sym___DATE__] = ACTIONS(4448),
    [anon_sym___FILE__] = ACTIONS(4448),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4448),
    [anon_sym___FUNCTION__] = ACTIONS(4448),
    [anon_sym___LINE__] = ACTIONS(4448),
    [anon_sym___MODULE__] = ACTIONS(4448),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4448),
    [anon_sym___TIME__] = ACTIONS(4448),
    [anon_sym___TIMESTAMP__] = ACTIONS(4448),
    [anon_sym___VENDOR__] = ACTIONS(4448),
    [anon_sym___VERSION__] = ACTIONS(4448),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4450),
    [sym_float_literal] = ACTIONS(4450),
    [sym__string] = ACTIONS(4450),
  },
  [1367] = {
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_q_LBRACE] = ACTIONS(4454),
    [anon_sym_RBRACE] = ACTIONS(4454),
    [anon_sym_LBRACE] = ACTIONS(4454),
    [anon_sym_DOT] = ACTIONS(4454),
    [anon_sym_AMP] = ACTIONS(4454),
    [anon_sym_DASH] = ACTIONS(4452),
    [anon_sym_DASH_DASH] = ACTIONS(4454),
    [anon_sym_PLUS] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4454),
    [anon_sym_BANG] = ACTIONS(4454),
    [anon_sym_LPAREN] = ACTIONS(4454),
    [anon_sym_RPAREN] = ACTIONS(4454),
    [anon_sym_LBRACK] = ACTIONS(4454),
    [anon_sym_SEMI] = ACTIONS(4454),
    [anon_sym_DOLLAR] = ACTIONS(4454),
    [anon_sym_STAR] = ACTIONS(4454),
    [anon_sym_TILDE] = ACTIONS(4454),
    [anon_sym_AT] = ACTIONS(4454),
    [sym_bool] = ACTIONS(4452),
    [sym_byte] = ACTIONS(4452),
    [sym_ubyte] = ACTIONS(4452),
    [sym_char] = ACTIONS(4452),
    [sym_short] = ACTIONS(4452),
    [sym_ushort] = ACTIONS(4452),
    [sym_int] = ACTIONS(4452),
    [sym_uint] = ACTIONS(4452),
    [sym_long] = ACTIONS(4452),
    [sym_ulong] = ACTIONS(4452),
    [sym_cent] = ACTIONS(4452),
    [sym_ucent] = ACTIONS(4452),
    [sym_wchar] = ACTIONS(4452),
    [sym_dchar] = ACTIONS(4452),
    [sym_float] = ACTIONS(4452),
    [sym_double] = ACTIONS(4452),
    [sym_real] = ACTIONS(4452),
    [sym_ifloat] = ACTIONS(4452),
    [sym_idouble] = ACTIONS(4452),
    [sym_ireal] = ACTIONS(4452),
    [sym_cfloat] = ACTIONS(4452),
    [sym_cdouble] = ACTIONS(4452),
    [sym_creal] = ACTIONS(4452),
    [sym_size_t] = ACTIONS(4452),
    [sym_ptrdiff_t] = ACTIONS(4452),
    [sym_string] = ACTIONS(4452),
    [sym_cstring] = ACTIONS(4452),
    [sym_dstring] = ACTIONS(4452),
    [sym_wstring] = ACTIONS(4452),
    [sym_noreturn] = ACTIONS(4452),
    [sym_true] = ACTIONS(4452),
    [sym_false] = ACTIONS(4452),
    [sym_null] = ACTIONS(4452),
    [sym_super] = ACTIONS(4452),
    [sym_this] = ACTIONS(4452),
    [sym_abstract] = ACTIONS(4452),
    [sym_alias] = ACTIONS(4452),
    [sym_align] = ACTIONS(4452),
    [sym_asm] = ACTIONS(4452),
    [sym_assert] = ACTIONS(4452),
    [sym_auto] = ACTIONS(4452),
    [sym_break] = ACTIONS(4452),
    [sym_case] = ACTIONS(4452),
    [sym_cast] = ACTIONS(4452),
    [sym_catch] = ACTIONS(4452),
    [sym_class] = ACTIONS(4452),
    [sym_const] = ACTIONS(4452),
    [sym_continue] = ACTIONS(4452),
    [sym_debug] = ACTIONS(4452),
    [sym_default] = ACTIONS(4452),
    [sym_delegate] = ACTIONS(4452),
    [sym_delete] = ACTIONS(4452),
    [sym_deprecated] = ACTIONS(4452),
    [sym_do] = ACTIONS(4452),
    [sym_else] = ACTIONS(4452),
    [sym_enum] = ACTIONS(4452),
    [sym_export] = ACTIONS(4452),
    [sym_extern] = ACTIONS(4452),
    [sym_final] = ACTIONS(4452),
    [sym_finally] = ACTIONS(4452),
    [sym_for] = ACTIONS(4452),
    [sym_foreach] = ACTIONS(4452),
    [sym_foreach_reverse] = ACTIONS(4452),
    [sym_function] = ACTIONS(4452),
    [sym_goto] = ACTIONS(4452),
    [sym_if] = ACTIONS(4452),
    [sym_immutable] = ACTIONS(4452),
    [sym_import] = ACTIONS(4452),
    [sym_in] = ACTIONS(4452),
    [sym_inout] = ACTIONS(4452),
    [sym_interface] = ACTIONS(4452),
    [sym_invariant] = ACTIONS(4452),
    [sym_is] = ACTIONS(4452),
    [sym_mixin] = ACTIONS(4452),
    [sym_new] = ACTIONS(4452),
    [sym_nothrow] = ACTIONS(4452),
    [sym_out] = ACTIONS(4452),
    [sym_override] = ACTIONS(4452),
    [sym_package] = ACTIONS(4452),
    [sym_pragma] = ACTIONS(4452),
    [sym_private] = ACTIONS(4452),
    [sym_protected] = ACTIONS(4452),
    [sym_public] = ACTIONS(4452),
    [sym_pure] = ACTIONS(4452),
    [sym_ref] = ACTIONS(4452),
    [sym_return] = ACTIONS(4452),
    [sym_scope] = ACTIONS(4452),
    [sym_shared] = ACTIONS(4452),
    [sym_static] = ACTIONS(4452),
    [sym_struct] = ACTIONS(4452),
    [sym_switch] = ACTIONS(4452),
    [sym_synchronized] = ACTIONS(4452),
    [sym_template] = ACTIONS(4452),
    [sym_throw] = ACTIONS(4452),
    [sym_try] = ACTIONS(4452),
    [sym_typeid] = ACTIONS(4452),
    [sym_typeof] = ACTIONS(4452),
    [sym_union] = ACTIONS(4452),
    [sym_unittest] = ACTIONS(4452),
    [sym_version] = ACTIONS(4452),
    [sym_while] = ACTIONS(4452),
    [sym_with] = ACTIONS(4452),
    [sym_gshared] = ACTIONS(4452),
    [sym_traits] = ACTIONS(4452),
    [sym_vector] = ACTIONS(4452),
    [sym_void] = ACTIONS(4452),
    [anon_sym_BQUOTE] = ACTIONS(4454),
    [anon_sym_r_DQUOTE] = ACTIONS(4454),
    [anon_sym_x_DQUOTE] = ACTIONS(4454),
    [anon_sym_DQUOTE] = ACTIONS(4454),
    [anon_sym_i_BQUOTE] = ACTIONS(4454),
    [anon_sym_i_DQUOTE] = ACTIONS(4454),
    [anon_sym_iq_LBRACE] = ACTIONS(4454),
    [aux_sym_char_literal_token1] = ACTIONS(4454),
    [anon_sym_SQUOTE] = ACTIONS(4452),
    [anon_sym___DATE__] = ACTIONS(4452),
    [anon_sym___FILE__] = ACTIONS(4452),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4452),
    [anon_sym___FUNCTION__] = ACTIONS(4452),
    [anon_sym___LINE__] = ACTIONS(4452),
    [anon_sym___MODULE__] = ACTIONS(4452),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4452),
    [anon_sym___TIME__] = ACTIONS(4452),
    [anon_sym___TIMESTAMP__] = ACTIONS(4452),
    [anon_sym___VENDOR__] = ACTIONS(4452),
    [anon_sym___VERSION__] = ACTIONS(4452),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4454),
    [sym_float_literal] = ACTIONS(4454),
    [sym__string] = ACTIONS(4454),
  },
  [1368] = {
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_q_LBRACE] = ACTIONS(4458),
    [anon_sym_RBRACE] = ACTIONS(4458),
    [anon_sym_LBRACE] = ACTIONS(4458),
    [anon_sym_DOT] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4458),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_PLUS_PLUS] = ACTIONS(4458),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(4458),
    [anon_sym_RPAREN] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_SEMI] = ACTIONS(4458),
    [anon_sym_DOLLAR] = ACTIONS(4458),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_TILDE] = ACTIONS(4458),
    [anon_sym_AT] = ACTIONS(4458),
    [sym_bool] = ACTIONS(4456),
    [sym_byte] = ACTIONS(4456),
    [sym_ubyte] = ACTIONS(4456),
    [sym_char] = ACTIONS(4456),
    [sym_short] = ACTIONS(4456),
    [sym_ushort] = ACTIONS(4456),
    [sym_int] = ACTIONS(4456),
    [sym_uint] = ACTIONS(4456),
    [sym_long] = ACTIONS(4456),
    [sym_ulong] = ACTIONS(4456),
    [sym_cent] = ACTIONS(4456),
    [sym_ucent] = ACTIONS(4456),
    [sym_wchar] = ACTIONS(4456),
    [sym_dchar] = ACTIONS(4456),
    [sym_float] = ACTIONS(4456),
    [sym_double] = ACTIONS(4456),
    [sym_real] = ACTIONS(4456),
    [sym_ifloat] = ACTIONS(4456),
    [sym_idouble] = ACTIONS(4456),
    [sym_ireal] = ACTIONS(4456),
    [sym_cfloat] = ACTIONS(4456),
    [sym_cdouble] = ACTIONS(4456),
    [sym_creal] = ACTIONS(4456),
    [sym_size_t] = ACTIONS(4456),
    [sym_ptrdiff_t] = ACTIONS(4456),
    [sym_string] = ACTIONS(4456),
    [sym_cstring] = ACTIONS(4456),
    [sym_dstring] = ACTIONS(4456),
    [sym_wstring] = ACTIONS(4456),
    [sym_noreturn] = ACTIONS(4456),
    [sym_true] = ACTIONS(4456),
    [sym_false] = ACTIONS(4456),
    [sym_null] = ACTIONS(4456),
    [sym_super] = ACTIONS(4456),
    [sym_this] = ACTIONS(4456),
    [sym_abstract] = ACTIONS(4456),
    [sym_alias] = ACTIONS(4456),
    [sym_align] = ACTIONS(4456),
    [sym_asm] = ACTIONS(4456),
    [sym_assert] = ACTIONS(4456),
    [sym_auto] = ACTIONS(4456),
    [sym_break] = ACTIONS(4456),
    [sym_case] = ACTIONS(4456),
    [sym_cast] = ACTIONS(4456),
    [sym_catch] = ACTIONS(4456),
    [sym_class] = ACTIONS(4456),
    [sym_const] = ACTIONS(4456),
    [sym_continue] = ACTIONS(4456),
    [sym_debug] = ACTIONS(4456),
    [sym_default] = ACTIONS(4456),
    [sym_delegate] = ACTIONS(4456),
    [sym_delete] = ACTIONS(4456),
    [sym_deprecated] = ACTIONS(4456),
    [sym_do] = ACTIONS(4456),
    [sym_else] = ACTIONS(4456),
    [sym_enum] = ACTIONS(4456),
    [sym_export] = ACTIONS(4456),
    [sym_extern] = ACTIONS(4456),
    [sym_final] = ACTIONS(4456),
    [sym_finally] = ACTIONS(4456),
    [sym_for] = ACTIONS(4456),
    [sym_foreach] = ACTIONS(4456),
    [sym_foreach_reverse] = ACTIONS(4456),
    [sym_function] = ACTIONS(4456),
    [sym_goto] = ACTIONS(4456),
    [sym_if] = ACTIONS(4456),
    [sym_immutable] = ACTIONS(4456),
    [sym_import] = ACTIONS(4456),
    [sym_in] = ACTIONS(4456),
    [sym_inout] = ACTIONS(4456),
    [sym_interface] = ACTIONS(4456),
    [sym_invariant] = ACTIONS(4456),
    [sym_is] = ACTIONS(4456),
    [sym_mixin] = ACTIONS(4456),
    [sym_new] = ACTIONS(4456),
    [sym_nothrow] = ACTIONS(4456),
    [sym_out] = ACTIONS(4456),
    [sym_override] = ACTIONS(4456),
    [sym_package] = ACTIONS(4456),
    [sym_pragma] = ACTIONS(4456),
    [sym_private] = ACTIONS(4456),
    [sym_protected] = ACTIONS(4456),
    [sym_public] = ACTIONS(4456),
    [sym_pure] = ACTIONS(4456),
    [sym_ref] = ACTIONS(4456),
    [sym_return] = ACTIONS(4456),
    [sym_scope] = ACTIONS(4456),
    [sym_shared] = ACTIONS(4456),
    [sym_static] = ACTIONS(4456),
    [sym_struct] = ACTIONS(4456),
    [sym_switch] = ACTIONS(4456),
    [sym_synchronized] = ACTIONS(4456),
    [sym_template] = ACTIONS(4456),
    [sym_throw] = ACTIONS(4456),
    [sym_try] = ACTIONS(4456),
    [sym_typeid] = ACTIONS(4456),
    [sym_typeof] = ACTIONS(4456),
    [sym_union] = ACTIONS(4456),
    [sym_unittest] = ACTIONS(4456),
    [sym_version] = ACTIONS(4456),
    [sym_while] = ACTIONS(4456),
    [sym_with] = ACTIONS(4456),
    [sym_gshared] = ACTIONS(4456),
    [sym_traits] = ACTIONS(4456),
    [sym_vector] = ACTIONS(4456),
    [sym_void] = ACTIONS(4456),
    [anon_sym_BQUOTE] = ACTIONS(4458),
    [anon_sym_r_DQUOTE] = ACTIONS(4458),
    [anon_sym_x_DQUOTE] = ACTIONS(4458),
    [anon_sym_DQUOTE] = ACTIONS(4458),
    [anon_sym_i_BQUOTE] = ACTIONS(4458),
    [anon_sym_i_DQUOTE] = ACTIONS(4458),
    [anon_sym_iq_LBRACE] = ACTIONS(4458),
    [aux_sym_char_literal_token1] = ACTIONS(4458),
    [anon_sym_SQUOTE] = ACTIONS(4456),
    [anon_sym___DATE__] = ACTIONS(4456),
    [anon_sym___FILE__] = ACTIONS(4456),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4456),
    [anon_sym___FUNCTION__] = ACTIONS(4456),
    [anon_sym___LINE__] = ACTIONS(4456),
    [anon_sym___MODULE__] = ACTIONS(4456),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4456),
    [anon_sym___TIME__] = ACTIONS(4456),
    [anon_sym___TIMESTAMP__] = ACTIONS(4456),
    [anon_sym___VENDOR__] = ACTIONS(4456),
    [anon_sym___VERSION__] = ACTIONS(4456),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4458),
    [sym_float_literal] = ACTIONS(4458),
    [sym__string] = ACTIONS(4458),
  },
  [1369] = {
    [sym_identifier] = ACTIONS(4460),
    [anon_sym_q_LBRACE] = ACTIONS(4462),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_LBRACE] = ACTIONS(4462),
    [anon_sym_DOT] = ACTIONS(4462),
    [anon_sym_AMP] = ACTIONS(4462),
    [anon_sym_DASH] = ACTIONS(4460),
    [anon_sym_DASH_DASH] = ACTIONS(4462),
    [anon_sym_PLUS] = ACTIONS(4460),
    [anon_sym_PLUS_PLUS] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4462),
    [anon_sym_LPAREN] = ACTIONS(4462),
    [anon_sym_RPAREN] = ACTIONS(4462),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4462),
    [anon_sym_STAR] = ACTIONS(4462),
    [anon_sym_TILDE] = ACTIONS(4462),
    [anon_sym_AT] = ACTIONS(4462),
    [sym_bool] = ACTIONS(4460),
    [sym_byte] = ACTIONS(4460),
    [sym_ubyte] = ACTIONS(4460),
    [sym_char] = ACTIONS(4460),
    [sym_short] = ACTIONS(4460),
    [sym_ushort] = ACTIONS(4460),
    [sym_int] = ACTIONS(4460),
    [sym_uint] = ACTIONS(4460),
    [sym_long] = ACTIONS(4460),
    [sym_ulong] = ACTIONS(4460),
    [sym_cent] = ACTIONS(4460),
    [sym_ucent] = ACTIONS(4460),
    [sym_wchar] = ACTIONS(4460),
    [sym_dchar] = ACTIONS(4460),
    [sym_float] = ACTIONS(4460),
    [sym_double] = ACTIONS(4460),
    [sym_real] = ACTIONS(4460),
    [sym_ifloat] = ACTIONS(4460),
    [sym_idouble] = ACTIONS(4460),
    [sym_ireal] = ACTIONS(4460),
    [sym_cfloat] = ACTIONS(4460),
    [sym_cdouble] = ACTIONS(4460),
    [sym_creal] = ACTIONS(4460),
    [sym_size_t] = ACTIONS(4460),
    [sym_ptrdiff_t] = ACTIONS(4460),
    [sym_string] = ACTIONS(4460),
    [sym_cstring] = ACTIONS(4460),
    [sym_dstring] = ACTIONS(4460),
    [sym_wstring] = ACTIONS(4460),
    [sym_noreturn] = ACTIONS(4460),
    [sym_true] = ACTIONS(4460),
    [sym_false] = ACTIONS(4460),
    [sym_null] = ACTIONS(4460),
    [sym_super] = ACTIONS(4460),
    [sym_this] = ACTIONS(4460),
    [sym_abstract] = ACTIONS(4460),
    [sym_alias] = ACTIONS(4460),
    [sym_align] = ACTIONS(4460),
    [sym_asm] = ACTIONS(4460),
    [sym_assert] = ACTIONS(4460),
    [sym_auto] = ACTIONS(4460),
    [sym_break] = ACTIONS(4460),
    [sym_case] = ACTIONS(4460),
    [sym_cast] = ACTIONS(4460),
    [sym_catch] = ACTIONS(4460),
    [sym_class] = ACTIONS(4460),
    [sym_const] = ACTIONS(4460),
    [sym_continue] = ACTIONS(4460),
    [sym_debug] = ACTIONS(4460),
    [sym_default] = ACTIONS(4460),
    [sym_delegate] = ACTIONS(4460),
    [sym_delete] = ACTIONS(4460),
    [sym_deprecated] = ACTIONS(4460),
    [sym_do] = ACTIONS(4460),
    [sym_else] = ACTIONS(4460),
    [sym_enum] = ACTIONS(4460),
    [sym_export] = ACTIONS(4460),
    [sym_extern] = ACTIONS(4460),
    [sym_final] = ACTIONS(4460),
    [sym_finally] = ACTIONS(4460),
    [sym_for] = ACTIONS(4460),
    [sym_foreach] = ACTIONS(4460),
    [sym_foreach_reverse] = ACTIONS(4460),
    [sym_function] = ACTIONS(4460),
    [sym_goto] = ACTIONS(4460),
    [sym_if] = ACTIONS(4460),
    [sym_immutable] = ACTIONS(4460),
    [sym_import] = ACTIONS(4460),
    [sym_in] = ACTIONS(4460),
    [sym_inout] = ACTIONS(4460),
    [sym_interface] = ACTIONS(4460),
    [sym_invariant] = ACTIONS(4460),
    [sym_is] = ACTIONS(4460),
    [sym_mixin] = ACTIONS(4460),
    [sym_new] = ACTIONS(4460),
    [sym_nothrow] = ACTIONS(4460),
    [sym_out] = ACTIONS(4460),
    [sym_override] = ACTIONS(4460),
    [sym_package] = ACTIONS(4460),
    [sym_pragma] = ACTIONS(4460),
    [sym_private] = ACTIONS(4460),
    [sym_protected] = ACTIONS(4460),
    [sym_public] = ACTIONS(4460),
    [sym_pure] = ACTIONS(4460),
    [sym_ref] = ACTIONS(4460),
    [sym_return] = ACTIONS(4460),
    [sym_scope] = ACTIONS(4460),
    [sym_shared] = ACTIONS(4460),
    [sym_static] = ACTIONS(4460),
    [sym_struct] = ACTIONS(4460),
    [sym_switch] = ACTIONS(4460),
    [sym_synchronized] = ACTIONS(4460),
    [sym_template] = ACTIONS(4460),
    [sym_throw] = ACTIONS(4460),
    [sym_try] = ACTIONS(4460),
    [sym_typeid] = ACTIONS(4460),
    [sym_typeof] = ACTIONS(4460),
    [sym_union] = ACTIONS(4460),
    [sym_unittest] = ACTIONS(4460),
    [sym_version] = ACTIONS(4460),
    [sym_while] = ACTIONS(4460),
    [sym_with] = ACTIONS(4460),
    [sym_gshared] = ACTIONS(4460),
    [sym_traits] = ACTIONS(4460),
    [sym_vector] = ACTIONS(4460),
    [sym_void] = ACTIONS(4460),
    [anon_sym_BQUOTE] = ACTIONS(4462),
    [anon_sym_r_DQUOTE] = ACTIONS(4462),
    [anon_sym_x_DQUOTE] = ACTIONS(4462),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_i_BQUOTE] = ACTIONS(4462),
    [anon_sym_i_DQUOTE] = ACTIONS(4462),
    [anon_sym_iq_LBRACE] = ACTIONS(4462),
    [aux_sym_char_literal_token1] = ACTIONS(4462),
    [anon_sym_SQUOTE] = ACTIONS(4460),
    [anon_sym___DATE__] = ACTIONS(4460),
    [anon_sym___FILE__] = ACTIONS(4460),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4460),
    [anon_sym___FUNCTION__] = ACTIONS(4460),
    [anon_sym___LINE__] = ACTIONS(4460),
    [anon_sym___MODULE__] = ACTIONS(4460),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4460),
    [anon_sym___TIME__] = ACTIONS(4460),
    [anon_sym___TIMESTAMP__] = ACTIONS(4460),
    [anon_sym___VENDOR__] = ACTIONS(4460),
    [anon_sym___VERSION__] = ACTIONS(4460),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4462),
    [sym_float_literal] = ACTIONS(4462),
    [sym__string] = ACTIONS(4462),
  },
  [1370] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_asm] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_break] = ACTIONS(2505),
    [sym_case] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_continue] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_default] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_finally] = ACTIONS(2505),
    [sym_for] = ACTIONS(2505),
    [sym_foreach] = ACTIONS(2505),
    [sym_foreach_reverse] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_goto] = ACTIONS(2505),
    [sym_if] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_switch] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_try] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_with] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [1371] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_asm] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_break] = ACTIONS(2505),
    [sym_case] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_continue] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_default] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(4464),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_finally] = ACTIONS(2505),
    [sym_for] = ACTIONS(2505),
    [sym_foreach] = ACTIONS(2505),
    [sym_foreach_reverse] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_goto] = ACTIONS(2505),
    [sym_if] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_switch] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_try] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_with] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [1372] = {
    [sym_identifier] = ACTIONS(4466),
    [anon_sym_q_LBRACE] = ACTIONS(4468),
    [anon_sym_RBRACE] = ACTIONS(4468),
    [anon_sym_LBRACE] = ACTIONS(4468),
    [anon_sym_DOT] = ACTIONS(4468),
    [anon_sym_AMP] = ACTIONS(4468),
    [anon_sym_DASH] = ACTIONS(4466),
    [anon_sym_DASH_DASH] = ACTIONS(4468),
    [anon_sym_PLUS] = ACTIONS(4466),
    [anon_sym_PLUS_PLUS] = ACTIONS(4468),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_LPAREN] = ACTIONS(4468),
    [anon_sym_RPAREN] = ACTIONS(4468),
    [anon_sym_LBRACK] = ACTIONS(4468),
    [anon_sym_SEMI] = ACTIONS(4468),
    [anon_sym_DOLLAR] = ACTIONS(4468),
    [anon_sym_STAR] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [anon_sym_AT] = ACTIONS(4468),
    [sym_bool] = ACTIONS(4466),
    [sym_byte] = ACTIONS(4466),
    [sym_ubyte] = ACTIONS(4466),
    [sym_char] = ACTIONS(4466),
    [sym_short] = ACTIONS(4466),
    [sym_ushort] = ACTIONS(4466),
    [sym_int] = ACTIONS(4466),
    [sym_uint] = ACTIONS(4466),
    [sym_long] = ACTIONS(4466),
    [sym_ulong] = ACTIONS(4466),
    [sym_cent] = ACTIONS(4466),
    [sym_ucent] = ACTIONS(4466),
    [sym_wchar] = ACTIONS(4466),
    [sym_dchar] = ACTIONS(4466),
    [sym_float] = ACTIONS(4466),
    [sym_double] = ACTIONS(4466),
    [sym_real] = ACTIONS(4466),
    [sym_ifloat] = ACTIONS(4466),
    [sym_idouble] = ACTIONS(4466),
    [sym_ireal] = ACTIONS(4466),
    [sym_cfloat] = ACTIONS(4466),
    [sym_cdouble] = ACTIONS(4466),
    [sym_creal] = ACTIONS(4466),
    [sym_size_t] = ACTIONS(4466),
    [sym_ptrdiff_t] = ACTIONS(4466),
    [sym_string] = ACTIONS(4466),
    [sym_cstring] = ACTIONS(4466),
    [sym_dstring] = ACTIONS(4466),
    [sym_wstring] = ACTIONS(4466),
    [sym_noreturn] = ACTIONS(4466),
    [sym_true] = ACTIONS(4466),
    [sym_false] = ACTIONS(4466),
    [sym_null] = ACTIONS(4466),
    [sym_super] = ACTIONS(4466),
    [sym_this] = ACTIONS(4466),
    [sym_abstract] = ACTIONS(4466),
    [sym_alias] = ACTIONS(4466),
    [sym_align] = ACTIONS(4466),
    [sym_asm] = ACTIONS(4466),
    [sym_assert] = ACTIONS(4466),
    [sym_auto] = ACTIONS(4466),
    [sym_break] = ACTIONS(4466),
    [sym_case] = ACTIONS(4466),
    [sym_cast] = ACTIONS(4466),
    [sym_catch] = ACTIONS(4466),
    [sym_class] = ACTIONS(4466),
    [sym_const] = ACTIONS(4466),
    [sym_continue] = ACTIONS(4466),
    [sym_debug] = ACTIONS(4466),
    [sym_default] = ACTIONS(4466),
    [sym_delegate] = ACTIONS(4466),
    [sym_delete] = ACTIONS(4466),
    [sym_deprecated] = ACTIONS(4466),
    [sym_do] = ACTIONS(4466),
    [sym_else] = ACTIONS(4466),
    [sym_enum] = ACTIONS(4466),
    [sym_export] = ACTIONS(4466),
    [sym_extern] = ACTIONS(4466),
    [sym_final] = ACTIONS(4466),
    [sym_finally] = ACTIONS(4466),
    [sym_for] = ACTIONS(4466),
    [sym_foreach] = ACTIONS(4466),
    [sym_foreach_reverse] = ACTIONS(4466),
    [sym_function] = ACTIONS(4466),
    [sym_goto] = ACTIONS(4466),
    [sym_if] = ACTIONS(4466),
    [sym_immutable] = ACTIONS(4466),
    [sym_import] = ACTIONS(4466),
    [sym_in] = ACTIONS(4466),
    [sym_inout] = ACTIONS(4466),
    [sym_interface] = ACTIONS(4466),
    [sym_invariant] = ACTIONS(4466),
    [sym_is] = ACTIONS(4466),
    [sym_mixin] = ACTIONS(4466),
    [sym_new] = ACTIONS(4466),
    [sym_nothrow] = ACTIONS(4466),
    [sym_out] = ACTIONS(4466),
    [sym_override] = ACTIONS(4466),
    [sym_package] = ACTIONS(4466),
    [sym_pragma] = ACTIONS(4466),
    [sym_private] = ACTIONS(4466),
    [sym_protected] = ACTIONS(4466),
    [sym_public] = ACTIONS(4466),
    [sym_pure] = ACTIONS(4466),
    [sym_ref] = ACTIONS(4466),
    [sym_return] = ACTIONS(4466),
    [sym_scope] = ACTIONS(4466),
    [sym_shared] = ACTIONS(4466),
    [sym_static] = ACTIONS(4466),
    [sym_struct] = ACTIONS(4466),
    [sym_switch] = ACTIONS(4466),
    [sym_synchronized] = ACTIONS(4466),
    [sym_template] = ACTIONS(4466),
    [sym_throw] = ACTIONS(4466),
    [sym_try] = ACTIONS(4466),
    [sym_typeid] = ACTIONS(4466),
    [sym_typeof] = ACTIONS(4466),
    [sym_union] = ACTIONS(4466),
    [sym_unittest] = ACTIONS(4466),
    [sym_version] = ACTIONS(4466),
    [sym_while] = ACTIONS(4466),
    [sym_with] = ACTIONS(4466),
    [sym_gshared] = ACTIONS(4466),
    [sym_traits] = ACTIONS(4466),
    [sym_vector] = ACTIONS(4466),
    [sym_void] = ACTIONS(4466),
    [anon_sym_BQUOTE] = ACTIONS(4468),
    [anon_sym_r_DQUOTE] = ACTIONS(4468),
    [anon_sym_x_DQUOTE] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4468),
    [anon_sym_i_BQUOTE] = ACTIONS(4468),
    [anon_sym_i_DQUOTE] = ACTIONS(4468),
    [anon_sym_iq_LBRACE] = ACTIONS(4468),
    [aux_sym_char_literal_token1] = ACTIONS(4468),
    [anon_sym_SQUOTE] = ACTIONS(4466),
    [anon_sym___DATE__] = ACTIONS(4466),
    [anon_sym___FILE__] = ACTIONS(4466),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4466),
    [anon_sym___FUNCTION__] = ACTIONS(4466),
    [anon_sym___LINE__] = ACTIONS(4466),
    [anon_sym___MODULE__] = ACTIONS(4466),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4466),
    [anon_sym___TIME__] = ACTIONS(4466),
    [anon_sym___TIMESTAMP__] = ACTIONS(4466),
    [anon_sym___VENDOR__] = ACTIONS(4466),
    [anon_sym___VERSION__] = ACTIONS(4466),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4468),
    [sym_float_literal] = ACTIONS(4468),
    [sym__string] = ACTIONS(4468),
  },
  [1373] = {
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_q_LBRACE] = ACTIONS(4472),
    [anon_sym_RBRACE] = ACTIONS(4472),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_DOT] = ACTIONS(4472),
    [anon_sym_AMP] = ACTIONS(4472),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_RPAREN] = ACTIONS(4472),
    [anon_sym_LBRACK] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [anon_sym_AT] = ACTIONS(4472),
    [sym_bool] = ACTIONS(4470),
    [sym_byte] = ACTIONS(4470),
    [sym_ubyte] = ACTIONS(4470),
    [sym_char] = ACTIONS(4470),
    [sym_short] = ACTIONS(4470),
    [sym_ushort] = ACTIONS(4470),
    [sym_int] = ACTIONS(4470),
    [sym_uint] = ACTIONS(4470),
    [sym_long] = ACTIONS(4470),
    [sym_ulong] = ACTIONS(4470),
    [sym_cent] = ACTIONS(4470),
    [sym_ucent] = ACTIONS(4470),
    [sym_wchar] = ACTIONS(4470),
    [sym_dchar] = ACTIONS(4470),
    [sym_float] = ACTIONS(4470),
    [sym_double] = ACTIONS(4470),
    [sym_real] = ACTIONS(4470),
    [sym_ifloat] = ACTIONS(4470),
    [sym_idouble] = ACTIONS(4470),
    [sym_ireal] = ACTIONS(4470),
    [sym_cfloat] = ACTIONS(4470),
    [sym_cdouble] = ACTIONS(4470),
    [sym_creal] = ACTIONS(4470),
    [sym_size_t] = ACTIONS(4470),
    [sym_ptrdiff_t] = ACTIONS(4470),
    [sym_string] = ACTIONS(4470),
    [sym_cstring] = ACTIONS(4470),
    [sym_dstring] = ACTIONS(4470),
    [sym_wstring] = ACTIONS(4470),
    [sym_noreturn] = ACTIONS(4470),
    [sym_true] = ACTIONS(4470),
    [sym_false] = ACTIONS(4470),
    [sym_null] = ACTIONS(4470),
    [sym_super] = ACTIONS(4470),
    [sym_this] = ACTIONS(4470),
    [sym_abstract] = ACTIONS(4470),
    [sym_alias] = ACTIONS(4470),
    [sym_align] = ACTIONS(4470),
    [sym_asm] = ACTIONS(4470),
    [sym_assert] = ACTIONS(4470),
    [sym_auto] = ACTIONS(4470),
    [sym_break] = ACTIONS(4470),
    [sym_case] = ACTIONS(4470),
    [sym_cast] = ACTIONS(4470),
    [sym_catch] = ACTIONS(4470),
    [sym_class] = ACTIONS(4470),
    [sym_const] = ACTIONS(4470),
    [sym_continue] = ACTIONS(4470),
    [sym_debug] = ACTIONS(4470),
    [sym_default] = ACTIONS(4470),
    [sym_delegate] = ACTIONS(4470),
    [sym_delete] = ACTIONS(4470),
    [sym_deprecated] = ACTIONS(4470),
    [sym_do] = ACTIONS(4470),
    [sym_else] = ACTIONS(4470),
    [sym_enum] = ACTIONS(4470),
    [sym_export] = ACTIONS(4470),
    [sym_extern] = ACTIONS(4470),
    [sym_final] = ACTIONS(4470),
    [sym_finally] = ACTIONS(4470),
    [sym_for] = ACTIONS(4470),
    [sym_foreach] = ACTIONS(4470),
    [sym_foreach_reverse] = ACTIONS(4470),
    [sym_function] = ACTIONS(4470),
    [sym_goto] = ACTIONS(4470),
    [sym_if] = ACTIONS(4470),
    [sym_immutable] = ACTIONS(4470),
    [sym_import] = ACTIONS(4470),
    [sym_in] = ACTIONS(4470),
    [sym_inout] = ACTIONS(4470),
    [sym_interface] = ACTIONS(4470),
    [sym_invariant] = ACTIONS(4470),
    [sym_is] = ACTIONS(4470),
    [sym_mixin] = ACTIONS(4470),
    [sym_new] = ACTIONS(4470),
    [sym_nothrow] = ACTIONS(4470),
    [sym_out] = ACTIONS(4470),
    [sym_override] = ACTIONS(4470),
    [sym_package] = ACTIONS(4470),
    [sym_pragma] = ACTIONS(4470),
    [sym_private] = ACTIONS(4470),
    [sym_protected] = ACTIONS(4470),
    [sym_public] = ACTIONS(4470),
    [sym_pure] = ACTIONS(4470),
    [sym_ref] = ACTIONS(4470),
    [sym_return] = ACTIONS(4470),
    [sym_scope] = ACTIONS(4470),
    [sym_shared] = ACTIONS(4470),
    [sym_static] = ACTIONS(4470),
    [sym_struct] = ACTIONS(4470),
    [sym_switch] = ACTIONS(4470),
    [sym_synchronized] = ACTIONS(4470),
    [sym_template] = ACTIONS(4470),
    [sym_throw] = ACTIONS(4470),
    [sym_try] = ACTIONS(4470),
    [sym_typeid] = ACTIONS(4470),
    [sym_typeof] = ACTIONS(4470),
    [sym_union] = ACTIONS(4470),
    [sym_unittest] = ACTIONS(4470),
    [sym_version] = ACTIONS(4470),
    [sym_while] = ACTIONS(4470),
    [sym_with] = ACTIONS(4470),
    [sym_gshared] = ACTIONS(4470),
    [sym_traits] = ACTIONS(4470),
    [sym_vector] = ACTIONS(4470),
    [sym_void] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_r_DQUOTE] = ACTIONS(4472),
    [anon_sym_x_DQUOTE] = ACTIONS(4472),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_i_BQUOTE] = ACTIONS(4472),
    [anon_sym_i_DQUOTE] = ACTIONS(4472),
    [anon_sym_iq_LBRACE] = ACTIONS(4472),
    [aux_sym_char_literal_token1] = ACTIONS(4472),
    [anon_sym_SQUOTE] = ACTIONS(4470),
    [anon_sym___DATE__] = ACTIONS(4470),
    [anon_sym___FILE__] = ACTIONS(4470),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4470),
    [anon_sym___FUNCTION__] = ACTIONS(4470),
    [anon_sym___LINE__] = ACTIONS(4470),
    [anon_sym___MODULE__] = ACTIONS(4470),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4470),
    [anon_sym___TIME__] = ACTIONS(4470),
    [anon_sym___TIMESTAMP__] = ACTIONS(4470),
    [anon_sym___VENDOR__] = ACTIONS(4470),
    [anon_sym___VERSION__] = ACTIONS(4470),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4472),
    [sym_float_literal] = ACTIONS(4472),
    [sym__string] = ACTIONS(4472),
  },
  [1374] = {
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_q_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4476),
    [anon_sym_AMP] = ACTIONS(4476),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_DOLLAR] = ACTIONS(4476),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4476),
    [anon_sym_AT] = ACTIONS(4476),
    [sym_bool] = ACTIONS(4474),
    [sym_byte] = ACTIONS(4474),
    [sym_ubyte] = ACTIONS(4474),
    [sym_char] = ACTIONS(4474),
    [sym_short] = ACTIONS(4474),
    [sym_ushort] = ACTIONS(4474),
    [sym_int] = ACTIONS(4474),
    [sym_uint] = ACTIONS(4474),
    [sym_long] = ACTIONS(4474),
    [sym_ulong] = ACTIONS(4474),
    [sym_cent] = ACTIONS(4474),
    [sym_ucent] = ACTIONS(4474),
    [sym_wchar] = ACTIONS(4474),
    [sym_dchar] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_double] = ACTIONS(4474),
    [sym_real] = ACTIONS(4474),
    [sym_ifloat] = ACTIONS(4474),
    [sym_idouble] = ACTIONS(4474),
    [sym_ireal] = ACTIONS(4474),
    [sym_cfloat] = ACTIONS(4474),
    [sym_cdouble] = ACTIONS(4474),
    [sym_creal] = ACTIONS(4474),
    [sym_size_t] = ACTIONS(4474),
    [sym_ptrdiff_t] = ACTIONS(4474),
    [sym_string] = ACTIONS(4474),
    [sym_cstring] = ACTIONS(4474),
    [sym_dstring] = ACTIONS(4474),
    [sym_wstring] = ACTIONS(4474),
    [sym_noreturn] = ACTIONS(4474),
    [sym_true] = ACTIONS(4474),
    [sym_false] = ACTIONS(4474),
    [sym_null] = ACTIONS(4474),
    [sym_super] = ACTIONS(4474),
    [sym_this] = ACTIONS(4474),
    [sym_abstract] = ACTIONS(4474),
    [sym_alias] = ACTIONS(4474),
    [sym_align] = ACTIONS(4474),
    [sym_asm] = ACTIONS(4474),
    [sym_assert] = ACTIONS(4474),
    [sym_auto] = ACTIONS(4474),
    [sym_break] = ACTIONS(4474),
    [sym_case] = ACTIONS(4474),
    [sym_cast] = ACTIONS(4474),
    [sym_catch] = ACTIONS(4474),
    [sym_class] = ACTIONS(4474),
    [sym_const] = ACTIONS(4474),
    [sym_continue] = ACTIONS(4474),
    [sym_debug] = ACTIONS(4474),
    [sym_default] = ACTIONS(4474),
    [sym_delegate] = ACTIONS(4474),
    [sym_delete] = ACTIONS(4474),
    [sym_deprecated] = ACTIONS(4474),
    [sym_do] = ACTIONS(4474),
    [sym_else] = ACTIONS(4474),
    [sym_enum] = ACTIONS(4474),
    [sym_export] = ACTIONS(4474),
    [sym_extern] = ACTIONS(4474),
    [sym_final] = ACTIONS(4474),
    [sym_finally] = ACTIONS(4474),
    [sym_for] = ACTIONS(4474),
    [sym_foreach] = ACTIONS(4474),
    [sym_foreach_reverse] = ACTIONS(4474),
    [sym_function] = ACTIONS(4474),
    [sym_goto] = ACTIONS(4474),
    [sym_if] = ACTIONS(4474),
    [sym_immutable] = ACTIONS(4474),
    [sym_import] = ACTIONS(4474),
    [sym_in] = ACTIONS(4474),
    [sym_inout] = ACTIONS(4474),
    [sym_interface] = ACTIONS(4474),
    [sym_invariant] = ACTIONS(4474),
    [sym_is] = ACTIONS(4474),
    [sym_mixin] = ACTIONS(4474),
    [sym_new] = ACTIONS(4474),
    [sym_nothrow] = ACTIONS(4474),
    [sym_out] = ACTIONS(4474),
    [sym_override] = ACTIONS(4474),
    [sym_package] = ACTIONS(4474),
    [sym_pragma] = ACTIONS(4474),
    [sym_private] = ACTIONS(4474),
    [sym_protected] = ACTIONS(4474),
    [sym_public] = ACTIONS(4474),
    [sym_pure] = ACTIONS(4474),
    [sym_ref] = ACTIONS(4474),
    [sym_return] = ACTIONS(4474),
    [sym_scope] = ACTIONS(4474),
    [sym_shared] = ACTIONS(4474),
    [sym_static] = ACTIONS(4474),
    [sym_struct] = ACTIONS(4474),
    [sym_switch] = ACTIONS(4474),
    [sym_synchronized] = ACTIONS(4474),
    [sym_template] = ACTIONS(4474),
    [sym_throw] = ACTIONS(4474),
    [sym_try] = ACTIONS(4474),
    [sym_typeid] = ACTIONS(4474),
    [sym_typeof] = ACTIONS(4474),
    [sym_union] = ACTIONS(4474),
    [sym_unittest] = ACTIONS(4474),
    [sym_version] = ACTIONS(4474),
    [sym_while] = ACTIONS(4474),
    [sym_with] = ACTIONS(4474),
    [sym_gshared] = ACTIONS(4474),
    [sym_traits] = ACTIONS(4474),
    [sym_vector] = ACTIONS(4474),
    [sym_void] = ACTIONS(4474),
    [anon_sym_BQUOTE] = ACTIONS(4476),
    [anon_sym_r_DQUOTE] = ACTIONS(4476),
    [anon_sym_x_DQUOTE] = ACTIONS(4476),
    [anon_sym_DQUOTE] = ACTIONS(4476),
    [anon_sym_i_BQUOTE] = ACTIONS(4476),
    [anon_sym_i_DQUOTE] = ACTIONS(4476),
    [anon_sym_iq_LBRACE] = ACTIONS(4476),
    [aux_sym_char_literal_token1] = ACTIONS(4476),
    [anon_sym_SQUOTE] = ACTIONS(4474),
    [anon_sym___DATE__] = ACTIONS(4474),
    [anon_sym___FILE__] = ACTIONS(4474),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4474),
    [anon_sym___FUNCTION__] = ACTIONS(4474),
    [anon_sym___LINE__] = ACTIONS(4474),
    [anon_sym___MODULE__] = ACTIONS(4474),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4474),
    [anon_sym___TIME__] = ACTIONS(4474),
    [anon_sym___TIMESTAMP__] = ACTIONS(4474),
    [anon_sym___VENDOR__] = ACTIONS(4474),
    [anon_sym___VERSION__] = ACTIONS(4474),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4476),
    [sym_float_literal] = ACTIONS(4476),
    [sym__string] = ACTIONS(4476),
  },
  [1375] = {
    [sym_identifier] = ACTIONS(4478),
    [anon_sym_q_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_DOLLAR] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_TILDE] = ACTIONS(4480),
    [anon_sym_AT] = ACTIONS(4480),
    [sym_bool] = ACTIONS(4478),
    [sym_byte] = ACTIONS(4478),
    [sym_ubyte] = ACTIONS(4478),
    [sym_char] = ACTIONS(4478),
    [sym_short] = ACTIONS(4478),
    [sym_ushort] = ACTIONS(4478),
    [sym_int] = ACTIONS(4478),
    [sym_uint] = ACTIONS(4478),
    [sym_long] = ACTIONS(4478),
    [sym_ulong] = ACTIONS(4478),
    [sym_cent] = ACTIONS(4478),
    [sym_ucent] = ACTIONS(4478),
    [sym_wchar] = ACTIONS(4478),
    [sym_dchar] = ACTIONS(4478),
    [sym_float] = ACTIONS(4478),
    [sym_double] = ACTIONS(4478),
    [sym_real] = ACTIONS(4478),
    [sym_ifloat] = ACTIONS(4478),
    [sym_idouble] = ACTIONS(4478),
    [sym_ireal] = ACTIONS(4478),
    [sym_cfloat] = ACTIONS(4478),
    [sym_cdouble] = ACTIONS(4478),
    [sym_creal] = ACTIONS(4478),
    [sym_size_t] = ACTIONS(4478),
    [sym_ptrdiff_t] = ACTIONS(4478),
    [sym_string] = ACTIONS(4478),
    [sym_cstring] = ACTIONS(4478),
    [sym_dstring] = ACTIONS(4478),
    [sym_wstring] = ACTIONS(4478),
    [sym_noreturn] = ACTIONS(4478),
    [sym_true] = ACTIONS(4478),
    [sym_false] = ACTIONS(4478),
    [sym_null] = ACTIONS(4478),
    [sym_super] = ACTIONS(4478),
    [sym_this] = ACTIONS(4478),
    [sym_abstract] = ACTIONS(4478),
    [sym_alias] = ACTIONS(4478),
    [sym_align] = ACTIONS(4478),
    [sym_asm] = ACTIONS(4478),
    [sym_assert] = ACTIONS(4478),
    [sym_auto] = ACTIONS(4478),
    [sym_break] = ACTIONS(4478),
    [sym_case] = ACTIONS(4478),
    [sym_cast] = ACTIONS(4478),
    [sym_catch] = ACTIONS(4478),
    [sym_class] = ACTIONS(4478),
    [sym_const] = ACTIONS(4478),
    [sym_continue] = ACTIONS(4478),
    [sym_debug] = ACTIONS(4478),
    [sym_default] = ACTIONS(4478),
    [sym_delegate] = ACTIONS(4478),
    [sym_delete] = ACTIONS(4478),
    [sym_deprecated] = ACTIONS(4478),
    [sym_do] = ACTIONS(4478),
    [sym_else] = ACTIONS(4478),
    [sym_enum] = ACTIONS(4478),
    [sym_export] = ACTIONS(4478),
    [sym_extern] = ACTIONS(4478),
    [sym_final] = ACTIONS(4478),
    [sym_finally] = ACTIONS(4478),
    [sym_for] = ACTIONS(4478),
    [sym_foreach] = ACTIONS(4478),
    [sym_foreach_reverse] = ACTIONS(4478),
    [sym_function] = ACTIONS(4478),
    [sym_goto] = ACTIONS(4478),
    [sym_if] = ACTIONS(4478),
    [sym_immutable] = ACTIONS(4478),
    [sym_import] = ACTIONS(4478),
    [sym_in] = ACTIONS(4478),
    [sym_inout] = ACTIONS(4478),
    [sym_interface] = ACTIONS(4478),
    [sym_invariant] = ACTIONS(4478),
    [sym_is] = ACTIONS(4478),
    [sym_mixin] = ACTIONS(4478),
    [sym_new] = ACTIONS(4478),
    [sym_nothrow] = ACTIONS(4478),
    [sym_out] = ACTIONS(4478),
    [sym_override] = ACTIONS(4478),
    [sym_package] = ACTIONS(4478),
    [sym_pragma] = ACTIONS(4478),
    [sym_private] = ACTIONS(4478),
    [sym_protected] = ACTIONS(4478),
    [sym_public] = ACTIONS(4478),
    [sym_pure] = ACTIONS(4478),
    [sym_ref] = ACTIONS(4478),
    [sym_return] = ACTIONS(4478),
    [sym_scope] = ACTIONS(4478),
    [sym_shared] = ACTIONS(4478),
    [sym_static] = ACTIONS(4478),
    [sym_struct] = ACTIONS(4478),
    [sym_switch] = ACTIONS(4478),
    [sym_synchronized] = ACTIONS(4478),
    [sym_template] = ACTIONS(4478),
    [sym_throw] = ACTIONS(4478),
    [sym_try] = ACTIONS(4478),
    [sym_typeid] = ACTIONS(4478),
    [sym_typeof] = ACTIONS(4478),
    [sym_union] = ACTIONS(4478),
    [sym_unittest] = ACTIONS(4478),
    [sym_version] = ACTIONS(4478),
    [sym_while] = ACTIONS(4478),
    [sym_with] = ACTIONS(4478),
    [sym_gshared] = ACTIONS(4478),
    [sym_traits] = ACTIONS(4478),
    [sym_vector] = ACTIONS(4478),
    [sym_void] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_r_DQUOTE] = ACTIONS(4480),
    [anon_sym_x_DQUOTE] = ACTIONS(4480),
    [anon_sym_DQUOTE] = ACTIONS(4480),
    [anon_sym_i_BQUOTE] = ACTIONS(4480),
    [anon_sym_i_DQUOTE] = ACTIONS(4480),
    [anon_sym_iq_LBRACE] = ACTIONS(4480),
    [aux_sym_char_literal_token1] = ACTIONS(4480),
    [anon_sym_SQUOTE] = ACTIONS(4478),
    [anon_sym___DATE__] = ACTIONS(4478),
    [anon_sym___FILE__] = ACTIONS(4478),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4478),
    [anon_sym___FUNCTION__] = ACTIONS(4478),
    [anon_sym___LINE__] = ACTIONS(4478),
    [anon_sym___MODULE__] = ACTIONS(4478),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4478),
    [anon_sym___TIME__] = ACTIONS(4478),
    [anon_sym___TIMESTAMP__] = ACTIONS(4478),
    [anon_sym___VENDOR__] = ACTIONS(4478),
    [anon_sym___VERSION__] = ACTIONS(4478),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4480),
    [sym_float_literal] = ACTIONS(4480),
    [sym__string] = ACTIONS(4480),
  },
  [1376] = {
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_q_LBRACE] = ACTIONS(4484),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4484),
    [anon_sym_PLUS] = ACTIONS(4482),
    [anon_sym_PLUS_PLUS] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_LPAREN] = ACTIONS(4484),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_DOLLAR] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4484),
    [anon_sym_AT] = ACTIONS(4484),
    [sym_bool] = ACTIONS(4482),
    [sym_byte] = ACTIONS(4482),
    [sym_ubyte] = ACTIONS(4482),
    [sym_char] = ACTIONS(4482),
    [sym_short] = ACTIONS(4482),
    [sym_ushort] = ACTIONS(4482),
    [sym_int] = ACTIONS(4482),
    [sym_uint] = ACTIONS(4482),
    [sym_long] = ACTIONS(4482),
    [sym_ulong] = ACTIONS(4482),
    [sym_cent] = ACTIONS(4482),
    [sym_ucent] = ACTIONS(4482),
    [sym_wchar] = ACTIONS(4482),
    [sym_dchar] = ACTIONS(4482),
    [sym_float] = ACTIONS(4482),
    [sym_double] = ACTIONS(4482),
    [sym_real] = ACTIONS(4482),
    [sym_ifloat] = ACTIONS(4482),
    [sym_idouble] = ACTIONS(4482),
    [sym_ireal] = ACTIONS(4482),
    [sym_cfloat] = ACTIONS(4482),
    [sym_cdouble] = ACTIONS(4482),
    [sym_creal] = ACTIONS(4482),
    [sym_size_t] = ACTIONS(4482),
    [sym_ptrdiff_t] = ACTIONS(4482),
    [sym_string] = ACTIONS(4482),
    [sym_cstring] = ACTIONS(4482),
    [sym_dstring] = ACTIONS(4482),
    [sym_wstring] = ACTIONS(4482),
    [sym_noreturn] = ACTIONS(4482),
    [sym_true] = ACTIONS(4482),
    [sym_false] = ACTIONS(4482),
    [sym_null] = ACTIONS(4482),
    [sym_super] = ACTIONS(4482),
    [sym_this] = ACTIONS(4482),
    [sym_abstract] = ACTIONS(4482),
    [sym_alias] = ACTIONS(4482),
    [sym_align] = ACTIONS(4482),
    [sym_asm] = ACTIONS(4482),
    [sym_assert] = ACTIONS(4482),
    [sym_auto] = ACTIONS(4482),
    [sym_break] = ACTIONS(4482),
    [sym_case] = ACTIONS(4482),
    [sym_cast] = ACTIONS(4482),
    [sym_catch] = ACTIONS(4482),
    [sym_class] = ACTIONS(4482),
    [sym_const] = ACTIONS(4482),
    [sym_continue] = ACTIONS(4482),
    [sym_debug] = ACTIONS(4482),
    [sym_default] = ACTIONS(4482),
    [sym_delegate] = ACTIONS(4482),
    [sym_delete] = ACTIONS(4482),
    [sym_deprecated] = ACTIONS(4482),
    [sym_do] = ACTIONS(4482),
    [sym_else] = ACTIONS(4482),
    [sym_enum] = ACTIONS(4482),
    [sym_export] = ACTIONS(4482),
    [sym_extern] = ACTIONS(4482),
    [sym_final] = ACTIONS(4482),
    [sym_finally] = ACTIONS(4482),
    [sym_for] = ACTIONS(4482),
    [sym_foreach] = ACTIONS(4482),
    [sym_foreach_reverse] = ACTIONS(4482),
    [sym_function] = ACTIONS(4482),
    [sym_goto] = ACTIONS(4482),
    [sym_if] = ACTIONS(4482),
    [sym_immutable] = ACTIONS(4482),
    [sym_import] = ACTIONS(4482),
    [sym_in] = ACTIONS(4482),
    [sym_inout] = ACTIONS(4482),
    [sym_interface] = ACTIONS(4482),
    [sym_invariant] = ACTIONS(4482),
    [sym_is] = ACTIONS(4482),
    [sym_mixin] = ACTIONS(4482),
    [sym_new] = ACTIONS(4482),
    [sym_nothrow] = ACTIONS(4482),
    [sym_out] = ACTIONS(4482),
    [sym_override] = ACTIONS(4482),
    [sym_package] = ACTIONS(4482),
    [sym_pragma] = ACTIONS(4482),
    [sym_private] = ACTIONS(4482),
    [sym_protected] = ACTIONS(4482),
    [sym_public] = ACTIONS(4482),
    [sym_pure] = ACTIONS(4482),
    [sym_ref] = ACTIONS(4482),
    [sym_return] = ACTIONS(4482),
    [sym_scope] = ACTIONS(4482),
    [sym_shared] = ACTIONS(4482),
    [sym_static] = ACTIONS(4482),
    [sym_struct] = ACTIONS(4482),
    [sym_switch] = ACTIONS(4482),
    [sym_synchronized] = ACTIONS(4482),
    [sym_template] = ACTIONS(4482),
    [sym_throw] = ACTIONS(4482),
    [sym_try] = ACTIONS(4482),
    [sym_typeid] = ACTIONS(4482),
    [sym_typeof] = ACTIONS(4482),
    [sym_union] = ACTIONS(4482),
    [sym_unittest] = ACTIONS(4482),
    [sym_version] = ACTIONS(4482),
    [sym_while] = ACTIONS(4482),
    [sym_with] = ACTIONS(4482),
    [sym_gshared] = ACTIONS(4482),
    [sym_traits] = ACTIONS(4482),
    [sym_vector] = ACTIONS(4482),
    [sym_void] = ACTIONS(4482),
    [anon_sym_BQUOTE] = ACTIONS(4484),
    [anon_sym_r_DQUOTE] = ACTIONS(4484),
    [anon_sym_x_DQUOTE] = ACTIONS(4484),
    [anon_sym_DQUOTE] = ACTIONS(4484),
    [anon_sym_i_BQUOTE] = ACTIONS(4484),
    [anon_sym_i_DQUOTE] = ACTIONS(4484),
    [anon_sym_iq_LBRACE] = ACTIONS(4484),
    [aux_sym_char_literal_token1] = ACTIONS(4484),
    [anon_sym_SQUOTE] = ACTIONS(4482),
    [anon_sym___DATE__] = ACTIONS(4482),
    [anon_sym___FILE__] = ACTIONS(4482),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4482),
    [anon_sym___FUNCTION__] = ACTIONS(4482),
    [anon_sym___LINE__] = ACTIONS(4482),
    [anon_sym___MODULE__] = ACTIONS(4482),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4482),
    [anon_sym___TIME__] = ACTIONS(4482),
    [anon_sym___TIMESTAMP__] = ACTIONS(4482),
    [anon_sym___VENDOR__] = ACTIONS(4482),
    [anon_sym___VERSION__] = ACTIONS(4482),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4484),
    [sym_float_literal] = ACTIONS(4484),
    [sym__string] = ACTIONS(4484),
  },
  [1377] = {
    [sym_identifier] = ACTIONS(4486),
    [anon_sym_q_LBRACE] = ACTIONS(4488),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [anon_sym_LBRACE] = ACTIONS(4488),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4488),
    [anon_sym_PLUS] = ACTIONS(4486),
    [anon_sym_PLUS_PLUS] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_LPAREN] = ACTIONS(4488),
    [anon_sym_RPAREN] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4488),
    [anon_sym_DOLLAR] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4488),
    [anon_sym_AT] = ACTIONS(4488),
    [sym_bool] = ACTIONS(4486),
    [sym_byte] = ACTIONS(4486),
    [sym_ubyte] = ACTIONS(4486),
    [sym_char] = ACTIONS(4486),
    [sym_short] = ACTIONS(4486),
    [sym_ushort] = ACTIONS(4486),
    [sym_int] = ACTIONS(4486),
    [sym_uint] = ACTIONS(4486),
    [sym_long] = ACTIONS(4486),
    [sym_ulong] = ACTIONS(4486),
    [sym_cent] = ACTIONS(4486),
    [sym_ucent] = ACTIONS(4486),
    [sym_wchar] = ACTIONS(4486),
    [sym_dchar] = ACTIONS(4486),
    [sym_float] = ACTIONS(4486),
    [sym_double] = ACTIONS(4486),
    [sym_real] = ACTIONS(4486),
    [sym_ifloat] = ACTIONS(4486),
    [sym_idouble] = ACTIONS(4486),
    [sym_ireal] = ACTIONS(4486),
    [sym_cfloat] = ACTIONS(4486),
    [sym_cdouble] = ACTIONS(4486),
    [sym_creal] = ACTIONS(4486),
    [sym_size_t] = ACTIONS(4486),
    [sym_ptrdiff_t] = ACTIONS(4486),
    [sym_string] = ACTIONS(4486),
    [sym_cstring] = ACTIONS(4486),
    [sym_dstring] = ACTIONS(4486),
    [sym_wstring] = ACTIONS(4486),
    [sym_noreturn] = ACTIONS(4486),
    [sym_true] = ACTIONS(4486),
    [sym_false] = ACTIONS(4486),
    [sym_null] = ACTIONS(4486),
    [sym_super] = ACTIONS(4486),
    [sym_this] = ACTIONS(4486),
    [sym_abstract] = ACTIONS(4486),
    [sym_alias] = ACTIONS(4486),
    [sym_align] = ACTIONS(4486),
    [sym_asm] = ACTIONS(4486),
    [sym_assert] = ACTIONS(4486),
    [sym_auto] = ACTIONS(4486),
    [sym_break] = ACTIONS(4486),
    [sym_case] = ACTIONS(4486),
    [sym_cast] = ACTIONS(4486),
    [sym_catch] = ACTIONS(4486),
    [sym_class] = ACTIONS(4486),
    [sym_const] = ACTIONS(4486),
    [sym_continue] = ACTIONS(4486),
    [sym_debug] = ACTIONS(4486),
    [sym_default] = ACTIONS(4486),
    [sym_delegate] = ACTIONS(4486),
    [sym_delete] = ACTIONS(4486),
    [sym_deprecated] = ACTIONS(4486),
    [sym_do] = ACTIONS(4486),
    [sym_else] = ACTIONS(4486),
    [sym_enum] = ACTIONS(4486),
    [sym_export] = ACTIONS(4486),
    [sym_extern] = ACTIONS(4486),
    [sym_final] = ACTIONS(4486),
    [sym_finally] = ACTIONS(4486),
    [sym_for] = ACTIONS(4486),
    [sym_foreach] = ACTIONS(4486),
    [sym_foreach_reverse] = ACTIONS(4486),
    [sym_function] = ACTIONS(4486),
    [sym_goto] = ACTIONS(4486),
    [sym_if] = ACTIONS(4486),
    [sym_immutable] = ACTIONS(4486),
    [sym_import] = ACTIONS(4486),
    [sym_in] = ACTIONS(4486),
    [sym_inout] = ACTIONS(4486),
    [sym_interface] = ACTIONS(4486),
    [sym_invariant] = ACTIONS(4486),
    [sym_is] = ACTIONS(4486),
    [sym_mixin] = ACTIONS(4486),
    [sym_new] = ACTIONS(4486),
    [sym_nothrow] = ACTIONS(4486),
    [sym_out] = ACTIONS(4486),
    [sym_override] = ACTIONS(4486),
    [sym_package] = ACTIONS(4486),
    [sym_pragma] = ACTIONS(4486),
    [sym_private] = ACTIONS(4486),
    [sym_protected] = ACTIONS(4486),
    [sym_public] = ACTIONS(4486),
    [sym_pure] = ACTIONS(4486),
    [sym_ref] = ACTIONS(4486),
    [sym_return] = ACTIONS(4486),
    [sym_scope] = ACTIONS(4486),
    [sym_shared] = ACTIONS(4486),
    [sym_static] = ACTIONS(4486),
    [sym_struct] = ACTIONS(4486),
    [sym_switch] = ACTIONS(4486),
    [sym_synchronized] = ACTIONS(4486),
    [sym_template] = ACTIONS(4486),
    [sym_throw] = ACTIONS(4486),
    [sym_try] = ACTIONS(4486),
    [sym_typeid] = ACTIONS(4486),
    [sym_typeof] = ACTIONS(4486),
    [sym_union] = ACTIONS(4486),
    [sym_unittest] = ACTIONS(4486),
    [sym_version] = ACTIONS(4486),
    [sym_while] = ACTIONS(4486),
    [sym_with] = ACTIONS(4486),
    [sym_gshared] = ACTIONS(4486),
    [sym_traits] = ACTIONS(4486),
    [sym_vector] = ACTIONS(4486),
    [sym_void] = ACTIONS(4486),
    [anon_sym_BQUOTE] = ACTIONS(4488),
    [anon_sym_r_DQUOTE] = ACTIONS(4488),
    [anon_sym_x_DQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE] = ACTIONS(4488),
    [anon_sym_i_BQUOTE] = ACTIONS(4488),
    [anon_sym_i_DQUOTE] = ACTIONS(4488),
    [anon_sym_iq_LBRACE] = ACTIONS(4488),
    [aux_sym_char_literal_token1] = ACTIONS(4488),
    [anon_sym_SQUOTE] = ACTIONS(4486),
    [anon_sym___DATE__] = ACTIONS(4486),
    [anon_sym___FILE__] = ACTIONS(4486),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4486),
    [anon_sym___FUNCTION__] = ACTIONS(4486),
    [anon_sym___LINE__] = ACTIONS(4486),
    [anon_sym___MODULE__] = ACTIONS(4486),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4486),
    [anon_sym___TIME__] = ACTIONS(4486),
    [anon_sym___TIMESTAMP__] = ACTIONS(4486),
    [anon_sym___VENDOR__] = ACTIONS(4486),
    [anon_sym___VERSION__] = ACTIONS(4486),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4488),
    [sym_float_literal] = ACTIONS(4488),
    [sym__string] = ACTIONS(4488),
  },
  [1378] = {
    [sym_identifier] = ACTIONS(4490),
    [anon_sym_q_LBRACE] = ACTIONS(4492),
    [anon_sym_RBRACE] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4492),
    [anon_sym_DOT] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4492),
    [anon_sym_DASH] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4492),
    [anon_sym_PLUS] = ACTIONS(4490),
    [anon_sym_PLUS_PLUS] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4492),
    [anon_sym_LPAREN] = ACTIONS(4492),
    [anon_sym_RPAREN] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_SEMI] = ACTIONS(4492),
    [anon_sym_DOLLAR] = ACTIONS(4492),
    [anon_sym_STAR] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4492),
    [anon_sym_AT] = ACTIONS(4492),
    [sym_bool] = ACTIONS(4490),
    [sym_byte] = ACTIONS(4490),
    [sym_ubyte] = ACTIONS(4490),
    [sym_char] = ACTIONS(4490),
    [sym_short] = ACTIONS(4490),
    [sym_ushort] = ACTIONS(4490),
    [sym_int] = ACTIONS(4490),
    [sym_uint] = ACTIONS(4490),
    [sym_long] = ACTIONS(4490),
    [sym_ulong] = ACTIONS(4490),
    [sym_cent] = ACTIONS(4490),
    [sym_ucent] = ACTIONS(4490),
    [sym_wchar] = ACTIONS(4490),
    [sym_dchar] = ACTIONS(4490),
    [sym_float] = ACTIONS(4490),
    [sym_double] = ACTIONS(4490),
    [sym_real] = ACTIONS(4490),
    [sym_ifloat] = ACTIONS(4490),
    [sym_idouble] = ACTIONS(4490),
    [sym_ireal] = ACTIONS(4490),
    [sym_cfloat] = ACTIONS(4490),
    [sym_cdouble] = ACTIONS(4490),
    [sym_creal] = ACTIONS(4490),
    [sym_size_t] = ACTIONS(4490),
    [sym_ptrdiff_t] = ACTIONS(4490),
    [sym_string] = ACTIONS(4490),
    [sym_cstring] = ACTIONS(4490),
    [sym_dstring] = ACTIONS(4490),
    [sym_wstring] = ACTIONS(4490),
    [sym_noreturn] = ACTIONS(4490),
    [sym_true] = ACTIONS(4490),
    [sym_false] = ACTIONS(4490),
    [sym_null] = ACTIONS(4490),
    [sym_super] = ACTIONS(4490),
    [sym_this] = ACTIONS(4490),
    [sym_abstract] = ACTIONS(4490),
    [sym_alias] = ACTIONS(4490),
    [sym_align] = ACTIONS(4490),
    [sym_asm] = ACTIONS(4490),
    [sym_assert] = ACTIONS(4490),
    [sym_auto] = ACTIONS(4490),
    [sym_break] = ACTIONS(4490),
    [sym_case] = ACTIONS(4490),
    [sym_cast] = ACTIONS(4490),
    [sym_catch] = ACTIONS(4490),
    [sym_class] = ACTIONS(4490),
    [sym_const] = ACTIONS(4490),
    [sym_continue] = ACTIONS(4490),
    [sym_debug] = ACTIONS(4490),
    [sym_default] = ACTIONS(4490),
    [sym_delegate] = ACTIONS(4490),
    [sym_delete] = ACTIONS(4490),
    [sym_deprecated] = ACTIONS(4490),
    [sym_do] = ACTIONS(4490),
    [sym_else] = ACTIONS(4490),
    [sym_enum] = ACTIONS(4490),
    [sym_export] = ACTIONS(4490),
    [sym_extern] = ACTIONS(4490),
    [sym_final] = ACTIONS(4490),
    [sym_finally] = ACTIONS(4490),
    [sym_for] = ACTIONS(4490),
    [sym_foreach] = ACTIONS(4490),
    [sym_foreach_reverse] = ACTIONS(4490),
    [sym_function] = ACTIONS(4490),
    [sym_goto] = ACTIONS(4490),
    [sym_if] = ACTIONS(4490),
    [sym_immutable] = ACTIONS(4490),
    [sym_import] = ACTIONS(4490),
    [sym_in] = ACTIONS(4490),
    [sym_inout] = ACTIONS(4490),
    [sym_interface] = ACTIONS(4490),
    [sym_invariant] = ACTIONS(4490),
    [sym_is] = ACTIONS(4490),
    [sym_mixin] = ACTIONS(4490),
    [sym_new] = ACTIONS(4490),
    [sym_nothrow] = ACTIONS(4490),
    [sym_out] = ACTIONS(4490),
    [sym_override] = ACTIONS(4490),
    [sym_package] = ACTIONS(4490),
    [sym_pragma] = ACTIONS(4490),
    [sym_private] = ACTIONS(4490),
    [sym_protected] = ACTIONS(4490),
    [sym_public] = ACTIONS(4490),
    [sym_pure] = ACTIONS(4490),
    [sym_ref] = ACTIONS(4490),
    [sym_return] = ACTIONS(4490),
    [sym_scope] = ACTIONS(4490),
    [sym_shared] = ACTIONS(4490),
    [sym_static] = ACTIONS(4490),
    [sym_struct] = ACTIONS(4490),
    [sym_switch] = ACTIONS(4490),
    [sym_synchronized] = ACTIONS(4490),
    [sym_template] = ACTIONS(4490),
    [sym_throw] = ACTIONS(4490),
    [sym_try] = ACTIONS(4490),
    [sym_typeid] = ACTIONS(4490),
    [sym_typeof] = ACTIONS(4490),
    [sym_union] = ACTIONS(4490),
    [sym_unittest] = ACTIONS(4490),
    [sym_version] = ACTIONS(4490),
    [sym_while] = ACTIONS(4490),
    [sym_with] = ACTIONS(4490),
    [sym_gshared] = ACTIONS(4490),
    [sym_traits] = ACTIONS(4490),
    [sym_vector] = ACTIONS(4490),
    [sym_void] = ACTIONS(4490),
    [anon_sym_BQUOTE] = ACTIONS(4492),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_x_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE] = ACTIONS(4492),
    [anon_sym_i_BQUOTE] = ACTIONS(4492),
    [anon_sym_i_DQUOTE] = ACTIONS(4492),
    [anon_sym_iq_LBRACE] = ACTIONS(4492),
    [aux_sym_char_literal_token1] = ACTIONS(4492),
    [anon_sym_SQUOTE] = ACTIONS(4490),
    [anon_sym___DATE__] = ACTIONS(4490),
    [anon_sym___FILE__] = ACTIONS(4490),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4490),
    [anon_sym___FUNCTION__] = ACTIONS(4490),
    [anon_sym___LINE__] = ACTIONS(4490),
    [anon_sym___MODULE__] = ACTIONS(4490),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4490),
    [anon_sym___TIME__] = ACTIONS(4490),
    [anon_sym___TIMESTAMP__] = ACTIONS(4490),
    [anon_sym___VENDOR__] = ACTIONS(4490),
    [anon_sym___VERSION__] = ACTIONS(4490),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4492),
    [sym_float_literal] = ACTIONS(4492),
    [sym__string] = ACTIONS(4492),
  },
  [1379] = {
    [sym_identifier] = ACTIONS(4494),
    [anon_sym_q_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AT] = ACTIONS(4496),
    [sym_bool] = ACTIONS(4494),
    [sym_byte] = ACTIONS(4494),
    [sym_ubyte] = ACTIONS(4494),
    [sym_char] = ACTIONS(4494),
    [sym_short] = ACTIONS(4494),
    [sym_ushort] = ACTIONS(4494),
    [sym_int] = ACTIONS(4494),
    [sym_uint] = ACTIONS(4494),
    [sym_long] = ACTIONS(4494),
    [sym_ulong] = ACTIONS(4494),
    [sym_cent] = ACTIONS(4494),
    [sym_ucent] = ACTIONS(4494),
    [sym_wchar] = ACTIONS(4494),
    [sym_dchar] = ACTIONS(4494),
    [sym_float] = ACTIONS(4494),
    [sym_double] = ACTIONS(4494),
    [sym_real] = ACTIONS(4494),
    [sym_ifloat] = ACTIONS(4494),
    [sym_idouble] = ACTIONS(4494),
    [sym_ireal] = ACTIONS(4494),
    [sym_cfloat] = ACTIONS(4494),
    [sym_cdouble] = ACTIONS(4494),
    [sym_creal] = ACTIONS(4494),
    [sym_size_t] = ACTIONS(4494),
    [sym_ptrdiff_t] = ACTIONS(4494),
    [sym_string] = ACTIONS(4494),
    [sym_cstring] = ACTIONS(4494),
    [sym_dstring] = ACTIONS(4494),
    [sym_wstring] = ACTIONS(4494),
    [sym_noreturn] = ACTIONS(4494),
    [sym_true] = ACTIONS(4494),
    [sym_false] = ACTIONS(4494),
    [sym_null] = ACTIONS(4494),
    [sym_super] = ACTIONS(4494),
    [sym_this] = ACTIONS(4494),
    [sym_abstract] = ACTIONS(4494),
    [sym_alias] = ACTIONS(4494),
    [sym_align] = ACTIONS(4494),
    [sym_asm] = ACTIONS(4494),
    [sym_assert] = ACTIONS(4494),
    [sym_auto] = ACTIONS(4494),
    [sym_break] = ACTIONS(4494),
    [sym_case] = ACTIONS(4494),
    [sym_cast] = ACTIONS(4494),
    [sym_catch] = ACTIONS(4494),
    [sym_class] = ACTIONS(4494),
    [sym_const] = ACTIONS(4494),
    [sym_continue] = ACTIONS(4494),
    [sym_debug] = ACTIONS(4494),
    [sym_default] = ACTIONS(4494),
    [sym_delegate] = ACTIONS(4494),
    [sym_delete] = ACTIONS(4494),
    [sym_deprecated] = ACTIONS(4494),
    [sym_do] = ACTIONS(4494),
    [sym_else] = ACTIONS(4494),
    [sym_enum] = ACTIONS(4494),
    [sym_export] = ACTIONS(4494),
    [sym_extern] = ACTIONS(4494),
    [sym_final] = ACTIONS(4494),
    [sym_finally] = ACTIONS(4494),
    [sym_for] = ACTIONS(4494),
    [sym_foreach] = ACTIONS(4494),
    [sym_foreach_reverse] = ACTIONS(4494),
    [sym_function] = ACTIONS(4494),
    [sym_goto] = ACTIONS(4494),
    [sym_if] = ACTIONS(4494),
    [sym_immutable] = ACTIONS(4494),
    [sym_import] = ACTIONS(4494),
    [sym_in] = ACTIONS(4494),
    [sym_inout] = ACTIONS(4494),
    [sym_interface] = ACTIONS(4494),
    [sym_invariant] = ACTIONS(4494),
    [sym_is] = ACTIONS(4494),
    [sym_mixin] = ACTIONS(4494),
    [sym_new] = ACTIONS(4494),
    [sym_nothrow] = ACTIONS(4494),
    [sym_out] = ACTIONS(4494),
    [sym_override] = ACTIONS(4494),
    [sym_package] = ACTIONS(4494),
    [sym_pragma] = ACTIONS(4494),
    [sym_private] = ACTIONS(4494),
    [sym_protected] = ACTIONS(4494),
    [sym_public] = ACTIONS(4494),
    [sym_pure] = ACTIONS(4494),
    [sym_ref] = ACTIONS(4494),
    [sym_return] = ACTIONS(4494),
    [sym_scope] = ACTIONS(4494),
    [sym_shared] = ACTIONS(4494),
    [sym_static] = ACTIONS(4494),
    [sym_struct] = ACTIONS(4494),
    [sym_switch] = ACTIONS(4494),
    [sym_synchronized] = ACTIONS(4494),
    [sym_template] = ACTIONS(4494),
    [sym_throw] = ACTIONS(4494),
    [sym_try] = ACTIONS(4494),
    [sym_typeid] = ACTIONS(4494),
    [sym_typeof] = ACTIONS(4494),
    [sym_union] = ACTIONS(4494),
    [sym_unittest] = ACTIONS(4494),
    [sym_version] = ACTIONS(4494),
    [sym_while] = ACTIONS(4494),
    [sym_with] = ACTIONS(4494),
    [sym_gshared] = ACTIONS(4494),
    [sym_traits] = ACTIONS(4494),
    [sym_vector] = ACTIONS(4494),
    [sym_void] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [anon_sym_r_DQUOTE] = ACTIONS(4496),
    [anon_sym_x_DQUOTE] = ACTIONS(4496),
    [anon_sym_DQUOTE] = ACTIONS(4496),
    [anon_sym_i_BQUOTE] = ACTIONS(4496),
    [anon_sym_i_DQUOTE] = ACTIONS(4496),
    [anon_sym_iq_LBRACE] = ACTIONS(4496),
    [aux_sym_char_literal_token1] = ACTIONS(4496),
    [anon_sym_SQUOTE] = ACTIONS(4494),
    [anon_sym___DATE__] = ACTIONS(4494),
    [anon_sym___FILE__] = ACTIONS(4494),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4494),
    [anon_sym___FUNCTION__] = ACTIONS(4494),
    [anon_sym___LINE__] = ACTIONS(4494),
    [anon_sym___MODULE__] = ACTIONS(4494),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4494),
    [anon_sym___TIME__] = ACTIONS(4494),
    [anon_sym___TIMESTAMP__] = ACTIONS(4494),
    [anon_sym___VENDOR__] = ACTIONS(4494),
    [anon_sym___VERSION__] = ACTIONS(4494),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4496),
    [sym_float_literal] = ACTIONS(4496),
    [sym__string] = ACTIONS(4496),
  },
  [1380] = {
    [sym_identifier] = ACTIONS(4498),
    [anon_sym_q_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4500),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_BANG] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_DOLLAR] = ACTIONS(4500),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4500),
    [anon_sym_AT] = ACTIONS(4500),
    [sym_bool] = ACTIONS(4498),
    [sym_byte] = ACTIONS(4498),
    [sym_ubyte] = ACTIONS(4498),
    [sym_char] = ACTIONS(4498),
    [sym_short] = ACTIONS(4498),
    [sym_ushort] = ACTIONS(4498),
    [sym_int] = ACTIONS(4498),
    [sym_uint] = ACTIONS(4498),
    [sym_long] = ACTIONS(4498),
    [sym_ulong] = ACTIONS(4498),
    [sym_cent] = ACTIONS(4498),
    [sym_ucent] = ACTIONS(4498),
    [sym_wchar] = ACTIONS(4498),
    [sym_dchar] = ACTIONS(4498),
    [sym_float] = ACTIONS(4498),
    [sym_double] = ACTIONS(4498),
    [sym_real] = ACTIONS(4498),
    [sym_ifloat] = ACTIONS(4498),
    [sym_idouble] = ACTIONS(4498),
    [sym_ireal] = ACTIONS(4498),
    [sym_cfloat] = ACTIONS(4498),
    [sym_cdouble] = ACTIONS(4498),
    [sym_creal] = ACTIONS(4498),
    [sym_size_t] = ACTIONS(4498),
    [sym_ptrdiff_t] = ACTIONS(4498),
    [sym_string] = ACTIONS(4498),
    [sym_cstring] = ACTIONS(4498),
    [sym_dstring] = ACTIONS(4498),
    [sym_wstring] = ACTIONS(4498),
    [sym_noreturn] = ACTIONS(4498),
    [sym_true] = ACTIONS(4498),
    [sym_false] = ACTIONS(4498),
    [sym_null] = ACTIONS(4498),
    [sym_super] = ACTIONS(4498),
    [sym_this] = ACTIONS(4498),
    [sym_abstract] = ACTIONS(4498),
    [sym_alias] = ACTIONS(4498),
    [sym_align] = ACTIONS(4498),
    [sym_asm] = ACTIONS(4498),
    [sym_assert] = ACTIONS(4498),
    [sym_auto] = ACTIONS(4498),
    [sym_break] = ACTIONS(4498),
    [sym_case] = ACTIONS(4498),
    [sym_cast] = ACTIONS(4498),
    [sym_catch] = ACTIONS(4498),
    [sym_class] = ACTIONS(4498),
    [sym_const] = ACTIONS(4498),
    [sym_continue] = ACTIONS(4498),
    [sym_debug] = ACTIONS(4498),
    [sym_default] = ACTIONS(4498),
    [sym_delegate] = ACTIONS(4498),
    [sym_delete] = ACTIONS(4498),
    [sym_deprecated] = ACTIONS(4498),
    [sym_do] = ACTIONS(4498),
    [sym_else] = ACTIONS(4498),
    [sym_enum] = ACTIONS(4498),
    [sym_export] = ACTIONS(4498),
    [sym_extern] = ACTIONS(4498),
    [sym_final] = ACTIONS(4498),
    [sym_finally] = ACTIONS(4498),
    [sym_for] = ACTIONS(4498),
    [sym_foreach] = ACTIONS(4498),
    [sym_foreach_reverse] = ACTIONS(4498),
    [sym_function] = ACTIONS(4498),
    [sym_goto] = ACTIONS(4498),
    [sym_if] = ACTIONS(4498),
    [sym_immutable] = ACTIONS(4498),
    [sym_import] = ACTIONS(4498),
    [sym_in] = ACTIONS(4498),
    [sym_inout] = ACTIONS(4498),
    [sym_interface] = ACTIONS(4498),
    [sym_invariant] = ACTIONS(4498),
    [sym_is] = ACTIONS(4498),
    [sym_mixin] = ACTIONS(4498),
    [sym_new] = ACTIONS(4498),
    [sym_nothrow] = ACTIONS(4498),
    [sym_out] = ACTIONS(4498),
    [sym_override] = ACTIONS(4498),
    [sym_package] = ACTIONS(4498),
    [sym_pragma] = ACTIONS(4498),
    [sym_private] = ACTIONS(4498),
    [sym_protected] = ACTIONS(4498),
    [sym_public] = ACTIONS(4498),
    [sym_pure] = ACTIONS(4498),
    [sym_ref] = ACTIONS(4498),
    [sym_return] = ACTIONS(4498),
    [sym_scope] = ACTIONS(4498),
    [sym_shared] = ACTIONS(4498),
    [sym_static] = ACTIONS(4498),
    [sym_struct] = ACTIONS(4498),
    [sym_switch] = ACTIONS(4498),
    [sym_synchronized] = ACTIONS(4498),
    [sym_template] = ACTIONS(4498),
    [sym_throw] = ACTIONS(4498),
    [sym_try] = ACTIONS(4498),
    [sym_typeid] = ACTIONS(4498),
    [sym_typeof] = ACTIONS(4498),
    [sym_union] = ACTIONS(4498),
    [sym_unittest] = ACTIONS(4498),
    [sym_version] = ACTIONS(4498),
    [sym_while] = ACTIONS(4498),
    [sym_with] = ACTIONS(4498),
    [sym_gshared] = ACTIONS(4498),
    [sym_traits] = ACTIONS(4498),
    [sym_vector] = ACTIONS(4498),
    [sym_void] = ACTIONS(4498),
    [anon_sym_BQUOTE] = ACTIONS(4500),
    [anon_sym_r_DQUOTE] = ACTIONS(4500),
    [anon_sym_x_DQUOTE] = ACTIONS(4500),
    [anon_sym_DQUOTE] = ACTIONS(4500),
    [anon_sym_i_BQUOTE] = ACTIONS(4500),
    [anon_sym_i_DQUOTE] = ACTIONS(4500),
    [anon_sym_iq_LBRACE] = ACTIONS(4500),
    [aux_sym_char_literal_token1] = ACTIONS(4500),
    [anon_sym_SQUOTE] = ACTIONS(4498),
    [anon_sym___DATE__] = ACTIONS(4498),
    [anon_sym___FILE__] = ACTIONS(4498),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4498),
    [anon_sym___FUNCTION__] = ACTIONS(4498),
    [anon_sym___LINE__] = ACTIONS(4498),
    [anon_sym___MODULE__] = ACTIONS(4498),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4498),
    [anon_sym___TIME__] = ACTIONS(4498),
    [anon_sym___TIMESTAMP__] = ACTIONS(4498),
    [anon_sym___VENDOR__] = ACTIONS(4498),
    [anon_sym___VERSION__] = ACTIONS(4498),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4500),
    [sym_float_literal] = ACTIONS(4500),
    [sym__string] = ACTIONS(4500),
  },
  [1381] = {
    [sym_identifier] = ACTIONS(4502),
    [anon_sym_q_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4504),
    [anon_sym_AMP] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_BANG] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_DOLLAR] = ACTIONS(4504),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4504),
    [anon_sym_AT] = ACTIONS(4504),
    [sym_bool] = ACTIONS(4502),
    [sym_byte] = ACTIONS(4502),
    [sym_ubyte] = ACTIONS(4502),
    [sym_char] = ACTIONS(4502),
    [sym_short] = ACTIONS(4502),
    [sym_ushort] = ACTIONS(4502),
    [sym_int] = ACTIONS(4502),
    [sym_uint] = ACTIONS(4502),
    [sym_long] = ACTIONS(4502),
    [sym_ulong] = ACTIONS(4502),
    [sym_cent] = ACTIONS(4502),
    [sym_ucent] = ACTIONS(4502),
    [sym_wchar] = ACTIONS(4502),
    [sym_dchar] = ACTIONS(4502),
    [sym_float] = ACTIONS(4502),
    [sym_double] = ACTIONS(4502),
    [sym_real] = ACTIONS(4502),
    [sym_ifloat] = ACTIONS(4502),
    [sym_idouble] = ACTIONS(4502),
    [sym_ireal] = ACTIONS(4502),
    [sym_cfloat] = ACTIONS(4502),
    [sym_cdouble] = ACTIONS(4502),
    [sym_creal] = ACTIONS(4502),
    [sym_size_t] = ACTIONS(4502),
    [sym_ptrdiff_t] = ACTIONS(4502),
    [sym_string] = ACTIONS(4502),
    [sym_cstring] = ACTIONS(4502),
    [sym_dstring] = ACTIONS(4502),
    [sym_wstring] = ACTIONS(4502),
    [sym_noreturn] = ACTIONS(4502),
    [sym_true] = ACTIONS(4502),
    [sym_false] = ACTIONS(4502),
    [sym_null] = ACTIONS(4502),
    [sym_super] = ACTIONS(4502),
    [sym_this] = ACTIONS(4502),
    [sym_abstract] = ACTIONS(4502),
    [sym_alias] = ACTIONS(4502),
    [sym_align] = ACTIONS(4502),
    [sym_asm] = ACTIONS(4502),
    [sym_assert] = ACTIONS(4502),
    [sym_auto] = ACTIONS(4502),
    [sym_break] = ACTIONS(4502),
    [sym_case] = ACTIONS(4502),
    [sym_cast] = ACTIONS(4502),
    [sym_catch] = ACTIONS(4502),
    [sym_class] = ACTIONS(4502),
    [sym_const] = ACTIONS(4502),
    [sym_continue] = ACTIONS(4502),
    [sym_debug] = ACTIONS(4502),
    [sym_default] = ACTIONS(4502),
    [sym_delegate] = ACTIONS(4502),
    [sym_delete] = ACTIONS(4502),
    [sym_deprecated] = ACTIONS(4502),
    [sym_do] = ACTIONS(4502),
    [sym_else] = ACTIONS(4502),
    [sym_enum] = ACTIONS(4502),
    [sym_export] = ACTIONS(4502),
    [sym_extern] = ACTIONS(4502),
    [sym_final] = ACTIONS(4502),
    [sym_finally] = ACTIONS(4502),
    [sym_for] = ACTIONS(4502),
    [sym_foreach] = ACTIONS(4502),
    [sym_foreach_reverse] = ACTIONS(4502),
    [sym_function] = ACTIONS(4502),
    [sym_goto] = ACTIONS(4502),
    [sym_if] = ACTIONS(4502),
    [sym_immutable] = ACTIONS(4502),
    [sym_import] = ACTIONS(4502),
    [sym_in] = ACTIONS(4502),
    [sym_inout] = ACTIONS(4502),
    [sym_interface] = ACTIONS(4502),
    [sym_invariant] = ACTIONS(4502),
    [sym_is] = ACTIONS(4502),
    [sym_mixin] = ACTIONS(4502),
    [sym_new] = ACTIONS(4502),
    [sym_nothrow] = ACTIONS(4502),
    [sym_out] = ACTIONS(4502),
    [sym_override] = ACTIONS(4502),
    [sym_package] = ACTIONS(4502),
    [sym_pragma] = ACTIONS(4502),
    [sym_private] = ACTIONS(4502),
    [sym_protected] = ACTIONS(4502),
    [sym_public] = ACTIONS(4502),
    [sym_pure] = ACTIONS(4502),
    [sym_ref] = ACTIONS(4502),
    [sym_return] = ACTIONS(4502),
    [sym_scope] = ACTIONS(4502),
    [sym_shared] = ACTIONS(4502),
    [sym_static] = ACTIONS(4502),
    [sym_struct] = ACTIONS(4502),
    [sym_switch] = ACTIONS(4502),
    [sym_synchronized] = ACTIONS(4502),
    [sym_template] = ACTIONS(4502),
    [sym_throw] = ACTIONS(4502),
    [sym_try] = ACTIONS(4502),
    [sym_typeid] = ACTIONS(4502),
    [sym_typeof] = ACTIONS(4502),
    [sym_union] = ACTIONS(4502),
    [sym_unittest] = ACTIONS(4502),
    [sym_version] = ACTIONS(4502),
    [sym_while] = ACTIONS(4502),
    [sym_with] = ACTIONS(4502),
    [sym_gshared] = ACTIONS(4502),
    [sym_traits] = ACTIONS(4502),
    [sym_vector] = ACTIONS(4502),
    [sym_void] = ACTIONS(4502),
    [anon_sym_BQUOTE] = ACTIONS(4504),
    [anon_sym_r_DQUOTE] = ACTIONS(4504),
    [anon_sym_x_DQUOTE] = ACTIONS(4504),
    [anon_sym_DQUOTE] = ACTIONS(4504),
    [anon_sym_i_BQUOTE] = ACTIONS(4504),
    [anon_sym_i_DQUOTE] = ACTIONS(4504),
    [anon_sym_iq_LBRACE] = ACTIONS(4504),
    [aux_sym_char_literal_token1] = ACTIONS(4504),
    [anon_sym_SQUOTE] = ACTIONS(4502),
    [anon_sym___DATE__] = ACTIONS(4502),
    [anon_sym___FILE__] = ACTIONS(4502),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4502),
    [anon_sym___FUNCTION__] = ACTIONS(4502),
    [anon_sym___LINE__] = ACTIONS(4502),
    [anon_sym___MODULE__] = ACTIONS(4502),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4502),
    [anon_sym___TIME__] = ACTIONS(4502),
    [anon_sym___TIMESTAMP__] = ACTIONS(4502),
    [anon_sym___VENDOR__] = ACTIONS(4502),
    [anon_sym___VERSION__] = ACTIONS(4502),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4504),
    [sym_float_literal] = ACTIONS(4504),
    [sym__string] = ACTIONS(4504),
  },
  [1382] = {
    [sym_identifier] = ACTIONS(4506),
    [anon_sym_q_LBRACE] = ACTIONS(4508),
    [anon_sym_RBRACE] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(4508),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_AMP] = ACTIONS(4508),
    [anon_sym_DASH] = ACTIONS(4506),
    [anon_sym_DASH_DASH] = ACTIONS(4508),
    [anon_sym_PLUS] = ACTIONS(4506),
    [anon_sym_PLUS_PLUS] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(4508),
    [anon_sym_LPAREN] = ACTIONS(4508),
    [anon_sym_RPAREN] = ACTIONS(4508),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_SEMI] = ACTIONS(4508),
    [anon_sym_DOLLAR] = ACTIONS(4508),
    [anon_sym_STAR] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4508),
    [anon_sym_AT] = ACTIONS(4508),
    [sym_bool] = ACTIONS(4506),
    [sym_byte] = ACTIONS(4506),
    [sym_ubyte] = ACTIONS(4506),
    [sym_char] = ACTIONS(4506),
    [sym_short] = ACTIONS(4506),
    [sym_ushort] = ACTIONS(4506),
    [sym_int] = ACTIONS(4506),
    [sym_uint] = ACTIONS(4506),
    [sym_long] = ACTIONS(4506),
    [sym_ulong] = ACTIONS(4506),
    [sym_cent] = ACTIONS(4506),
    [sym_ucent] = ACTIONS(4506),
    [sym_wchar] = ACTIONS(4506),
    [sym_dchar] = ACTIONS(4506),
    [sym_float] = ACTIONS(4506),
    [sym_double] = ACTIONS(4506),
    [sym_real] = ACTIONS(4506),
    [sym_ifloat] = ACTIONS(4506),
    [sym_idouble] = ACTIONS(4506),
    [sym_ireal] = ACTIONS(4506),
    [sym_cfloat] = ACTIONS(4506),
    [sym_cdouble] = ACTIONS(4506),
    [sym_creal] = ACTIONS(4506),
    [sym_size_t] = ACTIONS(4506),
    [sym_ptrdiff_t] = ACTIONS(4506),
    [sym_string] = ACTIONS(4506),
    [sym_cstring] = ACTIONS(4506),
    [sym_dstring] = ACTIONS(4506),
    [sym_wstring] = ACTIONS(4506),
    [sym_noreturn] = ACTIONS(4506),
    [sym_true] = ACTIONS(4506),
    [sym_false] = ACTIONS(4506),
    [sym_null] = ACTIONS(4506),
    [sym_super] = ACTIONS(4506),
    [sym_this] = ACTIONS(4506),
    [sym_abstract] = ACTIONS(4506),
    [sym_alias] = ACTIONS(4506),
    [sym_align] = ACTIONS(4506),
    [sym_asm] = ACTIONS(4506),
    [sym_assert] = ACTIONS(4506),
    [sym_auto] = ACTIONS(4506),
    [sym_break] = ACTIONS(4506),
    [sym_case] = ACTIONS(4506),
    [sym_cast] = ACTIONS(4506),
    [sym_catch] = ACTIONS(4506),
    [sym_class] = ACTIONS(4506),
    [sym_const] = ACTIONS(4506),
    [sym_continue] = ACTIONS(4506),
    [sym_debug] = ACTIONS(4506),
    [sym_default] = ACTIONS(4506),
    [sym_delegate] = ACTIONS(4506),
    [sym_delete] = ACTIONS(4506),
    [sym_deprecated] = ACTIONS(4506),
    [sym_do] = ACTIONS(4506),
    [sym_else] = ACTIONS(4506),
    [sym_enum] = ACTIONS(4506),
    [sym_export] = ACTIONS(4506),
    [sym_extern] = ACTIONS(4506),
    [sym_final] = ACTIONS(4506),
    [sym_finally] = ACTIONS(4506),
    [sym_for] = ACTIONS(4506),
    [sym_foreach] = ACTIONS(4506),
    [sym_foreach_reverse] = ACTIONS(4506),
    [sym_function] = ACTIONS(4506),
    [sym_goto] = ACTIONS(4506),
    [sym_if] = ACTIONS(4506),
    [sym_immutable] = ACTIONS(4506),
    [sym_import] = ACTIONS(4506),
    [sym_in] = ACTIONS(4506),
    [sym_inout] = ACTIONS(4506),
    [sym_interface] = ACTIONS(4506),
    [sym_invariant] = ACTIONS(4506),
    [sym_is] = ACTIONS(4506),
    [sym_mixin] = ACTIONS(4506),
    [sym_new] = ACTIONS(4506),
    [sym_nothrow] = ACTIONS(4506),
    [sym_out] = ACTIONS(4506),
    [sym_override] = ACTIONS(4506),
    [sym_package] = ACTIONS(4506),
    [sym_pragma] = ACTIONS(4506),
    [sym_private] = ACTIONS(4506),
    [sym_protected] = ACTIONS(4506),
    [sym_public] = ACTIONS(4506),
    [sym_pure] = ACTIONS(4506),
    [sym_ref] = ACTIONS(4506),
    [sym_return] = ACTIONS(4506),
    [sym_scope] = ACTIONS(4506),
    [sym_shared] = ACTIONS(4506),
    [sym_static] = ACTIONS(4506),
    [sym_struct] = ACTIONS(4506),
    [sym_switch] = ACTIONS(4506),
    [sym_synchronized] = ACTIONS(4506),
    [sym_template] = ACTIONS(4506),
    [sym_throw] = ACTIONS(4506),
    [sym_try] = ACTIONS(4506),
    [sym_typeid] = ACTIONS(4506),
    [sym_typeof] = ACTIONS(4506),
    [sym_union] = ACTIONS(4506),
    [sym_unittest] = ACTIONS(4506),
    [sym_version] = ACTIONS(4506),
    [sym_while] = ACTIONS(4506),
    [sym_with] = ACTIONS(4506),
    [sym_gshared] = ACTIONS(4506),
    [sym_traits] = ACTIONS(4506),
    [sym_vector] = ACTIONS(4506),
    [sym_void] = ACTIONS(4506),
    [anon_sym_BQUOTE] = ACTIONS(4508),
    [anon_sym_r_DQUOTE] = ACTIONS(4508),
    [anon_sym_x_DQUOTE] = ACTIONS(4508),
    [anon_sym_DQUOTE] = ACTIONS(4508),
    [anon_sym_i_BQUOTE] = ACTIONS(4508),
    [anon_sym_i_DQUOTE] = ACTIONS(4508),
    [anon_sym_iq_LBRACE] = ACTIONS(4508),
    [aux_sym_char_literal_token1] = ACTIONS(4508),
    [anon_sym_SQUOTE] = ACTIONS(4506),
    [anon_sym___DATE__] = ACTIONS(4506),
    [anon_sym___FILE__] = ACTIONS(4506),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4506),
    [anon_sym___FUNCTION__] = ACTIONS(4506),
    [anon_sym___LINE__] = ACTIONS(4506),
    [anon_sym___MODULE__] = ACTIONS(4506),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4506),
    [anon_sym___TIME__] = ACTIONS(4506),
    [anon_sym___TIMESTAMP__] = ACTIONS(4506),
    [anon_sym___VENDOR__] = ACTIONS(4506),
    [anon_sym___VERSION__] = ACTIONS(4506),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4508),
    [sym_float_literal] = ACTIONS(4508),
    [sym__string] = ACTIONS(4508),
  },
  [1383] = {
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_q_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_DOLLAR] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(2640),
    [sym_bool] = ACTIONS(2642),
    [sym_byte] = ACTIONS(2642),
    [sym_ubyte] = ACTIONS(2642),
    [sym_char] = ACTIONS(2642),
    [sym_short] = ACTIONS(2642),
    [sym_ushort] = ACTIONS(2642),
    [sym_int] = ACTIONS(2642),
    [sym_uint] = ACTIONS(2642),
    [sym_long] = ACTIONS(2642),
    [sym_ulong] = ACTIONS(2642),
    [sym_cent] = ACTIONS(2642),
    [sym_ucent] = ACTIONS(2642),
    [sym_wchar] = ACTIONS(2642),
    [sym_dchar] = ACTIONS(2642),
    [sym_float] = ACTIONS(2642),
    [sym_double] = ACTIONS(2642),
    [sym_real] = ACTIONS(2642),
    [sym_ifloat] = ACTIONS(2642),
    [sym_idouble] = ACTIONS(2642),
    [sym_ireal] = ACTIONS(2642),
    [sym_cfloat] = ACTIONS(2642),
    [sym_cdouble] = ACTIONS(2642),
    [sym_creal] = ACTIONS(2642),
    [sym_size_t] = ACTIONS(2642),
    [sym_ptrdiff_t] = ACTIONS(2642),
    [sym_string] = ACTIONS(2642),
    [sym_cstring] = ACTIONS(2642),
    [sym_dstring] = ACTIONS(2642),
    [sym_wstring] = ACTIONS(2642),
    [sym_noreturn] = ACTIONS(2642),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_this] = ACTIONS(2642),
    [sym_abstract] = ACTIONS(2642),
    [sym_alias] = ACTIONS(2642),
    [sym_align] = ACTIONS(2642),
    [sym_asm] = ACTIONS(2642),
    [sym_assert] = ACTIONS(2642),
    [sym_auto] = ACTIONS(2642),
    [sym_break] = ACTIONS(2642),
    [sym_case] = ACTIONS(2642),
    [sym_cast] = ACTIONS(2642),
    [sym_catch] = ACTIONS(2642),
    [sym_class] = ACTIONS(2642),
    [sym_const] = ACTIONS(2642),
    [sym_continue] = ACTIONS(2642),
    [sym_debug] = ACTIONS(2642),
    [sym_default] = ACTIONS(2642),
    [sym_delegate] = ACTIONS(2642),
    [sym_delete] = ACTIONS(2642),
    [sym_deprecated] = ACTIONS(2642),
    [sym_do] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(2642),
    [sym_export] = ACTIONS(2642),
    [sym_extern] = ACTIONS(2642),
    [sym_final] = ACTIONS(2642),
    [sym_finally] = ACTIONS(2642),
    [sym_for] = ACTIONS(2642),
    [sym_foreach] = ACTIONS(2642),
    [sym_foreach_reverse] = ACTIONS(2642),
    [sym_function] = ACTIONS(2642),
    [sym_goto] = ACTIONS(2642),
    [sym_if] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(2642),
    [sym_import] = ACTIONS(2642),
    [sym_in] = ACTIONS(2642),
    [sym_inout] = ACTIONS(2642),
    [sym_interface] = ACTIONS(2642),
    [sym_invariant] = ACTIONS(2642),
    [sym_is] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2642),
    [sym_new] = ACTIONS(2642),
    [sym_nothrow] = ACTIONS(2642),
    [sym_out] = ACTIONS(2642),
    [sym_override] = ACTIONS(2642),
    [sym_package] = ACTIONS(2642),
    [sym_pragma] = ACTIONS(2642),
    [sym_private] = ACTIONS(2642),
    [sym_protected] = ACTIONS(2642),
    [sym_public] = ACTIONS(2642),
    [sym_pure] = ACTIONS(2642),
    [sym_ref] = ACTIONS(2642),
    [sym_return] = ACTIONS(2642),
    [sym_scope] = ACTIONS(2642),
    [sym_shared] = ACTIONS(2642),
    [sym_static] = ACTIONS(2642),
    [sym_struct] = ACTIONS(2642),
    [sym_switch] = ACTIONS(2642),
    [sym_synchronized] = ACTIONS(2642),
    [sym_template] = ACTIONS(2642),
    [sym_throw] = ACTIONS(2642),
    [sym_try] = ACTIONS(2642),
    [sym_typeid] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(2642),
    [sym_union] = ACTIONS(2642),
    [sym_unittest] = ACTIONS(2642),
    [sym_version] = ACTIONS(2642),
    [sym_while] = ACTIONS(2642),
    [sym_with] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(2642),
    [sym_traits] = ACTIONS(2642),
    [sym_vector] = ACTIONS(2642),
    [sym_void] = ACTIONS(2642),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [anon_sym_r_DQUOTE] = ACTIONS(2640),
    [anon_sym_x_DQUOTE] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_i_BQUOTE] = ACTIONS(2640),
    [anon_sym_i_DQUOTE] = ACTIONS(2640),
    [anon_sym_iq_LBRACE] = ACTIONS(2640),
    [aux_sym_char_literal_token1] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym___DATE__] = ACTIONS(2642),
    [anon_sym___FILE__] = ACTIONS(2642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2642),
    [anon_sym___FUNCTION__] = ACTIONS(2642),
    [anon_sym___LINE__] = ACTIONS(2642),
    [anon_sym___MODULE__] = ACTIONS(2642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2642),
    [anon_sym___TIME__] = ACTIONS(2642),
    [anon_sym___TIMESTAMP__] = ACTIONS(2642),
    [anon_sym___VENDOR__] = ACTIONS(2642),
    [anon_sym___VERSION__] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2640),
    [sym_float_literal] = ACTIONS(2640),
    [sym__string] = ACTIONS(2640),
  },
  [1384] = {
    [sym_identifier] = ACTIONS(4510),
    [anon_sym_q_LBRACE] = ACTIONS(4512),
    [anon_sym_RBRACE] = ACTIONS(4512),
    [anon_sym_LBRACE] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4512),
    [anon_sym_DASH] = ACTIONS(4510),
    [anon_sym_DASH_DASH] = ACTIONS(4512),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_PLUS_PLUS] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4512),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_SEMI] = ACTIONS(4512),
    [anon_sym_DOLLAR] = ACTIONS(4512),
    [anon_sym_STAR] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4512),
    [anon_sym_AT] = ACTIONS(4512),
    [sym_bool] = ACTIONS(4510),
    [sym_byte] = ACTIONS(4510),
    [sym_ubyte] = ACTIONS(4510),
    [sym_char] = ACTIONS(4510),
    [sym_short] = ACTIONS(4510),
    [sym_ushort] = ACTIONS(4510),
    [sym_int] = ACTIONS(4510),
    [sym_uint] = ACTIONS(4510),
    [sym_long] = ACTIONS(4510),
    [sym_ulong] = ACTIONS(4510),
    [sym_cent] = ACTIONS(4510),
    [sym_ucent] = ACTIONS(4510),
    [sym_wchar] = ACTIONS(4510),
    [sym_dchar] = ACTIONS(4510),
    [sym_float] = ACTIONS(4510),
    [sym_double] = ACTIONS(4510),
    [sym_real] = ACTIONS(4510),
    [sym_ifloat] = ACTIONS(4510),
    [sym_idouble] = ACTIONS(4510),
    [sym_ireal] = ACTIONS(4510),
    [sym_cfloat] = ACTIONS(4510),
    [sym_cdouble] = ACTIONS(4510),
    [sym_creal] = ACTIONS(4510),
    [sym_size_t] = ACTIONS(4510),
    [sym_ptrdiff_t] = ACTIONS(4510),
    [sym_string] = ACTIONS(4510),
    [sym_cstring] = ACTIONS(4510),
    [sym_dstring] = ACTIONS(4510),
    [sym_wstring] = ACTIONS(4510),
    [sym_noreturn] = ACTIONS(4510),
    [sym_true] = ACTIONS(4510),
    [sym_false] = ACTIONS(4510),
    [sym_null] = ACTIONS(4510),
    [sym_super] = ACTIONS(4510),
    [sym_this] = ACTIONS(4510),
    [sym_abstract] = ACTIONS(4510),
    [sym_alias] = ACTIONS(4510),
    [sym_align] = ACTIONS(4510),
    [sym_asm] = ACTIONS(4510),
    [sym_assert] = ACTIONS(4510),
    [sym_auto] = ACTIONS(4510),
    [sym_break] = ACTIONS(4510),
    [sym_case] = ACTIONS(4510),
    [sym_cast] = ACTIONS(4510),
    [sym_catch] = ACTIONS(4510),
    [sym_class] = ACTIONS(4510),
    [sym_const] = ACTIONS(4510),
    [sym_continue] = ACTIONS(4510),
    [sym_debug] = ACTIONS(4510),
    [sym_default] = ACTIONS(4510),
    [sym_delegate] = ACTIONS(4510),
    [sym_delete] = ACTIONS(4510),
    [sym_deprecated] = ACTIONS(4510),
    [sym_do] = ACTIONS(4510),
    [sym_else] = ACTIONS(4510),
    [sym_enum] = ACTIONS(4510),
    [sym_export] = ACTIONS(4510),
    [sym_extern] = ACTIONS(4510),
    [sym_final] = ACTIONS(4510),
    [sym_finally] = ACTIONS(4510),
    [sym_for] = ACTIONS(4510),
    [sym_foreach] = ACTIONS(4510),
    [sym_foreach_reverse] = ACTIONS(4510),
    [sym_function] = ACTIONS(4510),
    [sym_goto] = ACTIONS(4510),
    [sym_if] = ACTIONS(4510),
    [sym_immutable] = ACTIONS(4510),
    [sym_import] = ACTIONS(4510),
    [sym_in] = ACTIONS(4510),
    [sym_inout] = ACTIONS(4510),
    [sym_interface] = ACTIONS(4510),
    [sym_invariant] = ACTIONS(4510),
    [sym_is] = ACTIONS(4510),
    [sym_mixin] = ACTIONS(4510),
    [sym_new] = ACTIONS(4510),
    [sym_nothrow] = ACTIONS(4510),
    [sym_out] = ACTIONS(4510),
    [sym_override] = ACTIONS(4510),
    [sym_package] = ACTIONS(4510),
    [sym_pragma] = ACTIONS(4510),
    [sym_private] = ACTIONS(4510),
    [sym_protected] = ACTIONS(4510),
    [sym_public] = ACTIONS(4510),
    [sym_pure] = ACTIONS(4510),
    [sym_ref] = ACTIONS(4510),
    [sym_return] = ACTIONS(4510),
    [sym_scope] = ACTIONS(4510),
    [sym_shared] = ACTIONS(4510),
    [sym_static] = ACTIONS(4510),
    [sym_struct] = ACTIONS(4510),
    [sym_switch] = ACTIONS(4510),
    [sym_synchronized] = ACTIONS(4510),
    [sym_template] = ACTIONS(4510),
    [sym_throw] = ACTIONS(4510),
    [sym_try] = ACTIONS(4510),
    [sym_typeid] = ACTIONS(4510),
    [sym_typeof] = ACTIONS(4510),
    [sym_union] = ACTIONS(4510),
    [sym_unittest] = ACTIONS(4510),
    [sym_version] = ACTIONS(4510),
    [sym_while] = ACTIONS(4510),
    [sym_with] = ACTIONS(4510),
    [sym_gshared] = ACTIONS(4510),
    [sym_traits] = ACTIONS(4510),
    [sym_vector] = ACTIONS(4510),
    [sym_void] = ACTIONS(4510),
    [anon_sym_BQUOTE] = ACTIONS(4512),
    [anon_sym_r_DQUOTE] = ACTIONS(4512),
    [anon_sym_x_DQUOTE] = ACTIONS(4512),
    [anon_sym_DQUOTE] = ACTIONS(4512),
    [anon_sym_i_BQUOTE] = ACTIONS(4512),
    [anon_sym_i_DQUOTE] = ACTIONS(4512),
    [anon_sym_iq_LBRACE] = ACTIONS(4512),
    [aux_sym_char_literal_token1] = ACTIONS(4512),
    [anon_sym_SQUOTE] = ACTIONS(4510),
    [anon_sym___DATE__] = ACTIONS(4510),
    [anon_sym___FILE__] = ACTIONS(4510),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4510),
    [anon_sym___FUNCTION__] = ACTIONS(4510),
    [anon_sym___LINE__] = ACTIONS(4510),
    [anon_sym___MODULE__] = ACTIONS(4510),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4510),
    [anon_sym___TIME__] = ACTIONS(4510),
    [anon_sym___TIMESTAMP__] = ACTIONS(4510),
    [anon_sym___VENDOR__] = ACTIONS(4510),
    [anon_sym___VERSION__] = ACTIONS(4510),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4512),
    [sym_float_literal] = ACTIONS(4512),
    [sym__string] = ACTIONS(4512),
  },
  [1385] = {
    [sym_identifier] = ACTIONS(4514),
    [anon_sym_q_LBRACE] = ACTIONS(4516),
    [anon_sym_RBRACE] = ACTIONS(4516),
    [anon_sym_LBRACE] = ACTIONS(4516),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_DASH] = ACTIONS(4514),
    [anon_sym_DASH_DASH] = ACTIONS(4516),
    [anon_sym_PLUS] = ACTIONS(4514),
    [anon_sym_PLUS_PLUS] = ACTIONS(4516),
    [anon_sym_BANG] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4516),
    [anon_sym_RPAREN] = ACTIONS(4516),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_SEMI] = ACTIONS(4516),
    [anon_sym_DOLLAR] = ACTIONS(4516),
    [anon_sym_STAR] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4516),
    [anon_sym_AT] = ACTIONS(4516),
    [sym_bool] = ACTIONS(4514),
    [sym_byte] = ACTIONS(4514),
    [sym_ubyte] = ACTIONS(4514),
    [sym_char] = ACTIONS(4514),
    [sym_short] = ACTIONS(4514),
    [sym_ushort] = ACTIONS(4514),
    [sym_int] = ACTIONS(4514),
    [sym_uint] = ACTIONS(4514),
    [sym_long] = ACTIONS(4514),
    [sym_ulong] = ACTIONS(4514),
    [sym_cent] = ACTIONS(4514),
    [sym_ucent] = ACTIONS(4514),
    [sym_wchar] = ACTIONS(4514),
    [sym_dchar] = ACTIONS(4514),
    [sym_float] = ACTIONS(4514),
    [sym_double] = ACTIONS(4514),
    [sym_real] = ACTIONS(4514),
    [sym_ifloat] = ACTIONS(4514),
    [sym_idouble] = ACTIONS(4514),
    [sym_ireal] = ACTIONS(4514),
    [sym_cfloat] = ACTIONS(4514),
    [sym_cdouble] = ACTIONS(4514),
    [sym_creal] = ACTIONS(4514),
    [sym_size_t] = ACTIONS(4514),
    [sym_ptrdiff_t] = ACTIONS(4514),
    [sym_string] = ACTIONS(4514),
    [sym_cstring] = ACTIONS(4514),
    [sym_dstring] = ACTIONS(4514),
    [sym_wstring] = ACTIONS(4514),
    [sym_noreturn] = ACTIONS(4514),
    [sym_true] = ACTIONS(4514),
    [sym_false] = ACTIONS(4514),
    [sym_null] = ACTIONS(4514),
    [sym_super] = ACTIONS(4514),
    [sym_this] = ACTIONS(4514),
    [sym_abstract] = ACTIONS(4514),
    [sym_alias] = ACTIONS(4514),
    [sym_align] = ACTIONS(4514),
    [sym_asm] = ACTIONS(4514),
    [sym_assert] = ACTIONS(4514),
    [sym_auto] = ACTIONS(4514),
    [sym_break] = ACTIONS(4514),
    [sym_case] = ACTIONS(4514),
    [sym_cast] = ACTIONS(4514),
    [sym_catch] = ACTIONS(4514),
    [sym_class] = ACTIONS(4514),
    [sym_const] = ACTIONS(4514),
    [sym_continue] = ACTIONS(4514),
    [sym_debug] = ACTIONS(4514),
    [sym_default] = ACTIONS(4514),
    [sym_delegate] = ACTIONS(4514),
    [sym_delete] = ACTIONS(4514),
    [sym_deprecated] = ACTIONS(4514),
    [sym_do] = ACTIONS(4514),
    [sym_else] = ACTIONS(4514),
    [sym_enum] = ACTIONS(4514),
    [sym_export] = ACTIONS(4514),
    [sym_extern] = ACTIONS(4514),
    [sym_final] = ACTIONS(4514),
    [sym_finally] = ACTIONS(4514),
    [sym_for] = ACTIONS(4514),
    [sym_foreach] = ACTIONS(4514),
    [sym_foreach_reverse] = ACTIONS(4514),
    [sym_function] = ACTIONS(4514),
    [sym_goto] = ACTIONS(4514),
    [sym_if] = ACTIONS(4514),
    [sym_immutable] = ACTIONS(4514),
    [sym_import] = ACTIONS(4514),
    [sym_in] = ACTIONS(4514),
    [sym_inout] = ACTIONS(4514),
    [sym_interface] = ACTIONS(4514),
    [sym_invariant] = ACTIONS(4514),
    [sym_is] = ACTIONS(4514),
    [sym_mixin] = ACTIONS(4514),
    [sym_new] = ACTIONS(4514),
    [sym_nothrow] = ACTIONS(4514),
    [sym_out] = ACTIONS(4514),
    [sym_override] = ACTIONS(4514),
    [sym_package] = ACTIONS(4514),
    [sym_pragma] = ACTIONS(4514),
    [sym_private] = ACTIONS(4514),
    [sym_protected] = ACTIONS(4514),
    [sym_public] = ACTIONS(4514),
    [sym_pure] = ACTIONS(4514),
    [sym_ref] = ACTIONS(4514),
    [sym_return] = ACTIONS(4514),
    [sym_scope] = ACTIONS(4514),
    [sym_shared] = ACTIONS(4514),
    [sym_static] = ACTIONS(4514),
    [sym_struct] = ACTIONS(4514),
    [sym_switch] = ACTIONS(4514),
    [sym_synchronized] = ACTIONS(4514),
    [sym_template] = ACTIONS(4514),
    [sym_throw] = ACTIONS(4514),
    [sym_try] = ACTIONS(4514),
    [sym_typeid] = ACTIONS(4514),
    [sym_typeof] = ACTIONS(4514),
    [sym_union] = ACTIONS(4514),
    [sym_unittest] = ACTIONS(4514),
    [sym_version] = ACTIONS(4514),
    [sym_while] = ACTIONS(4514),
    [sym_with] = ACTIONS(4514),
    [sym_gshared] = ACTIONS(4514),
    [sym_traits] = ACTIONS(4514),
    [sym_vector] = ACTIONS(4514),
    [sym_void] = ACTIONS(4514),
    [anon_sym_BQUOTE] = ACTIONS(4516),
    [anon_sym_r_DQUOTE] = ACTIONS(4516),
    [anon_sym_x_DQUOTE] = ACTIONS(4516),
    [anon_sym_DQUOTE] = ACTIONS(4516),
    [anon_sym_i_BQUOTE] = ACTIONS(4516),
    [anon_sym_i_DQUOTE] = ACTIONS(4516),
    [anon_sym_iq_LBRACE] = ACTIONS(4516),
    [aux_sym_char_literal_token1] = ACTIONS(4516),
    [anon_sym_SQUOTE] = ACTIONS(4514),
    [anon_sym___DATE__] = ACTIONS(4514),
    [anon_sym___FILE__] = ACTIONS(4514),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4514),
    [anon_sym___FUNCTION__] = ACTIONS(4514),
    [anon_sym___LINE__] = ACTIONS(4514),
    [anon_sym___MODULE__] = ACTIONS(4514),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4514),
    [anon_sym___TIME__] = ACTIONS(4514),
    [anon_sym___TIMESTAMP__] = ACTIONS(4514),
    [anon_sym___VENDOR__] = ACTIONS(4514),
    [anon_sym___VERSION__] = ACTIONS(4514),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4516),
    [sym_float_literal] = ACTIONS(4516),
    [sym__string] = ACTIONS(4516),
  },
  [1386] = {
    [sym_identifier] = ACTIONS(4518),
    [anon_sym_q_LBRACE] = ACTIONS(4520),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_DOT] = ACTIONS(4520),
    [anon_sym_AMP] = ACTIONS(4520),
    [anon_sym_DASH] = ACTIONS(4518),
    [anon_sym_DASH_DASH] = ACTIONS(4520),
    [anon_sym_PLUS] = ACTIONS(4518),
    [anon_sym_PLUS_PLUS] = ACTIONS(4520),
    [anon_sym_BANG] = ACTIONS(4520),
    [anon_sym_LPAREN] = ACTIONS(4520),
    [anon_sym_RPAREN] = ACTIONS(4520),
    [anon_sym_LBRACK] = ACTIONS(4520),
    [anon_sym_SEMI] = ACTIONS(4520),
    [anon_sym_DOLLAR] = ACTIONS(4520),
    [anon_sym_STAR] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4520),
    [anon_sym_AT] = ACTIONS(4520),
    [sym_bool] = ACTIONS(4518),
    [sym_byte] = ACTIONS(4518),
    [sym_ubyte] = ACTIONS(4518),
    [sym_char] = ACTIONS(4518),
    [sym_short] = ACTIONS(4518),
    [sym_ushort] = ACTIONS(4518),
    [sym_int] = ACTIONS(4518),
    [sym_uint] = ACTIONS(4518),
    [sym_long] = ACTIONS(4518),
    [sym_ulong] = ACTIONS(4518),
    [sym_cent] = ACTIONS(4518),
    [sym_ucent] = ACTIONS(4518),
    [sym_wchar] = ACTIONS(4518),
    [sym_dchar] = ACTIONS(4518),
    [sym_float] = ACTIONS(4518),
    [sym_double] = ACTIONS(4518),
    [sym_real] = ACTIONS(4518),
    [sym_ifloat] = ACTIONS(4518),
    [sym_idouble] = ACTIONS(4518),
    [sym_ireal] = ACTIONS(4518),
    [sym_cfloat] = ACTIONS(4518),
    [sym_cdouble] = ACTIONS(4518),
    [sym_creal] = ACTIONS(4518),
    [sym_size_t] = ACTIONS(4518),
    [sym_ptrdiff_t] = ACTIONS(4518),
    [sym_string] = ACTIONS(4518),
    [sym_cstring] = ACTIONS(4518),
    [sym_dstring] = ACTIONS(4518),
    [sym_wstring] = ACTIONS(4518),
    [sym_noreturn] = ACTIONS(4518),
    [sym_true] = ACTIONS(4518),
    [sym_false] = ACTIONS(4518),
    [sym_null] = ACTIONS(4518),
    [sym_super] = ACTIONS(4518),
    [sym_this] = ACTIONS(4518),
    [sym_abstract] = ACTIONS(4518),
    [sym_alias] = ACTIONS(4518),
    [sym_align] = ACTIONS(4518),
    [sym_asm] = ACTIONS(4518),
    [sym_assert] = ACTIONS(4518),
    [sym_auto] = ACTIONS(4518),
    [sym_break] = ACTIONS(4518),
    [sym_case] = ACTIONS(4518),
    [sym_cast] = ACTIONS(4518),
    [sym_catch] = ACTIONS(4518),
    [sym_class] = ACTIONS(4518),
    [sym_const] = ACTIONS(4518),
    [sym_continue] = ACTIONS(4518),
    [sym_debug] = ACTIONS(4518),
    [sym_default] = ACTIONS(4518),
    [sym_delegate] = ACTIONS(4518),
    [sym_delete] = ACTIONS(4518),
    [sym_deprecated] = ACTIONS(4518),
    [sym_do] = ACTIONS(4518),
    [sym_else] = ACTIONS(4518),
    [sym_enum] = ACTIONS(4518),
    [sym_export] = ACTIONS(4518),
    [sym_extern] = ACTIONS(4518),
    [sym_final] = ACTIONS(4518),
    [sym_finally] = ACTIONS(4518),
    [sym_for] = ACTIONS(4518),
    [sym_foreach] = ACTIONS(4518),
    [sym_foreach_reverse] = ACTIONS(4518),
    [sym_function] = ACTIONS(4518),
    [sym_goto] = ACTIONS(4518),
    [sym_if] = ACTIONS(4518),
    [sym_immutable] = ACTIONS(4518),
    [sym_import] = ACTIONS(4518),
    [sym_in] = ACTIONS(4518),
    [sym_inout] = ACTIONS(4518),
    [sym_interface] = ACTIONS(4518),
    [sym_invariant] = ACTIONS(4518),
    [sym_is] = ACTIONS(4518),
    [sym_mixin] = ACTIONS(4518),
    [sym_new] = ACTIONS(4518),
    [sym_nothrow] = ACTIONS(4518),
    [sym_out] = ACTIONS(4518),
    [sym_override] = ACTIONS(4518),
    [sym_package] = ACTIONS(4518),
    [sym_pragma] = ACTIONS(4518),
    [sym_private] = ACTIONS(4518),
    [sym_protected] = ACTIONS(4518),
    [sym_public] = ACTIONS(4518),
    [sym_pure] = ACTIONS(4518),
    [sym_ref] = ACTIONS(4518),
    [sym_return] = ACTIONS(4518),
    [sym_scope] = ACTIONS(4518),
    [sym_shared] = ACTIONS(4518),
    [sym_static] = ACTIONS(4518),
    [sym_struct] = ACTIONS(4518),
    [sym_switch] = ACTIONS(4518),
    [sym_synchronized] = ACTIONS(4518),
    [sym_template] = ACTIONS(4518),
    [sym_throw] = ACTIONS(4518),
    [sym_try] = ACTIONS(4518),
    [sym_typeid] = ACTIONS(4518),
    [sym_typeof] = ACTIONS(4518),
    [sym_union] = ACTIONS(4518),
    [sym_unittest] = ACTIONS(4518),
    [sym_version] = ACTIONS(4518),
    [sym_while] = ACTIONS(4518),
    [sym_with] = ACTIONS(4518),
    [sym_gshared] = ACTIONS(4518),
    [sym_traits] = ACTIONS(4518),
    [sym_vector] = ACTIONS(4518),
    [sym_void] = ACTIONS(4518),
    [anon_sym_BQUOTE] = ACTIONS(4520),
    [anon_sym_r_DQUOTE] = ACTIONS(4520),
    [anon_sym_x_DQUOTE] = ACTIONS(4520),
    [anon_sym_DQUOTE] = ACTIONS(4520),
    [anon_sym_i_BQUOTE] = ACTIONS(4520),
    [anon_sym_i_DQUOTE] = ACTIONS(4520),
    [anon_sym_iq_LBRACE] = ACTIONS(4520),
    [aux_sym_char_literal_token1] = ACTIONS(4520),
    [anon_sym_SQUOTE] = ACTIONS(4518),
    [anon_sym___DATE__] = ACTIONS(4518),
    [anon_sym___FILE__] = ACTIONS(4518),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4518),
    [anon_sym___FUNCTION__] = ACTIONS(4518),
    [anon_sym___LINE__] = ACTIONS(4518),
    [anon_sym___MODULE__] = ACTIONS(4518),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4518),
    [anon_sym___TIME__] = ACTIONS(4518),
    [anon_sym___TIMESTAMP__] = ACTIONS(4518),
    [anon_sym___VENDOR__] = ACTIONS(4518),
    [anon_sym___VERSION__] = ACTIONS(4518),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4520),
    [sym_float_literal] = ACTIONS(4520),
    [sym__string] = ACTIONS(4520),
  },
  [1387] = {
    [sym_identifier] = ACTIONS(4522),
    [anon_sym_q_LBRACE] = ACTIONS(4524),
    [anon_sym_RBRACE] = ACTIONS(4524),
    [anon_sym_LBRACE] = ACTIONS(4524),
    [anon_sym_DOT] = ACTIONS(4524),
    [anon_sym_AMP] = ACTIONS(4524),
    [anon_sym_DASH] = ACTIONS(4522),
    [anon_sym_DASH_DASH] = ACTIONS(4524),
    [anon_sym_PLUS] = ACTIONS(4522),
    [anon_sym_PLUS_PLUS] = ACTIONS(4524),
    [anon_sym_BANG] = ACTIONS(4524),
    [anon_sym_LPAREN] = ACTIONS(4524),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_LBRACK] = ACTIONS(4524),
    [anon_sym_SEMI] = ACTIONS(4524),
    [anon_sym_DOLLAR] = ACTIONS(4524),
    [anon_sym_STAR] = ACTIONS(4524),
    [anon_sym_TILDE] = ACTIONS(4524),
    [anon_sym_AT] = ACTIONS(4524),
    [sym_bool] = ACTIONS(4522),
    [sym_byte] = ACTIONS(4522),
    [sym_ubyte] = ACTIONS(4522),
    [sym_char] = ACTIONS(4522),
    [sym_short] = ACTIONS(4522),
    [sym_ushort] = ACTIONS(4522),
    [sym_int] = ACTIONS(4522),
    [sym_uint] = ACTIONS(4522),
    [sym_long] = ACTIONS(4522),
    [sym_ulong] = ACTIONS(4522),
    [sym_cent] = ACTIONS(4522),
    [sym_ucent] = ACTIONS(4522),
    [sym_wchar] = ACTIONS(4522),
    [sym_dchar] = ACTIONS(4522),
    [sym_float] = ACTIONS(4522),
    [sym_double] = ACTIONS(4522),
    [sym_real] = ACTIONS(4522),
    [sym_ifloat] = ACTIONS(4522),
    [sym_idouble] = ACTIONS(4522),
    [sym_ireal] = ACTIONS(4522),
    [sym_cfloat] = ACTIONS(4522),
    [sym_cdouble] = ACTIONS(4522),
    [sym_creal] = ACTIONS(4522),
    [sym_size_t] = ACTIONS(4522),
    [sym_ptrdiff_t] = ACTIONS(4522),
    [sym_string] = ACTIONS(4522),
    [sym_cstring] = ACTIONS(4522),
    [sym_dstring] = ACTIONS(4522),
    [sym_wstring] = ACTIONS(4522),
    [sym_noreturn] = ACTIONS(4522),
    [sym_true] = ACTIONS(4522),
    [sym_false] = ACTIONS(4522),
    [sym_null] = ACTIONS(4522),
    [sym_super] = ACTIONS(4522),
    [sym_this] = ACTIONS(4522),
    [sym_abstract] = ACTIONS(4522),
    [sym_alias] = ACTIONS(4522),
    [sym_align] = ACTIONS(4522),
    [sym_asm] = ACTIONS(4522),
    [sym_assert] = ACTIONS(4522),
    [sym_auto] = ACTIONS(4522),
    [sym_break] = ACTIONS(4522),
    [sym_case] = ACTIONS(4522),
    [sym_cast] = ACTIONS(4522),
    [sym_catch] = ACTIONS(4522),
    [sym_class] = ACTIONS(4522),
    [sym_const] = ACTIONS(4522),
    [sym_continue] = ACTIONS(4522),
    [sym_debug] = ACTIONS(4522),
    [sym_default] = ACTIONS(4522),
    [sym_delegate] = ACTIONS(4522),
    [sym_delete] = ACTIONS(4522),
    [sym_deprecated] = ACTIONS(4522),
    [sym_do] = ACTIONS(4522),
    [sym_else] = ACTIONS(4522),
    [sym_enum] = ACTIONS(4522),
    [sym_export] = ACTIONS(4522),
    [sym_extern] = ACTIONS(4522),
    [sym_final] = ACTIONS(4522),
    [sym_finally] = ACTIONS(4522),
    [sym_for] = ACTIONS(4522),
    [sym_foreach] = ACTIONS(4522),
    [sym_foreach_reverse] = ACTIONS(4522),
    [sym_function] = ACTIONS(4522),
    [sym_goto] = ACTIONS(4522),
    [sym_if] = ACTIONS(4522),
    [sym_immutable] = ACTIONS(4522),
    [sym_import] = ACTIONS(4522),
    [sym_in] = ACTIONS(4522),
    [sym_inout] = ACTIONS(4522),
    [sym_interface] = ACTIONS(4522),
    [sym_invariant] = ACTIONS(4522),
    [sym_is] = ACTIONS(4522),
    [sym_mixin] = ACTIONS(4522),
    [sym_new] = ACTIONS(4522),
    [sym_nothrow] = ACTIONS(4522),
    [sym_out] = ACTIONS(4522),
    [sym_override] = ACTIONS(4522),
    [sym_package] = ACTIONS(4522),
    [sym_pragma] = ACTIONS(4522),
    [sym_private] = ACTIONS(4522),
    [sym_protected] = ACTIONS(4522),
    [sym_public] = ACTIONS(4522),
    [sym_pure] = ACTIONS(4522),
    [sym_ref] = ACTIONS(4522),
    [sym_return] = ACTIONS(4522),
    [sym_scope] = ACTIONS(4522),
    [sym_shared] = ACTIONS(4522),
    [sym_static] = ACTIONS(4522),
    [sym_struct] = ACTIONS(4522),
    [sym_switch] = ACTIONS(4522),
    [sym_synchronized] = ACTIONS(4522),
    [sym_template] = ACTIONS(4522),
    [sym_throw] = ACTIONS(4522),
    [sym_try] = ACTIONS(4522),
    [sym_typeid] = ACTIONS(4522),
    [sym_typeof] = ACTIONS(4522),
    [sym_union] = ACTIONS(4522),
    [sym_unittest] = ACTIONS(4522),
    [sym_version] = ACTIONS(4522),
    [sym_while] = ACTIONS(4522),
    [sym_with] = ACTIONS(4522),
    [sym_gshared] = ACTIONS(4522),
    [sym_traits] = ACTIONS(4522),
    [sym_vector] = ACTIONS(4522),
    [sym_void] = ACTIONS(4522),
    [anon_sym_BQUOTE] = ACTIONS(4524),
    [anon_sym_r_DQUOTE] = ACTIONS(4524),
    [anon_sym_x_DQUOTE] = ACTIONS(4524),
    [anon_sym_DQUOTE] = ACTIONS(4524),
    [anon_sym_i_BQUOTE] = ACTIONS(4524),
    [anon_sym_i_DQUOTE] = ACTIONS(4524),
    [anon_sym_iq_LBRACE] = ACTIONS(4524),
    [aux_sym_char_literal_token1] = ACTIONS(4524),
    [anon_sym_SQUOTE] = ACTIONS(4522),
    [anon_sym___DATE__] = ACTIONS(4522),
    [anon_sym___FILE__] = ACTIONS(4522),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4522),
    [anon_sym___FUNCTION__] = ACTIONS(4522),
    [anon_sym___LINE__] = ACTIONS(4522),
    [anon_sym___MODULE__] = ACTIONS(4522),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4522),
    [anon_sym___TIME__] = ACTIONS(4522),
    [anon_sym___TIMESTAMP__] = ACTIONS(4522),
    [anon_sym___VENDOR__] = ACTIONS(4522),
    [anon_sym___VERSION__] = ACTIONS(4522),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4524),
    [sym_float_literal] = ACTIONS(4524),
    [sym__string] = ACTIONS(4524),
  },
  [1388] = {
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_q_LBRACE] = ACTIONS(4528),
    [anon_sym_RBRACE] = ACTIONS(4528),
    [anon_sym_LBRACE] = ACTIONS(4528),
    [anon_sym_DOT] = ACTIONS(4528),
    [anon_sym_AMP] = ACTIONS(4528),
    [anon_sym_DASH] = ACTIONS(4526),
    [anon_sym_DASH_DASH] = ACTIONS(4528),
    [anon_sym_PLUS] = ACTIONS(4526),
    [anon_sym_PLUS_PLUS] = ACTIONS(4528),
    [anon_sym_BANG] = ACTIONS(4528),
    [anon_sym_LPAREN] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_DOLLAR] = ACTIONS(4528),
    [anon_sym_STAR] = ACTIONS(4528),
    [anon_sym_TILDE] = ACTIONS(4528),
    [anon_sym_AT] = ACTIONS(4528),
    [sym_bool] = ACTIONS(4526),
    [sym_byte] = ACTIONS(4526),
    [sym_ubyte] = ACTIONS(4526),
    [sym_char] = ACTIONS(4526),
    [sym_short] = ACTIONS(4526),
    [sym_ushort] = ACTIONS(4526),
    [sym_int] = ACTIONS(4526),
    [sym_uint] = ACTIONS(4526),
    [sym_long] = ACTIONS(4526),
    [sym_ulong] = ACTIONS(4526),
    [sym_cent] = ACTIONS(4526),
    [sym_ucent] = ACTIONS(4526),
    [sym_wchar] = ACTIONS(4526),
    [sym_dchar] = ACTIONS(4526),
    [sym_float] = ACTIONS(4526),
    [sym_double] = ACTIONS(4526),
    [sym_real] = ACTIONS(4526),
    [sym_ifloat] = ACTIONS(4526),
    [sym_idouble] = ACTIONS(4526),
    [sym_ireal] = ACTIONS(4526),
    [sym_cfloat] = ACTIONS(4526),
    [sym_cdouble] = ACTIONS(4526),
    [sym_creal] = ACTIONS(4526),
    [sym_size_t] = ACTIONS(4526),
    [sym_ptrdiff_t] = ACTIONS(4526),
    [sym_string] = ACTIONS(4526),
    [sym_cstring] = ACTIONS(4526),
    [sym_dstring] = ACTIONS(4526),
    [sym_wstring] = ACTIONS(4526),
    [sym_noreturn] = ACTIONS(4526),
    [sym_true] = ACTIONS(4526),
    [sym_false] = ACTIONS(4526),
    [sym_null] = ACTIONS(4526),
    [sym_super] = ACTIONS(4526),
    [sym_this] = ACTIONS(4526),
    [sym_abstract] = ACTIONS(4526),
    [sym_alias] = ACTIONS(4526),
    [sym_align] = ACTIONS(4526),
    [sym_asm] = ACTIONS(4526),
    [sym_assert] = ACTIONS(4526),
    [sym_auto] = ACTIONS(4526),
    [sym_break] = ACTIONS(4526),
    [sym_case] = ACTIONS(4526),
    [sym_cast] = ACTIONS(4526),
    [sym_catch] = ACTIONS(4526),
    [sym_class] = ACTIONS(4526),
    [sym_const] = ACTIONS(4526),
    [sym_continue] = ACTIONS(4526),
    [sym_debug] = ACTIONS(4526),
    [sym_default] = ACTIONS(4526),
    [sym_delegate] = ACTIONS(4526),
    [sym_delete] = ACTIONS(4526),
    [sym_deprecated] = ACTIONS(4526),
    [sym_do] = ACTIONS(4526),
    [sym_else] = ACTIONS(4526),
    [sym_enum] = ACTIONS(4526),
    [sym_export] = ACTIONS(4526),
    [sym_extern] = ACTIONS(4526),
    [sym_final] = ACTIONS(4526),
    [sym_finally] = ACTIONS(4526),
    [sym_for] = ACTIONS(4526),
    [sym_foreach] = ACTIONS(4526),
    [sym_foreach_reverse] = ACTIONS(4526),
    [sym_function] = ACTIONS(4526),
    [sym_goto] = ACTIONS(4526),
    [sym_if] = ACTIONS(4526),
    [sym_immutable] = ACTIONS(4526),
    [sym_import] = ACTIONS(4526),
    [sym_in] = ACTIONS(4526),
    [sym_inout] = ACTIONS(4526),
    [sym_interface] = ACTIONS(4526),
    [sym_invariant] = ACTIONS(4526),
    [sym_is] = ACTIONS(4526),
    [sym_mixin] = ACTIONS(4526),
    [sym_new] = ACTIONS(4526),
    [sym_nothrow] = ACTIONS(4526),
    [sym_out] = ACTIONS(4526),
    [sym_override] = ACTIONS(4526),
    [sym_package] = ACTIONS(4526),
    [sym_pragma] = ACTIONS(4526),
    [sym_private] = ACTIONS(4526),
    [sym_protected] = ACTIONS(4526),
    [sym_public] = ACTIONS(4526),
    [sym_pure] = ACTIONS(4526),
    [sym_ref] = ACTIONS(4526),
    [sym_return] = ACTIONS(4526),
    [sym_scope] = ACTIONS(4526),
    [sym_shared] = ACTIONS(4526),
    [sym_static] = ACTIONS(4526),
    [sym_struct] = ACTIONS(4526),
    [sym_switch] = ACTIONS(4526),
    [sym_synchronized] = ACTIONS(4526),
    [sym_template] = ACTIONS(4526),
    [sym_throw] = ACTIONS(4526),
    [sym_try] = ACTIONS(4526),
    [sym_typeid] = ACTIONS(4526),
    [sym_typeof] = ACTIONS(4526),
    [sym_union] = ACTIONS(4526),
    [sym_unittest] = ACTIONS(4526),
    [sym_version] = ACTIONS(4526),
    [sym_while] = ACTIONS(4526),
    [sym_with] = ACTIONS(4526),
    [sym_gshared] = ACTIONS(4526),
    [sym_traits] = ACTIONS(4526),
    [sym_vector] = ACTIONS(4526),
    [sym_void] = ACTIONS(4526),
    [anon_sym_BQUOTE] = ACTIONS(4528),
    [anon_sym_r_DQUOTE] = ACTIONS(4528),
    [anon_sym_x_DQUOTE] = ACTIONS(4528),
    [anon_sym_DQUOTE] = ACTIONS(4528),
    [anon_sym_i_BQUOTE] = ACTIONS(4528),
    [anon_sym_i_DQUOTE] = ACTIONS(4528),
    [anon_sym_iq_LBRACE] = ACTIONS(4528),
    [aux_sym_char_literal_token1] = ACTIONS(4528),
    [anon_sym_SQUOTE] = ACTIONS(4526),
    [anon_sym___DATE__] = ACTIONS(4526),
    [anon_sym___FILE__] = ACTIONS(4526),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4526),
    [anon_sym___FUNCTION__] = ACTIONS(4526),
    [anon_sym___LINE__] = ACTIONS(4526),
    [anon_sym___MODULE__] = ACTIONS(4526),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4526),
    [anon_sym___TIME__] = ACTIONS(4526),
    [anon_sym___TIMESTAMP__] = ACTIONS(4526),
    [anon_sym___VENDOR__] = ACTIONS(4526),
    [anon_sym___VERSION__] = ACTIONS(4526),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4528),
    [sym_float_literal] = ACTIONS(4528),
    [sym__string] = ACTIONS(4528),
  },
  [1389] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_q_LBRACE] = ACTIONS(4532),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4532),
    [anon_sym_AMP] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_BANG] = ACTIONS(4532),
    [anon_sym_LPAREN] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym_DOLLAR] = ACTIONS(4532),
    [anon_sym_STAR] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_AT] = ACTIONS(4532),
    [sym_bool] = ACTIONS(4530),
    [sym_byte] = ACTIONS(4530),
    [sym_ubyte] = ACTIONS(4530),
    [sym_char] = ACTIONS(4530),
    [sym_short] = ACTIONS(4530),
    [sym_ushort] = ACTIONS(4530),
    [sym_int] = ACTIONS(4530),
    [sym_uint] = ACTIONS(4530),
    [sym_long] = ACTIONS(4530),
    [sym_ulong] = ACTIONS(4530),
    [sym_cent] = ACTIONS(4530),
    [sym_ucent] = ACTIONS(4530),
    [sym_wchar] = ACTIONS(4530),
    [sym_dchar] = ACTIONS(4530),
    [sym_float] = ACTIONS(4530),
    [sym_double] = ACTIONS(4530),
    [sym_real] = ACTIONS(4530),
    [sym_ifloat] = ACTIONS(4530),
    [sym_idouble] = ACTIONS(4530),
    [sym_ireal] = ACTIONS(4530),
    [sym_cfloat] = ACTIONS(4530),
    [sym_cdouble] = ACTIONS(4530),
    [sym_creal] = ACTIONS(4530),
    [sym_size_t] = ACTIONS(4530),
    [sym_ptrdiff_t] = ACTIONS(4530),
    [sym_string] = ACTIONS(4530),
    [sym_cstring] = ACTIONS(4530),
    [sym_dstring] = ACTIONS(4530),
    [sym_wstring] = ACTIONS(4530),
    [sym_noreturn] = ACTIONS(4530),
    [sym_true] = ACTIONS(4530),
    [sym_false] = ACTIONS(4530),
    [sym_null] = ACTIONS(4530),
    [sym_super] = ACTIONS(4530),
    [sym_this] = ACTIONS(4530),
    [sym_abstract] = ACTIONS(4530),
    [sym_alias] = ACTIONS(4530),
    [sym_align] = ACTIONS(4530),
    [sym_asm] = ACTIONS(4530),
    [sym_assert] = ACTIONS(4530),
    [sym_auto] = ACTIONS(4530),
    [sym_break] = ACTIONS(4530),
    [sym_case] = ACTIONS(4530),
    [sym_cast] = ACTIONS(4530),
    [sym_catch] = ACTIONS(4530),
    [sym_class] = ACTIONS(4530),
    [sym_const] = ACTIONS(4530),
    [sym_continue] = ACTIONS(4530),
    [sym_debug] = ACTIONS(4530),
    [sym_default] = ACTIONS(4530),
    [sym_delegate] = ACTIONS(4530),
    [sym_delete] = ACTIONS(4530),
    [sym_deprecated] = ACTIONS(4530),
    [sym_do] = ACTIONS(4530),
    [sym_else] = ACTIONS(4530),
    [sym_enum] = ACTIONS(4530),
    [sym_export] = ACTIONS(4530),
    [sym_extern] = ACTIONS(4530),
    [sym_final] = ACTIONS(4530),
    [sym_finally] = ACTIONS(4530),
    [sym_for] = ACTIONS(4530),
    [sym_foreach] = ACTIONS(4530),
    [sym_foreach_reverse] = ACTIONS(4530),
    [sym_function] = ACTIONS(4530),
    [sym_goto] = ACTIONS(4530),
    [sym_if] = ACTIONS(4530),
    [sym_immutable] = ACTIONS(4530),
    [sym_import] = ACTIONS(4530),
    [sym_in] = ACTIONS(4530),
    [sym_inout] = ACTIONS(4530),
    [sym_interface] = ACTIONS(4530),
    [sym_invariant] = ACTIONS(4530),
    [sym_is] = ACTIONS(4530),
    [sym_mixin] = ACTIONS(4530),
    [sym_new] = ACTIONS(4530),
    [sym_nothrow] = ACTIONS(4530),
    [sym_out] = ACTIONS(4530),
    [sym_override] = ACTIONS(4530),
    [sym_package] = ACTIONS(4530),
    [sym_pragma] = ACTIONS(4530),
    [sym_private] = ACTIONS(4530),
    [sym_protected] = ACTIONS(4530),
    [sym_public] = ACTIONS(4530),
    [sym_pure] = ACTIONS(4530),
    [sym_ref] = ACTIONS(4530),
    [sym_return] = ACTIONS(4530),
    [sym_scope] = ACTIONS(4530),
    [sym_shared] = ACTIONS(4530),
    [sym_static] = ACTIONS(4530),
    [sym_struct] = ACTIONS(4530),
    [sym_switch] = ACTIONS(4530),
    [sym_synchronized] = ACTIONS(4530),
    [sym_template] = ACTIONS(4530),
    [sym_throw] = ACTIONS(4530),
    [sym_try] = ACTIONS(4530),
    [sym_typeid] = ACTIONS(4530),
    [sym_typeof] = ACTIONS(4530),
    [sym_union] = ACTIONS(4530),
    [sym_unittest] = ACTIONS(4530),
    [sym_version] = ACTIONS(4530),
    [sym_while] = ACTIONS(4530),
    [sym_with] = ACTIONS(4530),
    [sym_gshared] = ACTIONS(4530),
    [sym_traits] = ACTIONS(4530),
    [sym_vector] = ACTIONS(4530),
    [sym_void] = ACTIONS(4530),
    [anon_sym_BQUOTE] = ACTIONS(4532),
    [anon_sym_r_DQUOTE] = ACTIONS(4532),
    [anon_sym_x_DQUOTE] = ACTIONS(4532),
    [anon_sym_DQUOTE] = ACTIONS(4532),
    [anon_sym_i_BQUOTE] = ACTIONS(4532),
    [anon_sym_i_DQUOTE] = ACTIONS(4532),
    [anon_sym_iq_LBRACE] = ACTIONS(4532),
    [aux_sym_char_literal_token1] = ACTIONS(4532),
    [anon_sym_SQUOTE] = ACTIONS(4530),
    [anon_sym___DATE__] = ACTIONS(4530),
    [anon_sym___FILE__] = ACTIONS(4530),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4530),
    [anon_sym___FUNCTION__] = ACTIONS(4530),
    [anon_sym___LINE__] = ACTIONS(4530),
    [anon_sym___MODULE__] = ACTIONS(4530),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4530),
    [anon_sym___TIME__] = ACTIONS(4530),
    [anon_sym___TIMESTAMP__] = ACTIONS(4530),
    [anon_sym___VENDOR__] = ACTIONS(4530),
    [anon_sym___VERSION__] = ACTIONS(4530),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4532),
    [sym_float_literal] = ACTIONS(4532),
    [sym__string] = ACTIONS(4532),
  },
  [1390] = {
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_q_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_BANG] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_DOLLAR] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AT] = ACTIONS(4536),
    [sym_bool] = ACTIONS(4534),
    [sym_byte] = ACTIONS(4534),
    [sym_ubyte] = ACTIONS(4534),
    [sym_char] = ACTIONS(4534),
    [sym_short] = ACTIONS(4534),
    [sym_ushort] = ACTIONS(4534),
    [sym_int] = ACTIONS(4534),
    [sym_uint] = ACTIONS(4534),
    [sym_long] = ACTIONS(4534),
    [sym_ulong] = ACTIONS(4534),
    [sym_cent] = ACTIONS(4534),
    [sym_ucent] = ACTIONS(4534),
    [sym_wchar] = ACTIONS(4534),
    [sym_dchar] = ACTIONS(4534),
    [sym_float] = ACTIONS(4534),
    [sym_double] = ACTIONS(4534),
    [sym_real] = ACTIONS(4534),
    [sym_ifloat] = ACTIONS(4534),
    [sym_idouble] = ACTIONS(4534),
    [sym_ireal] = ACTIONS(4534),
    [sym_cfloat] = ACTIONS(4534),
    [sym_cdouble] = ACTIONS(4534),
    [sym_creal] = ACTIONS(4534),
    [sym_size_t] = ACTIONS(4534),
    [sym_ptrdiff_t] = ACTIONS(4534),
    [sym_string] = ACTIONS(4534),
    [sym_cstring] = ACTIONS(4534),
    [sym_dstring] = ACTIONS(4534),
    [sym_wstring] = ACTIONS(4534),
    [sym_noreturn] = ACTIONS(4534),
    [sym_true] = ACTIONS(4534),
    [sym_false] = ACTIONS(4534),
    [sym_null] = ACTIONS(4534),
    [sym_super] = ACTIONS(4534),
    [sym_this] = ACTIONS(4534),
    [sym_abstract] = ACTIONS(4534),
    [sym_alias] = ACTIONS(4534),
    [sym_align] = ACTIONS(4534),
    [sym_asm] = ACTIONS(4534),
    [sym_assert] = ACTIONS(4534),
    [sym_auto] = ACTIONS(4534),
    [sym_break] = ACTIONS(4534),
    [sym_case] = ACTIONS(4534),
    [sym_cast] = ACTIONS(4534),
    [sym_catch] = ACTIONS(4534),
    [sym_class] = ACTIONS(4534),
    [sym_const] = ACTIONS(4534),
    [sym_continue] = ACTIONS(4534),
    [sym_debug] = ACTIONS(4534),
    [sym_default] = ACTIONS(4534),
    [sym_delegate] = ACTIONS(4534),
    [sym_delete] = ACTIONS(4534),
    [sym_deprecated] = ACTIONS(4534),
    [sym_do] = ACTIONS(4534),
    [sym_else] = ACTIONS(4534),
    [sym_enum] = ACTIONS(4534),
    [sym_export] = ACTIONS(4534),
    [sym_extern] = ACTIONS(4534),
    [sym_final] = ACTIONS(4534),
    [sym_finally] = ACTIONS(4534),
    [sym_for] = ACTIONS(4534),
    [sym_foreach] = ACTIONS(4534),
    [sym_foreach_reverse] = ACTIONS(4534),
    [sym_function] = ACTIONS(4534),
    [sym_goto] = ACTIONS(4534),
    [sym_if] = ACTIONS(4534),
    [sym_immutable] = ACTIONS(4534),
    [sym_import] = ACTIONS(4534),
    [sym_in] = ACTIONS(4534),
    [sym_inout] = ACTIONS(4534),
    [sym_interface] = ACTIONS(4534),
    [sym_invariant] = ACTIONS(4534),
    [sym_is] = ACTIONS(4534),
    [sym_mixin] = ACTIONS(4534),
    [sym_new] = ACTIONS(4534),
    [sym_nothrow] = ACTIONS(4534),
    [sym_out] = ACTIONS(4534),
    [sym_override] = ACTIONS(4534),
    [sym_package] = ACTIONS(4534),
    [sym_pragma] = ACTIONS(4534),
    [sym_private] = ACTIONS(4534),
    [sym_protected] = ACTIONS(4534),
    [sym_public] = ACTIONS(4534),
    [sym_pure] = ACTIONS(4534),
    [sym_ref] = ACTIONS(4534),
    [sym_return] = ACTIONS(4534),
    [sym_scope] = ACTIONS(4534),
    [sym_shared] = ACTIONS(4534),
    [sym_static] = ACTIONS(4534),
    [sym_struct] = ACTIONS(4534),
    [sym_switch] = ACTIONS(4534),
    [sym_synchronized] = ACTIONS(4534),
    [sym_template] = ACTIONS(4534),
    [sym_throw] = ACTIONS(4534),
    [sym_try] = ACTIONS(4534),
    [sym_typeid] = ACTIONS(4534),
    [sym_typeof] = ACTIONS(4534),
    [sym_union] = ACTIONS(4534),
    [sym_unittest] = ACTIONS(4534),
    [sym_version] = ACTIONS(4534),
    [sym_while] = ACTIONS(4534),
    [sym_with] = ACTIONS(4534),
    [sym_gshared] = ACTIONS(4534),
    [sym_traits] = ACTIONS(4534),
    [sym_vector] = ACTIONS(4534),
    [sym_void] = ACTIONS(4534),
    [anon_sym_BQUOTE] = ACTIONS(4536),
    [anon_sym_r_DQUOTE] = ACTIONS(4536),
    [anon_sym_x_DQUOTE] = ACTIONS(4536),
    [anon_sym_DQUOTE] = ACTIONS(4536),
    [anon_sym_i_BQUOTE] = ACTIONS(4536),
    [anon_sym_i_DQUOTE] = ACTIONS(4536),
    [anon_sym_iq_LBRACE] = ACTIONS(4536),
    [aux_sym_char_literal_token1] = ACTIONS(4536),
    [anon_sym_SQUOTE] = ACTIONS(4534),
    [anon_sym___DATE__] = ACTIONS(4534),
    [anon_sym___FILE__] = ACTIONS(4534),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4534),
    [anon_sym___FUNCTION__] = ACTIONS(4534),
    [anon_sym___LINE__] = ACTIONS(4534),
    [anon_sym___MODULE__] = ACTIONS(4534),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4534),
    [anon_sym___TIME__] = ACTIONS(4534),
    [anon_sym___TIMESTAMP__] = ACTIONS(4534),
    [anon_sym___VENDOR__] = ACTIONS(4534),
    [anon_sym___VERSION__] = ACTIONS(4534),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4536),
    [sym_float_literal] = ACTIONS(4536),
    [sym__string] = ACTIONS(4536),
  },
  [1391] = {
    [sym_identifier] = ACTIONS(4538),
    [anon_sym_q_LBRACE] = ACTIONS(4540),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(4540),
    [anon_sym_DOT] = ACTIONS(4540),
    [anon_sym_AMP] = ACTIONS(4540),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_DASH_DASH] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_LPAREN] = ACTIONS(4540),
    [anon_sym_RPAREN] = ACTIONS(4540),
    [anon_sym_LBRACK] = ACTIONS(4540),
    [anon_sym_SEMI] = ACTIONS(4540),
    [anon_sym_DOLLAR] = ACTIONS(4540),
    [anon_sym_STAR] = ACTIONS(4540),
    [anon_sym_TILDE] = ACTIONS(4540),
    [anon_sym_AT] = ACTIONS(4540),
    [sym_bool] = ACTIONS(4538),
    [sym_byte] = ACTIONS(4538),
    [sym_ubyte] = ACTIONS(4538),
    [sym_char] = ACTIONS(4538),
    [sym_short] = ACTIONS(4538),
    [sym_ushort] = ACTIONS(4538),
    [sym_int] = ACTIONS(4538),
    [sym_uint] = ACTIONS(4538),
    [sym_long] = ACTIONS(4538),
    [sym_ulong] = ACTIONS(4538),
    [sym_cent] = ACTIONS(4538),
    [sym_ucent] = ACTIONS(4538),
    [sym_wchar] = ACTIONS(4538),
    [sym_dchar] = ACTIONS(4538),
    [sym_float] = ACTIONS(4538),
    [sym_double] = ACTIONS(4538),
    [sym_real] = ACTIONS(4538),
    [sym_ifloat] = ACTIONS(4538),
    [sym_idouble] = ACTIONS(4538),
    [sym_ireal] = ACTIONS(4538),
    [sym_cfloat] = ACTIONS(4538),
    [sym_cdouble] = ACTIONS(4538),
    [sym_creal] = ACTIONS(4538),
    [sym_size_t] = ACTIONS(4538),
    [sym_ptrdiff_t] = ACTIONS(4538),
    [sym_string] = ACTIONS(4538),
    [sym_cstring] = ACTIONS(4538),
    [sym_dstring] = ACTIONS(4538),
    [sym_wstring] = ACTIONS(4538),
    [sym_noreturn] = ACTIONS(4538),
    [sym_true] = ACTIONS(4538),
    [sym_false] = ACTIONS(4538),
    [sym_null] = ACTIONS(4538),
    [sym_super] = ACTIONS(4538),
    [sym_this] = ACTIONS(4538),
    [sym_abstract] = ACTIONS(4538),
    [sym_alias] = ACTIONS(4538),
    [sym_align] = ACTIONS(4538),
    [sym_asm] = ACTIONS(4538),
    [sym_assert] = ACTIONS(4538),
    [sym_auto] = ACTIONS(4538),
    [sym_break] = ACTIONS(4538),
    [sym_case] = ACTIONS(4538),
    [sym_cast] = ACTIONS(4538),
    [sym_catch] = ACTIONS(4538),
    [sym_class] = ACTIONS(4538),
    [sym_const] = ACTIONS(4538),
    [sym_continue] = ACTIONS(4538),
    [sym_debug] = ACTIONS(4538),
    [sym_default] = ACTIONS(4538),
    [sym_delegate] = ACTIONS(4538),
    [sym_delete] = ACTIONS(4538),
    [sym_deprecated] = ACTIONS(4538),
    [sym_do] = ACTIONS(4538),
    [sym_else] = ACTIONS(4538),
    [sym_enum] = ACTIONS(4538),
    [sym_export] = ACTIONS(4538),
    [sym_extern] = ACTIONS(4538),
    [sym_final] = ACTIONS(4538),
    [sym_finally] = ACTIONS(4538),
    [sym_for] = ACTIONS(4538),
    [sym_foreach] = ACTIONS(4538),
    [sym_foreach_reverse] = ACTIONS(4538),
    [sym_function] = ACTIONS(4538),
    [sym_goto] = ACTIONS(4538),
    [sym_if] = ACTIONS(4538),
    [sym_immutable] = ACTIONS(4538),
    [sym_import] = ACTIONS(4538),
    [sym_in] = ACTIONS(4538),
    [sym_inout] = ACTIONS(4538),
    [sym_interface] = ACTIONS(4538),
    [sym_invariant] = ACTIONS(4538),
    [sym_is] = ACTIONS(4538),
    [sym_mixin] = ACTIONS(4538),
    [sym_new] = ACTIONS(4538),
    [sym_nothrow] = ACTIONS(4538),
    [sym_out] = ACTIONS(4538),
    [sym_override] = ACTIONS(4538),
    [sym_package] = ACTIONS(4538),
    [sym_pragma] = ACTIONS(4538),
    [sym_private] = ACTIONS(4538),
    [sym_protected] = ACTIONS(4538),
    [sym_public] = ACTIONS(4538),
    [sym_pure] = ACTIONS(4538),
    [sym_ref] = ACTIONS(4538),
    [sym_return] = ACTIONS(4538),
    [sym_scope] = ACTIONS(4538),
    [sym_shared] = ACTIONS(4538),
    [sym_static] = ACTIONS(4538),
    [sym_struct] = ACTIONS(4538),
    [sym_switch] = ACTIONS(4538),
    [sym_synchronized] = ACTIONS(4538),
    [sym_template] = ACTIONS(4538),
    [sym_throw] = ACTIONS(4538),
    [sym_try] = ACTIONS(4538),
    [sym_typeid] = ACTIONS(4538),
    [sym_typeof] = ACTIONS(4538),
    [sym_union] = ACTIONS(4538),
    [sym_unittest] = ACTIONS(4538),
    [sym_version] = ACTIONS(4538),
    [sym_while] = ACTIONS(4538),
    [sym_with] = ACTIONS(4538),
    [sym_gshared] = ACTIONS(4538),
    [sym_traits] = ACTIONS(4538),
    [sym_vector] = ACTIONS(4538),
    [sym_void] = ACTIONS(4538),
    [anon_sym_BQUOTE] = ACTIONS(4540),
    [anon_sym_r_DQUOTE] = ACTIONS(4540),
    [anon_sym_x_DQUOTE] = ACTIONS(4540),
    [anon_sym_DQUOTE] = ACTIONS(4540),
    [anon_sym_i_BQUOTE] = ACTIONS(4540),
    [anon_sym_i_DQUOTE] = ACTIONS(4540),
    [anon_sym_iq_LBRACE] = ACTIONS(4540),
    [aux_sym_char_literal_token1] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4538),
    [anon_sym___DATE__] = ACTIONS(4538),
    [anon_sym___FILE__] = ACTIONS(4538),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4538),
    [anon_sym___FUNCTION__] = ACTIONS(4538),
    [anon_sym___LINE__] = ACTIONS(4538),
    [anon_sym___MODULE__] = ACTIONS(4538),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4538),
    [anon_sym___TIME__] = ACTIONS(4538),
    [anon_sym___TIMESTAMP__] = ACTIONS(4538),
    [anon_sym___VENDOR__] = ACTIONS(4538),
    [anon_sym___VERSION__] = ACTIONS(4538),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4540),
    [sym_float_literal] = ACTIONS(4540),
    [sym__string] = ACTIONS(4540),
  },
  [1392] = {
    [sym_identifier] = ACTIONS(4542),
    [anon_sym_q_LBRACE] = ACTIONS(4544),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_LBRACE] = ACTIONS(4544),
    [anon_sym_DOT] = ACTIONS(4544),
    [anon_sym_AMP] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4542),
    [anon_sym_DASH_DASH] = ACTIONS(4544),
    [anon_sym_PLUS] = ACTIONS(4542),
    [anon_sym_PLUS_PLUS] = ACTIONS(4544),
    [anon_sym_BANG] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(4544),
    [anon_sym_RPAREN] = ACTIONS(4544),
    [anon_sym_LBRACK] = ACTIONS(4544),
    [anon_sym_SEMI] = ACTIONS(4544),
    [anon_sym_DOLLAR] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_TILDE] = ACTIONS(4544),
    [anon_sym_AT] = ACTIONS(4544),
    [sym_bool] = ACTIONS(4542),
    [sym_byte] = ACTIONS(4542),
    [sym_ubyte] = ACTIONS(4542),
    [sym_char] = ACTIONS(4542),
    [sym_short] = ACTIONS(4542),
    [sym_ushort] = ACTIONS(4542),
    [sym_int] = ACTIONS(4542),
    [sym_uint] = ACTIONS(4542),
    [sym_long] = ACTIONS(4542),
    [sym_ulong] = ACTIONS(4542),
    [sym_cent] = ACTIONS(4542),
    [sym_ucent] = ACTIONS(4542),
    [sym_wchar] = ACTIONS(4542),
    [sym_dchar] = ACTIONS(4542),
    [sym_float] = ACTIONS(4542),
    [sym_double] = ACTIONS(4542),
    [sym_real] = ACTIONS(4542),
    [sym_ifloat] = ACTIONS(4542),
    [sym_idouble] = ACTIONS(4542),
    [sym_ireal] = ACTIONS(4542),
    [sym_cfloat] = ACTIONS(4542),
    [sym_cdouble] = ACTIONS(4542),
    [sym_creal] = ACTIONS(4542),
    [sym_size_t] = ACTIONS(4542),
    [sym_ptrdiff_t] = ACTIONS(4542),
    [sym_string] = ACTIONS(4542),
    [sym_cstring] = ACTIONS(4542),
    [sym_dstring] = ACTIONS(4542),
    [sym_wstring] = ACTIONS(4542),
    [sym_noreturn] = ACTIONS(4542),
    [sym_true] = ACTIONS(4542),
    [sym_false] = ACTIONS(4542),
    [sym_null] = ACTIONS(4542),
    [sym_super] = ACTIONS(4542),
    [sym_this] = ACTIONS(4542),
    [sym_abstract] = ACTIONS(4542),
    [sym_alias] = ACTIONS(4542),
    [sym_align] = ACTIONS(4542),
    [sym_asm] = ACTIONS(4542),
    [sym_assert] = ACTIONS(4542),
    [sym_auto] = ACTIONS(4542),
    [sym_break] = ACTIONS(4542),
    [sym_case] = ACTIONS(4542),
    [sym_cast] = ACTIONS(4542),
    [sym_catch] = ACTIONS(4542),
    [sym_class] = ACTIONS(4542),
    [sym_const] = ACTIONS(4542),
    [sym_continue] = ACTIONS(4542),
    [sym_debug] = ACTIONS(4542),
    [sym_default] = ACTIONS(4542),
    [sym_delegate] = ACTIONS(4542),
    [sym_delete] = ACTIONS(4542),
    [sym_deprecated] = ACTIONS(4542),
    [sym_do] = ACTIONS(4542),
    [sym_else] = ACTIONS(4542),
    [sym_enum] = ACTIONS(4542),
    [sym_export] = ACTIONS(4542),
    [sym_extern] = ACTIONS(4542),
    [sym_final] = ACTIONS(4542),
    [sym_finally] = ACTIONS(4542),
    [sym_for] = ACTIONS(4542),
    [sym_foreach] = ACTIONS(4542),
    [sym_foreach_reverse] = ACTIONS(4542),
    [sym_function] = ACTIONS(4542),
    [sym_goto] = ACTIONS(4542),
    [sym_if] = ACTIONS(4542),
    [sym_immutable] = ACTIONS(4542),
    [sym_import] = ACTIONS(4542),
    [sym_in] = ACTIONS(4542),
    [sym_inout] = ACTIONS(4542),
    [sym_interface] = ACTIONS(4542),
    [sym_invariant] = ACTIONS(4542),
    [sym_is] = ACTIONS(4542),
    [sym_mixin] = ACTIONS(4542),
    [sym_new] = ACTIONS(4542),
    [sym_nothrow] = ACTIONS(4542),
    [sym_out] = ACTIONS(4542),
    [sym_override] = ACTIONS(4542),
    [sym_package] = ACTIONS(4542),
    [sym_pragma] = ACTIONS(4542),
    [sym_private] = ACTIONS(4542),
    [sym_protected] = ACTIONS(4542),
    [sym_public] = ACTIONS(4542),
    [sym_pure] = ACTIONS(4542),
    [sym_ref] = ACTIONS(4542),
    [sym_return] = ACTIONS(4542),
    [sym_scope] = ACTIONS(4542),
    [sym_shared] = ACTIONS(4542),
    [sym_static] = ACTIONS(4542),
    [sym_struct] = ACTIONS(4542),
    [sym_switch] = ACTIONS(4542),
    [sym_synchronized] = ACTIONS(4542),
    [sym_template] = ACTIONS(4542),
    [sym_throw] = ACTIONS(4542),
    [sym_try] = ACTIONS(4542),
    [sym_typeid] = ACTIONS(4542),
    [sym_typeof] = ACTIONS(4542),
    [sym_union] = ACTIONS(4542),
    [sym_unittest] = ACTIONS(4542),
    [sym_version] = ACTIONS(4542),
    [sym_while] = ACTIONS(4542),
    [sym_with] = ACTIONS(4542),
    [sym_gshared] = ACTIONS(4542),
    [sym_traits] = ACTIONS(4542),
    [sym_vector] = ACTIONS(4542),
    [sym_void] = ACTIONS(4542),
    [anon_sym_BQUOTE] = ACTIONS(4544),
    [anon_sym_r_DQUOTE] = ACTIONS(4544),
    [anon_sym_x_DQUOTE] = ACTIONS(4544),
    [anon_sym_DQUOTE] = ACTIONS(4544),
    [anon_sym_i_BQUOTE] = ACTIONS(4544),
    [anon_sym_i_DQUOTE] = ACTIONS(4544),
    [anon_sym_iq_LBRACE] = ACTIONS(4544),
    [aux_sym_char_literal_token1] = ACTIONS(4544),
    [anon_sym_SQUOTE] = ACTIONS(4542),
    [anon_sym___DATE__] = ACTIONS(4542),
    [anon_sym___FILE__] = ACTIONS(4542),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4542),
    [anon_sym___FUNCTION__] = ACTIONS(4542),
    [anon_sym___LINE__] = ACTIONS(4542),
    [anon_sym___MODULE__] = ACTIONS(4542),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4542),
    [anon_sym___TIME__] = ACTIONS(4542),
    [anon_sym___TIMESTAMP__] = ACTIONS(4542),
    [anon_sym___VENDOR__] = ACTIONS(4542),
    [anon_sym___VERSION__] = ACTIONS(4542),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4544),
    [sym_float_literal] = ACTIONS(4544),
    [sym__string] = ACTIONS(4544),
  },
  [1393] = {
    [sym_identifier] = ACTIONS(4546),
    [anon_sym_q_LBRACE] = ACTIONS(4548),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(4548),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_DASH_DASH] = ACTIONS(4548),
    [anon_sym_PLUS] = ACTIONS(4546),
    [anon_sym_PLUS_PLUS] = ACTIONS(4548),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AT] = ACTIONS(4548),
    [sym_bool] = ACTIONS(4546),
    [sym_byte] = ACTIONS(4546),
    [sym_ubyte] = ACTIONS(4546),
    [sym_char] = ACTIONS(4546),
    [sym_short] = ACTIONS(4546),
    [sym_ushort] = ACTIONS(4546),
    [sym_int] = ACTIONS(4546),
    [sym_uint] = ACTIONS(4546),
    [sym_long] = ACTIONS(4546),
    [sym_ulong] = ACTIONS(4546),
    [sym_cent] = ACTIONS(4546),
    [sym_ucent] = ACTIONS(4546),
    [sym_wchar] = ACTIONS(4546),
    [sym_dchar] = ACTIONS(4546),
    [sym_float] = ACTIONS(4546),
    [sym_double] = ACTIONS(4546),
    [sym_real] = ACTIONS(4546),
    [sym_ifloat] = ACTIONS(4546),
    [sym_idouble] = ACTIONS(4546),
    [sym_ireal] = ACTIONS(4546),
    [sym_cfloat] = ACTIONS(4546),
    [sym_cdouble] = ACTIONS(4546),
    [sym_creal] = ACTIONS(4546),
    [sym_size_t] = ACTIONS(4546),
    [sym_ptrdiff_t] = ACTIONS(4546),
    [sym_string] = ACTIONS(4546),
    [sym_cstring] = ACTIONS(4546),
    [sym_dstring] = ACTIONS(4546),
    [sym_wstring] = ACTIONS(4546),
    [sym_noreturn] = ACTIONS(4546),
    [sym_true] = ACTIONS(4546),
    [sym_false] = ACTIONS(4546),
    [sym_null] = ACTIONS(4546),
    [sym_super] = ACTIONS(4546),
    [sym_this] = ACTIONS(4546),
    [sym_abstract] = ACTIONS(4546),
    [sym_alias] = ACTIONS(4546),
    [sym_align] = ACTIONS(4546),
    [sym_asm] = ACTIONS(4546),
    [sym_assert] = ACTIONS(4546),
    [sym_auto] = ACTIONS(4546),
    [sym_break] = ACTIONS(4546),
    [sym_case] = ACTIONS(4546),
    [sym_cast] = ACTIONS(4546),
    [sym_catch] = ACTIONS(4546),
    [sym_class] = ACTIONS(4546),
    [sym_const] = ACTIONS(4546),
    [sym_continue] = ACTIONS(4546),
    [sym_debug] = ACTIONS(4546),
    [sym_default] = ACTIONS(4546),
    [sym_delegate] = ACTIONS(4546),
    [sym_delete] = ACTIONS(4546),
    [sym_deprecated] = ACTIONS(4546),
    [sym_do] = ACTIONS(4546),
    [sym_else] = ACTIONS(4546),
    [sym_enum] = ACTIONS(4546),
    [sym_export] = ACTIONS(4546),
    [sym_extern] = ACTIONS(4546),
    [sym_final] = ACTIONS(4546),
    [sym_finally] = ACTIONS(4546),
    [sym_for] = ACTIONS(4546),
    [sym_foreach] = ACTIONS(4546),
    [sym_foreach_reverse] = ACTIONS(4546),
    [sym_function] = ACTIONS(4546),
    [sym_goto] = ACTIONS(4546),
    [sym_if] = ACTIONS(4546),
    [sym_immutable] = ACTIONS(4546),
    [sym_import] = ACTIONS(4546),
    [sym_in] = ACTIONS(4546),
    [sym_inout] = ACTIONS(4546),
    [sym_interface] = ACTIONS(4546),
    [sym_invariant] = ACTIONS(4546),
    [sym_is] = ACTIONS(4546),
    [sym_mixin] = ACTIONS(4546),
    [sym_new] = ACTIONS(4546),
    [sym_nothrow] = ACTIONS(4546),
    [sym_out] = ACTIONS(4546),
    [sym_override] = ACTIONS(4546),
    [sym_package] = ACTIONS(4546),
    [sym_pragma] = ACTIONS(4546),
    [sym_private] = ACTIONS(4546),
    [sym_protected] = ACTIONS(4546),
    [sym_public] = ACTIONS(4546),
    [sym_pure] = ACTIONS(4546),
    [sym_ref] = ACTIONS(4546),
    [sym_return] = ACTIONS(4546),
    [sym_scope] = ACTIONS(4546),
    [sym_shared] = ACTIONS(4546),
    [sym_static] = ACTIONS(4546),
    [sym_struct] = ACTIONS(4546),
    [sym_switch] = ACTIONS(4546),
    [sym_synchronized] = ACTIONS(4546),
    [sym_template] = ACTIONS(4546),
    [sym_throw] = ACTIONS(4546),
    [sym_try] = ACTIONS(4546),
    [sym_typeid] = ACTIONS(4546),
    [sym_typeof] = ACTIONS(4546),
    [sym_union] = ACTIONS(4546),
    [sym_unittest] = ACTIONS(4546),
    [sym_version] = ACTIONS(4546),
    [sym_while] = ACTIONS(4546),
    [sym_with] = ACTIONS(4546),
    [sym_gshared] = ACTIONS(4546),
    [sym_traits] = ACTIONS(4546),
    [sym_vector] = ACTIONS(4546),
    [sym_void] = ACTIONS(4546),
    [anon_sym_BQUOTE] = ACTIONS(4548),
    [anon_sym_r_DQUOTE] = ACTIONS(4548),
    [anon_sym_x_DQUOTE] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4548),
    [anon_sym_i_BQUOTE] = ACTIONS(4548),
    [anon_sym_i_DQUOTE] = ACTIONS(4548),
    [anon_sym_iq_LBRACE] = ACTIONS(4548),
    [aux_sym_char_literal_token1] = ACTIONS(4548),
    [anon_sym_SQUOTE] = ACTIONS(4546),
    [anon_sym___DATE__] = ACTIONS(4546),
    [anon_sym___FILE__] = ACTIONS(4546),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4546),
    [anon_sym___FUNCTION__] = ACTIONS(4546),
    [anon_sym___LINE__] = ACTIONS(4546),
    [anon_sym___MODULE__] = ACTIONS(4546),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4546),
    [anon_sym___TIME__] = ACTIONS(4546),
    [anon_sym___TIMESTAMP__] = ACTIONS(4546),
    [anon_sym___VENDOR__] = ACTIONS(4546),
    [anon_sym___VERSION__] = ACTIONS(4546),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4548),
    [sym_float_literal] = ACTIONS(4548),
    [sym__string] = ACTIONS(4548),
  },
  [1394] = {
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_q_LBRACE] = ACTIONS(4552),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_LBRACE] = ACTIONS(4552),
    [anon_sym_DOT] = ACTIONS(4552),
    [anon_sym_AMP] = ACTIONS(4552),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_DASH_DASH] = ACTIONS(4552),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_PLUS_PLUS] = ACTIONS(4552),
    [anon_sym_BANG] = ACTIONS(4552),
    [anon_sym_LPAREN] = ACTIONS(4552),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_LBRACK] = ACTIONS(4552),
    [anon_sym_SEMI] = ACTIONS(4552),
    [anon_sym_DOLLAR] = ACTIONS(4552),
    [anon_sym_STAR] = ACTIONS(4552),
    [anon_sym_TILDE] = ACTIONS(4552),
    [anon_sym_AT] = ACTIONS(4552),
    [sym_bool] = ACTIONS(4550),
    [sym_byte] = ACTIONS(4550),
    [sym_ubyte] = ACTIONS(4550),
    [sym_char] = ACTIONS(4550),
    [sym_short] = ACTIONS(4550),
    [sym_ushort] = ACTIONS(4550),
    [sym_int] = ACTIONS(4550),
    [sym_uint] = ACTIONS(4550),
    [sym_long] = ACTIONS(4550),
    [sym_ulong] = ACTIONS(4550),
    [sym_cent] = ACTIONS(4550),
    [sym_ucent] = ACTIONS(4550),
    [sym_wchar] = ACTIONS(4550),
    [sym_dchar] = ACTIONS(4550),
    [sym_float] = ACTIONS(4550),
    [sym_double] = ACTIONS(4550),
    [sym_real] = ACTIONS(4550),
    [sym_ifloat] = ACTIONS(4550),
    [sym_idouble] = ACTIONS(4550),
    [sym_ireal] = ACTIONS(4550),
    [sym_cfloat] = ACTIONS(4550),
    [sym_cdouble] = ACTIONS(4550),
    [sym_creal] = ACTIONS(4550),
    [sym_size_t] = ACTIONS(4550),
    [sym_ptrdiff_t] = ACTIONS(4550),
    [sym_string] = ACTIONS(4550),
    [sym_cstring] = ACTIONS(4550),
    [sym_dstring] = ACTIONS(4550),
    [sym_wstring] = ACTIONS(4550),
    [sym_noreturn] = ACTIONS(4550),
    [sym_true] = ACTIONS(4550),
    [sym_false] = ACTIONS(4550),
    [sym_null] = ACTIONS(4550),
    [sym_super] = ACTIONS(4550),
    [sym_this] = ACTIONS(4550),
    [sym_abstract] = ACTIONS(4550),
    [sym_alias] = ACTIONS(4550),
    [sym_align] = ACTIONS(4550),
    [sym_asm] = ACTIONS(4550),
    [sym_assert] = ACTIONS(4550),
    [sym_auto] = ACTIONS(4550),
    [sym_break] = ACTIONS(4550),
    [sym_case] = ACTIONS(4550),
    [sym_cast] = ACTIONS(4550),
    [sym_catch] = ACTIONS(4550),
    [sym_class] = ACTIONS(4550),
    [sym_const] = ACTIONS(4550),
    [sym_continue] = ACTIONS(4550),
    [sym_debug] = ACTIONS(4550),
    [sym_default] = ACTIONS(4550),
    [sym_delegate] = ACTIONS(4550),
    [sym_delete] = ACTIONS(4550),
    [sym_deprecated] = ACTIONS(4550),
    [sym_do] = ACTIONS(4550),
    [sym_else] = ACTIONS(4550),
    [sym_enum] = ACTIONS(4550),
    [sym_export] = ACTIONS(4550),
    [sym_extern] = ACTIONS(4550),
    [sym_final] = ACTIONS(4550),
    [sym_finally] = ACTIONS(4550),
    [sym_for] = ACTIONS(4550),
    [sym_foreach] = ACTIONS(4550),
    [sym_foreach_reverse] = ACTIONS(4550),
    [sym_function] = ACTIONS(4550),
    [sym_goto] = ACTIONS(4550),
    [sym_if] = ACTIONS(4550),
    [sym_immutable] = ACTIONS(4550),
    [sym_import] = ACTIONS(4550),
    [sym_in] = ACTIONS(4550),
    [sym_inout] = ACTIONS(4550),
    [sym_interface] = ACTIONS(4550),
    [sym_invariant] = ACTIONS(4550),
    [sym_is] = ACTIONS(4550),
    [sym_mixin] = ACTIONS(4550),
    [sym_new] = ACTIONS(4550),
    [sym_nothrow] = ACTIONS(4550),
    [sym_out] = ACTIONS(4550),
    [sym_override] = ACTIONS(4550),
    [sym_package] = ACTIONS(4550),
    [sym_pragma] = ACTIONS(4550),
    [sym_private] = ACTIONS(4550),
    [sym_protected] = ACTIONS(4550),
    [sym_public] = ACTIONS(4550),
    [sym_pure] = ACTIONS(4550),
    [sym_ref] = ACTIONS(4550),
    [sym_return] = ACTIONS(4550),
    [sym_scope] = ACTIONS(4550),
    [sym_shared] = ACTIONS(4550),
    [sym_static] = ACTIONS(4550),
    [sym_struct] = ACTIONS(4550),
    [sym_switch] = ACTIONS(4550),
    [sym_synchronized] = ACTIONS(4550),
    [sym_template] = ACTIONS(4550),
    [sym_throw] = ACTIONS(4550),
    [sym_try] = ACTIONS(4550),
    [sym_typeid] = ACTIONS(4550),
    [sym_typeof] = ACTIONS(4550),
    [sym_union] = ACTIONS(4550),
    [sym_unittest] = ACTIONS(4550),
    [sym_version] = ACTIONS(4550),
    [sym_while] = ACTIONS(4550),
    [sym_with] = ACTIONS(4550),
    [sym_gshared] = ACTIONS(4550),
    [sym_traits] = ACTIONS(4550),
    [sym_vector] = ACTIONS(4550),
    [sym_void] = ACTIONS(4550),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [anon_sym_r_DQUOTE] = ACTIONS(4552),
    [anon_sym_x_DQUOTE] = ACTIONS(4552),
    [anon_sym_DQUOTE] = ACTIONS(4552),
    [anon_sym_i_BQUOTE] = ACTIONS(4552),
    [anon_sym_i_DQUOTE] = ACTIONS(4552),
    [anon_sym_iq_LBRACE] = ACTIONS(4552),
    [aux_sym_char_literal_token1] = ACTIONS(4552),
    [anon_sym_SQUOTE] = ACTIONS(4550),
    [anon_sym___DATE__] = ACTIONS(4550),
    [anon_sym___FILE__] = ACTIONS(4550),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4550),
    [anon_sym___FUNCTION__] = ACTIONS(4550),
    [anon_sym___LINE__] = ACTIONS(4550),
    [anon_sym___MODULE__] = ACTIONS(4550),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4550),
    [anon_sym___TIME__] = ACTIONS(4550),
    [anon_sym___TIMESTAMP__] = ACTIONS(4550),
    [anon_sym___VENDOR__] = ACTIONS(4550),
    [anon_sym___VERSION__] = ACTIONS(4550),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4552),
    [sym_float_literal] = ACTIONS(4552),
    [sym__string] = ACTIONS(4552),
  },
  [1395] = {
    [sym_identifier] = ACTIONS(4554),
    [anon_sym_q_LBRACE] = ACTIONS(4556),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4556),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4554),
    [anon_sym_DASH_DASH] = ACTIONS(4556),
    [anon_sym_PLUS] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4556),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_LPAREN] = ACTIONS(4556),
    [anon_sym_RPAREN] = ACTIONS(4556),
    [anon_sym_LBRACK] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4556),
    [anon_sym_DOLLAR] = ACTIONS(4556),
    [anon_sym_STAR] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [anon_sym_AT] = ACTIONS(4556),
    [sym_bool] = ACTIONS(4554),
    [sym_byte] = ACTIONS(4554),
    [sym_ubyte] = ACTIONS(4554),
    [sym_char] = ACTIONS(4554),
    [sym_short] = ACTIONS(4554),
    [sym_ushort] = ACTIONS(4554),
    [sym_int] = ACTIONS(4554),
    [sym_uint] = ACTIONS(4554),
    [sym_long] = ACTIONS(4554),
    [sym_ulong] = ACTIONS(4554),
    [sym_cent] = ACTIONS(4554),
    [sym_ucent] = ACTIONS(4554),
    [sym_wchar] = ACTIONS(4554),
    [sym_dchar] = ACTIONS(4554),
    [sym_float] = ACTIONS(4554),
    [sym_double] = ACTIONS(4554),
    [sym_real] = ACTIONS(4554),
    [sym_ifloat] = ACTIONS(4554),
    [sym_idouble] = ACTIONS(4554),
    [sym_ireal] = ACTIONS(4554),
    [sym_cfloat] = ACTIONS(4554),
    [sym_cdouble] = ACTIONS(4554),
    [sym_creal] = ACTIONS(4554),
    [sym_size_t] = ACTIONS(4554),
    [sym_ptrdiff_t] = ACTIONS(4554),
    [sym_string] = ACTIONS(4554),
    [sym_cstring] = ACTIONS(4554),
    [sym_dstring] = ACTIONS(4554),
    [sym_wstring] = ACTIONS(4554),
    [sym_noreturn] = ACTIONS(4554),
    [sym_true] = ACTIONS(4554),
    [sym_false] = ACTIONS(4554),
    [sym_null] = ACTIONS(4554),
    [sym_super] = ACTIONS(4554),
    [sym_this] = ACTIONS(4554),
    [sym_abstract] = ACTIONS(4554),
    [sym_alias] = ACTIONS(4554),
    [sym_align] = ACTIONS(4554),
    [sym_asm] = ACTIONS(4554),
    [sym_assert] = ACTIONS(4554),
    [sym_auto] = ACTIONS(4554),
    [sym_break] = ACTIONS(4554),
    [sym_case] = ACTIONS(4554),
    [sym_cast] = ACTIONS(4554),
    [sym_catch] = ACTIONS(4554),
    [sym_class] = ACTIONS(4554),
    [sym_const] = ACTIONS(4554),
    [sym_continue] = ACTIONS(4554),
    [sym_debug] = ACTIONS(4554),
    [sym_default] = ACTIONS(4554),
    [sym_delegate] = ACTIONS(4554),
    [sym_delete] = ACTIONS(4554),
    [sym_deprecated] = ACTIONS(4554),
    [sym_do] = ACTIONS(4554),
    [sym_else] = ACTIONS(4554),
    [sym_enum] = ACTIONS(4554),
    [sym_export] = ACTIONS(4554),
    [sym_extern] = ACTIONS(4554),
    [sym_final] = ACTIONS(4554),
    [sym_finally] = ACTIONS(4554),
    [sym_for] = ACTIONS(4554),
    [sym_foreach] = ACTIONS(4554),
    [sym_foreach_reverse] = ACTIONS(4554),
    [sym_function] = ACTIONS(4554),
    [sym_goto] = ACTIONS(4554),
    [sym_if] = ACTIONS(4554),
    [sym_immutable] = ACTIONS(4554),
    [sym_import] = ACTIONS(4554),
    [sym_in] = ACTIONS(4554),
    [sym_inout] = ACTIONS(4554),
    [sym_interface] = ACTIONS(4554),
    [sym_invariant] = ACTIONS(4554),
    [sym_is] = ACTIONS(4554),
    [sym_mixin] = ACTIONS(4554),
    [sym_new] = ACTIONS(4554),
    [sym_nothrow] = ACTIONS(4554),
    [sym_out] = ACTIONS(4554),
    [sym_override] = ACTIONS(4554),
    [sym_package] = ACTIONS(4554),
    [sym_pragma] = ACTIONS(4554),
    [sym_private] = ACTIONS(4554),
    [sym_protected] = ACTIONS(4554),
    [sym_public] = ACTIONS(4554),
    [sym_pure] = ACTIONS(4554),
    [sym_ref] = ACTIONS(4554),
    [sym_return] = ACTIONS(4554),
    [sym_scope] = ACTIONS(4554),
    [sym_shared] = ACTIONS(4554),
    [sym_static] = ACTIONS(4554),
    [sym_struct] = ACTIONS(4554),
    [sym_switch] = ACTIONS(4554),
    [sym_synchronized] = ACTIONS(4554),
    [sym_template] = ACTIONS(4554),
    [sym_throw] = ACTIONS(4554),
    [sym_try] = ACTIONS(4554),
    [sym_typeid] = ACTIONS(4554),
    [sym_typeof] = ACTIONS(4554),
    [sym_union] = ACTIONS(4554),
    [sym_unittest] = ACTIONS(4554),
    [sym_version] = ACTIONS(4554),
    [sym_while] = ACTIONS(4554),
    [sym_with] = ACTIONS(4554),
    [sym_gshared] = ACTIONS(4554),
    [sym_traits] = ACTIONS(4554),
    [sym_vector] = ACTIONS(4554),
    [sym_void] = ACTIONS(4554),
    [anon_sym_BQUOTE] = ACTIONS(4556),
    [anon_sym_r_DQUOTE] = ACTIONS(4556),
    [anon_sym_x_DQUOTE] = ACTIONS(4556),
    [anon_sym_DQUOTE] = ACTIONS(4556),
    [anon_sym_i_BQUOTE] = ACTIONS(4556),
    [anon_sym_i_DQUOTE] = ACTIONS(4556),
    [anon_sym_iq_LBRACE] = ACTIONS(4556),
    [aux_sym_char_literal_token1] = ACTIONS(4556),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym___DATE__] = ACTIONS(4554),
    [anon_sym___FILE__] = ACTIONS(4554),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4554),
    [anon_sym___FUNCTION__] = ACTIONS(4554),
    [anon_sym___LINE__] = ACTIONS(4554),
    [anon_sym___MODULE__] = ACTIONS(4554),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4554),
    [anon_sym___TIME__] = ACTIONS(4554),
    [anon_sym___TIMESTAMP__] = ACTIONS(4554),
    [anon_sym___VENDOR__] = ACTIONS(4554),
    [anon_sym___VERSION__] = ACTIONS(4554),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4556),
    [sym_float_literal] = ACTIONS(4556),
    [sym__string] = ACTIONS(4556),
  },
  [1396] = {
    [sym_identifier] = ACTIONS(4558),
    [anon_sym_q_LBRACE] = ACTIONS(4560),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_LBRACE] = ACTIONS(4560),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4560),
    [anon_sym_DASH] = ACTIONS(4558),
    [anon_sym_DASH_DASH] = ACTIONS(4560),
    [anon_sym_PLUS] = ACTIONS(4558),
    [anon_sym_PLUS_PLUS] = ACTIONS(4560),
    [anon_sym_BANG] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(4560),
    [anon_sym_RPAREN] = ACTIONS(4560),
    [anon_sym_LBRACK] = ACTIONS(4560),
    [anon_sym_SEMI] = ACTIONS(4560),
    [anon_sym_DOLLAR] = ACTIONS(4560),
    [anon_sym_STAR] = ACTIONS(4560),
    [anon_sym_TILDE] = ACTIONS(4560),
    [anon_sym_AT] = ACTIONS(4560),
    [sym_bool] = ACTIONS(4558),
    [sym_byte] = ACTIONS(4558),
    [sym_ubyte] = ACTIONS(4558),
    [sym_char] = ACTIONS(4558),
    [sym_short] = ACTIONS(4558),
    [sym_ushort] = ACTIONS(4558),
    [sym_int] = ACTIONS(4558),
    [sym_uint] = ACTIONS(4558),
    [sym_long] = ACTIONS(4558),
    [sym_ulong] = ACTIONS(4558),
    [sym_cent] = ACTIONS(4558),
    [sym_ucent] = ACTIONS(4558),
    [sym_wchar] = ACTIONS(4558),
    [sym_dchar] = ACTIONS(4558),
    [sym_float] = ACTIONS(4558),
    [sym_double] = ACTIONS(4558),
    [sym_real] = ACTIONS(4558),
    [sym_ifloat] = ACTIONS(4558),
    [sym_idouble] = ACTIONS(4558),
    [sym_ireal] = ACTIONS(4558),
    [sym_cfloat] = ACTIONS(4558),
    [sym_cdouble] = ACTIONS(4558),
    [sym_creal] = ACTIONS(4558),
    [sym_size_t] = ACTIONS(4558),
    [sym_ptrdiff_t] = ACTIONS(4558),
    [sym_string] = ACTIONS(4558),
    [sym_cstring] = ACTIONS(4558),
    [sym_dstring] = ACTIONS(4558),
    [sym_wstring] = ACTIONS(4558),
    [sym_noreturn] = ACTIONS(4558),
    [sym_true] = ACTIONS(4558),
    [sym_false] = ACTIONS(4558),
    [sym_null] = ACTIONS(4558),
    [sym_super] = ACTIONS(4558),
    [sym_this] = ACTIONS(4558),
    [sym_abstract] = ACTIONS(4558),
    [sym_alias] = ACTIONS(4558),
    [sym_align] = ACTIONS(4558),
    [sym_asm] = ACTIONS(4558),
    [sym_assert] = ACTIONS(4558),
    [sym_auto] = ACTIONS(4558),
    [sym_break] = ACTIONS(4558),
    [sym_case] = ACTIONS(4558),
    [sym_cast] = ACTIONS(4558),
    [sym_catch] = ACTIONS(4558),
    [sym_class] = ACTIONS(4558),
    [sym_const] = ACTIONS(4558),
    [sym_continue] = ACTIONS(4558),
    [sym_debug] = ACTIONS(4558),
    [sym_default] = ACTIONS(4558),
    [sym_delegate] = ACTIONS(4558),
    [sym_delete] = ACTIONS(4558),
    [sym_deprecated] = ACTIONS(4558),
    [sym_do] = ACTIONS(4558),
    [sym_else] = ACTIONS(4558),
    [sym_enum] = ACTIONS(4558),
    [sym_export] = ACTIONS(4558),
    [sym_extern] = ACTIONS(4558),
    [sym_final] = ACTIONS(4558),
    [sym_finally] = ACTIONS(4558),
    [sym_for] = ACTIONS(4558),
    [sym_foreach] = ACTIONS(4558),
    [sym_foreach_reverse] = ACTIONS(4558),
    [sym_function] = ACTIONS(4558),
    [sym_goto] = ACTIONS(4558),
    [sym_if] = ACTIONS(4558),
    [sym_immutable] = ACTIONS(4558),
    [sym_import] = ACTIONS(4558),
    [sym_in] = ACTIONS(4558),
    [sym_inout] = ACTIONS(4558),
    [sym_interface] = ACTIONS(4558),
    [sym_invariant] = ACTIONS(4558),
    [sym_is] = ACTIONS(4558),
    [sym_mixin] = ACTIONS(4558),
    [sym_new] = ACTIONS(4558),
    [sym_nothrow] = ACTIONS(4558),
    [sym_out] = ACTIONS(4558),
    [sym_override] = ACTIONS(4558),
    [sym_package] = ACTIONS(4558),
    [sym_pragma] = ACTIONS(4558),
    [sym_private] = ACTIONS(4558),
    [sym_protected] = ACTIONS(4558),
    [sym_public] = ACTIONS(4558),
    [sym_pure] = ACTIONS(4558),
    [sym_ref] = ACTIONS(4558),
    [sym_return] = ACTIONS(4558),
    [sym_scope] = ACTIONS(4558),
    [sym_shared] = ACTIONS(4558),
    [sym_static] = ACTIONS(4558),
    [sym_struct] = ACTIONS(4558),
    [sym_switch] = ACTIONS(4558),
    [sym_synchronized] = ACTIONS(4558),
    [sym_template] = ACTIONS(4558),
    [sym_throw] = ACTIONS(4558),
    [sym_try] = ACTIONS(4558),
    [sym_typeid] = ACTIONS(4558),
    [sym_typeof] = ACTIONS(4558),
    [sym_union] = ACTIONS(4558),
    [sym_unittest] = ACTIONS(4558),
    [sym_version] = ACTIONS(4558),
    [sym_while] = ACTIONS(4558),
    [sym_with] = ACTIONS(4558),
    [sym_gshared] = ACTIONS(4558),
    [sym_traits] = ACTIONS(4558),
    [sym_vector] = ACTIONS(4558),
    [sym_void] = ACTIONS(4558),
    [anon_sym_BQUOTE] = ACTIONS(4560),
    [anon_sym_r_DQUOTE] = ACTIONS(4560),
    [anon_sym_x_DQUOTE] = ACTIONS(4560),
    [anon_sym_DQUOTE] = ACTIONS(4560),
    [anon_sym_i_BQUOTE] = ACTIONS(4560),
    [anon_sym_i_DQUOTE] = ACTIONS(4560),
    [anon_sym_iq_LBRACE] = ACTIONS(4560),
    [aux_sym_char_literal_token1] = ACTIONS(4560),
    [anon_sym_SQUOTE] = ACTIONS(4558),
    [anon_sym___DATE__] = ACTIONS(4558),
    [anon_sym___FILE__] = ACTIONS(4558),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4558),
    [anon_sym___FUNCTION__] = ACTIONS(4558),
    [anon_sym___LINE__] = ACTIONS(4558),
    [anon_sym___MODULE__] = ACTIONS(4558),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4558),
    [anon_sym___TIME__] = ACTIONS(4558),
    [anon_sym___TIMESTAMP__] = ACTIONS(4558),
    [anon_sym___VENDOR__] = ACTIONS(4558),
    [anon_sym___VERSION__] = ACTIONS(4558),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4560),
    [sym_float_literal] = ACTIONS(4560),
    [sym__string] = ACTIONS(4560),
  },
  [1397] = {
    [sym_identifier] = ACTIONS(4562),
    [anon_sym_q_LBRACE] = ACTIONS(4564),
    [anon_sym_RBRACE] = ACTIONS(4564),
    [anon_sym_LBRACE] = ACTIONS(4564),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4562),
    [anon_sym_DASH_DASH] = ACTIONS(4564),
    [anon_sym_PLUS] = ACTIONS(4562),
    [anon_sym_PLUS_PLUS] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_LPAREN] = ACTIONS(4564),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_LBRACK] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_DOLLAR] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_TILDE] = ACTIONS(4564),
    [anon_sym_AT] = ACTIONS(4564),
    [sym_bool] = ACTIONS(4562),
    [sym_byte] = ACTIONS(4562),
    [sym_ubyte] = ACTIONS(4562),
    [sym_char] = ACTIONS(4562),
    [sym_short] = ACTIONS(4562),
    [sym_ushort] = ACTIONS(4562),
    [sym_int] = ACTIONS(4562),
    [sym_uint] = ACTIONS(4562),
    [sym_long] = ACTIONS(4562),
    [sym_ulong] = ACTIONS(4562),
    [sym_cent] = ACTIONS(4562),
    [sym_ucent] = ACTIONS(4562),
    [sym_wchar] = ACTIONS(4562),
    [sym_dchar] = ACTIONS(4562),
    [sym_float] = ACTIONS(4562),
    [sym_double] = ACTIONS(4562),
    [sym_real] = ACTIONS(4562),
    [sym_ifloat] = ACTIONS(4562),
    [sym_idouble] = ACTIONS(4562),
    [sym_ireal] = ACTIONS(4562),
    [sym_cfloat] = ACTIONS(4562),
    [sym_cdouble] = ACTIONS(4562),
    [sym_creal] = ACTIONS(4562),
    [sym_size_t] = ACTIONS(4562),
    [sym_ptrdiff_t] = ACTIONS(4562),
    [sym_string] = ACTIONS(4562),
    [sym_cstring] = ACTIONS(4562),
    [sym_dstring] = ACTIONS(4562),
    [sym_wstring] = ACTIONS(4562),
    [sym_noreturn] = ACTIONS(4562),
    [sym_true] = ACTIONS(4562),
    [sym_false] = ACTIONS(4562),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(4562),
    [sym_this] = ACTIONS(4562),
    [sym_abstract] = ACTIONS(4562),
    [sym_alias] = ACTIONS(4562),
    [sym_align] = ACTIONS(4562),
    [sym_asm] = ACTIONS(4562),
    [sym_assert] = ACTIONS(4562),
    [sym_auto] = ACTIONS(4562),
    [sym_break] = ACTIONS(4562),
    [sym_case] = ACTIONS(4562),
    [sym_cast] = ACTIONS(4562),
    [sym_catch] = ACTIONS(4562),
    [sym_class] = ACTIONS(4562),
    [sym_const] = ACTIONS(4562),
    [sym_continue] = ACTIONS(4562),
    [sym_debug] = ACTIONS(4562),
    [sym_default] = ACTIONS(4562),
    [sym_delegate] = ACTIONS(4562),
    [sym_delete] = ACTIONS(4562),
    [sym_deprecated] = ACTIONS(4562),
    [sym_do] = ACTIONS(4562),
    [sym_else] = ACTIONS(4562),
    [sym_enum] = ACTIONS(4562),
    [sym_export] = ACTIONS(4562),
    [sym_extern] = ACTIONS(4562),
    [sym_final] = ACTIONS(4562),
    [sym_finally] = ACTIONS(4562),
    [sym_for] = ACTIONS(4562),
    [sym_foreach] = ACTIONS(4562),
    [sym_foreach_reverse] = ACTIONS(4562),
    [sym_function] = ACTIONS(4562),
    [sym_goto] = ACTIONS(4562),
    [sym_if] = ACTIONS(4562),
    [sym_immutable] = ACTIONS(4562),
    [sym_import] = ACTIONS(4562),
    [sym_in] = ACTIONS(4562),
    [sym_inout] = ACTIONS(4562),
    [sym_interface] = ACTIONS(4562),
    [sym_invariant] = ACTIONS(4562),
    [sym_is] = ACTIONS(4562),
    [sym_mixin] = ACTIONS(4562),
    [sym_new] = ACTIONS(4562),
    [sym_nothrow] = ACTIONS(4562),
    [sym_out] = ACTIONS(4562),
    [sym_override] = ACTIONS(4562),
    [sym_package] = ACTIONS(4562),
    [sym_pragma] = ACTIONS(4562),
    [sym_private] = ACTIONS(4562),
    [sym_protected] = ACTIONS(4562),
    [sym_public] = ACTIONS(4562),
    [sym_pure] = ACTIONS(4562),
    [sym_ref] = ACTIONS(4562),
    [sym_return] = ACTIONS(4562),
    [sym_scope] = ACTIONS(4562),
    [sym_shared] = ACTIONS(4562),
    [sym_static] = ACTIONS(4562),
    [sym_struct] = ACTIONS(4562),
    [sym_switch] = ACTIONS(4562),
    [sym_synchronized] = ACTIONS(4562),
    [sym_template] = ACTIONS(4562),
    [sym_throw] = ACTIONS(4562),
    [sym_try] = ACTIONS(4562),
    [sym_typeid] = ACTIONS(4562),
    [sym_typeof] = ACTIONS(4562),
    [sym_union] = ACTIONS(4562),
    [sym_unittest] = ACTIONS(4562),
    [sym_version] = ACTIONS(4562),
    [sym_while] = ACTIONS(4562),
    [sym_with] = ACTIONS(4562),
    [sym_gshared] = ACTIONS(4562),
    [sym_traits] = ACTIONS(4562),
    [sym_vector] = ACTIONS(4562),
    [sym_void] = ACTIONS(4562),
    [anon_sym_BQUOTE] = ACTIONS(4564),
    [anon_sym_r_DQUOTE] = ACTIONS(4564),
    [anon_sym_x_DQUOTE] = ACTIONS(4564),
    [anon_sym_DQUOTE] = ACTIONS(4564),
    [anon_sym_i_BQUOTE] = ACTIONS(4564),
    [anon_sym_i_DQUOTE] = ACTIONS(4564),
    [anon_sym_iq_LBRACE] = ACTIONS(4564),
    [aux_sym_char_literal_token1] = ACTIONS(4564),
    [anon_sym_SQUOTE] = ACTIONS(4562),
    [anon_sym___DATE__] = ACTIONS(4562),
    [anon_sym___FILE__] = ACTIONS(4562),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4562),
    [anon_sym___FUNCTION__] = ACTIONS(4562),
    [anon_sym___LINE__] = ACTIONS(4562),
    [anon_sym___MODULE__] = ACTIONS(4562),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4562),
    [anon_sym___TIME__] = ACTIONS(4562),
    [anon_sym___TIMESTAMP__] = ACTIONS(4562),
    [anon_sym___VENDOR__] = ACTIONS(4562),
    [anon_sym___VERSION__] = ACTIONS(4562),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4564),
    [sym_float_literal] = ACTIONS(4564),
    [sym__string] = ACTIONS(4564),
  },
  [1398] = {
    [sym_identifier] = ACTIONS(4566),
    [anon_sym_q_LBRACE] = ACTIONS(4568),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_LBRACE] = ACTIONS(4568),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4568),
    [anon_sym_PLUS] = ACTIONS(4566),
    [anon_sym_PLUS_PLUS] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_LPAREN] = ACTIONS(4568),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_AT] = ACTIONS(4568),
    [sym_bool] = ACTIONS(4566),
    [sym_byte] = ACTIONS(4566),
    [sym_ubyte] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_short] = ACTIONS(4566),
    [sym_ushort] = ACTIONS(4566),
    [sym_int] = ACTIONS(4566),
    [sym_uint] = ACTIONS(4566),
    [sym_long] = ACTIONS(4566),
    [sym_ulong] = ACTIONS(4566),
    [sym_cent] = ACTIONS(4566),
    [sym_ucent] = ACTIONS(4566),
    [sym_wchar] = ACTIONS(4566),
    [sym_dchar] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_double] = ACTIONS(4566),
    [sym_real] = ACTIONS(4566),
    [sym_ifloat] = ACTIONS(4566),
    [sym_idouble] = ACTIONS(4566),
    [sym_ireal] = ACTIONS(4566),
    [sym_cfloat] = ACTIONS(4566),
    [sym_cdouble] = ACTIONS(4566),
    [sym_creal] = ACTIONS(4566),
    [sym_size_t] = ACTIONS(4566),
    [sym_ptrdiff_t] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym_cstring] = ACTIONS(4566),
    [sym_dstring] = ACTIONS(4566),
    [sym_wstring] = ACTIONS(4566),
    [sym_noreturn] = ACTIONS(4566),
    [sym_true] = ACTIONS(4566),
    [sym_false] = ACTIONS(4566),
    [sym_null] = ACTIONS(4566),
    [sym_super] = ACTIONS(4566),
    [sym_this] = ACTIONS(4566),
    [sym_abstract] = ACTIONS(4566),
    [sym_alias] = ACTIONS(4566),
    [sym_align] = ACTIONS(4566),
    [sym_asm] = ACTIONS(4566),
    [sym_assert] = ACTIONS(4566),
    [sym_auto] = ACTIONS(4566),
    [sym_break] = ACTIONS(4566),
    [sym_case] = ACTIONS(4566),
    [sym_cast] = ACTIONS(4566),
    [sym_catch] = ACTIONS(4566),
    [sym_class] = ACTIONS(4566),
    [sym_const] = ACTIONS(4566),
    [sym_continue] = ACTIONS(4566),
    [sym_debug] = ACTIONS(4566),
    [sym_default] = ACTIONS(4566),
    [sym_delegate] = ACTIONS(4566),
    [sym_delete] = ACTIONS(4566),
    [sym_deprecated] = ACTIONS(4566),
    [sym_do] = ACTIONS(4566),
    [sym_else] = ACTIONS(4566),
    [sym_enum] = ACTIONS(4566),
    [sym_export] = ACTIONS(4566),
    [sym_extern] = ACTIONS(4566),
    [sym_final] = ACTIONS(4566),
    [sym_finally] = ACTIONS(4566),
    [sym_for] = ACTIONS(4566),
    [sym_foreach] = ACTIONS(4566),
    [sym_foreach_reverse] = ACTIONS(4566),
    [sym_function] = ACTIONS(4566),
    [sym_goto] = ACTIONS(4566),
    [sym_if] = ACTIONS(4566),
    [sym_immutable] = ACTIONS(4566),
    [sym_import] = ACTIONS(4566),
    [sym_in] = ACTIONS(4566),
    [sym_inout] = ACTIONS(4566),
    [sym_interface] = ACTIONS(4566),
    [sym_invariant] = ACTIONS(4566),
    [sym_is] = ACTIONS(4566),
    [sym_mixin] = ACTIONS(4566),
    [sym_new] = ACTIONS(4566),
    [sym_nothrow] = ACTIONS(4566),
    [sym_out] = ACTIONS(4566),
    [sym_override] = ACTIONS(4566),
    [sym_package] = ACTIONS(4566),
    [sym_pragma] = ACTIONS(4566),
    [sym_private] = ACTIONS(4566),
    [sym_protected] = ACTIONS(4566),
    [sym_public] = ACTIONS(4566),
    [sym_pure] = ACTIONS(4566),
    [sym_ref] = ACTIONS(4566),
    [sym_return] = ACTIONS(4566),
    [sym_scope] = ACTIONS(4566),
    [sym_shared] = ACTIONS(4566),
    [sym_static] = ACTIONS(4566),
    [sym_struct] = ACTIONS(4566),
    [sym_switch] = ACTIONS(4566),
    [sym_synchronized] = ACTIONS(4566),
    [sym_template] = ACTIONS(4566),
    [sym_throw] = ACTIONS(4566),
    [sym_try] = ACTIONS(4566),
    [sym_typeid] = ACTIONS(4566),
    [sym_typeof] = ACTIONS(4566),
    [sym_union] = ACTIONS(4566),
    [sym_unittest] = ACTIONS(4566),
    [sym_version] = ACTIONS(4566),
    [sym_while] = ACTIONS(4566),
    [sym_with] = ACTIONS(4566),
    [sym_gshared] = ACTIONS(4566),
    [sym_traits] = ACTIONS(4566),
    [sym_vector] = ACTIONS(4566),
    [sym_void] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_r_DQUOTE] = ACTIONS(4568),
    [anon_sym_x_DQUOTE] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_i_BQUOTE] = ACTIONS(4568),
    [anon_sym_i_DQUOTE] = ACTIONS(4568),
    [anon_sym_iq_LBRACE] = ACTIONS(4568),
    [aux_sym_char_literal_token1] = ACTIONS(4568),
    [anon_sym_SQUOTE] = ACTIONS(4566),
    [anon_sym___DATE__] = ACTIONS(4566),
    [anon_sym___FILE__] = ACTIONS(4566),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4566),
    [anon_sym___FUNCTION__] = ACTIONS(4566),
    [anon_sym___LINE__] = ACTIONS(4566),
    [anon_sym___MODULE__] = ACTIONS(4566),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4566),
    [anon_sym___TIME__] = ACTIONS(4566),
    [anon_sym___TIMESTAMP__] = ACTIONS(4566),
    [anon_sym___VENDOR__] = ACTIONS(4566),
    [anon_sym___VERSION__] = ACTIONS(4566),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4568),
    [sym_float_literal] = ACTIONS(4568),
    [sym__string] = ACTIONS(4568),
  },
  [1399] = {
    [sym_identifier] = ACTIONS(4570),
    [anon_sym_q_LBRACE] = ACTIONS(4572),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_LBRACE] = ACTIONS(4572),
    [anon_sym_DOT] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4572),
    [anon_sym_DASH] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4572),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_PLUS_PLUS] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4572),
    [anon_sym_LPAREN] = ACTIONS(4572),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4572),
    [anon_sym_STAR] = ACTIONS(4572),
    [anon_sym_TILDE] = ACTIONS(4572),
    [anon_sym_AT] = ACTIONS(4572),
    [sym_bool] = ACTIONS(4570),
    [sym_byte] = ACTIONS(4570),
    [sym_ubyte] = ACTIONS(4570),
    [sym_char] = ACTIONS(4570),
    [sym_short] = ACTIONS(4570),
    [sym_ushort] = ACTIONS(4570),
    [sym_int] = ACTIONS(4570),
    [sym_uint] = ACTIONS(4570),
    [sym_long] = ACTIONS(4570),
    [sym_ulong] = ACTIONS(4570),
    [sym_cent] = ACTIONS(4570),
    [sym_ucent] = ACTIONS(4570),
    [sym_wchar] = ACTIONS(4570),
    [sym_dchar] = ACTIONS(4570),
    [sym_float] = ACTIONS(4570),
    [sym_double] = ACTIONS(4570),
    [sym_real] = ACTIONS(4570),
    [sym_ifloat] = ACTIONS(4570),
    [sym_idouble] = ACTIONS(4570),
    [sym_ireal] = ACTIONS(4570),
    [sym_cfloat] = ACTIONS(4570),
    [sym_cdouble] = ACTIONS(4570),
    [sym_creal] = ACTIONS(4570),
    [sym_size_t] = ACTIONS(4570),
    [sym_ptrdiff_t] = ACTIONS(4570),
    [sym_string] = ACTIONS(4570),
    [sym_cstring] = ACTIONS(4570),
    [sym_dstring] = ACTIONS(4570),
    [sym_wstring] = ACTIONS(4570),
    [sym_noreturn] = ACTIONS(4570),
    [sym_true] = ACTIONS(4570),
    [sym_false] = ACTIONS(4570),
    [sym_null] = ACTIONS(4570),
    [sym_super] = ACTIONS(4570),
    [sym_this] = ACTIONS(4570),
    [sym_abstract] = ACTIONS(4570),
    [sym_alias] = ACTIONS(4570),
    [sym_align] = ACTIONS(4570),
    [sym_asm] = ACTIONS(4570),
    [sym_assert] = ACTIONS(4570),
    [sym_auto] = ACTIONS(4570),
    [sym_break] = ACTIONS(4570),
    [sym_case] = ACTIONS(4570),
    [sym_cast] = ACTIONS(4570),
    [sym_catch] = ACTIONS(4570),
    [sym_class] = ACTIONS(4570),
    [sym_const] = ACTIONS(4570),
    [sym_continue] = ACTIONS(4570),
    [sym_debug] = ACTIONS(4570),
    [sym_default] = ACTIONS(4570),
    [sym_delegate] = ACTIONS(4570),
    [sym_delete] = ACTIONS(4570),
    [sym_deprecated] = ACTIONS(4570),
    [sym_do] = ACTIONS(4570),
    [sym_else] = ACTIONS(4570),
    [sym_enum] = ACTIONS(4570),
    [sym_export] = ACTIONS(4570),
    [sym_extern] = ACTIONS(4570),
    [sym_final] = ACTIONS(4570),
    [sym_finally] = ACTIONS(4570),
    [sym_for] = ACTIONS(4570),
    [sym_foreach] = ACTIONS(4570),
    [sym_foreach_reverse] = ACTIONS(4570),
    [sym_function] = ACTIONS(4570),
    [sym_goto] = ACTIONS(4570),
    [sym_if] = ACTIONS(4570),
    [sym_immutable] = ACTIONS(4570),
    [sym_import] = ACTIONS(4570),
    [sym_in] = ACTIONS(4570),
    [sym_inout] = ACTIONS(4570),
    [sym_interface] = ACTIONS(4570),
    [sym_invariant] = ACTIONS(4570),
    [sym_is] = ACTIONS(4570),
    [sym_mixin] = ACTIONS(4570),
    [sym_new] = ACTIONS(4570),
    [sym_nothrow] = ACTIONS(4570),
    [sym_out] = ACTIONS(4570),
    [sym_override] = ACTIONS(4570),
    [sym_package] = ACTIONS(4570),
    [sym_pragma] = ACTIONS(4570),
    [sym_private] = ACTIONS(4570),
    [sym_protected] = ACTIONS(4570),
    [sym_public] = ACTIONS(4570),
    [sym_pure] = ACTIONS(4570),
    [sym_ref] = ACTIONS(4570),
    [sym_return] = ACTIONS(4570),
    [sym_scope] = ACTIONS(4570),
    [sym_shared] = ACTIONS(4570),
    [sym_static] = ACTIONS(4570),
    [sym_struct] = ACTIONS(4570),
    [sym_switch] = ACTIONS(4570),
    [sym_synchronized] = ACTIONS(4570),
    [sym_template] = ACTIONS(4570),
    [sym_throw] = ACTIONS(4570),
    [sym_try] = ACTIONS(4570),
    [sym_typeid] = ACTIONS(4570),
    [sym_typeof] = ACTIONS(4570),
    [sym_union] = ACTIONS(4570),
    [sym_unittest] = ACTIONS(4570),
    [sym_version] = ACTIONS(4570),
    [sym_while] = ACTIONS(4570),
    [sym_with] = ACTIONS(4570),
    [sym_gshared] = ACTIONS(4570),
    [sym_traits] = ACTIONS(4570),
    [sym_vector] = ACTIONS(4570),
    [sym_void] = ACTIONS(4570),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_r_DQUOTE] = ACTIONS(4572),
    [anon_sym_x_DQUOTE] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_i_BQUOTE] = ACTIONS(4572),
    [anon_sym_i_DQUOTE] = ACTIONS(4572),
    [anon_sym_iq_LBRACE] = ACTIONS(4572),
    [aux_sym_char_literal_token1] = ACTIONS(4572),
    [anon_sym_SQUOTE] = ACTIONS(4570),
    [anon_sym___DATE__] = ACTIONS(4570),
    [anon_sym___FILE__] = ACTIONS(4570),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4570),
    [anon_sym___FUNCTION__] = ACTIONS(4570),
    [anon_sym___LINE__] = ACTIONS(4570),
    [anon_sym___MODULE__] = ACTIONS(4570),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4570),
    [anon_sym___TIME__] = ACTIONS(4570),
    [anon_sym___TIMESTAMP__] = ACTIONS(4570),
    [anon_sym___VENDOR__] = ACTIONS(4570),
    [anon_sym___VERSION__] = ACTIONS(4570),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4572),
    [sym_float_literal] = ACTIONS(4572),
    [sym__string] = ACTIONS(4572),
  },
  [1400] = {
    [sym_identifier] = ACTIONS(4574),
    [anon_sym_q_LBRACE] = ACTIONS(4576),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_LBRACE] = ACTIONS(4576),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4574),
    [anon_sym_DASH_DASH] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(4574),
    [anon_sym_PLUS_PLUS] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_LPAREN] = ACTIONS(4576),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [anon_sym_AT] = ACTIONS(4576),
    [sym_bool] = ACTIONS(4574),
    [sym_byte] = ACTIONS(4574),
    [sym_ubyte] = ACTIONS(4574),
    [sym_char] = ACTIONS(4574),
    [sym_short] = ACTIONS(4574),
    [sym_ushort] = ACTIONS(4574),
    [sym_int] = ACTIONS(4574),
    [sym_uint] = ACTIONS(4574),
    [sym_long] = ACTIONS(4574),
    [sym_ulong] = ACTIONS(4574),
    [sym_cent] = ACTIONS(4574),
    [sym_ucent] = ACTIONS(4574),
    [sym_wchar] = ACTIONS(4574),
    [sym_dchar] = ACTIONS(4574),
    [sym_float] = ACTIONS(4574),
    [sym_double] = ACTIONS(4574),
    [sym_real] = ACTIONS(4574),
    [sym_ifloat] = ACTIONS(4574),
    [sym_idouble] = ACTIONS(4574),
    [sym_ireal] = ACTIONS(4574),
    [sym_cfloat] = ACTIONS(4574),
    [sym_cdouble] = ACTIONS(4574),
    [sym_creal] = ACTIONS(4574),
    [sym_size_t] = ACTIONS(4574),
    [sym_ptrdiff_t] = ACTIONS(4574),
    [sym_string] = ACTIONS(4574),
    [sym_cstring] = ACTIONS(4574),
    [sym_dstring] = ACTIONS(4574),
    [sym_wstring] = ACTIONS(4574),
    [sym_noreturn] = ACTIONS(4574),
    [sym_true] = ACTIONS(4574),
    [sym_false] = ACTIONS(4574),
    [sym_null] = ACTIONS(4574),
    [sym_super] = ACTIONS(4574),
    [sym_this] = ACTIONS(4574),
    [sym_abstract] = ACTIONS(4574),
    [sym_alias] = ACTIONS(4574),
    [sym_align] = ACTIONS(4574),
    [sym_asm] = ACTIONS(4574),
    [sym_assert] = ACTIONS(4574),
    [sym_auto] = ACTIONS(4574),
    [sym_break] = ACTIONS(4574),
    [sym_case] = ACTIONS(4574),
    [sym_cast] = ACTIONS(4574),
    [sym_catch] = ACTIONS(4574),
    [sym_class] = ACTIONS(4574),
    [sym_const] = ACTIONS(4574),
    [sym_continue] = ACTIONS(4574),
    [sym_debug] = ACTIONS(4574),
    [sym_default] = ACTIONS(4574),
    [sym_delegate] = ACTIONS(4574),
    [sym_delete] = ACTIONS(4574),
    [sym_deprecated] = ACTIONS(4574),
    [sym_do] = ACTIONS(4574),
    [sym_else] = ACTIONS(4574),
    [sym_enum] = ACTIONS(4574),
    [sym_export] = ACTIONS(4574),
    [sym_extern] = ACTIONS(4574),
    [sym_final] = ACTIONS(4574),
    [sym_finally] = ACTIONS(4574),
    [sym_for] = ACTIONS(4574),
    [sym_foreach] = ACTIONS(4574),
    [sym_foreach_reverse] = ACTIONS(4574),
    [sym_function] = ACTIONS(4574),
    [sym_goto] = ACTIONS(4574),
    [sym_if] = ACTIONS(4574),
    [sym_immutable] = ACTIONS(4574),
    [sym_import] = ACTIONS(4574),
    [sym_in] = ACTIONS(4574),
    [sym_inout] = ACTIONS(4574),
    [sym_interface] = ACTIONS(4574),
    [sym_invariant] = ACTIONS(4574),
    [sym_is] = ACTIONS(4574),
    [sym_mixin] = ACTIONS(4574),
    [sym_new] = ACTIONS(4574),
    [sym_nothrow] = ACTIONS(4574),
    [sym_out] = ACTIONS(4574),
    [sym_override] = ACTIONS(4574),
    [sym_package] = ACTIONS(4574),
    [sym_pragma] = ACTIONS(4574),
    [sym_private] = ACTIONS(4574),
    [sym_protected] = ACTIONS(4574),
    [sym_public] = ACTIONS(4574),
    [sym_pure] = ACTIONS(4574),
    [sym_ref] = ACTIONS(4574),
    [sym_return] = ACTIONS(4574),
    [sym_scope] = ACTIONS(4574),
    [sym_shared] = ACTIONS(4574),
    [sym_static] = ACTIONS(4574),
    [sym_struct] = ACTIONS(4574),
    [sym_switch] = ACTIONS(4574),
    [sym_synchronized] = ACTIONS(4574),
    [sym_template] = ACTIONS(4574),
    [sym_throw] = ACTIONS(4574),
    [sym_try] = ACTIONS(4574),
    [sym_typeid] = ACTIONS(4574),
    [sym_typeof] = ACTIONS(4574),
    [sym_union] = ACTIONS(4574),
    [sym_unittest] = ACTIONS(4574),
    [sym_version] = ACTIONS(4574),
    [sym_while] = ACTIONS(4574),
    [sym_with] = ACTIONS(4574),
    [sym_gshared] = ACTIONS(4574),
    [sym_traits] = ACTIONS(4574),
    [sym_vector] = ACTIONS(4574),
    [sym_void] = ACTIONS(4574),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_r_DQUOTE] = ACTIONS(4576),
    [anon_sym_x_DQUOTE] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_i_BQUOTE] = ACTIONS(4576),
    [anon_sym_i_DQUOTE] = ACTIONS(4576),
    [anon_sym_iq_LBRACE] = ACTIONS(4576),
    [aux_sym_char_literal_token1] = ACTIONS(4576),
    [anon_sym_SQUOTE] = ACTIONS(4574),
    [anon_sym___DATE__] = ACTIONS(4574),
    [anon_sym___FILE__] = ACTIONS(4574),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4574),
    [anon_sym___FUNCTION__] = ACTIONS(4574),
    [anon_sym___LINE__] = ACTIONS(4574),
    [anon_sym___MODULE__] = ACTIONS(4574),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4574),
    [anon_sym___TIME__] = ACTIONS(4574),
    [anon_sym___TIMESTAMP__] = ACTIONS(4574),
    [anon_sym___VENDOR__] = ACTIONS(4574),
    [anon_sym___VERSION__] = ACTIONS(4574),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4576),
    [sym_float_literal] = ACTIONS(4576),
    [sym__string] = ACTIONS(4576),
  },
  [1401] = {
    [sym_identifier] = ACTIONS(4578),
    [anon_sym_q_LBRACE] = ACTIONS(4580),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_LBRACE] = ACTIONS(4580),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4580),
    [anon_sym_PLUS] = ACTIONS(4578),
    [anon_sym_PLUS_PLUS] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_LPAREN] = ACTIONS(4580),
    [anon_sym_RPAREN] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_DOLLAR] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_TILDE] = ACTIONS(4580),
    [anon_sym_AT] = ACTIONS(4580),
    [sym_bool] = ACTIONS(4578),
    [sym_byte] = ACTIONS(4578),
    [sym_ubyte] = ACTIONS(4578),
    [sym_char] = ACTIONS(4578),
    [sym_short] = ACTIONS(4578),
    [sym_ushort] = ACTIONS(4578),
    [sym_int] = ACTIONS(4578),
    [sym_uint] = ACTIONS(4578),
    [sym_long] = ACTIONS(4578),
    [sym_ulong] = ACTIONS(4578),
    [sym_cent] = ACTIONS(4578),
    [sym_ucent] = ACTIONS(4578),
    [sym_wchar] = ACTIONS(4578),
    [sym_dchar] = ACTIONS(4578),
    [sym_float] = ACTIONS(4578),
    [sym_double] = ACTIONS(4578),
    [sym_real] = ACTIONS(4578),
    [sym_ifloat] = ACTIONS(4578),
    [sym_idouble] = ACTIONS(4578),
    [sym_ireal] = ACTIONS(4578),
    [sym_cfloat] = ACTIONS(4578),
    [sym_cdouble] = ACTIONS(4578),
    [sym_creal] = ACTIONS(4578),
    [sym_size_t] = ACTIONS(4578),
    [sym_ptrdiff_t] = ACTIONS(4578),
    [sym_string] = ACTIONS(4578),
    [sym_cstring] = ACTIONS(4578),
    [sym_dstring] = ACTIONS(4578),
    [sym_wstring] = ACTIONS(4578),
    [sym_noreturn] = ACTIONS(4578),
    [sym_true] = ACTIONS(4578),
    [sym_false] = ACTIONS(4578),
    [sym_null] = ACTIONS(4578),
    [sym_super] = ACTIONS(4578),
    [sym_this] = ACTIONS(4578),
    [sym_abstract] = ACTIONS(4578),
    [sym_alias] = ACTIONS(4578),
    [sym_align] = ACTIONS(4578),
    [sym_asm] = ACTIONS(4578),
    [sym_assert] = ACTIONS(4578),
    [sym_auto] = ACTIONS(4578),
    [sym_break] = ACTIONS(4578),
    [sym_case] = ACTIONS(4578),
    [sym_cast] = ACTIONS(4578),
    [sym_catch] = ACTIONS(4578),
    [sym_class] = ACTIONS(4578),
    [sym_const] = ACTIONS(4578),
    [sym_continue] = ACTIONS(4578),
    [sym_debug] = ACTIONS(4578),
    [sym_default] = ACTIONS(4578),
    [sym_delegate] = ACTIONS(4578),
    [sym_delete] = ACTIONS(4578),
    [sym_deprecated] = ACTIONS(4578),
    [sym_do] = ACTIONS(4578),
    [sym_else] = ACTIONS(4578),
    [sym_enum] = ACTIONS(4578),
    [sym_export] = ACTIONS(4578),
    [sym_extern] = ACTIONS(4578),
    [sym_final] = ACTIONS(4578),
    [sym_finally] = ACTIONS(4578),
    [sym_for] = ACTIONS(4578),
    [sym_foreach] = ACTIONS(4578),
    [sym_foreach_reverse] = ACTIONS(4578),
    [sym_function] = ACTIONS(4578),
    [sym_goto] = ACTIONS(4578),
    [sym_if] = ACTIONS(4578),
    [sym_immutable] = ACTIONS(4578),
    [sym_import] = ACTIONS(4578),
    [sym_in] = ACTIONS(4578),
    [sym_inout] = ACTIONS(4578),
    [sym_interface] = ACTIONS(4578),
    [sym_invariant] = ACTIONS(4578),
    [sym_is] = ACTIONS(4578),
    [sym_mixin] = ACTIONS(4578),
    [sym_new] = ACTIONS(4578),
    [sym_nothrow] = ACTIONS(4578),
    [sym_out] = ACTIONS(4578),
    [sym_override] = ACTIONS(4578),
    [sym_package] = ACTIONS(4578),
    [sym_pragma] = ACTIONS(4578),
    [sym_private] = ACTIONS(4578),
    [sym_protected] = ACTIONS(4578),
    [sym_public] = ACTIONS(4578),
    [sym_pure] = ACTIONS(4578),
    [sym_ref] = ACTIONS(4578),
    [sym_return] = ACTIONS(4578),
    [sym_scope] = ACTIONS(4578),
    [sym_shared] = ACTIONS(4578),
    [sym_static] = ACTIONS(4578),
    [sym_struct] = ACTIONS(4578),
    [sym_switch] = ACTIONS(4578),
    [sym_synchronized] = ACTIONS(4578),
    [sym_template] = ACTIONS(4578),
    [sym_throw] = ACTIONS(4578),
    [sym_try] = ACTIONS(4578),
    [sym_typeid] = ACTIONS(4578),
    [sym_typeof] = ACTIONS(4578),
    [sym_union] = ACTIONS(4578),
    [sym_unittest] = ACTIONS(4578),
    [sym_version] = ACTIONS(4578),
    [sym_while] = ACTIONS(4578),
    [sym_with] = ACTIONS(4578),
    [sym_gshared] = ACTIONS(4578),
    [sym_traits] = ACTIONS(4578),
    [sym_vector] = ACTIONS(4578),
    [sym_void] = ACTIONS(4578),
    [anon_sym_BQUOTE] = ACTIONS(4580),
    [anon_sym_r_DQUOTE] = ACTIONS(4580),
    [anon_sym_x_DQUOTE] = ACTIONS(4580),
    [anon_sym_DQUOTE] = ACTIONS(4580),
    [anon_sym_i_BQUOTE] = ACTIONS(4580),
    [anon_sym_i_DQUOTE] = ACTIONS(4580),
    [anon_sym_iq_LBRACE] = ACTIONS(4580),
    [aux_sym_char_literal_token1] = ACTIONS(4580),
    [anon_sym_SQUOTE] = ACTIONS(4578),
    [anon_sym___DATE__] = ACTIONS(4578),
    [anon_sym___FILE__] = ACTIONS(4578),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4578),
    [anon_sym___FUNCTION__] = ACTIONS(4578),
    [anon_sym___LINE__] = ACTIONS(4578),
    [anon_sym___MODULE__] = ACTIONS(4578),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4578),
    [anon_sym___TIME__] = ACTIONS(4578),
    [anon_sym___TIMESTAMP__] = ACTIONS(4578),
    [anon_sym___VENDOR__] = ACTIONS(4578),
    [anon_sym___VERSION__] = ACTIONS(4578),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4580),
    [sym_float_literal] = ACTIONS(4580),
    [sym__string] = ACTIONS(4580),
  },
  [1402] = {
    [sym_identifier] = ACTIONS(4582),
    [anon_sym_q_LBRACE] = ACTIONS(4584),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_LBRACE] = ACTIONS(4584),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4582),
    [anon_sym_PLUS_PLUS] = ACTIONS(4584),
    [anon_sym_BANG] = ACTIONS(4584),
    [anon_sym_LPAREN] = ACTIONS(4584),
    [anon_sym_RPAREN] = ACTIONS(4584),
    [anon_sym_LBRACK] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_DOLLAR] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4584),
    [anon_sym_TILDE] = ACTIONS(4584),
    [anon_sym_AT] = ACTIONS(4584),
    [sym_bool] = ACTIONS(4582),
    [sym_byte] = ACTIONS(4582),
    [sym_ubyte] = ACTIONS(4582),
    [sym_char] = ACTIONS(4582),
    [sym_short] = ACTIONS(4582),
    [sym_ushort] = ACTIONS(4582),
    [sym_int] = ACTIONS(4582),
    [sym_uint] = ACTIONS(4582),
    [sym_long] = ACTIONS(4582),
    [sym_ulong] = ACTIONS(4582),
    [sym_cent] = ACTIONS(4582),
    [sym_ucent] = ACTIONS(4582),
    [sym_wchar] = ACTIONS(4582),
    [sym_dchar] = ACTIONS(4582),
    [sym_float] = ACTIONS(4582),
    [sym_double] = ACTIONS(4582),
    [sym_real] = ACTIONS(4582),
    [sym_ifloat] = ACTIONS(4582),
    [sym_idouble] = ACTIONS(4582),
    [sym_ireal] = ACTIONS(4582),
    [sym_cfloat] = ACTIONS(4582),
    [sym_cdouble] = ACTIONS(4582),
    [sym_creal] = ACTIONS(4582),
    [sym_size_t] = ACTIONS(4582),
    [sym_ptrdiff_t] = ACTIONS(4582),
    [sym_string] = ACTIONS(4582),
    [sym_cstring] = ACTIONS(4582),
    [sym_dstring] = ACTIONS(4582),
    [sym_wstring] = ACTIONS(4582),
    [sym_noreturn] = ACTIONS(4582),
    [sym_true] = ACTIONS(4582),
    [sym_false] = ACTIONS(4582),
    [sym_null] = ACTIONS(4582),
    [sym_super] = ACTIONS(4582),
    [sym_this] = ACTIONS(4582),
    [sym_abstract] = ACTIONS(4582),
    [sym_alias] = ACTIONS(4582),
    [sym_align] = ACTIONS(4582),
    [sym_asm] = ACTIONS(4582),
    [sym_assert] = ACTIONS(4582),
    [sym_auto] = ACTIONS(4582),
    [sym_break] = ACTIONS(4582),
    [sym_case] = ACTIONS(4582),
    [sym_cast] = ACTIONS(4582),
    [sym_catch] = ACTIONS(4582),
    [sym_class] = ACTIONS(4582),
    [sym_const] = ACTIONS(4582),
    [sym_continue] = ACTIONS(4582),
    [sym_debug] = ACTIONS(4582),
    [sym_default] = ACTIONS(4582),
    [sym_delegate] = ACTIONS(4582),
    [sym_delete] = ACTIONS(4582),
    [sym_deprecated] = ACTIONS(4582),
    [sym_do] = ACTIONS(4582),
    [sym_else] = ACTIONS(4582),
    [sym_enum] = ACTIONS(4582),
    [sym_export] = ACTIONS(4582),
    [sym_extern] = ACTIONS(4582),
    [sym_final] = ACTIONS(4582),
    [sym_finally] = ACTIONS(4582),
    [sym_for] = ACTIONS(4582),
    [sym_foreach] = ACTIONS(4582),
    [sym_foreach_reverse] = ACTIONS(4582),
    [sym_function] = ACTIONS(4582),
    [sym_goto] = ACTIONS(4582),
    [sym_if] = ACTIONS(4582),
    [sym_immutable] = ACTIONS(4582),
    [sym_import] = ACTIONS(4582),
    [sym_in] = ACTIONS(4582),
    [sym_inout] = ACTIONS(4582),
    [sym_interface] = ACTIONS(4582),
    [sym_invariant] = ACTIONS(4582),
    [sym_is] = ACTIONS(4582),
    [sym_mixin] = ACTIONS(4582),
    [sym_new] = ACTIONS(4582),
    [sym_nothrow] = ACTIONS(4582),
    [sym_out] = ACTIONS(4582),
    [sym_override] = ACTIONS(4582),
    [sym_package] = ACTIONS(4582),
    [sym_pragma] = ACTIONS(4582),
    [sym_private] = ACTIONS(4582),
    [sym_protected] = ACTIONS(4582),
    [sym_public] = ACTIONS(4582),
    [sym_pure] = ACTIONS(4582),
    [sym_ref] = ACTIONS(4582),
    [sym_return] = ACTIONS(4582),
    [sym_scope] = ACTIONS(4582),
    [sym_shared] = ACTIONS(4582),
    [sym_static] = ACTIONS(4582),
    [sym_struct] = ACTIONS(4582),
    [sym_switch] = ACTIONS(4582),
    [sym_synchronized] = ACTIONS(4582),
    [sym_template] = ACTIONS(4582),
    [sym_throw] = ACTIONS(4582),
    [sym_try] = ACTIONS(4582),
    [sym_typeid] = ACTIONS(4582),
    [sym_typeof] = ACTIONS(4582),
    [sym_union] = ACTIONS(4582),
    [sym_unittest] = ACTIONS(4582),
    [sym_version] = ACTIONS(4582),
    [sym_while] = ACTIONS(4582),
    [sym_with] = ACTIONS(4582),
    [sym_gshared] = ACTIONS(4582),
    [sym_traits] = ACTIONS(4582),
    [sym_vector] = ACTIONS(4582),
    [sym_void] = ACTIONS(4582),
    [anon_sym_BQUOTE] = ACTIONS(4584),
    [anon_sym_r_DQUOTE] = ACTIONS(4584),
    [anon_sym_x_DQUOTE] = ACTIONS(4584),
    [anon_sym_DQUOTE] = ACTIONS(4584),
    [anon_sym_i_BQUOTE] = ACTIONS(4584),
    [anon_sym_i_DQUOTE] = ACTIONS(4584),
    [anon_sym_iq_LBRACE] = ACTIONS(4584),
    [aux_sym_char_literal_token1] = ACTIONS(4584),
    [anon_sym_SQUOTE] = ACTIONS(4582),
    [anon_sym___DATE__] = ACTIONS(4582),
    [anon_sym___FILE__] = ACTIONS(4582),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4582),
    [anon_sym___FUNCTION__] = ACTIONS(4582),
    [anon_sym___LINE__] = ACTIONS(4582),
    [anon_sym___MODULE__] = ACTIONS(4582),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4582),
    [anon_sym___TIME__] = ACTIONS(4582),
    [anon_sym___TIMESTAMP__] = ACTIONS(4582),
    [anon_sym___VENDOR__] = ACTIONS(4582),
    [anon_sym___VERSION__] = ACTIONS(4582),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4584),
    [sym_float_literal] = ACTIONS(4584),
    [sym__string] = ACTIONS(4584),
  },
  [1403] = {
    [sym_identifier] = ACTIONS(4586),
    [anon_sym_q_LBRACE] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_LBRACE] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4588),
    [anon_sym_AMP] = ACTIONS(4588),
    [anon_sym_DASH] = ACTIONS(4586),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4586),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_BANG] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_DOLLAR] = ACTIONS(4588),
    [anon_sym_STAR] = ACTIONS(4588),
    [anon_sym_TILDE] = ACTIONS(4588),
    [anon_sym_AT] = ACTIONS(4588),
    [sym_bool] = ACTIONS(4586),
    [sym_byte] = ACTIONS(4586),
    [sym_ubyte] = ACTIONS(4586),
    [sym_char] = ACTIONS(4586),
    [sym_short] = ACTIONS(4586),
    [sym_ushort] = ACTIONS(4586),
    [sym_int] = ACTIONS(4586),
    [sym_uint] = ACTIONS(4586),
    [sym_long] = ACTIONS(4586),
    [sym_ulong] = ACTIONS(4586),
    [sym_cent] = ACTIONS(4586),
    [sym_ucent] = ACTIONS(4586),
    [sym_wchar] = ACTIONS(4586),
    [sym_dchar] = ACTIONS(4586),
    [sym_float] = ACTIONS(4586),
    [sym_double] = ACTIONS(4586),
    [sym_real] = ACTIONS(4586),
    [sym_ifloat] = ACTIONS(4586),
    [sym_idouble] = ACTIONS(4586),
    [sym_ireal] = ACTIONS(4586),
    [sym_cfloat] = ACTIONS(4586),
    [sym_cdouble] = ACTIONS(4586),
    [sym_creal] = ACTIONS(4586),
    [sym_size_t] = ACTIONS(4586),
    [sym_ptrdiff_t] = ACTIONS(4586),
    [sym_string] = ACTIONS(4586),
    [sym_cstring] = ACTIONS(4586),
    [sym_dstring] = ACTIONS(4586),
    [sym_wstring] = ACTIONS(4586),
    [sym_noreturn] = ACTIONS(4586),
    [sym_true] = ACTIONS(4586),
    [sym_false] = ACTIONS(4586),
    [sym_null] = ACTIONS(4586),
    [sym_super] = ACTIONS(4586),
    [sym_this] = ACTIONS(4586),
    [sym_abstract] = ACTIONS(4586),
    [sym_alias] = ACTIONS(4586),
    [sym_align] = ACTIONS(4586),
    [sym_asm] = ACTIONS(4586),
    [sym_assert] = ACTIONS(4586),
    [sym_auto] = ACTIONS(4586),
    [sym_break] = ACTIONS(4586),
    [sym_case] = ACTIONS(4586),
    [sym_cast] = ACTIONS(4586),
    [sym_catch] = ACTIONS(4586),
    [sym_class] = ACTIONS(4586),
    [sym_const] = ACTIONS(4586),
    [sym_continue] = ACTIONS(4586),
    [sym_debug] = ACTIONS(4586),
    [sym_default] = ACTIONS(4586),
    [sym_delegate] = ACTIONS(4586),
    [sym_delete] = ACTIONS(4586),
    [sym_deprecated] = ACTIONS(4586),
    [sym_do] = ACTIONS(4586),
    [sym_else] = ACTIONS(4586),
    [sym_enum] = ACTIONS(4586),
    [sym_export] = ACTIONS(4586),
    [sym_extern] = ACTIONS(4586),
    [sym_final] = ACTIONS(4586),
    [sym_finally] = ACTIONS(4586),
    [sym_for] = ACTIONS(4586),
    [sym_foreach] = ACTIONS(4586),
    [sym_foreach_reverse] = ACTIONS(4586),
    [sym_function] = ACTIONS(4586),
    [sym_goto] = ACTIONS(4586),
    [sym_if] = ACTIONS(4586),
    [sym_immutable] = ACTIONS(4586),
    [sym_import] = ACTIONS(4586),
    [sym_in] = ACTIONS(4586),
    [sym_inout] = ACTIONS(4586),
    [sym_interface] = ACTIONS(4586),
    [sym_invariant] = ACTIONS(4586),
    [sym_is] = ACTIONS(4586),
    [sym_mixin] = ACTIONS(4586),
    [sym_new] = ACTIONS(4586),
    [sym_nothrow] = ACTIONS(4586),
    [sym_out] = ACTIONS(4586),
    [sym_override] = ACTIONS(4586),
    [sym_package] = ACTIONS(4586),
    [sym_pragma] = ACTIONS(4586),
    [sym_private] = ACTIONS(4586),
    [sym_protected] = ACTIONS(4586),
    [sym_public] = ACTIONS(4586),
    [sym_pure] = ACTIONS(4586),
    [sym_ref] = ACTIONS(4586),
    [sym_return] = ACTIONS(4586),
    [sym_scope] = ACTIONS(4586),
    [sym_shared] = ACTIONS(4586),
    [sym_static] = ACTIONS(4586),
    [sym_struct] = ACTIONS(4586),
    [sym_switch] = ACTIONS(4586),
    [sym_synchronized] = ACTIONS(4586),
    [sym_template] = ACTIONS(4586),
    [sym_throw] = ACTIONS(4586),
    [sym_try] = ACTIONS(4586),
    [sym_typeid] = ACTIONS(4586),
    [sym_typeof] = ACTIONS(4586),
    [sym_union] = ACTIONS(4586),
    [sym_unittest] = ACTIONS(4586),
    [sym_version] = ACTIONS(4586),
    [sym_while] = ACTIONS(4586),
    [sym_with] = ACTIONS(4586),
    [sym_gshared] = ACTIONS(4586),
    [sym_traits] = ACTIONS(4586),
    [sym_vector] = ACTIONS(4586),
    [sym_void] = ACTIONS(4586),
    [anon_sym_BQUOTE] = ACTIONS(4588),
    [anon_sym_r_DQUOTE] = ACTIONS(4588),
    [anon_sym_x_DQUOTE] = ACTIONS(4588),
    [anon_sym_DQUOTE] = ACTIONS(4588),
    [anon_sym_i_BQUOTE] = ACTIONS(4588),
    [anon_sym_i_DQUOTE] = ACTIONS(4588),
    [anon_sym_iq_LBRACE] = ACTIONS(4588),
    [aux_sym_char_literal_token1] = ACTIONS(4588),
    [anon_sym_SQUOTE] = ACTIONS(4586),
    [anon_sym___DATE__] = ACTIONS(4586),
    [anon_sym___FILE__] = ACTIONS(4586),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4586),
    [anon_sym___FUNCTION__] = ACTIONS(4586),
    [anon_sym___LINE__] = ACTIONS(4586),
    [anon_sym___MODULE__] = ACTIONS(4586),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4586),
    [anon_sym___TIME__] = ACTIONS(4586),
    [anon_sym___TIMESTAMP__] = ACTIONS(4586),
    [anon_sym___VENDOR__] = ACTIONS(4586),
    [anon_sym___VERSION__] = ACTIONS(4586),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4588),
    [sym_float_literal] = ACTIONS(4588),
    [sym__string] = ACTIONS(4588),
  },
  [1404] = {
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_q_LBRACE] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_DOT] = ACTIONS(4592),
    [anon_sym_AMP] = ACTIONS(4592),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_DASH] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4592),
    [anon_sym_BANG] = ACTIONS(4592),
    [anon_sym_LPAREN] = ACTIONS(4592),
    [anon_sym_RPAREN] = ACTIONS(4592),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_DOLLAR] = ACTIONS(4592),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_TILDE] = ACTIONS(4592),
    [anon_sym_AT] = ACTIONS(4592),
    [sym_bool] = ACTIONS(4590),
    [sym_byte] = ACTIONS(4590),
    [sym_ubyte] = ACTIONS(4590),
    [sym_char] = ACTIONS(4590),
    [sym_short] = ACTIONS(4590),
    [sym_ushort] = ACTIONS(4590),
    [sym_int] = ACTIONS(4590),
    [sym_uint] = ACTIONS(4590),
    [sym_long] = ACTIONS(4590),
    [sym_ulong] = ACTIONS(4590),
    [sym_cent] = ACTIONS(4590),
    [sym_ucent] = ACTIONS(4590),
    [sym_wchar] = ACTIONS(4590),
    [sym_dchar] = ACTIONS(4590),
    [sym_float] = ACTIONS(4590),
    [sym_double] = ACTIONS(4590),
    [sym_real] = ACTIONS(4590),
    [sym_ifloat] = ACTIONS(4590),
    [sym_idouble] = ACTIONS(4590),
    [sym_ireal] = ACTIONS(4590),
    [sym_cfloat] = ACTIONS(4590),
    [sym_cdouble] = ACTIONS(4590),
    [sym_creal] = ACTIONS(4590),
    [sym_size_t] = ACTIONS(4590),
    [sym_ptrdiff_t] = ACTIONS(4590),
    [sym_string] = ACTIONS(4590),
    [sym_cstring] = ACTIONS(4590),
    [sym_dstring] = ACTIONS(4590),
    [sym_wstring] = ACTIONS(4590),
    [sym_noreturn] = ACTIONS(4590),
    [sym_true] = ACTIONS(4590),
    [sym_false] = ACTIONS(4590),
    [sym_null] = ACTIONS(4590),
    [sym_super] = ACTIONS(4590),
    [sym_this] = ACTIONS(4590),
    [sym_abstract] = ACTIONS(4590),
    [sym_alias] = ACTIONS(4590),
    [sym_align] = ACTIONS(4590),
    [sym_asm] = ACTIONS(4590),
    [sym_assert] = ACTIONS(4590),
    [sym_auto] = ACTIONS(4590),
    [sym_break] = ACTIONS(4590),
    [sym_case] = ACTIONS(4590),
    [sym_cast] = ACTIONS(4590),
    [sym_catch] = ACTIONS(4590),
    [sym_class] = ACTIONS(4590),
    [sym_const] = ACTIONS(4590),
    [sym_continue] = ACTIONS(4590),
    [sym_debug] = ACTIONS(4590),
    [sym_default] = ACTIONS(4590),
    [sym_delegate] = ACTIONS(4590),
    [sym_delete] = ACTIONS(4590),
    [sym_deprecated] = ACTIONS(4590),
    [sym_do] = ACTIONS(4590),
    [sym_else] = ACTIONS(4590),
    [sym_enum] = ACTIONS(4590),
    [sym_export] = ACTIONS(4590),
    [sym_extern] = ACTIONS(4590),
    [sym_final] = ACTIONS(4590),
    [sym_finally] = ACTIONS(4590),
    [sym_for] = ACTIONS(4590),
    [sym_foreach] = ACTIONS(4590),
    [sym_foreach_reverse] = ACTIONS(4590),
    [sym_function] = ACTIONS(4590),
    [sym_goto] = ACTIONS(4590),
    [sym_if] = ACTIONS(4590),
    [sym_immutable] = ACTIONS(4590),
    [sym_import] = ACTIONS(4590),
    [sym_in] = ACTIONS(4590),
    [sym_inout] = ACTIONS(4590),
    [sym_interface] = ACTIONS(4590),
    [sym_invariant] = ACTIONS(4590),
    [sym_is] = ACTIONS(4590),
    [sym_mixin] = ACTIONS(4590),
    [sym_new] = ACTIONS(4590),
    [sym_nothrow] = ACTIONS(4590),
    [sym_out] = ACTIONS(4590),
    [sym_override] = ACTIONS(4590),
    [sym_package] = ACTIONS(4590),
    [sym_pragma] = ACTIONS(4590),
    [sym_private] = ACTIONS(4590),
    [sym_protected] = ACTIONS(4590),
    [sym_public] = ACTIONS(4590),
    [sym_pure] = ACTIONS(4590),
    [sym_ref] = ACTIONS(4590),
    [sym_return] = ACTIONS(4590),
    [sym_scope] = ACTIONS(4590),
    [sym_shared] = ACTIONS(4590),
    [sym_static] = ACTIONS(4590),
    [sym_struct] = ACTIONS(4590),
    [sym_switch] = ACTIONS(4590),
    [sym_synchronized] = ACTIONS(4590),
    [sym_template] = ACTIONS(4590),
    [sym_throw] = ACTIONS(4590),
    [sym_try] = ACTIONS(4590),
    [sym_typeid] = ACTIONS(4590),
    [sym_typeof] = ACTIONS(4590),
    [sym_union] = ACTIONS(4590),
    [sym_unittest] = ACTIONS(4590),
    [sym_version] = ACTIONS(4590),
    [sym_while] = ACTIONS(4590),
    [sym_with] = ACTIONS(4590),
    [sym_gshared] = ACTIONS(4590),
    [sym_traits] = ACTIONS(4590),
    [sym_vector] = ACTIONS(4590),
    [sym_void] = ACTIONS(4590),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_r_DQUOTE] = ACTIONS(4592),
    [anon_sym_x_DQUOTE] = ACTIONS(4592),
    [anon_sym_DQUOTE] = ACTIONS(4592),
    [anon_sym_i_BQUOTE] = ACTIONS(4592),
    [anon_sym_i_DQUOTE] = ACTIONS(4592),
    [anon_sym_iq_LBRACE] = ACTIONS(4592),
    [aux_sym_char_literal_token1] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym___DATE__] = ACTIONS(4590),
    [anon_sym___FILE__] = ACTIONS(4590),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4590),
    [anon_sym___FUNCTION__] = ACTIONS(4590),
    [anon_sym___LINE__] = ACTIONS(4590),
    [anon_sym___MODULE__] = ACTIONS(4590),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4590),
    [anon_sym___TIME__] = ACTIONS(4590),
    [anon_sym___TIMESTAMP__] = ACTIONS(4590),
    [anon_sym___VENDOR__] = ACTIONS(4590),
    [anon_sym___VERSION__] = ACTIONS(4590),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4592),
    [sym_float_literal] = ACTIONS(4592),
    [sym__string] = ACTIONS(4592),
  },
  [1405] = {
    [sym_identifier] = ACTIONS(4594),
    [anon_sym_q_LBRACE] = ACTIONS(4596),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_LBRACE] = ACTIONS(4596),
    [anon_sym_DOT] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_DASH_DASH] = ACTIONS(4596),
    [anon_sym_PLUS] = ACTIONS(4594),
    [anon_sym_PLUS_PLUS] = ACTIONS(4596),
    [anon_sym_BANG] = ACTIONS(4596),
    [anon_sym_LPAREN] = ACTIONS(4596),
    [anon_sym_RPAREN] = ACTIONS(4596),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_DOLLAR] = ACTIONS(4596),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_TILDE] = ACTIONS(4596),
    [anon_sym_AT] = ACTIONS(4596),
    [sym_bool] = ACTIONS(4594),
    [sym_byte] = ACTIONS(4594),
    [sym_ubyte] = ACTIONS(4594),
    [sym_char] = ACTIONS(4594),
    [sym_short] = ACTIONS(4594),
    [sym_ushort] = ACTIONS(4594),
    [sym_int] = ACTIONS(4594),
    [sym_uint] = ACTIONS(4594),
    [sym_long] = ACTIONS(4594),
    [sym_ulong] = ACTIONS(4594),
    [sym_cent] = ACTIONS(4594),
    [sym_ucent] = ACTIONS(4594),
    [sym_wchar] = ACTIONS(4594),
    [sym_dchar] = ACTIONS(4594),
    [sym_float] = ACTIONS(4594),
    [sym_double] = ACTIONS(4594),
    [sym_real] = ACTIONS(4594),
    [sym_ifloat] = ACTIONS(4594),
    [sym_idouble] = ACTIONS(4594),
    [sym_ireal] = ACTIONS(4594),
    [sym_cfloat] = ACTIONS(4594),
    [sym_cdouble] = ACTIONS(4594),
    [sym_creal] = ACTIONS(4594),
    [sym_size_t] = ACTIONS(4594),
    [sym_ptrdiff_t] = ACTIONS(4594),
    [sym_string] = ACTIONS(4594),
    [sym_cstring] = ACTIONS(4594),
    [sym_dstring] = ACTIONS(4594),
    [sym_wstring] = ACTIONS(4594),
    [sym_noreturn] = ACTIONS(4594),
    [sym_true] = ACTIONS(4594),
    [sym_false] = ACTIONS(4594),
    [sym_null] = ACTIONS(4594),
    [sym_super] = ACTIONS(4594),
    [sym_this] = ACTIONS(4594),
    [sym_abstract] = ACTIONS(4594),
    [sym_alias] = ACTIONS(4594),
    [sym_align] = ACTIONS(4594),
    [sym_asm] = ACTIONS(4594),
    [sym_assert] = ACTIONS(4594),
    [sym_auto] = ACTIONS(4594),
    [sym_break] = ACTIONS(4594),
    [sym_case] = ACTIONS(4594),
    [sym_cast] = ACTIONS(4594),
    [sym_catch] = ACTIONS(4594),
    [sym_class] = ACTIONS(4594),
    [sym_const] = ACTIONS(4594),
    [sym_continue] = ACTIONS(4594),
    [sym_debug] = ACTIONS(4594),
    [sym_default] = ACTIONS(4594),
    [sym_delegate] = ACTIONS(4594),
    [sym_delete] = ACTIONS(4594),
    [sym_deprecated] = ACTIONS(4594),
    [sym_do] = ACTIONS(4594),
    [sym_else] = ACTIONS(4594),
    [sym_enum] = ACTIONS(4594),
    [sym_export] = ACTIONS(4594),
    [sym_extern] = ACTIONS(4594),
    [sym_final] = ACTIONS(4594),
    [sym_finally] = ACTIONS(4594),
    [sym_for] = ACTIONS(4594),
    [sym_foreach] = ACTIONS(4594),
    [sym_foreach_reverse] = ACTIONS(4594),
    [sym_function] = ACTIONS(4594),
    [sym_goto] = ACTIONS(4594),
    [sym_if] = ACTIONS(4594),
    [sym_immutable] = ACTIONS(4594),
    [sym_import] = ACTIONS(4594),
    [sym_in] = ACTIONS(4594),
    [sym_inout] = ACTIONS(4594),
    [sym_interface] = ACTIONS(4594),
    [sym_invariant] = ACTIONS(4594),
    [sym_is] = ACTIONS(4594),
    [sym_mixin] = ACTIONS(4594),
    [sym_new] = ACTIONS(4594),
    [sym_nothrow] = ACTIONS(4594),
    [sym_out] = ACTIONS(4594),
    [sym_override] = ACTIONS(4594),
    [sym_package] = ACTIONS(4594),
    [sym_pragma] = ACTIONS(4594),
    [sym_private] = ACTIONS(4594),
    [sym_protected] = ACTIONS(4594),
    [sym_public] = ACTIONS(4594),
    [sym_pure] = ACTIONS(4594),
    [sym_ref] = ACTIONS(4594),
    [sym_return] = ACTIONS(4594),
    [sym_scope] = ACTIONS(4594),
    [sym_shared] = ACTIONS(4594),
    [sym_static] = ACTIONS(4594),
    [sym_struct] = ACTIONS(4594),
    [sym_switch] = ACTIONS(4594),
    [sym_synchronized] = ACTIONS(4594),
    [sym_template] = ACTIONS(4594),
    [sym_throw] = ACTIONS(4594),
    [sym_try] = ACTIONS(4594),
    [sym_typeid] = ACTIONS(4594),
    [sym_typeof] = ACTIONS(4594),
    [sym_union] = ACTIONS(4594),
    [sym_unittest] = ACTIONS(4594),
    [sym_version] = ACTIONS(4594),
    [sym_while] = ACTIONS(4594),
    [sym_with] = ACTIONS(4594),
    [sym_gshared] = ACTIONS(4594),
    [sym_traits] = ACTIONS(4594),
    [sym_vector] = ACTIONS(4594),
    [sym_void] = ACTIONS(4594),
    [anon_sym_BQUOTE] = ACTIONS(4596),
    [anon_sym_r_DQUOTE] = ACTIONS(4596),
    [anon_sym_x_DQUOTE] = ACTIONS(4596),
    [anon_sym_DQUOTE] = ACTIONS(4596),
    [anon_sym_i_BQUOTE] = ACTIONS(4596),
    [anon_sym_i_DQUOTE] = ACTIONS(4596),
    [anon_sym_iq_LBRACE] = ACTIONS(4596),
    [aux_sym_char_literal_token1] = ACTIONS(4596),
    [anon_sym_SQUOTE] = ACTIONS(4594),
    [anon_sym___DATE__] = ACTIONS(4594),
    [anon_sym___FILE__] = ACTIONS(4594),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4594),
    [anon_sym___FUNCTION__] = ACTIONS(4594),
    [anon_sym___LINE__] = ACTIONS(4594),
    [anon_sym___MODULE__] = ACTIONS(4594),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4594),
    [anon_sym___TIME__] = ACTIONS(4594),
    [anon_sym___TIMESTAMP__] = ACTIONS(4594),
    [anon_sym___VENDOR__] = ACTIONS(4594),
    [anon_sym___VERSION__] = ACTIONS(4594),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4596),
    [sym_float_literal] = ACTIONS(4596),
    [sym__string] = ACTIONS(4596),
  },
  [1406] = {
    [sym_identifier] = ACTIONS(4598),
    [anon_sym_q_LBRACE] = ACTIONS(4600),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4600),
    [anon_sym_AMP] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4598),
    [anon_sym_DASH_DASH] = ACTIONS(4600),
    [anon_sym_PLUS] = ACTIONS(4598),
    [anon_sym_PLUS_PLUS] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4600),
    [anon_sym_LPAREN] = ACTIONS(4600),
    [anon_sym_RPAREN] = ACTIONS(4600),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_DOLLAR] = ACTIONS(4600),
    [anon_sym_STAR] = ACTIONS(4600),
    [anon_sym_TILDE] = ACTIONS(4600),
    [anon_sym_AT] = ACTIONS(4600),
    [sym_bool] = ACTIONS(4598),
    [sym_byte] = ACTIONS(4598),
    [sym_ubyte] = ACTIONS(4598),
    [sym_char] = ACTIONS(4598),
    [sym_short] = ACTIONS(4598),
    [sym_ushort] = ACTIONS(4598),
    [sym_int] = ACTIONS(4598),
    [sym_uint] = ACTIONS(4598),
    [sym_long] = ACTIONS(4598),
    [sym_ulong] = ACTIONS(4598),
    [sym_cent] = ACTIONS(4598),
    [sym_ucent] = ACTIONS(4598),
    [sym_wchar] = ACTIONS(4598),
    [sym_dchar] = ACTIONS(4598),
    [sym_float] = ACTIONS(4598),
    [sym_double] = ACTIONS(4598),
    [sym_real] = ACTIONS(4598),
    [sym_ifloat] = ACTIONS(4598),
    [sym_idouble] = ACTIONS(4598),
    [sym_ireal] = ACTIONS(4598),
    [sym_cfloat] = ACTIONS(4598),
    [sym_cdouble] = ACTIONS(4598),
    [sym_creal] = ACTIONS(4598),
    [sym_size_t] = ACTIONS(4598),
    [sym_ptrdiff_t] = ACTIONS(4598),
    [sym_string] = ACTIONS(4598),
    [sym_cstring] = ACTIONS(4598),
    [sym_dstring] = ACTIONS(4598),
    [sym_wstring] = ACTIONS(4598),
    [sym_noreturn] = ACTIONS(4598),
    [sym_true] = ACTIONS(4598),
    [sym_false] = ACTIONS(4598),
    [sym_null] = ACTIONS(4598),
    [sym_super] = ACTIONS(4598),
    [sym_this] = ACTIONS(4598),
    [sym_abstract] = ACTIONS(4598),
    [sym_alias] = ACTIONS(4598),
    [sym_align] = ACTIONS(4598),
    [sym_asm] = ACTIONS(4598),
    [sym_assert] = ACTIONS(4598),
    [sym_auto] = ACTIONS(4598),
    [sym_break] = ACTIONS(4598),
    [sym_case] = ACTIONS(4598),
    [sym_cast] = ACTIONS(4598),
    [sym_catch] = ACTIONS(4598),
    [sym_class] = ACTIONS(4598),
    [sym_const] = ACTIONS(4598),
    [sym_continue] = ACTIONS(4598),
    [sym_debug] = ACTIONS(4598),
    [sym_default] = ACTIONS(4598),
    [sym_delegate] = ACTIONS(4598),
    [sym_delete] = ACTIONS(4598),
    [sym_deprecated] = ACTIONS(4598),
    [sym_do] = ACTIONS(4598),
    [sym_else] = ACTIONS(4598),
    [sym_enum] = ACTIONS(4598),
    [sym_export] = ACTIONS(4598),
    [sym_extern] = ACTIONS(4598),
    [sym_final] = ACTIONS(4598),
    [sym_finally] = ACTIONS(4598),
    [sym_for] = ACTIONS(4598),
    [sym_foreach] = ACTIONS(4598),
    [sym_foreach_reverse] = ACTIONS(4598),
    [sym_function] = ACTIONS(4598),
    [sym_goto] = ACTIONS(4598),
    [sym_if] = ACTIONS(4598),
    [sym_immutable] = ACTIONS(4598),
    [sym_import] = ACTIONS(4598),
    [sym_in] = ACTIONS(4598),
    [sym_inout] = ACTIONS(4598),
    [sym_interface] = ACTIONS(4598),
    [sym_invariant] = ACTIONS(4598),
    [sym_is] = ACTIONS(4598),
    [sym_mixin] = ACTIONS(4598),
    [sym_new] = ACTIONS(4598),
    [sym_nothrow] = ACTIONS(4598),
    [sym_out] = ACTIONS(4598),
    [sym_override] = ACTIONS(4598),
    [sym_package] = ACTIONS(4598),
    [sym_pragma] = ACTIONS(4598),
    [sym_private] = ACTIONS(4598),
    [sym_protected] = ACTIONS(4598),
    [sym_public] = ACTIONS(4598),
    [sym_pure] = ACTIONS(4598),
    [sym_ref] = ACTIONS(4598),
    [sym_return] = ACTIONS(4598),
    [sym_scope] = ACTIONS(4598),
    [sym_shared] = ACTIONS(4598),
    [sym_static] = ACTIONS(4598),
    [sym_struct] = ACTIONS(4598),
    [sym_switch] = ACTIONS(4598),
    [sym_synchronized] = ACTIONS(4598),
    [sym_template] = ACTIONS(4598),
    [sym_throw] = ACTIONS(4598),
    [sym_try] = ACTIONS(4598),
    [sym_typeid] = ACTIONS(4598),
    [sym_typeof] = ACTIONS(4598),
    [sym_union] = ACTIONS(4598),
    [sym_unittest] = ACTIONS(4598),
    [sym_version] = ACTIONS(4598),
    [sym_while] = ACTIONS(4598),
    [sym_with] = ACTIONS(4598),
    [sym_gshared] = ACTIONS(4598),
    [sym_traits] = ACTIONS(4598),
    [sym_vector] = ACTIONS(4598),
    [sym_void] = ACTIONS(4598),
    [anon_sym_BQUOTE] = ACTIONS(4600),
    [anon_sym_r_DQUOTE] = ACTIONS(4600),
    [anon_sym_x_DQUOTE] = ACTIONS(4600),
    [anon_sym_DQUOTE] = ACTIONS(4600),
    [anon_sym_i_BQUOTE] = ACTIONS(4600),
    [anon_sym_i_DQUOTE] = ACTIONS(4600),
    [anon_sym_iq_LBRACE] = ACTIONS(4600),
    [aux_sym_char_literal_token1] = ACTIONS(4600),
    [anon_sym_SQUOTE] = ACTIONS(4598),
    [anon_sym___DATE__] = ACTIONS(4598),
    [anon_sym___FILE__] = ACTIONS(4598),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4598),
    [anon_sym___FUNCTION__] = ACTIONS(4598),
    [anon_sym___LINE__] = ACTIONS(4598),
    [anon_sym___MODULE__] = ACTIONS(4598),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4598),
    [anon_sym___TIME__] = ACTIONS(4598),
    [anon_sym___TIMESTAMP__] = ACTIONS(4598),
    [anon_sym___VENDOR__] = ACTIONS(4598),
    [anon_sym___VERSION__] = ACTIONS(4598),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4600),
    [sym_float_literal] = ACTIONS(4600),
    [sym__string] = ACTIONS(4600),
  },
  [1407] = {
    [sym_identifier] = ACTIONS(4602),
    [anon_sym_q_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4604),
    [anon_sym_AMP] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_BANG] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_DOLLAR] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4604),
    [anon_sym_AT] = ACTIONS(4604),
    [sym_bool] = ACTIONS(4602),
    [sym_byte] = ACTIONS(4602),
    [sym_ubyte] = ACTIONS(4602),
    [sym_char] = ACTIONS(4602),
    [sym_short] = ACTIONS(4602),
    [sym_ushort] = ACTIONS(4602),
    [sym_int] = ACTIONS(4602),
    [sym_uint] = ACTIONS(4602),
    [sym_long] = ACTIONS(4602),
    [sym_ulong] = ACTIONS(4602),
    [sym_cent] = ACTIONS(4602),
    [sym_ucent] = ACTIONS(4602),
    [sym_wchar] = ACTIONS(4602),
    [sym_dchar] = ACTIONS(4602),
    [sym_float] = ACTIONS(4602),
    [sym_double] = ACTIONS(4602),
    [sym_real] = ACTIONS(4602),
    [sym_ifloat] = ACTIONS(4602),
    [sym_idouble] = ACTIONS(4602),
    [sym_ireal] = ACTIONS(4602),
    [sym_cfloat] = ACTIONS(4602),
    [sym_cdouble] = ACTIONS(4602),
    [sym_creal] = ACTIONS(4602),
    [sym_size_t] = ACTIONS(4602),
    [sym_ptrdiff_t] = ACTIONS(4602),
    [sym_string] = ACTIONS(4602),
    [sym_cstring] = ACTIONS(4602),
    [sym_dstring] = ACTIONS(4602),
    [sym_wstring] = ACTIONS(4602),
    [sym_noreturn] = ACTIONS(4602),
    [sym_true] = ACTIONS(4602),
    [sym_false] = ACTIONS(4602),
    [sym_null] = ACTIONS(4602),
    [sym_super] = ACTIONS(4602),
    [sym_this] = ACTIONS(4602),
    [sym_abstract] = ACTIONS(4602),
    [sym_alias] = ACTIONS(4602),
    [sym_align] = ACTIONS(4602),
    [sym_asm] = ACTIONS(4602),
    [sym_assert] = ACTIONS(4602),
    [sym_auto] = ACTIONS(4602),
    [sym_break] = ACTIONS(4602),
    [sym_case] = ACTIONS(4602),
    [sym_cast] = ACTIONS(4602),
    [sym_catch] = ACTIONS(4602),
    [sym_class] = ACTIONS(4602),
    [sym_const] = ACTIONS(4602),
    [sym_continue] = ACTIONS(4602),
    [sym_debug] = ACTIONS(4602),
    [sym_default] = ACTIONS(4602),
    [sym_delegate] = ACTIONS(4602),
    [sym_delete] = ACTIONS(4602),
    [sym_deprecated] = ACTIONS(4602),
    [sym_do] = ACTIONS(4602),
    [sym_else] = ACTIONS(4602),
    [sym_enum] = ACTIONS(4602),
    [sym_export] = ACTIONS(4602),
    [sym_extern] = ACTIONS(4602),
    [sym_final] = ACTIONS(4602),
    [sym_finally] = ACTIONS(4602),
    [sym_for] = ACTIONS(4602),
    [sym_foreach] = ACTIONS(4602),
    [sym_foreach_reverse] = ACTIONS(4602),
    [sym_function] = ACTIONS(4602),
    [sym_goto] = ACTIONS(4602),
    [sym_if] = ACTIONS(4602),
    [sym_immutable] = ACTIONS(4602),
    [sym_import] = ACTIONS(4602),
    [sym_in] = ACTIONS(4602),
    [sym_inout] = ACTIONS(4602),
    [sym_interface] = ACTIONS(4602),
    [sym_invariant] = ACTIONS(4602),
    [sym_is] = ACTIONS(4602),
    [sym_mixin] = ACTIONS(4602),
    [sym_new] = ACTIONS(4602),
    [sym_nothrow] = ACTIONS(4602),
    [sym_out] = ACTIONS(4602),
    [sym_override] = ACTIONS(4602),
    [sym_package] = ACTIONS(4602),
    [sym_pragma] = ACTIONS(4602),
    [sym_private] = ACTIONS(4602),
    [sym_protected] = ACTIONS(4602),
    [sym_public] = ACTIONS(4602),
    [sym_pure] = ACTIONS(4602),
    [sym_ref] = ACTIONS(4602),
    [sym_return] = ACTIONS(4602),
    [sym_scope] = ACTIONS(4602),
    [sym_shared] = ACTIONS(4602),
    [sym_static] = ACTIONS(4602),
    [sym_struct] = ACTIONS(4602),
    [sym_switch] = ACTIONS(4602),
    [sym_synchronized] = ACTIONS(4602),
    [sym_template] = ACTIONS(4602),
    [sym_throw] = ACTIONS(4602),
    [sym_try] = ACTIONS(4602),
    [sym_typeid] = ACTIONS(4602),
    [sym_typeof] = ACTIONS(4602),
    [sym_union] = ACTIONS(4602),
    [sym_unittest] = ACTIONS(4602),
    [sym_version] = ACTIONS(4602),
    [sym_while] = ACTIONS(4602),
    [sym_with] = ACTIONS(4602),
    [sym_gshared] = ACTIONS(4602),
    [sym_traits] = ACTIONS(4602),
    [sym_vector] = ACTIONS(4602),
    [sym_void] = ACTIONS(4602),
    [anon_sym_BQUOTE] = ACTIONS(4604),
    [anon_sym_r_DQUOTE] = ACTIONS(4604),
    [anon_sym_x_DQUOTE] = ACTIONS(4604),
    [anon_sym_DQUOTE] = ACTIONS(4604),
    [anon_sym_i_BQUOTE] = ACTIONS(4604),
    [anon_sym_i_DQUOTE] = ACTIONS(4604),
    [anon_sym_iq_LBRACE] = ACTIONS(4604),
    [aux_sym_char_literal_token1] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4602),
    [anon_sym___DATE__] = ACTIONS(4602),
    [anon_sym___FILE__] = ACTIONS(4602),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4602),
    [anon_sym___FUNCTION__] = ACTIONS(4602),
    [anon_sym___LINE__] = ACTIONS(4602),
    [anon_sym___MODULE__] = ACTIONS(4602),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4602),
    [anon_sym___TIME__] = ACTIONS(4602),
    [anon_sym___TIMESTAMP__] = ACTIONS(4602),
    [anon_sym___VENDOR__] = ACTIONS(4602),
    [anon_sym___VERSION__] = ACTIONS(4602),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4604),
    [sym_float_literal] = ACTIONS(4604),
    [sym__string] = ACTIONS(4604),
  },
  [1408] = {
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_q_LBRACE] = ACTIONS(4608),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [anon_sym_LBRACE] = ACTIONS(4608),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_DASH_DASH] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_LPAREN] = ACTIONS(4608),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_LBRACK] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4608),
    [anon_sym_TILDE] = ACTIONS(4608),
    [anon_sym_AT] = ACTIONS(4608),
    [sym_bool] = ACTIONS(4606),
    [sym_byte] = ACTIONS(4606),
    [sym_ubyte] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_short] = ACTIONS(4606),
    [sym_ushort] = ACTIONS(4606),
    [sym_int] = ACTIONS(4606),
    [sym_uint] = ACTIONS(4606),
    [sym_long] = ACTIONS(4606),
    [sym_ulong] = ACTIONS(4606),
    [sym_cent] = ACTIONS(4606),
    [sym_ucent] = ACTIONS(4606),
    [sym_wchar] = ACTIONS(4606),
    [sym_dchar] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_double] = ACTIONS(4606),
    [sym_real] = ACTIONS(4606),
    [sym_ifloat] = ACTIONS(4606),
    [sym_idouble] = ACTIONS(4606),
    [sym_ireal] = ACTIONS(4606),
    [sym_cfloat] = ACTIONS(4606),
    [sym_cdouble] = ACTIONS(4606),
    [sym_creal] = ACTIONS(4606),
    [sym_size_t] = ACTIONS(4606),
    [sym_ptrdiff_t] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym_cstring] = ACTIONS(4606),
    [sym_dstring] = ACTIONS(4606),
    [sym_wstring] = ACTIONS(4606),
    [sym_noreturn] = ACTIONS(4606),
    [sym_true] = ACTIONS(4606),
    [sym_false] = ACTIONS(4606),
    [sym_null] = ACTIONS(4606),
    [sym_super] = ACTIONS(4606),
    [sym_this] = ACTIONS(4606),
    [sym_abstract] = ACTIONS(4606),
    [sym_alias] = ACTIONS(4606),
    [sym_align] = ACTIONS(4606),
    [sym_asm] = ACTIONS(4606),
    [sym_assert] = ACTIONS(4606),
    [sym_auto] = ACTIONS(4606),
    [sym_break] = ACTIONS(4606),
    [sym_case] = ACTIONS(4606),
    [sym_cast] = ACTIONS(4606),
    [sym_catch] = ACTIONS(4606),
    [sym_class] = ACTIONS(4606),
    [sym_const] = ACTIONS(4606),
    [sym_continue] = ACTIONS(4606),
    [sym_debug] = ACTIONS(4606),
    [sym_default] = ACTIONS(4606),
    [sym_delegate] = ACTIONS(4606),
    [sym_delete] = ACTIONS(4606),
    [sym_deprecated] = ACTIONS(4606),
    [sym_do] = ACTIONS(4606),
    [sym_else] = ACTIONS(4606),
    [sym_enum] = ACTIONS(4606),
    [sym_export] = ACTIONS(4606),
    [sym_extern] = ACTIONS(4606),
    [sym_final] = ACTIONS(4606),
    [sym_finally] = ACTIONS(4606),
    [sym_for] = ACTIONS(4606),
    [sym_foreach] = ACTIONS(4606),
    [sym_foreach_reverse] = ACTIONS(4606),
    [sym_function] = ACTIONS(4606),
    [sym_goto] = ACTIONS(4606),
    [sym_if] = ACTIONS(4606),
    [sym_immutable] = ACTIONS(4606),
    [sym_import] = ACTIONS(4606),
    [sym_in] = ACTIONS(4606),
    [sym_inout] = ACTIONS(4606),
    [sym_interface] = ACTIONS(4606),
    [sym_invariant] = ACTIONS(4606),
    [sym_is] = ACTIONS(4606),
    [sym_mixin] = ACTIONS(4606),
    [sym_new] = ACTIONS(4606),
    [sym_nothrow] = ACTIONS(4606),
    [sym_out] = ACTIONS(4606),
    [sym_override] = ACTIONS(4606),
    [sym_package] = ACTIONS(4606),
    [sym_pragma] = ACTIONS(4606),
    [sym_private] = ACTIONS(4606),
    [sym_protected] = ACTIONS(4606),
    [sym_public] = ACTIONS(4606),
    [sym_pure] = ACTIONS(4606),
    [sym_ref] = ACTIONS(4606),
    [sym_return] = ACTIONS(4606),
    [sym_scope] = ACTIONS(4606),
    [sym_shared] = ACTIONS(4606),
    [sym_static] = ACTIONS(4606),
    [sym_struct] = ACTIONS(4606),
    [sym_switch] = ACTIONS(4606),
    [sym_synchronized] = ACTIONS(4606),
    [sym_template] = ACTIONS(4606),
    [sym_throw] = ACTIONS(4606),
    [sym_try] = ACTIONS(4606),
    [sym_typeid] = ACTIONS(4606),
    [sym_typeof] = ACTIONS(4606),
    [sym_union] = ACTIONS(4606),
    [sym_unittest] = ACTIONS(4606),
    [sym_version] = ACTIONS(4606),
    [sym_while] = ACTIONS(4606),
    [sym_with] = ACTIONS(4606),
    [sym_gshared] = ACTIONS(4606),
    [sym_traits] = ACTIONS(4606),
    [sym_vector] = ACTIONS(4606),
    [sym_void] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_r_DQUOTE] = ACTIONS(4608),
    [anon_sym_x_DQUOTE] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_i_BQUOTE] = ACTIONS(4608),
    [anon_sym_i_DQUOTE] = ACTIONS(4608),
    [anon_sym_iq_LBRACE] = ACTIONS(4608),
    [aux_sym_char_literal_token1] = ACTIONS(4608),
    [anon_sym_SQUOTE] = ACTIONS(4606),
    [anon_sym___DATE__] = ACTIONS(4606),
    [anon_sym___FILE__] = ACTIONS(4606),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4606),
    [anon_sym___FUNCTION__] = ACTIONS(4606),
    [anon_sym___LINE__] = ACTIONS(4606),
    [anon_sym___MODULE__] = ACTIONS(4606),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4606),
    [anon_sym___TIME__] = ACTIONS(4606),
    [anon_sym___TIMESTAMP__] = ACTIONS(4606),
    [anon_sym___VENDOR__] = ACTIONS(4606),
    [anon_sym___VERSION__] = ACTIONS(4606),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4608),
    [sym_float_literal] = ACTIONS(4608),
    [sym__string] = ACTIONS(4608),
  },
  [1409] = {
    [sym_identifier] = ACTIONS(4610),
    [anon_sym_q_LBRACE] = ACTIONS(4612),
    [anon_sym_RBRACE] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(4612),
    [anon_sym_DOT] = ACTIONS(4612),
    [anon_sym_AMP] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4612),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_PLUS_PLUS] = ACTIONS(4612),
    [anon_sym_BANG] = ACTIONS(4612),
    [anon_sym_LPAREN] = ACTIONS(4612),
    [anon_sym_RPAREN] = ACTIONS(4612),
    [anon_sym_LBRACK] = ACTIONS(4612),
    [anon_sym_SEMI] = ACTIONS(4612),
    [anon_sym_DOLLAR] = ACTIONS(4612),
    [anon_sym_STAR] = ACTIONS(4612),
    [anon_sym_TILDE] = ACTIONS(4612),
    [anon_sym_AT] = ACTIONS(4612),
    [sym_bool] = ACTIONS(4610),
    [sym_byte] = ACTIONS(4610),
    [sym_ubyte] = ACTIONS(4610),
    [sym_char] = ACTIONS(4610),
    [sym_short] = ACTIONS(4610),
    [sym_ushort] = ACTIONS(4610),
    [sym_int] = ACTIONS(4610),
    [sym_uint] = ACTIONS(4610),
    [sym_long] = ACTIONS(4610),
    [sym_ulong] = ACTIONS(4610),
    [sym_cent] = ACTIONS(4610),
    [sym_ucent] = ACTIONS(4610),
    [sym_wchar] = ACTIONS(4610),
    [sym_dchar] = ACTIONS(4610),
    [sym_float] = ACTIONS(4610),
    [sym_double] = ACTIONS(4610),
    [sym_real] = ACTIONS(4610),
    [sym_ifloat] = ACTIONS(4610),
    [sym_idouble] = ACTIONS(4610),
    [sym_ireal] = ACTIONS(4610),
    [sym_cfloat] = ACTIONS(4610),
    [sym_cdouble] = ACTIONS(4610),
    [sym_creal] = ACTIONS(4610),
    [sym_size_t] = ACTIONS(4610),
    [sym_ptrdiff_t] = ACTIONS(4610),
    [sym_string] = ACTIONS(4610),
    [sym_cstring] = ACTIONS(4610),
    [sym_dstring] = ACTIONS(4610),
    [sym_wstring] = ACTIONS(4610),
    [sym_noreturn] = ACTIONS(4610),
    [sym_true] = ACTIONS(4610),
    [sym_false] = ACTIONS(4610),
    [sym_null] = ACTIONS(4610),
    [sym_super] = ACTIONS(4610),
    [sym_this] = ACTIONS(4610),
    [sym_abstract] = ACTIONS(4610),
    [sym_alias] = ACTIONS(4610),
    [sym_align] = ACTIONS(4610),
    [sym_asm] = ACTIONS(4610),
    [sym_assert] = ACTIONS(4610),
    [sym_auto] = ACTIONS(4610),
    [sym_break] = ACTIONS(4610),
    [sym_case] = ACTIONS(4610),
    [sym_cast] = ACTIONS(4610),
    [sym_catch] = ACTIONS(4610),
    [sym_class] = ACTIONS(4610),
    [sym_const] = ACTIONS(4610),
    [sym_continue] = ACTIONS(4610),
    [sym_debug] = ACTIONS(4610),
    [sym_default] = ACTIONS(4610),
    [sym_delegate] = ACTIONS(4610),
    [sym_delete] = ACTIONS(4610),
    [sym_deprecated] = ACTIONS(4610),
    [sym_do] = ACTIONS(4610),
    [sym_else] = ACTIONS(4610),
    [sym_enum] = ACTIONS(4610),
    [sym_export] = ACTIONS(4610),
    [sym_extern] = ACTIONS(4610),
    [sym_final] = ACTIONS(4610),
    [sym_finally] = ACTIONS(4610),
    [sym_for] = ACTIONS(4610),
    [sym_foreach] = ACTIONS(4610),
    [sym_foreach_reverse] = ACTIONS(4610),
    [sym_function] = ACTIONS(4610),
    [sym_goto] = ACTIONS(4610),
    [sym_if] = ACTIONS(4610),
    [sym_immutable] = ACTIONS(4610),
    [sym_import] = ACTIONS(4610),
    [sym_in] = ACTIONS(4610),
    [sym_inout] = ACTIONS(4610),
    [sym_interface] = ACTIONS(4610),
    [sym_invariant] = ACTIONS(4610),
    [sym_is] = ACTIONS(4610),
    [sym_mixin] = ACTIONS(4610),
    [sym_new] = ACTIONS(4610),
    [sym_nothrow] = ACTIONS(4610),
    [sym_out] = ACTIONS(4610),
    [sym_override] = ACTIONS(4610),
    [sym_package] = ACTIONS(4610),
    [sym_pragma] = ACTIONS(4610),
    [sym_private] = ACTIONS(4610),
    [sym_protected] = ACTIONS(4610),
    [sym_public] = ACTIONS(4610),
    [sym_pure] = ACTIONS(4610),
    [sym_ref] = ACTIONS(4610),
    [sym_return] = ACTIONS(4610),
    [sym_scope] = ACTIONS(4610),
    [sym_shared] = ACTIONS(4610),
    [sym_static] = ACTIONS(4610),
    [sym_struct] = ACTIONS(4610),
    [sym_switch] = ACTIONS(4610),
    [sym_synchronized] = ACTIONS(4610),
    [sym_template] = ACTIONS(4610),
    [sym_throw] = ACTIONS(4610),
    [sym_try] = ACTIONS(4610),
    [sym_typeid] = ACTIONS(4610),
    [sym_typeof] = ACTIONS(4610),
    [sym_union] = ACTIONS(4610),
    [sym_unittest] = ACTIONS(4610),
    [sym_version] = ACTIONS(4610),
    [sym_while] = ACTIONS(4610),
    [sym_with] = ACTIONS(4610),
    [sym_gshared] = ACTIONS(4610),
    [sym_traits] = ACTIONS(4610),
    [sym_vector] = ACTIONS(4610),
    [sym_void] = ACTIONS(4610),
    [anon_sym_BQUOTE] = ACTIONS(4612),
    [anon_sym_r_DQUOTE] = ACTIONS(4612),
    [anon_sym_x_DQUOTE] = ACTIONS(4612),
    [anon_sym_DQUOTE] = ACTIONS(4612),
    [anon_sym_i_BQUOTE] = ACTIONS(4612),
    [anon_sym_i_DQUOTE] = ACTIONS(4612),
    [anon_sym_iq_LBRACE] = ACTIONS(4612),
    [aux_sym_char_literal_token1] = ACTIONS(4612),
    [anon_sym_SQUOTE] = ACTIONS(4610),
    [anon_sym___DATE__] = ACTIONS(4610),
    [anon_sym___FILE__] = ACTIONS(4610),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4610),
    [anon_sym___FUNCTION__] = ACTIONS(4610),
    [anon_sym___LINE__] = ACTIONS(4610),
    [anon_sym___MODULE__] = ACTIONS(4610),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4610),
    [anon_sym___TIME__] = ACTIONS(4610),
    [anon_sym___TIMESTAMP__] = ACTIONS(4610),
    [anon_sym___VENDOR__] = ACTIONS(4610),
    [anon_sym___VERSION__] = ACTIONS(4610),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4612),
    [sym_float_literal] = ACTIONS(4612),
    [sym__string] = ACTIONS(4612),
  },
  [1410] = {
    [sym_identifier] = ACTIONS(4614),
    [anon_sym_q_LBRACE] = ACTIONS(4616),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_LBRACE] = ACTIONS(4616),
    [anon_sym_DOT] = ACTIONS(4616),
    [anon_sym_AMP] = ACTIONS(4616),
    [anon_sym_DASH] = ACTIONS(4614),
    [anon_sym_DASH_DASH] = ACTIONS(4616),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_PLUS_PLUS] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4616),
    [anon_sym_LPAREN] = ACTIONS(4616),
    [anon_sym_RPAREN] = ACTIONS(4616),
    [anon_sym_LBRACK] = ACTIONS(4616),
    [anon_sym_SEMI] = ACTIONS(4616),
    [anon_sym_DOLLAR] = ACTIONS(4616),
    [anon_sym_STAR] = ACTIONS(4616),
    [anon_sym_TILDE] = ACTIONS(4616),
    [anon_sym_AT] = ACTIONS(4616),
    [sym_bool] = ACTIONS(4614),
    [sym_byte] = ACTIONS(4614),
    [sym_ubyte] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_short] = ACTIONS(4614),
    [sym_ushort] = ACTIONS(4614),
    [sym_int] = ACTIONS(4614),
    [sym_uint] = ACTIONS(4614),
    [sym_long] = ACTIONS(4614),
    [sym_ulong] = ACTIONS(4614),
    [sym_cent] = ACTIONS(4614),
    [sym_ucent] = ACTIONS(4614),
    [sym_wchar] = ACTIONS(4614),
    [sym_dchar] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_double] = ACTIONS(4614),
    [sym_real] = ACTIONS(4614),
    [sym_ifloat] = ACTIONS(4614),
    [sym_idouble] = ACTIONS(4614),
    [sym_ireal] = ACTIONS(4614),
    [sym_cfloat] = ACTIONS(4614),
    [sym_cdouble] = ACTIONS(4614),
    [sym_creal] = ACTIONS(4614),
    [sym_size_t] = ACTIONS(4614),
    [sym_ptrdiff_t] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym_cstring] = ACTIONS(4614),
    [sym_dstring] = ACTIONS(4614),
    [sym_wstring] = ACTIONS(4614),
    [sym_noreturn] = ACTIONS(4614),
    [sym_true] = ACTIONS(4614),
    [sym_false] = ACTIONS(4614),
    [sym_null] = ACTIONS(4614),
    [sym_super] = ACTIONS(4614),
    [sym_this] = ACTIONS(4614),
    [sym_abstract] = ACTIONS(4614),
    [sym_alias] = ACTIONS(4614),
    [sym_align] = ACTIONS(4614),
    [sym_asm] = ACTIONS(4614),
    [sym_assert] = ACTIONS(4614),
    [sym_auto] = ACTIONS(4614),
    [sym_break] = ACTIONS(4614),
    [sym_case] = ACTIONS(4614),
    [sym_cast] = ACTIONS(4614),
    [sym_catch] = ACTIONS(4614),
    [sym_class] = ACTIONS(4614),
    [sym_const] = ACTIONS(4614),
    [sym_continue] = ACTIONS(4614),
    [sym_debug] = ACTIONS(4614),
    [sym_default] = ACTIONS(4614),
    [sym_delegate] = ACTIONS(4614),
    [sym_delete] = ACTIONS(4614),
    [sym_deprecated] = ACTIONS(4614),
    [sym_do] = ACTIONS(4614),
    [sym_else] = ACTIONS(4614),
    [sym_enum] = ACTIONS(4614),
    [sym_export] = ACTIONS(4614),
    [sym_extern] = ACTIONS(4614),
    [sym_final] = ACTIONS(4614),
    [sym_finally] = ACTIONS(4614),
    [sym_for] = ACTIONS(4614),
    [sym_foreach] = ACTIONS(4614),
    [sym_foreach_reverse] = ACTIONS(4614),
    [sym_function] = ACTIONS(4614),
    [sym_goto] = ACTIONS(4614),
    [sym_if] = ACTIONS(4614),
    [sym_immutable] = ACTIONS(4614),
    [sym_import] = ACTIONS(4614),
    [sym_in] = ACTIONS(4614),
    [sym_inout] = ACTIONS(4614),
    [sym_interface] = ACTIONS(4614),
    [sym_invariant] = ACTIONS(4614),
    [sym_is] = ACTIONS(4614),
    [sym_mixin] = ACTIONS(4614),
    [sym_new] = ACTIONS(4614),
    [sym_nothrow] = ACTIONS(4614),
    [sym_out] = ACTIONS(4614),
    [sym_override] = ACTIONS(4614),
    [sym_package] = ACTIONS(4614),
    [sym_pragma] = ACTIONS(4614),
    [sym_private] = ACTIONS(4614),
    [sym_protected] = ACTIONS(4614),
    [sym_public] = ACTIONS(4614),
    [sym_pure] = ACTIONS(4614),
    [sym_ref] = ACTIONS(4614),
    [sym_return] = ACTIONS(4614),
    [sym_scope] = ACTIONS(4614),
    [sym_shared] = ACTIONS(4614),
    [sym_static] = ACTIONS(4614),
    [sym_struct] = ACTIONS(4614),
    [sym_switch] = ACTIONS(4614),
    [sym_synchronized] = ACTIONS(4614),
    [sym_template] = ACTIONS(4614),
    [sym_throw] = ACTIONS(4614),
    [sym_try] = ACTIONS(4614),
    [sym_typeid] = ACTIONS(4614),
    [sym_typeof] = ACTIONS(4614),
    [sym_union] = ACTIONS(4614),
    [sym_unittest] = ACTIONS(4614),
    [sym_version] = ACTIONS(4614),
    [sym_while] = ACTIONS(4614),
    [sym_with] = ACTIONS(4614),
    [sym_gshared] = ACTIONS(4614),
    [sym_traits] = ACTIONS(4614),
    [sym_vector] = ACTIONS(4614),
    [sym_void] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4616),
    [anon_sym_r_DQUOTE] = ACTIONS(4616),
    [anon_sym_x_DQUOTE] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(4616),
    [anon_sym_i_BQUOTE] = ACTIONS(4616),
    [anon_sym_i_DQUOTE] = ACTIONS(4616),
    [anon_sym_iq_LBRACE] = ACTIONS(4616),
    [aux_sym_char_literal_token1] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4614),
    [anon_sym___DATE__] = ACTIONS(4614),
    [anon_sym___FILE__] = ACTIONS(4614),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4614),
    [anon_sym___FUNCTION__] = ACTIONS(4614),
    [anon_sym___LINE__] = ACTIONS(4614),
    [anon_sym___MODULE__] = ACTIONS(4614),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4614),
    [anon_sym___TIME__] = ACTIONS(4614),
    [anon_sym___TIMESTAMP__] = ACTIONS(4614),
    [anon_sym___VENDOR__] = ACTIONS(4614),
    [anon_sym___VERSION__] = ACTIONS(4614),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4616),
    [sym_float_literal] = ACTIONS(4616),
    [sym__string] = ACTIONS(4616),
  },
  [1411] = {
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_q_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4620),
    [anon_sym_AMP] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_BANG] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_DOLLAR] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_TILDE] = ACTIONS(4620),
    [anon_sym_AT] = ACTIONS(4620),
    [sym_bool] = ACTIONS(4618),
    [sym_byte] = ACTIONS(4618),
    [sym_ubyte] = ACTIONS(4618),
    [sym_char] = ACTIONS(4618),
    [sym_short] = ACTIONS(4618),
    [sym_ushort] = ACTIONS(4618),
    [sym_int] = ACTIONS(4618),
    [sym_uint] = ACTIONS(4618),
    [sym_long] = ACTIONS(4618),
    [sym_ulong] = ACTIONS(4618),
    [sym_cent] = ACTIONS(4618),
    [sym_ucent] = ACTIONS(4618),
    [sym_wchar] = ACTIONS(4618),
    [sym_dchar] = ACTIONS(4618),
    [sym_float] = ACTIONS(4618),
    [sym_double] = ACTIONS(4618),
    [sym_real] = ACTIONS(4618),
    [sym_ifloat] = ACTIONS(4618),
    [sym_idouble] = ACTIONS(4618),
    [sym_ireal] = ACTIONS(4618),
    [sym_cfloat] = ACTIONS(4618),
    [sym_cdouble] = ACTIONS(4618),
    [sym_creal] = ACTIONS(4618),
    [sym_size_t] = ACTIONS(4618),
    [sym_ptrdiff_t] = ACTIONS(4618),
    [sym_string] = ACTIONS(4618),
    [sym_cstring] = ACTIONS(4618),
    [sym_dstring] = ACTIONS(4618),
    [sym_wstring] = ACTIONS(4618),
    [sym_noreturn] = ACTIONS(4618),
    [sym_true] = ACTIONS(4618),
    [sym_false] = ACTIONS(4618),
    [sym_null] = ACTIONS(4618),
    [sym_super] = ACTIONS(4618),
    [sym_this] = ACTIONS(4618),
    [sym_abstract] = ACTIONS(4618),
    [sym_alias] = ACTIONS(4618),
    [sym_align] = ACTIONS(4618),
    [sym_asm] = ACTIONS(4618),
    [sym_assert] = ACTIONS(4618),
    [sym_auto] = ACTIONS(4618),
    [sym_break] = ACTIONS(4618),
    [sym_case] = ACTIONS(4618),
    [sym_cast] = ACTIONS(4618),
    [sym_catch] = ACTIONS(4618),
    [sym_class] = ACTIONS(4618),
    [sym_const] = ACTIONS(4618),
    [sym_continue] = ACTIONS(4618),
    [sym_debug] = ACTIONS(4618),
    [sym_default] = ACTIONS(4618),
    [sym_delegate] = ACTIONS(4618),
    [sym_delete] = ACTIONS(4618),
    [sym_deprecated] = ACTIONS(4618),
    [sym_do] = ACTIONS(4618),
    [sym_else] = ACTIONS(4618),
    [sym_enum] = ACTIONS(4618),
    [sym_export] = ACTIONS(4618),
    [sym_extern] = ACTIONS(4618),
    [sym_final] = ACTIONS(4618),
    [sym_finally] = ACTIONS(4618),
    [sym_for] = ACTIONS(4618),
    [sym_foreach] = ACTIONS(4618),
    [sym_foreach_reverse] = ACTIONS(4618),
    [sym_function] = ACTIONS(4618),
    [sym_goto] = ACTIONS(4618),
    [sym_if] = ACTIONS(4618),
    [sym_immutable] = ACTIONS(4618),
    [sym_import] = ACTIONS(4618),
    [sym_in] = ACTIONS(4618),
    [sym_inout] = ACTIONS(4618),
    [sym_interface] = ACTIONS(4618),
    [sym_invariant] = ACTIONS(4618),
    [sym_is] = ACTIONS(4618),
    [sym_mixin] = ACTIONS(4618),
    [sym_new] = ACTIONS(4618),
    [sym_nothrow] = ACTIONS(4618),
    [sym_out] = ACTIONS(4618),
    [sym_override] = ACTIONS(4618),
    [sym_package] = ACTIONS(4618),
    [sym_pragma] = ACTIONS(4618),
    [sym_private] = ACTIONS(4618),
    [sym_protected] = ACTIONS(4618),
    [sym_public] = ACTIONS(4618),
    [sym_pure] = ACTIONS(4618),
    [sym_ref] = ACTIONS(4618),
    [sym_return] = ACTIONS(4618),
    [sym_scope] = ACTIONS(4618),
    [sym_shared] = ACTIONS(4618),
    [sym_static] = ACTIONS(4618),
    [sym_struct] = ACTIONS(4618),
    [sym_switch] = ACTIONS(4618),
    [sym_synchronized] = ACTIONS(4618),
    [sym_template] = ACTIONS(4618),
    [sym_throw] = ACTIONS(4618),
    [sym_try] = ACTIONS(4618),
    [sym_typeid] = ACTIONS(4618),
    [sym_typeof] = ACTIONS(4618),
    [sym_union] = ACTIONS(4618),
    [sym_unittest] = ACTIONS(4618),
    [sym_version] = ACTIONS(4618),
    [sym_while] = ACTIONS(4618),
    [sym_with] = ACTIONS(4618),
    [sym_gshared] = ACTIONS(4618),
    [sym_traits] = ACTIONS(4618),
    [sym_vector] = ACTIONS(4618),
    [sym_void] = ACTIONS(4618),
    [anon_sym_BQUOTE] = ACTIONS(4620),
    [anon_sym_r_DQUOTE] = ACTIONS(4620),
    [anon_sym_x_DQUOTE] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [anon_sym_i_BQUOTE] = ACTIONS(4620),
    [anon_sym_i_DQUOTE] = ACTIONS(4620),
    [anon_sym_iq_LBRACE] = ACTIONS(4620),
    [aux_sym_char_literal_token1] = ACTIONS(4620),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym___DATE__] = ACTIONS(4618),
    [anon_sym___FILE__] = ACTIONS(4618),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4618),
    [anon_sym___FUNCTION__] = ACTIONS(4618),
    [anon_sym___LINE__] = ACTIONS(4618),
    [anon_sym___MODULE__] = ACTIONS(4618),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4618),
    [anon_sym___TIME__] = ACTIONS(4618),
    [anon_sym___TIMESTAMP__] = ACTIONS(4618),
    [anon_sym___VENDOR__] = ACTIONS(4618),
    [anon_sym___VERSION__] = ACTIONS(4618),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4620),
    [sym_float_literal] = ACTIONS(4620),
    [sym__string] = ACTIONS(4620),
  },
  [1412] = {
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_q_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_DOLLAR] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_AT] = ACTIONS(4624),
    [sym_bool] = ACTIONS(4622),
    [sym_byte] = ACTIONS(4622),
    [sym_ubyte] = ACTIONS(4622),
    [sym_char] = ACTIONS(4622),
    [sym_short] = ACTIONS(4622),
    [sym_ushort] = ACTIONS(4622),
    [sym_int] = ACTIONS(4622),
    [sym_uint] = ACTIONS(4622),
    [sym_long] = ACTIONS(4622),
    [sym_ulong] = ACTIONS(4622),
    [sym_cent] = ACTIONS(4622),
    [sym_ucent] = ACTIONS(4622),
    [sym_wchar] = ACTIONS(4622),
    [sym_dchar] = ACTIONS(4622),
    [sym_float] = ACTIONS(4622),
    [sym_double] = ACTIONS(4622),
    [sym_real] = ACTIONS(4622),
    [sym_ifloat] = ACTIONS(4622),
    [sym_idouble] = ACTIONS(4622),
    [sym_ireal] = ACTIONS(4622),
    [sym_cfloat] = ACTIONS(4622),
    [sym_cdouble] = ACTIONS(4622),
    [sym_creal] = ACTIONS(4622),
    [sym_size_t] = ACTIONS(4622),
    [sym_ptrdiff_t] = ACTIONS(4622),
    [sym_string] = ACTIONS(4622),
    [sym_cstring] = ACTIONS(4622),
    [sym_dstring] = ACTIONS(4622),
    [sym_wstring] = ACTIONS(4622),
    [sym_noreturn] = ACTIONS(4622),
    [sym_true] = ACTIONS(4622),
    [sym_false] = ACTIONS(4622),
    [sym_null] = ACTIONS(4622),
    [sym_super] = ACTIONS(4622),
    [sym_this] = ACTIONS(4622),
    [sym_abstract] = ACTIONS(4622),
    [sym_alias] = ACTIONS(4622),
    [sym_align] = ACTIONS(4622),
    [sym_asm] = ACTIONS(4622),
    [sym_assert] = ACTIONS(4622),
    [sym_auto] = ACTIONS(4622),
    [sym_break] = ACTIONS(4622),
    [sym_case] = ACTIONS(4622),
    [sym_cast] = ACTIONS(4622),
    [sym_catch] = ACTIONS(4622),
    [sym_class] = ACTIONS(4622),
    [sym_const] = ACTIONS(4622),
    [sym_continue] = ACTIONS(4622),
    [sym_debug] = ACTIONS(4622),
    [sym_default] = ACTIONS(4622),
    [sym_delegate] = ACTIONS(4622),
    [sym_delete] = ACTIONS(4622),
    [sym_deprecated] = ACTIONS(4622),
    [sym_do] = ACTIONS(4622),
    [sym_else] = ACTIONS(4622),
    [sym_enum] = ACTIONS(4622),
    [sym_export] = ACTIONS(4622),
    [sym_extern] = ACTIONS(4622),
    [sym_final] = ACTIONS(4622),
    [sym_finally] = ACTIONS(4622),
    [sym_for] = ACTIONS(4622),
    [sym_foreach] = ACTIONS(4622),
    [sym_foreach_reverse] = ACTIONS(4622),
    [sym_function] = ACTIONS(4622),
    [sym_goto] = ACTIONS(4622),
    [sym_if] = ACTIONS(4622),
    [sym_immutable] = ACTIONS(4622),
    [sym_import] = ACTIONS(4622),
    [sym_in] = ACTIONS(4622),
    [sym_inout] = ACTIONS(4622),
    [sym_interface] = ACTIONS(4622),
    [sym_invariant] = ACTIONS(4622),
    [sym_is] = ACTIONS(4622),
    [sym_mixin] = ACTIONS(4622),
    [sym_new] = ACTIONS(4622),
    [sym_nothrow] = ACTIONS(4622),
    [sym_out] = ACTIONS(4622),
    [sym_override] = ACTIONS(4622),
    [sym_package] = ACTIONS(4622),
    [sym_pragma] = ACTIONS(4622),
    [sym_private] = ACTIONS(4622),
    [sym_protected] = ACTIONS(4622),
    [sym_public] = ACTIONS(4622),
    [sym_pure] = ACTIONS(4622),
    [sym_ref] = ACTIONS(4622),
    [sym_return] = ACTIONS(4622),
    [sym_scope] = ACTIONS(4622),
    [sym_shared] = ACTIONS(4622),
    [sym_static] = ACTIONS(4622),
    [sym_struct] = ACTIONS(4622),
    [sym_switch] = ACTIONS(4622),
    [sym_synchronized] = ACTIONS(4622),
    [sym_template] = ACTIONS(4622),
    [sym_throw] = ACTIONS(4622),
    [sym_try] = ACTIONS(4622),
    [sym_typeid] = ACTIONS(4622),
    [sym_typeof] = ACTIONS(4622),
    [sym_union] = ACTIONS(4622),
    [sym_unittest] = ACTIONS(4622),
    [sym_version] = ACTIONS(4622),
    [sym_while] = ACTIONS(4622),
    [sym_with] = ACTIONS(4622),
    [sym_gshared] = ACTIONS(4622),
    [sym_traits] = ACTIONS(4622),
    [sym_vector] = ACTIONS(4622),
    [sym_void] = ACTIONS(4622),
    [anon_sym_BQUOTE] = ACTIONS(4624),
    [anon_sym_r_DQUOTE] = ACTIONS(4624),
    [anon_sym_x_DQUOTE] = ACTIONS(4624),
    [anon_sym_DQUOTE] = ACTIONS(4624),
    [anon_sym_i_BQUOTE] = ACTIONS(4624),
    [anon_sym_i_DQUOTE] = ACTIONS(4624),
    [anon_sym_iq_LBRACE] = ACTIONS(4624),
    [aux_sym_char_literal_token1] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4622),
    [anon_sym___DATE__] = ACTIONS(4622),
    [anon_sym___FILE__] = ACTIONS(4622),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4622),
    [anon_sym___FUNCTION__] = ACTIONS(4622),
    [anon_sym___LINE__] = ACTIONS(4622),
    [anon_sym___MODULE__] = ACTIONS(4622),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4622),
    [anon_sym___TIME__] = ACTIONS(4622),
    [anon_sym___TIMESTAMP__] = ACTIONS(4622),
    [anon_sym___VENDOR__] = ACTIONS(4622),
    [anon_sym___VERSION__] = ACTIONS(4622),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4624),
    [sym_float_literal] = ACTIONS(4624),
    [sym__string] = ACTIONS(4624),
  },
  [1413] = {
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_q_LBRACE] = ACTIONS(4628),
    [anon_sym_RBRACE] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(4628),
    [anon_sym_DOT] = ACTIONS(4628),
    [anon_sym_AMP] = ACTIONS(4628),
    [anon_sym_DASH] = ACTIONS(4626),
    [anon_sym_DASH_DASH] = ACTIONS(4628),
    [anon_sym_PLUS] = ACTIONS(4626),
    [anon_sym_PLUS_PLUS] = ACTIONS(4628),
    [anon_sym_BANG] = ACTIONS(4628),
    [anon_sym_LPAREN] = ACTIONS(4628),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_LBRACK] = ACTIONS(4628),
    [anon_sym_SEMI] = ACTIONS(4628),
    [anon_sym_DOLLAR] = ACTIONS(4628),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_TILDE] = ACTIONS(4628),
    [anon_sym_AT] = ACTIONS(4628),
    [sym_bool] = ACTIONS(4626),
    [sym_byte] = ACTIONS(4626),
    [sym_ubyte] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_short] = ACTIONS(4626),
    [sym_ushort] = ACTIONS(4626),
    [sym_int] = ACTIONS(4626),
    [sym_uint] = ACTIONS(4626),
    [sym_long] = ACTIONS(4626),
    [sym_ulong] = ACTIONS(4626),
    [sym_cent] = ACTIONS(4626),
    [sym_ucent] = ACTIONS(4626),
    [sym_wchar] = ACTIONS(4626),
    [sym_dchar] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_double] = ACTIONS(4626),
    [sym_real] = ACTIONS(4626),
    [sym_ifloat] = ACTIONS(4626),
    [sym_idouble] = ACTIONS(4626),
    [sym_ireal] = ACTIONS(4626),
    [sym_cfloat] = ACTIONS(4626),
    [sym_cdouble] = ACTIONS(4626),
    [sym_creal] = ACTIONS(4626),
    [sym_size_t] = ACTIONS(4626),
    [sym_ptrdiff_t] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym_cstring] = ACTIONS(4626),
    [sym_dstring] = ACTIONS(4626),
    [sym_wstring] = ACTIONS(4626),
    [sym_noreturn] = ACTIONS(4626),
    [sym_true] = ACTIONS(4626),
    [sym_false] = ACTIONS(4626),
    [sym_null] = ACTIONS(4626),
    [sym_super] = ACTIONS(4626),
    [sym_this] = ACTIONS(4626),
    [sym_abstract] = ACTIONS(4626),
    [sym_alias] = ACTIONS(4626),
    [sym_align] = ACTIONS(4626),
    [sym_asm] = ACTIONS(4626),
    [sym_assert] = ACTIONS(4626),
    [sym_auto] = ACTIONS(4626),
    [sym_break] = ACTIONS(4626),
    [sym_case] = ACTIONS(4626),
    [sym_cast] = ACTIONS(4626),
    [sym_catch] = ACTIONS(4626),
    [sym_class] = ACTIONS(4626),
    [sym_const] = ACTIONS(4626),
    [sym_continue] = ACTIONS(4626),
    [sym_debug] = ACTIONS(4626),
    [sym_default] = ACTIONS(4626),
    [sym_delegate] = ACTIONS(4626),
    [sym_delete] = ACTIONS(4626),
    [sym_deprecated] = ACTIONS(4626),
    [sym_do] = ACTIONS(4626),
    [sym_else] = ACTIONS(4626),
    [sym_enum] = ACTIONS(4626),
    [sym_export] = ACTIONS(4626),
    [sym_extern] = ACTIONS(4626),
    [sym_final] = ACTIONS(4626),
    [sym_finally] = ACTIONS(4626),
    [sym_for] = ACTIONS(4626),
    [sym_foreach] = ACTIONS(4626),
    [sym_foreach_reverse] = ACTIONS(4626),
    [sym_function] = ACTIONS(4626),
    [sym_goto] = ACTIONS(4626),
    [sym_if] = ACTIONS(4626),
    [sym_immutable] = ACTIONS(4626),
    [sym_import] = ACTIONS(4626),
    [sym_in] = ACTIONS(4626),
    [sym_inout] = ACTIONS(4626),
    [sym_interface] = ACTIONS(4626),
    [sym_invariant] = ACTIONS(4626),
    [sym_is] = ACTIONS(4626),
    [sym_mixin] = ACTIONS(4626),
    [sym_new] = ACTIONS(4626),
    [sym_nothrow] = ACTIONS(4626),
    [sym_out] = ACTIONS(4626),
    [sym_override] = ACTIONS(4626),
    [sym_package] = ACTIONS(4626),
    [sym_pragma] = ACTIONS(4626),
    [sym_private] = ACTIONS(4626),
    [sym_protected] = ACTIONS(4626),
    [sym_public] = ACTIONS(4626),
    [sym_pure] = ACTIONS(4626),
    [sym_ref] = ACTIONS(4626),
    [sym_return] = ACTIONS(4626),
    [sym_scope] = ACTIONS(4626),
    [sym_shared] = ACTIONS(4626),
    [sym_static] = ACTIONS(4626),
    [sym_struct] = ACTIONS(4626),
    [sym_switch] = ACTIONS(4626),
    [sym_synchronized] = ACTIONS(4626),
    [sym_template] = ACTIONS(4626),
    [sym_throw] = ACTIONS(4626),
    [sym_try] = ACTIONS(4626),
    [sym_typeid] = ACTIONS(4626),
    [sym_typeof] = ACTIONS(4626),
    [sym_union] = ACTIONS(4626),
    [sym_unittest] = ACTIONS(4626),
    [sym_version] = ACTIONS(4626),
    [sym_while] = ACTIONS(4626),
    [sym_with] = ACTIONS(4626),
    [sym_gshared] = ACTIONS(4626),
    [sym_traits] = ACTIONS(4626),
    [sym_vector] = ACTIONS(4626),
    [sym_void] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4628),
    [anon_sym_r_DQUOTE] = ACTIONS(4628),
    [anon_sym_x_DQUOTE] = ACTIONS(4628),
    [anon_sym_DQUOTE] = ACTIONS(4628),
    [anon_sym_i_BQUOTE] = ACTIONS(4628),
    [anon_sym_i_DQUOTE] = ACTIONS(4628),
    [anon_sym_iq_LBRACE] = ACTIONS(4628),
    [aux_sym_char_literal_token1] = ACTIONS(4628),
    [anon_sym_SQUOTE] = ACTIONS(4626),
    [anon_sym___DATE__] = ACTIONS(4626),
    [anon_sym___FILE__] = ACTIONS(4626),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4626),
    [anon_sym___FUNCTION__] = ACTIONS(4626),
    [anon_sym___LINE__] = ACTIONS(4626),
    [anon_sym___MODULE__] = ACTIONS(4626),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4626),
    [anon_sym___TIME__] = ACTIONS(4626),
    [anon_sym___TIMESTAMP__] = ACTIONS(4626),
    [anon_sym___VENDOR__] = ACTIONS(4626),
    [anon_sym___VERSION__] = ACTIONS(4626),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4628),
    [sym_float_literal] = ACTIONS(4628),
    [sym__string] = ACTIONS(4628),
  },
  [1414] = {
    [sym_identifier] = ACTIONS(4630),
    [anon_sym_q_LBRACE] = ACTIONS(4632),
    [anon_sym_RBRACE] = ACTIONS(4632),
    [anon_sym_LBRACE] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(4632),
    [anon_sym_AMP] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4630),
    [anon_sym_DASH_DASH] = ACTIONS(4632),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_PLUS_PLUS] = ACTIONS(4632),
    [anon_sym_BANG] = ACTIONS(4632),
    [anon_sym_LPAREN] = ACTIONS(4632),
    [anon_sym_RPAREN] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4632),
    [anon_sym_DOLLAR] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4632),
    [anon_sym_TILDE] = ACTIONS(4632),
    [anon_sym_AT] = ACTIONS(4632),
    [sym_bool] = ACTIONS(4630),
    [sym_byte] = ACTIONS(4630),
    [sym_ubyte] = ACTIONS(4630),
    [sym_char] = ACTIONS(4630),
    [sym_short] = ACTIONS(4630),
    [sym_ushort] = ACTIONS(4630),
    [sym_int] = ACTIONS(4630),
    [sym_uint] = ACTIONS(4630),
    [sym_long] = ACTIONS(4630),
    [sym_ulong] = ACTIONS(4630),
    [sym_cent] = ACTIONS(4630),
    [sym_ucent] = ACTIONS(4630),
    [sym_wchar] = ACTIONS(4630),
    [sym_dchar] = ACTIONS(4630),
    [sym_float] = ACTIONS(4630),
    [sym_double] = ACTIONS(4630),
    [sym_real] = ACTIONS(4630),
    [sym_ifloat] = ACTIONS(4630),
    [sym_idouble] = ACTIONS(4630),
    [sym_ireal] = ACTIONS(4630),
    [sym_cfloat] = ACTIONS(4630),
    [sym_cdouble] = ACTIONS(4630),
    [sym_creal] = ACTIONS(4630),
    [sym_size_t] = ACTIONS(4630),
    [sym_ptrdiff_t] = ACTIONS(4630),
    [sym_string] = ACTIONS(4630),
    [sym_cstring] = ACTIONS(4630),
    [sym_dstring] = ACTIONS(4630),
    [sym_wstring] = ACTIONS(4630),
    [sym_noreturn] = ACTIONS(4630),
    [sym_true] = ACTIONS(4630),
    [sym_false] = ACTIONS(4630),
    [sym_null] = ACTIONS(4630),
    [sym_super] = ACTIONS(4630),
    [sym_this] = ACTIONS(4630),
    [sym_abstract] = ACTIONS(4630),
    [sym_alias] = ACTIONS(4630),
    [sym_align] = ACTIONS(4630),
    [sym_asm] = ACTIONS(4630),
    [sym_assert] = ACTIONS(4630),
    [sym_auto] = ACTIONS(4630),
    [sym_break] = ACTIONS(4630),
    [sym_case] = ACTIONS(4630),
    [sym_cast] = ACTIONS(4630),
    [sym_catch] = ACTIONS(4630),
    [sym_class] = ACTIONS(4630),
    [sym_const] = ACTIONS(4630),
    [sym_continue] = ACTIONS(4630),
    [sym_debug] = ACTIONS(4630),
    [sym_default] = ACTIONS(4630),
    [sym_delegate] = ACTIONS(4630),
    [sym_delete] = ACTIONS(4630),
    [sym_deprecated] = ACTIONS(4630),
    [sym_do] = ACTIONS(4630),
    [sym_else] = ACTIONS(4630),
    [sym_enum] = ACTIONS(4630),
    [sym_export] = ACTIONS(4630),
    [sym_extern] = ACTIONS(4630),
    [sym_final] = ACTIONS(4630),
    [sym_finally] = ACTIONS(4630),
    [sym_for] = ACTIONS(4630),
    [sym_foreach] = ACTIONS(4630),
    [sym_foreach_reverse] = ACTIONS(4630),
    [sym_function] = ACTIONS(4630),
    [sym_goto] = ACTIONS(4630),
    [sym_if] = ACTIONS(4630),
    [sym_immutable] = ACTIONS(4630),
    [sym_import] = ACTIONS(4630),
    [sym_in] = ACTIONS(4630),
    [sym_inout] = ACTIONS(4630),
    [sym_interface] = ACTIONS(4630),
    [sym_invariant] = ACTIONS(4630),
    [sym_is] = ACTIONS(4630),
    [sym_mixin] = ACTIONS(4630),
    [sym_new] = ACTIONS(4630),
    [sym_nothrow] = ACTIONS(4630),
    [sym_out] = ACTIONS(4630),
    [sym_override] = ACTIONS(4630),
    [sym_package] = ACTIONS(4630),
    [sym_pragma] = ACTIONS(4630),
    [sym_private] = ACTIONS(4630),
    [sym_protected] = ACTIONS(4630),
    [sym_public] = ACTIONS(4630),
    [sym_pure] = ACTIONS(4630),
    [sym_ref] = ACTIONS(4630),
    [sym_return] = ACTIONS(4630),
    [sym_scope] = ACTIONS(4630),
    [sym_shared] = ACTIONS(4630),
    [sym_static] = ACTIONS(4630),
    [sym_struct] = ACTIONS(4630),
    [sym_switch] = ACTIONS(4630),
    [sym_synchronized] = ACTIONS(4630),
    [sym_template] = ACTIONS(4630),
    [sym_throw] = ACTIONS(4630),
    [sym_try] = ACTIONS(4630),
    [sym_typeid] = ACTIONS(4630),
    [sym_typeof] = ACTIONS(4630),
    [sym_union] = ACTIONS(4630),
    [sym_unittest] = ACTIONS(4630),
    [sym_version] = ACTIONS(4630),
    [sym_while] = ACTIONS(4630),
    [sym_with] = ACTIONS(4630),
    [sym_gshared] = ACTIONS(4630),
    [sym_traits] = ACTIONS(4630),
    [sym_vector] = ACTIONS(4630),
    [sym_void] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(4632),
    [anon_sym_r_DQUOTE] = ACTIONS(4632),
    [anon_sym_x_DQUOTE] = ACTIONS(4632),
    [anon_sym_DQUOTE] = ACTIONS(4632),
    [anon_sym_i_BQUOTE] = ACTIONS(4632),
    [anon_sym_i_DQUOTE] = ACTIONS(4632),
    [anon_sym_iq_LBRACE] = ACTIONS(4632),
    [aux_sym_char_literal_token1] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4630),
    [anon_sym___DATE__] = ACTIONS(4630),
    [anon_sym___FILE__] = ACTIONS(4630),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4630),
    [anon_sym___FUNCTION__] = ACTIONS(4630),
    [anon_sym___LINE__] = ACTIONS(4630),
    [anon_sym___MODULE__] = ACTIONS(4630),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4630),
    [anon_sym___TIME__] = ACTIONS(4630),
    [anon_sym___TIMESTAMP__] = ACTIONS(4630),
    [anon_sym___VENDOR__] = ACTIONS(4630),
    [anon_sym___VERSION__] = ACTIONS(4630),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4632),
    [sym_float_literal] = ACTIONS(4632),
    [sym__string] = ACTIONS(4632),
  },
  [1415] = {
    [sym_identifier] = ACTIONS(4634),
    [anon_sym_q_LBRACE] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LBRACE] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4636),
    [anon_sym_AMP] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(4634),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4634),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_DOLLAR] = ACTIONS(4636),
    [anon_sym_STAR] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [anon_sym_AT] = ACTIONS(4636),
    [sym_bool] = ACTIONS(4634),
    [sym_byte] = ACTIONS(4634),
    [sym_ubyte] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_short] = ACTIONS(4634),
    [sym_ushort] = ACTIONS(4634),
    [sym_int] = ACTIONS(4634),
    [sym_uint] = ACTIONS(4634),
    [sym_long] = ACTIONS(4634),
    [sym_ulong] = ACTIONS(4634),
    [sym_cent] = ACTIONS(4634),
    [sym_ucent] = ACTIONS(4634),
    [sym_wchar] = ACTIONS(4634),
    [sym_dchar] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_double] = ACTIONS(4634),
    [sym_real] = ACTIONS(4634),
    [sym_ifloat] = ACTIONS(4634),
    [sym_idouble] = ACTIONS(4634),
    [sym_ireal] = ACTIONS(4634),
    [sym_cfloat] = ACTIONS(4634),
    [sym_cdouble] = ACTIONS(4634),
    [sym_creal] = ACTIONS(4634),
    [sym_size_t] = ACTIONS(4634),
    [sym_ptrdiff_t] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym_cstring] = ACTIONS(4634),
    [sym_dstring] = ACTIONS(4634),
    [sym_wstring] = ACTIONS(4634),
    [sym_noreturn] = ACTIONS(4634),
    [sym_true] = ACTIONS(4634),
    [sym_false] = ACTIONS(4634),
    [sym_null] = ACTIONS(4634),
    [sym_super] = ACTIONS(4634),
    [sym_this] = ACTIONS(4634),
    [sym_abstract] = ACTIONS(4634),
    [sym_alias] = ACTIONS(4634),
    [sym_align] = ACTIONS(4634),
    [sym_asm] = ACTIONS(4634),
    [sym_assert] = ACTIONS(4634),
    [sym_auto] = ACTIONS(4634),
    [sym_break] = ACTIONS(4634),
    [sym_case] = ACTIONS(4634),
    [sym_cast] = ACTIONS(4634),
    [sym_catch] = ACTIONS(4634),
    [sym_class] = ACTIONS(4634),
    [sym_const] = ACTIONS(4634),
    [sym_continue] = ACTIONS(4634),
    [sym_debug] = ACTIONS(4634),
    [sym_default] = ACTIONS(4634),
    [sym_delegate] = ACTIONS(4634),
    [sym_delete] = ACTIONS(4634),
    [sym_deprecated] = ACTIONS(4634),
    [sym_do] = ACTIONS(4634),
    [sym_else] = ACTIONS(4634),
    [sym_enum] = ACTIONS(4634),
    [sym_export] = ACTIONS(4634),
    [sym_extern] = ACTIONS(4634),
    [sym_final] = ACTIONS(4634),
    [sym_finally] = ACTIONS(4634),
    [sym_for] = ACTIONS(4634),
    [sym_foreach] = ACTIONS(4634),
    [sym_foreach_reverse] = ACTIONS(4634),
    [sym_function] = ACTIONS(4634),
    [sym_goto] = ACTIONS(4634),
    [sym_if] = ACTIONS(4634),
    [sym_immutable] = ACTIONS(4634),
    [sym_import] = ACTIONS(4634),
    [sym_in] = ACTIONS(4634),
    [sym_inout] = ACTIONS(4634),
    [sym_interface] = ACTIONS(4634),
    [sym_invariant] = ACTIONS(4634),
    [sym_is] = ACTIONS(4634),
    [sym_mixin] = ACTIONS(4634),
    [sym_new] = ACTIONS(4634),
    [sym_nothrow] = ACTIONS(4634),
    [sym_out] = ACTIONS(4634),
    [sym_override] = ACTIONS(4634),
    [sym_package] = ACTIONS(4634),
    [sym_pragma] = ACTIONS(4634),
    [sym_private] = ACTIONS(4634),
    [sym_protected] = ACTIONS(4634),
    [sym_public] = ACTIONS(4634),
    [sym_pure] = ACTIONS(4634),
    [sym_ref] = ACTIONS(4634),
    [sym_return] = ACTIONS(4634),
    [sym_scope] = ACTIONS(4634),
    [sym_shared] = ACTIONS(4634),
    [sym_static] = ACTIONS(4634),
    [sym_struct] = ACTIONS(4634),
    [sym_switch] = ACTIONS(4634),
    [sym_synchronized] = ACTIONS(4634),
    [sym_template] = ACTIONS(4634),
    [sym_throw] = ACTIONS(4634),
    [sym_try] = ACTIONS(4634),
    [sym_typeid] = ACTIONS(4634),
    [sym_typeof] = ACTIONS(4634),
    [sym_union] = ACTIONS(4634),
    [sym_unittest] = ACTIONS(4634),
    [sym_version] = ACTIONS(4634),
    [sym_while] = ACTIONS(4634),
    [sym_with] = ACTIONS(4634),
    [sym_gshared] = ACTIONS(4634),
    [sym_traits] = ACTIONS(4634),
    [sym_vector] = ACTIONS(4634),
    [sym_void] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4636),
    [anon_sym_r_DQUOTE] = ACTIONS(4636),
    [anon_sym_x_DQUOTE] = ACTIONS(4636),
    [anon_sym_DQUOTE] = ACTIONS(4636),
    [anon_sym_i_BQUOTE] = ACTIONS(4636),
    [anon_sym_i_DQUOTE] = ACTIONS(4636),
    [anon_sym_iq_LBRACE] = ACTIONS(4636),
    [aux_sym_char_literal_token1] = ACTIONS(4636),
    [anon_sym_SQUOTE] = ACTIONS(4634),
    [anon_sym___DATE__] = ACTIONS(4634),
    [anon_sym___FILE__] = ACTIONS(4634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4634),
    [anon_sym___FUNCTION__] = ACTIONS(4634),
    [anon_sym___LINE__] = ACTIONS(4634),
    [anon_sym___MODULE__] = ACTIONS(4634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4634),
    [anon_sym___TIME__] = ACTIONS(4634),
    [anon_sym___TIMESTAMP__] = ACTIONS(4634),
    [anon_sym___VENDOR__] = ACTIONS(4634),
    [anon_sym___VERSION__] = ACTIONS(4634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4636),
    [sym_float_literal] = ACTIONS(4636),
    [sym__string] = ACTIONS(4636),
  },
  [1416] = {
    [sym_identifier] = ACTIONS(4638),
    [anon_sym_q_LBRACE] = ACTIONS(4640),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4640),
    [anon_sym_AMP] = ACTIONS(4640),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_BANG] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_DOLLAR] = ACTIONS(4640),
    [anon_sym_STAR] = ACTIONS(4640),
    [anon_sym_TILDE] = ACTIONS(4640),
    [anon_sym_AT] = ACTIONS(4640),
    [sym_bool] = ACTIONS(4638),
    [sym_byte] = ACTIONS(4638),
    [sym_ubyte] = ACTIONS(4638),
    [sym_char] = ACTIONS(4638),
    [sym_short] = ACTIONS(4638),
    [sym_ushort] = ACTIONS(4638),
    [sym_int] = ACTIONS(4638),
    [sym_uint] = ACTIONS(4638),
    [sym_long] = ACTIONS(4638),
    [sym_ulong] = ACTIONS(4638),
    [sym_cent] = ACTIONS(4638),
    [sym_ucent] = ACTIONS(4638),
    [sym_wchar] = ACTIONS(4638),
    [sym_dchar] = ACTIONS(4638),
    [sym_float] = ACTIONS(4638),
    [sym_double] = ACTIONS(4638),
    [sym_real] = ACTIONS(4638),
    [sym_ifloat] = ACTIONS(4638),
    [sym_idouble] = ACTIONS(4638),
    [sym_ireal] = ACTIONS(4638),
    [sym_cfloat] = ACTIONS(4638),
    [sym_cdouble] = ACTIONS(4638),
    [sym_creal] = ACTIONS(4638),
    [sym_size_t] = ACTIONS(4638),
    [sym_ptrdiff_t] = ACTIONS(4638),
    [sym_string] = ACTIONS(4638),
    [sym_cstring] = ACTIONS(4638),
    [sym_dstring] = ACTIONS(4638),
    [sym_wstring] = ACTIONS(4638),
    [sym_noreturn] = ACTIONS(4638),
    [sym_true] = ACTIONS(4638),
    [sym_false] = ACTIONS(4638),
    [sym_null] = ACTIONS(4638),
    [sym_super] = ACTIONS(4638),
    [sym_this] = ACTIONS(4638),
    [sym_abstract] = ACTIONS(4638),
    [sym_alias] = ACTIONS(4638),
    [sym_align] = ACTIONS(4638),
    [sym_asm] = ACTIONS(4638),
    [sym_assert] = ACTIONS(4638),
    [sym_auto] = ACTIONS(4638),
    [sym_break] = ACTIONS(4638),
    [sym_case] = ACTIONS(4638),
    [sym_cast] = ACTIONS(4638),
    [sym_catch] = ACTIONS(4638),
    [sym_class] = ACTIONS(4638),
    [sym_const] = ACTIONS(4638),
    [sym_continue] = ACTIONS(4638),
    [sym_debug] = ACTIONS(4638),
    [sym_default] = ACTIONS(4638),
    [sym_delegate] = ACTIONS(4638),
    [sym_delete] = ACTIONS(4638),
    [sym_deprecated] = ACTIONS(4638),
    [sym_do] = ACTIONS(4638),
    [sym_else] = ACTIONS(4638),
    [sym_enum] = ACTIONS(4638),
    [sym_export] = ACTIONS(4638),
    [sym_extern] = ACTIONS(4638),
    [sym_final] = ACTIONS(4638),
    [sym_finally] = ACTIONS(4638),
    [sym_for] = ACTIONS(4638),
    [sym_foreach] = ACTIONS(4638),
    [sym_foreach_reverse] = ACTIONS(4638),
    [sym_function] = ACTIONS(4638),
    [sym_goto] = ACTIONS(4638),
    [sym_if] = ACTIONS(4638),
    [sym_immutable] = ACTIONS(4638),
    [sym_import] = ACTIONS(4638),
    [sym_in] = ACTIONS(4638),
    [sym_inout] = ACTIONS(4638),
    [sym_interface] = ACTIONS(4638),
    [sym_invariant] = ACTIONS(4638),
    [sym_is] = ACTIONS(4638),
    [sym_mixin] = ACTIONS(4638),
    [sym_new] = ACTIONS(4638),
    [sym_nothrow] = ACTIONS(4638),
    [sym_out] = ACTIONS(4638),
    [sym_override] = ACTIONS(4638),
    [sym_package] = ACTIONS(4638),
    [sym_pragma] = ACTIONS(4638),
    [sym_private] = ACTIONS(4638),
    [sym_protected] = ACTIONS(4638),
    [sym_public] = ACTIONS(4638),
    [sym_pure] = ACTIONS(4638),
    [sym_ref] = ACTIONS(4638),
    [sym_return] = ACTIONS(4638),
    [sym_scope] = ACTIONS(4638),
    [sym_shared] = ACTIONS(4638),
    [sym_static] = ACTIONS(4638),
    [sym_struct] = ACTIONS(4638),
    [sym_switch] = ACTIONS(4638),
    [sym_synchronized] = ACTIONS(4638),
    [sym_template] = ACTIONS(4638),
    [sym_throw] = ACTIONS(4638),
    [sym_try] = ACTIONS(4638),
    [sym_typeid] = ACTIONS(4638),
    [sym_typeof] = ACTIONS(4638),
    [sym_union] = ACTIONS(4638),
    [sym_unittest] = ACTIONS(4638),
    [sym_version] = ACTIONS(4638),
    [sym_while] = ACTIONS(4638),
    [sym_with] = ACTIONS(4638),
    [sym_gshared] = ACTIONS(4638),
    [sym_traits] = ACTIONS(4638),
    [sym_vector] = ACTIONS(4638),
    [sym_void] = ACTIONS(4638),
    [anon_sym_BQUOTE] = ACTIONS(4640),
    [anon_sym_r_DQUOTE] = ACTIONS(4640),
    [anon_sym_x_DQUOTE] = ACTIONS(4640),
    [anon_sym_DQUOTE] = ACTIONS(4640),
    [anon_sym_i_BQUOTE] = ACTIONS(4640),
    [anon_sym_i_DQUOTE] = ACTIONS(4640),
    [anon_sym_iq_LBRACE] = ACTIONS(4640),
    [aux_sym_char_literal_token1] = ACTIONS(4640),
    [anon_sym_SQUOTE] = ACTIONS(4638),
    [anon_sym___DATE__] = ACTIONS(4638),
    [anon_sym___FILE__] = ACTIONS(4638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4638),
    [anon_sym___FUNCTION__] = ACTIONS(4638),
    [anon_sym___LINE__] = ACTIONS(4638),
    [anon_sym___MODULE__] = ACTIONS(4638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4638),
    [anon_sym___TIME__] = ACTIONS(4638),
    [anon_sym___TIMESTAMP__] = ACTIONS(4638),
    [anon_sym___VENDOR__] = ACTIONS(4638),
    [anon_sym___VERSION__] = ACTIONS(4638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4640),
    [sym_float_literal] = ACTIONS(4640),
    [sym__string] = ACTIONS(4640),
  },
  [1417] = {
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_q_LBRACE] = ACTIONS(4644),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_LBRACE] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4644),
    [anon_sym_AMP] = ACTIONS(4644),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_BANG] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_RPAREN] = ACTIONS(4644),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_SEMI] = ACTIONS(4644),
    [anon_sym_DOLLAR] = ACTIONS(4644),
    [anon_sym_STAR] = ACTIONS(4644),
    [anon_sym_TILDE] = ACTIONS(4644),
    [anon_sym_AT] = ACTIONS(4644),
    [sym_bool] = ACTIONS(4642),
    [sym_byte] = ACTIONS(4642),
    [sym_ubyte] = ACTIONS(4642),
    [sym_char] = ACTIONS(4642),
    [sym_short] = ACTIONS(4642),
    [sym_ushort] = ACTIONS(4642),
    [sym_int] = ACTIONS(4642),
    [sym_uint] = ACTIONS(4642),
    [sym_long] = ACTIONS(4642),
    [sym_ulong] = ACTIONS(4642),
    [sym_cent] = ACTIONS(4642),
    [sym_ucent] = ACTIONS(4642),
    [sym_wchar] = ACTIONS(4642),
    [sym_dchar] = ACTIONS(4642),
    [sym_float] = ACTIONS(4642),
    [sym_double] = ACTIONS(4642),
    [sym_real] = ACTIONS(4642),
    [sym_ifloat] = ACTIONS(4642),
    [sym_idouble] = ACTIONS(4642),
    [sym_ireal] = ACTIONS(4642),
    [sym_cfloat] = ACTIONS(4642),
    [sym_cdouble] = ACTIONS(4642),
    [sym_creal] = ACTIONS(4642),
    [sym_size_t] = ACTIONS(4642),
    [sym_ptrdiff_t] = ACTIONS(4642),
    [sym_string] = ACTIONS(4642),
    [sym_cstring] = ACTIONS(4642),
    [sym_dstring] = ACTIONS(4642),
    [sym_wstring] = ACTIONS(4642),
    [sym_noreturn] = ACTIONS(4642),
    [sym_true] = ACTIONS(4642),
    [sym_false] = ACTIONS(4642),
    [sym_null] = ACTIONS(4642),
    [sym_super] = ACTIONS(4642),
    [sym_this] = ACTIONS(4642),
    [sym_abstract] = ACTIONS(4642),
    [sym_alias] = ACTIONS(4642),
    [sym_align] = ACTIONS(4642),
    [sym_asm] = ACTIONS(4642),
    [sym_assert] = ACTIONS(4642),
    [sym_auto] = ACTIONS(4642),
    [sym_break] = ACTIONS(4642),
    [sym_case] = ACTIONS(4642),
    [sym_cast] = ACTIONS(4642),
    [sym_catch] = ACTIONS(4642),
    [sym_class] = ACTIONS(4642),
    [sym_const] = ACTIONS(4642),
    [sym_continue] = ACTIONS(4642),
    [sym_debug] = ACTIONS(4642),
    [sym_default] = ACTIONS(4642),
    [sym_delegate] = ACTIONS(4642),
    [sym_delete] = ACTIONS(4642),
    [sym_deprecated] = ACTIONS(4642),
    [sym_do] = ACTIONS(4642),
    [sym_else] = ACTIONS(4642),
    [sym_enum] = ACTIONS(4642),
    [sym_export] = ACTIONS(4642),
    [sym_extern] = ACTIONS(4642),
    [sym_final] = ACTIONS(4642),
    [sym_finally] = ACTIONS(4642),
    [sym_for] = ACTIONS(4642),
    [sym_foreach] = ACTIONS(4642),
    [sym_foreach_reverse] = ACTIONS(4642),
    [sym_function] = ACTIONS(4642),
    [sym_goto] = ACTIONS(4642),
    [sym_if] = ACTIONS(4642),
    [sym_immutable] = ACTIONS(4642),
    [sym_import] = ACTIONS(4642),
    [sym_in] = ACTIONS(4642),
    [sym_inout] = ACTIONS(4642),
    [sym_interface] = ACTIONS(4642),
    [sym_invariant] = ACTIONS(4642),
    [sym_is] = ACTIONS(4642),
    [sym_mixin] = ACTIONS(4642),
    [sym_new] = ACTIONS(4642),
    [sym_nothrow] = ACTIONS(4642),
    [sym_out] = ACTIONS(4642),
    [sym_override] = ACTIONS(4642),
    [sym_package] = ACTIONS(4642),
    [sym_pragma] = ACTIONS(4642),
    [sym_private] = ACTIONS(4642),
    [sym_protected] = ACTIONS(4642),
    [sym_public] = ACTIONS(4642),
    [sym_pure] = ACTIONS(4642),
    [sym_ref] = ACTIONS(4642),
    [sym_return] = ACTIONS(4642),
    [sym_scope] = ACTIONS(4642),
    [sym_shared] = ACTIONS(4642),
    [sym_static] = ACTIONS(4642),
    [sym_struct] = ACTIONS(4642),
    [sym_switch] = ACTIONS(4642),
    [sym_synchronized] = ACTIONS(4642),
    [sym_template] = ACTIONS(4642),
    [sym_throw] = ACTIONS(4642),
    [sym_try] = ACTIONS(4642),
    [sym_typeid] = ACTIONS(4642),
    [sym_typeof] = ACTIONS(4642),
    [sym_union] = ACTIONS(4642),
    [sym_unittest] = ACTIONS(4642),
    [sym_version] = ACTIONS(4642),
    [sym_while] = ACTIONS(4642),
    [sym_with] = ACTIONS(4642),
    [sym_gshared] = ACTIONS(4642),
    [sym_traits] = ACTIONS(4642),
    [sym_vector] = ACTIONS(4642),
    [sym_void] = ACTIONS(4642),
    [anon_sym_BQUOTE] = ACTIONS(4644),
    [anon_sym_r_DQUOTE] = ACTIONS(4644),
    [anon_sym_x_DQUOTE] = ACTIONS(4644),
    [anon_sym_DQUOTE] = ACTIONS(4644),
    [anon_sym_i_BQUOTE] = ACTIONS(4644),
    [anon_sym_i_DQUOTE] = ACTIONS(4644),
    [anon_sym_iq_LBRACE] = ACTIONS(4644),
    [aux_sym_char_literal_token1] = ACTIONS(4644),
    [anon_sym_SQUOTE] = ACTIONS(4642),
    [anon_sym___DATE__] = ACTIONS(4642),
    [anon_sym___FILE__] = ACTIONS(4642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4642),
    [anon_sym___FUNCTION__] = ACTIONS(4642),
    [anon_sym___LINE__] = ACTIONS(4642),
    [anon_sym___MODULE__] = ACTIONS(4642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4642),
    [anon_sym___TIME__] = ACTIONS(4642),
    [anon_sym___TIMESTAMP__] = ACTIONS(4642),
    [anon_sym___VENDOR__] = ACTIONS(4642),
    [anon_sym___VERSION__] = ACTIONS(4642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4644),
    [sym_float_literal] = ACTIONS(4644),
    [sym__string] = ACTIONS(4644),
  },
  [1418] = {
    [sym_identifier] = ACTIONS(4646),
    [anon_sym_q_LBRACE] = ACTIONS(4649),
    [anon_sym_RBRACE] = ACTIONS(4649),
    [anon_sym_LBRACE] = ACTIONS(4649),
    [anon_sym_DOT] = ACTIONS(4649),
    [anon_sym_AMP] = ACTIONS(4649),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_DASH_DASH] = ACTIONS(4649),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4649),
    [anon_sym_BANG] = ACTIONS(4649),
    [anon_sym_LPAREN] = ACTIONS(4649),
    [anon_sym_RPAREN] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(4649),
    [anon_sym_DOLLAR] = ACTIONS(4649),
    [anon_sym_STAR] = ACTIONS(4649),
    [anon_sym_TILDE] = ACTIONS(4649),
    [anon_sym_AT] = ACTIONS(4649),
    [sym_bool] = ACTIONS(4646),
    [sym_byte] = ACTIONS(4646),
    [sym_ubyte] = ACTIONS(4646),
    [sym_char] = ACTIONS(4646),
    [sym_short] = ACTIONS(4646),
    [sym_ushort] = ACTIONS(4646),
    [sym_int] = ACTIONS(4646),
    [sym_uint] = ACTIONS(4646),
    [sym_long] = ACTIONS(4646),
    [sym_ulong] = ACTIONS(4646),
    [sym_cent] = ACTIONS(4646),
    [sym_ucent] = ACTIONS(4646),
    [sym_wchar] = ACTIONS(4646),
    [sym_dchar] = ACTIONS(4646),
    [sym_float] = ACTIONS(4646),
    [sym_double] = ACTIONS(4646),
    [sym_real] = ACTIONS(4646),
    [sym_ifloat] = ACTIONS(4646),
    [sym_idouble] = ACTIONS(4646),
    [sym_ireal] = ACTIONS(4646),
    [sym_cfloat] = ACTIONS(4646),
    [sym_cdouble] = ACTIONS(4646),
    [sym_creal] = ACTIONS(4646),
    [sym_size_t] = ACTIONS(4646),
    [sym_ptrdiff_t] = ACTIONS(4646),
    [sym_string] = ACTIONS(4646),
    [sym_cstring] = ACTIONS(4646),
    [sym_dstring] = ACTIONS(4646),
    [sym_wstring] = ACTIONS(4646),
    [sym_noreturn] = ACTIONS(4646),
    [sym_true] = ACTIONS(4646),
    [sym_false] = ACTIONS(4646),
    [sym_null] = ACTIONS(4646),
    [sym_super] = ACTIONS(4646),
    [sym_this] = ACTIONS(4646),
    [sym_abstract] = ACTIONS(4646),
    [sym_alias] = ACTIONS(4646),
    [sym_align] = ACTIONS(4646),
    [sym_asm] = ACTIONS(4646),
    [sym_assert] = ACTIONS(4646),
    [sym_auto] = ACTIONS(4646),
    [sym_break] = ACTIONS(4646),
    [sym_case] = ACTIONS(4646),
    [sym_cast] = ACTIONS(4646),
    [sym_catch] = ACTIONS(4646),
    [sym_class] = ACTIONS(4646),
    [sym_const] = ACTIONS(4646),
    [sym_continue] = ACTIONS(4646),
    [sym_debug] = ACTIONS(4646),
    [sym_default] = ACTIONS(4646),
    [sym_delegate] = ACTIONS(4646),
    [sym_delete] = ACTIONS(4646),
    [sym_deprecated] = ACTIONS(4646),
    [sym_do] = ACTIONS(4646),
    [sym_else] = ACTIONS(4646),
    [sym_enum] = ACTIONS(4646),
    [sym_export] = ACTIONS(4646),
    [sym_extern] = ACTIONS(4646),
    [sym_final] = ACTIONS(4646),
    [sym_finally] = ACTIONS(4646),
    [sym_for] = ACTIONS(4646),
    [sym_foreach] = ACTIONS(4646),
    [sym_foreach_reverse] = ACTIONS(4646),
    [sym_function] = ACTIONS(4646),
    [sym_goto] = ACTIONS(4646),
    [sym_if] = ACTIONS(4646),
    [sym_immutable] = ACTIONS(4646),
    [sym_import] = ACTIONS(4646),
    [sym_in] = ACTIONS(4646),
    [sym_inout] = ACTIONS(4646),
    [sym_interface] = ACTIONS(4646),
    [sym_invariant] = ACTIONS(4646),
    [sym_is] = ACTIONS(4646),
    [sym_mixin] = ACTIONS(4646),
    [sym_new] = ACTIONS(4646),
    [sym_nothrow] = ACTIONS(4646),
    [sym_out] = ACTIONS(4646),
    [sym_override] = ACTIONS(4646),
    [sym_package] = ACTIONS(4646),
    [sym_pragma] = ACTIONS(4646),
    [sym_private] = ACTIONS(4646),
    [sym_protected] = ACTIONS(4646),
    [sym_public] = ACTIONS(4646),
    [sym_pure] = ACTIONS(4646),
    [sym_ref] = ACTIONS(4646),
    [sym_return] = ACTIONS(4646),
    [sym_scope] = ACTIONS(4646),
    [sym_shared] = ACTIONS(4646),
    [sym_static] = ACTIONS(4646),
    [sym_struct] = ACTIONS(4646),
    [sym_switch] = ACTIONS(4646),
    [sym_synchronized] = ACTIONS(4646),
    [sym_template] = ACTIONS(4646),
    [sym_throw] = ACTIONS(4646),
    [sym_try] = ACTIONS(4646),
    [sym_typeid] = ACTIONS(4646),
    [sym_typeof] = ACTIONS(4646),
    [sym_union] = ACTIONS(4646),
    [sym_unittest] = ACTIONS(4646),
    [sym_version] = ACTIONS(4646),
    [sym_while] = ACTIONS(4646),
    [sym_with] = ACTIONS(4646),
    [sym_gshared] = ACTIONS(4646),
    [sym_traits] = ACTIONS(4646),
    [sym_vector] = ACTIONS(4646),
    [sym_void] = ACTIONS(4646),
    [anon_sym_BQUOTE] = ACTIONS(4649),
    [anon_sym_r_DQUOTE] = ACTIONS(4649),
    [anon_sym_x_DQUOTE] = ACTIONS(4649),
    [anon_sym_DQUOTE] = ACTIONS(4649),
    [anon_sym_i_BQUOTE] = ACTIONS(4649),
    [anon_sym_i_DQUOTE] = ACTIONS(4649),
    [anon_sym_iq_LBRACE] = ACTIONS(4649),
    [aux_sym_char_literal_token1] = ACTIONS(4649),
    [anon_sym_SQUOTE] = ACTIONS(4646),
    [anon_sym___DATE__] = ACTIONS(4646),
    [anon_sym___FILE__] = ACTIONS(4646),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4646),
    [anon_sym___FUNCTION__] = ACTIONS(4646),
    [anon_sym___LINE__] = ACTIONS(4646),
    [anon_sym___MODULE__] = ACTIONS(4646),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4646),
    [anon_sym___TIME__] = ACTIONS(4646),
    [anon_sym___TIMESTAMP__] = ACTIONS(4646),
    [anon_sym___VENDOR__] = ACTIONS(4646),
    [anon_sym___VERSION__] = ACTIONS(4646),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4649),
    [sym_float_literal] = ACTIONS(4649),
    [sym__string] = ACTIONS(4649),
  },
  [1419] = {
    [sym_identifier] = ACTIONS(4652),
    [anon_sym_q_LBRACE] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4654),
    [anon_sym_AMP] = ACTIONS(4654),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_DOLLAR] = ACTIONS(4654),
    [anon_sym_STAR] = ACTIONS(4654),
    [anon_sym_TILDE] = ACTIONS(4654),
    [anon_sym_AT] = ACTIONS(4654),
    [sym_bool] = ACTIONS(4652),
    [sym_byte] = ACTIONS(4652),
    [sym_ubyte] = ACTIONS(4652),
    [sym_char] = ACTIONS(4652),
    [sym_short] = ACTIONS(4652),
    [sym_ushort] = ACTIONS(4652),
    [sym_int] = ACTIONS(4652),
    [sym_uint] = ACTIONS(4652),
    [sym_long] = ACTIONS(4652),
    [sym_ulong] = ACTIONS(4652),
    [sym_cent] = ACTIONS(4652),
    [sym_ucent] = ACTIONS(4652),
    [sym_wchar] = ACTIONS(4652),
    [sym_dchar] = ACTIONS(4652),
    [sym_float] = ACTIONS(4652),
    [sym_double] = ACTIONS(4652),
    [sym_real] = ACTIONS(4652),
    [sym_ifloat] = ACTIONS(4652),
    [sym_idouble] = ACTIONS(4652),
    [sym_ireal] = ACTIONS(4652),
    [sym_cfloat] = ACTIONS(4652),
    [sym_cdouble] = ACTIONS(4652),
    [sym_creal] = ACTIONS(4652),
    [sym_size_t] = ACTIONS(4652),
    [sym_ptrdiff_t] = ACTIONS(4652),
    [sym_string] = ACTIONS(4652),
    [sym_cstring] = ACTIONS(4652),
    [sym_dstring] = ACTIONS(4652),
    [sym_wstring] = ACTIONS(4652),
    [sym_noreturn] = ACTIONS(4652),
    [sym_true] = ACTIONS(4652),
    [sym_false] = ACTIONS(4652),
    [sym_null] = ACTIONS(4652),
    [sym_super] = ACTIONS(4652),
    [sym_this] = ACTIONS(4652),
    [sym_abstract] = ACTIONS(4652),
    [sym_alias] = ACTIONS(4652),
    [sym_align] = ACTIONS(4652),
    [sym_asm] = ACTIONS(4652),
    [sym_assert] = ACTIONS(4652),
    [sym_auto] = ACTIONS(4652),
    [sym_break] = ACTIONS(4652),
    [sym_case] = ACTIONS(4652),
    [sym_cast] = ACTIONS(4652),
    [sym_catch] = ACTIONS(4652),
    [sym_class] = ACTIONS(4652),
    [sym_const] = ACTIONS(4652),
    [sym_continue] = ACTIONS(4652),
    [sym_debug] = ACTIONS(4652),
    [sym_default] = ACTIONS(4652),
    [sym_delegate] = ACTIONS(4652),
    [sym_delete] = ACTIONS(4652),
    [sym_deprecated] = ACTIONS(4652),
    [sym_do] = ACTIONS(4652),
    [sym_else] = ACTIONS(4652),
    [sym_enum] = ACTIONS(4652),
    [sym_export] = ACTIONS(4652),
    [sym_extern] = ACTIONS(4652),
    [sym_final] = ACTIONS(4652),
    [sym_finally] = ACTIONS(4652),
    [sym_for] = ACTIONS(4652),
    [sym_foreach] = ACTIONS(4652),
    [sym_foreach_reverse] = ACTIONS(4652),
    [sym_function] = ACTIONS(4652),
    [sym_goto] = ACTIONS(4652),
    [sym_if] = ACTIONS(4652),
    [sym_immutable] = ACTIONS(4652),
    [sym_import] = ACTIONS(4652),
    [sym_in] = ACTIONS(4652),
    [sym_inout] = ACTIONS(4652),
    [sym_interface] = ACTIONS(4652),
    [sym_invariant] = ACTIONS(4652),
    [sym_is] = ACTIONS(4652),
    [sym_mixin] = ACTIONS(4652),
    [sym_new] = ACTIONS(4652),
    [sym_nothrow] = ACTIONS(4652),
    [sym_out] = ACTIONS(4652),
    [sym_override] = ACTIONS(4652),
    [sym_package] = ACTIONS(4652),
    [sym_pragma] = ACTIONS(4652),
    [sym_private] = ACTIONS(4652),
    [sym_protected] = ACTIONS(4652),
    [sym_public] = ACTIONS(4652),
    [sym_pure] = ACTIONS(4652),
    [sym_ref] = ACTIONS(4652),
    [sym_return] = ACTIONS(4652),
    [sym_scope] = ACTIONS(4652),
    [sym_shared] = ACTIONS(4652),
    [sym_static] = ACTIONS(4652),
    [sym_struct] = ACTIONS(4652),
    [sym_switch] = ACTIONS(4652),
    [sym_synchronized] = ACTIONS(4652),
    [sym_template] = ACTIONS(4652),
    [sym_throw] = ACTIONS(4652),
    [sym_try] = ACTIONS(4652),
    [sym_typeid] = ACTIONS(4652),
    [sym_typeof] = ACTIONS(4652),
    [sym_union] = ACTIONS(4652),
    [sym_unittest] = ACTIONS(4652),
    [sym_version] = ACTIONS(4652),
    [sym_while] = ACTIONS(4652),
    [sym_with] = ACTIONS(4652),
    [sym_gshared] = ACTIONS(4652),
    [sym_traits] = ACTIONS(4652),
    [sym_vector] = ACTIONS(4652),
    [sym_void] = ACTIONS(4652),
    [anon_sym_BQUOTE] = ACTIONS(4654),
    [anon_sym_r_DQUOTE] = ACTIONS(4654),
    [anon_sym_x_DQUOTE] = ACTIONS(4654),
    [anon_sym_DQUOTE] = ACTIONS(4654),
    [anon_sym_i_BQUOTE] = ACTIONS(4654),
    [anon_sym_i_DQUOTE] = ACTIONS(4654),
    [anon_sym_iq_LBRACE] = ACTIONS(4654),
    [aux_sym_char_literal_token1] = ACTIONS(4654),
    [anon_sym_SQUOTE] = ACTIONS(4652),
    [anon_sym___DATE__] = ACTIONS(4652),
    [anon_sym___FILE__] = ACTIONS(4652),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4652),
    [anon_sym___FUNCTION__] = ACTIONS(4652),
    [anon_sym___LINE__] = ACTIONS(4652),
    [anon_sym___MODULE__] = ACTIONS(4652),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4652),
    [anon_sym___TIME__] = ACTIONS(4652),
    [anon_sym___TIMESTAMP__] = ACTIONS(4652),
    [anon_sym___VENDOR__] = ACTIONS(4652),
    [anon_sym___VERSION__] = ACTIONS(4652),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4654),
    [sym_float_literal] = ACTIONS(4654),
    [sym__string] = ACTIONS(4654),
  },
  [1420] = {
    [sym_identifier] = ACTIONS(4656),
    [anon_sym_q_LBRACE] = ACTIONS(4658),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [anon_sym_LBRACE] = ACTIONS(4658),
    [anon_sym_DOT] = ACTIONS(4658),
    [anon_sym_AMP] = ACTIONS(4658),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_DASH_DASH] = ACTIONS(4658),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(4658),
    [anon_sym_RPAREN] = ACTIONS(4658),
    [anon_sym_LBRACK] = ACTIONS(4658),
    [anon_sym_SEMI] = ACTIONS(4658),
    [anon_sym_DOLLAR] = ACTIONS(4658),
    [anon_sym_STAR] = ACTIONS(4658),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_AT] = ACTIONS(4658),
    [sym_bool] = ACTIONS(4656),
    [sym_byte] = ACTIONS(4656),
    [sym_ubyte] = ACTIONS(4656),
    [sym_char] = ACTIONS(4656),
    [sym_short] = ACTIONS(4656),
    [sym_ushort] = ACTIONS(4656),
    [sym_int] = ACTIONS(4656),
    [sym_uint] = ACTIONS(4656),
    [sym_long] = ACTIONS(4656),
    [sym_ulong] = ACTIONS(4656),
    [sym_cent] = ACTIONS(4656),
    [sym_ucent] = ACTIONS(4656),
    [sym_wchar] = ACTIONS(4656),
    [sym_dchar] = ACTIONS(4656),
    [sym_float] = ACTIONS(4656),
    [sym_double] = ACTIONS(4656),
    [sym_real] = ACTIONS(4656),
    [sym_ifloat] = ACTIONS(4656),
    [sym_idouble] = ACTIONS(4656),
    [sym_ireal] = ACTIONS(4656),
    [sym_cfloat] = ACTIONS(4656),
    [sym_cdouble] = ACTIONS(4656),
    [sym_creal] = ACTIONS(4656),
    [sym_size_t] = ACTIONS(4656),
    [sym_ptrdiff_t] = ACTIONS(4656),
    [sym_string] = ACTIONS(4656),
    [sym_cstring] = ACTIONS(4656),
    [sym_dstring] = ACTIONS(4656),
    [sym_wstring] = ACTIONS(4656),
    [sym_noreturn] = ACTIONS(4656),
    [sym_true] = ACTIONS(4656),
    [sym_false] = ACTIONS(4656),
    [sym_null] = ACTIONS(4656),
    [sym_super] = ACTIONS(4656),
    [sym_this] = ACTIONS(4656),
    [sym_abstract] = ACTIONS(4656),
    [sym_alias] = ACTIONS(4656),
    [sym_align] = ACTIONS(4656),
    [sym_asm] = ACTIONS(4656),
    [sym_assert] = ACTIONS(4656),
    [sym_auto] = ACTIONS(4656),
    [sym_break] = ACTIONS(4656),
    [sym_case] = ACTIONS(4656),
    [sym_cast] = ACTIONS(4656),
    [sym_catch] = ACTIONS(4656),
    [sym_class] = ACTIONS(4656),
    [sym_const] = ACTIONS(4656),
    [sym_continue] = ACTIONS(4656),
    [sym_debug] = ACTIONS(4656),
    [sym_default] = ACTIONS(4656),
    [sym_delegate] = ACTIONS(4656),
    [sym_delete] = ACTIONS(4656),
    [sym_deprecated] = ACTIONS(4656),
    [sym_do] = ACTIONS(4656),
    [sym_else] = ACTIONS(4656),
    [sym_enum] = ACTIONS(4656),
    [sym_export] = ACTIONS(4656),
    [sym_extern] = ACTIONS(4656),
    [sym_final] = ACTIONS(4656),
    [sym_finally] = ACTIONS(4656),
    [sym_for] = ACTIONS(4656),
    [sym_foreach] = ACTIONS(4656),
    [sym_foreach_reverse] = ACTIONS(4656),
    [sym_function] = ACTIONS(4656),
    [sym_goto] = ACTIONS(4656),
    [sym_if] = ACTIONS(4656),
    [sym_immutable] = ACTIONS(4656),
    [sym_import] = ACTIONS(4656),
    [sym_in] = ACTIONS(4656),
    [sym_inout] = ACTIONS(4656),
    [sym_interface] = ACTIONS(4656),
    [sym_invariant] = ACTIONS(4656),
    [sym_is] = ACTIONS(4656),
    [sym_mixin] = ACTIONS(4656),
    [sym_new] = ACTIONS(4656),
    [sym_nothrow] = ACTIONS(4656),
    [sym_out] = ACTIONS(4656),
    [sym_override] = ACTIONS(4656),
    [sym_package] = ACTIONS(4656),
    [sym_pragma] = ACTIONS(4656),
    [sym_private] = ACTIONS(4656),
    [sym_protected] = ACTIONS(4656),
    [sym_public] = ACTIONS(4656),
    [sym_pure] = ACTIONS(4656),
    [sym_ref] = ACTIONS(4656),
    [sym_return] = ACTIONS(4656),
    [sym_scope] = ACTIONS(4656),
    [sym_shared] = ACTIONS(4656),
    [sym_static] = ACTIONS(4656),
    [sym_struct] = ACTIONS(4656),
    [sym_switch] = ACTIONS(4656),
    [sym_synchronized] = ACTIONS(4656),
    [sym_template] = ACTIONS(4656),
    [sym_throw] = ACTIONS(4656),
    [sym_try] = ACTIONS(4656),
    [sym_typeid] = ACTIONS(4656),
    [sym_typeof] = ACTIONS(4656),
    [sym_union] = ACTIONS(4656),
    [sym_unittest] = ACTIONS(4656),
    [sym_version] = ACTIONS(4656),
    [sym_while] = ACTIONS(4656),
    [sym_with] = ACTIONS(4656),
    [sym_gshared] = ACTIONS(4656),
    [sym_traits] = ACTIONS(4656),
    [sym_vector] = ACTIONS(4656),
    [sym_void] = ACTIONS(4656),
    [anon_sym_BQUOTE] = ACTIONS(4658),
    [anon_sym_r_DQUOTE] = ACTIONS(4658),
    [anon_sym_x_DQUOTE] = ACTIONS(4658),
    [anon_sym_DQUOTE] = ACTIONS(4658),
    [anon_sym_i_BQUOTE] = ACTIONS(4658),
    [anon_sym_i_DQUOTE] = ACTIONS(4658),
    [anon_sym_iq_LBRACE] = ACTIONS(4658),
    [aux_sym_char_literal_token1] = ACTIONS(4658),
    [anon_sym_SQUOTE] = ACTIONS(4656),
    [anon_sym___DATE__] = ACTIONS(4656),
    [anon_sym___FILE__] = ACTIONS(4656),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4656),
    [anon_sym___FUNCTION__] = ACTIONS(4656),
    [anon_sym___LINE__] = ACTIONS(4656),
    [anon_sym___MODULE__] = ACTIONS(4656),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4656),
    [anon_sym___TIME__] = ACTIONS(4656),
    [anon_sym___TIMESTAMP__] = ACTIONS(4656),
    [anon_sym___VENDOR__] = ACTIONS(4656),
    [anon_sym___VERSION__] = ACTIONS(4656),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4658),
    [sym_float_literal] = ACTIONS(4658),
    [sym__string] = ACTIONS(4658),
  },
  [1421] = {
    [sym_identifier] = ACTIONS(4660),
    [anon_sym_q_LBRACE] = ACTIONS(4662),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [anon_sym_LBRACE] = ACTIONS(4662),
    [anon_sym_DOT] = ACTIONS(4662),
    [anon_sym_AMP] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4660),
    [anon_sym_DASH_DASH] = ACTIONS(4662),
    [anon_sym_PLUS] = ACTIONS(4660),
    [anon_sym_PLUS_PLUS] = ACTIONS(4662),
    [anon_sym_BANG] = ACTIONS(4662),
    [anon_sym_LPAREN] = ACTIONS(4662),
    [anon_sym_RPAREN] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(4662),
    [anon_sym_SEMI] = ACTIONS(4662),
    [anon_sym_DOLLAR] = ACTIONS(4662),
    [anon_sym_STAR] = ACTIONS(4662),
    [anon_sym_TILDE] = ACTIONS(4662),
    [anon_sym_AT] = ACTIONS(4662),
    [sym_bool] = ACTIONS(4660),
    [sym_byte] = ACTIONS(4660),
    [sym_ubyte] = ACTIONS(4660),
    [sym_char] = ACTIONS(4660),
    [sym_short] = ACTIONS(4660),
    [sym_ushort] = ACTIONS(4660),
    [sym_int] = ACTIONS(4660),
    [sym_uint] = ACTIONS(4660),
    [sym_long] = ACTIONS(4660),
    [sym_ulong] = ACTIONS(4660),
    [sym_cent] = ACTIONS(4660),
    [sym_ucent] = ACTIONS(4660),
    [sym_wchar] = ACTIONS(4660),
    [sym_dchar] = ACTIONS(4660),
    [sym_float] = ACTIONS(4660),
    [sym_double] = ACTIONS(4660),
    [sym_real] = ACTIONS(4660),
    [sym_ifloat] = ACTIONS(4660),
    [sym_idouble] = ACTIONS(4660),
    [sym_ireal] = ACTIONS(4660),
    [sym_cfloat] = ACTIONS(4660),
    [sym_cdouble] = ACTIONS(4660),
    [sym_creal] = ACTIONS(4660),
    [sym_size_t] = ACTIONS(4660),
    [sym_ptrdiff_t] = ACTIONS(4660),
    [sym_string] = ACTIONS(4660),
    [sym_cstring] = ACTIONS(4660),
    [sym_dstring] = ACTIONS(4660),
    [sym_wstring] = ACTIONS(4660),
    [sym_noreturn] = ACTIONS(4660),
    [sym_true] = ACTIONS(4660),
    [sym_false] = ACTIONS(4660),
    [sym_null] = ACTIONS(4660),
    [sym_super] = ACTIONS(4660),
    [sym_this] = ACTIONS(4660),
    [sym_abstract] = ACTIONS(4660),
    [sym_alias] = ACTIONS(4660),
    [sym_align] = ACTIONS(4660),
    [sym_asm] = ACTIONS(4660),
    [sym_assert] = ACTIONS(4660),
    [sym_auto] = ACTIONS(4660),
    [sym_break] = ACTIONS(4660),
    [sym_case] = ACTIONS(4660),
    [sym_cast] = ACTIONS(4660),
    [sym_catch] = ACTIONS(4660),
    [sym_class] = ACTIONS(4660),
    [sym_const] = ACTIONS(4660),
    [sym_continue] = ACTIONS(4660),
    [sym_debug] = ACTIONS(4660),
    [sym_default] = ACTIONS(4660),
    [sym_delegate] = ACTIONS(4660),
    [sym_delete] = ACTIONS(4660),
    [sym_deprecated] = ACTIONS(4660),
    [sym_do] = ACTIONS(4660),
    [sym_else] = ACTIONS(4660),
    [sym_enum] = ACTIONS(4660),
    [sym_export] = ACTIONS(4660),
    [sym_extern] = ACTIONS(4660),
    [sym_final] = ACTIONS(4660),
    [sym_finally] = ACTIONS(4660),
    [sym_for] = ACTIONS(4660),
    [sym_foreach] = ACTIONS(4660),
    [sym_foreach_reverse] = ACTIONS(4660),
    [sym_function] = ACTIONS(4660),
    [sym_goto] = ACTIONS(4660),
    [sym_if] = ACTIONS(4660),
    [sym_immutable] = ACTIONS(4660),
    [sym_import] = ACTIONS(4660),
    [sym_in] = ACTIONS(4660),
    [sym_inout] = ACTIONS(4660),
    [sym_interface] = ACTIONS(4660),
    [sym_invariant] = ACTIONS(4660),
    [sym_is] = ACTIONS(4660),
    [sym_mixin] = ACTIONS(4660),
    [sym_new] = ACTIONS(4660),
    [sym_nothrow] = ACTIONS(4660),
    [sym_out] = ACTIONS(4660),
    [sym_override] = ACTIONS(4660),
    [sym_package] = ACTIONS(4660),
    [sym_pragma] = ACTIONS(4660),
    [sym_private] = ACTIONS(4660),
    [sym_protected] = ACTIONS(4660),
    [sym_public] = ACTIONS(4660),
    [sym_pure] = ACTIONS(4660),
    [sym_ref] = ACTIONS(4660),
    [sym_return] = ACTIONS(4660),
    [sym_scope] = ACTIONS(4660),
    [sym_shared] = ACTIONS(4660),
    [sym_static] = ACTIONS(4660),
    [sym_struct] = ACTIONS(4660),
    [sym_switch] = ACTIONS(4660),
    [sym_synchronized] = ACTIONS(4660),
    [sym_template] = ACTIONS(4660),
    [sym_throw] = ACTIONS(4660),
    [sym_try] = ACTIONS(4660),
    [sym_typeid] = ACTIONS(4660),
    [sym_typeof] = ACTIONS(4660),
    [sym_union] = ACTIONS(4660),
    [sym_unittest] = ACTIONS(4660),
    [sym_version] = ACTIONS(4660),
    [sym_while] = ACTIONS(4660),
    [sym_with] = ACTIONS(4660),
    [sym_gshared] = ACTIONS(4660),
    [sym_traits] = ACTIONS(4660),
    [sym_vector] = ACTIONS(4660),
    [sym_void] = ACTIONS(4660),
    [anon_sym_BQUOTE] = ACTIONS(4662),
    [anon_sym_r_DQUOTE] = ACTIONS(4662),
    [anon_sym_x_DQUOTE] = ACTIONS(4662),
    [anon_sym_DQUOTE] = ACTIONS(4662),
    [anon_sym_i_BQUOTE] = ACTIONS(4662),
    [anon_sym_i_DQUOTE] = ACTIONS(4662),
    [anon_sym_iq_LBRACE] = ACTIONS(4662),
    [aux_sym_char_literal_token1] = ACTIONS(4662),
    [anon_sym_SQUOTE] = ACTIONS(4660),
    [anon_sym___DATE__] = ACTIONS(4660),
    [anon_sym___FILE__] = ACTIONS(4660),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4660),
    [anon_sym___FUNCTION__] = ACTIONS(4660),
    [anon_sym___LINE__] = ACTIONS(4660),
    [anon_sym___MODULE__] = ACTIONS(4660),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4660),
    [anon_sym___TIME__] = ACTIONS(4660),
    [anon_sym___TIMESTAMP__] = ACTIONS(4660),
    [anon_sym___VENDOR__] = ACTIONS(4660),
    [anon_sym___VERSION__] = ACTIONS(4660),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4662),
    [sym_float_literal] = ACTIONS(4662),
    [sym__string] = ACTIONS(4662),
  },
  [1422] = {
    [sym_identifier] = ACTIONS(4664),
    [anon_sym_q_LBRACE] = ACTIONS(4666),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_LBRACE] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4666),
    [anon_sym_AMP] = ACTIONS(4666),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_BANG] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_RPAREN] = ACTIONS(4666),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_DOLLAR] = ACTIONS(4666),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_TILDE] = ACTIONS(4666),
    [anon_sym_AT] = ACTIONS(4666),
    [sym_bool] = ACTIONS(4664),
    [sym_byte] = ACTIONS(4664),
    [sym_ubyte] = ACTIONS(4664),
    [sym_char] = ACTIONS(4664),
    [sym_short] = ACTIONS(4664),
    [sym_ushort] = ACTIONS(4664),
    [sym_int] = ACTIONS(4664),
    [sym_uint] = ACTIONS(4664),
    [sym_long] = ACTIONS(4664),
    [sym_ulong] = ACTIONS(4664),
    [sym_cent] = ACTIONS(4664),
    [sym_ucent] = ACTIONS(4664),
    [sym_wchar] = ACTIONS(4664),
    [sym_dchar] = ACTIONS(4664),
    [sym_float] = ACTIONS(4664),
    [sym_double] = ACTIONS(4664),
    [sym_real] = ACTIONS(4664),
    [sym_ifloat] = ACTIONS(4664),
    [sym_idouble] = ACTIONS(4664),
    [sym_ireal] = ACTIONS(4664),
    [sym_cfloat] = ACTIONS(4664),
    [sym_cdouble] = ACTIONS(4664),
    [sym_creal] = ACTIONS(4664),
    [sym_size_t] = ACTIONS(4664),
    [sym_ptrdiff_t] = ACTIONS(4664),
    [sym_string] = ACTIONS(4664),
    [sym_cstring] = ACTIONS(4664),
    [sym_dstring] = ACTIONS(4664),
    [sym_wstring] = ACTIONS(4664),
    [sym_noreturn] = ACTIONS(4664),
    [sym_true] = ACTIONS(4664),
    [sym_false] = ACTIONS(4664),
    [sym_null] = ACTIONS(4664),
    [sym_super] = ACTIONS(4664),
    [sym_this] = ACTIONS(4664),
    [sym_abstract] = ACTIONS(4664),
    [sym_alias] = ACTIONS(4664),
    [sym_align] = ACTIONS(4664),
    [sym_asm] = ACTIONS(4664),
    [sym_assert] = ACTIONS(4664),
    [sym_auto] = ACTIONS(4664),
    [sym_break] = ACTIONS(4664),
    [sym_case] = ACTIONS(4664),
    [sym_cast] = ACTIONS(4664),
    [sym_catch] = ACTIONS(4664),
    [sym_class] = ACTIONS(4664),
    [sym_const] = ACTIONS(4664),
    [sym_continue] = ACTIONS(4664),
    [sym_debug] = ACTIONS(4664),
    [sym_default] = ACTIONS(4664),
    [sym_delegate] = ACTIONS(4664),
    [sym_delete] = ACTIONS(4664),
    [sym_deprecated] = ACTIONS(4664),
    [sym_do] = ACTIONS(4664),
    [sym_else] = ACTIONS(4664),
    [sym_enum] = ACTIONS(4664),
    [sym_export] = ACTIONS(4664),
    [sym_extern] = ACTIONS(4664),
    [sym_final] = ACTIONS(4664),
    [sym_finally] = ACTIONS(4664),
    [sym_for] = ACTIONS(4664),
    [sym_foreach] = ACTIONS(4664),
    [sym_foreach_reverse] = ACTIONS(4664),
    [sym_function] = ACTIONS(4664),
    [sym_goto] = ACTIONS(4664),
    [sym_if] = ACTIONS(4664),
    [sym_immutable] = ACTIONS(4664),
    [sym_import] = ACTIONS(4664),
    [sym_in] = ACTIONS(4664),
    [sym_inout] = ACTIONS(4664),
    [sym_interface] = ACTIONS(4664),
    [sym_invariant] = ACTIONS(4664),
    [sym_is] = ACTIONS(4664),
    [sym_mixin] = ACTIONS(4664),
    [sym_new] = ACTIONS(4664),
    [sym_nothrow] = ACTIONS(4664),
    [sym_out] = ACTIONS(4664),
    [sym_override] = ACTIONS(4664),
    [sym_package] = ACTIONS(4664),
    [sym_pragma] = ACTIONS(4664),
    [sym_private] = ACTIONS(4664),
    [sym_protected] = ACTIONS(4664),
    [sym_public] = ACTIONS(4664),
    [sym_pure] = ACTIONS(4664),
    [sym_ref] = ACTIONS(4664),
    [sym_return] = ACTIONS(4664),
    [sym_scope] = ACTIONS(4664),
    [sym_shared] = ACTIONS(4664),
    [sym_static] = ACTIONS(4664),
    [sym_struct] = ACTIONS(4664),
    [sym_switch] = ACTIONS(4664),
    [sym_synchronized] = ACTIONS(4664),
    [sym_template] = ACTIONS(4664),
    [sym_throw] = ACTIONS(4664),
    [sym_try] = ACTIONS(4664),
    [sym_typeid] = ACTIONS(4664),
    [sym_typeof] = ACTIONS(4664),
    [sym_union] = ACTIONS(4664),
    [sym_unittest] = ACTIONS(4664),
    [sym_version] = ACTIONS(4664),
    [sym_while] = ACTIONS(4664),
    [sym_with] = ACTIONS(4664),
    [sym_gshared] = ACTIONS(4664),
    [sym_traits] = ACTIONS(4664),
    [sym_vector] = ACTIONS(4664),
    [sym_void] = ACTIONS(4664),
    [anon_sym_BQUOTE] = ACTIONS(4666),
    [anon_sym_r_DQUOTE] = ACTIONS(4666),
    [anon_sym_x_DQUOTE] = ACTIONS(4666),
    [anon_sym_DQUOTE] = ACTIONS(4666),
    [anon_sym_i_BQUOTE] = ACTIONS(4666),
    [anon_sym_i_DQUOTE] = ACTIONS(4666),
    [anon_sym_iq_LBRACE] = ACTIONS(4666),
    [aux_sym_char_literal_token1] = ACTIONS(4666),
    [anon_sym_SQUOTE] = ACTIONS(4664),
    [anon_sym___DATE__] = ACTIONS(4664),
    [anon_sym___FILE__] = ACTIONS(4664),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4664),
    [anon_sym___FUNCTION__] = ACTIONS(4664),
    [anon_sym___LINE__] = ACTIONS(4664),
    [anon_sym___MODULE__] = ACTIONS(4664),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4664),
    [anon_sym___TIME__] = ACTIONS(4664),
    [anon_sym___TIMESTAMP__] = ACTIONS(4664),
    [anon_sym___VENDOR__] = ACTIONS(4664),
    [anon_sym___VERSION__] = ACTIONS(4664),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4666),
    [sym_float_literal] = ACTIONS(4666),
    [sym__string] = ACTIONS(4666),
  },
  [1423] = {
    [sym_identifier] = ACTIONS(4668),
    [anon_sym_q_LBRACE] = ACTIONS(4670),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_LBRACE] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_AMP] = ACTIONS(4670),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_DOLLAR] = ACTIONS(4670),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(4670),
    [anon_sym_AT] = ACTIONS(4670),
    [sym_bool] = ACTIONS(4668),
    [sym_byte] = ACTIONS(4668),
    [sym_ubyte] = ACTIONS(4668),
    [sym_char] = ACTIONS(4668),
    [sym_short] = ACTIONS(4668),
    [sym_ushort] = ACTIONS(4668),
    [sym_int] = ACTIONS(4668),
    [sym_uint] = ACTIONS(4668),
    [sym_long] = ACTIONS(4668),
    [sym_ulong] = ACTIONS(4668),
    [sym_cent] = ACTIONS(4668),
    [sym_ucent] = ACTIONS(4668),
    [sym_wchar] = ACTIONS(4668),
    [sym_dchar] = ACTIONS(4668),
    [sym_float] = ACTIONS(4668),
    [sym_double] = ACTIONS(4668),
    [sym_real] = ACTIONS(4668),
    [sym_ifloat] = ACTIONS(4668),
    [sym_idouble] = ACTIONS(4668),
    [sym_ireal] = ACTIONS(4668),
    [sym_cfloat] = ACTIONS(4668),
    [sym_cdouble] = ACTIONS(4668),
    [sym_creal] = ACTIONS(4668),
    [sym_size_t] = ACTIONS(4668),
    [sym_ptrdiff_t] = ACTIONS(4668),
    [sym_string] = ACTIONS(4668),
    [sym_cstring] = ACTIONS(4668),
    [sym_dstring] = ACTIONS(4668),
    [sym_wstring] = ACTIONS(4668),
    [sym_noreturn] = ACTIONS(4668),
    [sym_true] = ACTIONS(4668),
    [sym_false] = ACTIONS(4668),
    [sym_null] = ACTIONS(4668),
    [sym_super] = ACTIONS(4668),
    [sym_this] = ACTIONS(4668),
    [sym_abstract] = ACTIONS(4668),
    [sym_alias] = ACTIONS(4668),
    [sym_align] = ACTIONS(4668),
    [sym_asm] = ACTIONS(4668),
    [sym_assert] = ACTIONS(4668),
    [sym_auto] = ACTIONS(4668),
    [sym_break] = ACTIONS(4668),
    [sym_case] = ACTIONS(4668),
    [sym_cast] = ACTIONS(4668),
    [sym_catch] = ACTIONS(4668),
    [sym_class] = ACTIONS(4668),
    [sym_const] = ACTIONS(4668),
    [sym_continue] = ACTIONS(4668),
    [sym_debug] = ACTIONS(4668),
    [sym_default] = ACTIONS(4668),
    [sym_delegate] = ACTIONS(4668),
    [sym_delete] = ACTIONS(4668),
    [sym_deprecated] = ACTIONS(4668),
    [sym_do] = ACTIONS(4668),
    [sym_else] = ACTIONS(4668),
    [sym_enum] = ACTIONS(4668),
    [sym_export] = ACTIONS(4668),
    [sym_extern] = ACTIONS(4668),
    [sym_final] = ACTIONS(4668),
    [sym_finally] = ACTIONS(4668),
    [sym_for] = ACTIONS(4668),
    [sym_foreach] = ACTIONS(4668),
    [sym_foreach_reverse] = ACTIONS(4668),
    [sym_function] = ACTIONS(4668),
    [sym_goto] = ACTIONS(4668),
    [sym_if] = ACTIONS(4668),
    [sym_immutable] = ACTIONS(4668),
    [sym_import] = ACTIONS(4668),
    [sym_in] = ACTIONS(4668),
    [sym_inout] = ACTIONS(4668),
    [sym_interface] = ACTIONS(4668),
    [sym_invariant] = ACTIONS(4668),
    [sym_is] = ACTIONS(4668),
    [sym_mixin] = ACTIONS(4668),
    [sym_new] = ACTIONS(4668),
    [sym_nothrow] = ACTIONS(4668),
    [sym_out] = ACTIONS(4668),
    [sym_override] = ACTIONS(4668),
    [sym_package] = ACTIONS(4668),
    [sym_pragma] = ACTIONS(4668),
    [sym_private] = ACTIONS(4668),
    [sym_protected] = ACTIONS(4668),
    [sym_public] = ACTIONS(4668),
    [sym_pure] = ACTIONS(4668),
    [sym_ref] = ACTIONS(4668),
    [sym_return] = ACTIONS(4668),
    [sym_scope] = ACTIONS(4668),
    [sym_shared] = ACTIONS(4668),
    [sym_static] = ACTIONS(4668),
    [sym_struct] = ACTIONS(4668),
    [sym_switch] = ACTIONS(4668),
    [sym_synchronized] = ACTIONS(4668),
    [sym_template] = ACTIONS(4668),
    [sym_throw] = ACTIONS(4668),
    [sym_try] = ACTIONS(4668),
    [sym_typeid] = ACTIONS(4668),
    [sym_typeof] = ACTIONS(4668),
    [sym_union] = ACTIONS(4668),
    [sym_unittest] = ACTIONS(4668),
    [sym_version] = ACTIONS(4668),
    [sym_while] = ACTIONS(4668),
    [sym_with] = ACTIONS(4668),
    [sym_gshared] = ACTIONS(4668),
    [sym_traits] = ACTIONS(4668),
    [sym_vector] = ACTIONS(4668),
    [sym_void] = ACTIONS(4668),
    [anon_sym_BQUOTE] = ACTIONS(4670),
    [anon_sym_r_DQUOTE] = ACTIONS(4670),
    [anon_sym_x_DQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4670),
    [anon_sym_i_BQUOTE] = ACTIONS(4670),
    [anon_sym_i_DQUOTE] = ACTIONS(4670),
    [anon_sym_iq_LBRACE] = ACTIONS(4670),
    [aux_sym_char_literal_token1] = ACTIONS(4670),
    [anon_sym_SQUOTE] = ACTIONS(4668),
    [anon_sym___DATE__] = ACTIONS(4668),
    [anon_sym___FILE__] = ACTIONS(4668),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4668),
    [anon_sym___FUNCTION__] = ACTIONS(4668),
    [anon_sym___LINE__] = ACTIONS(4668),
    [anon_sym___MODULE__] = ACTIONS(4668),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4668),
    [anon_sym___TIME__] = ACTIONS(4668),
    [anon_sym___TIMESTAMP__] = ACTIONS(4668),
    [anon_sym___VENDOR__] = ACTIONS(4668),
    [anon_sym___VERSION__] = ACTIONS(4668),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4670),
    [sym_float_literal] = ACTIONS(4670),
    [sym__string] = ACTIONS(4670),
  },
  [1424] = {
    [sym_identifier] = ACTIONS(4672),
    [anon_sym_q_LBRACE] = ACTIONS(4675),
    [anon_sym_RBRACE] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(4675),
    [anon_sym_DOT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(4675),
    [anon_sym_DASH] = ACTIONS(4672),
    [anon_sym_DASH_DASH] = ACTIONS(4675),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_PLUS_PLUS] = ACTIONS(4675),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym_RPAREN] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(4675),
    [anon_sym_SEMI] = ACTIONS(4675),
    [anon_sym_DOLLAR] = ACTIONS(4675),
    [anon_sym_STAR] = ACTIONS(4675),
    [anon_sym_TILDE] = ACTIONS(4675),
    [anon_sym_AT] = ACTIONS(4675),
    [sym_bool] = ACTIONS(4672),
    [sym_byte] = ACTIONS(4672),
    [sym_ubyte] = ACTIONS(4672),
    [sym_char] = ACTIONS(4672),
    [sym_short] = ACTIONS(4672),
    [sym_ushort] = ACTIONS(4672),
    [sym_int] = ACTIONS(4672),
    [sym_uint] = ACTIONS(4672),
    [sym_long] = ACTIONS(4672),
    [sym_ulong] = ACTIONS(4672),
    [sym_cent] = ACTIONS(4672),
    [sym_ucent] = ACTIONS(4672),
    [sym_wchar] = ACTIONS(4672),
    [sym_dchar] = ACTIONS(4672),
    [sym_float] = ACTIONS(4672),
    [sym_double] = ACTIONS(4672),
    [sym_real] = ACTIONS(4672),
    [sym_ifloat] = ACTIONS(4672),
    [sym_idouble] = ACTIONS(4672),
    [sym_ireal] = ACTIONS(4672),
    [sym_cfloat] = ACTIONS(4672),
    [sym_cdouble] = ACTIONS(4672),
    [sym_creal] = ACTIONS(4672),
    [sym_size_t] = ACTIONS(4672),
    [sym_ptrdiff_t] = ACTIONS(4672),
    [sym_string] = ACTIONS(4672),
    [sym_cstring] = ACTIONS(4672),
    [sym_dstring] = ACTIONS(4672),
    [sym_wstring] = ACTIONS(4672),
    [sym_noreturn] = ACTIONS(4672),
    [sym_true] = ACTIONS(4672),
    [sym_false] = ACTIONS(4672),
    [sym_null] = ACTIONS(4672),
    [sym_super] = ACTIONS(4672),
    [sym_this] = ACTIONS(4672),
    [sym_abstract] = ACTIONS(4672),
    [sym_alias] = ACTIONS(4672),
    [sym_align] = ACTIONS(4672),
    [sym_asm] = ACTIONS(4672),
    [sym_assert] = ACTIONS(4672),
    [sym_auto] = ACTIONS(4672),
    [sym_break] = ACTIONS(4672),
    [sym_case] = ACTIONS(4672),
    [sym_cast] = ACTIONS(4672),
    [sym_catch] = ACTIONS(4672),
    [sym_class] = ACTIONS(4672),
    [sym_const] = ACTIONS(4672),
    [sym_continue] = ACTIONS(4672),
    [sym_debug] = ACTIONS(4672),
    [sym_default] = ACTIONS(4672),
    [sym_delegate] = ACTIONS(4672),
    [sym_delete] = ACTIONS(4672),
    [sym_deprecated] = ACTIONS(4672),
    [sym_do] = ACTIONS(4672),
    [sym_else] = ACTIONS(4672),
    [sym_enum] = ACTIONS(4672),
    [sym_export] = ACTIONS(4672),
    [sym_extern] = ACTIONS(4672),
    [sym_final] = ACTIONS(4672),
    [sym_finally] = ACTIONS(4672),
    [sym_for] = ACTIONS(4672),
    [sym_foreach] = ACTIONS(4672),
    [sym_foreach_reverse] = ACTIONS(4672),
    [sym_function] = ACTIONS(4672),
    [sym_goto] = ACTIONS(4672),
    [sym_if] = ACTIONS(4672),
    [sym_immutable] = ACTIONS(4672),
    [sym_import] = ACTIONS(4672),
    [sym_in] = ACTIONS(4672),
    [sym_inout] = ACTIONS(4672),
    [sym_interface] = ACTIONS(4672),
    [sym_invariant] = ACTIONS(4672),
    [sym_is] = ACTIONS(4672),
    [sym_mixin] = ACTIONS(4672),
    [sym_new] = ACTIONS(4672),
    [sym_nothrow] = ACTIONS(4672),
    [sym_out] = ACTIONS(4672),
    [sym_override] = ACTIONS(4672),
    [sym_package] = ACTIONS(4672),
    [sym_pragma] = ACTIONS(4672),
    [sym_private] = ACTIONS(4672),
    [sym_protected] = ACTIONS(4672),
    [sym_public] = ACTIONS(4672),
    [sym_pure] = ACTIONS(4672),
    [sym_ref] = ACTIONS(4672),
    [sym_return] = ACTIONS(4672),
    [sym_scope] = ACTIONS(4672),
    [sym_shared] = ACTIONS(4672),
    [sym_static] = ACTIONS(4672),
    [sym_struct] = ACTIONS(4672),
    [sym_switch] = ACTIONS(4672),
    [sym_synchronized] = ACTIONS(4672),
    [sym_template] = ACTIONS(4672),
    [sym_throw] = ACTIONS(4672),
    [sym_try] = ACTIONS(4672),
    [sym_typeid] = ACTIONS(4672),
    [sym_typeof] = ACTIONS(4672),
    [sym_union] = ACTIONS(4672),
    [sym_unittest] = ACTIONS(4672),
    [sym_version] = ACTIONS(4672),
    [sym_while] = ACTIONS(4672),
    [sym_with] = ACTIONS(4672),
    [sym_gshared] = ACTIONS(4672),
    [sym_traits] = ACTIONS(4672),
    [sym_vector] = ACTIONS(4672),
    [sym_void] = ACTIONS(4672),
    [anon_sym_BQUOTE] = ACTIONS(4675),
    [anon_sym_r_DQUOTE] = ACTIONS(4675),
    [anon_sym_x_DQUOTE] = ACTIONS(4675),
    [anon_sym_DQUOTE] = ACTIONS(4675),
    [anon_sym_i_BQUOTE] = ACTIONS(4675),
    [anon_sym_i_DQUOTE] = ACTIONS(4675),
    [anon_sym_iq_LBRACE] = ACTIONS(4675),
    [aux_sym_char_literal_token1] = ACTIONS(4675),
    [anon_sym_SQUOTE] = ACTIONS(4672),
    [anon_sym___DATE__] = ACTIONS(4672),
    [anon_sym___FILE__] = ACTIONS(4672),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4672),
    [anon_sym___FUNCTION__] = ACTIONS(4672),
    [anon_sym___LINE__] = ACTIONS(4672),
    [anon_sym___MODULE__] = ACTIONS(4672),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4672),
    [anon_sym___TIME__] = ACTIONS(4672),
    [anon_sym___TIMESTAMP__] = ACTIONS(4672),
    [anon_sym___VENDOR__] = ACTIONS(4672),
    [anon_sym___VERSION__] = ACTIONS(4672),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4675),
    [sym_float_literal] = ACTIONS(4675),
    [sym__string] = ACTIONS(4675),
  },
  [1425] = {
    [sym_identifier] = ACTIONS(4678),
    [anon_sym_q_LBRACE] = ACTIONS(4680),
    [anon_sym_RBRACE] = ACTIONS(4680),
    [anon_sym_LBRACE] = ACTIONS(4680),
    [anon_sym_DOT] = ACTIONS(4680),
    [anon_sym_AMP] = ACTIONS(4680),
    [anon_sym_DASH] = ACTIONS(4678),
    [anon_sym_DASH_DASH] = ACTIONS(4680),
    [anon_sym_PLUS] = ACTIONS(4678),
    [anon_sym_PLUS_PLUS] = ACTIONS(4680),
    [anon_sym_BANG] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4680),
    [anon_sym_RPAREN] = ACTIONS(4680),
    [anon_sym_LBRACK] = ACTIONS(4680),
    [anon_sym_SEMI] = ACTIONS(4680),
    [anon_sym_DOLLAR] = ACTIONS(4680),
    [anon_sym_STAR] = ACTIONS(4680),
    [anon_sym_TILDE] = ACTIONS(4680),
    [anon_sym_AT] = ACTIONS(4680),
    [sym_bool] = ACTIONS(4678),
    [sym_byte] = ACTIONS(4678),
    [sym_ubyte] = ACTIONS(4678),
    [sym_char] = ACTIONS(4678),
    [sym_short] = ACTIONS(4678),
    [sym_ushort] = ACTIONS(4678),
    [sym_int] = ACTIONS(4678),
    [sym_uint] = ACTIONS(4678),
    [sym_long] = ACTIONS(4678),
    [sym_ulong] = ACTIONS(4678),
    [sym_cent] = ACTIONS(4678),
    [sym_ucent] = ACTIONS(4678),
    [sym_wchar] = ACTIONS(4678),
    [sym_dchar] = ACTIONS(4678),
    [sym_float] = ACTIONS(4678),
    [sym_double] = ACTIONS(4678),
    [sym_real] = ACTIONS(4678),
    [sym_ifloat] = ACTIONS(4678),
    [sym_idouble] = ACTIONS(4678),
    [sym_ireal] = ACTIONS(4678),
    [sym_cfloat] = ACTIONS(4678),
    [sym_cdouble] = ACTIONS(4678),
    [sym_creal] = ACTIONS(4678),
    [sym_size_t] = ACTIONS(4678),
    [sym_ptrdiff_t] = ACTIONS(4678),
    [sym_string] = ACTIONS(4678),
    [sym_cstring] = ACTIONS(4678),
    [sym_dstring] = ACTIONS(4678),
    [sym_wstring] = ACTIONS(4678),
    [sym_noreturn] = ACTIONS(4678),
    [sym_true] = ACTIONS(4678),
    [sym_false] = ACTIONS(4678),
    [sym_null] = ACTIONS(4678),
    [sym_super] = ACTIONS(4678),
    [sym_this] = ACTIONS(4678),
    [sym_abstract] = ACTIONS(4678),
    [sym_alias] = ACTIONS(4678),
    [sym_align] = ACTIONS(4678),
    [sym_asm] = ACTIONS(4678),
    [sym_assert] = ACTIONS(4678),
    [sym_auto] = ACTIONS(4678),
    [sym_break] = ACTIONS(4678),
    [sym_case] = ACTIONS(4678),
    [sym_cast] = ACTIONS(4678),
    [sym_catch] = ACTIONS(4678),
    [sym_class] = ACTIONS(4678),
    [sym_const] = ACTIONS(4678),
    [sym_continue] = ACTIONS(4678),
    [sym_debug] = ACTIONS(4678),
    [sym_default] = ACTIONS(4678),
    [sym_delegate] = ACTIONS(4678),
    [sym_delete] = ACTIONS(4678),
    [sym_deprecated] = ACTIONS(4678),
    [sym_do] = ACTIONS(4678),
    [sym_else] = ACTIONS(4678),
    [sym_enum] = ACTIONS(4678),
    [sym_export] = ACTIONS(4678),
    [sym_extern] = ACTIONS(4678),
    [sym_final] = ACTIONS(4678),
    [sym_finally] = ACTIONS(4678),
    [sym_for] = ACTIONS(4678),
    [sym_foreach] = ACTIONS(4678),
    [sym_foreach_reverse] = ACTIONS(4678),
    [sym_function] = ACTIONS(4678),
    [sym_goto] = ACTIONS(4678),
    [sym_if] = ACTIONS(4678),
    [sym_immutable] = ACTIONS(4678),
    [sym_import] = ACTIONS(4678),
    [sym_in] = ACTIONS(4678),
    [sym_inout] = ACTIONS(4678),
    [sym_interface] = ACTIONS(4678),
    [sym_invariant] = ACTIONS(4678),
    [sym_is] = ACTIONS(4678),
    [sym_mixin] = ACTIONS(4678),
    [sym_new] = ACTIONS(4678),
    [sym_nothrow] = ACTIONS(4678),
    [sym_out] = ACTIONS(4678),
    [sym_override] = ACTIONS(4678),
    [sym_package] = ACTIONS(4678),
    [sym_pragma] = ACTIONS(4678),
    [sym_private] = ACTIONS(4678),
    [sym_protected] = ACTIONS(4678),
    [sym_public] = ACTIONS(4678),
    [sym_pure] = ACTIONS(4678),
    [sym_ref] = ACTIONS(4678),
    [sym_return] = ACTIONS(4678),
    [sym_scope] = ACTIONS(4678),
    [sym_shared] = ACTIONS(4678),
    [sym_static] = ACTIONS(4678),
    [sym_struct] = ACTIONS(4678),
    [sym_switch] = ACTIONS(4678),
    [sym_synchronized] = ACTIONS(4678),
    [sym_template] = ACTIONS(4678),
    [sym_throw] = ACTIONS(4678),
    [sym_try] = ACTIONS(4678),
    [sym_typeid] = ACTIONS(4678),
    [sym_typeof] = ACTIONS(4678),
    [sym_union] = ACTIONS(4678),
    [sym_unittest] = ACTIONS(4678),
    [sym_version] = ACTIONS(4678),
    [sym_while] = ACTIONS(4678),
    [sym_with] = ACTIONS(4678),
    [sym_gshared] = ACTIONS(4678),
    [sym_traits] = ACTIONS(4678),
    [sym_vector] = ACTIONS(4678),
    [sym_void] = ACTIONS(4678),
    [anon_sym_BQUOTE] = ACTIONS(4680),
    [anon_sym_r_DQUOTE] = ACTIONS(4680),
    [anon_sym_x_DQUOTE] = ACTIONS(4680),
    [anon_sym_DQUOTE] = ACTIONS(4680),
    [anon_sym_i_BQUOTE] = ACTIONS(4680),
    [anon_sym_i_DQUOTE] = ACTIONS(4680),
    [anon_sym_iq_LBRACE] = ACTIONS(4680),
    [aux_sym_char_literal_token1] = ACTIONS(4680),
    [anon_sym_SQUOTE] = ACTIONS(4678),
    [anon_sym___DATE__] = ACTIONS(4678),
    [anon_sym___FILE__] = ACTIONS(4678),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4678),
    [anon_sym___FUNCTION__] = ACTIONS(4678),
    [anon_sym___LINE__] = ACTIONS(4678),
    [anon_sym___MODULE__] = ACTIONS(4678),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4678),
    [anon_sym___TIME__] = ACTIONS(4678),
    [anon_sym___TIMESTAMP__] = ACTIONS(4678),
    [anon_sym___VENDOR__] = ACTIONS(4678),
    [anon_sym___VERSION__] = ACTIONS(4678),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4680),
    [sym_float_literal] = ACTIONS(4680),
    [sym__string] = ACTIONS(4680),
  },
  [1426] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_RBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_AT] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_abstract] = ACTIONS(4682),
    [sym_alias] = ACTIONS(4682),
    [sym_align] = ACTIONS(4682),
    [sym_asm] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_break] = ACTIONS(4682),
    [sym_case] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_catch] = ACTIONS(4682),
    [sym_class] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_continue] = ACTIONS(4682),
    [sym_debug] = ACTIONS(4682),
    [sym_default] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_deprecated] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(4686),
    [sym_enum] = ACTIONS(4682),
    [sym_export] = ACTIONS(4682),
    [sym_extern] = ACTIONS(4682),
    [sym_final] = ACTIONS(4682),
    [sym_finally] = ACTIONS(4682),
    [sym_for] = ACTIONS(4682),
    [sym_foreach] = ACTIONS(4682),
    [sym_foreach_reverse] = ACTIONS(4682),
    [sym_function] = ACTIONS(4682),
    [sym_goto] = ACTIONS(4682),
    [sym_if] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_interface] = ACTIONS(4682),
    [sym_invariant] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_nothrow] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_override] = ACTIONS(4682),
    [sym_package] = ACTIONS(4682),
    [sym_pragma] = ACTIONS(4682),
    [sym_private] = ACTIONS(4682),
    [sym_protected] = ACTIONS(4682),
    [sym_public] = ACTIONS(4682),
    [sym_pure] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_return] = ACTIONS(4682),
    [sym_scope] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_static] = ACTIONS(4682),
    [sym_struct] = ACTIONS(4682),
    [sym_switch] = ACTIONS(4682),
    [sym_synchronized] = ACTIONS(4682),
    [sym_template] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_try] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_union] = ACTIONS(4682),
    [sym_unittest] = ACTIONS(4682),
    [sym_version] = ACTIONS(4682),
    [sym_while] = ACTIONS(4682),
    [sym_with] = ACTIONS(4682),
    [sym_gshared] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [1427] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [anon_sym_AT] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_abstract] = ACTIONS(4688),
    [sym_alias] = ACTIONS(4688),
    [sym_align] = ACTIONS(4688),
    [sym_asm] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_break] = ACTIONS(4688),
    [sym_case] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_catch] = ACTIONS(4688),
    [sym_class] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_continue] = ACTIONS(4688),
    [sym_debug] = ACTIONS(4688),
    [sym_default] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_deprecated] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(4694),
    [sym_enum] = ACTIONS(4688),
    [sym_export] = ACTIONS(4688),
    [sym_extern] = ACTIONS(4688),
    [sym_final] = ACTIONS(4688),
    [sym_finally] = ACTIONS(4688),
    [sym_for] = ACTIONS(4688),
    [sym_foreach] = ACTIONS(4688),
    [sym_foreach_reverse] = ACTIONS(4688),
    [sym_function] = ACTIONS(4688),
    [sym_goto] = ACTIONS(4688),
    [sym_if] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_interface] = ACTIONS(4688),
    [sym_invariant] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_nothrow] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_override] = ACTIONS(4688),
    [sym_package] = ACTIONS(4688),
    [sym_pragma] = ACTIONS(4688),
    [sym_private] = ACTIONS(4688),
    [sym_protected] = ACTIONS(4688),
    [sym_public] = ACTIONS(4688),
    [sym_pure] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_return] = ACTIONS(4688),
    [sym_scope] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_static] = ACTIONS(4688),
    [sym_struct] = ACTIONS(4688),
    [sym_switch] = ACTIONS(4688),
    [sym_synchronized] = ACTIONS(4688),
    [sym_template] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_try] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_union] = ACTIONS(4688),
    [sym_unittest] = ACTIONS(4688),
    [sym_version] = ACTIONS(4688),
    [sym_while] = ACTIONS(4688),
    [sym_with] = ACTIONS(4688),
    [sym_gshared] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [1428] = {
    [sym_identifier] = ACTIONS(4697),
    [anon_sym_q_LBRACE] = ACTIONS(4699),
    [anon_sym_RBRACE] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4699),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_DASH] = ACTIONS(4699),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4699),
    [anon_sym_BANG] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4699),
    [anon_sym_RPAREN] = ACTIONS(4699),
    [anon_sym_LBRACK] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4699),
    [anon_sym_DOLLAR] = ACTIONS(4699),
    [anon_sym_STAR] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4699),
    [anon_sym_AT] = ACTIONS(4699),
    [sym_bool] = ACTIONS(4697),
    [sym_byte] = ACTIONS(4697),
    [sym_ubyte] = ACTIONS(4697),
    [sym_char] = ACTIONS(4697),
    [sym_short] = ACTIONS(4697),
    [sym_ushort] = ACTIONS(4697),
    [sym_int] = ACTIONS(4697),
    [sym_uint] = ACTIONS(4697),
    [sym_long] = ACTIONS(4697),
    [sym_ulong] = ACTIONS(4697),
    [sym_cent] = ACTIONS(4697),
    [sym_ucent] = ACTIONS(4697),
    [sym_wchar] = ACTIONS(4697),
    [sym_dchar] = ACTIONS(4697),
    [sym_float] = ACTIONS(4697),
    [sym_double] = ACTIONS(4697),
    [sym_real] = ACTIONS(4697),
    [sym_ifloat] = ACTIONS(4697),
    [sym_idouble] = ACTIONS(4697),
    [sym_ireal] = ACTIONS(4697),
    [sym_cfloat] = ACTIONS(4697),
    [sym_cdouble] = ACTIONS(4697),
    [sym_creal] = ACTIONS(4697),
    [sym_size_t] = ACTIONS(4697),
    [sym_ptrdiff_t] = ACTIONS(4697),
    [sym_string] = ACTIONS(4697),
    [sym_cstring] = ACTIONS(4697),
    [sym_dstring] = ACTIONS(4697),
    [sym_wstring] = ACTIONS(4697),
    [sym_noreturn] = ACTIONS(4697),
    [sym_true] = ACTIONS(4697),
    [sym_false] = ACTIONS(4697),
    [sym_null] = ACTIONS(4697),
    [sym_super] = ACTIONS(4697),
    [sym_this] = ACTIONS(4697),
    [sym_abstract] = ACTIONS(4697),
    [sym_alias] = ACTIONS(4697),
    [sym_align] = ACTIONS(4697),
    [sym_asm] = ACTIONS(4697),
    [sym_assert] = ACTIONS(4697),
    [sym_auto] = ACTIONS(4697),
    [sym_break] = ACTIONS(4697),
    [sym_case] = ACTIONS(4697),
    [sym_cast] = ACTIONS(4697),
    [sym_catch] = ACTIONS(4697),
    [sym_class] = ACTIONS(4697),
    [sym_const] = ACTIONS(4697),
    [sym_continue] = ACTIONS(4697),
    [sym_debug] = ACTIONS(4697),
    [sym_default] = ACTIONS(4697),
    [sym_delegate] = ACTIONS(4697),
    [sym_delete] = ACTIONS(4697),
    [sym_deprecated] = ACTIONS(4697),
    [sym_do] = ACTIONS(4697),
    [sym_else] = ACTIONS(4697),
    [sym_enum] = ACTIONS(4697),
    [sym_export] = ACTIONS(4697),
    [sym_extern] = ACTIONS(4697),
    [sym_final] = ACTIONS(4697),
    [sym_finally] = ACTIONS(4697),
    [sym_for] = ACTIONS(4697),
    [sym_foreach] = ACTIONS(4697),
    [sym_foreach_reverse] = ACTIONS(4697),
    [sym_function] = ACTIONS(4697),
    [sym_goto] = ACTIONS(4697),
    [sym_if] = ACTIONS(4697),
    [sym_immutable] = ACTIONS(4697),
    [sym_import] = ACTIONS(4697),
    [sym_in] = ACTIONS(4697),
    [sym_inout] = ACTIONS(4697),
    [sym_interface] = ACTIONS(4697),
    [sym_invariant] = ACTIONS(4697),
    [sym_is] = ACTIONS(4697),
    [sym_mixin] = ACTIONS(4697),
    [sym_new] = ACTIONS(4697),
    [sym_nothrow] = ACTIONS(4697),
    [sym_out] = ACTIONS(4697),
    [sym_override] = ACTIONS(4697),
    [sym_package] = ACTIONS(4697),
    [sym_pragma] = ACTIONS(4697),
    [sym_private] = ACTIONS(4697),
    [sym_protected] = ACTIONS(4697),
    [sym_public] = ACTIONS(4697),
    [sym_pure] = ACTIONS(4697),
    [sym_ref] = ACTIONS(4697),
    [sym_return] = ACTIONS(4697),
    [sym_scope] = ACTIONS(4697),
    [sym_shared] = ACTIONS(4697),
    [sym_static] = ACTIONS(4697),
    [sym_struct] = ACTIONS(4697),
    [sym_switch] = ACTIONS(4697),
    [sym_synchronized] = ACTIONS(4697),
    [sym_template] = ACTIONS(4697),
    [sym_throw] = ACTIONS(4697),
    [sym_try] = ACTIONS(4697),
    [sym_typeid] = ACTIONS(4697),
    [sym_typeof] = ACTIONS(4697),
    [sym_union] = ACTIONS(4697),
    [sym_unittest] = ACTIONS(4697),
    [sym_version] = ACTIONS(4697),
    [sym_while] = ACTIONS(4697),
    [sym_with] = ACTIONS(4697),
    [sym_gshared] = ACTIONS(4697),
    [sym_traits] = ACTIONS(4697),
    [sym_vector] = ACTIONS(4697),
    [sym_void] = ACTIONS(4697),
    [anon_sym_BQUOTE] = ACTIONS(4699),
    [anon_sym_r_DQUOTE] = ACTIONS(4699),
    [anon_sym_x_DQUOTE] = ACTIONS(4699),
    [anon_sym_DQUOTE] = ACTIONS(4699),
    [anon_sym_i_BQUOTE] = ACTIONS(4699),
    [anon_sym_i_DQUOTE] = ACTIONS(4699),
    [anon_sym_iq_LBRACE] = ACTIONS(4699),
    [aux_sym_char_literal_token1] = ACTIONS(4699),
    [anon_sym_SQUOTE] = ACTIONS(4697),
    [anon_sym___DATE__] = ACTIONS(4697),
    [anon_sym___FILE__] = ACTIONS(4697),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4697),
    [anon_sym___FUNCTION__] = ACTIONS(4697),
    [anon_sym___LINE__] = ACTIONS(4697),
    [anon_sym___MODULE__] = ACTIONS(4697),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4697),
    [anon_sym___TIME__] = ACTIONS(4697),
    [anon_sym___TIMESTAMP__] = ACTIONS(4697),
    [anon_sym___VENDOR__] = ACTIONS(4697),
    [anon_sym___VERSION__] = ACTIONS(4697),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4699),
    [sym_float_literal] = ACTIONS(4699),
    [sym__string] = ACTIONS(4699),
  },
  [1429] = {
    [sym_identifier] = ACTIONS(4701),
    [anon_sym_q_LBRACE] = ACTIONS(4704),
    [anon_sym_RBRACE] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(4704),
    [anon_sym_DOT] = ACTIONS(4704),
    [anon_sym_AMP] = ACTIONS(4704),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_DASH_DASH] = ACTIONS(4704),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4704),
    [anon_sym_BANG] = ACTIONS(4704),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_RPAREN] = ACTIONS(4704),
    [anon_sym_LBRACK] = ACTIONS(4704),
    [anon_sym_SEMI] = ACTIONS(4704),
    [anon_sym_DOLLAR] = ACTIONS(4704),
    [anon_sym_STAR] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(4704),
    [anon_sym_AT] = ACTIONS(4704),
    [sym_bool] = ACTIONS(4701),
    [sym_byte] = ACTIONS(4701),
    [sym_ubyte] = ACTIONS(4701),
    [sym_char] = ACTIONS(4701),
    [sym_short] = ACTIONS(4701),
    [sym_ushort] = ACTIONS(4701),
    [sym_int] = ACTIONS(4701),
    [sym_uint] = ACTIONS(4701),
    [sym_long] = ACTIONS(4701),
    [sym_ulong] = ACTIONS(4701),
    [sym_cent] = ACTIONS(4701),
    [sym_ucent] = ACTIONS(4701),
    [sym_wchar] = ACTIONS(4701),
    [sym_dchar] = ACTIONS(4701),
    [sym_float] = ACTIONS(4701),
    [sym_double] = ACTIONS(4701),
    [sym_real] = ACTIONS(4701),
    [sym_ifloat] = ACTIONS(4701),
    [sym_idouble] = ACTIONS(4701),
    [sym_ireal] = ACTIONS(4701),
    [sym_cfloat] = ACTIONS(4701),
    [sym_cdouble] = ACTIONS(4701),
    [sym_creal] = ACTIONS(4701),
    [sym_size_t] = ACTIONS(4701),
    [sym_ptrdiff_t] = ACTIONS(4701),
    [sym_string] = ACTIONS(4701),
    [sym_cstring] = ACTIONS(4701),
    [sym_dstring] = ACTIONS(4701),
    [sym_wstring] = ACTIONS(4701),
    [sym_noreturn] = ACTIONS(4701),
    [sym_true] = ACTIONS(4701),
    [sym_false] = ACTIONS(4701),
    [sym_null] = ACTIONS(4701),
    [sym_super] = ACTIONS(4701),
    [sym_this] = ACTIONS(4701),
    [sym_abstract] = ACTIONS(4701),
    [sym_alias] = ACTIONS(4701),
    [sym_align] = ACTIONS(4701),
    [sym_asm] = ACTIONS(4701),
    [sym_assert] = ACTIONS(4701),
    [sym_auto] = ACTIONS(4701),
    [sym_break] = ACTIONS(4701),
    [sym_case] = ACTIONS(4701),
    [sym_cast] = ACTIONS(4701),
    [sym_catch] = ACTIONS(4701),
    [sym_class] = ACTIONS(4701),
    [sym_const] = ACTIONS(4701),
    [sym_continue] = ACTIONS(4701),
    [sym_debug] = ACTIONS(4701),
    [sym_default] = ACTIONS(4701),
    [sym_delegate] = ACTIONS(4701),
    [sym_delete] = ACTIONS(4701),
    [sym_deprecated] = ACTIONS(4701),
    [sym_do] = ACTIONS(4701),
    [sym_else] = ACTIONS(4701),
    [sym_enum] = ACTIONS(4701),
    [sym_export] = ACTIONS(4701),
    [sym_extern] = ACTIONS(4701),
    [sym_final] = ACTIONS(4701),
    [sym_finally] = ACTIONS(4701),
    [sym_for] = ACTIONS(4701),
    [sym_foreach] = ACTIONS(4701),
    [sym_foreach_reverse] = ACTIONS(4701),
    [sym_function] = ACTIONS(4701),
    [sym_goto] = ACTIONS(4701),
    [sym_if] = ACTIONS(4701),
    [sym_immutable] = ACTIONS(4701),
    [sym_import] = ACTIONS(4701),
    [sym_in] = ACTIONS(4701),
    [sym_inout] = ACTIONS(4701),
    [sym_interface] = ACTIONS(4701),
    [sym_invariant] = ACTIONS(4701),
    [sym_is] = ACTIONS(4701),
    [sym_mixin] = ACTIONS(4701),
    [sym_new] = ACTIONS(4701),
    [sym_nothrow] = ACTIONS(4701),
    [sym_out] = ACTIONS(4701),
    [sym_override] = ACTIONS(4701),
    [sym_package] = ACTIONS(4701),
    [sym_pragma] = ACTIONS(4701),
    [sym_private] = ACTIONS(4701),
    [sym_protected] = ACTIONS(4701),
    [sym_public] = ACTIONS(4701),
    [sym_pure] = ACTIONS(4701),
    [sym_ref] = ACTIONS(4701),
    [sym_return] = ACTIONS(4701),
    [sym_scope] = ACTIONS(4701),
    [sym_shared] = ACTIONS(4701),
    [sym_static] = ACTIONS(4701),
    [sym_struct] = ACTIONS(4701),
    [sym_switch] = ACTIONS(4701),
    [sym_synchronized] = ACTIONS(4701),
    [sym_template] = ACTIONS(4701),
    [sym_throw] = ACTIONS(4701),
    [sym_try] = ACTIONS(4701),
    [sym_typeid] = ACTIONS(4701),
    [sym_typeof] = ACTIONS(4701),
    [sym_union] = ACTIONS(4701),
    [sym_unittest] = ACTIONS(4701),
    [sym_version] = ACTIONS(4701),
    [sym_while] = ACTIONS(4701),
    [sym_with] = ACTIONS(4701),
    [sym_gshared] = ACTIONS(4701),
    [sym_traits] = ACTIONS(4701),
    [sym_vector] = ACTIONS(4701),
    [sym_void] = ACTIONS(4701),
    [anon_sym_BQUOTE] = ACTIONS(4704),
    [anon_sym_r_DQUOTE] = ACTIONS(4704),
    [anon_sym_x_DQUOTE] = ACTIONS(4704),
    [anon_sym_DQUOTE] = ACTIONS(4704),
    [anon_sym_i_BQUOTE] = ACTIONS(4704),
    [anon_sym_i_DQUOTE] = ACTIONS(4704),
    [anon_sym_iq_LBRACE] = ACTIONS(4704),
    [aux_sym_char_literal_token1] = ACTIONS(4704),
    [anon_sym_SQUOTE] = ACTIONS(4701),
    [anon_sym___DATE__] = ACTIONS(4701),
    [anon_sym___FILE__] = ACTIONS(4701),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4701),
    [anon_sym___FUNCTION__] = ACTIONS(4701),
    [anon_sym___LINE__] = ACTIONS(4701),
    [anon_sym___MODULE__] = ACTIONS(4701),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4701),
    [anon_sym___TIME__] = ACTIONS(4701),
    [anon_sym___TIMESTAMP__] = ACTIONS(4701),
    [anon_sym___VENDOR__] = ACTIONS(4701),
    [anon_sym___VERSION__] = ACTIONS(4701),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4704),
    [sym_float_literal] = ACTIONS(4704),
    [sym__string] = ACTIONS(4704),
  },
  [1430] = {
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_q_LBRACE] = ACTIONS(4709),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_DOT] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_DASH_DASH] = ACTIONS(4709),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4709),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_RPAREN] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym_DOLLAR] = ACTIONS(4709),
    [anon_sym_STAR] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_AT] = ACTIONS(4709),
    [sym_bool] = ACTIONS(4707),
    [sym_byte] = ACTIONS(4707),
    [sym_ubyte] = ACTIONS(4707),
    [sym_char] = ACTIONS(4707),
    [sym_short] = ACTIONS(4707),
    [sym_ushort] = ACTIONS(4707),
    [sym_int] = ACTIONS(4707),
    [sym_uint] = ACTIONS(4707),
    [sym_long] = ACTIONS(4707),
    [sym_ulong] = ACTIONS(4707),
    [sym_cent] = ACTIONS(4707),
    [sym_ucent] = ACTIONS(4707),
    [sym_wchar] = ACTIONS(4707),
    [sym_dchar] = ACTIONS(4707),
    [sym_float] = ACTIONS(4707),
    [sym_double] = ACTIONS(4707),
    [sym_real] = ACTIONS(4707),
    [sym_ifloat] = ACTIONS(4707),
    [sym_idouble] = ACTIONS(4707),
    [sym_ireal] = ACTIONS(4707),
    [sym_cfloat] = ACTIONS(4707),
    [sym_cdouble] = ACTIONS(4707),
    [sym_creal] = ACTIONS(4707),
    [sym_size_t] = ACTIONS(4707),
    [sym_ptrdiff_t] = ACTIONS(4707),
    [sym_string] = ACTIONS(4707),
    [sym_cstring] = ACTIONS(4707),
    [sym_dstring] = ACTIONS(4707),
    [sym_wstring] = ACTIONS(4707),
    [sym_noreturn] = ACTIONS(4707),
    [sym_true] = ACTIONS(4707),
    [sym_false] = ACTIONS(4707),
    [sym_null] = ACTIONS(4707),
    [sym_super] = ACTIONS(4707),
    [sym_this] = ACTIONS(4707),
    [sym_abstract] = ACTIONS(4707),
    [sym_alias] = ACTIONS(4707),
    [sym_align] = ACTIONS(4707),
    [sym_asm] = ACTIONS(4707),
    [sym_assert] = ACTIONS(4707),
    [sym_auto] = ACTIONS(4707),
    [sym_break] = ACTIONS(4707),
    [sym_case] = ACTIONS(4707),
    [sym_cast] = ACTIONS(4707),
    [sym_catch] = ACTIONS(4707),
    [sym_class] = ACTIONS(4707),
    [sym_const] = ACTIONS(4707),
    [sym_continue] = ACTIONS(4707),
    [sym_debug] = ACTIONS(4707),
    [sym_default] = ACTIONS(4707),
    [sym_delegate] = ACTIONS(4707),
    [sym_delete] = ACTIONS(4707),
    [sym_deprecated] = ACTIONS(4707),
    [sym_do] = ACTIONS(4707),
    [sym_else] = ACTIONS(4707),
    [sym_enum] = ACTIONS(4707),
    [sym_export] = ACTIONS(4707),
    [sym_extern] = ACTIONS(4707),
    [sym_final] = ACTIONS(4707),
    [sym_finally] = ACTIONS(4707),
    [sym_for] = ACTIONS(4707),
    [sym_foreach] = ACTIONS(4707),
    [sym_foreach_reverse] = ACTIONS(4707),
    [sym_function] = ACTIONS(4707),
    [sym_goto] = ACTIONS(4707),
    [sym_if] = ACTIONS(4707),
    [sym_immutable] = ACTIONS(4707),
    [sym_import] = ACTIONS(4707),
    [sym_in] = ACTIONS(4707),
    [sym_inout] = ACTIONS(4707),
    [sym_interface] = ACTIONS(4707),
    [sym_invariant] = ACTIONS(4707),
    [sym_is] = ACTIONS(4707),
    [sym_mixin] = ACTIONS(4707),
    [sym_new] = ACTIONS(4707),
    [sym_nothrow] = ACTIONS(4707),
    [sym_out] = ACTIONS(4707),
    [sym_override] = ACTIONS(4707),
    [sym_package] = ACTIONS(4707),
    [sym_pragma] = ACTIONS(4707),
    [sym_private] = ACTIONS(4707),
    [sym_protected] = ACTIONS(4707),
    [sym_public] = ACTIONS(4707),
    [sym_pure] = ACTIONS(4707),
    [sym_ref] = ACTIONS(4707),
    [sym_return] = ACTIONS(4707),
    [sym_scope] = ACTIONS(4707),
    [sym_shared] = ACTIONS(4707),
    [sym_static] = ACTIONS(4707),
    [sym_struct] = ACTIONS(4707),
    [sym_switch] = ACTIONS(4707),
    [sym_synchronized] = ACTIONS(4707),
    [sym_template] = ACTIONS(4707),
    [sym_throw] = ACTIONS(4707),
    [sym_try] = ACTIONS(4707),
    [sym_typeid] = ACTIONS(4707),
    [sym_typeof] = ACTIONS(4707),
    [sym_union] = ACTIONS(4707),
    [sym_unittest] = ACTIONS(4707),
    [sym_version] = ACTIONS(4707),
    [sym_while] = ACTIONS(4707),
    [sym_with] = ACTIONS(4707),
    [sym_gshared] = ACTIONS(4707),
    [sym_traits] = ACTIONS(4707),
    [sym_vector] = ACTIONS(4707),
    [sym_void] = ACTIONS(4707),
    [anon_sym_BQUOTE] = ACTIONS(4709),
    [anon_sym_r_DQUOTE] = ACTIONS(4709),
    [anon_sym_x_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [anon_sym_i_BQUOTE] = ACTIONS(4709),
    [anon_sym_i_DQUOTE] = ACTIONS(4709),
    [anon_sym_iq_LBRACE] = ACTIONS(4709),
    [aux_sym_char_literal_token1] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4707),
    [anon_sym___DATE__] = ACTIONS(4707),
    [anon_sym___FILE__] = ACTIONS(4707),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4707),
    [anon_sym___FUNCTION__] = ACTIONS(4707),
    [anon_sym___LINE__] = ACTIONS(4707),
    [anon_sym___MODULE__] = ACTIONS(4707),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4707),
    [anon_sym___TIME__] = ACTIONS(4707),
    [anon_sym___TIMESTAMP__] = ACTIONS(4707),
    [anon_sym___VENDOR__] = ACTIONS(4707),
    [anon_sym___VERSION__] = ACTIONS(4707),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4709),
    [sym_float_literal] = ACTIONS(4709),
    [sym__string] = ACTIONS(4709),
  },
  [1431] = {
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2523),
    [sym_bool] = ACTIONS(2525),
    [sym_byte] = ACTIONS(2525),
    [sym_ubyte] = ACTIONS(2525),
    [sym_char] = ACTIONS(2525),
    [sym_short] = ACTIONS(2525),
    [sym_ushort] = ACTIONS(2525),
    [sym_int] = ACTIONS(2525),
    [sym_uint] = ACTIONS(2525),
    [sym_long] = ACTIONS(2525),
    [sym_ulong] = ACTIONS(2525),
    [sym_cent] = ACTIONS(2525),
    [sym_ucent] = ACTIONS(2525),
    [sym_wchar] = ACTIONS(2525),
    [sym_dchar] = ACTIONS(2525),
    [sym_float] = ACTIONS(2525),
    [sym_double] = ACTIONS(2525),
    [sym_real] = ACTIONS(2525),
    [sym_ifloat] = ACTIONS(2525),
    [sym_idouble] = ACTIONS(2525),
    [sym_ireal] = ACTIONS(2525),
    [sym_cfloat] = ACTIONS(2525),
    [sym_cdouble] = ACTIONS(2525),
    [sym_creal] = ACTIONS(2525),
    [sym_size_t] = ACTIONS(2525),
    [sym_ptrdiff_t] = ACTIONS(2525),
    [sym_string] = ACTIONS(2525),
    [sym_cstring] = ACTIONS(2525),
    [sym_dstring] = ACTIONS(2525),
    [sym_wstring] = ACTIONS(2525),
    [sym_noreturn] = ACTIONS(2525),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2525),
    [sym_abstract] = ACTIONS(2525),
    [sym_alias] = ACTIONS(2525),
    [sym_align] = ACTIONS(2525),
    [sym_asm] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(2525),
    [sym_break] = ACTIONS(2525),
    [sym_case] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_catch] = ACTIONS(2525),
    [sym_class] = ACTIONS(2525),
    [sym_const] = ACTIONS(2525),
    [sym_continue] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2525),
    [sym_default] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(2525),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(2525),
    [sym_export] = ACTIONS(2525),
    [sym_extern] = ACTIONS(2525),
    [sym_final] = ACTIONS(2525),
    [sym_finally] = ACTIONS(2525),
    [sym_for] = ACTIONS(2525),
    [sym_foreach] = ACTIONS(2525),
    [sym_foreach_reverse] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_goto] = ACTIONS(2525),
    [sym_if] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(2525),
    [sym_import] = ACTIONS(2525),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(2525),
    [sym_interface] = ACTIONS(2525),
    [sym_invariant] = ACTIONS(2525),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2525),
    [sym_new] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(2525),
    [sym_out] = ACTIONS(2525),
    [sym_override] = ACTIONS(2525),
    [sym_package] = ACTIONS(2525),
    [sym_pragma] = ACTIONS(2525),
    [sym_private] = ACTIONS(2525),
    [sym_protected] = ACTIONS(2525),
    [sym_public] = ACTIONS(2525),
    [sym_pure] = ACTIONS(2525),
    [sym_ref] = ACTIONS(2525),
    [sym_return] = ACTIONS(2525),
    [sym_scope] = ACTIONS(2525),
    [sym_shared] = ACTIONS(2525),
    [sym_static] = ACTIONS(2525),
    [sym_struct] = ACTIONS(2525),
    [sym_switch] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(2525),
    [sym_template] = ACTIONS(2525),
    [sym_throw] = ACTIONS(2525),
    [sym_try] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(2525),
    [sym_union] = ACTIONS(2525),
    [sym_unittest] = ACTIONS(2525),
    [sym_version] = ACTIONS(2525),
    [sym_while] = ACTIONS(2525),
    [sym_with] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(2525),
    [sym_traits] = ACTIONS(2525),
    [sym_vector] = ACTIONS(2525),
    [sym_void] = ACTIONS(2525),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [1432] = {
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_q_LBRACE] = ACTIONS(4713),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_LBRACE] = ACTIONS(4713),
    [anon_sym_DOT] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_DASH_DASH] = ACTIONS(4713),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_PLUS_PLUS] = ACTIONS(4713),
    [anon_sym_BANG] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_RPAREN] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_DOLLAR] = ACTIONS(4713),
    [anon_sym_STAR] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4713),
    [anon_sym_AT] = ACTIONS(4713),
    [sym_bool] = ACTIONS(4711),
    [sym_byte] = ACTIONS(4711),
    [sym_ubyte] = ACTIONS(4711),
    [sym_char] = ACTIONS(4711),
    [sym_short] = ACTIONS(4711),
    [sym_ushort] = ACTIONS(4711),
    [sym_int] = ACTIONS(4711),
    [sym_uint] = ACTIONS(4711),
    [sym_long] = ACTIONS(4711),
    [sym_ulong] = ACTIONS(4711),
    [sym_cent] = ACTIONS(4711),
    [sym_ucent] = ACTIONS(4711),
    [sym_wchar] = ACTIONS(4711),
    [sym_dchar] = ACTIONS(4711),
    [sym_float] = ACTIONS(4711),
    [sym_double] = ACTIONS(4711),
    [sym_real] = ACTIONS(4711),
    [sym_ifloat] = ACTIONS(4711),
    [sym_idouble] = ACTIONS(4711),
    [sym_ireal] = ACTIONS(4711),
    [sym_cfloat] = ACTIONS(4711),
    [sym_cdouble] = ACTIONS(4711),
    [sym_creal] = ACTIONS(4711),
    [sym_size_t] = ACTIONS(4711),
    [sym_ptrdiff_t] = ACTIONS(4711),
    [sym_string] = ACTIONS(4711),
    [sym_cstring] = ACTIONS(4711),
    [sym_dstring] = ACTIONS(4711),
    [sym_wstring] = ACTIONS(4711),
    [sym_noreturn] = ACTIONS(4711),
    [sym_true] = ACTIONS(4711),
    [sym_false] = ACTIONS(4711),
    [sym_null] = ACTIONS(4711),
    [sym_super] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [sym_abstract] = ACTIONS(4711),
    [sym_alias] = ACTIONS(4711),
    [sym_align] = ACTIONS(4711),
    [sym_asm] = ACTIONS(4711),
    [sym_assert] = ACTIONS(4711),
    [sym_auto] = ACTIONS(4711),
    [sym_break] = ACTIONS(4711),
    [sym_case] = ACTIONS(4711),
    [sym_cast] = ACTIONS(4711),
    [sym_catch] = ACTIONS(4711),
    [sym_class] = ACTIONS(4711),
    [sym_const] = ACTIONS(4711),
    [sym_continue] = ACTIONS(4711),
    [sym_debug] = ACTIONS(4711),
    [sym_default] = ACTIONS(4711),
    [sym_delegate] = ACTIONS(4711),
    [sym_delete] = ACTIONS(4711),
    [sym_deprecated] = ACTIONS(4711),
    [sym_do] = ACTIONS(4711),
    [sym_else] = ACTIONS(4711),
    [sym_enum] = ACTIONS(4711),
    [sym_export] = ACTIONS(4711),
    [sym_extern] = ACTIONS(4711),
    [sym_final] = ACTIONS(4711),
    [sym_finally] = ACTIONS(4711),
    [sym_for] = ACTIONS(4711),
    [sym_foreach] = ACTIONS(4711),
    [sym_foreach_reverse] = ACTIONS(4711),
    [sym_function] = ACTIONS(4711),
    [sym_goto] = ACTIONS(4711),
    [sym_if] = ACTIONS(4711),
    [sym_immutable] = ACTIONS(4711),
    [sym_import] = ACTIONS(4711),
    [sym_in] = ACTIONS(4711),
    [sym_inout] = ACTIONS(4711),
    [sym_interface] = ACTIONS(4711),
    [sym_invariant] = ACTIONS(4711),
    [sym_is] = ACTIONS(4711),
    [sym_mixin] = ACTIONS(4711),
    [sym_new] = ACTIONS(4711),
    [sym_nothrow] = ACTIONS(4711),
    [sym_out] = ACTIONS(4711),
    [sym_override] = ACTIONS(4711),
    [sym_package] = ACTIONS(4711),
    [sym_pragma] = ACTIONS(4711),
    [sym_private] = ACTIONS(4711),
    [sym_protected] = ACTIONS(4711),
    [sym_public] = ACTIONS(4711),
    [sym_pure] = ACTIONS(4711),
    [sym_ref] = ACTIONS(4711),
    [sym_return] = ACTIONS(4711),
    [sym_scope] = ACTIONS(4711),
    [sym_shared] = ACTIONS(4711),
    [sym_static] = ACTIONS(4711),
    [sym_struct] = ACTIONS(4711),
    [sym_switch] = ACTIONS(4711),
    [sym_synchronized] = ACTIONS(4711),
    [sym_template] = ACTIONS(4711),
    [sym_throw] = ACTIONS(4711),
    [sym_try] = ACTIONS(4711),
    [sym_typeid] = ACTIONS(4711),
    [sym_typeof] = ACTIONS(4711),
    [sym_union] = ACTIONS(4711),
    [sym_unittest] = ACTIONS(4711),
    [sym_version] = ACTIONS(4711),
    [sym_while] = ACTIONS(4711),
    [sym_with] = ACTIONS(4711),
    [sym_gshared] = ACTIONS(4711),
    [sym_traits] = ACTIONS(4711),
    [sym_vector] = ACTIONS(4711),
    [sym_void] = ACTIONS(4711),
    [anon_sym_BQUOTE] = ACTIONS(4713),
    [anon_sym_r_DQUOTE] = ACTIONS(4713),
    [anon_sym_x_DQUOTE] = ACTIONS(4713),
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [anon_sym_i_BQUOTE] = ACTIONS(4713),
    [anon_sym_i_DQUOTE] = ACTIONS(4713),
    [anon_sym_iq_LBRACE] = ACTIONS(4713),
    [aux_sym_char_literal_token1] = ACTIONS(4713),
    [anon_sym_SQUOTE] = ACTIONS(4711),
    [anon_sym___DATE__] = ACTIONS(4711),
    [anon_sym___FILE__] = ACTIONS(4711),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4711),
    [anon_sym___FUNCTION__] = ACTIONS(4711),
    [anon_sym___LINE__] = ACTIONS(4711),
    [anon_sym___MODULE__] = ACTIONS(4711),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4711),
    [anon_sym___TIME__] = ACTIONS(4711),
    [anon_sym___TIMESTAMP__] = ACTIONS(4711),
    [anon_sym___VENDOR__] = ACTIONS(4711),
    [anon_sym___VERSION__] = ACTIONS(4711),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4713),
    [sym_float_literal] = ACTIONS(4713),
    [sym__string] = ACTIONS(4713),
  },
  [1433] = {
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_q_LBRACE] = ACTIONS(4718),
    [anon_sym_RBRACE] = ACTIONS(4718),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_DOT] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4715),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_BANG] = ACTIONS(4718),
    [anon_sym_LPAREN] = ACTIONS(4718),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym_DOLLAR] = ACTIONS(4718),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_AT] = ACTIONS(4718),
    [sym_bool] = ACTIONS(4715),
    [sym_byte] = ACTIONS(4715),
    [sym_ubyte] = ACTIONS(4715),
    [sym_char] = ACTIONS(4715),
    [sym_short] = ACTIONS(4715),
    [sym_ushort] = ACTIONS(4715),
    [sym_int] = ACTIONS(4715),
    [sym_uint] = ACTIONS(4715),
    [sym_long] = ACTIONS(4715),
    [sym_ulong] = ACTIONS(4715),
    [sym_cent] = ACTIONS(4715),
    [sym_ucent] = ACTIONS(4715),
    [sym_wchar] = ACTIONS(4715),
    [sym_dchar] = ACTIONS(4715),
    [sym_float] = ACTIONS(4715),
    [sym_double] = ACTIONS(4715),
    [sym_real] = ACTIONS(4715),
    [sym_ifloat] = ACTIONS(4715),
    [sym_idouble] = ACTIONS(4715),
    [sym_ireal] = ACTIONS(4715),
    [sym_cfloat] = ACTIONS(4715),
    [sym_cdouble] = ACTIONS(4715),
    [sym_creal] = ACTIONS(4715),
    [sym_size_t] = ACTIONS(4715),
    [sym_ptrdiff_t] = ACTIONS(4715),
    [sym_string] = ACTIONS(4715),
    [sym_cstring] = ACTIONS(4715),
    [sym_dstring] = ACTIONS(4715),
    [sym_wstring] = ACTIONS(4715),
    [sym_noreturn] = ACTIONS(4715),
    [sym_true] = ACTIONS(4715),
    [sym_false] = ACTIONS(4715),
    [sym_null] = ACTIONS(4715),
    [sym_super] = ACTIONS(4715),
    [sym_this] = ACTIONS(4715),
    [sym_abstract] = ACTIONS(4715),
    [sym_alias] = ACTIONS(4715),
    [sym_align] = ACTIONS(4715),
    [sym_asm] = ACTIONS(4715),
    [sym_assert] = ACTIONS(4715),
    [sym_auto] = ACTIONS(4715),
    [sym_break] = ACTIONS(4715),
    [sym_case] = ACTIONS(4715),
    [sym_cast] = ACTIONS(4715),
    [sym_catch] = ACTIONS(4715),
    [sym_class] = ACTIONS(4715),
    [sym_const] = ACTIONS(4715),
    [sym_continue] = ACTIONS(4715),
    [sym_debug] = ACTIONS(4715),
    [sym_default] = ACTIONS(4715),
    [sym_delegate] = ACTIONS(4715),
    [sym_delete] = ACTIONS(4715),
    [sym_deprecated] = ACTIONS(4715),
    [sym_do] = ACTIONS(4715),
    [sym_else] = ACTIONS(4715),
    [sym_enum] = ACTIONS(4715),
    [sym_export] = ACTIONS(4715),
    [sym_extern] = ACTIONS(4715),
    [sym_final] = ACTIONS(4715),
    [sym_finally] = ACTIONS(4715),
    [sym_for] = ACTIONS(4715),
    [sym_foreach] = ACTIONS(4715),
    [sym_foreach_reverse] = ACTIONS(4715),
    [sym_function] = ACTIONS(4715),
    [sym_goto] = ACTIONS(4715),
    [sym_if] = ACTIONS(4715),
    [sym_immutable] = ACTIONS(4715),
    [sym_import] = ACTIONS(4715),
    [sym_in] = ACTIONS(4715),
    [sym_inout] = ACTIONS(4715),
    [sym_interface] = ACTIONS(4715),
    [sym_invariant] = ACTIONS(4715),
    [sym_is] = ACTIONS(4715),
    [sym_mixin] = ACTIONS(4715),
    [sym_new] = ACTIONS(4715),
    [sym_nothrow] = ACTIONS(4715),
    [sym_out] = ACTIONS(4715),
    [sym_override] = ACTIONS(4715),
    [sym_package] = ACTIONS(4715),
    [sym_pragma] = ACTIONS(4715),
    [sym_private] = ACTIONS(4715),
    [sym_protected] = ACTIONS(4715),
    [sym_public] = ACTIONS(4715),
    [sym_pure] = ACTIONS(4715),
    [sym_ref] = ACTIONS(4715),
    [sym_return] = ACTIONS(4715),
    [sym_scope] = ACTIONS(4715),
    [sym_shared] = ACTIONS(4715),
    [sym_static] = ACTIONS(4715),
    [sym_struct] = ACTIONS(4715),
    [sym_switch] = ACTIONS(4715),
    [sym_synchronized] = ACTIONS(4715),
    [sym_template] = ACTIONS(4715),
    [sym_throw] = ACTIONS(4715),
    [sym_try] = ACTIONS(4715),
    [sym_typeid] = ACTIONS(4715),
    [sym_typeof] = ACTIONS(4715),
    [sym_union] = ACTIONS(4715),
    [sym_unittest] = ACTIONS(4715),
    [sym_version] = ACTIONS(4715),
    [sym_while] = ACTIONS(4715),
    [sym_with] = ACTIONS(4715),
    [sym_gshared] = ACTIONS(4715),
    [sym_traits] = ACTIONS(4715),
    [sym_vector] = ACTIONS(4715),
    [sym_void] = ACTIONS(4715),
    [anon_sym_BQUOTE] = ACTIONS(4718),
    [anon_sym_r_DQUOTE] = ACTIONS(4718),
    [anon_sym_x_DQUOTE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4718),
    [anon_sym_i_BQUOTE] = ACTIONS(4718),
    [anon_sym_i_DQUOTE] = ACTIONS(4718),
    [anon_sym_iq_LBRACE] = ACTIONS(4718),
    [aux_sym_char_literal_token1] = ACTIONS(4718),
    [anon_sym_SQUOTE] = ACTIONS(4715),
    [anon_sym___DATE__] = ACTIONS(4715),
    [anon_sym___FILE__] = ACTIONS(4715),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4715),
    [anon_sym___FUNCTION__] = ACTIONS(4715),
    [anon_sym___LINE__] = ACTIONS(4715),
    [anon_sym___MODULE__] = ACTIONS(4715),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4715),
    [anon_sym___TIME__] = ACTIONS(4715),
    [anon_sym___TIMESTAMP__] = ACTIONS(4715),
    [anon_sym___VENDOR__] = ACTIONS(4715),
    [anon_sym___VERSION__] = ACTIONS(4715),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4718),
    [sym_float_literal] = ACTIONS(4718),
    [sym__string] = ACTIONS(4718),
  },
  [1434] = {
    [sym_identifier] = ACTIONS(4721),
    [anon_sym_q_LBRACE] = ACTIONS(4723),
    [anon_sym_RBRACE] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4723),
    [anon_sym_DOT] = ACTIONS(4723),
    [anon_sym_AMP] = ACTIONS(4723),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_DASH_DASH] = ACTIONS(4723),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_PLUS_PLUS] = ACTIONS(4723),
    [anon_sym_BANG] = ACTIONS(4723),
    [anon_sym_LPAREN] = ACTIONS(4723),
    [anon_sym_RPAREN] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(4723),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym_DOLLAR] = ACTIONS(4723),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [anon_sym_AT] = ACTIONS(4723),
    [sym_bool] = ACTIONS(4721),
    [sym_byte] = ACTIONS(4721),
    [sym_ubyte] = ACTIONS(4721),
    [sym_char] = ACTIONS(4721),
    [sym_short] = ACTIONS(4721),
    [sym_ushort] = ACTIONS(4721),
    [sym_int] = ACTIONS(4721),
    [sym_uint] = ACTIONS(4721),
    [sym_long] = ACTIONS(4721),
    [sym_ulong] = ACTIONS(4721),
    [sym_cent] = ACTIONS(4721),
    [sym_ucent] = ACTIONS(4721),
    [sym_wchar] = ACTIONS(4721),
    [sym_dchar] = ACTIONS(4721),
    [sym_float] = ACTIONS(4721),
    [sym_double] = ACTIONS(4721),
    [sym_real] = ACTIONS(4721),
    [sym_ifloat] = ACTIONS(4721),
    [sym_idouble] = ACTIONS(4721),
    [sym_ireal] = ACTIONS(4721),
    [sym_cfloat] = ACTIONS(4721),
    [sym_cdouble] = ACTIONS(4721),
    [sym_creal] = ACTIONS(4721),
    [sym_size_t] = ACTIONS(4721),
    [sym_ptrdiff_t] = ACTIONS(4721),
    [sym_string] = ACTIONS(4721),
    [sym_cstring] = ACTIONS(4721),
    [sym_dstring] = ACTIONS(4721),
    [sym_wstring] = ACTIONS(4721),
    [sym_noreturn] = ACTIONS(4721),
    [sym_true] = ACTIONS(4721),
    [sym_false] = ACTIONS(4721),
    [sym_null] = ACTIONS(4721),
    [sym_super] = ACTIONS(4721),
    [sym_this] = ACTIONS(4721),
    [sym_abstract] = ACTIONS(4721),
    [sym_alias] = ACTIONS(4721),
    [sym_align] = ACTIONS(4721),
    [sym_asm] = ACTIONS(4721),
    [sym_assert] = ACTIONS(4721),
    [sym_auto] = ACTIONS(4721),
    [sym_break] = ACTIONS(4721),
    [sym_case] = ACTIONS(4721),
    [sym_cast] = ACTIONS(4721),
    [sym_catch] = ACTIONS(4721),
    [sym_class] = ACTIONS(4721),
    [sym_const] = ACTIONS(4721),
    [sym_continue] = ACTIONS(4721),
    [sym_debug] = ACTIONS(4721),
    [sym_default] = ACTIONS(4721),
    [sym_delegate] = ACTIONS(4721),
    [sym_delete] = ACTIONS(4721),
    [sym_deprecated] = ACTIONS(4721),
    [sym_do] = ACTIONS(4721),
    [sym_else] = ACTIONS(4721),
    [sym_enum] = ACTIONS(4721),
    [sym_export] = ACTIONS(4721),
    [sym_extern] = ACTIONS(4721),
    [sym_final] = ACTIONS(4721),
    [sym_finally] = ACTIONS(4721),
    [sym_for] = ACTIONS(4721),
    [sym_foreach] = ACTIONS(4721),
    [sym_foreach_reverse] = ACTIONS(4721),
    [sym_function] = ACTIONS(4721),
    [sym_goto] = ACTIONS(4721),
    [sym_if] = ACTIONS(4721),
    [sym_immutable] = ACTIONS(4721),
    [sym_import] = ACTIONS(4721),
    [sym_in] = ACTIONS(4721),
    [sym_inout] = ACTIONS(4721),
    [sym_interface] = ACTIONS(4721),
    [sym_invariant] = ACTIONS(4721),
    [sym_is] = ACTIONS(4721),
    [sym_mixin] = ACTIONS(4721),
    [sym_new] = ACTIONS(4721),
    [sym_nothrow] = ACTIONS(4721),
    [sym_out] = ACTIONS(4721),
    [sym_override] = ACTIONS(4721),
    [sym_package] = ACTIONS(4721),
    [sym_pragma] = ACTIONS(4721),
    [sym_private] = ACTIONS(4721),
    [sym_protected] = ACTIONS(4721),
    [sym_public] = ACTIONS(4721),
    [sym_pure] = ACTIONS(4721),
    [sym_ref] = ACTIONS(4721),
    [sym_return] = ACTIONS(4721),
    [sym_scope] = ACTIONS(4721),
    [sym_shared] = ACTIONS(4721),
    [sym_static] = ACTIONS(4721),
    [sym_struct] = ACTIONS(4721),
    [sym_switch] = ACTIONS(4721),
    [sym_synchronized] = ACTIONS(4721),
    [sym_template] = ACTIONS(4721),
    [sym_throw] = ACTIONS(4721),
    [sym_try] = ACTIONS(4721),
    [sym_typeid] = ACTIONS(4721),
    [sym_typeof] = ACTIONS(4721),
    [sym_union] = ACTIONS(4721),
    [sym_unittest] = ACTIONS(4721),
    [sym_version] = ACTIONS(4721),
    [sym_while] = ACTIONS(4721),
    [sym_with] = ACTIONS(4721),
    [sym_gshared] = ACTIONS(4721),
    [sym_traits] = ACTIONS(4721),
    [sym_vector] = ACTIONS(4721),
    [sym_void] = ACTIONS(4721),
    [anon_sym_BQUOTE] = ACTIONS(4723),
    [anon_sym_r_DQUOTE] = ACTIONS(4723),
    [anon_sym_x_DQUOTE] = ACTIONS(4723),
    [anon_sym_DQUOTE] = ACTIONS(4723),
    [anon_sym_i_BQUOTE] = ACTIONS(4723),
    [anon_sym_i_DQUOTE] = ACTIONS(4723),
    [anon_sym_iq_LBRACE] = ACTIONS(4723),
    [aux_sym_char_literal_token1] = ACTIONS(4723),
    [anon_sym_SQUOTE] = ACTIONS(4721),
    [anon_sym___DATE__] = ACTIONS(4721),
    [anon_sym___FILE__] = ACTIONS(4721),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4721),
    [anon_sym___FUNCTION__] = ACTIONS(4721),
    [anon_sym___LINE__] = ACTIONS(4721),
    [anon_sym___MODULE__] = ACTIONS(4721),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4721),
    [anon_sym___TIME__] = ACTIONS(4721),
    [anon_sym___TIMESTAMP__] = ACTIONS(4721),
    [anon_sym___VENDOR__] = ACTIONS(4721),
    [anon_sym___VERSION__] = ACTIONS(4721),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4723),
    [sym_float_literal] = ACTIONS(4723),
    [sym__string] = ACTIONS(4723),
  },
  [1435] = {
    [sym_identifier] = ACTIONS(4725),
    [anon_sym_q_LBRACE] = ACTIONS(4727),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4727),
    [anon_sym_DOT] = ACTIONS(4727),
    [anon_sym_AMP] = ACTIONS(4727),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_DASH_DASH] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4727),
    [anon_sym_BANG] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4727),
    [anon_sym_RPAREN] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(4727),
    [anon_sym_DOLLAR] = ACTIONS(4727),
    [anon_sym_STAR] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4727),
    [anon_sym_AT] = ACTIONS(4727),
    [sym_bool] = ACTIONS(4725),
    [sym_byte] = ACTIONS(4725),
    [sym_ubyte] = ACTIONS(4725),
    [sym_char] = ACTIONS(4725),
    [sym_short] = ACTIONS(4725),
    [sym_ushort] = ACTIONS(4725),
    [sym_int] = ACTIONS(4725),
    [sym_uint] = ACTIONS(4725),
    [sym_long] = ACTIONS(4725),
    [sym_ulong] = ACTIONS(4725),
    [sym_cent] = ACTIONS(4725),
    [sym_ucent] = ACTIONS(4725),
    [sym_wchar] = ACTIONS(4725),
    [sym_dchar] = ACTIONS(4725),
    [sym_float] = ACTIONS(4725),
    [sym_double] = ACTIONS(4725),
    [sym_real] = ACTIONS(4725),
    [sym_ifloat] = ACTIONS(4725),
    [sym_idouble] = ACTIONS(4725),
    [sym_ireal] = ACTIONS(4725),
    [sym_cfloat] = ACTIONS(4725),
    [sym_cdouble] = ACTIONS(4725),
    [sym_creal] = ACTIONS(4725),
    [sym_size_t] = ACTIONS(4725),
    [sym_ptrdiff_t] = ACTIONS(4725),
    [sym_string] = ACTIONS(4725),
    [sym_cstring] = ACTIONS(4725),
    [sym_dstring] = ACTIONS(4725),
    [sym_wstring] = ACTIONS(4725),
    [sym_noreturn] = ACTIONS(4725),
    [sym_true] = ACTIONS(4725),
    [sym_false] = ACTIONS(4725),
    [sym_null] = ACTIONS(4725),
    [sym_super] = ACTIONS(4725),
    [sym_this] = ACTIONS(4725),
    [sym_abstract] = ACTIONS(4725),
    [sym_alias] = ACTIONS(4725),
    [sym_align] = ACTIONS(4725),
    [sym_asm] = ACTIONS(4725),
    [sym_assert] = ACTIONS(4725),
    [sym_auto] = ACTIONS(4725),
    [sym_break] = ACTIONS(4725),
    [sym_case] = ACTIONS(4725),
    [sym_cast] = ACTIONS(4725),
    [sym_catch] = ACTIONS(4725),
    [sym_class] = ACTIONS(4725),
    [sym_const] = ACTIONS(4725),
    [sym_continue] = ACTIONS(4725),
    [sym_debug] = ACTIONS(4725),
    [sym_default] = ACTIONS(4725),
    [sym_delegate] = ACTIONS(4725),
    [sym_delete] = ACTIONS(4725),
    [sym_deprecated] = ACTIONS(4725),
    [sym_do] = ACTIONS(4725),
    [sym_else] = ACTIONS(4725),
    [sym_enum] = ACTIONS(4725),
    [sym_export] = ACTIONS(4725),
    [sym_extern] = ACTIONS(4725),
    [sym_final] = ACTIONS(4725),
    [sym_finally] = ACTIONS(4725),
    [sym_for] = ACTIONS(4725),
    [sym_foreach] = ACTIONS(4725),
    [sym_foreach_reverse] = ACTIONS(4725),
    [sym_function] = ACTIONS(4725),
    [sym_goto] = ACTIONS(4725),
    [sym_if] = ACTIONS(4725),
    [sym_immutable] = ACTIONS(4725),
    [sym_import] = ACTIONS(4725),
    [sym_in] = ACTIONS(4725),
    [sym_inout] = ACTIONS(4725),
    [sym_interface] = ACTIONS(4725),
    [sym_invariant] = ACTIONS(4725),
    [sym_is] = ACTIONS(4725),
    [sym_mixin] = ACTIONS(4725),
    [sym_new] = ACTIONS(4725),
    [sym_nothrow] = ACTIONS(4725),
    [sym_out] = ACTIONS(4725),
    [sym_override] = ACTIONS(4725),
    [sym_package] = ACTIONS(4725),
    [sym_pragma] = ACTIONS(4725),
    [sym_private] = ACTIONS(4725),
    [sym_protected] = ACTIONS(4725),
    [sym_public] = ACTIONS(4725),
    [sym_pure] = ACTIONS(4725),
    [sym_ref] = ACTIONS(4725),
    [sym_return] = ACTIONS(4725),
    [sym_scope] = ACTIONS(4725),
    [sym_shared] = ACTIONS(4725),
    [sym_static] = ACTIONS(4725),
    [sym_struct] = ACTIONS(4725),
    [sym_switch] = ACTIONS(4725),
    [sym_synchronized] = ACTIONS(4725),
    [sym_template] = ACTIONS(4725),
    [sym_throw] = ACTIONS(4725),
    [sym_try] = ACTIONS(4725),
    [sym_typeid] = ACTIONS(4725),
    [sym_typeof] = ACTIONS(4725),
    [sym_union] = ACTIONS(4725),
    [sym_unittest] = ACTIONS(4725),
    [sym_version] = ACTIONS(4725),
    [sym_while] = ACTIONS(4725),
    [sym_with] = ACTIONS(4725),
    [sym_gshared] = ACTIONS(4725),
    [sym_traits] = ACTIONS(4725),
    [sym_vector] = ACTIONS(4725),
    [sym_void] = ACTIONS(4725),
    [anon_sym_BQUOTE] = ACTIONS(4727),
    [anon_sym_r_DQUOTE] = ACTIONS(4727),
    [anon_sym_x_DQUOTE] = ACTIONS(4727),
    [anon_sym_DQUOTE] = ACTIONS(4727),
    [anon_sym_i_BQUOTE] = ACTIONS(4727),
    [anon_sym_i_DQUOTE] = ACTIONS(4727),
    [anon_sym_iq_LBRACE] = ACTIONS(4727),
    [aux_sym_char_literal_token1] = ACTIONS(4727),
    [anon_sym_SQUOTE] = ACTIONS(4725),
    [anon_sym___DATE__] = ACTIONS(4725),
    [anon_sym___FILE__] = ACTIONS(4725),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4725),
    [anon_sym___FUNCTION__] = ACTIONS(4725),
    [anon_sym___LINE__] = ACTIONS(4725),
    [anon_sym___MODULE__] = ACTIONS(4725),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4725),
    [anon_sym___TIME__] = ACTIONS(4725),
    [anon_sym___TIMESTAMP__] = ACTIONS(4725),
    [anon_sym___VENDOR__] = ACTIONS(4725),
    [anon_sym___VERSION__] = ACTIONS(4725),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4727),
    [sym_float_literal] = ACTIONS(4727),
    [sym__string] = ACTIONS(4727),
  },
  [1436] = {
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [sym_bool] = ACTIONS(2638),
    [sym_byte] = ACTIONS(2638),
    [sym_ubyte] = ACTIONS(2638),
    [sym_char] = ACTIONS(2638),
    [sym_short] = ACTIONS(2638),
    [sym_ushort] = ACTIONS(2638),
    [sym_int] = ACTIONS(2638),
    [sym_uint] = ACTIONS(2638),
    [sym_long] = ACTIONS(2638),
    [sym_ulong] = ACTIONS(2638),
    [sym_cent] = ACTIONS(2638),
    [sym_ucent] = ACTIONS(2638),
    [sym_wchar] = ACTIONS(2638),
    [sym_dchar] = ACTIONS(2638),
    [sym_float] = ACTIONS(2638),
    [sym_double] = ACTIONS(2638),
    [sym_real] = ACTIONS(2638),
    [sym_ifloat] = ACTIONS(2638),
    [sym_idouble] = ACTIONS(2638),
    [sym_ireal] = ACTIONS(2638),
    [sym_cfloat] = ACTIONS(2638),
    [sym_cdouble] = ACTIONS(2638),
    [sym_creal] = ACTIONS(2638),
    [sym_size_t] = ACTIONS(2638),
    [sym_ptrdiff_t] = ACTIONS(2638),
    [sym_string] = ACTIONS(2638),
    [sym_cstring] = ACTIONS(2638),
    [sym_dstring] = ACTIONS(2638),
    [sym_wstring] = ACTIONS(2638),
    [sym_noreturn] = ACTIONS(2638),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2638),
    [sym_abstract] = ACTIONS(2638),
    [sym_alias] = ACTIONS(2638),
    [sym_align] = ACTIONS(2638),
    [sym_asm] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(2638),
    [sym_break] = ACTIONS(2638),
    [sym_case] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_catch] = ACTIONS(2638),
    [sym_class] = ACTIONS(2638),
    [sym_const] = ACTIONS(2638),
    [sym_continue] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2638),
    [sym_default] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(2638),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(2638),
    [sym_export] = ACTIONS(2638),
    [sym_extern] = ACTIONS(2638),
    [sym_final] = ACTIONS(2638),
    [sym_finally] = ACTIONS(2638),
    [sym_for] = ACTIONS(2638),
    [sym_foreach] = ACTIONS(2638),
    [sym_foreach_reverse] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_goto] = ACTIONS(2638),
    [sym_if] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(2638),
    [sym_import] = ACTIONS(2638),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(2638),
    [sym_interface] = ACTIONS(2638),
    [sym_invariant] = ACTIONS(2638),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2638),
    [sym_new] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(2638),
    [sym_out] = ACTIONS(2638),
    [sym_override] = ACTIONS(2638),
    [sym_package] = ACTIONS(2638),
    [sym_pragma] = ACTIONS(2638),
    [sym_private] = ACTIONS(2638),
    [sym_protected] = ACTIONS(2638),
    [sym_public] = ACTIONS(2638),
    [sym_pure] = ACTIONS(2638),
    [sym_ref] = ACTIONS(2638),
    [sym_return] = ACTIONS(2638),
    [sym_scope] = ACTIONS(2638),
    [sym_shared] = ACTIONS(2638),
    [sym_static] = ACTIONS(2638),
    [sym_struct] = ACTIONS(2638),
    [sym_switch] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(2638),
    [sym_template] = ACTIONS(2638),
    [sym_throw] = ACTIONS(2638),
    [sym_try] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(2638),
    [sym_union] = ACTIONS(2638),
    [sym_unittest] = ACTIONS(2638),
    [sym_version] = ACTIONS(2638),
    [sym_while] = ACTIONS(2638),
    [sym_with] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(2638),
    [sym_traits] = ACTIONS(2638),
    [sym_vector] = ACTIONS(2638),
    [sym_void] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [1437] = {
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_q_LBRACE] = ACTIONS(4731),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4731),
    [anon_sym_DOT] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_DASH] = ACTIONS(4729),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4729),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_BANG] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(4731),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [anon_sym_AT] = ACTIONS(4731),
    [sym_bool] = ACTIONS(4729),
    [sym_byte] = ACTIONS(4729),
    [sym_ubyte] = ACTIONS(4729),
    [sym_char] = ACTIONS(4729),
    [sym_short] = ACTIONS(4729),
    [sym_ushort] = ACTIONS(4729),
    [sym_int] = ACTIONS(4729),
    [sym_uint] = ACTIONS(4729),
    [sym_long] = ACTIONS(4729),
    [sym_ulong] = ACTIONS(4729),
    [sym_cent] = ACTIONS(4729),
    [sym_ucent] = ACTIONS(4729),
    [sym_wchar] = ACTIONS(4729),
    [sym_dchar] = ACTIONS(4729),
    [sym_float] = ACTIONS(4729),
    [sym_double] = ACTIONS(4729),
    [sym_real] = ACTIONS(4729),
    [sym_ifloat] = ACTIONS(4729),
    [sym_idouble] = ACTIONS(4729),
    [sym_ireal] = ACTIONS(4729),
    [sym_cfloat] = ACTIONS(4729),
    [sym_cdouble] = ACTIONS(4729),
    [sym_creal] = ACTIONS(4729),
    [sym_size_t] = ACTIONS(4729),
    [sym_ptrdiff_t] = ACTIONS(4729),
    [sym_string] = ACTIONS(4729),
    [sym_cstring] = ACTIONS(4729),
    [sym_dstring] = ACTIONS(4729),
    [sym_wstring] = ACTIONS(4729),
    [sym_noreturn] = ACTIONS(4729),
    [sym_true] = ACTIONS(4729),
    [sym_false] = ACTIONS(4729),
    [sym_null] = ACTIONS(4729),
    [sym_super] = ACTIONS(4729),
    [sym_this] = ACTIONS(4729),
    [sym_abstract] = ACTIONS(4729),
    [sym_alias] = ACTIONS(4729),
    [sym_align] = ACTIONS(4729),
    [sym_asm] = ACTIONS(4729),
    [sym_assert] = ACTIONS(4729),
    [sym_auto] = ACTIONS(4729),
    [sym_break] = ACTIONS(4729),
    [sym_case] = ACTIONS(4729),
    [sym_cast] = ACTIONS(4729),
    [sym_catch] = ACTIONS(4729),
    [sym_class] = ACTIONS(4729),
    [sym_const] = ACTIONS(4729),
    [sym_continue] = ACTIONS(4729),
    [sym_debug] = ACTIONS(4729),
    [sym_default] = ACTIONS(4729),
    [sym_delegate] = ACTIONS(4729),
    [sym_delete] = ACTIONS(4729),
    [sym_deprecated] = ACTIONS(4729),
    [sym_do] = ACTIONS(4729),
    [sym_else] = ACTIONS(4729),
    [sym_enum] = ACTIONS(4729),
    [sym_export] = ACTIONS(4729),
    [sym_extern] = ACTIONS(4729),
    [sym_final] = ACTIONS(4729),
    [sym_finally] = ACTIONS(4729),
    [sym_for] = ACTIONS(4729),
    [sym_foreach] = ACTIONS(4729),
    [sym_foreach_reverse] = ACTIONS(4729),
    [sym_function] = ACTIONS(4729),
    [sym_goto] = ACTIONS(4729),
    [sym_if] = ACTIONS(4729),
    [sym_immutable] = ACTIONS(4729),
    [sym_import] = ACTIONS(4729),
    [sym_in] = ACTIONS(4729),
    [sym_inout] = ACTIONS(4729),
    [sym_interface] = ACTIONS(4729),
    [sym_invariant] = ACTIONS(4729),
    [sym_is] = ACTIONS(4729),
    [sym_mixin] = ACTIONS(4729),
    [sym_new] = ACTIONS(4729),
    [sym_nothrow] = ACTIONS(4729),
    [sym_out] = ACTIONS(4729),
    [sym_override] = ACTIONS(4729),
    [sym_package] = ACTIONS(4729),
    [sym_pragma] = ACTIONS(4729),
    [sym_private] = ACTIONS(4729),
    [sym_protected] = ACTIONS(4729),
    [sym_public] = ACTIONS(4729),
    [sym_pure] = ACTIONS(4729),
    [sym_ref] = ACTIONS(4729),
    [sym_return] = ACTIONS(4729),
    [sym_scope] = ACTIONS(4729),
    [sym_shared] = ACTIONS(4729),
    [sym_static] = ACTIONS(4729),
    [sym_struct] = ACTIONS(4729),
    [sym_switch] = ACTIONS(4729),
    [sym_synchronized] = ACTIONS(4729),
    [sym_template] = ACTIONS(4729),
    [sym_throw] = ACTIONS(4729),
    [sym_try] = ACTIONS(4729),
    [sym_typeid] = ACTIONS(4729),
    [sym_typeof] = ACTIONS(4729),
    [sym_union] = ACTIONS(4729),
    [sym_unittest] = ACTIONS(4729),
    [sym_version] = ACTIONS(4729),
    [sym_while] = ACTIONS(4729),
    [sym_with] = ACTIONS(4729),
    [sym_gshared] = ACTIONS(4729),
    [sym_traits] = ACTIONS(4729),
    [sym_vector] = ACTIONS(4729),
    [sym_void] = ACTIONS(4729),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_r_DQUOTE] = ACTIONS(4731),
    [anon_sym_x_DQUOTE] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_i_BQUOTE] = ACTIONS(4731),
    [anon_sym_i_DQUOTE] = ACTIONS(4731),
    [anon_sym_iq_LBRACE] = ACTIONS(4731),
    [aux_sym_char_literal_token1] = ACTIONS(4731),
    [anon_sym_SQUOTE] = ACTIONS(4729),
    [anon_sym___DATE__] = ACTIONS(4729),
    [anon_sym___FILE__] = ACTIONS(4729),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4729),
    [anon_sym___FUNCTION__] = ACTIONS(4729),
    [anon_sym___LINE__] = ACTIONS(4729),
    [anon_sym___MODULE__] = ACTIONS(4729),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4729),
    [anon_sym___TIME__] = ACTIONS(4729),
    [anon_sym___TIMESTAMP__] = ACTIONS(4729),
    [anon_sym___VENDOR__] = ACTIONS(4729),
    [anon_sym___VERSION__] = ACTIONS(4729),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4731),
    [sym_float_literal] = ACTIONS(4731),
    [sym__string] = ACTIONS(4731),
  },
  [1438] = {
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_q_LBRACE] = ACTIONS(4735),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_DOT] = ACTIONS(4735),
    [anon_sym_AMP] = ACTIONS(4735),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(4735),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_PLUS_PLUS] = ACTIONS(4735),
    [anon_sym_BANG] = ACTIONS(4735),
    [anon_sym_LPAREN] = ACTIONS(4735),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4735),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_DOLLAR] = ACTIONS(4735),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [anon_sym_AT] = ACTIONS(4735),
    [sym_bool] = ACTIONS(4733),
    [sym_byte] = ACTIONS(4733),
    [sym_ubyte] = ACTIONS(4733),
    [sym_char] = ACTIONS(4733),
    [sym_short] = ACTIONS(4733),
    [sym_ushort] = ACTIONS(4733),
    [sym_int] = ACTIONS(4733),
    [sym_uint] = ACTIONS(4733),
    [sym_long] = ACTIONS(4733),
    [sym_ulong] = ACTIONS(4733),
    [sym_cent] = ACTIONS(4733),
    [sym_ucent] = ACTIONS(4733),
    [sym_wchar] = ACTIONS(4733),
    [sym_dchar] = ACTIONS(4733),
    [sym_float] = ACTIONS(4733),
    [sym_double] = ACTIONS(4733),
    [sym_real] = ACTIONS(4733),
    [sym_ifloat] = ACTIONS(4733),
    [sym_idouble] = ACTIONS(4733),
    [sym_ireal] = ACTIONS(4733),
    [sym_cfloat] = ACTIONS(4733),
    [sym_cdouble] = ACTIONS(4733),
    [sym_creal] = ACTIONS(4733),
    [sym_size_t] = ACTIONS(4733),
    [sym_ptrdiff_t] = ACTIONS(4733),
    [sym_string] = ACTIONS(4733),
    [sym_cstring] = ACTIONS(4733),
    [sym_dstring] = ACTIONS(4733),
    [sym_wstring] = ACTIONS(4733),
    [sym_noreturn] = ACTIONS(4733),
    [sym_true] = ACTIONS(4733),
    [sym_false] = ACTIONS(4733),
    [sym_null] = ACTIONS(4733),
    [sym_super] = ACTIONS(4733),
    [sym_this] = ACTIONS(4733),
    [sym_abstract] = ACTIONS(4733),
    [sym_alias] = ACTIONS(4733),
    [sym_align] = ACTIONS(4733),
    [sym_asm] = ACTIONS(4733),
    [sym_assert] = ACTIONS(4733),
    [sym_auto] = ACTIONS(4733),
    [sym_break] = ACTIONS(4733),
    [sym_case] = ACTIONS(4733),
    [sym_cast] = ACTIONS(4733),
    [sym_catch] = ACTIONS(4733),
    [sym_class] = ACTIONS(4733),
    [sym_const] = ACTIONS(4733),
    [sym_continue] = ACTIONS(4733),
    [sym_debug] = ACTIONS(4733),
    [sym_default] = ACTIONS(4733),
    [sym_delegate] = ACTIONS(4733),
    [sym_delete] = ACTIONS(4733),
    [sym_deprecated] = ACTIONS(4733),
    [sym_do] = ACTIONS(4733),
    [sym_else] = ACTIONS(4733),
    [sym_enum] = ACTIONS(4733),
    [sym_export] = ACTIONS(4733),
    [sym_extern] = ACTIONS(4733),
    [sym_final] = ACTIONS(4733),
    [sym_finally] = ACTIONS(4733),
    [sym_for] = ACTIONS(4733),
    [sym_foreach] = ACTIONS(4733),
    [sym_foreach_reverse] = ACTIONS(4733),
    [sym_function] = ACTIONS(4733),
    [sym_goto] = ACTIONS(4733),
    [sym_if] = ACTIONS(4733),
    [sym_immutable] = ACTIONS(4733),
    [sym_import] = ACTIONS(4733),
    [sym_in] = ACTIONS(4733),
    [sym_inout] = ACTIONS(4733),
    [sym_interface] = ACTIONS(4733),
    [sym_invariant] = ACTIONS(4733),
    [sym_is] = ACTIONS(4733),
    [sym_mixin] = ACTIONS(4733),
    [sym_new] = ACTIONS(4733),
    [sym_nothrow] = ACTIONS(4733),
    [sym_out] = ACTIONS(4733),
    [sym_override] = ACTIONS(4733),
    [sym_package] = ACTIONS(4733),
    [sym_pragma] = ACTIONS(4733),
    [sym_private] = ACTIONS(4733),
    [sym_protected] = ACTIONS(4733),
    [sym_public] = ACTIONS(4733),
    [sym_pure] = ACTIONS(4733),
    [sym_ref] = ACTIONS(4733),
    [sym_return] = ACTIONS(4733),
    [sym_scope] = ACTIONS(4733),
    [sym_shared] = ACTIONS(4733),
    [sym_static] = ACTIONS(4733),
    [sym_struct] = ACTIONS(4733),
    [sym_switch] = ACTIONS(4733),
    [sym_synchronized] = ACTIONS(4733),
    [sym_template] = ACTIONS(4733),
    [sym_throw] = ACTIONS(4733),
    [sym_try] = ACTIONS(4733),
    [sym_typeid] = ACTIONS(4733),
    [sym_typeof] = ACTIONS(4733),
    [sym_union] = ACTIONS(4733),
    [sym_unittest] = ACTIONS(4733),
    [sym_version] = ACTIONS(4733),
    [sym_while] = ACTIONS(4733),
    [sym_with] = ACTIONS(4733),
    [sym_gshared] = ACTIONS(4733),
    [sym_traits] = ACTIONS(4733),
    [sym_vector] = ACTIONS(4733),
    [sym_void] = ACTIONS(4733),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [anon_sym_r_DQUOTE] = ACTIONS(4735),
    [anon_sym_x_DQUOTE] = ACTIONS(4735),
    [anon_sym_DQUOTE] = ACTIONS(4735),
    [anon_sym_i_BQUOTE] = ACTIONS(4735),
    [anon_sym_i_DQUOTE] = ACTIONS(4735),
    [anon_sym_iq_LBRACE] = ACTIONS(4735),
    [aux_sym_char_literal_token1] = ACTIONS(4735),
    [anon_sym_SQUOTE] = ACTIONS(4733),
    [anon_sym___DATE__] = ACTIONS(4733),
    [anon_sym___FILE__] = ACTIONS(4733),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4733),
    [anon_sym___FUNCTION__] = ACTIONS(4733),
    [anon_sym___LINE__] = ACTIONS(4733),
    [anon_sym___MODULE__] = ACTIONS(4733),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4733),
    [anon_sym___TIME__] = ACTIONS(4733),
    [anon_sym___TIMESTAMP__] = ACTIONS(4733),
    [anon_sym___VENDOR__] = ACTIONS(4733),
    [anon_sym___VERSION__] = ACTIONS(4733),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4735),
    [sym_float_literal] = ACTIONS(4735),
    [sym__string] = ACTIONS(4735),
  },
  [1439] = {
    [sym_identifier] = ACTIONS(4737),
    [anon_sym_q_LBRACE] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LBRACE] = ACTIONS(4739),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_AMP] = ACTIONS(4739),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_DASH_DASH] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4737),
    [anon_sym_PLUS_PLUS] = ACTIONS(4739),
    [anon_sym_BANG] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(4739),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_DOLLAR] = ACTIONS(4739),
    [anon_sym_STAR] = ACTIONS(4739),
    [anon_sym_TILDE] = ACTIONS(4739),
    [anon_sym_AT] = ACTIONS(4739),
    [sym_bool] = ACTIONS(4737),
    [sym_byte] = ACTIONS(4737),
    [sym_ubyte] = ACTIONS(4737),
    [sym_char] = ACTIONS(4737),
    [sym_short] = ACTIONS(4737),
    [sym_ushort] = ACTIONS(4737),
    [sym_int] = ACTIONS(4737),
    [sym_uint] = ACTIONS(4737),
    [sym_long] = ACTIONS(4737),
    [sym_ulong] = ACTIONS(4737),
    [sym_cent] = ACTIONS(4737),
    [sym_ucent] = ACTIONS(4737),
    [sym_wchar] = ACTIONS(4737),
    [sym_dchar] = ACTIONS(4737),
    [sym_float] = ACTIONS(4737),
    [sym_double] = ACTIONS(4737),
    [sym_real] = ACTIONS(4737),
    [sym_ifloat] = ACTIONS(4737),
    [sym_idouble] = ACTIONS(4737),
    [sym_ireal] = ACTIONS(4737),
    [sym_cfloat] = ACTIONS(4737),
    [sym_cdouble] = ACTIONS(4737),
    [sym_creal] = ACTIONS(4737),
    [sym_size_t] = ACTIONS(4737),
    [sym_ptrdiff_t] = ACTIONS(4737),
    [sym_string] = ACTIONS(4737),
    [sym_cstring] = ACTIONS(4737),
    [sym_dstring] = ACTIONS(4737),
    [sym_wstring] = ACTIONS(4737),
    [sym_noreturn] = ACTIONS(4737),
    [sym_true] = ACTIONS(4737),
    [sym_false] = ACTIONS(4737),
    [sym_null] = ACTIONS(4737),
    [sym_super] = ACTIONS(4737),
    [sym_this] = ACTIONS(4737),
    [sym_abstract] = ACTIONS(4737),
    [sym_alias] = ACTIONS(4737),
    [sym_align] = ACTIONS(4737),
    [sym_asm] = ACTIONS(4737),
    [sym_assert] = ACTIONS(4737),
    [sym_auto] = ACTIONS(4737),
    [sym_break] = ACTIONS(4737),
    [sym_case] = ACTIONS(4737),
    [sym_cast] = ACTIONS(4737),
    [sym_catch] = ACTIONS(4737),
    [sym_class] = ACTIONS(4737),
    [sym_const] = ACTIONS(4737),
    [sym_continue] = ACTIONS(4737),
    [sym_debug] = ACTIONS(4737),
    [sym_default] = ACTIONS(4737),
    [sym_delegate] = ACTIONS(4737),
    [sym_delete] = ACTIONS(4737),
    [sym_deprecated] = ACTIONS(4737),
    [sym_do] = ACTIONS(4737),
    [sym_else] = ACTIONS(4737),
    [sym_enum] = ACTIONS(4737),
    [sym_export] = ACTIONS(4737),
    [sym_extern] = ACTIONS(4737),
    [sym_final] = ACTIONS(4737),
    [sym_finally] = ACTIONS(4737),
    [sym_for] = ACTIONS(4737),
    [sym_foreach] = ACTIONS(4737),
    [sym_foreach_reverse] = ACTIONS(4737),
    [sym_function] = ACTIONS(4737),
    [sym_goto] = ACTIONS(4737),
    [sym_if] = ACTIONS(4737),
    [sym_immutable] = ACTIONS(4737),
    [sym_import] = ACTIONS(4737),
    [sym_in] = ACTIONS(4737),
    [sym_inout] = ACTIONS(4737),
    [sym_interface] = ACTIONS(4737),
    [sym_invariant] = ACTIONS(4737),
    [sym_is] = ACTIONS(4737),
    [sym_mixin] = ACTIONS(4737),
    [sym_new] = ACTIONS(4737),
    [sym_nothrow] = ACTIONS(4737),
    [sym_out] = ACTIONS(4737),
    [sym_override] = ACTIONS(4737),
    [sym_package] = ACTIONS(4737),
    [sym_pragma] = ACTIONS(4737),
    [sym_private] = ACTIONS(4737),
    [sym_protected] = ACTIONS(4737),
    [sym_public] = ACTIONS(4737),
    [sym_pure] = ACTIONS(4737),
    [sym_ref] = ACTIONS(4737),
    [sym_return] = ACTIONS(4737),
    [sym_scope] = ACTIONS(4737),
    [sym_shared] = ACTIONS(4737),
    [sym_static] = ACTIONS(4737),
    [sym_struct] = ACTIONS(4737),
    [sym_switch] = ACTIONS(4737),
    [sym_synchronized] = ACTIONS(4737),
    [sym_template] = ACTIONS(4737),
    [sym_throw] = ACTIONS(4737),
    [sym_try] = ACTIONS(4737),
    [sym_typeid] = ACTIONS(4737),
    [sym_typeof] = ACTIONS(4737),
    [sym_union] = ACTIONS(4737),
    [sym_unittest] = ACTIONS(4737),
    [sym_version] = ACTIONS(4737),
    [sym_while] = ACTIONS(4737),
    [sym_with] = ACTIONS(4737),
    [sym_gshared] = ACTIONS(4737),
    [sym_traits] = ACTIONS(4737),
    [sym_vector] = ACTIONS(4737),
    [sym_void] = ACTIONS(4737),
    [anon_sym_BQUOTE] = ACTIONS(4739),
    [anon_sym_r_DQUOTE] = ACTIONS(4739),
    [anon_sym_x_DQUOTE] = ACTIONS(4739),
    [anon_sym_DQUOTE] = ACTIONS(4739),
    [anon_sym_i_BQUOTE] = ACTIONS(4739),
    [anon_sym_i_DQUOTE] = ACTIONS(4739),
    [anon_sym_iq_LBRACE] = ACTIONS(4739),
    [aux_sym_char_literal_token1] = ACTIONS(4739),
    [anon_sym_SQUOTE] = ACTIONS(4737),
    [anon_sym___DATE__] = ACTIONS(4737),
    [anon_sym___FILE__] = ACTIONS(4737),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4737),
    [anon_sym___FUNCTION__] = ACTIONS(4737),
    [anon_sym___LINE__] = ACTIONS(4737),
    [anon_sym___MODULE__] = ACTIONS(4737),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4737),
    [anon_sym___TIME__] = ACTIONS(4737),
    [anon_sym___TIMESTAMP__] = ACTIONS(4737),
    [anon_sym___VENDOR__] = ACTIONS(4737),
    [anon_sym___VERSION__] = ACTIONS(4737),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4739),
    [sym_float_literal] = ACTIONS(4739),
    [sym__string] = ACTIONS(4739),
  },
  [1440] = {
    [sym_identifier] = ACTIONS(4741),
    [anon_sym_q_LBRACE] = ACTIONS(4743),
    [anon_sym_RBRACE] = ACTIONS(4743),
    [anon_sym_LBRACE] = ACTIONS(4743),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4743),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4743),
    [anon_sym_PLUS] = ACTIONS(4741),
    [anon_sym_PLUS_PLUS] = ACTIONS(4743),
    [anon_sym_BANG] = ACTIONS(4743),
    [anon_sym_LPAREN] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [anon_sym_STAR] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [anon_sym_AT] = ACTIONS(4743),
    [sym_bool] = ACTIONS(4741),
    [sym_byte] = ACTIONS(4741),
    [sym_ubyte] = ACTIONS(4741),
    [sym_char] = ACTIONS(4741),
    [sym_short] = ACTIONS(4741),
    [sym_ushort] = ACTIONS(4741),
    [sym_int] = ACTIONS(4741),
    [sym_uint] = ACTIONS(4741),
    [sym_long] = ACTIONS(4741),
    [sym_ulong] = ACTIONS(4741),
    [sym_cent] = ACTIONS(4741),
    [sym_ucent] = ACTIONS(4741),
    [sym_wchar] = ACTIONS(4741),
    [sym_dchar] = ACTIONS(4741),
    [sym_float] = ACTIONS(4741),
    [sym_double] = ACTIONS(4741),
    [sym_real] = ACTIONS(4741),
    [sym_ifloat] = ACTIONS(4741),
    [sym_idouble] = ACTIONS(4741),
    [sym_ireal] = ACTIONS(4741),
    [sym_cfloat] = ACTIONS(4741),
    [sym_cdouble] = ACTIONS(4741),
    [sym_creal] = ACTIONS(4741),
    [sym_size_t] = ACTIONS(4741),
    [sym_ptrdiff_t] = ACTIONS(4741),
    [sym_string] = ACTIONS(4741),
    [sym_cstring] = ACTIONS(4741),
    [sym_dstring] = ACTIONS(4741),
    [sym_wstring] = ACTIONS(4741),
    [sym_noreturn] = ACTIONS(4741),
    [sym_true] = ACTIONS(4741),
    [sym_false] = ACTIONS(4741),
    [sym_null] = ACTIONS(4741),
    [sym_super] = ACTIONS(4741),
    [sym_this] = ACTIONS(4741),
    [sym_abstract] = ACTIONS(4741),
    [sym_alias] = ACTIONS(4741),
    [sym_align] = ACTIONS(4741),
    [sym_asm] = ACTIONS(4741),
    [sym_assert] = ACTIONS(4741),
    [sym_auto] = ACTIONS(4741),
    [sym_break] = ACTIONS(4741),
    [sym_case] = ACTIONS(4741),
    [sym_cast] = ACTIONS(4741),
    [sym_catch] = ACTIONS(4741),
    [sym_class] = ACTIONS(4741),
    [sym_const] = ACTIONS(4741),
    [sym_continue] = ACTIONS(4741),
    [sym_debug] = ACTIONS(4741),
    [sym_default] = ACTIONS(4741),
    [sym_delegate] = ACTIONS(4741),
    [sym_delete] = ACTIONS(4741),
    [sym_deprecated] = ACTIONS(4741),
    [sym_do] = ACTIONS(4741),
    [sym_else] = ACTIONS(4745),
    [sym_enum] = ACTIONS(4741),
    [sym_export] = ACTIONS(4741),
    [sym_extern] = ACTIONS(4741),
    [sym_final] = ACTIONS(4741),
    [sym_finally] = ACTIONS(4741),
    [sym_for] = ACTIONS(4741),
    [sym_foreach] = ACTIONS(4741),
    [sym_foreach_reverse] = ACTIONS(4741),
    [sym_function] = ACTIONS(4741),
    [sym_goto] = ACTIONS(4741),
    [sym_if] = ACTIONS(4741),
    [sym_immutable] = ACTIONS(4741),
    [sym_import] = ACTIONS(4741),
    [sym_in] = ACTIONS(4741),
    [sym_inout] = ACTIONS(4741),
    [sym_interface] = ACTIONS(4741),
    [sym_invariant] = ACTIONS(4741),
    [sym_is] = ACTIONS(4741),
    [sym_mixin] = ACTIONS(4741),
    [sym_new] = ACTIONS(4741),
    [sym_nothrow] = ACTIONS(4741),
    [sym_out] = ACTIONS(4741),
    [sym_override] = ACTIONS(4741),
    [sym_package] = ACTIONS(4741),
    [sym_pragma] = ACTIONS(4741),
    [sym_private] = ACTIONS(4741),
    [sym_protected] = ACTIONS(4741),
    [sym_public] = ACTIONS(4741),
    [sym_pure] = ACTIONS(4741),
    [sym_ref] = ACTIONS(4741),
    [sym_return] = ACTIONS(4741),
    [sym_scope] = ACTIONS(4741),
    [sym_shared] = ACTIONS(4741),
    [sym_static] = ACTIONS(4741),
    [sym_struct] = ACTIONS(4741),
    [sym_switch] = ACTIONS(4741),
    [sym_synchronized] = ACTIONS(4741),
    [sym_template] = ACTIONS(4741),
    [sym_throw] = ACTIONS(4741),
    [sym_try] = ACTIONS(4741),
    [sym_typeid] = ACTIONS(4741),
    [sym_typeof] = ACTIONS(4741),
    [sym_union] = ACTIONS(4741),
    [sym_unittest] = ACTIONS(4741),
    [sym_version] = ACTIONS(4741),
    [sym_while] = ACTIONS(4741),
    [sym_with] = ACTIONS(4741),
    [sym_gshared] = ACTIONS(4741),
    [sym_traits] = ACTIONS(4741),
    [sym_vector] = ACTIONS(4741),
    [sym_void] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_r_DQUOTE] = ACTIONS(4743),
    [anon_sym_x_DQUOTE] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_i_BQUOTE] = ACTIONS(4743),
    [anon_sym_i_DQUOTE] = ACTIONS(4743),
    [anon_sym_iq_LBRACE] = ACTIONS(4743),
    [aux_sym_char_literal_token1] = ACTIONS(4743),
    [anon_sym_SQUOTE] = ACTIONS(4741),
    [anon_sym___DATE__] = ACTIONS(4741),
    [anon_sym___FILE__] = ACTIONS(4741),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4741),
    [anon_sym___FUNCTION__] = ACTIONS(4741),
    [anon_sym___LINE__] = ACTIONS(4741),
    [anon_sym___MODULE__] = ACTIONS(4741),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4741),
    [anon_sym___TIME__] = ACTIONS(4741),
    [anon_sym___TIMESTAMP__] = ACTIONS(4741),
    [anon_sym___VENDOR__] = ACTIONS(4741),
    [anon_sym___VERSION__] = ACTIONS(4741),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4743),
    [sym_float_literal] = ACTIONS(4743),
    [sym__string] = ACTIONS(4743),
  },
  [1441] = {
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_q_LBRACE] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_LBRACE] = ACTIONS(4749),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4749),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_DASH_DASH] = ACTIONS(4749),
    [anon_sym_PLUS] = ACTIONS(4747),
    [anon_sym_PLUS_PLUS] = ACTIONS(4749),
    [anon_sym_BANG] = ACTIONS(4749),
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4749),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4749),
    [anon_sym_STAR] = ACTIONS(4749),
    [anon_sym_TILDE] = ACTIONS(4749),
    [anon_sym_AT] = ACTIONS(4749),
    [sym_bool] = ACTIONS(4747),
    [sym_byte] = ACTIONS(4747),
    [sym_ubyte] = ACTIONS(4747),
    [sym_char] = ACTIONS(4747),
    [sym_short] = ACTIONS(4747),
    [sym_ushort] = ACTIONS(4747),
    [sym_int] = ACTIONS(4747),
    [sym_uint] = ACTIONS(4747),
    [sym_long] = ACTIONS(4747),
    [sym_ulong] = ACTIONS(4747),
    [sym_cent] = ACTIONS(4747),
    [sym_ucent] = ACTIONS(4747),
    [sym_wchar] = ACTIONS(4747),
    [sym_dchar] = ACTIONS(4747),
    [sym_float] = ACTIONS(4747),
    [sym_double] = ACTIONS(4747),
    [sym_real] = ACTIONS(4747),
    [sym_ifloat] = ACTIONS(4747),
    [sym_idouble] = ACTIONS(4747),
    [sym_ireal] = ACTIONS(4747),
    [sym_cfloat] = ACTIONS(4747),
    [sym_cdouble] = ACTIONS(4747),
    [sym_creal] = ACTIONS(4747),
    [sym_size_t] = ACTIONS(4747),
    [sym_ptrdiff_t] = ACTIONS(4747),
    [sym_string] = ACTIONS(4747),
    [sym_cstring] = ACTIONS(4747),
    [sym_dstring] = ACTIONS(4747),
    [sym_wstring] = ACTIONS(4747),
    [sym_noreturn] = ACTIONS(4747),
    [sym_true] = ACTIONS(4747),
    [sym_false] = ACTIONS(4747),
    [sym_null] = ACTIONS(4747),
    [sym_super] = ACTIONS(4747),
    [sym_this] = ACTIONS(4747),
    [sym_abstract] = ACTIONS(4747),
    [sym_alias] = ACTIONS(4747),
    [sym_align] = ACTIONS(4747),
    [sym_asm] = ACTIONS(4747),
    [sym_assert] = ACTIONS(4747),
    [sym_auto] = ACTIONS(4747),
    [sym_break] = ACTIONS(4747),
    [sym_case] = ACTIONS(4747),
    [sym_cast] = ACTIONS(4747),
    [sym_catch] = ACTIONS(4747),
    [sym_class] = ACTIONS(4747),
    [sym_const] = ACTIONS(4747),
    [sym_continue] = ACTIONS(4747),
    [sym_debug] = ACTIONS(4747),
    [sym_default] = ACTIONS(4747),
    [sym_delegate] = ACTIONS(4747),
    [sym_delete] = ACTIONS(4747),
    [sym_deprecated] = ACTIONS(4747),
    [sym_do] = ACTIONS(4747),
    [sym_else] = ACTIONS(4747),
    [sym_enum] = ACTIONS(4747),
    [sym_export] = ACTIONS(4747),
    [sym_extern] = ACTIONS(4747),
    [sym_final] = ACTIONS(4747),
    [sym_finally] = ACTIONS(4747),
    [sym_for] = ACTIONS(4747),
    [sym_foreach] = ACTIONS(4747),
    [sym_foreach_reverse] = ACTIONS(4747),
    [sym_function] = ACTIONS(4747),
    [sym_goto] = ACTIONS(4747),
    [sym_if] = ACTIONS(4747),
    [sym_immutable] = ACTIONS(4747),
    [sym_import] = ACTIONS(4747),
    [sym_in] = ACTIONS(4747),
    [sym_inout] = ACTIONS(4747),
    [sym_interface] = ACTIONS(4747),
    [sym_invariant] = ACTIONS(4747),
    [sym_is] = ACTIONS(4747),
    [sym_mixin] = ACTIONS(4747),
    [sym_new] = ACTIONS(4747),
    [sym_nothrow] = ACTIONS(4747),
    [sym_out] = ACTIONS(4747),
    [sym_override] = ACTIONS(4747),
    [sym_package] = ACTIONS(4747),
    [sym_pragma] = ACTIONS(4747),
    [sym_private] = ACTIONS(4747),
    [sym_protected] = ACTIONS(4747),
    [sym_public] = ACTIONS(4747),
    [sym_pure] = ACTIONS(4747),
    [sym_ref] = ACTIONS(4747),
    [sym_return] = ACTIONS(4747),
    [sym_scope] = ACTIONS(4747),
    [sym_shared] = ACTIONS(4747),
    [sym_static] = ACTIONS(4747),
    [sym_struct] = ACTIONS(4747),
    [sym_switch] = ACTIONS(4747),
    [sym_synchronized] = ACTIONS(4747),
    [sym_template] = ACTIONS(4747),
    [sym_throw] = ACTIONS(4747),
    [sym_try] = ACTIONS(4747),
    [sym_typeid] = ACTIONS(4747),
    [sym_typeof] = ACTIONS(4747),
    [sym_union] = ACTIONS(4747),
    [sym_unittest] = ACTIONS(4747),
    [sym_version] = ACTIONS(4747),
    [sym_while] = ACTIONS(4747),
    [sym_with] = ACTIONS(4747),
    [sym_gshared] = ACTIONS(4747),
    [sym_traits] = ACTIONS(4747),
    [sym_vector] = ACTIONS(4747),
    [sym_void] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_r_DQUOTE] = ACTIONS(4749),
    [anon_sym_x_DQUOTE] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_i_BQUOTE] = ACTIONS(4749),
    [anon_sym_i_DQUOTE] = ACTIONS(4749),
    [anon_sym_iq_LBRACE] = ACTIONS(4749),
    [aux_sym_char_literal_token1] = ACTIONS(4749),
    [anon_sym_SQUOTE] = ACTIONS(4747),
    [anon_sym___DATE__] = ACTIONS(4747),
    [anon_sym___FILE__] = ACTIONS(4747),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4747),
    [anon_sym___FUNCTION__] = ACTIONS(4747),
    [anon_sym___LINE__] = ACTIONS(4747),
    [anon_sym___MODULE__] = ACTIONS(4747),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4747),
    [anon_sym___TIME__] = ACTIONS(4747),
    [anon_sym___TIMESTAMP__] = ACTIONS(4747),
    [anon_sym___VENDOR__] = ACTIONS(4747),
    [anon_sym___VERSION__] = ACTIONS(4747),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4749),
    [sym_float_literal] = ACTIONS(4749),
    [sym__string] = ACTIONS(4749),
  },
  [1442] = {
    [sym_identifier] = ACTIONS(4751),
    [anon_sym_q_LBRACE] = ACTIONS(4753),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [anon_sym_LBRACE] = ACTIONS(4753),
    [anon_sym_DOT] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4753),
    [anon_sym_PLUS] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4753),
    [anon_sym_BANG] = ACTIONS(4753),
    [anon_sym_LPAREN] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(4753),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [anon_sym_STAR] = ACTIONS(4753),
    [anon_sym_TILDE] = ACTIONS(4753),
    [anon_sym_AT] = ACTIONS(4753),
    [sym_bool] = ACTIONS(4751),
    [sym_byte] = ACTIONS(4751),
    [sym_ubyte] = ACTIONS(4751),
    [sym_char] = ACTIONS(4751),
    [sym_short] = ACTIONS(4751),
    [sym_ushort] = ACTIONS(4751),
    [sym_int] = ACTIONS(4751),
    [sym_uint] = ACTIONS(4751),
    [sym_long] = ACTIONS(4751),
    [sym_ulong] = ACTIONS(4751),
    [sym_cent] = ACTIONS(4751),
    [sym_ucent] = ACTIONS(4751),
    [sym_wchar] = ACTIONS(4751),
    [sym_dchar] = ACTIONS(4751),
    [sym_float] = ACTIONS(4751),
    [sym_double] = ACTIONS(4751),
    [sym_real] = ACTIONS(4751),
    [sym_ifloat] = ACTIONS(4751),
    [sym_idouble] = ACTIONS(4751),
    [sym_ireal] = ACTIONS(4751),
    [sym_cfloat] = ACTIONS(4751),
    [sym_cdouble] = ACTIONS(4751),
    [sym_creal] = ACTIONS(4751),
    [sym_size_t] = ACTIONS(4751),
    [sym_ptrdiff_t] = ACTIONS(4751),
    [sym_string] = ACTIONS(4751),
    [sym_cstring] = ACTIONS(4751),
    [sym_dstring] = ACTIONS(4751),
    [sym_wstring] = ACTIONS(4751),
    [sym_noreturn] = ACTIONS(4751),
    [sym_true] = ACTIONS(4751),
    [sym_false] = ACTIONS(4751),
    [sym_null] = ACTIONS(4751),
    [sym_super] = ACTIONS(4751),
    [sym_this] = ACTIONS(4751),
    [sym_abstract] = ACTIONS(4751),
    [sym_alias] = ACTIONS(4751),
    [sym_align] = ACTIONS(4751),
    [sym_asm] = ACTIONS(4751),
    [sym_assert] = ACTIONS(4751),
    [sym_auto] = ACTIONS(4751),
    [sym_break] = ACTIONS(4751),
    [sym_case] = ACTIONS(4751),
    [sym_cast] = ACTIONS(4751),
    [sym_catch] = ACTIONS(4751),
    [sym_class] = ACTIONS(4751),
    [sym_const] = ACTIONS(4751),
    [sym_continue] = ACTIONS(4751),
    [sym_debug] = ACTIONS(4751),
    [sym_default] = ACTIONS(4751),
    [sym_delegate] = ACTIONS(4751),
    [sym_delete] = ACTIONS(4751),
    [sym_deprecated] = ACTIONS(4751),
    [sym_do] = ACTIONS(4751),
    [sym_else] = ACTIONS(4751),
    [sym_enum] = ACTIONS(4751),
    [sym_export] = ACTIONS(4751),
    [sym_extern] = ACTIONS(4751),
    [sym_final] = ACTIONS(4751),
    [sym_finally] = ACTIONS(4751),
    [sym_for] = ACTIONS(4751),
    [sym_foreach] = ACTIONS(4751),
    [sym_foreach_reverse] = ACTIONS(4751),
    [sym_function] = ACTIONS(4751),
    [sym_goto] = ACTIONS(4751),
    [sym_if] = ACTIONS(4751),
    [sym_immutable] = ACTIONS(4751),
    [sym_import] = ACTIONS(4751),
    [sym_in] = ACTIONS(4751),
    [sym_inout] = ACTIONS(4751),
    [sym_interface] = ACTIONS(4751),
    [sym_invariant] = ACTIONS(4751),
    [sym_is] = ACTIONS(4751),
    [sym_mixin] = ACTIONS(4751),
    [sym_new] = ACTIONS(4751),
    [sym_nothrow] = ACTIONS(4751),
    [sym_out] = ACTIONS(4751),
    [sym_override] = ACTIONS(4751),
    [sym_package] = ACTIONS(4751),
    [sym_pragma] = ACTIONS(4751),
    [sym_private] = ACTIONS(4751),
    [sym_protected] = ACTIONS(4751),
    [sym_public] = ACTIONS(4751),
    [sym_pure] = ACTIONS(4751),
    [sym_ref] = ACTIONS(4751),
    [sym_return] = ACTIONS(4751),
    [sym_scope] = ACTIONS(4751),
    [sym_shared] = ACTIONS(4751),
    [sym_static] = ACTIONS(4751),
    [sym_struct] = ACTIONS(4751),
    [sym_switch] = ACTIONS(4751),
    [sym_synchronized] = ACTIONS(4751),
    [sym_template] = ACTIONS(4751),
    [sym_throw] = ACTIONS(4751),
    [sym_try] = ACTIONS(4751),
    [sym_typeid] = ACTIONS(4751),
    [sym_typeof] = ACTIONS(4751),
    [sym_union] = ACTIONS(4751),
    [sym_unittest] = ACTIONS(4751),
    [sym_version] = ACTIONS(4751),
    [sym_while] = ACTIONS(4751),
    [sym_with] = ACTIONS(4751),
    [sym_gshared] = ACTIONS(4751),
    [sym_traits] = ACTIONS(4751),
    [sym_vector] = ACTIONS(4751),
    [sym_void] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_r_DQUOTE] = ACTIONS(4753),
    [anon_sym_x_DQUOTE] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_i_BQUOTE] = ACTIONS(4753),
    [anon_sym_i_DQUOTE] = ACTIONS(4753),
    [anon_sym_iq_LBRACE] = ACTIONS(4753),
    [aux_sym_char_literal_token1] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4751),
    [anon_sym___DATE__] = ACTIONS(4751),
    [anon_sym___FILE__] = ACTIONS(4751),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4751),
    [anon_sym___FUNCTION__] = ACTIONS(4751),
    [anon_sym___LINE__] = ACTIONS(4751),
    [anon_sym___MODULE__] = ACTIONS(4751),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4751),
    [anon_sym___TIME__] = ACTIONS(4751),
    [anon_sym___TIMESTAMP__] = ACTIONS(4751),
    [anon_sym___VENDOR__] = ACTIONS(4751),
    [anon_sym___VERSION__] = ACTIONS(4751),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4753),
    [sym_float_literal] = ACTIONS(4753),
    [sym__string] = ACTIONS(4753),
  },
  [1443] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_q_LBRACE] = ACTIONS(4757),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4759),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_null] = ACTIONS(4755),
    [sym_super] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_asm] = ACTIONS(4755),
    [sym_assert] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_break] = ACTIONS(4755),
    [sym_case] = ACTIONS(4755),
    [sym_cast] = ACTIONS(4755),
    [sym_catch] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_continue] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_default] = ACTIONS(4755),
    [sym_delegate] = ACTIONS(4755),
    [sym_delete] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_do] = ACTIONS(4762),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_finally] = ACTIONS(4755),
    [sym_for] = ACTIONS(4755),
    [sym_foreach] = ACTIONS(4755),
    [sym_foreach_reverse] = ACTIONS(4755),
    [sym_function] = ACTIONS(4755),
    [sym_goto] = ACTIONS(4755),
    [sym_if] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(4762),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_is] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_new] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_out] = ACTIONS(4762),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_switch] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_throw] = ACTIONS(4755),
    [sym_try] = ACTIONS(4755),
    [sym_typeid] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_with] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4757),
    [anon_sym_r_DQUOTE] = ACTIONS(4757),
    [anon_sym_x_DQUOTE] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_i_BQUOTE] = ACTIONS(4757),
    [anon_sym_i_DQUOTE] = ACTIONS(4757),
    [anon_sym_iq_LBRACE] = ACTIONS(4757),
    [aux_sym_char_literal_token1] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym___DATE__] = ACTIONS(4755),
    [anon_sym___FILE__] = ACTIONS(4755),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4755),
    [anon_sym___FUNCTION__] = ACTIONS(4755),
    [anon_sym___LINE__] = ACTIONS(4755),
    [anon_sym___MODULE__] = ACTIONS(4755),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4755),
    [anon_sym___TIME__] = ACTIONS(4755),
    [anon_sym___TIMESTAMP__] = ACTIONS(4755),
    [anon_sym___VENDOR__] = ACTIONS(4755),
    [anon_sym___VERSION__] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4757),
    [sym_float_literal] = ACTIONS(4757),
    [sym__string] = ACTIONS(4757),
  },
  [1444] = {
    [sym_identifier] = ACTIONS(4765),
    [anon_sym_q_LBRACE] = ACTIONS(4767),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym_LBRACE] = ACTIONS(4767),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_AMP] = ACTIONS(4767),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_DASH_DASH] = ACTIONS(4767),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4767),
    [anon_sym_BANG] = ACTIONS(4767),
    [anon_sym_LPAREN] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_LBRACK] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [anon_sym_STAR] = ACTIONS(4767),
    [anon_sym_TILDE] = ACTIONS(4767),
    [anon_sym_AT] = ACTIONS(4767),
    [sym_bool] = ACTIONS(4765),
    [sym_byte] = ACTIONS(4765),
    [sym_ubyte] = ACTIONS(4765),
    [sym_char] = ACTIONS(4765),
    [sym_short] = ACTIONS(4765),
    [sym_ushort] = ACTIONS(4765),
    [sym_int] = ACTIONS(4765),
    [sym_uint] = ACTIONS(4765),
    [sym_long] = ACTIONS(4765),
    [sym_ulong] = ACTIONS(4765),
    [sym_cent] = ACTIONS(4765),
    [sym_ucent] = ACTIONS(4765),
    [sym_wchar] = ACTIONS(4765),
    [sym_dchar] = ACTIONS(4765),
    [sym_float] = ACTIONS(4765),
    [sym_double] = ACTIONS(4765),
    [sym_real] = ACTIONS(4765),
    [sym_ifloat] = ACTIONS(4765),
    [sym_idouble] = ACTIONS(4765),
    [sym_ireal] = ACTIONS(4765),
    [sym_cfloat] = ACTIONS(4765),
    [sym_cdouble] = ACTIONS(4765),
    [sym_creal] = ACTIONS(4765),
    [sym_size_t] = ACTIONS(4765),
    [sym_ptrdiff_t] = ACTIONS(4765),
    [sym_string] = ACTIONS(4765),
    [sym_cstring] = ACTIONS(4765),
    [sym_dstring] = ACTIONS(4765),
    [sym_wstring] = ACTIONS(4765),
    [sym_noreturn] = ACTIONS(4765),
    [sym_true] = ACTIONS(4765),
    [sym_false] = ACTIONS(4765),
    [sym_null] = ACTIONS(4765),
    [sym_super] = ACTIONS(4765),
    [sym_this] = ACTIONS(4765),
    [sym_abstract] = ACTIONS(4765),
    [sym_alias] = ACTIONS(4765),
    [sym_align] = ACTIONS(4765),
    [sym_asm] = ACTIONS(4765),
    [sym_assert] = ACTIONS(4765),
    [sym_auto] = ACTIONS(4765),
    [sym_break] = ACTIONS(4765),
    [sym_case] = ACTIONS(4765),
    [sym_cast] = ACTIONS(4765),
    [sym_catch] = ACTIONS(4765),
    [sym_class] = ACTIONS(4765),
    [sym_const] = ACTIONS(4765),
    [sym_continue] = ACTIONS(4765),
    [sym_debug] = ACTIONS(4765),
    [sym_default] = ACTIONS(4765),
    [sym_delegate] = ACTIONS(4765),
    [sym_delete] = ACTIONS(4765),
    [sym_deprecated] = ACTIONS(4765),
    [sym_do] = ACTIONS(4765),
    [sym_else] = ACTIONS(4765),
    [sym_enum] = ACTIONS(4765),
    [sym_export] = ACTIONS(4765),
    [sym_extern] = ACTIONS(4765),
    [sym_final] = ACTIONS(4765),
    [sym_finally] = ACTIONS(4765),
    [sym_for] = ACTIONS(4765),
    [sym_foreach] = ACTIONS(4765),
    [sym_foreach_reverse] = ACTIONS(4765),
    [sym_function] = ACTIONS(4765),
    [sym_goto] = ACTIONS(4765),
    [sym_if] = ACTIONS(4765),
    [sym_immutable] = ACTIONS(4765),
    [sym_import] = ACTIONS(4765),
    [sym_in] = ACTIONS(4765),
    [sym_inout] = ACTIONS(4765),
    [sym_interface] = ACTIONS(4765),
    [sym_invariant] = ACTIONS(4765),
    [sym_is] = ACTIONS(4765),
    [sym_mixin] = ACTIONS(4765),
    [sym_new] = ACTIONS(4765),
    [sym_nothrow] = ACTIONS(4765),
    [sym_out] = ACTIONS(4765),
    [sym_override] = ACTIONS(4765),
    [sym_package] = ACTIONS(4765),
    [sym_pragma] = ACTIONS(4765),
    [sym_private] = ACTIONS(4765),
    [sym_protected] = ACTIONS(4765),
    [sym_public] = ACTIONS(4765),
    [sym_pure] = ACTIONS(4765),
    [sym_ref] = ACTIONS(4765),
    [sym_return] = ACTIONS(4765),
    [sym_scope] = ACTIONS(4765),
    [sym_shared] = ACTIONS(4765),
    [sym_static] = ACTIONS(4765),
    [sym_struct] = ACTIONS(4765),
    [sym_switch] = ACTIONS(4765),
    [sym_synchronized] = ACTIONS(4765),
    [sym_template] = ACTIONS(4765),
    [sym_throw] = ACTIONS(4765),
    [sym_try] = ACTIONS(4765),
    [sym_typeid] = ACTIONS(4765),
    [sym_typeof] = ACTIONS(4765),
    [sym_union] = ACTIONS(4765),
    [sym_unittest] = ACTIONS(4765),
    [sym_version] = ACTIONS(4765),
    [sym_while] = ACTIONS(4765),
    [sym_with] = ACTIONS(4765),
    [sym_gshared] = ACTIONS(4765),
    [sym_traits] = ACTIONS(4765),
    [sym_vector] = ACTIONS(4765),
    [sym_void] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_r_DQUOTE] = ACTIONS(4767),
    [anon_sym_x_DQUOTE] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_i_BQUOTE] = ACTIONS(4767),
    [anon_sym_i_DQUOTE] = ACTIONS(4767),
    [anon_sym_iq_LBRACE] = ACTIONS(4767),
    [aux_sym_char_literal_token1] = ACTIONS(4767),
    [anon_sym_SQUOTE] = ACTIONS(4765),
    [anon_sym___DATE__] = ACTIONS(4765),
    [anon_sym___FILE__] = ACTIONS(4765),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4765),
    [anon_sym___FUNCTION__] = ACTIONS(4765),
    [anon_sym___LINE__] = ACTIONS(4765),
    [anon_sym___MODULE__] = ACTIONS(4765),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4765),
    [anon_sym___TIME__] = ACTIONS(4765),
    [anon_sym___TIMESTAMP__] = ACTIONS(4765),
    [anon_sym___VENDOR__] = ACTIONS(4765),
    [anon_sym___VERSION__] = ACTIONS(4765),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4767),
    [sym_float_literal] = ACTIONS(4767),
    [sym__string] = ACTIONS(4767),
  },
  [1445] = {
    [sym_identifier] = ACTIONS(4769),
    [anon_sym_q_LBRACE] = ACTIONS(4771),
    [anon_sym_RBRACE] = ACTIONS(4771),
    [anon_sym_LBRACE] = ACTIONS(4771),
    [anon_sym_DOT] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_DASH] = ACTIONS(4769),
    [anon_sym_DASH_DASH] = ACTIONS(4771),
    [anon_sym_PLUS] = ACTIONS(4769),
    [anon_sym_PLUS_PLUS] = ACTIONS(4771),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_LPAREN] = ACTIONS(4771),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_LBRACK] = ACTIONS(4771),
    [anon_sym_SEMI] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4771),
    [anon_sym_STAR] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [anon_sym_AT] = ACTIONS(4771),
    [sym_bool] = ACTIONS(4769),
    [sym_byte] = ACTIONS(4769),
    [sym_ubyte] = ACTIONS(4769),
    [sym_char] = ACTIONS(4769),
    [sym_short] = ACTIONS(4769),
    [sym_ushort] = ACTIONS(4769),
    [sym_int] = ACTIONS(4769),
    [sym_uint] = ACTIONS(4769),
    [sym_long] = ACTIONS(4769),
    [sym_ulong] = ACTIONS(4769),
    [sym_cent] = ACTIONS(4769),
    [sym_ucent] = ACTIONS(4769),
    [sym_wchar] = ACTIONS(4769),
    [sym_dchar] = ACTIONS(4769),
    [sym_float] = ACTIONS(4769),
    [sym_double] = ACTIONS(4769),
    [sym_real] = ACTIONS(4769),
    [sym_ifloat] = ACTIONS(4769),
    [sym_idouble] = ACTIONS(4769),
    [sym_ireal] = ACTIONS(4769),
    [sym_cfloat] = ACTIONS(4769),
    [sym_cdouble] = ACTIONS(4769),
    [sym_creal] = ACTIONS(4769),
    [sym_size_t] = ACTIONS(4769),
    [sym_ptrdiff_t] = ACTIONS(4769),
    [sym_string] = ACTIONS(4769),
    [sym_cstring] = ACTIONS(4769),
    [sym_dstring] = ACTIONS(4769),
    [sym_wstring] = ACTIONS(4769),
    [sym_noreturn] = ACTIONS(4769),
    [sym_true] = ACTIONS(4769),
    [sym_false] = ACTIONS(4769),
    [sym_null] = ACTIONS(4769),
    [sym_super] = ACTIONS(4769),
    [sym_this] = ACTIONS(4769),
    [sym_abstract] = ACTIONS(4769),
    [sym_alias] = ACTIONS(4769),
    [sym_align] = ACTIONS(4769),
    [sym_asm] = ACTIONS(4769),
    [sym_assert] = ACTIONS(4769),
    [sym_auto] = ACTIONS(4769),
    [sym_break] = ACTIONS(4769),
    [sym_case] = ACTIONS(4769),
    [sym_cast] = ACTIONS(4769),
    [sym_catch] = ACTIONS(4769),
    [sym_class] = ACTIONS(4769),
    [sym_const] = ACTIONS(4769),
    [sym_continue] = ACTIONS(4769),
    [sym_debug] = ACTIONS(4769),
    [sym_default] = ACTIONS(4769),
    [sym_delegate] = ACTIONS(4769),
    [sym_delete] = ACTIONS(4769),
    [sym_deprecated] = ACTIONS(4769),
    [sym_do] = ACTIONS(4769),
    [sym_else] = ACTIONS(4769),
    [sym_enum] = ACTIONS(4769),
    [sym_export] = ACTIONS(4769),
    [sym_extern] = ACTIONS(4769),
    [sym_final] = ACTIONS(4769),
    [sym_finally] = ACTIONS(4769),
    [sym_for] = ACTIONS(4769),
    [sym_foreach] = ACTIONS(4769),
    [sym_foreach_reverse] = ACTIONS(4769),
    [sym_function] = ACTIONS(4769),
    [sym_goto] = ACTIONS(4769),
    [sym_if] = ACTIONS(4769),
    [sym_immutable] = ACTIONS(4769),
    [sym_import] = ACTIONS(4769),
    [sym_in] = ACTIONS(4769),
    [sym_inout] = ACTIONS(4769),
    [sym_interface] = ACTIONS(4769),
    [sym_invariant] = ACTIONS(4769),
    [sym_is] = ACTIONS(4769),
    [sym_mixin] = ACTIONS(4769),
    [sym_new] = ACTIONS(4769),
    [sym_nothrow] = ACTIONS(4769),
    [sym_out] = ACTIONS(4769),
    [sym_override] = ACTIONS(4769),
    [sym_package] = ACTIONS(4769),
    [sym_pragma] = ACTIONS(4769),
    [sym_private] = ACTIONS(4769),
    [sym_protected] = ACTIONS(4769),
    [sym_public] = ACTIONS(4769),
    [sym_pure] = ACTIONS(4769),
    [sym_ref] = ACTIONS(4769),
    [sym_return] = ACTIONS(4769),
    [sym_scope] = ACTIONS(4769),
    [sym_shared] = ACTIONS(4769),
    [sym_static] = ACTIONS(4769),
    [sym_struct] = ACTIONS(4769),
    [sym_switch] = ACTIONS(4769),
    [sym_synchronized] = ACTIONS(4769),
    [sym_template] = ACTIONS(4769),
    [sym_throw] = ACTIONS(4769),
    [sym_try] = ACTIONS(4769),
    [sym_typeid] = ACTIONS(4769),
    [sym_typeof] = ACTIONS(4769),
    [sym_union] = ACTIONS(4769),
    [sym_unittest] = ACTIONS(4769),
    [sym_version] = ACTIONS(4769),
    [sym_while] = ACTIONS(4769),
    [sym_with] = ACTIONS(4769),
    [sym_gshared] = ACTIONS(4769),
    [sym_traits] = ACTIONS(4769),
    [sym_vector] = ACTIONS(4769),
    [sym_void] = ACTIONS(4769),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_r_DQUOTE] = ACTIONS(4771),
    [anon_sym_x_DQUOTE] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_i_BQUOTE] = ACTIONS(4771),
    [anon_sym_i_DQUOTE] = ACTIONS(4771),
    [anon_sym_iq_LBRACE] = ACTIONS(4771),
    [aux_sym_char_literal_token1] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(4769),
    [anon_sym___DATE__] = ACTIONS(4769),
    [anon_sym___FILE__] = ACTIONS(4769),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4769),
    [anon_sym___FUNCTION__] = ACTIONS(4769),
    [anon_sym___LINE__] = ACTIONS(4769),
    [anon_sym___MODULE__] = ACTIONS(4769),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4769),
    [anon_sym___TIME__] = ACTIONS(4769),
    [anon_sym___TIMESTAMP__] = ACTIONS(4769),
    [anon_sym___VENDOR__] = ACTIONS(4769),
    [anon_sym___VERSION__] = ACTIONS(4769),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4771),
    [sym_float_literal] = ACTIONS(4771),
    [sym__string] = ACTIONS(4771),
  },
  [1446] = {
    [sym_identifier] = ACTIONS(4773),
    [anon_sym_q_LBRACE] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(4775),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4775),
    [anon_sym_DASH] = ACTIONS(4773),
    [anon_sym_DASH_DASH] = ACTIONS(4775),
    [anon_sym_PLUS] = ACTIONS(4773),
    [anon_sym_PLUS_PLUS] = ACTIONS(4775),
    [anon_sym_BANG] = ACTIONS(4775),
    [anon_sym_LPAREN] = ACTIONS(4775),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_LBRACK] = ACTIONS(4775),
    [anon_sym_SEMI] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4775),
    [anon_sym_STAR] = ACTIONS(4775),
    [anon_sym_TILDE] = ACTIONS(4775),
    [anon_sym_AT] = ACTIONS(4775),
    [sym_bool] = ACTIONS(4773),
    [sym_byte] = ACTIONS(4773),
    [sym_ubyte] = ACTIONS(4773),
    [sym_char] = ACTIONS(4773),
    [sym_short] = ACTIONS(4773),
    [sym_ushort] = ACTIONS(4773),
    [sym_int] = ACTIONS(4773),
    [sym_uint] = ACTIONS(4773),
    [sym_long] = ACTIONS(4773),
    [sym_ulong] = ACTIONS(4773),
    [sym_cent] = ACTIONS(4773),
    [sym_ucent] = ACTIONS(4773),
    [sym_wchar] = ACTIONS(4773),
    [sym_dchar] = ACTIONS(4773),
    [sym_float] = ACTIONS(4773),
    [sym_double] = ACTIONS(4773),
    [sym_real] = ACTIONS(4773),
    [sym_ifloat] = ACTIONS(4773),
    [sym_idouble] = ACTIONS(4773),
    [sym_ireal] = ACTIONS(4773),
    [sym_cfloat] = ACTIONS(4773),
    [sym_cdouble] = ACTIONS(4773),
    [sym_creal] = ACTIONS(4773),
    [sym_size_t] = ACTIONS(4773),
    [sym_ptrdiff_t] = ACTIONS(4773),
    [sym_string] = ACTIONS(4773),
    [sym_cstring] = ACTIONS(4773),
    [sym_dstring] = ACTIONS(4773),
    [sym_wstring] = ACTIONS(4773),
    [sym_noreturn] = ACTIONS(4773),
    [sym_true] = ACTIONS(4773),
    [sym_false] = ACTIONS(4773),
    [sym_null] = ACTIONS(4773),
    [sym_super] = ACTIONS(4773),
    [sym_this] = ACTIONS(4773),
    [sym_abstract] = ACTIONS(4773),
    [sym_alias] = ACTIONS(4773),
    [sym_align] = ACTIONS(4773),
    [sym_asm] = ACTIONS(4773),
    [sym_assert] = ACTIONS(4773),
    [sym_auto] = ACTIONS(4773),
    [sym_break] = ACTIONS(4773),
    [sym_case] = ACTIONS(4773),
    [sym_cast] = ACTIONS(4773),
    [sym_catch] = ACTIONS(4773),
    [sym_class] = ACTIONS(4773),
    [sym_const] = ACTIONS(4773),
    [sym_continue] = ACTIONS(4773),
    [sym_debug] = ACTIONS(4773),
    [sym_default] = ACTIONS(4773),
    [sym_delegate] = ACTIONS(4773),
    [sym_delete] = ACTIONS(4773),
    [sym_deprecated] = ACTIONS(4773),
    [sym_do] = ACTIONS(4773),
    [sym_else] = ACTIONS(4773),
    [sym_enum] = ACTIONS(4773),
    [sym_export] = ACTIONS(4773),
    [sym_extern] = ACTIONS(4773),
    [sym_final] = ACTIONS(4773),
    [sym_finally] = ACTIONS(4773),
    [sym_for] = ACTIONS(4773),
    [sym_foreach] = ACTIONS(4773),
    [sym_foreach_reverse] = ACTIONS(4773),
    [sym_function] = ACTIONS(4773),
    [sym_goto] = ACTIONS(4773),
    [sym_if] = ACTIONS(4773),
    [sym_immutable] = ACTIONS(4773),
    [sym_import] = ACTIONS(4773),
    [sym_in] = ACTIONS(4773),
    [sym_inout] = ACTIONS(4773),
    [sym_interface] = ACTIONS(4773),
    [sym_invariant] = ACTIONS(4773),
    [sym_is] = ACTIONS(4773),
    [sym_mixin] = ACTIONS(4773),
    [sym_new] = ACTIONS(4773),
    [sym_nothrow] = ACTIONS(4773),
    [sym_out] = ACTIONS(4773),
    [sym_override] = ACTIONS(4773),
    [sym_package] = ACTIONS(4773),
    [sym_pragma] = ACTIONS(4773),
    [sym_private] = ACTIONS(4773),
    [sym_protected] = ACTIONS(4773),
    [sym_public] = ACTIONS(4773),
    [sym_pure] = ACTIONS(4773),
    [sym_ref] = ACTIONS(4773),
    [sym_return] = ACTIONS(4773),
    [sym_scope] = ACTIONS(4773),
    [sym_shared] = ACTIONS(4773),
    [sym_static] = ACTIONS(4773),
    [sym_struct] = ACTIONS(4773),
    [sym_switch] = ACTIONS(4773),
    [sym_synchronized] = ACTIONS(4773),
    [sym_template] = ACTIONS(4773),
    [sym_throw] = ACTIONS(4773),
    [sym_try] = ACTIONS(4773),
    [sym_typeid] = ACTIONS(4773),
    [sym_typeof] = ACTIONS(4773),
    [sym_union] = ACTIONS(4773),
    [sym_unittest] = ACTIONS(4773),
    [sym_version] = ACTIONS(4773),
    [sym_while] = ACTIONS(4773),
    [sym_with] = ACTIONS(4773),
    [sym_gshared] = ACTIONS(4773),
    [sym_traits] = ACTIONS(4773),
    [sym_vector] = ACTIONS(4773),
    [sym_void] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_r_DQUOTE] = ACTIONS(4775),
    [anon_sym_x_DQUOTE] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_i_BQUOTE] = ACTIONS(4775),
    [anon_sym_i_DQUOTE] = ACTIONS(4775),
    [anon_sym_iq_LBRACE] = ACTIONS(4775),
    [aux_sym_char_literal_token1] = ACTIONS(4775),
    [anon_sym_SQUOTE] = ACTIONS(4773),
    [anon_sym___DATE__] = ACTIONS(4773),
    [anon_sym___FILE__] = ACTIONS(4773),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4773),
    [anon_sym___FUNCTION__] = ACTIONS(4773),
    [anon_sym___LINE__] = ACTIONS(4773),
    [anon_sym___MODULE__] = ACTIONS(4773),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4773),
    [anon_sym___TIME__] = ACTIONS(4773),
    [anon_sym___TIMESTAMP__] = ACTIONS(4773),
    [anon_sym___VENDOR__] = ACTIONS(4773),
    [anon_sym___VERSION__] = ACTIONS(4773),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4775),
    [sym_float_literal] = ACTIONS(4775),
    [sym__string] = ACTIONS(4775),
  },
  [1447] = {
    [sym_identifier] = ACTIONS(4777),
    [anon_sym_q_LBRACE] = ACTIONS(4779),
    [anon_sym_RBRACE] = ACTIONS(4779),
    [anon_sym_LBRACE] = ACTIONS(4779),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_DASH] = ACTIONS(4777),
    [anon_sym_DASH_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4779),
    [anon_sym_BANG] = ACTIONS(4779),
    [anon_sym_LPAREN] = ACTIONS(4779),
    [anon_sym_RPAREN] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4779),
    [anon_sym_DOLLAR] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_TILDE] = ACTIONS(4779),
    [anon_sym_AT] = ACTIONS(4779),
    [sym_bool] = ACTIONS(4777),
    [sym_byte] = ACTIONS(4777),
    [sym_ubyte] = ACTIONS(4777),
    [sym_char] = ACTIONS(4777),
    [sym_short] = ACTIONS(4777),
    [sym_ushort] = ACTIONS(4777),
    [sym_int] = ACTIONS(4777),
    [sym_uint] = ACTIONS(4777),
    [sym_long] = ACTIONS(4777),
    [sym_ulong] = ACTIONS(4777),
    [sym_cent] = ACTIONS(4777),
    [sym_ucent] = ACTIONS(4777),
    [sym_wchar] = ACTIONS(4777),
    [sym_dchar] = ACTIONS(4777),
    [sym_float] = ACTIONS(4777),
    [sym_double] = ACTIONS(4777),
    [sym_real] = ACTIONS(4777),
    [sym_ifloat] = ACTIONS(4777),
    [sym_idouble] = ACTIONS(4777),
    [sym_ireal] = ACTIONS(4777),
    [sym_cfloat] = ACTIONS(4777),
    [sym_cdouble] = ACTIONS(4777),
    [sym_creal] = ACTIONS(4777),
    [sym_size_t] = ACTIONS(4777),
    [sym_ptrdiff_t] = ACTIONS(4777),
    [sym_string] = ACTIONS(4777),
    [sym_cstring] = ACTIONS(4777),
    [sym_dstring] = ACTIONS(4777),
    [sym_wstring] = ACTIONS(4777),
    [sym_noreturn] = ACTIONS(4777),
    [sym_true] = ACTIONS(4777),
    [sym_false] = ACTIONS(4777),
    [sym_null] = ACTIONS(4777),
    [sym_super] = ACTIONS(4777),
    [sym_this] = ACTIONS(4777),
    [sym_abstract] = ACTIONS(4777),
    [sym_alias] = ACTIONS(4777),
    [sym_align] = ACTIONS(4777),
    [sym_asm] = ACTIONS(4777),
    [sym_assert] = ACTIONS(4777),
    [sym_auto] = ACTIONS(4777),
    [sym_break] = ACTIONS(4777),
    [sym_case] = ACTIONS(4777),
    [sym_cast] = ACTIONS(4777),
    [sym_catch] = ACTIONS(4777),
    [sym_class] = ACTIONS(4777),
    [sym_const] = ACTIONS(4777),
    [sym_continue] = ACTIONS(4777),
    [sym_debug] = ACTIONS(4777),
    [sym_default] = ACTIONS(4777),
    [sym_delegate] = ACTIONS(4777),
    [sym_delete] = ACTIONS(4777),
    [sym_deprecated] = ACTIONS(4777),
    [sym_do] = ACTIONS(4777),
    [sym_else] = ACTIONS(4777),
    [sym_enum] = ACTIONS(4777),
    [sym_export] = ACTIONS(4777),
    [sym_extern] = ACTIONS(4777),
    [sym_final] = ACTIONS(4777),
    [sym_finally] = ACTIONS(4777),
    [sym_for] = ACTIONS(4777),
    [sym_foreach] = ACTIONS(4777),
    [sym_foreach_reverse] = ACTIONS(4777),
    [sym_function] = ACTIONS(4777),
    [sym_goto] = ACTIONS(4777),
    [sym_if] = ACTIONS(4777),
    [sym_immutable] = ACTIONS(4777),
    [sym_import] = ACTIONS(4777),
    [sym_in] = ACTIONS(4777),
    [sym_inout] = ACTIONS(4777),
    [sym_interface] = ACTIONS(4777),
    [sym_invariant] = ACTIONS(4777),
    [sym_is] = ACTIONS(4777),
    [sym_mixin] = ACTIONS(4777),
    [sym_new] = ACTIONS(4777),
    [sym_nothrow] = ACTIONS(4777),
    [sym_out] = ACTIONS(4777),
    [sym_override] = ACTIONS(4777),
    [sym_package] = ACTIONS(4777),
    [sym_pragma] = ACTIONS(4777),
    [sym_private] = ACTIONS(4777),
    [sym_protected] = ACTIONS(4777),
    [sym_public] = ACTIONS(4777),
    [sym_pure] = ACTIONS(4777),
    [sym_ref] = ACTIONS(4777),
    [sym_return] = ACTIONS(4777),
    [sym_scope] = ACTIONS(4777),
    [sym_shared] = ACTIONS(4777),
    [sym_static] = ACTIONS(4777),
    [sym_struct] = ACTIONS(4777),
    [sym_switch] = ACTIONS(4777),
    [sym_synchronized] = ACTIONS(4777),
    [sym_template] = ACTIONS(4777),
    [sym_throw] = ACTIONS(4777),
    [sym_try] = ACTIONS(4777),
    [sym_typeid] = ACTIONS(4777),
    [sym_typeof] = ACTIONS(4777),
    [sym_union] = ACTIONS(4777),
    [sym_unittest] = ACTIONS(4777),
    [sym_version] = ACTIONS(4777),
    [sym_while] = ACTIONS(4777),
    [sym_with] = ACTIONS(4777),
    [sym_gshared] = ACTIONS(4777),
    [sym_traits] = ACTIONS(4777),
    [sym_vector] = ACTIONS(4777),
    [sym_void] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4779),
    [anon_sym_r_DQUOTE] = ACTIONS(4779),
    [anon_sym_x_DQUOTE] = ACTIONS(4779),
    [anon_sym_DQUOTE] = ACTIONS(4779),
    [anon_sym_i_BQUOTE] = ACTIONS(4779),
    [anon_sym_i_DQUOTE] = ACTIONS(4779),
    [anon_sym_iq_LBRACE] = ACTIONS(4779),
    [aux_sym_char_literal_token1] = ACTIONS(4779),
    [anon_sym_SQUOTE] = ACTIONS(4777),
    [anon_sym___DATE__] = ACTIONS(4777),
    [anon_sym___FILE__] = ACTIONS(4777),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4777),
    [anon_sym___FUNCTION__] = ACTIONS(4777),
    [anon_sym___LINE__] = ACTIONS(4777),
    [anon_sym___MODULE__] = ACTIONS(4777),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4777),
    [anon_sym___TIME__] = ACTIONS(4777),
    [anon_sym___TIMESTAMP__] = ACTIONS(4777),
    [anon_sym___VENDOR__] = ACTIONS(4777),
    [anon_sym___VERSION__] = ACTIONS(4777),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4779),
    [sym_float_literal] = ACTIONS(4779),
    [sym__string] = ACTIONS(4779),
  },
  [1448] = {
    [sym_identifier] = ACTIONS(4781),
    [anon_sym_q_LBRACE] = ACTIONS(4783),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_AMP] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4781),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS] = ACTIONS(4781),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_BANG] = ACTIONS(4783),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_DOLLAR] = ACTIONS(4783),
    [anon_sym_STAR] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_AT] = ACTIONS(4783),
    [sym_bool] = ACTIONS(4781),
    [sym_byte] = ACTIONS(4781),
    [sym_ubyte] = ACTIONS(4781),
    [sym_char] = ACTIONS(4781),
    [sym_short] = ACTIONS(4781),
    [sym_ushort] = ACTIONS(4781),
    [sym_int] = ACTIONS(4781),
    [sym_uint] = ACTIONS(4781),
    [sym_long] = ACTIONS(4781),
    [sym_ulong] = ACTIONS(4781),
    [sym_cent] = ACTIONS(4781),
    [sym_ucent] = ACTIONS(4781),
    [sym_wchar] = ACTIONS(4781),
    [sym_dchar] = ACTIONS(4781),
    [sym_float] = ACTIONS(4781),
    [sym_double] = ACTIONS(4781),
    [sym_real] = ACTIONS(4781),
    [sym_ifloat] = ACTIONS(4781),
    [sym_idouble] = ACTIONS(4781),
    [sym_ireal] = ACTIONS(4781),
    [sym_cfloat] = ACTIONS(4781),
    [sym_cdouble] = ACTIONS(4781),
    [sym_creal] = ACTIONS(4781),
    [sym_size_t] = ACTIONS(4781),
    [sym_ptrdiff_t] = ACTIONS(4781),
    [sym_string] = ACTIONS(4781),
    [sym_cstring] = ACTIONS(4781),
    [sym_dstring] = ACTIONS(4781),
    [sym_wstring] = ACTIONS(4781),
    [sym_noreturn] = ACTIONS(4781),
    [sym_true] = ACTIONS(4781),
    [sym_false] = ACTIONS(4781),
    [sym_null] = ACTIONS(4781),
    [sym_super] = ACTIONS(4781),
    [sym_this] = ACTIONS(4781),
    [sym_abstract] = ACTIONS(4781),
    [sym_alias] = ACTIONS(4781),
    [sym_align] = ACTIONS(4781),
    [sym_asm] = ACTIONS(4781),
    [sym_assert] = ACTIONS(4781),
    [sym_auto] = ACTIONS(4781),
    [sym_break] = ACTIONS(4781),
    [sym_case] = ACTIONS(4781),
    [sym_cast] = ACTIONS(4781),
    [sym_catch] = ACTIONS(4781),
    [sym_class] = ACTIONS(4781),
    [sym_const] = ACTIONS(4781),
    [sym_continue] = ACTIONS(4781),
    [sym_debug] = ACTIONS(4781),
    [sym_default] = ACTIONS(4781),
    [sym_delegate] = ACTIONS(4781),
    [sym_delete] = ACTIONS(4781),
    [sym_deprecated] = ACTIONS(4781),
    [sym_do] = ACTIONS(4781),
    [sym_else] = ACTIONS(4781),
    [sym_enum] = ACTIONS(4781),
    [sym_export] = ACTIONS(4781),
    [sym_extern] = ACTIONS(4781),
    [sym_final] = ACTIONS(4781),
    [sym_finally] = ACTIONS(4781),
    [sym_for] = ACTIONS(4781),
    [sym_foreach] = ACTIONS(4781),
    [sym_foreach_reverse] = ACTIONS(4781),
    [sym_function] = ACTIONS(4781),
    [sym_goto] = ACTIONS(4781),
    [sym_if] = ACTIONS(4781),
    [sym_immutable] = ACTIONS(4781),
    [sym_import] = ACTIONS(4781),
    [sym_in] = ACTIONS(4781),
    [sym_inout] = ACTIONS(4781),
    [sym_interface] = ACTIONS(4781),
    [sym_invariant] = ACTIONS(4781),
    [sym_is] = ACTIONS(4781),
    [sym_mixin] = ACTIONS(4781),
    [sym_new] = ACTIONS(4781),
    [sym_nothrow] = ACTIONS(4781),
    [sym_out] = ACTIONS(4781),
    [sym_override] = ACTIONS(4781),
    [sym_package] = ACTIONS(4781),
    [sym_pragma] = ACTIONS(4781),
    [sym_private] = ACTIONS(4781),
    [sym_protected] = ACTIONS(4781),
    [sym_public] = ACTIONS(4781),
    [sym_pure] = ACTIONS(4781),
    [sym_ref] = ACTIONS(4781),
    [sym_return] = ACTIONS(4781),
    [sym_scope] = ACTIONS(4781),
    [sym_shared] = ACTIONS(4781),
    [sym_static] = ACTIONS(4781),
    [sym_struct] = ACTIONS(4781),
    [sym_switch] = ACTIONS(4781),
    [sym_synchronized] = ACTIONS(4781),
    [sym_template] = ACTIONS(4781),
    [sym_throw] = ACTIONS(4781),
    [sym_try] = ACTIONS(4781),
    [sym_typeid] = ACTIONS(4781),
    [sym_typeof] = ACTIONS(4781),
    [sym_union] = ACTIONS(4781),
    [sym_unittest] = ACTIONS(4781),
    [sym_version] = ACTIONS(4781),
    [sym_while] = ACTIONS(4781),
    [sym_with] = ACTIONS(4781),
    [sym_gshared] = ACTIONS(4781),
    [sym_traits] = ACTIONS(4781),
    [sym_vector] = ACTIONS(4781),
    [sym_void] = ACTIONS(4781),
    [anon_sym_BQUOTE] = ACTIONS(4783),
    [anon_sym_r_DQUOTE] = ACTIONS(4783),
    [anon_sym_x_DQUOTE] = ACTIONS(4783),
    [anon_sym_DQUOTE] = ACTIONS(4783),
    [anon_sym_i_BQUOTE] = ACTIONS(4783),
    [anon_sym_i_DQUOTE] = ACTIONS(4783),
    [anon_sym_iq_LBRACE] = ACTIONS(4783),
    [aux_sym_char_literal_token1] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(4781),
    [anon_sym___DATE__] = ACTIONS(4781),
    [anon_sym___FILE__] = ACTIONS(4781),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4781),
    [anon_sym___FUNCTION__] = ACTIONS(4781),
    [anon_sym___LINE__] = ACTIONS(4781),
    [anon_sym___MODULE__] = ACTIONS(4781),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4781),
    [anon_sym___TIME__] = ACTIONS(4781),
    [anon_sym___TIMESTAMP__] = ACTIONS(4781),
    [anon_sym___VENDOR__] = ACTIONS(4781),
    [anon_sym___VERSION__] = ACTIONS(4781),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4783),
    [sym_float_literal] = ACTIONS(4783),
    [sym__string] = ACTIONS(4783),
  },
  [1449] = {
    [sym_identifier] = ACTIONS(4785),
    [anon_sym_q_LBRACE] = ACTIONS(4787),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [anon_sym_LBRACE] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(4787),
    [anon_sym_AMP] = ACTIONS(4787),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4787),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_PLUS_PLUS] = ACTIONS(4787),
    [anon_sym_BANG] = ACTIONS(4787),
    [anon_sym_LPAREN] = ACTIONS(4787),
    [anon_sym_RPAREN] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4787),
    [anon_sym_SEMI] = ACTIONS(4787),
    [anon_sym_DOLLAR] = ACTIONS(4787),
    [anon_sym_STAR] = ACTIONS(4787),
    [anon_sym_TILDE] = ACTIONS(4787),
    [anon_sym_AT] = ACTIONS(4787),
    [sym_bool] = ACTIONS(4785),
    [sym_byte] = ACTIONS(4785),
    [sym_ubyte] = ACTIONS(4785),
    [sym_char] = ACTIONS(4785),
    [sym_short] = ACTIONS(4785),
    [sym_ushort] = ACTIONS(4785),
    [sym_int] = ACTIONS(4785),
    [sym_uint] = ACTIONS(4785),
    [sym_long] = ACTIONS(4785),
    [sym_ulong] = ACTIONS(4785),
    [sym_cent] = ACTIONS(4785),
    [sym_ucent] = ACTIONS(4785),
    [sym_wchar] = ACTIONS(4785),
    [sym_dchar] = ACTIONS(4785),
    [sym_float] = ACTIONS(4785),
    [sym_double] = ACTIONS(4785),
    [sym_real] = ACTIONS(4785),
    [sym_ifloat] = ACTIONS(4785),
    [sym_idouble] = ACTIONS(4785),
    [sym_ireal] = ACTIONS(4785),
    [sym_cfloat] = ACTIONS(4785),
    [sym_cdouble] = ACTIONS(4785),
    [sym_creal] = ACTIONS(4785),
    [sym_size_t] = ACTIONS(4785),
    [sym_ptrdiff_t] = ACTIONS(4785),
    [sym_string] = ACTIONS(4785),
    [sym_cstring] = ACTIONS(4785),
    [sym_dstring] = ACTIONS(4785),
    [sym_wstring] = ACTIONS(4785),
    [sym_noreturn] = ACTIONS(4785),
    [sym_true] = ACTIONS(4785),
    [sym_false] = ACTIONS(4785),
    [sym_null] = ACTIONS(4785),
    [sym_super] = ACTIONS(4785),
    [sym_this] = ACTIONS(4785),
    [sym_abstract] = ACTIONS(4785),
    [sym_alias] = ACTIONS(4785),
    [sym_align] = ACTIONS(4785),
    [sym_asm] = ACTIONS(4785),
    [sym_assert] = ACTIONS(4785),
    [sym_auto] = ACTIONS(4785),
    [sym_break] = ACTIONS(4785),
    [sym_case] = ACTIONS(4785),
    [sym_cast] = ACTIONS(4785),
    [sym_catch] = ACTIONS(4785),
    [sym_class] = ACTIONS(4785),
    [sym_const] = ACTIONS(4785),
    [sym_continue] = ACTIONS(4785),
    [sym_debug] = ACTIONS(4785),
    [sym_default] = ACTIONS(4785),
    [sym_delegate] = ACTIONS(4785),
    [sym_delete] = ACTIONS(4785),
    [sym_deprecated] = ACTIONS(4785),
    [sym_do] = ACTIONS(4785),
    [sym_else] = ACTIONS(4785),
    [sym_enum] = ACTIONS(4785),
    [sym_export] = ACTIONS(4785),
    [sym_extern] = ACTIONS(4785),
    [sym_final] = ACTIONS(4785),
    [sym_finally] = ACTIONS(4785),
    [sym_for] = ACTIONS(4785),
    [sym_foreach] = ACTIONS(4785),
    [sym_foreach_reverse] = ACTIONS(4785),
    [sym_function] = ACTIONS(4785),
    [sym_goto] = ACTIONS(4785),
    [sym_if] = ACTIONS(4785),
    [sym_immutable] = ACTIONS(4785),
    [sym_import] = ACTIONS(4785),
    [sym_in] = ACTIONS(4785),
    [sym_inout] = ACTIONS(4785),
    [sym_interface] = ACTIONS(4785),
    [sym_invariant] = ACTIONS(4785),
    [sym_is] = ACTIONS(4785),
    [sym_mixin] = ACTIONS(4785),
    [sym_new] = ACTIONS(4785),
    [sym_nothrow] = ACTIONS(4785),
    [sym_out] = ACTIONS(4785),
    [sym_override] = ACTIONS(4785),
    [sym_package] = ACTIONS(4785),
    [sym_pragma] = ACTIONS(4785),
    [sym_private] = ACTIONS(4785),
    [sym_protected] = ACTIONS(4785),
    [sym_public] = ACTIONS(4785),
    [sym_pure] = ACTIONS(4785),
    [sym_ref] = ACTIONS(4785),
    [sym_return] = ACTIONS(4785),
    [sym_scope] = ACTIONS(4785),
    [sym_shared] = ACTIONS(4785),
    [sym_static] = ACTIONS(4785),
    [sym_struct] = ACTIONS(4785),
    [sym_switch] = ACTIONS(4785),
    [sym_synchronized] = ACTIONS(4785),
    [sym_template] = ACTIONS(4785),
    [sym_throw] = ACTIONS(4785),
    [sym_try] = ACTIONS(4785),
    [sym_typeid] = ACTIONS(4785),
    [sym_typeof] = ACTIONS(4785),
    [sym_union] = ACTIONS(4785),
    [sym_unittest] = ACTIONS(4785),
    [sym_version] = ACTIONS(4785),
    [sym_while] = ACTIONS(4785),
    [sym_with] = ACTIONS(4785),
    [sym_gshared] = ACTIONS(4785),
    [sym_traits] = ACTIONS(4785),
    [sym_vector] = ACTIONS(4785),
    [sym_void] = ACTIONS(4785),
    [anon_sym_BQUOTE] = ACTIONS(4787),
    [anon_sym_r_DQUOTE] = ACTIONS(4787),
    [anon_sym_x_DQUOTE] = ACTIONS(4787),
    [anon_sym_DQUOTE] = ACTIONS(4787),
    [anon_sym_i_BQUOTE] = ACTIONS(4787),
    [anon_sym_i_DQUOTE] = ACTIONS(4787),
    [anon_sym_iq_LBRACE] = ACTIONS(4787),
    [aux_sym_char_literal_token1] = ACTIONS(4787),
    [anon_sym_SQUOTE] = ACTIONS(4785),
    [anon_sym___DATE__] = ACTIONS(4785),
    [anon_sym___FILE__] = ACTIONS(4785),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4785),
    [anon_sym___FUNCTION__] = ACTIONS(4785),
    [anon_sym___LINE__] = ACTIONS(4785),
    [anon_sym___MODULE__] = ACTIONS(4785),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4785),
    [anon_sym___TIME__] = ACTIONS(4785),
    [anon_sym___TIMESTAMP__] = ACTIONS(4785),
    [anon_sym___VENDOR__] = ACTIONS(4785),
    [anon_sym___VERSION__] = ACTIONS(4785),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4787),
    [sym_float_literal] = ACTIONS(4787),
    [sym__string] = ACTIONS(4787),
  },
  [1450] = {
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_q_LBRACE] = ACTIONS(4791),
    [anon_sym_RBRACE] = ACTIONS(4791),
    [anon_sym_LBRACE] = ACTIONS(4791),
    [anon_sym_DOT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4789),
    [anon_sym_DASH_DASH] = ACTIONS(4791),
    [anon_sym_PLUS] = ACTIONS(4789),
    [anon_sym_PLUS_PLUS] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_LPAREN] = ACTIONS(4791),
    [anon_sym_RPAREN] = ACTIONS(4791),
    [anon_sym_LBRACK] = ACTIONS(4791),
    [anon_sym_SEMI] = ACTIONS(4791),
    [anon_sym_DOLLAR] = ACTIONS(4791),
    [anon_sym_STAR] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [anon_sym_AT] = ACTIONS(4791),
    [sym_bool] = ACTIONS(4789),
    [sym_byte] = ACTIONS(4789),
    [sym_ubyte] = ACTIONS(4789),
    [sym_char] = ACTIONS(4789),
    [sym_short] = ACTIONS(4789),
    [sym_ushort] = ACTIONS(4789),
    [sym_int] = ACTIONS(4789),
    [sym_uint] = ACTIONS(4789),
    [sym_long] = ACTIONS(4789),
    [sym_ulong] = ACTIONS(4789),
    [sym_cent] = ACTIONS(4789),
    [sym_ucent] = ACTIONS(4789),
    [sym_wchar] = ACTIONS(4789),
    [sym_dchar] = ACTIONS(4789),
    [sym_float] = ACTIONS(4789),
    [sym_double] = ACTIONS(4789),
    [sym_real] = ACTIONS(4789),
    [sym_ifloat] = ACTIONS(4789),
    [sym_idouble] = ACTIONS(4789),
    [sym_ireal] = ACTIONS(4789),
    [sym_cfloat] = ACTIONS(4789),
    [sym_cdouble] = ACTIONS(4789),
    [sym_creal] = ACTIONS(4789),
    [sym_size_t] = ACTIONS(4789),
    [sym_ptrdiff_t] = ACTIONS(4789),
    [sym_string] = ACTIONS(4789),
    [sym_cstring] = ACTIONS(4789),
    [sym_dstring] = ACTIONS(4789),
    [sym_wstring] = ACTIONS(4789),
    [sym_noreturn] = ACTIONS(4789),
    [sym_true] = ACTIONS(4789),
    [sym_false] = ACTIONS(4789),
    [sym_null] = ACTIONS(4789),
    [sym_super] = ACTIONS(4789),
    [sym_this] = ACTIONS(4789),
    [sym_abstract] = ACTIONS(4789),
    [sym_alias] = ACTIONS(4789),
    [sym_align] = ACTIONS(4789),
    [sym_asm] = ACTIONS(4789),
    [sym_assert] = ACTIONS(4789),
    [sym_auto] = ACTIONS(4789),
    [sym_break] = ACTIONS(4789),
    [sym_case] = ACTIONS(4789),
    [sym_cast] = ACTIONS(4789),
    [sym_catch] = ACTIONS(4789),
    [sym_class] = ACTIONS(4789),
    [sym_const] = ACTIONS(4789),
    [sym_continue] = ACTIONS(4789),
    [sym_debug] = ACTIONS(4789),
    [sym_default] = ACTIONS(4789),
    [sym_delegate] = ACTIONS(4789),
    [sym_delete] = ACTIONS(4789),
    [sym_deprecated] = ACTIONS(4789),
    [sym_do] = ACTIONS(4789),
    [sym_else] = ACTIONS(4789),
    [sym_enum] = ACTIONS(4789),
    [sym_export] = ACTIONS(4789),
    [sym_extern] = ACTIONS(4789),
    [sym_final] = ACTIONS(4789),
    [sym_finally] = ACTIONS(4789),
    [sym_for] = ACTIONS(4789),
    [sym_foreach] = ACTIONS(4789),
    [sym_foreach_reverse] = ACTIONS(4789),
    [sym_function] = ACTIONS(4789),
    [sym_goto] = ACTIONS(4789),
    [sym_if] = ACTIONS(4789),
    [sym_immutable] = ACTIONS(4789),
    [sym_import] = ACTIONS(4789),
    [sym_in] = ACTIONS(4789),
    [sym_inout] = ACTIONS(4789),
    [sym_interface] = ACTIONS(4789),
    [sym_invariant] = ACTIONS(4789),
    [sym_is] = ACTIONS(4789),
    [sym_mixin] = ACTIONS(4789),
    [sym_new] = ACTIONS(4789),
    [sym_nothrow] = ACTIONS(4789),
    [sym_out] = ACTIONS(4789),
    [sym_override] = ACTIONS(4789),
    [sym_package] = ACTIONS(4789),
    [sym_pragma] = ACTIONS(4789),
    [sym_private] = ACTIONS(4789),
    [sym_protected] = ACTIONS(4789),
    [sym_public] = ACTIONS(4789),
    [sym_pure] = ACTIONS(4789),
    [sym_ref] = ACTIONS(4789),
    [sym_return] = ACTIONS(4789),
    [sym_scope] = ACTIONS(4789),
    [sym_shared] = ACTIONS(4789),
    [sym_static] = ACTIONS(4789),
    [sym_struct] = ACTIONS(4789),
    [sym_switch] = ACTIONS(4789),
    [sym_synchronized] = ACTIONS(4789),
    [sym_template] = ACTIONS(4789),
    [sym_throw] = ACTIONS(4789),
    [sym_try] = ACTIONS(4789),
    [sym_typeid] = ACTIONS(4789),
    [sym_typeof] = ACTIONS(4789),
    [sym_union] = ACTIONS(4789),
    [sym_unittest] = ACTIONS(4789),
    [sym_version] = ACTIONS(4789),
    [sym_while] = ACTIONS(4789),
    [sym_with] = ACTIONS(4789),
    [sym_gshared] = ACTIONS(4789),
    [sym_traits] = ACTIONS(4789),
    [sym_vector] = ACTIONS(4789),
    [sym_void] = ACTIONS(4789),
    [anon_sym_BQUOTE] = ACTIONS(4791),
    [anon_sym_r_DQUOTE] = ACTIONS(4791),
    [anon_sym_x_DQUOTE] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(4791),
    [anon_sym_i_BQUOTE] = ACTIONS(4791),
    [anon_sym_i_DQUOTE] = ACTIONS(4791),
    [anon_sym_iq_LBRACE] = ACTIONS(4791),
    [aux_sym_char_literal_token1] = ACTIONS(4791),
    [anon_sym_SQUOTE] = ACTIONS(4789),
    [anon_sym___DATE__] = ACTIONS(4789),
    [anon_sym___FILE__] = ACTIONS(4789),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4789),
    [anon_sym___FUNCTION__] = ACTIONS(4789),
    [anon_sym___LINE__] = ACTIONS(4789),
    [anon_sym___MODULE__] = ACTIONS(4789),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4789),
    [anon_sym___TIME__] = ACTIONS(4789),
    [anon_sym___TIMESTAMP__] = ACTIONS(4789),
    [anon_sym___VENDOR__] = ACTIONS(4789),
    [anon_sym___VERSION__] = ACTIONS(4789),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4791),
    [sym_float_literal] = ACTIONS(4791),
    [sym__string] = ACTIONS(4791),
  },
  [1451] = {
    [sym_identifier] = ACTIONS(4793),
    [anon_sym_q_LBRACE] = ACTIONS(4795),
    [anon_sym_RBRACE] = ACTIONS(4795),
    [anon_sym_LBRACE] = ACTIONS(4795),
    [anon_sym_DOT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4793),
    [anon_sym_DASH_DASH] = ACTIONS(4795),
    [anon_sym_PLUS] = ACTIONS(4793),
    [anon_sym_PLUS_PLUS] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(4795),
    [anon_sym_LPAREN] = ACTIONS(4795),
    [anon_sym_RPAREN] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4795),
    [anon_sym_SEMI] = ACTIONS(4795),
    [anon_sym_DOLLAR] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(4795),
    [anon_sym_TILDE] = ACTIONS(4795),
    [anon_sym_AT] = ACTIONS(4795),
    [sym_bool] = ACTIONS(4793),
    [sym_byte] = ACTIONS(4793),
    [sym_ubyte] = ACTIONS(4793),
    [sym_char] = ACTIONS(4793),
    [sym_short] = ACTIONS(4793),
    [sym_ushort] = ACTIONS(4793),
    [sym_int] = ACTIONS(4793),
    [sym_uint] = ACTIONS(4793),
    [sym_long] = ACTIONS(4793),
    [sym_ulong] = ACTIONS(4793),
    [sym_cent] = ACTIONS(4793),
    [sym_ucent] = ACTIONS(4793),
    [sym_wchar] = ACTIONS(4793),
    [sym_dchar] = ACTIONS(4793),
    [sym_float] = ACTIONS(4793),
    [sym_double] = ACTIONS(4793),
    [sym_real] = ACTIONS(4793),
    [sym_ifloat] = ACTIONS(4793),
    [sym_idouble] = ACTIONS(4793),
    [sym_ireal] = ACTIONS(4793),
    [sym_cfloat] = ACTIONS(4793),
    [sym_cdouble] = ACTIONS(4793),
    [sym_creal] = ACTIONS(4793),
    [sym_size_t] = ACTIONS(4793),
    [sym_ptrdiff_t] = ACTIONS(4793),
    [sym_string] = ACTIONS(4793),
    [sym_cstring] = ACTIONS(4793),
    [sym_dstring] = ACTIONS(4793),
    [sym_wstring] = ACTIONS(4793),
    [sym_noreturn] = ACTIONS(4793),
    [sym_true] = ACTIONS(4793),
    [sym_false] = ACTIONS(4793),
    [sym_null] = ACTIONS(4793),
    [sym_super] = ACTIONS(4793),
    [sym_this] = ACTIONS(4793),
    [sym_abstract] = ACTIONS(4793),
    [sym_alias] = ACTIONS(4793),
    [sym_align] = ACTIONS(4793),
    [sym_asm] = ACTIONS(4793),
    [sym_assert] = ACTIONS(4793),
    [sym_auto] = ACTIONS(4793),
    [sym_break] = ACTIONS(4793),
    [sym_case] = ACTIONS(4793),
    [sym_cast] = ACTIONS(4793),
    [sym_catch] = ACTIONS(4793),
    [sym_class] = ACTIONS(4793),
    [sym_const] = ACTIONS(4793),
    [sym_continue] = ACTIONS(4793),
    [sym_debug] = ACTIONS(4793),
    [sym_default] = ACTIONS(4793),
    [sym_delegate] = ACTIONS(4793),
    [sym_delete] = ACTIONS(4793),
    [sym_deprecated] = ACTIONS(4793),
    [sym_do] = ACTIONS(4793),
    [sym_else] = ACTIONS(4793),
    [sym_enum] = ACTIONS(4793),
    [sym_export] = ACTIONS(4793),
    [sym_extern] = ACTIONS(4793),
    [sym_final] = ACTIONS(4793),
    [sym_finally] = ACTIONS(4793),
    [sym_for] = ACTIONS(4793),
    [sym_foreach] = ACTIONS(4793),
    [sym_foreach_reverse] = ACTIONS(4793),
    [sym_function] = ACTIONS(4793),
    [sym_goto] = ACTIONS(4793),
    [sym_if] = ACTIONS(4793),
    [sym_immutable] = ACTIONS(4793),
    [sym_import] = ACTIONS(4793),
    [sym_in] = ACTIONS(4793),
    [sym_inout] = ACTIONS(4793),
    [sym_interface] = ACTIONS(4793),
    [sym_invariant] = ACTIONS(4793),
    [sym_is] = ACTIONS(4793),
    [sym_mixin] = ACTIONS(4793),
    [sym_new] = ACTIONS(4793),
    [sym_nothrow] = ACTIONS(4793),
    [sym_out] = ACTIONS(4793),
    [sym_override] = ACTIONS(4793),
    [sym_package] = ACTIONS(4793),
    [sym_pragma] = ACTIONS(4793),
    [sym_private] = ACTIONS(4793),
    [sym_protected] = ACTIONS(4793),
    [sym_public] = ACTIONS(4793),
    [sym_pure] = ACTIONS(4793),
    [sym_ref] = ACTIONS(4793),
    [sym_return] = ACTIONS(4793),
    [sym_scope] = ACTIONS(4793),
    [sym_shared] = ACTIONS(4793),
    [sym_static] = ACTIONS(4793),
    [sym_struct] = ACTIONS(4793),
    [sym_switch] = ACTIONS(4793),
    [sym_synchronized] = ACTIONS(4793),
    [sym_template] = ACTIONS(4793),
    [sym_throw] = ACTIONS(4793),
    [sym_try] = ACTIONS(4793),
    [sym_typeid] = ACTIONS(4793),
    [sym_typeof] = ACTIONS(4793),
    [sym_union] = ACTIONS(4793),
    [sym_unittest] = ACTIONS(4793),
    [sym_version] = ACTIONS(4793),
    [sym_while] = ACTIONS(4793),
    [sym_with] = ACTIONS(4793),
    [sym_gshared] = ACTIONS(4793),
    [sym_traits] = ACTIONS(4793),
    [sym_vector] = ACTIONS(4793),
    [sym_void] = ACTIONS(4793),
    [anon_sym_BQUOTE] = ACTIONS(4795),
    [anon_sym_r_DQUOTE] = ACTIONS(4795),
    [anon_sym_x_DQUOTE] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4795),
    [anon_sym_i_BQUOTE] = ACTIONS(4795),
    [anon_sym_i_DQUOTE] = ACTIONS(4795),
    [anon_sym_iq_LBRACE] = ACTIONS(4795),
    [aux_sym_char_literal_token1] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4793),
    [anon_sym___DATE__] = ACTIONS(4793),
    [anon_sym___FILE__] = ACTIONS(4793),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4793),
    [anon_sym___FUNCTION__] = ACTIONS(4793),
    [anon_sym___LINE__] = ACTIONS(4793),
    [anon_sym___MODULE__] = ACTIONS(4793),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4793),
    [anon_sym___TIME__] = ACTIONS(4793),
    [anon_sym___TIMESTAMP__] = ACTIONS(4793),
    [anon_sym___VENDOR__] = ACTIONS(4793),
    [anon_sym___VERSION__] = ACTIONS(4793),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4795),
    [sym_float_literal] = ACTIONS(4795),
    [sym__string] = ACTIONS(4795),
  },
  [1452] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_q_LBRACE] = ACTIONS(4757),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4757),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_null] = ACTIONS(4755),
    [sym_super] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_asm] = ACTIONS(4755),
    [sym_assert] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_break] = ACTIONS(4755),
    [sym_case] = ACTIONS(4755),
    [sym_cast] = ACTIONS(4755),
    [sym_catch] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_continue] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_default] = ACTIONS(4755),
    [sym_delegate] = ACTIONS(4755),
    [sym_delete] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_do] = ACTIONS(4755),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_finally] = ACTIONS(4755),
    [sym_for] = ACTIONS(4755),
    [sym_foreach] = ACTIONS(4755),
    [sym_foreach_reverse] = ACTIONS(4755),
    [sym_function] = ACTIONS(4755),
    [sym_goto] = ACTIONS(4755),
    [sym_if] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(4755),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_is] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_new] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_out] = ACTIONS(4755),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_switch] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_throw] = ACTIONS(4755),
    [sym_try] = ACTIONS(4755),
    [sym_typeid] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_with] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4757),
    [anon_sym_r_DQUOTE] = ACTIONS(4757),
    [anon_sym_x_DQUOTE] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_i_BQUOTE] = ACTIONS(4757),
    [anon_sym_i_DQUOTE] = ACTIONS(4757),
    [anon_sym_iq_LBRACE] = ACTIONS(4757),
    [aux_sym_char_literal_token1] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym___DATE__] = ACTIONS(4755),
    [anon_sym___FILE__] = ACTIONS(4755),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4755),
    [anon_sym___FUNCTION__] = ACTIONS(4755),
    [anon_sym___LINE__] = ACTIONS(4755),
    [anon_sym___MODULE__] = ACTIONS(4755),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4755),
    [anon_sym___TIME__] = ACTIONS(4755),
    [anon_sym___TIMESTAMP__] = ACTIONS(4755),
    [anon_sym___VENDOR__] = ACTIONS(4755),
    [anon_sym___VERSION__] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4757),
    [sym_float_literal] = ACTIONS(4757),
    [sym__string] = ACTIONS(4757),
  },
  [1453] = {
    [sym_identifier] = ACTIONS(4797),
    [anon_sym_q_LBRACE] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LBRACE] = ACTIONS(4799),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4797),
    [anon_sym_DASH_DASH] = ACTIONS(4799),
    [anon_sym_PLUS] = ACTIONS(4797),
    [anon_sym_PLUS_PLUS] = ACTIONS(4799),
    [anon_sym_BANG] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4799),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_DOLLAR] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(4799),
    [anon_sym_TILDE] = ACTIONS(4799),
    [anon_sym_AT] = ACTIONS(4799),
    [sym_bool] = ACTIONS(4797),
    [sym_byte] = ACTIONS(4797),
    [sym_ubyte] = ACTIONS(4797),
    [sym_char] = ACTIONS(4797),
    [sym_short] = ACTIONS(4797),
    [sym_ushort] = ACTIONS(4797),
    [sym_int] = ACTIONS(4797),
    [sym_uint] = ACTIONS(4797),
    [sym_long] = ACTIONS(4797),
    [sym_ulong] = ACTIONS(4797),
    [sym_cent] = ACTIONS(4797),
    [sym_ucent] = ACTIONS(4797),
    [sym_wchar] = ACTIONS(4797),
    [sym_dchar] = ACTIONS(4797),
    [sym_float] = ACTIONS(4797),
    [sym_double] = ACTIONS(4797),
    [sym_real] = ACTIONS(4797),
    [sym_ifloat] = ACTIONS(4797),
    [sym_idouble] = ACTIONS(4797),
    [sym_ireal] = ACTIONS(4797),
    [sym_cfloat] = ACTIONS(4797),
    [sym_cdouble] = ACTIONS(4797),
    [sym_creal] = ACTIONS(4797),
    [sym_size_t] = ACTIONS(4797),
    [sym_ptrdiff_t] = ACTIONS(4797),
    [sym_string] = ACTIONS(4797),
    [sym_cstring] = ACTIONS(4797),
    [sym_dstring] = ACTIONS(4797),
    [sym_wstring] = ACTIONS(4797),
    [sym_noreturn] = ACTIONS(4797),
    [sym_true] = ACTIONS(4797),
    [sym_false] = ACTIONS(4797),
    [sym_null] = ACTIONS(4797),
    [sym_super] = ACTIONS(4797),
    [sym_this] = ACTIONS(4797),
    [sym_abstract] = ACTIONS(4797),
    [sym_alias] = ACTIONS(4797),
    [sym_align] = ACTIONS(4797),
    [sym_asm] = ACTIONS(4797),
    [sym_assert] = ACTIONS(4797),
    [sym_auto] = ACTIONS(4797),
    [sym_break] = ACTIONS(4797),
    [sym_case] = ACTIONS(4797),
    [sym_cast] = ACTIONS(4797),
    [sym_catch] = ACTIONS(4797),
    [sym_class] = ACTIONS(4797),
    [sym_const] = ACTIONS(4797),
    [sym_continue] = ACTIONS(4797),
    [sym_debug] = ACTIONS(4797),
    [sym_default] = ACTIONS(4797),
    [sym_delegate] = ACTIONS(4797),
    [sym_delete] = ACTIONS(4797),
    [sym_deprecated] = ACTIONS(4797),
    [sym_do] = ACTIONS(4797),
    [sym_else] = ACTIONS(4797),
    [sym_enum] = ACTIONS(4797),
    [sym_export] = ACTIONS(4797),
    [sym_extern] = ACTIONS(4797),
    [sym_final] = ACTIONS(4797),
    [sym_finally] = ACTIONS(4797),
    [sym_for] = ACTIONS(4797),
    [sym_foreach] = ACTIONS(4797),
    [sym_foreach_reverse] = ACTIONS(4797),
    [sym_function] = ACTIONS(4797),
    [sym_goto] = ACTIONS(4797),
    [sym_if] = ACTIONS(4797),
    [sym_immutable] = ACTIONS(4797),
    [sym_import] = ACTIONS(4797),
    [sym_in] = ACTIONS(4797),
    [sym_inout] = ACTIONS(4797),
    [sym_interface] = ACTIONS(4797),
    [sym_invariant] = ACTIONS(4797),
    [sym_is] = ACTIONS(4797),
    [sym_mixin] = ACTIONS(4797),
    [sym_new] = ACTIONS(4797),
    [sym_nothrow] = ACTIONS(4797),
    [sym_out] = ACTIONS(4797),
    [sym_override] = ACTIONS(4797),
    [sym_package] = ACTIONS(4797),
    [sym_pragma] = ACTIONS(4797),
    [sym_private] = ACTIONS(4797),
    [sym_protected] = ACTIONS(4797),
    [sym_public] = ACTIONS(4797),
    [sym_pure] = ACTIONS(4797),
    [sym_ref] = ACTIONS(4797),
    [sym_return] = ACTIONS(4797),
    [sym_scope] = ACTIONS(4797),
    [sym_shared] = ACTIONS(4797),
    [sym_static] = ACTIONS(4797),
    [sym_struct] = ACTIONS(4797),
    [sym_switch] = ACTIONS(4797),
    [sym_synchronized] = ACTIONS(4797),
    [sym_template] = ACTIONS(4797),
    [sym_throw] = ACTIONS(4797),
    [sym_try] = ACTIONS(4797),
    [sym_typeid] = ACTIONS(4797),
    [sym_typeof] = ACTIONS(4797),
    [sym_union] = ACTIONS(4797),
    [sym_unittest] = ACTIONS(4797),
    [sym_version] = ACTIONS(4797),
    [sym_while] = ACTIONS(4797),
    [sym_with] = ACTIONS(4797),
    [sym_gshared] = ACTIONS(4797),
    [sym_traits] = ACTIONS(4797),
    [sym_vector] = ACTIONS(4797),
    [sym_void] = ACTIONS(4797),
    [anon_sym_BQUOTE] = ACTIONS(4799),
    [anon_sym_r_DQUOTE] = ACTIONS(4799),
    [anon_sym_x_DQUOTE] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(4799),
    [anon_sym_i_BQUOTE] = ACTIONS(4799),
    [anon_sym_i_DQUOTE] = ACTIONS(4799),
    [anon_sym_iq_LBRACE] = ACTIONS(4799),
    [aux_sym_char_literal_token1] = ACTIONS(4799),
    [anon_sym_SQUOTE] = ACTIONS(4797),
    [anon_sym___DATE__] = ACTIONS(4797),
    [anon_sym___FILE__] = ACTIONS(4797),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4797),
    [anon_sym___FUNCTION__] = ACTIONS(4797),
    [anon_sym___LINE__] = ACTIONS(4797),
    [anon_sym___MODULE__] = ACTIONS(4797),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4797),
    [anon_sym___TIME__] = ACTIONS(4797),
    [anon_sym___TIMESTAMP__] = ACTIONS(4797),
    [anon_sym___VENDOR__] = ACTIONS(4797),
    [anon_sym___VERSION__] = ACTIONS(4797),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4799),
    [sym_float_literal] = ACTIONS(4799),
    [sym__string] = ACTIONS(4799),
  },
  [1454] = {
    [sym_identifier] = ACTIONS(4801),
    [anon_sym_q_LBRACE] = ACTIONS(4803),
    [anon_sym_RBRACE] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(4803),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_AMP] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4803),
    [anon_sym_PLUS] = ACTIONS(4801),
    [anon_sym_PLUS_PLUS] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(4803),
    [anon_sym_LPAREN] = ACTIONS(4803),
    [anon_sym_RPAREN] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4803),
    [anon_sym_DOLLAR] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [anon_sym_AT] = ACTIONS(4803),
    [sym_bool] = ACTIONS(4801),
    [sym_byte] = ACTIONS(4801),
    [sym_ubyte] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_short] = ACTIONS(4801),
    [sym_ushort] = ACTIONS(4801),
    [sym_int] = ACTIONS(4801),
    [sym_uint] = ACTIONS(4801),
    [sym_long] = ACTIONS(4801),
    [sym_ulong] = ACTIONS(4801),
    [sym_cent] = ACTIONS(4801),
    [sym_ucent] = ACTIONS(4801),
    [sym_wchar] = ACTIONS(4801),
    [sym_dchar] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_double] = ACTIONS(4801),
    [sym_real] = ACTIONS(4801),
    [sym_ifloat] = ACTIONS(4801),
    [sym_idouble] = ACTIONS(4801),
    [sym_ireal] = ACTIONS(4801),
    [sym_cfloat] = ACTIONS(4801),
    [sym_cdouble] = ACTIONS(4801),
    [sym_creal] = ACTIONS(4801),
    [sym_size_t] = ACTIONS(4801),
    [sym_ptrdiff_t] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym_cstring] = ACTIONS(4801),
    [sym_dstring] = ACTIONS(4801),
    [sym_wstring] = ACTIONS(4801),
    [sym_noreturn] = ACTIONS(4801),
    [sym_true] = ACTIONS(4801),
    [sym_false] = ACTIONS(4801),
    [sym_null] = ACTIONS(4801),
    [sym_super] = ACTIONS(4801),
    [sym_this] = ACTIONS(4801),
    [sym_abstract] = ACTIONS(4801),
    [sym_alias] = ACTIONS(4801),
    [sym_align] = ACTIONS(4801),
    [sym_asm] = ACTIONS(4801),
    [sym_assert] = ACTIONS(4801),
    [sym_auto] = ACTIONS(4801),
    [sym_break] = ACTIONS(4801),
    [sym_case] = ACTIONS(4801),
    [sym_cast] = ACTIONS(4801),
    [sym_catch] = ACTIONS(4801),
    [sym_class] = ACTIONS(4801),
    [sym_const] = ACTIONS(4801),
    [sym_continue] = ACTIONS(4801),
    [sym_debug] = ACTIONS(4801),
    [sym_default] = ACTIONS(4801),
    [sym_delegate] = ACTIONS(4801),
    [sym_delete] = ACTIONS(4801),
    [sym_deprecated] = ACTIONS(4801),
    [sym_do] = ACTIONS(4801),
    [sym_else] = ACTIONS(4801),
    [sym_enum] = ACTIONS(4801),
    [sym_export] = ACTIONS(4801),
    [sym_extern] = ACTIONS(4801),
    [sym_final] = ACTIONS(4801),
    [sym_finally] = ACTIONS(4801),
    [sym_for] = ACTIONS(4801),
    [sym_foreach] = ACTIONS(4801),
    [sym_foreach_reverse] = ACTIONS(4801),
    [sym_function] = ACTIONS(4801),
    [sym_goto] = ACTIONS(4801),
    [sym_if] = ACTIONS(4801),
    [sym_immutable] = ACTIONS(4801),
    [sym_import] = ACTIONS(4801),
    [sym_in] = ACTIONS(4801),
    [sym_inout] = ACTIONS(4801),
    [sym_interface] = ACTIONS(4801),
    [sym_invariant] = ACTIONS(4801),
    [sym_is] = ACTIONS(4801),
    [sym_mixin] = ACTIONS(4801),
    [sym_new] = ACTIONS(4801),
    [sym_nothrow] = ACTIONS(4801),
    [sym_out] = ACTIONS(4801),
    [sym_override] = ACTIONS(4801),
    [sym_package] = ACTIONS(4801),
    [sym_pragma] = ACTIONS(4801),
    [sym_private] = ACTIONS(4801),
    [sym_protected] = ACTIONS(4801),
    [sym_public] = ACTIONS(4801),
    [sym_pure] = ACTIONS(4801),
    [sym_ref] = ACTIONS(4801),
    [sym_return] = ACTIONS(4801),
    [sym_scope] = ACTIONS(4801),
    [sym_shared] = ACTIONS(4801),
    [sym_static] = ACTIONS(4801),
    [sym_struct] = ACTIONS(4801),
    [sym_switch] = ACTIONS(4801),
    [sym_synchronized] = ACTIONS(4801),
    [sym_template] = ACTIONS(4801),
    [sym_throw] = ACTIONS(4801),
    [sym_try] = ACTIONS(4801),
    [sym_typeid] = ACTIONS(4801),
    [sym_typeof] = ACTIONS(4801),
    [sym_union] = ACTIONS(4801),
    [sym_unittest] = ACTIONS(4801),
    [sym_version] = ACTIONS(4801),
    [sym_while] = ACTIONS(4801),
    [sym_with] = ACTIONS(4801),
    [sym_gshared] = ACTIONS(4801),
    [sym_traits] = ACTIONS(4801),
    [sym_vector] = ACTIONS(4801),
    [sym_void] = ACTIONS(4801),
    [anon_sym_BQUOTE] = ACTIONS(4803),
    [anon_sym_r_DQUOTE] = ACTIONS(4803),
    [anon_sym_x_DQUOTE] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(4803),
    [anon_sym_i_BQUOTE] = ACTIONS(4803),
    [anon_sym_i_DQUOTE] = ACTIONS(4803),
    [anon_sym_iq_LBRACE] = ACTIONS(4803),
    [aux_sym_char_literal_token1] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4801),
    [anon_sym___DATE__] = ACTIONS(4801),
    [anon_sym___FILE__] = ACTIONS(4801),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4801),
    [anon_sym___FUNCTION__] = ACTIONS(4801),
    [anon_sym___LINE__] = ACTIONS(4801),
    [anon_sym___MODULE__] = ACTIONS(4801),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4801),
    [anon_sym___TIME__] = ACTIONS(4801),
    [anon_sym___TIMESTAMP__] = ACTIONS(4801),
    [anon_sym___VENDOR__] = ACTIONS(4801),
    [anon_sym___VERSION__] = ACTIONS(4801),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4803),
    [sym_float_literal] = ACTIONS(4803),
    [sym__string] = ACTIONS(4803),
  },
  [1455] = {
    [sym_identifier] = ACTIONS(4805),
    [anon_sym_q_LBRACE] = ACTIONS(4807),
    [anon_sym_RBRACE] = ACTIONS(4807),
    [anon_sym_LBRACE] = ACTIONS(4807),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_DASH] = ACTIONS(4805),
    [anon_sym_DASH_DASH] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(4805),
    [anon_sym_PLUS_PLUS] = ACTIONS(4807),
    [anon_sym_BANG] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(4807),
    [anon_sym_RPAREN] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4807),
    [anon_sym_SEMI] = ACTIONS(4807),
    [anon_sym_DOLLAR] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [anon_sym_AT] = ACTIONS(4807),
    [sym_bool] = ACTIONS(4805),
    [sym_byte] = ACTIONS(4805),
    [sym_ubyte] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_short] = ACTIONS(4805),
    [sym_ushort] = ACTIONS(4805),
    [sym_int] = ACTIONS(4805),
    [sym_uint] = ACTIONS(4805),
    [sym_long] = ACTIONS(4805),
    [sym_ulong] = ACTIONS(4805),
    [sym_cent] = ACTIONS(4805),
    [sym_ucent] = ACTIONS(4805),
    [sym_wchar] = ACTIONS(4805),
    [sym_dchar] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_double] = ACTIONS(4805),
    [sym_real] = ACTIONS(4805),
    [sym_ifloat] = ACTIONS(4805),
    [sym_idouble] = ACTIONS(4805),
    [sym_ireal] = ACTIONS(4805),
    [sym_cfloat] = ACTIONS(4805),
    [sym_cdouble] = ACTIONS(4805),
    [sym_creal] = ACTIONS(4805),
    [sym_size_t] = ACTIONS(4805),
    [sym_ptrdiff_t] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym_cstring] = ACTIONS(4805),
    [sym_dstring] = ACTIONS(4805),
    [sym_wstring] = ACTIONS(4805),
    [sym_noreturn] = ACTIONS(4805),
    [sym_true] = ACTIONS(4805),
    [sym_false] = ACTIONS(4805),
    [sym_null] = ACTIONS(4805),
    [sym_super] = ACTIONS(4805),
    [sym_this] = ACTIONS(4805),
    [sym_abstract] = ACTIONS(4805),
    [sym_alias] = ACTIONS(4805),
    [sym_align] = ACTIONS(4805),
    [sym_asm] = ACTIONS(4805),
    [sym_assert] = ACTIONS(4805),
    [sym_auto] = ACTIONS(4805),
    [sym_break] = ACTIONS(4805),
    [sym_case] = ACTIONS(4805),
    [sym_cast] = ACTIONS(4805),
    [sym_catch] = ACTIONS(4805),
    [sym_class] = ACTIONS(4805),
    [sym_const] = ACTIONS(4805),
    [sym_continue] = ACTIONS(4805),
    [sym_debug] = ACTIONS(4805),
    [sym_default] = ACTIONS(4805),
    [sym_delegate] = ACTIONS(4805),
    [sym_delete] = ACTIONS(4805),
    [sym_deprecated] = ACTIONS(4805),
    [sym_do] = ACTIONS(4805),
    [sym_else] = ACTIONS(4805),
    [sym_enum] = ACTIONS(4805),
    [sym_export] = ACTIONS(4805),
    [sym_extern] = ACTIONS(4805),
    [sym_final] = ACTIONS(4805),
    [sym_finally] = ACTIONS(4805),
    [sym_for] = ACTIONS(4805),
    [sym_foreach] = ACTIONS(4805),
    [sym_foreach_reverse] = ACTIONS(4805),
    [sym_function] = ACTIONS(4805),
    [sym_goto] = ACTIONS(4805),
    [sym_if] = ACTIONS(4805),
    [sym_immutable] = ACTIONS(4805),
    [sym_import] = ACTIONS(4805),
    [sym_in] = ACTIONS(4805),
    [sym_inout] = ACTIONS(4805),
    [sym_interface] = ACTIONS(4805),
    [sym_invariant] = ACTIONS(4805),
    [sym_is] = ACTIONS(4805),
    [sym_mixin] = ACTIONS(4805),
    [sym_new] = ACTIONS(4805),
    [sym_nothrow] = ACTIONS(4805),
    [sym_out] = ACTIONS(4805),
    [sym_override] = ACTIONS(4805),
    [sym_package] = ACTIONS(4805),
    [sym_pragma] = ACTIONS(4805),
    [sym_private] = ACTIONS(4805),
    [sym_protected] = ACTIONS(4805),
    [sym_public] = ACTIONS(4805),
    [sym_pure] = ACTIONS(4805),
    [sym_ref] = ACTIONS(4805),
    [sym_return] = ACTIONS(4805),
    [sym_scope] = ACTIONS(4805),
    [sym_shared] = ACTIONS(4805),
    [sym_static] = ACTIONS(4805),
    [sym_struct] = ACTIONS(4805),
    [sym_switch] = ACTIONS(4805),
    [sym_synchronized] = ACTIONS(4805),
    [sym_template] = ACTIONS(4805),
    [sym_throw] = ACTIONS(4805),
    [sym_try] = ACTIONS(4805),
    [sym_typeid] = ACTIONS(4805),
    [sym_typeof] = ACTIONS(4805),
    [sym_union] = ACTIONS(4805),
    [sym_unittest] = ACTIONS(4805),
    [sym_version] = ACTIONS(4805),
    [sym_while] = ACTIONS(4805),
    [sym_with] = ACTIONS(4805),
    [sym_gshared] = ACTIONS(4805),
    [sym_traits] = ACTIONS(4805),
    [sym_vector] = ACTIONS(4805),
    [sym_void] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4807),
    [anon_sym_r_DQUOTE] = ACTIONS(4807),
    [anon_sym_x_DQUOTE] = ACTIONS(4807),
    [anon_sym_DQUOTE] = ACTIONS(4807),
    [anon_sym_i_BQUOTE] = ACTIONS(4807),
    [anon_sym_i_DQUOTE] = ACTIONS(4807),
    [anon_sym_iq_LBRACE] = ACTIONS(4807),
    [aux_sym_char_literal_token1] = ACTIONS(4807),
    [anon_sym_SQUOTE] = ACTIONS(4805),
    [anon_sym___DATE__] = ACTIONS(4805),
    [anon_sym___FILE__] = ACTIONS(4805),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4805),
    [anon_sym___FUNCTION__] = ACTIONS(4805),
    [anon_sym___LINE__] = ACTIONS(4805),
    [anon_sym___MODULE__] = ACTIONS(4805),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4805),
    [anon_sym___TIME__] = ACTIONS(4805),
    [anon_sym___TIMESTAMP__] = ACTIONS(4805),
    [anon_sym___VENDOR__] = ACTIONS(4805),
    [anon_sym___VERSION__] = ACTIONS(4805),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4807),
    [sym_float_literal] = ACTIONS(4807),
    [sym__string] = ACTIONS(4807),
  },
  [1456] = {
    [sym_identifier] = ACTIONS(4809),
    [anon_sym_q_LBRACE] = ACTIONS(4811),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4811),
    [anon_sym_AMP] = ACTIONS(4811),
    [anon_sym_DASH] = ACTIONS(4809),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4809),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_BANG] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(4811),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_DOLLAR] = ACTIONS(4811),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_TILDE] = ACTIONS(4811),
    [anon_sym_AT] = ACTIONS(4811),
    [sym_bool] = ACTIONS(4809),
    [sym_byte] = ACTIONS(4809),
    [sym_ubyte] = ACTIONS(4809),
    [sym_char] = ACTIONS(4809),
    [sym_short] = ACTIONS(4809),
    [sym_ushort] = ACTIONS(4809),
    [sym_int] = ACTIONS(4809),
    [sym_uint] = ACTIONS(4809),
    [sym_long] = ACTIONS(4809),
    [sym_ulong] = ACTIONS(4809),
    [sym_cent] = ACTIONS(4809),
    [sym_ucent] = ACTIONS(4809),
    [sym_wchar] = ACTIONS(4809),
    [sym_dchar] = ACTIONS(4809),
    [sym_float] = ACTIONS(4809),
    [sym_double] = ACTIONS(4809),
    [sym_real] = ACTIONS(4809),
    [sym_ifloat] = ACTIONS(4809),
    [sym_idouble] = ACTIONS(4809),
    [sym_ireal] = ACTIONS(4809),
    [sym_cfloat] = ACTIONS(4809),
    [sym_cdouble] = ACTIONS(4809),
    [sym_creal] = ACTIONS(4809),
    [sym_size_t] = ACTIONS(4809),
    [sym_ptrdiff_t] = ACTIONS(4809),
    [sym_string] = ACTIONS(4809),
    [sym_cstring] = ACTIONS(4809),
    [sym_dstring] = ACTIONS(4809),
    [sym_wstring] = ACTIONS(4809),
    [sym_noreturn] = ACTIONS(4809),
    [sym_true] = ACTIONS(4809),
    [sym_false] = ACTIONS(4809),
    [sym_null] = ACTIONS(4809),
    [sym_super] = ACTIONS(4809),
    [sym_this] = ACTIONS(4809),
    [sym_abstract] = ACTIONS(4809),
    [sym_alias] = ACTIONS(4809),
    [sym_align] = ACTIONS(4809),
    [sym_asm] = ACTIONS(4809),
    [sym_assert] = ACTIONS(4809),
    [sym_auto] = ACTIONS(4809),
    [sym_break] = ACTIONS(4809),
    [sym_case] = ACTIONS(4809),
    [sym_cast] = ACTIONS(4809),
    [sym_catch] = ACTIONS(4809),
    [sym_class] = ACTIONS(4809),
    [sym_const] = ACTIONS(4809),
    [sym_continue] = ACTIONS(4809),
    [sym_debug] = ACTIONS(4809),
    [sym_default] = ACTIONS(4809),
    [sym_delegate] = ACTIONS(4809),
    [sym_delete] = ACTIONS(4809),
    [sym_deprecated] = ACTIONS(4809),
    [sym_do] = ACTIONS(4809),
    [sym_else] = ACTIONS(4809),
    [sym_enum] = ACTIONS(4809),
    [sym_export] = ACTIONS(4809),
    [sym_extern] = ACTIONS(4809),
    [sym_final] = ACTIONS(4809),
    [sym_finally] = ACTIONS(4809),
    [sym_for] = ACTIONS(4809),
    [sym_foreach] = ACTIONS(4809),
    [sym_foreach_reverse] = ACTIONS(4809),
    [sym_function] = ACTIONS(4809),
    [sym_goto] = ACTIONS(4809),
    [sym_if] = ACTIONS(4809),
    [sym_immutable] = ACTIONS(4809),
    [sym_import] = ACTIONS(4809),
    [sym_in] = ACTIONS(4809),
    [sym_inout] = ACTIONS(4809),
    [sym_interface] = ACTIONS(4809),
    [sym_invariant] = ACTIONS(4809),
    [sym_is] = ACTIONS(4809),
    [sym_mixin] = ACTIONS(4809),
    [sym_new] = ACTIONS(4809),
    [sym_nothrow] = ACTIONS(4809),
    [sym_out] = ACTIONS(4809),
    [sym_override] = ACTIONS(4809),
    [sym_package] = ACTIONS(4809),
    [sym_pragma] = ACTIONS(4809),
    [sym_private] = ACTIONS(4809),
    [sym_protected] = ACTIONS(4809),
    [sym_public] = ACTIONS(4809),
    [sym_pure] = ACTIONS(4809),
    [sym_ref] = ACTIONS(4809),
    [sym_return] = ACTIONS(4809),
    [sym_scope] = ACTIONS(4809),
    [sym_shared] = ACTIONS(4809),
    [sym_static] = ACTIONS(4809),
    [sym_struct] = ACTIONS(4809),
    [sym_switch] = ACTIONS(4809),
    [sym_synchronized] = ACTIONS(4809),
    [sym_template] = ACTIONS(4809),
    [sym_throw] = ACTIONS(4809),
    [sym_try] = ACTIONS(4809),
    [sym_typeid] = ACTIONS(4809),
    [sym_typeof] = ACTIONS(4809),
    [sym_union] = ACTIONS(4809),
    [sym_unittest] = ACTIONS(4809),
    [sym_version] = ACTIONS(4809),
    [sym_while] = ACTIONS(4809),
    [sym_with] = ACTIONS(4809),
    [sym_gshared] = ACTIONS(4809),
    [sym_traits] = ACTIONS(4809),
    [sym_vector] = ACTIONS(4809),
    [sym_void] = ACTIONS(4809),
    [anon_sym_BQUOTE] = ACTIONS(4811),
    [anon_sym_r_DQUOTE] = ACTIONS(4811),
    [anon_sym_x_DQUOTE] = ACTIONS(4811),
    [anon_sym_DQUOTE] = ACTIONS(4811),
    [anon_sym_i_BQUOTE] = ACTIONS(4811),
    [anon_sym_i_DQUOTE] = ACTIONS(4811),
    [anon_sym_iq_LBRACE] = ACTIONS(4811),
    [aux_sym_char_literal_token1] = ACTIONS(4811),
    [anon_sym_SQUOTE] = ACTIONS(4809),
    [anon_sym___DATE__] = ACTIONS(4809),
    [anon_sym___FILE__] = ACTIONS(4809),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4809),
    [anon_sym___FUNCTION__] = ACTIONS(4809),
    [anon_sym___LINE__] = ACTIONS(4809),
    [anon_sym___MODULE__] = ACTIONS(4809),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4809),
    [anon_sym___TIME__] = ACTIONS(4809),
    [anon_sym___TIMESTAMP__] = ACTIONS(4809),
    [anon_sym___VENDOR__] = ACTIONS(4809),
    [anon_sym___VERSION__] = ACTIONS(4809),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4811),
    [sym_float_literal] = ACTIONS(4811),
    [sym__string] = ACTIONS(4811),
  },
  [1457] = {
    [sym_identifier] = ACTIONS(4813),
    [anon_sym_q_LBRACE] = ACTIONS(4815),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_LBRACE] = ACTIONS(4815),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4813),
    [anon_sym_DASH_DASH] = ACTIONS(4815),
    [anon_sym_PLUS] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_LPAREN] = ACTIONS(4815),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(4815),
    [anon_sym_SEMI] = ACTIONS(4815),
    [anon_sym_DOLLAR] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4815),
    [anon_sym_AT] = ACTIONS(4815),
    [sym_bool] = ACTIONS(4813),
    [sym_byte] = ACTIONS(4813),
    [sym_ubyte] = ACTIONS(4813),
    [sym_char] = ACTIONS(4813),
    [sym_short] = ACTIONS(4813),
    [sym_ushort] = ACTIONS(4813),
    [sym_int] = ACTIONS(4813),
    [sym_uint] = ACTIONS(4813),
    [sym_long] = ACTIONS(4813),
    [sym_ulong] = ACTIONS(4813),
    [sym_cent] = ACTIONS(4813),
    [sym_ucent] = ACTIONS(4813),
    [sym_wchar] = ACTIONS(4813),
    [sym_dchar] = ACTIONS(4813),
    [sym_float] = ACTIONS(4813),
    [sym_double] = ACTIONS(4813),
    [sym_real] = ACTIONS(4813),
    [sym_ifloat] = ACTIONS(4813),
    [sym_idouble] = ACTIONS(4813),
    [sym_ireal] = ACTIONS(4813),
    [sym_cfloat] = ACTIONS(4813),
    [sym_cdouble] = ACTIONS(4813),
    [sym_creal] = ACTIONS(4813),
    [sym_size_t] = ACTIONS(4813),
    [sym_ptrdiff_t] = ACTIONS(4813),
    [sym_string] = ACTIONS(4813),
    [sym_cstring] = ACTIONS(4813),
    [sym_dstring] = ACTIONS(4813),
    [sym_wstring] = ACTIONS(4813),
    [sym_noreturn] = ACTIONS(4813),
    [sym_true] = ACTIONS(4813),
    [sym_false] = ACTIONS(4813),
    [sym_null] = ACTIONS(4813),
    [sym_super] = ACTIONS(4813),
    [sym_this] = ACTIONS(4813),
    [sym_abstract] = ACTIONS(4813),
    [sym_alias] = ACTIONS(4813),
    [sym_align] = ACTIONS(4813),
    [sym_asm] = ACTIONS(4813),
    [sym_assert] = ACTIONS(4813),
    [sym_auto] = ACTIONS(4813),
    [sym_break] = ACTIONS(4813),
    [sym_case] = ACTIONS(4813),
    [sym_cast] = ACTIONS(4813),
    [sym_catch] = ACTIONS(4813),
    [sym_class] = ACTIONS(4813),
    [sym_const] = ACTIONS(4813),
    [sym_continue] = ACTIONS(4813),
    [sym_debug] = ACTIONS(4813),
    [sym_default] = ACTIONS(4813),
    [sym_delegate] = ACTIONS(4813),
    [sym_delete] = ACTIONS(4813),
    [sym_deprecated] = ACTIONS(4813),
    [sym_do] = ACTIONS(4813),
    [sym_else] = ACTIONS(4813),
    [sym_enum] = ACTIONS(4813),
    [sym_export] = ACTIONS(4813),
    [sym_extern] = ACTIONS(4813),
    [sym_final] = ACTIONS(4813),
    [sym_finally] = ACTIONS(4813),
    [sym_for] = ACTIONS(4813),
    [sym_foreach] = ACTIONS(4813),
    [sym_foreach_reverse] = ACTIONS(4813),
    [sym_function] = ACTIONS(4813),
    [sym_goto] = ACTIONS(4813),
    [sym_if] = ACTIONS(4813),
    [sym_immutable] = ACTIONS(4813),
    [sym_import] = ACTIONS(4813),
    [sym_in] = ACTIONS(4813),
    [sym_inout] = ACTIONS(4813),
    [sym_interface] = ACTIONS(4813),
    [sym_invariant] = ACTIONS(4813),
    [sym_is] = ACTIONS(4813),
    [sym_mixin] = ACTIONS(4813),
    [sym_new] = ACTIONS(4813),
    [sym_nothrow] = ACTIONS(4813),
    [sym_out] = ACTIONS(4813),
    [sym_override] = ACTIONS(4813),
    [sym_package] = ACTIONS(4813),
    [sym_pragma] = ACTIONS(4813),
    [sym_private] = ACTIONS(4813),
    [sym_protected] = ACTIONS(4813),
    [sym_public] = ACTIONS(4813),
    [sym_pure] = ACTIONS(4813),
    [sym_ref] = ACTIONS(4813),
    [sym_return] = ACTIONS(4813),
    [sym_scope] = ACTIONS(4813),
    [sym_shared] = ACTIONS(4813),
    [sym_static] = ACTIONS(4813),
    [sym_struct] = ACTIONS(4813),
    [sym_switch] = ACTIONS(4813),
    [sym_synchronized] = ACTIONS(4813),
    [sym_template] = ACTIONS(4813),
    [sym_throw] = ACTIONS(4813),
    [sym_try] = ACTIONS(4813),
    [sym_typeid] = ACTIONS(4813),
    [sym_typeof] = ACTIONS(4813),
    [sym_union] = ACTIONS(4813),
    [sym_unittest] = ACTIONS(4813),
    [sym_version] = ACTIONS(4813),
    [sym_while] = ACTIONS(4813),
    [sym_with] = ACTIONS(4813),
    [sym_gshared] = ACTIONS(4813),
    [sym_traits] = ACTIONS(4813),
    [sym_vector] = ACTIONS(4813),
    [sym_void] = ACTIONS(4813),
    [anon_sym_BQUOTE] = ACTIONS(4815),
    [anon_sym_r_DQUOTE] = ACTIONS(4815),
    [anon_sym_x_DQUOTE] = ACTIONS(4815),
    [anon_sym_DQUOTE] = ACTIONS(4815),
    [anon_sym_i_BQUOTE] = ACTIONS(4815),
    [anon_sym_i_DQUOTE] = ACTIONS(4815),
    [anon_sym_iq_LBRACE] = ACTIONS(4815),
    [aux_sym_char_literal_token1] = ACTIONS(4815),
    [anon_sym_SQUOTE] = ACTIONS(4813),
    [anon_sym___DATE__] = ACTIONS(4813),
    [anon_sym___FILE__] = ACTIONS(4813),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4813),
    [anon_sym___FUNCTION__] = ACTIONS(4813),
    [anon_sym___LINE__] = ACTIONS(4813),
    [anon_sym___MODULE__] = ACTIONS(4813),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4813),
    [anon_sym___TIME__] = ACTIONS(4813),
    [anon_sym___TIMESTAMP__] = ACTIONS(4813),
    [anon_sym___VENDOR__] = ACTIONS(4813),
    [anon_sym___VERSION__] = ACTIONS(4813),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4815),
    [sym_float_literal] = ACTIONS(4815),
    [sym__string] = ACTIONS(4815),
  },
  [1458] = {
    [sym_identifier] = ACTIONS(4817),
    [anon_sym_q_LBRACE] = ACTIONS(4819),
    [anon_sym_RBRACE] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4819),
    [anon_sym_DOT] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4817),
    [anon_sym_DASH_DASH] = ACTIONS(4819),
    [anon_sym_PLUS] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4819),
    [anon_sym_BANG] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym_RPAREN] = ACTIONS(4819),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_DOLLAR] = ACTIONS(4819),
    [anon_sym_STAR] = ACTIONS(4819),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_AT] = ACTIONS(4819),
    [sym_bool] = ACTIONS(4817),
    [sym_byte] = ACTIONS(4817),
    [sym_ubyte] = ACTIONS(4817),
    [sym_char] = ACTIONS(4817),
    [sym_short] = ACTIONS(4817),
    [sym_ushort] = ACTIONS(4817),
    [sym_int] = ACTIONS(4817),
    [sym_uint] = ACTIONS(4817),
    [sym_long] = ACTIONS(4817),
    [sym_ulong] = ACTIONS(4817),
    [sym_cent] = ACTIONS(4817),
    [sym_ucent] = ACTIONS(4817),
    [sym_wchar] = ACTIONS(4817),
    [sym_dchar] = ACTIONS(4817),
    [sym_float] = ACTIONS(4817),
    [sym_double] = ACTIONS(4817),
    [sym_real] = ACTIONS(4817),
    [sym_ifloat] = ACTIONS(4817),
    [sym_idouble] = ACTIONS(4817),
    [sym_ireal] = ACTIONS(4817),
    [sym_cfloat] = ACTIONS(4817),
    [sym_cdouble] = ACTIONS(4817),
    [sym_creal] = ACTIONS(4817),
    [sym_size_t] = ACTIONS(4817),
    [sym_ptrdiff_t] = ACTIONS(4817),
    [sym_string] = ACTIONS(4817),
    [sym_cstring] = ACTIONS(4817),
    [sym_dstring] = ACTIONS(4817),
    [sym_wstring] = ACTIONS(4817),
    [sym_noreturn] = ACTIONS(4817),
    [sym_true] = ACTIONS(4817),
    [sym_false] = ACTIONS(4817),
    [sym_null] = ACTIONS(4817),
    [sym_super] = ACTIONS(4817),
    [sym_this] = ACTIONS(4817),
    [sym_abstract] = ACTIONS(4817),
    [sym_alias] = ACTIONS(4817),
    [sym_align] = ACTIONS(4817),
    [sym_asm] = ACTIONS(4817),
    [sym_assert] = ACTIONS(4817),
    [sym_auto] = ACTIONS(4817),
    [sym_break] = ACTIONS(4817),
    [sym_case] = ACTIONS(4817),
    [sym_cast] = ACTIONS(4817),
    [sym_catch] = ACTIONS(4817),
    [sym_class] = ACTIONS(4817),
    [sym_const] = ACTIONS(4817),
    [sym_continue] = ACTIONS(4817),
    [sym_debug] = ACTIONS(4817),
    [sym_default] = ACTIONS(4817),
    [sym_delegate] = ACTIONS(4817),
    [sym_delete] = ACTIONS(4817),
    [sym_deprecated] = ACTIONS(4817),
    [sym_do] = ACTIONS(4817),
    [sym_else] = ACTIONS(4817),
    [sym_enum] = ACTIONS(4817),
    [sym_export] = ACTIONS(4817),
    [sym_extern] = ACTIONS(4817),
    [sym_final] = ACTIONS(4817),
    [sym_finally] = ACTIONS(4817),
    [sym_for] = ACTIONS(4817),
    [sym_foreach] = ACTIONS(4817),
    [sym_foreach_reverse] = ACTIONS(4817),
    [sym_function] = ACTIONS(4817),
    [sym_goto] = ACTIONS(4817),
    [sym_if] = ACTIONS(4817),
    [sym_immutable] = ACTIONS(4817),
    [sym_import] = ACTIONS(4817),
    [sym_in] = ACTIONS(4817),
    [sym_inout] = ACTIONS(4817),
    [sym_interface] = ACTIONS(4817),
    [sym_invariant] = ACTIONS(4817),
    [sym_is] = ACTIONS(4817),
    [sym_mixin] = ACTIONS(4817),
    [sym_new] = ACTIONS(4817),
    [sym_nothrow] = ACTIONS(4817),
    [sym_out] = ACTIONS(4817),
    [sym_override] = ACTIONS(4817),
    [sym_package] = ACTIONS(4817),
    [sym_pragma] = ACTIONS(4817),
    [sym_private] = ACTIONS(4817),
    [sym_protected] = ACTIONS(4817),
    [sym_public] = ACTIONS(4817),
    [sym_pure] = ACTIONS(4817),
    [sym_ref] = ACTIONS(4817),
    [sym_return] = ACTIONS(4817),
    [sym_scope] = ACTIONS(4817),
    [sym_shared] = ACTIONS(4817),
    [sym_static] = ACTIONS(4817),
    [sym_struct] = ACTIONS(4817),
    [sym_switch] = ACTIONS(4817),
    [sym_synchronized] = ACTIONS(4817),
    [sym_template] = ACTIONS(4817),
    [sym_throw] = ACTIONS(4817),
    [sym_try] = ACTIONS(4817),
    [sym_typeid] = ACTIONS(4817),
    [sym_typeof] = ACTIONS(4817),
    [sym_union] = ACTIONS(4817),
    [sym_unittest] = ACTIONS(4817),
    [sym_version] = ACTIONS(4817),
    [sym_while] = ACTIONS(4817),
    [sym_with] = ACTIONS(4817),
    [sym_gshared] = ACTIONS(4817),
    [sym_traits] = ACTIONS(4817),
    [sym_vector] = ACTIONS(4817),
    [sym_void] = ACTIONS(4817),
    [anon_sym_BQUOTE] = ACTIONS(4819),
    [anon_sym_r_DQUOTE] = ACTIONS(4819),
    [anon_sym_x_DQUOTE] = ACTIONS(4819),
    [anon_sym_DQUOTE] = ACTIONS(4819),
    [anon_sym_i_BQUOTE] = ACTIONS(4819),
    [anon_sym_i_DQUOTE] = ACTIONS(4819),
    [anon_sym_iq_LBRACE] = ACTIONS(4819),
    [aux_sym_char_literal_token1] = ACTIONS(4819),
    [anon_sym_SQUOTE] = ACTIONS(4817),
    [anon_sym___DATE__] = ACTIONS(4817),
    [anon_sym___FILE__] = ACTIONS(4817),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4817),
    [anon_sym___FUNCTION__] = ACTIONS(4817),
    [anon_sym___LINE__] = ACTIONS(4817),
    [anon_sym___MODULE__] = ACTIONS(4817),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4817),
    [anon_sym___TIME__] = ACTIONS(4817),
    [anon_sym___TIMESTAMP__] = ACTIONS(4817),
    [anon_sym___VENDOR__] = ACTIONS(4817),
    [anon_sym___VERSION__] = ACTIONS(4817),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4819),
    [sym_float_literal] = ACTIONS(4819),
    [sym__string] = ACTIONS(4819),
  },
  [1459] = {
    [sym_identifier] = ACTIONS(4821),
    [anon_sym_q_LBRACE] = ACTIONS(4823),
    [anon_sym_RBRACE] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4823),
    [anon_sym_DOT] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4821),
    [anon_sym_DASH_DASH] = ACTIONS(4823),
    [anon_sym_PLUS] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4823),
    [anon_sym_BANG] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4823),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_DOLLAR] = ACTIONS(4823),
    [anon_sym_STAR] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(4823),
    [sym_bool] = ACTIONS(4821),
    [sym_byte] = ACTIONS(4821),
    [sym_ubyte] = ACTIONS(4821),
    [sym_char] = ACTIONS(4821),
    [sym_short] = ACTIONS(4821),
    [sym_ushort] = ACTIONS(4821),
    [sym_int] = ACTIONS(4821),
    [sym_uint] = ACTIONS(4821),
    [sym_long] = ACTIONS(4821),
    [sym_ulong] = ACTIONS(4821),
    [sym_cent] = ACTIONS(4821),
    [sym_ucent] = ACTIONS(4821),
    [sym_wchar] = ACTIONS(4821),
    [sym_dchar] = ACTIONS(4821),
    [sym_float] = ACTIONS(4821),
    [sym_double] = ACTIONS(4821),
    [sym_real] = ACTIONS(4821),
    [sym_ifloat] = ACTIONS(4821),
    [sym_idouble] = ACTIONS(4821),
    [sym_ireal] = ACTIONS(4821),
    [sym_cfloat] = ACTIONS(4821),
    [sym_cdouble] = ACTIONS(4821),
    [sym_creal] = ACTIONS(4821),
    [sym_size_t] = ACTIONS(4821),
    [sym_ptrdiff_t] = ACTIONS(4821),
    [sym_string] = ACTIONS(4821),
    [sym_cstring] = ACTIONS(4821),
    [sym_dstring] = ACTIONS(4821),
    [sym_wstring] = ACTIONS(4821),
    [sym_noreturn] = ACTIONS(4821),
    [sym_true] = ACTIONS(4821),
    [sym_false] = ACTIONS(4821),
    [sym_null] = ACTIONS(4821),
    [sym_super] = ACTIONS(4821),
    [sym_this] = ACTIONS(4821),
    [sym_abstract] = ACTIONS(4821),
    [sym_alias] = ACTIONS(4821),
    [sym_align] = ACTIONS(4821),
    [sym_asm] = ACTIONS(4821),
    [sym_assert] = ACTIONS(4821),
    [sym_auto] = ACTIONS(4821),
    [sym_break] = ACTIONS(4821),
    [sym_case] = ACTIONS(4821),
    [sym_cast] = ACTIONS(4821),
    [sym_catch] = ACTIONS(4821),
    [sym_class] = ACTIONS(4821),
    [sym_const] = ACTIONS(4821),
    [sym_continue] = ACTIONS(4821),
    [sym_debug] = ACTIONS(4821),
    [sym_default] = ACTIONS(4821),
    [sym_delegate] = ACTIONS(4821),
    [sym_delete] = ACTIONS(4821),
    [sym_deprecated] = ACTIONS(4821),
    [sym_do] = ACTIONS(4821),
    [sym_else] = ACTIONS(4821),
    [sym_enum] = ACTIONS(4821),
    [sym_export] = ACTIONS(4821),
    [sym_extern] = ACTIONS(4821),
    [sym_final] = ACTIONS(4821),
    [sym_finally] = ACTIONS(4821),
    [sym_for] = ACTIONS(4821),
    [sym_foreach] = ACTIONS(4821),
    [sym_foreach_reverse] = ACTIONS(4821),
    [sym_function] = ACTIONS(4821),
    [sym_goto] = ACTIONS(4821),
    [sym_if] = ACTIONS(4821),
    [sym_immutable] = ACTIONS(4821),
    [sym_import] = ACTIONS(4821),
    [sym_in] = ACTIONS(4821),
    [sym_inout] = ACTIONS(4821),
    [sym_interface] = ACTIONS(4821),
    [sym_invariant] = ACTIONS(4821),
    [sym_is] = ACTIONS(4821),
    [sym_mixin] = ACTIONS(4821),
    [sym_new] = ACTIONS(4821),
    [sym_nothrow] = ACTIONS(4821),
    [sym_out] = ACTIONS(4821),
    [sym_override] = ACTIONS(4821),
    [sym_package] = ACTIONS(4821),
    [sym_pragma] = ACTIONS(4821),
    [sym_private] = ACTIONS(4821),
    [sym_protected] = ACTIONS(4821),
    [sym_public] = ACTIONS(4821),
    [sym_pure] = ACTIONS(4821),
    [sym_ref] = ACTIONS(4821),
    [sym_return] = ACTIONS(4821),
    [sym_scope] = ACTIONS(4821),
    [sym_shared] = ACTIONS(4821),
    [sym_static] = ACTIONS(4821),
    [sym_struct] = ACTIONS(4821),
    [sym_switch] = ACTIONS(4821),
    [sym_synchronized] = ACTIONS(4821),
    [sym_template] = ACTIONS(4821),
    [sym_throw] = ACTIONS(4821),
    [sym_try] = ACTIONS(4821),
    [sym_typeid] = ACTIONS(4821),
    [sym_typeof] = ACTIONS(4821),
    [sym_union] = ACTIONS(4821),
    [sym_unittest] = ACTIONS(4821),
    [sym_version] = ACTIONS(4821),
    [sym_while] = ACTIONS(4821),
    [sym_with] = ACTIONS(4821),
    [sym_gshared] = ACTIONS(4821),
    [sym_traits] = ACTIONS(4821),
    [sym_vector] = ACTIONS(4821),
    [sym_void] = ACTIONS(4821),
    [anon_sym_BQUOTE] = ACTIONS(4823),
    [anon_sym_r_DQUOTE] = ACTIONS(4823),
    [anon_sym_x_DQUOTE] = ACTIONS(4823),
    [anon_sym_DQUOTE] = ACTIONS(4823),
    [anon_sym_i_BQUOTE] = ACTIONS(4823),
    [anon_sym_i_DQUOTE] = ACTIONS(4823),
    [anon_sym_iq_LBRACE] = ACTIONS(4823),
    [aux_sym_char_literal_token1] = ACTIONS(4823),
    [anon_sym_SQUOTE] = ACTIONS(4821),
    [anon_sym___DATE__] = ACTIONS(4821),
    [anon_sym___FILE__] = ACTIONS(4821),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4821),
    [anon_sym___FUNCTION__] = ACTIONS(4821),
    [anon_sym___LINE__] = ACTIONS(4821),
    [anon_sym___MODULE__] = ACTIONS(4821),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4821),
    [anon_sym___TIME__] = ACTIONS(4821),
    [anon_sym___TIMESTAMP__] = ACTIONS(4821),
    [anon_sym___VENDOR__] = ACTIONS(4821),
    [anon_sym___VERSION__] = ACTIONS(4821),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4823),
    [sym_float_literal] = ACTIONS(4823),
    [sym__string] = ACTIONS(4823),
  },
  [1460] = {
    [sym_identifier] = ACTIONS(4825),
    [anon_sym_q_LBRACE] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4828),
    [anon_sym_AMP] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4825),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS] = ACTIONS(4825),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_BANG] = ACTIONS(4828),
    [anon_sym_LPAREN] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(4828),
    [anon_sym_STAR] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(4828),
    [sym_bool] = ACTIONS(4825),
    [sym_byte] = ACTIONS(4825),
    [sym_ubyte] = ACTIONS(4825),
    [sym_char] = ACTIONS(4825),
    [sym_short] = ACTIONS(4825),
    [sym_ushort] = ACTIONS(4825),
    [sym_int] = ACTIONS(4825),
    [sym_uint] = ACTIONS(4825),
    [sym_long] = ACTIONS(4825),
    [sym_ulong] = ACTIONS(4825),
    [sym_cent] = ACTIONS(4825),
    [sym_ucent] = ACTIONS(4825),
    [sym_wchar] = ACTIONS(4825),
    [sym_dchar] = ACTIONS(4825),
    [sym_float] = ACTIONS(4825),
    [sym_double] = ACTIONS(4825),
    [sym_real] = ACTIONS(4825),
    [sym_ifloat] = ACTIONS(4825),
    [sym_idouble] = ACTIONS(4825),
    [sym_ireal] = ACTIONS(4825),
    [sym_cfloat] = ACTIONS(4825),
    [sym_cdouble] = ACTIONS(4825),
    [sym_creal] = ACTIONS(4825),
    [sym_size_t] = ACTIONS(4825),
    [sym_ptrdiff_t] = ACTIONS(4825),
    [sym_string] = ACTIONS(4825),
    [sym_cstring] = ACTIONS(4825),
    [sym_dstring] = ACTIONS(4825),
    [sym_wstring] = ACTIONS(4825),
    [sym_noreturn] = ACTIONS(4825),
    [sym_true] = ACTIONS(4825),
    [sym_false] = ACTIONS(4825),
    [sym_null] = ACTIONS(4825),
    [sym_super] = ACTIONS(4825),
    [sym_this] = ACTIONS(4825),
    [sym_abstract] = ACTIONS(4825),
    [sym_alias] = ACTIONS(4825),
    [sym_align] = ACTIONS(4825),
    [sym_asm] = ACTIONS(4825),
    [sym_assert] = ACTIONS(4825),
    [sym_auto] = ACTIONS(4825),
    [sym_break] = ACTIONS(4825),
    [sym_case] = ACTIONS(4825),
    [sym_cast] = ACTIONS(4825),
    [sym_catch] = ACTIONS(4825),
    [sym_class] = ACTIONS(4825),
    [sym_const] = ACTIONS(4825),
    [sym_continue] = ACTIONS(4825),
    [sym_debug] = ACTIONS(4825),
    [sym_default] = ACTIONS(4825),
    [sym_delegate] = ACTIONS(4825),
    [sym_delete] = ACTIONS(4825),
    [sym_deprecated] = ACTIONS(4825),
    [sym_do] = ACTIONS(4825),
    [sym_else] = ACTIONS(4825),
    [sym_enum] = ACTIONS(4825),
    [sym_export] = ACTIONS(4825),
    [sym_extern] = ACTIONS(4825),
    [sym_final] = ACTIONS(4825),
    [sym_finally] = ACTIONS(4825),
    [sym_for] = ACTIONS(4825),
    [sym_foreach] = ACTIONS(4825),
    [sym_foreach_reverse] = ACTIONS(4825),
    [sym_function] = ACTIONS(4825),
    [sym_goto] = ACTIONS(4825),
    [sym_if] = ACTIONS(4825),
    [sym_immutable] = ACTIONS(4825),
    [sym_import] = ACTIONS(4825),
    [sym_in] = ACTIONS(4825),
    [sym_inout] = ACTIONS(4825),
    [sym_interface] = ACTIONS(4825),
    [sym_invariant] = ACTIONS(4825),
    [sym_is] = ACTIONS(4825),
    [sym_mixin] = ACTIONS(4825),
    [sym_new] = ACTIONS(4825),
    [sym_nothrow] = ACTIONS(4825),
    [sym_out] = ACTIONS(4825),
    [sym_override] = ACTIONS(4825),
    [sym_package] = ACTIONS(4825),
    [sym_pragma] = ACTIONS(4825),
    [sym_private] = ACTIONS(4825),
    [sym_protected] = ACTIONS(4825),
    [sym_public] = ACTIONS(4825),
    [sym_pure] = ACTIONS(4825),
    [sym_ref] = ACTIONS(4825),
    [sym_return] = ACTIONS(4825),
    [sym_scope] = ACTIONS(4825),
    [sym_shared] = ACTIONS(4825),
    [sym_static] = ACTIONS(4825),
    [sym_struct] = ACTIONS(4825),
    [sym_switch] = ACTIONS(4825),
    [sym_synchronized] = ACTIONS(4825),
    [sym_template] = ACTIONS(4825),
    [sym_throw] = ACTIONS(4825),
    [sym_try] = ACTIONS(4825),
    [sym_typeid] = ACTIONS(4825),
    [sym_typeof] = ACTIONS(4825),
    [sym_union] = ACTIONS(4825),
    [sym_unittest] = ACTIONS(4825),
    [sym_version] = ACTIONS(4825),
    [sym_while] = ACTIONS(4825),
    [sym_with] = ACTIONS(4825),
    [sym_gshared] = ACTIONS(4825),
    [sym_traits] = ACTIONS(4825),
    [sym_vector] = ACTIONS(4825),
    [sym_void] = ACTIONS(4825),
    [anon_sym_BQUOTE] = ACTIONS(4828),
    [anon_sym_r_DQUOTE] = ACTIONS(4828),
    [anon_sym_x_DQUOTE] = ACTIONS(4828),
    [anon_sym_DQUOTE] = ACTIONS(4828),
    [anon_sym_i_BQUOTE] = ACTIONS(4828),
    [anon_sym_i_DQUOTE] = ACTIONS(4828),
    [anon_sym_iq_LBRACE] = ACTIONS(4828),
    [aux_sym_char_literal_token1] = ACTIONS(4828),
    [anon_sym_SQUOTE] = ACTIONS(4825),
    [anon_sym___DATE__] = ACTIONS(4825),
    [anon_sym___FILE__] = ACTIONS(4825),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4825),
    [anon_sym___FUNCTION__] = ACTIONS(4825),
    [anon_sym___LINE__] = ACTIONS(4825),
    [anon_sym___MODULE__] = ACTIONS(4825),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4825),
    [anon_sym___TIME__] = ACTIONS(4825),
    [anon_sym___TIMESTAMP__] = ACTIONS(4825),
    [anon_sym___VENDOR__] = ACTIONS(4825),
    [anon_sym___VERSION__] = ACTIONS(4825),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4828),
    [sym_float_literal] = ACTIONS(4828),
    [sym__string] = ACTIONS(4828),
  },
  [1461] = {
    [sym_identifier] = ACTIONS(4831),
    [anon_sym_q_LBRACE] = ACTIONS(4833),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_LBRACE] = ACTIONS(4833),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_AMP] = ACTIONS(4833),
    [anon_sym_DASH] = ACTIONS(4831),
    [anon_sym_DASH_DASH] = ACTIONS(4833),
    [anon_sym_PLUS] = ACTIONS(4831),
    [anon_sym_PLUS_PLUS] = ACTIONS(4833),
    [anon_sym_BANG] = ACTIONS(4833),
    [anon_sym_LPAREN] = ACTIONS(4833),
    [anon_sym_RPAREN] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4833),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [anon_sym_STAR] = ACTIONS(4833),
    [anon_sym_TILDE] = ACTIONS(4833),
    [anon_sym_AT] = ACTIONS(4833),
    [sym_bool] = ACTIONS(4831),
    [sym_byte] = ACTIONS(4831),
    [sym_ubyte] = ACTIONS(4831),
    [sym_char] = ACTIONS(4831),
    [sym_short] = ACTIONS(4831),
    [sym_ushort] = ACTIONS(4831),
    [sym_int] = ACTIONS(4831),
    [sym_uint] = ACTIONS(4831),
    [sym_long] = ACTIONS(4831),
    [sym_ulong] = ACTIONS(4831),
    [sym_cent] = ACTIONS(4831),
    [sym_ucent] = ACTIONS(4831),
    [sym_wchar] = ACTIONS(4831),
    [sym_dchar] = ACTIONS(4831),
    [sym_float] = ACTIONS(4831),
    [sym_double] = ACTIONS(4831),
    [sym_real] = ACTIONS(4831),
    [sym_ifloat] = ACTIONS(4831),
    [sym_idouble] = ACTIONS(4831),
    [sym_ireal] = ACTIONS(4831),
    [sym_cfloat] = ACTIONS(4831),
    [sym_cdouble] = ACTIONS(4831),
    [sym_creal] = ACTIONS(4831),
    [sym_size_t] = ACTIONS(4831),
    [sym_ptrdiff_t] = ACTIONS(4831),
    [sym_string] = ACTIONS(4831),
    [sym_cstring] = ACTIONS(4831),
    [sym_dstring] = ACTIONS(4831),
    [sym_wstring] = ACTIONS(4831),
    [sym_noreturn] = ACTIONS(4831),
    [sym_true] = ACTIONS(4831),
    [sym_false] = ACTIONS(4831),
    [sym_null] = ACTIONS(4831),
    [sym_super] = ACTIONS(4831),
    [sym_this] = ACTIONS(4831),
    [sym_abstract] = ACTIONS(4831),
    [sym_alias] = ACTIONS(4831),
    [sym_align] = ACTIONS(4831),
    [sym_asm] = ACTIONS(4831),
    [sym_assert] = ACTIONS(4831),
    [sym_auto] = ACTIONS(4831),
    [sym_break] = ACTIONS(4831),
    [sym_case] = ACTIONS(4831),
    [sym_cast] = ACTIONS(4831),
    [sym_catch] = ACTIONS(4831),
    [sym_class] = ACTIONS(4831),
    [sym_const] = ACTIONS(4831),
    [sym_continue] = ACTIONS(4831),
    [sym_debug] = ACTIONS(4831),
    [sym_default] = ACTIONS(4831),
    [sym_delegate] = ACTIONS(4831),
    [sym_delete] = ACTIONS(4831),
    [sym_deprecated] = ACTIONS(4831),
    [sym_do] = ACTIONS(4831),
    [sym_else] = ACTIONS(4831),
    [sym_enum] = ACTIONS(4831),
    [sym_export] = ACTIONS(4831),
    [sym_extern] = ACTIONS(4831),
    [sym_final] = ACTIONS(4831),
    [sym_finally] = ACTIONS(4831),
    [sym_for] = ACTIONS(4831),
    [sym_foreach] = ACTIONS(4831),
    [sym_foreach_reverse] = ACTIONS(4831),
    [sym_function] = ACTIONS(4831),
    [sym_goto] = ACTIONS(4831),
    [sym_if] = ACTIONS(4831),
    [sym_immutable] = ACTIONS(4831),
    [sym_import] = ACTIONS(4831),
    [sym_in] = ACTIONS(4831),
    [sym_inout] = ACTIONS(4831),
    [sym_interface] = ACTIONS(4831),
    [sym_invariant] = ACTIONS(4831),
    [sym_is] = ACTIONS(4831),
    [sym_mixin] = ACTIONS(4831),
    [sym_new] = ACTIONS(4831),
    [sym_nothrow] = ACTIONS(4831),
    [sym_out] = ACTIONS(4831),
    [sym_override] = ACTIONS(4831),
    [sym_package] = ACTIONS(4831),
    [sym_pragma] = ACTIONS(4831),
    [sym_private] = ACTIONS(4831),
    [sym_protected] = ACTIONS(4831),
    [sym_public] = ACTIONS(4831),
    [sym_pure] = ACTIONS(4831),
    [sym_ref] = ACTIONS(4831),
    [sym_return] = ACTIONS(4831),
    [sym_scope] = ACTIONS(4831),
    [sym_shared] = ACTIONS(4831),
    [sym_static] = ACTIONS(4831),
    [sym_struct] = ACTIONS(4831),
    [sym_switch] = ACTIONS(4831),
    [sym_synchronized] = ACTIONS(4831),
    [sym_template] = ACTIONS(4831),
    [sym_throw] = ACTIONS(4831),
    [sym_try] = ACTIONS(4831),
    [sym_typeid] = ACTIONS(4831),
    [sym_typeof] = ACTIONS(4831),
    [sym_union] = ACTIONS(4831),
    [sym_unittest] = ACTIONS(4831),
    [sym_version] = ACTIONS(4831),
    [sym_while] = ACTIONS(4831),
    [sym_with] = ACTIONS(4831),
    [sym_gshared] = ACTIONS(4831),
    [sym_traits] = ACTIONS(4831),
    [sym_vector] = ACTIONS(4831),
    [sym_void] = ACTIONS(4831),
    [anon_sym_BQUOTE] = ACTIONS(4833),
    [anon_sym_r_DQUOTE] = ACTIONS(4833),
    [anon_sym_x_DQUOTE] = ACTIONS(4833),
    [anon_sym_DQUOTE] = ACTIONS(4833),
    [anon_sym_i_BQUOTE] = ACTIONS(4833),
    [anon_sym_i_DQUOTE] = ACTIONS(4833),
    [anon_sym_iq_LBRACE] = ACTIONS(4833),
    [aux_sym_char_literal_token1] = ACTIONS(4833),
    [anon_sym_SQUOTE] = ACTIONS(4831),
    [anon_sym___DATE__] = ACTIONS(4831),
    [anon_sym___FILE__] = ACTIONS(4831),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4831),
    [anon_sym___FUNCTION__] = ACTIONS(4831),
    [anon_sym___LINE__] = ACTIONS(4831),
    [anon_sym___MODULE__] = ACTIONS(4831),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4831),
    [anon_sym___TIME__] = ACTIONS(4831),
    [anon_sym___TIMESTAMP__] = ACTIONS(4831),
    [anon_sym___VENDOR__] = ACTIONS(4831),
    [anon_sym___VERSION__] = ACTIONS(4831),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4833),
    [sym_float_literal] = ACTIONS(4833),
    [sym__string] = ACTIONS(4833),
  },
  [1462] = {
    [sym_identifier] = ACTIONS(4835),
    [anon_sym_q_LBRACE] = ACTIONS(4837),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_LBRACE] = ACTIONS(4837),
    [anon_sym_DOT] = ACTIONS(4837),
    [anon_sym_AMP] = ACTIONS(4837),
    [anon_sym_DASH] = ACTIONS(4835),
    [anon_sym_DASH_DASH] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4835),
    [anon_sym_PLUS_PLUS] = ACTIONS(4837),
    [anon_sym_BANG] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(4837),
    [anon_sym_RPAREN] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym_DOLLAR] = ACTIONS(4837),
    [anon_sym_STAR] = ACTIONS(4837),
    [anon_sym_TILDE] = ACTIONS(4837),
    [anon_sym_AT] = ACTIONS(4837),
    [sym_bool] = ACTIONS(4835),
    [sym_byte] = ACTIONS(4835),
    [sym_ubyte] = ACTIONS(4835),
    [sym_char] = ACTIONS(4835),
    [sym_short] = ACTIONS(4835),
    [sym_ushort] = ACTIONS(4835),
    [sym_int] = ACTIONS(4835),
    [sym_uint] = ACTIONS(4835),
    [sym_long] = ACTIONS(4835),
    [sym_ulong] = ACTIONS(4835),
    [sym_cent] = ACTIONS(4835),
    [sym_ucent] = ACTIONS(4835),
    [sym_wchar] = ACTIONS(4835),
    [sym_dchar] = ACTIONS(4835),
    [sym_float] = ACTIONS(4835),
    [sym_double] = ACTIONS(4835),
    [sym_real] = ACTIONS(4835),
    [sym_ifloat] = ACTIONS(4835),
    [sym_idouble] = ACTIONS(4835),
    [sym_ireal] = ACTIONS(4835),
    [sym_cfloat] = ACTIONS(4835),
    [sym_cdouble] = ACTIONS(4835),
    [sym_creal] = ACTIONS(4835),
    [sym_size_t] = ACTIONS(4835),
    [sym_ptrdiff_t] = ACTIONS(4835),
    [sym_string] = ACTIONS(4835),
    [sym_cstring] = ACTIONS(4835),
    [sym_dstring] = ACTIONS(4835),
    [sym_wstring] = ACTIONS(4835),
    [sym_noreturn] = ACTIONS(4835),
    [sym_true] = ACTIONS(4835),
    [sym_false] = ACTIONS(4835),
    [sym_null] = ACTIONS(4835),
    [sym_super] = ACTIONS(4835),
    [sym_this] = ACTIONS(4835),
    [sym_abstract] = ACTIONS(4835),
    [sym_alias] = ACTIONS(4835),
    [sym_align] = ACTIONS(4835),
    [sym_asm] = ACTIONS(4835),
    [sym_assert] = ACTIONS(4835),
    [sym_auto] = ACTIONS(4835),
    [sym_break] = ACTIONS(4835),
    [sym_case] = ACTIONS(4835),
    [sym_cast] = ACTIONS(4835),
    [sym_catch] = ACTIONS(4835),
    [sym_class] = ACTIONS(4835),
    [sym_const] = ACTIONS(4835),
    [sym_continue] = ACTIONS(4835),
    [sym_debug] = ACTIONS(4835),
    [sym_default] = ACTIONS(4835),
    [sym_delegate] = ACTIONS(4835),
    [sym_delete] = ACTIONS(4835),
    [sym_deprecated] = ACTIONS(4835),
    [sym_do] = ACTIONS(4835),
    [sym_else] = ACTIONS(4835),
    [sym_enum] = ACTIONS(4835),
    [sym_export] = ACTIONS(4835),
    [sym_extern] = ACTIONS(4835),
    [sym_final] = ACTIONS(4835),
    [sym_finally] = ACTIONS(4835),
    [sym_for] = ACTIONS(4835),
    [sym_foreach] = ACTIONS(4835),
    [sym_foreach_reverse] = ACTIONS(4835),
    [sym_function] = ACTIONS(4835),
    [sym_goto] = ACTIONS(4835),
    [sym_if] = ACTIONS(4835),
    [sym_immutable] = ACTIONS(4835),
    [sym_import] = ACTIONS(4835),
    [sym_in] = ACTIONS(4835),
    [sym_inout] = ACTIONS(4835),
    [sym_interface] = ACTIONS(4835),
    [sym_invariant] = ACTIONS(4835),
    [sym_is] = ACTIONS(4835),
    [sym_mixin] = ACTIONS(4835),
    [sym_new] = ACTIONS(4835),
    [sym_nothrow] = ACTIONS(4835),
    [sym_out] = ACTIONS(4835),
    [sym_override] = ACTIONS(4835),
    [sym_package] = ACTIONS(4835),
    [sym_pragma] = ACTIONS(4835),
    [sym_private] = ACTIONS(4835),
    [sym_protected] = ACTIONS(4835),
    [sym_public] = ACTIONS(4835),
    [sym_pure] = ACTIONS(4835),
    [sym_ref] = ACTIONS(4835),
    [sym_return] = ACTIONS(4835),
    [sym_scope] = ACTIONS(4835),
    [sym_shared] = ACTIONS(4835),
    [sym_static] = ACTIONS(4835),
    [sym_struct] = ACTIONS(4835),
    [sym_switch] = ACTIONS(4835),
    [sym_synchronized] = ACTIONS(4835),
    [sym_template] = ACTIONS(4835),
    [sym_throw] = ACTIONS(4835),
    [sym_try] = ACTIONS(4835),
    [sym_typeid] = ACTIONS(4835),
    [sym_typeof] = ACTIONS(4835),
    [sym_union] = ACTIONS(4835),
    [sym_unittest] = ACTIONS(4835),
    [sym_version] = ACTIONS(4835),
    [sym_while] = ACTIONS(4835),
    [sym_with] = ACTIONS(4835),
    [sym_gshared] = ACTIONS(4835),
    [sym_traits] = ACTIONS(4835),
    [sym_vector] = ACTIONS(4835),
    [sym_void] = ACTIONS(4835),
    [anon_sym_BQUOTE] = ACTIONS(4837),
    [anon_sym_r_DQUOTE] = ACTIONS(4837),
    [anon_sym_x_DQUOTE] = ACTIONS(4837),
    [anon_sym_DQUOTE] = ACTIONS(4837),
    [anon_sym_i_BQUOTE] = ACTIONS(4837),
    [anon_sym_i_DQUOTE] = ACTIONS(4837),
    [anon_sym_iq_LBRACE] = ACTIONS(4837),
    [aux_sym_char_literal_token1] = ACTIONS(4837),
    [anon_sym_SQUOTE] = ACTIONS(4835),
    [anon_sym___DATE__] = ACTIONS(4835),
    [anon_sym___FILE__] = ACTIONS(4835),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4835),
    [anon_sym___FUNCTION__] = ACTIONS(4835),
    [anon_sym___LINE__] = ACTIONS(4835),
    [anon_sym___MODULE__] = ACTIONS(4835),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4835),
    [anon_sym___TIME__] = ACTIONS(4835),
    [anon_sym___TIMESTAMP__] = ACTIONS(4835),
    [anon_sym___VENDOR__] = ACTIONS(4835),
    [anon_sym___VERSION__] = ACTIONS(4835),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4837),
    [sym_float_literal] = ACTIONS(4837),
    [sym__string] = ACTIONS(4837),
  },
  [1463] = {
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_q_LBRACE] = ACTIONS(4841),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [anon_sym_LBRACE] = ACTIONS(4841),
    [anon_sym_DOT] = ACTIONS(4841),
    [anon_sym_AMP] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4839),
    [anon_sym_DASH_DASH] = ACTIONS(4841),
    [anon_sym_PLUS] = ACTIONS(4839),
    [anon_sym_PLUS_PLUS] = ACTIONS(4841),
    [anon_sym_BANG] = ACTIONS(4841),
    [anon_sym_LPAREN] = ACTIONS(4841),
    [anon_sym_RPAREN] = ACTIONS(4841),
    [anon_sym_LBRACK] = ACTIONS(4841),
    [anon_sym_SEMI] = ACTIONS(4841),
    [anon_sym_DOLLAR] = ACTIONS(4841),
    [anon_sym_STAR] = ACTIONS(4841),
    [anon_sym_TILDE] = ACTIONS(4841),
    [anon_sym_AT] = ACTIONS(4841),
    [sym_bool] = ACTIONS(4839),
    [sym_byte] = ACTIONS(4839),
    [sym_ubyte] = ACTIONS(4839),
    [sym_char] = ACTIONS(4839),
    [sym_short] = ACTIONS(4839),
    [sym_ushort] = ACTIONS(4839),
    [sym_int] = ACTIONS(4839),
    [sym_uint] = ACTIONS(4839),
    [sym_long] = ACTIONS(4839),
    [sym_ulong] = ACTIONS(4839),
    [sym_cent] = ACTIONS(4839),
    [sym_ucent] = ACTIONS(4839),
    [sym_wchar] = ACTIONS(4839),
    [sym_dchar] = ACTIONS(4839),
    [sym_float] = ACTIONS(4839),
    [sym_double] = ACTIONS(4839),
    [sym_real] = ACTIONS(4839),
    [sym_ifloat] = ACTIONS(4839),
    [sym_idouble] = ACTIONS(4839),
    [sym_ireal] = ACTIONS(4839),
    [sym_cfloat] = ACTIONS(4839),
    [sym_cdouble] = ACTIONS(4839),
    [sym_creal] = ACTIONS(4839),
    [sym_size_t] = ACTIONS(4839),
    [sym_ptrdiff_t] = ACTIONS(4839),
    [sym_string] = ACTIONS(4839),
    [sym_cstring] = ACTIONS(4839),
    [sym_dstring] = ACTIONS(4839),
    [sym_wstring] = ACTIONS(4839),
    [sym_noreturn] = ACTIONS(4839),
    [sym_true] = ACTIONS(4839),
    [sym_false] = ACTIONS(4839),
    [sym_null] = ACTIONS(4839),
    [sym_super] = ACTIONS(4839),
    [sym_this] = ACTIONS(4839),
    [sym_abstract] = ACTIONS(4839),
    [sym_alias] = ACTIONS(4839),
    [sym_align] = ACTIONS(4839),
    [sym_asm] = ACTIONS(4839),
    [sym_assert] = ACTIONS(4839),
    [sym_auto] = ACTIONS(4839),
    [sym_break] = ACTIONS(4839),
    [sym_case] = ACTIONS(4839),
    [sym_cast] = ACTIONS(4839),
    [sym_catch] = ACTIONS(4839),
    [sym_class] = ACTIONS(4839),
    [sym_const] = ACTIONS(4839),
    [sym_continue] = ACTIONS(4839),
    [sym_debug] = ACTIONS(4839),
    [sym_default] = ACTIONS(4839),
    [sym_delegate] = ACTIONS(4839),
    [sym_delete] = ACTIONS(4839),
    [sym_deprecated] = ACTIONS(4839),
    [sym_do] = ACTIONS(4839),
    [sym_else] = ACTIONS(4839),
    [sym_enum] = ACTIONS(4839),
    [sym_export] = ACTIONS(4839),
    [sym_extern] = ACTIONS(4839),
    [sym_final] = ACTIONS(4839),
    [sym_finally] = ACTIONS(4839),
    [sym_for] = ACTIONS(4839),
    [sym_foreach] = ACTIONS(4839),
    [sym_foreach_reverse] = ACTIONS(4839),
    [sym_function] = ACTIONS(4839),
    [sym_goto] = ACTIONS(4839),
    [sym_if] = ACTIONS(4839),
    [sym_immutable] = ACTIONS(4839),
    [sym_import] = ACTIONS(4839),
    [sym_in] = ACTIONS(4839),
    [sym_inout] = ACTIONS(4839),
    [sym_interface] = ACTIONS(4839),
    [sym_invariant] = ACTIONS(4839),
    [sym_is] = ACTIONS(4839),
    [sym_mixin] = ACTIONS(4839),
    [sym_new] = ACTIONS(4839),
    [sym_nothrow] = ACTIONS(4839),
    [sym_out] = ACTIONS(4839),
    [sym_override] = ACTIONS(4839),
    [sym_package] = ACTIONS(4839),
    [sym_pragma] = ACTIONS(4839),
    [sym_private] = ACTIONS(4839),
    [sym_protected] = ACTIONS(4839),
    [sym_public] = ACTIONS(4839),
    [sym_pure] = ACTIONS(4839),
    [sym_ref] = ACTIONS(4839),
    [sym_return] = ACTIONS(4839),
    [sym_scope] = ACTIONS(4839),
    [sym_shared] = ACTIONS(4839),
    [sym_static] = ACTIONS(4839),
    [sym_struct] = ACTIONS(4839),
    [sym_switch] = ACTIONS(4839),
    [sym_synchronized] = ACTIONS(4839),
    [sym_template] = ACTIONS(4839),
    [sym_throw] = ACTIONS(4839),
    [sym_try] = ACTIONS(4839),
    [sym_typeid] = ACTIONS(4839),
    [sym_typeof] = ACTIONS(4839),
    [sym_union] = ACTIONS(4839),
    [sym_unittest] = ACTIONS(4839),
    [sym_version] = ACTIONS(4839),
    [sym_while] = ACTIONS(4839),
    [sym_with] = ACTIONS(4839),
    [sym_gshared] = ACTIONS(4839),
    [sym_traits] = ACTIONS(4839),
    [sym_vector] = ACTIONS(4839),
    [sym_void] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_r_DQUOTE] = ACTIONS(4841),
    [anon_sym_x_DQUOTE] = ACTIONS(4841),
    [anon_sym_DQUOTE] = ACTIONS(4841),
    [anon_sym_i_BQUOTE] = ACTIONS(4841),
    [anon_sym_i_DQUOTE] = ACTIONS(4841),
    [anon_sym_iq_LBRACE] = ACTIONS(4841),
    [aux_sym_char_literal_token1] = ACTIONS(4841),
    [anon_sym_SQUOTE] = ACTIONS(4839),
    [anon_sym___DATE__] = ACTIONS(4839),
    [anon_sym___FILE__] = ACTIONS(4839),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4839),
    [anon_sym___FUNCTION__] = ACTIONS(4839),
    [anon_sym___LINE__] = ACTIONS(4839),
    [anon_sym___MODULE__] = ACTIONS(4839),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4839),
    [anon_sym___TIME__] = ACTIONS(4839),
    [anon_sym___TIMESTAMP__] = ACTIONS(4839),
    [anon_sym___VENDOR__] = ACTIONS(4839),
    [anon_sym___VERSION__] = ACTIONS(4839),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4841),
    [sym_float_literal] = ACTIONS(4841),
    [sym__string] = ACTIONS(4841),
  },
  [1464] = {
    [sym_identifier] = ACTIONS(4843),
    [anon_sym_q_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_DASH_DASH] = ACTIONS(4845),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_PLUS_PLUS] = ACTIONS(4845),
    [anon_sym_BANG] = ACTIONS(4845),
    [anon_sym_LPAREN] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4845),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_AT] = ACTIONS(4845),
    [sym_bool] = ACTIONS(4843),
    [sym_byte] = ACTIONS(4843),
    [sym_ubyte] = ACTIONS(4843),
    [sym_char] = ACTIONS(4843),
    [sym_short] = ACTIONS(4843),
    [sym_ushort] = ACTIONS(4843),
    [sym_int] = ACTIONS(4843),
    [sym_uint] = ACTIONS(4843),
    [sym_long] = ACTIONS(4843),
    [sym_ulong] = ACTIONS(4843),
    [sym_cent] = ACTIONS(4843),
    [sym_ucent] = ACTIONS(4843),
    [sym_wchar] = ACTIONS(4843),
    [sym_dchar] = ACTIONS(4843),
    [sym_float] = ACTIONS(4843),
    [sym_double] = ACTIONS(4843),
    [sym_real] = ACTIONS(4843),
    [sym_ifloat] = ACTIONS(4843),
    [sym_idouble] = ACTIONS(4843),
    [sym_ireal] = ACTIONS(4843),
    [sym_cfloat] = ACTIONS(4843),
    [sym_cdouble] = ACTIONS(4843),
    [sym_creal] = ACTIONS(4843),
    [sym_size_t] = ACTIONS(4843),
    [sym_ptrdiff_t] = ACTIONS(4843),
    [sym_string] = ACTIONS(4843),
    [sym_cstring] = ACTIONS(4843),
    [sym_dstring] = ACTIONS(4843),
    [sym_wstring] = ACTIONS(4843),
    [sym_noreturn] = ACTIONS(4843),
    [sym_true] = ACTIONS(4843),
    [sym_false] = ACTIONS(4843),
    [sym_null] = ACTIONS(4843),
    [sym_super] = ACTIONS(4843),
    [sym_this] = ACTIONS(4843),
    [sym_abstract] = ACTIONS(4843),
    [sym_alias] = ACTIONS(4843),
    [sym_align] = ACTIONS(4843),
    [sym_asm] = ACTIONS(4843),
    [sym_assert] = ACTIONS(4843),
    [sym_auto] = ACTIONS(4843),
    [sym_break] = ACTIONS(4843),
    [sym_case] = ACTIONS(4843),
    [sym_cast] = ACTIONS(4843),
    [sym_catch] = ACTIONS(4843),
    [sym_class] = ACTIONS(4843),
    [sym_const] = ACTIONS(4843),
    [sym_continue] = ACTIONS(4843),
    [sym_debug] = ACTIONS(4843),
    [sym_default] = ACTIONS(4843),
    [sym_delegate] = ACTIONS(4843),
    [sym_delete] = ACTIONS(4843),
    [sym_deprecated] = ACTIONS(4843),
    [sym_do] = ACTIONS(4843),
    [sym_else] = ACTIONS(4843),
    [sym_enum] = ACTIONS(4843),
    [sym_export] = ACTIONS(4843),
    [sym_extern] = ACTIONS(4843),
    [sym_final] = ACTIONS(4843),
    [sym_finally] = ACTIONS(4843),
    [sym_for] = ACTIONS(4843),
    [sym_foreach] = ACTIONS(4843),
    [sym_foreach_reverse] = ACTIONS(4843),
    [sym_function] = ACTIONS(4843),
    [sym_goto] = ACTIONS(4843),
    [sym_if] = ACTIONS(4843),
    [sym_immutable] = ACTIONS(4843),
    [sym_import] = ACTIONS(4843),
    [sym_in] = ACTIONS(4843),
    [sym_inout] = ACTIONS(4843),
    [sym_interface] = ACTIONS(4843),
    [sym_invariant] = ACTIONS(4843),
    [sym_is] = ACTIONS(4843),
    [sym_mixin] = ACTIONS(4843),
    [sym_new] = ACTIONS(4843),
    [sym_nothrow] = ACTIONS(4843),
    [sym_out] = ACTIONS(4843),
    [sym_override] = ACTIONS(4843),
    [sym_package] = ACTIONS(4843),
    [sym_pragma] = ACTIONS(4843),
    [sym_private] = ACTIONS(4843),
    [sym_protected] = ACTIONS(4843),
    [sym_public] = ACTIONS(4843),
    [sym_pure] = ACTIONS(4843),
    [sym_ref] = ACTIONS(4843),
    [sym_return] = ACTIONS(4843),
    [sym_scope] = ACTIONS(4843),
    [sym_shared] = ACTIONS(4843),
    [sym_static] = ACTIONS(4843),
    [sym_struct] = ACTIONS(4843),
    [sym_switch] = ACTIONS(4843),
    [sym_synchronized] = ACTIONS(4843),
    [sym_template] = ACTIONS(4843),
    [sym_throw] = ACTIONS(4843),
    [sym_try] = ACTIONS(4843),
    [sym_typeid] = ACTIONS(4843),
    [sym_typeof] = ACTIONS(4843),
    [sym_union] = ACTIONS(4843),
    [sym_unittest] = ACTIONS(4843),
    [sym_version] = ACTIONS(4843),
    [sym_while] = ACTIONS(4843),
    [sym_with] = ACTIONS(4843),
    [sym_gshared] = ACTIONS(4843),
    [sym_traits] = ACTIONS(4843),
    [sym_vector] = ACTIONS(4843),
    [sym_void] = ACTIONS(4843),
    [anon_sym_BQUOTE] = ACTIONS(4845),
    [anon_sym_r_DQUOTE] = ACTIONS(4845),
    [anon_sym_x_DQUOTE] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4845),
    [anon_sym_i_BQUOTE] = ACTIONS(4845),
    [anon_sym_i_DQUOTE] = ACTIONS(4845),
    [anon_sym_iq_LBRACE] = ACTIONS(4845),
    [aux_sym_char_literal_token1] = ACTIONS(4845),
    [anon_sym_SQUOTE] = ACTIONS(4843),
    [anon_sym___DATE__] = ACTIONS(4843),
    [anon_sym___FILE__] = ACTIONS(4843),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4843),
    [anon_sym___FUNCTION__] = ACTIONS(4843),
    [anon_sym___LINE__] = ACTIONS(4843),
    [anon_sym___MODULE__] = ACTIONS(4843),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4843),
    [anon_sym___TIME__] = ACTIONS(4843),
    [anon_sym___TIMESTAMP__] = ACTIONS(4843),
    [anon_sym___VENDOR__] = ACTIONS(4843),
    [anon_sym___VERSION__] = ACTIONS(4843),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4845),
    [sym_float_literal] = ACTIONS(4845),
    [sym__string] = ACTIONS(4845),
  },
  [1465] = {
    [sym_identifier] = ACTIONS(4847),
    [anon_sym_q_LBRACE] = ACTIONS(4849),
    [anon_sym_RBRACE] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_DOT] = ACTIONS(4849),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4849),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_PLUS_PLUS] = ACTIONS(4849),
    [anon_sym_BANG] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(4849),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_DOLLAR] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_TILDE] = ACTIONS(4849),
    [anon_sym_AT] = ACTIONS(4849),
    [sym_bool] = ACTIONS(4847),
    [sym_byte] = ACTIONS(4847),
    [sym_ubyte] = ACTIONS(4847),
    [sym_char] = ACTIONS(4847),
    [sym_short] = ACTIONS(4847),
    [sym_ushort] = ACTIONS(4847),
    [sym_int] = ACTIONS(4847),
    [sym_uint] = ACTIONS(4847),
    [sym_long] = ACTIONS(4847),
    [sym_ulong] = ACTIONS(4847),
    [sym_cent] = ACTIONS(4847),
    [sym_ucent] = ACTIONS(4847),
    [sym_wchar] = ACTIONS(4847),
    [sym_dchar] = ACTIONS(4847),
    [sym_float] = ACTIONS(4847),
    [sym_double] = ACTIONS(4847),
    [sym_real] = ACTIONS(4847),
    [sym_ifloat] = ACTIONS(4847),
    [sym_idouble] = ACTIONS(4847),
    [sym_ireal] = ACTIONS(4847),
    [sym_cfloat] = ACTIONS(4847),
    [sym_cdouble] = ACTIONS(4847),
    [sym_creal] = ACTIONS(4847),
    [sym_size_t] = ACTIONS(4847),
    [sym_ptrdiff_t] = ACTIONS(4847),
    [sym_string] = ACTIONS(4847),
    [sym_cstring] = ACTIONS(4847),
    [sym_dstring] = ACTIONS(4847),
    [sym_wstring] = ACTIONS(4847),
    [sym_noreturn] = ACTIONS(4847),
    [sym_true] = ACTIONS(4847),
    [sym_false] = ACTIONS(4847),
    [sym_null] = ACTIONS(4847),
    [sym_super] = ACTIONS(4847),
    [sym_this] = ACTIONS(4847),
    [sym_abstract] = ACTIONS(4847),
    [sym_alias] = ACTIONS(4847),
    [sym_align] = ACTIONS(4847),
    [sym_asm] = ACTIONS(4847),
    [sym_assert] = ACTIONS(4847),
    [sym_auto] = ACTIONS(4847),
    [sym_break] = ACTIONS(4847),
    [sym_case] = ACTIONS(4847),
    [sym_cast] = ACTIONS(4847),
    [sym_catch] = ACTIONS(4847),
    [sym_class] = ACTIONS(4847),
    [sym_const] = ACTIONS(4847),
    [sym_continue] = ACTIONS(4847),
    [sym_debug] = ACTIONS(4847),
    [sym_default] = ACTIONS(4847),
    [sym_delegate] = ACTIONS(4847),
    [sym_delete] = ACTIONS(4847),
    [sym_deprecated] = ACTIONS(4847),
    [sym_do] = ACTIONS(4847),
    [sym_else] = ACTIONS(4847),
    [sym_enum] = ACTIONS(4847),
    [sym_export] = ACTIONS(4847),
    [sym_extern] = ACTIONS(4847),
    [sym_final] = ACTIONS(4847),
    [sym_finally] = ACTIONS(4847),
    [sym_for] = ACTIONS(4847),
    [sym_foreach] = ACTIONS(4847),
    [sym_foreach_reverse] = ACTIONS(4847),
    [sym_function] = ACTIONS(4847),
    [sym_goto] = ACTIONS(4847),
    [sym_if] = ACTIONS(4847),
    [sym_immutable] = ACTIONS(4847),
    [sym_import] = ACTIONS(4847),
    [sym_in] = ACTIONS(4847),
    [sym_inout] = ACTIONS(4847),
    [sym_interface] = ACTIONS(4847),
    [sym_invariant] = ACTIONS(4847),
    [sym_is] = ACTIONS(4847),
    [sym_mixin] = ACTIONS(4847),
    [sym_new] = ACTIONS(4847),
    [sym_nothrow] = ACTIONS(4847),
    [sym_out] = ACTIONS(4847),
    [sym_override] = ACTIONS(4847),
    [sym_package] = ACTIONS(4847),
    [sym_pragma] = ACTIONS(4847),
    [sym_private] = ACTIONS(4847),
    [sym_protected] = ACTIONS(4847),
    [sym_public] = ACTIONS(4847),
    [sym_pure] = ACTIONS(4847),
    [sym_ref] = ACTIONS(4847),
    [sym_return] = ACTIONS(4847),
    [sym_scope] = ACTIONS(4847),
    [sym_shared] = ACTIONS(4847),
    [sym_static] = ACTIONS(4847),
    [sym_struct] = ACTIONS(4847),
    [sym_switch] = ACTIONS(4847),
    [sym_synchronized] = ACTIONS(4847),
    [sym_template] = ACTIONS(4847),
    [sym_throw] = ACTIONS(4847),
    [sym_try] = ACTIONS(4847),
    [sym_typeid] = ACTIONS(4847),
    [sym_typeof] = ACTIONS(4847),
    [sym_union] = ACTIONS(4847),
    [sym_unittest] = ACTIONS(4847),
    [sym_version] = ACTIONS(4847),
    [sym_while] = ACTIONS(4847),
    [sym_with] = ACTIONS(4847),
    [sym_gshared] = ACTIONS(4847),
    [sym_traits] = ACTIONS(4847),
    [sym_vector] = ACTIONS(4847),
    [sym_void] = ACTIONS(4847),
    [anon_sym_BQUOTE] = ACTIONS(4849),
    [anon_sym_r_DQUOTE] = ACTIONS(4849),
    [anon_sym_x_DQUOTE] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4849),
    [anon_sym_i_BQUOTE] = ACTIONS(4849),
    [anon_sym_i_DQUOTE] = ACTIONS(4849),
    [anon_sym_iq_LBRACE] = ACTIONS(4849),
    [aux_sym_char_literal_token1] = ACTIONS(4849),
    [anon_sym_SQUOTE] = ACTIONS(4847),
    [anon_sym___DATE__] = ACTIONS(4847),
    [anon_sym___FILE__] = ACTIONS(4847),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4847),
    [anon_sym___FUNCTION__] = ACTIONS(4847),
    [anon_sym___LINE__] = ACTIONS(4847),
    [anon_sym___MODULE__] = ACTIONS(4847),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4847),
    [anon_sym___TIME__] = ACTIONS(4847),
    [anon_sym___TIMESTAMP__] = ACTIONS(4847),
    [anon_sym___VENDOR__] = ACTIONS(4847),
    [anon_sym___VERSION__] = ACTIONS(4847),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4849),
    [sym_float_literal] = ACTIONS(4849),
    [sym__string] = ACTIONS(4849),
  },
  [1466] = {
    [sym_identifier] = ACTIONS(4851),
    [anon_sym_q_LBRACE] = ACTIONS(4853),
    [anon_sym_RBRACE] = ACTIONS(4853),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [anon_sym_DOT] = ACTIONS(4853),
    [anon_sym_AMP] = ACTIONS(4853),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_DASH_DASH] = ACTIONS(4853),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_PLUS_PLUS] = ACTIONS(4853),
    [anon_sym_BANG] = ACTIONS(4853),
    [anon_sym_LPAREN] = ACTIONS(4853),
    [anon_sym_RPAREN] = ACTIONS(4853),
    [anon_sym_LBRACK] = ACTIONS(4853),
    [anon_sym_SEMI] = ACTIONS(4853),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [anon_sym_STAR] = ACTIONS(4853),
    [anon_sym_TILDE] = ACTIONS(4853),
    [anon_sym_AT] = ACTIONS(4853),
    [sym_bool] = ACTIONS(4851),
    [sym_byte] = ACTIONS(4851),
    [sym_ubyte] = ACTIONS(4851),
    [sym_char] = ACTIONS(4851),
    [sym_short] = ACTIONS(4851),
    [sym_ushort] = ACTIONS(4851),
    [sym_int] = ACTIONS(4851),
    [sym_uint] = ACTIONS(4851),
    [sym_long] = ACTIONS(4851),
    [sym_ulong] = ACTIONS(4851),
    [sym_cent] = ACTIONS(4851),
    [sym_ucent] = ACTIONS(4851),
    [sym_wchar] = ACTIONS(4851),
    [sym_dchar] = ACTIONS(4851),
    [sym_float] = ACTIONS(4851),
    [sym_double] = ACTIONS(4851),
    [sym_real] = ACTIONS(4851),
    [sym_ifloat] = ACTIONS(4851),
    [sym_idouble] = ACTIONS(4851),
    [sym_ireal] = ACTIONS(4851),
    [sym_cfloat] = ACTIONS(4851),
    [sym_cdouble] = ACTIONS(4851),
    [sym_creal] = ACTIONS(4851),
    [sym_size_t] = ACTIONS(4851),
    [sym_ptrdiff_t] = ACTIONS(4851),
    [sym_string] = ACTIONS(4851),
    [sym_cstring] = ACTIONS(4851),
    [sym_dstring] = ACTIONS(4851),
    [sym_wstring] = ACTIONS(4851),
    [sym_noreturn] = ACTIONS(4851),
    [sym_true] = ACTIONS(4851),
    [sym_false] = ACTIONS(4851),
    [sym_null] = ACTIONS(4851),
    [sym_super] = ACTIONS(4851),
    [sym_this] = ACTIONS(4851),
    [sym_abstract] = ACTIONS(4851),
    [sym_alias] = ACTIONS(4851),
    [sym_align] = ACTIONS(4851),
    [sym_asm] = ACTIONS(4851),
    [sym_assert] = ACTIONS(4851),
    [sym_auto] = ACTIONS(4851),
    [sym_break] = ACTIONS(4851),
    [sym_case] = ACTIONS(4851),
    [sym_cast] = ACTIONS(4851),
    [sym_catch] = ACTIONS(4851),
    [sym_class] = ACTIONS(4851),
    [sym_const] = ACTIONS(4851),
    [sym_continue] = ACTIONS(4851),
    [sym_debug] = ACTIONS(4851),
    [sym_default] = ACTIONS(4851),
    [sym_delegate] = ACTIONS(4851),
    [sym_delete] = ACTIONS(4851),
    [sym_deprecated] = ACTIONS(4851),
    [sym_do] = ACTIONS(4851),
    [sym_else] = ACTIONS(4851),
    [sym_enum] = ACTIONS(4851),
    [sym_export] = ACTIONS(4851),
    [sym_extern] = ACTIONS(4851),
    [sym_final] = ACTIONS(4851),
    [sym_finally] = ACTIONS(4851),
    [sym_for] = ACTIONS(4851),
    [sym_foreach] = ACTIONS(4851),
    [sym_foreach_reverse] = ACTIONS(4851),
    [sym_function] = ACTIONS(4851),
    [sym_goto] = ACTIONS(4851),
    [sym_if] = ACTIONS(4851),
    [sym_immutable] = ACTIONS(4851),
    [sym_import] = ACTIONS(4851),
    [sym_in] = ACTIONS(4851),
    [sym_inout] = ACTIONS(4851),
    [sym_interface] = ACTIONS(4851),
    [sym_invariant] = ACTIONS(4851),
    [sym_is] = ACTIONS(4851),
    [sym_mixin] = ACTIONS(4851),
    [sym_new] = ACTIONS(4851),
    [sym_nothrow] = ACTIONS(4851),
    [sym_out] = ACTIONS(4851),
    [sym_override] = ACTIONS(4851),
    [sym_package] = ACTIONS(4851),
    [sym_pragma] = ACTIONS(4851),
    [sym_private] = ACTIONS(4851),
    [sym_protected] = ACTIONS(4851),
    [sym_public] = ACTIONS(4851),
    [sym_pure] = ACTIONS(4851),
    [sym_ref] = ACTIONS(4851),
    [sym_return] = ACTIONS(4851),
    [sym_scope] = ACTIONS(4851),
    [sym_shared] = ACTIONS(4851),
    [sym_static] = ACTIONS(4851),
    [sym_struct] = ACTIONS(4851),
    [sym_switch] = ACTIONS(4851),
    [sym_synchronized] = ACTIONS(4851),
    [sym_template] = ACTIONS(4851),
    [sym_throw] = ACTIONS(4851),
    [sym_try] = ACTIONS(4851),
    [sym_typeid] = ACTIONS(4851),
    [sym_typeof] = ACTIONS(4851),
    [sym_union] = ACTIONS(4851),
    [sym_unittest] = ACTIONS(4851),
    [sym_version] = ACTIONS(4851),
    [sym_while] = ACTIONS(4851),
    [sym_with] = ACTIONS(4851),
    [sym_gshared] = ACTIONS(4851),
    [sym_traits] = ACTIONS(4851),
    [sym_vector] = ACTIONS(4851),
    [sym_void] = ACTIONS(4851),
    [anon_sym_BQUOTE] = ACTIONS(4853),
    [anon_sym_r_DQUOTE] = ACTIONS(4853),
    [anon_sym_x_DQUOTE] = ACTIONS(4853),
    [anon_sym_DQUOTE] = ACTIONS(4853),
    [anon_sym_i_BQUOTE] = ACTIONS(4853),
    [anon_sym_i_DQUOTE] = ACTIONS(4853),
    [anon_sym_iq_LBRACE] = ACTIONS(4853),
    [aux_sym_char_literal_token1] = ACTIONS(4853),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [anon_sym___DATE__] = ACTIONS(4851),
    [anon_sym___FILE__] = ACTIONS(4851),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4851),
    [anon_sym___FUNCTION__] = ACTIONS(4851),
    [anon_sym___LINE__] = ACTIONS(4851),
    [anon_sym___MODULE__] = ACTIONS(4851),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4851),
    [anon_sym___TIME__] = ACTIONS(4851),
    [anon_sym___TIMESTAMP__] = ACTIONS(4851),
    [anon_sym___VENDOR__] = ACTIONS(4851),
    [anon_sym___VERSION__] = ACTIONS(4851),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4853),
    [sym_float_literal] = ACTIONS(4853),
    [sym__string] = ACTIONS(4853),
  },
  [1467] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_q_LBRACE] = ACTIONS(4857),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACE] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(4857),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS] = ACTIONS(4855),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4857),
    [anon_sym_LPAREN] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym_DOLLAR] = ACTIONS(4857),
    [anon_sym_STAR] = ACTIONS(4857),
    [anon_sym_TILDE] = ACTIONS(4857),
    [anon_sym_AT] = ACTIONS(4857),
    [sym_bool] = ACTIONS(4855),
    [sym_byte] = ACTIONS(4855),
    [sym_ubyte] = ACTIONS(4855),
    [sym_char] = ACTIONS(4855),
    [sym_short] = ACTIONS(4855),
    [sym_ushort] = ACTIONS(4855),
    [sym_int] = ACTIONS(4855),
    [sym_uint] = ACTIONS(4855),
    [sym_long] = ACTIONS(4855),
    [sym_ulong] = ACTIONS(4855),
    [sym_cent] = ACTIONS(4855),
    [sym_ucent] = ACTIONS(4855),
    [sym_wchar] = ACTIONS(4855),
    [sym_dchar] = ACTIONS(4855),
    [sym_float] = ACTIONS(4855),
    [sym_double] = ACTIONS(4855),
    [sym_real] = ACTIONS(4855),
    [sym_ifloat] = ACTIONS(4855),
    [sym_idouble] = ACTIONS(4855),
    [sym_ireal] = ACTIONS(4855),
    [sym_cfloat] = ACTIONS(4855),
    [sym_cdouble] = ACTIONS(4855),
    [sym_creal] = ACTIONS(4855),
    [sym_size_t] = ACTIONS(4855),
    [sym_ptrdiff_t] = ACTIONS(4855),
    [sym_string] = ACTIONS(4855),
    [sym_cstring] = ACTIONS(4855),
    [sym_dstring] = ACTIONS(4855),
    [sym_wstring] = ACTIONS(4855),
    [sym_noreturn] = ACTIONS(4855),
    [sym_true] = ACTIONS(4855),
    [sym_false] = ACTIONS(4855),
    [sym_null] = ACTIONS(4855),
    [sym_super] = ACTIONS(4855),
    [sym_this] = ACTIONS(4855),
    [sym_abstract] = ACTIONS(4855),
    [sym_alias] = ACTIONS(4855),
    [sym_align] = ACTIONS(4855),
    [sym_asm] = ACTIONS(4855),
    [sym_assert] = ACTIONS(4855),
    [sym_auto] = ACTIONS(4855),
    [sym_break] = ACTIONS(4855),
    [sym_case] = ACTIONS(4855),
    [sym_cast] = ACTIONS(4855),
    [sym_catch] = ACTIONS(4855),
    [sym_class] = ACTIONS(4855),
    [sym_const] = ACTIONS(4855),
    [sym_continue] = ACTIONS(4855),
    [sym_debug] = ACTIONS(4855),
    [sym_default] = ACTIONS(4855),
    [sym_delegate] = ACTIONS(4855),
    [sym_delete] = ACTIONS(4855),
    [sym_deprecated] = ACTIONS(4855),
    [sym_do] = ACTIONS(4855),
    [sym_else] = ACTIONS(4855),
    [sym_enum] = ACTIONS(4855),
    [sym_export] = ACTIONS(4855),
    [sym_extern] = ACTIONS(4855),
    [sym_final] = ACTIONS(4855),
    [sym_finally] = ACTIONS(4855),
    [sym_for] = ACTIONS(4855),
    [sym_foreach] = ACTIONS(4855),
    [sym_foreach_reverse] = ACTIONS(4855),
    [sym_function] = ACTIONS(4855),
    [sym_goto] = ACTIONS(4855),
    [sym_if] = ACTIONS(4855),
    [sym_immutable] = ACTIONS(4855),
    [sym_import] = ACTIONS(4855),
    [sym_in] = ACTIONS(4855),
    [sym_inout] = ACTIONS(4855),
    [sym_interface] = ACTIONS(4855),
    [sym_invariant] = ACTIONS(4855),
    [sym_is] = ACTIONS(4855),
    [sym_mixin] = ACTIONS(4855),
    [sym_new] = ACTIONS(4855),
    [sym_nothrow] = ACTIONS(4855),
    [sym_out] = ACTIONS(4855),
    [sym_override] = ACTIONS(4855),
    [sym_package] = ACTIONS(4855),
    [sym_pragma] = ACTIONS(4855),
    [sym_private] = ACTIONS(4855),
    [sym_protected] = ACTIONS(4855),
    [sym_public] = ACTIONS(4855),
    [sym_pure] = ACTIONS(4855),
    [sym_ref] = ACTIONS(4855),
    [sym_return] = ACTIONS(4855),
    [sym_scope] = ACTIONS(4855),
    [sym_shared] = ACTIONS(4855),
    [sym_static] = ACTIONS(4855),
    [sym_struct] = ACTIONS(4855),
    [sym_switch] = ACTIONS(4855),
    [sym_synchronized] = ACTIONS(4855),
    [sym_template] = ACTIONS(4855),
    [sym_throw] = ACTIONS(4855),
    [sym_try] = ACTIONS(4855),
    [sym_typeid] = ACTIONS(4855),
    [sym_typeof] = ACTIONS(4855),
    [sym_union] = ACTIONS(4855),
    [sym_unittest] = ACTIONS(4855),
    [sym_version] = ACTIONS(4855),
    [sym_while] = ACTIONS(4855),
    [sym_with] = ACTIONS(4855),
    [sym_gshared] = ACTIONS(4855),
    [sym_traits] = ACTIONS(4855),
    [sym_vector] = ACTIONS(4855),
    [sym_void] = ACTIONS(4855),
    [anon_sym_BQUOTE] = ACTIONS(4857),
    [anon_sym_r_DQUOTE] = ACTIONS(4857),
    [anon_sym_x_DQUOTE] = ACTIONS(4857),
    [anon_sym_DQUOTE] = ACTIONS(4857),
    [anon_sym_i_BQUOTE] = ACTIONS(4857),
    [anon_sym_i_DQUOTE] = ACTIONS(4857),
    [anon_sym_iq_LBRACE] = ACTIONS(4857),
    [aux_sym_char_literal_token1] = ACTIONS(4857),
    [anon_sym_SQUOTE] = ACTIONS(4855),
    [anon_sym___DATE__] = ACTIONS(4855),
    [anon_sym___FILE__] = ACTIONS(4855),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4855),
    [anon_sym___FUNCTION__] = ACTIONS(4855),
    [anon_sym___LINE__] = ACTIONS(4855),
    [anon_sym___MODULE__] = ACTIONS(4855),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4855),
    [anon_sym___TIME__] = ACTIONS(4855),
    [anon_sym___TIMESTAMP__] = ACTIONS(4855),
    [anon_sym___VENDOR__] = ACTIONS(4855),
    [anon_sym___VERSION__] = ACTIONS(4855),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4857),
    [sym_float_literal] = ACTIONS(4857),
    [sym__string] = ACTIONS(4857),
  },
  [1468] = {
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_q_LBRACE] = ACTIONS(4861),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_LBRACE] = ACTIONS(4861),
    [anon_sym_DOT] = ACTIONS(4861),
    [anon_sym_AMP] = ACTIONS(4861),
    [anon_sym_DASH] = ACTIONS(4859),
    [anon_sym_DASH_DASH] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4859),
    [anon_sym_PLUS_PLUS] = ACTIONS(4861),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_LPAREN] = ACTIONS(4861),
    [anon_sym_RPAREN] = ACTIONS(4861),
    [anon_sym_LBRACK] = ACTIONS(4861),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_DOLLAR] = ACTIONS(4861),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_AT] = ACTIONS(4861),
    [sym_bool] = ACTIONS(4859),
    [sym_byte] = ACTIONS(4859),
    [sym_ubyte] = ACTIONS(4859),
    [sym_char] = ACTIONS(4859),
    [sym_short] = ACTIONS(4859),
    [sym_ushort] = ACTIONS(4859),
    [sym_int] = ACTIONS(4859),
    [sym_uint] = ACTIONS(4859),
    [sym_long] = ACTIONS(4859),
    [sym_ulong] = ACTIONS(4859),
    [sym_cent] = ACTIONS(4859),
    [sym_ucent] = ACTIONS(4859),
    [sym_wchar] = ACTIONS(4859),
    [sym_dchar] = ACTIONS(4859),
    [sym_float] = ACTIONS(4859),
    [sym_double] = ACTIONS(4859),
    [sym_real] = ACTIONS(4859),
    [sym_ifloat] = ACTIONS(4859),
    [sym_idouble] = ACTIONS(4859),
    [sym_ireal] = ACTIONS(4859),
    [sym_cfloat] = ACTIONS(4859),
    [sym_cdouble] = ACTIONS(4859),
    [sym_creal] = ACTIONS(4859),
    [sym_size_t] = ACTIONS(4859),
    [sym_ptrdiff_t] = ACTIONS(4859),
    [sym_string] = ACTIONS(4859),
    [sym_cstring] = ACTIONS(4859),
    [sym_dstring] = ACTIONS(4859),
    [sym_wstring] = ACTIONS(4859),
    [sym_noreturn] = ACTIONS(4859),
    [sym_true] = ACTIONS(4859),
    [sym_false] = ACTIONS(4859),
    [sym_null] = ACTIONS(4859),
    [sym_super] = ACTIONS(4859),
    [sym_this] = ACTIONS(4859),
    [sym_abstract] = ACTIONS(4859),
    [sym_alias] = ACTIONS(4859),
    [sym_align] = ACTIONS(4859),
    [sym_asm] = ACTIONS(4859),
    [sym_assert] = ACTIONS(4859),
    [sym_auto] = ACTIONS(4859),
    [sym_break] = ACTIONS(4859),
    [sym_case] = ACTIONS(4859),
    [sym_cast] = ACTIONS(4859),
    [sym_catch] = ACTIONS(4859),
    [sym_class] = ACTIONS(4859),
    [sym_const] = ACTIONS(4859),
    [sym_continue] = ACTIONS(4859),
    [sym_debug] = ACTIONS(4859),
    [sym_default] = ACTIONS(4859),
    [sym_delegate] = ACTIONS(4859),
    [sym_delete] = ACTIONS(4859),
    [sym_deprecated] = ACTIONS(4859),
    [sym_do] = ACTIONS(4859),
    [sym_else] = ACTIONS(4859),
    [sym_enum] = ACTIONS(4859),
    [sym_export] = ACTIONS(4859),
    [sym_extern] = ACTIONS(4859),
    [sym_final] = ACTIONS(4859),
    [sym_finally] = ACTIONS(4859),
    [sym_for] = ACTIONS(4859),
    [sym_foreach] = ACTIONS(4859),
    [sym_foreach_reverse] = ACTIONS(4859),
    [sym_function] = ACTIONS(4859),
    [sym_goto] = ACTIONS(4859),
    [sym_if] = ACTIONS(4859),
    [sym_immutable] = ACTIONS(4859),
    [sym_import] = ACTIONS(4859),
    [sym_in] = ACTIONS(4859),
    [sym_inout] = ACTIONS(4859),
    [sym_interface] = ACTIONS(4859),
    [sym_invariant] = ACTIONS(4859),
    [sym_is] = ACTIONS(4859),
    [sym_mixin] = ACTIONS(4859),
    [sym_new] = ACTIONS(4859),
    [sym_nothrow] = ACTIONS(4859),
    [sym_out] = ACTIONS(4859),
    [sym_override] = ACTIONS(4859),
    [sym_package] = ACTIONS(4859),
    [sym_pragma] = ACTIONS(4859),
    [sym_private] = ACTIONS(4859),
    [sym_protected] = ACTIONS(4859),
    [sym_public] = ACTIONS(4859),
    [sym_pure] = ACTIONS(4859),
    [sym_ref] = ACTIONS(4859),
    [sym_return] = ACTIONS(4859),
    [sym_scope] = ACTIONS(4859),
    [sym_shared] = ACTIONS(4859),
    [sym_static] = ACTIONS(4859),
    [sym_struct] = ACTIONS(4859),
    [sym_switch] = ACTIONS(4859),
    [sym_synchronized] = ACTIONS(4859),
    [sym_template] = ACTIONS(4859),
    [sym_throw] = ACTIONS(4859),
    [sym_try] = ACTIONS(4859),
    [sym_typeid] = ACTIONS(4859),
    [sym_typeof] = ACTIONS(4859),
    [sym_union] = ACTIONS(4859),
    [sym_unittest] = ACTIONS(4859),
    [sym_version] = ACTIONS(4859),
    [sym_while] = ACTIONS(4859),
    [sym_with] = ACTIONS(4859),
    [sym_gshared] = ACTIONS(4859),
    [sym_traits] = ACTIONS(4859),
    [sym_vector] = ACTIONS(4859),
    [sym_void] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_r_DQUOTE] = ACTIONS(4861),
    [anon_sym_x_DQUOTE] = ACTIONS(4861),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_i_BQUOTE] = ACTIONS(4861),
    [anon_sym_i_DQUOTE] = ACTIONS(4861),
    [anon_sym_iq_LBRACE] = ACTIONS(4861),
    [aux_sym_char_literal_token1] = ACTIONS(4861),
    [anon_sym_SQUOTE] = ACTIONS(4859),
    [anon_sym___DATE__] = ACTIONS(4859),
    [anon_sym___FILE__] = ACTIONS(4859),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4859),
    [anon_sym___FUNCTION__] = ACTIONS(4859),
    [anon_sym___LINE__] = ACTIONS(4859),
    [anon_sym___MODULE__] = ACTIONS(4859),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4859),
    [anon_sym___TIME__] = ACTIONS(4859),
    [anon_sym___TIMESTAMP__] = ACTIONS(4859),
    [anon_sym___VENDOR__] = ACTIONS(4859),
    [anon_sym___VERSION__] = ACTIONS(4859),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4861),
    [sym_float_literal] = ACTIONS(4861),
    [sym__string] = ACTIONS(4861),
  },
  [1469] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_q_LBRACE] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [sym_bool] = ACTIONS(2634),
    [sym_byte] = ACTIONS(2634),
    [sym_ubyte] = ACTIONS(2634),
    [sym_char] = ACTIONS(2634),
    [sym_short] = ACTIONS(2634),
    [sym_ushort] = ACTIONS(2634),
    [sym_int] = ACTIONS(2634),
    [sym_uint] = ACTIONS(2634),
    [sym_long] = ACTIONS(2634),
    [sym_ulong] = ACTIONS(2634),
    [sym_cent] = ACTIONS(2634),
    [sym_ucent] = ACTIONS(2634),
    [sym_wchar] = ACTIONS(2634),
    [sym_dchar] = ACTIONS(2634),
    [sym_float] = ACTIONS(2634),
    [sym_double] = ACTIONS(2634),
    [sym_real] = ACTIONS(2634),
    [sym_ifloat] = ACTIONS(2634),
    [sym_idouble] = ACTIONS(2634),
    [sym_ireal] = ACTIONS(2634),
    [sym_cfloat] = ACTIONS(2634),
    [sym_cdouble] = ACTIONS(2634),
    [sym_creal] = ACTIONS(2634),
    [sym_size_t] = ACTIONS(2634),
    [sym_ptrdiff_t] = ACTIONS(2634),
    [sym_string] = ACTIONS(2634),
    [sym_cstring] = ACTIONS(2634),
    [sym_dstring] = ACTIONS(2634),
    [sym_wstring] = ACTIONS(2634),
    [sym_noreturn] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_this] = ACTIONS(2634),
    [sym_abstract] = ACTIONS(2634),
    [sym_alias] = ACTIONS(2634),
    [sym_align] = ACTIONS(2634),
    [sym_asm] = ACTIONS(2634),
    [sym_assert] = ACTIONS(2634),
    [sym_auto] = ACTIONS(2634),
    [sym_break] = ACTIONS(2634),
    [sym_case] = ACTIONS(2634),
    [sym_cast] = ACTIONS(2634),
    [sym_catch] = ACTIONS(2634),
    [sym_class] = ACTIONS(2634),
    [sym_const] = ACTIONS(2634),
    [sym_continue] = ACTIONS(2634),
    [sym_debug] = ACTIONS(2634),
    [sym_default] = ACTIONS(2634),
    [sym_delegate] = ACTIONS(2634),
    [sym_delete] = ACTIONS(2634),
    [sym_deprecated] = ACTIONS(2634),
    [sym_do] = ACTIONS(2634),
    [sym_else] = ACTIONS(4863),
    [sym_enum] = ACTIONS(2634),
    [sym_export] = ACTIONS(2634),
    [sym_extern] = ACTIONS(2634),
    [sym_final] = ACTIONS(2634),
    [sym_finally] = ACTIONS(2634),
    [sym_for] = ACTIONS(2634),
    [sym_foreach] = ACTIONS(2634),
    [sym_foreach_reverse] = ACTIONS(2634),
    [sym_function] = ACTIONS(2634),
    [sym_goto] = ACTIONS(2634),
    [sym_if] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(2634),
    [sym_import] = ACTIONS(2634),
    [sym_in] = ACTIONS(2634),
    [sym_inout] = ACTIONS(2634),
    [sym_interface] = ACTIONS(2634),
    [sym_invariant] = ACTIONS(2634),
    [sym_is] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2634),
    [sym_new] = ACTIONS(2634),
    [sym_nothrow] = ACTIONS(2634),
    [sym_out] = ACTIONS(2634),
    [sym_override] = ACTIONS(2634),
    [sym_package] = ACTIONS(2634),
    [sym_pragma] = ACTIONS(2634),
    [sym_private] = ACTIONS(2634),
    [sym_protected] = ACTIONS(2634),
    [sym_public] = ACTIONS(2634),
    [sym_pure] = ACTIONS(2634),
    [sym_ref] = ACTIONS(2634),
    [sym_return] = ACTIONS(2634),
    [sym_scope] = ACTIONS(2634),
    [sym_shared] = ACTIONS(2634),
    [sym_static] = ACTIONS(2634),
    [sym_struct] = ACTIONS(2634),
    [sym_switch] = ACTIONS(2634),
    [sym_synchronized] = ACTIONS(2634),
    [sym_template] = ACTIONS(2634),
    [sym_throw] = ACTIONS(2634),
    [sym_try] = ACTIONS(2634),
    [sym_typeid] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(2634),
    [sym_union] = ACTIONS(2634),
    [sym_unittest] = ACTIONS(2634),
    [sym_version] = ACTIONS(2634),
    [sym_while] = ACTIONS(2634),
    [sym_with] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(2634),
    [sym_traits] = ACTIONS(2634),
    [sym_vector] = ACTIONS(2634),
    [sym_void] = ACTIONS(2634),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_r_DQUOTE] = ACTIONS(2632),
    [anon_sym_x_DQUOTE] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_i_BQUOTE] = ACTIONS(2632),
    [anon_sym_i_DQUOTE] = ACTIONS(2632),
    [anon_sym_iq_LBRACE] = ACTIONS(2632),
    [aux_sym_char_literal_token1] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym___DATE__] = ACTIONS(2634),
    [anon_sym___FILE__] = ACTIONS(2634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2634),
    [anon_sym___FUNCTION__] = ACTIONS(2634),
    [anon_sym___LINE__] = ACTIONS(2634),
    [anon_sym___MODULE__] = ACTIONS(2634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2634),
    [anon_sym___TIME__] = ACTIONS(2634),
    [anon_sym___TIMESTAMP__] = ACTIONS(2634),
    [anon_sym___VENDOR__] = ACTIONS(2634),
    [anon_sym___VERSION__] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__string] = ACTIONS(2632),
  },
  [1470] = {
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_q_LBRACE] = ACTIONS(4867),
    [anon_sym_RBRACE] = ACTIONS(4867),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_AMP] = ACTIONS(4867),
    [anon_sym_DASH] = ACTIONS(4865),
    [anon_sym_DASH_DASH] = ACTIONS(4867),
    [anon_sym_PLUS] = ACTIONS(4865),
    [anon_sym_PLUS_PLUS] = ACTIONS(4867),
    [anon_sym_BANG] = ACTIONS(4867),
    [anon_sym_LPAREN] = ACTIONS(4867),
    [anon_sym_RPAREN] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4867),
    [anon_sym_SEMI] = ACTIONS(4867),
    [anon_sym_DOLLAR] = ACTIONS(4867),
    [anon_sym_STAR] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4867),
    [anon_sym_AT] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4865),
    [sym_byte] = ACTIONS(4865),
    [sym_ubyte] = ACTIONS(4865),
    [sym_char] = ACTIONS(4865),
    [sym_short] = ACTIONS(4865),
    [sym_ushort] = ACTIONS(4865),
    [sym_int] = ACTIONS(4865),
    [sym_uint] = ACTIONS(4865),
    [sym_long] = ACTIONS(4865),
    [sym_ulong] = ACTIONS(4865),
    [sym_cent] = ACTIONS(4865),
    [sym_ucent] = ACTIONS(4865),
    [sym_wchar] = ACTIONS(4865),
    [sym_dchar] = ACTIONS(4865),
    [sym_float] = ACTIONS(4865),
    [sym_double] = ACTIONS(4865),
    [sym_real] = ACTIONS(4865),
    [sym_ifloat] = ACTIONS(4865),
    [sym_idouble] = ACTIONS(4865),
    [sym_ireal] = ACTIONS(4865),
    [sym_cfloat] = ACTIONS(4865),
    [sym_cdouble] = ACTIONS(4865),
    [sym_creal] = ACTIONS(4865),
    [sym_size_t] = ACTIONS(4865),
    [sym_ptrdiff_t] = ACTIONS(4865),
    [sym_string] = ACTIONS(4865),
    [sym_cstring] = ACTIONS(4865),
    [sym_dstring] = ACTIONS(4865),
    [sym_wstring] = ACTIONS(4865),
    [sym_noreturn] = ACTIONS(4865),
    [sym_true] = ACTIONS(4865),
    [sym_false] = ACTIONS(4865),
    [sym_null] = ACTIONS(4865),
    [sym_super] = ACTIONS(4865),
    [sym_this] = ACTIONS(4865),
    [sym_abstract] = ACTIONS(4865),
    [sym_alias] = ACTIONS(4865),
    [sym_align] = ACTIONS(4865),
    [sym_asm] = ACTIONS(4865),
    [sym_assert] = ACTIONS(4865),
    [sym_auto] = ACTIONS(4865),
    [sym_break] = ACTIONS(4865),
    [sym_case] = ACTIONS(4865),
    [sym_cast] = ACTIONS(4865),
    [sym_catch] = ACTIONS(4865),
    [sym_class] = ACTIONS(4865),
    [sym_const] = ACTIONS(4865),
    [sym_continue] = ACTIONS(4865),
    [sym_debug] = ACTIONS(4865),
    [sym_default] = ACTIONS(4865),
    [sym_delegate] = ACTIONS(4865),
    [sym_delete] = ACTIONS(4865),
    [sym_deprecated] = ACTIONS(4865),
    [sym_do] = ACTIONS(4865),
    [sym_else] = ACTIONS(4865),
    [sym_enum] = ACTIONS(4865),
    [sym_export] = ACTIONS(4865),
    [sym_extern] = ACTIONS(4865),
    [sym_final] = ACTIONS(4865),
    [sym_finally] = ACTIONS(4865),
    [sym_for] = ACTIONS(4865),
    [sym_foreach] = ACTIONS(4865),
    [sym_foreach_reverse] = ACTIONS(4865),
    [sym_function] = ACTIONS(4865),
    [sym_goto] = ACTIONS(4865),
    [sym_if] = ACTIONS(4865),
    [sym_immutable] = ACTIONS(4865),
    [sym_import] = ACTIONS(4865),
    [sym_in] = ACTIONS(4865),
    [sym_inout] = ACTIONS(4865),
    [sym_interface] = ACTIONS(4865),
    [sym_invariant] = ACTIONS(4865),
    [sym_is] = ACTIONS(4865),
    [sym_mixin] = ACTIONS(4865),
    [sym_new] = ACTIONS(4865),
    [sym_nothrow] = ACTIONS(4865),
    [sym_out] = ACTIONS(4865),
    [sym_override] = ACTIONS(4865),
    [sym_package] = ACTIONS(4865),
    [sym_pragma] = ACTIONS(4865),
    [sym_private] = ACTIONS(4865),
    [sym_protected] = ACTIONS(4865),
    [sym_public] = ACTIONS(4865),
    [sym_pure] = ACTIONS(4865),
    [sym_ref] = ACTIONS(4865),
    [sym_return] = ACTIONS(4865),
    [sym_scope] = ACTIONS(4865),
    [sym_shared] = ACTIONS(4865),
    [sym_static] = ACTIONS(4865),
    [sym_struct] = ACTIONS(4865),
    [sym_switch] = ACTIONS(4865),
    [sym_synchronized] = ACTIONS(4865),
    [sym_template] = ACTIONS(4865),
    [sym_throw] = ACTIONS(4865),
    [sym_try] = ACTIONS(4865),
    [sym_typeid] = ACTIONS(4865),
    [sym_typeof] = ACTIONS(4865),
    [sym_union] = ACTIONS(4865),
    [sym_unittest] = ACTIONS(4865),
    [sym_version] = ACTIONS(4865),
    [sym_while] = ACTIONS(4865),
    [sym_with] = ACTIONS(4865),
    [sym_gshared] = ACTIONS(4865),
    [sym_traits] = ACTIONS(4865),
    [sym_vector] = ACTIONS(4865),
    [sym_void] = ACTIONS(4865),
    [anon_sym_BQUOTE] = ACTIONS(4867),
    [anon_sym_r_DQUOTE] = ACTIONS(4867),
    [anon_sym_x_DQUOTE] = ACTIONS(4867),
    [anon_sym_DQUOTE] = ACTIONS(4867),
    [anon_sym_i_BQUOTE] = ACTIONS(4867),
    [anon_sym_i_DQUOTE] = ACTIONS(4867),
    [anon_sym_iq_LBRACE] = ACTIONS(4867),
    [aux_sym_char_literal_token1] = ACTIONS(4867),
    [anon_sym_SQUOTE] = ACTIONS(4865),
    [anon_sym___DATE__] = ACTIONS(4865),
    [anon_sym___FILE__] = ACTIONS(4865),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4865),
    [anon_sym___FUNCTION__] = ACTIONS(4865),
    [anon_sym___LINE__] = ACTIONS(4865),
    [anon_sym___MODULE__] = ACTIONS(4865),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4865),
    [anon_sym___TIME__] = ACTIONS(4865),
    [anon_sym___TIMESTAMP__] = ACTIONS(4865),
    [anon_sym___VENDOR__] = ACTIONS(4865),
    [anon_sym___VERSION__] = ACTIONS(4865),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4867),
    [sym_float_literal] = ACTIONS(4867),
    [sym__string] = ACTIONS(4867),
  },
  [1471] = {
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_q_LBRACE] = ACTIONS(4871),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4871),
    [anon_sym_DASH] = ACTIONS(4869),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4869),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_BANG] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_DOLLAR] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4871),
    [anon_sym_AT] = ACTIONS(4871),
    [sym_bool] = ACTIONS(4869),
    [sym_byte] = ACTIONS(4869),
    [sym_ubyte] = ACTIONS(4869),
    [sym_char] = ACTIONS(4869),
    [sym_short] = ACTIONS(4869),
    [sym_ushort] = ACTIONS(4869),
    [sym_int] = ACTIONS(4869),
    [sym_uint] = ACTIONS(4869),
    [sym_long] = ACTIONS(4869),
    [sym_ulong] = ACTIONS(4869),
    [sym_cent] = ACTIONS(4869),
    [sym_ucent] = ACTIONS(4869),
    [sym_wchar] = ACTIONS(4869),
    [sym_dchar] = ACTIONS(4869),
    [sym_float] = ACTIONS(4869),
    [sym_double] = ACTIONS(4869),
    [sym_real] = ACTIONS(4869),
    [sym_ifloat] = ACTIONS(4869),
    [sym_idouble] = ACTIONS(4869),
    [sym_ireal] = ACTIONS(4869),
    [sym_cfloat] = ACTIONS(4869),
    [sym_cdouble] = ACTIONS(4869),
    [sym_creal] = ACTIONS(4869),
    [sym_size_t] = ACTIONS(4869),
    [sym_ptrdiff_t] = ACTIONS(4869),
    [sym_string] = ACTIONS(4869),
    [sym_cstring] = ACTIONS(4869),
    [sym_dstring] = ACTIONS(4869),
    [sym_wstring] = ACTIONS(4869),
    [sym_noreturn] = ACTIONS(4869),
    [sym_true] = ACTIONS(4869),
    [sym_false] = ACTIONS(4869),
    [sym_null] = ACTIONS(4869),
    [sym_super] = ACTIONS(4869),
    [sym_this] = ACTIONS(4869),
    [sym_abstract] = ACTIONS(4869),
    [sym_alias] = ACTIONS(4869),
    [sym_align] = ACTIONS(4869),
    [sym_asm] = ACTIONS(4869),
    [sym_assert] = ACTIONS(4869),
    [sym_auto] = ACTIONS(4869),
    [sym_break] = ACTIONS(4869),
    [sym_case] = ACTIONS(4869),
    [sym_cast] = ACTIONS(4869),
    [sym_catch] = ACTIONS(4869),
    [sym_class] = ACTIONS(4869),
    [sym_const] = ACTIONS(4869),
    [sym_continue] = ACTIONS(4869),
    [sym_debug] = ACTIONS(4869),
    [sym_default] = ACTIONS(4869),
    [sym_delegate] = ACTIONS(4869),
    [sym_delete] = ACTIONS(4869),
    [sym_deprecated] = ACTIONS(4869),
    [sym_do] = ACTIONS(4869),
    [sym_else] = ACTIONS(4869),
    [sym_enum] = ACTIONS(4869),
    [sym_export] = ACTIONS(4869),
    [sym_extern] = ACTIONS(4869),
    [sym_final] = ACTIONS(4869),
    [sym_finally] = ACTIONS(4869),
    [sym_for] = ACTIONS(4869),
    [sym_foreach] = ACTIONS(4869),
    [sym_foreach_reverse] = ACTIONS(4869),
    [sym_function] = ACTIONS(4869),
    [sym_goto] = ACTIONS(4869),
    [sym_if] = ACTIONS(4869),
    [sym_immutable] = ACTIONS(4869),
    [sym_import] = ACTIONS(4869),
    [sym_in] = ACTIONS(4869),
    [sym_inout] = ACTIONS(4869),
    [sym_interface] = ACTIONS(4869),
    [sym_invariant] = ACTIONS(4869),
    [sym_is] = ACTIONS(4869),
    [sym_mixin] = ACTIONS(4869),
    [sym_new] = ACTIONS(4869),
    [sym_nothrow] = ACTIONS(4869),
    [sym_out] = ACTIONS(4869),
    [sym_override] = ACTIONS(4869),
    [sym_package] = ACTIONS(4869),
    [sym_pragma] = ACTIONS(4869),
    [sym_private] = ACTIONS(4869),
    [sym_protected] = ACTIONS(4869),
    [sym_public] = ACTIONS(4869),
    [sym_pure] = ACTIONS(4869),
    [sym_ref] = ACTIONS(4869),
    [sym_return] = ACTIONS(4869),
    [sym_scope] = ACTIONS(4869),
    [sym_shared] = ACTIONS(4869),
    [sym_static] = ACTIONS(4869),
    [sym_struct] = ACTIONS(4869),
    [sym_switch] = ACTIONS(4869),
    [sym_synchronized] = ACTIONS(4869),
    [sym_template] = ACTIONS(4869),
    [sym_throw] = ACTIONS(4869),
    [sym_try] = ACTIONS(4869),
    [sym_typeid] = ACTIONS(4869),
    [sym_typeof] = ACTIONS(4869),
    [sym_union] = ACTIONS(4869),
    [sym_unittest] = ACTIONS(4869),
    [sym_version] = ACTIONS(4869),
    [sym_while] = ACTIONS(4869),
    [sym_with] = ACTIONS(4869),
    [sym_gshared] = ACTIONS(4869),
    [sym_traits] = ACTIONS(4869),
    [sym_vector] = ACTIONS(4869),
    [sym_void] = ACTIONS(4869),
    [anon_sym_BQUOTE] = ACTIONS(4871),
    [anon_sym_r_DQUOTE] = ACTIONS(4871),
    [anon_sym_x_DQUOTE] = ACTIONS(4871),
    [anon_sym_DQUOTE] = ACTIONS(4871),
    [anon_sym_i_BQUOTE] = ACTIONS(4871),
    [anon_sym_i_DQUOTE] = ACTIONS(4871),
    [anon_sym_iq_LBRACE] = ACTIONS(4871),
    [aux_sym_char_literal_token1] = ACTIONS(4871),
    [anon_sym_SQUOTE] = ACTIONS(4869),
    [anon_sym___DATE__] = ACTIONS(4869),
    [anon_sym___FILE__] = ACTIONS(4869),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4869),
    [anon_sym___FUNCTION__] = ACTIONS(4869),
    [anon_sym___LINE__] = ACTIONS(4869),
    [anon_sym___MODULE__] = ACTIONS(4869),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4869),
    [anon_sym___TIME__] = ACTIONS(4869),
    [anon_sym___TIMESTAMP__] = ACTIONS(4869),
    [anon_sym___VENDOR__] = ACTIONS(4869),
    [anon_sym___VERSION__] = ACTIONS(4869),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4871),
    [sym_float_literal] = ACTIONS(4871),
    [sym__string] = ACTIONS(4871),
  },
  [1472] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_q_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_abstract] = ACTIONS(3176),
    [sym_alias] = ACTIONS(3176),
    [sym_align] = ACTIONS(3176),
    [sym_asm] = ACTIONS(3176),
    [sym_assert] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_break] = ACTIONS(3176),
    [sym_case] = ACTIONS(3176),
    [sym_cast] = ACTIONS(3176),
    [sym_catch] = ACTIONS(3176),
    [sym_class] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_continue] = ACTIONS(3176),
    [sym_debug] = ACTIONS(3176),
    [sym_default] = ACTIONS(3176),
    [sym_delegate] = ACTIONS(3176),
    [sym_delete] = ACTIONS(3176),
    [sym_deprecated] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_enum] = ACTIONS(3176),
    [sym_export] = ACTIONS(3176),
    [sym_extern] = ACTIONS(3176),
    [sym_final] = ACTIONS(3176),
    [sym_finally] = ACTIONS(3176),
    [sym_for] = ACTIONS(3176),
    [sym_foreach] = ACTIONS(3176),
    [sym_foreach_reverse] = ACTIONS(3176),
    [sym_function] = ACTIONS(3176),
    [sym_goto] = ACTIONS(3176),
    [sym_if] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_interface] = ACTIONS(3176),
    [sym_invariant] = ACTIONS(3176),
    [sym_is] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_new] = ACTIONS(3176),
    [sym_nothrow] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_override] = ACTIONS(3176),
    [sym_package] = ACTIONS(3176),
    [sym_pragma] = ACTIONS(3176),
    [sym_private] = ACTIONS(3176),
    [sym_protected] = ACTIONS(3176),
    [sym_public] = ACTIONS(3176),
    [sym_pure] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_return] = ACTIONS(3176),
    [sym_scope] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_static] = ACTIONS(3176),
    [sym_struct] = ACTIONS(3176),
    [sym_switch] = ACTIONS(3176),
    [sym_synchronized] = ACTIONS(3176),
    [sym_template] = ACTIONS(3176),
    [sym_throw] = ACTIONS(3176),
    [sym_try] = ACTIONS(3176),
    [sym_typeid] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_union] = ACTIONS(3176),
    [sym_unittest] = ACTIONS(3176),
    [sym_version] = ACTIONS(3176),
    [sym_while] = ACTIONS(3176),
    [sym_with] = ACTIONS(3176),
    [sym_gshared] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_r_DQUOTE] = ACTIONS(3178),
    [anon_sym_x_DQUOTE] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_i_BQUOTE] = ACTIONS(3178),
    [anon_sym_i_DQUOTE] = ACTIONS(3178),
    [anon_sym_iq_LBRACE] = ACTIONS(3178),
    [aux_sym_char_literal_token1] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym___DATE__] = ACTIONS(3176),
    [anon_sym___FILE__] = ACTIONS(3176),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3176),
    [anon_sym___FUNCTION__] = ACTIONS(3176),
    [anon_sym___LINE__] = ACTIONS(3176),
    [anon_sym___MODULE__] = ACTIONS(3176),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3176),
    [anon_sym___TIME__] = ACTIONS(3176),
    [anon_sym___TIMESTAMP__] = ACTIONS(3176),
    [anon_sym___VENDOR__] = ACTIONS(3176),
    [anon_sym___VERSION__] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3178),
    [sym_float_literal] = ACTIONS(3178),
    [sym__string] = ACTIONS(3178),
  },
  [1473] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_q_LBRACE] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_abstract] = ACTIONS(3163),
    [sym_alias] = ACTIONS(3163),
    [sym_align] = ACTIONS(3163),
    [sym_asm] = ACTIONS(3163),
    [sym_assert] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_break] = ACTIONS(3163),
    [sym_case] = ACTIONS(3163),
    [sym_cast] = ACTIONS(3163),
    [sym_catch] = ACTIONS(3163),
    [sym_class] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_continue] = ACTIONS(3163),
    [sym_debug] = ACTIONS(3163),
    [sym_default] = ACTIONS(3163),
    [sym_delegate] = ACTIONS(3163),
    [sym_delete] = ACTIONS(3163),
    [sym_deprecated] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_enum] = ACTIONS(3163),
    [sym_export] = ACTIONS(3163),
    [sym_extern] = ACTIONS(3163),
    [sym_final] = ACTIONS(3163),
    [sym_finally] = ACTIONS(3163),
    [sym_for] = ACTIONS(3163),
    [sym_foreach] = ACTIONS(3163),
    [sym_foreach_reverse] = ACTIONS(3163),
    [sym_function] = ACTIONS(3163),
    [sym_goto] = ACTIONS(3163),
    [sym_if] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_interface] = ACTIONS(3163),
    [sym_invariant] = ACTIONS(3163),
    [sym_is] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_new] = ACTIONS(3163),
    [sym_nothrow] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_override] = ACTIONS(3163),
    [sym_package] = ACTIONS(3163),
    [sym_pragma] = ACTIONS(3163),
    [sym_private] = ACTIONS(3163),
    [sym_protected] = ACTIONS(3163),
    [sym_public] = ACTIONS(3163),
    [sym_pure] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_return] = ACTIONS(3163),
    [sym_scope] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_static] = ACTIONS(3163),
    [sym_struct] = ACTIONS(3163),
    [sym_switch] = ACTIONS(3163),
    [sym_synchronized] = ACTIONS(3163),
    [sym_template] = ACTIONS(3163),
    [sym_throw] = ACTIONS(3163),
    [sym_try] = ACTIONS(3163),
    [sym_typeid] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_union] = ACTIONS(3163),
    [sym_unittest] = ACTIONS(3163),
    [sym_version] = ACTIONS(3163),
    [sym_while] = ACTIONS(3163),
    [sym_with] = ACTIONS(3163),
    [sym_gshared] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [anon_sym_r_DQUOTE] = ACTIONS(3165),
    [anon_sym_x_DQUOTE] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_i_BQUOTE] = ACTIONS(3165),
    [anon_sym_i_DQUOTE] = ACTIONS(3165),
    [anon_sym_iq_LBRACE] = ACTIONS(3165),
    [aux_sym_char_literal_token1] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym___DATE__] = ACTIONS(3163),
    [anon_sym___FILE__] = ACTIONS(3163),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3163),
    [anon_sym___FUNCTION__] = ACTIONS(3163),
    [anon_sym___LINE__] = ACTIONS(3163),
    [anon_sym___MODULE__] = ACTIONS(3163),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3163),
    [anon_sym___TIME__] = ACTIONS(3163),
    [anon_sym___TIMESTAMP__] = ACTIONS(3163),
    [anon_sym___VENDOR__] = ACTIONS(3163),
    [anon_sym___VERSION__] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym__string] = ACTIONS(3165),
  },
  [1474] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_asm] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_break] = ACTIONS(3127),
    [sym_case] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_catch] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_continue] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_default] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_finally] = ACTIONS(3127),
    [sym_for] = ACTIONS(3127),
    [sym_foreach] = ACTIONS(3127),
    [sym_foreach_reverse] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_goto] = ACTIONS(3127),
    [sym_if] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_switch] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_try] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_with] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
  },
  [1475] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_RBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_AT] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_abstract] = ACTIONS(4682),
    [sym_alias] = ACTIONS(4682),
    [sym_align] = ACTIONS(4682),
    [sym_asm] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_break] = ACTIONS(4682),
    [sym_case] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_catch] = ACTIONS(4682),
    [sym_class] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_continue] = ACTIONS(4682),
    [sym_debug] = ACTIONS(4682),
    [sym_default] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_deprecated] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(4873),
    [sym_enum] = ACTIONS(4682),
    [sym_export] = ACTIONS(4682),
    [sym_extern] = ACTIONS(4682),
    [sym_final] = ACTIONS(4682),
    [sym_finally] = ACTIONS(4682),
    [sym_for] = ACTIONS(4682),
    [sym_foreach] = ACTIONS(4682),
    [sym_foreach_reverse] = ACTIONS(4682),
    [sym_function] = ACTIONS(4682),
    [sym_goto] = ACTIONS(4682),
    [sym_if] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_interface] = ACTIONS(4682),
    [sym_invariant] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_nothrow] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_override] = ACTIONS(4682),
    [sym_package] = ACTIONS(4682),
    [sym_pragma] = ACTIONS(4682),
    [sym_private] = ACTIONS(4682),
    [sym_protected] = ACTIONS(4682),
    [sym_public] = ACTIONS(4682),
    [sym_pure] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_return] = ACTIONS(4682),
    [sym_scope] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_static] = ACTIONS(4682),
    [sym_struct] = ACTIONS(4682),
    [sym_switch] = ACTIONS(4682),
    [sym_synchronized] = ACTIONS(4682),
    [sym_template] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_try] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_union] = ACTIONS(4682),
    [sym_unittest] = ACTIONS(4682),
    [sym_version] = ACTIONS(4682),
    [sym_while] = ACTIONS(4682),
    [sym_with] = ACTIONS(4682),
    [sym_gshared] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [1476] = {
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_q_LBRACE] = ACTIONS(4877),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_LBRACE] = ACTIONS(4877),
    [anon_sym_DOT] = ACTIONS(4877),
    [anon_sym_AMP] = ACTIONS(4877),
    [anon_sym_DASH] = ACTIONS(4875),
    [anon_sym_DASH_DASH] = ACTIONS(4877),
    [anon_sym_PLUS] = ACTIONS(4875),
    [anon_sym_PLUS_PLUS] = ACTIONS(4877),
    [anon_sym_BANG] = ACTIONS(4877),
    [anon_sym_LPAREN] = ACTIONS(4877),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_DOLLAR] = ACTIONS(4877),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_TILDE] = ACTIONS(4877),
    [anon_sym_AT] = ACTIONS(4877),
    [sym_bool] = ACTIONS(4875),
    [sym_byte] = ACTIONS(4875),
    [sym_ubyte] = ACTIONS(4875),
    [sym_char] = ACTIONS(4875),
    [sym_short] = ACTIONS(4875),
    [sym_ushort] = ACTIONS(4875),
    [sym_int] = ACTIONS(4875),
    [sym_uint] = ACTIONS(4875),
    [sym_long] = ACTIONS(4875),
    [sym_ulong] = ACTIONS(4875),
    [sym_cent] = ACTIONS(4875),
    [sym_ucent] = ACTIONS(4875),
    [sym_wchar] = ACTIONS(4875),
    [sym_dchar] = ACTIONS(4875),
    [sym_float] = ACTIONS(4875),
    [sym_double] = ACTIONS(4875),
    [sym_real] = ACTIONS(4875),
    [sym_ifloat] = ACTIONS(4875),
    [sym_idouble] = ACTIONS(4875),
    [sym_ireal] = ACTIONS(4875),
    [sym_cfloat] = ACTIONS(4875),
    [sym_cdouble] = ACTIONS(4875),
    [sym_creal] = ACTIONS(4875),
    [sym_size_t] = ACTIONS(4875),
    [sym_ptrdiff_t] = ACTIONS(4875),
    [sym_string] = ACTIONS(4875),
    [sym_cstring] = ACTIONS(4875),
    [sym_dstring] = ACTIONS(4875),
    [sym_wstring] = ACTIONS(4875),
    [sym_noreturn] = ACTIONS(4875),
    [sym_true] = ACTIONS(4875),
    [sym_false] = ACTIONS(4875),
    [sym_null] = ACTIONS(4875),
    [sym_super] = ACTIONS(4875),
    [sym_this] = ACTIONS(4875),
    [sym_abstract] = ACTIONS(4875),
    [sym_alias] = ACTIONS(4875),
    [sym_align] = ACTIONS(4875),
    [sym_asm] = ACTIONS(4875),
    [sym_assert] = ACTIONS(4875),
    [sym_auto] = ACTIONS(4875),
    [sym_break] = ACTIONS(4875),
    [sym_case] = ACTIONS(4875),
    [sym_cast] = ACTIONS(4875),
    [sym_catch] = ACTIONS(4875),
    [sym_class] = ACTIONS(4875),
    [sym_const] = ACTIONS(4875),
    [sym_continue] = ACTIONS(4875),
    [sym_debug] = ACTIONS(4875),
    [sym_default] = ACTIONS(4875),
    [sym_delegate] = ACTIONS(4875),
    [sym_delete] = ACTIONS(4875),
    [sym_deprecated] = ACTIONS(4875),
    [sym_do] = ACTIONS(4875),
    [sym_else] = ACTIONS(4875),
    [sym_enum] = ACTIONS(4875),
    [sym_export] = ACTIONS(4875),
    [sym_extern] = ACTIONS(4875),
    [sym_final] = ACTIONS(4875),
    [sym_finally] = ACTIONS(4875),
    [sym_for] = ACTIONS(4875),
    [sym_foreach] = ACTIONS(4875),
    [sym_foreach_reverse] = ACTIONS(4875),
    [sym_function] = ACTIONS(4875),
    [sym_goto] = ACTIONS(4875),
    [sym_if] = ACTIONS(4875),
    [sym_immutable] = ACTIONS(4875),
    [sym_import] = ACTIONS(4875),
    [sym_in] = ACTIONS(4875),
    [sym_inout] = ACTIONS(4875),
    [sym_interface] = ACTIONS(4875),
    [sym_invariant] = ACTIONS(4875),
    [sym_is] = ACTIONS(4875),
    [sym_mixin] = ACTIONS(4875),
    [sym_new] = ACTIONS(4875),
    [sym_nothrow] = ACTIONS(4875),
    [sym_out] = ACTIONS(4875),
    [sym_override] = ACTIONS(4875),
    [sym_package] = ACTIONS(4875),
    [sym_pragma] = ACTIONS(4875),
    [sym_private] = ACTIONS(4875),
    [sym_protected] = ACTIONS(4875),
    [sym_public] = ACTIONS(4875),
    [sym_pure] = ACTIONS(4875),
    [sym_ref] = ACTIONS(4875),
    [sym_return] = ACTIONS(4875),
    [sym_scope] = ACTIONS(4875),
    [sym_shared] = ACTIONS(4875),
    [sym_static] = ACTIONS(4875),
    [sym_struct] = ACTIONS(4875),
    [sym_switch] = ACTIONS(4875),
    [sym_synchronized] = ACTIONS(4875),
    [sym_template] = ACTIONS(4875),
    [sym_throw] = ACTIONS(4875),
    [sym_try] = ACTIONS(4875),
    [sym_typeid] = ACTIONS(4875),
    [sym_typeof] = ACTIONS(4875),
    [sym_union] = ACTIONS(4875),
    [sym_unittest] = ACTIONS(4875),
    [sym_version] = ACTIONS(4875),
    [sym_while] = ACTIONS(4875),
    [sym_with] = ACTIONS(4875),
    [sym_gshared] = ACTIONS(4875),
    [sym_traits] = ACTIONS(4875),
    [sym_vector] = ACTIONS(4875),
    [sym_void] = ACTIONS(4875),
    [anon_sym_BQUOTE] = ACTIONS(4877),
    [anon_sym_r_DQUOTE] = ACTIONS(4877),
    [anon_sym_x_DQUOTE] = ACTIONS(4877),
    [anon_sym_DQUOTE] = ACTIONS(4877),
    [anon_sym_i_BQUOTE] = ACTIONS(4877),
    [anon_sym_i_DQUOTE] = ACTIONS(4877),
    [anon_sym_iq_LBRACE] = ACTIONS(4877),
    [aux_sym_char_literal_token1] = ACTIONS(4877),
    [anon_sym_SQUOTE] = ACTIONS(4875),
    [anon_sym___DATE__] = ACTIONS(4875),
    [anon_sym___FILE__] = ACTIONS(4875),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4875),
    [anon_sym___FUNCTION__] = ACTIONS(4875),
    [anon_sym___LINE__] = ACTIONS(4875),
    [anon_sym___MODULE__] = ACTIONS(4875),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4875),
    [anon_sym___TIME__] = ACTIONS(4875),
    [anon_sym___TIMESTAMP__] = ACTIONS(4875),
    [anon_sym___VENDOR__] = ACTIONS(4875),
    [anon_sym___VERSION__] = ACTIONS(4875),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4877),
    [sym_float_literal] = ACTIONS(4877),
    [sym__string] = ACTIONS(4877),
  },
  [1477] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_q_LBRACE] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4881),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_DASH_DASH] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_PLUS_PLUS] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_DOLLAR] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_true] = ACTIONS(4879),
    [sym_false] = ACTIONS(4879),
    [sym_null] = ACTIONS(4879),
    [sym_super] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_asm] = ACTIONS(4879),
    [sym_assert] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_break] = ACTIONS(4879),
    [sym_case] = ACTIONS(4879),
    [sym_cast] = ACTIONS(4879),
    [sym_catch] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_continue] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_default] = ACTIONS(4879),
    [sym_delegate] = ACTIONS(4879),
    [sym_delete] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_do] = ACTIONS(4879),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_finally] = ACTIONS(4879),
    [sym_for] = ACTIONS(4879),
    [sym_foreach] = ACTIONS(4879),
    [sym_foreach_reverse] = ACTIONS(4879),
    [sym_function] = ACTIONS(4879),
    [sym_goto] = ACTIONS(4879),
    [sym_if] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(4879),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_is] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_new] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_out] = ACTIONS(4879),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_switch] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_throw] = ACTIONS(4879),
    [sym_try] = ACTIONS(4879),
    [sym_typeid] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_with] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [anon_sym_BQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [anon_sym_x_DQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_i_BQUOTE] = ACTIONS(4881),
    [anon_sym_i_DQUOTE] = ACTIONS(4881),
    [anon_sym_iq_LBRACE] = ACTIONS(4881),
    [aux_sym_char_literal_token1] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4879),
    [anon_sym___DATE__] = ACTIONS(4879),
    [anon_sym___FILE__] = ACTIONS(4879),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4879),
    [anon_sym___FUNCTION__] = ACTIONS(4879),
    [anon_sym___LINE__] = ACTIONS(4879),
    [anon_sym___MODULE__] = ACTIONS(4879),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4879),
    [anon_sym___TIME__] = ACTIONS(4879),
    [anon_sym___TIMESTAMP__] = ACTIONS(4879),
    [anon_sym___VENDOR__] = ACTIONS(4879),
    [anon_sym___VERSION__] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym__string] = ACTIONS(4881),
  },
  [1478] = {
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_q_LBRACE] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LBRACE] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4883),
    [anon_sym_DASH_DASH] = ACTIONS(4885),
    [anon_sym_PLUS] = ACTIONS(4883),
    [anon_sym_PLUS_PLUS] = ACTIONS(4885),
    [anon_sym_BANG] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(4885),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(4885),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [anon_sym_AT] = ACTIONS(4885),
    [sym_bool] = ACTIONS(4883),
    [sym_byte] = ACTIONS(4883),
    [sym_ubyte] = ACTIONS(4883),
    [sym_char] = ACTIONS(4883),
    [sym_short] = ACTIONS(4883),
    [sym_ushort] = ACTIONS(4883),
    [sym_int] = ACTIONS(4883),
    [sym_uint] = ACTIONS(4883),
    [sym_long] = ACTIONS(4883),
    [sym_ulong] = ACTIONS(4883),
    [sym_cent] = ACTIONS(4883),
    [sym_ucent] = ACTIONS(4883),
    [sym_wchar] = ACTIONS(4883),
    [sym_dchar] = ACTIONS(4883),
    [sym_float] = ACTIONS(4883),
    [sym_double] = ACTIONS(4883),
    [sym_real] = ACTIONS(4883),
    [sym_ifloat] = ACTIONS(4883),
    [sym_idouble] = ACTIONS(4883),
    [sym_ireal] = ACTIONS(4883),
    [sym_cfloat] = ACTIONS(4883),
    [sym_cdouble] = ACTIONS(4883),
    [sym_creal] = ACTIONS(4883),
    [sym_size_t] = ACTIONS(4883),
    [sym_ptrdiff_t] = ACTIONS(4883),
    [sym_string] = ACTIONS(4883),
    [sym_cstring] = ACTIONS(4883),
    [sym_dstring] = ACTIONS(4883),
    [sym_wstring] = ACTIONS(4883),
    [sym_noreturn] = ACTIONS(4883),
    [sym_true] = ACTIONS(4883),
    [sym_false] = ACTIONS(4883),
    [sym_null] = ACTIONS(4883),
    [sym_super] = ACTIONS(4883),
    [sym_this] = ACTIONS(4883),
    [sym_abstract] = ACTIONS(4883),
    [sym_alias] = ACTIONS(4883),
    [sym_align] = ACTIONS(4883),
    [sym_asm] = ACTIONS(4883),
    [sym_assert] = ACTIONS(4883),
    [sym_auto] = ACTIONS(4883),
    [sym_break] = ACTIONS(4883),
    [sym_case] = ACTIONS(4883),
    [sym_cast] = ACTIONS(4883),
    [sym_catch] = ACTIONS(4883),
    [sym_class] = ACTIONS(4883),
    [sym_const] = ACTIONS(4883),
    [sym_continue] = ACTIONS(4883),
    [sym_debug] = ACTIONS(4883),
    [sym_default] = ACTIONS(4883),
    [sym_delegate] = ACTIONS(4883),
    [sym_delete] = ACTIONS(4883),
    [sym_deprecated] = ACTIONS(4883),
    [sym_do] = ACTIONS(4883),
    [sym_else] = ACTIONS(4883),
    [sym_enum] = ACTIONS(4883),
    [sym_export] = ACTIONS(4883),
    [sym_extern] = ACTIONS(4883),
    [sym_final] = ACTIONS(4883),
    [sym_finally] = ACTIONS(4883),
    [sym_for] = ACTIONS(4883),
    [sym_foreach] = ACTIONS(4883),
    [sym_foreach_reverse] = ACTIONS(4883),
    [sym_function] = ACTIONS(4883),
    [sym_goto] = ACTIONS(4883),
    [sym_if] = ACTIONS(4883),
    [sym_immutable] = ACTIONS(4883),
    [sym_import] = ACTIONS(4883),
    [sym_in] = ACTIONS(4883),
    [sym_inout] = ACTIONS(4883),
    [sym_interface] = ACTIONS(4883),
    [sym_invariant] = ACTIONS(4883),
    [sym_is] = ACTIONS(4883),
    [sym_mixin] = ACTIONS(4883),
    [sym_new] = ACTIONS(4883),
    [sym_nothrow] = ACTIONS(4883),
    [sym_out] = ACTIONS(4883),
    [sym_override] = ACTIONS(4883),
    [sym_package] = ACTIONS(4883),
    [sym_pragma] = ACTIONS(4883),
    [sym_private] = ACTIONS(4883),
    [sym_protected] = ACTIONS(4883),
    [sym_public] = ACTIONS(4883),
    [sym_pure] = ACTIONS(4883),
    [sym_ref] = ACTIONS(4883),
    [sym_return] = ACTIONS(4883),
    [sym_scope] = ACTIONS(4883),
    [sym_shared] = ACTIONS(4883),
    [sym_static] = ACTIONS(4883),
    [sym_struct] = ACTIONS(4883),
    [sym_switch] = ACTIONS(4883),
    [sym_synchronized] = ACTIONS(4883),
    [sym_template] = ACTIONS(4883),
    [sym_throw] = ACTIONS(4883),
    [sym_try] = ACTIONS(4883),
    [sym_typeid] = ACTIONS(4883),
    [sym_typeof] = ACTIONS(4883),
    [sym_union] = ACTIONS(4883),
    [sym_unittest] = ACTIONS(4883),
    [sym_version] = ACTIONS(4883),
    [sym_while] = ACTIONS(4883),
    [sym_with] = ACTIONS(4883),
    [sym_gshared] = ACTIONS(4883),
    [sym_traits] = ACTIONS(4883),
    [sym_vector] = ACTIONS(4883),
    [sym_void] = ACTIONS(4883),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_r_DQUOTE] = ACTIONS(4885),
    [anon_sym_x_DQUOTE] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_i_BQUOTE] = ACTIONS(4885),
    [anon_sym_i_DQUOTE] = ACTIONS(4885),
    [anon_sym_iq_LBRACE] = ACTIONS(4885),
    [aux_sym_char_literal_token1] = ACTIONS(4885),
    [anon_sym_SQUOTE] = ACTIONS(4883),
    [anon_sym___DATE__] = ACTIONS(4883),
    [anon_sym___FILE__] = ACTIONS(4883),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4883),
    [anon_sym___FUNCTION__] = ACTIONS(4883),
    [anon_sym___LINE__] = ACTIONS(4883),
    [anon_sym___MODULE__] = ACTIONS(4883),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4883),
    [anon_sym___TIME__] = ACTIONS(4883),
    [anon_sym___TIMESTAMP__] = ACTIONS(4883),
    [anon_sym___VENDOR__] = ACTIONS(4883),
    [anon_sym___VERSION__] = ACTIONS(4883),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4885),
    [sym_float_literal] = ACTIONS(4885),
    [sym__string] = ACTIONS(4885),
  },
  [1479] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [anon_sym_AT] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_abstract] = ACTIONS(4688),
    [sym_alias] = ACTIONS(4688),
    [sym_align] = ACTIONS(4688),
    [sym_asm] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_break] = ACTIONS(4688),
    [sym_case] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_catch] = ACTIONS(4688),
    [sym_class] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_continue] = ACTIONS(4688),
    [sym_debug] = ACTIONS(4688),
    [sym_default] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_deprecated] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(4887),
    [sym_enum] = ACTIONS(4688),
    [sym_export] = ACTIONS(4688),
    [sym_extern] = ACTIONS(4688),
    [sym_final] = ACTIONS(4688),
    [sym_finally] = ACTIONS(4688),
    [sym_for] = ACTIONS(4688),
    [sym_foreach] = ACTIONS(4688),
    [sym_foreach_reverse] = ACTIONS(4688),
    [sym_function] = ACTIONS(4688),
    [sym_goto] = ACTIONS(4688),
    [sym_if] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_interface] = ACTIONS(4688),
    [sym_invariant] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_nothrow] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_override] = ACTIONS(4688),
    [sym_package] = ACTIONS(4688),
    [sym_pragma] = ACTIONS(4688),
    [sym_private] = ACTIONS(4688),
    [sym_protected] = ACTIONS(4688),
    [sym_public] = ACTIONS(4688),
    [sym_pure] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_return] = ACTIONS(4688),
    [sym_scope] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_static] = ACTIONS(4688),
    [sym_struct] = ACTIONS(4688),
    [sym_switch] = ACTIONS(4688),
    [sym_synchronized] = ACTIONS(4688),
    [sym_template] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_try] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_union] = ACTIONS(4688),
    [sym_unittest] = ACTIONS(4688),
    [sym_version] = ACTIONS(4688),
    [sym_while] = ACTIONS(4688),
    [sym_with] = ACTIONS(4688),
    [sym_gshared] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [1480] = {
    [sym_identifier] = ACTIONS(4891),
    [anon_sym_q_LBRACE] = ACTIONS(4893),
    [anon_sym_RBRACE] = ACTIONS(4893),
    [anon_sym_LBRACE] = ACTIONS(4893),
    [anon_sym_DOT] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_DASH] = ACTIONS(4891),
    [anon_sym_DASH_DASH] = ACTIONS(4893),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_PLUS_PLUS] = ACTIONS(4893),
    [anon_sym_BANG] = ACTIONS(4893),
    [anon_sym_LPAREN] = ACTIONS(4893),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_LBRACK] = ACTIONS(4893),
    [anon_sym_SEMI] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4893),
    [anon_sym_STAR] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4893),
    [anon_sym_AT] = ACTIONS(4893),
    [sym_bool] = ACTIONS(4891),
    [sym_byte] = ACTIONS(4891),
    [sym_ubyte] = ACTIONS(4891),
    [sym_char] = ACTIONS(4891),
    [sym_short] = ACTIONS(4891),
    [sym_ushort] = ACTIONS(4891),
    [sym_int] = ACTIONS(4891),
    [sym_uint] = ACTIONS(4891),
    [sym_long] = ACTIONS(4891),
    [sym_ulong] = ACTIONS(4891),
    [sym_cent] = ACTIONS(4891),
    [sym_ucent] = ACTIONS(4891),
    [sym_wchar] = ACTIONS(4891),
    [sym_dchar] = ACTIONS(4891),
    [sym_float] = ACTIONS(4891),
    [sym_double] = ACTIONS(4891),
    [sym_real] = ACTIONS(4891),
    [sym_ifloat] = ACTIONS(4891),
    [sym_idouble] = ACTIONS(4891),
    [sym_ireal] = ACTIONS(4891),
    [sym_cfloat] = ACTIONS(4891),
    [sym_cdouble] = ACTIONS(4891),
    [sym_creal] = ACTIONS(4891),
    [sym_size_t] = ACTIONS(4891),
    [sym_ptrdiff_t] = ACTIONS(4891),
    [sym_string] = ACTIONS(4891),
    [sym_cstring] = ACTIONS(4891),
    [sym_dstring] = ACTIONS(4891),
    [sym_wstring] = ACTIONS(4891),
    [sym_noreturn] = ACTIONS(4891),
    [sym_true] = ACTIONS(4891),
    [sym_false] = ACTIONS(4891),
    [sym_null] = ACTIONS(4891),
    [sym_super] = ACTIONS(4891),
    [sym_this] = ACTIONS(4891),
    [sym_abstract] = ACTIONS(4891),
    [sym_alias] = ACTIONS(4891),
    [sym_align] = ACTIONS(4891),
    [sym_asm] = ACTIONS(4891),
    [sym_assert] = ACTIONS(4891),
    [sym_auto] = ACTIONS(4891),
    [sym_break] = ACTIONS(4891),
    [sym_case] = ACTIONS(4891),
    [sym_cast] = ACTIONS(4891),
    [sym_catch] = ACTIONS(4891),
    [sym_class] = ACTIONS(4891),
    [sym_const] = ACTIONS(4891),
    [sym_continue] = ACTIONS(4891),
    [sym_debug] = ACTIONS(4891),
    [sym_default] = ACTIONS(4891),
    [sym_delegate] = ACTIONS(4891),
    [sym_delete] = ACTIONS(4891),
    [sym_deprecated] = ACTIONS(4891),
    [sym_do] = ACTIONS(4891),
    [sym_else] = ACTIONS(4891),
    [sym_enum] = ACTIONS(4891),
    [sym_export] = ACTIONS(4891),
    [sym_extern] = ACTIONS(4891),
    [sym_final] = ACTIONS(4891),
    [sym_finally] = ACTIONS(4891),
    [sym_for] = ACTIONS(4891),
    [sym_foreach] = ACTIONS(4891),
    [sym_foreach_reverse] = ACTIONS(4891),
    [sym_function] = ACTIONS(4891),
    [sym_goto] = ACTIONS(4891),
    [sym_if] = ACTIONS(4891),
    [sym_immutable] = ACTIONS(4891),
    [sym_import] = ACTIONS(4891),
    [sym_in] = ACTIONS(4891),
    [sym_inout] = ACTIONS(4891),
    [sym_interface] = ACTIONS(4891),
    [sym_invariant] = ACTIONS(4891),
    [sym_is] = ACTIONS(4891),
    [sym_mixin] = ACTIONS(4891),
    [sym_new] = ACTIONS(4891),
    [sym_nothrow] = ACTIONS(4891),
    [sym_out] = ACTIONS(4891),
    [sym_override] = ACTIONS(4891),
    [sym_package] = ACTIONS(4891),
    [sym_pragma] = ACTIONS(4891),
    [sym_private] = ACTIONS(4891),
    [sym_protected] = ACTIONS(4891),
    [sym_public] = ACTIONS(4891),
    [sym_pure] = ACTIONS(4891),
    [sym_ref] = ACTIONS(4891),
    [sym_return] = ACTIONS(4891),
    [sym_scope] = ACTIONS(4891),
    [sym_shared] = ACTIONS(4891),
    [sym_static] = ACTIONS(4891),
    [sym_struct] = ACTIONS(4891),
    [sym_switch] = ACTIONS(4891),
    [sym_synchronized] = ACTIONS(4891),
    [sym_template] = ACTIONS(4891),
    [sym_throw] = ACTIONS(4891),
    [sym_try] = ACTIONS(4891),
    [sym_typeid] = ACTIONS(4891),
    [sym_typeof] = ACTIONS(4891),
    [sym_union] = ACTIONS(4891),
    [sym_unittest] = ACTIONS(4891),
    [sym_version] = ACTIONS(4891),
    [sym_while] = ACTIONS(4891),
    [sym_with] = ACTIONS(4891),
    [sym_gshared] = ACTIONS(4891),
    [sym_traits] = ACTIONS(4891),
    [sym_vector] = ACTIONS(4891),
    [sym_void] = ACTIONS(4891),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_r_DQUOTE] = ACTIONS(4893),
    [anon_sym_x_DQUOTE] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_i_BQUOTE] = ACTIONS(4893),
    [anon_sym_i_DQUOTE] = ACTIONS(4893),
    [anon_sym_iq_LBRACE] = ACTIONS(4893),
    [aux_sym_char_literal_token1] = ACTIONS(4893),
    [anon_sym_SQUOTE] = ACTIONS(4891),
    [anon_sym___DATE__] = ACTIONS(4891),
    [anon_sym___FILE__] = ACTIONS(4891),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4891),
    [anon_sym___FUNCTION__] = ACTIONS(4891),
    [anon_sym___LINE__] = ACTIONS(4891),
    [anon_sym___MODULE__] = ACTIONS(4891),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4891),
    [anon_sym___TIME__] = ACTIONS(4891),
    [anon_sym___TIMESTAMP__] = ACTIONS(4891),
    [anon_sym___VENDOR__] = ACTIONS(4891),
    [anon_sym___VERSION__] = ACTIONS(4891),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4893),
    [sym_float_literal] = ACTIONS(4893),
    [sym__string] = ACTIONS(4893),
  },
  [1481] = {
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_q_LBRACE] = ACTIONS(4897),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [anon_sym_LBRACE] = ACTIONS(4897),
    [anon_sym_DOT] = ACTIONS(4897),
    [anon_sym_AMP] = ACTIONS(4897),
    [anon_sym_DASH] = ACTIONS(4895),
    [anon_sym_DASH_DASH] = ACTIONS(4897),
    [anon_sym_PLUS] = ACTIONS(4895),
    [anon_sym_PLUS_PLUS] = ACTIONS(4897),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_LPAREN] = ACTIONS(4897),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_DOLLAR] = ACTIONS(4897),
    [anon_sym_STAR] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [anon_sym_AT] = ACTIONS(4897),
    [sym_bool] = ACTIONS(4895),
    [sym_byte] = ACTIONS(4895),
    [sym_ubyte] = ACTIONS(4895),
    [sym_char] = ACTIONS(4895),
    [sym_short] = ACTIONS(4895),
    [sym_ushort] = ACTIONS(4895),
    [sym_int] = ACTIONS(4895),
    [sym_uint] = ACTIONS(4895),
    [sym_long] = ACTIONS(4895),
    [sym_ulong] = ACTIONS(4895),
    [sym_cent] = ACTIONS(4895),
    [sym_ucent] = ACTIONS(4895),
    [sym_wchar] = ACTIONS(4895),
    [sym_dchar] = ACTIONS(4895),
    [sym_float] = ACTIONS(4895),
    [sym_double] = ACTIONS(4895),
    [sym_real] = ACTIONS(4895),
    [sym_ifloat] = ACTIONS(4895),
    [sym_idouble] = ACTIONS(4895),
    [sym_ireal] = ACTIONS(4895),
    [sym_cfloat] = ACTIONS(4895),
    [sym_cdouble] = ACTIONS(4895),
    [sym_creal] = ACTIONS(4895),
    [sym_size_t] = ACTIONS(4895),
    [sym_ptrdiff_t] = ACTIONS(4895),
    [sym_string] = ACTIONS(4895),
    [sym_cstring] = ACTIONS(4895),
    [sym_dstring] = ACTIONS(4895),
    [sym_wstring] = ACTIONS(4895),
    [sym_noreturn] = ACTIONS(4895),
    [sym_true] = ACTIONS(4895),
    [sym_false] = ACTIONS(4895),
    [sym_null] = ACTIONS(4895),
    [sym_super] = ACTIONS(4895),
    [sym_this] = ACTIONS(4895),
    [sym_abstract] = ACTIONS(4895),
    [sym_alias] = ACTIONS(4895),
    [sym_align] = ACTIONS(4895),
    [sym_asm] = ACTIONS(4895),
    [sym_assert] = ACTIONS(4895),
    [sym_auto] = ACTIONS(4895),
    [sym_break] = ACTIONS(4895),
    [sym_case] = ACTIONS(4895),
    [sym_cast] = ACTIONS(4895),
    [sym_catch] = ACTIONS(4895),
    [sym_class] = ACTIONS(4895),
    [sym_const] = ACTIONS(4895),
    [sym_continue] = ACTIONS(4895),
    [sym_debug] = ACTIONS(4895),
    [sym_default] = ACTIONS(4895),
    [sym_delegate] = ACTIONS(4895),
    [sym_delete] = ACTIONS(4895),
    [sym_deprecated] = ACTIONS(4895),
    [sym_do] = ACTIONS(4895),
    [sym_else] = ACTIONS(4895),
    [sym_enum] = ACTIONS(4895),
    [sym_export] = ACTIONS(4895),
    [sym_extern] = ACTIONS(4895),
    [sym_final] = ACTIONS(4895),
    [sym_finally] = ACTIONS(4895),
    [sym_for] = ACTIONS(4895),
    [sym_foreach] = ACTIONS(4895),
    [sym_foreach_reverse] = ACTIONS(4895),
    [sym_function] = ACTIONS(4895),
    [sym_goto] = ACTIONS(4895),
    [sym_if] = ACTIONS(4895),
    [sym_immutable] = ACTIONS(4895),
    [sym_import] = ACTIONS(4895),
    [sym_in] = ACTIONS(4895),
    [sym_inout] = ACTIONS(4895),
    [sym_interface] = ACTIONS(4895),
    [sym_invariant] = ACTIONS(4895),
    [sym_is] = ACTIONS(4895),
    [sym_mixin] = ACTIONS(4895),
    [sym_new] = ACTIONS(4895),
    [sym_nothrow] = ACTIONS(4895),
    [sym_out] = ACTIONS(4895),
    [sym_override] = ACTIONS(4895),
    [sym_package] = ACTIONS(4895),
    [sym_pragma] = ACTIONS(4895),
    [sym_private] = ACTIONS(4895),
    [sym_protected] = ACTIONS(4895),
    [sym_public] = ACTIONS(4895),
    [sym_pure] = ACTIONS(4895),
    [sym_ref] = ACTIONS(4895),
    [sym_return] = ACTIONS(4895),
    [sym_scope] = ACTIONS(4895),
    [sym_shared] = ACTIONS(4895),
    [sym_static] = ACTIONS(4895),
    [sym_struct] = ACTIONS(4895),
    [sym_switch] = ACTIONS(4895),
    [sym_synchronized] = ACTIONS(4895),
    [sym_template] = ACTIONS(4895),
    [sym_throw] = ACTIONS(4895),
    [sym_try] = ACTIONS(4895),
    [sym_typeid] = ACTIONS(4895),
    [sym_typeof] = ACTIONS(4895),
    [sym_union] = ACTIONS(4895),
    [sym_unittest] = ACTIONS(4895),
    [sym_version] = ACTIONS(4895),
    [sym_while] = ACTIONS(4895),
    [sym_with] = ACTIONS(4895),
    [sym_gshared] = ACTIONS(4895),
    [sym_traits] = ACTIONS(4895),
    [sym_vector] = ACTIONS(4895),
    [sym_void] = ACTIONS(4895),
    [anon_sym_BQUOTE] = ACTIONS(4897),
    [anon_sym_r_DQUOTE] = ACTIONS(4897),
    [anon_sym_x_DQUOTE] = ACTIONS(4897),
    [anon_sym_DQUOTE] = ACTIONS(4897),
    [anon_sym_i_BQUOTE] = ACTIONS(4897),
    [anon_sym_i_DQUOTE] = ACTIONS(4897),
    [anon_sym_iq_LBRACE] = ACTIONS(4897),
    [aux_sym_char_literal_token1] = ACTIONS(4897),
    [anon_sym_SQUOTE] = ACTIONS(4895),
    [anon_sym___DATE__] = ACTIONS(4895),
    [anon_sym___FILE__] = ACTIONS(4895),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4895),
    [anon_sym___FUNCTION__] = ACTIONS(4895),
    [anon_sym___LINE__] = ACTIONS(4895),
    [anon_sym___MODULE__] = ACTIONS(4895),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4895),
    [anon_sym___TIME__] = ACTIONS(4895),
    [anon_sym___TIMESTAMP__] = ACTIONS(4895),
    [anon_sym___VENDOR__] = ACTIONS(4895),
    [anon_sym___VERSION__] = ACTIONS(4895),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4897),
    [sym_float_literal] = ACTIONS(4897),
    [sym__string] = ACTIONS(4897),
  },
  [1482] = {
    [sym_identifier] = ACTIONS(4899),
    [anon_sym_q_LBRACE] = ACTIONS(4901),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_LBRACE] = ACTIONS(4901),
    [anon_sym_DOT] = ACTIONS(4901),
    [anon_sym_AMP] = ACTIONS(4901),
    [anon_sym_DASH] = ACTIONS(4899),
    [anon_sym_DASH_DASH] = ACTIONS(4901),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_PLUS_PLUS] = ACTIONS(4901),
    [anon_sym_BANG] = ACTIONS(4901),
    [anon_sym_LPAREN] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4901),
    [anon_sym_LBRACK] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [anon_sym_STAR] = ACTIONS(4901),
    [anon_sym_TILDE] = ACTIONS(4901),
    [anon_sym_AT] = ACTIONS(4901),
    [sym_bool] = ACTIONS(4899),
    [sym_byte] = ACTIONS(4899),
    [sym_ubyte] = ACTIONS(4899),
    [sym_char] = ACTIONS(4899),
    [sym_short] = ACTIONS(4899),
    [sym_ushort] = ACTIONS(4899),
    [sym_int] = ACTIONS(4899),
    [sym_uint] = ACTIONS(4899),
    [sym_long] = ACTIONS(4899),
    [sym_ulong] = ACTIONS(4899),
    [sym_cent] = ACTIONS(4899),
    [sym_ucent] = ACTIONS(4899),
    [sym_wchar] = ACTIONS(4899),
    [sym_dchar] = ACTIONS(4899),
    [sym_float] = ACTIONS(4899),
    [sym_double] = ACTIONS(4899),
    [sym_real] = ACTIONS(4899),
    [sym_ifloat] = ACTIONS(4899),
    [sym_idouble] = ACTIONS(4899),
    [sym_ireal] = ACTIONS(4899),
    [sym_cfloat] = ACTIONS(4899),
    [sym_cdouble] = ACTIONS(4899),
    [sym_creal] = ACTIONS(4899),
    [sym_size_t] = ACTIONS(4899),
    [sym_ptrdiff_t] = ACTIONS(4899),
    [sym_string] = ACTIONS(4899),
    [sym_cstring] = ACTIONS(4899),
    [sym_dstring] = ACTIONS(4899),
    [sym_wstring] = ACTIONS(4899),
    [sym_noreturn] = ACTIONS(4899),
    [sym_true] = ACTIONS(4899),
    [sym_false] = ACTIONS(4899),
    [sym_null] = ACTIONS(4899),
    [sym_super] = ACTIONS(4899),
    [sym_this] = ACTIONS(4899),
    [sym_abstract] = ACTIONS(4899),
    [sym_alias] = ACTIONS(4899),
    [sym_align] = ACTIONS(4899),
    [sym_asm] = ACTIONS(4899),
    [sym_assert] = ACTIONS(4899),
    [sym_auto] = ACTIONS(4899),
    [sym_break] = ACTIONS(4899),
    [sym_case] = ACTIONS(4899),
    [sym_cast] = ACTIONS(4899),
    [sym_catch] = ACTIONS(4899),
    [sym_class] = ACTIONS(4899),
    [sym_const] = ACTIONS(4899),
    [sym_continue] = ACTIONS(4899),
    [sym_debug] = ACTIONS(4899),
    [sym_default] = ACTIONS(4899),
    [sym_delegate] = ACTIONS(4899),
    [sym_delete] = ACTIONS(4899),
    [sym_deprecated] = ACTIONS(4899),
    [sym_do] = ACTIONS(4899),
    [sym_else] = ACTIONS(4899),
    [sym_enum] = ACTIONS(4899),
    [sym_export] = ACTIONS(4899),
    [sym_extern] = ACTIONS(4899),
    [sym_final] = ACTIONS(4899),
    [sym_finally] = ACTIONS(4899),
    [sym_for] = ACTIONS(4899),
    [sym_foreach] = ACTIONS(4899),
    [sym_foreach_reverse] = ACTIONS(4899),
    [sym_function] = ACTIONS(4899),
    [sym_goto] = ACTIONS(4899),
    [sym_if] = ACTIONS(4899),
    [sym_immutable] = ACTIONS(4899),
    [sym_import] = ACTIONS(4899),
    [sym_in] = ACTIONS(4899),
    [sym_inout] = ACTIONS(4899),
    [sym_interface] = ACTIONS(4899),
    [sym_invariant] = ACTIONS(4899),
    [sym_is] = ACTIONS(4899),
    [sym_mixin] = ACTIONS(4899),
    [sym_new] = ACTIONS(4899),
    [sym_nothrow] = ACTIONS(4899),
    [sym_out] = ACTIONS(4899),
    [sym_override] = ACTIONS(4899),
    [sym_package] = ACTIONS(4899),
    [sym_pragma] = ACTIONS(4899),
    [sym_private] = ACTIONS(4899),
    [sym_protected] = ACTIONS(4899),
    [sym_public] = ACTIONS(4899),
    [sym_pure] = ACTIONS(4899),
    [sym_ref] = ACTIONS(4899),
    [sym_return] = ACTIONS(4899),
    [sym_scope] = ACTIONS(4899),
    [sym_shared] = ACTIONS(4899),
    [sym_static] = ACTIONS(4899),
    [sym_struct] = ACTIONS(4899),
    [sym_switch] = ACTIONS(4899),
    [sym_synchronized] = ACTIONS(4899),
    [sym_template] = ACTIONS(4899),
    [sym_throw] = ACTIONS(4899),
    [sym_try] = ACTIONS(4899),
    [sym_typeid] = ACTIONS(4899),
    [sym_typeof] = ACTIONS(4899),
    [sym_union] = ACTIONS(4899),
    [sym_unittest] = ACTIONS(4899),
    [sym_version] = ACTIONS(4899),
    [sym_while] = ACTIONS(4899),
    [sym_with] = ACTIONS(4899),
    [sym_gshared] = ACTIONS(4899),
    [sym_traits] = ACTIONS(4899),
    [sym_vector] = ACTIONS(4899),
    [sym_void] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4901),
    [anon_sym_r_DQUOTE] = ACTIONS(4901),
    [anon_sym_x_DQUOTE] = ACTIONS(4901),
    [anon_sym_DQUOTE] = ACTIONS(4901),
    [anon_sym_i_BQUOTE] = ACTIONS(4901),
    [anon_sym_i_DQUOTE] = ACTIONS(4901),
    [anon_sym_iq_LBRACE] = ACTIONS(4901),
    [aux_sym_char_literal_token1] = ACTIONS(4901),
    [anon_sym_SQUOTE] = ACTIONS(4899),
    [anon_sym___DATE__] = ACTIONS(4899),
    [anon_sym___FILE__] = ACTIONS(4899),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4899),
    [anon_sym___FUNCTION__] = ACTIONS(4899),
    [anon_sym___LINE__] = ACTIONS(4899),
    [anon_sym___MODULE__] = ACTIONS(4899),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4899),
    [anon_sym___TIME__] = ACTIONS(4899),
    [anon_sym___TIMESTAMP__] = ACTIONS(4899),
    [anon_sym___VENDOR__] = ACTIONS(4899),
    [anon_sym___VERSION__] = ACTIONS(4899),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4901),
    [sym_float_literal] = ACTIONS(4901),
    [sym__string] = ACTIONS(4901),
  },
  [1483] = {
    [sym_identifier] = ACTIONS(4903),
    [anon_sym_q_LBRACE] = ACTIONS(4905),
    [anon_sym_RBRACE] = ACTIONS(4905),
    [anon_sym_LBRACE] = ACTIONS(4905),
    [anon_sym_DOT] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4905),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_DASH_DASH] = ACTIONS(4905),
    [anon_sym_PLUS] = ACTIONS(4903),
    [anon_sym_PLUS_PLUS] = ACTIONS(4905),
    [anon_sym_BANG] = ACTIONS(4905),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(4905),
    [anon_sym_SEMI] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4905),
    [anon_sym_STAR] = ACTIONS(4905),
    [anon_sym_TILDE] = ACTIONS(4905),
    [anon_sym_AT] = ACTIONS(4905),
    [sym_bool] = ACTIONS(4903),
    [sym_byte] = ACTIONS(4903),
    [sym_ubyte] = ACTIONS(4903),
    [sym_char] = ACTIONS(4903),
    [sym_short] = ACTIONS(4903),
    [sym_ushort] = ACTIONS(4903),
    [sym_int] = ACTIONS(4903),
    [sym_uint] = ACTIONS(4903),
    [sym_long] = ACTIONS(4903),
    [sym_ulong] = ACTIONS(4903),
    [sym_cent] = ACTIONS(4903),
    [sym_ucent] = ACTIONS(4903),
    [sym_wchar] = ACTIONS(4903),
    [sym_dchar] = ACTIONS(4903),
    [sym_float] = ACTIONS(4903),
    [sym_double] = ACTIONS(4903),
    [sym_real] = ACTIONS(4903),
    [sym_ifloat] = ACTIONS(4903),
    [sym_idouble] = ACTIONS(4903),
    [sym_ireal] = ACTIONS(4903),
    [sym_cfloat] = ACTIONS(4903),
    [sym_cdouble] = ACTIONS(4903),
    [sym_creal] = ACTIONS(4903),
    [sym_size_t] = ACTIONS(4903),
    [sym_ptrdiff_t] = ACTIONS(4903),
    [sym_string] = ACTIONS(4903),
    [sym_cstring] = ACTIONS(4903),
    [sym_dstring] = ACTIONS(4903),
    [sym_wstring] = ACTIONS(4903),
    [sym_noreturn] = ACTIONS(4903),
    [sym_true] = ACTIONS(4903),
    [sym_false] = ACTIONS(4903),
    [sym_null] = ACTIONS(4903),
    [sym_super] = ACTIONS(4903),
    [sym_this] = ACTIONS(4903),
    [sym_abstract] = ACTIONS(4903),
    [sym_alias] = ACTIONS(4903),
    [sym_align] = ACTIONS(4903),
    [sym_asm] = ACTIONS(4903),
    [sym_assert] = ACTIONS(4903),
    [sym_auto] = ACTIONS(4903),
    [sym_break] = ACTIONS(4903),
    [sym_case] = ACTIONS(4903),
    [sym_cast] = ACTIONS(4903),
    [sym_catch] = ACTIONS(4903),
    [sym_class] = ACTIONS(4903),
    [sym_const] = ACTIONS(4903),
    [sym_continue] = ACTIONS(4903),
    [sym_debug] = ACTIONS(4903),
    [sym_default] = ACTIONS(4903),
    [sym_delegate] = ACTIONS(4903),
    [sym_delete] = ACTIONS(4903),
    [sym_deprecated] = ACTIONS(4903),
    [sym_do] = ACTIONS(4903),
    [sym_else] = ACTIONS(4903),
    [sym_enum] = ACTIONS(4903),
    [sym_export] = ACTIONS(4903),
    [sym_extern] = ACTIONS(4903),
    [sym_final] = ACTIONS(4903),
    [sym_finally] = ACTIONS(4903),
    [sym_for] = ACTIONS(4903),
    [sym_foreach] = ACTIONS(4903),
    [sym_foreach_reverse] = ACTIONS(4903),
    [sym_function] = ACTIONS(4903),
    [sym_goto] = ACTIONS(4903),
    [sym_if] = ACTIONS(4903),
    [sym_immutable] = ACTIONS(4903),
    [sym_import] = ACTIONS(4903),
    [sym_in] = ACTIONS(4903),
    [sym_inout] = ACTIONS(4903),
    [sym_interface] = ACTIONS(4903),
    [sym_invariant] = ACTIONS(4903),
    [sym_is] = ACTIONS(4903),
    [sym_mixin] = ACTIONS(4903),
    [sym_new] = ACTIONS(4903),
    [sym_nothrow] = ACTIONS(4903),
    [sym_out] = ACTIONS(4903),
    [sym_override] = ACTIONS(4903),
    [sym_package] = ACTIONS(4903),
    [sym_pragma] = ACTIONS(4903),
    [sym_private] = ACTIONS(4903),
    [sym_protected] = ACTIONS(4903),
    [sym_public] = ACTIONS(4903),
    [sym_pure] = ACTIONS(4903),
    [sym_ref] = ACTIONS(4903),
    [sym_return] = ACTIONS(4903),
    [sym_scope] = ACTIONS(4903),
    [sym_shared] = ACTIONS(4903),
    [sym_static] = ACTIONS(4903),
    [sym_struct] = ACTIONS(4903),
    [sym_switch] = ACTIONS(4903),
    [sym_synchronized] = ACTIONS(4903),
    [sym_template] = ACTIONS(4903),
    [sym_throw] = ACTIONS(4903),
    [sym_try] = ACTIONS(4903),
    [sym_typeid] = ACTIONS(4903),
    [sym_typeof] = ACTIONS(4903),
    [sym_union] = ACTIONS(4903),
    [sym_unittest] = ACTIONS(4903),
    [sym_version] = ACTIONS(4903),
    [sym_while] = ACTIONS(4903),
    [sym_with] = ACTIONS(4903),
    [sym_gshared] = ACTIONS(4903),
    [sym_traits] = ACTIONS(4903),
    [sym_vector] = ACTIONS(4903),
    [sym_void] = ACTIONS(4903),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_r_DQUOTE] = ACTIONS(4905),
    [anon_sym_x_DQUOTE] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_i_BQUOTE] = ACTIONS(4905),
    [anon_sym_i_DQUOTE] = ACTIONS(4905),
    [anon_sym_iq_LBRACE] = ACTIONS(4905),
    [aux_sym_char_literal_token1] = ACTIONS(4905),
    [anon_sym_SQUOTE] = ACTIONS(4903),
    [anon_sym___DATE__] = ACTIONS(4903),
    [anon_sym___FILE__] = ACTIONS(4903),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4903),
    [anon_sym___FUNCTION__] = ACTIONS(4903),
    [anon_sym___LINE__] = ACTIONS(4903),
    [anon_sym___MODULE__] = ACTIONS(4903),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4903),
    [anon_sym___TIME__] = ACTIONS(4903),
    [anon_sym___TIMESTAMP__] = ACTIONS(4903),
    [anon_sym___VENDOR__] = ACTIONS(4903),
    [anon_sym___VERSION__] = ACTIONS(4903),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4905),
    [sym_float_literal] = ACTIONS(4905),
    [sym__string] = ACTIONS(4905),
  },
  [1484] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [anon_sym_AT] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_abstract] = ACTIONS(4366),
    [sym_alias] = ACTIONS(4366),
    [sym_align] = ACTIONS(4366),
    [sym_asm] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_break] = ACTIONS(4366),
    [sym_case] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_catch] = ACTIONS(4366),
    [sym_class] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_continue] = ACTIONS(4366),
    [sym_debug] = ACTIONS(4366),
    [sym_default] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_deprecated] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(4907),
    [sym_enum] = ACTIONS(4366),
    [sym_export] = ACTIONS(4366),
    [sym_extern] = ACTIONS(4366),
    [sym_final] = ACTIONS(4366),
    [sym_finally] = ACTIONS(4366),
    [sym_for] = ACTIONS(4366),
    [sym_foreach] = ACTIONS(4366),
    [sym_foreach_reverse] = ACTIONS(4366),
    [sym_function] = ACTIONS(4366),
    [sym_goto] = ACTIONS(4366),
    [sym_if] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_interface] = ACTIONS(4366),
    [sym_invariant] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_nothrow] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_override] = ACTIONS(4366),
    [sym_package] = ACTIONS(4366),
    [sym_pragma] = ACTIONS(4366),
    [sym_private] = ACTIONS(4366),
    [sym_protected] = ACTIONS(4366),
    [sym_public] = ACTIONS(4366),
    [sym_pure] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_return] = ACTIONS(4366),
    [sym_scope] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_static] = ACTIONS(4366),
    [sym_struct] = ACTIONS(4366),
    [sym_switch] = ACTIONS(4366),
    [sym_synchronized] = ACTIONS(4366),
    [sym_template] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_try] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_union] = ACTIONS(4366),
    [sym_unittest] = ACTIONS(4366),
    [sym_version] = ACTIONS(4366),
    [sym_while] = ACTIONS(4366),
    [sym_with] = ACTIONS(4366),
    [sym_gshared] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [1485] = {
    [sym_identifier] = ACTIONS(4909),
    [anon_sym_q_LBRACE] = ACTIONS(4911),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_LBRACE] = ACTIONS(4911),
    [anon_sym_DOT] = ACTIONS(4911),
    [anon_sym_AMP] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_DASH_DASH] = ACTIONS(4911),
    [anon_sym_PLUS] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4911),
    [anon_sym_BANG] = ACTIONS(4911),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [anon_sym_RPAREN] = ACTIONS(4911),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym_DOLLAR] = ACTIONS(4911),
    [anon_sym_STAR] = ACTIONS(4911),
    [anon_sym_TILDE] = ACTIONS(4911),
    [anon_sym_AT] = ACTIONS(4911),
    [sym_bool] = ACTIONS(4909),
    [sym_byte] = ACTIONS(4909),
    [sym_ubyte] = ACTIONS(4909),
    [sym_char] = ACTIONS(4909),
    [sym_short] = ACTIONS(4909),
    [sym_ushort] = ACTIONS(4909),
    [sym_int] = ACTIONS(4909),
    [sym_uint] = ACTIONS(4909),
    [sym_long] = ACTIONS(4909),
    [sym_ulong] = ACTIONS(4909),
    [sym_cent] = ACTIONS(4909),
    [sym_ucent] = ACTIONS(4909),
    [sym_wchar] = ACTIONS(4909),
    [sym_dchar] = ACTIONS(4909),
    [sym_float] = ACTIONS(4909),
    [sym_double] = ACTIONS(4909),
    [sym_real] = ACTIONS(4909),
    [sym_ifloat] = ACTIONS(4909),
    [sym_idouble] = ACTIONS(4909),
    [sym_ireal] = ACTIONS(4909),
    [sym_cfloat] = ACTIONS(4909),
    [sym_cdouble] = ACTIONS(4909),
    [sym_creal] = ACTIONS(4909),
    [sym_size_t] = ACTIONS(4909),
    [sym_ptrdiff_t] = ACTIONS(4909),
    [sym_string] = ACTIONS(4909),
    [sym_cstring] = ACTIONS(4909),
    [sym_dstring] = ACTIONS(4909),
    [sym_wstring] = ACTIONS(4909),
    [sym_noreturn] = ACTIONS(4909),
    [sym_true] = ACTIONS(4909),
    [sym_false] = ACTIONS(4909),
    [sym_null] = ACTIONS(4909),
    [sym_super] = ACTIONS(4909),
    [sym_this] = ACTIONS(4909),
    [sym_abstract] = ACTIONS(4909),
    [sym_alias] = ACTIONS(4909),
    [sym_align] = ACTIONS(4909),
    [sym_asm] = ACTIONS(4909),
    [sym_assert] = ACTIONS(4909),
    [sym_auto] = ACTIONS(4909),
    [sym_break] = ACTIONS(4909),
    [sym_case] = ACTIONS(4909),
    [sym_cast] = ACTIONS(4909),
    [sym_catch] = ACTIONS(4909),
    [sym_class] = ACTIONS(4909),
    [sym_const] = ACTIONS(4909),
    [sym_continue] = ACTIONS(4909),
    [sym_debug] = ACTIONS(4909),
    [sym_default] = ACTIONS(4909),
    [sym_delegate] = ACTIONS(4909),
    [sym_delete] = ACTIONS(4909),
    [sym_deprecated] = ACTIONS(4909),
    [sym_do] = ACTIONS(4909),
    [sym_else] = ACTIONS(4909),
    [sym_enum] = ACTIONS(4909),
    [sym_export] = ACTIONS(4909),
    [sym_extern] = ACTIONS(4909),
    [sym_final] = ACTIONS(4909),
    [sym_finally] = ACTIONS(4909),
    [sym_for] = ACTIONS(4909),
    [sym_foreach] = ACTIONS(4909),
    [sym_foreach_reverse] = ACTIONS(4909),
    [sym_function] = ACTIONS(4909),
    [sym_goto] = ACTIONS(4909),
    [sym_if] = ACTIONS(4909),
    [sym_immutable] = ACTIONS(4909),
    [sym_import] = ACTIONS(4909),
    [sym_in] = ACTIONS(4909),
    [sym_inout] = ACTIONS(4909),
    [sym_interface] = ACTIONS(4909),
    [sym_invariant] = ACTIONS(4909),
    [sym_is] = ACTIONS(4909),
    [sym_mixin] = ACTIONS(4909),
    [sym_new] = ACTIONS(4909),
    [sym_nothrow] = ACTIONS(4909),
    [sym_out] = ACTIONS(4909),
    [sym_override] = ACTIONS(4909),
    [sym_package] = ACTIONS(4909),
    [sym_pragma] = ACTIONS(4909),
    [sym_private] = ACTIONS(4909),
    [sym_protected] = ACTIONS(4909),
    [sym_public] = ACTIONS(4909),
    [sym_pure] = ACTIONS(4909),
    [sym_ref] = ACTIONS(4909),
    [sym_return] = ACTIONS(4909),
    [sym_scope] = ACTIONS(4909),
    [sym_shared] = ACTIONS(4909),
    [sym_static] = ACTIONS(4909),
    [sym_struct] = ACTIONS(4909),
    [sym_switch] = ACTIONS(4909),
    [sym_synchronized] = ACTIONS(4909),
    [sym_template] = ACTIONS(4909),
    [sym_throw] = ACTIONS(4909),
    [sym_try] = ACTIONS(4909),
    [sym_typeid] = ACTIONS(4909),
    [sym_typeof] = ACTIONS(4909),
    [sym_union] = ACTIONS(4909),
    [sym_unittest] = ACTIONS(4909),
    [sym_version] = ACTIONS(4909),
    [sym_while] = ACTIONS(4909),
    [sym_with] = ACTIONS(4909),
    [sym_gshared] = ACTIONS(4909),
    [sym_traits] = ACTIONS(4909),
    [sym_vector] = ACTIONS(4909),
    [sym_void] = ACTIONS(4909),
    [anon_sym_BQUOTE] = ACTIONS(4911),
    [anon_sym_r_DQUOTE] = ACTIONS(4911),
    [anon_sym_x_DQUOTE] = ACTIONS(4911),
    [anon_sym_DQUOTE] = ACTIONS(4911),
    [anon_sym_i_BQUOTE] = ACTIONS(4911),
    [anon_sym_i_DQUOTE] = ACTIONS(4911),
    [anon_sym_iq_LBRACE] = ACTIONS(4911),
    [aux_sym_char_literal_token1] = ACTIONS(4911),
    [anon_sym_SQUOTE] = ACTIONS(4909),
    [anon_sym___DATE__] = ACTIONS(4909),
    [anon_sym___FILE__] = ACTIONS(4909),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4909),
    [anon_sym___FUNCTION__] = ACTIONS(4909),
    [anon_sym___LINE__] = ACTIONS(4909),
    [anon_sym___MODULE__] = ACTIONS(4909),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4909),
    [anon_sym___TIME__] = ACTIONS(4909),
    [anon_sym___TIMESTAMP__] = ACTIONS(4909),
    [anon_sym___VENDOR__] = ACTIONS(4909),
    [anon_sym___VERSION__] = ACTIONS(4909),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4911),
    [sym_float_literal] = ACTIONS(4911),
    [sym__string] = ACTIONS(4911),
  },
  [1486] = {
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_q_LBRACE] = ACTIONS(4915),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [anon_sym_LBRACE] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4915),
    [anon_sym_DASH] = ACTIONS(4913),
    [anon_sym_DASH_DASH] = ACTIONS(4915),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_PLUS_PLUS] = ACTIONS(4915),
    [anon_sym_BANG] = ACTIONS(4915),
    [anon_sym_LPAREN] = ACTIONS(4915),
    [anon_sym_RPAREN] = ACTIONS(4915),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_DOLLAR] = ACTIONS(4915),
    [anon_sym_STAR] = ACTIONS(4915),
    [anon_sym_TILDE] = ACTIONS(4915),
    [anon_sym_AT] = ACTIONS(4915),
    [sym_bool] = ACTIONS(4913),
    [sym_byte] = ACTIONS(4913),
    [sym_ubyte] = ACTIONS(4913),
    [sym_char] = ACTIONS(4913),
    [sym_short] = ACTIONS(4913),
    [sym_ushort] = ACTIONS(4913),
    [sym_int] = ACTIONS(4913),
    [sym_uint] = ACTIONS(4913),
    [sym_long] = ACTIONS(4913),
    [sym_ulong] = ACTIONS(4913),
    [sym_cent] = ACTIONS(4913),
    [sym_ucent] = ACTIONS(4913),
    [sym_wchar] = ACTIONS(4913),
    [sym_dchar] = ACTIONS(4913),
    [sym_float] = ACTIONS(4913),
    [sym_double] = ACTIONS(4913),
    [sym_real] = ACTIONS(4913),
    [sym_ifloat] = ACTIONS(4913),
    [sym_idouble] = ACTIONS(4913),
    [sym_ireal] = ACTIONS(4913),
    [sym_cfloat] = ACTIONS(4913),
    [sym_cdouble] = ACTIONS(4913),
    [sym_creal] = ACTIONS(4913),
    [sym_size_t] = ACTIONS(4913),
    [sym_ptrdiff_t] = ACTIONS(4913),
    [sym_string] = ACTIONS(4913),
    [sym_cstring] = ACTIONS(4913),
    [sym_dstring] = ACTIONS(4913),
    [sym_wstring] = ACTIONS(4913),
    [sym_noreturn] = ACTIONS(4913),
    [sym_true] = ACTIONS(4913),
    [sym_false] = ACTIONS(4913),
    [sym_null] = ACTIONS(4913),
    [sym_super] = ACTIONS(4913),
    [sym_this] = ACTIONS(4913),
    [sym_abstract] = ACTIONS(4913),
    [sym_alias] = ACTIONS(4913),
    [sym_align] = ACTIONS(4913),
    [sym_asm] = ACTIONS(4913),
    [sym_assert] = ACTIONS(4913),
    [sym_auto] = ACTIONS(4913),
    [sym_break] = ACTIONS(4913),
    [sym_case] = ACTIONS(4913),
    [sym_cast] = ACTIONS(4913),
    [sym_catch] = ACTIONS(4913),
    [sym_class] = ACTIONS(4913),
    [sym_const] = ACTIONS(4913),
    [sym_continue] = ACTIONS(4913),
    [sym_debug] = ACTIONS(4913),
    [sym_default] = ACTIONS(4913),
    [sym_delegate] = ACTIONS(4913),
    [sym_delete] = ACTIONS(4913),
    [sym_deprecated] = ACTIONS(4913),
    [sym_do] = ACTIONS(4913),
    [sym_else] = ACTIONS(4913),
    [sym_enum] = ACTIONS(4913),
    [sym_export] = ACTIONS(4913),
    [sym_extern] = ACTIONS(4913),
    [sym_final] = ACTIONS(4913),
    [sym_finally] = ACTIONS(4913),
    [sym_for] = ACTIONS(4913),
    [sym_foreach] = ACTIONS(4913),
    [sym_foreach_reverse] = ACTIONS(4913),
    [sym_function] = ACTIONS(4913),
    [sym_goto] = ACTIONS(4913),
    [sym_if] = ACTIONS(4913),
    [sym_immutable] = ACTIONS(4913),
    [sym_import] = ACTIONS(4913),
    [sym_in] = ACTIONS(4913),
    [sym_inout] = ACTIONS(4913),
    [sym_interface] = ACTIONS(4913),
    [sym_invariant] = ACTIONS(4913),
    [sym_is] = ACTIONS(4913),
    [sym_mixin] = ACTIONS(4913),
    [sym_new] = ACTIONS(4913),
    [sym_nothrow] = ACTIONS(4913),
    [sym_out] = ACTIONS(4913),
    [sym_override] = ACTIONS(4913),
    [sym_package] = ACTIONS(4913),
    [sym_pragma] = ACTIONS(4913),
    [sym_private] = ACTIONS(4913),
    [sym_protected] = ACTIONS(4913),
    [sym_public] = ACTIONS(4913),
    [sym_pure] = ACTIONS(4913),
    [sym_ref] = ACTIONS(4913),
    [sym_return] = ACTIONS(4913),
    [sym_scope] = ACTIONS(4913),
    [sym_shared] = ACTIONS(4913),
    [sym_static] = ACTIONS(4913),
    [sym_struct] = ACTIONS(4913),
    [sym_switch] = ACTIONS(4913),
    [sym_synchronized] = ACTIONS(4913),
    [sym_template] = ACTIONS(4913),
    [sym_throw] = ACTIONS(4913),
    [sym_try] = ACTIONS(4913),
    [sym_typeid] = ACTIONS(4913),
    [sym_typeof] = ACTIONS(4913),
    [sym_union] = ACTIONS(4913),
    [sym_unittest] = ACTIONS(4913),
    [sym_version] = ACTIONS(4913),
    [sym_while] = ACTIONS(4913),
    [sym_with] = ACTIONS(4913),
    [sym_gshared] = ACTIONS(4913),
    [sym_traits] = ACTIONS(4913),
    [sym_vector] = ACTIONS(4913),
    [sym_void] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4915),
    [anon_sym_r_DQUOTE] = ACTIONS(4915),
    [anon_sym_x_DQUOTE] = ACTIONS(4915),
    [anon_sym_DQUOTE] = ACTIONS(4915),
    [anon_sym_i_BQUOTE] = ACTIONS(4915),
    [anon_sym_i_DQUOTE] = ACTIONS(4915),
    [anon_sym_iq_LBRACE] = ACTIONS(4915),
    [aux_sym_char_literal_token1] = ACTIONS(4915),
    [anon_sym_SQUOTE] = ACTIONS(4913),
    [anon_sym___DATE__] = ACTIONS(4913),
    [anon_sym___FILE__] = ACTIONS(4913),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4913),
    [anon_sym___FUNCTION__] = ACTIONS(4913),
    [anon_sym___LINE__] = ACTIONS(4913),
    [anon_sym___MODULE__] = ACTIONS(4913),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4913),
    [anon_sym___TIME__] = ACTIONS(4913),
    [anon_sym___TIMESTAMP__] = ACTIONS(4913),
    [anon_sym___VENDOR__] = ACTIONS(4913),
    [anon_sym___VERSION__] = ACTIONS(4913),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4915),
    [sym_float_literal] = ACTIONS(4915),
    [sym__string] = ACTIONS(4915),
  },
  [1487] = {
    [sym_identifier] = ACTIONS(4917),
    [anon_sym_q_LBRACE] = ACTIONS(4919),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_LBRACE] = ACTIONS(4919),
    [anon_sym_DOT] = ACTIONS(4919),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_DASH] = ACTIONS(4917),
    [anon_sym_DASH_DASH] = ACTIONS(4919),
    [anon_sym_PLUS] = ACTIONS(4917),
    [anon_sym_PLUS_PLUS] = ACTIONS(4919),
    [anon_sym_BANG] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(4919),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4919),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_DOLLAR] = ACTIONS(4919),
    [anon_sym_STAR] = ACTIONS(4919),
    [anon_sym_TILDE] = ACTIONS(4919),
    [anon_sym_AT] = ACTIONS(4919),
    [sym_bool] = ACTIONS(4917),
    [sym_byte] = ACTIONS(4917),
    [sym_ubyte] = ACTIONS(4917),
    [sym_char] = ACTIONS(4917),
    [sym_short] = ACTIONS(4917),
    [sym_ushort] = ACTIONS(4917),
    [sym_int] = ACTIONS(4917),
    [sym_uint] = ACTIONS(4917),
    [sym_long] = ACTIONS(4917),
    [sym_ulong] = ACTIONS(4917),
    [sym_cent] = ACTIONS(4917),
    [sym_ucent] = ACTIONS(4917),
    [sym_wchar] = ACTIONS(4917),
    [sym_dchar] = ACTIONS(4917),
    [sym_float] = ACTIONS(4917),
    [sym_double] = ACTIONS(4917),
    [sym_real] = ACTIONS(4917),
    [sym_ifloat] = ACTIONS(4917),
    [sym_idouble] = ACTIONS(4917),
    [sym_ireal] = ACTIONS(4917),
    [sym_cfloat] = ACTIONS(4917),
    [sym_cdouble] = ACTIONS(4917),
    [sym_creal] = ACTIONS(4917),
    [sym_size_t] = ACTIONS(4917),
    [sym_ptrdiff_t] = ACTIONS(4917),
    [sym_string] = ACTIONS(4917),
    [sym_cstring] = ACTIONS(4917),
    [sym_dstring] = ACTIONS(4917),
    [sym_wstring] = ACTIONS(4917),
    [sym_noreturn] = ACTIONS(4917),
    [sym_true] = ACTIONS(4917),
    [sym_false] = ACTIONS(4917),
    [sym_null] = ACTIONS(4917),
    [sym_super] = ACTIONS(4917),
    [sym_this] = ACTIONS(4917),
    [sym_abstract] = ACTIONS(4917),
    [sym_alias] = ACTIONS(4917),
    [sym_align] = ACTIONS(4917),
    [sym_asm] = ACTIONS(4917),
    [sym_assert] = ACTIONS(4917),
    [sym_auto] = ACTIONS(4917),
    [sym_break] = ACTIONS(4917),
    [sym_case] = ACTIONS(4917),
    [sym_cast] = ACTIONS(4917),
    [sym_catch] = ACTIONS(4917),
    [sym_class] = ACTIONS(4917),
    [sym_const] = ACTIONS(4917),
    [sym_continue] = ACTIONS(4917),
    [sym_debug] = ACTIONS(4917),
    [sym_default] = ACTIONS(4917),
    [sym_delegate] = ACTIONS(4917),
    [sym_delete] = ACTIONS(4917),
    [sym_deprecated] = ACTIONS(4917),
    [sym_do] = ACTIONS(4917),
    [sym_else] = ACTIONS(4917),
    [sym_enum] = ACTIONS(4917),
    [sym_export] = ACTIONS(4917),
    [sym_extern] = ACTIONS(4917),
    [sym_final] = ACTIONS(4917),
    [sym_finally] = ACTIONS(4917),
    [sym_for] = ACTIONS(4917),
    [sym_foreach] = ACTIONS(4917),
    [sym_foreach_reverse] = ACTIONS(4917),
    [sym_function] = ACTIONS(4917),
    [sym_goto] = ACTIONS(4917),
    [sym_if] = ACTIONS(4917),
    [sym_immutable] = ACTIONS(4917),
    [sym_import] = ACTIONS(4917),
    [sym_in] = ACTIONS(4917),
    [sym_inout] = ACTIONS(4917),
    [sym_interface] = ACTIONS(4917),
    [sym_invariant] = ACTIONS(4917),
    [sym_is] = ACTIONS(4917),
    [sym_mixin] = ACTIONS(4917),
    [sym_new] = ACTIONS(4917),
    [sym_nothrow] = ACTIONS(4917),
    [sym_out] = ACTIONS(4917),
    [sym_override] = ACTIONS(4917),
    [sym_package] = ACTIONS(4917),
    [sym_pragma] = ACTIONS(4917),
    [sym_private] = ACTIONS(4917),
    [sym_protected] = ACTIONS(4917),
    [sym_public] = ACTIONS(4917),
    [sym_pure] = ACTIONS(4917),
    [sym_ref] = ACTIONS(4917),
    [sym_return] = ACTIONS(4917),
    [sym_scope] = ACTIONS(4917),
    [sym_shared] = ACTIONS(4917),
    [sym_static] = ACTIONS(4917),
    [sym_struct] = ACTIONS(4917),
    [sym_switch] = ACTIONS(4917),
    [sym_synchronized] = ACTIONS(4917),
    [sym_template] = ACTIONS(4917),
    [sym_throw] = ACTIONS(4917),
    [sym_try] = ACTIONS(4917),
    [sym_typeid] = ACTIONS(4917),
    [sym_typeof] = ACTIONS(4917),
    [sym_union] = ACTIONS(4917),
    [sym_unittest] = ACTIONS(4917),
    [sym_version] = ACTIONS(4917),
    [sym_while] = ACTIONS(4917),
    [sym_with] = ACTIONS(4917),
    [sym_gshared] = ACTIONS(4917),
    [sym_traits] = ACTIONS(4917),
    [sym_vector] = ACTIONS(4917),
    [sym_void] = ACTIONS(4917),
    [anon_sym_BQUOTE] = ACTIONS(4919),
    [anon_sym_r_DQUOTE] = ACTIONS(4919),
    [anon_sym_x_DQUOTE] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4919),
    [anon_sym_i_BQUOTE] = ACTIONS(4919),
    [anon_sym_i_DQUOTE] = ACTIONS(4919),
    [anon_sym_iq_LBRACE] = ACTIONS(4919),
    [aux_sym_char_literal_token1] = ACTIONS(4919),
    [anon_sym_SQUOTE] = ACTIONS(4917),
    [anon_sym___DATE__] = ACTIONS(4917),
    [anon_sym___FILE__] = ACTIONS(4917),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4917),
    [anon_sym___FUNCTION__] = ACTIONS(4917),
    [anon_sym___LINE__] = ACTIONS(4917),
    [anon_sym___MODULE__] = ACTIONS(4917),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4917),
    [anon_sym___TIME__] = ACTIONS(4917),
    [anon_sym___TIMESTAMP__] = ACTIONS(4917),
    [anon_sym___VENDOR__] = ACTIONS(4917),
    [anon_sym___VERSION__] = ACTIONS(4917),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4919),
    [sym_float_literal] = ACTIONS(4919),
    [sym__string] = ACTIONS(4919),
  },
  [1488] = {
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_q_LBRACE] = ACTIONS(4923),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_LBRACE] = ACTIONS(4923),
    [anon_sym_DOT] = ACTIONS(4923),
    [anon_sym_AMP] = ACTIONS(4923),
    [anon_sym_DASH] = ACTIONS(4921),
    [anon_sym_DASH_DASH] = ACTIONS(4923),
    [anon_sym_PLUS] = ACTIONS(4921),
    [anon_sym_PLUS_PLUS] = ACTIONS(4923),
    [anon_sym_BANG] = ACTIONS(4923),
    [anon_sym_LPAREN] = ACTIONS(4923),
    [anon_sym_RPAREN] = ACTIONS(4923),
    [anon_sym_LBRACK] = ACTIONS(4923),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym_DOLLAR] = ACTIONS(4923),
    [anon_sym_STAR] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4923),
    [anon_sym_AT] = ACTIONS(4923),
    [sym_bool] = ACTIONS(4921),
    [sym_byte] = ACTIONS(4921),
    [sym_ubyte] = ACTIONS(4921),
    [sym_char] = ACTIONS(4921),
    [sym_short] = ACTIONS(4921),
    [sym_ushort] = ACTIONS(4921),
    [sym_int] = ACTIONS(4921),
    [sym_uint] = ACTIONS(4921),
    [sym_long] = ACTIONS(4921),
    [sym_ulong] = ACTIONS(4921),
    [sym_cent] = ACTIONS(4921),
    [sym_ucent] = ACTIONS(4921),
    [sym_wchar] = ACTIONS(4921),
    [sym_dchar] = ACTIONS(4921),
    [sym_float] = ACTIONS(4921),
    [sym_double] = ACTIONS(4921),
    [sym_real] = ACTIONS(4921),
    [sym_ifloat] = ACTIONS(4921),
    [sym_idouble] = ACTIONS(4921),
    [sym_ireal] = ACTIONS(4921),
    [sym_cfloat] = ACTIONS(4921),
    [sym_cdouble] = ACTIONS(4921),
    [sym_creal] = ACTIONS(4921),
    [sym_size_t] = ACTIONS(4921),
    [sym_ptrdiff_t] = ACTIONS(4921),
    [sym_string] = ACTIONS(4921),
    [sym_cstring] = ACTIONS(4921),
    [sym_dstring] = ACTIONS(4921),
    [sym_wstring] = ACTIONS(4921),
    [sym_noreturn] = ACTIONS(4921),
    [sym_true] = ACTIONS(4921),
    [sym_false] = ACTIONS(4921),
    [sym_null] = ACTIONS(4921),
    [sym_super] = ACTIONS(4921),
    [sym_this] = ACTIONS(4921),
    [sym_abstract] = ACTIONS(4921),
    [sym_alias] = ACTIONS(4921),
    [sym_align] = ACTIONS(4921),
    [sym_asm] = ACTIONS(4921),
    [sym_assert] = ACTIONS(4921),
    [sym_auto] = ACTIONS(4921),
    [sym_break] = ACTIONS(4921),
    [sym_case] = ACTIONS(4921),
    [sym_cast] = ACTIONS(4921),
    [sym_catch] = ACTIONS(4921),
    [sym_class] = ACTIONS(4921),
    [sym_const] = ACTIONS(4921),
    [sym_continue] = ACTIONS(4921),
    [sym_debug] = ACTIONS(4921),
    [sym_default] = ACTIONS(4921),
    [sym_delegate] = ACTIONS(4921),
    [sym_delete] = ACTIONS(4921),
    [sym_deprecated] = ACTIONS(4921),
    [sym_do] = ACTIONS(4921),
    [sym_else] = ACTIONS(4921),
    [sym_enum] = ACTIONS(4921),
    [sym_export] = ACTIONS(4921),
    [sym_extern] = ACTIONS(4921),
    [sym_final] = ACTIONS(4921),
    [sym_finally] = ACTIONS(4921),
    [sym_for] = ACTIONS(4921),
    [sym_foreach] = ACTIONS(4921),
    [sym_foreach_reverse] = ACTIONS(4921),
    [sym_function] = ACTIONS(4921),
    [sym_goto] = ACTIONS(4921),
    [sym_if] = ACTIONS(4921),
    [sym_immutable] = ACTIONS(4921),
    [sym_import] = ACTIONS(4921),
    [sym_in] = ACTIONS(4921),
    [sym_inout] = ACTIONS(4921),
    [sym_interface] = ACTIONS(4921),
    [sym_invariant] = ACTIONS(4921),
    [sym_is] = ACTIONS(4921),
    [sym_mixin] = ACTIONS(4921),
    [sym_new] = ACTIONS(4921),
    [sym_nothrow] = ACTIONS(4921),
    [sym_out] = ACTIONS(4921),
    [sym_override] = ACTIONS(4921),
    [sym_package] = ACTIONS(4921),
    [sym_pragma] = ACTIONS(4921),
    [sym_private] = ACTIONS(4921),
    [sym_protected] = ACTIONS(4921),
    [sym_public] = ACTIONS(4921),
    [sym_pure] = ACTIONS(4921),
    [sym_ref] = ACTIONS(4921),
    [sym_return] = ACTIONS(4921),
    [sym_scope] = ACTIONS(4921),
    [sym_shared] = ACTIONS(4921),
    [sym_static] = ACTIONS(4921),
    [sym_struct] = ACTIONS(4921),
    [sym_switch] = ACTIONS(4921),
    [sym_synchronized] = ACTIONS(4921),
    [sym_template] = ACTIONS(4921),
    [sym_throw] = ACTIONS(4921),
    [sym_try] = ACTIONS(4921),
    [sym_typeid] = ACTIONS(4921),
    [sym_typeof] = ACTIONS(4921),
    [sym_union] = ACTIONS(4921),
    [sym_unittest] = ACTIONS(4921),
    [sym_version] = ACTIONS(4921),
    [sym_while] = ACTIONS(4921),
    [sym_with] = ACTIONS(4921),
    [sym_gshared] = ACTIONS(4921),
    [sym_traits] = ACTIONS(4921),
    [sym_vector] = ACTIONS(4921),
    [sym_void] = ACTIONS(4921),
    [anon_sym_BQUOTE] = ACTIONS(4923),
    [anon_sym_r_DQUOTE] = ACTIONS(4923),
    [anon_sym_x_DQUOTE] = ACTIONS(4923),
    [anon_sym_DQUOTE] = ACTIONS(4923),
    [anon_sym_i_BQUOTE] = ACTIONS(4923),
    [anon_sym_i_DQUOTE] = ACTIONS(4923),
    [anon_sym_iq_LBRACE] = ACTIONS(4923),
    [aux_sym_char_literal_token1] = ACTIONS(4923),
    [anon_sym_SQUOTE] = ACTIONS(4921),
    [anon_sym___DATE__] = ACTIONS(4921),
    [anon_sym___FILE__] = ACTIONS(4921),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4921),
    [anon_sym___FUNCTION__] = ACTIONS(4921),
    [anon_sym___LINE__] = ACTIONS(4921),
    [anon_sym___MODULE__] = ACTIONS(4921),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4921),
    [anon_sym___TIME__] = ACTIONS(4921),
    [anon_sym___TIMESTAMP__] = ACTIONS(4921),
    [anon_sym___VENDOR__] = ACTIONS(4921),
    [anon_sym___VERSION__] = ACTIONS(4921),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4923),
    [sym_float_literal] = ACTIONS(4923),
    [sym__string] = ACTIONS(4923),
  },
  [1489] = {
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_q_LBRACE] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_LBRACE] = ACTIONS(4927),
    [anon_sym_DOT] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(4927),
    [anon_sym_DASH] = ACTIONS(4925),
    [anon_sym_DASH_DASH] = ACTIONS(4927),
    [anon_sym_PLUS] = ACTIONS(4925),
    [anon_sym_PLUS_PLUS] = ACTIONS(4927),
    [anon_sym_BANG] = ACTIONS(4927),
    [anon_sym_LPAREN] = ACTIONS(4927),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_DOLLAR] = ACTIONS(4927),
    [anon_sym_STAR] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(4927),
    [sym_bool] = ACTIONS(4925),
    [sym_byte] = ACTIONS(4925),
    [sym_ubyte] = ACTIONS(4925),
    [sym_char] = ACTIONS(4925),
    [sym_short] = ACTIONS(4925),
    [sym_ushort] = ACTIONS(4925),
    [sym_int] = ACTIONS(4925),
    [sym_uint] = ACTIONS(4925),
    [sym_long] = ACTIONS(4925),
    [sym_ulong] = ACTIONS(4925),
    [sym_cent] = ACTIONS(4925),
    [sym_ucent] = ACTIONS(4925),
    [sym_wchar] = ACTIONS(4925),
    [sym_dchar] = ACTIONS(4925),
    [sym_float] = ACTIONS(4925),
    [sym_double] = ACTIONS(4925),
    [sym_real] = ACTIONS(4925),
    [sym_ifloat] = ACTIONS(4925),
    [sym_idouble] = ACTIONS(4925),
    [sym_ireal] = ACTIONS(4925),
    [sym_cfloat] = ACTIONS(4925),
    [sym_cdouble] = ACTIONS(4925),
    [sym_creal] = ACTIONS(4925),
    [sym_size_t] = ACTIONS(4925),
    [sym_ptrdiff_t] = ACTIONS(4925),
    [sym_string] = ACTIONS(4925),
    [sym_cstring] = ACTIONS(4925),
    [sym_dstring] = ACTIONS(4925),
    [sym_wstring] = ACTIONS(4925),
    [sym_noreturn] = ACTIONS(4925),
    [sym_true] = ACTIONS(4925),
    [sym_false] = ACTIONS(4925),
    [sym_null] = ACTIONS(4925),
    [sym_super] = ACTIONS(4925),
    [sym_this] = ACTIONS(4925),
    [sym_abstract] = ACTIONS(4925),
    [sym_alias] = ACTIONS(4925),
    [sym_align] = ACTIONS(4925),
    [sym_asm] = ACTIONS(4925),
    [sym_assert] = ACTIONS(4925),
    [sym_auto] = ACTIONS(4925),
    [sym_break] = ACTIONS(4925),
    [sym_case] = ACTIONS(4925),
    [sym_cast] = ACTIONS(4925),
    [sym_catch] = ACTIONS(4925),
    [sym_class] = ACTIONS(4925),
    [sym_const] = ACTIONS(4925),
    [sym_continue] = ACTIONS(4925),
    [sym_debug] = ACTIONS(4925),
    [sym_default] = ACTIONS(4925),
    [sym_delegate] = ACTIONS(4925),
    [sym_delete] = ACTIONS(4925),
    [sym_deprecated] = ACTIONS(4925),
    [sym_do] = ACTIONS(4925),
    [sym_else] = ACTIONS(4925),
    [sym_enum] = ACTIONS(4925),
    [sym_export] = ACTIONS(4925),
    [sym_extern] = ACTIONS(4925),
    [sym_final] = ACTIONS(4925),
    [sym_finally] = ACTIONS(4925),
    [sym_for] = ACTIONS(4925),
    [sym_foreach] = ACTIONS(4925),
    [sym_foreach_reverse] = ACTIONS(4925),
    [sym_function] = ACTIONS(4925),
    [sym_goto] = ACTIONS(4925),
    [sym_if] = ACTIONS(4925),
    [sym_immutable] = ACTIONS(4925),
    [sym_import] = ACTIONS(4925),
    [sym_in] = ACTIONS(4925),
    [sym_inout] = ACTIONS(4925),
    [sym_interface] = ACTIONS(4925),
    [sym_invariant] = ACTIONS(4925),
    [sym_is] = ACTIONS(4925),
    [sym_mixin] = ACTIONS(4925),
    [sym_new] = ACTIONS(4925),
    [sym_nothrow] = ACTIONS(4925),
    [sym_out] = ACTIONS(4925),
    [sym_override] = ACTIONS(4925),
    [sym_package] = ACTIONS(4925),
    [sym_pragma] = ACTIONS(4925),
    [sym_private] = ACTIONS(4925),
    [sym_protected] = ACTIONS(4925),
    [sym_public] = ACTIONS(4925),
    [sym_pure] = ACTIONS(4925),
    [sym_ref] = ACTIONS(4925),
    [sym_return] = ACTIONS(4925),
    [sym_scope] = ACTIONS(4925),
    [sym_shared] = ACTIONS(4925),
    [sym_static] = ACTIONS(4925),
    [sym_struct] = ACTIONS(4925),
    [sym_switch] = ACTIONS(4925),
    [sym_synchronized] = ACTIONS(4925),
    [sym_template] = ACTIONS(4925),
    [sym_throw] = ACTIONS(4925),
    [sym_try] = ACTIONS(4925),
    [sym_typeid] = ACTIONS(4925),
    [sym_typeof] = ACTIONS(4925),
    [sym_union] = ACTIONS(4925),
    [sym_unittest] = ACTIONS(4925),
    [sym_version] = ACTIONS(4925),
    [sym_while] = ACTIONS(4925),
    [sym_with] = ACTIONS(4925),
    [sym_gshared] = ACTIONS(4925),
    [sym_traits] = ACTIONS(4925),
    [sym_vector] = ACTIONS(4925),
    [sym_void] = ACTIONS(4925),
    [anon_sym_BQUOTE] = ACTIONS(4927),
    [anon_sym_r_DQUOTE] = ACTIONS(4927),
    [anon_sym_x_DQUOTE] = ACTIONS(4927),
    [anon_sym_DQUOTE] = ACTIONS(4927),
    [anon_sym_i_BQUOTE] = ACTIONS(4927),
    [anon_sym_i_DQUOTE] = ACTIONS(4927),
    [anon_sym_iq_LBRACE] = ACTIONS(4927),
    [aux_sym_char_literal_token1] = ACTIONS(4927),
    [anon_sym_SQUOTE] = ACTIONS(4925),
    [anon_sym___DATE__] = ACTIONS(4925),
    [anon_sym___FILE__] = ACTIONS(4925),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4925),
    [anon_sym___FUNCTION__] = ACTIONS(4925),
    [anon_sym___LINE__] = ACTIONS(4925),
    [anon_sym___MODULE__] = ACTIONS(4925),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4925),
    [anon_sym___TIME__] = ACTIONS(4925),
    [anon_sym___TIMESTAMP__] = ACTIONS(4925),
    [anon_sym___VENDOR__] = ACTIONS(4925),
    [anon_sym___VERSION__] = ACTIONS(4925),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4927),
    [sym_float_literal] = ACTIONS(4927),
    [sym__string] = ACTIONS(4927),
  },
  [1490] = {
    [sym_identifier] = ACTIONS(4929),
    [anon_sym_q_LBRACE] = ACTIONS(4931),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_LBRACE] = ACTIONS(4931),
    [anon_sym_DOT] = ACTIONS(4931),
    [anon_sym_AMP] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(4929),
    [anon_sym_DASH_DASH] = ACTIONS(4931),
    [anon_sym_PLUS] = ACTIONS(4929),
    [anon_sym_PLUS_PLUS] = ACTIONS(4931),
    [anon_sym_BANG] = ACTIONS(4931),
    [anon_sym_LPAREN] = ACTIONS(4931),
    [anon_sym_RPAREN] = ACTIONS(4931),
    [anon_sym_LBRACK] = ACTIONS(4931),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_DOLLAR] = ACTIONS(4931),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4931),
    [anon_sym_AT] = ACTIONS(4931),
    [sym_bool] = ACTIONS(4929),
    [sym_byte] = ACTIONS(4929),
    [sym_ubyte] = ACTIONS(4929),
    [sym_char] = ACTIONS(4929),
    [sym_short] = ACTIONS(4929),
    [sym_ushort] = ACTIONS(4929),
    [sym_int] = ACTIONS(4929),
    [sym_uint] = ACTIONS(4929),
    [sym_long] = ACTIONS(4929),
    [sym_ulong] = ACTIONS(4929),
    [sym_cent] = ACTIONS(4929),
    [sym_ucent] = ACTIONS(4929),
    [sym_wchar] = ACTIONS(4929),
    [sym_dchar] = ACTIONS(4929),
    [sym_float] = ACTIONS(4929),
    [sym_double] = ACTIONS(4929),
    [sym_real] = ACTIONS(4929),
    [sym_ifloat] = ACTIONS(4929),
    [sym_idouble] = ACTIONS(4929),
    [sym_ireal] = ACTIONS(4929),
    [sym_cfloat] = ACTIONS(4929),
    [sym_cdouble] = ACTIONS(4929),
    [sym_creal] = ACTIONS(4929),
    [sym_size_t] = ACTIONS(4929),
    [sym_ptrdiff_t] = ACTIONS(4929),
    [sym_string] = ACTIONS(4929),
    [sym_cstring] = ACTIONS(4929),
    [sym_dstring] = ACTIONS(4929),
    [sym_wstring] = ACTIONS(4929),
    [sym_noreturn] = ACTIONS(4929),
    [sym_true] = ACTIONS(4929),
    [sym_false] = ACTIONS(4929),
    [sym_null] = ACTIONS(4929),
    [sym_super] = ACTIONS(4929),
    [sym_this] = ACTIONS(4929),
    [sym_abstract] = ACTIONS(4929),
    [sym_alias] = ACTIONS(4929),
    [sym_align] = ACTIONS(4929),
    [sym_asm] = ACTIONS(4929),
    [sym_assert] = ACTIONS(4929),
    [sym_auto] = ACTIONS(4929),
    [sym_break] = ACTIONS(4929),
    [sym_case] = ACTIONS(4929),
    [sym_cast] = ACTIONS(4929),
    [sym_catch] = ACTIONS(4929),
    [sym_class] = ACTIONS(4929),
    [sym_const] = ACTIONS(4929),
    [sym_continue] = ACTIONS(4929),
    [sym_debug] = ACTIONS(4929),
    [sym_default] = ACTIONS(4929),
    [sym_delegate] = ACTIONS(4929),
    [sym_delete] = ACTIONS(4929),
    [sym_deprecated] = ACTIONS(4929),
    [sym_do] = ACTIONS(4929),
    [sym_else] = ACTIONS(4929),
    [sym_enum] = ACTIONS(4929),
    [sym_export] = ACTIONS(4929),
    [sym_extern] = ACTIONS(4929),
    [sym_final] = ACTIONS(4929),
    [sym_finally] = ACTIONS(4929),
    [sym_for] = ACTIONS(4929),
    [sym_foreach] = ACTIONS(4929),
    [sym_foreach_reverse] = ACTIONS(4929),
    [sym_function] = ACTIONS(4929),
    [sym_goto] = ACTIONS(4929),
    [sym_if] = ACTIONS(4929),
    [sym_immutable] = ACTIONS(4929),
    [sym_import] = ACTIONS(4929),
    [sym_in] = ACTIONS(4929),
    [sym_inout] = ACTIONS(4929),
    [sym_interface] = ACTIONS(4929),
    [sym_invariant] = ACTIONS(4929),
    [sym_is] = ACTIONS(4929),
    [sym_mixin] = ACTIONS(4929),
    [sym_new] = ACTIONS(4929),
    [sym_nothrow] = ACTIONS(4929),
    [sym_out] = ACTIONS(4929),
    [sym_override] = ACTIONS(4929),
    [sym_package] = ACTIONS(4929),
    [sym_pragma] = ACTIONS(4929),
    [sym_private] = ACTIONS(4929),
    [sym_protected] = ACTIONS(4929),
    [sym_public] = ACTIONS(4929),
    [sym_pure] = ACTIONS(4929),
    [sym_ref] = ACTIONS(4929),
    [sym_return] = ACTIONS(4929),
    [sym_scope] = ACTIONS(4929),
    [sym_shared] = ACTIONS(4929),
    [sym_static] = ACTIONS(4929),
    [sym_struct] = ACTIONS(4929),
    [sym_switch] = ACTIONS(4929),
    [sym_synchronized] = ACTIONS(4929),
    [sym_template] = ACTIONS(4929),
    [sym_throw] = ACTIONS(4929),
    [sym_try] = ACTIONS(4929),
    [sym_typeid] = ACTIONS(4929),
    [sym_typeof] = ACTIONS(4929),
    [sym_union] = ACTIONS(4929),
    [sym_unittest] = ACTIONS(4929),
    [sym_version] = ACTIONS(4929),
    [sym_while] = ACTIONS(4929),
    [sym_with] = ACTIONS(4929),
    [sym_gshared] = ACTIONS(4929),
    [sym_traits] = ACTIONS(4929),
    [sym_vector] = ACTIONS(4929),
    [sym_void] = ACTIONS(4929),
    [anon_sym_BQUOTE] = ACTIONS(4931),
    [anon_sym_r_DQUOTE] = ACTIONS(4931),
    [anon_sym_x_DQUOTE] = ACTIONS(4931),
    [anon_sym_DQUOTE] = ACTIONS(4931),
    [anon_sym_i_BQUOTE] = ACTIONS(4931),
    [anon_sym_i_DQUOTE] = ACTIONS(4931),
    [anon_sym_iq_LBRACE] = ACTIONS(4931),
    [aux_sym_char_literal_token1] = ACTIONS(4931),
    [anon_sym_SQUOTE] = ACTIONS(4929),
    [anon_sym___DATE__] = ACTIONS(4929),
    [anon_sym___FILE__] = ACTIONS(4929),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4929),
    [anon_sym___FUNCTION__] = ACTIONS(4929),
    [anon_sym___LINE__] = ACTIONS(4929),
    [anon_sym___MODULE__] = ACTIONS(4929),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4929),
    [anon_sym___TIME__] = ACTIONS(4929),
    [anon_sym___TIMESTAMP__] = ACTIONS(4929),
    [anon_sym___VENDOR__] = ACTIONS(4929),
    [anon_sym___VERSION__] = ACTIONS(4929),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4931),
    [sym_float_literal] = ACTIONS(4931),
    [sym__string] = ACTIONS(4931),
  },
  [1491] = {
    [sym_identifier] = ACTIONS(4933),
    [anon_sym_q_LBRACE] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4935),
    [anon_sym_PLUS] = ACTIONS(4933),
    [anon_sym_PLUS_PLUS] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_LPAREN] = ACTIONS(4935),
    [anon_sym_RPAREN] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4935),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym_DOLLAR] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4935),
    [anon_sym_TILDE] = ACTIONS(4935),
    [anon_sym_AT] = ACTIONS(4935),
    [sym_bool] = ACTIONS(4933),
    [sym_byte] = ACTIONS(4933),
    [sym_ubyte] = ACTIONS(4933),
    [sym_char] = ACTIONS(4933),
    [sym_short] = ACTIONS(4933),
    [sym_ushort] = ACTIONS(4933),
    [sym_int] = ACTIONS(4933),
    [sym_uint] = ACTIONS(4933),
    [sym_long] = ACTIONS(4933),
    [sym_ulong] = ACTIONS(4933),
    [sym_cent] = ACTIONS(4933),
    [sym_ucent] = ACTIONS(4933),
    [sym_wchar] = ACTIONS(4933),
    [sym_dchar] = ACTIONS(4933),
    [sym_float] = ACTIONS(4933),
    [sym_double] = ACTIONS(4933),
    [sym_real] = ACTIONS(4933),
    [sym_ifloat] = ACTIONS(4933),
    [sym_idouble] = ACTIONS(4933),
    [sym_ireal] = ACTIONS(4933),
    [sym_cfloat] = ACTIONS(4933),
    [sym_cdouble] = ACTIONS(4933),
    [sym_creal] = ACTIONS(4933),
    [sym_size_t] = ACTIONS(4933),
    [sym_ptrdiff_t] = ACTIONS(4933),
    [sym_string] = ACTIONS(4933),
    [sym_cstring] = ACTIONS(4933),
    [sym_dstring] = ACTIONS(4933),
    [sym_wstring] = ACTIONS(4933),
    [sym_noreturn] = ACTIONS(4933),
    [sym_true] = ACTIONS(4933),
    [sym_false] = ACTIONS(4933),
    [sym_null] = ACTIONS(4933),
    [sym_super] = ACTIONS(4933),
    [sym_this] = ACTIONS(4933),
    [sym_abstract] = ACTIONS(4933),
    [sym_alias] = ACTIONS(4933),
    [sym_align] = ACTIONS(4933),
    [sym_asm] = ACTIONS(4933),
    [sym_assert] = ACTIONS(4933),
    [sym_auto] = ACTIONS(4933),
    [sym_break] = ACTIONS(4933),
    [sym_case] = ACTIONS(4933),
    [sym_cast] = ACTIONS(4933),
    [sym_catch] = ACTIONS(4933),
    [sym_class] = ACTIONS(4933),
    [sym_const] = ACTIONS(4933),
    [sym_continue] = ACTIONS(4933),
    [sym_debug] = ACTIONS(4933),
    [sym_default] = ACTIONS(4933),
    [sym_delegate] = ACTIONS(4933),
    [sym_delete] = ACTIONS(4933),
    [sym_deprecated] = ACTIONS(4933),
    [sym_do] = ACTIONS(4933),
    [sym_else] = ACTIONS(4933),
    [sym_enum] = ACTIONS(4933),
    [sym_export] = ACTIONS(4933),
    [sym_extern] = ACTIONS(4933),
    [sym_final] = ACTIONS(4933),
    [sym_finally] = ACTIONS(4933),
    [sym_for] = ACTIONS(4933),
    [sym_foreach] = ACTIONS(4933),
    [sym_foreach_reverse] = ACTIONS(4933),
    [sym_function] = ACTIONS(4933),
    [sym_goto] = ACTIONS(4933),
    [sym_if] = ACTIONS(4933),
    [sym_immutable] = ACTIONS(4933),
    [sym_import] = ACTIONS(4933),
    [sym_in] = ACTIONS(4933),
    [sym_inout] = ACTIONS(4933),
    [sym_interface] = ACTIONS(4933),
    [sym_invariant] = ACTIONS(4933),
    [sym_is] = ACTIONS(4933),
    [sym_mixin] = ACTIONS(4933),
    [sym_new] = ACTIONS(4933),
    [sym_nothrow] = ACTIONS(4933),
    [sym_out] = ACTIONS(4933),
    [sym_override] = ACTIONS(4933),
    [sym_package] = ACTIONS(4933),
    [sym_pragma] = ACTIONS(4933),
    [sym_private] = ACTIONS(4933),
    [sym_protected] = ACTIONS(4933),
    [sym_public] = ACTIONS(4933),
    [sym_pure] = ACTIONS(4933),
    [sym_ref] = ACTIONS(4933),
    [sym_return] = ACTIONS(4933),
    [sym_scope] = ACTIONS(4933),
    [sym_shared] = ACTIONS(4933),
    [sym_static] = ACTIONS(4933),
    [sym_struct] = ACTIONS(4933),
    [sym_switch] = ACTIONS(4933),
    [sym_synchronized] = ACTIONS(4933),
    [sym_template] = ACTIONS(4933),
    [sym_throw] = ACTIONS(4933),
    [sym_try] = ACTIONS(4933),
    [sym_typeid] = ACTIONS(4933),
    [sym_typeof] = ACTIONS(4933),
    [sym_union] = ACTIONS(4933),
    [sym_unittest] = ACTIONS(4933),
    [sym_version] = ACTIONS(4933),
    [sym_while] = ACTIONS(4933),
    [sym_with] = ACTIONS(4933),
    [sym_gshared] = ACTIONS(4933),
    [sym_traits] = ACTIONS(4933),
    [sym_vector] = ACTIONS(4933),
    [sym_void] = ACTIONS(4933),
    [anon_sym_BQUOTE] = ACTIONS(4935),
    [anon_sym_r_DQUOTE] = ACTIONS(4935),
    [anon_sym_x_DQUOTE] = ACTIONS(4935),
    [anon_sym_DQUOTE] = ACTIONS(4935),
    [anon_sym_i_BQUOTE] = ACTIONS(4935),
    [anon_sym_i_DQUOTE] = ACTIONS(4935),
    [anon_sym_iq_LBRACE] = ACTIONS(4935),
    [aux_sym_char_literal_token1] = ACTIONS(4935),
    [anon_sym_SQUOTE] = ACTIONS(4933),
    [anon_sym___DATE__] = ACTIONS(4933),
    [anon_sym___FILE__] = ACTIONS(4933),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4933),
    [anon_sym___FUNCTION__] = ACTIONS(4933),
    [anon_sym___LINE__] = ACTIONS(4933),
    [anon_sym___MODULE__] = ACTIONS(4933),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4933),
    [anon_sym___TIME__] = ACTIONS(4933),
    [anon_sym___TIMESTAMP__] = ACTIONS(4933),
    [anon_sym___VENDOR__] = ACTIONS(4933),
    [anon_sym___VERSION__] = ACTIONS(4933),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4935),
    [sym_float_literal] = ACTIONS(4935),
    [sym__string] = ACTIONS(4935),
  },
  [1492] = {
    [sym_identifier] = ACTIONS(4937),
    [anon_sym_q_LBRACE] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_DASH] = ACTIONS(4937),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4937),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_BANG] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_DOLLAR] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_TILDE] = ACTIONS(4939),
    [anon_sym_AT] = ACTIONS(4939),
    [sym_bool] = ACTIONS(4937),
    [sym_byte] = ACTIONS(4937),
    [sym_ubyte] = ACTIONS(4937),
    [sym_char] = ACTIONS(4937),
    [sym_short] = ACTIONS(4937),
    [sym_ushort] = ACTIONS(4937),
    [sym_int] = ACTIONS(4937),
    [sym_uint] = ACTIONS(4937),
    [sym_long] = ACTIONS(4937),
    [sym_ulong] = ACTIONS(4937),
    [sym_cent] = ACTIONS(4937),
    [sym_ucent] = ACTIONS(4937),
    [sym_wchar] = ACTIONS(4937),
    [sym_dchar] = ACTIONS(4937),
    [sym_float] = ACTIONS(4937),
    [sym_double] = ACTIONS(4937),
    [sym_real] = ACTIONS(4937),
    [sym_ifloat] = ACTIONS(4937),
    [sym_idouble] = ACTIONS(4937),
    [sym_ireal] = ACTIONS(4937),
    [sym_cfloat] = ACTIONS(4937),
    [sym_cdouble] = ACTIONS(4937),
    [sym_creal] = ACTIONS(4937),
    [sym_size_t] = ACTIONS(4937),
    [sym_ptrdiff_t] = ACTIONS(4937),
    [sym_string] = ACTIONS(4937),
    [sym_cstring] = ACTIONS(4937),
    [sym_dstring] = ACTIONS(4937),
    [sym_wstring] = ACTIONS(4937),
    [sym_noreturn] = ACTIONS(4937),
    [sym_true] = ACTIONS(4937),
    [sym_false] = ACTIONS(4937),
    [sym_null] = ACTIONS(4937),
    [sym_super] = ACTIONS(4937),
    [sym_this] = ACTIONS(4937),
    [sym_abstract] = ACTIONS(4937),
    [sym_alias] = ACTIONS(4937),
    [sym_align] = ACTIONS(4937),
    [sym_asm] = ACTIONS(4937),
    [sym_assert] = ACTIONS(4937),
    [sym_auto] = ACTIONS(4937),
    [sym_break] = ACTIONS(4937),
    [sym_case] = ACTIONS(4937),
    [sym_cast] = ACTIONS(4937),
    [sym_catch] = ACTIONS(4937),
    [sym_class] = ACTIONS(4937),
    [sym_const] = ACTIONS(4937),
    [sym_continue] = ACTIONS(4937),
    [sym_debug] = ACTIONS(4937),
    [sym_default] = ACTIONS(4937),
    [sym_delegate] = ACTIONS(4937),
    [sym_delete] = ACTIONS(4937),
    [sym_deprecated] = ACTIONS(4937),
    [sym_do] = ACTIONS(4937),
    [sym_else] = ACTIONS(4937),
    [sym_enum] = ACTIONS(4937),
    [sym_export] = ACTIONS(4937),
    [sym_extern] = ACTIONS(4937),
    [sym_final] = ACTIONS(4937),
    [sym_finally] = ACTIONS(4937),
    [sym_for] = ACTIONS(4937),
    [sym_foreach] = ACTIONS(4937),
    [sym_foreach_reverse] = ACTIONS(4937),
    [sym_function] = ACTIONS(4937),
    [sym_goto] = ACTIONS(4937),
    [sym_if] = ACTIONS(4937),
    [sym_immutable] = ACTIONS(4937),
    [sym_import] = ACTIONS(4937),
    [sym_in] = ACTIONS(4937),
    [sym_inout] = ACTIONS(4937),
    [sym_interface] = ACTIONS(4937),
    [sym_invariant] = ACTIONS(4937),
    [sym_is] = ACTIONS(4937),
    [sym_mixin] = ACTIONS(4937),
    [sym_new] = ACTIONS(4937),
    [sym_nothrow] = ACTIONS(4937),
    [sym_out] = ACTIONS(4937),
    [sym_override] = ACTIONS(4937),
    [sym_package] = ACTIONS(4937),
    [sym_pragma] = ACTIONS(4937),
    [sym_private] = ACTIONS(4937),
    [sym_protected] = ACTIONS(4937),
    [sym_public] = ACTIONS(4937),
    [sym_pure] = ACTIONS(4937),
    [sym_ref] = ACTIONS(4937),
    [sym_return] = ACTIONS(4937),
    [sym_scope] = ACTIONS(4937),
    [sym_shared] = ACTIONS(4937),
    [sym_static] = ACTIONS(4937),
    [sym_struct] = ACTIONS(4937),
    [sym_switch] = ACTIONS(4937),
    [sym_synchronized] = ACTIONS(4937),
    [sym_template] = ACTIONS(4937),
    [sym_throw] = ACTIONS(4937),
    [sym_try] = ACTIONS(4937),
    [sym_typeid] = ACTIONS(4937),
    [sym_typeof] = ACTIONS(4937),
    [sym_union] = ACTIONS(4937),
    [sym_unittest] = ACTIONS(4937),
    [sym_version] = ACTIONS(4937),
    [sym_while] = ACTIONS(4937),
    [sym_with] = ACTIONS(4937),
    [sym_gshared] = ACTIONS(4937),
    [sym_traits] = ACTIONS(4937),
    [sym_vector] = ACTIONS(4937),
    [sym_void] = ACTIONS(4937),
    [anon_sym_BQUOTE] = ACTIONS(4939),
    [anon_sym_r_DQUOTE] = ACTIONS(4939),
    [anon_sym_x_DQUOTE] = ACTIONS(4939),
    [anon_sym_DQUOTE] = ACTIONS(4939),
    [anon_sym_i_BQUOTE] = ACTIONS(4939),
    [anon_sym_i_DQUOTE] = ACTIONS(4939),
    [anon_sym_iq_LBRACE] = ACTIONS(4939),
    [aux_sym_char_literal_token1] = ACTIONS(4939),
    [anon_sym_SQUOTE] = ACTIONS(4937),
    [anon_sym___DATE__] = ACTIONS(4937),
    [anon_sym___FILE__] = ACTIONS(4937),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4937),
    [anon_sym___FUNCTION__] = ACTIONS(4937),
    [anon_sym___LINE__] = ACTIONS(4937),
    [anon_sym___MODULE__] = ACTIONS(4937),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4937),
    [anon_sym___TIME__] = ACTIONS(4937),
    [anon_sym___TIMESTAMP__] = ACTIONS(4937),
    [anon_sym___VENDOR__] = ACTIONS(4937),
    [anon_sym___VERSION__] = ACTIONS(4937),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4939),
    [sym_float_literal] = ACTIONS(4939),
    [sym__string] = ACTIONS(4939),
  },
  [1493] = {
    [sym_identifier] = ACTIONS(4941),
    [anon_sym_q_LBRACE] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_LBRACE] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4943),
    [anon_sym_AMP] = ACTIONS(4943),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_BANG] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_DOLLAR] = ACTIONS(4943),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4943),
    [anon_sym_AT] = ACTIONS(4943),
    [sym_bool] = ACTIONS(4941),
    [sym_byte] = ACTIONS(4941),
    [sym_ubyte] = ACTIONS(4941),
    [sym_char] = ACTIONS(4941),
    [sym_short] = ACTIONS(4941),
    [sym_ushort] = ACTIONS(4941),
    [sym_int] = ACTIONS(4941),
    [sym_uint] = ACTIONS(4941),
    [sym_long] = ACTIONS(4941),
    [sym_ulong] = ACTIONS(4941),
    [sym_cent] = ACTIONS(4941),
    [sym_ucent] = ACTIONS(4941),
    [sym_wchar] = ACTIONS(4941),
    [sym_dchar] = ACTIONS(4941),
    [sym_float] = ACTIONS(4941),
    [sym_double] = ACTIONS(4941),
    [sym_real] = ACTIONS(4941),
    [sym_ifloat] = ACTIONS(4941),
    [sym_idouble] = ACTIONS(4941),
    [sym_ireal] = ACTIONS(4941),
    [sym_cfloat] = ACTIONS(4941),
    [sym_cdouble] = ACTIONS(4941),
    [sym_creal] = ACTIONS(4941),
    [sym_size_t] = ACTIONS(4941),
    [sym_ptrdiff_t] = ACTIONS(4941),
    [sym_string] = ACTIONS(4941),
    [sym_cstring] = ACTIONS(4941),
    [sym_dstring] = ACTIONS(4941),
    [sym_wstring] = ACTIONS(4941),
    [sym_noreturn] = ACTIONS(4941),
    [sym_true] = ACTIONS(4941),
    [sym_false] = ACTIONS(4941),
    [sym_null] = ACTIONS(4941),
    [sym_super] = ACTIONS(4941),
    [sym_this] = ACTIONS(4941),
    [sym_abstract] = ACTIONS(4941),
    [sym_alias] = ACTIONS(4941),
    [sym_align] = ACTIONS(4941),
    [sym_asm] = ACTIONS(4941),
    [sym_assert] = ACTIONS(4941),
    [sym_auto] = ACTIONS(4941),
    [sym_break] = ACTIONS(4941),
    [sym_case] = ACTIONS(4941),
    [sym_cast] = ACTIONS(4941),
    [sym_catch] = ACTIONS(4941),
    [sym_class] = ACTIONS(4941),
    [sym_const] = ACTIONS(4941),
    [sym_continue] = ACTIONS(4941),
    [sym_debug] = ACTIONS(4941),
    [sym_default] = ACTIONS(4941),
    [sym_delegate] = ACTIONS(4941),
    [sym_delete] = ACTIONS(4941),
    [sym_deprecated] = ACTIONS(4941),
    [sym_do] = ACTIONS(4941),
    [sym_else] = ACTIONS(4941),
    [sym_enum] = ACTIONS(4941),
    [sym_export] = ACTIONS(4941),
    [sym_extern] = ACTIONS(4941),
    [sym_final] = ACTIONS(4941),
    [sym_finally] = ACTIONS(4941),
    [sym_for] = ACTIONS(4941),
    [sym_foreach] = ACTIONS(4941),
    [sym_foreach_reverse] = ACTIONS(4941),
    [sym_function] = ACTIONS(4941),
    [sym_goto] = ACTIONS(4941),
    [sym_if] = ACTIONS(4941),
    [sym_immutable] = ACTIONS(4941),
    [sym_import] = ACTIONS(4941),
    [sym_in] = ACTIONS(4941),
    [sym_inout] = ACTIONS(4941),
    [sym_interface] = ACTIONS(4941),
    [sym_invariant] = ACTIONS(4941),
    [sym_is] = ACTIONS(4941),
    [sym_mixin] = ACTIONS(4941),
    [sym_new] = ACTIONS(4941),
    [sym_nothrow] = ACTIONS(4941),
    [sym_out] = ACTIONS(4941),
    [sym_override] = ACTIONS(4941),
    [sym_package] = ACTIONS(4941),
    [sym_pragma] = ACTIONS(4941),
    [sym_private] = ACTIONS(4941),
    [sym_protected] = ACTIONS(4941),
    [sym_public] = ACTIONS(4941),
    [sym_pure] = ACTIONS(4941),
    [sym_ref] = ACTIONS(4941),
    [sym_return] = ACTIONS(4941),
    [sym_scope] = ACTIONS(4941),
    [sym_shared] = ACTIONS(4941),
    [sym_static] = ACTIONS(4941),
    [sym_struct] = ACTIONS(4941),
    [sym_switch] = ACTIONS(4941),
    [sym_synchronized] = ACTIONS(4941),
    [sym_template] = ACTIONS(4941),
    [sym_throw] = ACTIONS(4941),
    [sym_try] = ACTIONS(4941),
    [sym_typeid] = ACTIONS(4941),
    [sym_typeof] = ACTIONS(4941),
    [sym_union] = ACTIONS(4941),
    [sym_unittest] = ACTIONS(4941),
    [sym_version] = ACTIONS(4941),
    [sym_while] = ACTIONS(4941),
    [sym_with] = ACTIONS(4941),
    [sym_gshared] = ACTIONS(4941),
    [sym_traits] = ACTIONS(4941),
    [sym_vector] = ACTIONS(4941),
    [sym_void] = ACTIONS(4941),
    [anon_sym_BQUOTE] = ACTIONS(4943),
    [anon_sym_r_DQUOTE] = ACTIONS(4943),
    [anon_sym_x_DQUOTE] = ACTIONS(4943),
    [anon_sym_DQUOTE] = ACTIONS(4943),
    [anon_sym_i_BQUOTE] = ACTIONS(4943),
    [anon_sym_i_DQUOTE] = ACTIONS(4943),
    [anon_sym_iq_LBRACE] = ACTIONS(4943),
    [aux_sym_char_literal_token1] = ACTIONS(4943),
    [anon_sym_SQUOTE] = ACTIONS(4941),
    [anon_sym___DATE__] = ACTIONS(4941),
    [anon_sym___FILE__] = ACTIONS(4941),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4941),
    [anon_sym___FUNCTION__] = ACTIONS(4941),
    [anon_sym___LINE__] = ACTIONS(4941),
    [anon_sym___MODULE__] = ACTIONS(4941),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4941),
    [anon_sym___TIME__] = ACTIONS(4941),
    [anon_sym___TIMESTAMP__] = ACTIONS(4941),
    [anon_sym___VENDOR__] = ACTIONS(4941),
    [anon_sym___VERSION__] = ACTIONS(4941),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4943),
    [sym_float_literal] = ACTIONS(4943),
    [sym__string] = ACTIONS(4943),
  },
  [1494] = {
    [sym_identifier] = ACTIONS(4945),
    [anon_sym_q_LBRACE] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym_LBRACE] = ACTIONS(4947),
    [anon_sym_DOT] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4947),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_DASH_DASH] = ACTIONS(4947),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4947),
    [anon_sym_BANG] = ACTIONS(4947),
    [anon_sym_LPAREN] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_LBRACK] = ACTIONS(4947),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4947),
    [anon_sym_AT] = ACTIONS(4947),
    [sym_bool] = ACTIONS(4945),
    [sym_byte] = ACTIONS(4945),
    [sym_ubyte] = ACTIONS(4945),
    [sym_char] = ACTIONS(4945),
    [sym_short] = ACTIONS(4945),
    [sym_ushort] = ACTIONS(4945),
    [sym_int] = ACTIONS(4945),
    [sym_uint] = ACTIONS(4945),
    [sym_long] = ACTIONS(4945),
    [sym_ulong] = ACTIONS(4945),
    [sym_cent] = ACTIONS(4945),
    [sym_ucent] = ACTIONS(4945),
    [sym_wchar] = ACTIONS(4945),
    [sym_dchar] = ACTIONS(4945),
    [sym_float] = ACTIONS(4945),
    [sym_double] = ACTIONS(4945),
    [sym_real] = ACTIONS(4945),
    [sym_ifloat] = ACTIONS(4945),
    [sym_idouble] = ACTIONS(4945),
    [sym_ireal] = ACTIONS(4945),
    [sym_cfloat] = ACTIONS(4945),
    [sym_cdouble] = ACTIONS(4945),
    [sym_creal] = ACTIONS(4945),
    [sym_size_t] = ACTIONS(4945),
    [sym_ptrdiff_t] = ACTIONS(4945),
    [sym_string] = ACTIONS(4945),
    [sym_cstring] = ACTIONS(4945),
    [sym_dstring] = ACTIONS(4945),
    [sym_wstring] = ACTIONS(4945),
    [sym_noreturn] = ACTIONS(4945),
    [sym_true] = ACTIONS(4945),
    [sym_false] = ACTIONS(4945),
    [sym_null] = ACTIONS(4945),
    [sym_super] = ACTIONS(4945),
    [sym_this] = ACTIONS(4945),
    [sym_abstract] = ACTIONS(4945),
    [sym_alias] = ACTIONS(4945),
    [sym_align] = ACTIONS(4945),
    [sym_asm] = ACTIONS(4945),
    [sym_assert] = ACTIONS(4945),
    [sym_auto] = ACTIONS(4945),
    [sym_break] = ACTIONS(4945),
    [sym_case] = ACTIONS(4945),
    [sym_cast] = ACTIONS(4945),
    [sym_catch] = ACTIONS(4945),
    [sym_class] = ACTIONS(4945),
    [sym_const] = ACTIONS(4945),
    [sym_continue] = ACTIONS(4945),
    [sym_debug] = ACTIONS(4945),
    [sym_default] = ACTIONS(4945),
    [sym_delegate] = ACTIONS(4945),
    [sym_delete] = ACTIONS(4945),
    [sym_deprecated] = ACTIONS(4945),
    [sym_do] = ACTIONS(4945),
    [sym_else] = ACTIONS(4945),
    [sym_enum] = ACTIONS(4945),
    [sym_export] = ACTIONS(4945),
    [sym_extern] = ACTIONS(4945),
    [sym_final] = ACTIONS(4945),
    [sym_finally] = ACTIONS(4945),
    [sym_for] = ACTIONS(4945),
    [sym_foreach] = ACTIONS(4945),
    [sym_foreach_reverse] = ACTIONS(4945),
    [sym_function] = ACTIONS(4945),
    [sym_goto] = ACTIONS(4945),
    [sym_if] = ACTIONS(4945),
    [sym_immutable] = ACTIONS(4945),
    [sym_import] = ACTIONS(4945),
    [sym_in] = ACTIONS(4945),
    [sym_inout] = ACTIONS(4945),
    [sym_interface] = ACTIONS(4945),
    [sym_invariant] = ACTIONS(4945),
    [sym_is] = ACTIONS(4945),
    [sym_mixin] = ACTIONS(4945),
    [sym_new] = ACTIONS(4945),
    [sym_nothrow] = ACTIONS(4945),
    [sym_out] = ACTIONS(4945),
    [sym_override] = ACTIONS(4945),
    [sym_package] = ACTIONS(4945),
    [sym_pragma] = ACTIONS(4945),
    [sym_private] = ACTIONS(4945),
    [sym_protected] = ACTIONS(4945),
    [sym_public] = ACTIONS(4945),
    [sym_pure] = ACTIONS(4945),
    [sym_ref] = ACTIONS(4945),
    [sym_return] = ACTIONS(4945),
    [sym_scope] = ACTIONS(4945),
    [sym_shared] = ACTIONS(4945),
    [sym_static] = ACTIONS(4945),
    [sym_struct] = ACTIONS(4945),
    [sym_switch] = ACTIONS(4945),
    [sym_synchronized] = ACTIONS(4945),
    [sym_template] = ACTIONS(4945),
    [sym_throw] = ACTIONS(4945),
    [sym_try] = ACTIONS(4945),
    [sym_typeid] = ACTIONS(4945),
    [sym_typeof] = ACTIONS(4945),
    [sym_union] = ACTIONS(4945),
    [sym_unittest] = ACTIONS(4945),
    [sym_version] = ACTIONS(4945),
    [sym_while] = ACTIONS(4945),
    [sym_with] = ACTIONS(4945),
    [sym_gshared] = ACTIONS(4945),
    [sym_traits] = ACTIONS(4945),
    [sym_vector] = ACTIONS(4945),
    [sym_void] = ACTIONS(4945),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_r_DQUOTE] = ACTIONS(4947),
    [anon_sym_x_DQUOTE] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_i_BQUOTE] = ACTIONS(4947),
    [anon_sym_i_DQUOTE] = ACTIONS(4947),
    [anon_sym_iq_LBRACE] = ACTIONS(4947),
    [aux_sym_char_literal_token1] = ACTIONS(4947),
    [anon_sym_SQUOTE] = ACTIONS(4945),
    [anon_sym___DATE__] = ACTIONS(4945),
    [anon_sym___FILE__] = ACTIONS(4945),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4945),
    [anon_sym___FUNCTION__] = ACTIONS(4945),
    [anon_sym___LINE__] = ACTIONS(4945),
    [anon_sym___MODULE__] = ACTIONS(4945),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4945),
    [anon_sym___TIME__] = ACTIONS(4945),
    [anon_sym___TIMESTAMP__] = ACTIONS(4945),
    [anon_sym___VENDOR__] = ACTIONS(4945),
    [anon_sym___VERSION__] = ACTIONS(4945),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4947),
    [sym_float_literal] = ACTIONS(4947),
    [sym__string] = ACTIONS(4947),
  },
  [1495] = {
    [sym_identifier] = ACTIONS(4949),
    [anon_sym_q_LBRACE] = ACTIONS(4951),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4951),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4949),
    [anon_sym_DASH_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4949),
    [anon_sym_PLUS_PLUS] = ACTIONS(4951),
    [anon_sym_BANG] = ACTIONS(4951),
    [anon_sym_LPAREN] = ACTIONS(4951),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_TILDE] = ACTIONS(4951),
    [anon_sym_AT] = ACTIONS(4951),
    [sym_bool] = ACTIONS(4949),
    [sym_byte] = ACTIONS(4949),
    [sym_ubyte] = ACTIONS(4949),
    [sym_char] = ACTIONS(4949),
    [sym_short] = ACTIONS(4949),
    [sym_ushort] = ACTIONS(4949),
    [sym_int] = ACTIONS(4949),
    [sym_uint] = ACTIONS(4949),
    [sym_long] = ACTIONS(4949),
    [sym_ulong] = ACTIONS(4949),
    [sym_cent] = ACTIONS(4949),
    [sym_ucent] = ACTIONS(4949),
    [sym_wchar] = ACTIONS(4949),
    [sym_dchar] = ACTIONS(4949),
    [sym_float] = ACTIONS(4949),
    [sym_double] = ACTIONS(4949),
    [sym_real] = ACTIONS(4949),
    [sym_ifloat] = ACTIONS(4949),
    [sym_idouble] = ACTIONS(4949),
    [sym_ireal] = ACTIONS(4949),
    [sym_cfloat] = ACTIONS(4949),
    [sym_cdouble] = ACTIONS(4949),
    [sym_creal] = ACTIONS(4949),
    [sym_size_t] = ACTIONS(4949),
    [sym_ptrdiff_t] = ACTIONS(4949),
    [sym_string] = ACTIONS(4949),
    [sym_cstring] = ACTIONS(4949),
    [sym_dstring] = ACTIONS(4949),
    [sym_wstring] = ACTIONS(4949),
    [sym_noreturn] = ACTIONS(4949),
    [sym_true] = ACTIONS(4949),
    [sym_false] = ACTIONS(4949),
    [sym_null] = ACTIONS(4949),
    [sym_super] = ACTIONS(4949),
    [sym_this] = ACTIONS(4949),
    [sym_abstract] = ACTIONS(4949),
    [sym_alias] = ACTIONS(4949),
    [sym_align] = ACTIONS(4949),
    [sym_asm] = ACTIONS(4949),
    [sym_assert] = ACTIONS(4949),
    [sym_auto] = ACTIONS(4949),
    [sym_break] = ACTIONS(4949),
    [sym_case] = ACTIONS(4949),
    [sym_cast] = ACTIONS(4949),
    [sym_catch] = ACTIONS(4949),
    [sym_class] = ACTIONS(4949),
    [sym_const] = ACTIONS(4949),
    [sym_continue] = ACTIONS(4949),
    [sym_debug] = ACTIONS(4949),
    [sym_default] = ACTIONS(4949),
    [sym_delegate] = ACTIONS(4949),
    [sym_delete] = ACTIONS(4949),
    [sym_deprecated] = ACTIONS(4949),
    [sym_do] = ACTIONS(4949),
    [sym_else] = ACTIONS(4949),
    [sym_enum] = ACTIONS(4949),
    [sym_export] = ACTIONS(4949),
    [sym_extern] = ACTIONS(4949),
    [sym_final] = ACTIONS(4949),
    [sym_finally] = ACTIONS(4949),
    [sym_for] = ACTIONS(4949),
    [sym_foreach] = ACTIONS(4949),
    [sym_foreach_reverse] = ACTIONS(4949),
    [sym_function] = ACTIONS(4949),
    [sym_goto] = ACTIONS(4949),
    [sym_if] = ACTIONS(4949),
    [sym_immutable] = ACTIONS(4949),
    [sym_import] = ACTIONS(4949),
    [sym_in] = ACTIONS(4949),
    [sym_inout] = ACTIONS(4949),
    [sym_interface] = ACTIONS(4949),
    [sym_invariant] = ACTIONS(4949),
    [sym_is] = ACTIONS(4949),
    [sym_mixin] = ACTIONS(4949),
    [sym_new] = ACTIONS(4949),
    [sym_nothrow] = ACTIONS(4949),
    [sym_out] = ACTIONS(4949),
    [sym_override] = ACTIONS(4949),
    [sym_package] = ACTIONS(4949),
    [sym_pragma] = ACTIONS(4949),
    [sym_private] = ACTIONS(4949),
    [sym_protected] = ACTIONS(4949),
    [sym_public] = ACTIONS(4949),
    [sym_pure] = ACTIONS(4949),
    [sym_ref] = ACTIONS(4949),
    [sym_return] = ACTIONS(4949),
    [sym_scope] = ACTIONS(4949),
    [sym_shared] = ACTIONS(4949),
    [sym_static] = ACTIONS(4949),
    [sym_struct] = ACTIONS(4949),
    [sym_switch] = ACTIONS(4949),
    [sym_synchronized] = ACTIONS(4949),
    [sym_template] = ACTIONS(4949),
    [sym_throw] = ACTIONS(4949),
    [sym_try] = ACTIONS(4949),
    [sym_typeid] = ACTIONS(4949),
    [sym_typeof] = ACTIONS(4949),
    [sym_union] = ACTIONS(4949),
    [sym_unittest] = ACTIONS(4949),
    [sym_version] = ACTIONS(4949),
    [sym_while] = ACTIONS(4949),
    [sym_with] = ACTIONS(4949),
    [sym_gshared] = ACTIONS(4949),
    [sym_traits] = ACTIONS(4949),
    [sym_vector] = ACTIONS(4949),
    [sym_void] = ACTIONS(4949),
    [anon_sym_BQUOTE] = ACTIONS(4951),
    [anon_sym_r_DQUOTE] = ACTIONS(4951),
    [anon_sym_x_DQUOTE] = ACTIONS(4951),
    [anon_sym_DQUOTE] = ACTIONS(4951),
    [anon_sym_i_BQUOTE] = ACTIONS(4951),
    [anon_sym_i_DQUOTE] = ACTIONS(4951),
    [anon_sym_iq_LBRACE] = ACTIONS(4951),
    [aux_sym_char_literal_token1] = ACTIONS(4951),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [anon_sym___DATE__] = ACTIONS(4949),
    [anon_sym___FILE__] = ACTIONS(4949),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4949),
    [anon_sym___FUNCTION__] = ACTIONS(4949),
    [anon_sym___LINE__] = ACTIONS(4949),
    [anon_sym___MODULE__] = ACTIONS(4949),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4949),
    [anon_sym___TIME__] = ACTIONS(4949),
    [anon_sym___TIMESTAMP__] = ACTIONS(4949),
    [anon_sym___VENDOR__] = ACTIONS(4949),
    [anon_sym___VERSION__] = ACTIONS(4949),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4951),
    [sym_float_literal] = ACTIONS(4951),
    [sym__string] = ACTIONS(4951),
  },
  [1496] = {
    [sym_identifier] = ACTIONS(4953),
    [anon_sym_q_LBRACE] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4955),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_DASH] = ACTIONS(4953),
    [anon_sym_DASH_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4955),
    [anon_sym_BANG] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [anon_sym_AT] = ACTIONS(4955),
    [sym_bool] = ACTIONS(4953),
    [sym_byte] = ACTIONS(4953),
    [sym_ubyte] = ACTIONS(4953),
    [sym_char] = ACTIONS(4953),
    [sym_short] = ACTIONS(4953),
    [sym_ushort] = ACTIONS(4953),
    [sym_int] = ACTIONS(4953),
    [sym_uint] = ACTIONS(4953),
    [sym_long] = ACTIONS(4953),
    [sym_ulong] = ACTIONS(4953),
    [sym_cent] = ACTIONS(4953),
    [sym_ucent] = ACTIONS(4953),
    [sym_wchar] = ACTIONS(4953),
    [sym_dchar] = ACTIONS(4953),
    [sym_float] = ACTIONS(4953),
    [sym_double] = ACTIONS(4953),
    [sym_real] = ACTIONS(4953),
    [sym_ifloat] = ACTIONS(4953),
    [sym_idouble] = ACTIONS(4953),
    [sym_ireal] = ACTIONS(4953),
    [sym_cfloat] = ACTIONS(4953),
    [sym_cdouble] = ACTIONS(4953),
    [sym_creal] = ACTIONS(4953),
    [sym_size_t] = ACTIONS(4953),
    [sym_ptrdiff_t] = ACTIONS(4953),
    [sym_string] = ACTIONS(4953),
    [sym_cstring] = ACTIONS(4953),
    [sym_dstring] = ACTIONS(4953),
    [sym_wstring] = ACTIONS(4953),
    [sym_noreturn] = ACTIONS(4953),
    [sym_true] = ACTIONS(4953),
    [sym_false] = ACTIONS(4953),
    [sym_null] = ACTIONS(4953),
    [sym_super] = ACTIONS(4953),
    [sym_this] = ACTIONS(4953),
    [sym_abstract] = ACTIONS(4953),
    [sym_alias] = ACTIONS(4953),
    [sym_align] = ACTIONS(4953),
    [sym_asm] = ACTIONS(4953),
    [sym_assert] = ACTIONS(4953),
    [sym_auto] = ACTIONS(4953),
    [sym_break] = ACTIONS(4953),
    [sym_case] = ACTIONS(4953),
    [sym_cast] = ACTIONS(4953),
    [sym_catch] = ACTIONS(4953),
    [sym_class] = ACTIONS(4953),
    [sym_const] = ACTIONS(4953),
    [sym_continue] = ACTIONS(4953),
    [sym_debug] = ACTIONS(4953),
    [sym_default] = ACTIONS(4953),
    [sym_delegate] = ACTIONS(4953),
    [sym_delete] = ACTIONS(4953),
    [sym_deprecated] = ACTIONS(4953),
    [sym_do] = ACTIONS(4953),
    [sym_else] = ACTIONS(4953),
    [sym_enum] = ACTIONS(4953),
    [sym_export] = ACTIONS(4953),
    [sym_extern] = ACTIONS(4953),
    [sym_final] = ACTIONS(4953),
    [sym_finally] = ACTIONS(4953),
    [sym_for] = ACTIONS(4953),
    [sym_foreach] = ACTIONS(4953),
    [sym_foreach_reverse] = ACTIONS(4953),
    [sym_function] = ACTIONS(4953),
    [sym_goto] = ACTIONS(4953),
    [sym_if] = ACTIONS(4953),
    [sym_immutable] = ACTIONS(4953),
    [sym_import] = ACTIONS(4953),
    [sym_in] = ACTIONS(4953),
    [sym_inout] = ACTIONS(4953),
    [sym_interface] = ACTIONS(4953),
    [sym_invariant] = ACTIONS(4953),
    [sym_is] = ACTIONS(4953),
    [sym_mixin] = ACTIONS(4953),
    [sym_new] = ACTIONS(4953),
    [sym_nothrow] = ACTIONS(4953),
    [sym_out] = ACTIONS(4953),
    [sym_override] = ACTIONS(4953),
    [sym_package] = ACTIONS(4953),
    [sym_pragma] = ACTIONS(4953),
    [sym_private] = ACTIONS(4953),
    [sym_protected] = ACTIONS(4953),
    [sym_public] = ACTIONS(4953),
    [sym_pure] = ACTIONS(4953),
    [sym_ref] = ACTIONS(4953),
    [sym_return] = ACTIONS(4953),
    [sym_scope] = ACTIONS(4953),
    [sym_shared] = ACTIONS(4953),
    [sym_static] = ACTIONS(4953),
    [sym_struct] = ACTIONS(4953),
    [sym_switch] = ACTIONS(4953),
    [sym_synchronized] = ACTIONS(4953),
    [sym_template] = ACTIONS(4953),
    [sym_throw] = ACTIONS(4953),
    [sym_try] = ACTIONS(4953),
    [sym_typeid] = ACTIONS(4953),
    [sym_typeof] = ACTIONS(4953),
    [sym_union] = ACTIONS(4953),
    [sym_unittest] = ACTIONS(4953),
    [sym_version] = ACTIONS(4953),
    [sym_while] = ACTIONS(4953),
    [sym_with] = ACTIONS(4953),
    [sym_gshared] = ACTIONS(4953),
    [sym_traits] = ACTIONS(4953),
    [sym_vector] = ACTIONS(4953),
    [sym_void] = ACTIONS(4953),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_r_DQUOTE] = ACTIONS(4955),
    [anon_sym_x_DQUOTE] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_i_BQUOTE] = ACTIONS(4955),
    [anon_sym_i_DQUOTE] = ACTIONS(4955),
    [anon_sym_iq_LBRACE] = ACTIONS(4955),
    [aux_sym_char_literal_token1] = ACTIONS(4955),
    [anon_sym_SQUOTE] = ACTIONS(4953),
    [anon_sym___DATE__] = ACTIONS(4953),
    [anon_sym___FILE__] = ACTIONS(4953),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4953),
    [anon_sym___FUNCTION__] = ACTIONS(4953),
    [anon_sym___LINE__] = ACTIONS(4953),
    [anon_sym___MODULE__] = ACTIONS(4953),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4953),
    [anon_sym___TIME__] = ACTIONS(4953),
    [anon_sym___TIMESTAMP__] = ACTIONS(4953),
    [anon_sym___VENDOR__] = ACTIONS(4953),
    [anon_sym___VERSION__] = ACTIONS(4953),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4955),
    [sym_float_literal] = ACTIONS(4955),
    [sym__string] = ACTIONS(4955),
  },
  [1497] = {
    [sym_identifier] = ACTIONS(4957),
    [anon_sym_q_LBRACE] = ACTIONS(4959),
    [anon_sym_RBRACE] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4959),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_DASH] = ACTIONS(4957),
    [anon_sym_DASH_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4959),
    [anon_sym_BANG] = ACTIONS(4959),
    [anon_sym_LPAREN] = ACTIONS(4959),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_TILDE] = ACTIONS(4959),
    [anon_sym_AT] = ACTIONS(4959),
    [sym_bool] = ACTIONS(4957),
    [sym_byte] = ACTIONS(4957),
    [sym_ubyte] = ACTIONS(4957),
    [sym_char] = ACTIONS(4957),
    [sym_short] = ACTIONS(4957),
    [sym_ushort] = ACTIONS(4957),
    [sym_int] = ACTIONS(4957),
    [sym_uint] = ACTIONS(4957),
    [sym_long] = ACTIONS(4957),
    [sym_ulong] = ACTIONS(4957),
    [sym_cent] = ACTIONS(4957),
    [sym_ucent] = ACTIONS(4957),
    [sym_wchar] = ACTIONS(4957),
    [sym_dchar] = ACTIONS(4957),
    [sym_float] = ACTIONS(4957),
    [sym_double] = ACTIONS(4957),
    [sym_real] = ACTIONS(4957),
    [sym_ifloat] = ACTIONS(4957),
    [sym_idouble] = ACTIONS(4957),
    [sym_ireal] = ACTIONS(4957),
    [sym_cfloat] = ACTIONS(4957),
    [sym_cdouble] = ACTIONS(4957),
    [sym_creal] = ACTIONS(4957),
    [sym_size_t] = ACTIONS(4957),
    [sym_ptrdiff_t] = ACTIONS(4957),
    [sym_string] = ACTIONS(4957),
    [sym_cstring] = ACTIONS(4957),
    [sym_dstring] = ACTIONS(4957),
    [sym_wstring] = ACTIONS(4957),
    [sym_noreturn] = ACTIONS(4957),
    [sym_true] = ACTIONS(4957),
    [sym_false] = ACTIONS(4957),
    [sym_null] = ACTIONS(4957),
    [sym_super] = ACTIONS(4957),
    [sym_this] = ACTIONS(4957),
    [sym_abstract] = ACTIONS(4957),
    [sym_alias] = ACTIONS(4957),
    [sym_align] = ACTIONS(4957),
    [sym_asm] = ACTIONS(4957),
    [sym_assert] = ACTIONS(4957),
    [sym_auto] = ACTIONS(4957),
    [sym_break] = ACTIONS(4957),
    [sym_case] = ACTIONS(4957),
    [sym_cast] = ACTIONS(4957),
    [sym_catch] = ACTIONS(4957),
    [sym_class] = ACTIONS(4957),
    [sym_const] = ACTIONS(4957),
    [sym_continue] = ACTIONS(4957),
    [sym_debug] = ACTIONS(4957),
    [sym_default] = ACTIONS(4957),
    [sym_delegate] = ACTIONS(4957),
    [sym_delete] = ACTIONS(4957),
    [sym_deprecated] = ACTIONS(4957),
    [sym_do] = ACTIONS(4957),
    [sym_else] = ACTIONS(4957),
    [sym_enum] = ACTIONS(4957),
    [sym_export] = ACTIONS(4957),
    [sym_extern] = ACTIONS(4957),
    [sym_final] = ACTIONS(4957),
    [sym_finally] = ACTIONS(4957),
    [sym_for] = ACTIONS(4957),
    [sym_foreach] = ACTIONS(4957),
    [sym_foreach_reverse] = ACTIONS(4957),
    [sym_function] = ACTIONS(4957),
    [sym_goto] = ACTIONS(4957),
    [sym_if] = ACTIONS(4957),
    [sym_immutable] = ACTIONS(4957),
    [sym_import] = ACTIONS(4957),
    [sym_in] = ACTIONS(4957),
    [sym_inout] = ACTIONS(4957),
    [sym_interface] = ACTIONS(4957),
    [sym_invariant] = ACTIONS(4957),
    [sym_is] = ACTIONS(4957),
    [sym_mixin] = ACTIONS(4957),
    [sym_new] = ACTIONS(4957),
    [sym_nothrow] = ACTIONS(4957),
    [sym_out] = ACTIONS(4957),
    [sym_override] = ACTIONS(4957),
    [sym_package] = ACTIONS(4957),
    [sym_pragma] = ACTIONS(4957),
    [sym_private] = ACTIONS(4957),
    [sym_protected] = ACTIONS(4957),
    [sym_public] = ACTIONS(4957),
    [sym_pure] = ACTIONS(4957),
    [sym_ref] = ACTIONS(4957),
    [sym_return] = ACTIONS(4957),
    [sym_scope] = ACTIONS(4957),
    [sym_shared] = ACTIONS(4957),
    [sym_static] = ACTIONS(4957),
    [sym_struct] = ACTIONS(4957),
    [sym_switch] = ACTIONS(4957),
    [sym_synchronized] = ACTIONS(4957),
    [sym_template] = ACTIONS(4957),
    [sym_throw] = ACTIONS(4957),
    [sym_try] = ACTIONS(4957),
    [sym_typeid] = ACTIONS(4957),
    [sym_typeof] = ACTIONS(4957),
    [sym_union] = ACTIONS(4957),
    [sym_unittest] = ACTIONS(4957),
    [sym_version] = ACTIONS(4957),
    [sym_while] = ACTIONS(4957),
    [sym_with] = ACTIONS(4957),
    [sym_gshared] = ACTIONS(4957),
    [sym_traits] = ACTIONS(4957),
    [sym_vector] = ACTIONS(4957),
    [sym_void] = ACTIONS(4957),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_r_DQUOTE] = ACTIONS(4959),
    [anon_sym_x_DQUOTE] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_i_BQUOTE] = ACTIONS(4959),
    [anon_sym_i_DQUOTE] = ACTIONS(4959),
    [anon_sym_iq_LBRACE] = ACTIONS(4959),
    [aux_sym_char_literal_token1] = ACTIONS(4959),
    [anon_sym_SQUOTE] = ACTIONS(4957),
    [anon_sym___DATE__] = ACTIONS(4957),
    [anon_sym___FILE__] = ACTIONS(4957),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4957),
    [anon_sym___FUNCTION__] = ACTIONS(4957),
    [anon_sym___LINE__] = ACTIONS(4957),
    [anon_sym___MODULE__] = ACTIONS(4957),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4957),
    [anon_sym___TIME__] = ACTIONS(4957),
    [anon_sym___TIMESTAMP__] = ACTIONS(4957),
    [anon_sym___VENDOR__] = ACTIONS(4957),
    [anon_sym___VERSION__] = ACTIONS(4957),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4959),
    [sym_float_literal] = ACTIONS(4959),
    [sym__string] = ACTIONS(4959),
  },
  [1498] = {
    [sym_identifier] = ACTIONS(4961),
    [anon_sym_q_LBRACE] = ACTIONS(4963),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4963),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_DASH_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4963),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [anon_sym_RPAREN] = ACTIONS(4963),
    [anon_sym_LBRACK] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4963),
    [anon_sym_DOLLAR] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [anon_sym_AT] = ACTIONS(4963),
    [sym_bool] = ACTIONS(4961),
    [sym_byte] = ACTIONS(4961),
    [sym_ubyte] = ACTIONS(4961),
    [sym_char] = ACTIONS(4961),
    [sym_short] = ACTIONS(4961),
    [sym_ushort] = ACTIONS(4961),
    [sym_int] = ACTIONS(4961),
    [sym_uint] = ACTIONS(4961),
    [sym_long] = ACTIONS(4961),
    [sym_ulong] = ACTIONS(4961),
    [sym_cent] = ACTIONS(4961),
    [sym_ucent] = ACTIONS(4961),
    [sym_wchar] = ACTIONS(4961),
    [sym_dchar] = ACTIONS(4961),
    [sym_float] = ACTIONS(4961),
    [sym_double] = ACTIONS(4961),
    [sym_real] = ACTIONS(4961),
    [sym_ifloat] = ACTIONS(4961),
    [sym_idouble] = ACTIONS(4961),
    [sym_ireal] = ACTIONS(4961),
    [sym_cfloat] = ACTIONS(4961),
    [sym_cdouble] = ACTIONS(4961),
    [sym_creal] = ACTIONS(4961),
    [sym_size_t] = ACTIONS(4961),
    [sym_ptrdiff_t] = ACTIONS(4961),
    [sym_string] = ACTIONS(4961),
    [sym_cstring] = ACTIONS(4961),
    [sym_dstring] = ACTIONS(4961),
    [sym_wstring] = ACTIONS(4961),
    [sym_noreturn] = ACTIONS(4961),
    [sym_true] = ACTIONS(4961),
    [sym_false] = ACTIONS(4961),
    [sym_null] = ACTIONS(4961),
    [sym_super] = ACTIONS(4961),
    [sym_this] = ACTIONS(4961),
    [sym_abstract] = ACTIONS(4961),
    [sym_alias] = ACTIONS(4961),
    [sym_align] = ACTIONS(4961),
    [sym_asm] = ACTIONS(4961),
    [sym_assert] = ACTIONS(4961),
    [sym_auto] = ACTIONS(4961),
    [sym_break] = ACTIONS(4961),
    [sym_case] = ACTIONS(4961),
    [sym_cast] = ACTIONS(4961),
    [sym_catch] = ACTIONS(4961),
    [sym_class] = ACTIONS(4961),
    [sym_const] = ACTIONS(4961),
    [sym_continue] = ACTIONS(4961),
    [sym_debug] = ACTIONS(4961),
    [sym_default] = ACTIONS(4961),
    [sym_delegate] = ACTIONS(4961),
    [sym_delete] = ACTIONS(4961),
    [sym_deprecated] = ACTIONS(4961),
    [sym_do] = ACTIONS(4961),
    [sym_else] = ACTIONS(4961),
    [sym_enum] = ACTIONS(4961),
    [sym_export] = ACTIONS(4961),
    [sym_extern] = ACTIONS(4961),
    [sym_final] = ACTIONS(4961),
    [sym_finally] = ACTIONS(4961),
    [sym_for] = ACTIONS(4961),
    [sym_foreach] = ACTIONS(4961),
    [sym_foreach_reverse] = ACTIONS(4961),
    [sym_function] = ACTIONS(4961),
    [sym_goto] = ACTIONS(4961),
    [sym_if] = ACTIONS(4961),
    [sym_immutable] = ACTIONS(4961),
    [sym_import] = ACTIONS(4961),
    [sym_in] = ACTIONS(4961),
    [sym_inout] = ACTIONS(4961),
    [sym_interface] = ACTIONS(4961),
    [sym_invariant] = ACTIONS(4961),
    [sym_is] = ACTIONS(4961),
    [sym_mixin] = ACTIONS(4961),
    [sym_new] = ACTIONS(4961),
    [sym_nothrow] = ACTIONS(4961),
    [sym_out] = ACTIONS(4961),
    [sym_override] = ACTIONS(4961),
    [sym_package] = ACTIONS(4961),
    [sym_pragma] = ACTIONS(4961),
    [sym_private] = ACTIONS(4961),
    [sym_protected] = ACTIONS(4961),
    [sym_public] = ACTIONS(4961),
    [sym_pure] = ACTIONS(4961),
    [sym_ref] = ACTIONS(4961),
    [sym_return] = ACTIONS(4961),
    [sym_scope] = ACTIONS(4961),
    [sym_shared] = ACTIONS(4961),
    [sym_static] = ACTIONS(4961),
    [sym_struct] = ACTIONS(4961),
    [sym_switch] = ACTIONS(4961),
    [sym_synchronized] = ACTIONS(4961),
    [sym_template] = ACTIONS(4961),
    [sym_throw] = ACTIONS(4961),
    [sym_try] = ACTIONS(4961),
    [sym_typeid] = ACTIONS(4961),
    [sym_typeof] = ACTIONS(4961),
    [sym_union] = ACTIONS(4961),
    [sym_unittest] = ACTIONS(4961),
    [sym_version] = ACTIONS(4961),
    [sym_while] = ACTIONS(4961),
    [sym_with] = ACTIONS(4961),
    [sym_gshared] = ACTIONS(4961),
    [sym_traits] = ACTIONS(4961),
    [sym_vector] = ACTIONS(4961),
    [sym_void] = ACTIONS(4961),
    [anon_sym_BQUOTE] = ACTIONS(4963),
    [anon_sym_r_DQUOTE] = ACTIONS(4963),
    [anon_sym_x_DQUOTE] = ACTIONS(4963),
    [anon_sym_DQUOTE] = ACTIONS(4963),
    [anon_sym_i_BQUOTE] = ACTIONS(4963),
    [anon_sym_i_DQUOTE] = ACTIONS(4963),
    [anon_sym_iq_LBRACE] = ACTIONS(4963),
    [aux_sym_char_literal_token1] = ACTIONS(4963),
    [anon_sym_SQUOTE] = ACTIONS(4961),
    [anon_sym___DATE__] = ACTIONS(4961),
    [anon_sym___FILE__] = ACTIONS(4961),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4961),
    [anon_sym___FUNCTION__] = ACTIONS(4961),
    [anon_sym___LINE__] = ACTIONS(4961),
    [anon_sym___MODULE__] = ACTIONS(4961),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4961),
    [anon_sym___TIME__] = ACTIONS(4961),
    [anon_sym___TIMESTAMP__] = ACTIONS(4961),
    [anon_sym___VENDOR__] = ACTIONS(4961),
    [anon_sym___VERSION__] = ACTIONS(4961),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4963),
    [sym_float_literal] = ACTIONS(4963),
    [sym__string] = ACTIONS(4963),
  },
  [1499] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_q_LBRACE] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_DASH_DASH] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_PLUS_PLUS] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_DOLLAR] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_true] = ACTIONS(4879),
    [sym_false] = ACTIONS(4879),
    [sym_null] = ACTIONS(4879),
    [sym_super] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_asm] = ACTIONS(4879),
    [sym_assert] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_break] = ACTIONS(4879),
    [sym_case] = ACTIONS(4879),
    [sym_cast] = ACTIONS(4879),
    [sym_catch] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_continue] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_default] = ACTIONS(4879),
    [sym_delegate] = ACTIONS(4879),
    [sym_delete] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_do] = ACTIONS(4968),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_finally] = ACTIONS(4879),
    [sym_for] = ACTIONS(4879),
    [sym_foreach] = ACTIONS(4879),
    [sym_foreach_reverse] = ACTIONS(4879),
    [sym_function] = ACTIONS(4879),
    [sym_goto] = ACTIONS(4879),
    [sym_if] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(4968),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_is] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_new] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_out] = ACTIONS(4968),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_switch] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_throw] = ACTIONS(4879),
    [sym_try] = ACTIONS(4879),
    [sym_typeid] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_with] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [anon_sym_BQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [anon_sym_x_DQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_i_BQUOTE] = ACTIONS(4881),
    [anon_sym_i_DQUOTE] = ACTIONS(4881),
    [anon_sym_iq_LBRACE] = ACTIONS(4881),
    [aux_sym_char_literal_token1] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4879),
    [anon_sym___DATE__] = ACTIONS(4879),
    [anon_sym___FILE__] = ACTIONS(4879),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4879),
    [anon_sym___FUNCTION__] = ACTIONS(4879),
    [anon_sym___LINE__] = ACTIONS(4879),
    [anon_sym___MODULE__] = ACTIONS(4879),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4879),
    [anon_sym___TIME__] = ACTIONS(4879),
    [anon_sym___TIMESTAMP__] = ACTIONS(4879),
    [anon_sym___VENDOR__] = ACTIONS(4879),
    [anon_sym___VERSION__] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym__string] = ACTIONS(4881),
  },
  [1500] = {
    [sym_identifier] = ACTIONS(4971),
    [anon_sym_q_LBRACE] = ACTIONS(4973),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4973),
    [anon_sym_DOT] = ACTIONS(4973),
    [anon_sym_AMP] = ACTIONS(4973),
    [anon_sym_DASH] = ACTIONS(4971),
    [anon_sym_DASH_DASH] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4971),
    [anon_sym_PLUS_PLUS] = ACTIONS(4973),
    [anon_sym_BANG] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4973),
    [anon_sym_RPAREN] = ACTIONS(4973),
    [anon_sym_LBRACK] = ACTIONS(4973),
    [anon_sym_SEMI] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4973),
    [anon_sym_STAR] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_AT] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4971),
    [sym_byte] = ACTIONS(4971),
    [sym_ubyte] = ACTIONS(4971),
    [sym_char] = ACTIONS(4971),
    [sym_short] = ACTIONS(4971),
    [sym_ushort] = ACTIONS(4971),
    [sym_int] = ACTIONS(4971),
    [sym_uint] = ACTIONS(4971),
    [sym_long] = ACTIONS(4971),
    [sym_ulong] = ACTIONS(4971),
    [sym_cent] = ACTIONS(4971),
    [sym_ucent] = ACTIONS(4971),
    [sym_wchar] = ACTIONS(4971),
    [sym_dchar] = ACTIONS(4971),
    [sym_float] = ACTIONS(4971),
    [sym_double] = ACTIONS(4971),
    [sym_real] = ACTIONS(4971),
    [sym_ifloat] = ACTIONS(4971),
    [sym_idouble] = ACTIONS(4971),
    [sym_ireal] = ACTIONS(4971),
    [sym_cfloat] = ACTIONS(4971),
    [sym_cdouble] = ACTIONS(4971),
    [sym_creal] = ACTIONS(4971),
    [sym_size_t] = ACTIONS(4971),
    [sym_ptrdiff_t] = ACTIONS(4971),
    [sym_string] = ACTIONS(4971),
    [sym_cstring] = ACTIONS(4971),
    [sym_dstring] = ACTIONS(4971),
    [sym_wstring] = ACTIONS(4971),
    [sym_noreturn] = ACTIONS(4971),
    [sym_true] = ACTIONS(4971),
    [sym_false] = ACTIONS(4971),
    [sym_null] = ACTIONS(4971),
    [sym_super] = ACTIONS(4971),
    [sym_this] = ACTIONS(4971),
    [sym_abstract] = ACTIONS(4971),
    [sym_alias] = ACTIONS(4971),
    [sym_align] = ACTIONS(4971),
    [sym_asm] = ACTIONS(4971),
    [sym_assert] = ACTIONS(4971),
    [sym_auto] = ACTIONS(4971),
    [sym_break] = ACTIONS(4971),
    [sym_case] = ACTIONS(4971),
    [sym_cast] = ACTIONS(4971),
    [sym_catch] = ACTIONS(4971),
    [sym_class] = ACTIONS(4971),
    [sym_const] = ACTIONS(4971),
    [sym_continue] = ACTIONS(4971),
    [sym_debug] = ACTIONS(4971),
    [sym_default] = ACTIONS(4971),
    [sym_delegate] = ACTIONS(4971),
    [sym_delete] = ACTIONS(4971),
    [sym_deprecated] = ACTIONS(4971),
    [sym_do] = ACTIONS(4971),
    [sym_else] = ACTIONS(4971),
    [sym_enum] = ACTIONS(4971),
    [sym_export] = ACTIONS(4971),
    [sym_extern] = ACTIONS(4971),
    [sym_final] = ACTIONS(4971),
    [sym_finally] = ACTIONS(4971),
    [sym_for] = ACTIONS(4971),
    [sym_foreach] = ACTIONS(4971),
    [sym_foreach_reverse] = ACTIONS(4971),
    [sym_function] = ACTIONS(4971),
    [sym_goto] = ACTIONS(4971),
    [sym_if] = ACTIONS(4971),
    [sym_immutable] = ACTIONS(4971),
    [sym_import] = ACTIONS(4971),
    [sym_in] = ACTIONS(4971),
    [sym_inout] = ACTIONS(4971),
    [sym_interface] = ACTIONS(4971),
    [sym_invariant] = ACTIONS(4971),
    [sym_is] = ACTIONS(4971),
    [sym_mixin] = ACTIONS(4971),
    [sym_new] = ACTIONS(4971),
    [sym_nothrow] = ACTIONS(4971),
    [sym_out] = ACTIONS(4971),
    [sym_override] = ACTIONS(4971),
    [sym_package] = ACTIONS(4971),
    [sym_pragma] = ACTIONS(4971),
    [sym_private] = ACTIONS(4971),
    [sym_protected] = ACTIONS(4971),
    [sym_public] = ACTIONS(4971),
    [sym_pure] = ACTIONS(4971),
    [sym_ref] = ACTIONS(4971),
    [sym_return] = ACTIONS(4971),
    [sym_scope] = ACTIONS(4971),
    [sym_shared] = ACTIONS(4971),
    [sym_static] = ACTIONS(4971),
    [sym_struct] = ACTIONS(4971),
    [sym_switch] = ACTIONS(4971),
    [sym_synchronized] = ACTIONS(4971),
    [sym_template] = ACTIONS(4971),
    [sym_throw] = ACTIONS(4971),
    [sym_try] = ACTIONS(4971),
    [sym_typeid] = ACTIONS(4971),
    [sym_typeof] = ACTIONS(4971),
    [sym_union] = ACTIONS(4971),
    [sym_unittest] = ACTIONS(4971),
    [sym_version] = ACTIONS(4971),
    [sym_while] = ACTIONS(4971),
    [sym_with] = ACTIONS(4971),
    [sym_gshared] = ACTIONS(4971),
    [sym_traits] = ACTIONS(4971),
    [sym_vector] = ACTIONS(4971),
    [sym_void] = ACTIONS(4971),
    [anon_sym_BQUOTE] = ACTIONS(4973),
    [anon_sym_r_DQUOTE] = ACTIONS(4973),
    [anon_sym_x_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_i_BQUOTE] = ACTIONS(4973),
    [anon_sym_i_DQUOTE] = ACTIONS(4973),
    [anon_sym_iq_LBRACE] = ACTIONS(4973),
    [aux_sym_char_literal_token1] = ACTIONS(4973),
    [anon_sym_SQUOTE] = ACTIONS(4971),
    [anon_sym___DATE__] = ACTIONS(4971),
    [anon_sym___FILE__] = ACTIONS(4971),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4971),
    [anon_sym___FUNCTION__] = ACTIONS(4971),
    [anon_sym___LINE__] = ACTIONS(4971),
    [anon_sym___MODULE__] = ACTIONS(4971),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4971),
    [anon_sym___TIME__] = ACTIONS(4971),
    [anon_sym___TIMESTAMP__] = ACTIONS(4971),
    [anon_sym___VENDOR__] = ACTIONS(4971),
    [anon_sym___VERSION__] = ACTIONS(4971),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4973),
    [sym_float_literal] = ACTIONS(4973),
    [sym__string] = ACTIONS(4973),
  },
  [1501] = {
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_q_LBRACE] = ACTIONS(4977),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_LBRACE] = ACTIONS(4977),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4977),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_PLUS_PLUS] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_LPAREN] = ACTIONS(4977),
    [anon_sym_RPAREN] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(4977),
    [anon_sym_SEMI] = ACTIONS(4977),
    [anon_sym_DOLLAR] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_TILDE] = ACTIONS(4977),
    [anon_sym_AT] = ACTIONS(4977),
    [sym_bool] = ACTIONS(4975),
    [sym_byte] = ACTIONS(4975),
    [sym_ubyte] = ACTIONS(4975),
    [sym_char] = ACTIONS(4975),
    [sym_short] = ACTIONS(4975),
    [sym_ushort] = ACTIONS(4975),
    [sym_int] = ACTIONS(4975),
    [sym_uint] = ACTIONS(4975),
    [sym_long] = ACTIONS(4975),
    [sym_ulong] = ACTIONS(4975),
    [sym_cent] = ACTIONS(4975),
    [sym_ucent] = ACTIONS(4975),
    [sym_wchar] = ACTIONS(4975),
    [sym_dchar] = ACTIONS(4975),
    [sym_float] = ACTIONS(4975),
    [sym_double] = ACTIONS(4975),
    [sym_real] = ACTIONS(4975),
    [sym_ifloat] = ACTIONS(4975),
    [sym_idouble] = ACTIONS(4975),
    [sym_ireal] = ACTIONS(4975),
    [sym_cfloat] = ACTIONS(4975),
    [sym_cdouble] = ACTIONS(4975),
    [sym_creal] = ACTIONS(4975),
    [sym_size_t] = ACTIONS(4975),
    [sym_ptrdiff_t] = ACTIONS(4975),
    [sym_string] = ACTIONS(4975),
    [sym_cstring] = ACTIONS(4975),
    [sym_dstring] = ACTIONS(4975),
    [sym_wstring] = ACTIONS(4975),
    [sym_noreturn] = ACTIONS(4975),
    [sym_true] = ACTIONS(4975),
    [sym_false] = ACTIONS(4975),
    [sym_null] = ACTIONS(4975),
    [sym_super] = ACTIONS(4975),
    [sym_this] = ACTIONS(4975),
    [sym_abstract] = ACTIONS(4975),
    [sym_alias] = ACTIONS(4975),
    [sym_align] = ACTIONS(4975),
    [sym_asm] = ACTIONS(4975),
    [sym_assert] = ACTIONS(4975),
    [sym_auto] = ACTIONS(4975),
    [sym_break] = ACTIONS(4975),
    [sym_case] = ACTIONS(4975),
    [sym_cast] = ACTIONS(4975),
    [sym_catch] = ACTIONS(4975),
    [sym_class] = ACTIONS(4975),
    [sym_const] = ACTIONS(4975),
    [sym_continue] = ACTIONS(4975),
    [sym_debug] = ACTIONS(4975),
    [sym_default] = ACTIONS(4975),
    [sym_delegate] = ACTIONS(4975),
    [sym_delete] = ACTIONS(4975),
    [sym_deprecated] = ACTIONS(4975),
    [sym_do] = ACTIONS(4975),
    [sym_else] = ACTIONS(4975),
    [sym_enum] = ACTIONS(4975),
    [sym_export] = ACTIONS(4975),
    [sym_extern] = ACTIONS(4975),
    [sym_final] = ACTIONS(4975),
    [sym_finally] = ACTIONS(4975),
    [sym_for] = ACTIONS(4975),
    [sym_foreach] = ACTIONS(4975),
    [sym_foreach_reverse] = ACTIONS(4975),
    [sym_function] = ACTIONS(4975),
    [sym_goto] = ACTIONS(4975),
    [sym_if] = ACTIONS(4975),
    [sym_immutable] = ACTIONS(4975),
    [sym_import] = ACTIONS(4975),
    [sym_in] = ACTIONS(4975),
    [sym_inout] = ACTIONS(4975),
    [sym_interface] = ACTIONS(4975),
    [sym_invariant] = ACTIONS(4975),
    [sym_is] = ACTIONS(4975),
    [sym_mixin] = ACTIONS(4975),
    [sym_new] = ACTIONS(4975),
    [sym_nothrow] = ACTIONS(4975),
    [sym_out] = ACTIONS(4975),
    [sym_override] = ACTIONS(4975),
    [sym_package] = ACTIONS(4975),
    [sym_pragma] = ACTIONS(4975),
    [sym_private] = ACTIONS(4975),
    [sym_protected] = ACTIONS(4975),
    [sym_public] = ACTIONS(4975),
    [sym_pure] = ACTIONS(4975),
    [sym_ref] = ACTIONS(4975),
    [sym_return] = ACTIONS(4975),
    [sym_scope] = ACTIONS(4975),
    [sym_shared] = ACTIONS(4975),
    [sym_static] = ACTIONS(4975),
    [sym_struct] = ACTIONS(4975),
    [sym_switch] = ACTIONS(4975),
    [sym_synchronized] = ACTIONS(4975),
    [sym_template] = ACTIONS(4975),
    [sym_throw] = ACTIONS(4975),
    [sym_try] = ACTIONS(4975),
    [sym_typeid] = ACTIONS(4975),
    [sym_typeof] = ACTIONS(4975),
    [sym_union] = ACTIONS(4975),
    [sym_unittest] = ACTIONS(4975),
    [sym_version] = ACTIONS(4975),
    [sym_while] = ACTIONS(4975),
    [sym_with] = ACTIONS(4975),
    [sym_gshared] = ACTIONS(4975),
    [sym_traits] = ACTIONS(4975),
    [sym_vector] = ACTIONS(4975),
    [sym_void] = ACTIONS(4975),
    [anon_sym_BQUOTE] = ACTIONS(4977),
    [anon_sym_r_DQUOTE] = ACTIONS(4977),
    [anon_sym_x_DQUOTE] = ACTIONS(4977),
    [anon_sym_DQUOTE] = ACTIONS(4977),
    [anon_sym_i_BQUOTE] = ACTIONS(4977),
    [anon_sym_i_DQUOTE] = ACTIONS(4977),
    [anon_sym_iq_LBRACE] = ACTIONS(4977),
    [aux_sym_char_literal_token1] = ACTIONS(4977),
    [anon_sym_SQUOTE] = ACTIONS(4975),
    [anon_sym___DATE__] = ACTIONS(4975),
    [anon_sym___FILE__] = ACTIONS(4975),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4975),
    [anon_sym___FUNCTION__] = ACTIONS(4975),
    [anon_sym___LINE__] = ACTIONS(4975),
    [anon_sym___MODULE__] = ACTIONS(4975),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4975),
    [anon_sym___TIME__] = ACTIONS(4975),
    [anon_sym___TIMESTAMP__] = ACTIONS(4975),
    [anon_sym___VENDOR__] = ACTIONS(4975),
    [anon_sym___VERSION__] = ACTIONS(4975),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4977),
    [sym_float_literal] = ACTIONS(4977),
    [sym__string] = ACTIONS(4977),
  },
  [1502] = {
    [sym_identifier] = ACTIONS(4979),
    [anon_sym_q_LBRACE] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_LBRACE] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4983),
    [anon_sym_AMP] = ACTIONS(4983),
    [anon_sym_DASH] = ACTIONS(4979),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4979),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_BANG] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_DOLLAR] = ACTIONS(4983),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_TILDE] = ACTIONS(4983),
    [anon_sym_AT] = ACTIONS(4983),
    [sym_bool] = ACTIONS(4979),
    [sym_byte] = ACTIONS(4979),
    [sym_ubyte] = ACTIONS(4979),
    [sym_char] = ACTIONS(4979),
    [sym_short] = ACTIONS(4979),
    [sym_ushort] = ACTIONS(4979),
    [sym_int] = ACTIONS(4979),
    [sym_uint] = ACTIONS(4979),
    [sym_long] = ACTIONS(4979),
    [sym_ulong] = ACTIONS(4979),
    [sym_cent] = ACTIONS(4979),
    [sym_ucent] = ACTIONS(4979),
    [sym_wchar] = ACTIONS(4979),
    [sym_dchar] = ACTIONS(4979),
    [sym_float] = ACTIONS(4979),
    [sym_double] = ACTIONS(4979),
    [sym_real] = ACTIONS(4979),
    [sym_ifloat] = ACTIONS(4979),
    [sym_idouble] = ACTIONS(4979),
    [sym_ireal] = ACTIONS(4979),
    [sym_cfloat] = ACTIONS(4979),
    [sym_cdouble] = ACTIONS(4979),
    [sym_creal] = ACTIONS(4979),
    [sym_size_t] = ACTIONS(4979),
    [sym_ptrdiff_t] = ACTIONS(4979),
    [sym_string] = ACTIONS(4979),
    [sym_cstring] = ACTIONS(4979),
    [sym_dstring] = ACTIONS(4979),
    [sym_wstring] = ACTIONS(4979),
    [sym_noreturn] = ACTIONS(4979),
    [sym_true] = ACTIONS(4979),
    [sym_false] = ACTIONS(4979),
    [sym_null] = ACTIONS(4979),
    [sym_super] = ACTIONS(4979),
    [sym_this] = ACTIONS(4979),
    [sym_abstract] = ACTIONS(4979),
    [sym_alias] = ACTIONS(4979),
    [sym_align] = ACTIONS(4979),
    [sym_asm] = ACTIONS(4979),
    [sym_assert] = ACTIONS(4979),
    [sym_auto] = ACTIONS(4979),
    [sym_break] = ACTIONS(4979),
    [sym_case] = ACTIONS(4979),
    [sym_cast] = ACTIONS(4979),
    [sym_catch] = ACTIONS(4979),
    [sym_class] = ACTIONS(4979),
    [sym_const] = ACTIONS(4979),
    [sym_continue] = ACTIONS(4979),
    [sym_debug] = ACTIONS(4979),
    [sym_default] = ACTIONS(4979),
    [sym_delegate] = ACTIONS(4979),
    [sym_delete] = ACTIONS(4979),
    [sym_deprecated] = ACTIONS(4979),
    [sym_do] = ACTIONS(4979),
    [sym_else] = ACTIONS(4979),
    [sym_enum] = ACTIONS(4979),
    [sym_export] = ACTIONS(4979),
    [sym_extern] = ACTIONS(4979),
    [sym_final] = ACTIONS(4979),
    [sym_finally] = ACTIONS(4979),
    [sym_for] = ACTIONS(4979),
    [sym_foreach] = ACTIONS(4979),
    [sym_foreach_reverse] = ACTIONS(4979),
    [sym_function] = ACTIONS(4979),
    [sym_goto] = ACTIONS(4979),
    [sym_if] = ACTIONS(4979),
    [sym_immutable] = ACTIONS(4979),
    [sym_import] = ACTIONS(4979),
    [sym_in] = ACTIONS(4979),
    [sym_inout] = ACTIONS(4979),
    [sym_interface] = ACTIONS(4979),
    [sym_invariant] = ACTIONS(4979),
    [sym_is] = ACTIONS(4979),
    [sym_mixin] = ACTIONS(4979),
    [sym_new] = ACTIONS(4979),
    [sym_nothrow] = ACTIONS(4979),
    [sym_out] = ACTIONS(4979),
    [sym_override] = ACTIONS(4979),
    [sym_package] = ACTIONS(4979),
    [sym_pragma] = ACTIONS(4979),
    [sym_private] = ACTIONS(4979),
    [sym_protected] = ACTIONS(4979),
    [sym_public] = ACTIONS(4979),
    [sym_pure] = ACTIONS(4979),
    [sym_ref] = ACTIONS(4979),
    [sym_return] = ACTIONS(4979),
    [sym_scope] = ACTIONS(4979),
    [sym_shared] = ACTIONS(4979),
    [sym_static] = ACTIONS(4979),
    [sym_struct] = ACTIONS(4979),
    [sym_switch] = ACTIONS(4979),
    [sym_synchronized] = ACTIONS(4979),
    [sym_template] = ACTIONS(4979),
    [sym_throw] = ACTIONS(4979),
    [sym_try] = ACTIONS(4979),
    [sym_typeid] = ACTIONS(4979),
    [sym_typeof] = ACTIONS(4979),
    [sym_union] = ACTIONS(4979),
    [sym_unittest] = ACTIONS(4979),
    [sym_version] = ACTIONS(4979),
    [sym_while] = ACTIONS(4979),
    [sym_with] = ACTIONS(4979),
    [sym_gshared] = ACTIONS(4979),
    [sym_traits] = ACTIONS(4979),
    [sym_vector] = ACTIONS(4979),
    [sym_void] = ACTIONS(4979),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_r_DQUOTE] = ACTIONS(4983),
    [anon_sym_x_DQUOTE] = ACTIONS(4983),
    [anon_sym_DQUOTE] = ACTIONS(4983),
    [anon_sym_i_BQUOTE] = ACTIONS(4983),
    [anon_sym_i_DQUOTE] = ACTIONS(4983),
    [anon_sym_iq_LBRACE] = ACTIONS(4983),
    [aux_sym_char_literal_token1] = ACTIONS(4983),
    [anon_sym_SQUOTE] = ACTIONS(4979),
    [anon_sym___DATE__] = ACTIONS(4979),
    [anon_sym___FILE__] = ACTIONS(4979),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4979),
    [anon_sym___FUNCTION__] = ACTIONS(4979),
    [anon_sym___LINE__] = ACTIONS(4979),
    [anon_sym___MODULE__] = ACTIONS(4979),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4979),
    [anon_sym___TIME__] = ACTIONS(4979),
    [anon_sym___TIMESTAMP__] = ACTIONS(4979),
    [anon_sym___VENDOR__] = ACTIONS(4979),
    [anon_sym___VERSION__] = ACTIONS(4979),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4983),
    [sym_float_literal] = ACTIONS(4983),
    [sym__string] = ACTIONS(4983),
  },
  [1503] = {
    [sym_identifier] = ACTIONS(4987),
    [anon_sym_q_LBRACE] = ACTIONS(4989),
    [anon_sym_RBRACE] = ACTIONS(4989),
    [anon_sym_LBRACE] = ACTIONS(4989),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4989),
    [anon_sym_PLUS] = ACTIONS(4987),
    [anon_sym_PLUS_PLUS] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(4989),
    [anon_sym_RPAREN] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4989),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(4989),
    [sym_bool] = ACTIONS(4987),
    [sym_byte] = ACTIONS(4987),
    [sym_ubyte] = ACTIONS(4987),
    [sym_char] = ACTIONS(4987),
    [sym_short] = ACTIONS(4987),
    [sym_ushort] = ACTIONS(4987),
    [sym_int] = ACTIONS(4987),
    [sym_uint] = ACTIONS(4987),
    [sym_long] = ACTIONS(4987),
    [sym_ulong] = ACTIONS(4987),
    [sym_cent] = ACTIONS(4987),
    [sym_ucent] = ACTIONS(4987),
    [sym_wchar] = ACTIONS(4987),
    [sym_dchar] = ACTIONS(4987),
    [sym_float] = ACTIONS(4987),
    [sym_double] = ACTIONS(4987),
    [sym_real] = ACTIONS(4987),
    [sym_ifloat] = ACTIONS(4987),
    [sym_idouble] = ACTIONS(4987),
    [sym_ireal] = ACTIONS(4987),
    [sym_cfloat] = ACTIONS(4987),
    [sym_cdouble] = ACTIONS(4987),
    [sym_creal] = ACTIONS(4987),
    [sym_size_t] = ACTIONS(4987),
    [sym_ptrdiff_t] = ACTIONS(4987),
    [sym_string] = ACTIONS(4987),
    [sym_cstring] = ACTIONS(4987),
    [sym_dstring] = ACTIONS(4987),
    [sym_wstring] = ACTIONS(4987),
    [sym_noreturn] = ACTIONS(4987),
    [sym_true] = ACTIONS(4987),
    [sym_false] = ACTIONS(4987),
    [sym_null] = ACTIONS(4987),
    [sym_super] = ACTIONS(4987),
    [sym_this] = ACTIONS(4987),
    [sym_abstract] = ACTIONS(4987),
    [sym_alias] = ACTIONS(4987),
    [sym_align] = ACTIONS(4987),
    [sym_asm] = ACTIONS(4987),
    [sym_assert] = ACTIONS(4987),
    [sym_auto] = ACTIONS(4987),
    [sym_break] = ACTIONS(4987),
    [sym_case] = ACTIONS(4987),
    [sym_cast] = ACTIONS(4987),
    [sym_catch] = ACTIONS(4987),
    [sym_class] = ACTIONS(4987),
    [sym_const] = ACTIONS(4987),
    [sym_continue] = ACTIONS(4987),
    [sym_debug] = ACTIONS(4987),
    [sym_default] = ACTIONS(4987),
    [sym_delegate] = ACTIONS(4987),
    [sym_delete] = ACTIONS(4987),
    [sym_deprecated] = ACTIONS(4987),
    [sym_do] = ACTIONS(4987),
    [sym_else] = ACTIONS(4987),
    [sym_enum] = ACTIONS(4987),
    [sym_export] = ACTIONS(4987),
    [sym_extern] = ACTIONS(4987),
    [sym_final] = ACTIONS(4987),
    [sym_finally] = ACTIONS(4987),
    [sym_for] = ACTIONS(4987),
    [sym_foreach] = ACTIONS(4987),
    [sym_foreach_reverse] = ACTIONS(4987),
    [sym_function] = ACTIONS(4987),
    [sym_goto] = ACTIONS(4987),
    [sym_if] = ACTIONS(4987),
    [sym_immutable] = ACTIONS(4987),
    [sym_import] = ACTIONS(4987),
    [sym_in] = ACTIONS(4987),
    [sym_inout] = ACTIONS(4987),
    [sym_interface] = ACTIONS(4987),
    [sym_invariant] = ACTIONS(4987),
    [sym_is] = ACTIONS(4987),
    [sym_mixin] = ACTIONS(4987),
    [sym_new] = ACTIONS(4987),
    [sym_nothrow] = ACTIONS(4987),
    [sym_out] = ACTIONS(4987),
    [sym_override] = ACTIONS(4987),
    [sym_package] = ACTIONS(4987),
    [sym_pragma] = ACTIONS(4987),
    [sym_private] = ACTIONS(4987),
    [sym_protected] = ACTIONS(4987),
    [sym_public] = ACTIONS(4987),
    [sym_pure] = ACTIONS(4987),
    [sym_ref] = ACTIONS(4987),
    [sym_return] = ACTIONS(4987),
    [sym_scope] = ACTIONS(4987),
    [sym_shared] = ACTIONS(4987),
    [sym_static] = ACTIONS(4987),
    [sym_struct] = ACTIONS(4987),
    [sym_switch] = ACTIONS(4987),
    [sym_synchronized] = ACTIONS(4987),
    [sym_template] = ACTIONS(4987),
    [sym_throw] = ACTIONS(4987),
    [sym_try] = ACTIONS(4987),
    [sym_typeid] = ACTIONS(4987),
    [sym_typeof] = ACTIONS(4987),
    [sym_union] = ACTIONS(4987),
    [sym_unittest] = ACTIONS(4987),
    [sym_version] = ACTIONS(4987),
    [sym_while] = ACTIONS(4987),
    [sym_with] = ACTIONS(4987),
    [sym_gshared] = ACTIONS(4987),
    [sym_traits] = ACTIONS(4987),
    [sym_vector] = ACTIONS(4987),
    [sym_void] = ACTIONS(4987),
    [anon_sym_BQUOTE] = ACTIONS(4989),
    [anon_sym_r_DQUOTE] = ACTIONS(4989),
    [anon_sym_x_DQUOTE] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_i_BQUOTE] = ACTIONS(4989),
    [anon_sym_i_DQUOTE] = ACTIONS(4989),
    [anon_sym_iq_LBRACE] = ACTIONS(4989),
    [aux_sym_char_literal_token1] = ACTIONS(4989),
    [anon_sym_SQUOTE] = ACTIONS(4987),
    [anon_sym___DATE__] = ACTIONS(4987),
    [anon_sym___FILE__] = ACTIONS(4987),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4987),
    [anon_sym___FUNCTION__] = ACTIONS(4987),
    [anon_sym___LINE__] = ACTIONS(4987),
    [anon_sym___MODULE__] = ACTIONS(4987),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4987),
    [anon_sym___TIME__] = ACTIONS(4987),
    [anon_sym___TIMESTAMP__] = ACTIONS(4987),
    [anon_sym___VENDOR__] = ACTIONS(4987),
    [anon_sym___VERSION__] = ACTIONS(4987),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4989),
    [sym_float_literal] = ACTIONS(4989),
    [sym__string] = ACTIONS(4989),
  },
  [1504] = {
    [sym_identifier] = ACTIONS(4991),
    [anon_sym_q_LBRACE] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4991),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_LPAREN] = ACTIONS(4993),
    [anon_sym_RPAREN] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_AT] = ACTIONS(4993),
    [sym_bool] = ACTIONS(4991),
    [sym_byte] = ACTIONS(4991),
    [sym_ubyte] = ACTIONS(4991),
    [sym_char] = ACTIONS(4991),
    [sym_short] = ACTIONS(4991),
    [sym_ushort] = ACTIONS(4991),
    [sym_int] = ACTIONS(4991),
    [sym_uint] = ACTIONS(4991),
    [sym_long] = ACTIONS(4991),
    [sym_ulong] = ACTIONS(4991),
    [sym_cent] = ACTIONS(4991),
    [sym_ucent] = ACTIONS(4991),
    [sym_wchar] = ACTIONS(4991),
    [sym_dchar] = ACTIONS(4991),
    [sym_float] = ACTIONS(4991),
    [sym_double] = ACTIONS(4991),
    [sym_real] = ACTIONS(4991),
    [sym_ifloat] = ACTIONS(4991),
    [sym_idouble] = ACTIONS(4991),
    [sym_ireal] = ACTIONS(4991),
    [sym_cfloat] = ACTIONS(4991),
    [sym_cdouble] = ACTIONS(4991),
    [sym_creal] = ACTIONS(4991),
    [sym_size_t] = ACTIONS(4991),
    [sym_ptrdiff_t] = ACTIONS(4991),
    [sym_string] = ACTIONS(4991),
    [sym_cstring] = ACTIONS(4991),
    [sym_dstring] = ACTIONS(4991),
    [sym_wstring] = ACTIONS(4991),
    [sym_noreturn] = ACTIONS(4991),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_super] = ACTIONS(4991),
    [sym_this] = ACTIONS(4991),
    [sym_abstract] = ACTIONS(4991),
    [sym_alias] = ACTIONS(4991),
    [sym_align] = ACTIONS(4991),
    [sym_asm] = ACTIONS(4991),
    [sym_assert] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [sym_break] = ACTIONS(4991),
    [sym_case] = ACTIONS(4991),
    [sym_cast] = ACTIONS(4991),
    [sym_catch] = ACTIONS(4991),
    [sym_class] = ACTIONS(4991),
    [sym_const] = ACTIONS(4991),
    [sym_continue] = ACTIONS(4991),
    [sym_debug] = ACTIONS(4991),
    [sym_default] = ACTIONS(4991),
    [sym_delegate] = ACTIONS(4991),
    [sym_delete] = ACTIONS(4991),
    [sym_deprecated] = ACTIONS(4991),
    [sym_do] = ACTIONS(4991),
    [sym_else] = ACTIONS(4991),
    [sym_enum] = ACTIONS(4991),
    [sym_export] = ACTIONS(4991),
    [sym_extern] = ACTIONS(4991),
    [sym_final] = ACTIONS(4991),
    [sym_finally] = ACTIONS(4991),
    [sym_for] = ACTIONS(4991),
    [sym_foreach] = ACTIONS(4991),
    [sym_foreach_reverse] = ACTIONS(4991),
    [sym_function] = ACTIONS(4991),
    [sym_goto] = ACTIONS(4991),
    [sym_if] = ACTIONS(4991),
    [sym_immutable] = ACTIONS(4991),
    [sym_import] = ACTIONS(4991),
    [sym_in] = ACTIONS(4991),
    [sym_inout] = ACTIONS(4991),
    [sym_interface] = ACTIONS(4991),
    [sym_invariant] = ACTIONS(4991),
    [sym_is] = ACTIONS(4991),
    [sym_mixin] = ACTIONS(4991),
    [sym_new] = ACTIONS(4991),
    [sym_nothrow] = ACTIONS(4991),
    [sym_out] = ACTIONS(4991),
    [sym_override] = ACTIONS(4991),
    [sym_package] = ACTIONS(4991),
    [sym_pragma] = ACTIONS(4991),
    [sym_private] = ACTIONS(4991),
    [sym_protected] = ACTIONS(4991),
    [sym_public] = ACTIONS(4991),
    [sym_pure] = ACTIONS(4991),
    [sym_ref] = ACTIONS(4991),
    [sym_return] = ACTIONS(4991),
    [sym_scope] = ACTIONS(4991),
    [sym_shared] = ACTIONS(4991),
    [sym_static] = ACTIONS(4991),
    [sym_struct] = ACTIONS(4991),
    [sym_switch] = ACTIONS(4991),
    [sym_synchronized] = ACTIONS(4991),
    [sym_template] = ACTIONS(4991),
    [sym_throw] = ACTIONS(4991),
    [sym_try] = ACTIONS(4991),
    [sym_typeid] = ACTIONS(4991),
    [sym_typeof] = ACTIONS(4991),
    [sym_union] = ACTIONS(4991),
    [sym_unittest] = ACTIONS(4991),
    [sym_version] = ACTIONS(4991),
    [sym_while] = ACTIONS(4991),
    [sym_with] = ACTIONS(4991),
    [sym_gshared] = ACTIONS(4991),
    [sym_traits] = ACTIONS(4991),
    [sym_vector] = ACTIONS(4991),
    [sym_void] = ACTIONS(4991),
    [anon_sym_BQUOTE] = ACTIONS(4993),
    [anon_sym_r_DQUOTE] = ACTIONS(4993),
    [anon_sym_x_DQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_i_BQUOTE] = ACTIONS(4993),
    [anon_sym_i_DQUOTE] = ACTIONS(4993),
    [anon_sym_iq_LBRACE] = ACTIONS(4993),
    [aux_sym_char_literal_token1] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4991),
    [anon_sym___DATE__] = ACTIONS(4991),
    [anon_sym___FILE__] = ACTIONS(4991),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4991),
    [anon_sym___FUNCTION__] = ACTIONS(4991),
    [anon_sym___LINE__] = ACTIONS(4991),
    [anon_sym___MODULE__] = ACTIONS(4991),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4991),
    [anon_sym___TIME__] = ACTIONS(4991),
    [anon_sym___TIMESTAMP__] = ACTIONS(4991),
    [anon_sym___VENDOR__] = ACTIONS(4991),
    [anon_sym___VERSION__] = ACTIONS(4991),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4993),
    [sym_float_literal] = ACTIONS(4993),
    [sym__string] = ACTIONS(4993),
  },
  [1505] = {
    [sym_identifier] = ACTIONS(4995),
    [anon_sym_q_LBRACE] = ACTIONS(4997),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_LBRACE] = ACTIONS(4997),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_PLUS_PLUS] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_LPAREN] = ACTIONS(4997),
    [anon_sym_RPAREN] = ACTIONS(4997),
    [anon_sym_LBRACK] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(4997),
    [anon_sym_DOLLAR] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_TILDE] = ACTIONS(4997),
    [anon_sym_AT] = ACTIONS(4997),
    [sym_bool] = ACTIONS(4995),
    [sym_byte] = ACTIONS(4995),
    [sym_ubyte] = ACTIONS(4995),
    [sym_char] = ACTIONS(4995),
    [sym_short] = ACTIONS(4995),
    [sym_ushort] = ACTIONS(4995),
    [sym_int] = ACTIONS(4995),
    [sym_uint] = ACTIONS(4995),
    [sym_long] = ACTIONS(4995),
    [sym_ulong] = ACTIONS(4995),
    [sym_cent] = ACTIONS(4995),
    [sym_ucent] = ACTIONS(4995),
    [sym_wchar] = ACTIONS(4995),
    [sym_dchar] = ACTIONS(4995),
    [sym_float] = ACTIONS(4995),
    [sym_double] = ACTIONS(4995),
    [sym_real] = ACTIONS(4995),
    [sym_ifloat] = ACTIONS(4995),
    [sym_idouble] = ACTIONS(4995),
    [sym_ireal] = ACTIONS(4995),
    [sym_cfloat] = ACTIONS(4995),
    [sym_cdouble] = ACTIONS(4995),
    [sym_creal] = ACTIONS(4995),
    [sym_size_t] = ACTIONS(4995),
    [sym_ptrdiff_t] = ACTIONS(4995),
    [sym_string] = ACTIONS(4995),
    [sym_cstring] = ACTIONS(4995),
    [sym_dstring] = ACTIONS(4995),
    [sym_wstring] = ACTIONS(4995),
    [sym_noreturn] = ACTIONS(4995),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_super] = ACTIONS(4995),
    [sym_this] = ACTIONS(4995),
    [sym_abstract] = ACTIONS(4995),
    [sym_alias] = ACTIONS(4995),
    [sym_align] = ACTIONS(4995),
    [sym_asm] = ACTIONS(4995),
    [sym_assert] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [sym_break] = ACTIONS(4995),
    [sym_case] = ACTIONS(4995),
    [sym_cast] = ACTIONS(4995),
    [sym_catch] = ACTIONS(4995),
    [sym_class] = ACTIONS(4995),
    [sym_const] = ACTIONS(4995),
    [sym_continue] = ACTIONS(4995),
    [sym_debug] = ACTIONS(4995),
    [sym_default] = ACTIONS(4995),
    [sym_delegate] = ACTIONS(4995),
    [sym_delete] = ACTIONS(4995),
    [sym_deprecated] = ACTIONS(4995),
    [sym_do] = ACTIONS(4995),
    [sym_else] = ACTIONS(4995),
    [sym_enum] = ACTIONS(4995),
    [sym_export] = ACTIONS(4995),
    [sym_extern] = ACTIONS(4995),
    [sym_final] = ACTIONS(4995),
    [sym_finally] = ACTIONS(4995),
    [sym_for] = ACTIONS(4995),
    [sym_foreach] = ACTIONS(4995),
    [sym_foreach_reverse] = ACTIONS(4995),
    [sym_function] = ACTIONS(4995),
    [sym_goto] = ACTIONS(4995),
    [sym_if] = ACTIONS(4995),
    [sym_immutable] = ACTIONS(4995),
    [sym_import] = ACTIONS(4995),
    [sym_in] = ACTIONS(4995),
    [sym_inout] = ACTIONS(4995),
    [sym_interface] = ACTIONS(4995),
    [sym_invariant] = ACTIONS(4995),
    [sym_is] = ACTIONS(4995),
    [sym_mixin] = ACTIONS(4995),
    [sym_new] = ACTIONS(4995),
    [sym_nothrow] = ACTIONS(4995),
    [sym_out] = ACTIONS(4995),
    [sym_override] = ACTIONS(4995),
    [sym_package] = ACTIONS(4995),
    [sym_pragma] = ACTIONS(4995),
    [sym_private] = ACTIONS(4995),
    [sym_protected] = ACTIONS(4995),
    [sym_public] = ACTIONS(4995),
    [sym_pure] = ACTIONS(4995),
    [sym_ref] = ACTIONS(4995),
    [sym_return] = ACTIONS(4995),
    [sym_scope] = ACTIONS(4995),
    [sym_shared] = ACTIONS(4995),
    [sym_static] = ACTIONS(4995),
    [sym_struct] = ACTIONS(4995),
    [sym_switch] = ACTIONS(4995),
    [sym_synchronized] = ACTIONS(4995),
    [sym_template] = ACTIONS(4995),
    [sym_throw] = ACTIONS(4995),
    [sym_try] = ACTIONS(4995),
    [sym_typeid] = ACTIONS(4995),
    [sym_typeof] = ACTIONS(4995),
    [sym_union] = ACTIONS(4995),
    [sym_unittest] = ACTIONS(4995),
    [sym_version] = ACTIONS(4995),
    [sym_while] = ACTIONS(4995),
    [sym_with] = ACTIONS(4995),
    [sym_gshared] = ACTIONS(4995),
    [sym_traits] = ACTIONS(4995),
    [sym_vector] = ACTIONS(4995),
    [sym_void] = ACTIONS(4995),
    [anon_sym_BQUOTE] = ACTIONS(4997),
    [anon_sym_r_DQUOTE] = ACTIONS(4997),
    [anon_sym_x_DQUOTE] = ACTIONS(4997),
    [anon_sym_DQUOTE] = ACTIONS(4997),
    [anon_sym_i_BQUOTE] = ACTIONS(4997),
    [anon_sym_i_DQUOTE] = ACTIONS(4997),
    [anon_sym_iq_LBRACE] = ACTIONS(4997),
    [aux_sym_char_literal_token1] = ACTIONS(4997),
    [anon_sym_SQUOTE] = ACTIONS(4995),
    [anon_sym___DATE__] = ACTIONS(4995),
    [anon_sym___FILE__] = ACTIONS(4995),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4995),
    [anon_sym___FUNCTION__] = ACTIONS(4995),
    [anon_sym___LINE__] = ACTIONS(4995),
    [anon_sym___MODULE__] = ACTIONS(4995),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4995),
    [anon_sym___TIME__] = ACTIONS(4995),
    [anon_sym___TIMESTAMP__] = ACTIONS(4995),
    [anon_sym___VENDOR__] = ACTIONS(4995),
    [anon_sym___VERSION__] = ACTIONS(4995),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4997),
    [sym_float_literal] = ACTIONS(4997),
    [sym__string] = ACTIONS(4997),
  },
  [1506] = {
    [sym_identifier] = ACTIONS(4999),
    [anon_sym_q_LBRACE] = ACTIONS(5001),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(5001),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(5001),
    [anon_sym_PLUS] = ACTIONS(4999),
    [anon_sym_PLUS_PLUS] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_LPAREN] = ACTIONS(5001),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [anon_sym_LBRACK] = ACTIONS(5001),
    [anon_sym_SEMI] = ACTIONS(5001),
    [anon_sym_DOLLAR] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5001),
    [anon_sym_AT] = ACTIONS(5001),
    [sym_bool] = ACTIONS(4999),
    [sym_byte] = ACTIONS(4999),
    [sym_ubyte] = ACTIONS(4999),
    [sym_char] = ACTIONS(4999),
    [sym_short] = ACTIONS(4999),
    [sym_ushort] = ACTIONS(4999),
    [sym_int] = ACTIONS(4999),
    [sym_uint] = ACTIONS(4999),
    [sym_long] = ACTIONS(4999),
    [sym_ulong] = ACTIONS(4999),
    [sym_cent] = ACTIONS(4999),
    [sym_ucent] = ACTIONS(4999),
    [sym_wchar] = ACTIONS(4999),
    [sym_dchar] = ACTIONS(4999),
    [sym_float] = ACTIONS(4999),
    [sym_double] = ACTIONS(4999),
    [sym_real] = ACTIONS(4999),
    [sym_ifloat] = ACTIONS(4999),
    [sym_idouble] = ACTIONS(4999),
    [sym_ireal] = ACTIONS(4999),
    [sym_cfloat] = ACTIONS(4999),
    [sym_cdouble] = ACTIONS(4999),
    [sym_creal] = ACTIONS(4999),
    [sym_size_t] = ACTIONS(4999),
    [sym_ptrdiff_t] = ACTIONS(4999),
    [sym_string] = ACTIONS(4999),
    [sym_cstring] = ACTIONS(4999),
    [sym_dstring] = ACTIONS(4999),
    [sym_wstring] = ACTIONS(4999),
    [sym_noreturn] = ACTIONS(4999),
    [sym_true] = ACTIONS(4999),
    [sym_false] = ACTIONS(4999),
    [sym_null] = ACTIONS(4999),
    [sym_super] = ACTIONS(4999),
    [sym_this] = ACTIONS(4999),
    [sym_abstract] = ACTIONS(4999),
    [sym_alias] = ACTIONS(4999),
    [sym_align] = ACTIONS(4999),
    [sym_asm] = ACTIONS(4999),
    [sym_assert] = ACTIONS(4999),
    [sym_auto] = ACTIONS(4999),
    [sym_break] = ACTIONS(4999),
    [sym_case] = ACTIONS(4999),
    [sym_cast] = ACTIONS(4999),
    [sym_catch] = ACTIONS(4999),
    [sym_class] = ACTIONS(4999),
    [sym_const] = ACTIONS(4999),
    [sym_continue] = ACTIONS(4999),
    [sym_debug] = ACTIONS(4999),
    [sym_default] = ACTIONS(4999),
    [sym_delegate] = ACTIONS(4999),
    [sym_delete] = ACTIONS(4999),
    [sym_deprecated] = ACTIONS(4999),
    [sym_do] = ACTIONS(4999),
    [sym_else] = ACTIONS(4999),
    [sym_enum] = ACTIONS(4999),
    [sym_export] = ACTIONS(4999),
    [sym_extern] = ACTIONS(4999),
    [sym_final] = ACTIONS(4999),
    [sym_finally] = ACTIONS(4999),
    [sym_for] = ACTIONS(4999),
    [sym_foreach] = ACTIONS(4999),
    [sym_foreach_reverse] = ACTIONS(4999),
    [sym_function] = ACTIONS(4999),
    [sym_goto] = ACTIONS(4999),
    [sym_if] = ACTIONS(4999),
    [sym_immutable] = ACTIONS(4999),
    [sym_import] = ACTIONS(4999),
    [sym_in] = ACTIONS(4999),
    [sym_inout] = ACTIONS(4999),
    [sym_interface] = ACTIONS(4999),
    [sym_invariant] = ACTIONS(4999),
    [sym_is] = ACTIONS(4999),
    [sym_mixin] = ACTIONS(4999),
    [sym_new] = ACTIONS(4999),
    [sym_nothrow] = ACTIONS(4999),
    [sym_out] = ACTIONS(4999),
    [sym_override] = ACTIONS(4999),
    [sym_package] = ACTIONS(4999),
    [sym_pragma] = ACTIONS(4999),
    [sym_private] = ACTIONS(4999),
    [sym_protected] = ACTIONS(4999),
    [sym_public] = ACTIONS(4999),
    [sym_pure] = ACTIONS(4999),
    [sym_ref] = ACTIONS(4999),
    [sym_return] = ACTIONS(4999),
    [sym_scope] = ACTIONS(4999),
    [sym_shared] = ACTIONS(4999),
    [sym_static] = ACTIONS(4999),
    [sym_struct] = ACTIONS(4999),
    [sym_switch] = ACTIONS(4999),
    [sym_synchronized] = ACTIONS(4999),
    [sym_template] = ACTIONS(4999),
    [sym_throw] = ACTIONS(4999),
    [sym_try] = ACTIONS(4999),
    [sym_typeid] = ACTIONS(4999),
    [sym_typeof] = ACTIONS(4999),
    [sym_union] = ACTIONS(4999),
    [sym_unittest] = ACTIONS(4999),
    [sym_version] = ACTIONS(4999),
    [sym_while] = ACTIONS(4999),
    [sym_with] = ACTIONS(4999),
    [sym_gshared] = ACTIONS(4999),
    [sym_traits] = ACTIONS(4999),
    [sym_vector] = ACTIONS(4999),
    [sym_void] = ACTIONS(4999),
    [anon_sym_BQUOTE] = ACTIONS(5001),
    [anon_sym_r_DQUOTE] = ACTIONS(5001),
    [anon_sym_x_DQUOTE] = ACTIONS(5001),
    [anon_sym_DQUOTE] = ACTIONS(5001),
    [anon_sym_i_BQUOTE] = ACTIONS(5001),
    [anon_sym_i_DQUOTE] = ACTIONS(5001),
    [anon_sym_iq_LBRACE] = ACTIONS(5001),
    [aux_sym_char_literal_token1] = ACTIONS(5001),
    [anon_sym_SQUOTE] = ACTIONS(4999),
    [anon_sym___DATE__] = ACTIONS(4999),
    [anon_sym___FILE__] = ACTIONS(4999),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4999),
    [anon_sym___FUNCTION__] = ACTIONS(4999),
    [anon_sym___LINE__] = ACTIONS(4999),
    [anon_sym___MODULE__] = ACTIONS(4999),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4999),
    [anon_sym___TIME__] = ACTIONS(4999),
    [anon_sym___TIMESTAMP__] = ACTIONS(4999),
    [anon_sym___VENDOR__] = ACTIONS(4999),
    [anon_sym___VERSION__] = ACTIONS(4999),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5001),
    [sym_float_literal] = ACTIONS(5001),
    [sym__string] = ACTIONS(5001),
  },
  [1507] = {
    [sym_identifier] = ACTIONS(5003),
    [anon_sym_q_LBRACE] = ACTIONS(5005),
    [anon_sym_RBRACE] = ACTIONS(5005),
    [anon_sym_LBRACE] = ACTIONS(5005),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_PLUS_PLUS] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_LPAREN] = ACTIONS(5005),
    [anon_sym_RPAREN] = ACTIONS(5005),
    [anon_sym_LBRACK] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(5005),
    [anon_sym_DOLLAR] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5005),
    [anon_sym_AT] = ACTIONS(5005),
    [sym_bool] = ACTIONS(5003),
    [sym_byte] = ACTIONS(5003),
    [sym_ubyte] = ACTIONS(5003),
    [sym_char] = ACTIONS(5003),
    [sym_short] = ACTIONS(5003),
    [sym_ushort] = ACTIONS(5003),
    [sym_int] = ACTIONS(5003),
    [sym_uint] = ACTIONS(5003),
    [sym_long] = ACTIONS(5003),
    [sym_ulong] = ACTIONS(5003),
    [sym_cent] = ACTIONS(5003),
    [sym_ucent] = ACTIONS(5003),
    [sym_wchar] = ACTIONS(5003),
    [sym_dchar] = ACTIONS(5003),
    [sym_float] = ACTIONS(5003),
    [sym_double] = ACTIONS(5003),
    [sym_real] = ACTIONS(5003),
    [sym_ifloat] = ACTIONS(5003),
    [sym_idouble] = ACTIONS(5003),
    [sym_ireal] = ACTIONS(5003),
    [sym_cfloat] = ACTIONS(5003),
    [sym_cdouble] = ACTIONS(5003),
    [sym_creal] = ACTIONS(5003),
    [sym_size_t] = ACTIONS(5003),
    [sym_ptrdiff_t] = ACTIONS(5003),
    [sym_string] = ACTIONS(5003),
    [sym_cstring] = ACTIONS(5003),
    [sym_dstring] = ACTIONS(5003),
    [sym_wstring] = ACTIONS(5003),
    [sym_noreturn] = ACTIONS(5003),
    [sym_true] = ACTIONS(5003),
    [sym_false] = ACTIONS(5003),
    [sym_null] = ACTIONS(5003),
    [sym_super] = ACTIONS(5003),
    [sym_this] = ACTIONS(5003),
    [sym_abstract] = ACTIONS(5003),
    [sym_alias] = ACTIONS(5003),
    [sym_align] = ACTIONS(5003),
    [sym_asm] = ACTIONS(5003),
    [sym_assert] = ACTIONS(5003),
    [sym_auto] = ACTIONS(5003),
    [sym_break] = ACTIONS(5003),
    [sym_case] = ACTIONS(5003),
    [sym_cast] = ACTIONS(5003),
    [sym_catch] = ACTIONS(5003),
    [sym_class] = ACTIONS(5003),
    [sym_const] = ACTIONS(5003),
    [sym_continue] = ACTIONS(5003),
    [sym_debug] = ACTIONS(5003),
    [sym_default] = ACTIONS(5003),
    [sym_delegate] = ACTIONS(5003),
    [sym_delete] = ACTIONS(5003),
    [sym_deprecated] = ACTIONS(5003),
    [sym_do] = ACTIONS(5003),
    [sym_else] = ACTIONS(5003),
    [sym_enum] = ACTIONS(5003),
    [sym_export] = ACTIONS(5003),
    [sym_extern] = ACTIONS(5003),
    [sym_final] = ACTIONS(5003),
    [sym_finally] = ACTIONS(5003),
    [sym_for] = ACTIONS(5003),
    [sym_foreach] = ACTIONS(5003),
    [sym_foreach_reverse] = ACTIONS(5003),
    [sym_function] = ACTIONS(5003),
    [sym_goto] = ACTIONS(5003),
    [sym_if] = ACTIONS(5003),
    [sym_immutable] = ACTIONS(5003),
    [sym_import] = ACTIONS(5003),
    [sym_in] = ACTIONS(5003),
    [sym_inout] = ACTIONS(5003),
    [sym_interface] = ACTIONS(5003),
    [sym_invariant] = ACTIONS(5003),
    [sym_is] = ACTIONS(5003),
    [sym_mixin] = ACTIONS(5003),
    [sym_new] = ACTIONS(5003),
    [sym_nothrow] = ACTIONS(5003),
    [sym_out] = ACTIONS(5003),
    [sym_override] = ACTIONS(5003),
    [sym_package] = ACTIONS(5003),
    [sym_pragma] = ACTIONS(5003),
    [sym_private] = ACTIONS(5003),
    [sym_protected] = ACTIONS(5003),
    [sym_public] = ACTIONS(5003),
    [sym_pure] = ACTIONS(5003),
    [sym_ref] = ACTIONS(5003),
    [sym_return] = ACTIONS(5003),
    [sym_scope] = ACTIONS(5003),
    [sym_shared] = ACTIONS(5003),
    [sym_static] = ACTIONS(5003),
    [sym_struct] = ACTIONS(5003),
    [sym_switch] = ACTIONS(5003),
    [sym_synchronized] = ACTIONS(5003),
    [sym_template] = ACTIONS(5003),
    [sym_throw] = ACTIONS(5003),
    [sym_try] = ACTIONS(5003),
    [sym_typeid] = ACTIONS(5003),
    [sym_typeof] = ACTIONS(5003),
    [sym_union] = ACTIONS(5003),
    [sym_unittest] = ACTIONS(5003),
    [sym_version] = ACTIONS(5003),
    [sym_while] = ACTIONS(5003),
    [sym_with] = ACTIONS(5003),
    [sym_gshared] = ACTIONS(5003),
    [sym_traits] = ACTIONS(5003),
    [sym_vector] = ACTIONS(5003),
    [sym_void] = ACTIONS(5003),
    [anon_sym_BQUOTE] = ACTIONS(5005),
    [anon_sym_r_DQUOTE] = ACTIONS(5005),
    [anon_sym_x_DQUOTE] = ACTIONS(5005),
    [anon_sym_DQUOTE] = ACTIONS(5005),
    [anon_sym_i_BQUOTE] = ACTIONS(5005),
    [anon_sym_i_DQUOTE] = ACTIONS(5005),
    [anon_sym_iq_LBRACE] = ACTIONS(5005),
    [aux_sym_char_literal_token1] = ACTIONS(5005),
    [anon_sym_SQUOTE] = ACTIONS(5003),
    [anon_sym___DATE__] = ACTIONS(5003),
    [anon_sym___FILE__] = ACTIONS(5003),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5003),
    [anon_sym___FUNCTION__] = ACTIONS(5003),
    [anon_sym___LINE__] = ACTIONS(5003),
    [anon_sym___MODULE__] = ACTIONS(5003),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5003),
    [anon_sym___TIME__] = ACTIONS(5003),
    [anon_sym___TIMESTAMP__] = ACTIONS(5003),
    [anon_sym___VENDOR__] = ACTIONS(5003),
    [anon_sym___VERSION__] = ACTIONS(5003),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5005),
    [sym_float_literal] = ACTIONS(5005),
    [sym__string] = ACTIONS(5005),
  },
  [1508] = {
    [sym_identifier] = ACTIONS(5007),
    [anon_sym_q_LBRACE] = ACTIONS(5009),
    [anon_sym_RBRACE] = ACTIONS(5009),
    [anon_sym_LBRACE] = ACTIONS(5009),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5009),
    [anon_sym_PLUS] = ACTIONS(5007),
    [anon_sym_PLUS_PLUS] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_RPAREN] = ACTIONS(5009),
    [anon_sym_LBRACK] = ACTIONS(5009),
    [anon_sym_SEMI] = ACTIONS(5009),
    [anon_sym_DOLLAR] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5009),
    [anon_sym_AT] = ACTIONS(5009),
    [sym_bool] = ACTIONS(5007),
    [sym_byte] = ACTIONS(5007),
    [sym_ubyte] = ACTIONS(5007),
    [sym_char] = ACTIONS(5007),
    [sym_short] = ACTIONS(5007),
    [sym_ushort] = ACTIONS(5007),
    [sym_int] = ACTIONS(5007),
    [sym_uint] = ACTIONS(5007),
    [sym_long] = ACTIONS(5007),
    [sym_ulong] = ACTIONS(5007),
    [sym_cent] = ACTIONS(5007),
    [sym_ucent] = ACTIONS(5007),
    [sym_wchar] = ACTIONS(5007),
    [sym_dchar] = ACTIONS(5007),
    [sym_float] = ACTIONS(5007),
    [sym_double] = ACTIONS(5007),
    [sym_real] = ACTIONS(5007),
    [sym_ifloat] = ACTIONS(5007),
    [sym_idouble] = ACTIONS(5007),
    [sym_ireal] = ACTIONS(5007),
    [sym_cfloat] = ACTIONS(5007),
    [sym_cdouble] = ACTIONS(5007),
    [sym_creal] = ACTIONS(5007),
    [sym_size_t] = ACTIONS(5007),
    [sym_ptrdiff_t] = ACTIONS(5007),
    [sym_string] = ACTIONS(5007),
    [sym_cstring] = ACTIONS(5007),
    [sym_dstring] = ACTIONS(5007),
    [sym_wstring] = ACTIONS(5007),
    [sym_noreturn] = ACTIONS(5007),
    [sym_true] = ACTIONS(5007),
    [sym_false] = ACTIONS(5007),
    [sym_null] = ACTIONS(5007),
    [sym_super] = ACTIONS(5007),
    [sym_this] = ACTIONS(5007),
    [sym_abstract] = ACTIONS(5007),
    [sym_alias] = ACTIONS(5007),
    [sym_align] = ACTIONS(5007),
    [sym_asm] = ACTIONS(5007),
    [sym_assert] = ACTIONS(5007),
    [sym_auto] = ACTIONS(5007),
    [sym_break] = ACTIONS(5007),
    [sym_case] = ACTIONS(5007),
    [sym_cast] = ACTIONS(5007),
    [sym_catch] = ACTIONS(5007),
    [sym_class] = ACTIONS(5007),
    [sym_const] = ACTIONS(5007),
    [sym_continue] = ACTIONS(5007),
    [sym_debug] = ACTIONS(5007),
    [sym_default] = ACTIONS(5007),
    [sym_delegate] = ACTIONS(5007),
    [sym_delete] = ACTIONS(5007),
    [sym_deprecated] = ACTIONS(5007),
    [sym_do] = ACTIONS(5007),
    [sym_else] = ACTIONS(5007),
    [sym_enum] = ACTIONS(5007),
    [sym_export] = ACTIONS(5007),
    [sym_extern] = ACTIONS(5007),
    [sym_final] = ACTIONS(5007),
    [sym_finally] = ACTIONS(5007),
    [sym_for] = ACTIONS(5007),
    [sym_foreach] = ACTIONS(5007),
    [sym_foreach_reverse] = ACTIONS(5007),
    [sym_function] = ACTIONS(5007),
    [sym_goto] = ACTIONS(5007),
    [sym_if] = ACTIONS(5007),
    [sym_immutable] = ACTIONS(5007),
    [sym_import] = ACTIONS(5007),
    [sym_in] = ACTIONS(5007),
    [sym_inout] = ACTIONS(5007),
    [sym_interface] = ACTIONS(5007),
    [sym_invariant] = ACTIONS(5007),
    [sym_is] = ACTIONS(5007),
    [sym_mixin] = ACTIONS(5007),
    [sym_new] = ACTIONS(5007),
    [sym_nothrow] = ACTIONS(5007),
    [sym_out] = ACTIONS(5007),
    [sym_override] = ACTIONS(5007),
    [sym_package] = ACTIONS(5007),
    [sym_pragma] = ACTIONS(5007),
    [sym_private] = ACTIONS(5007),
    [sym_protected] = ACTIONS(5007),
    [sym_public] = ACTIONS(5007),
    [sym_pure] = ACTIONS(5007),
    [sym_ref] = ACTIONS(5007),
    [sym_return] = ACTIONS(5007),
    [sym_scope] = ACTIONS(5007),
    [sym_shared] = ACTIONS(5007),
    [sym_static] = ACTIONS(5007),
    [sym_struct] = ACTIONS(5007),
    [sym_switch] = ACTIONS(5007),
    [sym_synchronized] = ACTIONS(5007),
    [sym_template] = ACTIONS(5007),
    [sym_throw] = ACTIONS(5007),
    [sym_try] = ACTIONS(5007),
    [sym_typeid] = ACTIONS(5007),
    [sym_typeof] = ACTIONS(5007),
    [sym_union] = ACTIONS(5007),
    [sym_unittest] = ACTIONS(5007),
    [sym_version] = ACTIONS(5007),
    [sym_while] = ACTIONS(5007),
    [sym_with] = ACTIONS(5007),
    [sym_gshared] = ACTIONS(5007),
    [sym_traits] = ACTIONS(5007),
    [sym_vector] = ACTIONS(5007),
    [sym_void] = ACTIONS(5007),
    [anon_sym_BQUOTE] = ACTIONS(5009),
    [anon_sym_r_DQUOTE] = ACTIONS(5009),
    [anon_sym_x_DQUOTE] = ACTIONS(5009),
    [anon_sym_DQUOTE] = ACTIONS(5009),
    [anon_sym_i_BQUOTE] = ACTIONS(5009),
    [anon_sym_i_DQUOTE] = ACTIONS(5009),
    [anon_sym_iq_LBRACE] = ACTIONS(5009),
    [aux_sym_char_literal_token1] = ACTIONS(5009),
    [anon_sym_SQUOTE] = ACTIONS(5007),
    [anon_sym___DATE__] = ACTIONS(5007),
    [anon_sym___FILE__] = ACTIONS(5007),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5007),
    [anon_sym___FUNCTION__] = ACTIONS(5007),
    [anon_sym___LINE__] = ACTIONS(5007),
    [anon_sym___MODULE__] = ACTIONS(5007),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5007),
    [anon_sym___TIME__] = ACTIONS(5007),
    [anon_sym___TIMESTAMP__] = ACTIONS(5007),
    [anon_sym___VENDOR__] = ACTIONS(5007),
    [anon_sym___VERSION__] = ACTIONS(5007),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5009),
    [sym_float_literal] = ACTIONS(5009),
    [sym__string] = ACTIONS(5009),
  },
  [1509] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_asm] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_break] = ACTIONS(2505),
    [sym_case] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_continue] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_default] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_for] = ACTIONS(2505),
    [sym_foreach] = ACTIONS(2505),
    [sym_foreach_reverse] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_goto] = ACTIONS(2505),
    [sym_if] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_switch] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_try] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_with] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [1510] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [anon_sym_AT] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_abstract] = ACTIONS(4366),
    [sym_alias] = ACTIONS(4366),
    [sym_align] = ACTIONS(4366),
    [sym_asm] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_break] = ACTIONS(4366),
    [sym_case] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_class] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_continue] = ACTIONS(4366),
    [sym_debug] = ACTIONS(4366),
    [sym_default] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_deprecated] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(5011),
    [sym_enum] = ACTIONS(4366),
    [sym_export] = ACTIONS(4366),
    [sym_extern] = ACTIONS(4366),
    [sym_final] = ACTIONS(4366),
    [sym_for] = ACTIONS(4366),
    [sym_foreach] = ACTIONS(4366),
    [sym_foreach_reverse] = ACTIONS(4366),
    [sym_function] = ACTIONS(4366),
    [sym_goto] = ACTIONS(4366),
    [sym_if] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_interface] = ACTIONS(4366),
    [sym_invariant] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_nothrow] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_override] = ACTIONS(4366),
    [sym_package] = ACTIONS(4366),
    [sym_pragma] = ACTIONS(4366),
    [sym_private] = ACTIONS(4366),
    [sym_protected] = ACTIONS(4366),
    [sym_public] = ACTIONS(4366),
    [sym_pure] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_return] = ACTIONS(4366),
    [sym_scope] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_static] = ACTIONS(4366),
    [sym_struct] = ACTIONS(4366),
    [sym_switch] = ACTIONS(4366),
    [sym_synchronized] = ACTIONS(4366),
    [sym_template] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_try] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_union] = ACTIONS(4366),
    [sym_unittest] = ACTIONS(4366),
    [sym_version] = ACTIONS(4366),
    [sym_while] = ACTIONS(4366),
    [sym_with] = ACTIONS(4366),
    [sym_gshared] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [1511] = {
    [sym_identifier] = ACTIONS(4909),
    [anon_sym_q_LBRACE] = ACTIONS(4911),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_LBRACE] = ACTIONS(4911),
    [anon_sym_DOT] = ACTIONS(4911),
    [anon_sym_AMP] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_DASH_DASH] = ACTIONS(4911),
    [anon_sym_PLUS] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4911),
    [anon_sym_BANG] = ACTIONS(4911),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [anon_sym_RPAREN] = ACTIONS(4911),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym_DOLLAR] = ACTIONS(4911),
    [anon_sym_STAR] = ACTIONS(4911),
    [anon_sym_TILDE] = ACTIONS(4911),
    [anon_sym_AT] = ACTIONS(4911),
    [sym_bool] = ACTIONS(4909),
    [sym_byte] = ACTIONS(4909),
    [sym_ubyte] = ACTIONS(4909),
    [sym_char] = ACTIONS(4909),
    [sym_short] = ACTIONS(4909),
    [sym_ushort] = ACTIONS(4909),
    [sym_int] = ACTIONS(4909),
    [sym_uint] = ACTIONS(4909),
    [sym_long] = ACTIONS(4909),
    [sym_ulong] = ACTIONS(4909),
    [sym_cent] = ACTIONS(4909),
    [sym_ucent] = ACTIONS(4909),
    [sym_wchar] = ACTIONS(4909),
    [sym_dchar] = ACTIONS(4909),
    [sym_float] = ACTIONS(4909),
    [sym_double] = ACTIONS(4909),
    [sym_real] = ACTIONS(4909),
    [sym_ifloat] = ACTIONS(4909),
    [sym_idouble] = ACTIONS(4909),
    [sym_ireal] = ACTIONS(4909),
    [sym_cfloat] = ACTIONS(4909),
    [sym_cdouble] = ACTIONS(4909),
    [sym_creal] = ACTIONS(4909),
    [sym_size_t] = ACTIONS(4909),
    [sym_ptrdiff_t] = ACTIONS(4909),
    [sym_string] = ACTIONS(4909),
    [sym_cstring] = ACTIONS(4909),
    [sym_dstring] = ACTIONS(4909),
    [sym_wstring] = ACTIONS(4909),
    [sym_noreturn] = ACTIONS(4909),
    [sym_true] = ACTIONS(4909),
    [sym_false] = ACTIONS(4909),
    [sym_null] = ACTIONS(4909),
    [sym_super] = ACTIONS(4909),
    [sym_this] = ACTIONS(4909),
    [sym_abstract] = ACTIONS(4909),
    [sym_alias] = ACTIONS(4909),
    [sym_align] = ACTIONS(4909),
    [sym_asm] = ACTIONS(4909),
    [sym_assert] = ACTIONS(4909),
    [sym_auto] = ACTIONS(4909),
    [sym_break] = ACTIONS(4909),
    [sym_case] = ACTIONS(4909),
    [sym_cast] = ACTIONS(4909),
    [sym_class] = ACTIONS(4909),
    [sym_const] = ACTIONS(4909),
    [sym_continue] = ACTIONS(4909),
    [sym_debug] = ACTIONS(4909),
    [sym_default] = ACTIONS(4909),
    [sym_delegate] = ACTIONS(4909),
    [sym_delete] = ACTIONS(4909),
    [sym_deprecated] = ACTIONS(4909),
    [sym_do] = ACTIONS(4909),
    [sym_else] = ACTIONS(4909),
    [sym_enum] = ACTIONS(4909),
    [sym_export] = ACTIONS(4909),
    [sym_extern] = ACTIONS(4909),
    [sym_final] = ACTIONS(4909),
    [sym_for] = ACTIONS(4909),
    [sym_foreach] = ACTIONS(4909),
    [sym_foreach_reverse] = ACTIONS(4909),
    [sym_function] = ACTIONS(4909),
    [sym_goto] = ACTIONS(4909),
    [sym_if] = ACTIONS(4909),
    [sym_immutable] = ACTIONS(4909),
    [sym_import] = ACTIONS(4909),
    [sym_in] = ACTIONS(4909),
    [sym_inout] = ACTIONS(4909),
    [sym_interface] = ACTIONS(4909),
    [sym_invariant] = ACTIONS(4909),
    [sym_is] = ACTIONS(4909),
    [sym_mixin] = ACTIONS(4909),
    [sym_new] = ACTIONS(4909),
    [sym_nothrow] = ACTIONS(4909),
    [sym_out] = ACTIONS(4909),
    [sym_override] = ACTIONS(4909),
    [sym_package] = ACTIONS(4909),
    [sym_pragma] = ACTIONS(4909),
    [sym_private] = ACTIONS(4909),
    [sym_protected] = ACTIONS(4909),
    [sym_public] = ACTIONS(4909),
    [sym_pure] = ACTIONS(4909),
    [sym_ref] = ACTIONS(4909),
    [sym_return] = ACTIONS(4909),
    [sym_scope] = ACTIONS(4909),
    [sym_shared] = ACTIONS(4909),
    [sym_static] = ACTIONS(4909),
    [sym_struct] = ACTIONS(4909),
    [sym_switch] = ACTIONS(4909),
    [sym_synchronized] = ACTIONS(4909),
    [sym_template] = ACTIONS(4909),
    [sym_throw] = ACTIONS(4909),
    [sym_try] = ACTIONS(4909),
    [sym_typeid] = ACTIONS(4909),
    [sym_typeof] = ACTIONS(4909),
    [sym_union] = ACTIONS(4909),
    [sym_unittest] = ACTIONS(4909),
    [sym_version] = ACTIONS(4909),
    [sym_while] = ACTIONS(4909),
    [sym_with] = ACTIONS(4909),
    [sym_gshared] = ACTIONS(4909),
    [sym_traits] = ACTIONS(4909),
    [sym_vector] = ACTIONS(4909),
    [sym_void] = ACTIONS(4909),
    [anon_sym_BQUOTE] = ACTIONS(4911),
    [anon_sym_r_DQUOTE] = ACTIONS(4911),
    [anon_sym_x_DQUOTE] = ACTIONS(4911),
    [anon_sym_DQUOTE] = ACTIONS(4911),
    [anon_sym_i_BQUOTE] = ACTIONS(4911),
    [anon_sym_i_DQUOTE] = ACTIONS(4911),
    [anon_sym_iq_LBRACE] = ACTIONS(4911),
    [aux_sym_char_literal_token1] = ACTIONS(4911),
    [anon_sym_SQUOTE] = ACTIONS(4909),
    [anon_sym___DATE__] = ACTIONS(4909),
    [anon_sym___FILE__] = ACTIONS(4909),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4909),
    [anon_sym___FUNCTION__] = ACTIONS(4909),
    [anon_sym___LINE__] = ACTIONS(4909),
    [anon_sym___MODULE__] = ACTIONS(4909),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4909),
    [anon_sym___TIME__] = ACTIONS(4909),
    [anon_sym___TIMESTAMP__] = ACTIONS(4909),
    [anon_sym___VENDOR__] = ACTIONS(4909),
    [anon_sym___VERSION__] = ACTIONS(4909),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4911),
    [sym_float_literal] = ACTIONS(4911),
    [sym__string] = ACTIONS(4911),
  },
  [1512] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_q_LBRACE] = ACTIONS(4757),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4757),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_null] = ACTIONS(4755),
    [sym_super] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_asm] = ACTIONS(4755),
    [sym_assert] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_break] = ACTIONS(4755),
    [sym_case] = ACTIONS(4755),
    [sym_cast] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_continue] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_default] = ACTIONS(4755),
    [sym_delegate] = ACTIONS(4755),
    [sym_delete] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_do] = ACTIONS(4755),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_for] = ACTIONS(4755),
    [sym_foreach] = ACTIONS(4755),
    [sym_foreach_reverse] = ACTIONS(4755),
    [sym_function] = ACTIONS(4755),
    [sym_goto] = ACTIONS(4755),
    [sym_if] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(4755),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_is] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_new] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_out] = ACTIONS(4755),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_switch] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_throw] = ACTIONS(4755),
    [sym_try] = ACTIONS(4755),
    [sym_typeid] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_with] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4757),
    [anon_sym_r_DQUOTE] = ACTIONS(4757),
    [anon_sym_x_DQUOTE] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_i_BQUOTE] = ACTIONS(4757),
    [anon_sym_i_DQUOTE] = ACTIONS(4757),
    [anon_sym_iq_LBRACE] = ACTIONS(4757),
    [aux_sym_char_literal_token1] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym___DATE__] = ACTIONS(4755),
    [anon_sym___FILE__] = ACTIONS(4755),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4755),
    [anon_sym___FUNCTION__] = ACTIONS(4755),
    [anon_sym___LINE__] = ACTIONS(4755),
    [anon_sym___MODULE__] = ACTIONS(4755),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4755),
    [anon_sym___TIME__] = ACTIONS(4755),
    [anon_sym___TIMESTAMP__] = ACTIONS(4755),
    [anon_sym___VENDOR__] = ACTIONS(4755),
    [anon_sym___VERSION__] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4757),
    [sym_float_literal] = ACTIONS(4757),
    [sym__string] = ACTIONS(4757),
  },
  [1513] = {
    [sym_identifier] = ACTIONS(4851),
    [anon_sym_q_LBRACE] = ACTIONS(4853),
    [anon_sym_RBRACE] = ACTIONS(4853),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [anon_sym_DOT] = ACTIONS(4853),
    [anon_sym_AMP] = ACTIONS(4853),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_DASH_DASH] = ACTIONS(4853),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_PLUS_PLUS] = ACTIONS(4853),
    [anon_sym_BANG] = ACTIONS(4853),
    [anon_sym_LPAREN] = ACTIONS(4853),
    [anon_sym_RPAREN] = ACTIONS(4853),
    [anon_sym_LBRACK] = ACTIONS(4853),
    [anon_sym_SEMI] = ACTIONS(4853),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [anon_sym_STAR] = ACTIONS(4853),
    [anon_sym_TILDE] = ACTIONS(4853),
    [anon_sym_AT] = ACTIONS(4853),
    [sym_bool] = ACTIONS(4851),
    [sym_byte] = ACTIONS(4851),
    [sym_ubyte] = ACTIONS(4851),
    [sym_char] = ACTIONS(4851),
    [sym_short] = ACTIONS(4851),
    [sym_ushort] = ACTIONS(4851),
    [sym_int] = ACTIONS(4851),
    [sym_uint] = ACTIONS(4851),
    [sym_long] = ACTIONS(4851),
    [sym_ulong] = ACTIONS(4851),
    [sym_cent] = ACTIONS(4851),
    [sym_ucent] = ACTIONS(4851),
    [sym_wchar] = ACTIONS(4851),
    [sym_dchar] = ACTIONS(4851),
    [sym_float] = ACTIONS(4851),
    [sym_double] = ACTIONS(4851),
    [sym_real] = ACTIONS(4851),
    [sym_ifloat] = ACTIONS(4851),
    [sym_idouble] = ACTIONS(4851),
    [sym_ireal] = ACTIONS(4851),
    [sym_cfloat] = ACTIONS(4851),
    [sym_cdouble] = ACTIONS(4851),
    [sym_creal] = ACTIONS(4851),
    [sym_size_t] = ACTIONS(4851),
    [sym_ptrdiff_t] = ACTIONS(4851),
    [sym_string] = ACTIONS(4851),
    [sym_cstring] = ACTIONS(4851),
    [sym_dstring] = ACTIONS(4851),
    [sym_wstring] = ACTIONS(4851),
    [sym_noreturn] = ACTIONS(4851),
    [sym_true] = ACTIONS(4851),
    [sym_false] = ACTIONS(4851),
    [sym_null] = ACTIONS(4851),
    [sym_super] = ACTIONS(4851),
    [sym_this] = ACTIONS(4851),
    [sym_abstract] = ACTIONS(4851),
    [sym_alias] = ACTIONS(4851),
    [sym_align] = ACTIONS(4851),
    [sym_asm] = ACTIONS(4851),
    [sym_assert] = ACTIONS(4851),
    [sym_auto] = ACTIONS(4851),
    [sym_break] = ACTIONS(4851),
    [sym_case] = ACTIONS(4851),
    [sym_cast] = ACTIONS(4851),
    [sym_class] = ACTIONS(4851),
    [sym_const] = ACTIONS(4851),
    [sym_continue] = ACTIONS(4851),
    [sym_debug] = ACTIONS(4851),
    [sym_default] = ACTIONS(4851),
    [sym_delegate] = ACTIONS(4851),
    [sym_delete] = ACTIONS(4851),
    [sym_deprecated] = ACTIONS(4851),
    [sym_do] = ACTIONS(4851),
    [sym_else] = ACTIONS(4851),
    [sym_enum] = ACTIONS(4851),
    [sym_export] = ACTIONS(4851),
    [sym_extern] = ACTIONS(4851),
    [sym_final] = ACTIONS(4851),
    [sym_for] = ACTIONS(4851),
    [sym_foreach] = ACTIONS(4851),
    [sym_foreach_reverse] = ACTIONS(4851),
    [sym_function] = ACTIONS(4851),
    [sym_goto] = ACTIONS(4851),
    [sym_if] = ACTIONS(4851),
    [sym_immutable] = ACTIONS(4851),
    [sym_import] = ACTIONS(4851),
    [sym_in] = ACTIONS(4851),
    [sym_inout] = ACTIONS(4851),
    [sym_interface] = ACTIONS(4851),
    [sym_invariant] = ACTIONS(4851),
    [sym_is] = ACTIONS(4851),
    [sym_mixin] = ACTIONS(4851),
    [sym_new] = ACTIONS(4851),
    [sym_nothrow] = ACTIONS(4851),
    [sym_out] = ACTIONS(4851),
    [sym_override] = ACTIONS(4851),
    [sym_package] = ACTIONS(4851),
    [sym_pragma] = ACTIONS(4851),
    [sym_private] = ACTIONS(4851),
    [sym_protected] = ACTIONS(4851),
    [sym_public] = ACTIONS(4851),
    [sym_pure] = ACTIONS(4851),
    [sym_ref] = ACTIONS(4851),
    [sym_return] = ACTIONS(4851),
    [sym_scope] = ACTIONS(4851),
    [sym_shared] = ACTIONS(4851),
    [sym_static] = ACTIONS(4851),
    [sym_struct] = ACTIONS(4851),
    [sym_switch] = ACTIONS(4851),
    [sym_synchronized] = ACTIONS(4851),
    [sym_template] = ACTIONS(4851),
    [sym_throw] = ACTIONS(4851),
    [sym_try] = ACTIONS(4851),
    [sym_typeid] = ACTIONS(4851),
    [sym_typeof] = ACTIONS(4851),
    [sym_union] = ACTIONS(4851),
    [sym_unittest] = ACTIONS(4851),
    [sym_version] = ACTIONS(4851),
    [sym_while] = ACTIONS(4851),
    [sym_with] = ACTIONS(4851),
    [sym_gshared] = ACTIONS(4851),
    [sym_traits] = ACTIONS(4851),
    [sym_vector] = ACTIONS(4851),
    [sym_void] = ACTIONS(4851),
    [anon_sym_BQUOTE] = ACTIONS(4853),
    [anon_sym_r_DQUOTE] = ACTIONS(4853),
    [anon_sym_x_DQUOTE] = ACTIONS(4853),
    [anon_sym_DQUOTE] = ACTIONS(4853),
    [anon_sym_i_BQUOTE] = ACTIONS(4853),
    [anon_sym_i_DQUOTE] = ACTIONS(4853),
    [anon_sym_iq_LBRACE] = ACTIONS(4853),
    [aux_sym_char_literal_token1] = ACTIONS(4853),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [anon_sym___DATE__] = ACTIONS(4851),
    [anon_sym___FILE__] = ACTIONS(4851),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4851),
    [anon_sym___FUNCTION__] = ACTIONS(4851),
    [anon_sym___LINE__] = ACTIONS(4851),
    [anon_sym___MODULE__] = ACTIONS(4851),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4851),
    [anon_sym___TIME__] = ACTIONS(4851),
    [anon_sym___TIMESTAMP__] = ACTIONS(4851),
    [anon_sym___VENDOR__] = ACTIONS(4851),
    [anon_sym___VERSION__] = ACTIONS(4851),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4853),
    [sym_float_literal] = ACTIONS(4853),
    [sym__string] = ACTIONS(4853),
  },
  [1514] = {
    [sym_identifier] = ACTIONS(4797),
    [anon_sym_q_LBRACE] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_LBRACE] = ACTIONS(4799),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4797),
    [anon_sym_DASH_DASH] = ACTIONS(4799),
    [anon_sym_PLUS] = ACTIONS(4797),
    [anon_sym_PLUS_PLUS] = ACTIONS(4799),
    [anon_sym_BANG] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4799),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_DOLLAR] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(4799),
    [anon_sym_TILDE] = ACTIONS(4799),
    [anon_sym_AT] = ACTIONS(4799),
    [sym_bool] = ACTIONS(4797),
    [sym_byte] = ACTIONS(4797),
    [sym_ubyte] = ACTIONS(4797),
    [sym_char] = ACTIONS(4797),
    [sym_short] = ACTIONS(4797),
    [sym_ushort] = ACTIONS(4797),
    [sym_int] = ACTIONS(4797),
    [sym_uint] = ACTIONS(4797),
    [sym_long] = ACTIONS(4797),
    [sym_ulong] = ACTIONS(4797),
    [sym_cent] = ACTIONS(4797),
    [sym_ucent] = ACTIONS(4797),
    [sym_wchar] = ACTIONS(4797),
    [sym_dchar] = ACTIONS(4797),
    [sym_float] = ACTIONS(4797),
    [sym_double] = ACTIONS(4797),
    [sym_real] = ACTIONS(4797),
    [sym_ifloat] = ACTIONS(4797),
    [sym_idouble] = ACTIONS(4797),
    [sym_ireal] = ACTIONS(4797),
    [sym_cfloat] = ACTIONS(4797),
    [sym_cdouble] = ACTIONS(4797),
    [sym_creal] = ACTIONS(4797),
    [sym_size_t] = ACTIONS(4797),
    [sym_ptrdiff_t] = ACTIONS(4797),
    [sym_string] = ACTIONS(4797),
    [sym_cstring] = ACTIONS(4797),
    [sym_dstring] = ACTIONS(4797),
    [sym_wstring] = ACTIONS(4797),
    [sym_noreturn] = ACTIONS(4797),
    [sym_true] = ACTIONS(4797),
    [sym_false] = ACTIONS(4797),
    [sym_null] = ACTIONS(4797),
    [sym_super] = ACTIONS(4797),
    [sym_this] = ACTIONS(4797),
    [sym_abstract] = ACTIONS(4797),
    [sym_alias] = ACTIONS(4797),
    [sym_align] = ACTIONS(4797),
    [sym_asm] = ACTIONS(4797),
    [sym_assert] = ACTIONS(4797),
    [sym_auto] = ACTIONS(4797),
    [sym_break] = ACTIONS(4797),
    [sym_case] = ACTIONS(4797),
    [sym_cast] = ACTIONS(4797),
    [sym_class] = ACTIONS(4797),
    [sym_const] = ACTIONS(4797),
    [sym_continue] = ACTIONS(4797),
    [sym_debug] = ACTIONS(4797),
    [sym_default] = ACTIONS(4797),
    [sym_delegate] = ACTIONS(4797),
    [sym_delete] = ACTIONS(4797),
    [sym_deprecated] = ACTIONS(4797),
    [sym_do] = ACTIONS(4797),
    [sym_else] = ACTIONS(4797),
    [sym_enum] = ACTIONS(4797),
    [sym_export] = ACTIONS(4797),
    [sym_extern] = ACTIONS(4797),
    [sym_final] = ACTIONS(4797),
    [sym_for] = ACTIONS(4797),
    [sym_foreach] = ACTIONS(4797),
    [sym_foreach_reverse] = ACTIONS(4797),
    [sym_function] = ACTIONS(4797),
    [sym_goto] = ACTIONS(4797),
    [sym_if] = ACTIONS(4797),
    [sym_immutable] = ACTIONS(4797),
    [sym_import] = ACTIONS(4797),
    [sym_in] = ACTIONS(4797),
    [sym_inout] = ACTIONS(4797),
    [sym_interface] = ACTIONS(4797),
    [sym_invariant] = ACTIONS(4797),
    [sym_is] = ACTIONS(4797),
    [sym_mixin] = ACTIONS(4797),
    [sym_new] = ACTIONS(4797),
    [sym_nothrow] = ACTIONS(4797),
    [sym_out] = ACTIONS(4797),
    [sym_override] = ACTIONS(4797),
    [sym_package] = ACTIONS(4797),
    [sym_pragma] = ACTIONS(4797),
    [sym_private] = ACTIONS(4797),
    [sym_protected] = ACTIONS(4797),
    [sym_public] = ACTIONS(4797),
    [sym_pure] = ACTIONS(4797),
    [sym_ref] = ACTIONS(4797),
    [sym_return] = ACTIONS(4797),
    [sym_scope] = ACTIONS(4797),
    [sym_shared] = ACTIONS(4797),
    [sym_static] = ACTIONS(4797),
    [sym_struct] = ACTIONS(4797),
    [sym_switch] = ACTIONS(4797),
    [sym_synchronized] = ACTIONS(4797),
    [sym_template] = ACTIONS(4797),
    [sym_throw] = ACTIONS(4797),
    [sym_try] = ACTIONS(4797),
    [sym_typeid] = ACTIONS(4797),
    [sym_typeof] = ACTIONS(4797),
    [sym_union] = ACTIONS(4797),
    [sym_unittest] = ACTIONS(4797),
    [sym_version] = ACTIONS(4797),
    [sym_while] = ACTIONS(4797),
    [sym_with] = ACTIONS(4797),
    [sym_gshared] = ACTIONS(4797),
    [sym_traits] = ACTIONS(4797),
    [sym_vector] = ACTIONS(4797),
    [sym_void] = ACTIONS(4797),
    [anon_sym_BQUOTE] = ACTIONS(4799),
    [anon_sym_r_DQUOTE] = ACTIONS(4799),
    [anon_sym_x_DQUOTE] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(4799),
    [anon_sym_i_BQUOTE] = ACTIONS(4799),
    [anon_sym_i_DQUOTE] = ACTIONS(4799),
    [anon_sym_iq_LBRACE] = ACTIONS(4799),
    [aux_sym_char_literal_token1] = ACTIONS(4799),
    [anon_sym_SQUOTE] = ACTIONS(4797),
    [anon_sym___DATE__] = ACTIONS(4797),
    [anon_sym___FILE__] = ACTIONS(4797),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4797),
    [anon_sym___FUNCTION__] = ACTIONS(4797),
    [anon_sym___LINE__] = ACTIONS(4797),
    [anon_sym___MODULE__] = ACTIONS(4797),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4797),
    [anon_sym___TIME__] = ACTIONS(4797),
    [anon_sym___TIMESTAMP__] = ACTIONS(4797),
    [anon_sym___VENDOR__] = ACTIONS(4797),
    [anon_sym___VERSION__] = ACTIONS(4797),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4799),
    [sym_float_literal] = ACTIONS(4799),
    [sym__string] = ACTIONS(4799),
  },
  [1515] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_q_LBRACE] = ACTIONS(4757),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4759),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_null] = ACTIONS(4755),
    [sym_super] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_asm] = ACTIONS(4755),
    [sym_assert] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_break] = ACTIONS(4755),
    [sym_case] = ACTIONS(4755),
    [sym_cast] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_continue] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_default] = ACTIONS(4755),
    [sym_delegate] = ACTIONS(4755),
    [sym_delete] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_do] = ACTIONS(4762),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_for] = ACTIONS(4755),
    [sym_foreach] = ACTIONS(4755),
    [sym_foreach_reverse] = ACTIONS(4755),
    [sym_function] = ACTIONS(4755),
    [sym_goto] = ACTIONS(4755),
    [sym_if] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(4762),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_is] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_new] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_out] = ACTIONS(4762),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_switch] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_throw] = ACTIONS(4755),
    [sym_try] = ACTIONS(4755),
    [sym_typeid] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_with] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4757),
    [anon_sym_r_DQUOTE] = ACTIONS(4757),
    [anon_sym_x_DQUOTE] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_i_BQUOTE] = ACTIONS(4757),
    [anon_sym_i_DQUOTE] = ACTIONS(4757),
    [anon_sym_iq_LBRACE] = ACTIONS(4757),
    [aux_sym_char_literal_token1] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym___DATE__] = ACTIONS(4755),
    [anon_sym___FILE__] = ACTIONS(4755),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4755),
    [anon_sym___FUNCTION__] = ACTIONS(4755),
    [anon_sym___LINE__] = ACTIONS(4755),
    [anon_sym___MODULE__] = ACTIONS(4755),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4755),
    [anon_sym___TIME__] = ACTIONS(4755),
    [anon_sym___TIMESTAMP__] = ACTIONS(4755),
    [anon_sym___VENDOR__] = ACTIONS(4755),
    [anon_sym___VERSION__] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4757),
    [sym_float_literal] = ACTIONS(4757),
    [sym__string] = ACTIONS(4757),
  },
  [1516] = {
    [sym_identifier] = ACTIONS(4420),
    [anon_sym_q_LBRACE] = ACTIONS(4422),
    [anon_sym_RBRACE] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(4422),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4422),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_PLUS_PLUS] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_LPAREN] = ACTIONS(4422),
    [anon_sym_RPAREN] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_DOLLAR] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4422),
    [anon_sym_TILDE] = ACTIONS(4422),
    [anon_sym_AT] = ACTIONS(4422),
    [sym_bool] = ACTIONS(4420),
    [sym_byte] = ACTIONS(4420),
    [sym_ubyte] = ACTIONS(4420),
    [sym_char] = ACTIONS(4420),
    [sym_short] = ACTIONS(4420),
    [sym_ushort] = ACTIONS(4420),
    [sym_int] = ACTIONS(4420),
    [sym_uint] = ACTIONS(4420),
    [sym_long] = ACTIONS(4420),
    [sym_ulong] = ACTIONS(4420),
    [sym_cent] = ACTIONS(4420),
    [sym_ucent] = ACTIONS(4420),
    [sym_wchar] = ACTIONS(4420),
    [sym_dchar] = ACTIONS(4420),
    [sym_float] = ACTIONS(4420),
    [sym_double] = ACTIONS(4420),
    [sym_real] = ACTIONS(4420),
    [sym_ifloat] = ACTIONS(4420),
    [sym_idouble] = ACTIONS(4420),
    [sym_ireal] = ACTIONS(4420),
    [sym_cfloat] = ACTIONS(4420),
    [sym_cdouble] = ACTIONS(4420),
    [sym_creal] = ACTIONS(4420),
    [sym_size_t] = ACTIONS(4420),
    [sym_ptrdiff_t] = ACTIONS(4420),
    [sym_string] = ACTIONS(4420),
    [sym_cstring] = ACTIONS(4420),
    [sym_dstring] = ACTIONS(4420),
    [sym_wstring] = ACTIONS(4420),
    [sym_noreturn] = ACTIONS(4420),
    [sym_true] = ACTIONS(4420),
    [sym_false] = ACTIONS(4420),
    [sym_null] = ACTIONS(4420),
    [sym_super] = ACTIONS(4420),
    [sym_this] = ACTIONS(4420),
    [sym_abstract] = ACTIONS(4420),
    [sym_alias] = ACTIONS(4420),
    [sym_align] = ACTIONS(4420),
    [sym_asm] = ACTIONS(4420),
    [sym_assert] = ACTIONS(4420),
    [sym_auto] = ACTIONS(4420),
    [sym_break] = ACTIONS(4420),
    [sym_case] = ACTIONS(4420),
    [sym_cast] = ACTIONS(4420),
    [sym_class] = ACTIONS(4420),
    [sym_const] = ACTIONS(4420),
    [sym_continue] = ACTIONS(4420),
    [sym_debug] = ACTIONS(4420),
    [sym_default] = ACTIONS(4420),
    [sym_delegate] = ACTIONS(4420),
    [sym_delete] = ACTIONS(4420),
    [sym_deprecated] = ACTIONS(4420),
    [sym_do] = ACTIONS(4420),
    [sym_else] = ACTIONS(4420),
    [sym_enum] = ACTIONS(4420),
    [sym_export] = ACTIONS(4420),
    [sym_extern] = ACTIONS(4420),
    [sym_final] = ACTIONS(4420),
    [sym_for] = ACTIONS(4420),
    [sym_foreach] = ACTIONS(4420),
    [sym_foreach_reverse] = ACTIONS(4420),
    [sym_function] = ACTIONS(4420),
    [sym_goto] = ACTIONS(4420),
    [sym_if] = ACTIONS(4420),
    [sym_immutable] = ACTIONS(4420),
    [sym_import] = ACTIONS(4420),
    [sym_in] = ACTIONS(4420),
    [sym_inout] = ACTIONS(4420),
    [sym_interface] = ACTIONS(4420),
    [sym_invariant] = ACTIONS(4420),
    [sym_is] = ACTIONS(4420),
    [sym_mixin] = ACTIONS(4420),
    [sym_new] = ACTIONS(4420),
    [sym_nothrow] = ACTIONS(4420),
    [sym_out] = ACTIONS(4420),
    [sym_override] = ACTIONS(4420),
    [sym_package] = ACTIONS(4420),
    [sym_pragma] = ACTIONS(4420),
    [sym_private] = ACTIONS(4420),
    [sym_protected] = ACTIONS(4420),
    [sym_public] = ACTIONS(4420),
    [sym_pure] = ACTIONS(4420),
    [sym_ref] = ACTIONS(4420),
    [sym_return] = ACTIONS(4420),
    [sym_scope] = ACTIONS(4420),
    [sym_shared] = ACTIONS(4420),
    [sym_static] = ACTIONS(4420),
    [sym_struct] = ACTIONS(4420),
    [sym_switch] = ACTIONS(4420),
    [sym_synchronized] = ACTIONS(4420),
    [sym_template] = ACTIONS(4420),
    [sym_throw] = ACTIONS(4420),
    [sym_try] = ACTIONS(4420),
    [sym_typeid] = ACTIONS(4420),
    [sym_typeof] = ACTIONS(4420),
    [sym_union] = ACTIONS(4420),
    [sym_unittest] = ACTIONS(4420),
    [sym_version] = ACTIONS(4420),
    [sym_while] = ACTIONS(4420),
    [sym_with] = ACTIONS(4420),
    [sym_gshared] = ACTIONS(4420),
    [sym_traits] = ACTIONS(4420),
    [sym_vector] = ACTIONS(4420),
    [sym_void] = ACTIONS(4420),
    [anon_sym_BQUOTE] = ACTIONS(4422),
    [anon_sym_r_DQUOTE] = ACTIONS(4422),
    [anon_sym_x_DQUOTE] = ACTIONS(4422),
    [anon_sym_DQUOTE] = ACTIONS(4422),
    [anon_sym_i_BQUOTE] = ACTIONS(4422),
    [anon_sym_i_DQUOTE] = ACTIONS(4422),
    [anon_sym_iq_LBRACE] = ACTIONS(4422),
    [aux_sym_char_literal_token1] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4420),
    [anon_sym___DATE__] = ACTIONS(4420),
    [anon_sym___FILE__] = ACTIONS(4420),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4420),
    [anon_sym___FUNCTION__] = ACTIONS(4420),
    [anon_sym___LINE__] = ACTIONS(4420),
    [anon_sym___MODULE__] = ACTIONS(4420),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4420),
    [anon_sym___TIME__] = ACTIONS(4420),
    [anon_sym___TIMESTAMP__] = ACTIONS(4420),
    [anon_sym___VENDOR__] = ACTIONS(4420),
    [anon_sym___VERSION__] = ACTIONS(4420),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4422),
    [sym_float_literal] = ACTIONS(4422),
    [sym__string] = ACTIONS(4422),
  },
  [1517] = {
    [sym_identifier] = ACTIONS(4436),
    [anon_sym_q_LBRACE] = ACTIONS(4438),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4438),
    [anon_sym_AMP] = ACTIONS(4438),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_BANG] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_DOLLAR] = ACTIONS(4438),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_TILDE] = ACTIONS(4438),
    [anon_sym_AT] = ACTIONS(4438),
    [sym_bool] = ACTIONS(4436),
    [sym_byte] = ACTIONS(4436),
    [sym_ubyte] = ACTIONS(4436),
    [sym_char] = ACTIONS(4436),
    [sym_short] = ACTIONS(4436),
    [sym_ushort] = ACTIONS(4436),
    [sym_int] = ACTIONS(4436),
    [sym_uint] = ACTIONS(4436),
    [sym_long] = ACTIONS(4436),
    [sym_ulong] = ACTIONS(4436),
    [sym_cent] = ACTIONS(4436),
    [sym_ucent] = ACTIONS(4436),
    [sym_wchar] = ACTIONS(4436),
    [sym_dchar] = ACTIONS(4436),
    [sym_float] = ACTIONS(4436),
    [sym_double] = ACTIONS(4436),
    [sym_real] = ACTIONS(4436),
    [sym_ifloat] = ACTIONS(4436),
    [sym_idouble] = ACTIONS(4436),
    [sym_ireal] = ACTIONS(4436),
    [sym_cfloat] = ACTIONS(4436),
    [sym_cdouble] = ACTIONS(4436),
    [sym_creal] = ACTIONS(4436),
    [sym_size_t] = ACTIONS(4436),
    [sym_ptrdiff_t] = ACTIONS(4436),
    [sym_string] = ACTIONS(4436),
    [sym_cstring] = ACTIONS(4436),
    [sym_dstring] = ACTIONS(4436),
    [sym_wstring] = ACTIONS(4436),
    [sym_noreturn] = ACTIONS(4436),
    [sym_true] = ACTIONS(4436),
    [sym_false] = ACTIONS(4436),
    [sym_null] = ACTIONS(4436),
    [sym_super] = ACTIONS(4436),
    [sym_this] = ACTIONS(4436),
    [sym_abstract] = ACTIONS(4436),
    [sym_alias] = ACTIONS(4436),
    [sym_align] = ACTIONS(4436),
    [sym_asm] = ACTIONS(4436),
    [sym_assert] = ACTIONS(4436),
    [sym_auto] = ACTIONS(4436),
    [sym_break] = ACTIONS(4436),
    [sym_case] = ACTIONS(4436),
    [sym_cast] = ACTIONS(4436),
    [sym_class] = ACTIONS(4436),
    [sym_const] = ACTIONS(4436),
    [sym_continue] = ACTIONS(4436),
    [sym_debug] = ACTIONS(4436),
    [sym_default] = ACTIONS(4436),
    [sym_delegate] = ACTIONS(4436),
    [sym_delete] = ACTIONS(4436),
    [sym_deprecated] = ACTIONS(4436),
    [sym_do] = ACTIONS(4436),
    [sym_else] = ACTIONS(4436),
    [sym_enum] = ACTIONS(4436),
    [sym_export] = ACTIONS(4436),
    [sym_extern] = ACTIONS(4436),
    [sym_final] = ACTIONS(4436),
    [sym_for] = ACTIONS(4436),
    [sym_foreach] = ACTIONS(4436),
    [sym_foreach_reverse] = ACTIONS(4436),
    [sym_function] = ACTIONS(4436),
    [sym_goto] = ACTIONS(4436),
    [sym_if] = ACTIONS(4436),
    [sym_immutable] = ACTIONS(4436),
    [sym_import] = ACTIONS(4436),
    [sym_in] = ACTIONS(4436),
    [sym_inout] = ACTIONS(4436),
    [sym_interface] = ACTIONS(4436),
    [sym_invariant] = ACTIONS(4436),
    [sym_is] = ACTIONS(4436),
    [sym_mixin] = ACTIONS(4436),
    [sym_new] = ACTIONS(4436),
    [sym_nothrow] = ACTIONS(4436),
    [sym_out] = ACTIONS(4436),
    [sym_override] = ACTIONS(4436),
    [sym_package] = ACTIONS(4436),
    [sym_pragma] = ACTIONS(4436),
    [sym_private] = ACTIONS(4436),
    [sym_protected] = ACTIONS(4436),
    [sym_public] = ACTIONS(4436),
    [sym_pure] = ACTIONS(4436),
    [sym_ref] = ACTIONS(4436),
    [sym_return] = ACTIONS(4436),
    [sym_scope] = ACTIONS(4436),
    [sym_shared] = ACTIONS(4436),
    [sym_static] = ACTIONS(4436),
    [sym_struct] = ACTIONS(4436),
    [sym_switch] = ACTIONS(4436),
    [sym_synchronized] = ACTIONS(4436),
    [sym_template] = ACTIONS(4436),
    [sym_throw] = ACTIONS(4436),
    [sym_try] = ACTIONS(4436),
    [sym_typeid] = ACTIONS(4436),
    [sym_typeof] = ACTIONS(4436),
    [sym_union] = ACTIONS(4436),
    [sym_unittest] = ACTIONS(4436),
    [sym_version] = ACTIONS(4436),
    [sym_while] = ACTIONS(4436),
    [sym_with] = ACTIONS(4436),
    [sym_gshared] = ACTIONS(4436),
    [sym_traits] = ACTIONS(4436),
    [sym_vector] = ACTIONS(4436),
    [sym_void] = ACTIONS(4436),
    [anon_sym_BQUOTE] = ACTIONS(4438),
    [anon_sym_r_DQUOTE] = ACTIONS(4438),
    [anon_sym_x_DQUOTE] = ACTIONS(4438),
    [anon_sym_DQUOTE] = ACTIONS(4438),
    [anon_sym_i_BQUOTE] = ACTIONS(4438),
    [anon_sym_i_DQUOTE] = ACTIONS(4438),
    [anon_sym_iq_LBRACE] = ACTIONS(4438),
    [aux_sym_char_literal_token1] = ACTIONS(4438),
    [anon_sym_SQUOTE] = ACTIONS(4436),
    [anon_sym___DATE__] = ACTIONS(4436),
    [anon_sym___FILE__] = ACTIONS(4436),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4436),
    [anon_sym___FUNCTION__] = ACTIONS(4436),
    [anon_sym___LINE__] = ACTIONS(4436),
    [anon_sym___MODULE__] = ACTIONS(4436),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4436),
    [anon_sym___TIME__] = ACTIONS(4436),
    [anon_sym___TIMESTAMP__] = ACTIONS(4436),
    [anon_sym___VENDOR__] = ACTIONS(4436),
    [anon_sym___VERSION__] = ACTIONS(4436),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4438),
    [sym_float_literal] = ACTIONS(4438),
    [sym__string] = ACTIONS(4438),
  },
  [1518] = {
    [sym_identifier] = ACTIONS(4847),
    [anon_sym_q_LBRACE] = ACTIONS(4849),
    [anon_sym_RBRACE] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_DOT] = ACTIONS(4849),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4849),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_PLUS_PLUS] = ACTIONS(4849),
    [anon_sym_BANG] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(4849),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_DOLLAR] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_TILDE] = ACTIONS(4849),
    [anon_sym_AT] = ACTIONS(4849),
    [sym_bool] = ACTIONS(4847),
    [sym_byte] = ACTIONS(4847),
    [sym_ubyte] = ACTIONS(4847),
    [sym_char] = ACTIONS(4847),
    [sym_short] = ACTIONS(4847),
    [sym_ushort] = ACTIONS(4847),
    [sym_int] = ACTIONS(4847),
    [sym_uint] = ACTIONS(4847),
    [sym_long] = ACTIONS(4847),
    [sym_ulong] = ACTIONS(4847),
    [sym_cent] = ACTIONS(4847),
    [sym_ucent] = ACTIONS(4847),
    [sym_wchar] = ACTIONS(4847),
    [sym_dchar] = ACTIONS(4847),
    [sym_float] = ACTIONS(4847),
    [sym_double] = ACTIONS(4847),
    [sym_real] = ACTIONS(4847),
    [sym_ifloat] = ACTIONS(4847),
    [sym_idouble] = ACTIONS(4847),
    [sym_ireal] = ACTIONS(4847),
    [sym_cfloat] = ACTIONS(4847),
    [sym_cdouble] = ACTIONS(4847),
    [sym_creal] = ACTIONS(4847),
    [sym_size_t] = ACTIONS(4847),
    [sym_ptrdiff_t] = ACTIONS(4847),
    [sym_string] = ACTIONS(4847),
    [sym_cstring] = ACTIONS(4847),
    [sym_dstring] = ACTIONS(4847),
    [sym_wstring] = ACTIONS(4847),
    [sym_noreturn] = ACTIONS(4847),
    [sym_true] = ACTIONS(4847),
    [sym_false] = ACTIONS(4847),
    [sym_null] = ACTIONS(4847),
    [sym_super] = ACTIONS(4847),
    [sym_this] = ACTIONS(4847),
    [sym_abstract] = ACTIONS(4847),
    [sym_alias] = ACTIONS(4847),
    [sym_align] = ACTIONS(4847),
    [sym_asm] = ACTIONS(4847),
    [sym_assert] = ACTIONS(4847),
    [sym_auto] = ACTIONS(4847),
    [sym_break] = ACTIONS(4847),
    [sym_case] = ACTIONS(4847),
    [sym_cast] = ACTIONS(4847),
    [sym_class] = ACTIONS(4847),
    [sym_const] = ACTIONS(4847),
    [sym_continue] = ACTIONS(4847),
    [sym_debug] = ACTIONS(4847),
    [sym_default] = ACTIONS(4847),
    [sym_delegate] = ACTIONS(4847),
    [sym_delete] = ACTIONS(4847),
    [sym_deprecated] = ACTIONS(4847),
    [sym_do] = ACTIONS(4847),
    [sym_else] = ACTIONS(4847),
    [sym_enum] = ACTIONS(4847),
    [sym_export] = ACTIONS(4847),
    [sym_extern] = ACTIONS(4847),
    [sym_final] = ACTIONS(4847),
    [sym_for] = ACTIONS(4847),
    [sym_foreach] = ACTIONS(4847),
    [sym_foreach_reverse] = ACTIONS(4847),
    [sym_function] = ACTIONS(4847),
    [sym_goto] = ACTIONS(4847),
    [sym_if] = ACTIONS(4847),
    [sym_immutable] = ACTIONS(4847),
    [sym_import] = ACTIONS(4847),
    [sym_in] = ACTIONS(4847),
    [sym_inout] = ACTIONS(4847),
    [sym_interface] = ACTIONS(4847),
    [sym_invariant] = ACTIONS(4847),
    [sym_is] = ACTIONS(4847),
    [sym_mixin] = ACTIONS(4847),
    [sym_new] = ACTIONS(4847),
    [sym_nothrow] = ACTIONS(4847),
    [sym_out] = ACTIONS(4847),
    [sym_override] = ACTIONS(4847),
    [sym_package] = ACTIONS(4847),
    [sym_pragma] = ACTIONS(4847),
    [sym_private] = ACTIONS(4847),
    [sym_protected] = ACTIONS(4847),
    [sym_public] = ACTIONS(4847),
    [sym_pure] = ACTIONS(4847),
    [sym_ref] = ACTIONS(4847),
    [sym_return] = ACTIONS(4847),
    [sym_scope] = ACTIONS(4847),
    [sym_shared] = ACTIONS(4847),
    [sym_static] = ACTIONS(4847),
    [sym_struct] = ACTIONS(4847),
    [sym_switch] = ACTIONS(4847),
    [sym_synchronized] = ACTIONS(4847),
    [sym_template] = ACTIONS(4847),
    [sym_throw] = ACTIONS(4847),
    [sym_try] = ACTIONS(4847),
    [sym_typeid] = ACTIONS(4847),
    [sym_typeof] = ACTIONS(4847),
    [sym_union] = ACTIONS(4847),
    [sym_unittest] = ACTIONS(4847),
    [sym_version] = ACTIONS(4847),
    [sym_while] = ACTIONS(4847),
    [sym_with] = ACTIONS(4847),
    [sym_gshared] = ACTIONS(4847),
    [sym_traits] = ACTIONS(4847),
    [sym_vector] = ACTIONS(4847),
    [sym_void] = ACTIONS(4847),
    [anon_sym_BQUOTE] = ACTIONS(4849),
    [anon_sym_r_DQUOTE] = ACTIONS(4849),
    [anon_sym_x_DQUOTE] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4849),
    [anon_sym_i_BQUOTE] = ACTIONS(4849),
    [anon_sym_i_DQUOTE] = ACTIONS(4849),
    [anon_sym_iq_LBRACE] = ACTIONS(4849),
    [aux_sym_char_literal_token1] = ACTIONS(4849),
    [anon_sym_SQUOTE] = ACTIONS(4847),
    [anon_sym___DATE__] = ACTIONS(4847),
    [anon_sym___FILE__] = ACTIONS(4847),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4847),
    [anon_sym___FUNCTION__] = ACTIONS(4847),
    [anon_sym___LINE__] = ACTIONS(4847),
    [anon_sym___MODULE__] = ACTIONS(4847),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4847),
    [anon_sym___TIME__] = ACTIONS(4847),
    [anon_sym___TIMESTAMP__] = ACTIONS(4847),
    [anon_sym___VENDOR__] = ACTIONS(4847),
    [anon_sym___VERSION__] = ACTIONS(4847),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4849),
    [sym_float_literal] = ACTIONS(4849),
    [sym__string] = ACTIONS(4849),
  },
  [1519] = {
    [sym_identifier] = ACTIONS(4801),
    [anon_sym_q_LBRACE] = ACTIONS(4803),
    [anon_sym_RBRACE] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(4803),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_AMP] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4803),
    [anon_sym_PLUS] = ACTIONS(4801),
    [anon_sym_PLUS_PLUS] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(4803),
    [anon_sym_LPAREN] = ACTIONS(4803),
    [anon_sym_RPAREN] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4803),
    [anon_sym_DOLLAR] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [anon_sym_AT] = ACTIONS(4803),
    [sym_bool] = ACTIONS(4801),
    [sym_byte] = ACTIONS(4801),
    [sym_ubyte] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_short] = ACTIONS(4801),
    [sym_ushort] = ACTIONS(4801),
    [sym_int] = ACTIONS(4801),
    [sym_uint] = ACTIONS(4801),
    [sym_long] = ACTIONS(4801),
    [sym_ulong] = ACTIONS(4801),
    [sym_cent] = ACTIONS(4801),
    [sym_ucent] = ACTIONS(4801),
    [sym_wchar] = ACTIONS(4801),
    [sym_dchar] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_double] = ACTIONS(4801),
    [sym_real] = ACTIONS(4801),
    [sym_ifloat] = ACTIONS(4801),
    [sym_idouble] = ACTIONS(4801),
    [sym_ireal] = ACTIONS(4801),
    [sym_cfloat] = ACTIONS(4801),
    [sym_cdouble] = ACTIONS(4801),
    [sym_creal] = ACTIONS(4801),
    [sym_size_t] = ACTIONS(4801),
    [sym_ptrdiff_t] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym_cstring] = ACTIONS(4801),
    [sym_dstring] = ACTIONS(4801),
    [sym_wstring] = ACTIONS(4801),
    [sym_noreturn] = ACTIONS(4801),
    [sym_true] = ACTIONS(4801),
    [sym_false] = ACTIONS(4801),
    [sym_null] = ACTIONS(4801),
    [sym_super] = ACTIONS(4801),
    [sym_this] = ACTIONS(4801),
    [sym_abstract] = ACTIONS(4801),
    [sym_alias] = ACTIONS(4801),
    [sym_align] = ACTIONS(4801),
    [sym_asm] = ACTIONS(4801),
    [sym_assert] = ACTIONS(4801),
    [sym_auto] = ACTIONS(4801),
    [sym_break] = ACTIONS(4801),
    [sym_case] = ACTIONS(4801),
    [sym_cast] = ACTIONS(4801),
    [sym_class] = ACTIONS(4801),
    [sym_const] = ACTIONS(4801),
    [sym_continue] = ACTIONS(4801),
    [sym_debug] = ACTIONS(4801),
    [sym_default] = ACTIONS(4801),
    [sym_delegate] = ACTIONS(4801),
    [sym_delete] = ACTIONS(4801),
    [sym_deprecated] = ACTIONS(4801),
    [sym_do] = ACTIONS(4801),
    [sym_else] = ACTIONS(4801),
    [sym_enum] = ACTIONS(4801),
    [sym_export] = ACTIONS(4801),
    [sym_extern] = ACTIONS(4801),
    [sym_final] = ACTIONS(4801),
    [sym_for] = ACTIONS(4801),
    [sym_foreach] = ACTIONS(4801),
    [sym_foreach_reverse] = ACTIONS(4801),
    [sym_function] = ACTIONS(4801),
    [sym_goto] = ACTIONS(4801),
    [sym_if] = ACTIONS(4801),
    [sym_immutable] = ACTIONS(4801),
    [sym_import] = ACTIONS(4801),
    [sym_in] = ACTIONS(4801),
    [sym_inout] = ACTIONS(4801),
    [sym_interface] = ACTIONS(4801),
    [sym_invariant] = ACTIONS(4801),
    [sym_is] = ACTIONS(4801),
    [sym_mixin] = ACTIONS(4801),
    [sym_new] = ACTIONS(4801),
    [sym_nothrow] = ACTIONS(4801),
    [sym_out] = ACTIONS(4801),
    [sym_override] = ACTIONS(4801),
    [sym_package] = ACTIONS(4801),
    [sym_pragma] = ACTIONS(4801),
    [sym_private] = ACTIONS(4801),
    [sym_protected] = ACTIONS(4801),
    [sym_public] = ACTIONS(4801),
    [sym_pure] = ACTIONS(4801),
    [sym_ref] = ACTIONS(4801),
    [sym_return] = ACTIONS(4801),
    [sym_scope] = ACTIONS(4801),
    [sym_shared] = ACTIONS(4801),
    [sym_static] = ACTIONS(4801),
    [sym_struct] = ACTIONS(4801),
    [sym_switch] = ACTIONS(4801),
    [sym_synchronized] = ACTIONS(4801),
    [sym_template] = ACTIONS(4801),
    [sym_throw] = ACTIONS(4801),
    [sym_try] = ACTIONS(4801),
    [sym_typeid] = ACTIONS(4801),
    [sym_typeof] = ACTIONS(4801),
    [sym_union] = ACTIONS(4801),
    [sym_unittest] = ACTIONS(4801),
    [sym_version] = ACTIONS(4801),
    [sym_while] = ACTIONS(4801),
    [sym_with] = ACTIONS(4801),
    [sym_gshared] = ACTIONS(4801),
    [sym_traits] = ACTIONS(4801),
    [sym_vector] = ACTIONS(4801),
    [sym_void] = ACTIONS(4801),
    [anon_sym_BQUOTE] = ACTIONS(4803),
    [anon_sym_r_DQUOTE] = ACTIONS(4803),
    [anon_sym_x_DQUOTE] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(4803),
    [anon_sym_i_BQUOTE] = ACTIONS(4803),
    [anon_sym_i_DQUOTE] = ACTIONS(4803),
    [anon_sym_iq_LBRACE] = ACTIONS(4803),
    [aux_sym_char_literal_token1] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4801),
    [anon_sym___DATE__] = ACTIONS(4801),
    [anon_sym___FILE__] = ACTIONS(4801),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4801),
    [anon_sym___FUNCTION__] = ACTIONS(4801),
    [anon_sym___LINE__] = ACTIONS(4801),
    [anon_sym___MODULE__] = ACTIONS(4801),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4801),
    [anon_sym___TIME__] = ACTIONS(4801),
    [anon_sym___TIMESTAMP__] = ACTIONS(4801),
    [anon_sym___VENDOR__] = ACTIONS(4801),
    [anon_sym___VERSION__] = ACTIONS(4801),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4803),
    [sym_float_literal] = ACTIONS(4803),
    [sym__string] = ACTIONS(4803),
  },
  [1520] = {
    [sym_identifier] = ACTIONS(4805),
    [anon_sym_q_LBRACE] = ACTIONS(4807),
    [anon_sym_RBRACE] = ACTIONS(4807),
    [anon_sym_LBRACE] = ACTIONS(4807),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_DASH] = ACTIONS(4805),
    [anon_sym_DASH_DASH] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(4805),
    [anon_sym_PLUS_PLUS] = ACTIONS(4807),
    [anon_sym_BANG] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(4807),
    [anon_sym_RPAREN] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4807),
    [anon_sym_SEMI] = ACTIONS(4807),
    [anon_sym_DOLLAR] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [anon_sym_AT] = ACTIONS(4807),
    [sym_bool] = ACTIONS(4805),
    [sym_byte] = ACTIONS(4805),
    [sym_ubyte] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_short] = ACTIONS(4805),
    [sym_ushort] = ACTIONS(4805),
    [sym_int] = ACTIONS(4805),
    [sym_uint] = ACTIONS(4805),
    [sym_long] = ACTIONS(4805),
    [sym_ulong] = ACTIONS(4805),
    [sym_cent] = ACTIONS(4805),
    [sym_ucent] = ACTIONS(4805),
    [sym_wchar] = ACTIONS(4805),
    [sym_dchar] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_double] = ACTIONS(4805),
    [sym_real] = ACTIONS(4805),
    [sym_ifloat] = ACTIONS(4805),
    [sym_idouble] = ACTIONS(4805),
    [sym_ireal] = ACTIONS(4805),
    [sym_cfloat] = ACTIONS(4805),
    [sym_cdouble] = ACTIONS(4805),
    [sym_creal] = ACTIONS(4805),
    [sym_size_t] = ACTIONS(4805),
    [sym_ptrdiff_t] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym_cstring] = ACTIONS(4805),
    [sym_dstring] = ACTIONS(4805),
    [sym_wstring] = ACTIONS(4805),
    [sym_noreturn] = ACTIONS(4805),
    [sym_true] = ACTIONS(4805),
    [sym_false] = ACTIONS(4805),
    [sym_null] = ACTIONS(4805),
    [sym_super] = ACTIONS(4805),
    [sym_this] = ACTIONS(4805),
    [sym_abstract] = ACTIONS(4805),
    [sym_alias] = ACTIONS(4805),
    [sym_align] = ACTIONS(4805),
    [sym_asm] = ACTIONS(4805),
    [sym_assert] = ACTIONS(4805),
    [sym_auto] = ACTIONS(4805),
    [sym_break] = ACTIONS(4805),
    [sym_case] = ACTIONS(4805),
    [sym_cast] = ACTIONS(4805),
    [sym_class] = ACTIONS(4805),
    [sym_const] = ACTIONS(4805),
    [sym_continue] = ACTIONS(4805),
    [sym_debug] = ACTIONS(4805),
    [sym_default] = ACTIONS(4805),
    [sym_delegate] = ACTIONS(4805),
    [sym_delete] = ACTIONS(4805),
    [sym_deprecated] = ACTIONS(4805),
    [sym_do] = ACTIONS(4805),
    [sym_else] = ACTIONS(4805),
    [sym_enum] = ACTIONS(4805),
    [sym_export] = ACTIONS(4805),
    [sym_extern] = ACTIONS(4805),
    [sym_final] = ACTIONS(4805),
    [sym_for] = ACTIONS(4805),
    [sym_foreach] = ACTIONS(4805),
    [sym_foreach_reverse] = ACTIONS(4805),
    [sym_function] = ACTIONS(4805),
    [sym_goto] = ACTIONS(4805),
    [sym_if] = ACTIONS(4805),
    [sym_immutable] = ACTIONS(4805),
    [sym_import] = ACTIONS(4805),
    [sym_in] = ACTIONS(4805),
    [sym_inout] = ACTIONS(4805),
    [sym_interface] = ACTIONS(4805),
    [sym_invariant] = ACTIONS(4805),
    [sym_is] = ACTIONS(4805),
    [sym_mixin] = ACTIONS(4805),
    [sym_new] = ACTIONS(4805),
    [sym_nothrow] = ACTIONS(4805),
    [sym_out] = ACTIONS(4805),
    [sym_override] = ACTIONS(4805),
    [sym_package] = ACTIONS(4805),
    [sym_pragma] = ACTIONS(4805),
    [sym_private] = ACTIONS(4805),
    [sym_protected] = ACTIONS(4805),
    [sym_public] = ACTIONS(4805),
    [sym_pure] = ACTIONS(4805),
    [sym_ref] = ACTIONS(4805),
    [sym_return] = ACTIONS(4805),
    [sym_scope] = ACTIONS(4805),
    [sym_shared] = ACTIONS(4805),
    [sym_static] = ACTIONS(4805),
    [sym_struct] = ACTIONS(4805),
    [sym_switch] = ACTIONS(4805),
    [sym_synchronized] = ACTIONS(4805),
    [sym_template] = ACTIONS(4805),
    [sym_throw] = ACTIONS(4805),
    [sym_try] = ACTIONS(4805),
    [sym_typeid] = ACTIONS(4805),
    [sym_typeof] = ACTIONS(4805),
    [sym_union] = ACTIONS(4805),
    [sym_unittest] = ACTIONS(4805),
    [sym_version] = ACTIONS(4805),
    [sym_while] = ACTIONS(4805),
    [sym_with] = ACTIONS(4805),
    [sym_gshared] = ACTIONS(4805),
    [sym_traits] = ACTIONS(4805),
    [sym_vector] = ACTIONS(4805),
    [sym_void] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4807),
    [anon_sym_r_DQUOTE] = ACTIONS(4807),
    [anon_sym_x_DQUOTE] = ACTIONS(4807),
    [anon_sym_DQUOTE] = ACTIONS(4807),
    [anon_sym_i_BQUOTE] = ACTIONS(4807),
    [anon_sym_i_DQUOTE] = ACTIONS(4807),
    [anon_sym_iq_LBRACE] = ACTIONS(4807),
    [aux_sym_char_literal_token1] = ACTIONS(4807),
    [anon_sym_SQUOTE] = ACTIONS(4805),
    [anon_sym___DATE__] = ACTIONS(4805),
    [anon_sym___FILE__] = ACTIONS(4805),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4805),
    [anon_sym___FUNCTION__] = ACTIONS(4805),
    [anon_sym___LINE__] = ACTIONS(4805),
    [anon_sym___MODULE__] = ACTIONS(4805),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4805),
    [anon_sym___TIME__] = ACTIONS(4805),
    [anon_sym___TIMESTAMP__] = ACTIONS(4805),
    [anon_sym___VENDOR__] = ACTIONS(4805),
    [anon_sym___VERSION__] = ACTIONS(4805),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4807),
    [sym_float_literal] = ACTIONS(4807),
    [sym__string] = ACTIONS(4807),
  },
  [1521] = {
    [sym_identifier] = ACTIONS(4809),
    [anon_sym_q_LBRACE] = ACTIONS(4811),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4811),
    [anon_sym_AMP] = ACTIONS(4811),
    [anon_sym_DASH] = ACTIONS(4809),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4809),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_BANG] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(4811),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_DOLLAR] = ACTIONS(4811),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_TILDE] = ACTIONS(4811),
    [anon_sym_AT] = ACTIONS(4811),
    [sym_bool] = ACTIONS(4809),
    [sym_byte] = ACTIONS(4809),
    [sym_ubyte] = ACTIONS(4809),
    [sym_char] = ACTIONS(4809),
    [sym_short] = ACTIONS(4809),
    [sym_ushort] = ACTIONS(4809),
    [sym_int] = ACTIONS(4809),
    [sym_uint] = ACTIONS(4809),
    [sym_long] = ACTIONS(4809),
    [sym_ulong] = ACTIONS(4809),
    [sym_cent] = ACTIONS(4809),
    [sym_ucent] = ACTIONS(4809),
    [sym_wchar] = ACTIONS(4809),
    [sym_dchar] = ACTIONS(4809),
    [sym_float] = ACTIONS(4809),
    [sym_double] = ACTIONS(4809),
    [sym_real] = ACTIONS(4809),
    [sym_ifloat] = ACTIONS(4809),
    [sym_idouble] = ACTIONS(4809),
    [sym_ireal] = ACTIONS(4809),
    [sym_cfloat] = ACTIONS(4809),
    [sym_cdouble] = ACTIONS(4809),
    [sym_creal] = ACTIONS(4809),
    [sym_size_t] = ACTIONS(4809),
    [sym_ptrdiff_t] = ACTIONS(4809),
    [sym_string] = ACTIONS(4809),
    [sym_cstring] = ACTIONS(4809),
    [sym_dstring] = ACTIONS(4809),
    [sym_wstring] = ACTIONS(4809),
    [sym_noreturn] = ACTIONS(4809),
    [sym_true] = ACTIONS(4809),
    [sym_false] = ACTIONS(4809),
    [sym_null] = ACTIONS(4809),
    [sym_super] = ACTIONS(4809),
    [sym_this] = ACTIONS(4809),
    [sym_abstract] = ACTIONS(4809),
    [sym_alias] = ACTIONS(4809),
    [sym_align] = ACTIONS(4809),
    [sym_asm] = ACTIONS(4809),
    [sym_assert] = ACTIONS(4809),
    [sym_auto] = ACTIONS(4809),
    [sym_break] = ACTIONS(4809),
    [sym_case] = ACTIONS(4809),
    [sym_cast] = ACTIONS(4809),
    [sym_class] = ACTIONS(4809),
    [sym_const] = ACTIONS(4809),
    [sym_continue] = ACTIONS(4809),
    [sym_debug] = ACTIONS(4809),
    [sym_default] = ACTIONS(4809),
    [sym_delegate] = ACTIONS(4809),
    [sym_delete] = ACTIONS(4809),
    [sym_deprecated] = ACTIONS(4809),
    [sym_do] = ACTIONS(4809),
    [sym_else] = ACTIONS(4809),
    [sym_enum] = ACTIONS(4809),
    [sym_export] = ACTIONS(4809),
    [sym_extern] = ACTIONS(4809),
    [sym_final] = ACTIONS(4809),
    [sym_for] = ACTIONS(4809),
    [sym_foreach] = ACTIONS(4809),
    [sym_foreach_reverse] = ACTIONS(4809),
    [sym_function] = ACTIONS(4809),
    [sym_goto] = ACTIONS(4809),
    [sym_if] = ACTIONS(4809),
    [sym_immutable] = ACTIONS(4809),
    [sym_import] = ACTIONS(4809),
    [sym_in] = ACTIONS(4809),
    [sym_inout] = ACTIONS(4809),
    [sym_interface] = ACTIONS(4809),
    [sym_invariant] = ACTIONS(4809),
    [sym_is] = ACTIONS(4809),
    [sym_mixin] = ACTIONS(4809),
    [sym_new] = ACTIONS(4809),
    [sym_nothrow] = ACTIONS(4809),
    [sym_out] = ACTIONS(4809),
    [sym_override] = ACTIONS(4809),
    [sym_package] = ACTIONS(4809),
    [sym_pragma] = ACTIONS(4809),
    [sym_private] = ACTIONS(4809),
    [sym_protected] = ACTIONS(4809),
    [sym_public] = ACTIONS(4809),
    [sym_pure] = ACTIONS(4809),
    [sym_ref] = ACTIONS(4809),
    [sym_return] = ACTIONS(4809),
    [sym_scope] = ACTIONS(4809),
    [sym_shared] = ACTIONS(4809),
    [sym_static] = ACTIONS(4809),
    [sym_struct] = ACTIONS(4809),
    [sym_switch] = ACTIONS(4809),
    [sym_synchronized] = ACTIONS(4809),
    [sym_template] = ACTIONS(4809),
    [sym_throw] = ACTIONS(4809),
    [sym_try] = ACTIONS(4809),
    [sym_typeid] = ACTIONS(4809),
    [sym_typeof] = ACTIONS(4809),
    [sym_union] = ACTIONS(4809),
    [sym_unittest] = ACTIONS(4809),
    [sym_version] = ACTIONS(4809),
    [sym_while] = ACTIONS(4809),
    [sym_with] = ACTIONS(4809),
    [sym_gshared] = ACTIONS(4809),
    [sym_traits] = ACTIONS(4809),
    [sym_vector] = ACTIONS(4809),
    [sym_void] = ACTIONS(4809),
    [anon_sym_BQUOTE] = ACTIONS(4811),
    [anon_sym_r_DQUOTE] = ACTIONS(4811),
    [anon_sym_x_DQUOTE] = ACTIONS(4811),
    [anon_sym_DQUOTE] = ACTIONS(4811),
    [anon_sym_i_BQUOTE] = ACTIONS(4811),
    [anon_sym_i_DQUOTE] = ACTIONS(4811),
    [anon_sym_iq_LBRACE] = ACTIONS(4811),
    [aux_sym_char_literal_token1] = ACTIONS(4811),
    [anon_sym_SQUOTE] = ACTIONS(4809),
    [anon_sym___DATE__] = ACTIONS(4809),
    [anon_sym___FILE__] = ACTIONS(4809),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4809),
    [anon_sym___FUNCTION__] = ACTIONS(4809),
    [anon_sym___LINE__] = ACTIONS(4809),
    [anon_sym___MODULE__] = ACTIONS(4809),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4809),
    [anon_sym___TIME__] = ACTIONS(4809),
    [anon_sym___TIMESTAMP__] = ACTIONS(4809),
    [anon_sym___VENDOR__] = ACTIONS(4809),
    [anon_sym___VERSION__] = ACTIONS(4809),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4811),
    [sym_float_literal] = ACTIONS(4811),
    [sym__string] = ACTIONS(4811),
  },
  [1522] = {
    [sym_identifier] = ACTIONS(4813),
    [anon_sym_q_LBRACE] = ACTIONS(4815),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_LBRACE] = ACTIONS(4815),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4813),
    [anon_sym_DASH_DASH] = ACTIONS(4815),
    [anon_sym_PLUS] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_LPAREN] = ACTIONS(4815),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(4815),
    [anon_sym_SEMI] = ACTIONS(4815),
    [anon_sym_DOLLAR] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4815),
    [anon_sym_AT] = ACTIONS(4815),
    [sym_bool] = ACTIONS(4813),
    [sym_byte] = ACTIONS(4813),
    [sym_ubyte] = ACTIONS(4813),
    [sym_char] = ACTIONS(4813),
    [sym_short] = ACTIONS(4813),
    [sym_ushort] = ACTIONS(4813),
    [sym_int] = ACTIONS(4813),
    [sym_uint] = ACTIONS(4813),
    [sym_long] = ACTIONS(4813),
    [sym_ulong] = ACTIONS(4813),
    [sym_cent] = ACTIONS(4813),
    [sym_ucent] = ACTIONS(4813),
    [sym_wchar] = ACTIONS(4813),
    [sym_dchar] = ACTIONS(4813),
    [sym_float] = ACTIONS(4813),
    [sym_double] = ACTIONS(4813),
    [sym_real] = ACTIONS(4813),
    [sym_ifloat] = ACTIONS(4813),
    [sym_idouble] = ACTIONS(4813),
    [sym_ireal] = ACTIONS(4813),
    [sym_cfloat] = ACTIONS(4813),
    [sym_cdouble] = ACTIONS(4813),
    [sym_creal] = ACTIONS(4813),
    [sym_size_t] = ACTIONS(4813),
    [sym_ptrdiff_t] = ACTIONS(4813),
    [sym_string] = ACTIONS(4813),
    [sym_cstring] = ACTIONS(4813),
    [sym_dstring] = ACTIONS(4813),
    [sym_wstring] = ACTIONS(4813),
    [sym_noreturn] = ACTIONS(4813),
    [sym_true] = ACTIONS(4813),
    [sym_false] = ACTIONS(4813),
    [sym_null] = ACTIONS(4813),
    [sym_super] = ACTIONS(4813),
    [sym_this] = ACTIONS(4813),
    [sym_abstract] = ACTIONS(4813),
    [sym_alias] = ACTIONS(4813),
    [sym_align] = ACTIONS(4813),
    [sym_asm] = ACTIONS(4813),
    [sym_assert] = ACTIONS(4813),
    [sym_auto] = ACTIONS(4813),
    [sym_break] = ACTIONS(4813),
    [sym_case] = ACTIONS(4813),
    [sym_cast] = ACTIONS(4813),
    [sym_class] = ACTIONS(4813),
    [sym_const] = ACTIONS(4813),
    [sym_continue] = ACTIONS(4813),
    [sym_debug] = ACTIONS(4813),
    [sym_default] = ACTIONS(4813),
    [sym_delegate] = ACTIONS(4813),
    [sym_delete] = ACTIONS(4813),
    [sym_deprecated] = ACTIONS(4813),
    [sym_do] = ACTIONS(4813),
    [sym_else] = ACTIONS(4813),
    [sym_enum] = ACTIONS(4813),
    [sym_export] = ACTIONS(4813),
    [sym_extern] = ACTIONS(4813),
    [sym_final] = ACTIONS(4813),
    [sym_for] = ACTIONS(4813),
    [sym_foreach] = ACTIONS(4813),
    [sym_foreach_reverse] = ACTIONS(4813),
    [sym_function] = ACTIONS(4813),
    [sym_goto] = ACTIONS(4813),
    [sym_if] = ACTIONS(4813),
    [sym_immutable] = ACTIONS(4813),
    [sym_import] = ACTIONS(4813),
    [sym_in] = ACTIONS(4813),
    [sym_inout] = ACTIONS(4813),
    [sym_interface] = ACTIONS(4813),
    [sym_invariant] = ACTIONS(4813),
    [sym_is] = ACTIONS(4813),
    [sym_mixin] = ACTIONS(4813),
    [sym_new] = ACTIONS(4813),
    [sym_nothrow] = ACTIONS(4813),
    [sym_out] = ACTIONS(4813),
    [sym_override] = ACTIONS(4813),
    [sym_package] = ACTIONS(4813),
    [sym_pragma] = ACTIONS(4813),
    [sym_private] = ACTIONS(4813),
    [sym_protected] = ACTIONS(4813),
    [sym_public] = ACTIONS(4813),
    [sym_pure] = ACTIONS(4813),
    [sym_ref] = ACTIONS(4813),
    [sym_return] = ACTIONS(4813),
    [sym_scope] = ACTIONS(4813),
    [sym_shared] = ACTIONS(4813),
    [sym_static] = ACTIONS(4813),
    [sym_struct] = ACTIONS(4813),
    [sym_switch] = ACTIONS(4813),
    [sym_synchronized] = ACTIONS(4813),
    [sym_template] = ACTIONS(4813),
    [sym_throw] = ACTIONS(4813),
    [sym_try] = ACTIONS(4813),
    [sym_typeid] = ACTIONS(4813),
    [sym_typeof] = ACTIONS(4813),
    [sym_union] = ACTIONS(4813),
    [sym_unittest] = ACTIONS(4813),
    [sym_version] = ACTIONS(4813),
    [sym_while] = ACTIONS(4813),
    [sym_with] = ACTIONS(4813),
    [sym_gshared] = ACTIONS(4813),
    [sym_traits] = ACTIONS(4813),
    [sym_vector] = ACTIONS(4813),
    [sym_void] = ACTIONS(4813),
    [anon_sym_BQUOTE] = ACTIONS(4815),
    [anon_sym_r_DQUOTE] = ACTIONS(4815),
    [anon_sym_x_DQUOTE] = ACTIONS(4815),
    [anon_sym_DQUOTE] = ACTIONS(4815),
    [anon_sym_i_BQUOTE] = ACTIONS(4815),
    [anon_sym_i_DQUOTE] = ACTIONS(4815),
    [anon_sym_iq_LBRACE] = ACTIONS(4815),
    [aux_sym_char_literal_token1] = ACTIONS(4815),
    [anon_sym_SQUOTE] = ACTIONS(4813),
    [anon_sym___DATE__] = ACTIONS(4813),
    [anon_sym___FILE__] = ACTIONS(4813),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4813),
    [anon_sym___FUNCTION__] = ACTIONS(4813),
    [anon_sym___LINE__] = ACTIONS(4813),
    [anon_sym___MODULE__] = ACTIONS(4813),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4813),
    [anon_sym___TIME__] = ACTIONS(4813),
    [anon_sym___TIMESTAMP__] = ACTIONS(4813),
    [anon_sym___VENDOR__] = ACTIONS(4813),
    [anon_sym___VERSION__] = ACTIONS(4813),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4815),
    [sym_float_literal] = ACTIONS(4815),
    [sym__string] = ACTIONS(4815),
  },
  [1523] = {
    [sym_identifier] = ACTIONS(4817),
    [anon_sym_q_LBRACE] = ACTIONS(4819),
    [anon_sym_RBRACE] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4819),
    [anon_sym_DOT] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4817),
    [anon_sym_DASH_DASH] = ACTIONS(4819),
    [anon_sym_PLUS] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4819),
    [anon_sym_BANG] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym_RPAREN] = ACTIONS(4819),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_DOLLAR] = ACTIONS(4819),
    [anon_sym_STAR] = ACTIONS(4819),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_AT] = ACTIONS(4819),
    [sym_bool] = ACTIONS(4817),
    [sym_byte] = ACTIONS(4817),
    [sym_ubyte] = ACTIONS(4817),
    [sym_char] = ACTIONS(4817),
    [sym_short] = ACTIONS(4817),
    [sym_ushort] = ACTIONS(4817),
    [sym_int] = ACTIONS(4817),
    [sym_uint] = ACTIONS(4817),
    [sym_long] = ACTIONS(4817),
    [sym_ulong] = ACTIONS(4817),
    [sym_cent] = ACTIONS(4817),
    [sym_ucent] = ACTIONS(4817),
    [sym_wchar] = ACTIONS(4817),
    [sym_dchar] = ACTIONS(4817),
    [sym_float] = ACTIONS(4817),
    [sym_double] = ACTIONS(4817),
    [sym_real] = ACTIONS(4817),
    [sym_ifloat] = ACTIONS(4817),
    [sym_idouble] = ACTIONS(4817),
    [sym_ireal] = ACTIONS(4817),
    [sym_cfloat] = ACTIONS(4817),
    [sym_cdouble] = ACTIONS(4817),
    [sym_creal] = ACTIONS(4817),
    [sym_size_t] = ACTIONS(4817),
    [sym_ptrdiff_t] = ACTIONS(4817),
    [sym_string] = ACTIONS(4817),
    [sym_cstring] = ACTIONS(4817),
    [sym_dstring] = ACTIONS(4817),
    [sym_wstring] = ACTIONS(4817),
    [sym_noreturn] = ACTIONS(4817),
    [sym_true] = ACTIONS(4817),
    [sym_false] = ACTIONS(4817),
    [sym_null] = ACTIONS(4817),
    [sym_super] = ACTIONS(4817),
    [sym_this] = ACTIONS(4817),
    [sym_abstract] = ACTIONS(4817),
    [sym_alias] = ACTIONS(4817),
    [sym_align] = ACTIONS(4817),
    [sym_asm] = ACTIONS(4817),
    [sym_assert] = ACTIONS(4817),
    [sym_auto] = ACTIONS(4817),
    [sym_break] = ACTIONS(4817),
    [sym_case] = ACTIONS(4817),
    [sym_cast] = ACTIONS(4817),
    [sym_class] = ACTIONS(4817),
    [sym_const] = ACTIONS(4817),
    [sym_continue] = ACTIONS(4817),
    [sym_debug] = ACTIONS(4817),
    [sym_default] = ACTIONS(4817),
    [sym_delegate] = ACTIONS(4817),
    [sym_delete] = ACTIONS(4817),
    [sym_deprecated] = ACTIONS(4817),
    [sym_do] = ACTIONS(4817),
    [sym_else] = ACTIONS(4817),
    [sym_enum] = ACTIONS(4817),
    [sym_export] = ACTIONS(4817),
    [sym_extern] = ACTIONS(4817),
    [sym_final] = ACTIONS(4817),
    [sym_for] = ACTIONS(4817),
    [sym_foreach] = ACTIONS(4817),
    [sym_foreach_reverse] = ACTIONS(4817),
    [sym_function] = ACTIONS(4817),
    [sym_goto] = ACTIONS(4817),
    [sym_if] = ACTIONS(4817),
    [sym_immutable] = ACTIONS(4817),
    [sym_import] = ACTIONS(4817),
    [sym_in] = ACTIONS(4817),
    [sym_inout] = ACTIONS(4817),
    [sym_interface] = ACTIONS(4817),
    [sym_invariant] = ACTIONS(4817),
    [sym_is] = ACTIONS(4817),
    [sym_mixin] = ACTIONS(4817),
    [sym_new] = ACTIONS(4817),
    [sym_nothrow] = ACTIONS(4817),
    [sym_out] = ACTIONS(4817),
    [sym_override] = ACTIONS(4817),
    [sym_package] = ACTIONS(4817),
    [sym_pragma] = ACTIONS(4817),
    [sym_private] = ACTIONS(4817),
    [sym_protected] = ACTIONS(4817),
    [sym_public] = ACTIONS(4817),
    [sym_pure] = ACTIONS(4817),
    [sym_ref] = ACTIONS(4817),
    [sym_return] = ACTIONS(4817),
    [sym_scope] = ACTIONS(4817),
    [sym_shared] = ACTIONS(4817),
    [sym_static] = ACTIONS(4817),
    [sym_struct] = ACTIONS(4817),
    [sym_switch] = ACTIONS(4817),
    [sym_synchronized] = ACTIONS(4817),
    [sym_template] = ACTIONS(4817),
    [sym_throw] = ACTIONS(4817),
    [sym_try] = ACTIONS(4817),
    [sym_typeid] = ACTIONS(4817),
    [sym_typeof] = ACTIONS(4817),
    [sym_union] = ACTIONS(4817),
    [sym_unittest] = ACTIONS(4817),
    [sym_version] = ACTIONS(4817),
    [sym_while] = ACTIONS(4817),
    [sym_with] = ACTIONS(4817),
    [sym_gshared] = ACTIONS(4817),
    [sym_traits] = ACTIONS(4817),
    [sym_vector] = ACTIONS(4817),
    [sym_void] = ACTIONS(4817),
    [anon_sym_BQUOTE] = ACTIONS(4819),
    [anon_sym_r_DQUOTE] = ACTIONS(4819),
    [anon_sym_x_DQUOTE] = ACTIONS(4819),
    [anon_sym_DQUOTE] = ACTIONS(4819),
    [anon_sym_i_BQUOTE] = ACTIONS(4819),
    [anon_sym_i_DQUOTE] = ACTIONS(4819),
    [anon_sym_iq_LBRACE] = ACTIONS(4819),
    [aux_sym_char_literal_token1] = ACTIONS(4819),
    [anon_sym_SQUOTE] = ACTIONS(4817),
    [anon_sym___DATE__] = ACTIONS(4817),
    [anon_sym___FILE__] = ACTIONS(4817),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4817),
    [anon_sym___FUNCTION__] = ACTIONS(4817),
    [anon_sym___LINE__] = ACTIONS(4817),
    [anon_sym___MODULE__] = ACTIONS(4817),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4817),
    [anon_sym___TIME__] = ACTIONS(4817),
    [anon_sym___TIMESTAMP__] = ACTIONS(4817),
    [anon_sym___VENDOR__] = ACTIONS(4817),
    [anon_sym___VERSION__] = ACTIONS(4817),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4819),
    [sym_float_literal] = ACTIONS(4819),
    [sym__string] = ACTIONS(4819),
  },
  [1524] = {
    [sym_identifier] = ACTIONS(4821),
    [anon_sym_q_LBRACE] = ACTIONS(4823),
    [anon_sym_RBRACE] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4823),
    [anon_sym_DOT] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4821),
    [anon_sym_DASH_DASH] = ACTIONS(4823),
    [anon_sym_PLUS] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4823),
    [anon_sym_BANG] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4823),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_DOLLAR] = ACTIONS(4823),
    [anon_sym_STAR] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(4823),
    [sym_bool] = ACTIONS(4821),
    [sym_byte] = ACTIONS(4821),
    [sym_ubyte] = ACTIONS(4821),
    [sym_char] = ACTIONS(4821),
    [sym_short] = ACTIONS(4821),
    [sym_ushort] = ACTIONS(4821),
    [sym_int] = ACTIONS(4821),
    [sym_uint] = ACTIONS(4821),
    [sym_long] = ACTIONS(4821),
    [sym_ulong] = ACTIONS(4821),
    [sym_cent] = ACTIONS(4821),
    [sym_ucent] = ACTIONS(4821),
    [sym_wchar] = ACTIONS(4821),
    [sym_dchar] = ACTIONS(4821),
    [sym_float] = ACTIONS(4821),
    [sym_double] = ACTIONS(4821),
    [sym_real] = ACTIONS(4821),
    [sym_ifloat] = ACTIONS(4821),
    [sym_idouble] = ACTIONS(4821),
    [sym_ireal] = ACTIONS(4821),
    [sym_cfloat] = ACTIONS(4821),
    [sym_cdouble] = ACTIONS(4821),
    [sym_creal] = ACTIONS(4821),
    [sym_size_t] = ACTIONS(4821),
    [sym_ptrdiff_t] = ACTIONS(4821),
    [sym_string] = ACTIONS(4821),
    [sym_cstring] = ACTIONS(4821),
    [sym_dstring] = ACTIONS(4821),
    [sym_wstring] = ACTIONS(4821),
    [sym_noreturn] = ACTIONS(4821),
    [sym_true] = ACTIONS(4821),
    [sym_false] = ACTIONS(4821),
    [sym_null] = ACTIONS(4821),
    [sym_super] = ACTIONS(4821),
    [sym_this] = ACTIONS(4821),
    [sym_abstract] = ACTIONS(4821),
    [sym_alias] = ACTIONS(4821),
    [sym_align] = ACTIONS(4821),
    [sym_asm] = ACTIONS(4821),
    [sym_assert] = ACTIONS(4821),
    [sym_auto] = ACTIONS(4821),
    [sym_break] = ACTIONS(4821),
    [sym_case] = ACTIONS(4821),
    [sym_cast] = ACTIONS(4821),
    [sym_class] = ACTIONS(4821),
    [sym_const] = ACTIONS(4821),
    [sym_continue] = ACTIONS(4821),
    [sym_debug] = ACTIONS(4821),
    [sym_default] = ACTIONS(4821),
    [sym_delegate] = ACTIONS(4821),
    [sym_delete] = ACTIONS(4821),
    [sym_deprecated] = ACTIONS(4821),
    [sym_do] = ACTIONS(4821),
    [sym_else] = ACTIONS(4821),
    [sym_enum] = ACTIONS(4821),
    [sym_export] = ACTIONS(4821),
    [sym_extern] = ACTIONS(4821),
    [sym_final] = ACTIONS(4821),
    [sym_for] = ACTIONS(4821),
    [sym_foreach] = ACTIONS(4821),
    [sym_foreach_reverse] = ACTIONS(4821),
    [sym_function] = ACTIONS(4821),
    [sym_goto] = ACTIONS(4821),
    [sym_if] = ACTIONS(4821),
    [sym_immutable] = ACTIONS(4821),
    [sym_import] = ACTIONS(4821),
    [sym_in] = ACTIONS(4821),
    [sym_inout] = ACTIONS(4821),
    [sym_interface] = ACTIONS(4821),
    [sym_invariant] = ACTIONS(4821),
    [sym_is] = ACTIONS(4821),
    [sym_mixin] = ACTIONS(4821),
    [sym_new] = ACTIONS(4821),
    [sym_nothrow] = ACTIONS(4821),
    [sym_out] = ACTIONS(4821),
    [sym_override] = ACTIONS(4821),
    [sym_package] = ACTIONS(4821),
    [sym_pragma] = ACTIONS(4821),
    [sym_private] = ACTIONS(4821),
    [sym_protected] = ACTIONS(4821),
    [sym_public] = ACTIONS(4821),
    [sym_pure] = ACTIONS(4821),
    [sym_ref] = ACTIONS(4821),
    [sym_return] = ACTIONS(4821),
    [sym_scope] = ACTIONS(4821),
    [sym_shared] = ACTIONS(4821),
    [sym_static] = ACTIONS(4821),
    [sym_struct] = ACTIONS(4821),
    [sym_switch] = ACTIONS(4821),
    [sym_synchronized] = ACTIONS(4821),
    [sym_template] = ACTIONS(4821),
    [sym_throw] = ACTIONS(4821),
    [sym_try] = ACTIONS(4821),
    [sym_typeid] = ACTIONS(4821),
    [sym_typeof] = ACTIONS(4821),
    [sym_union] = ACTIONS(4821),
    [sym_unittest] = ACTIONS(4821),
    [sym_version] = ACTIONS(4821),
    [sym_while] = ACTIONS(4821),
    [sym_with] = ACTIONS(4821),
    [sym_gshared] = ACTIONS(4821),
    [sym_traits] = ACTIONS(4821),
    [sym_vector] = ACTIONS(4821),
    [sym_void] = ACTIONS(4821),
    [anon_sym_BQUOTE] = ACTIONS(4823),
    [anon_sym_r_DQUOTE] = ACTIONS(4823),
    [anon_sym_x_DQUOTE] = ACTIONS(4823),
    [anon_sym_DQUOTE] = ACTIONS(4823),
    [anon_sym_i_BQUOTE] = ACTIONS(4823),
    [anon_sym_i_DQUOTE] = ACTIONS(4823),
    [anon_sym_iq_LBRACE] = ACTIONS(4823),
    [aux_sym_char_literal_token1] = ACTIONS(4823),
    [anon_sym_SQUOTE] = ACTIONS(4821),
    [anon_sym___DATE__] = ACTIONS(4821),
    [anon_sym___FILE__] = ACTIONS(4821),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4821),
    [anon_sym___FUNCTION__] = ACTIONS(4821),
    [anon_sym___LINE__] = ACTIONS(4821),
    [anon_sym___MODULE__] = ACTIONS(4821),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4821),
    [anon_sym___TIME__] = ACTIONS(4821),
    [anon_sym___TIMESTAMP__] = ACTIONS(4821),
    [anon_sym___VENDOR__] = ACTIONS(4821),
    [anon_sym___VERSION__] = ACTIONS(4821),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4823),
    [sym_float_literal] = ACTIONS(4823),
    [sym__string] = ACTIONS(4823),
  },
  [1525] = {
    [sym_identifier] = ACTIONS(4793),
    [anon_sym_q_LBRACE] = ACTIONS(4795),
    [anon_sym_RBRACE] = ACTIONS(4795),
    [anon_sym_LBRACE] = ACTIONS(4795),
    [anon_sym_DOT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4793),
    [anon_sym_DASH_DASH] = ACTIONS(4795),
    [anon_sym_PLUS] = ACTIONS(4793),
    [anon_sym_PLUS_PLUS] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(4795),
    [anon_sym_LPAREN] = ACTIONS(4795),
    [anon_sym_RPAREN] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4795),
    [anon_sym_SEMI] = ACTIONS(4795),
    [anon_sym_DOLLAR] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(4795),
    [anon_sym_TILDE] = ACTIONS(4795),
    [anon_sym_AT] = ACTIONS(4795),
    [sym_bool] = ACTIONS(4793),
    [sym_byte] = ACTIONS(4793),
    [sym_ubyte] = ACTIONS(4793),
    [sym_char] = ACTIONS(4793),
    [sym_short] = ACTIONS(4793),
    [sym_ushort] = ACTIONS(4793),
    [sym_int] = ACTIONS(4793),
    [sym_uint] = ACTIONS(4793),
    [sym_long] = ACTIONS(4793),
    [sym_ulong] = ACTIONS(4793),
    [sym_cent] = ACTIONS(4793),
    [sym_ucent] = ACTIONS(4793),
    [sym_wchar] = ACTIONS(4793),
    [sym_dchar] = ACTIONS(4793),
    [sym_float] = ACTIONS(4793),
    [sym_double] = ACTIONS(4793),
    [sym_real] = ACTIONS(4793),
    [sym_ifloat] = ACTIONS(4793),
    [sym_idouble] = ACTIONS(4793),
    [sym_ireal] = ACTIONS(4793),
    [sym_cfloat] = ACTIONS(4793),
    [sym_cdouble] = ACTIONS(4793),
    [sym_creal] = ACTIONS(4793),
    [sym_size_t] = ACTIONS(4793),
    [sym_ptrdiff_t] = ACTIONS(4793),
    [sym_string] = ACTIONS(4793),
    [sym_cstring] = ACTIONS(4793),
    [sym_dstring] = ACTIONS(4793),
    [sym_wstring] = ACTIONS(4793),
    [sym_noreturn] = ACTIONS(4793),
    [sym_true] = ACTIONS(4793),
    [sym_false] = ACTIONS(4793),
    [sym_null] = ACTIONS(4793),
    [sym_super] = ACTIONS(4793),
    [sym_this] = ACTIONS(4793),
    [sym_abstract] = ACTIONS(4793),
    [sym_alias] = ACTIONS(4793),
    [sym_align] = ACTIONS(4793),
    [sym_asm] = ACTIONS(4793),
    [sym_assert] = ACTIONS(4793),
    [sym_auto] = ACTIONS(4793),
    [sym_break] = ACTIONS(4793),
    [sym_case] = ACTIONS(4793),
    [sym_cast] = ACTIONS(4793),
    [sym_class] = ACTIONS(4793),
    [sym_const] = ACTIONS(4793),
    [sym_continue] = ACTIONS(4793),
    [sym_debug] = ACTIONS(4793),
    [sym_default] = ACTIONS(4793),
    [sym_delegate] = ACTIONS(4793),
    [sym_delete] = ACTIONS(4793),
    [sym_deprecated] = ACTIONS(4793),
    [sym_do] = ACTIONS(4793),
    [sym_else] = ACTIONS(4793),
    [sym_enum] = ACTIONS(4793),
    [sym_export] = ACTIONS(4793),
    [sym_extern] = ACTIONS(4793),
    [sym_final] = ACTIONS(4793),
    [sym_for] = ACTIONS(4793),
    [sym_foreach] = ACTIONS(4793),
    [sym_foreach_reverse] = ACTIONS(4793),
    [sym_function] = ACTIONS(4793),
    [sym_goto] = ACTIONS(4793),
    [sym_if] = ACTIONS(4793),
    [sym_immutable] = ACTIONS(4793),
    [sym_import] = ACTIONS(4793),
    [sym_in] = ACTIONS(4793),
    [sym_inout] = ACTIONS(4793),
    [sym_interface] = ACTIONS(4793),
    [sym_invariant] = ACTIONS(4793),
    [sym_is] = ACTIONS(4793),
    [sym_mixin] = ACTIONS(4793),
    [sym_new] = ACTIONS(4793),
    [sym_nothrow] = ACTIONS(4793),
    [sym_out] = ACTIONS(4793),
    [sym_override] = ACTIONS(4793),
    [sym_package] = ACTIONS(4793),
    [sym_pragma] = ACTIONS(4793),
    [sym_private] = ACTIONS(4793),
    [sym_protected] = ACTIONS(4793),
    [sym_public] = ACTIONS(4793),
    [sym_pure] = ACTIONS(4793),
    [sym_ref] = ACTIONS(4793),
    [sym_return] = ACTIONS(4793),
    [sym_scope] = ACTIONS(4793),
    [sym_shared] = ACTIONS(4793),
    [sym_static] = ACTIONS(4793),
    [sym_struct] = ACTIONS(4793),
    [sym_switch] = ACTIONS(4793),
    [sym_synchronized] = ACTIONS(4793),
    [sym_template] = ACTIONS(4793),
    [sym_throw] = ACTIONS(4793),
    [sym_try] = ACTIONS(4793),
    [sym_typeid] = ACTIONS(4793),
    [sym_typeof] = ACTIONS(4793),
    [sym_union] = ACTIONS(4793),
    [sym_unittest] = ACTIONS(4793),
    [sym_version] = ACTIONS(4793),
    [sym_while] = ACTIONS(4793),
    [sym_with] = ACTIONS(4793),
    [sym_gshared] = ACTIONS(4793),
    [sym_traits] = ACTIONS(4793),
    [sym_vector] = ACTIONS(4793),
    [sym_void] = ACTIONS(4793),
    [anon_sym_BQUOTE] = ACTIONS(4795),
    [anon_sym_r_DQUOTE] = ACTIONS(4795),
    [anon_sym_x_DQUOTE] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4795),
    [anon_sym_i_BQUOTE] = ACTIONS(4795),
    [anon_sym_i_DQUOTE] = ACTIONS(4795),
    [anon_sym_iq_LBRACE] = ACTIONS(4795),
    [aux_sym_char_literal_token1] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4793),
    [anon_sym___DATE__] = ACTIONS(4793),
    [anon_sym___FILE__] = ACTIONS(4793),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4793),
    [anon_sym___FUNCTION__] = ACTIONS(4793),
    [anon_sym___LINE__] = ACTIONS(4793),
    [anon_sym___MODULE__] = ACTIONS(4793),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4793),
    [anon_sym___TIME__] = ACTIONS(4793),
    [anon_sym___TIMESTAMP__] = ACTIONS(4793),
    [anon_sym___VENDOR__] = ACTIONS(4793),
    [anon_sym___VERSION__] = ACTIONS(4793),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4795),
    [sym_float_literal] = ACTIONS(4795),
    [sym__string] = ACTIONS(4795),
  },
  [1526] = {
    [sym_identifier] = ACTIONS(4785),
    [anon_sym_q_LBRACE] = ACTIONS(4787),
    [anon_sym_RBRACE] = ACTIONS(4787),
    [anon_sym_LBRACE] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(4787),
    [anon_sym_AMP] = ACTIONS(4787),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4787),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_PLUS_PLUS] = ACTIONS(4787),
    [anon_sym_BANG] = ACTIONS(4787),
    [anon_sym_LPAREN] = ACTIONS(4787),
    [anon_sym_RPAREN] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4787),
    [anon_sym_SEMI] = ACTIONS(4787),
    [anon_sym_DOLLAR] = ACTIONS(4787),
    [anon_sym_STAR] = ACTIONS(4787),
    [anon_sym_TILDE] = ACTIONS(4787),
    [anon_sym_AT] = ACTIONS(4787),
    [sym_bool] = ACTIONS(4785),
    [sym_byte] = ACTIONS(4785),
    [sym_ubyte] = ACTIONS(4785),
    [sym_char] = ACTIONS(4785),
    [sym_short] = ACTIONS(4785),
    [sym_ushort] = ACTIONS(4785),
    [sym_int] = ACTIONS(4785),
    [sym_uint] = ACTIONS(4785),
    [sym_long] = ACTIONS(4785),
    [sym_ulong] = ACTIONS(4785),
    [sym_cent] = ACTIONS(4785),
    [sym_ucent] = ACTIONS(4785),
    [sym_wchar] = ACTIONS(4785),
    [sym_dchar] = ACTIONS(4785),
    [sym_float] = ACTIONS(4785),
    [sym_double] = ACTIONS(4785),
    [sym_real] = ACTIONS(4785),
    [sym_ifloat] = ACTIONS(4785),
    [sym_idouble] = ACTIONS(4785),
    [sym_ireal] = ACTIONS(4785),
    [sym_cfloat] = ACTIONS(4785),
    [sym_cdouble] = ACTIONS(4785),
    [sym_creal] = ACTIONS(4785),
    [sym_size_t] = ACTIONS(4785),
    [sym_ptrdiff_t] = ACTIONS(4785),
    [sym_string] = ACTIONS(4785),
    [sym_cstring] = ACTIONS(4785),
    [sym_dstring] = ACTIONS(4785),
    [sym_wstring] = ACTIONS(4785),
    [sym_noreturn] = ACTIONS(4785),
    [sym_true] = ACTIONS(4785),
    [sym_false] = ACTIONS(4785),
    [sym_null] = ACTIONS(4785),
    [sym_super] = ACTIONS(4785),
    [sym_this] = ACTIONS(4785),
    [sym_abstract] = ACTIONS(4785),
    [sym_alias] = ACTIONS(4785),
    [sym_align] = ACTIONS(4785),
    [sym_asm] = ACTIONS(4785),
    [sym_assert] = ACTIONS(4785),
    [sym_auto] = ACTIONS(4785),
    [sym_break] = ACTIONS(4785),
    [sym_case] = ACTIONS(4785),
    [sym_cast] = ACTIONS(4785),
    [sym_class] = ACTIONS(4785),
    [sym_const] = ACTIONS(4785),
    [sym_continue] = ACTIONS(4785),
    [sym_debug] = ACTIONS(4785),
    [sym_default] = ACTIONS(4785),
    [sym_delegate] = ACTIONS(4785),
    [sym_delete] = ACTIONS(4785),
    [sym_deprecated] = ACTIONS(4785),
    [sym_do] = ACTIONS(4785),
    [sym_else] = ACTIONS(4785),
    [sym_enum] = ACTIONS(4785),
    [sym_export] = ACTIONS(4785),
    [sym_extern] = ACTIONS(4785),
    [sym_final] = ACTIONS(4785),
    [sym_for] = ACTIONS(4785),
    [sym_foreach] = ACTIONS(4785),
    [sym_foreach_reverse] = ACTIONS(4785),
    [sym_function] = ACTIONS(4785),
    [sym_goto] = ACTIONS(4785),
    [sym_if] = ACTIONS(4785),
    [sym_immutable] = ACTIONS(4785),
    [sym_import] = ACTIONS(4785),
    [sym_in] = ACTIONS(4785),
    [sym_inout] = ACTIONS(4785),
    [sym_interface] = ACTIONS(4785),
    [sym_invariant] = ACTIONS(4785),
    [sym_is] = ACTIONS(4785),
    [sym_mixin] = ACTIONS(4785),
    [sym_new] = ACTIONS(4785),
    [sym_nothrow] = ACTIONS(4785),
    [sym_out] = ACTIONS(4785),
    [sym_override] = ACTIONS(4785),
    [sym_package] = ACTIONS(4785),
    [sym_pragma] = ACTIONS(4785),
    [sym_private] = ACTIONS(4785),
    [sym_protected] = ACTIONS(4785),
    [sym_public] = ACTIONS(4785),
    [sym_pure] = ACTIONS(4785),
    [sym_ref] = ACTIONS(4785),
    [sym_return] = ACTIONS(4785),
    [sym_scope] = ACTIONS(4785),
    [sym_shared] = ACTIONS(4785),
    [sym_static] = ACTIONS(4785),
    [sym_struct] = ACTIONS(4785),
    [sym_switch] = ACTIONS(4785),
    [sym_synchronized] = ACTIONS(4785),
    [sym_template] = ACTIONS(4785),
    [sym_throw] = ACTIONS(4785),
    [sym_try] = ACTIONS(4785),
    [sym_typeid] = ACTIONS(4785),
    [sym_typeof] = ACTIONS(4785),
    [sym_union] = ACTIONS(4785),
    [sym_unittest] = ACTIONS(4785),
    [sym_version] = ACTIONS(4785),
    [sym_while] = ACTIONS(4785),
    [sym_with] = ACTIONS(4785),
    [sym_gshared] = ACTIONS(4785),
    [sym_traits] = ACTIONS(4785),
    [sym_vector] = ACTIONS(4785),
    [sym_void] = ACTIONS(4785),
    [anon_sym_BQUOTE] = ACTIONS(4787),
    [anon_sym_r_DQUOTE] = ACTIONS(4787),
    [anon_sym_x_DQUOTE] = ACTIONS(4787),
    [anon_sym_DQUOTE] = ACTIONS(4787),
    [anon_sym_i_BQUOTE] = ACTIONS(4787),
    [anon_sym_i_DQUOTE] = ACTIONS(4787),
    [anon_sym_iq_LBRACE] = ACTIONS(4787),
    [aux_sym_char_literal_token1] = ACTIONS(4787),
    [anon_sym_SQUOTE] = ACTIONS(4785),
    [anon_sym___DATE__] = ACTIONS(4785),
    [anon_sym___FILE__] = ACTIONS(4785),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4785),
    [anon_sym___FUNCTION__] = ACTIONS(4785),
    [anon_sym___LINE__] = ACTIONS(4785),
    [anon_sym___MODULE__] = ACTIONS(4785),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4785),
    [anon_sym___TIME__] = ACTIONS(4785),
    [anon_sym___TIMESTAMP__] = ACTIONS(4785),
    [anon_sym___VENDOR__] = ACTIONS(4785),
    [anon_sym___VERSION__] = ACTIONS(4785),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4787),
    [sym_float_literal] = ACTIONS(4787),
    [sym__string] = ACTIONS(4787),
  },
  [1527] = {
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_q_LBRACE] = ACTIONS(4709),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_DOT] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_DASH_DASH] = ACTIONS(4709),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4709),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_RPAREN] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym_DOLLAR] = ACTIONS(4709),
    [anon_sym_STAR] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_AT] = ACTIONS(4709),
    [sym_bool] = ACTIONS(4707),
    [sym_byte] = ACTIONS(4707),
    [sym_ubyte] = ACTIONS(4707),
    [sym_char] = ACTIONS(4707),
    [sym_short] = ACTIONS(4707),
    [sym_ushort] = ACTIONS(4707),
    [sym_int] = ACTIONS(4707),
    [sym_uint] = ACTIONS(4707),
    [sym_long] = ACTIONS(4707),
    [sym_ulong] = ACTIONS(4707),
    [sym_cent] = ACTIONS(4707),
    [sym_ucent] = ACTIONS(4707),
    [sym_wchar] = ACTIONS(4707),
    [sym_dchar] = ACTIONS(4707),
    [sym_float] = ACTIONS(4707),
    [sym_double] = ACTIONS(4707),
    [sym_real] = ACTIONS(4707),
    [sym_ifloat] = ACTIONS(4707),
    [sym_idouble] = ACTIONS(4707),
    [sym_ireal] = ACTIONS(4707),
    [sym_cfloat] = ACTIONS(4707),
    [sym_cdouble] = ACTIONS(4707),
    [sym_creal] = ACTIONS(4707),
    [sym_size_t] = ACTIONS(4707),
    [sym_ptrdiff_t] = ACTIONS(4707),
    [sym_string] = ACTIONS(4707),
    [sym_cstring] = ACTIONS(4707),
    [sym_dstring] = ACTIONS(4707),
    [sym_wstring] = ACTIONS(4707),
    [sym_noreturn] = ACTIONS(4707),
    [sym_true] = ACTIONS(4707),
    [sym_false] = ACTIONS(4707),
    [sym_null] = ACTIONS(4707),
    [sym_super] = ACTIONS(4707),
    [sym_this] = ACTIONS(4707),
    [sym_abstract] = ACTIONS(4707),
    [sym_alias] = ACTIONS(4707),
    [sym_align] = ACTIONS(4707),
    [sym_asm] = ACTIONS(4707),
    [sym_assert] = ACTIONS(4707),
    [sym_auto] = ACTIONS(4707),
    [sym_break] = ACTIONS(4707),
    [sym_case] = ACTIONS(4707),
    [sym_cast] = ACTIONS(4707),
    [sym_class] = ACTIONS(4707),
    [sym_const] = ACTIONS(4707),
    [sym_continue] = ACTIONS(4707),
    [sym_debug] = ACTIONS(4707),
    [sym_default] = ACTIONS(4707),
    [sym_delegate] = ACTIONS(4707),
    [sym_delete] = ACTIONS(4707),
    [sym_deprecated] = ACTIONS(4707),
    [sym_do] = ACTIONS(4707),
    [sym_else] = ACTIONS(4707),
    [sym_enum] = ACTIONS(4707),
    [sym_export] = ACTIONS(4707),
    [sym_extern] = ACTIONS(4707),
    [sym_final] = ACTIONS(4707),
    [sym_for] = ACTIONS(4707),
    [sym_foreach] = ACTIONS(4707),
    [sym_foreach_reverse] = ACTIONS(4707),
    [sym_function] = ACTIONS(4707),
    [sym_goto] = ACTIONS(4707),
    [sym_if] = ACTIONS(4707),
    [sym_immutable] = ACTIONS(4707),
    [sym_import] = ACTIONS(4707),
    [sym_in] = ACTIONS(4707),
    [sym_inout] = ACTIONS(4707),
    [sym_interface] = ACTIONS(4707),
    [sym_invariant] = ACTIONS(4707),
    [sym_is] = ACTIONS(4707),
    [sym_mixin] = ACTIONS(4707),
    [sym_new] = ACTIONS(4707),
    [sym_nothrow] = ACTIONS(4707),
    [sym_out] = ACTIONS(4707),
    [sym_override] = ACTIONS(4707),
    [sym_package] = ACTIONS(4707),
    [sym_pragma] = ACTIONS(4707),
    [sym_private] = ACTIONS(4707),
    [sym_protected] = ACTIONS(4707),
    [sym_public] = ACTIONS(4707),
    [sym_pure] = ACTIONS(4707),
    [sym_ref] = ACTIONS(4707),
    [sym_return] = ACTIONS(4707),
    [sym_scope] = ACTIONS(4707),
    [sym_shared] = ACTIONS(4707),
    [sym_static] = ACTIONS(4707),
    [sym_struct] = ACTIONS(4707),
    [sym_switch] = ACTIONS(4707),
    [sym_synchronized] = ACTIONS(4707),
    [sym_template] = ACTIONS(4707),
    [sym_throw] = ACTIONS(4707),
    [sym_try] = ACTIONS(4707),
    [sym_typeid] = ACTIONS(4707),
    [sym_typeof] = ACTIONS(4707),
    [sym_union] = ACTIONS(4707),
    [sym_unittest] = ACTIONS(4707),
    [sym_version] = ACTIONS(4707),
    [sym_while] = ACTIONS(4707),
    [sym_with] = ACTIONS(4707),
    [sym_gshared] = ACTIONS(4707),
    [sym_traits] = ACTIONS(4707),
    [sym_vector] = ACTIONS(4707),
    [sym_void] = ACTIONS(4707),
    [anon_sym_BQUOTE] = ACTIONS(4709),
    [anon_sym_r_DQUOTE] = ACTIONS(4709),
    [anon_sym_x_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [anon_sym_i_BQUOTE] = ACTIONS(4709),
    [anon_sym_i_DQUOTE] = ACTIONS(4709),
    [anon_sym_iq_LBRACE] = ACTIONS(4709),
    [aux_sym_char_literal_token1] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4707),
    [anon_sym___DATE__] = ACTIONS(4707),
    [anon_sym___FILE__] = ACTIONS(4707),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4707),
    [anon_sym___FUNCTION__] = ACTIONS(4707),
    [anon_sym___LINE__] = ACTIONS(4707),
    [anon_sym___MODULE__] = ACTIONS(4707),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4707),
    [anon_sym___TIME__] = ACTIONS(4707),
    [anon_sym___TIMESTAMP__] = ACTIONS(4707),
    [anon_sym___VENDOR__] = ACTIONS(4707),
    [anon_sym___VERSION__] = ACTIONS(4707),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4709),
    [sym_float_literal] = ACTIONS(4709),
    [sym__string] = ACTIONS(4709),
  },
  [1528] = {
    [sym_identifier] = ACTIONS(4831),
    [anon_sym_q_LBRACE] = ACTIONS(4833),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_LBRACE] = ACTIONS(4833),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_AMP] = ACTIONS(4833),
    [anon_sym_DASH] = ACTIONS(4831),
    [anon_sym_DASH_DASH] = ACTIONS(4833),
    [anon_sym_PLUS] = ACTIONS(4831),
    [anon_sym_PLUS_PLUS] = ACTIONS(4833),
    [anon_sym_BANG] = ACTIONS(4833),
    [anon_sym_LPAREN] = ACTIONS(4833),
    [anon_sym_RPAREN] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4833),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [anon_sym_STAR] = ACTIONS(4833),
    [anon_sym_TILDE] = ACTIONS(4833),
    [anon_sym_AT] = ACTIONS(4833),
    [sym_bool] = ACTIONS(4831),
    [sym_byte] = ACTIONS(4831),
    [sym_ubyte] = ACTIONS(4831),
    [sym_char] = ACTIONS(4831),
    [sym_short] = ACTIONS(4831),
    [sym_ushort] = ACTIONS(4831),
    [sym_int] = ACTIONS(4831),
    [sym_uint] = ACTIONS(4831),
    [sym_long] = ACTIONS(4831),
    [sym_ulong] = ACTIONS(4831),
    [sym_cent] = ACTIONS(4831),
    [sym_ucent] = ACTIONS(4831),
    [sym_wchar] = ACTIONS(4831),
    [sym_dchar] = ACTIONS(4831),
    [sym_float] = ACTIONS(4831),
    [sym_double] = ACTIONS(4831),
    [sym_real] = ACTIONS(4831),
    [sym_ifloat] = ACTIONS(4831),
    [sym_idouble] = ACTIONS(4831),
    [sym_ireal] = ACTIONS(4831),
    [sym_cfloat] = ACTIONS(4831),
    [sym_cdouble] = ACTIONS(4831),
    [sym_creal] = ACTIONS(4831),
    [sym_size_t] = ACTIONS(4831),
    [sym_ptrdiff_t] = ACTIONS(4831),
    [sym_string] = ACTIONS(4831),
    [sym_cstring] = ACTIONS(4831),
    [sym_dstring] = ACTIONS(4831),
    [sym_wstring] = ACTIONS(4831),
    [sym_noreturn] = ACTIONS(4831),
    [sym_true] = ACTIONS(4831),
    [sym_false] = ACTIONS(4831),
    [sym_null] = ACTIONS(4831),
    [sym_super] = ACTIONS(4831),
    [sym_this] = ACTIONS(4831),
    [sym_abstract] = ACTIONS(4831),
    [sym_alias] = ACTIONS(4831),
    [sym_align] = ACTIONS(4831),
    [sym_asm] = ACTIONS(4831),
    [sym_assert] = ACTIONS(4831),
    [sym_auto] = ACTIONS(4831),
    [sym_break] = ACTIONS(4831),
    [sym_case] = ACTIONS(4831),
    [sym_cast] = ACTIONS(4831),
    [sym_class] = ACTIONS(4831),
    [sym_const] = ACTIONS(4831),
    [sym_continue] = ACTIONS(4831),
    [sym_debug] = ACTIONS(4831),
    [sym_default] = ACTIONS(4831),
    [sym_delegate] = ACTIONS(4831),
    [sym_delete] = ACTIONS(4831),
    [sym_deprecated] = ACTIONS(4831),
    [sym_do] = ACTIONS(4831),
    [sym_else] = ACTIONS(4831),
    [sym_enum] = ACTIONS(4831),
    [sym_export] = ACTIONS(4831),
    [sym_extern] = ACTIONS(4831),
    [sym_final] = ACTIONS(4831),
    [sym_for] = ACTIONS(4831),
    [sym_foreach] = ACTIONS(4831),
    [sym_foreach_reverse] = ACTIONS(4831),
    [sym_function] = ACTIONS(4831),
    [sym_goto] = ACTIONS(4831),
    [sym_if] = ACTIONS(4831),
    [sym_immutable] = ACTIONS(4831),
    [sym_import] = ACTIONS(4831),
    [sym_in] = ACTIONS(4831),
    [sym_inout] = ACTIONS(4831),
    [sym_interface] = ACTIONS(4831),
    [sym_invariant] = ACTIONS(4831),
    [sym_is] = ACTIONS(4831),
    [sym_mixin] = ACTIONS(4831),
    [sym_new] = ACTIONS(4831),
    [sym_nothrow] = ACTIONS(4831),
    [sym_out] = ACTIONS(4831),
    [sym_override] = ACTIONS(4831),
    [sym_package] = ACTIONS(4831),
    [sym_pragma] = ACTIONS(4831),
    [sym_private] = ACTIONS(4831),
    [sym_protected] = ACTIONS(4831),
    [sym_public] = ACTIONS(4831),
    [sym_pure] = ACTIONS(4831),
    [sym_ref] = ACTIONS(4831),
    [sym_return] = ACTIONS(4831),
    [sym_scope] = ACTIONS(4831),
    [sym_shared] = ACTIONS(4831),
    [sym_static] = ACTIONS(4831),
    [sym_struct] = ACTIONS(4831),
    [sym_switch] = ACTIONS(4831),
    [sym_synchronized] = ACTIONS(4831),
    [sym_template] = ACTIONS(4831),
    [sym_throw] = ACTIONS(4831),
    [sym_try] = ACTIONS(4831),
    [sym_typeid] = ACTIONS(4831),
    [sym_typeof] = ACTIONS(4831),
    [sym_union] = ACTIONS(4831),
    [sym_unittest] = ACTIONS(4831),
    [sym_version] = ACTIONS(4831),
    [sym_while] = ACTIONS(4831),
    [sym_with] = ACTIONS(4831),
    [sym_gshared] = ACTIONS(4831),
    [sym_traits] = ACTIONS(4831),
    [sym_vector] = ACTIONS(4831),
    [sym_void] = ACTIONS(4831),
    [anon_sym_BQUOTE] = ACTIONS(4833),
    [anon_sym_r_DQUOTE] = ACTIONS(4833),
    [anon_sym_x_DQUOTE] = ACTIONS(4833),
    [anon_sym_DQUOTE] = ACTIONS(4833),
    [anon_sym_i_BQUOTE] = ACTIONS(4833),
    [anon_sym_i_DQUOTE] = ACTIONS(4833),
    [anon_sym_iq_LBRACE] = ACTIONS(4833),
    [aux_sym_char_literal_token1] = ACTIONS(4833),
    [anon_sym_SQUOTE] = ACTIONS(4831),
    [anon_sym___DATE__] = ACTIONS(4831),
    [anon_sym___FILE__] = ACTIONS(4831),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4831),
    [anon_sym___FUNCTION__] = ACTIONS(4831),
    [anon_sym___LINE__] = ACTIONS(4831),
    [anon_sym___MODULE__] = ACTIONS(4831),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4831),
    [anon_sym___TIME__] = ACTIONS(4831),
    [anon_sym___TIMESTAMP__] = ACTIONS(4831),
    [anon_sym___VENDOR__] = ACTIONS(4831),
    [anon_sym___VERSION__] = ACTIONS(4831),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4833),
    [sym_float_literal] = ACTIONS(4833),
    [sym__string] = ACTIONS(4833),
  },
  [1529] = {
    [sym_identifier] = ACTIONS(4835),
    [anon_sym_q_LBRACE] = ACTIONS(4837),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_LBRACE] = ACTIONS(4837),
    [anon_sym_DOT] = ACTIONS(4837),
    [anon_sym_AMP] = ACTIONS(4837),
    [anon_sym_DASH] = ACTIONS(4835),
    [anon_sym_DASH_DASH] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4835),
    [anon_sym_PLUS_PLUS] = ACTIONS(4837),
    [anon_sym_BANG] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(4837),
    [anon_sym_RPAREN] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym_DOLLAR] = ACTIONS(4837),
    [anon_sym_STAR] = ACTIONS(4837),
    [anon_sym_TILDE] = ACTIONS(4837),
    [anon_sym_AT] = ACTIONS(4837),
    [sym_bool] = ACTIONS(4835),
    [sym_byte] = ACTIONS(4835),
    [sym_ubyte] = ACTIONS(4835),
    [sym_char] = ACTIONS(4835),
    [sym_short] = ACTIONS(4835),
    [sym_ushort] = ACTIONS(4835),
    [sym_int] = ACTIONS(4835),
    [sym_uint] = ACTIONS(4835),
    [sym_long] = ACTIONS(4835),
    [sym_ulong] = ACTIONS(4835),
    [sym_cent] = ACTIONS(4835),
    [sym_ucent] = ACTIONS(4835),
    [sym_wchar] = ACTIONS(4835),
    [sym_dchar] = ACTIONS(4835),
    [sym_float] = ACTIONS(4835),
    [sym_double] = ACTIONS(4835),
    [sym_real] = ACTIONS(4835),
    [sym_ifloat] = ACTIONS(4835),
    [sym_idouble] = ACTIONS(4835),
    [sym_ireal] = ACTIONS(4835),
    [sym_cfloat] = ACTIONS(4835),
    [sym_cdouble] = ACTIONS(4835),
    [sym_creal] = ACTIONS(4835),
    [sym_size_t] = ACTIONS(4835),
    [sym_ptrdiff_t] = ACTIONS(4835),
    [sym_string] = ACTIONS(4835),
    [sym_cstring] = ACTIONS(4835),
    [sym_dstring] = ACTIONS(4835),
    [sym_wstring] = ACTIONS(4835),
    [sym_noreturn] = ACTIONS(4835),
    [sym_true] = ACTIONS(4835),
    [sym_false] = ACTIONS(4835),
    [sym_null] = ACTIONS(4835),
    [sym_super] = ACTIONS(4835),
    [sym_this] = ACTIONS(4835),
    [sym_abstract] = ACTIONS(4835),
    [sym_alias] = ACTIONS(4835),
    [sym_align] = ACTIONS(4835),
    [sym_asm] = ACTIONS(4835),
    [sym_assert] = ACTIONS(4835),
    [sym_auto] = ACTIONS(4835),
    [sym_break] = ACTIONS(4835),
    [sym_case] = ACTIONS(4835),
    [sym_cast] = ACTIONS(4835),
    [sym_class] = ACTIONS(4835),
    [sym_const] = ACTIONS(4835),
    [sym_continue] = ACTIONS(4835),
    [sym_debug] = ACTIONS(4835),
    [sym_default] = ACTIONS(4835),
    [sym_delegate] = ACTIONS(4835),
    [sym_delete] = ACTIONS(4835),
    [sym_deprecated] = ACTIONS(4835),
    [sym_do] = ACTIONS(4835),
    [sym_else] = ACTIONS(4835),
    [sym_enum] = ACTIONS(4835),
    [sym_export] = ACTIONS(4835),
    [sym_extern] = ACTIONS(4835),
    [sym_final] = ACTIONS(4835),
    [sym_for] = ACTIONS(4835),
    [sym_foreach] = ACTIONS(4835),
    [sym_foreach_reverse] = ACTIONS(4835),
    [sym_function] = ACTIONS(4835),
    [sym_goto] = ACTIONS(4835),
    [sym_if] = ACTIONS(4835),
    [sym_immutable] = ACTIONS(4835),
    [sym_import] = ACTIONS(4835),
    [sym_in] = ACTIONS(4835),
    [sym_inout] = ACTIONS(4835),
    [sym_interface] = ACTIONS(4835),
    [sym_invariant] = ACTIONS(4835),
    [sym_is] = ACTIONS(4835),
    [sym_mixin] = ACTIONS(4835),
    [sym_new] = ACTIONS(4835),
    [sym_nothrow] = ACTIONS(4835),
    [sym_out] = ACTIONS(4835),
    [sym_override] = ACTIONS(4835),
    [sym_package] = ACTIONS(4835),
    [sym_pragma] = ACTIONS(4835),
    [sym_private] = ACTIONS(4835),
    [sym_protected] = ACTIONS(4835),
    [sym_public] = ACTIONS(4835),
    [sym_pure] = ACTIONS(4835),
    [sym_ref] = ACTIONS(4835),
    [sym_return] = ACTIONS(4835),
    [sym_scope] = ACTIONS(4835),
    [sym_shared] = ACTIONS(4835),
    [sym_static] = ACTIONS(4835),
    [sym_struct] = ACTIONS(4835),
    [sym_switch] = ACTIONS(4835),
    [sym_synchronized] = ACTIONS(4835),
    [sym_template] = ACTIONS(4835),
    [sym_throw] = ACTIONS(4835),
    [sym_try] = ACTIONS(4835),
    [sym_typeid] = ACTIONS(4835),
    [sym_typeof] = ACTIONS(4835),
    [sym_union] = ACTIONS(4835),
    [sym_unittest] = ACTIONS(4835),
    [sym_version] = ACTIONS(4835),
    [sym_while] = ACTIONS(4835),
    [sym_with] = ACTIONS(4835),
    [sym_gshared] = ACTIONS(4835),
    [sym_traits] = ACTIONS(4835),
    [sym_vector] = ACTIONS(4835),
    [sym_void] = ACTIONS(4835),
    [anon_sym_BQUOTE] = ACTIONS(4837),
    [anon_sym_r_DQUOTE] = ACTIONS(4837),
    [anon_sym_x_DQUOTE] = ACTIONS(4837),
    [anon_sym_DQUOTE] = ACTIONS(4837),
    [anon_sym_i_BQUOTE] = ACTIONS(4837),
    [anon_sym_i_DQUOTE] = ACTIONS(4837),
    [anon_sym_iq_LBRACE] = ACTIONS(4837),
    [aux_sym_char_literal_token1] = ACTIONS(4837),
    [anon_sym_SQUOTE] = ACTIONS(4835),
    [anon_sym___DATE__] = ACTIONS(4835),
    [anon_sym___FILE__] = ACTIONS(4835),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4835),
    [anon_sym___FUNCTION__] = ACTIONS(4835),
    [anon_sym___LINE__] = ACTIONS(4835),
    [anon_sym___MODULE__] = ACTIONS(4835),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4835),
    [anon_sym___TIME__] = ACTIONS(4835),
    [anon_sym___TIMESTAMP__] = ACTIONS(4835),
    [anon_sym___VENDOR__] = ACTIONS(4835),
    [anon_sym___VERSION__] = ACTIONS(4835),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4837),
    [sym_float_literal] = ACTIONS(4837),
    [sym__string] = ACTIONS(4837),
  },
  [1530] = {
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_q_LBRACE] = ACTIONS(4841),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [anon_sym_LBRACE] = ACTIONS(4841),
    [anon_sym_DOT] = ACTIONS(4841),
    [anon_sym_AMP] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4839),
    [anon_sym_DASH_DASH] = ACTIONS(4841),
    [anon_sym_PLUS] = ACTIONS(4839),
    [anon_sym_PLUS_PLUS] = ACTIONS(4841),
    [anon_sym_BANG] = ACTIONS(4841),
    [anon_sym_LPAREN] = ACTIONS(4841),
    [anon_sym_RPAREN] = ACTIONS(4841),
    [anon_sym_LBRACK] = ACTIONS(4841),
    [anon_sym_SEMI] = ACTIONS(4841),
    [anon_sym_DOLLAR] = ACTIONS(4841),
    [anon_sym_STAR] = ACTIONS(4841),
    [anon_sym_TILDE] = ACTIONS(4841),
    [anon_sym_AT] = ACTIONS(4841),
    [sym_bool] = ACTIONS(4839),
    [sym_byte] = ACTIONS(4839),
    [sym_ubyte] = ACTIONS(4839),
    [sym_char] = ACTIONS(4839),
    [sym_short] = ACTIONS(4839),
    [sym_ushort] = ACTIONS(4839),
    [sym_int] = ACTIONS(4839),
    [sym_uint] = ACTIONS(4839),
    [sym_long] = ACTIONS(4839),
    [sym_ulong] = ACTIONS(4839),
    [sym_cent] = ACTIONS(4839),
    [sym_ucent] = ACTIONS(4839),
    [sym_wchar] = ACTIONS(4839),
    [sym_dchar] = ACTIONS(4839),
    [sym_float] = ACTIONS(4839),
    [sym_double] = ACTIONS(4839),
    [sym_real] = ACTIONS(4839),
    [sym_ifloat] = ACTIONS(4839),
    [sym_idouble] = ACTIONS(4839),
    [sym_ireal] = ACTIONS(4839),
    [sym_cfloat] = ACTIONS(4839),
    [sym_cdouble] = ACTIONS(4839),
    [sym_creal] = ACTIONS(4839),
    [sym_size_t] = ACTIONS(4839),
    [sym_ptrdiff_t] = ACTIONS(4839),
    [sym_string] = ACTIONS(4839),
    [sym_cstring] = ACTIONS(4839),
    [sym_dstring] = ACTIONS(4839),
    [sym_wstring] = ACTIONS(4839),
    [sym_noreturn] = ACTIONS(4839),
    [sym_true] = ACTIONS(4839),
    [sym_false] = ACTIONS(4839),
    [sym_null] = ACTIONS(4839),
    [sym_super] = ACTIONS(4839),
    [sym_this] = ACTIONS(4839),
    [sym_abstract] = ACTIONS(4839),
    [sym_alias] = ACTIONS(4839),
    [sym_align] = ACTIONS(4839),
    [sym_asm] = ACTIONS(4839),
    [sym_assert] = ACTIONS(4839),
    [sym_auto] = ACTIONS(4839),
    [sym_break] = ACTIONS(4839),
    [sym_case] = ACTIONS(4839),
    [sym_cast] = ACTIONS(4839),
    [sym_class] = ACTIONS(4839),
    [sym_const] = ACTIONS(4839),
    [sym_continue] = ACTIONS(4839),
    [sym_debug] = ACTIONS(4839),
    [sym_default] = ACTIONS(4839),
    [sym_delegate] = ACTIONS(4839),
    [sym_delete] = ACTIONS(4839),
    [sym_deprecated] = ACTIONS(4839),
    [sym_do] = ACTIONS(4839),
    [sym_else] = ACTIONS(4839),
    [sym_enum] = ACTIONS(4839),
    [sym_export] = ACTIONS(4839),
    [sym_extern] = ACTIONS(4839),
    [sym_final] = ACTIONS(4839),
    [sym_for] = ACTIONS(4839),
    [sym_foreach] = ACTIONS(4839),
    [sym_foreach_reverse] = ACTIONS(4839),
    [sym_function] = ACTIONS(4839),
    [sym_goto] = ACTIONS(4839),
    [sym_if] = ACTIONS(4839),
    [sym_immutable] = ACTIONS(4839),
    [sym_import] = ACTIONS(4839),
    [sym_in] = ACTIONS(4839),
    [sym_inout] = ACTIONS(4839),
    [sym_interface] = ACTIONS(4839),
    [sym_invariant] = ACTIONS(4839),
    [sym_is] = ACTIONS(4839),
    [sym_mixin] = ACTIONS(4839),
    [sym_new] = ACTIONS(4839),
    [sym_nothrow] = ACTIONS(4839),
    [sym_out] = ACTIONS(4839),
    [sym_override] = ACTIONS(4839),
    [sym_package] = ACTIONS(4839),
    [sym_pragma] = ACTIONS(4839),
    [sym_private] = ACTIONS(4839),
    [sym_protected] = ACTIONS(4839),
    [sym_public] = ACTIONS(4839),
    [sym_pure] = ACTIONS(4839),
    [sym_ref] = ACTIONS(4839),
    [sym_return] = ACTIONS(4839),
    [sym_scope] = ACTIONS(4839),
    [sym_shared] = ACTIONS(4839),
    [sym_static] = ACTIONS(4839),
    [sym_struct] = ACTIONS(4839),
    [sym_switch] = ACTIONS(4839),
    [sym_synchronized] = ACTIONS(4839),
    [sym_template] = ACTIONS(4839),
    [sym_throw] = ACTIONS(4839),
    [sym_try] = ACTIONS(4839),
    [sym_typeid] = ACTIONS(4839),
    [sym_typeof] = ACTIONS(4839),
    [sym_union] = ACTIONS(4839),
    [sym_unittest] = ACTIONS(4839),
    [sym_version] = ACTIONS(4839),
    [sym_while] = ACTIONS(4839),
    [sym_with] = ACTIONS(4839),
    [sym_gshared] = ACTIONS(4839),
    [sym_traits] = ACTIONS(4839),
    [sym_vector] = ACTIONS(4839),
    [sym_void] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_r_DQUOTE] = ACTIONS(4841),
    [anon_sym_x_DQUOTE] = ACTIONS(4841),
    [anon_sym_DQUOTE] = ACTIONS(4841),
    [anon_sym_i_BQUOTE] = ACTIONS(4841),
    [anon_sym_i_DQUOTE] = ACTIONS(4841),
    [anon_sym_iq_LBRACE] = ACTIONS(4841),
    [aux_sym_char_literal_token1] = ACTIONS(4841),
    [anon_sym_SQUOTE] = ACTIONS(4839),
    [anon_sym___DATE__] = ACTIONS(4839),
    [anon_sym___FILE__] = ACTIONS(4839),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4839),
    [anon_sym___FUNCTION__] = ACTIONS(4839),
    [anon_sym___LINE__] = ACTIONS(4839),
    [anon_sym___MODULE__] = ACTIONS(4839),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4839),
    [anon_sym___TIME__] = ACTIONS(4839),
    [anon_sym___TIMESTAMP__] = ACTIONS(4839),
    [anon_sym___VENDOR__] = ACTIONS(4839),
    [anon_sym___VERSION__] = ACTIONS(4839),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4841),
    [sym_float_literal] = ACTIONS(4841),
    [sym__string] = ACTIONS(4841),
  },
  [1531] = {
    [sym_identifier] = ACTIONS(4765),
    [anon_sym_q_LBRACE] = ACTIONS(4767),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym_LBRACE] = ACTIONS(4767),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_AMP] = ACTIONS(4767),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_DASH_DASH] = ACTIONS(4767),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4767),
    [anon_sym_BANG] = ACTIONS(4767),
    [anon_sym_LPAREN] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_LBRACK] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [anon_sym_STAR] = ACTIONS(4767),
    [anon_sym_TILDE] = ACTIONS(4767),
    [anon_sym_AT] = ACTIONS(4767),
    [sym_bool] = ACTIONS(4765),
    [sym_byte] = ACTIONS(4765),
    [sym_ubyte] = ACTIONS(4765),
    [sym_char] = ACTIONS(4765),
    [sym_short] = ACTIONS(4765),
    [sym_ushort] = ACTIONS(4765),
    [sym_int] = ACTIONS(4765),
    [sym_uint] = ACTIONS(4765),
    [sym_long] = ACTIONS(4765),
    [sym_ulong] = ACTIONS(4765),
    [sym_cent] = ACTIONS(4765),
    [sym_ucent] = ACTIONS(4765),
    [sym_wchar] = ACTIONS(4765),
    [sym_dchar] = ACTIONS(4765),
    [sym_float] = ACTIONS(4765),
    [sym_double] = ACTIONS(4765),
    [sym_real] = ACTIONS(4765),
    [sym_ifloat] = ACTIONS(4765),
    [sym_idouble] = ACTIONS(4765),
    [sym_ireal] = ACTIONS(4765),
    [sym_cfloat] = ACTIONS(4765),
    [sym_cdouble] = ACTIONS(4765),
    [sym_creal] = ACTIONS(4765),
    [sym_size_t] = ACTIONS(4765),
    [sym_ptrdiff_t] = ACTIONS(4765),
    [sym_string] = ACTIONS(4765),
    [sym_cstring] = ACTIONS(4765),
    [sym_dstring] = ACTIONS(4765),
    [sym_wstring] = ACTIONS(4765),
    [sym_noreturn] = ACTIONS(4765),
    [sym_true] = ACTIONS(4765),
    [sym_false] = ACTIONS(4765),
    [sym_null] = ACTIONS(4765),
    [sym_super] = ACTIONS(4765),
    [sym_this] = ACTIONS(4765),
    [sym_abstract] = ACTIONS(4765),
    [sym_alias] = ACTIONS(4765),
    [sym_align] = ACTIONS(4765),
    [sym_asm] = ACTIONS(4765),
    [sym_assert] = ACTIONS(4765),
    [sym_auto] = ACTIONS(4765),
    [sym_break] = ACTIONS(4765),
    [sym_case] = ACTIONS(4765),
    [sym_cast] = ACTIONS(4765),
    [sym_class] = ACTIONS(4765),
    [sym_const] = ACTIONS(4765),
    [sym_continue] = ACTIONS(4765),
    [sym_debug] = ACTIONS(4765),
    [sym_default] = ACTIONS(4765),
    [sym_delegate] = ACTIONS(4765),
    [sym_delete] = ACTIONS(4765),
    [sym_deprecated] = ACTIONS(4765),
    [sym_do] = ACTIONS(4765),
    [sym_else] = ACTIONS(4765),
    [sym_enum] = ACTIONS(4765),
    [sym_export] = ACTIONS(4765),
    [sym_extern] = ACTIONS(4765),
    [sym_final] = ACTIONS(4765),
    [sym_for] = ACTIONS(4765),
    [sym_foreach] = ACTIONS(4765),
    [sym_foreach_reverse] = ACTIONS(4765),
    [sym_function] = ACTIONS(4765),
    [sym_goto] = ACTIONS(4765),
    [sym_if] = ACTIONS(4765),
    [sym_immutable] = ACTIONS(4765),
    [sym_import] = ACTIONS(4765),
    [sym_in] = ACTIONS(4765),
    [sym_inout] = ACTIONS(4765),
    [sym_interface] = ACTIONS(4765),
    [sym_invariant] = ACTIONS(4765),
    [sym_is] = ACTIONS(4765),
    [sym_mixin] = ACTIONS(4765),
    [sym_new] = ACTIONS(4765),
    [sym_nothrow] = ACTIONS(4765),
    [sym_out] = ACTIONS(4765),
    [sym_override] = ACTIONS(4765),
    [sym_package] = ACTIONS(4765),
    [sym_pragma] = ACTIONS(4765),
    [sym_private] = ACTIONS(4765),
    [sym_protected] = ACTIONS(4765),
    [sym_public] = ACTIONS(4765),
    [sym_pure] = ACTIONS(4765),
    [sym_ref] = ACTIONS(4765),
    [sym_return] = ACTIONS(4765),
    [sym_scope] = ACTIONS(4765),
    [sym_shared] = ACTIONS(4765),
    [sym_static] = ACTIONS(4765),
    [sym_struct] = ACTIONS(4765),
    [sym_switch] = ACTIONS(4765),
    [sym_synchronized] = ACTIONS(4765),
    [sym_template] = ACTIONS(4765),
    [sym_throw] = ACTIONS(4765),
    [sym_try] = ACTIONS(4765),
    [sym_typeid] = ACTIONS(4765),
    [sym_typeof] = ACTIONS(4765),
    [sym_union] = ACTIONS(4765),
    [sym_unittest] = ACTIONS(4765),
    [sym_version] = ACTIONS(4765),
    [sym_while] = ACTIONS(4765),
    [sym_with] = ACTIONS(4765),
    [sym_gshared] = ACTIONS(4765),
    [sym_traits] = ACTIONS(4765),
    [sym_vector] = ACTIONS(4765),
    [sym_void] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_r_DQUOTE] = ACTIONS(4767),
    [anon_sym_x_DQUOTE] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_i_BQUOTE] = ACTIONS(4767),
    [anon_sym_i_DQUOTE] = ACTIONS(4767),
    [anon_sym_iq_LBRACE] = ACTIONS(4767),
    [aux_sym_char_literal_token1] = ACTIONS(4767),
    [anon_sym_SQUOTE] = ACTIONS(4765),
    [anon_sym___DATE__] = ACTIONS(4765),
    [anon_sym___FILE__] = ACTIONS(4765),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4765),
    [anon_sym___FUNCTION__] = ACTIONS(4765),
    [anon_sym___LINE__] = ACTIONS(4765),
    [anon_sym___MODULE__] = ACTIONS(4765),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4765),
    [anon_sym___TIME__] = ACTIONS(4765),
    [anon_sym___TIMESTAMP__] = ACTIONS(4765),
    [anon_sym___VENDOR__] = ACTIONS(4765),
    [anon_sym___VERSION__] = ACTIONS(4765),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4767),
    [sym_float_literal] = ACTIONS(4767),
    [sym__string] = ACTIONS(4767),
  },
  [1532] = {
    [sym_identifier] = ACTIONS(4843),
    [anon_sym_q_LBRACE] = ACTIONS(4845),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_DASH_DASH] = ACTIONS(4845),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_PLUS_PLUS] = ACTIONS(4845),
    [anon_sym_BANG] = ACTIONS(4845),
    [anon_sym_LPAREN] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4845),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_AT] = ACTIONS(4845),
    [sym_bool] = ACTIONS(4843),
    [sym_byte] = ACTIONS(4843),
    [sym_ubyte] = ACTIONS(4843),
    [sym_char] = ACTIONS(4843),
    [sym_short] = ACTIONS(4843),
    [sym_ushort] = ACTIONS(4843),
    [sym_int] = ACTIONS(4843),
    [sym_uint] = ACTIONS(4843),
    [sym_long] = ACTIONS(4843),
    [sym_ulong] = ACTIONS(4843),
    [sym_cent] = ACTIONS(4843),
    [sym_ucent] = ACTIONS(4843),
    [sym_wchar] = ACTIONS(4843),
    [sym_dchar] = ACTIONS(4843),
    [sym_float] = ACTIONS(4843),
    [sym_double] = ACTIONS(4843),
    [sym_real] = ACTIONS(4843),
    [sym_ifloat] = ACTIONS(4843),
    [sym_idouble] = ACTIONS(4843),
    [sym_ireal] = ACTIONS(4843),
    [sym_cfloat] = ACTIONS(4843),
    [sym_cdouble] = ACTIONS(4843),
    [sym_creal] = ACTIONS(4843),
    [sym_size_t] = ACTIONS(4843),
    [sym_ptrdiff_t] = ACTIONS(4843),
    [sym_string] = ACTIONS(4843),
    [sym_cstring] = ACTIONS(4843),
    [sym_dstring] = ACTIONS(4843),
    [sym_wstring] = ACTIONS(4843),
    [sym_noreturn] = ACTIONS(4843),
    [sym_true] = ACTIONS(4843),
    [sym_false] = ACTIONS(4843),
    [sym_null] = ACTIONS(4843),
    [sym_super] = ACTIONS(4843),
    [sym_this] = ACTIONS(4843),
    [sym_abstract] = ACTIONS(4843),
    [sym_alias] = ACTIONS(4843),
    [sym_align] = ACTIONS(4843),
    [sym_asm] = ACTIONS(4843),
    [sym_assert] = ACTIONS(4843),
    [sym_auto] = ACTIONS(4843),
    [sym_break] = ACTIONS(4843),
    [sym_case] = ACTIONS(4843),
    [sym_cast] = ACTIONS(4843),
    [sym_class] = ACTIONS(4843),
    [sym_const] = ACTIONS(4843),
    [sym_continue] = ACTIONS(4843),
    [sym_debug] = ACTIONS(4843),
    [sym_default] = ACTIONS(4843),
    [sym_delegate] = ACTIONS(4843),
    [sym_delete] = ACTIONS(4843),
    [sym_deprecated] = ACTIONS(4843),
    [sym_do] = ACTIONS(4843),
    [sym_else] = ACTIONS(4843),
    [sym_enum] = ACTIONS(4843),
    [sym_export] = ACTIONS(4843),
    [sym_extern] = ACTIONS(4843),
    [sym_final] = ACTIONS(4843),
    [sym_for] = ACTIONS(4843),
    [sym_foreach] = ACTIONS(4843),
    [sym_foreach_reverse] = ACTIONS(4843),
    [sym_function] = ACTIONS(4843),
    [sym_goto] = ACTIONS(4843),
    [sym_if] = ACTIONS(4843),
    [sym_immutable] = ACTIONS(4843),
    [sym_import] = ACTIONS(4843),
    [sym_in] = ACTIONS(4843),
    [sym_inout] = ACTIONS(4843),
    [sym_interface] = ACTIONS(4843),
    [sym_invariant] = ACTIONS(4843),
    [sym_is] = ACTIONS(4843),
    [sym_mixin] = ACTIONS(4843),
    [sym_new] = ACTIONS(4843),
    [sym_nothrow] = ACTIONS(4843),
    [sym_out] = ACTIONS(4843),
    [sym_override] = ACTIONS(4843),
    [sym_package] = ACTIONS(4843),
    [sym_pragma] = ACTIONS(4843),
    [sym_private] = ACTIONS(4843),
    [sym_protected] = ACTIONS(4843),
    [sym_public] = ACTIONS(4843),
    [sym_pure] = ACTIONS(4843),
    [sym_ref] = ACTIONS(4843),
    [sym_return] = ACTIONS(4843),
    [sym_scope] = ACTIONS(4843),
    [sym_shared] = ACTIONS(4843),
    [sym_static] = ACTIONS(4843),
    [sym_struct] = ACTIONS(4843),
    [sym_switch] = ACTIONS(4843),
    [sym_synchronized] = ACTIONS(4843),
    [sym_template] = ACTIONS(4843),
    [sym_throw] = ACTIONS(4843),
    [sym_try] = ACTIONS(4843),
    [sym_typeid] = ACTIONS(4843),
    [sym_typeof] = ACTIONS(4843),
    [sym_union] = ACTIONS(4843),
    [sym_unittest] = ACTIONS(4843),
    [sym_version] = ACTIONS(4843),
    [sym_while] = ACTIONS(4843),
    [sym_with] = ACTIONS(4843),
    [sym_gshared] = ACTIONS(4843),
    [sym_traits] = ACTIONS(4843),
    [sym_vector] = ACTIONS(4843),
    [sym_void] = ACTIONS(4843),
    [anon_sym_BQUOTE] = ACTIONS(4845),
    [anon_sym_r_DQUOTE] = ACTIONS(4845),
    [anon_sym_x_DQUOTE] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4845),
    [anon_sym_i_BQUOTE] = ACTIONS(4845),
    [anon_sym_i_DQUOTE] = ACTIONS(4845),
    [anon_sym_iq_LBRACE] = ACTIONS(4845),
    [aux_sym_char_literal_token1] = ACTIONS(4845),
    [anon_sym_SQUOTE] = ACTIONS(4843),
    [anon_sym___DATE__] = ACTIONS(4843),
    [anon_sym___FILE__] = ACTIONS(4843),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4843),
    [anon_sym___FUNCTION__] = ACTIONS(4843),
    [anon_sym___LINE__] = ACTIONS(4843),
    [anon_sym___MODULE__] = ACTIONS(4843),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4843),
    [anon_sym___TIME__] = ACTIONS(4843),
    [anon_sym___TIMESTAMP__] = ACTIONS(4843),
    [anon_sym___VENDOR__] = ACTIONS(4843),
    [anon_sym___VERSION__] = ACTIONS(4843),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4845),
    [sym_float_literal] = ACTIONS(4845),
    [sym__string] = ACTIONS(4845),
  },
  [1533] = {
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_q_LBRACE] = ACTIONS(4552),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_LBRACE] = ACTIONS(4552),
    [anon_sym_DOT] = ACTIONS(4552),
    [anon_sym_AMP] = ACTIONS(4552),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_DASH_DASH] = ACTIONS(4552),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_PLUS_PLUS] = ACTIONS(4552),
    [anon_sym_BANG] = ACTIONS(4552),
    [anon_sym_LPAREN] = ACTIONS(4552),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_LBRACK] = ACTIONS(4552),
    [anon_sym_SEMI] = ACTIONS(4552),
    [anon_sym_DOLLAR] = ACTIONS(4552),
    [anon_sym_STAR] = ACTIONS(4552),
    [anon_sym_TILDE] = ACTIONS(4552),
    [anon_sym_AT] = ACTIONS(4552),
    [sym_bool] = ACTIONS(4550),
    [sym_byte] = ACTIONS(4550),
    [sym_ubyte] = ACTIONS(4550),
    [sym_char] = ACTIONS(4550),
    [sym_short] = ACTIONS(4550),
    [sym_ushort] = ACTIONS(4550),
    [sym_int] = ACTIONS(4550),
    [sym_uint] = ACTIONS(4550),
    [sym_long] = ACTIONS(4550),
    [sym_ulong] = ACTIONS(4550),
    [sym_cent] = ACTIONS(4550),
    [sym_ucent] = ACTIONS(4550),
    [sym_wchar] = ACTIONS(4550),
    [sym_dchar] = ACTIONS(4550),
    [sym_float] = ACTIONS(4550),
    [sym_double] = ACTIONS(4550),
    [sym_real] = ACTIONS(4550),
    [sym_ifloat] = ACTIONS(4550),
    [sym_idouble] = ACTIONS(4550),
    [sym_ireal] = ACTIONS(4550),
    [sym_cfloat] = ACTIONS(4550),
    [sym_cdouble] = ACTIONS(4550),
    [sym_creal] = ACTIONS(4550),
    [sym_size_t] = ACTIONS(4550),
    [sym_ptrdiff_t] = ACTIONS(4550),
    [sym_string] = ACTIONS(4550),
    [sym_cstring] = ACTIONS(4550),
    [sym_dstring] = ACTIONS(4550),
    [sym_wstring] = ACTIONS(4550),
    [sym_noreturn] = ACTIONS(4550),
    [sym_true] = ACTIONS(4550),
    [sym_false] = ACTIONS(4550),
    [sym_null] = ACTIONS(4550),
    [sym_super] = ACTIONS(4550),
    [sym_this] = ACTIONS(4550),
    [sym_abstract] = ACTIONS(4550),
    [sym_alias] = ACTIONS(4550),
    [sym_align] = ACTIONS(4550),
    [sym_asm] = ACTIONS(4550),
    [sym_assert] = ACTIONS(4550),
    [sym_auto] = ACTIONS(4550),
    [sym_break] = ACTIONS(4550),
    [sym_case] = ACTIONS(4550),
    [sym_cast] = ACTIONS(4550),
    [sym_class] = ACTIONS(4550),
    [sym_const] = ACTIONS(4550),
    [sym_continue] = ACTIONS(4550),
    [sym_debug] = ACTIONS(4550),
    [sym_default] = ACTIONS(4550),
    [sym_delegate] = ACTIONS(4550),
    [sym_delete] = ACTIONS(4550),
    [sym_deprecated] = ACTIONS(4550),
    [sym_do] = ACTIONS(4550),
    [sym_else] = ACTIONS(4550),
    [sym_enum] = ACTIONS(4550),
    [sym_export] = ACTIONS(4550),
    [sym_extern] = ACTIONS(4550),
    [sym_final] = ACTIONS(4550),
    [sym_for] = ACTIONS(4550),
    [sym_foreach] = ACTIONS(4550),
    [sym_foreach_reverse] = ACTIONS(4550),
    [sym_function] = ACTIONS(4550),
    [sym_goto] = ACTIONS(4550),
    [sym_if] = ACTIONS(4550),
    [sym_immutable] = ACTIONS(4550),
    [sym_import] = ACTIONS(4550),
    [sym_in] = ACTIONS(4550),
    [sym_inout] = ACTIONS(4550),
    [sym_interface] = ACTIONS(4550),
    [sym_invariant] = ACTIONS(4550),
    [sym_is] = ACTIONS(4550),
    [sym_mixin] = ACTIONS(4550),
    [sym_new] = ACTIONS(4550),
    [sym_nothrow] = ACTIONS(4550),
    [sym_out] = ACTIONS(4550),
    [sym_override] = ACTIONS(4550),
    [sym_package] = ACTIONS(4550),
    [sym_pragma] = ACTIONS(4550),
    [sym_private] = ACTIONS(4550),
    [sym_protected] = ACTIONS(4550),
    [sym_public] = ACTIONS(4550),
    [sym_pure] = ACTIONS(4550),
    [sym_ref] = ACTIONS(4550),
    [sym_return] = ACTIONS(4550),
    [sym_scope] = ACTIONS(4550),
    [sym_shared] = ACTIONS(4550),
    [sym_static] = ACTIONS(4550),
    [sym_struct] = ACTIONS(4550),
    [sym_switch] = ACTIONS(4550),
    [sym_synchronized] = ACTIONS(4550),
    [sym_template] = ACTIONS(4550),
    [sym_throw] = ACTIONS(4550),
    [sym_try] = ACTIONS(4550),
    [sym_typeid] = ACTIONS(4550),
    [sym_typeof] = ACTIONS(4550),
    [sym_union] = ACTIONS(4550),
    [sym_unittest] = ACTIONS(4550),
    [sym_version] = ACTIONS(4550),
    [sym_while] = ACTIONS(4550),
    [sym_with] = ACTIONS(4550),
    [sym_gshared] = ACTIONS(4550),
    [sym_traits] = ACTIONS(4550),
    [sym_vector] = ACTIONS(4550),
    [sym_void] = ACTIONS(4550),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [anon_sym_r_DQUOTE] = ACTIONS(4552),
    [anon_sym_x_DQUOTE] = ACTIONS(4552),
    [anon_sym_DQUOTE] = ACTIONS(4552),
    [anon_sym_i_BQUOTE] = ACTIONS(4552),
    [anon_sym_i_DQUOTE] = ACTIONS(4552),
    [anon_sym_iq_LBRACE] = ACTIONS(4552),
    [aux_sym_char_literal_token1] = ACTIONS(4552),
    [anon_sym_SQUOTE] = ACTIONS(4550),
    [anon_sym___DATE__] = ACTIONS(4550),
    [anon_sym___FILE__] = ACTIONS(4550),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4550),
    [anon_sym___FUNCTION__] = ACTIONS(4550),
    [anon_sym___LINE__] = ACTIONS(4550),
    [anon_sym___MODULE__] = ACTIONS(4550),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4550),
    [anon_sym___TIME__] = ACTIONS(4550),
    [anon_sym___TIMESTAMP__] = ACTIONS(4550),
    [anon_sym___VENDOR__] = ACTIONS(4550),
    [anon_sym___VERSION__] = ACTIONS(4550),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4552),
    [sym_float_literal] = ACTIONS(4552),
    [sym__string] = ACTIONS(4552),
  },
  [1534] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_q_LBRACE] = ACTIONS(4857),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_LBRACE] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(4857),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS] = ACTIONS(4855),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4857),
    [anon_sym_LPAREN] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym_DOLLAR] = ACTIONS(4857),
    [anon_sym_STAR] = ACTIONS(4857),
    [anon_sym_TILDE] = ACTIONS(4857),
    [anon_sym_AT] = ACTIONS(4857),
    [sym_bool] = ACTIONS(4855),
    [sym_byte] = ACTIONS(4855),
    [sym_ubyte] = ACTIONS(4855),
    [sym_char] = ACTIONS(4855),
    [sym_short] = ACTIONS(4855),
    [sym_ushort] = ACTIONS(4855),
    [sym_int] = ACTIONS(4855),
    [sym_uint] = ACTIONS(4855),
    [sym_long] = ACTIONS(4855),
    [sym_ulong] = ACTIONS(4855),
    [sym_cent] = ACTIONS(4855),
    [sym_ucent] = ACTIONS(4855),
    [sym_wchar] = ACTIONS(4855),
    [sym_dchar] = ACTIONS(4855),
    [sym_float] = ACTIONS(4855),
    [sym_double] = ACTIONS(4855),
    [sym_real] = ACTIONS(4855),
    [sym_ifloat] = ACTIONS(4855),
    [sym_idouble] = ACTIONS(4855),
    [sym_ireal] = ACTIONS(4855),
    [sym_cfloat] = ACTIONS(4855),
    [sym_cdouble] = ACTIONS(4855),
    [sym_creal] = ACTIONS(4855),
    [sym_size_t] = ACTIONS(4855),
    [sym_ptrdiff_t] = ACTIONS(4855),
    [sym_string] = ACTIONS(4855),
    [sym_cstring] = ACTIONS(4855),
    [sym_dstring] = ACTIONS(4855),
    [sym_wstring] = ACTIONS(4855),
    [sym_noreturn] = ACTIONS(4855),
    [sym_true] = ACTIONS(4855),
    [sym_false] = ACTIONS(4855),
    [sym_null] = ACTIONS(4855),
    [sym_super] = ACTIONS(4855),
    [sym_this] = ACTIONS(4855),
    [sym_abstract] = ACTIONS(4855),
    [sym_alias] = ACTIONS(4855),
    [sym_align] = ACTIONS(4855),
    [sym_asm] = ACTIONS(4855),
    [sym_assert] = ACTIONS(4855),
    [sym_auto] = ACTIONS(4855),
    [sym_break] = ACTIONS(4855),
    [sym_case] = ACTIONS(4855),
    [sym_cast] = ACTIONS(4855),
    [sym_class] = ACTIONS(4855),
    [sym_const] = ACTIONS(4855),
    [sym_continue] = ACTIONS(4855),
    [sym_debug] = ACTIONS(4855),
    [sym_default] = ACTIONS(4855),
    [sym_delegate] = ACTIONS(4855),
    [sym_delete] = ACTIONS(4855),
    [sym_deprecated] = ACTIONS(4855),
    [sym_do] = ACTIONS(4855),
    [sym_else] = ACTIONS(4855),
    [sym_enum] = ACTIONS(4855),
    [sym_export] = ACTIONS(4855),
    [sym_extern] = ACTIONS(4855),
    [sym_final] = ACTIONS(4855),
    [sym_for] = ACTIONS(4855),
    [sym_foreach] = ACTIONS(4855),
    [sym_foreach_reverse] = ACTIONS(4855),
    [sym_function] = ACTIONS(4855),
    [sym_goto] = ACTIONS(4855),
    [sym_if] = ACTIONS(4855),
    [sym_immutable] = ACTIONS(4855),
    [sym_import] = ACTIONS(4855),
    [sym_in] = ACTIONS(4855),
    [sym_inout] = ACTIONS(4855),
    [sym_interface] = ACTIONS(4855),
    [sym_invariant] = ACTIONS(4855),
    [sym_is] = ACTIONS(4855),
    [sym_mixin] = ACTIONS(4855),
    [sym_new] = ACTIONS(4855),
    [sym_nothrow] = ACTIONS(4855),
    [sym_out] = ACTIONS(4855),
    [sym_override] = ACTIONS(4855),
    [sym_package] = ACTIONS(4855),
    [sym_pragma] = ACTIONS(4855),
    [sym_private] = ACTIONS(4855),
    [sym_protected] = ACTIONS(4855),
    [sym_public] = ACTIONS(4855),
    [sym_pure] = ACTIONS(4855),
    [sym_ref] = ACTIONS(4855),
    [sym_return] = ACTIONS(4855),
    [sym_scope] = ACTIONS(4855),
    [sym_shared] = ACTIONS(4855),
    [sym_static] = ACTIONS(4855),
    [sym_struct] = ACTIONS(4855),
    [sym_switch] = ACTIONS(4855),
    [sym_synchronized] = ACTIONS(4855),
    [sym_template] = ACTIONS(4855),
    [sym_throw] = ACTIONS(4855),
    [sym_try] = ACTIONS(4855),
    [sym_typeid] = ACTIONS(4855),
    [sym_typeof] = ACTIONS(4855),
    [sym_union] = ACTIONS(4855),
    [sym_unittest] = ACTIONS(4855),
    [sym_version] = ACTIONS(4855),
    [sym_while] = ACTIONS(4855),
    [sym_with] = ACTIONS(4855),
    [sym_gshared] = ACTIONS(4855),
    [sym_traits] = ACTIONS(4855),
    [sym_vector] = ACTIONS(4855),
    [sym_void] = ACTIONS(4855),
    [anon_sym_BQUOTE] = ACTIONS(4857),
    [anon_sym_r_DQUOTE] = ACTIONS(4857),
    [anon_sym_x_DQUOTE] = ACTIONS(4857),
    [anon_sym_DQUOTE] = ACTIONS(4857),
    [anon_sym_i_BQUOTE] = ACTIONS(4857),
    [anon_sym_i_DQUOTE] = ACTIONS(4857),
    [anon_sym_iq_LBRACE] = ACTIONS(4857),
    [aux_sym_char_literal_token1] = ACTIONS(4857),
    [anon_sym_SQUOTE] = ACTIONS(4855),
    [anon_sym___DATE__] = ACTIONS(4855),
    [anon_sym___FILE__] = ACTIONS(4855),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4855),
    [anon_sym___FUNCTION__] = ACTIONS(4855),
    [anon_sym___LINE__] = ACTIONS(4855),
    [anon_sym___MODULE__] = ACTIONS(4855),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4855),
    [anon_sym___TIME__] = ACTIONS(4855),
    [anon_sym___TIMESTAMP__] = ACTIONS(4855),
    [anon_sym___VENDOR__] = ACTIONS(4855),
    [anon_sym___VERSION__] = ACTIONS(4855),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4857),
    [sym_float_literal] = ACTIONS(4857),
    [sym__string] = ACTIONS(4857),
  },
  [1535] = {
    [sym_identifier] = ACTIONS(4697),
    [anon_sym_q_LBRACE] = ACTIONS(4699),
    [anon_sym_RBRACE] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4699),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_DASH] = ACTIONS(4699),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4699),
    [anon_sym_BANG] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4699),
    [anon_sym_RPAREN] = ACTIONS(4699),
    [anon_sym_LBRACK] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4699),
    [anon_sym_DOLLAR] = ACTIONS(4699),
    [anon_sym_STAR] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4699),
    [anon_sym_AT] = ACTIONS(4699),
    [sym_bool] = ACTIONS(4697),
    [sym_byte] = ACTIONS(4697),
    [sym_ubyte] = ACTIONS(4697),
    [sym_char] = ACTIONS(4697),
    [sym_short] = ACTIONS(4697),
    [sym_ushort] = ACTIONS(4697),
    [sym_int] = ACTIONS(4697),
    [sym_uint] = ACTIONS(4697),
    [sym_long] = ACTIONS(4697),
    [sym_ulong] = ACTIONS(4697),
    [sym_cent] = ACTIONS(4697),
    [sym_ucent] = ACTIONS(4697),
    [sym_wchar] = ACTIONS(4697),
    [sym_dchar] = ACTIONS(4697),
    [sym_float] = ACTIONS(4697),
    [sym_double] = ACTIONS(4697),
    [sym_real] = ACTIONS(4697),
    [sym_ifloat] = ACTIONS(4697),
    [sym_idouble] = ACTIONS(4697),
    [sym_ireal] = ACTIONS(4697),
    [sym_cfloat] = ACTIONS(4697),
    [sym_cdouble] = ACTIONS(4697),
    [sym_creal] = ACTIONS(4697),
    [sym_size_t] = ACTIONS(4697),
    [sym_ptrdiff_t] = ACTIONS(4697),
    [sym_string] = ACTIONS(4697),
    [sym_cstring] = ACTIONS(4697),
    [sym_dstring] = ACTIONS(4697),
    [sym_wstring] = ACTIONS(4697),
    [sym_noreturn] = ACTIONS(4697),
    [sym_true] = ACTIONS(4697),
    [sym_false] = ACTIONS(4697),
    [sym_null] = ACTIONS(4697),
    [sym_super] = ACTIONS(4697),
    [sym_this] = ACTIONS(4697),
    [sym_abstract] = ACTIONS(4697),
    [sym_alias] = ACTIONS(4697),
    [sym_align] = ACTIONS(4697),
    [sym_asm] = ACTIONS(4697),
    [sym_assert] = ACTIONS(4697),
    [sym_auto] = ACTIONS(4697),
    [sym_break] = ACTIONS(4697),
    [sym_case] = ACTIONS(4697),
    [sym_cast] = ACTIONS(4697),
    [sym_class] = ACTIONS(4697),
    [sym_const] = ACTIONS(4697),
    [sym_continue] = ACTIONS(4697),
    [sym_debug] = ACTIONS(4697),
    [sym_default] = ACTIONS(4697),
    [sym_delegate] = ACTIONS(4697),
    [sym_delete] = ACTIONS(4697),
    [sym_deprecated] = ACTIONS(4697),
    [sym_do] = ACTIONS(4697),
    [sym_else] = ACTIONS(4697),
    [sym_enum] = ACTIONS(4697),
    [sym_export] = ACTIONS(4697),
    [sym_extern] = ACTIONS(4697),
    [sym_final] = ACTIONS(4697),
    [sym_for] = ACTIONS(4697),
    [sym_foreach] = ACTIONS(4697),
    [sym_foreach_reverse] = ACTIONS(4697),
    [sym_function] = ACTIONS(4697),
    [sym_goto] = ACTIONS(4697),
    [sym_if] = ACTIONS(4697),
    [sym_immutable] = ACTIONS(4697),
    [sym_import] = ACTIONS(4697),
    [sym_in] = ACTIONS(4697),
    [sym_inout] = ACTIONS(4697),
    [sym_interface] = ACTIONS(4697),
    [sym_invariant] = ACTIONS(4697),
    [sym_is] = ACTIONS(4697),
    [sym_mixin] = ACTIONS(4697),
    [sym_new] = ACTIONS(4697),
    [sym_nothrow] = ACTIONS(4697),
    [sym_out] = ACTIONS(4697),
    [sym_override] = ACTIONS(4697),
    [sym_package] = ACTIONS(4697),
    [sym_pragma] = ACTIONS(4697),
    [sym_private] = ACTIONS(4697),
    [sym_protected] = ACTIONS(4697),
    [sym_public] = ACTIONS(4697),
    [sym_pure] = ACTIONS(4697),
    [sym_ref] = ACTIONS(4697),
    [sym_return] = ACTIONS(4697),
    [sym_scope] = ACTIONS(4697),
    [sym_shared] = ACTIONS(4697),
    [sym_static] = ACTIONS(4697),
    [sym_struct] = ACTIONS(4697),
    [sym_switch] = ACTIONS(4697),
    [sym_synchronized] = ACTIONS(4697),
    [sym_template] = ACTIONS(4697),
    [sym_throw] = ACTIONS(4697),
    [sym_try] = ACTIONS(4697),
    [sym_typeid] = ACTIONS(4697),
    [sym_typeof] = ACTIONS(4697),
    [sym_union] = ACTIONS(4697),
    [sym_unittest] = ACTIONS(4697),
    [sym_version] = ACTIONS(4697),
    [sym_while] = ACTIONS(4697),
    [sym_with] = ACTIONS(4697),
    [sym_gshared] = ACTIONS(4697),
    [sym_traits] = ACTIONS(4697),
    [sym_vector] = ACTIONS(4697),
    [sym_void] = ACTIONS(4697),
    [anon_sym_BQUOTE] = ACTIONS(4699),
    [anon_sym_r_DQUOTE] = ACTIONS(4699),
    [anon_sym_x_DQUOTE] = ACTIONS(4699),
    [anon_sym_DQUOTE] = ACTIONS(4699),
    [anon_sym_i_BQUOTE] = ACTIONS(4699),
    [anon_sym_i_DQUOTE] = ACTIONS(4699),
    [anon_sym_iq_LBRACE] = ACTIONS(4699),
    [aux_sym_char_literal_token1] = ACTIONS(4699),
    [anon_sym_SQUOTE] = ACTIONS(4697),
    [anon_sym___DATE__] = ACTIONS(4697),
    [anon_sym___FILE__] = ACTIONS(4697),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4697),
    [anon_sym___FUNCTION__] = ACTIONS(4697),
    [anon_sym___LINE__] = ACTIONS(4697),
    [anon_sym___MODULE__] = ACTIONS(4697),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4697),
    [anon_sym___TIME__] = ACTIONS(4697),
    [anon_sym___TIMESTAMP__] = ACTIONS(4697),
    [anon_sym___VENDOR__] = ACTIONS(4697),
    [anon_sym___VERSION__] = ACTIONS(4697),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4699),
    [sym_float_literal] = ACTIONS(4699),
    [sym__string] = ACTIONS(4699),
  },
  [1536] = {
    [sym_identifier] = ACTIONS(4751),
    [anon_sym_q_LBRACE] = ACTIONS(4753),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [anon_sym_LBRACE] = ACTIONS(4753),
    [anon_sym_DOT] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4753),
    [anon_sym_PLUS] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4753),
    [anon_sym_BANG] = ACTIONS(4753),
    [anon_sym_LPAREN] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(4753),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [anon_sym_STAR] = ACTIONS(4753),
    [anon_sym_TILDE] = ACTIONS(4753),
    [anon_sym_AT] = ACTIONS(4753),
    [sym_bool] = ACTIONS(4751),
    [sym_byte] = ACTIONS(4751),
    [sym_ubyte] = ACTIONS(4751),
    [sym_char] = ACTIONS(4751),
    [sym_short] = ACTIONS(4751),
    [sym_ushort] = ACTIONS(4751),
    [sym_int] = ACTIONS(4751),
    [sym_uint] = ACTIONS(4751),
    [sym_long] = ACTIONS(4751),
    [sym_ulong] = ACTIONS(4751),
    [sym_cent] = ACTIONS(4751),
    [sym_ucent] = ACTIONS(4751),
    [sym_wchar] = ACTIONS(4751),
    [sym_dchar] = ACTIONS(4751),
    [sym_float] = ACTIONS(4751),
    [sym_double] = ACTIONS(4751),
    [sym_real] = ACTIONS(4751),
    [sym_ifloat] = ACTIONS(4751),
    [sym_idouble] = ACTIONS(4751),
    [sym_ireal] = ACTIONS(4751),
    [sym_cfloat] = ACTIONS(4751),
    [sym_cdouble] = ACTIONS(4751),
    [sym_creal] = ACTIONS(4751),
    [sym_size_t] = ACTIONS(4751),
    [sym_ptrdiff_t] = ACTIONS(4751),
    [sym_string] = ACTIONS(4751),
    [sym_cstring] = ACTIONS(4751),
    [sym_dstring] = ACTIONS(4751),
    [sym_wstring] = ACTIONS(4751),
    [sym_noreturn] = ACTIONS(4751),
    [sym_true] = ACTIONS(4751),
    [sym_false] = ACTIONS(4751),
    [sym_null] = ACTIONS(4751),
    [sym_super] = ACTIONS(4751),
    [sym_this] = ACTIONS(4751),
    [sym_abstract] = ACTIONS(4751),
    [sym_alias] = ACTIONS(4751),
    [sym_align] = ACTIONS(4751),
    [sym_asm] = ACTIONS(4751),
    [sym_assert] = ACTIONS(4751),
    [sym_auto] = ACTIONS(4751),
    [sym_break] = ACTIONS(4751),
    [sym_case] = ACTIONS(4751),
    [sym_cast] = ACTIONS(4751),
    [sym_class] = ACTIONS(4751),
    [sym_const] = ACTIONS(4751),
    [sym_continue] = ACTIONS(4751),
    [sym_debug] = ACTIONS(4751),
    [sym_default] = ACTIONS(4751),
    [sym_delegate] = ACTIONS(4751),
    [sym_delete] = ACTIONS(4751),
    [sym_deprecated] = ACTIONS(4751),
    [sym_do] = ACTIONS(4751),
    [sym_else] = ACTIONS(4751),
    [sym_enum] = ACTIONS(4751),
    [sym_export] = ACTIONS(4751),
    [sym_extern] = ACTIONS(4751),
    [sym_final] = ACTIONS(4751),
    [sym_for] = ACTIONS(4751),
    [sym_foreach] = ACTIONS(4751),
    [sym_foreach_reverse] = ACTIONS(4751),
    [sym_function] = ACTIONS(4751),
    [sym_goto] = ACTIONS(4751),
    [sym_if] = ACTIONS(4751),
    [sym_immutable] = ACTIONS(4751),
    [sym_import] = ACTIONS(4751),
    [sym_in] = ACTIONS(4751),
    [sym_inout] = ACTIONS(4751),
    [sym_interface] = ACTIONS(4751),
    [sym_invariant] = ACTIONS(4751),
    [sym_is] = ACTIONS(4751),
    [sym_mixin] = ACTIONS(4751),
    [sym_new] = ACTIONS(4751),
    [sym_nothrow] = ACTIONS(4751),
    [sym_out] = ACTIONS(4751),
    [sym_override] = ACTIONS(4751),
    [sym_package] = ACTIONS(4751),
    [sym_pragma] = ACTIONS(4751),
    [sym_private] = ACTIONS(4751),
    [sym_protected] = ACTIONS(4751),
    [sym_public] = ACTIONS(4751),
    [sym_pure] = ACTIONS(4751),
    [sym_ref] = ACTIONS(4751),
    [sym_return] = ACTIONS(4751),
    [sym_scope] = ACTIONS(4751),
    [sym_shared] = ACTIONS(4751),
    [sym_static] = ACTIONS(4751),
    [sym_struct] = ACTIONS(4751),
    [sym_switch] = ACTIONS(4751),
    [sym_synchronized] = ACTIONS(4751),
    [sym_template] = ACTIONS(4751),
    [sym_throw] = ACTIONS(4751),
    [sym_try] = ACTIONS(4751),
    [sym_typeid] = ACTIONS(4751),
    [sym_typeof] = ACTIONS(4751),
    [sym_union] = ACTIONS(4751),
    [sym_unittest] = ACTIONS(4751),
    [sym_version] = ACTIONS(4751),
    [sym_while] = ACTIONS(4751),
    [sym_with] = ACTIONS(4751),
    [sym_gshared] = ACTIONS(4751),
    [sym_traits] = ACTIONS(4751),
    [sym_vector] = ACTIONS(4751),
    [sym_void] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_r_DQUOTE] = ACTIONS(4753),
    [anon_sym_x_DQUOTE] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_i_BQUOTE] = ACTIONS(4753),
    [anon_sym_i_DQUOTE] = ACTIONS(4753),
    [anon_sym_iq_LBRACE] = ACTIONS(4753),
    [aux_sym_char_literal_token1] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4751),
    [anon_sym___DATE__] = ACTIONS(4751),
    [anon_sym___FILE__] = ACTIONS(4751),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4751),
    [anon_sym___FUNCTION__] = ACTIONS(4751),
    [anon_sym___LINE__] = ACTIONS(4751),
    [anon_sym___MODULE__] = ACTIONS(4751),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4751),
    [anon_sym___TIME__] = ACTIONS(4751),
    [anon_sym___TIMESTAMP__] = ACTIONS(4751),
    [anon_sym___VENDOR__] = ACTIONS(4751),
    [anon_sym___VERSION__] = ACTIONS(4751),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4753),
    [sym_float_literal] = ACTIONS(4753),
    [sym__string] = ACTIONS(4753),
  },
  [1537] = {
    [sym_identifier] = ACTIONS(4777),
    [anon_sym_q_LBRACE] = ACTIONS(4779),
    [anon_sym_RBRACE] = ACTIONS(4779),
    [anon_sym_LBRACE] = ACTIONS(4779),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_DASH] = ACTIONS(4777),
    [anon_sym_DASH_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4779),
    [anon_sym_BANG] = ACTIONS(4779),
    [anon_sym_LPAREN] = ACTIONS(4779),
    [anon_sym_RPAREN] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4779),
    [anon_sym_DOLLAR] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_TILDE] = ACTIONS(4779),
    [anon_sym_AT] = ACTIONS(4779),
    [sym_bool] = ACTIONS(4777),
    [sym_byte] = ACTIONS(4777),
    [sym_ubyte] = ACTIONS(4777),
    [sym_char] = ACTIONS(4777),
    [sym_short] = ACTIONS(4777),
    [sym_ushort] = ACTIONS(4777),
    [sym_int] = ACTIONS(4777),
    [sym_uint] = ACTIONS(4777),
    [sym_long] = ACTIONS(4777),
    [sym_ulong] = ACTIONS(4777),
    [sym_cent] = ACTIONS(4777),
    [sym_ucent] = ACTIONS(4777),
    [sym_wchar] = ACTIONS(4777),
    [sym_dchar] = ACTIONS(4777),
    [sym_float] = ACTIONS(4777),
    [sym_double] = ACTIONS(4777),
    [sym_real] = ACTIONS(4777),
    [sym_ifloat] = ACTIONS(4777),
    [sym_idouble] = ACTIONS(4777),
    [sym_ireal] = ACTIONS(4777),
    [sym_cfloat] = ACTIONS(4777),
    [sym_cdouble] = ACTIONS(4777),
    [sym_creal] = ACTIONS(4777),
    [sym_size_t] = ACTIONS(4777),
    [sym_ptrdiff_t] = ACTIONS(4777),
    [sym_string] = ACTIONS(4777),
    [sym_cstring] = ACTIONS(4777),
    [sym_dstring] = ACTIONS(4777),
    [sym_wstring] = ACTIONS(4777),
    [sym_noreturn] = ACTIONS(4777),
    [sym_true] = ACTIONS(4777),
    [sym_false] = ACTIONS(4777),
    [sym_null] = ACTIONS(4777),
    [sym_super] = ACTIONS(4777),
    [sym_this] = ACTIONS(4777),
    [sym_abstract] = ACTIONS(4777),
    [sym_alias] = ACTIONS(4777),
    [sym_align] = ACTIONS(4777),
    [sym_asm] = ACTIONS(4777),
    [sym_assert] = ACTIONS(4777),
    [sym_auto] = ACTIONS(4777),
    [sym_break] = ACTIONS(4777),
    [sym_case] = ACTIONS(4777),
    [sym_cast] = ACTIONS(4777),
    [sym_class] = ACTIONS(4777),
    [sym_const] = ACTIONS(4777),
    [sym_continue] = ACTIONS(4777),
    [sym_debug] = ACTIONS(4777),
    [sym_default] = ACTIONS(4777),
    [sym_delegate] = ACTIONS(4777),
    [sym_delete] = ACTIONS(4777),
    [sym_deprecated] = ACTIONS(4777),
    [sym_do] = ACTIONS(4777),
    [sym_else] = ACTIONS(4777),
    [sym_enum] = ACTIONS(4777),
    [sym_export] = ACTIONS(4777),
    [sym_extern] = ACTIONS(4777),
    [sym_final] = ACTIONS(4777),
    [sym_for] = ACTIONS(4777),
    [sym_foreach] = ACTIONS(4777),
    [sym_foreach_reverse] = ACTIONS(4777),
    [sym_function] = ACTIONS(4777),
    [sym_goto] = ACTIONS(4777),
    [sym_if] = ACTIONS(4777),
    [sym_immutable] = ACTIONS(4777),
    [sym_import] = ACTIONS(4777),
    [sym_in] = ACTIONS(4777),
    [sym_inout] = ACTIONS(4777),
    [sym_interface] = ACTIONS(4777),
    [sym_invariant] = ACTIONS(4777),
    [sym_is] = ACTIONS(4777),
    [sym_mixin] = ACTIONS(4777),
    [sym_new] = ACTIONS(4777),
    [sym_nothrow] = ACTIONS(4777),
    [sym_out] = ACTIONS(4777),
    [sym_override] = ACTIONS(4777),
    [sym_package] = ACTIONS(4777),
    [sym_pragma] = ACTIONS(4777),
    [sym_private] = ACTIONS(4777),
    [sym_protected] = ACTIONS(4777),
    [sym_public] = ACTIONS(4777),
    [sym_pure] = ACTIONS(4777),
    [sym_ref] = ACTIONS(4777),
    [sym_return] = ACTIONS(4777),
    [sym_scope] = ACTIONS(4777),
    [sym_shared] = ACTIONS(4777),
    [sym_static] = ACTIONS(4777),
    [sym_struct] = ACTIONS(4777),
    [sym_switch] = ACTIONS(4777),
    [sym_synchronized] = ACTIONS(4777),
    [sym_template] = ACTIONS(4777),
    [sym_throw] = ACTIONS(4777),
    [sym_try] = ACTIONS(4777),
    [sym_typeid] = ACTIONS(4777),
    [sym_typeof] = ACTIONS(4777),
    [sym_union] = ACTIONS(4777),
    [sym_unittest] = ACTIONS(4777),
    [sym_version] = ACTIONS(4777),
    [sym_while] = ACTIONS(4777),
    [sym_with] = ACTIONS(4777),
    [sym_gshared] = ACTIONS(4777),
    [sym_traits] = ACTIONS(4777),
    [sym_vector] = ACTIONS(4777),
    [sym_void] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4779),
    [anon_sym_r_DQUOTE] = ACTIONS(4779),
    [anon_sym_x_DQUOTE] = ACTIONS(4779),
    [anon_sym_DQUOTE] = ACTIONS(4779),
    [anon_sym_i_BQUOTE] = ACTIONS(4779),
    [anon_sym_i_DQUOTE] = ACTIONS(4779),
    [anon_sym_iq_LBRACE] = ACTIONS(4779),
    [aux_sym_char_literal_token1] = ACTIONS(4779),
    [anon_sym_SQUOTE] = ACTIONS(4777),
    [anon_sym___DATE__] = ACTIONS(4777),
    [anon_sym___FILE__] = ACTIONS(4777),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4777),
    [anon_sym___FUNCTION__] = ACTIONS(4777),
    [anon_sym___LINE__] = ACTIONS(4777),
    [anon_sym___MODULE__] = ACTIONS(4777),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4777),
    [anon_sym___TIME__] = ACTIONS(4777),
    [anon_sym___TIMESTAMP__] = ACTIONS(4777),
    [anon_sym___VENDOR__] = ACTIONS(4777),
    [anon_sym___VERSION__] = ACTIONS(4777),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4779),
    [sym_float_literal] = ACTIONS(4779),
    [sym__string] = ACTIONS(4779),
  },
  [1538] = {
    [sym_identifier] = ACTIONS(4660),
    [anon_sym_q_LBRACE] = ACTIONS(4662),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [anon_sym_LBRACE] = ACTIONS(4662),
    [anon_sym_DOT] = ACTIONS(4662),
    [anon_sym_AMP] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4660),
    [anon_sym_DASH_DASH] = ACTIONS(4662),
    [anon_sym_PLUS] = ACTIONS(4660),
    [anon_sym_PLUS_PLUS] = ACTIONS(4662),
    [anon_sym_BANG] = ACTIONS(4662),
    [anon_sym_LPAREN] = ACTIONS(4662),
    [anon_sym_RPAREN] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(4662),
    [anon_sym_SEMI] = ACTIONS(4662),
    [anon_sym_DOLLAR] = ACTIONS(4662),
    [anon_sym_STAR] = ACTIONS(4662),
    [anon_sym_TILDE] = ACTIONS(4662),
    [anon_sym_AT] = ACTIONS(4662),
    [sym_bool] = ACTIONS(4660),
    [sym_byte] = ACTIONS(4660),
    [sym_ubyte] = ACTIONS(4660),
    [sym_char] = ACTIONS(4660),
    [sym_short] = ACTIONS(4660),
    [sym_ushort] = ACTIONS(4660),
    [sym_int] = ACTIONS(4660),
    [sym_uint] = ACTIONS(4660),
    [sym_long] = ACTIONS(4660),
    [sym_ulong] = ACTIONS(4660),
    [sym_cent] = ACTIONS(4660),
    [sym_ucent] = ACTIONS(4660),
    [sym_wchar] = ACTIONS(4660),
    [sym_dchar] = ACTIONS(4660),
    [sym_float] = ACTIONS(4660),
    [sym_double] = ACTIONS(4660),
    [sym_real] = ACTIONS(4660),
    [sym_ifloat] = ACTIONS(4660),
    [sym_idouble] = ACTIONS(4660),
    [sym_ireal] = ACTIONS(4660),
    [sym_cfloat] = ACTIONS(4660),
    [sym_cdouble] = ACTIONS(4660),
    [sym_creal] = ACTIONS(4660),
    [sym_size_t] = ACTIONS(4660),
    [sym_ptrdiff_t] = ACTIONS(4660),
    [sym_string] = ACTIONS(4660),
    [sym_cstring] = ACTIONS(4660),
    [sym_dstring] = ACTIONS(4660),
    [sym_wstring] = ACTIONS(4660),
    [sym_noreturn] = ACTIONS(4660),
    [sym_true] = ACTIONS(4660),
    [sym_false] = ACTIONS(4660),
    [sym_null] = ACTIONS(4660),
    [sym_super] = ACTIONS(4660),
    [sym_this] = ACTIONS(4660),
    [sym_abstract] = ACTIONS(4660),
    [sym_alias] = ACTIONS(4660),
    [sym_align] = ACTIONS(4660),
    [sym_asm] = ACTIONS(4660),
    [sym_assert] = ACTIONS(4660),
    [sym_auto] = ACTIONS(4660),
    [sym_break] = ACTIONS(4660),
    [sym_case] = ACTIONS(4660),
    [sym_cast] = ACTIONS(4660),
    [sym_class] = ACTIONS(4660),
    [sym_const] = ACTIONS(4660),
    [sym_continue] = ACTIONS(4660),
    [sym_debug] = ACTIONS(4660),
    [sym_default] = ACTIONS(4660),
    [sym_delegate] = ACTIONS(4660),
    [sym_delete] = ACTIONS(4660),
    [sym_deprecated] = ACTIONS(4660),
    [sym_do] = ACTIONS(4660),
    [sym_else] = ACTIONS(4660),
    [sym_enum] = ACTIONS(4660),
    [sym_export] = ACTIONS(4660),
    [sym_extern] = ACTIONS(4660),
    [sym_final] = ACTIONS(4660),
    [sym_for] = ACTIONS(4660),
    [sym_foreach] = ACTIONS(4660),
    [sym_foreach_reverse] = ACTIONS(4660),
    [sym_function] = ACTIONS(4660),
    [sym_goto] = ACTIONS(4660),
    [sym_if] = ACTIONS(4660),
    [sym_immutable] = ACTIONS(4660),
    [sym_import] = ACTIONS(4660),
    [sym_in] = ACTIONS(4660),
    [sym_inout] = ACTIONS(4660),
    [sym_interface] = ACTIONS(4660),
    [sym_invariant] = ACTIONS(4660),
    [sym_is] = ACTIONS(4660),
    [sym_mixin] = ACTIONS(4660),
    [sym_new] = ACTIONS(4660),
    [sym_nothrow] = ACTIONS(4660),
    [sym_out] = ACTIONS(4660),
    [sym_override] = ACTIONS(4660),
    [sym_package] = ACTIONS(4660),
    [sym_pragma] = ACTIONS(4660),
    [sym_private] = ACTIONS(4660),
    [sym_protected] = ACTIONS(4660),
    [sym_public] = ACTIONS(4660),
    [sym_pure] = ACTIONS(4660),
    [sym_ref] = ACTIONS(4660),
    [sym_return] = ACTIONS(4660),
    [sym_scope] = ACTIONS(4660),
    [sym_shared] = ACTIONS(4660),
    [sym_static] = ACTIONS(4660),
    [sym_struct] = ACTIONS(4660),
    [sym_switch] = ACTIONS(4660),
    [sym_synchronized] = ACTIONS(4660),
    [sym_template] = ACTIONS(4660),
    [sym_throw] = ACTIONS(4660),
    [sym_try] = ACTIONS(4660),
    [sym_typeid] = ACTIONS(4660),
    [sym_typeof] = ACTIONS(4660),
    [sym_union] = ACTIONS(4660),
    [sym_unittest] = ACTIONS(4660),
    [sym_version] = ACTIONS(4660),
    [sym_while] = ACTIONS(4660),
    [sym_with] = ACTIONS(4660),
    [sym_gshared] = ACTIONS(4660),
    [sym_traits] = ACTIONS(4660),
    [sym_vector] = ACTIONS(4660),
    [sym_void] = ACTIONS(4660),
    [anon_sym_BQUOTE] = ACTIONS(4662),
    [anon_sym_r_DQUOTE] = ACTIONS(4662),
    [anon_sym_x_DQUOTE] = ACTIONS(4662),
    [anon_sym_DQUOTE] = ACTIONS(4662),
    [anon_sym_i_BQUOTE] = ACTIONS(4662),
    [anon_sym_i_DQUOTE] = ACTIONS(4662),
    [anon_sym_iq_LBRACE] = ACTIONS(4662),
    [aux_sym_char_literal_token1] = ACTIONS(4662),
    [anon_sym_SQUOTE] = ACTIONS(4660),
    [anon_sym___DATE__] = ACTIONS(4660),
    [anon_sym___FILE__] = ACTIONS(4660),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4660),
    [anon_sym___FUNCTION__] = ACTIONS(4660),
    [anon_sym___LINE__] = ACTIONS(4660),
    [anon_sym___MODULE__] = ACTIONS(4660),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4660),
    [anon_sym___TIME__] = ACTIONS(4660),
    [anon_sym___TIMESTAMP__] = ACTIONS(4660),
    [anon_sym___VENDOR__] = ACTIONS(4660),
    [anon_sym___VERSION__] = ACTIONS(4660),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4662),
    [sym_float_literal] = ACTIONS(4662),
    [sym__string] = ACTIONS(4662),
  },
  [1539] = {
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_q_LBRACE] = ACTIONS(4861),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_LBRACE] = ACTIONS(4861),
    [anon_sym_DOT] = ACTIONS(4861),
    [anon_sym_AMP] = ACTIONS(4861),
    [anon_sym_DASH] = ACTIONS(4859),
    [anon_sym_DASH_DASH] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4859),
    [anon_sym_PLUS_PLUS] = ACTIONS(4861),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_LPAREN] = ACTIONS(4861),
    [anon_sym_RPAREN] = ACTIONS(4861),
    [anon_sym_LBRACK] = ACTIONS(4861),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_DOLLAR] = ACTIONS(4861),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_AT] = ACTIONS(4861),
    [sym_bool] = ACTIONS(4859),
    [sym_byte] = ACTIONS(4859),
    [sym_ubyte] = ACTIONS(4859),
    [sym_char] = ACTIONS(4859),
    [sym_short] = ACTIONS(4859),
    [sym_ushort] = ACTIONS(4859),
    [sym_int] = ACTIONS(4859),
    [sym_uint] = ACTIONS(4859),
    [sym_long] = ACTIONS(4859),
    [sym_ulong] = ACTIONS(4859),
    [sym_cent] = ACTIONS(4859),
    [sym_ucent] = ACTIONS(4859),
    [sym_wchar] = ACTIONS(4859),
    [sym_dchar] = ACTIONS(4859),
    [sym_float] = ACTIONS(4859),
    [sym_double] = ACTIONS(4859),
    [sym_real] = ACTIONS(4859),
    [sym_ifloat] = ACTIONS(4859),
    [sym_idouble] = ACTIONS(4859),
    [sym_ireal] = ACTIONS(4859),
    [sym_cfloat] = ACTIONS(4859),
    [sym_cdouble] = ACTIONS(4859),
    [sym_creal] = ACTIONS(4859),
    [sym_size_t] = ACTIONS(4859),
    [sym_ptrdiff_t] = ACTIONS(4859),
    [sym_string] = ACTIONS(4859),
    [sym_cstring] = ACTIONS(4859),
    [sym_dstring] = ACTIONS(4859),
    [sym_wstring] = ACTIONS(4859),
    [sym_noreturn] = ACTIONS(4859),
    [sym_true] = ACTIONS(4859),
    [sym_false] = ACTIONS(4859),
    [sym_null] = ACTIONS(4859),
    [sym_super] = ACTIONS(4859),
    [sym_this] = ACTIONS(4859),
    [sym_abstract] = ACTIONS(4859),
    [sym_alias] = ACTIONS(4859),
    [sym_align] = ACTIONS(4859),
    [sym_asm] = ACTIONS(4859),
    [sym_assert] = ACTIONS(4859),
    [sym_auto] = ACTIONS(4859),
    [sym_break] = ACTIONS(4859),
    [sym_case] = ACTIONS(4859),
    [sym_cast] = ACTIONS(4859),
    [sym_class] = ACTIONS(4859),
    [sym_const] = ACTIONS(4859),
    [sym_continue] = ACTIONS(4859),
    [sym_debug] = ACTIONS(4859),
    [sym_default] = ACTIONS(4859),
    [sym_delegate] = ACTIONS(4859),
    [sym_delete] = ACTIONS(4859),
    [sym_deprecated] = ACTIONS(4859),
    [sym_do] = ACTIONS(4859),
    [sym_else] = ACTIONS(4859),
    [sym_enum] = ACTIONS(4859),
    [sym_export] = ACTIONS(4859),
    [sym_extern] = ACTIONS(4859),
    [sym_final] = ACTIONS(4859),
    [sym_for] = ACTIONS(4859),
    [sym_foreach] = ACTIONS(4859),
    [sym_foreach_reverse] = ACTIONS(4859),
    [sym_function] = ACTIONS(4859),
    [sym_goto] = ACTIONS(4859),
    [sym_if] = ACTIONS(4859),
    [sym_immutable] = ACTIONS(4859),
    [sym_import] = ACTIONS(4859),
    [sym_in] = ACTIONS(4859),
    [sym_inout] = ACTIONS(4859),
    [sym_interface] = ACTIONS(4859),
    [sym_invariant] = ACTIONS(4859),
    [sym_is] = ACTIONS(4859),
    [sym_mixin] = ACTIONS(4859),
    [sym_new] = ACTIONS(4859),
    [sym_nothrow] = ACTIONS(4859),
    [sym_out] = ACTIONS(4859),
    [sym_override] = ACTIONS(4859),
    [sym_package] = ACTIONS(4859),
    [sym_pragma] = ACTIONS(4859),
    [sym_private] = ACTIONS(4859),
    [sym_protected] = ACTIONS(4859),
    [sym_public] = ACTIONS(4859),
    [sym_pure] = ACTIONS(4859),
    [sym_ref] = ACTIONS(4859),
    [sym_return] = ACTIONS(4859),
    [sym_scope] = ACTIONS(4859),
    [sym_shared] = ACTIONS(4859),
    [sym_static] = ACTIONS(4859),
    [sym_struct] = ACTIONS(4859),
    [sym_switch] = ACTIONS(4859),
    [sym_synchronized] = ACTIONS(4859),
    [sym_template] = ACTIONS(4859),
    [sym_throw] = ACTIONS(4859),
    [sym_try] = ACTIONS(4859),
    [sym_typeid] = ACTIONS(4859),
    [sym_typeof] = ACTIONS(4859),
    [sym_union] = ACTIONS(4859),
    [sym_unittest] = ACTIONS(4859),
    [sym_version] = ACTIONS(4859),
    [sym_while] = ACTIONS(4859),
    [sym_with] = ACTIONS(4859),
    [sym_gshared] = ACTIONS(4859),
    [sym_traits] = ACTIONS(4859),
    [sym_vector] = ACTIONS(4859),
    [sym_void] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_r_DQUOTE] = ACTIONS(4861),
    [anon_sym_x_DQUOTE] = ACTIONS(4861),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_i_BQUOTE] = ACTIONS(4861),
    [anon_sym_i_DQUOTE] = ACTIONS(4861),
    [anon_sym_iq_LBRACE] = ACTIONS(4861),
    [aux_sym_char_literal_token1] = ACTIONS(4861),
    [anon_sym_SQUOTE] = ACTIONS(4859),
    [anon_sym___DATE__] = ACTIONS(4859),
    [anon_sym___FILE__] = ACTIONS(4859),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4859),
    [anon_sym___FUNCTION__] = ACTIONS(4859),
    [anon_sym___LINE__] = ACTIONS(4859),
    [anon_sym___MODULE__] = ACTIONS(4859),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4859),
    [anon_sym___TIME__] = ACTIONS(4859),
    [anon_sym___TIMESTAMP__] = ACTIONS(4859),
    [anon_sym___VENDOR__] = ACTIONS(4859),
    [anon_sym___VERSION__] = ACTIONS(4859),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4861),
    [sym_float_literal] = ACTIONS(4861),
    [sym__string] = ACTIONS(4861),
  },
  [1540] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_q_LBRACE] = ACTIONS(2632),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [sym_bool] = ACTIONS(2634),
    [sym_byte] = ACTIONS(2634),
    [sym_ubyte] = ACTIONS(2634),
    [sym_char] = ACTIONS(2634),
    [sym_short] = ACTIONS(2634),
    [sym_ushort] = ACTIONS(2634),
    [sym_int] = ACTIONS(2634),
    [sym_uint] = ACTIONS(2634),
    [sym_long] = ACTIONS(2634),
    [sym_ulong] = ACTIONS(2634),
    [sym_cent] = ACTIONS(2634),
    [sym_ucent] = ACTIONS(2634),
    [sym_wchar] = ACTIONS(2634),
    [sym_dchar] = ACTIONS(2634),
    [sym_float] = ACTIONS(2634),
    [sym_double] = ACTIONS(2634),
    [sym_real] = ACTIONS(2634),
    [sym_ifloat] = ACTIONS(2634),
    [sym_idouble] = ACTIONS(2634),
    [sym_ireal] = ACTIONS(2634),
    [sym_cfloat] = ACTIONS(2634),
    [sym_cdouble] = ACTIONS(2634),
    [sym_creal] = ACTIONS(2634),
    [sym_size_t] = ACTIONS(2634),
    [sym_ptrdiff_t] = ACTIONS(2634),
    [sym_string] = ACTIONS(2634),
    [sym_cstring] = ACTIONS(2634),
    [sym_dstring] = ACTIONS(2634),
    [sym_wstring] = ACTIONS(2634),
    [sym_noreturn] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_this] = ACTIONS(2634),
    [sym_abstract] = ACTIONS(2634),
    [sym_alias] = ACTIONS(2634),
    [sym_align] = ACTIONS(2634),
    [sym_asm] = ACTIONS(2634),
    [sym_assert] = ACTIONS(2634),
    [sym_auto] = ACTIONS(2634),
    [sym_break] = ACTIONS(2634),
    [sym_case] = ACTIONS(2634),
    [sym_cast] = ACTIONS(2634),
    [sym_class] = ACTIONS(2634),
    [sym_const] = ACTIONS(2634),
    [sym_continue] = ACTIONS(2634),
    [sym_debug] = ACTIONS(2634),
    [sym_default] = ACTIONS(2634),
    [sym_delegate] = ACTIONS(2634),
    [sym_delete] = ACTIONS(2634),
    [sym_deprecated] = ACTIONS(2634),
    [sym_do] = ACTIONS(2634),
    [sym_else] = ACTIONS(5013),
    [sym_enum] = ACTIONS(2634),
    [sym_export] = ACTIONS(2634),
    [sym_extern] = ACTIONS(2634),
    [sym_final] = ACTIONS(2634),
    [sym_for] = ACTIONS(2634),
    [sym_foreach] = ACTIONS(2634),
    [sym_foreach_reverse] = ACTIONS(2634),
    [sym_function] = ACTIONS(2634),
    [sym_goto] = ACTIONS(2634),
    [sym_if] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(2634),
    [sym_import] = ACTIONS(2634),
    [sym_in] = ACTIONS(2634),
    [sym_inout] = ACTIONS(2634),
    [sym_interface] = ACTIONS(2634),
    [sym_invariant] = ACTIONS(2634),
    [sym_is] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2634),
    [sym_new] = ACTIONS(2634),
    [sym_nothrow] = ACTIONS(2634),
    [sym_out] = ACTIONS(2634),
    [sym_override] = ACTIONS(2634),
    [sym_package] = ACTIONS(2634),
    [sym_pragma] = ACTIONS(2634),
    [sym_private] = ACTIONS(2634),
    [sym_protected] = ACTIONS(2634),
    [sym_public] = ACTIONS(2634),
    [sym_pure] = ACTIONS(2634),
    [sym_ref] = ACTIONS(2634),
    [sym_return] = ACTIONS(2634),
    [sym_scope] = ACTIONS(2634),
    [sym_shared] = ACTIONS(2634),
    [sym_static] = ACTIONS(2634),
    [sym_struct] = ACTIONS(2634),
    [sym_switch] = ACTIONS(2634),
    [sym_synchronized] = ACTIONS(2634),
    [sym_template] = ACTIONS(2634),
    [sym_throw] = ACTIONS(2634),
    [sym_try] = ACTIONS(2634),
    [sym_typeid] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(2634),
    [sym_union] = ACTIONS(2634),
    [sym_unittest] = ACTIONS(2634),
    [sym_version] = ACTIONS(2634),
    [sym_while] = ACTIONS(2634),
    [sym_with] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(2634),
    [sym_traits] = ACTIONS(2634),
    [sym_vector] = ACTIONS(2634),
    [sym_void] = ACTIONS(2634),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_r_DQUOTE] = ACTIONS(2632),
    [anon_sym_x_DQUOTE] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_i_BQUOTE] = ACTIONS(2632),
    [anon_sym_i_DQUOTE] = ACTIONS(2632),
    [anon_sym_iq_LBRACE] = ACTIONS(2632),
    [aux_sym_char_literal_token1] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym___DATE__] = ACTIONS(2634),
    [anon_sym___FILE__] = ACTIONS(2634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2634),
    [anon_sym___FUNCTION__] = ACTIONS(2634),
    [anon_sym___LINE__] = ACTIONS(2634),
    [anon_sym___MODULE__] = ACTIONS(2634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2634),
    [anon_sym___TIME__] = ACTIONS(2634),
    [anon_sym___TIMESTAMP__] = ACTIONS(2634),
    [anon_sym___VENDOR__] = ACTIONS(2634),
    [anon_sym___VERSION__] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__string] = ACTIONS(2632),
  },
  [1541] = {
    [sym_identifier] = ACTIONS(4781),
    [anon_sym_q_LBRACE] = ACTIONS(4783),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_AMP] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4781),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS] = ACTIONS(4781),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_BANG] = ACTIONS(4783),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_DOLLAR] = ACTIONS(4783),
    [anon_sym_STAR] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_AT] = ACTIONS(4783),
    [sym_bool] = ACTIONS(4781),
    [sym_byte] = ACTIONS(4781),
    [sym_ubyte] = ACTIONS(4781),
    [sym_char] = ACTIONS(4781),
    [sym_short] = ACTIONS(4781),
    [sym_ushort] = ACTIONS(4781),
    [sym_int] = ACTIONS(4781),
    [sym_uint] = ACTIONS(4781),
    [sym_long] = ACTIONS(4781),
    [sym_ulong] = ACTIONS(4781),
    [sym_cent] = ACTIONS(4781),
    [sym_ucent] = ACTIONS(4781),
    [sym_wchar] = ACTIONS(4781),
    [sym_dchar] = ACTIONS(4781),
    [sym_float] = ACTIONS(4781),
    [sym_double] = ACTIONS(4781),
    [sym_real] = ACTIONS(4781),
    [sym_ifloat] = ACTIONS(4781),
    [sym_idouble] = ACTIONS(4781),
    [sym_ireal] = ACTIONS(4781),
    [sym_cfloat] = ACTIONS(4781),
    [sym_cdouble] = ACTIONS(4781),
    [sym_creal] = ACTIONS(4781),
    [sym_size_t] = ACTIONS(4781),
    [sym_ptrdiff_t] = ACTIONS(4781),
    [sym_string] = ACTIONS(4781),
    [sym_cstring] = ACTIONS(4781),
    [sym_dstring] = ACTIONS(4781),
    [sym_wstring] = ACTIONS(4781),
    [sym_noreturn] = ACTIONS(4781),
    [sym_true] = ACTIONS(4781),
    [sym_false] = ACTIONS(4781),
    [sym_null] = ACTIONS(4781),
    [sym_super] = ACTIONS(4781),
    [sym_this] = ACTIONS(4781),
    [sym_abstract] = ACTIONS(4781),
    [sym_alias] = ACTIONS(4781),
    [sym_align] = ACTIONS(4781),
    [sym_asm] = ACTIONS(4781),
    [sym_assert] = ACTIONS(4781),
    [sym_auto] = ACTIONS(4781),
    [sym_break] = ACTIONS(4781),
    [sym_case] = ACTIONS(4781),
    [sym_cast] = ACTIONS(4781),
    [sym_class] = ACTIONS(4781),
    [sym_const] = ACTIONS(4781),
    [sym_continue] = ACTIONS(4781),
    [sym_debug] = ACTIONS(4781),
    [sym_default] = ACTIONS(4781),
    [sym_delegate] = ACTIONS(4781),
    [sym_delete] = ACTIONS(4781),
    [sym_deprecated] = ACTIONS(4781),
    [sym_do] = ACTIONS(4781),
    [sym_else] = ACTIONS(4781),
    [sym_enum] = ACTIONS(4781),
    [sym_export] = ACTIONS(4781),
    [sym_extern] = ACTIONS(4781),
    [sym_final] = ACTIONS(4781),
    [sym_for] = ACTIONS(4781),
    [sym_foreach] = ACTIONS(4781),
    [sym_foreach_reverse] = ACTIONS(4781),
    [sym_function] = ACTIONS(4781),
    [sym_goto] = ACTIONS(4781),
    [sym_if] = ACTIONS(4781),
    [sym_immutable] = ACTIONS(4781),
    [sym_import] = ACTIONS(4781),
    [sym_in] = ACTIONS(4781),
    [sym_inout] = ACTIONS(4781),
    [sym_interface] = ACTIONS(4781),
    [sym_invariant] = ACTIONS(4781),
    [sym_is] = ACTIONS(4781),
    [sym_mixin] = ACTIONS(4781),
    [sym_new] = ACTIONS(4781),
    [sym_nothrow] = ACTIONS(4781),
    [sym_out] = ACTIONS(4781),
    [sym_override] = ACTIONS(4781),
    [sym_package] = ACTIONS(4781),
    [sym_pragma] = ACTIONS(4781),
    [sym_private] = ACTIONS(4781),
    [sym_protected] = ACTIONS(4781),
    [sym_public] = ACTIONS(4781),
    [sym_pure] = ACTIONS(4781),
    [sym_ref] = ACTIONS(4781),
    [sym_return] = ACTIONS(4781),
    [sym_scope] = ACTIONS(4781),
    [sym_shared] = ACTIONS(4781),
    [sym_static] = ACTIONS(4781),
    [sym_struct] = ACTIONS(4781),
    [sym_switch] = ACTIONS(4781),
    [sym_synchronized] = ACTIONS(4781),
    [sym_template] = ACTIONS(4781),
    [sym_throw] = ACTIONS(4781),
    [sym_try] = ACTIONS(4781),
    [sym_typeid] = ACTIONS(4781),
    [sym_typeof] = ACTIONS(4781),
    [sym_union] = ACTIONS(4781),
    [sym_unittest] = ACTIONS(4781),
    [sym_version] = ACTIONS(4781),
    [sym_while] = ACTIONS(4781),
    [sym_with] = ACTIONS(4781),
    [sym_gshared] = ACTIONS(4781),
    [sym_traits] = ACTIONS(4781),
    [sym_vector] = ACTIONS(4781),
    [sym_void] = ACTIONS(4781),
    [anon_sym_BQUOTE] = ACTIONS(4783),
    [anon_sym_r_DQUOTE] = ACTIONS(4783),
    [anon_sym_x_DQUOTE] = ACTIONS(4783),
    [anon_sym_DQUOTE] = ACTIONS(4783),
    [anon_sym_i_BQUOTE] = ACTIONS(4783),
    [anon_sym_i_DQUOTE] = ACTIONS(4783),
    [anon_sym_iq_LBRACE] = ACTIONS(4783),
    [aux_sym_char_literal_token1] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(4781),
    [anon_sym___DATE__] = ACTIONS(4781),
    [anon_sym___FILE__] = ACTIONS(4781),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4781),
    [anon_sym___FUNCTION__] = ACTIONS(4781),
    [anon_sym___LINE__] = ACTIONS(4781),
    [anon_sym___MODULE__] = ACTIONS(4781),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4781),
    [anon_sym___TIME__] = ACTIONS(4781),
    [anon_sym___TIMESTAMP__] = ACTIONS(4781),
    [anon_sym___VENDOR__] = ACTIONS(4781),
    [anon_sym___VERSION__] = ACTIONS(4781),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4783),
    [sym_float_literal] = ACTIONS(4783),
    [sym__string] = ACTIONS(4783),
  },
  [1542] = {
    [sym_identifier] = ACTIONS(4634),
    [anon_sym_q_LBRACE] = ACTIONS(4636),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_LBRACE] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4636),
    [anon_sym_AMP] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(4634),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4634),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_DOLLAR] = ACTIONS(4636),
    [anon_sym_STAR] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [anon_sym_AT] = ACTIONS(4636),
    [sym_bool] = ACTIONS(4634),
    [sym_byte] = ACTIONS(4634),
    [sym_ubyte] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_short] = ACTIONS(4634),
    [sym_ushort] = ACTIONS(4634),
    [sym_int] = ACTIONS(4634),
    [sym_uint] = ACTIONS(4634),
    [sym_long] = ACTIONS(4634),
    [sym_ulong] = ACTIONS(4634),
    [sym_cent] = ACTIONS(4634),
    [sym_ucent] = ACTIONS(4634),
    [sym_wchar] = ACTIONS(4634),
    [sym_dchar] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_double] = ACTIONS(4634),
    [sym_real] = ACTIONS(4634),
    [sym_ifloat] = ACTIONS(4634),
    [sym_idouble] = ACTIONS(4634),
    [sym_ireal] = ACTIONS(4634),
    [sym_cfloat] = ACTIONS(4634),
    [sym_cdouble] = ACTIONS(4634),
    [sym_creal] = ACTIONS(4634),
    [sym_size_t] = ACTIONS(4634),
    [sym_ptrdiff_t] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym_cstring] = ACTIONS(4634),
    [sym_dstring] = ACTIONS(4634),
    [sym_wstring] = ACTIONS(4634),
    [sym_noreturn] = ACTIONS(4634),
    [sym_true] = ACTIONS(4634),
    [sym_false] = ACTIONS(4634),
    [sym_null] = ACTIONS(4634),
    [sym_super] = ACTIONS(4634),
    [sym_this] = ACTIONS(4634),
    [sym_abstract] = ACTIONS(4634),
    [sym_alias] = ACTIONS(4634),
    [sym_align] = ACTIONS(4634),
    [sym_asm] = ACTIONS(4634),
    [sym_assert] = ACTIONS(4634),
    [sym_auto] = ACTIONS(4634),
    [sym_break] = ACTIONS(4634),
    [sym_case] = ACTIONS(4634),
    [sym_cast] = ACTIONS(4634),
    [sym_class] = ACTIONS(4634),
    [sym_const] = ACTIONS(4634),
    [sym_continue] = ACTIONS(4634),
    [sym_debug] = ACTIONS(4634),
    [sym_default] = ACTIONS(4634),
    [sym_delegate] = ACTIONS(4634),
    [sym_delete] = ACTIONS(4634),
    [sym_deprecated] = ACTIONS(4634),
    [sym_do] = ACTIONS(4634),
    [sym_else] = ACTIONS(4634),
    [sym_enum] = ACTIONS(4634),
    [sym_export] = ACTIONS(4634),
    [sym_extern] = ACTIONS(4634),
    [sym_final] = ACTIONS(4634),
    [sym_for] = ACTIONS(4634),
    [sym_foreach] = ACTIONS(4634),
    [sym_foreach_reverse] = ACTIONS(4634),
    [sym_function] = ACTIONS(4634),
    [sym_goto] = ACTIONS(4634),
    [sym_if] = ACTIONS(4634),
    [sym_immutable] = ACTIONS(4634),
    [sym_import] = ACTIONS(4634),
    [sym_in] = ACTIONS(4634),
    [sym_inout] = ACTIONS(4634),
    [sym_interface] = ACTIONS(4634),
    [sym_invariant] = ACTIONS(4634),
    [sym_is] = ACTIONS(4634),
    [sym_mixin] = ACTIONS(4634),
    [sym_new] = ACTIONS(4634),
    [sym_nothrow] = ACTIONS(4634),
    [sym_out] = ACTIONS(4634),
    [sym_override] = ACTIONS(4634),
    [sym_package] = ACTIONS(4634),
    [sym_pragma] = ACTIONS(4634),
    [sym_private] = ACTIONS(4634),
    [sym_protected] = ACTIONS(4634),
    [sym_public] = ACTIONS(4634),
    [sym_pure] = ACTIONS(4634),
    [sym_ref] = ACTIONS(4634),
    [sym_return] = ACTIONS(4634),
    [sym_scope] = ACTIONS(4634),
    [sym_shared] = ACTIONS(4634),
    [sym_static] = ACTIONS(4634),
    [sym_struct] = ACTIONS(4634),
    [sym_switch] = ACTIONS(4634),
    [sym_synchronized] = ACTIONS(4634),
    [sym_template] = ACTIONS(4634),
    [sym_throw] = ACTIONS(4634),
    [sym_try] = ACTIONS(4634),
    [sym_typeid] = ACTIONS(4634),
    [sym_typeof] = ACTIONS(4634),
    [sym_union] = ACTIONS(4634),
    [sym_unittest] = ACTIONS(4634),
    [sym_version] = ACTIONS(4634),
    [sym_while] = ACTIONS(4634),
    [sym_with] = ACTIONS(4634),
    [sym_gshared] = ACTIONS(4634),
    [sym_traits] = ACTIONS(4634),
    [sym_vector] = ACTIONS(4634),
    [sym_void] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4636),
    [anon_sym_r_DQUOTE] = ACTIONS(4636),
    [anon_sym_x_DQUOTE] = ACTIONS(4636),
    [anon_sym_DQUOTE] = ACTIONS(4636),
    [anon_sym_i_BQUOTE] = ACTIONS(4636),
    [anon_sym_i_DQUOTE] = ACTIONS(4636),
    [anon_sym_iq_LBRACE] = ACTIONS(4636),
    [aux_sym_char_literal_token1] = ACTIONS(4636),
    [anon_sym_SQUOTE] = ACTIONS(4634),
    [anon_sym___DATE__] = ACTIONS(4634),
    [anon_sym___FILE__] = ACTIONS(4634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4634),
    [anon_sym___FUNCTION__] = ACTIONS(4634),
    [anon_sym___LINE__] = ACTIONS(4634),
    [anon_sym___MODULE__] = ACTIONS(4634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4634),
    [anon_sym___TIME__] = ACTIONS(4634),
    [anon_sym___TIMESTAMP__] = ACTIONS(4634),
    [anon_sym___VENDOR__] = ACTIONS(4634),
    [anon_sym___VERSION__] = ACTIONS(4634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4636),
    [sym_float_literal] = ACTIONS(4636),
    [sym__string] = ACTIONS(4636),
  },
  [1543] = {
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_q_LBRACE] = ACTIONS(4867),
    [anon_sym_RBRACE] = ACTIONS(4867),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_AMP] = ACTIONS(4867),
    [anon_sym_DASH] = ACTIONS(4865),
    [anon_sym_DASH_DASH] = ACTIONS(4867),
    [anon_sym_PLUS] = ACTIONS(4865),
    [anon_sym_PLUS_PLUS] = ACTIONS(4867),
    [anon_sym_BANG] = ACTIONS(4867),
    [anon_sym_LPAREN] = ACTIONS(4867),
    [anon_sym_RPAREN] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4867),
    [anon_sym_SEMI] = ACTIONS(4867),
    [anon_sym_DOLLAR] = ACTIONS(4867),
    [anon_sym_STAR] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4867),
    [anon_sym_AT] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4865),
    [sym_byte] = ACTIONS(4865),
    [sym_ubyte] = ACTIONS(4865),
    [sym_char] = ACTIONS(4865),
    [sym_short] = ACTIONS(4865),
    [sym_ushort] = ACTIONS(4865),
    [sym_int] = ACTIONS(4865),
    [sym_uint] = ACTIONS(4865),
    [sym_long] = ACTIONS(4865),
    [sym_ulong] = ACTIONS(4865),
    [sym_cent] = ACTIONS(4865),
    [sym_ucent] = ACTIONS(4865),
    [sym_wchar] = ACTIONS(4865),
    [sym_dchar] = ACTIONS(4865),
    [sym_float] = ACTIONS(4865),
    [sym_double] = ACTIONS(4865),
    [sym_real] = ACTIONS(4865),
    [sym_ifloat] = ACTIONS(4865),
    [sym_idouble] = ACTIONS(4865),
    [sym_ireal] = ACTIONS(4865),
    [sym_cfloat] = ACTIONS(4865),
    [sym_cdouble] = ACTIONS(4865),
    [sym_creal] = ACTIONS(4865),
    [sym_size_t] = ACTIONS(4865),
    [sym_ptrdiff_t] = ACTIONS(4865),
    [sym_string] = ACTIONS(4865),
    [sym_cstring] = ACTIONS(4865),
    [sym_dstring] = ACTIONS(4865),
    [sym_wstring] = ACTIONS(4865),
    [sym_noreturn] = ACTIONS(4865),
    [sym_true] = ACTIONS(4865),
    [sym_false] = ACTIONS(4865),
    [sym_null] = ACTIONS(4865),
    [sym_super] = ACTIONS(4865),
    [sym_this] = ACTIONS(4865),
    [sym_abstract] = ACTIONS(4865),
    [sym_alias] = ACTIONS(4865),
    [sym_align] = ACTIONS(4865),
    [sym_asm] = ACTIONS(4865),
    [sym_assert] = ACTIONS(4865),
    [sym_auto] = ACTIONS(4865),
    [sym_break] = ACTIONS(4865),
    [sym_case] = ACTIONS(4865),
    [sym_cast] = ACTIONS(4865),
    [sym_class] = ACTIONS(4865),
    [sym_const] = ACTIONS(4865),
    [sym_continue] = ACTIONS(4865),
    [sym_debug] = ACTIONS(4865),
    [sym_default] = ACTIONS(4865),
    [sym_delegate] = ACTIONS(4865),
    [sym_delete] = ACTIONS(4865),
    [sym_deprecated] = ACTIONS(4865),
    [sym_do] = ACTIONS(4865),
    [sym_else] = ACTIONS(4865),
    [sym_enum] = ACTIONS(4865),
    [sym_export] = ACTIONS(4865),
    [sym_extern] = ACTIONS(4865),
    [sym_final] = ACTIONS(4865),
    [sym_for] = ACTIONS(4865),
    [sym_foreach] = ACTIONS(4865),
    [sym_foreach_reverse] = ACTIONS(4865),
    [sym_function] = ACTIONS(4865),
    [sym_goto] = ACTIONS(4865),
    [sym_if] = ACTIONS(4865),
    [sym_immutable] = ACTIONS(4865),
    [sym_import] = ACTIONS(4865),
    [sym_in] = ACTIONS(4865),
    [sym_inout] = ACTIONS(4865),
    [sym_interface] = ACTIONS(4865),
    [sym_invariant] = ACTIONS(4865),
    [sym_is] = ACTIONS(4865),
    [sym_mixin] = ACTIONS(4865),
    [sym_new] = ACTIONS(4865),
    [sym_nothrow] = ACTIONS(4865),
    [sym_out] = ACTIONS(4865),
    [sym_override] = ACTIONS(4865),
    [sym_package] = ACTIONS(4865),
    [sym_pragma] = ACTIONS(4865),
    [sym_private] = ACTIONS(4865),
    [sym_protected] = ACTIONS(4865),
    [sym_public] = ACTIONS(4865),
    [sym_pure] = ACTIONS(4865),
    [sym_ref] = ACTIONS(4865),
    [sym_return] = ACTIONS(4865),
    [sym_scope] = ACTIONS(4865),
    [sym_shared] = ACTIONS(4865),
    [sym_static] = ACTIONS(4865),
    [sym_struct] = ACTIONS(4865),
    [sym_switch] = ACTIONS(4865),
    [sym_synchronized] = ACTIONS(4865),
    [sym_template] = ACTIONS(4865),
    [sym_throw] = ACTIONS(4865),
    [sym_try] = ACTIONS(4865),
    [sym_typeid] = ACTIONS(4865),
    [sym_typeof] = ACTIONS(4865),
    [sym_union] = ACTIONS(4865),
    [sym_unittest] = ACTIONS(4865),
    [sym_version] = ACTIONS(4865),
    [sym_while] = ACTIONS(4865),
    [sym_with] = ACTIONS(4865),
    [sym_gshared] = ACTIONS(4865),
    [sym_traits] = ACTIONS(4865),
    [sym_vector] = ACTIONS(4865),
    [sym_void] = ACTIONS(4865),
    [anon_sym_BQUOTE] = ACTIONS(4867),
    [anon_sym_r_DQUOTE] = ACTIONS(4867),
    [anon_sym_x_DQUOTE] = ACTIONS(4867),
    [anon_sym_DQUOTE] = ACTIONS(4867),
    [anon_sym_i_BQUOTE] = ACTIONS(4867),
    [anon_sym_i_DQUOTE] = ACTIONS(4867),
    [anon_sym_iq_LBRACE] = ACTIONS(4867),
    [aux_sym_char_literal_token1] = ACTIONS(4867),
    [anon_sym_SQUOTE] = ACTIONS(4865),
    [anon_sym___DATE__] = ACTIONS(4865),
    [anon_sym___FILE__] = ACTIONS(4865),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4865),
    [anon_sym___FUNCTION__] = ACTIONS(4865),
    [anon_sym___LINE__] = ACTIONS(4865),
    [anon_sym___MODULE__] = ACTIONS(4865),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4865),
    [anon_sym___TIME__] = ACTIONS(4865),
    [anon_sym___TIMESTAMP__] = ACTIONS(4865),
    [anon_sym___VENDOR__] = ACTIONS(4865),
    [anon_sym___VERSION__] = ACTIONS(4865),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4867),
    [sym_float_literal] = ACTIONS(4867),
    [sym__string] = ACTIONS(4867),
  },
  [1544] = {
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_q_LBRACE] = ACTIONS(4871),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4871),
    [anon_sym_DASH] = ACTIONS(4869),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4869),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_BANG] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_DOLLAR] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4871),
    [anon_sym_AT] = ACTIONS(4871),
    [sym_bool] = ACTIONS(4869),
    [sym_byte] = ACTIONS(4869),
    [sym_ubyte] = ACTIONS(4869),
    [sym_char] = ACTIONS(4869),
    [sym_short] = ACTIONS(4869),
    [sym_ushort] = ACTIONS(4869),
    [sym_int] = ACTIONS(4869),
    [sym_uint] = ACTIONS(4869),
    [sym_long] = ACTIONS(4869),
    [sym_ulong] = ACTIONS(4869),
    [sym_cent] = ACTIONS(4869),
    [sym_ucent] = ACTIONS(4869),
    [sym_wchar] = ACTIONS(4869),
    [sym_dchar] = ACTIONS(4869),
    [sym_float] = ACTIONS(4869),
    [sym_double] = ACTIONS(4869),
    [sym_real] = ACTIONS(4869),
    [sym_ifloat] = ACTIONS(4869),
    [sym_idouble] = ACTIONS(4869),
    [sym_ireal] = ACTIONS(4869),
    [sym_cfloat] = ACTIONS(4869),
    [sym_cdouble] = ACTIONS(4869),
    [sym_creal] = ACTIONS(4869),
    [sym_size_t] = ACTIONS(4869),
    [sym_ptrdiff_t] = ACTIONS(4869),
    [sym_string] = ACTIONS(4869),
    [sym_cstring] = ACTIONS(4869),
    [sym_dstring] = ACTIONS(4869),
    [sym_wstring] = ACTIONS(4869),
    [sym_noreturn] = ACTIONS(4869),
    [sym_true] = ACTIONS(4869),
    [sym_false] = ACTIONS(4869),
    [sym_null] = ACTIONS(4869),
    [sym_super] = ACTIONS(4869),
    [sym_this] = ACTIONS(4869),
    [sym_abstract] = ACTIONS(4869),
    [sym_alias] = ACTIONS(4869),
    [sym_align] = ACTIONS(4869),
    [sym_asm] = ACTIONS(4869),
    [sym_assert] = ACTIONS(4869),
    [sym_auto] = ACTIONS(4869),
    [sym_break] = ACTIONS(4869),
    [sym_case] = ACTIONS(4869),
    [sym_cast] = ACTIONS(4869),
    [sym_class] = ACTIONS(4869),
    [sym_const] = ACTIONS(4869),
    [sym_continue] = ACTIONS(4869),
    [sym_debug] = ACTIONS(4869),
    [sym_default] = ACTIONS(4869),
    [sym_delegate] = ACTIONS(4869),
    [sym_delete] = ACTIONS(4869),
    [sym_deprecated] = ACTIONS(4869),
    [sym_do] = ACTIONS(4869),
    [sym_else] = ACTIONS(4869),
    [sym_enum] = ACTIONS(4869),
    [sym_export] = ACTIONS(4869),
    [sym_extern] = ACTIONS(4869),
    [sym_final] = ACTIONS(4869),
    [sym_for] = ACTIONS(4869),
    [sym_foreach] = ACTIONS(4869),
    [sym_foreach_reverse] = ACTIONS(4869),
    [sym_function] = ACTIONS(4869),
    [sym_goto] = ACTIONS(4869),
    [sym_if] = ACTIONS(4869),
    [sym_immutable] = ACTIONS(4869),
    [sym_import] = ACTIONS(4869),
    [sym_in] = ACTIONS(4869),
    [sym_inout] = ACTIONS(4869),
    [sym_interface] = ACTIONS(4869),
    [sym_invariant] = ACTIONS(4869),
    [sym_is] = ACTIONS(4869),
    [sym_mixin] = ACTIONS(4869),
    [sym_new] = ACTIONS(4869),
    [sym_nothrow] = ACTIONS(4869),
    [sym_out] = ACTIONS(4869),
    [sym_override] = ACTIONS(4869),
    [sym_package] = ACTIONS(4869),
    [sym_pragma] = ACTIONS(4869),
    [sym_private] = ACTIONS(4869),
    [sym_protected] = ACTIONS(4869),
    [sym_public] = ACTIONS(4869),
    [sym_pure] = ACTIONS(4869),
    [sym_ref] = ACTIONS(4869),
    [sym_return] = ACTIONS(4869),
    [sym_scope] = ACTIONS(4869),
    [sym_shared] = ACTIONS(4869),
    [sym_static] = ACTIONS(4869),
    [sym_struct] = ACTIONS(4869),
    [sym_switch] = ACTIONS(4869),
    [sym_synchronized] = ACTIONS(4869),
    [sym_template] = ACTIONS(4869),
    [sym_throw] = ACTIONS(4869),
    [sym_try] = ACTIONS(4869),
    [sym_typeid] = ACTIONS(4869),
    [sym_typeof] = ACTIONS(4869),
    [sym_union] = ACTIONS(4869),
    [sym_unittest] = ACTIONS(4869),
    [sym_version] = ACTIONS(4869),
    [sym_while] = ACTIONS(4869),
    [sym_with] = ACTIONS(4869),
    [sym_gshared] = ACTIONS(4869),
    [sym_traits] = ACTIONS(4869),
    [sym_vector] = ACTIONS(4869),
    [sym_void] = ACTIONS(4869),
    [anon_sym_BQUOTE] = ACTIONS(4871),
    [anon_sym_r_DQUOTE] = ACTIONS(4871),
    [anon_sym_x_DQUOTE] = ACTIONS(4871),
    [anon_sym_DQUOTE] = ACTIONS(4871),
    [anon_sym_i_BQUOTE] = ACTIONS(4871),
    [anon_sym_i_DQUOTE] = ACTIONS(4871),
    [anon_sym_iq_LBRACE] = ACTIONS(4871),
    [aux_sym_char_literal_token1] = ACTIONS(4871),
    [anon_sym_SQUOTE] = ACTIONS(4869),
    [anon_sym___DATE__] = ACTIONS(4869),
    [anon_sym___FILE__] = ACTIONS(4869),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4869),
    [anon_sym___FUNCTION__] = ACTIONS(4869),
    [anon_sym___LINE__] = ACTIONS(4869),
    [anon_sym___MODULE__] = ACTIONS(4869),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4869),
    [anon_sym___TIME__] = ACTIONS(4869),
    [anon_sym___TIMESTAMP__] = ACTIONS(4869),
    [anon_sym___VENDOR__] = ACTIONS(4869),
    [anon_sym___VERSION__] = ACTIONS(4869),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4871),
    [sym_float_literal] = ACTIONS(4871),
    [sym__string] = ACTIONS(4871),
  },
  [1545] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [anon_sym_AT] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_abstract] = ACTIONS(4688),
    [sym_alias] = ACTIONS(4688),
    [sym_align] = ACTIONS(4688),
    [sym_asm] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_break] = ACTIONS(4688),
    [sym_case] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_class] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_continue] = ACTIONS(4688),
    [sym_debug] = ACTIONS(4688),
    [sym_default] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_deprecated] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(5015),
    [sym_enum] = ACTIONS(4688),
    [sym_export] = ACTIONS(4688),
    [sym_extern] = ACTIONS(4688),
    [sym_final] = ACTIONS(4688),
    [sym_for] = ACTIONS(4688),
    [sym_foreach] = ACTIONS(4688),
    [sym_foreach_reverse] = ACTIONS(4688),
    [sym_function] = ACTIONS(4688),
    [sym_goto] = ACTIONS(4688),
    [sym_if] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_interface] = ACTIONS(4688),
    [sym_invariant] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_nothrow] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_override] = ACTIONS(4688),
    [sym_package] = ACTIONS(4688),
    [sym_pragma] = ACTIONS(4688),
    [sym_private] = ACTIONS(4688),
    [sym_protected] = ACTIONS(4688),
    [sym_public] = ACTIONS(4688),
    [sym_pure] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_return] = ACTIONS(4688),
    [sym_scope] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_static] = ACTIONS(4688),
    [sym_struct] = ACTIONS(4688),
    [sym_switch] = ACTIONS(4688),
    [sym_synchronized] = ACTIONS(4688),
    [sym_template] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_try] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_union] = ACTIONS(4688),
    [sym_unittest] = ACTIONS(4688),
    [sym_version] = ACTIONS(4688),
    [sym_while] = ACTIONS(4688),
    [sym_with] = ACTIONS(4688),
    [sym_gshared] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [1546] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_RBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_AT] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_abstract] = ACTIONS(4682),
    [sym_alias] = ACTIONS(4682),
    [sym_align] = ACTIONS(4682),
    [sym_asm] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_break] = ACTIONS(4682),
    [sym_case] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_class] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_continue] = ACTIONS(4682),
    [sym_debug] = ACTIONS(4682),
    [sym_default] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_deprecated] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(5018),
    [sym_enum] = ACTIONS(4682),
    [sym_export] = ACTIONS(4682),
    [sym_extern] = ACTIONS(4682),
    [sym_final] = ACTIONS(4682),
    [sym_for] = ACTIONS(4682),
    [sym_foreach] = ACTIONS(4682),
    [sym_foreach_reverse] = ACTIONS(4682),
    [sym_function] = ACTIONS(4682),
    [sym_goto] = ACTIONS(4682),
    [sym_if] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_interface] = ACTIONS(4682),
    [sym_invariant] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_nothrow] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_override] = ACTIONS(4682),
    [sym_package] = ACTIONS(4682),
    [sym_pragma] = ACTIONS(4682),
    [sym_private] = ACTIONS(4682),
    [sym_protected] = ACTIONS(4682),
    [sym_public] = ACTIONS(4682),
    [sym_pure] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_return] = ACTIONS(4682),
    [sym_scope] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_static] = ACTIONS(4682),
    [sym_struct] = ACTIONS(4682),
    [sym_switch] = ACTIONS(4682),
    [sym_synchronized] = ACTIONS(4682),
    [sym_template] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_try] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_union] = ACTIONS(4682),
    [sym_unittest] = ACTIONS(4682),
    [sym_version] = ACTIONS(4682),
    [sym_while] = ACTIONS(4682),
    [sym_with] = ACTIONS(4682),
    [sym_gshared] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [1547] = {
    [sym_identifier] = ACTIONS(4598),
    [anon_sym_q_LBRACE] = ACTIONS(4600),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4600),
    [anon_sym_AMP] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4598),
    [anon_sym_DASH_DASH] = ACTIONS(4600),
    [anon_sym_PLUS] = ACTIONS(4598),
    [anon_sym_PLUS_PLUS] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4600),
    [anon_sym_LPAREN] = ACTIONS(4600),
    [anon_sym_RPAREN] = ACTIONS(4600),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_DOLLAR] = ACTIONS(4600),
    [anon_sym_STAR] = ACTIONS(4600),
    [anon_sym_TILDE] = ACTIONS(4600),
    [anon_sym_AT] = ACTIONS(4600),
    [sym_bool] = ACTIONS(4598),
    [sym_byte] = ACTIONS(4598),
    [sym_ubyte] = ACTIONS(4598),
    [sym_char] = ACTIONS(4598),
    [sym_short] = ACTIONS(4598),
    [sym_ushort] = ACTIONS(4598),
    [sym_int] = ACTIONS(4598),
    [sym_uint] = ACTIONS(4598),
    [sym_long] = ACTIONS(4598),
    [sym_ulong] = ACTIONS(4598),
    [sym_cent] = ACTIONS(4598),
    [sym_ucent] = ACTIONS(4598),
    [sym_wchar] = ACTIONS(4598),
    [sym_dchar] = ACTIONS(4598),
    [sym_float] = ACTIONS(4598),
    [sym_double] = ACTIONS(4598),
    [sym_real] = ACTIONS(4598),
    [sym_ifloat] = ACTIONS(4598),
    [sym_idouble] = ACTIONS(4598),
    [sym_ireal] = ACTIONS(4598),
    [sym_cfloat] = ACTIONS(4598),
    [sym_cdouble] = ACTIONS(4598),
    [sym_creal] = ACTIONS(4598),
    [sym_size_t] = ACTIONS(4598),
    [sym_ptrdiff_t] = ACTIONS(4598),
    [sym_string] = ACTIONS(4598),
    [sym_cstring] = ACTIONS(4598),
    [sym_dstring] = ACTIONS(4598),
    [sym_wstring] = ACTIONS(4598),
    [sym_noreturn] = ACTIONS(4598),
    [sym_true] = ACTIONS(4598),
    [sym_false] = ACTIONS(4598),
    [sym_null] = ACTIONS(4598),
    [sym_super] = ACTIONS(4598),
    [sym_this] = ACTIONS(4598),
    [sym_abstract] = ACTIONS(4598),
    [sym_alias] = ACTIONS(4598),
    [sym_align] = ACTIONS(4598),
    [sym_asm] = ACTIONS(4598),
    [sym_assert] = ACTIONS(4598),
    [sym_auto] = ACTIONS(4598),
    [sym_break] = ACTIONS(4598),
    [sym_case] = ACTIONS(4598),
    [sym_cast] = ACTIONS(4598),
    [sym_class] = ACTIONS(4598),
    [sym_const] = ACTIONS(4598),
    [sym_continue] = ACTIONS(4598),
    [sym_debug] = ACTIONS(4598),
    [sym_default] = ACTIONS(4598),
    [sym_delegate] = ACTIONS(4598),
    [sym_delete] = ACTIONS(4598),
    [sym_deprecated] = ACTIONS(4598),
    [sym_do] = ACTIONS(4598),
    [sym_else] = ACTIONS(4598),
    [sym_enum] = ACTIONS(4598),
    [sym_export] = ACTIONS(4598),
    [sym_extern] = ACTIONS(4598),
    [sym_final] = ACTIONS(4598),
    [sym_for] = ACTIONS(4598),
    [sym_foreach] = ACTIONS(4598),
    [sym_foreach_reverse] = ACTIONS(4598),
    [sym_function] = ACTIONS(4598),
    [sym_goto] = ACTIONS(4598),
    [sym_if] = ACTIONS(4598),
    [sym_immutable] = ACTIONS(4598),
    [sym_import] = ACTIONS(4598),
    [sym_in] = ACTIONS(4598),
    [sym_inout] = ACTIONS(4598),
    [sym_interface] = ACTIONS(4598),
    [sym_invariant] = ACTIONS(4598),
    [sym_is] = ACTIONS(4598),
    [sym_mixin] = ACTIONS(4598),
    [sym_new] = ACTIONS(4598),
    [sym_nothrow] = ACTIONS(4598),
    [sym_out] = ACTIONS(4598),
    [sym_override] = ACTIONS(4598),
    [sym_package] = ACTIONS(4598),
    [sym_pragma] = ACTIONS(4598),
    [sym_private] = ACTIONS(4598),
    [sym_protected] = ACTIONS(4598),
    [sym_public] = ACTIONS(4598),
    [sym_pure] = ACTIONS(4598),
    [sym_ref] = ACTIONS(4598),
    [sym_return] = ACTIONS(4598),
    [sym_scope] = ACTIONS(4598),
    [sym_shared] = ACTIONS(4598),
    [sym_static] = ACTIONS(4598),
    [sym_struct] = ACTIONS(4598),
    [sym_switch] = ACTIONS(4598),
    [sym_synchronized] = ACTIONS(4598),
    [sym_template] = ACTIONS(4598),
    [sym_throw] = ACTIONS(4598),
    [sym_try] = ACTIONS(4598),
    [sym_typeid] = ACTIONS(4598),
    [sym_typeof] = ACTIONS(4598),
    [sym_union] = ACTIONS(4598),
    [sym_unittest] = ACTIONS(4598),
    [sym_version] = ACTIONS(4598),
    [sym_while] = ACTIONS(4598),
    [sym_with] = ACTIONS(4598),
    [sym_gshared] = ACTIONS(4598),
    [sym_traits] = ACTIONS(4598),
    [sym_vector] = ACTIONS(4598),
    [sym_void] = ACTIONS(4598),
    [anon_sym_BQUOTE] = ACTIONS(4600),
    [anon_sym_r_DQUOTE] = ACTIONS(4600),
    [anon_sym_x_DQUOTE] = ACTIONS(4600),
    [anon_sym_DQUOTE] = ACTIONS(4600),
    [anon_sym_i_BQUOTE] = ACTIONS(4600),
    [anon_sym_i_DQUOTE] = ACTIONS(4600),
    [anon_sym_iq_LBRACE] = ACTIONS(4600),
    [aux_sym_char_literal_token1] = ACTIONS(4600),
    [anon_sym_SQUOTE] = ACTIONS(4598),
    [anon_sym___DATE__] = ACTIONS(4598),
    [anon_sym___FILE__] = ACTIONS(4598),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4598),
    [anon_sym___FUNCTION__] = ACTIONS(4598),
    [anon_sym___LINE__] = ACTIONS(4598),
    [anon_sym___MODULE__] = ACTIONS(4598),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4598),
    [anon_sym___TIME__] = ACTIONS(4598),
    [anon_sym___TIMESTAMP__] = ACTIONS(4598),
    [anon_sym___VENDOR__] = ACTIONS(4598),
    [anon_sym___VERSION__] = ACTIONS(4598),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4600),
    [sym_float_literal] = ACTIONS(4600),
    [sym__string] = ACTIONS(4600),
  },
  [1548] = {
    [sym_identifier] = ACTIONS(4594),
    [anon_sym_q_LBRACE] = ACTIONS(4596),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_LBRACE] = ACTIONS(4596),
    [anon_sym_DOT] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_DASH_DASH] = ACTIONS(4596),
    [anon_sym_PLUS] = ACTIONS(4594),
    [anon_sym_PLUS_PLUS] = ACTIONS(4596),
    [anon_sym_BANG] = ACTIONS(4596),
    [anon_sym_LPAREN] = ACTIONS(4596),
    [anon_sym_RPAREN] = ACTIONS(4596),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_DOLLAR] = ACTIONS(4596),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_TILDE] = ACTIONS(4596),
    [anon_sym_AT] = ACTIONS(4596),
    [sym_bool] = ACTIONS(4594),
    [sym_byte] = ACTIONS(4594),
    [sym_ubyte] = ACTIONS(4594),
    [sym_char] = ACTIONS(4594),
    [sym_short] = ACTIONS(4594),
    [sym_ushort] = ACTIONS(4594),
    [sym_int] = ACTIONS(4594),
    [sym_uint] = ACTIONS(4594),
    [sym_long] = ACTIONS(4594),
    [sym_ulong] = ACTIONS(4594),
    [sym_cent] = ACTIONS(4594),
    [sym_ucent] = ACTIONS(4594),
    [sym_wchar] = ACTIONS(4594),
    [sym_dchar] = ACTIONS(4594),
    [sym_float] = ACTIONS(4594),
    [sym_double] = ACTIONS(4594),
    [sym_real] = ACTIONS(4594),
    [sym_ifloat] = ACTIONS(4594),
    [sym_idouble] = ACTIONS(4594),
    [sym_ireal] = ACTIONS(4594),
    [sym_cfloat] = ACTIONS(4594),
    [sym_cdouble] = ACTIONS(4594),
    [sym_creal] = ACTIONS(4594),
    [sym_size_t] = ACTIONS(4594),
    [sym_ptrdiff_t] = ACTIONS(4594),
    [sym_string] = ACTIONS(4594),
    [sym_cstring] = ACTIONS(4594),
    [sym_dstring] = ACTIONS(4594),
    [sym_wstring] = ACTIONS(4594),
    [sym_noreturn] = ACTIONS(4594),
    [sym_true] = ACTIONS(4594),
    [sym_false] = ACTIONS(4594),
    [sym_null] = ACTIONS(4594),
    [sym_super] = ACTIONS(4594),
    [sym_this] = ACTIONS(4594),
    [sym_abstract] = ACTIONS(4594),
    [sym_alias] = ACTIONS(4594),
    [sym_align] = ACTIONS(4594),
    [sym_asm] = ACTIONS(4594),
    [sym_assert] = ACTIONS(4594),
    [sym_auto] = ACTIONS(4594),
    [sym_break] = ACTIONS(4594),
    [sym_case] = ACTIONS(4594),
    [sym_cast] = ACTIONS(4594),
    [sym_class] = ACTIONS(4594),
    [sym_const] = ACTIONS(4594),
    [sym_continue] = ACTIONS(4594),
    [sym_debug] = ACTIONS(4594),
    [sym_default] = ACTIONS(4594),
    [sym_delegate] = ACTIONS(4594),
    [sym_delete] = ACTIONS(4594),
    [sym_deprecated] = ACTIONS(4594),
    [sym_do] = ACTIONS(4594),
    [sym_else] = ACTIONS(4594),
    [sym_enum] = ACTIONS(4594),
    [sym_export] = ACTIONS(4594),
    [sym_extern] = ACTIONS(4594),
    [sym_final] = ACTIONS(4594),
    [sym_for] = ACTIONS(4594),
    [sym_foreach] = ACTIONS(4594),
    [sym_foreach_reverse] = ACTIONS(4594),
    [sym_function] = ACTIONS(4594),
    [sym_goto] = ACTIONS(4594),
    [sym_if] = ACTIONS(4594),
    [sym_immutable] = ACTIONS(4594),
    [sym_import] = ACTIONS(4594),
    [sym_in] = ACTIONS(4594),
    [sym_inout] = ACTIONS(4594),
    [sym_interface] = ACTIONS(4594),
    [sym_invariant] = ACTIONS(4594),
    [sym_is] = ACTIONS(4594),
    [sym_mixin] = ACTIONS(4594),
    [sym_new] = ACTIONS(4594),
    [sym_nothrow] = ACTIONS(4594),
    [sym_out] = ACTIONS(4594),
    [sym_override] = ACTIONS(4594),
    [sym_package] = ACTIONS(4594),
    [sym_pragma] = ACTIONS(4594),
    [sym_private] = ACTIONS(4594),
    [sym_protected] = ACTIONS(4594),
    [sym_public] = ACTIONS(4594),
    [sym_pure] = ACTIONS(4594),
    [sym_ref] = ACTIONS(4594),
    [sym_return] = ACTIONS(4594),
    [sym_scope] = ACTIONS(4594),
    [sym_shared] = ACTIONS(4594),
    [sym_static] = ACTIONS(4594),
    [sym_struct] = ACTIONS(4594),
    [sym_switch] = ACTIONS(4594),
    [sym_synchronized] = ACTIONS(4594),
    [sym_template] = ACTIONS(4594),
    [sym_throw] = ACTIONS(4594),
    [sym_try] = ACTIONS(4594),
    [sym_typeid] = ACTIONS(4594),
    [sym_typeof] = ACTIONS(4594),
    [sym_union] = ACTIONS(4594),
    [sym_unittest] = ACTIONS(4594),
    [sym_version] = ACTIONS(4594),
    [sym_while] = ACTIONS(4594),
    [sym_with] = ACTIONS(4594),
    [sym_gshared] = ACTIONS(4594),
    [sym_traits] = ACTIONS(4594),
    [sym_vector] = ACTIONS(4594),
    [sym_void] = ACTIONS(4594),
    [anon_sym_BQUOTE] = ACTIONS(4596),
    [anon_sym_r_DQUOTE] = ACTIONS(4596),
    [anon_sym_x_DQUOTE] = ACTIONS(4596),
    [anon_sym_DQUOTE] = ACTIONS(4596),
    [anon_sym_i_BQUOTE] = ACTIONS(4596),
    [anon_sym_i_DQUOTE] = ACTIONS(4596),
    [anon_sym_iq_LBRACE] = ACTIONS(4596),
    [aux_sym_char_literal_token1] = ACTIONS(4596),
    [anon_sym_SQUOTE] = ACTIONS(4594),
    [anon_sym___DATE__] = ACTIONS(4594),
    [anon_sym___FILE__] = ACTIONS(4594),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4594),
    [anon_sym___FUNCTION__] = ACTIONS(4594),
    [anon_sym___LINE__] = ACTIONS(4594),
    [anon_sym___MODULE__] = ACTIONS(4594),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4594),
    [anon_sym___TIME__] = ACTIONS(4594),
    [anon_sym___TIMESTAMP__] = ACTIONS(4594),
    [anon_sym___VENDOR__] = ACTIONS(4594),
    [anon_sym___VERSION__] = ACTIONS(4594),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4596),
    [sym_float_literal] = ACTIONS(4596),
    [sym__string] = ACTIONS(4596),
  },
  [1549] = {
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_q_LBRACE] = ACTIONS(4592),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_DOT] = ACTIONS(4592),
    [anon_sym_AMP] = ACTIONS(4592),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_DASH] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4592),
    [anon_sym_BANG] = ACTIONS(4592),
    [anon_sym_LPAREN] = ACTIONS(4592),
    [anon_sym_RPAREN] = ACTIONS(4592),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_DOLLAR] = ACTIONS(4592),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_TILDE] = ACTIONS(4592),
    [anon_sym_AT] = ACTIONS(4592),
    [sym_bool] = ACTIONS(4590),
    [sym_byte] = ACTIONS(4590),
    [sym_ubyte] = ACTIONS(4590),
    [sym_char] = ACTIONS(4590),
    [sym_short] = ACTIONS(4590),
    [sym_ushort] = ACTIONS(4590),
    [sym_int] = ACTIONS(4590),
    [sym_uint] = ACTIONS(4590),
    [sym_long] = ACTIONS(4590),
    [sym_ulong] = ACTIONS(4590),
    [sym_cent] = ACTIONS(4590),
    [sym_ucent] = ACTIONS(4590),
    [sym_wchar] = ACTIONS(4590),
    [sym_dchar] = ACTIONS(4590),
    [sym_float] = ACTIONS(4590),
    [sym_double] = ACTIONS(4590),
    [sym_real] = ACTIONS(4590),
    [sym_ifloat] = ACTIONS(4590),
    [sym_idouble] = ACTIONS(4590),
    [sym_ireal] = ACTIONS(4590),
    [sym_cfloat] = ACTIONS(4590),
    [sym_cdouble] = ACTIONS(4590),
    [sym_creal] = ACTIONS(4590),
    [sym_size_t] = ACTIONS(4590),
    [sym_ptrdiff_t] = ACTIONS(4590),
    [sym_string] = ACTIONS(4590),
    [sym_cstring] = ACTIONS(4590),
    [sym_dstring] = ACTIONS(4590),
    [sym_wstring] = ACTIONS(4590),
    [sym_noreturn] = ACTIONS(4590),
    [sym_true] = ACTIONS(4590),
    [sym_false] = ACTIONS(4590),
    [sym_null] = ACTIONS(4590),
    [sym_super] = ACTIONS(4590),
    [sym_this] = ACTIONS(4590),
    [sym_abstract] = ACTIONS(4590),
    [sym_alias] = ACTIONS(4590),
    [sym_align] = ACTIONS(4590),
    [sym_asm] = ACTIONS(4590),
    [sym_assert] = ACTIONS(4590),
    [sym_auto] = ACTIONS(4590),
    [sym_break] = ACTIONS(4590),
    [sym_case] = ACTIONS(4590),
    [sym_cast] = ACTIONS(4590),
    [sym_class] = ACTIONS(4590),
    [sym_const] = ACTIONS(4590),
    [sym_continue] = ACTIONS(4590),
    [sym_debug] = ACTIONS(4590),
    [sym_default] = ACTIONS(4590),
    [sym_delegate] = ACTIONS(4590),
    [sym_delete] = ACTIONS(4590),
    [sym_deprecated] = ACTIONS(4590),
    [sym_do] = ACTIONS(4590),
    [sym_else] = ACTIONS(4590),
    [sym_enum] = ACTIONS(4590),
    [sym_export] = ACTIONS(4590),
    [sym_extern] = ACTIONS(4590),
    [sym_final] = ACTIONS(4590),
    [sym_for] = ACTIONS(4590),
    [sym_foreach] = ACTIONS(4590),
    [sym_foreach_reverse] = ACTIONS(4590),
    [sym_function] = ACTIONS(4590),
    [sym_goto] = ACTIONS(4590),
    [sym_if] = ACTIONS(4590),
    [sym_immutable] = ACTIONS(4590),
    [sym_import] = ACTIONS(4590),
    [sym_in] = ACTIONS(4590),
    [sym_inout] = ACTIONS(4590),
    [sym_interface] = ACTIONS(4590),
    [sym_invariant] = ACTIONS(4590),
    [sym_is] = ACTIONS(4590),
    [sym_mixin] = ACTIONS(4590),
    [sym_new] = ACTIONS(4590),
    [sym_nothrow] = ACTIONS(4590),
    [sym_out] = ACTIONS(4590),
    [sym_override] = ACTIONS(4590),
    [sym_package] = ACTIONS(4590),
    [sym_pragma] = ACTIONS(4590),
    [sym_private] = ACTIONS(4590),
    [sym_protected] = ACTIONS(4590),
    [sym_public] = ACTIONS(4590),
    [sym_pure] = ACTIONS(4590),
    [sym_ref] = ACTIONS(4590),
    [sym_return] = ACTIONS(4590),
    [sym_scope] = ACTIONS(4590),
    [sym_shared] = ACTIONS(4590),
    [sym_static] = ACTIONS(4590),
    [sym_struct] = ACTIONS(4590),
    [sym_switch] = ACTIONS(4590),
    [sym_synchronized] = ACTIONS(4590),
    [sym_template] = ACTIONS(4590),
    [sym_throw] = ACTIONS(4590),
    [sym_try] = ACTIONS(4590),
    [sym_typeid] = ACTIONS(4590),
    [sym_typeof] = ACTIONS(4590),
    [sym_union] = ACTIONS(4590),
    [sym_unittest] = ACTIONS(4590),
    [sym_version] = ACTIONS(4590),
    [sym_while] = ACTIONS(4590),
    [sym_with] = ACTIONS(4590),
    [sym_gshared] = ACTIONS(4590),
    [sym_traits] = ACTIONS(4590),
    [sym_vector] = ACTIONS(4590),
    [sym_void] = ACTIONS(4590),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_r_DQUOTE] = ACTIONS(4592),
    [anon_sym_x_DQUOTE] = ACTIONS(4592),
    [anon_sym_DQUOTE] = ACTIONS(4592),
    [anon_sym_i_BQUOTE] = ACTIONS(4592),
    [anon_sym_i_DQUOTE] = ACTIONS(4592),
    [anon_sym_iq_LBRACE] = ACTIONS(4592),
    [aux_sym_char_literal_token1] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym___DATE__] = ACTIONS(4590),
    [anon_sym___FILE__] = ACTIONS(4590),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4590),
    [anon_sym___FUNCTION__] = ACTIONS(4590),
    [anon_sym___LINE__] = ACTIONS(4590),
    [anon_sym___MODULE__] = ACTIONS(4590),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4590),
    [anon_sym___TIME__] = ACTIONS(4590),
    [anon_sym___TIMESTAMP__] = ACTIONS(4590),
    [anon_sym___VENDOR__] = ACTIONS(4590),
    [anon_sym___VERSION__] = ACTIONS(4590),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4592),
    [sym_float_literal] = ACTIONS(4592),
    [sym__string] = ACTIONS(4592),
  },
  [1550] = {
    [sym_identifier] = ACTIONS(4578),
    [anon_sym_q_LBRACE] = ACTIONS(4580),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_LBRACE] = ACTIONS(4580),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4580),
    [anon_sym_PLUS] = ACTIONS(4578),
    [anon_sym_PLUS_PLUS] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_LPAREN] = ACTIONS(4580),
    [anon_sym_RPAREN] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_DOLLAR] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_TILDE] = ACTIONS(4580),
    [anon_sym_AT] = ACTIONS(4580),
    [sym_bool] = ACTIONS(4578),
    [sym_byte] = ACTIONS(4578),
    [sym_ubyte] = ACTIONS(4578),
    [sym_char] = ACTIONS(4578),
    [sym_short] = ACTIONS(4578),
    [sym_ushort] = ACTIONS(4578),
    [sym_int] = ACTIONS(4578),
    [sym_uint] = ACTIONS(4578),
    [sym_long] = ACTIONS(4578),
    [sym_ulong] = ACTIONS(4578),
    [sym_cent] = ACTIONS(4578),
    [sym_ucent] = ACTIONS(4578),
    [sym_wchar] = ACTIONS(4578),
    [sym_dchar] = ACTIONS(4578),
    [sym_float] = ACTIONS(4578),
    [sym_double] = ACTIONS(4578),
    [sym_real] = ACTIONS(4578),
    [sym_ifloat] = ACTIONS(4578),
    [sym_idouble] = ACTIONS(4578),
    [sym_ireal] = ACTIONS(4578),
    [sym_cfloat] = ACTIONS(4578),
    [sym_cdouble] = ACTIONS(4578),
    [sym_creal] = ACTIONS(4578),
    [sym_size_t] = ACTIONS(4578),
    [sym_ptrdiff_t] = ACTIONS(4578),
    [sym_string] = ACTIONS(4578),
    [sym_cstring] = ACTIONS(4578),
    [sym_dstring] = ACTIONS(4578),
    [sym_wstring] = ACTIONS(4578),
    [sym_noreturn] = ACTIONS(4578),
    [sym_true] = ACTIONS(4578),
    [sym_false] = ACTIONS(4578),
    [sym_null] = ACTIONS(4578),
    [sym_super] = ACTIONS(4578),
    [sym_this] = ACTIONS(4578),
    [sym_abstract] = ACTIONS(4578),
    [sym_alias] = ACTIONS(4578),
    [sym_align] = ACTIONS(4578),
    [sym_asm] = ACTIONS(4578),
    [sym_assert] = ACTIONS(4578),
    [sym_auto] = ACTIONS(4578),
    [sym_break] = ACTIONS(4578),
    [sym_case] = ACTIONS(4578),
    [sym_cast] = ACTIONS(4578),
    [sym_class] = ACTIONS(4578),
    [sym_const] = ACTIONS(4578),
    [sym_continue] = ACTIONS(4578),
    [sym_debug] = ACTIONS(4578),
    [sym_default] = ACTIONS(4578),
    [sym_delegate] = ACTIONS(4578),
    [sym_delete] = ACTIONS(4578),
    [sym_deprecated] = ACTIONS(4578),
    [sym_do] = ACTIONS(4578),
    [sym_else] = ACTIONS(4578),
    [sym_enum] = ACTIONS(4578),
    [sym_export] = ACTIONS(4578),
    [sym_extern] = ACTIONS(4578),
    [sym_final] = ACTIONS(4578),
    [sym_for] = ACTIONS(4578),
    [sym_foreach] = ACTIONS(4578),
    [sym_foreach_reverse] = ACTIONS(4578),
    [sym_function] = ACTIONS(4578),
    [sym_goto] = ACTIONS(4578),
    [sym_if] = ACTIONS(4578),
    [sym_immutable] = ACTIONS(4578),
    [sym_import] = ACTIONS(4578),
    [sym_in] = ACTIONS(4578),
    [sym_inout] = ACTIONS(4578),
    [sym_interface] = ACTIONS(4578),
    [sym_invariant] = ACTIONS(4578),
    [sym_is] = ACTIONS(4578),
    [sym_mixin] = ACTIONS(4578),
    [sym_new] = ACTIONS(4578),
    [sym_nothrow] = ACTIONS(4578),
    [sym_out] = ACTIONS(4578),
    [sym_override] = ACTIONS(4578),
    [sym_package] = ACTIONS(4578),
    [sym_pragma] = ACTIONS(4578),
    [sym_private] = ACTIONS(4578),
    [sym_protected] = ACTIONS(4578),
    [sym_public] = ACTIONS(4578),
    [sym_pure] = ACTIONS(4578),
    [sym_ref] = ACTIONS(4578),
    [sym_return] = ACTIONS(4578),
    [sym_scope] = ACTIONS(4578),
    [sym_shared] = ACTIONS(4578),
    [sym_static] = ACTIONS(4578),
    [sym_struct] = ACTIONS(4578),
    [sym_switch] = ACTIONS(4578),
    [sym_synchronized] = ACTIONS(4578),
    [sym_template] = ACTIONS(4578),
    [sym_throw] = ACTIONS(4578),
    [sym_try] = ACTIONS(4578),
    [sym_typeid] = ACTIONS(4578),
    [sym_typeof] = ACTIONS(4578),
    [sym_union] = ACTIONS(4578),
    [sym_unittest] = ACTIONS(4578),
    [sym_version] = ACTIONS(4578),
    [sym_while] = ACTIONS(4578),
    [sym_with] = ACTIONS(4578),
    [sym_gshared] = ACTIONS(4578),
    [sym_traits] = ACTIONS(4578),
    [sym_vector] = ACTIONS(4578),
    [sym_void] = ACTIONS(4578),
    [anon_sym_BQUOTE] = ACTIONS(4580),
    [anon_sym_r_DQUOTE] = ACTIONS(4580),
    [anon_sym_x_DQUOTE] = ACTIONS(4580),
    [anon_sym_DQUOTE] = ACTIONS(4580),
    [anon_sym_i_BQUOTE] = ACTIONS(4580),
    [anon_sym_i_DQUOTE] = ACTIONS(4580),
    [anon_sym_iq_LBRACE] = ACTIONS(4580),
    [aux_sym_char_literal_token1] = ACTIONS(4580),
    [anon_sym_SQUOTE] = ACTIONS(4578),
    [anon_sym___DATE__] = ACTIONS(4578),
    [anon_sym___FILE__] = ACTIONS(4578),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4578),
    [anon_sym___FUNCTION__] = ACTIONS(4578),
    [anon_sym___LINE__] = ACTIONS(4578),
    [anon_sym___MODULE__] = ACTIONS(4578),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4578),
    [anon_sym___TIME__] = ACTIONS(4578),
    [anon_sym___TIMESTAMP__] = ACTIONS(4578),
    [anon_sym___VENDOR__] = ACTIONS(4578),
    [anon_sym___VERSION__] = ACTIONS(4578),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4580),
    [sym_float_literal] = ACTIONS(4580),
    [sym__string] = ACTIONS(4580),
  },
  [1551] = {
    [sym_identifier] = ACTIONS(4995),
    [anon_sym_q_LBRACE] = ACTIONS(4997),
    [anon_sym_RBRACE] = ACTIONS(4997),
    [anon_sym_LBRACE] = ACTIONS(4997),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_PLUS_PLUS] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_LPAREN] = ACTIONS(4997),
    [anon_sym_RPAREN] = ACTIONS(4997),
    [anon_sym_LBRACK] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(4997),
    [anon_sym_DOLLAR] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_TILDE] = ACTIONS(4997),
    [anon_sym_AT] = ACTIONS(4997),
    [sym_bool] = ACTIONS(4995),
    [sym_byte] = ACTIONS(4995),
    [sym_ubyte] = ACTIONS(4995),
    [sym_char] = ACTIONS(4995),
    [sym_short] = ACTIONS(4995),
    [sym_ushort] = ACTIONS(4995),
    [sym_int] = ACTIONS(4995),
    [sym_uint] = ACTIONS(4995),
    [sym_long] = ACTIONS(4995),
    [sym_ulong] = ACTIONS(4995),
    [sym_cent] = ACTIONS(4995),
    [sym_ucent] = ACTIONS(4995),
    [sym_wchar] = ACTIONS(4995),
    [sym_dchar] = ACTIONS(4995),
    [sym_float] = ACTIONS(4995),
    [sym_double] = ACTIONS(4995),
    [sym_real] = ACTIONS(4995),
    [sym_ifloat] = ACTIONS(4995),
    [sym_idouble] = ACTIONS(4995),
    [sym_ireal] = ACTIONS(4995),
    [sym_cfloat] = ACTIONS(4995),
    [sym_cdouble] = ACTIONS(4995),
    [sym_creal] = ACTIONS(4995),
    [sym_size_t] = ACTIONS(4995),
    [sym_ptrdiff_t] = ACTIONS(4995),
    [sym_string] = ACTIONS(4995),
    [sym_cstring] = ACTIONS(4995),
    [sym_dstring] = ACTIONS(4995),
    [sym_wstring] = ACTIONS(4995),
    [sym_noreturn] = ACTIONS(4995),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_super] = ACTIONS(4995),
    [sym_this] = ACTIONS(4995),
    [sym_abstract] = ACTIONS(4995),
    [sym_alias] = ACTIONS(4995),
    [sym_align] = ACTIONS(4995),
    [sym_asm] = ACTIONS(4995),
    [sym_assert] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [sym_break] = ACTIONS(4995),
    [sym_case] = ACTIONS(4995),
    [sym_cast] = ACTIONS(4995),
    [sym_class] = ACTIONS(4995),
    [sym_const] = ACTIONS(4995),
    [sym_continue] = ACTIONS(4995),
    [sym_debug] = ACTIONS(4995),
    [sym_default] = ACTIONS(4995),
    [sym_delegate] = ACTIONS(4995),
    [sym_delete] = ACTIONS(4995),
    [sym_deprecated] = ACTIONS(4995),
    [sym_do] = ACTIONS(4995),
    [sym_else] = ACTIONS(4995),
    [sym_enum] = ACTIONS(4995),
    [sym_export] = ACTIONS(4995),
    [sym_extern] = ACTIONS(4995),
    [sym_final] = ACTIONS(4995),
    [sym_for] = ACTIONS(4995),
    [sym_foreach] = ACTIONS(4995),
    [sym_foreach_reverse] = ACTIONS(4995),
    [sym_function] = ACTIONS(4995),
    [sym_goto] = ACTIONS(4995),
    [sym_if] = ACTIONS(4995),
    [sym_immutable] = ACTIONS(4995),
    [sym_import] = ACTIONS(4995),
    [sym_in] = ACTIONS(4995),
    [sym_inout] = ACTIONS(4995),
    [sym_interface] = ACTIONS(4995),
    [sym_invariant] = ACTIONS(4995),
    [sym_is] = ACTIONS(4995),
    [sym_mixin] = ACTIONS(4995),
    [sym_new] = ACTIONS(4995),
    [sym_nothrow] = ACTIONS(4995),
    [sym_out] = ACTIONS(4995),
    [sym_override] = ACTIONS(4995),
    [sym_package] = ACTIONS(4995),
    [sym_pragma] = ACTIONS(4995),
    [sym_private] = ACTIONS(4995),
    [sym_protected] = ACTIONS(4995),
    [sym_public] = ACTIONS(4995),
    [sym_pure] = ACTIONS(4995),
    [sym_ref] = ACTIONS(4995),
    [sym_return] = ACTIONS(4995),
    [sym_scope] = ACTIONS(4995),
    [sym_shared] = ACTIONS(4995),
    [sym_static] = ACTIONS(4995),
    [sym_struct] = ACTIONS(4995),
    [sym_switch] = ACTIONS(4995),
    [sym_synchronized] = ACTIONS(4995),
    [sym_template] = ACTIONS(4995),
    [sym_throw] = ACTIONS(4995),
    [sym_try] = ACTIONS(4995),
    [sym_typeid] = ACTIONS(4995),
    [sym_typeof] = ACTIONS(4995),
    [sym_union] = ACTIONS(4995),
    [sym_unittest] = ACTIONS(4995),
    [sym_version] = ACTIONS(4995),
    [sym_while] = ACTIONS(4995),
    [sym_with] = ACTIONS(4995),
    [sym_gshared] = ACTIONS(4995),
    [sym_traits] = ACTIONS(4995),
    [sym_vector] = ACTIONS(4995),
    [sym_void] = ACTIONS(4995),
    [anon_sym_BQUOTE] = ACTIONS(4997),
    [anon_sym_r_DQUOTE] = ACTIONS(4997),
    [anon_sym_x_DQUOTE] = ACTIONS(4997),
    [anon_sym_DQUOTE] = ACTIONS(4997),
    [anon_sym_i_BQUOTE] = ACTIONS(4997),
    [anon_sym_i_DQUOTE] = ACTIONS(4997),
    [anon_sym_iq_LBRACE] = ACTIONS(4997),
    [aux_sym_char_literal_token1] = ACTIONS(4997),
    [anon_sym_SQUOTE] = ACTIONS(4995),
    [anon_sym___DATE__] = ACTIONS(4995),
    [anon_sym___FILE__] = ACTIONS(4995),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4995),
    [anon_sym___FUNCTION__] = ACTIONS(4995),
    [anon_sym___LINE__] = ACTIONS(4995),
    [anon_sym___MODULE__] = ACTIONS(4995),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4995),
    [anon_sym___TIME__] = ACTIONS(4995),
    [anon_sym___TIMESTAMP__] = ACTIONS(4995),
    [anon_sym___VENDOR__] = ACTIONS(4995),
    [anon_sym___VERSION__] = ACTIONS(4995),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4997),
    [sym_float_literal] = ACTIONS(4997),
    [sym__string] = ACTIONS(4997),
  },
  [1552] = {
    [sym_identifier] = ACTIONS(4987),
    [anon_sym_q_LBRACE] = ACTIONS(4989),
    [anon_sym_RBRACE] = ACTIONS(4989),
    [anon_sym_LBRACE] = ACTIONS(4989),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4989),
    [anon_sym_PLUS] = ACTIONS(4987),
    [anon_sym_PLUS_PLUS] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(4989),
    [anon_sym_RPAREN] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4989),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [anon_sym_AT] = ACTIONS(4989),
    [sym_bool] = ACTIONS(4987),
    [sym_byte] = ACTIONS(4987),
    [sym_ubyte] = ACTIONS(4987),
    [sym_char] = ACTIONS(4987),
    [sym_short] = ACTIONS(4987),
    [sym_ushort] = ACTIONS(4987),
    [sym_int] = ACTIONS(4987),
    [sym_uint] = ACTIONS(4987),
    [sym_long] = ACTIONS(4987),
    [sym_ulong] = ACTIONS(4987),
    [sym_cent] = ACTIONS(4987),
    [sym_ucent] = ACTIONS(4987),
    [sym_wchar] = ACTIONS(4987),
    [sym_dchar] = ACTIONS(4987),
    [sym_float] = ACTIONS(4987),
    [sym_double] = ACTIONS(4987),
    [sym_real] = ACTIONS(4987),
    [sym_ifloat] = ACTIONS(4987),
    [sym_idouble] = ACTIONS(4987),
    [sym_ireal] = ACTIONS(4987),
    [sym_cfloat] = ACTIONS(4987),
    [sym_cdouble] = ACTIONS(4987),
    [sym_creal] = ACTIONS(4987),
    [sym_size_t] = ACTIONS(4987),
    [sym_ptrdiff_t] = ACTIONS(4987),
    [sym_string] = ACTIONS(4987),
    [sym_cstring] = ACTIONS(4987),
    [sym_dstring] = ACTIONS(4987),
    [sym_wstring] = ACTIONS(4987),
    [sym_noreturn] = ACTIONS(4987),
    [sym_true] = ACTIONS(4987),
    [sym_false] = ACTIONS(4987),
    [sym_null] = ACTIONS(4987),
    [sym_super] = ACTIONS(4987),
    [sym_this] = ACTIONS(4987),
    [sym_abstract] = ACTIONS(4987),
    [sym_alias] = ACTIONS(4987),
    [sym_align] = ACTIONS(4987),
    [sym_asm] = ACTIONS(4987),
    [sym_assert] = ACTIONS(4987),
    [sym_auto] = ACTIONS(4987),
    [sym_break] = ACTIONS(4987),
    [sym_case] = ACTIONS(4987),
    [sym_cast] = ACTIONS(4987),
    [sym_class] = ACTIONS(4987),
    [sym_const] = ACTIONS(4987),
    [sym_continue] = ACTIONS(4987),
    [sym_debug] = ACTIONS(4987),
    [sym_default] = ACTIONS(4987),
    [sym_delegate] = ACTIONS(4987),
    [sym_delete] = ACTIONS(4987),
    [sym_deprecated] = ACTIONS(4987),
    [sym_do] = ACTIONS(4987),
    [sym_else] = ACTIONS(4987),
    [sym_enum] = ACTIONS(4987),
    [sym_export] = ACTIONS(4987),
    [sym_extern] = ACTIONS(4987),
    [sym_final] = ACTIONS(4987),
    [sym_for] = ACTIONS(4987),
    [sym_foreach] = ACTIONS(4987),
    [sym_foreach_reverse] = ACTIONS(4987),
    [sym_function] = ACTIONS(4987),
    [sym_goto] = ACTIONS(4987),
    [sym_if] = ACTIONS(4987),
    [sym_immutable] = ACTIONS(4987),
    [sym_import] = ACTIONS(4987),
    [sym_in] = ACTIONS(4987),
    [sym_inout] = ACTIONS(4987),
    [sym_interface] = ACTIONS(4987),
    [sym_invariant] = ACTIONS(4987),
    [sym_is] = ACTIONS(4987),
    [sym_mixin] = ACTIONS(4987),
    [sym_new] = ACTIONS(4987),
    [sym_nothrow] = ACTIONS(4987),
    [sym_out] = ACTIONS(4987),
    [sym_override] = ACTIONS(4987),
    [sym_package] = ACTIONS(4987),
    [sym_pragma] = ACTIONS(4987),
    [sym_private] = ACTIONS(4987),
    [sym_protected] = ACTIONS(4987),
    [sym_public] = ACTIONS(4987),
    [sym_pure] = ACTIONS(4987),
    [sym_ref] = ACTIONS(4987),
    [sym_return] = ACTIONS(4987),
    [sym_scope] = ACTIONS(4987),
    [sym_shared] = ACTIONS(4987),
    [sym_static] = ACTIONS(4987),
    [sym_struct] = ACTIONS(4987),
    [sym_switch] = ACTIONS(4987),
    [sym_synchronized] = ACTIONS(4987),
    [sym_template] = ACTIONS(4987),
    [sym_throw] = ACTIONS(4987),
    [sym_try] = ACTIONS(4987),
    [sym_typeid] = ACTIONS(4987),
    [sym_typeof] = ACTIONS(4987),
    [sym_union] = ACTIONS(4987),
    [sym_unittest] = ACTIONS(4987),
    [sym_version] = ACTIONS(4987),
    [sym_while] = ACTIONS(4987),
    [sym_with] = ACTIONS(4987),
    [sym_gshared] = ACTIONS(4987),
    [sym_traits] = ACTIONS(4987),
    [sym_vector] = ACTIONS(4987),
    [sym_void] = ACTIONS(4987),
    [anon_sym_BQUOTE] = ACTIONS(4989),
    [anon_sym_r_DQUOTE] = ACTIONS(4989),
    [anon_sym_x_DQUOTE] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_i_BQUOTE] = ACTIONS(4989),
    [anon_sym_i_DQUOTE] = ACTIONS(4989),
    [anon_sym_iq_LBRACE] = ACTIONS(4989),
    [aux_sym_char_literal_token1] = ACTIONS(4989),
    [anon_sym_SQUOTE] = ACTIONS(4987),
    [anon_sym___DATE__] = ACTIONS(4987),
    [anon_sym___FILE__] = ACTIONS(4987),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4987),
    [anon_sym___FUNCTION__] = ACTIONS(4987),
    [anon_sym___LINE__] = ACTIONS(4987),
    [anon_sym___MODULE__] = ACTIONS(4987),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4987),
    [anon_sym___TIME__] = ACTIONS(4987),
    [anon_sym___TIMESTAMP__] = ACTIONS(4987),
    [anon_sym___VENDOR__] = ACTIONS(4987),
    [anon_sym___VERSION__] = ACTIONS(4987),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4989),
    [sym_float_literal] = ACTIONS(4989),
    [sym__string] = ACTIONS(4989),
  },
  [1553] = {
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_q_LBRACE] = ACTIONS(4735),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_DOT] = ACTIONS(4735),
    [anon_sym_AMP] = ACTIONS(4735),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(4735),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_PLUS_PLUS] = ACTIONS(4735),
    [anon_sym_BANG] = ACTIONS(4735),
    [anon_sym_LPAREN] = ACTIONS(4735),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4735),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_DOLLAR] = ACTIONS(4735),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [anon_sym_AT] = ACTIONS(4735),
    [sym_bool] = ACTIONS(4733),
    [sym_byte] = ACTIONS(4733),
    [sym_ubyte] = ACTIONS(4733),
    [sym_char] = ACTIONS(4733),
    [sym_short] = ACTIONS(4733),
    [sym_ushort] = ACTIONS(4733),
    [sym_int] = ACTIONS(4733),
    [sym_uint] = ACTIONS(4733),
    [sym_long] = ACTIONS(4733),
    [sym_ulong] = ACTIONS(4733),
    [sym_cent] = ACTIONS(4733),
    [sym_ucent] = ACTIONS(4733),
    [sym_wchar] = ACTIONS(4733),
    [sym_dchar] = ACTIONS(4733),
    [sym_float] = ACTIONS(4733),
    [sym_double] = ACTIONS(4733),
    [sym_real] = ACTIONS(4733),
    [sym_ifloat] = ACTIONS(4733),
    [sym_idouble] = ACTIONS(4733),
    [sym_ireal] = ACTIONS(4733),
    [sym_cfloat] = ACTIONS(4733),
    [sym_cdouble] = ACTIONS(4733),
    [sym_creal] = ACTIONS(4733),
    [sym_size_t] = ACTIONS(4733),
    [sym_ptrdiff_t] = ACTIONS(4733),
    [sym_string] = ACTIONS(4733),
    [sym_cstring] = ACTIONS(4733),
    [sym_dstring] = ACTIONS(4733),
    [sym_wstring] = ACTIONS(4733),
    [sym_noreturn] = ACTIONS(4733),
    [sym_true] = ACTIONS(4733),
    [sym_false] = ACTIONS(4733),
    [sym_null] = ACTIONS(4733),
    [sym_super] = ACTIONS(4733),
    [sym_this] = ACTIONS(4733),
    [sym_abstract] = ACTIONS(4733),
    [sym_alias] = ACTIONS(4733),
    [sym_align] = ACTIONS(4733),
    [sym_asm] = ACTIONS(4733),
    [sym_assert] = ACTIONS(4733),
    [sym_auto] = ACTIONS(4733),
    [sym_break] = ACTIONS(4733),
    [sym_case] = ACTIONS(4733),
    [sym_cast] = ACTIONS(4733),
    [sym_class] = ACTIONS(4733),
    [sym_const] = ACTIONS(4733),
    [sym_continue] = ACTIONS(4733),
    [sym_debug] = ACTIONS(4733),
    [sym_default] = ACTIONS(4733),
    [sym_delegate] = ACTIONS(4733),
    [sym_delete] = ACTIONS(4733),
    [sym_deprecated] = ACTIONS(4733),
    [sym_do] = ACTIONS(4733),
    [sym_else] = ACTIONS(4733),
    [sym_enum] = ACTIONS(4733),
    [sym_export] = ACTIONS(4733),
    [sym_extern] = ACTIONS(4733),
    [sym_final] = ACTIONS(4733),
    [sym_for] = ACTIONS(4733),
    [sym_foreach] = ACTIONS(4733),
    [sym_foreach_reverse] = ACTIONS(4733),
    [sym_function] = ACTIONS(4733),
    [sym_goto] = ACTIONS(4733),
    [sym_if] = ACTIONS(4733),
    [sym_immutable] = ACTIONS(4733),
    [sym_import] = ACTIONS(4733),
    [sym_in] = ACTIONS(4733),
    [sym_inout] = ACTIONS(4733),
    [sym_interface] = ACTIONS(4733),
    [sym_invariant] = ACTIONS(4733),
    [sym_is] = ACTIONS(4733),
    [sym_mixin] = ACTIONS(4733),
    [sym_new] = ACTIONS(4733),
    [sym_nothrow] = ACTIONS(4733),
    [sym_out] = ACTIONS(4733),
    [sym_override] = ACTIONS(4733),
    [sym_package] = ACTIONS(4733),
    [sym_pragma] = ACTIONS(4733),
    [sym_private] = ACTIONS(4733),
    [sym_protected] = ACTIONS(4733),
    [sym_public] = ACTIONS(4733),
    [sym_pure] = ACTIONS(4733),
    [sym_ref] = ACTIONS(4733),
    [sym_return] = ACTIONS(4733),
    [sym_scope] = ACTIONS(4733),
    [sym_shared] = ACTIONS(4733),
    [sym_static] = ACTIONS(4733),
    [sym_struct] = ACTIONS(4733),
    [sym_switch] = ACTIONS(4733),
    [sym_synchronized] = ACTIONS(4733),
    [sym_template] = ACTIONS(4733),
    [sym_throw] = ACTIONS(4733),
    [sym_try] = ACTIONS(4733),
    [sym_typeid] = ACTIONS(4733),
    [sym_typeof] = ACTIONS(4733),
    [sym_union] = ACTIONS(4733),
    [sym_unittest] = ACTIONS(4733),
    [sym_version] = ACTIONS(4733),
    [sym_while] = ACTIONS(4733),
    [sym_with] = ACTIONS(4733),
    [sym_gshared] = ACTIONS(4733),
    [sym_traits] = ACTIONS(4733),
    [sym_vector] = ACTIONS(4733),
    [sym_void] = ACTIONS(4733),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [anon_sym_r_DQUOTE] = ACTIONS(4735),
    [anon_sym_x_DQUOTE] = ACTIONS(4735),
    [anon_sym_DQUOTE] = ACTIONS(4735),
    [anon_sym_i_BQUOTE] = ACTIONS(4735),
    [anon_sym_i_DQUOTE] = ACTIONS(4735),
    [anon_sym_iq_LBRACE] = ACTIONS(4735),
    [aux_sym_char_literal_token1] = ACTIONS(4735),
    [anon_sym_SQUOTE] = ACTIONS(4733),
    [anon_sym___DATE__] = ACTIONS(4733),
    [anon_sym___FILE__] = ACTIONS(4733),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4733),
    [anon_sym___FUNCTION__] = ACTIONS(4733),
    [anon_sym___LINE__] = ACTIONS(4733),
    [anon_sym___MODULE__] = ACTIONS(4733),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4733),
    [anon_sym___TIME__] = ACTIONS(4733),
    [anon_sym___TIMESTAMP__] = ACTIONS(4733),
    [anon_sym___VENDOR__] = ACTIONS(4733),
    [anon_sym___VERSION__] = ACTIONS(4733),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4735),
    [sym_float_literal] = ACTIONS(4735),
    [sym__string] = ACTIONS(4735),
  },
  [1554] = {
    [sym_identifier] = ACTIONS(4546),
    [anon_sym_q_LBRACE] = ACTIONS(4548),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(4548),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_DASH_DASH] = ACTIONS(4548),
    [anon_sym_PLUS] = ACTIONS(4546),
    [anon_sym_PLUS_PLUS] = ACTIONS(4548),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AT] = ACTIONS(4548),
    [sym_bool] = ACTIONS(4546),
    [sym_byte] = ACTIONS(4546),
    [sym_ubyte] = ACTIONS(4546),
    [sym_char] = ACTIONS(4546),
    [sym_short] = ACTIONS(4546),
    [sym_ushort] = ACTIONS(4546),
    [sym_int] = ACTIONS(4546),
    [sym_uint] = ACTIONS(4546),
    [sym_long] = ACTIONS(4546),
    [sym_ulong] = ACTIONS(4546),
    [sym_cent] = ACTIONS(4546),
    [sym_ucent] = ACTIONS(4546),
    [sym_wchar] = ACTIONS(4546),
    [sym_dchar] = ACTIONS(4546),
    [sym_float] = ACTIONS(4546),
    [sym_double] = ACTIONS(4546),
    [sym_real] = ACTIONS(4546),
    [sym_ifloat] = ACTIONS(4546),
    [sym_idouble] = ACTIONS(4546),
    [sym_ireal] = ACTIONS(4546),
    [sym_cfloat] = ACTIONS(4546),
    [sym_cdouble] = ACTIONS(4546),
    [sym_creal] = ACTIONS(4546),
    [sym_size_t] = ACTIONS(4546),
    [sym_ptrdiff_t] = ACTIONS(4546),
    [sym_string] = ACTIONS(4546),
    [sym_cstring] = ACTIONS(4546),
    [sym_dstring] = ACTIONS(4546),
    [sym_wstring] = ACTIONS(4546),
    [sym_noreturn] = ACTIONS(4546),
    [sym_true] = ACTIONS(4546),
    [sym_false] = ACTIONS(4546),
    [sym_null] = ACTIONS(4546),
    [sym_super] = ACTIONS(4546),
    [sym_this] = ACTIONS(4546),
    [sym_abstract] = ACTIONS(4546),
    [sym_alias] = ACTIONS(4546),
    [sym_align] = ACTIONS(4546),
    [sym_asm] = ACTIONS(4546),
    [sym_assert] = ACTIONS(4546),
    [sym_auto] = ACTIONS(4546),
    [sym_break] = ACTIONS(4546),
    [sym_case] = ACTIONS(4546),
    [sym_cast] = ACTIONS(4546),
    [sym_class] = ACTIONS(4546),
    [sym_const] = ACTIONS(4546),
    [sym_continue] = ACTIONS(4546),
    [sym_debug] = ACTIONS(4546),
    [sym_default] = ACTIONS(4546),
    [sym_delegate] = ACTIONS(4546),
    [sym_delete] = ACTIONS(4546),
    [sym_deprecated] = ACTIONS(4546),
    [sym_do] = ACTIONS(4546),
    [sym_else] = ACTIONS(4546),
    [sym_enum] = ACTIONS(4546),
    [sym_export] = ACTIONS(4546),
    [sym_extern] = ACTIONS(4546),
    [sym_final] = ACTIONS(4546),
    [sym_for] = ACTIONS(4546),
    [sym_foreach] = ACTIONS(4546),
    [sym_foreach_reverse] = ACTIONS(4546),
    [sym_function] = ACTIONS(4546),
    [sym_goto] = ACTIONS(4546),
    [sym_if] = ACTIONS(4546),
    [sym_immutable] = ACTIONS(4546),
    [sym_import] = ACTIONS(4546),
    [sym_in] = ACTIONS(4546),
    [sym_inout] = ACTIONS(4546),
    [sym_interface] = ACTIONS(4546),
    [sym_invariant] = ACTIONS(4546),
    [sym_is] = ACTIONS(4546),
    [sym_mixin] = ACTIONS(4546),
    [sym_new] = ACTIONS(4546),
    [sym_nothrow] = ACTIONS(4546),
    [sym_out] = ACTIONS(4546),
    [sym_override] = ACTIONS(4546),
    [sym_package] = ACTIONS(4546),
    [sym_pragma] = ACTIONS(4546),
    [sym_private] = ACTIONS(4546),
    [sym_protected] = ACTIONS(4546),
    [sym_public] = ACTIONS(4546),
    [sym_pure] = ACTIONS(4546),
    [sym_ref] = ACTIONS(4546),
    [sym_return] = ACTIONS(4546),
    [sym_scope] = ACTIONS(4546),
    [sym_shared] = ACTIONS(4546),
    [sym_static] = ACTIONS(4546),
    [sym_struct] = ACTIONS(4546),
    [sym_switch] = ACTIONS(4546),
    [sym_synchronized] = ACTIONS(4546),
    [sym_template] = ACTIONS(4546),
    [sym_throw] = ACTIONS(4546),
    [sym_try] = ACTIONS(4546),
    [sym_typeid] = ACTIONS(4546),
    [sym_typeof] = ACTIONS(4546),
    [sym_union] = ACTIONS(4546),
    [sym_unittest] = ACTIONS(4546),
    [sym_version] = ACTIONS(4546),
    [sym_while] = ACTIONS(4546),
    [sym_with] = ACTIONS(4546),
    [sym_gshared] = ACTIONS(4546),
    [sym_traits] = ACTIONS(4546),
    [sym_vector] = ACTIONS(4546),
    [sym_void] = ACTIONS(4546),
    [anon_sym_BQUOTE] = ACTIONS(4548),
    [anon_sym_r_DQUOTE] = ACTIONS(4548),
    [anon_sym_x_DQUOTE] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4548),
    [anon_sym_i_BQUOTE] = ACTIONS(4548),
    [anon_sym_i_DQUOTE] = ACTIONS(4548),
    [anon_sym_iq_LBRACE] = ACTIONS(4548),
    [aux_sym_char_literal_token1] = ACTIONS(4548),
    [anon_sym_SQUOTE] = ACTIONS(4546),
    [anon_sym___DATE__] = ACTIONS(4546),
    [anon_sym___FILE__] = ACTIONS(4546),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4546),
    [anon_sym___FUNCTION__] = ACTIONS(4546),
    [anon_sym___LINE__] = ACTIONS(4546),
    [anon_sym___MODULE__] = ACTIONS(4546),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4546),
    [anon_sym___TIME__] = ACTIONS(4546),
    [anon_sym___TIMESTAMP__] = ACTIONS(4546),
    [anon_sym___VENDOR__] = ACTIONS(4546),
    [anon_sym___VERSION__] = ACTIONS(4546),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4548),
    [sym_float_literal] = ACTIONS(4548),
    [sym__string] = ACTIONS(4548),
  },
  [1555] = {
    [sym_identifier] = ACTIONS(4542),
    [anon_sym_q_LBRACE] = ACTIONS(4544),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_LBRACE] = ACTIONS(4544),
    [anon_sym_DOT] = ACTIONS(4544),
    [anon_sym_AMP] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4542),
    [anon_sym_DASH_DASH] = ACTIONS(4544),
    [anon_sym_PLUS] = ACTIONS(4542),
    [anon_sym_PLUS_PLUS] = ACTIONS(4544),
    [anon_sym_BANG] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(4544),
    [anon_sym_RPAREN] = ACTIONS(4544),
    [anon_sym_LBRACK] = ACTIONS(4544),
    [anon_sym_SEMI] = ACTIONS(4544),
    [anon_sym_DOLLAR] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_TILDE] = ACTIONS(4544),
    [anon_sym_AT] = ACTIONS(4544),
    [sym_bool] = ACTIONS(4542),
    [sym_byte] = ACTIONS(4542),
    [sym_ubyte] = ACTIONS(4542),
    [sym_char] = ACTIONS(4542),
    [sym_short] = ACTIONS(4542),
    [sym_ushort] = ACTIONS(4542),
    [sym_int] = ACTIONS(4542),
    [sym_uint] = ACTIONS(4542),
    [sym_long] = ACTIONS(4542),
    [sym_ulong] = ACTIONS(4542),
    [sym_cent] = ACTIONS(4542),
    [sym_ucent] = ACTIONS(4542),
    [sym_wchar] = ACTIONS(4542),
    [sym_dchar] = ACTIONS(4542),
    [sym_float] = ACTIONS(4542),
    [sym_double] = ACTIONS(4542),
    [sym_real] = ACTIONS(4542),
    [sym_ifloat] = ACTIONS(4542),
    [sym_idouble] = ACTIONS(4542),
    [sym_ireal] = ACTIONS(4542),
    [sym_cfloat] = ACTIONS(4542),
    [sym_cdouble] = ACTIONS(4542),
    [sym_creal] = ACTIONS(4542),
    [sym_size_t] = ACTIONS(4542),
    [sym_ptrdiff_t] = ACTIONS(4542),
    [sym_string] = ACTIONS(4542),
    [sym_cstring] = ACTIONS(4542),
    [sym_dstring] = ACTIONS(4542),
    [sym_wstring] = ACTIONS(4542),
    [sym_noreturn] = ACTIONS(4542),
    [sym_true] = ACTIONS(4542),
    [sym_false] = ACTIONS(4542),
    [sym_null] = ACTIONS(4542),
    [sym_super] = ACTIONS(4542),
    [sym_this] = ACTIONS(4542),
    [sym_abstract] = ACTIONS(4542),
    [sym_alias] = ACTIONS(4542),
    [sym_align] = ACTIONS(4542),
    [sym_asm] = ACTIONS(4542),
    [sym_assert] = ACTIONS(4542),
    [sym_auto] = ACTIONS(4542),
    [sym_break] = ACTIONS(4542),
    [sym_case] = ACTIONS(4542),
    [sym_cast] = ACTIONS(4542),
    [sym_class] = ACTIONS(4542),
    [sym_const] = ACTIONS(4542),
    [sym_continue] = ACTIONS(4542),
    [sym_debug] = ACTIONS(4542),
    [sym_default] = ACTIONS(4542),
    [sym_delegate] = ACTIONS(4542),
    [sym_delete] = ACTIONS(4542),
    [sym_deprecated] = ACTIONS(4542),
    [sym_do] = ACTIONS(4542),
    [sym_else] = ACTIONS(4542),
    [sym_enum] = ACTIONS(4542),
    [sym_export] = ACTIONS(4542),
    [sym_extern] = ACTIONS(4542),
    [sym_final] = ACTIONS(4542),
    [sym_for] = ACTIONS(4542),
    [sym_foreach] = ACTIONS(4542),
    [sym_foreach_reverse] = ACTIONS(4542),
    [sym_function] = ACTIONS(4542),
    [sym_goto] = ACTIONS(4542),
    [sym_if] = ACTIONS(4542),
    [sym_immutable] = ACTIONS(4542),
    [sym_import] = ACTIONS(4542),
    [sym_in] = ACTIONS(4542),
    [sym_inout] = ACTIONS(4542),
    [sym_interface] = ACTIONS(4542),
    [sym_invariant] = ACTIONS(4542),
    [sym_is] = ACTIONS(4542),
    [sym_mixin] = ACTIONS(4542),
    [sym_new] = ACTIONS(4542),
    [sym_nothrow] = ACTIONS(4542),
    [sym_out] = ACTIONS(4542),
    [sym_override] = ACTIONS(4542),
    [sym_package] = ACTIONS(4542),
    [sym_pragma] = ACTIONS(4542),
    [sym_private] = ACTIONS(4542),
    [sym_protected] = ACTIONS(4542),
    [sym_public] = ACTIONS(4542),
    [sym_pure] = ACTIONS(4542),
    [sym_ref] = ACTIONS(4542),
    [sym_return] = ACTIONS(4542),
    [sym_scope] = ACTIONS(4542),
    [sym_shared] = ACTIONS(4542),
    [sym_static] = ACTIONS(4542),
    [sym_struct] = ACTIONS(4542),
    [sym_switch] = ACTIONS(4542),
    [sym_synchronized] = ACTIONS(4542),
    [sym_template] = ACTIONS(4542),
    [sym_throw] = ACTIONS(4542),
    [sym_try] = ACTIONS(4542),
    [sym_typeid] = ACTIONS(4542),
    [sym_typeof] = ACTIONS(4542),
    [sym_union] = ACTIONS(4542),
    [sym_unittest] = ACTIONS(4542),
    [sym_version] = ACTIONS(4542),
    [sym_while] = ACTIONS(4542),
    [sym_with] = ACTIONS(4542),
    [sym_gshared] = ACTIONS(4542),
    [sym_traits] = ACTIONS(4542),
    [sym_vector] = ACTIONS(4542),
    [sym_void] = ACTIONS(4542),
    [anon_sym_BQUOTE] = ACTIONS(4544),
    [anon_sym_r_DQUOTE] = ACTIONS(4544),
    [anon_sym_x_DQUOTE] = ACTIONS(4544),
    [anon_sym_DQUOTE] = ACTIONS(4544),
    [anon_sym_i_BQUOTE] = ACTIONS(4544),
    [anon_sym_i_DQUOTE] = ACTIONS(4544),
    [anon_sym_iq_LBRACE] = ACTIONS(4544),
    [aux_sym_char_literal_token1] = ACTIONS(4544),
    [anon_sym_SQUOTE] = ACTIONS(4542),
    [anon_sym___DATE__] = ACTIONS(4542),
    [anon_sym___FILE__] = ACTIONS(4542),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4542),
    [anon_sym___FUNCTION__] = ACTIONS(4542),
    [anon_sym___LINE__] = ACTIONS(4542),
    [anon_sym___MODULE__] = ACTIONS(4542),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4542),
    [anon_sym___TIME__] = ACTIONS(4542),
    [anon_sym___TIMESTAMP__] = ACTIONS(4542),
    [anon_sym___VENDOR__] = ACTIONS(4542),
    [anon_sym___VERSION__] = ACTIONS(4542),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4544),
    [sym_float_literal] = ACTIONS(4544),
    [sym__string] = ACTIONS(4544),
  },
  [1556] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_q_LBRACE] = ACTIONS(4532),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4532),
    [anon_sym_AMP] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_BANG] = ACTIONS(4532),
    [anon_sym_LPAREN] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym_DOLLAR] = ACTIONS(4532),
    [anon_sym_STAR] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_AT] = ACTIONS(4532),
    [sym_bool] = ACTIONS(4530),
    [sym_byte] = ACTIONS(4530),
    [sym_ubyte] = ACTIONS(4530),
    [sym_char] = ACTIONS(4530),
    [sym_short] = ACTIONS(4530),
    [sym_ushort] = ACTIONS(4530),
    [sym_int] = ACTIONS(4530),
    [sym_uint] = ACTIONS(4530),
    [sym_long] = ACTIONS(4530),
    [sym_ulong] = ACTIONS(4530),
    [sym_cent] = ACTIONS(4530),
    [sym_ucent] = ACTIONS(4530),
    [sym_wchar] = ACTIONS(4530),
    [sym_dchar] = ACTIONS(4530),
    [sym_float] = ACTIONS(4530),
    [sym_double] = ACTIONS(4530),
    [sym_real] = ACTIONS(4530),
    [sym_ifloat] = ACTIONS(4530),
    [sym_idouble] = ACTIONS(4530),
    [sym_ireal] = ACTIONS(4530),
    [sym_cfloat] = ACTIONS(4530),
    [sym_cdouble] = ACTIONS(4530),
    [sym_creal] = ACTIONS(4530),
    [sym_size_t] = ACTIONS(4530),
    [sym_ptrdiff_t] = ACTIONS(4530),
    [sym_string] = ACTIONS(4530),
    [sym_cstring] = ACTIONS(4530),
    [sym_dstring] = ACTIONS(4530),
    [sym_wstring] = ACTIONS(4530),
    [sym_noreturn] = ACTIONS(4530),
    [sym_true] = ACTIONS(4530),
    [sym_false] = ACTIONS(4530),
    [sym_null] = ACTIONS(4530),
    [sym_super] = ACTIONS(4530),
    [sym_this] = ACTIONS(4530),
    [sym_abstract] = ACTIONS(4530),
    [sym_alias] = ACTIONS(4530),
    [sym_align] = ACTIONS(4530),
    [sym_asm] = ACTIONS(4530),
    [sym_assert] = ACTIONS(4530),
    [sym_auto] = ACTIONS(4530),
    [sym_break] = ACTIONS(4530),
    [sym_case] = ACTIONS(4530),
    [sym_cast] = ACTIONS(4530),
    [sym_class] = ACTIONS(4530),
    [sym_const] = ACTIONS(4530),
    [sym_continue] = ACTIONS(4530),
    [sym_debug] = ACTIONS(4530),
    [sym_default] = ACTIONS(4530),
    [sym_delegate] = ACTIONS(4530),
    [sym_delete] = ACTIONS(4530),
    [sym_deprecated] = ACTIONS(4530),
    [sym_do] = ACTIONS(4530),
    [sym_else] = ACTIONS(4530),
    [sym_enum] = ACTIONS(4530),
    [sym_export] = ACTIONS(4530),
    [sym_extern] = ACTIONS(4530),
    [sym_final] = ACTIONS(4530),
    [sym_for] = ACTIONS(4530),
    [sym_foreach] = ACTIONS(4530),
    [sym_foreach_reverse] = ACTIONS(4530),
    [sym_function] = ACTIONS(4530),
    [sym_goto] = ACTIONS(4530),
    [sym_if] = ACTIONS(4530),
    [sym_immutable] = ACTIONS(4530),
    [sym_import] = ACTIONS(4530),
    [sym_in] = ACTIONS(4530),
    [sym_inout] = ACTIONS(4530),
    [sym_interface] = ACTIONS(4530),
    [sym_invariant] = ACTIONS(4530),
    [sym_is] = ACTIONS(4530),
    [sym_mixin] = ACTIONS(4530),
    [sym_new] = ACTIONS(4530),
    [sym_nothrow] = ACTIONS(4530),
    [sym_out] = ACTIONS(4530),
    [sym_override] = ACTIONS(4530),
    [sym_package] = ACTIONS(4530),
    [sym_pragma] = ACTIONS(4530),
    [sym_private] = ACTIONS(4530),
    [sym_protected] = ACTIONS(4530),
    [sym_public] = ACTIONS(4530),
    [sym_pure] = ACTIONS(4530),
    [sym_ref] = ACTIONS(4530),
    [sym_return] = ACTIONS(4530),
    [sym_scope] = ACTIONS(4530),
    [sym_shared] = ACTIONS(4530),
    [sym_static] = ACTIONS(4530),
    [sym_struct] = ACTIONS(4530),
    [sym_switch] = ACTIONS(4530),
    [sym_synchronized] = ACTIONS(4530),
    [sym_template] = ACTIONS(4530),
    [sym_throw] = ACTIONS(4530),
    [sym_try] = ACTIONS(4530),
    [sym_typeid] = ACTIONS(4530),
    [sym_typeof] = ACTIONS(4530),
    [sym_union] = ACTIONS(4530),
    [sym_unittest] = ACTIONS(4530),
    [sym_version] = ACTIONS(4530),
    [sym_while] = ACTIONS(4530),
    [sym_with] = ACTIONS(4530),
    [sym_gshared] = ACTIONS(4530),
    [sym_traits] = ACTIONS(4530),
    [sym_vector] = ACTIONS(4530),
    [sym_void] = ACTIONS(4530),
    [anon_sym_BQUOTE] = ACTIONS(4532),
    [anon_sym_r_DQUOTE] = ACTIONS(4532),
    [anon_sym_x_DQUOTE] = ACTIONS(4532),
    [anon_sym_DQUOTE] = ACTIONS(4532),
    [anon_sym_i_BQUOTE] = ACTIONS(4532),
    [anon_sym_i_DQUOTE] = ACTIONS(4532),
    [anon_sym_iq_LBRACE] = ACTIONS(4532),
    [aux_sym_char_literal_token1] = ACTIONS(4532),
    [anon_sym_SQUOTE] = ACTIONS(4530),
    [anon_sym___DATE__] = ACTIONS(4530),
    [anon_sym___FILE__] = ACTIONS(4530),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4530),
    [anon_sym___FUNCTION__] = ACTIONS(4530),
    [anon_sym___LINE__] = ACTIONS(4530),
    [anon_sym___MODULE__] = ACTIONS(4530),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4530),
    [anon_sym___TIME__] = ACTIONS(4530),
    [anon_sym___TIMESTAMP__] = ACTIONS(4530),
    [anon_sym___VENDOR__] = ACTIONS(4530),
    [anon_sym___VERSION__] = ACTIONS(4530),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4532),
    [sym_float_literal] = ACTIONS(4532),
    [sym__string] = ACTIONS(4532),
  },
  [1557] = {
    [sym_identifier] = ACTIONS(4979),
    [anon_sym_q_LBRACE] = ACTIONS(4983),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym_LBRACE] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4983),
    [anon_sym_AMP] = ACTIONS(4983),
    [anon_sym_DASH] = ACTIONS(4979),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4979),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_BANG] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_DOLLAR] = ACTIONS(4983),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_TILDE] = ACTIONS(4983),
    [anon_sym_AT] = ACTIONS(4983),
    [sym_bool] = ACTIONS(4979),
    [sym_byte] = ACTIONS(4979),
    [sym_ubyte] = ACTIONS(4979),
    [sym_char] = ACTIONS(4979),
    [sym_short] = ACTIONS(4979),
    [sym_ushort] = ACTIONS(4979),
    [sym_int] = ACTIONS(4979),
    [sym_uint] = ACTIONS(4979),
    [sym_long] = ACTIONS(4979),
    [sym_ulong] = ACTIONS(4979),
    [sym_cent] = ACTIONS(4979),
    [sym_ucent] = ACTIONS(4979),
    [sym_wchar] = ACTIONS(4979),
    [sym_dchar] = ACTIONS(4979),
    [sym_float] = ACTIONS(4979),
    [sym_double] = ACTIONS(4979),
    [sym_real] = ACTIONS(4979),
    [sym_ifloat] = ACTIONS(4979),
    [sym_idouble] = ACTIONS(4979),
    [sym_ireal] = ACTIONS(4979),
    [sym_cfloat] = ACTIONS(4979),
    [sym_cdouble] = ACTIONS(4979),
    [sym_creal] = ACTIONS(4979),
    [sym_size_t] = ACTIONS(4979),
    [sym_ptrdiff_t] = ACTIONS(4979),
    [sym_string] = ACTIONS(4979),
    [sym_cstring] = ACTIONS(4979),
    [sym_dstring] = ACTIONS(4979),
    [sym_wstring] = ACTIONS(4979),
    [sym_noreturn] = ACTIONS(4979),
    [sym_true] = ACTIONS(4979),
    [sym_false] = ACTIONS(4979),
    [sym_null] = ACTIONS(4979),
    [sym_super] = ACTIONS(4979),
    [sym_this] = ACTIONS(4979),
    [sym_abstract] = ACTIONS(4979),
    [sym_alias] = ACTIONS(4979),
    [sym_align] = ACTIONS(4979),
    [sym_asm] = ACTIONS(4979),
    [sym_assert] = ACTIONS(4979),
    [sym_auto] = ACTIONS(4979),
    [sym_break] = ACTIONS(4979),
    [sym_case] = ACTIONS(4979),
    [sym_cast] = ACTIONS(4979),
    [sym_class] = ACTIONS(4979),
    [sym_const] = ACTIONS(4979),
    [sym_continue] = ACTIONS(4979),
    [sym_debug] = ACTIONS(4979),
    [sym_default] = ACTIONS(4979),
    [sym_delegate] = ACTIONS(4979),
    [sym_delete] = ACTIONS(4979),
    [sym_deprecated] = ACTIONS(4979),
    [sym_do] = ACTIONS(4979),
    [sym_else] = ACTIONS(4979),
    [sym_enum] = ACTIONS(4979),
    [sym_export] = ACTIONS(4979),
    [sym_extern] = ACTIONS(4979),
    [sym_final] = ACTIONS(4979),
    [sym_for] = ACTIONS(4979),
    [sym_foreach] = ACTIONS(4979),
    [sym_foreach_reverse] = ACTIONS(4979),
    [sym_function] = ACTIONS(4979),
    [sym_goto] = ACTIONS(4979),
    [sym_if] = ACTIONS(4979),
    [sym_immutable] = ACTIONS(4979),
    [sym_import] = ACTIONS(4979),
    [sym_in] = ACTIONS(4979),
    [sym_inout] = ACTIONS(4979),
    [sym_interface] = ACTIONS(4979),
    [sym_invariant] = ACTIONS(4979),
    [sym_is] = ACTIONS(4979),
    [sym_mixin] = ACTIONS(4979),
    [sym_new] = ACTIONS(4979),
    [sym_nothrow] = ACTIONS(4979),
    [sym_out] = ACTIONS(4979),
    [sym_override] = ACTIONS(4979),
    [sym_package] = ACTIONS(4979),
    [sym_pragma] = ACTIONS(4979),
    [sym_private] = ACTIONS(4979),
    [sym_protected] = ACTIONS(4979),
    [sym_public] = ACTIONS(4979),
    [sym_pure] = ACTIONS(4979),
    [sym_ref] = ACTIONS(4979),
    [sym_return] = ACTIONS(4979),
    [sym_scope] = ACTIONS(4979),
    [sym_shared] = ACTIONS(4979),
    [sym_static] = ACTIONS(4979),
    [sym_struct] = ACTIONS(4979),
    [sym_switch] = ACTIONS(4979),
    [sym_synchronized] = ACTIONS(4979),
    [sym_template] = ACTIONS(4979),
    [sym_throw] = ACTIONS(4979),
    [sym_try] = ACTIONS(4979),
    [sym_typeid] = ACTIONS(4979),
    [sym_typeof] = ACTIONS(4979),
    [sym_union] = ACTIONS(4979),
    [sym_unittest] = ACTIONS(4979),
    [sym_version] = ACTIONS(4979),
    [sym_while] = ACTIONS(4979),
    [sym_with] = ACTIONS(4979),
    [sym_gshared] = ACTIONS(4979),
    [sym_traits] = ACTIONS(4979),
    [sym_vector] = ACTIONS(4979),
    [sym_void] = ACTIONS(4979),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_r_DQUOTE] = ACTIONS(4983),
    [anon_sym_x_DQUOTE] = ACTIONS(4983),
    [anon_sym_DQUOTE] = ACTIONS(4983),
    [anon_sym_i_BQUOTE] = ACTIONS(4983),
    [anon_sym_i_DQUOTE] = ACTIONS(4983),
    [anon_sym_iq_LBRACE] = ACTIONS(4983),
    [aux_sym_char_literal_token1] = ACTIONS(4983),
    [anon_sym_SQUOTE] = ACTIONS(4979),
    [anon_sym___DATE__] = ACTIONS(4979),
    [anon_sym___FILE__] = ACTIONS(4979),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4979),
    [anon_sym___FUNCTION__] = ACTIONS(4979),
    [anon_sym___LINE__] = ACTIONS(4979),
    [anon_sym___MODULE__] = ACTIONS(4979),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4979),
    [anon_sym___TIME__] = ACTIONS(4979),
    [anon_sym___TIMESTAMP__] = ACTIONS(4979),
    [anon_sym___VENDOR__] = ACTIONS(4979),
    [anon_sym___VERSION__] = ACTIONS(4979),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4983),
    [sym_float_literal] = ACTIONS(4983),
    [sym__string] = ACTIONS(4983),
  },
  [1558] = {
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_q_LBRACE] = ACTIONS(4977),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_LBRACE] = ACTIONS(4977),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4977),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_PLUS_PLUS] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_LPAREN] = ACTIONS(4977),
    [anon_sym_RPAREN] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(4977),
    [anon_sym_SEMI] = ACTIONS(4977),
    [anon_sym_DOLLAR] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_TILDE] = ACTIONS(4977),
    [anon_sym_AT] = ACTIONS(4977),
    [sym_bool] = ACTIONS(4975),
    [sym_byte] = ACTIONS(4975),
    [sym_ubyte] = ACTIONS(4975),
    [sym_char] = ACTIONS(4975),
    [sym_short] = ACTIONS(4975),
    [sym_ushort] = ACTIONS(4975),
    [sym_int] = ACTIONS(4975),
    [sym_uint] = ACTIONS(4975),
    [sym_long] = ACTIONS(4975),
    [sym_ulong] = ACTIONS(4975),
    [sym_cent] = ACTIONS(4975),
    [sym_ucent] = ACTIONS(4975),
    [sym_wchar] = ACTIONS(4975),
    [sym_dchar] = ACTIONS(4975),
    [sym_float] = ACTIONS(4975),
    [sym_double] = ACTIONS(4975),
    [sym_real] = ACTIONS(4975),
    [sym_ifloat] = ACTIONS(4975),
    [sym_idouble] = ACTIONS(4975),
    [sym_ireal] = ACTIONS(4975),
    [sym_cfloat] = ACTIONS(4975),
    [sym_cdouble] = ACTIONS(4975),
    [sym_creal] = ACTIONS(4975),
    [sym_size_t] = ACTIONS(4975),
    [sym_ptrdiff_t] = ACTIONS(4975),
    [sym_string] = ACTIONS(4975),
    [sym_cstring] = ACTIONS(4975),
    [sym_dstring] = ACTIONS(4975),
    [sym_wstring] = ACTIONS(4975),
    [sym_noreturn] = ACTIONS(4975),
    [sym_true] = ACTIONS(4975),
    [sym_false] = ACTIONS(4975),
    [sym_null] = ACTIONS(4975),
    [sym_super] = ACTIONS(4975),
    [sym_this] = ACTIONS(4975),
    [sym_abstract] = ACTIONS(4975),
    [sym_alias] = ACTIONS(4975),
    [sym_align] = ACTIONS(4975),
    [sym_asm] = ACTIONS(4975),
    [sym_assert] = ACTIONS(4975),
    [sym_auto] = ACTIONS(4975),
    [sym_break] = ACTIONS(4975),
    [sym_case] = ACTIONS(4975),
    [sym_cast] = ACTIONS(4975),
    [sym_class] = ACTIONS(4975),
    [sym_const] = ACTIONS(4975),
    [sym_continue] = ACTIONS(4975),
    [sym_debug] = ACTIONS(4975),
    [sym_default] = ACTIONS(4975),
    [sym_delegate] = ACTIONS(4975),
    [sym_delete] = ACTIONS(4975),
    [sym_deprecated] = ACTIONS(4975),
    [sym_do] = ACTIONS(4975),
    [sym_else] = ACTIONS(4975),
    [sym_enum] = ACTIONS(4975),
    [sym_export] = ACTIONS(4975),
    [sym_extern] = ACTIONS(4975),
    [sym_final] = ACTIONS(4975),
    [sym_for] = ACTIONS(4975),
    [sym_foreach] = ACTIONS(4975),
    [sym_foreach_reverse] = ACTIONS(4975),
    [sym_function] = ACTIONS(4975),
    [sym_goto] = ACTIONS(4975),
    [sym_if] = ACTIONS(4975),
    [sym_immutable] = ACTIONS(4975),
    [sym_import] = ACTIONS(4975),
    [sym_in] = ACTIONS(4975),
    [sym_inout] = ACTIONS(4975),
    [sym_interface] = ACTIONS(4975),
    [sym_invariant] = ACTIONS(4975),
    [sym_is] = ACTIONS(4975),
    [sym_mixin] = ACTIONS(4975),
    [sym_new] = ACTIONS(4975),
    [sym_nothrow] = ACTIONS(4975),
    [sym_out] = ACTIONS(4975),
    [sym_override] = ACTIONS(4975),
    [sym_package] = ACTIONS(4975),
    [sym_pragma] = ACTIONS(4975),
    [sym_private] = ACTIONS(4975),
    [sym_protected] = ACTIONS(4975),
    [sym_public] = ACTIONS(4975),
    [sym_pure] = ACTIONS(4975),
    [sym_ref] = ACTIONS(4975),
    [sym_return] = ACTIONS(4975),
    [sym_scope] = ACTIONS(4975),
    [sym_shared] = ACTIONS(4975),
    [sym_static] = ACTIONS(4975),
    [sym_struct] = ACTIONS(4975),
    [sym_switch] = ACTIONS(4975),
    [sym_synchronized] = ACTIONS(4975),
    [sym_template] = ACTIONS(4975),
    [sym_throw] = ACTIONS(4975),
    [sym_try] = ACTIONS(4975),
    [sym_typeid] = ACTIONS(4975),
    [sym_typeof] = ACTIONS(4975),
    [sym_union] = ACTIONS(4975),
    [sym_unittest] = ACTIONS(4975),
    [sym_version] = ACTIONS(4975),
    [sym_while] = ACTIONS(4975),
    [sym_with] = ACTIONS(4975),
    [sym_gshared] = ACTIONS(4975),
    [sym_traits] = ACTIONS(4975),
    [sym_vector] = ACTIONS(4975),
    [sym_void] = ACTIONS(4975),
    [anon_sym_BQUOTE] = ACTIONS(4977),
    [anon_sym_r_DQUOTE] = ACTIONS(4977),
    [anon_sym_x_DQUOTE] = ACTIONS(4977),
    [anon_sym_DQUOTE] = ACTIONS(4977),
    [anon_sym_i_BQUOTE] = ACTIONS(4977),
    [anon_sym_i_DQUOTE] = ACTIONS(4977),
    [anon_sym_iq_LBRACE] = ACTIONS(4977),
    [aux_sym_char_literal_token1] = ACTIONS(4977),
    [anon_sym_SQUOTE] = ACTIONS(4975),
    [anon_sym___DATE__] = ACTIONS(4975),
    [anon_sym___FILE__] = ACTIONS(4975),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4975),
    [anon_sym___FUNCTION__] = ACTIONS(4975),
    [anon_sym___LINE__] = ACTIONS(4975),
    [anon_sym___MODULE__] = ACTIONS(4975),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4975),
    [anon_sym___TIME__] = ACTIONS(4975),
    [anon_sym___TIMESTAMP__] = ACTIONS(4975),
    [anon_sym___VENDOR__] = ACTIONS(4975),
    [anon_sym___VERSION__] = ACTIONS(4975),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4977),
    [sym_float_literal] = ACTIONS(4977),
    [sym__string] = ACTIONS(4977),
  },
  [1559] = {
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_q_LBRACE] = ACTIONS(4418),
    [anon_sym_RBRACE] = ACTIONS(4418),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_PLUS_PLUS] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(4418),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym_DOLLAR] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4418),
    [anon_sym_TILDE] = ACTIONS(4418),
    [anon_sym_AT] = ACTIONS(4418),
    [sym_bool] = ACTIONS(4416),
    [sym_byte] = ACTIONS(4416),
    [sym_ubyte] = ACTIONS(4416),
    [sym_char] = ACTIONS(4416),
    [sym_short] = ACTIONS(4416),
    [sym_ushort] = ACTIONS(4416),
    [sym_int] = ACTIONS(4416),
    [sym_uint] = ACTIONS(4416),
    [sym_long] = ACTIONS(4416),
    [sym_ulong] = ACTIONS(4416),
    [sym_cent] = ACTIONS(4416),
    [sym_ucent] = ACTIONS(4416),
    [sym_wchar] = ACTIONS(4416),
    [sym_dchar] = ACTIONS(4416),
    [sym_float] = ACTIONS(4416),
    [sym_double] = ACTIONS(4416),
    [sym_real] = ACTIONS(4416),
    [sym_ifloat] = ACTIONS(4416),
    [sym_idouble] = ACTIONS(4416),
    [sym_ireal] = ACTIONS(4416),
    [sym_cfloat] = ACTIONS(4416),
    [sym_cdouble] = ACTIONS(4416),
    [sym_creal] = ACTIONS(4416),
    [sym_size_t] = ACTIONS(4416),
    [sym_ptrdiff_t] = ACTIONS(4416),
    [sym_string] = ACTIONS(4416),
    [sym_cstring] = ACTIONS(4416),
    [sym_dstring] = ACTIONS(4416),
    [sym_wstring] = ACTIONS(4416),
    [sym_noreturn] = ACTIONS(4416),
    [sym_true] = ACTIONS(4416),
    [sym_false] = ACTIONS(4416),
    [sym_null] = ACTIONS(4416),
    [sym_super] = ACTIONS(4416),
    [sym_this] = ACTIONS(4416),
    [sym_abstract] = ACTIONS(4416),
    [sym_alias] = ACTIONS(4416),
    [sym_align] = ACTIONS(4416),
    [sym_asm] = ACTIONS(4416),
    [sym_assert] = ACTIONS(4416),
    [sym_auto] = ACTIONS(4416),
    [sym_break] = ACTIONS(4416),
    [sym_case] = ACTIONS(4416),
    [sym_cast] = ACTIONS(4416),
    [sym_class] = ACTIONS(4416),
    [sym_const] = ACTIONS(4416),
    [sym_continue] = ACTIONS(4416),
    [sym_debug] = ACTIONS(4416),
    [sym_default] = ACTIONS(4416),
    [sym_delegate] = ACTIONS(4416),
    [sym_delete] = ACTIONS(4416),
    [sym_deprecated] = ACTIONS(4416),
    [sym_do] = ACTIONS(4416),
    [sym_else] = ACTIONS(4416),
    [sym_enum] = ACTIONS(4416),
    [sym_export] = ACTIONS(4416),
    [sym_extern] = ACTIONS(4416),
    [sym_final] = ACTIONS(4416),
    [sym_for] = ACTIONS(4416),
    [sym_foreach] = ACTIONS(4416),
    [sym_foreach_reverse] = ACTIONS(4416),
    [sym_function] = ACTIONS(4416),
    [sym_goto] = ACTIONS(4416),
    [sym_if] = ACTIONS(4416),
    [sym_immutable] = ACTIONS(4416),
    [sym_import] = ACTIONS(4416),
    [sym_in] = ACTIONS(4416),
    [sym_inout] = ACTIONS(4416),
    [sym_interface] = ACTIONS(4416),
    [sym_invariant] = ACTIONS(4416),
    [sym_is] = ACTIONS(4416),
    [sym_mixin] = ACTIONS(4416),
    [sym_new] = ACTIONS(4416),
    [sym_nothrow] = ACTIONS(4416),
    [sym_out] = ACTIONS(4416),
    [sym_override] = ACTIONS(4416),
    [sym_package] = ACTIONS(4416),
    [sym_pragma] = ACTIONS(4416),
    [sym_private] = ACTIONS(4416),
    [sym_protected] = ACTIONS(4416),
    [sym_public] = ACTIONS(4416),
    [sym_pure] = ACTIONS(4416),
    [sym_ref] = ACTIONS(4416),
    [sym_return] = ACTIONS(4416),
    [sym_scope] = ACTIONS(4416),
    [sym_shared] = ACTIONS(4416),
    [sym_static] = ACTIONS(4416),
    [sym_struct] = ACTIONS(4416),
    [sym_switch] = ACTIONS(4416),
    [sym_synchronized] = ACTIONS(4416),
    [sym_template] = ACTIONS(4416),
    [sym_throw] = ACTIONS(4416),
    [sym_try] = ACTIONS(4416),
    [sym_typeid] = ACTIONS(4416),
    [sym_typeof] = ACTIONS(4416),
    [sym_union] = ACTIONS(4416),
    [sym_unittest] = ACTIONS(4416),
    [sym_version] = ACTIONS(4416),
    [sym_while] = ACTIONS(4416),
    [sym_with] = ACTIONS(4416),
    [sym_gshared] = ACTIONS(4416),
    [sym_traits] = ACTIONS(4416),
    [sym_vector] = ACTIONS(4416),
    [sym_void] = ACTIONS(4416),
    [anon_sym_BQUOTE] = ACTIONS(4418),
    [anon_sym_r_DQUOTE] = ACTIONS(4418),
    [anon_sym_x_DQUOTE] = ACTIONS(4418),
    [anon_sym_DQUOTE] = ACTIONS(4418),
    [anon_sym_i_BQUOTE] = ACTIONS(4418),
    [anon_sym_i_DQUOTE] = ACTIONS(4418),
    [anon_sym_iq_LBRACE] = ACTIONS(4418),
    [aux_sym_char_literal_token1] = ACTIONS(4418),
    [anon_sym_SQUOTE] = ACTIONS(4416),
    [anon_sym___DATE__] = ACTIONS(4416),
    [anon_sym___FILE__] = ACTIONS(4416),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4416),
    [anon_sym___FUNCTION__] = ACTIONS(4416),
    [anon_sym___LINE__] = ACTIONS(4416),
    [anon_sym___MODULE__] = ACTIONS(4416),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4416),
    [anon_sym___TIME__] = ACTIONS(4416),
    [anon_sym___TIMESTAMP__] = ACTIONS(4416),
    [anon_sym___VENDOR__] = ACTIONS(4416),
    [anon_sym___VERSION__] = ACTIONS(4416),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4418),
    [sym_float_literal] = ACTIONS(4418),
    [sym__string] = ACTIONS(4418),
  },
  [1560] = {
    [sym_identifier] = ACTIONS(4514),
    [anon_sym_q_LBRACE] = ACTIONS(4516),
    [anon_sym_RBRACE] = ACTIONS(4516),
    [anon_sym_LBRACE] = ACTIONS(4516),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_DASH] = ACTIONS(4514),
    [anon_sym_DASH_DASH] = ACTIONS(4516),
    [anon_sym_PLUS] = ACTIONS(4514),
    [anon_sym_PLUS_PLUS] = ACTIONS(4516),
    [anon_sym_BANG] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4516),
    [anon_sym_RPAREN] = ACTIONS(4516),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_SEMI] = ACTIONS(4516),
    [anon_sym_DOLLAR] = ACTIONS(4516),
    [anon_sym_STAR] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4516),
    [anon_sym_AT] = ACTIONS(4516),
    [sym_bool] = ACTIONS(4514),
    [sym_byte] = ACTIONS(4514),
    [sym_ubyte] = ACTIONS(4514),
    [sym_char] = ACTIONS(4514),
    [sym_short] = ACTIONS(4514),
    [sym_ushort] = ACTIONS(4514),
    [sym_int] = ACTIONS(4514),
    [sym_uint] = ACTIONS(4514),
    [sym_long] = ACTIONS(4514),
    [sym_ulong] = ACTIONS(4514),
    [sym_cent] = ACTIONS(4514),
    [sym_ucent] = ACTIONS(4514),
    [sym_wchar] = ACTIONS(4514),
    [sym_dchar] = ACTIONS(4514),
    [sym_float] = ACTIONS(4514),
    [sym_double] = ACTIONS(4514),
    [sym_real] = ACTIONS(4514),
    [sym_ifloat] = ACTIONS(4514),
    [sym_idouble] = ACTIONS(4514),
    [sym_ireal] = ACTIONS(4514),
    [sym_cfloat] = ACTIONS(4514),
    [sym_cdouble] = ACTIONS(4514),
    [sym_creal] = ACTIONS(4514),
    [sym_size_t] = ACTIONS(4514),
    [sym_ptrdiff_t] = ACTIONS(4514),
    [sym_string] = ACTIONS(4514),
    [sym_cstring] = ACTIONS(4514),
    [sym_dstring] = ACTIONS(4514),
    [sym_wstring] = ACTIONS(4514),
    [sym_noreturn] = ACTIONS(4514),
    [sym_true] = ACTIONS(4514),
    [sym_false] = ACTIONS(4514),
    [sym_null] = ACTIONS(4514),
    [sym_super] = ACTIONS(4514),
    [sym_this] = ACTIONS(4514),
    [sym_abstract] = ACTIONS(4514),
    [sym_alias] = ACTIONS(4514),
    [sym_align] = ACTIONS(4514),
    [sym_asm] = ACTIONS(4514),
    [sym_assert] = ACTIONS(4514),
    [sym_auto] = ACTIONS(4514),
    [sym_break] = ACTIONS(4514),
    [sym_case] = ACTIONS(4514),
    [sym_cast] = ACTIONS(4514),
    [sym_class] = ACTIONS(4514),
    [sym_const] = ACTIONS(4514),
    [sym_continue] = ACTIONS(4514),
    [sym_debug] = ACTIONS(4514),
    [sym_default] = ACTIONS(4514),
    [sym_delegate] = ACTIONS(4514),
    [sym_delete] = ACTIONS(4514),
    [sym_deprecated] = ACTIONS(4514),
    [sym_do] = ACTIONS(4514),
    [sym_else] = ACTIONS(4514),
    [sym_enum] = ACTIONS(4514),
    [sym_export] = ACTIONS(4514),
    [sym_extern] = ACTIONS(4514),
    [sym_final] = ACTIONS(4514),
    [sym_for] = ACTIONS(4514),
    [sym_foreach] = ACTIONS(4514),
    [sym_foreach_reverse] = ACTIONS(4514),
    [sym_function] = ACTIONS(4514),
    [sym_goto] = ACTIONS(4514),
    [sym_if] = ACTIONS(4514),
    [sym_immutable] = ACTIONS(4514),
    [sym_import] = ACTIONS(4514),
    [sym_in] = ACTIONS(4514),
    [sym_inout] = ACTIONS(4514),
    [sym_interface] = ACTIONS(4514),
    [sym_invariant] = ACTIONS(4514),
    [sym_is] = ACTIONS(4514),
    [sym_mixin] = ACTIONS(4514),
    [sym_new] = ACTIONS(4514),
    [sym_nothrow] = ACTIONS(4514),
    [sym_out] = ACTIONS(4514),
    [sym_override] = ACTIONS(4514),
    [sym_package] = ACTIONS(4514),
    [sym_pragma] = ACTIONS(4514),
    [sym_private] = ACTIONS(4514),
    [sym_protected] = ACTIONS(4514),
    [sym_public] = ACTIONS(4514),
    [sym_pure] = ACTIONS(4514),
    [sym_ref] = ACTIONS(4514),
    [sym_return] = ACTIONS(4514),
    [sym_scope] = ACTIONS(4514),
    [sym_shared] = ACTIONS(4514),
    [sym_static] = ACTIONS(4514),
    [sym_struct] = ACTIONS(4514),
    [sym_switch] = ACTIONS(4514),
    [sym_synchronized] = ACTIONS(4514),
    [sym_template] = ACTIONS(4514),
    [sym_throw] = ACTIONS(4514),
    [sym_try] = ACTIONS(4514),
    [sym_typeid] = ACTIONS(4514),
    [sym_typeof] = ACTIONS(4514),
    [sym_union] = ACTIONS(4514),
    [sym_unittest] = ACTIONS(4514),
    [sym_version] = ACTIONS(4514),
    [sym_while] = ACTIONS(4514),
    [sym_with] = ACTIONS(4514),
    [sym_gshared] = ACTIONS(4514),
    [sym_traits] = ACTIONS(4514),
    [sym_vector] = ACTIONS(4514),
    [sym_void] = ACTIONS(4514),
    [anon_sym_BQUOTE] = ACTIONS(4516),
    [anon_sym_r_DQUOTE] = ACTIONS(4516),
    [anon_sym_x_DQUOTE] = ACTIONS(4516),
    [anon_sym_DQUOTE] = ACTIONS(4516),
    [anon_sym_i_BQUOTE] = ACTIONS(4516),
    [anon_sym_i_DQUOTE] = ACTIONS(4516),
    [anon_sym_iq_LBRACE] = ACTIONS(4516),
    [aux_sym_char_literal_token1] = ACTIONS(4516),
    [anon_sym_SQUOTE] = ACTIONS(4514),
    [anon_sym___DATE__] = ACTIONS(4514),
    [anon_sym___FILE__] = ACTIONS(4514),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4514),
    [anon_sym___FUNCTION__] = ACTIONS(4514),
    [anon_sym___LINE__] = ACTIONS(4514),
    [anon_sym___MODULE__] = ACTIONS(4514),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4514),
    [anon_sym___TIME__] = ACTIONS(4514),
    [anon_sym___TIMESTAMP__] = ACTIONS(4514),
    [anon_sym___VENDOR__] = ACTIONS(4514),
    [anon_sym___VERSION__] = ACTIONS(4514),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4516),
    [sym_float_literal] = ACTIONS(4516),
    [sym__string] = ACTIONS(4516),
  },
  [1561] = {
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_q_LBRACE] = ACTIONS(2640),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_DOLLAR] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(2640),
    [sym_bool] = ACTIONS(2642),
    [sym_byte] = ACTIONS(2642),
    [sym_ubyte] = ACTIONS(2642),
    [sym_char] = ACTIONS(2642),
    [sym_short] = ACTIONS(2642),
    [sym_ushort] = ACTIONS(2642),
    [sym_int] = ACTIONS(2642),
    [sym_uint] = ACTIONS(2642),
    [sym_long] = ACTIONS(2642),
    [sym_ulong] = ACTIONS(2642),
    [sym_cent] = ACTIONS(2642),
    [sym_ucent] = ACTIONS(2642),
    [sym_wchar] = ACTIONS(2642),
    [sym_dchar] = ACTIONS(2642),
    [sym_float] = ACTIONS(2642),
    [sym_double] = ACTIONS(2642),
    [sym_real] = ACTIONS(2642),
    [sym_ifloat] = ACTIONS(2642),
    [sym_idouble] = ACTIONS(2642),
    [sym_ireal] = ACTIONS(2642),
    [sym_cfloat] = ACTIONS(2642),
    [sym_cdouble] = ACTIONS(2642),
    [sym_creal] = ACTIONS(2642),
    [sym_size_t] = ACTIONS(2642),
    [sym_ptrdiff_t] = ACTIONS(2642),
    [sym_string] = ACTIONS(2642),
    [sym_cstring] = ACTIONS(2642),
    [sym_dstring] = ACTIONS(2642),
    [sym_wstring] = ACTIONS(2642),
    [sym_noreturn] = ACTIONS(2642),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_this] = ACTIONS(2642),
    [sym_abstract] = ACTIONS(2642),
    [sym_alias] = ACTIONS(2642),
    [sym_align] = ACTIONS(2642),
    [sym_asm] = ACTIONS(2642),
    [sym_assert] = ACTIONS(2642),
    [sym_auto] = ACTIONS(2642),
    [sym_break] = ACTIONS(2642),
    [sym_case] = ACTIONS(2642),
    [sym_cast] = ACTIONS(2642),
    [sym_class] = ACTIONS(2642),
    [sym_const] = ACTIONS(2642),
    [sym_continue] = ACTIONS(2642),
    [sym_debug] = ACTIONS(2642),
    [sym_default] = ACTIONS(2642),
    [sym_delegate] = ACTIONS(2642),
    [sym_delete] = ACTIONS(2642),
    [sym_deprecated] = ACTIONS(2642),
    [sym_do] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(2642),
    [sym_export] = ACTIONS(2642),
    [sym_extern] = ACTIONS(2642),
    [sym_final] = ACTIONS(2642),
    [sym_for] = ACTIONS(2642),
    [sym_foreach] = ACTIONS(2642),
    [sym_foreach_reverse] = ACTIONS(2642),
    [sym_function] = ACTIONS(2642),
    [sym_goto] = ACTIONS(2642),
    [sym_if] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(2642),
    [sym_import] = ACTIONS(2642),
    [sym_in] = ACTIONS(2642),
    [sym_inout] = ACTIONS(2642),
    [sym_interface] = ACTIONS(2642),
    [sym_invariant] = ACTIONS(2642),
    [sym_is] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2642),
    [sym_new] = ACTIONS(2642),
    [sym_nothrow] = ACTIONS(2642),
    [sym_out] = ACTIONS(2642),
    [sym_override] = ACTIONS(2642),
    [sym_package] = ACTIONS(2642),
    [sym_pragma] = ACTIONS(2642),
    [sym_private] = ACTIONS(2642),
    [sym_protected] = ACTIONS(2642),
    [sym_public] = ACTIONS(2642),
    [sym_pure] = ACTIONS(2642),
    [sym_ref] = ACTIONS(2642),
    [sym_return] = ACTIONS(2642),
    [sym_scope] = ACTIONS(2642),
    [sym_shared] = ACTIONS(2642),
    [sym_static] = ACTIONS(2642),
    [sym_struct] = ACTIONS(2642),
    [sym_switch] = ACTIONS(2642),
    [sym_synchronized] = ACTIONS(2642),
    [sym_template] = ACTIONS(2642),
    [sym_throw] = ACTIONS(2642),
    [sym_try] = ACTIONS(2642),
    [sym_typeid] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(2642),
    [sym_union] = ACTIONS(2642),
    [sym_unittest] = ACTIONS(2642),
    [sym_version] = ACTIONS(2642),
    [sym_while] = ACTIONS(2642),
    [sym_with] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(2642),
    [sym_traits] = ACTIONS(2642),
    [sym_vector] = ACTIONS(2642),
    [sym_void] = ACTIONS(2642),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [anon_sym_r_DQUOTE] = ACTIONS(2640),
    [anon_sym_x_DQUOTE] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_i_BQUOTE] = ACTIONS(2640),
    [anon_sym_i_DQUOTE] = ACTIONS(2640),
    [anon_sym_iq_LBRACE] = ACTIONS(2640),
    [aux_sym_char_literal_token1] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym___DATE__] = ACTIONS(2642),
    [anon_sym___FILE__] = ACTIONS(2642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2642),
    [anon_sym___FUNCTION__] = ACTIONS(2642),
    [anon_sym___LINE__] = ACTIONS(2642),
    [anon_sym___MODULE__] = ACTIONS(2642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2642),
    [anon_sym___TIME__] = ACTIONS(2642),
    [anon_sym___TIMESTAMP__] = ACTIONS(2642),
    [anon_sym___VENDOR__] = ACTIONS(2642),
    [anon_sym___VERSION__] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2640),
    [sym_float_literal] = ACTIONS(2640),
    [sym__string] = ACTIONS(2640),
  },
  [1562] = {
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_q_LBRACE] = ACTIONS(4390),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_LBRACE] = ACTIONS(4390),
    [anon_sym_DOT] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4388),
    [anon_sym_DASH_DASH] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4388),
    [anon_sym_PLUS_PLUS] = ACTIONS(4390),
    [anon_sym_BANG] = ACTIONS(4390),
    [anon_sym_LPAREN] = ACTIONS(4390),
    [anon_sym_RPAREN] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4390),
    [anon_sym_DOLLAR] = ACTIONS(4390),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_TILDE] = ACTIONS(4390),
    [anon_sym_AT] = ACTIONS(4390),
    [sym_bool] = ACTIONS(4388),
    [sym_byte] = ACTIONS(4388),
    [sym_ubyte] = ACTIONS(4388),
    [sym_char] = ACTIONS(4388),
    [sym_short] = ACTIONS(4388),
    [sym_ushort] = ACTIONS(4388),
    [sym_int] = ACTIONS(4388),
    [sym_uint] = ACTIONS(4388),
    [sym_long] = ACTIONS(4388),
    [sym_ulong] = ACTIONS(4388),
    [sym_cent] = ACTIONS(4388),
    [sym_ucent] = ACTIONS(4388),
    [sym_wchar] = ACTIONS(4388),
    [sym_dchar] = ACTIONS(4388),
    [sym_float] = ACTIONS(4388),
    [sym_double] = ACTIONS(4388),
    [sym_real] = ACTIONS(4388),
    [sym_ifloat] = ACTIONS(4388),
    [sym_idouble] = ACTIONS(4388),
    [sym_ireal] = ACTIONS(4388),
    [sym_cfloat] = ACTIONS(4388),
    [sym_cdouble] = ACTIONS(4388),
    [sym_creal] = ACTIONS(4388),
    [sym_size_t] = ACTIONS(4388),
    [sym_ptrdiff_t] = ACTIONS(4388),
    [sym_string] = ACTIONS(4388),
    [sym_cstring] = ACTIONS(4388),
    [sym_dstring] = ACTIONS(4388),
    [sym_wstring] = ACTIONS(4388),
    [sym_noreturn] = ACTIONS(4388),
    [sym_true] = ACTIONS(4388),
    [sym_false] = ACTIONS(4388),
    [sym_null] = ACTIONS(4388),
    [sym_super] = ACTIONS(4388),
    [sym_this] = ACTIONS(4388),
    [sym_abstract] = ACTIONS(4388),
    [sym_alias] = ACTIONS(4388),
    [sym_align] = ACTIONS(4388),
    [sym_asm] = ACTIONS(4388),
    [sym_assert] = ACTIONS(4388),
    [sym_auto] = ACTIONS(4388),
    [sym_break] = ACTIONS(4388),
    [sym_case] = ACTIONS(4388),
    [sym_cast] = ACTIONS(4388),
    [sym_class] = ACTIONS(4388),
    [sym_const] = ACTIONS(4388),
    [sym_continue] = ACTIONS(4388),
    [sym_debug] = ACTIONS(4388),
    [sym_default] = ACTIONS(4388),
    [sym_delegate] = ACTIONS(4388),
    [sym_delete] = ACTIONS(4388),
    [sym_deprecated] = ACTIONS(4388),
    [sym_do] = ACTIONS(4388),
    [sym_else] = ACTIONS(4388),
    [sym_enum] = ACTIONS(4388),
    [sym_export] = ACTIONS(4388),
    [sym_extern] = ACTIONS(4388),
    [sym_final] = ACTIONS(4388),
    [sym_for] = ACTIONS(4388),
    [sym_foreach] = ACTIONS(4388),
    [sym_foreach_reverse] = ACTIONS(4388),
    [sym_function] = ACTIONS(4388),
    [sym_goto] = ACTIONS(4388),
    [sym_if] = ACTIONS(4388),
    [sym_immutable] = ACTIONS(4388),
    [sym_import] = ACTIONS(4388),
    [sym_in] = ACTIONS(4388),
    [sym_inout] = ACTIONS(4388),
    [sym_interface] = ACTIONS(4388),
    [sym_invariant] = ACTIONS(4388),
    [sym_is] = ACTIONS(4388),
    [sym_mixin] = ACTIONS(4388),
    [sym_new] = ACTIONS(4388),
    [sym_nothrow] = ACTIONS(4388),
    [sym_out] = ACTIONS(4388),
    [sym_override] = ACTIONS(4388),
    [sym_package] = ACTIONS(4388),
    [sym_pragma] = ACTIONS(4388),
    [sym_private] = ACTIONS(4388),
    [sym_protected] = ACTIONS(4388),
    [sym_public] = ACTIONS(4388),
    [sym_pure] = ACTIONS(4388),
    [sym_ref] = ACTIONS(4388),
    [sym_return] = ACTIONS(4388),
    [sym_scope] = ACTIONS(4388),
    [sym_shared] = ACTIONS(4388),
    [sym_static] = ACTIONS(4388),
    [sym_struct] = ACTIONS(4388),
    [sym_switch] = ACTIONS(4388),
    [sym_synchronized] = ACTIONS(4388),
    [sym_template] = ACTIONS(4388),
    [sym_throw] = ACTIONS(4388),
    [sym_try] = ACTIONS(4388),
    [sym_typeid] = ACTIONS(4388),
    [sym_typeof] = ACTIONS(4388),
    [sym_union] = ACTIONS(4388),
    [sym_unittest] = ACTIONS(4388),
    [sym_version] = ACTIONS(4388),
    [sym_while] = ACTIONS(4388),
    [sym_with] = ACTIONS(4388),
    [sym_gshared] = ACTIONS(4388),
    [sym_traits] = ACTIONS(4388),
    [sym_vector] = ACTIONS(4388),
    [sym_void] = ACTIONS(4388),
    [anon_sym_BQUOTE] = ACTIONS(4390),
    [anon_sym_r_DQUOTE] = ACTIONS(4390),
    [anon_sym_x_DQUOTE] = ACTIONS(4390),
    [anon_sym_DQUOTE] = ACTIONS(4390),
    [anon_sym_i_BQUOTE] = ACTIONS(4390),
    [anon_sym_i_DQUOTE] = ACTIONS(4390),
    [anon_sym_iq_LBRACE] = ACTIONS(4390),
    [aux_sym_char_literal_token1] = ACTIONS(4390),
    [anon_sym_SQUOTE] = ACTIONS(4388),
    [anon_sym___DATE__] = ACTIONS(4388),
    [anon_sym___FILE__] = ACTIONS(4388),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4388),
    [anon_sym___FUNCTION__] = ACTIONS(4388),
    [anon_sym___LINE__] = ACTIONS(4388),
    [anon_sym___MODULE__] = ACTIONS(4388),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4388),
    [anon_sym___TIME__] = ACTIONS(4388),
    [anon_sym___TIMESTAMP__] = ACTIONS(4388),
    [anon_sym___VENDOR__] = ACTIONS(4388),
    [anon_sym___VERSION__] = ACTIONS(4388),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4390),
    [sym_float_literal] = ACTIONS(4390),
    [sym__string] = ACTIONS(4390),
  },
  [1563] = {
    [sym_identifier] = ACTIONS(4502),
    [anon_sym_q_LBRACE] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4504),
    [anon_sym_AMP] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_BANG] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_DOLLAR] = ACTIONS(4504),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4504),
    [anon_sym_AT] = ACTIONS(4504),
    [sym_bool] = ACTIONS(4502),
    [sym_byte] = ACTIONS(4502),
    [sym_ubyte] = ACTIONS(4502),
    [sym_char] = ACTIONS(4502),
    [sym_short] = ACTIONS(4502),
    [sym_ushort] = ACTIONS(4502),
    [sym_int] = ACTIONS(4502),
    [sym_uint] = ACTIONS(4502),
    [sym_long] = ACTIONS(4502),
    [sym_ulong] = ACTIONS(4502),
    [sym_cent] = ACTIONS(4502),
    [sym_ucent] = ACTIONS(4502),
    [sym_wchar] = ACTIONS(4502),
    [sym_dchar] = ACTIONS(4502),
    [sym_float] = ACTIONS(4502),
    [sym_double] = ACTIONS(4502),
    [sym_real] = ACTIONS(4502),
    [sym_ifloat] = ACTIONS(4502),
    [sym_idouble] = ACTIONS(4502),
    [sym_ireal] = ACTIONS(4502),
    [sym_cfloat] = ACTIONS(4502),
    [sym_cdouble] = ACTIONS(4502),
    [sym_creal] = ACTIONS(4502),
    [sym_size_t] = ACTIONS(4502),
    [sym_ptrdiff_t] = ACTIONS(4502),
    [sym_string] = ACTIONS(4502),
    [sym_cstring] = ACTIONS(4502),
    [sym_dstring] = ACTIONS(4502),
    [sym_wstring] = ACTIONS(4502),
    [sym_noreturn] = ACTIONS(4502),
    [sym_true] = ACTIONS(4502),
    [sym_false] = ACTIONS(4502),
    [sym_null] = ACTIONS(4502),
    [sym_super] = ACTIONS(4502),
    [sym_this] = ACTIONS(4502),
    [sym_abstract] = ACTIONS(4502),
    [sym_alias] = ACTIONS(4502),
    [sym_align] = ACTIONS(4502),
    [sym_asm] = ACTIONS(4502),
    [sym_assert] = ACTIONS(4502),
    [sym_auto] = ACTIONS(4502),
    [sym_break] = ACTIONS(4502),
    [sym_case] = ACTIONS(4502),
    [sym_cast] = ACTIONS(4502),
    [sym_class] = ACTIONS(4502),
    [sym_const] = ACTIONS(4502),
    [sym_continue] = ACTIONS(4502),
    [sym_debug] = ACTIONS(4502),
    [sym_default] = ACTIONS(4502),
    [sym_delegate] = ACTIONS(4502),
    [sym_delete] = ACTIONS(4502),
    [sym_deprecated] = ACTIONS(4502),
    [sym_do] = ACTIONS(4502),
    [sym_else] = ACTIONS(4502),
    [sym_enum] = ACTIONS(4502),
    [sym_export] = ACTIONS(4502),
    [sym_extern] = ACTIONS(4502),
    [sym_final] = ACTIONS(4502),
    [sym_for] = ACTIONS(4502),
    [sym_foreach] = ACTIONS(4502),
    [sym_foreach_reverse] = ACTIONS(4502),
    [sym_function] = ACTIONS(4502),
    [sym_goto] = ACTIONS(4502),
    [sym_if] = ACTIONS(4502),
    [sym_immutable] = ACTIONS(4502),
    [sym_import] = ACTIONS(4502),
    [sym_in] = ACTIONS(4502),
    [sym_inout] = ACTIONS(4502),
    [sym_interface] = ACTIONS(4502),
    [sym_invariant] = ACTIONS(4502),
    [sym_is] = ACTIONS(4502),
    [sym_mixin] = ACTIONS(4502),
    [sym_new] = ACTIONS(4502),
    [sym_nothrow] = ACTIONS(4502),
    [sym_out] = ACTIONS(4502),
    [sym_override] = ACTIONS(4502),
    [sym_package] = ACTIONS(4502),
    [sym_pragma] = ACTIONS(4502),
    [sym_private] = ACTIONS(4502),
    [sym_protected] = ACTIONS(4502),
    [sym_public] = ACTIONS(4502),
    [sym_pure] = ACTIONS(4502),
    [sym_ref] = ACTIONS(4502),
    [sym_return] = ACTIONS(4502),
    [sym_scope] = ACTIONS(4502),
    [sym_shared] = ACTIONS(4502),
    [sym_static] = ACTIONS(4502),
    [sym_struct] = ACTIONS(4502),
    [sym_switch] = ACTIONS(4502),
    [sym_synchronized] = ACTIONS(4502),
    [sym_template] = ACTIONS(4502),
    [sym_throw] = ACTIONS(4502),
    [sym_try] = ACTIONS(4502),
    [sym_typeid] = ACTIONS(4502),
    [sym_typeof] = ACTIONS(4502),
    [sym_union] = ACTIONS(4502),
    [sym_unittest] = ACTIONS(4502),
    [sym_version] = ACTIONS(4502),
    [sym_while] = ACTIONS(4502),
    [sym_with] = ACTIONS(4502),
    [sym_gshared] = ACTIONS(4502),
    [sym_traits] = ACTIONS(4502),
    [sym_vector] = ACTIONS(4502),
    [sym_void] = ACTIONS(4502),
    [anon_sym_BQUOTE] = ACTIONS(4504),
    [anon_sym_r_DQUOTE] = ACTIONS(4504),
    [anon_sym_x_DQUOTE] = ACTIONS(4504),
    [anon_sym_DQUOTE] = ACTIONS(4504),
    [anon_sym_i_BQUOTE] = ACTIONS(4504),
    [anon_sym_i_DQUOTE] = ACTIONS(4504),
    [anon_sym_iq_LBRACE] = ACTIONS(4504),
    [aux_sym_char_literal_token1] = ACTIONS(4504),
    [anon_sym_SQUOTE] = ACTIONS(4502),
    [anon_sym___DATE__] = ACTIONS(4502),
    [anon_sym___FILE__] = ACTIONS(4502),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4502),
    [anon_sym___FUNCTION__] = ACTIONS(4502),
    [anon_sym___LINE__] = ACTIONS(4502),
    [anon_sym___MODULE__] = ACTIONS(4502),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4502),
    [anon_sym___TIME__] = ACTIONS(4502),
    [anon_sym___TIMESTAMP__] = ACTIONS(4502),
    [anon_sym___VENDOR__] = ACTIONS(4502),
    [anon_sym___VERSION__] = ACTIONS(4502),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4504),
    [sym_float_literal] = ACTIONS(4504),
    [sym__string] = ACTIONS(4504),
  },
  [1564] = {
    [sym_identifier] = ACTIONS(4498),
    [anon_sym_q_LBRACE] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4500),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_BANG] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_DOLLAR] = ACTIONS(4500),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4500),
    [anon_sym_AT] = ACTIONS(4500),
    [sym_bool] = ACTIONS(4498),
    [sym_byte] = ACTIONS(4498),
    [sym_ubyte] = ACTIONS(4498),
    [sym_char] = ACTIONS(4498),
    [sym_short] = ACTIONS(4498),
    [sym_ushort] = ACTIONS(4498),
    [sym_int] = ACTIONS(4498),
    [sym_uint] = ACTIONS(4498),
    [sym_long] = ACTIONS(4498),
    [sym_ulong] = ACTIONS(4498),
    [sym_cent] = ACTIONS(4498),
    [sym_ucent] = ACTIONS(4498),
    [sym_wchar] = ACTIONS(4498),
    [sym_dchar] = ACTIONS(4498),
    [sym_float] = ACTIONS(4498),
    [sym_double] = ACTIONS(4498),
    [sym_real] = ACTIONS(4498),
    [sym_ifloat] = ACTIONS(4498),
    [sym_idouble] = ACTIONS(4498),
    [sym_ireal] = ACTIONS(4498),
    [sym_cfloat] = ACTIONS(4498),
    [sym_cdouble] = ACTIONS(4498),
    [sym_creal] = ACTIONS(4498),
    [sym_size_t] = ACTIONS(4498),
    [sym_ptrdiff_t] = ACTIONS(4498),
    [sym_string] = ACTIONS(4498),
    [sym_cstring] = ACTIONS(4498),
    [sym_dstring] = ACTIONS(4498),
    [sym_wstring] = ACTIONS(4498),
    [sym_noreturn] = ACTIONS(4498),
    [sym_true] = ACTIONS(4498),
    [sym_false] = ACTIONS(4498),
    [sym_null] = ACTIONS(4498),
    [sym_super] = ACTIONS(4498),
    [sym_this] = ACTIONS(4498),
    [sym_abstract] = ACTIONS(4498),
    [sym_alias] = ACTIONS(4498),
    [sym_align] = ACTIONS(4498),
    [sym_asm] = ACTIONS(4498),
    [sym_assert] = ACTIONS(4498),
    [sym_auto] = ACTIONS(4498),
    [sym_break] = ACTIONS(4498),
    [sym_case] = ACTIONS(4498),
    [sym_cast] = ACTIONS(4498),
    [sym_class] = ACTIONS(4498),
    [sym_const] = ACTIONS(4498),
    [sym_continue] = ACTIONS(4498),
    [sym_debug] = ACTIONS(4498),
    [sym_default] = ACTIONS(4498),
    [sym_delegate] = ACTIONS(4498),
    [sym_delete] = ACTIONS(4498),
    [sym_deprecated] = ACTIONS(4498),
    [sym_do] = ACTIONS(4498),
    [sym_else] = ACTIONS(4498),
    [sym_enum] = ACTIONS(4498),
    [sym_export] = ACTIONS(4498),
    [sym_extern] = ACTIONS(4498),
    [sym_final] = ACTIONS(4498),
    [sym_for] = ACTIONS(4498),
    [sym_foreach] = ACTIONS(4498),
    [sym_foreach_reverse] = ACTIONS(4498),
    [sym_function] = ACTIONS(4498),
    [sym_goto] = ACTIONS(4498),
    [sym_if] = ACTIONS(4498),
    [sym_immutable] = ACTIONS(4498),
    [sym_import] = ACTIONS(4498),
    [sym_in] = ACTIONS(4498),
    [sym_inout] = ACTIONS(4498),
    [sym_interface] = ACTIONS(4498),
    [sym_invariant] = ACTIONS(4498),
    [sym_is] = ACTIONS(4498),
    [sym_mixin] = ACTIONS(4498),
    [sym_new] = ACTIONS(4498),
    [sym_nothrow] = ACTIONS(4498),
    [sym_out] = ACTIONS(4498),
    [sym_override] = ACTIONS(4498),
    [sym_package] = ACTIONS(4498),
    [sym_pragma] = ACTIONS(4498),
    [sym_private] = ACTIONS(4498),
    [sym_protected] = ACTIONS(4498),
    [sym_public] = ACTIONS(4498),
    [sym_pure] = ACTIONS(4498),
    [sym_ref] = ACTIONS(4498),
    [sym_return] = ACTIONS(4498),
    [sym_scope] = ACTIONS(4498),
    [sym_shared] = ACTIONS(4498),
    [sym_static] = ACTIONS(4498),
    [sym_struct] = ACTIONS(4498),
    [sym_switch] = ACTIONS(4498),
    [sym_synchronized] = ACTIONS(4498),
    [sym_template] = ACTIONS(4498),
    [sym_throw] = ACTIONS(4498),
    [sym_try] = ACTIONS(4498),
    [sym_typeid] = ACTIONS(4498),
    [sym_typeof] = ACTIONS(4498),
    [sym_union] = ACTIONS(4498),
    [sym_unittest] = ACTIONS(4498),
    [sym_version] = ACTIONS(4498),
    [sym_while] = ACTIONS(4498),
    [sym_with] = ACTIONS(4498),
    [sym_gshared] = ACTIONS(4498),
    [sym_traits] = ACTIONS(4498),
    [sym_vector] = ACTIONS(4498),
    [sym_void] = ACTIONS(4498),
    [anon_sym_BQUOTE] = ACTIONS(4500),
    [anon_sym_r_DQUOTE] = ACTIONS(4500),
    [anon_sym_x_DQUOTE] = ACTIONS(4500),
    [anon_sym_DQUOTE] = ACTIONS(4500),
    [anon_sym_i_BQUOTE] = ACTIONS(4500),
    [anon_sym_i_DQUOTE] = ACTIONS(4500),
    [anon_sym_iq_LBRACE] = ACTIONS(4500),
    [aux_sym_char_literal_token1] = ACTIONS(4500),
    [anon_sym_SQUOTE] = ACTIONS(4498),
    [anon_sym___DATE__] = ACTIONS(4498),
    [anon_sym___FILE__] = ACTIONS(4498),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4498),
    [anon_sym___FUNCTION__] = ACTIONS(4498),
    [anon_sym___LINE__] = ACTIONS(4498),
    [anon_sym___MODULE__] = ACTIONS(4498),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4498),
    [anon_sym___TIME__] = ACTIONS(4498),
    [anon_sym___TIMESTAMP__] = ACTIONS(4498),
    [anon_sym___VENDOR__] = ACTIONS(4498),
    [anon_sym___VERSION__] = ACTIONS(4498),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4500),
    [sym_float_literal] = ACTIONS(4500),
    [sym__string] = ACTIONS(4500),
  },
  [1565] = {
    [sym_identifier] = ACTIONS(4494),
    [anon_sym_q_LBRACE] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AT] = ACTIONS(4496),
    [sym_bool] = ACTIONS(4494),
    [sym_byte] = ACTIONS(4494),
    [sym_ubyte] = ACTIONS(4494),
    [sym_char] = ACTIONS(4494),
    [sym_short] = ACTIONS(4494),
    [sym_ushort] = ACTIONS(4494),
    [sym_int] = ACTIONS(4494),
    [sym_uint] = ACTIONS(4494),
    [sym_long] = ACTIONS(4494),
    [sym_ulong] = ACTIONS(4494),
    [sym_cent] = ACTIONS(4494),
    [sym_ucent] = ACTIONS(4494),
    [sym_wchar] = ACTIONS(4494),
    [sym_dchar] = ACTIONS(4494),
    [sym_float] = ACTIONS(4494),
    [sym_double] = ACTIONS(4494),
    [sym_real] = ACTIONS(4494),
    [sym_ifloat] = ACTIONS(4494),
    [sym_idouble] = ACTIONS(4494),
    [sym_ireal] = ACTIONS(4494),
    [sym_cfloat] = ACTIONS(4494),
    [sym_cdouble] = ACTIONS(4494),
    [sym_creal] = ACTIONS(4494),
    [sym_size_t] = ACTIONS(4494),
    [sym_ptrdiff_t] = ACTIONS(4494),
    [sym_string] = ACTIONS(4494),
    [sym_cstring] = ACTIONS(4494),
    [sym_dstring] = ACTIONS(4494),
    [sym_wstring] = ACTIONS(4494),
    [sym_noreturn] = ACTIONS(4494),
    [sym_true] = ACTIONS(4494),
    [sym_false] = ACTIONS(4494),
    [sym_null] = ACTIONS(4494),
    [sym_super] = ACTIONS(4494),
    [sym_this] = ACTIONS(4494),
    [sym_abstract] = ACTIONS(4494),
    [sym_alias] = ACTIONS(4494),
    [sym_align] = ACTIONS(4494),
    [sym_asm] = ACTIONS(4494),
    [sym_assert] = ACTIONS(4494),
    [sym_auto] = ACTIONS(4494),
    [sym_break] = ACTIONS(4494),
    [sym_case] = ACTIONS(4494),
    [sym_cast] = ACTIONS(4494),
    [sym_class] = ACTIONS(4494),
    [sym_const] = ACTIONS(4494),
    [sym_continue] = ACTIONS(4494),
    [sym_debug] = ACTIONS(4494),
    [sym_default] = ACTIONS(4494),
    [sym_delegate] = ACTIONS(4494),
    [sym_delete] = ACTIONS(4494),
    [sym_deprecated] = ACTIONS(4494),
    [sym_do] = ACTIONS(4494),
    [sym_else] = ACTIONS(4494),
    [sym_enum] = ACTIONS(4494),
    [sym_export] = ACTIONS(4494),
    [sym_extern] = ACTIONS(4494),
    [sym_final] = ACTIONS(4494),
    [sym_for] = ACTIONS(4494),
    [sym_foreach] = ACTIONS(4494),
    [sym_foreach_reverse] = ACTIONS(4494),
    [sym_function] = ACTIONS(4494),
    [sym_goto] = ACTIONS(4494),
    [sym_if] = ACTIONS(4494),
    [sym_immutable] = ACTIONS(4494),
    [sym_import] = ACTIONS(4494),
    [sym_in] = ACTIONS(4494),
    [sym_inout] = ACTIONS(4494),
    [sym_interface] = ACTIONS(4494),
    [sym_invariant] = ACTIONS(4494),
    [sym_is] = ACTIONS(4494),
    [sym_mixin] = ACTIONS(4494),
    [sym_new] = ACTIONS(4494),
    [sym_nothrow] = ACTIONS(4494),
    [sym_out] = ACTIONS(4494),
    [sym_override] = ACTIONS(4494),
    [sym_package] = ACTIONS(4494),
    [sym_pragma] = ACTIONS(4494),
    [sym_private] = ACTIONS(4494),
    [sym_protected] = ACTIONS(4494),
    [sym_public] = ACTIONS(4494),
    [sym_pure] = ACTIONS(4494),
    [sym_ref] = ACTIONS(4494),
    [sym_return] = ACTIONS(4494),
    [sym_scope] = ACTIONS(4494),
    [sym_shared] = ACTIONS(4494),
    [sym_static] = ACTIONS(4494),
    [sym_struct] = ACTIONS(4494),
    [sym_switch] = ACTIONS(4494),
    [sym_synchronized] = ACTIONS(4494),
    [sym_template] = ACTIONS(4494),
    [sym_throw] = ACTIONS(4494),
    [sym_try] = ACTIONS(4494),
    [sym_typeid] = ACTIONS(4494),
    [sym_typeof] = ACTIONS(4494),
    [sym_union] = ACTIONS(4494),
    [sym_unittest] = ACTIONS(4494),
    [sym_version] = ACTIONS(4494),
    [sym_while] = ACTIONS(4494),
    [sym_with] = ACTIONS(4494),
    [sym_gshared] = ACTIONS(4494),
    [sym_traits] = ACTIONS(4494),
    [sym_vector] = ACTIONS(4494),
    [sym_void] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [anon_sym_r_DQUOTE] = ACTIONS(4496),
    [anon_sym_x_DQUOTE] = ACTIONS(4496),
    [anon_sym_DQUOTE] = ACTIONS(4496),
    [anon_sym_i_BQUOTE] = ACTIONS(4496),
    [anon_sym_i_DQUOTE] = ACTIONS(4496),
    [anon_sym_iq_LBRACE] = ACTIONS(4496),
    [aux_sym_char_literal_token1] = ACTIONS(4496),
    [anon_sym_SQUOTE] = ACTIONS(4494),
    [anon_sym___DATE__] = ACTIONS(4494),
    [anon_sym___FILE__] = ACTIONS(4494),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4494),
    [anon_sym___FUNCTION__] = ACTIONS(4494),
    [anon_sym___LINE__] = ACTIONS(4494),
    [anon_sym___MODULE__] = ACTIONS(4494),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4494),
    [anon_sym___TIME__] = ACTIONS(4494),
    [anon_sym___TIMESTAMP__] = ACTIONS(4494),
    [anon_sym___VENDOR__] = ACTIONS(4494),
    [anon_sym___VERSION__] = ACTIONS(4494),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4496),
    [sym_float_literal] = ACTIONS(4496),
    [sym__string] = ACTIONS(4496),
  },
  [1566] = {
    [sym_identifier] = ACTIONS(4490),
    [anon_sym_q_LBRACE] = ACTIONS(4492),
    [anon_sym_RBRACE] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4492),
    [anon_sym_DOT] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4492),
    [anon_sym_DASH] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4492),
    [anon_sym_PLUS] = ACTIONS(4490),
    [anon_sym_PLUS_PLUS] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4492),
    [anon_sym_LPAREN] = ACTIONS(4492),
    [anon_sym_RPAREN] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_SEMI] = ACTIONS(4492),
    [anon_sym_DOLLAR] = ACTIONS(4492),
    [anon_sym_STAR] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4492),
    [anon_sym_AT] = ACTIONS(4492),
    [sym_bool] = ACTIONS(4490),
    [sym_byte] = ACTIONS(4490),
    [sym_ubyte] = ACTIONS(4490),
    [sym_char] = ACTIONS(4490),
    [sym_short] = ACTIONS(4490),
    [sym_ushort] = ACTIONS(4490),
    [sym_int] = ACTIONS(4490),
    [sym_uint] = ACTIONS(4490),
    [sym_long] = ACTIONS(4490),
    [sym_ulong] = ACTIONS(4490),
    [sym_cent] = ACTIONS(4490),
    [sym_ucent] = ACTIONS(4490),
    [sym_wchar] = ACTIONS(4490),
    [sym_dchar] = ACTIONS(4490),
    [sym_float] = ACTIONS(4490),
    [sym_double] = ACTIONS(4490),
    [sym_real] = ACTIONS(4490),
    [sym_ifloat] = ACTIONS(4490),
    [sym_idouble] = ACTIONS(4490),
    [sym_ireal] = ACTIONS(4490),
    [sym_cfloat] = ACTIONS(4490),
    [sym_cdouble] = ACTIONS(4490),
    [sym_creal] = ACTIONS(4490),
    [sym_size_t] = ACTIONS(4490),
    [sym_ptrdiff_t] = ACTIONS(4490),
    [sym_string] = ACTIONS(4490),
    [sym_cstring] = ACTIONS(4490),
    [sym_dstring] = ACTIONS(4490),
    [sym_wstring] = ACTIONS(4490),
    [sym_noreturn] = ACTIONS(4490),
    [sym_true] = ACTIONS(4490),
    [sym_false] = ACTIONS(4490),
    [sym_null] = ACTIONS(4490),
    [sym_super] = ACTIONS(4490),
    [sym_this] = ACTIONS(4490),
    [sym_abstract] = ACTIONS(4490),
    [sym_alias] = ACTIONS(4490),
    [sym_align] = ACTIONS(4490),
    [sym_asm] = ACTIONS(4490),
    [sym_assert] = ACTIONS(4490),
    [sym_auto] = ACTIONS(4490),
    [sym_break] = ACTIONS(4490),
    [sym_case] = ACTIONS(4490),
    [sym_cast] = ACTIONS(4490),
    [sym_class] = ACTIONS(4490),
    [sym_const] = ACTIONS(4490),
    [sym_continue] = ACTIONS(4490),
    [sym_debug] = ACTIONS(4490),
    [sym_default] = ACTIONS(4490),
    [sym_delegate] = ACTIONS(4490),
    [sym_delete] = ACTIONS(4490),
    [sym_deprecated] = ACTIONS(4490),
    [sym_do] = ACTIONS(4490),
    [sym_else] = ACTIONS(4490),
    [sym_enum] = ACTIONS(4490),
    [sym_export] = ACTIONS(4490),
    [sym_extern] = ACTIONS(4490),
    [sym_final] = ACTIONS(4490),
    [sym_for] = ACTIONS(4490),
    [sym_foreach] = ACTIONS(4490),
    [sym_foreach_reverse] = ACTIONS(4490),
    [sym_function] = ACTIONS(4490),
    [sym_goto] = ACTIONS(4490),
    [sym_if] = ACTIONS(4490),
    [sym_immutable] = ACTIONS(4490),
    [sym_import] = ACTIONS(4490),
    [sym_in] = ACTIONS(4490),
    [sym_inout] = ACTIONS(4490),
    [sym_interface] = ACTIONS(4490),
    [sym_invariant] = ACTIONS(4490),
    [sym_is] = ACTIONS(4490),
    [sym_mixin] = ACTIONS(4490),
    [sym_new] = ACTIONS(4490),
    [sym_nothrow] = ACTIONS(4490),
    [sym_out] = ACTIONS(4490),
    [sym_override] = ACTIONS(4490),
    [sym_package] = ACTIONS(4490),
    [sym_pragma] = ACTIONS(4490),
    [sym_private] = ACTIONS(4490),
    [sym_protected] = ACTIONS(4490),
    [sym_public] = ACTIONS(4490),
    [sym_pure] = ACTIONS(4490),
    [sym_ref] = ACTIONS(4490),
    [sym_return] = ACTIONS(4490),
    [sym_scope] = ACTIONS(4490),
    [sym_shared] = ACTIONS(4490),
    [sym_static] = ACTIONS(4490),
    [sym_struct] = ACTIONS(4490),
    [sym_switch] = ACTIONS(4490),
    [sym_synchronized] = ACTIONS(4490),
    [sym_template] = ACTIONS(4490),
    [sym_throw] = ACTIONS(4490),
    [sym_try] = ACTIONS(4490),
    [sym_typeid] = ACTIONS(4490),
    [sym_typeof] = ACTIONS(4490),
    [sym_union] = ACTIONS(4490),
    [sym_unittest] = ACTIONS(4490),
    [sym_version] = ACTIONS(4490),
    [sym_while] = ACTIONS(4490),
    [sym_with] = ACTIONS(4490),
    [sym_gshared] = ACTIONS(4490),
    [sym_traits] = ACTIONS(4490),
    [sym_vector] = ACTIONS(4490),
    [sym_void] = ACTIONS(4490),
    [anon_sym_BQUOTE] = ACTIONS(4492),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_x_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE] = ACTIONS(4492),
    [anon_sym_i_BQUOTE] = ACTIONS(4492),
    [anon_sym_i_DQUOTE] = ACTIONS(4492),
    [anon_sym_iq_LBRACE] = ACTIONS(4492),
    [aux_sym_char_literal_token1] = ACTIONS(4492),
    [anon_sym_SQUOTE] = ACTIONS(4490),
    [anon_sym___DATE__] = ACTIONS(4490),
    [anon_sym___FILE__] = ACTIONS(4490),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4490),
    [anon_sym___FUNCTION__] = ACTIONS(4490),
    [anon_sym___LINE__] = ACTIONS(4490),
    [anon_sym___MODULE__] = ACTIONS(4490),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4490),
    [anon_sym___TIME__] = ACTIONS(4490),
    [anon_sym___TIMESTAMP__] = ACTIONS(4490),
    [anon_sym___VENDOR__] = ACTIONS(4490),
    [anon_sym___VERSION__] = ACTIONS(4490),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4492),
    [sym_float_literal] = ACTIONS(4492),
    [sym__string] = ACTIONS(4492),
  },
  [1567] = {
    [sym_identifier] = ACTIONS(4384),
    [anon_sym_q_LBRACE] = ACTIONS(4386),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_LBRACE] = ACTIONS(4386),
    [anon_sym_DOT] = ACTIONS(4386),
    [anon_sym_AMP] = ACTIONS(4386),
    [anon_sym_DASH] = ACTIONS(4384),
    [anon_sym_DASH_DASH] = ACTIONS(4386),
    [anon_sym_PLUS] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4386),
    [anon_sym_LPAREN] = ACTIONS(4386),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_LBRACK] = ACTIONS(4386),
    [anon_sym_SEMI] = ACTIONS(4386),
    [anon_sym_DOLLAR] = ACTIONS(4386),
    [anon_sym_STAR] = ACTIONS(4386),
    [anon_sym_TILDE] = ACTIONS(4386),
    [anon_sym_AT] = ACTIONS(4386),
    [sym_bool] = ACTIONS(4384),
    [sym_byte] = ACTIONS(4384),
    [sym_ubyte] = ACTIONS(4384),
    [sym_char] = ACTIONS(4384),
    [sym_short] = ACTIONS(4384),
    [sym_ushort] = ACTIONS(4384),
    [sym_int] = ACTIONS(4384),
    [sym_uint] = ACTIONS(4384),
    [sym_long] = ACTIONS(4384),
    [sym_ulong] = ACTIONS(4384),
    [sym_cent] = ACTIONS(4384),
    [sym_ucent] = ACTIONS(4384),
    [sym_wchar] = ACTIONS(4384),
    [sym_dchar] = ACTIONS(4384),
    [sym_float] = ACTIONS(4384),
    [sym_double] = ACTIONS(4384),
    [sym_real] = ACTIONS(4384),
    [sym_ifloat] = ACTIONS(4384),
    [sym_idouble] = ACTIONS(4384),
    [sym_ireal] = ACTIONS(4384),
    [sym_cfloat] = ACTIONS(4384),
    [sym_cdouble] = ACTIONS(4384),
    [sym_creal] = ACTIONS(4384),
    [sym_size_t] = ACTIONS(4384),
    [sym_ptrdiff_t] = ACTIONS(4384),
    [sym_string] = ACTIONS(4384),
    [sym_cstring] = ACTIONS(4384),
    [sym_dstring] = ACTIONS(4384),
    [sym_wstring] = ACTIONS(4384),
    [sym_noreturn] = ACTIONS(4384),
    [sym_true] = ACTIONS(4384),
    [sym_false] = ACTIONS(4384),
    [sym_null] = ACTIONS(4384),
    [sym_super] = ACTIONS(4384),
    [sym_this] = ACTIONS(4384),
    [sym_abstract] = ACTIONS(4384),
    [sym_alias] = ACTIONS(4384),
    [sym_align] = ACTIONS(4384),
    [sym_asm] = ACTIONS(4384),
    [sym_assert] = ACTIONS(4384),
    [sym_auto] = ACTIONS(4384),
    [sym_break] = ACTIONS(4384),
    [sym_case] = ACTIONS(4384),
    [sym_cast] = ACTIONS(4384),
    [sym_class] = ACTIONS(4384),
    [sym_const] = ACTIONS(4384),
    [sym_continue] = ACTIONS(4384),
    [sym_debug] = ACTIONS(4384),
    [sym_default] = ACTIONS(4384),
    [sym_delegate] = ACTIONS(4384),
    [sym_delete] = ACTIONS(4384),
    [sym_deprecated] = ACTIONS(4384),
    [sym_do] = ACTIONS(4384),
    [sym_else] = ACTIONS(4384),
    [sym_enum] = ACTIONS(4384),
    [sym_export] = ACTIONS(4384),
    [sym_extern] = ACTIONS(4384),
    [sym_final] = ACTIONS(4384),
    [sym_for] = ACTIONS(4384),
    [sym_foreach] = ACTIONS(4384),
    [sym_foreach_reverse] = ACTIONS(4384),
    [sym_function] = ACTIONS(4384),
    [sym_goto] = ACTIONS(4384),
    [sym_if] = ACTIONS(4384),
    [sym_immutable] = ACTIONS(4384),
    [sym_import] = ACTIONS(4384),
    [sym_in] = ACTIONS(4384),
    [sym_inout] = ACTIONS(4384),
    [sym_interface] = ACTIONS(4384),
    [sym_invariant] = ACTIONS(4384),
    [sym_is] = ACTIONS(4384),
    [sym_mixin] = ACTIONS(4384),
    [sym_new] = ACTIONS(4384),
    [sym_nothrow] = ACTIONS(4384),
    [sym_out] = ACTIONS(4384),
    [sym_override] = ACTIONS(4384),
    [sym_package] = ACTIONS(4384),
    [sym_pragma] = ACTIONS(4384),
    [sym_private] = ACTIONS(4384),
    [sym_protected] = ACTIONS(4384),
    [sym_public] = ACTIONS(4384),
    [sym_pure] = ACTIONS(4384),
    [sym_ref] = ACTIONS(4384),
    [sym_return] = ACTIONS(4384),
    [sym_scope] = ACTIONS(4384),
    [sym_shared] = ACTIONS(4384),
    [sym_static] = ACTIONS(4384),
    [sym_struct] = ACTIONS(4384),
    [sym_switch] = ACTIONS(4384),
    [sym_synchronized] = ACTIONS(4384),
    [sym_template] = ACTIONS(4384),
    [sym_throw] = ACTIONS(4384),
    [sym_try] = ACTIONS(4384),
    [sym_typeid] = ACTIONS(4384),
    [sym_typeof] = ACTIONS(4384),
    [sym_union] = ACTIONS(4384),
    [sym_unittest] = ACTIONS(4384),
    [sym_version] = ACTIONS(4384),
    [sym_while] = ACTIONS(4384),
    [sym_with] = ACTIONS(4384),
    [sym_gshared] = ACTIONS(4384),
    [sym_traits] = ACTIONS(4384),
    [sym_vector] = ACTIONS(4384),
    [sym_void] = ACTIONS(4384),
    [anon_sym_BQUOTE] = ACTIONS(4386),
    [anon_sym_r_DQUOTE] = ACTIONS(4386),
    [anon_sym_x_DQUOTE] = ACTIONS(4386),
    [anon_sym_DQUOTE] = ACTIONS(4386),
    [anon_sym_i_BQUOTE] = ACTIONS(4386),
    [anon_sym_i_DQUOTE] = ACTIONS(4386),
    [anon_sym_iq_LBRACE] = ACTIONS(4386),
    [aux_sym_char_literal_token1] = ACTIONS(4386),
    [anon_sym_SQUOTE] = ACTIONS(4384),
    [anon_sym___DATE__] = ACTIONS(4384),
    [anon_sym___FILE__] = ACTIONS(4384),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4384),
    [anon_sym___FUNCTION__] = ACTIONS(4384),
    [anon_sym___LINE__] = ACTIONS(4384),
    [anon_sym___MODULE__] = ACTIONS(4384),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4384),
    [anon_sym___TIME__] = ACTIONS(4384),
    [anon_sym___TIMESTAMP__] = ACTIONS(4384),
    [anon_sym___VENDOR__] = ACTIONS(4384),
    [anon_sym___VERSION__] = ACTIONS(4384),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4386),
    [sym_float_literal] = ACTIONS(4386),
    [sym__string] = ACTIONS(4386),
  },
  [1568] = {
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_q_LBRACE] = ACTIONS(4484),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4484),
    [anon_sym_PLUS] = ACTIONS(4482),
    [anon_sym_PLUS_PLUS] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_LPAREN] = ACTIONS(4484),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_DOLLAR] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4484),
    [anon_sym_AT] = ACTIONS(4484),
    [sym_bool] = ACTIONS(4482),
    [sym_byte] = ACTIONS(4482),
    [sym_ubyte] = ACTIONS(4482),
    [sym_char] = ACTIONS(4482),
    [sym_short] = ACTIONS(4482),
    [sym_ushort] = ACTIONS(4482),
    [sym_int] = ACTIONS(4482),
    [sym_uint] = ACTIONS(4482),
    [sym_long] = ACTIONS(4482),
    [sym_ulong] = ACTIONS(4482),
    [sym_cent] = ACTIONS(4482),
    [sym_ucent] = ACTIONS(4482),
    [sym_wchar] = ACTIONS(4482),
    [sym_dchar] = ACTIONS(4482),
    [sym_float] = ACTIONS(4482),
    [sym_double] = ACTIONS(4482),
    [sym_real] = ACTIONS(4482),
    [sym_ifloat] = ACTIONS(4482),
    [sym_idouble] = ACTIONS(4482),
    [sym_ireal] = ACTIONS(4482),
    [sym_cfloat] = ACTIONS(4482),
    [sym_cdouble] = ACTIONS(4482),
    [sym_creal] = ACTIONS(4482),
    [sym_size_t] = ACTIONS(4482),
    [sym_ptrdiff_t] = ACTIONS(4482),
    [sym_string] = ACTIONS(4482),
    [sym_cstring] = ACTIONS(4482),
    [sym_dstring] = ACTIONS(4482),
    [sym_wstring] = ACTIONS(4482),
    [sym_noreturn] = ACTIONS(4482),
    [sym_true] = ACTIONS(4482),
    [sym_false] = ACTIONS(4482),
    [sym_null] = ACTIONS(4482),
    [sym_super] = ACTIONS(4482),
    [sym_this] = ACTIONS(4482),
    [sym_abstract] = ACTIONS(4482),
    [sym_alias] = ACTIONS(4482),
    [sym_align] = ACTIONS(4482),
    [sym_asm] = ACTIONS(4482),
    [sym_assert] = ACTIONS(4482),
    [sym_auto] = ACTIONS(4482),
    [sym_break] = ACTIONS(4482),
    [sym_case] = ACTIONS(4482),
    [sym_cast] = ACTIONS(4482),
    [sym_class] = ACTIONS(4482),
    [sym_const] = ACTIONS(4482),
    [sym_continue] = ACTIONS(4482),
    [sym_debug] = ACTIONS(4482),
    [sym_default] = ACTIONS(4482),
    [sym_delegate] = ACTIONS(4482),
    [sym_delete] = ACTIONS(4482),
    [sym_deprecated] = ACTIONS(4482),
    [sym_do] = ACTIONS(4482),
    [sym_else] = ACTIONS(4482),
    [sym_enum] = ACTIONS(4482),
    [sym_export] = ACTIONS(4482),
    [sym_extern] = ACTIONS(4482),
    [sym_final] = ACTIONS(4482),
    [sym_for] = ACTIONS(4482),
    [sym_foreach] = ACTIONS(4482),
    [sym_foreach_reverse] = ACTIONS(4482),
    [sym_function] = ACTIONS(4482),
    [sym_goto] = ACTIONS(4482),
    [sym_if] = ACTIONS(4482),
    [sym_immutable] = ACTIONS(4482),
    [sym_import] = ACTIONS(4482),
    [sym_in] = ACTIONS(4482),
    [sym_inout] = ACTIONS(4482),
    [sym_interface] = ACTIONS(4482),
    [sym_invariant] = ACTIONS(4482),
    [sym_is] = ACTIONS(4482),
    [sym_mixin] = ACTIONS(4482),
    [sym_new] = ACTIONS(4482),
    [sym_nothrow] = ACTIONS(4482),
    [sym_out] = ACTIONS(4482),
    [sym_override] = ACTIONS(4482),
    [sym_package] = ACTIONS(4482),
    [sym_pragma] = ACTIONS(4482),
    [sym_private] = ACTIONS(4482),
    [sym_protected] = ACTIONS(4482),
    [sym_public] = ACTIONS(4482),
    [sym_pure] = ACTIONS(4482),
    [sym_ref] = ACTIONS(4482),
    [sym_return] = ACTIONS(4482),
    [sym_scope] = ACTIONS(4482),
    [sym_shared] = ACTIONS(4482),
    [sym_static] = ACTIONS(4482),
    [sym_struct] = ACTIONS(4482),
    [sym_switch] = ACTIONS(4482),
    [sym_synchronized] = ACTIONS(4482),
    [sym_template] = ACTIONS(4482),
    [sym_throw] = ACTIONS(4482),
    [sym_try] = ACTIONS(4482),
    [sym_typeid] = ACTIONS(4482),
    [sym_typeof] = ACTIONS(4482),
    [sym_union] = ACTIONS(4482),
    [sym_unittest] = ACTIONS(4482),
    [sym_version] = ACTIONS(4482),
    [sym_while] = ACTIONS(4482),
    [sym_with] = ACTIONS(4482),
    [sym_gshared] = ACTIONS(4482),
    [sym_traits] = ACTIONS(4482),
    [sym_vector] = ACTIONS(4482),
    [sym_void] = ACTIONS(4482),
    [anon_sym_BQUOTE] = ACTIONS(4484),
    [anon_sym_r_DQUOTE] = ACTIONS(4484),
    [anon_sym_x_DQUOTE] = ACTIONS(4484),
    [anon_sym_DQUOTE] = ACTIONS(4484),
    [anon_sym_i_BQUOTE] = ACTIONS(4484),
    [anon_sym_i_DQUOTE] = ACTIONS(4484),
    [anon_sym_iq_LBRACE] = ACTIONS(4484),
    [aux_sym_char_literal_token1] = ACTIONS(4484),
    [anon_sym_SQUOTE] = ACTIONS(4482),
    [anon_sym___DATE__] = ACTIONS(4482),
    [anon_sym___FILE__] = ACTIONS(4482),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4482),
    [anon_sym___FUNCTION__] = ACTIONS(4482),
    [anon_sym___LINE__] = ACTIONS(4482),
    [anon_sym___MODULE__] = ACTIONS(4482),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4482),
    [anon_sym___TIME__] = ACTIONS(4482),
    [anon_sym___TIMESTAMP__] = ACTIONS(4482),
    [anon_sym___VENDOR__] = ACTIONS(4482),
    [anon_sym___VERSION__] = ACTIONS(4482),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4484),
    [sym_float_literal] = ACTIONS(4484),
    [sym__string] = ACTIONS(4484),
  },
  [1569] = {
    [sym_identifier] = ACTIONS(4957),
    [anon_sym_q_LBRACE] = ACTIONS(4959),
    [anon_sym_RBRACE] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4959),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_DASH] = ACTIONS(4957),
    [anon_sym_DASH_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4959),
    [anon_sym_BANG] = ACTIONS(4959),
    [anon_sym_LPAREN] = ACTIONS(4959),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_TILDE] = ACTIONS(4959),
    [anon_sym_AT] = ACTIONS(4959),
    [sym_bool] = ACTIONS(4957),
    [sym_byte] = ACTIONS(4957),
    [sym_ubyte] = ACTIONS(4957),
    [sym_char] = ACTIONS(4957),
    [sym_short] = ACTIONS(4957),
    [sym_ushort] = ACTIONS(4957),
    [sym_int] = ACTIONS(4957),
    [sym_uint] = ACTIONS(4957),
    [sym_long] = ACTIONS(4957),
    [sym_ulong] = ACTIONS(4957),
    [sym_cent] = ACTIONS(4957),
    [sym_ucent] = ACTIONS(4957),
    [sym_wchar] = ACTIONS(4957),
    [sym_dchar] = ACTIONS(4957),
    [sym_float] = ACTIONS(4957),
    [sym_double] = ACTIONS(4957),
    [sym_real] = ACTIONS(4957),
    [sym_ifloat] = ACTIONS(4957),
    [sym_idouble] = ACTIONS(4957),
    [sym_ireal] = ACTIONS(4957),
    [sym_cfloat] = ACTIONS(4957),
    [sym_cdouble] = ACTIONS(4957),
    [sym_creal] = ACTIONS(4957),
    [sym_size_t] = ACTIONS(4957),
    [sym_ptrdiff_t] = ACTIONS(4957),
    [sym_string] = ACTIONS(4957),
    [sym_cstring] = ACTIONS(4957),
    [sym_dstring] = ACTIONS(4957),
    [sym_wstring] = ACTIONS(4957),
    [sym_noreturn] = ACTIONS(4957),
    [sym_true] = ACTIONS(4957),
    [sym_false] = ACTIONS(4957),
    [sym_null] = ACTIONS(4957),
    [sym_super] = ACTIONS(4957),
    [sym_this] = ACTIONS(4957),
    [sym_abstract] = ACTIONS(4957),
    [sym_alias] = ACTIONS(4957),
    [sym_align] = ACTIONS(4957),
    [sym_asm] = ACTIONS(4957),
    [sym_assert] = ACTIONS(4957),
    [sym_auto] = ACTIONS(4957),
    [sym_break] = ACTIONS(4957),
    [sym_case] = ACTIONS(4957),
    [sym_cast] = ACTIONS(4957),
    [sym_class] = ACTIONS(4957),
    [sym_const] = ACTIONS(4957),
    [sym_continue] = ACTIONS(4957),
    [sym_debug] = ACTIONS(4957),
    [sym_default] = ACTIONS(4957),
    [sym_delegate] = ACTIONS(4957),
    [sym_delete] = ACTIONS(4957),
    [sym_deprecated] = ACTIONS(4957),
    [sym_do] = ACTIONS(4957),
    [sym_else] = ACTIONS(4957),
    [sym_enum] = ACTIONS(4957),
    [sym_export] = ACTIONS(4957),
    [sym_extern] = ACTIONS(4957),
    [sym_final] = ACTIONS(4957),
    [sym_for] = ACTIONS(4957),
    [sym_foreach] = ACTIONS(4957),
    [sym_foreach_reverse] = ACTIONS(4957),
    [sym_function] = ACTIONS(4957),
    [sym_goto] = ACTIONS(4957),
    [sym_if] = ACTIONS(4957),
    [sym_immutable] = ACTIONS(4957),
    [sym_import] = ACTIONS(4957),
    [sym_in] = ACTIONS(4957),
    [sym_inout] = ACTIONS(4957),
    [sym_interface] = ACTIONS(4957),
    [sym_invariant] = ACTIONS(4957),
    [sym_is] = ACTIONS(4957),
    [sym_mixin] = ACTIONS(4957),
    [sym_new] = ACTIONS(4957),
    [sym_nothrow] = ACTIONS(4957),
    [sym_out] = ACTIONS(4957),
    [sym_override] = ACTIONS(4957),
    [sym_package] = ACTIONS(4957),
    [sym_pragma] = ACTIONS(4957),
    [sym_private] = ACTIONS(4957),
    [sym_protected] = ACTIONS(4957),
    [sym_public] = ACTIONS(4957),
    [sym_pure] = ACTIONS(4957),
    [sym_ref] = ACTIONS(4957),
    [sym_return] = ACTIONS(4957),
    [sym_scope] = ACTIONS(4957),
    [sym_shared] = ACTIONS(4957),
    [sym_static] = ACTIONS(4957),
    [sym_struct] = ACTIONS(4957),
    [sym_switch] = ACTIONS(4957),
    [sym_synchronized] = ACTIONS(4957),
    [sym_template] = ACTIONS(4957),
    [sym_throw] = ACTIONS(4957),
    [sym_try] = ACTIONS(4957),
    [sym_typeid] = ACTIONS(4957),
    [sym_typeof] = ACTIONS(4957),
    [sym_union] = ACTIONS(4957),
    [sym_unittest] = ACTIONS(4957),
    [sym_version] = ACTIONS(4957),
    [sym_while] = ACTIONS(4957),
    [sym_with] = ACTIONS(4957),
    [sym_gshared] = ACTIONS(4957),
    [sym_traits] = ACTIONS(4957),
    [sym_vector] = ACTIONS(4957),
    [sym_void] = ACTIONS(4957),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_r_DQUOTE] = ACTIONS(4959),
    [anon_sym_x_DQUOTE] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_i_BQUOTE] = ACTIONS(4959),
    [anon_sym_i_DQUOTE] = ACTIONS(4959),
    [anon_sym_iq_LBRACE] = ACTIONS(4959),
    [aux_sym_char_literal_token1] = ACTIONS(4959),
    [anon_sym_SQUOTE] = ACTIONS(4957),
    [anon_sym___DATE__] = ACTIONS(4957),
    [anon_sym___FILE__] = ACTIONS(4957),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4957),
    [anon_sym___FUNCTION__] = ACTIONS(4957),
    [anon_sym___LINE__] = ACTIONS(4957),
    [anon_sym___MODULE__] = ACTIONS(4957),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4957),
    [anon_sym___TIME__] = ACTIONS(4957),
    [anon_sym___TIMESTAMP__] = ACTIONS(4957),
    [anon_sym___VENDOR__] = ACTIONS(4957),
    [anon_sym___VERSION__] = ACTIONS(4957),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4959),
    [sym_float_literal] = ACTIONS(4959),
    [sym__string] = ACTIONS(4959),
  },
  [1570] = {
    [sym_identifier] = ACTIONS(4322),
    [anon_sym_q_LBRACE] = ACTIONS(4324),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4324),
    [anon_sym_DOT] = ACTIONS(4324),
    [anon_sym_AMP] = ACTIONS(4324),
    [anon_sym_DASH] = ACTIONS(4322),
    [anon_sym_DASH_DASH] = ACTIONS(4324),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_PLUS_PLUS] = ACTIONS(4324),
    [anon_sym_BANG] = ACTIONS(4324),
    [anon_sym_LPAREN] = ACTIONS(4324),
    [anon_sym_RPAREN] = ACTIONS(4324),
    [anon_sym_LBRACK] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_DOLLAR] = ACTIONS(4324),
    [anon_sym_STAR] = ACTIONS(4324),
    [anon_sym_TILDE] = ACTIONS(4324),
    [anon_sym_AT] = ACTIONS(4324),
    [sym_bool] = ACTIONS(4322),
    [sym_byte] = ACTIONS(4322),
    [sym_ubyte] = ACTIONS(4322),
    [sym_char] = ACTIONS(4322),
    [sym_short] = ACTIONS(4322),
    [sym_ushort] = ACTIONS(4322),
    [sym_int] = ACTIONS(4322),
    [sym_uint] = ACTIONS(4322),
    [sym_long] = ACTIONS(4322),
    [sym_ulong] = ACTIONS(4322),
    [sym_cent] = ACTIONS(4322),
    [sym_ucent] = ACTIONS(4322),
    [sym_wchar] = ACTIONS(4322),
    [sym_dchar] = ACTIONS(4322),
    [sym_float] = ACTIONS(4322),
    [sym_double] = ACTIONS(4322),
    [sym_real] = ACTIONS(4322),
    [sym_ifloat] = ACTIONS(4322),
    [sym_idouble] = ACTIONS(4322),
    [sym_ireal] = ACTIONS(4322),
    [sym_cfloat] = ACTIONS(4322),
    [sym_cdouble] = ACTIONS(4322),
    [sym_creal] = ACTIONS(4322),
    [sym_size_t] = ACTIONS(4322),
    [sym_ptrdiff_t] = ACTIONS(4322),
    [sym_string] = ACTIONS(4322),
    [sym_cstring] = ACTIONS(4322),
    [sym_dstring] = ACTIONS(4322),
    [sym_wstring] = ACTIONS(4322),
    [sym_noreturn] = ACTIONS(4322),
    [sym_true] = ACTIONS(4322),
    [sym_false] = ACTIONS(4322),
    [sym_null] = ACTIONS(4322),
    [sym_super] = ACTIONS(4322),
    [sym_this] = ACTIONS(4322),
    [sym_abstract] = ACTIONS(4322),
    [sym_alias] = ACTIONS(4322),
    [sym_align] = ACTIONS(4322),
    [sym_asm] = ACTIONS(4322),
    [sym_assert] = ACTIONS(4322),
    [sym_auto] = ACTIONS(4322),
    [sym_break] = ACTIONS(4322),
    [sym_case] = ACTIONS(4322),
    [sym_cast] = ACTIONS(4322),
    [sym_class] = ACTIONS(4322),
    [sym_const] = ACTIONS(4322),
    [sym_continue] = ACTIONS(4322),
    [sym_debug] = ACTIONS(4322),
    [sym_default] = ACTIONS(4322),
    [sym_delegate] = ACTIONS(4322),
    [sym_delete] = ACTIONS(4322),
    [sym_deprecated] = ACTIONS(4322),
    [sym_do] = ACTIONS(4322),
    [sym_else] = ACTIONS(4322),
    [sym_enum] = ACTIONS(4322),
    [sym_export] = ACTIONS(4322),
    [sym_extern] = ACTIONS(4322),
    [sym_final] = ACTIONS(4322),
    [sym_for] = ACTIONS(4322),
    [sym_foreach] = ACTIONS(4322),
    [sym_foreach_reverse] = ACTIONS(4322),
    [sym_function] = ACTIONS(4322),
    [sym_goto] = ACTIONS(4322),
    [sym_if] = ACTIONS(4322),
    [sym_immutable] = ACTIONS(4322),
    [sym_import] = ACTIONS(4322),
    [sym_in] = ACTIONS(4322),
    [sym_inout] = ACTIONS(4322),
    [sym_interface] = ACTIONS(4322),
    [sym_invariant] = ACTIONS(4322),
    [sym_is] = ACTIONS(4322),
    [sym_mixin] = ACTIONS(4322),
    [sym_new] = ACTIONS(4322),
    [sym_nothrow] = ACTIONS(4322),
    [sym_out] = ACTIONS(4322),
    [sym_override] = ACTIONS(4322),
    [sym_package] = ACTIONS(4322),
    [sym_pragma] = ACTIONS(4322),
    [sym_private] = ACTIONS(4322),
    [sym_protected] = ACTIONS(4322),
    [sym_public] = ACTIONS(4322),
    [sym_pure] = ACTIONS(4322),
    [sym_ref] = ACTIONS(4322),
    [sym_return] = ACTIONS(4322),
    [sym_scope] = ACTIONS(4322),
    [sym_shared] = ACTIONS(4322),
    [sym_static] = ACTIONS(4322),
    [sym_struct] = ACTIONS(4322),
    [sym_switch] = ACTIONS(4322),
    [sym_synchronized] = ACTIONS(4322),
    [sym_template] = ACTIONS(4322),
    [sym_throw] = ACTIONS(4322),
    [sym_try] = ACTIONS(4322),
    [sym_typeid] = ACTIONS(4322),
    [sym_typeof] = ACTIONS(4322),
    [sym_union] = ACTIONS(4322),
    [sym_unittest] = ACTIONS(4322),
    [sym_version] = ACTIONS(4322),
    [sym_while] = ACTIONS(4322),
    [sym_with] = ACTIONS(4322),
    [sym_gshared] = ACTIONS(4322),
    [sym_traits] = ACTIONS(4322),
    [sym_vector] = ACTIONS(4322),
    [sym_void] = ACTIONS(4322),
    [anon_sym_BQUOTE] = ACTIONS(4324),
    [anon_sym_r_DQUOTE] = ACTIONS(4324),
    [anon_sym_x_DQUOTE] = ACTIONS(4324),
    [anon_sym_DQUOTE] = ACTIONS(4324),
    [anon_sym_i_BQUOTE] = ACTIONS(4324),
    [anon_sym_i_DQUOTE] = ACTIONS(4324),
    [anon_sym_iq_LBRACE] = ACTIONS(4324),
    [aux_sym_char_literal_token1] = ACTIONS(4324),
    [anon_sym_SQUOTE] = ACTIONS(4322),
    [anon_sym___DATE__] = ACTIONS(4322),
    [anon_sym___FILE__] = ACTIONS(4322),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4322),
    [anon_sym___FUNCTION__] = ACTIONS(4322),
    [anon_sym___LINE__] = ACTIONS(4322),
    [anon_sym___MODULE__] = ACTIONS(4322),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4322),
    [anon_sym___TIME__] = ACTIONS(4322),
    [anon_sym___TIMESTAMP__] = ACTIONS(4322),
    [anon_sym___VENDOR__] = ACTIONS(4322),
    [anon_sym___VERSION__] = ACTIONS(4322),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4324),
    [sym_float_literal] = ACTIONS(4324),
    [sym__string] = ACTIONS(4324),
  },
  [1571] = {
    [sym_identifier] = ACTIONS(4825),
    [anon_sym_q_LBRACE] = ACTIONS(4828),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4828),
    [anon_sym_AMP] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4825),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS] = ACTIONS(4825),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_BANG] = ACTIONS(4828),
    [anon_sym_LPAREN] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(4828),
    [anon_sym_STAR] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_AT] = ACTIONS(4828),
    [sym_bool] = ACTIONS(4825),
    [sym_byte] = ACTIONS(4825),
    [sym_ubyte] = ACTIONS(4825),
    [sym_char] = ACTIONS(4825),
    [sym_short] = ACTIONS(4825),
    [sym_ushort] = ACTIONS(4825),
    [sym_int] = ACTIONS(4825),
    [sym_uint] = ACTIONS(4825),
    [sym_long] = ACTIONS(4825),
    [sym_ulong] = ACTIONS(4825),
    [sym_cent] = ACTIONS(4825),
    [sym_ucent] = ACTIONS(4825),
    [sym_wchar] = ACTIONS(4825),
    [sym_dchar] = ACTIONS(4825),
    [sym_float] = ACTIONS(4825),
    [sym_double] = ACTIONS(4825),
    [sym_real] = ACTIONS(4825),
    [sym_ifloat] = ACTIONS(4825),
    [sym_idouble] = ACTIONS(4825),
    [sym_ireal] = ACTIONS(4825),
    [sym_cfloat] = ACTIONS(4825),
    [sym_cdouble] = ACTIONS(4825),
    [sym_creal] = ACTIONS(4825),
    [sym_size_t] = ACTIONS(4825),
    [sym_ptrdiff_t] = ACTIONS(4825),
    [sym_string] = ACTIONS(4825),
    [sym_cstring] = ACTIONS(4825),
    [sym_dstring] = ACTIONS(4825),
    [sym_wstring] = ACTIONS(4825),
    [sym_noreturn] = ACTIONS(4825),
    [sym_true] = ACTIONS(4825),
    [sym_false] = ACTIONS(4825),
    [sym_null] = ACTIONS(4825),
    [sym_super] = ACTIONS(4825),
    [sym_this] = ACTIONS(4825),
    [sym_abstract] = ACTIONS(4825),
    [sym_alias] = ACTIONS(4825),
    [sym_align] = ACTIONS(4825),
    [sym_asm] = ACTIONS(4825),
    [sym_assert] = ACTIONS(4825),
    [sym_auto] = ACTIONS(4825),
    [sym_break] = ACTIONS(4825),
    [sym_case] = ACTIONS(4825),
    [sym_cast] = ACTIONS(4825),
    [sym_class] = ACTIONS(4825),
    [sym_const] = ACTIONS(4825),
    [sym_continue] = ACTIONS(4825),
    [sym_debug] = ACTIONS(4825),
    [sym_default] = ACTIONS(4825),
    [sym_delegate] = ACTIONS(4825),
    [sym_delete] = ACTIONS(4825),
    [sym_deprecated] = ACTIONS(4825),
    [sym_do] = ACTIONS(4825),
    [sym_else] = ACTIONS(4825),
    [sym_enum] = ACTIONS(4825),
    [sym_export] = ACTIONS(4825),
    [sym_extern] = ACTIONS(4825),
    [sym_final] = ACTIONS(4825),
    [sym_for] = ACTIONS(4825),
    [sym_foreach] = ACTIONS(4825),
    [sym_foreach_reverse] = ACTIONS(4825),
    [sym_function] = ACTIONS(4825),
    [sym_goto] = ACTIONS(4825),
    [sym_if] = ACTIONS(4825),
    [sym_immutable] = ACTIONS(4825),
    [sym_import] = ACTIONS(4825),
    [sym_in] = ACTIONS(4825),
    [sym_inout] = ACTIONS(4825),
    [sym_interface] = ACTIONS(4825),
    [sym_invariant] = ACTIONS(4825),
    [sym_is] = ACTIONS(4825),
    [sym_mixin] = ACTIONS(4825),
    [sym_new] = ACTIONS(4825),
    [sym_nothrow] = ACTIONS(4825),
    [sym_out] = ACTIONS(4825),
    [sym_override] = ACTIONS(4825),
    [sym_package] = ACTIONS(4825),
    [sym_pragma] = ACTIONS(4825),
    [sym_private] = ACTIONS(4825),
    [sym_protected] = ACTIONS(4825),
    [sym_public] = ACTIONS(4825),
    [sym_pure] = ACTIONS(4825),
    [sym_ref] = ACTIONS(4825),
    [sym_return] = ACTIONS(4825),
    [sym_scope] = ACTIONS(4825),
    [sym_shared] = ACTIONS(4825),
    [sym_static] = ACTIONS(4825),
    [sym_struct] = ACTIONS(4825),
    [sym_switch] = ACTIONS(4825),
    [sym_synchronized] = ACTIONS(4825),
    [sym_template] = ACTIONS(4825),
    [sym_throw] = ACTIONS(4825),
    [sym_try] = ACTIONS(4825),
    [sym_typeid] = ACTIONS(4825),
    [sym_typeof] = ACTIONS(4825),
    [sym_union] = ACTIONS(4825),
    [sym_unittest] = ACTIONS(4825),
    [sym_version] = ACTIONS(4825),
    [sym_while] = ACTIONS(4825),
    [sym_with] = ACTIONS(4825),
    [sym_gshared] = ACTIONS(4825),
    [sym_traits] = ACTIONS(4825),
    [sym_vector] = ACTIONS(4825),
    [sym_void] = ACTIONS(4825),
    [anon_sym_BQUOTE] = ACTIONS(4828),
    [anon_sym_r_DQUOTE] = ACTIONS(4828),
    [anon_sym_x_DQUOTE] = ACTIONS(4828),
    [anon_sym_DQUOTE] = ACTIONS(4828),
    [anon_sym_i_BQUOTE] = ACTIONS(4828),
    [anon_sym_i_DQUOTE] = ACTIONS(4828),
    [anon_sym_iq_LBRACE] = ACTIONS(4828),
    [aux_sym_char_literal_token1] = ACTIONS(4828),
    [anon_sym_SQUOTE] = ACTIONS(4825),
    [anon_sym___DATE__] = ACTIONS(4825),
    [anon_sym___FILE__] = ACTIONS(4825),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4825),
    [anon_sym___FUNCTION__] = ACTIONS(4825),
    [anon_sym___LINE__] = ACTIONS(4825),
    [anon_sym___MODULE__] = ACTIONS(4825),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4825),
    [anon_sym___TIME__] = ACTIONS(4825),
    [anon_sym___TIMESTAMP__] = ACTIONS(4825),
    [anon_sym___VENDOR__] = ACTIONS(4825),
    [anon_sym___VERSION__] = ACTIONS(4825),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4828),
    [sym_float_literal] = ACTIONS(4828),
    [sym__string] = ACTIONS(4828),
  },
  [1572] = {
    [sym_identifier] = ACTIONS(4769),
    [anon_sym_q_LBRACE] = ACTIONS(4771),
    [anon_sym_RBRACE] = ACTIONS(4771),
    [anon_sym_LBRACE] = ACTIONS(4771),
    [anon_sym_DOT] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_DASH] = ACTIONS(4769),
    [anon_sym_DASH_DASH] = ACTIONS(4771),
    [anon_sym_PLUS] = ACTIONS(4769),
    [anon_sym_PLUS_PLUS] = ACTIONS(4771),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_LPAREN] = ACTIONS(4771),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_LBRACK] = ACTIONS(4771),
    [anon_sym_SEMI] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4771),
    [anon_sym_STAR] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [anon_sym_AT] = ACTIONS(4771),
    [sym_bool] = ACTIONS(4769),
    [sym_byte] = ACTIONS(4769),
    [sym_ubyte] = ACTIONS(4769),
    [sym_char] = ACTIONS(4769),
    [sym_short] = ACTIONS(4769),
    [sym_ushort] = ACTIONS(4769),
    [sym_int] = ACTIONS(4769),
    [sym_uint] = ACTIONS(4769),
    [sym_long] = ACTIONS(4769),
    [sym_ulong] = ACTIONS(4769),
    [sym_cent] = ACTIONS(4769),
    [sym_ucent] = ACTIONS(4769),
    [sym_wchar] = ACTIONS(4769),
    [sym_dchar] = ACTIONS(4769),
    [sym_float] = ACTIONS(4769),
    [sym_double] = ACTIONS(4769),
    [sym_real] = ACTIONS(4769),
    [sym_ifloat] = ACTIONS(4769),
    [sym_idouble] = ACTIONS(4769),
    [sym_ireal] = ACTIONS(4769),
    [sym_cfloat] = ACTIONS(4769),
    [sym_cdouble] = ACTIONS(4769),
    [sym_creal] = ACTIONS(4769),
    [sym_size_t] = ACTIONS(4769),
    [sym_ptrdiff_t] = ACTIONS(4769),
    [sym_string] = ACTIONS(4769),
    [sym_cstring] = ACTIONS(4769),
    [sym_dstring] = ACTIONS(4769),
    [sym_wstring] = ACTIONS(4769),
    [sym_noreturn] = ACTIONS(4769),
    [sym_true] = ACTIONS(4769),
    [sym_false] = ACTIONS(4769),
    [sym_null] = ACTIONS(4769),
    [sym_super] = ACTIONS(4769),
    [sym_this] = ACTIONS(4769),
    [sym_abstract] = ACTIONS(4769),
    [sym_alias] = ACTIONS(4769),
    [sym_align] = ACTIONS(4769),
    [sym_asm] = ACTIONS(4769),
    [sym_assert] = ACTIONS(4769),
    [sym_auto] = ACTIONS(4769),
    [sym_break] = ACTIONS(4769),
    [sym_case] = ACTIONS(4769),
    [sym_cast] = ACTIONS(4769),
    [sym_class] = ACTIONS(4769),
    [sym_const] = ACTIONS(4769),
    [sym_continue] = ACTIONS(4769),
    [sym_debug] = ACTIONS(4769),
    [sym_default] = ACTIONS(4769),
    [sym_delegate] = ACTIONS(4769),
    [sym_delete] = ACTIONS(4769),
    [sym_deprecated] = ACTIONS(4769),
    [sym_do] = ACTIONS(4769),
    [sym_else] = ACTIONS(4769),
    [sym_enum] = ACTIONS(4769),
    [sym_export] = ACTIONS(4769),
    [sym_extern] = ACTIONS(4769),
    [sym_final] = ACTIONS(4769),
    [sym_for] = ACTIONS(4769),
    [sym_foreach] = ACTIONS(4769),
    [sym_foreach_reverse] = ACTIONS(4769),
    [sym_function] = ACTIONS(4769),
    [sym_goto] = ACTIONS(4769),
    [sym_if] = ACTIONS(4769),
    [sym_immutable] = ACTIONS(4769),
    [sym_import] = ACTIONS(4769),
    [sym_in] = ACTIONS(4769),
    [sym_inout] = ACTIONS(4769),
    [sym_interface] = ACTIONS(4769),
    [sym_invariant] = ACTIONS(4769),
    [sym_is] = ACTIONS(4769),
    [sym_mixin] = ACTIONS(4769),
    [sym_new] = ACTIONS(4769),
    [sym_nothrow] = ACTIONS(4769),
    [sym_out] = ACTIONS(4769),
    [sym_override] = ACTIONS(4769),
    [sym_package] = ACTIONS(4769),
    [sym_pragma] = ACTIONS(4769),
    [sym_private] = ACTIONS(4769),
    [sym_protected] = ACTIONS(4769),
    [sym_public] = ACTIONS(4769),
    [sym_pure] = ACTIONS(4769),
    [sym_ref] = ACTIONS(4769),
    [sym_return] = ACTIONS(4769),
    [sym_scope] = ACTIONS(4769),
    [sym_shared] = ACTIONS(4769),
    [sym_static] = ACTIONS(4769),
    [sym_struct] = ACTIONS(4769),
    [sym_switch] = ACTIONS(4769),
    [sym_synchronized] = ACTIONS(4769),
    [sym_template] = ACTIONS(4769),
    [sym_throw] = ACTIONS(4769),
    [sym_try] = ACTIONS(4769),
    [sym_typeid] = ACTIONS(4769),
    [sym_typeof] = ACTIONS(4769),
    [sym_union] = ACTIONS(4769),
    [sym_unittest] = ACTIONS(4769),
    [sym_version] = ACTIONS(4769),
    [sym_while] = ACTIONS(4769),
    [sym_with] = ACTIONS(4769),
    [sym_gshared] = ACTIONS(4769),
    [sym_traits] = ACTIONS(4769),
    [sym_vector] = ACTIONS(4769),
    [sym_void] = ACTIONS(4769),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_r_DQUOTE] = ACTIONS(4771),
    [anon_sym_x_DQUOTE] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_i_BQUOTE] = ACTIONS(4771),
    [anon_sym_i_DQUOTE] = ACTIONS(4771),
    [anon_sym_iq_LBRACE] = ACTIONS(4771),
    [aux_sym_char_literal_token1] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(4769),
    [anon_sym___DATE__] = ACTIONS(4769),
    [anon_sym___FILE__] = ACTIONS(4769),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4769),
    [anon_sym___FUNCTION__] = ACTIONS(4769),
    [anon_sym___LINE__] = ACTIONS(4769),
    [anon_sym___MODULE__] = ACTIONS(4769),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4769),
    [anon_sym___TIME__] = ACTIONS(4769),
    [anon_sym___TIMESTAMP__] = ACTIONS(4769),
    [anon_sym___VENDOR__] = ACTIONS(4769),
    [anon_sym___VERSION__] = ACTIONS(4769),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4771),
    [sym_float_literal] = ACTIONS(4771),
    [sym__string] = ACTIONS(4771),
  },
  [1573] = {
    [sym_identifier] = ACTIONS(4741),
    [anon_sym_q_LBRACE] = ACTIONS(4743),
    [anon_sym_RBRACE] = ACTIONS(4743),
    [anon_sym_LBRACE] = ACTIONS(4743),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4743),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4743),
    [anon_sym_PLUS] = ACTIONS(4741),
    [anon_sym_PLUS_PLUS] = ACTIONS(4743),
    [anon_sym_BANG] = ACTIONS(4743),
    [anon_sym_LPAREN] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [anon_sym_STAR] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [anon_sym_AT] = ACTIONS(4743),
    [sym_bool] = ACTIONS(4741),
    [sym_byte] = ACTIONS(4741),
    [sym_ubyte] = ACTIONS(4741),
    [sym_char] = ACTIONS(4741),
    [sym_short] = ACTIONS(4741),
    [sym_ushort] = ACTIONS(4741),
    [sym_int] = ACTIONS(4741),
    [sym_uint] = ACTIONS(4741),
    [sym_long] = ACTIONS(4741),
    [sym_ulong] = ACTIONS(4741),
    [sym_cent] = ACTIONS(4741),
    [sym_ucent] = ACTIONS(4741),
    [sym_wchar] = ACTIONS(4741),
    [sym_dchar] = ACTIONS(4741),
    [sym_float] = ACTIONS(4741),
    [sym_double] = ACTIONS(4741),
    [sym_real] = ACTIONS(4741),
    [sym_ifloat] = ACTIONS(4741),
    [sym_idouble] = ACTIONS(4741),
    [sym_ireal] = ACTIONS(4741),
    [sym_cfloat] = ACTIONS(4741),
    [sym_cdouble] = ACTIONS(4741),
    [sym_creal] = ACTIONS(4741),
    [sym_size_t] = ACTIONS(4741),
    [sym_ptrdiff_t] = ACTIONS(4741),
    [sym_string] = ACTIONS(4741),
    [sym_cstring] = ACTIONS(4741),
    [sym_dstring] = ACTIONS(4741),
    [sym_wstring] = ACTIONS(4741),
    [sym_noreturn] = ACTIONS(4741),
    [sym_true] = ACTIONS(4741),
    [sym_false] = ACTIONS(4741),
    [sym_null] = ACTIONS(4741),
    [sym_super] = ACTIONS(4741),
    [sym_this] = ACTIONS(4741),
    [sym_abstract] = ACTIONS(4741),
    [sym_alias] = ACTIONS(4741),
    [sym_align] = ACTIONS(4741),
    [sym_asm] = ACTIONS(4741),
    [sym_assert] = ACTIONS(4741),
    [sym_auto] = ACTIONS(4741),
    [sym_break] = ACTIONS(4741),
    [sym_case] = ACTIONS(4741),
    [sym_cast] = ACTIONS(4741),
    [sym_class] = ACTIONS(4741),
    [sym_const] = ACTIONS(4741),
    [sym_continue] = ACTIONS(4741),
    [sym_debug] = ACTIONS(4741),
    [sym_default] = ACTIONS(4741),
    [sym_delegate] = ACTIONS(4741),
    [sym_delete] = ACTIONS(4741),
    [sym_deprecated] = ACTIONS(4741),
    [sym_do] = ACTIONS(4741),
    [sym_else] = ACTIONS(5020),
    [sym_enum] = ACTIONS(4741),
    [sym_export] = ACTIONS(4741),
    [sym_extern] = ACTIONS(4741),
    [sym_final] = ACTIONS(4741),
    [sym_for] = ACTIONS(4741),
    [sym_foreach] = ACTIONS(4741),
    [sym_foreach_reverse] = ACTIONS(4741),
    [sym_function] = ACTIONS(4741),
    [sym_goto] = ACTIONS(4741),
    [sym_if] = ACTIONS(4741),
    [sym_immutable] = ACTIONS(4741),
    [sym_import] = ACTIONS(4741),
    [sym_in] = ACTIONS(4741),
    [sym_inout] = ACTIONS(4741),
    [sym_interface] = ACTIONS(4741),
    [sym_invariant] = ACTIONS(4741),
    [sym_is] = ACTIONS(4741),
    [sym_mixin] = ACTIONS(4741),
    [sym_new] = ACTIONS(4741),
    [sym_nothrow] = ACTIONS(4741),
    [sym_out] = ACTIONS(4741),
    [sym_override] = ACTIONS(4741),
    [sym_package] = ACTIONS(4741),
    [sym_pragma] = ACTIONS(4741),
    [sym_private] = ACTIONS(4741),
    [sym_protected] = ACTIONS(4741),
    [sym_public] = ACTIONS(4741),
    [sym_pure] = ACTIONS(4741),
    [sym_ref] = ACTIONS(4741),
    [sym_return] = ACTIONS(4741),
    [sym_scope] = ACTIONS(4741),
    [sym_shared] = ACTIONS(4741),
    [sym_static] = ACTIONS(4741),
    [sym_struct] = ACTIONS(4741),
    [sym_switch] = ACTIONS(4741),
    [sym_synchronized] = ACTIONS(4741),
    [sym_template] = ACTIONS(4741),
    [sym_throw] = ACTIONS(4741),
    [sym_try] = ACTIONS(4741),
    [sym_typeid] = ACTIONS(4741),
    [sym_typeof] = ACTIONS(4741),
    [sym_union] = ACTIONS(4741),
    [sym_unittest] = ACTIONS(4741),
    [sym_version] = ACTIONS(4741),
    [sym_while] = ACTIONS(4741),
    [sym_with] = ACTIONS(4741),
    [sym_gshared] = ACTIONS(4741),
    [sym_traits] = ACTIONS(4741),
    [sym_vector] = ACTIONS(4741),
    [sym_void] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_r_DQUOTE] = ACTIONS(4743),
    [anon_sym_x_DQUOTE] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_i_BQUOTE] = ACTIONS(4743),
    [anon_sym_i_DQUOTE] = ACTIONS(4743),
    [anon_sym_iq_LBRACE] = ACTIONS(4743),
    [aux_sym_char_literal_token1] = ACTIONS(4743),
    [anon_sym_SQUOTE] = ACTIONS(4741),
    [anon_sym___DATE__] = ACTIONS(4741),
    [anon_sym___FILE__] = ACTIONS(4741),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4741),
    [anon_sym___FUNCTION__] = ACTIONS(4741),
    [anon_sym___LINE__] = ACTIONS(4741),
    [anon_sym___MODULE__] = ACTIONS(4741),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4741),
    [anon_sym___TIME__] = ACTIONS(4741),
    [anon_sym___TIMESTAMP__] = ACTIONS(4741),
    [anon_sym___VENDOR__] = ACTIONS(4741),
    [anon_sym___VERSION__] = ACTIONS(4741),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4743),
    [sym_float_literal] = ACTIONS(4743),
    [sym__string] = ACTIONS(4743),
  },
  [1574] = {
    [sym_identifier] = ACTIONS(4953),
    [anon_sym_q_LBRACE] = ACTIONS(4955),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4955),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_DASH] = ACTIONS(4953),
    [anon_sym_DASH_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4955),
    [anon_sym_BANG] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [anon_sym_AT] = ACTIONS(4955),
    [sym_bool] = ACTIONS(4953),
    [sym_byte] = ACTIONS(4953),
    [sym_ubyte] = ACTIONS(4953),
    [sym_char] = ACTIONS(4953),
    [sym_short] = ACTIONS(4953),
    [sym_ushort] = ACTIONS(4953),
    [sym_int] = ACTIONS(4953),
    [sym_uint] = ACTIONS(4953),
    [sym_long] = ACTIONS(4953),
    [sym_ulong] = ACTIONS(4953),
    [sym_cent] = ACTIONS(4953),
    [sym_ucent] = ACTIONS(4953),
    [sym_wchar] = ACTIONS(4953),
    [sym_dchar] = ACTIONS(4953),
    [sym_float] = ACTIONS(4953),
    [sym_double] = ACTIONS(4953),
    [sym_real] = ACTIONS(4953),
    [sym_ifloat] = ACTIONS(4953),
    [sym_idouble] = ACTIONS(4953),
    [sym_ireal] = ACTIONS(4953),
    [sym_cfloat] = ACTIONS(4953),
    [sym_cdouble] = ACTIONS(4953),
    [sym_creal] = ACTIONS(4953),
    [sym_size_t] = ACTIONS(4953),
    [sym_ptrdiff_t] = ACTIONS(4953),
    [sym_string] = ACTIONS(4953),
    [sym_cstring] = ACTIONS(4953),
    [sym_dstring] = ACTIONS(4953),
    [sym_wstring] = ACTIONS(4953),
    [sym_noreturn] = ACTIONS(4953),
    [sym_true] = ACTIONS(4953),
    [sym_false] = ACTIONS(4953),
    [sym_null] = ACTIONS(4953),
    [sym_super] = ACTIONS(4953),
    [sym_this] = ACTIONS(4953),
    [sym_abstract] = ACTIONS(4953),
    [sym_alias] = ACTIONS(4953),
    [sym_align] = ACTIONS(4953),
    [sym_asm] = ACTIONS(4953),
    [sym_assert] = ACTIONS(4953),
    [sym_auto] = ACTIONS(4953),
    [sym_break] = ACTIONS(4953),
    [sym_case] = ACTIONS(4953),
    [sym_cast] = ACTIONS(4953),
    [sym_class] = ACTIONS(4953),
    [sym_const] = ACTIONS(4953),
    [sym_continue] = ACTIONS(4953),
    [sym_debug] = ACTIONS(4953),
    [sym_default] = ACTIONS(4953),
    [sym_delegate] = ACTIONS(4953),
    [sym_delete] = ACTIONS(4953),
    [sym_deprecated] = ACTIONS(4953),
    [sym_do] = ACTIONS(4953),
    [sym_else] = ACTIONS(4953),
    [sym_enum] = ACTIONS(4953),
    [sym_export] = ACTIONS(4953),
    [sym_extern] = ACTIONS(4953),
    [sym_final] = ACTIONS(4953),
    [sym_for] = ACTIONS(4953),
    [sym_foreach] = ACTIONS(4953),
    [sym_foreach_reverse] = ACTIONS(4953),
    [sym_function] = ACTIONS(4953),
    [sym_goto] = ACTIONS(4953),
    [sym_if] = ACTIONS(4953),
    [sym_immutable] = ACTIONS(4953),
    [sym_import] = ACTIONS(4953),
    [sym_in] = ACTIONS(4953),
    [sym_inout] = ACTIONS(4953),
    [sym_interface] = ACTIONS(4953),
    [sym_invariant] = ACTIONS(4953),
    [sym_is] = ACTIONS(4953),
    [sym_mixin] = ACTIONS(4953),
    [sym_new] = ACTIONS(4953),
    [sym_nothrow] = ACTIONS(4953),
    [sym_out] = ACTIONS(4953),
    [sym_override] = ACTIONS(4953),
    [sym_package] = ACTIONS(4953),
    [sym_pragma] = ACTIONS(4953),
    [sym_private] = ACTIONS(4953),
    [sym_protected] = ACTIONS(4953),
    [sym_public] = ACTIONS(4953),
    [sym_pure] = ACTIONS(4953),
    [sym_ref] = ACTIONS(4953),
    [sym_return] = ACTIONS(4953),
    [sym_scope] = ACTIONS(4953),
    [sym_shared] = ACTIONS(4953),
    [sym_static] = ACTIONS(4953),
    [sym_struct] = ACTIONS(4953),
    [sym_switch] = ACTIONS(4953),
    [sym_synchronized] = ACTIONS(4953),
    [sym_template] = ACTIONS(4953),
    [sym_throw] = ACTIONS(4953),
    [sym_try] = ACTIONS(4953),
    [sym_typeid] = ACTIONS(4953),
    [sym_typeof] = ACTIONS(4953),
    [sym_union] = ACTIONS(4953),
    [sym_unittest] = ACTIONS(4953),
    [sym_version] = ACTIONS(4953),
    [sym_while] = ACTIONS(4953),
    [sym_with] = ACTIONS(4953),
    [sym_gshared] = ACTIONS(4953),
    [sym_traits] = ACTIONS(4953),
    [sym_vector] = ACTIONS(4953),
    [sym_void] = ACTIONS(4953),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_r_DQUOTE] = ACTIONS(4955),
    [anon_sym_x_DQUOTE] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_i_BQUOTE] = ACTIONS(4955),
    [anon_sym_i_DQUOTE] = ACTIONS(4955),
    [anon_sym_iq_LBRACE] = ACTIONS(4955),
    [aux_sym_char_literal_token1] = ACTIONS(4955),
    [anon_sym_SQUOTE] = ACTIONS(4953),
    [anon_sym___DATE__] = ACTIONS(4953),
    [anon_sym___FILE__] = ACTIONS(4953),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4953),
    [anon_sym___FUNCTION__] = ACTIONS(4953),
    [anon_sym___LINE__] = ACTIONS(4953),
    [anon_sym___MODULE__] = ACTIONS(4953),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4953),
    [anon_sym___TIME__] = ACTIONS(4953),
    [anon_sym___TIMESTAMP__] = ACTIONS(4953),
    [anon_sym___VENDOR__] = ACTIONS(4953),
    [anon_sym___VERSION__] = ACTIONS(4953),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4955),
    [sym_float_literal] = ACTIONS(4955),
    [sym__string] = ACTIONS(4955),
  },
  [1575] = {
    [sym_identifier] = ACTIONS(4737),
    [anon_sym_q_LBRACE] = ACTIONS(4739),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_LBRACE] = ACTIONS(4739),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_AMP] = ACTIONS(4739),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_DASH_DASH] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4737),
    [anon_sym_PLUS_PLUS] = ACTIONS(4739),
    [anon_sym_BANG] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(4739),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_DOLLAR] = ACTIONS(4739),
    [anon_sym_STAR] = ACTIONS(4739),
    [anon_sym_TILDE] = ACTIONS(4739),
    [anon_sym_AT] = ACTIONS(4739),
    [sym_bool] = ACTIONS(4737),
    [sym_byte] = ACTIONS(4737),
    [sym_ubyte] = ACTIONS(4737),
    [sym_char] = ACTIONS(4737),
    [sym_short] = ACTIONS(4737),
    [sym_ushort] = ACTIONS(4737),
    [sym_int] = ACTIONS(4737),
    [sym_uint] = ACTIONS(4737),
    [sym_long] = ACTIONS(4737),
    [sym_ulong] = ACTIONS(4737),
    [sym_cent] = ACTIONS(4737),
    [sym_ucent] = ACTIONS(4737),
    [sym_wchar] = ACTIONS(4737),
    [sym_dchar] = ACTIONS(4737),
    [sym_float] = ACTIONS(4737),
    [sym_double] = ACTIONS(4737),
    [sym_real] = ACTIONS(4737),
    [sym_ifloat] = ACTIONS(4737),
    [sym_idouble] = ACTIONS(4737),
    [sym_ireal] = ACTIONS(4737),
    [sym_cfloat] = ACTIONS(4737),
    [sym_cdouble] = ACTIONS(4737),
    [sym_creal] = ACTIONS(4737),
    [sym_size_t] = ACTIONS(4737),
    [sym_ptrdiff_t] = ACTIONS(4737),
    [sym_string] = ACTIONS(4737),
    [sym_cstring] = ACTIONS(4737),
    [sym_dstring] = ACTIONS(4737),
    [sym_wstring] = ACTIONS(4737),
    [sym_noreturn] = ACTIONS(4737),
    [sym_true] = ACTIONS(4737),
    [sym_false] = ACTIONS(4737),
    [sym_null] = ACTIONS(4737),
    [sym_super] = ACTIONS(4737),
    [sym_this] = ACTIONS(4737),
    [sym_abstract] = ACTIONS(4737),
    [sym_alias] = ACTIONS(4737),
    [sym_align] = ACTIONS(4737),
    [sym_asm] = ACTIONS(4737),
    [sym_assert] = ACTIONS(4737),
    [sym_auto] = ACTIONS(4737),
    [sym_break] = ACTIONS(4737),
    [sym_case] = ACTIONS(4737),
    [sym_cast] = ACTIONS(4737),
    [sym_class] = ACTIONS(4737),
    [sym_const] = ACTIONS(4737),
    [sym_continue] = ACTIONS(4737),
    [sym_debug] = ACTIONS(4737),
    [sym_default] = ACTIONS(4737),
    [sym_delegate] = ACTIONS(4737),
    [sym_delete] = ACTIONS(4737),
    [sym_deprecated] = ACTIONS(4737),
    [sym_do] = ACTIONS(4737),
    [sym_else] = ACTIONS(4737),
    [sym_enum] = ACTIONS(4737),
    [sym_export] = ACTIONS(4737),
    [sym_extern] = ACTIONS(4737),
    [sym_final] = ACTIONS(4737),
    [sym_for] = ACTIONS(4737),
    [sym_foreach] = ACTIONS(4737),
    [sym_foreach_reverse] = ACTIONS(4737),
    [sym_function] = ACTIONS(4737),
    [sym_goto] = ACTIONS(4737),
    [sym_if] = ACTIONS(4737),
    [sym_immutable] = ACTIONS(4737),
    [sym_import] = ACTIONS(4737),
    [sym_in] = ACTIONS(4737),
    [sym_inout] = ACTIONS(4737),
    [sym_interface] = ACTIONS(4737),
    [sym_invariant] = ACTIONS(4737),
    [sym_is] = ACTIONS(4737),
    [sym_mixin] = ACTIONS(4737),
    [sym_new] = ACTIONS(4737),
    [sym_nothrow] = ACTIONS(4737),
    [sym_out] = ACTIONS(4737),
    [sym_override] = ACTIONS(4737),
    [sym_package] = ACTIONS(4737),
    [sym_pragma] = ACTIONS(4737),
    [sym_private] = ACTIONS(4737),
    [sym_protected] = ACTIONS(4737),
    [sym_public] = ACTIONS(4737),
    [sym_pure] = ACTIONS(4737),
    [sym_ref] = ACTIONS(4737),
    [sym_return] = ACTIONS(4737),
    [sym_scope] = ACTIONS(4737),
    [sym_shared] = ACTIONS(4737),
    [sym_static] = ACTIONS(4737),
    [sym_struct] = ACTIONS(4737),
    [sym_switch] = ACTIONS(4737),
    [sym_synchronized] = ACTIONS(4737),
    [sym_template] = ACTIONS(4737),
    [sym_throw] = ACTIONS(4737),
    [sym_try] = ACTIONS(4737),
    [sym_typeid] = ACTIONS(4737),
    [sym_typeof] = ACTIONS(4737),
    [sym_union] = ACTIONS(4737),
    [sym_unittest] = ACTIONS(4737),
    [sym_version] = ACTIONS(4737),
    [sym_while] = ACTIONS(4737),
    [sym_with] = ACTIONS(4737),
    [sym_gshared] = ACTIONS(4737),
    [sym_traits] = ACTIONS(4737),
    [sym_vector] = ACTIONS(4737),
    [sym_void] = ACTIONS(4737),
    [anon_sym_BQUOTE] = ACTIONS(4739),
    [anon_sym_r_DQUOTE] = ACTIONS(4739),
    [anon_sym_x_DQUOTE] = ACTIONS(4739),
    [anon_sym_DQUOTE] = ACTIONS(4739),
    [anon_sym_i_BQUOTE] = ACTIONS(4739),
    [anon_sym_i_DQUOTE] = ACTIONS(4739),
    [anon_sym_iq_LBRACE] = ACTIONS(4739),
    [aux_sym_char_literal_token1] = ACTIONS(4739),
    [anon_sym_SQUOTE] = ACTIONS(4737),
    [anon_sym___DATE__] = ACTIONS(4737),
    [anon_sym___FILE__] = ACTIONS(4737),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4737),
    [anon_sym___FUNCTION__] = ACTIONS(4737),
    [anon_sym___LINE__] = ACTIONS(4737),
    [anon_sym___MODULE__] = ACTIONS(4737),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4737),
    [anon_sym___TIME__] = ACTIONS(4737),
    [anon_sym___TIMESTAMP__] = ACTIONS(4737),
    [anon_sym___VENDOR__] = ACTIONS(4737),
    [anon_sym___VERSION__] = ACTIONS(4737),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4739),
    [sym_float_literal] = ACTIONS(4739),
    [sym__string] = ACTIONS(4739),
  },
  [1576] = {
    [sym_identifier] = ACTIONS(4721),
    [anon_sym_q_LBRACE] = ACTIONS(4723),
    [anon_sym_RBRACE] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4723),
    [anon_sym_DOT] = ACTIONS(4723),
    [anon_sym_AMP] = ACTIONS(4723),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_DASH_DASH] = ACTIONS(4723),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_PLUS_PLUS] = ACTIONS(4723),
    [anon_sym_BANG] = ACTIONS(4723),
    [anon_sym_LPAREN] = ACTIONS(4723),
    [anon_sym_RPAREN] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(4723),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym_DOLLAR] = ACTIONS(4723),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [anon_sym_AT] = ACTIONS(4723),
    [sym_bool] = ACTIONS(4721),
    [sym_byte] = ACTIONS(4721),
    [sym_ubyte] = ACTIONS(4721),
    [sym_char] = ACTIONS(4721),
    [sym_short] = ACTIONS(4721),
    [sym_ushort] = ACTIONS(4721),
    [sym_int] = ACTIONS(4721),
    [sym_uint] = ACTIONS(4721),
    [sym_long] = ACTIONS(4721),
    [sym_ulong] = ACTIONS(4721),
    [sym_cent] = ACTIONS(4721),
    [sym_ucent] = ACTIONS(4721),
    [sym_wchar] = ACTIONS(4721),
    [sym_dchar] = ACTIONS(4721),
    [sym_float] = ACTIONS(4721),
    [sym_double] = ACTIONS(4721),
    [sym_real] = ACTIONS(4721),
    [sym_ifloat] = ACTIONS(4721),
    [sym_idouble] = ACTIONS(4721),
    [sym_ireal] = ACTIONS(4721),
    [sym_cfloat] = ACTIONS(4721),
    [sym_cdouble] = ACTIONS(4721),
    [sym_creal] = ACTIONS(4721),
    [sym_size_t] = ACTIONS(4721),
    [sym_ptrdiff_t] = ACTIONS(4721),
    [sym_string] = ACTIONS(4721),
    [sym_cstring] = ACTIONS(4721),
    [sym_dstring] = ACTIONS(4721),
    [sym_wstring] = ACTIONS(4721),
    [sym_noreturn] = ACTIONS(4721),
    [sym_true] = ACTIONS(4721),
    [sym_false] = ACTIONS(4721),
    [sym_null] = ACTIONS(4721),
    [sym_super] = ACTIONS(4721),
    [sym_this] = ACTIONS(4721),
    [sym_abstract] = ACTIONS(4721),
    [sym_alias] = ACTIONS(4721),
    [sym_align] = ACTIONS(4721),
    [sym_asm] = ACTIONS(4721),
    [sym_assert] = ACTIONS(4721),
    [sym_auto] = ACTIONS(4721),
    [sym_break] = ACTIONS(4721),
    [sym_case] = ACTIONS(4721),
    [sym_cast] = ACTIONS(4721),
    [sym_class] = ACTIONS(4721),
    [sym_const] = ACTIONS(4721),
    [sym_continue] = ACTIONS(4721),
    [sym_debug] = ACTIONS(4721),
    [sym_default] = ACTIONS(4721),
    [sym_delegate] = ACTIONS(4721),
    [sym_delete] = ACTIONS(4721),
    [sym_deprecated] = ACTIONS(4721),
    [sym_do] = ACTIONS(4721),
    [sym_else] = ACTIONS(4721),
    [sym_enum] = ACTIONS(4721),
    [sym_export] = ACTIONS(4721),
    [sym_extern] = ACTIONS(4721),
    [sym_final] = ACTIONS(4721),
    [sym_for] = ACTIONS(4721),
    [sym_foreach] = ACTIONS(4721),
    [sym_foreach_reverse] = ACTIONS(4721),
    [sym_function] = ACTIONS(4721),
    [sym_goto] = ACTIONS(4721),
    [sym_if] = ACTIONS(4721),
    [sym_immutable] = ACTIONS(4721),
    [sym_import] = ACTIONS(4721),
    [sym_in] = ACTIONS(4721),
    [sym_inout] = ACTIONS(4721),
    [sym_interface] = ACTIONS(4721),
    [sym_invariant] = ACTIONS(4721),
    [sym_is] = ACTIONS(4721),
    [sym_mixin] = ACTIONS(4721),
    [sym_new] = ACTIONS(4721),
    [sym_nothrow] = ACTIONS(4721),
    [sym_out] = ACTIONS(4721),
    [sym_override] = ACTIONS(4721),
    [sym_package] = ACTIONS(4721),
    [sym_pragma] = ACTIONS(4721),
    [sym_private] = ACTIONS(4721),
    [sym_protected] = ACTIONS(4721),
    [sym_public] = ACTIONS(4721),
    [sym_pure] = ACTIONS(4721),
    [sym_ref] = ACTIONS(4721),
    [sym_return] = ACTIONS(4721),
    [sym_scope] = ACTIONS(4721),
    [sym_shared] = ACTIONS(4721),
    [sym_static] = ACTIONS(4721),
    [sym_struct] = ACTIONS(4721),
    [sym_switch] = ACTIONS(4721),
    [sym_synchronized] = ACTIONS(4721),
    [sym_template] = ACTIONS(4721),
    [sym_throw] = ACTIONS(4721),
    [sym_try] = ACTIONS(4721),
    [sym_typeid] = ACTIONS(4721),
    [sym_typeof] = ACTIONS(4721),
    [sym_union] = ACTIONS(4721),
    [sym_unittest] = ACTIONS(4721),
    [sym_version] = ACTIONS(4721),
    [sym_while] = ACTIONS(4721),
    [sym_with] = ACTIONS(4721),
    [sym_gshared] = ACTIONS(4721),
    [sym_traits] = ACTIONS(4721),
    [sym_vector] = ACTIONS(4721),
    [sym_void] = ACTIONS(4721),
    [anon_sym_BQUOTE] = ACTIONS(4723),
    [anon_sym_r_DQUOTE] = ACTIONS(4723),
    [anon_sym_x_DQUOTE] = ACTIONS(4723),
    [anon_sym_DQUOTE] = ACTIONS(4723),
    [anon_sym_i_BQUOTE] = ACTIONS(4723),
    [anon_sym_i_DQUOTE] = ACTIONS(4723),
    [anon_sym_iq_LBRACE] = ACTIONS(4723),
    [aux_sym_char_literal_token1] = ACTIONS(4723),
    [anon_sym_SQUOTE] = ACTIONS(4721),
    [anon_sym___DATE__] = ACTIONS(4721),
    [anon_sym___FILE__] = ACTIONS(4721),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4721),
    [anon_sym___FUNCTION__] = ACTIONS(4721),
    [anon_sym___LINE__] = ACTIONS(4721),
    [anon_sym___MODULE__] = ACTIONS(4721),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4721),
    [anon_sym___TIME__] = ACTIONS(4721),
    [anon_sym___TIMESTAMP__] = ACTIONS(4721),
    [anon_sym___VENDOR__] = ACTIONS(4721),
    [anon_sym___VERSION__] = ACTIONS(4721),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4723),
    [sym_float_literal] = ACTIONS(4723),
    [sym__string] = ACTIONS(4723),
  },
  [1577] = {
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_q_LBRACE] = ACTIONS(4718),
    [anon_sym_RBRACE] = ACTIONS(4718),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_DOT] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4715),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_BANG] = ACTIONS(4718),
    [anon_sym_LPAREN] = ACTIONS(4718),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym_DOLLAR] = ACTIONS(4718),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_AT] = ACTIONS(4718),
    [sym_bool] = ACTIONS(4715),
    [sym_byte] = ACTIONS(4715),
    [sym_ubyte] = ACTIONS(4715),
    [sym_char] = ACTIONS(4715),
    [sym_short] = ACTIONS(4715),
    [sym_ushort] = ACTIONS(4715),
    [sym_int] = ACTIONS(4715),
    [sym_uint] = ACTIONS(4715),
    [sym_long] = ACTIONS(4715),
    [sym_ulong] = ACTIONS(4715),
    [sym_cent] = ACTIONS(4715),
    [sym_ucent] = ACTIONS(4715),
    [sym_wchar] = ACTIONS(4715),
    [sym_dchar] = ACTIONS(4715),
    [sym_float] = ACTIONS(4715),
    [sym_double] = ACTIONS(4715),
    [sym_real] = ACTIONS(4715),
    [sym_ifloat] = ACTIONS(4715),
    [sym_idouble] = ACTIONS(4715),
    [sym_ireal] = ACTIONS(4715),
    [sym_cfloat] = ACTIONS(4715),
    [sym_cdouble] = ACTIONS(4715),
    [sym_creal] = ACTIONS(4715),
    [sym_size_t] = ACTIONS(4715),
    [sym_ptrdiff_t] = ACTIONS(4715),
    [sym_string] = ACTIONS(4715),
    [sym_cstring] = ACTIONS(4715),
    [sym_dstring] = ACTIONS(4715),
    [sym_wstring] = ACTIONS(4715),
    [sym_noreturn] = ACTIONS(4715),
    [sym_true] = ACTIONS(4715),
    [sym_false] = ACTIONS(4715),
    [sym_null] = ACTIONS(4715),
    [sym_super] = ACTIONS(4715),
    [sym_this] = ACTIONS(4715),
    [sym_abstract] = ACTIONS(4715),
    [sym_alias] = ACTIONS(4715),
    [sym_align] = ACTIONS(4715),
    [sym_asm] = ACTIONS(4715),
    [sym_assert] = ACTIONS(4715),
    [sym_auto] = ACTIONS(4715),
    [sym_break] = ACTIONS(4715),
    [sym_case] = ACTIONS(4715),
    [sym_cast] = ACTIONS(4715),
    [sym_class] = ACTIONS(4715),
    [sym_const] = ACTIONS(4715),
    [sym_continue] = ACTIONS(4715),
    [sym_debug] = ACTIONS(4715),
    [sym_default] = ACTIONS(4715),
    [sym_delegate] = ACTIONS(4715),
    [sym_delete] = ACTIONS(4715),
    [sym_deprecated] = ACTIONS(4715),
    [sym_do] = ACTIONS(4715),
    [sym_else] = ACTIONS(4715),
    [sym_enum] = ACTIONS(4715),
    [sym_export] = ACTIONS(4715),
    [sym_extern] = ACTIONS(4715),
    [sym_final] = ACTIONS(4715),
    [sym_for] = ACTIONS(4715),
    [sym_foreach] = ACTIONS(4715),
    [sym_foreach_reverse] = ACTIONS(4715),
    [sym_function] = ACTIONS(4715),
    [sym_goto] = ACTIONS(4715),
    [sym_if] = ACTIONS(4715),
    [sym_immutable] = ACTIONS(4715),
    [sym_import] = ACTIONS(4715),
    [sym_in] = ACTIONS(4715),
    [sym_inout] = ACTIONS(4715),
    [sym_interface] = ACTIONS(4715),
    [sym_invariant] = ACTIONS(4715),
    [sym_is] = ACTIONS(4715),
    [sym_mixin] = ACTIONS(4715),
    [sym_new] = ACTIONS(4715),
    [sym_nothrow] = ACTIONS(4715),
    [sym_out] = ACTIONS(4715),
    [sym_override] = ACTIONS(4715),
    [sym_package] = ACTIONS(4715),
    [sym_pragma] = ACTIONS(4715),
    [sym_private] = ACTIONS(4715),
    [sym_protected] = ACTIONS(4715),
    [sym_public] = ACTIONS(4715),
    [sym_pure] = ACTIONS(4715),
    [sym_ref] = ACTIONS(4715),
    [sym_return] = ACTIONS(4715),
    [sym_scope] = ACTIONS(4715),
    [sym_shared] = ACTIONS(4715),
    [sym_static] = ACTIONS(4715),
    [sym_struct] = ACTIONS(4715),
    [sym_switch] = ACTIONS(4715),
    [sym_synchronized] = ACTIONS(4715),
    [sym_template] = ACTIONS(4715),
    [sym_throw] = ACTIONS(4715),
    [sym_try] = ACTIONS(4715),
    [sym_typeid] = ACTIONS(4715),
    [sym_typeof] = ACTIONS(4715),
    [sym_union] = ACTIONS(4715),
    [sym_unittest] = ACTIONS(4715),
    [sym_version] = ACTIONS(4715),
    [sym_while] = ACTIONS(4715),
    [sym_with] = ACTIONS(4715),
    [sym_gshared] = ACTIONS(4715),
    [sym_traits] = ACTIONS(4715),
    [sym_vector] = ACTIONS(4715),
    [sym_void] = ACTIONS(4715),
    [anon_sym_BQUOTE] = ACTIONS(4718),
    [anon_sym_r_DQUOTE] = ACTIONS(4718),
    [anon_sym_x_DQUOTE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4718),
    [anon_sym_i_BQUOTE] = ACTIONS(4718),
    [anon_sym_i_DQUOTE] = ACTIONS(4718),
    [anon_sym_iq_LBRACE] = ACTIONS(4718),
    [aux_sym_char_literal_token1] = ACTIONS(4718),
    [anon_sym_SQUOTE] = ACTIONS(4715),
    [anon_sym___DATE__] = ACTIONS(4715),
    [anon_sym___FILE__] = ACTIONS(4715),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4715),
    [anon_sym___FUNCTION__] = ACTIONS(4715),
    [anon_sym___LINE__] = ACTIONS(4715),
    [anon_sym___MODULE__] = ACTIONS(4715),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4715),
    [anon_sym___TIME__] = ACTIONS(4715),
    [anon_sym___TIMESTAMP__] = ACTIONS(4715),
    [anon_sym___VENDOR__] = ACTIONS(4715),
    [anon_sym___VERSION__] = ACTIONS(4715),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4718),
    [sym_float_literal] = ACTIONS(4718),
    [sym__string] = ACTIONS(4718),
  },
  [1578] = {
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_q_LBRACE] = ACTIONS(4713),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_LBRACE] = ACTIONS(4713),
    [anon_sym_DOT] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_DASH_DASH] = ACTIONS(4713),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_PLUS_PLUS] = ACTIONS(4713),
    [anon_sym_BANG] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_RPAREN] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_DOLLAR] = ACTIONS(4713),
    [anon_sym_STAR] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4713),
    [anon_sym_AT] = ACTIONS(4713),
    [sym_bool] = ACTIONS(4711),
    [sym_byte] = ACTIONS(4711),
    [sym_ubyte] = ACTIONS(4711),
    [sym_char] = ACTIONS(4711),
    [sym_short] = ACTIONS(4711),
    [sym_ushort] = ACTIONS(4711),
    [sym_int] = ACTIONS(4711),
    [sym_uint] = ACTIONS(4711),
    [sym_long] = ACTIONS(4711),
    [sym_ulong] = ACTIONS(4711),
    [sym_cent] = ACTIONS(4711),
    [sym_ucent] = ACTIONS(4711),
    [sym_wchar] = ACTIONS(4711),
    [sym_dchar] = ACTIONS(4711),
    [sym_float] = ACTIONS(4711),
    [sym_double] = ACTIONS(4711),
    [sym_real] = ACTIONS(4711),
    [sym_ifloat] = ACTIONS(4711),
    [sym_idouble] = ACTIONS(4711),
    [sym_ireal] = ACTIONS(4711),
    [sym_cfloat] = ACTIONS(4711),
    [sym_cdouble] = ACTIONS(4711),
    [sym_creal] = ACTIONS(4711),
    [sym_size_t] = ACTIONS(4711),
    [sym_ptrdiff_t] = ACTIONS(4711),
    [sym_string] = ACTIONS(4711),
    [sym_cstring] = ACTIONS(4711),
    [sym_dstring] = ACTIONS(4711),
    [sym_wstring] = ACTIONS(4711),
    [sym_noreturn] = ACTIONS(4711),
    [sym_true] = ACTIONS(4711),
    [sym_false] = ACTIONS(4711),
    [sym_null] = ACTIONS(4711),
    [sym_super] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [sym_abstract] = ACTIONS(4711),
    [sym_alias] = ACTIONS(4711),
    [sym_align] = ACTIONS(4711),
    [sym_asm] = ACTIONS(4711),
    [sym_assert] = ACTIONS(4711),
    [sym_auto] = ACTIONS(4711),
    [sym_break] = ACTIONS(4711),
    [sym_case] = ACTIONS(4711),
    [sym_cast] = ACTIONS(4711),
    [sym_class] = ACTIONS(4711),
    [sym_const] = ACTIONS(4711),
    [sym_continue] = ACTIONS(4711),
    [sym_debug] = ACTIONS(4711),
    [sym_default] = ACTIONS(4711),
    [sym_delegate] = ACTIONS(4711),
    [sym_delete] = ACTIONS(4711),
    [sym_deprecated] = ACTIONS(4711),
    [sym_do] = ACTIONS(4711),
    [sym_else] = ACTIONS(4711),
    [sym_enum] = ACTIONS(4711),
    [sym_export] = ACTIONS(4711),
    [sym_extern] = ACTIONS(4711),
    [sym_final] = ACTIONS(4711),
    [sym_for] = ACTIONS(4711),
    [sym_foreach] = ACTIONS(4711),
    [sym_foreach_reverse] = ACTIONS(4711),
    [sym_function] = ACTIONS(4711),
    [sym_goto] = ACTIONS(4711),
    [sym_if] = ACTIONS(4711),
    [sym_immutable] = ACTIONS(4711),
    [sym_import] = ACTIONS(4711),
    [sym_in] = ACTIONS(4711),
    [sym_inout] = ACTIONS(4711),
    [sym_interface] = ACTIONS(4711),
    [sym_invariant] = ACTIONS(4711),
    [sym_is] = ACTIONS(4711),
    [sym_mixin] = ACTIONS(4711),
    [sym_new] = ACTIONS(4711),
    [sym_nothrow] = ACTIONS(4711),
    [sym_out] = ACTIONS(4711),
    [sym_override] = ACTIONS(4711),
    [sym_package] = ACTIONS(4711),
    [sym_pragma] = ACTIONS(4711),
    [sym_private] = ACTIONS(4711),
    [sym_protected] = ACTIONS(4711),
    [sym_public] = ACTIONS(4711),
    [sym_pure] = ACTIONS(4711),
    [sym_ref] = ACTIONS(4711),
    [sym_return] = ACTIONS(4711),
    [sym_scope] = ACTIONS(4711),
    [sym_shared] = ACTIONS(4711),
    [sym_static] = ACTIONS(4711),
    [sym_struct] = ACTIONS(4711),
    [sym_switch] = ACTIONS(4711),
    [sym_synchronized] = ACTIONS(4711),
    [sym_template] = ACTIONS(4711),
    [sym_throw] = ACTIONS(4711),
    [sym_try] = ACTIONS(4711),
    [sym_typeid] = ACTIONS(4711),
    [sym_typeof] = ACTIONS(4711),
    [sym_union] = ACTIONS(4711),
    [sym_unittest] = ACTIONS(4711),
    [sym_version] = ACTIONS(4711),
    [sym_while] = ACTIONS(4711),
    [sym_with] = ACTIONS(4711),
    [sym_gshared] = ACTIONS(4711),
    [sym_traits] = ACTIONS(4711),
    [sym_vector] = ACTIONS(4711),
    [sym_void] = ACTIONS(4711),
    [anon_sym_BQUOTE] = ACTIONS(4713),
    [anon_sym_r_DQUOTE] = ACTIONS(4713),
    [anon_sym_x_DQUOTE] = ACTIONS(4713),
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [anon_sym_i_BQUOTE] = ACTIONS(4713),
    [anon_sym_i_DQUOTE] = ACTIONS(4713),
    [anon_sym_iq_LBRACE] = ACTIONS(4713),
    [aux_sym_char_literal_token1] = ACTIONS(4713),
    [anon_sym_SQUOTE] = ACTIONS(4711),
    [anon_sym___DATE__] = ACTIONS(4711),
    [anon_sym___FILE__] = ACTIONS(4711),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4711),
    [anon_sym___FUNCTION__] = ACTIONS(4711),
    [anon_sym___LINE__] = ACTIONS(4711),
    [anon_sym___MODULE__] = ACTIONS(4711),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4711),
    [anon_sym___TIME__] = ACTIONS(4711),
    [anon_sym___TIMESTAMP__] = ACTIONS(4711),
    [anon_sym___VENDOR__] = ACTIONS(4711),
    [anon_sym___VERSION__] = ACTIONS(4711),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4713),
    [sym_float_literal] = ACTIONS(4713),
    [sym__string] = ACTIONS(4713),
  },
  [1579] = {
    [sym_identifier] = ACTIONS(4656),
    [anon_sym_q_LBRACE] = ACTIONS(4658),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [anon_sym_LBRACE] = ACTIONS(4658),
    [anon_sym_DOT] = ACTIONS(4658),
    [anon_sym_AMP] = ACTIONS(4658),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_DASH_DASH] = ACTIONS(4658),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(4658),
    [anon_sym_RPAREN] = ACTIONS(4658),
    [anon_sym_LBRACK] = ACTIONS(4658),
    [anon_sym_SEMI] = ACTIONS(4658),
    [anon_sym_DOLLAR] = ACTIONS(4658),
    [anon_sym_STAR] = ACTIONS(4658),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_AT] = ACTIONS(4658),
    [sym_bool] = ACTIONS(4656),
    [sym_byte] = ACTIONS(4656),
    [sym_ubyte] = ACTIONS(4656),
    [sym_char] = ACTIONS(4656),
    [sym_short] = ACTIONS(4656),
    [sym_ushort] = ACTIONS(4656),
    [sym_int] = ACTIONS(4656),
    [sym_uint] = ACTIONS(4656),
    [sym_long] = ACTIONS(4656),
    [sym_ulong] = ACTIONS(4656),
    [sym_cent] = ACTIONS(4656),
    [sym_ucent] = ACTIONS(4656),
    [sym_wchar] = ACTIONS(4656),
    [sym_dchar] = ACTIONS(4656),
    [sym_float] = ACTIONS(4656),
    [sym_double] = ACTIONS(4656),
    [sym_real] = ACTIONS(4656),
    [sym_ifloat] = ACTIONS(4656),
    [sym_idouble] = ACTIONS(4656),
    [sym_ireal] = ACTIONS(4656),
    [sym_cfloat] = ACTIONS(4656),
    [sym_cdouble] = ACTIONS(4656),
    [sym_creal] = ACTIONS(4656),
    [sym_size_t] = ACTIONS(4656),
    [sym_ptrdiff_t] = ACTIONS(4656),
    [sym_string] = ACTIONS(4656),
    [sym_cstring] = ACTIONS(4656),
    [sym_dstring] = ACTIONS(4656),
    [sym_wstring] = ACTIONS(4656),
    [sym_noreturn] = ACTIONS(4656),
    [sym_true] = ACTIONS(4656),
    [sym_false] = ACTIONS(4656),
    [sym_null] = ACTIONS(4656),
    [sym_super] = ACTIONS(4656),
    [sym_this] = ACTIONS(4656),
    [sym_abstract] = ACTIONS(4656),
    [sym_alias] = ACTIONS(4656),
    [sym_align] = ACTIONS(4656),
    [sym_asm] = ACTIONS(4656),
    [sym_assert] = ACTIONS(4656),
    [sym_auto] = ACTIONS(4656),
    [sym_break] = ACTIONS(4656),
    [sym_case] = ACTIONS(4656),
    [sym_cast] = ACTIONS(4656),
    [sym_class] = ACTIONS(4656),
    [sym_const] = ACTIONS(4656),
    [sym_continue] = ACTIONS(4656),
    [sym_debug] = ACTIONS(4656),
    [sym_default] = ACTIONS(4656),
    [sym_delegate] = ACTIONS(4656),
    [sym_delete] = ACTIONS(4656),
    [sym_deprecated] = ACTIONS(4656),
    [sym_do] = ACTIONS(4656),
    [sym_else] = ACTIONS(4656),
    [sym_enum] = ACTIONS(4656),
    [sym_export] = ACTIONS(4656),
    [sym_extern] = ACTIONS(4656),
    [sym_final] = ACTIONS(4656),
    [sym_for] = ACTIONS(4656),
    [sym_foreach] = ACTIONS(4656),
    [sym_foreach_reverse] = ACTIONS(4656),
    [sym_function] = ACTIONS(4656),
    [sym_goto] = ACTIONS(4656),
    [sym_if] = ACTIONS(4656),
    [sym_immutable] = ACTIONS(4656),
    [sym_import] = ACTIONS(4656),
    [sym_in] = ACTIONS(4656),
    [sym_inout] = ACTIONS(4656),
    [sym_interface] = ACTIONS(4656),
    [sym_invariant] = ACTIONS(4656),
    [sym_is] = ACTIONS(4656),
    [sym_mixin] = ACTIONS(4656),
    [sym_new] = ACTIONS(4656),
    [sym_nothrow] = ACTIONS(4656),
    [sym_out] = ACTIONS(4656),
    [sym_override] = ACTIONS(4656),
    [sym_package] = ACTIONS(4656),
    [sym_pragma] = ACTIONS(4656),
    [sym_private] = ACTIONS(4656),
    [sym_protected] = ACTIONS(4656),
    [sym_public] = ACTIONS(4656),
    [sym_pure] = ACTIONS(4656),
    [sym_ref] = ACTIONS(4656),
    [sym_return] = ACTIONS(4656),
    [sym_scope] = ACTIONS(4656),
    [sym_shared] = ACTIONS(4656),
    [sym_static] = ACTIONS(4656),
    [sym_struct] = ACTIONS(4656),
    [sym_switch] = ACTIONS(4656),
    [sym_synchronized] = ACTIONS(4656),
    [sym_template] = ACTIONS(4656),
    [sym_throw] = ACTIONS(4656),
    [sym_try] = ACTIONS(4656),
    [sym_typeid] = ACTIONS(4656),
    [sym_typeof] = ACTIONS(4656),
    [sym_union] = ACTIONS(4656),
    [sym_unittest] = ACTIONS(4656),
    [sym_version] = ACTIONS(4656),
    [sym_while] = ACTIONS(4656),
    [sym_with] = ACTIONS(4656),
    [sym_gshared] = ACTIONS(4656),
    [sym_traits] = ACTIONS(4656),
    [sym_vector] = ACTIONS(4656),
    [sym_void] = ACTIONS(4656),
    [anon_sym_BQUOTE] = ACTIONS(4658),
    [anon_sym_r_DQUOTE] = ACTIONS(4658),
    [anon_sym_x_DQUOTE] = ACTIONS(4658),
    [anon_sym_DQUOTE] = ACTIONS(4658),
    [anon_sym_i_BQUOTE] = ACTIONS(4658),
    [anon_sym_i_DQUOTE] = ACTIONS(4658),
    [anon_sym_iq_LBRACE] = ACTIONS(4658),
    [aux_sym_char_literal_token1] = ACTIONS(4658),
    [anon_sym_SQUOTE] = ACTIONS(4656),
    [anon_sym___DATE__] = ACTIONS(4656),
    [anon_sym___FILE__] = ACTIONS(4656),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4656),
    [anon_sym___FUNCTION__] = ACTIONS(4656),
    [anon_sym___LINE__] = ACTIONS(4656),
    [anon_sym___MODULE__] = ACTIONS(4656),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4656),
    [anon_sym___TIME__] = ACTIONS(4656),
    [anon_sym___TIMESTAMP__] = ACTIONS(4656),
    [anon_sym___VENDOR__] = ACTIONS(4656),
    [anon_sym___VERSION__] = ACTIONS(4656),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4658),
    [sym_float_literal] = ACTIONS(4658),
    [sym__string] = ACTIONS(4658),
  },
  [1580] = {
    [sym_identifier] = ACTIONS(4586),
    [anon_sym_q_LBRACE] = ACTIONS(4588),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_LBRACE] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4588),
    [anon_sym_AMP] = ACTIONS(4588),
    [anon_sym_DASH] = ACTIONS(4586),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4586),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_BANG] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_DOLLAR] = ACTIONS(4588),
    [anon_sym_STAR] = ACTIONS(4588),
    [anon_sym_TILDE] = ACTIONS(4588),
    [anon_sym_AT] = ACTIONS(4588),
    [sym_bool] = ACTIONS(4586),
    [sym_byte] = ACTIONS(4586),
    [sym_ubyte] = ACTIONS(4586),
    [sym_char] = ACTIONS(4586),
    [sym_short] = ACTIONS(4586),
    [sym_ushort] = ACTIONS(4586),
    [sym_int] = ACTIONS(4586),
    [sym_uint] = ACTIONS(4586),
    [sym_long] = ACTIONS(4586),
    [sym_ulong] = ACTIONS(4586),
    [sym_cent] = ACTIONS(4586),
    [sym_ucent] = ACTIONS(4586),
    [sym_wchar] = ACTIONS(4586),
    [sym_dchar] = ACTIONS(4586),
    [sym_float] = ACTIONS(4586),
    [sym_double] = ACTIONS(4586),
    [sym_real] = ACTIONS(4586),
    [sym_ifloat] = ACTIONS(4586),
    [sym_idouble] = ACTIONS(4586),
    [sym_ireal] = ACTIONS(4586),
    [sym_cfloat] = ACTIONS(4586),
    [sym_cdouble] = ACTIONS(4586),
    [sym_creal] = ACTIONS(4586),
    [sym_size_t] = ACTIONS(4586),
    [sym_ptrdiff_t] = ACTIONS(4586),
    [sym_string] = ACTIONS(4586),
    [sym_cstring] = ACTIONS(4586),
    [sym_dstring] = ACTIONS(4586),
    [sym_wstring] = ACTIONS(4586),
    [sym_noreturn] = ACTIONS(4586),
    [sym_true] = ACTIONS(4586),
    [sym_false] = ACTIONS(4586),
    [sym_null] = ACTIONS(4586),
    [sym_super] = ACTIONS(4586),
    [sym_this] = ACTIONS(4586),
    [sym_abstract] = ACTIONS(4586),
    [sym_alias] = ACTIONS(4586),
    [sym_align] = ACTIONS(4586),
    [sym_asm] = ACTIONS(4586),
    [sym_assert] = ACTIONS(4586),
    [sym_auto] = ACTIONS(4586),
    [sym_break] = ACTIONS(4586),
    [sym_case] = ACTIONS(4586),
    [sym_cast] = ACTIONS(4586),
    [sym_class] = ACTIONS(4586),
    [sym_const] = ACTIONS(4586),
    [sym_continue] = ACTIONS(4586),
    [sym_debug] = ACTIONS(4586),
    [sym_default] = ACTIONS(4586),
    [sym_delegate] = ACTIONS(4586),
    [sym_delete] = ACTIONS(4586),
    [sym_deprecated] = ACTIONS(4586),
    [sym_do] = ACTIONS(4586),
    [sym_else] = ACTIONS(4586),
    [sym_enum] = ACTIONS(4586),
    [sym_export] = ACTIONS(4586),
    [sym_extern] = ACTIONS(4586),
    [sym_final] = ACTIONS(4586),
    [sym_for] = ACTIONS(4586),
    [sym_foreach] = ACTIONS(4586),
    [sym_foreach_reverse] = ACTIONS(4586),
    [sym_function] = ACTIONS(4586),
    [sym_goto] = ACTIONS(4586),
    [sym_if] = ACTIONS(4586),
    [sym_immutable] = ACTIONS(4586),
    [sym_import] = ACTIONS(4586),
    [sym_in] = ACTIONS(4586),
    [sym_inout] = ACTIONS(4586),
    [sym_interface] = ACTIONS(4586),
    [sym_invariant] = ACTIONS(4586),
    [sym_is] = ACTIONS(4586),
    [sym_mixin] = ACTIONS(4586),
    [sym_new] = ACTIONS(4586),
    [sym_nothrow] = ACTIONS(4586),
    [sym_out] = ACTIONS(4586),
    [sym_override] = ACTIONS(4586),
    [sym_package] = ACTIONS(4586),
    [sym_pragma] = ACTIONS(4586),
    [sym_private] = ACTIONS(4586),
    [sym_protected] = ACTIONS(4586),
    [sym_public] = ACTIONS(4586),
    [sym_pure] = ACTIONS(4586),
    [sym_ref] = ACTIONS(4586),
    [sym_return] = ACTIONS(4586),
    [sym_scope] = ACTIONS(4586),
    [sym_shared] = ACTIONS(4586),
    [sym_static] = ACTIONS(4586),
    [sym_struct] = ACTIONS(4586),
    [sym_switch] = ACTIONS(4586),
    [sym_synchronized] = ACTIONS(4586),
    [sym_template] = ACTIONS(4586),
    [sym_throw] = ACTIONS(4586),
    [sym_try] = ACTIONS(4586),
    [sym_typeid] = ACTIONS(4586),
    [sym_typeof] = ACTIONS(4586),
    [sym_union] = ACTIONS(4586),
    [sym_unittest] = ACTIONS(4586),
    [sym_version] = ACTIONS(4586),
    [sym_while] = ACTIONS(4586),
    [sym_with] = ACTIONS(4586),
    [sym_gshared] = ACTIONS(4586),
    [sym_traits] = ACTIONS(4586),
    [sym_vector] = ACTIONS(4586),
    [sym_void] = ACTIONS(4586),
    [anon_sym_BQUOTE] = ACTIONS(4588),
    [anon_sym_r_DQUOTE] = ACTIONS(4588),
    [anon_sym_x_DQUOTE] = ACTIONS(4588),
    [anon_sym_DQUOTE] = ACTIONS(4588),
    [anon_sym_i_BQUOTE] = ACTIONS(4588),
    [anon_sym_i_DQUOTE] = ACTIONS(4588),
    [anon_sym_iq_LBRACE] = ACTIONS(4588),
    [aux_sym_char_literal_token1] = ACTIONS(4588),
    [anon_sym_SQUOTE] = ACTIONS(4586),
    [anon_sym___DATE__] = ACTIONS(4586),
    [anon_sym___FILE__] = ACTIONS(4586),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4586),
    [anon_sym___FUNCTION__] = ACTIONS(4586),
    [anon_sym___LINE__] = ACTIONS(4586),
    [anon_sym___MODULE__] = ACTIONS(4586),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4586),
    [anon_sym___TIME__] = ACTIONS(4586),
    [anon_sym___TIMESTAMP__] = ACTIONS(4586),
    [anon_sym___VENDOR__] = ACTIONS(4586),
    [anon_sym___VERSION__] = ACTIONS(4586),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4588),
    [sym_float_literal] = ACTIONS(4588),
    [sym__string] = ACTIONS(4588),
  },
  [1581] = {
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_q_LBRACE] = ACTIONS(4877),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_LBRACE] = ACTIONS(4877),
    [anon_sym_DOT] = ACTIONS(4877),
    [anon_sym_AMP] = ACTIONS(4877),
    [anon_sym_DASH] = ACTIONS(4875),
    [anon_sym_DASH_DASH] = ACTIONS(4877),
    [anon_sym_PLUS] = ACTIONS(4875),
    [anon_sym_PLUS_PLUS] = ACTIONS(4877),
    [anon_sym_BANG] = ACTIONS(4877),
    [anon_sym_LPAREN] = ACTIONS(4877),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_DOLLAR] = ACTIONS(4877),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_TILDE] = ACTIONS(4877),
    [anon_sym_AT] = ACTIONS(4877),
    [sym_bool] = ACTIONS(4875),
    [sym_byte] = ACTIONS(4875),
    [sym_ubyte] = ACTIONS(4875),
    [sym_char] = ACTIONS(4875),
    [sym_short] = ACTIONS(4875),
    [sym_ushort] = ACTIONS(4875),
    [sym_int] = ACTIONS(4875),
    [sym_uint] = ACTIONS(4875),
    [sym_long] = ACTIONS(4875),
    [sym_ulong] = ACTIONS(4875),
    [sym_cent] = ACTIONS(4875),
    [sym_ucent] = ACTIONS(4875),
    [sym_wchar] = ACTIONS(4875),
    [sym_dchar] = ACTIONS(4875),
    [sym_float] = ACTIONS(4875),
    [sym_double] = ACTIONS(4875),
    [sym_real] = ACTIONS(4875),
    [sym_ifloat] = ACTIONS(4875),
    [sym_idouble] = ACTIONS(4875),
    [sym_ireal] = ACTIONS(4875),
    [sym_cfloat] = ACTIONS(4875),
    [sym_cdouble] = ACTIONS(4875),
    [sym_creal] = ACTIONS(4875),
    [sym_size_t] = ACTIONS(4875),
    [sym_ptrdiff_t] = ACTIONS(4875),
    [sym_string] = ACTIONS(4875),
    [sym_cstring] = ACTIONS(4875),
    [sym_dstring] = ACTIONS(4875),
    [sym_wstring] = ACTIONS(4875),
    [sym_noreturn] = ACTIONS(4875),
    [sym_true] = ACTIONS(4875),
    [sym_false] = ACTIONS(4875),
    [sym_null] = ACTIONS(4875),
    [sym_super] = ACTIONS(4875),
    [sym_this] = ACTIONS(4875),
    [sym_abstract] = ACTIONS(4875),
    [sym_alias] = ACTIONS(4875),
    [sym_align] = ACTIONS(4875),
    [sym_asm] = ACTIONS(4875),
    [sym_assert] = ACTIONS(4875),
    [sym_auto] = ACTIONS(4875),
    [sym_break] = ACTIONS(4875),
    [sym_case] = ACTIONS(4875),
    [sym_cast] = ACTIONS(4875),
    [sym_class] = ACTIONS(4875),
    [sym_const] = ACTIONS(4875),
    [sym_continue] = ACTIONS(4875),
    [sym_debug] = ACTIONS(4875),
    [sym_default] = ACTIONS(4875),
    [sym_delegate] = ACTIONS(4875),
    [sym_delete] = ACTIONS(4875),
    [sym_deprecated] = ACTIONS(4875),
    [sym_do] = ACTIONS(4875),
    [sym_else] = ACTIONS(4875),
    [sym_enum] = ACTIONS(4875),
    [sym_export] = ACTIONS(4875),
    [sym_extern] = ACTIONS(4875),
    [sym_final] = ACTIONS(4875),
    [sym_for] = ACTIONS(4875),
    [sym_foreach] = ACTIONS(4875),
    [sym_foreach_reverse] = ACTIONS(4875),
    [sym_function] = ACTIONS(4875),
    [sym_goto] = ACTIONS(4875),
    [sym_if] = ACTIONS(4875),
    [sym_immutable] = ACTIONS(4875),
    [sym_import] = ACTIONS(4875),
    [sym_in] = ACTIONS(4875),
    [sym_inout] = ACTIONS(4875),
    [sym_interface] = ACTIONS(4875),
    [sym_invariant] = ACTIONS(4875),
    [sym_is] = ACTIONS(4875),
    [sym_mixin] = ACTIONS(4875),
    [sym_new] = ACTIONS(4875),
    [sym_nothrow] = ACTIONS(4875),
    [sym_out] = ACTIONS(4875),
    [sym_override] = ACTIONS(4875),
    [sym_package] = ACTIONS(4875),
    [sym_pragma] = ACTIONS(4875),
    [sym_private] = ACTIONS(4875),
    [sym_protected] = ACTIONS(4875),
    [sym_public] = ACTIONS(4875),
    [sym_pure] = ACTIONS(4875),
    [sym_ref] = ACTIONS(4875),
    [sym_return] = ACTIONS(4875),
    [sym_scope] = ACTIONS(4875),
    [sym_shared] = ACTIONS(4875),
    [sym_static] = ACTIONS(4875),
    [sym_struct] = ACTIONS(4875),
    [sym_switch] = ACTIONS(4875),
    [sym_synchronized] = ACTIONS(4875),
    [sym_template] = ACTIONS(4875),
    [sym_throw] = ACTIONS(4875),
    [sym_try] = ACTIONS(4875),
    [sym_typeid] = ACTIONS(4875),
    [sym_typeof] = ACTIONS(4875),
    [sym_union] = ACTIONS(4875),
    [sym_unittest] = ACTIONS(4875),
    [sym_version] = ACTIONS(4875),
    [sym_while] = ACTIONS(4875),
    [sym_with] = ACTIONS(4875),
    [sym_gshared] = ACTIONS(4875),
    [sym_traits] = ACTIONS(4875),
    [sym_vector] = ACTIONS(4875),
    [sym_void] = ACTIONS(4875),
    [anon_sym_BQUOTE] = ACTIONS(4877),
    [anon_sym_r_DQUOTE] = ACTIONS(4877),
    [anon_sym_x_DQUOTE] = ACTIONS(4877),
    [anon_sym_DQUOTE] = ACTIONS(4877),
    [anon_sym_i_BQUOTE] = ACTIONS(4877),
    [anon_sym_i_DQUOTE] = ACTIONS(4877),
    [anon_sym_iq_LBRACE] = ACTIONS(4877),
    [aux_sym_char_literal_token1] = ACTIONS(4877),
    [anon_sym_SQUOTE] = ACTIONS(4875),
    [anon_sym___DATE__] = ACTIONS(4875),
    [anon_sym___FILE__] = ACTIONS(4875),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4875),
    [anon_sym___FUNCTION__] = ACTIONS(4875),
    [anon_sym___LINE__] = ACTIONS(4875),
    [anon_sym___MODULE__] = ACTIONS(4875),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4875),
    [anon_sym___TIME__] = ACTIONS(4875),
    [anon_sym___TIMESTAMP__] = ACTIONS(4875),
    [anon_sym___VENDOR__] = ACTIONS(4875),
    [anon_sym___VERSION__] = ACTIONS(4875),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4877),
    [sym_float_literal] = ACTIONS(4877),
    [sym__string] = ACTIONS(4877),
  },
  [1582] = {
    [sym_identifier] = ACTIONS(4582),
    [anon_sym_q_LBRACE] = ACTIONS(4584),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_LBRACE] = ACTIONS(4584),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4582),
    [anon_sym_PLUS_PLUS] = ACTIONS(4584),
    [anon_sym_BANG] = ACTIONS(4584),
    [anon_sym_LPAREN] = ACTIONS(4584),
    [anon_sym_RPAREN] = ACTIONS(4584),
    [anon_sym_LBRACK] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_DOLLAR] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4584),
    [anon_sym_TILDE] = ACTIONS(4584),
    [anon_sym_AT] = ACTIONS(4584),
    [sym_bool] = ACTIONS(4582),
    [sym_byte] = ACTIONS(4582),
    [sym_ubyte] = ACTIONS(4582),
    [sym_char] = ACTIONS(4582),
    [sym_short] = ACTIONS(4582),
    [sym_ushort] = ACTIONS(4582),
    [sym_int] = ACTIONS(4582),
    [sym_uint] = ACTIONS(4582),
    [sym_long] = ACTIONS(4582),
    [sym_ulong] = ACTIONS(4582),
    [sym_cent] = ACTIONS(4582),
    [sym_ucent] = ACTIONS(4582),
    [sym_wchar] = ACTIONS(4582),
    [sym_dchar] = ACTIONS(4582),
    [sym_float] = ACTIONS(4582),
    [sym_double] = ACTIONS(4582),
    [sym_real] = ACTIONS(4582),
    [sym_ifloat] = ACTIONS(4582),
    [sym_idouble] = ACTIONS(4582),
    [sym_ireal] = ACTIONS(4582),
    [sym_cfloat] = ACTIONS(4582),
    [sym_cdouble] = ACTIONS(4582),
    [sym_creal] = ACTIONS(4582),
    [sym_size_t] = ACTIONS(4582),
    [sym_ptrdiff_t] = ACTIONS(4582),
    [sym_string] = ACTIONS(4582),
    [sym_cstring] = ACTIONS(4582),
    [sym_dstring] = ACTIONS(4582),
    [sym_wstring] = ACTIONS(4582),
    [sym_noreturn] = ACTIONS(4582),
    [sym_true] = ACTIONS(4582),
    [sym_false] = ACTIONS(4582),
    [sym_null] = ACTIONS(4582),
    [sym_super] = ACTIONS(4582),
    [sym_this] = ACTIONS(4582),
    [sym_abstract] = ACTIONS(4582),
    [sym_alias] = ACTIONS(4582),
    [sym_align] = ACTIONS(4582),
    [sym_asm] = ACTIONS(4582),
    [sym_assert] = ACTIONS(4582),
    [sym_auto] = ACTIONS(4582),
    [sym_break] = ACTIONS(4582),
    [sym_case] = ACTIONS(4582),
    [sym_cast] = ACTIONS(4582),
    [sym_class] = ACTIONS(4582),
    [sym_const] = ACTIONS(4582),
    [sym_continue] = ACTIONS(4582),
    [sym_debug] = ACTIONS(4582),
    [sym_default] = ACTIONS(4582),
    [sym_delegate] = ACTIONS(4582),
    [sym_delete] = ACTIONS(4582),
    [sym_deprecated] = ACTIONS(4582),
    [sym_do] = ACTIONS(4582),
    [sym_else] = ACTIONS(4582),
    [sym_enum] = ACTIONS(4582),
    [sym_export] = ACTIONS(4582),
    [sym_extern] = ACTIONS(4582),
    [sym_final] = ACTIONS(4582),
    [sym_for] = ACTIONS(4582),
    [sym_foreach] = ACTIONS(4582),
    [sym_foreach_reverse] = ACTIONS(4582),
    [sym_function] = ACTIONS(4582),
    [sym_goto] = ACTIONS(4582),
    [sym_if] = ACTIONS(4582),
    [sym_immutable] = ACTIONS(4582),
    [sym_import] = ACTIONS(4582),
    [sym_in] = ACTIONS(4582),
    [sym_inout] = ACTIONS(4582),
    [sym_interface] = ACTIONS(4582),
    [sym_invariant] = ACTIONS(4582),
    [sym_is] = ACTIONS(4582),
    [sym_mixin] = ACTIONS(4582),
    [sym_new] = ACTIONS(4582),
    [sym_nothrow] = ACTIONS(4582),
    [sym_out] = ACTIONS(4582),
    [sym_override] = ACTIONS(4582),
    [sym_package] = ACTIONS(4582),
    [sym_pragma] = ACTIONS(4582),
    [sym_private] = ACTIONS(4582),
    [sym_protected] = ACTIONS(4582),
    [sym_public] = ACTIONS(4582),
    [sym_pure] = ACTIONS(4582),
    [sym_ref] = ACTIONS(4582),
    [sym_return] = ACTIONS(4582),
    [sym_scope] = ACTIONS(4582),
    [sym_shared] = ACTIONS(4582),
    [sym_static] = ACTIONS(4582),
    [sym_struct] = ACTIONS(4582),
    [sym_switch] = ACTIONS(4582),
    [sym_synchronized] = ACTIONS(4582),
    [sym_template] = ACTIONS(4582),
    [sym_throw] = ACTIONS(4582),
    [sym_try] = ACTIONS(4582),
    [sym_typeid] = ACTIONS(4582),
    [sym_typeof] = ACTIONS(4582),
    [sym_union] = ACTIONS(4582),
    [sym_unittest] = ACTIONS(4582),
    [sym_version] = ACTIONS(4582),
    [sym_while] = ACTIONS(4582),
    [sym_with] = ACTIONS(4582),
    [sym_gshared] = ACTIONS(4582),
    [sym_traits] = ACTIONS(4582),
    [sym_vector] = ACTIONS(4582),
    [sym_void] = ACTIONS(4582),
    [anon_sym_BQUOTE] = ACTIONS(4584),
    [anon_sym_r_DQUOTE] = ACTIONS(4584),
    [anon_sym_x_DQUOTE] = ACTIONS(4584),
    [anon_sym_DQUOTE] = ACTIONS(4584),
    [anon_sym_i_BQUOTE] = ACTIONS(4584),
    [anon_sym_i_DQUOTE] = ACTIONS(4584),
    [anon_sym_iq_LBRACE] = ACTIONS(4584),
    [aux_sym_char_literal_token1] = ACTIONS(4584),
    [anon_sym_SQUOTE] = ACTIONS(4582),
    [anon_sym___DATE__] = ACTIONS(4582),
    [anon_sym___FILE__] = ACTIONS(4582),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4582),
    [anon_sym___FUNCTION__] = ACTIONS(4582),
    [anon_sym___LINE__] = ACTIONS(4582),
    [anon_sym___MODULE__] = ACTIONS(4582),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4582),
    [anon_sym___TIME__] = ACTIONS(4582),
    [anon_sym___TIMESTAMP__] = ACTIONS(4582),
    [anon_sym___VENDOR__] = ACTIONS(4582),
    [anon_sym___VERSION__] = ACTIONS(4582),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4584),
    [sym_float_literal] = ACTIONS(4584),
    [sym__string] = ACTIONS(4584),
  },
  [1583] = {
    [sym_identifier] = ACTIONS(4562),
    [anon_sym_q_LBRACE] = ACTIONS(4564),
    [anon_sym_RBRACE] = ACTIONS(4564),
    [anon_sym_LBRACE] = ACTIONS(4564),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4562),
    [anon_sym_DASH_DASH] = ACTIONS(4564),
    [anon_sym_PLUS] = ACTIONS(4562),
    [anon_sym_PLUS_PLUS] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_LPAREN] = ACTIONS(4564),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_LBRACK] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_DOLLAR] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_TILDE] = ACTIONS(4564),
    [anon_sym_AT] = ACTIONS(4564),
    [sym_bool] = ACTIONS(4562),
    [sym_byte] = ACTIONS(4562),
    [sym_ubyte] = ACTIONS(4562),
    [sym_char] = ACTIONS(4562),
    [sym_short] = ACTIONS(4562),
    [sym_ushort] = ACTIONS(4562),
    [sym_int] = ACTIONS(4562),
    [sym_uint] = ACTIONS(4562),
    [sym_long] = ACTIONS(4562),
    [sym_ulong] = ACTIONS(4562),
    [sym_cent] = ACTIONS(4562),
    [sym_ucent] = ACTIONS(4562),
    [sym_wchar] = ACTIONS(4562),
    [sym_dchar] = ACTIONS(4562),
    [sym_float] = ACTIONS(4562),
    [sym_double] = ACTIONS(4562),
    [sym_real] = ACTIONS(4562),
    [sym_ifloat] = ACTIONS(4562),
    [sym_idouble] = ACTIONS(4562),
    [sym_ireal] = ACTIONS(4562),
    [sym_cfloat] = ACTIONS(4562),
    [sym_cdouble] = ACTIONS(4562),
    [sym_creal] = ACTIONS(4562),
    [sym_size_t] = ACTIONS(4562),
    [sym_ptrdiff_t] = ACTIONS(4562),
    [sym_string] = ACTIONS(4562),
    [sym_cstring] = ACTIONS(4562),
    [sym_dstring] = ACTIONS(4562),
    [sym_wstring] = ACTIONS(4562),
    [sym_noreturn] = ACTIONS(4562),
    [sym_true] = ACTIONS(4562),
    [sym_false] = ACTIONS(4562),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(4562),
    [sym_this] = ACTIONS(4562),
    [sym_abstract] = ACTIONS(4562),
    [sym_alias] = ACTIONS(4562),
    [sym_align] = ACTIONS(4562),
    [sym_asm] = ACTIONS(4562),
    [sym_assert] = ACTIONS(4562),
    [sym_auto] = ACTIONS(4562),
    [sym_break] = ACTIONS(4562),
    [sym_case] = ACTIONS(4562),
    [sym_cast] = ACTIONS(4562),
    [sym_class] = ACTIONS(4562),
    [sym_const] = ACTIONS(4562),
    [sym_continue] = ACTIONS(4562),
    [sym_debug] = ACTIONS(4562),
    [sym_default] = ACTIONS(4562),
    [sym_delegate] = ACTIONS(4562),
    [sym_delete] = ACTIONS(4562),
    [sym_deprecated] = ACTIONS(4562),
    [sym_do] = ACTIONS(4562),
    [sym_else] = ACTIONS(4562),
    [sym_enum] = ACTIONS(4562),
    [sym_export] = ACTIONS(4562),
    [sym_extern] = ACTIONS(4562),
    [sym_final] = ACTIONS(4562),
    [sym_for] = ACTIONS(4562),
    [sym_foreach] = ACTIONS(4562),
    [sym_foreach_reverse] = ACTIONS(4562),
    [sym_function] = ACTIONS(4562),
    [sym_goto] = ACTIONS(4562),
    [sym_if] = ACTIONS(4562),
    [sym_immutable] = ACTIONS(4562),
    [sym_import] = ACTIONS(4562),
    [sym_in] = ACTIONS(4562),
    [sym_inout] = ACTIONS(4562),
    [sym_interface] = ACTIONS(4562),
    [sym_invariant] = ACTIONS(4562),
    [sym_is] = ACTIONS(4562),
    [sym_mixin] = ACTIONS(4562),
    [sym_new] = ACTIONS(4562),
    [sym_nothrow] = ACTIONS(4562),
    [sym_out] = ACTIONS(4562),
    [sym_override] = ACTIONS(4562),
    [sym_package] = ACTIONS(4562),
    [sym_pragma] = ACTIONS(4562),
    [sym_private] = ACTIONS(4562),
    [sym_protected] = ACTIONS(4562),
    [sym_public] = ACTIONS(4562),
    [sym_pure] = ACTIONS(4562),
    [sym_ref] = ACTIONS(4562),
    [sym_return] = ACTIONS(4562),
    [sym_scope] = ACTIONS(4562),
    [sym_shared] = ACTIONS(4562),
    [sym_static] = ACTIONS(4562),
    [sym_struct] = ACTIONS(4562),
    [sym_switch] = ACTIONS(4562),
    [sym_synchronized] = ACTIONS(4562),
    [sym_template] = ACTIONS(4562),
    [sym_throw] = ACTIONS(4562),
    [sym_try] = ACTIONS(4562),
    [sym_typeid] = ACTIONS(4562),
    [sym_typeof] = ACTIONS(4562),
    [sym_union] = ACTIONS(4562),
    [sym_unittest] = ACTIONS(4562),
    [sym_version] = ACTIONS(4562),
    [sym_while] = ACTIONS(4562),
    [sym_with] = ACTIONS(4562),
    [sym_gshared] = ACTIONS(4562),
    [sym_traits] = ACTIONS(4562),
    [sym_vector] = ACTIONS(4562),
    [sym_void] = ACTIONS(4562),
    [anon_sym_BQUOTE] = ACTIONS(4564),
    [anon_sym_r_DQUOTE] = ACTIONS(4564),
    [anon_sym_x_DQUOTE] = ACTIONS(4564),
    [anon_sym_DQUOTE] = ACTIONS(4564),
    [anon_sym_i_BQUOTE] = ACTIONS(4564),
    [anon_sym_i_DQUOTE] = ACTIONS(4564),
    [anon_sym_iq_LBRACE] = ACTIONS(4564),
    [aux_sym_char_literal_token1] = ACTIONS(4564),
    [anon_sym_SQUOTE] = ACTIONS(4562),
    [anon_sym___DATE__] = ACTIONS(4562),
    [anon_sym___FILE__] = ACTIONS(4562),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4562),
    [anon_sym___FUNCTION__] = ACTIONS(4562),
    [anon_sym___LINE__] = ACTIONS(4562),
    [anon_sym___MODULE__] = ACTIONS(4562),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4562),
    [anon_sym___TIME__] = ACTIONS(4562),
    [anon_sym___TIMESTAMP__] = ACTIONS(4562),
    [anon_sym___VENDOR__] = ACTIONS(4562),
    [anon_sym___VERSION__] = ACTIONS(4562),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4564),
    [sym_float_literal] = ACTIONS(4564),
    [sym__string] = ACTIONS(4564),
  },
  [1584] = {
    [sym_identifier] = ACTIONS(4380),
    [anon_sym_q_LBRACE] = ACTIONS(4382),
    [anon_sym_RBRACE] = ACTIONS(4382),
    [anon_sym_LBRACE] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_DASH] = ACTIONS(4380),
    [anon_sym_DASH_DASH] = ACTIONS(4382),
    [anon_sym_PLUS] = ACTIONS(4380),
    [anon_sym_PLUS_PLUS] = ACTIONS(4382),
    [anon_sym_BANG] = ACTIONS(4382),
    [anon_sym_LPAREN] = ACTIONS(4382),
    [anon_sym_RPAREN] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(4382),
    [anon_sym_SEMI] = ACTIONS(4382),
    [anon_sym_DOLLAR] = ACTIONS(4382),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_TILDE] = ACTIONS(4382),
    [anon_sym_AT] = ACTIONS(4382),
    [sym_bool] = ACTIONS(4380),
    [sym_byte] = ACTIONS(4380),
    [sym_ubyte] = ACTIONS(4380),
    [sym_char] = ACTIONS(4380),
    [sym_short] = ACTIONS(4380),
    [sym_ushort] = ACTIONS(4380),
    [sym_int] = ACTIONS(4380),
    [sym_uint] = ACTIONS(4380),
    [sym_long] = ACTIONS(4380),
    [sym_ulong] = ACTIONS(4380),
    [sym_cent] = ACTIONS(4380),
    [sym_ucent] = ACTIONS(4380),
    [sym_wchar] = ACTIONS(4380),
    [sym_dchar] = ACTIONS(4380),
    [sym_float] = ACTIONS(4380),
    [sym_double] = ACTIONS(4380),
    [sym_real] = ACTIONS(4380),
    [sym_ifloat] = ACTIONS(4380),
    [sym_idouble] = ACTIONS(4380),
    [sym_ireal] = ACTIONS(4380),
    [sym_cfloat] = ACTIONS(4380),
    [sym_cdouble] = ACTIONS(4380),
    [sym_creal] = ACTIONS(4380),
    [sym_size_t] = ACTIONS(4380),
    [sym_ptrdiff_t] = ACTIONS(4380),
    [sym_string] = ACTIONS(4380),
    [sym_cstring] = ACTIONS(4380),
    [sym_dstring] = ACTIONS(4380),
    [sym_wstring] = ACTIONS(4380),
    [sym_noreturn] = ACTIONS(4380),
    [sym_true] = ACTIONS(4380),
    [sym_false] = ACTIONS(4380),
    [sym_null] = ACTIONS(4380),
    [sym_super] = ACTIONS(4380),
    [sym_this] = ACTIONS(4380),
    [sym_abstract] = ACTIONS(4380),
    [sym_alias] = ACTIONS(4380),
    [sym_align] = ACTIONS(4380),
    [sym_asm] = ACTIONS(4380),
    [sym_assert] = ACTIONS(4380),
    [sym_auto] = ACTIONS(4380),
    [sym_break] = ACTIONS(4380),
    [sym_case] = ACTIONS(4380),
    [sym_cast] = ACTIONS(4380),
    [sym_class] = ACTIONS(4380),
    [sym_const] = ACTIONS(4380),
    [sym_continue] = ACTIONS(4380),
    [sym_debug] = ACTIONS(4380),
    [sym_default] = ACTIONS(4380),
    [sym_delegate] = ACTIONS(4380),
    [sym_delete] = ACTIONS(4380),
    [sym_deprecated] = ACTIONS(4380),
    [sym_do] = ACTIONS(4380),
    [sym_else] = ACTIONS(4380),
    [sym_enum] = ACTIONS(4380),
    [sym_export] = ACTIONS(4380),
    [sym_extern] = ACTIONS(4380),
    [sym_final] = ACTIONS(4380),
    [sym_for] = ACTIONS(4380),
    [sym_foreach] = ACTIONS(4380),
    [sym_foreach_reverse] = ACTIONS(4380),
    [sym_function] = ACTIONS(4380),
    [sym_goto] = ACTIONS(4380),
    [sym_if] = ACTIONS(4380),
    [sym_immutable] = ACTIONS(4380),
    [sym_import] = ACTIONS(4380),
    [sym_in] = ACTIONS(4380),
    [sym_inout] = ACTIONS(4380),
    [sym_interface] = ACTIONS(4380),
    [sym_invariant] = ACTIONS(4380),
    [sym_is] = ACTIONS(4380),
    [sym_mixin] = ACTIONS(4380),
    [sym_new] = ACTIONS(4380),
    [sym_nothrow] = ACTIONS(4380),
    [sym_out] = ACTIONS(4380),
    [sym_override] = ACTIONS(4380),
    [sym_package] = ACTIONS(4380),
    [sym_pragma] = ACTIONS(4380),
    [sym_private] = ACTIONS(4380),
    [sym_protected] = ACTIONS(4380),
    [sym_public] = ACTIONS(4380),
    [sym_pure] = ACTIONS(4380),
    [sym_ref] = ACTIONS(4380),
    [sym_return] = ACTIONS(4380),
    [sym_scope] = ACTIONS(4380),
    [sym_shared] = ACTIONS(4380),
    [sym_static] = ACTIONS(4380),
    [sym_struct] = ACTIONS(4380),
    [sym_switch] = ACTIONS(4380),
    [sym_synchronized] = ACTIONS(4380),
    [sym_template] = ACTIONS(4380),
    [sym_throw] = ACTIONS(4380),
    [sym_try] = ACTIONS(4380),
    [sym_typeid] = ACTIONS(4380),
    [sym_typeof] = ACTIONS(4380),
    [sym_union] = ACTIONS(4380),
    [sym_unittest] = ACTIONS(4380),
    [sym_version] = ACTIONS(4380),
    [sym_while] = ACTIONS(4380),
    [sym_with] = ACTIONS(4380),
    [sym_gshared] = ACTIONS(4380),
    [sym_traits] = ACTIONS(4380),
    [sym_vector] = ACTIONS(4380),
    [sym_void] = ACTIONS(4380),
    [anon_sym_BQUOTE] = ACTIONS(4382),
    [anon_sym_r_DQUOTE] = ACTIONS(4382),
    [anon_sym_x_DQUOTE] = ACTIONS(4382),
    [anon_sym_DQUOTE] = ACTIONS(4382),
    [anon_sym_i_BQUOTE] = ACTIONS(4382),
    [anon_sym_i_DQUOTE] = ACTIONS(4382),
    [anon_sym_iq_LBRACE] = ACTIONS(4382),
    [aux_sym_char_literal_token1] = ACTIONS(4382),
    [anon_sym_SQUOTE] = ACTIONS(4380),
    [anon_sym___DATE__] = ACTIONS(4380),
    [anon_sym___FILE__] = ACTIONS(4380),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4380),
    [anon_sym___FUNCTION__] = ACTIONS(4380),
    [anon_sym___LINE__] = ACTIONS(4380),
    [anon_sym___MODULE__] = ACTIONS(4380),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4380),
    [anon_sym___TIME__] = ACTIONS(4380),
    [anon_sym___TIMESTAMP__] = ACTIONS(4380),
    [anon_sym___VENDOR__] = ACTIONS(4380),
    [anon_sym___VERSION__] = ACTIONS(4380),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4382),
    [sym_float_literal] = ACTIONS(4382),
    [sym__string] = ACTIONS(4382),
  },
  [1585] = {
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_q_LBRACE] = ACTIONS(4536),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_BANG] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_DOLLAR] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AT] = ACTIONS(4536),
    [sym_bool] = ACTIONS(4534),
    [sym_byte] = ACTIONS(4534),
    [sym_ubyte] = ACTIONS(4534),
    [sym_char] = ACTIONS(4534),
    [sym_short] = ACTIONS(4534),
    [sym_ushort] = ACTIONS(4534),
    [sym_int] = ACTIONS(4534),
    [sym_uint] = ACTIONS(4534),
    [sym_long] = ACTIONS(4534),
    [sym_ulong] = ACTIONS(4534),
    [sym_cent] = ACTIONS(4534),
    [sym_ucent] = ACTIONS(4534),
    [sym_wchar] = ACTIONS(4534),
    [sym_dchar] = ACTIONS(4534),
    [sym_float] = ACTIONS(4534),
    [sym_double] = ACTIONS(4534),
    [sym_real] = ACTIONS(4534),
    [sym_ifloat] = ACTIONS(4534),
    [sym_idouble] = ACTIONS(4534),
    [sym_ireal] = ACTIONS(4534),
    [sym_cfloat] = ACTIONS(4534),
    [sym_cdouble] = ACTIONS(4534),
    [sym_creal] = ACTIONS(4534),
    [sym_size_t] = ACTIONS(4534),
    [sym_ptrdiff_t] = ACTIONS(4534),
    [sym_string] = ACTIONS(4534),
    [sym_cstring] = ACTIONS(4534),
    [sym_dstring] = ACTIONS(4534),
    [sym_wstring] = ACTIONS(4534),
    [sym_noreturn] = ACTIONS(4534),
    [sym_true] = ACTIONS(4534),
    [sym_false] = ACTIONS(4534),
    [sym_null] = ACTIONS(4534),
    [sym_super] = ACTIONS(4534),
    [sym_this] = ACTIONS(4534),
    [sym_abstract] = ACTIONS(4534),
    [sym_alias] = ACTIONS(4534),
    [sym_align] = ACTIONS(4534),
    [sym_asm] = ACTIONS(4534),
    [sym_assert] = ACTIONS(4534),
    [sym_auto] = ACTIONS(4534),
    [sym_break] = ACTIONS(4534),
    [sym_case] = ACTIONS(4534),
    [sym_cast] = ACTIONS(4534),
    [sym_class] = ACTIONS(4534),
    [sym_const] = ACTIONS(4534),
    [sym_continue] = ACTIONS(4534),
    [sym_debug] = ACTIONS(4534),
    [sym_default] = ACTIONS(4534),
    [sym_delegate] = ACTIONS(4534),
    [sym_delete] = ACTIONS(4534),
    [sym_deprecated] = ACTIONS(4534),
    [sym_do] = ACTIONS(4534),
    [sym_else] = ACTIONS(4534),
    [sym_enum] = ACTIONS(4534),
    [sym_export] = ACTIONS(4534),
    [sym_extern] = ACTIONS(4534),
    [sym_final] = ACTIONS(4534),
    [sym_for] = ACTIONS(4534),
    [sym_foreach] = ACTIONS(4534),
    [sym_foreach_reverse] = ACTIONS(4534),
    [sym_function] = ACTIONS(4534),
    [sym_goto] = ACTIONS(4534),
    [sym_if] = ACTIONS(4534),
    [sym_immutable] = ACTIONS(4534),
    [sym_import] = ACTIONS(4534),
    [sym_in] = ACTIONS(4534),
    [sym_inout] = ACTIONS(4534),
    [sym_interface] = ACTIONS(4534),
    [sym_invariant] = ACTIONS(4534),
    [sym_is] = ACTIONS(4534),
    [sym_mixin] = ACTIONS(4534),
    [sym_new] = ACTIONS(4534),
    [sym_nothrow] = ACTIONS(4534),
    [sym_out] = ACTIONS(4534),
    [sym_override] = ACTIONS(4534),
    [sym_package] = ACTIONS(4534),
    [sym_pragma] = ACTIONS(4534),
    [sym_private] = ACTIONS(4534),
    [sym_protected] = ACTIONS(4534),
    [sym_public] = ACTIONS(4534),
    [sym_pure] = ACTIONS(4534),
    [sym_ref] = ACTIONS(4534),
    [sym_return] = ACTIONS(4534),
    [sym_scope] = ACTIONS(4534),
    [sym_shared] = ACTIONS(4534),
    [sym_static] = ACTIONS(4534),
    [sym_struct] = ACTIONS(4534),
    [sym_switch] = ACTIONS(4534),
    [sym_synchronized] = ACTIONS(4534),
    [sym_template] = ACTIONS(4534),
    [sym_throw] = ACTIONS(4534),
    [sym_try] = ACTIONS(4534),
    [sym_typeid] = ACTIONS(4534),
    [sym_typeof] = ACTIONS(4534),
    [sym_union] = ACTIONS(4534),
    [sym_unittest] = ACTIONS(4534),
    [sym_version] = ACTIONS(4534),
    [sym_while] = ACTIONS(4534),
    [sym_with] = ACTIONS(4534),
    [sym_gshared] = ACTIONS(4534),
    [sym_traits] = ACTIONS(4534),
    [sym_vector] = ACTIONS(4534),
    [sym_void] = ACTIONS(4534),
    [anon_sym_BQUOTE] = ACTIONS(4536),
    [anon_sym_r_DQUOTE] = ACTIONS(4536),
    [anon_sym_x_DQUOTE] = ACTIONS(4536),
    [anon_sym_DQUOTE] = ACTIONS(4536),
    [anon_sym_i_BQUOTE] = ACTIONS(4536),
    [anon_sym_i_DQUOTE] = ACTIONS(4536),
    [anon_sym_iq_LBRACE] = ACTIONS(4536),
    [aux_sym_char_literal_token1] = ACTIONS(4536),
    [anon_sym_SQUOTE] = ACTIONS(4534),
    [anon_sym___DATE__] = ACTIONS(4534),
    [anon_sym___FILE__] = ACTIONS(4534),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4534),
    [anon_sym___FUNCTION__] = ACTIONS(4534),
    [anon_sym___LINE__] = ACTIONS(4534),
    [anon_sym___MODULE__] = ACTIONS(4534),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4534),
    [anon_sym___TIME__] = ACTIONS(4534),
    [anon_sym___TIMESTAMP__] = ACTIONS(4534),
    [anon_sym___VENDOR__] = ACTIONS(4534),
    [anon_sym___VERSION__] = ACTIONS(4534),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4536),
    [sym_float_literal] = ACTIONS(4536),
    [sym__string] = ACTIONS(4536),
  },
  [1586] = {
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_q_LBRACE] = ACTIONS(4528),
    [anon_sym_RBRACE] = ACTIONS(4528),
    [anon_sym_LBRACE] = ACTIONS(4528),
    [anon_sym_DOT] = ACTIONS(4528),
    [anon_sym_AMP] = ACTIONS(4528),
    [anon_sym_DASH] = ACTIONS(4526),
    [anon_sym_DASH_DASH] = ACTIONS(4528),
    [anon_sym_PLUS] = ACTIONS(4526),
    [anon_sym_PLUS_PLUS] = ACTIONS(4528),
    [anon_sym_BANG] = ACTIONS(4528),
    [anon_sym_LPAREN] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_DOLLAR] = ACTIONS(4528),
    [anon_sym_STAR] = ACTIONS(4528),
    [anon_sym_TILDE] = ACTIONS(4528),
    [anon_sym_AT] = ACTIONS(4528),
    [sym_bool] = ACTIONS(4526),
    [sym_byte] = ACTIONS(4526),
    [sym_ubyte] = ACTIONS(4526),
    [sym_char] = ACTIONS(4526),
    [sym_short] = ACTIONS(4526),
    [sym_ushort] = ACTIONS(4526),
    [sym_int] = ACTIONS(4526),
    [sym_uint] = ACTIONS(4526),
    [sym_long] = ACTIONS(4526),
    [sym_ulong] = ACTIONS(4526),
    [sym_cent] = ACTIONS(4526),
    [sym_ucent] = ACTIONS(4526),
    [sym_wchar] = ACTIONS(4526),
    [sym_dchar] = ACTIONS(4526),
    [sym_float] = ACTIONS(4526),
    [sym_double] = ACTIONS(4526),
    [sym_real] = ACTIONS(4526),
    [sym_ifloat] = ACTIONS(4526),
    [sym_idouble] = ACTIONS(4526),
    [sym_ireal] = ACTIONS(4526),
    [sym_cfloat] = ACTIONS(4526),
    [sym_cdouble] = ACTIONS(4526),
    [sym_creal] = ACTIONS(4526),
    [sym_size_t] = ACTIONS(4526),
    [sym_ptrdiff_t] = ACTIONS(4526),
    [sym_string] = ACTIONS(4526),
    [sym_cstring] = ACTIONS(4526),
    [sym_dstring] = ACTIONS(4526),
    [sym_wstring] = ACTIONS(4526),
    [sym_noreturn] = ACTIONS(4526),
    [sym_true] = ACTIONS(4526),
    [sym_false] = ACTIONS(4526),
    [sym_null] = ACTIONS(4526),
    [sym_super] = ACTIONS(4526),
    [sym_this] = ACTIONS(4526),
    [sym_abstract] = ACTIONS(4526),
    [sym_alias] = ACTIONS(4526),
    [sym_align] = ACTIONS(4526),
    [sym_asm] = ACTIONS(4526),
    [sym_assert] = ACTIONS(4526),
    [sym_auto] = ACTIONS(4526),
    [sym_break] = ACTIONS(4526),
    [sym_case] = ACTIONS(4526),
    [sym_cast] = ACTIONS(4526),
    [sym_class] = ACTIONS(4526),
    [sym_const] = ACTIONS(4526),
    [sym_continue] = ACTIONS(4526),
    [sym_debug] = ACTIONS(4526),
    [sym_default] = ACTIONS(4526),
    [sym_delegate] = ACTIONS(4526),
    [sym_delete] = ACTIONS(4526),
    [sym_deprecated] = ACTIONS(4526),
    [sym_do] = ACTIONS(4526),
    [sym_else] = ACTIONS(4526),
    [sym_enum] = ACTIONS(4526),
    [sym_export] = ACTIONS(4526),
    [sym_extern] = ACTIONS(4526),
    [sym_final] = ACTIONS(4526),
    [sym_for] = ACTIONS(4526),
    [sym_foreach] = ACTIONS(4526),
    [sym_foreach_reverse] = ACTIONS(4526),
    [sym_function] = ACTIONS(4526),
    [sym_goto] = ACTIONS(4526),
    [sym_if] = ACTIONS(4526),
    [sym_immutable] = ACTIONS(4526),
    [sym_import] = ACTIONS(4526),
    [sym_in] = ACTIONS(4526),
    [sym_inout] = ACTIONS(4526),
    [sym_interface] = ACTIONS(4526),
    [sym_invariant] = ACTIONS(4526),
    [sym_is] = ACTIONS(4526),
    [sym_mixin] = ACTIONS(4526),
    [sym_new] = ACTIONS(4526),
    [sym_nothrow] = ACTIONS(4526),
    [sym_out] = ACTIONS(4526),
    [sym_override] = ACTIONS(4526),
    [sym_package] = ACTIONS(4526),
    [sym_pragma] = ACTIONS(4526),
    [sym_private] = ACTIONS(4526),
    [sym_protected] = ACTIONS(4526),
    [sym_public] = ACTIONS(4526),
    [sym_pure] = ACTIONS(4526),
    [sym_ref] = ACTIONS(4526),
    [sym_return] = ACTIONS(4526),
    [sym_scope] = ACTIONS(4526),
    [sym_shared] = ACTIONS(4526),
    [sym_static] = ACTIONS(4526),
    [sym_struct] = ACTIONS(4526),
    [sym_switch] = ACTIONS(4526),
    [sym_synchronized] = ACTIONS(4526),
    [sym_template] = ACTIONS(4526),
    [sym_throw] = ACTIONS(4526),
    [sym_try] = ACTIONS(4526),
    [sym_typeid] = ACTIONS(4526),
    [sym_typeof] = ACTIONS(4526),
    [sym_union] = ACTIONS(4526),
    [sym_unittest] = ACTIONS(4526),
    [sym_version] = ACTIONS(4526),
    [sym_while] = ACTIONS(4526),
    [sym_with] = ACTIONS(4526),
    [sym_gshared] = ACTIONS(4526),
    [sym_traits] = ACTIONS(4526),
    [sym_vector] = ACTIONS(4526),
    [sym_void] = ACTIONS(4526),
    [anon_sym_BQUOTE] = ACTIONS(4528),
    [anon_sym_r_DQUOTE] = ACTIONS(4528),
    [anon_sym_x_DQUOTE] = ACTIONS(4528),
    [anon_sym_DQUOTE] = ACTIONS(4528),
    [anon_sym_i_BQUOTE] = ACTIONS(4528),
    [anon_sym_i_DQUOTE] = ACTIONS(4528),
    [anon_sym_iq_LBRACE] = ACTIONS(4528),
    [aux_sym_char_literal_token1] = ACTIONS(4528),
    [anon_sym_SQUOTE] = ACTIONS(4526),
    [anon_sym___DATE__] = ACTIONS(4526),
    [anon_sym___FILE__] = ACTIONS(4526),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4526),
    [anon_sym___FUNCTION__] = ACTIONS(4526),
    [anon_sym___LINE__] = ACTIONS(4526),
    [anon_sym___MODULE__] = ACTIONS(4526),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4526),
    [anon_sym___TIME__] = ACTIONS(4526),
    [anon_sym___TIMESTAMP__] = ACTIONS(4526),
    [anon_sym___VENDOR__] = ACTIONS(4526),
    [anon_sym___VERSION__] = ACTIONS(4526),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4528),
    [sym_float_literal] = ACTIONS(4528),
    [sym__string] = ACTIONS(4528),
  },
  [1587] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_q_LBRACE] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4881),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_DASH_DASH] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_PLUS_PLUS] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_DOLLAR] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_true] = ACTIONS(4879),
    [sym_false] = ACTIONS(4879),
    [sym_null] = ACTIONS(4879),
    [sym_super] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_asm] = ACTIONS(4879),
    [sym_assert] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_break] = ACTIONS(4879),
    [sym_case] = ACTIONS(4879),
    [sym_cast] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_continue] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_default] = ACTIONS(4879),
    [sym_delegate] = ACTIONS(4879),
    [sym_delete] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_do] = ACTIONS(4879),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_for] = ACTIONS(4879),
    [sym_foreach] = ACTIONS(4879),
    [sym_foreach_reverse] = ACTIONS(4879),
    [sym_function] = ACTIONS(4879),
    [sym_goto] = ACTIONS(4879),
    [sym_if] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(4879),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_is] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_new] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_out] = ACTIONS(4879),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_switch] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_throw] = ACTIONS(4879),
    [sym_try] = ACTIONS(4879),
    [sym_typeid] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_with] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [anon_sym_BQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [anon_sym_x_DQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_i_BQUOTE] = ACTIONS(4881),
    [anon_sym_i_DQUOTE] = ACTIONS(4881),
    [anon_sym_iq_LBRACE] = ACTIONS(4881),
    [aux_sym_char_literal_token1] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4879),
    [anon_sym___DATE__] = ACTIONS(4879),
    [anon_sym___FILE__] = ACTIONS(4879),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4879),
    [anon_sym___FUNCTION__] = ACTIONS(4879),
    [anon_sym___LINE__] = ACTIONS(4879),
    [anon_sym___MODULE__] = ACTIONS(4879),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4879),
    [anon_sym___TIME__] = ACTIONS(4879),
    [anon_sym___TIMESTAMP__] = ACTIONS(4879),
    [anon_sym___VENDOR__] = ACTIONS(4879),
    [anon_sym___VERSION__] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym__string] = ACTIONS(4881),
  },
  [1588] = {
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_q_LBRACE] = ACTIONS(4885),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_LBRACE] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4883),
    [anon_sym_DASH_DASH] = ACTIONS(4885),
    [anon_sym_PLUS] = ACTIONS(4883),
    [anon_sym_PLUS_PLUS] = ACTIONS(4885),
    [anon_sym_BANG] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(4885),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(4885),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [anon_sym_AT] = ACTIONS(4885),
    [sym_bool] = ACTIONS(4883),
    [sym_byte] = ACTIONS(4883),
    [sym_ubyte] = ACTIONS(4883),
    [sym_char] = ACTIONS(4883),
    [sym_short] = ACTIONS(4883),
    [sym_ushort] = ACTIONS(4883),
    [sym_int] = ACTIONS(4883),
    [sym_uint] = ACTIONS(4883),
    [sym_long] = ACTIONS(4883),
    [sym_ulong] = ACTIONS(4883),
    [sym_cent] = ACTIONS(4883),
    [sym_ucent] = ACTIONS(4883),
    [sym_wchar] = ACTIONS(4883),
    [sym_dchar] = ACTIONS(4883),
    [sym_float] = ACTIONS(4883),
    [sym_double] = ACTIONS(4883),
    [sym_real] = ACTIONS(4883),
    [sym_ifloat] = ACTIONS(4883),
    [sym_idouble] = ACTIONS(4883),
    [sym_ireal] = ACTIONS(4883),
    [sym_cfloat] = ACTIONS(4883),
    [sym_cdouble] = ACTIONS(4883),
    [sym_creal] = ACTIONS(4883),
    [sym_size_t] = ACTIONS(4883),
    [sym_ptrdiff_t] = ACTIONS(4883),
    [sym_string] = ACTIONS(4883),
    [sym_cstring] = ACTIONS(4883),
    [sym_dstring] = ACTIONS(4883),
    [sym_wstring] = ACTIONS(4883),
    [sym_noreturn] = ACTIONS(4883),
    [sym_true] = ACTIONS(4883),
    [sym_false] = ACTIONS(4883),
    [sym_null] = ACTIONS(4883),
    [sym_super] = ACTIONS(4883),
    [sym_this] = ACTIONS(4883),
    [sym_abstract] = ACTIONS(4883),
    [sym_alias] = ACTIONS(4883),
    [sym_align] = ACTIONS(4883),
    [sym_asm] = ACTIONS(4883),
    [sym_assert] = ACTIONS(4883),
    [sym_auto] = ACTIONS(4883),
    [sym_break] = ACTIONS(4883),
    [sym_case] = ACTIONS(4883),
    [sym_cast] = ACTIONS(4883),
    [sym_class] = ACTIONS(4883),
    [sym_const] = ACTIONS(4883),
    [sym_continue] = ACTIONS(4883),
    [sym_debug] = ACTIONS(4883),
    [sym_default] = ACTIONS(4883),
    [sym_delegate] = ACTIONS(4883),
    [sym_delete] = ACTIONS(4883),
    [sym_deprecated] = ACTIONS(4883),
    [sym_do] = ACTIONS(4883),
    [sym_else] = ACTIONS(4883),
    [sym_enum] = ACTIONS(4883),
    [sym_export] = ACTIONS(4883),
    [sym_extern] = ACTIONS(4883),
    [sym_final] = ACTIONS(4883),
    [sym_for] = ACTIONS(4883),
    [sym_foreach] = ACTIONS(4883),
    [sym_foreach_reverse] = ACTIONS(4883),
    [sym_function] = ACTIONS(4883),
    [sym_goto] = ACTIONS(4883),
    [sym_if] = ACTIONS(4883),
    [sym_immutable] = ACTIONS(4883),
    [sym_import] = ACTIONS(4883),
    [sym_in] = ACTIONS(4883),
    [sym_inout] = ACTIONS(4883),
    [sym_interface] = ACTIONS(4883),
    [sym_invariant] = ACTIONS(4883),
    [sym_is] = ACTIONS(4883),
    [sym_mixin] = ACTIONS(4883),
    [sym_new] = ACTIONS(4883),
    [sym_nothrow] = ACTIONS(4883),
    [sym_out] = ACTIONS(4883),
    [sym_override] = ACTIONS(4883),
    [sym_package] = ACTIONS(4883),
    [sym_pragma] = ACTIONS(4883),
    [sym_private] = ACTIONS(4883),
    [sym_protected] = ACTIONS(4883),
    [sym_public] = ACTIONS(4883),
    [sym_pure] = ACTIONS(4883),
    [sym_ref] = ACTIONS(4883),
    [sym_return] = ACTIONS(4883),
    [sym_scope] = ACTIONS(4883),
    [sym_shared] = ACTIONS(4883),
    [sym_static] = ACTIONS(4883),
    [sym_struct] = ACTIONS(4883),
    [sym_switch] = ACTIONS(4883),
    [sym_synchronized] = ACTIONS(4883),
    [sym_template] = ACTIONS(4883),
    [sym_throw] = ACTIONS(4883),
    [sym_try] = ACTIONS(4883),
    [sym_typeid] = ACTIONS(4883),
    [sym_typeof] = ACTIONS(4883),
    [sym_union] = ACTIONS(4883),
    [sym_unittest] = ACTIONS(4883),
    [sym_version] = ACTIONS(4883),
    [sym_while] = ACTIONS(4883),
    [sym_with] = ACTIONS(4883),
    [sym_gshared] = ACTIONS(4883),
    [sym_traits] = ACTIONS(4883),
    [sym_vector] = ACTIONS(4883),
    [sym_void] = ACTIONS(4883),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_r_DQUOTE] = ACTIONS(4885),
    [anon_sym_x_DQUOTE] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_i_BQUOTE] = ACTIONS(4885),
    [anon_sym_i_DQUOTE] = ACTIONS(4885),
    [anon_sym_iq_LBRACE] = ACTIONS(4885),
    [aux_sym_char_literal_token1] = ACTIONS(4885),
    [anon_sym_SQUOTE] = ACTIONS(4883),
    [anon_sym___DATE__] = ACTIONS(4883),
    [anon_sym___FILE__] = ACTIONS(4883),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4883),
    [anon_sym___FUNCTION__] = ACTIONS(4883),
    [anon_sym___LINE__] = ACTIONS(4883),
    [anon_sym___MODULE__] = ACTIONS(4883),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4883),
    [anon_sym___TIME__] = ACTIONS(4883),
    [anon_sym___TIMESTAMP__] = ACTIONS(4883),
    [anon_sym___VENDOR__] = ACTIONS(4883),
    [anon_sym___VERSION__] = ACTIONS(4883),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4885),
    [sym_float_literal] = ACTIONS(4885),
    [sym__string] = ACTIONS(4885),
  },
  [1589] = {
    [sym_identifier] = ACTIONS(4518),
    [anon_sym_q_LBRACE] = ACTIONS(4520),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_DOT] = ACTIONS(4520),
    [anon_sym_AMP] = ACTIONS(4520),
    [anon_sym_DASH] = ACTIONS(4518),
    [anon_sym_DASH_DASH] = ACTIONS(4520),
    [anon_sym_PLUS] = ACTIONS(4518),
    [anon_sym_PLUS_PLUS] = ACTIONS(4520),
    [anon_sym_BANG] = ACTIONS(4520),
    [anon_sym_LPAREN] = ACTIONS(4520),
    [anon_sym_RPAREN] = ACTIONS(4520),
    [anon_sym_LBRACK] = ACTIONS(4520),
    [anon_sym_SEMI] = ACTIONS(4520),
    [anon_sym_DOLLAR] = ACTIONS(4520),
    [anon_sym_STAR] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4520),
    [anon_sym_AT] = ACTIONS(4520),
    [sym_bool] = ACTIONS(4518),
    [sym_byte] = ACTIONS(4518),
    [sym_ubyte] = ACTIONS(4518),
    [sym_char] = ACTIONS(4518),
    [sym_short] = ACTIONS(4518),
    [sym_ushort] = ACTIONS(4518),
    [sym_int] = ACTIONS(4518),
    [sym_uint] = ACTIONS(4518),
    [sym_long] = ACTIONS(4518),
    [sym_ulong] = ACTIONS(4518),
    [sym_cent] = ACTIONS(4518),
    [sym_ucent] = ACTIONS(4518),
    [sym_wchar] = ACTIONS(4518),
    [sym_dchar] = ACTIONS(4518),
    [sym_float] = ACTIONS(4518),
    [sym_double] = ACTIONS(4518),
    [sym_real] = ACTIONS(4518),
    [sym_ifloat] = ACTIONS(4518),
    [sym_idouble] = ACTIONS(4518),
    [sym_ireal] = ACTIONS(4518),
    [sym_cfloat] = ACTIONS(4518),
    [sym_cdouble] = ACTIONS(4518),
    [sym_creal] = ACTIONS(4518),
    [sym_size_t] = ACTIONS(4518),
    [sym_ptrdiff_t] = ACTIONS(4518),
    [sym_string] = ACTIONS(4518),
    [sym_cstring] = ACTIONS(4518),
    [sym_dstring] = ACTIONS(4518),
    [sym_wstring] = ACTIONS(4518),
    [sym_noreturn] = ACTIONS(4518),
    [sym_true] = ACTIONS(4518),
    [sym_false] = ACTIONS(4518),
    [sym_null] = ACTIONS(4518),
    [sym_super] = ACTIONS(4518),
    [sym_this] = ACTIONS(4518),
    [sym_abstract] = ACTIONS(4518),
    [sym_alias] = ACTIONS(4518),
    [sym_align] = ACTIONS(4518),
    [sym_asm] = ACTIONS(4518),
    [sym_assert] = ACTIONS(4518),
    [sym_auto] = ACTIONS(4518),
    [sym_break] = ACTIONS(4518),
    [sym_case] = ACTIONS(4518),
    [sym_cast] = ACTIONS(4518),
    [sym_class] = ACTIONS(4518),
    [sym_const] = ACTIONS(4518),
    [sym_continue] = ACTIONS(4518),
    [sym_debug] = ACTIONS(4518),
    [sym_default] = ACTIONS(4518),
    [sym_delegate] = ACTIONS(4518),
    [sym_delete] = ACTIONS(4518),
    [sym_deprecated] = ACTIONS(4518),
    [sym_do] = ACTIONS(4518),
    [sym_else] = ACTIONS(4518),
    [sym_enum] = ACTIONS(4518),
    [sym_export] = ACTIONS(4518),
    [sym_extern] = ACTIONS(4518),
    [sym_final] = ACTIONS(4518),
    [sym_for] = ACTIONS(4518),
    [sym_foreach] = ACTIONS(4518),
    [sym_foreach_reverse] = ACTIONS(4518),
    [sym_function] = ACTIONS(4518),
    [sym_goto] = ACTIONS(4518),
    [sym_if] = ACTIONS(4518),
    [sym_immutable] = ACTIONS(4518),
    [sym_import] = ACTIONS(4518),
    [sym_in] = ACTIONS(4518),
    [sym_inout] = ACTIONS(4518),
    [sym_interface] = ACTIONS(4518),
    [sym_invariant] = ACTIONS(4518),
    [sym_is] = ACTIONS(4518),
    [sym_mixin] = ACTIONS(4518),
    [sym_new] = ACTIONS(4518),
    [sym_nothrow] = ACTIONS(4518),
    [sym_out] = ACTIONS(4518),
    [sym_override] = ACTIONS(4518),
    [sym_package] = ACTIONS(4518),
    [sym_pragma] = ACTIONS(4518),
    [sym_private] = ACTIONS(4518),
    [sym_protected] = ACTIONS(4518),
    [sym_public] = ACTIONS(4518),
    [sym_pure] = ACTIONS(4518),
    [sym_ref] = ACTIONS(4518),
    [sym_return] = ACTIONS(4518),
    [sym_scope] = ACTIONS(4518),
    [sym_shared] = ACTIONS(4518),
    [sym_static] = ACTIONS(4518),
    [sym_struct] = ACTIONS(4518),
    [sym_switch] = ACTIONS(4518),
    [sym_synchronized] = ACTIONS(4518),
    [sym_template] = ACTIONS(4518),
    [sym_throw] = ACTIONS(4518),
    [sym_try] = ACTIONS(4518),
    [sym_typeid] = ACTIONS(4518),
    [sym_typeof] = ACTIONS(4518),
    [sym_union] = ACTIONS(4518),
    [sym_unittest] = ACTIONS(4518),
    [sym_version] = ACTIONS(4518),
    [sym_while] = ACTIONS(4518),
    [sym_with] = ACTIONS(4518),
    [sym_gshared] = ACTIONS(4518),
    [sym_traits] = ACTIONS(4518),
    [sym_vector] = ACTIONS(4518),
    [sym_void] = ACTIONS(4518),
    [anon_sym_BQUOTE] = ACTIONS(4520),
    [anon_sym_r_DQUOTE] = ACTIONS(4520),
    [anon_sym_x_DQUOTE] = ACTIONS(4520),
    [anon_sym_DQUOTE] = ACTIONS(4520),
    [anon_sym_i_BQUOTE] = ACTIONS(4520),
    [anon_sym_i_DQUOTE] = ACTIONS(4520),
    [anon_sym_iq_LBRACE] = ACTIONS(4520),
    [aux_sym_char_literal_token1] = ACTIONS(4520),
    [anon_sym_SQUOTE] = ACTIONS(4518),
    [anon_sym___DATE__] = ACTIONS(4518),
    [anon_sym___FILE__] = ACTIONS(4518),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4518),
    [anon_sym___FUNCTION__] = ACTIONS(4518),
    [anon_sym___LINE__] = ACTIONS(4518),
    [anon_sym___MODULE__] = ACTIONS(4518),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4518),
    [anon_sym___TIME__] = ACTIONS(4518),
    [anon_sym___TIMESTAMP__] = ACTIONS(4518),
    [anon_sym___VENDOR__] = ACTIONS(4518),
    [anon_sym___VERSION__] = ACTIONS(4518),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4520),
    [sym_float_literal] = ACTIONS(4520),
    [sym__string] = ACTIONS(4520),
  },
  [1590] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_q_LBRACE] = ACTIONS(4881),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_DASH_DASH] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_PLUS_PLUS] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_DOLLAR] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_true] = ACTIONS(4879),
    [sym_false] = ACTIONS(4879),
    [sym_null] = ACTIONS(4879),
    [sym_super] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_asm] = ACTIONS(4879),
    [sym_assert] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_break] = ACTIONS(4879),
    [sym_case] = ACTIONS(4879),
    [sym_cast] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_continue] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_default] = ACTIONS(4879),
    [sym_delegate] = ACTIONS(4879),
    [sym_delete] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_do] = ACTIONS(4968),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_for] = ACTIONS(4879),
    [sym_foreach] = ACTIONS(4879),
    [sym_foreach_reverse] = ACTIONS(4879),
    [sym_function] = ACTIONS(4879),
    [sym_goto] = ACTIONS(4879),
    [sym_if] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(4968),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_is] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_new] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_out] = ACTIONS(4968),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_switch] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_throw] = ACTIONS(4879),
    [sym_try] = ACTIONS(4879),
    [sym_typeid] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_with] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [anon_sym_BQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [anon_sym_x_DQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_i_BQUOTE] = ACTIONS(4881),
    [anon_sym_i_DQUOTE] = ACTIONS(4881),
    [anon_sym_iq_LBRACE] = ACTIONS(4881),
    [aux_sym_char_literal_token1] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4879),
    [anon_sym___DATE__] = ACTIONS(4879),
    [anon_sym___FILE__] = ACTIONS(4879),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4879),
    [anon_sym___FUNCTION__] = ACTIONS(4879),
    [anon_sym___LINE__] = ACTIONS(4879),
    [anon_sym___MODULE__] = ACTIONS(4879),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4879),
    [anon_sym___TIME__] = ACTIONS(4879),
    [anon_sym___TIMESTAMP__] = ACTIONS(4879),
    [anon_sym___VENDOR__] = ACTIONS(4879),
    [anon_sym___VERSION__] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym__string] = ACTIONS(4881),
  },
  [1591] = {
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_q_LBRACE] = ACTIONS(4608),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [anon_sym_LBRACE] = ACTIONS(4608),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_DASH_DASH] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_LPAREN] = ACTIONS(4608),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_LBRACK] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4608),
    [anon_sym_TILDE] = ACTIONS(4608),
    [anon_sym_AT] = ACTIONS(4608),
    [sym_bool] = ACTIONS(4606),
    [sym_byte] = ACTIONS(4606),
    [sym_ubyte] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_short] = ACTIONS(4606),
    [sym_ushort] = ACTIONS(4606),
    [sym_int] = ACTIONS(4606),
    [sym_uint] = ACTIONS(4606),
    [sym_long] = ACTIONS(4606),
    [sym_ulong] = ACTIONS(4606),
    [sym_cent] = ACTIONS(4606),
    [sym_ucent] = ACTIONS(4606),
    [sym_wchar] = ACTIONS(4606),
    [sym_dchar] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_double] = ACTIONS(4606),
    [sym_real] = ACTIONS(4606),
    [sym_ifloat] = ACTIONS(4606),
    [sym_idouble] = ACTIONS(4606),
    [sym_ireal] = ACTIONS(4606),
    [sym_cfloat] = ACTIONS(4606),
    [sym_cdouble] = ACTIONS(4606),
    [sym_creal] = ACTIONS(4606),
    [sym_size_t] = ACTIONS(4606),
    [sym_ptrdiff_t] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym_cstring] = ACTIONS(4606),
    [sym_dstring] = ACTIONS(4606),
    [sym_wstring] = ACTIONS(4606),
    [sym_noreturn] = ACTIONS(4606),
    [sym_true] = ACTIONS(4606),
    [sym_false] = ACTIONS(4606),
    [sym_null] = ACTIONS(4606),
    [sym_super] = ACTIONS(4606),
    [sym_this] = ACTIONS(4606),
    [sym_abstract] = ACTIONS(4606),
    [sym_alias] = ACTIONS(4606),
    [sym_align] = ACTIONS(4606),
    [sym_asm] = ACTIONS(4606),
    [sym_assert] = ACTIONS(4606),
    [sym_auto] = ACTIONS(4606),
    [sym_break] = ACTIONS(4606),
    [sym_case] = ACTIONS(4606),
    [sym_cast] = ACTIONS(4606),
    [sym_class] = ACTIONS(4606),
    [sym_const] = ACTIONS(4606),
    [sym_continue] = ACTIONS(4606),
    [sym_debug] = ACTIONS(4606),
    [sym_default] = ACTIONS(4606),
    [sym_delegate] = ACTIONS(4606),
    [sym_delete] = ACTIONS(4606),
    [sym_deprecated] = ACTIONS(4606),
    [sym_do] = ACTIONS(4606),
    [sym_else] = ACTIONS(4606),
    [sym_enum] = ACTIONS(4606),
    [sym_export] = ACTIONS(4606),
    [sym_extern] = ACTIONS(4606),
    [sym_final] = ACTIONS(4606),
    [sym_for] = ACTIONS(4606),
    [sym_foreach] = ACTIONS(4606),
    [sym_foreach_reverse] = ACTIONS(4606),
    [sym_function] = ACTIONS(4606),
    [sym_goto] = ACTIONS(4606),
    [sym_if] = ACTIONS(4606),
    [sym_immutable] = ACTIONS(4606),
    [sym_import] = ACTIONS(4606),
    [sym_in] = ACTIONS(4606),
    [sym_inout] = ACTIONS(4606),
    [sym_interface] = ACTIONS(4606),
    [sym_invariant] = ACTIONS(4606),
    [sym_is] = ACTIONS(4606),
    [sym_mixin] = ACTIONS(4606),
    [sym_new] = ACTIONS(4606),
    [sym_nothrow] = ACTIONS(4606),
    [sym_out] = ACTIONS(4606),
    [sym_override] = ACTIONS(4606),
    [sym_package] = ACTIONS(4606),
    [sym_pragma] = ACTIONS(4606),
    [sym_private] = ACTIONS(4606),
    [sym_protected] = ACTIONS(4606),
    [sym_public] = ACTIONS(4606),
    [sym_pure] = ACTIONS(4606),
    [sym_ref] = ACTIONS(4606),
    [sym_return] = ACTIONS(4606),
    [sym_scope] = ACTIONS(4606),
    [sym_shared] = ACTIONS(4606),
    [sym_static] = ACTIONS(4606),
    [sym_struct] = ACTIONS(4606),
    [sym_switch] = ACTIONS(4606),
    [sym_synchronized] = ACTIONS(4606),
    [sym_template] = ACTIONS(4606),
    [sym_throw] = ACTIONS(4606),
    [sym_try] = ACTIONS(4606),
    [sym_typeid] = ACTIONS(4606),
    [sym_typeof] = ACTIONS(4606),
    [sym_union] = ACTIONS(4606),
    [sym_unittest] = ACTIONS(4606),
    [sym_version] = ACTIONS(4606),
    [sym_while] = ACTIONS(4606),
    [sym_with] = ACTIONS(4606),
    [sym_gshared] = ACTIONS(4606),
    [sym_traits] = ACTIONS(4606),
    [sym_vector] = ACTIONS(4606),
    [sym_void] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_r_DQUOTE] = ACTIONS(4608),
    [anon_sym_x_DQUOTE] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_i_BQUOTE] = ACTIONS(4608),
    [anon_sym_i_DQUOTE] = ACTIONS(4608),
    [anon_sym_iq_LBRACE] = ACTIONS(4608),
    [aux_sym_char_literal_token1] = ACTIONS(4608),
    [anon_sym_SQUOTE] = ACTIONS(4606),
    [anon_sym___DATE__] = ACTIONS(4606),
    [anon_sym___FILE__] = ACTIONS(4606),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4606),
    [anon_sym___FUNCTION__] = ACTIONS(4606),
    [anon_sym___LINE__] = ACTIONS(4606),
    [anon_sym___MODULE__] = ACTIONS(4606),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4606),
    [anon_sym___TIME__] = ACTIONS(4606),
    [anon_sym___TIMESTAMP__] = ACTIONS(4606),
    [anon_sym___VENDOR__] = ACTIONS(4606),
    [anon_sym___VERSION__] = ACTIONS(4606),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4608),
    [sym_float_literal] = ACTIONS(4608),
    [sym__string] = ACTIONS(4608),
  },
  [1592] = {
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_q_LBRACE] = ACTIONS(4374),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_LBRACE] = ACTIONS(4374),
    [anon_sym_DOT] = ACTIONS(4374),
    [anon_sym_AMP] = ACTIONS(4374),
    [anon_sym_DASH] = ACTIONS(4372),
    [anon_sym_DASH_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_PLUS_PLUS] = ACTIONS(4374),
    [anon_sym_BANG] = ACTIONS(4374),
    [anon_sym_LPAREN] = ACTIONS(4374),
    [anon_sym_RPAREN] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_SEMI] = ACTIONS(4374),
    [anon_sym_DOLLAR] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4374),
    [anon_sym_TILDE] = ACTIONS(4374),
    [anon_sym_AT] = ACTIONS(4374),
    [sym_bool] = ACTIONS(4372),
    [sym_byte] = ACTIONS(4372),
    [sym_ubyte] = ACTIONS(4372),
    [sym_char] = ACTIONS(4372),
    [sym_short] = ACTIONS(4372),
    [sym_ushort] = ACTIONS(4372),
    [sym_int] = ACTIONS(4372),
    [sym_uint] = ACTIONS(4372),
    [sym_long] = ACTIONS(4372),
    [sym_ulong] = ACTIONS(4372),
    [sym_cent] = ACTIONS(4372),
    [sym_ucent] = ACTIONS(4372),
    [sym_wchar] = ACTIONS(4372),
    [sym_dchar] = ACTIONS(4372),
    [sym_float] = ACTIONS(4372),
    [sym_double] = ACTIONS(4372),
    [sym_real] = ACTIONS(4372),
    [sym_ifloat] = ACTIONS(4372),
    [sym_idouble] = ACTIONS(4372),
    [sym_ireal] = ACTIONS(4372),
    [sym_cfloat] = ACTIONS(4372),
    [sym_cdouble] = ACTIONS(4372),
    [sym_creal] = ACTIONS(4372),
    [sym_size_t] = ACTIONS(4372),
    [sym_ptrdiff_t] = ACTIONS(4372),
    [sym_string] = ACTIONS(4372),
    [sym_cstring] = ACTIONS(4372),
    [sym_dstring] = ACTIONS(4372),
    [sym_wstring] = ACTIONS(4372),
    [sym_noreturn] = ACTIONS(4372),
    [sym_true] = ACTIONS(4372),
    [sym_false] = ACTIONS(4372),
    [sym_null] = ACTIONS(4372),
    [sym_super] = ACTIONS(4372),
    [sym_this] = ACTIONS(4372),
    [sym_abstract] = ACTIONS(4372),
    [sym_alias] = ACTIONS(4372),
    [sym_align] = ACTIONS(4372),
    [sym_asm] = ACTIONS(4372),
    [sym_assert] = ACTIONS(4372),
    [sym_auto] = ACTIONS(4372),
    [sym_break] = ACTIONS(4372),
    [sym_case] = ACTIONS(4372),
    [sym_cast] = ACTIONS(4372),
    [sym_class] = ACTIONS(4372),
    [sym_const] = ACTIONS(4372),
    [sym_continue] = ACTIONS(4372),
    [sym_debug] = ACTIONS(4372),
    [sym_default] = ACTIONS(4372),
    [sym_delegate] = ACTIONS(4372),
    [sym_delete] = ACTIONS(4372),
    [sym_deprecated] = ACTIONS(4372),
    [sym_do] = ACTIONS(4372),
    [sym_else] = ACTIONS(4372),
    [sym_enum] = ACTIONS(4372),
    [sym_export] = ACTIONS(4372),
    [sym_extern] = ACTIONS(4372),
    [sym_final] = ACTIONS(4372),
    [sym_for] = ACTIONS(4372),
    [sym_foreach] = ACTIONS(4372),
    [sym_foreach_reverse] = ACTIONS(4372),
    [sym_function] = ACTIONS(4372),
    [sym_goto] = ACTIONS(4372),
    [sym_if] = ACTIONS(4372),
    [sym_immutable] = ACTIONS(4372),
    [sym_import] = ACTIONS(4372),
    [sym_in] = ACTIONS(4372),
    [sym_inout] = ACTIONS(4372),
    [sym_interface] = ACTIONS(4372),
    [sym_invariant] = ACTIONS(4372),
    [sym_is] = ACTIONS(4372),
    [sym_mixin] = ACTIONS(4372),
    [sym_new] = ACTIONS(4372),
    [sym_nothrow] = ACTIONS(4372),
    [sym_out] = ACTIONS(4372),
    [sym_override] = ACTIONS(4372),
    [sym_package] = ACTIONS(4372),
    [sym_pragma] = ACTIONS(4372),
    [sym_private] = ACTIONS(4372),
    [sym_protected] = ACTIONS(4372),
    [sym_public] = ACTIONS(4372),
    [sym_pure] = ACTIONS(4372),
    [sym_ref] = ACTIONS(4372),
    [sym_return] = ACTIONS(4372),
    [sym_scope] = ACTIONS(4372),
    [sym_shared] = ACTIONS(4372),
    [sym_static] = ACTIONS(4372),
    [sym_struct] = ACTIONS(4372),
    [sym_switch] = ACTIONS(4372),
    [sym_synchronized] = ACTIONS(4372),
    [sym_template] = ACTIONS(4372),
    [sym_throw] = ACTIONS(4372),
    [sym_try] = ACTIONS(4372),
    [sym_typeid] = ACTIONS(4372),
    [sym_typeof] = ACTIONS(4372),
    [sym_union] = ACTIONS(4372),
    [sym_unittest] = ACTIONS(4372),
    [sym_version] = ACTIONS(4372),
    [sym_while] = ACTIONS(4372),
    [sym_with] = ACTIONS(4372),
    [sym_gshared] = ACTIONS(4372),
    [sym_traits] = ACTIONS(4372),
    [sym_vector] = ACTIONS(4372),
    [sym_void] = ACTIONS(4372),
    [anon_sym_BQUOTE] = ACTIONS(4374),
    [anon_sym_r_DQUOTE] = ACTIONS(4374),
    [anon_sym_x_DQUOTE] = ACTIONS(4374),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [anon_sym_i_BQUOTE] = ACTIONS(4374),
    [anon_sym_i_DQUOTE] = ACTIONS(4374),
    [anon_sym_iq_LBRACE] = ACTIONS(4374),
    [aux_sym_char_literal_token1] = ACTIONS(4374),
    [anon_sym_SQUOTE] = ACTIONS(4372),
    [anon_sym___DATE__] = ACTIONS(4372),
    [anon_sym___FILE__] = ACTIONS(4372),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4372),
    [anon_sym___FUNCTION__] = ACTIONS(4372),
    [anon_sym___LINE__] = ACTIONS(4372),
    [anon_sym___MODULE__] = ACTIONS(4372),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4372),
    [anon_sym___TIME__] = ACTIONS(4372),
    [anon_sym___TIMESTAMP__] = ACTIONS(4372),
    [anon_sym___VENDOR__] = ACTIONS(4372),
    [anon_sym___VERSION__] = ACTIONS(4372),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4374),
    [sym_float_literal] = ACTIONS(4374),
    [sym__string] = ACTIONS(4374),
  },
  [1593] = {
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_q_LBRACE] = ACTIONS(4624),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_DOLLAR] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_AT] = ACTIONS(4624),
    [sym_bool] = ACTIONS(4622),
    [sym_byte] = ACTIONS(4622),
    [sym_ubyte] = ACTIONS(4622),
    [sym_char] = ACTIONS(4622),
    [sym_short] = ACTIONS(4622),
    [sym_ushort] = ACTIONS(4622),
    [sym_int] = ACTIONS(4622),
    [sym_uint] = ACTIONS(4622),
    [sym_long] = ACTIONS(4622),
    [sym_ulong] = ACTIONS(4622),
    [sym_cent] = ACTIONS(4622),
    [sym_ucent] = ACTIONS(4622),
    [sym_wchar] = ACTIONS(4622),
    [sym_dchar] = ACTIONS(4622),
    [sym_float] = ACTIONS(4622),
    [sym_double] = ACTIONS(4622),
    [sym_real] = ACTIONS(4622),
    [sym_ifloat] = ACTIONS(4622),
    [sym_idouble] = ACTIONS(4622),
    [sym_ireal] = ACTIONS(4622),
    [sym_cfloat] = ACTIONS(4622),
    [sym_cdouble] = ACTIONS(4622),
    [sym_creal] = ACTIONS(4622),
    [sym_size_t] = ACTIONS(4622),
    [sym_ptrdiff_t] = ACTIONS(4622),
    [sym_string] = ACTIONS(4622),
    [sym_cstring] = ACTIONS(4622),
    [sym_dstring] = ACTIONS(4622),
    [sym_wstring] = ACTIONS(4622),
    [sym_noreturn] = ACTIONS(4622),
    [sym_true] = ACTIONS(4622),
    [sym_false] = ACTIONS(4622),
    [sym_null] = ACTIONS(4622),
    [sym_super] = ACTIONS(4622),
    [sym_this] = ACTIONS(4622),
    [sym_abstract] = ACTIONS(4622),
    [sym_alias] = ACTIONS(4622),
    [sym_align] = ACTIONS(4622),
    [sym_asm] = ACTIONS(4622),
    [sym_assert] = ACTIONS(4622),
    [sym_auto] = ACTIONS(4622),
    [sym_break] = ACTIONS(4622),
    [sym_case] = ACTIONS(4622),
    [sym_cast] = ACTIONS(4622),
    [sym_class] = ACTIONS(4622),
    [sym_const] = ACTIONS(4622),
    [sym_continue] = ACTIONS(4622),
    [sym_debug] = ACTIONS(4622),
    [sym_default] = ACTIONS(4622),
    [sym_delegate] = ACTIONS(4622),
    [sym_delete] = ACTIONS(4622),
    [sym_deprecated] = ACTIONS(4622),
    [sym_do] = ACTIONS(4622),
    [sym_else] = ACTIONS(4622),
    [sym_enum] = ACTIONS(4622),
    [sym_export] = ACTIONS(4622),
    [sym_extern] = ACTIONS(4622),
    [sym_final] = ACTIONS(4622),
    [sym_for] = ACTIONS(4622),
    [sym_foreach] = ACTIONS(4622),
    [sym_foreach_reverse] = ACTIONS(4622),
    [sym_function] = ACTIONS(4622),
    [sym_goto] = ACTIONS(4622),
    [sym_if] = ACTIONS(4622),
    [sym_immutable] = ACTIONS(4622),
    [sym_import] = ACTIONS(4622),
    [sym_in] = ACTIONS(4622),
    [sym_inout] = ACTIONS(4622),
    [sym_interface] = ACTIONS(4622),
    [sym_invariant] = ACTIONS(4622),
    [sym_is] = ACTIONS(4622),
    [sym_mixin] = ACTIONS(4622),
    [sym_new] = ACTIONS(4622),
    [sym_nothrow] = ACTIONS(4622),
    [sym_out] = ACTIONS(4622),
    [sym_override] = ACTIONS(4622),
    [sym_package] = ACTIONS(4622),
    [sym_pragma] = ACTIONS(4622),
    [sym_private] = ACTIONS(4622),
    [sym_protected] = ACTIONS(4622),
    [sym_public] = ACTIONS(4622),
    [sym_pure] = ACTIONS(4622),
    [sym_ref] = ACTIONS(4622),
    [sym_return] = ACTIONS(4622),
    [sym_scope] = ACTIONS(4622),
    [sym_shared] = ACTIONS(4622),
    [sym_static] = ACTIONS(4622),
    [sym_struct] = ACTIONS(4622),
    [sym_switch] = ACTIONS(4622),
    [sym_synchronized] = ACTIONS(4622),
    [sym_template] = ACTIONS(4622),
    [sym_throw] = ACTIONS(4622),
    [sym_try] = ACTIONS(4622),
    [sym_typeid] = ACTIONS(4622),
    [sym_typeof] = ACTIONS(4622),
    [sym_union] = ACTIONS(4622),
    [sym_unittest] = ACTIONS(4622),
    [sym_version] = ACTIONS(4622),
    [sym_while] = ACTIONS(4622),
    [sym_with] = ACTIONS(4622),
    [sym_gshared] = ACTIONS(4622),
    [sym_traits] = ACTIONS(4622),
    [sym_vector] = ACTIONS(4622),
    [sym_void] = ACTIONS(4622),
    [anon_sym_BQUOTE] = ACTIONS(4624),
    [anon_sym_r_DQUOTE] = ACTIONS(4624),
    [anon_sym_x_DQUOTE] = ACTIONS(4624),
    [anon_sym_DQUOTE] = ACTIONS(4624),
    [anon_sym_i_BQUOTE] = ACTIONS(4624),
    [anon_sym_i_DQUOTE] = ACTIONS(4624),
    [anon_sym_iq_LBRACE] = ACTIONS(4624),
    [aux_sym_char_literal_token1] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4622),
    [anon_sym___DATE__] = ACTIONS(4622),
    [anon_sym___FILE__] = ACTIONS(4622),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4622),
    [anon_sym___FUNCTION__] = ACTIONS(4622),
    [anon_sym___LINE__] = ACTIONS(4622),
    [anon_sym___MODULE__] = ACTIONS(4622),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4622),
    [anon_sym___TIME__] = ACTIONS(4622),
    [anon_sym___TIMESTAMP__] = ACTIONS(4622),
    [anon_sym___VENDOR__] = ACTIONS(4622),
    [anon_sym___VERSION__] = ACTIONS(4622),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4624),
    [sym_float_literal] = ACTIONS(4624),
    [sym__string] = ACTIONS(4624),
  },
  [1594] = {
    [sym_identifier] = ACTIONS(4891),
    [anon_sym_q_LBRACE] = ACTIONS(4893),
    [anon_sym_RBRACE] = ACTIONS(4893),
    [anon_sym_LBRACE] = ACTIONS(4893),
    [anon_sym_DOT] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_DASH] = ACTIONS(4891),
    [anon_sym_DASH_DASH] = ACTIONS(4893),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_PLUS_PLUS] = ACTIONS(4893),
    [anon_sym_BANG] = ACTIONS(4893),
    [anon_sym_LPAREN] = ACTIONS(4893),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_LBRACK] = ACTIONS(4893),
    [anon_sym_SEMI] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4893),
    [anon_sym_STAR] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4893),
    [anon_sym_AT] = ACTIONS(4893),
    [sym_bool] = ACTIONS(4891),
    [sym_byte] = ACTIONS(4891),
    [sym_ubyte] = ACTIONS(4891),
    [sym_char] = ACTIONS(4891),
    [sym_short] = ACTIONS(4891),
    [sym_ushort] = ACTIONS(4891),
    [sym_int] = ACTIONS(4891),
    [sym_uint] = ACTIONS(4891),
    [sym_long] = ACTIONS(4891),
    [sym_ulong] = ACTIONS(4891),
    [sym_cent] = ACTIONS(4891),
    [sym_ucent] = ACTIONS(4891),
    [sym_wchar] = ACTIONS(4891),
    [sym_dchar] = ACTIONS(4891),
    [sym_float] = ACTIONS(4891),
    [sym_double] = ACTIONS(4891),
    [sym_real] = ACTIONS(4891),
    [sym_ifloat] = ACTIONS(4891),
    [sym_idouble] = ACTIONS(4891),
    [sym_ireal] = ACTIONS(4891),
    [sym_cfloat] = ACTIONS(4891),
    [sym_cdouble] = ACTIONS(4891),
    [sym_creal] = ACTIONS(4891),
    [sym_size_t] = ACTIONS(4891),
    [sym_ptrdiff_t] = ACTIONS(4891),
    [sym_string] = ACTIONS(4891),
    [sym_cstring] = ACTIONS(4891),
    [sym_dstring] = ACTIONS(4891),
    [sym_wstring] = ACTIONS(4891),
    [sym_noreturn] = ACTIONS(4891),
    [sym_true] = ACTIONS(4891),
    [sym_false] = ACTIONS(4891),
    [sym_null] = ACTIONS(4891),
    [sym_super] = ACTIONS(4891),
    [sym_this] = ACTIONS(4891),
    [sym_abstract] = ACTIONS(4891),
    [sym_alias] = ACTIONS(4891),
    [sym_align] = ACTIONS(4891),
    [sym_asm] = ACTIONS(4891),
    [sym_assert] = ACTIONS(4891),
    [sym_auto] = ACTIONS(4891),
    [sym_break] = ACTIONS(4891),
    [sym_case] = ACTIONS(4891),
    [sym_cast] = ACTIONS(4891),
    [sym_class] = ACTIONS(4891),
    [sym_const] = ACTIONS(4891),
    [sym_continue] = ACTIONS(4891),
    [sym_debug] = ACTIONS(4891),
    [sym_default] = ACTIONS(4891),
    [sym_delegate] = ACTIONS(4891),
    [sym_delete] = ACTIONS(4891),
    [sym_deprecated] = ACTIONS(4891),
    [sym_do] = ACTIONS(4891),
    [sym_else] = ACTIONS(4891),
    [sym_enum] = ACTIONS(4891),
    [sym_export] = ACTIONS(4891),
    [sym_extern] = ACTIONS(4891),
    [sym_final] = ACTIONS(4891),
    [sym_for] = ACTIONS(4891),
    [sym_foreach] = ACTIONS(4891),
    [sym_foreach_reverse] = ACTIONS(4891),
    [sym_function] = ACTIONS(4891),
    [sym_goto] = ACTIONS(4891),
    [sym_if] = ACTIONS(4891),
    [sym_immutable] = ACTIONS(4891),
    [sym_import] = ACTIONS(4891),
    [sym_in] = ACTIONS(4891),
    [sym_inout] = ACTIONS(4891),
    [sym_interface] = ACTIONS(4891),
    [sym_invariant] = ACTIONS(4891),
    [sym_is] = ACTIONS(4891),
    [sym_mixin] = ACTIONS(4891),
    [sym_new] = ACTIONS(4891),
    [sym_nothrow] = ACTIONS(4891),
    [sym_out] = ACTIONS(4891),
    [sym_override] = ACTIONS(4891),
    [sym_package] = ACTIONS(4891),
    [sym_pragma] = ACTIONS(4891),
    [sym_private] = ACTIONS(4891),
    [sym_protected] = ACTIONS(4891),
    [sym_public] = ACTIONS(4891),
    [sym_pure] = ACTIONS(4891),
    [sym_ref] = ACTIONS(4891),
    [sym_return] = ACTIONS(4891),
    [sym_scope] = ACTIONS(4891),
    [sym_shared] = ACTIONS(4891),
    [sym_static] = ACTIONS(4891),
    [sym_struct] = ACTIONS(4891),
    [sym_switch] = ACTIONS(4891),
    [sym_synchronized] = ACTIONS(4891),
    [sym_template] = ACTIONS(4891),
    [sym_throw] = ACTIONS(4891),
    [sym_try] = ACTIONS(4891),
    [sym_typeid] = ACTIONS(4891),
    [sym_typeof] = ACTIONS(4891),
    [sym_union] = ACTIONS(4891),
    [sym_unittest] = ACTIONS(4891),
    [sym_version] = ACTIONS(4891),
    [sym_while] = ACTIONS(4891),
    [sym_with] = ACTIONS(4891),
    [sym_gshared] = ACTIONS(4891),
    [sym_traits] = ACTIONS(4891),
    [sym_vector] = ACTIONS(4891),
    [sym_void] = ACTIONS(4891),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_r_DQUOTE] = ACTIONS(4893),
    [anon_sym_x_DQUOTE] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_i_BQUOTE] = ACTIONS(4893),
    [anon_sym_i_DQUOTE] = ACTIONS(4893),
    [anon_sym_iq_LBRACE] = ACTIONS(4893),
    [aux_sym_char_literal_token1] = ACTIONS(4893),
    [anon_sym_SQUOTE] = ACTIONS(4891),
    [anon_sym___DATE__] = ACTIONS(4891),
    [anon_sym___FILE__] = ACTIONS(4891),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4891),
    [anon_sym___FUNCTION__] = ACTIONS(4891),
    [anon_sym___LINE__] = ACTIONS(4891),
    [anon_sym___MODULE__] = ACTIONS(4891),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4891),
    [anon_sym___TIME__] = ACTIONS(4891),
    [anon_sym___TIMESTAMP__] = ACTIONS(4891),
    [anon_sym___VENDOR__] = ACTIONS(4891),
    [anon_sym___VERSION__] = ACTIONS(4891),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4893),
    [sym_float_literal] = ACTIONS(4893),
    [sym__string] = ACTIONS(4893),
  },
  [1595] = {
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_q_LBRACE] = ACTIONS(4897),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [anon_sym_LBRACE] = ACTIONS(4897),
    [anon_sym_DOT] = ACTIONS(4897),
    [anon_sym_AMP] = ACTIONS(4897),
    [anon_sym_DASH] = ACTIONS(4895),
    [anon_sym_DASH_DASH] = ACTIONS(4897),
    [anon_sym_PLUS] = ACTIONS(4895),
    [anon_sym_PLUS_PLUS] = ACTIONS(4897),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_LPAREN] = ACTIONS(4897),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_DOLLAR] = ACTIONS(4897),
    [anon_sym_STAR] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [anon_sym_AT] = ACTIONS(4897),
    [sym_bool] = ACTIONS(4895),
    [sym_byte] = ACTIONS(4895),
    [sym_ubyte] = ACTIONS(4895),
    [sym_char] = ACTIONS(4895),
    [sym_short] = ACTIONS(4895),
    [sym_ushort] = ACTIONS(4895),
    [sym_int] = ACTIONS(4895),
    [sym_uint] = ACTIONS(4895),
    [sym_long] = ACTIONS(4895),
    [sym_ulong] = ACTIONS(4895),
    [sym_cent] = ACTIONS(4895),
    [sym_ucent] = ACTIONS(4895),
    [sym_wchar] = ACTIONS(4895),
    [sym_dchar] = ACTIONS(4895),
    [sym_float] = ACTIONS(4895),
    [sym_double] = ACTIONS(4895),
    [sym_real] = ACTIONS(4895),
    [sym_ifloat] = ACTIONS(4895),
    [sym_idouble] = ACTIONS(4895),
    [sym_ireal] = ACTIONS(4895),
    [sym_cfloat] = ACTIONS(4895),
    [sym_cdouble] = ACTIONS(4895),
    [sym_creal] = ACTIONS(4895),
    [sym_size_t] = ACTIONS(4895),
    [sym_ptrdiff_t] = ACTIONS(4895),
    [sym_string] = ACTIONS(4895),
    [sym_cstring] = ACTIONS(4895),
    [sym_dstring] = ACTIONS(4895),
    [sym_wstring] = ACTIONS(4895),
    [sym_noreturn] = ACTIONS(4895),
    [sym_true] = ACTIONS(4895),
    [sym_false] = ACTIONS(4895),
    [sym_null] = ACTIONS(4895),
    [sym_super] = ACTIONS(4895),
    [sym_this] = ACTIONS(4895),
    [sym_abstract] = ACTIONS(4895),
    [sym_alias] = ACTIONS(4895),
    [sym_align] = ACTIONS(4895),
    [sym_asm] = ACTIONS(4895),
    [sym_assert] = ACTIONS(4895),
    [sym_auto] = ACTIONS(4895),
    [sym_break] = ACTIONS(4895),
    [sym_case] = ACTIONS(4895),
    [sym_cast] = ACTIONS(4895),
    [sym_class] = ACTIONS(4895),
    [sym_const] = ACTIONS(4895),
    [sym_continue] = ACTIONS(4895),
    [sym_debug] = ACTIONS(4895),
    [sym_default] = ACTIONS(4895),
    [sym_delegate] = ACTIONS(4895),
    [sym_delete] = ACTIONS(4895),
    [sym_deprecated] = ACTIONS(4895),
    [sym_do] = ACTIONS(4895),
    [sym_else] = ACTIONS(4895),
    [sym_enum] = ACTIONS(4895),
    [sym_export] = ACTIONS(4895),
    [sym_extern] = ACTIONS(4895),
    [sym_final] = ACTIONS(4895),
    [sym_for] = ACTIONS(4895),
    [sym_foreach] = ACTIONS(4895),
    [sym_foreach_reverse] = ACTIONS(4895),
    [sym_function] = ACTIONS(4895),
    [sym_goto] = ACTIONS(4895),
    [sym_if] = ACTIONS(4895),
    [sym_immutable] = ACTIONS(4895),
    [sym_import] = ACTIONS(4895),
    [sym_in] = ACTIONS(4895),
    [sym_inout] = ACTIONS(4895),
    [sym_interface] = ACTIONS(4895),
    [sym_invariant] = ACTIONS(4895),
    [sym_is] = ACTIONS(4895),
    [sym_mixin] = ACTIONS(4895),
    [sym_new] = ACTIONS(4895),
    [sym_nothrow] = ACTIONS(4895),
    [sym_out] = ACTIONS(4895),
    [sym_override] = ACTIONS(4895),
    [sym_package] = ACTIONS(4895),
    [sym_pragma] = ACTIONS(4895),
    [sym_private] = ACTIONS(4895),
    [sym_protected] = ACTIONS(4895),
    [sym_public] = ACTIONS(4895),
    [sym_pure] = ACTIONS(4895),
    [sym_ref] = ACTIONS(4895),
    [sym_return] = ACTIONS(4895),
    [sym_scope] = ACTIONS(4895),
    [sym_shared] = ACTIONS(4895),
    [sym_static] = ACTIONS(4895),
    [sym_struct] = ACTIONS(4895),
    [sym_switch] = ACTIONS(4895),
    [sym_synchronized] = ACTIONS(4895),
    [sym_template] = ACTIONS(4895),
    [sym_throw] = ACTIONS(4895),
    [sym_try] = ACTIONS(4895),
    [sym_typeid] = ACTIONS(4895),
    [sym_typeof] = ACTIONS(4895),
    [sym_union] = ACTIONS(4895),
    [sym_unittest] = ACTIONS(4895),
    [sym_version] = ACTIONS(4895),
    [sym_while] = ACTIONS(4895),
    [sym_with] = ACTIONS(4895),
    [sym_gshared] = ACTIONS(4895),
    [sym_traits] = ACTIONS(4895),
    [sym_vector] = ACTIONS(4895),
    [sym_void] = ACTIONS(4895),
    [anon_sym_BQUOTE] = ACTIONS(4897),
    [anon_sym_r_DQUOTE] = ACTIONS(4897),
    [anon_sym_x_DQUOTE] = ACTIONS(4897),
    [anon_sym_DQUOTE] = ACTIONS(4897),
    [anon_sym_i_BQUOTE] = ACTIONS(4897),
    [anon_sym_i_DQUOTE] = ACTIONS(4897),
    [anon_sym_iq_LBRACE] = ACTIONS(4897),
    [aux_sym_char_literal_token1] = ACTIONS(4897),
    [anon_sym_SQUOTE] = ACTIONS(4895),
    [anon_sym___DATE__] = ACTIONS(4895),
    [anon_sym___FILE__] = ACTIONS(4895),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4895),
    [anon_sym___FUNCTION__] = ACTIONS(4895),
    [anon_sym___LINE__] = ACTIONS(4895),
    [anon_sym___MODULE__] = ACTIONS(4895),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4895),
    [anon_sym___TIME__] = ACTIONS(4895),
    [anon_sym___TIMESTAMP__] = ACTIONS(4895),
    [anon_sym___VENDOR__] = ACTIONS(4895),
    [anon_sym___VERSION__] = ACTIONS(4895),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4897),
    [sym_float_literal] = ACTIONS(4897),
    [sym__string] = ACTIONS(4897),
  },
  [1596] = {
    [sym_identifier] = ACTIONS(4664),
    [anon_sym_q_LBRACE] = ACTIONS(4666),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_LBRACE] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4666),
    [anon_sym_AMP] = ACTIONS(4666),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_BANG] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_RPAREN] = ACTIONS(4666),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_DOLLAR] = ACTIONS(4666),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_TILDE] = ACTIONS(4666),
    [anon_sym_AT] = ACTIONS(4666),
    [sym_bool] = ACTIONS(4664),
    [sym_byte] = ACTIONS(4664),
    [sym_ubyte] = ACTIONS(4664),
    [sym_char] = ACTIONS(4664),
    [sym_short] = ACTIONS(4664),
    [sym_ushort] = ACTIONS(4664),
    [sym_int] = ACTIONS(4664),
    [sym_uint] = ACTIONS(4664),
    [sym_long] = ACTIONS(4664),
    [sym_ulong] = ACTIONS(4664),
    [sym_cent] = ACTIONS(4664),
    [sym_ucent] = ACTIONS(4664),
    [sym_wchar] = ACTIONS(4664),
    [sym_dchar] = ACTIONS(4664),
    [sym_float] = ACTIONS(4664),
    [sym_double] = ACTIONS(4664),
    [sym_real] = ACTIONS(4664),
    [sym_ifloat] = ACTIONS(4664),
    [sym_idouble] = ACTIONS(4664),
    [sym_ireal] = ACTIONS(4664),
    [sym_cfloat] = ACTIONS(4664),
    [sym_cdouble] = ACTIONS(4664),
    [sym_creal] = ACTIONS(4664),
    [sym_size_t] = ACTIONS(4664),
    [sym_ptrdiff_t] = ACTIONS(4664),
    [sym_string] = ACTIONS(4664),
    [sym_cstring] = ACTIONS(4664),
    [sym_dstring] = ACTIONS(4664),
    [sym_wstring] = ACTIONS(4664),
    [sym_noreturn] = ACTIONS(4664),
    [sym_true] = ACTIONS(4664),
    [sym_false] = ACTIONS(4664),
    [sym_null] = ACTIONS(4664),
    [sym_super] = ACTIONS(4664),
    [sym_this] = ACTIONS(4664),
    [sym_abstract] = ACTIONS(4664),
    [sym_alias] = ACTIONS(4664),
    [sym_align] = ACTIONS(4664),
    [sym_asm] = ACTIONS(4664),
    [sym_assert] = ACTIONS(4664),
    [sym_auto] = ACTIONS(4664),
    [sym_break] = ACTIONS(4664),
    [sym_case] = ACTIONS(4664),
    [sym_cast] = ACTIONS(4664),
    [sym_class] = ACTIONS(4664),
    [sym_const] = ACTIONS(4664),
    [sym_continue] = ACTIONS(4664),
    [sym_debug] = ACTIONS(4664),
    [sym_default] = ACTIONS(4664),
    [sym_delegate] = ACTIONS(4664),
    [sym_delete] = ACTIONS(4664),
    [sym_deprecated] = ACTIONS(4664),
    [sym_do] = ACTIONS(4664),
    [sym_else] = ACTIONS(4664),
    [sym_enum] = ACTIONS(4664),
    [sym_export] = ACTIONS(4664),
    [sym_extern] = ACTIONS(4664),
    [sym_final] = ACTIONS(4664),
    [sym_for] = ACTIONS(4664),
    [sym_foreach] = ACTIONS(4664),
    [sym_foreach_reverse] = ACTIONS(4664),
    [sym_function] = ACTIONS(4664),
    [sym_goto] = ACTIONS(4664),
    [sym_if] = ACTIONS(4664),
    [sym_immutable] = ACTIONS(4664),
    [sym_import] = ACTIONS(4664),
    [sym_in] = ACTIONS(4664),
    [sym_inout] = ACTIONS(4664),
    [sym_interface] = ACTIONS(4664),
    [sym_invariant] = ACTIONS(4664),
    [sym_is] = ACTIONS(4664),
    [sym_mixin] = ACTIONS(4664),
    [sym_new] = ACTIONS(4664),
    [sym_nothrow] = ACTIONS(4664),
    [sym_out] = ACTIONS(4664),
    [sym_override] = ACTIONS(4664),
    [sym_package] = ACTIONS(4664),
    [sym_pragma] = ACTIONS(4664),
    [sym_private] = ACTIONS(4664),
    [sym_protected] = ACTIONS(4664),
    [sym_public] = ACTIONS(4664),
    [sym_pure] = ACTIONS(4664),
    [sym_ref] = ACTIONS(4664),
    [sym_return] = ACTIONS(4664),
    [sym_scope] = ACTIONS(4664),
    [sym_shared] = ACTIONS(4664),
    [sym_static] = ACTIONS(4664),
    [sym_struct] = ACTIONS(4664),
    [sym_switch] = ACTIONS(4664),
    [sym_synchronized] = ACTIONS(4664),
    [sym_template] = ACTIONS(4664),
    [sym_throw] = ACTIONS(4664),
    [sym_try] = ACTIONS(4664),
    [sym_typeid] = ACTIONS(4664),
    [sym_typeof] = ACTIONS(4664),
    [sym_union] = ACTIONS(4664),
    [sym_unittest] = ACTIONS(4664),
    [sym_version] = ACTIONS(4664),
    [sym_while] = ACTIONS(4664),
    [sym_with] = ACTIONS(4664),
    [sym_gshared] = ACTIONS(4664),
    [sym_traits] = ACTIONS(4664),
    [sym_vector] = ACTIONS(4664),
    [sym_void] = ACTIONS(4664),
    [anon_sym_BQUOTE] = ACTIONS(4666),
    [anon_sym_r_DQUOTE] = ACTIONS(4666),
    [anon_sym_x_DQUOTE] = ACTIONS(4666),
    [anon_sym_DQUOTE] = ACTIONS(4666),
    [anon_sym_i_BQUOTE] = ACTIONS(4666),
    [anon_sym_i_DQUOTE] = ACTIONS(4666),
    [anon_sym_iq_LBRACE] = ACTIONS(4666),
    [aux_sym_char_literal_token1] = ACTIONS(4666),
    [anon_sym_SQUOTE] = ACTIONS(4664),
    [anon_sym___DATE__] = ACTIONS(4664),
    [anon_sym___FILE__] = ACTIONS(4664),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4664),
    [anon_sym___FUNCTION__] = ACTIONS(4664),
    [anon_sym___LINE__] = ACTIONS(4664),
    [anon_sym___MODULE__] = ACTIONS(4664),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4664),
    [anon_sym___TIME__] = ACTIONS(4664),
    [anon_sym___TIMESTAMP__] = ACTIONS(4664),
    [anon_sym___VENDOR__] = ACTIONS(4664),
    [anon_sym___VERSION__] = ACTIONS(4664),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4666),
    [sym_float_literal] = ACTIONS(4666),
    [sym__string] = ACTIONS(4666),
  },
  [1597] = {
    [sym_identifier] = ACTIONS(4899),
    [anon_sym_q_LBRACE] = ACTIONS(4901),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_LBRACE] = ACTIONS(4901),
    [anon_sym_DOT] = ACTIONS(4901),
    [anon_sym_AMP] = ACTIONS(4901),
    [anon_sym_DASH] = ACTIONS(4899),
    [anon_sym_DASH_DASH] = ACTIONS(4901),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_PLUS_PLUS] = ACTIONS(4901),
    [anon_sym_BANG] = ACTIONS(4901),
    [anon_sym_LPAREN] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4901),
    [anon_sym_LBRACK] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [anon_sym_STAR] = ACTIONS(4901),
    [anon_sym_TILDE] = ACTIONS(4901),
    [anon_sym_AT] = ACTIONS(4901),
    [sym_bool] = ACTIONS(4899),
    [sym_byte] = ACTIONS(4899),
    [sym_ubyte] = ACTIONS(4899),
    [sym_char] = ACTIONS(4899),
    [sym_short] = ACTIONS(4899),
    [sym_ushort] = ACTIONS(4899),
    [sym_int] = ACTIONS(4899),
    [sym_uint] = ACTIONS(4899),
    [sym_long] = ACTIONS(4899),
    [sym_ulong] = ACTIONS(4899),
    [sym_cent] = ACTIONS(4899),
    [sym_ucent] = ACTIONS(4899),
    [sym_wchar] = ACTIONS(4899),
    [sym_dchar] = ACTIONS(4899),
    [sym_float] = ACTIONS(4899),
    [sym_double] = ACTIONS(4899),
    [sym_real] = ACTIONS(4899),
    [sym_ifloat] = ACTIONS(4899),
    [sym_idouble] = ACTIONS(4899),
    [sym_ireal] = ACTIONS(4899),
    [sym_cfloat] = ACTIONS(4899),
    [sym_cdouble] = ACTIONS(4899),
    [sym_creal] = ACTIONS(4899),
    [sym_size_t] = ACTIONS(4899),
    [sym_ptrdiff_t] = ACTIONS(4899),
    [sym_string] = ACTIONS(4899),
    [sym_cstring] = ACTIONS(4899),
    [sym_dstring] = ACTIONS(4899),
    [sym_wstring] = ACTIONS(4899),
    [sym_noreturn] = ACTIONS(4899),
    [sym_true] = ACTIONS(4899),
    [sym_false] = ACTIONS(4899),
    [sym_null] = ACTIONS(4899),
    [sym_super] = ACTIONS(4899),
    [sym_this] = ACTIONS(4899),
    [sym_abstract] = ACTIONS(4899),
    [sym_alias] = ACTIONS(4899),
    [sym_align] = ACTIONS(4899),
    [sym_asm] = ACTIONS(4899),
    [sym_assert] = ACTIONS(4899),
    [sym_auto] = ACTIONS(4899),
    [sym_break] = ACTIONS(4899),
    [sym_case] = ACTIONS(4899),
    [sym_cast] = ACTIONS(4899),
    [sym_class] = ACTIONS(4899),
    [sym_const] = ACTIONS(4899),
    [sym_continue] = ACTIONS(4899),
    [sym_debug] = ACTIONS(4899),
    [sym_default] = ACTIONS(4899),
    [sym_delegate] = ACTIONS(4899),
    [sym_delete] = ACTIONS(4899),
    [sym_deprecated] = ACTIONS(4899),
    [sym_do] = ACTIONS(4899),
    [sym_else] = ACTIONS(4899),
    [sym_enum] = ACTIONS(4899),
    [sym_export] = ACTIONS(4899),
    [sym_extern] = ACTIONS(4899),
    [sym_final] = ACTIONS(4899),
    [sym_for] = ACTIONS(4899),
    [sym_foreach] = ACTIONS(4899),
    [sym_foreach_reverse] = ACTIONS(4899),
    [sym_function] = ACTIONS(4899),
    [sym_goto] = ACTIONS(4899),
    [sym_if] = ACTIONS(4899),
    [sym_immutable] = ACTIONS(4899),
    [sym_import] = ACTIONS(4899),
    [sym_in] = ACTIONS(4899),
    [sym_inout] = ACTIONS(4899),
    [sym_interface] = ACTIONS(4899),
    [sym_invariant] = ACTIONS(4899),
    [sym_is] = ACTIONS(4899),
    [sym_mixin] = ACTIONS(4899),
    [sym_new] = ACTIONS(4899),
    [sym_nothrow] = ACTIONS(4899),
    [sym_out] = ACTIONS(4899),
    [sym_override] = ACTIONS(4899),
    [sym_package] = ACTIONS(4899),
    [sym_pragma] = ACTIONS(4899),
    [sym_private] = ACTIONS(4899),
    [sym_protected] = ACTIONS(4899),
    [sym_public] = ACTIONS(4899),
    [sym_pure] = ACTIONS(4899),
    [sym_ref] = ACTIONS(4899),
    [sym_return] = ACTIONS(4899),
    [sym_scope] = ACTIONS(4899),
    [sym_shared] = ACTIONS(4899),
    [sym_static] = ACTIONS(4899),
    [sym_struct] = ACTIONS(4899),
    [sym_switch] = ACTIONS(4899),
    [sym_synchronized] = ACTIONS(4899),
    [sym_template] = ACTIONS(4899),
    [sym_throw] = ACTIONS(4899),
    [sym_try] = ACTIONS(4899),
    [sym_typeid] = ACTIONS(4899),
    [sym_typeof] = ACTIONS(4899),
    [sym_union] = ACTIONS(4899),
    [sym_unittest] = ACTIONS(4899),
    [sym_version] = ACTIONS(4899),
    [sym_while] = ACTIONS(4899),
    [sym_with] = ACTIONS(4899),
    [sym_gshared] = ACTIONS(4899),
    [sym_traits] = ACTIONS(4899),
    [sym_vector] = ACTIONS(4899),
    [sym_void] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4901),
    [anon_sym_r_DQUOTE] = ACTIONS(4901),
    [anon_sym_x_DQUOTE] = ACTIONS(4901),
    [anon_sym_DQUOTE] = ACTIONS(4901),
    [anon_sym_i_BQUOTE] = ACTIONS(4901),
    [anon_sym_i_DQUOTE] = ACTIONS(4901),
    [anon_sym_iq_LBRACE] = ACTIONS(4901),
    [aux_sym_char_literal_token1] = ACTIONS(4901),
    [anon_sym_SQUOTE] = ACTIONS(4899),
    [anon_sym___DATE__] = ACTIONS(4899),
    [anon_sym___FILE__] = ACTIONS(4899),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4899),
    [anon_sym___FUNCTION__] = ACTIONS(4899),
    [anon_sym___LINE__] = ACTIONS(4899),
    [anon_sym___MODULE__] = ACTIONS(4899),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4899),
    [anon_sym___TIME__] = ACTIONS(4899),
    [anon_sym___TIMESTAMP__] = ACTIONS(4899),
    [anon_sym___VENDOR__] = ACTIONS(4899),
    [anon_sym___VERSION__] = ACTIONS(4899),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4901),
    [sym_float_literal] = ACTIONS(4901),
    [sym__string] = ACTIONS(4901),
  },
  [1598] = {
    [sym_identifier] = ACTIONS(4440),
    [anon_sym_q_LBRACE] = ACTIONS(4442),
    [anon_sym_RBRACE] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [anon_sym_DOT] = ACTIONS(4442),
    [anon_sym_AMP] = ACTIONS(4442),
    [anon_sym_DASH] = ACTIONS(4440),
    [anon_sym_DASH_DASH] = ACTIONS(4442),
    [anon_sym_PLUS] = ACTIONS(4440),
    [anon_sym_PLUS_PLUS] = ACTIONS(4442),
    [anon_sym_BANG] = ACTIONS(4442),
    [anon_sym_LPAREN] = ACTIONS(4442),
    [anon_sym_RPAREN] = ACTIONS(4442),
    [anon_sym_LBRACK] = ACTIONS(4442),
    [anon_sym_SEMI] = ACTIONS(4442),
    [anon_sym_DOLLAR] = ACTIONS(4442),
    [anon_sym_STAR] = ACTIONS(4442),
    [anon_sym_TILDE] = ACTIONS(4442),
    [anon_sym_AT] = ACTIONS(4442),
    [sym_bool] = ACTIONS(4440),
    [sym_byte] = ACTIONS(4440),
    [sym_ubyte] = ACTIONS(4440),
    [sym_char] = ACTIONS(4440),
    [sym_short] = ACTIONS(4440),
    [sym_ushort] = ACTIONS(4440),
    [sym_int] = ACTIONS(4440),
    [sym_uint] = ACTIONS(4440),
    [sym_long] = ACTIONS(4440),
    [sym_ulong] = ACTIONS(4440),
    [sym_cent] = ACTIONS(4440),
    [sym_ucent] = ACTIONS(4440),
    [sym_wchar] = ACTIONS(4440),
    [sym_dchar] = ACTIONS(4440),
    [sym_float] = ACTIONS(4440),
    [sym_double] = ACTIONS(4440),
    [sym_real] = ACTIONS(4440),
    [sym_ifloat] = ACTIONS(4440),
    [sym_idouble] = ACTIONS(4440),
    [sym_ireal] = ACTIONS(4440),
    [sym_cfloat] = ACTIONS(4440),
    [sym_cdouble] = ACTIONS(4440),
    [sym_creal] = ACTIONS(4440),
    [sym_size_t] = ACTIONS(4440),
    [sym_ptrdiff_t] = ACTIONS(4440),
    [sym_string] = ACTIONS(4440),
    [sym_cstring] = ACTIONS(4440),
    [sym_dstring] = ACTIONS(4440),
    [sym_wstring] = ACTIONS(4440),
    [sym_noreturn] = ACTIONS(4440),
    [sym_true] = ACTIONS(4440),
    [sym_false] = ACTIONS(4440),
    [sym_null] = ACTIONS(4440),
    [sym_super] = ACTIONS(4440),
    [sym_this] = ACTIONS(4440),
    [sym_abstract] = ACTIONS(4440),
    [sym_alias] = ACTIONS(4440),
    [sym_align] = ACTIONS(4440),
    [sym_asm] = ACTIONS(4440),
    [sym_assert] = ACTIONS(4440),
    [sym_auto] = ACTIONS(4440),
    [sym_break] = ACTIONS(4440),
    [sym_case] = ACTIONS(4440),
    [sym_cast] = ACTIONS(4440),
    [sym_class] = ACTIONS(4440),
    [sym_const] = ACTIONS(4440),
    [sym_continue] = ACTIONS(4440),
    [sym_debug] = ACTIONS(4440),
    [sym_default] = ACTIONS(4440),
    [sym_delegate] = ACTIONS(4440),
    [sym_delete] = ACTIONS(4440),
    [sym_deprecated] = ACTIONS(4440),
    [sym_do] = ACTIONS(4440),
    [sym_else] = ACTIONS(4440),
    [sym_enum] = ACTIONS(4440),
    [sym_export] = ACTIONS(4440),
    [sym_extern] = ACTIONS(4440),
    [sym_final] = ACTIONS(4440),
    [sym_for] = ACTIONS(4440),
    [sym_foreach] = ACTIONS(4440),
    [sym_foreach_reverse] = ACTIONS(4440),
    [sym_function] = ACTIONS(4440),
    [sym_goto] = ACTIONS(4440),
    [sym_if] = ACTIONS(4440),
    [sym_immutable] = ACTIONS(4440),
    [sym_import] = ACTIONS(4440),
    [sym_in] = ACTIONS(4440),
    [sym_inout] = ACTIONS(4440),
    [sym_interface] = ACTIONS(4440),
    [sym_invariant] = ACTIONS(4440),
    [sym_is] = ACTIONS(4440),
    [sym_mixin] = ACTIONS(4440),
    [sym_new] = ACTIONS(4440),
    [sym_nothrow] = ACTIONS(4440),
    [sym_out] = ACTIONS(4440),
    [sym_override] = ACTIONS(4440),
    [sym_package] = ACTIONS(4440),
    [sym_pragma] = ACTIONS(4440),
    [sym_private] = ACTIONS(4440),
    [sym_protected] = ACTIONS(4440),
    [sym_public] = ACTIONS(4440),
    [sym_pure] = ACTIONS(4440),
    [sym_ref] = ACTIONS(4440),
    [sym_return] = ACTIONS(4440),
    [sym_scope] = ACTIONS(4440),
    [sym_shared] = ACTIONS(4440),
    [sym_static] = ACTIONS(4440),
    [sym_struct] = ACTIONS(4440),
    [sym_switch] = ACTIONS(4440),
    [sym_synchronized] = ACTIONS(4440),
    [sym_template] = ACTIONS(4440),
    [sym_throw] = ACTIONS(4440),
    [sym_try] = ACTIONS(4440),
    [sym_typeid] = ACTIONS(4440),
    [sym_typeof] = ACTIONS(4440),
    [sym_union] = ACTIONS(4440),
    [sym_unittest] = ACTIONS(4440),
    [sym_version] = ACTIONS(4440),
    [sym_while] = ACTIONS(4440),
    [sym_with] = ACTIONS(4440),
    [sym_gshared] = ACTIONS(4440),
    [sym_traits] = ACTIONS(4440),
    [sym_vector] = ACTIONS(4440),
    [sym_void] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_r_DQUOTE] = ACTIONS(4442),
    [anon_sym_x_DQUOTE] = ACTIONS(4442),
    [anon_sym_DQUOTE] = ACTIONS(4442),
    [anon_sym_i_BQUOTE] = ACTIONS(4442),
    [anon_sym_i_DQUOTE] = ACTIONS(4442),
    [anon_sym_iq_LBRACE] = ACTIONS(4442),
    [aux_sym_char_literal_token1] = ACTIONS(4442),
    [anon_sym_SQUOTE] = ACTIONS(4440),
    [anon_sym___DATE__] = ACTIONS(4440),
    [anon_sym___FILE__] = ACTIONS(4440),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4440),
    [anon_sym___FUNCTION__] = ACTIONS(4440),
    [anon_sym___LINE__] = ACTIONS(4440),
    [anon_sym___MODULE__] = ACTIONS(4440),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4440),
    [anon_sym___TIME__] = ACTIONS(4440),
    [anon_sym___TIMESTAMP__] = ACTIONS(4440),
    [anon_sym___VENDOR__] = ACTIONS(4440),
    [anon_sym___VERSION__] = ACTIONS(4440),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4442),
    [sym_float_literal] = ACTIONS(4442),
    [sym__string] = ACTIONS(4442),
  },
  [1599] = {
    [sym_identifier] = ACTIONS(4903),
    [anon_sym_q_LBRACE] = ACTIONS(4905),
    [anon_sym_RBRACE] = ACTIONS(4905),
    [anon_sym_LBRACE] = ACTIONS(4905),
    [anon_sym_DOT] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4905),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_DASH_DASH] = ACTIONS(4905),
    [anon_sym_PLUS] = ACTIONS(4903),
    [anon_sym_PLUS_PLUS] = ACTIONS(4905),
    [anon_sym_BANG] = ACTIONS(4905),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(4905),
    [anon_sym_SEMI] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4905),
    [anon_sym_STAR] = ACTIONS(4905),
    [anon_sym_TILDE] = ACTIONS(4905),
    [anon_sym_AT] = ACTIONS(4905),
    [sym_bool] = ACTIONS(4903),
    [sym_byte] = ACTIONS(4903),
    [sym_ubyte] = ACTIONS(4903),
    [sym_char] = ACTIONS(4903),
    [sym_short] = ACTIONS(4903),
    [sym_ushort] = ACTIONS(4903),
    [sym_int] = ACTIONS(4903),
    [sym_uint] = ACTIONS(4903),
    [sym_long] = ACTIONS(4903),
    [sym_ulong] = ACTIONS(4903),
    [sym_cent] = ACTIONS(4903),
    [sym_ucent] = ACTIONS(4903),
    [sym_wchar] = ACTIONS(4903),
    [sym_dchar] = ACTIONS(4903),
    [sym_float] = ACTIONS(4903),
    [sym_double] = ACTIONS(4903),
    [sym_real] = ACTIONS(4903),
    [sym_ifloat] = ACTIONS(4903),
    [sym_idouble] = ACTIONS(4903),
    [sym_ireal] = ACTIONS(4903),
    [sym_cfloat] = ACTIONS(4903),
    [sym_cdouble] = ACTIONS(4903),
    [sym_creal] = ACTIONS(4903),
    [sym_size_t] = ACTIONS(4903),
    [sym_ptrdiff_t] = ACTIONS(4903),
    [sym_string] = ACTIONS(4903),
    [sym_cstring] = ACTIONS(4903),
    [sym_dstring] = ACTIONS(4903),
    [sym_wstring] = ACTIONS(4903),
    [sym_noreturn] = ACTIONS(4903),
    [sym_true] = ACTIONS(4903),
    [sym_false] = ACTIONS(4903),
    [sym_null] = ACTIONS(4903),
    [sym_super] = ACTIONS(4903),
    [sym_this] = ACTIONS(4903),
    [sym_abstract] = ACTIONS(4903),
    [sym_alias] = ACTIONS(4903),
    [sym_align] = ACTIONS(4903),
    [sym_asm] = ACTIONS(4903),
    [sym_assert] = ACTIONS(4903),
    [sym_auto] = ACTIONS(4903),
    [sym_break] = ACTIONS(4903),
    [sym_case] = ACTIONS(4903),
    [sym_cast] = ACTIONS(4903),
    [sym_class] = ACTIONS(4903),
    [sym_const] = ACTIONS(4903),
    [sym_continue] = ACTIONS(4903),
    [sym_debug] = ACTIONS(4903),
    [sym_default] = ACTIONS(4903),
    [sym_delegate] = ACTIONS(4903),
    [sym_delete] = ACTIONS(4903),
    [sym_deprecated] = ACTIONS(4903),
    [sym_do] = ACTIONS(4903),
    [sym_else] = ACTIONS(4903),
    [sym_enum] = ACTIONS(4903),
    [sym_export] = ACTIONS(4903),
    [sym_extern] = ACTIONS(4903),
    [sym_final] = ACTIONS(4903),
    [sym_for] = ACTIONS(4903),
    [sym_foreach] = ACTIONS(4903),
    [sym_foreach_reverse] = ACTIONS(4903),
    [sym_function] = ACTIONS(4903),
    [sym_goto] = ACTIONS(4903),
    [sym_if] = ACTIONS(4903),
    [sym_immutable] = ACTIONS(4903),
    [sym_import] = ACTIONS(4903),
    [sym_in] = ACTIONS(4903),
    [sym_inout] = ACTIONS(4903),
    [sym_interface] = ACTIONS(4903),
    [sym_invariant] = ACTIONS(4903),
    [sym_is] = ACTIONS(4903),
    [sym_mixin] = ACTIONS(4903),
    [sym_new] = ACTIONS(4903),
    [sym_nothrow] = ACTIONS(4903),
    [sym_out] = ACTIONS(4903),
    [sym_override] = ACTIONS(4903),
    [sym_package] = ACTIONS(4903),
    [sym_pragma] = ACTIONS(4903),
    [sym_private] = ACTIONS(4903),
    [sym_protected] = ACTIONS(4903),
    [sym_public] = ACTIONS(4903),
    [sym_pure] = ACTIONS(4903),
    [sym_ref] = ACTIONS(4903),
    [sym_return] = ACTIONS(4903),
    [sym_scope] = ACTIONS(4903),
    [sym_shared] = ACTIONS(4903),
    [sym_static] = ACTIONS(4903),
    [sym_struct] = ACTIONS(4903),
    [sym_switch] = ACTIONS(4903),
    [sym_synchronized] = ACTIONS(4903),
    [sym_template] = ACTIONS(4903),
    [sym_throw] = ACTIONS(4903),
    [sym_try] = ACTIONS(4903),
    [sym_typeid] = ACTIONS(4903),
    [sym_typeof] = ACTIONS(4903),
    [sym_union] = ACTIONS(4903),
    [sym_unittest] = ACTIONS(4903),
    [sym_version] = ACTIONS(4903),
    [sym_while] = ACTIONS(4903),
    [sym_with] = ACTIONS(4903),
    [sym_gshared] = ACTIONS(4903),
    [sym_traits] = ACTIONS(4903),
    [sym_vector] = ACTIONS(4903),
    [sym_void] = ACTIONS(4903),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_r_DQUOTE] = ACTIONS(4905),
    [anon_sym_x_DQUOTE] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_i_BQUOTE] = ACTIONS(4905),
    [anon_sym_i_DQUOTE] = ACTIONS(4905),
    [anon_sym_iq_LBRACE] = ACTIONS(4905),
    [aux_sym_char_literal_token1] = ACTIONS(4905),
    [anon_sym_SQUOTE] = ACTIONS(4903),
    [anon_sym___DATE__] = ACTIONS(4903),
    [anon_sym___FILE__] = ACTIONS(4903),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4903),
    [anon_sym___FUNCTION__] = ACTIONS(4903),
    [anon_sym___LINE__] = ACTIONS(4903),
    [anon_sym___MODULE__] = ACTIONS(4903),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4903),
    [anon_sym___TIME__] = ACTIONS(4903),
    [anon_sym___TIMESTAMP__] = ACTIONS(4903),
    [anon_sym___VENDOR__] = ACTIONS(4903),
    [anon_sym___VERSION__] = ACTIONS(4903),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4905),
    [sym_float_literal] = ACTIONS(4905),
    [sym__string] = ACTIONS(4905),
  },
  [1600] = {
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_q_LBRACE] = ACTIONS(4923),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_LBRACE] = ACTIONS(4923),
    [anon_sym_DOT] = ACTIONS(4923),
    [anon_sym_AMP] = ACTIONS(4923),
    [anon_sym_DASH] = ACTIONS(4921),
    [anon_sym_DASH_DASH] = ACTIONS(4923),
    [anon_sym_PLUS] = ACTIONS(4921),
    [anon_sym_PLUS_PLUS] = ACTIONS(4923),
    [anon_sym_BANG] = ACTIONS(4923),
    [anon_sym_LPAREN] = ACTIONS(4923),
    [anon_sym_RPAREN] = ACTIONS(4923),
    [anon_sym_LBRACK] = ACTIONS(4923),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym_DOLLAR] = ACTIONS(4923),
    [anon_sym_STAR] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4923),
    [anon_sym_AT] = ACTIONS(4923),
    [sym_bool] = ACTIONS(4921),
    [sym_byte] = ACTIONS(4921),
    [sym_ubyte] = ACTIONS(4921),
    [sym_char] = ACTIONS(4921),
    [sym_short] = ACTIONS(4921),
    [sym_ushort] = ACTIONS(4921),
    [sym_int] = ACTIONS(4921),
    [sym_uint] = ACTIONS(4921),
    [sym_long] = ACTIONS(4921),
    [sym_ulong] = ACTIONS(4921),
    [sym_cent] = ACTIONS(4921),
    [sym_ucent] = ACTIONS(4921),
    [sym_wchar] = ACTIONS(4921),
    [sym_dchar] = ACTIONS(4921),
    [sym_float] = ACTIONS(4921),
    [sym_double] = ACTIONS(4921),
    [sym_real] = ACTIONS(4921),
    [sym_ifloat] = ACTIONS(4921),
    [sym_idouble] = ACTIONS(4921),
    [sym_ireal] = ACTIONS(4921),
    [sym_cfloat] = ACTIONS(4921),
    [sym_cdouble] = ACTIONS(4921),
    [sym_creal] = ACTIONS(4921),
    [sym_size_t] = ACTIONS(4921),
    [sym_ptrdiff_t] = ACTIONS(4921),
    [sym_string] = ACTIONS(4921),
    [sym_cstring] = ACTIONS(4921),
    [sym_dstring] = ACTIONS(4921),
    [sym_wstring] = ACTIONS(4921),
    [sym_noreturn] = ACTIONS(4921),
    [sym_true] = ACTIONS(4921),
    [sym_false] = ACTIONS(4921),
    [sym_null] = ACTIONS(4921),
    [sym_super] = ACTIONS(4921),
    [sym_this] = ACTIONS(4921),
    [sym_abstract] = ACTIONS(4921),
    [sym_alias] = ACTIONS(4921),
    [sym_align] = ACTIONS(4921),
    [sym_asm] = ACTIONS(4921),
    [sym_assert] = ACTIONS(4921),
    [sym_auto] = ACTIONS(4921),
    [sym_break] = ACTIONS(4921),
    [sym_case] = ACTIONS(4921),
    [sym_cast] = ACTIONS(4921),
    [sym_class] = ACTIONS(4921),
    [sym_const] = ACTIONS(4921),
    [sym_continue] = ACTIONS(4921),
    [sym_debug] = ACTIONS(4921),
    [sym_default] = ACTIONS(4921),
    [sym_delegate] = ACTIONS(4921),
    [sym_delete] = ACTIONS(4921),
    [sym_deprecated] = ACTIONS(4921),
    [sym_do] = ACTIONS(4921),
    [sym_else] = ACTIONS(4921),
    [sym_enum] = ACTIONS(4921),
    [sym_export] = ACTIONS(4921),
    [sym_extern] = ACTIONS(4921),
    [sym_final] = ACTIONS(4921),
    [sym_for] = ACTIONS(4921),
    [sym_foreach] = ACTIONS(4921),
    [sym_foreach_reverse] = ACTIONS(4921),
    [sym_function] = ACTIONS(4921),
    [sym_goto] = ACTIONS(4921),
    [sym_if] = ACTIONS(4921),
    [sym_immutable] = ACTIONS(4921),
    [sym_import] = ACTIONS(4921),
    [sym_in] = ACTIONS(4921),
    [sym_inout] = ACTIONS(4921),
    [sym_interface] = ACTIONS(4921),
    [sym_invariant] = ACTIONS(4921),
    [sym_is] = ACTIONS(4921),
    [sym_mixin] = ACTIONS(4921),
    [sym_new] = ACTIONS(4921),
    [sym_nothrow] = ACTIONS(4921),
    [sym_out] = ACTIONS(4921),
    [sym_override] = ACTIONS(4921),
    [sym_package] = ACTIONS(4921),
    [sym_pragma] = ACTIONS(4921),
    [sym_private] = ACTIONS(4921),
    [sym_protected] = ACTIONS(4921),
    [sym_public] = ACTIONS(4921),
    [sym_pure] = ACTIONS(4921),
    [sym_ref] = ACTIONS(4921),
    [sym_return] = ACTIONS(4921),
    [sym_scope] = ACTIONS(4921),
    [sym_shared] = ACTIONS(4921),
    [sym_static] = ACTIONS(4921),
    [sym_struct] = ACTIONS(4921),
    [sym_switch] = ACTIONS(4921),
    [sym_synchronized] = ACTIONS(4921),
    [sym_template] = ACTIONS(4921),
    [sym_throw] = ACTIONS(4921),
    [sym_try] = ACTIONS(4921),
    [sym_typeid] = ACTIONS(4921),
    [sym_typeof] = ACTIONS(4921),
    [sym_union] = ACTIONS(4921),
    [sym_unittest] = ACTIONS(4921),
    [sym_version] = ACTIONS(4921),
    [sym_while] = ACTIONS(4921),
    [sym_with] = ACTIONS(4921),
    [sym_gshared] = ACTIONS(4921),
    [sym_traits] = ACTIONS(4921),
    [sym_vector] = ACTIONS(4921),
    [sym_void] = ACTIONS(4921),
    [anon_sym_BQUOTE] = ACTIONS(4923),
    [anon_sym_r_DQUOTE] = ACTIONS(4923),
    [anon_sym_x_DQUOTE] = ACTIONS(4923),
    [anon_sym_DQUOTE] = ACTIONS(4923),
    [anon_sym_i_BQUOTE] = ACTIONS(4923),
    [anon_sym_i_DQUOTE] = ACTIONS(4923),
    [anon_sym_iq_LBRACE] = ACTIONS(4923),
    [aux_sym_char_literal_token1] = ACTIONS(4923),
    [anon_sym_SQUOTE] = ACTIONS(4921),
    [anon_sym___DATE__] = ACTIONS(4921),
    [anon_sym___FILE__] = ACTIONS(4921),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4921),
    [anon_sym___FUNCTION__] = ACTIONS(4921),
    [anon_sym___LINE__] = ACTIONS(4921),
    [anon_sym___MODULE__] = ACTIONS(4921),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4921),
    [anon_sym___TIME__] = ACTIONS(4921),
    [anon_sym___TIMESTAMP__] = ACTIONS(4921),
    [anon_sym___VENDOR__] = ACTIONS(4921),
    [anon_sym___VERSION__] = ACTIONS(4921),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4923),
    [sym_float_literal] = ACTIONS(4923),
    [sym__string] = ACTIONS(4923),
  },
  [1601] = {
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_q_LBRACE] = ACTIONS(4927),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_LBRACE] = ACTIONS(4927),
    [anon_sym_DOT] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(4927),
    [anon_sym_DASH] = ACTIONS(4925),
    [anon_sym_DASH_DASH] = ACTIONS(4927),
    [anon_sym_PLUS] = ACTIONS(4925),
    [anon_sym_PLUS_PLUS] = ACTIONS(4927),
    [anon_sym_BANG] = ACTIONS(4927),
    [anon_sym_LPAREN] = ACTIONS(4927),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_DOLLAR] = ACTIONS(4927),
    [anon_sym_STAR] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(4927),
    [sym_bool] = ACTIONS(4925),
    [sym_byte] = ACTIONS(4925),
    [sym_ubyte] = ACTIONS(4925),
    [sym_char] = ACTIONS(4925),
    [sym_short] = ACTIONS(4925),
    [sym_ushort] = ACTIONS(4925),
    [sym_int] = ACTIONS(4925),
    [sym_uint] = ACTIONS(4925),
    [sym_long] = ACTIONS(4925),
    [sym_ulong] = ACTIONS(4925),
    [sym_cent] = ACTIONS(4925),
    [sym_ucent] = ACTIONS(4925),
    [sym_wchar] = ACTIONS(4925),
    [sym_dchar] = ACTIONS(4925),
    [sym_float] = ACTIONS(4925),
    [sym_double] = ACTIONS(4925),
    [sym_real] = ACTIONS(4925),
    [sym_ifloat] = ACTIONS(4925),
    [sym_idouble] = ACTIONS(4925),
    [sym_ireal] = ACTIONS(4925),
    [sym_cfloat] = ACTIONS(4925),
    [sym_cdouble] = ACTIONS(4925),
    [sym_creal] = ACTIONS(4925),
    [sym_size_t] = ACTIONS(4925),
    [sym_ptrdiff_t] = ACTIONS(4925),
    [sym_string] = ACTIONS(4925),
    [sym_cstring] = ACTIONS(4925),
    [sym_dstring] = ACTIONS(4925),
    [sym_wstring] = ACTIONS(4925),
    [sym_noreturn] = ACTIONS(4925),
    [sym_true] = ACTIONS(4925),
    [sym_false] = ACTIONS(4925),
    [sym_null] = ACTIONS(4925),
    [sym_super] = ACTIONS(4925),
    [sym_this] = ACTIONS(4925),
    [sym_abstract] = ACTIONS(4925),
    [sym_alias] = ACTIONS(4925),
    [sym_align] = ACTIONS(4925),
    [sym_asm] = ACTIONS(4925),
    [sym_assert] = ACTIONS(4925),
    [sym_auto] = ACTIONS(4925),
    [sym_break] = ACTIONS(4925),
    [sym_case] = ACTIONS(4925),
    [sym_cast] = ACTIONS(4925),
    [sym_class] = ACTIONS(4925),
    [sym_const] = ACTIONS(4925),
    [sym_continue] = ACTIONS(4925),
    [sym_debug] = ACTIONS(4925),
    [sym_default] = ACTIONS(4925),
    [sym_delegate] = ACTIONS(4925),
    [sym_delete] = ACTIONS(4925),
    [sym_deprecated] = ACTIONS(4925),
    [sym_do] = ACTIONS(4925),
    [sym_else] = ACTIONS(4925),
    [sym_enum] = ACTIONS(4925),
    [sym_export] = ACTIONS(4925),
    [sym_extern] = ACTIONS(4925),
    [sym_final] = ACTIONS(4925),
    [sym_for] = ACTIONS(4925),
    [sym_foreach] = ACTIONS(4925),
    [sym_foreach_reverse] = ACTIONS(4925),
    [sym_function] = ACTIONS(4925),
    [sym_goto] = ACTIONS(4925),
    [sym_if] = ACTIONS(4925),
    [sym_immutable] = ACTIONS(4925),
    [sym_import] = ACTIONS(4925),
    [sym_in] = ACTIONS(4925),
    [sym_inout] = ACTIONS(4925),
    [sym_interface] = ACTIONS(4925),
    [sym_invariant] = ACTIONS(4925),
    [sym_is] = ACTIONS(4925),
    [sym_mixin] = ACTIONS(4925),
    [sym_new] = ACTIONS(4925),
    [sym_nothrow] = ACTIONS(4925),
    [sym_out] = ACTIONS(4925),
    [sym_override] = ACTIONS(4925),
    [sym_package] = ACTIONS(4925),
    [sym_pragma] = ACTIONS(4925),
    [sym_private] = ACTIONS(4925),
    [sym_protected] = ACTIONS(4925),
    [sym_public] = ACTIONS(4925),
    [sym_pure] = ACTIONS(4925),
    [sym_ref] = ACTIONS(4925),
    [sym_return] = ACTIONS(4925),
    [sym_scope] = ACTIONS(4925),
    [sym_shared] = ACTIONS(4925),
    [sym_static] = ACTIONS(4925),
    [sym_struct] = ACTIONS(4925),
    [sym_switch] = ACTIONS(4925),
    [sym_synchronized] = ACTIONS(4925),
    [sym_template] = ACTIONS(4925),
    [sym_throw] = ACTIONS(4925),
    [sym_try] = ACTIONS(4925),
    [sym_typeid] = ACTIONS(4925),
    [sym_typeof] = ACTIONS(4925),
    [sym_union] = ACTIONS(4925),
    [sym_unittest] = ACTIONS(4925),
    [sym_version] = ACTIONS(4925),
    [sym_while] = ACTIONS(4925),
    [sym_with] = ACTIONS(4925),
    [sym_gshared] = ACTIONS(4925),
    [sym_traits] = ACTIONS(4925),
    [sym_vector] = ACTIONS(4925),
    [sym_void] = ACTIONS(4925),
    [anon_sym_BQUOTE] = ACTIONS(4927),
    [anon_sym_r_DQUOTE] = ACTIONS(4927),
    [anon_sym_x_DQUOTE] = ACTIONS(4927),
    [anon_sym_DQUOTE] = ACTIONS(4927),
    [anon_sym_i_BQUOTE] = ACTIONS(4927),
    [anon_sym_i_DQUOTE] = ACTIONS(4927),
    [anon_sym_iq_LBRACE] = ACTIONS(4927),
    [aux_sym_char_literal_token1] = ACTIONS(4927),
    [anon_sym_SQUOTE] = ACTIONS(4925),
    [anon_sym___DATE__] = ACTIONS(4925),
    [anon_sym___FILE__] = ACTIONS(4925),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4925),
    [anon_sym___FUNCTION__] = ACTIONS(4925),
    [anon_sym___LINE__] = ACTIONS(4925),
    [anon_sym___MODULE__] = ACTIONS(4925),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4925),
    [anon_sym___TIME__] = ACTIONS(4925),
    [anon_sym___TIMESTAMP__] = ACTIONS(4925),
    [anon_sym___VENDOR__] = ACTIONS(4925),
    [anon_sym___VERSION__] = ACTIONS(4925),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4927),
    [sym_float_literal] = ACTIONS(4927),
    [sym__string] = ACTIONS(4927),
  },
  [1602] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_RBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [anon_sym_AT] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_abstract] = ACTIONS(4688),
    [sym_alias] = ACTIONS(4688),
    [sym_align] = ACTIONS(4688),
    [sym_asm] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_break] = ACTIONS(4688),
    [sym_case] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_class] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_continue] = ACTIONS(4688),
    [sym_debug] = ACTIONS(4688),
    [sym_default] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_deprecated] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(5022),
    [sym_enum] = ACTIONS(4688),
    [sym_export] = ACTIONS(4688),
    [sym_extern] = ACTIONS(4688),
    [sym_final] = ACTIONS(4688),
    [sym_for] = ACTIONS(4688),
    [sym_foreach] = ACTIONS(4688),
    [sym_foreach_reverse] = ACTIONS(4688),
    [sym_function] = ACTIONS(4688),
    [sym_goto] = ACTIONS(4688),
    [sym_if] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_interface] = ACTIONS(4688),
    [sym_invariant] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_nothrow] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_override] = ACTIONS(4688),
    [sym_package] = ACTIONS(4688),
    [sym_pragma] = ACTIONS(4688),
    [sym_private] = ACTIONS(4688),
    [sym_protected] = ACTIONS(4688),
    [sym_public] = ACTIONS(4688),
    [sym_pure] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_return] = ACTIONS(4688),
    [sym_scope] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_static] = ACTIONS(4688),
    [sym_struct] = ACTIONS(4688),
    [sym_switch] = ACTIONS(4688),
    [sym_synchronized] = ACTIONS(4688),
    [sym_template] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_try] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_union] = ACTIONS(4688),
    [sym_unittest] = ACTIONS(4688),
    [sym_version] = ACTIONS(4688),
    [sym_while] = ACTIONS(4688),
    [sym_with] = ACTIONS(4688),
    [sym_gshared] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [1603] = {
    [sym_identifier] = ACTIONS(4929),
    [anon_sym_q_LBRACE] = ACTIONS(4931),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_LBRACE] = ACTIONS(4931),
    [anon_sym_DOT] = ACTIONS(4931),
    [anon_sym_AMP] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(4929),
    [anon_sym_DASH_DASH] = ACTIONS(4931),
    [anon_sym_PLUS] = ACTIONS(4929),
    [anon_sym_PLUS_PLUS] = ACTIONS(4931),
    [anon_sym_BANG] = ACTIONS(4931),
    [anon_sym_LPAREN] = ACTIONS(4931),
    [anon_sym_RPAREN] = ACTIONS(4931),
    [anon_sym_LBRACK] = ACTIONS(4931),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_DOLLAR] = ACTIONS(4931),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4931),
    [anon_sym_AT] = ACTIONS(4931),
    [sym_bool] = ACTIONS(4929),
    [sym_byte] = ACTIONS(4929),
    [sym_ubyte] = ACTIONS(4929),
    [sym_char] = ACTIONS(4929),
    [sym_short] = ACTIONS(4929),
    [sym_ushort] = ACTIONS(4929),
    [sym_int] = ACTIONS(4929),
    [sym_uint] = ACTIONS(4929),
    [sym_long] = ACTIONS(4929),
    [sym_ulong] = ACTIONS(4929),
    [sym_cent] = ACTIONS(4929),
    [sym_ucent] = ACTIONS(4929),
    [sym_wchar] = ACTIONS(4929),
    [sym_dchar] = ACTIONS(4929),
    [sym_float] = ACTIONS(4929),
    [sym_double] = ACTIONS(4929),
    [sym_real] = ACTIONS(4929),
    [sym_ifloat] = ACTIONS(4929),
    [sym_idouble] = ACTIONS(4929),
    [sym_ireal] = ACTIONS(4929),
    [sym_cfloat] = ACTIONS(4929),
    [sym_cdouble] = ACTIONS(4929),
    [sym_creal] = ACTIONS(4929),
    [sym_size_t] = ACTIONS(4929),
    [sym_ptrdiff_t] = ACTIONS(4929),
    [sym_string] = ACTIONS(4929),
    [sym_cstring] = ACTIONS(4929),
    [sym_dstring] = ACTIONS(4929),
    [sym_wstring] = ACTIONS(4929),
    [sym_noreturn] = ACTIONS(4929),
    [sym_true] = ACTIONS(4929),
    [sym_false] = ACTIONS(4929),
    [sym_null] = ACTIONS(4929),
    [sym_super] = ACTIONS(4929),
    [sym_this] = ACTIONS(4929),
    [sym_abstract] = ACTIONS(4929),
    [sym_alias] = ACTIONS(4929),
    [sym_align] = ACTIONS(4929),
    [sym_asm] = ACTIONS(4929),
    [sym_assert] = ACTIONS(4929),
    [sym_auto] = ACTIONS(4929),
    [sym_break] = ACTIONS(4929),
    [sym_case] = ACTIONS(4929),
    [sym_cast] = ACTIONS(4929),
    [sym_class] = ACTIONS(4929),
    [sym_const] = ACTIONS(4929),
    [sym_continue] = ACTIONS(4929),
    [sym_debug] = ACTIONS(4929),
    [sym_default] = ACTIONS(4929),
    [sym_delegate] = ACTIONS(4929),
    [sym_delete] = ACTIONS(4929),
    [sym_deprecated] = ACTIONS(4929),
    [sym_do] = ACTIONS(4929),
    [sym_else] = ACTIONS(4929),
    [sym_enum] = ACTIONS(4929),
    [sym_export] = ACTIONS(4929),
    [sym_extern] = ACTIONS(4929),
    [sym_final] = ACTIONS(4929),
    [sym_for] = ACTIONS(4929),
    [sym_foreach] = ACTIONS(4929),
    [sym_foreach_reverse] = ACTIONS(4929),
    [sym_function] = ACTIONS(4929),
    [sym_goto] = ACTIONS(4929),
    [sym_if] = ACTIONS(4929),
    [sym_immutable] = ACTIONS(4929),
    [sym_import] = ACTIONS(4929),
    [sym_in] = ACTIONS(4929),
    [sym_inout] = ACTIONS(4929),
    [sym_interface] = ACTIONS(4929),
    [sym_invariant] = ACTIONS(4929),
    [sym_is] = ACTIONS(4929),
    [sym_mixin] = ACTIONS(4929),
    [sym_new] = ACTIONS(4929),
    [sym_nothrow] = ACTIONS(4929),
    [sym_out] = ACTIONS(4929),
    [sym_override] = ACTIONS(4929),
    [sym_package] = ACTIONS(4929),
    [sym_pragma] = ACTIONS(4929),
    [sym_private] = ACTIONS(4929),
    [sym_protected] = ACTIONS(4929),
    [sym_public] = ACTIONS(4929),
    [sym_pure] = ACTIONS(4929),
    [sym_ref] = ACTIONS(4929),
    [sym_return] = ACTIONS(4929),
    [sym_scope] = ACTIONS(4929),
    [sym_shared] = ACTIONS(4929),
    [sym_static] = ACTIONS(4929),
    [sym_struct] = ACTIONS(4929),
    [sym_switch] = ACTIONS(4929),
    [sym_synchronized] = ACTIONS(4929),
    [sym_template] = ACTIONS(4929),
    [sym_throw] = ACTIONS(4929),
    [sym_try] = ACTIONS(4929),
    [sym_typeid] = ACTIONS(4929),
    [sym_typeof] = ACTIONS(4929),
    [sym_union] = ACTIONS(4929),
    [sym_unittest] = ACTIONS(4929),
    [sym_version] = ACTIONS(4929),
    [sym_while] = ACTIONS(4929),
    [sym_with] = ACTIONS(4929),
    [sym_gshared] = ACTIONS(4929),
    [sym_traits] = ACTIONS(4929),
    [sym_vector] = ACTIONS(4929),
    [sym_void] = ACTIONS(4929),
    [anon_sym_BQUOTE] = ACTIONS(4931),
    [anon_sym_r_DQUOTE] = ACTIONS(4931),
    [anon_sym_x_DQUOTE] = ACTIONS(4931),
    [anon_sym_DQUOTE] = ACTIONS(4931),
    [anon_sym_i_BQUOTE] = ACTIONS(4931),
    [anon_sym_i_DQUOTE] = ACTIONS(4931),
    [anon_sym_iq_LBRACE] = ACTIONS(4931),
    [aux_sym_char_literal_token1] = ACTIONS(4931),
    [anon_sym_SQUOTE] = ACTIONS(4929),
    [anon_sym___DATE__] = ACTIONS(4929),
    [anon_sym___FILE__] = ACTIONS(4929),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4929),
    [anon_sym___FUNCTION__] = ACTIONS(4929),
    [anon_sym___LINE__] = ACTIONS(4929),
    [anon_sym___MODULE__] = ACTIONS(4929),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4929),
    [anon_sym___TIME__] = ACTIONS(4929),
    [anon_sym___TIMESTAMP__] = ACTIONS(4929),
    [anon_sym___VENDOR__] = ACTIONS(4929),
    [anon_sym___VERSION__] = ACTIONS(4929),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4931),
    [sym_float_literal] = ACTIONS(4931),
    [sym__string] = ACTIONS(4931),
  },
  [1604] = {
    [sym_identifier] = ACTIONS(4412),
    [anon_sym_q_LBRACE] = ACTIONS(4414),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_LBRACE] = ACTIONS(4414),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_PLUS_PLUS] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_LPAREN] = ACTIONS(4414),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_DOLLAR] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_AT] = ACTIONS(4414),
    [sym_bool] = ACTIONS(4412),
    [sym_byte] = ACTIONS(4412),
    [sym_ubyte] = ACTIONS(4412),
    [sym_char] = ACTIONS(4412),
    [sym_short] = ACTIONS(4412),
    [sym_ushort] = ACTIONS(4412),
    [sym_int] = ACTIONS(4412),
    [sym_uint] = ACTIONS(4412),
    [sym_long] = ACTIONS(4412),
    [sym_ulong] = ACTIONS(4412),
    [sym_cent] = ACTIONS(4412),
    [sym_ucent] = ACTIONS(4412),
    [sym_wchar] = ACTIONS(4412),
    [sym_dchar] = ACTIONS(4412),
    [sym_float] = ACTIONS(4412),
    [sym_double] = ACTIONS(4412),
    [sym_real] = ACTIONS(4412),
    [sym_ifloat] = ACTIONS(4412),
    [sym_idouble] = ACTIONS(4412),
    [sym_ireal] = ACTIONS(4412),
    [sym_cfloat] = ACTIONS(4412),
    [sym_cdouble] = ACTIONS(4412),
    [sym_creal] = ACTIONS(4412),
    [sym_size_t] = ACTIONS(4412),
    [sym_ptrdiff_t] = ACTIONS(4412),
    [sym_string] = ACTIONS(4412),
    [sym_cstring] = ACTIONS(4412),
    [sym_dstring] = ACTIONS(4412),
    [sym_wstring] = ACTIONS(4412),
    [sym_noreturn] = ACTIONS(4412),
    [sym_true] = ACTIONS(4412),
    [sym_false] = ACTIONS(4412),
    [sym_null] = ACTIONS(4412),
    [sym_super] = ACTIONS(4412),
    [sym_this] = ACTIONS(4412),
    [sym_abstract] = ACTIONS(4412),
    [sym_alias] = ACTIONS(4412),
    [sym_align] = ACTIONS(4412),
    [sym_asm] = ACTIONS(4412),
    [sym_assert] = ACTIONS(4412),
    [sym_auto] = ACTIONS(4412),
    [sym_break] = ACTIONS(4412),
    [sym_case] = ACTIONS(4412),
    [sym_cast] = ACTIONS(4412),
    [sym_class] = ACTIONS(4412),
    [sym_const] = ACTIONS(4412),
    [sym_continue] = ACTIONS(4412),
    [sym_debug] = ACTIONS(4412),
    [sym_default] = ACTIONS(4412),
    [sym_delegate] = ACTIONS(4412),
    [sym_delete] = ACTIONS(4412),
    [sym_deprecated] = ACTIONS(4412),
    [sym_do] = ACTIONS(4412),
    [sym_else] = ACTIONS(4412),
    [sym_enum] = ACTIONS(4412),
    [sym_export] = ACTIONS(4412),
    [sym_extern] = ACTIONS(4412),
    [sym_final] = ACTIONS(4412),
    [sym_for] = ACTIONS(4412),
    [sym_foreach] = ACTIONS(4412),
    [sym_foreach_reverse] = ACTIONS(4412),
    [sym_function] = ACTIONS(4412),
    [sym_goto] = ACTIONS(4412),
    [sym_if] = ACTIONS(4412),
    [sym_immutable] = ACTIONS(4412),
    [sym_import] = ACTIONS(4412),
    [sym_in] = ACTIONS(4412),
    [sym_inout] = ACTIONS(4412),
    [sym_interface] = ACTIONS(4412),
    [sym_invariant] = ACTIONS(4412),
    [sym_is] = ACTIONS(4412),
    [sym_mixin] = ACTIONS(4412),
    [sym_new] = ACTIONS(4412),
    [sym_nothrow] = ACTIONS(4412),
    [sym_out] = ACTIONS(4412),
    [sym_override] = ACTIONS(4412),
    [sym_package] = ACTIONS(4412),
    [sym_pragma] = ACTIONS(4412),
    [sym_private] = ACTIONS(4412),
    [sym_protected] = ACTIONS(4412),
    [sym_public] = ACTIONS(4412),
    [sym_pure] = ACTIONS(4412),
    [sym_ref] = ACTIONS(4412),
    [sym_return] = ACTIONS(4412),
    [sym_scope] = ACTIONS(4412),
    [sym_shared] = ACTIONS(4412),
    [sym_static] = ACTIONS(4412),
    [sym_struct] = ACTIONS(4412),
    [sym_switch] = ACTIONS(4412),
    [sym_synchronized] = ACTIONS(4412),
    [sym_template] = ACTIONS(4412),
    [sym_throw] = ACTIONS(4412),
    [sym_try] = ACTIONS(4412),
    [sym_typeid] = ACTIONS(4412),
    [sym_typeof] = ACTIONS(4412),
    [sym_union] = ACTIONS(4412),
    [sym_unittest] = ACTIONS(4412),
    [sym_version] = ACTIONS(4412),
    [sym_while] = ACTIONS(4412),
    [sym_with] = ACTIONS(4412),
    [sym_gshared] = ACTIONS(4412),
    [sym_traits] = ACTIONS(4412),
    [sym_vector] = ACTIONS(4412),
    [sym_void] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4414),
    [anon_sym_r_DQUOTE] = ACTIONS(4414),
    [anon_sym_x_DQUOTE] = ACTIONS(4414),
    [anon_sym_DQUOTE] = ACTIONS(4414),
    [anon_sym_i_BQUOTE] = ACTIONS(4414),
    [anon_sym_i_DQUOTE] = ACTIONS(4414),
    [anon_sym_iq_LBRACE] = ACTIONS(4414),
    [aux_sym_char_literal_token1] = ACTIONS(4414),
    [anon_sym_SQUOTE] = ACTIONS(4412),
    [anon_sym___DATE__] = ACTIONS(4412),
    [anon_sym___FILE__] = ACTIONS(4412),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4412),
    [anon_sym___FUNCTION__] = ACTIONS(4412),
    [anon_sym___LINE__] = ACTIONS(4412),
    [anon_sym___MODULE__] = ACTIONS(4412),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4412),
    [anon_sym___TIME__] = ACTIONS(4412),
    [anon_sym___TIMESTAMP__] = ACTIONS(4412),
    [anon_sym___VENDOR__] = ACTIONS(4412),
    [anon_sym___VERSION__] = ACTIONS(4412),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4414),
    [sym_float_literal] = ACTIONS(4414),
    [sym__string] = ACTIONS(4414),
  },
  [1605] = {
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_q_LBRACE] = ACTIONS(4328),
    [anon_sym_RBRACE] = ACTIONS(4328),
    [anon_sym_LBRACE] = ACTIONS(4328),
    [anon_sym_DOT] = ACTIONS(4328),
    [anon_sym_AMP] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4328),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_PLUS_PLUS] = ACTIONS(4328),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_LPAREN] = ACTIONS(4328),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(4328),
    [anon_sym_SEMI] = ACTIONS(4328),
    [anon_sym_DOLLAR] = ACTIONS(4328),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [anon_sym_AT] = ACTIONS(4328),
    [sym_bool] = ACTIONS(4326),
    [sym_byte] = ACTIONS(4326),
    [sym_ubyte] = ACTIONS(4326),
    [sym_char] = ACTIONS(4326),
    [sym_short] = ACTIONS(4326),
    [sym_ushort] = ACTIONS(4326),
    [sym_int] = ACTIONS(4326),
    [sym_uint] = ACTIONS(4326),
    [sym_long] = ACTIONS(4326),
    [sym_ulong] = ACTIONS(4326),
    [sym_cent] = ACTIONS(4326),
    [sym_ucent] = ACTIONS(4326),
    [sym_wchar] = ACTIONS(4326),
    [sym_dchar] = ACTIONS(4326),
    [sym_float] = ACTIONS(4326),
    [sym_double] = ACTIONS(4326),
    [sym_real] = ACTIONS(4326),
    [sym_ifloat] = ACTIONS(4326),
    [sym_idouble] = ACTIONS(4326),
    [sym_ireal] = ACTIONS(4326),
    [sym_cfloat] = ACTIONS(4326),
    [sym_cdouble] = ACTIONS(4326),
    [sym_creal] = ACTIONS(4326),
    [sym_size_t] = ACTIONS(4326),
    [sym_ptrdiff_t] = ACTIONS(4326),
    [sym_string] = ACTIONS(4326),
    [sym_cstring] = ACTIONS(4326),
    [sym_dstring] = ACTIONS(4326),
    [sym_wstring] = ACTIONS(4326),
    [sym_noreturn] = ACTIONS(4326),
    [sym_true] = ACTIONS(4326),
    [sym_false] = ACTIONS(4326),
    [sym_null] = ACTIONS(4326),
    [sym_super] = ACTIONS(4326),
    [sym_this] = ACTIONS(4326),
    [sym_abstract] = ACTIONS(4326),
    [sym_alias] = ACTIONS(4326),
    [sym_align] = ACTIONS(4326),
    [sym_asm] = ACTIONS(4326),
    [sym_assert] = ACTIONS(4326),
    [sym_auto] = ACTIONS(4326),
    [sym_break] = ACTIONS(4326),
    [sym_case] = ACTIONS(4326),
    [sym_cast] = ACTIONS(4326),
    [sym_class] = ACTIONS(4326),
    [sym_const] = ACTIONS(4326),
    [sym_continue] = ACTIONS(4326),
    [sym_debug] = ACTIONS(4326),
    [sym_default] = ACTIONS(4326),
    [sym_delegate] = ACTIONS(4326),
    [sym_delete] = ACTIONS(4326),
    [sym_deprecated] = ACTIONS(4326),
    [sym_do] = ACTIONS(4326),
    [sym_else] = ACTIONS(4326),
    [sym_enum] = ACTIONS(4326),
    [sym_export] = ACTIONS(4326),
    [sym_extern] = ACTIONS(4326),
    [sym_final] = ACTIONS(4326),
    [sym_for] = ACTIONS(4326),
    [sym_foreach] = ACTIONS(4326),
    [sym_foreach_reverse] = ACTIONS(4326),
    [sym_function] = ACTIONS(4326),
    [sym_goto] = ACTIONS(4326),
    [sym_if] = ACTIONS(4326),
    [sym_immutable] = ACTIONS(4326),
    [sym_import] = ACTIONS(4326),
    [sym_in] = ACTIONS(4326),
    [sym_inout] = ACTIONS(4326),
    [sym_interface] = ACTIONS(4326),
    [sym_invariant] = ACTIONS(4326),
    [sym_is] = ACTIONS(4326),
    [sym_mixin] = ACTIONS(4326),
    [sym_new] = ACTIONS(4326),
    [sym_nothrow] = ACTIONS(4326),
    [sym_out] = ACTIONS(4326),
    [sym_override] = ACTIONS(4326),
    [sym_package] = ACTIONS(4326),
    [sym_pragma] = ACTIONS(4326),
    [sym_private] = ACTIONS(4326),
    [sym_protected] = ACTIONS(4326),
    [sym_public] = ACTIONS(4326),
    [sym_pure] = ACTIONS(4326),
    [sym_ref] = ACTIONS(4326),
    [sym_return] = ACTIONS(4326),
    [sym_scope] = ACTIONS(4326),
    [sym_shared] = ACTIONS(4326),
    [sym_static] = ACTIONS(4326),
    [sym_struct] = ACTIONS(4326),
    [sym_switch] = ACTIONS(4326),
    [sym_synchronized] = ACTIONS(4326),
    [sym_template] = ACTIONS(4326),
    [sym_throw] = ACTIONS(4326),
    [sym_try] = ACTIONS(4326),
    [sym_typeid] = ACTIONS(4326),
    [sym_typeof] = ACTIONS(4326),
    [sym_union] = ACTIONS(4326),
    [sym_unittest] = ACTIONS(4326),
    [sym_version] = ACTIONS(4326),
    [sym_while] = ACTIONS(4326),
    [sym_with] = ACTIONS(4326),
    [sym_gshared] = ACTIONS(4326),
    [sym_traits] = ACTIONS(4326),
    [sym_vector] = ACTIONS(4326),
    [sym_void] = ACTIONS(4326),
    [anon_sym_BQUOTE] = ACTIONS(4328),
    [anon_sym_r_DQUOTE] = ACTIONS(4328),
    [anon_sym_x_DQUOTE] = ACTIONS(4328),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_i_BQUOTE] = ACTIONS(4328),
    [anon_sym_i_DQUOTE] = ACTIONS(4328),
    [anon_sym_iq_LBRACE] = ACTIONS(4328),
    [aux_sym_char_literal_token1] = ACTIONS(4328),
    [anon_sym_SQUOTE] = ACTIONS(4326),
    [anon_sym___DATE__] = ACTIONS(4326),
    [anon_sym___FILE__] = ACTIONS(4326),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4326),
    [anon_sym___FUNCTION__] = ACTIONS(4326),
    [anon_sym___LINE__] = ACTIONS(4326),
    [anon_sym___MODULE__] = ACTIONS(4326),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4326),
    [anon_sym___TIME__] = ACTIONS(4326),
    [anon_sym___TIMESTAMP__] = ACTIONS(4326),
    [anon_sym___VENDOR__] = ACTIONS(4326),
    [anon_sym___VERSION__] = ACTIONS(4326),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4328),
    [sym_float_literal] = ACTIONS(4328),
    [sym__string] = ACTIONS(4328),
  },
  [1606] = {
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [sym_bool] = ACTIONS(2638),
    [sym_byte] = ACTIONS(2638),
    [sym_ubyte] = ACTIONS(2638),
    [sym_char] = ACTIONS(2638),
    [sym_short] = ACTIONS(2638),
    [sym_ushort] = ACTIONS(2638),
    [sym_int] = ACTIONS(2638),
    [sym_uint] = ACTIONS(2638),
    [sym_long] = ACTIONS(2638),
    [sym_ulong] = ACTIONS(2638),
    [sym_cent] = ACTIONS(2638),
    [sym_ucent] = ACTIONS(2638),
    [sym_wchar] = ACTIONS(2638),
    [sym_dchar] = ACTIONS(2638),
    [sym_float] = ACTIONS(2638),
    [sym_double] = ACTIONS(2638),
    [sym_real] = ACTIONS(2638),
    [sym_ifloat] = ACTIONS(2638),
    [sym_idouble] = ACTIONS(2638),
    [sym_ireal] = ACTIONS(2638),
    [sym_cfloat] = ACTIONS(2638),
    [sym_cdouble] = ACTIONS(2638),
    [sym_creal] = ACTIONS(2638),
    [sym_size_t] = ACTIONS(2638),
    [sym_ptrdiff_t] = ACTIONS(2638),
    [sym_string] = ACTIONS(2638),
    [sym_cstring] = ACTIONS(2638),
    [sym_dstring] = ACTIONS(2638),
    [sym_wstring] = ACTIONS(2638),
    [sym_noreturn] = ACTIONS(2638),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2638),
    [sym_abstract] = ACTIONS(2638),
    [sym_alias] = ACTIONS(2638),
    [sym_align] = ACTIONS(2638),
    [sym_asm] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(2638),
    [sym_break] = ACTIONS(2638),
    [sym_case] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_class] = ACTIONS(2638),
    [sym_const] = ACTIONS(2638),
    [sym_continue] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2638),
    [sym_default] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(2638),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(2638),
    [sym_export] = ACTIONS(2638),
    [sym_extern] = ACTIONS(2638),
    [sym_final] = ACTIONS(2638),
    [sym_for] = ACTIONS(2638),
    [sym_foreach] = ACTIONS(2638),
    [sym_foreach_reverse] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_goto] = ACTIONS(2638),
    [sym_if] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(2638),
    [sym_import] = ACTIONS(2638),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(2638),
    [sym_interface] = ACTIONS(2638),
    [sym_invariant] = ACTIONS(2638),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2638),
    [sym_new] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(2638),
    [sym_out] = ACTIONS(2638),
    [sym_override] = ACTIONS(2638),
    [sym_package] = ACTIONS(2638),
    [sym_pragma] = ACTIONS(2638),
    [sym_private] = ACTIONS(2638),
    [sym_protected] = ACTIONS(2638),
    [sym_public] = ACTIONS(2638),
    [sym_pure] = ACTIONS(2638),
    [sym_ref] = ACTIONS(2638),
    [sym_return] = ACTIONS(2638),
    [sym_scope] = ACTIONS(2638),
    [sym_shared] = ACTIONS(2638),
    [sym_static] = ACTIONS(2638),
    [sym_struct] = ACTIONS(2638),
    [sym_switch] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(2638),
    [sym_template] = ACTIONS(2638),
    [sym_throw] = ACTIONS(2638),
    [sym_try] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(2638),
    [sym_union] = ACTIONS(2638),
    [sym_unittest] = ACTIONS(2638),
    [sym_version] = ACTIONS(2638),
    [sym_while] = ACTIONS(2638),
    [sym_with] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(2638),
    [sym_traits] = ACTIONS(2638),
    [sym_vector] = ACTIONS(2638),
    [sym_void] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [1607] = {
    [sym_identifier] = ACTIONS(4945),
    [anon_sym_q_LBRACE] = ACTIONS(4947),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym_LBRACE] = ACTIONS(4947),
    [anon_sym_DOT] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4947),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_DASH_DASH] = ACTIONS(4947),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4947),
    [anon_sym_BANG] = ACTIONS(4947),
    [anon_sym_LPAREN] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_LBRACK] = ACTIONS(4947),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4947),
    [anon_sym_AT] = ACTIONS(4947),
    [sym_bool] = ACTIONS(4945),
    [sym_byte] = ACTIONS(4945),
    [sym_ubyte] = ACTIONS(4945),
    [sym_char] = ACTIONS(4945),
    [sym_short] = ACTIONS(4945),
    [sym_ushort] = ACTIONS(4945),
    [sym_int] = ACTIONS(4945),
    [sym_uint] = ACTIONS(4945),
    [sym_long] = ACTIONS(4945),
    [sym_ulong] = ACTIONS(4945),
    [sym_cent] = ACTIONS(4945),
    [sym_ucent] = ACTIONS(4945),
    [sym_wchar] = ACTIONS(4945),
    [sym_dchar] = ACTIONS(4945),
    [sym_float] = ACTIONS(4945),
    [sym_double] = ACTIONS(4945),
    [sym_real] = ACTIONS(4945),
    [sym_ifloat] = ACTIONS(4945),
    [sym_idouble] = ACTIONS(4945),
    [sym_ireal] = ACTIONS(4945),
    [sym_cfloat] = ACTIONS(4945),
    [sym_cdouble] = ACTIONS(4945),
    [sym_creal] = ACTIONS(4945),
    [sym_size_t] = ACTIONS(4945),
    [sym_ptrdiff_t] = ACTIONS(4945),
    [sym_string] = ACTIONS(4945),
    [sym_cstring] = ACTIONS(4945),
    [sym_dstring] = ACTIONS(4945),
    [sym_wstring] = ACTIONS(4945),
    [sym_noreturn] = ACTIONS(4945),
    [sym_true] = ACTIONS(4945),
    [sym_false] = ACTIONS(4945),
    [sym_null] = ACTIONS(4945),
    [sym_super] = ACTIONS(4945),
    [sym_this] = ACTIONS(4945),
    [sym_abstract] = ACTIONS(4945),
    [sym_alias] = ACTIONS(4945),
    [sym_align] = ACTIONS(4945),
    [sym_asm] = ACTIONS(4945),
    [sym_assert] = ACTIONS(4945),
    [sym_auto] = ACTIONS(4945),
    [sym_break] = ACTIONS(4945),
    [sym_case] = ACTIONS(4945),
    [sym_cast] = ACTIONS(4945),
    [sym_class] = ACTIONS(4945),
    [sym_const] = ACTIONS(4945),
    [sym_continue] = ACTIONS(4945),
    [sym_debug] = ACTIONS(4945),
    [sym_default] = ACTIONS(4945),
    [sym_delegate] = ACTIONS(4945),
    [sym_delete] = ACTIONS(4945),
    [sym_deprecated] = ACTIONS(4945),
    [sym_do] = ACTIONS(4945),
    [sym_else] = ACTIONS(4945),
    [sym_enum] = ACTIONS(4945),
    [sym_export] = ACTIONS(4945),
    [sym_extern] = ACTIONS(4945),
    [sym_final] = ACTIONS(4945),
    [sym_for] = ACTIONS(4945),
    [sym_foreach] = ACTIONS(4945),
    [sym_foreach_reverse] = ACTIONS(4945),
    [sym_function] = ACTIONS(4945),
    [sym_goto] = ACTIONS(4945),
    [sym_if] = ACTIONS(4945),
    [sym_immutable] = ACTIONS(4945),
    [sym_import] = ACTIONS(4945),
    [sym_in] = ACTIONS(4945),
    [sym_inout] = ACTIONS(4945),
    [sym_interface] = ACTIONS(4945),
    [sym_invariant] = ACTIONS(4945),
    [sym_is] = ACTIONS(4945),
    [sym_mixin] = ACTIONS(4945),
    [sym_new] = ACTIONS(4945),
    [sym_nothrow] = ACTIONS(4945),
    [sym_out] = ACTIONS(4945),
    [sym_override] = ACTIONS(4945),
    [sym_package] = ACTIONS(4945),
    [sym_pragma] = ACTIONS(4945),
    [sym_private] = ACTIONS(4945),
    [sym_protected] = ACTIONS(4945),
    [sym_public] = ACTIONS(4945),
    [sym_pure] = ACTIONS(4945),
    [sym_ref] = ACTIONS(4945),
    [sym_return] = ACTIONS(4945),
    [sym_scope] = ACTIONS(4945),
    [sym_shared] = ACTIONS(4945),
    [sym_static] = ACTIONS(4945),
    [sym_struct] = ACTIONS(4945),
    [sym_switch] = ACTIONS(4945),
    [sym_synchronized] = ACTIONS(4945),
    [sym_template] = ACTIONS(4945),
    [sym_throw] = ACTIONS(4945),
    [sym_try] = ACTIONS(4945),
    [sym_typeid] = ACTIONS(4945),
    [sym_typeof] = ACTIONS(4945),
    [sym_union] = ACTIONS(4945),
    [sym_unittest] = ACTIONS(4945),
    [sym_version] = ACTIONS(4945),
    [sym_while] = ACTIONS(4945),
    [sym_with] = ACTIONS(4945),
    [sym_gshared] = ACTIONS(4945),
    [sym_traits] = ACTIONS(4945),
    [sym_vector] = ACTIONS(4945),
    [sym_void] = ACTIONS(4945),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_r_DQUOTE] = ACTIONS(4947),
    [anon_sym_x_DQUOTE] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_i_BQUOTE] = ACTIONS(4947),
    [anon_sym_i_DQUOTE] = ACTIONS(4947),
    [anon_sym_iq_LBRACE] = ACTIONS(4947),
    [aux_sym_char_literal_token1] = ACTIONS(4947),
    [anon_sym_SQUOTE] = ACTIONS(4945),
    [anon_sym___DATE__] = ACTIONS(4945),
    [anon_sym___FILE__] = ACTIONS(4945),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4945),
    [anon_sym___FUNCTION__] = ACTIONS(4945),
    [anon_sym___LINE__] = ACTIONS(4945),
    [anon_sym___MODULE__] = ACTIONS(4945),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4945),
    [anon_sym___TIME__] = ACTIONS(4945),
    [anon_sym___TIMESTAMP__] = ACTIONS(4945),
    [anon_sym___VENDOR__] = ACTIONS(4945),
    [anon_sym___VERSION__] = ACTIONS(4945),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4947),
    [sym_float_literal] = ACTIONS(4947),
    [sym__string] = ACTIONS(4947),
  },
  [1608] = {
    [sym_identifier] = ACTIONS(4376),
    [anon_sym_q_LBRACE] = ACTIONS(4378),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_LBRACE] = ACTIONS(4378),
    [anon_sym_DOT] = ACTIONS(4378),
    [anon_sym_AMP] = ACTIONS(4378),
    [anon_sym_DASH] = ACTIONS(4376),
    [anon_sym_DASH_DASH] = ACTIONS(4378),
    [anon_sym_PLUS] = ACTIONS(4376),
    [anon_sym_PLUS_PLUS] = ACTIONS(4378),
    [anon_sym_BANG] = ACTIONS(4378),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_RPAREN] = ACTIONS(4378),
    [anon_sym_LBRACK] = ACTIONS(4378),
    [anon_sym_SEMI] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(4378),
    [anon_sym_TILDE] = ACTIONS(4378),
    [anon_sym_AT] = ACTIONS(4378),
    [sym_bool] = ACTIONS(4376),
    [sym_byte] = ACTIONS(4376),
    [sym_ubyte] = ACTIONS(4376),
    [sym_char] = ACTIONS(4376),
    [sym_short] = ACTIONS(4376),
    [sym_ushort] = ACTIONS(4376),
    [sym_int] = ACTIONS(4376),
    [sym_uint] = ACTIONS(4376),
    [sym_long] = ACTIONS(4376),
    [sym_ulong] = ACTIONS(4376),
    [sym_cent] = ACTIONS(4376),
    [sym_ucent] = ACTIONS(4376),
    [sym_wchar] = ACTIONS(4376),
    [sym_dchar] = ACTIONS(4376),
    [sym_float] = ACTIONS(4376),
    [sym_double] = ACTIONS(4376),
    [sym_real] = ACTIONS(4376),
    [sym_ifloat] = ACTIONS(4376),
    [sym_idouble] = ACTIONS(4376),
    [sym_ireal] = ACTIONS(4376),
    [sym_cfloat] = ACTIONS(4376),
    [sym_cdouble] = ACTIONS(4376),
    [sym_creal] = ACTIONS(4376),
    [sym_size_t] = ACTIONS(4376),
    [sym_ptrdiff_t] = ACTIONS(4376),
    [sym_string] = ACTIONS(4376),
    [sym_cstring] = ACTIONS(4376),
    [sym_dstring] = ACTIONS(4376),
    [sym_wstring] = ACTIONS(4376),
    [sym_noreturn] = ACTIONS(4376),
    [sym_true] = ACTIONS(4376),
    [sym_false] = ACTIONS(4376),
    [sym_null] = ACTIONS(4376),
    [sym_super] = ACTIONS(4376),
    [sym_this] = ACTIONS(4376),
    [sym_abstract] = ACTIONS(4376),
    [sym_alias] = ACTIONS(4376),
    [sym_align] = ACTIONS(4376),
    [sym_asm] = ACTIONS(4376),
    [sym_assert] = ACTIONS(4376),
    [sym_auto] = ACTIONS(4376),
    [sym_break] = ACTIONS(4376),
    [sym_case] = ACTIONS(4376),
    [sym_cast] = ACTIONS(4376),
    [sym_class] = ACTIONS(4376),
    [sym_const] = ACTIONS(4376),
    [sym_continue] = ACTIONS(4376),
    [sym_debug] = ACTIONS(4376),
    [sym_default] = ACTIONS(4376),
    [sym_delegate] = ACTIONS(4376),
    [sym_delete] = ACTIONS(4376),
    [sym_deprecated] = ACTIONS(4376),
    [sym_do] = ACTIONS(4376),
    [sym_else] = ACTIONS(4376),
    [sym_enum] = ACTIONS(4376),
    [sym_export] = ACTIONS(4376),
    [sym_extern] = ACTIONS(4376),
    [sym_final] = ACTIONS(4376),
    [sym_for] = ACTIONS(4376),
    [sym_foreach] = ACTIONS(4376),
    [sym_foreach_reverse] = ACTIONS(4376),
    [sym_function] = ACTIONS(4376),
    [sym_goto] = ACTIONS(4376),
    [sym_if] = ACTIONS(4376),
    [sym_immutable] = ACTIONS(4376),
    [sym_import] = ACTIONS(4376),
    [sym_in] = ACTIONS(4376),
    [sym_inout] = ACTIONS(4376),
    [sym_interface] = ACTIONS(4376),
    [sym_invariant] = ACTIONS(4376),
    [sym_is] = ACTIONS(4376),
    [sym_mixin] = ACTIONS(4376),
    [sym_new] = ACTIONS(4376),
    [sym_nothrow] = ACTIONS(4376),
    [sym_out] = ACTIONS(4376),
    [sym_override] = ACTIONS(4376),
    [sym_package] = ACTIONS(4376),
    [sym_pragma] = ACTIONS(4376),
    [sym_private] = ACTIONS(4376),
    [sym_protected] = ACTIONS(4376),
    [sym_public] = ACTIONS(4376),
    [sym_pure] = ACTIONS(4376),
    [sym_ref] = ACTIONS(4376),
    [sym_return] = ACTIONS(4376),
    [sym_scope] = ACTIONS(4376),
    [sym_shared] = ACTIONS(4376),
    [sym_static] = ACTIONS(4376),
    [sym_struct] = ACTIONS(4376),
    [sym_switch] = ACTIONS(4376),
    [sym_synchronized] = ACTIONS(4376),
    [sym_template] = ACTIONS(4376),
    [sym_throw] = ACTIONS(4376),
    [sym_try] = ACTIONS(4376),
    [sym_typeid] = ACTIONS(4376),
    [sym_typeof] = ACTIONS(4376),
    [sym_union] = ACTIONS(4376),
    [sym_unittest] = ACTIONS(4376),
    [sym_version] = ACTIONS(4376),
    [sym_while] = ACTIONS(4376),
    [sym_with] = ACTIONS(4376),
    [sym_gshared] = ACTIONS(4376),
    [sym_traits] = ACTIONS(4376),
    [sym_vector] = ACTIONS(4376),
    [sym_void] = ACTIONS(4376),
    [anon_sym_BQUOTE] = ACTIONS(4378),
    [anon_sym_r_DQUOTE] = ACTIONS(4378),
    [anon_sym_x_DQUOTE] = ACTIONS(4378),
    [anon_sym_DQUOTE] = ACTIONS(4378),
    [anon_sym_i_BQUOTE] = ACTIONS(4378),
    [anon_sym_i_DQUOTE] = ACTIONS(4378),
    [anon_sym_iq_LBRACE] = ACTIONS(4378),
    [aux_sym_char_literal_token1] = ACTIONS(4378),
    [anon_sym_SQUOTE] = ACTIONS(4376),
    [anon_sym___DATE__] = ACTIONS(4376),
    [anon_sym___FILE__] = ACTIONS(4376),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4376),
    [anon_sym___FUNCTION__] = ACTIONS(4376),
    [anon_sym___LINE__] = ACTIONS(4376),
    [anon_sym___MODULE__] = ACTIONS(4376),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4376),
    [anon_sym___TIME__] = ACTIONS(4376),
    [anon_sym___TIMESTAMP__] = ACTIONS(4376),
    [anon_sym___VENDOR__] = ACTIONS(4376),
    [anon_sym___VERSION__] = ACTIONS(4376),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4378),
    [sym_float_literal] = ACTIONS(4378),
    [sym__string] = ACTIONS(4378),
  },
  [1609] = {
    [sym_identifier] = ACTIONS(4554),
    [anon_sym_q_LBRACE] = ACTIONS(4556),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4556),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4554),
    [anon_sym_DASH_DASH] = ACTIONS(4556),
    [anon_sym_PLUS] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4556),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_LPAREN] = ACTIONS(4556),
    [anon_sym_RPAREN] = ACTIONS(4556),
    [anon_sym_LBRACK] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4556),
    [anon_sym_DOLLAR] = ACTIONS(4556),
    [anon_sym_STAR] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [anon_sym_AT] = ACTIONS(4556),
    [sym_bool] = ACTIONS(4554),
    [sym_byte] = ACTIONS(4554),
    [sym_ubyte] = ACTIONS(4554),
    [sym_char] = ACTIONS(4554),
    [sym_short] = ACTIONS(4554),
    [sym_ushort] = ACTIONS(4554),
    [sym_int] = ACTIONS(4554),
    [sym_uint] = ACTIONS(4554),
    [sym_long] = ACTIONS(4554),
    [sym_ulong] = ACTIONS(4554),
    [sym_cent] = ACTIONS(4554),
    [sym_ucent] = ACTIONS(4554),
    [sym_wchar] = ACTIONS(4554),
    [sym_dchar] = ACTIONS(4554),
    [sym_float] = ACTIONS(4554),
    [sym_double] = ACTIONS(4554),
    [sym_real] = ACTIONS(4554),
    [sym_ifloat] = ACTIONS(4554),
    [sym_idouble] = ACTIONS(4554),
    [sym_ireal] = ACTIONS(4554),
    [sym_cfloat] = ACTIONS(4554),
    [sym_cdouble] = ACTIONS(4554),
    [sym_creal] = ACTIONS(4554),
    [sym_size_t] = ACTIONS(4554),
    [sym_ptrdiff_t] = ACTIONS(4554),
    [sym_string] = ACTIONS(4554),
    [sym_cstring] = ACTIONS(4554),
    [sym_dstring] = ACTIONS(4554),
    [sym_wstring] = ACTIONS(4554),
    [sym_noreturn] = ACTIONS(4554),
    [sym_true] = ACTIONS(4554),
    [sym_false] = ACTIONS(4554),
    [sym_null] = ACTIONS(4554),
    [sym_super] = ACTIONS(4554),
    [sym_this] = ACTIONS(4554),
    [sym_abstract] = ACTIONS(4554),
    [sym_alias] = ACTIONS(4554),
    [sym_align] = ACTIONS(4554),
    [sym_asm] = ACTIONS(4554),
    [sym_assert] = ACTIONS(4554),
    [sym_auto] = ACTIONS(4554),
    [sym_break] = ACTIONS(4554),
    [sym_case] = ACTIONS(4554),
    [sym_cast] = ACTIONS(4554),
    [sym_class] = ACTIONS(4554),
    [sym_const] = ACTIONS(4554),
    [sym_continue] = ACTIONS(4554),
    [sym_debug] = ACTIONS(4554),
    [sym_default] = ACTIONS(4554),
    [sym_delegate] = ACTIONS(4554),
    [sym_delete] = ACTIONS(4554),
    [sym_deprecated] = ACTIONS(4554),
    [sym_do] = ACTIONS(4554),
    [sym_else] = ACTIONS(4554),
    [sym_enum] = ACTIONS(4554),
    [sym_export] = ACTIONS(4554),
    [sym_extern] = ACTIONS(4554),
    [sym_final] = ACTIONS(4554),
    [sym_for] = ACTIONS(4554),
    [sym_foreach] = ACTIONS(4554),
    [sym_foreach_reverse] = ACTIONS(4554),
    [sym_function] = ACTIONS(4554),
    [sym_goto] = ACTIONS(4554),
    [sym_if] = ACTIONS(4554),
    [sym_immutable] = ACTIONS(4554),
    [sym_import] = ACTIONS(4554),
    [sym_in] = ACTIONS(4554),
    [sym_inout] = ACTIONS(4554),
    [sym_interface] = ACTIONS(4554),
    [sym_invariant] = ACTIONS(4554),
    [sym_is] = ACTIONS(4554),
    [sym_mixin] = ACTIONS(4554),
    [sym_new] = ACTIONS(4554),
    [sym_nothrow] = ACTIONS(4554),
    [sym_out] = ACTIONS(4554),
    [sym_override] = ACTIONS(4554),
    [sym_package] = ACTIONS(4554),
    [sym_pragma] = ACTIONS(4554),
    [sym_private] = ACTIONS(4554),
    [sym_protected] = ACTIONS(4554),
    [sym_public] = ACTIONS(4554),
    [sym_pure] = ACTIONS(4554),
    [sym_ref] = ACTIONS(4554),
    [sym_return] = ACTIONS(4554),
    [sym_scope] = ACTIONS(4554),
    [sym_shared] = ACTIONS(4554),
    [sym_static] = ACTIONS(4554),
    [sym_struct] = ACTIONS(4554),
    [sym_switch] = ACTIONS(4554),
    [sym_synchronized] = ACTIONS(4554),
    [sym_template] = ACTIONS(4554),
    [sym_throw] = ACTIONS(4554),
    [sym_try] = ACTIONS(4554),
    [sym_typeid] = ACTIONS(4554),
    [sym_typeof] = ACTIONS(4554),
    [sym_union] = ACTIONS(4554),
    [sym_unittest] = ACTIONS(4554),
    [sym_version] = ACTIONS(4554),
    [sym_while] = ACTIONS(4554),
    [sym_with] = ACTIONS(4554),
    [sym_gshared] = ACTIONS(4554),
    [sym_traits] = ACTIONS(4554),
    [sym_vector] = ACTIONS(4554),
    [sym_void] = ACTIONS(4554),
    [anon_sym_BQUOTE] = ACTIONS(4556),
    [anon_sym_r_DQUOTE] = ACTIONS(4556),
    [anon_sym_x_DQUOTE] = ACTIONS(4556),
    [anon_sym_DQUOTE] = ACTIONS(4556),
    [anon_sym_i_BQUOTE] = ACTIONS(4556),
    [anon_sym_i_DQUOTE] = ACTIONS(4556),
    [anon_sym_iq_LBRACE] = ACTIONS(4556),
    [aux_sym_char_literal_token1] = ACTIONS(4556),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym___DATE__] = ACTIONS(4554),
    [anon_sym___FILE__] = ACTIONS(4554),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4554),
    [anon_sym___FUNCTION__] = ACTIONS(4554),
    [anon_sym___LINE__] = ACTIONS(4554),
    [anon_sym___MODULE__] = ACTIONS(4554),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4554),
    [anon_sym___TIME__] = ACTIONS(4554),
    [anon_sym___TIMESTAMP__] = ACTIONS(4554),
    [anon_sym___VENDOR__] = ACTIONS(4554),
    [anon_sym___VERSION__] = ACTIONS(4554),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4556),
    [sym_float_literal] = ACTIONS(4556),
    [sym__string] = ACTIONS(4556),
  },
  [1610] = {
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_q_LBRACE] = ACTIONS(4731),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4731),
    [anon_sym_DOT] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_DASH] = ACTIONS(4729),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4729),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_BANG] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(4731),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [anon_sym_AT] = ACTIONS(4731),
    [sym_bool] = ACTIONS(4729),
    [sym_byte] = ACTIONS(4729),
    [sym_ubyte] = ACTIONS(4729),
    [sym_char] = ACTIONS(4729),
    [sym_short] = ACTIONS(4729),
    [sym_ushort] = ACTIONS(4729),
    [sym_int] = ACTIONS(4729),
    [sym_uint] = ACTIONS(4729),
    [sym_long] = ACTIONS(4729),
    [sym_ulong] = ACTIONS(4729),
    [sym_cent] = ACTIONS(4729),
    [sym_ucent] = ACTIONS(4729),
    [sym_wchar] = ACTIONS(4729),
    [sym_dchar] = ACTIONS(4729),
    [sym_float] = ACTIONS(4729),
    [sym_double] = ACTIONS(4729),
    [sym_real] = ACTIONS(4729),
    [sym_ifloat] = ACTIONS(4729),
    [sym_idouble] = ACTIONS(4729),
    [sym_ireal] = ACTIONS(4729),
    [sym_cfloat] = ACTIONS(4729),
    [sym_cdouble] = ACTIONS(4729),
    [sym_creal] = ACTIONS(4729),
    [sym_size_t] = ACTIONS(4729),
    [sym_ptrdiff_t] = ACTIONS(4729),
    [sym_string] = ACTIONS(4729),
    [sym_cstring] = ACTIONS(4729),
    [sym_dstring] = ACTIONS(4729),
    [sym_wstring] = ACTIONS(4729),
    [sym_noreturn] = ACTIONS(4729),
    [sym_true] = ACTIONS(4729),
    [sym_false] = ACTIONS(4729),
    [sym_null] = ACTIONS(4729),
    [sym_super] = ACTIONS(4729),
    [sym_this] = ACTIONS(4729),
    [sym_abstract] = ACTIONS(4729),
    [sym_alias] = ACTIONS(4729),
    [sym_align] = ACTIONS(4729),
    [sym_asm] = ACTIONS(4729),
    [sym_assert] = ACTIONS(4729),
    [sym_auto] = ACTIONS(4729),
    [sym_break] = ACTIONS(4729),
    [sym_case] = ACTIONS(4729),
    [sym_cast] = ACTIONS(4729),
    [sym_class] = ACTIONS(4729),
    [sym_const] = ACTIONS(4729),
    [sym_continue] = ACTIONS(4729),
    [sym_debug] = ACTIONS(4729),
    [sym_default] = ACTIONS(4729),
    [sym_delegate] = ACTIONS(4729),
    [sym_delete] = ACTIONS(4729),
    [sym_deprecated] = ACTIONS(4729),
    [sym_do] = ACTIONS(4729),
    [sym_else] = ACTIONS(4729),
    [sym_enum] = ACTIONS(4729),
    [sym_export] = ACTIONS(4729),
    [sym_extern] = ACTIONS(4729),
    [sym_final] = ACTIONS(4729),
    [sym_for] = ACTIONS(4729),
    [sym_foreach] = ACTIONS(4729),
    [sym_foreach_reverse] = ACTIONS(4729),
    [sym_function] = ACTIONS(4729),
    [sym_goto] = ACTIONS(4729),
    [sym_if] = ACTIONS(4729),
    [sym_immutable] = ACTIONS(4729),
    [sym_import] = ACTIONS(4729),
    [sym_in] = ACTIONS(4729),
    [sym_inout] = ACTIONS(4729),
    [sym_interface] = ACTIONS(4729),
    [sym_invariant] = ACTIONS(4729),
    [sym_is] = ACTIONS(4729),
    [sym_mixin] = ACTIONS(4729),
    [sym_new] = ACTIONS(4729),
    [sym_nothrow] = ACTIONS(4729),
    [sym_out] = ACTIONS(4729),
    [sym_override] = ACTIONS(4729),
    [sym_package] = ACTIONS(4729),
    [sym_pragma] = ACTIONS(4729),
    [sym_private] = ACTIONS(4729),
    [sym_protected] = ACTIONS(4729),
    [sym_public] = ACTIONS(4729),
    [sym_pure] = ACTIONS(4729),
    [sym_ref] = ACTIONS(4729),
    [sym_return] = ACTIONS(4729),
    [sym_scope] = ACTIONS(4729),
    [sym_shared] = ACTIONS(4729),
    [sym_static] = ACTIONS(4729),
    [sym_struct] = ACTIONS(4729),
    [sym_switch] = ACTIONS(4729),
    [sym_synchronized] = ACTIONS(4729),
    [sym_template] = ACTIONS(4729),
    [sym_throw] = ACTIONS(4729),
    [sym_try] = ACTIONS(4729),
    [sym_typeid] = ACTIONS(4729),
    [sym_typeof] = ACTIONS(4729),
    [sym_union] = ACTIONS(4729),
    [sym_unittest] = ACTIONS(4729),
    [sym_version] = ACTIONS(4729),
    [sym_while] = ACTIONS(4729),
    [sym_with] = ACTIONS(4729),
    [sym_gshared] = ACTIONS(4729),
    [sym_traits] = ACTIONS(4729),
    [sym_vector] = ACTIONS(4729),
    [sym_void] = ACTIONS(4729),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_r_DQUOTE] = ACTIONS(4731),
    [anon_sym_x_DQUOTE] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_i_BQUOTE] = ACTIONS(4731),
    [anon_sym_i_DQUOTE] = ACTIONS(4731),
    [anon_sym_iq_LBRACE] = ACTIONS(4731),
    [aux_sym_char_literal_token1] = ACTIONS(4731),
    [anon_sym_SQUOTE] = ACTIONS(4729),
    [anon_sym___DATE__] = ACTIONS(4729),
    [anon_sym___FILE__] = ACTIONS(4729),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4729),
    [anon_sym___FUNCTION__] = ACTIONS(4729),
    [anon_sym___LINE__] = ACTIONS(4729),
    [anon_sym___MODULE__] = ACTIONS(4729),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4729),
    [anon_sym___TIME__] = ACTIONS(4729),
    [anon_sym___TIMESTAMP__] = ACTIONS(4729),
    [anon_sym___VENDOR__] = ACTIONS(4729),
    [anon_sym___VERSION__] = ACTIONS(4729),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4731),
    [sym_float_literal] = ACTIONS(4731),
    [sym__string] = ACTIONS(4731),
  },
  [1611] = {
    [sym_identifier] = ACTIONS(4392),
    [anon_sym_q_LBRACE] = ACTIONS(4394),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_LBRACE] = ACTIONS(4394),
    [anon_sym_DOT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_DASH] = ACTIONS(4392),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS] = ACTIONS(4392),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_BANG] = ACTIONS(4394),
    [anon_sym_LPAREN] = ACTIONS(4394),
    [anon_sym_RPAREN] = ACTIONS(4394),
    [anon_sym_LBRACK] = ACTIONS(4394),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_DOLLAR] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(4394),
    [anon_sym_TILDE] = ACTIONS(4394),
    [anon_sym_AT] = ACTIONS(4394),
    [sym_bool] = ACTIONS(4392),
    [sym_byte] = ACTIONS(4392),
    [sym_ubyte] = ACTIONS(4392),
    [sym_char] = ACTIONS(4392),
    [sym_short] = ACTIONS(4392),
    [sym_ushort] = ACTIONS(4392),
    [sym_int] = ACTIONS(4392),
    [sym_uint] = ACTIONS(4392),
    [sym_long] = ACTIONS(4392),
    [sym_ulong] = ACTIONS(4392),
    [sym_cent] = ACTIONS(4392),
    [sym_ucent] = ACTIONS(4392),
    [sym_wchar] = ACTIONS(4392),
    [sym_dchar] = ACTIONS(4392),
    [sym_float] = ACTIONS(4392),
    [sym_double] = ACTIONS(4392),
    [sym_real] = ACTIONS(4392),
    [sym_ifloat] = ACTIONS(4392),
    [sym_idouble] = ACTIONS(4392),
    [sym_ireal] = ACTIONS(4392),
    [sym_cfloat] = ACTIONS(4392),
    [sym_cdouble] = ACTIONS(4392),
    [sym_creal] = ACTIONS(4392),
    [sym_size_t] = ACTIONS(4392),
    [sym_ptrdiff_t] = ACTIONS(4392),
    [sym_string] = ACTIONS(4392),
    [sym_cstring] = ACTIONS(4392),
    [sym_dstring] = ACTIONS(4392),
    [sym_wstring] = ACTIONS(4392),
    [sym_noreturn] = ACTIONS(4392),
    [sym_true] = ACTIONS(4392),
    [sym_false] = ACTIONS(4392),
    [sym_null] = ACTIONS(4392),
    [sym_super] = ACTIONS(4392),
    [sym_this] = ACTIONS(4392),
    [sym_abstract] = ACTIONS(4392),
    [sym_alias] = ACTIONS(4392),
    [sym_align] = ACTIONS(4392),
    [sym_asm] = ACTIONS(4392),
    [sym_assert] = ACTIONS(4392),
    [sym_auto] = ACTIONS(4392),
    [sym_break] = ACTIONS(4392),
    [sym_case] = ACTIONS(4392),
    [sym_cast] = ACTIONS(4392),
    [sym_class] = ACTIONS(4392),
    [sym_const] = ACTIONS(4392),
    [sym_continue] = ACTIONS(4392),
    [sym_debug] = ACTIONS(4392),
    [sym_default] = ACTIONS(4392),
    [sym_delegate] = ACTIONS(4392),
    [sym_delete] = ACTIONS(4392),
    [sym_deprecated] = ACTIONS(4392),
    [sym_do] = ACTIONS(4392),
    [sym_else] = ACTIONS(4392),
    [sym_enum] = ACTIONS(4392),
    [sym_export] = ACTIONS(4392),
    [sym_extern] = ACTIONS(4392),
    [sym_final] = ACTIONS(4392),
    [sym_for] = ACTIONS(4392),
    [sym_foreach] = ACTIONS(4392),
    [sym_foreach_reverse] = ACTIONS(4392),
    [sym_function] = ACTIONS(4392),
    [sym_goto] = ACTIONS(4392),
    [sym_if] = ACTIONS(4392),
    [sym_immutable] = ACTIONS(4392),
    [sym_import] = ACTIONS(4392),
    [sym_in] = ACTIONS(4392),
    [sym_inout] = ACTIONS(4392),
    [sym_interface] = ACTIONS(4392),
    [sym_invariant] = ACTIONS(4392),
    [sym_is] = ACTIONS(4392),
    [sym_mixin] = ACTIONS(4392),
    [sym_new] = ACTIONS(4392),
    [sym_nothrow] = ACTIONS(4392),
    [sym_out] = ACTIONS(4392),
    [sym_override] = ACTIONS(4392),
    [sym_package] = ACTIONS(4392),
    [sym_pragma] = ACTIONS(4392),
    [sym_private] = ACTIONS(4392),
    [sym_protected] = ACTIONS(4392),
    [sym_public] = ACTIONS(4392),
    [sym_pure] = ACTIONS(4392),
    [sym_ref] = ACTIONS(4392),
    [sym_return] = ACTIONS(4392),
    [sym_scope] = ACTIONS(4392),
    [sym_shared] = ACTIONS(4392),
    [sym_static] = ACTIONS(4392),
    [sym_struct] = ACTIONS(4392),
    [sym_switch] = ACTIONS(4392),
    [sym_synchronized] = ACTIONS(4392),
    [sym_template] = ACTIONS(4392),
    [sym_throw] = ACTIONS(4392),
    [sym_try] = ACTIONS(4392),
    [sym_typeid] = ACTIONS(4392),
    [sym_typeof] = ACTIONS(4392),
    [sym_union] = ACTIONS(4392),
    [sym_unittest] = ACTIONS(4392),
    [sym_version] = ACTIONS(4392),
    [sym_while] = ACTIONS(4392),
    [sym_with] = ACTIONS(4392),
    [sym_gshared] = ACTIONS(4392),
    [sym_traits] = ACTIONS(4392),
    [sym_vector] = ACTIONS(4392),
    [sym_void] = ACTIONS(4392),
    [anon_sym_BQUOTE] = ACTIONS(4394),
    [anon_sym_r_DQUOTE] = ACTIONS(4394),
    [anon_sym_x_DQUOTE] = ACTIONS(4394),
    [anon_sym_DQUOTE] = ACTIONS(4394),
    [anon_sym_i_BQUOTE] = ACTIONS(4394),
    [anon_sym_i_DQUOTE] = ACTIONS(4394),
    [anon_sym_iq_LBRACE] = ACTIONS(4394),
    [aux_sym_char_literal_token1] = ACTIONS(4394),
    [anon_sym_SQUOTE] = ACTIONS(4392),
    [anon_sym___DATE__] = ACTIONS(4392),
    [anon_sym___FILE__] = ACTIONS(4392),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4392),
    [anon_sym___FUNCTION__] = ACTIONS(4392),
    [anon_sym___LINE__] = ACTIONS(4392),
    [anon_sym___MODULE__] = ACTIONS(4392),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4392),
    [anon_sym___TIME__] = ACTIONS(4392),
    [anon_sym___TIMESTAMP__] = ACTIONS(4392),
    [anon_sym___VENDOR__] = ACTIONS(4392),
    [anon_sym___VERSION__] = ACTIONS(4392),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4394),
    [sym_float_literal] = ACTIONS(4394),
    [sym__string] = ACTIONS(4394),
  },
  [1612] = {
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_q_LBRACE] = ACTIONS(4749),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_LBRACE] = ACTIONS(4749),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4749),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_DASH_DASH] = ACTIONS(4749),
    [anon_sym_PLUS] = ACTIONS(4747),
    [anon_sym_PLUS_PLUS] = ACTIONS(4749),
    [anon_sym_BANG] = ACTIONS(4749),
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4749),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4749),
    [anon_sym_STAR] = ACTIONS(4749),
    [anon_sym_TILDE] = ACTIONS(4749),
    [anon_sym_AT] = ACTIONS(4749),
    [sym_bool] = ACTIONS(4747),
    [sym_byte] = ACTIONS(4747),
    [sym_ubyte] = ACTIONS(4747),
    [sym_char] = ACTIONS(4747),
    [sym_short] = ACTIONS(4747),
    [sym_ushort] = ACTIONS(4747),
    [sym_int] = ACTIONS(4747),
    [sym_uint] = ACTIONS(4747),
    [sym_long] = ACTIONS(4747),
    [sym_ulong] = ACTIONS(4747),
    [sym_cent] = ACTIONS(4747),
    [sym_ucent] = ACTIONS(4747),
    [sym_wchar] = ACTIONS(4747),
    [sym_dchar] = ACTIONS(4747),
    [sym_float] = ACTIONS(4747),
    [sym_double] = ACTIONS(4747),
    [sym_real] = ACTIONS(4747),
    [sym_ifloat] = ACTIONS(4747),
    [sym_idouble] = ACTIONS(4747),
    [sym_ireal] = ACTIONS(4747),
    [sym_cfloat] = ACTIONS(4747),
    [sym_cdouble] = ACTIONS(4747),
    [sym_creal] = ACTIONS(4747),
    [sym_size_t] = ACTIONS(4747),
    [sym_ptrdiff_t] = ACTIONS(4747),
    [sym_string] = ACTIONS(4747),
    [sym_cstring] = ACTIONS(4747),
    [sym_dstring] = ACTIONS(4747),
    [sym_wstring] = ACTIONS(4747),
    [sym_noreturn] = ACTIONS(4747),
    [sym_true] = ACTIONS(4747),
    [sym_false] = ACTIONS(4747),
    [sym_null] = ACTIONS(4747),
    [sym_super] = ACTIONS(4747),
    [sym_this] = ACTIONS(4747),
    [sym_abstract] = ACTIONS(4747),
    [sym_alias] = ACTIONS(4747),
    [sym_align] = ACTIONS(4747),
    [sym_asm] = ACTIONS(4747),
    [sym_assert] = ACTIONS(4747),
    [sym_auto] = ACTIONS(4747),
    [sym_break] = ACTIONS(4747),
    [sym_case] = ACTIONS(4747),
    [sym_cast] = ACTIONS(4747),
    [sym_class] = ACTIONS(4747),
    [sym_const] = ACTIONS(4747),
    [sym_continue] = ACTIONS(4747),
    [sym_debug] = ACTIONS(4747),
    [sym_default] = ACTIONS(4747),
    [sym_delegate] = ACTIONS(4747),
    [sym_delete] = ACTIONS(4747),
    [sym_deprecated] = ACTIONS(4747),
    [sym_do] = ACTIONS(4747),
    [sym_else] = ACTIONS(4747),
    [sym_enum] = ACTIONS(4747),
    [sym_export] = ACTIONS(4747),
    [sym_extern] = ACTIONS(4747),
    [sym_final] = ACTIONS(4747),
    [sym_for] = ACTIONS(4747),
    [sym_foreach] = ACTIONS(4747),
    [sym_foreach_reverse] = ACTIONS(4747),
    [sym_function] = ACTIONS(4747),
    [sym_goto] = ACTIONS(4747),
    [sym_if] = ACTIONS(4747),
    [sym_immutable] = ACTIONS(4747),
    [sym_import] = ACTIONS(4747),
    [sym_in] = ACTIONS(4747),
    [sym_inout] = ACTIONS(4747),
    [sym_interface] = ACTIONS(4747),
    [sym_invariant] = ACTIONS(4747),
    [sym_is] = ACTIONS(4747),
    [sym_mixin] = ACTIONS(4747),
    [sym_new] = ACTIONS(4747),
    [sym_nothrow] = ACTIONS(4747),
    [sym_out] = ACTIONS(4747),
    [sym_override] = ACTIONS(4747),
    [sym_package] = ACTIONS(4747),
    [sym_pragma] = ACTIONS(4747),
    [sym_private] = ACTIONS(4747),
    [sym_protected] = ACTIONS(4747),
    [sym_public] = ACTIONS(4747),
    [sym_pure] = ACTIONS(4747),
    [sym_ref] = ACTIONS(4747),
    [sym_return] = ACTIONS(4747),
    [sym_scope] = ACTIONS(4747),
    [sym_shared] = ACTIONS(4747),
    [sym_static] = ACTIONS(4747),
    [sym_struct] = ACTIONS(4747),
    [sym_switch] = ACTIONS(4747),
    [sym_synchronized] = ACTIONS(4747),
    [sym_template] = ACTIONS(4747),
    [sym_throw] = ACTIONS(4747),
    [sym_try] = ACTIONS(4747),
    [sym_typeid] = ACTIONS(4747),
    [sym_typeof] = ACTIONS(4747),
    [sym_union] = ACTIONS(4747),
    [sym_unittest] = ACTIONS(4747),
    [sym_version] = ACTIONS(4747),
    [sym_while] = ACTIONS(4747),
    [sym_with] = ACTIONS(4747),
    [sym_gshared] = ACTIONS(4747),
    [sym_traits] = ACTIONS(4747),
    [sym_vector] = ACTIONS(4747),
    [sym_void] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_r_DQUOTE] = ACTIONS(4749),
    [anon_sym_x_DQUOTE] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_i_BQUOTE] = ACTIONS(4749),
    [anon_sym_i_DQUOTE] = ACTIONS(4749),
    [anon_sym_iq_LBRACE] = ACTIONS(4749),
    [aux_sym_char_literal_token1] = ACTIONS(4749),
    [anon_sym_SQUOTE] = ACTIONS(4747),
    [anon_sym___DATE__] = ACTIONS(4747),
    [anon_sym___FILE__] = ACTIONS(4747),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4747),
    [anon_sym___FUNCTION__] = ACTIONS(4747),
    [anon_sym___LINE__] = ACTIONS(4747),
    [anon_sym___MODULE__] = ACTIONS(4747),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4747),
    [anon_sym___TIME__] = ACTIONS(4747),
    [anon_sym___TIMESTAMP__] = ACTIONS(4747),
    [anon_sym___VENDOR__] = ACTIONS(4747),
    [anon_sym___VERSION__] = ACTIONS(4747),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4749),
    [sym_float_literal] = ACTIONS(4749),
    [sym__string] = ACTIONS(4749),
  },
  [1613] = {
    [sym_identifier] = ACTIONS(4566),
    [anon_sym_q_LBRACE] = ACTIONS(4568),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_LBRACE] = ACTIONS(4568),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4568),
    [anon_sym_PLUS] = ACTIONS(4566),
    [anon_sym_PLUS_PLUS] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_LPAREN] = ACTIONS(4568),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_AT] = ACTIONS(4568),
    [sym_bool] = ACTIONS(4566),
    [sym_byte] = ACTIONS(4566),
    [sym_ubyte] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_short] = ACTIONS(4566),
    [sym_ushort] = ACTIONS(4566),
    [sym_int] = ACTIONS(4566),
    [sym_uint] = ACTIONS(4566),
    [sym_long] = ACTIONS(4566),
    [sym_ulong] = ACTIONS(4566),
    [sym_cent] = ACTIONS(4566),
    [sym_ucent] = ACTIONS(4566),
    [sym_wchar] = ACTIONS(4566),
    [sym_dchar] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_double] = ACTIONS(4566),
    [sym_real] = ACTIONS(4566),
    [sym_ifloat] = ACTIONS(4566),
    [sym_idouble] = ACTIONS(4566),
    [sym_ireal] = ACTIONS(4566),
    [sym_cfloat] = ACTIONS(4566),
    [sym_cdouble] = ACTIONS(4566),
    [sym_creal] = ACTIONS(4566),
    [sym_size_t] = ACTIONS(4566),
    [sym_ptrdiff_t] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym_cstring] = ACTIONS(4566),
    [sym_dstring] = ACTIONS(4566),
    [sym_wstring] = ACTIONS(4566),
    [sym_noreturn] = ACTIONS(4566),
    [sym_true] = ACTIONS(4566),
    [sym_false] = ACTIONS(4566),
    [sym_null] = ACTIONS(4566),
    [sym_super] = ACTIONS(4566),
    [sym_this] = ACTIONS(4566),
    [sym_abstract] = ACTIONS(4566),
    [sym_alias] = ACTIONS(4566),
    [sym_align] = ACTIONS(4566),
    [sym_asm] = ACTIONS(4566),
    [sym_assert] = ACTIONS(4566),
    [sym_auto] = ACTIONS(4566),
    [sym_break] = ACTIONS(4566),
    [sym_case] = ACTIONS(4566),
    [sym_cast] = ACTIONS(4566),
    [sym_class] = ACTIONS(4566),
    [sym_const] = ACTIONS(4566),
    [sym_continue] = ACTIONS(4566),
    [sym_debug] = ACTIONS(4566),
    [sym_default] = ACTIONS(4566),
    [sym_delegate] = ACTIONS(4566),
    [sym_delete] = ACTIONS(4566),
    [sym_deprecated] = ACTIONS(4566),
    [sym_do] = ACTIONS(4566),
    [sym_else] = ACTIONS(4566),
    [sym_enum] = ACTIONS(4566),
    [sym_export] = ACTIONS(4566),
    [sym_extern] = ACTIONS(4566),
    [sym_final] = ACTIONS(4566),
    [sym_for] = ACTIONS(4566),
    [sym_foreach] = ACTIONS(4566),
    [sym_foreach_reverse] = ACTIONS(4566),
    [sym_function] = ACTIONS(4566),
    [sym_goto] = ACTIONS(4566),
    [sym_if] = ACTIONS(4566),
    [sym_immutable] = ACTIONS(4566),
    [sym_import] = ACTIONS(4566),
    [sym_in] = ACTIONS(4566),
    [sym_inout] = ACTIONS(4566),
    [sym_interface] = ACTIONS(4566),
    [sym_invariant] = ACTIONS(4566),
    [sym_is] = ACTIONS(4566),
    [sym_mixin] = ACTIONS(4566),
    [sym_new] = ACTIONS(4566),
    [sym_nothrow] = ACTIONS(4566),
    [sym_out] = ACTIONS(4566),
    [sym_override] = ACTIONS(4566),
    [sym_package] = ACTIONS(4566),
    [sym_pragma] = ACTIONS(4566),
    [sym_private] = ACTIONS(4566),
    [sym_protected] = ACTIONS(4566),
    [sym_public] = ACTIONS(4566),
    [sym_pure] = ACTIONS(4566),
    [sym_ref] = ACTIONS(4566),
    [sym_return] = ACTIONS(4566),
    [sym_scope] = ACTIONS(4566),
    [sym_shared] = ACTIONS(4566),
    [sym_static] = ACTIONS(4566),
    [sym_struct] = ACTIONS(4566),
    [sym_switch] = ACTIONS(4566),
    [sym_synchronized] = ACTIONS(4566),
    [sym_template] = ACTIONS(4566),
    [sym_throw] = ACTIONS(4566),
    [sym_try] = ACTIONS(4566),
    [sym_typeid] = ACTIONS(4566),
    [sym_typeof] = ACTIONS(4566),
    [sym_union] = ACTIONS(4566),
    [sym_unittest] = ACTIONS(4566),
    [sym_version] = ACTIONS(4566),
    [sym_while] = ACTIONS(4566),
    [sym_with] = ACTIONS(4566),
    [sym_gshared] = ACTIONS(4566),
    [sym_traits] = ACTIONS(4566),
    [sym_vector] = ACTIONS(4566),
    [sym_void] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_r_DQUOTE] = ACTIONS(4568),
    [anon_sym_x_DQUOTE] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_i_BQUOTE] = ACTIONS(4568),
    [anon_sym_i_DQUOTE] = ACTIONS(4568),
    [anon_sym_iq_LBRACE] = ACTIONS(4568),
    [aux_sym_char_literal_token1] = ACTIONS(4568),
    [anon_sym_SQUOTE] = ACTIONS(4566),
    [anon_sym___DATE__] = ACTIONS(4566),
    [anon_sym___FILE__] = ACTIONS(4566),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4566),
    [anon_sym___FUNCTION__] = ACTIONS(4566),
    [anon_sym___LINE__] = ACTIONS(4566),
    [anon_sym___MODULE__] = ACTIONS(4566),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4566),
    [anon_sym___TIME__] = ACTIONS(4566),
    [anon_sym___TIMESTAMP__] = ACTIONS(4566),
    [anon_sym___VENDOR__] = ACTIONS(4566),
    [anon_sym___VERSION__] = ACTIONS(4566),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4568),
    [sym_float_literal] = ACTIONS(4568),
    [sym__string] = ACTIONS(4568),
  },
  [1614] = {
    [sym_identifier] = ACTIONS(4725),
    [anon_sym_q_LBRACE] = ACTIONS(4727),
    [anon_sym_RBRACE] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4727),
    [anon_sym_DOT] = ACTIONS(4727),
    [anon_sym_AMP] = ACTIONS(4727),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_DASH_DASH] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4727),
    [anon_sym_BANG] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4727),
    [anon_sym_RPAREN] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(4727),
    [anon_sym_DOLLAR] = ACTIONS(4727),
    [anon_sym_STAR] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4727),
    [anon_sym_AT] = ACTIONS(4727),
    [sym_bool] = ACTIONS(4725),
    [sym_byte] = ACTIONS(4725),
    [sym_ubyte] = ACTIONS(4725),
    [sym_char] = ACTIONS(4725),
    [sym_short] = ACTIONS(4725),
    [sym_ushort] = ACTIONS(4725),
    [sym_int] = ACTIONS(4725),
    [sym_uint] = ACTIONS(4725),
    [sym_long] = ACTIONS(4725),
    [sym_ulong] = ACTIONS(4725),
    [sym_cent] = ACTIONS(4725),
    [sym_ucent] = ACTIONS(4725),
    [sym_wchar] = ACTIONS(4725),
    [sym_dchar] = ACTIONS(4725),
    [sym_float] = ACTIONS(4725),
    [sym_double] = ACTIONS(4725),
    [sym_real] = ACTIONS(4725),
    [sym_ifloat] = ACTIONS(4725),
    [sym_idouble] = ACTIONS(4725),
    [sym_ireal] = ACTIONS(4725),
    [sym_cfloat] = ACTIONS(4725),
    [sym_cdouble] = ACTIONS(4725),
    [sym_creal] = ACTIONS(4725),
    [sym_size_t] = ACTIONS(4725),
    [sym_ptrdiff_t] = ACTIONS(4725),
    [sym_string] = ACTIONS(4725),
    [sym_cstring] = ACTIONS(4725),
    [sym_dstring] = ACTIONS(4725),
    [sym_wstring] = ACTIONS(4725),
    [sym_noreturn] = ACTIONS(4725),
    [sym_true] = ACTIONS(4725),
    [sym_false] = ACTIONS(4725),
    [sym_null] = ACTIONS(4725),
    [sym_super] = ACTIONS(4725),
    [sym_this] = ACTIONS(4725),
    [sym_abstract] = ACTIONS(4725),
    [sym_alias] = ACTIONS(4725),
    [sym_align] = ACTIONS(4725),
    [sym_asm] = ACTIONS(4725),
    [sym_assert] = ACTIONS(4725),
    [sym_auto] = ACTIONS(4725),
    [sym_break] = ACTIONS(4725),
    [sym_case] = ACTIONS(4725),
    [sym_cast] = ACTIONS(4725),
    [sym_class] = ACTIONS(4725),
    [sym_const] = ACTIONS(4725),
    [sym_continue] = ACTIONS(4725),
    [sym_debug] = ACTIONS(4725),
    [sym_default] = ACTIONS(4725),
    [sym_delegate] = ACTIONS(4725),
    [sym_delete] = ACTIONS(4725),
    [sym_deprecated] = ACTIONS(4725),
    [sym_do] = ACTIONS(4725),
    [sym_else] = ACTIONS(4725),
    [sym_enum] = ACTIONS(4725),
    [sym_export] = ACTIONS(4725),
    [sym_extern] = ACTIONS(4725),
    [sym_final] = ACTIONS(4725),
    [sym_for] = ACTIONS(4725),
    [sym_foreach] = ACTIONS(4725),
    [sym_foreach_reverse] = ACTIONS(4725),
    [sym_function] = ACTIONS(4725),
    [sym_goto] = ACTIONS(4725),
    [sym_if] = ACTIONS(4725),
    [sym_immutable] = ACTIONS(4725),
    [sym_import] = ACTIONS(4725),
    [sym_in] = ACTIONS(4725),
    [sym_inout] = ACTIONS(4725),
    [sym_interface] = ACTIONS(4725),
    [sym_invariant] = ACTIONS(4725),
    [sym_is] = ACTIONS(4725),
    [sym_mixin] = ACTIONS(4725),
    [sym_new] = ACTIONS(4725),
    [sym_nothrow] = ACTIONS(4725),
    [sym_out] = ACTIONS(4725),
    [sym_override] = ACTIONS(4725),
    [sym_package] = ACTIONS(4725),
    [sym_pragma] = ACTIONS(4725),
    [sym_private] = ACTIONS(4725),
    [sym_protected] = ACTIONS(4725),
    [sym_public] = ACTIONS(4725),
    [sym_pure] = ACTIONS(4725),
    [sym_ref] = ACTIONS(4725),
    [sym_return] = ACTIONS(4725),
    [sym_scope] = ACTIONS(4725),
    [sym_shared] = ACTIONS(4725),
    [sym_static] = ACTIONS(4725),
    [sym_struct] = ACTIONS(4725),
    [sym_switch] = ACTIONS(4725),
    [sym_synchronized] = ACTIONS(4725),
    [sym_template] = ACTIONS(4725),
    [sym_throw] = ACTIONS(4725),
    [sym_try] = ACTIONS(4725),
    [sym_typeid] = ACTIONS(4725),
    [sym_typeof] = ACTIONS(4725),
    [sym_union] = ACTIONS(4725),
    [sym_unittest] = ACTIONS(4725),
    [sym_version] = ACTIONS(4725),
    [sym_while] = ACTIONS(4725),
    [sym_with] = ACTIONS(4725),
    [sym_gshared] = ACTIONS(4725),
    [sym_traits] = ACTIONS(4725),
    [sym_vector] = ACTIONS(4725),
    [sym_void] = ACTIONS(4725),
    [anon_sym_BQUOTE] = ACTIONS(4727),
    [anon_sym_r_DQUOTE] = ACTIONS(4727),
    [anon_sym_x_DQUOTE] = ACTIONS(4727),
    [anon_sym_DQUOTE] = ACTIONS(4727),
    [anon_sym_i_BQUOTE] = ACTIONS(4727),
    [anon_sym_i_DQUOTE] = ACTIONS(4727),
    [anon_sym_iq_LBRACE] = ACTIONS(4727),
    [aux_sym_char_literal_token1] = ACTIONS(4727),
    [anon_sym_SQUOTE] = ACTIONS(4725),
    [anon_sym___DATE__] = ACTIONS(4725),
    [anon_sym___FILE__] = ACTIONS(4725),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4725),
    [anon_sym___FUNCTION__] = ACTIONS(4725),
    [anon_sym___LINE__] = ACTIONS(4725),
    [anon_sym___MODULE__] = ACTIONS(4725),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4725),
    [anon_sym___TIME__] = ACTIONS(4725),
    [anon_sym___TIMESTAMP__] = ACTIONS(4725),
    [anon_sym___VENDOR__] = ACTIONS(4725),
    [anon_sym___VERSION__] = ACTIONS(4725),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4727),
    [sym_float_literal] = ACTIONS(4727),
    [sym__string] = ACTIONS(4727),
  },
  [1615] = {
    [sym_identifier] = ACTIONS(4362),
    [anon_sym_q_LBRACE] = ACTIONS(4364),
    [anon_sym_RBRACE] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_DOT] = ACTIONS(4364),
    [anon_sym_AMP] = ACTIONS(4364),
    [anon_sym_DASH] = ACTIONS(4362),
    [anon_sym_DASH_DASH] = ACTIONS(4364),
    [anon_sym_PLUS] = ACTIONS(4362),
    [anon_sym_PLUS_PLUS] = ACTIONS(4364),
    [anon_sym_BANG] = ACTIONS(4364),
    [anon_sym_LPAREN] = ACTIONS(4364),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_DOLLAR] = ACTIONS(4364),
    [anon_sym_STAR] = ACTIONS(4364),
    [anon_sym_TILDE] = ACTIONS(4364),
    [anon_sym_AT] = ACTIONS(4364),
    [sym_bool] = ACTIONS(4362),
    [sym_byte] = ACTIONS(4362),
    [sym_ubyte] = ACTIONS(4362),
    [sym_char] = ACTIONS(4362),
    [sym_short] = ACTIONS(4362),
    [sym_ushort] = ACTIONS(4362),
    [sym_int] = ACTIONS(4362),
    [sym_uint] = ACTIONS(4362),
    [sym_long] = ACTIONS(4362),
    [sym_ulong] = ACTIONS(4362),
    [sym_cent] = ACTIONS(4362),
    [sym_ucent] = ACTIONS(4362),
    [sym_wchar] = ACTIONS(4362),
    [sym_dchar] = ACTIONS(4362),
    [sym_float] = ACTIONS(4362),
    [sym_double] = ACTIONS(4362),
    [sym_real] = ACTIONS(4362),
    [sym_ifloat] = ACTIONS(4362),
    [sym_idouble] = ACTIONS(4362),
    [sym_ireal] = ACTIONS(4362),
    [sym_cfloat] = ACTIONS(4362),
    [sym_cdouble] = ACTIONS(4362),
    [sym_creal] = ACTIONS(4362),
    [sym_size_t] = ACTIONS(4362),
    [sym_ptrdiff_t] = ACTIONS(4362),
    [sym_string] = ACTIONS(4362),
    [sym_cstring] = ACTIONS(4362),
    [sym_dstring] = ACTIONS(4362),
    [sym_wstring] = ACTIONS(4362),
    [sym_noreturn] = ACTIONS(4362),
    [sym_true] = ACTIONS(4362),
    [sym_false] = ACTIONS(4362),
    [sym_null] = ACTIONS(4362),
    [sym_super] = ACTIONS(4362),
    [sym_this] = ACTIONS(4362),
    [sym_abstract] = ACTIONS(4362),
    [sym_alias] = ACTIONS(4362),
    [sym_align] = ACTIONS(4362),
    [sym_asm] = ACTIONS(4362),
    [sym_assert] = ACTIONS(4362),
    [sym_auto] = ACTIONS(4362),
    [sym_break] = ACTIONS(4362),
    [sym_case] = ACTIONS(4362),
    [sym_cast] = ACTIONS(4362),
    [sym_class] = ACTIONS(4362),
    [sym_const] = ACTIONS(4362),
    [sym_continue] = ACTIONS(4362),
    [sym_debug] = ACTIONS(4362),
    [sym_default] = ACTIONS(4362),
    [sym_delegate] = ACTIONS(4362),
    [sym_delete] = ACTIONS(4362),
    [sym_deprecated] = ACTIONS(4362),
    [sym_do] = ACTIONS(4362),
    [sym_else] = ACTIONS(4362),
    [sym_enum] = ACTIONS(4362),
    [sym_export] = ACTIONS(4362),
    [sym_extern] = ACTIONS(4362),
    [sym_final] = ACTIONS(4362),
    [sym_for] = ACTIONS(4362),
    [sym_foreach] = ACTIONS(4362),
    [sym_foreach_reverse] = ACTIONS(4362),
    [sym_function] = ACTIONS(4362),
    [sym_goto] = ACTIONS(4362),
    [sym_if] = ACTIONS(4362),
    [sym_immutable] = ACTIONS(4362),
    [sym_import] = ACTIONS(4362),
    [sym_in] = ACTIONS(4362),
    [sym_inout] = ACTIONS(4362),
    [sym_interface] = ACTIONS(4362),
    [sym_invariant] = ACTIONS(4362),
    [sym_is] = ACTIONS(4362),
    [sym_mixin] = ACTIONS(4362),
    [sym_new] = ACTIONS(4362),
    [sym_nothrow] = ACTIONS(4362),
    [sym_out] = ACTIONS(4362),
    [sym_override] = ACTIONS(4362),
    [sym_package] = ACTIONS(4362),
    [sym_pragma] = ACTIONS(4362),
    [sym_private] = ACTIONS(4362),
    [sym_protected] = ACTIONS(4362),
    [sym_public] = ACTIONS(4362),
    [sym_pure] = ACTIONS(4362),
    [sym_ref] = ACTIONS(4362),
    [sym_return] = ACTIONS(4362),
    [sym_scope] = ACTIONS(4362),
    [sym_shared] = ACTIONS(4362),
    [sym_static] = ACTIONS(4362),
    [sym_struct] = ACTIONS(4362),
    [sym_switch] = ACTIONS(4362),
    [sym_synchronized] = ACTIONS(4362),
    [sym_template] = ACTIONS(4362),
    [sym_throw] = ACTIONS(4362),
    [sym_try] = ACTIONS(4362),
    [sym_typeid] = ACTIONS(4362),
    [sym_typeof] = ACTIONS(4362),
    [sym_union] = ACTIONS(4362),
    [sym_unittest] = ACTIONS(4362),
    [sym_version] = ACTIONS(4362),
    [sym_while] = ACTIONS(4362),
    [sym_with] = ACTIONS(4362),
    [sym_gshared] = ACTIONS(4362),
    [sym_traits] = ACTIONS(4362),
    [sym_vector] = ACTIONS(4362),
    [sym_void] = ACTIONS(4362),
    [anon_sym_BQUOTE] = ACTIONS(4364),
    [anon_sym_r_DQUOTE] = ACTIONS(4364),
    [anon_sym_x_DQUOTE] = ACTIONS(4364),
    [anon_sym_DQUOTE] = ACTIONS(4364),
    [anon_sym_i_BQUOTE] = ACTIONS(4364),
    [anon_sym_i_DQUOTE] = ACTIONS(4364),
    [anon_sym_iq_LBRACE] = ACTIONS(4364),
    [aux_sym_char_literal_token1] = ACTIONS(4364),
    [anon_sym_SQUOTE] = ACTIONS(4362),
    [anon_sym___DATE__] = ACTIONS(4362),
    [anon_sym___FILE__] = ACTIONS(4362),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4362),
    [anon_sym___FUNCTION__] = ACTIONS(4362),
    [anon_sym___LINE__] = ACTIONS(4362),
    [anon_sym___MODULE__] = ACTIONS(4362),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4362),
    [anon_sym___TIME__] = ACTIONS(4362),
    [anon_sym___TIMESTAMP__] = ACTIONS(4362),
    [anon_sym___VENDOR__] = ACTIONS(4362),
    [anon_sym___VERSION__] = ACTIONS(4362),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4364),
    [sym_float_literal] = ACTIONS(4364),
    [sym__string] = ACTIONS(4364),
  },
  [1616] = {
    [sym_identifier] = ACTIONS(4424),
    [anon_sym_q_LBRACE] = ACTIONS(4426),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_PLUS_PLUS] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_LPAREN] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOLLAR] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_TILDE] = ACTIONS(4426),
    [anon_sym_AT] = ACTIONS(4426),
    [sym_bool] = ACTIONS(4424),
    [sym_byte] = ACTIONS(4424),
    [sym_ubyte] = ACTIONS(4424),
    [sym_char] = ACTIONS(4424),
    [sym_short] = ACTIONS(4424),
    [sym_ushort] = ACTIONS(4424),
    [sym_int] = ACTIONS(4424),
    [sym_uint] = ACTIONS(4424),
    [sym_long] = ACTIONS(4424),
    [sym_ulong] = ACTIONS(4424),
    [sym_cent] = ACTIONS(4424),
    [sym_ucent] = ACTIONS(4424),
    [sym_wchar] = ACTIONS(4424),
    [sym_dchar] = ACTIONS(4424),
    [sym_float] = ACTIONS(4424),
    [sym_double] = ACTIONS(4424),
    [sym_real] = ACTIONS(4424),
    [sym_ifloat] = ACTIONS(4424),
    [sym_idouble] = ACTIONS(4424),
    [sym_ireal] = ACTIONS(4424),
    [sym_cfloat] = ACTIONS(4424),
    [sym_cdouble] = ACTIONS(4424),
    [sym_creal] = ACTIONS(4424),
    [sym_size_t] = ACTIONS(4424),
    [sym_ptrdiff_t] = ACTIONS(4424),
    [sym_string] = ACTIONS(4424),
    [sym_cstring] = ACTIONS(4424),
    [sym_dstring] = ACTIONS(4424),
    [sym_wstring] = ACTIONS(4424),
    [sym_noreturn] = ACTIONS(4424),
    [sym_true] = ACTIONS(4424),
    [sym_false] = ACTIONS(4424),
    [sym_null] = ACTIONS(4424),
    [sym_super] = ACTIONS(4424),
    [sym_this] = ACTIONS(4424),
    [sym_abstract] = ACTIONS(4424),
    [sym_alias] = ACTIONS(4424),
    [sym_align] = ACTIONS(4424),
    [sym_asm] = ACTIONS(4424),
    [sym_assert] = ACTIONS(4424),
    [sym_auto] = ACTIONS(4424),
    [sym_break] = ACTIONS(4424),
    [sym_case] = ACTIONS(4424),
    [sym_cast] = ACTIONS(4424),
    [sym_class] = ACTIONS(4424),
    [sym_const] = ACTIONS(4424),
    [sym_continue] = ACTIONS(4424),
    [sym_debug] = ACTIONS(4424),
    [sym_default] = ACTIONS(4424),
    [sym_delegate] = ACTIONS(4424),
    [sym_delete] = ACTIONS(4424),
    [sym_deprecated] = ACTIONS(4424),
    [sym_do] = ACTIONS(4424),
    [sym_else] = ACTIONS(4424),
    [sym_enum] = ACTIONS(4424),
    [sym_export] = ACTIONS(4424),
    [sym_extern] = ACTIONS(4424),
    [sym_final] = ACTIONS(4424),
    [sym_for] = ACTIONS(4424),
    [sym_foreach] = ACTIONS(4424),
    [sym_foreach_reverse] = ACTIONS(4424),
    [sym_function] = ACTIONS(4424),
    [sym_goto] = ACTIONS(4424),
    [sym_if] = ACTIONS(4424),
    [sym_immutable] = ACTIONS(4424),
    [sym_import] = ACTIONS(4424),
    [sym_in] = ACTIONS(4424),
    [sym_inout] = ACTIONS(4424),
    [sym_interface] = ACTIONS(4424),
    [sym_invariant] = ACTIONS(4424),
    [sym_is] = ACTIONS(4424),
    [sym_mixin] = ACTIONS(4424),
    [sym_new] = ACTIONS(4424),
    [sym_nothrow] = ACTIONS(4424),
    [sym_out] = ACTIONS(4424),
    [sym_override] = ACTIONS(4424),
    [sym_package] = ACTIONS(4424),
    [sym_pragma] = ACTIONS(4424),
    [sym_private] = ACTIONS(4424),
    [sym_protected] = ACTIONS(4424),
    [sym_public] = ACTIONS(4424),
    [sym_pure] = ACTIONS(4424),
    [sym_ref] = ACTIONS(4424),
    [sym_return] = ACTIONS(4424),
    [sym_scope] = ACTIONS(4424),
    [sym_shared] = ACTIONS(4424),
    [sym_static] = ACTIONS(4424),
    [sym_struct] = ACTIONS(4424),
    [sym_switch] = ACTIONS(4424),
    [sym_synchronized] = ACTIONS(4424),
    [sym_template] = ACTIONS(4424),
    [sym_throw] = ACTIONS(4424),
    [sym_try] = ACTIONS(4424),
    [sym_typeid] = ACTIONS(4424),
    [sym_typeof] = ACTIONS(4424),
    [sym_union] = ACTIONS(4424),
    [sym_unittest] = ACTIONS(4424),
    [sym_version] = ACTIONS(4424),
    [sym_while] = ACTIONS(4424),
    [sym_with] = ACTIONS(4424),
    [sym_gshared] = ACTIONS(4424),
    [sym_traits] = ACTIONS(4424),
    [sym_vector] = ACTIONS(4424),
    [sym_void] = ACTIONS(4424),
    [anon_sym_BQUOTE] = ACTIONS(4426),
    [anon_sym_r_DQUOTE] = ACTIONS(4426),
    [anon_sym_x_DQUOTE] = ACTIONS(4426),
    [anon_sym_DQUOTE] = ACTIONS(4426),
    [anon_sym_i_BQUOTE] = ACTIONS(4426),
    [anon_sym_i_DQUOTE] = ACTIONS(4426),
    [anon_sym_iq_LBRACE] = ACTIONS(4426),
    [aux_sym_char_literal_token1] = ACTIONS(4426),
    [anon_sym_SQUOTE] = ACTIONS(4424),
    [anon_sym___DATE__] = ACTIONS(4424),
    [anon_sym___FILE__] = ACTIONS(4424),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4424),
    [anon_sym___FUNCTION__] = ACTIONS(4424),
    [anon_sym___LINE__] = ACTIONS(4424),
    [anon_sym___MODULE__] = ACTIONS(4424),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4424),
    [anon_sym___TIME__] = ACTIONS(4424),
    [anon_sym___TIMESTAMP__] = ACTIONS(4424),
    [anon_sym___VENDOR__] = ACTIONS(4424),
    [anon_sym___VERSION__] = ACTIONS(4424),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4426),
    [sym_float_literal] = ACTIONS(4426),
    [sym__string] = ACTIONS(4426),
  },
  [1617] = {
    [sym_identifier] = ACTIONS(4444),
    [anon_sym_q_LBRACE] = ACTIONS(4446),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(4446),
    [anon_sym_DASH] = ACTIONS(4444),
    [anon_sym_DASH_DASH] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(4444),
    [anon_sym_PLUS_PLUS] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOLLAR] = ACTIONS(4446),
    [anon_sym_STAR] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_AT] = ACTIONS(4446),
    [sym_bool] = ACTIONS(4444),
    [sym_byte] = ACTIONS(4444),
    [sym_ubyte] = ACTIONS(4444),
    [sym_char] = ACTIONS(4444),
    [sym_short] = ACTIONS(4444),
    [sym_ushort] = ACTIONS(4444),
    [sym_int] = ACTIONS(4444),
    [sym_uint] = ACTIONS(4444),
    [sym_long] = ACTIONS(4444),
    [sym_ulong] = ACTIONS(4444),
    [sym_cent] = ACTIONS(4444),
    [sym_ucent] = ACTIONS(4444),
    [sym_wchar] = ACTIONS(4444),
    [sym_dchar] = ACTIONS(4444),
    [sym_float] = ACTIONS(4444),
    [sym_double] = ACTIONS(4444),
    [sym_real] = ACTIONS(4444),
    [sym_ifloat] = ACTIONS(4444),
    [sym_idouble] = ACTIONS(4444),
    [sym_ireal] = ACTIONS(4444),
    [sym_cfloat] = ACTIONS(4444),
    [sym_cdouble] = ACTIONS(4444),
    [sym_creal] = ACTIONS(4444),
    [sym_size_t] = ACTIONS(4444),
    [sym_ptrdiff_t] = ACTIONS(4444),
    [sym_string] = ACTIONS(4444),
    [sym_cstring] = ACTIONS(4444),
    [sym_dstring] = ACTIONS(4444),
    [sym_wstring] = ACTIONS(4444),
    [sym_noreturn] = ACTIONS(4444),
    [sym_true] = ACTIONS(4444),
    [sym_false] = ACTIONS(4444),
    [sym_null] = ACTIONS(4444),
    [sym_super] = ACTIONS(4444),
    [sym_this] = ACTIONS(4444),
    [sym_abstract] = ACTIONS(4444),
    [sym_alias] = ACTIONS(4444),
    [sym_align] = ACTIONS(4444),
    [sym_asm] = ACTIONS(4444),
    [sym_assert] = ACTIONS(4444),
    [sym_auto] = ACTIONS(4444),
    [sym_break] = ACTIONS(4444),
    [sym_case] = ACTIONS(4444),
    [sym_cast] = ACTIONS(4444),
    [sym_class] = ACTIONS(4444),
    [sym_const] = ACTIONS(4444),
    [sym_continue] = ACTIONS(4444),
    [sym_debug] = ACTIONS(4444),
    [sym_default] = ACTIONS(4444),
    [sym_delegate] = ACTIONS(4444),
    [sym_delete] = ACTIONS(4444),
    [sym_deprecated] = ACTIONS(4444),
    [sym_do] = ACTIONS(4444),
    [sym_else] = ACTIONS(4444),
    [sym_enum] = ACTIONS(4444),
    [sym_export] = ACTIONS(4444),
    [sym_extern] = ACTIONS(4444),
    [sym_final] = ACTIONS(4444),
    [sym_for] = ACTIONS(4444),
    [sym_foreach] = ACTIONS(4444),
    [sym_foreach_reverse] = ACTIONS(4444),
    [sym_function] = ACTIONS(4444),
    [sym_goto] = ACTIONS(4444),
    [sym_if] = ACTIONS(4444),
    [sym_immutable] = ACTIONS(4444),
    [sym_import] = ACTIONS(4444),
    [sym_in] = ACTIONS(4444),
    [sym_inout] = ACTIONS(4444),
    [sym_interface] = ACTIONS(4444),
    [sym_invariant] = ACTIONS(4444),
    [sym_is] = ACTIONS(4444),
    [sym_mixin] = ACTIONS(4444),
    [sym_new] = ACTIONS(4444),
    [sym_nothrow] = ACTIONS(4444),
    [sym_out] = ACTIONS(4444),
    [sym_override] = ACTIONS(4444),
    [sym_package] = ACTIONS(4444),
    [sym_pragma] = ACTIONS(4444),
    [sym_private] = ACTIONS(4444),
    [sym_protected] = ACTIONS(4444),
    [sym_public] = ACTIONS(4444),
    [sym_pure] = ACTIONS(4444),
    [sym_ref] = ACTIONS(4444),
    [sym_return] = ACTIONS(4444),
    [sym_scope] = ACTIONS(4444),
    [sym_shared] = ACTIONS(4444),
    [sym_static] = ACTIONS(4444),
    [sym_struct] = ACTIONS(4444),
    [sym_switch] = ACTIONS(4444),
    [sym_synchronized] = ACTIONS(4444),
    [sym_template] = ACTIONS(4444),
    [sym_throw] = ACTIONS(4444),
    [sym_try] = ACTIONS(4444),
    [sym_typeid] = ACTIONS(4444),
    [sym_typeof] = ACTIONS(4444),
    [sym_union] = ACTIONS(4444),
    [sym_unittest] = ACTIONS(4444),
    [sym_version] = ACTIONS(4444),
    [sym_while] = ACTIONS(4444),
    [sym_with] = ACTIONS(4444),
    [sym_gshared] = ACTIONS(4444),
    [sym_traits] = ACTIONS(4444),
    [sym_vector] = ACTIONS(4444),
    [sym_void] = ACTIONS(4444),
    [anon_sym_BQUOTE] = ACTIONS(4446),
    [anon_sym_r_DQUOTE] = ACTIONS(4446),
    [anon_sym_x_DQUOTE] = ACTIONS(4446),
    [anon_sym_DQUOTE] = ACTIONS(4446),
    [anon_sym_i_BQUOTE] = ACTIONS(4446),
    [anon_sym_i_DQUOTE] = ACTIONS(4446),
    [anon_sym_iq_LBRACE] = ACTIONS(4446),
    [aux_sym_char_literal_token1] = ACTIONS(4446),
    [anon_sym_SQUOTE] = ACTIONS(4444),
    [anon_sym___DATE__] = ACTIONS(4444),
    [anon_sym___FILE__] = ACTIONS(4444),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4444),
    [anon_sym___FUNCTION__] = ACTIONS(4444),
    [anon_sym___LINE__] = ACTIONS(4444),
    [anon_sym___MODULE__] = ACTIONS(4444),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4444),
    [anon_sym___TIME__] = ACTIONS(4444),
    [anon_sym___TIMESTAMP__] = ACTIONS(4444),
    [anon_sym___VENDOR__] = ACTIONS(4444),
    [anon_sym___VERSION__] = ACTIONS(4444),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4446),
    [sym_float_literal] = ACTIONS(4446),
    [sym__string] = ACTIONS(4446),
  },
  [1618] = {
    [sym_identifier] = ACTIONS(4773),
    [anon_sym_q_LBRACE] = ACTIONS(4775),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(4775),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4775),
    [anon_sym_DASH] = ACTIONS(4773),
    [anon_sym_DASH_DASH] = ACTIONS(4775),
    [anon_sym_PLUS] = ACTIONS(4773),
    [anon_sym_PLUS_PLUS] = ACTIONS(4775),
    [anon_sym_BANG] = ACTIONS(4775),
    [anon_sym_LPAREN] = ACTIONS(4775),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_LBRACK] = ACTIONS(4775),
    [anon_sym_SEMI] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4775),
    [anon_sym_STAR] = ACTIONS(4775),
    [anon_sym_TILDE] = ACTIONS(4775),
    [anon_sym_AT] = ACTIONS(4775),
    [sym_bool] = ACTIONS(4773),
    [sym_byte] = ACTIONS(4773),
    [sym_ubyte] = ACTIONS(4773),
    [sym_char] = ACTIONS(4773),
    [sym_short] = ACTIONS(4773),
    [sym_ushort] = ACTIONS(4773),
    [sym_int] = ACTIONS(4773),
    [sym_uint] = ACTIONS(4773),
    [sym_long] = ACTIONS(4773),
    [sym_ulong] = ACTIONS(4773),
    [sym_cent] = ACTIONS(4773),
    [sym_ucent] = ACTIONS(4773),
    [sym_wchar] = ACTIONS(4773),
    [sym_dchar] = ACTIONS(4773),
    [sym_float] = ACTIONS(4773),
    [sym_double] = ACTIONS(4773),
    [sym_real] = ACTIONS(4773),
    [sym_ifloat] = ACTIONS(4773),
    [sym_idouble] = ACTIONS(4773),
    [sym_ireal] = ACTIONS(4773),
    [sym_cfloat] = ACTIONS(4773),
    [sym_cdouble] = ACTIONS(4773),
    [sym_creal] = ACTIONS(4773),
    [sym_size_t] = ACTIONS(4773),
    [sym_ptrdiff_t] = ACTIONS(4773),
    [sym_string] = ACTIONS(4773),
    [sym_cstring] = ACTIONS(4773),
    [sym_dstring] = ACTIONS(4773),
    [sym_wstring] = ACTIONS(4773),
    [sym_noreturn] = ACTIONS(4773),
    [sym_true] = ACTIONS(4773),
    [sym_false] = ACTIONS(4773),
    [sym_null] = ACTIONS(4773),
    [sym_super] = ACTIONS(4773),
    [sym_this] = ACTIONS(4773),
    [sym_abstract] = ACTIONS(4773),
    [sym_alias] = ACTIONS(4773),
    [sym_align] = ACTIONS(4773),
    [sym_asm] = ACTIONS(4773),
    [sym_assert] = ACTIONS(4773),
    [sym_auto] = ACTIONS(4773),
    [sym_break] = ACTIONS(4773),
    [sym_case] = ACTIONS(4773),
    [sym_cast] = ACTIONS(4773),
    [sym_class] = ACTIONS(4773),
    [sym_const] = ACTIONS(4773),
    [sym_continue] = ACTIONS(4773),
    [sym_debug] = ACTIONS(4773),
    [sym_default] = ACTIONS(4773),
    [sym_delegate] = ACTIONS(4773),
    [sym_delete] = ACTIONS(4773),
    [sym_deprecated] = ACTIONS(4773),
    [sym_do] = ACTIONS(4773),
    [sym_else] = ACTIONS(4773),
    [sym_enum] = ACTIONS(4773),
    [sym_export] = ACTIONS(4773),
    [sym_extern] = ACTIONS(4773),
    [sym_final] = ACTIONS(4773),
    [sym_for] = ACTIONS(4773),
    [sym_foreach] = ACTIONS(4773),
    [sym_foreach_reverse] = ACTIONS(4773),
    [sym_function] = ACTIONS(4773),
    [sym_goto] = ACTIONS(4773),
    [sym_if] = ACTIONS(4773),
    [sym_immutable] = ACTIONS(4773),
    [sym_import] = ACTIONS(4773),
    [sym_in] = ACTIONS(4773),
    [sym_inout] = ACTIONS(4773),
    [sym_interface] = ACTIONS(4773),
    [sym_invariant] = ACTIONS(4773),
    [sym_is] = ACTIONS(4773),
    [sym_mixin] = ACTIONS(4773),
    [sym_new] = ACTIONS(4773),
    [sym_nothrow] = ACTIONS(4773),
    [sym_out] = ACTIONS(4773),
    [sym_override] = ACTIONS(4773),
    [sym_package] = ACTIONS(4773),
    [sym_pragma] = ACTIONS(4773),
    [sym_private] = ACTIONS(4773),
    [sym_protected] = ACTIONS(4773),
    [sym_public] = ACTIONS(4773),
    [sym_pure] = ACTIONS(4773),
    [sym_ref] = ACTIONS(4773),
    [sym_return] = ACTIONS(4773),
    [sym_scope] = ACTIONS(4773),
    [sym_shared] = ACTIONS(4773),
    [sym_static] = ACTIONS(4773),
    [sym_struct] = ACTIONS(4773),
    [sym_switch] = ACTIONS(4773),
    [sym_synchronized] = ACTIONS(4773),
    [sym_template] = ACTIONS(4773),
    [sym_throw] = ACTIONS(4773),
    [sym_try] = ACTIONS(4773),
    [sym_typeid] = ACTIONS(4773),
    [sym_typeof] = ACTIONS(4773),
    [sym_union] = ACTIONS(4773),
    [sym_unittest] = ACTIONS(4773),
    [sym_version] = ACTIONS(4773),
    [sym_while] = ACTIONS(4773),
    [sym_with] = ACTIONS(4773),
    [sym_gshared] = ACTIONS(4773),
    [sym_traits] = ACTIONS(4773),
    [sym_vector] = ACTIONS(4773),
    [sym_void] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_r_DQUOTE] = ACTIONS(4775),
    [anon_sym_x_DQUOTE] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_i_BQUOTE] = ACTIONS(4775),
    [anon_sym_i_DQUOTE] = ACTIONS(4775),
    [anon_sym_iq_LBRACE] = ACTIONS(4775),
    [aux_sym_char_literal_token1] = ACTIONS(4775),
    [anon_sym_SQUOTE] = ACTIONS(4773),
    [anon_sym___DATE__] = ACTIONS(4773),
    [anon_sym___FILE__] = ACTIONS(4773),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4773),
    [anon_sym___FUNCTION__] = ACTIONS(4773),
    [anon_sym___LINE__] = ACTIONS(4773),
    [anon_sym___MODULE__] = ACTIONS(4773),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4773),
    [anon_sym___TIME__] = ACTIONS(4773),
    [anon_sym___TIMESTAMP__] = ACTIONS(4773),
    [anon_sym___VENDOR__] = ACTIONS(4773),
    [anon_sym___VERSION__] = ACTIONS(4773),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4775),
    [sym_float_literal] = ACTIONS(4775),
    [sym__string] = ACTIONS(4775),
  },
  [1619] = {
    [sym_identifier] = ACTIONS(4701),
    [anon_sym_q_LBRACE] = ACTIONS(4704),
    [anon_sym_RBRACE] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(4704),
    [anon_sym_DOT] = ACTIONS(4704),
    [anon_sym_AMP] = ACTIONS(4704),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_DASH_DASH] = ACTIONS(4704),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4704),
    [anon_sym_BANG] = ACTIONS(4704),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_RPAREN] = ACTIONS(4704),
    [anon_sym_LBRACK] = ACTIONS(4704),
    [anon_sym_SEMI] = ACTIONS(4704),
    [anon_sym_DOLLAR] = ACTIONS(4704),
    [anon_sym_STAR] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(4704),
    [anon_sym_AT] = ACTIONS(4704),
    [sym_bool] = ACTIONS(4701),
    [sym_byte] = ACTIONS(4701),
    [sym_ubyte] = ACTIONS(4701),
    [sym_char] = ACTIONS(4701),
    [sym_short] = ACTIONS(4701),
    [sym_ushort] = ACTIONS(4701),
    [sym_int] = ACTIONS(4701),
    [sym_uint] = ACTIONS(4701),
    [sym_long] = ACTIONS(4701),
    [sym_ulong] = ACTIONS(4701),
    [sym_cent] = ACTIONS(4701),
    [sym_ucent] = ACTIONS(4701),
    [sym_wchar] = ACTIONS(4701),
    [sym_dchar] = ACTIONS(4701),
    [sym_float] = ACTIONS(4701),
    [sym_double] = ACTIONS(4701),
    [sym_real] = ACTIONS(4701),
    [sym_ifloat] = ACTIONS(4701),
    [sym_idouble] = ACTIONS(4701),
    [sym_ireal] = ACTIONS(4701),
    [sym_cfloat] = ACTIONS(4701),
    [sym_cdouble] = ACTIONS(4701),
    [sym_creal] = ACTIONS(4701),
    [sym_size_t] = ACTIONS(4701),
    [sym_ptrdiff_t] = ACTIONS(4701),
    [sym_string] = ACTIONS(4701),
    [sym_cstring] = ACTIONS(4701),
    [sym_dstring] = ACTIONS(4701),
    [sym_wstring] = ACTIONS(4701),
    [sym_noreturn] = ACTIONS(4701),
    [sym_true] = ACTIONS(4701),
    [sym_false] = ACTIONS(4701),
    [sym_null] = ACTIONS(4701),
    [sym_super] = ACTIONS(4701),
    [sym_this] = ACTIONS(4701),
    [sym_abstract] = ACTIONS(4701),
    [sym_alias] = ACTIONS(4701),
    [sym_align] = ACTIONS(4701),
    [sym_asm] = ACTIONS(4701),
    [sym_assert] = ACTIONS(4701),
    [sym_auto] = ACTIONS(4701),
    [sym_break] = ACTIONS(4701),
    [sym_case] = ACTIONS(4701),
    [sym_cast] = ACTIONS(4701),
    [sym_class] = ACTIONS(4701),
    [sym_const] = ACTIONS(4701),
    [sym_continue] = ACTIONS(4701),
    [sym_debug] = ACTIONS(4701),
    [sym_default] = ACTIONS(4701),
    [sym_delegate] = ACTIONS(4701),
    [sym_delete] = ACTIONS(4701),
    [sym_deprecated] = ACTIONS(4701),
    [sym_do] = ACTIONS(4701),
    [sym_else] = ACTIONS(4701),
    [sym_enum] = ACTIONS(4701),
    [sym_export] = ACTIONS(4701),
    [sym_extern] = ACTIONS(4701),
    [sym_final] = ACTIONS(4701),
    [sym_for] = ACTIONS(4701),
    [sym_foreach] = ACTIONS(4701),
    [sym_foreach_reverse] = ACTIONS(4701),
    [sym_function] = ACTIONS(4701),
    [sym_goto] = ACTIONS(4701),
    [sym_if] = ACTIONS(4701),
    [sym_immutable] = ACTIONS(4701),
    [sym_import] = ACTIONS(4701),
    [sym_in] = ACTIONS(4701),
    [sym_inout] = ACTIONS(4701),
    [sym_interface] = ACTIONS(4701),
    [sym_invariant] = ACTIONS(4701),
    [sym_is] = ACTIONS(4701),
    [sym_mixin] = ACTIONS(4701),
    [sym_new] = ACTIONS(4701),
    [sym_nothrow] = ACTIONS(4701),
    [sym_out] = ACTIONS(4701),
    [sym_override] = ACTIONS(4701),
    [sym_package] = ACTIONS(4701),
    [sym_pragma] = ACTIONS(4701),
    [sym_private] = ACTIONS(4701),
    [sym_protected] = ACTIONS(4701),
    [sym_public] = ACTIONS(4701),
    [sym_pure] = ACTIONS(4701),
    [sym_ref] = ACTIONS(4701),
    [sym_return] = ACTIONS(4701),
    [sym_scope] = ACTIONS(4701),
    [sym_shared] = ACTIONS(4701),
    [sym_static] = ACTIONS(4701),
    [sym_struct] = ACTIONS(4701),
    [sym_switch] = ACTIONS(4701),
    [sym_synchronized] = ACTIONS(4701),
    [sym_template] = ACTIONS(4701),
    [sym_throw] = ACTIONS(4701),
    [sym_try] = ACTIONS(4701),
    [sym_typeid] = ACTIONS(4701),
    [sym_typeof] = ACTIONS(4701),
    [sym_union] = ACTIONS(4701),
    [sym_unittest] = ACTIONS(4701),
    [sym_version] = ACTIONS(4701),
    [sym_while] = ACTIONS(4701),
    [sym_with] = ACTIONS(4701),
    [sym_gshared] = ACTIONS(4701),
    [sym_traits] = ACTIONS(4701),
    [sym_vector] = ACTIONS(4701),
    [sym_void] = ACTIONS(4701),
    [anon_sym_BQUOTE] = ACTIONS(4704),
    [anon_sym_r_DQUOTE] = ACTIONS(4704),
    [anon_sym_x_DQUOTE] = ACTIONS(4704),
    [anon_sym_DQUOTE] = ACTIONS(4704),
    [anon_sym_i_BQUOTE] = ACTIONS(4704),
    [anon_sym_i_DQUOTE] = ACTIONS(4704),
    [anon_sym_iq_LBRACE] = ACTIONS(4704),
    [aux_sym_char_literal_token1] = ACTIONS(4704),
    [anon_sym_SQUOTE] = ACTIONS(4701),
    [anon_sym___DATE__] = ACTIONS(4701),
    [anon_sym___FILE__] = ACTIONS(4701),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4701),
    [anon_sym___FUNCTION__] = ACTIONS(4701),
    [anon_sym___LINE__] = ACTIONS(4701),
    [anon_sym___MODULE__] = ACTIONS(4701),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4701),
    [anon_sym___TIME__] = ACTIONS(4701),
    [anon_sym___TIMESTAMP__] = ACTIONS(4701),
    [anon_sym___VENDOR__] = ACTIONS(4701),
    [anon_sym___VERSION__] = ACTIONS(4701),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4704),
    [sym_float_literal] = ACTIONS(4704),
    [sym__string] = ACTIONS(4704),
  },
  [1620] = {
    [sym_identifier] = ACTIONS(4428),
    [anon_sym_q_LBRACE] = ACTIONS(4430),
    [anon_sym_RBRACE] = ACTIONS(4430),
    [anon_sym_LBRACE] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4430),
    [anon_sym_PLUS] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4430),
    [anon_sym_BANG] = ACTIONS(4430),
    [anon_sym_LPAREN] = ACTIONS(4430),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym_DOLLAR] = ACTIONS(4430),
    [anon_sym_STAR] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(4430),
    [anon_sym_AT] = ACTIONS(4430),
    [sym_bool] = ACTIONS(4428),
    [sym_byte] = ACTIONS(4428),
    [sym_ubyte] = ACTIONS(4428),
    [sym_char] = ACTIONS(4428),
    [sym_short] = ACTIONS(4428),
    [sym_ushort] = ACTIONS(4428),
    [sym_int] = ACTIONS(4428),
    [sym_uint] = ACTIONS(4428),
    [sym_long] = ACTIONS(4428),
    [sym_ulong] = ACTIONS(4428),
    [sym_cent] = ACTIONS(4428),
    [sym_ucent] = ACTIONS(4428),
    [sym_wchar] = ACTIONS(4428),
    [sym_dchar] = ACTIONS(4428),
    [sym_float] = ACTIONS(4428),
    [sym_double] = ACTIONS(4428),
    [sym_real] = ACTIONS(4428),
    [sym_ifloat] = ACTIONS(4428),
    [sym_idouble] = ACTIONS(4428),
    [sym_ireal] = ACTIONS(4428),
    [sym_cfloat] = ACTIONS(4428),
    [sym_cdouble] = ACTIONS(4428),
    [sym_creal] = ACTIONS(4428),
    [sym_size_t] = ACTIONS(4428),
    [sym_ptrdiff_t] = ACTIONS(4428),
    [sym_string] = ACTIONS(4428),
    [sym_cstring] = ACTIONS(4428),
    [sym_dstring] = ACTIONS(4428),
    [sym_wstring] = ACTIONS(4428),
    [sym_noreturn] = ACTIONS(4428),
    [sym_true] = ACTIONS(4428),
    [sym_false] = ACTIONS(4428),
    [sym_null] = ACTIONS(4428),
    [sym_super] = ACTIONS(4428),
    [sym_this] = ACTIONS(4428),
    [sym_abstract] = ACTIONS(4428),
    [sym_alias] = ACTIONS(4428),
    [sym_align] = ACTIONS(4428),
    [sym_asm] = ACTIONS(4428),
    [sym_assert] = ACTIONS(4428),
    [sym_auto] = ACTIONS(4428),
    [sym_break] = ACTIONS(4428),
    [sym_case] = ACTIONS(4428),
    [sym_cast] = ACTIONS(4428),
    [sym_class] = ACTIONS(4428),
    [sym_const] = ACTIONS(4428),
    [sym_continue] = ACTIONS(4428),
    [sym_debug] = ACTIONS(4428),
    [sym_default] = ACTIONS(4428),
    [sym_delegate] = ACTIONS(4428),
    [sym_delete] = ACTIONS(4428),
    [sym_deprecated] = ACTIONS(4428),
    [sym_do] = ACTIONS(4428),
    [sym_else] = ACTIONS(4428),
    [sym_enum] = ACTIONS(4428),
    [sym_export] = ACTIONS(4428),
    [sym_extern] = ACTIONS(4428),
    [sym_final] = ACTIONS(4428),
    [sym_for] = ACTIONS(4428),
    [sym_foreach] = ACTIONS(4428),
    [sym_foreach_reverse] = ACTIONS(4428),
    [sym_function] = ACTIONS(4428),
    [sym_goto] = ACTIONS(4428),
    [sym_if] = ACTIONS(4428),
    [sym_immutable] = ACTIONS(4428),
    [sym_import] = ACTIONS(4428),
    [sym_in] = ACTIONS(4428),
    [sym_inout] = ACTIONS(4428),
    [sym_interface] = ACTIONS(4428),
    [sym_invariant] = ACTIONS(4428),
    [sym_is] = ACTIONS(4428),
    [sym_mixin] = ACTIONS(4428),
    [sym_new] = ACTIONS(4428),
    [sym_nothrow] = ACTIONS(4428),
    [sym_out] = ACTIONS(4428),
    [sym_override] = ACTIONS(4428),
    [sym_package] = ACTIONS(4428),
    [sym_pragma] = ACTIONS(4428),
    [sym_private] = ACTIONS(4428),
    [sym_protected] = ACTIONS(4428),
    [sym_public] = ACTIONS(4428),
    [sym_pure] = ACTIONS(4428),
    [sym_ref] = ACTIONS(4428),
    [sym_return] = ACTIONS(4428),
    [sym_scope] = ACTIONS(4428),
    [sym_shared] = ACTIONS(4428),
    [sym_static] = ACTIONS(4428),
    [sym_struct] = ACTIONS(4428),
    [sym_switch] = ACTIONS(4428),
    [sym_synchronized] = ACTIONS(4428),
    [sym_template] = ACTIONS(4428),
    [sym_throw] = ACTIONS(4428),
    [sym_try] = ACTIONS(4428),
    [sym_typeid] = ACTIONS(4428),
    [sym_typeof] = ACTIONS(4428),
    [sym_union] = ACTIONS(4428),
    [sym_unittest] = ACTIONS(4428),
    [sym_version] = ACTIONS(4428),
    [sym_while] = ACTIONS(4428),
    [sym_with] = ACTIONS(4428),
    [sym_gshared] = ACTIONS(4428),
    [sym_traits] = ACTIONS(4428),
    [sym_vector] = ACTIONS(4428),
    [sym_void] = ACTIONS(4428),
    [anon_sym_BQUOTE] = ACTIONS(4430),
    [anon_sym_r_DQUOTE] = ACTIONS(4430),
    [anon_sym_x_DQUOTE] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4430),
    [anon_sym_i_BQUOTE] = ACTIONS(4430),
    [anon_sym_i_DQUOTE] = ACTIONS(4430),
    [anon_sym_iq_LBRACE] = ACTIONS(4430),
    [aux_sym_char_literal_token1] = ACTIONS(4430),
    [anon_sym_SQUOTE] = ACTIONS(4428),
    [anon_sym___DATE__] = ACTIONS(4428),
    [anon_sym___FILE__] = ACTIONS(4428),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4428),
    [anon_sym___FUNCTION__] = ACTIONS(4428),
    [anon_sym___LINE__] = ACTIONS(4428),
    [anon_sym___MODULE__] = ACTIONS(4428),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4428),
    [anon_sym___TIME__] = ACTIONS(4428),
    [anon_sym___TIMESTAMP__] = ACTIONS(4428),
    [anon_sym___VENDOR__] = ACTIONS(4428),
    [anon_sym___VERSION__] = ACTIONS(4428),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4430),
    [sym_float_literal] = ACTIONS(4430),
    [sym__string] = ACTIONS(4430),
  },
  [1621] = {
    [sym_identifier] = ACTIONS(4432),
    [anon_sym_q_LBRACE] = ACTIONS(4434),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4434),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_BANG] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_TILDE] = ACTIONS(4434),
    [anon_sym_AT] = ACTIONS(4434),
    [sym_bool] = ACTIONS(4432),
    [sym_byte] = ACTIONS(4432),
    [sym_ubyte] = ACTIONS(4432),
    [sym_char] = ACTIONS(4432),
    [sym_short] = ACTIONS(4432),
    [sym_ushort] = ACTIONS(4432),
    [sym_int] = ACTIONS(4432),
    [sym_uint] = ACTIONS(4432),
    [sym_long] = ACTIONS(4432),
    [sym_ulong] = ACTIONS(4432),
    [sym_cent] = ACTIONS(4432),
    [sym_ucent] = ACTIONS(4432),
    [sym_wchar] = ACTIONS(4432),
    [sym_dchar] = ACTIONS(4432),
    [sym_float] = ACTIONS(4432),
    [sym_double] = ACTIONS(4432),
    [sym_real] = ACTIONS(4432),
    [sym_ifloat] = ACTIONS(4432),
    [sym_idouble] = ACTIONS(4432),
    [sym_ireal] = ACTIONS(4432),
    [sym_cfloat] = ACTIONS(4432),
    [sym_cdouble] = ACTIONS(4432),
    [sym_creal] = ACTIONS(4432),
    [sym_size_t] = ACTIONS(4432),
    [sym_ptrdiff_t] = ACTIONS(4432),
    [sym_string] = ACTIONS(4432),
    [sym_cstring] = ACTIONS(4432),
    [sym_dstring] = ACTIONS(4432),
    [sym_wstring] = ACTIONS(4432),
    [sym_noreturn] = ACTIONS(4432),
    [sym_true] = ACTIONS(4432),
    [sym_false] = ACTIONS(4432),
    [sym_null] = ACTIONS(4432),
    [sym_super] = ACTIONS(4432),
    [sym_this] = ACTIONS(4432),
    [sym_abstract] = ACTIONS(4432),
    [sym_alias] = ACTIONS(4432),
    [sym_align] = ACTIONS(4432),
    [sym_asm] = ACTIONS(4432),
    [sym_assert] = ACTIONS(4432),
    [sym_auto] = ACTIONS(4432),
    [sym_break] = ACTIONS(4432),
    [sym_case] = ACTIONS(4432),
    [sym_cast] = ACTIONS(4432),
    [sym_class] = ACTIONS(4432),
    [sym_const] = ACTIONS(4432),
    [sym_continue] = ACTIONS(4432),
    [sym_debug] = ACTIONS(4432),
    [sym_default] = ACTIONS(4432),
    [sym_delegate] = ACTIONS(4432),
    [sym_delete] = ACTIONS(4432),
    [sym_deprecated] = ACTIONS(4432),
    [sym_do] = ACTIONS(4432),
    [sym_else] = ACTIONS(4432),
    [sym_enum] = ACTIONS(4432),
    [sym_export] = ACTIONS(4432),
    [sym_extern] = ACTIONS(4432),
    [sym_final] = ACTIONS(4432),
    [sym_for] = ACTIONS(4432),
    [sym_foreach] = ACTIONS(4432),
    [sym_foreach_reverse] = ACTIONS(4432),
    [sym_function] = ACTIONS(4432),
    [sym_goto] = ACTIONS(4432),
    [sym_if] = ACTIONS(4432),
    [sym_immutable] = ACTIONS(4432),
    [sym_import] = ACTIONS(4432),
    [sym_in] = ACTIONS(4432),
    [sym_inout] = ACTIONS(4432),
    [sym_interface] = ACTIONS(4432),
    [sym_invariant] = ACTIONS(4432),
    [sym_is] = ACTIONS(4432),
    [sym_mixin] = ACTIONS(4432),
    [sym_new] = ACTIONS(4432),
    [sym_nothrow] = ACTIONS(4432),
    [sym_out] = ACTIONS(4432),
    [sym_override] = ACTIONS(4432),
    [sym_package] = ACTIONS(4432),
    [sym_pragma] = ACTIONS(4432),
    [sym_private] = ACTIONS(4432),
    [sym_protected] = ACTIONS(4432),
    [sym_public] = ACTIONS(4432),
    [sym_pure] = ACTIONS(4432),
    [sym_ref] = ACTIONS(4432),
    [sym_return] = ACTIONS(4432),
    [sym_scope] = ACTIONS(4432),
    [sym_shared] = ACTIONS(4432),
    [sym_static] = ACTIONS(4432),
    [sym_struct] = ACTIONS(4432),
    [sym_switch] = ACTIONS(4432),
    [sym_synchronized] = ACTIONS(4432),
    [sym_template] = ACTIONS(4432),
    [sym_throw] = ACTIONS(4432),
    [sym_try] = ACTIONS(4432),
    [sym_typeid] = ACTIONS(4432),
    [sym_typeof] = ACTIONS(4432),
    [sym_union] = ACTIONS(4432),
    [sym_unittest] = ACTIONS(4432),
    [sym_version] = ACTIONS(4432),
    [sym_while] = ACTIONS(4432),
    [sym_with] = ACTIONS(4432),
    [sym_gshared] = ACTIONS(4432),
    [sym_traits] = ACTIONS(4432),
    [sym_vector] = ACTIONS(4432),
    [sym_void] = ACTIONS(4432),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [anon_sym_r_DQUOTE] = ACTIONS(4434),
    [anon_sym_x_DQUOTE] = ACTIONS(4434),
    [anon_sym_DQUOTE] = ACTIONS(4434),
    [anon_sym_i_BQUOTE] = ACTIONS(4434),
    [anon_sym_i_DQUOTE] = ACTIONS(4434),
    [anon_sym_iq_LBRACE] = ACTIONS(4434),
    [aux_sym_char_literal_token1] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4432),
    [anon_sym___DATE__] = ACTIONS(4432),
    [anon_sym___FILE__] = ACTIONS(4432),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4432),
    [anon_sym___FUNCTION__] = ACTIONS(4432),
    [anon_sym___LINE__] = ACTIONS(4432),
    [anon_sym___MODULE__] = ACTIONS(4432),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4432),
    [anon_sym___TIME__] = ACTIONS(4432),
    [anon_sym___TIMESTAMP__] = ACTIONS(4432),
    [anon_sym___VENDOR__] = ACTIONS(4432),
    [anon_sym___VERSION__] = ACTIONS(4432),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4434),
    [sym_float_literal] = ACTIONS(4434),
    [sym__string] = ACTIONS(4434),
  },
  [1622] = {
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [anon_sym_AT] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_abstract] = ACTIONS(4190),
    [sym_alias] = ACTIONS(4190),
    [sym_align] = ACTIONS(4190),
    [sym_asm] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_break] = ACTIONS(4190),
    [sym_case] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_class] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_continue] = ACTIONS(4190),
    [sym_debug] = ACTIONS(4190),
    [sym_default] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_deprecated] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_enum] = ACTIONS(4190),
    [sym_export] = ACTIONS(4190),
    [sym_extern] = ACTIONS(4190),
    [sym_final] = ACTIONS(4190),
    [sym_for] = ACTIONS(4190),
    [sym_foreach] = ACTIONS(4190),
    [sym_foreach_reverse] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_goto] = ACTIONS(4190),
    [sym_if] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_interface] = ACTIONS(4190),
    [sym_invariant] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_nothrow] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_override] = ACTIONS(4190),
    [sym_package] = ACTIONS(4190),
    [sym_pragma] = ACTIONS(4190),
    [sym_private] = ACTIONS(4190),
    [sym_protected] = ACTIONS(4190),
    [sym_public] = ACTIONS(4190),
    [sym_pure] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_return] = ACTIONS(4190),
    [sym_scope] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_static] = ACTIONS(4190),
    [sym_struct] = ACTIONS(4190),
    [sym_switch] = ACTIONS(4190),
    [sym_synchronized] = ACTIONS(4190),
    [sym_template] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_try] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_union] = ACTIONS(4190),
    [sym_unittest] = ACTIONS(4190),
    [sym_version] = ACTIONS(4190),
    [sym_while] = ACTIONS(4190),
    [sym_with] = ACTIONS(4190),
    [sym_gshared] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1623] = {
    [sym_identifier] = ACTIONS(4318),
    [anon_sym_q_LBRACE] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(4320),
    [anon_sym_AMP] = ACTIONS(4320),
    [anon_sym_DASH] = ACTIONS(4318),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(4318),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_BANG] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_DOLLAR] = ACTIONS(4320),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_TILDE] = ACTIONS(4320),
    [anon_sym_AT] = ACTIONS(4320),
    [sym_bool] = ACTIONS(4318),
    [sym_byte] = ACTIONS(4318),
    [sym_ubyte] = ACTIONS(4318),
    [sym_char] = ACTIONS(4318),
    [sym_short] = ACTIONS(4318),
    [sym_ushort] = ACTIONS(4318),
    [sym_int] = ACTIONS(4318),
    [sym_uint] = ACTIONS(4318),
    [sym_long] = ACTIONS(4318),
    [sym_ulong] = ACTIONS(4318),
    [sym_cent] = ACTIONS(4318),
    [sym_ucent] = ACTIONS(4318),
    [sym_wchar] = ACTIONS(4318),
    [sym_dchar] = ACTIONS(4318),
    [sym_float] = ACTIONS(4318),
    [sym_double] = ACTIONS(4318),
    [sym_real] = ACTIONS(4318),
    [sym_ifloat] = ACTIONS(4318),
    [sym_idouble] = ACTIONS(4318),
    [sym_ireal] = ACTIONS(4318),
    [sym_cfloat] = ACTIONS(4318),
    [sym_cdouble] = ACTIONS(4318),
    [sym_creal] = ACTIONS(4318),
    [sym_size_t] = ACTIONS(4318),
    [sym_ptrdiff_t] = ACTIONS(4318),
    [sym_string] = ACTIONS(4318),
    [sym_cstring] = ACTIONS(4318),
    [sym_dstring] = ACTIONS(4318),
    [sym_wstring] = ACTIONS(4318),
    [sym_noreturn] = ACTIONS(4318),
    [sym_true] = ACTIONS(4318),
    [sym_false] = ACTIONS(4318),
    [sym_null] = ACTIONS(4318),
    [sym_super] = ACTIONS(4318),
    [sym_this] = ACTIONS(4318),
    [sym_abstract] = ACTIONS(4318),
    [sym_alias] = ACTIONS(4318),
    [sym_align] = ACTIONS(4318),
    [sym_asm] = ACTIONS(4318),
    [sym_assert] = ACTIONS(4318),
    [sym_auto] = ACTIONS(4318),
    [sym_break] = ACTIONS(4318),
    [sym_case] = ACTIONS(4318),
    [sym_cast] = ACTIONS(4318),
    [sym_class] = ACTIONS(4318),
    [sym_const] = ACTIONS(4318),
    [sym_continue] = ACTIONS(4318),
    [sym_debug] = ACTIONS(4318),
    [sym_default] = ACTIONS(4318),
    [sym_delegate] = ACTIONS(4318),
    [sym_delete] = ACTIONS(4318),
    [sym_deprecated] = ACTIONS(4318),
    [sym_do] = ACTIONS(4318),
    [sym_else] = ACTIONS(4318),
    [sym_enum] = ACTIONS(4318),
    [sym_export] = ACTIONS(4318),
    [sym_extern] = ACTIONS(4318),
    [sym_final] = ACTIONS(4318),
    [sym_for] = ACTIONS(4318),
    [sym_foreach] = ACTIONS(4318),
    [sym_foreach_reverse] = ACTIONS(4318),
    [sym_function] = ACTIONS(4318),
    [sym_goto] = ACTIONS(4318),
    [sym_if] = ACTIONS(4318),
    [sym_immutable] = ACTIONS(4318),
    [sym_import] = ACTIONS(4318),
    [sym_in] = ACTIONS(4318),
    [sym_inout] = ACTIONS(4318),
    [sym_interface] = ACTIONS(4318),
    [sym_invariant] = ACTIONS(4318),
    [sym_is] = ACTIONS(4318),
    [sym_mixin] = ACTIONS(4318),
    [sym_new] = ACTIONS(4318),
    [sym_nothrow] = ACTIONS(4318),
    [sym_out] = ACTIONS(4318),
    [sym_override] = ACTIONS(4318),
    [sym_package] = ACTIONS(4318),
    [sym_pragma] = ACTIONS(4318),
    [sym_private] = ACTIONS(4318),
    [sym_protected] = ACTIONS(4318),
    [sym_public] = ACTIONS(4318),
    [sym_pure] = ACTIONS(4318),
    [sym_ref] = ACTIONS(4318),
    [sym_return] = ACTIONS(4318),
    [sym_scope] = ACTIONS(4318),
    [sym_shared] = ACTIONS(4318),
    [sym_static] = ACTIONS(4318),
    [sym_struct] = ACTIONS(4318),
    [sym_switch] = ACTIONS(4318),
    [sym_synchronized] = ACTIONS(4318),
    [sym_template] = ACTIONS(4318),
    [sym_throw] = ACTIONS(4318),
    [sym_try] = ACTIONS(4318),
    [sym_typeid] = ACTIONS(4318),
    [sym_typeof] = ACTIONS(4318),
    [sym_union] = ACTIONS(4318),
    [sym_unittest] = ACTIONS(4318),
    [sym_version] = ACTIONS(4318),
    [sym_while] = ACTIONS(4318),
    [sym_with] = ACTIONS(4318),
    [sym_gshared] = ACTIONS(4318),
    [sym_traits] = ACTIONS(4318),
    [sym_vector] = ACTIONS(4318),
    [sym_void] = ACTIONS(4318),
    [anon_sym_BQUOTE] = ACTIONS(4320),
    [anon_sym_r_DQUOTE] = ACTIONS(4320),
    [anon_sym_x_DQUOTE] = ACTIONS(4320),
    [anon_sym_DQUOTE] = ACTIONS(4320),
    [anon_sym_i_BQUOTE] = ACTIONS(4320),
    [anon_sym_i_DQUOTE] = ACTIONS(4320),
    [anon_sym_iq_LBRACE] = ACTIONS(4320),
    [aux_sym_char_literal_token1] = ACTIONS(4320),
    [anon_sym_SQUOTE] = ACTIONS(4318),
    [anon_sym___DATE__] = ACTIONS(4318),
    [anon_sym___FILE__] = ACTIONS(4318),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4318),
    [anon_sym___FUNCTION__] = ACTIONS(4318),
    [anon_sym___LINE__] = ACTIONS(4318),
    [anon_sym___MODULE__] = ACTIONS(4318),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4318),
    [anon_sym___TIME__] = ACTIONS(4318),
    [anon_sym___TIMESTAMP__] = ACTIONS(4318),
    [anon_sym___VENDOR__] = ACTIONS(4318),
    [anon_sym___VERSION__] = ACTIONS(4318),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4320),
    [sym_float_literal] = ACTIONS(4320),
    [sym__string] = ACTIONS(4320),
  },
  [1624] = {
    [sym_identifier] = ACTIONS(4538),
    [anon_sym_q_LBRACE] = ACTIONS(4540),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(4540),
    [anon_sym_DOT] = ACTIONS(4540),
    [anon_sym_AMP] = ACTIONS(4540),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_DASH_DASH] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_LPAREN] = ACTIONS(4540),
    [anon_sym_RPAREN] = ACTIONS(4540),
    [anon_sym_LBRACK] = ACTIONS(4540),
    [anon_sym_SEMI] = ACTIONS(4540),
    [anon_sym_DOLLAR] = ACTIONS(4540),
    [anon_sym_STAR] = ACTIONS(4540),
    [anon_sym_TILDE] = ACTIONS(4540),
    [anon_sym_AT] = ACTIONS(4540),
    [sym_bool] = ACTIONS(4538),
    [sym_byte] = ACTIONS(4538),
    [sym_ubyte] = ACTIONS(4538),
    [sym_char] = ACTIONS(4538),
    [sym_short] = ACTIONS(4538),
    [sym_ushort] = ACTIONS(4538),
    [sym_int] = ACTIONS(4538),
    [sym_uint] = ACTIONS(4538),
    [sym_long] = ACTIONS(4538),
    [sym_ulong] = ACTIONS(4538),
    [sym_cent] = ACTIONS(4538),
    [sym_ucent] = ACTIONS(4538),
    [sym_wchar] = ACTIONS(4538),
    [sym_dchar] = ACTIONS(4538),
    [sym_float] = ACTIONS(4538),
    [sym_double] = ACTIONS(4538),
    [sym_real] = ACTIONS(4538),
    [sym_ifloat] = ACTIONS(4538),
    [sym_idouble] = ACTIONS(4538),
    [sym_ireal] = ACTIONS(4538),
    [sym_cfloat] = ACTIONS(4538),
    [sym_cdouble] = ACTIONS(4538),
    [sym_creal] = ACTIONS(4538),
    [sym_size_t] = ACTIONS(4538),
    [sym_ptrdiff_t] = ACTIONS(4538),
    [sym_string] = ACTIONS(4538),
    [sym_cstring] = ACTIONS(4538),
    [sym_dstring] = ACTIONS(4538),
    [sym_wstring] = ACTIONS(4538),
    [sym_noreturn] = ACTIONS(4538),
    [sym_true] = ACTIONS(4538),
    [sym_false] = ACTIONS(4538),
    [sym_null] = ACTIONS(4538),
    [sym_super] = ACTIONS(4538),
    [sym_this] = ACTIONS(4538),
    [sym_abstract] = ACTIONS(4538),
    [sym_alias] = ACTIONS(4538),
    [sym_align] = ACTIONS(4538),
    [sym_asm] = ACTIONS(4538),
    [sym_assert] = ACTIONS(4538),
    [sym_auto] = ACTIONS(4538),
    [sym_break] = ACTIONS(4538),
    [sym_case] = ACTIONS(4538),
    [sym_cast] = ACTIONS(4538),
    [sym_class] = ACTIONS(4538),
    [sym_const] = ACTIONS(4538),
    [sym_continue] = ACTIONS(4538),
    [sym_debug] = ACTIONS(4538),
    [sym_default] = ACTIONS(4538),
    [sym_delegate] = ACTIONS(4538),
    [sym_delete] = ACTIONS(4538),
    [sym_deprecated] = ACTIONS(4538),
    [sym_do] = ACTIONS(4538),
    [sym_else] = ACTIONS(4538),
    [sym_enum] = ACTIONS(4538),
    [sym_export] = ACTIONS(4538),
    [sym_extern] = ACTIONS(4538),
    [sym_final] = ACTIONS(4538),
    [sym_for] = ACTIONS(4538),
    [sym_foreach] = ACTIONS(4538),
    [sym_foreach_reverse] = ACTIONS(4538),
    [sym_function] = ACTIONS(4538),
    [sym_goto] = ACTIONS(4538),
    [sym_if] = ACTIONS(4538),
    [sym_immutable] = ACTIONS(4538),
    [sym_import] = ACTIONS(4538),
    [sym_in] = ACTIONS(4538),
    [sym_inout] = ACTIONS(4538),
    [sym_interface] = ACTIONS(4538),
    [sym_invariant] = ACTIONS(4538),
    [sym_is] = ACTIONS(4538),
    [sym_mixin] = ACTIONS(4538),
    [sym_new] = ACTIONS(4538),
    [sym_nothrow] = ACTIONS(4538),
    [sym_out] = ACTIONS(4538),
    [sym_override] = ACTIONS(4538),
    [sym_package] = ACTIONS(4538),
    [sym_pragma] = ACTIONS(4538),
    [sym_private] = ACTIONS(4538),
    [sym_protected] = ACTIONS(4538),
    [sym_public] = ACTIONS(4538),
    [sym_pure] = ACTIONS(4538),
    [sym_ref] = ACTIONS(4538),
    [sym_return] = ACTIONS(4538),
    [sym_scope] = ACTIONS(4538),
    [sym_shared] = ACTIONS(4538),
    [sym_static] = ACTIONS(4538),
    [sym_struct] = ACTIONS(4538),
    [sym_switch] = ACTIONS(4538),
    [sym_synchronized] = ACTIONS(4538),
    [sym_template] = ACTIONS(4538),
    [sym_throw] = ACTIONS(4538),
    [sym_try] = ACTIONS(4538),
    [sym_typeid] = ACTIONS(4538),
    [sym_typeof] = ACTIONS(4538),
    [sym_union] = ACTIONS(4538),
    [sym_unittest] = ACTIONS(4538),
    [sym_version] = ACTIONS(4538),
    [sym_while] = ACTIONS(4538),
    [sym_with] = ACTIONS(4538),
    [sym_gshared] = ACTIONS(4538),
    [sym_traits] = ACTIONS(4538),
    [sym_vector] = ACTIONS(4538),
    [sym_void] = ACTIONS(4538),
    [anon_sym_BQUOTE] = ACTIONS(4540),
    [anon_sym_r_DQUOTE] = ACTIONS(4540),
    [anon_sym_x_DQUOTE] = ACTIONS(4540),
    [anon_sym_DQUOTE] = ACTIONS(4540),
    [anon_sym_i_BQUOTE] = ACTIONS(4540),
    [anon_sym_i_DQUOTE] = ACTIONS(4540),
    [anon_sym_iq_LBRACE] = ACTIONS(4540),
    [aux_sym_char_literal_token1] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4538),
    [anon_sym___DATE__] = ACTIONS(4538),
    [anon_sym___FILE__] = ACTIONS(4538),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4538),
    [anon_sym___FUNCTION__] = ACTIONS(4538),
    [anon_sym___LINE__] = ACTIONS(4538),
    [anon_sym___MODULE__] = ACTIONS(4538),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4538),
    [anon_sym___TIME__] = ACTIONS(4538),
    [anon_sym___TIMESTAMP__] = ACTIONS(4538),
    [anon_sym___VENDOR__] = ACTIONS(4538),
    [anon_sym___VERSION__] = ACTIONS(4538),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4540),
    [sym_float_literal] = ACTIONS(4540),
    [sym__string] = ACTIONS(4540),
  },
  [1625] = {
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_q_LBRACE] = ACTIONS(4356),
    [anon_sym_RBRACE] = ACTIONS(4356),
    [anon_sym_LBRACE] = ACTIONS(4356),
    [anon_sym_DOT] = ACTIONS(4356),
    [anon_sym_AMP] = ACTIONS(4356),
    [anon_sym_DASH] = ACTIONS(4354),
    [anon_sym_DASH_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4354),
    [anon_sym_PLUS_PLUS] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4356),
    [anon_sym_LPAREN] = ACTIONS(4356),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(4356),
    [anon_sym_SEMI] = ACTIONS(4356),
    [anon_sym_DOLLAR] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4356),
    [anon_sym_AT] = ACTIONS(4356),
    [sym_bool] = ACTIONS(4354),
    [sym_byte] = ACTIONS(4354),
    [sym_ubyte] = ACTIONS(4354),
    [sym_char] = ACTIONS(4354),
    [sym_short] = ACTIONS(4354),
    [sym_ushort] = ACTIONS(4354),
    [sym_int] = ACTIONS(4354),
    [sym_uint] = ACTIONS(4354),
    [sym_long] = ACTIONS(4354),
    [sym_ulong] = ACTIONS(4354),
    [sym_cent] = ACTIONS(4354),
    [sym_ucent] = ACTIONS(4354),
    [sym_wchar] = ACTIONS(4354),
    [sym_dchar] = ACTIONS(4354),
    [sym_float] = ACTIONS(4354),
    [sym_double] = ACTIONS(4354),
    [sym_real] = ACTIONS(4354),
    [sym_ifloat] = ACTIONS(4354),
    [sym_idouble] = ACTIONS(4354),
    [sym_ireal] = ACTIONS(4354),
    [sym_cfloat] = ACTIONS(4354),
    [sym_cdouble] = ACTIONS(4354),
    [sym_creal] = ACTIONS(4354),
    [sym_size_t] = ACTIONS(4354),
    [sym_ptrdiff_t] = ACTIONS(4354),
    [sym_string] = ACTIONS(4354),
    [sym_cstring] = ACTIONS(4354),
    [sym_dstring] = ACTIONS(4354),
    [sym_wstring] = ACTIONS(4354),
    [sym_noreturn] = ACTIONS(4354),
    [sym_true] = ACTIONS(4354),
    [sym_false] = ACTIONS(4354),
    [sym_null] = ACTIONS(4354),
    [sym_super] = ACTIONS(4354),
    [sym_this] = ACTIONS(4354),
    [sym_abstract] = ACTIONS(4354),
    [sym_alias] = ACTIONS(4354),
    [sym_align] = ACTIONS(4354),
    [sym_asm] = ACTIONS(4354),
    [sym_assert] = ACTIONS(4354),
    [sym_auto] = ACTIONS(4354),
    [sym_break] = ACTIONS(4354),
    [sym_case] = ACTIONS(4354),
    [sym_cast] = ACTIONS(4354),
    [sym_class] = ACTIONS(4354),
    [sym_const] = ACTIONS(4354),
    [sym_continue] = ACTIONS(4354),
    [sym_debug] = ACTIONS(4354),
    [sym_default] = ACTIONS(4354),
    [sym_delegate] = ACTIONS(4354),
    [sym_delete] = ACTIONS(4354),
    [sym_deprecated] = ACTIONS(4354),
    [sym_do] = ACTIONS(4354),
    [sym_else] = ACTIONS(4354),
    [sym_enum] = ACTIONS(4354),
    [sym_export] = ACTIONS(4354),
    [sym_extern] = ACTIONS(4354),
    [sym_final] = ACTIONS(4354),
    [sym_for] = ACTIONS(4354),
    [sym_foreach] = ACTIONS(4354),
    [sym_foreach_reverse] = ACTIONS(4354),
    [sym_function] = ACTIONS(4354),
    [sym_goto] = ACTIONS(4354),
    [sym_if] = ACTIONS(4354),
    [sym_immutable] = ACTIONS(4354),
    [sym_import] = ACTIONS(4354),
    [sym_in] = ACTIONS(4354),
    [sym_inout] = ACTIONS(4354),
    [sym_interface] = ACTIONS(4354),
    [sym_invariant] = ACTIONS(4354),
    [sym_is] = ACTIONS(4354),
    [sym_mixin] = ACTIONS(4354),
    [sym_new] = ACTIONS(4354),
    [sym_nothrow] = ACTIONS(4354),
    [sym_out] = ACTIONS(4354),
    [sym_override] = ACTIONS(4354),
    [sym_package] = ACTIONS(4354),
    [sym_pragma] = ACTIONS(4354),
    [sym_private] = ACTIONS(4354),
    [sym_protected] = ACTIONS(4354),
    [sym_public] = ACTIONS(4354),
    [sym_pure] = ACTIONS(4354),
    [sym_ref] = ACTIONS(4354),
    [sym_return] = ACTIONS(4354),
    [sym_scope] = ACTIONS(4354),
    [sym_shared] = ACTIONS(4354),
    [sym_static] = ACTIONS(4354),
    [sym_struct] = ACTIONS(4354),
    [sym_switch] = ACTIONS(4354),
    [sym_synchronized] = ACTIONS(4354),
    [sym_template] = ACTIONS(4354),
    [sym_throw] = ACTIONS(4354),
    [sym_try] = ACTIONS(4354),
    [sym_typeid] = ACTIONS(4354),
    [sym_typeof] = ACTIONS(4354),
    [sym_union] = ACTIONS(4354),
    [sym_unittest] = ACTIONS(4354),
    [sym_version] = ACTIONS(4354),
    [sym_while] = ACTIONS(4354),
    [sym_with] = ACTIONS(4354),
    [sym_gshared] = ACTIONS(4354),
    [sym_traits] = ACTIONS(4354),
    [sym_vector] = ACTIONS(4354),
    [sym_void] = ACTIONS(4354),
    [anon_sym_BQUOTE] = ACTIONS(4356),
    [anon_sym_r_DQUOTE] = ACTIONS(4356),
    [anon_sym_x_DQUOTE] = ACTIONS(4356),
    [anon_sym_DQUOTE] = ACTIONS(4356),
    [anon_sym_i_BQUOTE] = ACTIONS(4356),
    [anon_sym_i_DQUOTE] = ACTIONS(4356),
    [anon_sym_iq_LBRACE] = ACTIONS(4356),
    [aux_sym_char_literal_token1] = ACTIONS(4356),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym___DATE__] = ACTIONS(4354),
    [anon_sym___FILE__] = ACTIONS(4354),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4354),
    [anon_sym___FUNCTION__] = ACTIONS(4354),
    [anon_sym___LINE__] = ACTIONS(4354),
    [anon_sym___MODULE__] = ACTIONS(4354),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4354),
    [anon_sym___TIME__] = ACTIONS(4354),
    [anon_sym___TIMESTAMP__] = ACTIONS(4354),
    [anon_sym___VENDOR__] = ACTIONS(4354),
    [anon_sym___VERSION__] = ACTIONS(4354),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4356),
    [sym_float_literal] = ACTIONS(4356),
    [sym__string] = ACTIONS(4356),
  },
  [1626] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_RBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_AT] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_abstract] = ACTIONS(4682),
    [sym_alias] = ACTIONS(4682),
    [sym_align] = ACTIONS(4682),
    [sym_asm] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_break] = ACTIONS(4682),
    [sym_case] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_class] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_continue] = ACTIONS(4682),
    [sym_debug] = ACTIONS(4682),
    [sym_default] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_deprecated] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(5026),
    [sym_enum] = ACTIONS(4682),
    [sym_export] = ACTIONS(4682),
    [sym_extern] = ACTIONS(4682),
    [sym_final] = ACTIONS(4682),
    [sym_for] = ACTIONS(4682),
    [sym_foreach] = ACTIONS(4682),
    [sym_foreach_reverse] = ACTIONS(4682),
    [sym_function] = ACTIONS(4682),
    [sym_goto] = ACTIONS(4682),
    [sym_if] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_interface] = ACTIONS(4682),
    [sym_invariant] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_nothrow] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_override] = ACTIONS(4682),
    [sym_package] = ACTIONS(4682),
    [sym_pragma] = ACTIONS(4682),
    [sym_private] = ACTIONS(4682),
    [sym_protected] = ACTIONS(4682),
    [sym_public] = ACTIONS(4682),
    [sym_pure] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_return] = ACTIONS(4682),
    [sym_scope] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_static] = ACTIONS(4682),
    [sym_struct] = ACTIONS(4682),
    [sym_switch] = ACTIONS(4682),
    [sym_synchronized] = ACTIONS(4682),
    [sym_template] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_try] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_union] = ACTIONS(4682),
    [sym_unittest] = ACTIONS(4682),
    [sym_version] = ACTIONS(4682),
    [sym_while] = ACTIONS(4682),
    [sym_with] = ACTIONS(4682),
    [sym_gshared] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [1627] = {
    [sym_identifier] = ACTIONS(4678),
    [anon_sym_q_LBRACE] = ACTIONS(4680),
    [anon_sym_RBRACE] = ACTIONS(4680),
    [anon_sym_LBRACE] = ACTIONS(4680),
    [anon_sym_DOT] = ACTIONS(4680),
    [anon_sym_AMP] = ACTIONS(4680),
    [anon_sym_DASH] = ACTIONS(4678),
    [anon_sym_DASH_DASH] = ACTIONS(4680),
    [anon_sym_PLUS] = ACTIONS(4678),
    [anon_sym_PLUS_PLUS] = ACTIONS(4680),
    [anon_sym_BANG] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4680),
    [anon_sym_RPAREN] = ACTIONS(4680),
    [anon_sym_LBRACK] = ACTIONS(4680),
    [anon_sym_SEMI] = ACTIONS(4680),
    [anon_sym_DOLLAR] = ACTIONS(4680),
    [anon_sym_STAR] = ACTIONS(4680),
    [anon_sym_TILDE] = ACTIONS(4680),
    [anon_sym_AT] = ACTIONS(4680),
    [sym_bool] = ACTIONS(4678),
    [sym_byte] = ACTIONS(4678),
    [sym_ubyte] = ACTIONS(4678),
    [sym_char] = ACTIONS(4678),
    [sym_short] = ACTIONS(4678),
    [sym_ushort] = ACTIONS(4678),
    [sym_int] = ACTIONS(4678),
    [sym_uint] = ACTIONS(4678),
    [sym_long] = ACTIONS(4678),
    [sym_ulong] = ACTIONS(4678),
    [sym_cent] = ACTIONS(4678),
    [sym_ucent] = ACTIONS(4678),
    [sym_wchar] = ACTIONS(4678),
    [sym_dchar] = ACTIONS(4678),
    [sym_float] = ACTIONS(4678),
    [sym_double] = ACTIONS(4678),
    [sym_real] = ACTIONS(4678),
    [sym_ifloat] = ACTIONS(4678),
    [sym_idouble] = ACTIONS(4678),
    [sym_ireal] = ACTIONS(4678),
    [sym_cfloat] = ACTIONS(4678),
    [sym_cdouble] = ACTIONS(4678),
    [sym_creal] = ACTIONS(4678),
    [sym_size_t] = ACTIONS(4678),
    [sym_ptrdiff_t] = ACTIONS(4678),
    [sym_string] = ACTIONS(4678),
    [sym_cstring] = ACTIONS(4678),
    [sym_dstring] = ACTIONS(4678),
    [sym_wstring] = ACTIONS(4678),
    [sym_noreturn] = ACTIONS(4678),
    [sym_true] = ACTIONS(4678),
    [sym_false] = ACTIONS(4678),
    [sym_null] = ACTIONS(4678),
    [sym_super] = ACTIONS(4678),
    [sym_this] = ACTIONS(4678),
    [sym_abstract] = ACTIONS(4678),
    [sym_alias] = ACTIONS(4678),
    [sym_align] = ACTIONS(4678),
    [sym_asm] = ACTIONS(4678),
    [sym_assert] = ACTIONS(4678),
    [sym_auto] = ACTIONS(4678),
    [sym_break] = ACTIONS(4678),
    [sym_case] = ACTIONS(4678),
    [sym_cast] = ACTIONS(4678),
    [sym_class] = ACTIONS(4678),
    [sym_const] = ACTIONS(4678),
    [sym_continue] = ACTIONS(4678),
    [sym_debug] = ACTIONS(4678),
    [sym_default] = ACTIONS(4678),
    [sym_delegate] = ACTIONS(4678),
    [sym_delete] = ACTIONS(4678),
    [sym_deprecated] = ACTIONS(4678),
    [sym_do] = ACTIONS(4678),
    [sym_else] = ACTIONS(4678),
    [sym_enum] = ACTIONS(4678),
    [sym_export] = ACTIONS(4678),
    [sym_extern] = ACTIONS(4678),
    [sym_final] = ACTIONS(4678),
    [sym_for] = ACTIONS(4678),
    [sym_foreach] = ACTIONS(4678),
    [sym_foreach_reverse] = ACTIONS(4678),
    [sym_function] = ACTIONS(4678),
    [sym_goto] = ACTIONS(4678),
    [sym_if] = ACTIONS(4678),
    [sym_immutable] = ACTIONS(4678),
    [sym_import] = ACTIONS(4678),
    [sym_in] = ACTIONS(4678),
    [sym_inout] = ACTIONS(4678),
    [sym_interface] = ACTIONS(4678),
    [sym_invariant] = ACTIONS(4678),
    [sym_is] = ACTIONS(4678),
    [sym_mixin] = ACTIONS(4678),
    [sym_new] = ACTIONS(4678),
    [sym_nothrow] = ACTIONS(4678),
    [sym_out] = ACTIONS(4678),
    [sym_override] = ACTIONS(4678),
    [sym_package] = ACTIONS(4678),
    [sym_pragma] = ACTIONS(4678),
    [sym_private] = ACTIONS(4678),
    [sym_protected] = ACTIONS(4678),
    [sym_public] = ACTIONS(4678),
    [sym_pure] = ACTIONS(4678),
    [sym_ref] = ACTIONS(4678),
    [sym_return] = ACTIONS(4678),
    [sym_scope] = ACTIONS(4678),
    [sym_shared] = ACTIONS(4678),
    [sym_static] = ACTIONS(4678),
    [sym_struct] = ACTIONS(4678),
    [sym_switch] = ACTIONS(4678),
    [sym_synchronized] = ACTIONS(4678),
    [sym_template] = ACTIONS(4678),
    [sym_throw] = ACTIONS(4678),
    [sym_try] = ACTIONS(4678),
    [sym_typeid] = ACTIONS(4678),
    [sym_typeof] = ACTIONS(4678),
    [sym_union] = ACTIONS(4678),
    [sym_unittest] = ACTIONS(4678),
    [sym_version] = ACTIONS(4678),
    [sym_while] = ACTIONS(4678),
    [sym_with] = ACTIONS(4678),
    [sym_gshared] = ACTIONS(4678),
    [sym_traits] = ACTIONS(4678),
    [sym_vector] = ACTIONS(4678),
    [sym_void] = ACTIONS(4678),
    [anon_sym_BQUOTE] = ACTIONS(4680),
    [anon_sym_r_DQUOTE] = ACTIONS(4680),
    [anon_sym_x_DQUOTE] = ACTIONS(4680),
    [anon_sym_DQUOTE] = ACTIONS(4680),
    [anon_sym_i_BQUOTE] = ACTIONS(4680),
    [anon_sym_i_DQUOTE] = ACTIONS(4680),
    [anon_sym_iq_LBRACE] = ACTIONS(4680),
    [aux_sym_char_literal_token1] = ACTIONS(4680),
    [anon_sym_SQUOTE] = ACTIONS(4678),
    [anon_sym___DATE__] = ACTIONS(4678),
    [anon_sym___FILE__] = ACTIONS(4678),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4678),
    [anon_sym___FUNCTION__] = ACTIONS(4678),
    [anon_sym___LINE__] = ACTIONS(4678),
    [anon_sym___MODULE__] = ACTIONS(4678),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4678),
    [anon_sym___TIME__] = ACTIONS(4678),
    [anon_sym___TIMESTAMP__] = ACTIONS(4678),
    [anon_sym___VENDOR__] = ACTIONS(4678),
    [anon_sym___VERSION__] = ACTIONS(4678),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4680),
    [sym_float_literal] = ACTIONS(4680),
    [sym__string] = ACTIONS(4680),
  },
  [1628] = {
    [sym_identifier] = ACTIONS(4510),
    [anon_sym_q_LBRACE] = ACTIONS(4512),
    [anon_sym_RBRACE] = ACTIONS(4512),
    [anon_sym_LBRACE] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4512),
    [anon_sym_DASH] = ACTIONS(4510),
    [anon_sym_DASH_DASH] = ACTIONS(4512),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_PLUS_PLUS] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4512),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_SEMI] = ACTIONS(4512),
    [anon_sym_DOLLAR] = ACTIONS(4512),
    [anon_sym_STAR] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4512),
    [anon_sym_AT] = ACTIONS(4512),
    [sym_bool] = ACTIONS(4510),
    [sym_byte] = ACTIONS(4510),
    [sym_ubyte] = ACTIONS(4510),
    [sym_char] = ACTIONS(4510),
    [sym_short] = ACTIONS(4510),
    [sym_ushort] = ACTIONS(4510),
    [sym_int] = ACTIONS(4510),
    [sym_uint] = ACTIONS(4510),
    [sym_long] = ACTIONS(4510),
    [sym_ulong] = ACTIONS(4510),
    [sym_cent] = ACTIONS(4510),
    [sym_ucent] = ACTIONS(4510),
    [sym_wchar] = ACTIONS(4510),
    [sym_dchar] = ACTIONS(4510),
    [sym_float] = ACTIONS(4510),
    [sym_double] = ACTIONS(4510),
    [sym_real] = ACTIONS(4510),
    [sym_ifloat] = ACTIONS(4510),
    [sym_idouble] = ACTIONS(4510),
    [sym_ireal] = ACTIONS(4510),
    [sym_cfloat] = ACTIONS(4510),
    [sym_cdouble] = ACTIONS(4510),
    [sym_creal] = ACTIONS(4510),
    [sym_size_t] = ACTIONS(4510),
    [sym_ptrdiff_t] = ACTIONS(4510),
    [sym_string] = ACTIONS(4510),
    [sym_cstring] = ACTIONS(4510),
    [sym_dstring] = ACTIONS(4510),
    [sym_wstring] = ACTIONS(4510),
    [sym_noreturn] = ACTIONS(4510),
    [sym_true] = ACTIONS(4510),
    [sym_false] = ACTIONS(4510),
    [sym_null] = ACTIONS(4510),
    [sym_super] = ACTIONS(4510),
    [sym_this] = ACTIONS(4510),
    [sym_abstract] = ACTIONS(4510),
    [sym_alias] = ACTIONS(4510),
    [sym_align] = ACTIONS(4510),
    [sym_asm] = ACTIONS(4510),
    [sym_assert] = ACTIONS(4510),
    [sym_auto] = ACTIONS(4510),
    [sym_break] = ACTIONS(4510),
    [sym_case] = ACTIONS(4510),
    [sym_cast] = ACTIONS(4510),
    [sym_class] = ACTIONS(4510),
    [sym_const] = ACTIONS(4510),
    [sym_continue] = ACTIONS(4510),
    [sym_debug] = ACTIONS(4510),
    [sym_default] = ACTIONS(4510),
    [sym_delegate] = ACTIONS(4510),
    [sym_delete] = ACTIONS(4510),
    [sym_deprecated] = ACTIONS(4510),
    [sym_do] = ACTIONS(4510),
    [sym_else] = ACTIONS(4510),
    [sym_enum] = ACTIONS(4510),
    [sym_export] = ACTIONS(4510),
    [sym_extern] = ACTIONS(4510),
    [sym_final] = ACTIONS(4510),
    [sym_for] = ACTIONS(4510),
    [sym_foreach] = ACTIONS(4510),
    [sym_foreach_reverse] = ACTIONS(4510),
    [sym_function] = ACTIONS(4510),
    [sym_goto] = ACTIONS(4510),
    [sym_if] = ACTIONS(4510),
    [sym_immutable] = ACTIONS(4510),
    [sym_import] = ACTIONS(4510),
    [sym_in] = ACTIONS(4510),
    [sym_inout] = ACTIONS(4510),
    [sym_interface] = ACTIONS(4510),
    [sym_invariant] = ACTIONS(4510),
    [sym_is] = ACTIONS(4510),
    [sym_mixin] = ACTIONS(4510),
    [sym_new] = ACTIONS(4510),
    [sym_nothrow] = ACTIONS(4510),
    [sym_out] = ACTIONS(4510),
    [sym_override] = ACTIONS(4510),
    [sym_package] = ACTIONS(4510),
    [sym_pragma] = ACTIONS(4510),
    [sym_private] = ACTIONS(4510),
    [sym_protected] = ACTIONS(4510),
    [sym_public] = ACTIONS(4510),
    [sym_pure] = ACTIONS(4510),
    [sym_ref] = ACTIONS(4510),
    [sym_return] = ACTIONS(4510),
    [sym_scope] = ACTIONS(4510),
    [sym_shared] = ACTIONS(4510),
    [sym_static] = ACTIONS(4510),
    [sym_struct] = ACTIONS(4510),
    [sym_switch] = ACTIONS(4510),
    [sym_synchronized] = ACTIONS(4510),
    [sym_template] = ACTIONS(4510),
    [sym_throw] = ACTIONS(4510),
    [sym_try] = ACTIONS(4510),
    [sym_typeid] = ACTIONS(4510),
    [sym_typeof] = ACTIONS(4510),
    [sym_union] = ACTIONS(4510),
    [sym_unittest] = ACTIONS(4510),
    [sym_version] = ACTIONS(4510),
    [sym_while] = ACTIONS(4510),
    [sym_with] = ACTIONS(4510),
    [sym_gshared] = ACTIONS(4510),
    [sym_traits] = ACTIONS(4510),
    [sym_vector] = ACTIONS(4510),
    [sym_void] = ACTIONS(4510),
    [anon_sym_BQUOTE] = ACTIONS(4512),
    [anon_sym_r_DQUOTE] = ACTIONS(4512),
    [anon_sym_x_DQUOTE] = ACTIONS(4512),
    [anon_sym_DQUOTE] = ACTIONS(4512),
    [anon_sym_i_BQUOTE] = ACTIONS(4512),
    [anon_sym_i_DQUOTE] = ACTIONS(4512),
    [anon_sym_iq_LBRACE] = ACTIONS(4512),
    [aux_sym_char_literal_token1] = ACTIONS(4512),
    [anon_sym_SQUOTE] = ACTIONS(4510),
    [anon_sym___DATE__] = ACTIONS(4510),
    [anon_sym___FILE__] = ACTIONS(4510),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4510),
    [anon_sym___FUNCTION__] = ACTIONS(4510),
    [anon_sym___LINE__] = ACTIONS(4510),
    [anon_sym___MODULE__] = ACTIONS(4510),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4510),
    [anon_sym___TIME__] = ACTIONS(4510),
    [anon_sym___TIMESTAMP__] = ACTIONS(4510),
    [anon_sym___VENDOR__] = ACTIONS(4510),
    [anon_sym___VERSION__] = ACTIONS(4510),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4512),
    [sym_float_literal] = ACTIONS(4512),
    [sym__string] = ACTIONS(4512),
  },
  [1629] = {
    [sym_identifier] = ACTIONS(4668),
    [anon_sym_q_LBRACE] = ACTIONS(4670),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_LBRACE] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_AMP] = ACTIONS(4670),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_DOLLAR] = ACTIONS(4670),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(4670),
    [anon_sym_AT] = ACTIONS(4670),
    [sym_bool] = ACTIONS(4668),
    [sym_byte] = ACTIONS(4668),
    [sym_ubyte] = ACTIONS(4668),
    [sym_char] = ACTIONS(4668),
    [sym_short] = ACTIONS(4668),
    [sym_ushort] = ACTIONS(4668),
    [sym_int] = ACTIONS(4668),
    [sym_uint] = ACTIONS(4668),
    [sym_long] = ACTIONS(4668),
    [sym_ulong] = ACTIONS(4668),
    [sym_cent] = ACTIONS(4668),
    [sym_ucent] = ACTIONS(4668),
    [sym_wchar] = ACTIONS(4668),
    [sym_dchar] = ACTIONS(4668),
    [sym_float] = ACTIONS(4668),
    [sym_double] = ACTIONS(4668),
    [sym_real] = ACTIONS(4668),
    [sym_ifloat] = ACTIONS(4668),
    [sym_idouble] = ACTIONS(4668),
    [sym_ireal] = ACTIONS(4668),
    [sym_cfloat] = ACTIONS(4668),
    [sym_cdouble] = ACTIONS(4668),
    [sym_creal] = ACTIONS(4668),
    [sym_size_t] = ACTIONS(4668),
    [sym_ptrdiff_t] = ACTIONS(4668),
    [sym_string] = ACTIONS(4668),
    [sym_cstring] = ACTIONS(4668),
    [sym_dstring] = ACTIONS(4668),
    [sym_wstring] = ACTIONS(4668),
    [sym_noreturn] = ACTIONS(4668),
    [sym_true] = ACTIONS(4668),
    [sym_false] = ACTIONS(4668),
    [sym_null] = ACTIONS(4668),
    [sym_super] = ACTIONS(4668),
    [sym_this] = ACTIONS(4668),
    [sym_abstract] = ACTIONS(4668),
    [sym_alias] = ACTIONS(4668),
    [sym_align] = ACTIONS(4668),
    [sym_asm] = ACTIONS(4668),
    [sym_assert] = ACTIONS(4668),
    [sym_auto] = ACTIONS(4668),
    [sym_break] = ACTIONS(4668),
    [sym_case] = ACTIONS(4668),
    [sym_cast] = ACTIONS(4668),
    [sym_class] = ACTIONS(4668),
    [sym_const] = ACTIONS(4668),
    [sym_continue] = ACTIONS(4668),
    [sym_debug] = ACTIONS(4668),
    [sym_default] = ACTIONS(4668),
    [sym_delegate] = ACTIONS(4668),
    [sym_delete] = ACTIONS(4668),
    [sym_deprecated] = ACTIONS(4668),
    [sym_do] = ACTIONS(4668),
    [sym_else] = ACTIONS(4668),
    [sym_enum] = ACTIONS(4668),
    [sym_export] = ACTIONS(4668),
    [sym_extern] = ACTIONS(4668),
    [sym_final] = ACTIONS(4668),
    [sym_for] = ACTIONS(4668),
    [sym_foreach] = ACTIONS(4668),
    [sym_foreach_reverse] = ACTIONS(4668),
    [sym_function] = ACTIONS(4668),
    [sym_goto] = ACTIONS(4668),
    [sym_if] = ACTIONS(4668),
    [sym_immutable] = ACTIONS(4668),
    [sym_import] = ACTIONS(4668),
    [sym_in] = ACTIONS(4668),
    [sym_inout] = ACTIONS(4668),
    [sym_interface] = ACTIONS(4668),
    [sym_invariant] = ACTIONS(4668),
    [sym_is] = ACTIONS(4668),
    [sym_mixin] = ACTIONS(4668),
    [sym_new] = ACTIONS(4668),
    [sym_nothrow] = ACTIONS(4668),
    [sym_out] = ACTIONS(4668),
    [sym_override] = ACTIONS(4668),
    [sym_package] = ACTIONS(4668),
    [sym_pragma] = ACTIONS(4668),
    [sym_private] = ACTIONS(4668),
    [sym_protected] = ACTIONS(4668),
    [sym_public] = ACTIONS(4668),
    [sym_pure] = ACTIONS(4668),
    [sym_ref] = ACTIONS(4668),
    [sym_return] = ACTIONS(4668),
    [sym_scope] = ACTIONS(4668),
    [sym_shared] = ACTIONS(4668),
    [sym_static] = ACTIONS(4668),
    [sym_struct] = ACTIONS(4668),
    [sym_switch] = ACTIONS(4668),
    [sym_synchronized] = ACTIONS(4668),
    [sym_template] = ACTIONS(4668),
    [sym_throw] = ACTIONS(4668),
    [sym_try] = ACTIONS(4668),
    [sym_typeid] = ACTIONS(4668),
    [sym_typeof] = ACTIONS(4668),
    [sym_union] = ACTIONS(4668),
    [sym_unittest] = ACTIONS(4668),
    [sym_version] = ACTIONS(4668),
    [sym_while] = ACTIONS(4668),
    [sym_with] = ACTIONS(4668),
    [sym_gshared] = ACTIONS(4668),
    [sym_traits] = ACTIONS(4668),
    [sym_vector] = ACTIONS(4668),
    [sym_void] = ACTIONS(4668),
    [anon_sym_BQUOTE] = ACTIONS(4670),
    [anon_sym_r_DQUOTE] = ACTIONS(4670),
    [anon_sym_x_DQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4670),
    [anon_sym_i_BQUOTE] = ACTIONS(4670),
    [anon_sym_i_DQUOTE] = ACTIONS(4670),
    [anon_sym_iq_LBRACE] = ACTIONS(4670),
    [aux_sym_char_literal_token1] = ACTIONS(4670),
    [anon_sym_SQUOTE] = ACTIONS(4668),
    [anon_sym___DATE__] = ACTIONS(4668),
    [anon_sym___FILE__] = ACTIONS(4668),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4668),
    [anon_sym___FUNCTION__] = ACTIONS(4668),
    [anon_sym___LINE__] = ACTIONS(4668),
    [anon_sym___MODULE__] = ACTIONS(4668),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4668),
    [anon_sym___TIME__] = ACTIONS(4668),
    [anon_sym___TIMESTAMP__] = ACTIONS(4668),
    [anon_sym___VENDOR__] = ACTIONS(4668),
    [anon_sym___VERSION__] = ACTIONS(4668),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4670),
    [sym_float_literal] = ACTIONS(4670),
    [sym__string] = ACTIONS(4670),
  },
  [1630] = {
    [sym_identifier] = ACTIONS(4672),
    [anon_sym_q_LBRACE] = ACTIONS(4675),
    [anon_sym_RBRACE] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(4675),
    [anon_sym_DOT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(4675),
    [anon_sym_DASH] = ACTIONS(4672),
    [anon_sym_DASH_DASH] = ACTIONS(4675),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_PLUS_PLUS] = ACTIONS(4675),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym_RPAREN] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(4675),
    [anon_sym_SEMI] = ACTIONS(4675),
    [anon_sym_DOLLAR] = ACTIONS(4675),
    [anon_sym_STAR] = ACTIONS(4675),
    [anon_sym_TILDE] = ACTIONS(4675),
    [anon_sym_AT] = ACTIONS(4675),
    [sym_bool] = ACTIONS(4672),
    [sym_byte] = ACTIONS(4672),
    [sym_ubyte] = ACTIONS(4672),
    [sym_char] = ACTIONS(4672),
    [sym_short] = ACTIONS(4672),
    [sym_ushort] = ACTIONS(4672),
    [sym_int] = ACTIONS(4672),
    [sym_uint] = ACTIONS(4672),
    [sym_long] = ACTIONS(4672),
    [sym_ulong] = ACTIONS(4672),
    [sym_cent] = ACTIONS(4672),
    [sym_ucent] = ACTIONS(4672),
    [sym_wchar] = ACTIONS(4672),
    [sym_dchar] = ACTIONS(4672),
    [sym_float] = ACTIONS(4672),
    [sym_double] = ACTIONS(4672),
    [sym_real] = ACTIONS(4672),
    [sym_ifloat] = ACTIONS(4672),
    [sym_idouble] = ACTIONS(4672),
    [sym_ireal] = ACTIONS(4672),
    [sym_cfloat] = ACTIONS(4672),
    [sym_cdouble] = ACTIONS(4672),
    [sym_creal] = ACTIONS(4672),
    [sym_size_t] = ACTIONS(4672),
    [sym_ptrdiff_t] = ACTIONS(4672),
    [sym_string] = ACTIONS(4672),
    [sym_cstring] = ACTIONS(4672),
    [sym_dstring] = ACTIONS(4672),
    [sym_wstring] = ACTIONS(4672),
    [sym_noreturn] = ACTIONS(4672),
    [sym_true] = ACTIONS(4672),
    [sym_false] = ACTIONS(4672),
    [sym_null] = ACTIONS(4672),
    [sym_super] = ACTIONS(4672),
    [sym_this] = ACTIONS(4672),
    [sym_abstract] = ACTIONS(4672),
    [sym_alias] = ACTIONS(4672),
    [sym_align] = ACTIONS(4672),
    [sym_asm] = ACTIONS(4672),
    [sym_assert] = ACTIONS(4672),
    [sym_auto] = ACTIONS(4672),
    [sym_break] = ACTIONS(4672),
    [sym_case] = ACTIONS(4672),
    [sym_cast] = ACTIONS(4672),
    [sym_class] = ACTIONS(4672),
    [sym_const] = ACTIONS(4672),
    [sym_continue] = ACTIONS(4672),
    [sym_debug] = ACTIONS(4672),
    [sym_default] = ACTIONS(4672),
    [sym_delegate] = ACTIONS(4672),
    [sym_delete] = ACTIONS(4672),
    [sym_deprecated] = ACTIONS(4672),
    [sym_do] = ACTIONS(4672),
    [sym_else] = ACTIONS(4672),
    [sym_enum] = ACTIONS(4672),
    [sym_export] = ACTIONS(4672),
    [sym_extern] = ACTIONS(4672),
    [sym_final] = ACTIONS(4672),
    [sym_for] = ACTIONS(4672),
    [sym_foreach] = ACTIONS(4672),
    [sym_foreach_reverse] = ACTIONS(4672),
    [sym_function] = ACTIONS(4672),
    [sym_goto] = ACTIONS(4672),
    [sym_if] = ACTIONS(4672),
    [sym_immutable] = ACTIONS(4672),
    [sym_import] = ACTIONS(4672),
    [sym_in] = ACTIONS(4672),
    [sym_inout] = ACTIONS(4672),
    [sym_interface] = ACTIONS(4672),
    [sym_invariant] = ACTIONS(4672),
    [sym_is] = ACTIONS(4672),
    [sym_mixin] = ACTIONS(4672),
    [sym_new] = ACTIONS(4672),
    [sym_nothrow] = ACTIONS(4672),
    [sym_out] = ACTIONS(4672),
    [sym_override] = ACTIONS(4672),
    [sym_package] = ACTIONS(4672),
    [sym_pragma] = ACTIONS(4672),
    [sym_private] = ACTIONS(4672),
    [sym_protected] = ACTIONS(4672),
    [sym_public] = ACTIONS(4672),
    [sym_pure] = ACTIONS(4672),
    [sym_ref] = ACTIONS(4672),
    [sym_return] = ACTIONS(4672),
    [sym_scope] = ACTIONS(4672),
    [sym_shared] = ACTIONS(4672),
    [sym_static] = ACTIONS(4672),
    [sym_struct] = ACTIONS(4672),
    [sym_switch] = ACTIONS(4672),
    [sym_synchronized] = ACTIONS(4672),
    [sym_template] = ACTIONS(4672),
    [sym_throw] = ACTIONS(4672),
    [sym_try] = ACTIONS(4672),
    [sym_typeid] = ACTIONS(4672),
    [sym_typeof] = ACTIONS(4672),
    [sym_union] = ACTIONS(4672),
    [sym_unittest] = ACTIONS(4672),
    [sym_version] = ACTIONS(4672),
    [sym_while] = ACTIONS(4672),
    [sym_with] = ACTIONS(4672),
    [sym_gshared] = ACTIONS(4672),
    [sym_traits] = ACTIONS(4672),
    [sym_vector] = ACTIONS(4672),
    [sym_void] = ACTIONS(4672),
    [anon_sym_BQUOTE] = ACTIONS(4675),
    [anon_sym_r_DQUOTE] = ACTIONS(4675),
    [anon_sym_x_DQUOTE] = ACTIONS(4675),
    [anon_sym_DQUOTE] = ACTIONS(4675),
    [anon_sym_i_BQUOTE] = ACTIONS(4675),
    [anon_sym_i_DQUOTE] = ACTIONS(4675),
    [anon_sym_iq_LBRACE] = ACTIONS(4675),
    [aux_sym_char_literal_token1] = ACTIONS(4675),
    [anon_sym_SQUOTE] = ACTIONS(4672),
    [anon_sym___DATE__] = ACTIONS(4672),
    [anon_sym___FILE__] = ACTIONS(4672),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4672),
    [anon_sym___FUNCTION__] = ACTIONS(4672),
    [anon_sym___LINE__] = ACTIONS(4672),
    [anon_sym___MODULE__] = ACTIONS(4672),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4672),
    [anon_sym___TIME__] = ACTIONS(4672),
    [anon_sym___TIMESTAMP__] = ACTIONS(4672),
    [anon_sym___VENDOR__] = ACTIONS(4672),
    [anon_sym___VERSION__] = ACTIONS(4672),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4675),
    [sym_float_literal] = ACTIONS(4675),
    [sym__string] = ACTIONS(4675),
  },
  [1631] = {
    [sym_identifier] = ACTIONS(4506),
    [anon_sym_q_LBRACE] = ACTIONS(4508),
    [anon_sym_RBRACE] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(4508),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_AMP] = ACTIONS(4508),
    [anon_sym_DASH] = ACTIONS(4506),
    [anon_sym_DASH_DASH] = ACTIONS(4508),
    [anon_sym_PLUS] = ACTIONS(4506),
    [anon_sym_PLUS_PLUS] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(4508),
    [anon_sym_LPAREN] = ACTIONS(4508),
    [anon_sym_RPAREN] = ACTIONS(4508),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_SEMI] = ACTIONS(4508),
    [anon_sym_DOLLAR] = ACTIONS(4508),
    [anon_sym_STAR] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4508),
    [anon_sym_AT] = ACTIONS(4508),
    [sym_bool] = ACTIONS(4506),
    [sym_byte] = ACTIONS(4506),
    [sym_ubyte] = ACTIONS(4506),
    [sym_char] = ACTIONS(4506),
    [sym_short] = ACTIONS(4506),
    [sym_ushort] = ACTIONS(4506),
    [sym_int] = ACTIONS(4506),
    [sym_uint] = ACTIONS(4506),
    [sym_long] = ACTIONS(4506),
    [sym_ulong] = ACTIONS(4506),
    [sym_cent] = ACTIONS(4506),
    [sym_ucent] = ACTIONS(4506),
    [sym_wchar] = ACTIONS(4506),
    [sym_dchar] = ACTIONS(4506),
    [sym_float] = ACTIONS(4506),
    [sym_double] = ACTIONS(4506),
    [sym_real] = ACTIONS(4506),
    [sym_ifloat] = ACTIONS(4506),
    [sym_idouble] = ACTIONS(4506),
    [sym_ireal] = ACTIONS(4506),
    [sym_cfloat] = ACTIONS(4506),
    [sym_cdouble] = ACTIONS(4506),
    [sym_creal] = ACTIONS(4506),
    [sym_size_t] = ACTIONS(4506),
    [sym_ptrdiff_t] = ACTIONS(4506),
    [sym_string] = ACTIONS(4506),
    [sym_cstring] = ACTIONS(4506),
    [sym_dstring] = ACTIONS(4506),
    [sym_wstring] = ACTIONS(4506),
    [sym_noreturn] = ACTIONS(4506),
    [sym_true] = ACTIONS(4506),
    [sym_false] = ACTIONS(4506),
    [sym_null] = ACTIONS(4506),
    [sym_super] = ACTIONS(4506),
    [sym_this] = ACTIONS(4506),
    [sym_abstract] = ACTIONS(4506),
    [sym_alias] = ACTIONS(4506),
    [sym_align] = ACTIONS(4506),
    [sym_asm] = ACTIONS(4506),
    [sym_assert] = ACTIONS(4506),
    [sym_auto] = ACTIONS(4506),
    [sym_break] = ACTIONS(4506),
    [sym_case] = ACTIONS(4506),
    [sym_cast] = ACTIONS(4506),
    [sym_class] = ACTIONS(4506),
    [sym_const] = ACTIONS(4506),
    [sym_continue] = ACTIONS(4506),
    [sym_debug] = ACTIONS(4506),
    [sym_default] = ACTIONS(4506),
    [sym_delegate] = ACTIONS(4506),
    [sym_delete] = ACTIONS(4506),
    [sym_deprecated] = ACTIONS(4506),
    [sym_do] = ACTIONS(4506),
    [sym_else] = ACTIONS(4506),
    [sym_enum] = ACTIONS(4506),
    [sym_export] = ACTIONS(4506),
    [sym_extern] = ACTIONS(4506),
    [sym_final] = ACTIONS(4506),
    [sym_for] = ACTIONS(4506),
    [sym_foreach] = ACTIONS(4506),
    [sym_foreach_reverse] = ACTIONS(4506),
    [sym_function] = ACTIONS(4506),
    [sym_goto] = ACTIONS(4506),
    [sym_if] = ACTIONS(4506),
    [sym_immutable] = ACTIONS(4506),
    [sym_import] = ACTIONS(4506),
    [sym_in] = ACTIONS(4506),
    [sym_inout] = ACTIONS(4506),
    [sym_interface] = ACTIONS(4506),
    [sym_invariant] = ACTIONS(4506),
    [sym_is] = ACTIONS(4506),
    [sym_mixin] = ACTIONS(4506),
    [sym_new] = ACTIONS(4506),
    [sym_nothrow] = ACTIONS(4506),
    [sym_out] = ACTIONS(4506),
    [sym_override] = ACTIONS(4506),
    [sym_package] = ACTIONS(4506),
    [sym_pragma] = ACTIONS(4506),
    [sym_private] = ACTIONS(4506),
    [sym_protected] = ACTIONS(4506),
    [sym_public] = ACTIONS(4506),
    [sym_pure] = ACTIONS(4506),
    [sym_ref] = ACTIONS(4506),
    [sym_return] = ACTIONS(4506),
    [sym_scope] = ACTIONS(4506),
    [sym_shared] = ACTIONS(4506),
    [sym_static] = ACTIONS(4506),
    [sym_struct] = ACTIONS(4506),
    [sym_switch] = ACTIONS(4506),
    [sym_synchronized] = ACTIONS(4506),
    [sym_template] = ACTIONS(4506),
    [sym_throw] = ACTIONS(4506),
    [sym_try] = ACTIONS(4506),
    [sym_typeid] = ACTIONS(4506),
    [sym_typeof] = ACTIONS(4506),
    [sym_union] = ACTIONS(4506),
    [sym_unittest] = ACTIONS(4506),
    [sym_version] = ACTIONS(4506),
    [sym_while] = ACTIONS(4506),
    [sym_with] = ACTIONS(4506),
    [sym_gshared] = ACTIONS(4506),
    [sym_traits] = ACTIONS(4506),
    [sym_vector] = ACTIONS(4506),
    [sym_void] = ACTIONS(4506),
    [anon_sym_BQUOTE] = ACTIONS(4508),
    [anon_sym_r_DQUOTE] = ACTIONS(4508),
    [anon_sym_x_DQUOTE] = ACTIONS(4508),
    [anon_sym_DQUOTE] = ACTIONS(4508),
    [anon_sym_i_BQUOTE] = ACTIONS(4508),
    [anon_sym_i_DQUOTE] = ACTIONS(4508),
    [anon_sym_iq_LBRACE] = ACTIONS(4508),
    [aux_sym_char_literal_token1] = ACTIONS(4508),
    [anon_sym_SQUOTE] = ACTIONS(4506),
    [anon_sym___DATE__] = ACTIONS(4506),
    [anon_sym___FILE__] = ACTIONS(4506),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4506),
    [anon_sym___FUNCTION__] = ACTIONS(4506),
    [anon_sym___LINE__] = ACTIONS(4506),
    [anon_sym___MODULE__] = ACTIONS(4506),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4506),
    [anon_sym___TIME__] = ACTIONS(4506),
    [anon_sym___TIMESTAMP__] = ACTIONS(4506),
    [anon_sym___VENDOR__] = ACTIONS(4506),
    [anon_sym___VERSION__] = ACTIONS(4506),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4508),
    [sym_float_literal] = ACTIONS(4508),
    [sym__string] = ACTIONS(4508),
  },
  [1632] = {
    [sym_identifier] = ACTIONS(4448),
    [anon_sym_q_LBRACE] = ACTIONS(4450),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(4450),
    [anon_sym_DOT] = ACTIONS(4450),
    [anon_sym_AMP] = ACTIONS(4450),
    [anon_sym_DASH] = ACTIONS(4448),
    [anon_sym_DASH_DASH] = ACTIONS(4450),
    [anon_sym_PLUS] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4450),
    [anon_sym_BANG] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(4450),
    [anon_sym_RPAREN] = ACTIONS(4450),
    [anon_sym_LBRACK] = ACTIONS(4450),
    [anon_sym_SEMI] = ACTIONS(4450),
    [anon_sym_DOLLAR] = ACTIONS(4450),
    [anon_sym_STAR] = ACTIONS(4450),
    [anon_sym_TILDE] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4450),
    [sym_bool] = ACTIONS(4448),
    [sym_byte] = ACTIONS(4448),
    [sym_ubyte] = ACTIONS(4448),
    [sym_char] = ACTIONS(4448),
    [sym_short] = ACTIONS(4448),
    [sym_ushort] = ACTIONS(4448),
    [sym_int] = ACTIONS(4448),
    [sym_uint] = ACTIONS(4448),
    [sym_long] = ACTIONS(4448),
    [sym_ulong] = ACTIONS(4448),
    [sym_cent] = ACTIONS(4448),
    [sym_ucent] = ACTIONS(4448),
    [sym_wchar] = ACTIONS(4448),
    [sym_dchar] = ACTIONS(4448),
    [sym_float] = ACTIONS(4448),
    [sym_double] = ACTIONS(4448),
    [sym_real] = ACTIONS(4448),
    [sym_ifloat] = ACTIONS(4448),
    [sym_idouble] = ACTIONS(4448),
    [sym_ireal] = ACTIONS(4448),
    [sym_cfloat] = ACTIONS(4448),
    [sym_cdouble] = ACTIONS(4448),
    [sym_creal] = ACTIONS(4448),
    [sym_size_t] = ACTIONS(4448),
    [sym_ptrdiff_t] = ACTIONS(4448),
    [sym_string] = ACTIONS(4448),
    [sym_cstring] = ACTIONS(4448),
    [sym_dstring] = ACTIONS(4448),
    [sym_wstring] = ACTIONS(4448),
    [sym_noreturn] = ACTIONS(4448),
    [sym_true] = ACTIONS(4448),
    [sym_false] = ACTIONS(4448),
    [sym_null] = ACTIONS(4448),
    [sym_super] = ACTIONS(4448),
    [sym_this] = ACTIONS(4448),
    [sym_abstract] = ACTIONS(4448),
    [sym_alias] = ACTIONS(4448),
    [sym_align] = ACTIONS(4448),
    [sym_asm] = ACTIONS(4448),
    [sym_assert] = ACTIONS(4448),
    [sym_auto] = ACTIONS(4448),
    [sym_break] = ACTIONS(4448),
    [sym_case] = ACTIONS(4448),
    [sym_cast] = ACTIONS(4448),
    [sym_class] = ACTIONS(4448),
    [sym_const] = ACTIONS(4448),
    [sym_continue] = ACTIONS(4448),
    [sym_debug] = ACTIONS(4448),
    [sym_default] = ACTIONS(4448),
    [sym_delegate] = ACTIONS(4448),
    [sym_delete] = ACTIONS(4448),
    [sym_deprecated] = ACTIONS(4448),
    [sym_do] = ACTIONS(4448),
    [sym_else] = ACTIONS(4448),
    [sym_enum] = ACTIONS(4448),
    [sym_export] = ACTIONS(4448),
    [sym_extern] = ACTIONS(4448),
    [sym_final] = ACTIONS(4448),
    [sym_for] = ACTIONS(4448),
    [sym_foreach] = ACTIONS(4448),
    [sym_foreach_reverse] = ACTIONS(4448),
    [sym_function] = ACTIONS(4448),
    [sym_goto] = ACTIONS(4448),
    [sym_if] = ACTIONS(4448),
    [sym_immutable] = ACTIONS(4448),
    [sym_import] = ACTIONS(4448),
    [sym_in] = ACTIONS(4448),
    [sym_inout] = ACTIONS(4448),
    [sym_interface] = ACTIONS(4448),
    [sym_invariant] = ACTIONS(4448),
    [sym_is] = ACTIONS(4448),
    [sym_mixin] = ACTIONS(4448),
    [sym_new] = ACTIONS(4448),
    [sym_nothrow] = ACTIONS(4448),
    [sym_out] = ACTIONS(4448),
    [sym_override] = ACTIONS(4448),
    [sym_package] = ACTIONS(4448),
    [sym_pragma] = ACTIONS(4448),
    [sym_private] = ACTIONS(4448),
    [sym_protected] = ACTIONS(4448),
    [sym_public] = ACTIONS(4448),
    [sym_pure] = ACTIONS(4448),
    [sym_ref] = ACTIONS(4448),
    [sym_return] = ACTIONS(4448),
    [sym_scope] = ACTIONS(4448),
    [sym_shared] = ACTIONS(4448),
    [sym_static] = ACTIONS(4448),
    [sym_struct] = ACTIONS(4448),
    [sym_switch] = ACTIONS(4448),
    [sym_synchronized] = ACTIONS(4448),
    [sym_template] = ACTIONS(4448),
    [sym_throw] = ACTIONS(4448),
    [sym_try] = ACTIONS(4448),
    [sym_typeid] = ACTIONS(4448),
    [sym_typeof] = ACTIONS(4448),
    [sym_union] = ACTIONS(4448),
    [sym_unittest] = ACTIONS(4448),
    [sym_version] = ACTIONS(4448),
    [sym_while] = ACTIONS(4448),
    [sym_with] = ACTIONS(4448),
    [sym_gshared] = ACTIONS(4448),
    [sym_traits] = ACTIONS(4448),
    [sym_vector] = ACTIONS(4448),
    [sym_void] = ACTIONS(4448),
    [anon_sym_BQUOTE] = ACTIONS(4450),
    [anon_sym_r_DQUOTE] = ACTIONS(4450),
    [anon_sym_x_DQUOTE] = ACTIONS(4450),
    [anon_sym_DQUOTE] = ACTIONS(4450),
    [anon_sym_i_BQUOTE] = ACTIONS(4450),
    [anon_sym_i_DQUOTE] = ACTIONS(4450),
    [anon_sym_iq_LBRACE] = ACTIONS(4450),
    [aux_sym_char_literal_token1] = ACTIONS(4450),
    [anon_sym_SQUOTE] = ACTIONS(4448),
    [anon_sym___DATE__] = ACTIONS(4448),
    [anon_sym___FILE__] = ACTIONS(4448),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4448),
    [anon_sym___FUNCTION__] = ACTIONS(4448),
    [anon_sym___LINE__] = ACTIONS(4448),
    [anon_sym___MODULE__] = ACTIONS(4448),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4448),
    [anon_sym___TIME__] = ACTIONS(4448),
    [anon_sym___TIMESTAMP__] = ACTIONS(4448),
    [anon_sym___VENDOR__] = ACTIONS(4448),
    [anon_sym___VERSION__] = ACTIONS(4448),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4450),
    [sym_float_literal] = ACTIONS(4450),
    [sym__string] = ACTIONS(4450),
  },
  [1633] = {
    [sym_identifier] = ACTIONS(4486),
    [anon_sym_q_LBRACE] = ACTIONS(4488),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [anon_sym_LBRACE] = ACTIONS(4488),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4488),
    [anon_sym_PLUS] = ACTIONS(4486),
    [anon_sym_PLUS_PLUS] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_LPAREN] = ACTIONS(4488),
    [anon_sym_RPAREN] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4488),
    [anon_sym_DOLLAR] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4488),
    [anon_sym_AT] = ACTIONS(4488),
    [sym_bool] = ACTIONS(4486),
    [sym_byte] = ACTIONS(4486),
    [sym_ubyte] = ACTIONS(4486),
    [sym_char] = ACTIONS(4486),
    [sym_short] = ACTIONS(4486),
    [sym_ushort] = ACTIONS(4486),
    [sym_int] = ACTIONS(4486),
    [sym_uint] = ACTIONS(4486),
    [sym_long] = ACTIONS(4486),
    [sym_ulong] = ACTIONS(4486),
    [sym_cent] = ACTIONS(4486),
    [sym_ucent] = ACTIONS(4486),
    [sym_wchar] = ACTIONS(4486),
    [sym_dchar] = ACTIONS(4486),
    [sym_float] = ACTIONS(4486),
    [sym_double] = ACTIONS(4486),
    [sym_real] = ACTIONS(4486),
    [sym_ifloat] = ACTIONS(4486),
    [sym_idouble] = ACTIONS(4486),
    [sym_ireal] = ACTIONS(4486),
    [sym_cfloat] = ACTIONS(4486),
    [sym_cdouble] = ACTIONS(4486),
    [sym_creal] = ACTIONS(4486),
    [sym_size_t] = ACTIONS(4486),
    [sym_ptrdiff_t] = ACTIONS(4486),
    [sym_string] = ACTIONS(4486),
    [sym_cstring] = ACTIONS(4486),
    [sym_dstring] = ACTIONS(4486),
    [sym_wstring] = ACTIONS(4486),
    [sym_noreturn] = ACTIONS(4486),
    [sym_true] = ACTIONS(4486),
    [sym_false] = ACTIONS(4486),
    [sym_null] = ACTIONS(4486),
    [sym_super] = ACTIONS(4486),
    [sym_this] = ACTIONS(4486),
    [sym_abstract] = ACTIONS(4486),
    [sym_alias] = ACTIONS(4486),
    [sym_align] = ACTIONS(4486),
    [sym_asm] = ACTIONS(4486),
    [sym_assert] = ACTIONS(4486),
    [sym_auto] = ACTIONS(4486),
    [sym_break] = ACTIONS(4486),
    [sym_case] = ACTIONS(4486),
    [sym_cast] = ACTIONS(4486),
    [sym_class] = ACTIONS(4486),
    [sym_const] = ACTIONS(4486),
    [sym_continue] = ACTIONS(4486),
    [sym_debug] = ACTIONS(4486),
    [sym_default] = ACTIONS(4486),
    [sym_delegate] = ACTIONS(4486),
    [sym_delete] = ACTIONS(4486),
    [sym_deprecated] = ACTIONS(4486),
    [sym_do] = ACTIONS(4486),
    [sym_else] = ACTIONS(4486),
    [sym_enum] = ACTIONS(4486),
    [sym_export] = ACTIONS(4486),
    [sym_extern] = ACTIONS(4486),
    [sym_final] = ACTIONS(4486),
    [sym_for] = ACTIONS(4486),
    [sym_foreach] = ACTIONS(4486),
    [sym_foreach_reverse] = ACTIONS(4486),
    [sym_function] = ACTIONS(4486),
    [sym_goto] = ACTIONS(4486),
    [sym_if] = ACTIONS(4486),
    [sym_immutable] = ACTIONS(4486),
    [sym_import] = ACTIONS(4486),
    [sym_in] = ACTIONS(4486),
    [sym_inout] = ACTIONS(4486),
    [sym_interface] = ACTIONS(4486),
    [sym_invariant] = ACTIONS(4486),
    [sym_is] = ACTIONS(4486),
    [sym_mixin] = ACTIONS(4486),
    [sym_new] = ACTIONS(4486),
    [sym_nothrow] = ACTIONS(4486),
    [sym_out] = ACTIONS(4486),
    [sym_override] = ACTIONS(4486),
    [sym_package] = ACTIONS(4486),
    [sym_pragma] = ACTIONS(4486),
    [sym_private] = ACTIONS(4486),
    [sym_protected] = ACTIONS(4486),
    [sym_public] = ACTIONS(4486),
    [sym_pure] = ACTIONS(4486),
    [sym_ref] = ACTIONS(4486),
    [sym_return] = ACTIONS(4486),
    [sym_scope] = ACTIONS(4486),
    [sym_shared] = ACTIONS(4486),
    [sym_static] = ACTIONS(4486),
    [sym_struct] = ACTIONS(4486),
    [sym_switch] = ACTIONS(4486),
    [sym_synchronized] = ACTIONS(4486),
    [sym_template] = ACTIONS(4486),
    [sym_throw] = ACTIONS(4486),
    [sym_try] = ACTIONS(4486),
    [sym_typeid] = ACTIONS(4486),
    [sym_typeof] = ACTIONS(4486),
    [sym_union] = ACTIONS(4486),
    [sym_unittest] = ACTIONS(4486),
    [sym_version] = ACTIONS(4486),
    [sym_while] = ACTIONS(4486),
    [sym_with] = ACTIONS(4486),
    [sym_gshared] = ACTIONS(4486),
    [sym_traits] = ACTIONS(4486),
    [sym_vector] = ACTIONS(4486),
    [sym_void] = ACTIONS(4486),
    [anon_sym_BQUOTE] = ACTIONS(4488),
    [anon_sym_r_DQUOTE] = ACTIONS(4488),
    [anon_sym_x_DQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE] = ACTIONS(4488),
    [anon_sym_i_BQUOTE] = ACTIONS(4488),
    [anon_sym_i_DQUOTE] = ACTIONS(4488),
    [anon_sym_iq_LBRACE] = ACTIONS(4488),
    [aux_sym_char_literal_token1] = ACTIONS(4488),
    [anon_sym_SQUOTE] = ACTIONS(4486),
    [anon_sym___DATE__] = ACTIONS(4486),
    [anon_sym___FILE__] = ACTIONS(4486),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4486),
    [anon_sym___FUNCTION__] = ACTIONS(4486),
    [anon_sym___LINE__] = ACTIONS(4486),
    [anon_sym___MODULE__] = ACTIONS(4486),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4486),
    [anon_sym___TIME__] = ACTIONS(4486),
    [anon_sym___TIMESTAMP__] = ACTIONS(4486),
    [anon_sym___VENDOR__] = ACTIONS(4486),
    [anon_sym___VERSION__] = ACTIONS(4486),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4488),
    [sym_float_literal] = ACTIONS(4488),
    [sym__string] = ACTIONS(4488),
  },
  [1634] = {
    [sym_identifier] = ACTIONS(4478),
    [anon_sym_q_LBRACE] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_DOLLAR] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_TILDE] = ACTIONS(4480),
    [anon_sym_AT] = ACTIONS(4480),
    [sym_bool] = ACTIONS(4478),
    [sym_byte] = ACTIONS(4478),
    [sym_ubyte] = ACTIONS(4478),
    [sym_char] = ACTIONS(4478),
    [sym_short] = ACTIONS(4478),
    [sym_ushort] = ACTIONS(4478),
    [sym_int] = ACTIONS(4478),
    [sym_uint] = ACTIONS(4478),
    [sym_long] = ACTIONS(4478),
    [sym_ulong] = ACTIONS(4478),
    [sym_cent] = ACTIONS(4478),
    [sym_ucent] = ACTIONS(4478),
    [sym_wchar] = ACTIONS(4478),
    [sym_dchar] = ACTIONS(4478),
    [sym_float] = ACTIONS(4478),
    [sym_double] = ACTIONS(4478),
    [sym_real] = ACTIONS(4478),
    [sym_ifloat] = ACTIONS(4478),
    [sym_idouble] = ACTIONS(4478),
    [sym_ireal] = ACTIONS(4478),
    [sym_cfloat] = ACTIONS(4478),
    [sym_cdouble] = ACTIONS(4478),
    [sym_creal] = ACTIONS(4478),
    [sym_size_t] = ACTIONS(4478),
    [sym_ptrdiff_t] = ACTIONS(4478),
    [sym_string] = ACTIONS(4478),
    [sym_cstring] = ACTIONS(4478),
    [sym_dstring] = ACTIONS(4478),
    [sym_wstring] = ACTIONS(4478),
    [sym_noreturn] = ACTIONS(4478),
    [sym_true] = ACTIONS(4478),
    [sym_false] = ACTIONS(4478),
    [sym_null] = ACTIONS(4478),
    [sym_super] = ACTIONS(4478),
    [sym_this] = ACTIONS(4478),
    [sym_abstract] = ACTIONS(4478),
    [sym_alias] = ACTIONS(4478),
    [sym_align] = ACTIONS(4478),
    [sym_asm] = ACTIONS(4478),
    [sym_assert] = ACTIONS(4478),
    [sym_auto] = ACTIONS(4478),
    [sym_break] = ACTIONS(4478),
    [sym_case] = ACTIONS(4478),
    [sym_cast] = ACTIONS(4478),
    [sym_class] = ACTIONS(4478),
    [sym_const] = ACTIONS(4478),
    [sym_continue] = ACTIONS(4478),
    [sym_debug] = ACTIONS(4478),
    [sym_default] = ACTIONS(4478),
    [sym_delegate] = ACTIONS(4478),
    [sym_delete] = ACTIONS(4478),
    [sym_deprecated] = ACTIONS(4478),
    [sym_do] = ACTIONS(4478),
    [sym_else] = ACTIONS(4478),
    [sym_enum] = ACTIONS(4478),
    [sym_export] = ACTIONS(4478),
    [sym_extern] = ACTIONS(4478),
    [sym_final] = ACTIONS(4478),
    [sym_for] = ACTIONS(4478),
    [sym_foreach] = ACTIONS(4478),
    [sym_foreach_reverse] = ACTIONS(4478),
    [sym_function] = ACTIONS(4478),
    [sym_goto] = ACTIONS(4478),
    [sym_if] = ACTIONS(4478),
    [sym_immutable] = ACTIONS(4478),
    [sym_import] = ACTIONS(4478),
    [sym_in] = ACTIONS(4478),
    [sym_inout] = ACTIONS(4478),
    [sym_interface] = ACTIONS(4478),
    [sym_invariant] = ACTIONS(4478),
    [sym_is] = ACTIONS(4478),
    [sym_mixin] = ACTIONS(4478),
    [sym_new] = ACTIONS(4478),
    [sym_nothrow] = ACTIONS(4478),
    [sym_out] = ACTIONS(4478),
    [sym_override] = ACTIONS(4478),
    [sym_package] = ACTIONS(4478),
    [sym_pragma] = ACTIONS(4478),
    [sym_private] = ACTIONS(4478),
    [sym_protected] = ACTIONS(4478),
    [sym_public] = ACTIONS(4478),
    [sym_pure] = ACTIONS(4478),
    [sym_ref] = ACTIONS(4478),
    [sym_return] = ACTIONS(4478),
    [sym_scope] = ACTIONS(4478),
    [sym_shared] = ACTIONS(4478),
    [sym_static] = ACTIONS(4478),
    [sym_struct] = ACTIONS(4478),
    [sym_switch] = ACTIONS(4478),
    [sym_synchronized] = ACTIONS(4478),
    [sym_template] = ACTIONS(4478),
    [sym_throw] = ACTIONS(4478),
    [sym_try] = ACTIONS(4478),
    [sym_typeid] = ACTIONS(4478),
    [sym_typeof] = ACTIONS(4478),
    [sym_union] = ACTIONS(4478),
    [sym_unittest] = ACTIONS(4478),
    [sym_version] = ACTIONS(4478),
    [sym_while] = ACTIONS(4478),
    [sym_with] = ACTIONS(4478),
    [sym_gshared] = ACTIONS(4478),
    [sym_traits] = ACTIONS(4478),
    [sym_vector] = ACTIONS(4478),
    [sym_void] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_r_DQUOTE] = ACTIONS(4480),
    [anon_sym_x_DQUOTE] = ACTIONS(4480),
    [anon_sym_DQUOTE] = ACTIONS(4480),
    [anon_sym_i_BQUOTE] = ACTIONS(4480),
    [anon_sym_i_DQUOTE] = ACTIONS(4480),
    [anon_sym_iq_LBRACE] = ACTIONS(4480),
    [aux_sym_char_literal_token1] = ACTIONS(4480),
    [anon_sym_SQUOTE] = ACTIONS(4478),
    [anon_sym___DATE__] = ACTIONS(4478),
    [anon_sym___FILE__] = ACTIONS(4478),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4478),
    [anon_sym___FUNCTION__] = ACTIONS(4478),
    [anon_sym___LINE__] = ACTIONS(4478),
    [anon_sym___MODULE__] = ACTIONS(4478),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4478),
    [anon_sym___TIME__] = ACTIONS(4478),
    [anon_sym___TIMESTAMP__] = ACTIONS(4478),
    [anon_sym___VENDOR__] = ACTIONS(4478),
    [anon_sym___VERSION__] = ACTIONS(4478),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4480),
    [sym_float_literal] = ACTIONS(4480),
    [sym__string] = ACTIONS(4480),
  },
  [1635] = {
    [sym_identifier] = ACTIONS(4949),
    [anon_sym_q_LBRACE] = ACTIONS(4951),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4951),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4949),
    [anon_sym_DASH_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4949),
    [anon_sym_PLUS_PLUS] = ACTIONS(4951),
    [anon_sym_BANG] = ACTIONS(4951),
    [anon_sym_LPAREN] = ACTIONS(4951),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_TILDE] = ACTIONS(4951),
    [anon_sym_AT] = ACTIONS(4951),
    [sym_bool] = ACTIONS(4949),
    [sym_byte] = ACTIONS(4949),
    [sym_ubyte] = ACTIONS(4949),
    [sym_char] = ACTIONS(4949),
    [sym_short] = ACTIONS(4949),
    [sym_ushort] = ACTIONS(4949),
    [sym_int] = ACTIONS(4949),
    [sym_uint] = ACTIONS(4949),
    [sym_long] = ACTIONS(4949),
    [sym_ulong] = ACTIONS(4949),
    [sym_cent] = ACTIONS(4949),
    [sym_ucent] = ACTIONS(4949),
    [sym_wchar] = ACTIONS(4949),
    [sym_dchar] = ACTIONS(4949),
    [sym_float] = ACTIONS(4949),
    [sym_double] = ACTIONS(4949),
    [sym_real] = ACTIONS(4949),
    [sym_ifloat] = ACTIONS(4949),
    [sym_idouble] = ACTIONS(4949),
    [sym_ireal] = ACTIONS(4949),
    [sym_cfloat] = ACTIONS(4949),
    [sym_cdouble] = ACTIONS(4949),
    [sym_creal] = ACTIONS(4949),
    [sym_size_t] = ACTIONS(4949),
    [sym_ptrdiff_t] = ACTIONS(4949),
    [sym_string] = ACTIONS(4949),
    [sym_cstring] = ACTIONS(4949),
    [sym_dstring] = ACTIONS(4949),
    [sym_wstring] = ACTIONS(4949),
    [sym_noreturn] = ACTIONS(4949),
    [sym_true] = ACTIONS(4949),
    [sym_false] = ACTIONS(4949),
    [sym_null] = ACTIONS(4949),
    [sym_super] = ACTIONS(4949),
    [sym_this] = ACTIONS(4949),
    [sym_abstract] = ACTIONS(4949),
    [sym_alias] = ACTIONS(4949),
    [sym_align] = ACTIONS(4949),
    [sym_asm] = ACTIONS(4949),
    [sym_assert] = ACTIONS(4949),
    [sym_auto] = ACTIONS(4949),
    [sym_break] = ACTIONS(4949),
    [sym_case] = ACTIONS(4949),
    [sym_cast] = ACTIONS(4949),
    [sym_class] = ACTIONS(4949),
    [sym_const] = ACTIONS(4949),
    [sym_continue] = ACTIONS(4949),
    [sym_debug] = ACTIONS(4949),
    [sym_default] = ACTIONS(4949),
    [sym_delegate] = ACTIONS(4949),
    [sym_delete] = ACTIONS(4949),
    [sym_deprecated] = ACTIONS(4949),
    [sym_do] = ACTIONS(4949),
    [sym_else] = ACTIONS(4949),
    [sym_enum] = ACTIONS(4949),
    [sym_export] = ACTIONS(4949),
    [sym_extern] = ACTIONS(4949),
    [sym_final] = ACTIONS(4949),
    [sym_for] = ACTIONS(4949),
    [sym_foreach] = ACTIONS(4949),
    [sym_foreach_reverse] = ACTIONS(4949),
    [sym_function] = ACTIONS(4949),
    [sym_goto] = ACTIONS(4949),
    [sym_if] = ACTIONS(4949),
    [sym_immutable] = ACTIONS(4949),
    [sym_import] = ACTIONS(4949),
    [sym_in] = ACTIONS(4949),
    [sym_inout] = ACTIONS(4949),
    [sym_interface] = ACTIONS(4949),
    [sym_invariant] = ACTIONS(4949),
    [sym_is] = ACTIONS(4949),
    [sym_mixin] = ACTIONS(4949),
    [sym_new] = ACTIONS(4949),
    [sym_nothrow] = ACTIONS(4949),
    [sym_out] = ACTIONS(4949),
    [sym_override] = ACTIONS(4949),
    [sym_package] = ACTIONS(4949),
    [sym_pragma] = ACTIONS(4949),
    [sym_private] = ACTIONS(4949),
    [sym_protected] = ACTIONS(4949),
    [sym_public] = ACTIONS(4949),
    [sym_pure] = ACTIONS(4949),
    [sym_ref] = ACTIONS(4949),
    [sym_return] = ACTIONS(4949),
    [sym_scope] = ACTIONS(4949),
    [sym_shared] = ACTIONS(4949),
    [sym_static] = ACTIONS(4949),
    [sym_struct] = ACTIONS(4949),
    [sym_switch] = ACTIONS(4949),
    [sym_synchronized] = ACTIONS(4949),
    [sym_template] = ACTIONS(4949),
    [sym_throw] = ACTIONS(4949),
    [sym_try] = ACTIONS(4949),
    [sym_typeid] = ACTIONS(4949),
    [sym_typeof] = ACTIONS(4949),
    [sym_union] = ACTIONS(4949),
    [sym_unittest] = ACTIONS(4949),
    [sym_version] = ACTIONS(4949),
    [sym_while] = ACTIONS(4949),
    [sym_with] = ACTIONS(4949),
    [sym_gshared] = ACTIONS(4949),
    [sym_traits] = ACTIONS(4949),
    [sym_vector] = ACTIONS(4949),
    [sym_void] = ACTIONS(4949),
    [anon_sym_BQUOTE] = ACTIONS(4951),
    [anon_sym_r_DQUOTE] = ACTIONS(4951),
    [anon_sym_x_DQUOTE] = ACTIONS(4951),
    [anon_sym_DQUOTE] = ACTIONS(4951),
    [anon_sym_i_BQUOTE] = ACTIONS(4951),
    [anon_sym_i_DQUOTE] = ACTIONS(4951),
    [anon_sym_iq_LBRACE] = ACTIONS(4951),
    [aux_sym_char_literal_token1] = ACTIONS(4951),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [anon_sym___DATE__] = ACTIONS(4949),
    [anon_sym___FILE__] = ACTIONS(4949),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4949),
    [anon_sym___FUNCTION__] = ACTIONS(4949),
    [anon_sym___LINE__] = ACTIONS(4949),
    [anon_sym___MODULE__] = ACTIONS(4949),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4949),
    [anon_sym___TIME__] = ACTIONS(4949),
    [anon_sym___TIMESTAMP__] = ACTIONS(4949),
    [anon_sym___VENDOR__] = ACTIONS(4949),
    [anon_sym___VERSION__] = ACTIONS(4949),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4951),
    [sym_float_literal] = ACTIONS(4951),
    [sym__string] = ACTIONS(4951),
  },
  [1636] = {
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_q_LBRACE] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4476),
    [anon_sym_AMP] = ACTIONS(4476),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_DOLLAR] = ACTIONS(4476),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4476),
    [anon_sym_AT] = ACTIONS(4476),
    [sym_bool] = ACTIONS(4474),
    [sym_byte] = ACTIONS(4474),
    [sym_ubyte] = ACTIONS(4474),
    [sym_char] = ACTIONS(4474),
    [sym_short] = ACTIONS(4474),
    [sym_ushort] = ACTIONS(4474),
    [sym_int] = ACTIONS(4474),
    [sym_uint] = ACTIONS(4474),
    [sym_long] = ACTIONS(4474),
    [sym_ulong] = ACTIONS(4474),
    [sym_cent] = ACTIONS(4474),
    [sym_ucent] = ACTIONS(4474),
    [sym_wchar] = ACTIONS(4474),
    [sym_dchar] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_double] = ACTIONS(4474),
    [sym_real] = ACTIONS(4474),
    [sym_ifloat] = ACTIONS(4474),
    [sym_idouble] = ACTIONS(4474),
    [sym_ireal] = ACTIONS(4474),
    [sym_cfloat] = ACTIONS(4474),
    [sym_cdouble] = ACTIONS(4474),
    [sym_creal] = ACTIONS(4474),
    [sym_size_t] = ACTIONS(4474),
    [sym_ptrdiff_t] = ACTIONS(4474),
    [sym_string] = ACTIONS(4474),
    [sym_cstring] = ACTIONS(4474),
    [sym_dstring] = ACTIONS(4474),
    [sym_wstring] = ACTIONS(4474),
    [sym_noreturn] = ACTIONS(4474),
    [sym_true] = ACTIONS(4474),
    [sym_false] = ACTIONS(4474),
    [sym_null] = ACTIONS(4474),
    [sym_super] = ACTIONS(4474),
    [sym_this] = ACTIONS(4474),
    [sym_abstract] = ACTIONS(4474),
    [sym_alias] = ACTIONS(4474),
    [sym_align] = ACTIONS(4474),
    [sym_asm] = ACTIONS(4474),
    [sym_assert] = ACTIONS(4474),
    [sym_auto] = ACTIONS(4474),
    [sym_break] = ACTIONS(4474),
    [sym_case] = ACTIONS(4474),
    [sym_cast] = ACTIONS(4474),
    [sym_class] = ACTIONS(4474),
    [sym_const] = ACTIONS(4474),
    [sym_continue] = ACTIONS(4474),
    [sym_debug] = ACTIONS(4474),
    [sym_default] = ACTIONS(4474),
    [sym_delegate] = ACTIONS(4474),
    [sym_delete] = ACTIONS(4474),
    [sym_deprecated] = ACTIONS(4474),
    [sym_do] = ACTIONS(4474),
    [sym_else] = ACTIONS(4474),
    [sym_enum] = ACTIONS(4474),
    [sym_export] = ACTIONS(4474),
    [sym_extern] = ACTIONS(4474),
    [sym_final] = ACTIONS(4474),
    [sym_for] = ACTIONS(4474),
    [sym_foreach] = ACTIONS(4474),
    [sym_foreach_reverse] = ACTIONS(4474),
    [sym_function] = ACTIONS(4474),
    [sym_goto] = ACTIONS(4474),
    [sym_if] = ACTIONS(4474),
    [sym_immutable] = ACTIONS(4474),
    [sym_import] = ACTIONS(4474),
    [sym_in] = ACTIONS(4474),
    [sym_inout] = ACTIONS(4474),
    [sym_interface] = ACTIONS(4474),
    [sym_invariant] = ACTIONS(4474),
    [sym_is] = ACTIONS(4474),
    [sym_mixin] = ACTIONS(4474),
    [sym_new] = ACTIONS(4474),
    [sym_nothrow] = ACTIONS(4474),
    [sym_out] = ACTIONS(4474),
    [sym_override] = ACTIONS(4474),
    [sym_package] = ACTIONS(4474),
    [sym_pragma] = ACTIONS(4474),
    [sym_private] = ACTIONS(4474),
    [sym_protected] = ACTIONS(4474),
    [sym_public] = ACTIONS(4474),
    [sym_pure] = ACTIONS(4474),
    [sym_ref] = ACTIONS(4474),
    [sym_return] = ACTIONS(4474),
    [sym_scope] = ACTIONS(4474),
    [sym_shared] = ACTIONS(4474),
    [sym_static] = ACTIONS(4474),
    [sym_struct] = ACTIONS(4474),
    [sym_switch] = ACTIONS(4474),
    [sym_synchronized] = ACTIONS(4474),
    [sym_template] = ACTIONS(4474),
    [sym_throw] = ACTIONS(4474),
    [sym_try] = ACTIONS(4474),
    [sym_typeid] = ACTIONS(4474),
    [sym_typeof] = ACTIONS(4474),
    [sym_union] = ACTIONS(4474),
    [sym_unittest] = ACTIONS(4474),
    [sym_version] = ACTIONS(4474),
    [sym_while] = ACTIONS(4474),
    [sym_with] = ACTIONS(4474),
    [sym_gshared] = ACTIONS(4474),
    [sym_traits] = ACTIONS(4474),
    [sym_vector] = ACTIONS(4474),
    [sym_void] = ACTIONS(4474),
    [anon_sym_BQUOTE] = ACTIONS(4476),
    [anon_sym_r_DQUOTE] = ACTIONS(4476),
    [anon_sym_x_DQUOTE] = ACTIONS(4476),
    [anon_sym_DQUOTE] = ACTIONS(4476),
    [anon_sym_i_BQUOTE] = ACTIONS(4476),
    [anon_sym_i_DQUOTE] = ACTIONS(4476),
    [anon_sym_iq_LBRACE] = ACTIONS(4476),
    [aux_sym_char_literal_token1] = ACTIONS(4476),
    [anon_sym_SQUOTE] = ACTIONS(4474),
    [anon_sym___DATE__] = ACTIONS(4474),
    [anon_sym___FILE__] = ACTIONS(4474),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4474),
    [anon_sym___FUNCTION__] = ACTIONS(4474),
    [anon_sym___LINE__] = ACTIONS(4474),
    [anon_sym___MODULE__] = ACTIONS(4474),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4474),
    [anon_sym___TIME__] = ACTIONS(4474),
    [anon_sym___TIMESTAMP__] = ACTIONS(4474),
    [anon_sym___VENDOR__] = ACTIONS(4474),
    [anon_sym___VERSION__] = ACTIONS(4474),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4476),
    [sym_float_literal] = ACTIONS(4476),
    [sym__string] = ACTIONS(4476),
  },
  [1637] = {
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_q_LBRACE] = ACTIONS(4915),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [anon_sym_LBRACE] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4915),
    [anon_sym_DASH] = ACTIONS(4913),
    [anon_sym_DASH_DASH] = ACTIONS(4915),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_PLUS_PLUS] = ACTIONS(4915),
    [anon_sym_BANG] = ACTIONS(4915),
    [anon_sym_LPAREN] = ACTIONS(4915),
    [anon_sym_RPAREN] = ACTIONS(4915),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_DOLLAR] = ACTIONS(4915),
    [anon_sym_STAR] = ACTIONS(4915),
    [anon_sym_TILDE] = ACTIONS(4915),
    [anon_sym_AT] = ACTIONS(4915),
    [sym_bool] = ACTIONS(4913),
    [sym_byte] = ACTIONS(4913),
    [sym_ubyte] = ACTIONS(4913),
    [sym_char] = ACTIONS(4913),
    [sym_short] = ACTIONS(4913),
    [sym_ushort] = ACTIONS(4913),
    [sym_int] = ACTIONS(4913),
    [sym_uint] = ACTIONS(4913),
    [sym_long] = ACTIONS(4913),
    [sym_ulong] = ACTIONS(4913),
    [sym_cent] = ACTIONS(4913),
    [sym_ucent] = ACTIONS(4913),
    [sym_wchar] = ACTIONS(4913),
    [sym_dchar] = ACTIONS(4913),
    [sym_float] = ACTIONS(4913),
    [sym_double] = ACTIONS(4913),
    [sym_real] = ACTIONS(4913),
    [sym_ifloat] = ACTIONS(4913),
    [sym_idouble] = ACTIONS(4913),
    [sym_ireal] = ACTIONS(4913),
    [sym_cfloat] = ACTIONS(4913),
    [sym_cdouble] = ACTIONS(4913),
    [sym_creal] = ACTIONS(4913),
    [sym_size_t] = ACTIONS(4913),
    [sym_ptrdiff_t] = ACTIONS(4913),
    [sym_string] = ACTIONS(4913),
    [sym_cstring] = ACTIONS(4913),
    [sym_dstring] = ACTIONS(4913),
    [sym_wstring] = ACTIONS(4913),
    [sym_noreturn] = ACTIONS(4913),
    [sym_true] = ACTIONS(4913),
    [sym_false] = ACTIONS(4913),
    [sym_null] = ACTIONS(4913),
    [sym_super] = ACTIONS(4913),
    [sym_this] = ACTIONS(4913),
    [sym_abstract] = ACTIONS(4913),
    [sym_alias] = ACTIONS(4913),
    [sym_align] = ACTIONS(4913),
    [sym_asm] = ACTIONS(4913),
    [sym_assert] = ACTIONS(4913),
    [sym_auto] = ACTIONS(4913),
    [sym_break] = ACTIONS(4913),
    [sym_case] = ACTIONS(4913),
    [sym_cast] = ACTIONS(4913),
    [sym_class] = ACTIONS(4913),
    [sym_const] = ACTIONS(4913),
    [sym_continue] = ACTIONS(4913),
    [sym_debug] = ACTIONS(4913),
    [sym_default] = ACTIONS(4913),
    [sym_delegate] = ACTIONS(4913),
    [sym_delete] = ACTIONS(4913),
    [sym_deprecated] = ACTIONS(4913),
    [sym_do] = ACTIONS(4913),
    [sym_else] = ACTIONS(4913),
    [sym_enum] = ACTIONS(4913),
    [sym_export] = ACTIONS(4913),
    [sym_extern] = ACTIONS(4913),
    [sym_final] = ACTIONS(4913),
    [sym_for] = ACTIONS(4913),
    [sym_foreach] = ACTIONS(4913),
    [sym_foreach_reverse] = ACTIONS(4913),
    [sym_function] = ACTIONS(4913),
    [sym_goto] = ACTIONS(4913),
    [sym_if] = ACTIONS(4913),
    [sym_immutable] = ACTIONS(4913),
    [sym_import] = ACTIONS(4913),
    [sym_in] = ACTIONS(4913),
    [sym_inout] = ACTIONS(4913),
    [sym_interface] = ACTIONS(4913),
    [sym_invariant] = ACTIONS(4913),
    [sym_is] = ACTIONS(4913),
    [sym_mixin] = ACTIONS(4913),
    [sym_new] = ACTIONS(4913),
    [sym_nothrow] = ACTIONS(4913),
    [sym_out] = ACTIONS(4913),
    [sym_override] = ACTIONS(4913),
    [sym_package] = ACTIONS(4913),
    [sym_pragma] = ACTIONS(4913),
    [sym_private] = ACTIONS(4913),
    [sym_protected] = ACTIONS(4913),
    [sym_public] = ACTIONS(4913),
    [sym_pure] = ACTIONS(4913),
    [sym_ref] = ACTIONS(4913),
    [sym_return] = ACTIONS(4913),
    [sym_scope] = ACTIONS(4913),
    [sym_shared] = ACTIONS(4913),
    [sym_static] = ACTIONS(4913),
    [sym_struct] = ACTIONS(4913),
    [sym_switch] = ACTIONS(4913),
    [sym_synchronized] = ACTIONS(4913),
    [sym_template] = ACTIONS(4913),
    [sym_throw] = ACTIONS(4913),
    [sym_try] = ACTIONS(4913),
    [sym_typeid] = ACTIONS(4913),
    [sym_typeof] = ACTIONS(4913),
    [sym_union] = ACTIONS(4913),
    [sym_unittest] = ACTIONS(4913),
    [sym_version] = ACTIONS(4913),
    [sym_while] = ACTIONS(4913),
    [sym_with] = ACTIONS(4913),
    [sym_gshared] = ACTIONS(4913),
    [sym_traits] = ACTIONS(4913),
    [sym_vector] = ACTIONS(4913),
    [sym_void] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4915),
    [anon_sym_r_DQUOTE] = ACTIONS(4915),
    [anon_sym_x_DQUOTE] = ACTIONS(4915),
    [anon_sym_DQUOTE] = ACTIONS(4915),
    [anon_sym_i_BQUOTE] = ACTIONS(4915),
    [anon_sym_i_DQUOTE] = ACTIONS(4915),
    [anon_sym_iq_LBRACE] = ACTIONS(4915),
    [aux_sym_char_literal_token1] = ACTIONS(4915),
    [anon_sym_SQUOTE] = ACTIONS(4913),
    [anon_sym___DATE__] = ACTIONS(4913),
    [anon_sym___FILE__] = ACTIONS(4913),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4913),
    [anon_sym___FUNCTION__] = ACTIONS(4913),
    [anon_sym___LINE__] = ACTIONS(4913),
    [anon_sym___MODULE__] = ACTIONS(4913),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4913),
    [anon_sym___TIME__] = ACTIONS(4913),
    [anon_sym___TIMESTAMP__] = ACTIONS(4913),
    [anon_sym___VENDOR__] = ACTIONS(4913),
    [anon_sym___VERSION__] = ACTIONS(4913),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4915),
    [sym_float_literal] = ACTIONS(4915),
    [sym__string] = ACTIONS(4915),
  },
  [1638] = {
    [sym_identifier] = ACTIONS(4917),
    [anon_sym_q_LBRACE] = ACTIONS(4919),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_LBRACE] = ACTIONS(4919),
    [anon_sym_DOT] = ACTIONS(4919),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_DASH] = ACTIONS(4917),
    [anon_sym_DASH_DASH] = ACTIONS(4919),
    [anon_sym_PLUS] = ACTIONS(4917),
    [anon_sym_PLUS_PLUS] = ACTIONS(4919),
    [anon_sym_BANG] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(4919),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4919),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_DOLLAR] = ACTIONS(4919),
    [anon_sym_STAR] = ACTIONS(4919),
    [anon_sym_TILDE] = ACTIONS(4919),
    [anon_sym_AT] = ACTIONS(4919),
    [sym_bool] = ACTIONS(4917),
    [sym_byte] = ACTIONS(4917),
    [sym_ubyte] = ACTIONS(4917),
    [sym_char] = ACTIONS(4917),
    [sym_short] = ACTIONS(4917),
    [sym_ushort] = ACTIONS(4917),
    [sym_int] = ACTIONS(4917),
    [sym_uint] = ACTIONS(4917),
    [sym_long] = ACTIONS(4917),
    [sym_ulong] = ACTIONS(4917),
    [sym_cent] = ACTIONS(4917),
    [sym_ucent] = ACTIONS(4917),
    [sym_wchar] = ACTIONS(4917),
    [sym_dchar] = ACTIONS(4917),
    [sym_float] = ACTIONS(4917),
    [sym_double] = ACTIONS(4917),
    [sym_real] = ACTIONS(4917),
    [sym_ifloat] = ACTIONS(4917),
    [sym_idouble] = ACTIONS(4917),
    [sym_ireal] = ACTIONS(4917),
    [sym_cfloat] = ACTIONS(4917),
    [sym_cdouble] = ACTIONS(4917),
    [sym_creal] = ACTIONS(4917),
    [sym_size_t] = ACTIONS(4917),
    [sym_ptrdiff_t] = ACTIONS(4917),
    [sym_string] = ACTIONS(4917),
    [sym_cstring] = ACTIONS(4917),
    [sym_dstring] = ACTIONS(4917),
    [sym_wstring] = ACTIONS(4917),
    [sym_noreturn] = ACTIONS(4917),
    [sym_true] = ACTIONS(4917),
    [sym_false] = ACTIONS(4917),
    [sym_null] = ACTIONS(4917),
    [sym_super] = ACTIONS(4917),
    [sym_this] = ACTIONS(4917),
    [sym_abstract] = ACTIONS(4917),
    [sym_alias] = ACTIONS(4917),
    [sym_align] = ACTIONS(4917),
    [sym_asm] = ACTIONS(4917),
    [sym_assert] = ACTIONS(4917),
    [sym_auto] = ACTIONS(4917),
    [sym_break] = ACTIONS(4917),
    [sym_case] = ACTIONS(4917),
    [sym_cast] = ACTIONS(4917),
    [sym_class] = ACTIONS(4917),
    [sym_const] = ACTIONS(4917),
    [sym_continue] = ACTIONS(4917),
    [sym_debug] = ACTIONS(4917),
    [sym_default] = ACTIONS(4917),
    [sym_delegate] = ACTIONS(4917),
    [sym_delete] = ACTIONS(4917),
    [sym_deprecated] = ACTIONS(4917),
    [sym_do] = ACTIONS(4917),
    [sym_else] = ACTIONS(4917),
    [sym_enum] = ACTIONS(4917),
    [sym_export] = ACTIONS(4917),
    [sym_extern] = ACTIONS(4917),
    [sym_final] = ACTIONS(4917),
    [sym_for] = ACTIONS(4917),
    [sym_foreach] = ACTIONS(4917),
    [sym_foreach_reverse] = ACTIONS(4917),
    [sym_function] = ACTIONS(4917),
    [sym_goto] = ACTIONS(4917),
    [sym_if] = ACTIONS(4917),
    [sym_immutable] = ACTIONS(4917),
    [sym_import] = ACTIONS(4917),
    [sym_in] = ACTIONS(4917),
    [sym_inout] = ACTIONS(4917),
    [sym_interface] = ACTIONS(4917),
    [sym_invariant] = ACTIONS(4917),
    [sym_is] = ACTIONS(4917),
    [sym_mixin] = ACTIONS(4917),
    [sym_new] = ACTIONS(4917),
    [sym_nothrow] = ACTIONS(4917),
    [sym_out] = ACTIONS(4917),
    [sym_override] = ACTIONS(4917),
    [sym_package] = ACTIONS(4917),
    [sym_pragma] = ACTIONS(4917),
    [sym_private] = ACTIONS(4917),
    [sym_protected] = ACTIONS(4917),
    [sym_public] = ACTIONS(4917),
    [sym_pure] = ACTIONS(4917),
    [sym_ref] = ACTIONS(4917),
    [sym_return] = ACTIONS(4917),
    [sym_scope] = ACTIONS(4917),
    [sym_shared] = ACTIONS(4917),
    [sym_static] = ACTIONS(4917),
    [sym_struct] = ACTIONS(4917),
    [sym_switch] = ACTIONS(4917),
    [sym_synchronized] = ACTIONS(4917),
    [sym_template] = ACTIONS(4917),
    [sym_throw] = ACTIONS(4917),
    [sym_try] = ACTIONS(4917),
    [sym_typeid] = ACTIONS(4917),
    [sym_typeof] = ACTIONS(4917),
    [sym_union] = ACTIONS(4917),
    [sym_unittest] = ACTIONS(4917),
    [sym_version] = ACTIONS(4917),
    [sym_while] = ACTIONS(4917),
    [sym_with] = ACTIONS(4917),
    [sym_gshared] = ACTIONS(4917),
    [sym_traits] = ACTIONS(4917),
    [sym_vector] = ACTIONS(4917),
    [sym_void] = ACTIONS(4917),
    [anon_sym_BQUOTE] = ACTIONS(4919),
    [anon_sym_r_DQUOTE] = ACTIONS(4919),
    [anon_sym_x_DQUOTE] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4919),
    [anon_sym_i_BQUOTE] = ACTIONS(4919),
    [anon_sym_i_DQUOTE] = ACTIONS(4919),
    [anon_sym_iq_LBRACE] = ACTIONS(4919),
    [aux_sym_char_literal_token1] = ACTIONS(4919),
    [anon_sym_SQUOTE] = ACTIONS(4917),
    [anon_sym___DATE__] = ACTIONS(4917),
    [anon_sym___FILE__] = ACTIONS(4917),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4917),
    [anon_sym___FUNCTION__] = ACTIONS(4917),
    [anon_sym___LINE__] = ACTIONS(4917),
    [anon_sym___MODULE__] = ACTIONS(4917),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4917),
    [anon_sym___TIME__] = ACTIONS(4917),
    [anon_sym___TIMESTAMP__] = ACTIONS(4917),
    [anon_sym___VENDOR__] = ACTIONS(4917),
    [anon_sym___VERSION__] = ACTIONS(4917),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4919),
    [sym_float_literal] = ACTIONS(4919),
    [sym__string] = ACTIONS(4919),
  },
  [1639] = {
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_q_LBRACE] = ACTIONS(4472),
    [anon_sym_RBRACE] = ACTIONS(4472),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_DOT] = ACTIONS(4472),
    [anon_sym_AMP] = ACTIONS(4472),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_RPAREN] = ACTIONS(4472),
    [anon_sym_LBRACK] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [anon_sym_AT] = ACTIONS(4472),
    [sym_bool] = ACTIONS(4470),
    [sym_byte] = ACTIONS(4470),
    [sym_ubyte] = ACTIONS(4470),
    [sym_char] = ACTIONS(4470),
    [sym_short] = ACTIONS(4470),
    [sym_ushort] = ACTIONS(4470),
    [sym_int] = ACTIONS(4470),
    [sym_uint] = ACTIONS(4470),
    [sym_long] = ACTIONS(4470),
    [sym_ulong] = ACTIONS(4470),
    [sym_cent] = ACTIONS(4470),
    [sym_ucent] = ACTIONS(4470),
    [sym_wchar] = ACTIONS(4470),
    [sym_dchar] = ACTIONS(4470),
    [sym_float] = ACTIONS(4470),
    [sym_double] = ACTIONS(4470),
    [sym_real] = ACTIONS(4470),
    [sym_ifloat] = ACTIONS(4470),
    [sym_idouble] = ACTIONS(4470),
    [sym_ireal] = ACTIONS(4470),
    [sym_cfloat] = ACTIONS(4470),
    [sym_cdouble] = ACTIONS(4470),
    [sym_creal] = ACTIONS(4470),
    [sym_size_t] = ACTIONS(4470),
    [sym_ptrdiff_t] = ACTIONS(4470),
    [sym_string] = ACTIONS(4470),
    [sym_cstring] = ACTIONS(4470),
    [sym_dstring] = ACTIONS(4470),
    [sym_wstring] = ACTIONS(4470),
    [sym_noreturn] = ACTIONS(4470),
    [sym_true] = ACTIONS(4470),
    [sym_false] = ACTIONS(4470),
    [sym_null] = ACTIONS(4470),
    [sym_super] = ACTIONS(4470),
    [sym_this] = ACTIONS(4470),
    [sym_abstract] = ACTIONS(4470),
    [sym_alias] = ACTIONS(4470),
    [sym_align] = ACTIONS(4470),
    [sym_asm] = ACTIONS(4470),
    [sym_assert] = ACTIONS(4470),
    [sym_auto] = ACTIONS(4470),
    [sym_break] = ACTIONS(4470),
    [sym_case] = ACTIONS(4470),
    [sym_cast] = ACTIONS(4470),
    [sym_class] = ACTIONS(4470),
    [sym_const] = ACTIONS(4470),
    [sym_continue] = ACTIONS(4470),
    [sym_debug] = ACTIONS(4470),
    [sym_default] = ACTIONS(4470),
    [sym_delegate] = ACTIONS(4470),
    [sym_delete] = ACTIONS(4470),
    [sym_deprecated] = ACTIONS(4470),
    [sym_do] = ACTIONS(4470),
    [sym_else] = ACTIONS(4470),
    [sym_enum] = ACTIONS(4470),
    [sym_export] = ACTIONS(4470),
    [sym_extern] = ACTIONS(4470),
    [sym_final] = ACTIONS(4470),
    [sym_for] = ACTIONS(4470),
    [sym_foreach] = ACTIONS(4470),
    [sym_foreach_reverse] = ACTIONS(4470),
    [sym_function] = ACTIONS(4470),
    [sym_goto] = ACTIONS(4470),
    [sym_if] = ACTIONS(4470),
    [sym_immutable] = ACTIONS(4470),
    [sym_import] = ACTIONS(4470),
    [sym_in] = ACTIONS(4470),
    [sym_inout] = ACTIONS(4470),
    [sym_interface] = ACTIONS(4470),
    [sym_invariant] = ACTIONS(4470),
    [sym_is] = ACTIONS(4470),
    [sym_mixin] = ACTIONS(4470),
    [sym_new] = ACTIONS(4470),
    [sym_nothrow] = ACTIONS(4470),
    [sym_out] = ACTIONS(4470),
    [sym_override] = ACTIONS(4470),
    [sym_package] = ACTIONS(4470),
    [sym_pragma] = ACTIONS(4470),
    [sym_private] = ACTIONS(4470),
    [sym_protected] = ACTIONS(4470),
    [sym_public] = ACTIONS(4470),
    [sym_pure] = ACTIONS(4470),
    [sym_ref] = ACTIONS(4470),
    [sym_return] = ACTIONS(4470),
    [sym_scope] = ACTIONS(4470),
    [sym_shared] = ACTIONS(4470),
    [sym_static] = ACTIONS(4470),
    [sym_struct] = ACTIONS(4470),
    [sym_switch] = ACTIONS(4470),
    [sym_synchronized] = ACTIONS(4470),
    [sym_template] = ACTIONS(4470),
    [sym_throw] = ACTIONS(4470),
    [sym_try] = ACTIONS(4470),
    [sym_typeid] = ACTIONS(4470),
    [sym_typeof] = ACTIONS(4470),
    [sym_union] = ACTIONS(4470),
    [sym_unittest] = ACTIONS(4470),
    [sym_version] = ACTIONS(4470),
    [sym_while] = ACTIONS(4470),
    [sym_with] = ACTIONS(4470),
    [sym_gshared] = ACTIONS(4470),
    [sym_traits] = ACTIONS(4470),
    [sym_vector] = ACTIONS(4470),
    [sym_void] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_r_DQUOTE] = ACTIONS(4472),
    [anon_sym_x_DQUOTE] = ACTIONS(4472),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_i_BQUOTE] = ACTIONS(4472),
    [anon_sym_i_DQUOTE] = ACTIONS(4472),
    [anon_sym_iq_LBRACE] = ACTIONS(4472),
    [aux_sym_char_literal_token1] = ACTIONS(4472),
    [anon_sym_SQUOTE] = ACTIONS(4470),
    [anon_sym___DATE__] = ACTIONS(4470),
    [anon_sym___FILE__] = ACTIONS(4470),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4470),
    [anon_sym___FUNCTION__] = ACTIONS(4470),
    [anon_sym___LINE__] = ACTIONS(4470),
    [anon_sym___MODULE__] = ACTIONS(4470),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4470),
    [anon_sym___TIME__] = ACTIONS(4470),
    [anon_sym___TIMESTAMP__] = ACTIONS(4470),
    [anon_sym___VENDOR__] = ACTIONS(4470),
    [anon_sym___VERSION__] = ACTIONS(4470),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4472),
    [sym_float_literal] = ACTIONS(4472),
    [sym__string] = ACTIONS(4472),
  },
  [1640] = {
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_q_LBRACE] = ACTIONS(4454),
    [anon_sym_RBRACE] = ACTIONS(4454),
    [anon_sym_LBRACE] = ACTIONS(4454),
    [anon_sym_DOT] = ACTIONS(4454),
    [anon_sym_AMP] = ACTIONS(4454),
    [anon_sym_DASH] = ACTIONS(4452),
    [anon_sym_DASH_DASH] = ACTIONS(4454),
    [anon_sym_PLUS] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4454),
    [anon_sym_BANG] = ACTIONS(4454),
    [anon_sym_LPAREN] = ACTIONS(4454),
    [anon_sym_RPAREN] = ACTIONS(4454),
    [anon_sym_LBRACK] = ACTIONS(4454),
    [anon_sym_SEMI] = ACTIONS(4454),
    [anon_sym_DOLLAR] = ACTIONS(4454),
    [anon_sym_STAR] = ACTIONS(4454),
    [anon_sym_TILDE] = ACTIONS(4454),
    [anon_sym_AT] = ACTIONS(4454),
    [sym_bool] = ACTIONS(4452),
    [sym_byte] = ACTIONS(4452),
    [sym_ubyte] = ACTIONS(4452),
    [sym_char] = ACTIONS(4452),
    [sym_short] = ACTIONS(4452),
    [sym_ushort] = ACTIONS(4452),
    [sym_int] = ACTIONS(4452),
    [sym_uint] = ACTIONS(4452),
    [sym_long] = ACTIONS(4452),
    [sym_ulong] = ACTIONS(4452),
    [sym_cent] = ACTIONS(4452),
    [sym_ucent] = ACTIONS(4452),
    [sym_wchar] = ACTIONS(4452),
    [sym_dchar] = ACTIONS(4452),
    [sym_float] = ACTIONS(4452),
    [sym_double] = ACTIONS(4452),
    [sym_real] = ACTIONS(4452),
    [sym_ifloat] = ACTIONS(4452),
    [sym_idouble] = ACTIONS(4452),
    [sym_ireal] = ACTIONS(4452),
    [sym_cfloat] = ACTIONS(4452),
    [sym_cdouble] = ACTIONS(4452),
    [sym_creal] = ACTIONS(4452),
    [sym_size_t] = ACTIONS(4452),
    [sym_ptrdiff_t] = ACTIONS(4452),
    [sym_string] = ACTIONS(4452),
    [sym_cstring] = ACTIONS(4452),
    [sym_dstring] = ACTIONS(4452),
    [sym_wstring] = ACTIONS(4452),
    [sym_noreturn] = ACTIONS(4452),
    [sym_true] = ACTIONS(4452),
    [sym_false] = ACTIONS(4452),
    [sym_null] = ACTIONS(4452),
    [sym_super] = ACTIONS(4452),
    [sym_this] = ACTIONS(4452),
    [sym_abstract] = ACTIONS(4452),
    [sym_alias] = ACTIONS(4452),
    [sym_align] = ACTIONS(4452),
    [sym_asm] = ACTIONS(4452),
    [sym_assert] = ACTIONS(4452),
    [sym_auto] = ACTIONS(4452),
    [sym_break] = ACTIONS(4452),
    [sym_case] = ACTIONS(4452),
    [sym_cast] = ACTIONS(4452),
    [sym_class] = ACTIONS(4452),
    [sym_const] = ACTIONS(4452),
    [sym_continue] = ACTIONS(4452),
    [sym_debug] = ACTIONS(4452),
    [sym_default] = ACTIONS(4452),
    [sym_delegate] = ACTIONS(4452),
    [sym_delete] = ACTIONS(4452),
    [sym_deprecated] = ACTIONS(4452),
    [sym_do] = ACTIONS(4452),
    [sym_else] = ACTIONS(4452),
    [sym_enum] = ACTIONS(4452),
    [sym_export] = ACTIONS(4452),
    [sym_extern] = ACTIONS(4452),
    [sym_final] = ACTIONS(4452),
    [sym_for] = ACTIONS(4452),
    [sym_foreach] = ACTIONS(4452),
    [sym_foreach_reverse] = ACTIONS(4452),
    [sym_function] = ACTIONS(4452),
    [sym_goto] = ACTIONS(4452),
    [sym_if] = ACTIONS(4452),
    [sym_immutable] = ACTIONS(4452),
    [sym_import] = ACTIONS(4452),
    [sym_in] = ACTIONS(4452),
    [sym_inout] = ACTIONS(4452),
    [sym_interface] = ACTIONS(4452),
    [sym_invariant] = ACTIONS(4452),
    [sym_is] = ACTIONS(4452),
    [sym_mixin] = ACTIONS(4452),
    [sym_new] = ACTIONS(4452),
    [sym_nothrow] = ACTIONS(4452),
    [sym_out] = ACTIONS(4452),
    [sym_override] = ACTIONS(4452),
    [sym_package] = ACTIONS(4452),
    [sym_pragma] = ACTIONS(4452),
    [sym_private] = ACTIONS(4452),
    [sym_protected] = ACTIONS(4452),
    [sym_public] = ACTIONS(4452),
    [sym_pure] = ACTIONS(4452),
    [sym_ref] = ACTIONS(4452),
    [sym_return] = ACTIONS(4452),
    [sym_scope] = ACTIONS(4452),
    [sym_shared] = ACTIONS(4452),
    [sym_static] = ACTIONS(4452),
    [sym_struct] = ACTIONS(4452),
    [sym_switch] = ACTIONS(4452),
    [sym_synchronized] = ACTIONS(4452),
    [sym_template] = ACTIONS(4452),
    [sym_throw] = ACTIONS(4452),
    [sym_try] = ACTIONS(4452),
    [sym_typeid] = ACTIONS(4452),
    [sym_typeof] = ACTIONS(4452),
    [sym_union] = ACTIONS(4452),
    [sym_unittest] = ACTIONS(4452),
    [sym_version] = ACTIONS(4452),
    [sym_while] = ACTIONS(4452),
    [sym_with] = ACTIONS(4452),
    [sym_gshared] = ACTIONS(4452),
    [sym_traits] = ACTIONS(4452),
    [sym_vector] = ACTIONS(4452),
    [sym_void] = ACTIONS(4452),
    [anon_sym_BQUOTE] = ACTIONS(4454),
    [anon_sym_r_DQUOTE] = ACTIONS(4454),
    [anon_sym_x_DQUOTE] = ACTIONS(4454),
    [anon_sym_DQUOTE] = ACTIONS(4454),
    [anon_sym_i_BQUOTE] = ACTIONS(4454),
    [anon_sym_i_DQUOTE] = ACTIONS(4454),
    [anon_sym_iq_LBRACE] = ACTIONS(4454),
    [aux_sym_char_literal_token1] = ACTIONS(4454),
    [anon_sym_SQUOTE] = ACTIONS(4452),
    [anon_sym___DATE__] = ACTIONS(4452),
    [anon_sym___FILE__] = ACTIONS(4452),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4452),
    [anon_sym___FUNCTION__] = ACTIONS(4452),
    [anon_sym___LINE__] = ACTIONS(4452),
    [anon_sym___MODULE__] = ACTIONS(4452),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4452),
    [anon_sym___TIME__] = ACTIONS(4452),
    [anon_sym___TIMESTAMP__] = ACTIONS(4452),
    [anon_sym___VENDOR__] = ACTIONS(4452),
    [anon_sym___VERSION__] = ACTIONS(4452),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4454),
    [sym_float_literal] = ACTIONS(4454),
    [sym__string] = ACTIONS(4454),
  },
  [1641] = {
    [sym_identifier] = ACTIONS(4961),
    [anon_sym_q_LBRACE] = ACTIONS(4963),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4963),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_DASH_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4963),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [anon_sym_RPAREN] = ACTIONS(4963),
    [anon_sym_LBRACK] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4963),
    [anon_sym_DOLLAR] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [anon_sym_AT] = ACTIONS(4963),
    [sym_bool] = ACTIONS(4961),
    [sym_byte] = ACTIONS(4961),
    [sym_ubyte] = ACTIONS(4961),
    [sym_char] = ACTIONS(4961),
    [sym_short] = ACTIONS(4961),
    [sym_ushort] = ACTIONS(4961),
    [sym_int] = ACTIONS(4961),
    [sym_uint] = ACTIONS(4961),
    [sym_long] = ACTIONS(4961),
    [sym_ulong] = ACTIONS(4961),
    [sym_cent] = ACTIONS(4961),
    [sym_ucent] = ACTIONS(4961),
    [sym_wchar] = ACTIONS(4961),
    [sym_dchar] = ACTIONS(4961),
    [sym_float] = ACTIONS(4961),
    [sym_double] = ACTIONS(4961),
    [sym_real] = ACTIONS(4961),
    [sym_ifloat] = ACTIONS(4961),
    [sym_idouble] = ACTIONS(4961),
    [sym_ireal] = ACTIONS(4961),
    [sym_cfloat] = ACTIONS(4961),
    [sym_cdouble] = ACTIONS(4961),
    [sym_creal] = ACTIONS(4961),
    [sym_size_t] = ACTIONS(4961),
    [sym_ptrdiff_t] = ACTIONS(4961),
    [sym_string] = ACTIONS(4961),
    [sym_cstring] = ACTIONS(4961),
    [sym_dstring] = ACTIONS(4961),
    [sym_wstring] = ACTIONS(4961),
    [sym_noreturn] = ACTIONS(4961),
    [sym_true] = ACTIONS(4961),
    [sym_false] = ACTIONS(4961),
    [sym_null] = ACTIONS(4961),
    [sym_super] = ACTIONS(4961),
    [sym_this] = ACTIONS(4961),
    [sym_abstract] = ACTIONS(4961),
    [sym_alias] = ACTIONS(4961),
    [sym_align] = ACTIONS(4961),
    [sym_asm] = ACTIONS(4961),
    [sym_assert] = ACTIONS(4961),
    [sym_auto] = ACTIONS(4961),
    [sym_break] = ACTIONS(4961),
    [sym_case] = ACTIONS(4961),
    [sym_cast] = ACTIONS(4961),
    [sym_class] = ACTIONS(4961),
    [sym_const] = ACTIONS(4961),
    [sym_continue] = ACTIONS(4961),
    [sym_debug] = ACTIONS(4961),
    [sym_default] = ACTIONS(4961),
    [sym_delegate] = ACTIONS(4961),
    [sym_delete] = ACTIONS(4961),
    [sym_deprecated] = ACTIONS(4961),
    [sym_do] = ACTIONS(4961),
    [sym_else] = ACTIONS(4961),
    [sym_enum] = ACTIONS(4961),
    [sym_export] = ACTIONS(4961),
    [sym_extern] = ACTIONS(4961),
    [sym_final] = ACTIONS(4961),
    [sym_for] = ACTIONS(4961),
    [sym_foreach] = ACTIONS(4961),
    [sym_foreach_reverse] = ACTIONS(4961),
    [sym_function] = ACTIONS(4961),
    [sym_goto] = ACTIONS(4961),
    [sym_if] = ACTIONS(4961),
    [sym_immutable] = ACTIONS(4961),
    [sym_import] = ACTIONS(4961),
    [sym_in] = ACTIONS(4961),
    [sym_inout] = ACTIONS(4961),
    [sym_interface] = ACTIONS(4961),
    [sym_invariant] = ACTIONS(4961),
    [sym_is] = ACTIONS(4961),
    [sym_mixin] = ACTIONS(4961),
    [sym_new] = ACTIONS(4961),
    [sym_nothrow] = ACTIONS(4961),
    [sym_out] = ACTIONS(4961),
    [sym_override] = ACTIONS(4961),
    [sym_package] = ACTIONS(4961),
    [sym_pragma] = ACTIONS(4961),
    [sym_private] = ACTIONS(4961),
    [sym_protected] = ACTIONS(4961),
    [sym_public] = ACTIONS(4961),
    [sym_pure] = ACTIONS(4961),
    [sym_ref] = ACTIONS(4961),
    [sym_return] = ACTIONS(4961),
    [sym_scope] = ACTIONS(4961),
    [sym_shared] = ACTIONS(4961),
    [sym_static] = ACTIONS(4961),
    [sym_struct] = ACTIONS(4961),
    [sym_switch] = ACTIONS(4961),
    [sym_synchronized] = ACTIONS(4961),
    [sym_template] = ACTIONS(4961),
    [sym_throw] = ACTIONS(4961),
    [sym_try] = ACTIONS(4961),
    [sym_typeid] = ACTIONS(4961),
    [sym_typeof] = ACTIONS(4961),
    [sym_union] = ACTIONS(4961),
    [sym_unittest] = ACTIONS(4961),
    [sym_version] = ACTIONS(4961),
    [sym_while] = ACTIONS(4961),
    [sym_with] = ACTIONS(4961),
    [sym_gshared] = ACTIONS(4961),
    [sym_traits] = ACTIONS(4961),
    [sym_vector] = ACTIONS(4961),
    [sym_void] = ACTIONS(4961),
    [anon_sym_BQUOTE] = ACTIONS(4963),
    [anon_sym_r_DQUOTE] = ACTIONS(4963),
    [anon_sym_x_DQUOTE] = ACTIONS(4963),
    [anon_sym_DQUOTE] = ACTIONS(4963),
    [anon_sym_i_BQUOTE] = ACTIONS(4963),
    [anon_sym_i_DQUOTE] = ACTIONS(4963),
    [anon_sym_iq_LBRACE] = ACTIONS(4963),
    [aux_sym_char_literal_token1] = ACTIONS(4963),
    [anon_sym_SQUOTE] = ACTIONS(4961),
    [anon_sym___DATE__] = ACTIONS(4961),
    [anon_sym___FILE__] = ACTIONS(4961),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4961),
    [anon_sym___FUNCTION__] = ACTIONS(4961),
    [anon_sym___LINE__] = ACTIONS(4961),
    [anon_sym___MODULE__] = ACTIONS(4961),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4961),
    [anon_sym___TIME__] = ACTIONS(4961),
    [anon_sym___TIMESTAMP__] = ACTIONS(4961),
    [anon_sym___VENDOR__] = ACTIONS(4961),
    [anon_sym___VERSION__] = ACTIONS(4961),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4963),
    [sym_float_literal] = ACTIONS(4963),
    [sym__string] = ACTIONS(4963),
  },
  [1642] = {
    [sym_identifier] = ACTIONS(4971),
    [anon_sym_q_LBRACE] = ACTIONS(4973),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4973),
    [anon_sym_DOT] = ACTIONS(4973),
    [anon_sym_AMP] = ACTIONS(4973),
    [anon_sym_DASH] = ACTIONS(4971),
    [anon_sym_DASH_DASH] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4971),
    [anon_sym_PLUS_PLUS] = ACTIONS(4973),
    [anon_sym_BANG] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4973),
    [anon_sym_RPAREN] = ACTIONS(4973),
    [anon_sym_LBRACK] = ACTIONS(4973),
    [anon_sym_SEMI] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4973),
    [anon_sym_STAR] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_AT] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4971),
    [sym_byte] = ACTIONS(4971),
    [sym_ubyte] = ACTIONS(4971),
    [sym_char] = ACTIONS(4971),
    [sym_short] = ACTIONS(4971),
    [sym_ushort] = ACTIONS(4971),
    [sym_int] = ACTIONS(4971),
    [sym_uint] = ACTIONS(4971),
    [sym_long] = ACTIONS(4971),
    [sym_ulong] = ACTIONS(4971),
    [sym_cent] = ACTIONS(4971),
    [sym_ucent] = ACTIONS(4971),
    [sym_wchar] = ACTIONS(4971),
    [sym_dchar] = ACTIONS(4971),
    [sym_float] = ACTIONS(4971),
    [sym_double] = ACTIONS(4971),
    [sym_real] = ACTIONS(4971),
    [sym_ifloat] = ACTIONS(4971),
    [sym_idouble] = ACTIONS(4971),
    [sym_ireal] = ACTIONS(4971),
    [sym_cfloat] = ACTIONS(4971),
    [sym_cdouble] = ACTIONS(4971),
    [sym_creal] = ACTIONS(4971),
    [sym_size_t] = ACTIONS(4971),
    [sym_ptrdiff_t] = ACTIONS(4971),
    [sym_string] = ACTIONS(4971),
    [sym_cstring] = ACTIONS(4971),
    [sym_dstring] = ACTIONS(4971),
    [sym_wstring] = ACTIONS(4971),
    [sym_noreturn] = ACTIONS(4971),
    [sym_true] = ACTIONS(4971),
    [sym_false] = ACTIONS(4971),
    [sym_null] = ACTIONS(4971),
    [sym_super] = ACTIONS(4971),
    [sym_this] = ACTIONS(4971),
    [sym_abstract] = ACTIONS(4971),
    [sym_alias] = ACTIONS(4971),
    [sym_align] = ACTIONS(4971),
    [sym_asm] = ACTIONS(4971),
    [sym_assert] = ACTIONS(4971),
    [sym_auto] = ACTIONS(4971),
    [sym_break] = ACTIONS(4971),
    [sym_case] = ACTIONS(4971),
    [sym_cast] = ACTIONS(4971),
    [sym_class] = ACTIONS(4971),
    [sym_const] = ACTIONS(4971),
    [sym_continue] = ACTIONS(4971),
    [sym_debug] = ACTIONS(4971),
    [sym_default] = ACTIONS(4971),
    [sym_delegate] = ACTIONS(4971),
    [sym_delete] = ACTIONS(4971),
    [sym_deprecated] = ACTIONS(4971),
    [sym_do] = ACTIONS(4971),
    [sym_else] = ACTIONS(4971),
    [sym_enum] = ACTIONS(4971),
    [sym_export] = ACTIONS(4971),
    [sym_extern] = ACTIONS(4971),
    [sym_final] = ACTIONS(4971),
    [sym_for] = ACTIONS(4971),
    [sym_foreach] = ACTIONS(4971),
    [sym_foreach_reverse] = ACTIONS(4971),
    [sym_function] = ACTIONS(4971),
    [sym_goto] = ACTIONS(4971),
    [sym_if] = ACTIONS(4971),
    [sym_immutable] = ACTIONS(4971),
    [sym_import] = ACTIONS(4971),
    [sym_in] = ACTIONS(4971),
    [sym_inout] = ACTIONS(4971),
    [sym_interface] = ACTIONS(4971),
    [sym_invariant] = ACTIONS(4971),
    [sym_is] = ACTIONS(4971),
    [sym_mixin] = ACTIONS(4971),
    [sym_new] = ACTIONS(4971),
    [sym_nothrow] = ACTIONS(4971),
    [sym_out] = ACTIONS(4971),
    [sym_override] = ACTIONS(4971),
    [sym_package] = ACTIONS(4971),
    [sym_pragma] = ACTIONS(4971),
    [sym_private] = ACTIONS(4971),
    [sym_protected] = ACTIONS(4971),
    [sym_public] = ACTIONS(4971),
    [sym_pure] = ACTIONS(4971),
    [sym_ref] = ACTIONS(4971),
    [sym_return] = ACTIONS(4971),
    [sym_scope] = ACTIONS(4971),
    [sym_shared] = ACTIONS(4971),
    [sym_static] = ACTIONS(4971),
    [sym_struct] = ACTIONS(4971),
    [sym_switch] = ACTIONS(4971),
    [sym_synchronized] = ACTIONS(4971),
    [sym_template] = ACTIONS(4971),
    [sym_throw] = ACTIONS(4971),
    [sym_try] = ACTIONS(4971),
    [sym_typeid] = ACTIONS(4971),
    [sym_typeof] = ACTIONS(4971),
    [sym_union] = ACTIONS(4971),
    [sym_unittest] = ACTIONS(4971),
    [sym_version] = ACTIONS(4971),
    [sym_while] = ACTIONS(4971),
    [sym_with] = ACTIONS(4971),
    [sym_gshared] = ACTIONS(4971),
    [sym_traits] = ACTIONS(4971),
    [sym_vector] = ACTIONS(4971),
    [sym_void] = ACTIONS(4971),
    [anon_sym_BQUOTE] = ACTIONS(4973),
    [anon_sym_r_DQUOTE] = ACTIONS(4973),
    [anon_sym_x_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_i_BQUOTE] = ACTIONS(4973),
    [anon_sym_i_DQUOTE] = ACTIONS(4973),
    [anon_sym_iq_LBRACE] = ACTIONS(4973),
    [aux_sym_char_literal_token1] = ACTIONS(4973),
    [anon_sym_SQUOTE] = ACTIONS(4971),
    [anon_sym___DATE__] = ACTIONS(4971),
    [anon_sym___FILE__] = ACTIONS(4971),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4971),
    [anon_sym___FUNCTION__] = ACTIONS(4971),
    [anon_sym___LINE__] = ACTIONS(4971),
    [anon_sym___MODULE__] = ACTIONS(4971),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4971),
    [anon_sym___TIME__] = ACTIONS(4971),
    [anon_sym___TIMESTAMP__] = ACTIONS(4971),
    [anon_sym___VENDOR__] = ACTIONS(4971),
    [anon_sym___VERSION__] = ACTIONS(4971),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4973),
    [sym_float_literal] = ACTIONS(4973),
    [sym__string] = ACTIONS(4973),
  },
  [1643] = {
    [sym_identifier] = ACTIONS(4652),
    [anon_sym_q_LBRACE] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4654),
    [anon_sym_AMP] = ACTIONS(4654),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_DOLLAR] = ACTIONS(4654),
    [anon_sym_STAR] = ACTIONS(4654),
    [anon_sym_TILDE] = ACTIONS(4654),
    [anon_sym_AT] = ACTIONS(4654),
    [sym_bool] = ACTIONS(4652),
    [sym_byte] = ACTIONS(4652),
    [sym_ubyte] = ACTIONS(4652),
    [sym_char] = ACTIONS(4652),
    [sym_short] = ACTIONS(4652),
    [sym_ushort] = ACTIONS(4652),
    [sym_int] = ACTIONS(4652),
    [sym_uint] = ACTIONS(4652),
    [sym_long] = ACTIONS(4652),
    [sym_ulong] = ACTIONS(4652),
    [sym_cent] = ACTIONS(4652),
    [sym_ucent] = ACTIONS(4652),
    [sym_wchar] = ACTIONS(4652),
    [sym_dchar] = ACTIONS(4652),
    [sym_float] = ACTIONS(4652),
    [sym_double] = ACTIONS(4652),
    [sym_real] = ACTIONS(4652),
    [sym_ifloat] = ACTIONS(4652),
    [sym_idouble] = ACTIONS(4652),
    [sym_ireal] = ACTIONS(4652),
    [sym_cfloat] = ACTIONS(4652),
    [sym_cdouble] = ACTIONS(4652),
    [sym_creal] = ACTIONS(4652),
    [sym_size_t] = ACTIONS(4652),
    [sym_ptrdiff_t] = ACTIONS(4652),
    [sym_string] = ACTIONS(4652),
    [sym_cstring] = ACTIONS(4652),
    [sym_dstring] = ACTIONS(4652),
    [sym_wstring] = ACTIONS(4652),
    [sym_noreturn] = ACTIONS(4652),
    [sym_true] = ACTIONS(4652),
    [sym_false] = ACTIONS(4652),
    [sym_null] = ACTIONS(4652),
    [sym_super] = ACTIONS(4652),
    [sym_this] = ACTIONS(4652),
    [sym_abstract] = ACTIONS(4652),
    [sym_alias] = ACTIONS(4652),
    [sym_align] = ACTIONS(4652),
    [sym_asm] = ACTIONS(4652),
    [sym_assert] = ACTIONS(4652),
    [sym_auto] = ACTIONS(4652),
    [sym_break] = ACTIONS(4652),
    [sym_case] = ACTIONS(4652),
    [sym_cast] = ACTIONS(4652),
    [sym_class] = ACTIONS(4652),
    [sym_const] = ACTIONS(4652),
    [sym_continue] = ACTIONS(4652),
    [sym_debug] = ACTIONS(4652),
    [sym_default] = ACTIONS(4652),
    [sym_delegate] = ACTIONS(4652),
    [sym_delete] = ACTIONS(4652),
    [sym_deprecated] = ACTIONS(4652),
    [sym_do] = ACTIONS(4652),
    [sym_else] = ACTIONS(4652),
    [sym_enum] = ACTIONS(4652),
    [sym_export] = ACTIONS(4652),
    [sym_extern] = ACTIONS(4652),
    [sym_final] = ACTIONS(4652),
    [sym_for] = ACTIONS(4652),
    [sym_foreach] = ACTIONS(4652),
    [sym_foreach_reverse] = ACTIONS(4652),
    [sym_function] = ACTIONS(4652),
    [sym_goto] = ACTIONS(4652),
    [sym_if] = ACTIONS(4652),
    [sym_immutable] = ACTIONS(4652),
    [sym_import] = ACTIONS(4652),
    [sym_in] = ACTIONS(4652),
    [sym_inout] = ACTIONS(4652),
    [sym_interface] = ACTIONS(4652),
    [sym_invariant] = ACTIONS(4652),
    [sym_is] = ACTIONS(4652),
    [sym_mixin] = ACTIONS(4652),
    [sym_new] = ACTIONS(4652),
    [sym_nothrow] = ACTIONS(4652),
    [sym_out] = ACTIONS(4652),
    [sym_override] = ACTIONS(4652),
    [sym_package] = ACTIONS(4652),
    [sym_pragma] = ACTIONS(4652),
    [sym_private] = ACTIONS(4652),
    [sym_protected] = ACTIONS(4652),
    [sym_public] = ACTIONS(4652),
    [sym_pure] = ACTIONS(4652),
    [sym_ref] = ACTIONS(4652),
    [sym_return] = ACTIONS(4652),
    [sym_scope] = ACTIONS(4652),
    [sym_shared] = ACTIONS(4652),
    [sym_static] = ACTIONS(4652),
    [sym_struct] = ACTIONS(4652),
    [sym_switch] = ACTIONS(4652),
    [sym_synchronized] = ACTIONS(4652),
    [sym_template] = ACTIONS(4652),
    [sym_throw] = ACTIONS(4652),
    [sym_try] = ACTIONS(4652),
    [sym_typeid] = ACTIONS(4652),
    [sym_typeof] = ACTIONS(4652),
    [sym_union] = ACTIONS(4652),
    [sym_unittest] = ACTIONS(4652),
    [sym_version] = ACTIONS(4652),
    [sym_while] = ACTIONS(4652),
    [sym_with] = ACTIONS(4652),
    [sym_gshared] = ACTIONS(4652),
    [sym_traits] = ACTIONS(4652),
    [sym_vector] = ACTIONS(4652),
    [sym_void] = ACTIONS(4652),
    [anon_sym_BQUOTE] = ACTIONS(4654),
    [anon_sym_r_DQUOTE] = ACTIONS(4654),
    [anon_sym_x_DQUOTE] = ACTIONS(4654),
    [anon_sym_DQUOTE] = ACTIONS(4654),
    [anon_sym_i_BQUOTE] = ACTIONS(4654),
    [anon_sym_i_DQUOTE] = ACTIONS(4654),
    [anon_sym_iq_LBRACE] = ACTIONS(4654),
    [aux_sym_char_literal_token1] = ACTIONS(4654),
    [anon_sym_SQUOTE] = ACTIONS(4652),
    [anon_sym___DATE__] = ACTIONS(4652),
    [anon_sym___FILE__] = ACTIONS(4652),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4652),
    [anon_sym___FUNCTION__] = ACTIONS(4652),
    [anon_sym___LINE__] = ACTIONS(4652),
    [anon_sym___MODULE__] = ACTIONS(4652),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4652),
    [anon_sym___TIME__] = ACTIONS(4652),
    [anon_sym___TIMESTAMP__] = ACTIONS(4652),
    [anon_sym___VENDOR__] = ACTIONS(4652),
    [anon_sym___VERSION__] = ACTIONS(4652),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4654),
    [sym_float_literal] = ACTIONS(4654),
    [sym__string] = ACTIONS(4654),
  },
  [1644] = {
    [sym_identifier] = ACTIONS(4466),
    [anon_sym_q_LBRACE] = ACTIONS(4468),
    [anon_sym_RBRACE] = ACTIONS(4468),
    [anon_sym_LBRACE] = ACTIONS(4468),
    [anon_sym_DOT] = ACTIONS(4468),
    [anon_sym_AMP] = ACTIONS(4468),
    [anon_sym_DASH] = ACTIONS(4466),
    [anon_sym_DASH_DASH] = ACTIONS(4468),
    [anon_sym_PLUS] = ACTIONS(4466),
    [anon_sym_PLUS_PLUS] = ACTIONS(4468),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_LPAREN] = ACTIONS(4468),
    [anon_sym_RPAREN] = ACTIONS(4468),
    [anon_sym_LBRACK] = ACTIONS(4468),
    [anon_sym_SEMI] = ACTIONS(4468),
    [anon_sym_DOLLAR] = ACTIONS(4468),
    [anon_sym_STAR] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [anon_sym_AT] = ACTIONS(4468),
    [sym_bool] = ACTIONS(4466),
    [sym_byte] = ACTIONS(4466),
    [sym_ubyte] = ACTIONS(4466),
    [sym_char] = ACTIONS(4466),
    [sym_short] = ACTIONS(4466),
    [sym_ushort] = ACTIONS(4466),
    [sym_int] = ACTIONS(4466),
    [sym_uint] = ACTIONS(4466),
    [sym_long] = ACTIONS(4466),
    [sym_ulong] = ACTIONS(4466),
    [sym_cent] = ACTIONS(4466),
    [sym_ucent] = ACTIONS(4466),
    [sym_wchar] = ACTIONS(4466),
    [sym_dchar] = ACTIONS(4466),
    [sym_float] = ACTIONS(4466),
    [sym_double] = ACTIONS(4466),
    [sym_real] = ACTIONS(4466),
    [sym_ifloat] = ACTIONS(4466),
    [sym_idouble] = ACTIONS(4466),
    [sym_ireal] = ACTIONS(4466),
    [sym_cfloat] = ACTIONS(4466),
    [sym_cdouble] = ACTIONS(4466),
    [sym_creal] = ACTIONS(4466),
    [sym_size_t] = ACTIONS(4466),
    [sym_ptrdiff_t] = ACTIONS(4466),
    [sym_string] = ACTIONS(4466),
    [sym_cstring] = ACTIONS(4466),
    [sym_dstring] = ACTIONS(4466),
    [sym_wstring] = ACTIONS(4466),
    [sym_noreturn] = ACTIONS(4466),
    [sym_true] = ACTIONS(4466),
    [sym_false] = ACTIONS(4466),
    [sym_null] = ACTIONS(4466),
    [sym_super] = ACTIONS(4466),
    [sym_this] = ACTIONS(4466),
    [sym_abstract] = ACTIONS(4466),
    [sym_alias] = ACTIONS(4466),
    [sym_align] = ACTIONS(4466),
    [sym_asm] = ACTIONS(4466),
    [sym_assert] = ACTIONS(4466),
    [sym_auto] = ACTIONS(4466),
    [sym_break] = ACTIONS(4466),
    [sym_case] = ACTIONS(4466),
    [sym_cast] = ACTIONS(4466),
    [sym_class] = ACTIONS(4466),
    [sym_const] = ACTIONS(4466),
    [sym_continue] = ACTIONS(4466),
    [sym_debug] = ACTIONS(4466),
    [sym_default] = ACTIONS(4466),
    [sym_delegate] = ACTIONS(4466),
    [sym_delete] = ACTIONS(4466),
    [sym_deprecated] = ACTIONS(4466),
    [sym_do] = ACTIONS(4466),
    [sym_else] = ACTIONS(4466),
    [sym_enum] = ACTIONS(4466),
    [sym_export] = ACTIONS(4466),
    [sym_extern] = ACTIONS(4466),
    [sym_final] = ACTIONS(4466),
    [sym_for] = ACTIONS(4466),
    [sym_foreach] = ACTIONS(4466),
    [sym_foreach_reverse] = ACTIONS(4466),
    [sym_function] = ACTIONS(4466),
    [sym_goto] = ACTIONS(4466),
    [sym_if] = ACTIONS(4466),
    [sym_immutable] = ACTIONS(4466),
    [sym_import] = ACTIONS(4466),
    [sym_in] = ACTIONS(4466),
    [sym_inout] = ACTIONS(4466),
    [sym_interface] = ACTIONS(4466),
    [sym_invariant] = ACTIONS(4466),
    [sym_is] = ACTIONS(4466),
    [sym_mixin] = ACTIONS(4466),
    [sym_new] = ACTIONS(4466),
    [sym_nothrow] = ACTIONS(4466),
    [sym_out] = ACTIONS(4466),
    [sym_override] = ACTIONS(4466),
    [sym_package] = ACTIONS(4466),
    [sym_pragma] = ACTIONS(4466),
    [sym_private] = ACTIONS(4466),
    [sym_protected] = ACTIONS(4466),
    [sym_public] = ACTIONS(4466),
    [sym_pure] = ACTIONS(4466),
    [sym_ref] = ACTIONS(4466),
    [sym_return] = ACTIONS(4466),
    [sym_scope] = ACTIONS(4466),
    [sym_shared] = ACTIONS(4466),
    [sym_static] = ACTIONS(4466),
    [sym_struct] = ACTIONS(4466),
    [sym_switch] = ACTIONS(4466),
    [sym_synchronized] = ACTIONS(4466),
    [sym_template] = ACTIONS(4466),
    [sym_throw] = ACTIONS(4466),
    [sym_try] = ACTIONS(4466),
    [sym_typeid] = ACTIONS(4466),
    [sym_typeof] = ACTIONS(4466),
    [sym_union] = ACTIONS(4466),
    [sym_unittest] = ACTIONS(4466),
    [sym_version] = ACTIONS(4466),
    [sym_while] = ACTIONS(4466),
    [sym_with] = ACTIONS(4466),
    [sym_gshared] = ACTIONS(4466),
    [sym_traits] = ACTIONS(4466),
    [sym_vector] = ACTIONS(4466),
    [sym_void] = ACTIONS(4466),
    [anon_sym_BQUOTE] = ACTIONS(4468),
    [anon_sym_r_DQUOTE] = ACTIONS(4468),
    [anon_sym_x_DQUOTE] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4468),
    [anon_sym_i_BQUOTE] = ACTIONS(4468),
    [anon_sym_i_DQUOTE] = ACTIONS(4468),
    [anon_sym_iq_LBRACE] = ACTIONS(4468),
    [aux_sym_char_literal_token1] = ACTIONS(4468),
    [anon_sym_SQUOTE] = ACTIONS(4466),
    [anon_sym___DATE__] = ACTIONS(4466),
    [anon_sym___FILE__] = ACTIONS(4466),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4466),
    [anon_sym___FUNCTION__] = ACTIONS(4466),
    [anon_sym___LINE__] = ACTIONS(4466),
    [anon_sym___MODULE__] = ACTIONS(4466),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4466),
    [anon_sym___TIME__] = ACTIONS(4466),
    [anon_sym___TIMESTAMP__] = ACTIONS(4466),
    [anon_sym___VENDOR__] = ACTIONS(4466),
    [anon_sym___VERSION__] = ACTIONS(4466),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4468),
    [sym_float_literal] = ACTIONS(4468),
    [sym__string] = ACTIONS(4468),
  },
  [1645] = {
    [sym_identifier] = ACTIONS(4991),
    [anon_sym_q_LBRACE] = ACTIONS(4993),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4991),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_LPAREN] = ACTIONS(4993),
    [anon_sym_RPAREN] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_AT] = ACTIONS(4993),
    [sym_bool] = ACTIONS(4991),
    [sym_byte] = ACTIONS(4991),
    [sym_ubyte] = ACTIONS(4991),
    [sym_char] = ACTIONS(4991),
    [sym_short] = ACTIONS(4991),
    [sym_ushort] = ACTIONS(4991),
    [sym_int] = ACTIONS(4991),
    [sym_uint] = ACTIONS(4991),
    [sym_long] = ACTIONS(4991),
    [sym_ulong] = ACTIONS(4991),
    [sym_cent] = ACTIONS(4991),
    [sym_ucent] = ACTIONS(4991),
    [sym_wchar] = ACTIONS(4991),
    [sym_dchar] = ACTIONS(4991),
    [sym_float] = ACTIONS(4991),
    [sym_double] = ACTIONS(4991),
    [sym_real] = ACTIONS(4991),
    [sym_ifloat] = ACTIONS(4991),
    [sym_idouble] = ACTIONS(4991),
    [sym_ireal] = ACTIONS(4991),
    [sym_cfloat] = ACTIONS(4991),
    [sym_cdouble] = ACTIONS(4991),
    [sym_creal] = ACTIONS(4991),
    [sym_size_t] = ACTIONS(4991),
    [sym_ptrdiff_t] = ACTIONS(4991),
    [sym_string] = ACTIONS(4991),
    [sym_cstring] = ACTIONS(4991),
    [sym_dstring] = ACTIONS(4991),
    [sym_wstring] = ACTIONS(4991),
    [sym_noreturn] = ACTIONS(4991),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_super] = ACTIONS(4991),
    [sym_this] = ACTIONS(4991),
    [sym_abstract] = ACTIONS(4991),
    [sym_alias] = ACTIONS(4991),
    [sym_align] = ACTIONS(4991),
    [sym_asm] = ACTIONS(4991),
    [sym_assert] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [sym_break] = ACTIONS(4991),
    [sym_case] = ACTIONS(4991),
    [sym_cast] = ACTIONS(4991),
    [sym_class] = ACTIONS(4991),
    [sym_const] = ACTIONS(4991),
    [sym_continue] = ACTIONS(4991),
    [sym_debug] = ACTIONS(4991),
    [sym_default] = ACTIONS(4991),
    [sym_delegate] = ACTIONS(4991),
    [sym_delete] = ACTIONS(4991),
    [sym_deprecated] = ACTIONS(4991),
    [sym_do] = ACTIONS(4991),
    [sym_else] = ACTIONS(4991),
    [sym_enum] = ACTIONS(4991),
    [sym_export] = ACTIONS(4991),
    [sym_extern] = ACTIONS(4991),
    [sym_final] = ACTIONS(4991),
    [sym_for] = ACTIONS(4991),
    [sym_foreach] = ACTIONS(4991),
    [sym_foreach_reverse] = ACTIONS(4991),
    [sym_function] = ACTIONS(4991),
    [sym_goto] = ACTIONS(4991),
    [sym_if] = ACTIONS(4991),
    [sym_immutable] = ACTIONS(4991),
    [sym_import] = ACTIONS(4991),
    [sym_in] = ACTIONS(4991),
    [sym_inout] = ACTIONS(4991),
    [sym_interface] = ACTIONS(4991),
    [sym_invariant] = ACTIONS(4991),
    [sym_is] = ACTIONS(4991),
    [sym_mixin] = ACTIONS(4991),
    [sym_new] = ACTIONS(4991),
    [sym_nothrow] = ACTIONS(4991),
    [sym_out] = ACTIONS(4991),
    [sym_override] = ACTIONS(4991),
    [sym_package] = ACTIONS(4991),
    [sym_pragma] = ACTIONS(4991),
    [sym_private] = ACTIONS(4991),
    [sym_protected] = ACTIONS(4991),
    [sym_public] = ACTIONS(4991),
    [sym_pure] = ACTIONS(4991),
    [sym_ref] = ACTIONS(4991),
    [sym_return] = ACTIONS(4991),
    [sym_scope] = ACTIONS(4991),
    [sym_shared] = ACTIONS(4991),
    [sym_static] = ACTIONS(4991),
    [sym_struct] = ACTIONS(4991),
    [sym_switch] = ACTIONS(4991),
    [sym_synchronized] = ACTIONS(4991),
    [sym_template] = ACTIONS(4991),
    [sym_throw] = ACTIONS(4991),
    [sym_try] = ACTIONS(4991),
    [sym_typeid] = ACTIONS(4991),
    [sym_typeof] = ACTIONS(4991),
    [sym_union] = ACTIONS(4991),
    [sym_unittest] = ACTIONS(4991),
    [sym_version] = ACTIONS(4991),
    [sym_while] = ACTIONS(4991),
    [sym_with] = ACTIONS(4991),
    [sym_gshared] = ACTIONS(4991),
    [sym_traits] = ACTIONS(4991),
    [sym_vector] = ACTIONS(4991),
    [sym_void] = ACTIONS(4991),
    [anon_sym_BQUOTE] = ACTIONS(4993),
    [anon_sym_r_DQUOTE] = ACTIONS(4993),
    [anon_sym_x_DQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_i_BQUOTE] = ACTIONS(4993),
    [anon_sym_i_DQUOTE] = ACTIONS(4993),
    [anon_sym_iq_LBRACE] = ACTIONS(4993),
    [aux_sym_char_literal_token1] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4991),
    [anon_sym___DATE__] = ACTIONS(4991),
    [anon_sym___FILE__] = ACTIONS(4991),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4991),
    [anon_sym___FUNCTION__] = ACTIONS(4991),
    [anon_sym___LINE__] = ACTIONS(4991),
    [anon_sym___MODULE__] = ACTIONS(4991),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4991),
    [anon_sym___TIME__] = ACTIONS(4991),
    [anon_sym___TIMESTAMP__] = ACTIONS(4991),
    [anon_sym___VENDOR__] = ACTIONS(4991),
    [anon_sym___VERSION__] = ACTIONS(4991),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4993),
    [sym_float_literal] = ACTIONS(4993),
    [sym__string] = ACTIONS(4993),
  },
  [1646] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_asm] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_break] = ACTIONS(2505),
    [sym_case] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_continue] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_default] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(5028),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_for] = ACTIONS(2505),
    [sym_foreach] = ACTIONS(2505),
    [sym_foreach_reverse] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_goto] = ACTIONS(2505),
    [sym_if] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_switch] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_try] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_with] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [1647] = {
    [sym_identifier] = ACTIONS(4999),
    [anon_sym_q_LBRACE] = ACTIONS(5001),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(5001),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(5001),
    [anon_sym_PLUS] = ACTIONS(4999),
    [anon_sym_PLUS_PLUS] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_LPAREN] = ACTIONS(5001),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [anon_sym_LBRACK] = ACTIONS(5001),
    [anon_sym_SEMI] = ACTIONS(5001),
    [anon_sym_DOLLAR] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5001),
    [anon_sym_AT] = ACTIONS(5001),
    [sym_bool] = ACTIONS(4999),
    [sym_byte] = ACTIONS(4999),
    [sym_ubyte] = ACTIONS(4999),
    [sym_char] = ACTIONS(4999),
    [sym_short] = ACTIONS(4999),
    [sym_ushort] = ACTIONS(4999),
    [sym_int] = ACTIONS(4999),
    [sym_uint] = ACTIONS(4999),
    [sym_long] = ACTIONS(4999),
    [sym_ulong] = ACTIONS(4999),
    [sym_cent] = ACTIONS(4999),
    [sym_ucent] = ACTIONS(4999),
    [sym_wchar] = ACTIONS(4999),
    [sym_dchar] = ACTIONS(4999),
    [sym_float] = ACTIONS(4999),
    [sym_double] = ACTIONS(4999),
    [sym_real] = ACTIONS(4999),
    [sym_ifloat] = ACTIONS(4999),
    [sym_idouble] = ACTIONS(4999),
    [sym_ireal] = ACTIONS(4999),
    [sym_cfloat] = ACTIONS(4999),
    [sym_cdouble] = ACTIONS(4999),
    [sym_creal] = ACTIONS(4999),
    [sym_size_t] = ACTIONS(4999),
    [sym_ptrdiff_t] = ACTIONS(4999),
    [sym_string] = ACTIONS(4999),
    [sym_cstring] = ACTIONS(4999),
    [sym_dstring] = ACTIONS(4999),
    [sym_wstring] = ACTIONS(4999),
    [sym_noreturn] = ACTIONS(4999),
    [sym_true] = ACTIONS(4999),
    [sym_false] = ACTIONS(4999),
    [sym_null] = ACTIONS(4999),
    [sym_super] = ACTIONS(4999),
    [sym_this] = ACTIONS(4999),
    [sym_abstract] = ACTIONS(4999),
    [sym_alias] = ACTIONS(4999),
    [sym_align] = ACTIONS(4999),
    [sym_asm] = ACTIONS(4999),
    [sym_assert] = ACTIONS(4999),
    [sym_auto] = ACTIONS(4999),
    [sym_break] = ACTIONS(4999),
    [sym_case] = ACTIONS(4999),
    [sym_cast] = ACTIONS(4999),
    [sym_class] = ACTIONS(4999),
    [sym_const] = ACTIONS(4999),
    [sym_continue] = ACTIONS(4999),
    [sym_debug] = ACTIONS(4999),
    [sym_default] = ACTIONS(4999),
    [sym_delegate] = ACTIONS(4999),
    [sym_delete] = ACTIONS(4999),
    [sym_deprecated] = ACTIONS(4999),
    [sym_do] = ACTIONS(4999),
    [sym_else] = ACTIONS(4999),
    [sym_enum] = ACTIONS(4999),
    [sym_export] = ACTIONS(4999),
    [sym_extern] = ACTIONS(4999),
    [sym_final] = ACTIONS(4999),
    [sym_for] = ACTIONS(4999),
    [sym_foreach] = ACTIONS(4999),
    [sym_foreach_reverse] = ACTIONS(4999),
    [sym_function] = ACTIONS(4999),
    [sym_goto] = ACTIONS(4999),
    [sym_if] = ACTIONS(4999),
    [sym_immutable] = ACTIONS(4999),
    [sym_import] = ACTIONS(4999),
    [sym_in] = ACTIONS(4999),
    [sym_inout] = ACTIONS(4999),
    [sym_interface] = ACTIONS(4999),
    [sym_invariant] = ACTIONS(4999),
    [sym_is] = ACTIONS(4999),
    [sym_mixin] = ACTIONS(4999),
    [sym_new] = ACTIONS(4999),
    [sym_nothrow] = ACTIONS(4999),
    [sym_out] = ACTIONS(4999),
    [sym_override] = ACTIONS(4999),
    [sym_package] = ACTIONS(4999),
    [sym_pragma] = ACTIONS(4999),
    [sym_private] = ACTIONS(4999),
    [sym_protected] = ACTIONS(4999),
    [sym_public] = ACTIONS(4999),
    [sym_pure] = ACTIONS(4999),
    [sym_ref] = ACTIONS(4999),
    [sym_return] = ACTIONS(4999),
    [sym_scope] = ACTIONS(4999),
    [sym_shared] = ACTIONS(4999),
    [sym_static] = ACTIONS(4999),
    [sym_struct] = ACTIONS(4999),
    [sym_switch] = ACTIONS(4999),
    [sym_synchronized] = ACTIONS(4999),
    [sym_template] = ACTIONS(4999),
    [sym_throw] = ACTIONS(4999),
    [sym_try] = ACTIONS(4999),
    [sym_typeid] = ACTIONS(4999),
    [sym_typeof] = ACTIONS(4999),
    [sym_union] = ACTIONS(4999),
    [sym_unittest] = ACTIONS(4999),
    [sym_version] = ACTIONS(4999),
    [sym_while] = ACTIONS(4999),
    [sym_with] = ACTIONS(4999),
    [sym_gshared] = ACTIONS(4999),
    [sym_traits] = ACTIONS(4999),
    [sym_vector] = ACTIONS(4999),
    [sym_void] = ACTIONS(4999),
    [anon_sym_BQUOTE] = ACTIONS(5001),
    [anon_sym_r_DQUOTE] = ACTIONS(5001),
    [anon_sym_x_DQUOTE] = ACTIONS(5001),
    [anon_sym_DQUOTE] = ACTIONS(5001),
    [anon_sym_i_BQUOTE] = ACTIONS(5001),
    [anon_sym_i_DQUOTE] = ACTIONS(5001),
    [anon_sym_iq_LBRACE] = ACTIONS(5001),
    [aux_sym_char_literal_token1] = ACTIONS(5001),
    [anon_sym_SQUOTE] = ACTIONS(4999),
    [anon_sym___DATE__] = ACTIONS(4999),
    [anon_sym___FILE__] = ACTIONS(4999),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4999),
    [anon_sym___FUNCTION__] = ACTIONS(4999),
    [anon_sym___LINE__] = ACTIONS(4999),
    [anon_sym___MODULE__] = ACTIONS(4999),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4999),
    [anon_sym___TIME__] = ACTIONS(4999),
    [anon_sym___TIMESTAMP__] = ACTIONS(4999),
    [anon_sym___VENDOR__] = ACTIONS(4999),
    [anon_sym___VERSION__] = ACTIONS(4999),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5001),
    [sym_float_literal] = ACTIONS(5001),
    [sym__string] = ACTIONS(5001),
  },
  [1648] = {
    [sym_identifier] = ACTIONS(5003),
    [anon_sym_q_LBRACE] = ACTIONS(5005),
    [anon_sym_RBRACE] = ACTIONS(5005),
    [anon_sym_LBRACE] = ACTIONS(5005),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_PLUS_PLUS] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_LPAREN] = ACTIONS(5005),
    [anon_sym_RPAREN] = ACTIONS(5005),
    [anon_sym_LBRACK] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(5005),
    [anon_sym_DOLLAR] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5005),
    [anon_sym_AT] = ACTIONS(5005),
    [sym_bool] = ACTIONS(5003),
    [sym_byte] = ACTIONS(5003),
    [sym_ubyte] = ACTIONS(5003),
    [sym_char] = ACTIONS(5003),
    [sym_short] = ACTIONS(5003),
    [sym_ushort] = ACTIONS(5003),
    [sym_int] = ACTIONS(5003),
    [sym_uint] = ACTIONS(5003),
    [sym_long] = ACTIONS(5003),
    [sym_ulong] = ACTIONS(5003),
    [sym_cent] = ACTIONS(5003),
    [sym_ucent] = ACTIONS(5003),
    [sym_wchar] = ACTIONS(5003),
    [sym_dchar] = ACTIONS(5003),
    [sym_float] = ACTIONS(5003),
    [sym_double] = ACTIONS(5003),
    [sym_real] = ACTIONS(5003),
    [sym_ifloat] = ACTIONS(5003),
    [sym_idouble] = ACTIONS(5003),
    [sym_ireal] = ACTIONS(5003),
    [sym_cfloat] = ACTIONS(5003),
    [sym_cdouble] = ACTIONS(5003),
    [sym_creal] = ACTIONS(5003),
    [sym_size_t] = ACTIONS(5003),
    [sym_ptrdiff_t] = ACTIONS(5003),
    [sym_string] = ACTIONS(5003),
    [sym_cstring] = ACTIONS(5003),
    [sym_dstring] = ACTIONS(5003),
    [sym_wstring] = ACTIONS(5003),
    [sym_noreturn] = ACTIONS(5003),
    [sym_true] = ACTIONS(5003),
    [sym_false] = ACTIONS(5003),
    [sym_null] = ACTIONS(5003),
    [sym_super] = ACTIONS(5003),
    [sym_this] = ACTIONS(5003),
    [sym_abstract] = ACTIONS(5003),
    [sym_alias] = ACTIONS(5003),
    [sym_align] = ACTIONS(5003),
    [sym_asm] = ACTIONS(5003),
    [sym_assert] = ACTIONS(5003),
    [sym_auto] = ACTIONS(5003),
    [sym_break] = ACTIONS(5003),
    [sym_case] = ACTIONS(5003),
    [sym_cast] = ACTIONS(5003),
    [sym_class] = ACTIONS(5003),
    [sym_const] = ACTIONS(5003),
    [sym_continue] = ACTIONS(5003),
    [sym_debug] = ACTIONS(5003),
    [sym_default] = ACTIONS(5003),
    [sym_delegate] = ACTIONS(5003),
    [sym_delete] = ACTIONS(5003),
    [sym_deprecated] = ACTIONS(5003),
    [sym_do] = ACTIONS(5003),
    [sym_else] = ACTIONS(5003),
    [sym_enum] = ACTIONS(5003),
    [sym_export] = ACTIONS(5003),
    [sym_extern] = ACTIONS(5003),
    [sym_final] = ACTIONS(5003),
    [sym_for] = ACTIONS(5003),
    [sym_foreach] = ACTIONS(5003),
    [sym_foreach_reverse] = ACTIONS(5003),
    [sym_function] = ACTIONS(5003),
    [sym_goto] = ACTIONS(5003),
    [sym_if] = ACTIONS(5003),
    [sym_immutable] = ACTIONS(5003),
    [sym_import] = ACTIONS(5003),
    [sym_in] = ACTIONS(5003),
    [sym_inout] = ACTIONS(5003),
    [sym_interface] = ACTIONS(5003),
    [sym_invariant] = ACTIONS(5003),
    [sym_is] = ACTIONS(5003),
    [sym_mixin] = ACTIONS(5003),
    [sym_new] = ACTIONS(5003),
    [sym_nothrow] = ACTIONS(5003),
    [sym_out] = ACTIONS(5003),
    [sym_override] = ACTIONS(5003),
    [sym_package] = ACTIONS(5003),
    [sym_pragma] = ACTIONS(5003),
    [sym_private] = ACTIONS(5003),
    [sym_protected] = ACTIONS(5003),
    [sym_public] = ACTIONS(5003),
    [sym_pure] = ACTIONS(5003),
    [sym_ref] = ACTIONS(5003),
    [sym_return] = ACTIONS(5003),
    [sym_scope] = ACTIONS(5003),
    [sym_shared] = ACTIONS(5003),
    [sym_static] = ACTIONS(5003),
    [sym_struct] = ACTIONS(5003),
    [sym_switch] = ACTIONS(5003),
    [sym_synchronized] = ACTIONS(5003),
    [sym_template] = ACTIONS(5003),
    [sym_throw] = ACTIONS(5003),
    [sym_try] = ACTIONS(5003),
    [sym_typeid] = ACTIONS(5003),
    [sym_typeof] = ACTIONS(5003),
    [sym_union] = ACTIONS(5003),
    [sym_unittest] = ACTIONS(5003),
    [sym_version] = ACTIONS(5003),
    [sym_while] = ACTIONS(5003),
    [sym_with] = ACTIONS(5003),
    [sym_gshared] = ACTIONS(5003),
    [sym_traits] = ACTIONS(5003),
    [sym_vector] = ACTIONS(5003),
    [sym_void] = ACTIONS(5003),
    [anon_sym_BQUOTE] = ACTIONS(5005),
    [anon_sym_r_DQUOTE] = ACTIONS(5005),
    [anon_sym_x_DQUOTE] = ACTIONS(5005),
    [anon_sym_DQUOTE] = ACTIONS(5005),
    [anon_sym_i_BQUOTE] = ACTIONS(5005),
    [anon_sym_i_DQUOTE] = ACTIONS(5005),
    [anon_sym_iq_LBRACE] = ACTIONS(5005),
    [aux_sym_char_literal_token1] = ACTIONS(5005),
    [anon_sym_SQUOTE] = ACTIONS(5003),
    [anon_sym___DATE__] = ACTIONS(5003),
    [anon_sym___FILE__] = ACTIONS(5003),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5003),
    [anon_sym___FUNCTION__] = ACTIONS(5003),
    [anon_sym___LINE__] = ACTIONS(5003),
    [anon_sym___MODULE__] = ACTIONS(5003),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5003),
    [anon_sym___TIME__] = ACTIONS(5003),
    [anon_sym___TIMESTAMP__] = ACTIONS(5003),
    [anon_sym___VENDOR__] = ACTIONS(5003),
    [anon_sym___VERSION__] = ACTIONS(5003),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5005),
    [sym_float_literal] = ACTIONS(5005),
    [sym__string] = ACTIONS(5005),
  },
  [1649] = {
    [sym_identifier] = ACTIONS(4460),
    [anon_sym_q_LBRACE] = ACTIONS(4462),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_LBRACE] = ACTIONS(4462),
    [anon_sym_DOT] = ACTIONS(4462),
    [anon_sym_AMP] = ACTIONS(4462),
    [anon_sym_DASH] = ACTIONS(4460),
    [anon_sym_DASH_DASH] = ACTIONS(4462),
    [anon_sym_PLUS] = ACTIONS(4460),
    [anon_sym_PLUS_PLUS] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4462),
    [anon_sym_LPAREN] = ACTIONS(4462),
    [anon_sym_RPAREN] = ACTIONS(4462),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4462),
    [anon_sym_STAR] = ACTIONS(4462),
    [anon_sym_TILDE] = ACTIONS(4462),
    [anon_sym_AT] = ACTIONS(4462),
    [sym_bool] = ACTIONS(4460),
    [sym_byte] = ACTIONS(4460),
    [sym_ubyte] = ACTIONS(4460),
    [sym_char] = ACTIONS(4460),
    [sym_short] = ACTIONS(4460),
    [sym_ushort] = ACTIONS(4460),
    [sym_int] = ACTIONS(4460),
    [sym_uint] = ACTIONS(4460),
    [sym_long] = ACTIONS(4460),
    [sym_ulong] = ACTIONS(4460),
    [sym_cent] = ACTIONS(4460),
    [sym_ucent] = ACTIONS(4460),
    [sym_wchar] = ACTIONS(4460),
    [sym_dchar] = ACTIONS(4460),
    [sym_float] = ACTIONS(4460),
    [sym_double] = ACTIONS(4460),
    [sym_real] = ACTIONS(4460),
    [sym_ifloat] = ACTIONS(4460),
    [sym_idouble] = ACTIONS(4460),
    [sym_ireal] = ACTIONS(4460),
    [sym_cfloat] = ACTIONS(4460),
    [sym_cdouble] = ACTIONS(4460),
    [sym_creal] = ACTIONS(4460),
    [sym_size_t] = ACTIONS(4460),
    [sym_ptrdiff_t] = ACTIONS(4460),
    [sym_string] = ACTIONS(4460),
    [sym_cstring] = ACTIONS(4460),
    [sym_dstring] = ACTIONS(4460),
    [sym_wstring] = ACTIONS(4460),
    [sym_noreturn] = ACTIONS(4460),
    [sym_true] = ACTIONS(4460),
    [sym_false] = ACTIONS(4460),
    [sym_null] = ACTIONS(4460),
    [sym_super] = ACTIONS(4460),
    [sym_this] = ACTIONS(4460),
    [sym_abstract] = ACTIONS(4460),
    [sym_alias] = ACTIONS(4460),
    [sym_align] = ACTIONS(4460),
    [sym_asm] = ACTIONS(4460),
    [sym_assert] = ACTIONS(4460),
    [sym_auto] = ACTIONS(4460),
    [sym_break] = ACTIONS(4460),
    [sym_case] = ACTIONS(4460),
    [sym_cast] = ACTIONS(4460),
    [sym_class] = ACTIONS(4460),
    [sym_const] = ACTIONS(4460),
    [sym_continue] = ACTIONS(4460),
    [sym_debug] = ACTIONS(4460),
    [sym_default] = ACTIONS(4460),
    [sym_delegate] = ACTIONS(4460),
    [sym_delete] = ACTIONS(4460),
    [sym_deprecated] = ACTIONS(4460),
    [sym_do] = ACTIONS(4460),
    [sym_else] = ACTIONS(4460),
    [sym_enum] = ACTIONS(4460),
    [sym_export] = ACTIONS(4460),
    [sym_extern] = ACTIONS(4460),
    [sym_final] = ACTIONS(4460),
    [sym_for] = ACTIONS(4460),
    [sym_foreach] = ACTIONS(4460),
    [sym_foreach_reverse] = ACTIONS(4460),
    [sym_function] = ACTIONS(4460),
    [sym_goto] = ACTIONS(4460),
    [sym_if] = ACTIONS(4460),
    [sym_immutable] = ACTIONS(4460),
    [sym_import] = ACTIONS(4460),
    [sym_in] = ACTIONS(4460),
    [sym_inout] = ACTIONS(4460),
    [sym_interface] = ACTIONS(4460),
    [sym_invariant] = ACTIONS(4460),
    [sym_is] = ACTIONS(4460),
    [sym_mixin] = ACTIONS(4460),
    [sym_new] = ACTIONS(4460),
    [sym_nothrow] = ACTIONS(4460),
    [sym_out] = ACTIONS(4460),
    [sym_override] = ACTIONS(4460),
    [sym_package] = ACTIONS(4460),
    [sym_pragma] = ACTIONS(4460),
    [sym_private] = ACTIONS(4460),
    [sym_protected] = ACTIONS(4460),
    [sym_public] = ACTIONS(4460),
    [sym_pure] = ACTIONS(4460),
    [sym_ref] = ACTIONS(4460),
    [sym_return] = ACTIONS(4460),
    [sym_scope] = ACTIONS(4460),
    [sym_shared] = ACTIONS(4460),
    [sym_static] = ACTIONS(4460),
    [sym_struct] = ACTIONS(4460),
    [sym_switch] = ACTIONS(4460),
    [sym_synchronized] = ACTIONS(4460),
    [sym_template] = ACTIONS(4460),
    [sym_throw] = ACTIONS(4460),
    [sym_try] = ACTIONS(4460),
    [sym_typeid] = ACTIONS(4460),
    [sym_typeof] = ACTIONS(4460),
    [sym_union] = ACTIONS(4460),
    [sym_unittest] = ACTIONS(4460),
    [sym_version] = ACTIONS(4460),
    [sym_while] = ACTIONS(4460),
    [sym_with] = ACTIONS(4460),
    [sym_gshared] = ACTIONS(4460),
    [sym_traits] = ACTIONS(4460),
    [sym_vector] = ACTIONS(4460),
    [sym_void] = ACTIONS(4460),
    [anon_sym_BQUOTE] = ACTIONS(4462),
    [anon_sym_r_DQUOTE] = ACTIONS(4462),
    [anon_sym_x_DQUOTE] = ACTIONS(4462),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_i_BQUOTE] = ACTIONS(4462),
    [anon_sym_i_DQUOTE] = ACTIONS(4462),
    [anon_sym_iq_LBRACE] = ACTIONS(4462),
    [aux_sym_char_literal_token1] = ACTIONS(4462),
    [anon_sym_SQUOTE] = ACTIONS(4460),
    [anon_sym___DATE__] = ACTIONS(4460),
    [anon_sym___FILE__] = ACTIONS(4460),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4460),
    [anon_sym___FUNCTION__] = ACTIONS(4460),
    [anon_sym___LINE__] = ACTIONS(4460),
    [anon_sym___MODULE__] = ACTIONS(4460),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4460),
    [anon_sym___TIME__] = ACTIONS(4460),
    [anon_sym___TIMESTAMP__] = ACTIONS(4460),
    [anon_sym___VENDOR__] = ACTIONS(4460),
    [anon_sym___VERSION__] = ACTIONS(4460),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4462),
    [sym_float_literal] = ACTIONS(4462),
    [sym__string] = ACTIONS(4462),
  },
  [1650] = {
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_q_LBRACE] = ACTIONS(4458),
    [anon_sym_RBRACE] = ACTIONS(4458),
    [anon_sym_LBRACE] = ACTIONS(4458),
    [anon_sym_DOT] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4458),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_PLUS_PLUS] = ACTIONS(4458),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(4458),
    [anon_sym_RPAREN] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_SEMI] = ACTIONS(4458),
    [anon_sym_DOLLAR] = ACTIONS(4458),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_TILDE] = ACTIONS(4458),
    [anon_sym_AT] = ACTIONS(4458),
    [sym_bool] = ACTIONS(4456),
    [sym_byte] = ACTIONS(4456),
    [sym_ubyte] = ACTIONS(4456),
    [sym_char] = ACTIONS(4456),
    [sym_short] = ACTIONS(4456),
    [sym_ushort] = ACTIONS(4456),
    [sym_int] = ACTIONS(4456),
    [sym_uint] = ACTIONS(4456),
    [sym_long] = ACTIONS(4456),
    [sym_ulong] = ACTIONS(4456),
    [sym_cent] = ACTIONS(4456),
    [sym_ucent] = ACTIONS(4456),
    [sym_wchar] = ACTIONS(4456),
    [sym_dchar] = ACTIONS(4456),
    [sym_float] = ACTIONS(4456),
    [sym_double] = ACTIONS(4456),
    [sym_real] = ACTIONS(4456),
    [sym_ifloat] = ACTIONS(4456),
    [sym_idouble] = ACTIONS(4456),
    [sym_ireal] = ACTIONS(4456),
    [sym_cfloat] = ACTIONS(4456),
    [sym_cdouble] = ACTIONS(4456),
    [sym_creal] = ACTIONS(4456),
    [sym_size_t] = ACTIONS(4456),
    [sym_ptrdiff_t] = ACTIONS(4456),
    [sym_string] = ACTIONS(4456),
    [sym_cstring] = ACTIONS(4456),
    [sym_dstring] = ACTIONS(4456),
    [sym_wstring] = ACTIONS(4456),
    [sym_noreturn] = ACTIONS(4456),
    [sym_true] = ACTIONS(4456),
    [sym_false] = ACTIONS(4456),
    [sym_null] = ACTIONS(4456),
    [sym_super] = ACTIONS(4456),
    [sym_this] = ACTIONS(4456),
    [sym_abstract] = ACTIONS(4456),
    [sym_alias] = ACTIONS(4456),
    [sym_align] = ACTIONS(4456),
    [sym_asm] = ACTIONS(4456),
    [sym_assert] = ACTIONS(4456),
    [sym_auto] = ACTIONS(4456),
    [sym_break] = ACTIONS(4456),
    [sym_case] = ACTIONS(4456),
    [sym_cast] = ACTIONS(4456),
    [sym_class] = ACTIONS(4456),
    [sym_const] = ACTIONS(4456),
    [sym_continue] = ACTIONS(4456),
    [sym_debug] = ACTIONS(4456),
    [sym_default] = ACTIONS(4456),
    [sym_delegate] = ACTIONS(4456),
    [sym_delete] = ACTIONS(4456),
    [sym_deprecated] = ACTIONS(4456),
    [sym_do] = ACTIONS(4456),
    [sym_else] = ACTIONS(4456),
    [sym_enum] = ACTIONS(4456),
    [sym_export] = ACTIONS(4456),
    [sym_extern] = ACTIONS(4456),
    [sym_final] = ACTIONS(4456),
    [sym_for] = ACTIONS(4456),
    [sym_foreach] = ACTIONS(4456),
    [sym_foreach_reverse] = ACTIONS(4456),
    [sym_function] = ACTIONS(4456),
    [sym_goto] = ACTIONS(4456),
    [sym_if] = ACTIONS(4456),
    [sym_immutable] = ACTIONS(4456),
    [sym_import] = ACTIONS(4456),
    [sym_in] = ACTIONS(4456),
    [sym_inout] = ACTIONS(4456),
    [sym_interface] = ACTIONS(4456),
    [sym_invariant] = ACTIONS(4456),
    [sym_is] = ACTIONS(4456),
    [sym_mixin] = ACTIONS(4456),
    [sym_new] = ACTIONS(4456),
    [sym_nothrow] = ACTIONS(4456),
    [sym_out] = ACTIONS(4456),
    [sym_override] = ACTIONS(4456),
    [sym_package] = ACTIONS(4456),
    [sym_pragma] = ACTIONS(4456),
    [sym_private] = ACTIONS(4456),
    [sym_protected] = ACTIONS(4456),
    [sym_public] = ACTIONS(4456),
    [sym_pure] = ACTIONS(4456),
    [sym_ref] = ACTIONS(4456),
    [sym_return] = ACTIONS(4456),
    [sym_scope] = ACTIONS(4456),
    [sym_shared] = ACTIONS(4456),
    [sym_static] = ACTIONS(4456),
    [sym_struct] = ACTIONS(4456),
    [sym_switch] = ACTIONS(4456),
    [sym_synchronized] = ACTIONS(4456),
    [sym_template] = ACTIONS(4456),
    [sym_throw] = ACTIONS(4456),
    [sym_try] = ACTIONS(4456),
    [sym_typeid] = ACTIONS(4456),
    [sym_typeof] = ACTIONS(4456),
    [sym_union] = ACTIONS(4456),
    [sym_unittest] = ACTIONS(4456),
    [sym_version] = ACTIONS(4456),
    [sym_while] = ACTIONS(4456),
    [sym_with] = ACTIONS(4456),
    [sym_gshared] = ACTIONS(4456),
    [sym_traits] = ACTIONS(4456),
    [sym_vector] = ACTIONS(4456),
    [sym_void] = ACTIONS(4456),
    [anon_sym_BQUOTE] = ACTIONS(4458),
    [anon_sym_r_DQUOTE] = ACTIONS(4458),
    [anon_sym_x_DQUOTE] = ACTIONS(4458),
    [anon_sym_DQUOTE] = ACTIONS(4458),
    [anon_sym_i_BQUOTE] = ACTIONS(4458),
    [anon_sym_i_DQUOTE] = ACTIONS(4458),
    [anon_sym_iq_LBRACE] = ACTIONS(4458),
    [aux_sym_char_literal_token1] = ACTIONS(4458),
    [anon_sym_SQUOTE] = ACTIONS(4456),
    [anon_sym___DATE__] = ACTIONS(4456),
    [anon_sym___FILE__] = ACTIONS(4456),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4456),
    [anon_sym___FUNCTION__] = ACTIONS(4456),
    [anon_sym___LINE__] = ACTIONS(4456),
    [anon_sym___MODULE__] = ACTIONS(4456),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4456),
    [anon_sym___TIME__] = ACTIONS(4456),
    [anon_sym___TIMESTAMP__] = ACTIONS(4456),
    [anon_sym___VENDOR__] = ACTIONS(4456),
    [anon_sym___VERSION__] = ACTIONS(4456),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4458),
    [sym_float_literal] = ACTIONS(4458),
    [sym__string] = ACTIONS(4458),
  },
  [1651] = {
    [sym_identifier] = ACTIONS(4646),
    [anon_sym_q_LBRACE] = ACTIONS(4649),
    [anon_sym_RBRACE] = ACTIONS(4649),
    [anon_sym_LBRACE] = ACTIONS(4649),
    [anon_sym_DOT] = ACTIONS(4649),
    [anon_sym_AMP] = ACTIONS(4649),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_DASH_DASH] = ACTIONS(4649),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4649),
    [anon_sym_BANG] = ACTIONS(4649),
    [anon_sym_LPAREN] = ACTIONS(4649),
    [anon_sym_RPAREN] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(4649),
    [anon_sym_DOLLAR] = ACTIONS(4649),
    [anon_sym_STAR] = ACTIONS(4649),
    [anon_sym_TILDE] = ACTIONS(4649),
    [anon_sym_AT] = ACTIONS(4649),
    [sym_bool] = ACTIONS(4646),
    [sym_byte] = ACTIONS(4646),
    [sym_ubyte] = ACTIONS(4646),
    [sym_char] = ACTIONS(4646),
    [sym_short] = ACTIONS(4646),
    [sym_ushort] = ACTIONS(4646),
    [sym_int] = ACTIONS(4646),
    [sym_uint] = ACTIONS(4646),
    [sym_long] = ACTIONS(4646),
    [sym_ulong] = ACTIONS(4646),
    [sym_cent] = ACTIONS(4646),
    [sym_ucent] = ACTIONS(4646),
    [sym_wchar] = ACTIONS(4646),
    [sym_dchar] = ACTIONS(4646),
    [sym_float] = ACTIONS(4646),
    [sym_double] = ACTIONS(4646),
    [sym_real] = ACTIONS(4646),
    [sym_ifloat] = ACTIONS(4646),
    [sym_idouble] = ACTIONS(4646),
    [sym_ireal] = ACTIONS(4646),
    [sym_cfloat] = ACTIONS(4646),
    [sym_cdouble] = ACTIONS(4646),
    [sym_creal] = ACTIONS(4646),
    [sym_size_t] = ACTIONS(4646),
    [sym_ptrdiff_t] = ACTIONS(4646),
    [sym_string] = ACTIONS(4646),
    [sym_cstring] = ACTIONS(4646),
    [sym_dstring] = ACTIONS(4646),
    [sym_wstring] = ACTIONS(4646),
    [sym_noreturn] = ACTIONS(4646),
    [sym_true] = ACTIONS(4646),
    [sym_false] = ACTIONS(4646),
    [sym_null] = ACTIONS(4646),
    [sym_super] = ACTIONS(4646),
    [sym_this] = ACTIONS(4646),
    [sym_abstract] = ACTIONS(4646),
    [sym_alias] = ACTIONS(4646),
    [sym_align] = ACTIONS(4646),
    [sym_asm] = ACTIONS(4646),
    [sym_assert] = ACTIONS(4646),
    [sym_auto] = ACTIONS(4646),
    [sym_break] = ACTIONS(4646),
    [sym_case] = ACTIONS(4646),
    [sym_cast] = ACTIONS(4646),
    [sym_class] = ACTIONS(4646),
    [sym_const] = ACTIONS(4646),
    [sym_continue] = ACTIONS(4646),
    [sym_debug] = ACTIONS(4646),
    [sym_default] = ACTIONS(4646),
    [sym_delegate] = ACTIONS(4646),
    [sym_delete] = ACTIONS(4646),
    [sym_deprecated] = ACTIONS(4646),
    [sym_do] = ACTIONS(4646),
    [sym_else] = ACTIONS(4646),
    [sym_enum] = ACTIONS(4646),
    [sym_export] = ACTIONS(4646),
    [sym_extern] = ACTIONS(4646),
    [sym_final] = ACTIONS(4646),
    [sym_for] = ACTIONS(4646),
    [sym_foreach] = ACTIONS(4646),
    [sym_foreach_reverse] = ACTIONS(4646),
    [sym_function] = ACTIONS(4646),
    [sym_goto] = ACTIONS(4646),
    [sym_if] = ACTIONS(4646),
    [sym_immutable] = ACTIONS(4646),
    [sym_import] = ACTIONS(4646),
    [sym_in] = ACTIONS(4646),
    [sym_inout] = ACTIONS(4646),
    [sym_interface] = ACTIONS(4646),
    [sym_invariant] = ACTIONS(4646),
    [sym_is] = ACTIONS(4646),
    [sym_mixin] = ACTIONS(4646),
    [sym_new] = ACTIONS(4646),
    [sym_nothrow] = ACTIONS(4646),
    [sym_out] = ACTIONS(4646),
    [sym_override] = ACTIONS(4646),
    [sym_package] = ACTIONS(4646),
    [sym_pragma] = ACTIONS(4646),
    [sym_private] = ACTIONS(4646),
    [sym_protected] = ACTIONS(4646),
    [sym_public] = ACTIONS(4646),
    [sym_pure] = ACTIONS(4646),
    [sym_ref] = ACTIONS(4646),
    [sym_return] = ACTIONS(4646),
    [sym_scope] = ACTIONS(4646),
    [sym_shared] = ACTIONS(4646),
    [sym_static] = ACTIONS(4646),
    [sym_struct] = ACTIONS(4646),
    [sym_switch] = ACTIONS(4646),
    [sym_synchronized] = ACTIONS(4646),
    [sym_template] = ACTIONS(4646),
    [sym_throw] = ACTIONS(4646),
    [sym_try] = ACTIONS(4646),
    [sym_typeid] = ACTIONS(4646),
    [sym_typeof] = ACTIONS(4646),
    [sym_union] = ACTIONS(4646),
    [sym_unittest] = ACTIONS(4646),
    [sym_version] = ACTIONS(4646),
    [sym_while] = ACTIONS(4646),
    [sym_with] = ACTIONS(4646),
    [sym_gshared] = ACTIONS(4646),
    [sym_traits] = ACTIONS(4646),
    [sym_vector] = ACTIONS(4646),
    [sym_void] = ACTIONS(4646),
    [anon_sym_BQUOTE] = ACTIONS(4649),
    [anon_sym_r_DQUOTE] = ACTIONS(4649),
    [anon_sym_x_DQUOTE] = ACTIONS(4649),
    [anon_sym_DQUOTE] = ACTIONS(4649),
    [anon_sym_i_BQUOTE] = ACTIONS(4649),
    [anon_sym_i_DQUOTE] = ACTIONS(4649),
    [anon_sym_iq_LBRACE] = ACTIONS(4649),
    [aux_sym_char_literal_token1] = ACTIONS(4649),
    [anon_sym_SQUOTE] = ACTIONS(4646),
    [anon_sym___DATE__] = ACTIONS(4646),
    [anon_sym___FILE__] = ACTIONS(4646),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4646),
    [anon_sym___FUNCTION__] = ACTIONS(4646),
    [anon_sym___LINE__] = ACTIONS(4646),
    [anon_sym___MODULE__] = ACTIONS(4646),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4646),
    [anon_sym___TIME__] = ACTIONS(4646),
    [anon_sym___TIMESTAMP__] = ACTIONS(4646),
    [anon_sym___VENDOR__] = ACTIONS(4646),
    [anon_sym___VERSION__] = ACTIONS(4646),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4649),
    [sym_float_literal] = ACTIONS(4649),
    [sym__string] = ACTIONS(4649),
  },
  [1652] = {
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_q_LBRACE] = ACTIONS(4644),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_LBRACE] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4644),
    [anon_sym_AMP] = ACTIONS(4644),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_BANG] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_RPAREN] = ACTIONS(4644),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_SEMI] = ACTIONS(4644),
    [anon_sym_DOLLAR] = ACTIONS(4644),
    [anon_sym_STAR] = ACTIONS(4644),
    [anon_sym_TILDE] = ACTIONS(4644),
    [anon_sym_AT] = ACTIONS(4644),
    [sym_bool] = ACTIONS(4642),
    [sym_byte] = ACTIONS(4642),
    [sym_ubyte] = ACTIONS(4642),
    [sym_char] = ACTIONS(4642),
    [sym_short] = ACTIONS(4642),
    [sym_ushort] = ACTIONS(4642),
    [sym_int] = ACTIONS(4642),
    [sym_uint] = ACTIONS(4642),
    [sym_long] = ACTIONS(4642),
    [sym_ulong] = ACTIONS(4642),
    [sym_cent] = ACTIONS(4642),
    [sym_ucent] = ACTIONS(4642),
    [sym_wchar] = ACTIONS(4642),
    [sym_dchar] = ACTIONS(4642),
    [sym_float] = ACTIONS(4642),
    [sym_double] = ACTIONS(4642),
    [sym_real] = ACTIONS(4642),
    [sym_ifloat] = ACTIONS(4642),
    [sym_idouble] = ACTIONS(4642),
    [sym_ireal] = ACTIONS(4642),
    [sym_cfloat] = ACTIONS(4642),
    [sym_cdouble] = ACTIONS(4642),
    [sym_creal] = ACTIONS(4642),
    [sym_size_t] = ACTIONS(4642),
    [sym_ptrdiff_t] = ACTIONS(4642),
    [sym_string] = ACTIONS(4642),
    [sym_cstring] = ACTIONS(4642),
    [sym_dstring] = ACTIONS(4642),
    [sym_wstring] = ACTIONS(4642),
    [sym_noreturn] = ACTIONS(4642),
    [sym_true] = ACTIONS(4642),
    [sym_false] = ACTIONS(4642),
    [sym_null] = ACTIONS(4642),
    [sym_super] = ACTIONS(4642),
    [sym_this] = ACTIONS(4642),
    [sym_abstract] = ACTIONS(4642),
    [sym_alias] = ACTIONS(4642),
    [sym_align] = ACTIONS(4642),
    [sym_asm] = ACTIONS(4642),
    [sym_assert] = ACTIONS(4642),
    [sym_auto] = ACTIONS(4642),
    [sym_break] = ACTIONS(4642),
    [sym_case] = ACTIONS(4642),
    [sym_cast] = ACTIONS(4642),
    [sym_class] = ACTIONS(4642),
    [sym_const] = ACTIONS(4642),
    [sym_continue] = ACTIONS(4642),
    [sym_debug] = ACTIONS(4642),
    [sym_default] = ACTIONS(4642),
    [sym_delegate] = ACTIONS(4642),
    [sym_delete] = ACTIONS(4642),
    [sym_deprecated] = ACTIONS(4642),
    [sym_do] = ACTIONS(4642),
    [sym_else] = ACTIONS(4642),
    [sym_enum] = ACTIONS(4642),
    [sym_export] = ACTIONS(4642),
    [sym_extern] = ACTIONS(4642),
    [sym_final] = ACTIONS(4642),
    [sym_for] = ACTIONS(4642),
    [sym_foreach] = ACTIONS(4642),
    [sym_foreach_reverse] = ACTIONS(4642),
    [sym_function] = ACTIONS(4642),
    [sym_goto] = ACTIONS(4642),
    [sym_if] = ACTIONS(4642),
    [sym_immutable] = ACTIONS(4642),
    [sym_import] = ACTIONS(4642),
    [sym_in] = ACTIONS(4642),
    [sym_inout] = ACTIONS(4642),
    [sym_interface] = ACTIONS(4642),
    [sym_invariant] = ACTIONS(4642),
    [sym_is] = ACTIONS(4642),
    [sym_mixin] = ACTIONS(4642),
    [sym_new] = ACTIONS(4642),
    [sym_nothrow] = ACTIONS(4642),
    [sym_out] = ACTIONS(4642),
    [sym_override] = ACTIONS(4642),
    [sym_package] = ACTIONS(4642),
    [sym_pragma] = ACTIONS(4642),
    [sym_private] = ACTIONS(4642),
    [sym_protected] = ACTIONS(4642),
    [sym_public] = ACTIONS(4642),
    [sym_pure] = ACTIONS(4642),
    [sym_ref] = ACTIONS(4642),
    [sym_return] = ACTIONS(4642),
    [sym_scope] = ACTIONS(4642),
    [sym_shared] = ACTIONS(4642),
    [sym_static] = ACTIONS(4642),
    [sym_struct] = ACTIONS(4642),
    [sym_switch] = ACTIONS(4642),
    [sym_synchronized] = ACTIONS(4642),
    [sym_template] = ACTIONS(4642),
    [sym_throw] = ACTIONS(4642),
    [sym_try] = ACTIONS(4642),
    [sym_typeid] = ACTIONS(4642),
    [sym_typeof] = ACTIONS(4642),
    [sym_union] = ACTIONS(4642),
    [sym_unittest] = ACTIONS(4642),
    [sym_version] = ACTIONS(4642),
    [sym_while] = ACTIONS(4642),
    [sym_with] = ACTIONS(4642),
    [sym_gshared] = ACTIONS(4642),
    [sym_traits] = ACTIONS(4642),
    [sym_vector] = ACTIONS(4642),
    [sym_void] = ACTIONS(4642),
    [anon_sym_BQUOTE] = ACTIONS(4644),
    [anon_sym_r_DQUOTE] = ACTIONS(4644),
    [anon_sym_x_DQUOTE] = ACTIONS(4644),
    [anon_sym_DQUOTE] = ACTIONS(4644),
    [anon_sym_i_BQUOTE] = ACTIONS(4644),
    [anon_sym_i_DQUOTE] = ACTIONS(4644),
    [anon_sym_iq_LBRACE] = ACTIONS(4644),
    [aux_sym_char_literal_token1] = ACTIONS(4644),
    [anon_sym_SQUOTE] = ACTIONS(4642),
    [anon_sym___DATE__] = ACTIONS(4642),
    [anon_sym___FILE__] = ACTIONS(4642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4642),
    [anon_sym___FUNCTION__] = ACTIONS(4642),
    [anon_sym___LINE__] = ACTIONS(4642),
    [anon_sym___MODULE__] = ACTIONS(4642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4642),
    [anon_sym___TIME__] = ACTIONS(4642),
    [anon_sym___TIMESTAMP__] = ACTIONS(4642),
    [anon_sym___VENDOR__] = ACTIONS(4642),
    [anon_sym___VERSION__] = ACTIONS(4642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4644),
    [sym_float_literal] = ACTIONS(4644),
    [sym__string] = ACTIONS(4644),
  },
  [1653] = {
    [sym_identifier] = ACTIONS(4638),
    [anon_sym_q_LBRACE] = ACTIONS(4640),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4640),
    [anon_sym_AMP] = ACTIONS(4640),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_BANG] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_DOLLAR] = ACTIONS(4640),
    [anon_sym_STAR] = ACTIONS(4640),
    [anon_sym_TILDE] = ACTIONS(4640),
    [anon_sym_AT] = ACTIONS(4640),
    [sym_bool] = ACTIONS(4638),
    [sym_byte] = ACTIONS(4638),
    [sym_ubyte] = ACTIONS(4638),
    [sym_char] = ACTIONS(4638),
    [sym_short] = ACTIONS(4638),
    [sym_ushort] = ACTIONS(4638),
    [sym_int] = ACTIONS(4638),
    [sym_uint] = ACTIONS(4638),
    [sym_long] = ACTIONS(4638),
    [sym_ulong] = ACTIONS(4638),
    [sym_cent] = ACTIONS(4638),
    [sym_ucent] = ACTIONS(4638),
    [sym_wchar] = ACTIONS(4638),
    [sym_dchar] = ACTIONS(4638),
    [sym_float] = ACTIONS(4638),
    [sym_double] = ACTIONS(4638),
    [sym_real] = ACTIONS(4638),
    [sym_ifloat] = ACTIONS(4638),
    [sym_idouble] = ACTIONS(4638),
    [sym_ireal] = ACTIONS(4638),
    [sym_cfloat] = ACTIONS(4638),
    [sym_cdouble] = ACTIONS(4638),
    [sym_creal] = ACTIONS(4638),
    [sym_size_t] = ACTIONS(4638),
    [sym_ptrdiff_t] = ACTIONS(4638),
    [sym_string] = ACTIONS(4638),
    [sym_cstring] = ACTIONS(4638),
    [sym_dstring] = ACTIONS(4638),
    [sym_wstring] = ACTIONS(4638),
    [sym_noreturn] = ACTIONS(4638),
    [sym_true] = ACTIONS(4638),
    [sym_false] = ACTIONS(4638),
    [sym_null] = ACTIONS(4638),
    [sym_super] = ACTIONS(4638),
    [sym_this] = ACTIONS(4638),
    [sym_abstract] = ACTIONS(4638),
    [sym_alias] = ACTIONS(4638),
    [sym_align] = ACTIONS(4638),
    [sym_asm] = ACTIONS(4638),
    [sym_assert] = ACTIONS(4638),
    [sym_auto] = ACTIONS(4638),
    [sym_break] = ACTIONS(4638),
    [sym_case] = ACTIONS(4638),
    [sym_cast] = ACTIONS(4638),
    [sym_class] = ACTIONS(4638),
    [sym_const] = ACTIONS(4638),
    [sym_continue] = ACTIONS(4638),
    [sym_debug] = ACTIONS(4638),
    [sym_default] = ACTIONS(4638),
    [sym_delegate] = ACTIONS(4638),
    [sym_delete] = ACTIONS(4638),
    [sym_deprecated] = ACTIONS(4638),
    [sym_do] = ACTIONS(4638),
    [sym_else] = ACTIONS(4638),
    [sym_enum] = ACTIONS(4638),
    [sym_export] = ACTIONS(4638),
    [sym_extern] = ACTIONS(4638),
    [sym_final] = ACTIONS(4638),
    [sym_for] = ACTIONS(4638),
    [sym_foreach] = ACTIONS(4638),
    [sym_foreach_reverse] = ACTIONS(4638),
    [sym_function] = ACTIONS(4638),
    [sym_goto] = ACTIONS(4638),
    [sym_if] = ACTIONS(4638),
    [sym_immutable] = ACTIONS(4638),
    [sym_import] = ACTIONS(4638),
    [sym_in] = ACTIONS(4638),
    [sym_inout] = ACTIONS(4638),
    [sym_interface] = ACTIONS(4638),
    [sym_invariant] = ACTIONS(4638),
    [sym_is] = ACTIONS(4638),
    [sym_mixin] = ACTIONS(4638),
    [sym_new] = ACTIONS(4638),
    [sym_nothrow] = ACTIONS(4638),
    [sym_out] = ACTIONS(4638),
    [sym_override] = ACTIONS(4638),
    [sym_package] = ACTIONS(4638),
    [sym_pragma] = ACTIONS(4638),
    [sym_private] = ACTIONS(4638),
    [sym_protected] = ACTIONS(4638),
    [sym_public] = ACTIONS(4638),
    [sym_pure] = ACTIONS(4638),
    [sym_ref] = ACTIONS(4638),
    [sym_return] = ACTIONS(4638),
    [sym_scope] = ACTIONS(4638),
    [sym_shared] = ACTIONS(4638),
    [sym_static] = ACTIONS(4638),
    [sym_struct] = ACTIONS(4638),
    [sym_switch] = ACTIONS(4638),
    [sym_synchronized] = ACTIONS(4638),
    [sym_template] = ACTIONS(4638),
    [sym_throw] = ACTIONS(4638),
    [sym_try] = ACTIONS(4638),
    [sym_typeid] = ACTIONS(4638),
    [sym_typeof] = ACTIONS(4638),
    [sym_union] = ACTIONS(4638),
    [sym_unittest] = ACTIONS(4638),
    [sym_version] = ACTIONS(4638),
    [sym_while] = ACTIONS(4638),
    [sym_with] = ACTIONS(4638),
    [sym_gshared] = ACTIONS(4638),
    [sym_traits] = ACTIONS(4638),
    [sym_vector] = ACTIONS(4638),
    [sym_void] = ACTIONS(4638),
    [anon_sym_BQUOTE] = ACTIONS(4640),
    [anon_sym_r_DQUOTE] = ACTIONS(4640),
    [anon_sym_x_DQUOTE] = ACTIONS(4640),
    [anon_sym_DQUOTE] = ACTIONS(4640),
    [anon_sym_i_BQUOTE] = ACTIONS(4640),
    [anon_sym_i_DQUOTE] = ACTIONS(4640),
    [anon_sym_iq_LBRACE] = ACTIONS(4640),
    [aux_sym_char_literal_token1] = ACTIONS(4640),
    [anon_sym_SQUOTE] = ACTIONS(4638),
    [anon_sym___DATE__] = ACTIONS(4638),
    [anon_sym___FILE__] = ACTIONS(4638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4638),
    [anon_sym___FUNCTION__] = ACTIONS(4638),
    [anon_sym___LINE__] = ACTIONS(4638),
    [anon_sym___MODULE__] = ACTIONS(4638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4638),
    [anon_sym___TIME__] = ACTIONS(4638),
    [anon_sym___TIMESTAMP__] = ACTIONS(4638),
    [anon_sym___VENDOR__] = ACTIONS(4638),
    [anon_sym___VERSION__] = ACTIONS(4638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4640),
    [sym_float_literal] = ACTIONS(4640),
    [sym__string] = ACTIONS(4640),
  },
  [1654] = {
    [sym_identifier] = ACTIONS(5007),
    [anon_sym_q_LBRACE] = ACTIONS(5009),
    [anon_sym_RBRACE] = ACTIONS(5009),
    [anon_sym_LBRACE] = ACTIONS(5009),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5009),
    [anon_sym_PLUS] = ACTIONS(5007),
    [anon_sym_PLUS_PLUS] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_RPAREN] = ACTIONS(5009),
    [anon_sym_LBRACK] = ACTIONS(5009),
    [anon_sym_SEMI] = ACTIONS(5009),
    [anon_sym_DOLLAR] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5009),
    [anon_sym_AT] = ACTIONS(5009),
    [sym_bool] = ACTIONS(5007),
    [sym_byte] = ACTIONS(5007),
    [sym_ubyte] = ACTIONS(5007),
    [sym_char] = ACTIONS(5007),
    [sym_short] = ACTIONS(5007),
    [sym_ushort] = ACTIONS(5007),
    [sym_int] = ACTIONS(5007),
    [sym_uint] = ACTIONS(5007),
    [sym_long] = ACTIONS(5007),
    [sym_ulong] = ACTIONS(5007),
    [sym_cent] = ACTIONS(5007),
    [sym_ucent] = ACTIONS(5007),
    [sym_wchar] = ACTIONS(5007),
    [sym_dchar] = ACTIONS(5007),
    [sym_float] = ACTIONS(5007),
    [sym_double] = ACTIONS(5007),
    [sym_real] = ACTIONS(5007),
    [sym_ifloat] = ACTIONS(5007),
    [sym_idouble] = ACTIONS(5007),
    [sym_ireal] = ACTIONS(5007),
    [sym_cfloat] = ACTIONS(5007),
    [sym_cdouble] = ACTIONS(5007),
    [sym_creal] = ACTIONS(5007),
    [sym_size_t] = ACTIONS(5007),
    [sym_ptrdiff_t] = ACTIONS(5007),
    [sym_string] = ACTIONS(5007),
    [sym_cstring] = ACTIONS(5007),
    [sym_dstring] = ACTIONS(5007),
    [sym_wstring] = ACTIONS(5007),
    [sym_noreturn] = ACTIONS(5007),
    [sym_true] = ACTIONS(5007),
    [sym_false] = ACTIONS(5007),
    [sym_null] = ACTIONS(5007),
    [sym_super] = ACTIONS(5007),
    [sym_this] = ACTIONS(5007),
    [sym_abstract] = ACTIONS(5007),
    [sym_alias] = ACTIONS(5007),
    [sym_align] = ACTIONS(5007),
    [sym_asm] = ACTIONS(5007),
    [sym_assert] = ACTIONS(5007),
    [sym_auto] = ACTIONS(5007),
    [sym_break] = ACTIONS(5007),
    [sym_case] = ACTIONS(5007),
    [sym_cast] = ACTIONS(5007),
    [sym_class] = ACTIONS(5007),
    [sym_const] = ACTIONS(5007),
    [sym_continue] = ACTIONS(5007),
    [sym_debug] = ACTIONS(5007),
    [sym_default] = ACTIONS(5007),
    [sym_delegate] = ACTIONS(5007),
    [sym_delete] = ACTIONS(5007),
    [sym_deprecated] = ACTIONS(5007),
    [sym_do] = ACTIONS(5007),
    [sym_else] = ACTIONS(5007),
    [sym_enum] = ACTIONS(5007),
    [sym_export] = ACTIONS(5007),
    [sym_extern] = ACTIONS(5007),
    [sym_final] = ACTIONS(5007),
    [sym_for] = ACTIONS(5007),
    [sym_foreach] = ACTIONS(5007),
    [sym_foreach_reverse] = ACTIONS(5007),
    [sym_function] = ACTIONS(5007),
    [sym_goto] = ACTIONS(5007),
    [sym_if] = ACTIONS(5007),
    [sym_immutable] = ACTIONS(5007),
    [sym_import] = ACTIONS(5007),
    [sym_in] = ACTIONS(5007),
    [sym_inout] = ACTIONS(5007),
    [sym_interface] = ACTIONS(5007),
    [sym_invariant] = ACTIONS(5007),
    [sym_is] = ACTIONS(5007),
    [sym_mixin] = ACTIONS(5007),
    [sym_new] = ACTIONS(5007),
    [sym_nothrow] = ACTIONS(5007),
    [sym_out] = ACTIONS(5007),
    [sym_override] = ACTIONS(5007),
    [sym_package] = ACTIONS(5007),
    [sym_pragma] = ACTIONS(5007),
    [sym_private] = ACTIONS(5007),
    [sym_protected] = ACTIONS(5007),
    [sym_public] = ACTIONS(5007),
    [sym_pure] = ACTIONS(5007),
    [sym_ref] = ACTIONS(5007),
    [sym_return] = ACTIONS(5007),
    [sym_scope] = ACTIONS(5007),
    [sym_shared] = ACTIONS(5007),
    [sym_static] = ACTIONS(5007),
    [sym_struct] = ACTIONS(5007),
    [sym_switch] = ACTIONS(5007),
    [sym_synchronized] = ACTIONS(5007),
    [sym_template] = ACTIONS(5007),
    [sym_throw] = ACTIONS(5007),
    [sym_try] = ACTIONS(5007),
    [sym_typeid] = ACTIONS(5007),
    [sym_typeof] = ACTIONS(5007),
    [sym_union] = ACTIONS(5007),
    [sym_unittest] = ACTIONS(5007),
    [sym_version] = ACTIONS(5007),
    [sym_while] = ACTIONS(5007),
    [sym_with] = ACTIONS(5007),
    [sym_gshared] = ACTIONS(5007),
    [sym_traits] = ACTIONS(5007),
    [sym_vector] = ACTIONS(5007),
    [sym_void] = ACTIONS(5007),
    [anon_sym_BQUOTE] = ACTIONS(5009),
    [anon_sym_r_DQUOTE] = ACTIONS(5009),
    [anon_sym_x_DQUOTE] = ACTIONS(5009),
    [anon_sym_DQUOTE] = ACTIONS(5009),
    [anon_sym_i_BQUOTE] = ACTIONS(5009),
    [anon_sym_i_DQUOTE] = ACTIONS(5009),
    [anon_sym_iq_LBRACE] = ACTIONS(5009),
    [aux_sym_char_literal_token1] = ACTIONS(5009),
    [anon_sym_SQUOTE] = ACTIONS(5007),
    [anon_sym___DATE__] = ACTIONS(5007),
    [anon_sym___FILE__] = ACTIONS(5007),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5007),
    [anon_sym___FUNCTION__] = ACTIONS(5007),
    [anon_sym___LINE__] = ACTIONS(5007),
    [anon_sym___MODULE__] = ACTIONS(5007),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5007),
    [anon_sym___TIME__] = ACTIONS(5007),
    [anon_sym___TIMESTAMP__] = ACTIONS(5007),
    [anon_sym___VENDOR__] = ACTIONS(5007),
    [anon_sym___VERSION__] = ACTIONS(5007),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5009),
    [sym_float_literal] = ACTIONS(5009),
    [sym__string] = ACTIONS(5009),
  },
  [1655] = {
    [sym_identifier] = ACTIONS(4558),
    [anon_sym_q_LBRACE] = ACTIONS(4560),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_LBRACE] = ACTIONS(4560),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4560),
    [anon_sym_DASH] = ACTIONS(4558),
    [anon_sym_DASH_DASH] = ACTIONS(4560),
    [anon_sym_PLUS] = ACTIONS(4558),
    [anon_sym_PLUS_PLUS] = ACTIONS(4560),
    [anon_sym_BANG] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(4560),
    [anon_sym_RPAREN] = ACTIONS(4560),
    [anon_sym_LBRACK] = ACTIONS(4560),
    [anon_sym_SEMI] = ACTIONS(4560),
    [anon_sym_DOLLAR] = ACTIONS(4560),
    [anon_sym_STAR] = ACTIONS(4560),
    [anon_sym_TILDE] = ACTIONS(4560),
    [anon_sym_AT] = ACTIONS(4560),
    [sym_bool] = ACTIONS(4558),
    [sym_byte] = ACTIONS(4558),
    [sym_ubyte] = ACTIONS(4558),
    [sym_char] = ACTIONS(4558),
    [sym_short] = ACTIONS(4558),
    [sym_ushort] = ACTIONS(4558),
    [sym_int] = ACTIONS(4558),
    [sym_uint] = ACTIONS(4558),
    [sym_long] = ACTIONS(4558),
    [sym_ulong] = ACTIONS(4558),
    [sym_cent] = ACTIONS(4558),
    [sym_ucent] = ACTIONS(4558),
    [sym_wchar] = ACTIONS(4558),
    [sym_dchar] = ACTIONS(4558),
    [sym_float] = ACTIONS(4558),
    [sym_double] = ACTIONS(4558),
    [sym_real] = ACTIONS(4558),
    [sym_ifloat] = ACTIONS(4558),
    [sym_idouble] = ACTIONS(4558),
    [sym_ireal] = ACTIONS(4558),
    [sym_cfloat] = ACTIONS(4558),
    [sym_cdouble] = ACTIONS(4558),
    [sym_creal] = ACTIONS(4558),
    [sym_size_t] = ACTIONS(4558),
    [sym_ptrdiff_t] = ACTIONS(4558),
    [sym_string] = ACTIONS(4558),
    [sym_cstring] = ACTIONS(4558),
    [sym_dstring] = ACTIONS(4558),
    [sym_wstring] = ACTIONS(4558),
    [sym_noreturn] = ACTIONS(4558),
    [sym_true] = ACTIONS(4558),
    [sym_false] = ACTIONS(4558),
    [sym_null] = ACTIONS(4558),
    [sym_super] = ACTIONS(4558),
    [sym_this] = ACTIONS(4558),
    [sym_abstract] = ACTIONS(4558),
    [sym_alias] = ACTIONS(4558),
    [sym_align] = ACTIONS(4558),
    [sym_asm] = ACTIONS(4558),
    [sym_assert] = ACTIONS(4558),
    [sym_auto] = ACTIONS(4558),
    [sym_break] = ACTIONS(4558),
    [sym_case] = ACTIONS(4558),
    [sym_cast] = ACTIONS(4558),
    [sym_class] = ACTIONS(4558),
    [sym_const] = ACTIONS(4558),
    [sym_continue] = ACTIONS(4558),
    [sym_debug] = ACTIONS(4558),
    [sym_default] = ACTIONS(4558),
    [sym_delegate] = ACTIONS(4558),
    [sym_delete] = ACTIONS(4558),
    [sym_deprecated] = ACTIONS(4558),
    [sym_do] = ACTIONS(4558),
    [sym_else] = ACTIONS(4558),
    [sym_enum] = ACTIONS(4558),
    [sym_export] = ACTIONS(4558),
    [sym_extern] = ACTIONS(4558),
    [sym_final] = ACTIONS(4558),
    [sym_for] = ACTIONS(4558),
    [sym_foreach] = ACTIONS(4558),
    [sym_foreach_reverse] = ACTIONS(4558),
    [sym_function] = ACTIONS(4558),
    [sym_goto] = ACTIONS(4558),
    [sym_if] = ACTIONS(4558),
    [sym_immutable] = ACTIONS(4558),
    [sym_import] = ACTIONS(4558),
    [sym_in] = ACTIONS(4558),
    [sym_inout] = ACTIONS(4558),
    [sym_interface] = ACTIONS(4558),
    [sym_invariant] = ACTIONS(4558),
    [sym_is] = ACTIONS(4558),
    [sym_mixin] = ACTIONS(4558),
    [sym_new] = ACTIONS(4558),
    [sym_nothrow] = ACTIONS(4558),
    [sym_out] = ACTIONS(4558),
    [sym_override] = ACTIONS(4558),
    [sym_package] = ACTIONS(4558),
    [sym_pragma] = ACTIONS(4558),
    [sym_private] = ACTIONS(4558),
    [sym_protected] = ACTIONS(4558),
    [sym_public] = ACTIONS(4558),
    [sym_pure] = ACTIONS(4558),
    [sym_ref] = ACTIONS(4558),
    [sym_return] = ACTIONS(4558),
    [sym_scope] = ACTIONS(4558),
    [sym_shared] = ACTIONS(4558),
    [sym_static] = ACTIONS(4558),
    [sym_struct] = ACTIONS(4558),
    [sym_switch] = ACTIONS(4558),
    [sym_synchronized] = ACTIONS(4558),
    [sym_template] = ACTIONS(4558),
    [sym_throw] = ACTIONS(4558),
    [sym_try] = ACTIONS(4558),
    [sym_typeid] = ACTIONS(4558),
    [sym_typeof] = ACTIONS(4558),
    [sym_union] = ACTIONS(4558),
    [sym_unittest] = ACTIONS(4558),
    [sym_version] = ACTIONS(4558),
    [sym_while] = ACTIONS(4558),
    [sym_with] = ACTIONS(4558),
    [sym_gshared] = ACTIONS(4558),
    [sym_traits] = ACTIONS(4558),
    [sym_vector] = ACTIONS(4558),
    [sym_void] = ACTIONS(4558),
    [anon_sym_BQUOTE] = ACTIONS(4560),
    [anon_sym_r_DQUOTE] = ACTIONS(4560),
    [anon_sym_x_DQUOTE] = ACTIONS(4560),
    [anon_sym_DQUOTE] = ACTIONS(4560),
    [anon_sym_i_BQUOTE] = ACTIONS(4560),
    [anon_sym_i_DQUOTE] = ACTIONS(4560),
    [anon_sym_iq_LBRACE] = ACTIONS(4560),
    [aux_sym_char_literal_token1] = ACTIONS(4560),
    [anon_sym_SQUOTE] = ACTIONS(4558),
    [anon_sym___DATE__] = ACTIONS(4558),
    [anon_sym___FILE__] = ACTIONS(4558),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4558),
    [anon_sym___FUNCTION__] = ACTIONS(4558),
    [anon_sym___LINE__] = ACTIONS(4558),
    [anon_sym___MODULE__] = ACTIONS(4558),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4558),
    [anon_sym___TIME__] = ACTIONS(4558),
    [anon_sym___TIMESTAMP__] = ACTIONS(4558),
    [anon_sym___VENDOR__] = ACTIONS(4558),
    [anon_sym___VERSION__] = ACTIONS(4558),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4560),
    [sym_float_literal] = ACTIONS(4560),
    [sym__string] = ACTIONS(4560),
  },
  [1656] = {
    [sym_identifier] = ACTIONS(4358),
    [anon_sym_q_LBRACE] = ACTIONS(4360),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_LBRACE] = ACTIONS(4360),
    [anon_sym_DOT] = ACTIONS(4360),
    [anon_sym_AMP] = ACTIONS(4360),
    [anon_sym_DASH] = ACTIONS(4358),
    [anon_sym_DASH_DASH] = ACTIONS(4360),
    [anon_sym_PLUS] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4360),
    [anon_sym_BANG] = ACTIONS(4360),
    [anon_sym_LPAREN] = ACTIONS(4360),
    [anon_sym_RPAREN] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(4360),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_DOLLAR] = ACTIONS(4360),
    [anon_sym_STAR] = ACTIONS(4360),
    [anon_sym_TILDE] = ACTIONS(4360),
    [anon_sym_AT] = ACTIONS(4360),
    [sym_bool] = ACTIONS(4358),
    [sym_byte] = ACTIONS(4358),
    [sym_ubyte] = ACTIONS(4358),
    [sym_char] = ACTIONS(4358),
    [sym_short] = ACTIONS(4358),
    [sym_ushort] = ACTIONS(4358),
    [sym_int] = ACTIONS(4358),
    [sym_uint] = ACTIONS(4358),
    [sym_long] = ACTIONS(4358),
    [sym_ulong] = ACTIONS(4358),
    [sym_cent] = ACTIONS(4358),
    [sym_ucent] = ACTIONS(4358),
    [sym_wchar] = ACTIONS(4358),
    [sym_dchar] = ACTIONS(4358),
    [sym_float] = ACTIONS(4358),
    [sym_double] = ACTIONS(4358),
    [sym_real] = ACTIONS(4358),
    [sym_ifloat] = ACTIONS(4358),
    [sym_idouble] = ACTIONS(4358),
    [sym_ireal] = ACTIONS(4358),
    [sym_cfloat] = ACTIONS(4358),
    [sym_cdouble] = ACTIONS(4358),
    [sym_creal] = ACTIONS(4358),
    [sym_size_t] = ACTIONS(4358),
    [sym_ptrdiff_t] = ACTIONS(4358),
    [sym_string] = ACTIONS(4358),
    [sym_cstring] = ACTIONS(4358),
    [sym_dstring] = ACTIONS(4358),
    [sym_wstring] = ACTIONS(4358),
    [sym_noreturn] = ACTIONS(4358),
    [sym_true] = ACTIONS(4358),
    [sym_false] = ACTIONS(4358),
    [sym_null] = ACTIONS(4358),
    [sym_super] = ACTIONS(4358),
    [sym_this] = ACTIONS(4358),
    [sym_abstract] = ACTIONS(4358),
    [sym_alias] = ACTIONS(4358),
    [sym_align] = ACTIONS(4358),
    [sym_asm] = ACTIONS(4358),
    [sym_assert] = ACTIONS(4358),
    [sym_auto] = ACTIONS(4358),
    [sym_break] = ACTIONS(4358),
    [sym_case] = ACTIONS(4358),
    [sym_cast] = ACTIONS(4358),
    [sym_class] = ACTIONS(4358),
    [sym_const] = ACTIONS(4358),
    [sym_continue] = ACTIONS(4358),
    [sym_debug] = ACTIONS(4358),
    [sym_default] = ACTIONS(4358),
    [sym_delegate] = ACTIONS(4358),
    [sym_delete] = ACTIONS(4358),
    [sym_deprecated] = ACTIONS(4358),
    [sym_do] = ACTIONS(4358),
    [sym_else] = ACTIONS(4358),
    [sym_enum] = ACTIONS(4358),
    [sym_export] = ACTIONS(4358),
    [sym_extern] = ACTIONS(4358),
    [sym_final] = ACTIONS(4358),
    [sym_for] = ACTIONS(4358),
    [sym_foreach] = ACTIONS(4358),
    [sym_foreach_reverse] = ACTIONS(4358),
    [sym_function] = ACTIONS(4358),
    [sym_goto] = ACTIONS(4358),
    [sym_if] = ACTIONS(4358),
    [sym_immutable] = ACTIONS(4358),
    [sym_import] = ACTIONS(4358),
    [sym_in] = ACTIONS(4358),
    [sym_inout] = ACTIONS(4358),
    [sym_interface] = ACTIONS(4358),
    [sym_invariant] = ACTIONS(4358),
    [sym_is] = ACTIONS(4358),
    [sym_mixin] = ACTIONS(4358),
    [sym_new] = ACTIONS(4358),
    [sym_nothrow] = ACTIONS(4358),
    [sym_out] = ACTIONS(4358),
    [sym_override] = ACTIONS(4358),
    [sym_package] = ACTIONS(4358),
    [sym_pragma] = ACTIONS(4358),
    [sym_private] = ACTIONS(4358),
    [sym_protected] = ACTIONS(4358),
    [sym_public] = ACTIONS(4358),
    [sym_pure] = ACTIONS(4358),
    [sym_ref] = ACTIONS(4358),
    [sym_return] = ACTIONS(4358),
    [sym_scope] = ACTIONS(4358),
    [sym_shared] = ACTIONS(4358),
    [sym_static] = ACTIONS(4358),
    [sym_struct] = ACTIONS(4358),
    [sym_switch] = ACTIONS(4358),
    [sym_synchronized] = ACTIONS(4358),
    [sym_template] = ACTIONS(4358),
    [sym_throw] = ACTIONS(4358),
    [sym_try] = ACTIONS(4358),
    [sym_typeid] = ACTIONS(4358),
    [sym_typeof] = ACTIONS(4358),
    [sym_union] = ACTIONS(4358),
    [sym_unittest] = ACTIONS(4358),
    [sym_version] = ACTIONS(4358),
    [sym_while] = ACTIONS(4358),
    [sym_with] = ACTIONS(4358),
    [sym_gshared] = ACTIONS(4358),
    [sym_traits] = ACTIONS(4358),
    [sym_vector] = ACTIONS(4358),
    [sym_void] = ACTIONS(4358),
    [anon_sym_BQUOTE] = ACTIONS(4360),
    [anon_sym_r_DQUOTE] = ACTIONS(4360),
    [anon_sym_x_DQUOTE] = ACTIONS(4360),
    [anon_sym_DQUOTE] = ACTIONS(4360),
    [anon_sym_i_BQUOTE] = ACTIONS(4360),
    [anon_sym_i_DQUOTE] = ACTIONS(4360),
    [anon_sym_iq_LBRACE] = ACTIONS(4360),
    [aux_sym_char_literal_token1] = ACTIONS(4360),
    [anon_sym_SQUOTE] = ACTIONS(4358),
    [anon_sym___DATE__] = ACTIONS(4358),
    [anon_sym___FILE__] = ACTIONS(4358),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4358),
    [anon_sym___FUNCTION__] = ACTIONS(4358),
    [anon_sym___LINE__] = ACTIONS(4358),
    [anon_sym___MODULE__] = ACTIONS(4358),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4358),
    [anon_sym___TIME__] = ACTIONS(4358),
    [anon_sym___TIMESTAMP__] = ACTIONS(4358),
    [anon_sym___VENDOR__] = ACTIONS(4358),
    [anon_sym___VERSION__] = ACTIONS(4358),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4360),
    [sym_float_literal] = ACTIONS(4360),
    [sym__string] = ACTIONS(4360),
  },
  [1657] = {
    [sym_identifier] = ACTIONS(4941),
    [anon_sym_q_LBRACE] = ACTIONS(4943),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_LBRACE] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4943),
    [anon_sym_AMP] = ACTIONS(4943),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_BANG] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_DOLLAR] = ACTIONS(4943),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4943),
    [anon_sym_AT] = ACTIONS(4943),
    [sym_bool] = ACTIONS(4941),
    [sym_byte] = ACTIONS(4941),
    [sym_ubyte] = ACTIONS(4941),
    [sym_char] = ACTIONS(4941),
    [sym_short] = ACTIONS(4941),
    [sym_ushort] = ACTIONS(4941),
    [sym_int] = ACTIONS(4941),
    [sym_uint] = ACTIONS(4941),
    [sym_long] = ACTIONS(4941),
    [sym_ulong] = ACTIONS(4941),
    [sym_cent] = ACTIONS(4941),
    [sym_ucent] = ACTIONS(4941),
    [sym_wchar] = ACTIONS(4941),
    [sym_dchar] = ACTIONS(4941),
    [sym_float] = ACTIONS(4941),
    [sym_double] = ACTIONS(4941),
    [sym_real] = ACTIONS(4941),
    [sym_ifloat] = ACTIONS(4941),
    [sym_idouble] = ACTIONS(4941),
    [sym_ireal] = ACTIONS(4941),
    [sym_cfloat] = ACTIONS(4941),
    [sym_cdouble] = ACTIONS(4941),
    [sym_creal] = ACTIONS(4941),
    [sym_size_t] = ACTIONS(4941),
    [sym_ptrdiff_t] = ACTIONS(4941),
    [sym_string] = ACTIONS(4941),
    [sym_cstring] = ACTIONS(4941),
    [sym_dstring] = ACTIONS(4941),
    [sym_wstring] = ACTIONS(4941),
    [sym_noreturn] = ACTIONS(4941),
    [sym_true] = ACTIONS(4941),
    [sym_false] = ACTIONS(4941),
    [sym_null] = ACTIONS(4941),
    [sym_super] = ACTIONS(4941),
    [sym_this] = ACTIONS(4941),
    [sym_abstract] = ACTIONS(4941),
    [sym_alias] = ACTIONS(4941),
    [sym_align] = ACTIONS(4941),
    [sym_asm] = ACTIONS(4941),
    [sym_assert] = ACTIONS(4941),
    [sym_auto] = ACTIONS(4941),
    [sym_break] = ACTIONS(4941),
    [sym_case] = ACTIONS(4941),
    [sym_cast] = ACTIONS(4941),
    [sym_class] = ACTIONS(4941),
    [sym_const] = ACTIONS(4941),
    [sym_continue] = ACTIONS(4941),
    [sym_debug] = ACTIONS(4941),
    [sym_default] = ACTIONS(4941),
    [sym_delegate] = ACTIONS(4941),
    [sym_delete] = ACTIONS(4941),
    [sym_deprecated] = ACTIONS(4941),
    [sym_do] = ACTIONS(4941),
    [sym_else] = ACTIONS(4941),
    [sym_enum] = ACTIONS(4941),
    [sym_export] = ACTIONS(4941),
    [sym_extern] = ACTIONS(4941),
    [sym_final] = ACTIONS(4941),
    [sym_for] = ACTIONS(4941),
    [sym_foreach] = ACTIONS(4941),
    [sym_foreach_reverse] = ACTIONS(4941),
    [sym_function] = ACTIONS(4941),
    [sym_goto] = ACTIONS(4941),
    [sym_if] = ACTIONS(4941),
    [sym_immutable] = ACTIONS(4941),
    [sym_import] = ACTIONS(4941),
    [sym_in] = ACTIONS(4941),
    [sym_inout] = ACTIONS(4941),
    [sym_interface] = ACTIONS(4941),
    [sym_invariant] = ACTIONS(4941),
    [sym_is] = ACTIONS(4941),
    [sym_mixin] = ACTIONS(4941),
    [sym_new] = ACTIONS(4941),
    [sym_nothrow] = ACTIONS(4941),
    [sym_out] = ACTIONS(4941),
    [sym_override] = ACTIONS(4941),
    [sym_package] = ACTIONS(4941),
    [sym_pragma] = ACTIONS(4941),
    [sym_private] = ACTIONS(4941),
    [sym_protected] = ACTIONS(4941),
    [sym_public] = ACTIONS(4941),
    [sym_pure] = ACTIONS(4941),
    [sym_ref] = ACTIONS(4941),
    [sym_return] = ACTIONS(4941),
    [sym_scope] = ACTIONS(4941),
    [sym_shared] = ACTIONS(4941),
    [sym_static] = ACTIONS(4941),
    [sym_struct] = ACTIONS(4941),
    [sym_switch] = ACTIONS(4941),
    [sym_synchronized] = ACTIONS(4941),
    [sym_template] = ACTIONS(4941),
    [sym_throw] = ACTIONS(4941),
    [sym_try] = ACTIONS(4941),
    [sym_typeid] = ACTIONS(4941),
    [sym_typeof] = ACTIONS(4941),
    [sym_union] = ACTIONS(4941),
    [sym_unittest] = ACTIONS(4941),
    [sym_version] = ACTIONS(4941),
    [sym_while] = ACTIONS(4941),
    [sym_with] = ACTIONS(4941),
    [sym_gshared] = ACTIONS(4941),
    [sym_traits] = ACTIONS(4941),
    [sym_vector] = ACTIONS(4941),
    [sym_void] = ACTIONS(4941),
    [anon_sym_BQUOTE] = ACTIONS(4943),
    [anon_sym_r_DQUOTE] = ACTIONS(4943),
    [anon_sym_x_DQUOTE] = ACTIONS(4943),
    [anon_sym_DQUOTE] = ACTIONS(4943),
    [anon_sym_i_BQUOTE] = ACTIONS(4943),
    [anon_sym_i_DQUOTE] = ACTIONS(4943),
    [anon_sym_iq_LBRACE] = ACTIONS(4943),
    [aux_sym_char_literal_token1] = ACTIONS(4943),
    [anon_sym_SQUOTE] = ACTIONS(4941),
    [anon_sym___DATE__] = ACTIONS(4941),
    [anon_sym___FILE__] = ACTIONS(4941),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4941),
    [anon_sym___FUNCTION__] = ACTIONS(4941),
    [anon_sym___LINE__] = ACTIONS(4941),
    [anon_sym___MODULE__] = ACTIONS(4941),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4941),
    [anon_sym___TIME__] = ACTIONS(4941),
    [anon_sym___TIMESTAMP__] = ACTIONS(4941),
    [anon_sym___VENDOR__] = ACTIONS(4941),
    [anon_sym___VERSION__] = ACTIONS(4941),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4943),
    [sym_float_literal] = ACTIONS(4943),
    [sym__string] = ACTIONS(4943),
  },
  [1658] = {
    [sym_identifier] = ACTIONS(4570),
    [anon_sym_q_LBRACE] = ACTIONS(4572),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_LBRACE] = ACTIONS(4572),
    [anon_sym_DOT] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4572),
    [anon_sym_DASH] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4572),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_PLUS_PLUS] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4572),
    [anon_sym_LPAREN] = ACTIONS(4572),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4572),
    [anon_sym_STAR] = ACTIONS(4572),
    [anon_sym_TILDE] = ACTIONS(4572),
    [anon_sym_AT] = ACTIONS(4572),
    [sym_bool] = ACTIONS(4570),
    [sym_byte] = ACTIONS(4570),
    [sym_ubyte] = ACTIONS(4570),
    [sym_char] = ACTIONS(4570),
    [sym_short] = ACTIONS(4570),
    [sym_ushort] = ACTIONS(4570),
    [sym_int] = ACTIONS(4570),
    [sym_uint] = ACTIONS(4570),
    [sym_long] = ACTIONS(4570),
    [sym_ulong] = ACTIONS(4570),
    [sym_cent] = ACTIONS(4570),
    [sym_ucent] = ACTIONS(4570),
    [sym_wchar] = ACTIONS(4570),
    [sym_dchar] = ACTIONS(4570),
    [sym_float] = ACTIONS(4570),
    [sym_double] = ACTIONS(4570),
    [sym_real] = ACTIONS(4570),
    [sym_ifloat] = ACTIONS(4570),
    [sym_idouble] = ACTIONS(4570),
    [sym_ireal] = ACTIONS(4570),
    [sym_cfloat] = ACTIONS(4570),
    [sym_cdouble] = ACTIONS(4570),
    [sym_creal] = ACTIONS(4570),
    [sym_size_t] = ACTIONS(4570),
    [sym_ptrdiff_t] = ACTIONS(4570),
    [sym_string] = ACTIONS(4570),
    [sym_cstring] = ACTIONS(4570),
    [sym_dstring] = ACTIONS(4570),
    [sym_wstring] = ACTIONS(4570),
    [sym_noreturn] = ACTIONS(4570),
    [sym_true] = ACTIONS(4570),
    [sym_false] = ACTIONS(4570),
    [sym_null] = ACTIONS(4570),
    [sym_super] = ACTIONS(4570),
    [sym_this] = ACTIONS(4570),
    [sym_abstract] = ACTIONS(4570),
    [sym_alias] = ACTIONS(4570),
    [sym_align] = ACTIONS(4570),
    [sym_asm] = ACTIONS(4570),
    [sym_assert] = ACTIONS(4570),
    [sym_auto] = ACTIONS(4570),
    [sym_break] = ACTIONS(4570),
    [sym_case] = ACTIONS(4570),
    [sym_cast] = ACTIONS(4570),
    [sym_class] = ACTIONS(4570),
    [sym_const] = ACTIONS(4570),
    [sym_continue] = ACTIONS(4570),
    [sym_debug] = ACTIONS(4570),
    [sym_default] = ACTIONS(4570),
    [sym_delegate] = ACTIONS(4570),
    [sym_delete] = ACTIONS(4570),
    [sym_deprecated] = ACTIONS(4570),
    [sym_do] = ACTIONS(4570),
    [sym_else] = ACTIONS(4570),
    [sym_enum] = ACTIONS(4570),
    [sym_export] = ACTIONS(4570),
    [sym_extern] = ACTIONS(4570),
    [sym_final] = ACTIONS(4570),
    [sym_for] = ACTIONS(4570),
    [sym_foreach] = ACTIONS(4570),
    [sym_foreach_reverse] = ACTIONS(4570),
    [sym_function] = ACTIONS(4570),
    [sym_goto] = ACTIONS(4570),
    [sym_if] = ACTIONS(4570),
    [sym_immutable] = ACTIONS(4570),
    [sym_import] = ACTIONS(4570),
    [sym_in] = ACTIONS(4570),
    [sym_inout] = ACTIONS(4570),
    [sym_interface] = ACTIONS(4570),
    [sym_invariant] = ACTIONS(4570),
    [sym_is] = ACTIONS(4570),
    [sym_mixin] = ACTIONS(4570),
    [sym_new] = ACTIONS(4570),
    [sym_nothrow] = ACTIONS(4570),
    [sym_out] = ACTIONS(4570),
    [sym_override] = ACTIONS(4570),
    [sym_package] = ACTIONS(4570),
    [sym_pragma] = ACTIONS(4570),
    [sym_private] = ACTIONS(4570),
    [sym_protected] = ACTIONS(4570),
    [sym_public] = ACTIONS(4570),
    [sym_pure] = ACTIONS(4570),
    [sym_ref] = ACTIONS(4570),
    [sym_return] = ACTIONS(4570),
    [sym_scope] = ACTIONS(4570),
    [sym_shared] = ACTIONS(4570),
    [sym_static] = ACTIONS(4570),
    [sym_struct] = ACTIONS(4570),
    [sym_switch] = ACTIONS(4570),
    [sym_synchronized] = ACTIONS(4570),
    [sym_template] = ACTIONS(4570),
    [sym_throw] = ACTIONS(4570),
    [sym_try] = ACTIONS(4570),
    [sym_typeid] = ACTIONS(4570),
    [sym_typeof] = ACTIONS(4570),
    [sym_union] = ACTIONS(4570),
    [sym_unittest] = ACTIONS(4570),
    [sym_version] = ACTIONS(4570),
    [sym_while] = ACTIONS(4570),
    [sym_with] = ACTIONS(4570),
    [sym_gshared] = ACTIONS(4570),
    [sym_traits] = ACTIONS(4570),
    [sym_vector] = ACTIONS(4570),
    [sym_void] = ACTIONS(4570),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_r_DQUOTE] = ACTIONS(4572),
    [anon_sym_x_DQUOTE] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_i_BQUOTE] = ACTIONS(4572),
    [anon_sym_i_DQUOTE] = ACTIONS(4572),
    [anon_sym_iq_LBRACE] = ACTIONS(4572),
    [aux_sym_char_literal_token1] = ACTIONS(4572),
    [anon_sym_SQUOTE] = ACTIONS(4570),
    [anon_sym___DATE__] = ACTIONS(4570),
    [anon_sym___FILE__] = ACTIONS(4570),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4570),
    [anon_sym___FUNCTION__] = ACTIONS(4570),
    [anon_sym___LINE__] = ACTIONS(4570),
    [anon_sym___MODULE__] = ACTIONS(4570),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4570),
    [anon_sym___TIME__] = ACTIONS(4570),
    [anon_sym___TIMESTAMP__] = ACTIONS(4570),
    [anon_sym___VENDOR__] = ACTIONS(4570),
    [anon_sym___VERSION__] = ACTIONS(4570),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4572),
    [sym_float_literal] = ACTIONS(4572),
    [sym__string] = ACTIONS(4572),
  },
  [1659] = {
    [sym_identifier] = ACTIONS(4937),
    [anon_sym_q_LBRACE] = ACTIONS(4939),
    [anon_sym_RBRACE] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_DASH] = ACTIONS(4937),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4937),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_BANG] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_DOLLAR] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_TILDE] = ACTIONS(4939),
    [anon_sym_AT] = ACTIONS(4939),
    [sym_bool] = ACTIONS(4937),
    [sym_byte] = ACTIONS(4937),
    [sym_ubyte] = ACTIONS(4937),
    [sym_char] = ACTIONS(4937),
    [sym_short] = ACTIONS(4937),
    [sym_ushort] = ACTIONS(4937),
    [sym_int] = ACTIONS(4937),
    [sym_uint] = ACTIONS(4937),
    [sym_long] = ACTIONS(4937),
    [sym_ulong] = ACTIONS(4937),
    [sym_cent] = ACTIONS(4937),
    [sym_ucent] = ACTIONS(4937),
    [sym_wchar] = ACTIONS(4937),
    [sym_dchar] = ACTIONS(4937),
    [sym_float] = ACTIONS(4937),
    [sym_double] = ACTIONS(4937),
    [sym_real] = ACTIONS(4937),
    [sym_ifloat] = ACTIONS(4937),
    [sym_idouble] = ACTIONS(4937),
    [sym_ireal] = ACTIONS(4937),
    [sym_cfloat] = ACTIONS(4937),
    [sym_cdouble] = ACTIONS(4937),
    [sym_creal] = ACTIONS(4937),
    [sym_size_t] = ACTIONS(4937),
    [sym_ptrdiff_t] = ACTIONS(4937),
    [sym_string] = ACTIONS(4937),
    [sym_cstring] = ACTIONS(4937),
    [sym_dstring] = ACTIONS(4937),
    [sym_wstring] = ACTIONS(4937),
    [sym_noreturn] = ACTIONS(4937),
    [sym_true] = ACTIONS(4937),
    [sym_false] = ACTIONS(4937),
    [sym_null] = ACTIONS(4937),
    [sym_super] = ACTIONS(4937),
    [sym_this] = ACTIONS(4937),
    [sym_abstract] = ACTIONS(4937),
    [sym_alias] = ACTIONS(4937),
    [sym_align] = ACTIONS(4937),
    [sym_asm] = ACTIONS(4937),
    [sym_assert] = ACTIONS(4937),
    [sym_auto] = ACTIONS(4937),
    [sym_break] = ACTIONS(4937),
    [sym_case] = ACTIONS(4937),
    [sym_cast] = ACTIONS(4937),
    [sym_class] = ACTIONS(4937),
    [sym_const] = ACTIONS(4937),
    [sym_continue] = ACTIONS(4937),
    [sym_debug] = ACTIONS(4937),
    [sym_default] = ACTIONS(4937),
    [sym_delegate] = ACTIONS(4937),
    [sym_delete] = ACTIONS(4937),
    [sym_deprecated] = ACTIONS(4937),
    [sym_do] = ACTIONS(4937),
    [sym_else] = ACTIONS(4937),
    [sym_enum] = ACTIONS(4937),
    [sym_export] = ACTIONS(4937),
    [sym_extern] = ACTIONS(4937),
    [sym_final] = ACTIONS(4937),
    [sym_for] = ACTIONS(4937),
    [sym_foreach] = ACTIONS(4937),
    [sym_foreach_reverse] = ACTIONS(4937),
    [sym_function] = ACTIONS(4937),
    [sym_goto] = ACTIONS(4937),
    [sym_if] = ACTIONS(4937),
    [sym_immutable] = ACTIONS(4937),
    [sym_import] = ACTIONS(4937),
    [sym_in] = ACTIONS(4937),
    [sym_inout] = ACTIONS(4937),
    [sym_interface] = ACTIONS(4937),
    [sym_invariant] = ACTIONS(4937),
    [sym_is] = ACTIONS(4937),
    [sym_mixin] = ACTIONS(4937),
    [sym_new] = ACTIONS(4937),
    [sym_nothrow] = ACTIONS(4937),
    [sym_out] = ACTIONS(4937),
    [sym_override] = ACTIONS(4937),
    [sym_package] = ACTIONS(4937),
    [sym_pragma] = ACTIONS(4937),
    [sym_private] = ACTIONS(4937),
    [sym_protected] = ACTIONS(4937),
    [sym_public] = ACTIONS(4937),
    [sym_pure] = ACTIONS(4937),
    [sym_ref] = ACTIONS(4937),
    [sym_return] = ACTIONS(4937),
    [sym_scope] = ACTIONS(4937),
    [sym_shared] = ACTIONS(4937),
    [sym_static] = ACTIONS(4937),
    [sym_struct] = ACTIONS(4937),
    [sym_switch] = ACTIONS(4937),
    [sym_synchronized] = ACTIONS(4937),
    [sym_template] = ACTIONS(4937),
    [sym_throw] = ACTIONS(4937),
    [sym_try] = ACTIONS(4937),
    [sym_typeid] = ACTIONS(4937),
    [sym_typeof] = ACTIONS(4937),
    [sym_union] = ACTIONS(4937),
    [sym_unittest] = ACTIONS(4937),
    [sym_version] = ACTIONS(4937),
    [sym_while] = ACTIONS(4937),
    [sym_with] = ACTIONS(4937),
    [sym_gshared] = ACTIONS(4937),
    [sym_traits] = ACTIONS(4937),
    [sym_vector] = ACTIONS(4937),
    [sym_void] = ACTIONS(4937),
    [anon_sym_BQUOTE] = ACTIONS(4939),
    [anon_sym_r_DQUOTE] = ACTIONS(4939),
    [anon_sym_x_DQUOTE] = ACTIONS(4939),
    [anon_sym_DQUOTE] = ACTIONS(4939),
    [anon_sym_i_BQUOTE] = ACTIONS(4939),
    [anon_sym_i_DQUOTE] = ACTIONS(4939),
    [anon_sym_iq_LBRACE] = ACTIONS(4939),
    [aux_sym_char_literal_token1] = ACTIONS(4939),
    [anon_sym_SQUOTE] = ACTIONS(4937),
    [anon_sym___DATE__] = ACTIONS(4937),
    [anon_sym___FILE__] = ACTIONS(4937),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4937),
    [anon_sym___FUNCTION__] = ACTIONS(4937),
    [anon_sym___LINE__] = ACTIONS(4937),
    [anon_sym___MODULE__] = ACTIONS(4937),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4937),
    [anon_sym___TIME__] = ACTIONS(4937),
    [anon_sym___TIMESTAMP__] = ACTIONS(4937),
    [anon_sym___VENDOR__] = ACTIONS(4937),
    [anon_sym___VERSION__] = ACTIONS(4937),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4939),
    [sym_float_literal] = ACTIONS(4939),
    [sym__string] = ACTIONS(4939),
  },
  [1660] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [anon_sym_AT] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_abstract] = ACTIONS(4366),
    [sym_alias] = ACTIONS(4366),
    [sym_align] = ACTIONS(4366),
    [sym_asm] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_break] = ACTIONS(4366),
    [sym_case] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_class] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_continue] = ACTIONS(4366),
    [sym_debug] = ACTIONS(4366),
    [sym_default] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_deprecated] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(5030),
    [sym_enum] = ACTIONS(4366),
    [sym_export] = ACTIONS(4366),
    [sym_extern] = ACTIONS(4366),
    [sym_final] = ACTIONS(4366),
    [sym_for] = ACTIONS(4366),
    [sym_foreach] = ACTIONS(4366),
    [sym_foreach_reverse] = ACTIONS(4366),
    [sym_function] = ACTIONS(4366),
    [sym_goto] = ACTIONS(4366),
    [sym_if] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_interface] = ACTIONS(4366),
    [sym_invariant] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_nothrow] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_override] = ACTIONS(4366),
    [sym_package] = ACTIONS(4366),
    [sym_pragma] = ACTIONS(4366),
    [sym_private] = ACTIONS(4366),
    [sym_protected] = ACTIONS(4366),
    [sym_public] = ACTIONS(4366),
    [sym_pure] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_return] = ACTIONS(4366),
    [sym_scope] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_static] = ACTIONS(4366),
    [sym_struct] = ACTIONS(4366),
    [sym_switch] = ACTIONS(4366),
    [sym_synchronized] = ACTIONS(4366),
    [sym_template] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_try] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_union] = ACTIONS(4366),
    [sym_unittest] = ACTIONS(4366),
    [sym_version] = ACTIONS(4366),
    [sym_while] = ACTIONS(4366),
    [sym_with] = ACTIONS(4366),
    [sym_gshared] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [1661] = {
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_q_LBRACE] = ACTIONS(4791),
    [anon_sym_RBRACE] = ACTIONS(4791),
    [anon_sym_LBRACE] = ACTIONS(4791),
    [anon_sym_DOT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4789),
    [anon_sym_DASH_DASH] = ACTIONS(4791),
    [anon_sym_PLUS] = ACTIONS(4789),
    [anon_sym_PLUS_PLUS] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_LPAREN] = ACTIONS(4791),
    [anon_sym_RPAREN] = ACTIONS(4791),
    [anon_sym_LBRACK] = ACTIONS(4791),
    [anon_sym_SEMI] = ACTIONS(4791),
    [anon_sym_DOLLAR] = ACTIONS(4791),
    [anon_sym_STAR] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [anon_sym_AT] = ACTIONS(4791),
    [sym_bool] = ACTIONS(4789),
    [sym_byte] = ACTIONS(4789),
    [sym_ubyte] = ACTIONS(4789),
    [sym_char] = ACTIONS(4789),
    [sym_short] = ACTIONS(4789),
    [sym_ushort] = ACTIONS(4789),
    [sym_int] = ACTIONS(4789),
    [sym_uint] = ACTIONS(4789),
    [sym_long] = ACTIONS(4789),
    [sym_ulong] = ACTIONS(4789),
    [sym_cent] = ACTIONS(4789),
    [sym_ucent] = ACTIONS(4789),
    [sym_wchar] = ACTIONS(4789),
    [sym_dchar] = ACTIONS(4789),
    [sym_float] = ACTIONS(4789),
    [sym_double] = ACTIONS(4789),
    [sym_real] = ACTIONS(4789),
    [sym_ifloat] = ACTIONS(4789),
    [sym_idouble] = ACTIONS(4789),
    [sym_ireal] = ACTIONS(4789),
    [sym_cfloat] = ACTIONS(4789),
    [sym_cdouble] = ACTIONS(4789),
    [sym_creal] = ACTIONS(4789),
    [sym_size_t] = ACTIONS(4789),
    [sym_ptrdiff_t] = ACTIONS(4789),
    [sym_string] = ACTIONS(4789),
    [sym_cstring] = ACTIONS(4789),
    [sym_dstring] = ACTIONS(4789),
    [sym_wstring] = ACTIONS(4789),
    [sym_noreturn] = ACTIONS(4789),
    [sym_true] = ACTIONS(4789),
    [sym_false] = ACTIONS(4789),
    [sym_null] = ACTIONS(4789),
    [sym_super] = ACTIONS(4789),
    [sym_this] = ACTIONS(4789),
    [sym_abstract] = ACTIONS(4789),
    [sym_alias] = ACTIONS(4789),
    [sym_align] = ACTIONS(4789),
    [sym_asm] = ACTIONS(4789),
    [sym_assert] = ACTIONS(4789),
    [sym_auto] = ACTIONS(4789),
    [sym_break] = ACTIONS(4789),
    [sym_case] = ACTIONS(4789),
    [sym_cast] = ACTIONS(4789),
    [sym_class] = ACTIONS(4789),
    [sym_const] = ACTIONS(4789),
    [sym_continue] = ACTIONS(4789),
    [sym_debug] = ACTIONS(4789),
    [sym_default] = ACTIONS(4789),
    [sym_delegate] = ACTIONS(4789),
    [sym_delete] = ACTIONS(4789),
    [sym_deprecated] = ACTIONS(4789),
    [sym_do] = ACTIONS(4789),
    [sym_else] = ACTIONS(4789),
    [sym_enum] = ACTIONS(4789),
    [sym_export] = ACTIONS(4789),
    [sym_extern] = ACTIONS(4789),
    [sym_final] = ACTIONS(4789),
    [sym_for] = ACTIONS(4789),
    [sym_foreach] = ACTIONS(4789),
    [sym_foreach_reverse] = ACTIONS(4789),
    [sym_function] = ACTIONS(4789),
    [sym_goto] = ACTIONS(4789),
    [sym_if] = ACTIONS(4789),
    [sym_immutable] = ACTIONS(4789),
    [sym_import] = ACTIONS(4789),
    [sym_in] = ACTIONS(4789),
    [sym_inout] = ACTIONS(4789),
    [sym_interface] = ACTIONS(4789),
    [sym_invariant] = ACTIONS(4789),
    [sym_is] = ACTIONS(4789),
    [sym_mixin] = ACTIONS(4789),
    [sym_new] = ACTIONS(4789),
    [sym_nothrow] = ACTIONS(4789),
    [sym_out] = ACTIONS(4789),
    [sym_override] = ACTIONS(4789),
    [sym_package] = ACTIONS(4789),
    [sym_pragma] = ACTIONS(4789),
    [sym_private] = ACTIONS(4789),
    [sym_protected] = ACTIONS(4789),
    [sym_public] = ACTIONS(4789),
    [sym_pure] = ACTIONS(4789),
    [sym_ref] = ACTIONS(4789),
    [sym_return] = ACTIONS(4789),
    [sym_scope] = ACTIONS(4789),
    [sym_shared] = ACTIONS(4789),
    [sym_static] = ACTIONS(4789),
    [sym_struct] = ACTIONS(4789),
    [sym_switch] = ACTIONS(4789),
    [sym_synchronized] = ACTIONS(4789),
    [sym_template] = ACTIONS(4789),
    [sym_throw] = ACTIONS(4789),
    [sym_try] = ACTIONS(4789),
    [sym_typeid] = ACTIONS(4789),
    [sym_typeof] = ACTIONS(4789),
    [sym_union] = ACTIONS(4789),
    [sym_unittest] = ACTIONS(4789),
    [sym_version] = ACTIONS(4789),
    [sym_while] = ACTIONS(4789),
    [sym_with] = ACTIONS(4789),
    [sym_gshared] = ACTIONS(4789),
    [sym_traits] = ACTIONS(4789),
    [sym_vector] = ACTIONS(4789),
    [sym_void] = ACTIONS(4789),
    [anon_sym_BQUOTE] = ACTIONS(4791),
    [anon_sym_r_DQUOTE] = ACTIONS(4791),
    [anon_sym_x_DQUOTE] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(4791),
    [anon_sym_i_BQUOTE] = ACTIONS(4791),
    [anon_sym_i_DQUOTE] = ACTIONS(4791),
    [anon_sym_iq_LBRACE] = ACTIONS(4791),
    [aux_sym_char_literal_token1] = ACTIONS(4791),
    [anon_sym_SQUOTE] = ACTIONS(4789),
    [anon_sym___DATE__] = ACTIONS(4789),
    [anon_sym___FILE__] = ACTIONS(4789),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4789),
    [anon_sym___FUNCTION__] = ACTIONS(4789),
    [anon_sym___LINE__] = ACTIONS(4789),
    [anon_sym___MODULE__] = ACTIONS(4789),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4789),
    [anon_sym___TIME__] = ACTIONS(4789),
    [anon_sym___TIMESTAMP__] = ACTIONS(4789),
    [anon_sym___VENDOR__] = ACTIONS(4789),
    [anon_sym___VERSION__] = ACTIONS(4789),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4791),
    [sym_float_literal] = ACTIONS(4791),
    [sym__string] = ACTIONS(4791),
  },
  [1662] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_q_LBRACE] = ACTIONS(3178),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_abstract] = ACTIONS(3176),
    [sym_alias] = ACTIONS(3176),
    [sym_align] = ACTIONS(3176),
    [sym_asm] = ACTIONS(3176),
    [sym_assert] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_break] = ACTIONS(3176),
    [sym_case] = ACTIONS(3176),
    [sym_cast] = ACTIONS(3176),
    [sym_class] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_continue] = ACTIONS(3176),
    [sym_debug] = ACTIONS(3176),
    [sym_default] = ACTIONS(3176),
    [sym_delegate] = ACTIONS(3176),
    [sym_delete] = ACTIONS(3176),
    [sym_deprecated] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_enum] = ACTIONS(3176),
    [sym_export] = ACTIONS(3176),
    [sym_extern] = ACTIONS(3176),
    [sym_final] = ACTIONS(3176),
    [sym_for] = ACTIONS(3176),
    [sym_foreach] = ACTIONS(3176),
    [sym_foreach_reverse] = ACTIONS(3176),
    [sym_function] = ACTIONS(3176),
    [sym_goto] = ACTIONS(3176),
    [sym_if] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_interface] = ACTIONS(3176),
    [sym_invariant] = ACTIONS(3176),
    [sym_is] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_new] = ACTIONS(3176),
    [sym_nothrow] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_override] = ACTIONS(3176),
    [sym_package] = ACTIONS(3176),
    [sym_pragma] = ACTIONS(3176),
    [sym_private] = ACTIONS(3176),
    [sym_protected] = ACTIONS(3176),
    [sym_public] = ACTIONS(3176),
    [sym_pure] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_return] = ACTIONS(3176),
    [sym_scope] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_static] = ACTIONS(3176),
    [sym_struct] = ACTIONS(3176),
    [sym_switch] = ACTIONS(3176),
    [sym_synchronized] = ACTIONS(3176),
    [sym_template] = ACTIONS(3176),
    [sym_throw] = ACTIONS(3176),
    [sym_try] = ACTIONS(3176),
    [sym_typeid] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_union] = ACTIONS(3176),
    [sym_unittest] = ACTIONS(3176),
    [sym_version] = ACTIONS(3176),
    [sym_while] = ACTIONS(3176),
    [sym_with] = ACTIONS(3176),
    [sym_gshared] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_r_DQUOTE] = ACTIONS(3178),
    [anon_sym_x_DQUOTE] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_i_BQUOTE] = ACTIONS(3178),
    [anon_sym_i_DQUOTE] = ACTIONS(3178),
    [anon_sym_iq_LBRACE] = ACTIONS(3178),
    [aux_sym_char_literal_token1] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym___DATE__] = ACTIONS(3176),
    [anon_sym___FILE__] = ACTIONS(3176),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3176),
    [anon_sym___FUNCTION__] = ACTIONS(3176),
    [anon_sym___LINE__] = ACTIONS(3176),
    [anon_sym___MODULE__] = ACTIONS(3176),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3176),
    [anon_sym___TIME__] = ACTIONS(3176),
    [anon_sym___TIMESTAMP__] = ACTIONS(3176),
    [anon_sym___VENDOR__] = ACTIONS(3176),
    [anon_sym___VERSION__] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3178),
    [sym_float_literal] = ACTIONS(3178),
    [sym__string] = ACTIONS(3178),
  },
  [1663] = {
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2523),
    [sym_bool] = ACTIONS(2525),
    [sym_byte] = ACTIONS(2525),
    [sym_ubyte] = ACTIONS(2525),
    [sym_char] = ACTIONS(2525),
    [sym_short] = ACTIONS(2525),
    [sym_ushort] = ACTIONS(2525),
    [sym_int] = ACTIONS(2525),
    [sym_uint] = ACTIONS(2525),
    [sym_long] = ACTIONS(2525),
    [sym_ulong] = ACTIONS(2525),
    [sym_cent] = ACTIONS(2525),
    [sym_ucent] = ACTIONS(2525),
    [sym_wchar] = ACTIONS(2525),
    [sym_dchar] = ACTIONS(2525),
    [sym_float] = ACTIONS(2525),
    [sym_double] = ACTIONS(2525),
    [sym_real] = ACTIONS(2525),
    [sym_ifloat] = ACTIONS(2525),
    [sym_idouble] = ACTIONS(2525),
    [sym_ireal] = ACTIONS(2525),
    [sym_cfloat] = ACTIONS(2525),
    [sym_cdouble] = ACTIONS(2525),
    [sym_creal] = ACTIONS(2525),
    [sym_size_t] = ACTIONS(2525),
    [sym_ptrdiff_t] = ACTIONS(2525),
    [sym_string] = ACTIONS(2525),
    [sym_cstring] = ACTIONS(2525),
    [sym_dstring] = ACTIONS(2525),
    [sym_wstring] = ACTIONS(2525),
    [sym_noreturn] = ACTIONS(2525),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2525),
    [sym_abstract] = ACTIONS(2525),
    [sym_alias] = ACTIONS(2525),
    [sym_align] = ACTIONS(2525),
    [sym_asm] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(2525),
    [sym_break] = ACTIONS(2525),
    [sym_case] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_class] = ACTIONS(2525),
    [sym_const] = ACTIONS(2525),
    [sym_continue] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2525),
    [sym_default] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(2525),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(2525),
    [sym_export] = ACTIONS(2525),
    [sym_extern] = ACTIONS(2525),
    [sym_final] = ACTIONS(2525),
    [sym_for] = ACTIONS(2525),
    [sym_foreach] = ACTIONS(2525),
    [sym_foreach_reverse] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_goto] = ACTIONS(2525),
    [sym_if] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(2525),
    [sym_import] = ACTIONS(2525),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(2525),
    [sym_interface] = ACTIONS(2525),
    [sym_invariant] = ACTIONS(2525),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2525),
    [sym_new] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(2525),
    [sym_out] = ACTIONS(2525),
    [sym_override] = ACTIONS(2525),
    [sym_package] = ACTIONS(2525),
    [sym_pragma] = ACTIONS(2525),
    [sym_private] = ACTIONS(2525),
    [sym_protected] = ACTIONS(2525),
    [sym_public] = ACTIONS(2525),
    [sym_pure] = ACTIONS(2525),
    [sym_ref] = ACTIONS(2525),
    [sym_return] = ACTIONS(2525),
    [sym_scope] = ACTIONS(2525),
    [sym_shared] = ACTIONS(2525),
    [sym_static] = ACTIONS(2525),
    [sym_struct] = ACTIONS(2525),
    [sym_switch] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(2525),
    [sym_template] = ACTIONS(2525),
    [sym_throw] = ACTIONS(2525),
    [sym_try] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(2525),
    [sym_union] = ACTIONS(2525),
    [sym_unittest] = ACTIONS(2525),
    [sym_version] = ACTIONS(2525),
    [sym_while] = ACTIONS(2525),
    [sym_with] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(2525),
    [sym_traits] = ACTIONS(2525),
    [sym_vector] = ACTIONS(2525),
    [sym_void] = ACTIONS(2525),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [1664] = {
    [sym_identifier] = ACTIONS(4630),
    [anon_sym_q_LBRACE] = ACTIONS(4632),
    [anon_sym_RBRACE] = ACTIONS(4632),
    [anon_sym_LBRACE] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(4632),
    [anon_sym_AMP] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4630),
    [anon_sym_DASH_DASH] = ACTIONS(4632),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_PLUS_PLUS] = ACTIONS(4632),
    [anon_sym_BANG] = ACTIONS(4632),
    [anon_sym_LPAREN] = ACTIONS(4632),
    [anon_sym_RPAREN] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4632),
    [anon_sym_DOLLAR] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4632),
    [anon_sym_TILDE] = ACTIONS(4632),
    [anon_sym_AT] = ACTIONS(4632),
    [sym_bool] = ACTIONS(4630),
    [sym_byte] = ACTIONS(4630),
    [sym_ubyte] = ACTIONS(4630),
    [sym_char] = ACTIONS(4630),
    [sym_short] = ACTIONS(4630),
    [sym_ushort] = ACTIONS(4630),
    [sym_int] = ACTIONS(4630),
    [sym_uint] = ACTIONS(4630),
    [sym_long] = ACTIONS(4630),
    [sym_ulong] = ACTIONS(4630),
    [sym_cent] = ACTIONS(4630),
    [sym_ucent] = ACTIONS(4630),
    [sym_wchar] = ACTIONS(4630),
    [sym_dchar] = ACTIONS(4630),
    [sym_float] = ACTIONS(4630),
    [sym_double] = ACTIONS(4630),
    [sym_real] = ACTIONS(4630),
    [sym_ifloat] = ACTIONS(4630),
    [sym_idouble] = ACTIONS(4630),
    [sym_ireal] = ACTIONS(4630),
    [sym_cfloat] = ACTIONS(4630),
    [sym_cdouble] = ACTIONS(4630),
    [sym_creal] = ACTIONS(4630),
    [sym_size_t] = ACTIONS(4630),
    [sym_ptrdiff_t] = ACTIONS(4630),
    [sym_string] = ACTIONS(4630),
    [sym_cstring] = ACTIONS(4630),
    [sym_dstring] = ACTIONS(4630),
    [sym_wstring] = ACTIONS(4630),
    [sym_noreturn] = ACTIONS(4630),
    [sym_true] = ACTIONS(4630),
    [sym_false] = ACTIONS(4630),
    [sym_null] = ACTIONS(4630),
    [sym_super] = ACTIONS(4630),
    [sym_this] = ACTIONS(4630),
    [sym_abstract] = ACTIONS(4630),
    [sym_alias] = ACTIONS(4630),
    [sym_align] = ACTIONS(4630),
    [sym_asm] = ACTIONS(4630),
    [sym_assert] = ACTIONS(4630),
    [sym_auto] = ACTIONS(4630),
    [sym_break] = ACTIONS(4630),
    [sym_case] = ACTIONS(4630),
    [sym_cast] = ACTIONS(4630),
    [sym_class] = ACTIONS(4630),
    [sym_const] = ACTIONS(4630),
    [sym_continue] = ACTIONS(4630),
    [sym_debug] = ACTIONS(4630),
    [sym_default] = ACTIONS(4630),
    [sym_delegate] = ACTIONS(4630),
    [sym_delete] = ACTIONS(4630),
    [sym_deprecated] = ACTIONS(4630),
    [sym_do] = ACTIONS(4630),
    [sym_else] = ACTIONS(4630),
    [sym_enum] = ACTIONS(4630),
    [sym_export] = ACTIONS(4630),
    [sym_extern] = ACTIONS(4630),
    [sym_final] = ACTIONS(4630),
    [sym_for] = ACTIONS(4630),
    [sym_foreach] = ACTIONS(4630),
    [sym_foreach_reverse] = ACTIONS(4630),
    [sym_function] = ACTIONS(4630),
    [sym_goto] = ACTIONS(4630),
    [sym_if] = ACTIONS(4630),
    [sym_immutable] = ACTIONS(4630),
    [sym_import] = ACTIONS(4630),
    [sym_in] = ACTIONS(4630),
    [sym_inout] = ACTIONS(4630),
    [sym_interface] = ACTIONS(4630),
    [sym_invariant] = ACTIONS(4630),
    [sym_is] = ACTIONS(4630),
    [sym_mixin] = ACTIONS(4630),
    [sym_new] = ACTIONS(4630),
    [sym_nothrow] = ACTIONS(4630),
    [sym_out] = ACTIONS(4630),
    [sym_override] = ACTIONS(4630),
    [sym_package] = ACTIONS(4630),
    [sym_pragma] = ACTIONS(4630),
    [sym_private] = ACTIONS(4630),
    [sym_protected] = ACTIONS(4630),
    [sym_public] = ACTIONS(4630),
    [sym_pure] = ACTIONS(4630),
    [sym_ref] = ACTIONS(4630),
    [sym_return] = ACTIONS(4630),
    [sym_scope] = ACTIONS(4630),
    [sym_shared] = ACTIONS(4630),
    [sym_static] = ACTIONS(4630),
    [sym_struct] = ACTIONS(4630),
    [sym_switch] = ACTIONS(4630),
    [sym_synchronized] = ACTIONS(4630),
    [sym_template] = ACTIONS(4630),
    [sym_throw] = ACTIONS(4630),
    [sym_try] = ACTIONS(4630),
    [sym_typeid] = ACTIONS(4630),
    [sym_typeof] = ACTIONS(4630),
    [sym_union] = ACTIONS(4630),
    [sym_unittest] = ACTIONS(4630),
    [sym_version] = ACTIONS(4630),
    [sym_while] = ACTIONS(4630),
    [sym_with] = ACTIONS(4630),
    [sym_gshared] = ACTIONS(4630),
    [sym_traits] = ACTIONS(4630),
    [sym_vector] = ACTIONS(4630),
    [sym_void] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(4632),
    [anon_sym_r_DQUOTE] = ACTIONS(4632),
    [anon_sym_x_DQUOTE] = ACTIONS(4632),
    [anon_sym_DQUOTE] = ACTIONS(4632),
    [anon_sym_i_BQUOTE] = ACTIONS(4632),
    [anon_sym_i_DQUOTE] = ACTIONS(4632),
    [anon_sym_iq_LBRACE] = ACTIONS(4632),
    [aux_sym_char_literal_token1] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4630),
    [anon_sym___DATE__] = ACTIONS(4630),
    [anon_sym___FILE__] = ACTIONS(4630),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4630),
    [anon_sym___FUNCTION__] = ACTIONS(4630),
    [anon_sym___LINE__] = ACTIONS(4630),
    [anon_sym___MODULE__] = ACTIONS(4630),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4630),
    [anon_sym___TIME__] = ACTIONS(4630),
    [anon_sym___TIMESTAMP__] = ACTIONS(4630),
    [anon_sym___VENDOR__] = ACTIONS(4630),
    [anon_sym___VERSION__] = ACTIONS(4630),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4632),
    [sym_float_literal] = ACTIONS(4632),
    [sym__string] = ACTIONS(4632),
  },
  [1665] = {
    [sym_identifier] = ACTIONS(4933),
    [anon_sym_q_LBRACE] = ACTIONS(4935),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4935),
    [anon_sym_PLUS] = ACTIONS(4933),
    [anon_sym_PLUS_PLUS] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_LPAREN] = ACTIONS(4935),
    [anon_sym_RPAREN] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4935),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym_DOLLAR] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4935),
    [anon_sym_TILDE] = ACTIONS(4935),
    [anon_sym_AT] = ACTIONS(4935),
    [sym_bool] = ACTIONS(4933),
    [sym_byte] = ACTIONS(4933),
    [sym_ubyte] = ACTIONS(4933),
    [sym_char] = ACTIONS(4933),
    [sym_short] = ACTIONS(4933),
    [sym_ushort] = ACTIONS(4933),
    [sym_int] = ACTIONS(4933),
    [sym_uint] = ACTIONS(4933),
    [sym_long] = ACTIONS(4933),
    [sym_ulong] = ACTIONS(4933),
    [sym_cent] = ACTIONS(4933),
    [sym_ucent] = ACTIONS(4933),
    [sym_wchar] = ACTIONS(4933),
    [sym_dchar] = ACTIONS(4933),
    [sym_float] = ACTIONS(4933),
    [sym_double] = ACTIONS(4933),
    [sym_real] = ACTIONS(4933),
    [sym_ifloat] = ACTIONS(4933),
    [sym_idouble] = ACTIONS(4933),
    [sym_ireal] = ACTIONS(4933),
    [sym_cfloat] = ACTIONS(4933),
    [sym_cdouble] = ACTIONS(4933),
    [sym_creal] = ACTIONS(4933),
    [sym_size_t] = ACTIONS(4933),
    [sym_ptrdiff_t] = ACTIONS(4933),
    [sym_string] = ACTIONS(4933),
    [sym_cstring] = ACTIONS(4933),
    [sym_dstring] = ACTIONS(4933),
    [sym_wstring] = ACTIONS(4933),
    [sym_noreturn] = ACTIONS(4933),
    [sym_true] = ACTIONS(4933),
    [sym_false] = ACTIONS(4933),
    [sym_null] = ACTIONS(4933),
    [sym_super] = ACTIONS(4933),
    [sym_this] = ACTIONS(4933),
    [sym_abstract] = ACTIONS(4933),
    [sym_alias] = ACTIONS(4933),
    [sym_align] = ACTIONS(4933),
    [sym_asm] = ACTIONS(4933),
    [sym_assert] = ACTIONS(4933),
    [sym_auto] = ACTIONS(4933),
    [sym_break] = ACTIONS(4933),
    [sym_case] = ACTIONS(4933),
    [sym_cast] = ACTIONS(4933),
    [sym_class] = ACTIONS(4933),
    [sym_const] = ACTIONS(4933),
    [sym_continue] = ACTIONS(4933),
    [sym_debug] = ACTIONS(4933),
    [sym_default] = ACTIONS(4933),
    [sym_delegate] = ACTIONS(4933),
    [sym_delete] = ACTIONS(4933),
    [sym_deprecated] = ACTIONS(4933),
    [sym_do] = ACTIONS(4933),
    [sym_else] = ACTIONS(4933),
    [sym_enum] = ACTIONS(4933),
    [sym_export] = ACTIONS(4933),
    [sym_extern] = ACTIONS(4933),
    [sym_final] = ACTIONS(4933),
    [sym_for] = ACTIONS(4933),
    [sym_foreach] = ACTIONS(4933),
    [sym_foreach_reverse] = ACTIONS(4933),
    [sym_function] = ACTIONS(4933),
    [sym_goto] = ACTIONS(4933),
    [sym_if] = ACTIONS(4933),
    [sym_immutable] = ACTIONS(4933),
    [sym_import] = ACTIONS(4933),
    [sym_in] = ACTIONS(4933),
    [sym_inout] = ACTIONS(4933),
    [sym_interface] = ACTIONS(4933),
    [sym_invariant] = ACTIONS(4933),
    [sym_is] = ACTIONS(4933),
    [sym_mixin] = ACTIONS(4933),
    [sym_new] = ACTIONS(4933),
    [sym_nothrow] = ACTIONS(4933),
    [sym_out] = ACTIONS(4933),
    [sym_override] = ACTIONS(4933),
    [sym_package] = ACTIONS(4933),
    [sym_pragma] = ACTIONS(4933),
    [sym_private] = ACTIONS(4933),
    [sym_protected] = ACTIONS(4933),
    [sym_public] = ACTIONS(4933),
    [sym_pure] = ACTIONS(4933),
    [sym_ref] = ACTIONS(4933),
    [sym_return] = ACTIONS(4933),
    [sym_scope] = ACTIONS(4933),
    [sym_shared] = ACTIONS(4933),
    [sym_static] = ACTIONS(4933),
    [sym_struct] = ACTIONS(4933),
    [sym_switch] = ACTIONS(4933),
    [sym_synchronized] = ACTIONS(4933),
    [sym_template] = ACTIONS(4933),
    [sym_throw] = ACTIONS(4933),
    [sym_try] = ACTIONS(4933),
    [sym_typeid] = ACTIONS(4933),
    [sym_typeof] = ACTIONS(4933),
    [sym_union] = ACTIONS(4933),
    [sym_unittest] = ACTIONS(4933),
    [sym_version] = ACTIONS(4933),
    [sym_while] = ACTIONS(4933),
    [sym_with] = ACTIONS(4933),
    [sym_gshared] = ACTIONS(4933),
    [sym_traits] = ACTIONS(4933),
    [sym_vector] = ACTIONS(4933),
    [sym_void] = ACTIONS(4933),
    [anon_sym_BQUOTE] = ACTIONS(4935),
    [anon_sym_r_DQUOTE] = ACTIONS(4935),
    [anon_sym_x_DQUOTE] = ACTIONS(4935),
    [anon_sym_DQUOTE] = ACTIONS(4935),
    [anon_sym_i_BQUOTE] = ACTIONS(4935),
    [anon_sym_i_DQUOTE] = ACTIONS(4935),
    [anon_sym_iq_LBRACE] = ACTIONS(4935),
    [aux_sym_char_literal_token1] = ACTIONS(4935),
    [anon_sym_SQUOTE] = ACTIONS(4933),
    [anon_sym___DATE__] = ACTIONS(4933),
    [anon_sym___FILE__] = ACTIONS(4933),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4933),
    [anon_sym___FUNCTION__] = ACTIONS(4933),
    [anon_sym___LINE__] = ACTIONS(4933),
    [anon_sym___MODULE__] = ACTIONS(4933),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4933),
    [anon_sym___TIME__] = ACTIONS(4933),
    [anon_sym___TIMESTAMP__] = ACTIONS(4933),
    [anon_sym___VENDOR__] = ACTIONS(4933),
    [anon_sym___VERSION__] = ACTIONS(4933),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4935),
    [sym_float_literal] = ACTIONS(4935),
    [sym__string] = ACTIONS(4935),
  },
  [1666] = {
    [sym_identifier] = ACTIONS(4330),
    [anon_sym_q_LBRACE] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_DOT] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [anon_sym_RPAREN] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_DOLLAR] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_AT] = ACTIONS(4332),
    [sym_bool] = ACTIONS(4330),
    [sym_byte] = ACTIONS(4330),
    [sym_ubyte] = ACTIONS(4330),
    [sym_char] = ACTIONS(4330),
    [sym_short] = ACTIONS(4330),
    [sym_ushort] = ACTIONS(4330),
    [sym_int] = ACTIONS(4330),
    [sym_uint] = ACTIONS(4330),
    [sym_long] = ACTIONS(4330),
    [sym_ulong] = ACTIONS(4330),
    [sym_cent] = ACTIONS(4330),
    [sym_ucent] = ACTIONS(4330),
    [sym_wchar] = ACTIONS(4330),
    [sym_dchar] = ACTIONS(4330),
    [sym_float] = ACTIONS(4330),
    [sym_double] = ACTIONS(4330),
    [sym_real] = ACTIONS(4330),
    [sym_ifloat] = ACTIONS(4330),
    [sym_idouble] = ACTIONS(4330),
    [sym_ireal] = ACTIONS(4330),
    [sym_cfloat] = ACTIONS(4330),
    [sym_cdouble] = ACTIONS(4330),
    [sym_creal] = ACTIONS(4330),
    [sym_size_t] = ACTIONS(4330),
    [sym_ptrdiff_t] = ACTIONS(4330),
    [sym_string] = ACTIONS(4330),
    [sym_cstring] = ACTIONS(4330),
    [sym_dstring] = ACTIONS(4330),
    [sym_wstring] = ACTIONS(4330),
    [sym_noreturn] = ACTIONS(4330),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_super] = ACTIONS(4330),
    [sym_this] = ACTIONS(4330),
    [sym_abstract] = ACTIONS(4330),
    [sym_alias] = ACTIONS(4330),
    [sym_align] = ACTIONS(4330),
    [sym_asm] = ACTIONS(4330),
    [sym_assert] = ACTIONS(4330),
    [sym_auto] = ACTIONS(4330),
    [sym_break] = ACTIONS(4330),
    [sym_case] = ACTIONS(4330),
    [sym_cast] = ACTIONS(4330),
    [sym_class] = ACTIONS(4330),
    [sym_const] = ACTIONS(4330),
    [sym_continue] = ACTIONS(4330),
    [sym_debug] = ACTIONS(4330),
    [sym_default] = ACTIONS(4330),
    [sym_delegate] = ACTIONS(4330),
    [sym_delete] = ACTIONS(4330),
    [sym_deprecated] = ACTIONS(4330),
    [sym_do] = ACTIONS(4330),
    [sym_else] = ACTIONS(4330),
    [sym_enum] = ACTIONS(4330),
    [sym_export] = ACTIONS(4330),
    [sym_extern] = ACTIONS(4330),
    [sym_final] = ACTIONS(4330),
    [sym_for] = ACTIONS(4330),
    [sym_foreach] = ACTIONS(4330),
    [sym_foreach_reverse] = ACTIONS(4330),
    [sym_function] = ACTIONS(4330),
    [sym_goto] = ACTIONS(4330),
    [sym_if] = ACTIONS(4330),
    [sym_immutable] = ACTIONS(4330),
    [sym_import] = ACTIONS(4330),
    [sym_in] = ACTIONS(4330),
    [sym_inout] = ACTIONS(4330),
    [sym_interface] = ACTIONS(4330),
    [sym_invariant] = ACTIONS(4330),
    [sym_is] = ACTIONS(4330),
    [sym_mixin] = ACTIONS(4330),
    [sym_new] = ACTIONS(4330),
    [sym_nothrow] = ACTIONS(4330),
    [sym_out] = ACTIONS(4330),
    [sym_override] = ACTIONS(4330),
    [sym_package] = ACTIONS(4330),
    [sym_pragma] = ACTIONS(4330),
    [sym_private] = ACTIONS(4330),
    [sym_protected] = ACTIONS(4330),
    [sym_public] = ACTIONS(4330),
    [sym_pure] = ACTIONS(4330),
    [sym_ref] = ACTIONS(4330),
    [sym_return] = ACTIONS(4330),
    [sym_scope] = ACTIONS(4330),
    [sym_shared] = ACTIONS(4330),
    [sym_static] = ACTIONS(4330),
    [sym_struct] = ACTIONS(4330),
    [sym_switch] = ACTIONS(4330),
    [sym_synchronized] = ACTIONS(4330),
    [sym_template] = ACTIONS(4330),
    [sym_throw] = ACTIONS(4330),
    [sym_try] = ACTIONS(4330),
    [sym_typeid] = ACTIONS(4330),
    [sym_typeof] = ACTIONS(4330),
    [sym_union] = ACTIONS(4330),
    [sym_unittest] = ACTIONS(4330),
    [sym_version] = ACTIONS(4330),
    [sym_while] = ACTIONS(4330),
    [sym_with] = ACTIONS(4330),
    [sym_gshared] = ACTIONS(4330),
    [sym_traits] = ACTIONS(4330),
    [sym_vector] = ACTIONS(4330),
    [sym_void] = ACTIONS(4330),
    [anon_sym_BQUOTE] = ACTIONS(4332),
    [anon_sym_r_DQUOTE] = ACTIONS(4332),
    [anon_sym_x_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4332),
    [anon_sym_i_BQUOTE] = ACTIONS(4332),
    [anon_sym_i_DQUOTE] = ACTIONS(4332),
    [anon_sym_iq_LBRACE] = ACTIONS(4332),
    [aux_sym_char_literal_token1] = ACTIONS(4332),
    [anon_sym_SQUOTE] = ACTIONS(4330),
    [anon_sym___DATE__] = ACTIONS(4330),
    [anon_sym___FILE__] = ACTIONS(4330),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4330),
    [anon_sym___FUNCTION__] = ACTIONS(4330),
    [anon_sym___LINE__] = ACTIONS(4330),
    [anon_sym___MODULE__] = ACTIONS(4330),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4330),
    [anon_sym___TIME__] = ACTIONS(4330),
    [anon_sym___TIMESTAMP__] = ACTIONS(4330),
    [anon_sym___VENDOR__] = ACTIONS(4330),
    [anon_sym___VERSION__] = ACTIONS(4330),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4332),
    [sym_float_literal] = ACTIONS(4332),
    [sym__string] = ACTIONS(4332),
  },
  [1667] = {
    [sym_identifier] = ACTIONS(4574),
    [anon_sym_q_LBRACE] = ACTIONS(4576),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_LBRACE] = ACTIONS(4576),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4574),
    [anon_sym_DASH_DASH] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(4574),
    [anon_sym_PLUS_PLUS] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_LPAREN] = ACTIONS(4576),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [anon_sym_AT] = ACTIONS(4576),
    [sym_bool] = ACTIONS(4574),
    [sym_byte] = ACTIONS(4574),
    [sym_ubyte] = ACTIONS(4574),
    [sym_char] = ACTIONS(4574),
    [sym_short] = ACTIONS(4574),
    [sym_ushort] = ACTIONS(4574),
    [sym_int] = ACTIONS(4574),
    [sym_uint] = ACTIONS(4574),
    [sym_long] = ACTIONS(4574),
    [sym_ulong] = ACTIONS(4574),
    [sym_cent] = ACTIONS(4574),
    [sym_ucent] = ACTIONS(4574),
    [sym_wchar] = ACTIONS(4574),
    [sym_dchar] = ACTIONS(4574),
    [sym_float] = ACTIONS(4574),
    [sym_double] = ACTIONS(4574),
    [sym_real] = ACTIONS(4574),
    [sym_ifloat] = ACTIONS(4574),
    [sym_idouble] = ACTIONS(4574),
    [sym_ireal] = ACTIONS(4574),
    [sym_cfloat] = ACTIONS(4574),
    [sym_cdouble] = ACTIONS(4574),
    [sym_creal] = ACTIONS(4574),
    [sym_size_t] = ACTIONS(4574),
    [sym_ptrdiff_t] = ACTIONS(4574),
    [sym_string] = ACTIONS(4574),
    [sym_cstring] = ACTIONS(4574),
    [sym_dstring] = ACTIONS(4574),
    [sym_wstring] = ACTIONS(4574),
    [sym_noreturn] = ACTIONS(4574),
    [sym_true] = ACTIONS(4574),
    [sym_false] = ACTIONS(4574),
    [sym_null] = ACTIONS(4574),
    [sym_super] = ACTIONS(4574),
    [sym_this] = ACTIONS(4574),
    [sym_abstract] = ACTIONS(4574),
    [sym_alias] = ACTIONS(4574),
    [sym_align] = ACTIONS(4574),
    [sym_asm] = ACTIONS(4574),
    [sym_assert] = ACTIONS(4574),
    [sym_auto] = ACTIONS(4574),
    [sym_break] = ACTIONS(4574),
    [sym_case] = ACTIONS(4574),
    [sym_cast] = ACTIONS(4574),
    [sym_class] = ACTIONS(4574),
    [sym_const] = ACTIONS(4574),
    [sym_continue] = ACTIONS(4574),
    [sym_debug] = ACTIONS(4574),
    [sym_default] = ACTIONS(4574),
    [sym_delegate] = ACTIONS(4574),
    [sym_delete] = ACTIONS(4574),
    [sym_deprecated] = ACTIONS(4574),
    [sym_do] = ACTIONS(4574),
    [sym_else] = ACTIONS(4574),
    [sym_enum] = ACTIONS(4574),
    [sym_export] = ACTIONS(4574),
    [sym_extern] = ACTIONS(4574),
    [sym_final] = ACTIONS(4574),
    [sym_for] = ACTIONS(4574),
    [sym_foreach] = ACTIONS(4574),
    [sym_foreach_reverse] = ACTIONS(4574),
    [sym_function] = ACTIONS(4574),
    [sym_goto] = ACTIONS(4574),
    [sym_if] = ACTIONS(4574),
    [sym_immutable] = ACTIONS(4574),
    [sym_import] = ACTIONS(4574),
    [sym_in] = ACTIONS(4574),
    [sym_inout] = ACTIONS(4574),
    [sym_interface] = ACTIONS(4574),
    [sym_invariant] = ACTIONS(4574),
    [sym_is] = ACTIONS(4574),
    [sym_mixin] = ACTIONS(4574),
    [sym_new] = ACTIONS(4574),
    [sym_nothrow] = ACTIONS(4574),
    [sym_out] = ACTIONS(4574),
    [sym_override] = ACTIONS(4574),
    [sym_package] = ACTIONS(4574),
    [sym_pragma] = ACTIONS(4574),
    [sym_private] = ACTIONS(4574),
    [sym_protected] = ACTIONS(4574),
    [sym_public] = ACTIONS(4574),
    [sym_pure] = ACTIONS(4574),
    [sym_ref] = ACTIONS(4574),
    [sym_return] = ACTIONS(4574),
    [sym_scope] = ACTIONS(4574),
    [sym_shared] = ACTIONS(4574),
    [sym_static] = ACTIONS(4574),
    [sym_struct] = ACTIONS(4574),
    [sym_switch] = ACTIONS(4574),
    [sym_synchronized] = ACTIONS(4574),
    [sym_template] = ACTIONS(4574),
    [sym_throw] = ACTIONS(4574),
    [sym_try] = ACTIONS(4574),
    [sym_typeid] = ACTIONS(4574),
    [sym_typeof] = ACTIONS(4574),
    [sym_union] = ACTIONS(4574),
    [sym_unittest] = ACTIONS(4574),
    [sym_version] = ACTIONS(4574),
    [sym_while] = ACTIONS(4574),
    [sym_with] = ACTIONS(4574),
    [sym_gshared] = ACTIONS(4574),
    [sym_traits] = ACTIONS(4574),
    [sym_vector] = ACTIONS(4574),
    [sym_void] = ACTIONS(4574),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_r_DQUOTE] = ACTIONS(4576),
    [anon_sym_x_DQUOTE] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_i_BQUOTE] = ACTIONS(4576),
    [anon_sym_i_DQUOTE] = ACTIONS(4576),
    [anon_sym_iq_LBRACE] = ACTIONS(4576),
    [aux_sym_char_literal_token1] = ACTIONS(4576),
    [anon_sym_SQUOTE] = ACTIONS(4574),
    [anon_sym___DATE__] = ACTIONS(4574),
    [anon_sym___FILE__] = ACTIONS(4574),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4574),
    [anon_sym___FUNCTION__] = ACTIONS(4574),
    [anon_sym___LINE__] = ACTIONS(4574),
    [anon_sym___MODULE__] = ACTIONS(4574),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4574),
    [anon_sym___TIME__] = ACTIONS(4574),
    [anon_sym___TIMESTAMP__] = ACTIONS(4574),
    [anon_sym___VENDOR__] = ACTIONS(4574),
    [anon_sym___VERSION__] = ACTIONS(4574),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4576),
    [sym_float_literal] = ACTIONS(4576),
    [sym__string] = ACTIONS(4576),
  },
  [1668] = {
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_q_LBRACE] = ACTIONS(4628),
    [anon_sym_RBRACE] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(4628),
    [anon_sym_DOT] = ACTIONS(4628),
    [anon_sym_AMP] = ACTIONS(4628),
    [anon_sym_DASH] = ACTIONS(4626),
    [anon_sym_DASH_DASH] = ACTIONS(4628),
    [anon_sym_PLUS] = ACTIONS(4626),
    [anon_sym_PLUS_PLUS] = ACTIONS(4628),
    [anon_sym_BANG] = ACTIONS(4628),
    [anon_sym_LPAREN] = ACTIONS(4628),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_LBRACK] = ACTIONS(4628),
    [anon_sym_SEMI] = ACTIONS(4628),
    [anon_sym_DOLLAR] = ACTIONS(4628),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_TILDE] = ACTIONS(4628),
    [anon_sym_AT] = ACTIONS(4628),
    [sym_bool] = ACTIONS(4626),
    [sym_byte] = ACTIONS(4626),
    [sym_ubyte] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_short] = ACTIONS(4626),
    [sym_ushort] = ACTIONS(4626),
    [sym_int] = ACTIONS(4626),
    [sym_uint] = ACTIONS(4626),
    [sym_long] = ACTIONS(4626),
    [sym_ulong] = ACTIONS(4626),
    [sym_cent] = ACTIONS(4626),
    [sym_ucent] = ACTIONS(4626),
    [sym_wchar] = ACTIONS(4626),
    [sym_dchar] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_double] = ACTIONS(4626),
    [sym_real] = ACTIONS(4626),
    [sym_ifloat] = ACTIONS(4626),
    [sym_idouble] = ACTIONS(4626),
    [sym_ireal] = ACTIONS(4626),
    [sym_cfloat] = ACTIONS(4626),
    [sym_cdouble] = ACTIONS(4626),
    [sym_creal] = ACTIONS(4626),
    [sym_size_t] = ACTIONS(4626),
    [sym_ptrdiff_t] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym_cstring] = ACTIONS(4626),
    [sym_dstring] = ACTIONS(4626),
    [sym_wstring] = ACTIONS(4626),
    [sym_noreturn] = ACTIONS(4626),
    [sym_true] = ACTIONS(4626),
    [sym_false] = ACTIONS(4626),
    [sym_null] = ACTIONS(4626),
    [sym_super] = ACTIONS(4626),
    [sym_this] = ACTIONS(4626),
    [sym_abstract] = ACTIONS(4626),
    [sym_alias] = ACTIONS(4626),
    [sym_align] = ACTIONS(4626),
    [sym_asm] = ACTIONS(4626),
    [sym_assert] = ACTIONS(4626),
    [sym_auto] = ACTIONS(4626),
    [sym_break] = ACTIONS(4626),
    [sym_case] = ACTIONS(4626),
    [sym_cast] = ACTIONS(4626),
    [sym_class] = ACTIONS(4626),
    [sym_const] = ACTIONS(4626),
    [sym_continue] = ACTIONS(4626),
    [sym_debug] = ACTIONS(4626),
    [sym_default] = ACTIONS(4626),
    [sym_delegate] = ACTIONS(4626),
    [sym_delete] = ACTIONS(4626),
    [sym_deprecated] = ACTIONS(4626),
    [sym_do] = ACTIONS(4626),
    [sym_else] = ACTIONS(4626),
    [sym_enum] = ACTIONS(4626),
    [sym_export] = ACTIONS(4626),
    [sym_extern] = ACTIONS(4626),
    [sym_final] = ACTIONS(4626),
    [sym_for] = ACTIONS(4626),
    [sym_foreach] = ACTIONS(4626),
    [sym_foreach_reverse] = ACTIONS(4626),
    [sym_function] = ACTIONS(4626),
    [sym_goto] = ACTIONS(4626),
    [sym_if] = ACTIONS(4626),
    [sym_immutable] = ACTIONS(4626),
    [sym_import] = ACTIONS(4626),
    [sym_in] = ACTIONS(4626),
    [sym_inout] = ACTIONS(4626),
    [sym_interface] = ACTIONS(4626),
    [sym_invariant] = ACTIONS(4626),
    [sym_is] = ACTIONS(4626),
    [sym_mixin] = ACTIONS(4626),
    [sym_new] = ACTIONS(4626),
    [sym_nothrow] = ACTIONS(4626),
    [sym_out] = ACTIONS(4626),
    [sym_override] = ACTIONS(4626),
    [sym_package] = ACTIONS(4626),
    [sym_pragma] = ACTIONS(4626),
    [sym_private] = ACTIONS(4626),
    [sym_protected] = ACTIONS(4626),
    [sym_public] = ACTIONS(4626),
    [sym_pure] = ACTIONS(4626),
    [sym_ref] = ACTIONS(4626),
    [sym_return] = ACTIONS(4626),
    [sym_scope] = ACTIONS(4626),
    [sym_shared] = ACTIONS(4626),
    [sym_static] = ACTIONS(4626),
    [sym_struct] = ACTIONS(4626),
    [sym_switch] = ACTIONS(4626),
    [sym_synchronized] = ACTIONS(4626),
    [sym_template] = ACTIONS(4626),
    [sym_throw] = ACTIONS(4626),
    [sym_try] = ACTIONS(4626),
    [sym_typeid] = ACTIONS(4626),
    [sym_typeof] = ACTIONS(4626),
    [sym_union] = ACTIONS(4626),
    [sym_unittest] = ACTIONS(4626),
    [sym_version] = ACTIONS(4626),
    [sym_while] = ACTIONS(4626),
    [sym_with] = ACTIONS(4626),
    [sym_gshared] = ACTIONS(4626),
    [sym_traits] = ACTIONS(4626),
    [sym_vector] = ACTIONS(4626),
    [sym_void] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4628),
    [anon_sym_r_DQUOTE] = ACTIONS(4628),
    [anon_sym_x_DQUOTE] = ACTIONS(4628),
    [anon_sym_DQUOTE] = ACTIONS(4628),
    [anon_sym_i_BQUOTE] = ACTIONS(4628),
    [anon_sym_i_DQUOTE] = ACTIONS(4628),
    [anon_sym_iq_LBRACE] = ACTIONS(4628),
    [aux_sym_char_literal_token1] = ACTIONS(4628),
    [anon_sym_SQUOTE] = ACTIONS(4626),
    [anon_sym___DATE__] = ACTIONS(4626),
    [anon_sym___FILE__] = ACTIONS(4626),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4626),
    [anon_sym___FUNCTION__] = ACTIONS(4626),
    [anon_sym___LINE__] = ACTIONS(4626),
    [anon_sym___MODULE__] = ACTIONS(4626),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4626),
    [anon_sym___TIME__] = ACTIONS(4626),
    [anon_sym___TIMESTAMP__] = ACTIONS(4626),
    [anon_sym___VENDOR__] = ACTIONS(4626),
    [anon_sym___VERSION__] = ACTIONS(4626),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4628),
    [sym_float_literal] = ACTIONS(4628),
    [sym__string] = ACTIONS(4628),
  },
  [1669] = {
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_q_LBRACE] = ACTIONS(4620),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4620),
    [anon_sym_AMP] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_BANG] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_DOLLAR] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_TILDE] = ACTIONS(4620),
    [anon_sym_AT] = ACTIONS(4620),
    [sym_bool] = ACTIONS(4618),
    [sym_byte] = ACTIONS(4618),
    [sym_ubyte] = ACTIONS(4618),
    [sym_char] = ACTIONS(4618),
    [sym_short] = ACTIONS(4618),
    [sym_ushort] = ACTIONS(4618),
    [sym_int] = ACTIONS(4618),
    [sym_uint] = ACTIONS(4618),
    [sym_long] = ACTIONS(4618),
    [sym_ulong] = ACTIONS(4618),
    [sym_cent] = ACTIONS(4618),
    [sym_ucent] = ACTIONS(4618),
    [sym_wchar] = ACTIONS(4618),
    [sym_dchar] = ACTIONS(4618),
    [sym_float] = ACTIONS(4618),
    [sym_double] = ACTIONS(4618),
    [sym_real] = ACTIONS(4618),
    [sym_ifloat] = ACTIONS(4618),
    [sym_idouble] = ACTIONS(4618),
    [sym_ireal] = ACTIONS(4618),
    [sym_cfloat] = ACTIONS(4618),
    [sym_cdouble] = ACTIONS(4618),
    [sym_creal] = ACTIONS(4618),
    [sym_size_t] = ACTIONS(4618),
    [sym_ptrdiff_t] = ACTIONS(4618),
    [sym_string] = ACTIONS(4618),
    [sym_cstring] = ACTIONS(4618),
    [sym_dstring] = ACTIONS(4618),
    [sym_wstring] = ACTIONS(4618),
    [sym_noreturn] = ACTIONS(4618),
    [sym_true] = ACTIONS(4618),
    [sym_false] = ACTIONS(4618),
    [sym_null] = ACTIONS(4618),
    [sym_super] = ACTIONS(4618),
    [sym_this] = ACTIONS(4618),
    [sym_abstract] = ACTIONS(4618),
    [sym_alias] = ACTIONS(4618),
    [sym_align] = ACTIONS(4618),
    [sym_asm] = ACTIONS(4618),
    [sym_assert] = ACTIONS(4618),
    [sym_auto] = ACTIONS(4618),
    [sym_break] = ACTIONS(4618),
    [sym_case] = ACTIONS(4618),
    [sym_cast] = ACTIONS(4618),
    [sym_class] = ACTIONS(4618),
    [sym_const] = ACTIONS(4618),
    [sym_continue] = ACTIONS(4618),
    [sym_debug] = ACTIONS(4618),
    [sym_default] = ACTIONS(4618),
    [sym_delegate] = ACTIONS(4618),
    [sym_delete] = ACTIONS(4618),
    [sym_deprecated] = ACTIONS(4618),
    [sym_do] = ACTIONS(4618),
    [sym_else] = ACTIONS(4618),
    [sym_enum] = ACTIONS(4618),
    [sym_export] = ACTIONS(4618),
    [sym_extern] = ACTIONS(4618),
    [sym_final] = ACTIONS(4618),
    [sym_for] = ACTIONS(4618),
    [sym_foreach] = ACTIONS(4618),
    [sym_foreach_reverse] = ACTIONS(4618),
    [sym_function] = ACTIONS(4618),
    [sym_goto] = ACTIONS(4618),
    [sym_if] = ACTIONS(4618),
    [sym_immutable] = ACTIONS(4618),
    [sym_import] = ACTIONS(4618),
    [sym_in] = ACTIONS(4618),
    [sym_inout] = ACTIONS(4618),
    [sym_interface] = ACTIONS(4618),
    [sym_invariant] = ACTIONS(4618),
    [sym_is] = ACTIONS(4618),
    [sym_mixin] = ACTIONS(4618),
    [sym_new] = ACTIONS(4618),
    [sym_nothrow] = ACTIONS(4618),
    [sym_out] = ACTIONS(4618),
    [sym_override] = ACTIONS(4618),
    [sym_package] = ACTIONS(4618),
    [sym_pragma] = ACTIONS(4618),
    [sym_private] = ACTIONS(4618),
    [sym_protected] = ACTIONS(4618),
    [sym_public] = ACTIONS(4618),
    [sym_pure] = ACTIONS(4618),
    [sym_ref] = ACTIONS(4618),
    [sym_return] = ACTIONS(4618),
    [sym_scope] = ACTIONS(4618),
    [sym_shared] = ACTIONS(4618),
    [sym_static] = ACTIONS(4618),
    [sym_struct] = ACTIONS(4618),
    [sym_switch] = ACTIONS(4618),
    [sym_synchronized] = ACTIONS(4618),
    [sym_template] = ACTIONS(4618),
    [sym_throw] = ACTIONS(4618),
    [sym_try] = ACTIONS(4618),
    [sym_typeid] = ACTIONS(4618),
    [sym_typeof] = ACTIONS(4618),
    [sym_union] = ACTIONS(4618),
    [sym_unittest] = ACTIONS(4618),
    [sym_version] = ACTIONS(4618),
    [sym_while] = ACTIONS(4618),
    [sym_with] = ACTIONS(4618),
    [sym_gshared] = ACTIONS(4618),
    [sym_traits] = ACTIONS(4618),
    [sym_vector] = ACTIONS(4618),
    [sym_void] = ACTIONS(4618),
    [anon_sym_BQUOTE] = ACTIONS(4620),
    [anon_sym_r_DQUOTE] = ACTIONS(4620),
    [anon_sym_x_DQUOTE] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [anon_sym_i_BQUOTE] = ACTIONS(4620),
    [anon_sym_i_DQUOTE] = ACTIONS(4620),
    [anon_sym_iq_LBRACE] = ACTIONS(4620),
    [aux_sym_char_literal_token1] = ACTIONS(4620),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym___DATE__] = ACTIONS(4618),
    [anon_sym___FILE__] = ACTIONS(4618),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4618),
    [anon_sym___FUNCTION__] = ACTIONS(4618),
    [anon_sym___LINE__] = ACTIONS(4618),
    [anon_sym___MODULE__] = ACTIONS(4618),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4618),
    [anon_sym___TIME__] = ACTIONS(4618),
    [anon_sym___TIMESTAMP__] = ACTIONS(4618),
    [anon_sym___VENDOR__] = ACTIONS(4618),
    [anon_sym___VERSION__] = ACTIONS(4618),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4620),
    [sym_float_literal] = ACTIONS(4620),
    [sym__string] = ACTIONS(4620),
  },
  [1670] = {
    [sym_identifier] = ACTIONS(4614),
    [anon_sym_q_LBRACE] = ACTIONS(4616),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_LBRACE] = ACTIONS(4616),
    [anon_sym_DOT] = ACTIONS(4616),
    [anon_sym_AMP] = ACTIONS(4616),
    [anon_sym_DASH] = ACTIONS(4614),
    [anon_sym_DASH_DASH] = ACTIONS(4616),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_PLUS_PLUS] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4616),
    [anon_sym_LPAREN] = ACTIONS(4616),
    [anon_sym_RPAREN] = ACTIONS(4616),
    [anon_sym_LBRACK] = ACTIONS(4616),
    [anon_sym_SEMI] = ACTIONS(4616),
    [anon_sym_DOLLAR] = ACTIONS(4616),
    [anon_sym_STAR] = ACTIONS(4616),
    [anon_sym_TILDE] = ACTIONS(4616),
    [anon_sym_AT] = ACTIONS(4616),
    [sym_bool] = ACTIONS(4614),
    [sym_byte] = ACTIONS(4614),
    [sym_ubyte] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_short] = ACTIONS(4614),
    [sym_ushort] = ACTIONS(4614),
    [sym_int] = ACTIONS(4614),
    [sym_uint] = ACTIONS(4614),
    [sym_long] = ACTIONS(4614),
    [sym_ulong] = ACTIONS(4614),
    [sym_cent] = ACTIONS(4614),
    [sym_ucent] = ACTIONS(4614),
    [sym_wchar] = ACTIONS(4614),
    [sym_dchar] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_double] = ACTIONS(4614),
    [sym_real] = ACTIONS(4614),
    [sym_ifloat] = ACTIONS(4614),
    [sym_idouble] = ACTIONS(4614),
    [sym_ireal] = ACTIONS(4614),
    [sym_cfloat] = ACTIONS(4614),
    [sym_cdouble] = ACTIONS(4614),
    [sym_creal] = ACTIONS(4614),
    [sym_size_t] = ACTIONS(4614),
    [sym_ptrdiff_t] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym_cstring] = ACTIONS(4614),
    [sym_dstring] = ACTIONS(4614),
    [sym_wstring] = ACTIONS(4614),
    [sym_noreturn] = ACTIONS(4614),
    [sym_true] = ACTIONS(4614),
    [sym_false] = ACTIONS(4614),
    [sym_null] = ACTIONS(4614),
    [sym_super] = ACTIONS(4614),
    [sym_this] = ACTIONS(4614),
    [sym_abstract] = ACTIONS(4614),
    [sym_alias] = ACTIONS(4614),
    [sym_align] = ACTIONS(4614),
    [sym_asm] = ACTIONS(4614),
    [sym_assert] = ACTIONS(4614),
    [sym_auto] = ACTIONS(4614),
    [sym_break] = ACTIONS(4614),
    [sym_case] = ACTIONS(4614),
    [sym_cast] = ACTIONS(4614),
    [sym_class] = ACTIONS(4614),
    [sym_const] = ACTIONS(4614),
    [sym_continue] = ACTIONS(4614),
    [sym_debug] = ACTIONS(4614),
    [sym_default] = ACTIONS(4614),
    [sym_delegate] = ACTIONS(4614),
    [sym_delete] = ACTIONS(4614),
    [sym_deprecated] = ACTIONS(4614),
    [sym_do] = ACTIONS(4614),
    [sym_else] = ACTIONS(4614),
    [sym_enum] = ACTIONS(4614),
    [sym_export] = ACTIONS(4614),
    [sym_extern] = ACTIONS(4614),
    [sym_final] = ACTIONS(4614),
    [sym_for] = ACTIONS(4614),
    [sym_foreach] = ACTIONS(4614),
    [sym_foreach_reverse] = ACTIONS(4614),
    [sym_function] = ACTIONS(4614),
    [sym_goto] = ACTIONS(4614),
    [sym_if] = ACTIONS(4614),
    [sym_immutable] = ACTIONS(4614),
    [sym_import] = ACTIONS(4614),
    [sym_in] = ACTIONS(4614),
    [sym_inout] = ACTIONS(4614),
    [sym_interface] = ACTIONS(4614),
    [sym_invariant] = ACTIONS(4614),
    [sym_is] = ACTIONS(4614),
    [sym_mixin] = ACTIONS(4614),
    [sym_new] = ACTIONS(4614),
    [sym_nothrow] = ACTIONS(4614),
    [sym_out] = ACTIONS(4614),
    [sym_override] = ACTIONS(4614),
    [sym_package] = ACTIONS(4614),
    [sym_pragma] = ACTIONS(4614),
    [sym_private] = ACTIONS(4614),
    [sym_protected] = ACTIONS(4614),
    [sym_public] = ACTIONS(4614),
    [sym_pure] = ACTIONS(4614),
    [sym_ref] = ACTIONS(4614),
    [sym_return] = ACTIONS(4614),
    [sym_scope] = ACTIONS(4614),
    [sym_shared] = ACTIONS(4614),
    [sym_static] = ACTIONS(4614),
    [sym_struct] = ACTIONS(4614),
    [sym_switch] = ACTIONS(4614),
    [sym_synchronized] = ACTIONS(4614),
    [sym_template] = ACTIONS(4614),
    [sym_throw] = ACTIONS(4614),
    [sym_try] = ACTIONS(4614),
    [sym_typeid] = ACTIONS(4614),
    [sym_typeof] = ACTIONS(4614),
    [sym_union] = ACTIONS(4614),
    [sym_unittest] = ACTIONS(4614),
    [sym_version] = ACTIONS(4614),
    [sym_while] = ACTIONS(4614),
    [sym_with] = ACTIONS(4614),
    [sym_gshared] = ACTIONS(4614),
    [sym_traits] = ACTIONS(4614),
    [sym_vector] = ACTIONS(4614),
    [sym_void] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4616),
    [anon_sym_r_DQUOTE] = ACTIONS(4616),
    [anon_sym_x_DQUOTE] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(4616),
    [anon_sym_i_BQUOTE] = ACTIONS(4616),
    [anon_sym_i_DQUOTE] = ACTIONS(4616),
    [anon_sym_iq_LBRACE] = ACTIONS(4616),
    [aux_sym_char_literal_token1] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4614),
    [anon_sym___DATE__] = ACTIONS(4614),
    [anon_sym___FILE__] = ACTIONS(4614),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4614),
    [anon_sym___FUNCTION__] = ACTIONS(4614),
    [anon_sym___LINE__] = ACTIONS(4614),
    [anon_sym___MODULE__] = ACTIONS(4614),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4614),
    [anon_sym___TIME__] = ACTIONS(4614),
    [anon_sym___TIMESTAMP__] = ACTIONS(4614),
    [anon_sym___VENDOR__] = ACTIONS(4614),
    [anon_sym___VERSION__] = ACTIONS(4614),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4616),
    [sym_float_literal] = ACTIONS(4616),
    [sym__string] = ACTIONS(4616),
  },
  [1671] = {
    [sym_identifier] = ACTIONS(4602),
    [anon_sym_q_LBRACE] = ACTIONS(4604),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4604),
    [anon_sym_AMP] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_BANG] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_DOLLAR] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4604),
    [anon_sym_AT] = ACTIONS(4604),
    [sym_bool] = ACTIONS(4602),
    [sym_byte] = ACTIONS(4602),
    [sym_ubyte] = ACTIONS(4602),
    [sym_char] = ACTIONS(4602),
    [sym_short] = ACTIONS(4602),
    [sym_ushort] = ACTIONS(4602),
    [sym_int] = ACTIONS(4602),
    [sym_uint] = ACTIONS(4602),
    [sym_long] = ACTIONS(4602),
    [sym_ulong] = ACTIONS(4602),
    [sym_cent] = ACTIONS(4602),
    [sym_ucent] = ACTIONS(4602),
    [sym_wchar] = ACTIONS(4602),
    [sym_dchar] = ACTIONS(4602),
    [sym_float] = ACTIONS(4602),
    [sym_double] = ACTIONS(4602),
    [sym_real] = ACTIONS(4602),
    [sym_ifloat] = ACTIONS(4602),
    [sym_idouble] = ACTIONS(4602),
    [sym_ireal] = ACTIONS(4602),
    [sym_cfloat] = ACTIONS(4602),
    [sym_cdouble] = ACTIONS(4602),
    [sym_creal] = ACTIONS(4602),
    [sym_size_t] = ACTIONS(4602),
    [sym_ptrdiff_t] = ACTIONS(4602),
    [sym_string] = ACTIONS(4602),
    [sym_cstring] = ACTIONS(4602),
    [sym_dstring] = ACTIONS(4602),
    [sym_wstring] = ACTIONS(4602),
    [sym_noreturn] = ACTIONS(4602),
    [sym_true] = ACTIONS(4602),
    [sym_false] = ACTIONS(4602),
    [sym_null] = ACTIONS(4602),
    [sym_super] = ACTIONS(4602),
    [sym_this] = ACTIONS(4602),
    [sym_abstract] = ACTIONS(4602),
    [sym_alias] = ACTIONS(4602),
    [sym_align] = ACTIONS(4602),
    [sym_asm] = ACTIONS(4602),
    [sym_assert] = ACTIONS(4602),
    [sym_auto] = ACTIONS(4602),
    [sym_break] = ACTIONS(4602),
    [sym_case] = ACTIONS(4602),
    [sym_cast] = ACTIONS(4602),
    [sym_class] = ACTIONS(4602),
    [sym_const] = ACTIONS(4602),
    [sym_continue] = ACTIONS(4602),
    [sym_debug] = ACTIONS(4602),
    [sym_default] = ACTIONS(4602),
    [sym_delegate] = ACTIONS(4602),
    [sym_delete] = ACTIONS(4602),
    [sym_deprecated] = ACTIONS(4602),
    [sym_do] = ACTIONS(4602),
    [sym_else] = ACTIONS(4602),
    [sym_enum] = ACTIONS(4602),
    [sym_export] = ACTIONS(4602),
    [sym_extern] = ACTIONS(4602),
    [sym_final] = ACTIONS(4602),
    [sym_for] = ACTIONS(4602),
    [sym_foreach] = ACTIONS(4602),
    [sym_foreach_reverse] = ACTIONS(4602),
    [sym_function] = ACTIONS(4602),
    [sym_goto] = ACTIONS(4602),
    [sym_if] = ACTIONS(4602),
    [sym_immutable] = ACTIONS(4602),
    [sym_import] = ACTIONS(4602),
    [sym_in] = ACTIONS(4602),
    [sym_inout] = ACTIONS(4602),
    [sym_interface] = ACTIONS(4602),
    [sym_invariant] = ACTIONS(4602),
    [sym_is] = ACTIONS(4602),
    [sym_mixin] = ACTIONS(4602),
    [sym_new] = ACTIONS(4602),
    [sym_nothrow] = ACTIONS(4602),
    [sym_out] = ACTIONS(4602),
    [sym_override] = ACTIONS(4602),
    [sym_package] = ACTIONS(4602),
    [sym_pragma] = ACTIONS(4602),
    [sym_private] = ACTIONS(4602),
    [sym_protected] = ACTIONS(4602),
    [sym_public] = ACTIONS(4602),
    [sym_pure] = ACTIONS(4602),
    [sym_ref] = ACTIONS(4602),
    [sym_return] = ACTIONS(4602),
    [sym_scope] = ACTIONS(4602),
    [sym_shared] = ACTIONS(4602),
    [sym_static] = ACTIONS(4602),
    [sym_struct] = ACTIONS(4602),
    [sym_switch] = ACTIONS(4602),
    [sym_synchronized] = ACTIONS(4602),
    [sym_template] = ACTIONS(4602),
    [sym_throw] = ACTIONS(4602),
    [sym_try] = ACTIONS(4602),
    [sym_typeid] = ACTIONS(4602),
    [sym_typeof] = ACTIONS(4602),
    [sym_union] = ACTIONS(4602),
    [sym_unittest] = ACTIONS(4602),
    [sym_version] = ACTIONS(4602),
    [sym_while] = ACTIONS(4602),
    [sym_with] = ACTIONS(4602),
    [sym_gshared] = ACTIONS(4602),
    [sym_traits] = ACTIONS(4602),
    [sym_vector] = ACTIONS(4602),
    [sym_void] = ACTIONS(4602),
    [anon_sym_BQUOTE] = ACTIONS(4604),
    [anon_sym_r_DQUOTE] = ACTIONS(4604),
    [anon_sym_x_DQUOTE] = ACTIONS(4604),
    [anon_sym_DQUOTE] = ACTIONS(4604),
    [anon_sym_i_BQUOTE] = ACTIONS(4604),
    [anon_sym_i_DQUOTE] = ACTIONS(4604),
    [anon_sym_iq_LBRACE] = ACTIONS(4604),
    [aux_sym_char_literal_token1] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4602),
    [anon_sym___DATE__] = ACTIONS(4602),
    [anon_sym___FILE__] = ACTIONS(4602),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4602),
    [anon_sym___FUNCTION__] = ACTIONS(4602),
    [anon_sym___LINE__] = ACTIONS(4602),
    [anon_sym___MODULE__] = ACTIONS(4602),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4602),
    [anon_sym___TIME__] = ACTIONS(4602),
    [anon_sym___TIMESTAMP__] = ACTIONS(4602),
    [anon_sym___VENDOR__] = ACTIONS(4602),
    [anon_sym___VERSION__] = ACTIONS(4602),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4604),
    [sym_float_literal] = ACTIONS(4604),
    [sym__string] = ACTIONS(4604),
  },
  [1672] = {
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_q_LBRACE] = ACTIONS(4336),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4334),
    [anon_sym_DASH_DASH] = ACTIONS(4336),
    [anon_sym_PLUS] = ACTIONS(4334),
    [anon_sym_PLUS_PLUS] = ACTIONS(4336),
    [anon_sym_BANG] = ACTIONS(4336),
    [anon_sym_LPAREN] = ACTIONS(4336),
    [anon_sym_RPAREN] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_DOLLAR] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4336),
    [anon_sym_AT] = ACTIONS(4336),
    [sym_bool] = ACTIONS(4334),
    [sym_byte] = ACTIONS(4334),
    [sym_ubyte] = ACTIONS(4334),
    [sym_char] = ACTIONS(4334),
    [sym_short] = ACTIONS(4334),
    [sym_ushort] = ACTIONS(4334),
    [sym_int] = ACTIONS(4334),
    [sym_uint] = ACTIONS(4334),
    [sym_long] = ACTIONS(4334),
    [sym_ulong] = ACTIONS(4334),
    [sym_cent] = ACTIONS(4334),
    [sym_ucent] = ACTIONS(4334),
    [sym_wchar] = ACTIONS(4334),
    [sym_dchar] = ACTIONS(4334),
    [sym_float] = ACTIONS(4334),
    [sym_double] = ACTIONS(4334),
    [sym_real] = ACTIONS(4334),
    [sym_ifloat] = ACTIONS(4334),
    [sym_idouble] = ACTIONS(4334),
    [sym_ireal] = ACTIONS(4334),
    [sym_cfloat] = ACTIONS(4334),
    [sym_cdouble] = ACTIONS(4334),
    [sym_creal] = ACTIONS(4334),
    [sym_size_t] = ACTIONS(4334),
    [sym_ptrdiff_t] = ACTIONS(4334),
    [sym_string] = ACTIONS(4334),
    [sym_cstring] = ACTIONS(4334),
    [sym_dstring] = ACTIONS(4334),
    [sym_wstring] = ACTIONS(4334),
    [sym_noreturn] = ACTIONS(4334),
    [sym_true] = ACTIONS(4334),
    [sym_false] = ACTIONS(4334),
    [sym_null] = ACTIONS(4334),
    [sym_super] = ACTIONS(4334),
    [sym_this] = ACTIONS(4334),
    [sym_abstract] = ACTIONS(4334),
    [sym_alias] = ACTIONS(4334),
    [sym_align] = ACTIONS(4334),
    [sym_asm] = ACTIONS(4334),
    [sym_assert] = ACTIONS(4334),
    [sym_auto] = ACTIONS(4334),
    [sym_break] = ACTIONS(4334),
    [sym_case] = ACTIONS(4334),
    [sym_cast] = ACTIONS(4334),
    [sym_class] = ACTIONS(4334),
    [sym_const] = ACTIONS(4334),
    [sym_continue] = ACTIONS(4334),
    [sym_debug] = ACTIONS(4334),
    [sym_default] = ACTIONS(4334),
    [sym_delegate] = ACTIONS(4334),
    [sym_delete] = ACTIONS(4334),
    [sym_deprecated] = ACTIONS(4334),
    [sym_do] = ACTIONS(4334),
    [sym_else] = ACTIONS(4334),
    [sym_enum] = ACTIONS(4334),
    [sym_export] = ACTIONS(4334),
    [sym_extern] = ACTIONS(4334),
    [sym_final] = ACTIONS(4334),
    [sym_for] = ACTIONS(4334),
    [sym_foreach] = ACTIONS(4334),
    [sym_foreach_reverse] = ACTIONS(4334),
    [sym_function] = ACTIONS(4334),
    [sym_goto] = ACTIONS(4334),
    [sym_if] = ACTIONS(4334),
    [sym_immutable] = ACTIONS(4334),
    [sym_import] = ACTIONS(4334),
    [sym_in] = ACTIONS(4334),
    [sym_inout] = ACTIONS(4334),
    [sym_interface] = ACTIONS(4334),
    [sym_invariant] = ACTIONS(4334),
    [sym_is] = ACTIONS(4334),
    [sym_mixin] = ACTIONS(4334),
    [sym_new] = ACTIONS(4334),
    [sym_nothrow] = ACTIONS(4334),
    [sym_out] = ACTIONS(4334),
    [sym_override] = ACTIONS(4334),
    [sym_package] = ACTIONS(4334),
    [sym_pragma] = ACTIONS(4334),
    [sym_private] = ACTIONS(4334),
    [sym_protected] = ACTIONS(4334),
    [sym_public] = ACTIONS(4334),
    [sym_pure] = ACTIONS(4334),
    [sym_ref] = ACTIONS(4334),
    [sym_return] = ACTIONS(4334),
    [sym_scope] = ACTIONS(4334),
    [sym_shared] = ACTIONS(4334),
    [sym_static] = ACTIONS(4334),
    [sym_struct] = ACTIONS(4334),
    [sym_switch] = ACTIONS(4334),
    [sym_synchronized] = ACTIONS(4334),
    [sym_template] = ACTIONS(4334),
    [sym_throw] = ACTIONS(4334),
    [sym_try] = ACTIONS(4334),
    [sym_typeid] = ACTIONS(4334),
    [sym_typeof] = ACTIONS(4334),
    [sym_union] = ACTIONS(4334),
    [sym_unittest] = ACTIONS(4334),
    [sym_version] = ACTIONS(4334),
    [sym_while] = ACTIONS(4334),
    [sym_with] = ACTIONS(4334),
    [sym_gshared] = ACTIONS(4334),
    [sym_traits] = ACTIONS(4334),
    [sym_vector] = ACTIONS(4334),
    [sym_void] = ACTIONS(4334),
    [anon_sym_BQUOTE] = ACTIONS(4336),
    [anon_sym_r_DQUOTE] = ACTIONS(4336),
    [anon_sym_x_DQUOTE] = ACTIONS(4336),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_i_BQUOTE] = ACTIONS(4336),
    [anon_sym_i_DQUOTE] = ACTIONS(4336),
    [anon_sym_iq_LBRACE] = ACTIONS(4336),
    [aux_sym_char_literal_token1] = ACTIONS(4336),
    [anon_sym_SQUOTE] = ACTIONS(4334),
    [anon_sym___DATE__] = ACTIONS(4334),
    [anon_sym___FILE__] = ACTIONS(4334),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4334),
    [anon_sym___FUNCTION__] = ACTIONS(4334),
    [anon_sym___LINE__] = ACTIONS(4334),
    [anon_sym___MODULE__] = ACTIONS(4334),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4334),
    [anon_sym___TIME__] = ACTIONS(4334),
    [anon_sym___TIMESTAMP__] = ACTIONS(4334),
    [anon_sym___VENDOR__] = ACTIONS(4334),
    [anon_sym___VERSION__] = ACTIONS(4334),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4336),
    [sym_float_literal] = ACTIONS(4336),
    [sym__string] = ACTIONS(4336),
  },
  [1673] = {
    [sym_identifier] = ACTIONS(4338),
    [anon_sym_q_LBRACE] = ACTIONS(4340),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_LBRACE] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4340),
    [anon_sym_DASH] = ACTIONS(4338),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_BANG] = ACTIONS(4340),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_RPAREN] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_DOLLAR] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4340),
    [anon_sym_TILDE] = ACTIONS(4340),
    [anon_sym_AT] = ACTIONS(4340),
    [sym_bool] = ACTIONS(4338),
    [sym_byte] = ACTIONS(4338),
    [sym_ubyte] = ACTIONS(4338),
    [sym_char] = ACTIONS(4338),
    [sym_short] = ACTIONS(4338),
    [sym_ushort] = ACTIONS(4338),
    [sym_int] = ACTIONS(4338),
    [sym_uint] = ACTIONS(4338),
    [sym_long] = ACTIONS(4338),
    [sym_ulong] = ACTIONS(4338),
    [sym_cent] = ACTIONS(4338),
    [sym_ucent] = ACTIONS(4338),
    [sym_wchar] = ACTIONS(4338),
    [sym_dchar] = ACTIONS(4338),
    [sym_float] = ACTIONS(4338),
    [sym_double] = ACTIONS(4338),
    [sym_real] = ACTIONS(4338),
    [sym_ifloat] = ACTIONS(4338),
    [sym_idouble] = ACTIONS(4338),
    [sym_ireal] = ACTIONS(4338),
    [sym_cfloat] = ACTIONS(4338),
    [sym_cdouble] = ACTIONS(4338),
    [sym_creal] = ACTIONS(4338),
    [sym_size_t] = ACTIONS(4338),
    [sym_ptrdiff_t] = ACTIONS(4338),
    [sym_string] = ACTIONS(4338),
    [sym_cstring] = ACTIONS(4338),
    [sym_dstring] = ACTIONS(4338),
    [sym_wstring] = ACTIONS(4338),
    [sym_noreturn] = ACTIONS(4338),
    [sym_true] = ACTIONS(4338),
    [sym_false] = ACTIONS(4338),
    [sym_null] = ACTIONS(4338),
    [sym_super] = ACTIONS(4338),
    [sym_this] = ACTIONS(4338),
    [sym_abstract] = ACTIONS(4338),
    [sym_alias] = ACTIONS(4338),
    [sym_align] = ACTIONS(4338),
    [sym_asm] = ACTIONS(4338),
    [sym_assert] = ACTIONS(4338),
    [sym_auto] = ACTIONS(4338),
    [sym_break] = ACTIONS(4338),
    [sym_case] = ACTIONS(4338),
    [sym_cast] = ACTIONS(4338),
    [sym_class] = ACTIONS(4338),
    [sym_const] = ACTIONS(4338),
    [sym_continue] = ACTIONS(4338),
    [sym_debug] = ACTIONS(4338),
    [sym_default] = ACTIONS(4338),
    [sym_delegate] = ACTIONS(4338),
    [sym_delete] = ACTIONS(4338),
    [sym_deprecated] = ACTIONS(4338),
    [sym_do] = ACTIONS(4338),
    [sym_else] = ACTIONS(4338),
    [sym_enum] = ACTIONS(4338),
    [sym_export] = ACTIONS(4338),
    [sym_extern] = ACTIONS(4338),
    [sym_final] = ACTIONS(4338),
    [sym_for] = ACTIONS(4338),
    [sym_foreach] = ACTIONS(4338),
    [sym_foreach_reverse] = ACTIONS(4338),
    [sym_function] = ACTIONS(4338),
    [sym_goto] = ACTIONS(4338),
    [sym_if] = ACTIONS(4338),
    [sym_immutable] = ACTIONS(4338),
    [sym_import] = ACTIONS(4338),
    [sym_in] = ACTIONS(4338),
    [sym_inout] = ACTIONS(4338),
    [sym_interface] = ACTIONS(4338),
    [sym_invariant] = ACTIONS(4338),
    [sym_is] = ACTIONS(4338),
    [sym_mixin] = ACTIONS(4338),
    [sym_new] = ACTIONS(4338),
    [sym_nothrow] = ACTIONS(4338),
    [sym_out] = ACTIONS(4338),
    [sym_override] = ACTIONS(4338),
    [sym_package] = ACTIONS(4338),
    [sym_pragma] = ACTIONS(4338),
    [sym_private] = ACTIONS(4338),
    [sym_protected] = ACTIONS(4338),
    [sym_public] = ACTIONS(4338),
    [sym_pure] = ACTIONS(4338),
    [sym_ref] = ACTIONS(4338),
    [sym_return] = ACTIONS(4338),
    [sym_scope] = ACTIONS(4338),
    [sym_shared] = ACTIONS(4338),
    [sym_static] = ACTIONS(4338),
    [sym_struct] = ACTIONS(4338),
    [sym_switch] = ACTIONS(4338),
    [sym_synchronized] = ACTIONS(4338),
    [sym_template] = ACTIONS(4338),
    [sym_throw] = ACTIONS(4338),
    [sym_try] = ACTIONS(4338),
    [sym_typeid] = ACTIONS(4338),
    [sym_typeof] = ACTIONS(4338),
    [sym_union] = ACTIONS(4338),
    [sym_unittest] = ACTIONS(4338),
    [sym_version] = ACTIONS(4338),
    [sym_while] = ACTIONS(4338),
    [sym_with] = ACTIONS(4338),
    [sym_gshared] = ACTIONS(4338),
    [sym_traits] = ACTIONS(4338),
    [sym_vector] = ACTIONS(4338),
    [sym_void] = ACTIONS(4338),
    [anon_sym_BQUOTE] = ACTIONS(4340),
    [anon_sym_r_DQUOTE] = ACTIONS(4340),
    [anon_sym_x_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [anon_sym_i_BQUOTE] = ACTIONS(4340),
    [anon_sym_i_DQUOTE] = ACTIONS(4340),
    [anon_sym_iq_LBRACE] = ACTIONS(4340),
    [aux_sym_char_literal_token1] = ACTIONS(4340),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym___DATE__] = ACTIONS(4338),
    [anon_sym___FILE__] = ACTIONS(4338),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4338),
    [anon_sym___FUNCTION__] = ACTIONS(4338),
    [anon_sym___LINE__] = ACTIONS(4338),
    [anon_sym___MODULE__] = ACTIONS(4338),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4338),
    [anon_sym___TIME__] = ACTIONS(4338),
    [anon_sym___TIMESTAMP__] = ACTIONS(4338),
    [anon_sym___VENDOR__] = ACTIONS(4338),
    [anon_sym___VERSION__] = ACTIONS(4338),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4340),
    [sym_float_literal] = ACTIONS(4340),
    [sym__string] = ACTIONS(4340),
  },
  [1674] = {
    [sym_identifier] = ACTIONS(4342),
    [anon_sym_q_LBRACE] = ACTIONS(4344),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_LBRACE] = ACTIONS(4344),
    [anon_sym_DOT] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(4344),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4344),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_PLUS_PLUS] = ACTIONS(4344),
    [anon_sym_BANG] = ACTIONS(4344),
    [anon_sym_LPAREN] = ACTIONS(4344),
    [anon_sym_RPAREN] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(4344),
    [anon_sym_SEMI] = ACTIONS(4344),
    [anon_sym_DOLLAR] = ACTIONS(4344),
    [anon_sym_STAR] = ACTIONS(4344),
    [anon_sym_TILDE] = ACTIONS(4344),
    [anon_sym_AT] = ACTIONS(4344),
    [sym_bool] = ACTIONS(4342),
    [sym_byte] = ACTIONS(4342),
    [sym_ubyte] = ACTIONS(4342),
    [sym_char] = ACTIONS(4342),
    [sym_short] = ACTIONS(4342),
    [sym_ushort] = ACTIONS(4342),
    [sym_int] = ACTIONS(4342),
    [sym_uint] = ACTIONS(4342),
    [sym_long] = ACTIONS(4342),
    [sym_ulong] = ACTIONS(4342),
    [sym_cent] = ACTIONS(4342),
    [sym_ucent] = ACTIONS(4342),
    [sym_wchar] = ACTIONS(4342),
    [sym_dchar] = ACTIONS(4342),
    [sym_float] = ACTIONS(4342),
    [sym_double] = ACTIONS(4342),
    [sym_real] = ACTIONS(4342),
    [sym_ifloat] = ACTIONS(4342),
    [sym_idouble] = ACTIONS(4342),
    [sym_ireal] = ACTIONS(4342),
    [sym_cfloat] = ACTIONS(4342),
    [sym_cdouble] = ACTIONS(4342),
    [sym_creal] = ACTIONS(4342),
    [sym_size_t] = ACTIONS(4342),
    [sym_ptrdiff_t] = ACTIONS(4342),
    [sym_string] = ACTIONS(4342),
    [sym_cstring] = ACTIONS(4342),
    [sym_dstring] = ACTIONS(4342),
    [sym_wstring] = ACTIONS(4342),
    [sym_noreturn] = ACTIONS(4342),
    [sym_true] = ACTIONS(4342),
    [sym_false] = ACTIONS(4342),
    [sym_null] = ACTIONS(4342),
    [sym_super] = ACTIONS(4342),
    [sym_this] = ACTIONS(4342),
    [sym_abstract] = ACTIONS(4342),
    [sym_alias] = ACTIONS(4342),
    [sym_align] = ACTIONS(4342),
    [sym_asm] = ACTIONS(4342),
    [sym_assert] = ACTIONS(4342),
    [sym_auto] = ACTIONS(4342),
    [sym_break] = ACTIONS(4342),
    [sym_case] = ACTIONS(4342),
    [sym_cast] = ACTIONS(4342),
    [sym_class] = ACTIONS(4342),
    [sym_const] = ACTIONS(4342),
    [sym_continue] = ACTIONS(4342),
    [sym_debug] = ACTIONS(4342),
    [sym_default] = ACTIONS(4342),
    [sym_delegate] = ACTIONS(4342),
    [sym_delete] = ACTIONS(4342),
    [sym_deprecated] = ACTIONS(4342),
    [sym_do] = ACTIONS(4342),
    [sym_else] = ACTIONS(4342),
    [sym_enum] = ACTIONS(4342),
    [sym_export] = ACTIONS(4342),
    [sym_extern] = ACTIONS(4342),
    [sym_final] = ACTIONS(4342),
    [sym_for] = ACTIONS(4342),
    [sym_foreach] = ACTIONS(4342),
    [sym_foreach_reverse] = ACTIONS(4342),
    [sym_function] = ACTIONS(4342),
    [sym_goto] = ACTIONS(4342),
    [sym_if] = ACTIONS(4342),
    [sym_immutable] = ACTIONS(4342),
    [sym_import] = ACTIONS(4342),
    [sym_in] = ACTIONS(4342),
    [sym_inout] = ACTIONS(4342),
    [sym_interface] = ACTIONS(4342),
    [sym_invariant] = ACTIONS(4342),
    [sym_is] = ACTIONS(4342),
    [sym_mixin] = ACTIONS(4342),
    [sym_new] = ACTIONS(4342),
    [sym_nothrow] = ACTIONS(4342),
    [sym_out] = ACTIONS(4342),
    [sym_override] = ACTIONS(4342),
    [sym_package] = ACTIONS(4342),
    [sym_pragma] = ACTIONS(4342),
    [sym_private] = ACTIONS(4342),
    [sym_protected] = ACTIONS(4342),
    [sym_public] = ACTIONS(4342),
    [sym_pure] = ACTIONS(4342),
    [sym_ref] = ACTIONS(4342),
    [sym_return] = ACTIONS(4342),
    [sym_scope] = ACTIONS(4342),
    [sym_shared] = ACTIONS(4342),
    [sym_static] = ACTIONS(4342),
    [sym_struct] = ACTIONS(4342),
    [sym_switch] = ACTIONS(4342),
    [sym_synchronized] = ACTIONS(4342),
    [sym_template] = ACTIONS(4342),
    [sym_throw] = ACTIONS(4342),
    [sym_try] = ACTIONS(4342),
    [sym_typeid] = ACTIONS(4342),
    [sym_typeof] = ACTIONS(4342),
    [sym_union] = ACTIONS(4342),
    [sym_unittest] = ACTIONS(4342),
    [sym_version] = ACTIONS(4342),
    [sym_while] = ACTIONS(4342),
    [sym_with] = ACTIONS(4342),
    [sym_gshared] = ACTIONS(4342),
    [sym_traits] = ACTIONS(4342),
    [sym_vector] = ACTIONS(4342),
    [sym_void] = ACTIONS(4342),
    [anon_sym_BQUOTE] = ACTIONS(4344),
    [anon_sym_r_DQUOTE] = ACTIONS(4344),
    [anon_sym_x_DQUOTE] = ACTIONS(4344),
    [anon_sym_DQUOTE] = ACTIONS(4344),
    [anon_sym_i_BQUOTE] = ACTIONS(4344),
    [anon_sym_i_DQUOTE] = ACTIONS(4344),
    [anon_sym_iq_LBRACE] = ACTIONS(4344),
    [aux_sym_char_literal_token1] = ACTIONS(4344),
    [anon_sym_SQUOTE] = ACTIONS(4342),
    [anon_sym___DATE__] = ACTIONS(4342),
    [anon_sym___FILE__] = ACTIONS(4342),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4342),
    [anon_sym___FUNCTION__] = ACTIONS(4342),
    [anon_sym___LINE__] = ACTIONS(4342),
    [anon_sym___MODULE__] = ACTIONS(4342),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4342),
    [anon_sym___TIME__] = ACTIONS(4342),
    [anon_sym___TIMESTAMP__] = ACTIONS(4342),
    [anon_sym___VENDOR__] = ACTIONS(4342),
    [anon_sym___VERSION__] = ACTIONS(4342),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4344),
    [sym_float_literal] = ACTIONS(4344),
    [sym__string] = ACTIONS(4344),
  },
  [1675] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_asm] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_break] = ACTIONS(3127),
    [sym_case] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_continue] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_default] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_for] = ACTIONS(3127),
    [sym_foreach] = ACTIONS(3127),
    [sym_foreach_reverse] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_goto] = ACTIONS(3127),
    [sym_if] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_switch] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_try] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_with] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
  },
  [1676] = {
    [sym_identifier] = ACTIONS(4346),
    [anon_sym_q_LBRACE] = ACTIONS(4348),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_LBRACE] = ACTIONS(4348),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_DASH] = ACTIONS(4346),
    [anon_sym_DASH_DASH] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(4348),
    [anon_sym_BANG] = ACTIONS(4348),
    [anon_sym_LPAREN] = ACTIONS(4348),
    [anon_sym_RPAREN] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_DOLLAR] = ACTIONS(4348),
    [anon_sym_STAR] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4348),
    [anon_sym_AT] = ACTIONS(4348),
    [sym_bool] = ACTIONS(4346),
    [sym_byte] = ACTIONS(4346),
    [sym_ubyte] = ACTIONS(4346),
    [sym_char] = ACTIONS(4346),
    [sym_short] = ACTIONS(4346),
    [sym_ushort] = ACTIONS(4346),
    [sym_int] = ACTIONS(4346),
    [sym_uint] = ACTIONS(4346),
    [sym_long] = ACTIONS(4346),
    [sym_ulong] = ACTIONS(4346),
    [sym_cent] = ACTIONS(4346),
    [sym_ucent] = ACTIONS(4346),
    [sym_wchar] = ACTIONS(4346),
    [sym_dchar] = ACTIONS(4346),
    [sym_float] = ACTIONS(4346),
    [sym_double] = ACTIONS(4346),
    [sym_real] = ACTIONS(4346),
    [sym_ifloat] = ACTIONS(4346),
    [sym_idouble] = ACTIONS(4346),
    [sym_ireal] = ACTIONS(4346),
    [sym_cfloat] = ACTIONS(4346),
    [sym_cdouble] = ACTIONS(4346),
    [sym_creal] = ACTIONS(4346),
    [sym_size_t] = ACTIONS(4346),
    [sym_ptrdiff_t] = ACTIONS(4346),
    [sym_string] = ACTIONS(4346),
    [sym_cstring] = ACTIONS(4346),
    [sym_dstring] = ACTIONS(4346),
    [sym_wstring] = ACTIONS(4346),
    [sym_noreturn] = ACTIONS(4346),
    [sym_true] = ACTIONS(4346),
    [sym_false] = ACTIONS(4346),
    [sym_null] = ACTIONS(4346),
    [sym_super] = ACTIONS(4346),
    [sym_this] = ACTIONS(4346),
    [sym_abstract] = ACTIONS(4346),
    [sym_alias] = ACTIONS(4346),
    [sym_align] = ACTIONS(4346),
    [sym_asm] = ACTIONS(4346),
    [sym_assert] = ACTIONS(4346),
    [sym_auto] = ACTIONS(4346),
    [sym_break] = ACTIONS(4346),
    [sym_case] = ACTIONS(4346),
    [sym_cast] = ACTIONS(4346),
    [sym_class] = ACTIONS(4346),
    [sym_const] = ACTIONS(4346),
    [sym_continue] = ACTIONS(4346),
    [sym_debug] = ACTIONS(4346),
    [sym_default] = ACTIONS(4346),
    [sym_delegate] = ACTIONS(4346),
    [sym_delete] = ACTIONS(4346),
    [sym_deprecated] = ACTIONS(4346),
    [sym_do] = ACTIONS(4346),
    [sym_else] = ACTIONS(4346),
    [sym_enum] = ACTIONS(4346),
    [sym_export] = ACTIONS(4346),
    [sym_extern] = ACTIONS(4346),
    [sym_final] = ACTIONS(4346),
    [sym_for] = ACTIONS(4346),
    [sym_foreach] = ACTIONS(4346),
    [sym_foreach_reverse] = ACTIONS(4346),
    [sym_function] = ACTIONS(4346),
    [sym_goto] = ACTIONS(4346),
    [sym_if] = ACTIONS(4346),
    [sym_immutable] = ACTIONS(4346),
    [sym_import] = ACTIONS(4346),
    [sym_in] = ACTIONS(4346),
    [sym_inout] = ACTIONS(4346),
    [sym_interface] = ACTIONS(4346),
    [sym_invariant] = ACTIONS(4346),
    [sym_is] = ACTIONS(4346),
    [sym_mixin] = ACTIONS(4346),
    [sym_new] = ACTIONS(4346),
    [sym_nothrow] = ACTIONS(4346),
    [sym_out] = ACTIONS(4346),
    [sym_override] = ACTIONS(4346),
    [sym_package] = ACTIONS(4346),
    [sym_pragma] = ACTIONS(4346),
    [sym_private] = ACTIONS(4346),
    [sym_protected] = ACTIONS(4346),
    [sym_public] = ACTIONS(4346),
    [sym_pure] = ACTIONS(4346),
    [sym_ref] = ACTIONS(4346),
    [sym_return] = ACTIONS(4346),
    [sym_scope] = ACTIONS(4346),
    [sym_shared] = ACTIONS(4346),
    [sym_static] = ACTIONS(4346),
    [sym_struct] = ACTIONS(4346),
    [sym_switch] = ACTIONS(4346),
    [sym_synchronized] = ACTIONS(4346),
    [sym_template] = ACTIONS(4346),
    [sym_throw] = ACTIONS(4346),
    [sym_try] = ACTIONS(4346),
    [sym_typeid] = ACTIONS(4346),
    [sym_typeof] = ACTIONS(4346),
    [sym_union] = ACTIONS(4346),
    [sym_unittest] = ACTIONS(4346),
    [sym_version] = ACTIONS(4346),
    [sym_while] = ACTIONS(4346),
    [sym_with] = ACTIONS(4346),
    [sym_gshared] = ACTIONS(4346),
    [sym_traits] = ACTIONS(4346),
    [sym_vector] = ACTIONS(4346),
    [sym_void] = ACTIONS(4346),
    [anon_sym_BQUOTE] = ACTIONS(4348),
    [anon_sym_r_DQUOTE] = ACTIONS(4348),
    [anon_sym_x_DQUOTE] = ACTIONS(4348),
    [anon_sym_DQUOTE] = ACTIONS(4348),
    [anon_sym_i_BQUOTE] = ACTIONS(4348),
    [anon_sym_i_DQUOTE] = ACTIONS(4348),
    [anon_sym_iq_LBRACE] = ACTIONS(4348),
    [aux_sym_char_literal_token1] = ACTIONS(4348),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym___DATE__] = ACTIONS(4346),
    [anon_sym___FILE__] = ACTIONS(4346),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4346),
    [anon_sym___FUNCTION__] = ACTIONS(4346),
    [anon_sym___LINE__] = ACTIONS(4346),
    [anon_sym___MODULE__] = ACTIONS(4346),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4346),
    [anon_sym___TIME__] = ACTIONS(4346),
    [anon_sym___TIMESTAMP__] = ACTIONS(4346),
    [anon_sym___VENDOR__] = ACTIONS(4346),
    [anon_sym___VERSION__] = ACTIONS(4346),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4348),
    [sym_float_literal] = ACTIONS(4348),
    [sym__string] = ACTIONS(4348),
  },
  [1677] = {
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_q_LBRACE] = ACTIONS(4352),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_LBRACE] = ACTIONS(4352),
    [anon_sym_DOT] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_DASH] = ACTIONS(4350),
    [anon_sym_DASH_DASH] = ACTIONS(4352),
    [anon_sym_PLUS] = ACTIONS(4350),
    [anon_sym_PLUS_PLUS] = ACTIONS(4352),
    [anon_sym_BANG] = ACTIONS(4352),
    [anon_sym_LPAREN] = ACTIONS(4352),
    [anon_sym_RPAREN] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4352),
    [anon_sym_STAR] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4352),
    [anon_sym_AT] = ACTIONS(4352),
    [sym_bool] = ACTIONS(4350),
    [sym_byte] = ACTIONS(4350),
    [sym_ubyte] = ACTIONS(4350),
    [sym_char] = ACTIONS(4350),
    [sym_short] = ACTIONS(4350),
    [sym_ushort] = ACTIONS(4350),
    [sym_int] = ACTIONS(4350),
    [sym_uint] = ACTIONS(4350),
    [sym_long] = ACTIONS(4350),
    [sym_ulong] = ACTIONS(4350),
    [sym_cent] = ACTIONS(4350),
    [sym_ucent] = ACTIONS(4350),
    [sym_wchar] = ACTIONS(4350),
    [sym_dchar] = ACTIONS(4350),
    [sym_float] = ACTIONS(4350),
    [sym_double] = ACTIONS(4350),
    [sym_real] = ACTIONS(4350),
    [sym_ifloat] = ACTIONS(4350),
    [sym_idouble] = ACTIONS(4350),
    [sym_ireal] = ACTIONS(4350),
    [sym_cfloat] = ACTIONS(4350),
    [sym_cdouble] = ACTIONS(4350),
    [sym_creal] = ACTIONS(4350),
    [sym_size_t] = ACTIONS(4350),
    [sym_ptrdiff_t] = ACTIONS(4350),
    [sym_string] = ACTIONS(4350),
    [sym_cstring] = ACTIONS(4350),
    [sym_dstring] = ACTIONS(4350),
    [sym_wstring] = ACTIONS(4350),
    [sym_noreturn] = ACTIONS(4350),
    [sym_true] = ACTIONS(4350),
    [sym_false] = ACTIONS(4350),
    [sym_null] = ACTIONS(4350),
    [sym_super] = ACTIONS(4350),
    [sym_this] = ACTIONS(4350),
    [sym_abstract] = ACTIONS(4350),
    [sym_alias] = ACTIONS(4350),
    [sym_align] = ACTIONS(4350),
    [sym_asm] = ACTIONS(4350),
    [sym_assert] = ACTIONS(4350),
    [sym_auto] = ACTIONS(4350),
    [sym_break] = ACTIONS(4350),
    [sym_case] = ACTIONS(4350),
    [sym_cast] = ACTIONS(4350),
    [sym_class] = ACTIONS(4350),
    [sym_const] = ACTIONS(4350),
    [sym_continue] = ACTIONS(4350),
    [sym_debug] = ACTIONS(4350),
    [sym_default] = ACTIONS(4350),
    [sym_delegate] = ACTIONS(4350),
    [sym_delete] = ACTIONS(4350),
    [sym_deprecated] = ACTIONS(4350),
    [sym_do] = ACTIONS(4350),
    [sym_else] = ACTIONS(4350),
    [sym_enum] = ACTIONS(4350),
    [sym_export] = ACTIONS(4350),
    [sym_extern] = ACTIONS(4350),
    [sym_final] = ACTIONS(4350),
    [sym_for] = ACTIONS(4350),
    [sym_foreach] = ACTIONS(4350),
    [sym_foreach_reverse] = ACTIONS(4350),
    [sym_function] = ACTIONS(4350),
    [sym_goto] = ACTIONS(4350),
    [sym_if] = ACTIONS(4350),
    [sym_immutable] = ACTIONS(4350),
    [sym_import] = ACTIONS(4350),
    [sym_in] = ACTIONS(4350),
    [sym_inout] = ACTIONS(4350),
    [sym_interface] = ACTIONS(4350),
    [sym_invariant] = ACTIONS(4350),
    [sym_is] = ACTIONS(4350),
    [sym_mixin] = ACTIONS(4350),
    [sym_new] = ACTIONS(4350),
    [sym_nothrow] = ACTIONS(4350),
    [sym_out] = ACTIONS(4350),
    [sym_override] = ACTIONS(4350),
    [sym_package] = ACTIONS(4350),
    [sym_pragma] = ACTIONS(4350),
    [sym_private] = ACTIONS(4350),
    [sym_protected] = ACTIONS(4350),
    [sym_public] = ACTIONS(4350),
    [sym_pure] = ACTIONS(4350),
    [sym_ref] = ACTIONS(4350),
    [sym_return] = ACTIONS(4350),
    [sym_scope] = ACTIONS(4350),
    [sym_shared] = ACTIONS(4350),
    [sym_static] = ACTIONS(4350),
    [sym_struct] = ACTIONS(4350),
    [sym_switch] = ACTIONS(4350),
    [sym_synchronized] = ACTIONS(4350),
    [sym_template] = ACTIONS(4350),
    [sym_throw] = ACTIONS(4350),
    [sym_try] = ACTIONS(4350),
    [sym_typeid] = ACTIONS(4350),
    [sym_typeof] = ACTIONS(4350),
    [sym_union] = ACTIONS(4350),
    [sym_unittest] = ACTIONS(4350),
    [sym_version] = ACTIONS(4350),
    [sym_while] = ACTIONS(4350),
    [sym_with] = ACTIONS(4350),
    [sym_gshared] = ACTIONS(4350),
    [sym_traits] = ACTIONS(4350),
    [sym_vector] = ACTIONS(4350),
    [sym_void] = ACTIONS(4350),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_r_DQUOTE] = ACTIONS(4352),
    [anon_sym_x_DQUOTE] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_i_BQUOTE] = ACTIONS(4352),
    [anon_sym_i_DQUOTE] = ACTIONS(4352),
    [anon_sym_iq_LBRACE] = ACTIONS(4352),
    [aux_sym_char_literal_token1] = ACTIONS(4352),
    [anon_sym_SQUOTE] = ACTIONS(4350),
    [anon_sym___DATE__] = ACTIONS(4350),
    [anon_sym___FILE__] = ACTIONS(4350),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4350),
    [anon_sym___FUNCTION__] = ACTIONS(4350),
    [anon_sym___LINE__] = ACTIONS(4350),
    [anon_sym___MODULE__] = ACTIONS(4350),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4350),
    [anon_sym___TIME__] = ACTIONS(4350),
    [anon_sym___TIMESTAMP__] = ACTIONS(4350),
    [anon_sym___VENDOR__] = ACTIONS(4350),
    [anon_sym___VERSION__] = ACTIONS(4350),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4352),
    [sym_float_literal] = ACTIONS(4352),
    [sym__string] = ACTIONS(4352),
  },
  [1678] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_q_LBRACE] = ACTIONS(3165),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_abstract] = ACTIONS(3163),
    [sym_alias] = ACTIONS(3163),
    [sym_align] = ACTIONS(3163),
    [sym_asm] = ACTIONS(3163),
    [sym_assert] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_break] = ACTIONS(3163),
    [sym_case] = ACTIONS(3163),
    [sym_cast] = ACTIONS(3163),
    [sym_class] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_continue] = ACTIONS(3163),
    [sym_debug] = ACTIONS(3163),
    [sym_default] = ACTIONS(3163),
    [sym_delegate] = ACTIONS(3163),
    [sym_delete] = ACTIONS(3163),
    [sym_deprecated] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_enum] = ACTIONS(3163),
    [sym_export] = ACTIONS(3163),
    [sym_extern] = ACTIONS(3163),
    [sym_final] = ACTIONS(3163),
    [sym_for] = ACTIONS(3163),
    [sym_foreach] = ACTIONS(3163),
    [sym_foreach_reverse] = ACTIONS(3163),
    [sym_function] = ACTIONS(3163),
    [sym_goto] = ACTIONS(3163),
    [sym_if] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_interface] = ACTIONS(3163),
    [sym_invariant] = ACTIONS(3163),
    [sym_is] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_new] = ACTIONS(3163),
    [sym_nothrow] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_override] = ACTIONS(3163),
    [sym_package] = ACTIONS(3163),
    [sym_pragma] = ACTIONS(3163),
    [sym_private] = ACTIONS(3163),
    [sym_protected] = ACTIONS(3163),
    [sym_public] = ACTIONS(3163),
    [sym_pure] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_return] = ACTIONS(3163),
    [sym_scope] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_static] = ACTIONS(3163),
    [sym_struct] = ACTIONS(3163),
    [sym_switch] = ACTIONS(3163),
    [sym_synchronized] = ACTIONS(3163),
    [sym_template] = ACTIONS(3163),
    [sym_throw] = ACTIONS(3163),
    [sym_try] = ACTIONS(3163),
    [sym_typeid] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_union] = ACTIONS(3163),
    [sym_unittest] = ACTIONS(3163),
    [sym_version] = ACTIONS(3163),
    [sym_while] = ACTIONS(3163),
    [sym_with] = ACTIONS(3163),
    [sym_gshared] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [anon_sym_r_DQUOTE] = ACTIONS(3165),
    [anon_sym_x_DQUOTE] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_i_BQUOTE] = ACTIONS(3165),
    [anon_sym_i_DQUOTE] = ACTIONS(3165),
    [anon_sym_iq_LBRACE] = ACTIONS(3165),
    [aux_sym_char_literal_token1] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym___DATE__] = ACTIONS(3163),
    [anon_sym___FILE__] = ACTIONS(3163),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3163),
    [anon_sym___FUNCTION__] = ACTIONS(3163),
    [anon_sym___LINE__] = ACTIONS(3163),
    [anon_sym___MODULE__] = ACTIONS(3163),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3163),
    [anon_sym___TIME__] = ACTIONS(3163),
    [anon_sym___TIMESTAMP__] = ACTIONS(3163),
    [anon_sym___VENDOR__] = ACTIONS(3163),
    [anon_sym___VERSION__] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym__string] = ACTIONS(3165),
  },
  [1679] = {
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_q_LBRACE] = ACTIONS(4410),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4410),
    [anon_sym_LPAREN] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_AT] = ACTIONS(4410),
    [sym_bool] = ACTIONS(4408),
    [sym_byte] = ACTIONS(4408),
    [sym_ubyte] = ACTIONS(4408),
    [sym_char] = ACTIONS(4408),
    [sym_short] = ACTIONS(4408),
    [sym_ushort] = ACTIONS(4408),
    [sym_int] = ACTIONS(4408),
    [sym_uint] = ACTIONS(4408),
    [sym_long] = ACTIONS(4408),
    [sym_ulong] = ACTIONS(4408),
    [sym_cent] = ACTIONS(4408),
    [sym_ucent] = ACTIONS(4408),
    [sym_wchar] = ACTIONS(4408),
    [sym_dchar] = ACTIONS(4408),
    [sym_float] = ACTIONS(4408),
    [sym_double] = ACTIONS(4408),
    [sym_real] = ACTIONS(4408),
    [sym_ifloat] = ACTIONS(4408),
    [sym_idouble] = ACTIONS(4408),
    [sym_ireal] = ACTIONS(4408),
    [sym_cfloat] = ACTIONS(4408),
    [sym_cdouble] = ACTIONS(4408),
    [sym_creal] = ACTIONS(4408),
    [sym_size_t] = ACTIONS(4408),
    [sym_ptrdiff_t] = ACTIONS(4408),
    [sym_string] = ACTIONS(4408),
    [sym_cstring] = ACTIONS(4408),
    [sym_dstring] = ACTIONS(4408),
    [sym_wstring] = ACTIONS(4408),
    [sym_noreturn] = ACTIONS(4408),
    [sym_true] = ACTIONS(4408),
    [sym_false] = ACTIONS(4408),
    [sym_null] = ACTIONS(4408),
    [sym_super] = ACTIONS(4408),
    [sym_this] = ACTIONS(4408),
    [sym_abstract] = ACTIONS(4408),
    [sym_alias] = ACTIONS(4408),
    [sym_align] = ACTIONS(4408),
    [sym_asm] = ACTIONS(4408),
    [sym_assert] = ACTIONS(4408),
    [sym_auto] = ACTIONS(4408),
    [sym_break] = ACTIONS(4408),
    [sym_case] = ACTIONS(4408),
    [sym_cast] = ACTIONS(4408),
    [sym_class] = ACTIONS(4408),
    [sym_const] = ACTIONS(4408),
    [sym_continue] = ACTIONS(4408),
    [sym_debug] = ACTIONS(4408),
    [sym_default] = ACTIONS(4408),
    [sym_delegate] = ACTIONS(4408),
    [sym_delete] = ACTIONS(4408),
    [sym_deprecated] = ACTIONS(4408),
    [sym_do] = ACTIONS(4408),
    [sym_else] = ACTIONS(4408),
    [sym_enum] = ACTIONS(4408),
    [sym_export] = ACTIONS(4408),
    [sym_extern] = ACTIONS(4408),
    [sym_final] = ACTIONS(4408),
    [sym_for] = ACTIONS(4408),
    [sym_foreach] = ACTIONS(4408),
    [sym_foreach_reverse] = ACTIONS(4408),
    [sym_function] = ACTIONS(4408),
    [sym_goto] = ACTIONS(4408),
    [sym_if] = ACTIONS(4408),
    [sym_immutable] = ACTIONS(4408),
    [sym_import] = ACTIONS(4408),
    [sym_in] = ACTIONS(4408),
    [sym_inout] = ACTIONS(4408),
    [sym_interface] = ACTIONS(4408),
    [sym_invariant] = ACTIONS(4408),
    [sym_is] = ACTIONS(4408),
    [sym_mixin] = ACTIONS(4408),
    [sym_new] = ACTIONS(4408),
    [sym_nothrow] = ACTIONS(4408),
    [sym_out] = ACTIONS(4408),
    [sym_override] = ACTIONS(4408),
    [sym_package] = ACTIONS(4408),
    [sym_pragma] = ACTIONS(4408),
    [sym_private] = ACTIONS(4408),
    [sym_protected] = ACTIONS(4408),
    [sym_public] = ACTIONS(4408),
    [sym_pure] = ACTIONS(4408),
    [sym_ref] = ACTIONS(4408),
    [sym_return] = ACTIONS(4408),
    [sym_scope] = ACTIONS(4408),
    [sym_shared] = ACTIONS(4408),
    [sym_static] = ACTIONS(4408),
    [sym_struct] = ACTIONS(4408),
    [sym_switch] = ACTIONS(4408),
    [sym_synchronized] = ACTIONS(4408),
    [sym_template] = ACTIONS(4408),
    [sym_throw] = ACTIONS(4408),
    [sym_try] = ACTIONS(4408),
    [sym_typeid] = ACTIONS(4408),
    [sym_typeof] = ACTIONS(4408),
    [sym_union] = ACTIONS(4408),
    [sym_unittest] = ACTIONS(4408),
    [sym_version] = ACTIONS(4408),
    [sym_while] = ACTIONS(4408),
    [sym_with] = ACTIONS(4408),
    [sym_gshared] = ACTIONS(4408),
    [sym_traits] = ACTIONS(4408),
    [sym_vector] = ACTIONS(4408),
    [sym_void] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_r_DQUOTE] = ACTIONS(4410),
    [anon_sym_x_DQUOTE] = ACTIONS(4410),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [anon_sym_i_BQUOTE] = ACTIONS(4410),
    [anon_sym_i_DQUOTE] = ACTIONS(4410),
    [anon_sym_iq_LBRACE] = ACTIONS(4410),
    [aux_sym_char_literal_token1] = ACTIONS(4410),
    [anon_sym_SQUOTE] = ACTIONS(4408),
    [anon_sym___DATE__] = ACTIONS(4408),
    [anon_sym___FILE__] = ACTIONS(4408),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4408),
    [anon_sym___FUNCTION__] = ACTIONS(4408),
    [anon_sym___LINE__] = ACTIONS(4408),
    [anon_sym___MODULE__] = ACTIONS(4408),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4408),
    [anon_sym___TIME__] = ACTIONS(4408),
    [anon_sym___TIMESTAMP__] = ACTIONS(4408),
    [anon_sym___VENDOR__] = ACTIONS(4408),
    [anon_sym___VERSION__] = ACTIONS(4408),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4410),
    [sym_float_literal] = ACTIONS(4410),
    [sym__string] = ACTIONS(4410),
  },
  [1680] = {
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_q_LBRACE] = ACTIONS(4406),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4406),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_AT] = ACTIONS(4406),
    [sym_bool] = ACTIONS(4404),
    [sym_byte] = ACTIONS(4404),
    [sym_ubyte] = ACTIONS(4404),
    [sym_char] = ACTIONS(4404),
    [sym_short] = ACTIONS(4404),
    [sym_ushort] = ACTIONS(4404),
    [sym_int] = ACTIONS(4404),
    [sym_uint] = ACTIONS(4404),
    [sym_long] = ACTIONS(4404),
    [sym_ulong] = ACTIONS(4404),
    [sym_cent] = ACTIONS(4404),
    [sym_ucent] = ACTIONS(4404),
    [sym_wchar] = ACTIONS(4404),
    [sym_dchar] = ACTIONS(4404),
    [sym_float] = ACTIONS(4404),
    [sym_double] = ACTIONS(4404),
    [sym_real] = ACTIONS(4404),
    [sym_ifloat] = ACTIONS(4404),
    [sym_idouble] = ACTIONS(4404),
    [sym_ireal] = ACTIONS(4404),
    [sym_cfloat] = ACTIONS(4404),
    [sym_cdouble] = ACTIONS(4404),
    [sym_creal] = ACTIONS(4404),
    [sym_size_t] = ACTIONS(4404),
    [sym_ptrdiff_t] = ACTIONS(4404),
    [sym_string] = ACTIONS(4404),
    [sym_cstring] = ACTIONS(4404),
    [sym_dstring] = ACTIONS(4404),
    [sym_wstring] = ACTIONS(4404),
    [sym_noreturn] = ACTIONS(4404),
    [sym_true] = ACTIONS(4404),
    [sym_false] = ACTIONS(4404),
    [sym_null] = ACTIONS(4404),
    [sym_super] = ACTIONS(4404),
    [sym_this] = ACTIONS(4404),
    [sym_abstract] = ACTIONS(4404),
    [sym_alias] = ACTIONS(4404),
    [sym_align] = ACTIONS(4404),
    [sym_asm] = ACTIONS(4404),
    [sym_assert] = ACTIONS(4404),
    [sym_auto] = ACTIONS(4404),
    [sym_break] = ACTIONS(4404),
    [sym_case] = ACTIONS(4404),
    [sym_cast] = ACTIONS(4404),
    [sym_class] = ACTIONS(4404),
    [sym_const] = ACTIONS(4404),
    [sym_continue] = ACTIONS(4404),
    [sym_debug] = ACTIONS(4404),
    [sym_default] = ACTIONS(4404),
    [sym_delegate] = ACTIONS(4404),
    [sym_delete] = ACTIONS(4404),
    [sym_deprecated] = ACTIONS(4404),
    [sym_do] = ACTIONS(4404),
    [sym_else] = ACTIONS(4404),
    [sym_enum] = ACTIONS(4404),
    [sym_export] = ACTIONS(4404),
    [sym_extern] = ACTIONS(4404),
    [sym_final] = ACTIONS(4404),
    [sym_for] = ACTIONS(4404),
    [sym_foreach] = ACTIONS(4404),
    [sym_foreach_reverse] = ACTIONS(4404),
    [sym_function] = ACTIONS(4404),
    [sym_goto] = ACTIONS(4404),
    [sym_if] = ACTIONS(4404),
    [sym_immutable] = ACTIONS(4404),
    [sym_import] = ACTIONS(4404),
    [sym_in] = ACTIONS(4404),
    [sym_inout] = ACTIONS(4404),
    [sym_interface] = ACTIONS(4404),
    [sym_invariant] = ACTIONS(4404),
    [sym_is] = ACTIONS(4404),
    [sym_mixin] = ACTIONS(4404),
    [sym_new] = ACTIONS(4404),
    [sym_nothrow] = ACTIONS(4404),
    [sym_out] = ACTIONS(4404),
    [sym_override] = ACTIONS(4404),
    [sym_package] = ACTIONS(4404),
    [sym_pragma] = ACTIONS(4404),
    [sym_private] = ACTIONS(4404),
    [sym_protected] = ACTIONS(4404),
    [sym_public] = ACTIONS(4404),
    [sym_pure] = ACTIONS(4404),
    [sym_ref] = ACTIONS(4404),
    [sym_return] = ACTIONS(4404),
    [sym_scope] = ACTIONS(4404),
    [sym_shared] = ACTIONS(4404),
    [sym_static] = ACTIONS(4404),
    [sym_struct] = ACTIONS(4404),
    [sym_switch] = ACTIONS(4404),
    [sym_synchronized] = ACTIONS(4404),
    [sym_template] = ACTIONS(4404),
    [sym_throw] = ACTIONS(4404),
    [sym_try] = ACTIONS(4404),
    [sym_typeid] = ACTIONS(4404),
    [sym_typeof] = ACTIONS(4404),
    [sym_union] = ACTIONS(4404),
    [sym_unittest] = ACTIONS(4404),
    [sym_version] = ACTIONS(4404),
    [sym_while] = ACTIONS(4404),
    [sym_with] = ACTIONS(4404),
    [sym_gshared] = ACTIONS(4404),
    [sym_traits] = ACTIONS(4404),
    [sym_vector] = ACTIONS(4404),
    [sym_void] = ACTIONS(4404),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_r_DQUOTE] = ACTIONS(4406),
    [anon_sym_x_DQUOTE] = ACTIONS(4406),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [anon_sym_i_BQUOTE] = ACTIONS(4406),
    [anon_sym_i_DQUOTE] = ACTIONS(4406),
    [anon_sym_iq_LBRACE] = ACTIONS(4406),
    [aux_sym_char_literal_token1] = ACTIONS(4406),
    [anon_sym_SQUOTE] = ACTIONS(4404),
    [anon_sym___DATE__] = ACTIONS(4404),
    [anon_sym___FILE__] = ACTIONS(4404),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4404),
    [anon_sym___FUNCTION__] = ACTIONS(4404),
    [anon_sym___LINE__] = ACTIONS(4404),
    [anon_sym___MODULE__] = ACTIONS(4404),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4404),
    [anon_sym___TIME__] = ACTIONS(4404),
    [anon_sym___TIMESTAMP__] = ACTIONS(4404),
    [anon_sym___VENDOR__] = ACTIONS(4404),
    [anon_sym___VERSION__] = ACTIONS(4404),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4406),
    [sym_float_literal] = ACTIONS(4406),
    [sym__string] = ACTIONS(4406),
  },
  [1681] = {
    [sym_identifier] = ACTIONS(4396),
    [anon_sym_q_LBRACE] = ACTIONS(4398),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4398),
    [anon_sym_DASH] = ACTIONS(4396),
    [anon_sym_DASH_DASH] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4398),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_DOLLAR] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4398),
    [anon_sym_TILDE] = ACTIONS(4398),
    [anon_sym_AT] = ACTIONS(4398),
    [sym_bool] = ACTIONS(4396),
    [sym_byte] = ACTIONS(4396),
    [sym_ubyte] = ACTIONS(4396),
    [sym_char] = ACTIONS(4396),
    [sym_short] = ACTIONS(4396),
    [sym_ushort] = ACTIONS(4396),
    [sym_int] = ACTIONS(4396),
    [sym_uint] = ACTIONS(4396),
    [sym_long] = ACTIONS(4396),
    [sym_ulong] = ACTIONS(4396),
    [sym_cent] = ACTIONS(4396),
    [sym_ucent] = ACTIONS(4396),
    [sym_wchar] = ACTIONS(4396),
    [sym_dchar] = ACTIONS(4396),
    [sym_float] = ACTIONS(4396),
    [sym_double] = ACTIONS(4396),
    [sym_real] = ACTIONS(4396),
    [sym_ifloat] = ACTIONS(4396),
    [sym_idouble] = ACTIONS(4396),
    [sym_ireal] = ACTIONS(4396),
    [sym_cfloat] = ACTIONS(4396),
    [sym_cdouble] = ACTIONS(4396),
    [sym_creal] = ACTIONS(4396),
    [sym_size_t] = ACTIONS(4396),
    [sym_ptrdiff_t] = ACTIONS(4396),
    [sym_string] = ACTIONS(4396),
    [sym_cstring] = ACTIONS(4396),
    [sym_dstring] = ACTIONS(4396),
    [sym_wstring] = ACTIONS(4396),
    [sym_noreturn] = ACTIONS(4396),
    [sym_true] = ACTIONS(4396),
    [sym_false] = ACTIONS(4396),
    [sym_null] = ACTIONS(4396),
    [sym_super] = ACTIONS(4396),
    [sym_this] = ACTIONS(4396),
    [sym_abstract] = ACTIONS(4396),
    [sym_alias] = ACTIONS(4396),
    [sym_align] = ACTIONS(4396),
    [sym_asm] = ACTIONS(4396),
    [sym_assert] = ACTIONS(4396),
    [sym_auto] = ACTIONS(4396),
    [sym_break] = ACTIONS(4396),
    [sym_case] = ACTIONS(4396),
    [sym_cast] = ACTIONS(4396),
    [sym_class] = ACTIONS(4396),
    [sym_const] = ACTIONS(4396),
    [sym_continue] = ACTIONS(4396),
    [sym_debug] = ACTIONS(4396),
    [sym_default] = ACTIONS(4396),
    [sym_delegate] = ACTIONS(4396),
    [sym_delete] = ACTIONS(4396),
    [sym_deprecated] = ACTIONS(4396),
    [sym_do] = ACTIONS(4396),
    [sym_else] = ACTIONS(4396),
    [sym_enum] = ACTIONS(4396),
    [sym_export] = ACTIONS(4396),
    [sym_extern] = ACTIONS(4396),
    [sym_final] = ACTIONS(4396),
    [sym_for] = ACTIONS(4396),
    [sym_foreach] = ACTIONS(4396),
    [sym_foreach_reverse] = ACTIONS(4396),
    [sym_function] = ACTIONS(4396),
    [sym_goto] = ACTIONS(4396),
    [sym_if] = ACTIONS(4396),
    [sym_immutable] = ACTIONS(4396),
    [sym_import] = ACTIONS(4396),
    [sym_in] = ACTIONS(4396),
    [sym_inout] = ACTIONS(4396),
    [sym_interface] = ACTIONS(4396),
    [sym_invariant] = ACTIONS(4396),
    [sym_is] = ACTIONS(4396),
    [sym_mixin] = ACTIONS(4396),
    [sym_new] = ACTIONS(4396),
    [sym_nothrow] = ACTIONS(4396),
    [sym_out] = ACTIONS(4396),
    [sym_override] = ACTIONS(4396),
    [sym_package] = ACTIONS(4396),
    [sym_pragma] = ACTIONS(4396),
    [sym_private] = ACTIONS(4396),
    [sym_protected] = ACTIONS(4396),
    [sym_public] = ACTIONS(4396),
    [sym_pure] = ACTIONS(4396),
    [sym_ref] = ACTIONS(4396),
    [sym_return] = ACTIONS(4396),
    [sym_scope] = ACTIONS(4396),
    [sym_shared] = ACTIONS(4396),
    [sym_static] = ACTIONS(4396),
    [sym_struct] = ACTIONS(4396),
    [sym_switch] = ACTIONS(4396),
    [sym_synchronized] = ACTIONS(4396),
    [sym_template] = ACTIONS(4396),
    [sym_throw] = ACTIONS(4396),
    [sym_try] = ACTIONS(4396),
    [sym_typeid] = ACTIONS(4396),
    [sym_typeof] = ACTIONS(4396),
    [sym_union] = ACTIONS(4396),
    [sym_unittest] = ACTIONS(4396),
    [sym_version] = ACTIONS(4396),
    [sym_while] = ACTIONS(4396),
    [sym_with] = ACTIONS(4396),
    [sym_gshared] = ACTIONS(4396),
    [sym_traits] = ACTIONS(4396),
    [sym_vector] = ACTIONS(4396),
    [sym_void] = ACTIONS(4396),
    [anon_sym_BQUOTE] = ACTIONS(4398),
    [anon_sym_r_DQUOTE] = ACTIONS(4398),
    [anon_sym_x_DQUOTE] = ACTIONS(4398),
    [anon_sym_DQUOTE] = ACTIONS(4398),
    [anon_sym_i_BQUOTE] = ACTIONS(4398),
    [anon_sym_i_DQUOTE] = ACTIONS(4398),
    [anon_sym_iq_LBRACE] = ACTIONS(4398),
    [aux_sym_char_literal_token1] = ACTIONS(4398),
    [anon_sym_SQUOTE] = ACTIONS(4396),
    [anon_sym___DATE__] = ACTIONS(4396),
    [anon_sym___FILE__] = ACTIONS(4396),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4396),
    [anon_sym___FUNCTION__] = ACTIONS(4396),
    [anon_sym___LINE__] = ACTIONS(4396),
    [anon_sym___MODULE__] = ACTIONS(4396),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4396),
    [anon_sym___TIME__] = ACTIONS(4396),
    [anon_sym___TIMESTAMP__] = ACTIONS(4396),
    [anon_sym___VENDOR__] = ACTIONS(4396),
    [anon_sym___VERSION__] = ACTIONS(4396),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4398),
    [sym_float_literal] = ACTIONS(4398),
    [sym__string] = ACTIONS(4398),
  },
  [1682] = {
    [sym_identifier] = ACTIONS(4400),
    [anon_sym_q_LBRACE] = ACTIONS(4402),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_LPAREN] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_DOLLAR] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4402),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_AT] = ACTIONS(4402),
    [sym_bool] = ACTIONS(4400),
    [sym_byte] = ACTIONS(4400),
    [sym_ubyte] = ACTIONS(4400),
    [sym_char] = ACTIONS(4400),
    [sym_short] = ACTIONS(4400),
    [sym_ushort] = ACTIONS(4400),
    [sym_int] = ACTIONS(4400),
    [sym_uint] = ACTIONS(4400),
    [sym_long] = ACTIONS(4400),
    [sym_ulong] = ACTIONS(4400),
    [sym_cent] = ACTIONS(4400),
    [sym_ucent] = ACTIONS(4400),
    [sym_wchar] = ACTIONS(4400),
    [sym_dchar] = ACTIONS(4400),
    [sym_float] = ACTIONS(4400),
    [sym_double] = ACTIONS(4400),
    [sym_real] = ACTIONS(4400),
    [sym_ifloat] = ACTIONS(4400),
    [sym_idouble] = ACTIONS(4400),
    [sym_ireal] = ACTIONS(4400),
    [sym_cfloat] = ACTIONS(4400),
    [sym_cdouble] = ACTIONS(4400),
    [sym_creal] = ACTIONS(4400),
    [sym_size_t] = ACTIONS(4400),
    [sym_ptrdiff_t] = ACTIONS(4400),
    [sym_string] = ACTIONS(4400),
    [sym_cstring] = ACTIONS(4400),
    [sym_dstring] = ACTIONS(4400),
    [sym_wstring] = ACTIONS(4400),
    [sym_noreturn] = ACTIONS(4400),
    [sym_true] = ACTIONS(4400),
    [sym_false] = ACTIONS(4400),
    [sym_null] = ACTIONS(4400),
    [sym_super] = ACTIONS(4400),
    [sym_this] = ACTIONS(4400),
    [sym_abstract] = ACTIONS(4400),
    [sym_alias] = ACTIONS(4400),
    [sym_align] = ACTIONS(4400),
    [sym_asm] = ACTIONS(4400),
    [sym_assert] = ACTIONS(4400),
    [sym_auto] = ACTIONS(4400),
    [sym_break] = ACTIONS(4400),
    [sym_case] = ACTIONS(4400),
    [sym_cast] = ACTIONS(4400),
    [sym_class] = ACTIONS(4400),
    [sym_const] = ACTIONS(4400),
    [sym_continue] = ACTIONS(4400),
    [sym_debug] = ACTIONS(4400),
    [sym_default] = ACTIONS(4400),
    [sym_delegate] = ACTIONS(4400),
    [sym_delete] = ACTIONS(4400),
    [sym_deprecated] = ACTIONS(4400),
    [sym_do] = ACTIONS(4400),
    [sym_else] = ACTIONS(4400),
    [sym_enum] = ACTIONS(4400),
    [sym_export] = ACTIONS(4400),
    [sym_extern] = ACTIONS(4400),
    [sym_final] = ACTIONS(4400),
    [sym_for] = ACTIONS(4400),
    [sym_foreach] = ACTIONS(4400),
    [sym_foreach_reverse] = ACTIONS(4400),
    [sym_function] = ACTIONS(4400),
    [sym_goto] = ACTIONS(4400),
    [sym_if] = ACTIONS(4400),
    [sym_immutable] = ACTIONS(4400),
    [sym_import] = ACTIONS(4400),
    [sym_in] = ACTIONS(4400),
    [sym_inout] = ACTIONS(4400),
    [sym_interface] = ACTIONS(4400),
    [sym_invariant] = ACTIONS(4400),
    [sym_is] = ACTIONS(4400),
    [sym_mixin] = ACTIONS(4400),
    [sym_new] = ACTIONS(4400),
    [sym_nothrow] = ACTIONS(4400),
    [sym_out] = ACTIONS(4400),
    [sym_override] = ACTIONS(4400),
    [sym_package] = ACTIONS(4400),
    [sym_pragma] = ACTIONS(4400),
    [sym_private] = ACTIONS(4400),
    [sym_protected] = ACTIONS(4400),
    [sym_public] = ACTIONS(4400),
    [sym_pure] = ACTIONS(4400),
    [sym_ref] = ACTIONS(4400),
    [sym_return] = ACTIONS(4400),
    [sym_scope] = ACTIONS(4400),
    [sym_shared] = ACTIONS(4400),
    [sym_static] = ACTIONS(4400),
    [sym_struct] = ACTIONS(4400),
    [sym_switch] = ACTIONS(4400),
    [sym_synchronized] = ACTIONS(4400),
    [sym_template] = ACTIONS(4400),
    [sym_throw] = ACTIONS(4400),
    [sym_try] = ACTIONS(4400),
    [sym_typeid] = ACTIONS(4400),
    [sym_typeof] = ACTIONS(4400),
    [sym_union] = ACTIONS(4400),
    [sym_unittest] = ACTIONS(4400),
    [sym_version] = ACTIONS(4400),
    [sym_while] = ACTIONS(4400),
    [sym_with] = ACTIONS(4400),
    [sym_gshared] = ACTIONS(4400),
    [sym_traits] = ACTIONS(4400),
    [sym_vector] = ACTIONS(4400),
    [sym_void] = ACTIONS(4400),
    [anon_sym_BQUOTE] = ACTIONS(4402),
    [anon_sym_r_DQUOTE] = ACTIONS(4402),
    [anon_sym_x_DQUOTE] = ACTIONS(4402),
    [anon_sym_DQUOTE] = ACTIONS(4402),
    [anon_sym_i_BQUOTE] = ACTIONS(4402),
    [anon_sym_i_DQUOTE] = ACTIONS(4402),
    [anon_sym_iq_LBRACE] = ACTIONS(4402),
    [aux_sym_char_literal_token1] = ACTIONS(4402),
    [anon_sym_SQUOTE] = ACTIONS(4400),
    [anon_sym___DATE__] = ACTIONS(4400),
    [anon_sym___FILE__] = ACTIONS(4400),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4400),
    [anon_sym___FUNCTION__] = ACTIONS(4400),
    [anon_sym___LINE__] = ACTIONS(4400),
    [anon_sym___MODULE__] = ACTIONS(4400),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4400),
    [anon_sym___TIME__] = ACTIONS(4400),
    [anon_sym___TIMESTAMP__] = ACTIONS(4400),
    [anon_sym___VENDOR__] = ACTIONS(4400),
    [anon_sym___VERSION__] = ACTIONS(4400),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4402),
    [sym_float_literal] = ACTIONS(4402),
    [sym__string] = ACTIONS(4402),
  },
  [1683] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_q_LBRACE] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(5032),
    [anon_sym_DASH_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5034),
    [anon_sym_BANG] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5034),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_DOLLAR] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5038),
    [anon_sym_STAR] = ACTIONS(5034),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_true] = ACTIONS(5032),
    [sym_false] = ACTIONS(5032),
    [sym_null] = ACTIONS(5032),
    [sym_super] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_asm] = ACTIONS(5032),
    [sym_assert] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_break] = ACTIONS(5032),
    [sym_case] = ACTIONS(5032),
    [sym_cast] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_continue] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_default] = ACTIONS(5032),
    [sym_delegate] = ACTIONS(5032),
    [sym_delete] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_do] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_for] = ACTIONS(5032),
    [sym_foreach] = ACTIONS(5032),
    [sym_foreach_reverse] = ACTIONS(5032),
    [sym_function] = ACTIONS(5032),
    [sym_goto] = ACTIONS(5032),
    [sym_if] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_in] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_is] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_new] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_out] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_switch] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_throw] = ACTIONS(5032),
    [sym_try] = ACTIONS(5032),
    [sym_typeid] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_while] = ACTIONS(5032),
    [sym_with] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(5034),
    [anon_sym_r_DQUOTE] = ACTIONS(5034),
    [anon_sym_x_DQUOTE] = ACTIONS(5034),
    [anon_sym_DQUOTE] = ACTIONS(5034),
    [anon_sym_i_BQUOTE] = ACTIONS(5034),
    [anon_sym_i_DQUOTE] = ACTIONS(5034),
    [anon_sym_iq_LBRACE] = ACTIONS(5034),
    [aux_sym_char_literal_token1] = ACTIONS(5034),
    [anon_sym_SQUOTE] = ACTIONS(5032),
    [anon_sym___DATE__] = ACTIONS(5032),
    [anon_sym___FILE__] = ACTIONS(5032),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5032),
    [anon_sym___FUNCTION__] = ACTIONS(5032),
    [anon_sym___LINE__] = ACTIONS(5032),
    [anon_sym___MODULE__] = ACTIONS(5032),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5032),
    [anon_sym___TIME__] = ACTIONS(5032),
    [anon_sym___TIMESTAMP__] = ACTIONS(5032),
    [anon_sym___VENDOR__] = ACTIONS(5032),
    [anon_sym___VERSION__] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5034),
    [sym_float_literal] = ACTIONS(5034),
    [sym__string] = ACTIONS(5034),
  },
  [1684] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_q_LBRACE] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(5032),
    [anon_sym_DASH_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5034),
    [anon_sym_BANG] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5034),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_DOLLAR] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5040),
    [anon_sym_STAR] = ACTIONS(5034),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_true] = ACTIONS(5032),
    [sym_false] = ACTIONS(5032),
    [sym_null] = ACTIONS(5032),
    [sym_super] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_asm] = ACTIONS(5032),
    [sym_assert] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_break] = ACTIONS(5032),
    [sym_case] = ACTIONS(5032),
    [sym_cast] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_continue] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_default] = ACTIONS(5032),
    [sym_delegate] = ACTIONS(5032),
    [sym_delete] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_do] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_for] = ACTIONS(5032),
    [sym_foreach] = ACTIONS(5032),
    [sym_foreach_reverse] = ACTIONS(5032),
    [sym_function] = ACTIONS(5032),
    [sym_goto] = ACTIONS(5032),
    [sym_if] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_in] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_is] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_new] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_out] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_switch] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_throw] = ACTIONS(5032),
    [sym_try] = ACTIONS(5032),
    [sym_typeid] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_while] = ACTIONS(5032),
    [sym_with] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(5034),
    [anon_sym_r_DQUOTE] = ACTIONS(5034),
    [anon_sym_x_DQUOTE] = ACTIONS(5034),
    [anon_sym_DQUOTE] = ACTIONS(5034),
    [anon_sym_i_BQUOTE] = ACTIONS(5034),
    [anon_sym_i_DQUOTE] = ACTIONS(5034),
    [anon_sym_iq_LBRACE] = ACTIONS(5034),
    [aux_sym_char_literal_token1] = ACTIONS(5034),
    [anon_sym_SQUOTE] = ACTIONS(5032),
    [anon_sym___DATE__] = ACTIONS(5032),
    [anon_sym___FILE__] = ACTIONS(5032),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5032),
    [anon_sym___FUNCTION__] = ACTIONS(5032),
    [anon_sym___LINE__] = ACTIONS(5032),
    [anon_sym___MODULE__] = ACTIONS(5032),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5032),
    [anon_sym___TIME__] = ACTIONS(5032),
    [anon_sym___TIMESTAMP__] = ACTIONS(5032),
    [anon_sym___VENDOR__] = ACTIONS(5032),
    [anon_sym___VERSION__] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5034),
    [sym_float_literal] = ACTIONS(5034),
    [sym__string] = ACTIONS(5034),
  },
  [1685] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_q_LBRACE] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(5032),
    [anon_sym_DASH_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5034),
    [anon_sym_BANG] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5034),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_DOLLAR] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5042),
    [anon_sym_STAR] = ACTIONS(5034),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_true] = ACTIONS(5032),
    [sym_false] = ACTIONS(5032),
    [sym_null] = ACTIONS(5032),
    [sym_super] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_asm] = ACTIONS(5032),
    [sym_assert] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_break] = ACTIONS(5032),
    [sym_case] = ACTIONS(5032),
    [sym_cast] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_continue] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_default] = ACTIONS(5032),
    [sym_delegate] = ACTIONS(5032),
    [sym_delete] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_do] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_for] = ACTIONS(5032),
    [sym_foreach] = ACTIONS(5032),
    [sym_foreach_reverse] = ACTIONS(5032),
    [sym_function] = ACTIONS(5032),
    [sym_goto] = ACTIONS(5032),
    [sym_if] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_in] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_is] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_new] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_out] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_switch] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_throw] = ACTIONS(5032),
    [sym_try] = ACTIONS(5032),
    [sym_typeid] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_while] = ACTIONS(5032),
    [sym_with] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(5034),
    [anon_sym_r_DQUOTE] = ACTIONS(5034),
    [anon_sym_x_DQUOTE] = ACTIONS(5034),
    [anon_sym_DQUOTE] = ACTIONS(5034),
    [anon_sym_i_BQUOTE] = ACTIONS(5034),
    [anon_sym_i_DQUOTE] = ACTIONS(5034),
    [anon_sym_iq_LBRACE] = ACTIONS(5034),
    [aux_sym_char_literal_token1] = ACTIONS(5034),
    [anon_sym_SQUOTE] = ACTIONS(5032),
    [anon_sym___DATE__] = ACTIONS(5032),
    [anon_sym___FILE__] = ACTIONS(5032),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5032),
    [anon_sym___FUNCTION__] = ACTIONS(5032),
    [anon_sym___LINE__] = ACTIONS(5032),
    [anon_sym___MODULE__] = ACTIONS(5032),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5032),
    [anon_sym___TIME__] = ACTIONS(5032),
    [anon_sym___TIMESTAMP__] = ACTIONS(5032),
    [anon_sym___VENDOR__] = ACTIONS(5032),
    [anon_sym___VERSION__] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5034),
    [sym_float_literal] = ACTIONS(5034),
    [sym__string] = ACTIONS(5034),
  },
  [1686] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_q_LBRACE] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(5032),
    [anon_sym_DASH_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5034),
    [anon_sym_BANG] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5034),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_DOLLAR] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5044),
    [anon_sym_STAR] = ACTIONS(5034),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_true] = ACTIONS(5032),
    [sym_false] = ACTIONS(5032),
    [sym_null] = ACTIONS(5032),
    [sym_super] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_asm] = ACTIONS(5032),
    [sym_assert] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_break] = ACTIONS(5032),
    [sym_case] = ACTIONS(5032),
    [sym_cast] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_continue] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_default] = ACTIONS(5032),
    [sym_delegate] = ACTIONS(5032),
    [sym_delete] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_do] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_for] = ACTIONS(5032),
    [sym_foreach] = ACTIONS(5032),
    [sym_foreach_reverse] = ACTIONS(5032),
    [sym_function] = ACTIONS(5032),
    [sym_goto] = ACTIONS(5032),
    [sym_if] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_in] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_is] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_new] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_out] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_switch] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_throw] = ACTIONS(5032),
    [sym_try] = ACTIONS(5032),
    [sym_typeid] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_while] = ACTIONS(5032),
    [sym_with] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(5034),
    [anon_sym_r_DQUOTE] = ACTIONS(5034),
    [anon_sym_x_DQUOTE] = ACTIONS(5034),
    [anon_sym_DQUOTE] = ACTIONS(5034),
    [anon_sym_i_BQUOTE] = ACTIONS(5034),
    [anon_sym_i_DQUOTE] = ACTIONS(5034),
    [anon_sym_iq_LBRACE] = ACTIONS(5034),
    [aux_sym_char_literal_token1] = ACTIONS(5034),
    [anon_sym_SQUOTE] = ACTIONS(5032),
    [anon_sym___DATE__] = ACTIONS(5032),
    [anon_sym___FILE__] = ACTIONS(5032),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5032),
    [anon_sym___FUNCTION__] = ACTIONS(5032),
    [anon_sym___LINE__] = ACTIONS(5032),
    [anon_sym___MODULE__] = ACTIONS(5032),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5032),
    [anon_sym___TIME__] = ACTIONS(5032),
    [anon_sym___TIMESTAMP__] = ACTIONS(5032),
    [anon_sym___VENDOR__] = ACTIONS(5032),
    [anon_sym___VERSION__] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5034),
    [sym_float_literal] = ACTIONS(5034),
    [sym__string] = ACTIONS(5034),
  },
  [1687] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_q_LBRACE] = ACTIONS(5034),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_AMP] = ACTIONS(5034),
    [anon_sym_DASH] = ACTIONS(5032),
    [anon_sym_DASH_DASH] = ACTIONS(5034),
    [anon_sym_PLUS] = ACTIONS(5032),
    [anon_sym_PLUS_PLUS] = ACTIONS(5034),
    [anon_sym_BANG] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(5036),
    [anon_sym_LBRACK] = ACTIONS(5034),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_DOLLAR] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5046),
    [anon_sym_STAR] = ACTIONS(5034),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_true] = ACTIONS(5032),
    [sym_false] = ACTIONS(5032),
    [sym_null] = ACTIONS(5032),
    [sym_super] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_asm] = ACTIONS(5032),
    [sym_assert] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_break] = ACTIONS(5032),
    [sym_case] = ACTIONS(5032),
    [sym_cast] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_continue] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_default] = ACTIONS(5032),
    [sym_delegate] = ACTIONS(5032),
    [sym_delete] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_do] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_for] = ACTIONS(5032),
    [sym_foreach] = ACTIONS(5032),
    [sym_foreach_reverse] = ACTIONS(5032),
    [sym_function] = ACTIONS(5032),
    [sym_goto] = ACTIONS(5032),
    [sym_if] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_in] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_is] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_new] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_out] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_switch] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_throw] = ACTIONS(5032),
    [sym_try] = ACTIONS(5032),
    [sym_typeid] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_while] = ACTIONS(5032),
    [sym_with] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(5034),
    [anon_sym_r_DQUOTE] = ACTIONS(5034),
    [anon_sym_x_DQUOTE] = ACTIONS(5034),
    [anon_sym_DQUOTE] = ACTIONS(5034),
    [anon_sym_i_BQUOTE] = ACTIONS(5034),
    [anon_sym_i_DQUOTE] = ACTIONS(5034),
    [anon_sym_iq_LBRACE] = ACTIONS(5034),
    [aux_sym_char_literal_token1] = ACTIONS(5034),
    [anon_sym_SQUOTE] = ACTIONS(5032),
    [anon_sym___DATE__] = ACTIONS(5032),
    [anon_sym___FILE__] = ACTIONS(5032),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5032),
    [anon_sym___FUNCTION__] = ACTIONS(5032),
    [anon_sym___LINE__] = ACTIONS(5032),
    [anon_sym___MODULE__] = ACTIONS(5032),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5032),
    [anon_sym___TIME__] = ACTIONS(5032),
    [anon_sym___TIMESTAMP__] = ACTIONS(5032),
    [anon_sym___VENDOR__] = ACTIONS(5032),
    [anon_sym___VERSION__] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5034),
    [sym_float_literal] = ACTIONS(5034),
    [sym__string] = ACTIONS(5034),
  },
  [1688] = {
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_q_LBRACE] = ACTIONS(2175),
    [anon_sym_RBRACE] = ACTIONS(2175),
    [anon_sym_LBRACE] = ACTIONS(2175),
    [anon_sym_DOT] = ACTIONS(2175),
    [anon_sym_AMP] = ACTIONS(2175),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2175),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2175),
    [anon_sym_BANG] = ACTIONS(2175),
    [anon_sym_LPAREN] = ACTIONS(2175),
    [anon_sym_LBRACK] = ACTIONS(2175),
    [anon_sym_SEMI] = ACTIONS(2175),
    [anon_sym_DOLLAR] = ACTIONS(2175),
    [anon_sym_STAR] = ACTIONS(2175),
    [anon_sym_TILDE] = ACTIONS(2175),
    [anon_sym_AT] = ACTIONS(2175),
    [sym_bool] = ACTIONS(2204),
    [sym_byte] = ACTIONS(2204),
    [sym_ubyte] = ACTIONS(2204),
    [sym_char] = ACTIONS(2204),
    [sym_short] = ACTIONS(2204),
    [sym_ushort] = ACTIONS(2204),
    [sym_int] = ACTIONS(2204),
    [sym_uint] = ACTIONS(2204),
    [sym_long] = ACTIONS(2204),
    [sym_ulong] = ACTIONS(2204),
    [sym_cent] = ACTIONS(2204),
    [sym_ucent] = ACTIONS(2204),
    [sym_wchar] = ACTIONS(2204),
    [sym_dchar] = ACTIONS(2204),
    [sym_float] = ACTIONS(2204),
    [sym_double] = ACTIONS(2204),
    [sym_real] = ACTIONS(2204),
    [sym_ifloat] = ACTIONS(2204),
    [sym_idouble] = ACTIONS(2204),
    [sym_ireal] = ACTIONS(2204),
    [sym_cfloat] = ACTIONS(2204),
    [sym_cdouble] = ACTIONS(2204),
    [sym_creal] = ACTIONS(2204),
    [sym_size_t] = ACTIONS(2204),
    [sym_ptrdiff_t] = ACTIONS(2204),
    [sym_string] = ACTIONS(2204),
    [sym_cstring] = ACTIONS(2204),
    [sym_dstring] = ACTIONS(2204),
    [sym_wstring] = ACTIONS(2204),
    [sym_noreturn] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [sym_false] = ACTIONS(2204),
    [sym_null] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [sym_this] = ACTIONS(2204),
    [sym_abstract] = ACTIONS(2204),
    [sym_alias] = ACTIONS(2204),
    [sym_align] = ACTIONS(2204),
    [sym_asm] = ACTIONS(2204),
    [sym_assert] = ACTIONS(2204),
    [sym_auto] = ACTIONS(2204),
    [sym_break] = ACTIONS(2204),
    [sym_case] = ACTIONS(2204),
    [sym_cast] = ACTIONS(2204),
    [sym_class] = ACTIONS(2204),
    [sym_const] = ACTIONS(2204),
    [sym_continue] = ACTIONS(2204),
    [sym_debug] = ACTIONS(2204),
    [sym_default] = ACTIONS(2204),
    [sym_delegate] = ACTIONS(2204),
    [sym_delete] = ACTIONS(2204),
    [sym_deprecated] = ACTIONS(2204),
    [sym_do] = ACTIONS(2204),
    [sym_enum] = ACTIONS(2204),
    [sym_export] = ACTIONS(2204),
    [sym_extern] = ACTIONS(2204),
    [sym_final] = ACTIONS(2204),
    [sym_for] = ACTIONS(2204),
    [sym_foreach] = ACTIONS(2204),
    [sym_foreach_reverse] = ACTIONS(2204),
    [sym_function] = ACTIONS(2204),
    [sym_goto] = ACTIONS(2204),
    [sym_if] = ACTIONS(2204),
    [sym_immutable] = ACTIONS(2204),
    [sym_import] = ACTIONS(2204),
    [sym_in] = ACTIONS(2204),
    [sym_inout] = ACTIONS(2204),
    [sym_interface] = ACTIONS(2204),
    [sym_invariant] = ACTIONS(2204),
    [sym_is] = ACTIONS(2204),
    [sym_mixin] = ACTIONS(2204),
    [sym_new] = ACTIONS(2204),
    [sym_nothrow] = ACTIONS(2204),
    [sym_out] = ACTIONS(2204),
    [sym_override] = ACTIONS(2204),
    [sym_package] = ACTIONS(2204),
    [sym_pragma] = ACTIONS(2204),
    [sym_private] = ACTIONS(2204),
    [sym_protected] = ACTIONS(2204),
    [sym_public] = ACTIONS(2204),
    [sym_pure] = ACTIONS(2204),
    [sym_ref] = ACTIONS(2204),
    [sym_return] = ACTIONS(2204),
    [sym_scope] = ACTIONS(2204),
    [sym_shared] = ACTIONS(2204),
    [sym_static] = ACTIONS(2204),
    [sym_struct] = ACTIONS(2204),
    [sym_switch] = ACTIONS(2204),
    [sym_synchronized] = ACTIONS(2204),
    [sym_template] = ACTIONS(2204),
    [sym_throw] = ACTIONS(2204),
    [sym_try] = ACTIONS(2204),
    [sym_typeid] = ACTIONS(2204),
    [sym_typeof] = ACTIONS(2204),
    [sym_union] = ACTIONS(2204),
    [sym_unittest] = ACTIONS(2204),
    [sym_version] = ACTIONS(2204),
    [sym_while] = ACTIONS(2204),
    [sym_with] = ACTIONS(2204),
    [sym_gshared] = ACTIONS(2204),
    [sym_traits] = ACTIONS(2204),
    [sym_vector] = ACTIONS(2204),
    [sym_void] = ACTIONS(2204),
    [anon_sym_BQUOTE] = ACTIONS(2175),
    [anon_sym_r_DQUOTE] = ACTIONS(2175),
    [anon_sym_x_DQUOTE] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2175),
    [anon_sym_i_BQUOTE] = ACTIONS(2175),
    [anon_sym_i_DQUOTE] = ACTIONS(2175),
    [anon_sym_iq_LBRACE] = ACTIONS(2175),
    [aux_sym_char_literal_token1] = ACTIONS(2175),
    [anon_sym_SQUOTE] = ACTIONS(2204),
    [anon_sym___DATE__] = ACTIONS(2204),
    [anon_sym___FILE__] = ACTIONS(2204),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2204),
    [anon_sym___FUNCTION__] = ACTIONS(2204),
    [anon_sym___LINE__] = ACTIONS(2204),
    [anon_sym___MODULE__] = ACTIONS(2204),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2204),
    [anon_sym___TIME__] = ACTIONS(2204),
    [anon_sym___TIMESTAMP__] = ACTIONS(2204),
    [anon_sym___VENDOR__] = ACTIONS(2204),
    [anon_sym___VERSION__] = ACTIONS(2204),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2175),
    [sym_float_literal] = ACTIONS(2175),
    [sym__string] = ACTIONS(2175),
  },
  [1689] = {
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_q_LBRACE] = ACTIONS(5050),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_AMP] = ACTIONS(5050),
    [anon_sym_DASH] = ACTIONS(5048),
    [anon_sym_DASH_DASH] = ACTIONS(5050),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_PLUS_PLUS] = ACTIONS(5050),
    [anon_sym_BANG] = ACTIONS(5050),
    [anon_sym_LPAREN] = ACTIONS(5050),
    [anon_sym_LBRACK] = ACTIONS(5050),
    [anon_sym_SEMI] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5050),
    [anon_sym_DOLLAR] = ACTIONS(5050),
    [anon_sym_STAR] = ACTIONS(5050),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_AT] = ACTIONS(5050),
    [sym_bool] = ACTIONS(5048),
    [sym_byte] = ACTIONS(5048),
    [sym_ubyte] = ACTIONS(5048),
    [sym_char] = ACTIONS(5048),
    [sym_short] = ACTIONS(5048),
    [sym_ushort] = ACTIONS(5048),
    [sym_int] = ACTIONS(5048),
    [sym_uint] = ACTIONS(5048),
    [sym_long] = ACTIONS(5048),
    [sym_ulong] = ACTIONS(5048),
    [sym_cent] = ACTIONS(5048),
    [sym_ucent] = ACTIONS(5048),
    [sym_wchar] = ACTIONS(5048),
    [sym_dchar] = ACTIONS(5048),
    [sym_float] = ACTIONS(5048),
    [sym_double] = ACTIONS(5048),
    [sym_real] = ACTIONS(5048),
    [sym_ifloat] = ACTIONS(5048),
    [sym_idouble] = ACTIONS(5048),
    [sym_ireal] = ACTIONS(5048),
    [sym_cfloat] = ACTIONS(5048),
    [sym_cdouble] = ACTIONS(5048),
    [sym_creal] = ACTIONS(5048),
    [sym_size_t] = ACTIONS(5048),
    [sym_ptrdiff_t] = ACTIONS(5048),
    [sym_string] = ACTIONS(5048),
    [sym_cstring] = ACTIONS(5048),
    [sym_dstring] = ACTIONS(5048),
    [sym_wstring] = ACTIONS(5048),
    [sym_noreturn] = ACTIONS(5048),
    [sym_true] = ACTIONS(5048),
    [sym_false] = ACTIONS(5048),
    [sym_null] = ACTIONS(5048),
    [sym_super] = ACTIONS(5048),
    [sym_this] = ACTIONS(5048),
    [sym_abstract] = ACTIONS(5048),
    [sym_alias] = ACTIONS(5048),
    [sym_align] = ACTIONS(5048),
    [sym_asm] = ACTIONS(5048),
    [sym_assert] = ACTIONS(5048),
    [sym_auto] = ACTIONS(5048),
    [sym_break] = ACTIONS(5048),
    [sym_case] = ACTIONS(5048),
    [sym_cast] = ACTIONS(5048),
    [sym_class] = ACTIONS(5048),
    [sym_const] = ACTIONS(5048),
    [sym_continue] = ACTIONS(5048),
    [sym_debug] = ACTIONS(5048),
    [sym_default] = ACTIONS(5048),
    [sym_delegate] = ACTIONS(5048),
    [sym_delete] = ACTIONS(5048),
    [sym_deprecated] = ACTIONS(5048),
    [sym_do] = ACTIONS(5048),
    [sym_enum] = ACTIONS(5048),
    [sym_export] = ACTIONS(5048),
    [sym_extern] = ACTIONS(5048),
    [sym_final] = ACTIONS(5048),
    [sym_for] = ACTIONS(5048),
    [sym_foreach] = ACTIONS(5048),
    [sym_foreach_reverse] = ACTIONS(5048),
    [sym_function] = ACTIONS(5048),
    [sym_goto] = ACTIONS(5048),
    [sym_if] = ACTIONS(5048),
    [sym_immutable] = ACTIONS(5048),
    [sym_import] = ACTIONS(5048),
    [sym_in] = ACTIONS(5048),
    [sym_inout] = ACTIONS(5048),
    [sym_interface] = ACTIONS(5048),
    [sym_invariant] = ACTIONS(5048),
    [sym_is] = ACTIONS(5048),
    [sym_mixin] = ACTIONS(5048),
    [sym_new] = ACTIONS(5048),
    [sym_nothrow] = ACTIONS(5048),
    [sym_out] = ACTIONS(5048),
    [sym_override] = ACTIONS(5048),
    [sym_package] = ACTIONS(5048),
    [sym_pragma] = ACTIONS(5048),
    [sym_private] = ACTIONS(5048),
    [sym_protected] = ACTIONS(5048),
    [sym_public] = ACTIONS(5048),
    [sym_pure] = ACTIONS(5048),
    [sym_ref] = ACTIONS(5048),
    [sym_return] = ACTIONS(5048),
    [sym_scope] = ACTIONS(5048),
    [sym_shared] = ACTIONS(5048),
    [sym_static] = ACTIONS(5048),
    [sym_struct] = ACTIONS(5048),
    [sym_switch] = ACTIONS(5048),
    [sym_synchronized] = ACTIONS(5048),
    [sym_template] = ACTIONS(5048),
    [sym_throw] = ACTIONS(5048),
    [sym_try] = ACTIONS(5048),
    [sym_typeid] = ACTIONS(5048),
    [sym_typeof] = ACTIONS(5048),
    [sym_union] = ACTIONS(5048),
    [sym_unittest] = ACTIONS(5048),
    [sym_version] = ACTIONS(5048),
    [sym_while] = ACTIONS(5048),
    [sym_with] = ACTIONS(5048),
    [sym_gshared] = ACTIONS(5048),
    [sym_traits] = ACTIONS(5048),
    [sym_vector] = ACTIONS(5048),
    [sym_void] = ACTIONS(5048),
    [anon_sym_BQUOTE] = ACTIONS(5050),
    [anon_sym_r_DQUOTE] = ACTIONS(5050),
    [anon_sym_x_DQUOTE] = ACTIONS(5050),
    [anon_sym_DQUOTE] = ACTIONS(5050),
    [anon_sym_i_BQUOTE] = ACTIONS(5050),
    [anon_sym_i_DQUOTE] = ACTIONS(5050),
    [anon_sym_iq_LBRACE] = ACTIONS(5050),
    [aux_sym_char_literal_token1] = ACTIONS(5050),
    [anon_sym_SQUOTE] = ACTIONS(5048),
    [anon_sym___DATE__] = ACTIONS(5048),
    [anon_sym___FILE__] = ACTIONS(5048),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5048),
    [anon_sym___FUNCTION__] = ACTIONS(5048),
    [anon_sym___LINE__] = ACTIONS(5048),
    [anon_sym___MODULE__] = ACTIONS(5048),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5048),
    [anon_sym___TIME__] = ACTIONS(5048),
    [anon_sym___TIMESTAMP__] = ACTIONS(5048),
    [anon_sym___VENDOR__] = ACTIONS(5048),
    [anon_sym___VERSION__] = ACTIONS(5048),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5050),
    [sym_float_literal] = ACTIONS(5050),
    [sym__string] = ACTIONS(5050),
  },
  [1690] = {
    [sym_identifier] = ACTIONS(5052),
    [anon_sym_q_LBRACE] = ACTIONS(5055),
    [anon_sym_RBRACE] = ACTIONS(5057),
    [anon_sym_LBRACE] = ACTIONS(5055),
    [anon_sym_DOT] = ACTIONS(5057),
    [anon_sym_AMP] = ACTIONS(5055),
    [anon_sym_DASH] = ACTIONS(5060),
    [anon_sym_DASH_DASH] = ACTIONS(5055),
    [anon_sym_PLUS] = ACTIONS(5060),
    [anon_sym_PLUS_PLUS] = ACTIONS(5055),
    [anon_sym_BANG] = ACTIONS(5055),
    [anon_sym_LPAREN] = ACTIONS(5055),
    [anon_sym_LBRACK] = ACTIONS(5055),
    [anon_sym_SEMI] = ACTIONS(5057),
    [anon_sym_DOLLAR] = ACTIONS(5055),
    [anon_sym_STAR] = ACTIONS(5055),
    [anon_sym_TILDE] = ACTIONS(5057),
    [anon_sym_AT] = ACTIONS(5057),
    [sym_bool] = ACTIONS(5052),
    [sym_byte] = ACTIONS(5052),
    [sym_ubyte] = ACTIONS(5052),
    [sym_char] = ACTIONS(5052),
    [sym_short] = ACTIONS(5052),
    [sym_ushort] = ACTIONS(5052),
    [sym_int] = ACTIONS(5052),
    [sym_uint] = ACTIONS(5052),
    [sym_long] = ACTIONS(5052),
    [sym_ulong] = ACTIONS(5052),
    [sym_cent] = ACTIONS(5052),
    [sym_ucent] = ACTIONS(5052),
    [sym_wchar] = ACTIONS(5052),
    [sym_dchar] = ACTIONS(5052),
    [sym_float] = ACTIONS(5052),
    [sym_double] = ACTIONS(5052),
    [sym_real] = ACTIONS(5052),
    [sym_ifloat] = ACTIONS(5052),
    [sym_idouble] = ACTIONS(5052),
    [sym_ireal] = ACTIONS(5052),
    [sym_cfloat] = ACTIONS(5052),
    [sym_cdouble] = ACTIONS(5052),
    [sym_creal] = ACTIONS(5052),
    [sym_size_t] = ACTIONS(5052),
    [sym_ptrdiff_t] = ACTIONS(5052),
    [sym_string] = ACTIONS(5052),
    [sym_cstring] = ACTIONS(5052),
    [sym_dstring] = ACTIONS(5052),
    [sym_wstring] = ACTIONS(5052),
    [sym_noreturn] = ACTIONS(5052),
    [sym_true] = ACTIONS(5060),
    [sym_false] = ACTIONS(5060),
    [sym_null] = ACTIONS(5060),
    [sym_super] = ACTIONS(5060),
    [sym_this] = ACTIONS(5052),
    [sym_abstract] = ACTIONS(5052),
    [sym_alias] = ACTIONS(5052),
    [sym_align] = ACTIONS(5052),
    [sym_asm] = ACTIONS(5060),
    [sym_assert] = ACTIONS(5060),
    [sym_auto] = ACTIONS(5052),
    [sym_break] = ACTIONS(5060),
    [sym_case] = ACTIONS(5060),
    [sym_cast] = ACTIONS(5060),
    [sym_class] = ACTIONS(5052),
    [sym_const] = ACTIONS(5052),
    [sym_continue] = ACTIONS(5060),
    [sym_debug] = ACTIONS(5052),
    [sym_default] = ACTIONS(5060),
    [sym_delegate] = ACTIONS(5060),
    [sym_delete] = ACTIONS(5060),
    [sym_deprecated] = ACTIONS(5052),
    [sym_do] = ACTIONS(5060),
    [sym_enum] = ACTIONS(5052),
    [sym_export] = ACTIONS(5052),
    [sym_extern] = ACTIONS(5052),
    [sym_final] = ACTIONS(5052),
    [sym_for] = ACTIONS(5060),
    [sym_foreach] = ACTIONS(5060),
    [sym_foreach_reverse] = ACTIONS(5060),
    [sym_function] = ACTIONS(5060),
    [sym_goto] = ACTIONS(5060),
    [sym_if] = ACTIONS(5060),
    [sym_immutable] = ACTIONS(5052),
    [sym_import] = ACTIONS(5052),
    [sym_in] = ACTIONS(5060),
    [sym_inout] = ACTIONS(5052),
    [sym_interface] = ACTIONS(5052),
    [sym_invariant] = ACTIONS(5052),
    [sym_is] = ACTIONS(5060),
    [sym_mixin] = ACTIONS(5052),
    [sym_new] = ACTIONS(5060),
    [sym_nothrow] = ACTIONS(5052),
    [sym_out] = ACTIONS(5060),
    [sym_override] = ACTIONS(5052),
    [sym_package] = ACTIONS(5052),
    [sym_pragma] = ACTIONS(5052),
    [sym_private] = ACTIONS(5052),
    [sym_protected] = ACTIONS(5052),
    [sym_public] = ACTIONS(5052),
    [sym_pure] = ACTIONS(5052),
    [sym_ref] = ACTIONS(5052),
    [sym_return] = ACTIONS(5052),
    [sym_scope] = ACTIONS(5052),
    [sym_shared] = ACTIONS(5052),
    [sym_static] = ACTIONS(5052),
    [sym_struct] = ACTIONS(5052),
    [sym_switch] = ACTIONS(5060),
    [sym_synchronized] = ACTIONS(5052),
    [sym_template] = ACTIONS(5052),
    [sym_throw] = ACTIONS(5060),
    [sym_try] = ACTIONS(5060),
    [sym_typeid] = ACTIONS(5060),
    [sym_typeof] = ACTIONS(5052),
    [sym_union] = ACTIONS(5052),
    [sym_unittest] = ACTIONS(5052),
    [sym_version] = ACTIONS(5052),
    [sym_while] = ACTIONS(5060),
    [sym_with] = ACTIONS(5060),
    [sym_gshared] = ACTIONS(5052),
    [sym_traits] = ACTIONS(5052),
    [sym_vector] = ACTIONS(5052),
    [sym_void] = ACTIONS(5052),
    [anon_sym_BQUOTE] = ACTIONS(5055),
    [anon_sym_r_DQUOTE] = ACTIONS(5055),
    [anon_sym_x_DQUOTE] = ACTIONS(5055),
    [anon_sym_DQUOTE] = ACTIONS(5055),
    [anon_sym_i_BQUOTE] = ACTIONS(5055),
    [anon_sym_i_DQUOTE] = ACTIONS(5055),
    [anon_sym_iq_LBRACE] = ACTIONS(5055),
    [aux_sym_char_literal_token1] = ACTIONS(5055),
    [anon_sym_SQUOTE] = ACTIONS(5060),
    [anon_sym___DATE__] = ACTIONS(5060),
    [anon_sym___FILE__] = ACTIONS(5060),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5060),
    [anon_sym___FUNCTION__] = ACTIONS(5060),
    [anon_sym___LINE__] = ACTIONS(5060),
    [anon_sym___MODULE__] = ACTIONS(5060),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5060),
    [anon_sym___TIME__] = ACTIONS(5060),
    [anon_sym___TIMESTAMP__] = ACTIONS(5060),
    [anon_sym___VENDOR__] = ACTIONS(5060),
    [anon_sym___VERSION__] = ACTIONS(5060),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5055),
    [sym_float_literal] = ACTIONS(5055),
    [sym__string] = ACTIONS(5055),
  },
  [1691] = {
    [sym_identifier] = ACTIONS(5062),
    [anon_sym_q_LBRACE] = ACTIONS(5064),
    [anon_sym_LBRACE] = ACTIONS(5064),
    [anon_sym_DOT] = ACTIONS(5064),
    [anon_sym_AMP] = ACTIONS(5064),
    [anon_sym_DASH] = ACTIONS(5062),
    [anon_sym_DASH_DASH] = ACTIONS(5064),
    [anon_sym_PLUS] = ACTIONS(5062),
    [anon_sym_PLUS_PLUS] = ACTIONS(5064),
    [anon_sym_BANG] = ACTIONS(5064),
    [anon_sym_LPAREN] = ACTIONS(5064),
    [anon_sym_LBRACK] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(5064),
    [anon_sym_COLON] = ACTIONS(5064),
    [anon_sym_DOLLAR] = ACTIONS(5064),
    [anon_sym_STAR] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [anon_sym_AT] = ACTIONS(5064),
    [sym_bool] = ACTIONS(5062),
    [sym_byte] = ACTIONS(5062),
    [sym_ubyte] = ACTIONS(5062),
    [sym_char] = ACTIONS(5062),
    [sym_short] = ACTIONS(5062),
    [sym_ushort] = ACTIONS(5062),
    [sym_int] = ACTIONS(5062),
    [sym_uint] = ACTIONS(5062),
    [sym_long] = ACTIONS(5062),
    [sym_ulong] = ACTIONS(5062),
    [sym_cent] = ACTIONS(5062),
    [sym_ucent] = ACTIONS(5062),
    [sym_wchar] = ACTIONS(5062),
    [sym_dchar] = ACTIONS(5062),
    [sym_float] = ACTIONS(5062),
    [sym_double] = ACTIONS(5062),
    [sym_real] = ACTIONS(5062),
    [sym_ifloat] = ACTIONS(5062),
    [sym_idouble] = ACTIONS(5062),
    [sym_ireal] = ACTIONS(5062),
    [sym_cfloat] = ACTIONS(5062),
    [sym_cdouble] = ACTIONS(5062),
    [sym_creal] = ACTIONS(5062),
    [sym_size_t] = ACTIONS(5062),
    [sym_ptrdiff_t] = ACTIONS(5062),
    [sym_string] = ACTIONS(5062),
    [sym_cstring] = ACTIONS(5062),
    [sym_dstring] = ACTIONS(5062),
    [sym_wstring] = ACTIONS(5062),
    [sym_noreturn] = ACTIONS(5062),
    [sym_true] = ACTIONS(5062),
    [sym_false] = ACTIONS(5062),
    [sym_null] = ACTIONS(5062),
    [sym_super] = ACTIONS(5062),
    [sym_this] = ACTIONS(5062),
    [sym_abstract] = ACTIONS(5062),
    [sym_alias] = ACTIONS(5062),
    [sym_align] = ACTIONS(5062),
    [sym_asm] = ACTIONS(5062),
    [sym_assert] = ACTIONS(5062),
    [sym_auto] = ACTIONS(5062),
    [sym_break] = ACTIONS(5062),
    [sym_case] = ACTIONS(5062),
    [sym_cast] = ACTIONS(5062),
    [sym_class] = ACTIONS(5062),
    [sym_const] = ACTIONS(5062),
    [sym_continue] = ACTIONS(5062),
    [sym_debug] = ACTIONS(5062),
    [sym_default] = ACTIONS(5062),
    [sym_delegate] = ACTIONS(5062),
    [sym_delete] = ACTIONS(5062),
    [sym_deprecated] = ACTIONS(5062),
    [sym_do] = ACTIONS(5062),
    [sym_enum] = ACTIONS(5062),
    [sym_export] = ACTIONS(5062),
    [sym_extern] = ACTIONS(5062),
    [sym_final] = ACTIONS(5062),
    [sym_for] = ACTIONS(5062),
    [sym_foreach] = ACTIONS(5062),
    [sym_foreach_reverse] = ACTIONS(5062),
    [sym_function] = ACTIONS(5062),
    [sym_goto] = ACTIONS(5062),
    [sym_if] = ACTIONS(5062),
    [sym_immutable] = ACTIONS(5062),
    [sym_import] = ACTIONS(5062),
    [sym_in] = ACTIONS(5062),
    [sym_inout] = ACTIONS(5062),
    [sym_interface] = ACTIONS(5062),
    [sym_invariant] = ACTIONS(5062),
    [sym_is] = ACTIONS(5062),
    [sym_mixin] = ACTIONS(5062),
    [sym_new] = ACTIONS(5062),
    [sym_nothrow] = ACTIONS(5062),
    [sym_out] = ACTIONS(5062),
    [sym_override] = ACTIONS(5062),
    [sym_package] = ACTIONS(5062),
    [sym_pragma] = ACTIONS(5062),
    [sym_private] = ACTIONS(5062),
    [sym_protected] = ACTIONS(5062),
    [sym_public] = ACTIONS(5062),
    [sym_pure] = ACTIONS(5062),
    [sym_ref] = ACTIONS(5062),
    [sym_return] = ACTIONS(5062),
    [sym_scope] = ACTIONS(5062),
    [sym_shared] = ACTIONS(5062),
    [sym_static] = ACTIONS(5062),
    [sym_struct] = ACTIONS(5062),
    [sym_switch] = ACTIONS(5062),
    [sym_synchronized] = ACTIONS(5062),
    [sym_template] = ACTIONS(5062),
    [sym_throw] = ACTIONS(5062),
    [sym_try] = ACTIONS(5062),
    [sym_typeid] = ACTIONS(5062),
    [sym_typeof] = ACTIONS(5062),
    [sym_union] = ACTIONS(5062),
    [sym_unittest] = ACTIONS(5062),
    [sym_version] = ACTIONS(5062),
    [sym_while] = ACTIONS(5062),
    [sym_with] = ACTIONS(5062),
    [sym_gshared] = ACTIONS(5062),
    [sym_traits] = ACTIONS(5062),
    [sym_vector] = ACTIONS(5062),
    [sym_void] = ACTIONS(5062),
    [anon_sym_BQUOTE] = ACTIONS(5064),
    [anon_sym_r_DQUOTE] = ACTIONS(5064),
    [anon_sym_x_DQUOTE] = ACTIONS(5064),
    [anon_sym_DQUOTE] = ACTIONS(5064),
    [anon_sym_i_BQUOTE] = ACTIONS(5064),
    [anon_sym_i_DQUOTE] = ACTIONS(5064),
    [anon_sym_iq_LBRACE] = ACTIONS(5064),
    [aux_sym_char_literal_token1] = ACTIONS(5064),
    [anon_sym_SQUOTE] = ACTIONS(5062),
    [anon_sym___DATE__] = ACTIONS(5062),
    [anon_sym___FILE__] = ACTIONS(5062),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5062),
    [anon_sym___FUNCTION__] = ACTIONS(5062),
    [anon_sym___LINE__] = ACTIONS(5062),
    [anon_sym___MODULE__] = ACTIONS(5062),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5062),
    [anon_sym___TIME__] = ACTIONS(5062),
    [anon_sym___TIMESTAMP__] = ACTIONS(5062),
    [anon_sym___VENDOR__] = ACTIONS(5062),
    [anon_sym___VERSION__] = ACTIONS(5062),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5064),
    [sym_float_literal] = ACTIONS(5064),
    [sym__string] = ACTIONS(5064),
  },
  [1692] = {
    [sym_identifier] = ACTIONS(5066),
    [anon_sym_q_LBRACE] = ACTIONS(5068),
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_DOT] = ACTIONS(5068),
    [anon_sym_AMP] = ACTIONS(5068),
    [anon_sym_DASH] = ACTIONS(5066),
    [anon_sym_DASH_DASH] = ACTIONS(5068),
    [anon_sym_PLUS] = ACTIONS(5066),
    [anon_sym_PLUS_PLUS] = ACTIONS(5068),
    [anon_sym_BANG] = ACTIONS(5068),
    [anon_sym_LPAREN] = ACTIONS(5068),
    [anon_sym_LBRACK] = ACTIONS(5068),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_DOLLAR] = ACTIONS(5068),
    [anon_sym_STAR] = ACTIONS(5068),
    [anon_sym_TILDE] = ACTIONS(5068),
    [anon_sym_AT] = ACTIONS(5068),
    [sym_bool] = ACTIONS(5066),
    [sym_byte] = ACTIONS(5066),
    [sym_ubyte] = ACTIONS(5066),
    [sym_char] = ACTIONS(5066),
    [sym_short] = ACTIONS(5066),
    [sym_ushort] = ACTIONS(5066),
    [sym_int] = ACTIONS(5066),
    [sym_uint] = ACTIONS(5066),
    [sym_long] = ACTIONS(5066),
    [sym_ulong] = ACTIONS(5066),
    [sym_cent] = ACTIONS(5066),
    [sym_ucent] = ACTIONS(5066),
    [sym_wchar] = ACTIONS(5066),
    [sym_dchar] = ACTIONS(5066),
    [sym_float] = ACTIONS(5066),
    [sym_double] = ACTIONS(5066),
    [sym_real] = ACTIONS(5066),
    [sym_ifloat] = ACTIONS(5066),
    [sym_idouble] = ACTIONS(5066),
    [sym_ireal] = ACTIONS(5066),
    [sym_cfloat] = ACTIONS(5066),
    [sym_cdouble] = ACTIONS(5066),
    [sym_creal] = ACTIONS(5066),
    [sym_size_t] = ACTIONS(5066),
    [sym_ptrdiff_t] = ACTIONS(5066),
    [sym_string] = ACTIONS(5066),
    [sym_cstring] = ACTIONS(5066),
    [sym_dstring] = ACTIONS(5066),
    [sym_wstring] = ACTIONS(5066),
    [sym_noreturn] = ACTIONS(5066),
    [sym_true] = ACTIONS(5066),
    [sym_false] = ACTIONS(5066),
    [sym_null] = ACTIONS(5066),
    [sym_super] = ACTIONS(5066),
    [sym_this] = ACTIONS(5066),
    [sym_abstract] = ACTIONS(5066),
    [sym_alias] = ACTIONS(5066),
    [sym_align] = ACTIONS(5066),
    [sym_asm] = ACTIONS(5066),
    [sym_assert] = ACTIONS(5066),
    [sym_auto] = ACTIONS(5066),
    [sym_break] = ACTIONS(5066),
    [sym_case] = ACTIONS(5066),
    [sym_cast] = ACTIONS(5066),
    [sym_class] = ACTIONS(5066),
    [sym_const] = ACTIONS(5066),
    [sym_continue] = ACTIONS(5066),
    [sym_debug] = ACTIONS(5066),
    [sym_default] = ACTIONS(5066),
    [sym_delegate] = ACTIONS(5066),
    [sym_delete] = ACTIONS(5066),
    [sym_deprecated] = ACTIONS(5066),
    [sym_do] = ACTIONS(5066),
    [sym_enum] = ACTIONS(5066),
    [sym_export] = ACTIONS(5066),
    [sym_extern] = ACTIONS(5066),
    [sym_final] = ACTIONS(5066),
    [sym_for] = ACTIONS(5066),
    [sym_foreach] = ACTIONS(5066),
    [sym_foreach_reverse] = ACTIONS(5066),
    [sym_function] = ACTIONS(5066),
    [sym_goto] = ACTIONS(5066),
    [sym_if] = ACTIONS(5066),
    [sym_immutable] = ACTIONS(5066),
    [sym_import] = ACTIONS(5066),
    [sym_in] = ACTIONS(5066),
    [sym_inout] = ACTIONS(5066),
    [sym_interface] = ACTIONS(5066),
    [sym_invariant] = ACTIONS(5066),
    [sym_is] = ACTIONS(5066),
    [sym_mixin] = ACTIONS(5066),
    [sym_new] = ACTIONS(5066),
    [sym_nothrow] = ACTIONS(5066),
    [sym_out] = ACTIONS(5066),
    [sym_override] = ACTIONS(5066),
    [sym_package] = ACTIONS(5066),
    [sym_pragma] = ACTIONS(5066),
    [sym_private] = ACTIONS(5066),
    [sym_protected] = ACTIONS(5066),
    [sym_public] = ACTIONS(5066),
    [sym_pure] = ACTIONS(5066),
    [sym_ref] = ACTIONS(5066),
    [sym_return] = ACTIONS(5066),
    [sym_scope] = ACTIONS(5066),
    [sym_shared] = ACTIONS(5066),
    [sym_static] = ACTIONS(5066),
    [sym_struct] = ACTIONS(5066),
    [sym_switch] = ACTIONS(5066),
    [sym_synchronized] = ACTIONS(5066),
    [sym_template] = ACTIONS(5066),
    [sym_throw] = ACTIONS(5066),
    [sym_try] = ACTIONS(5066),
    [sym_typeid] = ACTIONS(5066),
    [sym_typeof] = ACTIONS(5066),
    [sym_union] = ACTIONS(5066),
    [sym_unittest] = ACTIONS(5066),
    [sym_version] = ACTIONS(5066),
    [sym_while] = ACTIONS(5066),
    [sym_with] = ACTIONS(5066),
    [sym_gshared] = ACTIONS(5066),
    [sym_traits] = ACTIONS(5066),
    [sym_vector] = ACTIONS(5066),
    [sym_void] = ACTIONS(5066),
    [anon_sym_BQUOTE] = ACTIONS(5068),
    [anon_sym_r_DQUOTE] = ACTIONS(5068),
    [anon_sym_x_DQUOTE] = ACTIONS(5068),
    [anon_sym_DQUOTE] = ACTIONS(5068),
    [anon_sym_i_BQUOTE] = ACTIONS(5068),
    [anon_sym_i_DQUOTE] = ACTIONS(5068),
    [anon_sym_iq_LBRACE] = ACTIONS(5068),
    [aux_sym_char_literal_token1] = ACTIONS(5068),
    [anon_sym_SQUOTE] = ACTIONS(5066),
    [anon_sym___DATE__] = ACTIONS(5066),
    [anon_sym___FILE__] = ACTIONS(5066),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5066),
    [anon_sym___FUNCTION__] = ACTIONS(5066),
    [anon_sym___LINE__] = ACTIONS(5066),
    [anon_sym___MODULE__] = ACTIONS(5066),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5066),
    [anon_sym___TIME__] = ACTIONS(5066),
    [anon_sym___TIMESTAMP__] = ACTIONS(5066),
    [anon_sym___VENDOR__] = ACTIONS(5066),
    [anon_sym___VERSION__] = ACTIONS(5066),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5068),
    [sym_float_literal] = ACTIONS(5068),
    [sym__string] = ACTIONS(5068),
  },
  [1693] = {
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_q_LBRACE] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5072),
    [anon_sym_AMP] = ACTIONS(5072),
    [anon_sym_DASH] = ACTIONS(5070),
    [anon_sym_DASH_DASH] = ACTIONS(5072),
    [anon_sym_PLUS] = ACTIONS(5070),
    [anon_sym_PLUS_PLUS] = ACTIONS(5072),
    [anon_sym_BANG] = ACTIONS(5072),
    [anon_sym_LPAREN] = ACTIONS(5072),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym_COLON] = ACTIONS(5072),
    [anon_sym_DOLLAR] = ACTIONS(5072),
    [anon_sym_STAR] = ACTIONS(5072),
    [anon_sym_TILDE] = ACTIONS(5072),
    [anon_sym_AT] = ACTIONS(5072),
    [sym_bool] = ACTIONS(5070),
    [sym_byte] = ACTIONS(5070),
    [sym_ubyte] = ACTIONS(5070),
    [sym_char] = ACTIONS(5070),
    [sym_short] = ACTIONS(5070),
    [sym_ushort] = ACTIONS(5070),
    [sym_int] = ACTIONS(5070),
    [sym_uint] = ACTIONS(5070),
    [sym_long] = ACTIONS(5070),
    [sym_ulong] = ACTIONS(5070),
    [sym_cent] = ACTIONS(5070),
    [sym_ucent] = ACTIONS(5070),
    [sym_wchar] = ACTIONS(5070),
    [sym_dchar] = ACTIONS(5070),
    [sym_float] = ACTIONS(5070),
    [sym_double] = ACTIONS(5070),
    [sym_real] = ACTIONS(5070),
    [sym_ifloat] = ACTIONS(5070),
    [sym_idouble] = ACTIONS(5070),
    [sym_ireal] = ACTIONS(5070),
    [sym_cfloat] = ACTIONS(5070),
    [sym_cdouble] = ACTIONS(5070),
    [sym_creal] = ACTIONS(5070),
    [sym_size_t] = ACTIONS(5070),
    [sym_ptrdiff_t] = ACTIONS(5070),
    [sym_string] = ACTIONS(5070),
    [sym_cstring] = ACTIONS(5070),
    [sym_dstring] = ACTIONS(5070),
    [sym_wstring] = ACTIONS(5070),
    [sym_noreturn] = ACTIONS(5070),
    [sym_true] = ACTIONS(5070),
    [sym_false] = ACTIONS(5070),
    [sym_null] = ACTIONS(5070),
    [sym_super] = ACTIONS(5070),
    [sym_this] = ACTIONS(5070),
    [sym_abstract] = ACTIONS(5070),
    [sym_alias] = ACTIONS(5070),
    [sym_align] = ACTIONS(5070),
    [sym_asm] = ACTIONS(5070),
    [sym_assert] = ACTIONS(5070),
    [sym_auto] = ACTIONS(5070),
    [sym_break] = ACTIONS(5070),
    [sym_case] = ACTIONS(5070),
    [sym_cast] = ACTIONS(5070),
    [sym_class] = ACTIONS(5070),
    [sym_const] = ACTIONS(5070),
    [sym_continue] = ACTIONS(5070),
    [sym_debug] = ACTIONS(5070),
    [sym_default] = ACTIONS(5070),
    [sym_delegate] = ACTIONS(5070),
    [sym_delete] = ACTIONS(5070),
    [sym_deprecated] = ACTIONS(5070),
    [sym_do] = ACTIONS(5070),
    [sym_enum] = ACTIONS(5070),
    [sym_export] = ACTIONS(5070),
    [sym_extern] = ACTIONS(5070),
    [sym_final] = ACTIONS(5070),
    [sym_for] = ACTIONS(5070),
    [sym_foreach] = ACTIONS(5070),
    [sym_foreach_reverse] = ACTIONS(5070),
    [sym_function] = ACTIONS(5070),
    [sym_goto] = ACTIONS(5070),
    [sym_if] = ACTIONS(5070),
    [sym_immutable] = ACTIONS(5070),
    [sym_import] = ACTIONS(5070),
    [sym_in] = ACTIONS(5070),
    [sym_inout] = ACTIONS(5070),
    [sym_interface] = ACTIONS(5070),
    [sym_invariant] = ACTIONS(5070),
    [sym_is] = ACTIONS(5070),
    [sym_mixin] = ACTIONS(5070),
    [sym_new] = ACTIONS(5070),
    [sym_nothrow] = ACTIONS(5070),
    [sym_out] = ACTIONS(5070),
    [sym_override] = ACTIONS(5070),
    [sym_package] = ACTIONS(5070),
    [sym_pragma] = ACTIONS(5070),
    [sym_private] = ACTIONS(5070),
    [sym_protected] = ACTIONS(5070),
    [sym_public] = ACTIONS(5070),
    [sym_pure] = ACTIONS(5070),
    [sym_ref] = ACTIONS(5070),
    [sym_return] = ACTIONS(5070),
    [sym_scope] = ACTIONS(5070),
    [sym_shared] = ACTIONS(5070),
    [sym_static] = ACTIONS(5070),
    [sym_struct] = ACTIONS(5070),
    [sym_switch] = ACTIONS(5070),
    [sym_synchronized] = ACTIONS(5070),
    [sym_template] = ACTIONS(5070),
    [sym_throw] = ACTIONS(5070),
    [sym_try] = ACTIONS(5070),
    [sym_typeid] = ACTIONS(5070),
    [sym_typeof] = ACTIONS(5070),
    [sym_union] = ACTIONS(5070),
    [sym_unittest] = ACTIONS(5070),
    [sym_version] = ACTIONS(5070),
    [sym_while] = ACTIONS(5070),
    [sym_with] = ACTIONS(5070),
    [sym_gshared] = ACTIONS(5070),
    [sym_traits] = ACTIONS(5070),
    [sym_vector] = ACTIONS(5070),
    [sym_void] = ACTIONS(5070),
    [anon_sym_BQUOTE] = ACTIONS(5072),
    [anon_sym_r_DQUOTE] = ACTIONS(5072),
    [anon_sym_x_DQUOTE] = ACTIONS(5072),
    [anon_sym_DQUOTE] = ACTIONS(5072),
    [anon_sym_i_BQUOTE] = ACTIONS(5072),
    [anon_sym_i_DQUOTE] = ACTIONS(5072),
    [anon_sym_iq_LBRACE] = ACTIONS(5072),
    [aux_sym_char_literal_token1] = ACTIONS(5072),
    [anon_sym_SQUOTE] = ACTIONS(5070),
    [anon_sym___DATE__] = ACTIONS(5070),
    [anon_sym___FILE__] = ACTIONS(5070),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5070),
    [anon_sym___FUNCTION__] = ACTIONS(5070),
    [anon_sym___LINE__] = ACTIONS(5070),
    [anon_sym___MODULE__] = ACTIONS(5070),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5070),
    [anon_sym___TIME__] = ACTIONS(5070),
    [anon_sym___TIMESTAMP__] = ACTIONS(5070),
    [anon_sym___VENDOR__] = ACTIONS(5070),
    [anon_sym___VERSION__] = ACTIONS(5070),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5072),
    [sym_float_literal] = ACTIONS(5072),
    [sym__string] = ACTIONS(5072),
  },
  [1694] = {
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_q_LBRACE] = ACTIONS(5076),
    [anon_sym_LBRACE] = ACTIONS(5076),
    [anon_sym_DOT] = ACTIONS(5076),
    [anon_sym_AMP] = ACTIONS(5076),
    [anon_sym_DASH] = ACTIONS(5074),
    [anon_sym_DASH_DASH] = ACTIONS(5076),
    [anon_sym_PLUS] = ACTIONS(5074),
    [anon_sym_PLUS_PLUS] = ACTIONS(5076),
    [anon_sym_BANG] = ACTIONS(5076),
    [anon_sym_LPAREN] = ACTIONS(5076),
    [anon_sym_LBRACK] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym_COLON] = ACTIONS(5076),
    [anon_sym_DOLLAR] = ACTIONS(5076),
    [anon_sym_STAR] = ACTIONS(5076),
    [anon_sym_TILDE] = ACTIONS(5076),
    [anon_sym_AT] = ACTIONS(5076),
    [sym_bool] = ACTIONS(5074),
    [sym_byte] = ACTIONS(5074),
    [sym_ubyte] = ACTIONS(5074),
    [sym_char] = ACTIONS(5074),
    [sym_short] = ACTIONS(5074),
    [sym_ushort] = ACTIONS(5074),
    [sym_int] = ACTIONS(5074),
    [sym_uint] = ACTIONS(5074),
    [sym_long] = ACTIONS(5074),
    [sym_ulong] = ACTIONS(5074),
    [sym_cent] = ACTIONS(5074),
    [sym_ucent] = ACTIONS(5074),
    [sym_wchar] = ACTIONS(5074),
    [sym_dchar] = ACTIONS(5074),
    [sym_float] = ACTIONS(5074),
    [sym_double] = ACTIONS(5074),
    [sym_real] = ACTIONS(5074),
    [sym_ifloat] = ACTIONS(5074),
    [sym_idouble] = ACTIONS(5074),
    [sym_ireal] = ACTIONS(5074),
    [sym_cfloat] = ACTIONS(5074),
    [sym_cdouble] = ACTIONS(5074),
    [sym_creal] = ACTIONS(5074),
    [sym_size_t] = ACTIONS(5074),
    [sym_ptrdiff_t] = ACTIONS(5074),
    [sym_string] = ACTIONS(5074),
    [sym_cstring] = ACTIONS(5074),
    [sym_dstring] = ACTIONS(5074),
    [sym_wstring] = ACTIONS(5074),
    [sym_noreturn] = ACTIONS(5074),
    [sym_true] = ACTIONS(5074),
    [sym_false] = ACTIONS(5074),
    [sym_null] = ACTIONS(5074),
    [sym_super] = ACTIONS(5074),
    [sym_this] = ACTIONS(5074),
    [sym_abstract] = ACTIONS(5074),
    [sym_alias] = ACTIONS(5074),
    [sym_align] = ACTIONS(5074),
    [sym_asm] = ACTIONS(5074),
    [sym_assert] = ACTIONS(5074),
    [sym_auto] = ACTIONS(5074),
    [sym_break] = ACTIONS(5074),
    [sym_case] = ACTIONS(5074),
    [sym_cast] = ACTIONS(5074),
    [sym_class] = ACTIONS(5074),
    [sym_const] = ACTIONS(5074),
    [sym_continue] = ACTIONS(5074),
    [sym_debug] = ACTIONS(5074),
    [sym_default] = ACTIONS(5074),
    [sym_delegate] = ACTIONS(5074),
    [sym_delete] = ACTIONS(5074),
    [sym_deprecated] = ACTIONS(5074),
    [sym_do] = ACTIONS(5074),
    [sym_enum] = ACTIONS(5074),
    [sym_export] = ACTIONS(5074),
    [sym_extern] = ACTIONS(5074),
    [sym_final] = ACTIONS(5074),
    [sym_for] = ACTIONS(5074),
    [sym_foreach] = ACTIONS(5074),
    [sym_foreach_reverse] = ACTIONS(5074),
    [sym_function] = ACTIONS(5074),
    [sym_goto] = ACTIONS(5074),
    [sym_if] = ACTIONS(5074),
    [sym_immutable] = ACTIONS(5074),
    [sym_import] = ACTIONS(5074),
    [sym_in] = ACTIONS(5074),
    [sym_inout] = ACTIONS(5074),
    [sym_interface] = ACTIONS(5074),
    [sym_invariant] = ACTIONS(5074),
    [sym_is] = ACTIONS(5074),
    [sym_mixin] = ACTIONS(5074),
    [sym_new] = ACTIONS(5074),
    [sym_nothrow] = ACTIONS(5074),
    [sym_out] = ACTIONS(5074),
    [sym_override] = ACTIONS(5074),
    [sym_package] = ACTIONS(5074),
    [sym_pragma] = ACTIONS(5074),
    [sym_private] = ACTIONS(5074),
    [sym_protected] = ACTIONS(5074),
    [sym_public] = ACTIONS(5074),
    [sym_pure] = ACTIONS(5074),
    [sym_ref] = ACTIONS(5074),
    [sym_return] = ACTIONS(5074),
    [sym_scope] = ACTIONS(5074),
    [sym_shared] = ACTIONS(5074),
    [sym_static] = ACTIONS(5074),
    [sym_struct] = ACTIONS(5074),
    [sym_switch] = ACTIONS(5074),
    [sym_synchronized] = ACTIONS(5074),
    [sym_template] = ACTIONS(5074),
    [sym_throw] = ACTIONS(5074),
    [sym_try] = ACTIONS(5074),
    [sym_typeid] = ACTIONS(5074),
    [sym_typeof] = ACTIONS(5074),
    [sym_union] = ACTIONS(5074),
    [sym_unittest] = ACTIONS(5074),
    [sym_version] = ACTIONS(5074),
    [sym_while] = ACTIONS(5074),
    [sym_with] = ACTIONS(5074),
    [sym_gshared] = ACTIONS(5074),
    [sym_traits] = ACTIONS(5074),
    [sym_vector] = ACTIONS(5074),
    [sym_void] = ACTIONS(5074),
    [anon_sym_BQUOTE] = ACTIONS(5076),
    [anon_sym_r_DQUOTE] = ACTIONS(5076),
    [anon_sym_x_DQUOTE] = ACTIONS(5076),
    [anon_sym_DQUOTE] = ACTIONS(5076),
    [anon_sym_i_BQUOTE] = ACTIONS(5076),
    [anon_sym_i_DQUOTE] = ACTIONS(5076),
    [anon_sym_iq_LBRACE] = ACTIONS(5076),
    [aux_sym_char_literal_token1] = ACTIONS(5076),
    [anon_sym_SQUOTE] = ACTIONS(5074),
    [anon_sym___DATE__] = ACTIONS(5074),
    [anon_sym___FILE__] = ACTIONS(5074),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5074),
    [anon_sym___FUNCTION__] = ACTIONS(5074),
    [anon_sym___LINE__] = ACTIONS(5074),
    [anon_sym___MODULE__] = ACTIONS(5074),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5074),
    [anon_sym___TIME__] = ACTIONS(5074),
    [anon_sym___TIMESTAMP__] = ACTIONS(5074),
    [anon_sym___VENDOR__] = ACTIONS(5074),
    [anon_sym___VERSION__] = ACTIONS(5074),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5076),
    [sym_float_literal] = ACTIONS(5076),
    [sym__string] = ACTIONS(5076),
  },
  [1695] = {
    [sym_identifier] = ACTIONS(5078),
    [anon_sym_q_LBRACE] = ACTIONS(5080),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_AMP] = ACTIONS(5080),
    [anon_sym_DASH] = ACTIONS(5078),
    [anon_sym_DASH_DASH] = ACTIONS(5080),
    [anon_sym_PLUS] = ACTIONS(5078),
    [anon_sym_PLUS_PLUS] = ACTIONS(5080),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_LPAREN] = ACTIONS(5080),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_COLON] = ACTIONS(5080),
    [anon_sym_DOLLAR] = ACTIONS(5080),
    [anon_sym_STAR] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5080),
    [anon_sym_AT] = ACTIONS(5080),
    [sym_bool] = ACTIONS(5078),
    [sym_byte] = ACTIONS(5078),
    [sym_ubyte] = ACTIONS(5078),
    [sym_char] = ACTIONS(5078),
    [sym_short] = ACTIONS(5078),
    [sym_ushort] = ACTIONS(5078),
    [sym_int] = ACTIONS(5078),
    [sym_uint] = ACTIONS(5078),
    [sym_long] = ACTIONS(5078),
    [sym_ulong] = ACTIONS(5078),
    [sym_cent] = ACTIONS(5078),
    [sym_ucent] = ACTIONS(5078),
    [sym_wchar] = ACTIONS(5078),
    [sym_dchar] = ACTIONS(5078),
    [sym_float] = ACTIONS(5078),
    [sym_double] = ACTIONS(5078),
    [sym_real] = ACTIONS(5078),
    [sym_ifloat] = ACTIONS(5078),
    [sym_idouble] = ACTIONS(5078),
    [sym_ireal] = ACTIONS(5078),
    [sym_cfloat] = ACTIONS(5078),
    [sym_cdouble] = ACTIONS(5078),
    [sym_creal] = ACTIONS(5078),
    [sym_size_t] = ACTIONS(5078),
    [sym_ptrdiff_t] = ACTIONS(5078),
    [sym_string] = ACTIONS(5078),
    [sym_cstring] = ACTIONS(5078),
    [sym_dstring] = ACTIONS(5078),
    [sym_wstring] = ACTIONS(5078),
    [sym_noreturn] = ACTIONS(5078),
    [sym_true] = ACTIONS(5078),
    [sym_false] = ACTIONS(5078),
    [sym_null] = ACTIONS(5078),
    [sym_super] = ACTIONS(5078),
    [sym_this] = ACTIONS(5078),
    [sym_abstract] = ACTIONS(5078),
    [sym_alias] = ACTIONS(5078),
    [sym_align] = ACTIONS(5078),
    [sym_asm] = ACTIONS(5078),
    [sym_assert] = ACTIONS(5078),
    [sym_auto] = ACTIONS(5078),
    [sym_break] = ACTIONS(5078),
    [sym_case] = ACTIONS(5078),
    [sym_cast] = ACTIONS(5078),
    [sym_class] = ACTIONS(5078),
    [sym_const] = ACTIONS(5078),
    [sym_continue] = ACTIONS(5078),
    [sym_debug] = ACTIONS(5078),
    [sym_default] = ACTIONS(5078),
    [sym_delegate] = ACTIONS(5078),
    [sym_delete] = ACTIONS(5078),
    [sym_deprecated] = ACTIONS(5078),
    [sym_do] = ACTIONS(5078),
    [sym_enum] = ACTIONS(5078),
    [sym_export] = ACTIONS(5078),
    [sym_extern] = ACTIONS(5078),
    [sym_final] = ACTIONS(5078),
    [sym_for] = ACTIONS(5078),
    [sym_foreach] = ACTIONS(5078),
    [sym_foreach_reverse] = ACTIONS(5078),
    [sym_function] = ACTIONS(5078),
    [sym_goto] = ACTIONS(5078),
    [sym_if] = ACTIONS(5078),
    [sym_immutable] = ACTIONS(5078),
    [sym_import] = ACTIONS(5078),
    [sym_in] = ACTIONS(5078),
    [sym_inout] = ACTIONS(5078),
    [sym_interface] = ACTIONS(5078),
    [sym_invariant] = ACTIONS(5078),
    [sym_is] = ACTIONS(5078),
    [sym_mixin] = ACTIONS(5078),
    [sym_new] = ACTIONS(5078),
    [sym_nothrow] = ACTIONS(5078),
    [sym_out] = ACTIONS(5078),
    [sym_override] = ACTIONS(5078),
    [sym_package] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(5078),
    [sym_private] = ACTIONS(5078),
    [sym_protected] = ACTIONS(5078),
    [sym_public] = ACTIONS(5078),
    [sym_pure] = ACTIONS(5078),
    [sym_ref] = ACTIONS(5078),
    [sym_return] = ACTIONS(5078),
    [sym_scope] = ACTIONS(5078),
    [sym_shared] = ACTIONS(5078),
    [sym_static] = ACTIONS(5078),
    [sym_struct] = ACTIONS(5078),
    [sym_switch] = ACTIONS(5078),
    [sym_synchronized] = ACTIONS(5078),
    [sym_template] = ACTIONS(5078),
    [sym_throw] = ACTIONS(5078),
    [sym_try] = ACTIONS(5078),
    [sym_typeid] = ACTIONS(5078),
    [sym_typeof] = ACTIONS(5078),
    [sym_union] = ACTIONS(5078),
    [sym_unittest] = ACTIONS(5078),
    [sym_version] = ACTIONS(5078),
    [sym_while] = ACTIONS(5078),
    [sym_with] = ACTIONS(5078),
    [sym_gshared] = ACTIONS(5078),
    [sym_traits] = ACTIONS(5078),
    [sym_vector] = ACTIONS(5078),
    [sym_void] = ACTIONS(5078),
    [anon_sym_BQUOTE] = ACTIONS(5080),
    [anon_sym_r_DQUOTE] = ACTIONS(5080),
    [anon_sym_x_DQUOTE] = ACTIONS(5080),
    [anon_sym_DQUOTE] = ACTIONS(5080),
    [anon_sym_i_BQUOTE] = ACTIONS(5080),
    [anon_sym_i_DQUOTE] = ACTIONS(5080),
    [anon_sym_iq_LBRACE] = ACTIONS(5080),
    [aux_sym_char_literal_token1] = ACTIONS(5080),
    [anon_sym_SQUOTE] = ACTIONS(5078),
    [anon_sym___DATE__] = ACTIONS(5078),
    [anon_sym___FILE__] = ACTIONS(5078),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5078),
    [anon_sym___FUNCTION__] = ACTIONS(5078),
    [anon_sym___LINE__] = ACTIONS(5078),
    [anon_sym___MODULE__] = ACTIONS(5078),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5078),
    [anon_sym___TIME__] = ACTIONS(5078),
    [anon_sym___TIMESTAMP__] = ACTIONS(5078),
    [anon_sym___VENDOR__] = ACTIONS(5078),
    [anon_sym___VERSION__] = ACTIONS(5078),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5080),
    [sym_float_literal] = ACTIONS(5080),
    [sym__string] = ACTIONS(5080),
  },
  [1696] = {
    [sym_identifier] = ACTIONS(5082),
    [anon_sym_q_LBRACE] = ACTIONS(5084),
    [anon_sym_LBRACE] = ACTIONS(5084),
    [anon_sym_DOT] = ACTIONS(5084),
    [anon_sym_AMP] = ACTIONS(5084),
    [anon_sym_DASH] = ACTIONS(5082),
    [anon_sym_DASH_DASH] = ACTIONS(5084),
    [anon_sym_PLUS] = ACTIONS(5082),
    [anon_sym_PLUS_PLUS] = ACTIONS(5084),
    [anon_sym_BANG] = ACTIONS(5084),
    [anon_sym_LPAREN] = ACTIONS(5084),
    [anon_sym_LBRACK] = ACTIONS(5084),
    [anon_sym_SEMI] = ACTIONS(5084),
    [anon_sym_DOLLAR] = ACTIONS(5084),
    [anon_sym_STAR] = ACTIONS(5084),
    [anon_sym_TILDE] = ACTIONS(5084),
    [anon_sym_AT] = ACTIONS(5084),
    [sym_bool] = ACTIONS(5082),
    [sym_byte] = ACTIONS(5082),
    [sym_ubyte] = ACTIONS(5082),
    [sym_char] = ACTIONS(5082),
    [sym_short] = ACTIONS(5082),
    [sym_ushort] = ACTIONS(5082),
    [sym_int] = ACTIONS(5082),
    [sym_uint] = ACTIONS(5082),
    [sym_long] = ACTIONS(5082),
    [sym_ulong] = ACTIONS(5082),
    [sym_cent] = ACTIONS(5082),
    [sym_ucent] = ACTIONS(5082),
    [sym_wchar] = ACTIONS(5082),
    [sym_dchar] = ACTIONS(5082),
    [sym_float] = ACTIONS(5082),
    [sym_double] = ACTIONS(5082),
    [sym_real] = ACTIONS(5082),
    [sym_ifloat] = ACTIONS(5082),
    [sym_idouble] = ACTIONS(5082),
    [sym_ireal] = ACTIONS(5082),
    [sym_cfloat] = ACTIONS(5082),
    [sym_cdouble] = ACTIONS(5082),
    [sym_creal] = ACTIONS(5082),
    [sym_size_t] = ACTIONS(5082),
    [sym_ptrdiff_t] = ACTIONS(5082),
    [sym_string] = ACTIONS(5082),
    [sym_cstring] = ACTIONS(5082),
    [sym_dstring] = ACTIONS(5082),
    [sym_wstring] = ACTIONS(5082),
    [sym_noreturn] = ACTIONS(5082),
    [sym_true] = ACTIONS(5082),
    [sym_false] = ACTIONS(5082),
    [sym_null] = ACTIONS(5082),
    [sym_super] = ACTIONS(5082),
    [sym_this] = ACTIONS(5082),
    [sym_abstract] = ACTIONS(5082),
    [sym_alias] = ACTIONS(5082),
    [sym_align] = ACTIONS(5082),
    [sym_asm] = ACTIONS(5082),
    [sym_assert] = ACTIONS(5082),
    [sym_auto] = ACTIONS(5082),
    [sym_break] = ACTIONS(5082),
    [sym_case] = ACTIONS(5082),
    [sym_cast] = ACTIONS(5082),
    [sym_class] = ACTIONS(5082),
    [sym_const] = ACTIONS(5082),
    [sym_continue] = ACTIONS(5082),
    [sym_debug] = ACTIONS(5082),
    [sym_default] = ACTIONS(5082),
    [sym_delegate] = ACTIONS(5082),
    [sym_delete] = ACTIONS(5082),
    [sym_deprecated] = ACTIONS(5082),
    [sym_do] = ACTIONS(5082),
    [sym_enum] = ACTIONS(5082),
    [sym_export] = ACTIONS(5082),
    [sym_extern] = ACTIONS(5082),
    [sym_final] = ACTIONS(5082),
    [sym_for] = ACTIONS(5082),
    [sym_foreach] = ACTIONS(5082),
    [sym_foreach_reverse] = ACTIONS(5082),
    [sym_function] = ACTIONS(5082),
    [sym_goto] = ACTIONS(5082),
    [sym_if] = ACTIONS(5082),
    [sym_immutable] = ACTIONS(5082),
    [sym_import] = ACTIONS(5082),
    [sym_in] = ACTIONS(5082),
    [sym_inout] = ACTIONS(5082),
    [sym_interface] = ACTIONS(5082),
    [sym_invariant] = ACTIONS(5082),
    [sym_is] = ACTIONS(5082),
    [sym_mixin] = ACTIONS(5082),
    [sym_new] = ACTIONS(5082),
    [sym_nothrow] = ACTIONS(5082),
    [sym_out] = ACTIONS(5082),
    [sym_override] = ACTIONS(5082),
    [sym_package] = ACTIONS(5082),
    [sym_pragma] = ACTIONS(5082),
    [sym_private] = ACTIONS(5082),
    [sym_protected] = ACTIONS(5082),
    [sym_public] = ACTIONS(5082),
    [sym_pure] = ACTIONS(5082),
    [sym_ref] = ACTIONS(5082),
    [sym_return] = ACTIONS(5082),
    [sym_scope] = ACTIONS(5082),
    [sym_shared] = ACTIONS(5082),
    [sym_static] = ACTIONS(5082),
    [sym_struct] = ACTIONS(5082),
    [sym_switch] = ACTIONS(5082),
    [sym_synchronized] = ACTIONS(5082),
    [sym_template] = ACTIONS(5082),
    [sym_throw] = ACTIONS(5082),
    [sym_try] = ACTIONS(5082),
    [sym_typeid] = ACTIONS(5082),
    [sym_typeof] = ACTIONS(5082),
    [sym_union] = ACTIONS(5082),
    [sym_unittest] = ACTIONS(5082),
    [sym_version] = ACTIONS(5082),
    [sym_while] = ACTIONS(5082),
    [sym_with] = ACTIONS(5082),
    [sym_gshared] = ACTIONS(5082),
    [sym_traits] = ACTIONS(5082),
    [sym_vector] = ACTIONS(5082),
    [sym_void] = ACTIONS(5082),
    [anon_sym_BQUOTE] = ACTIONS(5084),
    [anon_sym_r_DQUOTE] = ACTIONS(5084),
    [anon_sym_x_DQUOTE] = ACTIONS(5084),
    [anon_sym_DQUOTE] = ACTIONS(5084),
    [anon_sym_i_BQUOTE] = ACTIONS(5084),
    [anon_sym_i_DQUOTE] = ACTIONS(5084),
    [anon_sym_iq_LBRACE] = ACTIONS(5084),
    [aux_sym_char_literal_token1] = ACTIONS(5084),
    [anon_sym_SQUOTE] = ACTIONS(5082),
    [anon_sym___DATE__] = ACTIONS(5082),
    [anon_sym___FILE__] = ACTIONS(5082),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5082),
    [anon_sym___FUNCTION__] = ACTIONS(5082),
    [anon_sym___LINE__] = ACTIONS(5082),
    [anon_sym___MODULE__] = ACTIONS(5082),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5082),
    [anon_sym___TIME__] = ACTIONS(5082),
    [anon_sym___TIMESTAMP__] = ACTIONS(5082),
    [anon_sym___VENDOR__] = ACTIONS(5082),
    [anon_sym___VERSION__] = ACTIONS(5082),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5084),
    [sym_float_literal] = ACTIONS(5084),
    [sym__string] = ACTIONS(5084),
  },
  [1697] = {
    [sym_identifier] = ACTIONS(5086),
    [anon_sym_q_LBRACE] = ACTIONS(5088),
    [anon_sym_LBRACE] = ACTIONS(5088),
    [anon_sym_DOT] = ACTIONS(5088),
    [anon_sym_AMP] = ACTIONS(5088),
    [anon_sym_DASH] = ACTIONS(5086),
    [anon_sym_DASH_DASH] = ACTIONS(5088),
    [anon_sym_PLUS] = ACTIONS(5086),
    [anon_sym_PLUS_PLUS] = ACTIONS(5088),
    [anon_sym_BANG] = ACTIONS(5088),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [anon_sym_LBRACK] = ACTIONS(5088),
    [anon_sym_SEMI] = ACTIONS(5088),
    [anon_sym_DOLLAR] = ACTIONS(5088),
    [anon_sym_STAR] = ACTIONS(5088),
    [anon_sym_TILDE] = ACTIONS(5088),
    [anon_sym_AT] = ACTIONS(5088),
    [sym_bool] = ACTIONS(5086),
    [sym_byte] = ACTIONS(5086),
    [sym_ubyte] = ACTIONS(5086),
    [sym_char] = ACTIONS(5086),
    [sym_short] = ACTIONS(5086),
    [sym_ushort] = ACTIONS(5086),
    [sym_int] = ACTIONS(5086),
    [sym_uint] = ACTIONS(5086),
    [sym_long] = ACTIONS(5086),
    [sym_ulong] = ACTIONS(5086),
    [sym_cent] = ACTIONS(5086),
    [sym_ucent] = ACTIONS(5086),
    [sym_wchar] = ACTIONS(5086),
    [sym_dchar] = ACTIONS(5086),
    [sym_float] = ACTIONS(5086),
    [sym_double] = ACTIONS(5086),
    [sym_real] = ACTIONS(5086),
    [sym_ifloat] = ACTIONS(5086),
    [sym_idouble] = ACTIONS(5086),
    [sym_ireal] = ACTIONS(5086),
    [sym_cfloat] = ACTIONS(5086),
    [sym_cdouble] = ACTIONS(5086),
    [sym_creal] = ACTIONS(5086),
    [sym_size_t] = ACTIONS(5086),
    [sym_ptrdiff_t] = ACTIONS(5086),
    [sym_string] = ACTIONS(5086),
    [sym_cstring] = ACTIONS(5086),
    [sym_dstring] = ACTIONS(5086),
    [sym_wstring] = ACTIONS(5086),
    [sym_noreturn] = ACTIONS(5086),
    [sym_true] = ACTIONS(5086),
    [sym_false] = ACTIONS(5086),
    [sym_null] = ACTIONS(5086),
    [sym_super] = ACTIONS(5086),
    [sym_this] = ACTIONS(5086),
    [sym_abstract] = ACTIONS(5086),
    [sym_alias] = ACTIONS(5086),
    [sym_align] = ACTIONS(5086),
    [sym_asm] = ACTIONS(5086),
    [sym_assert] = ACTIONS(5086),
    [sym_auto] = ACTIONS(5086),
    [sym_break] = ACTIONS(5086),
    [sym_case] = ACTIONS(5086),
    [sym_cast] = ACTIONS(5086),
    [sym_class] = ACTIONS(5086),
    [sym_const] = ACTIONS(5086),
    [sym_continue] = ACTIONS(5086),
    [sym_debug] = ACTIONS(5086),
    [sym_default] = ACTIONS(5086),
    [sym_delegate] = ACTIONS(5086),
    [sym_delete] = ACTIONS(5086),
    [sym_deprecated] = ACTIONS(5086),
    [sym_do] = ACTIONS(5086),
    [sym_enum] = ACTIONS(5086),
    [sym_export] = ACTIONS(5086),
    [sym_extern] = ACTIONS(5086),
    [sym_final] = ACTIONS(5086),
    [sym_for] = ACTIONS(5086),
    [sym_foreach] = ACTIONS(5086),
    [sym_foreach_reverse] = ACTIONS(5086),
    [sym_function] = ACTIONS(5086),
    [sym_goto] = ACTIONS(5086),
    [sym_if] = ACTIONS(5086),
    [sym_immutable] = ACTIONS(5086),
    [sym_import] = ACTIONS(5086),
    [sym_in] = ACTIONS(5086),
    [sym_inout] = ACTIONS(5086),
    [sym_interface] = ACTIONS(5086),
    [sym_invariant] = ACTIONS(5086),
    [sym_is] = ACTIONS(5086),
    [sym_mixin] = ACTIONS(5086),
    [sym_new] = ACTIONS(5086),
    [sym_nothrow] = ACTIONS(5086),
    [sym_out] = ACTIONS(5086),
    [sym_override] = ACTIONS(5086),
    [sym_package] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(5086),
    [sym_private] = ACTIONS(5086),
    [sym_protected] = ACTIONS(5086),
    [sym_public] = ACTIONS(5086),
    [sym_pure] = ACTIONS(5086),
    [sym_ref] = ACTIONS(5086),
    [sym_return] = ACTIONS(5086),
    [sym_scope] = ACTIONS(5086),
    [sym_shared] = ACTIONS(5086),
    [sym_static] = ACTIONS(5086),
    [sym_struct] = ACTIONS(5086),
    [sym_switch] = ACTIONS(5086),
    [sym_synchronized] = ACTIONS(5086),
    [sym_template] = ACTIONS(5086),
    [sym_throw] = ACTIONS(5086),
    [sym_try] = ACTIONS(5086),
    [sym_typeid] = ACTIONS(5086),
    [sym_typeof] = ACTIONS(5086),
    [sym_union] = ACTIONS(5086),
    [sym_unittest] = ACTIONS(5086),
    [sym_version] = ACTIONS(5086),
    [sym_while] = ACTIONS(5086),
    [sym_with] = ACTIONS(5086),
    [sym_gshared] = ACTIONS(5086),
    [sym_traits] = ACTIONS(5086),
    [sym_vector] = ACTIONS(5086),
    [sym_void] = ACTIONS(5086),
    [anon_sym_BQUOTE] = ACTIONS(5088),
    [anon_sym_r_DQUOTE] = ACTIONS(5088),
    [anon_sym_x_DQUOTE] = ACTIONS(5088),
    [anon_sym_DQUOTE] = ACTIONS(5088),
    [anon_sym_i_BQUOTE] = ACTIONS(5088),
    [anon_sym_i_DQUOTE] = ACTIONS(5088),
    [anon_sym_iq_LBRACE] = ACTIONS(5088),
    [aux_sym_char_literal_token1] = ACTIONS(5088),
    [anon_sym_SQUOTE] = ACTIONS(5086),
    [anon_sym___DATE__] = ACTIONS(5086),
    [anon_sym___FILE__] = ACTIONS(5086),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5086),
    [anon_sym___FUNCTION__] = ACTIONS(5086),
    [anon_sym___LINE__] = ACTIONS(5086),
    [anon_sym___MODULE__] = ACTIONS(5086),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5086),
    [anon_sym___TIME__] = ACTIONS(5086),
    [anon_sym___TIMESTAMP__] = ACTIONS(5086),
    [anon_sym___VENDOR__] = ACTIONS(5086),
    [anon_sym___VERSION__] = ACTIONS(5086),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5088),
    [sym_float_literal] = ACTIONS(5088),
    [sym__string] = ACTIONS(5088),
  },
  [1698] = {
    [sym_module_def] = STATE(6412),
    [sym_module_declaration] = STATE(1872),
    [sym_import_declaration] = STATE(1876),
    [sym_mixin_declaration] = STATE(1876),
    [sym__declaration] = STATE(1876),
    [sym__declaration2] = STATE(1876),
    [sym_variable_declaration] = STATE(1876),
    [sym_manifest_constant] = STATE(1876),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1876),
    [sym_alias_declaration] = STATE(1876),
    [sym_alias_reassign] = STATE(1876),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1876),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2206),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2451),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1876),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1876),
    [sym_union_declaration] = STATE(1876),
    [sym_postblit] = STATE(1876),
    [sym_invariant_declaration] = STATE(1876),
    [sym_class_declaration] = STATE(1876),
    [sym_constructor] = STATE(1876),
    [sym_destructor] = STATE(1876),
    [sym_alias_this] = STATE(1876),
    [sym_interface_declaration] = STATE(1876),
    [sym_enum_declaration] = STATE(1876),
    [sym_anonymous_enum_declaration] = STATE(1876),
    [sym_function_declaration] = STATE(1876),
    [sym_template_declaration] = STATE(1876),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1876),
    [sym_template_mixin] = STATE(1876),
    [sym_conditional_declaration] = STATE(1876),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1876),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1876),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1876),
    [sym_static_assert] = STATE(1876),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1876),
    [aux_sym_source_file_repeat1] = STATE(1876),
    [aux_sym_module_declaration_repeat1] = STATE(4467),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(5090),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5092),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_module] = ACTIONS(53),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1699] = {
    [sym_import_declaration] = STATE(1709),
    [sym_mixin_declaration] = STATE(1709),
    [sym__declaration] = STATE(1709),
    [sym__declaration2] = STATE(1709),
    [sym_variable_declaration] = STATE(1709),
    [sym_manifest_constant] = STATE(1709),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1709),
    [sym_alias_declaration] = STATE(1709),
    [sym_alias_reassign] = STATE(1709),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1709),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1709),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1709),
    [sym_union_declaration] = STATE(1709),
    [sym_postblit] = STATE(1709),
    [sym_invariant_declaration] = STATE(1709),
    [sym_class_declaration] = STATE(1709),
    [sym_constructor] = STATE(1709),
    [sym_destructor] = STATE(1709),
    [sym_alias_this] = STATE(1709),
    [sym_interface_declaration] = STATE(1709),
    [sym_enum_declaration] = STATE(1709),
    [sym_anonymous_enum_declaration] = STATE(1709),
    [sym_function_declaration] = STATE(1709),
    [sym_template_declaration] = STATE(1709),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1709),
    [sym_template_mixin] = STATE(1709),
    [sym_conditional_declaration] = STATE(1709),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1709),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1709),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1709),
    [sym_static_assert] = STATE(1709),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1709),
    [aux_sym_source_file_repeat1] = STATE(1709),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5096),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2525),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1700] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1701] = {
    [sym_import_declaration] = STATE(1703),
    [sym_mixin_declaration] = STATE(1703),
    [sym__declaration] = STATE(1703),
    [sym__declaration2] = STATE(1703),
    [sym_variable_declaration] = STATE(1703),
    [sym_manifest_constant] = STATE(1703),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1703),
    [sym_alias_declaration] = STATE(1703),
    [sym_alias_reassign] = STATE(1703),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1703),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1703),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1703),
    [sym_union_declaration] = STATE(1703),
    [sym_postblit] = STATE(1703),
    [sym_invariant_declaration] = STATE(1703),
    [sym_class_declaration] = STATE(1703),
    [sym_constructor] = STATE(1703),
    [sym_destructor] = STATE(1703),
    [sym_alias_this] = STATE(1703),
    [sym_interface_declaration] = STATE(1703),
    [sym_enum_declaration] = STATE(1703),
    [sym_anonymous_enum_declaration] = STATE(1703),
    [sym_function_declaration] = STATE(1703),
    [sym_template_declaration] = STATE(1703),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1703),
    [sym_template_mixin] = STATE(1703),
    [sym_conditional_declaration] = STATE(1703),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1703),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1703),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1703),
    [sym_static_assert] = STATE(1703),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1703),
    [aux_sym_source_file_repeat1] = STATE(1703),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2634),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2634),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1702] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2632),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2634),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1703] = {
    [sym_import_declaration] = STATE(1703),
    [sym_mixin_declaration] = STATE(1703),
    [sym__declaration] = STATE(1703),
    [sym__declaration2] = STATE(1703),
    [sym_variable_declaration] = STATE(1703),
    [sym_manifest_constant] = STATE(1703),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1703),
    [sym_alias_declaration] = STATE(1703),
    [sym_alias_reassign] = STATE(1703),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1703),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1703),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1703),
    [sym_union_declaration] = STATE(1703),
    [sym_postblit] = STATE(1703),
    [sym_invariant_declaration] = STATE(1703),
    [sym_class_declaration] = STATE(1703),
    [sym_constructor] = STATE(1703),
    [sym_destructor] = STATE(1703),
    [sym_alias_this] = STATE(1703),
    [sym_interface_declaration] = STATE(1703),
    [sym_enum_declaration] = STATE(1703),
    [sym_anonymous_enum_declaration] = STATE(1703),
    [sym_function_declaration] = STATE(1703),
    [sym_template_declaration] = STATE(1703),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1703),
    [sym_template_mixin] = STATE(1703),
    [sym_conditional_declaration] = STATE(1703),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1703),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1703),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1703),
    [sym_static_assert] = STATE(1703),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1703),
    [aux_sym_source_file_repeat1] = STATE(1703),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5122),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(5125),
    [anon_sym_TILDE] = ACTIONS(5128),
    [anon_sym_AT] = ACTIONS(2545),
    [sym_bool] = ACTIONS(2548),
    [sym_byte] = ACTIONS(2548),
    [sym_ubyte] = ACTIONS(2548),
    [sym_char] = ACTIONS(2548),
    [sym_short] = ACTIONS(2548),
    [sym_ushort] = ACTIONS(2548),
    [sym_int] = ACTIONS(2548),
    [sym_uint] = ACTIONS(2548),
    [sym_long] = ACTIONS(2548),
    [sym_ulong] = ACTIONS(2548),
    [sym_cent] = ACTIONS(2548),
    [sym_ucent] = ACTIONS(2548),
    [sym_wchar] = ACTIONS(2548),
    [sym_dchar] = ACTIONS(2548),
    [sym_float] = ACTIONS(2548),
    [sym_double] = ACTIONS(2548),
    [sym_real] = ACTIONS(2548),
    [sym_ifloat] = ACTIONS(2548),
    [sym_idouble] = ACTIONS(2548),
    [sym_ireal] = ACTIONS(2548),
    [sym_cfloat] = ACTIONS(2548),
    [sym_cdouble] = ACTIONS(2548),
    [sym_creal] = ACTIONS(2548),
    [sym_size_t] = ACTIONS(2548),
    [sym_ptrdiff_t] = ACTIONS(2548),
    [sym_string] = ACTIONS(2548),
    [sym_cstring] = ACTIONS(2548),
    [sym_dstring] = ACTIONS(2548),
    [sym_wstring] = ACTIONS(2548),
    [sym_noreturn] = ACTIONS(2548),
    [sym_this] = ACTIONS(5131),
    [sym_abstract] = ACTIONS(2554),
    [sym_alias] = ACTIONS(5134),
    [sym_align] = ACTIONS(2560),
    [sym_auto] = ACTIONS(2554),
    [sym_catch] = ACTIONS(2537),
    [sym_class] = ACTIONS(5137),
    [sym_const] = ACTIONS(2566),
    [sym_debug] = ACTIONS(5140),
    [sym_deprecated] = ACTIONS(2572),
    [sym_else] = ACTIONS(2537),
    [sym_enum] = ACTIONS(5143),
    [sym_export] = ACTIONS(5146),
    [sym_extern] = ACTIONS(2581),
    [sym_final] = ACTIONS(2554),
    [sym_finally] = ACTIONS(2537),
    [sym_immutable] = ACTIONS(2566),
    [sym_import] = ACTIONS(5149),
    [sym_inout] = ACTIONS(2566),
    [sym_interface] = ACTIONS(5152),
    [sym_invariant] = ACTIONS(5155),
    [sym_mixin] = ACTIONS(5158),
    [sym_nothrow] = ACTIONS(2554),
    [sym_override] = ACTIONS(2554),
    [sym_package] = ACTIONS(2596),
    [sym_pragma] = ACTIONS(2599),
    [sym_private] = ACTIONS(5146),
    [sym_protected] = ACTIONS(5146),
    [sym_public] = ACTIONS(5146),
    [sym_pure] = ACTIONS(2554),
    [sym_ref] = ACTIONS(2554),
    [sym_return] = ACTIONS(5146),
    [sym_scope] = ACTIONS(2554),
    [sym_shared] = ACTIONS(5161),
    [sym_static] = ACTIONS(5164),
    [sym_struct] = ACTIONS(5167),
    [sym_synchronized] = ACTIONS(2554),
    [sym_template] = ACTIONS(5170),
    [sym_typeof] = ACTIONS(2614),
    [sym_union] = ACTIONS(5173),
    [sym_unittest] = ACTIONS(5176),
    [sym_version] = ACTIONS(5179),
    [sym_while] = ACTIONS(2537),
    [sym_gshared] = ACTIONS(2554),
    [sym_traits] = ACTIONS(2626),
    [sym_vector] = ACTIONS(2629),
    [sym_void] = ACTIONS(2548),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1704] = {
    [sym_import_declaration] = STATE(1705),
    [sym_mixin_declaration] = STATE(1705),
    [sym__declaration] = STATE(1705),
    [sym__declaration2] = STATE(1705),
    [sym_variable_declaration] = STATE(1705),
    [sym_manifest_constant] = STATE(1705),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1705),
    [sym_alias_declaration] = STATE(1705),
    [sym_alias_reassign] = STATE(1705),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1705),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1705),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1705),
    [sym_union_declaration] = STATE(1705),
    [sym_postblit] = STATE(1705),
    [sym_invariant_declaration] = STATE(1705),
    [sym_class_declaration] = STATE(1705),
    [sym_constructor] = STATE(1705),
    [sym_destructor] = STATE(1705),
    [sym_alias_this] = STATE(1705),
    [sym_interface_declaration] = STATE(1705),
    [sym_enum_declaration] = STATE(1705),
    [sym_anonymous_enum_declaration] = STATE(1705),
    [sym_function_declaration] = STATE(1705),
    [sym_template_declaration] = STATE(1705),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1705),
    [sym_template_mixin] = STATE(1705),
    [sym_conditional_declaration] = STATE(1705),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1705),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1705),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1705),
    [sym_static_assert] = STATE(1705),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1705),
    [aux_sym_source_file_repeat1] = STATE(1705),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5182),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1705] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1706] = {
    [sym_import_declaration] = STATE(1711),
    [sym_mixin_declaration] = STATE(1711),
    [sym__declaration] = STATE(1711),
    [sym__declaration2] = STATE(1711),
    [sym_variable_declaration] = STATE(1711),
    [sym_manifest_constant] = STATE(1711),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1711),
    [sym_alias_declaration] = STATE(1711),
    [sym_alias_reassign] = STATE(1711),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1711),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1711),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1711),
    [sym_union_declaration] = STATE(1711),
    [sym_postblit] = STATE(1711),
    [sym_invariant_declaration] = STATE(1711),
    [sym_class_declaration] = STATE(1711),
    [sym_constructor] = STATE(1711),
    [sym_destructor] = STATE(1711),
    [sym_alias_this] = STATE(1711),
    [sym_interface_declaration] = STATE(1711),
    [sym_enum_declaration] = STATE(1711),
    [sym_anonymous_enum_declaration] = STATE(1711),
    [sym_function_declaration] = STATE(1711),
    [sym_template_declaration] = STATE(1711),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1711),
    [sym_template_mixin] = STATE(1711),
    [sym_conditional_declaration] = STATE(1711),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1711),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1711),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1711),
    [sym_static_assert] = STATE(1711),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1711),
    [aux_sym_source_file_repeat1] = STATE(1711),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2636),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5184),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1707] = {
    [sym_import_declaration] = STATE(1700),
    [sym_mixin_declaration] = STATE(1700),
    [sym__declaration] = STATE(1700),
    [sym__declaration2] = STATE(1700),
    [sym_variable_declaration] = STATE(1700),
    [sym_manifest_constant] = STATE(1700),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1700),
    [sym_alias_declaration] = STATE(1700),
    [sym_alias_reassign] = STATE(1700),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1700),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1700),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1700),
    [sym_union_declaration] = STATE(1700),
    [sym_postblit] = STATE(1700),
    [sym_invariant_declaration] = STATE(1700),
    [sym_class_declaration] = STATE(1700),
    [sym_constructor] = STATE(1700),
    [sym_destructor] = STATE(1700),
    [sym_alias_this] = STATE(1700),
    [sym_interface_declaration] = STATE(1700),
    [sym_enum_declaration] = STATE(1700),
    [sym_anonymous_enum_declaration] = STATE(1700),
    [sym_function_declaration] = STATE(1700),
    [sym_template_declaration] = STATE(1700),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1700),
    [sym_template_mixin] = STATE(1700),
    [sym_conditional_declaration] = STATE(1700),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1700),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1700),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1700),
    [sym_static_assert] = STATE(1700),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1700),
    [aux_sym_source_file_repeat1] = STATE(1700),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2503),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5186),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1708] = {
    [sym_import_declaration] = STATE(1714),
    [sym_mixin_declaration] = STATE(1714),
    [sym__declaration] = STATE(1714),
    [sym__declaration2] = STATE(1714),
    [sym_variable_declaration] = STATE(1714),
    [sym_manifest_constant] = STATE(1714),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1714),
    [sym_alias_declaration] = STATE(1714),
    [sym_alias_reassign] = STATE(1714),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1714),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1714),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1714),
    [sym_union_declaration] = STATE(1714),
    [sym_postblit] = STATE(1714),
    [sym_invariant_declaration] = STATE(1714),
    [sym_class_declaration] = STATE(1714),
    [sym_constructor] = STATE(1714),
    [sym_destructor] = STATE(1714),
    [sym_alias_this] = STATE(1714),
    [sym_interface_declaration] = STATE(1714),
    [sym_enum_declaration] = STATE(1714),
    [sym_anonymous_enum_declaration] = STATE(1714),
    [sym_function_declaration] = STATE(1714),
    [sym_template_declaration] = STATE(1714),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1714),
    [sym_template_mixin] = STATE(1714),
    [sym_conditional_declaration] = STATE(1714),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1714),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1714),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1714),
    [sym_static_assert] = STATE(1714),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1714),
    [aux_sym_source_file_repeat1] = STATE(1714),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5188),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2638),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1709] = {
    [sym_import_declaration] = STATE(1703),
    [sym_mixin_declaration] = STATE(1703),
    [sym__declaration] = STATE(1703),
    [sym__declaration2] = STATE(1703),
    [sym_variable_declaration] = STATE(1703),
    [sym_manifest_constant] = STATE(1703),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1703),
    [sym_alias_declaration] = STATE(1703),
    [sym_alias_reassign] = STATE(1703),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1703),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1703),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1703),
    [sym_union_declaration] = STATE(1703),
    [sym_postblit] = STATE(1703),
    [sym_invariant_declaration] = STATE(1703),
    [sym_class_declaration] = STATE(1703),
    [sym_constructor] = STATE(1703),
    [sym_destructor] = STATE(1703),
    [sym_alias_this] = STATE(1703),
    [sym_interface_declaration] = STATE(1703),
    [sym_enum_declaration] = STATE(1703),
    [sym_anonymous_enum_declaration] = STATE(1703),
    [sym_function_declaration] = STATE(1703),
    [sym_template_declaration] = STATE(1703),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1703),
    [sym_template_mixin] = STATE(1703),
    [sym_conditional_declaration] = STATE(1703),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1703),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1703),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1703),
    [sym_static_assert] = STATE(1703),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1703),
    [aux_sym_source_file_repeat1] = STATE(1703),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2638),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1710] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2532),
    [sym_identifier] = ACTIONS(5190),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_DOT] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(5193),
    [anon_sym_TILDE] = ACTIONS(5196),
    [anon_sym_AT] = ACTIONS(2545),
    [sym_bool] = ACTIONS(2548),
    [sym_byte] = ACTIONS(2548),
    [sym_ubyte] = ACTIONS(2548),
    [sym_char] = ACTIONS(2548),
    [sym_short] = ACTIONS(2548),
    [sym_ushort] = ACTIONS(2548),
    [sym_int] = ACTIONS(2548),
    [sym_uint] = ACTIONS(2548),
    [sym_long] = ACTIONS(2548),
    [sym_ulong] = ACTIONS(2548),
    [sym_cent] = ACTIONS(2548),
    [sym_ucent] = ACTIONS(2548),
    [sym_wchar] = ACTIONS(2548),
    [sym_dchar] = ACTIONS(2548),
    [sym_float] = ACTIONS(2548),
    [sym_double] = ACTIONS(2548),
    [sym_real] = ACTIONS(2548),
    [sym_ifloat] = ACTIONS(2548),
    [sym_idouble] = ACTIONS(2548),
    [sym_ireal] = ACTIONS(2548),
    [sym_cfloat] = ACTIONS(2548),
    [sym_cdouble] = ACTIONS(2548),
    [sym_creal] = ACTIONS(2548),
    [sym_size_t] = ACTIONS(2548),
    [sym_ptrdiff_t] = ACTIONS(2548),
    [sym_string] = ACTIONS(2548),
    [sym_cstring] = ACTIONS(2548),
    [sym_dstring] = ACTIONS(2548),
    [sym_wstring] = ACTIONS(2548),
    [sym_noreturn] = ACTIONS(2548),
    [sym_this] = ACTIONS(5199),
    [sym_abstract] = ACTIONS(2554),
    [sym_alias] = ACTIONS(5202),
    [sym_align] = ACTIONS(2560),
    [sym_auto] = ACTIONS(2554),
    [sym_class] = ACTIONS(5205),
    [sym_const] = ACTIONS(2566),
    [sym_debug] = ACTIONS(5208),
    [sym_deprecated] = ACTIONS(2572),
    [sym_else] = ACTIONS(2537),
    [sym_enum] = ACTIONS(5211),
    [sym_export] = ACTIONS(5214),
    [sym_extern] = ACTIONS(2581),
    [sym_final] = ACTIONS(2554),
    [sym_immutable] = ACTIONS(2566),
    [sym_import] = ACTIONS(5217),
    [sym_inout] = ACTIONS(2566),
    [sym_interface] = ACTIONS(5220),
    [sym_invariant] = ACTIONS(5223),
    [sym_mixin] = ACTIONS(5226),
    [sym_nothrow] = ACTIONS(2554),
    [sym_override] = ACTIONS(2554),
    [sym_package] = ACTIONS(2596),
    [sym_pragma] = ACTIONS(2599),
    [sym_private] = ACTIONS(5214),
    [sym_protected] = ACTIONS(5214),
    [sym_public] = ACTIONS(5214),
    [sym_pure] = ACTIONS(2554),
    [sym_ref] = ACTIONS(2554),
    [sym_return] = ACTIONS(5214),
    [sym_scope] = ACTIONS(2554),
    [sym_shared] = ACTIONS(5229),
    [sym_static] = ACTIONS(5232),
    [sym_struct] = ACTIONS(5235),
    [sym_synchronized] = ACTIONS(2554),
    [sym_template] = ACTIONS(5238),
    [sym_typeof] = ACTIONS(2614),
    [sym_union] = ACTIONS(5241),
    [sym_unittest] = ACTIONS(5244),
    [sym_version] = ACTIONS(5247),
    [sym_while] = ACTIONS(2537),
    [sym_gshared] = ACTIONS(2554),
    [sym_traits] = ACTIONS(2626),
    [sym_vector] = ACTIONS(2629),
    [sym_void] = ACTIONS(2548),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1711] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(2640),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_while] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1712] = {
    [sym_import_declaration] = STATE(1703),
    [sym_mixin_declaration] = STATE(1703),
    [sym__declaration] = STATE(1703),
    [sym__declaration2] = STATE(1703),
    [sym_variable_declaration] = STATE(1703),
    [sym_manifest_constant] = STATE(1703),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1703),
    [sym_alias_declaration] = STATE(1703),
    [sym_alias_reassign] = STATE(1703),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1703),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1703),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1703),
    [sym_union_declaration] = STATE(1703),
    [sym_postblit] = STATE(1703),
    [sym_invariant_declaration] = STATE(1703),
    [sym_class_declaration] = STATE(1703),
    [sym_constructor] = STATE(1703),
    [sym_destructor] = STATE(1703),
    [sym_alias_this] = STATE(1703),
    [sym_interface_declaration] = STATE(1703),
    [sym_enum_declaration] = STATE(1703),
    [sym_anonymous_enum_declaration] = STATE(1703),
    [sym_function_declaration] = STATE(1703),
    [sym_template_declaration] = STATE(1703),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1703),
    [sym_template_mixin] = STATE(1703),
    [sym_conditional_declaration] = STATE(1703),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1703),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1703),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1703),
    [sym_static_assert] = STATE(1703),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1703),
    [aux_sym_source_file_repeat1] = STATE(1703),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2525),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1713] = {
    [sym_import_declaration] = STATE(1712),
    [sym_mixin_declaration] = STATE(1712),
    [sym__declaration] = STATE(1712),
    [sym__declaration2] = STATE(1712),
    [sym_variable_declaration] = STATE(1712),
    [sym_manifest_constant] = STATE(1712),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1712),
    [sym_alias_declaration] = STATE(1712),
    [sym_alias_reassign] = STATE(1712),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1712),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1712),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1712),
    [sym_union_declaration] = STATE(1712),
    [sym_postblit] = STATE(1712),
    [sym_invariant_declaration] = STATE(1712),
    [sym_class_declaration] = STATE(1712),
    [sym_constructor] = STATE(1712),
    [sym_destructor] = STATE(1712),
    [sym_alias_this] = STATE(1712),
    [sym_interface_declaration] = STATE(1712),
    [sym_enum_declaration] = STATE(1712),
    [sym_anonymous_enum_declaration] = STATE(1712),
    [sym_function_declaration] = STATE(1712),
    [sym_template_declaration] = STATE(1712),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1712),
    [sym_template_mixin] = STATE(1712),
    [sym_conditional_declaration] = STATE(1712),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1712),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1712),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1712),
    [sym_static_assert] = STATE(1712),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1712),
    [aux_sym_source_file_repeat1] = STATE(1712),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5250),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2505),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1714] = {
    [sym_import_declaration] = STATE(1703),
    [sym_mixin_declaration] = STATE(1703),
    [sym__declaration] = STATE(1703),
    [sym__declaration2] = STATE(1703),
    [sym_variable_declaration] = STATE(1703),
    [sym_manifest_constant] = STATE(1703),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1703),
    [sym_alias_declaration] = STATE(1703),
    [sym_alias_reassign] = STATE(1703),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1703),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1703),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1703),
    [sym_union_declaration] = STATE(1703),
    [sym_postblit] = STATE(1703),
    [sym_invariant_declaration] = STATE(1703),
    [sym_class_declaration] = STATE(1703),
    [sym_constructor] = STATE(1703),
    [sym_destructor] = STATE(1703),
    [sym_alias_this] = STATE(1703),
    [sym_interface_declaration] = STATE(1703),
    [sym_enum_declaration] = STATE(1703),
    [sym_anonymous_enum_declaration] = STATE(1703),
    [sym_function_declaration] = STATE(1703),
    [sym_template_declaration] = STATE(1703),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1703),
    [sym_template_mixin] = STATE(1703),
    [sym_conditional_declaration] = STATE(1703),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1703),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1703),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1703),
    [sym_static_assert] = STATE(1703),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1703),
    [aux_sym_source_file_repeat1] = STATE(1703),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5120),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_catch] = ACTIONS(2642),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_finally] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_while] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1715] = {
    [sym_import_declaration] = STATE(2442),
    [sym_mixin_declaration] = STATE(2442),
    [sym__declaration] = STATE(2442),
    [sym__declaration2] = STATE(2442),
    [sym_variable_declaration] = STATE(2442),
    [sym_manifest_constant] = STATE(2442),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2442),
    [sym_alias_declaration] = STATE(2442),
    [sym_alias_reassign] = STATE(2442),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2442),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2442),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2442),
    [sym_union_declaration] = STATE(2442),
    [sym_postblit] = STATE(2442),
    [sym_invariant_declaration] = STATE(2442),
    [sym_class_declaration] = STATE(2442),
    [sym_constructor] = STATE(2442),
    [sym_destructor] = STATE(2442),
    [sym_alias_this] = STATE(2442),
    [sym_interface_declaration] = STATE(2442),
    [sym_enum_declaration] = STATE(2442),
    [sym_anonymous_enum_declaration] = STATE(2442),
    [sym_function_declaration] = STATE(2442),
    [sym_template_declaration] = STATE(2442),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2442),
    [sym_template_mixin] = STATE(2442),
    [sym_conditional_declaration] = STATE(2442),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2442),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2442),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2442),
    [sym_static_assert] = STATE(2442),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2442),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1716] = {
    [sym_import_declaration] = STATE(2335),
    [sym_mixin_declaration] = STATE(2335),
    [sym__declaration] = STATE(2335),
    [sym__declaration2] = STATE(2335),
    [sym_variable_declaration] = STATE(2335),
    [sym_manifest_constant] = STATE(2335),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2335),
    [sym_alias_declaration] = STATE(2335),
    [sym_alias_reassign] = STATE(2335),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2335),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2335),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2335),
    [sym_union_declaration] = STATE(2335),
    [sym_postblit] = STATE(2335),
    [sym_invariant_declaration] = STATE(2335),
    [sym_class_declaration] = STATE(2335),
    [sym_constructor] = STATE(2335),
    [sym_destructor] = STATE(2335),
    [sym_alias_this] = STATE(2335),
    [sym_interface_declaration] = STATE(2335),
    [sym_enum_declaration] = STATE(2335),
    [sym_anonymous_enum_declaration] = STATE(2335),
    [sym_function_declaration] = STATE(2335),
    [sym_template_declaration] = STATE(2335),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2335),
    [sym_template_mixin] = STATE(2335),
    [sym_conditional_declaration] = STATE(2335),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2335),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2335),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2335),
    [sym_static_assert] = STATE(2335),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2335),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_COLON] = ACTIONS(5266),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1717] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5268),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1718] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5270),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1719] = {
    [sym_import_declaration] = STATE(2319),
    [sym_mixin_declaration] = STATE(2319),
    [sym__declaration] = STATE(2319),
    [sym__declaration2] = STATE(2319),
    [sym_variable_declaration] = STATE(2319),
    [sym_manifest_constant] = STATE(2319),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2319),
    [sym_alias_declaration] = STATE(2319),
    [sym_alias_reassign] = STATE(2319),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2319),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2319),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2319),
    [sym_union_declaration] = STATE(2319),
    [sym_postblit] = STATE(2319),
    [sym_invariant_declaration] = STATE(2319),
    [sym_class_declaration] = STATE(2319),
    [sym_constructor] = STATE(2319),
    [sym_destructor] = STATE(2319),
    [sym_alias_this] = STATE(2319),
    [sym_interface_declaration] = STATE(2319),
    [sym_enum_declaration] = STATE(2319),
    [sym_anonymous_enum_declaration] = STATE(2319),
    [sym_function_declaration] = STATE(2319),
    [sym_template_declaration] = STATE(2319),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2319),
    [sym_template_mixin] = STATE(2319),
    [sym_conditional_declaration] = STATE(2319),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2319),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2319),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2319),
    [sym_static_assert] = STATE(2319),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2319),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5272),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5274),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1720] = {
    [sym_import_declaration] = STATE(1431),
    [sym_mixin_declaration] = STATE(1431),
    [sym__declaration] = STATE(1431),
    [sym__declaration2] = STATE(1431),
    [sym_variable_declaration] = STATE(1431),
    [sym_manifest_constant] = STATE(1431),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1431),
    [sym_alias_declaration] = STATE(1431),
    [sym_alias_reassign] = STATE(1431),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1431),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1431),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1431),
    [sym_union_declaration] = STATE(1431),
    [sym_postblit] = STATE(1431),
    [sym_invariant_declaration] = STATE(1431),
    [sym_class_declaration] = STATE(1431),
    [sym_constructor] = STATE(1431),
    [sym_destructor] = STATE(1431),
    [sym_alias_this] = STATE(1431),
    [sym_interface_declaration] = STATE(1431),
    [sym_enum_declaration] = STATE(1431),
    [sym_anonymous_enum_declaration] = STATE(1431),
    [sym_function_declaration] = STATE(1431),
    [sym_template_declaration] = STATE(1431),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1431),
    [sym_template_mixin] = STATE(1431),
    [sym_conditional_declaration] = STATE(1431),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1431),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1431),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1431),
    [sym_static_assert] = STATE(1431),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1431),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5282),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5284),
    [anon_sym_COLON] = ACTIONS(5286),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1721] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1722] = {
    [sym_import_declaration] = STATE(1718),
    [sym_mixin_declaration] = STATE(1718),
    [sym__declaration] = STATE(1718),
    [sym__declaration2] = STATE(1718),
    [sym_variable_declaration] = STATE(1718),
    [sym_manifest_constant] = STATE(1718),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1718),
    [sym_alias_declaration] = STATE(1718),
    [sym_alias_reassign] = STATE(1718),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1718),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1718),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1718),
    [sym_union_declaration] = STATE(1718),
    [sym_postblit] = STATE(1718),
    [sym_invariant_declaration] = STATE(1718),
    [sym_class_declaration] = STATE(1718),
    [sym_constructor] = STATE(1718),
    [sym_destructor] = STATE(1718),
    [sym_alias_this] = STATE(1718),
    [sym_interface_declaration] = STATE(1718),
    [sym_enum_declaration] = STATE(1718),
    [sym_anonymous_enum_declaration] = STATE(1718),
    [sym_function_declaration] = STATE(1718),
    [sym_template_declaration] = STATE(1718),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1718),
    [sym_template_mixin] = STATE(1718),
    [sym_conditional_declaration] = STATE(1718),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1718),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1718),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1718),
    [sym_static_assert] = STATE(1718),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1718),
    [aux_sym_source_file_repeat1] = STATE(1718),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5288),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5290),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1723] = {
    [sym_import_declaration] = STATE(2119),
    [sym_mixin_declaration] = STATE(2119),
    [sym__declaration] = STATE(2119),
    [sym__declaration2] = STATE(2119),
    [sym_variable_declaration] = STATE(2119),
    [sym_manifest_constant] = STATE(2119),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2119),
    [sym_alias_declaration] = STATE(2119),
    [sym_alias_reassign] = STATE(2119),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2119),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2119),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2119),
    [sym_union_declaration] = STATE(2119),
    [sym_postblit] = STATE(2119),
    [sym_invariant_declaration] = STATE(2119),
    [sym_class_declaration] = STATE(2119),
    [sym_constructor] = STATE(2119),
    [sym_destructor] = STATE(2119),
    [sym_alias_this] = STATE(2119),
    [sym_interface_declaration] = STATE(2119),
    [sym_enum_declaration] = STATE(2119),
    [sym_anonymous_enum_declaration] = STATE(2119),
    [sym_function_declaration] = STATE(2119),
    [sym_template_declaration] = STATE(2119),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2119),
    [sym_template_mixin] = STATE(2119),
    [sym_conditional_declaration] = STATE(2119),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2119),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2119),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2119),
    [sym_static_assert] = STATE(2119),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2119),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5296),
    [anon_sym_COLON] = ACTIONS(5298),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1724] = {
    [sym_import_declaration] = STATE(1837),
    [sym_mixin_declaration] = STATE(1837),
    [sym__declaration] = STATE(1837),
    [sym__declaration2] = STATE(1837),
    [sym_variable_declaration] = STATE(1837),
    [sym_manifest_constant] = STATE(1837),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1837),
    [sym_alias_declaration] = STATE(1837),
    [sym_alias_reassign] = STATE(1837),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1837),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1837),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1837),
    [sym_union_declaration] = STATE(1837),
    [sym_postblit] = STATE(1837),
    [sym_invariant_declaration] = STATE(1837),
    [sym_class_declaration] = STATE(1837),
    [sym_constructor] = STATE(1837),
    [sym_destructor] = STATE(1837),
    [sym_alias_this] = STATE(1837),
    [sym_interface_declaration] = STATE(1837),
    [sym_enum_declaration] = STATE(1837),
    [sym_anonymous_enum_declaration] = STATE(1837),
    [sym_function_declaration] = STATE(1837),
    [sym_template_declaration] = STATE(1837),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1837),
    [sym_template_mixin] = STATE(1837),
    [sym_conditional_declaration] = STATE(1837),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1837),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1837),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1837),
    [sym_static_assert] = STATE(1837),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1837),
    [aux_sym_source_file_repeat1] = STATE(1837),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5314),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1725] = {
    [sym_import_declaration] = STATE(2119),
    [sym_mixin_declaration] = STATE(2119),
    [sym__declaration] = STATE(2119),
    [sym__declaration2] = STATE(2119),
    [sym_variable_declaration] = STATE(2119),
    [sym_manifest_constant] = STATE(2119),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2119),
    [sym_alias_declaration] = STATE(2119),
    [sym_alias_reassign] = STATE(2119),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2119),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2119),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2119),
    [sym_union_declaration] = STATE(2119),
    [sym_postblit] = STATE(2119),
    [sym_invariant_declaration] = STATE(2119),
    [sym_class_declaration] = STATE(2119),
    [sym_constructor] = STATE(2119),
    [sym_destructor] = STATE(2119),
    [sym_alias_this] = STATE(2119),
    [sym_interface_declaration] = STATE(2119),
    [sym_enum_declaration] = STATE(2119),
    [sym_anonymous_enum_declaration] = STATE(2119),
    [sym_function_declaration] = STATE(2119),
    [sym_template_declaration] = STATE(2119),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2119),
    [sym_template_mixin] = STATE(2119),
    [sym_conditional_declaration] = STATE(2119),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2119),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2119),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2119),
    [sym_static_assert] = STATE(2119),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2119),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5296),
    [anon_sym_COLON] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1726] = {
    [sym_import_declaration] = STATE(1797),
    [sym_mixin_declaration] = STATE(1797),
    [sym__declaration] = STATE(1797),
    [sym__declaration2] = STATE(1797),
    [sym_variable_declaration] = STATE(1797),
    [sym_manifest_constant] = STATE(1797),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1797),
    [sym_alias_declaration] = STATE(1797),
    [sym_alias_reassign] = STATE(1797),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1797),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1797),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1797),
    [sym_union_declaration] = STATE(1797),
    [sym_postblit] = STATE(1797),
    [sym_invariant_declaration] = STATE(1797),
    [sym_class_declaration] = STATE(1797),
    [sym_constructor] = STATE(1797),
    [sym_destructor] = STATE(1797),
    [sym_alias_this] = STATE(1797),
    [sym_interface_declaration] = STATE(1797),
    [sym_enum_declaration] = STATE(1797),
    [sym_anonymous_enum_declaration] = STATE(1797),
    [sym_function_declaration] = STATE(1797),
    [sym_template_declaration] = STATE(1797),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1797),
    [sym_template_mixin] = STATE(1797),
    [sym_conditional_declaration] = STATE(1797),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1797),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1797),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1797),
    [sym_static_assert] = STATE(1797),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1797),
    [aux_sym_source_file_repeat1] = STATE(1797),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5322),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5324),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1727] = {
    [sym_import_declaration] = STATE(1799),
    [sym_mixin_declaration] = STATE(1799),
    [sym__declaration] = STATE(1799),
    [sym__declaration2] = STATE(1799),
    [sym_variable_declaration] = STATE(1799),
    [sym_manifest_constant] = STATE(1799),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1799),
    [sym_alias_declaration] = STATE(1799),
    [sym_alias_reassign] = STATE(1799),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1799),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1799),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1799),
    [sym_union_declaration] = STATE(1799),
    [sym_postblit] = STATE(1799),
    [sym_invariant_declaration] = STATE(1799),
    [sym_class_declaration] = STATE(1799),
    [sym_constructor] = STATE(1799),
    [sym_destructor] = STATE(1799),
    [sym_alias_this] = STATE(1799),
    [sym_interface_declaration] = STATE(1799),
    [sym_enum_declaration] = STATE(1799),
    [sym_anonymous_enum_declaration] = STATE(1799),
    [sym_function_declaration] = STATE(1799),
    [sym_template_declaration] = STATE(1799),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1799),
    [sym_template_mixin] = STATE(1799),
    [sym_conditional_declaration] = STATE(1799),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1799),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1799),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1799),
    [sym_static_assert] = STATE(1799),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1799),
    [aux_sym_source_file_repeat1] = STATE(1799),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5326),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5328),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1728] = {
    [sym_import_declaration] = STATE(1869),
    [sym_mixin_declaration] = STATE(1869),
    [sym__declaration] = STATE(1869),
    [sym__declaration2] = STATE(1869),
    [sym_variable_declaration] = STATE(1869),
    [sym_manifest_constant] = STATE(1869),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1869),
    [sym_alias_declaration] = STATE(1869),
    [sym_alias_reassign] = STATE(1869),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1869),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1869),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1869),
    [sym_union_declaration] = STATE(1869),
    [sym_postblit] = STATE(1869),
    [sym_invariant_declaration] = STATE(1869),
    [sym_class_declaration] = STATE(1869),
    [sym_constructor] = STATE(1869),
    [sym_destructor] = STATE(1869),
    [sym_alias_this] = STATE(1869),
    [sym_interface_declaration] = STATE(1869),
    [sym_enum_declaration] = STATE(1869),
    [sym_anonymous_enum_declaration] = STATE(1869),
    [sym_function_declaration] = STATE(1869),
    [sym_template_declaration] = STATE(1869),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1869),
    [sym_template_mixin] = STATE(1869),
    [sym_conditional_declaration] = STATE(1869),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1869),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1869),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1869),
    [sym_static_assert] = STATE(1869),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1869),
    [aux_sym_source_file_repeat1] = STATE(1869),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5330),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1729] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5332),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1730] = {
    [sym_import_declaration] = STATE(1721),
    [sym_mixin_declaration] = STATE(1721),
    [sym__declaration] = STATE(1721),
    [sym__declaration2] = STATE(1721),
    [sym_variable_declaration] = STATE(1721),
    [sym_manifest_constant] = STATE(1721),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1721),
    [sym_alias_declaration] = STATE(1721),
    [sym_alias_reassign] = STATE(1721),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1721),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1721),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1721),
    [sym_union_declaration] = STATE(1721),
    [sym_postblit] = STATE(1721),
    [sym_invariant_declaration] = STATE(1721),
    [sym_class_declaration] = STATE(1721),
    [sym_constructor] = STATE(1721),
    [sym_destructor] = STATE(1721),
    [sym_alias_this] = STATE(1721),
    [sym_interface_declaration] = STATE(1721),
    [sym_enum_declaration] = STATE(1721),
    [sym_anonymous_enum_declaration] = STATE(1721),
    [sym_function_declaration] = STATE(1721),
    [sym_template_declaration] = STATE(1721),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1721),
    [sym_template_mixin] = STATE(1721),
    [sym_conditional_declaration] = STATE(1721),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1721),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1721),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1721),
    [sym_static_assert] = STATE(1721),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1721),
    [aux_sym_source_file_repeat1] = STATE(1721),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5336),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1731] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1732] = {
    [sym_import_declaration] = STATE(1805),
    [sym_mixin_declaration] = STATE(1805),
    [sym__declaration] = STATE(1805),
    [sym__declaration2] = STATE(1805),
    [sym_variable_declaration] = STATE(1805),
    [sym_manifest_constant] = STATE(1805),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1805),
    [sym_alias_declaration] = STATE(1805),
    [sym_alias_reassign] = STATE(1805),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1805),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1805),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1805),
    [sym_union_declaration] = STATE(1805),
    [sym_postblit] = STATE(1805),
    [sym_invariant_declaration] = STATE(1805),
    [sym_class_declaration] = STATE(1805),
    [sym_constructor] = STATE(1805),
    [sym_destructor] = STATE(1805),
    [sym_alias_this] = STATE(1805),
    [sym_interface_declaration] = STATE(1805),
    [sym_enum_declaration] = STATE(1805),
    [sym_anonymous_enum_declaration] = STATE(1805),
    [sym_function_declaration] = STATE(1805),
    [sym_template_declaration] = STATE(1805),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1805),
    [sym_template_mixin] = STATE(1805),
    [sym_conditional_declaration] = STATE(1805),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1805),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1805),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1805),
    [sym_static_assert] = STATE(1805),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1805),
    [aux_sym_source_file_repeat1] = STATE(1805),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5338),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5340),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1733] = {
    [sym_import_declaration] = STATE(1808),
    [sym_mixin_declaration] = STATE(1808),
    [sym__declaration] = STATE(1808),
    [sym__declaration2] = STATE(1808),
    [sym_variable_declaration] = STATE(1808),
    [sym_manifest_constant] = STATE(1808),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1808),
    [sym_alias_declaration] = STATE(1808),
    [sym_alias_reassign] = STATE(1808),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1808),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1808),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1808),
    [sym_union_declaration] = STATE(1808),
    [sym_postblit] = STATE(1808),
    [sym_invariant_declaration] = STATE(1808),
    [sym_class_declaration] = STATE(1808),
    [sym_constructor] = STATE(1808),
    [sym_destructor] = STATE(1808),
    [sym_alias_this] = STATE(1808),
    [sym_interface_declaration] = STATE(1808),
    [sym_enum_declaration] = STATE(1808),
    [sym_anonymous_enum_declaration] = STATE(1808),
    [sym_function_declaration] = STATE(1808),
    [sym_template_declaration] = STATE(1808),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1808),
    [sym_template_mixin] = STATE(1808),
    [sym_conditional_declaration] = STATE(1808),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1808),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1808),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1808),
    [sym_static_assert] = STATE(1808),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1808),
    [aux_sym_source_file_repeat1] = STATE(1808),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5342),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5344),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1734] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5346),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1735] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5348),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1736] = {
    [sym_import_declaration] = STATE(1729),
    [sym_mixin_declaration] = STATE(1729),
    [sym__declaration] = STATE(1729),
    [sym__declaration2] = STATE(1729),
    [sym_variable_declaration] = STATE(1729),
    [sym_manifest_constant] = STATE(1729),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1729),
    [sym_alias_declaration] = STATE(1729),
    [sym_alias_reassign] = STATE(1729),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1729),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1729),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1729),
    [sym_union_declaration] = STATE(1729),
    [sym_postblit] = STATE(1729),
    [sym_invariant_declaration] = STATE(1729),
    [sym_class_declaration] = STATE(1729),
    [sym_constructor] = STATE(1729),
    [sym_destructor] = STATE(1729),
    [sym_alias_this] = STATE(1729),
    [sym_interface_declaration] = STATE(1729),
    [sym_enum_declaration] = STATE(1729),
    [sym_anonymous_enum_declaration] = STATE(1729),
    [sym_function_declaration] = STATE(1729),
    [sym_template_declaration] = STATE(1729),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1729),
    [sym_template_mixin] = STATE(1729),
    [sym_conditional_declaration] = STATE(1729),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1729),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1729),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1729),
    [sym_static_assert] = STATE(1729),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1729),
    [aux_sym_source_file_repeat1] = STATE(1729),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5348),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5350),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1737] = {
    [sym_import_declaration] = STATE(2054),
    [sym_mixin_declaration] = STATE(2054),
    [sym__declaration] = STATE(2054),
    [sym__declaration2] = STATE(2054),
    [sym_variable_declaration] = STATE(2054),
    [sym_manifest_constant] = STATE(2054),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2054),
    [sym_alias_declaration] = STATE(2054),
    [sym_alias_reassign] = STATE(2054),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2054),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2054),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2054),
    [sym_union_declaration] = STATE(2054),
    [sym_postblit] = STATE(2054),
    [sym_invariant_declaration] = STATE(2054),
    [sym_class_declaration] = STATE(2054),
    [sym_constructor] = STATE(2054),
    [sym_destructor] = STATE(2054),
    [sym_alias_this] = STATE(2054),
    [sym_interface_declaration] = STATE(2054),
    [sym_enum_declaration] = STATE(2054),
    [sym_anonymous_enum_declaration] = STATE(2054),
    [sym_function_declaration] = STATE(2054),
    [sym_template_declaration] = STATE(2054),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2054),
    [sym_template_mixin] = STATE(2054),
    [sym_conditional_declaration] = STATE(2054),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2054),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2054),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2054),
    [sym_static_assert] = STATE(2054),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2054),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5352),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5354),
    [anon_sym_COLON] = ACTIONS(5356),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1738] = {
    [sym_import_declaration] = STATE(1827),
    [sym_mixin_declaration] = STATE(1827),
    [sym__declaration] = STATE(1827),
    [sym__declaration2] = STATE(1827),
    [sym_variable_declaration] = STATE(1827),
    [sym_manifest_constant] = STATE(1827),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1827),
    [sym_alias_declaration] = STATE(1827),
    [sym_alias_reassign] = STATE(1827),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1827),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1827),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1827),
    [sym_union_declaration] = STATE(1827),
    [sym_postblit] = STATE(1827),
    [sym_invariant_declaration] = STATE(1827),
    [sym_class_declaration] = STATE(1827),
    [sym_constructor] = STATE(1827),
    [sym_destructor] = STATE(1827),
    [sym_alias_this] = STATE(1827),
    [sym_interface_declaration] = STATE(1827),
    [sym_enum_declaration] = STATE(1827),
    [sym_anonymous_enum_declaration] = STATE(1827),
    [sym_function_declaration] = STATE(1827),
    [sym_template_declaration] = STATE(1827),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1827),
    [sym_template_mixin] = STATE(1827),
    [sym_conditional_declaration] = STATE(1827),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1827),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1827),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1827),
    [sym_static_assert] = STATE(1827),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1827),
    [aux_sym_source_file_repeat1] = STATE(1827),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5360),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1739] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5358),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1740] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5362),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1741] = {
    [sym_import_declaration] = STATE(2054),
    [sym_mixin_declaration] = STATE(2054),
    [sym__declaration] = STATE(2054),
    [sym__declaration2] = STATE(2054),
    [sym_variable_declaration] = STATE(2054),
    [sym_manifest_constant] = STATE(2054),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2054),
    [sym_alias_declaration] = STATE(2054),
    [sym_alias_reassign] = STATE(2054),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2054),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2054),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2054),
    [sym_union_declaration] = STATE(2054),
    [sym_postblit] = STATE(2054),
    [sym_invariant_declaration] = STATE(2054),
    [sym_class_declaration] = STATE(2054),
    [sym_constructor] = STATE(2054),
    [sym_destructor] = STATE(2054),
    [sym_alias_this] = STATE(2054),
    [sym_interface_declaration] = STATE(2054),
    [sym_enum_declaration] = STATE(2054),
    [sym_anonymous_enum_declaration] = STATE(2054),
    [sym_function_declaration] = STATE(2054),
    [sym_template_declaration] = STATE(2054),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2054),
    [sym_template_mixin] = STATE(2054),
    [sym_conditional_declaration] = STATE(2054),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2054),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2054),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2054),
    [sym_static_assert] = STATE(2054),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2054),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5352),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5354),
    [anon_sym_COLON] = ACTIONS(5286),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1742] = {
    [sym_import_declaration] = STATE(1735),
    [sym_mixin_declaration] = STATE(1735),
    [sym__declaration] = STATE(1735),
    [sym__declaration2] = STATE(1735),
    [sym_variable_declaration] = STATE(1735),
    [sym_manifest_constant] = STATE(1735),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1735),
    [sym_alias_declaration] = STATE(1735),
    [sym_alias_reassign] = STATE(1735),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1735),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1735),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1735),
    [sym_union_declaration] = STATE(1735),
    [sym_postblit] = STATE(1735),
    [sym_invariant_declaration] = STATE(1735),
    [sym_class_declaration] = STATE(1735),
    [sym_constructor] = STATE(1735),
    [sym_destructor] = STATE(1735),
    [sym_alias_this] = STATE(1735),
    [sym_interface_declaration] = STATE(1735),
    [sym_enum_declaration] = STATE(1735),
    [sym_anonymous_enum_declaration] = STATE(1735),
    [sym_function_declaration] = STATE(1735),
    [sym_template_declaration] = STATE(1735),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1735),
    [sym_template_mixin] = STATE(1735),
    [sym_conditional_declaration] = STATE(1735),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1735),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1735),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1735),
    [sym_static_assert] = STATE(1735),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1735),
    [aux_sym_source_file_repeat1] = STATE(1735),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1743] = {
    [sym_import_declaration] = STATE(1606),
    [sym_mixin_declaration] = STATE(1606),
    [sym__declaration] = STATE(1606),
    [sym__declaration2] = STATE(1606),
    [sym_variable_declaration] = STATE(1606),
    [sym_manifest_constant] = STATE(1606),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1606),
    [sym_alias_declaration] = STATE(1606),
    [sym_alias_reassign] = STATE(1606),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1606),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1606),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1606),
    [sym_union_declaration] = STATE(1606),
    [sym_postblit] = STATE(1606),
    [sym_invariant_declaration] = STATE(1606),
    [sym_class_declaration] = STATE(1606),
    [sym_constructor] = STATE(1606),
    [sym_destructor] = STATE(1606),
    [sym_alias_this] = STATE(1606),
    [sym_interface_declaration] = STATE(1606),
    [sym_enum_declaration] = STATE(1606),
    [sym_anonymous_enum_declaration] = STATE(1606),
    [sym_function_declaration] = STATE(1606),
    [sym_template_declaration] = STATE(1606),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1606),
    [sym_template_mixin] = STATE(1606),
    [sym_conditional_declaration] = STATE(1606),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1606),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1606),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1606),
    [sym_static_assert] = STATE(1606),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1606),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5368),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5370),
    [anon_sym_COLON] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1744] = {
    [sym_import_declaration] = STATE(2268),
    [sym_mixin_declaration] = STATE(2268),
    [sym__declaration] = STATE(2268),
    [sym__declaration2] = STATE(2268),
    [sym_variable_declaration] = STATE(2268),
    [sym_manifest_constant] = STATE(2268),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2268),
    [sym_alias_declaration] = STATE(2268),
    [sym_alias_reassign] = STATE(2268),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2268),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2268),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2268),
    [sym_union_declaration] = STATE(2268),
    [sym_postblit] = STATE(2268),
    [sym_invariant_declaration] = STATE(2268),
    [sym_class_declaration] = STATE(2268),
    [sym_constructor] = STATE(2268),
    [sym_destructor] = STATE(2268),
    [sym_alias_this] = STATE(2268),
    [sym_interface_declaration] = STATE(2268),
    [sym_enum_declaration] = STATE(2268),
    [sym_anonymous_enum_declaration] = STATE(2268),
    [sym_function_declaration] = STATE(2268),
    [sym_template_declaration] = STATE(2268),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2268),
    [sym_template_mixin] = STATE(2268),
    [sym_conditional_declaration] = STATE(2268),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2268),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2268),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2268),
    [sym_static_assert] = STATE(2268),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2268),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_COLON] = ACTIONS(5378),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1745] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5380),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1746] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5382),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1747] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5384),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1748] = {
    [sym_import_declaration] = STATE(1731),
    [sym_mixin_declaration] = STATE(1731),
    [sym__declaration] = STATE(1731),
    [sym__declaration2] = STATE(1731),
    [sym_variable_declaration] = STATE(1731),
    [sym_manifest_constant] = STATE(1731),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1731),
    [sym_alias_declaration] = STATE(1731),
    [sym_alias_reassign] = STATE(1731),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1731),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1731),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1731),
    [sym_union_declaration] = STATE(1731),
    [sym_postblit] = STATE(1731),
    [sym_invariant_declaration] = STATE(1731),
    [sym_class_declaration] = STATE(1731),
    [sym_constructor] = STATE(1731),
    [sym_destructor] = STATE(1731),
    [sym_alias_this] = STATE(1731),
    [sym_interface_declaration] = STATE(1731),
    [sym_enum_declaration] = STATE(1731),
    [sym_anonymous_enum_declaration] = STATE(1731),
    [sym_function_declaration] = STATE(1731),
    [sym_template_declaration] = STATE(1731),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1731),
    [sym_template_mixin] = STATE(1731),
    [sym_conditional_declaration] = STATE(1731),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1731),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1731),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1731),
    [sym_static_assert] = STATE(1731),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1731),
    [aux_sym_source_file_repeat1] = STATE(1731),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5386),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5388),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1749] = {
    [sym_import_declaration] = STATE(2120),
    [sym_mixin_declaration] = STATE(2120),
    [sym__declaration] = STATE(2120),
    [sym__declaration2] = STATE(2120),
    [sym_variable_declaration] = STATE(2120),
    [sym_manifest_constant] = STATE(2120),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2120),
    [sym_alias_declaration] = STATE(2120),
    [sym_alias_reassign] = STATE(2120),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2120),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2120),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2120),
    [sym_union_declaration] = STATE(2120),
    [sym_postblit] = STATE(2120),
    [sym_invariant_declaration] = STATE(2120),
    [sym_class_declaration] = STATE(2120),
    [sym_constructor] = STATE(2120),
    [sym_destructor] = STATE(2120),
    [sym_alias_this] = STATE(2120),
    [sym_interface_declaration] = STATE(2120),
    [sym_enum_declaration] = STATE(2120),
    [sym_anonymous_enum_declaration] = STATE(2120),
    [sym_function_declaration] = STATE(2120),
    [sym_template_declaration] = STATE(2120),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2120),
    [sym_template_mixin] = STATE(2120),
    [sym_conditional_declaration] = STATE(2120),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2120),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2120),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2120),
    [sym_static_assert] = STATE(2120),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2120),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5390),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym_COLON] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1750] = {
    [sym_import_declaration] = STATE(1740),
    [sym_mixin_declaration] = STATE(1740),
    [sym__declaration] = STATE(1740),
    [sym__declaration2] = STATE(1740),
    [sym_variable_declaration] = STATE(1740),
    [sym_manifest_constant] = STATE(1740),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1740),
    [sym_alias_declaration] = STATE(1740),
    [sym_alias_reassign] = STATE(1740),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1740),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1740),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1740),
    [sym_union_declaration] = STATE(1740),
    [sym_postblit] = STATE(1740),
    [sym_invariant_declaration] = STATE(1740),
    [sym_class_declaration] = STATE(1740),
    [sym_constructor] = STATE(1740),
    [sym_destructor] = STATE(1740),
    [sym_alias_this] = STATE(1740),
    [sym_interface_declaration] = STATE(1740),
    [sym_enum_declaration] = STATE(1740),
    [sym_anonymous_enum_declaration] = STATE(1740),
    [sym_function_declaration] = STATE(1740),
    [sym_template_declaration] = STATE(1740),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1740),
    [sym_template_mixin] = STATE(1740),
    [sym_conditional_declaration] = STATE(1740),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1740),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1740),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1740),
    [sym_static_assert] = STATE(1740),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1740),
    [aux_sym_source_file_repeat1] = STATE(1740),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5396),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5398),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1751] = {
    [sym_import_declaration] = STATE(1840),
    [sym_mixin_declaration] = STATE(1840),
    [sym__declaration] = STATE(1840),
    [sym__declaration2] = STATE(1840),
    [sym_variable_declaration] = STATE(1840),
    [sym_manifest_constant] = STATE(1840),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1840),
    [sym_alias_declaration] = STATE(1840),
    [sym_alias_reassign] = STATE(1840),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1840),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1840),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1840),
    [sym_union_declaration] = STATE(1840),
    [sym_postblit] = STATE(1840),
    [sym_invariant_declaration] = STATE(1840),
    [sym_class_declaration] = STATE(1840),
    [sym_constructor] = STATE(1840),
    [sym_destructor] = STATE(1840),
    [sym_alias_this] = STATE(1840),
    [sym_interface_declaration] = STATE(1840),
    [sym_enum_declaration] = STATE(1840),
    [sym_anonymous_enum_declaration] = STATE(1840),
    [sym_function_declaration] = STATE(1840),
    [sym_template_declaration] = STATE(1840),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1840),
    [sym_template_mixin] = STATE(1840),
    [sym_conditional_declaration] = STATE(1840),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1840),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1840),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1840),
    [sym_static_assert] = STATE(1840),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1840),
    [aux_sym_source_file_repeat1] = STATE(1840),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5400),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5402),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1752] = {
    [sym_import_declaration] = STATE(1803),
    [sym_mixin_declaration] = STATE(1803),
    [sym__declaration] = STATE(1803),
    [sym__declaration2] = STATE(1803),
    [sym_variable_declaration] = STATE(1803),
    [sym_manifest_constant] = STATE(1803),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1803),
    [sym_alias_declaration] = STATE(1803),
    [sym_alias_reassign] = STATE(1803),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1803),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1803),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1803),
    [sym_union_declaration] = STATE(1803),
    [sym_postblit] = STATE(1803),
    [sym_invariant_declaration] = STATE(1803),
    [sym_class_declaration] = STATE(1803),
    [sym_constructor] = STATE(1803),
    [sym_destructor] = STATE(1803),
    [sym_alias_this] = STATE(1803),
    [sym_interface_declaration] = STATE(1803),
    [sym_enum_declaration] = STATE(1803),
    [sym_anonymous_enum_declaration] = STATE(1803),
    [sym_function_declaration] = STATE(1803),
    [sym_template_declaration] = STATE(1803),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1803),
    [sym_template_mixin] = STATE(1803),
    [sym_conditional_declaration] = STATE(1803),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1803),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1803),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1803),
    [sym_static_assert] = STATE(1803),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1803),
    [aux_sym_source_file_repeat1] = STATE(1803),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5404),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5406),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1753] = {
    [sym_import_declaration] = STATE(1849),
    [sym_mixin_declaration] = STATE(1849),
    [sym__declaration] = STATE(1849),
    [sym__declaration2] = STATE(1849),
    [sym_variable_declaration] = STATE(1849),
    [sym_manifest_constant] = STATE(1849),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1849),
    [sym_alias_declaration] = STATE(1849),
    [sym_alias_reassign] = STATE(1849),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1849),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1849),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1849),
    [sym_union_declaration] = STATE(1849),
    [sym_postblit] = STATE(1849),
    [sym_invariant_declaration] = STATE(1849),
    [sym_class_declaration] = STATE(1849),
    [sym_constructor] = STATE(1849),
    [sym_destructor] = STATE(1849),
    [sym_alias_this] = STATE(1849),
    [sym_interface_declaration] = STATE(1849),
    [sym_enum_declaration] = STATE(1849),
    [sym_anonymous_enum_declaration] = STATE(1849),
    [sym_function_declaration] = STATE(1849),
    [sym_template_declaration] = STATE(1849),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1849),
    [sym_template_mixin] = STATE(1849),
    [sym_conditional_declaration] = STATE(1849),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1849),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1849),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1849),
    [sym_static_assert] = STATE(1849),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1849),
    [aux_sym_source_file_repeat1] = STATE(1849),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5408),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1754] = {
    [sym_import_declaration] = STATE(2044),
    [sym_mixin_declaration] = STATE(2044),
    [sym__declaration] = STATE(2044),
    [sym__declaration2] = STATE(2044),
    [sym_variable_declaration] = STATE(2044),
    [sym_manifest_constant] = STATE(2044),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2044),
    [sym_alias_declaration] = STATE(2044),
    [sym_alias_reassign] = STATE(2044),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2044),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2044),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2044),
    [sym_union_declaration] = STATE(2044),
    [sym_postblit] = STATE(2044),
    [sym_invariant_declaration] = STATE(2044),
    [sym_class_declaration] = STATE(2044),
    [sym_constructor] = STATE(2044),
    [sym_destructor] = STATE(2044),
    [sym_alias_this] = STATE(2044),
    [sym_interface_declaration] = STATE(2044),
    [sym_enum_declaration] = STATE(2044),
    [sym_anonymous_enum_declaration] = STATE(2044),
    [sym_function_declaration] = STATE(2044),
    [sym_template_declaration] = STATE(2044),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2044),
    [sym_template_mixin] = STATE(2044),
    [sym_conditional_declaration] = STATE(2044),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2044),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2044),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2044),
    [sym_static_assert] = STATE(2044),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2044),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5414),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1755] = {
    [sym_import_declaration] = STATE(1854),
    [sym_mixin_declaration] = STATE(1854),
    [sym__declaration] = STATE(1854),
    [sym__declaration2] = STATE(1854),
    [sym_variable_declaration] = STATE(1854),
    [sym_manifest_constant] = STATE(1854),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1854),
    [sym_alias_declaration] = STATE(1854),
    [sym_alias_reassign] = STATE(1854),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1854),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1854),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1854),
    [sym_union_declaration] = STATE(1854),
    [sym_postblit] = STATE(1854),
    [sym_invariant_declaration] = STATE(1854),
    [sym_class_declaration] = STATE(1854),
    [sym_constructor] = STATE(1854),
    [sym_destructor] = STATE(1854),
    [sym_alias_this] = STATE(1854),
    [sym_interface_declaration] = STATE(1854),
    [sym_enum_declaration] = STATE(1854),
    [sym_anonymous_enum_declaration] = STATE(1854),
    [sym_function_declaration] = STATE(1854),
    [sym_template_declaration] = STATE(1854),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1854),
    [sym_template_mixin] = STATE(1854),
    [sym_conditional_declaration] = STATE(1854),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1854),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1854),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1854),
    [sym_static_assert] = STATE(1854),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1854),
    [aux_sym_source_file_repeat1] = STATE(1854),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5416),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5418),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1756] = {
    [sym_import_declaration] = STATE(1888),
    [sym_mixin_declaration] = STATE(1888),
    [sym__declaration] = STATE(1888),
    [sym__declaration2] = STATE(1888),
    [sym_variable_declaration] = STATE(1888),
    [sym_manifest_constant] = STATE(1888),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1888),
    [sym_alias_declaration] = STATE(1888),
    [sym_alias_reassign] = STATE(1888),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1888),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1888),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1888),
    [sym_union_declaration] = STATE(1888),
    [sym_postblit] = STATE(1888),
    [sym_invariant_declaration] = STATE(1888),
    [sym_class_declaration] = STATE(1888),
    [sym_constructor] = STATE(1888),
    [sym_destructor] = STATE(1888),
    [sym_alias_this] = STATE(1888),
    [sym_interface_declaration] = STATE(1888),
    [sym_enum_declaration] = STATE(1888),
    [sym_anonymous_enum_declaration] = STATE(1888),
    [sym_function_declaration] = STATE(1888),
    [sym_template_declaration] = STATE(1888),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1888),
    [sym_template_mixin] = STATE(1888),
    [sym_conditional_declaration] = STATE(1888),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1888),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1888),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1888),
    [sym_static_assert] = STATE(1888),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1888),
    [aux_sym_source_file_repeat1] = STATE(1888),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5420),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5422),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1757] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5424),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1758] = {
    [sym_import_declaration] = STATE(2289),
    [sym_mixin_declaration] = STATE(2289),
    [sym__declaration] = STATE(2289),
    [sym__declaration2] = STATE(2289),
    [sym_variable_declaration] = STATE(2289),
    [sym_manifest_constant] = STATE(2289),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2289),
    [sym_alias_declaration] = STATE(2289),
    [sym_alias_reassign] = STATE(2289),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2289),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2289),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2289),
    [sym_union_declaration] = STATE(2289),
    [sym_postblit] = STATE(2289),
    [sym_invariant_declaration] = STATE(2289),
    [sym_class_declaration] = STATE(2289),
    [sym_constructor] = STATE(2289),
    [sym_destructor] = STATE(2289),
    [sym_alias_this] = STATE(2289),
    [sym_interface_declaration] = STATE(2289),
    [sym_enum_declaration] = STATE(2289),
    [sym_anonymous_enum_declaration] = STATE(2289),
    [sym_function_declaration] = STATE(2289),
    [sym_template_declaration] = STATE(2289),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2289),
    [sym_template_mixin] = STATE(2289),
    [sym_conditional_declaration] = STATE(2289),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2289),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2289),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2289),
    [sym_static_assert] = STATE(2289),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2289),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5426),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1759] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(5432),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1760] = {
    [sym_import_declaration] = STATE(1766),
    [sym_mixin_declaration] = STATE(1766),
    [sym__declaration] = STATE(1766),
    [sym__declaration2] = STATE(1766),
    [sym_variable_declaration] = STATE(1766),
    [sym_manifest_constant] = STATE(1766),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1766),
    [sym_alias_declaration] = STATE(1766),
    [sym_alias_reassign] = STATE(1766),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1766),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1766),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1766),
    [sym_union_declaration] = STATE(1766),
    [sym_postblit] = STATE(1766),
    [sym_invariant_declaration] = STATE(1766),
    [sym_class_declaration] = STATE(1766),
    [sym_constructor] = STATE(1766),
    [sym_destructor] = STATE(1766),
    [sym_alias_this] = STATE(1766),
    [sym_interface_declaration] = STATE(1766),
    [sym_enum_declaration] = STATE(1766),
    [sym_anonymous_enum_declaration] = STATE(1766),
    [sym_function_declaration] = STATE(1766),
    [sym_template_declaration] = STATE(1766),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1766),
    [sym_template_mixin] = STATE(1766),
    [sym_conditional_declaration] = STATE(1766),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1766),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1766),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1766),
    [sym_static_assert] = STATE(1766),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1766),
    [aux_sym_source_file_repeat1] = STATE(1766),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5434),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5436),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1761] = {
    [sym_import_declaration] = STATE(2130),
    [sym_mixin_declaration] = STATE(2130),
    [sym__declaration] = STATE(2130),
    [sym__declaration2] = STATE(2130),
    [sym_variable_declaration] = STATE(2130),
    [sym_manifest_constant] = STATE(2130),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2130),
    [sym_alias_declaration] = STATE(2130),
    [sym_alias_reassign] = STATE(2130),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2130),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2130),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2130),
    [sym_union_declaration] = STATE(2130),
    [sym_postblit] = STATE(2130),
    [sym_invariant_declaration] = STATE(2130),
    [sym_class_declaration] = STATE(2130),
    [sym_constructor] = STATE(2130),
    [sym_destructor] = STATE(2130),
    [sym_alias_this] = STATE(2130),
    [sym_interface_declaration] = STATE(2130),
    [sym_enum_declaration] = STATE(2130),
    [sym_anonymous_enum_declaration] = STATE(2130),
    [sym_function_declaration] = STATE(2130),
    [sym_template_declaration] = STATE(2130),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2130),
    [sym_template_mixin] = STATE(2130),
    [sym_conditional_declaration] = STATE(2130),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2130),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2130),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2130),
    [sym_static_assert] = STATE(2130),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2130),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5438),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5440),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1762] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5442),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1763] = {
    [sym_import_declaration] = STATE(2335),
    [sym_mixin_declaration] = STATE(2335),
    [sym__declaration] = STATE(2335),
    [sym__declaration2] = STATE(2335),
    [sym_variable_declaration] = STATE(2335),
    [sym_manifest_constant] = STATE(2335),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2335),
    [sym_alias_declaration] = STATE(2335),
    [sym_alias_reassign] = STATE(2335),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2335),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2335),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2335),
    [sym_union_declaration] = STATE(2335),
    [sym_postblit] = STATE(2335),
    [sym_invariant_declaration] = STATE(2335),
    [sym_class_declaration] = STATE(2335),
    [sym_constructor] = STATE(2335),
    [sym_destructor] = STATE(2335),
    [sym_alias_this] = STATE(2335),
    [sym_interface_declaration] = STATE(2335),
    [sym_enum_declaration] = STATE(2335),
    [sym_anonymous_enum_declaration] = STATE(2335),
    [sym_function_declaration] = STATE(2335),
    [sym_template_declaration] = STATE(2335),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2335),
    [sym_template_mixin] = STATE(2335),
    [sym_conditional_declaration] = STATE(2335),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2335),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2335),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2335),
    [sym_static_assert] = STATE(2335),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2335),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5264),
    [anon_sym_COLON] = ACTIONS(5266),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1764] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1765] = {
    [sym_import_declaration] = STATE(1784),
    [sym_mixin_declaration] = STATE(1784),
    [sym__declaration] = STATE(1784),
    [sym__declaration2] = STATE(1784),
    [sym_variable_declaration] = STATE(1784),
    [sym_manifest_constant] = STATE(1784),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1784),
    [sym_alias_declaration] = STATE(1784),
    [sym_alias_reassign] = STATE(1784),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1784),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1784),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1784),
    [sym_union_declaration] = STATE(1784),
    [sym_postblit] = STATE(1784),
    [sym_invariant_declaration] = STATE(1784),
    [sym_class_declaration] = STATE(1784),
    [sym_constructor] = STATE(1784),
    [sym_destructor] = STATE(1784),
    [sym_alias_this] = STATE(1784),
    [sym_interface_declaration] = STATE(1784),
    [sym_enum_declaration] = STATE(1784),
    [sym_anonymous_enum_declaration] = STATE(1784),
    [sym_function_declaration] = STATE(1784),
    [sym_template_declaration] = STATE(1784),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1784),
    [sym_template_mixin] = STATE(1784),
    [sym_conditional_declaration] = STATE(1784),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1784),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1784),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1784),
    [sym_static_assert] = STATE(1784),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1784),
    [aux_sym_source_file_repeat1] = STATE(1784),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5444),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5446),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1766] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5448),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1767] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5364),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1768] = {
    [sym_import_declaration] = STATE(1767),
    [sym_mixin_declaration] = STATE(1767),
    [sym__declaration] = STATE(1767),
    [sym__declaration2] = STATE(1767),
    [sym_variable_declaration] = STATE(1767),
    [sym_manifest_constant] = STATE(1767),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1767),
    [sym_alias_declaration] = STATE(1767),
    [sym_alias_reassign] = STATE(1767),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1767),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1767),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1767),
    [sym_union_declaration] = STATE(1767),
    [sym_postblit] = STATE(1767),
    [sym_invariant_declaration] = STATE(1767),
    [sym_class_declaration] = STATE(1767),
    [sym_constructor] = STATE(1767),
    [sym_destructor] = STATE(1767),
    [sym_alias_this] = STATE(1767),
    [sym_interface_declaration] = STATE(1767),
    [sym_enum_declaration] = STATE(1767),
    [sym_anonymous_enum_declaration] = STATE(1767),
    [sym_function_declaration] = STATE(1767),
    [sym_template_declaration] = STATE(1767),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1767),
    [sym_template_mixin] = STATE(1767),
    [sym_conditional_declaration] = STATE(1767),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1767),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1767),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1767),
    [sym_static_assert] = STATE(1767),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1767),
    [aux_sym_source_file_repeat1] = STATE(1767),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5450),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5452),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1769] = {
    [sym_import_declaration] = STATE(1746),
    [sym_mixin_declaration] = STATE(1746),
    [sym__declaration] = STATE(1746),
    [sym__declaration2] = STATE(1746),
    [sym_variable_declaration] = STATE(1746),
    [sym_manifest_constant] = STATE(1746),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1746),
    [sym_alias_declaration] = STATE(1746),
    [sym_alias_reassign] = STATE(1746),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1746),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1746),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1746),
    [sym_union_declaration] = STATE(1746),
    [sym_postblit] = STATE(1746),
    [sym_invariant_declaration] = STATE(1746),
    [sym_class_declaration] = STATE(1746),
    [sym_constructor] = STATE(1746),
    [sym_destructor] = STATE(1746),
    [sym_alias_this] = STATE(1746),
    [sym_interface_declaration] = STATE(1746),
    [sym_enum_declaration] = STATE(1746),
    [sym_anonymous_enum_declaration] = STATE(1746),
    [sym_function_declaration] = STATE(1746),
    [sym_template_declaration] = STATE(1746),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1746),
    [sym_template_mixin] = STATE(1746),
    [sym_conditional_declaration] = STATE(1746),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1746),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1746),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1746),
    [sym_static_assert] = STATE(1746),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1746),
    [aux_sym_source_file_repeat1] = STATE(1746),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5454),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5456),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1770] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5458),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1771] = {
    [sym_import_declaration] = STATE(1663),
    [sym_mixin_declaration] = STATE(1663),
    [sym__declaration] = STATE(1663),
    [sym__declaration2] = STATE(1663),
    [sym_variable_declaration] = STATE(1663),
    [sym_manifest_constant] = STATE(1663),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1663),
    [sym_alias_declaration] = STATE(1663),
    [sym_alias_reassign] = STATE(1663),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1663),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1663),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1663),
    [sym_union_declaration] = STATE(1663),
    [sym_postblit] = STATE(1663),
    [sym_invariant_declaration] = STATE(1663),
    [sym_class_declaration] = STATE(1663),
    [sym_constructor] = STATE(1663),
    [sym_destructor] = STATE(1663),
    [sym_alias_this] = STATE(1663),
    [sym_interface_declaration] = STATE(1663),
    [sym_enum_declaration] = STATE(1663),
    [sym_anonymous_enum_declaration] = STATE(1663),
    [sym_function_declaration] = STATE(1663),
    [sym_template_declaration] = STATE(1663),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1663),
    [sym_template_mixin] = STATE(1663),
    [sym_conditional_declaration] = STATE(1663),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1663),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1663),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1663),
    [sym_static_assert] = STATE(1663),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1663),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5460),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5462),
    [anon_sym_COLON] = ACTIONS(5356),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1772] = {
    [sym_import_declaration] = STATE(1789),
    [sym_mixin_declaration] = STATE(1789),
    [sym__declaration] = STATE(1789),
    [sym__declaration2] = STATE(1789),
    [sym_variable_declaration] = STATE(1789),
    [sym_manifest_constant] = STATE(1789),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1789),
    [sym_alias_declaration] = STATE(1789),
    [sym_alias_reassign] = STATE(1789),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1789),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1789),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1789),
    [sym_union_declaration] = STATE(1789),
    [sym_postblit] = STATE(1789),
    [sym_invariant_declaration] = STATE(1789),
    [sym_class_declaration] = STATE(1789),
    [sym_constructor] = STATE(1789),
    [sym_destructor] = STATE(1789),
    [sym_alias_this] = STATE(1789),
    [sym_interface_declaration] = STATE(1789),
    [sym_enum_declaration] = STATE(1789),
    [sym_anonymous_enum_declaration] = STATE(1789),
    [sym_function_declaration] = STATE(1789),
    [sym_template_declaration] = STATE(1789),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1789),
    [sym_template_mixin] = STATE(1789),
    [sym_conditional_declaration] = STATE(1789),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1789),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1789),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1789),
    [sym_static_assert] = STATE(1789),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1789),
    [aux_sym_source_file_repeat1] = STATE(1789),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5466),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1773] = {
    [sym_import_declaration] = STATE(1793),
    [sym_mixin_declaration] = STATE(1793),
    [sym__declaration] = STATE(1793),
    [sym__declaration2] = STATE(1793),
    [sym_variable_declaration] = STATE(1793),
    [sym_manifest_constant] = STATE(1793),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1793),
    [sym_alias_declaration] = STATE(1793),
    [sym_alias_reassign] = STATE(1793),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1793),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1793),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1793),
    [sym_union_declaration] = STATE(1793),
    [sym_postblit] = STATE(1793),
    [sym_invariant_declaration] = STATE(1793),
    [sym_class_declaration] = STATE(1793),
    [sym_constructor] = STATE(1793),
    [sym_destructor] = STATE(1793),
    [sym_alias_this] = STATE(1793),
    [sym_interface_declaration] = STATE(1793),
    [sym_enum_declaration] = STATE(1793),
    [sym_anonymous_enum_declaration] = STATE(1793),
    [sym_function_declaration] = STATE(1793),
    [sym_template_declaration] = STATE(1793),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1793),
    [sym_template_mixin] = STATE(1793),
    [sym_conditional_declaration] = STATE(1793),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1793),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1793),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1793),
    [sym_static_assert] = STATE(1793),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1793),
    [aux_sym_source_file_repeat1] = STATE(1793),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5470),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1774] = {
    [sym_import_declaration] = STATE(1770),
    [sym_mixin_declaration] = STATE(1770),
    [sym__declaration] = STATE(1770),
    [sym__declaration2] = STATE(1770),
    [sym_variable_declaration] = STATE(1770),
    [sym_manifest_constant] = STATE(1770),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1770),
    [sym_alias_declaration] = STATE(1770),
    [sym_alias_reassign] = STATE(1770),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1770),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1770),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1770),
    [sym_union_declaration] = STATE(1770),
    [sym_postblit] = STATE(1770),
    [sym_invariant_declaration] = STATE(1770),
    [sym_class_declaration] = STATE(1770),
    [sym_constructor] = STATE(1770),
    [sym_destructor] = STATE(1770),
    [sym_alias_this] = STATE(1770),
    [sym_interface_declaration] = STATE(1770),
    [sym_enum_declaration] = STATE(1770),
    [sym_anonymous_enum_declaration] = STATE(1770),
    [sym_function_declaration] = STATE(1770),
    [sym_template_declaration] = STATE(1770),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1770),
    [sym_template_mixin] = STATE(1770),
    [sym_conditional_declaration] = STATE(1770),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1770),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1770),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1770),
    [sym_static_assert] = STATE(1770),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1770),
    [aux_sym_source_file_repeat1] = STATE(1770),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5472),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5474),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1775] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1776] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5478),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1777] = {
    [sym_import_declaration] = STATE(1811),
    [sym_mixin_declaration] = STATE(1811),
    [sym__declaration] = STATE(1811),
    [sym__declaration2] = STATE(1811),
    [sym_variable_declaration] = STATE(1811),
    [sym_manifest_constant] = STATE(1811),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1811),
    [sym_alias_declaration] = STATE(1811),
    [sym_alias_reassign] = STATE(1811),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1811),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1811),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1811),
    [sym_union_declaration] = STATE(1811),
    [sym_postblit] = STATE(1811),
    [sym_invariant_declaration] = STATE(1811),
    [sym_class_declaration] = STATE(1811),
    [sym_constructor] = STATE(1811),
    [sym_destructor] = STATE(1811),
    [sym_alias_this] = STATE(1811),
    [sym_interface_declaration] = STATE(1811),
    [sym_enum_declaration] = STATE(1811),
    [sym_anonymous_enum_declaration] = STATE(1811),
    [sym_function_declaration] = STATE(1811),
    [sym_template_declaration] = STATE(1811),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1811),
    [sym_template_mixin] = STATE(1811),
    [sym_conditional_declaration] = STATE(1811),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1811),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1811),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1811),
    [sym_static_assert] = STATE(1811),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1811),
    [aux_sym_source_file_repeat1] = STATE(1811),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5480),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5482),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1778] = {
    [sym_import_declaration] = STATE(1762),
    [sym_mixin_declaration] = STATE(1762),
    [sym__declaration] = STATE(1762),
    [sym__declaration2] = STATE(1762),
    [sym_variable_declaration] = STATE(1762),
    [sym_manifest_constant] = STATE(1762),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1762),
    [sym_alias_declaration] = STATE(1762),
    [sym_alias_reassign] = STATE(1762),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1762),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1762),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1762),
    [sym_union_declaration] = STATE(1762),
    [sym_postblit] = STATE(1762),
    [sym_invariant_declaration] = STATE(1762),
    [sym_class_declaration] = STATE(1762),
    [sym_constructor] = STATE(1762),
    [sym_destructor] = STATE(1762),
    [sym_alias_this] = STATE(1762),
    [sym_interface_declaration] = STATE(1762),
    [sym_enum_declaration] = STATE(1762),
    [sym_anonymous_enum_declaration] = STATE(1762),
    [sym_function_declaration] = STATE(1762),
    [sym_template_declaration] = STATE(1762),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1762),
    [sym_template_mixin] = STATE(1762),
    [sym_conditional_declaration] = STATE(1762),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1762),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1762),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1762),
    [sym_static_assert] = STATE(1762),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1762),
    [aux_sym_source_file_repeat1] = STATE(1762),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5476),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5484),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1779] = {
    [sym_import_declaration] = STATE(1775),
    [sym_mixin_declaration] = STATE(1775),
    [sym__declaration] = STATE(1775),
    [sym__declaration2] = STATE(1775),
    [sym_variable_declaration] = STATE(1775),
    [sym_manifest_constant] = STATE(1775),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1775),
    [sym_alias_declaration] = STATE(1775),
    [sym_alias_reassign] = STATE(1775),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1775),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1775),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1775),
    [sym_union_declaration] = STATE(1775),
    [sym_postblit] = STATE(1775),
    [sym_invariant_declaration] = STATE(1775),
    [sym_class_declaration] = STATE(1775),
    [sym_constructor] = STATE(1775),
    [sym_destructor] = STATE(1775),
    [sym_alias_this] = STATE(1775),
    [sym_interface_declaration] = STATE(1775),
    [sym_enum_declaration] = STATE(1775),
    [sym_anonymous_enum_declaration] = STATE(1775),
    [sym_function_declaration] = STATE(1775),
    [sym_template_declaration] = STATE(1775),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1775),
    [sym_template_mixin] = STATE(1775),
    [sym_conditional_declaration] = STATE(1775),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1775),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1775),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1775),
    [sym_static_assert] = STATE(1775),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1775),
    [aux_sym_source_file_repeat1] = STATE(1775),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5488),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1780] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5486),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1781] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5490),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1782] = {
    [sym_import_declaration] = STATE(1798),
    [sym_mixin_declaration] = STATE(1798),
    [sym__declaration] = STATE(1798),
    [sym__declaration2] = STATE(1798),
    [sym_variable_declaration] = STATE(1798),
    [sym_manifest_constant] = STATE(1798),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1798),
    [sym_alias_declaration] = STATE(1798),
    [sym_alias_reassign] = STATE(1798),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1798),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1798),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1798),
    [sym_union_declaration] = STATE(1798),
    [sym_postblit] = STATE(1798),
    [sym_invariant_declaration] = STATE(1798),
    [sym_class_declaration] = STATE(1798),
    [sym_constructor] = STATE(1798),
    [sym_destructor] = STATE(1798),
    [sym_alias_this] = STATE(1798),
    [sym_interface_declaration] = STATE(1798),
    [sym_enum_declaration] = STATE(1798),
    [sym_anonymous_enum_declaration] = STATE(1798),
    [sym_function_declaration] = STATE(1798),
    [sym_template_declaration] = STATE(1798),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1798),
    [sym_template_mixin] = STATE(1798),
    [sym_conditional_declaration] = STATE(1798),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1798),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1798),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1798),
    [sym_static_assert] = STATE(1798),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1798),
    [aux_sym_source_file_repeat1] = STATE(1798),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5492),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5494),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1783] = {
    [sym_import_declaration] = STATE(1734),
    [sym_mixin_declaration] = STATE(1734),
    [sym__declaration] = STATE(1734),
    [sym__declaration2] = STATE(1734),
    [sym_variable_declaration] = STATE(1734),
    [sym_manifest_constant] = STATE(1734),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1734),
    [sym_alias_declaration] = STATE(1734),
    [sym_alias_reassign] = STATE(1734),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1734),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1734),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1734),
    [sym_union_declaration] = STATE(1734),
    [sym_postblit] = STATE(1734),
    [sym_invariant_declaration] = STATE(1734),
    [sym_class_declaration] = STATE(1734),
    [sym_constructor] = STATE(1734),
    [sym_destructor] = STATE(1734),
    [sym_alias_this] = STATE(1734),
    [sym_interface_declaration] = STATE(1734),
    [sym_enum_declaration] = STATE(1734),
    [sym_anonymous_enum_declaration] = STATE(1734),
    [sym_function_declaration] = STATE(1734),
    [sym_template_declaration] = STATE(1734),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1734),
    [sym_template_mixin] = STATE(1734),
    [sym_conditional_declaration] = STATE(1734),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1734),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1734),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1734),
    [sym_static_assert] = STATE(1734),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1734),
    [aux_sym_source_file_repeat1] = STATE(1734),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5496),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1784] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5464),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1785] = {
    [sym_import_declaration] = STATE(1757),
    [sym_mixin_declaration] = STATE(1757),
    [sym__declaration] = STATE(1757),
    [sym__declaration2] = STATE(1757),
    [sym_variable_declaration] = STATE(1757),
    [sym_manifest_constant] = STATE(1757),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1757),
    [sym_alias_declaration] = STATE(1757),
    [sym_alias_reassign] = STATE(1757),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1757),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1757),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1757),
    [sym_union_declaration] = STATE(1757),
    [sym_postblit] = STATE(1757),
    [sym_invariant_declaration] = STATE(1757),
    [sym_class_declaration] = STATE(1757),
    [sym_constructor] = STATE(1757),
    [sym_destructor] = STATE(1757),
    [sym_alias_this] = STATE(1757),
    [sym_interface_declaration] = STATE(1757),
    [sym_enum_declaration] = STATE(1757),
    [sym_anonymous_enum_declaration] = STATE(1757),
    [sym_function_declaration] = STATE(1757),
    [sym_template_declaration] = STATE(1757),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1757),
    [sym_template_mixin] = STATE(1757),
    [sym_conditional_declaration] = STATE(1757),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1757),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1757),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1757),
    [sym_static_assert] = STATE(1757),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1757),
    [aux_sym_source_file_repeat1] = STATE(1757),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1786] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5500),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1787] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1788] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5506),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1789] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1790] = {
    [sym_import_declaration] = STATE(1576),
    [sym_mixin_declaration] = STATE(1576),
    [sym__declaration] = STATE(1576),
    [sym__declaration2] = STATE(1576),
    [sym_variable_declaration] = STATE(1576),
    [sym_manifest_constant] = STATE(1576),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1576),
    [sym_alias_declaration] = STATE(1576),
    [sym_alias_reassign] = STATE(1576),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1576),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1576),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1576),
    [sym_union_declaration] = STATE(1576),
    [sym_postblit] = STATE(1576),
    [sym_invariant_declaration] = STATE(1576),
    [sym_class_declaration] = STATE(1576),
    [sym_constructor] = STATE(1576),
    [sym_destructor] = STATE(1576),
    [sym_alias_this] = STATE(1576),
    [sym_interface_declaration] = STATE(1576),
    [sym_enum_declaration] = STATE(1576),
    [sym_anonymous_enum_declaration] = STATE(1576),
    [sym_function_declaration] = STATE(1576),
    [sym_template_declaration] = STATE(1576),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1576),
    [sym_template_mixin] = STATE(1576),
    [sym_conditional_declaration] = STATE(1576),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1576),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1576),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1576),
    [sym_static_assert] = STATE(1576),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1576),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5510),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5512),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1791] = {
    [sym_import_declaration] = STATE(2236),
    [sym_mixin_declaration] = STATE(2236),
    [sym__declaration] = STATE(2236),
    [sym__declaration2] = STATE(2236),
    [sym_variable_declaration] = STATE(2236),
    [sym_manifest_constant] = STATE(2236),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2236),
    [sym_alias_declaration] = STATE(2236),
    [sym_alias_reassign] = STATE(2236),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2236),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2236),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2236),
    [sym_union_declaration] = STATE(2236),
    [sym_postblit] = STATE(2236),
    [sym_invariant_declaration] = STATE(2236),
    [sym_class_declaration] = STATE(2236),
    [sym_constructor] = STATE(2236),
    [sym_destructor] = STATE(2236),
    [sym_alias_this] = STATE(2236),
    [sym_interface_declaration] = STATE(2236),
    [sym_enum_declaration] = STATE(2236),
    [sym_anonymous_enum_declaration] = STATE(2236),
    [sym_function_declaration] = STATE(2236),
    [sym_template_declaration] = STATE(2236),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2236),
    [sym_template_mixin] = STATE(2236),
    [sym_conditional_declaration] = STATE(2236),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2236),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2236),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2236),
    [sym_static_assert] = STATE(2236),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2236),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1792] = {
    [sym_import_declaration] = STATE(1788),
    [sym_mixin_declaration] = STATE(1788),
    [sym__declaration] = STATE(1788),
    [sym__declaration2] = STATE(1788),
    [sym_variable_declaration] = STATE(1788),
    [sym_manifest_constant] = STATE(1788),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1788),
    [sym_alias_declaration] = STATE(1788),
    [sym_alias_reassign] = STATE(1788),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1788),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1788),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1788),
    [sym_union_declaration] = STATE(1788),
    [sym_postblit] = STATE(1788),
    [sym_invariant_declaration] = STATE(1788),
    [sym_class_declaration] = STATE(1788),
    [sym_constructor] = STATE(1788),
    [sym_destructor] = STATE(1788),
    [sym_alias_this] = STATE(1788),
    [sym_interface_declaration] = STATE(1788),
    [sym_enum_declaration] = STATE(1788),
    [sym_anonymous_enum_declaration] = STATE(1788),
    [sym_function_declaration] = STATE(1788),
    [sym_template_declaration] = STATE(1788),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1788),
    [sym_template_mixin] = STATE(1788),
    [sym_conditional_declaration] = STATE(1788),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1788),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1788),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1788),
    [sym_static_assert] = STATE(1788),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1788),
    [aux_sym_source_file_repeat1] = STATE(1788),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5522),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1793] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5520),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1794] = {
    [sym_import_declaration] = STATE(1780),
    [sym_mixin_declaration] = STATE(1780),
    [sym__declaration] = STATE(1780),
    [sym__declaration2] = STATE(1780),
    [sym_variable_declaration] = STATE(1780),
    [sym_manifest_constant] = STATE(1780),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1780),
    [sym_alias_declaration] = STATE(1780),
    [sym_alias_reassign] = STATE(1780),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1780),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1780),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1780),
    [sym_union_declaration] = STATE(1780),
    [sym_postblit] = STATE(1780),
    [sym_invariant_declaration] = STATE(1780),
    [sym_class_declaration] = STATE(1780),
    [sym_constructor] = STATE(1780),
    [sym_destructor] = STATE(1780),
    [sym_alias_this] = STATE(1780),
    [sym_interface_declaration] = STATE(1780),
    [sym_enum_declaration] = STATE(1780),
    [sym_anonymous_enum_declaration] = STATE(1780),
    [sym_function_declaration] = STATE(1780),
    [sym_template_declaration] = STATE(1780),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1780),
    [sym_template_mixin] = STATE(1780),
    [sym_conditional_declaration] = STATE(1780),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1780),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1780),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1780),
    [sym_static_assert] = STATE(1780),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1780),
    [aux_sym_source_file_repeat1] = STATE(1780),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5524),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5526),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1795] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5528),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1796] = {
    [sym_import_declaration] = STATE(1573),
    [sym_mixin_declaration] = STATE(1573),
    [sym__declaration] = STATE(1573),
    [sym__declaration2] = STATE(1573),
    [sym_variable_declaration] = STATE(1573),
    [sym_manifest_constant] = STATE(1573),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1573),
    [sym_alias_declaration] = STATE(1573),
    [sym_alias_reassign] = STATE(1573),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1573),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1573),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1573),
    [sym_union_declaration] = STATE(1573),
    [sym_postblit] = STATE(1573),
    [sym_invariant_declaration] = STATE(1573),
    [sym_class_declaration] = STATE(1573),
    [sym_constructor] = STATE(1573),
    [sym_destructor] = STATE(1573),
    [sym_alias_this] = STATE(1573),
    [sym_interface_declaration] = STATE(1573),
    [sym_enum_declaration] = STATE(1573),
    [sym_anonymous_enum_declaration] = STATE(1573),
    [sym_function_declaration] = STATE(1573),
    [sym_template_declaration] = STATE(1573),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1573),
    [sym_template_mixin] = STATE(1573),
    [sym_conditional_declaration] = STATE(1573),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1573),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1573),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1573),
    [sym_static_assert] = STATE(1573),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1573),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5530),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5532),
    [anon_sym_COLON] = ACTIONS(1284),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1797] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5534),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1798] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5536),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1799] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5538),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1800] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5540),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1801] = {
    [sym_import_declaration] = STATE(1717),
    [sym_mixin_declaration] = STATE(1717),
    [sym__declaration] = STATE(1717),
    [sym__declaration2] = STATE(1717),
    [sym_variable_declaration] = STATE(1717),
    [sym_manifest_constant] = STATE(1717),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1717),
    [sym_alias_declaration] = STATE(1717),
    [sym_alias_reassign] = STATE(1717),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1717),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1717),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1717),
    [sym_union_declaration] = STATE(1717),
    [sym_postblit] = STATE(1717),
    [sym_invariant_declaration] = STATE(1717),
    [sym_class_declaration] = STATE(1717),
    [sym_constructor] = STATE(1717),
    [sym_destructor] = STATE(1717),
    [sym_alias_this] = STATE(1717),
    [sym_interface_declaration] = STATE(1717),
    [sym_enum_declaration] = STATE(1717),
    [sym_anonymous_enum_declaration] = STATE(1717),
    [sym_function_declaration] = STATE(1717),
    [sym_template_declaration] = STATE(1717),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1717),
    [sym_template_mixin] = STATE(1717),
    [sym_conditional_declaration] = STATE(1717),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1717),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1717),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1717),
    [sym_static_assert] = STATE(1717),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1717),
    [aux_sym_source_file_repeat1] = STATE(1717),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5542),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5544),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1802] = {
    [sym_import_declaration] = STATE(2044),
    [sym_mixin_declaration] = STATE(2044),
    [sym__declaration] = STATE(2044),
    [sym__declaration2] = STATE(2044),
    [sym_variable_declaration] = STATE(2044),
    [sym_manifest_constant] = STATE(2044),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2044),
    [sym_alias_declaration] = STATE(2044),
    [sym_alias_reassign] = STATE(2044),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2044),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2044),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2044),
    [sym_union_declaration] = STATE(2044),
    [sym_postblit] = STATE(2044),
    [sym_invariant_declaration] = STATE(2044),
    [sym_class_declaration] = STATE(2044),
    [sym_constructor] = STATE(2044),
    [sym_destructor] = STATE(2044),
    [sym_alias_this] = STATE(2044),
    [sym_interface_declaration] = STATE(2044),
    [sym_enum_declaration] = STATE(2044),
    [sym_anonymous_enum_declaration] = STATE(2044),
    [sym_function_declaration] = STATE(2044),
    [sym_template_declaration] = STATE(2044),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2044),
    [sym_template_mixin] = STATE(2044),
    [sym_conditional_declaration] = STATE(2044),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2044),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2044),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2044),
    [sym_static_assert] = STATE(2044),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2044),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5412),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5414),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1803] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5546),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1804] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(5090),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1805] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5548),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1806] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5550),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1807] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1808] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5552),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1809] = {
    [sym_import_declaration] = STATE(1786),
    [sym_mixin_declaration] = STATE(1786),
    [sym__declaration] = STATE(1786),
    [sym__declaration2] = STATE(1786),
    [sym_variable_declaration] = STATE(1786),
    [sym_manifest_constant] = STATE(1786),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1786),
    [sym_alias_declaration] = STATE(1786),
    [sym_alias_reassign] = STATE(1786),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1786),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1786),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1786),
    [sym_union_declaration] = STATE(1786),
    [sym_postblit] = STATE(1786),
    [sym_invariant_declaration] = STATE(1786),
    [sym_class_declaration] = STATE(1786),
    [sym_constructor] = STATE(1786),
    [sym_destructor] = STATE(1786),
    [sym_alias_this] = STATE(1786),
    [sym_interface_declaration] = STATE(1786),
    [sym_enum_declaration] = STATE(1786),
    [sym_anonymous_enum_declaration] = STATE(1786),
    [sym_function_declaration] = STATE(1786),
    [sym_template_declaration] = STATE(1786),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1786),
    [sym_template_mixin] = STATE(1786),
    [sym_conditional_declaration] = STATE(1786),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1786),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1786),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1786),
    [sym_static_assert] = STATE(1786),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1786),
    [aux_sym_source_file_repeat1] = STATE(1786),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5370),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5554),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1810] = {
    [sym_import_declaration] = STATE(1787),
    [sym_mixin_declaration] = STATE(1787),
    [sym__declaration] = STATE(1787),
    [sym__declaration2] = STATE(1787),
    [sym_variable_declaration] = STATE(1787),
    [sym_manifest_constant] = STATE(1787),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1787),
    [sym_alias_declaration] = STATE(1787),
    [sym_alias_reassign] = STATE(1787),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1787),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1787),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1787),
    [sym_union_declaration] = STATE(1787),
    [sym_postblit] = STATE(1787),
    [sym_invariant_declaration] = STATE(1787),
    [sym_class_declaration] = STATE(1787),
    [sym_constructor] = STATE(1787),
    [sym_destructor] = STATE(1787),
    [sym_alias_this] = STATE(1787),
    [sym_interface_declaration] = STATE(1787),
    [sym_enum_declaration] = STATE(1787),
    [sym_anonymous_enum_declaration] = STATE(1787),
    [sym_function_declaration] = STATE(1787),
    [sym_template_declaration] = STATE(1787),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1787),
    [sym_template_mixin] = STATE(1787),
    [sym_conditional_declaration] = STATE(1787),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1787),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1787),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1787),
    [sym_static_assert] = STATE(1787),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1787),
    [aux_sym_source_file_repeat1] = STATE(1787),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5558),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1811] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5560),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1812] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5556),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1813] = {
    [sym_import_declaration] = STATE(2015),
    [sym_mixin_declaration] = STATE(2015),
    [sym__declaration] = STATE(2015),
    [sym__declaration2] = STATE(2015),
    [sym_variable_declaration] = STATE(2015),
    [sym_manifest_constant] = STATE(2015),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2015),
    [sym_alias_declaration] = STATE(2015),
    [sym_alias_reassign] = STATE(2015),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2015),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2015),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2015),
    [sym_union_declaration] = STATE(2015),
    [sym_postblit] = STATE(2015),
    [sym_invariant_declaration] = STATE(2015),
    [sym_class_declaration] = STATE(2015),
    [sym_constructor] = STATE(2015),
    [sym_destructor] = STATE(2015),
    [sym_alias_this] = STATE(2015),
    [sym_interface_declaration] = STATE(2015),
    [sym_enum_declaration] = STATE(2015),
    [sym_anonymous_enum_declaration] = STATE(2015),
    [sym_function_declaration] = STATE(2015),
    [sym_template_declaration] = STATE(2015),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2015),
    [sym_template_mixin] = STATE(2015),
    [sym_conditional_declaration] = STATE(2015),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2015),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2015),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2015),
    [sym_static_assert] = STATE(2015),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2015),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5562),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5564),
    [anon_sym_COLON] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1814] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5468),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1815] = {
    [sym_import_declaration] = STATE(1860),
    [sym_mixin_declaration] = STATE(1860),
    [sym__declaration] = STATE(1860),
    [sym__declaration2] = STATE(1860),
    [sym_variable_declaration] = STATE(1860),
    [sym_manifest_constant] = STATE(1860),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1860),
    [sym_alias_declaration] = STATE(1860),
    [sym_alias_reassign] = STATE(1860),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1860),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1860),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1860),
    [sym_union_declaration] = STATE(1860),
    [sym_postblit] = STATE(1860),
    [sym_invariant_declaration] = STATE(1860),
    [sym_class_declaration] = STATE(1860),
    [sym_constructor] = STATE(1860),
    [sym_destructor] = STATE(1860),
    [sym_alias_this] = STATE(1860),
    [sym_interface_declaration] = STATE(1860),
    [sym_enum_declaration] = STATE(1860),
    [sym_anonymous_enum_declaration] = STATE(1860),
    [sym_function_declaration] = STATE(1860),
    [sym_template_declaration] = STATE(1860),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1860),
    [sym_template_mixin] = STATE(1860),
    [sym_conditional_declaration] = STATE(1860),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1860),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1860),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1860),
    [sym_static_assert] = STATE(1860),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1860),
    [aux_sym_source_file_repeat1] = STATE(1860),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5568),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1816] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5570),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1817] = {
    [sym_import_declaration] = STATE(1795),
    [sym_mixin_declaration] = STATE(1795),
    [sym__declaration] = STATE(1795),
    [sym__declaration2] = STATE(1795),
    [sym_variable_declaration] = STATE(1795),
    [sym_manifest_constant] = STATE(1795),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1795),
    [sym_alias_declaration] = STATE(1795),
    [sym_alias_reassign] = STATE(1795),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1795),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1795),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1795),
    [sym_union_declaration] = STATE(1795),
    [sym_postblit] = STATE(1795),
    [sym_invariant_declaration] = STATE(1795),
    [sym_class_declaration] = STATE(1795),
    [sym_constructor] = STATE(1795),
    [sym_destructor] = STATE(1795),
    [sym_alias_this] = STATE(1795),
    [sym_interface_declaration] = STATE(1795),
    [sym_enum_declaration] = STATE(1795),
    [sym_anonymous_enum_declaration] = STATE(1795),
    [sym_function_declaration] = STATE(1795),
    [sym_template_declaration] = STATE(1795),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1795),
    [sym_template_mixin] = STATE(1795),
    [sym_conditional_declaration] = STATE(1795),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1795),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1795),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1795),
    [sym_static_assert] = STATE(1795),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1795),
    [aux_sym_source_file_repeat1] = STATE(1795),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5574),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1818] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5572),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1819] = {
    [sym_import_declaration] = STATE(1436),
    [sym_mixin_declaration] = STATE(1436),
    [sym__declaration] = STATE(1436),
    [sym__declaration2] = STATE(1436),
    [sym_variable_declaration] = STATE(1436),
    [sym_manifest_constant] = STATE(1436),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1436),
    [sym_alias_declaration] = STATE(1436),
    [sym_alias_reassign] = STATE(1436),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1436),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1436),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1436),
    [sym_union_declaration] = STATE(1436),
    [sym_postblit] = STATE(1436),
    [sym_invariant_declaration] = STATE(1436),
    [sym_class_declaration] = STATE(1436),
    [sym_constructor] = STATE(1436),
    [sym_destructor] = STATE(1436),
    [sym_alias_this] = STATE(1436),
    [sym_interface_declaration] = STATE(1436),
    [sym_enum_declaration] = STATE(1436),
    [sym_anonymous_enum_declaration] = STATE(1436),
    [sym_function_declaration] = STATE(1436),
    [sym_template_declaration] = STATE(1436),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1436),
    [sym_template_mixin] = STATE(1436),
    [sym_conditional_declaration] = STATE(1436),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1436),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1436),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1436),
    [sym_static_assert] = STATE(1436),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1436),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5576),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5468),
    [anon_sym_COLON] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1820] = {
    [sym_import_declaration] = STATE(2412),
    [sym_mixin_declaration] = STATE(2412),
    [sym__declaration] = STATE(2412),
    [sym__declaration2] = STATE(2412),
    [sym_variable_declaration] = STATE(2412),
    [sym_manifest_constant] = STATE(2412),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2412),
    [sym_alias_declaration] = STATE(2412),
    [sym_alias_reassign] = STATE(2412),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2412),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2412),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2412),
    [sym_union_declaration] = STATE(2412),
    [sym_postblit] = STATE(2412),
    [sym_invariant_declaration] = STATE(2412),
    [sym_class_declaration] = STATE(2412),
    [sym_constructor] = STATE(2412),
    [sym_destructor] = STATE(2412),
    [sym_alias_this] = STATE(2412),
    [sym_interface_declaration] = STATE(2412),
    [sym_enum_declaration] = STATE(2412),
    [sym_anonymous_enum_declaration] = STATE(2412),
    [sym_function_declaration] = STATE(2412),
    [sym_template_declaration] = STATE(2412),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2412),
    [sym_template_mixin] = STATE(2412),
    [sym_conditional_declaration] = STATE(2412),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2412),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2412),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2412),
    [sym_static_assert] = STATE(2412),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2412),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5578),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5580),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1821] = {
    [sym_import_declaration] = STATE(2399),
    [sym_mixin_declaration] = STATE(2399),
    [sym__declaration] = STATE(2399),
    [sym__declaration2] = STATE(2399),
    [sym_variable_declaration] = STATE(2399),
    [sym_manifest_constant] = STATE(2399),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2399),
    [sym_alias_declaration] = STATE(2399),
    [sym_alias_reassign] = STATE(2399),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2399),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2399),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2399),
    [sym_union_declaration] = STATE(2399),
    [sym_postblit] = STATE(2399),
    [sym_invariant_declaration] = STATE(2399),
    [sym_class_declaration] = STATE(2399),
    [sym_constructor] = STATE(2399),
    [sym_destructor] = STATE(2399),
    [sym_alias_this] = STATE(2399),
    [sym_interface_declaration] = STATE(2399),
    [sym_enum_declaration] = STATE(2399),
    [sym_anonymous_enum_declaration] = STATE(2399),
    [sym_function_declaration] = STATE(2399),
    [sym_template_declaration] = STATE(2399),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2399),
    [sym_template_mixin] = STATE(2399),
    [sym_conditional_declaration] = STATE(2399),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2399),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2399),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2399),
    [sym_static_assert] = STATE(2399),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2399),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5584),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1822] = {
    [sym_import_declaration] = STATE(1370),
    [sym_mixin_declaration] = STATE(1370),
    [sym__declaration] = STATE(1370),
    [sym__declaration2] = STATE(1370),
    [sym_variable_declaration] = STATE(1370),
    [sym_manifest_constant] = STATE(1370),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1370),
    [sym_alias_declaration] = STATE(1370),
    [sym_alias_reassign] = STATE(1370),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1370),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1370),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1370),
    [sym_union_declaration] = STATE(1370),
    [sym_postblit] = STATE(1370),
    [sym_invariant_declaration] = STATE(1370),
    [sym_class_declaration] = STATE(1370),
    [sym_constructor] = STATE(1370),
    [sym_destructor] = STATE(1370),
    [sym_alias_this] = STATE(1370),
    [sym_interface_declaration] = STATE(1370),
    [sym_enum_declaration] = STATE(1370),
    [sym_anonymous_enum_declaration] = STATE(1370),
    [sym_function_declaration] = STATE(1370),
    [sym_template_declaration] = STATE(1370),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1370),
    [sym_template_mixin] = STATE(1370),
    [sym_conditional_declaration] = STATE(1370),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1370),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1370),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1370),
    [sym_static_assert] = STATE(1370),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1370),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5590),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_COLON] = ACTIONS(5298),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1823] = {
    [sym_import_declaration] = STATE(1764),
    [sym_mixin_declaration] = STATE(1764),
    [sym__declaration] = STATE(1764),
    [sym__declaration2] = STATE(1764),
    [sym_variable_declaration] = STATE(1764),
    [sym_manifest_constant] = STATE(1764),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1764),
    [sym_alias_declaration] = STATE(1764),
    [sym_alias_reassign] = STATE(1764),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1764),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1764),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1764),
    [sym_union_declaration] = STATE(1764),
    [sym_postblit] = STATE(1764),
    [sym_invariant_declaration] = STATE(1764),
    [sym_class_declaration] = STATE(1764),
    [sym_constructor] = STATE(1764),
    [sym_destructor] = STATE(1764),
    [sym_alias_this] = STATE(1764),
    [sym_interface_declaration] = STATE(1764),
    [sym_enum_declaration] = STATE(1764),
    [sym_anonymous_enum_declaration] = STATE(1764),
    [sym_function_declaration] = STATE(1764),
    [sym_template_declaration] = STATE(1764),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1764),
    [sym_template_mixin] = STATE(1764),
    [sym_conditional_declaration] = STATE(1764),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1764),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1764),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1764),
    [sym_static_assert] = STATE(1764),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1764),
    [aux_sym_source_file_repeat1] = STATE(1764),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5594),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1824] = {
    [sym_import_declaration] = STATE(5400),
    [sym_mixin_declaration] = STATE(5400),
    [sym__declaration] = STATE(5400),
    [sym__declaration2] = STATE(5400),
    [sym_variable_declaration] = STATE(5400),
    [sym_manifest_constant] = STATE(5400),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(5400),
    [sym_alias_declaration] = STATE(5400),
    [sym_alias_reassign] = STATE(5400),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(5400),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(5400),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(5400),
    [sym_union_declaration] = STATE(5400),
    [sym_postblit] = STATE(5400),
    [sym_invariant_declaration] = STATE(5400),
    [sym_class_declaration] = STATE(5400),
    [sym_constructor] = STATE(5400),
    [sym_destructor] = STATE(5400),
    [sym_alias_this] = STATE(5400),
    [sym_interface_declaration] = STATE(5400),
    [sym_enum_declaration] = STATE(5400),
    [sym_anonymous_enum_declaration] = STATE(5400),
    [sym_function_declaration] = STATE(5400),
    [sym_template_declaration] = STATE(5400),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(5400),
    [sym_template_mixin] = STATE(5400),
    [sym_conditional_declaration] = STATE(5400),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(5400),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(5400),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(5400),
    [sym_static_assert] = STATE(5400),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(5400),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5598),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5600),
    [anon_sym_COLON] = ACTIONS(1814),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1825] = {
    [sym_import_declaration] = STATE(1440),
    [sym_mixin_declaration] = STATE(1440),
    [sym__declaration] = STATE(1440),
    [sym__declaration2] = STATE(1440),
    [sym_variable_declaration] = STATE(1440),
    [sym_manifest_constant] = STATE(1440),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1440),
    [sym_alias_declaration] = STATE(1440),
    [sym_alias_reassign] = STATE(1440),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1440),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1440),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1440),
    [sym_union_declaration] = STATE(1440),
    [sym_postblit] = STATE(1440),
    [sym_invariant_declaration] = STATE(1440),
    [sym_class_declaration] = STATE(1440),
    [sym_constructor] = STATE(1440),
    [sym_destructor] = STATE(1440),
    [sym_alias_this] = STATE(1440),
    [sym_interface_declaration] = STATE(1440),
    [sym_enum_declaration] = STATE(1440),
    [sym_anonymous_enum_declaration] = STATE(1440),
    [sym_function_declaration] = STATE(1440),
    [sym_template_declaration] = STATE(1440),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1440),
    [sym_template_mixin] = STATE(1440),
    [sym_conditional_declaration] = STATE(1440),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1440),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1440),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1440),
    [sym_static_assert] = STATE(1440),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1440),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5602),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5604),
    [anon_sym_COLON] = ACTIONS(1176),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1826] = {
    [sym_import_declaration] = STATE(1878),
    [sym_mixin_declaration] = STATE(1878),
    [sym__declaration] = STATE(1878),
    [sym__declaration2] = STATE(1878),
    [sym_variable_declaration] = STATE(1878),
    [sym_manifest_constant] = STATE(1878),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1878),
    [sym_alias_declaration] = STATE(1878),
    [sym_alias_reassign] = STATE(1878),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1878),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1878),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1878),
    [sym_union_declaration] = STATE(1878),
    [sym_postblit] = STATE(1878),
    [sym_invariant_declaration] = STATE(1878),
    [sym_class_declaration] = STATE(1878),
    [sym_constructor] = STATE(1878),
    [sym_destructor] = STATE(1878),
    [sym_alias_this] = STATE(1878),
    [sym_interface_declaration] = STATE(1878),
    [sym_enum_declaration] = STATE(1878),
    [sym_anonymous_enum_declaration] = STATE(1878),
    [sym_function_declaration] = STATE(1878),
    [sym_template_declaration] = STATE(1878),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1878),
    [sym_template_mixin] = STATE(1878),
    [sym_conditional_declaration] = STATE(1878),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1878),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1878),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1878),
    [sym_static_assert] = STATE(1878),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1878),
    [aux_sym_source_file_repeat1] = STATE(1878),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5606),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5608),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1827] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1828] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5612),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1829] = {
    [sym_import_declaration] = STATE(1806),
    [sym_mixin_declaration] = STATE(1806),
    [sym__declaration] = STATE(1806),
    [sym__declaration2] = STATE(1806),
    [sym_variable_declaration] = STATE(1806),
    [sym_manifest_constant] = STATE(1806),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1806),
    [sym_alias_declaration] = STATE(1806),
    [sym_alias_reassign] = STATE(1806),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1806),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1806),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1806),
    [sym_union_declaration] = STATE(1806),
    [sym_postblit] = STATE(1806),
    [sym_invariant_declaration] = STATE(1806),
    [sym_class_declaration] = STATE(1806),
    [sym_constructor] = STATE(1806),
    [sym_destructor] = STATE(1806),
    [sym_alias_this] = STATE(1806),
    [sym_interface_declaration] = STATE(1806),
    [sym_enum_declaration] = STATE(1806),
    [sym_anonymous_enum_declaration] = STATE(1806),
    [sym_function_declaration] = STATE(1806),
    [sym_template_declaration] = STATE(1806),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1806),
    [sym_template_mixin] = STATE(1806),
    [sym_conditional_declaration] = STATE(1806),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1806),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1806),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1806),
    [sym_static_assert] = STATE(1806),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1806),
    [aux_sym_source_file_repeat1] = STATE(1806),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5614),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5616),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1830] = {
    [sym_import_declaration] = STATE(1844),
    [sym_mixin_declaration] = STATE(1844),
    [sym__declaration] = STATE(1844),
    [sym__declaration2] = STATE(1844),
    [sym_variable_declaration] = STATE(1844),
    [sym_manifest_constant] = STATE(1844),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1844),
    [sym_alias_declaration] = STATE(1844),
    [sym_alias_reassign] = STATE(1844),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1844),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1844),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1844),
    [sym_union_declaration] = STATE(1844),
    [sym_postblit] = STATE(1844),
    [sym_invariant_declaration] = STATE(1844),
    [sym_class_declaration] = STATE(1844),
    [sym_constructor] = STATE(1844),
    [sym_destructor] = STATE(1844),
    [sym_alias_this] = STATE(1844),
    [sym_interface_declaration] = STATE(1844),
    [sym_enum_declaration] = STATE(1844),
    [sym_anonymous_enum_declaration] = STATE(1844),
    [sym_function_declaration] = STATE(1844),
    [sym_template_declaration] = STATE(1844),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1844),
    [sym_template_mixin] = STATE(1844),
    [sym_conditional_declaration] = STATE(1844),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1844),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1844),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1844),
    [sym_static_assert] = STATE(1844),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1844),
    [aux_sym_source_file_repeat1] = STATE(1844),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5618),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5620),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1831] = {
    [sym_import_declaration] = STATE(4721),
    [sym_mixin_declaration] = STATE(4721),
    [sym__declaration] = STATE(4721),
    [sym__declaration2] = STATE(4721),
    [sym_variable_declaration] = STATE(4721),
    [sym_manifest_constant] = STATE(4721),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(4721),
    [sym_alias_declaration] = STATE(4721),
    [sym_alias_reassign] = STATE(4721),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(4721),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(4721),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(4721),
    [sym_union_declaration] = STATE(4721),
    [sym_postblit] = STATE(4721),
    [sym_invariant_declaration] = STATE(4721),
    [sym_class_declaration] = STATE(4721),
    [sym_constructor] = STATE(4721),
    [sym_destructor] = STATE(4721),
    [sym_alias_this] = STATE(4721),
    [sym_interface_declaration] = STATE(4721),
    [sym_enum_declaration] = STATE(4721),
    [sym_anonymous_enum_declaration] = STATE(4721),
    [sym_function_declaration] = STATE(4721),
    [sym_template_declaration] = STATE(4721),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(4721),
    [sym_template_mixin] = STATE(4721),
    [sym_conditional_declaration] = STATE(4721),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(4721),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(4721),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(4721),
    [sym_static_assert] = STATE(4721),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(4721),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5622),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5624),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1832] = {
    [sym_import_declaration] = STATE(1828),
    [sym_mixin_declaration] = STATE(1828),
    [sym__declaration] = STATE(1828),
    [sym__declaration2] = STATE(1828),
    [sym_variable_declaration] = STATE(1828),
    [sym_manifest_constant] = STATE(1828),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1828),
    [sym_alias_declaration] = STATE(1828),
    [sym_alias_reassign] = STATE(1828),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1828),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1828),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1828),
    [sym_union_declaration] = STATE(1828),
    [sym_postblit] = STATE(1828),
    [sym_invariant_declaration] = STATE(1828),
    [sym_class_declaration] = STATE(1828),
    [sym_constructor] = STATE(1828),
    [sym_destructor] = STATE(1828),
    [sym_alias_this] = STATE(1828),
    [sym_interface_declaration] = STATE(1828),
    [sym_enum_declaration] = STATE(1828),
    [sym_anonymous_enum_declaration] = STATE(1828),
    [sym_function_declaration] = STATE(1828),
    [sym_template_declaration] = STATE(1828),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1828),
    [sym_template_mixin] = STATE(1828),
    [sym_conditional_declaration] = STATE(1828),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1828),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1828),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1828),
    [sym_static_assert] = STATE(1828),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1828),
    [aux_sym_source_file_repeat1] = STATE(1828),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5626),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5628),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1833] = {
    [sym_import_declaration] = STATE(1852),
    [sym_mixin_declaration] = STATE(1852),
    [sym__declaration] = STATE(1852),
    [sym__declaration2] = STATE(1852),
    [sym_variable_declaration] = STATE(1852),
    [sym_manifest_constant] = STATE(1852),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1852),
    [sym_alias_declaration] = STATE(1852),
    [sym_alias_reassign] = STATE(1852),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1852),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1852),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1852),
    [sym_union_declaration] = STATE(1852),
    [sym_postblit] = STATE(1852),
    [sym_invariant_declaration] = STATE(1852),
    [sym_class_declaration] = STATE(1852),
    [sym_constructor] = STATE(1852),
    [sym_destructor] = STATE(1852),
    [sym_alias_this] = STATE(1852),
    [sym_interface_declaration] = STATE(1852),
    [sym_enum_declaration] = STATE(1852),
    [sym_anonymous_enum_declaration] = STATE(1852),
    [sym_function_declaration] = STATE(1852),
    [sym_template_declaration] = STATE(1852),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1852),
    [sym_template_mixin] = STATE(1852),
    [sym_conditional_declaration] = STATE(1852),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1852),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1852),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1852),
    [sym_static_assert] = STATE(1852),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1852),
    [aux_sym_source_file_repeat1] = STATE(1852),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5630),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1834] = {
    [sym_import_declaration] = STATE(1807),
    [sym_mixin_declaration] = STATE(1807),
    [sym__declaration] = STATE(1807),
    [sym__declaration2] = STATE(1807),
    [sym_variable_declaration] = STATE(1807),
    [sym_manifest_constant] = STATE(1807),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1807),
    [sym_alias_declaration] = STATE(1807),
    [sym_alias_reassign] = STATE(1807),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1807),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1807),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1807),
    [sym_union_declaration] = STATE(1807),
    [sym_postblit] = STATE(1807),
    [sym_invariant_declaration] = STATE(1807),
    [sym_class_declaration] = STATE(1807),
    [sym_constructor] = STATE(1807),
    [sym_destructor] = STATE(1807),
    [sym_alias_this] = STATE(1807),
    [sym_interface_declaration] = STATE(1807),
    [sym_enum_declaration] = STATE(1807),
    [sym_anonymous_enum_declaration] = STATE(1807),
    [sym_function_declaration] = STATE(1807),
    [sym_template_declaration] = STATE(1807),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1807),
    [sym_template_mixin] = STATE(1807),
    [sym_conditional_declaration] = STATE(1807),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1807),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1807),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1807),
    [sym_static_assert] = STATE(1807),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1807),
    [aux_sym_source_file_repeat1] = STATE(1807),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5462),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5632),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1835] = {
    [sym_import_declaration] = STATE(1812),
    [sym_mixin_declaration] = STATE(1812),
    [sym__declaration] = STATE(1812),
    [sym__declaration2] = STATE(1812),
    [sym_variable_declaration] = STATE(1812),
    [sym_manifest_constant] = STATE(1812),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1812),
    [sym_alias_declaration] = STATE(1812),
    [sym_alias_reassign] = STATE(1812),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1812),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1812),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1812),
    [sym_union_declaration] = STATE(1812),
    [sym_postblit] = STATE(1812),
    [sym_invariant_declaration] = STATE(1812),
    [sym_class_declaration] = STATE(1812),
    [sym_constructor] = STATE(1812),
    [sym_destructor] = STATE(1812),
    [sym_alias_this] = STATE(1812),
    [sym_interface_declaration] = STATE(1812),
    [sym_enum_declaration] = STATE(1812),
    [sym_anonymous_enum_declaration] = STATE(1812),
    [sym_function_declaration] = STATE(1812),
    [sym_template_declaration] = STATE(1812),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1812),
    [sym_template_mixin] = STATE(1812),
    [sym_conditional_declaration] = STATE(1812),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1812),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1812),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1812),
    [sym_static_assert] = STATE(1812),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1812),
    [aux_sym_source_file_repeat1] = STATE(1812),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5634),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5636),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1836] = {
    [sym_import_declaration] = STATE(1818),
    [sym_mixin_declaration] = STATE(1818),
    [sym__declaration] = STATE(1818),
    [sym__declaration2] = STATE(1818),
    [sym_variable_declaration] = STATE(1818),
    [sym_manifest_constant] = STATE(1818),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1818),
    [sym_alias_declaration] = STATE(1818),
    [sym_alias_reassign] = STATE(1818),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1818),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1818),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1818),
    [sym_union_declaration] = STATE(1818),
    [sym_postblit] = STATE(1818),
    [sym_invariant_declaration] = STATE(1818),
    [sym_class_declaration] = STATE(1818),
    [sym_constructor] = STATE(1818),
    [sym_destructor] = STATE(1818),
    [sym_alias_this] = STATE(1818),
    [sym_interface_declaration] = STATE(1818),
    [sym_enum_declaration] = STATE(1818),
    [sym_anonymous_enum_declaration] = STATE(1818),
    [sym_function_declaration] = STATE(1818),
    [sym_template_declaration] = STATE(1818),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1818),
    [sym_template_mixin] = STATE(1818),
    [sym_conditional_declaration] = STATE(1818),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1818),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1818),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1818),
    [sym_static_assert] = STATE(1818),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1818),
    [aux_sym_source_file_repeat1] = STATE(1818),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5638),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5640),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1837] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5642),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1838] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5644),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1839] = {
    [sym_import_declaration] = STATE(2381),
    [sym_mixin_declaration] = STATE(2381),
    [sym__declaration] = STATE(2381),
    [sym__declaration2] = STATE(2381),
    [sym_variable_declaration] = STATE(2381),
    [sym_manifest_constant] = STATE(2381),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2381),
    [sym_alias_declaration] = STATE(2381),
    [sym_alias_reassign] = STATE(2381),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2381),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2381),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2381),
    [sym_union_declaration] = STATE(2381),
    [sym_postblit] = STATE(2381),
    [sym_invariant_declaration] = STATE(2381),
    [sym_class_declaration] = STATE(2381),
    [sym_constructor] = STATE(2381),
    [sym_destructor] = STATE(2381),
    [sym_alias_this] = STATE(2381),
    [sym_interface_declaration] = STATE(2381),
    [sym_enum_declaration] = STATE(2381),
    [sym_anonymous_enum_declaration] = STATE(2381),
    [sym_function_declaration] = STATE(2381),
    [sym_template_declaration] = STATE(2381),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2381),
    [sym_template_mixin] = STATE(2381),
    [sym_conditional_declaration] = STATE(2381),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2381),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2381),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2381),
    [sym_static_assert] = STATE(2381),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2381),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5646),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5648),
    [anon_sym_COLON] = ACTIONS(1114),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1840] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5650),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1841] = {
    [sym_import_declaration] = STATE(1853),
    [sym_mixin_declaration] = STATE(1853),
    [sym__declaration] = STATE(1853),
    [sym__declaration2] = STATE(1853),
    [sym_variable_declaration] = STATE(1853),
    [sym_manifest_constant] = STATE(1853),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1853),
    [sym_alias_declaration] = STATE(1853),
    [sym_alias_reassign] = STATE(1853),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1853),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1853),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1853),
    [sym_union_declaration] = STATE(1853),
    [sym_postblit] = STATE(1853),
    [sym_invariant_declaration] = STATE(1853),
    [sym_class_declaration] = STATE(1853),
    [sym_constructor] = STATE(1853),
    [sym_destructor] = STATE(1853),
    [sym_alias_this] = STATE(1853),
    [sym_interface_declaration] = STATE(1853),
    [sym_enum_declaration] = STATE(1853),
    [sym_anonymous_enum_declaration] = STATE(1853),
    [sym_function_declaration] = STATE(1853),
    [sym_template_declaration] = STATE(1853),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1853),
    [sym_template_mixin] = STATE(1853),
    [sym_conditional_declaration] = STATE(1853),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1853),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1853),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1853),
    [sym_static_assert] = STATE(1853),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1853),
    [aux_sym_source_file_repeat1] = STATE(1853),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5652),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5654),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1842] = {
    [sym_import_declaration] = STATE(2120),
    [sym_mixin_declaration] = STATE(2120),
    [sym__declaration] = STATE(2120),
    [sym__declaration2] = STATE(2120),
    [sym_variable_declaration] = STATE(2120),
    [sym_manifest_constant] = STATE(2120),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2120),
    [sym_alias_declaration] = STATE(2120),
    [sym_alias_reassign] = STATE(2120),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2120),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2120),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2120),
    [sym_union_declaration] = STATE(2120),
    [sym_postblit] = STATE(2120),
    [sym_invariant_declaration] = STATE(2120),
    [sym_class_declaration] = STATE(2120),
    [sym_constructor] = STATE(2120),
    [sym_destructor] = STATE(2120),
    [sym_alias_this] = STATE(2120),
    [sym_interface_declaration] = STATE(2120),
    [sym_enum_declaration] = STATE(2120),
    [sym_anonymous_enum_declaration] = STATE(2120),
    [sym_function_declaration] = STATE(2120),
    [sym_template_declaration] = STATE(2120),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2120),
    [sym_template_mixin] = STATE(2120),
    [sym_conditional_declaration] = STATE(2120),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2120),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2120),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2120),
    [sym_static_assert] = STATE(2120),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2120),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5390),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5392),
    [anon_sym_COLON] = ACTIONS(5372),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1843] = {
    [sym_import_declaration] = STATE(1739),
    [sym_mixin_declaration] = STATE(1739),
    [sym__declaration] = STATE(1739),
    [sym__declaration2] = STATE(1739),
    [sym_variable_declaration] = STATE(1739),
    [sym_manifest_constant] = STATE(1739),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1739),
    [sym_alias_declaration] = STATE(1739),
    [sym_alias_reassign] = STATE(1739),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1739),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1739),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1739),
    [sym_union_declaration] = STATE(1739),
    [sym_postblit] = STATE(1739),
    [sym_invariant_declaration] = STATE(1739),
    [sym_class_declaration] = STATE(1739),
    [sym_constructor] = STATE(1739),
    [sym_destructor] = STATE(1739),
    [sym_alias_this] = STATE(1739),
    [sym_interface_declaration] = STATE(1739),
    [sym_enum_declaration] = STATE(1739),
    [sym_anonymous_enum_declaration] = STATE(1739),
    [sym_function_declaration] = STATE(1739),
    [sym_template_declaration] = STATE(1739),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1739),
    [sym_template_mixin] = STATE(1739),
    [sym_conditional_declaration] = STATE(1739),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1739),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1739),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1739),
    [sym_static_assert] = STATE(1739),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1739),
    [aux_sym_source_file_repeat1] = STATE(1739),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5656),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5658),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1844] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5566),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1845] = {
    [sym_import_declaration] = STATE(1814),
    [sym_mixin_declaration] = STATE(1814),
    [sym__declaration] = STATE(1814),
    [sym__declaration2] = STATE(1814),
    [sym_variable_declaration] = STATE(1814),
    [sym_manifest_constant] = STATE(1814),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1814),
    [sym_alias_declaration] = STATE(1814),
    [sym_alias_reassign] = STATE(1814),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1814),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1814),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1814),
    [sym_union_declaration] = STATE(1814),
    [sym_postblit] = STATE(1814),
    [sym_invariant_declaration] = STATE(1814),
    [sym_class_declaration] = STATE(1814),
    [sym_constructor] = STATE(1814),
    [sym_destructor] = STATE(1814),
    [sym_alias_this] = STATE(1814),
    [sym_interface_declaration] = STATE(1814),
    [sym_enum_declaration] = STATE(1814),
    [sym_anonymous_enum_declaration] = STATE(1814),
    [sym_function_declaration] = STATE(1814),
    [sym_template_declaration] = STATE(1814),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1814),
    [sym_template_mixin] = STATE(1814),
    [sym_conditional_declaration] = STATE(1814),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1814),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1814),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1814),
    [sym_static_assert] = STATE(1814),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1814),
    [aux_sym_source_file_repeat1] = STATE(1814),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5284),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5660),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1846] = {
    [sym_import_declaration] = STATE(1776),
    [sym_mixin_declaration] = STATE(1776),
    [sym__declaration] = STATE(1776),
    [sym__declaration2] = STATE(1776),
    [sym_variable_declaration] = STATE(1776),
    [sym_manifest_constant] = STATE(1776),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1776),
    [sym_alias_declaration] = STATE(1776),
    [sym_alias_reassign] = STATE(1776),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1776),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1776),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1776),
    [sym_union_declaration] = STATE(1776),
    [sym_postblit] = STATE(1776),
    [sym_invariant_declaration] = STATE(1776),
    [sym_class_declaration] = STATE(1776),
    [sym_constructor] = STATE(1776),
    [sym_destructor] = STATE(1776),
    [sym_alias_this] = STATE(1776),
    [sym_interface_declaration] = STATE(1776),
    [sym_enum_declaration] = STATE(1776),
    [sym_anonymous_enum_declaration] = STATE(1776),
    [sym_function_declaration] = STATE(1776),
    [sym_template_declaration] = STATE(1776),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1776),
    [sym_template_mixin] = STATE(1776),
    [sym_conditional_declaration] = STATE(1776),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1776),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1776),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1776),
    [sym_static_assert] = STATE(1776),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1776),
    [aux_sym_source_file_repeat1] = STATE(1776),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5662),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5664),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1847] = {
    [sym_import_declaration] = STATE(1861),
    [sym_mixin_declaration] = STATE(1861),
    [sym__declaration] = STATE(1861),
    [sym__declaration2] = STATE(1861),
    [sym_variable_declaration] = STATE(1861),
    [sym_manifest_constant] = STATE(1861),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1861),
    [sym_alias_declaration] = STATE(1861),
    [sym_alias_reassign] = STATE(1861),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1861),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1861),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1861),
    [sym_union_declaration] = STATE(1861),
    [sym_postblit] = STATE(1861),
    [sym_invariant_declaration] = STATE(1861),
    [sym_class_declaration] = STATE(1861),
    [sym_constructor] = STATE(1861),
    [sym_destructor] = STATE(1861),
    [sym_alias_this] = STATE(1861),
    [sym_interface_declaration] = STATE(1861),
    [sym_enum_declaration] = STATE(1861),
    [sym_anonymous_enum_declaration] = STATE(1861),
    [sym_function_declaration] = STATE(1861),
    [sym_template_declaration] = STATE(1861),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1861),
    [sym_template_mixin] = STATE(1861),
    [sym_conditional_declaration] = STATE(1861),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1861),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1861),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1861),
    [sym_static_assert] = STATE(1861),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1861),
    [aux_sym_source_file_repeat1] = STATE(1861),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5666),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1848] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5516),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1849] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5668),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1850] = {
    [sym_import_declaration] = STATE(2442),
    [sym_mixin_declaration] = STATE(2442),
    [sym__declaration] = STATE(2442),
    [sym__declaration2] = STATE(2442),
    [sym_variable_declaration] = STATE(2442),
    [sym_manifest_constant] = STATE(2442),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2442),
    [sym_alias_declaration] = STATE(2442),
    [sym_alias_reassign] = STATE(2442),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2442),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2442),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2442),
    [sym_union_declaration] = STATE(2442),
    [sym_postblit] = STATE(2442),
    [sym_invariant_declaration] = STATE(2442),
    [sym_class_declaration] = STATE(2442),
    [sym_constructor] = STATE(2442),
    [sym_destructor] = STATE(2442),
    [sym_alias_this] = STATE(2442),
    [sym_interface_declaration] = STATE(2442),
    [sym_enum_declaration] = STATE(2442),
    [sym_anonymous_enum_declaration] = STATE(2442),
    [sym_function_declaration] = STATE(2442),
    [sym_template_declaration] = STATE(2442),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2442),
    [sym_template_mixin] = STATE(2442),
    [sym_conditional_declaration] = STATE(2442),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2442),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2442),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2442),
    [sym_static_assert] = STATE(2442),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2442),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5252),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5254),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1851] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5392),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1852] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5614),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1853] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5670),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1854] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5672),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1855] = {
    [sym_import_declaration] = STATE(1863),
    [sym_mixin_declaration] = STATE(1863),
    [sym__declaration] = STATE(1863),
    [sym__declaration2] = STATE(1863),
    [sym_variable_declaration] = STATE(1863),
    [sym_manifest_constant] = STATE(1863),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1863),
    [sym_alias_declaration] = STATE(1863),
    [sym_alias_reassign] = STATE(1863),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1863),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1863),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1863),
    [sym_union_declaration] = STATE(1863),
    [sym_postblit] = STATE(1863),
    [sym_invariant_declaration] = STATE(1863),
    [sym_class_declaration] = STATE(1863),
    [sym_constructor] = STATE(1863),
    [sym_destructor] = STATE(1863),
    [sym_alias_this] = STATE(1863),
    [sym_interface_declaration] = STATE(1863),
    [sym_enum_declaration] = STATE(1863),
    [sym_anonymous_enum_declaration] = STATE(1863),
    [sym_function_declaration] = STATE(1863),
    [sym_template_declaration] = STATE(1863),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1863),
    [sym_template_mixin] = STATE(1863),
    [sym_conditional_declaration] = STATE(1863),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1863),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1863),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1863),
    [sym_static_assert] = STATE(1863),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1863),
    [aux_sym_source_file_repeat1] = STATE(1863),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5674),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1856] = {
    [sym_import_declaration] = STATE(2268),
    [sym_mixin_declaration] = STATE(2268),
    [sym__declaration] = STATE(2268),
    [sym__declaration2] = STATE(2268),
    [sym_variable_declaration] = STATE(2268),
    [sym_manifest_constant] = STATE(2268),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2268),
    [sym_alias_declaration] = STATE(2268),
    [sym_alias_reassign] = STATE(2268),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2268),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2268),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2268),
    [sym_union_declaration] = STATE(2268),
    [sym_postblit] = STATE(2268),
    [sym_invariant_declaration] = STATE(2268),
    [sym_class_declaration] = STATE(2268),
    [sym_constructor] = STATE(2268),
    [sym_destructor] = STATE(2268),
    [sym_alias_this] = STATE(2268),
    [sym_interface_declaration] = STATE(2268),
    [sym_enum_declaration] = STATE(2268),
    [sym_anonymous_enum_declaration] = STATE(2268),
    [sym_function_declaration] = STATE(2268),
    [sym_template_declaration] = STATE(2268),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2268),
    [sym_template_mixin] = STATE(2268),
    [sym_conditional_declaration] = STATE(2268),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2268),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2268),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2268),
    [sym_static_assert] = STATE(2268),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2268),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5374),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5376),
    [anon_sym_COLON] = ACTIONS(5378),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1857] = {
    [sym_import_declaration] = STATE(1781),
    [sym_mixin_declaration] = STATE(1781),
    [sym__declaration] = STATE(1781),
    [sym__declaration2] = STATE(1781),
    [sym_variable_declaration] = STATE(1781),
    [sym_manifest_constant] = STATE(1781),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1781),
    [sym_alias_declaration] = STATE(1781),
    [sym_alias_reassign] = STATE(1781),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1781),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1781),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1781),
    [sym_union_declaration] = STATE(1781),
    [sym_postblit] = STATE(1781),
    [sym_invariant_declaration] = STATE(1781),
    [sym_class_declaration] = STATE(1781),
    [sym_constructor] = STATE(1781),
    [sym_destructor] = STATE(1781),
    [sym_alias_this] = STATE(1781),
    [sym_interface_declaration] = STATE(1781),
    [sym_enum_declaration] = STATE(1781),
    [sym_anonymous_enum_declaration] = STATE(1781),
    [sym_function_declaration] = STATE(1781),
    [sym_template_declaration] = STATE(1781),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1781),
    [sym_template_mixin] = STATE(1781),
    [sym_conditional_declaration] = STATE(1781),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1781),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1781),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1781),
    [sym_static_assert] = STATE(1781),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1781),
    [aux_sym_source_file_repeat1] = STATE(1781),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5678),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5680),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1858] = {
    [sym_import_declaration] = STATE(1838),
    [sym_mixin_declaration] = STATE(1838),
    [sym__declaration] = STATE(1838),
    [sym__declaration2] = STATE(1838),
    [sym_variable_declaration] = STATE(1838),
    [sym_manifest_constant] = STATE(1838),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1838),
    [sym_alias_declaration] = STATE(1838),
    [sym_alias_reassign] = STATE(1838),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1838),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1838),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1838),
    [sym_union_declaration] = STATE(1838),
    [sym_postblit] = STATE(1838),
    [sym_invariant_declaration] = STATE(1838),
    [sym_class_declaration] = STATE(1838),
    [sym_constructor] = STATE(1838),
    [sym_destructor] = STATE(1838),
    [sym_alias_this] = STATE(1838),
    [sym_interface_declaration] = STATE(1838),
    [sym_enum_declaration] = STATE(1838),
    [sym_anonymous_enum_declaration] = STATE(1838),
    [sym_function_declaration] = STATE(1838),
    [sym_template_declaration] = STATE(1838),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1838),
    [sym_template_mixin] = STATE(1838),
    [sym_conditional_declaration] = STATE(1838),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1838),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1838),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1838),
    [sym_static_assert] = STATE(1838),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1838),
    [aux_sym_source_file_repeat1] = STATE(1838),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5684),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1859] = {
    [sym_import_declaration] = STATE(1816),
    [sym_mixin_declaration] = STATE(1816),
    [sym__declaration] = STATE(1816),
    [sym__declaration2] = STATE(1816),
    [sym_variable_declaration] = STATE(1816),
    [sym_manifest_constant] = STATE(1816),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1816),
    [sym_alias_declaration] = STATE(1816),
    [sym_alias_reassign] = STATE(1816),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1816),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1816),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1816),
    [sym_union_declaration] = STATE(1816),
    [sym_postblit] = STATE(1816),
    [sym_invariant_declaration] = STATE(1816),
    [sym_class_declaration] = STATE(1816),
    [sym_constructor] = STATE(1816),
    [sym_destructor] = STATE(1816),
    [sym_alias_this] = STATE(1816),
    [sym_interface_declaration] = STATE(1816),
    [sym_enum_declaration] = STATE(1816),
    [sym_anonymous_enum_declaration] = STATE(1816),
    [sym_function_declaration] = STATE(1816),
    [sym_template_declaration] = STATE(1816),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1816),
    [sym_template_mixin] = STATE(1816),
    [sym_conditional_declaration] = STATE(1816),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1816),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1816),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1816),
    [sym_static_assert] = STATE(1816),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1816),
    [aux_sym_source_file_repeat1] = STATE(1816),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5686),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5688),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1860] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1861] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1862] = {
    [sym_import_declaration] = STATE(1871),
    [sym_mixin_declaration] = STATE(1871),
    [sym__declaration] = STATE(1871),
    [sym__declaration2] = STATE(1871),
    [sym_variable_declaration] = STATE(1871),
    [sym_manifest_constant] = STATE(1871),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1871),
    [sym_alias_declaration] = STATE(1871),
    [sym_alias_reassign] = STATE(1871),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1871),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1871),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1871),
    [sym_union_declaration] = STATE(1871),
    [sym_postblit] = STATE(1871),
    [sym_invariant_declaration] = STATE(1871),
    [sym_class_declaration] = STATE(1871),
    [sym_constructor] = STATE(1871),
    [sym_destructor] = STATE(1871),
    [sym_alias_this] = STATE(1871),
    [sym_interface_declaration] = STATE(1871),
    [sym_enum_declaration] = STATE(1871),
    [sym_anonymous_enum_declaration] = STATE(1871),
    [sym_function_declaration] = STATE(1871),
    [sym_template_declaration] = STATE(1871),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1871),
    [sym_template_mixin] = STATE(1871),
    [sym_conditional_declaration] = STATE(1871),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1871),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1871),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1871),
    [sym_static_assert] = STATE(1871),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1871),
    [aux_sym_source_file_repeat1] = STATE(1871),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5692),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5694),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1863] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5682),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1864] = {
    [sym_import_declaration] = STATE(2412),
    [sym_mixin_declaration] = STATE(2412),
    [sym__declaration] = STATE(2412),
    [sym__declaration2] = STATE(2412),
    [sym_variable_declaration] = STATE(2412),
    [sym_manifest_constant] = STATE(2412),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2412),
    [sym_alias_declaration] = STATE(2412),
    [sym_alias_reassign] = STATE(2412),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2412),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2412),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2412),
    [sym_union_declaration] = STATE(2412),
    [sym_postblit] = STATE(2412),
    [sym_invariant_declaration] = STATE(2412),
    [sym_class_declaration] = STATE(2412),
    [sym_constructor] = STATE(2412),
    [sym_destructor] = STATE(2412),
    [sym_alias_this] = STATE(2412),
    [sym_interface_declaration] = STATE(2412),
    [sym_enum_declaration] = STATE(2412),
    [sym_anonymous_enum_declaration] = STATE(2412),
    [sym_function_declaration] = STATE(2412),
    [sym_template_declaration] = STATE(2412),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2412),
    [sym_template_mixin] = STATE(2412),
    [sym_conditional_declaration] = STATE(2412),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2412),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2412),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2412),
    [sym_static_assert] = STATE(2412),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2412),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5578),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5580),
    [anon_sym_COLON] = ACTIONS(5582),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1865] = {
    [sym_import_declaration] = STATE(1509),
    [sym_mixin_declaration] = STATE(1509),
    [sym__declaration] = STATE(1509),
    [sym__declaration2] = STATE(1509),
    [sym_variable_declaration] = STATE(1509),
    [sym_manifest_constant] = STATE(1509),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1509),
    [sym_alias_declaration] = STATE(1509),
    [sym_alias_reassign] = STATE(1509),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1509),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1509),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1509),
    [sym_union_declaration] = STATE(1509),
    [sym_postblit] = STATE(1509),
    [sym_invariant_declaration] = STATE(1509),
    [sym_class_declaration] = STATE(1509),
    [sym_constructor] = STATE(1509),
    [sym_destructor] = STATE(1509),
    [sym_alias_this] = STATE(1509),
    [sym_interface_declaration] = STATE(1509),
    [sym_enum_declaration] = STATE(1509),
    [sym_anonymous_enum_declaration] = STATE(1509),
    [sym_function_declaration] = STATE(1509),
    [sym_template_declaration] = STATE(1509),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1509),
    [sym_template_mixin] = STATE(1509),
    [sym_conditional_declaration] = STATE(1509),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1509),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1509),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1509),
    [sym_static_assert] = STATE(1509),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1509),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5696),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5698),
    [anon_sym_COLON] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1866] = {
    [sym_import_declaration] = STATE(2319),
    [sym_mixin_declaration] = STATE(2319),
    [sym__declaration] = STATE(2319),
    [sym__declaration2] = STATE(2319),
    [sym_variable_declaration] = STATE(2319),
    [sym_manifest_constant] = STATE(2319),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2319),
    [sym_alias_declaration] = STATE(2319),
    [sym_alias_reassign] = STATE(2319),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2319),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2319),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2319),
    [sym_union_declaration] = STATE(2319),
    [sym_postblit] = STATE(2319),
    [sym_invariant_declaration] = STATE(2319),
    [sym_class_declaration] = STATE(2319),
    [sym_constructor] = STATE(2319),
    [sym_destructor] = STATE(2319),
    [sym_alias_this] = STATE(2319),
    [sym_interface_declaration] = STATE(2319),
    [sym_enum_declaration] = STATE(2319),
    [sym_anonymous_enum_declaration] = STATE(2319),
    [sym_function_declaration] = STATE(2319),
    [sym_template_declaration] = STATE(2319),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2319),
    [sym_template_mixin] = STATE(2319),
    [sym_conditional_declaration] = STATE(2319),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2319),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2319),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2319),
    [sym_static_assert] = STATE(2319),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2319),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5272),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5274),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1867] = {
    [sym_import_declaration] = STATE(2388),
    [sym_mixin_declaration] = STATE(2388),
    [sym__declaration] = STATE(2388),
    [sym__declaration2] = STATE(2388),
    [sym_variable_declaration] = STATE(2388),
    [sym_manifest_constant] = STATE(2388),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2388),
    [sym_alias_declaration] = STATE(2388),
    [sym_alias_reassign] = STATE(2388),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2388),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2388),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2388),
    [sym_union_declaration] = STATE(2388),
    [sym_postblit] = STATE(2388),
    [sym_invariant_declaration] = STATE(2388),
    [sym_class_declaration] = STATE(2388),
    [sym_constructor] = STATE(2388),
    [sym_destructor] = STATE(2388),
    [sym_alias_this] = STATE(2388),
    [sym_interface_declaration] = STATE(2388),
    [sym_enum_declaration] = STATE(2388),
    [sym_anonymous_enum_declaration] = STATE(2388),
    [sym_function_declaration] = STATE(2388),
    [sym_template_declaration] = STATE(2388),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2388),
    [sym_template_mixin] = STATE(2388),
    [sym_conditional_declaration] = STATE(2388),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2388),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2388),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2388),
    [sym_static_assert] = STATE(2388),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2388),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5700),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5702),
    [anon_sym_COLON] = ACTIONS(1814),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1868] = {
    [sym_import_declaration] = STATE(1434),
    [sym_mixin_declaration] = STATE(1434),
    [sym__declaration] = STATE(1434),
    [sym__declaration2] = STATE(1434),
    [sym_variable_declaration] = STATE(1434),
    [sym_manifest_constant] = STATE(1434),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1434),
    [sym_alias_declaration] = STATE(1434),
    [sym_alias_reassign] = STATE(1434),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1434),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1434),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1434),
    [sym_union_declaration] = STATE(1434),
    [sym_postblit] = STATE(1434),
    [sym_invariant_declaration] = STATE(1434),
    [sym_class_declaration] = STATE(1434),
    [sym_constructor] = STATE(1434),
    [sym_destructor] = STATE(1434),
    [sym_alias_this] = STATE(1434),
    [sym_interface_declaration] = STATE(1434),
    [sym_enum_declaration] = STATE(1434),
    [sym_anonymous_enum_declaration] = STATE(1434),
    [sym_function_declaration] = STATE(1434),
    [sym_template_declaration] = STATE(1434),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1434),
    [sym_template_mixin] = STATE(1434),
    [sym_conditional_declaration] = STATE(1434),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1434),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1434),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1434),
    [sym_static_assert] = STATE(1434),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1434),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5704),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5706),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1869] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1870] = {
    [sym_import_declaration] = STATE(2236),
    [sym_mixin_declaration] = STATE(2236),
    [sym__declaration] = STATE(2236),
    [sym__declaration2] = STATE(2236),
    [sym_variable_declaration] = STATE(2236),
    [sym_manifest_constant] = STATE(2236),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2236),
    [sym_alias_declaration] = STATE(2236),
    [sym_alias_reassign] = STATE(2236),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2236),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2236),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2236),
    [sym_union_declaration] = STATE(2236),
    [sym_postblit] = STATE(2236),
    [sym_invariant_declaration] = STATE(2236),
    [sym_class_declaration] = STATE(2236),
    [sym_constructor] = STATE(2236),
    [sym_destructor] = STATE(2236),
    [sym_alias_this] = STATE(2236),
    [sym_interface_declaration] = STATE(2236),
    [sym_enum_declaration] = STATE(2236),
    [sym_anonymous_enum_declaration] = STATE(2236),
    [sym_function_declaration] = STATE(2236),
    [sym_template_declaration] = STATE(2236),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2236),
    [sym_template_mixin] = STATE(2236),
    [sym_conditional_declaration] = STATE(2236),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2236),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2236),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2236),
    [sym_static_assert] = STATE(2236),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2236),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5514),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5516),
    [anon_sym_COLON] = ACTIONS(5518),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1871] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5710),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1872] = {
    [sym_import_declaration] = STATE(1759),
    [sym_mixin_declaration] = STATE(1759),
    [sym__declaration] = STATE(1759),
    [sym__declaration2] = STATE(1759),
    [sym_variable_declaration] = STATE(1759),
    [sym_manifest_constant] = STATE(1759),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1759),
    [sym_alias_declaration] = STATE(1759),
    [sym_alias_reassign] = STATE(1759),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1759),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1759),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1759),
    [sym_union_declaration] = STATE(1759),
    [sym_postblit] = STATE(1759),
    [sym_invariant_declaration] = STATE(1759),
    [sym_class_declaration] = STATE(1759),
    [sym_constructor] = STATE(1759),
    [sym_destructor] = STATE(1759),
    [sym_alias_this] = STATE(1759),
    [sym_interface_declaration] = STATE(1759),
    [sym_enum_declaration] = STATE(1759),
    [sym_anonymous_enum_declaration] = STATE(1759),
    [sym_function_declaration] = STATE(1759),
    [sym_template_declaration] = STATE(1759),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1759),
    [sym_template_mixin] = STATE(1759),
    [sym_conditional_declaration] = STATE(1759),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1759),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1759),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1759),
    [sym_static_assert] = STATE(1759),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1759),
    [aux_sym_source_file_repeat1] = STATE(1759),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(5712),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5714),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1873] = {
    [sym_import_declaration] = STATE(2399),
    [sym_mixin_declaration] = STATE(2399),
    [sym__declaration] = STATE(2399),
    [sym__declaration2] = STATE(2399),
    [sym_variable_declaration] = STATE(2399),
    [sym_manifest_constant] = STATE(2399),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2399),
    [sym_alias_declaration] = STATE(2399),
    [sym_alias_reassign] = STATE(2399),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2399),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2399),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2399),
    [sym_union_declaration] = STATE(2399),
    [sym_postblit] = STATE(2399),
    [sym_invariant_declaration] = STATE(2399),
    [sym_class_declaration] = STATE(2399),
    [sym_constructor] = STATE(2399),
    [sym_destructor] = STATE(2399),
    [sym_alias_this] = STATE(2399),
    [sym_interface_declaration] = STATE(2399),
    [sym_enum_declaration] = STATE(2399),
    [sym_anonymous_enum_declaration] = STATE(2399),
    [sym_function_declaration] = STATE(2399),
    [sym_template_declaration] = STATE(2399),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2399),
    [sym_template_mixin] = STATE(2399),
    [sym_conditional_declaration] = STATE(2399),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2399),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2399),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2399),
    [sym_static_assert] = STATE(2399),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2399),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5584),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5586),
    [anon_sym_COLON] = ACTIONS(5588),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1874] = {
    [sym_import_declaration] = STATE(1890),
    [sym_mixin_declaration] = STATE(1890),
    [sym__declaration] = STATE(1890),
    [sym__declaration2] = STATE(1890),
    [sym_variable_declaration] = STATE(1890),
    [sym_manifest_constant] = STATE(1890),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1890),
    [sym_alias_declaration] = STATE(1890),
    [sym_alias_reassign] = STATE(1890),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1890),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1890),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1890),
    [sym_union_declaration] = STATE(1890),
    [sym_postblit] = STATE(1890),
    [sym_invariant_declaration] = STATE(1890),
    [sym_class_declaration] = STATE(1890),
    [sym_constructor] = STATE(1890),
    [sym_destructor] = STATE(1890),
    [sym_alias_this] = STATE(1890),
    [sym_interface_declaration] = STATE(1890),
    [sym_enum_declaration] = STATE(1890),
    [sym_anonymous_enum_declaration] = STATE(1890),
    [sym_function_declaration] = STATE(1890),
    [sym_template_declaration] = STATE(1890),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1890),
    [sym_template_mixin] = STATE(1890),
    [sym_conditional_declaration] = STATE(1890),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1890),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1890),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1890),
    [sym_static_assert] = STATE(1890),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1890),
    [aux_sym_source_file_repeat1] = STATE(1890),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5376),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5716),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1875] = {
    [sym_import_declaration] = STATE(1880),
    [sym_mixin_declaration] = STATE(1880),
    [sym__declaration] = STATE(1880),
    [sym__declaration2] = STATE(1880),
    [sym_variable_declaration] = STATE(1880),
    [sym_manifest_constant] = STATE(1880),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1880),
    [sym_alias_declaration] = STATE(1880),
    [sym_alias_reassign] = STATE(1880),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1880),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1880),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1880),
    [sym_union_declaration] = STATE(1880),
    [sym_postblit] = STATE(1880),
    [sym_invariant_declaration] = STATE(1880),
    [sym_class_declaration] = STATE(1880),
    [sym_constructor] = STATE(1880),
    [sym_destructor] = STATE(1880),
    [sym_alias_this] = STATE(1880),
    [sym_interface_declaration] = STATE(1880),
    [sym_enum_declaration] = STATE(1880),
    [sym_anonymous_enum_declaration] = STATE(1880),
    [sym_function_declaration] = STATE(1880),
    [sym_template_declaration] = STATE(1880),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1880),
    [sym_template_mixin] = STATE(1880),
    [sym_conditional_declaration] = STATE(1880),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1880),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1880),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1880),
    [sym_static_assert] = STATE(1880),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1880),
    [aux_sym_source_file_repeat1] = STATE(1880),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5718),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5720),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1876] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [ts_builtin_sym_end] = ACTIONS(5722),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1877] = {
    [sym_import_declaration] = STATE(1800),
    [sym_mixin_declaration] = STATE(1800),
    [sym__declaration] = STATE(1800),
    [sym__declaration2] = STATE(1800),
    [sym_variable_declaration] = STATE(1800),
    [sym_manifest_constant] = STATE(1800),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1800),
    [sym_alias_declaration] = STATE(1800),
    [sym_alias_reassign] = STATE(1800),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1800),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1800),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1800),
    [sym_union_declaration] = STATE(1800),
    [sym_postblit] = STATE(1800),
    [sym_invariant_declaration] = STATE(1800),
    [sym_class_declaration] = STATE(1800),
    [sym_constructor] = STATE(1800),
    [sym_destructor] = STATE(1800),
    [sym_alias_this] = STATE(1800),
    [sym_interface_declaration] = STATE(1800),
    [sym_enum_declaration] = STATE(1800),
    [sym_anonymous_enum_declaration] = STATE(1800),
    [sym_function_declaration] = STATE(1800),
    [sym_template_declaration] = STATE(1800),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1800),
    [sym_template_mixin] = STATE(1800),
    [sym_conditional_declaration] = STATE(1800),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1800),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1800),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1800),
    [sym_static_assert] = STATE(1800),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1800),
    [aux_sym_source_file_repeat1] = STATE(1800),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5724),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5726),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1878] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5728),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1879] = {
    [sym_import_declaration] = STATE(2289),
    [sym_mixin_declaration] = STATE(2289),
    [sym__declaration] = STATE(2289),
    [sym__declaration2] = STATE(2289),
    [sym_variable_declaration] = STATE(2289),
    [sym_manifest_constant] = STATE(2289),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2289),
    [sym_alias_declaration] = STATE(2289),
    [sym_alias_reassign] = STATE(2289),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2289),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2289),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2289),
    [sym_union_declaration] = STATE(2289),
    [sym_postblit] = STATE(2289),
    [sym_invariant_declaration] = STATE(2289),
    [sym_class_declaration] = STATE(2289),
    [sym_constructor] = STATE(2289),
    [sym_destructor] = STATE(2289),
    [sym_alias_this] = STATE(2289),
    [sym_interface_declaration] = STATE(2289),
    [sym_enum_declaration] = STATE(2289),
    [sym_anonymous_enum_declaration] = STATE(2289),
    [sym_function_declaration] = STATE(2289),
    [sym_template_declaration] = STATE(2289),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2289),
    [sym_template_mixin] = STATE(2289),
    [sym_conditional_declaration] = STATE(2289),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2289),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2289),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2289),
    [sym_static_assert] = STATE(2289),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2289),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5426),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5428),
    [anon_sym_COLON] = ACTIONS(5430),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1880] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1881] = {
    [sym_import_declaration] = STATE(1886),
    [sym_mixin_declaration] = STATE(1886),
    [sym__declaration] = STATE(1886),
    [sym__declaration2] = STATE(1886),
    [sym_variable_declaration] = STATE(1886),
    [sym_manifest_constant] = STATE(1886),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1886),
    [sym_alias_declaration] = STATE(1886),
    [sym_alias_reassign] = STATE(1886),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1886),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1886),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1886),
    [sym_union_declaration] = STATE(1886),
    [sym_postblit] = STATE(1886),
    [sym_invariant_declaration] = STATE(1886),
    [sym_class_declaration] = STATE(1886),
    [sym_constructor] = STATE(1886),
    [sym_destructor] = STATE(1886),
    [sym_alias_this] = STATE(1886),
    [sym_interface_declaration] = STATE(1886),
    [sym_enum_declaration] = STATE(1886),
    [sym_anonymous_enum_declaration] = STATE(1886),
    [sym_function_declaration] = STATE(1886),
    [sym_template_declaration] = STATE(1886),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1886),
    [sym_template_mixin] = STATE(1886),
    [sym_conditional_declaration] = STATE(1886),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1886),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1886),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1886),
    [sym_static_assert] = STATE(1886),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1886),
    [aux_sym_source_file_repeat1] = STATE(1886),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5730),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5732),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1882] = {
    [sym_import_declaration] = STATE(1887),
    [sym_mixin_declaration] = STATE(1887),
    [sym__declaration] = STATE(1887),
    [sym__declaration2] = STATE(1887),
    [sym_variable_declaration] = STATE(1887),
    [sym_manifest_constant] = STATE(1887),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1887),
    [sym_alias_declaration] = STATE(1887),
    [sym_alias_reassign] = STATE(1887),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1887),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1887),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1887),
    [sym_union_declaration] = STATE(1887),
    [sym_postblit] = STATE(1887),
    [sym_invariant_declaration] = STATE(1887),
    [sym_class_declaration] = STATE(1887),
    [sym_constructor] = STATE(1887),
    [sym_destructor] = STATE(1887),
    [sym_alias_this] = STATE(1887),
    [sym_interface_declaration] = STATE(1887),
    [sym_enum_declaration] = STATE(1887),
    [sym_anonymous_enum_declaration] = STATE(1887),
    [sym_function_declaration] = STATE(1887),
    [sym_template_declaration] = STATE(1887),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1887),
    [sym_template_mixin] = STATE(1887),
    [sym_conditional_declaration] = STATE(1887),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1887),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1887),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1887),
    [sym_static_assert] = STATE(1887),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1887),
    [aux_sym_source_file_repeat1] = STATE(1887),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5736),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1883] = {
    [sym_import_declaration] = STATE(1747),
    [sym_mixin_declaration] = STATE(1747),
    [sym__declaration] = STATE(1747),
    [sym__declaration2] = STATE(1747),
    [sym_variable_declaration] = STATE(1747),
    [sym_manifest_constant] = STATE(1747),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1747),
    [sym_alias_declaration] = STATE(1747),
    [sym_alias_reassign] = STATE(1747),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1747),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1747),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1747),
    [sym_union_declaration] = STATE(1747),
    [sym_postblit] = STATE(1747),
    [sym_invariant_declaration] = STATE(1747),
    [sym_class_declaration] = STATE(1747),
    [sym_constructor] = STATE(1747),
    [sym_destructor] = STATE(1747),
    [sym_alias_this] = STATE(1747),
    [sym_interface_declaration] = STATE(1747),
    [sym_enum_declaration] = STATE(1747),
    [sym_anonymous_enum_declaration] = STATE(1747),
    [sym_function_declaration] = STATE(1747),
    [sym_template_declaration] = STATE(1747),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1747),
    [sym_template_mixin] = STATE(1747),
    [sym_conditional_declaration] = STATE(1747),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1747),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1747),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1747),
    [sym_static_assert] = STATE(1747),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1747),
    [aux_sym_source_file_repeat1] = STATE(1747),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5708),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1884] = {
    [sym_import_declaration] = STATE(1848),
    [sym_mixin_declaration] = STATE(1848),
    [sym__declaration] = STATE(1848),
    [sym__declaration2] = STATE(1848),
    [sym_variable_declaration] = STATE(1848),
    [sym_manifest_constant] = STATE(1848),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1848),
    [sym_alias_declaration] = STATE(1848),
    [sym_alias_reassign] = STATE(1848),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1848),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1848),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1848),
    [sym_union_declaration] = STATE(1848),
    [sym_postblit] = STATE(1848),
    [sym_invariant_declaration] = STATE(1848),
    [sym_class_declaration] = STATE(1848),
    [sym_constructor] = STATE(1848),
    [sym_destructor] = STATE(1848),
    [sym_alias_this] = STATE(1848),
    [sym_interface_declaration] = STATE(1848),
    [sym_enum_declaration] = STATE(1848),
    [sym_anonymous_enum_declaration] = STATE(1848),
    [sym_function_declaration] = STATE(1848),
    [sym_template_declaration] = STATE(1848),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1848),
    [sym_template_mixin] = STATE(1848),
    [sym_conditional_declaration] = STATE(1848),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1848),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1848),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1848),
    [sym_static_assert] = STATE(1848),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1848),
    [aux_sym_source_file_repeat1] = STATE(1848),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5428),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5740),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1885] = {
    [sym_import_declaration] = STATE(1745),
    [sym_mixin_declaration] = STATE(1745),
    [sym__declaration] = STATE(1745),
    [sym__declaration2] = STATE(1745),
    [sym_variable_declaration] = STATE(1745),
    [sym_manifest_constant] = STATE(1745),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1745),
    [sym_alias_declaration] = STATE(1745),
    [sym_alias_reassign] = STATE(1745),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1745),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1745),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1745),
    [sym_union_declaration] = STATE(1745),
    [sym_postblit] = STATE(1745),
    [sym_invariant_declaration] = STATE(1745),
    [sym_class_declaration] = STATE(1745),
    [sym_constructor] = STATE(1745),
    [sym_destructor] = STATE(1745),
    [sym_alias_this] = STATE(1745),
    [sym_interface_declaration] = STATE(1745),
    [sym_enum_declaration] = STATE(1745),
    [sym_anonymous_enum_declaration] = STATE(1745),
    [sym_function_declaration] = STATE(1745),
    [sym_template_declaration] = STATE(1745),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1745),
    [sym_template_mixin] = STATE(1745),
    [sym_conditional_declaration] = STATE(1745),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1745),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1745),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1745),
    [sym_static_assert] = STATE(1745),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1745),
    [aux_sym_source_file_repeat1] = STATE(1745),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5742),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5744),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1886] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5734),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1887] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5746),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1888] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5748),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1889] = {
    [sym_import_declaration] = STATE(1851),
    [sym_mixin_declaration] = STATE(1851),
    [sym__declaration] = STATE(1851),
    [sym__declaration2] = STATE(1851),
    [sym_variable_declaration] = STATE(1851),
    [sym_manifest_constant] = STATE(1851),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1851),
    [sym_alias_declaration] = STATE(1851),
    [sym_alias_reassign] = STATE(1851),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1851),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1851),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1851),
    [sym_union_declaration] = STATE(1851),
    [sym_postblit] = STATE(1851),
    [sym_invariant_declaration] = STATE(1851),
    [sym_class_declaration] = STATE(1851),
    [sym_constructor] = STATE(1851),
    [sym_destructor] = STATE(1851),
    [sym_alias_this] = STATE(1851),
    [sym_interface_declaration] = STATE(1851),
    [sym_enum_declaration] = STATE(1851),
    [sym_anonymous_enum_declaration] = STATE(1851),
    [sym_function_declaration] = STATE(1851),
    [sym_template_declaration] = STATE(1851),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1851),
    [sym_template_mixin] = STATE(1851),
    [sym_conditional_declaration] = STATE(1851),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1851),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1851),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1851),
    [sym_static_assert] = STATE(1851),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1851),
    [aux_sym_source_file_repeat1] = STATE(1851),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5354),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1890] = {
    [sym_import_declaration] = STATE(1710),
    [sym_mixin_declaration] = STATE(1710),
    [sym__declaration] = STATE(1710),
    [sym__declaration2] = STATE(1710),
    [sym_variable_declaration] = STATE(1710),
    [sym_manifest_constant] = STATE(1710),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1710),
    [sym_alias_declaration] = STATE(1710),
    [sym_alias_reassign] = STATE(1710),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1710),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1710),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1710),
    [sym_union_declaration] = STATE(1710),
    [sym_postblit] = STATE(1710),
    [sym_invariant_declaration] = STATE(1710),
    [sym_class_declaration] = STATE(1710),
    [sym_constructor] = STATE(1710),
    [sym_destructor] = STATE(1710),
    [sym_alias_this] = STATE(1710),
    [sym_interface_declaration] = STATE(1710),
    [sym_enum_declaration] = STATE(1710),
    [sym_anonymous_enum_declaration] = STATE(1710),
    [sym_function_declaration] = STATE(1710),
    [sym_template_declaration] = STATE(1710),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1710),
    [sym_template_mixin] = STATE(1710),
    [sym_conditional_declaration] = STATE(1710),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1710),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1710),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1710),
    [sym_static_assert] = STATE(1710),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1710),
    [aux_sym_source_file_repeat1] = STATE(1710),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(5264),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1891] = {
    [sym_import_declaration] = STATE(553),
    [sym_mixin_declaration] = STATE(553),
    [sym__declaration] = STATE(553),
    [sym__declaration2] = STATE(553),
    [sym_variable_declaration] = STATE(553),
    [sym_manifest_constant] = STATE(553),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(553),
    [sym_alias_declaration] = STATE(553),
    [sym_alias_reassign] = STATE(553),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(553),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(553),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(553),
    [sym_union_declaration] = STATE(553),
    [sym_postblit] = STATE(553),
    [sym_invariant_declaration] = STATE(553),
    [sym_class_declaration] = STATE(553),
    [sym_constructor] = STATE(553),
    [sym_destructor] = STATE(553),
    [sym_alias_this] = STATE(553),
    [sym_interface_declaration] = STATE(553),
    [sym_enum_declaration] = STATE(553),
    [sym_anonymous_enum_declaration] = STATE(553),
    [sym_function_declaration] = STATE(553),
    [sym_template_declaration] = STATE(553),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(553),
    [sym_template_mixin] = STATE(553),
    [sym_conditional_declaration] = STATE(553),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(553),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(553),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(553),
    [sym_static_assert] = STATE(553),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(553),
    [aux_sym_source_file_repeat1] = STATE(553),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5752),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1892] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3127),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3127),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3127),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3127),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_catch] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_finally] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1893] = {
    [sym_import_declaration] = STATE(1542),
    [sym_mixin_declaration] = STATE(1542),
    [sym__declaration] = STATE(1542),
    [sym__declaration2] = STATE(1542),
    [sym_variable_declaration] = STATE(1542),
    [sym_manifest_constant] = STATE(1542),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1542),
    [sym_alias_declaration] = STATE(1542),
    [sym_alias_reassign] = STATE(1542),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1542),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1542),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1542),
    [sym_union_declaration] = STATE(1542),
    [sym_postblit] = STATE(1542),
    [sym_invariant_declaration] = STATE(1542),
    [sym_class_declaration] = STATE(1542),
    [sym_constructor] = STATE(1542),
    [sym_destructor] = STATE(1542),
    [sym_alias_this] = STATE(1542),
    [sym_interface_declaration] = STATE(1542),
    [sym_enum_declaration] = STATE(1542),
    [sym_anonymous_enum_declaration] = STATE(1542),
    [sym_function_declaration] = STATE(1542),
    [sym_template_declaration] = STATE(1542),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1542),
    [sym_template_mixin] = STATE(1542),
    [sym_conditional_declaration] = STATE(1542),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1542),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1542),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1542),
    [sym_static_assert] = STATE(1542),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1542),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5754),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5386),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1894] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_catch] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(5756),
    [sym_finally] = ACTIONS(3167),
    [sym_function] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1895] = {
    [sym_import_declaration] = STATE(2091),
    [sym_mixin_declaration] = STATE(2091),
    [sym__declaration] = STATE(2091),
    [sym__declaration2] = STATE(2091),
    [sym_variable_declaration] = STATE(2091),
    [sym_manifest_constant] = STATE(2091),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2091),
    [sym_alias_declaration] = STATE(2091),
    [sym_alias_reassign] = STATE(2091),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2091),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2091),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2091),
    [sym_union_declaration] = STATE(2091),
    [sym_postblit] = STATE(2091),
    [sym_invariant_declaration] = STATE(2091),
    [sym_class_declaration] = STATE(2091),
    [sym_constructor] = STATE(2091),
    [sym_destructor] = STATE(2091),
    [sym_alias_this] = STATE(2091),
    [sym_interface_declaration] = STATE(2091),
    [sym_enum_declaration] = STATE(2091),
    [sym_anonymous_enum_declaration] = STATE(2091),
    [sym_function_declaration] = STATE(2091),
    [sym_template_declaration] = STATE(2091),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2091),
    [sym_template_mixin] = STATE(2091),
    [sym_conditional_declaration] = STATE(2091),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2091),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2091),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2091),
    [sym_static_assert] = STATE(2091),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2091),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1896] = {
    [sym_import_declaration] = STATE(2092),
    [sym_mixin_declaration] = STATE(2092),
    [sym__declaration] = STATE(2092),
    [sym__declaration2] = STATE(2092),
    [sym_variable_declaration] = STATE(2092),
    [sym_manifest_constant] = STATE(2092),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2092),
    [sym_alias_declaration] = STATE(2092),
    [sym_alias_reassign] = STATE(2092),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2092),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2092),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2092),
    [sym_union_declaration] = STATE(2092),
    [sym_postblit] = STATE(2092),
    [sym_invariant_declaration] = STATE(2092),
    [sym_class_declaration] = STATE(2092),
    [sym_constructor] = STATE(2092),
    [sym_destructor] = STATE(2092),
    [sym_alias_this] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_enum_declaration] = STATE(2092),
    [sym_anonymous_enum_declaration] = STATE(2092),
    [sym_function_declaration] = STATE(2092),
    [sym_template_declaration] = STATE(2092),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2092),
    [sym_template_mixin] = STATE(2092),
    [sym_conditional_declaration] = STATE(2092),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2092),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2092),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2092),
    [sym_static_assert] = STATE(2092),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2092),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1897] = {
    [sym_import_declaration] = STATE(2096),
    [sym_mixin_declaration] = STATE(2096),
    [sym__declaration] = STATE(2096),
    [sym__declaration2] = STATE(2096),
    [sym_variable_declaration] = STATE(2096),
    [sym_manifest_constant] = STATE(2096),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2096),
    [sym_alias_declaration] = STATE(2096),
    [sym_alias_reassign] = STATE(2096),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2096),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2096),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2096),
    [sym_union_declaration] = STATE(2096),
    [sym_postblit] = STATE(2096),
    [sym_invariant_declaration] = STATE(2096),
    [sym_class_declaration] = STATE(2096),
    [sym_constructor] = STATE(2096),
    [sym_destructor] = STATE(2096),
    [sym_alias_this] = STATE(2096),
    [sym_interface_declaration] = STATE(2096),
    [sym_enum_declaration] = STATE(2096),
    [sym_anonymous_enum_declaration] = STATE(2096),
    [sym_function_declaration] = STATE(2096),
    [sym_template_declaration] = STATE(2096),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2096),
    [sym_template_mixin] = STATE(2096),
    [sym_conditional_declaration] = STATE(2096),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2096),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2096),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2096),
    [sym_static_assert] = STATE(2096),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2096),
    [aux_sym__declaration_repeat1] = STATE(1935),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5766),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1898] = {
    [sym_import_declaration] = STATE(2401),
    [sym_mixin_declaration] = STATE(2401),
    [sym__declaration] = STATE(2401),
    [sym__declaration2] = STATE(2401),
    [sym_variable_declaration] = STATE(2401),
    [sym_manifest_constant] = STATE(2401),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2401),
    [sym_alias_declaration] = STATE(2401),
    [sym_alias_reassign] = STATE(2401),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2401),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2401),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2401),
    [sym_union_declaration] = STATE(2401),
    [sym_postblit] = STATE(2401),
    [sym_invariant_declaration] = STATE(2401),
    [sym_class_declaration] = STATE(2401),
    [sym_constructor] = STATE(2401),
    [sym_destructor] = STATE(2401),
    [sym_alias_this] = STATE(2401),
    [sym_interface_declaration] = STATE(2401),
    [sym_enum_declaration] = STATE(2401),
    [sym_anonymous_enum_declaration] = STATE(2401),
    [sym_function_declaration] = STATE(2401),
    [sym_template_declaration] = STATE(2401),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2401),
    [sym_template_mixin] = STATE(2401),
    [sym_conditional_declaration] = STATE(2401),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2401),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2401),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2401),
    [sym_static_assert] = STATE(2401),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2401),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1899] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_catch] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(5770),
    [sym_finally] = ACTIONS(3167),
    [sym_function] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1900] = {
    [sym_import_declaration] = STATE(2344),
    [sym_mixin_declaration] = STATE(2344),
    [sym__declaration] = STATE(2344),
    [sym__declaration2] = STATE(2344),
    [sym_variable_declaration] = STATE(2344),
    [sym_manifest_constant] = STATE(2344),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2344),
    [sym_alias_declaration] = STATE(2344),
    [sym_alias_reassign] = STATE(2344),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2344),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2344),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2344),
    [sym_union_declaration] = STATE(2344),
    [sym_postblit] = STATE(2344),
    [sym_invariant_declaration] = STATE(2344),
    [sym_class_declaration] = STATE(2344),
    [sym_constructor] = STATE(2344),
    [sym_destructor] = STATE(2344),
    [sym_alias_this] = STATE(2344),
    [sym_interface_declaration] = STATE(2344),
    [sym_enum_declaration] = STATE(2344),
    [sym_anonymous_enum_declaration] = STATE(2344),
    [sym_function_declaration] = STATE(2344),
    [sym_template_declaration] = STATE(2344),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2344),
    [sym_template_mixin] = STATE(2344),
    [sym_conditional_declaration] = STATE(2344),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2344),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2344),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2344),
    [sym_static_assert] = STATE(2344),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2344),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1901] = {
    [sym_import_declaration] = STATE(2092),
    [sym_mixin_declaration] = STATE(2092),
    [sym__declaration] = STATE(2092),
    [sym__declaration2] = STATE(2092),
    [sym_variable_declaration] = STATE(2092),
    [sym_manifest_constant] = STATE(2092),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2092),
    [sym_alias_declaration] = STATE(2092),
    [sym_alias_reassign] = STATE(2092),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2092),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2092),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2092),
    [sym_union_declaration] = STATE(2092),
    [sym_postblit] = STATE(2092),
    [sym_invariant_declaration] = STATE(2092),
    [sym_class_declaration] = STATE(2092),
    [sym_constructor] = STATE(2092),
    [sym_destructor] = STATE(2092),
    [sym_alias_this] = STATE(2092),
    [sym_interface_declaration] = STATE(2092),
    [sym_enum_declaration] = STATE(2092),
    [sym_anonymous_enum_declaration] = STATE(2092),
    [sym_function_declaration] = STATE(2092),
    [sym_template_declaration] = STATE(2092),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2092),
    [sym_template_mixin] = STATE(2092),
    [sym_conditional_declaration] = STATE(2092),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2092),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2092),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2092),
    [sym_static_assert] = STATE(2092),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2092),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5762),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5524),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1902] = {
    [sym_import_declaration] = STATE(2307),
    [sym_mixin_declaration] = STATE(2307),
    [sym__declaration] = STATE(2307),
    [sym__declaration2] = STATE(2307),
    [sym_variable_declaration] = STATE(2307),
    [sym_manifest_constant] = STATE(2307),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2307),
    [sym_alias_declaration] = STATE(2307),
    [sym_alias_reassign] = STATE(2307),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2307),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2307),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2307),
    [sym_union_declaration] = STATE(2307),
    [sym_postblit] = STATE(2307),
    [sym_invariant_declaration] = STATE(2307),
    [sym_class_declaration] = STATE(2307),
    [sym_constructor] = STATE(2307),
    [sym_destructor] = STATE(2307),
    [sym_alias_this] = STATE(2307),
    [sym_interface_declaration] = STATE(2307),
    [sym_enum_declaration] = STATE(2307),
    [sym_anonymous_enum_declaration] = STATE(2307),
    [sym_function_declaration] = STATE(2307),
    [sym_template_declaration] = STATE(2307),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2307),
    [sym_template_mixin] = STATE(2307),
    [sym_conditional_declaration] = STATE(2307),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2307),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2307),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2307),
    [sym_static_assert] = STATE(2307),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2307),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5777),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1903] = {
    [sym_import_declaration] = STATE(1548),
    [sym_mixin_declaration] = STATE(1548),
    [sym__declaration] = STATE(1548),
    [sym__declaration2] = STATE(1548),
    [sym_variable_declaration] = STATE(1548),
    [sym_manifest_constant] = STATE(1548),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1548),
    [sym_alias_declaration] = STATE(1548),
    [sym_alias_reassign] = STATE(1548),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1548),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1548),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1548),
    [sym_union_declaration] = STATE(1548),
    [sym_postblit] = STATE(1548),
    [sym_invariant_declaration] = STATE(1548),
    [sym_class_declaration] = STATE(1548),
    [sym_constructor] = STATE(1548),
    [sym_destructor] = STATE(1548),
    [sym_alias_this] = STATE(1548),
    [sym_interface_declaration] = STATE(1548),
    [sym_enum_declaration] = STATE(1548),
    [sym_anonymous_enum_declaration] = STATE(1548),
    [sym_function_declaration] = STATE(1548),
    [sym_template_declaration] = STATE(1548),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1548),
    [sym_template_mixin] = STATE(1548),
    [sym_conditional_declaration] = STATE(1548),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1548),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1548),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1548),
    [sym_static_assert] = STATE(1548),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1548),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5779),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5781),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1904] = {
    [sym_import_declaration] = STATE(2307),
    [sym_mixin_declaration] = STATE(2307),
    [sym__declaration] = STATE(2307),
    [sym__declaration2] = STATE(2307),
    [sym_variable_declaration] = STATE(2307),
    [sym_manifest_constant] = STATE(2307),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2307),
    [sym_alias_declaration] = STATE(2307),
    [sym_alias_reassign] = STATE(2307),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2307),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2307),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2307),
    [sym_union_declaration] = STATE(2307),
    [sym_postblit] = STATE(2307),
    [sym_invariant_declaration] = STATE(2307),
    [sym_class_declaration] = STATE(2307),
    [sym_constructor] = STATE(2307),
    [sym_destructor] = STATE(2307),
    [sym_alias_this] = STATE(2307),
    [sym_interface_declaration] = STATE(2307),
    [sym_enum_declaration] = STATE(2307),
    [sym_anonymous_enum_declaration] = STATE(2307),
    [sym_function_declaration] = STATE(2307),
    [sym_template_declaration] = STATE(2307),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2307),
    [sym_template_mixin] = STATE(2307),
    [sym_conditional_declaration] = STATE(2307),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2307),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2307),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2307),
    [sym_static_assert] = STATE(2307),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2307),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5777),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5594),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1905] = {
    [sym_identifier] = ACTIONS(3121),
    [anon_sym_q_LBRACE] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3124),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3124),
    [anon_sym_AMP] = ACTIONS(3121),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3121),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3121),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3121),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3124),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym_DOLLAR] = ACTIONS(3124),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3121),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3121),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3121),
    [sym_byte] = ACTIONS(3121),
    [sym_ubyte] = ACTIONS(3121),
    [sym_char] = ACTIONS(3121),
    [sym_short] = ACTIONS(3121),
    [sym_ushort] = ACTIONS(3121),
    [sym_int] = ACTIONS(3121),
    [sym_uint] = ACTIONS(3121),
    [sym_long] = ACTIONS(3121),
    [sym_ulong] = ACTIONS(3121),
    [sym_cent] = ACTIONS(3121),
    [sym_ucent] = ACTIONS(3121),
    [sym_wchar] = ACTIONS(3121),
    [sym_dchar] = ACTIONS(3121),
    [sym_float] = ACTIONS(3121),
    [sym_double] = ACTIONS(3121),
    [sym_real] = ACTIONS(3121),
    [sym_ifloat] = ACTIONS(3121),
    [sym_idouble] = ACTIONS(3121),
    [sym_ireal] = ACTIONS(3121),
    [sym_cfloat] = ACTIONS(3121),
    [sym_cdouble] = ACTIONS(3121),
    [sym_creal] = ACTIONS(3121),
    [sym_size_t] = ACTIONS(3121),
    [sym_ptrdiff_t] = ACTIONS(3121),
    [sym_string] = ACTIONS(3121),
    [sym_cstring] = ACTIONS(3121),
    [sym_dstring] = ACTIONS(3121),
    [sym_wstring] = ACTIONS(3121),
    [sym_noreturn] = ACTIONS(3121),
    [sym_true] = ACTIONS(3121),
    [sym_false] = ACTIONS(3121),
    [sym_null] = ACTIONS(3121),
    [sym_super] = ACTIONS(3121),
    [sym_this] = ACTIONS(3121),
    [sym_assert] = ACTIONS(3121),
    [sym_auto] = ACTIONS(3121),
    [sym_cast] = ACTIONS(3121),
    [sym_catch] = ACTIONS(3121),
    [sym_const] = ACTIONS(3121),
    [sym_delegate] = ACTIONS(3121),
    [sym_delete] = ACTIONS(3121),
    [sym_do] = ACTIONS(3121),
    [sym_else] = ACTIONS(3121),
    [sym_finally] = ACTIONS(3121),
    [sym_function] = ACTIONS(3121),
    [sym_immutable] = ACTIONS(3121),
    [sym_import] = ACTIONS(3121),
    [sym_in] = ACTIONS(3121),
    [sym_inout] = ACTIONS(3121),
    [sym_is] = ACTIONS(3121),
    [sym_mixin] = ACTIONS(3121),
    [sym_new] = ACTIONS(3121),
    [sym_out] = ACTIONS(3121),
    [sym_ref] = ACTIONS(3121),
    [sym_shared] = ACTIONS(3121),
    [sym_throw] = ACTIONS(3121),
    [sym_typeid] = ACTIONS(3121),
    [sym_typeof] = ACTIONS(3121),
    [sym_traits] = ACTIONS(3121),
    [sym_vector] = ACTIONS(3121),
    [sym_void] = ACTIONS(3121),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_r_DQUOTE] = ACTIONS(3124),
    [anon_sym_x_DQUOTE] = ACTIONS(3124),
    [anon_sym_DQUOTE] = ACTIONS(3124),
    [anon_sym_i_BQUOTE] = ACTIONS(3124),
    [anon_sym_i_DQUOTE] = ACTIONS(3124),
    [anon_sym_iq_LBRACE] = ACTIONS(3124),
    [aux_sym_char_literal_token1] = ACTIONS(3124),
    [anon_sym_SQUOTE] = ACTIONS(3121),
    [anon_sym___DATE__] = ACTIONS(3121),
    [anon_sym___FILE__] = ACTIONS(3121),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3121),
    [anon_sym___FUNCTION__] = ACTIONS(3121),
    [anon_sym___LINE__] = ACTIONS(3121),
    [anon_sym___MODULE__] = ACTIONS(3121),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3121),
    [anon_sym___TIME__] = ACTIONS(3121),
    [anon_sym___TIMESTAMP__] = ACTIONS(3121),
    [anon_sym___VENDOR__] = ACTIONS(3121),
    [anon_sym___VERSION__] = ACTIONS(3121),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3124),
    [sym_float_literal] = ACTIONS(3124),
    [sym__string] = ACTIONS(3124),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1906] = {
    [sym_import_declaration] = STATE(2371),
    [sym_mixin_declaration] = STATE(2371),
    [sym__declaration] = STATE(2371),
    [sym__declaration2] = STATE(2371),
    [sym_variable_declaration] = STATE(2371),
    [sym_manifest_constant] = STATE(2371),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2371),
    [sym_alias_declaration] = STATE(2371),
    [sym_alias_reassign] = STATE(2371),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2371),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2371),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2371),
    [sym_union_declaration] = STATE(2371),
    [sym_postblit] = STATE(2371),
    [sym_invariant_declaration] = STATE(2371),
    [sym_class_declaration] = STATE(2371),
    [sym_constructor] = STATE(2371),
    [sym_destructor] = STATE(2371),
    [sym_alias_this] = STATE(2371),
    [sym_interface_declaration] = STATE(2371),
    [sym_enum_declaration] = STATE(2371),
    [sym_anonymous_enum_declaration] = STATE(2371),
    [sym_function_declaration] = STATE(2371),
    [sym_template_declaration] = STATE(2371),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2371),
    [sym_template_mixin] = STATE(2371),
    [sym_conditional_declaration] = STATE(2371),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2371),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2371),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2371),
    [sym_static_assert] = STATE(2371),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2371),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5783),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1907] = {
    [sym_import_declaration] = STATE(1538),
    [sym_mixin_declaration] = STATE(1538),
    [sym__declaration] = STATE(1538),
    [sym__declaration2] = STATE(1538),
    [sym_variable_declaration] = STATE(1538),
    [sym_manifest_constant] = STATE(1538),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1538),
    [sym_alias_declaration] = STATE(1538),
    [sym_alias_reassign] = STATE(1538),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1538),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1538),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1538),
    [sym_union_declaration] = STATE(1538),
    [sym_postblit] = STATE(1538),
    [sym_invariant_declaration] = STATE(1538),
    [sym_class_declaration] = STATE(1538),
    [sym_constructor] = STATE(1538),
    [sym_destructor] = STATE(1538),
    [sym_alias_this] = STATE(1538),
    [sym_interface_declaration] = STATE(1538),
    [sym_enum_declaration] = STATE(1538),
    [sym_anonymous_enum_declaration] = STATE(1538),
    [sym_function_declaration] = STATE(1538),
    [sym_template_declaration] = STATE(1538),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1538),
    [sym_template_mixin] = STATE(1538),
    [sym_conditional_declaration] = STATE(1538),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1538),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1538),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1538),
    [sym_static_assert] = STATE(1538),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1538),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5785),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5334),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1908] = {
    [sym_identifier] = ACTIONS(3145),
    [anon_sym_q_LBRACE] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3148),
    [anon_sym_AMP] = ACTIONS(3145),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3145),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3148),
    [anon_sym_PLUS] = ACTIONS(3145),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3145),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3148),
    [anon_sym_DOLLAR] = ACTIONS(3148),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3145),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3145),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3145),
    [sym_byte] = ACTIONS(3145),
    [sym_ubyte] = ACTIONS(3145),
    [sym_char] = ACTIONS(3145),
    [sym_short] = ACTIONS(3145),
    [sym_ushort] = ACTIONS(3145),
    [sym_int] = ACTIONS(3145),
    [sym_uint] = ACTIONS(3145),
    [sym_long] = ACTIONS(3145),
    [sym_ulong] = ACTIONS(3145),
    [sym_cent] = ACTIONS(3145),
    [sym_ucent] = ACTIONS(3145),
    [sym_wchar] = ACTIONS(3145),
    [sym_dchar] = ACTIONS(3145),
    [sym_float] = ACTIONS(3145),
    [sym_double] = ACTIONS(3145),
    [sym_real] = ACTIONS(3145),
    [sym_ifloat] = ACTIONS(3145),
    [sym_idouble] = ACTIONS(3145),
    [sym_ireal] = ACTIONS(3145),
    [sym_cfloat] = ACTIONS(3145),
    [sym_cdouble] = ACTIONS(3145),
    [sym_creal] = ACTIONS(3145),
    [sym_size_t] = ACTIONS(3145),
    [sym_ptrdiff_t] = ACTIONS(3145),
    [sym_string] = ACTIONS(3145),
    [sym_cstring] = ACTIONS(3145),
    [sym_dstring] = ACTIONS(3145),
    [sym_wstring] = ACTIONS(3145),
    [sym_noreturn] = ACTIONS(3145),
    [sym_true] = ACTIONS(3145),
    [sym_false] = ACTIONS(3145),
    [sym_null] = ACTIONS(3145),
    [sym_super] = ACTIONS(3145),
    [sym_this] = ACTIONS(3145),
    [sym_assert] = ACTIONS(3145),
    [sym_auto] = ACTIONS(3145),
    [sym_cast] = ACTIONS(3145),
    [sym_catch] = ACTIONS(3145),
    [sym_const] = ACTIONS(3145),
    [sym_delegate] = ACTIONS(3145),
    [sym_delete] = ACTIONS(3145),
    [sym_do] = ACTIONS(3145),
    [sym_else] = ACTIONS(3145),
    [sym_finally] = ACTIONS(3145),
    [sym_function] = ACTIONS(3145),
    [sym_immutable] = ACTIONS(3145),
    [sym_import] = ACTIONS(3145),
    [sym_in] = ACTIONS(3145),
    [sym_inout] = ACTIONS(3145),
    [sym_is] = ACTIONS(3145),
    [sym_mixin] = ACTIONS(3145),
    [sym_new] = ACTIONS(3145),
    [sym_out] = ACTIONS(3145),
    [sym_ref] = ACTIONS(3145),
    [sym_shared] = ACTIONS(3145),
    [sym_throw] = ACTIONS(3145),
    [sym_typeid] = ACTIONS(3145),
    [sym_typeof] = ACTIONS(3145),
    [sym_traits] = ACTIONS(3145),
    [sym_vector] = ACTIONS(3145),
    [sym_void] = ACTIONS(3145),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [anon_sym_r_DQUOTE] = ACTIONS(3148),
    [anon_sym_x_DQUOTE] = ACTIONS(3148),
    [anon_sym_DQUOTE] = ACTIONS(3148),
    [anon_sym_i_BQUOTE] = ACTIONS(3148),
    [anon_sym_i_DQUOTE] = ACTIONS(3148),
    [anon_sym_iq_LBRACE] = ACTIONS(3148),
    [aux_sym_char_literal_token1] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(3145),
    [anon_sym___DATE__] = ACTIONS(3145),
    [anon_sym___FILE__] = ACTIONS(3145),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3145),
    [anon_sym___FUNCTION__] = ACTIONS(3145),
    [anon_sym___LINE__] = ACTIONS(3145),
    [anon_sym___MODULE__] = ACTIONS(3145),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3145),
    [anon_sym___TIME__] = ACTIONS(3145),
    [anon_sym___TIMESTAMP__] = ACTIONS(3145),
    [anon_sym___VENDOR__] = ACTIONS(3145),
    [anon_sym___VERSION__] = ACTIONS(3145),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3148),
    [sym_float_literal] = ACTIONS(3148),
    [sym__string] = ACTIONS(3148),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1909] = {
    [sym_import_declaration] = STATE(2096),
    [sym_mixin_declaration] = STATE(2096),
    [sym__declaration] = STATE(2096),
    [sym__declaration2] = STATE(2096),
    [sym_variable_declaration] = STATE(2096),
    [sym_manifest_constant] = STATE(2096),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2096),
    [sym_alias_declaration] = STATE(2096),
    [sym_alias_reassign] = STATE(2096),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2096),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2096),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2096),
    [sym_union_declaration] = STATE(2096),
    [sym_postblit] = STATE(2096),
    [sym_invariant_declaration] = STATE(2096),
    [sym_class_declaration] = STATE(2096),
    [sym_constructor] = STATE(2096),
    [sym_destructor] = STATE(2096),
    [sym_alias_this] = STATE(2096),
    [sym_interface_declaration] = STATE(2096),
    [sym_enum_declaration] = STATE(2096),
    [sym_anonymous_enum_declaration] = STATE(2096),
    [sym_function_declaration] = STATE(2096),
    [sym_template_declaration] = STATE(2096),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2096),
    [sym_template_mixin] = STATE(2096),
    [sym_conditional_declaration] = STATE(2096),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2096),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2096),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2096),
    [sym_static_assert] = STATE(2096),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2096),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5766),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1910] = {
    [sym_import_declaration] = STATE(2383),
    [sym_mixin_declaration] = STATE(2383),
    [sym__declaration] = STATE(2383),
    [sym__declaration2] = STATE(2383),
    [sym_variable_declaration] = STATE(2383),
    [sym_manifest_constant] = STATE(2383),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2383),
    [sym_alias_declaration] = STATE(2383),
    [sym_alias_reassign] = STATE(2383),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2383),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2383),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2383),
    [sym_union_declaration] = STATE(2383),
    [sym_postblit] = STATE(2383),
    [sym_invariant_declaration] = STATE(2383),
    [sym_class_declaration] = STATE(2383),
    [sym_constructor] = STATE(2383),
    [sym_destructor] = STATE(2383),
    [sym_alias_this] = STATE(2383),
    [sym_interface_declaration] = STATE(2383),
    [sym_enum_declaration] = STATE(2383),
    [sym_anonymous_enum_declaration] = STATE(2383),
    [sym_function_declaration] = STATE(2383),
    [sym_template_declaration] = STATE(2383),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2383),
    [sym_template_mixin] = STATE(2383),
    [sym_conditional_declaration] = STATE(2383),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2383),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2383),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2383),
    [sym_static_assert] = STATE(2383),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2383),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5787),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1911] = {
    [sym_import_declaration] = STATE(2401),
    [sym_mixin_declaration] = STATE(2401),
    [sym__declaration] = STATE(2401),
    [sym__declaration2] = STATE(2401),
    [sym_variable_declaration] = STATE(2401),
    [sym_manifest_constant] = STATE(2401),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2401),
    [sym_alias_declaration] = STATE(2401),
    [sym_alias_reassign] = STATE(2401),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2401),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2401),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2401),
    [sym_union_declaration] = STATE(2401),
    [sym_postblit] = STATE(2401),
    [sym_invariant_declaration] = STATE(2401),
    [sym_class_declaration] = STATE(2401),
    [sym_constructor] = STATE(2401),
    [sym_destructor] = STATE(2401),
    [sym_alias_this] = STATE(2401),
    [sym_interface_declaration] = STATE(2401),
    [sym_enum_declaration] = STATE(2401),
    [sym_anonymous_enum_declaration] = STATE(2401),
    [sym_function_declaration] = STATE(2401),
    [sym_template_declaration] = STATE(2401),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2401),
    [sym_template_mixin] = STATE(2401),
    [sym_conditional_declaration] = STATE(2401),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2401),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2401),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2401),
    [sym_static_assert] = STATE(2401),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2401),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5768),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5444),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1912] = {
    [sym_import_declaration] = STATE(1415),
    [sym_mixin_declaration] = STATE(1415),
    [sym__declaration] = STATE(1415),
    [sym__declaration2] = STATE(1415),
    [sym_variable_declaration] = STATE(1415),
    [sym_manifest_constant] = STATE(1415),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1415),
    [sym_alias_declaration] = STATE(1415),
    [sym_alias_reassign] = STATE(1415),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1415),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1415),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1415),
    [sym_union_declaration] = STATE(1415),
    [sym_postblit] = STATE(1415),
    [sym_invariant_declaration] = STATE(1415),
    [sym_class_declaration] = STATE(1415),
    [sym_constructor] = STATE(1415),
    [sym_destructor] = STATE(1415),
    [sym_alias_this] = STATE(1415),
    [sym_interface_declaration] = STATE(1415),
    [sym_enum_declaration] = STATE(1415),
    [sym_anonymous_enum_declaration] = STATE(1415),
    [sym_function_declaration] = STATE(1415),
    [sym_template_declaration] = STATE(1415),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1415),
    [sym_template_mixin] = STATE(1415),
    [sym_conditional_declaration] = STATE(1415),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1415),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1415),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1415),
    [sym_static_assert] = STATE(1415),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1415),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5789),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5450),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1913] = {
    [sym_import_declaration] = STATE(1701),
    [sym_mixin_declaration] = STATE(1701),
    [sym__declaration] = STATE(1701),
    [sym__declaration2] = STATE(1701),
    [sym_variable_declaration] = STATE(1701),
    [sym_manifest_constant] = STATE(1701),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(1701),
    [sym_alias_declaration] = STATE(1701),
    [sym_alias_reassign] = STATE(1701),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1701),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1701),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(1701),
    [sym_union_declaration] = STATE(1701),
    [sym_postblit] = STATE(1701),
    [sym_invariant_declaration] = STATE(1701),
    [sym_class_declaration] = STATE(1701),
    [sym_constructor] = STATE(1701),
    [sym_destructor] = STATE(1701),
    [sym_alias_this] = STATE(1701),
    [sym_interface_declaration] = STATE(1701),
    [sym_enum_declaration] = STATE(1701),
    [sym_anonymous_enum_declaration] = STATE(1701),
    [sym_function_declaration] = STATE(1701),
    [sym_template_declaration] = STATE(1701),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1701),
    [sym_template_mixin] = STATE(1701),
    [sym_conditional_declaration] = STATE(1701),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1701),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1701),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1701),
    [sym_static_assert] = STATE(1701),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1701),
    [aux_sym_source_file_repeat1] = STATE(1701),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5791),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1914] = {
    [sym_import_declaration] = STATE(1405),
    [sym_mixin_declaration] = STATE(1405),
    [sym__declaration] = STATE(1405),
    [sym__declaration2] = STATE(1405),
    [sym_variable_declaration] = STATE(1405),
    [sym_manifest_constant] = STATE(1405),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1405),
    [sym_alias_declaration] = STATE(1405),
    [sym_alias_reassign] = STATE(1405),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1405),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1405),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1405),
    [sym_union_declaration] = STATE(1405),
    [sym_postblit] = STATE(1405),
    [sym_invariant_declaration] = STATE(1405),
    [sym_class_declaration] = STATE(1405),
    [sym_constructor] = STATE(1405),
    [sym_destructor] = STATE(1405),
    [sym_alias_this] = STATE(1405),
    [sym_interface_declaration] = STATE(1405),
    [sym_enum_declaration] = STATE(1405),
    [sym_anonymous_enum_declaration] = STATE(1405),
    [sym_function_declaration] = STATE(1405),
    [sym_template_declaration] = STATE(1405),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1405),
    [sym_template_mixin] = STATE(1405),
    [sym_conditional_declaration] = STATE(1405),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1405),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1405),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1405),
    [sym_static_assert] = STATE(1405),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1405),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5793),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5795),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1915] = {
    [sym_import_declaration] = STATE(2344),
    [sym_mixin_declaration] = STATE(2344),
    [sym__declaration] = STATE(2344),
    [sym__declaration2] = STATE(2344),
    [sym_variable_declaration] = STATE(2344),
    [sym_manifest_constant] = STATE(2344),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2344),
    [sym_alias_declaration] = STATE(2344),
    [sym_alias_reassign] = STATE(2344),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2344),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2344),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2344),
    [sym_union_declaration] = STATE(2344),
    [sym_postblit] = STATE(2344),
    [sym_invariant_declaration] = STATE(2344),
    [sym_class_declaration] = STATE(2344),
    [sym_constructor] = STATE(2344),
    [sym_destructor] = STATE(2344),
    [sym_alias_this] = STATE(2344),
    [sym_interface_declaration] = STATE(2344),
    [sym_enum_declaration] = STATE(2344),
    [sym_anonymous_enum_declaration] = STATE(2344),
    [sym_function_declaration] = STATE(2344),
    [sym_template_declaration] = STATE(2344),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2344),
    [sym_template_mixin] = STATE(2344),
    [sym_conditional_declaration] = STATE(2344),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2344),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2344),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2344),
    [sym_static_assert] = STATE(2344),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2344),
    [aux_sym__declaration_repeat1] = STATE(1933),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5773),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5775),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1916] = {
    [sym_import_declaration] = STATE(599),
    [sym_mixin_declaration] = STATE(599),
    [sym__declaration] = STATE(599),
    [sym__declaration2] = STATE(599),
    [sym_variable_declaration] = STATE(599),
    [sym_manifest_constant] = STATE(599),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(599),
    [sym_alias_declaration] = STATE(599),
    [sym_alias_reassign] = STATE(599),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(599),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(599),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(599),
    [sym_union_declaration] = STATE(599),
    [sym_postblit] = STATE(599),
    [sym_invariant_declaration] = STATE(599),
    [sym_class_declaration] = STATE(599),
    [sym_constructor] = STATE(599),
    [sym_destructor] = STATE(599),
    [sym_alias_this] = STATE(599),
    [sym_interface_declaration] = STATE(599),
    [sym_enum_declaration] = STATE(599),
    [sym_anonymous_enum_declaration] = STATE(599),
    [sym_function_declaration] = STATE(599),
    [sym_template_declaration] = STATE(599),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(599),
    [sym_template_mixin] = STATE(599),
    [sym_conditional_declaration] = STATE(599),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(599),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(599),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(599),
    [sym_static_assert] = STATE(599),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(599),
    [aux_sym_source_file_repeat1] = STATE(599),
    [aux_sym__declaration_repeat1] = STATE(1930),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5797),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1917] = {
    [sym_identifier] = ACTIONS(3131),
    [anon_sym_q_LBRACE] = ACTIONS(3133),
    [anon_sym_LBRACE] = ACTIONS(3133),
    [anon_sym_SLASH] = ACTIONS(3135),
    [anon_sym_SLASH_EQ] = ACTIONS(3137),
    [anon_sym_DOT] = ACTIONS(3139),
    [anon_sym_AMP] = ACTIONS(3142),
    [anon_sym_AMP_EQ] = ACTIONS(3137),
    [anon_sym_AMP_AMP] = ACTIONS(3137),
    [anon_sym_PIPE] = ACTIONS(3135),
    [anon_sym_PIPE_EQ] = ACTIONS(3137),
    [anon_sym_PIPE_PIPE] = ACTIONS(3137),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_DASH_EQ] = ACTIONS(3137),
    [anon_sym_DASH_DASH] = ACTIONS(3139),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_PLUS_EQ] = ACTIONS(3137),
    [anon_sym_PLUS_PLUS] = ACTIONS(3139),
    [anon_sym_LT] = ACTIONS(3135),
    [anon_sym_LT_EQ] = ACTIONS(3137),
    [anon_sym_LT_LT] = ACTIONS(3135),
    [anon_sym_LT_LT_EQ] = ACTIONS(3137),
    [anon_sym_GT] = ACTIONS(3135),
    [anon_sym_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3137),
    [anon_sym_GT_GT] = ACTIONS(3135),
    [anon_sym_GT_GT_GT] = ACTIONS(3135),
    [anon_sym_BANG] = ACTIONS(3131),
    [anon_sym_BANG_EQ] = ACTIONS(3137),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_RPAREN] = ACTIONS(3133),
    [anon_sym_LBRACK] = ACTIONS(3139),
    [anon_sym_QMARK] = ACTIONS(3137),
    [anon_sym_COMMA] = ACTIONS(3137),
    [anon_sym_SEMI] = ACTIONS(3139),
    [anon_sym_DOLLAR] = ACTIONS(3133),
    [anon_sym_EQ] = ACTIONS(3135),
    [anon_sym_EQ_EQ] = ACTIONS(3137),
    [anon_sym_STAR] = ACTIONS(3142),
    [anon_sym_STAR_EQ] = ACTIONS(3137),
    [anon_sym_PERCENT] = ACTIONS(3135),
    [anon_sym_PERCENT_EQ] = ACTIONS(3137),
    [anon_sym_CARET] = ACTIONS(3135),
    [anon_sym_CARET_EQ] = ACTIONS(3137),
    [anon_sym_CARET_CARET] = ACTIONS(3135),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3137),
    [anon_sym_TILDE] = ACTIONS(3142),
    [anon_sym_TILDE_EQ] = ACTIONS(3137),
    [sym_bool] = ACTIONS(3131),
    [sym_byte] = ACTIONS(3131),
    [sym_ubyte] = ACTIONS(3131),
    [sym_char] = ACTIONS(3131),
    [sym_short] = ACTIONS(3131),
    [sym_ushort] = ACTIONS(3131),
    [sym_int] = ACTIONS(3131),
    [sym_uint] = ACTIONS(3131),
    [sym_long] = ACTIONS(3131),
    [sym_ulong] = ACTIONS(3131),
    [sym_cent] = ACTIONS(3131),
    [sym_ucent] = ACTIONS(3131),
    [sym_wchar] = ACTIONS(3131),
    [sym_dchar] = ACTIONS(3131),
    [sym_float] = ACTIONS(3131),
    [sym_double] = ACTIONS(3131),
    [sym_real] = ACTIONS(3131),
    [sym_ifloat] = ACTIONS(3131),
    [sym_idouble] = ACTIONS(3131),
    [sym_ireal] = ACTIONS(3131),
    [sym_cfloat] = ACTIONS(3131),
    [sym_cdouble] = ACTIONS(3131),
    [sym_creal] = ACTIONS(3131),
    [sym_size_t] = ACTIONS(3131),
    [sym_ptrdiff_t] = ACTIONS(3131),
    [sym_string] = ACTIONS(3131),
    [sym_cstring] = ACTIONS(3131),
    [sym_dstring] = ACTIONS(3131),
    [sym_wstring] = ACTIONS(3131),
    [sym_noreturn] = ACTIONS(3131),
    [sym_true] = ACTIONS(3131),
    [sym_false] = ACTIONS(3131),
    [sym_null] = ACTIONS(3131),
    [sym_super] = ACTIONS(3131),
    [sym_this] = ACTIONS(3131),
    [sym_assert] = ACTIONS(3131),
    [sym_auto] = ACTIONS(3131),
    [sym_cast] = ACTIONS(3131),
    [sym_catch] = ACTIONS(3131),
    [sym_const] = ACTIONS(3131),
    [sym_delegate] = ACTIONS(3131),
    [sym_delete] = ACTIONS(3131),
    [sym_do] = ACTIONS(3131),
    [sym_else] = ACTIONS(3131),
    [sym_finally] = ACTIONS(3131),
    [sym_function] = ACTIONS(3131),
    [sym_immutable] = ACTIONS(3131),
    [sym_import] = ACTIONS(3131),
    [sym_in] = ACTIONS(3142),
    [sym_inout] = ACTIONS(3131),
    [sym_is] = ACTIONS(3142),
    [sym_mixin] = ACTIONS(3131),
    [sym_new] = ACTIONS(3131),
    [sym_out] = ACTIONS(3131),
    [sym_ref] = ACTIONS(3131),
    [sym_shared] = ACTIONS(3131),
    [sym_throw] = ACTIONS(3131),
    [sym_typeid] = ACTIONS(3131),
    [sym_typeof] = ACTIONS(3131),
    [sym_traits] = ACTIONS(3131),
    [sym_vector] = ACTIONS(3131),
    [sym_void] = ACTIONS(3131),
    [anon_sym_BQUOTE] = ACTIONS(3133),
    [anon_sym_r_DQUOTE] = ACTIONS(3133),
    [anon_sym_x_DQUOTE] = ACTIONS(3133),
    [anon_sym_DQUOTE] = ACTIONS(3133),
    [anon_sym_i_BQUOTE] = ACTIONS(3133),
    [anon_sym_i_DQUOTE] = ACTIONS(3133),
    [anon_sym_iq_LBRACE] = ACTIONS(3133),
    [aux_sym_char_literal_token1] = ACTIONS(3133),
    [anon_sym_SQUOTE] = ACTIONS(3131),
    [anon_sym___DATE__] = ACTIONS(3131),
    [anon_sym___FILE__] = ACTIONS(3131),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3131),
    [anon_sym___FUNCTION__] = ACTIONS(3131),
    [anon_sym___LINE__] = ACTIONS(3131),
    [anon_sym___MODULE__] = ACTIONS(3131),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3131),
    [anon_sym___TIME__] = ACTIONS(3131),
    [anon_sym___TIMESTAMP__] = ACTIONS(3131),
    [anon_sym___VENDOR__] = ACTIONS(3131),
    [anon_sym___VERSION__] = ACTIONS(3131),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3133),
    [sym_float_literal] = ACTIONS(3133),
    [sym__string] = ACTIONS(3133),
    [sym_not_in] = ACTIONS(3137),
    [sym_not_is] = ACTIONS(3137),
  },
  [1918] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_q_LBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_SLASH] = ACTIONS(3176),
    [anon_sym_SLASH_EQ] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3176),
    [anon_sym_AMP_EQ] = ACTIONS(3178),
    [anon_sym_AMP_AMP] = ACTIONS(3178),
    [anon_sym_PIPE] = ACTIONS(3176),
    [anon_sym_PIPE_EQ] = ACTIONS(3178),
    [anon_sym_PIPE_PIPE] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_DASH_EQ] = ACTIONS(3178),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_PLUS_EQ] = ACTIONS(3178),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_LT] = ACTIONS(3176),
    [anon_sym_LT_EQ] = ACTIONS(3178),
    [anon_sym_LT_LT] = ACTIONS(3176),
    [anon_sym_LT_LT_EQ] = ACTIONS(3178),
    [anon_sym_GT] = ACTIONS(3176),
    [anon_sym_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3178),
    [anon_sym_GT_GT] = ACTIONS(3176),
    [anon_sym_GT_GT_GT] = ACTIONS(3176),
    [anon_sym_BANG] = ACTIONS(3176),
    [anon_sym_BANG_EQ] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_QMARK] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3178),
    [anon_sym_EQ] = ACTIONS(3176),
    [anon_sym_EQ_EQ] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3176),
    [anon_sym_STAR_EQ] = ACTIONS(3178),
    [anon_sym_PERCENT] = ACTIONS(3176),
    [anon_sym_PERCENT_EQ] = ACTIONS(3178),
    [anon_sym_CARET] = ACTIONS(3176),
    [anon_sym_CARET_EQ] = ACTIONS(3178),
    [anon_sym_CARET_CARET] = ACTIONS(3176),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3176),
    [anon_sym_TILDE_EQ] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_assert] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_cast] = ACTIONS(3176),
    [sym_catch] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_delegate] = ACTIONS(3176),
    [sym_delete] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_finally] = ACTIONS(3176),
    [sym_function] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_is] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_new] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_throw] = ACTIONS(3176),
    [sym_typeid] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_r_DQUOTE] = ACTIONS(3178),
    [anon_sym_x_DQUOTE] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_i_BQUOTE] = ACTIONS(3178),
    [anon_sym_i_DQUOTE] = ACTIONS(3178),
    [anon_sym_iq_LBRACE] = ACTIONS(3178),
    [aux_sym_char_literal_token1] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym___DATE__] = ACTIONS(3176),
    [anon_sym___FILE__] = ACTIONS(3176),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3176),
    [anon_sym___FUNCTION__] = ACTIONS(3176),
    [anon_sym___LINE__] = ACTIONS(3176),
    [anon_sym___MODULE__] = ACTIONS(3176),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3176),
    [anon_sym___TIME__] = ACTIONS(3176),
    [anon_sym___TIMESTAMP__] = ACTIONS(3176),
    [anon_sym___VENDOR__] = ACTIONS(3176),
    [anon_sym___VERSION__] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3178),
    [sym_float_literal] = ACTIONS(3178),
    [sym__string] = ACTIONS(3178),
    [sym_not_in] = ACTIONS(3178),
    [sym_not_is] = ACTIONS(3178),
  },
  [1919] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_q_LBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_SLASH] = ACTIONS(3163),
    [anon_sym_SLASH_EQ] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3163),
    [anon_sym_AMP_EQ] = ACTIONS(3165),
    [anon_sym_AMP_AMP] = ACTIONS(3165),
    [anon_sym_PIPE] = ACTIONS(3163),
    [anon_sym_PIPE_EQ] = ACTIONS(3165),
    [anon_sym_PIPE_PIPE] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DASH_EQ] = ACTIONS(3165),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_PLUS_EQ] = ACTIONS(3165),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_LT] = ACTIONS(3163),
    [anon_sym_LT_EQ] = ACTIONS(3165),
    [anon_sym_LT_LT] = ACTIONS(3163),
    [anon_sym_LT_LT_EQ] = ACTIONS(3165),
    [anon_sym_GT] = ACTIONS(3163),
    [anon_sym_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3165),
    [anon_sym_GT_GT] = ACTIONS(3163),
    [anon_sym_GT_GT_GT] = ACTIONS(3163),
    [anon_sym_BANG] = ACTIONS(3163),
    [anon_sym_BANG_EQ] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_EQ] = ACTIONS(3163),
    [anon_sym_EQ_EQ] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3163),
    [anon_sym_STAR_EQ] = ACTIONS(3165),
    [anon_sym_PERCENT] = ACTIONS(3163),
    [anon_sym_PERCENT_EQ] = ACTIONS(3165),
    [anon_sym_CARET] = ACTIONS(3163),
    [anon_sym_CARET_EQ] = ACTIONS(3165),
    [anon_sym_CARET_CARET] = ACTIONS(3163),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3163),
    [anon_sym_TILDE_EQ] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_assert] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_cast] = ACTIONS(3163),
    [sym_catch] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_delegate] = ACTIONS(3163),
    [sym_delete] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_finally] = ACTIONS(3163),
    [sym_function] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_is] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_new] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_throw] = ACTIONS(3163),
    [sym_typeid] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [anon_sym_r_DQUOTE] = ACTIONS(3165),
    [anon_sym_x_DQUOTE] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_i_BQUOTE] = ACTIONS(3165),
    [anon_sym_i_DQUOTE] = ACTIONS(3165),
    [anon_sym_iq_LBRACE] = ACTIONS(3165),
    [aux_sym_char_literal_token1] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym___DATE__] = ACTIONS(3163),
    [anon_sym___FILE__] = ACTIONS(3163),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3163),
    [anon_sym___FUNCTION__] = ACTIONS(3163),
    [anon_sym___LINE__] = ACTIONS(3163),
    [anon_sym___MODULE__] = ACTIONS(3163),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3163),
    [anon_sym___TIME__] = ACTIONS(3163),
    [anon_sym___TIMESTAMP__] = ACTIONS(3163),
    [anon_sym___VENDOR__] = ACTIONS(3163),
    [anon_sym___VERSION__] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym__string] = ACTIONS(3165),
    [sym_not_in] = ACTIONS(3165),
    [sym_not_is] = ACTIONS(3165),
  },
  [1920] = {
    [sym_import_declaration] = STATE(2353),
    [sym_mixin_declaration] = STATE(2353),
    [sym__declaration] = STATE(2353),
    [sym__declaration2] = STATE(2353),
    [sym_variable_declaration] = STATE(2353),
    [sym_manifest_constant] = STATE(2353),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2353),
    [sym_alias_declaration] = STATE(2353),
    [sym_alias_reassign] = STATE(2353),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2353),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2353),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2353),
    [sym_union_declaration] = STATE(2353),
    [sym_postblit] = STATE(2353),
    [sym_invariant_declaration] = STATE(2353),
    [sym_class_declaration] = STATE(2353),
    [sym_constructor] = STATE(2353),
    [sym_destructor] = STATE(2353),
    [sym_alias_this] = STATE(2353),
    [sym_interface_declaration] = STATE(2353),
    [sym_enum_declaration] = STATE(2353),
    [sym_anonymous_enum_declaration] = STATE(2353),
    [sym_function_declaration] = STATE(2353),
    [sym_template_declaration] = STATE(2353),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2353),
    [sym_template_mixin] = STATE(2353),
    [sym_conditional_declaration] = STATE(2353),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2353),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2353),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2353),
    [sym_static_assert] = STATE(2353),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2353),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1921] = {
    [sym_import_declaration] = STATE(2091),
    [sym_mixin_declaration] = STATE(2091),
    [sym__declaration] = STATE(2091),
    [sym__declaration2] = STATE(2091),
    [sym_variable_declaration] = STATE(2091),
    [sym_manifest_constant] = STATE(2091),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2091),
    [sym_alias_declaration] = STATE(2091),
    [sym_alias_reassign] = STATE(2091),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2091),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2091),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2091),
    [sym_union_declaration] = STATE(2091),
    [sym_postblit] = STATE(2091),
    [sym_invariant_declaration] = STATE(2091),
    [sym_class_declaration] = STATE(2091),
    [sym_constructor] = STATE(2091),
    [sym_destructor] = STATE(2091),
    [sym_alias_this] = STATE(2091),
    [sym_interface_declaration] = STATE(2091),
    [sym_enum_declaration] = STATE(2091),
    [sym_anonymous_enum_declaration] = STATE(2091),
    [sym_function_declaration] = STATE(2091),
    [sym_template_declaration] = STATE(2091),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2091),
    [sym_template_mixin] = STATE(2091),
    [sym_conditional_declaration] = STATE(2091),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2091),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2091),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2091),
    [sym_static_assert] = STATE(2091),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2091),
    [aux_sym__declaration_repeat1] = STATE(1931),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5760),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5486),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1922] = {
    [sym_identifier] = ACTIONS(3157),
    [anon_sym_q_LBRACE] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3160),
    [anon_sym_AMP] = ACTIONS(3157),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3157),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3160),
    [anon_sym_PLUS] = ACTIONS(3157),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3160),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3157),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_RPAREN] = ACTIONS(3160),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3160),
    [anon_sym_DOLLAR] = ACTIONS(3160),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3157),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3157),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3157),
    [sym_byte] = ACTIONS(3157),
    [sym_ubyte] = ACTIONS(3157),
    [sym_char] = ACTIONS(3157),
    [sym_short] = ACTIONS(3157),
    [sym_ushort] = ACTIONS(3157),
    [sym_int] = ACTIONS(3157),
    [sym_uint] = ACTIONS(3157),
    [sym_long] = ACTIONS(3157),
    [sym_ulong] = ACTIONS(3157),
    [sym_cent] = ACTIONS(3157),
    [sym_ucent] = ACTIONS(3157),
    [sym_wchar] = ACTIONS(3157),
    [sym_dchar] = ACTIONS(3157),
    [sym_float] = ACTIONS(3157),
    [sym_double] = ACTIONS(3157),
    [sym_real] = ACTIONS(3157),
    [sym_ifloat] = ACTIONS(3157),
    [sym_idouble] = ACTIONS(3157),
    [sym_ireal] = ACTIONS(3157),
    [sym_cfloat] = ACTIONS(3157),
    [sym_cdouble] = ACTIONS(3157),
    [sym_creal] = ACTIONS(3157),
    [sym_size_t] = ACTIONS(3157),
    [sym_ptrdiff_t] = ACTIONS(3157),
    [sym_string] = ACTIONS(3157),
    [sym_cstring] = ACTIONS(3157),
    [sym_dstring] = ACTIONS(3157),
    [sym_wstring] = ACTIONS(3157),
    [sym_noreturn] = ACTIONS(3157),
    [sym_true] = ACTIONS(3157),
    [sym_false] = ACTIONS(3157),
    [sym_null] = ACTIONS(3157),
    [sym_super] = ACTIONS(3157),
    [sym_this] = ACTIONS(3157),
    [sym_assert] = ACTIONS(3157),
    [sym_auto] = ACTIONS(3157),
    [sym_cast] = ACTIONS(3157),
    [sym_catch] = ACTIONS(3157),
    [sym_const] = ACTIONS(3157),
    [sym_delegate] = ACTIONS(3157),
    [sym_delete] = ACTIONS(3157),
    [sym_do] = ACTIONS(3157),
    [sym_else] = ACTIONS(3157),
    [sym_finally] = ACTIONS(3157),
    [sym_function] = ACTIONS(3157),
    [sym_immutable] = ACTIONS(3157),
    [sym_import] = ACTIONS(3157),
    [sym_in] = ACTIONS(3157),
    [sym_inout] = ACTIONS(3157),
    [sym_is] = ACTIONS(3157),
    [sym_mixin] = ACTIONS(3157),
    [sym_new] = ACTIONS(3157),
    [sym_out] = ACTIONS(3157),
    [sym_ref] = ACTIONS(3157),
    [sym_shared] = ACTIONS(3157),
    [sym_throw] = ACTIONS(3157),
    [sym_typeid] = ACTIONS(3157),
    [sym_typeof] = ACTIONS(3157),
    [sym_traits] = ACTIONS(3157),
    [sym_vector] = ACTIONS(3157),
    [sym_void] = ACTIONS(3157),
    [anon_sym_BQUOTE] = ACTIONS(3160),
    [anon_sym_r_DQUOTE] = ACTIONS(3160),
    [anon_sym_x_DQUOTE] = ACTIONS(3160),
    [anon_sym_DQUOTE] = ACTIONS(3160),
    [anon_sym_i_BQUOTE] = ACTIONS(3160),
    [anon_sym_i_DQUOTE] = ACTIONS(3160),
    [anon_sym_iq_LBRACE] = ACTIONS(3160),
    [aux_sym_char_literal_token1] = ACTIONS(3160),
    [anon_sym_SQUOTE] = ACTIONS(3157),
    [anon_sym___DATE__] = ACTIONS(3157),
    [anon_sym___FILE__] = ACTIONS(3157),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3157),
    [anon_sym___FUNCTION__] = ACTIONS(3157),
    [anon_sym___LINE__] = ACTIONS(3157),
    [anon_sym___MODULE__] = ACTIONS(3157),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3157),
    [anon_sym___TIME__] = ACTIONS(3157),
    [anon_sym___TIMESTAMP__] = ACTIONS(3157),
    [anon_sym___VENDOR__] = ACTIONS(3157),
    [anon_sym___VERSION__] = ACTIONS(3157),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3160),
    [sym_float_literal] = ACTIONS(3160),
    [sym__string] = ACTIONS(3160),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1923] = {
    [sym_identifier] = ACTIONS(3151),
    [anon_sym_q_LBRACE] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_AMP] = ACTIONS(3151),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3151),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3154),
    [anon_sym_PLUS] = ACTIONS(3151),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3154),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3151),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_DOLLAR] = ACTIONS(3154),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3151),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3151),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3151),
    [sym_byte] = ACTIONS(3151),
    [sym_ubyte] = ACTIONS(3151),
    [sym_char] = ACTIONS(3151),
    [sym_short] = ACTIONS(3151),
    [sym_ushort] = ACTIONS(3151),
    [sym_int] = ACTIONS(3151),
    [sym_uint] = ACTIONS(3151),
    [sym_long] = ACTIONS(3151),
    [sym_ulong] = ACTIONS(3151),
    [sym_cent] = ACTIONS(3151),
    [sym_ucent] = ACTIONS(3151),
    [sym_wchar] = ACTIONS(3151),
    [sym_dchar] = ACTIONS(3151),
    [sym_float] = ACTIONS(3151),
    [sym_double] = ACTIONS(3151),
    [sym_real] = ACTIONS(3151),
    [sym_ifloat] = ACTIONS(3151),
    [sym_idouble] = ACTIONS(3151),
    [sym_ireal] = ACTIONS(3151),
    [sym_cfloat] = ACTIONS(3151),
    [sym_cdouble] = ACTIONS(3151),
    [sym_creal] = ACTIONS(3151),
    [sym_size_t] = ACTIONS(3151),
    [sym_ptrdiff_t] = ACTIONS(3151),
    [sym_string] = ACTIONS(3151),
    [sym_cstring] = ACTIONS(3151),
    [sym_dstring] = ACTIONS(3151),
    [sym_wstring] = ACTIONS(3151),
    [sym_noreturn] = ACTIONS(3151),
    [sym_true] = ACTIONS(3151),
    [sym_false] = ACTIONS(3151),
    [sym_null] = ACTIONS(3151),
    [sym_super] = ACTIONS(3151),
    [sym_this] = ACTIONS(3151),
    [sym_assert] = ACTIONS(3151),
    [sym_auto] = ACTIONS(3151),
    [sym_cast] = ACTIONS(3151),
    [sym_catch] = ACTIONS(3151),
    [sym_const] = ACTIONS(3151),
    [sym_delegate] = ACTIONS(3151),
    [sym_delete] = ACTIONS(3151),
    [sym_do] = ACTIONS(3151),
    [sym_else] = ACTIONS(3151),
    [sym_finally] = ACTIONS(3151),
    [sym_function] = ACTIONS(3151),
    [sym_immutable] = ACTIONS(3151),
    [sym_import] = ACTIONS(3151),
    [sym_in] = ACTIONS(3151),
    [sym_inout] = ACTIONS(3151),
    [sym_is] = ACTIONS(3151),
    [sym_mixin] = ACTIONS(3151),
    [sym_new] = ACTIONS(3151),
    [sym_out] = ACTIONS(3151),
    [sym_ref] = ACTIONS(3151),
    [sym_shared] = ACTIONS(3151),
    [sym_throw] = ACTIONS(3151),
    [sym_typeid] = ACTIONS(3151),
    [sym_typeof] = ACTIONS(3151),
    [sym_traits] = ACTIONS(3151),
    [sym_vector] = ACTIONS(3151),
    [sym_void] = ACTIONS(3151),
    [anon_sym_BQUOTE] = ACTIONS(3154),
    [anon_sym_r_DQUOTE] = ACTIONS(3154),
    [anon_sym_x_DQUOTE] = ACTIONS(3154),
    [anon_sym_DQUOTE] = ACTIONS(3154),
    [anon_sym_i_BQUOTE] = ACTIONS(3154),
    [anon_sym_i_DQUOTE] = ACTIONS(3154),
    [anon_sym_iq_LBRACE] = ACTIONS(3154),
    [aux_sym_char_literal_token1] = ACTIONS(3154),
    [anon_sym_SQUOTE] = ACTIONS(3151),
    [anon_sym___DATE__] = ACTIONS(3151),
    [anon_sym___FILE__] = ACTIONS(3151),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3151),
    [anon_sym___FUNCTION__] = ACTIONS(3151),
    [anon_sym___LINE__] = ACTIONS(3151),
    [anon_sym___MODULE__] = ACTIONS(3151),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3151),
    [anon_sym___TIME__] = ACTIONS(3151),
    [anon_sym___TIMESTAMP__] = ACTIONS(3151),
    [anon_sym___VENDOR__] = ACTIONS(3151),
    [anon_sym___VERSION__] = ACTIONS(3151),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3154),
    [sym_float_literal] = ACTIONS(3154),
    [sym__string] = ACTIONS(3154),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1924] = {
    [sym_import_declaration] = STATE(1421),
    [sym_mixin_declaration] = STATE(1421),
    [sym__declaration] = STATE(1421),
    [sym__declaration2] = STATE(1421),
    [sym_variable_declaration] = STATE(1421),
    [sym_manifest_constant] = STATE(1421),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1421),
    [sym_alias_declaration] = STATE(1421),
    [sym_alias_reassign] = STATE(1421),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1421),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1421),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1421),
    [sym_union_declaration] = STATE(1421),
    [sym_postblit] = STATE(1421),
    [sym_invariant_declaration] = STATE(1421),
    [sym_class_declaration] = STATE(1421),
    [sym_constructor] = STATE(1421),
    [sym_destructor] = STATE(1421),
    [sym_alias_this] = STATE(1421),
    [sym_interface_declaration] = STATE(1421),
    [sym_enum_declaration] = STATE(1421),
    [sym_anonymous_enum_declaration] = STATE(1421),
    [sym_function_declaration] = STATE(1421),
    [sym_template_declaration] = STATE(1421),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1421),
    [sym_template_mixin] = STATE(1421),
    [sym_conditional_declaration] = STATE(1421),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1421),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1421),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1421),
    [sym_static_assert] = STATE(1421),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1421),
    [aux_sym__declaration_repeat1] = STATE(1934),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5803),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5364),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1925] = {
    [sym_import_declaration] = STATE(1702),
    [sym_mixin_declaration] = STATE(1702),
    [sym__declaration] = STATE(1702),
    [sym__declaration2] = STATE(1702),
    [sym_variable_declaration] = STATE(1702),
    [sym_manifest_constant] = STATE(1702),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(1702),
    [sym_alias_declaration] = STATE(1702),
    [sym_alias_reassign] = STATE(1702),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1702),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1702),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(1702),
    [sym_union_declaration] = STATE(1702),
    [sym_postblit] = STATE(1702),
    [sym_invariant_declaration] = STATE(1702),
    [sym_class_declaration] = STATE(1702),
    [sym_constructor] = STATE(1702),
    [sym_destructor] = STATE(1702),
    [sym_alias_this] = STATE(1702),
    [sym_interface_declaration] = STATE(1702),
    [sym_enum_declaration] = STATE(1702),
    [sym_anonymous_enum_declaration] = STATE(1702),
    [sym_function_declaration] = STATE(1702),
    [sym_template_declaration] = STATE(1702),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1702),
    [sym_template_mixin] = STATE(1702),
    [sym_conditional_declaration] = STATE(1702),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1702),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1702),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1702),
    [sym_static_assert] = STATE(1702),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1702),
    [aux_sym_source_file_repeat1] = STATE(1702),
    [aux_sym__declaration_repeat1] = STATE(1929),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5805),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1926] = {
    [sym_import_declaration] = STATE(2383),
    [sym_mixin_declaration] = STATE(2383),
    [sym__declaration] = STATE(2383),
    [sym__declaration2] = STATE(2383),
    [sym_variable_declaration] = STATE(2383),
    [sym_manifest_constant] = STATE(2383),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2383),
    [sym_alias_declaration] = STATE(2383),
    [sym_alias_reassign] = STATE(2383),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2383),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2383),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2383),
    [sym_union_declaration] = STATE(2383),
    [sym_postblit] = STATE(2383),
    [sym_invariant_declaration] = STATE(2383),
    [sym_class_declaration] = STATE(2383),
    [sym_constructor] = STATE(2383),
    [sym_destructor] = STATE(2383),
    [sym_alias_this] = STATE(2383),
    [sym_interface_declaration] = STATE(2383),
    [sym_enum_declaration] = STATE(2383),
    [sym_anonymous_enum_declaration] = STATE(2383),
    [sym_function_declaration] = STATE(2383),
    [sym_template_declaration] = STATE(2383),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2383),
    [sym_template_mixin] = STATE(2383),
    [sym_conditional_declaration] = STATE(2383),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2383),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2383),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2383),
    [sym_static_assert] = STATE(2383),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2383),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5787),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5730),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1927] = {
    [sym_import_declaration] = STATE(2353),
    [sym_mixin_declaration] = STATE(2353),
    [sym__declaration] = STATE(2353),
    [sym__declaration2] = STATE(2353),
    [sym_variable_declaration] = STATE(2353),
    [sym_manifest_constant] = STATE(2353),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2353),
    [sym_alias_declaration] = STATE(2353),
    [sym_alias_reassign] = STATE(2353),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2353),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2353),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2353),
    [sym_union_declaration] = STATE(2353),
    [sym_postblit] = STATE(2353),
    [sym_invariant_declaration] = STATE(2353),
    [sym_class_declaration] = STATE(2353),
    [sym_constructor] = STATE(2353),
    [sym_destructor] = STATE(2353),
    [sym_alias_this] = STATE(2353),
    [sym_interface_declaration] = STATE(2353),
    [sym_enum_declaration] = STATE(2353),
    [sym_anonymous_enum_declaration] = STATE(2353),
    [sym_function_declaration] = STATE(2353),
    [sym_template_declaration] = STATE(2353),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2353),
    [sym_template_mixin] = STATE(2353),
    [sym_conditional_declaration] = STATE(2353),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2353),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2353),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2353),
    [sym_static_assert] = STATE(2353),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2353),
    [aux_sym__declaration_repeat1] = STATE(1932),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5799),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5801),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1928] = {
    [sym_import_declaration] = STATE(2371),
    [sym_mixin_declaration] = STATE(2371),
    [sym__declaration] = STATE(2371),
    [sym__declaration2] = STATE(2371),
    [sym_variable_declaration] = STATE(2371),
    [sym_manifest_constant] = STATE(2371),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2371),
    [sym_alias_declaration] = STATE(2371),
    [sym_alias_reassign] = STATE(2371),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2371),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2371),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2371),
    [sym_union_declaration] = STATE(2371),
    [sym_postblit] = STATE(2371),
    [sym_invariant_declaration] = STATE(2371),
    [sym_class_declaration] = STATE(2371),
    [sym_constructor] = STATE(2371),
    [sym_destructor] = STATE(2371),
    [sym_alias_this] = STATE(2371),
    [sym_interface_declaration] = STATE(2371),
    [sym_enum_declaration] = STATE(2371),
    [sym_anonymous_enum_declaration] = STATE(2371),
    [sym_function_declaration] = STATE(2371),
    [sym_template_declaration] = STATE(2371),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2371),
    [sym_template_mixin] = STATE(2371),
    [sym_conditional_declaration] = STATE(2371),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2371),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2371),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2371),
    [sym_static_assert] = STATE(2371),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2371),
    [aux_sym__declaration_repeat1] = STATE(1936),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5783),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5718),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1929] = {
    [sym_import_declaration] = STATE(2413),
    [sym_mixin_declaration] = STATE(2413),
    [sym__declaration2] = STATE(2413),
    [sym_variable_declaration] = STATE(2413),
    [sym_manifest_constant] = STATE(2413),
    [sym_storage_class] = STATE(2510),
    [sym_auto_declaration] = STATE(2413),
    [sym_alias_declaration] = STATE(2413),
    [sym_alias_reassign] = STATE(2413),
    [sym_type] = STATE(4668),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2413),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2413),
    [sym_pragma_expression] = STATE(1850),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2413),
    [sym_union_declaration] = STATE(2413),
    [sym_postblit] = STATE(2413),
    [sym_invariant_declaration] = STATE(2413),
    [sym_class_declaration] = STATE(2413),
    [sym_constructor] = STATE(2413),
    [sym_destructor] = STATE(2413),
    [sym_alias_this] = STATE(2413),
    [sym_interface_declaration] = STATE(2413),
    [sym_enum_declaration] = STATE(2413),
    [sym_anonymous_enum_declaration] = STATE(2413),
    [sym_function_declaration] = STATE(2413),
    [sym_template_declaration] = STATE(2413),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2413),
    [sym_template_mixin] = STATE(2413),
    [sym_conditional_declaration] = STATE(2413),
    [sym_condition] = STATE(1867),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2413),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2413),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2413),
    [sym_static_assert] = STATE(2413),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2413),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2510),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5809),
    [anon_sym_TILDE] = ACTIONS(17),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(23),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(59),
    [sym_static] = ACTIONS(61),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1930] = {
    [sym_import_declaration] = STATE(1572),
    [sym_mixin_declaration] = STATE(1572),
    [sym__declaration2] = STATE(1572),
    [sym_variable_declaration] = STATE(1572),
    [sym_manifest_constant] = STATE(1572),
    [sym_storage_class] = STATE(2511),
    [sym_auto_declaration] = STATE(1572),
    [sym_alias_declaration] = STATE(1572),
    [sym_alias_reassign] = STATE(1572),
    [sym_type] = STATE(4706),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1572),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2484),
    [sym__attribute] = STATE(2484),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1572),
    [sym_pragma_expression] = STATE(1790),
    [sym_mixin_expression] = STATE(4456),
    [sym_struct_declaration] = STATE(1572),
    [sym_union_declaration] = STATE(1572),
    [sym_postblit] = STATE(1572),
    [sym_invariant_declaration] = STATE(1572),
    [sym_class_declaration] = STATE(1572),
    [sym_constructor] = STATE(1572),
    [sym_destructor] = STATE(1572),
    [sym_alias_this] = STATE(1572),
    [sym_interface_declaration] = STATE(1572),
    [sym_enum_declaration] = STATE(1572),
    [sym_anonymous_enum_declaration] = STATE(1572),
    [sym_function_declaration] = STATE(1572),
    [sym_template_declaration] = STATE(1572),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1572),
    [sym_template_mixin] = STATE(1572),
    [sym_conditional_declaration] = STATE(1572),
    [sym_condition] = STATE(1796),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1572),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1572),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1572),
    [sym_static_assert] = STATE(1572),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1572),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2511),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(5811),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5813),
    [anon_sym_TILDE] = ACTIONS(2859),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2861),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(109),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(123),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2863),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(137),
    [sym_export] = ACTIONS(139),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2865),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(157),
    [sym_invariant] = ACTIONS(159),
    [sym_mixin] = ACTIONS(2867),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(139),
    [sym_protected] = ACTIONS(139),
    [sym_public] = ACTIONS(139),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(139),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(177),
    [sym_static] = ACTIONS(2869),
    [sym_struct] = ACTIONS(181),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(187),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(197),
    [sym_unittest] = ACTIONS(199),
    [sym_version] = ACTIONS(2871),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1931] = {
    [sym_import_declaration] = STATE(2018),
    [sym_mixin_declaration] = STATE(2018),
    [sym__declaration2] = STATE(2018),
    [sym_variable_declaration] = STATE(2018),
    [sym_manifest_constant] = STATE(2018),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2018),
    [sym_alias_declaration] = STATE(2018),
    [sym_alias_reassign] = STATE(2018),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2018),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2018),
    [sym_pragma_expression] = STATE(1802),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2018),
    [sym_union_declaration] = STATE(2018),
    [sym_postblit] = STATE(2018),
    [sym_invariant_declaration] = STATE(2018),
    [sym_class_declaration] = STATE(2018),
    [sym_constructor] = STATE(2018),
    [sym_destructor] = STATE(2018),
    [sym_alias_this] = STATE(2018),
    [sym_interface_declaration] = STATE(2018),
    [sym_enum_declaration] = STATE(2018),
    [sym_anonymous_enum_declaration] = STATE(2018),
    [sym_function_declaration] = STATE(2018),
    [sym_template_declaration] = STATE(2018),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2018),
    [sym_template_mixin] = STATE(2018),
    [sym_conditional_declaration] = STATE(2018),
    [sym_condition] = STATE(1761),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2018),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2018),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2018),
    [sym_static_assert] = STATE(2018),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2018),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5815),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5320),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1932] = {
    [sym_import_declaration] = STATE(2413),
    [sym_mixin_declaration] = STATE(2413),
    [sym__declaration2] = STATE(2413),
    [sym_variable_declaration] = STATE(2413),
    [sym_manifest_constant] = STATE(2413),
    [sym_storage_class] = STATE(2515),
    [sym_auto_declaration] = STATE(2413),
    [sym_alias_declaration] = STATE(2413),
    [sym_alias_reassign] = STATE(2413),
    [sym_type] = STATE(4734),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2413),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2495),
    [sym__attribute] = STATE(2495),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2413),
    [sym_pragma_expression] = STATE(1715),
    [sym_mixin_expression] = STATE(4434),
    [sym_struct_declaration] = STATE(2413),
    [sym_union_declaration] = STATE(2413),
    [sym_postblit] = STATE(2413),
    [sym_invariant_declaration] = STATE(2413),
    [sym_class_declaration] = STATE(2413),
    [sym_constructor] = STATE(2413),
    [sym_destructor] = STATE(2413),
    [sym_alias_this] = STATE(2413),
    [sym_interface_declaration] = STATE(2413),
    [sym_enum_declaration] = STATE(2413),
    [sym_anonymous_enum_declaration] = STATE(2413),
    [sym_function_declaration] = STATE(2413),
    [sym_template_declaration] = STATE(2413),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2413),
    [sym_template_mixin] = STATE(2413),
    [sym_conditional_declaration] = STATE(2413),
    [sym_condition] = STATE(1824),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2413),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2413),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2413),
    [sym_static_assert] = STATE(2413),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2413),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2515),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_LBRACE] = ACTIONS(5807),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5809),
    [anon_sym_TILDE] = ACTIONS(5256),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5258),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(27),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(31),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(35),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(39),
    [sym_export] = ACTIONS(41),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(45),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(47),
    [sym_invariant] = ACTIONS(49),
    [sym_mixin] = ACTIONS(51),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(41),
    [sym_protected] = ACTIONS(41),
    [sym_public] = ACTIONS(41),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(41),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1822),
    [sym_static] = ACTIONS(5260),
    [sym_struct] = ACTIONS(63),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(65),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_unittest] = ACTIONS(71),
    [sym_version] = ACTIONS(73),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1933] = {
    [sym_import_declaration] = STATE(2324),
    [sym_mixin_declaration] = STATE(2324),
    [sym__declaration2] = STATE(2324),
    [sym_variable_declaration] = STATE(2324),
    [sym_manifest_constant] = STATE(2324),
    [sym_storage_class] = STATE(2518),
    [sym_auto_declaration] = STATE(2324),
    [sym_alias_declaration] = STATE(2324),
    [sym_alias_reassign] = STATE(2324),
    [sym_type] = STATE(4637),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2324),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2324),
    [sym_pragma_expression] = STATE(1719),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2324),
    [sym_union_declaration] = STATE(2324),
    [sym_postblit] = STATE(2324),
    [sym_invariant_declaration] = STATE(2324),
    [sym_class_declaration] = STATE(2324),
    [sym_constructor] = STATE(2324),
    [sym_destructor] = STATE(2324),
    [sym_alias_this] = STATE(2324),
    [sym_interface_declaration] = STATE(2324),
    [sym_enum_declaration] = STATE(2324),
    [sym_anonymous_enum_declaration] = STATE(2324),
    [sym_function_declaration] = STATE(2324),
    [sym_template_declaration] = STATE(2324),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2324),
    [sym_template_mixin] = STATE(2324),
    [sym_conditional_declaration] = STATE(2324),
    [sym_condition] = STATE(1831),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2324),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2324),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2324),
    [sym_static_assert] = STATE(2324),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2324),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2518),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5819),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_TILDE] = ACTIONS(5276),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5278),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(1016),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1124),
    [sym_static] = ACTIONS(5280),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(1048),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1934] = {
    [sym_import_declaration] = STATE(1445),
    [sym_mixin_declaration] = STATE(1445),
    [sym__declaration2] = STATE(1445),
    [sym_variable_declaration] = STATE(1445),
    [sym_manifest_constant] = STATE(1445),
    [sym_storage_class] = STATE(2514),
    [sym_auto_declaration] = STATE(1445),
    [sym_alias_declaration] = STATE(1445),
    [sym_alias_reassign] = STATE(1445),
    [sym_type] = STATE(4727),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(1445),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2477),
    [sym__attribute] = STATE(2477),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(1445),
    [sym_pragma_expression] = STATE(1868),
    [sym_mixin_expression] = STATE(4451),
    [sym_struct_declaration] = STATE(1445),
    [sym_union_declaration] = STATE(1445),
    [sym_postblit] = STATE(1445),
    [sym_invariant_declaration] = STATE(1445),
    [sym_class_declaration] = STATE(1445),
    [sym_constructor] = STATE(1445),
    [sym_destructor] = STATE(1445),
    [sym_alias_this] = STATE(1445),
    [sym_interface_declaration] = STATE(1445),
    [sym_enum_declaration] = STATE(1445),
    [sym_anonymous_enum_declaration] = STATE(1445),
    [sym_function_declaration] = STATE(1445),
    [sym_template_declaration] = STATE(1445),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(1445),
    [sym_template_mixin] = STATE(1445),
    [sym_conditional_declaration] = STATE(1445),
    [sym_condition] = STATE(1825),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(1445),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(1445),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(1445),
    [sym_static_assert] = STATE(1445),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(1445),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2514),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(5823),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5825),
    [anon_sym_TILDE] = ACTIONS(2509),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(2511),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(313),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(321),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(2513),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(329),
    [sym_export] = ACTIONS(331),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(2515),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(345),
    [sym_invariant] = ACTIONS(347),
    [sym_mixin] = ACTIONS(2517),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(331),
    [sym_protected] = ACTIONS(331),
    [sym_public] = ACTIONS(331),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(331),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(355),
    [sym_static] = ACTIONS(2519),
    [sym_struct] = ACTIONS(359),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(365),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(369),
    [sym_unittest] = ACTIONS(371),
    [sym_version] = ACTIONS(2521),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1935] = {
    [sym_import_declaration] = STATE(2018),
    [sym_mixin_declaration] = STATE(2018),
    [sym__declaration2] = STATE(2018),
    [sym_variable_declaration] = STATE(2018),
    [sym_manifest_constant] = STATE(2018),
    [sym_storage_class] = STATE(2507),
    [sym_auto_declaration] = STATE(2018),
    [sym_alias_declaration] = STATE(2018),
    [sym_alias_reassign] = STATE(2018),
    [sym_type] = STATE(4696),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2018),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2491),
    [sym__attribute] = STATE(2491),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2018),
    [sym_pragma_expression] = STATE(1754),
    [sym_mixin_expression] = STATE(4454),
    [sym_struct_declaration] = STATE(2018),
    [sym_union_declaration] = STATE(2018),
    [sym_postblit] = STATE(2018),
    [sym_invariant_declaration] = STATE(2018),
    [sym_class_declaration] = STATE(2018),
    [sym_constructor] = STATE(2018),
    [sym_destructor] = STATE(2018),
    [sym_alias_this] = STATE(2018),
    [sym_interface_declaration] = STATE(2018),
    [sym_enum_declaration] = STATE(2018),
    [sym_anonymous_enum_declaration] = STATE(2018),
    [sym_function_declaration] = STATE(2018),
    [sym_template_declaration] = STATE(2018),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2018),
    [sym_template_mixin] = STATE(2018),
    [sym_conditional_declaration] = STATE(2018),
    [sym_condition] = STATE(1813),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2018),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2018),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2018),
    [sym_static_assert] = STATE(2018),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2018),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2507),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5815),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5817),
    [anon_sym_TILDE] = ACTIONS(5300),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5302),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(684),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(696),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5304),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1236),
    [sym_export] = ACTIONS(713),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5306),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(731),
    [sym_invariant] = ACTIONS(733),
    [sym_mixin] = ACTIONS(5308),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(713),
    [sym_protected] = ACTIONS(713),
    [sym_public] = ACTIONS(713),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(713),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(1244),
    [sym_static] = ACTIONS(5310),
    [sym_struct] = ACTIONS(752),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(759),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(766),
    [sym_unittest] = ACTIONS(768),
    [sym_version] = ACTIONS(5312),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1936] = {
    [sym_import_declaration] = STATE(2324),
    [sym_mixin_declaration] = STATE(2324),
    [sym__declaration2] = STATE(2324),
    [sym_variable_declaration] = STATE(2324),
    [sym_manifest_constant] = STATE(2324),
    [sym_storage_class] = STATE(2509),
    [sym_auto_declaration] = STATE(2324),
    [sym_alias_declaration] = STATE(2324),
    [sym_alias_reassign] = STATE(2324),
    [sym_type] = STATE(4700),
    [sym_type_ctor] = STATE(2458),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_attribute_declaration] = STATE(2324),
    [sym_align_attribute] = STATE(2496),
    [sym_deprecated_attribute] = STATE(2485),
    [sym__attribute] = STATE(2485),
    [sym_at_attribute] = STATE(2496),
    [sym__function_attribute_kwd] = STATE(2496),
    [sym_linkage_attribute] = STATE(2496),
    [sym_pragma_declaration] = STATE(2324),
    [sym_pragma_expression] = STATE(1866),
    [sym_mixin_expression] = STATE(4438),
    [sym_struct_declaration] = STATE(2324),
    [sym_union_declaration] = STATE(2324),
    [sym_postblit] = STATE(2324),
    [sym_invariant_declaration] = STATE(2324),
    [sym_class_declaration] = STATE(2324),
    [sym_constructor] = STATE(2324),
    [sym_destructor] = STATE(2324),
    [sym_alias_this] = STATE(2324),
    [sym_interface_declaration] = STATE(2324),
    [sym_enum_declaration] = STATE(2324),
    [sym_anonymous_enum_declaration] = STATE(2324),
    [sym_function_declaration] = STATE(2324),
    [sym_template_declaration] = STATE(2324),
    [sym_template_instance] = STATE(4235),
    [sym_mixin_template_declaration] = STATE(2324),
    [sym_template_mixin] = STATE(2324),
    [sym_conditional_declaration] = STATE(2324),
    [sym_condition] = STATE(1839),
    [sym_version_condition] = STATE(2492),
    [sym_version_specification] = STATE(2324),
    [sym_debug_condition] = STATE(2492),
    [sym_debug_specification] = STATE(2324),
    [sym_static_if_condition] = STATE(2492),
    [sym_static_foreach_declaration] = STATE(2324),
    [sym_static_assert] = STATE(2324),
    [sym_traits_expression] = STATE(4223),
    [sym_unittest_declaration] = STATE(2324),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [aux_sym_variable_declaration_repeat1] = STATE(2509),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(5819),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(5821),
    [anon_sym_TILDE] = ACTIONS(5098),
    [anon_sym_AT] = ACTIONS(19),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(5100),
    [sym_abstract] = ACTIONS(25),
    [sym_alias] = ACTIONS(990),
    [sym_align] = ACTIONS(29),
    [sym_auto] = ACTIONS(25),
    [sym_class] = ACTIONS(992),
    [sym_const] = ACTIONS(33),
    [sym_debug] = ACTIONS(5102),
    [sym_deprecated] = ACTIONS(37),
    [sym_enum] = ACTIONS(1116),
    [sym_export] = ACTIONS(1000),
    [sym_extern] = ACTIONS(43),
    [sym_final] = ACTIONS(25),
    [sym_immutable] = ACTIONS(33),
    [sym_import] = ACTIONS(5104),
    [sym_inout] = ACTIONS(33),
    [sym_interface] = ACTIONS(1014),
    [sym_invariant] = ACTIONS(5106),
    [sym_mixin] = ACTIONS(5108),
    [sym_nothrow] = ACTIONS(25),
    [sym_override] = ACTIONS(25),
    [sym_package] = ACTIONS(55),
    [sym_pragma] = ACTIONS(57),
    [sym_private] = ACTIONS(1000),
    [sym_protected] = ACTIONS(1000),
    [sym_public] = ACTIONS(1000),
    [sym_pure] = ACTIONS(25),
    [sym_ref] = ACTIONS(25),
    [sym_return] = ACTIONS(1000),
    [sym_scope] = ACTIONS(25),
    [sym_shared] = ACTIONS(5110),
    [sym_static] = ACTIONS(5112),
    [sym_struct] = ACTIONS(1034),
    [sym_synchronized] = ACTIONS(25),
    [sym_template] = ACTIONS(1042),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(1046),
    [sym_unittest] = ACTIONS(5114),
    [sym_version] = ACTIONS(5116),
    [sym_gshared] = ACTIONS(25),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [1937] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(5827),
    [sym_function] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1938] = {
    [sym_identifier] = ACTIONS(3167),
    [anon_sym_q_LBRACE] = ACTIONS(3170),
    [anon_sym_LBRACE] = ACTIONS(3170),
    [anon_sym_SLASH] = ACTIONS(3127),
    [anon_sym_SLASH_EQ] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3170),
    [anon_sym_AMP] = ACTIONS(3167),
    [anon_sym_AMP_EQ] = ACTIONS(3129),
    [anon_sym_AMP_AMP] = ACTIONS(3129),
    [anon_sym_PIPE] = ACTIONS(3127),
    [anon_sym_PIPE_EQ] = ACTIONS(3129),
    [anon_sym_PIPE_PIPE] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3167),
    [anon_sym_DASH_EQ] = ACTIONS(3129),
    [anon_sym_DASH_DASH] = ACTIONS(3170),
    [anon_sym_PLUS] = ACTIONS(3167),
    [anon_sym_PLUS_EQ] = ACTIONS(3129),
    [anon_sym_PLUS_PLUS] = ACTIONS(3170),
    [anon_sym_LT] = ACTIONS(3127),
    [anon_sym_LT_EQ] = ACTIONS(3129),
    [anon_sym_LT_LT] = ACTIONS(3127),
    [anon_sym_LT_LT_EQ] = ACTIONS(3129),
    [anon_sym_GT] = ACTIONS(3127),
    [anon_sym_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3129),
    [anon_sym_GT_GT] = ACTIONS(3127),
    [anon_sym_GT_GT_GT] = ACTIONS(3127),
    [anon_sym_BANG] = ACTIONS(3167),
    [anon_sym_BANG_EQ] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3170),
    [anon_sym_RPAREN] = ACTIONS(3170),
    [anon_sym_LBRACK] = ACTIONS(3170),
    [anon_sym_QMARK] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3170),
    [anon_sym_DOLLAR] = ACTIONS(3170),
    [anon_sym_EQ] = ACTIONS(3127),
    [anon_sym_EQ_EQ] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3167),
    [anon_sym_STAR_EQ] = ACTIONS(3129),
    [anon_sym_PERCENT] = ACTIONS(3127),
    [anon_sym_PERCENT_EQ] = ACTIONS(3129),
    [anon_sym_CARET] = ACTIONS(3127),
    [anon_sym_CARET_EQ] = ACTIONS(3129),
    [anon_sym_CARET_CARET] = ACTIONS(3127),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3167),
    [anon_sym_TILDE_EQ] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3167),
    [sym_byte] = ACTIONS(3167),
    [sym_ubyte] = ACTIONS(3167),
    [sym_char] = ACTIONS(3167),
    [sym_short] = ACTIONS(3167),
    [sym_ushort] = ACTIONS(3167),
    [sym_int] = ACTIONS(3167),
    [sym_uint] = ACTIONS(3167),
    [sym_long] = ACTIONS(3167),
    [sym_ulong] = ACTIONS(3167),
    [sym_cent] = ACTIONS(3167),
    [sym_ucent] = ACTIONS(3167),
    [sym_wchar] = ACTIONS(3167),
    [sym_dchar] = ACTIONS(3167),
    [sym_float] = ACTIONS(3167),
    [sym_double] = ACTIONS(3167),
    [sym_real] = ACTIONS(3167),
    [sym_ifloat] = ACTIONS(3167),
    [sym_idouble] = ACTIONS(3167),
    [sym_ireal] = ACTIONS(3167),
    [sym_cfloat] = ACTIONS(3167),
    [sym_cdouble] = ACTIONS(3167),
    [sym_creal] = ACTIONS(3167),
    [sym_size_t] = ACTIONS(3167),
    [sym_ptrdiff_t] = ACTIONS(3167),
    [sym_string] = ACTIONS(3167),
    [sym_cstring] = ACTIONS(3167),
    [sym_dstring] = ACTIONS(3167),
    [sym_wstring] = ACTIONS(3167),
    [sym_noreturn] = ACTIONS(3167),
    [sym_true] = ACTIONS(3167),
    [sym_false] = ACTIONS(3167),
    [sym_null] = ACTIONS(3167),
    [sym_super] = ACTIONS(3167),
    [sym_this] = ACTIONS(3167),
    [sym_assert] = ACTIONS(3167),
    [sym_auto] = ACTIONS(3167),
    [sym_cast] = ACTIONS(3167),
    [sym_const] = ACTIONS(3167),
    [sym_delegate] = ACTIONS(3167),
    [sym_delete] = ACTIONS(3167),
    [sym_do] = ACTIONS(3167),
    [sym_else] = ACTIONS(5831),
    [sym_function] = ACTIONS(3167),
    [sym_immutable] = ACTIONS(3167),
    [sym_import] = ACTIONS(3167),
    [sym_in] = ACTIONS(3167),
    [sym_inout] = ACTIONS(3167),
    [sym_is] = ACTIONS(3167),
    [sym_mixin] = ACTIONS(3167),
    [sym_new] = ACTIONS(3167),
    [sym_out] = ACTIONS(3167),
    [sym_ref] = ACTIONS(3167),
    [sym_shared] = ACTIONS(3167),
    [sym_throw] = ACTIONS(3167),
    [sym_typeid] = ACTIONS(3167),
    [sym_typeof] = ACTIONS(3167),
    [sym_traits] = ACTIONS(3167),
    [sym_vector] = ACTIONS(3167),
    [sym_void] = ACTIONS(3167),
    [anon_sym_BQUOTE] = ACTIONS(3170),
    [anon_sym_r_DQUOTE] = ACTIONS(3170),
    [anon_sym_x_DQUOTE] = ACTIONS(3170),
    [anon_sym_DQUOTE] = ACTIONS(3170),
    [anon_sym_i_BQUOTE] = ACTIONS(3170),
    [anon_sym_i_DQUOTE] = ACTIONS(3170),
    [anon_sym_iq_LBRACE] = ACTIONS(3170),
    [aux_sym_char_literal_token1] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(3167),
    [anon_sym___DATE__] = ACTIONS(3167),
    [anon_sym___FILE__] = ACTIONS(3167),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3167),
    [anon_sym___FUNCTION__] = ACTIONS(3167),
    [anon_sym___LINE__] = ACTIONS(3167),
    [anon_sym___MODULE__] = ACTIONS(3167),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3167),
    [anon_sym___TIME__] = ACTIONS(3167),
    [anon_sym___TIMESTAMP__] = ACTIONS(3167),
    [anon_sym___VENDOR__] = ACTIONS(3167),
    [anon_sym___VERSION__] = ACTIONS(3167),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3170),
    [sym_float_literal] = ACTIONS(3170),
    [sym__string] = ACTIONS(3170),
    [sym_not_in] = ACTIONS(3129),
    [sym_not_is] = ACTIONS(3129),
  },
  [1939] = {
    [sym_catch_statement] = STATE(1947),
    [sym_finally_statement] = STATE(2064),
    [aux_sym_try_statement_repeat1] = STATE(1947),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(5834),
    [sym_const] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_finally] = ACTIONS(5836),
    [sym_function] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1940] = {
    [sym_catch_statement] = STATE(1939),
    [sym_finally_statement] = STATE(2008),
    [aux_sym_try_statement_repeat1] = STATE(1939),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(5834),
    [sym_const] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_else] = ACTIONS(4182),
    [sym_finally] = ACTIONS(5836),
    [sym_function] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1941] = {
    [sym_catch_statement] = STATE(1942),
    [sym_finally_statement] = STATE(2008),
    [aux_sym_try_statement_repeat1] = STATE(1942),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(5834),
    [sym_const] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_else] = ACTIONS(4182),
    [sym_finally] = ACTIONS(5838),
    [sym_function] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1942] = {
    [sym_catch_statement] = STATE(1947),
    [sym_finally_statement] = STATE(2064),
    [aux_sym_try_statement_repeat1] = STATE(1947),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(5834),
    [sym_const] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_finally] = ACTIONS(5838),
    [sym_function] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1943] = {
    [sym_catch_statement] = STATE(1948),
    [sym_finally_statement] = STATE(2064),
    [aux_sym_try_statement_repeat1] = STATE(1948),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(5840),
    [sym_const] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_finally] = ACTIONS(5842),
    [sym_function] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1944] = {
    [sym_catch_statement] = STATE(1946),
    [sym_finally_statement] = STATE(2008),
    [aux_sym_try_statement_repeat1] = STATE(1946),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(5840),
    [sym_const] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_finally] = ACTIONS(5844),
    [sym_function] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1945] = {
    [sym_catch_statement] = STATE(1943),
    [sym_finally_statement] = STATE(2008),
    [aux_sym_try_statement_repeat1] = STATE(1943),
    [sym_identifier] = ACTIONS(4182),
    [anon_sym_q_LBRACE] = ACTIONS(4184),
    [anon_sym_LBRACE] = ACTIONS(4184),
    [anon_sym_DOT] = ACTIONS(4184),
    [anon_sym_AMP] = ACTIONS(4184),
    [anon_sym_DASH] = ACTIONS(4182),
    [anon_sym_DASH_DASH] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4182),
    [anon_sym_PLUS_PLUS] = ACTIONS(4184),
    [anon_sym_BANG] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4184),
    [anon_sym_RPAREN] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4184),
    [anon_sym_SEMI] = ACTIONS(4184),
    [anon_sym_DOLLAR] = ACTIONS(4184),
    [anon_sym_STAR] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4184),
    [sym_bool] = ACTIONS(4182),
    [sym_byte] = ACTIONS(4182),
    [sym_ubyte] = ACTIONS(4182),
    [sym_char] = ACTIONS(4182),
    [sym_short] = ACTIONS(4182),
    [sym_ushort] = ACTIONS(4182),
    [sym_int] = ACTIONS(4182),
    [sym_uint] = ACTIONS(4182),
    [sym_long] = ACTIONS(4182),
    [sym_ulong] = ACTIONS(4182),
    [sym_cent] = ACTIONS(4182),
    [sym_ucent] = ACTIONS(4182),
    [sym_wchar] = ACTIONS(4182),
    [sym_dchar] = ACTIONS(4182),
    [sym_float] = ACTIONS(4182),
    [sym_double] = ACTIONS(4182),
    [sym_real] = ACTIONS(4182),
    [sym_ifloat] = ACTIONS(4182),
    [sym_idouble] = ACTIONS(4182),
    [sym_ireal] = ACTIONS(4182),
    [sym_cfloat] = ACTIONS(4182),
    [sym_cdouble] = ACTIONS(4182),
    [sym_creal] = ACTIONS(4182),
    [sym_size_t] = ACTIONS(4182),
    [sym_ptrdiff_t] = ACTIONS(4182),
    [sym_string] = ACTIONS(4182),
    [sym_cstring] = ACTIONS(4182),
    [sym_dstring] = ACTIONS(4182),
    [sym_wstring] = ACTIONS(4182),
    [sym_noreturn] = ACTIONS(4182),
    [sym_true] = ACTIONS(4182),
    [sym_false] = ACTIONS(4182),
    [sym_null] = ACTIONS(4182),
    [sym_super] = ACTIONS(4182),
    [sym_this] = ACTIONS(4182),
    [sym_assert] = ACTIONS(4182),
    [sym_auto] = ACTIONS(4182),
    [sym_cast] = ACTIONS(4182),
    [sym_catch] = ACTIONS(5840),
    [sym_const] = ACTIONS(4182),
    [sym_delegate] = ACTIONS(4182),
    [sym_delete] = ACTIONS(4182),
    [sym_do] = ACTIONS(4182),
    [sym_finally] = ACTIONS(5842),
    [sym_function] = ACTIONS(4182),
    [sym_immutable] = ACTIONS(4182),
    [sym_import] = ACTIONS(4182),
    [sym_in] = ACTIONS(4182),
    [sym_inout] = ACTIONS(4182),
    [sym_is] = ACTIONS(4182),
    [sym_mixin] = ACTIONS(4182),
    [sym_new] = ACTIONS(4182),
    [sym_out] = ACTIONS(4182),
    [sym_ref] = ACTIONS(4182),
    [sym_shared] = ACTIONS(4182),
    [sym_throw] = ACTIONS(4182),
    [sym_typeid] = ACTIONS(4182),
    [sym_typeof] = ACTIONS(4182),
    [sym_traits] = ACTIONS(4182),
    [sym_vector] = ACTIONS(4182),
    [sym_void] = ACTIONS(4182),
    [anon_sym_BQUOTE] = ACTIONS(4184),
    [anon_sym_r_DQUOTE] = ACTIONS(4184),
    [anon_sym_x_DQUOTE] = ACTIONS(4184),
    [anon_sym_DQUOTE] = ACTIONS(4184),
    [anon_sym_i_BQUOTE] = ACTIONS(4184),
    [anon_sym_i_DQUOTE] = ACTIONS(4184),
    [anon_sym_iq_LBRACE] = ACTIONS(4184),
    [aux_sym_char_literal_token1] = ACTIONS(4184),
    [anon_sym_SQUOTE] = ACTIONS(4182),
    [anon_sym___DATE__] = ACTIONS(4182),
    [anon_sym___FILE__] = ACTIONS(4182),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4182),
    [anon_sym___FUNCTION__] = ACTIONS(4182),
    [anon_sym___LINE__] = ACTIONS(4182),
    [anon_sym___MODULE__] = ACTIONS(4182),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4182),
    [anon_sym___TIME__] = ACTIONS(4182),
    [anon_sym___TIMESTAMP__] = ACTIONS(4182),
    [anon_sym___VENDOR__] = ACTIONS(4182),
    [anon_sym___VERSION__] = ACTIONS(4182),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4184),
    [sym_float_literal] = ACTIONS(4184),
    [sym__string] = ACTIONS(4184),
  },
  [1946] = {
    [sym_catch_statement] = STATE(1948),
    [sym_finally_statement] = STATE(2064),
    [aux_sym_try_statement_repeat1] = STATE(1948),
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(5840),
    [sym_const] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_finally] = ACTIONS(5844),
    [sym_function] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [1947] = {
    [sym_catch_statement] = STATE(1947),
    [aux_sym_try_statement_repeat1] = STATE(1947),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_q_LBRACE] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_DOT] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_DOLLAR] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [sym_bool] = ACTIONS(4196),
    [sym_byte] = ACTIONS(4196),
    [sym_ubyte] = ACTIONS(4196),
    [sym_char] = ACTIONS(4196),
    [sym_short] = ACTIONS(4196),
    [sym_ushort] = ACTIONS(4196),
    [sym_int] = ACTIONS(4196),
    [sym_uint] = ACTIONS(4196),
    [sym_long] = ACTIONS(4196),
    [sym_ulong] = ACTIONS(4196),
    [sym_cent] = ACTIONS(4196),
    [sym_ucent] = ACTIONS(4196),
    [sym_wchar] = ACTIONS(4196),
    [sym_dchar] = ACTIONS(4196),
    [sym_float] = ACTIONS(4196),
    [sym_double] = ACTIONS(4196),
    [sym_real] = ACTIONS(4196),
    [sym_ifloat] = ACTIONS(4196),
    [sym_idouble] = ACTIONS(4196),
    [sym_ireal] = ACTIONS(4196),
    [sym_cfloat] = ACTIONS(4196),
    [sym_cdouble] = ACTIONS(4196),
    [sym_creal] = ACTIONS(4196),
    [sym_size_t] = ACTIONS(4196),
    [sym_ptrdiff_t] = ACTIONS(4196),
    [sym_string] = ACTIONS(4196),
    [sym_cstring] = ACTIONS(4196),
    [sym_dstring] = ACTIONS(4196),
    [sym_wstring] = ACTIONS(4196),
    [sym_noreturn] = ACTIONS(4196),
    [sym_true] = ACTIONS(4196),
    [sym_false] = ACTIONS(4196),
    [sym_null] = ACTIONS(4196),
    [sym_super] = ACTIONS(4196),
    [sym_this] = ACTIONS(4196),
    [sym_assert] = ACTIONS(4196),
    [sym_auto] = ACTIONS(4196),
    [sym_cast] = ACTIONS(4196),
    [sym_catch] = ACTIONS(5846),
    [sym_const] = ACTIONS(4196),
    [sym_delegate] = ACTIONS(4196),
    [sym_delete] = ACTIONS(4196),
    [sym_do] = ACTIONS(4196),
    [sym_else] = ACTIONS(4196),
    [sym_finally] = ACTIONS(4196),
    [sym_function] = ACTIONS(4196),
    [sym_immutable] = ACTIONS(4196),
    [sym_import] = ACTIONS(4196),
    [sym_in] = ACTIONS(4196),
    [sym_inout] = ACTIONS(4196),
    [sym_is] = ACTIONS(4196),
    [sym_mixin] = ACTIONS(4196),
    [sym_new] = ACTIONS(4196),
    [sym_out] = ACTIONS(4196),
    [sym_ref] = ACTIONS(4196),
    [sym_shared] = ACTIONS(4196),
    [sym_throw] = ACTIONS(4196),
    [sym_typeid] = ACTIONS(4196),
    [sym_typeof] = ACTIONS(4196),
    [sym_traits] = ACTIONS(4196),
    [sym_vector] = ACTIONS(4196),
    [sym_void] = ACTIONS(4196),
    [anon_sym_BQUOTE] = ACTIONS(4198),
    [anon_sym_r_DQUOTE] = ACTIONS(4198),
    [anon_sym_x_DQUOTE] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(4198),
    [anon_sym_i_BQUOTE] = ACTIONS(4198),
    [anon_sym_i_DQUOTE] = ACTIONS(4198),
    [anon_sym_iq_LBRACE] = ACTIONS(4198),
    [aux_sym_char_literal_token1] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4196),
    [anon_sym___DATE__] = ACTIONS(4196),
    [anon_sym___FILE__] = ACTIONS(4196),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4196),
    [anon_sym___FUNCTION__] = ACTIONS(4196),
    [anon_sym___LINE__] = ACTIONS(4196),
    [anon_sym___MODULE__] = ACTIONS(4196),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4196),
    [anon_sym___TIME__] = ACTIONS(4196),
    [anon_sym___TIMESTAMP__] = ACTIONS(4196),
    [anon_sym___VENDOR__] = ACTIONS(4196),
    [anon_sym___VERSION__] = ACTIONS(4196),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4198),
    [sym_float_literal] = ACTIONS(4198),
    [sym__string] = ACTIONS(4198),
  },
  [1948] = {
    [sym_catch_statement] = STATE(1948),
    [aux_sym_try_statement_repeat1] = STATE(1948),
    [sym_identifier] = ACTIONS(4196),
    [anon_sym_q_LBRACE] = ACTIONS(4198),
    [anon_sym_LBRACE] = ACTIONS(4198),
    [anon_sym_DOT] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4198),
    [anon_sym_DASH] = ACTIONS(4196),
    [anon_sym_DASH_DASH] = ACTIONS(4198),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_PLUS_PLUS] = ACTIONS(4198),
    [anon_sym_BANG] = ACTIONS(4198),
    [anon_sym_LPAREN] = ACTIONS(4198),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_SEMI] = ACTIONS(4198),
    [anon_sym_DOLLAR] = ACTIONS(4198),
    [anon_sym_STAR] = ACTIONS(4198),
    [anon_sym_TILDE] = ACTIONS(4198),
    [sym_bool] = ACTIONS(4196),
    [sym_byte] = ACTIONS(4196),
    [sym_ubyte] = ACTIONS(4196),
    [sym_char] = ACTIONS(4196),
    [sym_short] = ACTIONS(4196),
    [sym_ushort] = ACTIONS(4196),
    [sym_int] = ACTIONS(4196),
    [sym_uint] = ACTIONS(4196),
    [sym_long] = ACTIONS(4196),
    [sym_ulong] = ACTIONS(4196),
    [sym_cent] = ACTIONS(4196),
    [sym_ucent] = ACTIONS(4196),
    [sym_wchar] = ACTIONS(4196),
    [sym_dchar] = ACTIONS(4196),
    [sym_float] = ACTIONS(4196),
    [sym_double] = ACTIONS(4196),
    [sym_real] = ACTIONS(4196),
    [sym_ifloat] = ACTIONS(4196),
    [sym_idouble] = ACTIONS(4196),
    [sym_ireal] = ACTIONS(4196),
    [sym_cfloat] = ACTIONS(4196),
    [sym_cdouble] = ACTIONS(4196),
    [sym_creal] = ACTIONS(4196),
    [sym_size_t] = ACTIONS(4196),
    [sym_ptrdiff_t] = ACTIONS(4196),
    [sym_string] = ACTIONS(4196),
    [sym_cstring] = ACTIONS(4196),
    [sym_dstring] = ACTIONS(4196),
    [sym_wstring] = ACTIONS(4196),
    [sym_noreturn] = ACTIONS(4196),
    [sym_true] = ACTIONS(4196),
    [sym_false] = ACTIONS(4196),
    [sym_null] = ACTIONS(4196),
    [sym_super] = ACTIONS(4196),
    [sym_this] = ACTIONS(4196),
    [sym_assert] = ACTIONS(4196),
    [sym_auto] = ACTIONS(4196),
    [sym_cast] = ACTIONS(4196),
    [sym_catch] = ACTIONS(5849),
    [sym_const] = ACTIONS(4196),
    [sym_delegate] = ACTIONS(4196),
    [sym_delete] = ACTIONS(4196),
    [sym_do] = ACTIONS(4196),
    [sym_finally] = ACTIONS(4196),
    [sym_function] = ACTIONS(4196),
    [sym_immutable] = ACTIONS(4196),
    [sym_import] = ACTIONS(4196),
    [sym_in] = ACTIONS(4196),
    [sym_inout] = ACTIONS(4196),
    [sym_is] = ACTIONS(4196),
    [sym_mixin] = ACTIONS(4196),
    [sym_new] = ACTIONS(4196),
    [sym_out] = ACTIONS(4196),
    [sym_ref] = ACTIONS(4196),
    [sym_shared] = ACTIONS(4196),
    [sym_throw] = ACTIONS(4196),
    [sym_typeid] = ACTIONS(4196),
    [sym_typeof] = ACTIONS(4196),
    [sym_traits] = ACTIONS(4196),
    [sym_vector] = ACTIONS(4196),
    [sym_void] = ACTIONS(4196),
    [anon_sym_BQUOTE] = ACTIONS(4198),
    [anon_sym_r_DQUOTE] = ACTIONS(4198),
    [anon_sym_x_DQUOTE] = ACTIONS(4198),
    [anon_sym_DQUOTE] = ACTIONS(4198),
    [anon_sym_i_BQUOTE] = ACTIONS(4198),
    [anon_sym_i_DQUOTE] = ACTIONS(4198),
    [anon_sym_iq_LBRACE] = ACTIONS(4198),
    [aux_sym_char_literal_token1] = ACTIONS(4198),
    [anon_sym_SQUOTE] = ACTIONS(4196),
    [anon_sym___DATE__] = ACTIONS(4196),
    [anon_sym___FILE__] = ACTIONS(4196),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4196),
    [anon_sym___FUNCTION__] = ACTIONS(4196),
    [anon_sym___LINE__] = ACTIONS(4196),
    [anon_sym___MODULE__] = ACTIONS(4196),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4196),
    [anon_sym___TIME__] = ACTIONS(4196),
    [anon_sym___TIMESTAMP__] = ACTIONS(4196),
    [anon_sym___VENDOR__] = ACTIONS(4196),
    [anon_sym___VERSION__] = ACTIONS(4196),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4198),
    [sym_float_literal] = ACTIONS(4198),
    [sym__string] = ACTIONS(4198),
  },
  [1949] = {
    [sym_identifier] = ACTIONS(4618),
    [anon_sym_q_LBRACE] = ACTIONS(4620),
    [anon_sym_LBRACE] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4620),
    [anon_sym_AMP] = ACTIONS(4620),
    [anon_sym_DASH] = ACTIONS(4618),
    [anon_sym_DASH_DASH] = ACTIONS(4620),
    [anon_sym_PLUS] = ACTIONS(4618),
    [anon_sym_PLUS_PLUS] = ACTIONS(4620),
    [anon_sym_BANG] = ACTIONS(4620),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_SEMI] = ACTIONS(4620),
    [anon_sym_DOLLAR] = ACTIONS(4620),
    [anon_sym_STAR] = ACTIONS(4620),
    [anon_sym_TILDE] = ACTIONS(4620),
    [sym_bool] = ACTIONS(4618),
    [sym_byte] = ACTIONS(4618),
    [sym_ubyte] = ACTIONS(4618),
    [sym_char] = ACTIONS(4618),
    [sym_short] = ACTIONS(4618),
    [sym_ushort] = ACTIONS(4618),
    [sym_int] = ACTIONS(4618),
    [sym_uint] = ACTIONS(4618),
    [sym_long] = ACTIONS(4618),
    [sym_ulong] = ACTIONS(4618),
    [sym_cent] = ACTIONS(4618),
    [sym_ucent] = ACTIONS(4618),
    [sym_wchar] = ACTIONS(4618),
    [sym_dchar] = ACTIONS(4618),
    [sym_float] = ACTIONS(4618),
    [sym_double] = ACTIONS(4618),
    [sym_real] = ACTIONS(4618),
    [sym_ifloat] = ACTIONS(4618),
    [sym_idouble] = ACTIONS(4618),
    [sym_ireal] = ACTIONS(4618),
    [sym_cfloat] = ACTIONS(4618),
    [sym_cdouble] = ACTIONS(4618),
    [sym_creal] = ACTIONS(4618),
    [sym_size_t] = ACTIONS(4618),
    [sym_ptrdiff_t] = ACTIONS(4618),
    [sym_string] = ACTIONS(4618),
    [sym_cstring] = ACTIONS(4618),
    [sym_dstring] = ACTIONS(4618),
    [sym_wstring] = ACTIONS(4618),
    [sym_noreturn] = ACTIONS(4618),
    [sym_true] = ACTIONS(4618),
    [sym_false] = ACTIONS(4618),
    [sym_null] = ACTIONS(4618),
    [sym_super] = ACTIONS(4618),
    [sym_this] = ACTIONS(4618),
    [sym_assert] = ACTIONS(4618),
    [sym_auto] = ACTIONS(4618),
    [sym_cast] = ACTIONS(4618),
    [sym_catch] = ACTIONS(4618),
    [sym_const] = ACTIONS(4618),
    [sym_delegate] = ACTIONS(4618),
    [sym_delete] = ACTIONS(4618),
    [sym_do] = ACTIONS(4618),
    [sym_else] = ACTIONS(4618),
    [sym_finally] = ACTIONS(4618),
    [sym_function] = ACTIONS(4618),
    [sym_immutable] = ACTIONS(4618),
    [sym_import] = ACTIONS(4618),
    [sym_in] = ACTIONS(4618),
    [sym_inout] = ACTIONS(4618),
    [sym_is] = ACTIONS(4618),
    [sym_mixin] = ACTIONS(4618),
    [sym_new] = ACTIONS(4618),
    [sym_out] = ACTIONS(4618),
    [sym_ref] = ACTIONS(4618),
    [sym_shared] = ACTIONS(4618),
    [sym_throw] = ACTIONS(4618),
    [sym_typeid] = ACTIONS(4618),
    [sym_typeof] = ACTIONS(4618),
    [sym_traits] = ACTIONS(4618),
    [sym_vector] = ACTIONS(4618),
    [sym_void] = ACTIONS(4618),
    [anon_sym_BQUOTE] = ACTIONS(4620),
    [anon_sym_r_DQUOTE] = ACTIONS(4620),
    [anon_sym_x_DQUOTE] = ACTIONS(4620),
    [anon_sym_DQUOTE] = ACTIONS(4620),
    [anon_sym_i_BQUOTE] = ACTIONS(4620),
    [anon_sym_i_DQUOTE] = ACTIONS(4620),
    [anon_sym_iq_LBRACE] = ACTIONS(4620),
    [aux_sym_char_literal_token1] = ACTIONS(4620),
    [anon_sym_SQUOTE] = ACTIONS(4618),
    [anon_sym___DATE__] = ACTIONS(4618),
    [anon_sym___FILE__] = ACTIONS(4618),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4618),
    [anon_sym___FUNCTION__] = ACTIONS(4618),
    [anon_sym___LINE__] = ACTIONS(4618),
    [anon_sym___MODULE__] = ACTIONS(4618),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4618),
    [anon_sym___TIME__] = ACTIONS(4618),
    [anon_sym___TIMESTAMP__] = ACTIONS(4618),
    [anon_sym___VENDOR__] = ACTIONS(4618),
    [anon_sym___VERSION__] = ACTIONS(4618),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4620),
    [sym_float_literal] = ACTIONS(4620),
    [sym__string] = ACTIONS(4620),
  },
  [1950] = {
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_q_LBRACE] = ACTIONS(4713),
    [anon_sym_LBRACE] = ACTIONS(4713),
    [anon_sym_DOT] = ACTIONS(4713),
    [anon_sym_AMP] = ACTIONS(4713),
    [anon_sym_DASH] = ACTIONS(4711),
    [anon_sym_DASH_DASH] = ACTIONS(4713),
    [anon_sym_PLUS] = ACTIONS(4711),
    [anon_sym_PLUS_PLUS] = ACTIONS(4713),
    [anon_sym_BANG] = ACTIONS(4713),
    [anon_sym_LPAREN] = ACTIONS(4713),
    [anon_sym_RPAREN] = ACTIONS(4713),
    [anon_sym_LBRACK] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_DOLLAR] = ACTIONS(4713),
    [anon_sym_STAR] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4713),
    [sym_bool] = ACTIONS(4711),
    [sym_byte] = ACTIONS(4711),
    [sym_ubyte] = ACTIONS(4711),
    [sym_char] = ACTIONS(4711),
    [sym_short] = ACTIONS(4711),
    [sym_ushort] = ACTIONS(4711),
    [sym_int] = ACTIONS(4711),
    [sym_uint] = ACTIONS(4711),
    [sym_long] = ACTIONS(4711),
    [sym_ulong] = ACTIONS(4711),
    [sym_cent] = ACTIONS(4711),
    [sym_ucent] = ACTIONS(4711),
    [sym_wchar] = ACTIONS(4711),
    [sym_dchar] = ACTIONS(4711),
    [sym_float] = ACTIONS(4711),
    [sym_double] = ACTIONS(4711),
    [sym_real] = ACTIONS(4711),
    [sym_ifloat] = ACTIONS(4711),
    [sym_idouble] = ACTIONS(4711),
    [sym_ireal] = ACTIONS(4711),
    [sym_cfloat] = ACTIONS(4711),
    [sym_cdouble] = ACTIONS(4711),
    [sym_creal] = ACTIONS(4711),
    [sym_size_t] = ACTIONS(4711),
    [sym_ptrdiff_t] = ACTIONS(4711),
    [sym_string] = ACTIONS(4711),
    [sym_cstring] = ACTIONS(4711),
    [sym_dstring] = ACTIONS(4711),
    [sym_wstring] = ACTIONS(4711),
    [sym_noreturn] = ACTIONS(4711),
    [sym_true] = ACTIONS(4711),
    [sym_false] = ACTIONS(4711),
    [sym_null] = ACTIONS(4711),
    [sym_super] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [sym_assert] = ACTIONS(4711),
    [sym_auto] = ACTIONS(4711),
    [sym_cast] = ACTIONS(4711),
    [sym_catch] = ACTIONS(4711),
    [sym_const] = ACTIONS(4711),
    [sym_delegate] = ACTIONS(4711),
    [sym_delete] = ACTIONS(4711),
    [sym_do] = ACTIONS(4711),
    [sym_else] = ACTIONS(4711),
    [sym_finally] = ACTIONS(4711),
    [sym_function] = ACTIONS(4711),
    [sym_immutable] = ACTIONS(4711),
    [sym_import] = ACTIONS(4711),
    [sym_in] = ACTIONS(4711),
    [sym_inout] = ACTIONS(4711),
    [sym_is] = ACTIONS(4711),
    [sym_mixin] = ACTIONS(4711),
    [sym_new] = ACTIONS(4711),
    [sym_out] = ACTIONS(4711),
    [sym_ref] = ACTIONS(4711),
    [sym_shared] = ACTIONS(4711),
    [sym_throw] = ACTIONS(4711),
    [sym_typeid] = ACTIONS(4711),
    [sym_typeof] = ACTIONS(4711),
    [sym_traits] = ACTIONS(4711),
    [sym_vector] = ACTIONS(4711),
    [sym_void] = ACTIONS(4711),
    [anon_sym_BQUOTE] = ACTIONS(4713),
    [anon_sym_r_DQUOTE] = ACTIONS(4713),
    [anon_sym_x_DQUOTE] = ACTIONS(4713),
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [anon_sym_i_BQUOTE] = ACTIONS(4713),
    [anon_sym_i_DQUOTE] = ACTIONS(4713),
    [anon_sym_iq_LBRACE] = ACTIONS(4713),
    [aux_sym_char_literal_token1] = ACTIONS(4713),
    [anon_sym_SQUOTE] = ACTIONS(4711),
    [anon_sym___DATE__] = ACTIONS(4711),
    [anon_sym___FILE__] = ACTIONS(4711),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4711),
    [anon_sym___FUNCTION__] = ACTIONS(4711),
    [anon_sym___LINE__] = ACTIONS(4711),
    [anon_sym___MODULE__] = ACTIONS(4711),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4711),
    [anon_sym___TIME__] = ACTIONS(4711),
    [anon_sym___TIMESTAMP__] = ACTIONS(4711),
    [anon_sym___VENDOR__] = ACTIONS(4711),
    [anon_sym___VERSION__] = ACTIONS(4711),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4713),
    [sym_float_literal] = ACTIONS(4713),
    [sym__string] = ACTIONS(4713),
  },
  [1951] = {
    [sym_identifier] = ACTIONS(4420),
    [anon_sym_q_LBRACE] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(4422),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_AMP] = ACTIONS(4422),
    [anon_sym_DASH] = ACTIONS(4420),
    [anon_sym_DASH_DASH] = ACTIONS(4422),
    [anon_sym_PLUS] = ACTIONS(4420),
    [anon_sym_PLUS_PLUS] = ACTIONS(4422),
    [anon_sym_BANG] = ACTIONS(4422),
    [anon_sym_LPAREN] = ACTIONS(4422),
    [anon_sym_RPAREN] = ACTIONS(4422),
    [anon_sym_LBRACK] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_DOLLAR] = ACTIONS(4422),
    [anon_sym_STAR] = ACTIONS(4422),
    [anon_sym_TILDE] = ACTIONS(4422),
    [sym_bool] = ACTIONS(4420),
    [sym_byte] = ACTIONS(4420),
    [sym_ubyte] = ACTIONS(4420),
    [sym_char] = ACTIONS(4420),
    [sym_short] = ACTIONS(4420),
    [sym_ushort] = ACTIONS(4420),
    [sym_int] = ACTIONS(4420),
    [sym_uint] = ACTIONS(4420),
    [sym_long] = ACTIONS(4420),
    [sym_ulong] = ACTIONS(4420),
    [sym_cent] = ACTIONS(4420),
    [sym_ucent] = ACTIONS(4420),
    [sym_wchar] = ACTIONS(4420),
    [sym_dchar] = ACTIONS(4420),
    [sym_float] = ACTIONS(4420),
    [sym_double] = ACTIONS(4420),
    [sym_real] = ACTIONS(4420),
    [sym_ifloat] = ACTIONS(4420),
    [sym_idouble] = ACTIONS(4420),
    [sym_ireal] = ACTIONS(4420),
    [sym_cfloat] = ACTIONS(4420),
    [sym_cdouble] = ACTIONS(4420),
    [sym_creal] = ACTIONS(4420),
    [sym_size_t] = ACTIONS(4420),
    [sym_ptrdiff_t] = ACTIONS(4420),
    [sym_string] = ACTIONS(4420),
    [sym_cstring] = ACTIONS(4420),
    [sym_dstring] = ACTIONS(4420),
    [sym_wstring] = ACTIONS(4420),
    [sym_noreturn] = ACTIONS(4420),
    [sym_true] = ACTIONS(4420),
    [sym_false] = ACTIONS(4420),
    [sym_null] = ACTIONS(4420),
    [sym_super] = ACTIONS(4420),
    [sym_this] = ACTIONS(4420),
    [sym_assert] = ACTIONS(4420),
    [sym_auto] = ACTIONS(4420),
    [sym_cast] = ACTIONS(4420),
    [sym_catch] = ACTIONS(4420),
    [sym_const] = ACTIONS(4420),
    [sym_delegate] = ACTIONS(4420),
    [sym_delete] = ACTIONS(4420),
    [sym_do] = ACTIONS(4420),
    [sym_else] = ACTIONS(4420),
    [sym_finally] = ACTIONS(4420),
    [sym_function] = ACTIONS(4420),
    [sym_immutable] = ACTIONS(4420),
    [sym_import] = ACTIONS(4420),
    [sym_in] = ACTIONS(4420),
    [sym_inout] = ACTIONS(4420),
    [sym_is] = ACTIONS(4420),
    [sym_mixin] = ACTIONS(4420),
    [sym_new] = ACTIONS(4420),
    [sym_out] = ACTIONS(4420),
    [sym_ref] = ACTIONS(4420),
    [sym_shared] = ACTIONS(4420),
    [sym_throw] = ACTIONS(4420),
    [sym_typeid] = ACTIONS(4420),
    [sym_typeof] = ACTIONS(4420),
    [sym_traits] = ACTIONS(4420),
    [sym_vector] = ACTIONS(4420),
    [sym_void] = ACTIONS(4420),
    [anon_sym_BQUOTE] = ACTIONS(4422),
    [anon_sym_r_DQUOTE] = ACTIONS(4422),
    [anon_sym_x_DQUOTE] = ACTIONS(4422),
    [anon_sym_DQUOTE] = ACTIONS(4422),
    [anon_sym_i_BQUOTE] = ACTIONS(4422),
    [anon_sym_i_DQUOTE] = ACTIONS(4422),
    [anon_sym_iq_LBRACE] = ACTIONS(4422),
    [aux_sym_char_literal_token1] = ACTIONS(4422),
    [anon_sym_SQUOTE] = ACTIONS(4420),
    [anon_sym___DATE__] = ACTIONS(4420),
    [anon_sym___FILE__] = ACTIONS(4420),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4420),
    [anon_sym___FUNCTION__] = ACTIONS(4420),
    [anon_sym___LINE__] = ACTIONS(4420),
    [anon_sym___MODULE__] = ACTIONS(4420),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4420),
    [anon_sym___TIME__] = ACTIONS(4420),
    [anon_sym___TIMESTAMP__] = ACTIONS(4420),
    [anon_sym___VENDOR__] = ACTIONS(4420),
    [anon_sym___VERSION__] = ACTIONS(4420),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4422),
    [sym_float_literal] = ACTIONS(4422),
    [sym__string] = ACTIONS(4422),
  },
  [1952] = {
    [sym_identifier] = ACTIONS(4412),
    [anon_sym_q_LBRACE] = ACTIONS(4414),
    [anon_sym_LBRACE] = ACTIONS(4414),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_AMP] = ACTIONS(4414),
    [anon_sym_DASH] = ACTIONS(4412),
    [anon_sym_DASH_DASH] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4412),
    [anon_sym_PLUS_PLUS] = ACTIONS(4414),
    [anon_sym_BANG] = ACTIONS(4414),
    [anon_sym_LPAREN] = ACTIONS(4414),
    [anon_sym_RPAREN] = ACTIONS(4414),
    [anon_sym_LBRACK] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_DOLLAR] = ACTIONS(4414),
    [anon_sym_STAR] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [sym_bool] = ACTIONS(4412),
    [sym_byte] = ACTIONS(4412),
    [sym_ubyte] = ACTIONS(4412),
    [sym_char] = ACTIONS(4412),
    [sym_short] = ACTIONS(4412),
    [sym_ushort] = ACTIONS(4412),
    [sym_int] = ACTIONS(4412),
    [sym_uint] = ACTIONS(4412),
    [sym_long] = ACTIONS(4412),
    [sym_ulong] = ACTIONS(4412),
    [sym_cent] = ACTIONS(4412),
    [sym_ucent] = ACTIONS(4412),
    [sym_wchar] = ACTIONS(4412),
    [sym_dchar] = ACTIONS(4412),
    [sym_float] = ACTIONS(4412),
    [sym_double] = ACTIONS(4412),
    [sym_real] = ACTIONS(4412),
    [sym_ifloat] = ACTIONS(4412),
    [sym_idouble] = ACTIONS(4412),
    [sym_ireal] = ACTIONS(4412),
    [sym_cfloat] = ACTIONS(4412),
    [sym_cdouble] = ACTIONS(4412),
    [sym_creal] = ACTIONS(4412),
    [sym_size_t] = ACTIONS(4412),
    [sym_ptrdiff_t] = ACTIONS(4412),
    [sym_string] = ACTIONS(4412),
    [sym_cstring] = ACTIONS(4412),
    [sym_dstring] = ACTIONS(4412),
    [sym_wstring] = ACTIONS(4412),
    [sym_noreturn] = ACTIONS(4412),
    [sym_true] = ACTIONS(4412),
    [sym_false] = ACTIONS(4412),
    [sym_null] = ACTIONS(4412),
    [sym_super] = ACTIONS(4412),
    [sym_this] = ACTIONS(4412),
    [sym_assert] = ACTIONS(4412),
    [sym_auto] = ACTIONS(4412),
    [sym_cast] = ACTIONS(4412),
    [sym_catch] = ACTIONS(4412),
    [sym_const] = ACTIONS(4412),
    [sym_delegate] = ACTIONS(4412),
    [sym_delete] = ACTIONS(4412),
    [sym_do] = ACTIONS(4412),
    [sym_else] = ACTIONS(4412),
    [sym_finally] = ACTIONS(4412),
    [sym_function] = ACTIONS(4412),
    [sym_immutable] = ACTIONS(4412),
    [sym_import] = ACTIONS(4412),
    [sym_in] = ACTIONS(4412),
    [sym_inout] = ACTIONS(4412),
    [sym_is] = ACTIONS(4412),
    [sym_mixin] = ACTIONS(4412),
    [sym_new] = ACTIONS(4412),
    [sym_out] = ACTIONS(4412),
    [sym_ref] = ACTIONS(4412),
    [sym_shared] = ACTIONS(4412),
    [sym_throw] = ACTIONS(4412),
    [sym_typeid] = ACTIONS(4412),
    [sym_typeof] = ACTIONS(4412),
    [sym_traits] = ACTIONS(4412),
    [sym_vector] = ACTIONS(4412),
    [sym_void] = ACTIONS(4412),
    [anon_sym_BQUOTE] = ACTIONS(4414),
    [anon_sym_r_DQUOTE] = ACTIONS(4414),
    [anon_sym_x_DQUOTE] = ACTIONS(4414),
    [anon_sym_DQUOTE] = ACTIONS(4414),
    [anon_sym_i_BQUOTE] = ACTIONS(4414),
    [anon_sym_i_DQUOTE] = ACTIONS(4414),
    [anon_sym_iq_LBRACE] = ACTIONS(4414),
    [aux_sym_char_literal_token1] = ACTIONS(4414),
    [anon_sym_SQUOTE] = ACTIONS(4412),
    [anon_sym___DATE__] = ACTIONS(4412),
    [anon_sym___FILE__] = ACTIONS(4412),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4412),
    [anon_sym___FUNCTION__] = ACTIONS(4412),
    [anon_sym___LINE__] = ACTIONS(4412),
    [anon_sym___MODULE__] = ACTIONS(4412),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4412),
    [anon_sym___TIME__] = ACTIONS(4412),
    [anon_sym___TIMESTAMP__] = ACTIONS(4412),
    [anon_sym___VENDOR__] = ACTIONS(4412),
    [anon_sym___VERSION__] = ACTIONS(4412),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4414),
    [sym_float_literal] = ACTIONS(4414),
    [sym__string] = ACTIONS(4414),
  },
  [1953] = {
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_q_LBRACE] = ACTIONS(4410),
    [anon_sym_LBRACE] = ACTIONS(4410),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_AMP] = ACTIONS(4410),
    [anon_sym_DASH] = ACTIONS(4408),
    [anon_sym_DASH_DASH] = ACTIONS(4410),
    [anon_sym_PLUS] = ACTIONS(4408),
    [anon_sym_PLUS_PLUS] = ACTIONS(4410),
    [anon_sym_BANG] = ACTIONS(4410),
    [anon_sym_LPAREN] = ACTIONS(4410),
    [anon_sym_RPAREN] = ACTIONS(4410),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_DOLLAR] = ACTIONS(4410),
    [anon_sym_STAR] = ACTIONS(4410),
    [anon_sym_TILDE] = ACTIONS(4410),
    [sym_bool] = ACTIONS(4408),
    [sym_byte] = ACTIONS(4408),
    [sym_ubyte] = ACTIONS(4408),
    [sym_char] = ACTIONS(4408),
    [sym_short] = ACTIONS(4408),
    [sym_ushort] = ACTIONS(4408),
    [sym_int] = ACTIONS(4408),
    [sym_uint] = ACTIONS(4408),
    [sym_long] = ACTIONS(4408),
    [sym_ulong] = ACTIONS(4408),
    [sym_cent] = ACTIONS(4408),
    [sym_ucent] = ACTIONS(4408),
    [sym_wchar] = ACTIONS(4408),
    [sym_dchar] = ACTIONS(4408),
    [sym_float] = ACTIONS(4408),
    [sym_double] = ACTIONS(4408),
    [sym_real] = ACTIONS(4408),
    [sym_ifloat] = ACTIONS(4408),
    [sym_idouble] = ACTIONS(4408),
    [sym_ireal] = ACTIONS(4408),
    [sym_cfloat] = ACTIONS(4408),
    [sym_cdouble] = ACTIONS(4408),
    [sym_creal] = ACTIONS(4408),
    [sym_size_t] = ACTIONS(4408),
    [sym_ptrdiff_t] = ACTIONS(4408),
    [sym_string] = ACTIONS(4408),
    [sym_cstring] = ACTIONS(4408),
    [sym_dstring] = ACTIONS(4408),
    [sym_wstring] = ACTIONS(4408),
    [sym_noreturn] = ACTIONS(4408),
    [sym_true] = ACTIONS(4408),
    [sym_false] = ACTIONS(4408),
    [sym_null] = ACTIONS(4408),
    [sym_super] = ACTIONS(4408),
    [sym_this] = ACTIONS(4408),
    [sym_assert] = ACTIONS(4408),
    [sym_auto] = ACTIONS(4408),
    [sym_cast] = ACTIONS(4408),
    [sym_catch] = ACTIONS(4408),
    [sym_const] = ACTIONS(4408),
    [sym_delegate] = ACTIONS(4408),
    [sym_delete] = ACTIONS(4408),
    [sym_do] = ACTIONS(4408),
    [sym_else] = ACTIONS(4408),
    [sym_finally] = ACTIONS(4408),
    [sym_function] = ACTIONS(4408),
    [sym_immutable] = ACTIONS(4408),
    [sym_import] = ACTIONS(4408),
    [sym_in] = ACTIONS(4408),
    [sym_inout] = ACTIONS(4408),
    [sym_is] = ACTIONS(4408),
    [sym_mixin] = ACTIONS(4408),
    [sym_new] = ACTIONS(4408),
    [sym_out] = ACTIONS(4408),
    [sym_ref] = ACTIONS(4408),
    [sym_shared] = ACTIONS(4408),
    [sym_throw] = ACTIONS(4408),
    [sym_typeid] = ACTIONS(4408),
    [sym_typeof] = ACTIONS(4408),
    [sym_traits] = ACTIONS(4408),
    [sym_vector] = ACTIONS(4408),
    [sym_void] = ACTIONS(4408),
    [anon_sym_BQUOTE] = ACTIONS(4410),
    [anon_sym_r_DQUOTE] = ACTIONS(4410),
    [anon_sym_x_DQUOTE] = ACTIONS(4410),
    [anon_sym_DQUOTE] = ACTIONS(4410),
    [anon_sym_i_BQUOTE] = ACTIONS(4410),
    [anon_sym_i_DQUOTE] = ACTIONS(4410),
    [anon_sym_iq_LBRACE] = ACTIONS(4410),
    [aux_sym_char_literal_token1] = ACTIONS(4410),
    [anon_sym_SQUOTE] = ACTIONS(4408),
    [anon_sym___DATE__] = ACTIONS(4408),
    [anon_sym___FILE__] = ACTIONS(4408),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4408),
    [anon_sym___FUNCTION__] = ACTIONS(4408),
    [anon_sym___LINE__] = ACTIONS(4408),
    [anon_sym___MODULE__] = ACTIONS(4408),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4408),
    [anon_sym___TIME__] = ACTIONS(4408),
    [anon_sym___TIMESTAMP__] = ACTIONS(4408),
    [anon_sym___VENDOR__] = ACTIONS(4408),
    [anon_sym___VERSION__] = ACTIONS(4408),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4410),
    [sym_float_literal] = ACTIONS(4410),
    [sym__string] = ACTIONS(4410),
  },
  [1954] = {
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_q_LBRACE] = ACTIONS(4406),
    [anon_sym_LBRACE] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_AMP] = ACTIONS(4406),
    [anon_sym_DASH] = ACTIONS(4404),
    [anon_sym_DASH_DASH] = ACTIONS(4406),
    [anon_sym_PLUS] = ACTIONS(4404),
    [anon_sym_PLUS_PLUS] = ACTIONS(4406),
    [anon_sym_BANG] = ACTIONS(4406),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_RPAREN] = ACTIONS(4406),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_DOLLAR] = ACTIONS(4406),
    [anon_sym_STAR] = ACTIONS(4406),
    [anon_sym_TILDE] = ACTIONS(4406),
    [sym_bool] = ACTIONS(4404),
    [sym_byte] = ACTIONS(4404),
    [sym_ubyte] = ACTIONS(4404),
    [sym_char] = ACTIONS(4404),
    [sym_short] = ACTIONS(4404),
    [sym_ushort] = ACTIONS(4404),
    [sym_int] = ACTIONS(4404),
    [sym_uint] = ACTIONS(4404),
    [sym_long] = ACTIONS(4404),
    [sym_ulong] = ACTIONS(4404),
    [sym_cent] = ACTIONS(4404),
    [sym_ucent] = ACTIONS(4404),
    [sym_wchar] = ACTIONS(4404),
    [sym_dchar] = ACTIONS(4404),
    [sym_float] = ACTIONS(4404),
    [sym_double] = ACTIONS(4404),
    [sym_real] = ACTIONS(4404),
    [sym_ifloat] = ACTIONS(4404),
    [sym_idouble] = ACTIONS(4404),
    [sym_ireal] = ACTIONS(4404),
    [sym_cfloat] = ACTIONS(4404),
    [sym_cdouble] = ACTIONS(4404),
    [sym_creal] = ACTIONS(4404),
    [sym_size_t] = ACTIONS(4404),
    [sym_ptrdiff_t] = ACTIONS(4404),
    [sym_string] = ACTIONS(4404),
    [sym_cstring] = ACTIONS(4404),
    [sym_dstring] = ACTIONS(4404),
    [sym_wstring] = ACTIONS(4404),
    [sym_noreturn] = ACTIONS(4404),
    [sym_true] = ACTIONS(4404),
    [sym_false] = ACTIONS(4404),
    [sym_null] = ACTIONS(4404),
    [sym_super] = ACTIONS(4404),
    [sym_this] = ACTIONS(4404),
    [sym_assert] = ACTIONS(4404),
    [sym_auto] = ACTIONS(4404),
    [sym_cast] = ACTIONS(4404),
    [sym_catch] = ACTIONS(4404),
    [sym_const] = ACTIONS(4404),
    [sym_delegate] = ACTIONS(4404),
    [sym_delete] = ACTIONS(4404),
    [sym_do] = ACTIONS(4404),
    [sym_else] = ACTIONS(4404),
    [sym_finally] = ACTIONS(4404),
    [sym_function] = ACTIONS(4404),
    [sym_immutable] = ACTIONS(4404),
    [sym_import] = ACTIONS(4404),
    [sym_in] = ACTIONS(4404),
    [sym_inout] = ACTIONS(4404),
    [sym_is] = ACTIONS(4404),
    [sym_mixin] = ACTIONS(4404),
    [sym_new] = ACTIONS(4404),
    [sym_out] = ACTIONS(4404),
    [sym_ref] = ACTIONS(4404),
    [sym_shared] = ACTIONS(4404),
    [sym_throw] = ACTIONS(4404),
    [sym_typeid] = ACTIONS(4404),
    [sym_typeof] = ACTIONS(4404),
    [sym_traits] = ACTIONS(4404),
    [sym_vector] = ACTIONS(4404),
    [sym_void] = ACTIONS(4404),
    [anon_sym_BQUOTE] = ACTIONS(4406),
    [anon_sym_r_DQUOTE] = ACTIONS(4406),
    [anon_sym_x_DQUOTE] = ACTIONS(4406),
    [anon_sym_DQUOTE] = ACTIONS(4406),
    [anon_sym_i_BQUOTE] = ACTIONS(4406),
    [anon_sym_i_DQUOTE] = ACTIONS(4406),
    [anon_sym_iq_LBRACE] = ACTIONS(4406),
    [aux_sym_char_literal_token1] = ACTIONS(4406),
    [anon_sym_SQUOTE] = ACTIONS(4404),
    [anon_sym___DATE__] = ACTIONS(4404),
    [anon_sym___FILE__] = ACTIONS(4404),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4404),
    [anon_sym___FUNCTION__] = ACTIONS(4404),
    [anon_sym___LINE__] = ACTIONS(4404),
    [anon_sym___MODULE__] = ACTIONS(4404),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4404),
    [anon_sym___TIME__] = ACTIONS(4404),
    [anon_sym___TIMESTAMP__] = ACTIONS(4404),
    [anon_sym___VENDOR__] = ACTIONS(4404),
    [anon_sym___VERSION__] = ACTIONS(4404),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4406),
    [sym_float_literal] = ACTIONS(4406),
    [sym__string] = ACTIONS(4406),
  },
  [1955] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_catch] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(5852),
    [sym_finally] = ACTIONS(4688),
    [sym_function] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [1956] = {
    [sym_identifier] = ACTIONS(4436),
    [anon_sym_q_LBRACE] = ACTIONS(4438),
    [anon_sym_LBRACE] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4438),
    [anon_sym_AMP] = ACTIONS(4438),
    [anon_sym_DASH] = ACTIONS(4436),
    [anon_sym_DASH_DASH] = ACTIONS(4438),
    [anon_sym_PLUS] = ACTIONS(4436),
    [anon_sym_PLUS_PLUS] = ACTIONS(4438),
    [anon_sym_BANG] = ACTIONS(4438),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_RPAREN] = ACTIONS(4438),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_DOLLAR] = ACTIONS(4438),
    [anon_sym_STAR] = ACTIONS(4438),
    [anon_sym_TILDE] = ACTIONS(4438),
    [sym_bool] = ACTIONS(4436),
    [sym_byte] = ACTIONS(4436),
    [sym_ubyte] = ACTIONS(4436),
    [sym_char] = ACTIONS(4436),
    [sym_short] = ACTIONS(4436),
    [sym_ushort] = ACTIONS(4436),
    [sym_int] = ACTIONS(4436),
    [sym_uint] = ACTIONS(4436),
    [sym_long] = ACTIONS(4436),
    [sym_ulong] = ACTIONS(4436),
    [sym_cent] = ACTIONS(4436),
    [sym_ucent] = ACTIONS(4436),
    [sym_wchar] = ACTIONS(4436),
    [sym_dchar] = ACTIONS(4436),
    [sym_float] = ACTIONS(4436),
    [sym_double] = ACTIONS(4436),
    [sym_real] = ACTIONS(4436),
    [sym_ifloat] = ACTIONS(4436),
    [sym_idouble] = ACTIONS(4436),
    [sym_ireal] = ACTIONS(4436),
    [sym_cfloat] = ACTIONS(4436),
    [sym_cdouble] = ACTIONS(4436),
    [sym_creal] = ACTIONS(4436),
    [sym_size_t] = ACTIONS(4436),
    [sym_ptrdiff_t] = ACTIONS(4436),
    [sym_string] = ACTIONS(4436),
    [sym_cstring] = ACTIONS(4436),
    [sym_dstring] = ACTIONS(4436),
    [sym_wstring] = ACTIONS(4436),
    [sym_noreturn] = ACTIONS(4436),
    [sym_true] = ACTIONS(4436),
    [sym_false] = ACTIONS(4436),
    [sym_null] = ACTIONS(4436),
    [sym_super] = ACTIONS(4436),
    [sym_this] = ACTIONS(4436),
    [sym_assert] = ACTIONS(4436),
    [sym_auto] = ACTIONS(4436),
    [sym_cast] = ACTIONS(4436),
    [sym_catch] = ACTIONS(4436),
    [sym_const] = ACTIONS(4436),
    [sym_delegate] = ACTIONS(4436),
    [sym_delete] = ACTIONS(4436),
    [sym_do] = ACTIONS(4436),
    [sym_else] = ACTIONS(4436),
    [sym_finally] = ACTIONS(4436),
    [sym_function] = ACTIONS(4436),
    [sym_immutable] = ACTIONS(4436),
    [sym_import] = ACTIONS(4436),
    [sym_in] = ACTIONS(4436),
    [sym_inout] = ACTIONS(4436),
    [sym_is] = ACTIONS(4436),
    [sym_mixin] = ACTIONS(4436),
    [sym_new] = ACTIONS(4436),
    [sym_out] = ACTIONS(4436),
    [sym_ref] = ACTIONS(4436),
    [sym_shared] = ACTIONS(4436),
    [sym_throw] = ACTIONS(4436),
    [sym_typeid] = ACTIONS(4436),
    [sym_typeof] = ACTIONS(4436),
    [sym_traits] = ACTIONS(4436),
    [sym_vector] = ACTIONS(4436),
    [sym_void] = ACTIONS(4436),
    [anon_sym_BQUOTE] = ACTIONS(4438),
    [anon_sym_r_DQUOTE] = ACTIONS(4438),
    [anon_sym_x_DQUOTE] = ACTIONS(4438),
    [anon_sym_DQUOTE] = ACTIONS(4438),
    [anon_sym_i_BQUOTE] = ACTIONS(4438),
    [anon_sym_i_DQUOTE] = ACTIONS(4438),
    [anon_sym_iq_LBRACE] = ACTIONS(4438),
    [aux_sym_char_literal_token1] = ACTIONS(4438),
    [anon_sym_SQUOTE] = ACTIONS(4436),
    [anon_sym___DATE__] = ACTIONS(4436),
    [anon_sym___FILE__] = ACTIONS(4436),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4436),
    [anon_sym___FUNCTION__] = ACTIONS(4436),
    [anon_sym___LINE__] = ACTIONS(4436),
    [anon_sym___MODULE__] = ACTIONS(4436),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4436),
    [anon_sym___TIME__] = ACTIONS(4436),
    [anon_sym___TIMESTAMP__] = ACTIONS(4436),
    [anon_sym___VENDOR__] = ACTIONS(4436),
    [anon_sym___VERSION__] = ACTIONS(4436),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4438),
    [sym_float_literal] = ACTIONS(4438),
    [sym__string] = ACTIONS(4438),
  },
  [1957] = {
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_q_LBRACE] = ACTIONS(4867),
    [anon_sym_LBRACE] = ACTIONS(4867),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_AMP] = ACTIONS(4867),
    [anon_sym_DASH] = ACTIONS(4865),
    [anon_sym_DASH_DASH] = ACTIONS(4867),
    [anon_sym_PLUS] = ACTIONS(4865),
    [anon_sym_PLUS_PLUS] = ACTIONS(4867),
    [anon_sym_BANG] = ACTIONS(4867),
    [anon_sym_LPAREN] = ACTIONS(4867),
    [anon_sym_RPAREN] = ACTIONS(4867),
    [anon_sym_LBRACK] = ACTIONS(4867),
    [anon_sym_SEMI] = ACTIONS(4867),
    [anon_sym_DOLLAR] = ACTIONS(4867),
    [anon_sym_STAR] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4865),
    [sym_byte] = ACTIONS(4865),
    [sym_ubyte] = ACTIONS(4865),
    [sym_char] = ACTIONS(4865),
    [sym_short] = ACTIONS(4865),
    [sym_ushort] = ACTIONS(4865),
    [sym_int] = ACTIONS(4865),
    [sym_uint] = ACTIONS(4865),
    [sym_long] = ACTIONS(4865),
    [sym_ulong] = ACTIONS(4865),
    [sym_cent] = ACTIONS(4865),
    [sym_ucent] = ACTIONS(4865),
    [sym_wchar] = ACTIONS(4865),
    [sym_dchar] = ACTIONS(4865),
    [sym_float] = ACTIONS(4865),
    [sym_double] = ACTIONS(4865),
    [sym_real] = ACTIONS(4865),
    [sym_ifloat] = ACTIONS(4865),
    [sym_idouble] = ACTIONS(4865),
    [sym_ireal] = ACTIONS(4865),
    [sym_cfloat] = ACTIONS(4865),
    [sym_cdouble] = ACTIONS(4865),
    [sym_creal] = ACTIONS(4865),
    [sym_size_t] = ACTIONS(4865),
    [sym_ptrdiff_t] = ACTIONS(4865),
    [sym_string] = ACTIONS(4865),
    [sym_cstring] = ACTIONS(4865),
    [sym_dstring] = ACTIONS(4865),
    [sym_wstring] = ACTIONS(4865),
    [sym_noreturn] = ACTIONS(4865),
    [sym_true] = ACTIONS(4865),
    [sym_false] = ACTIONS(4865),
    [sym_null] = ACTIONS(4865),
    [sym_super] = ACTIONS(4865),
    [sym_this] = ACTIONS(4865),
    [sym_assert] = ACTIONS(4865),
    [sym_auto] = ACTIONS(4865),
    [sym_cast] = ACTIONS(4865),
    [sym_catch] = ACTIONS(4865),
    [sym_const] = ACTIONS(4865),
    [sym_delegate] = ACTIONS(4865),
    [sym_delete] = ACTIONS(4865),
    [sym_do] = ACTIONS(4865),
    [sym_else] = ACTIONS(4865),
    [sym_finally] = ACTIONS(4865),
    [sym_function] = ACTIONS(4865),
    [sym_immutable] = ACTIONS(4865),
    [sym_import] = ACTIONS(4865),
    [sym_in] = ACTIONS(4865),
    [sym_inout] = ACTIONS(4865),
    [sym_is] = ACTIONS(4865),
    [sym_mixin] = ACTIONS(4865),
    [sym_new] = ACTIONS(4865),
    [sym_out] = ACTIONS(4865),
    [sym_ref] = ACTIONS(4865),
    [sym_shared] = ACTIONS(4865),
    [sym_throw] = ACTIONS(4865),
    [sym_typeid] = ACTIONS(4865),
    [sym_typeof] = ACTIONS(4865),
    [sym_traits] = ACTIONS(4865),
    [sym_vector] = ACTIONS(4865),
    [sym_void] = ACTIONS(4865),
    [anon_sym_BQUOTE] = ACTIONS(4867),
    [anon_sym_r_DQUOTE] = ACTIONS(4867),
    [anon_sym_x_DQUOTE] = ACTIONS(4867),
    [anon_sym_DQUOTE] = ACTIONS(4867),
    [anon_sym_i_BQUOTE] = ACTIONS(4867),
    [anon_sym_i_DQUOTE] = ACTIONS(4867),
    [anon_sym_iq_LBRACE] = ACTIONS(4867),
    [aux_sym_char_literal_token1] = ACTIONS(4867),
    [anon_sym_SQUOTE] = ACTIONS(4865),
    [anon_sym___DATE__] = ACTIONS(4865),
    [anon_sym___FILE__] = ACTIONS(4865),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4865),
    [anon_sym___FUNCTION__] = ACTIONS(4865),
    [anon_sym___LINE__] = ACTIONS(4865),
    [anon_sym___MODULE__] = ACTIONS(4865),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4865),
    [anon_sym___TIME__] = ACTIONS(4865),
    [anon_sym___TIMESTAMP__] = ACTIONS(4865),
    [anon_sym___VENDOR__] = ACTIONS(4865),
    [anon_sym___VERSION__] = ACTIONS(4865),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4867),
    [sym_float_literal] = ACTIONS(4867),
    [sym__string] = ACTIONS(4867),
  },
  [1958] = {
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_q_LBRACE] = ACTIONS(4735),
    [anon_sym_LBRACE] = ACTIONS(4735),
    [anon_sym_DOT] = ACTIONS(4735),
    [anon_sym_AMP] = ACTIONS(4735),
    [anon_sym_DASH] = ACTIONS(4733),
    [anon_sym_DASH_DASH] = ACTIONS(4735),
    [anon_sym_PLUS] = ACTIONS(4733),
    [anon_sym_PLUS_PLUS] = ACTIONS(4735),
    [anon_sym_BANG] = ACTIONS(4735),
    [anon_sym_LPAREN] = ACTIONS(4735),
    [anon_sym_RPAREN] = ACTIONS(4735),
    [anon_sym_LBRACK] = ACTIONS(4735),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_DOLLAR] = ACTIONS(4735),
    [anon_sym_STAR] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [sym_bool] = ACTIONS(4733),
    [sym_byte] = ACTIONS(4733),
    [sym_ubyte] = ACTIONS(4733),
    [sym_char] = ACTIONS(4733),
    [sym_short] = ACTIONS(4733),
    [sym_ushort] = ACTIONS(4733),
    [sym_int] = ACTIONS(4733),
    [sym_uint] = ACTIONS(4733),
    [sym_long] = ACTIONS(4733),
    [sym_ulong] = ACTIONS(4733),
    [sym_cent] = ACTIONS(4733),
    [sym_ucent] = ACTIONS(4733),
    [sym_wchar] = ACTIONS(4733),
    [sym_dchar] = ACTIONS(4733),
    [sym_float] = ACTIONS(4733),
    [sym_double] = ACTIONS(4733),
    [sym_real] = ACTIONS(4733),
    [sym_ifloat] = ACTIONS(4733),
    [sym_idouble] = ACTIONS(4733),
    [sym_ireal] = ACTIONS(4733),
    [sym_cfloat] = ACTIONS(4733),
    [sym_cdouble] = ACTIONS(4733),
    [sym_creal] = ACTIONS(4733),
    [sym_size_t] = ACTIONS(4733),
    [sym_ptrdiff_t] = ACTIONS(4733),
    [sym_string] = ACTIONS(4733),
    [sym_cstring] = ACTIONS(4733),
    [sym_dstring] = ACTIONS(4733),
    [sym_wstring] = ACTIONS(4733),
    [sym_noreturn] = ACTIONS(4733),
    [sym_true] = ACTIONS(4733),
    [sym_false] = ACTIONS(4733),
    [sym_null] = ACTIONS(4733),
    [sym_super] = ACTIONS(4733),
    [sym_this] = ACTIONS(4733),
    [sym_assert] = ACTIONS(4733),
    [sym_auto] = ACTIONS(4733),
    [sym_cast] = ACTIONS(4733),
    [sym_catch] = ACTIONS(4733),
    [sym_const] = ACTIONS(4733),
    [sym_delegate] = ACTIONS(4733),
    [sym_delete] = ACTIONS(4733),
    [sym_do] = ACTIONS(4733),
    [sym_else] = ACTIONS(4733),
    [sym_finally] = ACTIONS(4733),
    [sym_function] = ACTIONS(4733),
    [sym_immutable] = ACTIONS(4733),
    [sym_import] = ACTIONS(4733),
    [sym_in] = ACTIONS(4733),
    [sym_inout] = ACTIONS(4733),
    [sym_is] = ACTIONS(4733),
    [sym_mixin] = ACTIONS(4733),
    [sym_new] = ACTIONS(4733),
    [sym_out] = ACTIONS(4733),
    [sym_ref] = ACTIONS(4733),
    [sym_shared] = ACTIONS(4733),
    [sym_throw] = ACTIONS(4733),
    [sym_typeid] = ACTIONS(4733),
    [sym_typeof] = ACTIONS(4733),
    [sym_traits] = ACTIONS(4733),
    [sym_vector] = ACTIONS(4733),
    [sym_void] = ACTIONS(4733),
    [anon_sym_BQUOTE] = ACTIONS(4735),
    [anon_sym_r_DQUOTE] = ACTIONS(4735),
    [anon_sym_x_DQUOTE] = ACTIONS(4735),
    [anon_sym_DQUOTE] = ACTIONS(4735),
    [anon_sym_i_BQUOTE] = ACTIONS(4735),
    [anon_sym_i_DQUOTE] = ACTIONS(4735),
    [anon_sym_iq_LBRACE] = ACTIONS(4735),
    [aux_sym_char_literal_token1] = ACTIONS(4735),
    [anon_sym_SQUOTE] = ACTIONS(4733),
    [anon_sym___DATE__] = ACTIONS(4733),
    [anon_sym___FILE__] = ACTIONS(4733),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4733),
    [anon_sym___FUNCTION__] = ACTIONS(4733),
    [anon_sym___LINE__] = ACTIONS(4733),
    [anon_sym___MODULE__] = ACTIONS(4733),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4733),
    [anon_sym___TIME__] = ACTIONS(4733),
    [anon_sym___TIMESTAMP__] = ACTIONS(4733),
    [anon_sym___VENDOR__] = ACTIONS(4733),
    [anon_sym___VERSION__] = ACTIONS(4733),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4735),
    [sym_float_literal] = ACTIONS(4735),
    [sym__string] = ACTIONS(4735),
  },
  [1959] = {
    [sym_identifier] = ACTIONS(4777),
    [anon_sym_q_LBRACE] = ACTIONS(4779),
    [anon_sym_LBRACE] = ACTIONS(4779),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_AMP] = ACTIONS(4779),
    [anon_sym_DASH] = ACTIONS(4777),
    [anon_sym_DASH_DASH] = ACTIONS(4779),
    [anon_sym_PLUS] = ACTIONS(4777),
    [anon_sym_PLUS_PLUS] = ACTIONS(4779),
    [anon_sym_BANG] = ACTIONS(4779),
    [anon_sym_LPAREN] = ACTIONS(4779),
    [anon_sym_RPAREN] = ACTIONS(4779),
    [anon_sym_LBRACK] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4779),
    [anon_sym_DOLLAR] = ACTIONS(4779),
    [anon_sym_STAR] = ACTIONS(4779),
    [anon_sym_TILDE] = ACTIONS(4779),
    [sym_bool] = ACTIONS(4777),
    [sym_byte] = ACTIONS(4777),
    [sym_ubyte] = ACTIONS(4777),
    [sym_char] = ACTIONS(4777),
    [sym_short] = ACTIONS(4777),
    [sym_ushort] = ACTIONS(4777),
    [sym_int] = ACTIONS(4777),
    [sym_uint] = ACTIONS(4777),
    [sym_long] = ACTIONS(4777),
    [sym_ulong] = ACTIONS(4777),
    [sym_cent] = ACTIONS(4777),
    [sym_ucent] = ACTIONS(4777),
    [sym_wchar] = ACTIONS(4777),
    [sym_dchar] = ACTIONS(4777),
    [sym_float] = ACTIONS(4777),
    [sym_double] = ACTIONS(4777),
    [sym_real] = ACTIONS(4777),
    [sym_ifloat] = ACTIONS(4777),
    [sym_idouble] = ACTIONS(4777),
    [sym_ireal] = ACTIONS(4777),
    [sym_cfloat] = ACTIONS(4777),
    [sym_cdouble] = ACTIONS(4777),
    [sym_creal] = ACTIONS(4777),
    [sym_size_t] = ACTIONS(4777),
    [sym_ptrdiff_t] = ACTIONS(4777),
    [sym_string] = ACTIONS(4777),
    [sym_cstring] = ACTIONS(4777),
    [sym_dstring] = ACTIONS(4777),
    [sym_wstring] = ACTIONS(4777),
    [sym_noreturn] = ACTIONS(4777),
    [sym_true] = ACTIONS(4777),
    [sym_false] = ACTIONS(4777),
    [sym_null] = ACTIONS(4777),
    [sym_super] = ACTIONS(4777),
    [sym_this] = ACTIONS(4777),
    [sym_assert] = ACTIONS(4777),
    [sym_auto] = ACTIONS(4777),
    [sym_cast] = ACTIONS(4777),
    [sym_catch] = ACTIONS(4777),
    [sym_const] = ACTIONS(4777),
    [sym_delegate] = ACTIONS(4777),
    [sym_delete] = ACTIONS(4777),
    [sym_do] = ACTIONS(4777),
    [sym_else] = ACTIONS(4777),
    [sym_finally] = ACTIONS(4777),
    [sym_function] = ACTIONS(4777),
    [sym_immutable] = ACTIONS(4777),
    [sym_import] = ACTIONS(4777),
    [sym_in] = ACTIONS(4777),
    [sym_inout] = ACTIONS(4777),
    [sym_is] = ACTIONS(4777),
    [sym_mixin] = ACTIONS(4777),
    [sym_new] = ACTIONS(4777),
    [sym_out] = ACTIONS(4777),
    [sym_ref] = ACTIONS(4777),
    [sym_shared] = ACTIONS(4777),
    [sym_throw] = ACTIONS(4777),
    [sym_typeid] = ACTIONS(4777),
    [sym_typeof] = ACTIONS(4777),
    [sym_traits] = ACTIONS(4777),
    [sym_vector] = ACTIONS(4777),
    [sym_void] = ACTIONS(4777),
    [anon_sym_BQUOTE] = ACTIONS(4779),
    [anon_sym_r_DQUOTE] = ACTIONS(4779),
    [anon_sym_x_DQUOTE] = ACTIONS(4779),
    [anon_sym_DQUOTE] = ACTIONS(4779),
    [anon_sym_i_BQUOTE] = ACTIONS(4779),
    [anon_sym_i_DQUOTE] = ACTIONS(4779),
    [anon_sym_iq_LBRACE] = ACTIONS(4779),
    [aux_sym_char_literal_token1] = ACTIONS(4779),
    [anon_sym_SQUOTE] = ACTIONS(4777),
    [anon_sym___DATE__] = ACTIONS(4777),
    [anon_sym___FILE__] = ACTIONS(4777),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4777),
    [anon_sym___FUNCTION__] = ACTIONS(4777),
    [anon_sym___LINE__] = ACTIONS(4777),
    [anon_sym___MODULE__] = ACTIONS(4777),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4777),
    [anon_sym___TIME__] = ACTIONS(4777),
    [anon_sym___TIMESTAMP__] = ACTIONS(4777),
    [anon_sym___VENDOR__] = ACTIONS(4777),
    [anon_sym___VERSION__] = ACTIONS(4777),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4779),
    [sym_float_literal] = ACTIONS(4779),
    [sym__string] = ACTIONS(4779),
  },
  [1960] = {
    [sym_identifier] = ACTIONS(4376),
    [anon_sym_q_LBRACE] = ACTIONS(4378),
    [anon_sym_LBRACE] = ACTIONS(4378),
    [anon_sym_DOT] = ACTIONS(4378),
    [anon_sym_AMP] = ACTIONS(4378),
    [anon_sym_DASH] = ACTIONS(4376),
    [anon_sym_DASH_DASH] = ACTIONS(4378),
    [anon_sym_PLUS] = ACTIONS(4376),
    [anon_sym_PLUS_PLUS] = ACTIONS(4378),
    [anon_sym_BANG] = ACTIONS(4378),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_RPAREN] = ACTIONS(4378),
    [anon_sym_LBRACK] = ACTIONS(4378),
    [anon_sym_SEMI] = ACTIONS(4378),
    [anon_sym_DOLLAR] = ACTIONS(4378),
    [anon_sym_STAR] = ACTIONS(4378),
    [anon_sym_TILDE] = ACTIONS(4378),
    [sym_bool] = ACTIONS(4376),
    [sym_byte] = ACTIONS(4376),
    [sym_ubyte] = ACTIONS(4376),
    [sym_char] = ACTIONS(4376),
    [sym_short] = ACTIONS(4376),
    [sym_ushort] = ACTIONS(4376),
    [sym_int] = ACTIONS(4376),
    [sym_uint] = ACTIONS(4376),
    [sym_long] = ACTIONS(4376),
    [sym_ulong] = ACTIONS(4376),
    [sym_cent] = ACTIONS(4376),
    [sym_ucent] = ACTIONS(4376),
    [sym_wchar] = ACTIONS(4376),
    [sym_dchar] = ACTIONS(4376),
    [sym_float] = ACTIONS(4376),
    [sym_double] = ACTIONS(4376),
    [sym_real] = ACTIONS(4376),
    [sym_ifloat] = ACTIONS(4376),
    [sym_idouble] = ACTIONS(4376),
    [sym_ireal] = ACTIONS(4376),
    [sym_cfloat] = ACTIONS(4376),
    [sym_cdouble] = ACTIONS(4376),
    [sym_creal] = ACTIONS(4376),
    [sym_size_t] = ACTIONS(4376),
    [sym_ptrdiff_t] = ACTIONS(4376),
    [sym_string] = ACTIONS(4376),
    [sym_cstring] = ACTIONS(4376),
    [sym_dstring] = ACTIONS(4376),
    [sym_wstring] = ACTIONS(4376),
    [sym_noreturn] = ACTIONS(4376),
    [sym_true] = ACTIONS(4376),
    [sym_false] = ACTIONS(4376),
    [sym_null] = ACTIONS(4376),
    [sym_super] = ACTIONS(4376),
    [sym_this] = ACTIONS(4376),
    [sym_assert] = ACTIONS(4376),
    [sym_auto] = ACTIONS(4376),
    [sym_cast] = ACTIONS(4376),
    [sym_catch] = ACTIONS(4376),
    [sym_const] = ACTIONS(4376),
    [sym_delegate] = ACTIONS(4376),
    [sym_delete] = ACTIONS(4376),
    [sym_do] = ACTIONS(4376),
    [sym_else] = ACTIONS(4376),
    [sym_finally] = ACTIONS(4376),
    [sym_function] = ACTIONS(4376),
    [sym_immutable] = ACTIONS(4376),
    [sym_import] = ACTIONS(4376),
    [sym_in] = ACTIONS(4376),
    [sym_inout] = ACTIONS(4376),
    [sym_is] = ACTIONS(4376),
    [sym_mixin] = ACTIONS(4376),
    [sym_new] = ACTIONS(4376),
    [sym_out] = ACTIONS(4376),
    [sym_ref] = ACTIONS(4376),
    [sym_shared] = ACTIONS(4376),
    [sym_throw] = ACTIONS(4376),
    [sym_typeid] = ACTIONS(4376),
    [sym_typeof] = ACTIONS(4376),
    [sym_traits] = ACTIONS(4376),
    [sym_vector] = ACTIONS(4376),
    [sym_void] = ACTIONS(4376),
    [anon_sym_BQUOTE] = ACTIONS(4378),
    [anon_sym_r_DQUOTE] = ACTIONS(4378),
    [anon_sym_x_DQUOTE] = ACTIONS(4378),
    [anon_sym_DQUOTE] = ACTIONS(4378),
    [anon_sym_i_BQUOTE] = ACTIONS(4378),
    [anon_sym_i_DQUOTE] = ACTIONS(4378),
    [anon_sym_iq_LBRACE] = ACTIONS(4378),
    [aux_sym_char_literal_token1] = ACTIONS(4378),
    [anon_sym_SQUOTE] = ACTIONS(4376),
    [anon_sym___DATE__] = ACTIONS(4376),
    [anon_sym___FILE__] = ACTIONS(4376),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4376),
    [anon_sym___FUNCTION__] = ACTIONS(4376),
    [anon_sym___LINE__] = ACTIONS(4376),
    [anon_sym___MODULE__] = ACTIONS(4376),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4376),
    [anon_sym___TIME__] = ACTIONS(4376),
    [anon_sym___TIMESTAMP__] = ACTIONS(4376),
    [anon_sym___VENDOR__] = ACTIONS(4376),
    [anon_sym___VERSION__] = ACTIONS(4376),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4378),
    [sym_float_literal] = ACTIONS(4378),
    [sym__string] = ACTIONS(4378),
  },
  [1961] = {
    [sym_identifier] = ACTIONS(4825),
    [anon_sym_q_LBRACE] = ACTIONS(4828),
    [anon_sym_LBRACE] = ACTIONS(4828),
    [anon_sym_DOT] = ACTIONS(4828),
    [anon_sym_AMP] = ACTIONS(4828),
    [anon_sym_DASH] = ACTIONS(4825),
    [anon_sym_DASH_DASH] = ACTIONS(4828),
    [anon_sym_PLUS] = ACTIONS(4825),
    [anon_sym_PLUS_PLUS] = ACTIONS(4828),
    [anon_sym_BANG] = ACTIONS(4828),
    [anon_sym_LPAREN] = ACTIONS(4828),
    [anon_sym_RPAREN] = ACTIONS(4828),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_SEMI] = ACTIONS(4828),
    [anon_sym_DOLLAR] = ACTIONS(4828),
    [anon_sym_STAR] = ACTIONS(4828),
    [anon_sym_TILDE] = ACTIONS(4828),
    [sym_bool] = ACTIONS(4825),
    [sym_byte] = ACTIONS(4825),
    [sym_ubyte] = ACTIONS(4825),
    [sym_char] = ACTIONS(4825),
    [sym_short] = ACTIONS(4825),
    [sym_ushort] = ACTIONS(4825),
    [sym_int] = ACTIONS(4825),
    [sym_uint] = ACTIONS(4825),
    [sym_long] = ACTIONS(4825),
    [sym_ulong] = ACTIONS(4825),
    [sym_cent] = ACTIONS(4825),
    [sym_ucent] = ACTIONS(4825),
    [sym_wchar] = ACTIONS(4825),
    [sym_dchar] = ACTIONS(4825),
    [sym_float] = ACTIONS(4825),
    [sym_double] = ACTIONS(4825),
    [sym_real] = ACTIONS(4825),
    [sym_ifloat] = ACTIONS(4825),
    [sym_idouble] = ACTIONS(4825),
    [sym_ireal] = ACTIONS(4825),
    [sym_cfloat] = ACTIONS(4825),
    [sym_cdouble] = ACTIONS(4825),
    [sym_creal] = ACTIONS(4825),
    [sym_size_t] = ACTIONS(4825),
    [sym_ptrdiff_t] = ACTIONS(4825),
    [sym_string] = ACTIONS(4825),
    [sym_cstring] = ACTIONS(4825),
    [sym_dstring] = ACTIONS(4825),
    [sym_wstring] = ACTIONS(4825),
    [sym_noreturn] = ACTIONS(4825),
    [sym_true] = ACTIONS(4825),
    [sym_false] = ACTIONS(4825),
    [sym_null] = ACTIONS(4825),
    [sym_super] = ACTIONS(4825),
    [sym_this] = ACTIONS(4825),
    [sym_assert] = ACTIONS(4825),
    [sym_auto] = ACTIONS(4825),
    [sym_cast] = ACTIONS(4825),
    [sym_catch] = ACTIONS(4825),
    [sym_const] = ACTIONS(4825),
    [sym_delegate] = ACTIONS(4825),
    [sym_delete] = ACTIONS(4825),
    [sym_do] = ACTIONS(4825),
    [sym_else] = ACTIONS(4825),
    [sym_finally] = ACTIONS(4825),
    [sym_function] = ACTIONS(4825),
    [sym_immutable] = ACTIONS(4825),
    [sym_import] = ACTIONS(4825),
    [sym_in] = ACTIONS(4825),
    [sym_inout] = ACTIONS(4825),
    [sym_is] = ACTIONS(4825),
    [sym_mixin] = ACTIONS(4825),
    [sym_new] = ACTIONS(4825),
    [sym_out] = ACTIONS(4825),
    [sym_ref] = ACTIONS(4825),
    [sym_shared] = ACTIONS(4825),
    [sym_throw] = ACTIONS(4825),
    [sym_typeid] = ACTIONS(4825),
    [sym_typeof] = ACTIONS(4825),
    [sym_traits] = ACTIONS(4825),
    [sym_vector] = ACTIONS(4825),
    [sym_void] = ACTIONS(4825),
    [anon_sym_BQUOTE] = ACTIONS(4828),
    [anon_sym_r_DQUOTE] = ACTIONS(4828),
    [anon_sym_x_DQUOTE] = ACTIONS(4828),
    [anon_sym_DQUOTE] = ACTIONS(4828),
    [anon_sym_i_BQUOTE] = ACTIONS(4828),
    [anon_sym_i_DQUOTE] = ACTIONS(4828),
    [anon_sym_iq_LBRACE] = ACTIONS(4828),
    [aux_sym_char_literal_token1] = ACTIONS(4828),
    [anon_sym_SQUOTE] = ACTIONS(4825),
    [anon_sym___DATE__] = ACTIONS(4825),
    [anon_sym___FILE__] = ACTIONS(4825),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4825),
    [anon_sym___FUNCTION__] = ACTIONS(4825),
    [anon_sym___LINE__] = ACTIONS(4825),
    [anon_sym___MODULE__] = ACTIONS(4825),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4825),
    [anon_sym___TIME__] = ACTIONS(4825),
    [anon_sym___TIMESTAMP__] = ACTIONS(4825),
    [anon_sym___VENDOR__] = ACTIONS(4825),
    [anon_sym___VERSION__] = ACTIONS(4825),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4828),
    [sym_float_literal] = ACTIONS(4828),
    [sym__string] = ACTIONS(4828),
  },
  [1962] = {
    [sym_identifier] = ACTIONS(4392),
    [anon_sym_q_LBRACE] = ACTIONS(4394),
    [anon_sym_LBRACE] = ACTIONS(4394),
    [anon_sym_DOT] = ACTIONS(4394),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_DASH] = ACTIONS(4392),
    [anon_sym_DASH_DASH] = ACTIONS(4394),
    [anon_sym_PLUS] = ACTIONS(4392),
    [anon_sym_PLUS_PLUS] = ACTIONS(4394),
    [anon_sym_BANG] = ACTIONS(4394),
    [anon_sym_LPAREN] = ACTIONS(4394),
    [anon_sym_RPAREN] = ACTIONS(4394),
    [anon_sym_LBRACK] = ACTIONS(4394),
    [anon_sym_SEMI] = ACTIONS(4394),
    [anon_sym_DOLLAR] = ACTIONS(4394),
    [anon_sym_STAR] = ACTIONS(4394),
    [anon_sym_TILDE] = ACTIONS(4394),
    [sym_bool] = ACTIONS(4392),
    [sym_byte] = ACTIONS(4392),
    [sym_ubyte] = ACTIONS(4392),
    [sym_char] = ACTIONS(4392),
    [sym_short] = ACTIONS(4392),
    [sym_ushort] = ACTIONS(4392),
    [sym_int] = ACTIONS(4392),
    [sym_uint] = ACTIONS(4392),
    [sym_long] = ACTIONS(4392),
    [sym_ulong] = ACTIONS(4392),
    [sym_cent] = ACTIONS(4392),
    [sym_ucent] = ACTIONS(4392),
    [sym_wchar] = ACTIONS(4392),
    [sym_dchar] = ACTIONS(4392),
    [sym_float] = ACTIONS(4392),
    [sym_double] = ACTIONS(4392),
    [sym_real] = ACTIONS(4392),
    [sym_ifloat] = ACTIONS(4392),
    [sym_idouble] = ACTIONS(4392),
    [sym_ireal] = ACTIONS(4392),
    [sym_cfloat] = ACTIONS(4392),
    [sym_cdouble] = ACTIONS(4392),
    [sym_creal] = ACTIONS(4392),
    [sym_size_t] = ACTIONS(4392),
    [sym_ptrdiff_t] = ACTIONS(4392),
    [sym_string] = ACTIONS(4392),
    [sym_cstring] = ACTIONS(4392),
    [sym_dstring] = ACTIONS(4392),
    [sym_wstring] = ACTIONS(4392),
    [sym_noreturn] = ACTIONS(4392),
    [sym_true] = ACTIONS(4392),
    [sym_false] = ACTIONS(4392),
    [sym_null] = ACTIONS(4392),
    [sym_super] = ACTIONS(4392),
    [sym_this] = ACTIONS(4392),
    [sym_assert] = ACTIONS(4392),
    [sym_auto] = ACTIONS(4392),
    [sym_cast] = ACTIONS(4392),
    [sym_catch] = ACTIONS(4392),
    [sym_const] = ACTIONS(4392),
    [sym_delegate] = ACTIONS(4392),
    [sym_delete] = ACTIONS(4392),
    [sym_do] = ACTIONS(4392),
    [sym_else] = ACTIONS(4392),
    [sym_finally] = ACTIONS(4392),
    [sym_function] = ACTIONS(4392),
    [sym_immutable] = ACTIONS(4392),
    [sym_import] = ACTIONS(4392),
    [sym_in] = ACTIONS(4392),
    [sym_inout] = ACTIONS(4392),
    [sym_is] = ACTIONS(4392),
    [sym_mixin] = ACTIONS(4392),
    [sym_new] = ACTIONS(4392),
    [sym_out] = ACTIONS(4392),
    [sym_ref] = ACTIONS(4392),
    [sym_shared] = ACTIONS(4392),
    [sym_throw] = ACTIONS(4392),
    [sym_typeid] = ACTIONS(4392),
    [sym_typeof] = ACTIONS(4392),
    [sym_traits] = ACTIONS(4392),
    [sym_vector] = ACTIONS(4392),
    [sym_void] = ACTIONS(4392),
    [anon_sym_BQUOTE] = ACTIONS(4394),
    [anon_sym_r_DQUOTE] = ACTIONS(4394),
    [anon_sym_x_DQUOTE] = ACTIONS(4394),
    [anon_sym_DQUOTE] = ACTIONS(4394),
    [anon_sym_i_BQUOTE] = ACTIONS(4394),
    [anon_sym_i_DQUOTE] = ACTIONS(4394),
    [anon_sym_iq_LBRACE] = ACTIONS(4394),
    [aux_sym_char_literal_token1] = ACTIONS(4394),
    [anon_sym_SQUOTE] = ACTIONS(4392),
    [anon_sym___DATE__] = ACTIONS(4392),
    [anon_sym___FILE__] = ACTIONS(4392),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4392),
    [anon_sym___FUNCTION__] = ACTIONS(4392),
    [anon_sym___LINE__] = ACTIONS(4392),
    [anon_sym___MODULE__] = ACTIONS(4392),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4392),
    [anon_sym___TIME__] = ACTIONS(4392),
    [anon_sym___TIMESTAMP__] = ACTIONS(4392),
    [anon_sym___VENDOR__] = ACTIONS(4392),
    [anon_sym___VERSION__] = ACTIONS(4392),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4394),
    [sym_float_literal] = ACTIONS(4394),
    [sym__string] = ACTIONS(4394),
  },
  [1963] = {
    [sym_identifier] = ACTIONS(4971),
    [anon_sym_q_LBRACE] = ACTIONS(4973),
    [anon_sym_LBRACE] = ACTIONS(4973),
    [anon_sym_DOT] = ACTIONS(4973),
    [anon_sym_AMP] = ACTIONS(4973),
    [anon_sym_DASH] = ACTIONS(4971),
    [anon_sym_DASH_DASH] = ACTIONS(4973),
    [anon_sym_PLUS] = ACTIONS(4971),
    [anon_sym_PLUS_PLUS] = ACTIONS(4973),
    [anon_sym_BANG] = ACTIONS(4973),
    [anon_sym_LPAREN] = ACTIONS(4973),
    [anon_sym_RPAREN] = ACTIONS(4973),
    [anon_sym_LBRACK] = ACTIONS(4973),
    [anon_sym_SEMI] = ACTIONS(4973),
    [anon_sym_DOLLAR] = ACTIONS(4973),
    [anon_sym_STAR] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4971),
    [sym_byte] = ACTIONS(4971),
    [sym_ubyte] = ACTIONS(4971),
    [sym_char] = ACTIONS(4971),
    [sym_short] = ACTIONS(4971),
    [sym_ushort] = ACTIONS(4971),
    [sym_int] = ACTIONS(4971),
    [sym_uint] = ACTIONS(4971),
    [sym_long] = ACTIONS(4971),
    [sym_ulong] = ACTIONS(4971),
    [sym_cent] = ACTIONS(4971),
    [sym_ucent] = ACTIONS(4971),
    [sym_wchar] = ACTIONS(4971),
    [sym_dchar] = ACTIONS(4971),
    [sym_float] = ACTIONS(4971),
    [sym_double] = ACTIONS(4971),
    [sym_real] = ACTIONS(4971),
    [sym_ifloat] = ACTIONS(4971),
    [sym_idouble] = ACTIONS(4971),
    [sym_ireal] = ACTIONS(4971),
    [sym_cfloat] = ACTIONS(4971),
    [sym_cdouble] = ACTIONS(4971),
    [sym_creal] = ACTIONS(4971),
    [sym_size_t] = ACTIONS(4971),
    [sym_ptrdiff_t] = ACTIONS(4971),
    [sym_string] = ACTIONS(4971),
    [sym_cstring] = ACTIONS(4971),
    [sym_dstring] = ACTIONS(4971),
    [sym_wstring] = ACTIONS(4971),
    [sym_noreturn] = ACTIONS(4971),
    [sym_true] = ACTIONS(4971),
    [sym_false] = ACTIONS(4971),
    [sym_null] = ACTIONS(4971),
    [sym_super] = ACTIONS(4971),
    [sym_this] = ACTIONS(4971),
    [sym_assert] = ACTIONS(4971),
    [sym_auto] = ACTIONS(4971),
    [sym_cast] = ACTIONS(4971),
    [sym_catch] = ACTIONS(4971),
    [sym_const] = ACTIONS(4971),
    [sym_delegate] = ACTIONS(4971),
    [sym_delete] = ACTIONS(4971),
    [sym_do] = ACTIONS(4971),
    [sym_else] = ACTIONS(4971),
    [sym_finally] = ACTIONS(4971),
    [sym_function] = ACTIONS(4971),
    [sym_immutable] = ACTIONS(4971),
    [sym_import] = ACTIONS(4971),
    [sym_in] = ACTIONS(4971),
    [sym_inout] = ACTIONS(4971),
    [sym_is] = ACTIONS(4971),
    [sym_mixin] = ACTIONS(4971),
    [sym_new] = ACTIONS(4971),
    [sym_out] = ACTIONS(4971),
    [sym_ref] = ACTIONS(4971),
    [sym_shared] = ACTIONS(4971),
    [sym_throw] = ACTIONS(4971),
    [sym_typeid] = ACTIONS(4971),
    [sym_typeof] = ACTIONS(4971),
    [sym_traits] = ACTIONS(4971),
    [sym_vector] = ACTIONS(4971),
    [sym_void] = ACTIONS(4971),
    [anon_sym_BQUOTE] = ACTIONS(4973),
    [anon_sym_r_DQUOTE] = ACTIONS(4973),
    [anon_sym_x_DQUOTE] = ACTIONS(4973),
    [anon_sym_DQUOTE] = ACTIONS(4973),
    [anon_sym_i_BQUOTE] = ACTIONS(4973),
    [anon_sym_i_DQUOTE] = ACTIONS(4973),
    [anon_sym_iq_LBRACE] = ACTIONS(4973),
    [aux_sym_char_literal_token1] = ACTIONS(4973),
    [anon_sym_SQUOTE] = ACTIONS(4971),
    [anon_sym___DATE__] = ACTIONS(4971),
    [anon_sym___FILE__] = ACTIONS(4971),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4971),
    [anon_sym___FUNCTION__] = ACTIONS(4971),
    [anon_sym___LINE__] = ACTIONS(4971),
    [anon_sym___MODULE__] = ACTIONS(4971),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4971),
    [anon_sym___TIME__] = ACTIONS(4971),
    [anon_sym___TIMESTAMP__] = ACTIONS(4971),
    [anon_sym___VENDOR__] = ACTIONS(4971),
    [anon_sym___VERSION__] = ACTIONS(4971),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4973),
    [sym_float_literal] = ACTIONS(4973),
    [sym__string] = ACTIONS(4973),
  },
  [1964] = {
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_q_LBRACE] = ACTIONS(4861),
    [anon_sym_LBRACE] = ACTIONS(4861),
    [anon_sym_DOT] = ACTIONS(4861),
    [anon_sym_AMP] = ACTIONS(4861),
    [anon_sym_DASH] = ACTIONS(4859),
    [anon_sym_DASH_DASH] = ACTIONS(4861),
    [anon_sym_PLUS] = ACTIONS(4859),
    [anon_sym_PLUS_PLUS] = ACTIONS(4861),
    [anon_sym_BANG] = ACTIONS(4861),
    [anon_sym_LPAREN] = ACTIONS(4861),
    [anon_sym_RPAREN] = ACTIONS(4861),
    [anon_sym_LBRACK] = ACTIONS(4861),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_DOLLAR] = ACTIONS(4861),
    [anon_sym_STAR] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [sym_bool] = ACTIONS(4859),
    [sym_byte] = ACTIONS(4859),
    [sym_ubyte] = ACTIONS(4859),
    [sym_char] = ACTIONS(4859),
    [sym_short] = ACTIONS(4859),
    [sym_ushort] = ACTIONS(4859),
    [sym_int] = ACTIONS(4859),
    [sym_uint] = ACTIONS(4859),
    [sym_long] = ACTIONS(4859),
    [sym_ulong] = ACTIONS(4859),
    [sym_cent] = ACTIONS(4859),
    [sym_ucent] = ACTIONS(4859),
    [sym_wchar] = ACTIONS(4859),
    [sym_dchar] = ACTIONS(4859),
    [sym_float] = ACTIONS(4859),
    [sym_double] = ACTIONS(4859),
    [sym_real] = ACTIONS(4859),
    [sym_ifloat] = ACTIONS(4859),
    [sym_idouble] = ACTIONS(4859),
    [sym_ireal] = ACTIONS(4859),
    [sym_cfloat] = ACTIONS(4859),
    [sym_cdouble] = ACTIONS(4859),
    [sym_creal] = ACTIONS(4859),
    [sym_size_t] = ACTIONS(4859),
    [sym_ptrdiff_t] = ACTIONS(4859),
    [sym_string] = ACTIONS(4859),
    [sym_cstring] = ACTIONS(4859),
    [sym_dstring] = ACTIONS(4859),
    [sym_wstring] = ACTIONS(4859),
    [sym_noreturn] = ACTIONS(4859),
    [sym_true] = ACTIONS(4859),
    [sym_false] = ACTIONS(4859),
    [sym_null] = ACTIONS(4859),
    [sym_super] = ACTIONS(4859),
    [sym_this] = ACTIONS(4859),
    [sym_assert] = ACTIONS(4859),
    [sym_auto] = ACTIONS(4859),
    [sym_cast] = ACTIONS(4859),
    [sym_catch] = ACTIONS(4859),
    [sym_const] = ACTIONS(4859),
    [sym_delegate] = ACTIONS(4859),
    [sym_delete] = ACTIONS(4859),
    [sym_do] = ACTIONS(4859),
    [sym_else] = ACTIONS(4859),
    [sym_finally] = ACTIONS(4859),
    [sym_function] = ACTIONS(4859),
    [sym_immutable] = ACTIONS(4859),
    [sym_import] = ACTIONS(4859),
    [sym_in] = ACTIONS(4859),
    [sym_inout] = ACTIONS(4859),
    [sym_is] = ACTIONS(4859),
    [sym_mixin] = ACTIONS(4859),
    [sym_new] = ACTIONS(4859),
    [sym_out] = ACTIONS(4859),
    [sym_ref] = ACTIONS(4859),
    [sym_shared] = ACTIONS(4859),
    [sym_throw] = ACTIONS(4859),
    [sym_typeid] = ACTIONS(4859),
    [sym_typeof] = ACTIONS(4859),
    [sym_traits] = ACTIONS(4859),
    [sym_vector] = ACTIONS(4859),
    [sym_void] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4861),
    [anon_sym_r_DQUOTE] = ACTIONS(4861),
    [anon_sym_x_DQUOTE] = ACTIONS(4861),
    [anon_sym_DQUOTE] = ACTIONS(4861),
    [anon_sym_i_BQUOTE] = ACTIONS(4861),
    [anon_sym_i_DQUOTE] = ACTIONS(4861),
    [anon_sym_iq_LBRACE] = ACTIONS(4861),
    [aux_sym_char_literal_token1] = ACTIONS(4861),
    [anon_sym_SQUOTE] = ACTIONS(4859),
    [anon_sym___DATE__] = ACTIONS(4859),
    [anon_sym___FILE__] = ACTIONS(4859),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4859),
    [anon_sym___FUNCTION__] = ACTIONS(4859),
    [anon_sym___LINE__] = ACTIONS(4859),
    [anon_sym___MODULE__] = ACTIONS(4859),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4859),
    [anon_sym___TIME__] = ACTIONS(4859),
    [anon_sym___TIMESTAMP__] = ACTIONS(4859),
    [anon_sym___VENDOR__] = ACTIONS(4859),
    [anon_sym___VERSION__] = ACTIONS(4859),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4861),
    [sym_float_literal] = ACTIONS(4861),
    [sym__string] = ACTIONS(4861),
  },
  [1965] = {
    [sym_identifier] = ACTIONS(4326),
    [anon_sym_q_LBRACE] = ACTIONS(4328),
    [anon_sym_LBRACE] = ACTIONS(4328),
    [anon_sym_DOT] = ACTIONS(4328),
    [anon_sym_AMP] = ACTIONS(4328),
    [anon_sym_DASH] = ACTIONS(4326),
    [anon_sym_DASH_DASH] = ACTIONS(4328),
    [anon_sym_PLUS] = ACTIONS(4326),
    [anon_sym_PLUS_PLUS] = ACTIONS(4328),
    [anon_sym_BANG] = ACTIONS(4328),
    [anon_sym_LPAREN] = ACTIONS(4328),
    [anon_sym_RPAREN] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(4328),
    [anon_sym_SEMI] = ACTIONS(4328),
    [anon_sym_DOLLAR] = ACTIONS(4328),
    [anon_sym_STAR] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4328),
    [sym_bool] = ACTIONS(4326),
    [sym_byte] = ACTIONS(4326),
    [sym_ubyte] = ACTIONS(4326),
    [sym_char] = ACTIONS(4326),
    [sym_short] = ACTIONS(4326),
    [sym_ushort] = ACTIONS(4326),
    [sym_int] = ACTIONS(4326),
    [sym_uint] = ACTIONS(4326),
    [sym_long] = ACTIONS(4326),
    [sym_ulong] = ACTIONS(4326),
    [sym_cent] = ACTIONS(4326),
    [sym_ucent] = ACTIONS(4326),
    [sym_wchar] = ACTIONS(4326),
    [sym_dchar] = ACTIONS(4326),
    [sym_float] = ACTIONS(4326),
    [sym_double] = ACTIONS(4326),
    [sym_real] = ACTIONS(4326),
    [sym_ifloat] = ACTIONS(4326),
    [sym_idouble] = ACTIONS(4326),
    [sym_ireal] = ACTIONS(4326),
    [sym_cfloat] = ACTIONS(4326),
    [sym_cdouble] = ACTIONS(4326),
    [sym_creal] = ACTIONS(4326),
    [sym_size_t] = ACTIONS(4326),
    [sym_ptrdiff_t] = ACTIONS(4326),
    [sym_string] = ACTIONS(4326),
    [sym_cstring] = ACTIONS(4326),
    [sym_dstring] = ACTIONS(4326),
    [sym_wstring] = ACTIONS(4326),
    [sym_noreturn] = ACTIONS(4326),
    [sym_true] = ACTIONS(4326),
    [sym_false] = ACTIONS(4326),
    [sym_null] = ACTIONS(4326),
    [sym_super] = ACTIONS(4326),
    [sym_this] = ACTIONS(4326),
    [sym_assert] = ACTIONS(4326),
    [sym_auto] = ACTIONS(4326),
    [sym_cast] = ACTIONS(4326),
    [sym_catch] = ACTIONS(4326),
    [sym_const] = ACTIONS(4326),
    [sym_delegate] = ACTIONS(4326),
    [sym_delete] = ACTIONS(4326),
    [sym_do] = ACTIONS(4326),
    [sym_else] = ACTIONS(4326),
    [sym_finally] = ACTIONS(4326),
    [sym_function] = ACTIONS(4326),
    [sym_immutable] = ACTIONS(4326),
    [sym_import] = ACTIONS(4326),
    [sym_in] = ACTIONS(4326),
    [sym_inout] = ACTIONS(4326),
    [sym_is] = ACTIONS(4326),
    [sym_mixin] = ACTIONS(4326),
    [sym_new] = ACTIONS(4326),
    [sym_out] = ACTIONS(4326),
    [sym_ref] = ACTIONS(4326),
    [sym_shared] = ACTIONS(4326),
    [sym_throw] = ACTIONS(4326),
    [sym_typeid] = ACTIONS(4326),
    [sym_typeof] = ACTIONS(4326),
    [sym_traits] = ACTIONS(4326),
    [sym_vector] = ACTIONS(4326),
    [sym_void] = ACTIONS(4326),
    [anon_sym_BQUOTE] = ACTIONS(4328),
    [anon_sym_r_DQUOTE] = ACTIONS(4328),
    [anon_sym_x_DQUOTE] = ACTIONS(4328),
    [anon_sym_DQUOTE] = ACTIONS(4328),
    [anon_sym_i_BQUOTE] = ACTIONS(4328),
    [anon_sym_i_DQUOTE] = ACTIONS(4328),
    [anon_sym_iq_LBRACE] = ACTIONS(4328),
    [aux_sym_char_literal_token1] = ACTIONS(4328),
    [anon_sym_SQUOTE] = ACTIONS(4326),
    [anon_sym___DATE__] = ACTIONS(4326),
    [anon_sym___FILE__] = ACTIONS(4326),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4326),
    [anon_sym___FUNCTION__] = ACTIONS(4326),
    [anon_sym___LINE__] = ACTIONS(4326),
    [anon_sym___MODULE__] = ACTIONS(4326),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4326),
    [anon_sym___TIME__] = ACTIONS(4326),
    [anon_sym___TIMESTAMP__] = ACTIONS(4326),
    [anon_sym___VENDOR__] = ACTIONS(4326),
    [anon_sym___VERSION__] = ACTIONS(4326),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4328),
    [sym_float_literal] = ACTIONS(4328),
    [sym__string] = ACTIONS(4328),
  },
  [1966] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_q_LBRACE] = ACTIONS(4857),
    [anon_sym_LBRACE] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4857),
    [anon_sym_AMP] = ACTIONS(4857),
    [anon_sym_DASH] = ACTIONS(4855),
    [anon_sym_DASH_DASH] = ACTIONS(4857),
    [anon_sym_PLUS] = ACTIONS(4855),
    [anon_sym_PLUS_PLUS] = ACTIONS(4857),
    [anon_sym_BANG] = ACTIONS(4857),
    [anon_sym_LPAREN] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [anon_sym_LBRACK] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym_DOLLAR] = ACTIONS(4857),
    [anon_sym_STAR] = ACTIONS(4857),
    [anon_sym_TILDE] = ACTIONS(4857),
    [sym_bool] = ACTIONS(4855),
    [sym_byte] = ACTIONS(4855),
    [sym_ubyte] = ACTIONS(4855),
    [sym_char] = ACTIONS(4855),
    [sym_short] = ACTIONS(4855),
    [sym_ushort] = ACTIONS(4855),
    [sym_int] = ACTIONS(4855),
    [sym_uint] = ACTIONS(4855),
    [sym_long] = ACTIONS(4855),
    [sym_ulong] = ACTIONS(4855),
    [sym_cent] = ACTIONS(4855),
    [sym_ucent] = ACTIONS(4855),
    [sym_wchar] = ACTIONS(4855),
    [sym_dchar] = ACTIONS(4855),
    [sym_float] = ACTIONS(4855),
    [sym_double] = ACTIONS(4855),
    [sym_real] = ACTIONS(4855),
    [sym_ifloat] = ACTIONS(4855),
    [sym_idouble] = ACTIONS(4855),
    [sym_ireal] = ACTIONS(4855),
    [sym_cfloat] = ACTIONS(4855),
    [sym_cdouble] = ACTIONS(4855),
    [sym_creal] = ACTIONS(4855),
    [sym_size_t] = ACTIONS(4855),
    [sym_ptrdiff_t] = ACTIONS(4855),
    [sym_string] = ACTIONS(4855),
    [sym_cstring] = ACTIONS(4855),
    [sym_dstring] = ACTIONS(4855),
    [sym_wstring] = ACTIONS(4855),
    [sym_noreturn] = ACTIONS(4855),
    [sym_true] = ACTIONS(4855),
    [sym_false] = ACTIONS(4855),
    [sym_null] = ACTIONS(4855),
    [sym_super] = ACTIONS(4855),
    [sym_this] = ACTIONS(4855),
    [sym_assert] = ACTIONS(4855),
    [sym_auto] = ACTIONS(4855),
    [sym_cast] = ACTIONS(4855),
    [sym_catch] = ACTIONS(4855),
    [sym_const] = ACTIONS(4855),
    [sym_delegate] = ACTIONS(4855),
    [sym_delete] = ACTIONS(4855),
    [sym_do] = ACTIONS(4855),
    [sym_else] = ACTIONS(4855),
    [sym_finally] = ACTIONS(4855),
    [sym_function] = ACTIONS(4855),
    [sym_immutable] = ACTIONS(4855),
    [sym_import] = ACTIONS(4855),
    [sym_in] = ACTIONS(4855),
    [sym_inout] = ACTIONS(4855),
    [sym_is] = ACTIONS(4855),
    [sym_mixin] = ACTIONS(4855),
    [sym_new] = ACTIONS(4855),
    [sym_out] = ACTIONS(4855),
    [sym_ref] = ACTIONS(4855),
    [sym_shared] = ACTIONS(4855),
    [sym_throw] = ACTIONS(4855),
    [sym_typeid] = ACTIONS(4855),
    [sym_typeof] = ACTIONS(4855),
    [sym_traits] = ACTIONS(4855),
    [sym_vector] = ACTIONS(4855),
    [sym_void] = ACTIONS(4855),
    [anon_sym_BQUOTE] = ACTIONS(4857),
    [anon_sym_r_DQUOTE] = ACTIONS(4857),
    [anon_sym_x_DQUOTE] = ACTIONS(4857),
    [anon_sym_DQUOTE] = ACTIONS(4857),
    [anon_sym_i_BQUOTE] = ACTIONS(4857),
    [anon_sym_i_DQUOTE] = ACTIONS(4857),
    [anon_sym_iq_LBRACE] = ACTIONS(4857),
    [aux_sym_char_literal_token1] = ACTIONS(4857),
    [anon_sym_SQUOTE] = ACTIONS(4855),
    [anon_sym___DATE__] = ACTIONS(4855),
    [anon_sym___FILE__] = ACTIONS(4855),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4855),
    [anon_sym___FUNCTION__] = ACTIONS(4855),
    [anon_sym___LINE__] = ACTIONS(4855),
    [anon_sym___MODULE__] = ACTIONS(4855),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4855),
    [anon_sym___TIME__] = ACTIONS(4855),
    [anon_sym___TIMESTAMP__] = ACTIONS(4855),
    [anon_sym___VENDOR__] = ACTIONS(4855),
    [anon_sym___VERSION__] = ACTIONS(4855),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4857),
    [sym_float_literal] = ACTIONS(4857),
    [sym__string] = ACTIONS(4857),
  },
  [1967] = {
    [sym_identifier] = ACTIONS(4781),
    [anon_sym_q_LBRACE] = ACTIONS(4783),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_AMP] = ACTIONS(4783),
    [anon_sym_DASH] = ACTIONS(4781),
    [anon_sym_DASH_DASH] = ACTIONS(4783),
    [anon_sym_PLUS] = ACTIONS(4781),
    [anon_sym_PLUS_PLUS] = ACTIONS(4783),
    [anon_sym_BANG] = ACTIONS(4783),
    [anon_sym_LPAREN] = ACTIONS(4783),
    [anon_sym_RPAREN] = ACTIONS(4783),
    [anon_sym_LBRACK] = ACTIONS(4783),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_DOLLAR] = ACTIONS(4783),
    [anon_sym_STAR] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4783),
    [sym_bool] = ACTIONS(4781),
    [sym_byte] = ACTIONS(4781),
    [sym_ubyte] = ACTIONS(4781),
    [sym_char] = ACTIONS(4781),
    [sym_short] = ACTIONS(4781),
    [sym_ushort] = ACTIONS(4781),
    [sym_int] = ACTIONS(4781),
    [sym_uint] = ACTIONS(4781),
    [sym_long] = ACTIONS(4781),
    [sym_ulong] = ACTIONS(4781),
    [sym_cent] = ACTIONS(4781),
    [sym_ucent] = ACTIONS(4781),
    [sym_wchar] = ACTIONS(4781),
    [sym_dchar] = ACTIONS(4781),
    [sym_float] = ACTIONS(4781),
    [sym_double] = ACTIONS(4781),
    [sym_real] = ACTIONS(4781),
    [sym_ifloat] = ACTIONS(4781),
    [sym_idouble] = ACTIONS(4781),
    [sym_ireal] = ACTIONS(4781),
    [sym_cfloat] = ACTIONS(4781),
    [sym_cdouble] = ACTIONS(4781),
    [sym_creal] = ACTIONS(4781),
    [sym_size_t] = ACTIONS(4781),
    [sym_ptrdiff_t] = ACTIONS(4781),
    [sym_string] = ACTIONS(4781),
    [sym_cstring] = ACTIONS(4781),
    [sym_dstring] = ACTIONS(4781),
    [sym_wstring] = ACTIONS(4781),
    [sym_noreturn] = ACTIONS(4781),
    [sym_true] = ACTIONS(4781),
    [sym_false] = ACTIONS(4781),
    [sym_null] = ACTIONS(4781),
    [sym_super] = ACTIONS(4781),
    [sym_this] = ACTIONS(4781),
    [sym_assert] = ACTIONS(4781),
    [sym_auto] = ACTIONS(4781),
    [sym_cast] = ACTIONS(4781),
    [sym_catch] = ACTIONS(4781),
    [sym_const] = ACTIONS(4781),
    [sym_delegate] = ACTIONS(4781),
    [sym_delete] = ACTIONS(4781),
    [sym_do] = ACTIONS(4781),
    [sym_else] = ACTIONS(4781),
    [sym_finally] = ACTIONS(4781),
    [sym_function] = ACTIONS(4781),
    [sym_immutable] = ACTIONS(4781),
    [sym_import] = ACTIONS(4781),
    [sym_in] = ACTIONS(4781),
    [sym_inout] = ACTIONS(4781),
    [sym_is] = ACTIONS(4781),
    [sym_mixin] = ACTIONS(4781),
    [sym_new] = ACTIONS(4781),
    [sym_out] = ACTIONS(4781),
    [sym_ref] = ACTIONS(4781),
    [sym_shared] = ACTIONS(4781),
    [sym_throw] = ACTIONS(4781),
    [sym_typeid] = ACTIONS(4781),
    [sym_typeof] = ACTIONS(4781),
    [sym_traits] = ACTIONS(4781),
    [sym_vector] = ACTIONS(4781),
    [sym_void] = ACTIONS(4781),
    [anon_sym_BQUOTE] = ACTIONS(4783),
    [anon_sym_r_DQUOTE] = ACTIONS(4783),
    [anon_sym_x_DQUOTE] = ACTIONS(4783),
    [anon_sym_DQUOTE] = ACTIONS(4783),
    [anon_sym_i_BQUOTE] = ACTIONS(4783),
    [anon_sym_i_DQUOTE] = ACTIONS(4783),
    [anon_sym_iq_LBRACE] = ACTIONS(4783),
    [aux_sym_char_literal_token1] = ACTIONS(4783),
    [anon_sym_SQUOTE] = ACTIONS(4781),
    [anon_sym___DATE__] = ACTIONS(4781),
    [anon_sym___FILE__] = ACTIONS(4781),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4781),
    [anon_sym___FUNCTION__] = ACTIONS(4781),
    [anon_sym___LINE__] = ACTIONS(4781),
    [anon_sym___MODULE__] = ACTIONS(4781),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4781),
    [anon_sym___TIME__] = ACTIONS(4781),
    [anon_sym___TIMESTAMP__] = ACTIONS(4781),
    [anon_sym___VENDOR__] = ACTIONS(4781),
    [anon_sym___VERSION__] = ACTIONS(4781),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4783),
    [sym_float_literal] = ACTIONS(4783),
    [sym__string] = ACTIONS(4783),
  },
  [1968] = {
    [sym_identifier] = ACTIONS(4424),
    [anon_sym_q_LBRACE] = ACTIONS(4426),
    [anon_sym_LBRACE] = ACTIONS(4426),
    [anon_sym_DOT] = ACTIONS(4426),
    [anon_sym_AMP] = ACTIONS(4426),
    [anon_sym_DASH] = ACTIONS(4424),
    [anon_sym_DASH_DASH] = ACTIONS(4426),
    [anon_sym_PLUS] = ACTIONS(4424),
    [anon_sym_PLUS_PLUS] = ACTIONS(4426),
    [anon_sym_BANG] = ACTIONS(4426),
    [anon_sym_LPAREN] = ACTIONS(4426),
    [anon_sym_RPAREN] = ACTIONS(4426),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_SEMI] = ACTIONS(4426),
    [anon_sym_DOLLAR] = ACTIONS(4426),
    [anon_sym_STAR] = ACTIONS(4426),
    [anon_sym_TILDE] = ACTIONS(4426),
    [sym_bool] = ACTIONS(4424),
    [sym_byte] = ACTIONS(4424),
    [sym_ubyte] = ACTIONS(4424),
    [sym_char] = ACTIONS(4424),
    [sym_short] = ACTIONS(4424),
    [sym_ushort] = ACTIONS(4424),
    [sym_int] = ACTIONS(4424),
    [sym_uint] = ACTIONS(4424),
    [sym_long] = ACTIONS(4424),
    [sym_ulong] = ACTIONS(4424),
    [sym_cent] = ACTIONS(4424),
    [sym_ucent] = ACTIONS(4424),
    [sym_wchar] = ACTIONS(4424),
    [sym_dchar] = ACTIONS(4424),
    [sym_float] = ACTIONS(4424),
    [sym_double] = ACTIONS(4424),
    [sym_real] = ACTIONS(4424),
    [sym_ifloat] = ACTIONS(4424),
    [sym_idouble] = ACTIONS(4424),
    [sym_ireal] = ACTIONS(4424),
    [sym_cfloat] = ACTIONS(4424),
    [sym_cdouble] = ACTIONS(4424),
    [sym_creal] = ACTIONS(4424),
    [sym_size_t] = ACTIONS(4424),
    [sym_ptrdiff_t] = ACTIONS(4424),
    [sym_string] = ACTIONS(4424),
    [sym_cstring] = ACTIONS(4424),
    [sym_dstring] = ACTIONS(4424),
    [sym_wstring] = ACTIONS(4424),
    [sym_noreturn] = ACTIONS(4424),
    [sym_true] = ACTIONS(4424),
    [sym_false] = ACTIONS(4424),
    [sym_null] = ACTIONS(4424),
    [sym_super] = ACTIONS(4424),
    [sym_this] = ACTIONS(4424),
    [sym_assert] = ACTIONS(4424),
    [sym_auto] = ACTIONS(4424),
    [sym_cast] = ACTIONS(4424),
    [sym_catch] = ACTIONS(4424),
    [sym_const] = ACTIONS(4424),
    [sym_delegate] = ACTIONS(4424),
    [sym_delete] = ACTIONS(4424),
    [sym_do] = ACTIONS(4424),
    [sym_else] = ACTIONS(4424),
    [sym_finally] = ACTIONS(4424),
    [sym_function] = ACTIONS(4424),
    [sym_immutable] = ACTIONS(4424),
    [sym_import] = ACTIONS(4424),
    [sym_in] = ACTIONS(4424),
    [sym_inout] = ACTIONS(4424),
    [sym_is] = ACTIONS(4424),
    [sym_mixin] = ACTIONS(4424),
    [sym_new] = ACTIONS(4424),
    [sym_out] = ACTIONS(4424),
    [sym_ref] = ACTIONS(4424),
    [sym_shared] = ACTIONS(4424),
    [sym_throw] = ACTIONS(4424),
    [sym_typeid] = ACTIONS(4424),
    [sym_typeof] = ACTIONS(4424),
    [sym_traits] = ACTIONS(4424),
    [sym_vector] = ACTIONS(4424),
    [sym_void] = ACTIONS(4424),
    [anon_sym_BQUOTE] = ACTIONS(4426),
    [anon_sym_r_DQUOTE] = ACTIONS(4426),
    [anon_sym_x_DQUOTE] = ACTIONS(4426),
    [anon_sym_DQUOTE] = ACTIONS(4426),
    [anon_sym_i_BQUOTE] = ACTIONS(4426),
    [anon_sym_i_DQUOTE] = ACTIONS(4426),
    [anon_sym_iq_LBRACE] = ACTIONS(4426),
    [aux_sym_char_literal_token1] = ACTIONS(4426),
    [anon_sym_SQUOTE] = ACTIONS(4424),
    [anon_sym___DATE__] = ACTIONS(4424),
    [anon_sym___FILE__] = ACTIONS(4424),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4424),
    [anon_sym___FUNCTION__] = ACTIONS(4424),
    [anon_sym___LINE__] = ACTIONS(4424),
    [anon_sym___MODULE__] = ACTIONS(4424),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4424),
    [anon_sym___TIME__] = ACTIONS(4424),
    [anon_sym___TIMESTAMP__] = ACTIONS(4424),
    [anon_sym___VENDOR__] = ACTIONS(4424),
    [anon_sym___VERSION__] = ACTIONS(4424),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4426),
    [sym_float_literal] = ACTIONS(4426),
    [sym__string] = ACTIONS(4426),
  },
  [1969] = {
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_q_LBRACE] = ACTIONS(4877),
    [anon_sym_LBRACE] = ACTIONS(4877),
    [anon_sym_DOT] = ACTIONS(4877),
    [anon_sym_AMP] = ACTIONS(4877),
    [anon_sym_DASH] = ACTIONS(4875),
    [anon_sym_DASH_DASH] = ACTIONS(4877),
    [anon_sym_PLUS] = ACTIONS(4875),
    [anon_sym_PLUS_PLUS] = ACTIONS(4877),
    [anon_sym_BANG] = ACTIONS(4877),
    [anon_sym_LPAREN] = ACTIONS(4877),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [anon_sym_LBRACK] = ACTIONS(4877),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_DOLLAR] = ACTIONS(4877),
    [anon_sym_STAR] = ACTIONS(4877),
    [anon_sym_TILDE] = ACTIONS(4877),
    [sym_bool] = ACTIONS(4875),
    [sym_byte] = ACTIONS(4875),
    [sym_ubyte] = ACTIONS(4875),
    [sym_char] = ACTIONS(4875),
    [sym_short] = ACTIONS(4875),
    [sym_ushort] = ACTIONS(4875),
    [sym_int] = ACTIONS(4875),
    [sym_uint] = ACTIONS(4875),
    [sym_long] = ACTIONS(4875),
    [sym_ulong] = ACTIONS(4875),
    [sym_cent] = ACTIONS(4875),
    [sym_ucent] = ACTIONS(4875),
    [sym_wchar] = ACTIONS(4875),
    [sym_dchar] = ACTIONS(4875),
    [sym_float] = ACTIONS(4875),
    [sym_double] = ACTIONS(4875),
    [sym_real] = ACTIONS(4875),
    [sym_ifloat] = ACTIONS(4875),
    [sym_idouble] = ACTIONS(4875),
    [sym_ireal] = ACTIONS(4875),
    [sym_cfloat] = ACTIONS(4875),
    [sym_cdouble] = ACTIONS(4875),
    [sym_creal] = ACTIONS(4875),
    [sym_size_t] = ACTIONS(4875),
    [sym_ptrdiff_t] = ACTIONS(4875),
    [sym_string] = ACTIONS(4875),
    [sym_cstring] = ACTIONS(4875),
    [sym_dstring] = ACTIONS(4875),
    [sym_wstring] = ACTIONS(4875),
    [sym_noreturn] = ACTIONS(4875),
    [sym_true] = ACTIONS(4875),
    [sym_false] = ACTIONS(4875),
    [sym_null] = ACTIONS(4875),
    [sym_super] = ACTIONS(4875),
    [sym_this] = ACTIONS(4875),
    [sym_assert] = ACTIONS(4875),
    [sym_auto] = ACTIONS(4875),
    [sym_cast] = ACTIONS(4875),
    [sym_catch] = ACTIONS(4875),
    [sym_const] = ACTIONS(4875),
    [sym_delegate] = ACTIONS(4875),
    [sym_delete] = ACTIONS(4875),
    [sym_do] = ACTIONS(4875),
    [sym_else] = ACTIONS(4875),
    [sym_finally] = ACTIONS(4875),
    [sym_function] = ACTIONS(4875),
    [sym_immutable] = ACTIONS(4875),
    [sym_import] = ACTIONS(4875),
    [sym_in] = ACTIONS(4875),
    [sym_inout] = ACTIONS(4875),
    [sym_is] = ACTIONS(4875),
    [sym_mixin] = ACTIONS(4875),
    [sym_new] = ACTIONS(4875),
    [sym_out] = ACTIONS(4875),
    [sym_ref] = ACTIONS(4875),
    [sym_shared] = ACTIONS(4875),
    [sym_throw] = ACTIONS(4875),
    [sym_typeid] = ACTIONS(4875),
    [sym_typeof] = ACTIONS(4875),
    [sym_traits] = ACTIONS(4875),
    [sym_vector] = ACTIONS(4875),
    [sym_void] = ACTIONS(4875),
    [anon_sym_BQUOTE] = ACTIONS(4877),
    [anon_sym_r_DQUOTE] = ACTIONS(4877),
    [anon_sym_x_DQUOTE] = ACTIONS(4877),
    [anon_sym_DQUOTE] = ACTIONS(4877),
    [anon_sym_i_BQUOTE] = ACTIONS(4877),
    [anon_sym_i_DQUOTE] = ACTIONS(4877),
    [anon_sym_iq_LBRACE] = ACTIONS(4877),
    [aux_sym_char_literal_token1] = ACTIONS(4877),
    [anon_sym_SQUOTE] = ACTIONS(4875),
    [anon_sym___DATE__] = ACTIONS(4875),
    [anon_sym___FILE__] = ACTIONS(4875),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4875),
    [anon_sym___FUNCTION__] = ACTIONS(4875),
    [anon_sym___LINE__] = ACTIONS(4875),
    [anon_sym___MODULE__] = ACTIONS(4875),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4875),
    [anon_sym___TIME__] = ACTIONS(4875),
    [anon_sym___TIMESTAMP__] = ACTIONS(4875),
    [anon_sym___VENDOR__] = ACTIONS(4875),
    [anon_sym___VERSION__] = ACTIONS(4875),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4877),
    [sym_float_literal] = ACTIONS(4877),
    [sym__string] = ACTIONS(4877),
  },
  [1970] = {
    [sym_identifier] = ACTIONS(4843),
    [anon_sym_q_LBRACE] = ACTIONS(4845),
    [anon_sym_LBRACE] = ACTIONS(4845),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_AMP] = ACTIONS(4845),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_DASH_DASH] = ACTIONS(4845),
    [anon_sym_PLUS] = ACTIONS(4843),
    [anon_sym_PLUS_PLUS] = ACTIONS(4845),
    [anon_sym_BANG] = ACTIONS(4845),
    [anon_sym_LPAREN] = ACTIONS(4845),
    [anon_sym_RPAREN] = ACTIONS(4845),
    [anon_sym_LBRACK] = ACTIONS(4845),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym_DOLLAR] = ACTIONS(4845),
    [anon_sym_STAR] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4845),
    [sym_bool] = ACTIONS(4843),
    [sym_byte] = ACTIONS(4843),
    [sym_ubyte] = ACTIONS(4843),
    [sym_char] = ACTIONS(4843),
    [sym_short] = ACTIONS(4843),
    [sym_ushort] = ACTIONS(4843),
    [sym_int] = ACTIONS(4843),
    [sym_uint] = ACTIONS(4843),
    [sym_long] = ACTIONS(4843),
    [sym_ulong] = ACTIONS(4843),
    [sym_cent] = ACTIONS(4843),
    [sym_ucent] = ACTIONS(4843),
    [sym_wchar] = ACTIONS(4843),
    [sym_dchar] = ACTIONS(4843),
    [sym_float] = ACTIONS(4843),
    [sym_double] = ACTIONS(4843),
    [sym_real] = ACTIONS(4843),
    [sym_ifloat] = ACTIONS(4843),
    [sym_idouble] = ACTIONS(4843),
    [sym_ireal] = ACTIONS(4843),
    [sym_cfloat] = ACTIONS(4843),
    [sym_cdouble] = ACTIONS(4843),
    [sym_creal] = ACTIONS(4843),
    [sym_size_t] = ACTIONS(4843),
    [sym_ptrdiff_t] = ACTIONS(4843),
    [sym_string] = ACTIONS(4843),
    [sym_cstring] = ACTIONS(4843),
    [sym_dstring] = ACTIONS(4843),
    [sym_wstring] = ACTIONS(4843),
    [sym_noreturn] = ACTIONS(4843),
    [sym_true] = ACTIONS(4843),
    [sym_false] = ACTIONS(4843),
    [sym_null] = ACTIONS(4843),
    [sym_super] = ACTIONS(4843),
    [sym_this] = ACTIONS(4843),
    [sym_assert] = ACTIONS(4843),
    [sym_auto] = ACTIONS(4843),
    [sym_cast] = ACTIONS(4843),
    [sym_catch] = ACTIONS(4843),
    [sym_const] = ACTIONS(4843),
    [sym_delegate] = ACTIONS(4843),
    [sym_delete] = ACTIONS(4843),
    [sym_do] = ACTIONS(4843),
    [sym_else] = ACTIONS(4843),
    [sym_finally] = ACTIONS(4843),
    [sym_function] = ACTIONS(4843),
    [sym_immutable] = ACTIONS(4843),
    [sym_import] = ACTIONS(4843),
    [sym_in] = ACTIONS(4843),
    [sym_inout] = ACTIONS(4843),
    [sym_is] = ACTIONS(4843),
    [sym_mixin] = ACTIONS(4843),
    [sym_new] = ACTIONS(4843),
    [sym_out] = ACTIONS(4843),
    [sym_ref] = ACTIONS(4843),
    [sym_shared] = ACTIONS(4843),
    [sym_throw] = ACTIONS(4843),
    [sym_typeid] = ACTIONS(4843),
    [sym_typeof] = ACTIONS(4843),
    [sym_traits] = ACTIONS(4843),
    [sym_vector] = ACTIONS(4843),
    [sym_void] = ACTIONS(4843),
    [anon_sym_BQUOTE] = ACTIONS(4845),
    [anon_sym_r_DQUOTE] = ACTIONS(4845),
    [anon_sym_x_DQUOTE] = ACTIONS(4845),
    [anon_sym_DQUOTE] = ACTIONS(4845),
    [anon_sym_i_BQUOTE] = ACTIONS(4845),
    [anon_sym_i_DQUOTE] = ACTIONS(4845),
    [anon_sym_iq_LBRACE] = ACTIONS(4845),
    [aux_sym_char_literal_token1] = ACTIONS(4845),
    [anon_sym_SQUOTE] = ACTIONS(4843),
    [anon_sym___DATE__] = ACTIONS(4843),
    [anon_sym___FILE__] = ACTIONS(4843),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4843),
    [anon_sym___FUNCTION__] = ACTIONS(4843),
    [anon_sym___LINE__] = ACTIONS(4843),
    [anon_sym___MODULE__] = ACTIONS(4843),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4843),
    [anon_sym___TIME__] = ACTIONS(4843),
    [anon_sym___TIMESTAMP__] = ACTIONS(4843),
    [anon_sym___VENDOR__] = ACTIONS(4843),
    [anon_sym___VERSION__] = ACTIONS(4843),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4845),
    [sym_float_literal] = ACTIONS(4845),
    [sym__string] = ACTIONS(4845),
  },
  [1971] = {
    [sym_identifier] = ACTIONS(4440),
    [anon_sym_q_LBRACE] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(4442),
    [anon_sym_DOT] = ACTIONS(4442),
    [anon_sym_AMP] = ACTIONS(4442),
    [anon_sym_DASH] = ACTIONS(4440),
    [anon_sym_DASH_DASH] = ACTIONS(4442),
    [anon_sym_PLUS] = ACTIONS(4440),
    [anon_sym_PLUS_PLUS] = ACTIONS(4442),
    [anon_sym_BANG] = ACTIONS(4442),
    [anon_sym_LPAREN] = ACTIONS(4442),
    [anon_sym_RPAREN] = ACTIONS(4442),
    [anon_sym_LBRACK] = ACTIONS(4442),
    [anon_sym_SEMI] = ACTIONS(4442),
    [anon_sym_DOLLAR] = ACTIONS(4442),
    [anon_sym_STAR] = ACTIONS(4442),
    [anon_sym_TILDE] = ACTIONS(4442),
    [sym_bool] = ACTIONS(4440),
    [sym_byte] = ACTIONS(4440),
    [sym_ubyte] = ACTIONS(4440),
    [sym_char] = ACTIONS(4440),
    [sym_short] = ACTIONS(4440),
    [sym_ushort] = ACTIONS(4440),
    [sym_int] = ACTIONS(4440),
    [sym_uint] = ACTIONS(4440),
    [sym_long] = ACTIONS(4440),
    [sym_ulong] = ACTIONS(4440),
    [sym_cent] = ACTIONS(4440),
    [sym_ucent] = ACTIONS(4440),
    [sym_wchar] = ACTIONS(4440),
    [sym_dchar] = ACTIONS(4440),
    [sym_float] = ACTIONS(4440),
    [sym_double] = ACTIONS(4440),
    [sym_real] = ACTIONS(4440),
    [sym_ifloat] = ACTIONS(4440),
    [sym_idouble] = ACTIONS(4440),
    [sym_ireal] = ACTIONS(4440),
    [sym_cfloat] = ACTIONS(4440),
    [sym_cdouble] = ACTIONS(4440),
    [sym_creal] = ACTIONS(4440),
    [sym_size_t] = ACTIONS(4440),
    [sym_ptrdiff_t] = ACTIONS(4440),
    [sym_string] = ACTIONS(4440),
    [sym_cstring] = ACTIONS(4440),
    [sym_dstring] = ACTIONS(4440),
    [sym_wstring] = ACTIONS(4440),
    [sym_noreturn] = ACTIONS(4440),
    [sym_true] = ACTIONS(4440),
    [sym_false] = ACTIONS(4440),
    [sym_null] = ACTIONS(4440),
    [sym_super] = ACTIONS(4440),
    [sym_this] = ACTIONS(4440),
    [sym_assert] = ACTIONS(4440),
    [sym_auto] = ACTIONS(4440),
    [sym_cast] = ACTIONS(4440),
    [sym_catch] = ACTIONS(4440),
    [sym_const] = ACTIONS(4440),
    [sym_delegate] = ACTIONS(4440),
    [sym_delete] = ACTIONS(4440),
    [sym_do] = ACTIONS(4440),
    [sym_else] = ACTIONS(4440),
    [sym_finally] = ACTIONS(4440),
    [sym_function] = ACTIONS(4440),
    [sym_immutable] = ACTIONS(4440),
    [sym_import] = ACTIONS(4440),
    [sym_in] = ACTIONS(4440),
    [sym_inout] = ACTIONS(4440),
    [sym_is] = ACTIONS(4440),
    [sym_mixin] = ACTIONS(4440),
    [sym_new] = ACTIONS(4440),
    [sym_out] = ACTIONS(4440),
    [sym_ref] = ACTIONS(4440),
    [sym_shared] = ACTIONS(4440),
    [sym_throw] = ACTIONS(4440),
    [sym_typeid] = ACTIONS(4440),
    [sym_typeof] = ACTIONS(4440),
    [sym_traits] = ACTIONS(4440),
    [sym_vector] = ACTIONS(4440),
    [sym_void] = ACTIONS(4440),
    [anon_sym_BQUOTE] = ACTIONS(4442),
    [anon_sym_r_DQUOTE] = ACTIONS(4442),
    [anon_sym_x_DQUOTE] = ACTIONS(4442),
    [anon_sym_DQUOTE] = ACTIONS(4442),
    [anon_sym_i_BQUOTE] = ACTIONS(4442),
    [anon_sym_i_DQUOTE] = ACTIONS(4442),
    [anon_sym_iq_LBRACE] = ACTIONS(4442),
    [aux_sym_char_literal_token1] = ACTIONS(4442),
    [anon_sym_SQUOTE] = ACTIONS(4440),
    [anon_sym___DATE__] = ACTIONS(4440),
    [anon_sym___FILE__] = ACTIONS(4440),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4440),
    [anon_sym___FUNCTION__] = ACTIONS(4440),
    [anon_sym___LINE__] = ACTIONS(4440),
    [anon_sym___MODULE__] = ACTIONS(4440),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4440),
    [anon_sym___TIME__] = ACTIONS(4440),
    [anon_sym___TIMESTAMP__] = ACTIONS(4440),
    [anon_sym___VENDOR__] = ACTIONS(4440),
    [anon_sym___VERSION__] = ACTIONS(4440),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4442),
    [sym_float_literal] = ACTIONS(4442),
    [sym__string] = ACTIONS(4442),
  },
  [1972] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_q_LBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_AMP] = ACTIONS(3178),
    [anon_sym_DASH] = ACTIONS(3176),
    [anon_sym_DASH_DASH] = ACTIONS(3178),
    [anon_sym_PLUS] = ACTIONS(3176),
    [anon_sym_PLUS_PLUS] = ACTIONS(3178),
    [anon_sym_BANG] = ACTIONS(3178),
    [anon_sym_LPAREN] = ACTIONS(3178),
    [anon_sym_RPAREN] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_DOLLAR] = ACTIONS(3178),
    [anon_sym_STAR] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_true] = ACTIONS(3176),
    [sym_false] = ACTIONS(3176),
    [sym_null] = ACTIONS(3176),
    [sym_super] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_assert] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_cast] = ACTIONS(3176),
    [sym_catch] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_delegate] = ACTIONS(3176),
    [sym_delete] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_finally] = ACTIONS(3176),
    [sym_function] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_is] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_new] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_throw] = ACTIONS(3176),
    [sym_typeid] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [anon_sym_BQUOTE] = ACTIONS(3178),
    [anon_sym_r_DQUOTE] = ACTIONS(3178),
    [anon_sym_x_DQUOTE] = ACTIONS(3178),
    [anon_sym_DQUOTE] = ACTIONS(3178),
    [anon_sym_i_BQUOTE] = ACTIONS(3178),
    [anon_sym_i_DQUOTE] = ACTIONS(3178),
    [anon_sym_iq_LBRACE] = ACTIONS(3178),
    [aux_sym_char_literal_token1] = ACTIONS(3178),
    [anon_sym_SQUOTE] = ACTIONS(3176),
    [anon_sym___DATE__] = ACTIONS(3176),
    [anon_sym___FILE__] = ACTIONS(3176),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3176),
    [anon_sym___FUNCTION__] = ACTIONS(3176),
    [anon_sym___LINE__] = ACTIONS(3176),
    [anon_sym___MODULE__] = ACTIONS(3176),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3176),
    [anon_sym___TIME__] = ACTIONS(3176),
    [anon_sym___TIMESTAMP__] = ACTIONS(3176),
    [anon_sym___VENDOR__] = ACTIONS(3176),
    [anon_sym___VERSION__] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3178),
    [sym_float_literal] = ACTIONS(3178),
    [sym__string] = ACTIONS(3178),
  },
  [1973] = {
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_q_LBRACE] = ACTIONS(4841),
    [anon_sym_LBRACE] = ACTIONS(4841),
    [anon_sym_DOT] = ACTIONS(4841),
    [anon_sym_AMP] = ACTIONS(4841),
    [anon_sym_DASH] = ACTIONS(4839),
    [anon_sym_DASH_DASH] = ACTIONS(4841),
    [anon_sym_PLUS] = ACTIONS(4839),
    [anon_sym_PLUS_PLUS] = ACTIONS(4841),
    [anon_sym_BANG] = ACTIONS(4841),
    [anon_sym_LPAREN] = ACTIONS(4841),
    [anon_sym_RPAREN] = ACTIONS(4841),
    [anon_sym_LBRACK] = ACTIONS(4841),
    [anon_sym_SEMI] = ACTIONS(4841),
    [anon_sym_DOLLAR] = ACTIONS(4841),
    [anon_sym_STAR] = ACTIONS(4841),
    [anon_sym_TILDE] = ACTIONS(4841),
    [sym_bool] = ACTIONS(4839),
    [sym_byte] = ACTIONS(4839),
    [sym_ubyte] = ACTIONS(4839),
    [sym_char] = ACTIONS(4839),
    [sym_short] = ACTIONS(4839),
    [sym_ushort] = ACTIONS(4839),
    [sym_int] = ACTIONS(4839),
    [sym_uint] = ACTIONS(4839),
    [sym_long] = ACTIONS(4839),
    [sym_ulong] = ACTIONS(4839),
    [sym_cent] = ACTIONS(4839),
    [sym_ucent] = ACTIONS(4839),
    [sym_wchar] = ACTIONS(4839),
    [sym_dchar] = ACTIONS(4839),
    [sym_float] = ACTIONS(4839),
    [sym_double] = ACTIONS(4839),
    [sym_real] = ACTIONS(4839),
    [sym_ifloat] = ACTIONS(4839),
    [sym_idouble] = ACTIONS(4839),
    [sym_ireal] = ACTIONS(4839),
    [sym_cfloat] = ACTIONS(4839),
    [sym_cdouble] = ACTIONS(4839),
    [sym_creal] = ACTIONS(4839),
    [sym_size_t] = ACTIONS(4839),
    [sym_ptrdiff_t] = ACTIONS(4839),
    [sym_string] = ACTIONS(4839),
    [sym_cstring] = ACTIONS(4839),
    [sym_dstring] = ACTIONS(4839),
    [sym_wstring] = ACTIONS(4839),
    [sym_noreturn] = ACTIONS(4839),
    [sym_true] = ACTIONS(4839),
    [sym_false] = ACTIONS(4839),
    [sym_null] = ACTIONS(4839),
    [sym_super] = ACTIONS(4839),
    [sym_this] = ACTIONS(4839),
    [sym_assert] = ACTIONS(4839),
    [sym_auto] = ACTIONS(4839),
    [sym_cast] = ACTIONS(4839),
    [sym_catch] = ACTIONS(4839),
    [sym_const] = ACTIONS(4839),
    [sym_delegate] = ACTIONS(4839),
    [sym_delete] = ACTIONS(4839),
    [sym_do] = ACTIONS(4839),
    [sym_else] = ACTIONS(4839),
    [sym_finally] = ACTIONS(4839),
    [sym_function] = ACTIONS(4839),
    [sym_immutable] = ACTIONS(4839),
    [sym_import] = ACTIONS(4839),
    [sym_in] = ACTIONS(4839),
    [sym_inout] = ACTIONS(4839),
    [sym_is] = ACTIONS(4839),
    [sym_mixin] = ACTIONS(4839),
    [sym_new] = ACTIONS(4839),
    [sym_out] = ACTIONS(4839),
    [sym_ref] = ACTIONS(4839),
    [sym_shared] = ACTIONS(4839),
    [sym_throw] = ACTIONS(4839),
    [sym_typeid] = ACTIONS(4839),
    [sym_typeof] = ACTIONS(4839),
    [sym_traits] = ACTIONS(4839),
    [sym_vector] = ACTIONS(4839),
    [sym_void] = ACTIONS(4839),
    [anon_sym_BQUOTE] = ACTIONS(4841),
    [anon_sym_r_DQUOTE] = ACTIONS(4841),
    [anon_sym_x_DQUOTE] = ACTIONS(4841),
    [anon_sym_DQUOTE] = ACTIONS(4841),
    [anon_sym_i_BQUOTE] = ACTIONS(4841),
    [anon_sym_i_DQUOTE] = ACTIONS(4841),
    [anon_sym_iq_LBRACE] = ACTIONS(4841),
    [aux_sym_char_literal_token1] = ACTIONS(4841),
    [anon_sym_SQUOTE] = ACTIONS(4839),
    [anon_sym___DATE__] = ACTIONS(4839),
    [anon_sym___FILE__] = ACTIONS(4839),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4839),
    [anon_sym___FUNCTION__] = ACTIONS(4839),
    [anon_sym___LINE__] = ACTIONS(4839),
    [anon_sym___MODULE__] = ACTIONS(4839),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4839),
    [anon_sym___TIME__] = ACTIONS(4839),
    [anon_sym___TIMESTAMP__] = ACTIONS(4839),
    [anon_sym___VENDOR__] = ACTIONS(4839),
    [anon_sym___VERSION__] = ACTIONS(4839),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4841),
    [sym_float_literal] = ACTIONS(4841),
    [sym__string] = ACTIONS(4841),
  },
  [1974] = {
    [sym_identifier] = ACTIONS(4444),
    [anon_sym_q_LBRACE] = ACTIONS(4446),
    [anon_sym_LBRACE] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_AMP] = ACTIONS(4446),
    [anon_sym_DASH] = ACTIONS(4444),
    [anon_sym_DASH_DASH] = ACTIONS(4446),
    [anon_sym_PLUS] = ACTIONS(4444),
    [anon_sym_PLUS_PLUS] = ACTIONS(4446),
    [anon_sym_BANG] = ACTIONS(4446),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_RPAREN] = ACTIONS(4446),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_DOLLAR] = ACTIONS(4446),
    [anon_sym_STAR] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [sym_bool] = ACTIONS(4444),
    [sym_byte] = ACTIONS(4444),
    [sym_ubyte] = ACTIONS(4444),
    [sym_char] = ACTIONS(4444),
    [sym_short] = ACTIONS(4444),
    [sym_ushort] = ACTIONS(4444),
    [sym_int] = ACTIONS(4444),
    [sym_uint] = ACTIONS(4444),
    [sym_long] = ACTIONS(4444),
    [sym_ulong] = ACTIONS(4444),
    [sym_cent] = ACTIONS(4444),
    [sym_ucent] = ACTIONS(4444),
    [sym_wchar] = ACTIONS(4444),
    [sym_dchar] = ACTIONS(4444),
    [sym_float] = ACTIONS(4444),
    [sym_double] = ACTIONS(4444),
    [sym_real] = ACTIONS(4444),
    [sym_ifloat] = ACTIONS(4444),
    [sym_idouble] = ACTIONS(4444),
    [sym_ireal] = ACTIONS(4444),
    [sym_cfloat] = ACTIONS(4444),
    [sym_cdouble] = ACTIONS(4444),
    [sym_creal] = ACTIONS(4444),
    [sym_size_t] = ACTIONS(4444),
    [sym_ptrdiff_t] = ACTIONS(4444),
    [sym_string] = ACTIONS(4444),
    [sym_cstring] = ACTIONS(4444),
    [sym_dstring] = ACTIONS(4444),
    [sym_wstring] = ACTIONS(4444),
    [sym_noreturn] = ACTIONS(4444),
    [sym_true] = ACTIONS(4444),
    [sym_false] = ACTIONS(4444),
    [sym_null] = ACTIONS(4444),
    [sym_super] = ACTIONS(4444),
    [sym_this] = ACTIONS(4444),
    [sym_assert] = ACTIONS(4444),
    [sym_auto] = ACTIONS(4444),
    [sym_cast] = ACTIONS(4444),
    [sym_catch] = ACTIONS(4444),
    [sym_const] = ACTIONS(4444),
    [sym_delegate] = ACTIONS(4444),
    [sym_delete] = ACTIONS(4444),
    [sym_do] = ACTIONS(4444),
    [sym_else] = ACTIONS(4444),
    [sym_finally] = ACTIONS(4444),
    [sym_function] = ACTIONS(4444),
    [sym_immutable] = ACTIONS(4444),
    [sym_import] = ACTIONS(4444),
    [sym_in] = ACTIONS(4444),
    [sym_inout] = ACTIONS(4444),
    [sym_is] = ACTIONS(4444),
    [sym_mixin] = ACTIONS(4444),
    [sym_new] = ACTIONS(4444),
    [sym_out] = ACTIONS(4444),
    [sym_ref] = ACTIONS(4444),
    [sym_shared] = ACTIONS(4444),
    [sym_throw] = ACTIONS(4444),
    [sym_typeid] = ACTIONS(4444),
    [sym_typeof] = ACTIONS(4444),
    [sym_traits] = ACTIONS(4444),
    [sym_vector] = ACTIONS(4444),
    [sym_void] = ACTIONS(4444),
    [anon_sym_BQUOTE] = ACTIONS(4446),
    [anon_sym_r_DQUOTE] = ACTIONS(4446),
    [anon_sym_x_DQUOTE] = ACTIONS(4446),
    [anon_sym_DQUOTE] = ACTIONS(4446),
    [anon_sym_i_BQUOTE] = ACTIONS(4446),
    [anon_sym_i_DQUOTE] = ACTIONS(4446),
    [anon_sym_iq_LBRACE] = ACTIONS(4446),
    [aux_sym_char_literal_token1] = ACTIONS(4446),
    [anon_sym_SQUOTE] = ACTIONS(4444),
    [anon_sym___DATE__] = ACTIONS(4444),
    [anon_sym___FILE__] = ACTIONS(4444),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4444),
    [anon_sym___FUNCTION__] = ACTIONS(4444),
    [anon_sym___LINE__] = ACTIONS(4444),
    [anon_sym___MODULE__] = ACTIONS(4444),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4444),
    [anon_sym___TIME__] = ACTIONS(4444),
    [anon_sym___TIMESTAMP__] = ACTIONS(4444),
    [anon_sym___VENDOR__] = ACTIONS(4444),
    [anon_sym___VERSION__] = ACTIONS(4444),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4446),
    [sym_float_literal] = ACTIONS(4446),
    [sym__string] = ACTIONS(4446),
  },
  [1975] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_q_LBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4881),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_DASH_DASH] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_PLUS_PLUS] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_DOLLAR] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_true] = ACTIONS(4879),
    [sym_false] = ACTIONS(4879),
    [sym_null] = ACTIONS(4879),
    [sym_super] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_assert] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_cast] = ACTIONS(4879),
    [sym_catch] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_delegate] = ACTIONS(4879),
    [sym_delete] = ACTIONS(4879),
    [sym_do] = ACTIONS(4879),
    [sym_else] = ACTIONS(4879),
    [sym_finally] = ACTIONS(4879),
    [sym_function] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(4879),
    [sym_inout] = ACTIONS(4879),
    [sym_is] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_new] = ACTIONS(4879),
    [sym_out] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_throw] = ACTIONS(4879),
    [sym_typeid] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [anon_sym_BQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [anon_sym_x_DQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_i_BQUOTE] = ACTIONS(4881),
    [anon_sym_i_DQUOTE] = ACTIONS(4881),
    [anon_sym_iq_LBRACE] = ACTIONS(4881),
    [aux_sym_char_literal_token1] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4879),
    [anon_sym___DATE__] = ACTIONS(4879),
    [anon_sym___FILE__] = ACTIONS(4879),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4879),
    [anon_sym___FUNCTION__] = ACTIONS(4879),
    [anon_sym___LINE__] = ACTIONS(4879),
    [anon_sym___MODULE__] = ACTIONS(4879),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4879),
    [anon_sym___TIME__] = ACTIONS(4879),
    [anon_sym___TIMESTAMP__] = ACTIONS(4879),
    [anon_sym___VENDOR__] = ACTIONS(4879),
    [anon_sym___VERSION__] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym__string] = ACTIONS(4881),
  },
  [1976] = {
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_q_LBRACE] = ACTIONS(4885),
    [anon_sym_LBRACE] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_AMP] = ACTIONS(4885),
    [anon_sym_DASH] = ACTIONS(4883),
    [anon_sym_DASH_DASH] = ACTIONS(4885),
    [anon_sym_PLUS] = ACTIONS(4883),
    [anon_sym_PLUS_PLUS] = ACTIONS(4885),
    [anon_sym_BANG] = ACTIONS(4885),
    [anon_sym_LPAREN] = ACTIONS(4885),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [anon_sym_LBRACK] = ACTIONS(4885),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_DOLLAR] = ACTIONS(4885),
    [anon_sym_STAR] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [sym_bool] = ACTIONS(4883),
    [sym_byte] = ACTIONS(4883),
    [sym_ubyte] = ACTIONS(4883),
    [sym_char] = ACTIONS(4883),
    [sym_short] = ACTIONS(4883),
    [sym_ushort] = ACTIONS(4883),
    [sym_int] = ACTIONS(4883),
    [sym_uint] = ACTIONS(4883),
    [sym_long] = ACTIONS(4883),
    [sym_ulong] = ACTIONS(4883),
    [sym_cent] = ACTIONS(4883),
    [sym_ucent] = ACTIONS(4883),
    [sym_wchar] = ACTIONS(4883),
    [sym_dchar] = ACTIONS(4883),
    [sym_float] = ACTIONS(4883),
    [sym_double] = ACTIONS(4883),
    [sym_real] = ACTIONS(4883),
    [sym_ifloat] = ACTIONS(4883),
    [sym_idouble] = ACTIONS(4883),
    [sym_ireal] = ACTIONS(4883),
    [sym_cfloat] = ACTIONS(4883),
    [sym_cdouble] = ACTIONS(4883),
    [sym_creal] = ACTIONS(4883),
    [sym_size_t] = ACTIONS(4883),
    [sym_ptrdiff_t] = ACTIONS(4883),
    [sym_string] = ACTIONS(4883),
    [sym_cstring] = ACTIONS(4883),
    [sym_dstring] = ACTIONS(4883),
    [sym_wstring] = ACTIONS(4883),
    [sym_noreturn] = ACTIONS(4883),
    [sym_true] = ACTIONS(4883),
    [sym_false] = ACTIONS(4883),
    [sym_null] = ACTIONS(4883),
    [sym_super] = ACTIONS(4883),
    [sym_this] = ACTIONS(4883),
    [sym_assert] = ACTIONS(4883),
    [sym_auto] = ACTIONS(4883),
    [sym_cast] = ACTIONS(4883),
    [sym_catch] = ACTIONS(4883),
    [sym_const] = ACTIONS(4883),
    [sym_delegate] = ACTIONS(4883),
    [sym_delete] = ACTIONS(4883),
    [sym_do] = ACTIONS(4883),
    [sym_else] = ACTIONS(4883),
    [sym_finally] = ACTIONS(4883),
    [sym_function] = ACTIONS(4883),
    [sym_immutable] = ACTIONS(4883),
    [sym_import] = ACTIONS(4883),
    [sym_in] = ACTIONS(4883),
    [sym_inout] = ACTIONS(4883),
    [sym_is] = ACTIONS(4883),
    [sym_mixin] = ACTIONS(4883),
    [sym_new] = ACTIONS(4883),
    [sym_out] = ACTIONS(4883),
    [sym_ref] = ACTIONS(4883),
    [sym_shared] = ACTIONS(4883),
    [sym_throw] = ACTIONS(4883),
    [sym_typeid] = ACTIONS(4883),
    [sym_typeof] = ACTIONS(4883),
    [sym_traits] = ACTIONS(4883),
    [sym_vector] = ACTIONS(4883),
    [sym_void] = ACTIONS(4883),
    [anon_sym_BQUOTE] = ACTIONS(4885),
    [anon_sym_r_DQUOTE] = ACTIONS(4885),
    [anon_sym_x_DQUOTE] = ACTIONS(4885),
    [anon_sym_DQUOTE] = ACTIONS(4885),
    [anon_sym_i_BQUOTE] = ACTIONS(4885),
    [anon_sym_i_DQUOTE] = ACTIONS(4885),
    [anon_sym_iq_LBRACE] = ACTIONS(4885),
    [aux_sym_char_literal_token1] = ACTIONS(4885),
    [anon_sym_SQUOTE] = ACTIONS(4883),
    [anon_sym___DATE__] = ACTIONS(4883),
    [anon_sym___FILE__] = ACTIONS(4883),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4883),
    [anon_sym___FUNCTION__] = ACTIONS(4883),
    [anon_sym___LINE__] = ACTIONS(4883),
    [anon_sym___MODULE__] = ACTIONS(4883),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4883),
    [anon_sym___TIME__] = ACTIONS(4883),
    [anon_sym___TIMESTAMP__] = ACTIONS(4883),
    [anon_sym___VENDOR__] = ACTIONS(4883),
    [anon_sym___VERSION__] = ACTIONS(4883),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4885),
    [sym_float_literal] = ACTIONS(4885),
    [sym__string] = ACTIONS(4885),
  },
  [1977] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_q_LBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(4965),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_AMP] = ACTIONS(4881),
    [anon_sym_DASH] = ACTIONS(4879),
    [anon_sym_DASH_DASH] = ACTIONS(4881),
    [anon_sym_PLUS] = ACTIONS(4879),
    [anon_sym_PLUS_PLUS] = ACTIONS(4881),
    [anon_sym_BANG] = ACTIONS(4881),
    [anon_sym_LPAREN] = ACTIONS(4881),
    [anon_sym_RPAREN] = ACTIONS(4881),
    [anon_sym_LBRACK] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_DOLLAR] = ACTIONS(4881),
    [anon_sym_STAR] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_true] = ACTIONS(4879),
    [sym_false] = ACTIONS(4879),
    [sym_null] = ACTIONS(4879),
    [sym_super] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_assert] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_cast] = ACTIONS(4879),
    [sym_catch] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_delegate] = ACTIONS(4879),
    [sym_delete] = ACTIONS(4879),
    [sym_do] = ACTIONS(4968),
    [sym_else] = ACTIONS(4879),
    [sym_finally] = ACTIONS(4879),
    [sym_function] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(4968),
    [sym_inout] = ACTIONS(4879),
    [sym_is] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_new] = ACTIONS(4879),
    [sym_out] = ACTIONS(4968),
    [sym_ref] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_throw] = ACTIONS(4879),
    [sym_typeid] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [anon_sym_BQUOTE] = ACTIONS(4881),
    [anon_sym_r_DQUOTE] = ACTIONS(4881),
    [anon_sym_x_DQUOTE] = ACTIONS(4881),
    [anon_sym_DQUOTE] = ACTIONS(4881),
    [anon_sym_i_BQUOTE] = ACTIONS(4881),
    [anon_sym_i_DQUOTE] = ACTIONS(4881),
    [anon_sym_iq_LBRACE] = ACTIONS(4881),
    [aux_sym_char_literal_token1] = ACTIONS(4881),
    [anon_sym_SQUOTE] = ACTIONS(4879),
    [anon_sym___DATE__] = ACTIONS(4879),
    [anon_sym___FILE__] = ACTIONS(4879),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4879),
    [anon_sym___FUNCTION__] = ACTIONS(4879),
    [anon_sym___LINE__] = ACTIONS(4879),
    [anon_sym___MODULE__] = ACTIONS(4879),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4879),
    [anon_sym___TIME__] = ACTIONS(4879),
    [anon_sym___TIMESTAMP__] = ACTIONS(4879),
    [anon_sym___VENDOR__] = ACTIONS(4879),
    [anon_sym___VERSION__] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4881),
    [sym_float_literal] = ACTIONS(4881),
    [sym__string] = ACTIONS(4881),
  },
  [1978] = {
    [sym_identifier] = ACTIONS(4891),
    [anon_sym_q_LBRACE] = ACTIONS(4893),
    [anon_sym_LBRACE] = ACTIONS(4893),
    [anon_sym_DOT] = ACTIONS(4893),
    [anon_sym_AMP] = ACTIONS(4893),
    [anon_sym_DASH] = ACTIONS(4891),
    [anon_sym_DASH_DASH] = ACTIONS(4893),
    [anon_sym_PLUS] = ACTIONS(4891),
    [anon_sym_PLUS_PLUS] = ACTIONS(4893),
    [anon_sym_BANG] = ACTIONS(4893),
    [anon_sym_LPAREN] = ACTIONS(4893),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [anon_sym_LBRACK] = ACTIONS(4893),
    [anon_sym_SEMI] = ACTIONS(4893),
    [anon_sym_DOLLAR] = ACTIONS(4893),
    [anon_sym_STAR] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4893),
    [sym_bool] = ACTIONS(4891),
    [sym_byte] = ACTIONS(4891),
    [sym_ubyte] = ACTIONS(4891),
    [sym_char] = ACTIONS(4891),
    [sym_short] = ACTIONS(4891),
    [sym_ushort] = ACTIONS(4891),
    [sym_int] = ACTIONS(4891),
    [sym_uint] = ACTIONS(4891),
    [sym_long] = ACTIONS(4891),
    [sym_ulong] = ACTIONS(4891),
    [sym_cent] = ACTIONS(4891),
    [sym_ucent] = ACTIONS(4891),
    [sym_wchar] = ACTIONS(4891),
    [sym_dchar] = ACTIONS(4891),
    [sym_float] = ACTIONS(4891),
    [sym_double] = ACTIONS(4891),
    [sym_real] = ACTIONS(4891),
    [sym_ifloat] = ACTIONS(4891),
    [sym_idouble] = ACTIONS(4891),
    [sym_ireal] = ACTIONS(4891),
    [sym_cfloat] = ACTIONS(4891),
    [sym_cdouble] = ACTIONS(4891),
    [sym_creal] = ACTIONS(4891),
    [sym_size_t] = ACTIONS(4891),
    [sym_ptrdiff_t] = ACTIONS(4891),
    [sym_string] = ACTIONS(4891),
    [sym_cstring] = ACTIONS(4891),
    [sym_dstring] = ACTIONS(4891),
    [sym_wstring] = ACTIONS(4891),
    [sym_noreturn] = ACTIONS(4891),
    [sym_true] = ACTIONS(4891),
    [sym_false] = ACTIONS(4891),
    [sym_null] = ACTIONS(4891),
    [sym_super] = ACTIONS(4891),
    [sym_this] = ACTIONS(4891),
    [sym_assert] = ACTIONS(4891),
    [sym_auto] = ACTIONS(4891),
    [sym_cast] = ACTIONS(4891),
    [sym_catch] = ACTIONS(4891),
    [sym_const] = ACTIONS(4891),
    [sym_delegate] = ACTIONS(4891),
    [sym_delete] = ACTIONS(4891),
    [sym_do] = ACTIONS(4891),
    [sym_else] = ACTIONS(4891),
    [sym_finally] = ACTIONS(4891),
    [sym_function] = ACTIONS(4891),
    [sym_immutable] = ACTIONS(4891),
    [sym_import] = ACTIONS(4891),
    [sym_in] = ACTIONS(4891),
    [sym_inout] = ACTIONS(4891),
    [sym_is] = ACTIONS(4891),
    [sym_mixin] = ACTIONS(4891),
    [sym_new] = ACTIONS(4891),
    [sym_out] = ACTIONS(4891),
    [sym_ref] = ACTIONS(4891),
    [sym_shared] = ACTIONS(4891),
    [sym_throw] = ACTIONS(4891),
    [sym_typeid] = ACTIONS(4891),
    [sym_typeof] = ACTIONS(4891),
    [sym_traits] = ACTIONS(4891),
    [sym_vector] = ACTIONS(4891),
    [sym_void] = ACTIONS(4891),
    [anon_sym_BQUOTE] = ACTIONS(4893),
    [anon_sym_r_DQUOTE] = ACTIONS(4893),
    [anon_sym_x_DQUOTE] = ACTIONS(4893),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [anon_sym_i_BQUOTE] = ACTIONS(4893),
    [anon_sym_i_DQUOTE] = ACTIONS(4893),
    [anon_sym_iq_LBRACE] = ACTIONS(4893),
    [aux_sym_char_literal_token1] = ACTIONS(4893),
    [anon_sym_SQUOTE] = ACTIONS(4891),
    [anon_sym___DATE__] = ACTIONS(4891),
    [anon_sym___FILE__] = ACTIONS(4891),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4891),
    [anon_sym___FUNCTION__] = ACTIONS(4891),
    [anon_sym___LINE__] = ACTIONS(4891),
    [anon_sym___MODULE__] = ACTIONS(4891),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4891),
    [anon_sym___TIME__] = ACTIONS(4891),
    [anon_sym___TIMESTAMP__] = ACTIONS(4891),
    [anon_sym___VENDOR__] = ACTIONS(4891),
    [anon_sym___VERSION__] = ACTIONS(4891),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4893),
    [sym_float_literal] = ACTIONS(4893),
    [sym__string] = ACTIONS(4893),
  },
  [1979] = {
    [sym_identifier] = ACTIONS(4835),
    [anon_sym_q_LBRACE] = ACTIONS(4837),
    [anon_sym_LBRACE] = ACTIONS(4837),
    [anon_sym_DOT] = ACTIONS(4837),
    [anon_sym_AMP] = ACTIONS(4837),
    [anon_sym_DASH] = ACTIONS(4835),
    [anon_sym_DASH_DASH] = ACTIONS(4837),
    [anon_sym_PLUS] = ACTIONS(4835),
    [anon_sym_PLUS_PLUS] = ACTIONS(4837),
    [anon_sym_BANG] = ACTIONS(4837),
    [anon_sym_LPAREN] = ACTIONS(4837),
    [anon_sym_RPAREN] = ACTIONS(4837),
    [anon_sym_LBRACK] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym_DOLLAR] = ACTIONS(4837),
    [anon_sym_STAR] = ACTIONS(4837),
    [anon_sym_TILDE] = ACTIONS(4837),
    [sym_bool] = ACTIONS(4835),
    [sym_byte] = ACTIONS(4835),
    [sym_ubyte] = ACTIONS(4835),
    [sym_char] = ACTIONS(4835),
    [sym_short] = ACTIONS(4835),
    [sym_ushort] = ACTIONS(4835),
    [sym_int] = ACTIONS(4835),
    [sym_uint] = ACTIONS(4835),
    [sym_long] = ACTIONS(4835),
    [sym_ulong] = ACTIONS(4835),
    [sym_cent] = ACTIONS(4835),
    [sym_ucent] = ACTIONS(4835),
    [sym_wchar] = ACTIONS(4835),
    [sym_dchar] = ACTIONS(4835),
    [sym_float] = ACTIONS(4835),
    [sym_double] = ACTIONS(4835),
    [sym_real] = ACTIONS(4835),
    [sym_ifloat] = ACTIONS(4835),
    [sym_idouble] = ACTIONS(4835),
    [sym_ireal] = ACTIONS(4835),
    [sym_cfloat] = ACTIONS(4835),
    [sym_cdouble] = ACTIONS(4835),
    [sym_creal] = ACTIONS(4835),
    [sym_size_t] = ACTIONS(4835),
    [sym_ptrdiff_t] = ACTIONS(4835),
    [sym_string] = ACTIONS(4835),
    [sym_cstring] = ACTIONS(4835),
    [sym_dstring] = ACTIONS(4835),
    [sym_wstring] = ACTIONS(4835),
    [sym_noreturn] = ACTIONS(4835),
    [sym_true] = ACTIONS(4835),
    [sym_false] = ACTIONS(4835),
    [sym_null] = ACTIONS(4835),
    [sym_super] = ACTIONS(4835),
    [sym_this] = ACTIONS(4835),
    [sym_assert] = ACTIONS(4835),
    [sym_auto] = ACTIONS(4835),
    [sym_cast] = ACTIONS(4835),
    [sym_catch] = ACTIONS(4835),
    [sym_const] = ACTIONS(4835),
    [sym_delegate] = ACTIONS(4835),
    [sym_delete] = ACTIONS(4835),
    [sym_do] = ACTIONS(4835),
    [sym_else] = ACTIONS(4835),
    [sym_finally] = ACTIONS(4835),
    [sym_function] = ACTIONS(4835),
    [sym_immutable] = ACTIONS(4835),
    [sym_import] = ACTIONS(4835),
    [sym_in] = ACTIONS(4835),
    [sym_inout] = ACTIONS(4835),
    [sym_is] = ACTIONS(4835),
    [sym_mixin] = ACTIONS(4835),
    [sym_new] = ACTIONS(4835),
    [sym_out] = ACTIONS(4835),
    [sym_ref] = ACTIONS(4835),
    [sym_shared] = ACTIONS(4835),
    [sym_throw] = ACTIONS(4835),
    [sym_typeid] = ACTIONS(4835),
    [sym_typeof] = ACTIONS(4835),
    [sym_traits] = ACTIONS(4835),
    [sym_vector] = ACTIONS(4835),
    [sym_void] = ACTIONS(4835),
    [anon_sym_BQUOTE] = ACTIONS(4837),
    [anon_sym_r_DQUOTE] = ACTIONS(4837),
    [anon_sym_x_DQUOTE] = ACTIONS(4837),
    [anon_sym_DQUOTE] = ACTIONS(4837),
    [anon_sym_i_BQUOTE] = ACTIONS(4837),
    [anon_sym_i_DQUOTE] = ACTIONS(4837),
    [anon_sym_iq_LBRACE] = ACTIONS(4837),
    [aux_sym_char_literal_token1] = ACTIONS(4837),
    [anon_sym_SQUOTE] = ACTIONS(4835),
    [anon_sym___DATE__] = ACTIONS(4835),
    [anon_sym___FILE__] = ACTIONS(4835),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4835),
    [anon_sym___FUNCTION__] = ACTIONS(4835),
    [anon_sym___LINE__] = ACTIONS(4835),
    [anon_sym___MODULE__] = ACTIONS(4835),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4835),
    [anon_sym___TIME__] = ACTIONS(4835),
    [anon_sym___TIMESTAMP__] = ACTIONS(4835),
    [anon_sym___VENDOR__] = ACTIONS(4835),
    [anon_sym___VERSION__] = ACTIONS(4835),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4837),
    [sym_float_literal] = ACTIONS(4837),
    [sym__string] = ACTIONS(4837),
  },
  [1980] = {
    [sym_identifier] = ACTIONS(4831),
    [anon_sym_q_LBRACE] = ACTIONS(4833),
    [anon_sym_LBRACE] = ACTIONS(4833),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_AMP] = ACTIONS(4833),
    [anon_sym_DASH] = ACTIONS(4831),
    [anon_sym_DASH_DASH] = ACTIONS(4833),
    [anon_sym_PLUS] = ACTIONS(4831),
    [anon_sym_PLUS_PLUS] = ACTIONS(4833),
    [anon_sym_BANG] = ACTIONS(4833),
    [anon_sym_LPAREN] = ACTIONS(4833),
    [anon_sym_RPAREN] = ACTIONS(4833),
    [anon_sym_LBRACK] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4833),
    [anon_sym_DOLLAR] = ACTIONS(4833),
    [anon_sym_STAR] = ACTIONS(4833),
    [anon_sym_TILDE] = ACTIONS(4833),
    [sym_bool] = ACTIONS(4831),
    [sym_byte] = ACTIONS(4831),
    [sym_ubyte] = ACTIONS(4831),
    [sym_char] = ACTIONS(4831),
    [sym_short] = ACTIONS(4831),
    [sym_ushort] = ACTIONS(4831),
    [sym_int] = ACTIONS(4831),
    [sym_uint] = ACTIONS(4831),
    [sym_long] = ACTIONS(4831),
    [sym_ulong] = ACTIONS(4831),
    [sym_cent] = ACTIONS(4831),
    [sym_ucent] = ACTIONS(4831),
    [sym_wchar] = ACTIONS(4831),
    [sym_dchar] = ACTIONS(4831),
    [sym_float] = ACTIONS(4831),
    [sym_double] = ACTIONS(4831),
    [sym_real] = ACTIONS(4831),
    [sym_ifloat] = ACTIONS(4831),
    [sym_idouble] = ACTIONS(4831),
    [sym_ireal] = ACTIONS(4831),
    [sym_cfloat] = ACTIONS(4831),
    [sym_cdouble] = ACTIONS(4831),
    [sym_creal] = ACTIONS(4831),
    [sym_size_t] = ACTIONS(4831),
    [sym_ptrdiff_t] = ACTIONS(4831),
    [sym_string] = ACTIONS(4831),
    [sym_cstring] = ACTIONS(4831),
    [sym_dstring] = ACTIONS(4831),
    [sym_wstring] = ACTIONS(4831),
    [sym_noreturn] = ACTIONS(4831),
    [sym_true] = ACTIONS(4831),
    [sym_false] = ACTIONS(4831),
    [sym_null] = ACTIONS(4831),
    [sym_super] = ACTIONS(4831),
    [sym_this] = ACTIONS(4831),
    [sym_assert] = ACTIONS(4831),
    [sym_auto] = ACTIONS(4831),
    [sym_cast] = ACTIONS(4831),
    [sym_catch] = ACTIONS(4831),
    [sym_const] = ACTIONS(4831),
    [sym_delegate] = ACTIONS(4831),
    [sym_delete] = ACTIONS(4831),
    [sym_do] = ACTIONS(4831),
    [sym_else] = ACTIONS(4831),
    [sym_finally] = ACTIONS(4831),
    [sym_function] = ACTIONS(4831),
    [sym_immutable] = ACTIONS(4831),
    [sym_import] = ACTIONS(4831),
    [sym_in] = ACTIONS(4831),
    [sym_inout] = ACTIONS(4831),
    [sym_is] = ACTIONS(4831),
    [sym_mixin] = ACTIONS(4831),
    [sym_new] = ACTIONS(4831),
    [sym_out] = ACTIONS(4831),
    [sym_ref] = ACTIONS(4831),
    [sym_shared] = ACTIONS(4831),
    [sym_throw] = ACTIONS(4831),
    [sym_typeid] = ACTIONS(4831),
    [sym_typeof] = ACTIONS(4831),
    [sym_traits] = ACTIONS(4831),
    [sym_vector] = ACTIONS(4831),
    [sym_void] = ACTIONS(4831),
    [anon_sym_BQUOTE] = ACTIONS(4833),
    [anon_sym_r_DQUOTE] = ACTIONS(4833),
    [anon_sym_x_DQUOTE] = ACTIONS(4833),
    [anon_sym_DQUOTE] = ACTIONS(4833),
    [anon_sym_i_BQUOTE] = ACTIONS(4833),
    [anon_sym_i_DQUOTE] = ACTIONS(4833),
    [anon_sym_iq_LBRACE] = ACTIONS(4833),
    [aux_sym_char_literal_token1] = ACTIONS(4833),
    [anon_sym_SQUOTE] = ACTIONS(4831),
    [anon_sym___DATE__] = ACTIONS(4831),
    [anon_sym___FILE__] = ACTIONS(4831),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4831),
    [anon_sym___FUNCTION__] = ACTIONS(4831),
    [anon_sym___LINE__] = ACTIONS(4831),
    [anon_sym___MODULE__] = ACTIONS(4831),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4831),
    [anon_sym___TIME__] = ACTIONS(4831),
    [anon_sym___TIMESTAMP__] = ACTIONS(4831),
    [anon_sym___VENDOR__] = ACTIONS(4831),
    [anon_sym___VERSION__] = ACTIONS(4831),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4833),
    [sym_float_literal] = ACTIONS(4833),
    [sym__string] = ACTIONS(4833),
  },
  [1981] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_catch] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(5856),
    [sym_finally] = ACTIONS(4366),
    [sym_function] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [1982] = {
    [sym_identifier] = ACTIONS(4448),
    [anon_sym_q_LBRACE] = ACTIONS(4450),
    [anon_sym_LBRACE] = ACTIONS(4450),
    [anon_sym_DOT] = ACTIONS(4450),
    [anon_sym_AMP] = ACTIONS(4450),
    [anon_sym_DASH] = ACTIONS(4448),
    [anon_sym_DASH_DASH] = ACTIONS(4450),
    [anon_sym_PLUS] = ACTIONS(4448),
    [anon_sym_PLUS_PLUS] = ACTIONS(4450),
    [anon_sym_BANG] = ACTIONS(4450),
    [anon_sym_LPAREN] = ACTIONS(4450),
    [anon_sym_RPAREN] = ACTIONS(4450),
    [anon_sym_LBRACK] = ACTIONS(4450),
    [anon_sym_SEMI] = ACTIONS(4450),
    [anon_sym_DOLLAR] = ACTIONS(4450),
    [anon_sym_STAR] = ACTIONS(4450),
    [anon_sym_TILDE] = ACTIONS(4450),
    [sym_bool] = ACTIONS(4448),
    [sym_byte] = ACTIONS(4448),
    [sym_ubyte] = ACTIONS(4448),
    [sym_char] = ACTIONS(4448),
    [sym_short] = ACTIONS(4448),
    [sym_ushort] = ACTIONS(4448),
    [sym_int] = ACTIONS(4448),
    [sym_uint] = ACTIONS(4448),
    [sym_long] = ACTIONS(4448),
    [sym_ulong] = ACTIONS(4448),
    [sym_cent] = ACTIONS(4448),
    [sym_ucent] = ACTIONS(4448),
    [sym_wchar] = ACTIONS(4448),
    [sym_dchar] = ACTIONS(4448),
    [sym_float] = ACTIONS(4448),
    [sym_double] = ACTIONS(4448),
    [sym_real] = ACTIONS(4448),
    [sym_ifloat] = ACTIONS(4448),
    [sym_idouble] = ACTIONS(4448),
    [sym_ireal] = ACTIONS(4448),
    [sym_cfloat] = ACTIONS(4448),
    [sym_cdouble] = ACTIONS(4448),
    [sym_creal] = ACTIONS(4448),
    [sym_size_t] = ACTIONS(4448),
    [sym_ptrdiff_t] = ACTIONS(4448),
    [sym_string] = ACTIONS(4448),
    [sym_cstring] = ACTIONS(4448),
    [sym_dstring] = ACTIONS(4448),
    [sym_wstring] = ACTIONS(4448),
    [sym_noreturn] = ACTIONS(4448),
    [sym_true] = ACTIONS(4448),
    [sym_false] = ACTIONS(4448),
    [sym_null] = ACTIONS(4448),
    [sym_super] = ACTIONS(4448),
    [sym_this] = ACTIONS(4448),
    [sym_assert] = ACTIONS(4448),
    [sym_auto] = ACTIONS(4448),
    [sym_cast] = ACTIONS(4448),
    [sym_catch] = ACTIONS(4448),
    [sym_const] = ACTIONS(4448),
    [sym_delegate] = ACTIONS(4448),
    [sym_delete] = ACTIONS(4448),
    [sym_do] = ACTIONS(4448),
    [sym_else] = ACTIONS(4448),
    [sym_finally] = ACTIONS(4448),
    [sym_function] = ACTIONS(4448),
    [sym_immutable] = ACTIONS(4448),
    [sym_import] = ACTIONS(4448),
    [sym_in] = ACTIONS(4448),
    [sym_inout] = ACTIONS(4448),
    [sym_is] = ACTIONS(4448),
    [sym_mixin] = ACTIONS(4448),
    [sym_new] = ACTIONS(4448),
    [sym_out] = ACTIONS(4448),
    [sym_ref] = ACTIONS(4448),
    [sym_shared] = ACTIONS(4448),
    [sym_throw] = ACTIONS(4448),
    [sym_typeid] = ACTIONS(4448),
    [sym_typeof] = ACTIONS(4448),
    [sym_traits] = ACTIONS(4448),
    [sym_vector] = ACTIONS(4448),
    [sym_void] = ACTIONS(4448),
    [anon_sym_BQUOTE] = ACTIONS(4450),
    [anon_sym_r_DQUOTE] = ACTIONS(4450),
    [anon_sym_x_DQUOTE] = ACTIONS(4450),
    [anon_sym_DQUOTE] = ACTIONS(4450),
    [anon_sym_i_BQUOTE] = ACTIONS(4450),
    [anon_sym_i_DQUOTE] = ACTIONS(4450),
    [anon_sym_iq_LBRACE] = ACTIONS(4450),
    [aux_sym_char_literal_token1] = ACTIONS(4450),
    [anon_sym_SQUOTE] = ACTIONS(4448),
    [anon_sym___DATE__] = ACTIONS(4448),
    [anon_sym___FILE__] = ACTIONS(4448),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4448),
    [anon_sym___FUNCTION__] = ACTIONS(4448),
    [anon_sym___LINE__] = ACTIONS(4448),
    [anon_sym___MODULE__] = ACTIONS(4448),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4448),
    [anon_sym___TIME__] = ACTIONS(4448),
    [anon_sym___TIMESTAMP__] = ACTIONS(4448),
    [anon_sym___VENDOR__] = ACTIONS(4448),
    [anon_sym___VERSION__] = ACTIONS(4448),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4450),
    [sym_float_literal] = ACTIONS(4450),
    [sym__string] = ACTIONS(4450),
  },
  [1983] = {
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_q_LBRACE] = ACTIONS(4454),
    [anon_sym_LBRACE] = ACTIONS(4454),
    [anon_sym_DOT] = ACTIONS(4454),
    [anon_sym_AMP] = ACTIONS(4454),
    [anon_sym_DASH] = ACTIONS(4452),
    [anon_sym_DASH_DASH] = ACTIONS(4454),
    [anon_sym_PLUS] = ACTIONS(4452),
    [anon_sym_PLUS_PLUS] = ACTIONS(4454),
    [anon_sym_BANG] = ACTIONS(4454),
    [anon_sym_LPAREN] = ACTIONS(4454),
    [anon_sym_RPAREN] = ACTIONS(4454),
    [anon_sym_LBRACK] = ACTIONS(4454),
    [anon_sym_SEMI] = ACTIONS(4454),
    [anon_sym_DOLLAR] = ACTIONS(4454),
    [anon_sym_STAR] = ACTIONS(4454),
    [anon_sym_TILDE] = ACTIONS(4454),
    [sym_bool] = ACTIONS(4452),
    [sym_byte] = ACTIONS(4452),
    [sym_ubyte] = ACTIONS(4452),
    [sym_char] = ACTIONS(4452),
    [sym_short] = ACTIONS(4452),
    [sym_ushort] = ACTIONS(4452),
    [sym_int] = ACTIONS(4452),
    [sym_uint] = ACTIONS(4452),
    [sym_long] = ACTIONS(4452),
    [sym_ulong] = ACTIONS(4452),
    [sym_cent] = ACTIONS(4452),
    [sym_ucent] = ACTIONS(4452),
    [sym_wchar] = ACTIONS(4452),
    [sym_dchar] = ACTIONS(4452),
    [sym_float] = ACTIONS(4452),
    [sym_double] = ACTIONS(4452),
    [sym_real] = ACTIONS(4452),
    [sym_ifloat] = ACTIONS(4452),
    [sym_idouble] = ACTIONS(4452),
    [sym_ireal] = ACTIONS(4452),
    [sym_cfloat] = ACTIONS(4452),
    [sym_cdouble] = ACTIONS(4452),
    [sym_creal] = ACTIONS(4452),
    [sym_size_t] = ACTIONS(4452),
    [sym_ptrdiff_t] = ACTIONS(4452),
    [sym_string] = ACTIONS(4452),
    [sym_cstring] = ACTIONS(4452),
    [sym_dstring] = ACTIONS(4452),
    [sym_wstring] = ACTIONS(4452),
    [sym_noreturn] = ACTIONS(4452),
    [sym_true] = ACTIONS(4452),
    [sym_false] = ACTIONS(4452),
    [sym_null] = ACTIONS(4452),
    [sym_super] = ACTIONS(4452),
    [sym_this] = ACTIONS(4452),
    [sym_assert] = ACTIONS(4452),
    [sym_auto] = ACTIONS(4452),
    [sym_cast] = ACTIONS(4452),
    [sym_catch] = ACTIONS(4452),
    [sym_const] = ACTIONS(4452),
    [sym_delegate] = ACTIONS(4452),
    [sym_delete] = ACTIONS(4452),
    [sym_do] = ACTIONS(4452),
    [sym_else] = ACTIONS(4452),
    [sym_finally] = ACTIONS(4452),
    [sym_function] = ACTIONS(4452),
    [sym_immutable] = ACTIONS(4452),
    [sym_import] = ACTIONS(4452),
    [sym_in] = ACTIONS(4452),
    [sym_inout] = ACTIONS(4452),
    [sym_is] = ACTIONS(4452),
    [sym_mixin] = ACTIONS(4452),
    [sym_new] = ACTIONS(4452),
    [sym_out] = ACTIONS(4452),
    [sym_ref] = ACTIONS(4452),
    [sym_shared] = ACTIONS(4452),
    [sym_throw] = ACTIONS(4452),
    [sym_typeid] = ACTIONS(4452),
    [sym_typeof] = ACTIONS(4452),
    [sym_traits] = ACTIONS(4452),
    [sym_vector] = ACTIONS(4452),
    [sym_void] = ACTIONS(4452),
    [anon_sym_BQUOTE] = ACTIONS(4454),
    [anon_sym_r_DQUOTE] = ACTIONS(4454),
    [anon_sym_x_DQUOTE] = ACTIONS(4454),
    [anon_sym_DQUOTE] = ACTIONS(4454),
    [anon_sym_i_BQUOTE] = ACTIONS(4454),
    [anon_sym_i_DQUOTE] = ACTIONS(4454),
    [anon_sym_iq_LBRACE] = ACTIONS(4454),
    [aux_sym_char_literal_token1] = ACTIONS(4454),
    [anon_sym_SQUOTE] = ACTIONS(4452),
    [anon_sym___DATE__] = ACTIONS(4452),
    [anon_sym___FILE__] = ACTIONS(4452),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4452),
    [anon_sym___FUNCTION__] = ACTIONS(4452),
    [anon_sym___LINE__] = ACTIONS(4452),
    [anon_sym___MODULE__] = ACTIONS(4452),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4452),
    [anon_sym___TIME__] = ACTIONS(4452),
    [anon_sym___TIMESTAMP__] = ACTIONS(4452),
    [anon_sym___VENDOR__] = ACTIONS(4452),
    [anon_sym___VERSION__] = ACTIONS(4452),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4454),
    [sym_float_literal] = ACTIONS(4454),
    [sym__string] = ACTIONS(4454),
  },
  [1984] = {
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_q_LBRACE] = ACTIONS(4897),
    [anon_sym_LBRACE] = ACTIONS(4897),
    [anon_sym_DOT] = ACTIONS(4897),
    [anon_sym_AMP] = ACTIONS(4897),
    [anon_sym_DASH] = ACTIONS(4895),
    [anon_sym_DASH_DASH] = ACTIONS(4897),
    [anon_sym_PLUS] = ACTIONS(4895),
    [anon_sym_PLUS_PLUS] = ACTIONS(4897),
    [anon_sym_BANG] = ACTIONS(4897),
    [anon_sym_LPAREN] = ACTIONS(4897),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [anon_sym_LBRACK] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_DOLLAR] = ACTIONS(4897),
    [anon_sym_STAR] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [sym_bool] = ACTIONS(4895),
    [sym_byte] = ACTIONS(4895),
    [sym_ubyte] = ACTIONS(4895),
    [sym_char] = ACTIONS(4895),
    [sym_short] = ACTIONS(4895),
    [sym_ushort] = ACTIONS(4895),
    [sym_int] = ACTIONS(4895),
    [sym_uint] = ACTIONS(4895),
    [sym_long] = ACTIONS(4895),
    [sym_ulong] = ACTIONS(4895),
    [sym_cent] = ACTIONS(4895),
    [sym_ucent] = ACTIONS(4895),
    [sym_wchar] = ACTIONS(4895),
    [sym_dchar] = ACTIONS(4895),
    [sym_float] = ACTIONS(4895),
    [sym_double] = ACTIONS(4895),
    [sym_real] = ACTIONS(4895),
    [sym_ifloat] = ACTIONS(4895),
    [sym_idouble] = ACTIONS(4895),
    [sym_ireal] = ACTIONS(4895),
    [sym_cfloat] = ACTIONS(4895),
    [sym_cdouble] = ACTIONS(4895),
    [sym_creal] = ACTIONS(4895),
    [sym_size_t] = ACTIONS(4895),
    [sym_ptrdiff_t] = ACTIONS(4895),
    [sym_string] = ACTIONS(4895),
    [sym_cstring] = ACTIONS(4895),
    [sym_dstring] = ACTIONS(4895),
    [sym_wstring] = ACTIONS(4895),
    [sym_noreturn] = ACTIONS(4895),
    [sym_true] = ACTIONS(4895),
    [sym_false] = ACTIONS(4895),
    [sym_null] = ACTIONS(4895),
    [sym_super] = ACTIONS(4895),
    [sym_this] = ACTIONS(4895),
    [sym_assert] = ACTIONS(4895),
    [sym_auto] = ACTIONS(4895),
    [sym_cast] = ACTIONS(4895),
    [sym_catch] = ACTIONS(4895),
    [sym_const] = ACTIONS(4895),
    [sym_delegate] = ACTIONS(4895),
    [sym_delete] = ACTIONS(4895),
    [sym_do] = ACTIONS(4895),
    [sym_else] = ACTIONS(4895),
    [sym_finally] = ACTIONS(4895),
    [sym_function] = ACTIONS(4895),
    [sym_immutable] = ACTIONS(4895),
    [sym_import] = ACTIONS(4895),
    [sym_in] = ACTIONS(4895),
    [sym_inout] = ACTIONS(4895),
    [sym_is] = ACTIONS(4895),
    [sym_mixin] = ACTIONS(4895),
    [sym_new] = ACTIONS(4895),
    [sym_out] = ACTIONS(4895),
    [sym_ref] = ACTIONS(4895),
    [sym_shared] = ACTIONS(4895),
    [sym_throw] = ACTIONS(4895),
    [sym_typeid] = ACTIONS(4895),
    [sym_typeof] = ACTIONS(4895),
    [sym_traits] = ACTIONS(4895),
    [sym_vector] = ACTIONS(4895),
    [sym_void] = ACTIONS(4895),
    [anon_sym_BQUOTE] = ACTIONS(4897),
    [anon_sym_r_DQUOTE] = ACTIONS(4897),
    [anon_sym_x_DQUOTE] = ACTIONS(4897),
    [anon_sym_DQUOTE] = ACTIONS(4897),
    [anon_sym_i_BQUOTE] = ACTIONS(4897),
    [anon_sym_i_DQUOTE] = ACTIONS(4897),
    [anon_sym_iq_LBRACE] = ACTIONS(4897),
    [aux_sym_char_literal_token1] = ACTIONS(4897),
    [anon_sym_SQUOTE] = ACTIONS(4895),
    [anon_sym___DATE__] = ACTIONS(4895),
    [anon_sym___FILE__] = ACTIONS(4895),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4895),
    [anon_sym___FUNCTION__] = ACTIONS(4895),
    [anon_sym___LINE__] = ACTIONS(4895),
    [anon_sym___MODULE__] = ACTIONS(4895),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4895),
    [anon_sym___TIME__] = ACTIONS(4895),
    [anon_sym___TIMESTAMP__] = ACTIONS(4895),
    [anon_sym___VENDOR__] = ACTIONS(4895),
    [anon_sym___VERSION__] = ACTIONS(4895),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4897),
    [sym_float_literal] = ACTIONS(4897),
    [sym__string] = ACTIONS(4897),
  },
  [1985] = {
    [sym_identifier] = ACTIONS(4428),
    [anon_sym_q_LBRACE] = ACTIONS(4430),
    [anon_sym_LBRACE] = ACTIONS(4430),
    [anon_sym_DOT] = ACTIONS(4430),
    [anon_sym_AMP] = ACTIONS(4430),
    [anon_sym_DASH] = ACTIONS(4428),
    [anon_sym_DASH_DASH] = ACTIONS(4430),
    [anon_sym_PLUS] = ACTIONS(4428),
    [anon_sym_PLUS_PLUS] = ACTIONS(4430),
    [anon_sym_BANG] = ACTIONS(4430),
    [anon_sym_LPAREN] = ACTIONS(4430),
    [anon_sym_RPAREN] = ACTIONS(4430),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_SEMI] = ACTIONS(4430),
    [anon_sym_DOLLAR] = ACTIONS(4430),
    [anon_sym_STAR] = ACTIONS(4430),
    [anon_sym_TILDE] = ACTIONS(4430),
    [sym_bool] = ACTIONS(4428),
    [sym_byte] = ACTIONS(4428),
    [sym_ubyte] = ACTIONS(4428),
    [sym_char] = ACTIONS(4428),
    [sym_short] = ACTIONS(4428),
    [sym_ushort] = ACTIONS(4428),
    [sym_int] = ACTIONS(4428),
    [sym_uint] = ACTIONS(4428),
    [sym_long] = ACTIONS(4428),
    [sym_ulong] = ACTIONS(4428),
    [sym_cent] = ACTIONS(4428),
    [sym_ucent] = ACTIONS(4428),
    [sym_wchar] = ACTIONS(4428),
    [sym_dchar] = ACTIONS(4428),
    [sym_float] = ACTIONS(4428),
    [sym_double] = ACTIONS(4428),
    [sym_real] = ACTIONS(4428),
    [sym_ifloat] = ACTIONS(4428),
    [sym_idouble] = ACTIONS(4428),
    [sym_ireal] = ACTIONS(4428),
    [sym_cfloat] = ACTIONS(4428),
    [sym_cdouble] = ACTIONS(4428),
    [sym_creal] = ACTIONS(4428),
    [sym_size_t] = ACTIONS(4428),
    [sym_ptrdiff_t] = ACTIONS(4428),
    [sym_string] = ACTIONS(4428),
    [sym_cstring] = ACTIONS(4428),
    [sym_dstring] = ACTIONS(4428),
    [sym_wstring] = ACTIONS(4428),
    [sym_noreturn] = ACTIONS(4428),
    [sym_true] = ACTIONS(4428),
    [sym_false] = ACTIONS(4428),
    [sym_null] = ACTIONS(4428),
    [sym_super] = ACTIONS(4428),
    [sym_this] = ACTIONS(4428),
    [sym_assert] = ACTIONS(4428),
    [sym_auto] = ACTIONS(4428),
    [sym_cast] = ACTIONS(4428),
    [sym_catch] = ACTIONS(4428),
    [sym_const] = ACTIONS(4428),
    [sym_delegate] = ACTIONS(4428),
    [sym_delete] = ACTIONS(4428),
    [sym_do] = ACTIONS(4428),
    [sym_else] = ACTIONS(4428),
    [sym_finally] = ACTIONS(4428),
    [sym_function] = ACTIONS(4428),
    [sym_immutable] = ACTIONS(4428),
    [sym_import] = ACTIONS(4428),
    [sym_in] = ACTIONS(4428),
    [sym_inout] = ACTIONS(4428),
    [sym_is] = ACTIONS(4428),
    [sym_mixin] = ACTIONS(4428),
    [sym_new] = ACTIONS(4428),
    [sym_out] = ACTIONS(4428),
    [sym_ref] = ACTIONS(4428),
    [sym_shared] = ACTIONS(4428),
    [sym_throw] = ACTIONS(4428),
    [sym_typeid] = ACTIONS(4428),
    [sym_typeof] = ACTIONS(4428),
    [sym_traits] = ACTIONS(4428),
    [sym_vector] = ACTIONS(4428),
    [sym_void] = ACTIONS(4428),
    [anon_sym_BQUOTE] = ACTIONS(4430),
    [anon_sym_r_DQUOTE] = ACTIONS(4430),
    [anon_sym_x_DQUOTE] = ACTIONS(4430),
    [anon_sym_DQUOTE] = ACTIONS(4430),
    [anon_sym_i_BQUOTE] = ACTIONS(4430),
    [anon_sym_i_DQUOTE] = ACTIONS(4430),
    [anon_sym_iq_LBRACE] = ACTIONS(4430),
    [aux_sym_char_literal_token1] = ACTIONS(4430),
    [anon_sym_SQUOTE] = ACTIONS(4428),
    [anon_sym___DATE__] = ACTIONS(4428),
    [anon_sym___FILE__] = ACTIONS(4428),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4428),
    [anon_sym___FUNCTION__] = ACTIONS(4428),
    [anon_sym___LINE__] = ACTIONS(4428),
    [anon_sym___MODULE__] = ACTIONS(4428),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4428),
    [anon_sym___TIME__] = ACTIONS(4428),
    [anon_sym___TIMESTAMP__] = ACTIONS(4428),
    [anon_sym___VENDOR__] = ACTIONS(4428),
    [anon_sym___VERSION__] = ACTIONS(4428),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4430),
    [sym_float_literal] = ACTIONS(4430),
    [sym__string] = ACTIONS(4430),
  },
  [1986] = {
    [sym_identifier] = ACTIONS(4899),
    [anon_sym_q_LBRACE] = ACTIONS(4901),
    [anon_sym_LBRACE] = ACTIONS(4901),
    [anon_sym_DOT] = ACTIONS(4901),
    [anon_sym_AMP] = ACTIONS(4901),
    [anon_sym_DASH] = ACTIONS(4899),
    [anon_sym_DASH_DASH] = ACTIONS(4901),
    [anon_sym_PLUS] = ACTIONS(4899),
    [anon_sym_PLUS_PLUS] = ACTIONS(4901),
    [anon_sym_BANG] = ACTIONS(4901),
    [anon_sym_LPAREN] = ACTIONS(4901),
    [anon_sym_RPAREN] = ACTIONS(4901),
    [anon_sym_LBRACK] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_DOLLAR] = ACTIONS(4901),
    [anon_sym_STAR] = ACTIONS(4901),
    [anon_sym_TILDE] = ACTIONS(4901),
    [sym_bool] = ACTIONS(4899),
    [sym_byte] = ACTIONS(4899),
    [sym_ubyte] = ACTIONS(4899),
    [sym_char] = ACTIONS(4899),
    [sym_short] = ACTIONS(4899),
    [sym_ushort] = ACTIONS(4899),
    [sym_int] = ACTIONS(4899),
    [sym_uint] = ACTIONS(4899),
    [sym_long] = ACTIONS(4899),
    [sym_ulong] = ACTIONS(4899),
    [sym_cent] = ACTIONS(4899),
    [sym_ucent] = ACTIONS(4899),
    [sym_wchar] = ACTIONS(4899),
    [sym_dchar] = ACTIONS(4899),
    [sym_float] = ACTIONS(4899),
    [sym_double] = ACTIONS(4899),
    [sym_real] = ACTIONS(4899),
    [sym_ifloat] = ACTIONS(4899),
    [sym_idouble] = ACTIONS(4899),
    [sym_ireal] = ACTIONS(4899),
    [sym_cfloat] = ACTIONS(4899),
    [sym_cdouble] = ACTIONS(4899),
    [sym_creal] = ACTIONS(4899),
    [sym_size_t] = ACTIONS(4899),
    [sym_ptrdiff_t] = ACTIONS(4899),
    [sym_string] = ACTIONS(4899),
    [sym_cstring] = ACTIONS(4899),
    [sym_dstring] = ACTIONS(4899),
    [sym_wstring] = ACTIONS(4899),
    [sym_noreturn] = ACTIONS(4899),
    [sym_true] = ACTIONS(4899),
    [sym_false] = ACTIONS(4899),
    [sym_null] = ACTIONS(4899),
    [sym_super] = ACTIONS(4899),
    [sym_this] = ACTIONS(4899),
    [sym_assert] = ACTIONS(4899),
    [sym_auto] = ACTIONS(4899),
    [sym_cast] = ACTIONS(4899),
    [sym_catch] = ACTIONS(4899),
    [sym_const] = ACTIONS(4899),
    [sym_delegate] = ACTIONS(4899),
    [sym_delete] = ACTIONS(4899),
    [sym_do] = ACTIONS(4899),
    [sym_else] = ACTIONS(4899),
    [sym_finally] = ACTIONS(4899),
    [sym_function] = ACTIONS(4899),
    [sym_immutable] = ACTIONS(4899),
    [sym_import] = ACTIONS(4899),
    [sym_in] = ACTIONS(4899),
    [sym_inout] = ACTIONS(4899),
    [sym_is] = ACTIONS(4899),
    [sym_mixin] = ACTIONS(4899),
    [sym_new] = ACTIONS(4899),
    [sym_out] = ACTIONS(4899),
    [sym_ref] = ACTIONS(4899),
    [sym_shared] = ACTIONS(4899),
    [sym_throw] = ACTIONS(4899),
    [sym_typeid] = ACTIONS(4899),
    [sym_typeof] = ACTIONS(4899),
    [sym_traits] = ACTIONS(4899),
    [sym_vector] = ACTIONS(4899),
    [sym_void] = ACTIONS(4899),
    [anon_sym_BQUOTE] = ACTIONS(4901),
    [anon_sym_r_DQUOTE] = ACTIONS(4901),
    [anon_sym_x_DQUOTE] = ACTIONS(4901),
    [anon_sym_DQUOTE] = ACTIONS(4901),
    [anon_sym_i_BQUOTE] = ACTIONS(4901),
    [anon_sym_i_DQUOTE] = ACTIONS(4901),
    [anon_sym_iq_LBRACE] = ACTIONS(4901),
    [aux_sym_char_literal_token1] = ACTIONS(4901),
    [anon_sym_SQUOTE] = ACTIONS(4899),
    [anon_sym___DATE__] = ACTIONS(4899),
    [anon_sym___FILE__] = ACTIONS(4899),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4899),
    [anon_sym___FUNCTION__] = ACTIONS(4899),
    [anon_sym___LINE__] = ACTIONS(4899),
    [anon_sym___MODULE__] = ACTIONS(4899),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4899),
    [anon_sym___TIME__] = ACTIONS(4899),
    [anon_sym___TIMESTAMP__] = ACTIONS(4899),
    [anon_sym___VENDOR__] = ACTIONS(4899),
    [anon_sym___VERSION__] = ACTIONS(4899),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4901),
    [sym_float_literal] = ACTIONS(4901),
    [sym__string] = ACTIONS(4901),
  },
  [1987] = {
    [sym_identifier] = ACTIONS(4903),
    [anon_sym_q_LBRACE] = ACTIONS(4905),
    [anon_sym_LBRACE] = ACTIONS(4905),
    [anon_sym_DOT] = ACTIONS(4905),
    [anon_sym_AMP] = ACTIONS(4905),
    [anon_sym_DASH] = ACTIONS(4903),
    [anon_sym_DASH_DASH] = ACTIONS(4905),
    [anon_sym_PLUS] = ACTIONS(4903),
    [anon_sym_PLUS_PLUS] = ACTIONS(4905),
    [anon_sym_BANG] = ACTIONS(4905),
    [anon_sym_LPAREN] = ACTIONS(4905),
    [anon_sym_RPAREN] = ACTIONS(4905),
    [anon_sym_LBRACK] = ACTIONS(4905),
    [anon_sym_SEMI] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(4905),
    [anon_sym_STAR] = ACTIONS(4905),
    [anon_sym_TILDE] = ACTIONS(4905),
    [sym_bool] = ACTIONS(4903),
    [sym_byte] = ACTIONS(4903),
    [sym_ubyte] = ACTIONS(4903),
    [sym_char] = ACTIONS(4903),
    [sym_short] = ACTIONS(4903),
    [sym_ushort] = ACTIONS(4903),
    [sym_int] = ACTIONS(4903),
    [sym_uint] = ACTIONS(4903),
    [sym_long] = ACTIONS(4903),
    [sym_ulong] = ACTIONS(4903),
    [sym_cent] = ACTIONS(4903),
    [sym_ucent] = ACTIONS(4903),
    [sym_wchar] = ACTIONS(4903),
    [sym_dchar] = ACTIONS(4903),
    [sym_float] = ACTIONS(4903),
    [sym_double] = ACTIONS(4903),
    [sym_real] = ACTIONS(4903),
    [sym_ifloat] = ACTIONS(4903),
    [sym_idouble] = ACTIONS(4903),
    [sym_ireal] = ACTIONS(4903),
    [sym_cfloat] = ACTIONS(4903),
    [sym_cdouble] = ACTIONS(4903),
    [sym_creal] = ACTIONS(4903),
    [sym_size_t] = ACTIONS(4903),
    [sym_ptrdiff_t] = ACTIONS(4903),
    [sym_string] = ACTIONS(4903),
    [sym_cstring] = ACTIONS(4903),
    [sym_dstring] = ACTIONS(4903),
    [sym_wstring] = ACTIONS(4903),
    [sym_noreturn] = ACTIONS(4903),
    [sym_true] = ACTIONS(4903),
    [sym_false] = ACTIONS(4903),
    [sym_null] = ACTIONS(4903),
    [sym_super] = ACTIONS(4903),
    [sym_this] = ACTIONS(4903),
    [sym_assert] = ACTIONS(4903),
    [sym_auto] = ACTIONS(4903),
    [sym_cast] = ACTIONS(4903),
    [sym_catch] = ACTIONS(4903),
    [sym_const] = ACTIONS(4903),
    [sym_delegate] = ACTIONS(4903),
    [sym_delete] = ACTIONS(4903),
    [sym_do] = ACTIONS(4903),
    [sym_else] = ACTIONS(4903),
    [sym_finally] = ACTIONS(4903),
    [sym_function] = ACTIONS(4903),
    [sym_immutable] = ACTIONS(4903),
    [sym_import] = ACTIONS(4903),
    [sym_in] = ACTIONS(4903),
    [sym_inout] = ACTIONS(4903),
    [sym_is] = ACTIONS(4903),
    [sym_mixin] = ACTIONS(4903),
    [sym_new] = ACTIONS(4903),
    [sym_out] = ACTIONS(4903),
    [sym_ref] = ACTIONS(4903),
    [sym_shared] = ACTIONS(4903),
    [sym_throw] = ACTIONS(4903),
    [sym_typeid] = ACTIONS(4903),
    [sym_typeof] = ACTIONS(4903),
    [sym_traits] = ACTIONS(4903),
    [sym_vector] = ACTIONS(4903),
    [sym_void] = ACTIONS(4903),
    [anon_sym_BQUOTE] = ACTIONS(4905),
    [anon_sym_r_DQUOTE] = ACTIONS(4905),
    [anon_sym_x_DQUOTE] = ACTIONS(4905),
    [anon_sym_DQUOTE] = ACTIONS(4905),
    [anon_sym_i_BQUOTE] = ACTIONS(4905),
    [anon_sym_i_DQUOTE] = ACTIONS(4905),
    [anon_sym_iq_LBRACE] = ACTIONS(4905),
    [aux_sym_char_literal_token1] = ACTIONS(4905),
    [anon_sym_SQUOTE] = ACTIONS(4903),
    [anon_sym___DATE__] = ACTIONS(4903),
    [anon_sym___FILE__] = ACTIONS(4903),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4903),
    [anon_sym___FUNCTION__] = ACTIONS(4903),
    [anon_sym___LINE__] = ACTIONS(4903),
    [anon_sym___MODULE__] = ACTIONS(4903),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4903),
    [anon_sym___TIME__] = ACTIONS(4903),
    [anon_sym___TIMESTAMP__] = ACTIONS(4903),
    [anon_sym___VENDOR__] = ACTIONS(4903),
    [anon_sym___VERSION__] = ACTIONS(4903),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4905),
    [sym_float_literal] = ACTIONS(4905),
    [sym__string] = ACTIONS(4905),
  },
  [1988] = {
    [sym_identifier] = ACTIONS(4961),
    [anon_sym_q_LBRACE] = ACTIONS(4963),
    [anon_sym_LBRACE] = ACTIONS(4963),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_AMP] = ACTIONS(4963),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_DASH_DASH] = ACTIONS(4963),
    [anon_sym_PLUS] = ACTIONS(4961),
    [anon_sym_PLUS_PLUS] = ACTIONS(4963),
    [anon_sym_BANG] = ACTIONS(4963),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [anon_sym_RPAREN] = ACTIONS(4963),
    [anon_sym_LBRACK] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4963),
    [anon_sym_DOLLAR] = ACTIONS(4963),
    [anon_sym_STAR] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [sym_bool] = ACTIONS(4961),
    [sym_byte] = ACTIONS(4961),
    [sym_ubyte] = ACTIONS(4961),
    [sym_char] = ACTIONS(4961),
    [sym_short] = ACTIONS(4961),
    [sym_ushort] = ACTIONS(4961),
    [sym_int] = ACTIONS(4961),
    [sym_uint] = ACTIONS(4961),
    [sym_long] = ACTIONS(4961),
    [sym_ulong] = ACTIONS(4961),
    [sym_cent] = ACTIONS(4961),
    [sym_ucent] = ACTIONS(4961),
    [sym_wchar] = ACTIONS(4961),
    [sym_dchar] = ACTIONS(4961),
    [sym_float] = ACTIONS(4961),
    [sym_double] = ACTIONS(4961),
    [sym_real] = ACTIONS(4961),
    [sym_ifloat] = ACTIONS(4961),
    [sym_idouble] = ACTIONS(4961),
    [sym_ireal] = ACTIONS(4961),
    [sym_cfloat] = ACTIONS(4961),
    [sym_cdouble] = ACTIONS(4961),
    [sym_creal] = ACTIONS(4961),
    [sym_size_t] = ACTIONS(4961),
    [sym_ptrdiff_t] = ACTIONS(4961),
    [sym_string] = ACTIONS(4961),
    [sym_cstring] = ACTIONS(4961),
    [sym_dstring] = ACTIONS(4961),
    [sym_wstring] = ACTIONS(4961),
    [sym_noreturn] = ACTIONS(4961),
    [sym_true] = ACTIONS(4961),
    [sym_false] = ACTIONS(4961),
    [sym_null] = ACTIONS(4961),
    [sym_super] = ACTIONS(4961),
    [sym_this] = ACTIONS(4961),
    [sym_assert] = ACTIONS(4961),
    [sym_auto] = ACTIONS(4961),
    [sym_cast] = ACTIONS(4961),
    [sym_catch] = ACTIONS(4961),
    [sym_const] = ACTIONS(4961),
    [sym_delegate] = ACTIONS(4961),
    [sym_delete] = ACTIONS(4961),
    [sym_do] = ACTIONS(4961),
    [sym_else] = ACTIONS(4961),
    [sym_finally] = ACTIONS(4961),
    [sym_function] = ACTIONS(4961),
    [sym_immutable] = ACTIONS(4961),
    [sym_import] = ACTIONS(4961),
    [sym_in] = ACTIONS(4961),
    [sym_inout] = ACTIONS(4961),
    [sym_is] = ACTIONS(4961),
    [sym_mixin] = ACTIONS(4961),
    [sym_new] = ACTIONS(4961),
    [sym_out] = ACTIONS(4961),
    [sym_ref] = ACTIONS(4961),
    [sym_shared] = ACTIONS(4961),
    [sym_throw] = ACTIONS(4961),
    [sym_typeid] = ACTIONS(4961),
    [sym_typeof] = ACTIONS(4961),
    [sym_traits] = ACTIONS(4961),
    [sym_vector] = ACTIONS(4961),
    [sym_void] = ACTIONS(4961),
    [anon_sym_BQUOTE] = ACTIONS(4963),
    [anon_sym_r_DQUOTE] = ACTIONS(4963),
    [anon_sym_x_DQUOTE] = ACTIONS(4963),
    [anon_sym_DQUOTE] = ACTIONS(4963),
    [anon_sym_i_BQUOTE] = ACTIONS(4963),
    [anon_sym_i_DQUOTE] = ACTIONS(4963),
    [anon_sym_iq_LBRACE] = ACTIONS(4963),
    [aux_sym_char_literal_token1] = ACTIONS(4963),
    [anon_sym_SQUOTE] = ACTIONS(4961),
    [anon_sym___DATE__] = ACTIONS(4961),
    [anon_sym___FILE__] = ACTIONS(4961),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4961),
    [anon_sym___FUNCTION__] = ACTIONS(4961),
    [anon_sym___LINE__] = ACTIONS(4961),
    [anon_sym___MODULE__] = ACTIONS(4961),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4961),
    [anon_sym___TIME__] = ACTIONS(4961),
    [anon_sym___TIMESTAMP__] = ACTIONS(4961),
    [anon_sym___VENDOR__] = ACTIONS(4961),
    [anon_sym___VERSION__] = ACTIONS(4961),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4963),
    [sym_float_literal] = ACTIONS(4963),
    [sym__string] = ACTIONS(4963),
  },
  [1989] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_q_LBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_AMP] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3163),
    [anon_sym_DASH_DASH] = ACTIONS(3165),
    [anon_sym_PLUS] = ACTIONS(3163),
    [anon_sym_PLUS_PLUS] = ACTIONS(3165),
    [anon_sym_BANG] = ACTIONS(3165),
    [anon_sym_LPAREN] = ACTIONS(3165),
    [anon_sym_RPAREN] = ACTIONS(3165),
    [anon_sym_LBRACK] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_true] = ACTIONS(3163),
    [sym_false] = ACTIONS(3163),
    [sym_null] = ACTIONS(3163),
    [sym_super] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_assert] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_cast] = ACTIONS(3163),
    [sym_catch] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_delegate] = ACTIONS(3163),
    [sym_delete] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_finally] = ACTIONS(3163),
    [sym_function] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_is] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_new] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_throw] = ACTIONS(3163),
    [sym_typeid] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [anon_sym_BQUOTE] = ACTIONS(3165),
    [anon_sym_r_DQUOTE] = ACTIONS(3165),
    [anon_sym_x_DQUOTE] = ACTIONS(3165),
    [anon_sym_DQUOTE] = ACTIONS(3165),
    [anon_sym_i_BQUOTE] = ACTIONS(3165),
    [anon_sym_i_DQUOTE] = ACTIONS(3165),
    [anon_sym_iq_LBRACE] = ACTIONS(3165),
    [aux_sym_char_literal_token1] = ACTIONS(3165),
    [anon_sym_SQUOTE] = ACTIONS(3163),
    [anon_sym___DATE__] = ACTIONS(3163),
    [anon_sym___FILE__] = ACTIONS(3163),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3163),
    [anon_sym___FUNCTION__] = ACTIONS(3163),
    [anon_sym___LINE__] = ACTIONS(3163),
    [anon_sym___MODULE__] = ACTIONS(3163),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3163),
    [anon_sym___TIME__] = ACTIONS(3163),
    [anon_sym___TIMESTAMP__] = ACTIONS(3163),
    [anon_sym___VENDOR__] = ACTIONS(3163),
    [anon_sym___VERSION__] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3165),
    [sym_float_literal] = ACTIONS(3165),
    [sym__string] = ACTIONS(3165),
  },
  [1990] = {
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_q_LBRACE] = ACTIONS(4923),
    [anon_sym_LBRACE] = ACTIONS(4923),
    [anon_sym_DOT] = ACTIONS(4923),
    [anon_sym_AMP] = ACTIONS(4923),
    [anon_sym_DASH] = ACTIONS(4921),
    [anon_sym_DASH_DASH] = ACTIONS(4923),
    [anon_sym_PLUS] = ACTIONS(4921),
    [anon_sym_PLUS_PLUS] = ACTIONS(4923),
    [anon_sym_BANG] = ACTIONS(4923),
    [anon_sym_LPAREN] = ACTIONS(4923),
    [anon_sym_RPAREN] = ACTIONS(4923),
    [anon_sym_LBRACK] = ACTIONS(4923),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym_DOLLAR] = ACTIONS(4923),
    [anon_sym_STAR] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4923),
    [sym_bool] = ACTIONS(4921),
    [sym_byte] = ACTIONS(4921),
    [sym_ubyte] = ACTIONS(4921),
    [sym_char] = ACTIONS(4921),
    [sym_short] = ACTIONS(4921),
    [sym_ushort] = ACTIONS(4921),
    [sym_int] = ACTIONS(4921),
    [sym_uint] = ACTIONS(4921),
    [sym_long] = ACTIONS(4921),
    [sym_ulong] = ACTIONS(4921),
    [sym_cent] = ACTIONS(4921),
    [sym_ucent] = ACTIONS(4921),
    [sym_wchar] = ACTIONS(4921),
    [sym_dchar] = ACTIONS(4921),
    [sym_float] = ACTIONS(4921),
    [sym_double] = ACTIONS(4921),
    [sym_real] = ACTIONS(4921),
    [sym_ifloat] = ACTIONS(4921),
    [sym_idouble] = ACTIONS(4921),
    [sym_ireal] = ACTIONS(4921),
    [sym_cfloat] = ACTIONS(4921),
    [sym_cdouble] = ACTIONS(4921),
    [sym_creal] = ACTIONS(4921),
    [sym_size_t] = ACTIONS(4921),
    [sym_ptrdiff_t] = ACTIONS(4921),
    [sym_string] = ACTIONS(4921),
    [sym_cstring] = ACTIONS(4921),
    [sym_dstring] = ACTIONS(4921),
    [sym_wstring] = ACTIONS(4921),
    [sym_noreturn] = ACTIONS(4921),
    [sym_true] = ACTIONS(4921),
    [sym_false] = ACTIONS(4921),
    [sym_null] = ACTIONS(4921),
    [sym_super] = ACTIONS(4921),
    [sym_this] = ACTIONS(4921),
    [sym_assert] = ACTIONS(4921),
    [sym_auto] = ACTIONS(4921),
    [sym_cast] = ACTIONS(4921),
    [sym_catch] = ACTIONS(4921),
    [sym_const] = ACTIONS(4921),
    [sym_delegate] = ACTIONS(4921),
    [sym_delete] = ACTIONS(4921),
    [sym_do] = ACTIONS(4921),
    [sym_else] = ACTIONS(4921),
    [sym_finally] = ACTIONS(4921),
    [sym_function] = ACTIONS(4921),
    [sym_immutable] = ACTIONS(4921),
    [sym_import] = ACTIONS(4921),
    [sym_in] = ACTIONS(4921),
    [sym_inout] = ACTIONS(4921),
    [sym_is] = ACTIONS(4921),
    [sym_mixin] = ACTIONS(4921),
    [sym_new] = ACTIONS(4921),
    [sym_out] = ACTIONS(4921),
    [sym_ref] = ACTIONS(4921),
    [sym_shared] = ACTIONS(4921),
    [sym_throw] = ACTIONS(4921),
    [sym_typeid] = ACTIONS(4921),
    [sym_typeof] = ACTIONS(4921),
    [sym_traits] = ACTIONS(4921),
    [sym_vector] = ACTIONS(4921),
    [sym_void] = ACTIONS(4921),
    [anon_sym_BQUOTE] = ACTIONS(4923),
    [anon_sym_r_DQUOTE] = ACTIONS(4923),
    [anon_sym_x_DQUOTE] = ACTIONS(4923),
    [anon_sym_DQUOTE] = ACTIONS(4923),
    [anon_sym_i_BQUOTE] = ACTIONS(4923),
    [anon_sym_i_DQUOTE] = ACTIONS(4923),
    [anon_sym_iq_LBRACE] = ACTIONS(4923),
    [aux_sym_char_literal_token1] = ACTIONS(4923),
    [anon_sym_SQUOTE] = ACTIONS(4921),
    [anon_sym___DATE__] = ACTIONS(4921),
    [anon_sym___FILE__] = ACTIONS(4921),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4921),
    [anon_sym___FUNCTION__] = ACTIONS(4921),
    [anon_sym___LINE__] = ACTIONS(4921),
    [anon_sym___MODULE__] = ACTIONS(4921),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4921),
    [anon_sym___TIME__] = ACTIONS(4921),
    [anon_sym___TIMESTAMP__] = ACTIONS(4921),
    [anon_sym___VENDOR__] = ACTIONS(4921),
    [anon_sym___VERSION__] = ACTIONS(4921),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4923),
    [sym_float_literal] = ACTIONS(4923),
    [sym__string] = ACTIONS(4923),
  },
  [1991] = {
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_q_LBRACE] = ACTIONS(4927),
    [anon_sym_LBRACE] = ACTIONS(4927),
    [anon_sym_DOT] = ACTIONS(4927),
    [anon_sym_AMP] = ACTIONS(4927),
    [anon_sym_DASH] = ACTIONS(4925),
    [anon_sym_DASH_DASH] = ACTIONS(4927),
    [anon_sym_PLUS] = ACTIONS(4925),
    [anon_sym_PLUS_PLUS] = ACTIONS(4927),
    [anon_sym_BANG] = ACTIONS(4927),
    [anon_sym_LPAREN] = ACTIONS(4927),
    [anon_sym_RPAREN] = ACTIONS(4927),
    [anon_sym_LBRACK] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_DOLLAR] = ACTIONS(4927),
    [anon_sym_STAR] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4927),
    [sym_bool] = ACTIONS(4925),
    [sym_byte] = ACTIONS(4925),
    [sym_ubyte] = ACTIONS(4925),
    [sym_char] = ACTIONS(4925),
    [sym_short] = ACTIONS(4925),
    [sym_ushort] = ACTIONS(4925),
    [sym_int] = ACTIONS(4925),
    [sym_uint] = ACTIONS(4925),
    [sym_long] = ACTIONS(4925),
    [sym_ulong] = ACTIONS(4925),
    [sym_cent] = ACTIONS(4925),
    [sym_ucent] = ACTIONS(4925),
    [sym_wchar] = ACTIONS(4925),
    [sym_dchar] = ACTIONS(4925),
    [sym_float] = ACTIONS(4925),
    [sym_double] = ACTIONS(4925),
    [sym_real] = ACTIONS(4925),
    [sym_ifloat] = ACTIONS(4925),
    [sym_idouble] = ACTIONS(4925),
    [sym_ireal] = ACTIONS(4925),
    [sym_cfloat] = ACTIONS(4925),
    [sym_cdouble] = ACTIONS(4925),
    [sym_creal] = ACTIONS(4925),
    [sym_size_t] = ACTIONS(4925),
    [sym_ptrdiff_t] = ACTIONS(4925),
    [sym_string] = ACTIONS(4925),
    [sym_cstring] = ACTIONS(4925),
    [sym_dstring] = ACTIONS(4925),
    [sym_wstring] = ACTIONS(4925),
    [sym_noreturn] = ACTIONS(4925),
    [sym_true] = ACTIONS(4925),
    [sym_false] = ACTIONS(4925),
    [sym_null] = ACTIONS(4925),
    [sym_super] = ACTIONS(4925),
    [sym_this] = ACTIONS(4925),
    [sym_assert] = ACTIONS(4925),
    [sym_auto] = ACTIONS(4925),
    [sym_cast] = ACTIONS(4925),
    [sym_catch] = ACTIONS(4925),
    [sym_const] = ACTIONS(4925),
    [sym_delegate] = ACTIONS(4925),
    [sym_delete] = ACTIONS(4925),
    [sym_do] = ACTIONS(4925),
    [sym_else] = ACTIONS(4925),
    [sym_finally] = ACTIONS(4925),
    [sym_function] = ACTIONS(4925),
    [sym_immutable] = ACTIONS(4925),
    [sym_import] = ACTIONS(4925),
    [sym_in] = ACTIONS(4925),
    [sym_inout] = ACTIONS(4925),
    [sym_is] = ACTIONS(4925),
    [sym_mixin] = ACTIONS(4925),
    [sym_new] = ACTIONS(4925),
    [sym_out] = ACTIONS(4925),
    [sym_ref] = ACTIONS(4925),
    [sym_shared] = ACTIONS(4925),
    [sym_throw] = ACTIONS(4925),
    [sym_typeid] = ACTIONS(4925),
    [sym_typeof] = ACTIONS(4925),
    [sym_traits] = ACTIONS(4925),
    [sym_vector] = ACTIONS(4925),
    [sym_void] = ACTIONS(4925),
    [anon_sym_BQUOTE] = ACTIONS(4927),
    [anon_sym_r_DQUOTE] = ACTIONS(4927),
    [anon_sym_x_DQUOTE] = ACTIONS(4927),
    [anon_sym_DQUOTE] = ACTIONS(4927),
    [anon_sym_i_BQUOTE] = ACTIONS(4927),
    [anon_sym_i_DQUOTE] = ACTIONS(4927),
    [anon_sym_iq_LBRACE] = ACTIONS(4927),
    [aux_sym_char_literal_token1] = ACTIONS(4927),
    [anon_sym_SQUOTE] = ACTIONS(4925),
    [anon_sym___DATE__] = ACTIONS(4925),
    [anon_sym___FILE__] = ACTIONS(4925),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4925),
    [anon_sym___FUNCTION__] = ACTIONS(4925),
    [anon_sym___LINE__] = ACTIONS(4925),
    [anon_sym___MODULE__] = ACTIONS(4925),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4925),
    [anon_sym___TIME__] = ACTIONS(4925),
    [anon_sym___TIMESTAMP__] = ACTIONS(4925),
    [anon_sym___VENDOR__] = ACTIONS(4925),
    [anon_sym___VERSION__] = ACTIONS(4925),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4927),
    [sym_float_literal] = ACTIONS(4927),
    [sym__string] = ACTIONS(4927),
  },
  [1992] = {
    [sym_identifier] = ACTIONS(4929),
    [anon_sym_q_LBRACE] = ACTIONS(4931),
    [anon_sym_LBRACE] = ACTIONS(4931),
    [anon_sym_DOT] = ACTIONS(4931),
    [anon_sym_AMP] = ACTIONS(4931),
    [anon_sym_DASH] = ACTIONS(4929),
    [anon_sym_DASH_DASH] = ACTIONS(4931),
    [anon_sym_PLUS] = ACTIONS(4929),
    [anon_sym_PLUS_PLUS] = ACTIONS(4931),
    [anon_sym_BANG] = ACTIONS(4931),
    [anon_sym_LPAREN] = ACTIONS(4931),
    [anon_sym_RPAREN] = ACTIONS(4931),
    [anon_sym_LBRACK] = ACTIONS(4931),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_DOLLAR] = ACTIONS(4931),
    [anon_sym_STAR] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4931),
    [sym_bool] = ACTIONS(4929),
    [sym_byte] = ACTIONS(4929),
    [sym_ubyte] = ACTIONS(4929),
    [sym_char] = ACTIONS(4929),
    [sym_short] = ACTIONS(4929),
    [sym_ushort] = ACTIONS(4929),
    [sym_int] = ACTIONS(4929),
    [sym_uint] = ACTIONS(4929),
    [sym_long] = ACTIONS(4929),
    [sym_ulong] = ACTIONS(4929),
    [sym_cent] = ACTIONS(4929),
    [sym_ucent] = ACTIONS(4929),
    [sym_wchar] = ACTIONS(4929),
    [sym_dchar] = ACTIONS(4929),
    [sym_float] = ACTIONS(4929),
    [sym_double] = ACTIONS(4929),
    [sym_real] = ACTIONS(4929),
    [sym_ifloat] = ACTIONS(4929),
    [sym_idouble] = ACTIONS(4929),
    [sym_ireal] = ACTIONS(4929),
    [sym_cfloat] = ACTIONS(4929),
    [sym_cdouble] = ACTIONS(4929),
    [sym_creal] = ACTIONS(4929),
    [sym_size_t] = ACTIONS(4929),
    [sym_ptrdiff_t] = ACTIONS(4929),
    [sym_string] = ACTIONS(4929),
    [sym_cstring] = ACTIONS(4929),
    [sym_dstring] = ACTIONS(4929),
    [sym_wstring] = ACTIONS(4929),
    [sym_noreturn] = ACTIONS(4929),
    [sym_true] = ACTIONS(4929),
    [sym_false] = ACTIONS(4929),
    [sym_null] = ACTIONS(4929),
    [sym_super] = ACTIONS(4929),
    [sym_this] = ACTIONS(4929),
    [sym_assert] = ACTIONS(4929),
    [sym_auto] = ACTIONS(4929),
    [sym_cast] = ACTIONS(4929),
    [sym_catch] = ACTIONS(4929),
    [sym_const] = ACTIONS(4929),
    [sym_delegate] = ACTIONS(4929),
    [sym_delete] = ACTIONS(4929),
    [sym_do] = ACTIONS(4929),
    [sym_else] = ACTIONS(4929),
    [sym_finally] = ACTIONS(4929),
    [sym_function] = ACTIONS(4929),
    [sym_immutable] = ACTIONS(4929),
    [sym_import] = ACTIONS(4929),
    [sym_in] = ACTIONS(4929),
    [sym_inout] = ACTIONS(4929),
    [sym_is] = ACTIONS(4929),
    [sym_mixin] = ACTIONS(4929),
    [sym_new] = ACTIONS(4929),
    [sym_out] = ACTIONS(4929),
    [sym_ref] = ACTIONS(4929),
    [sym_shared] = ACTIONS(4929),
    [sym_throw] = ACTIONS(4929),
    [sym_typeid] = ACTIONS(4929),
    [sym_typeof] = ACTIONS(4929),
    [sym_traits] = ACTIONS(4929),
    [sym_vector] = ACTIONS(4929),
    [sym_void] = ACTIONS(4929),
    [anon_sym_BQUOTE] = ACTIONS(4931),
    [anon_sym_r_DQUOTE] = ACTIONS(4931),
    [anon_sym_x_DQUOTE] = ACTIONS(4931),
    [anon_sym_DQUOTE] = ACTIONS(4931),
    [anon_sym_i_BQUOTE] = ACTIONS(4931),
    [anon_sym_i_DQUOTE] = ACTIONS(4931),
    [anon_sym_iq_LBRACE] = ACTIONS(4931),
    [aux_sym_char_literal_token1] = ACTIONS(4931),
    [anon_sym_SQUOTE] = ACTIONS(4929),
    [anon_sym___DATE__] = ACTIONS(4929),
    [anon_sym___FILE__] = ACTIONS(4929),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4929),
    [anon_sym___FUNCTION__] = ACTIONS(4929),
    [anon_sym___LINE__] = ACTIONS(4929),
    [anon_sym___MODULE__] = ACTIONS(4929),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4929),
    [anon_sym___TIME__] = ACTIONS(4929),
    [anon_sym___TIMESTAMP__] = ACTIONS(4929),
    [anon_sym___VENDOR__] = ACTIONS(4929),
    [anon_sym___VERSION__] = ACTIONS(4929),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4931),
    [sym_float_literal] = ACTIONS(4931),
    [sym__string] = ACTIONS(4931),
  },
  [1993] = {
    [sym_identifier] = ACTIONS(4354),
    [anon_sym_q_LBRACE] = ACTIONS(4356),
    [anon_sym_LBRACE] = ACTIONS(4356),
    [anon_sym_DOT] = ACTIONS(4356),
    [anon_sym_AMP] = ACTIONS(4356),
    [anon_sym_DASH] = ACTIONS(4354),
    [anon_sym_DASH_DASH] = ACTIONS(4356),
    [anon_sym_PLUS] = ACTIONS(4354),
    [anon_sym_PLUS_PLUS] = ACTIONS(4356),
    [anon_sym_BANG] = ACTIONS(4356),
    [anon_sym_LPAREN] = ACTIONS(4356),
    [anon_sym_RPAREN] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(4356),
    [anon_sym_SEMI] = ACTIONS(4356),
    [anon_sym_DOLLAR] = ACTIONS(4356),
    [anon_sym_STAR] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4356),
    [sym_bool] = ACTIONS(4354),
    [sym_byte] = ACTIONS(4354),
    [sym_ubyte] = ACTIONS(4354),
    [sym_char] = ACTIONS(4354),
    [sym_short] = ACTIONS(4354),
    [sym_ushort] = ACTIONS(4354),
    [sym_int] = ACTIONS(4354),
    [sym_uint] = ACTIONS(4354),
    [sym_long] = ACTIONS(4354),
    [sym_ulong] = ACTIONS(4354),
    [sym_cent] = ACTIONS(4354),
    [sym_ucent] = ACTIONS(4354),
    [sym_wchar] = ACTIONS(4354),
    [sym_dchar] = ACTIONS(4354),
    [sym_float] = ACTIONS(4354),
    [sym_double] = ACTIONS(4354),
    [sym_real] = ACTIONS(4354),
    [sym_ifloat] = ACTIONS(4354),
    [sym_idouble] = ACTIONS(4354),
    [sym_ireal] = ACTIONS(4354),
    [sym_cfloat] = ACTIONS(4354),
    [sym_cdouble] = ACTIONS(4354),
    [sym_creal] = ACTIONS(4354),
    [sym_size_t] = ACTIONS(4354),
    [sym_ptrdiff_t] = ACTIONS(4354),
    [sym_string] = ACTIONS(4354),
    [sym_cstring] = ACTIONS(4354),
    [sym_dstring] = ACTIONS(4354),
    [sym_wstring] = ACTIONS(4354),
    [sym_noreturn] = ACTIONS(4354),
    [sym_true] = ACTIONS(4354),
    [sym_false] = ACTIONS(4354),
    [sym_null] = ACTIONS(4354),
    [sym_super] = ACTIONS(4354),
    [sym_this] = ACTIONS(4354),
    [sym_assert] = ACTIONS(4354),
    [sym_auto] = ACTIONS(4354),
    [sym_cast] = ACTIONS(4354),
    [sym_catch] = ACTIONS(4354),
    [sym_const] = ACTIONS(4354),
    [sym_delegate] = ACTIONS(4354),
    [sym_delete] = ACTIONS(4354),
    [sym_do] = ACTIONS(4354),
    [sym_else] = ACTIONS(4354),
    [sym_finally] = ACTIONS(4354),
    [sym_function] = ACTIONS(4354),
    [sym_immutable] = ACTIONS(4354),
    [sym_import] = ACTIONS(4354),
    [sym_in] = ACTIONS(4354),
    [sym_inout] = ACTIONS(4354),
    [sym_is] = ACTIONS(4354),
    [sym_mixin] = ACTIONS(4354),
    [sym_new] = ACTIONS(4354),
    [sym_out] = ACTIONS(4354),
    [sym_ref] = ACTIONS(4354),
    [sym_shared] = ACTIONS(4354),
    [sym_throw] = ACTIONS(4354),
    [sym_typeid] = ACTIONS(4354),
    [sym_typeof] = ACTIONS(4354),
    [sym_traits] = ACTIONS(4354),
    [sym_vector] = ACTIONS(4354),
    [sym_void] = ACTIONS(4354),
    [anon_sym_BQUOTE] = ACTIONS(4356),
    [anon_sym_r_DQUOTE] = ACTIONS(4356),
    [anon_sym_x_DQUOTE] = ACTIONS(4356),
    [anon_sym_DQUOTE] = ACTIONS(4356),
    [anon_sym_i_BQUOTE] = ACTIONS(4356),
    [anon_sym_i_DQUOTE] = ACTIONS(4356),
    [anon_sym_iq_LBRACE] = ACTIONS(4356),
    [aux_sym_char_literal_token1] = ACTIONS(4356),
    [anon_sym_SQUOTE] = ACTIONS(4354),
    [anon_sym___DATE__] = ACTIONS(4354),
    [anon_sym___FILE__] = ACTIONS(4354),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4354),
    [anon_sym___FUNCTION__] = ACTIONS(4354),
    [anon_sym___LINE__] = ACTIONS(4354),
    [anon_sym___MODULE__] = ACTIONS(4354),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4354),
    [anon_sym___TIME__] = ACTIONS(4354),
    [anon_sym___TIMESTAMP__] = ACTIONS(4354),
    [anon_sym___VENDOR__] = ACTIONS(4354),
    [anon_sym___VERSION__] = ACTIONS(4354),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4356),
    [sym_float_literal] = ACTIONS(4356),
    [sym__string] = ACTIONS(4356),
  },
  [1994] = {
    [sym_identifier] = ACTIONS(4821),
    [anon_sym_q_LBRACE] = ACTIONS(4823),
    [anon_sym_LBRACE] = ACTIONS(4823),
    [anon_sym_DOT] = ACTIONS(4823),
    [anon_sym_AMP] = ACTIONS(4823),
    [anon_sym_DASH] = ACTIONS(4821),
    [anon_sym_DASH_DASH] = ACTIONS(4823),
    [anon_sym_PLUS] = ACTIONS(4821),
    [anon_sym_PLUS_PLUS] = ACTIONS(4823),
    [anon_sym_BANG] = ACTIONS(4823),
    [anon_sym_LPAREN] = ACTIONS(4823),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [anon_sym_LBRACK] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_DOLLAR] = ACTIONS(4823),
    [anon_sym_STAR] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4823),
    [sym_bool] = ACTIONS(4821),
    [sym_byte] = ACTIONS(4821),
    [sym_ubyte] = ACTIONS(4821),
    [sym_char] = ACTIONS(4821),
    [sym_short] = ACTIONS(4821),
    [sym_ushort] = ACTIONS(4821),
    [sym_int] = ACTIONS(4821),
    [sym_uint] = ACTIONS(4821),
    [sym_long] = ACTIONS(4821),
    [sym_ulong] = ACTIONS(4821),
    [sym_cent] = ACTIONS(4821),
    [sym_ucent] = ACTIONS(4821),
    [sym_wchar] = ACTIONS(4821),
    [sym_dchar] = ACTIONS(4821),
    [sym_float] = ACTIONS(4821),
    [sym_double] = ACTIONS(4821),
    [sym_real] = ACTIONS(4821),
    [sym_ifloat] = ACTIONS(4821),
    [sym_idouble] = ACTIONS(4821),
    [sym_ireal] = ACTIONS(4821),
    [sym_cfloat] = ACTIONS(4821),
    [sym_cdouble] = ACTIONS(4821),
    [sym_creal] = ACTIONS(4821),
    [sym_size_t] = ACTIONS(4821),
    [sym_ptrdiff_t] = ACTIONS(4821),
    [sym_string] = ACTIONS(4821),
    [sym_cstring] = ACTIONS(4821),
    [sym_dstring] = ACTIONS(4821),
    [sym_wstring] = ACTIONS(4821),
    [sym_noreturn] = ACTIONS(4821),
    [sym_true] = ACTIONS(4821),
    [sym_false] = ACTIONS(4821),
    [sym_null] = ACTIONS(4821),
    [sym_super] = ACTIONS(4821),
    [sym_this] = ACTIONS(4821),
    [sym_assert] = ACTIONS(4821),
    [sym_auto] = ACTIONS(4821),
    [sym_cast] = ACTIONS(4821),
    [sym_catch] = ACTIONS(4821),
    [sym_const] = ACTIONS(4821),
    [sym_delegate] = ACTIONS(4821),
    [sym_delete] = ACTIONS(4821),
    [sym_do] = ACTIONS(4821),
    [sym_else] = ACTIONS(4821),
    [sym_finally] = ACTIONS(4821),
    [sym_function] = ACTIONS(4821),
    [sym_immutable] = ACTIONS(4821),
    [sym_import] = ACTIONS(4821),
    [sym_in] = ACTIONS(4821),
    [sym_inout] = ACTIONS(4821),
    [sym_is] = ACTIONS(4821),
    [sym_mixin] = ACTIONS(4821),
    [sym_new] = ACTIONS(4821),
    [sym_out] = ACTIONS(4821),
    [sym_ref] = ACTIONS(4821),
    [sym_shared] = ACTIONS(4821),
    [sym_throw] = ACTIONS(4821),
    [sym_typeid] = ACTIONS(4821),
    [sym_typeof] = ACTIONS(4821),
    [sym_traits] = ACTIONS(4821),
    [sym_vector] = ACTIONS(4821),
    [sym_void] = ACTIONS(4821),
    [anon_sym_BQUOTE] = ACTIONS(4823),
    [anon_sym_r_DQUOTE] = ACTIONS(4823),
    [anon_sym_x_DQUOTE] = ACTIONS(4823),
    [anon_sym_DQUOTE] = ACTIONS(4823),
    [anon_sym_i_BQUOTE] = ACTIONS(4823),
    [anon_sym_i_DQUOTE] = ACTIONS(4823),
    [anon_sym_iq_LBRACE] = ACTIONS(4823),
    [aux_sym_char_literal_token1] = ACTIONS(4823),
    [anon_sym_SQUOTE] = ACTIONS(4821),
    [anon_sym___DATE__] = ACTIONS(4821),
    [anon_sym___FILE__] = ACTIONS(4821),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4821),
    [anon_sym___FUNCTION__] = ACTIONS(4821),
    [anon_sym___LINE__] = ACTIONS(4821),
    [anon_sym___MODULE__] = ACTIONS(4821),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4821),
    [anon_sym___TIME__] = ACTIONS(4821),
    [anon_sym___TIMESTAMP__] = ACTIONS(4821),
    [anon_sym___VENDOR__] = ACTIONS(4821),
    [anon_sym___VERSION__] = ACTIONS(4821),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4823),
    [sym_float_literal] = ACTIONS(4823),
    [sym__string] = ACTIONS(4823),
  },
  [1995] = {
    [sym_identifier] = ACTIONS(4817),
    [anon_sym_q_LBRACE] = ACTIONS(4819),
    [anon_sym_LBRACE] = ACTIONS(4819),
    [anon_sym_DOT] = ACTIONS(4819),
    [anon_sym_AMP] = ACTIONS(4819),
    [anon_sym_DASH] = ACTIONS(4817),
    [anon_sym_DASH_DASH] = ACTIONS(4819),
    [anon_sym_PLUS] = ACTIONS(4817),
    [anon_sym_PLUS_PLUS] = ACTIONS(4819),
    [anon_sym_BANG] = ACTIONS(4819),
    [anon_sym_LPAREN] = ACTIONS(4819),
    [anon_sym_RPAREN] = ACTIONS(4819),
    [anon_sym_LBRACK] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_DOLLAR] = ACTIONS(4819),
    [anon_sym_STAR] = ACTIONS(4819),
    [anon_sym_TILDE] = ACTIONS(4819),
    [sym_bool] = ACTIONS(4817),
    [sym_byte] = ACTIONS(4817),
    [sym_ubyte] = ACTIONS(4817),
    [sym_char] = ACTIONS(4817),
    [sym_short] = ACTIONS(4817),
    [sym_ushort] = ACTIONS(4817),
    [sym_int] = ACTIONS(4817),
    [sym_uint] = ACTIONS(4817),
    [sym_long] = ACTIONS(4817),
    [sym_ulong] = ACTIONS(4817),
    [sym_cent] = ACTIONS(4817),
    [sym_ucent] = ACTIONS(4817),
    [sym_wchar] = ACTIONS(4817),
    [sym_dchar] = ACTIONS(4817),
    [sym_float] = ACTIONS(4817),
    [sym_double] = ACTIONS(4817),
    [sym_real] = ACTIONS(4817),
    [sym_ifloat] = ACTIONS(4817),
    [sym_idouble] = ACTIONS(4817),
    [sym_ireal] = ACTIONS(4817),
    [sym_cfloat] = ACTIONS(4817),
    [sym_cdouble] = ACTIONS(4817),
    [sym_creal] = ACTIONS(4817),
    [sym_size_t] = ACTIONS(4817),
    [sym_ptrdiff_t] = ACTIONS(4817),
    [sym_string] = ACTIONS(4817),
    [sym_cstring] = ACTIONS(4817),
    [sym_dstring] = ACTIONS(4817),
    [sym_wstring] = ACTIONS(4817),
    [sym_noreturn] = ACTIONS(4817),
    [sym_true] = ACTIONS(4817),
    [sym_false] = ACTIONS(4817),
    [sym_null] = ACTIONS(4817),
    [sym_super] = ACTIONS(4817),
    [sym_this] = ACTIONS(4817),
    [sym_assert] = ACTIONS(4817),
    [sym_auto] = ACTIONS(4817),
    [sym_cast] = ACTIONS(4817),
    [sym_catch] = ACTIONS(4817),
    [sym_const] = ACTIONS(4817),
    [sym_delegate] = ACTIONS(4817),
    [sym_delete] = ACTIONS(4817),
    [sym_do] = ACTIONS(4817),
    [sym_else] = ACTIONS(4817),
    [sym_finally] = ACTIONS(4817),
    [sym_function] = ACTIONS(4817),
    [sym_immutable] = ACTIONS(4817),
    [sym_import] = ACTIONS(4817),
    [sym_in] = ACTIONS(4817),
    [sym_inout] = ACTIONS(4817),
    [sym_is] = ACTIONS(4817),
    [sym_mixin] = ACTIONS(4817),
    [sym_new] = ACTIONS(4817),
    [sym_out] = ACTIONS(4817),
    [sym_ref] = ACTIONS(4817),
    [sym_shared] = ACTIONS(4817),
    [sym_throw] = ACTIONS(4817),
    [sym_typeid] = ACTIONS(4817),
    [sym_typeof] = ACTIONS(4817),
    [sym_traits] = ACTIONS(4817),
    [sym_vector] = ACTIONS(4817),
    [sym_void] = ACTIONS(4817),
    [anon_sym_BQUOTE] = ACTIONS(4819),
    [anon_sym_r_DQUOTE] = ACTIONS(4819),
    [anon_sym_x_DQUOTE] = ACTIONS(4819),
    [anon_sym_DQUOTE] = ACTIONS(4819),
    [anon_sym_i_BQUOTE] = ACTIONS(4819),
    [anon_sym_i_DQUOTE] = ACTIONS(4819),
    [anon_sym_iq_LBRACE] = ACTIONS(4819),
    [aux_sym_char_literal_token1] = ACTIONS(4819),
    [anon_sym_SQUOTE] = ACTIONS(4817),
    [anon_sym___DATE__] = ACTIONS(4817),
    [anon_sym___FILE__] = ACTIONS(4817),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4817),
    [anon_sym___FUNCTION__] = ACTIONS(4817),
    [anon_sym___LINE__] = ACTIONS(4817),
    [anon_sym___MODULE__] = ACTIONS(4817),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4817),
    [anon_sym___TIME__] = ACTIONS(4817),
    [anon_sym___TIMESTAMP__] = ACTIONS(4817),
    [anon_sym___VENDOR__] = ACTIONS(4817),
    [anon_sym___VERSION__] = ACTIONS(4817),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4819),
    [sym_float_literal] = ACTIONS(4819),
    [sym__string] = ACTIONS(4819),
  },
  [1996] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_q_LBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_AMP] = ACTIONS(3129),
    [anon_sym_DASH] = ACTIONS(3127),
    [anon_sym_DASH_DASH] = ACTIONS(3129),
    [anon_sym_PLUS] = ACTIONS(3127),
    [anon_sym_PLUS_PLUS] = ACTIONS(3129),
    [anon_sym_BANG] = ACTIONS(3129),
    [anon_sym_LPAREN] = ACTIONS(3129),
    [anon_sym_RPAREN] = ACTIONS(3129),
    [anon_sym_LBRACK] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_DOLLAR] = ACTIONS(3129),
    [anon_sym_STAR] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_true] = ACTIONS(3127),
    [sym_false] = ACTIONS(3127),
    [sym_null] = ACTIONS(3127),
    [sym_super] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_assert] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_cast] = ACTIONS(3127),
    [sym_catch] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_delegate] = ACTIONS(3127),
    [sym_delete] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_finally] = ACTIONS(3127),
    [sym_function] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_is] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_new] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_throw] = ACTIONS(3127),
    [sym_typeid] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [anon_sym_BQUOTE] = ACTIONS(3129),
    [anon_sym_r_DQUOTE] = ACTIONS(3129),
    [anon_sym_x_DQUOTE] = ACTIONS(3129),
    [anon_sym_DQUOTE] = ACTIONS(3129),
    [anon_sym_i_BQUOTE] = ACTIONS(3129),
    [anon_sym_i_DQUOTE] = ACTIONS(3129),
    [anon_sym_iq_LBRACE] = ACTIONS(3129),
    [aux_sym_char_literal_token1] = ACTIONS(3129),
    [anon_sym_SQUOTE] = ACTIONS(3127),
    [anon_sym___DATE__] = ACTIONS(3127),
    [anon_sym___FILE__] = ACTIONS(3127),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3127),
    [anon_sym___FUNCTION__] = ACTIONS(3127),
    [anon_sym___LINE__] = ACTIONS(3127),
    [anon_sym___MODULE__] = ACTIONS(3127),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3127),
    [anon_sym___TIME__] = ACTIONS(3127),
    [anon_sym___TIMESTAMP__] = ACTIONS(3127),
    [anon_sym___VENDOR__] = ACTIONS(3127),
    [anon_sym___VERSION__] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(3129),
    [sym_float_literal] = ACTIONS(3129),
    [sym__string] = ACTIONS(3129),
  },
  [1997] = {
    [sym_identifier] = ACTIONS(4318),
    [anon_sym_q_LBRACE] = ACTIONS(4320),
    [anon_sym_LBRACE] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(4320),
    [anon_sym_AMP] = ACTIONS(4320),
    [anon_sym_DASH] = ACTIONS(4318),
    [anon_sym_DASH_DASH] = ACTIONS(4320),
    [anon_sym_PLUS] = ACTIONS(4318),
    [anon_sym_PLUS_PLUS] = ACTIONS(4320),
    [anon_sym_BANG] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4320),
    [anon_sym_RPAREN] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4320),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_DOLLAR] = ACTIONS(4320),
    [anon_sym_STAR] = ACTIONS(4320),
    [anon_sym_TILDE] = ACTIONS(4320),
    [sym_bool] = ACTIONS(4318),
    [sym_byte] = ACTIONS(4318),
    [sym_ubyte] = ACTIONS(4318),
    [sym_char] = ACTIONS(4318),
    [sym_short] = ACTIONS(4318),
    [sym_ushort] = ACTIONS(4318),
    [sym_int] = ACTIONS(4318),
    [sym_uint] = ACTIONS(4318),
    [sym_long] = ACTIONS(4318),
    [sym_ulong] = ACTIONS(4318),
    [sym_cent] = ACTIONS(4318),
    [sym_ucent] = ACTIONS(4318),
    [sym_wchar] = ACTIONS(4318),
    [sym_dchar] = ACTIONS(4318),
    [sym_float] = ACTIONS(4318),
    [sym_double] = ACTIONS(4318),
    [sym_real] = ACTIONS(4318),
    [sym_ifloat] = ACTIONS(4318),
    [sym_idouble] = ACTIONS(4318),
    [sym_ireal] = ACTIONS(4318),
    [sym_cfloat] = ACTIONS(4318),
    [sym_cdouble] = ACTIONS(4318),
    [sym_creal] = ACTIONS(4318),
    [sym_size_t] = ACTIONS(4318),
    [sym_ptrdiff_t] = ACTIONS(4318),
    [sym_string] = ACTIONS(4318),
    [sym_cstring] = ACTIONS(4318),
    [sym_dstring] = ACTIONS(4318),
    [sym_wstring] = ACTIONS(4318),
    [sym_noreturn] = ACTIONS(4318),
    [sym_true] = ACTIONS(4318),
    [sym_false] = ACTIONS(4318),
    [sym_null] = ACTIONS(4318),
    [sym_super] = ACTIONS(4318),
    [sym_this] = ACTIONS(4318),
    [sym_assert] = ACTIONS(4318),
    [sym_auto] = ACTIONS(4318),
    [sym_cast] = ACTIONS(4318),
    [sym_catch] = ACTIONS(4318),
    [sym_const] = ACTIONS(4318),
    [sym_delegate] = ACTIONS(4318),
    [sym_delete] = ACTIONS(4318),
    [sym_do] = ACTIONS(4318),
    [sym_else] = ACTIONS(4318),
    [sym_finally] = ACTIONS(4318),
    [sym_function] = ACTIONS(4318),
    [sym_immutable] = ACTIONS(4318),
    [sym_import] = ACTIONS(4318),
    [sym_in] = ACTIONS(4318),
    [sym_inout] = ACTIONS(4318),
    [sym_is] = ACTIONS(4318),
    [sym_mixin] = ACTIONS(4318),
    [sym_new] = ACTIONS(4318),
    [sym_out] = ACTIONS(4318),
    [sym_ref] = ACTIONS(4318),
    [sym_shared] = ACTIONS(4318),
    [sym_throw] = ACTIONS(4318),
    [sym_typeid] = ACTIONS(4318),
    [sym_typeof] = ACTIONS(4318),
    [sym_traits] = ACTIONS(4318),
    [sym_vector] = ACTIONS(4318),
    [sym_void] = ACTIONS(4318),
    [anon_sym_BQUOTE] = ACTIONS(4320),
    [anon_sym_r_DQUOTE] = ACTIONS(4320),
    [anon_sym_x_DQUOTE] = ACTIONS(4320),
    [anon_sym_DQUOTE] = ACTIONS(4320),
    [anon_sym_i_BQUOTE] = ACTIONS(4320),
    [anon_sym_i_DQUOTE] = ACTIONS(4320),
    [anon_sym_iq_LBRACE] = ACTIONS(4320),
    [aux_sym_char_literal_token1] = ACTIONS(4320),
    [anon_sym_SQUOTE] = ACTIONS(4318),
    [anon_sym___DATE__] = ACTIONS(4318),
    [anon_sym___FILE__] = ACTIONS(4318),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4318),
    [anon_sym___FUNCTION__] = ACTIONS(4318),
    [anon_sym___LINE__] = ACTIONS(4318),
    [anon_sym___MODULE__] = ACTIONS(4318),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4318),
    [anon_sym___TIME__] = ACTIONS(4318),
    [anon_sym___TIMESTAMP__] = ACTIONS(4318),
    [anon_sym___VENDOR__] = ACTIONS(4318),
    [anon_sym___VERSION__] = ACTIONS(4318),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4320),
    [sym_float_literal] = ACTIONS(4320),
    [sym__string] = ACTIONS(4320),
  },
  [1998] = {
    [sym_identifier] = ACTIONS(4538),
    [anon_sym_q_LBRACE] = ACTIONS(4540),
    [anon_sym_LBRACE] = ACTIONS(4540),
    [anon_sym_DOT] = ACTIONS(4540),
    [anon_sym_AMP] = ACTIONS(4540),
    [anon_sym_DASH] = ACTIONS(4538),
    [anon_sym_DASH_DASH] = ACTIONS(4540),
    [anon_sym_PLUS] = ACTIONS(4538),
    [anon_sym_PLUS_PLUS] = ACTIONS(4540),
    [anon_sym_BANG] = ACTIONS(4540),
    [anon_sym_LPAREN] = ACTIONS(4540),
    [anon_sym_RPAREN] = ACTIONS(4540),
    [anon_sym_LBRACK] = ACTIONS(4540),
    [anon_sym_SEMI] = ACTIONS(4540),
    [anon_sym_DOLLAR] = ACTIONS(4540),
    [anon_sym_STAR] = ACTIONS(4540),
    [anon_sym_TILDE] = ACTIONS(4540),
    [sym_bool] = ACTIONS(4538),
    [sym_byte] = ACTIONS(4538),
    [sym_ubyte] = ACTIONS(4538),
    [sym_char] = ACTIONS(4538),
    [sym_short] = ACTIONS(4538),
    [sym_ushort] = ACTIONS(4538),
    [sym_int] = ACTIONS(4538),
    [sym_uint] = ACTIONS(4538),
    [sym_long] = ACTIONS(4538),
    [sym_ulong] = ACTIONS(4538),
    [sym_cent] = ACTIONS(4538),
    [sym_ucent] = ACTIONS(4538),
    [sym_wchar] = ACTIONS(4538),
    [sym_dchar] = ACTIONS(4538),
    [sym_float] = ACTIONS(4538),
    [sym_double] = ACTIONS(4538),
    [sym_real] = ACTIONS(4538),
    [sym_ifloat] = ACTIONS(4538),
    [sym_idouble] = ACTIONS(4538),
    [sym_ireal] = ACTIONS(4538),
    [sym_cfloat] = ACTIONS(4538),
    [sym_cdouble] = ACTIONS(4538),
    [sym_creal] = ACTIONS(4538),
    [sym_size_t] = ACTIONS(4538),
    [sym_ptrdiff_t] = ACTIONS(4538),
    [sym_string] = ACTIONS(4538),
    [sym_cstring] = ACTIONS(4538),
    [sym_dstring] = ACTIONS(4538),
    [sym_wstring] = ACTIONS(4538),
    [sym_noreturn] = ACTIONS(4538),
    [sym_true] = ACTIONS(4538),
    [sym_false] = ACTIONS(4538),
    [sym_null] = ACTIONS(4538),
    [sym_super] = ACTIONS(4538),
    [sym_this] = ACTIONS(4538),
    [sym_assert] = ACTIONS(4538),
    [sym_auto] = ACTIONS(4538),
    [sym_cast] = ACTIONS(4538),
    [sym_catch] = ACTIONS(4538),
    [sym_const] = ACTIONS(4538),
    [sym_delegate] = ACTIONS(4538),
    [sym_delete] = ACTIONS(4538),
    [sym_do] = ACTIONS(4538),
    [sym_else] = ACTIONS(4538),
    [sym_finally] = ACTIONS(4538),
    [sym_function] = ACTIONS(4538),
    [sym_immutable] = ACTIONS(4538),
    [sym_import] = ACTIONS(4538),
    [sym_in] = ACTIONS(4538),
    [sym_inout] = ACTIONS(4538),
    [sym_is] = ACTIONS(4538),
    [sym_mixin] = ACTIONS(4538),
    [sym_new] = ACTIONS(4538),
    [sym_out] = ACTIONS(4538),
    [sym_ref] = ACTIONS(4538),
    [sym_shared] = ACTIONS(4538),
    [sym_throw] = ACTIONS(4538),
    [sym_typeid] = ACTIONS(4538),
    [sym_typeof] = ACTIONS(4538),
    [sym_traits] = ACTIONS(4538),
    [sym_vector] = ACTIONS(4538),
    [sym_void] = ACTIONS(4538),
    [anon_sym_BQUOTE] = ACTIONS(4540),
    [anon_sym_r_DQUOTE] = ACTIONS(4540),
    [anon_sym_x_DQUOTE] = ACTIONS(4540),
    [anon_sym_DQUOTE] = ACTIONS(4540),
    [anon_sym_i_BQUOTE] = ACTIONS(4540),
    [anon_sym_i_DQUOTE] = ACTIONS(4540),
    [anon_sym_iq_LBRACE] = ACTIONS(4540),
    [aux_sym_char_literal_token1] = ACTIONS(4540),
    [anon_sym_SQUOTE] = ACTIONS(4538),
    [anon_sym___DATE__] = ACTIONS(4538),
    [anon_sym___FILE__] = ACTIONS(4538),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4538),
    [anon_sym___FUNCTION__] = ACTIONS(4538),
    [anon_sym___LINE__] = ACTIONS(4538),
    [anon_sym___MODULE__] = ACTIONS(4538),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4538),
    [anon_sym___TIME__] = ACTIONS(4538),
    [anon_sym___TIMESTAMP__] = ACTIONS(4538),
    [anon_sym___VENDOR__] = ACTIONS(4538),
    [anon_sym___VERSION__] = ACTIONS(4538),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4540),
    [sym_float_literal] = ACTIONS(4540),
    [sym__string] = ACTIONS(4540),
  },
  [1999] = {
    [sym_identifier] = ACTIONS(4510),
    [anon_sym_q_LBRACE] = ACTIONS(4512),
    [anon_sym_LBRACE] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4512),
    [anon_sym_DASH] = ACTIONS(4510),
    [anon_sym_DASH_DASH] = ACTIONS(4512),
    [anon_sym_PLUS] = ACTIONS(4510),
    [anon_sym_PLUS_PLUS] = ACTIONS(4512),
    [anon_sym_BANG] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4512),
    [anon_sym_RPAREN] = ACTIONS(4512),
    [anon_sym_LBRACK] = ACTIONS(4512),
    [anon_sym_SEMI] = ACTIONS(4512),
    [anon_sym_DOLLAR] = ACTIONS(4512),
    [anon_sym_STAR] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4512),
    [sym_bool] = ACTIONS(4510),
    [sym_byte] = ACTIONS(4510),
    [sym_ubyte] = ACTIONS(4510),
    [sym_char] = ACTIONS(4510),
    [sym_short] = ACTIONS(4510),
    [sym_ushort] = ACTIONS(4510),
    [sym_int] = ACTIONS(4510),
    [sym_uint] = ACTIONS(4510),
    [sym_long] = ACTIONS(4510),
    [sym_ulong] = ACTIONS(4510),
    [sym_cent] = ACTIONS(4510),
    [sym_ucent] = ACTIONS(4510),
    [sym_wchar] = ACTIONS(4510),
    [sym_dchar] = ACTIONS(4510),
    [sym_float] = ACTIONS(4510),
    [sym_double] = ACTIONS(4510),
    [sym_real] = ACTIONS(4510),
    [sym_ifloat] = ACTIONS(4510),
    [sym_idouble] = ACTIONS(4510),
    [sym_ireal] = ACTIONS(4510),
    [sym_cfloat] = ACTIONS(4510),
    [sym_cdouble] = ACTIONS(4510),
    [sym_creal] = ACTIONS(4510),
    [sym_size_t] = ACTIONS(4510),
    [sym_ptrdiff_t] = ACTIONS(4510),
    [sym_string] = ACTIONS(4510),
    [sym_cstring] = ACTIONS(4510),
    [sym_dstring] = ACTIONS(4510),
    [sym_wstring] = ACTIONS(4510),
    [sym_noreturn] = ACTIONS(4510),
    [sym_true] = ACTIONS(4510),
    [sym_false] = ACTIONS(4510),
    [sym_null] = ACTIONS(4510),
    [sym_super] = ACTIONS(4510),
    [sym_this] = ACTIONS(4510),
    [sym_assert] = ACTIONS(4510),
    [sym_auto] = ACTIONS(4510),
    [sym_cast] = ACTIONS(4510),
    [sym_catch] = ACTIONS(4510),
    [sym_const] = ACTIONS(4510),
    [sym_delegate] = ACTIONS(4510),
    [sym_delete] = ACTIONS(4510),
    [sym_do] = ACTIONS(4510),
    [sym_else] = ACTIONS(4510),
    [sym_finally] = ACTIONS(4510),
    [sym_function] = ACTIONS(4510),
    [sym_immutable] = ACTIONS(4510),
    [sym_import] = ACTIONS(4510),
    [sym_in] = ACTIONS(4510),
    [sym_inout] = ACTIONS(4510),
    [sym_is] = ACTIONS(4510),
    [sym_mixin] = ACTIONS(4510),
    [sym_new] = ACTIONS(4510),
    [sym_out] = ACTIONS(4510),
    [sym_ref] = ACTIONS(4510),
    [sym_shared] = ACTIONS(4510),
    [sym_throw] = ACTIONS(4510),
    [sym_typeid] = ACTIONS(4510),
    [sym_typeof] = ACTIONS(4510),
    [sym_traits] = ACTIONS(4510),
    [sym_vector] = ACTIONS(4510),
    [sym_void] = ACTIONS(4510),
    [anon_sym_BQUOTE] = ACTIONS(4512),
    [anon_sym_r_DQUOTE] = ACTIONS(4512),
    [anon_sym_x_DQUOTE] = ACTIONS(4512),
    [anon_sym_DQUOTE] = ACTIONS(4512),
    [anon_sym_i_BQUOTE] = ACTIONS(4512),
    [anon_sym_i_DQUOTE] = ACTIONS(4512),
    [anon_sym_iq_LBRACE] = ACTIONS(4512),
    [aux_sym_char_literal_token1] = ACTIONS(4512),
    [anon_sym_SQUOTE] = ACTIONS(4510),
    [anon_sym___DATE__] = ACTIONS(4510),
    [anon_sym___FILE__] = ACTIONS(4510),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4510),
    [anon_sym___FUNCTION__] = ACTIONS(4510),
    [anon_sym___LINE__] = ACTIONS(4510),
    [anon_sym___MODULE__] = ACTIONS(4510),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4510),
    [anon_sym___TIME__] = ACTIONS(4510),
    [anon_sym___TIMESTAMP__] = ACTIONS(4510),
    [anon_sym___VENDOR__] = ACTIONS(4510),
    [anon_sym___VERSION__] = ACTIONS(4510),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4512),
    [sym_float_literal] = ACTIONS(4512),
    [sym__string] = ACTIONS(4512),
  },
  [2000] = {
    [sym_identifier] = ACTIONS(4813),
    [anon_sym_q_LBRACE] = ACTIONS(4815),
    [anon_sym_LBRACE] = ACTIONS(4815),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_AMP] = ACTIONS(4815),
    [anon_sym_DASH] = ACTIONS(4813),
    [anon_sym_DASH_DASH] = ACTIONS(4815),
    [anon_sym_PLUS] = ACTIONS(4813),
    [anon_sym_PLUS_PLUS] = ACTIONS(4815),
    [anon_sym_BANG] = ACTIONS(4815),
    [anon_sym_LPAREN] = ACTIONS(4815),
    [anon_sym_RPAREN] = ACTIONS(4815),
    [anon_sym_LBRACK] = ACTIONS(4815),
    [anon_sym_SEMI] = ACTIONS(4815),
    [anon_sym_DOLLAR] = ACTIONS(4815),
    [anon_sym_STAR] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4815),
    [sym_bool] = ACTIONS(4813),
    [sym_byte] = ACTIONS(4813),
    [sym_ubyte] = ACTIONS(4813),
    [sym_char] = ACTIONS(4813),
    [sym_short] = ACTIONS(4813),
    [sym_ushort] = ACTIONS(4813),
    [sym_int] = ACTIONS(4813),
    [sym_uint] = ACTIONS(4813),
    [sym_long] = ACTIONS(4813),
    [sym_ulong] = ACTIONS(4813),
    [sym_cent] = ACTIONS(4813),
    [sym_ucent] = ACTIONS(4813),
    [sym_wchar] = ACTIONS(4813),
    [sym_dchar] = ACTIONS(4813),
    [sym_float] = ACTIONS(4813),
    [sym_double] = ACTIONS(4813),
    [sym_real] = ACTIONS(4813),
    [sym_ifloat] = ACTIONS(4813),
    [sym_idouble] = ACTIONS(4813),
    [sym_ireal] = ACTIONS(4813),
    [sym_cfloat] = ACTIONS(4813),
    [sym_cdouble] = ACTIONS(4813),
    [sym_creal] = ACTIONS(4813),
    [sym_size_t] = ACTIONS(4813),
    [sym_ptrdiff_t] = ACTIONS(4813),
    [sym_string] = ACTIONS(4813),
    [sym_cstring] = ACTIONS(4813),
    [sym_dstring] = ACTIONS(4813),
    [sym_wstring] = ACTIONS(4813),
    [sym_noreturn] = ACTIONS(4813),
    [sym_true] = ACTIONS(4813),
    [sym_false] = ACTIONS(4813),
    [sym_null] = ACTIONS(4813),
    [sym_super] = ACTIONS(4813),
    [sym_this] = ACTIONS(4813),
    [sym_assert] = ACTIONS(4813),
    [sym_auto] = ACTIONS(4813),
    [sym_cast] = ACTIONS(4813),
    [sym_catch] = ACTIONS(4813),
    [sym_const] = ACTIONS(4813),
    [sym_delegate] = ACTIONS(4813),
    [sym_delete] = ACTIONS(4813),
    [sym_do] = ACTIONS(4813),
    [sym_else] = ACTIONS(4813),
    [sym_finally] = ACTIONS(4813),
    [sym_function] = ACTIONS(4813),
    [sym_immutable] = ACTIONS(4813),
    [sym_import] = ACTIONS(4813),
    [sym_in] = ACTIONS(4813),
    [sym_inout] = ACTIONS(4813),
    [sym_is] = ACTIONS(4813),
    [sym_mixin] = ACTIONS(4813),
    [sym_new] = ACTIONS(4813),
    [sym_out] = ACTIONS(4813),
    [sym_ref] = ACTIONS(4813),
    [sym_shared] = ACTIONS(4813),
    [sym_throw] = ACTIONS(4813),
    [sym_typeid] = ACTIONS(4813),
    [sym_typeof] = ACTIONS(4813),
    [sym_traits] = ACTIONS(4813),
    [sym_vector] = ACTIONS(4813),
    [sym_void] = ACTIONS(4813),
    [anon_sym_BQUOTE] = ACTIONS(4815),
    [anon_sym_r_DQUOTE] = ACTIONS(4815),
    [anon_sym_x_DQUOTE] = ACTIONS(4815),
    [anon_sym_DQUOTE] = ACTIONS(4815),
    [anon_sym_i_BQUOTE] = ACTIONS(4815),
    [anon_sym_i_DQUOTE] = ACTIONS(4815),
    [anon_sym_iq_LBRACE] = ACTIONS(4815),
    [aux_sym_char_literal_token1] = ACTIONS(4815),
    [anon_sym_SQUOTE] = ACTIONS(4813),
    [anon_sym___DATE__] = ACTIONS(4813),
    [anon_sym___FILE__] = ACTIONS(4813),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4813),
    [anon_sym___FUNCTION__] = ACTIONS(4813),
    [anon_sym___LINE__] = ACTIONS(4813),
    [anon_sym___MODULE__] = ACTIONS(4813),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4813),
    [anon_sym___TIME__] = ACTIONS(4813),
    [anon_sym___TIMESTAMP__] = ACTIONS(4813),
    [anon_sym___VENDOR__] = ACTIONS(4813),
    [anon_sym___VERSION__] = ACTIONS(4813),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4815),
    [sym_float_literal] = ACTIONS(4815),
    [sym__string] = ACTIONS(4815),
  },
  [2001] = {
    [sym_identifier] = ACTIONS(4809),
    [anon_sym_q_LBRACE] = ACTIONS(4811),
    [anon_sym_LBRACE] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4811),
    [anon_sym_AMP] = ACTIONS(4811),
    [anon_sym_DASH] = ACTIONS(4809),
    [anon_sym_DASH_DASH] = ACTIONS(4811),
    [anon_sym_PLUS] = ACTIONS(4809),
    [anon_sym_PLUS_PLUS] = ACTIONS(4811),
    [anon_sym_BANG] = ACTIONS(4811),
    [anon_sym_LPAREN] = ACTIONS(4811),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [anon_sym_LBRACK] = ACTIONS(4811),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_DOLLAR] = ACTIONS(4811),
    [anon_sym_STAR] = ACTIONS(4811),
    [anon_sym_TILDE] = ACTIONS(4811),
    [sym_bool] = ACTIONS(4809),
    [sym_byte] = ACTIONS(4809),
    [sym_ubyte] = ACTIONS(4809),
    [sym_char] = ACTIONS(4809),
    [sym_short] = ACTIONS(4809),
    [sym_ushort] = ACTIONS(4809),
    [sym_int] = ACTIONS(4809),
    [sym_uint] = ACTIONS(4809),
    [sym_long] = ACTIONS(4809),
    [sym_ulong] = ACTIONS(4809),
    [sym_cent] = ACTIONS(4809),
    [sym_ucent] = ACTIONS(4809),
    [sym_wchar] = ACTIONS(4809),
    [sym_dchar] = ACTIONS(4809),
    [sym_float] = ACTIONS(4809),
    [sym_double] = ACTIONS(4809),
    [sym_real] = ACTIONS(4809),
    [sym_ifloat] = ACTIONS(4809),
    [sym_idouble] = ACTIONS(4809),
    [sym_ireal] = ACTIONS(4809),
    [sym_cfloat] = ACTIONS(4809),
    [sym_cdouble] = ACTIONS(4809),
    [sym_creal] = ACTIONS(4809),
    [sym_size_t] = ACTIONS(4809),
    [sym_ptrdiff_t] = ACTIONS(4809),
    [sym_string] = ACTIONS(4809),
    [sym_cstring] = ACTIONS(4809),
    [sym_dstring] = ACTIONS(4809),
    [sym_wstring] = ACTIONS(4809),
    [sym_noreturn] = ACTIONS(4809),
    [sym_true] = ACTIONS(4809),
    [sym_false] = ACTIONS(4809),
    [sym_null] = ACTIONS(4809),
    [sym_super] = ACTIONS(4809),
    [sym_this] = ACTIONS(4809),
    [sym_assert] = ACTIONS(4809),
    [sym_auto] = ACTIONS(4809),
    [sym_cast] = ACTIONS(4809),
    [sym_catch] = ACTIONS(4809),
    [sym_const] = ACTIONS(4809),
    [sym_delegate] = ACTIONS(4809),
    [sym_delete] = ACTIONS(4809),
    [sym_do] = ACTIONS(4809),
    [sym_else] = ACTIONS(4809),
    [sym_finally] = ACTIONS(4809),
    [sym_function] = ACTIONS(4809),
    [sym_immutable] = ACTIONS(4809),
    [sym_import] = ACTIONS(4809),
    [sym_in] = ACTIONS(4809),
    [sym_inout] = ACTIONS(4809),
    [sym_is] = ACTIONS(4809),
    [sym_mixin] = ACTIONS(4809),
    [sym_new] = ACTIONS(4809),
    [sym_out] = ACTIONS(4809),
    [sym_ref] = ACTIONS(4809),
    [sym_shared] = ACTIONS(4809),
    [sym_throw] = ACTIONS(4809),
    [sym_typeid] = ACTIONS(4809),
    [sym_typeof] = ACTIONS(4809),
    [sym_traits] = ACTIONS(4809),
    [sym_vector] = ACTIONS(4809),
    [sym_void] = ACTIONS(4809),
    [anon_sym_BQUOTE] = ACTIONS(4811),
    [anon_sym_r_DQUOTE] = ACTIONS(4811),
    [anon_sym_x_DQUOTE] = ACTIONS(4811),
    [anon_sym_DQUOTE] = ACTIONS(4811),
    [anon_sym_i_BQUOTE] = ACTIONS(4811),
    [anon_sym_i_DQUOTE] = ACTIONS(4811),
    [anon_sym_iq_LBRACE] = ACTIONS(4811),
    [aux_sym_char_literal_token1] = ACTIONS(4811),
    [anon_sym_SQUOTE] = ACTIONS(4809),
    [anon_sym___DATE__] = ACTIONS(4809),
    [anon_sym___FILE__] = ACTIONS(4809),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4809),
    [anon_sym___FUNCTION__] = ACTIONS(4809),
    [anon_sym___LINE__] = ACTIONS(4809),
    [anon_sym___MODULE__] = ACTIONS(4809),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4809),
    [anon_sym___TIME__] = ACTIONS(4809),
    [anon_sym___TIMESTAMP__] = ACTIONS(4809),
    [anon_sym___VENDOR__] = ACTIONS(4809),
    [anon_sym___VERSION__] = ACTIONS(4809),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4811),
    [sym_float_literal] = ACTIONS(4811),
    [sym__string] = ACTIONS(4811),
  },
  [2002] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(5858),
    [sym_finally] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [2003] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_catch] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(5860),
    [sym_finally] = ACTIONS(4688),
    [sym_function] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [2004] = {
    [sym_identifier] = ACTIONS(4518),
    [anon_sym_q_LBRACE] = ACTIONS(4520),
    [anon_sym_LBRACE] = ACTIONS(4520),
    [anon_sym_DOT] = ACTIONS(4520),
    [anon_sym_AMP] = ACTIONS(4520),
    [anon_sym_DASH] = ACTIONS(4518),
    [anon_sym_DASH_DASH] = ACTIONS(4520),
    [anon_sym_PLUS] = ACTIONS(4518),
    [anon_sym_PLUS_PLUS] = ACTIONS(4520),
    [anon_sym_BANG] = ACTIONS(4520),
    [anon_sym_LPAREN] = ACTIONS(4520),
    [anon_sym_RPAREN] = ACTIONS(4520),
    [anon_sym_LBRACK] = ACTIONS(4520),
    [anon_sym_SEMI] = ACTIONS(4520),
    [anon_sym_DOLLAR] = ACTIONS(4520),
    [anon_sym_STAR] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4520),
    [sym_bool] = ACTIONS(4518),
    [sym_byte] = ACTIONS(4518),
    [sym_ubyte] = ACTIONS(4518),
    [sym_char] = ACTIONS(4518),
    [sym_short] = ACTIONS(4518),
    [sym_ushort] = ACTIONS(4518),
    [sym_int] = ACTIONS(4518),
    [sym_uint] = ACTIONS(4518),
    [sym_long] = ACTIONS(4518),
    [sym_ulong] = ACTIONS(4518),
    [sym_cent] = ACTIONS(4518),
    [sym_ucent] = ACTIONS(4518),
    [sym_wchar] = ACTIONS(4518),
    [sym_dchar] = ACTIONS(4518),
    [sym_float] = ACTIONS(4518),
    [sym_double] = ACTIONS(4518),
    [sym_real] = ACTIONS(4518),
    [sym_ifloat] = ACTIONS(4518),
    [sym_idouble] = ACTIONS(4518),
    [sym_ireal] = ACTIONS(4518),
    [sym_cfloat] = ACTIONS(4518),
    [sym_cdouble] = ACTIONS(4518),
    [sym_creal] = ACTIONS(4518),
    [sym_size_t] = ACTIONS(4518),
    [sym_ptrdiff_t] = ACTIONS(4518),
    [sym_string] = ACTIONS(4518),
    [sym_cstring] = ACTIONS(4518),
    [sym_dstring] = ACTIONS(4518),
    [sym_wstring] = ACTIONS(4518),
    [sym_noreturn] = ACTIONS(4518),
    [sym_true] = ACTIONS(4518),
    [sym_false] = ACTIONS(4518),
    [sym_null] = ACTIONS(4518),
    [sym_super] = ACTIONS(4518),
    [sym_this] = ACTIONS(4518),
    [sym_assert] = ACTIONS(4518),
    [sym_auto] = ACTIONS(4518),
    [sym_cast] = ACTIONS(4518),
    [sym_catch] = ACTIONS(4518),
    [sym_const] = ACTIONS(4518),
    [sym_delegate] = ACTIONS(4518),
    [sym_delete] = ACTIONS(4518),
    [sym_do] = ACTIONS(4518),
    [sym_else] = ACTIONS(4518),
    [sym_finally] = ACTIONS(4518),
    [sym_function] = ACTIONS(4518),
    [sym_immutable] = ACTIONS(4518),
    [sym_import] = ACTIONS(4518),
    [sym_in] = ACTIONS(4518),
    [sym_inout] = ACTIONS(4518),
    [sym_is] = ACTIONS(4518),
    [sym_mixin] = ACTIONS(4518),
    [sym_new] = ACTIONS(4518),
    [sym_out] = ACTIONS(4518),
    [sym_ref] = ACTIONS(4518),
    [sym_shared] = ACTIONS(4518),
    [sym_throw] = ACTIONS(4518),
    [sym_typeid] = ACTIONS(4518),
    [sym_typeof] = ACTIONS(4518),
    [sym_traits] = ACTIONS(4518),
    [sym_vector] = ACTIONS(4518),
    [sym_void] = ACTIONS(4518),
    [anon_sym_BQUOTE] = ACTIONS(4520),
    [anon_sym_r_DQUOTE] = ACTIONS(4520),
    [anon_sym_x_DQUOTE] = ACTIONS(4520),
    [anon_sym_DQUOTE] = ACTIONS(4520),
    [anon_sym_i_BQUOTE] = ACTIONS(4520),
    [anon_sym_i_DQUOTE] = ACTIONS(4520),
    [anon_sym_iq_LBRACE] = ACTIONS(4520),
    [aux_sym_char_literal_token1] = ACTIONS(4520),
    [anon_sym_SQUOTE] = ACTIONS(4518),
    [anon_sym___DATE__] = ACTIONS(4518),
    [anon_sym___FILE__] = ACTIONS(4518),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4518),
    [anon_sym___FUNCTION__] = ACTIONS(4518),
    [anon_sym___LINE__] = ACTIONS(4518),
    [anon_sym___MODULE__] = ACTIONS(4518),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4518),
    [anon_sym___TIME__] = ACTIONS(4518),
    [anon_sym___TIMESTAMP__] = ACTIONS(4518),
    [anon_sym___VENDOR__] = ACTIONS(4518),
    [anon_sym___VERSION__] = ACTIONS(4518),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4520),
    [sym_float_literal] = ACTIONS(4520),
    [sym__string] = ACTIONS(4520),
  },
  [2005] = {
    [sym_identifier] = ACTIONS(4805),
    [anon_sym_q_LBRACE] = ACTIONS(4807),
    [anon_sym_LBRACE] = ACTIONS(4807),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_AMP] = ACTIONS(4807),
    [anon_sym_DASH] = ACTIONS(4805),
    [anon_sym_DASH_DASH] = ACTIONS(4807),
    [anon_sym_PLUS] = ACTIONS(4805),
    [anon_sym_PLUS_PLUS] = ACTIONS(4807),
    [anon_sym_BANG] = ACTIONS(4807),
    [anon_sym_LPAREN] = ACTIONS(4807),
    [anon_sym_RPAREN] = ACTIONS(4807),
    [anon_sym_LBRACK] = ACTIONS(4807),
    [anon_sym_SEMI] = ACTIONS(4807),
    [anon_sym_DOLLAR] = ACTIONS(4807),
    [anon_sym_STAR] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [sym_bool] = ACTIONS(4805),
    [sym_byte] = ACTIONS(4805),
    [sym_ubyte] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_short] = ACTIONS(4805),
    [sym_ushort] = ACTIONS(4805),
    [sym_int] = ACTIONS(4805),
    [sym_uint] = ACTIONS(4805),
    [sym_long] = ACTIONS(4805),
    [sym_ulong] = ACTIONS(4805),
    [sym_cent] = ACTIONS(4805),
    [sym_ucent] = ACTIONS(4805),
    [sym_wchar] = ACTIONS(4805),
    [sym_dchar] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_double] = ACTIONS(4805),
    [sym_real] = ACTIONS(4805),
    [sym_ifloat] = ACTIONS(4805),
    [sym_idouble] = ACTIONS(4805),
    [sym_ireal] = ACTIONS(4805),
    [sym_cfloat] = ACTIONS(4805),
    [sym_cdouble] = ACTIONS(4805),
    [sym_creal] = ACTIONS(4805),
    [sym_size_t] = ACTIONS(4805),
    [sym_ptrdiff_t] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym_cstring] = ACTIONS(4805),
    [sym_dstring] = ACTIONS(4805),
    [sym_wstring] = ACTIONS(4805),
    [sym_noreturn] = ACTIONS(4805),
    [sym_true] = ACTIONS(4805),
    [sym_false] = ACTIONS(4805),
    [sym_null] = ACTIONS(4805),
    [sym_super] = ACTIONS(4805),
    [sym_this] = ACTIONS(4805),
    [sym_assert] = ACTIONS(4805),
    [sym_auto] = ACTIONS(4805),
    [sym_cast] = ACTIONS(4805),
    [sym_catch] = ACTIONS(4805),
    [sym_const] = ACTIONS(4805),
    [sym_delegate] = ACTIONS(4805),
    [sym_delete] = ACTIONS(4805),
    [sym_do] = ACTIONS(4805),
    [sym_else] = ACTIONS(4805),
    [sym_finally] = ACTIONS(4805),
    [sym_function] = ACTIONS(4805),
    [sym_immutable] = ACTIONS(4805),
    [sym_import] = ACTIONS(4805),
    [sym_in] = ACTIONS(4805),
    [sym_inout] = ACTIONS(4805),
    [sym_is] = ACTIONS(4805),
    [sym_mixin] = ACTIONS(4805),
    [sym_new] = ACTIONS(4805),
    [sym_out] = ACTIONS(4805),
    [sym_ref] = ACTIONS(4805),
    [sym_shared] = ACTIONS(4805),
    [sym_throw] = ACTIONS(4805),
    [sym_typeid] = ACTIONS(4805),
    [sym_typeof] = ACTIONS(4805),
    [sym_traits] = ACTIONS(4805),
    [sym_vector] = ACTIONS(4805),
    [sym_void] = ACTIONS(4805),
    [anon_sym_BQUOTE] = ACTIONS(4807),
    [anon_sym_r_DQUOTE] = ACTIONS(4807),
    [anon_sym_x_DQUOTE] = ACTIONS(4807),
    [anon_sym_DQUOTE] = ACTIONS(4807),
    [anon_sym_i_BQUOTE] = ACTIONS(4807),
    [anon_sym_i_DQUOTE] = ACTIONS(4807),
    [anon_sym_iq_LBRACE] = ACTIONS(4807),
    [aux_sym_char_literal_token1] = ACTIONS(4807),
    [anon_sym_SQUOTE] = ACTIONS(4805),
    [anon_sym___DATE__] = ACTIONS(4805),
    [anon_sym___FILE__] = ACTIONS(4805),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4805),
    [anon_sym___FUNCTION__] = ACTIONS(4805),
    [anon_sym___LINE__] = ACTIONS(4805),
    [anon_sym___MODULE__] = ACTIONS(4805),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4805),
    [anon_sym___TIME__] = ACTIONS(4805),
    [anon_sym___TIMESTAMP__] = ACTIONS(4805),
    [anon_sym___VENDOR__] = ACTIONS(4805),
    [anon_sym___VERSION__] = ACTIONS(4805),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4807),
    [sym_float_literal] = ACTIONS(4807),
    [sym__string] = ACTIONS(4807),
  },
  [2006] = {
    [sym_identifier] = ACTIONS(4801),
    [anon_sym_q_LBRACE] = ACTIONS(4803),
    [anon_sym_LBRACE] = ACTIONS(4803),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_AMP] = ACTIONS(4803),
    [anon_sym_DASH] = ACTIONS(4801),
    [anon_sym_DASH_DASH] = ACTIONS(4803),
    [anon_sym_PLUS] = ACTIONS(4801),
    [anon_sym_PLUS_PLUS] = ACTIONS(4803),
    [anon_sym_BANG] = ACTIONS(4803),
    [anon_sym_LPAREN] = ACTIONS(4803),
    [anon_sym_RPAREN] = ACTIONS(4803),
    [anon_sym_LBRACK] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4803),
    [anon_sym_DOLLAR] = ACTIONS(4803),
    [anon_sym_STAR] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [sym_bool] = ACTIONS(4801),
    [sym_byte] = ACTIONS(4801),
    [sym_ubyte] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_short] = ACTIONS(4801),
    [sym_ushort] = ACTIONS(4801),
    [sym_int] = ACTIONS(4801),
    [sym_uint] = ACTIONS(4801),
    [sym_long] = ACTIONS(4801),
    [sym_ulong] = ACTIONS(4801),
    [sym_cent] = ACTIONS(4801),
    [sym_ucent] = ACTIONS(4801),
    [sym_wchar] = ACTIONS(4801),
    [sym_dchar] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_double] = ACTIONS(4801),
    [sym_real] = ACTIONS(4801),
    [sym_ifloat] = ACTIONS(4801),
    [sym_idouble] = ACTIONS(4801),
    [sym_ireal] = ACTIONS(4801),
    [sym_cfloat] = ACTIONS(4801),
    [sym_cdouble] = ACTIONS(4801),
    [sym_creal] = ACTIONS(4801),
    [sym_size_t] = ACTIONS(4801),
    [sym_ptrdiff_t] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym_cstring] = ACTIONS(4801),
    [sym_dstring] = ACTIONS(4801),
    [sym_wstring] = ACTIONS(4801),
    [sym_noreturn] = ACTIONS(4801),
    [sym_true] = ACTIONS(4801),
    [sym_false] = ACTIONS(4801),
    [sym_null] = ACTIONS(4801),
    [sym_super] = ACTIONS(4801),
    [sym_this] = ACTIONS(4801),
    [sym_assert] = ACTIONS(4801),
    [sym_auto] = ACTIONS(4801),
    [sym_cast] = ACTIONS(4801),
    [sym_catch] = ACTIONS(4801),
    [sym_const] = ACTIONS(4801),
    [sym_delegate] = ACTIONS(4801),
    [sym_delete] = ACTIONS(4801),
    [sym_do] = ACTIONS(4801),
    [sym_else] = ACTIONS(4801),
    [sym_finally] = ACTIONS(4801),
    [sym_function] = ACTIONS(4801),
    [sym_immutable] = ACTIONS(4801),
    [sym_import] = ACTIONS(4801),
    [sym_in] = ACTIONS(4801),
    [sym_inout] = ACTIONS(4801),
    [sym_is] = ACTIONS(4801),
    [sym_mixin] = ACTIONS(4801),
    [sym_new] = ACTIONS(4801),
    [sym_out] = ACTIONS(4801),
    [sym_ref] = ACTIONS(4801),
    [sym_shared] = ACTIONS(4801),
    [sym_throw] = ACTIONS(4801),
    [sym_typeid] = ACTIONS(4801),
    [sym_typeof] = ACTIONS(4801),
    [sym_traits] = ACTIONS(4801),
    [sym_vector] = ACTIONS(4801),
    [sym_void] = ACTIONS(4801),
    [anon_sym_BQUOTE] = ACTIONS(4803),
    [anon_sym_r_DQUOTE] = ACTIONS(4803),
    [anon_sym_x_DQUOTE] = ACTIONS(4803),
    [anon_sym_DQUOTE] = ACTIONS(4803),
    [anon_sym_i_BQUOTE] = ACTIONS(4803),
    [anon_sym_i_DQUOTE] = ACTIONS(4803),
    [anon_sym_iq_LBRACE] = ACTIONS(4803),
    [aux_sym_char_literal_token1] = ACTIONS(4803),
    [anon_sym_SQUOTE] = ACTIONS(4801),
    [anon_sym___DATE__] = ACTIONS(4801),
    [anon_sym___FILE__] = ACTIONS(4801),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4801),
    [anon_sym___FUNCTION__] = ACTIONS(4801),
    [anon_sym___LINE__] = ACTIONS(4801),
    [anon_sym___MODULE__] = ACTIONS(4801),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4801),
    [anon_sym___TIME__] = ACTIONS(4801),
    [anon_sym___TIMESTAMP__] = ACTIONS(4801),
    [anon_sym___VENDOR__] = ACTIONS(4801),
    [anon_sym___VERSION__] = ACTIONS(4801),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4803),
    [sym_float_literal] = ACTIONS(4803),
    [sym__string] = ACTIONS(4803),
  },
  [2007] = {
    [sym_identifier] = ACTIONS(4400),
    [anon_sym_q_LBRACE] = ACTIONS(4402),
    [anon_sym_LBRACE] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_AMP] = ACTIONS(4402),
    [anon_sym_DASH] = ACTIONS(4400),
    [anon_sym_DASH_DASH] = ACTIONS(4402),
    [anon_sym_PLUS] = ACTIONS(4400),
    [anon_sym_PLUS_PLUS] = ACTIONS(4402),
    [anon_sym_BANG] = ACTIONS(4402),
    [anon_sym_LPAREN] = ACTIONS(4402),
    [anon_sym_RPAREN] = ACTIONS(4402),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_DOLLAR] = ACTIONS(4402),
    [anon_sym_STAR] = ACTIONS(4402),
    [anon_sym_TILDE] = ACTIONS(4402),
    [sym_bool] = ACTIONS(4400),
    [sym_byte] = ACTIONS(4400),
    [sym_ubyte] = ACTIONS(4400),
    [sym_char] = ACTIONS(4400),
    [sym_short] = ACTIONS(4400),
    [sym_ushort] = ACTIONS(4400),
    [sym_int] = ACTIONS(4400),
    [sym_uint] = ACTIONS(4400),
    [sym_long] = ACTIONS(4400),
    [sym_ulong] = ACTIONS(4400),
    [sym_cent] = ACTIONS(4400),
    [sym_ucent] = ACTIONS(4400),
    [sym_wchar] = ACTIONS(4400),
    [sym_dchar] = ACTIONS(4400),
    [sym_float] = ACTIONS(4400),
    [sym_double] = ACTIONS(4400),
    [sym_real] = ACTIONS(4400),
    [sym_ifloat] = ACTIONS(4400),
    [sym_idouble] = ACTIONS(4400),
    [sym_ireal] = ACTIONS(4400),
    [sym_cfloat] = ACTIONS(4400),
    [sym_cdouble] = ACTIONS(4400),
    [sym_creal] = ACTIONS(4400),
    [sym_size_t] = ACTIONS(4400),
    [sym_ptrdiff_t] = ACTIONS(4400),
    [sym_string] = ACTIONS(4400),
    [sym_cstring] = ACTIONS(4400),
    [sym_dstring] = ACTIONS(4400),
    [sym_wstring] = ACTIONS(4400),
    [sym_noreturn] = ACTIONS(4400),
    [sym_true] = ACTIONS(4400),
    [sym_false] = ACTIONS(4400),
    [sym_null] = ACTIONS(4400),
    [sym_super] = ACTIONS(4400),
    [sym_this] = ACTIONS(4400),
    [sym_assert] = ACTIONS(4400),
    [sym_auto] = ACTIONS(4400),
    [sym_cast] = ACTIONS(4400),
    [sym_catch] = ACTIONS(4400),
    [sym_const] = ACTIONS(4400),
    [sym_delegate] = ACTIONS(4400),
    [sym_delete] = ACTIONS(4400),
    [sym_do] = ACTIONS(4400),
    [sym_else] = ACTIONS(4400),
    [sym_finally] = ACTIONS(4400),
    [sym_function] = ACTIONS(4400),
    [sym_immutable] = ACTIONS(4400),
    [sym_import] = ACTIONS(4400),
    [sym_in] = ACTIONS(4400),
    [sym_inout] = ACTIONS(4400),
    [sym_is] = ACTIONS(4400),
    [sym_mixin] = ACTIONS(4400),
    [sym_new] = ACTIONS(4400),
    [sym_out] = ACTIONS(4400),
    [sym_ref] = ACTIONS(4400),
    [sym_shared] = ACTIONS(4400),
    [sym_throw] = ACTIONS(4400),
    [sym_typeid] = ACTIONS(4400),
    [sym_typeof] = ACTIONS(4400),
    [sym_traits] = ACTIONS(4400),
    [sym_vector] = ACTIONS(4400),
    [sym_void] = ACTIONS(4400),
    [anon_sym_BQUOTE] = ACTIONS(4402),
    [anon_sym_r_DQUOTE] = ACTIONS(4402),
    [anon_sym_x_DQUOTE] = ACTIONS(4402),
    [anon_sym_DQUOTE] = ACTIONS(4402),
    [anon_sym_i_BQUOTE] = ACTIONS(4402),
    [anon_sym_i_DQUOTE] = ACTIONS(4402),
    [anon_sym_iq_LBRACE] = ACTIONS(4402),
    [aux_sym_char_literal_token1] = ACTIONS(4402),
    [anon_sym_SQUOTE] = ACTIONS(4400),
    [anon_sym___DATE__] = ACTIONS(4400),
    [anon_sym___FILE__] = ACTIONS(4400),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4400),
    [anon_sym___FUNCTION__] = ACTIONS(4400),
    [anon_sym___LINE__] = ACTIONS(4400),
    [anon_sym___MODULE__] = ACTIONS(4400),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4400),
    [anon_sym___TIME__] = ACTIONS(4400),
    [anon_sym___TIMESTAMP__] = ACTIONS(4400),
    [anon_sym___VENDOR__] = ACTIONS(4400),
    [anon_sym___VERSION__] = ACTIONS(4400),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4402),
    [sym_float_literal] = ACTIONS(4402),
    [sym__string] = ACTIONS(4402),
  },
  [2008] = {
    [sym_identifier] = ACTIONS(4190),
    [anon_sym_q_LBRACE] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4192),
    [anon_sym_DOT] = ACTIONS(4192),
    [anon_sym_AMP] = ACTIONS(4192),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_DASH_DASH] = ACTIONS(4192),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_PLUS_PLUS] = ACTIONS(4192),
    [anon_sym_BANG] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4192),
    [anon_sym_RPAREN] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4192),
    [anon_sym_SEMI] = ACTIONS(4192),
    [anon_sym_DOLLAR] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4192),
    [sym_bool] = ACTIONS(4190),
    [sym_byte] = ACTIONS(4190),
    [sym_ubyte] = ACTIONS(4190),
    [sym_char] = ACTIONS(4190),
    [sym_short] = ACTIONS(4190),
    [sym_ushort] = ACTIONS(4190),
    [sym_int] = ACTIONS(4190),
    [sym_uint] = ACTIONS(4190),
    [sym_long] = ACTIONS(4190),
    [sym_ulong] = ACTIONS(4190),
    [sym_cent] = ACTIONS(4190),
    [sym_ucent] = ACTIONS(4190),
    [sym_wchar] = ACTIONS(4190),
    [sym_dchar] = ACTIONS(4190),
    [sym_float] = ACTIONS(4190),
    [sym_double] = ACTIONS(4190),
    [sym_real] = ACTIONS(4190),
    [sym_ifloat] = ACTIONS(4190),
    [sym_idouble] = ACTIONS(4190),
    [sym_ireal] = ACTIONS(4190),
    [sym_cfloat] = ACTIONS(4190),
    [sym_cdouble] = ACTIONS(4190),
    [sym_creal] = ACTIONS(4190),
    [sym_size_t] = ACTIONS(4190),
    [sym_ptrdiff_t] = ACTIONS(4190),
    [sym_string] = ACTIONS(4190),
    [sym_cstring] = ACTIONS(4190),
    [sym_dstring] = ACTIONS(4190),
    [sym_wstring] = ACTIONS(4190),
    [sym_noreturn] = ACTIONS(4190),
    [sym_true] = ACTIONS(4190),
    [sym_false] = ACTIONS(4190),
    [sym_null] = ACTIONS(4190),
    [sym_super] = ACTIONS(4190),
    [sym_this] = ACTIONS(4190),
    [sym_assert] = ACTIONS(4190),
    [sym_auto] = ACTIONS(4190),
    [sym_cast] = ACTIONS(4190),
    [sym_catch] = ACTIONS(4190),
    [sym_const] = ACTIONS(4190),
    [sym_delegate] = ACTIONS(4190),
    [sym_delete] = ACTIONS(4190),
    [sym_do] = ACTIONS(4190),
    [sym_else] = ACTIONS(4190),
    [sym_finally] = ACTIONS(4190),
    [sym_function] = ACTIONS(4190),
    [sym_immutable] = ACTIONS(4190),
    [sym_import] = ACTIONS(4190),
    [sym_in] = ACTIONS(4190),
    [sym_inout] = ACTIONS(4190),
    [sym_is] = ACTIONS(4190),
    [sym_mixin] = ACTIONS(4190),
    [sym_new] = ACTIONS(4190),
    [sym_out] = ACTIONS(4190),
    [sym_ref] = ACTIONS(4190),
    [sym_shared] = ACTIONS(4190),
    [sym_throw] = ACTIONS(4190),
    [sym_typeid] = ACTIONS(4190),
    [sym_typeof] = ACTIONS(4190),
    [sym_traits] = ACTIONS(4190),
    [sym_vector] = ACTIONS(4190),
    [sym_void] = ACTIONS(4190),
    [anon_sym_BQUOTE] = ACTIONS(4192),
    [anon_sym_r_DQUOTE] = ACTIONS(4192),
    [anon_sym_x_DQUOTE] = ACTIONS(4192),
    [anon_sym_DQUOTE] = ACTIONS(4192),
    [anon_sym_i_BQUOTE] = ACTIONS(4192),
    [anon_sym_i_DQUOTE] = ACTIONS(4192),
    [anon_sym_iq_LBRACE] = ACTIONS(4192),
    [aux_sym_char_literal_token1] = ACTIONS(4192),
    [anon_sym_SQUOTE] = ACTIONS(4190),
    [anon_sym___DATE__] = ACTIONS(4190),
    [anon_sym___FILE__] = ACTIONS(4190),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4190),
    [anon_sym___FUNCTION__] = ACTIONS(4190),
    [anon_sym___LINE__] = ACTIONS(4190),
    [anon_sym___MODULE__] = ACTIONS(4190),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4190),
    [anon_sym___TIME__] = ACTIONS(4190),
    [anon_sym___TIMESTAMP__] = ACTIONS(4190),
    [anon_sym___VENDOR__] = ACTIONS(4190),
    [anon_sym___VERSION__] = ACTIONS(4190),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4192),
    [sym_float_literal] = ACTIONS(4192),
    [sym__string] = ACTIONS(4192),
  },
  [2009] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_q_LBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4759),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_null] = ACTIONS(4755),
    [sym_super] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_assert] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_cast] = ACTIONS(4755),
    [sym_catch] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_delegate] = ACTIONS(4755),
    [sym_delete] = ACTIONS(4755),
    [sym_do] = ACTIONS(4762),
    [sym_else] = ACTIONS(4755),
    [sym_finally] = ACTIONS(4755),
    [sym_function] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(4762),
    [sym_inout] = ACTIONS(4755),
    [sym_is] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_new] = ACTIONS(4755),
    [sym_out] = ACTIONS(4762),
    [sym_ref] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_throw] = ACTIONS(4755),
    [sym_typeid] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4757),
    [anon_sym_r_DQUOTE] = ACTIONS(4757),
    [anon_sym_x_DQUOTE] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_i_BQUOTE] = ACTIONS(4757),
    [anon_sym_i_DQUOTE] = ACTIONS(4757),
    [anon_sym_iq_LBRACE] = ACTIONS(4757),
    [aux_sym_char_literal_token1] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym___DATE__] = ACTIONS(4755),
    [anon_sym___FILE__] = ACTIONS(4755),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4755),
    [anon_sym___FUNCTION__] = ACTIONS(4755),
    [anon_sym___LINE__] = ACTIONS(4755),
    [anon_sym___MODULE__] = ACTIONS(4755),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4755),
    [anon_sym___TIME__] = ACTIONS(4755),
    [anon_sym___TIMESTAMP__] = ACTIONS(4755),
    [anon_sym___VENDOR__] = ACTIONS(4755),
    [anon_sym___VERSION__] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4757),
    [sym_float_literal] = ACTIONS(4757),
    [sym__string] = ACTIONS(4757),
  },
  [2010] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_q_LBRACE] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [sym_bool] = ACTIONS(2634),
    [sym_byte] = ACTIONS(2634),
    [sym_ubyte] = ACTIONS(2634),
    [sym_char] = ACTIONS(2634),
    [sym_short] = ACTIONS(2634),
    [sym_ushort] = ACTIONS(2634),
    [sym_int] = ACTIONS(2634),
    [sym_uint] = ACTIONS(2634),
    [sym_long] = ACTIONS(2634),
    [sym_ulong] = ACTIONS(2634),
    [sym_cent] = ACTIONS(2634),
    [sym_ucent] = ACTIONS(2634),
    [sym_wchar] = ACTIONS(2634),
    [sym_dchar] = ACTIONS(2634),
    [sym_float] = ACTIONS(2634),
    [sym_double] = ACTIONS(2634),
    [sym_real] = ACTIONS(2634),
    [sym_ifloat] = ACTIONS(2634),
    [sym_idouble] = ACTIONS(2634),
    [sym_ireal] = ACTIONS(2634),
    [sym_cfloat] = ACTIONS(2634),
    [sym_cdouble] = ACTIONS(2634),
    [sym_creal] = ACTIONS(2634),
    [sym_size_t] = ACTIONS(2634),
    [sym_ptrdiff_t] = ACTIONS(2634),
    [sym_string] = ACTIONS(2634),
    [sym_cstring] = ACTIONS(2634),
    [sym_dstring] = ACTIONS(2634),
    [sym_wstring] = ACTIONS(2634),
    [sym_noreturn] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_this] = ACTIONS(2634),
    [sym_assert] = ACTIONS(2634),
    [sym_auto] = ACTIONS(2634),
    [sym_cast] = ACTIONS(2634),
    [sym_catch] = ACTIONS(2634),
    [sym_const] = ACTIONS(2634),
    [sym_delegate] = ACTIONS(2634),
    [sym_delete] = ACTIONS(2634),
    [sym_do] = ACTIONS(2634),
    [sym_else] = ACTIONS(5863),
    [sym_finally] = ACTIONS(2634),
    [sym_function] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(2634),
    [sym_import] = ACTIONS(2634),
    [sym_in] = ACTIONS(2634),
    [sym_inout] = ACTIONS(2634),
    [sym_is] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2634),
    [sym_new] = ACTIONS(2634),
    [sym_out] = ACTIONS(2634),
    [sym_ref] = ACTIONS(2634),
    [sym_shared] = ACTIONS(2634),
    [sym_throw] = ACTIONS(2634),
    [sym_typeid] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(2634),
    [sym_traits] = ACTIONS(2634),
    [sym_vector] = ACTIONS(2634),
    [sym_void] = ACTIONS(2634),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_r_DQUOTE] = ACTIONS(2632),
    [anon_sym_x_DQUOTE] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_i_BQUOTE] = ACTIONS(2632),
    [anon_sym_i_DQUOTE] = ACTIONS(2632),
    [anon_sym_iq_LBRACE] = ACTIONS(2632),
    [aux_sym_char_literal_token1] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym___DATE__] = ACTIONS(2634),
    [anon_sym___FILE__] = ACTIONS(2634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2634),
    [anon_sym___FUNCTION__] = ACTIONS(2634),
    [anon_sym___LINE__] = ACTIONS(2634),
    [anon_sym___MODULE__] = ACTIONS(2634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2634),
    [anon_sym___TIME__] = ACTIONS(2634),
    [anon_sym___TIMESTAMP__] = ACTIONS(2634),
    [anon_sym___VENDOR__] = ACTIONS(2634),
    [anon_sym___VERSION__] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__string] = ACTIONS(2632),
  },
  [2011] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_catch] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(5865),
    [sym_finally] = ACTIONS(4682),
    [sym_function] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [2012] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_catch] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(5867),
    [sym_finally] = ACTIONS(4366),
    [sym_function] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [2013] = {
    [sym_identifier] = ACTIONS(4797),
    [anon_sym_q_LBRACE] = ACTIONS(4799),
    [anon_sym_LBRACE] = ACTIONS(4799),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_AMP] = ACTIONS(4799),
    [anon_sym_DASH] = ACTIONS(4797),
    [anon_sym_DASH_DASH] = ACTIONS(4799),
    [anon_sym_PLUS] = ACTIONS(4797),
    [anon_sym_PLUS_PLUS] = ACTIONS(4799),
    [anon_sym_BANG] = ACTIONS(4799),
    [anon_sym_LPAREN] = ACTIONS(4799),
    [anon_sym_RPAREN] = ACTIONS(4799),
    [anon_sym_LBRACK] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_DOLLAR] = ACTIONS(4799),
    [anon_sym_STAR] = ACTIONS(4799),
    [anon_sym_TILDE] = ACTIONS(4799),
    [sym_bool] = ACTIONS(4797),
    [sym_byte] = ACTIONS(4797),
    [sym_ubyte] = ACTIONS(4797),
    [sym_char] = ACTIONS(4797),
    [sym_short] = ACTIONS(4797),
    [sym_ushort] = ACTIONS(4797),
    [sym_int] = ACTIONS(4797),
    [sym_uint] = ACTIONS(4797),
    [sym_long] = ACTIONS(4797),
    [sym_ulong] = ACTIONS(4797),
    [sym_cent] = ACTIONS(4797),
    [sym_ucent] = ACTIONS(4797),
    [sym_wchar] = ACTIONS(4797),
    [sym_dchar] = ACTIONS(4797),
    [sym_float] = ACTIONS(4797),
    [sym_double] = ACTIONS(4797),
    [sym_real] = ACTIONS(4797),
    [sym_ifloat] = ACTIONS(4797),
    [sym_idouble] = ACTIONS(4797),
    [sym_ireal] = ACTIONS(4797),
    [sym_cfloat] = ACTIONS(4797),
    [sym_cdouble] = ACTIONS(4797),
    [sym_creal] = ACTIONS(4797),
    [sym_size_t] = ACTIONS(4797),
    [sym_ptrdiff_t] = ACTIONS(4797),
    [sym_string] = ACTIONS(4797),
    [sym_cstring] = ACTIONS(4797),
    [sym_dstring] = ACTIONS(4797),
    [sym_wstring] = ACTIONS(4797),
    [sym_noreturn] = ACTIONS(4797),
    [sym_true] = ACTIONS(4797),
    [sym_false] = ACTIONS(4797),
    [sym_null] = ACTIONS(4797),
    [sym_super] = ACTIONS(4797),
    [sym_this] = ACTIONS(4797),
    [sym_assert] = ACTIONS(4797),
    [sym_auto] = ACTIONS(4797),
    [sym_cast] = ACTIONS(4797),
    [sym_catch] = ACTIONS(4797),
    [sym_const] = ACTIONS(4797),
    [sym_delegate] = ACTIONS(4797),
    [sym_delete] = ACTIONS(4797),
    [sym_do] = ACTIONS(4797),
    [sym_else] = ACTIONS(4797),
    [sym_finally] = ACTIONS(4797),
    [sym_function] = ACTIONS(4797),
    [sym_immutable] = ACTIONS(4797),
    [sym_import] = ACTIONS(4797),
    [sym_in] = ACTIONS(4797),
    [sym_inout] = ACTIONS(4797),
    [sym_is] = ACTIONS(4797),
    [sym_mixin] = ACTIONS(4797),
    [sym_new] = ACTIONS(4797),
    [sym_out] = ACTIONS(4797),
    [sym_ref] = ACTIONS(4797),
    [sym_shared] = ACTIONS(4797),
    [sym_throw] = ACTIONS(4797),
    [sym_typeid] = ACTIONS(4797),
    [sym_typeof] = ACTIONS(4797),
    [sym_traits] = ACTIONS(4797),
    [sym_vector] = ACTIONS(4797),
    [sym_void] = ACTIONS(4797),
    [anon_sym_BQUOTE] = ACTIONS(4799),
    [anon_sym_r_DQUOTE] = ACTIONS(4799),
    [anon_sym_x_DQUOTE] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(4799),
    [anon_sym_i_BQUOTE] = ACTIONS(4799),
    [anon_sym_i_DQUOTE] = ACTIONS(4799),
    [anon_sym_iq_LBRACE] = ACTIONS(4799),
    [aux_sym_char_literal_token1] = ACTIONS(4799),
    [anon_sym_SQUOTE] = ACTIONS(4797),
    [anon_sym___DATE__] = ACTIONS(4797),
    [anon_sym___FILE__] = ACTIONS(4797),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4797),
    [anon_sym___FUNCTION__] = ACTIONS(4797),
    [anon_sym___LINE__] = ACTIONS(4797),
    [anon_sym___MODULE__] = ACTIONS(4797),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4797),
    [anon_sym___TIME__] = ACTIONS(4797),
    [anon_sym___TIMESTAMP__] = ACTIONS(4797),
    [anon_sym___VENDOR__] = ACTIONS(4797),
    [anon_sym___VERSION__] = ACTIONS(4797),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4799),
    [sym_float_literal] = ACTIONS(4799),
    [sym__string] = ACTIONS(4799),
  },
  [2014] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_q_LBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(4757),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_AMP] = ACTIONS(4757),
    [anon_sym_DASH] = ACTIONS(4755),
    [anon_sym_DASH_DASH] = ACTIONS(4757),
    [anon_sym_PLUS] = ACTIONS(4755),
    [anon_sym_PLUS_PLUS] = ACTIONS(4757),
    [anon_sym_BANG] = ACTIONS(4757),
    [anon_sym_LPAREN] = ACTIONS(4757),
    [anon_sym_RPAREN] = ACTIONS(4757),
    [anon_sym_LBRACK] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_DOLLAR] = ACTIONS(4757),
    [anon_sym_STAR] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_true] = ACTIONS(4755),
    [sym_false] = ACTIONS(4755),
    [sym_null] = ACTIONS(4755),
    [sym_super] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_assert] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_cast] = ACTIONS(4755),
    [sym_catch] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_delegate] = ACTIONS(4755),
    [sym_delete] = ACTIONS(4755),
    [sym_do] = ACTIONS(4755),
    [sym_else] = ACTIONS(4755),
    [sym_finally] = ACTIONS(4755),
    [sym_function] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(4755),
    [sym_inout] = ACTIONS(4755),
    [sym_is] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_new] = ACTIONS(4755),
    [sym_out] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_throw] = ACTIONS(4755),
    [sym_typeid] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [anon_sym_BQUOTE] = ACTIONS(4757),
    [anon_sym_r_DQUOTE] = ACTIONS(4757),
    [anon_sym_x_DQUOTE] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(4757),
    [anon_sym_i_BQUOTE] = ACTIONS(4757),
    [anon_sym_i_DQUOTE] = ACTIONS(4757),
    [anon_sym_iq_LBRACE] = ACTIONS(4757),
    [aux_sym_char_literal_token1] = ACTIONS(4757),
    [anon_sym_SQUOTE] = ACTIONS(4755),
    [anon_sym___DATE__] = ACTIONS(4755),
    [anon_sym___FILE__] = ACTIONS(4755),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4755),
    [anon_sym___FUNCTION__] = ACTIONS(4755),
    [anon_sym___LINE__] = ACTIONS(4755),
    [anon_sym___MODULE__] = ACTIONS(4755),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4755),
    [anon_sym___TIME__] = ACTIONS(4755),
    [anon_sym___TIMESTAMP__] = ACTIONS(4755),
    [anon_sym___VENDOR__] = ACTIONS(4755),
    [anon_sym___VERSION__] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4757),
    [sym_float_literal] = ACTIONS(4757),
    [sym__string] = ACTIONS(4757),
  },
  [2015] = {
    [sym_identifier] = ACTIONS(4741),
    [anon_sym_q_LBRACE] = ACTIONS(4743),
    [anon_sym_LBRACE] = ACTIONS(4743),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4743),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4743),
    [anon_sym_PLUS] = ACTIONS(4741),
    [anon_sym_PLUS_PLUS] = ACTIONS(4743),
    [anon_sym_BANG] = ACTIONS(4743),
    [anon_sym_LPAREN] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [anon_sym_STAR] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [sym_bool] = ACTIONS(4741),
    [sym_byte] = ACTIONS(4741),
    [sym_ubyte] = ACTIONS(4741),
    [sym_char] = ACTIONS(4741),
    [sym_short] = ACTIONS(4741),
    [sym_ushort] = ACTIONS(4741),
    [sym_int] = ACTIONS(4741),
    [sym_uint] = ACTIONS(4741),
    [sym_long] = ACTIONS(4741),
    [sym_ulong] = ACTIONS(4741),
    [sym_cent] = ACTIONS(4741),
    [sym_ucent] = ACTIONS(4741),
    [sym_wchar] = ACTIONS(4741),
    [sym_dchar] = ACTIONS(4741),
    [sym_float] = ACTIONS(4741),
    [sym_double] = ACTIONS(4741),
    [sym_real] = ACTIONS(4741),
    [sym_ifloat] = ACTIONS(4741),
    [sym_idouble] = ACTIONS(4741),
    [sym_ireal] = ACTIONS(4741),
    [sym_cfloat] = ACTIONS(4741),
    [sym_cdouble] = ACTIONS(4741),
    [sym_creal] = ACTIONS(4741),
    [sym_size_t] = ACTIONS(4741),
    [sym_ptrdiff_t] = ACTIONS(4741),
    [sym_string] = ACTIONS(4741),
    [sym_cstring] = ACTIONS(4741),
    [sym_dstring] = ACTIONS(4741),
    [sym_wstring] = ACTIONS(4741),
    [sym_noreturn] = ACTIONS(4741),
    [sym_true] = ACTIONS(4741),
    [sym_false] = ACTIONS(4741),
    [sym_null] = ACTIONS(4741),
    [sym_super] = ACTIONS(4741),
    [sym_this] = ACTIONS(4741),
    [sym_assert] = ACTIONS(4741),
    [sym_auto] = ACTIONS(4741),
    [sym_cast] = ACTIONS(4741),
    [sym_catch] = ACTIONS(4741),
    [sym_const] = ACTIONS(4741),
    [sym_delegate] = ACTIONS(4741),
    [sym_delete] = ACTIONS(4741),
    [sym_do] = ACTIONS(4741),
    [sym_else] = ACTIONS(5869),
    [sym_finally] = ACTIONS(4741),
    [sym_function] = ACTIONS(4741),
    [sym_immutable] = ACTIONS(4741),
    [sym_import] = ACTIONS(4741),
    [sym_in] = ACTIONS(4741),
    [sym_inout] = ACTIONS(4741),
    [sym_is] = ACTIONS(4741),
    [sym_mixin] = ACTIONS(4741),
    [sym_new] = ACTIONS(4741),
    [sym_out] = ACTIONS(4741),
    [sym_ref] = ACTIONS(4741),
    [sym_shared] = ACTIONS(4741),
    [sym_throw] = ACTIONS(4741),
    [sym_typeid] = ACTIONS(4741),
    [sym_typeof] = ACTIONS(4741),
    [sym_traits] = ACTIONS(4741),
    [sym_vector] = ACTIONS(4741),
    [sym_void] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_r_DQUOTE] = ACTIONS(4743),
    [anon_sym_x_DQUOTE] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_i_BQUOTE] = ACTIONS(4743),
    [anon_sym_i_DQUOTE] = ACTIONS(4743),
    [anon_sym_iq_LBRACE] = ACTIONS(4743),
    [aux_sym_char_literal_token1] = ACTIONS(4743),
    [anon_sym_SQUOTE] = ACTIONS(4741),
    [anon_sym___DATE__] = ACTIONS(4741),
    [anon_sym___FILE__] = ACTIONS(4741),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4741),
    [anon_sym___FUNCTION__] = ACTIONS(4741),
    [anon_sym___LINE__] = ACTIONS(4741),
    [anon_sym___MODULE__] = ACTIONS(4741),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4741),
    [anon_sym___TIME__] = ACTIONS(4741),
    [anon_sym___TIMESTAMP__] = ACTIONS(4741),
    [anon_sym___VENDOR__] = ACTIONS(4741),
    [anon_sym___VERSION__] = ACTIONS(4741),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4743),
    [sym_float_literal] = ACTIONS(4743),
    [sym__string] = ACTIONS(4743),
  },
  [2016] = {
    [sym_identifier] = ACTIONS(4396),
    [anon_sym_q_LBRACE] = ACTIONS(4398),
    [anon_sym_LBRACE] = ACTIONS(4398),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_AMP] = ACTIONS(4398),
    [anon_sym_DASH] = ACTIONS(4396),
    [anon_sym_DASH_DASH] = ACTIONS(4398),
    [anon_sym_PLUS] = ACTIONS(4396),
    [anon_sym_PLUS_PLUS] = ACTIONS(4398),
    [anon_sym_BANG] = ACTIONS(4398),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_RPAREN] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_DOLLAR] = ACTIONS(4398),
    [anon_sym_STAR] = ACTIONS(4398),
    [anon_sym_TILDE] = ACTIONS(4398),
    [sym_bool] = ACTIONS(4396),
    [sym_byte] = ACTIONS(4396),
    [sym_ubyte] = ACTIONS(4396),
    [sym_char] = ACTIONS(4396),
    [sym_short] = ACTIONS(4396),
    [sym_ushort] = ACTIONS(4396),
    [sym_int] = ACTIONS(4396),
    [sym_uint] = ACTIONS(4396),
    [sym_long] = ACTIONS(4396),
    [sym_ulong] = ACTIONS(4396),
    [sym_cent] = ACTIONS(4396),
    [sym_ucent] = ACTIONS(4396),
    [sym_wchar] = ACTIONS(4396),
    [sym_dchar] = ACTIONS(4396),
    [sym_float] = ACTIONS(4396),
    [sym_double] = ACTIONS(4396),
    [sym_real] = ACTIONS(4396),
    [sym_ifloat] = ACTIONS(4396),
    [sym_idouble] = ACTIONS(4396),
    [sym_ireal] = ACTIONS(4396),
    [sym_cfloat] = ACTIONS(4396),
    [sym_cdouble] = ACTIONS(4396),
    [sym_creal] = ACTIONS(4396),
    [sym_size_t] = ACTIONS(4396),
    [sym_ptrdiff_t] = ACTIONS(4396),
    [sym_string] = ACTIONS(4396),
    [sym_cstring] = ACTIONS(4396),
    [sym_dstring] = ACTIONS(4396),
    [sym_wstring] = ACTIONS(4396),
    [sym_noreturn] = ACTIONS(4396),
    [sym_true] = ACTIONS(4396),
    [sym_false] = ACTIONS(4396),
    [sym_null] = ACTIONS(4396),
    [sym_super] = ACTIONS(4396),
    [sym_this] = ACTIONS(4396),
    [sym_assert] = ACTIONS(4396),
    [sym_auto] = ACTIONS(4396),
    [sym_cast] = ACTIONS(4396),
    [sym_catch] = ACTIONS(4396),
    [sym_const] = ACTIONS(4396),
    [sym_delegate] = ACTIONS(4396),
    [sym_delete] = ACTIONS(4396),
    [sym_do] = ACTIONS(4396),
    [sym_else] = ACTIONS(4396),
    [sym_finally] = ACTIONS(4396),
    [sym_function] = ACTIONS(4396),
    [sym_immutable] = ACTIONS(4396),
    [sym_import] = ACTIONS(4396),
    [sym_in] = ACTIONS(4396),
    [sym_inout] = ACTIONS(4396),
    [sym_is] = ACTIONS(4396),
    [sym_mixin] = ACTIONS(4396),
    [sym_new] = ACTIONS(4396),
    [sym_out] = ACTIONS(4396),
    [sym_ref] = ACTIONS(4396),
    [sym_shared] = ACTIONS(4396),
    [sym_throw] = ACTIONS(4396),
    [sym_typeid] = ACTIONS(4396),
    [sym_typeof] = ACTIONS(4396),
    [sym_traits] = ACTIONS(4396),
    [sym_vector] = ACTIONS(4396),
    [sym_void] = ACTIONS(4396),
    [anon_sym_BQUOTE] = ACTIONS(4398),
    [anon_sym_r_DQUOTE] = ACTIONS(4398),
    [anon_sym_x_DQUOTE] = ACTIONS(4398),
    [anon_sym_DQUOTE] = ACTIONS(4398),
    [anon_sym_i_BQUOTE] = ACTIONS(4398),
    [anon_sym_i_DQUOTE] = ACTIONS(4398),
    [anon_sym_iq_LBRACE] = ACTIONS(4398),
    [aux_sym_char_literal_token1] = ACTIONS(4398),
    [anon_sym_SQUOTE] = ACTIONS(4396),
    [anon_sym___DATE__] = ACTIONS(4396),
    [anon_sym___FILE__] = ACTIONS(4396),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4396),
    [anon_sym___FUNCTION__] = ACTIONS(4396),
    [anon_sym___LINE__] = ACTIONS(4396),
    [anon_sym___MODULE__] = ACTIONS(4396),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4396),
    [anon_sym___TIME__] = ACTIONS(4396),
    [anon_sym___TIMESTAMP__] = ACTIONS(4396),
    [anon_sym___VENDOR__] = ACTIONS(4396),
    [anon_sym___VERSION__] = ACTIONS(4396),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4398),
    [sym_float_literal] = ACTIONS(4398),
    [sym__string] = ACTIONS(4398),
  },
  [2017] = {
    [sym_identifier] = ACTIONS(4917),
    [anon_sym_q_LBRACE] = ACTIONS(4919),
    [anon_sym_LBRACE] = ACTIONS(4919),
    [anon_sym_DOT] = ACTIONS(4919),
    [anon_sym_AMP] = ACTIONS(4919),
    [anon_sym_DASH] = ACTIONS(4917),
    [anon_sym_DASH_DASH] = ACTIONS(4919),
    [anon_sym_PLUS] = ACTIONS(4917),
    [anon_sym_PLUS_PLUS] = ACTIONS(4919),
    [anon_sym_BANG] = ACTIONS(4919),
    [anon_sym_LPAREN] = ACTIONS(4919),
    [anon_sym_RPAREN] = ACTIONS(4919),
    [anon_sym_LBRACK] = ACTIONS(4919),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_DOLLAR] = ACTIONS(4919),
    [anon_sym_STAR] = ACTIONS(4919),
    [anon_sym_TILDE] = ACTIONS(4919),
    [sym_bool] = ACTIONS(4917),
    [sym_byte] = ACTIONS(4917),
    [sym_ubyte] = ACTIONS(4917),
    [sym_char] = ACTIONS(4917),
    [sym_short] = ACTIONS(4917),
    [sym_ushort] = ACTIONS(4917),
    [sym_int] = ACTIONS(4917),
    [sym_uint] = ACTIONS(4917),
    [sym_long] = ACTIONS(4917),
    [sym_ulong] = ACTIONS(4917),
    [sym_cent] = ACTIONS(4917),
    [sym_ucent] = ACTIONS(4917),
    [sym_wchar] = ACTIONS(4917),
    [sym_dchar] = ACTIONS(4917),
    [sym_float] = ACTIONS(4917),
    [sym_double] = ACTIONS(4917),
    [sym_real] = ACTIONS(4917),
    [sym_ifloat] = ACTIONS(4917),
    [sym_idouble] = ACTIONS(4917),
    [sym_ireal] = ACTIONS(4917),
    [sym_cfloat] = ACTIONS(4917),
    [sym_cdouble] = ACTIONS(4917),
    [sym_creal] = ACTIONS(4917),
    [sym_size_t] = ACTIONS(4917),
    [sym_ptrdiff_t] = ACTIONS(4917),
    [sym_string] = ACTIONS(4917),
    [sym_cstring] = ACTIONS(4917),
    [sym_dstring] = ACTIONS(4917),
    [sym_wstring] = ACTIONS(4917),
    [sym_noreturn] = ACTIONS(4917),
    [sym_true] = ACTIONS(4917),
    [sym_false] = ACTIONS(4917),
    [sym_null] = ACTIONS(4917),
    [sym_super] = ACTIONS(4917),
    [sym_this] = ACTIONS(4917),
    [sym_assert] = ACTIONS(4917),
    [sym_auto] = ACTIONS(4917),
    [sym_cast] = ACTIONS(4917),
    [sym_catch] = ACTIONS(4917),
    [sym_const] = ACTIONS(4917),
    [sym_delegate] = ACTIONS(4917),
    [sym_delete] = ACTIONS(4917),
    [sym_do] = ACTIONS(4917),
    [sym_else] = ACTIONS(4917),
    [sym_finally] = ACTIONS(4917),
    [sym_function] = ACTIONS(4917),
    [sym_immutable] = ACTIONS(4917),
    [sym_import] = ACTIONS(4917),
    [sym_in] = ACTIONS(4917),
    [sym_inout] = ACTIONS(4917),
    [sym_is] = ACTIONS(4917),
    [sym_mixin] = ACTIONS(4917),
    [sym_new] = ACTIONS(4917),
    [sym_out] = ACTIONS(4917),
    [sym_ref] = ACTIONS(4917),
    [sym_shared] = ACTIONS(4917),
    [sym_throw] = ACTIONS(4917),
    [sym_typeid] = ACTIONS(4917),
    [sym_typeof] = ACTIONS(4917),
    [sym_traits] = ACTIONS(4917),
    [sym_vector] = ACTIONS(4917),
    [sym_void] = ACTIONS(4917),
    [anon_sym_BQUOTE] = ACTIONS(4919),
    [anon_sym_r_DQUOTE] = ACTIONS(4919),
    [anon_sym_x_DQUOTE] = ACTIONS(4919),
    [anon_sym_DQUOTE] = ACTIONS(4919),
    [anon_sym_i_BQUOTE] = ACTIONS(4919),
    [anon_sym_i_DQUOTE] = ACTIONS(4919),
    [anon_sym_iq_LBRACE] = ACTIONS(4919),
    [aux_sym_char_literal_token1] = ACTIONS(4919),
    [anon_sym_SQUOTE] = ACTIONS(4917),
    [anon_sym___DATE__] = ACTIONS(4917),
    [anon_sym___FILE__] = ACTIONS(4917),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4917),
    [anon_sym___FUNCTION__] = ACTIONS(4917),
    [anon_sym___LINE__] = ACTIONS(4917),
    [anon_sym___MODULE__] = ACTIONS(4917),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4917),
    [anon_sym___TIME__] = ACTIONS(4917),
    [anon_sym___TIMESTAMP__] = ACTIONS(4917),
    [anon_sym___VENDOR__] = ACTIONS(4917),
    [anon_sym___VERSION__] = ACTIONS(4917),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4919),
    [sym_float_literal] = ACTIONS(4919),
    [sym__string] = ACTIONS(4919),
  },
  [2018] = {
    [sym_identifier] = ACTIONS(4769),
    [anon_sym_q_LBRACE] = ACTIONS(4771),
    [anon_sym_LBRACE] = ACTIONS(4771),
    [anon_sym_DOT] = ACTIONS(4771),
    [anon_sym_AMP] = ACTIONS(4771),
    [anon_sym_DASH] = ACTIONS(4769),
    [anon_sym_DASH_DASH] = ACTIONS(4771),
    [anon_sym_PLUS] = ACTIONS(4769),
    [anon_sym_PLUS_PLUS] = ACTIONS(4771),
    [anon_sym_BANG] = ACTIONS(4771),
    [anon_sym_LPAREN] = ACTIONS(4771),
    [anon_sym_RPAREN] = ACTIONS(4771),
    [anon_sym_LBRACK] = ACTIONS(4771),
    [anon_sym_SEMI] = ACTIONS(4771),
    [anon_sym_DOLLAR] = ACTIONS(4771),
    [anon_sym_STAR] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [sym_bool] = ACTIONS(4769),
    [sym_byte] = ACTIONS(4769),
    [sym_ubyte] = ACTIONS(4769),
    [sym_char] = ACTIONS(4769),
    [sym_short] = ACTIONS(4769),
    [sym_ushort] = ACTIONS(4769),
    [sym_int] = ACTIONS(4769),
    [sym_uint] = ACTIONS(4769),
    [sym_long] = ACTIONS(4769),
    [sym_ulong] = ACTIONS(4769),
    [sym_cent] = ACTIONS(4769),
    [sym_ucent] = ACTIONS(4769),
    [sym_wchar] = ACTIONS(4769),
    [sym_dchar] = ACTIONS(4769),
    [sym_float] = ACTIONS(4769),
    [sym_double] = ACTIONS(4769),
    [sym_real] = ACTIONS(4769),
    [sym_ifloat] = ACTIONS(4769),
    [sym_idouble] = ACTIONS(4769),
    [sym_ireal] = ACTIONS(4769),
    [sym_cfloat] = ACTIONS(4769),
    [sym_cdouble] = ACTIONS(4769),
    [sym_creal] = ACTIONS(4769),
    [sym_size_t] = ACTIONS(4769),
    [sym_ptrdiff_t] = ACTIONS(4769),
    [sym_string] = ACTIONS(4769),
    [sym_cstring] = ACTIONS(4769),
    [sym_dstring] = ACTIONS(4769),
    [sym_wstring] = ACTIONS(4769),
    [sym_noreturn] = ACTIONS(4769),
    [sym_true] = ACTIONS(4769),
    [sym_false] = ACTIONS(4769),
    [sym_null] = ACTIONS(4769),
    [sym_super] = ACTIONS(4769),
    [sym_this] = ACTIONS(4769),
    [sym_assert] = ACTIONS(4769),
    [sym_auto] = ACTIONS(4769),
    [sym_cast] = ACTIONS(4769),
    [sym_catch] = ACTIONS(4769),
    [sym_const] = ACTIONS(4769),
    [sym_delegate] = ACTIONS(4769),
    [sym_delete] = ACTIONS(4769),
    [sym_do] = ACTIONS(4769),
    [sym_else] = ACTIONS(4769),
    [sym_finally] = ACTIONS(4769),
    [sym_function] = ACTIONS(4769),
    [sym_immutable] = ACTIONS(4769),
    [sym_import] = ACTIONS(4769),
    [sym_in] = ACTIONS(4769),
    [sym_inout] = ACTIONS(4769),
    [sym_is] = ACTIONS(4769),
    [sym_mixin] = ACTIONS(4769),
    [sym_new] = ACTIONS(4769),
    [sym_out] = ACTIONS(4769),
    [sym_ref] = ACTIONS(4769),
    [sym_shared] = ACTIONS(4769),
    [sym_throw] = ACTIONS(4769),
    [sym_typeid] = ACTIONS(4769),
    [sym_typeof] = ACTIONS(4769),
    [sym_traits] = ACTIONS(4769),
    [sym_vector] = ACTIONS(4769),
    [sym_void] = ACTIONS(4769),
    [anon_sym_BQUOTE] = ACTIONS(4771),
    [anon_sym_r_DQUOTE] = ACTIONS(4771),
    [anon_sym_x_DQUOTE] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(4771),
    [anon_sym_i_BQUOTE] = ACTIONS(4771),
    [anon_sym_i_DQUOTE] = ACTIONS(4771),
    [anon_sym_iq_LBRACE] = ACTIONS(4771),
    [aux_sym_char_literal_token1] = ACTIONS(4771),
    [anon_sym_SQUOTE] = ACTIONS(4769),
    [anon_sym___DATE__] = ACTIONS(4769),
    [anon_sym___FILE__] = ACTIONS(4769),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4769),
    [anon_sym___FUNCTION__] = ACTIONS(4769),
    [anon_sym___LINE__] = ACTIONS(4769),
    [anon_sym___MODULE__] = ACTIONS(4769),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4769),
    [anon_sym___TIME__] = ACTIONS(4769),
    [anon_sym___TIMESTAMP__] = ACTIONS(4769),
    [anon_sym___VENDOR__] = ACTIONS(4769),
    [anon_sym___VERSION__] = ACTIONS(4769),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4771),
    [sym_float_literal] = ACTIONS(4771),
    [sym__string] = ACTIONS(4771),
  },
  [2019] = {
    [sym_identifier] = ACTIONS(4362),
    [anon_sym_q_LBRACE] = ACTIONS(4364),
    [anon_sym_LBRACE] = ACTIONS(4364),
    [anon_sym_DOT] = ACTIONS(4364),
    [anon_sym_AMP] = ACTIONS(4364),
    [anon_sym_DASH] = ACTIONS(4362),
    [anon_sym_DASH_DASH] = ACTIONS(4364),
    [anon_sym_PLUS] = ACTIONS(4362),
    [anon_sym_PLUS_PLUS] = ACTIONS(4364),
    [anon_sym_BANG] = ACTIONS(4364),
    [anon_sym_LPAREN] = ACTIONS(4364),
    [anon_sym_RPAREN] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(4364),
    [anon_sym_SEMI] = ACTIONS(4364),
    [anon_sym_DOLLAR] = ACTIONS(4364),
    [anon_sym_STAR] = ACTIONS(4364),
    [anon_sym_TILDE] = ACTIONS(4364),
    [sym_bool] = ACTIONS(4362),
    [sym_byte] = ACTIONS(4362),
    [sym_ubyte] = ACTIONS(4362),
    [sym_char] = ACTIONS(4362),
    [sym_short] = ACTIONS(4362),
    [sym_ushort] = ACTIONS(4362),
    [sym_int] = ACTIONS(4362),
    [sym_uint] = ACTIONS(4362),
    [sym_long] = ACTIONS(4362),
    [sym_ulong] = ACTIONS(4362),
    [sym_cent] = ACTIONS(4362),
    [sym_ucent] = ACTIONS(4362),
    [sym_wchar] = ACTIONS(4362),
    [sym_dchar] = ACTIONS(4362),
    [sym_float] = ACTIONS(4362),
    [sym_double] = ACTIONS(4362),
    [sym_real] = ACTIONS(4362),
    [sym_ifloat] = ACTIONS(4362),
    [sym_idouble] = ACTIONS(4362),
    [sym_ireal] = ACTIONS(4362),
    [sym_cfloat] = ACTIONS(4362),
    [sym_cdouble] = ACTIONS(4362),
    [sym_creal] = ACTIONS(4362),
    [sym_size_t] = ACTIONS(4362),
    [sym_ptrdiff_t] = ACTIONS(4362),
    [sym_string] = ACTIONS(4362),
    [sym_cstring] = ACTIONS(4362),
    [sym_dstring] = ACTIONS(4362),
    [sym_wstring] = ACTIONS(4362),
    [sym_noreturn] = ACTIONS(4362),
    [sym_true] = ACTIONS(4362),
    [sym_false] = ACTIONS(4362),
    [sym_null] = ACTIONS(4362),
    [sym_super] = ACTIONS(4362),
    [sym_this] = ACTIONS(4362),
    [sym_assert] = ACTIONS(4362),
    [sym_auto] = ACTIONS(4362),
    [sym_cast] = ACTIONS(4362),
    [sym_catch] = ACTIONS(4362),
    [sym_const] = ACTIONS(4362),
    [sym_delegate] = ACTIONS(4362),
    [sym_delete] = ACTIONS(4362),
    [sym_do] = ACTIONS(4362),
    [sym_else] = ACTIONS(4362),
    [sym_finally] = ACTIONS(4362),
    [sym_function] = ACTIONS(4362),
    [sym_immutable] = ACTIONS(4362),
    [sym_import] = ACTIONS(4362),
    [sym_in] = ACTIONS(4362),
    [sym_inout] = ACTIONS(4362),
    [sym_is] = ACTIONS(4362),
    [sym_mixin] = ACTIONS(4362),
    [sym_new] = ACTIONS(4362),
    [sym_out] = ACTIONS(4362),
    [sym_ref] = ACTIONS(4362),
    [sym_shared] = ACTIONS(4362),
    [sym_throw] = ACTIONS(4362),
    [sym_typeid] = ACTIONS(4362),
    [sym_typeof] = ACTIONS(4362),
    [sym_traits] = ACTIONS(4362),
    [sym_vector] = ACTIONS(4362),
    [sym_void] = ACTIONS(4362),
    [anon_sym_BQUOTE] = ACTIONS(4364),
    [anon_sym_r_DQUOTE] = ACTIONS(4364),
    [anon_sym_x_DQUOTE] = ACTIONS(4364),
    [anon_sym_DQUOTE] = ACTIONS(4364),
    [anon_sym_i_BQUOTE] = ACTIONS(4364),
    [anon_sym_i_DQUOTE] = ACTIONS(4364),
    [anon_sym_iq_LBRACE] = ACTIONS(4364),
    [aux_sym_char_literal_token1] = ACTIONS(4364),
    [anon_sym_SQUOTE] = ACTIONS(4362),
    [anon_sym___DATE__] = ACTIONS(4362),
    [anon_sym___FILE__] = ACTIONS(4362),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4362),
    [anon_sym___FUNCTION__] = ACTIONS(4362),
    [anon_sym___LINE__] = ACTIONS(4362),
    [anon_sym___MODULE__] = ACTIONS(4362),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4362),
    [anon_sym___TIME__] = ACTIONS(4362),
    [anon_sym___TIMESTAMP__] = ACTIONS(4362),
    [anon_sym___VENDOR__] = ACTIONS(4362),
    [anon_sym___VERSION__] = ACTIONS(4362),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4364),
    [sym_float_literal] = ACTIONS(4364),
    [sym__string] = ACTIONS(4364),
  },
  [2020] = {
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_q_LBRACE] = ACTIONS(4458),
    [anon_sym_LBRACE] = ACTIONS(4458),
    [anon_sym_DOT] = ACTIONS(4458),
    [anon_sym_AMP] = ACTIONS(4458),
    [anon_sym_DASH] = ACTIONS(4456),
    [anon_sym_DASH_DASH] = ACTIONS(4458),
    [anon_sym_PLUS] = ACTIONS(4456),
    [anon_sym_PLUS_PLUS] = ACTIONS(4458),
    [anon_sym_BANG] = ACTIONS(4458),
    [anon_sym_LPAREN] = ACTIONS(4458),
    [anon_sym_RPAREN] = ACTIONS(4458),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_SEMI] = ACTIONS(4458),
    [anon_sym_DOLLAR] = ACTIONS(4458),
    [anon_sym_STAR] = ACTIONS(4458),
    [anon_sym_TILDE] = ACTIONS(4458),
    [sym_bool] = ACTIONS(4456),
    [sym_byte] = ACTIONS(4456),
    [sym_ubyte] = ACTIONS(4456),
    [sym_char] = ACTIONS(4456),
    [sym_short] = ACTIONS(4456),
    [sym_ushort] = ACTIONS(4456),
    [sym_int] = ACTIONS(4456),
    [sym_uint] = ACTIONS(4456),
    [sym_long] = ACTIONS(4456),
    [sym_ulong] = ACTIONS(4456),
    [sym_cent] = ACTIONS(4456),
    [sym_ucent] = ACTIONS(4456),
    [sym_wchar] = ACTIONS(4456),
    [sym_dchar] = ACTIONS(4456),
    [sym_float] = ACTIONS(4456),
    [sym_double] = ACTIONS(4456),
    [sym_real] = ACTIONS(4456),
    [sym_ifloat] = ACTIONS(4456),
    [sym_idouble] = ACTIONS(4456),
    [sym_ireal] = ACTIONS(4456),
    [sym_cfloat] = ACTIONS(4456),
    [sym_cdouble] = ACTIONS(4456),
    [sym_creal] = ACTIONS(4456),
    [sym_size_t] = ACTIONS(4456),
    [sym_ptrdiff_t] = ACTIONS(4456),
    [sym_string] = ACTIONS(4456),
    [sym_cstring] = ACTIONS(4456),
    [sym_dstring] = ACTIONS(4456),
    [sym_wstring] = ACTIONS(4456),
    [sym_noreturn] = ACTIONS(4456),
    [sym_true] = ACTIONS(4456),
    [sym_false] = ACTIONS(4456),
    [sym_null] = ACTIONS(4456),
    [sym_super] = ACTIONS(4456),
    [sym_this] = ACTIONS(4456),
    [sym_assert] = ACTIONS(4456),
    [sym_auto] = ACTIONS(4456),
    [sym_cast] = ACTIONS(4456),
    [sym_catch] = ACTIONS(4456),
    [sym_const] = ACTIONS(4456),
    [sym_delegate] = ACTIONS(4456),
    [sym_delete] = ACTIONS(4456),
    [sym_do] = ACTIONS(4456),
    [sym_else] = ACTIONS(4456),
    [sym_finally] = ACTIONS(4456),
    [sym_function] = ACTIONS(4456),
    [sym_immutable] = ACTIONS(4456),
    [sym_import] = ACTIONS(4456),
    [sym_in] = ACTIONS(4456),
    [sym_inout] = ACTIONS(4456),
    [sym_is] = ACTIONS(4456),
    [sym_mixin] = ACTIONS(4456),
    [sym_new] = ACTIONS(4456),
    [sym_out] = ACTIONS(4456),
    [sym_ref] = ACTIONS(4456),
    [sym_shared] = ACTIONS(4456),
    [sym_throw] = ACTIONS(4456),
    [sym_typeid] = ACTIONS(4456),
    [sym_typeof] = ACTIONS(4456),
    [sym_traits] = ACTIONS(4456),
    [sym_vector] = ACTIONS(4456),
    [sym_void] = ACTIONS(4456),
    [anon_sym_BQUOTE] = ACTIONS(4458),
    [anon_sym_r_DQUOTE] = ACTIONS(4458),
    [anon_sym_x_DQUOTE] = ACTIONS(4458),
    [anon_sym_DQUOTE] = ACTIONS(4458),
    [anon_sym_i_BQUOTE] = ACTIONS(4458),
    [anon_sym_i_DQUOTE] = ACTIONS(4458),
    [anon_sym_iq_LBRACE] = ACTIONS(4458),
    [aux_sym_char_literal_token1] = ACTIONS(4458),
    [anon_sym_SQUOTE] = ACTIONS(4456),
    [anon_sym___DATE__] = ACTIONS(4456),
    [anon_sym___FILE__] = ACTIONS(4456),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4456),
    [anon_sym___FUNCTION__] = ACTIONS(4456),
    [anon_sym___LINE__] = ACTIONS(4456),
    [anon_sym___MODULE__] = ACTIONS(4456),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4456),
    [anon_sym___TIME__] = ACTIONS(4456),
    [anon_sym___TIMESTAMP__] = ACTIONS(4456),
    [anon_sym___VENDOR__] = ACTIONS(4456),
    [anon_sym___VERSION__] = ACTIONS(4456),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4458),
    [sym_float_literal] = ACTIONS(4458),
    [sym__string] = ACTIONS(4458),
  },
  [2021] = {
    [sym_identifier] = ACTIONS(4737),
    [anon_sym_q_LBRACE] = ACTIONS(4739),
    [anon_sym_LBRACE] = ACTIONS(4739),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_AMP] = ACTIONS(4739),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_DASH_DASH] = ACTIONS(4739),
    [anon_sym_PLUS] = ACTIONS(4737),
    [anon_sym_PLUS_PLUS] = ACTIONS(4739),
    [anon_sym_BANG] = ACTIONS(4739),
    [anon_sym_LPAREN] = ACTIONS(4739),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [anon_sym_LBRACK] = ACTIONS(4739),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_DOLLAR] = ACTIONS(4739),
    [anon_sym_STAR] = ACTIONS(4739),
    [anon_sym_TILDE] = ACTIONS(4739),
    [sym_bool] = ACTIONS(4737),
    [sym_byte] = ACTIONS(4737),
    [sym_ubyte] = ACTIONS(4737),
    [sym_char] = ACTIONS(4737),
    [sym_short] = ACTIONS(4737),
    [sym_ushort] = ACTIONS(4737),
    [sym_int] = ACTIONS(4737),
    [sym_uint] = ACTIONS(4737),
    [sym_long] = ACTIONS(4737),
    [sym_ulong] = ACTIONS(4737),
    [sym_cent] = ACTIONS(4737),
    [sym_ucent] = ACTIONS(4737),
    [sym_wchar] = ACTIONS(4737),
    [sym_dchar] = ACTIONS(4737),
    [sym_float] = ACTIONS(4737),
    [sym_double] = ACTIONS(4737),
    [sym_real] = ACTIONS(4737),
    [sym_ifloat] = ACTIONS(4737),
    [sym_idouble] = ACTIONS(4737),
    [sym_ireal] = ACTIONS(4737),
    [sym_cfloat] = ACTIONS(4737),
    [sym_cdouble] = ACTIONS(4737),
    [sym_creal] = ACTIONS(4737),
    [sym_size_t] = ACTIONS(4737),
    [sym_ptrdiff_t] = ACTIONS(4737),
    [sym_string] = ACTIONS(4737),
    [sym_cstring] = ACTIONS(4737),
    [sym_dstring] = ACTIONS(4737),
    [sym_wstring] = ACTIONS(4737),
    [sym_noreturn] = ACTIONS(4737),
    [sym_true] = ACTIONS(4737),
    [sym_false] = ACTIONS(4737),
    [sym_null] = ACTIONS(4737),
    [sym_super] = ACTIONS(4737),
    [sym_this] = ACTIONS(4737),
    [sym_assert] = ACTIONS(4737),
    [sym_auto] = ACTIONS(4737),
    [sym_cast] = ACTIONS(4737),
    [sym_catch] = ACTIONS(4737),
    [sym_const] = ACTIONS(4737),
    [sym_delegate] = ACTIONS(4737),
    [sym_delete] = ACTIONS(4737),
    [sym_do] = ACTIONS(4737),
    [sym_else] = ACTIONS(4737),
    [sym_finally] = ACTIONS(4737),
    [sym_function] = ACTIONS(4737),
    [sym_immutable] = ACTIONS(4737),
    [sym_import] = ACTIONS(4737),
    [sym_in] = ACTIONS(4737),
    [sym_inout] = ACTIONS(4737),
    [sym_is] = ACTIONS(4737),
    [sym_mixin] = ACTIONS(4737),
    [sym_new] = ACTIONS(4737),
    [sym_out] = ACTIONS(4737),
    [sym_ref] = ACTIONS(4737),
    [sym_shared] = ACTIONS(4737),
    [sym_throw] = ACTIONS(4737),
    [sym_typeid] = ACTIONS(4737),
    [sym_typeof] = ACTIONS(4737),
    [sym_traits] = ACTIONS(4737),
    [sym_vector] = ACTIONS(4737),
    [sym_void] = ACTIONS(4737),
    [anon_sym_BQUOTE] = ACTIONS(4739),
    [anon_sym_r_DQUOTE] = ACTIONS(4739),
    [anon_sym_x_DQUOTE] = ACTIONS(4739),
    [anon_sym_DQUOTE] = ACTIONS(4739),
    [anon_sym_i_BQUOTE] = ACTIONS(4739),
    [anon_sym_i_DQUOTE] = ACTIONS(4739),
    [anon_sym_iq_LBRACE] = ACTIONS(4739),
    [aux_sym_char_literal_token1] = ACTIONS(4739),
    [anon_sym_SQUOTE] = ACTIONS(4737),
    [anon_sym___DATE__] = ACTIONS(4737),
    [anon_sym___FILE__] = ACTIONS(4737),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4737),
    [anon_sym___FUNCTION__] = ACTIONS(4737),
    [anon_sym___LINE__] = ACTIONS(4737),
    [anon_sym___MODULE__] = ACTIONS(4737),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4737),
    [anon_sym___TIME__] = ACTIONS(4737),
    [anon_sym___TIMESTAMP__] = ACTIONS(4737),
    [anon_sym___VENDOR__] = ACTIONS(4737),
    [anon_sym___VERSION__] = ACTIONS(4737),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4739),
    [sym_float_literal] = ACTIONS(4739),
    [sym__string] = ACTIONS(4739),
  },
  [2022] = {
    [sym_identifier] = ACTIONS(4933),
    [anon_sym_q_LBRACE] = ACTIONS(4935),
    [anon_sym_LBRACE] = ACTIONS(4935),
    [anon_sym_DOT] = ACTIONS(4935),
    [anon_sym_AMP] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4933),
    [anon_sym_DASH_DASH] = ACTIONS(4935),
    [anon_sym_PLUS] = ACTIONS(4933),
    [anon_sym_PLUS_PLUS] = ACTIONS(4935),
    [anon_sym_BANG] = ACTIONS(4935),
    [anon_sym_LPAREN] = ACTIONS(4935),
    [anon_sym_RPAREN] = ACTIONS(4935),
    [anon_sym_LBRACK] = ACTIONS(4935),
    [anon_sym_SEMI] = ACTIONS(4935),
    [anon_sym_DOLLAR] = ACTIONS(4935),
    [anon_sym_STAR] = ACTIONS(4935),
    [anon_sym_TILDE] = ACTIONS(4935),
    [sym_bool] = ACTIONS(4933),
    [sym_byte] = ACTIONS(4933),
    [sym_ubyte] = ACTIONS(4933),
    [sym_char] = ACTIONS(4933),
    [sym_short] = ACTIONS(4933),
    [sym_ushort] = ACTIONS(4933),
    [sym_int] = ACTIONS(4933),
    [sym_uint] = ACTIONS(4933),
    [sym_long] = ACTIONS(4933),
    [sym_ulong] = ACTIONS(4933),
    [sym_cent] = ACTIONS(4933),
    [sym_ucent] = ACTIONS(4933),
    [sym_wchar] = ACTIONS(4933),
    [sym_dchar] = ACTIONS(4933),
    [sym_float] = ACTIONS(4933),
    [sym_double] = ACTIONS(4933),
    [sym_real] = ACTIONS(4933),
    [sym_ifloat] = ACTIONS(4933),
    [sym_idouble] = ACTIONS(4933),
    [sym_ireal] = ACTIONS(4933),
    [sym_cfloat] = ACTIONS(4933),
    [sym_cdouble] = ACTIONS(4933),
    [sym_creal] = ACTIONS(4933),
    [sym_size_t] = ACTIONS(4933),
    [sym_ptrdiff_t] = ACTIONS(4933),
    [sym_string] = ACTIONS(4933),
    [sym_cstring] = ACTIONS(4933),
    [sym_dstring] = ACTIONS(4933),
    [sym_wstring] = ACTIONS(4933),
    [sym_noreturn] = ACTIONS(4933),
    [sym_true] = ACTIONS(4933),
    [sym_false] = ACTIONS(4933),
    [sym_null] = ACTIONS(4933),
    [sym_super] = ACTIONS(4933),
    [sym_this] = ACTIONS(4933),
    [sym_assert] = ACTIONS(4933),
    [sym_auto] = ACTIONS(4933),
    [sym_cast] = ACTIONS(4933),
    [sym_catch] = ACTIONS(4933),
    [sym_const] = ACTIONS(4933),
    [sym_delegate] = ACTIONS(4933),
    [sym_delete] = ACTIONS(4933),
    [sym_do] = ACTIONS(4933),
    [sym_else] = ACTIONS(4933),
    [sym_finally] = ACTIONS(4933),
    [sym_function] = ACTIONS(4933),
    [sym_immutable] = ACTIONS(4933),
    [sym_import] = ACTIONS(4933),
    [sym_in] = ACTIONS(4933),
    [sym_inout] = ACTIONS(4933),
    [sym_is] = ACTIONS(4933),
    [sym_mixin] = ACTIONS(4933),
    [sym_new] = ACTIONS(4933),
    [sym_out] = ACTIONS(4933),
    [sym_ref] = ACTIONS(4933),
    [sym_shared] = ACTIONS(4933),
    [sym_throw] = ACTIONS(4933),
    [sym_typeid] = ACTIONS(4933),
    [sym_typeof] = ACTIONS(4933),
    [sym_traits] = ACTIONS(4933),
    [sym_vector] = ACTIONS(4933),
    [sym_void] = ACTIONS(4933),
    [anon_sym_BQUOTE] = ACTIONS(4935),
    [anon_sym_r_DQUOTE] = ACTIONS(4935),
    [anon_sym_x_DQUOTE] = ACTIONS(4935),
    [anon_sym_DQUOTE] = ACTIONS(4935),
    [anon_sym_i_BQUOTE] = ACTIONS(4935),
    [anon_sym_i_DQUOTE] = ACTIONS(4935),
    [anon_sym_iq_LBRACE] = ACTIONS(4935),
    [aux_sym_char_literal_token1] = ACTIONS(4935),
    [anon_sym_SQUOTE] = ACTIONS(4933),
    [anon_sym___DATE__] = ACTIONS(4933),
    [anon_sym___FILE__] = ACTIONS(4933),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4933),
    [anon_sym___FUNCTION__] = ACTIONS(4933),
    [anon_sym___LINE__] = ACTIONS(4933),
    [anon_sym___MODULE__] = ACTIONS(4933),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4933),
    [anon_sym___TIME__] = ACTIONS(4933),
    [anon_sym___TIMESTAMP__] = ACTIONS(4933),
    [anon_sym___VENDOR__] = ACTIONS(4933),
    [anon_sym___VERSION__] = ACTIONS(4933),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4935),
    [sym_float_literal] = ACTIONS(4935),
    [sym__string] = ACTIONS(4935),
  },
  [2023] = {
    [sym_identifier] = ACTIONS(4937),
    [anon_sym_q_LBRACE] = ACTIONS(4939),
    [anon_sym_LBRACE] = ACTIONS(4939),
    [anon_sym_DOT] = ACTIONS(4939),
    [anon_sym_AMP] = ACTIONS(4939),
    [anon_sym_DASH] = ACTIONS(4937),
    [anon_sym_DASH_DASH] = ACTIONS(4939),
    [anon_sym_PLUS] = ACTIONS(4937),
    [anon_sym_PLUS_PLUS] = ACTIONS(4939),
    [anon_sym_BANG] = ACTIONS(4939),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [anon_sym_RPAREN] = ACTIONS(4939),
    [anon_sym_LBRACK] = ACTIONS(4939),
    [anon_sym_SEMI] = ACTIONS(4939),
    [anon_sym_DOLLAR] = ACTIONS(4939),
    [anon_sym_STAR] = ACTIONS(4939),
    [anon_sym_TILDE] = ACTIONS(4939),
    [sym_bool] = ACTIONS(4937),
    [sym_byte] = ACTIONS(4937),
    [sym_ubyte] = ACTIONS(4937),
    [sym_char] = ACTIONS(4937),
    [sym_short] = ACTIONS(4937),
    [sym_ushort] = ACTIONS(4937),
    [sym_int] = ACTIONS(4937),
    [sym_uint] = ACTIONS(4937),
    [sym_long] = ACTIONS(4937),
    [sym_ulong] = ACTIONS(4937),
    [sym_cent] = ACTIONS(4937),
    [sym_ucent] = ACTIONS(4937),
    [sym_wchar] = ACTIONS(4937),
    [sym_dchar] = ACTIONS(4937),
    [sym_float] = ACTIONS(4937),
    [sym_double] = ACTIONS(4937),
    [sym_real] = ACTIONS(4937),
    [sym_ifloat] = ACTIONS(4937),
    [sym_idouble] = ACTIONS(4937),
    [sym_ireal] = ACTIONS(4937),
    [sym_cfloat] = ACTIONS(4937),
    [sym_cdouble] = ACTIONS(4937),
    [sym_creal] = ACTIONS(4937),
    [sym_size_t] = ACTIONS(4937),
    [sym_ptrdiff_t] = ACTIONS(4937),
    [sym_string] = ACTIONS(4937),
    [sym_cstring] = ACTIONS(4937),
    [sym_dstring] = ACTIONS(4937),
    [sym_wstring] = ACTIONS(4937),
    [sym_noreturn] = ACTIONS(4937),
    [sym_true] = ACTIONS(4937),
    [sym_false] = ACTIONS(4937),
    [sym_null] = ACTIONS(4937),
    [sym_super] = ACTIONS(4937),
    [sym_this] = ACTIONS(4937),
    [sym_assert] = ACTIONS(4937),
    [sym_auto] = ACTIONS(4937),
    [sym_cast] = ACTIONS(4937),
    [sym_catch] = ACTIONS(4937),
    [sym_const] = ACTIONS(4937),
    [sym_delegate] = ACTIONS(4937),
    [sym_delete] = ACTIONS(4937),
    [sym_do] = ACTIONS(4937),
    [sym_else] = ACTIONS(4937),
    [sym_finally] = ACTIONS(4937),
    [sym_function] = ACTIONS(4937),
    [sym_immutable] = ACTIONS(4937),
    [sym_import] = ACTIONS(4937),
    [sym_in] = ACTIONS(4937),
    [sym_inout] = ACTIONS(4937),
    [sym_is] = ACTIONS(4937),
    [sym_mixin] = ACTIONS(4937),
    [sym_new] = ACTIONS(4937),
    [sym_out] = ACTIONS(4937),
    [sym_ref] = ACTIONS(4937),
    [sym_shared] = ACTIONS(4937),
    [sym_throw] = ACTIONS(4937),
    [sym_typeid] = ACTIONS(4937),
    [sym_typeof] = ACTIONS(4937),
    [sym_traits] = ACTIONS(4937),
    [sym_vector] = ACTIONS(4937),
    [sym_void] = ACTIONS(4937),
    [anon_sym_BQUOTE] = ACTIONS(4939),
    [anon_sym_r_DQUOTE] = ACTIONS(4939),
    [anon_sym_x_DQUOTE] = ACTIONS(4939),
    [anon_sym_DQUOTE] = ACTIONS(4939),
    [anon_sym_i_BQUOTE] = ACTIONS(4939),
    [anon_sym_i_DQUOTE] = ACTIONS(4939),
    [anon_sym_iq_LBRACE] = ACTIONS(4939),
    [aux_sym_char_literal_token1] = ACTIONS(4939),
    [anon_sym_SQUOTE] = ACTIONS(4937),
    [anon_sym___DATE__] = ACTIONS(4937),
    [anon_sym___FILE__] = ACTIONS(4937),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4937),
    [anon_sym___FUNCTION__] = ACTIONS(4937),
    [anon_sym___LINE__] = ACTIONS(4937),
    [anon_sym___MODULE__] = ACTIONS(4937),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4937),
    [anon_sym___TIME__] = ACTIONS(4937),
    [anon_sym___TIMESTAMP__] = ACTIONS(4937),
    [anon_sym___VENDOR__] = ACTIONS(4937),
    [anon_sym___VERSION__] = ACTIONS(4937),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4939),
    [sym_float_literal] = ACTIONS(4939),
    [sym__string] = ACTIONS(4939),
  },
  [2024] = {
    [sym_identifier] = ACTIONS(4945),
    [anon_sym_q_LBRACE] = ACTIONS(4947),
    [anon_sym_LBRACE] = ACTIONS(4947),
    [anon_sym_DOT] = ACTIONS(4947),
    [anon_sym_AMP] = ACTIONS(4947),
    [anon_sym_DASH] = ACTIONS(4945),
    [anon_sym_DASH_DASH] = ACTIONS(4947),
    [anon_sym_PLUS] = ACTIONS(4945),
    [anon_sym_PLUS_PLUS] = ACTIONS(4947),
    [anon_sym_BANG] = ACTIONS(4947),
    [anon_sym_LPAREN] = ACTIONS(4947),
    [anon_sym_RPAREN] = ACTIONS(4947),
    [anon_sym_LBRACK] = ACTIONS(4947),
    [anon_sym_SEMI] = ACTIONS(4947),
    [anon_sym_DOLLAR] = ACTIONS(4947),
    [anon_sym_STAR] = ACTIONS(4947),
    [anon_sym_TILDE] = ACTIONS(4947),
    [sym_bool] = ACTIONS(4945),
    [sym_byte] = ACTIONS(4945),
    [sym_ubyte] = ACTIONS(4945),
    [sym_char] = ACTIONS(4945),
    [sym_short] = ACTIONS(4945),
    [sym_ushort] = ACTIONS(4945),
    [sym_int] = ACTIONS(4945),
    [sym_uint] = ACTIONS(4945),
    [sym_long] = ACTIONS(4945),
    [sym_ulong] = ACTIONS(4945),
    [sym_cent] = ACTIONS(4945),
    [sym_ucent] = ACTIONS(4945),
    [sym_wchar] = ACTIONS(4945),
    [sym_dchar] = ACTIONS(4945),
    [sym_float] = ACTIONS(4945),
    [sym_double] = ACTIONS(4945),
    [sym_real] = ACTIONS(4945),
    [sym_ifloat] = ACTIONS(4945),
    [sym_idouble] = ACTIONS(4945),
    [sym_ireal] = ACTIONS(4945),
    [sym_cfloat] = ACTIONS(4945),
    [sym_cdouble] = ACTIONS(4945),
    [sym_creal] = ACTIONS(4945),
    [sym_size_t] = ACTIONS(4945),
    [sym_ptrdiff_t] = ACTIONS(4945),
    [sym_string] = ACTIONS(4945),
    [sym_cstring] = ACTIONS(4945),
    [sym_dstring] = ACTIONS(4945),
    [sym_wstring] = ACTIONS(4945),
    [sym_noreturn] = ACTIONS(4945),
    [sym_true] = ACTIONS(4945),
    [sym_false] = ACTIONS(4945),
    [sym_null] = ACTIONS(4945),
    [sym_super] = ACTIONS(4945),
    [sym_this] = ACTIONS(4945),
    [sym_assert] = ACTIONS(4945),
    [sym_auto] = ACTIONS(4945),
    [sym_cast] = ACTIONS(4945),
    [sym_catch] = ACTIONS(4945),
    [sym_const] = ACTIONS(4945),
    [sym_delegate] = ACTIONS(4945),
    [sym_delete] = ACTIONS(4945),
    [sym_do] = ACTIONS(4945),
    [sym_else] = ACTIONS(4945),
    [sym_finally] = ACTIONS(4945),
    [sym_function] = ACTIONS(4945),
    [sym_immutable] = ACTIONS(4945),
    [sym_import] = ACTIONS(4945),
    [sym_in] = ACTIONS(4945),
    [sym_inout] = ACTIONS(4945),
    [sym_is] = ACTIONS(4945),
    [sym_mixin] = ACTIONS(4945),
    [sym_new] = ACTIONS(4945),
    [sym_out] = ACTIONS(4945),
    [sym_ref] = ACTIONS(4945),
    [sym_shared] = ACTIONS(4945),
    [sym_throw] = ACTIONS(4945),
    [sym_typeid] = ACTIONS(4945),
    [sym_typeof] = ACTIONS(4945),
    [sym_traits] = ACTIONS(4945),
    [sym_vector] = ACTIONS(4945),
    [sym_void] = ACTIONS(4945),
    [anon_sym_BQUOTE] = ACTIONS(4947),
    [anon_sym_r_DQUOTE] = ACTIONS(4947),
    [anon_sym_x_DQUOTE] = ACTIONS(4947),
    [anon_sym_DQUOTE] = ACTIONS(4947),
    [anon_sym_i_BQUOTE] = ACTIONS(4947),
    [anon_sym_i_DQUOTE] = ACTIONS(4947),
    [anon_sym_iq_LBRACE] = ACTIONS(4947),
    [aux_sym_char_literal_token1] = ACTIONS(4947),
    [anon_sym_SQUOTE] = ACTIONS(4945),
    [anon_sym___DATE__] = ACTIONS(4945),
    [anon_sym___FILE__] = ACTIONS(4945),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4945),
    [anon_sym___FUNCTION__] = ACTIONS(4945),
    [anon_sym___LINE__] = ACTIONS(4945),
    [anon_sym___MODULE__] = ACTIONS(4945),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4945),
    [anon_sym___TIME__] = ACTIONS(4945),
    [anon_sym___TIMESTAMP__] = ACTIONS(4945),
    [anon_sym___VENDOR__] = ACTIONS(4945),
    [anon_sym___VERSION__] = ACTIONS(4945),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4947),
    [sym_float_literal] = ACTIONS(4947),
    [sym__string] = ACTIONS(4947),
  },
  [2025] = {
    [sym_identifier] = ACTIONS(4949),
    [anon_sym_q_LBRACE] = ACTIONS(4951),
    [anon_sym_LBRACE] = ACTIONS(4951),
    [anon_sym_DOT] = ACTIONS(4951),
    [anon_sym_AMP] = ACTIONS(4951),
    [anon_sym_DASH] = ACTIONS(4949),
    [anon_sym_DASH_DASH] = ACTIONS(4951),
    [anon_sym_PLUS] = ACTIONS(4949),
    [anon_sym_PLUS_PLUS] = ACTIONS(4951),
    [anon_sym_BANG] = ACTIONS(4951),
    [anon_sym_LPAREN] = ACTIONS(4951),
    [anon_sym_RPAREN] = ACTIONS(4951),
    [anon_sym_LBRACK] = ACTIONS(4951),
    [anon_sym_SEMI] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(4951),
    [anon_sym_STAR] = ACTIONS(4951),
    [anon_sym_TILDE] = ACTIONS(4951),
    [sym_bool] = ACTIONS(4949),
    [sym_byte] = ACTIONS(4949),
    [sym_ubyte] = ACTIONS(4949),
    [sym_char] = ACTIONS(4949),
    [sym_short] = ACTIONS(4949),
    [sym_ushort] = ACTIONS(4949),
    [sym_int] = ACTIONS(4949),
    [sym_uint] = ACTIONS(4949),
    [sym_long] = ACTIONS(4949),
    [sym_ulong] = ACTIONS(4949),
    [sym_cent] = ACTIONS(4949),
    [sym_ucent] = ACTIONS(4949),
    [sym_wchar] = ACTIONS(4949),
    [sym_dchar] = ACTIONS(4949),
    [sym_float] = ACTIONS(4949),
    [sym_double] = ACTIONS(4949),
    [sym_real] = ACTIONS(4949),
    [sym_ifloat] = ACTIONS(4949),
    [sym_idouble] = ACTIONS(4949),
    [sym_ireal] = ACTIONS(4949),
    [sym_cfloat] = ACTIONS(4949),
    [sym_cdouble] = ACTIONS(4949),
    [sym_creal] = ACTIONS(4949),
    [sym_size_t] = ACTIONS(4949),
    [sym_ptrdiff_t] = ACTIONS(4949),
    [sym_string] = ACTIONS(4949),
    [sym_cstring] = ACTIONS(4949),
    [sym_dstring] = ACTIONS(4949),
    [sym_wstring] = ACTIONS(4949),
    [sym_noreturn] = ACTIONS(4949),
    [sym_true] = ACTIONS(4949),
    [sym_false] = ACTIONS(4949),
    [sym_null] = ACTIONS(4949),
    [sym_super] = ACTIONS(4949),
    [sym_this] = ACTIONS(4949),
    [sym_assert] = ACTIONS(4949),
    [sym_auto] = ACTIONS(4949),
    [sym_cast] = ACTIONS(4949),
    [sym_catch] = ACTIONS(4949),
    [sym_const] = ACTIONS(4949),
    [sym_delegate] = ACTIONS(4949),
    [sym_delete] = ACTIONS(4949),
    [sym_do] = ACTIONS(4949),
    [sym_else] = ACTIONS(4949),
    [sym_finally] = ACTIONS(4949),
    [sym_function] = ACTIONS(4949),
    [sym_immutable] = ACTIONS(4949),
    [sym_import] = ACTIONS(4949),
    [sym_in] = ACTIONS(4949),
    [sym_inout] = ACTIONS(4949),
    [sym_is] = ACTIONS(4949),
    [sym_mixin] = ACTIONS(4949),
    [sym_new] = ACTIONS(4949),
    [sym_out] = ACTIONS(4949),
    [sym_ref] = ACTIONS(4949),
    [sym_shared] = ACTIONS(4949),
    [sym_throw] = ACTIONS(4949),
    [sym_typeid] = ACTIONS(4949),
    [sym_typeof] = ACTIONS(4949),
    [sym_traits] = ACTIONS(4949),
    [sym_vector] = ACTIONS(4949),
    [sym_void] = ACTIONS(4949),
    [anon_sym_BQUOTE] = ACTIONS(4951),
    [anon_sym_r_DQUOTE] = ACTIONS(4951),
    [anon_sym_x_DQUOTE] = ACTIONS(4951),
    [anon_sym_DQUOTE] = ACTIONS(4951),
    [anon_sym_i_BQUOTE] = ACTIONS(4951),
    [anon_sym_i_DQUOTE] = ACTIONS(4951),
    [anon_sym_iq_LBRACE] = ACTIONS(4951),
    [aux_sym_char_literal_token1] = ACTIONS(4951),
    [anon_sym_SQUOTE] = ACTIONS(4949),
    [anon_sym___DATE__] = ACTIONS(4949),
    [anon_sym___FILE__] = ACTIONS(4949),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4949),
    [anon_sym___FUNCTION__] = ACTIONS(4949),
    [anon_sym___LINE__] = ACTIONS(4949),
    [anon_sym___MODULE__] = ACTIONS(4949),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4949),
    [anon_sym___TIME__] = ACTIONS(4949),
    [anon_sym___TIMESTAMP__] = ACTIONS(4949),
    [anon_sym___VENDOR__] = ACTIONS(4949),
    [anon_sym___VERSION__] = ACTIONS(4949),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4951),
    [sym_float_literal] = ACTIONS(4951),
    [sym__string] = ACTIONS(4951),
  },
  [2026] = {
    [sym_identifier] = ACTIONS(4570),
    [anon_sym_q_LBRACE] = ACTIONS(4572),
    [anon_sym_LBRACE] = ACTIONS(4572),
    [anon_sym_DOT] = ACTIONS(4572),
    [anon_sym_AMP] = ACTIONS(4572),
    [anon_sym_DASH] = ACTIONS(4570),
    [anon_sym_DASH_DASH] = ACTIONS(4572),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_PLUS_PLUS] = ACTIONS(4572),
    [anon_sym_BANG] = ACTIONS(4572),
    [anon_sym_LPAREN] = ACTIONS(4572),
    [anon_sym_RPAREN] = ACTIONS(4572),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4572),
    [anon_sym_DOLLAR] = ACTIONS(4572),
    [anon_sym_STAR] = ACTIONS(4572),
    [anon_sym_TILDE] = ACTIONS(4572),
    [sym_bool] = ACTIONS(4570),
    [sym_byte] = ACTIONS(4570),
    [sym_ubyte] = ACTIONS(4570),
    [sym_char] = ACTIONS(4570),
    [sym_short] = ACTIONS(4570),
    [sym_ushort] = ACTIONS(4570),
    [sym_int] = ACTIONS(4570),
    [sym_uint] = ACTIONS(4570),
    [sym_long] = ACTIONS(4570),
    [sym_ulong] = ACTIONS(4570),
    [sym_cent] = ACTIONS(4570),
    [sym_ucent] = ACTIONS(4570),
    [sym_wchar] = ACTIONS(4570),
    [sym_dchar] = ACTIONS(4570),
    [sym_float] = ACTIONS(4570),
    [sym_double] = ACTIONS(4570),
    [sym_real] = ACTIONS(4570),
    [sym_ifloat] = ACTIONS(4570),
    [sym_idouble] = ACTIONS(4570),
    [sym_ireal] = ACTIONS(4570),
    [sym_cfloat] = ACTIONS(4570),
    [sym_cdouble] = ACTIONS(4570),
    [sym_creal] = ACTIONS(4570),
    [sym_size_t] = ACTIONS(4570),
    [sym_ptrdiff_t] = ACTIONS(4570),
    [sym_string] = ACTIONS(4570),
    [sym_cstring] = ACTIONS(4570),
    [sym_dstring] = ACTIONS(4570),
    [sym_wstring] = ACTIONS(4570),
    [sym_noreturn] = ACTIONS(4570),
    [sym_true] = ACTIONS(4570),
    [sym_false] = ACTIONS(4570),
    [sym_null] = ACTIONS(4570),
    [sym_super] = ACTIONS(4570),
    [sym_this] = ACTIONS(4570),
    [sym_assert] = ACTIONS(4570),
    [sym_auto] = ACTIONS(4570),
    [sym_cast] = ACTIONS(4570),
    [sym_catch] = ACTIONS(4570),
    [sym_const] = ACTIONS(4570),
    [sym_delegate] = ACTIONS(4570),
    [sym_delete] = ACTIONS(4570),
    [sym_do] = ACTIONS(4570),
    [sym_else] = ACTIONS(4570),
    [sym_finally] = ACTIONS(4570),
    [sym_function] = ACTIONS(4570),
    [sym_immutable] = ACTIONS(4570),
    [sym_import] = ACTIONS(4570),
    [sym_in] = ACTIONS(4570),
    [sym_inout] = ACTIONS(4570),
    [sym_is] = ACTIONS(4570),
    [sym_mixin] = ACTIONS(4570),
    [sym_new] = ACTIONS(4570),
    [sym_out] = ACTIONS(4570),
    [sym_ref] = ACTIONS(4570),
    [sym_shared] = ACTIONS(4570),
    [sym_throw] = ACTIONS(4570),
    [sym_typeid] = ACTIONS(4570),
    [sym_typeof] = ACTIONS(4570),
    [sym_traits] = ACTIONS(4570),
    [sym_vector] = ACTIONS(4570),
    [sym_void] = ACTIONS(4570),
    [anon_sym_BQUOTE] = ACTIONS(4572),
    [anon_sym_r_DQUOTE] = ACTIONS(4572),
    [anon_sym_x_DQUOTE] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(4572),
    [anon_sym_i_BQUOTE] = ACTIONS(4572),
    [anon_sym_i_DQUOTE] = ACTIONS(4572),
    [anon_sym_iq_LBRACE] = ACTIONS(4572),
    [aux_sym_char_literal_token1] = ACTIONS(4572),
    [anon_sym_SQUOTE] = ACTIONS(4570),
    [anon_sym___DATE__] = ACTIONS(4570),
    [anon_sym___FILE__] = ACTIONS(4570),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4570),
    [anon_sym___FUNCTION__] = ACTIONS(4570),
    [anon_sym___LINE__] = ACTIONS(4570),
    [anon_sym___MODULE__] = ACTIONS(4570),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4570),
    [anon_sym___TIME__] = ACTIONS(4570),
    [anon_sym___TIMESTAMP__] = ACTIONS(4570),
    [anon_sym___VENDOR__] = ACTIONS(4570),
    [anon_sym___VERSION__] = ACTIONS(4570),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4572),
    [sym_float_literal] = ACTIONS(4572),
    [sym__string] = ACTIONS(4572),
  },
  [2027] = {
    [sym_identifier] = ACTIONS(4610),
    [anon_sym_q_LBRACE] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(4612),
    [anon_sym_DOT] = ACTIONS(4612),
    [anon_sym_AMP] = ACTIONS(4612),
    [anon_sym_DASH] = ACTIONS(4610),
    [anon_sym_DASH_DASH] = ACTIONS(4612),
    [anon_sym_PLUS] = ACTIONS(4610),
    [anon_sym_PLUS_PLUS] = ACTIONS(4612),
    [anon_sym_BANG] = ACTIONS(4612),
    [anon_sym_LPAREN] = ACTIONS(4612),
    [anon_sym_RPAREN] = ACTIONS(4612),
    [anon_sym_LBRACK] = ACTIONS(4612),
    [anon_sym_SEMI] = ACTIONS(4612),
    [anon_sym_DOLLAR] = ACTIONS(4612),
    [anon_sym_STAR] = ACTIONS(4612),
    [anon_sym_TILDE] = ACTIONS(4612),
    [sym_bool] = ACTIONS(4610),
    [sym_byte] = ACTIONS(4610),
    [sym_ubyte] = ACTIONS(4610),
    [sym_char] = ACTIONS(4610),
    [sym_short] = ACTIONS(4610),
    [sym_ushort] = ACTIONS(4610),
    [sym_int] = ACTIONS(4610),
    [sym_uint] = ACTIONS(4610),
    [sym_long] = ACTIONS(4610),
    [sym_ulong] = ACTIONS(4610),
    [sym_cent] = ACTIONS(4610),
    [sym_ucent] = ACTIONS(4610),
    [sym_wchar] = ACTIONS(4610),
    [sym_dchar] = ACTIONS(4610),
    [sym_float] = ACTIONS(4610),
    [sym_double] = ACTIONS(4610),
    [sym_real] = ACTIONS(4610),
    [sym_ifloat] = ACTIONS(4610),
    [sym_idouble] = ACTIONS(4610),
    [sym_ireal] = ACTIONS(4610),
    [sym_cfloat] = ACTIONS(4610),
    [sym_cdouble] = ACTIONS(4610),
    [sym_creal] = ACTIONS(4610),
    [sym_size_t] = ACTIONS(4610),
    [sym_ptrdiff_t] = ACTIONS(4610),
    [sym_string] = ACTIONS(4610),
    [sym_cstring] = ACTIONS(4610),
    [sym_dstring] = ACTIONS(4610),
    [sym_wstring] = ACTIONS(4610),
    [sym_noreturn] = ACTIONS(4610),
    [sym_true] = ACTIONS(4610),
    [sym_false] = ACTIONS(4610),
    [sym_null] = ACTIONS(4610),
    [sym_super] = ACTIONS(4610),
    [sym_this] = ACTIONS(4610),
    [sym_assert] = ACTIONS(4610),
    [sym_auto] = ACTIONS(4610),
    [sym_cast] = ACTIONS(4610),
    [sym_catch] = ACTIONS(4610),
    [sym_const] = ACTIONS(4610),
    [sym_delegate] = ACTIONS(4610),
    [sym_delete] = ACTIONS(4610),
    [sym_do] = ACTIONS(4610),
    [sym_else] = ACTIONS(4610),
    [sym_finally] = ACTIONS(4610),
    [sym_function] = ACTIONS(4610),
    [sym_immutable] = ACTIONS(4610),
    [sym_import] = ACTIONS(4610),
    [sym_in] = ACTIONS(4610),
    [sym_inout] = ACTIONS(4610),
    [sym_is] = ACTIONS(4610),
    [sym_mixin] = ACTIONS(4610),
    [sym_new] = ACTIONS(4610),
    [sym_out] = ACTIONS(4610),
    [sym_ref] = ACTIONS(4610),
    [sym_shared] = ACTIONS(4610),
    [sym_throw] = ACTIONS(4610),
    [sym_typeid] = ACTIONS(4610),
    [sym_typeof] = ACTIONS(4610),
    [sym_traits] = ACTIONS(4610),
    [sym_vector] = ACTIONS(4610),
    [sym_void] = ACTIONS(4610),
    [anon_sym_BQUOTE] = ACTIONS(4612),
    [anon_sym_r_DQUOTE] = ACTIONS(4612),
    [anon_sym_x_DQUOTE] = ACTIONS(4612),
    [anon_sym_DQUOTE] = ACTIONS(4612),
    [anon_sym_i_BQUOTE] = ACTIONS(4612),
    [anon_sym_i_DQUOTE] = ACTIONS(4612),
    [anon_sym_iq_LBRACE] = ACTIONS(4612),
    [aux_sym_char_literal_token1] = ACTIONS(4612),
    [anon_sym_SQUOTE] = ACTIONS(4610),
    [anon_sym___DATE__] = ACTIONS(4610),
    [anon_sym___FILE__] = ACTIONS(4610),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4610),
    [anon_sym___FUNCTION__] = ACTIONS(4610),
    [anon_sym___LINE__] = ACTIONS(4610),
    [anon_sym___MODULE__] = ACTIONS(4610),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4610),
    [anon_sym___TIME__] = ACTIONS(4610),
    [anon_sym___TIMESTAMP__] = ACTIONS(4610),
    [anon_sym___VENDOR__] = ACTIONS(4610),
    [anon_sym___VERSION__] = ACTIONS(4610),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4612),
    [sym_float_literal] = ACTIONS(4612),
    [sym__string] = ACTIONS(4612),
  },
  [2028] = {
    [sym_identifier] = ACTIONS(4953),
    [anon_sym_q_LBRACE] = ACTIONS(4955),
    [anon_sym_LBRACE] = ACTIONS(4955),
    [anon_sym_DOT] = ACTIONS(4955),
    [anon_sym_AMP] = ACTIONS(4955),
    [anon_sym_DASH] = ACTIONS(4953),
    [anon_sym_DASH_DASH] = ACTIONS(4955),
    [anon_sym_PLUS] = ACTIONS(4953),
    [anon_sym_PLUS_PLUS] = ACTIONS(4955),
    [anon_sym_BANG] = ACTIONS(4955),
    [anon_sym_LPAREN] = ACTIONS(4955),
    [anon_sym_RPAREN] = ACTIONS(4955),
    [anon_sym_LBRACK] = ACTIONS(4955),
    [anon_sym_SEMI] = ACTIONS(4955),
    [anon_sym_DOLLAR] = ACTIONS(4955),
    [anon_sym_STAR] = ACTIONS(4955),
    [anon_sym_TILDE] = ACTIONS(4955),
    [sym_bool] = ACTIONS(4953),
    [sym_byte] = ACTIONS(4953),
    [sym_ubyte] = ACTIONS(4953),
    [sym_char] = ACTIONS(4953),
    [sym_short] = ACTIONS(4953),
    [sym_ushort] = ACTIONS(4953),
    [sym_int] = ACTIONS(4953),
    [sym_uint] = ACTIONS(4953),
    [sym_long] = ACTIONS(4953),
    [sym_ulong] = ACTIONS(4953),
    [sym_cent] = ACTIONS(4953),
    [sym_ucent] = ACTIONS(4953),
    [sym_wchar] = ACTIONS(4953),
    [sym_dchar] = ACTIONS(4953),
    [sym_float] = ACTIONS(4953),
    [sym_double] = ACTIONS(4953),
    [sym_real] = ACTIONS(4953),
    [sym_ifloat] = ACTIONS(4953),
    [sym_idouble] = ACTIONS(4953),
    [sym_ireal] = ACTIONS(4953),
    [sym_cfloat] = ACTIONS(4953),
    [sym_cdouble] = ACTIONS(4953),
    [sym_creal] = ACTIONS(4953),
    [sym_size_t] = ACTIONS(4953),
    [sym_ptrdiff_t] = ACTIONS(4953),
    [sym_string] = ACTIONS(4953),
    [sym_cstring] = ACTIONS(4953),
    [sym_dstring] = ACTIONS(4953),
    [sym_wstring] = ACTIONS(4953),
    [sym_noreturn] = ACTIONS(4953),
    [sym_true] = ACTIONS(4953),
    [sym_false] = ACTIONS(4953),
    [sym_null] = ACTIONS(4953),
    [sym_super] = ACTIONS(4953),
    [sym_this] = ACTIONS(4953),
    [sym_assert] = ACTIONS(4953),
    [sym_auto] = ACTIONS(4953),
    [sym_cast] = ACTIONS(4953),
    [sym_catch] = ACTIONS(4953),
    [sym_const] = ACTIONS(4953),
    [sym_delegate] = ACTIONS(4953),
    [sym_delete] = ACTIONS(4953),
    [sym_do] = ACTIONS(4953),
    [sym_else] = ACTIONS(4953),
    [sym_finally] = ACTIONS(4953),
    [sym_function] = ACTIONS(4953),
    [sym_immutable] = ACTIONS(4953),
    [sym_import] = ACTIONS(4953),
    [sym_in] = ACTIONS(4953),
    [sym_inout] = ACTIONS(4953),
    [sym_is] = ACTIONS(4953),
    [sym_mixin] = ACTIONS(4953),
    [sym_new] = ACTIONS(4953),
    [sym_out] = ACTIONS(4953),
    [sym_ref] = ACTIONS(4953),
    [sym_shared] = ACTIONS(4953),
    [sym_throw] = ACTIONS(4953),
    [sym_typeid] = ACTIONS(4953),
    [sym_typeof] = ACTIONS(4953),
    [sym_traits] = ACTIONS(4953),
    [sym_vector] = ACTIONS(4953),
    [sym_void] = ACTIONS(4953),
    [anon_sym_BQUOTE] = ACTIONS(4955),
    [anon_sym_r_DQUOTE] = ACTIONS(4955),
    [anon_sym_x_DQUOTE] = ACTIONS(4955),
    [anon_sym_DQUOTE] = ACTIONS(4955),
    [anon_sym_i_BQUOTE] = ACTIONS(4955),
    [anon_sym_i_DQUOTE] = ACTIONS(4955),
    [anon_sym_iq_LBRACE] = ACTIONS(4955),
    [aux_sym_char_literal_token1] = ACTIONS(4955),
    [anon_sym_SQUOTE] = ACTIONS(4953),
    [anon_sym___DATE__] = ACTIONS(4953),
    [anon_sym___FILE__] = ACTIONS(4953),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4953),
    [anon_sym___FUNCTION__] = ACTIONS(4953),
    [anon_sym___LINE__] = ACTIONS(4953),
    [anon_sym___MODULE__] = ACTIONS(4953),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4953),
    [anon_sym___TIME__] = ACTIONS(4953),
    [anon_sym___TIMESTAMP__] = ACTIONS(4953),
    [anon_sym___VENDOR__] = ACTIONS(4953),
    [anon_sym___VERSION__] = ACTIONS(4953),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4955),
    [sym_float_literal] = ACTIONS(4955),
    [sym__string] = ACTIONS(4955),
  },
  [2029] = {
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_q_LBRACE] = ACTIONS(4352),
    [anon_sym_LBRACE] = ACTIONS(4352),
    [anon_sym_DOT] = ACTIONS(4352),
    [anon_sym_AMP] = ACTIONS(4352),
    [anon_sym_DASH] = ACTIONS(4350),
    [anon_sym_DASH_DASH] = ACTIONS(4352),
    [anon_sym_PLUS] = ACTIONS(4350),
    [anon_sym_PLUS_PLUS] = ACTIONS(4352),
    [anon_sym_BANG] = ACTIONS(4352),
    [anon_sym_LPAREN] = ACTIONS(4352),
    [anon_sym_RPAREN] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym_DOLLAR] = ACTIONS(4352),
    [anon_sym_STAR] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4352),
    [sym_bool] = ACTIONS(4350),
    [sym_byte] = ACTIONS(4350),
    [sym_ubyte] = ACTIONS(4350),
    [sym_char] = ACTIONS(4350),
    [sym_short] = ACTIONS(4350),
    [sym_ushort] = ACTIONS(4350),
    [sym_int] = ACTIONS(4350),
    [sym_uint] = ACTIONS(4350),
    [sym_long] = ACTIONS(4350),
    [sym_ulong] = ACTIONS(4350),
    [sym_cent] = ACTIONS(4350),
    [sym_ucent] = ACTIONS(4350),
    [sym_wchar] = ACTIONS(4350),
    [sym_dchar] = ACTIONS(4350),
    [sym_float] = ACTIONS(4350),
    [sym_double] = ACTIONS(4350),
    [sym_real] = ACTIONS(4350),
    [sym_ifloat] = ACTIONS(4350),
    [sym_idouble] = ACTIONS(4350),
    [sym_ireal] = ACTIONS(4350),
    [sym_cfloat] = ACTIONS(4350),
    [sym_cdouble] = ACTIONS(4350),
    [sym_creal] = ACTIONS(4350),
    [sym_size_t] = ACTIONS(4350),
    [sym_ptrdiff_t] = ACTIONS(4350),
    [sym_string] = ACTIONS(4350),
    [sym_cstring] = ACTIONS(4350),
    [sym_dstring] = ACTIONS(4350),
    [sym_wstring] = ACTIONS(4350),
    [sym_noreturn] = ACTIONS(4350),
    [sym_true] = ACTIONS(4350),
    [sym_false] = ACTIONS(4350),
    [sym_null] = ACTIONS(4350),
    [sym_super] = ACTIONS(4350),
    [sym_this] = ACTIONS(4350),
    [sym_assert] = ACTIONS(4350),
    [sym_auto] = ACTIONS(4350),
    [sym_cast] = ACTIONS(4350),
    [sym_catch] = ACTIONS(4350),
    [sym_const] = ACTIONS(4350),
    [sym_delegate] = ACTIONS(4350),
    [sym_delete] = ACTIONS(4350),
    [sym_do] = ACTIONS(4350),
    [sym_else] = ACTIONS(4350),
    [sym_finally] = ACTIONS(4350),
    [sym_function] = ACTIONS(4350),
    [sym_immutable] = ACTIONS(4350),
    [sym_import] = ACTIONS(4350),
    [sym_in] = ACTIONS(4350),
    [sym_inout] = ACTIONS(4350),
    [sym_is] = ACTIONS(4350),
    [sym_mixin] = ACTIONS(4350),
    [sym_new] = ACTIONS(4350),
    [sym_out] = ACTIONS(4350),
    [sym_ref] = ACTIONS(4350),
    [sym_shared] = ACTIONS(4350),
    [sym_throw] = ACTIONS(4350),
    [sym_typeid] = ACTIONS(4350),
    [sym_typeof] = ACTIONS(4350),
    [sym_traits] = ACTIONS(4350),
    [sym_vector] = ACTIONS(4350),
    [sym_void] = ACTIONS(4350),
    [anon_sym_BQUOTE] = ACTIONS(4352),
    [anon_sym_r_DQUOTE] = ACTIONS(4352),
    [anon_sym_x_DQUOTE] = ACTIONS(4352),
    [anon_sym_DQUOTE] = ACTIONS(4352),
    [anon_sym_i_BQUOTE] = ACTIONS(4352),
    [anon_sym_i_DQUOTE] = ACTIONS(4352),
    [anon_sym_iq_LBRACE] = ACTIONS(4352),
    [aux_sym_char_literal_token1] = ACTIONS(4352),
    [anon_sym_SQUOTE] = ACTIONS(4350),
    [anon_sym___DATE__] = ACTIONS(4350),
    [anon_sym___FILE__] = ACTIONS(4350),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4350),
    [anon_sym___FUNCTION__] = ACTIONS(4350),
    [anon_sym___LINE__] = ACTIONS(4350),
    [anon_sym___MODULE__] = ACTIONS(4350),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4350),
    [anon_sym___TIME__] = ACTIONS(4350),
    [anon_sym___TIMESTAMP__] = ACTIONS(4350),
    [anon_sym___VENDOR__] = ACTIONS(4350),
    [anon_sym___VERSION__] = ACTIONS(4350),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4352),
    [sym_float_literal] = ACTIONS(4352),
    [sym__string] = ACTIONS(4352),
  },
  [2030] = {
    [sym_identifier] = ACTIONS(4957),
    [anon_sym_q_LBRACE] = ACTIONS(4959),
    [anon_sym_LBRACE] = ACTIONS(4959),
    [anon_sym_DOT] = ACTIONS(4959),
    [anon_sym_AMP] = ACTIONS(4959),
    [anon_sym_DASH] = ACTIONS(4957),
    [anon_sym_DASH_DASH] = ACTIONS(4959),
    [anon_sym_PLUS] = ACTIONS(4957),
    [anon_sym_PLUS_PLUS] = ACTIONS(4959),
    [anon_sym_BANG] = ACTIONS(4959),
    [anon_sym_LPAREN] = ACTIONS(4959),
    [anon_sym_RPAREN] = ACTIONS(4959),
    [anon_sym_LBRACK] = ACTIONS(4959),
    [anon_sym_SEMI] = ACTIONS(4959),
    [anon_sym_DOLLAR] = ACTIONS(4959),
    [anon_sym_STAR] = ACTIONS(4959),
    [anon_sym_TILDE] = ACTIONS(4959),
    [sym_bool] = ACTIONS(4957),
    [sym_byte] = ACTIONS(4957),
    [sym_ubyte] = ACTIONS(4957),
    [sym_char] = ACTIONS(4957),
    [sym_short] = ACTIONS(4957),
    [sym_ushort] = ACTIONS(4957),
    [sym_int] = ACTIONS(4957),
    [sym_uint] = ACTIONS(4957),
    [sym_long] = ACTIONS(4957),
    [sym_ulong] = ACTIONS(4957),
    [sym_cent] = ACTIONS(4957),
    [sym_ucent] = ACTIONS(4957),
    [sym_wchar] = ACTIONS(4957),
    [sym_dchar] = ACTIONS(4957),
    [sym_float] = ACTIONS(4957),
    [sym_double] = ACTIONS(4957),
    [sym_real] = ACTIONS(4957),
    [sym_ifloat] = ACTIONS(4957),
    [sym_idouble] = ACTIONS(4957),
    [sym_ireal] = ACTIONS(4957),
    [sym_cfloat] = ACTIONS(4957),
    [sym_cdouble] = ACTIONS(4957),
    [sym_creal] = ACTIONS(4957),
    [sym_size_t] = ACTIONS(4957),
    [sym_ptrdiff_t] = ACTIONS(4957),
    [sym_string] = ACTIONS(4957),
    [sym_cstring] = ACTIONS(4957),
    [sym_dstring] = ACTIONS(4957),
    [sym_wstring] = ACTIONS(4957),
    [sym_noreturn] = ACTIONS(4957),
    [sym_true] = ACTIONS(4957),
    [sym_false] = ACTIONS(4957),
    [sym_null] = ACTIONS(4957),
    [sym_super] = ACTIONS(4957),
    [sym_this] = ACTIONS(4957),
    [sym_assert] = ACTIONS(4957),
    [sym_auto] = ACTIONS(4957),
    [sym_cast] = ACTIONS(4957),
    [sym_catch] = ACTIONS(4957),
    [sym_const] = ACTIONS(4957),
    [sym_delegate] = ACTIONS(4957),
    [sym_delete] = ACTIONS(4957),
    [sym_do] = ACTIONS(4957),
    [sym_else] = ACTIONS(4957),
    [sym_finally] = ACTIONS(4957),
    [sym_function] = ACTIONS(4957),
    [sym_immutable] = ACTIONS(4957),
    [sym_import] = ACTIONS(4957),
    [sym_in] = ACTIONS(4957),
    [sym_inout] = ACTIONS(4957),
    [sym_is] = ACTIONS(4957),
    [sym_mixin] = ACTIONS(4957),
    [sym_new] = ACTIONS(4957),
    [sym_out] = ACTIONS(4957),
    [sym_ref] = ACTIONS(4957),
    [sym_shared] = ACTIONS(4957),
    [sym_throw] = ACTIONS(4957),
    [sym_typeid] = ACTIONS(4957),
    [sym_typeof] = ACTIONS(4957),
    [sym_traits] = ACTIONS(4957),
    [sym_vector] = ACTIONS(4957),
    [sym_void] = ACTIONS(4957),
    [anon_sym_BQUOTE] = ACTIONS(4959),
    [anon_sym_r_DQUOTE] = ACTIONS(4959),
    [anon_sym_x_DQUOTE] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(4959),
    [anon_sym_i_BQUOTE] = ACTIONS(4959),
    [anon_sym_i_DQUOTE] = ACTIONS(4959),
    [anon_sym_iq_LBRACE] = ACTIONS(4959),
    [aux_sym_char_literal_token1] = ACTIONS(4959),
    [anon_sym_SQUOTE] = ACTIONS(4957),
    [anon_sym___DATE__] = ACTIONS(4957),
    [anon_sym___FILE__] = ACTIONS(4957),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4957),
    [anon_sym___FUNCTION__] = ACTIONS(4957),
    [anon_sym___LINE__] = ACTIONS(4957),
    [anon_sym___MODULE__] = ACTIONS(4957),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4957),
    [anon_sym___TIME__] = ACTIONS(4957),
    [anon_sym___TIMESTAMP__] = ACTIONS(4957),
    [anon_sym___VENDOR__] = ACTIONS(4957),
    [anon_sym___VERSION__] = ACTIONS(4957),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4959),
    [sym_float_literal] = ACTIONS(4959),
    [sym__string] = ACTIONS(4959),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(4975),
    [anon_sym_q_LBRACE] = ACTIONS(4977),
    [anon_sym_LBRACE] = ACTIONS(4977),
    [anon_sym_DOT] = ACTIONS(4977),
    [anon_sym_AMP] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4975),
    [anon_sym_DASH_DASH] = ACTIONS(4977),
    [anon_sym_PLUS] = ACTIONS(4975),
    [anon_sym_PLUS_PLUS] = ACTIONS(4977),
    [anon_sym_BANG] = ACTIONS(4977),
    [anon_sym_LPAREN] = ACTIONS(4977),
    [anon_sym_RPAREN] = ACTIONS(4977),
    [anon_sym_LBRACK] = ACTIONS(4977),
    [anon_sym_SEMI] = ACTIONS(4977),
    [anon_sym_DOLLAR] = ACTIONS(4977),
    [anon_sym_STAR] = ACTIONS(4977),
    [anon_sym_TILDE] = ACTIONS(4977),
    [sym_bool] = ACTIONS(4975),
    [sym_byte] = ACTIONS(4975),
    [sym_ubyte] = ACTIONS(4975),
    [sym_char] = ACTIONS(4975),
    [sym_short] = ACTIONS(4975),
    [sym_ushort] = ACTIONS(4975),
    [sym_int] = ACTIONS(4975),
    [sym_uint] = ACTIONS(4975),
    [sym_long] = ACTIONS(4975),
    [sym_ulong] = ACTIONS(4975),
    [sym_cent] = ACTIONS(4975),
    [sym_ucent] = ACTIONS(4975),
    [sym_wchar] = ACTIONS(4975),
    [sym_dchar] = ACTIONS(4975),
    [sym_float] = ACTIONS(4975),
    [sym_double] = ACTIONS(4975),
    [sym_real] = ACTIONS(4975),
    [sym_ifloat] = ACTIONS(4975),
    [sym_idouble] = ACTIONS(4975),
    [sym_ireal] = ACTIONS(4975),
    [sym_cfloat] = ACTIONS(4975),
    [sym_cdouble] = ACTIONS(4975),
    [sym_creal] = ACTIONS(4975),
    [sym_size_t] = ACTIONS(4975),
    [sym_ptrdiff_t] = ACTIONS(4975),
    [sym_string] = ACTIONS(4975),
    [sym_cstring] = ACTIONS(4975),
    [sym_dstring] = ACTIONS(4975),
    [sym_wstring] = ACTIONS(4975),
    [sym_noreturn] = ACTIONS(4975),
    [sym_true] = ACTIONS(4975),
    [sym_false] = ACTIONS(4975),
    [sym_null] = ACTIONS(4975),
    [sym_super] = ACTIONS(4975),
    [sym_this] = ACTIONS(4975),
    [sym_assert] = ACTIONS(4975),
    [sym_auto] = ACTIONS(4975),
    [sym_cast] = ACTIONS(4975),
    [sym_catch] = ACTIONS(4975),
    [sym_const] = ACTIONS(4975),
    [sym_delegate] = ACTIONS(4975),
    [sym_delete] = ACTIONS(4975),
    [sym_do] = ACTIONS(4975),
    [sym_else] = ACTIONS(4975),
    [sym_finally] = ACTIONS(4975),
    [sym_function] = ACTIONS(4975),
    [sym_immutable] = ACTIONS(4975),
    [sym_import] = ACTIONS(4975),
    [sym_in] = ACTIONS(4975),
    [sym_inout] = ACTIONS(4975),
    [sym_is] = ACTIONS(4975),
    [sym_mixin] = ACTIONS(4975),
    [sym_new] = ACTIONS(4975),
    [sym_out] = ACTIONS(4975),
    [sym_ref] = ACTIONS(4975),
    [sym_shared] = ACTIONS(4975),
    [sym_throw] = ACTIONS(4975),
    [sym_typeid] = ACTIONS(4975),
    [sym_typeof] = ACTIONS(4975),
    [sym_traits] = ACTIONS(4975),
    [sym_vector] = ACTIONS(4975),
    [sym_void] = ACTIONS(4975),
    [anon_sym_BQUOTE] = ACTIONS(4977),
    [anon_sym_r_DQUOTE] = ACTIONS(4977),
    [anon_sym_x_DQUOTE] = ACTIONS(4977),
    [anon_sym_DQUOTE] = ACTIONS(4977),
    [anon_sym_i_BQUOTE] = ACTIONS(4977),
    [anon_sym_i_DQUOTE] = ACTIONS(4977),
    [anon_sym_iq_LBRACE] = ACTIONS(4977),
    [aux_sym_char_literal_token1] = ACTIONS(4977),
    [anon_sym_SQUOTE] = ACTIONS(4975),
    [anon_sym___DATE__] = ACTIONS(4975),
    [anon_sym___FILE__] = ACTIONS(4975),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4975),
    [anon_sym___FUNCTION__] = ACTIONS(4975),
    [anon_sym___LINE__] = ACTIONS(4975),
    [anon_sym___MODULE__] = ACTIONS(4975),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4975),
    [anon_sym___TIME__] = ACTIONS(4975),
    [anon_sym___TIMESTAMP__] = ACTIONS(4975),
    [anon_sym___VENDOR__] = ACTIONS(4975),
    [anon_sym___VERSION__] = ACTIONS(4975),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4977),
    [sym_float_literal] = ACTIONS(4977),
    [sym__string] = ACTIONS(4977),
  },
  [2032] = {
    [sym_identifier] = ACTIONS(4979),
    [anon_sym_q_LBRACE] = ACTIONS(4983),
    [anon_sym_LBRACE] = ACTIONS(4983),
    [anon_sym_DOT] = ACTIONS(4983),
    [anon_sym_AMP] = ACTIONS(4983),
    [anon_sym_DASH] = ACTIONS(4979),
    [anon_sym_DASH_DASH] = ACTIONS(4983),
    [anon_sym_PLUS] = ACTIONS(4979),
    [anon_sym_PLUS_PLUS] = ACTIONS(4983),
    [anon_sym_BANG] = ACTIONS(4983),
    [anon_sym_LPAREN] = ACTIONS(4983),
    [anon_sym_RPAREN] = ACTIONS(4983),
    [anon_sym_LBRACK] = ACTIONS(4983),
    [anon_sym_SEMI] = ACTIONS(4983),
    [anon_sym_DOLLAR] = ACTIONS(4983),
    [anon_sym_STAR] = ACTIONS(4983),
    [anon_sym_TILDE] = ACTIONS(4983),
    [sym_bool] = ACTIONS(4979),
    [sym_byte] = ACTIONS(4979),
    [sym_ubyte] = ACTIONS(4979),
    [sym_char] = ACTIONS(4979),
    [sym_short] = ACTIONS(4979),
    [sym_ushort] = ACTIONS(4979),
    [sym_int] = ACTIONS(4979),
    [sym_uint] = ACTIONS(4979),
    [sym_long] = ACTIONS(4979),
    [sym_ulong] = ACTIONS(4979),
    [sym_cent] = ACTIONS(4979),
    [sym_ucent] = ACTIONS(4979),
    [sym_wchar] = ACTIONS(4979),
    [sym_dchar] = ACTIONS(4979),
    [sym_float] = ACTIONS(4979),
    [sym_double] = ACTIONS(4979),
    [sym_real] = ACTIONS(4979),
    [sym_ifloat] = ACTIONS(4979),
    [sym_idouble] = ACTIONS(4979),
    [sym_ireal] = ACTIONS(4979),
    [sym_cfloat] = ACTIONS(4979),
    [sym_cdouble] = ACTIONS(4979),
    [sym_creal] = ACTIONS(4979),
    [sym_size_t] = ACTIONS(4979),
    [sym_ptrdiff_t] = ACTIONS(4979),
    [sym_string] = ACTIONS(4979),
    [sym_cstring] = ACTIONS(4979),
    [sym_dstring] = ACTIONS(4979),
    [sym_wstring] = ACTIONS(4979),
    [sym_noreturn] = ACTIONS(4979),
    [sym_true] = ACTIONS(4979),
    [sym_false] = ACTIONS(4979),
    [sym_null] = ACTIONS(4979),
    [sym_super] = ACTIONS(4979),
    [sym_this] = ACTIONS(4979),
    [sym_assert] = ACTIONS(4979),
    [sym_auto] = ACTIONS(4979),
    [sym_cast] = ACTIONS(4979),
    [sym_catch] = ACTIONS(4979),
    [sym_const] = ACTIONS(4979),
    [sym_delegate] = ACTIONS(4979),
    [sym_delete] = ACTIONS(4979),
    [sym_do] = ACTIONS(4979),
    [sym_else] = ACTIONS(4979),
    [sym_finally] = ACTIONS(4979),
    [sym_function] = ACTIONS(4979),
    [sym_immutable] = ACTIONS(4979),
    [sym_import] = ACTIONS(4979),
    [sym_in] = ACTIONS(4979),
    [sym_inout] = ACTIONS(4979),
    [sym_is] = ACTIONS(4979),
    [sym_mixin] = ACTIONS(4979),
    [sym_new] = ACTIONS(4979),
    [sym_out] = ACTIONS(4979),
    [sym_ref] = ACTIONS(4979),
    [sym_shared] = ACTIONS(4979),
    [sym_throw] = ACTIONS(4979),
    [sym_typeid] = ACTIONS(4979),
    [sym_typeof] = ACTIONS(4979),
    [sym_traits] = ACTIONS(4979),
    [sym_vector] = ACTIONS(4979),
    [sym_void] = ACTIONS(4979),
    [anon_sym_BQUOTE] = ACTIONS(4983),
    [anon_sym_r_DQUOTE] = ACTIONS(4983),
    [anon_sym_x_DQUOTE] = ACTIONS(4983),
    [anon_sym_DQUOTE] = ACTIONS(4983),
    [anon_sym_i_BQUOTE] = ACTIONS(4983),
    [anon_sym_i_DQUOTE] = ACTIONS(4983),
    [anon_sym_iq_LBRACE] = ACTIONS(4983),
    [aux_sym_char_literal_token1] = ACTIONS(4983),
    [anon_sym_SQUOTE] = ACTIONS(4979),
    [anon_sym___DATE__] = ACTIONS(4979),
    [anon_sym___FILE__] = ACTIONS(4979),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4979),
    [anon_sym___FUNCTION__] = ACTIONS(4979),
    [anon_sym___LINE__] = ACTIONS(4979),
    [anon_sym___MODULE__] = ACTIONS(4979),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4979),
    [anon_sym___TIME__] = ACTIONS(4979),
    [anon_sym___TIMESTAMP__] = ACTIONS(4979),
    [anon_sym___VENDOR__] = ACTIONS(4979),
    [anon_sym___VERSION__] = ACTIONS(4979),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4983),
    [sym_float_literal] = ACTIONS(4983),
    [sym__string] = ACTIONS(4983),
  },
  [2033] = {
    [sym_identifier] = ACTIONS(4506),
    [anon_sym_q_LBRACE] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(4508),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_AMP] = ACTIONS(4508),
    [anon_sym_DASH] = ACTIONS(4506),
    [anon_sym_DASH_DASH] = ACTIONS(4508),
    [anon_sym_PLUS] = ACTIONS(4506),
    [anon_sym_PLUS_PLUS] = ACTIONS(4508),
    [anon_sym_BANG] = ACTIONS(4508),
    [anon_sym_LPAREN] = ACTIONS(4508),
    [anon_sym_RPAREN] = ACTIONS(4508),
    [anon_sym_LBRACK] = ACTIONS(4508),
    [anon_sym_SEMI] = ACTIONS(4508),
    [anon_sym_DOLLAR] = ACTIONS(4508),
    [anon_sym_STAR] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4508),
    [sym_bool] = ACTIONS(4506),
    [sym_byte] = ACTIONS(4506),
    [sym_ubyte] = ACTIONS(4506),
    [sym_char] = ACTIONS(4506),
    [sym_short] = ACTIONS(4506),
    [sym_ushort] = ACTIONS(4506),
    [sym_int] = ACTIONS(4506),
    [sym_uint] = ACTIONS(4506),
    [sym_long] = ACTIONS(4506),
    [sym_ulong] = ACTIONS(4506),
    [sym_cent] = ACTIONS(4506),
    [sym_ucent] = ACTIONS(4506),
    [sym_wchar] = ACTIONS(4506),
    [sym_dchar] = ACTIONS(4506),
    [sym_float] = ACTIONS(4506),
    [sym_double] = ACTIONS(4506),
    [sym_real] = ACTIONS(4506),
    [sym_ifloat] = ACTIONS(4506),
    [sym_idouble] = ACTIONS(4506),
    [sym_ireal] = ACTIONS(4506),
    [sym_cfloat] = ACTIONS(4506),
    [sym_cdouble] = ACTIONS(4506),
    [sym_creal] = ACTIONS(4506),
    [sym_size_t] = ACTIONS(4506),
    [sym_ptrdiff_t] = ACTIONS(4506),
    [sym_string] = ACTIONS(4506),
    [sym_cstring] = ACTIONS(4506),
    [sym_dstring] = ACTIONS(4506),
    [sym_wstring] = ACTIONS(4506),
    [sym_noreturn] = ACTIONS(4506),
    [sym_true] = ACTIONS(4506),
    [sym_false] = ACTIONS(4506),
    [sym_null] = ACTIONS(4506),
    [sym_super] = ACTIONS(4506),
    [sym_this] = ACTIONS(4506),
    [sym_assert] = ACTIONS(4506),
    [sym_auto] = ACTIONS(4506),
    [sym_cast] = ACTIONS(4506),
    [sym_catch] = ACTIONS(4506),
    [sym_const] = ACTIONS(4506),
    [sym_delegate] = ACTIONS(4506),
    [sym_delete] = ACTIONS(4506),
    [sym_do] = ACTIONS(4506),
    [sym_else] = ACTIONS(4506),
    [sym_finally] = ACTIONS(4506),
    [sym_function] = ACTIONS(4506),
    [sym_immutable] = ACTIONS(4506),
    [sym_import] = ACTIONS(4506),
    [sym_in] = ACTIONS(4506),
    [sym_inout] = ACTIONS(4506),
    [sym_is] = ACTIONS(4506),
    [sym_mixin] = ACTIONS(4506),
    [sym_new] = ACTIONS(4506),
    [sym_out] = ACTIONS(4506),
    [sym_ref] = ACTIONS(4506),
    [sym_shared] = ACTIONS(4506),
    [sym_throw] = ACTIONS(4506),
    [sym_typeid] = ACTIONS(4506),
    [sym_typeof] = ACTIONS(4506),
    [sym_traits] = ACTIONS(4506),
    [sym_vector] = ACTIONS(4506),
    [sym_void] = ACTIONS(4506),
    [anon_sym_BQUOTE] = ACTIONS(4508),
    [anon_sym_r_DQUOTE] = ACTIONS(4508),
    [anon_sym_x_DQUOTE] = ACTIONS(4508),
    [anon_sym_DQUOTE] = ACTIONS(4508),
    [anon_sym_i_BQUOTE] = ACTIONS(4508),
    [anon_sym_i_DQUOTE] = ACTIONS(4508),
    [anon_sym_iq_LBRACE] = ACTIONS(4508),
    [aux_sym_char_literal_token1] = ACTIONS(4508),
    [anon_sym_SQUOTE] = ACTIONS(4506),
    [anon_sym___DATE__] = ACTIONS(4506),
    [anon_sym___FILE__] = ACTIONS(4506),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4506),
    [anon_sym___FUNCTION__] = ACTIONS(4506),
    [anon_sym___LINE__] = ACTIONS(4506),
    [anon_sym___MODULE__] = ACTIONS(4506),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4506),
    [anon_sym___TIME__] = ACTIONS(4506),
    [anon_sym___TIMESTAMP__] = ACTIONS(4506),
    [anon_sym___VENDOR__] = ACTIONS(4506),
    [anon_sym___VERSION__] = ACTIONS(4506),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4508),
    [sym_float_literal] = ACTIONS(4508),
    [sym__string] = ACTIONS(4508),
  },
  [2034] = {
    [sym_identifier] = ACTIONS(4668),
    [anon_sym_q_LBRACE] = ACTIONS(4670),
    [anon_sym_LBRACE] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_AMP] = ACTIONS(4670),
    [anon_sym_DASH] = ACTIONS(4668),
    [anon_sym_DASH_DASH] = ACTIONS(4670),
    [anon_sym_PLUS] = ACTIONS(4668),
    [anon_sym_PLUS_PLUS] = ACTIONS(4670),
    [anon_sym_BANG] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4670),
    [anon_sym_RPAREN] = ACTIONS(4670),
    [anon_sym_LBRACK] = ACTIONS(4670),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_DOLLAR] = ACTIONS(4670),
    [anon_sym_STAR] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(4670),
    [sym_bool] = ACTIONS(4668),
    [sym_byte] = ACTIONS(4668),
    [sym_ubyte] = ACTIONS(4668),
    [sym_char] = ACTIONS(4668),
    [sym_short] = ACTIONS(4668),
    [sym_ushort] = ACTIONS(4668),
    [sym_int] = ACTIONS(4668),
    [sym_uint] = ACTIONS(4668),
    [sym_long] = ACTIONS(4668),
    [sym_ulong] = ACTIONS(4668),
    [sym_cent] = ACTIONS(4668),
    [sym_ucent] = ACTIONS(4668),
    [sym_wchar] = ACTIONS(4668),
    [sym_dchar] = ACTIONS(4668),
    [sym_float] = ACTIONS(4668),
    [sym_double] = ACTIONS(4668),
    [sym_real] = ACTIONS(4668),
    [sym_ifloat] = ACTIONS(4668),
    [sym_idouble] = ACTIONS(4668),
    [sym_ireal] = ACTIONS(4668),
    [sym_cfloat] = ACTIONS(4668),
    [sym_cdouble] = ACTIONS(4668),
    [sym_creal] = ACTIONS(4668),
    [sym_size_t] = ACTIONS(4668),
    [sym_ptrdiff_t] = ACTIONS(4668),
    [sym_string] = ACTIONS(4668),
    [sym_cstring] = ACTIONS(4668),
    [sym_dstring] = ACTIONS(4668),
    [sym_wstring] = ACTIONS(4668),
    [sym_noreturn] = ACTIONS(4668),
    [sym_true] = ACTIONS(4668),
    [sym_false] = ACTIONS(4668),
    [sym_null] = ACTIONS(4668),
    [sym_super] = ACTIONS(4668),
    [sym_this] = ACTIONS(4668),
    [sym_assert] = ACTIONS(4668),
    [sym_auto] = ACTIONS(4668),
    [sym_cast] = ACTIONS(4668),
    [sym_catch] = ACTIONS(4668),
    [sym_const] = ACTIONS(4668),
    [sym_delegate] = ACTIONS(4668),
    [sym_delete] = ACTIONS(4668),
    [sym_do] = ACTIONS(4668),
    [sym_else] = ACTIONS(4668),
    [sym_finally] = ACTIONS(4668),
    [sym_function] = ACTIONS(4668),
    [sym_immutable] = ACTIONS(4668),
    [sym_import] = ACTIONS(4668),
    [sym_in] = ACTIONS(4668),
    [sym_inout] = ACTIONS(4668),
    [sym_is] = ACTIONS(4668),
    [sym_mixin] = ACTIONS(4668),
    [sym_new] = ACTIONS(4668),
    [sym_out] = ACTIONS(4668),
    [sym_ref] = ACTIONS(4668),
    [sym_shared] = ACTIONS(4668),
    [sym_throw] = ACTIONS(4668),
    [sym_typeid] = ACTIONS(4668),
    [sym_typeof] = ACTIONS(4668),
    [sym_traits] = ACTIONS(4668),
    [sym_vector] = ACTIONS(4668),
    [sym_void] = ACTIONS(4668),
    [anon_sym_BQUOTE] = ACTIONS(4670),
    [anon_sym_r_DQUOTE] = ACTIONS(4670),
    [anon_sym_x_DQUOTE] = ACTIONS(4670),
    [anon_sym_DQUOTE] = ACTIONS(4670),
    [anon_sym_i_BQUOTE] = ACTIONS(4670),
    [anon_sym_i_DQUOTE] = ACTIONS(4670),
    [anon_sym_iq_LBRACE] = ACTIONS(4670),
    [aux_sym_char_literal_token1] = ACTIONS(4670),
    [anon_sym_SQUOTE] = ACTIONS(4668),
    [anon_sym___DATE__] = ACTIONS(4668),
    [anon_sym___FILE__] = ACTIONS(4668),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4668),
    [anon_sym___FUNCTION__] = ACTIONS(4668),
    [anon_sym___LINE__] = ACTIONS(4668),
    [anon_sym___MODULE__] = ACTIONS(4668),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4668),
    [anon_sym___TIME__] = ACTIONS(4668),
    [anon_sym___TIMESTAMP__] = ACTIONS(4668),
    [anon_sym___VENDOR__] = ACTIONS(4668),
    [anon_sym___VERSION__] = ACTIONS(4668),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4670),
    [sym_float_literal] = ACTIONS(4670),
    [sym__string] = ACTIONS(4670),
  },
  [2035] = {
    [sym_identifier] = ACTIONS(4372),
    [anon_sym_q_LBRACE] = ACTIONS(4374),
    [anon_sym_LBRACE] = ACTIONS(4374),
    [anon_sym_DOT] = ACTIONS(4374),
    [anon_sym_AMP] = ACTIONS(4374),
    [anon_sym_DASH] = ACTIONS(4372),
    [anon_sym_DASH_DASH] = ACTIONS(4374),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_PLUS_PLUS] = ACTIONS(4374),
    [anon_sym_BANG] = ACTIONS(4374),
    [anon_sym_LPAREN] = ACTIONS(4374),
    [anon_sym_RPAREN] = ACTIONS(4374),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_SEMI] = ACTIONS(4374),
    [anon_sym_DOLLAR] = ACTIONS(4374),
    [anon_sym_STAR] = ACTIONS(4374),
    [anon_sym_TILDE] = ACTIONS(4374),
    [sym_bool] = ACTIONS(4372),
    [sym_byte] = ACTIONS(4372),
    [sym_ubyte] = ACTIONS(4372),
    [sym_char] = ACTIONS(4372),
    [sym_short] = ACTIONS(4372),
    [sym_ushort] = ACTIONS(4372),
    [sym_int] = ACTIONS(4372),
    [sym_uint] = ACTIONS(4372),
    [sym_long] = ACTIONS(4372),
    [sym_ulong] = ACTIONS(4372),
    [sym_cent] = ACTIONS(4372),
    [sym_ucent] = ACTIONS(4372),
    [sym_wchar] = ACTIONS(4372),
    [sym_dchar] = ACTIONS(4372),
    [sym_float] = ACTIONS(4372),
    [sym_double] = ACTIONS(4372),
    [sym_real] = ACTIONS(4372),
    [sym_ifloat] = ACTIONS(4372),
    [sym_idouble] = ACTIONS(4372),
    [sym_ireal] = ACTIONS(4372),
    [sym_cfloat] = ACTIONS(4372),
    [sym_cdouble] = ACTIONS(4372),
    [sym_creal] = ACTIONS(4372),
    [sym_size_t] = ACTIONS(4372),
    [sym_ptrdiff_t] = ACTIONS(4372),
    [sym_string] = ACTIONS(4372),
    [sym_cstring] = ACTIONS(4372),
    [sym_dstring] = ACTIONS(4372),
    [sym_wstring] = ACTIONS(4372),
    [sym_noreturn] = ACTIONS(4372),
    [sym_true] = ACTIONS(4372),
    [sym_false] = ACTIONS(4372),
    [sym_null] = ACTIONS(4372),
    [sym_super] = ACTIONS(4372),
    [sym_this] = ACTIONS(4372),
    [sym_assert] = ACTIONS(4372),
    [sym_auto] = ACTIONS(4372),
    [sym_cast] = ACTIONS(4372),
    [sym_catch] = ACTIONS(4372),
    [sym_const] = ACTIONS(4372),
    [sym_delegate] = ACTIONS(4372),
    [sym_delete] = ACTIONS(4372),
    [sym_do] = ACTIONS(4372),
    [sym_else] = ACTIONS(4372),
    [sym_finally] = ACTIONS(4372),
    [sym_function] = ACTIONS(4372),
    [sym_immutable] = ACTIONS(4372),
    [sym_import] = ACTIONS(4372),
    [sym_in] = ACTIONS(4372),
    [sym_inout] = ACTIONS(4372),
    [sym_is] = ACTIONS(4372),
    [sym_mixin] = ACTIONS(4372),
    [sym_new] = ACTIONS(4372),
    [sym_out] = ACTIONS(4372),
    [sym_ref] = ACTIONS(4372),
    [sym_shared] = ACTIONS(4372),
    [sym_throw] = ACTIONS(4372),
    [sym_typeid] = ACTIONS(4372),
    [sym_typeof] = ACTIONS(4372),
    [sym_traits] = ACTIONS(4372),
    [sym_vector] = ACTIONS(4372),
    [sym_void] = ACTIONS(4372),
    [anon_sym_BQUOTE] = ACTIONS(4374),
    [anon_sym_r_DQUOTE] = ACTIONS(4374),
    [anon_sym_x_DQUOTE] = ACTIONS(4374),
    [anon_sym_DQUOTE] = ACTIONS(4374),
    [anon_sym_i_BQUOTE] = ACTIONS(4374),
    [anon_sym_i_DQUOTE] = ACTIONS(4374),
    [anon_sym_iq_LBRACE] = ACTIONS(4374),
    [aux_sym_char_literal_token1] = ACTIONS(4374),
    [anon_sym_SQUOTE] = ACTIONS(4372),
    [anon_sym___DATE__] = ACTIONS(4372),
    [anon_sym___FILE__] = ACTIONS(4372),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4372),
    [anon_sym___FUNCTION__] = ACTIONS(4372),
    [anon_sym___LINE__] = ACTIONS(4372),
    [anon_sym___MODULE__] = ACTIONS(4372),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4372),
    [anon_sym___TIME__] = ACTIONS(4372),
    [anon_sym___TIMESTAMP__] = ACTIONS(4372),
    [anon_sym___VENDOR__] = ACTIONS(4372),
    [anon_sym___VERSION__] = ACTIONS(4372),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4374),
    [sym_float_literal] = ACTIONS(4374),
    [sym__string] = ACTIONS(4374),
  },
  [2036] = {
    [sym_identifier] = ACTIONS(4346),
    [anon_sym_q_LBRACE] = ACTIONS(4348),
    [anon_sym_LBRACE] = ACTIONS(4348),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_DASH] = ACTIONS(4346),
    [anon_sym_DASH_DASH] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_PLUS_PLUS] = ACTIONS(4348),
    [anon_sym_BANG] = ACTIONS(4348),
    [anon_sym_LPAREN] = ACTIONS(4348),
    [anon_sym_RPAREN] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_DOLLAR] = ACTIONS(4348),
    [anon_sym_STAR] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4348),
    [sym_bool] = ACTIONS(4346),
    [sym_byte] = ACTIONS(4346),
    [sym_ubyte] = ACTIONS(4346),
    [sym_char] = ACTIONS(4346),
    [sym_short] = ACTIONS(4346),
    [sym_ushort] = ACTIONS(4346),
    [sym_int] = ACTIONS(4346),
    [sym_uint] = ACTIONS(4346),
    [sym_long] = ACTIONS(4346),
    [sym_ulong] = ACTIONS(4346),
    [sym_cent] = ACTIONS(4346),
    [sym_ucent] = ACTIONS(4346),
    [sym_wchar] = ACTIONS(4346),
    [sym_dchar] = ACTIONS(4346),
    [sym_float] = ACTIONS(4346),
    [sym_double] = ACTIONS(4346),
    [sym_real] = ACTIONS(4346),
    [sym_ifloat] = ACTIONS(4346),
    [sym_idouble] = ACTIONS(4346),
    [sym_ireal] = ACTIONS(4346),
    [sym_cfloat] = ACTIONS(4346),
    [sym_cdouble] = ACTIONS(4346),
    [sym_creal] = ACTIONS(4346),
    [sym_size_t] = ACTIONS(4346),
    [sym_ptrdiff_t] = ACTIONS(4346),
    [sym_string] = ACTIONS(4346),
    [sym_cstring] = ACTIONS(4346),
    [sym_dstring] = ACTIONS(4346),
    [sym_wstring] = ACTIONS(4346),
    [sym_noreturn] = ACTIONS(4346),
    [sym_true] = ACTIONS(4346),
    [sym_false] = ACTIONS(4346),
    [sym_null] = ACTIONS(4346),
    [sym_super] = ACTIONS(4346),
    [sym_this] = ACTIONS(4346),
    [sym_assert] = ACTIONS(4346),
    [sym_auto] = ACTIONS(4346),
    [sym_cast] = ACTIONS(4346),
    [sym_catch] = ACTIONS(4346),
    [sym_const] = ACTIONS(4346),
    [sym_delegate] = ACTIONS(4346),
    [sym_delete] = ACTIONS(4346),
    [sym_do] = ACTIONS(4346),
    [sym_else] = ACTIONS(4346),
    [sym_finally] = ACTIONS(4346),
    [sym_function] = ACTIONS(4346),
    [sym_immutable] = ACTIONS(4346),
    [sym_import] = ACTIONS(4346),
    [sym_in] = ACTIONS(4346),
    [sym_inout] = ACTIONS(4346),
    [sym_is] = ACTIONS(4346),
    [sym_mixin] = ACTIONS(4346),
    [sym_new] = ACTIONS(4346),
    [sym_out] = ACTIONS(4346),
    [sym_ref] = ACTIONS(4346),
    [sym_shared] = ACTIONS(4346),
    [sym_throw] = ACTIONS(4346),
    [sym_typeid] = ACTIONS(4346),
    [sym_typeof] = ACTIONS(4346),
    [sym_traits] = ACTIONS(4346),
    [sym_vector] = ACTIONS(4346),
    [sym_void] = ACTIONS(4346),
    [anon_sym_BQUOTE] = ACTIONS(4348),
    [anon_sym_r_DQUOTE] = ACTIONS(4348),
    [anon_sym_x_DQUOTE] = ACTIONS(4348),
    [anon_sym_DQUOTE] = ACTIONS(4348),
    [anon_sym_i_BQUOTE] = ACTIONS(4348),
    [anon_sym_i_DQUOTE] = ACTIONS(4348),
    [anon_sym_iq_LBRACE] = ACTIONS(4348),
    [aux_sym_char_literal_token1] = ACTIONS(4348),
    [anon_sym_SQUOTE] = ACTIONS(4346),
    [anon_sym___DATE__] = ACTIONS(4346),
    [anon_sym___FILE__] = ACTIONS(4346),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4346),
    [anon_sym___FUNCTION__] = ACTIONS(4346),
    [anon_sym___LINE__] = ACTIONS(4346),
    [anon_sym___MODULE__] = ACTIONS(4346),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4346),
    [anon_sym___TIME__] = ACTIONS(4346),
    [anon_sym___TIMESTAMP__] = ACTIONS(4346),
    [anon_sym___VENDOR__] = ACTIONS(4346),
    [anon_sym___VERSION__] = ACTIONS(4346),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4348),
    [sym_float_literal] = ACTIONS(4348),
    [sym__string] = ACTIONS(4348),
  },
  [2037] = {
    [sym_identifier] = ACTIONS(4987),
    [anon_sym_q_LBRACE] = ACTIONS(4989),
    [anon_sym_LBRACE] = ACTIONS(4989),
    [anon_sym_DOT] = ACTIONS(4989),
    [anon_sym_AMP] = ACTIONS(4989),
    [anon_sym_DASH] = ACTIONS(4987),
    [anon_sym_DASH_DASH] = ACTIONS(4989),
    [anon_sym_PLUS] = ACTIONS(4987),
    [anon_sym_PLUS_PLUS] = ACTIONS(4989),
    [anon_sym_BANG] = ACTIONS(4989),
    [anon_sym_LPAREN] = ACTIONS(4989),
    [anon_sym_RPAREN] = ACTIONS(4989),
    [anon_sym_LBRACK] = ACTIONS(4989),
    [anon_sym_SEMI] = ACTIONS(4989),
    [anon_sym_DOLLAR] = ACTIONS(4989),
    [anon_sym_STAR] = ACTIONS(4989),
    [anon_sym_TILDE] = ACTIONS(4989),
    [sym_bool] = ACTIONS(4987),
    [sym_byte] = ACTIONS(4987),
    [sym_ubyte] = ACTIONS(4987),
    [sym_char] = ACTIONS(4987),
    [sym_short] = ACTIONS(4987),
    [sym_ushort] = ACTIONS(4987),
    [sym_int] = ACTIONS(4987),
    [sym_uint] = ACTIONS(4987),
    [sym_long] = ACTIONS(4987),
    [sym_ulong] = ACTIONS(4987),
    [sym_cent] = ACTIONS(4987),
    [sym_ucent] = ACTIONS(4987),
    [sym_wchar] = ACTIONS(4987),
    [sym_dchar] = ACTIONS(4987),
    [sym_float] = ACTIONS(4987),
    [sym_double] = ACTIONS(4987),
    [sym_real] = ACTIONS(4987),
    [sym_ifloat] = ACTIONS(4987),
    [sym_idouble] = ACTIONS(4987),
    [sym_ireal] = ACTIONS(4987),
    [sym_cfloat] = ACTIONS(4987),
    [sym_cdouble] = ACTIONS(4987),
    [sym_creal] = ACTIONS(4987),
    [sym_size_t] = ACTIONS(4987),
    [sym_ptrdiff_t] = ACTIONS(4987),
    [sym_string] = ACTIONS(4987),
    [sym_cstring] = ACTIONS(4987),
    [sym_dstring] = ACTIONS(4987),
    [sym_wstring] = ACTIONS(4987),
    [sym_noreturn] = ACTIONS(4987),
    [sym_true] = ACTIONS(4987),
    [sym_false] = ACTIONS(4987),
    [sym_null] = ACTIONS(4987),
    [sym_super] = ACTIONS(4987),
    [sym_this] = ACTIONS(4987),
    [sym_assert] = ACTIONS(4987),
    [sym_auto] = ACTIONS(4987),
    [sym_cast] = ACTIONS(4987),
    [sym_catch] = ACTIONS(4987),
    [sym_const] = ACTIONS(4987),
    [sym_delegate] = ACTIONS(4987),
    [sym_delete] = ACTIONS(4987),
    [sym_do] = ACTIONS(4987),
    [sym_else] = ACTIONS(4987),
    [sym_finally] = ACTIONS(4987),
    [sym_function] = ACTIONS(4987),
    [sym_immutable] = ACTIONS(4987),
    [sym_import] = ACTIONS(4987),
    [sym_in] = ACTIONS(4987),
    [sym_inout] = ACTIONS(4987),
    [sym_is] = ACTIONS(4987),
    [sym_mixin] = ACTIONS(4987),
    [sym_new] = ACTIONS(4987),
    [sym_out] = ACTIONS(4987),
    [sym_ref] = ACTIONS(4987),
    [sym_shared] = ACTIONS(4987),
    [sym_throw] = ACTIONS(4987),
    [sym_typeid] = ACTIONS(4987),
    [sym_typeof] = ACTIONS(4987),
    [sym_traits] = ACTIONS(4987),
    [sym_vector] = ACTIONS(4987),
    [sym_void] = ACTIONS(4987),
    [anon_sym_BQUOTE] = ACTIONS(4989),
    [anon_sym_r_DQUOTE] = ACTIONS(4989),
    [anon_sym_x_DQUOTE] = ACTIONS(4989),
    [anon_sym_DQUOTE] = ACTIONS(4989),
    [anon_sym_i_BQUOTE] = ACTIONS(4989),
    [anon_sym_i_DQUOTE] = ACTIONS(4989),
    [anon_sym_iq_LBRACE] = ACTIONS(4989),
    [aux_sym_char_literal_token1] = ACTIONS(4989),
    [anon_sym_SQUOTE] = ACTIONS(4987),
    [anon_sym___DATE__] = ACTIONS(4987),
    [anon_sym___FILE__] = ACTIONS(4987),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4987),
    [anon_sym___FUNCTION__] = ACTIONS(4987),
    [anon_sym___LINE__] = ACTIONS(4987),
    [anon_sym___MODULE__] = ACTIONS(4987),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4987),
    [anon_sym___TIME__] = ACTIONS(4987),
    [anon_sym___TIMESTAMP__] = ACTIONS(4987),
    [anon_sym___VENDOR__] = ACTIONS(4987),
    [anon_sym___VERSION__] = ACTIONS(4987),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4989),
    [sym_float_literal] = ACTIONS(4989),
    [sym__string] = ACTIONS(4989),
  },
  [2038] = {
    [sym_identifier] = ACTIONS(4342),
    [anon_sym_q_LBRACE] = ACTIONS(4344),
    [anon_sym_LBRACE] = ACTIONS(4344),
    [anon_sym_DOT] = ACTIONS(4344),
    [anon_sym_AMP] = ACTIONS(4344),
    [anon_sym_DASH] = ACTIONS(4342),
    [anon_sym_DASH_DASH] = ACTIONS(4344),
    [anon_sym_PLUS] = ACTIONS(4342),
    [anon_sym_PLUS_PLUS] = ACTIONS(4344),
    [anon_sym_BANG] = ACTIONS(4344),
    [anon_sym_LPAREN] = ACTIONS(4344),
    [anon_sym_RPAREN] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(4344),
    [anon_sym_SEMI] = ACTIONS(4344),
    [anon_sym_DOLLAR] = ACTIONS(4344),
    [anon_sym_STAR] = ACTIONS(4344),
    [anon_sym_TILDE] = ACTIONS(4344),
    [sym_bool] = ACTIONS(4342),
    [sym_byte] = ACTIONS(4342),
    [sym_ubyte] = ACTIONS(4342),
    [sym_char] = ACTIONS(4342),
    [sym_short] = ACTIONS(4342),
    [sym_ushort] = ACTIONS(4342),
    [sym_int] = ACTIONS(4342),
    [sym_uint] = ACTIONS(4342),
    [sym_long] = ACTIONS(4342),
    [sym_ulong] = ACTIONS(4342),
    [sym_cent] = ACTIONS(4342),
    [sym_ucent] = ACTIONS(4342),
    [sym_wchar] = ACTIONS(4342),
    [sym_dchar] = ACTIONS(4342),
    [sym_float] = ACTIONS(4342),
    [sym_double] = ACTIONS(4342),
    [sym_real] = ACTIONS(4342),
    [sym_ifloat] = ACTIONS(4342),
    [sym_idouble] = ACTIONS(4342),
    [sym_ireal] = ACTIONS(4342),
    [sym_cfloat] = ACTIONS(4342),
    [sym_cdouble] = ACTIONS(4342),
    [sym_creal] = ACTIONS(4342),
    [sym_size_t] = ACTIONS(4342),
    [sym_ptrdiff_t] = ACTIONS(4342),
    [sym_string] = ACTIONS(4342),
    [sym_cstring] = ACTIONS(4342),
    [sym_dstring] = ACTIONS(4342),
    [sym_wstring] = ACTIONS(4342),
    [sym_noreturn] = ACTIONS(4342),
    [sym_true] = ACTIONS(4342),
    [sym_false] = ACTIONS(4342),
    [sym_null] = ACTIONS(4342),
    [sym_super] = ACTIONS(4342),
    [sym_this] = ACTIONS(4342),
    [sym_assert] = ACTIONS(4342),
    [sym_auto] = ACTIONS(4342),
    [sym_cast] = ACTIONS(4342),
    [sym_catch] = ACTIONS(4342),
    [sym_const] = ACTIONS(4342),
    [sym_delegate] = ACTIONS(4342),
    [sym_delete] = ACTIONS(4342),
    [sym_do] = ACTIONS(4342),
    [sym_else] = ACTIONS(4342),
    [sym_finally] = ACTIONS(4342),
    [sym_function] = ACTIONS(4342),
    [sym_immutable] = ACTIONS(4342),
    [sym_import] = ACTIONS(4342),
    [sym_in] = ACTIONS(4342),
    [sym_inout] = ACTIONS(4342),
    [sym_is] = ACTIONS(4342),
    [sym_mixin] = ACTIONS(4342),
    [sym_new] = ACTIONS(4342),
    [sym_out] = ACTIONS(4342),
    [sym_ref] = ACTIONS(4342),
    [sym_shared] = ACTIONS(4342),
    [sym_throw] = ACTIONS(4342),
    [sym_typeid] = ACTIONS(4342),
    [sym_typeof] = ACTIONS(4342),
    [sym_traits] = ACTIONS(4342),
    [sym_vector] = ACTIONS(4342),
    [sym_void] = ACTIONS(4342),
    [anon_sym_BQUOTE] = ACTIONS(4344),
    [anon_sym_r_DQUOTE] = ACTIONS(4344),
    [anon_sym_x_DQUOTE] = ACTIONS(4344),
    [anon_sym_DQUOTE] = ACTIONS(4344),
    [anon_sym_i_BQUOTE] = ACTIONS(4344),
    [anon_sym_i_DQUOTE] = ACTIONS(4344),
    [anon_sym_iq_LBRACE] = ACTIONS(4344),
    [aux_sym_char_literal_token1] = ACTIONS(4344),
    [anon_sym_SQUOTE] = ACTIONS(4342),
    [anon_sym___DATE__] = ACTIONS(4342),
    [anon_sym___FILE__] = ACTIONS(4342),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4342),
    [anon_sym___FUNCTION__] = ACTIONS(4342),
    [anon_sym___LINE__] = ACTIONS(4342),
    [anon_sym___MODULE__] = ACTIONS(4342),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4342),
    [anon_sym___TIME__] = ACTIONS(4342),
    [anon_sym___TIMESTAMP__] = ACTIONS(4342),
    [anon_sym___VENDOR__] = ACTIONS(4342),
    [anon_sym___VERSION__] = ACTIONS(4342),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4344),
    [sym_float_literal] = ACTIONS(4344),
    [sym__string] = ACTIONS(4344),
  },
  [2039] = {
    [sym_identifier] = ACTIONS(4995),
    [anon_sym_q_LBRACE] = ACTIONS(4997),
    [anon_sym_LBRACE] = ACTIONS(4997),
    [anon_sym_DOT] = ACTIONS(4997),
    [anon_sym_AMP] = ACTIONS(4997),
    [anon_sym_DASH] = ACTIONS(4995),
    [anon_sym_DASH_DASH] = ACTIONS(4997),
    [anon_sym_PLUS] = ACTIONS(4995),
    [anon_sym_PLUS_PLUS] = ACTIONS(4997),
    [anon_sym_BANG] = ACTIONS(4997),
    [anon_sym_LPAREN] = ACTIONS(4997),
    [anon_sym_RPAREN] = ACTIONS(4997),
    [anon_sym_LBRACK] = ACTIONS(4997),
    [anon_sym_SEMI] = ACTIONS(4997),
    [anon_sym_DOLLAR] = ACTIONS(4997),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_TILDE] = ACTIONS(4997),
    [sym_bool] = ACTIONS(4995),
    [sym_byte] = ACTIONS(4995),
    [sym_ubyte] = ACTIONS(4995),
    [sym_char] = ACTIONS(4995),
    [sym_short] = ACTIONS(4995),
    [sym_ushort] = ACTIONS(4995),
    [sym_int] = ACTIONS(4995),
    [sym_uint] = ACTIONS(4995),
    [sym_long] = ACTIONS(4995),
    [sym_ulong] = ACTIONS(4995),
    [sym_cent] = ACTIONS(4995),
    [sym_ucent] = ACTIONS(4995),
    [sym_wchar] = ACTIONS(4995),
    [sym_dchar] = ACTIONS(4995),
    [sym_float] = ACTIONS(4995),
    [sym_double] = ACTIONS(4995),
    [sym_real] = ACTIONS(4995),
    [sym_ifloat] = ACTIONS(4995),
    [sym_idouble] = ACTIONS(4995),
    [sym_ireal] = ACTIONS(4995),
    [sym_cfloat] = ACTIONS(4995),
    [sym_cdouble] = ACTIONS(4995),
    [sym_creal] = ACTIONS(4995),
    [sym_size_t] = ACTIONS(4995),
    [sym_ptrdiff_t] = ACTIONS(4995),
    [sym_string] = ACTIONS(4995),
    [sym_cstring] = ACTIONS(4995),
    [sym_dstring] = ACTIONS(4995),
    [sym_wstring] = ACTIONS(4995),
    [sym_noreturn] = ACTIONS(4995),
    [sym_true] = ACTIONS(4995),
    [sym_false] = ACTIONS(4995),
    [sym_null] = ACTIONS(4995),
    [sym_super] = ACTIONS(4995),
    [sym_this] = ACTIONS(4995),
    [sym_assert] = ACTIONS(4995),
    [sym_auto] = ACTIONS(4995),
    [sym_cast] = ACTIONS(4995),
    [sym_catch] = ACTIONS(4995),
    [sym_const] = ACTIONS(4995),
    [sym_delegate] = ACTIONS(4995),
    [sym_delete] = ACTIONS(4995),
    [sym_do] = ACTIONS(4995),
    [sym_else] = ACTIONS(4995),
    [sym_finally] = ACTIONS(4995),
    [sym_function] = ACTIONS(4995),
    [sym_immutable] = ACTIONS(4995),
    [sym_import] = ACTIONS(4995),
    [sym_in] = ACTIONS(4995),
    [sym_inout] = ACTIONS(4995),
    [sym_is] = ACTIONS(4995),
    [sym_mixin] = ACTIONS(4995),
    [sym_new] = ACTIONS(4995),
    [sym_out] = ACTIONS(4995),
    [sym_ref] = ACTIONS(4995),
    [sym_shared] = ACTIONS(4995),
    [sym_throw] = ACTIONS(4995),
    [sym_typeid] = ACTIONS(4995),
    [sym_typeof] = ACTIONS(4995),
    [sym_traits] = ACTIONS(4995),
    [sym_vector] = ACTIONS(4995),
    [sym_void] = ACTIONS(4995),
    [anon_sym_BQUOTE] = ACTIONS(4997),
    [anon_sym_r_DQUOTE] = ACTIONS(4997),
    [anon_sym_x_DQUOTE] = ACTIONS(4997),
    [anon_sym_DQUOTE] = ACTIONS(4997),
    [anon_sym_i_BQUOTE] = ACTIONS(4997),
    [anon_sym_i_DQUOTE] = ACTIONS(4997),
    [anon_sym_iq_LBRACE] = ACTIONS(4997),
    [aux_sym_char_literal_token1] = ACTIONS(4997),
    [anon_sym_SQUOTE] = ACTIONS(4995),
    [anon_sym___DATE__] = ACTIONS(4995),
    [anon_sym___FILE__] = ACTIONS(4995),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4995),
    [anon_sym___FUNCTION__] = ACTIONS(4995),
    [anon_sym___LINE__] = ACTIONS(4995),
    [anon_sym___MODULE__] = ACTIONS(4995),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4995),
    [anon_sym___TIME__] = ACTIONS(4995),
    [anon_sym___TIMESTAMP__] = ACTIONS(4995),
    [anon_sym___VENDOR__] = ACTIONS(4995),
    [anon_sym___VERSION__] = ACTIONS(4995),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4997),
    [sym_float_literal] = ACTIONS(4997),
    [sym__string] = ACTIONS(4997),
  },
  [2040] = {
    [sym_identifier] = ACTIONS(4338),
    [anon_sym_q_LBRACE] = ACTIONS(4340),
    [anon_sym_LBRACE] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_AMP] = ACTIONS(4340),
    [anon_sym_DASH] = ACTIONS(4338),
    [anon_sym_DASH_DASH] = ACTIONS(4340),
    [anon_sym_PLUS] = ACTIONS(4338),
    [anon_sym_PLUS_PLUS] = ACTIONS(4340),
    [anon_sym_BANG] = ACTIONS(4340),
    [anon_sym_LPAREN] = ACTIONS(4340),
    [anon_sym_RPAREN] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_DOLLAR] = ACTIONS(4340),
    [anon_sym_STAR] = ACTIONS(4340),
    [anon_sym_TILDE] = ACTIONS(4340),
    [sym_bool] = ACTIONS(4338),
    [sym_byte] = ACTIONS(4338),
    [sym_ubyte] = ACTIONS(4338),
    [sym_char] = ACTIONS(4338),
    [sym_short] = ACTIONS(4338),
    [sym_ushort] = ACTIONS(4338),
    [sym_int] = ACTIONS(4338),
    [sym_uint] = ACTIONS(4338),
    [sym_long] = ACTIONS(4338),
    [sym_ulong] = ACTIONS(4338),
    [sym_cent] = ACTIONS(4338),
    [sym_ucent] = ACTIONS(4338),
    [sym_wchar] = ACTIONS(4338),
    [sym_dchar] = ACTIONS(4338),
    [sym_float] = ACTIONS(4338),
    [sym_double] = ACTIONS(4338),
    [sym_real] = ACTIONS(4338),
    [sym_ifloat] = ACTIONS(4338),
    [sym_idouble] = ACTIONS(4338),
    [sym_ireal] = ACTIONS(4338),
    [sym_cfloat] = ACTIONS(4338),
    [sym_cdouble] = ACTIONS(4338),
    [sym_creal] = ACTIONS(4338),
    [sym_size_t] = ACTIONS(4338),
    [sym_ptrdiff_t] = ACTIONS(4338),
    [sym_string] = ACTIONS(4338),
    [sym_cstring] = ACTIONS(4338),
    [sym_dstring] = ACTIONS(4338),
    [sym_wstring] = ACTIONS(4338),
    [sym_noreturn] = ACTIONS(4338),
    [sym_true] = ACTIONS(4338),
    [sym_false] = ACTIONS(4338),
    [sym_null] = ACTIONS(4338),
    [sym_super] = ACTIONS(4338),
    [sym_this] = ACTIONS(4338),
    [sym_assert] = ACTIONS(4338),
    [sym_auto] = ACTIONS(4338),
    [sym_cast] = ACTIONS(4338),
    [sym_catch] = ACTIONS(4338),
    [sym_const] = ACTIONS(4338),
    [sym_delegate] = ACTIONS(4338),
    [sym_delete] = ACTIONS(4338),
    [sym_do] = ACTIONS(4338),
    [sym_else] = ACTIONS(4338),
    [sym_finally] = ACTIONS(4338),
    [sym_function] = ACTIONS(4338),
    [sym_immutable] = ACTIONS(4338),
    [sym_import] = ACTIONS(4338),
    [sym_in] = ACTIONS(4338),
    [sym_inout] = ACTIONS(4338),
    [sym_is] = ACTIONS(4338),
    [sym_mixin] = ACTIONS(4338),
    [sym_new] = ACTIONS(4338),
    [sym_out] = ACTIONS(4338),
    [sym_ref] = ACTIONS(4338),
    [sym_shared] = ACTIONS(4338),
    [sym_throw] = ACTIONS(4338),
    [sym_typeid] = ACTIONS(4338),
    [sym_typeof] = ACTIONS(4338),
    [sym_traits] = ACTIONS(4338),
    [sym_vector] = ACTIONS(4338),
    [sym_void] = ACTIONS(4338),
    [anon_sym_BQUOTE] = ACTIONS(4340),
    [anon_sym_r_DQUOTE] = ACTIONS(4340),
    [anon_sym_x_DQUOTE] = ACTIONS(4340),
    [anon_sym_DQUOTE] = ACTIONS(4340),
    [anon_sym_i_BQUOTE] = ACTIONS(4340),
    [anon_sym_i_DQUOTE] = ACTIONS(4340),
    [anon_sym_iq_LBRACE] = ACTIONS(4340),
    [aux_sym_char_literal_token1] = ACTIONS(4340),
    [anon_sym_SQUOTE] = ACTIONS(4338),
    [anon_sym___DATE__] = ACTIONS(4338),
    [anon_sym___FILE__] = ACTIONS(4338),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4338),
    [anon_sym___FUNCTION__] = ACTIONS(4338),
    [anon_sym___LINE__] = ACTIONS(4338),
    [anon_sym___MODULE__] = ACTIONS(4338),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4338),
    [anon_sym___TIME__] = ACTIONS(4338),
    [anon_sym___TIMESTAMP__] = ACTIONS(4338),
    [anon_sym___VENDOR__] = ACTIONS(4338),
    [anon_sym___VERSION__] = ACTIONS(4338),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4340),
    [sym_float_literal] = ACTIONS(4340),
    [sym__string] = ACTIONS(4340),
  },
  [2041] = {
    [sym_identifier] = ACTIONS(4380),
    [anon_sym_q_LBRACE] = ACTIONS(4382),
    [anon_sym_LBRACE] = ACTIONS(4382),
    [anon_sym_DOT] = ACTIONS(4382),
    [anon_sym_AMP] = ACTIONS(4382),
    [anon_sym_DASH] = ACTIONS(4380),
    [anon_sym_DASH_DASH] = ACTIONS(4382),
    [anon_sym_PLUS] = ACTIONS(4380),
    [anon_sym_PLUS_PLUS] = ACTIONS(4382),
    [anon_sym_BANG] = ACTIONS(4382),
    [anon_sym_LPAREN] = ACTIONS(4382),
    [anon_sym_RPAREN] = ACTIONS(4382),
    [anon_sym_LBRACK] = ACTIONS(4382),
    [anon_sym_SEMI] = ACTIONS(4382),
    [anon_sym_DOLLAR] = ACTIONS(4382),
    [anon_sym_STAR] = ACTIONS(4382),
    [anon_sym_TILDE] = ACTIONS(4382),
    [sym_bool] = ACTIONS(4380),
    [sym_byte] = ACTIONS(4380),
    [sym_ubyte] = ACTIONS(4380),
    [sym_char] = ACTIONS(4380),
    [sym_short] = ACTIONS(4380),
    [sym_ushort] = ACTIONS(4380),
    [sym_int] = ACTIONS(4380),
    [sym_uint] = ACTIONS(4380),
    [sym_long] = ACTIONS(4380),
    [sym_ulong] = ACTIONS(4380),
    [sym_cent] = ACTIONS(4380),
    [sym_ucent] = ACTIONS(4380),
    [sym_wchar] = ACTIONS(4380),
    [sym_dchar] = ACTIONS(4380),
    [sym_float] = ACTIONS(4380),
    [sym_double] = ACTIONS(4380),
    [sym_real] = ACTIONS(4380),
    [sym_ifloat] = ACTIONS(4380),
    [sym_idouble] = ACTIONS(4380),
    [sym_ireal] = ACTIONS(4380),
    [sym_cfloat] = ACTIONS(4380),
    [sym_cdouble] = ACTIONS(4380),
    [sym_creal] = ACTIONS(4380),
    [sym_size_t] = ACTIONS(4380),
    [sym_ptrdiff_t] = ACTIONS(4380),
    [sym_string] = ACTIONS(4380),
    [sym_cstring] = ACTIONS(4380),
    [sym_dstring] = ACTIONS(4380),
    [sym_wstring] = ACTIONS(4380),
    [sym_noreturn] = ACTIONS(4380),
    [sym_true] = ACTIONS(4380),
    [sym_false] = ACTIONS(4380),
    [sym_null] = ACTIONS(4380),
    [sym_super] = ACTIONS(4380),
    [sym_this] = ACTIONS(4380),
    [sym_assert] = ACTIONS(4380),
    [sym_auto] = ACTIONS(4380),
    [sym_cast] = ACTIONS(4380),
    [sym_catch] = ACTIONS(4380),
    [sym_const] = ACTIONS(4380),
    [sym_delegate] = ACTIONS(4380),
    [sym_delete] = ACTIONS(4380),
    [sym_do] = ACTIONS(4380),
    [sym_else] = ACTIONS(4380),
    [sym_finally] = ACTIONS(4380),
    [sym_function] = ACTIONS(4380),
    [sym_immutable] = ACTIONS(4380),
    [sym_import] = ACTIONS(4380),
    [sym_in] = ACTIONS(4380),
    [sym_inout] = ACTIONS(4380),
    [sym_is] = ACTIONS(4380),
    [sym_mixin] = ACTIONS(4380),
    [sym_new] = ACTIONS(4380),
    [sym_out] = ACTIONS(4380),
    [sym_ref] = ACTIONS(4380),
    [sym_shared] = ACTIONS(4380),
    [sym_throw] = ACTIONS(4380),
    [sym_typeid] = ACTIONS(4380),
    [sym_typeof] = ACTIONS(4380),
    [sym_traits] = ACTIONS(4380),
    [sym_vector] = ACTIONS(4380),
    [sym_void] = ACTIONS(4380),
    [anon_sym_BQUOTE] = ACTIONS(4382),
    [anon_sym_r_DQUOTE] = ACTIONS(4382),
    [anon_sym_x_DQUOTE] = ACTIONS(4382),
    [anon_sym_DQUOTE] = ACTIONS(4382),
    [anon_sym_i_BQUOTE] = ACTIONS(4382),
    [anon_sym_i_DQUOTE] = ACTIONS(4382),
    [anon_sym_iq_LBRACE] = ACTIONS(4382),
    [aux_sym_char_literal_token1] = ACTIONS(4382),
    [anon_sym_SQUOTE] = ACTIONS(4380),
    [anon_sym___DATE__] = ACTIONS(4380),
    [anon_sym___FILE__] = ACTIONS(4380),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4380),
    [anon_sym___FUNCTION__] = ACTIONS(4380),
    [anon_sym___LINE__] = ACTIONS(4380),
    [anon_sym___MODULE__] = ACTIONS(4380),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4380),
    [anon_sym___TIME__] = ACTIONS(4380),
    [anon_sym___TIMESTAMP__] = ACTIONS(4380),
    [anon_sym___VENDOR__] = ACTIONS(4380),
    [anon_sym___VERSION__] = ACTIONS(4380),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4382),
    [sym_float_literal] = ACTIONS(4382),
    [sym__string] = ACTIONS(4382),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(4460),
    [anon_sym_q_LBRACE] = ACTIONS(4462),
    [anon_sym_LBRACE] = ACTIONS(4462),
    [anon_sym_DOT] = ACTIONS(4462),
    [anon_sym_AMP] = ACTIONS(4462),
    [anon_sym_DASH] = ACTIONS(4460),
    [anon_sym_DASH_DASH] = ACTIONS(4462),
    [anon_sym_PLUS] = ACTIONS(4460),
    [anon_sym_PLUS_PLUS] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4462),
    [anon_sym_LPAREN] = ACTIONS(4462),
    [anon_sym_RPAREN] = ACTIONS(4462),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_DOLLAR] = ACTIONS(4462),
    [anon_sym_STAR] = ACTIONS(4462),
    [anon_sym_TILDE] = ACTIONS(4462),
    [sym_bool] = ACTIONS(4460),
    [sym_byte] = ACTIONS(4460),
    [sym_ubyte] = ACTIONS(4460),
    [sym_char] = ACTIONS(4460),
    [sym_short] = ACTIONS(4460),
    [sym_ushort] = ACTIONS(4460),
    [sym_int] = ACTIONS(4460),
    [sym_uint] = ACTIONS(4460),
    [sym_long] = ACTIONS(4460),
    [sym_ulong] = ACTIONS(4460),
    [sym_cent] = ACTIONS(4460),
    [sym_ucent] = ACTIONS(4460),
    [sym_wchar] = ACTIONS(4460),
    [sym_dchar] = ACTIONS(4460),
    [sym_float] = ACTIONS(4460),
    [sym_double] = ACTIONS(4460),
    [sym_real] = ACTIONS(4460),
    [sym_ifloat] = ACTIONS(4460),
    [sym_idouble] = ACTIONS(4460),
    [sym_ireal] = ACTIONS(4460),
    [sym_cfloat] = ACTIONS(4460),
    [sym_cdouble] = ACTIONS(4460),
    [sym_creal] = ACTIONS(4460),
    [sym_size_t] = ACTIONS(4460),
    [sym_ptrdiff_t] = ACTIONS(4460),
    [sym_string] = ACTIONS(4460),
    [sym_cstring] = ACTIONS(4460),
    [sym_dstring] = ACTIONS(4460),
    [sym_wstring] = ACTIONS(4460),
    [sym_noreturn] = ACTIONS(4460),
    [sym_true] = ACTIONS(4460),
    [sym_false] = ACTIONS(4460),
    [sym_null] = ACTIONS(4460),
    [sym_super] = ACTIONS(4460),
    [sym_this] = ACTIONS(4460),
    [sym_assert] = ACTIONS(4460),
    [sym_auto] = ACTIONS(4460),
    [sym_cast] = ACTIONS(4460),
    [sym_catch] = ACTIONS(4460),
    [sym_const] = ACTIONS(4460),
    [sym_delegate] = ACTIONS(4460),
    [sym_delete] = ACTIONS(4460),
    [sym_do] = ACTIONS(4460),
    [sym_else] = ACTIONS(4460),
    [sym_finally] = ACTIONS(4460),
    [sym_function] = ACTIONS(4460),
    [sym_immutable] = ACTIONS(4460),
    [sym_import] = ACTIONS(4460),
    [sym_in] = ACTIONS(4460),
    [sym_inout] = ACTIONS(4460),
    [sym_is] = ACTIONS(4460),
    [sym_mixin] = ACTIONS(4460),
    [sym_new] = ACTIONS(4460),
    [sym_out] = ACTIONS(4460),
    [sym_ref] = ACTIONS(4460),
    [sym_shared] = ACTIONS(4460),
    [sym_throw] = ACTIONS(4460),
    [sym_typeid] = ACTIONS(4460),
    [sym_typeof] = ACTIONS(4460),
    [sym_traits] = ACTIONS(4460),
    [sym_vector] = ACTIONS(4460),
    [sym_void] = ACTIONS(4460),
    [anon_sym_BQUOTE] = ACTIONS(4462),
    [anon_sym_r_DQUOTE] = ACTIONS(4462),
    [anon_sym_x_DQUOTE] = ACTIONS(4462),
    [anon_sym_DQUOTE] = ACTIONS(4462),
    [anon_sym_i_BQUOTE] = ACTIONS(4462),
    [anon_sym_i_DQUOTE] = ACTIONS(4462),
    [anon_sym_iq_LBRACE] = ACTIONS(4462),
    [aux_sym_char_literal_token1] = ACTIONS(4462),
    [anon_sym_SQUOTE] = ACTIONS(4460),
    [anon_sym___DATE__] = ACTIONS(4460),
    [anon_sym___FILE__] = ACTIONS(4460),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4460),
    [anon_sym___FUNCTION__] = ACTIONS(4460),
    [anon_sym___LINE__] = ACTIONS(4460),
    [anon_sym___MODULE__] = ACTIONS(4460),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4460),
    [anon_sym___TIME__] = ACTIONS(4460),
    [anon_sym___TIMESTAMP__] = ACTIONS(4460),
    [anon_sym___VENDOR__] = ACTIONS(4460),
    [anon_sym___VERSION__] = ACTIONS(4460),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4462),
    [sym_float_literal] = ACTIONS(4462),
    [sym__string] = ACTIONS(4462),
  },
  [2043] = {
    [sym_identifier] = ACTIONS(4751),
    [anon_sym_q_LBRACE] = ACTIONS(4753),
    [anon_sym_LBRACE] = ACTIONS(4753),
    [anon_sym_DOT] = ACTIONS(4753),
    [anon_sym_AMP] = ACTIONS(4753),
    [anon_sym_DASH] = ACTIONS(4751),
    [anon_sym_DASH_DASH] = ACTIONS(4753),
    [anon_sym_PLUS] = ACTIONS(4751),
    [anon_sym_PLUS_PLUS] = ACTIONS(4753),
    [anon_sym_BANG] = ACTIONS(4753),
    [anon_sym_LPAREN] = ACTIONS(4753),
    [anon_sym_RPAREN] = ACTIONS(4753),
    [anon_sym_LBRACK] = ACTIONS(4753),
    [anon_sym_SEMI] = ACTIONS(4753),
    [anon_sym_DOLLAR] = ACTIONS(4753),
    [anon_sym_STAR] = ACTIONS(4753),
    [anon_sym_TILDE] = ACTIONS(4753),
    [sym_bool] = ACTIONS(4751),
    [sym_byte] = ACTIONS(4751),
    [sym_ubyte] = ACTIONS(4751),
    [sym_char] = ACTIONS(4751),
    [sym_short] = ACTIONS(4751),
    [sym_ushort] = ACTIONS(4751),
    [sym_int] = ACTIONS(4751),
    [sym_uint] = ACTIONS(4751),
    [sym_long] = ACTIONS(4751),
    [sym_ulong] = ACTIONS(4751),
    [sym_cent] = ACTIONS(4751),
    [sym_ucent] = ACTIONS(4751),
    [sym_wchar] = ACTIONS(4751),
    [sym_dchar] = ACTIONS(4751),
    [sym_float] = ACTIONS(4751),
    [sym_double] = ACTIONS(4751),
    [sym_real] = ACTIONS(4751),
    [sym_ifloat] = ACTIONS(4751),
    [sym_idouble] = ACTIONS(4751),
    [sym_ireal] = ACTIONS(4751),
    [sym_cfloat] = ACTIONS(4751),
    [sym_cdouble] = ACTIONS(4751),
    [sym_creal] = ACTIONS(4751),
    [sym_size_t] = ACTIONS(4751),
    [sym_ptrdiff_t] = ACTIONS(4751),
    [sym_string] = ACTIONS(4751),
    [sym_cstring] = ACTIONS(4751),
    [sym_dstring] = ACTIONS(4751),
    [sym_wstring] = ACTIONS(4751),
    [sym_noreturn] = ACTIONS(4751),
    [sym_true] = ACTIONS(4751),
    [sym_false] = ACTIONS(4751),
    [sym_null] = ACTIONS(4751),
    [sym_super] = ACTIONS(4751),
    [sym_this] = ACTIONS(4751),
    [sym_assert] = ACTIONS(4751),
    [sym_auto] = ACTIONS(4751),
    [sym_cast] = ACTIONS(4751),
    [sym_catch] = ACTIONS(4751),
    [sym_const] = ACTIONS(4751),
    [sym_delegate] = ACTIONS(4751),
    [sym_delete] = ACTIONS(4751),
    [sym_do] = ACTIONS(4751),
    [sym_else] = ACTIONS(4751),
    [sym_finally] = ACTIONS(4751),
    [sym_function] = ACTIONS(4751),
    [sym_immutable] = ACTIONS(4751),
    [sym_import] = ACTIONS(4751),
    [sym_in] = ACTIONS(4751),
    [sym_inout] = ACTIONS(4751),
    [sym_is] = ACTIONS(4751),
    [sym_mixin] = ACTIONS(4751),
    [sym_new] = ACTIONS(4751),
    [sym_out] = ACTIONS(4751),
    [sym_ref] = ACTIONS(4751),
    [sym_shared] = ACTIONS(4751),
    [sym_throw] = ACTIONS(4751),
    [sym_typeid] = ACTIONS(4751),
    [sym_typeof] = ACTIONS(4751),
    [sym_traits] = ACTIONS(4751),
    [sym_vector] = ACTIONS(4751),
    [sym_void] = ACTIONS(4751),
    [anon_sym_BQUOTE] = ACTIONS(4753),
    [anon_sym_r_DQUOTE] = ACTIONS(4753),
    [anon_sym_x_DQUOTE] = ACTIONS(4753),
    [anon_sym_DQUOTE] = ACTIONS(4753),
    [anon_sym_i_BQUOTE] = ACTIONS(4753),
    [anon_sym_i_DQUOTE] = ACTIONS(4753),
    [anon_sym_iq_LBRACE] = ACTIONS(4753),
    [aux_sym_char_literal_token1] = ACTIONS(4753),
    [anon_sym_SQUOTE] = ACTIONS(4751),
    [anon_sym___DATE__] = ACTIONS(4751),
    [anon_sym___FILE__] = ACTIONS(4751),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4751),
    [anon_sym___FUNCTION__] = ACTIONS(4751),
    [anon_sym___LINE__] = ACTIONS(4751),
    [anon_sym___MODULE__] = ACTIONS(4751),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4751),
    [anon_sym___TIME__] = ACTIONS(4751),
    [anon_sym___TIMESTAMP__] = ACTIONS(4751),
    [anon_sym___VENDOR__] = ACTIONS(4751),
    [anon_sym___VERSION__] = ACTIONS(4751),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4753),
    [sym_float_literal] = ACTIONS(4753),
    [sym__string] = ACTIONS(4753),
  },
  [2044] = {
    [sym_identifier] = ACTIONS(4721),
    [anon_sym_q_LBRACE] = ACTIONS(4723),
    [anon_sym_LBRACE] = ACTIONS(4723),
    [anon_sym_DOT] = ACTIONS(4723),
    [anon_sym_AMP] = ACTIONS(4723),
    [anon_sym_DASH] = ACTIONS(4721),
    [anon_sym_DASH_DASH] = ACTIONS(4723),
    [anon_sym_PLUS] = ACTIONS(4721),
    [anon_sym_PLUS_PLUS] = ACTIONS(4723),
    [anon_sym_BANG] = ACTIONS(4723),
    [anon_sym_LPAREN] = ACTIONS(4723),
    [anon_sym_RPAREN] = ACTIONS(4723),
    [anon_sym_LBRACK] = ACTIONS(4723),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym_DOLLAR] = ACTIONS(4723),
    [anon_sym_STAR] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [sym_bool] = ACTIONS(4721),
    [sym_byte] = ACTIONS(4721),
    [sym_ubyte] = ACTIONS(4721),
    [sym_char] = ACTIONS(4721),
    [sym_short] = ACTIONS(4721),
    [sym_ushort] = ACTIONS(4721),
    [sym_int] = ACTIONS(4721),
    [sym_uint] = ACTIONS(4721),
    [sym_long] = ACTIONS(4721),
    [sym_ulong] = ACTIONS(4721),
    [sym_cent] = ACTIONS(4721),
    [sym_ucent] = ACTIONS(4721),
    [sym_wchar] = ACTIONS(4721),
    [sym_dchar] = ACTIONS(4721),
    [sym_float] = ACTIONS(4721),
    [sym_double] = ACTIONS(4721),
    [sym_real] = ACTIONS(4721),
    [sym_ifloat] = ACTIONS(4721),
    [sym_idouble] = ACTIONS(4721),
    [sym_ireal] = ACTIONS(4721),
    [sym_cfloat] = ACTIONS(4721),
    [sym_cdouble] = ACTIONS(4721),
    [sym_creal] = ACTIONS(4721),
    [sym_size_t] = ACTIONS(4721),
    [sym_ptrdiff_t] = ACTIONS(4721),
    [sym_string] = ACTIONS(4721),
    [sym_cstring] = ACTIONS(4721),
    [sym_dstring] = ACTIONS(4721),
    [sym_wstring] = ACTIONS(4721),
    [sym_noreturn] = ACTIONS(4721),
    [sym_true] = ACTIONS(4721),
    [sym_false] = ACTIONS(4721),
    [sym_null] = ACTIONS(4721),
    [sym_super] = ACTIONS(4721),
    [sym_this] = ACTIONS(4721),
    [sym_assert] = ACTIONS(4721),
    [sym_auto] = ACTIONS(4721),
    [sym_cast] = ACTIONS(4721),
    [sym_catch] = ACTIONS(4721),
    [sym_const] = ACTIONS(4721),
    [sym_delegate] = ACTIONS(4721),
    [sym_delete] = ACTIONS(4721),
    [sym_do] = ACTIONS(4721),
    [sym_else] = ACTIONS(4721),
    [sym_finally] = ACTIONS(4721),
    [sym_function] = ACTIONS(4721),
    [sym_immutable] = ACTIONS(4721),
    [sym_import] = ACTIONS(4721),
    [sym_in] = ACTIONS(4721),
    [sym_inout] = ACTIONS(4721),
    [sym_is] = ACTIONS(4721),
    [sym_mixin] = ACTIONS(4721),
    [sym_new] = ACTIONS(4721),
    [sym_out] = ACTIONS(4721),
    [sym_ref] = ACTIONS(4721),
    [sym_shared] = ACTIONS(4721),
    [sym_throw] = ACTIONS(4721),
    [sym_typeid] = ACTIONS(4721),
    [sym_typeof] = ACTIONS(4721),
    [sym_traits] = ACTIONS(4721),
    [sym_vector] = ACTIONS(4721),
    [sym_void] = ACTIONS(4721),
    [anon_sym_BQUOTE] = ACTIONS(4723),
    [anon_sym_r_DQUOTE] = ACTIONS(4723),
    [anon_sym_x_DQUOTE] = ACTIONS(4723),
    [anon_sym_DQUOTE] = ACTIONS(4723),
    [anon_sym_i_BQUOTE] = ACTIONS(4723),
    [anon_sym_i_DQUOTE] = ACTIONS(4723),
    [anon_sym_iq_LBRACE] = ACTIONS(4723),
    [aux_sym_char_literal_token1] = ACTIONS(4723),
    [anon_sym_SQUOTE] = ACTIONS(4721),
    [anon_sym___DATE__] = ACTIONS(4721),
    [anon_sym___FILE__] = ACTIONS(4721),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4721),
    [anon_sym___FUNCTION__] = ACTIONS(4721),
    [anon_sym___LINE__] = ACTIONS(4721),
    [anon_sym___MODULE__] = ACTIONS(4721),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4721),
    [anon_sym___TIME__] = ACTIONS(4721),
    [anon_sym___TIMESTAMP__] = ACTIONS(4721),
    [anon_sym___VENDOR__] = ACTIONS(4721),
    [anon_sym___VERSION__] = ACTIONS(4721),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4723),
    [sym_float_literal] = ACTIONS(4723),
    [sym__string] = ACTIONS(4723),
  },
  [2045] = {
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_q_LBRACE] = ACTIONS(4718),
    [anon_sym_LBRACE] = ACTIONS(4718),
    [anon_sym_DOT] = ACTIONS(4718),
    [anon_sym_AMP] = ACTIONS(4718),
    [anon_sym_DASH] = ACTIONS(4715),
    [anon_sym_DASH_DASH] = ACTIONS(4718),
    [anon_sym_PLUS] = ACTIONS(4715),
    [anon_sym_PLUS_PLUS] = ACTIONS(4718),
    [anon_sym_BANG] = ACTIONS(4718),
    [anon_sym_LPAREN] = ACTIONS(4718),
    [anon_sym_RPAREN] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym_DOLLAR] = ACTIONS(4718),
    [anon_sym_STAR] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [sym_bool] = ACTIONS(4715),
    [sym_byte] = ACTIONS(4715),
    [sym_ubyte] = ACTIONS(4715),
    [sym_char] = ACTIONS(4715),
    [sym_short] = ACTIONS(4715),
    [sym_ushort] = ACTIONS(4715),
    [sym_int] = ACTIONS(4715),
    [sym_uint] = ACTIONS(4715),
    [sym_long] = ACTIONS(4715),
    [sym_ulong] = ACTIONS(4715),
    [sym_cent] = ACTIONS(4715),
    [sym_ucent] = ACTIONS(4715),
    [sym_wchar] = ACTIONS(4715),
    [sym_dchar] = ACTIONS(4715),
    [sym_float] = ACTIONS(4715),
    [sym_double] = ACTIONS(4715),
    [sym_real] = ACTIONS(4715),
    [sym_ifloat] = ACTIONS(4715),
    [sym_idouble] = ACTIONS(4715),
    [sym_ireal] = ACTIONS(4715),
    [sym_cfloat] = ACTIONS(4715),
    [sym_cdouble] = ACTIONS(4715),
    [sym_creal] = ACTIONS(4715),
    [sym_size_t] = ACTIONS(4715),
    [sym_ptrdiff_t] = ACTIONS(4715),
    [sym_string] = ACTIONS(4715),
    [sym_cstring] = ACTIONS(4715),
    [sym_dstring] = ACTIONS(4715),
    [sym_wstring] = ACTIONS(4715),
    [sym_noreturn] = ACTIONS(4715),
    [sym_true] = ACTIONS(4715),
    [sym_false] = ACTIONS(4715),
    [sym_null] = ACTIONS(4715),
    [sym_super] = ACTIONS(4715),
    [sym_this] = ACTIONS(4715),
    [sym_assert] = ACTIONS(4715),
    [sym_auto] = ACTIONS(4715),
    [sym_cast] = ACTIONS(4715),
    [sym_catch] = ACTIONS(4715),
    [sym_const] = ACTIONS(4715),
    [sym_delegate] = ACTIONS(4715),
    [sym_delete] = ACTIONS(4715),
    [sym_do] = ACTIONS(4715),
    [sym_else] = ACTIONS(4715),
    [sym_finally] = ACTIONS(4715),
    [sym_function] = ACTIONS(4715),
    [sym_immutable] = ACTIONS(4715),
    [sym_import] = ACTIONS(4715),
    [sym_in] = ACTIONS(4715),
    [sym_inout] = ACTIONS(4715),
    [sym_is] = ACTIONS(4715),
    [sym_mixin] = ACTIONS(4715),
    [sym_new] = ACTIONS(4715),
    [sym_out] = ACTIONS(4715),
    [sym_ref] = ACTIONS(4715),
    [sym_shared] = ACTIONS(4715),
    [sym_throw] = ACTIONS(4715),
    [sym_typeid] = ACTIONS(4715),
    [sym_typeof] = ACTIONS(4715),
    [sym_traits] = ACTIONS(4715),
    [sym_vector] = ACTIONS(4715),
    [sym_void] = ACTIONS(4715),
    [anon_sym_BQUOTE] = ACTIONS(4718),
    [anon_sym_r_DQUOTE] = ACTIONS(4718),
    [anon_sym_x_DQUOTE] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(4718),
    [anon_sym_i_BQUOTE] = ACTIONS(4718),
    [anon_sym_i_DQUOTE] = ACTIONS(4718),
    [anon_sym_iq_LBRACE] = ACTIONS(4718),
    [aux_sym_char_literal_token1] = ACTIONS(4718),
    [anon_sym_SQUOTE] = ACTIONS(4715),
    [anon_sym___DATE__] = ACTIONS(4715),
    [anon_sym___FILE__] = ACTIONS(4715),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4715),
    [anon_sym___FUNCTION__] = ACTIONS(4715),
    [anon_sym___LINE__] = ACTIONS(4715),
    [anon_sym___MODULE__] = ACTIONS(4715),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4715),
    [anon_sym___TIME__] = ACTIONS(4715),
    [anon_sym___TIMESTAMP__] = ACTIONS(4715),
    [anon_sym___VENDOR__] = ACTIONS(4715),
    [anon_sym___VERSION__] = ACTIONS(4715),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4718),
    [sym_float_literal] = ACTIONS(4718),
    [sym__string] = ACTIONS(4718),
  },
  [2046] = {
    [sym_identifier] = ACTIONS(4566),
    [anon_sym_q_LBRACE] = ACTIONS(4568),
    [anon_sym_LBRACE] = ACTIONS(4568),
    [anon_sym_DOT] = ACTIONS(4568),
    [anon_sym_AMP] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4566),
    [anon_sym_DASH_DASH] = ACTIONS(4568),
    [anon_sym_PLUS] = ACTIONS(4566),
    [anon_sym_PLUS_PLUS] = ACTIONS(4568),
    [anon_sym_BANG] = ACTIONS(4568),
    [anon_sym_LPAREN] = ACTIONS(4568),
    [anon_sym_RPAREN] = ACTIONS(4568),
    [anon_sym_LBRACK] = ACTIONS(4568),
    [anon_sym_SEMI] = ACTIONS(4568),
    [anon_sym_DOLLAR] = ACTIONS(4568),
    [anon_sym_STAR] = ACTIONS(4568),
    [anon_sym_TILDE] = ACTIONS(4568),
    [sym_bool] = ACTIONS(4566),
    [sym_byte] = ACTIONS(4566),
    [sym_ubyte] = ACTIONS(4566),
    [sym_char] = ACTIONS(4566),
    [sym_short] = ACTIONS(4566),
    [sym_ushort] = ACTIONS(4566),
    [sym_int] = ACTIONS(4566),
    [sym_uint] = ACTIONS(4566),
    [sym_long] = ACTIONS(4566),
    [sym_ulong] = ACTIONS(4566),
    [sym_cent] = ACTIONS(4566),
    [sym_ucent] = ACTIONS(4566),
    [sym_wchar] = ACTIONS(4566),
    [sym_dchar] = ACTIONS(4566),
    [sym_float] = ACTIONS(4566),
    [sym_double] = ACTIONS(4566),
    [sym_real] = ACTIONS(4566),
    [sym_ifloat] = ACTIONS(4566),
    [sym_idouble] = ACTIONS(4566),
    [sym_ireal] = ACTIONS(4566),
    [sym_cfloat] = ACTIONS(4566),
    [sym_cdouble] = ACTIONS(4566),
    [sym_creal] = ACTIONS(4566),
    [sym_size_t] = ACTIONS(4566),
    [sym_ptrdiff_t] = ACTIONS(4566),
    [sym_string] = ACTIONS(4566),
    [sym_cstring] = ACTIONS(4566),
    [sym_dstring] = ACTIONS(4566),
    [sym_wstring] = ACTIONS(4566),
    [sym_noreturn] = ACTIONS(4566),
    [sym_true] = ACTIONS(4566),
    [sym_false] = ACTIONS(4566),
    [sym_null] = ACTIONS(4566),
    [sym_super] = ACTIONS(4566),
    [sym_this] = ACTIONS(4566),
    [sym_assert] = ACTIONS(4566),
    [sym_auto] = ACTIONS(4566),
    [sym_cast] = ACTIONS(4566),
    [sym_catch] = ACTIONS(4566),
    [sym_const] = ACTIONS(4566),
    [sym_delegate] = ACTIONS(4566),
    [sym_delete] = ACTIONS(4566),
    [sym_do] = ACTIONS(4566),
    [sym_else] = ACTIONS(4566),
    [sym_finally] = ACTIONS(4566),
    [sym_function] = ACTIONS(4566),
    [sym_immutable] = ACTIONS(4566),
    [sym_import] = ACTIONS(4566),
    [sym_in] = ACTIONS(4566),
    [sym_inout] = ACTIONS(4566),
    [sym_is] = ACTIONS(4566),
    [sym_mixin] = ACTIONS(4566),
    [sym_new] = ACTIONS(4566),
    [sym_out] = ACTIONS(4566),
    [sym_ref] = ACTIONS(4566),
    [sym_shared] = ACTIONS(4566),
    [sym_throw] = ACTIONS(4566),
    [sym_typeid] = ACTIONS(4566),
    [sym_typeof] = ACTIONS(4566),
    [sym_traits] = ACTIONS(4566),
    [sym_vector] = ACTIONS(4566),
    [sym_void] = ACTIONS(4566),
    [anon_sym_BQUOTE] = ACTIONS(4568),
    [anon_sym_r_DQUOTE] = ACTIONS(4568),
    [anon_sym_x_DQUOTE] = ACTIONS(4568),
    [anon_sym_DQUOTE] = ACTIONS(4568),
    [anon_sym_i_BQUOTE] = ACTIONS(4568),
    [anon_sym_i_DQUOTE] = ACTIONS(4568),
    [anon_sym_iq_LBRACE] = ACTIONS(4568),
    [aux_sym_char_literal_token1] = ACTIONS(4568),
    [anon_sym_SQUOTE] = ACTIONS(4566),
    [anon_sym___DATE__] = ACTIONS(4566),
    [anon_sym___FILE__] = ACTIONS(4566),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4566),
    [anon_sym___FUNCTION__] = ACTIONS(4566),
    [anon_sym___LINE__] = ACTIONS(4566),
    [anon_sym___MODULE__] = ACTIONS(4566),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4566),
    [anon_sym___TIME__] = ACTIONS(4566),
    [anon_sym___TIMESTAMP__] = ACTIONS(4566),
    [anon_sym___VENDOR__] = ACTIONS(4566),
    [anon_sym___VERSION__] = ACTIONS(4566),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4568),
    [sym_float_literal] = ACTIONS(4568),
    [sym__string] = ACTIONS(4568),
  },
  [2047] = {
    [sym_identifier] = ACTIONS(4586),
    [anon_sym_q_LBRACE] = ACTIONS(4588),
    [anon_sym_LBRACE] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4588),
    [anon_sym_AMP] = ACTIONS(4588),
    [anon_sym_DASH] = ACTIONS(4586),
    [anon_sym_DASH_DASH] = ACTIONS(4588),
    [anon_sym_PLUS] = ACTIONS(4586),
    [anon_sym_PLUS_PLUS] = ACTIONS(4588),
    [anon_sym_BANG] = ACTIONS(4588),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_RPAREN] = ACTIONS(4588),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_DOLLAR] = ACTIONS(4588),
    [anon_sym_STAR] = ACTIONS(4588),
    [anon_sym_TILDE] = ACTIONS(4588),
    [sym_bool] = ACTIONS(4586),
    [sym_byte] = ACTIONS(4586),
    [sym_ubyte] = ACTIONS(4586),
    [sym_char] = ACTIONS(4586),
    [sym_short] = ACTIONS(4586),
    [sym_ushort] = ACTIONS(4586),
    [sym_int] = ACTIONS(4586),
    [sym_uint] = ACTIONS(4586),
    [sym_long] = ACTIONS(4586),
    [sym_ulong] = ACTIONS(4586),
    [sym_cent] = ACTIONS(4586),
    [sym_ucent] = ACTIONS(4586),
    [sym_wchar] = ACTIONS(4586),
    [sym_dchar] = ACTIONS(4586),
    [sym_float] = ACTIONS(4586),
    [sym_double] = ACTIONS(4586),
    [sym_real] = ACTIONS(4586),
    [sym_ifloat] = ACTIONS(4586),
    [sym_idouble] = ACTIONS(4586),
    [sym_ireal] = ACTIONS(4586),
    [sym_cfloat] = ACTIONS(4586),
    [sym_cdouble] = ACTIONS(4586),
    [sym_creal] = ACTIONS(4586),
    [sym_size_t] = ACTIONS(4586),
    [sym_ptrdiff_t] = ACTIONS(4586),
    [sym_string] = ACTIONS(4586),
    [sym_cstring] = ACTIONS(4586),
    [sym_dstring] = ACTIONS(4586),
    [sym_wstring] = ACTIONS(4586),
    [sym_noreturn] = ACTIONS(4586),
    [sym_true] = ACTIONS(4586),
    [sym_false] = ACTIONS(4586),
    [sym_null] = ACTIONS(4586),
    [sym_super] = ACTIONS(4586),
    [sym_this] = ACTIONS(4586),
    [sym_assert] = ACTIONS(4586),
    [sym_auto] = ACTIONS(4586),
    [sym_cast] = ACTIONS(4586),
    [sym_catch] = ACTIONS(4586),
    [sym_const] = ACTIONS(4586),
    [sym_delegate] = ACTIONS(4586),
    [sym_delete] = ACTIONS(4586),
    [sym_do] = ACTIONS(4586),
    [sym_else] = ACTIONS(4586),
    [sym_finally] = ACTIONS(4586),
    [sym_function] = ACTIONS(4586),
    [sym_immutable] = ACTIONS(4586),
    [sym_import] = ACTIONS(4586),
    [sym_in] = ACTIONS(4586),
    [sym_inout] = ACTIONS(4586),
    [sym_is] = ACTIONS(4586),
    [sym_mixin] = ACTIONS(4586),
    [sym_new] = ACTIONS(4586),
    [sym_out] = ACTIONS(4586),
    [sym_ref] = ACTIONS(4586),
    [sym_shared] = ACTIONS(4586),
    [sym_throw] = ACTIONS(4586),
    [sym_typeid] = ACTIONS(4586),
    [sym_typeof] = ACTIONS(4586),
    [sym_traits] = ACTIONS(4586),
    [sym_vector] = ACTIONS(4586),
    [sym_void] = ACTIONS(4586),
    [anon_sym_BQUOTE] = ACTIONS(4588),
    [anon_sym_r_DQUOTE] = ACTIONS(4588),
    [anon_sym_x_DQUOTE] = ACTIONS(4588),
    [anon_sym_DQUOTE] = ACTIONS(4588),
    [anon_sym_i_BQUOTE] = ACTIONS(4588),
    [anon_sym_i_DQUOTE] = ACTIONS(4588),
    [anon_sym_iq_LBRACE] = ACTIONS(4588),
    [aux_sym_char_literal_token1] = ACTIONS(4588),
    [anon_sym_SQUOTE] = ACTIONS(4586),
    [anon_sym___DATE__] = ACTIONS(4586),
    [anon_sym___FILE__] = ACTIONS(4586),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4586),
    [anon_sym___FUNCTION__] = ACTIONS(4586),
    [anon_sym___LINE__] = ACTIONS(4586),
    [anon_sym___MODULE__] = ACTIONS(4586),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4586),
    [anon_sym___TIME__] = ACTIONS(4586),
    [anon_sym___TIMESTAMP__] = ACTIONS(4586),
    [anon_sym___VENDOR__] = ACTIONS(4586),
    [anon_sym___VERSION__] = ACTIONS(4586),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4588),
    [sym_float_literal] = ACTIONS(4588),
    [sym__string] = ACTIONS(4588),
  },
  [2048] = {
    [sym_identifier] = ACTIONS(4582),
    [anon_sym_q_LBRACE] = ACTIONS(4584),
    [anon_sym_LBRACE] = ACTIONS(4584),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_AMP] = ACTIONS(4584),
    [anon_sym_DASH] = ACTIONS(4582),
    [anon_sym_DASH_DASH] = ACTIONS(4584),
    [anon_sym_PLUS] = ACTIONS(4582),
    [anon_sym_PLUS_PLUS] = ACTIONS(4584),
    [anon_sym_BANG] = ACTIONS(4584),
    [anon_sym_LPAREN] = ACTIONS(4584),
    [anon_sym_RPAREN] = ACTIONS(4584),
    [anon_sym_LBRACK] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_DOLLAR] = ACTIONS(4584),
    [anon_sym_STAR] = ACTIONS(4584),
    [anon_sym_TILDE] = ACTIONS(4584),
    [sym_bool] = ACTIONS(4582),
    [sym_byte] = ACTIONS(4582),
    [sym_ubyte] = ACTIONS(4582),
    [sym_char] = ACTIONS(4582),
    [sym_short] = ACTIONS(4582),
    [sym_ushort] = ACTIONS(4582),
    [sym_int] = ACTIONS(4582),
    [sym_uint] = ACTIONS(4582),
    [sym_long] = ACTIONS(4582),
    [sym_ulong] = ACTIONS(4582),
    [sym_cent] = ACTIONS(4582),
    [sym_ucent] = ACTIONS(4582),
    [sym_wchar] = ACTIONS(4582),
    [sym_dchar] = ACTIONS(4582),
    [sym_float] = ACTIONS(4582),
    [sym_double] = ACTIONS(4582),
    [sym_real] = ACTIONS(4582),
    [sym_ifloat] = ACTIONS(4582),
    [sym_idouble] = ACTIONS(4582),
    [sym_ireal] = ACTIONS(4582),
    [sym_cfloat] = ACTIONS(4582),
    [sym_cdouble] = ACTIONS(4582),
    [sym_creal] = ACTIONS(4582),
    [sym_size_t] = ACTIONS(4582),
    [sym_ptrdiff_t] = ACTIONS(4582),
    [sym_string] = ACTIONS(4582),
    [sym_cstring] = ACTIONS(4582),
    [sym_dstring] = ACTIONS(4582),
    [sym_wstring] = ACTIONS(4582),
    [sym_noreturn] = ACTIONS(4582),
    [sym_true] = ACTIONS(4582),
    [sym_false] = ACTIONS(4582),
    [sym_null] = ACTIONS(4582),
    [sym_super] = ACTIONS(4582),
    [sym_this] = ACTIONS(4582),
    [sym_assert] = ACTIONS(4582),
    [sym_auto] = ACTIONS(4582),
    [sym_cast] = ACTIONS(4582),
    [sym_catch] = ACTIONS(4582),
    [sym_const] = ACTIONS(4582),
    [sym_delegate] = ACTIONS(4582),
    [sym_delete] = ACTIONS(4582),
    [sym_do] = ACTIONS(4582),
    [sym_else] = ACTIONS(4582),
    [sym_finally] = ACTIONS(4582),
    [sym_function] = ACTIONS(4582),
    [sym_immutable] = ACTIONS(4582),
    [sym_import] = ACTIONS(4582),
    [sym_in] = ACTIONS(4582),
    [sym_inout] = ACTIONS(4582),
    [sym_is] = ACTIONS(4582),
    [sym_mixin] = ACTIONS(4582),
    [sym_new] = ACTIONS(4582),
    [sym_out] = ACTIONS(4582),
    [sym_ref] = ACTIONS(4582),
    [sym_shared] = ACTIONS(4582),
    [sym_throw] = ACTIONS(4582),
    [sym_typeid] = ACTIONS(4582),
    [sym_typeof] = ACTIONS(4582),
    [sym_traits] = ACTIONS(4582),
    [sym_vector] = ACTIONS(4582),
    [sym_void] = ACTIONS(4582),
    [anon_sym_BQUOTE] = ACTIONS(4584),
    [anon_sym_r_DQUOTE] = ACTIONS(4584),
    [anon_sym_x_DQUOTE] = ACTIONS(4584),
    [anon_sym_DQUOTE] = ACTIONS(4584),
    [anon_sym_i_BQUOTE] = ACTIONS(4584),
    [anon_sym_i_DQUOTE] = ACTIONS(4584),
    [anon_sym_iq_LBRACE] = ACTIONS(4584),
    [aux_sym_char_literal_token1] = ACTIONS(4584),
    [anon_sym_SQUOTE] = ACTIONS(4582),
    [anon_sym___DATE__] = ACTIONS(4582),
    [anon_sym___FILE__] = ACTIONS(4582),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4582),
    [anon_sym___FUNCTION__] = ACTIONS(4582),
    [anon_sym___LINE__] = ACTIONS(4582),
    [anon_sym___MODULE__] = ACTIONS(4582),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4582),
    [anon_sym___TIME__] = ACTIONS(4582),
    [anon_sym___TIMESTAMP__] = ACTIONS(4582),
    [anon_sym___VENDOR__] = ACTIONS(4582),
    [anon_sym___VERSION__] = ACTIONS(4582),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4584),
    [sym_float_literal] = ACTIONS(4584),
    [sym__string] = ACTIONS(4584),
  },
  [2049] = {
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_q_LBRACE] = ACTIONS(4336),
    [anon_sym_LBRACE] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_AMP] = ACTIONS(4336),
    [anon_sym_DASH] = ACTIONS(4334),
    [anon_sym_DASH_DASH] = ACTIONS(4336),
    [anon_sym_PLUS] = ACTIONS(4334),
    [anon_sym_PLUS_PLUS] = ACTIONS(4336),
    [anon_sym_BANG] = ACTIONS(4336),
    [anon_sym_LPAREN] = ACTIONS(4336),
    [anon_sym_RPAREN] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(4336),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_DOLLAR] = ACTIONS(4336),
    [anon_sym_STAR] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4336),
    [sym_bool] = ACTIONS(4334),
    [sym_byte] = ACTIONS(4334),
    [sym_ubyte] = ACTIONS(4334),
    [sym_char] = ACTIONS(4334),
    [sym_short] = ACTIONS(4334),
    [sym_ushort] = ACTIONS(4334),
    [sym_int] = ACTIONS(4334),
    [sym_uint] = ACTIONS(4334),
    [sym_long] = ACTIONS(4334),
    [sym_ulong] = ACTIONS(4334),
    [sym_cent] = ACTIONS(4334),
    [sym_ucent] = ACTIONS(4334),
    [sym_wchar] = ACTIONS(4334),
    [sym_dchar] = ACTIONS(4334),
    [sym_float] = ACTIONS(4334),
    [sym_double] = ACTIONS(4334),
    [sym_real] = ACTIONS(4334),
    [sym_ifloat] = ACTIONS(4334),
    [sym_idouble] = ACTIONS(4334),
    [sym_ireal] = ACTIONS(4334),
    [sym_cfloat] = ACTIONS(4334),
    [sym_cdouble] = ACTIONS(4334),
    [sym_creal] = ACTIONS(4334),
    [sym_size_t] = ACTIONS(4334),
    [sym_ptrdiff_t] = ACTIONS(4334),
    [sym_string] = ACTIONS(4334),
    [sym_cstring] = ACTIONS(4334),
    [sym_dstring] = ACTIONS(4334),
    [sym_wstring] = ACTIONS(4334),
    [sym_noreturn] = ACTIONS(4334),
    [sym_true] = ACTIONS(4334),
    [sym_false] = ACTIONS(4334),
    [sym_null] = ACTIONS(4334),
    [sym_super] = ACTIONS(4334),
    [sym_this] = ACTIONS(4334),
    [sym_assert] = ACTIONS(4334),
    [sym_auto] = ACTIONS(4334),
    [sym_cast] = ACTIONS(4334),
    [sym_catch] = ACTIONS(4334),
    [sym_const] = ACTIONS(4334),
    [sym_delegate] = ACTIONS(4334),
    [sym_delete] = ACTIONS(4334),
    [sym_do] = ACTIONS(4334),
    [sym_else] = ACTIONS(4334),
    [sym_finally] = ACTIONS(4334),
    [sym_function] = ACTIONS(4334),
    [sym_immutable] = ACTIONS(4334),
    [sym_import] = ACTIONS(4334),
    [sym_in] = ACTIONS(4334),
    [sym_inout] = ACTIONS(4334),
    [sym_is] = ACTIONS(4334),
    [sym_mixin] = ACTIONS(4334),
    [sym_new] = ACTIONS(4334),
    [sym_out] = ACTIONS(4334),
    [sym_ref] = ACTIONS(4334),
    [sym_shared] = ACTIONS(4334),
    [sym_throw] = ACTIONS(4334),
    [sym_typeid] = ACTIONS(4334),
    [sym_typeof] = ACTIONS(4334),
    [sym_traits] = ACTIONS(4334),
    [sym_vector] = ACTIONS(4334),
    [sym_void] = ACTIONS(4334),
    [anon_sym_BQUOTE] = ACTIONS(4336),
    [anon_sym_r_DQUOTE] = ACTIONS(4336),
    [anon_sym_x_DQUOTE] = ACTIONS(4336),
    [anon_sym_DQUOTE] = ACTIONS(4336),
    [anon_sym_i_BQUOTE] = ACTIONS(4336),
    [anon_sym_i_DQUOTE] = ACTIONS(4336),
    [anon_sym_iq_LBRACE] = ACTIONS(4336),
    [aux_sym_char_literal_token1] = ACTIONS(4336),
    [anon_sym_SQUOTE] = ACTIONS(4334),
    [anon_sym___DATE__] = ACTIONS(4334),
    [anon_sym___FILE__] = ACTIONS(4334),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4334),
    [anon_sym___FUNCTION__] = ACTIONS(4334),
    [anon_sym___LINE__] = ACTIONS(4334),
    [anon_sym___MODULE__] = ACTIONS(4334),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4334),
    [anon_sym___TIME__] = ACTIONS(4334),
    [anon_sym___TIMESTAMP__] = ACTIONS(4334),
    [anon_sym___VENDOR__] = ACTIONS(4334),
    [anon_sym___VERSION__] = ACTIONS(4334),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4336),
    [sym_float_literal] = ACTIONS(4336),
    [sym__string] = ACTIONS(4336),
  },
  [2050] = {
    [sym_identifier] = ACTIONS(4330),
    [anon_sym_q_LBRACE] = ACTIONS(4332),
    [anon_sym_LBRACE] = ACTIONS(4332),
    [anon_sym_DOT] = ACTIONS(4332),
    [anon_sym_AMP] = ACTIONS(4332),
    [anon_sym_DASH] = ACTIONS(4330),
    [anon_sym_DASH_DASH] = ACTIONS(4332),
    [anon_sym_PLUS] = ACTIONS(4330),
    [anon_sym_PLUS_PLUS] = ACTIONS(4332),
    [anon_sym_BANG] = ACTIONS(4332),
    [anon_sym_LPAREN] = ACTIONS(4332),
    [anon_sym_RPAREN] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(4332),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_DOLLAR] = ACTIONS(4332),
    [anon_sym_STAR] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [sym_bool] = ACTIONS(4330),
    [sym_byte] = ACTIONS(4330),
    [sym_ubyte] = ACTIONS(4330),
    [sym_char] = ACTIONS(4330),
    [sym_short] = ACTIONS(4330),
    [sym_ushort] = ACTIONS(4330),
    [sym_int] = ACTIONS(4330),
    [sym_uint] = ACTIONS(4330),
    [sym_long] = ACTIONS(4330),
    [sym_ulong] = ACTIONS(4330),
    [sym_cent] = ACTIONS(4330),
    [sym_ucent] = ACTIONS(4330),
    [sym_wchar] = ACTIONS(4330),
    [sym_dchar] = ACTIONS(4330),
    [sym_float] = ACTIONS(4330),
    [sym_double] = ACTIONS(4330),
    [sym_real] = ACTIONS(4330),
    [sym_ifloat] = ACTIONS(4330),
    [sym_idouble] = ACTIONS(4330),
    [sym_ireal] = ACTIONS(4330),
    [sym_cfloat] = ACTIONS(4330),
    [sym_cdouble] = ACTIONS(4330),
    [sym_creal] = ACTIONS(4330),
    [sym_size_t] = ACTIONS(4330),
    [sym_ptrdiff_t] = ACTIONS(4330),
    [sym_string] = ACTIONS(4330),
    [sym_cstring] = ACTIONS(4330),
    [sym_dstring] = ACTIONS(4330),
    [sym_wstring] = ACTIONS(4330),
    [sym_noreturn] = ACTIONS(4330),
    [sym_true] = ACTIONS(4330),
    [sym_false] = ACTIONS(4330),
    [sym_null] = ACTIONS(4330),
    [sym_super] = ACTIONS(4330),
    [sym_this] = ACTIONS(4330),
    [sym_assert] = ACTIONS(4330),
    [sym_auto] = ACTIONS(4330),
    [sym_cast] = ACTIONS(4330),
    [sym_catch] = ACTIONS(4330),
    [sym_const] = ACTIONS(4330),
    [sym_delegate] = ACTIONS(4330),
    [sym_delete] = ACTIONS(4330),
    [sym_do] = ACTIONS(4330),
    [sym_else] = ACTIONS(4330),
    [sym_finally] = ACTIONS(4330),
    [sym_function] = ACTIONS(4330),
    [sym_immutable] = ACTIONS(4330),
    [sym_import] = ACTIONS(4330),
    [sym_in] = ACTIONS(4330),
    [sym_inout] = ACTIONS(4330),
    [sym_is] = ACTIONS(4330),
    [sym_mixin] = ACTIONS(4330),
    [sym_new] = ACTIONS(4330),
    [sym_out] = ACTIONS(4330),
    [sym_ref] = ACTIONS(4330),
    [sym_shared] = ACTIONS(4330),
    [sym_throw] = ACTIONS(4330),
    [sym_typeid] = ACTIONS(4330),
    [sym_typeof] = ACTIONS(4330),
    [sym_traits] = ACTIONS(4330),
    [sym_vector] = ACTIONS(4330),
    [sym_void] = ACTIONS(4330),
    [anon_sym_BQUOTE] = ACTIONS(4332),
    [anon_sym_r_DQUOTE] = ACTIONS(4332),
    [anon_sym_x_DQUOTE] = ACTIONS(4332),
    [anon_sym_DQUOTE] = ACTIONS(4332),
    [anon_sym_i_BQUOTE] = ACTIONS(4332),
    [anon_sym_i_DQUOTE] = ACTIONS(4332),
    [anon_sym_iq_LBRACE] = ACTIONS(4332),
    [aux_sym_char_literal_token1] = ACTIONS(4332),
    [anon_sym_SQUOTE] = ACTIONS(4330),
    [anon_sym___DATE__] = ACTIONS(4330),
    [anon_sym___FILE__] = ACTIONS(4330),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4330),
    [anon_sym___FUNCTION__] = ACTIONS(4330),
    [anon_sym___LINE__] = ACTIONS(4330),
    [anon_sym___MODULE__] = ACTIONS(4330),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4330),
    [anon_sym___TIME__] = ACTIONS(4330),
    [anon_sym___TIMESTAMP__] = ACTIONS(4330),
    [anon_sym___VENDOR__] = ACTIONS(4330),
    [anon_sym___VERSION__] = ACTIONS(4330),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4332),
    [sym_float_literal] = ACTIONS(4332),
    [sym__string] = ACTIONS(4332),
  },
  [2051] = {
    [sym_identifier] = ACTIONS(4522),
    [anon_sym_q_LBRACE] = ACTIONS(4524),
    [anon_sym_LBRACE] = ACTIONS(4524),
    [anon_sym_DOT] = ACTIONS(4524),
    [anon_sym_AMP] = ACTIONS(4524),
    [anon_sym_DASH] = ACTIONS(4522),
    [anon_sym_DASH_DASH] = ACTIONS(4524),
    [anon_sym_PLUS] = ACTIONS(4522),
    [anon_sym_PLUS_PLUS] = ACTIONS(4524),
    [anon_sym_BANG] = ACTIONS(4524),
    [anon_sym_LPAREN] = ACTIONS(4524),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_LBRACK] = ACTIONS(4524),
    [anon_sym_SEMI] = ACTIONS(4524),
    [anon_sym_DOLLAR] = ACTIONS(4524),
    [anon_sym_STAR] = ACTIONS(4524),
    [anon_sym_TILDE] = ACTIONS(4524),
    [sym_bool] = ACTIONS(4522),
    [sym_byte] = ACTIONS(4522),
    [sym_ubyte] = ACTIONS(4522),
    [sym_char] = ACTIONS(4522),
    [sym_short] = ACTIONS(4522),
    [sym_ushort] = ACTIONS(4522),
    [sym_int] = ACTIONS(4522),
    [sym_uint] = ACTIONS(4522),
    [sym_long] = ACTIONS(4522),
    [sym_ulong] = ACTIONS(4522),
    [sym_cent] = ACTIONS(4522),
    [sym_ucent] = ACTIONS(4522),
    [sym_wchar] = ACTIONS(4522),
    [sym_dchar] = ACTIONS(4522),
    [sym_float] = ACTIONS(4522),
    [sym_double] = ACTIONS(4522),
    [sym_real] = ACTIONS(4522),
    [sym_ifloat] = ACTIONS(4522),
    [sym_idouble] = ACTIONS(4522),
    [sym_ireal] = ACTIONS(4522),
    [sym_cfloat] = ACTIONS(4522),
    [sym_cdouble] = ACTIONS(4522),
    [sym_creal] = ACTIONS(4522),
    [sym_size_t] = ACTIONS(4522),
    [sym_ptrdiff_t] = ACTIONS(4522),
    [sym_string] = ACTIONS(4522),
    [sym_cstring] = ACTIONS(4522),
    [sym_dstring] = ACTIONS(4522),
    [sym_wstring] = ACTIONS(4522),
    [sym_noreturn] = ACTIONS(4522),
    [sym_true] = ACTIONS(4522),
    [sym_false] = ACTIONS(4522),
    [sym_null] = ACTIONS(4522),
    [sym_super] = ACTIONS(4522),
    [sym_this] = ACTIONS(4522),
    [sym_assert] = ACTIONS(4522),
    [sym_auto] = ACTIONS(4522),
    [sym_cast] = ACTIONS(4522),
    [sym_catch] = ACTIONS(4522),
    [sym_const] = ACTIONS(4522),
    [sym_delegate] = ACTIONS(4522),
    [sym_delete] = ACTIONS(4522),
    [sym_do] = ACTIONS(4522),
    [sym_else] = ACTIONS(4522),
    [sym_finally] = ACTIONS(4522),
    [sym_function] = ACTIONS(4522),
    [sym_immutable] = ACTIONS(4522),
    [sym_import] = ACTIONS(4522),
    [sym_in] = ACTIONS(4522),
    [sym_inout] = ACTIONS(4522),
    [sym_is] = ACTIONS(4522),
    [sym_mixin] = ACTIONS(4522),
    [sym_new] = ACTIONS(4522),
    [sym_out] = ACTIONS(4522),
    [sym_ref] = ACTIONS(4522),
    [sym_shared] = ACTIONS(4522),
    [sym_throw] = ACTIONS(4522),
    [sym_typeid] = ACTIONS(4522),
    [sym_typeof] = ACTIONS(4522),
    [sym_traits] = ACTIONS(4522),
    [sym_vector] = ACTIONS(4522),
    [sym_void] = ACTIONS(4522),
    [anon_sym_BQUOTE] = ACTIONS(4524),
    [anon_sym_r_DQUOTE] = ACTIONS(4524),
    [anon_sym_x_DQUOTE] = ACTIONS(4524),
    [anon_sym_DQUOTE] = ACTIONS(4524),
    [anon_sym_i_BQUOTE] = ACTIONS(4524),
    [anon_sym_i_DQUOTE] = ACTIONS(4524),
    [anon_sym_iq_LBRACE] = ACTIONS(4524),
    [aux_sym_char_literal_token1] = ACTIONS(4524),
    [anon_sym_SQUOTE] = ACTIONS(4522),
    [anon_sym___DATE__] = ACTIONS(4522),
    [anon_sym___FILE__] = ACTIONS(4522),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4522),
    [anon_sym___FUNCTION__] = ACTIONS(4522),
    [anon_sym___LINE__] = ACTIONS(4522),
    [anon_sym___MODULE__] = ACTIONS(4522),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4522),
    [anon_sym___TIME__] = ACTIONS(4522),
    [anon_sym___TIMESTAMP__] = ACTIONS(4522),
    [anon_sym___VENDOR__] = ACTIONS(4522),
    [anon_sym___VERSION__] = ACTIONS(4522),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4524),
    [sym_float_literal] = ACTIONS(4524),
    [sym__string] = ACTIONS(4524),
  },
  [2052] = {
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_q_LBRACE] = ACTIONS(4536),
    [anon_sym_LBRACE] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_AMP] = ACTIONS(4536),
    [anon_sym_DASH] = ACTIONS(4534),
    [anon_sym_DASH_DASH] = ACTIONS(4536),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_PLUS_PLUS] = ACTIONS(4536),
    [anon_sym_BANG] = ACTIONS(4536),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_RPAREN] = ACTIONS(4536),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_DOLLAR] = ACTIONS(4536),
    [anon_sym_STAR] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [sym_bool] = ACTIONS(4534),
    [sym_byte] = ACTIONS(4534),
    [sym_ubyte] = ACTIONS(4534),
    [sym_char] = ACTIONS(4534),
    [sym_short] = ACTIONS(4534),
    [sym_ushort] = ACTIONS(4534),
    [sym_int] = ACTIONS(4534),
    [sym_uint] = ACTIONS(4534),
    [sym_long] = ACTIONS(4534),
    [sym_ulong] = ACTIONS(4534),
    [sym_cent] = ACTIONS(4534),
    [sym_ucent] = ACTIONS(4534),
    [sym_wchar] = ACTIONS(4534),
    [sym_dchar] = ACTIONS(4534),
    [sym_float] = ACTIONS(4534),
    [sym_double] = ACTIONS(4534),
    [sym_real] = ACTIONS(4534),
    [sym_ifloat] = ACTIONS(4534),
    [sym_idouble] = ACTIONS(4534),
    [sym_ireal] = ACTIONS(4534),
    [sym_cfloat] = ACTIONS(4534),
    [sym_cdouble] = ACTIONS(4534),
    [sym_creal] = ACTIONS(4534),
    [sym_size_t] = ACTIONS(4534),
    [sym_ptrdiff_t] = ACTIONS(4534),
    [sym_string] = ACTIONS(4534),
    [sym_cstring] = ACTIONS(4534),
    [sym_dstring] = ACTIONS(4534),
    [sym_wstring] = ACTIONS(4534),
    [sym_noreturn] = ACTIONS(4534),
    [sym_true] = ACTIONS(4534),
    [sym_false] = ACTIONS(4534),
    [sym_null] = ACTIONS(4534),
    [sym_super] = ACTIONS(4534),
    [sym_this] = ACTIONS(4534),
    [sym_assert] = ACTIONS(4534),
    [sym_auto] = ACTIONS(4534),
    [sym_cast] = ACTIONS(4534),
    [sym_catch] = ACTIONS(4534),
    [sym_const] = ACTIONS(4534),
    [sym_delegate] = ACTIONS(4534),
    [sym_delete] = ACTIONS(4534),
    [sym_do] = ACTIONS(4534),
    [sym_else] = ACTIONS(4534),
    [sym_finally] = ACTIONS(4534),
    [sym_function] = ACTIONS(4534),
    [sym_immutable] = ACTIONS(4534),
    [sym_import] = ACTIONS(4534),
    [sym_in] = ACTIONS(4534),
    [sym_inout] = ACTIONS(4534),
    [sym_is] = ACTIONS(4534),
    [sym_mixin] = ACTIONS(4534),
    [sym_new] = ACTIONS(4534),
    [sym_out] = ACTIONS(4534),
    [sym_ref] = ACTIONS(4534),
    [sym_shared] = ACTIONS(4534),
    [sym_throw] = ACTIONS(4534),
    [sym_typeid] = ACTIONS(4534),
    [sym_typeof] = ACTIONS(4534),
    [sym_traits] = ACTIONS(4534),
    [sym_vector] = ACTIONS(4534),
    [sym_void] = ACTIONS(4534),
    [anon_sym_BQUOTE] = ACTIONS(4536),
    [anon_sym_r_DQUOTE] = ACTIONS(4536),
    [anon_sym_x_DQUOTE] = ACTIONS(4536),
    [anon_sym_DQUOTE] = ACTIONS(4536),
    [anon_sym_i_BQUOTE] = ACTIONS(4536),
    [anon_sym_i_DQUOTE] = ACTIONS(4536),
    [anon_sym_iq_LBRACE] = ACTIONS(4536),
    [aux_sym_char_literal_token1] = ACTIONS(4536),
    [anon_sym_SQUOTE] = ACTIONS(4534),
    [anon_sym___DATE__] = ACTIONS(4534),
    [anon_sym___FILE__] = ACTIONS(4534),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4534),
    [anon_sym___FUNCTION__] = ACTIONS(4534),
    [anon_sym___LINE__] = ACTIONS(4534),
    [anon_sym___MODULE__] = ACTIONS(4534),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4534),
    [anon_sym___TIME__] = ACTIONS(4534),
    [anon_sym___TIMESTAMP__] = ACTIONS(4534),
    [anon_sym___VENDOR__] = ACTIONS(4534),
    [anon_sym___VERSION__] = ACTIONS(4534),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4536),
    [sym_float_literal] = ACTIONS(4536),
    [sym__string] = ACTIONS(4536),
  },
  [2053] = {
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_q_LBRACE] = ACTIONS(4528),
    [anon_sym_LBRACE] = ACTIONS(4528),
    [anon_sym_DOT] = ACTIONS(4528),
    [anon_sym_AMP] = ACTIONS(4528),
    [anon_sym_DASH] = ACTIONS(4526),
    [anon_sym_DASH_DASH] = ACTIONS(4528),
    [anon_sym_PLUS] = ACTIONS(4526),
    [anon_sym_PLUS_PLUS] = ACTIONS(4528),
    [anon_sym_BANG] = ACTIONS(4528),
    [anon_sym_LPAREN] = ACTIONS(4528),
    [anon_sym_RPAREN] = ACTIONS(4528),
    [anon_sym_LBRACK] = ACTIONS(4528),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_DOLLAR] = ACTIONS(4528),
    [anon_sym_STAR] = ACTIONS(4528),
    [anon_sym_TILDE] = ACTIONS(4528),
    [sym_bool] = ACTIONS(4526),
    [sym_byte] = ACTIONS(4526),
    [sym_ubyte] = ACTIONS(4526),
    [sym_char] = ACTIONS(4526),
    [sym_short] = ACTIONS(4526),
    [sym_ushort] = ACTIONS(4526),
    [sym_int] = ACTIONS(4526),
    [sym_uint] = ACTIONS(4526),
    [sym_long] = ACTIONS(4526),
    [sym_ulong] = ACTIONS(4526),
    [sym_cent] = ACTIONS(4526),
    [sym_ucent] = ACTIONS(4526),
    [sym_wchar] = ACTIONS(4526),
    [sym_dchar] = ACTIONS(4526),
    [sym_float] = ACTIONS(4526),
    [sym_double] = ACTIONS(4526),
    [sym_real] = ACTIONS(4526),
    [sym_ifloat] = ACTIONS(4526),
    [sym_idouble] = ACTIONS(4526),
    [sym_ireal] = ACTIONS(4526),
    [sym_cfloat] = ACTIONS(4526),
    [sym_cdouble] = ACTIONS(4526),
    [sym_creal] = ACTIONS(4526),
    [sym_size_t] = ACTIONS(4526),
    [sym_ptrdiff_t] = ACTIONS(4526),
    [sym_string] = ACTIONS(4526),
    [sym_cstring] = ACTIONS(4526),
    [sym_dstring] = ACTIONS(4526),
    [sym_wstring] = ACTIONS(4526),
    [sym_noreturn] = ACTIONS(4526),
    [sym_true] = ACTIONS(4526),
    [sym_false] = ACTIONS(4526),
    [sym_null] = ACTIONS(4526),
    [sym_super] = ACTIONS(4526),
    [sym_this] = ACTIONS(4526),
    [sym_assert] = ACTIONS(4526),
    [sym_auto] = ACTIONS(4526),
    [sym_cast] = ACTIONS(4526),
    [sym_catch] = ACTIONS(4526),
    [sym_const] = ACTIONS(4526),
    [sym_delegate] = ACTIONS(4526),
    [sym_delete] = ACTIONS(4526),
    [sym_do] = ACTIONS(4526),
    [sym_else] = ACTIONS(4526),
    [sym_finally] = ACTIONS(4526),
    [sym_function] = ACTIONS(4526),
    [sym_immutable] = ACTIONS(4526),
    [sym_import] = ACTIONS(4526),
    [sym_in] = ACTIONS(4526),
    [sym_inout] = ACTIONS(4526),
    [sym_is] = ACTIONS(4526),
    [sym_mixin] = ACTIONS(4526),
    [sym_new] = ACTIONS(4526),
    [sym_out] = ACTIONS(4526),
    [sym_ref] = ACTIONS(4526),
    [sym_shared] = ACTIONS(4526),
    [sym_throw] = ACTIONS(4526),
    [sym_typeid] = ACTIONS(4526),
    [sym_typeof] = ACTIONS(4526),
    [sym_traits] = ACTIONS(4526),
    [sym_vector] = ACTIONS(4526),
    [sym_void] = ACTIONS(4526),
    [anon_sym_BQUOTE] = ACTIONS(4528),
    [anon_sym_r_DQUOTE] = ACTIONS(4528),
    [anon_sym_x_DQUOTE] = ACTIONS(4528),
    [anon_sym_DQUOTE] = ACTIONS(4528),
    [anon_sym_i_BQUOTE] = ACTIONS(4528),
    [anon_sym_i_DQUOTE] = ACTIONS(4528),
    [anon_sym_iq_LBRACE] = ACTIONS(4528),
    [aux_sym_char_literal_token1] = ACTIONS(4528),
    [anon_sym_SQUOTE] = ACTIONS(4526),
    [anon_sym___DATE__] = ACTIONS(4526),
    [anon_sym___FILE__] = ACTIONS(4526),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4526),
    [anon_sym___FUNCTION__] = ACTIONS(4526),
    [anon_sym___LINE__] = ACTIONS(4526),
    [anon_sym___MODULE__] = ACTIONS(4526),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4526),
    [anon_sym___TIME__] = ACTIONS(4526),
    [anon_sym___TIMESTAMP__] = ACTIONS(4526),
    [anon_sym___VENDOR__] = ACTIONS(4526),
    [anon_sym___VERSION__] = ACTIONS(4526),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4528),
    [sym_float_literal] = ACTIONS(4528),
    [sym__string] = ACTIONS(4528),
  },
  [2054] = {
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_q_LBRACE] = ACTIONS(2523),
    [anon_sym_LBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(2525),
    [anon_sym_DASH_DASH] = ACTIONS(2523),
    [anon_sym_PLUS] = ACTIONS(2525),
    [anon_sym_PLUS_PLUS] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(2523),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_DOLLAR] = ACTIONS(2523),
    [anon_sym_STAR] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2523),
    [sym_bool] = ACTIONS(2525),
    [sym_byte] = ACTIONS(2525),
    [sym_ubyte] = ACTIONS(2525),
    [sym_char] = ACTIONS(2525),
    [sym_short] = ACTIONS(2525),
    [sym_ushort] = ACTIONS(2525),
    [sym_int] = ACTIONS(2525),
    [sym_uint] = ACTIONS(2525),
    [sym_long] = ACTIONS(2525),
    [sym_ulong] = ACTIONS(2525),
    [sym_cent] = ACTIONS(2525),
    [sym_ucent] = ACTIONS(2525),
    [sym_wchar] = ACTIONS(2525),
    [sym_dchar] = ACTIONS(2525),
    [sym_float] = ACTIONS(2525),
    [sym_double] = ACTIONS(2525),
    [sym_real] = ACTIONS(2525),
    [sym_ifloat] = ACTIONS(2525),
    [sym_idouble] = ACTIONS(2525),
    [sym_ireal] = ACTIONS(2525),
    [sym_cfloat] = ACTIONS(2525),
    [sym_cdouble] = ACTIONS(2525),
    [sym_creal] = ACTIONS(2525),
    [sym_size_t] = ACTIONS(2525),
    [sym_ptrdiff_t] = ACTIONS(2525),
    [sym_string] = ACTIONS(2525),
    [sym_cstring] = ACTIONS(2525),
    [sym_dstring] = ACTIONS(2525),
    [sym_wstring] = ACTIONS(2525),
    [sym_noreturn] = ACTIONS(2525),
    [sym_true] = ACTIONS(2525),
    [sym_false] = ACTIONS(2525),
    [sym_null] = ACTIONS(2525),
    [sym_super] = ACTIONS(2525),
    [sym_this] = ACTIONS(2525),
    [sym_assert] = ACTIONS(2525),
    [sym_auto] = ACTIONS(2525),
    [sym_cast] = ACTIONS(2525),
    [sym_catch] = ACTIONS(2525),
    [sym_const] = ACTIONS(2525),
    [sym_delegate] = ACTIONS(2525),
    [sym_delete] = ACTIONS(2525),
    [sym_do] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_finally] = ACTIONS(2525),
    [sym_function] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(2525),
    [sym_import] = ACTIONS(2525),
    [sym_in] = ACTIONS(2525),
    [sym_inout] = ACTIONS(2525),
    [sym_is] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2525),
    [sym_new] = ACTIONS(2525),
    [sym_out] = ACTIONS(2525),
    [sym_ref] = ACTIONS(2525),
    [sym_shared] = ACTIONS(2525),
    [sym_throw] = ACTIONS(2525),
    [sym_typeid] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(2525),
    [sym_traits] = ACTIONS(2525),
    [sym_vector] = ACTIONS(2525),
    [sym_void] = ACTIONS(2525),
    [anon_sym_BQUOTE] = ACTIONS(2523),
    [anon_sym_r_DQUOTE] = ACTIONS(2523),
    [anon_sym_x_DQUOTE] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2523),
    [anon_sym_i_BQUOTE] = ACTIONS(2523),
    [anon_sym_i_DQUOTE] = ACTIONS(2523),
    [anon_sym_iq_LBRACE] = ACTIONS(2523),
    [aux_sym_char_literal_token1] = ACTIONS(2523),
    [anon_sym_SQUOTE] = ACTIONS(2525),
    [anon_sym___DATE__] = ACTIONS(2525),
    [anon_sym___FILE__] = ACTIONS(2525),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2525),
    [anon_sym___FUNCTION__] = ACTIONS(2525),
    [anon_sym___LINE__] = ACTIONS(2525),
    [anon_sym___MODULE__] = ACTIONS(2525),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2525),
    [anon_sym___TIME__] = ACTIONS(2525),
    [anon_sym___TIMESTAMP__] = ACTIONS(2525),
    [anon_sym___VENDOR__] = ACTIONS(2525),
    [anon_sym___VERSION__] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2523),
    [sym_float_literal] = ACTIONS(2523),
    [sym__string] = ACTIONS(2523),
  },
  [2055] = {
    [sym_identifier] = ACTIONS(4765),
    [anon_sym_q_LBRACE] = ACTIONS(4767),
    [anon_sym_LBRACE] = ACTIONS(4767),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_AMP] = ACTIONS(4767),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_DASH_DASH] = ACTIONS(4767),
    [anon_sym_PLUS] = ACTIONS(4765),
    [anon_sym_PLUS_PLUS] = ACTIONS(4767),
    [anon_sym_BANG] = ACTIONS(4767),
    [anon_sym_LPAREN] = ACTIONS(4767),
    [anon_sym_RPAREN] = ACTIONS(4767),
    [anon_sym_LBRACK] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_DOLLAR] = ACTIONS(4767),
    [anon_sym_STAR] = ACTIONS(4767),
    [anon_sym_TILDE] = ACTIONS(4767),
    [sym_bool] = ACTIONS(4765),
    [sym_byte] = ACTIONS(4765),
    [sym_ubyte] = ACTIONS(4765),
    [sym_char] = ACTIONS(4765),
    [sym_short] = ACTIONS(4765),
    [sym_ushort] = ACTIONS(4765),
    [sym_int] = ACTIONS(4765),
    [sym_uint] = ACTIONS(4765),
    [sym_long] = ACTIONS(4765),
    [sym_ulong] = ACTIONS(4765),
    [sym_cent] = ACTIONS(4765),
    [sym_ucent] = ACTIONS(4765),
    [sym_wchar] = ACTIONS(4765),
    [sym_dchar] = ACTIONS(4765),
    [sym_float] = ACTIONS(4765),
    [sym_double] = ACTIONS(4765),
    [sym_real] = ACTIONS(4765),
    [sym_ifloat] = ACTIONS(4765),
    [sym_idouble] = ACTIONS(4765),
    [sym_ireal] = ACTIONS(4765),
    [sym_cfloat] = ACTIONS(4765),
    [sym_cdouble] = ACTIONS(4765),
    [sym_creal] = ACTIONS(4765),
    [sym_size_t] = ACTIONS(4765),
    [sym_ptrdiff_t] = ACTIONS(4765),
    [sym_string] = ACTIONS(4765),
    [sym_cstring] = ACTIONS(4765),
    [sym_dstring] = ACTIONS(4765),
    [sym_wstring] = ACTIONS(4765),
    [sym_noreturn] = ACTIONS(4765),
    [sym_true] = ACTIONS(4765),
    [sym_false] = ACTIONS(4765),
    [sym_null] = ACTIONS(4765),
    [sym_super] = ACTIONS(4765),
    [sym_this] = ACTIONS(4765),
    [sym_assert] = ACTIONS(4765),
    [sym_auto] = ACTIONS(4765),
    [sym_cast] = ACTIONS(4765),
    [sym_catch] = ACTIONS(4765),
    [sym_const] = ACTIONS(4765),
    [sym_delegate] = ACTIONS(4765),
    [sym_delete] = ACTIONS(4765),
    [sym_do] = ACTIONS(4765),
    [sym_else] = ACTIONS(4765),
    [sym_finally] = ACTIONS(4765),
    [sym_function] = ACTIONS(4765),
    [sym_immutable] = ACTIONS(4765),
    [sym_import] = ACTIONS(4765),
    [sym_in] = ACTIONS(4765),
    [sym_inout] = ACTIONS(4765),
    [sym_is] = ACTIONS(4765),
    [sym_mixin] = ACTIONS(4765),
    [sym_new] = ACTIONS(4765),
    [sym_out] = ACTIONS(4765),
    [sym_ref] = ACTIONS(4765),
    [sym_shared] = ACTIONS(4765),
    [sym_throw] = ACTIONS(4765),
    [sym_typeid] = ACTIONS(4765),
    [sym_typeof] = ACTIONS(4765),
    [sym_traits] = ACTIONS(4765),
    [sym_vector] = ACTIONS(4765),
    [sym_void] = ACTIONS(4765),
    [anon_sym_BQUOTE] = ACTIONS(4767),
    [anon_sym_r_DQUOTE] = ACTIONS(4767),
    [anon_sym_x_DQUOTE] = ACTIONS(4767),
    [anon_sym_DQUOTE] = ACTIONS(4767),
    [anon_sym_i_BQUOTE] = ACTIONS(4767),
    [anon_sym_i_DQUOTE] = ACTIONS(4767),
    [anon_sym_iq_LBRACE] = ACTIONS(4767),
    [aux_sym_char_literal_token1] = ACTIONS(4767),
    [anon_sym_SQUOTE] = ACTIONS(4765),
    [anon_sym___DATE__] = ACTIONS(4765),
    [anon_sym___FILE__] = ACTIONS(4765),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4765),
    [anon_sym___FUNCTION__] = ACTIONS(4765),
    [anon_sym___LINE__] = ACTIONS(4765),
    [anon_sym___MODULE__] = ACTIONS(4765),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4765),
    [anon_sym___TIME__] = ACTIONS(4765),
    [anon_sym___TIMESTAMP__] = ACTIONS(4765),
    [anon_sym___VENDOR__] = ACTIONS(4765),
    [anon_sym___VERSION__] = ACTIONS(4765),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4767),
    [sym_float_literal] = ACTIONS(4767),
    [sym__string] = ACTIONS(4767),
  },
  [2056] = {
    [sym_identifier] = ACTIONS(4432),
    [anon_sym_q_LBRACE] = ACTIONS(4434),
    [anon_sym_LBRACE] = ACTIONS(4434),
    [anon_sym_DOT] = ACTIONS(4434),
    [anon_sym_AMP] = ACTIONS(4434),
    [anon_sym_DASH] = ACTIONS(4432),
    [anon_sym_DASH_DASH] = ACTIONS(4434),
    [anon_sym_PLUS] = ACTIONS(4432),
    [anon_sym_PLUS_PLUS] = ACTIONS(4434),
    [anon_sym_BANG] = ACTIONS(4434),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_RPAREN] = ACTIONS(4434),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_SEMI] = ACTIONS(4434),
    [anon_sym_DOLLAR] = ACTIONS(4434),
    [anon_sym_STAR] = ACTIONS(4434),
    [anon_sym_TILDE] = ACTIONS(4434),
    [sym_bool] = ACTIONS(4432),
    [sym_byte] = ACTIONS(4432),
    [sym_ubyte] = ACTIONS(4432),
    [sym_char] = ACTIONS(4432),
    [sym_short] = ACTIONS(4432),
    [sym_ushort] = ACTIONS(4432),
    [sym_int] = ACTIONS(4432),
    [sym_uint] = ACTIONS(4432),
    [sym_long] = ACTIONS(4432),
    [sym_ulong] = ACTIONS(4432),
    [sym_cent] = ACTIONS(4432),
    [sym_ucent] = ACTIONS(4432),
    [sym_wchar] = ACTIONS(4432),
    [sym_dchar] = ACTIONS(4432),
    [sym_float] = ACTIONS(4432),
    [sym_double] = ACTIONS(4432),
    [sym_real] = ACTIONS(4432),
    [sym_ifloat] = ACTIONS(4432),
    [sym_idouble] = ACTIONS(4432),
    [sym_ireal] = ACTIONS(4432),
    [sym_cfloat] = ACTIONS(4432),
    [sym_cdouble] = ACTIONS(4432),
    [sym_creal] = ACTIONS(4432),
    [sym_size_t] = ACTIONS(4432),
    [sym_ptrdiff_t] = ACTIONS(4432),
    [sym_string] = ACTIONS(4432),
    [sym_cstring] = ACTIONS(4432),
    [sym_dstring] = ACTIONS(4432),
    [sym_wstring] = ACTIONS(4432),
    [sym_noreturn] = ACTIONS(4432),
    [sym_true] = ACTIONS(4432),
    [sym_false] = ACTIONS(4432),
    [sym_null] = ACTIONS(4432),
    [sym_super] = ACTIONS(4432),
    [sym_this] = ACTIONS(4432),
    [sym_assert] = ACTIONS(4432),
    [sym_auto] = ACTIONS(4432),
    [sym_cast] = ACTIONS(4432),
    [sym_catch] = ACTIONS(4432),
    [sym_const] = ACTIONS(4432),
    [sym_delegate] = ACTIONS(4432),
    [sym_delete] = ACTIONS(4432),
    [sym_do] = ACTIONS(4432),
    [sym_else] = ACTIONS(4432),
    [sym_finally] = ACTIONS(4432),
    [sym_function] = ACTIONS(4432),
    [sym_immutable] = ACTIONS(4432),
    [sym_import] = ACTIONS(4432),
    [sym_in] = ACTIONS(4432),
    [sym_inout] = ACTIONS(4432),
    [sym_is] = ACTIONS(4432),
    [sym_mixin] = ACTIONS(4432),
    [sym_new] = ACTIONS(4432),
    [sym_out] = ACTIONS(4432),
    [sym_ref] = ACTIONS(4432),
    [sym_shared] = ACTIONS(4432),
    [sym_throw] = ACTIONS(4432),
    [sym_typeid] = ACTIONS(4432),
    [sym_typeof] = ACTIONS(4432),
    [sym_traits] = ACTIONS(4432),
    [sym_vector] = ACTIONS(4432),
    [sym_void] = ACTIONS(4432),
    [anon_sym_BQUOTE] = ACTIONS(4434),
    [anon_sym_r_DQUOTE] = ACTIONS(4434),
    [anon_sym_x_DQUOTE] = ACTIONS(4434),
    [anon_sym_DQUOTE] = ACTIONS(4434),
    [anon_sym_i_BQUOTE] = ACTIONS(4434),
    [anon_sym_i_DQUOTE] = ACTIONS(4434),
    [anon_sym_iq_LBRACE] = ACTIONS(4434),
    [aux_sym_char_literal_token1] = ACTIONS(4434),
    [anon_sym_SQUOTE] = ACTIONS(4432),
    [anon_sym___DATE__] = ACTIONS(4432),
    [anon_sym___FILE__] = ACTIONS(4432),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4432),
    [anon_sym___FUNCTION__] = ACTIONS(4432),
    [anon_sym___LINE__] = ACTIONS(4432),
    [anon_sym___MODULE__] = ACTIONS(4432),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4432),
    [anon_sym___TIME__] = ACTIONS(4432),
    [anon_sym___TIMESTAMP__] = ACTIONS(4432),
    [anon_sym___VENDOR__] = ACTIONS(4432),
    [anon_sym___VERSION__] = ACTIONS(4432),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4434),
    [sym_float_literal] = ACTIONS(4434),
    [sym__string] = ACTIONS(4434),
  },
  [2057] = {
    [sym_identifier] = ACTIONS(4478),
    [anon_sym_q_LBRACE] = ACTIONS(4480),
    [anon_sym_LBRACE] = ACTIONS(4480),
    [anon_sym_DOT] = ACTIONS(4480),
    [anon_sym_AMP] = ACTIONS(4480),
    [anon_sym_DASH] = ACTIONS(4478),
    [anon_sym_DASH_DASH] = ACTIONS(4480),
    [anon_sym_PLUS] = ACTIONS(4478),
    [anon_sym_PLUS_PLUS] = ACTIONS(4480),
    [anon_sym_BANG] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4480),
    [anon_sym_RPAREN] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4480),
    [anon_sym_SEMI] = ACTIONS(4480),
    [anon_sym_DOLLAR] = ACTIONS(4480),
    [anon_sym_STAR] = ACTIONS(4480),
    [anon_sym_TILDE] = ACTIONS(4480),
    [sym_bool] = ACTIONS(4478),
    [sym_byte] = ACTIONS(4478),
    [sym_ubyte] = ACTIONS(4478),
    [sym_char] = ACTIONS(4478),
    [sym_short] = ACTIONS(4478),
    [sym_ushort] = ACTIONS(4478),
    [sym_int] = ACTIONS(4478),
    [sym_uint] = ACTIONS(4478),
    [sym_long] = ACTIONS(4478),
    [sym_ulong] = ACTIONS(4478),
    [sym_cent] = ACTIONS(4478),
    [sym_ucent] = ACTIONS(4478),
    [sym_wchar] = ACTIONS(4478),
    [sym_dchar] = ACTIONS(4478),
    [sym_float] = ACTIONS(4478),
    [sym_double] = ACTIONS(4478),
    [sym_real] = ACTIONS(4478),
    [sym_ifloat] = ACTIONS(4478),
    [sym_idouble] = ACTIONS(4478),
    [sym_ireal] = ACTIONS(4478),
    [sym_cfloat] = ACTIONS(4478),
    [sym_cdouble] = ACTIONS(4478),
    [sym_creal] = ACTIONS(4478),
    [sym_size_t] = ACTIONS(4478),
    [sym_ptrdiff_t] = ACTIONS(4478),
    [sym_string] = ACTIONS(4478),
    [sym_cstring] = ACTIONS(4478),
    [sym_dstring] = ACTIONS(4478),
    [sym_wstring] = ACTIONS(4478),
    [sym_noreturn] = ACTIONS(4478),
    [sym_true] = ACTIONS(4478),
    [sym_false] = ACTIONS(4478),
    [sym_null] = ACTIONS(4478),
    [sym_super] = ACTIONS(4478),
    [sym_this] = ACTIONS(4478),
    [sym_assert] = ACTIONS(4478),
    [sym_auto] = ACTIONS(4478),
    [sym_cast] = ACTIONS(4478),
    [sym_catch] = ACTIONS(4478),
    [sym_const] = ACTIONS(4478),
    [sym_delegate] = ACTIONS(4478),
    [sym_delete] = ACTIONS(4478),
    [sym_do] = ACTIONS(4478),
    [sym_else] = ACTIONS(4478),
    [sym_finally] = ACTIONS(4478),
    [sym_function] = ACTIONS(4478),
    [sym_immutable] = ACTIONS(4478),
    [sym_import] = ACTIONS(4478),
    [sym_in] = ACTIONS(4478),
    [sym_inout] = ACTIONS(4478),
    [sym_is] = ACTIONS(4478),
    [sym_mixin] = ACTIONS(4478),
    [sym_new] = ACTIONS(4478),
    [sym_out] = ACTIONS(4478),
    [sym_ref] = ACTIONS(4478),
    [sym_shared] = ACTIONS(4478),
    [sym_throw] = ACTIONS(4478),
    [sym_typeid] = ACTIONS(4478),
    [sym_typeof] = ACTIONS(4478),
    [sym_traits] = ACTIONS(4478),
    [sym_vector] = ACTIONS(4478),
    [sym_void] = ACTIONS(4478),
    [anon_sym_BQUOTE] = ACTIONS(4480),
    [anon_sym_r_DQUOTE] = ACTIONS(4480),
    [anon_sym_x_DQUOTE] = ACTIONS(4480),
    [anon_sym_DQUOTE] = ACTIONS(4480),
    [anon_sym_i_BQUOTE] = ACTIONS(4480),
    [anon_sym_i_DQUOTE] = ACTIONS(4480),
    [anon_sym_iq_LBRACE] = ACTIONS(4480),
    [aux_sym_char_literal_token1] = ACTIONS(4480),
    [anon_sym_SQUOTE] = ACTIONS(4478),
    [anon_sym___DATE__] = ACTIONS(4478),
    [anon_sym___FILE__] = ACTIONS(4478),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4478),
    [anon_sym___FUNCTION__] = ACTIONS(4478),
    [anon_sym___LINE__] = ACTIONS(4478),
    [anon_sym___MODULE__] = ACTIONS(4478),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4478),
    [anon_sym___TIME__] = ACTIONS(4478),
    [anon_sym___TIMESTAMP__] = ACTIONS(4478),
    [anon_sym___VENDOR__] = ACTIONS(4478),
    [anon_sym___VERSION__] = ACTIONS(4478),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4480),
    [sym_float_literal] = ACTIONS(4480),
    [sym__string] = ACTIONS(4480),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_catch] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(5871),
    [sym_finally] = ACTIONS(4682),
    [sym_function] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [2059] = {
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_q_LBRACE] = ACTIONS(4791),
    [anon_sym_LBRACE] = ACTIONS(4791),
    [anon_sym_DOT] = ACTIONS(4791),
    [anon_sym_AMP] = ACTIONS(4791),
    [anon_sym_DASH] = ACTIONS(4789),
    [anon_sym_DASH_DASH] = ACTIONS(4791),
    [anon_sym_PLUS] = ACTIONS(4789),
    [anon_sym_PLUS_PLUS] = ACTIONS(4791),
    [anon_sym_BANG] = ACTIONS(4791),
    [anon_sym_LPAREN] = ACTIONS(4791),
    [anon_sym_RPAREN] = ACTIONS(4791),
    [anon_sym_LBRACK] = ACTIONS(4791),
    [anon_sym_SEMI] = ACTIONS(4791),
    [anon_sym_DOLLAR] = ACTIONS(4791),
    [anon_sym_STAR] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [sym_bool] = ACTIONS(4789),
    [sym_byte] = ACTIONS(4789),
    [sym_ubyte] = ACTIONS(4789),
    [sym_char] = ACTIONS(4789),
    [sym_short] = ACTIONS(4789),
    [sym_ushort] = ACTIONS(4789),
    [sym_int] = ACTIONS(4789),
    [sym_uint] = ACTIONS(4789),
    [sym_long] = ACTIONS(4789),
    [sym_ulong] = ACTIONS(4789),
    [sym_cent] = ACTIONS(4789),
    [sym_ucent] = ACTIONS(4789),
    [sym_wchar] = ACTIONS(4789),
    [sym_dchar] = ACTIONS(4789),
    [sym_float] = ACTIONS(4789),
    [sym_double] = ACTIONS(4789),
    [sym_real] = ACTIONS(4789),
    [sym_ifloat] = ACTIONS(4789),
    [sym_idouble] = ACTIONS(4789),
    [sym_ireal] = ACTIONS(4789),
    [sym_cfloat] = ACTIONS(4789),
    [sym_cdouble] = ACTIONS(4789),
    [sym_creal] = ACTIONS(4789),
    [sym_size_t] = ACTIONS(4789),
    [sym_ptrdiff_t] = ACTIONS(4789),
    [sym_string] = ACTIONS(4789),
    [sym_cstring] = ACTIONS(4789),
    [sym_dstring] = ACTIONS(4789),
    [sym_wstring] = ACTIONS(4789),
    [sym_noreturn] = ACTIONS(4789),
    [sym_true] = ACTIONS(4789),
    [sym_false] = ACTIONS(4789),
    [sym_null] = ACTIONS(4789),
    [sym_super] = ACTIONS(4789),
    [sym_this] = ACTIONS(4789),
    [sym_assert] = ACTIONS(4789),
    [sym_auto] = ACTIONS(4789),
    [sym_cast] = ACTIONS(4789),
    [sym_catch] = ACTIONS(4789),
    [sym_const] = ACTIONS(4789),
    [sym_delegate] = ACTIONS(4789),
    [sym_delete] = ACTIONS(4789),
    [sym_do] = ACTIONS(4789),
    [sym_else] = ACTIONS(4789),
    [sym_finally] = ACTIONS(4789),
    [sym_function] = ACTIONS(4789),
    [sym_immutable] = ACTIONS(4789),
    [sym_import] = ACTIONS(4789),
    [sym_in] = ACTIONS(4789),
    [sym_inout] = ACTIONS(4789),
    [sym_is] = ACTIONS(4789),
    [sym_mixin] = ACTIONS(4789),
    [sym_new] = ACTIONS(4789),
    [sym_out] = ACTIONS(4789),
    [sym_ref] = ACTIONS(4789),
    [sym_shared] = ACTIONS(4789),
    [sym_throw] = ACTIONS(4789),
    [sym_typeid] = ACTIONS(4789),
    [sym_typeof] = ACTIONS(4789),
    [sym_traits] = ACTIONS(4789),
    [sym_vector] = ACTIONS(4789),
    [sym_void] = ACTIONS(4789),
    [anon_sym_BQUOTE] = ACTIONS(4791),
    [anon_sym_r_DQUOTE] = ACTIONS(4791),
    [anon_sym_x_DQUOTE] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(4791),
    [anon_sym_i_BQUOTE] = ACTIONS(4791),
    [anon_sym_i_DQUOTE] = ACTIONS(4791),
    [anon_sym_iq_LBRACE] = ACTIONS(4791),
    [aux_sym_char_literal_token1] = ACTIONS(4791),
    [anon_sym_SQUOTE] = ACTIONS(4789),
    [anon_sym___DATE__] = ACTIONS(4789),
    [anon_sym___FILE__] = ACTIONS(4789),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4789),
    [anon_sym___FUNCTION__] = ACTIONS(4789),
    [anon_sym___LINE__] = ACTIONS(4789),
    [anon_sym___MODULE__] = ACTIONS(4789),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4789),
    [anon_sym___TIME__] = ACTIONS(4789),
    [anon_sym___TIMESTAMP__] = ACTIONS(4789),
    [anon_sym___VENDOR__] = ACTIONS(4789),
    [anon_sym___VERSION__] = ACTIONS(4789),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4791),
    [sym_float_literal] = ACTIONS(4791),
    [sym__string] = ACTIONS(4791),
  },
  [2060] = {
    [sym_identifier] = ACTIONS(4941),
    [anon_sym_q_LBRACE] = ACTIONS(4943),
    [anon_sym_LBRACE] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4943),
    [anon_sym_AMP] = ACTIONS(4943),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_DASH_DASH] = ACTIONS(4943),
    [anon_sym_PLUS] = ACTIONS(4941),
    [anon_sym_PLUS_PLUS] = ACTIONS(4943),
    [anon_sym_BANG] = ACTIONS(4943),
    [anon_sym_LPAREN] = ACTIONS(4943),
    [anon_sym_RPAREN] = ACTIONS(4943),
    [anon_sym_LBRACK] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_DOLLAR] = ACTIONS(4943),
    [anon_sym_STAR] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4943),
    [sym_bool] = ACTIONS(4941),
    [sym_byte] = ACTIONS(4941),
    [sym_ubyte] = ACTIONS(4941),
    [sym_char] = ACTIONS(4941),
    [sym_short] = ACTIONS(4941),
    [sym_ushort] = ACTIONS(4941),
    [sym_int] = ACTIONS(4941),
    [sym_uint] = ACTIONS(4941),
    [sym_long] = ACTIONS(4941),
    [sym_ulong] = ACTIONS(4941),
    [sym_cent] = ACTIONS(4941),
    [sym_ucent] = ACTIONS(4941),
    [sym_wchar] = ACTIONS(4941),
    [sym_dchar] = ACTIONS(4941),
    [sym_float] = ACTIONS(4941),
    [sym_double] = ACTIONS(4941),
    [sym_real] = ACTIONS(4941),
    [sym_ifloat] = ACTIONS(4941),
    [sym_idouble] = ACTIONS(4941),
    [sym_ireal] = ACTIONS(4941),
    [sym_cfloat] = ACTIONS(4941),
    [sym_cdouble] = ACTIONS(4941),
    [sym_creal] = ACTIONS(4941),
    [sym_size_t] = ACTIONS(4941),
    [sym_ptrdiff_t] = ACTIONS(4941),
    [sym_string] = ACTIONS(4941),
    [sym_cstring] = ACTIONS(4941),
    [sym_dstring] = ACTIONS(4941),
    [sym_wstring] = ACTIONS(4941),
    [sym_noreturn] = ACTIONS(4941),
    [sym_true] = ACTIONS(4941),
    [sym_false] = ACTIONS(4941),
    [sym_null] = ACTIONS(4941),
    [sym_super] = ACTIONS(4941),
    [sym_this] = ACTIONS(4941),
    [sym_assert] = ACTIONS(4941),
    [sym_auto] = ACTIONS(4941),
    [sym_cast] = ACTIONS(4941),
    [sym_catch] = ACTIONS(4941),
    [sym_const] = ACTIONS(4941),
    [sym_delegate] = ACTIONS(4941),
    [sym_delete] = ACTIONS(4941),
    [sym_do] = ACTIONS(4941),
    [sym_else] = ACTIONS(4941),
    [sym_finally] = ACTIONS(4941),
    [sym_function] = ACTIONS(4941),
    [sym_immutable] = ACTIONS(4941),
    [sym_import] = ACTIONS(4941),
    [sym_in] = ACTIONS(4941),
    [sym_inout] = ACTIONS(4941),
    [sym_is] = ACTIONS(4941),
    [sym_mixin] = ACTIONS(4941),
    [sym_new] = ACTIONS(4941),
    [sym_out] = ACTIONS(4941),
    [sym_ref] = ACTIONS(4941),
    [sym_shared] = ACTIONS(4941),
    [sym_throw] = ACTIONS(4941),
    [sym_typeid] = ACTIONS(4941),
    [sym_typeof] = ACTIONS(4941),
    [sym_traits] = ACTIONS(4941),
    [sym_vector] = ACTIONS(4941),
    [sym_void] = ACTIONS(4941),
    [anon_sym_BQUOTE] = ACTIONS(4943),
    [anon_sym_r_DQUOTE] = ACTIONS(4943),
    [anon_sym_x_DQUOTE] = ACTIONS(4943),
    [anon_sym_DQUOTE] = ACTIONS(4943),
    [anon_sym_i_BQUOTE] = ACTIONS(4943),
    [anon_sym_i_DQUOTE] = ACTIONS(4943),
    [anon_sym_iq_LBRACE] = ACTIONS(4943),
    [aux_sym_char_literal_token1] = ACTIONS(4943),
    [anon_sym_SQUOTE] = ACTIONS(4941),
    [anon_sym___DATE__] = ACTIONS(4941),
    [anon_sym___FILE__] = ACTIONS(4941),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4941),
    [anon_sym___FUNCTION__] = ACTIONS(4941),
    [anon_sym___LINE__] = ACTIONS(4941),
    [anon_sym___MODULE__] = ACTIONS(4941),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4941),
    [anon_sym___TIME__] = ACTIONS(4941),
    [anon_sym___TIMESTAMP__] = ACTIONS(4941),
    [anon_sym___VENDOR__] = ACTIONS(4941),
    [anon_sym___VERSION__] = ACTIONS(4941),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4943),
    [sym_float_literal] = ACTIONS(4943),
    [sym__string] = ACTIONS(4943),
  },
  [2061] = {
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_q_LBRACE] = ACTIONS(4915),
    [anon_sym_LBRACE] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4915),
    [anon_sym_AMP] = ACTIONS(4915),
    [anon_sym_DASH] = ACTIONS(4913),
    [anon_sym_DASH_DASH] = ACTIONS(4915),
    [anon_sym_PLUS] = ACTIONS(4913),
    [anon_sym_PLUS_PLUS] = ACTIONS(4915),
    [anon_sym_BANG] = ACTIONS(4915),
    [anon_sym_LPAREN] = ACTIONS(4915),
    [anon_sym_RPAREN] = ACTIONS(4915),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_DOLLAR] = ACTIONS(4915),
    [anon_sym_STAR] = ACTIONS(4915),
    [anon_sym_TILDE] = ACTIONS(4915),
    [sym_bool] = ACTIONS(4913),
    [sym_byte] = ACTIONS(4913),
    [sym_ubyte] = ACTIONS(4913),
    [sym_char] = ACTIONS(4913),
    [sym_short] = ACTIONS(4913),
    [sym_ushort] = ACTIONS(4913),
    [sym_int] = ACTIONS(4913),
    [sym_uint] = ACTIONS(4913),
    [sym_long] = ACTIONS(4913),
    [sym_ulong] = ACTIONS(4913),
    [sym_cent] = ACTIONS(4913),
    [sym_ucent] = ACTIONS(4913),
    [sym_wchar] = ACTIONS(4913),
    [sym_dchar] = ACTIONS(4913),
    [sym_float] = ACTIONS(4913),
    [sym_double] = ACTIONS(4913),
    [sym_real] = ACTIONS(4913),
    [sym_ifloat] = ACTIONS(4913),
    [sym_idouble] = ACTIONS(4913),
    [sym_ireal] = ACTIONS(4913),
    [sym_cfloat] = ACTIONS(4913),
    [sym_cdouble] = ACTIONS(4913),
    [sym_creal] = ACTIONS(4913),
    [sym_size_t] = ACTIONS(4913),
    [sym_ptrdiff_t] = ACTIONS(4913),
    [sym_string] = ACTIONS(4913),
    [sym_cstring] = ACTIONS(4913),
    [sym_dstring] = ACTIONS(4913),
    [sym_wstring] = ACTIONS(4913),
    [sym_noreturn] = ACTIONS(4913),
    [sym_true] = ACTIONS(4913),
    [sym_false] = ACTIONS(4913),
    [sym_null] = ACTIONS(4913),
    [sym_super] = ACTIONS(4913),
    [sym_this] = ACTIONS(4913),
    [sym_assert] = ACTIONS(4913),
    [sym_auto] = ACTIONS(4913),
    [sym_cast] = ACTIONS(4913),
    [sym_catch] = ACTIONS(4913),
    [sym_const] = ACTIONS(4913),
    [sym_delegate] = ACTIONS(4913),
    [sym_delete] = ACTIONS(4913),
    [sym_do] = ACTIONS(4913),
    [sym_else] = ACTIONS(4913),
    [sym_finally] = ACTIONS(4913),
    [sym_function] = ACTIONS(4913),
    [sym_immutable] = ACTIONS(4913),
    [sym_import] = ACTIONS(4913),
    [sym_in] = ACTIONS(4913),
    [sym_inout] = ACTIONS(4913),
    [sym_is] = ACTIONS(4913),
    [sym_mixin] = ACTIONS(4913),
    [sym_new] = ACTIONS(4913),
    [sym_out] = ACTIONS(4913),
    [sym_ref] = ACTIONS(4913),
    [sym_shared] = ACTIONS(4913),
    [sym_throw] = ACTIONS(4913),
    [sym_typeid] = ACTIONS(4913),
    [sym_typeof] = ACTIONS(4913),
    [sym_traits] = ACTIONS(4913),
    [sym_vector] = ACTIONS(4913),
    [sym_void] = ACTIONS(4913),
    [anon_sym_BQUOTE] = ACTIONS(4915),
    [anon_sym_r_DQUOTE] = ACTIONS(4915),
    [anon_sym_x_DQUOTE] = ACTIONS(4915),
    [anon_sym_DQUOTE] = ACTIONS(4915),
    [anon_sym_i_BQUOTE] = ACTIONS(4915),
    [anon_sym_i_DQUOTE] = ACTIONS(4915),
    [anon_sym_iq_LBRACE] = ACTIONS(4915),
    [aux_sym_char_literal_token1] = ACTIONS(4915),
    [anon_sym_SQUOTE] = ACTIONS(4913),
    [anon_sym___DATE__] = ACTIONS(4913),
    [anon_sym___FILE__] = ACTIONS(4913),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4913),
    [anon_sym___FUNCTION__] = ACTIONS(4913),
    [anon_sym___LINE__] = ACTIONS(4913),
    [anon_sym___MODULE__] = ACTIONS(4913),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4913),
    [anon_sym___TIME__] = ACTIONS(4913),
    [anon_sym___TIMESTAMP__] = ACTIONS(4913),
    [anon_sym___VENDOR__] = ACTIONS(4913),
    [anon_sym___VERSION__] = ACTIONS(4913),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4915),
    [sym_float_literal] = ACTIONS(4915),
    [sym__string] = ACTIONS(4915),
  },
  [2062] = {
    [sym_identifier] = ACTIONS(4486),
    [anon_sym_q_LBRACE] = ACTIONS(4488),
    [anon_sym_LBRACE] = ACTIONS(4488),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_AMP] = ACTIONS(4488),
    [anon_sym_DASH] = ACTIONS(4486),
    [anon_sym_DASH_DASH] = ACTIONS(4488),
    [anon_sym_PLUS] = ACTIONS(4486),
    [anon_sym_PLUS_PLUS] = ACTIONS(4488),
    [anon_sym_BANG] = ACTIONS(4488),
    [anon_sym_LPAREN] = ACTIONS(4488),
    [anon_sym_RPAREN] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4488),
    [anon_sym_DOLLAR] = ACTIONS(4488),
    [anon_sym_STAR] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4488),
    [sym_bool] = ACTIONS(4486),
    [sym_byte] = ACTIONS(4486),
    [sym_ubyte] = ACTIONS(4486),
    [sym_char] = ACTIONS(4486),
    [sym_short] = ACTIONS(4486),
    [sym_ushort] = ACTIONS(4486),
    [sym_int] = ACTIONS(4486),
    [sym_uint] = ACTIONS(4486),
    [sym_long] = ACTIONS(4486),
    [sym_ulong] = ACTIONS(4486),
    [sym_cent] = ACTIONS(4486),
    [sym_ucent] = ACTIONS(4486),
    [sym_wchar] = ACTIONS(4486),
    [sym_dchar] = ACTIONS(4486),
    [sym_float] = ACTIONS(4486),
    [sym_double] = ACTIONS(4486),
    [sym_real] = ACTIONS(4486),
    [sym_ifloat] = ACTIONS(4486),
    [sym_idouble] = ACTIONS(4486),
    [sym_ireal] = ACTIONS(4486),
    [sym_cfloat] = ACTIONS(4486),
    [sym_cdouble] = ACTIONS(4486),
    [sym_creal] = ACTIONS(4486),
    [sym_size_t] = ACTIONS(4486),
    [sym_ptrdiff_t] = ACTIONS(4486),
    [sym_string] = ACTIONS(4486),
    [sym_cstring] = ACTIONS(4486),
    [sym_dstring] = ACTIONS(4486),
    [sym_wstring] = ACTIONS(4486),
    [sym_noreturn] = ACTIONS(4486),
    [sym_true] = ACTIONS(4486),
    [sym_false] = ACTIONS(4486),
    [sym_null] = ACTIONS(4486),
    [sym_super] = ACTIONS(4486),
    [sym_this] = ACTIONS(4486),
    [sym_assert] = ACTIONS(4486),
    [sym_auto] = ACTIONS(4486),
    [sym_cast] = ACTIONS(4486),
    [sym_catch] = ACTIONS(4486),
    [sym_const] = ACTIONS(4486),
    [sym_delegate] = ACTIONS(4486),
    [sym_delete] = ACTIONS(4486),
    [sym_do] = ACTIONS(4486),
    [sym_else] = ACTIONS(4486),
    [sym_finally] = ACTIONS(4486),
    [sym_function] = ACTIONS(4486),
    [sym_immutable] = ACTIONS(4486),
    [sym_import] = ACTIONS(4486),
    [sym_in] = ACTIONS(4486),
    [sym_inout] = ACTIONS(4486),
    [sym_is] = ACTIONS(4486),
    [sym_mixin] = ACTIONS(4486),
    [sym_new] = ACTIONS(4486),
    [sym_out] = ACTIONS(4486),
    [sym_ref] = ACTIONS(4486),
    [sym_shared] = ACTIONS(4486),
    [sym_throw] = ACTIONS(4486),
    [sym_typeid] = ACTIONS(4486),
    [sym_typeof] = ACTIONS(4486),
    [sym_traits] = ACTIONS(4486),
    [sym_vector] = ACTIONS(4486),
    [sym_void] = ACTIONS(4486),
    [anon_sym_BQUOTE] = ACTIONS(4488),
    [anon_sym_r_DQUOTE] = ACTIONS(4488),
    [anon_sym_x_DQUOTE] = ACTIONS(4488),
    [anon_sym_DQUOTE] = ACTIONS(4488),
    [anon_sym_i_BQUOTE] = ACTIONS(4488),
    [anon_sym_i_DQUOTE] = ACTIONS(4488),
    [anon_sym_iq_LBRACE] = ACTIONS(4488),
    [aux_sym_char_literal_token1] = ACTIONS(4488),
    [anon_sym_SQUOTE] = ACTIONS(4486),
    [anon_sym___DATE__] = ACTIONS(4486),
    [anon_sym___FILE__] = ACTIONS(4486),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4486),
    [anon_sym___FUNCTION__] = ACTIONS(4486),
    [anon_sym___LINE__] = ACTIONS(4486),
    [anon_sym___MODULE__] = ACTIONS(4486),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4486),
    [anon_sym___TIME__] = ACTIONS(4486),
    [anon_sym___TIMESTAMP__] = ACTIONS(4486),
    [anon_sym___VENDOR__] = ACTIONS(4486),
    [anon_sym___VERSION__] = ACTIONS(4486),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4488),
    [sym_float_literal] = ACTIONS(4488),
    [sym__string] = ACTIONS(4488),
  },
  [2063] = {
    [sym_identifier] = ACTIONS(4785),
    [anon_sym_q_LBRACE] = ACTIONS(4787),
    [anon_sym_LBRACE] = ACTIONS(4787),
    [anon_sym_DOT] = ACTIONS(4787),
    [anon_sym_AMP] = ACTIONS(4787),
    [anon_sym_DASH] = ACTIONS(4785),
    [anon_sym_DASH_DASH] = ACTIONS(4787),
    [anon_sym_PLUS] = ACTIONS(4785),
    [anon_sym_PLUS_PLUS] = ACTIONS(4787),
    [anon_sym_BANG] = ACTIONS(4787),
    [anon_sym_LPAREN] = ACTIONS(4787),
    [anon_sym_RPAREN] = ACTIONS(4787),
    [anon_sym_LBRACK] = ACTIONS(4787),
    [anon_sym_SEMI] = ACTIONS(4787),
    [anon_sym_DOLLAR] = ACTIONS(4787),
    [anon_sym_STAR] = ACTIONS(4787),
    [anon_sym_TILDE] = ACTIONS(4787),
    [sym_bool] = ACTIONS(4785),
    [sym_byte] = ACTIONS(4785),
    [sym_ubyte] = ACTIONS(4785),
    [sym_char] = ACTIONS(4785),
    [sym_short] = ACTIONS(4785),
    [sym_ushort] = ACTIONS(4785),
    [sym_int] = ACTIONS(4785),
    [sym_uint] = ACTIONS(4785),
    [sym_long] = ACTIONS(4785),
    [sym_ulong] = ACTIONS(4785),
    [sym_cent] = ACTIONS(4785),
    [sym_ucent] = ACTIONS(4785),
    [sym_wchar] = ACTIONS(4785),
    [sym_dchar] = ACTIONS(4785),
    [sym_float] = ACTIONS(4785),
    [sym_double] = ACTIONS(4785),
    [sym_real] = ACTIONS(4785),
    [sym_ifloat] = ACTIONS(4785),
    [sym_idouble] = ACTIONS(4785),
    [sym_ireal] = ACTIONS(4785),
    [sym_cfloat] = ACTIONS(4785),
    [sym_cdouble] = ACTIONS(4785),
    [sym_creal] = ACTIONS(4785),
    [sym_size_t] = ACTIONS(4785),
    [sym_ptrdiff_t] = ACTIONS(4785),
    [sym_string] = ACTIONS(4785),
    [sym_cstring] = ACTIONS(4785),
    [sym_dstring] = ACTIONS(4785),
    [sym_wstring] = ACTIONS(4785),
    [sym_noreturn] = ACTIONS(4785),
    [sym_true] = ACTIONS(4785),
    [sym_false] = ACTIONS(4785),
    [sym_null] = ACTIONS(4785),
    [sym_super] = ACTIONS(4785),
    [sym_this] = ACTIONS(4785),
    [sym_assert] = ACTIONS(4785),
    [sym_auto] = ACTIONS(4785),
    [sym_cast] = ACTIONS(4785),
    [sym_catch] = ACTIONS(4785),
    [sym_const] = ACTIONS(4785),
    [sym_delegate] = ACTIONS(4785),
    [sym_delete] = ACTIONS(4785),
    [sym_do] = ACTIONS(4785),
    [sym_else] = ACTIONS(4785),
    [sym_finally] = ACTIONS(4785),
    [sym_function] = ACTIONS(4785),
    [sym_immutable] = ACTIONS(4785),
    [sym_import] = ACTIONS(4785),
    [sym_in] = ACTIONS(4785),
    [sym_inout] = ACTIONS(4785),
    [sym_is] = ACTIONS(4785),
    [sym_mixin] = ACTIONS(4785),
    [sym_new] = ACTIONS(4785),
    [sym_out] = ACTIONS(4785),
    [sym_ref] = ACTIONS(4785),
    [sym_shared] = ACTIONS(4785),
    [sym_throw] = ACTIONS(4785),
    [sym_typeid] = ACTIONS(4785),
    [sym_typeof] = ACTIONS(4785),
    [sym_traits] = ACTIONS(4785),
    [sym_vector] = ACTIONS(4785),
    [sym_void] = ACTIONS(4785),
    [anon_sym_BQUOTE] = ACTIONS(4787),
    [anon_sym_r_DQUOTE] = ACTIONS(4787),
    [anon_sym_x_DQUOTE] = ACTIONS(4787),
    [anon_sym_DQUOTE] = ACTIONS(4787),
    [anon_sym_i_BQUOTE] = ACTIONS(4787),
    [anon_sym_i_DQUOTE] = ACTIONS(4787),
    [anon_sym_iq_LBRACE] = ACTIONS(4787),
    [aux_sym_char_literal_token1] = ACTIONS(4787),
    [anon_sym_SQUOTE] = ACTIONS(4785),
    [anon_sym___DATE__] = ACTIONS(4785),
    [anon_sym___FILE__] = ACTIONS(4785),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4785),
    [anon_sym___FUNCTION__] = ACTIONS(4785),
    [anon_sym___LINE__] = ACTIONS(4785),
    [anon_sym___MODULE__] = ACTIONS(4785),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4785),
    [anon_sym___TIME__] = ACTIONS(4785),
    [anon_sym___TIMESTAMP__] = ACTIONS(4785),
    [anon_sym___VENDOR__] = ACTIONS(4785),
    [anon_sym___VERSION__] = ACTIONS(4785),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4787),
    [sym_float_literal] = ACTIONS(4787),
    [sym__string] = ACTIONS(4787),
  },
  [2064] = {
    [sym_identifier] = ACTIONS(4793),
    [anon_sym_q_LBRACE] = ACTIONS(4795),
    [anon_sym_LBRACE] = ACTIONS(4795),
    [anon_sym_DOT] = ACTIONS(4795),
    [anon_sym_AMP] = ACTIONS(4795),
    [anon_sym_DASH] = ACTIONS(4793),
    [anon_sym_DASH_DASH] = ACTIONS(4795),
    [anon_sym_PLUS] = ACTIONS(4793),
    [anon_sym_PLUS_PLUS] = ACTIONS(4795),
    [anon_sym_BANG] = ACTIONS(4795),
    [anon_sym_LPAREN] = ACTIONS(4795),
    [anon_sym_RPAREN] = ACTIONS(4795),
    [anon_sym_LBRACK] = ACTIONS(4795),
    [anon_sym_SEMI] = ACTIONS(4795),
    [anon_sym_DOLLAR] = ACTIONS(4795),
    [anon_sym_STAR] = ACTIONS(4795),
    [anon_sym_TILDE] = ACTIONS(4795),
    [sym_bool] = ACTIONS(4793),
    [sym_byte] = ACTIONS(4793),
    [sym_ubyte] = ACTIONS(4793),
    [sym_char] = ACTIONS(4793),
    [sym_short] = ACTIONS(4793),
    [sym_ushort] = ACTIONS(4793),
    [sym_int] = ACTIONS(4793),
    [sym_uint] = ACTIONS(4793),
    [sym_long] = ACTIONS(4793),
    [sym_ulong] = ACTIONS(4793),
    [sym_cent] = ACTIONS(4793),
    [sym_ucent] = ACTIONS(4793),
    [sym_wchar] = ACTIONS(4793),
    [sym_dchar] = ACTIONS(4793),
    [sym_float] = ACTIONS(4793),
    [sym_double] = ACTIONS(4793),
    [sym_real] = ACTIONS(4793),
    [sym_ifloat] = ACTIONS(4793),
    [sym_idouble] = ACTIONS(4793),
    [sym_ireal] = ACTIONS(4793),
    [sym_cfloat] = ACTIONS(4793),
    [sym_cdouble] = ACTIONS(4793),
    [sym_creal] = ACTIONS(4793),
    [sym_size_t] = ACTIONS(4793),
    [sym_ptrdiff_t] = ACTIONS(4793),
    [sym_string] = ACTIONS(4793),
    [sym_cstring] = ACTIONS(4793),
    [sym_dstring] = ACTIONS(4793),
    [sym_wstring] = ACTIONS(4793),
    [sym_noreturn] = ACTIONS(4793),
    [sym_true] = ACTIONS(4793),
    [sym_false] = ACTIONS(4793),
    [sym_null] = ACTIONS(4793),
    [sym_super] = ACTIONS(4793),
    [sym_this] = ACTIONS(4793),
    [sym_assert] = ACTIONS(4793),
    [sym_auto] = ACTIONS(4793),
    [sym_cast] = ACTIONS(4793),
    [sym_catch] = ACTIONS(4793),
    [sym_const] = ACTIONS(4793),
    [sym_delegate] = ACTIONS(4793),
    [sym_delete] = ACTIONS(4793),
    [sym_do] = ACTIONS(4793),
    [sym_else] = ACTIONS(4793),
    [sym_finally] = ACTIONS(4793),
    [sym_function] = ACTIONS(4793),
    [sym_immutable] = ACTIONS(4793),
    [sym_import] = ACTIONS(4793),
    [sym_in] = ACTIONS(4793),
    [sym_inout] = ACTIONS(4793),
    [sym_is] = ACTIONS(4793),
    [sym_mixin] = ACTIONS(4793),
    [sym_new] = ACTIONS(4793),
    [sym_out] = ACTIONS(4793),
    [sym_ref] = ACTIONS(4793),
    [sym_shared] = ACTIONS(4793),
    [sym_throw] = ACTIONS(4793),
    [sym_typeid] = ACTIONS(4793),
    [sym_typeof] = ACTIONS(4793),
    [sym_traits] = ACTIONS(4793),
    [sym_vector] = ACTIONS(4793),
    [sym_void] = ACTIONS(4793),
    [anon_sym_BQUOTE] = ACTIONS(4795),
    [anon_sym_r_DQUOTE] = ACTIONS(4795),
    [anon_sym_x_DQUOTE] = ACTIONS(4795),
    [anon_sym_DQUOTE] = ACTIONS(4795),
    [anon_sym_i_BQUOTE] = ACTIONS(4795),
    [anon_sym_i_DQUOTE] = ACTIONS(4795),
    [anon_sym_iq_LBRACE] = ACTIONS(4795),
    [aux_sym_char_literal_token1] = ACTIONS(4795),
    [anon_sym_SQUOTE] = ACTIONS(4793),
    [anon_sym___DATE__] = ACTIONS(4793),
    [anon_sym___FILE__] = ACTIONS(4793),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4793),
    [anon_sym___FUNCTION__] = ACTIONS(4793),
    [anon_sym___LINE__] = ACTIONS(4793),
    [anon_sym___MODULE__] = ACTIONS(4793),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4793),
    [anon_sym___TIME__] = ACTIONS(4793),
    [anon_sym___TIMESTAMP__] = ACTIONS(4793),
    [anon_sym___VENDOR__] = ACTIONS(4793),
    [anon_sym___VERSION__] = ACTIONS(4793),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4795),
    [sym_float_literal] = ACTIONS(4795),
    [sym__string] = ACTIONS(4795),
  },
  [2065] = {
    [sym_identifier] = ACTIONS(4701),
    [anon_sym_q_LBRACE] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(4704),
    [anon_sym_DOT] = ACTIONS(4704),
    [anon_sym_AMP] = ACTIONS(4704),
    [anon_sym_DASH] = ACTIONS(4701),
    [anon_sym_DASH_DASH] = ACTIONS(4704),
    [anon_sym_PLUS] = ACTIONS(4701),
    [anon_sym_PLUS_PLUS] = ACTIONS(4704),
    [anon_sym_BANG] = ACTIONS(4704),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_RPAREN] = ACTIONS(4704),
    [anon_sym_LBRACK] = ACTIONS(4704),
    [anon_sym_SEMI] = ACTIONS(4704),
    [anon_sym_DOLLAR] = ACTIONS(4704),
    [anon_sym_STAR] = ACTIONS(4704),
    [anon_sym_TILDE] = ACTIONS(4704),
    [sym_bool] = ACTIONS(4701),
    [sym_byte] = ACTIONS(4701),
    [sym_ubyte] = ACTIONS(4701),
    [sym_char] = ACTIONS(4701),
    [sym_short] = ACTIONS(4701),
    [sym_ushort] = ACTIONS(4701),
    [sym_int] = ACTIONS(4701),
    [sym_uint] = ACTIONS(4701),
    [sym_long] = ACTIONS(4701),
    [sym_ulong] = ACTIONS(4701),
    [sym_cent] = ACTIONS(4701),
    [sym_ucent] = ACTIONS(4701),
    [sym_wchar] = ACTIONS(4701),
    [sym_dchar] = ACTIONS(4701),
    [sym_float] = ACTIONS(4701),
    [sym_double] = ACTIONS(4701),
    [sym_real] = ACTIONS(4701),
    [sym_ifloat] = ACTIONS(4701),
    [sym_idouble] = ACTIONS(4701),
    [sym_ireal] = ACTIONS(4701),
    [sym_cfloat] = ACTIONS(4701),
    [sym_cdouble] = ACTIONS(4701),
    [sym_creal] = ACTIONS(4701),
    [sym_size_t] = ACTIONS(4701),
    [sym_ptrdiff_t] = ACTIONS(4701),
    [sym_string] = ACTIONS(4701),
    [sym_cstring] = ACTIONS(4701),
    [sym_dstring] = ACTIONS(4701),
    [sym_wstring] = ACTIONS(4701),
    [sym_noreturn] = ACTIONS(4701),
    [sym_true] = ACTIONS(4701),
    [sym_false] = ACTIONS(4701),
    [sym_null] = ACTIONS(4701),
    [sym_super] = ACTIONS(4701),
    [sym_this] = ACTIONS(4701),
    [sym_assert] = ACTIONS(4701),
    [sym_auto] = ACTIONS(4701),
    [sym_cast] = ACTIONS(4701),
    [sym_catch] = ACTIONS(4701),
    [sym_const] = ACTIONS(4701),
    [sym_delegate] = ACTIONS(4701),
    [sym_delete] = ACTIONS(4701),
    [sym_do] = ACTIONS(4701),
    [sym_else] = ACTIONS(4701),
    [sym_finally] = ACTIONS(4701),
    [sym_function] = ACTIONS(4701),
    [sym_immutable] = ACTIONS(4701),
    [sym_import] = ACTIONS(4701),
    [sym_in] = ACTIONS(4701),
    [sym_inout] = ACTIONS(4701),
    [sym_is] = ACTIONS(4701),
    [sym_mixin] = ACTIONS(4701),
    [sym_new] = ACTIONS(4701),
    [sym_out] = ACTIONS(4701),
    [sym_ref] = ACTIONS(4701),
    [sym_shared] = ACTIONS(4701),
    [sym_throw] = ACTIONS(4701),
    [sym_typeid] = ACTIONS(4701),
    [sym_typeof] = ACTIONS(4701),
    [sym_traits] = ACTIONS(4701),
    [sym_vector] = ACTIONS(4701),
    [sym_void] = ACTIONS(4701),
    [anon_sym_BQUOTE] = ACTIONS(4704),
    [anon_sym_r_DQUOTE] = ACTIONS(4704),
    [anon_sym_x_DQUOTE] = ACTIONS(4704),
    [anon_sym_DQUOTE] = ACTIONS(4704),
    [anon_sym_i_BQUOTE] = ACTIONS(4704),
    [anon_sym_i_DQUOTE] = ACTIONS(4704),
    [anon_sym_iq_LBRACE] = ACTIONS(4704),
    [aux_sym_char_literal_token1] = ACTIONS(4704),
    [anon_sym_SQUOTE] = ACTIONS(4701),
    [anon_sym___DATE__] = ACTIONS(4701),
    [anon_sym___FILE__] = ACTIONS(4701),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4701),
    [anon_sym___FUNCTION__] = ACTIONS(4701),
    [anon_sym___LINE__] = ACTIONS(4701),
    [anon_sym___MODULE__] = ACTIONS(4701),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4701),
    [anon_sym___TIME__] = ACTIONS(4701),
    [anon_sym___TIMESTAMP__] = ACTIONS(4701),
    [anon_sym___VENDOR__] = ACTIONS(4701),
    [anon_sym___VERSION__] = ACTIONS(4701),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4704),
    [sym_float_literal] = ACTIONS(4704),
    [sym__string] = ACTIONS(4704),
  },
  [2066] = {
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_q_LBRACE] = ACTIONS(4476),
    [anon_sym_LBRACE] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4476),
    [anon_sym_AMP] = ACTIONS(4476),
    [anon_sym_DASH] = ACTIONS(4474),
    [anon_sym_DASH_DASH] = ACTIONS(4476),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_PLUS_PLUS] = ACTIONS(4476),
    [anon_sym_BANG] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4476),
    [anon_sym_RPAREN] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4476),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_DOLLAR] = ACTIONS(4476),
    [anon_sym_STAR] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4476),
    [sym_bool] = ACTIONS(4474),
    [sym_byte] = ACTIONS(4474),
    [sym_ubyte] = ACTIONS(4474),
    [sym_char] = ACTIONS(4474),
    [sym_short] = ACTIONS(4474),
    [sym_ushort] = ACTIONS(4474),
    [sym_int] = ACTIONS(4474),
    [sym_uint] = ACTIONS(4474),
    [sym_long] = ACTIONS(4474),
    [sym_ulong] = ACTIONS(4474),
    [sym_cent] = ACTIONS(4474),
    [sym_ucent] = ACTIONS(4474),
    [sym_wchar] = ACTIONS(4474),
    [sym_dchar] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_double] = ACTIONS(4474),
    [sym_real] = ACTIONS(4474),
    [sym_ifloat] = ACTIONS(4474),
    [sym_idouble] = ACTIONS(4474),
    [sym_ireal] = ACTIONS(4474),
    [sym_cfloat] = ACTIONS(4474),
    [sym_cdouble] = ACTIONS(4474),
    [sym_creal] = ACTIONS(4474),
    [sym_size_t] = ACTIONS(4474),
    [sym_ptrdiff_t] = ACTIONS(4474),
    [sym_string] = ACTIONS(4474),
    [sym_cstring] = ACTIONS(4474),
    [sym_dstring] = ACTIONS(4474),
    [sym_wstring] = ACTIONS(4474),
    [sym_noreturn] = ACTIONS(4474),
    [sym_true] = ACTIONS(4474),
    [sym_false] = ACTIONS(4474),
    [sym_null] = ACTIONS(4474),
    [sym_super] = ACTIONS(4474),
    [sym_this] = ACTIONS(4474),
    [sym_assert] = ACTIONS(4474),
    [sym_auto] = ACTIONS(4474),
    [sym_cast] = ACTIONS(4474),
    [sym_catch] = ACTIONS(4474),
    [sym_const] = ACTIONS(4474),
    [sym_delegate] = ACTIONS(4474),
    [sym_delete] = ACTIONS(4474),
    [sym_do] = ACTIONS(4474),
    [sym_else] = ACTIONS(4474),
    [sym_finally] = ACTIONS(4474),
    [sym_function] = ACTIONS(4474),
    [sym_immutable] = ACTIONS(4474),
    [sym_import] = ACTIONS(4474),
    [sym_in] = ACTIONS(4474),
    [sym_inout] = ACTIONS(4474),
    [sym_is] = ACTIONS(4474),
    [sym_mixin] = ACTIONS(4474),
    [sym_new] = ACTIONS(4474),
    [sym_out] = ACTIONS(4474),
    [sym_ref] = ACTIONS(4474),
    [sym_shared] = ACTIONS(4474),
    [sym_throw] = ACTIONS(4474),
    [sym_typeid] = ACTIONS(4474),
    [sym_typeof] = ACTIONS(4474),
    [sym_traits] = ACTIONS(4474),
    [sym_vector] = ACTIONS(4474),
    [sym_void] = ACTIONS(4474),
    [anon_sym_BQUOTE] = ACTIONS(4476),
    [anon_sym_r_DQUOTE] = ACTIONS(4476),
    [anon_sym_x_DQUOTE] = ACTIONS(4476),
    [anon_sym_DQUOTE] = ACTIONS(4476),
    [anon_sym_i_BQUOTE] = ACTIONS(4476),
    [anon_sym_i_DQUOTE] = ACTIONS(4476),
    [anon_sym_iq_LBRACE] = ACTIONS(4476),
    [aux_sym_char_literal_token1] = ACTIONS(4476),
    [anon_sym_SQUOTE] = ACTIONS(4474),
    [anon_sym___DATE__] = ACTIONS(4474),
    [anon_sym___FILE__] = ACTIONS(4474),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4474),
    [anon_sym___FUNCTION__] = ACTIONS(4474),
    [anon_sym___LINE__] = ACTIONS(4474),
    [anon_sym___MODULE__] = ACTIONS(4474),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4474),
    [anon_sym___TIME__] = ACTIONS(4474),
    [anon_sym___TIMESTAMP__] = ACTIONS(4474),
    [anon_sym___VENDOR__] = ACTIONS(4474),
    [anon_sym___VERSION__] = ACTIONS(4474),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4476),
    [sym_float_literal] = ACTIONS(4476),
    [sym__string] = ACTIONS(4476),
  },
  [2067] = {
    [sym_identifier] = ACTIONS(4847),
    [anon_sym_q_LBRACE] = ACTIONS(4849),
    [anon_sym_LBRACE] = ACTIONS(4849),
    [anon_sym_DOT] = ACTIONS(4849),
    [anon_sym_AMP] = ACTIONS(4849),
    [anon_sym_DASH] = ACTIONS(4847),
    [anon_sym_DASH_DASH] = ACTIONS(4849),
    [anon_sym_PLUS] = ACTIONS(4847),
    [anon_sym_PLUS_PLUS] = ACTIONS(4849),
    [anon_sym_BANG] = ACTIONS(4849),
    [anon_sym_LPAREN] = ACTIONS(4849),
    [anon_sym_RPAREN] = ACTIONS(4849),
    [anon_sym_LBRACK] = ACTIONS(4849),
    [anon_sym_SEMI] = ACTIONS(4849),
    [anon_sym_DOLLAR] = ACTIONS(4849),
    [anon_sym_STAR] = ACTIONS(4849),
    [anon_sym_TILDE] = ACTIONS(4849),
    [sym_bool] = ACTIONS(4847),
    [sym_byte] = ACTIONS(4847),
    [sym_ubyte] = ACTIONS(4847),
    [sym_char] = ACTIONS(4847),
    [sym_short] = ACTIONS(4847),
    [sym_ushort] = ACTIONS(4847),
    [sym_int] = ACTIONS(4847),
    [sym_uint] = ACTIONS(4847),
    [sym_long] = ACTIONS(4847),
    [sym_ulong] = ACTIONS(4847),
    [sym_cent] = ACTIONS(4847),
    [sym_ucent] = ACTIONS(4847),
    [sym_wchar] = ACTIONS(4847),
    [sym_dchar] = ACTIONS(4847),
    [sym_float] = ACTIONS(4847),
    [sym_double] = ACTIONS(4847),
    [sym_real] = ACTIONS(4847),
    [sym_ifloat] = ACTIONS(4847),
    [sym_idouble] = ACTIONS(4847),
    [sym_ireal] = ACTIONS(4847),
    [sym_cfloat] = ACTIONS(4847),
    [sym_cdouble] = ACTIONS(4847),
    [sym_creal] = ACTIONS(4847),
    [sym_size_t] = ACTIONS(4847),
    [sym_ptrdiff_t] = ACTIONS(4847),
    [sym_string] = ACTIONS(4847),
    [sym_cstring] = ACTIONS(4847),
    [sym_dstring] = ACTIONS(4847),
    [sym_wstring] = ACTIONS(4847),
    [sym_noreturn] = ACTIONS(4847),
    [sym_true] = ACTIONS(4847),
    [sym_false] = ACTIONS(4847),
    [sym_null] = ACTIONS(4847),
    [sym_super] = ACTIONS(4847),
    [sym_this] = ACTIONS(4847),
    [sym_assert] = ACTIONS(4847),
    [sym_auto] = ACTIONS(4847),
    [sym_cast] = ACTIONS(4847),
    [sym_catch] = ACTIONS(4847),
    [sym_const] = ACTIONS(4847),
    [sym_delegate] = ACTIONS(4847),
    [sym_delete] = ACTIONS(4847),
    [sym_do] = ACTIONS(4847),
    [sym_else] = ACTIONS(4847),
    [sym_finally] = ACTIONS(4847),
    [sym_function] = ACTIONS(4847),
    [sym_immutable] = ACTIONS(4847),
    [sym_import] = ACTIONS(4847),
    [sym_in] = ACTIONS(4847),
    [sym_inout] = ACTIONS(4847),
    [sym_is] = ACTIONS(4847),
    [sym_mixin] = ACTIONS(4847),
    [sym_new] = ACTIONS(4847),
    [sym_out] = ACTIONS(4847),
    [sym_ref] = ACTIONS(4847),
    [sym_shared] = ACTIONS(4847),
    [sym_throw] = ACTIONS(4847),
    [sym_typeid] = ACTIONS(4847),
    [sym_typeof] = ACTIONS(4847),
    [sym_traits] = ACTIONS(4847),
    [sym_vector] = ACTIONS(4847),
    [sym_void] = ACTIONS(4847),
    [anon_sym_BQUOTE] = ACTIONS(4849),
    [anon_sym_r_DQUOTE] = ACTIONS(4849),
    [anon_sym_x_DQUOTE] = ACTIONS(4849),
    [anon_sym_DQUOTE] = ACTIONS(4849),
    [anon_sym_i_BQUOTE] = ACTIONS(4849),
    [anon_sym_i_DQUOTE] = ACTIONS(4849),
    [anon_sym_iq_LBRACE] = ACTIONS(4849),
    [aux_sym_char_literal_token1] = ACTIONS(4849),
    [anon_sym_SQUOTE] = ACTIONS(4847),
    [anon_sym___DATE__] = ACTIONS(4847),
    [anon_sym___FILE__] = ACTIONS(4847),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4847),
    [anon_sym___FUNCTION__] = ACTIONS(4847),
    [anon_sym___LINE__] = ACTIONS(4847),
    [anon_sym___MODULE__] = ACTIONS(4847),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4847),
    [anon_sym___TIME__] = ACTIONS(4847),
    [anon_sym___TIMESTAMP__] = ACTIONS(4847),
    [anon_sym___VENDOR__] = ACTIONS(4847),
    [anon_sym___VERSION__] = ACTIONS(4847),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4849),
    [sym_float_literal] = ACTIONS(4849),
    [sym__string] = ACTIONS(4849),
  },
  [2068] = {
    [sym_identifier] = ACTIONS(4851),
    [anon_sym_q_LBRACE] = ACTIONS(4853),
    [anon_sym_LBRACE] = ACTIONS(4853),
    [anon_sym_DOT] = ACTIONS(4853),
    [anon_sym_AMP] = ACTIONS(4853),
    [anon_sym_DASH] = ACTIONS(4851),
    [anon_sym_DASH_DASH] = ACTIONS(4853),
    [anon_sym_PLUS] = ACTIONS(4851),
    [anon_sym_PLUS_PLUS] = ACTIONS(4853),
    [anon_sym_BANG] = ACTIONS(4853),
    [anon_sym_LPAREN] = ACTIONS(4853),
    [anon_sym_RPAREN] = ACTIONS(4853),
    [anon_sym_LBRACK] = ACTIONS(4853),
    [anon_sym_SEMI] = ACTIONS(4853),
    [anon_sym_DOLLAR] = ACTIONS(4853),
    [anon_sym_STAR] = ACTIONS(4853),
    [anon_sym_TILDE] = ACTIONS(4853),
    [sym_bool] = ACTIONS(4851),
    [sym_byte] = ACTIONS(4851),
    [sym_ubyte] = ACTIONS(4851),
    [sym_char] = ACTIONS(4851),
    [sym_short] = ACTIONS(4851),
    [sym_ushort] = ACTIONS(4851),
    [sym_int] = ACTIONS(4851),
    [sym_uint] = ACTIONS(4851),
    [sym_long] = ACTIONS(4851),
    [sym_ulong] = ACTIONS(4851),
    [sym_cent] = ACTIONS(4851),
    [sym_ucent] = ACTIONS(4851),
    [sym_wchar] = ACTIONS(4851),
    [sym_dchar] = ACTIONS(4851),
    [sym_float] = ACTIONS(4851),
    [sym_double] = ACTIONS(4851),
    [sym_real] = ACTIONS(4851),
    [sym_ifloat] = ACTIONS(4851),
    [sym_idouble] = ACTIONS(4851),
    [sym_ireal] = ACTIONS(4851),
    [sym_cfloat] = ACTIONS(4851),
    [sym_cdouble] = ACTIONS(4851),
    [sym_creal] = ACTIONS(4851),
    [sym_size_t] = ACTIONS(4851),
    [sym_ptrdiff_t] = ACTIONS(4851),
    [sym_string] = ACTIONS(4851),
    [sym_cstring] = ACTIONS(4851),
    [sym_dstring] = ACTIONS(4851),
    [sym_wstring] = ACTIONS(4851),
    [sym_noreturn] = ACTIONS(4851),
    [sym_true] = ACTIONS(4851),
    [sym_false] = ACTIONS(4851),
    [sym_null] = ACTIONS(4851),
    [sym_super] = ACTIONS(4851),
    [sym_this] = ACTIONS(4851),
    [sym_assert] = ACTIONS(4851),
    [sym_auto] = ACTIONS(4851),
    [sym_cast] = ACTIONS(4851),
    [sym_catch] = ACTIONS(4851),
    [sym_const] = ACTIONS(4851),
    [sym_delegate] = ACTIONS(4851),
    [sym_delete] = ACTIONS(4851),
    [sym_do] = ACTIONS(4851),
    [sym_else] = ACTIONS(4851),
    [sym_finally] = ACTIONS(4851),
    [sym_function] = ACTIONS(4851),
    [sym_immutable] = ACTIONS(4851),
    [sym_import] = ACTIONS(4851),
    [sym_in] = ACTIONS(4851),
    [sym_inout] = ACTIONS(4851),
    [sym_is] = ACTIONS(4851),
    [sym_mixin] = ACTIONS(4851),
    [sym_new] = ACTIONS(4851),
    [sym_out] = ACTIONS(4851),
    [sym_ref] = ACTIONS(4851),
    [sym_shared] = ACTIONS(4851),
    [sym_throw] = ACTIONS(4851),
    [sym_typeid] = ACTIONS(4851),
    [sym_typeof] = ACTIONS(4851),
    [sym_traits] = ACTIONS(4851),
    [sym_vector] = ACTIONS(4851),
    [sym_void] = ACTIONS(4851),
    [anon_sym_BQUOTE] = ACTIONS(4853),
    [anon_sym_r_DQUOTE] = ACTIONS(4853),
    [anon_sym_x_DQUOTE] = ACTIONS(4853),
    [anon_sym_DQUOTE] = ACTIONS(4853),
    [anon_sym_i_BQUOTE] = ACTIONS(4853),
    [anon_sym_i_DQUOTE] = ACTIONS(4853),
    [anon_sym_iq_LBRACE] = ACTIONS(4853),
    [aux_sym_char_literal_token1] = ACTIONS(4853),
    [anon_sym_SQUOTE] = ACTIONS(4851),
    [anon_sym___DATE__] = ACTIONS(4851),
    [anon_sym___FILE__] = ACTIONS(4851),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4851),
    [anon_sym___FUNCTION__] = ACTIONS(4851),
    [anon_sym___LINE__] = ACTIONS(4851),
    [anon_sym___MODULE__] = ACTIONS(4851),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4851),
    [anon_sym___TIME__] = ACTIONS(4851),
    [anon_sym___TIMESTAMP__] = ACTIONS(4851),
    [anon_sym___VENDOR__] = ACTIONS(4851),
    [anon_sym___VERSION__] = ACTIONS(4851),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4853),
    [sym_float_literal] = ACTIONS(4853),
    [sym__string] = ACTIONS(4853),
  },
  [2069] = {
    [sym_identifier] = ACTIONS(4358),
    [anon_sym_q_LBRACE] = ACTIONS(4360),
    [anon_sym_LBRACE] = ACTIONS(4360),
    [anon_sym_DOT] = ACTIONS(4360),
    [anon_sym_AMP] = ACTIONS(4360),
    [anon_sym_DASH] = ACTIONS(4358),
    [anon_sym_DASH_DASH] = ACTIONS(4360),
    [anon_sym_PLUS] = ACTIONS(4358),
    [anon_sym_PLUS_PLUS] = ACTIONS(4360),
    [anon_sym_BANG] = ACTIONS(4360),
    [anon_sym_LPAREN] = ACTIONS(4360),
    [anon_sym_RPAREN] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(4360),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_DOLLAR] = ACTIONS(4360),
    [anon_sym_STAR] = ACTIONS(4360),
    [anon_sym_TILDE] = ACTIONS(4360),
    [sym_bool] = ACTIONS(4358),
    [sym_byte] = ACTIONS(4358),
    [sym_ubyte] = ACTIONS(4358),
    [sym_char] = ACTIONS(4358),
    [sym_short] = ACTIONS(4358),
    [sym_ushort] = ACTIONS(4358),
    [sym_int] = ACTIONS(4358),
    [sym_uint] = ACTIONS(4358),
    [sym_long] = ACTIONS(4358),
    [sym_ulong] = ACTIONS(4358),
    [sym_cent] = ACTIONS(4358),
    [sym_ucent] = ACTIONS(4358),
    [sym_wchar] = ACTIONS(4358),
    [sym_dchar] = ACTIONS(4358),
    [sym_float] = ACTIONS(4358),
    [sym_double] = ACTIONS(4358),
    [sym_real] = ACTIONS(4358),
    [sym_ifloat] = ACTIONS(4358),
    [sym_idouble] = ACTIONS(4358),
    [sym_ireal] = ACTIONS(4358),
    [sym_cfloat] = ACTIONS(4358),
    [sym_cdouble] = ACTIONS(4358),
    [sym_creal] = ACTIONS(4358),
    [sym_size_t] = ACTIONS(4358),
    [sym_ptrdiff_t] = ACTIONS(4358),
    [sym_string] = ACTIONS(4358),
    [sym_cstring] = ACTIONS(4358),
    [sym_dstring] = ACTIONS(4358),
    [sym_wstring] = ACTIONS(4358),
    [sym_noreturn] = ACTIONS(4358),
    [sym_true] = ACTIONS(4358),
    [sym_false] = ACTIONS(4358),
    [sym_null] = ACTIONS(4358),
    [sym_super] = ACTIONS(4358),
    [sym_this] = ACTIONS(4358),
    [sym_assert] = ACTIONS(4358),
    [sym_auto] = ACTIONS(4358),
    [sym_cast] = ACTIONS(4358),
    [sym_catch] = ACTIONS(4358),
    [sym_const] = ACTIONS(4358),
    [sym_delegate] = ACTIONS(4358),
    [sym_delete] = ACTIONS(4358),
    [sym_do] = ACTIONS(4358),
    [sym_else] = ACTIONS(4358),
    [sym_finally] = ACTIONS(4358),
    [sym_function] = ACTIONS(4358),
    [sym_immutable] = ACTIONS(4358),
    [sym_import] = ACTIONS(4358),
    [sym_in] = ACTIONS(4358),
    [sym_inout] = ACTIONS(4358),
    [sym_is] = ACTIONS(4358),
    [sym_mixin] = ACTIONS(4358),
    [sym_new] = ACTIONS(4358),
    [sym_out] = ACTIONS(4358),
    [sym_ref] = ACTIONS(4358),
    [sym_shared] = ACTIONS(4358),
    [sym_throw] = ACTIONS(4358),
    [sym_typeid] = ACTIONS(4358),
    [sym_typeof] = ACTIONS(4358),
    [sym_traits] = ACTIONS(4358),
    [sym_vector] = ACTIONS(4358),
    [sym_void] = ACTIONS(4358),
    [anon_sym_BQUOTE] = ACTIONS(4360),
    [anon_sym_r_DQUOTE] = ACTIONS(4360),
    [anon_sym_x_DQUOTE] = ACTIONS(4360),
    [anon_sym_DQUOTE] = ACTIONS(4360),
    [anon_sym_i_BQUOTE] = ACTIONS(4360),
    [anon_sym_i_DQUOTE] = ACTIONS(4360),
    [anon_sym_iq_LBRACE] = ACTIONS(4360),
    [aux_sym_char_literal_token1] = ACTIONS(4360),
    [anon_sym_SQUOTE] = ACTIONS(4358),
    [anon_sym___DATE__] = ACTIONS(4358),
    [anon_sym___FILE__] = ACTIONS(4358),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4358),
    [anon_sym___FUNCTION__] = ACTIONS(4358),
    [anon_sym___LINE__] = ACTIONS(4358),
    [anon_sym___MODULE__] = ACTIONS(4358),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4358),
    [anon_sym___TIME__] = ACTIONS(4358),
    [anon_sym___TIMESTAMP__] = ACTIONS(4358),
    [anon_sym___VENDOR__] = ACTIONS(4358),
    [anon_sym___VERSION__] = ACTIONS(4358),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4360),
    [sym_float_literal] = ACTIONS(4360),
    [sym__string] = ACTIONS(4360),
  },
  [2070] = {
    [sym_identifier] = ACTIONS(4558),
    [anon_sym_q_LBRACE] = ACTIONS(4560),
    [anon_sym_LBRACE] = ACTIONS(4560),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_AMP] = ACTIONS(4560),
    [anon_sym_DASH] = ACTIONS(4558),
    [anon_sym_DASH_DASH] = ACTIONS(4560),
    [anon_sym_PLUS] = ACTIONS(4558),
    [anon_sym_PLUS_PLUS] = ACTIONS(4560),
    [anon_sym_BANG] = ACTIONS(4560),
    [anon_sym_LPAREN] = ACTIONS(4560),
    [anon_sym_RPAREN] = ACTIONS(4560),
    [anon_sym_LBRACK] = ACTIONS(4560),
    [anon_sym_SEMI] = ACTIONS(4560),
    [anon_sym_DOLLAR] = ACTIONS(4560),
    [anon_sym_STAR] = ACTIONS(4560),
    [anon_sym_TILDE] = ACTIONS(4560),
    [sym_bool] = ACTIONS(4558),
    [sym_byte] = ACTIONS(4558),
    [sym_ubyte] = ACTIONS(4558),
    [sym_char] = ACTIONS(4558),
    [sym_short] = ACTIONS(4558),
    [sym_ushort] = ACTIONS(4558),
    [sym_int] = ACTIONS(4558),
    [sym_uint] = ACTIONS(4558),
    [sym_long] = ACTIONS(4558),
    [sym_ulong] = ACTIONS(4558),
    [sym_cent] = ACTIONS(4558),
    [sym_ucent] = ACTIONS(4558),
    [sym_wchar] = ACTIONS(4558),
    [sym_dchar] = ACTIONS(4558),
    [sym_float] = ACTIONS(4558),
    [sym_double] = ACTIONS(4558),
    [sym_real] = ACTIONS(4558),
    [sym_ifloat] = ACTIONS(4558),
    [sym_idouble] = ACTIONS(4558),
    [sym_ireal] = ACTIONS(4558),
    [sym_cfloat] = ACTIONS(4558),
    [sym_cdouble] = ACTIONS(4558),
    [sym_creal] = ACTIONS(4558),
    [sym_size_t] = ACTIONS(4558),
    [sym_ptrdiff_t] = ACTIONS(4558),
    [sym_string] = ACTIONS(4558),
    [sym_cstring] = ACTIONS(4558),
    [sym_dstring] = ACTIONS(4558),
    [sym_wstring] = ACTIONS(4558),
    [sym_noreturn] = ACTIONS(4558),
    [sym_true] = ACTIONS(4558),
    [sym_false] = ACTIONS(4558),
    [sym_null] = ACTIONS(4558),
    [sym_super] = ACTIONS(4558),
    [sym_this] = ACTIONS(4558),
    [sym_assert] = ACTIONS(4558),
    [sym_auto] = ACTIONS(4558),
    [sym_cast] = ACTIONS(4558),
    [sym_catch] = ACTIONS(4558),
    [sym_const] = ACTIONS(4558),
    [sym_delegate] = ACTIONS(4558),
    [sym_delete] = ACTIONS(4558),
    [sym_do] = ACTIONS(4558),
    [sym_else] = ACTIONS(4558),
    [sym_finally] = ACTIONS(4558),
    [sym_function] = ACTIONS(4558),
    [sym_immutable] = ACTIONS(4558),
    [sym_import] = ACTIONS(4558),
    [sym_in] = ACTIONS(4558),
    [sym_inout] = ACTIONS(4558),
    [sym_is] = ACTIONS(4558),
    [sym_mixin] = ACTIONS(4558),
    [sym_new] = ACTIONS(4558),
    [sym_out] = ACTIONS(4558),
    [sym_ref] = ACTIONS(4558),
    [sym_shared] = ACTIONS(4558),
    [sym_throw] = ACTIONS(4558),
    [sym_typeid] = ACTIONS(4558),
    [sym_typeof] = ACTIONS(4558),
    [sym_traits] = ACTIONS(4558),
    [sym_vector] = ACTIONS(4558),
    [sym_void] = ACTIONS(4558),
    [anon_sym_BQUOTE] = ACTIONS(4560),
    [anon_sym_r_DQUOTE] = ACTIONS(4560),
    [anon_sym_x_DQUOTE] = ACTIONS(4560),
    [anon_sym_DQUOTE] = ACTIONS(4560),
    [anon_sym_i_BQUOTE] = ACTIONS(4560),
    [anon_sym_i_DQUOTE] = ACTIONS(4560),
    [anon_sym_iq_LBRACE] = ACTIONS(4560),
    [aux_sym_char_literal_token1] = ACTIONS(4560),
    [anon_sym_SQUOTE] = ACTIONS(4558),
    [anon_sym___DATE__] = ACTIONS(4558),
    [anon_sym___FILE__] = ACTIONS(4558),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4558),
    [anon_sym___FUNCTION__] = ACTIONS(4558),
    [anon_sym___LINE__] = ACTIONS(4558),
    [anon_sym___MODULE__] = ACTIONS(4558),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4558),
    [anon_sym___TIME__] = ACTIONS(4558),
    [anon_sym___TIMESTAMP__] = ACTIONS(4558),
    [anon_sym___VENDOR__] = ACTIONS(4558),
    [anon_sym___VERSION__] = ACTIONS(4558),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4560),
    [sym_float_literal] = ACTIONS(4560),
    [sym__string] = ACTIONS(4560),
  },
  [2071] = {
    [sym_identifier] = ACTIONS(4909),
    [anon_sym_q_LBRACE] = ACTIONS(4911),
    [anon_sym_LBRACE] = ACTIONS(4911),
    [anon_sym_DOT] = ACTIONS(4911),
    [anon_sym_AMP] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_DASH_DASH] = ACTIONS(4911),
    [anon_sym_PLUS] = ACTIONS(4909),
    [anon_sym_PLUS_PLUS] = ACTIONS(4911),
    [anon_sym_BANG] = ACTIONS(4911),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [anon_sym_RPAREN] = ACTIONS(4911),
    [anon_sym_LBRACK] = ACTIONS(4911),
    [anon_sym_SEMI] = ACTIONS(4911),
    [anon_sym_DOLLAR] = ACTIONS(4911),
    [anon_sym_STAR] = ACTIONS(4911),
    [anon_sym_TILDE] = ACTIONS(4911),
    [sym_bool] = ACTIONS(4909),
    [sym_byte] = ACTIONS(4909),
    [sym_ubyte] = ACTIONS(4909),
    [sym_char] = ACTIONS(4909),
    [sym_short] = ACTIONS(4909),
    [sym_ushort] = ACTIONS(4909),
    [sym_int] = ACTIONS(4909),
    [sym_uint] = ACTIONS(4909),
    [sym_long] = ACTIONS(4909),
    [sym_ulong] = ACTIONS(4909),
    [sym_cent] = ACTIONS(4909),
    [sym_ucent] = ACTIONS(4909),
    [sym_wchar] = ACTIONS(4909),
    [sym_dchar] = ACTIONS(4909),
    [sym_float] = ACTIONS(4909),
    [sym_double] = ACTIONS(4909),
    [sym_real] = ACTIONS(4909),
    [sym_ifloat] = ACTIONS(4909),
    [sym_idouble] = ACTIONS(4909),
    [sym_ireal] = ACTIONS(4909),
    [sym_cfloat] = ACTIONS(4909),
    [sym_cdouble] = ACTIONS(4909),
    [sym_creal] = ACTIONS(4909),
    [sym_size_t] = ACTIONS(4909),
    [sym_ptrdiff_t] = ACTIONS(4909),
    [sym_string] = ACTIONS(4909),
    [sym_cstring] = ACTIONS(4909),
    [sym_dstring] = ACTIONS(4909),
    [sym_wstring] = ACTIONS(4909),
    [sym_noreturn] = ACTIONS(4909),
    [sym_true] = ACTIONS(4909),
    [sym_false] = ACTIONS(4909),
    [sym_null] = ACTIONS(4909),
    [sym_super] = ACTIONS(4909),
    [sym_this] = ACTIONS(4909),
    [sym_assert] = ACTIONS(4909),
    [sym_auto] = ACTIONS(4909),
    [sym_cast] = ACTIONS(4909),
    [sym_catch] = ACTIONS(4909),
    [sym_const] = ACTIONS(4909),
    [sym_delegate] = ACTIONS(4909),
    [sym_delete] = ACTIONS(4909),
    [sym_do] = ACTIONS(4909),
    [sym_else] = ACTIONS(4909),
    [sym_finally] = ACTIONS(4909),
    [sym_function] = ACTIONS(4909),
    [sym_immutable] = ACTIONS(4909),
    [sym_import] = ACTIONS(4909),
    [sym_in] = ACTIONS(4909),
    [sym_inout] = ACTIONS(4909),
    [sym_is] = ACTIONS(4909),
    [sym_mixin] = ACTIONS(4909),
    [sym_new] = ACTIONS(4909),
    [sym_out] = ACTIONS(4909),
    [sym_ref] = ACTIONS(4909),
    [sym_shared] = ACTIONS(4909),
    [sym_throw] = ACTIONS(4909),
    [sym_typeid] = ACTIONS(4909),
    [sym_typeof] = ACTIONS(4909),
    [sym_traits] = ACTIONS(4909),
    [sym_vector] = ACTIONS(4909),
    [sym_void] = ACTIONS(4909),
    [anon_sym_BQUOTE] = ACTIONS(4911),
    [anon_sym_r_DQUOTE] = ACTIONS(4911),
    [anon_sym_x_DQUOTE] = ACTIONS(4911),
    [anon_sym_DQUOTE] = ACTIONS(4911),
    [anon_sym_i_BQUOTE] = ACTIONS(4911),
    [anon_sym_i_DQUOTE] = ACTIONS(4911),
    [anon_sym_iq_LBRACE] = ACTIONS(4911),
    [aux_sym_char_literal_token1] = ACTIONS(4911),
    [anon_sym_SQUOTE] = ACTIONS(4909),
    [anon_sym___DATE__] = ACTIONS(4909),
    [anon_sym___FILE__] = ACTIONS(4909),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4909),
    [anon_sym___FUNCTION__] = ACTIONS(4909),
    [anon_sym___LINE__] = ACTIONS(4909),
    [anon_sym___MODULE__] = ACTIONS(4909),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4909),
    [anon_sym___TIME__] = ACTIONS(4909),
    [anon_sym___TIMESTAMP__] = ACTIONS(4909),
    [anon_sym___VENDOR__] = ACTIONS(4909),
    [anon_sym___VERSION__] = ACTIONS(4909),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4911),
    [sym_float_literal] = ACTIONS(4911),
    [sym__string] = ACTIONS(4911),
  },
  [2072] = {
    [sym_identifier] = ACTIONS(4725),
    [anon_sym_q_LBRACE] = ACTIONS(4727),
    [anon_sym_LBRACE] = ACTIONS(4727),
    [anon_sym_DOT] = ACTIONS(4727),
    [anon_sym_AMP] = ACTIONS(4727),
    [anon_sym_DASH] = ACTIONS(4725),
    [anon_sym_DASH_DASH] = ACTIONS(4727),
    [anon_sym_PLUS] = ACTIONS(4725),
    [anon_sym_PLUS_PLUS] = ACTIONS(4727),
    [anon_sym_BANG] = ACTIONS(4727),
    [anon_sym_LPAREN] = ACTIONS(4727),
    [anon_sym_RPAREN] = ACTIONS(4727),
    [anon_sym_LBRACK] = ACTIONS(4727),
    [anon_sym_SEMI] = ACTIONS(4727),
    [anon_sym_DOLLAR] = ACTIONS(4727),
    [anon_sym_STAR] = ACTIONS(4727),
    [anon_sym_TILDE] = ACTIONS(4727),
    [sym_bool] = ACTIONS(4725),
    [sym_byte] = ACTIONS(4725),
    [sym_ubyte] = ACTIONS(4725),
    [sym_char] = ACTIONS(4725),
    [sym_short] = ACTIONS(4725),
    [sym_ushort] = ACTIONS(4725),
    [sym_int] = ACTIONS(4725),
    [sym_uint] = ACTIONS(4725),
    [sym_long] = ACTIONS(4725),
    [sym_ulong] = ACTIONS(4725),
    [sym_cent] = ACTIONS(4725),
    [sym_ucent] = ACTIONS(4725),
    [sym_wchar] = ACTIONS(4725),
    [sym_dchar] = ACTIONS(4725),
    [sym_float] = ACTIONS(4725),
    [sym_double] = ACTIONS(4725),
    [sym_real] = ACTIONS(4725),
    [sym_ifloat] = ACTIONS(4725),
    [sym_idouble] = ACTIONS(4725),
    [sym_ireal] = ACTIONS(4725),
    [sym_cfloat] = ACTIONS(4725),
    [sym_cdouble] = ACTIONS(4725),
    [sym_creal] = ACTIONS(4725),
    [sym_size_t] = ACTIONS(4725),
    [sym_ptrdiff_t] = ACTIONS(4725),
    [sym_string] = ACTIONS(4725),
    [sym_cstring] = ACTIONS(4725),
    [sym_dstring] = ACTIONS(4725),
    [sym_wstring] = ACTIONS(4725),
    [sym_noreturn] = ACTIONS(4725),
    [sym_true] = ACTIONS(4725),
    [sym_false] = ACTIONS(4725),
    [sym_null] = ACTIONS(4725),
    [sym_super] = ACTIONS(4725),
    [sym_this] = ACTIONS(4725),
    [sym_assert] = ACTIONS(4725),
    [sym_auto] = ACTIONS(4725),
    [sym_cast] = ACTIONS(4725),
    [sym_catch] = ACTIONS(4725),
    [sym_const] = ACTIONS(4725),
    [sym_delegate] = ACTIONS(4725),
    [sym_delete] = ACTIONS(4725),
    [sym_do] = ACTIONS(4725),
    [sym_else] = ACTIONS(4725),
    [sym_finally] = ACTIONS(4725),
    [sym_function] = ACTIONS(4725),
    [sym_immutable] = ACTIONS(4725),
    [sym_import] = ACTIONS(4725),
    [sym_in] = ACTIONS(4725),
    [sym_inout] = ACTIONS(4725),
    [sym_is] = ACTIONS(4725),
    [sym_mixin] = ACTIONS(4725),
    [sym_new] = ACTIONS(4725),
    [sym_out] = ACTIONS(4725),
    [sym_ref] = ACTIONS(4725),
    [sym_shared] = ACTIONS(4725),
    [sym_throw] = ACTIONS(4725),
    [sym_typeid] = ACTIONS(4725),
    [sym_typeof] = ACTIONS(4725),
    [sym_traits] = ACTIONS(4725),
    [sym_vector] = ACTIONS(4725),
    [sym_void] = ACTIONS(4725),
    [anon_sym_BQUOTE] = ACTIONS(4727),
    [anon_sym_r_DQUOTE] = ACTIONS(4727),
    [anon_sym_x_DQUOTE] = ACTIONS(4727),
    [anon_sym_DQUOTE] = ACTIONS(4727),
    [anon_sym_i_BQUOTE] = ACTIONS(4727),
    [anon_sym_i_DQUOTE] = ACTIONS(4727),
    [anon_sym_iq_LBRACE] = ACTIONS(4727),
    [aux_sym_char_literal_token1] = ACTIONS(4727),
    [anon_sym_SQUOTE] = ACTIONS(4725),
    [anon_sym___DATE__] = ACTIONS(4725),
    [anon_sym___FILE__] = ACTIONS(4725),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4725),
    [anon_sym___FUNCTION__] = ACTIONS(4725),
    [anon_sym___LINE__] = ACTIONS(4725),
    [anon_sym___MODULE__] = ACTIONS(4725),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4725),
    [anon_sym___TIME__] = ACTIONS(4725),
    [anon_sym___TIMESTAMP__] = ACTIONS(4725),
    [anon_sym___VENDOR__] = ACTIONS(4725),
    [anon_sym___VERSION__] = ACTIONS(4725),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4727),
    [sym_float_literal] = ACTIONS(4727),
    [sym__string] = ACTIONS(4727),
  },
  [2073] = {
    [sym_identifier] = ACTIONS(4550),
    [anon_sym_q_LBRACE] = ACTIONS(4552),
    [anon_sym_LBRACE] = ACTIONS(4552),
    [anon_sym_DOT] = ACTIONS(4552),
    [anon_sym_AMP] = ACTIONS(4552),
    [anon_sym_DASH] = ACTIONS(4550),
    [anon_sym_DASH_DASH] = ACTIONS(4552),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_PLUS_PLUS] = ACTIONS(4552),
    [anon_sym_BANG] = ACTIONS(4552),
    [anon_sym_LPAREN] = ACTIONS(4552),
    [anon_sym_RPAREN] = ACTIONS(4552),
    [anon_sym_LBRACK] = ACTIONS(4552),
    [anon_sym_SEMI] = ACTIONS(4552),
    [anon_sym_DOLLAR] = ACTIONS(4552),
    [anon_sym_STAR] = ACTIONS(4552),
    [anon_sym_TILDE] = ACTIONS(4552),
    [sym_bool] = ACTIONS(4550),
    [sym_byte] = ACTIONS(4550),
    [sym_ubyte] = ACTIONS(4550),
    [sym_char] = ACTIONS(4550),
    [sym_short] = ACTIONS(4550),
    [sym_ushort] = ACTIONS(4550),
    [sym_int] = ACTIONS(4550),
    [sym_uint] = ACTIONS(4550),
    [sym_long] = ACTIONS(4550),
    [sym_ulong] = ACTIONS(4550),
    [sym_cent] = ACTIONS(4550),
    [sym_ucent] = ACTIONS(4550),
    [sym_wchar] = ACTIONS(4550),
    [sym_dchar] = ACTIONS(4550),
    [sym_float] = ACTIONS(4550),
    [sym_double] = ACTIONS(4550),
    [sym_real] = ACTIONS(4550),
    [sym_ifloat] = ACTIONS(4550),
    [sym_idouble] = ACTIONS(4550),
    [sym_ireal] = ACTIONS(4550),
    [sym_cfloat] = ACTIONS(4550),
    [sym_cdouble] = ACTIONS(4550),
    [sym_creal] = ACTIONS(4550),
    [sym_size_t] = ACTIONS(4550),
    [sym_ptrdiff_t] = ACTIONS(4550),
    [sym_string] = ACTIONS(4550),
    [sym_cstring] = ACTIONS(4550),
    [sym_dstring] = ACTIONS(4550),
    [sym_wstring] = ACTIONS(4550),
    [sym_noreturn] = ACTIONS(4550),
    [sym_true] = ACTIONS(4550),
    [sym_false] = ACTIONS(4550),
    [sym_null] = ACTIONS(4550),
    [sym_super] = ACTIONS(4550),
    [sym_this] = ACTIONS(4550),
    [sym_assert] = ACTIONS(4550),
    [sym_auto] = ACTIONS(4550),
    [sym_cast] = ACTIONS(4550),
    [sym_catch] = ACTIONS(4550),
    [sym_const] = ACTIONS(4550),
    [sym_delegate] = ACTIONS(4550),
    [sym_delete] = ACTIONS(4550),
    [sym_do] = ACTIONS(4550),
    [sym_else] = ACTIONS(4550),
    [sym_finally] = ACTIONS(4550),
    [sym_function] = ACTIONS(4550),
    [sym_immutable] = ACTIONS(4550),
    [sym_import] = ACTIONS(4550),
    [sym_in] = ACTIONS(4550),
    [sym_inout] = ACTIONS(4550),
    [sym_is] = ACTIONS(4550),
    [sym_mixin] = ACTIONS(4550),
    [sym_new] = ACTIONS(4550),
    [sym_out] = ACTIONS(4550),
    [sym_ref] = ACTIONS(4550),
    [sym_shared] = ACTIONS(4550),
    [sym_throw] = ACTIONS(4550),
    [sym_typeid] = ACTIONS(4550),
    [sym_typeof] = ACTIONS(4550),
    [sym_traits] = ACTIONS(4550),
    [sym_vector] = ACTIONS(4550),
    [sym_void] = ACTIONS(4550),
    [anon_sym_BQUOTE] = ACTIONS(4552),
    [anon_sym_r_DQUOTE] = ACTIONS(4552),
    [anon_sym_x_DQUOTE] = ACTIONS(4552),
    [anon_sym_DQUOTE] = ACTIONS(4552),
    [anon_sym_i_BQUOTE] = ACTIONS(4552),
    [anon_sym_i_DQUOTE] = ACTIONS(4552),
    [anon_sym_iq_LBRACE] = ACTIONS(4552),
    [aux_sym_char_literal_token1] = ACTIONS(4552),
    [anon_sym_SQUOTE] = ACTIONS(4550),
    [anon_sym___DATE__] = ACTIONS(4550),
    [anon_sym___FILE__] = ACTIONS(4550),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4550),
    [anon_sym___FUNCTION__] = ACTIONS(4550),
    [anon_sym___LINE__] = ACTIONS(4550),
    [anon_sym___MODULE__] = ACTIONS(4550),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4550),
    [anon_sym___TIME__] = ACTIONS(4550),
    [anon_sym___TIMESTAMP__] = ACTIONS(4550),
    [anon_sym___VENDOR__] = ACTIONS(4550),
    [anon_sym___VERSION__] = ACTIONS(4550),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4552),
    [sym_float_literal] = ACTIONS(4552),
    [sym__string] = ACTIONS(4552),
  },
  [2074] = {
    [sym_identifier] = ACTIONS(4554),
    [anon_sym_q_LBRACE] = ACTIONS(4556),
    [anon_sym_LBRACE] = ACTIONS(4556),
    [anon_sym_DOT] = ACTIONS(4556),
    [anon_sym_AMP] = ACTIONS(4556),
    [anon_sym_DASH] = ACTIONS(4554),
    [anon_sym_DASH_DASH] = ACTIONS(4556),
    [anon_sym_PLUS] = ACTIONS(4554),
    [anon_sym_PLUS_PLUS] = ACTIONS(4556),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_LPAREN] = ACTIONS(4556),
    [anon_sym_RPAREN] = ACTIONS(4556),
    [anon_sym_LBRACK] = ACTIONS(4556),
    [anon_sym_SEMI] = ACTIONS(4556),
    [anon_sym_DOLLAR] = ACTIONS(4556),
    [anon_sym_STAR] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_bool] = ACTIONS(4554),
    [sym_byte] = ACTIONS(4554),
    [sym_ubyte] = ACTIONS(4554),
    [sym_char] = ACTIONS(4554),
    [sym_short] = ACTIONS(4554),
    [sym_ushort] = ACTIONS(4554),
    [sym_int] = ACTIONS(4554),
    [sym_uint] = ACTIONS(4554),
    [sym_long] = ACTIONS(4554),
    [sym_ulong] = ACTIONS(4554),
    [sym_cent] = ACTIONS(4554),
    [sym_ucent] = ACTIONS(4554),
    [sym_wchar] = ACTIONS(4554),
    [sym_dchar] = ACTIONS(4554),
    [sym_float] = ACTIONS(4554),
    [sym_double] = ACTIONS(4554),
    [sym_real] = ACTIONS(4554),
    [sym_ifloat] = ACTIONS(4554),
    [sym_idouble] = ACTIONS(4554),
    [sym_ireal] = ACTIONS(4554),
    [sym_cfloat] = ACTIONS(4554),
    [sym_cdouble] = ACTIONS(4554),
    [sym_creal] = ACTIONS(4554),
    [sym_size_t] = ACTIONS(4554),
    [sym_ptrdiff_t] = ACTIONS(4554),
    [sym_string] = ACTIONS(4554),
    [sym_cstring] = ACTIONS(4554),
    [sym_dstring] = ACTIONS(4554),
    [sym_wstring] = ACTIONS(4554),
    [sym_noreturn] = ACTIONS(4554),
    [sym_true] = ACTIONS(4554),
    [sym_false] = ACTIONS(4554),
    [sym_null] = ACTIONS(4554),
    [sym_super] = ACTIONS(4554),
    [sym_this] = ACTIONS(4554),
    [sym_assert] = ACTIONS(4554),
    [sym_auto] = ACTIONS(4554),
    [sym_cast] = ACTIONS(4554),
    [sym_catch] = ACTIONS(4554),
    [sym_const] = ACTIONS(4554),
    [sym_delegate] = ACTIONS(4554),
    [sym_delete] = ACTIONS(4554),
    [sym_do] = ACTIONS(4554),
    [sym_else] = ACTIONS(4554),
    [sym_finally] = ACTIONS(4554),
    [sym_function] = ACTIONS(4554),
    [sym_immutable] = ACTIONS(4554),
    [sym_import] = ACTIONS(4554),
    [sym_in] = ACTIONS(4554),
    [sym_inout] = ACTIONS(4554),
    [sym_is] = ACTIONS(4554),
    [sym_mixin] = ACTIONS(4554),
    [sym_new] = ACTIONS(4554),
    [sym_out] = ACTIONS(4554),
    [sym_ref] = ACTIONS(4554),
    [sym_shared] = ACTIONS(4554),
    [sym_throw] = ACTIONS(4554),
    [sym_typeid] = ACTIONS(4554),
    [sym_typeof] = ACTIONS(4554),
    [sym_traits] = ACTIONS(4554),
    [sym_vector] = ACTIONS(4554),
    [sym_void] = ACTIONS(4554),
    [anon_sym_BQUOTE] = ACTIONS(4556),
    [anon_sym_r_DQUOTE] = ACTIONS(4556),
    [anon_sym_x_DQUOTE] = ACTIONS(4556),
    [anon_sym_DQUOTE] = ACTIONS(4556),
    [anon_sym_i_BQUOTE] = ACTIONS(4556),
    [anon_sym_i_DQUOTE] = ACTIONS(4556),
    [anon_sym_iq_LBRACE] = ACTIONS(4556),
    [aux_sym_char_literal_token1] = ACTIONS(4556),
    [anon_sym_SQUOTE] = ACTIONS(4554),
    [anon_sym___DATE__] = ACTIONS(4554),
    [anon_sym___FILE__] = ACTIONS(4554),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4554),
    [anon_sym___FUNCTION__] = ACTIONS(4554),
    [anon_sym___LINE__] = ACTIONS(4554),
    [anon_sym___MODULE__] = ACTIONS(4554),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4554),
    [anon_sym___TIME__] = ACTIONS(4554),
    [anon_sym___TIMESTAMP__] = ACTIONS(4554),
    [anon_sym___VENDOR__] = ACTIONS(4554),
    [anon_sym___VERSION__] = ACTIONS(4554),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4556),
    [sym_float_literal] = ACTIONS(4556),
    [sym__string] = ACTIONS(4556),
  },
  [2075] = {
    [sym_identifier] = ACTIONS(5007),
    [anon_sym_q_LBRACE] = ACTIONS(5009),
    [anon_sym_LBRACE] = ACTIONS(5009),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_AMP] = ACTIONS(5009),
    [anon_sym_DASH] = ACTIONS(5007),
    [anon_sym_DASH_DASH] = ACTIONS(5009),
    [anon_sym_PLUS] = ACTIONS(5007),
    [anon_sym_PLUS_PLUS] = ACTIONS(5009),
    [anon_sym_BANG] = ACTIONS(5009),
    [anon_sym_LPAREN] = ACTIONS(5009),
    [anon_sym_RPAREN] = ACTIONS(5009),
    [anon_sym_LBRACK] = ACTIONS(5009),
    [anon_sym_SEMI] = ACTIONS(5009),
    [anon_sym_DOLLAR] = ACTIONS(5009),
    [anon_sym_STAR] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5009),
    [sym_bool] = ACTIONS(5007),
    [sym_byte] = ACTIONS(5007),
    [sym_ubyte] = ACTIONS(5007),
    [sym_char] = ACTIONS(5007),
    [sym_short] = ACTIONS(5007),
    [sym_ushort] = ACTIONS(5007),
    [sym_int] = ACTIONS(5007),
    [sym_uint] = ACTIONS(5007),
    [sym_long] = ACTIONS(5007),
    [sym_ulong] = ACTIONS(5007),
    [sym_cent] = ACTIONS(5007),
    [sym_ucent] = ACTIONS(5007),
    [sym_wchar] = ACTIONS(5007),
    [sym_dchar] = ACTIONS(5007),
    [sym_float] = ACTIONS(5007),
    [sym_double] = ACTIONS(5007),
    [sym_real] = ACTIONS(5007),
    [sym_ifloat] = ACTIONS(5007),
    [sym_idouble] = ACTIONS(5007),
    [sym_ireal] = ACTIONS(5007),
    [sym_cfloat] = ACTIONS(5007),
    [sym_cdouble] = ACTIONS(5007),
    [sym_creal] = ACTIONS(5007),
    [sym_size_t] = ACTIONS(5007),
    [sym_ptrdiff_t] = ACTIONS(5007),
    [sym_string] = ACTIONS(5007),
    [sym_cstring] = ACTIONS(5007),
    [sym_dstring] = ACTIONS(5007),
    [sym_wstring] = ACTIONS(5007),
    [sym_noreturn] = ACTIONS(5007),
    [sym_true] = ACTIONS(5007),
    [sym_false] = ACTIONS(5007),
    [sym_null] = ACTIONS(5007),
    [sym_super] = ACTIONS(5007),
    [sym_this] = ACTIONS(5007),
    [sym_assert] = ACTIONS(5007),
    [sym_auto] = ACTIONS(5007),
    [sym_cast] = ACTIONS(5007),
    [sym_catch] = ACTIONS(5007),
    [sym_const] = ACTIONS(5007),
    [sym_delegate] = ACTIONS(5007),
    [sym_delete] = ACTIONS(5007),
    [sym_do] = ACTIONS(5007),
    [sym_else] = ACTIONS(5007),
    [sym_finally] = ACTIONS(5007),
    [sym_function] = ACTIONS(5007),
    [sym_immutable] = ACTIONS(5007),
    [sym_import] = ACTIONS(5007),
    [sym_in] = ACTIONS(5007),
    [sym_inout] = ACTIONS(5007),
    [sym_is] = ACTIONS(5007),
    [sym_mixin] = ACTIONS(5007),
    [sym_new] = ACTIONS(5007),
    [sym_out] = ACTIONS(5007),
    [sym_ref] = ACTIONS(5007),
    [sym_shared] = ACTIONS(5007),
    [sym_throw] = ACTIONS(5007),
    [sym_typeid] = ACTIONS(5007),
    [sym_typeof] = ACTIONS(5007),
    [sym_traits] = ACTIONS(5007),
    [sym_vector] = ACTIONS(5007),
    [sym_void] = ACTIONS(5007),
    [anon_sym_BQUOTE] = ACTIONS(5009),
    [anon_sym_r_DQUOTE] = ACTIONS(5009),
    [anon_sym_x_DQUOTE] = ACTIONS(5009),
    [anon_sym_DQUOTE] = ACTIONS(5009),
    [anon_sym_i_BQUOTE] = ACTIONS(5009),
    [anon_sym_i_DQUOTE] = ACTIONS(5009),
    [anon_sym_iq_LBRACE] = ACTIONS(5009),
    [aux_sym_char_literal_token1] = ACTIONS(5009),
    [anon_sym_SQUOTE] = ACTIONS(5007),
    [anon_sym___DATE__] = ACTIONS(5007),
    [anon_sym___FILE__] = ACTIONS(5007),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5007),
    [anon_sym___FUNCTION__] = ACTIONS(5007),
    [anon_sym___LINE__] = ACTIONS(5007),
    [anon_sym___MODULE__] = ACTIONS(5007),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5007),
    [anon_sym___TIME__] = ACTIONS(5007),
    [anon_sym___TIMESTAMP__] = ACTIONS(5007),
    [anon_sym___VENDOR__] = ACTIONS(5007),
    [anon_sym___VERSION__] = ACTIONS(5007),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5009),
    [sym_float_literal] = ACTIONS(5009),
    [sym__string] = ACTIONS(5009),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(5003),
    [anon_sym_q_LBRACE] = ACTIONS(5005),
    [anon_sym_LBRACE] = ACTIONS(5005),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_AMP] = ACTIONS(5005),
    [anon_sym_DASH] = ACTIONS(5003),
    [anon_sym_DASH_DASH] = ACTIONS(5005),
    [anon_sym_PLUS] = ACTIONS(5003),
    [anon_sym_PLUS_PLUS] = ACTIONS(5005),
    [anon_sym_BANG] = ACTIONS(5005),
    [anon_sym_LPAREN] = ACTIONS(5005),
    [anon_sym_RPAREN] = ACTIONS(5005),
    [anon_sym_LBRACK] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(5005),
    [anon_sym_DOLLAR] = ACTIONS(5005),
    [anon_sym_STAR] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5005),
    [sym_bool] = ACTIONS(5003),
    [sym_byte] = ACTIONS(5003),
    [sym_ubyte] = ACTIONS(5003),
    [sym_char] = ACTIONS(5003),
    [sym_short] = ACTIONS(5003),
    [sym_ushort] = ACTIONS(5003),
    [sym_int] = ACTIONS(5003),
    [sym_uint] = ACTIONS(5003),
    [sym_long] = ACTIONS(5003),
    [sym_ulong] = ACTIONS(5003),
    [sym_cent] = ACTIONS(5003),
    [sym_ucent] = ACTIONS(5003),
    [sym_wchar] = ACTIONS(5003),
    [sym_dchar] = ACTIONS(5003),
    [sym_float] = ACTIONS(5003),
    [sym_double] = ACTIONS(5003),
    [sym_real] = ACTIONS(5003),
    [sym_ifloat] = ACTIONS(5003),
    [sym_idouble] = ACTIONS(5003),
    [sym_ireal] = ACTIONS(5003),
    [sym_cfloat] = ACTIONS(5003),
    [sym_cdouble] = ACTIONS(5003),
    [sym_creal] = ACTIONS(5003),
    [sym_size_t] = ACTIONS(5003),
    [sym_ptrdiff_t] = ACTIONS(5003),
    [sym_string] = ACTIONS(5003),
    [sym_cstring] = ACTIONS(5003),
    [sym_dstring] = ACTIONS(5003),
    [sym_wstring] = ACTIONS(5003),
    [sym_noreturn] = ACTIONS(5003),
    [sym_true] = ACTIONS(5003),
    [sym_false] = ACTIONS(5003),
    [sym_null] = ACTIONS(5003),
    [sym_super] = ACTIONS(5003),
    [sym_this] = ACTIONS(5003),
    [sym_assert] = ACTIONS(5003),
    [sym_auto] = ACTIONS(5003),
    [sym_cast] = ACTIONS(5003),
    [sym_catch] = ACTIONS(5003),
    [sym_const] = ACTIONS(5003),
    [sym_delegate] = ACTIONS(5003),
    [sym_delete] = ACTIONS(5003),
    [sym_do] = ACTIONS(5003),
    [sym_else] = ACTIONS(5003),
    [sym_finally] = ACTIONS(5003),
    [sym_function] = ACTIONS(5003),
    [sym_immutable] = ACTIONS(5003),
    [sym_import] = ACTIONS(5003),
    [sym_in] = ACTIONS(5003),
    [sym_inout] = ACTIONS(5003),
    [sym_is] = ACTIONS(5003),
    [sym_mixin] = ACTIONS(5003),
    [sym_new] = ACTIONS(5003),
    [sym_out] = ACTIONS(5003),
    [sym_ref] = ACTIONS(5003),
    [sym_shared] = ACTIONS(5003),
    [sym_throw] = ACTIONS(5003),
    [sym_typeid] = ACTIONS(5003),
    [sym_typeof] = ACTIONS(5003),
    [sym_traits] = ACTIONS(5003),
    [sym_vector] = ACTIONS(5003),
    [sym_void] = ACTIONS(5003),
    [anon_sym_BQUOTE] = ACTIONS(5005),
    [anon_sym_r_DQUOTE] = ACTIONS(5005),
    [anon_sym_x_DQUOTE] = ACTIONS(5005),
    [anon_sym_DQUOTE] = ACTIONS(5005),
    [anon_sym_i_BQUOTE] = ACTIONS(5005),
    [anon_sym_i_DQUOTE] = ACTIONS(5005),
    [anon_sym_iq_LBRACE] = ACTIONS(5005),
    [aux_sym_char_literal_token1] = ACTIONS(5005),
    [anon_sym_SQUOTE] = ACTIONS(5003),
    [anon_sym___DATE__] = ACTIONS(5003),
    [anon_sym___FILE__] = ACTIONS(5003),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(5003),
    [anon_sym___FUNCTION__] = ACTIONS(5003),
    [anon_sym___LINE__] = ACTIONS(5003),
    [anon_sym___MODULE__] = ACTIONS(5003),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(5003),
    [anon_sym___TIME__] = ACTIONS(5003),
    [anon_sym___TIMESTAMP__] = ACTIONS(5003),
    [anon_sym___VENDOR__] = ACTIONS(5003),
    [anon_sym___VERSION__] = ACTIONS(5003),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5005),
    [sym_float_literal] = ACTIONS(5005),
    [sym__string] = ACTIONS(5005),
  },
  [2077] = {
    [sym_identifier] = ACTIONS(4999),
    [anon_sym_q_LBRACE] = ACTIONS(5001),
    [anon_sym_LBRACE] = ACTIONS(5001),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_AMP] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(4999),
    [anon_sym_DASH_DASH] = ACTIONS(5001),
    [anon_sym_PLUS] = ACTIONS(4999),
    [anon_sym_PLUS_PLUS] = ACTIONS(5001),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_LPAREN] = ACTIONS(5001),
    [anon_sym_RPAREN] = ACTIONS(5001),
    [anon_sym_LBRACK] = ACTIONS(5001),
    [anon_sym_SEMI] = ACTIONS(5001),
    [anon_sym_DOLLAR] = ACTIONS(5001),
    [anon_sym_STAR] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5001),
    [sym_bool] = ACTIONS(4999),
    [sym_byte] = ACTIONS(4999),
    [sym_ubyte] = ACTIONS(4999),
    [sym_char] = ACTIONS(4999),
    [sym_short] = ACTIONS(4999),
    [sym_ushort] = ACTIONS(4999),
    [sym_int] = ACTIONS(4999),
    [sym_uint] = ACTIONS(4999),
    [sym_long] = ACTIONS(4999),
    [sym_ulong] = ACTIONS(4999),
    [sym_cent] = ACTIONS(4999),
    [sym_ucent] = ACTIONS(4999),
    [sym_wchar] = ACTIONS(4999),
    [sym_dchar] = ACTIONS(4999),
    [sym_float] = ACTIONS(4999),
    [sym_double] = ACTIONS(4999),
    [sym_real] = ACTIONS(4999),
    [sym_ifloat] = ACTIONS(4999),
    [sym_idouble] = ACTIONS(4999),
    [sym_ireal] = ACTIONS(4999),
    [sym_cfloat] = ACTIONS(4999),
    [sym_cdouble] = ACTIONS(4999),
    [sym_creal] = ACTIONS(4999),
    [sym_size_t] = ACTIONS(4999),
    [sym_ptrdiff_t] = ACTIONS(4999),
    [sym_string] = ACTIONS(4999),
    [sym_cstring] = ACTIONS(4999),
    [sym_dstring] = ACTIONS(4999),
    [sym_wstring] = ACTIONS(4999),
    [sym_noreturn] = ACTIONS(4999),
    [sym_true] = ACTIONS(4999),
    [sym_false] = ACTIONS(4999),
    [sym_null] = ACTIONS(4999),
    [sym_super] = ACTIONS(4999),
    [sym_this] = ACTIONS(4999),
    [sym_assert] = ACTIONS(4999),
    [sym_auto] = ACTIONS(4999),
    [sym_cast] = ACTIONS(4999),
    [sym_catch] = ACTIONS(4999),
    [sym_const] = ACTIONS(4999),
    [sym_delegate] = ACTIONS(4999),
    [sym_delete] = ACTIONS(4999),
    [sym_do] = ACTIONS(4999),
    [sym_else] = ACTIONS(4999),
    [sym_finally] = ACTIONS(4999),
    [sym_function] = ACTIONS(4999),
    [sym_immutable] = ACTIONS(4999),
    [sym_import] = ACTIONS(4999),
    [sym_in] = ACTIONS(4999),
    [sym_inout] = ACTIONS(4999),
    [sym_is] = ACTIONS(4999),
    [sym_mixin] = ACTIONS(4999),
    [sym_new] = ACTIONS(4999),
    [sym_out] = ACTIONS(4999),
    [sym_ref] = ACTIONS(4999),
    [sym_shared] = ACTIONS(4999),
    [sym_throw] = ACTIONS(4999),
    [sym_typeid] = ACTIONS(4999),
    [sym_typeof] = ACTIONS(4999),
    [sym_traits] = ACTIONS(4999),
    [sym_vector] = ACTIONS(4999),
    [sym_void] = ACTIONS(4999),
    [anon_sym_BQUOTE] = ACTIONS(5001),
    [anon_sym_r_DQUOTE] = ACTIONS(5001),
    [anon_sym_x_DQUOTE] = ACTIONS(5001),
    [anon_sym_DQUOTE] = ACTIONS(5001),
    [anon_sym_i_BQUOTE] = ACTIONS(5001),
    [anon_sym_i_DQUOTE] = ACTIONS(5001),
    [anon_sym_iq_LBRACE] = ACTIONS(5001),
    [aux_sym_char_literal_token1] = ACTIONS(5001),
    [anon_sym_SQUOTE] = ACTIONS(4999),
    [anon_sym___DATE__] = ACTIONS(4999),
    [anon_sym___FILE__] = ACTIONS(4999),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4999),
    [anon_sym___FUNCTION__] = ACTIONS(4999),
    [anon_sym___LINE__] = ACTIONS(4999),
    [anon_sym___MODULE__] = ACTIONS(4999),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4999),
    [anon_sym___TIME__] = ACTIONS(4999),
    [anon_sym___TIMESTAMP__] = ACTIONS(4999),
    [anon_sym___VENDOR__] = ACTIONS(4999),
    [anon_sym___VERSION__] = ACTIONS(4999),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(5001),
    [sym_float_literal] = ACTIONS(5001),
    [sym__string] = ACTIONS(5001),
  },
  [2078] = {
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_q_LBRACE] = ACTIONS(4871),
    [anon_sym_LBRACE] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_AMP] = ACTIONS(4871),
    [anon_sym_DASH] = ACTIONS(4869),
    [anon_sym_DASH_DASH] = ACTIONS(4871),
    [anon_sym_PLUS] = ACTIONS(4869),
    [anon_sym_PLUS_PLUS] = ACTIONS(4871),
    [anon_sym_BANG] = ACTIONS(4871),
    [anon_sym_LPAREN] = ACTIONS(4871),
    [anon_sym_RPAREN] = ACTIONS(4871),
    [anon_sym_LBRACK] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_DOLLAR] = ACTIONS(4871),
    [anon_sym_STAR] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4871),
    [sym_bool] = ACTIONS(4869),
    [sym_byte] = ACTIONS(4869),
    [sym_ubyte] = ACTIONS(4869),
    [sym_char] = ACTIONS(4869),
    [sym_short] = ACTIONS(4869),
    [sym_ushort] = ACTIONS(4869),
    [sym_int] = ACTIONS(4869),
    [sym_uint] = ACTIONS(4869),
    [sym_long] = ACTIONS(4869),
    [sym_ulong] = ACTIONS(4869),
    [sym_cent] = ACTIONS(4869),
    [sym_ucent] = ACTIONS(4869),
    [sym_wchar] = ACTIONS(4869),
    [sym_dchar] = ACTIONS(4869),
    [sym_float] = ACTIONS(4869),
    [sym_double] = ACTIONS(4869),
    [sym_real] = ACTIONS(4869),
    [sym_ifloat] = ACTIONS(4869),
    [sym_idouble] = ACTIONS(4869),
    [sym_ireal] = ACTIONS(4869),
    [sym_cfloat] = ACTIONS(4869),
    [sym_cdouble] = ACTIONS(4869),
    [sym_creal] = ACTIONS(4869),
    [sym_size_t] = ACTIONS(4869),
    [sym_ptrdiff_t] = ACTIONS(4869),
    [sym_string] = ACTIONS(4869),
    [sym_cstring] = ACTIONS(4869),
    [sym_dstring] = ACTIONS(4869),
    [sym_wstring] = ACTIONS(4869),
    [sym_noreturn] = ACTIONS(4869),
    [sym_true] = ACTIONS(4869),
    [sym_false] = ACTIONS(4869),
    [sym_null] = ACTIONS(4869),
    [sym_super] = ACTIONS(4869),
    [sym_this] = ACTIONS(4869),
    [sym_assert] = ACTIONS(4869),
    [sym_auto] = ACTIONS(4869),
    [sym_cast] = ACTIONS(4869),
    [sym_catch] = ACTIONS(4869),
    [sym_const] = ACTIONS(4869),
    [sym_delegate] = ACTIONS(4869),
    [sym_delete] = ACTIONS(4869),
    [sym_do] = ACTIONS(4869),
    [sym_else] = ACTIONS(4869),
    [sym_finally] = ACTIONS(4869),
    [sym_function] = ACTIONS(4869),
    [sym_immutable] = ACTIONS(4869),
    [sym_import] = ACTIONS(4869),
    [sym_in] = ACTIONS(4869),
    [sym_inout] = ACTIONS(4869),
    [sym_is] = ACTIONS(4869),
    [sym_mixin] = ACTIONS(4869),
    [sym_new] = ACTIONS(4869),
    [sym_out] = ACTIONS(4869),
    [sym_ref] = ACTIONS(4869),
    [sym_shared] = ACTIONS(4869),
    [sym_throw] = ACTIONS(4869),
    [sym_typeid] = ACTIONS(4869),
    [sym_typeof] = ACTIONS(4869),
    [sym_traits] = ACTIONS(4869),
    [sym_vector] = ACTIONS(4869),
    [sym_void] = ACTIONS(4869),
    [anon_sym_BQUOTE] = ACTIONS(4871),
    [anon_sym_r_DQUOTE] = ACTIONS(4871),
    [anon_sym_x_DQUOTE] = ACTIONS(4871),
    [anon_sym_DQUOTE] = ACTIONS(4871),
    [anon_sym_i_BQUOTE] = ACTIONS(4871),
    [anon_sym_i_DQUOTE] = ACTIONS(4871),
    [anon_sym_iq_LBRACE] = ACTIONS(4871),
    [aux_sym_char_literal_token1] = ACTIONS(4871),
    [anon_sym_SQUOTE] = ACTIONS(4869),
    [anon_sym___DATE__] = ACTIONS(4869),
    [anon_sym___FILE__] = ACTIONS(4869),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4869),
    [anon_sym___FUNCTION__] = ACTIONS(4869),
    [anon_sym___LINE__] = ACTIONS(4869),
    [anon_sym___MODULE__] = ACTIONS(4869),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4869),
    [anon_sym___TIME__] = ACTIONS(4869),
    [anon_sym___TIMESTAMP__] = ACTIONS(4869),
    [anon_sym___VENDOR__] = ACTIONS(4869),
    [anon_sym___VERSION__] = ACTIONS(4869),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4871),
    [sym_float_literal] = ACTIONS(4871),
    [sym__string] = ACTIONS(4871),
  },
  [2079] = {
    [sym_identifier] = ACTIONS(4991),
    [anon_sym_q_LBRACE] = ACTIONS(4993),
    [anon_sym_LBRACE] = ACTIONS(4993),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_AMP] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(4991),
    [anon_sym_DASH_DASH] = ACTIONS(4993),
    [anon_sym_PLUS] = ACTIONS(4991),
    [anon_sym_PLUS_PLUS] = ACTIONS(4993),
    [anon_sym_BANG] = ACTIONS(4993),
    [anon_sym_LPAREN] = ACTIONS(4993),
    [anon_sym_RPAREN] = ACTIONS(4993),
    [anon_sym_LBRACK] = ACTIONS(4993),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_DOLLAR] = ACTIONS(4993),
    [anon_sym_STAR] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [sym_bool] = ACTIONS(4991),
    [sym_byte] = ACTIONS(4991),
    [sym_ubyte] = ACTIONS(4991),
    [sym_char] = ACTIONS(4991),
    [sym_short] = ACTIONS(4991),
    [sym_ushort] = ACTIONS(4991),
    [sym_int] = ACTIONS(4991),
    [sym_uint] = ACTIONS(4991),
    [sym_long] = ACTIONS(4991),
    [sym_ulong] = ACTIONS(4991),
    [sym_cent] = ACTIONS(4991),
    [sym_ucent] = ACTIONS(4991),
    [sym_wchar] = ACTIONS(4991),
    [sym_dchar] = ACTIONS(4991),
    [sym_float] = ACTIONS(4991),
    [sym_double] = ACTIONS(4991),
    [sym_real] = ACTIONS(4991),
    [sym_ifloat] = ACTIONS(4991),
    [sym_idouble] = ACTIONS(4991),
    [sym_ireal] = ACTIONS(4991),
    [sym_cfloat] = ACTIONS(4991),
    [sym_cdouble] = ACTIONS(4991),
    [sym_creal] = ACTIONS(4991),
    [sym_size_t] = ACTIONS(4991),
    [sym_ptrdiff_t] = ACTIONS(4991),
    [sym_string] = ACTIONS(4991),
    [sym_cstring] = ACTIONS(4991),
    [sym_dstring] = ACTIONS(4991),
    [sym_wstring] = ACTIONS(4991),
    [sym_noreturn] = ACTIONS(4991),
    [sym_true] = ACTIONS(4991),
    [sym_false] = ACTIONS(4991),
    [sym_null] = ACTIONS(4991),
    [sym_super] = ACTIONS(4991),
    [sym_this] = ACTIONS(4991),
    [sym_assert] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [sym_cast] = ACTIONS(4991),
    [sym_catch] = ACTIONS(4991),
    [sym_const] = ACTIONS(4991),
    [sym_delegate] = ACTIONS(4991),
    [sym_delete] = ACTIONS(4991),
    [sym_do] = ACTIONS(4991),
    [sym_else] = ACTIONS(4991),
    [sym_finally] = ACTIONS(4991),
    [sym_function] = ACTIONS(4991),
    [sym_immutable] = ACTIONS(4991),
    [sym_import] = ACTIONS(4991),
    [sym_in] = ACTIONS(4991),
    [sym_inout] = ACTIONS(4991),
    [sym_is] = ACTIONS(4991),
    [sym_mixin] = ACTIONS(4991),
    [sym_new] = ACTIONS(4991),
    [sym_out] = ACTIONS(4991),
    [sym_ref] = ACTIONS(4991),
    [sym_shared] = ACTIONS(4991),
    [sym_throw] = ACTIONS(4991),
    [sym_typeid] = ACTIONS(4991),
    [sym_typeof] = ACTIONS(4991),
    [sym_traits] = ACTIONS(4991),
    [sym_vector] = ACTIONS(4991),
    [sym_void] = ACTIONS(4991),
    [anon_sym_BQUOTE] = ACTIONS(4993),
    [anon_sym_r_DQUOTE] = ACTIONS(4993),
    [anon_sym_x_DQUOTE] = ACTIONS(4993),
    [anon_sym_DQUOTE] = ACTIONS(4993),
    [anon_sym_i_BQUOTE] = ACTIONS(4993),
    [anon_sym_i_DQUOTE] = ACTIONS(4993),
    [anon_sym_iq_LBRACE] = ACTIONS(4993),
    [aux_sym_char_literal_token1] = ACTIONS(4993),
    [anon_sym_SQUOTE] = ACTIONS(4991),
    [anon_sym___DATE__] = ACTIONS(4991),
    [anon_sym___FILE__] = ACTIONS(4991),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4991),
    [anon_sym___FUNCTION__] = ACTIONS(4991),
    [anon_sym___LINE__] = ACTIONS(4991),
    [anon_sym___MODULE__] = ACTIONS(4991),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4991),
    [anon_sym___TIME__] = ACTIONS(4991),
    [anon_sym___TIMESTAMP__] = ACTIONS(4991),
    [anon_sym___VENDOR__] = ACTIONS(4991),
    [anon_sym___VERSION__] = ACTIONS(4991),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4993),
    [sym_float_literal] = ACTIONS(4993),
    [sym__string] = ACTIONS(4993),
  },
  [2080] = {
    [sym_identifier] = ACTIONS(4678),
    [anon_sym_q_LBRACE] = ACTIONS(4680),
    [anon_sym_LBRACE] = ACTIONS(4680),
    [anon_sym_DOT] = ACTIONS(4680),
    [anon_sym_AMP] = ACTIONS(4680),
    [anon_sym_DASH] = ACTIONS(4678),
    [anon_sym_DASH_DASH] = ACTIONS(4680),
    [anon_sym_PLUS] = ACTIONS(4678),
    [anon_sym_PLUS_PLUS] = ACTIONS(4680),
    [anon_sym_BANG] = ACTIONS(4680),
    [anon_sym_LPAREN] = ACTIONS(4680),
    [anon_sym_RPAREN] = ACTIONS(4680),
    [anon_sym_LBRACK] = ACTIONS(4680),
    [anon_sym_SEMI] = ACTIONS(4680),
    [anon_sym_DOLLAR] = ACTIONS(4680),
    [anon_sym_STAR] = ACTIONS(4680),
    [anon_sym_TILDE] = ACTIONS(4680),
    [sym_bool] = ACTIONS(4678),
    [sym_byte] = ACTIONS(4678),
    [sym_ubyte] = ACTIONS(4678),
    [sym_char] = ACTIONS(4678),
    [sym_short] = ACTIONS(4678),
    [sym_ushort] = ACTIONS(4678),
    [sym_int] = ACTIONS(4678),
    [sym_uint] = ACTIONS(4678),
    [sym_long] = ACTIONS(4678),
    [sym_ulong] = ACTIONS(4678),
    [sym_cent] = ACTIONS(4678),
    [sym_ucent] = ACTIONS(4678),
    [sym_wchar] = ACTIONS(4678),
    [sym_dchar] = ACTIONS(4678),
    [sym_float] = ACTIONS(4678),
    [sym_double] = ACTIONS(4678),
    [sym_real] = ACTIONS(4678),
    [sym_ifloat] = ACTIONS(4678),
    [sym_idouble] = ACTIONS(4678),
    [sym_ireal] = ACTIONS(4678),
    [sym_cfloat] = ACTIONS(4678),
    [sym_cdouble] = ACTIONS(4678),
    [sym_creal] = ACTIONS(4678),
    [sym_size_t] = ACTIONS(4678),
    [sym_ptrdiff_t] = ACTIONS(4678),
    [sym_string] = ACTIONS(4678),
    [sym_cstring] = ACTIONS(4678),
    [sym_dstring] = ACTIONS(4678),
    [sym_wstring] = ACTIONS(4678),
    [sym_noreturn] = ACTIONS(4678),
    [sym_true] = ACTIONS(4678),
    [sym_false] = ACTIONS(4678),
    [sym_null] = ACTIONS(4678),
    [sym_super] = ACTIONS(4678),
    [sym_this] = ACTIONS(4678),
    [sym_assert] = ACTIONS(4678),
    [sym_auto] = ACTIONS(4678),
    [sym_cast] = ACTIONS(4678),
    [sym_catch] = ACTIONS(4678),
    [sym_const] = ACTIONS(4678),
    [sym_delegate] = ACTIONS(4678),
    [sym_delete] = ACTIONS(4678),
    [sym_do] = ACTIONS(4678),
    [sym_else] = ACTIONS(4678),
    [sym_finally] = ACTIONS(4678),
    [sym_function] = ACTIONS(4678),
    [sym_immutable] = ACTIONS(4678),
    [sym_import] = ACTIONS(4678),
    [sym_in] = ACTIONS(4678),
    [sym_inout] = ACTIONS(4678),
    [sym_is] = ACTIONS(4678),
    [sym_mixin] = ACTIONS(4678),
    [sym_new] = ACTIONS(4678),
    [sym_out] = ACTIONS(4678),
    [sym_ref] = ACTIONS(4678),
    [sym_shared] = ACTIONS(4678),
    [sym_throw] = ACTIONS(4678),
    [sym_typeid] = ACTIONS(4678),
    [sym_typeof] = ACTIONS(4678),
    [sym_traits] = ACTIONS(4678),
    [sym_vector] = ACTIONS(4678),
    [sym_void] = ACTIONS(4678),
    [anon_sym_BQUOTE] = ACTIONS(4680),
    [anon_sym_r_DQUOTE] = ACTIONS(4680),
    [anon_sym_x_DQUOTE] = ACTIONS(4680),
    [anon_sym_DQUOTE] = ACTIONS(4680),
    [anon_sym_i_BQUOTE] = ACTIONS(4680),
    [anon_sym_i_DQUOTE] = ACTIONS(4680),
    [anon_sym_iq_LBRACE] = ACTIONS(4680),
    [aux_sym_char_literal_token1] = ACTIONS(4680),
    [anon_sym_SQUOTE] = ACTIONS(4678),
    [anon_sym___DATE__] = ACTIONS(4678),
    [anon_sym___FILE__] = ACTIONS(4678),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4678),
    [anon_sym___FUNCTION__] = ACTIONS(4678),
    [anon_sym___LINE__] = ACTIONS(4678),
    [anon_sym___MODULE__] = ACTIONS(4678),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4678),
    [anon_sym___TIME__] = ACTIONS(4678),
    [anon_sym___TIMESTAMP__] = ACTIONS(4678),
    [anon_sym___VENDOR__] = ACTIONS(4678),
    [anon_sym___VERSION__] = ACTIONS(4678),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4680),
    [sym_float_literal] = ACTIONS(4680),
    [sym__string] = ACTIONS(4680),
  },
  [2081] = {
    [sym_identifier] = ACTIONS(4672),
    [anon_sym_q_LBRACE] = ACTIONS(4675),
    [anon_sym_LBRACE] = ACTIONS(4675),
    [anon_sym_DOT] = ACTIONS(4675),
    [anon_sym_AMP] = ACTIONS(4675),
    [anon_sym_DASH] = ACTIONS(4672),
    [anon_sym_DASH_DASH] = ACTIONS(4675),
    [anon_sym_PLUS] = ACTIONS(4672),
    [anon_sym_PLUS_PLUS] = ACTIONS(4675),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_LPAREN] = ACTIONS(4675),
    [anon_sym_RPAREN] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(4675),
    [anon_sym_SEMI] = ACTIONS(4675),
    [anon_sym_DOLLAR] = ACTIONS(4675),
    [anon_sym_STAR] = ACTIONS(4675),
    [anon_sym_TILDE] = ACTIONS(4675),
    [sym_bool] = ACTIONS(4672),
    [sym_byte] = ACTIONS(4672),
    [sym_ubyte] = ACTIONS(4672),
    [sym_char] = ACTIONS(4672),
    [sym_short] = ACTIONS(4672),
    [sym_ushort] = ACTIONS(4672),
    [sym_int] = ACTIONS(4672),
    [sym_uint] = ACTIONS(4672),
    [sym_long] = ACTIONS(4672),
    [sym_ulong] = ACTIONS(4672),
    [sym_cent] = ACTIONS(4672),
    [sym_ucent] = ACTIONS(4672),
    [sym_wchar] = ACTIONS(4672),
    [sym_dchar] = ACTIONS(4672),
    [sym_float] = ACTIONS(4672),
    [sym_double] = ACTIONS(4672),
    [sym_real] = ACTIONS(4672),
    [sym_ifloat] = ACTIONS(4672),
    [sym_idouble] = ACTIONS(4672),
    [sym_ireal] = ACTIONS(4672),
    [sym_cfloat] = ACTIONS(4672),
    [sym_cdouble] = ACTIONS(4672),
    [sym_creal] = ACTIONS(4672),
    [sym_size_t] = ACTIONS(4672),
    [sym_ptrdiff_t] = ACTIONS(4672),
    [sym_string] = ACTIONS(4672),
    [sym_cstring] = ACTIONS(4672),
    [sym_dstring] = ACTIONS(4672),
    [sym_wstring] = ACTIONS(4672),
    [sym_noreturn] = ACTIONS(4672),
    [sym_true] = ACTIONS(4672),
    [sym_false] = ACTIONS(4672),
    [sym_null] = ACTIONS(4672),
    [sym_super] = ACTIONS(4672),
    [sym_this] = ACTIONS(4672),
    [sym_assert] = ACTIONS(4672),
    [sym_auto] = ACTIONS(4672),
    [sym_cast] = ACTIONS(4672),
    [sym_catch] = ACTIONS(4672),
    [sym_const] = ACTIONS(4672),
    [sym_delegate] = ACTIONS(4672),
    [sym_delete] = ACTIONS(4672),
    [sym_do] = ACTIONS(4672),
    [sym_else] = ACTIONS(4672),
    [sym_finally] = ACTIONS(4672),
    [sym_function] = ACTIONS(4672),
    [sym_immutable] = ACTIONS(4672),
    [sym_import] = ACTIONS(4672),
    [sym_in] = ACTIONS(4672),
    [sym_inout] = ACTIONS(4672),
    [sym_is] = ACTIONS(4672),
    [sym_mixin] = ACTIONS(4672),
    [sym_new] = ACTIONS(4672),
    [sym_out] = ACTIONS(4672),
    [sym_ref] = ACTIONS(4672),
    [sym_shared] = ACTIONS(4672),
    [sym_throw] = ACTIONS(4672),
    [sym_typeid] = ACTIONS(4672),
    [sym_typeof] = ACTIONS(4672),
    [sym_traits] = ACTIONS(4672),
    [sym_vector] = ACTIONS(4672),
    [sym_void] = ACTIONS(4672),
    [anon_sym_BQUOTE] = ACTIONS(4675),
    [anon_sym_r_DQUOTE] = ACTIONS(4675),
    [anon_sym_x_DQUOTE] = ACTIONS(4675),
    [anon_sym_DQUOTE] = ACTIONS(4675),
    [anon_sym_i_BQUOTE] = ACTIONS(4675),
    [anon_sym_i_DQUOTE] = ACTIONS(4675),
    [anon_sym_iq_LBRACE] = ACTIONS(4675),
    [aux_sym_char_literal_token1] = ACTIONS(4675),
    [anon_sym_SQUOTE] = ACTIONS(4672),
    [anon_sym___DATE__] = ACTIONS(4672),
    [anon_sym___FILE__] = ACTIONS(4672),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4672),
    [anon_sym___FUNCTION__] = ACTIONS(4672),
    [anon_sym___LINE__] = ACTIONS(4672),
    [anon_sym___MODULE__] = ACTIONS(4672),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4672),
    [anon_sym___TIME__] = ACTIONS(4672),
    [anon_sym___TIMESTAMP__] = ACTIONS(4672),
    [anon_sym___VENDOR__] = ACTIONS(4672),
    [anon_sym___VERSION__] = ACTIONS(4672),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4675),
    [sym_float_literal] = ACTIONS(4675),
    [sym__string] = ACTIONS(4675),
  },
  [2082] = {
    [sym_identifier] = ACTIONS(4652),
    [anon_sym_q_LBRACE] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(4654),
    [anon_sym_DOT] = ACTIONS(4654),
    [anon_sym_AMP] = ACTIONS(4654),
    [anon_sym_DASH] = ACTIONS(4652),
    [anon_sym_DASH_DASH] = ACTIONS(4654),
    [anon_sym_PLUS] = ACTIONS(4652),
    [anon_sym_PLUS_PLUS] = ACTIONS(4654),
    [anon_sym_BANG] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4654),
    [anon_sym_RPAREN] = ACTIONS(4654),
    [anon_sym_LBRACK] = ACTIONS(4654),
    [anon_sym_SEMI] = ACTIONS(4654),
    [anon_sym_DOLLAR] = ACTIONS(4654),
    [anon_sym_STAR] = ACTIONS(4654),
    [anon_sym_TILDE] = ACTIONS(4654),
    [sym_bool] = ACTIONS(4652),
    [sym_byte] = ACTIONS(4652),
    [sym_ubyte] = ACTIONS(4652),
    [sym_char] = ACTIONS(4652),
    [sym_short] = ACTIONS(4652),
    [sym_ushort] = ACTIONS(4652),
    [sym_int] = ACTIONS(4652),
    [sym_uint] = ACTIONS(4652),
    [sym_long] = ACTIONS(4652),
    [sym_ulong] = ACTIONS(4652),
    [sym_cent] = ACTIONS(4652),
    [sym_ucent] = ACTIONS(4652),
    [sym_wchar] = ACTIONS(4652),
    [sym_dchar] = ACTIONS(4652),
    [sym_float] = ACTIONS(4652),
    [sym_double] = ACTIONS(4652),
    [sym_real] = ACTIONS(4652),
    [sym_ifloat] = ACTIONS(4652),
    [sym_idouble] = ACTIONS(4652),
    [sym_ireal] = ACTIONS(4652),
    [sym_cfloat] = ACTIONS(4652),
    [sym_cdouble] = ACTIONS(4652),
    [sym_creal] = ACTIONS(4652),
    [sym_size_t] = ACTIONS(4652),
    [sym_ptrdiff_t] = ACTIONS(4652),
    [sym_string] = ACTIONS(4652),
    [sym_cstring] = ACTIONS(4652),
    [sym_dstring] = ACTIONS(4652),
    [sym_wstring] = ACTIONS(4652),
    [sym_noreturn] = ACTIONS(4652),
    [sym_true] = ACTIONS(4652),
    [sym_false] = ACTIONS(4652),
    [sym_null] = ACTIONS(4652),
    [sym_super] = ACTIONS(4652),
    [sym_this] = ACTIONS(4652),
    [sym_assert] = ACTIONS(4652),
    [sym_auto] = ACTIONS(4652),
    [sym_cast] = ACTIONS(4652),
    [sym_catch] = ACTIONS(4652),
    [sym_const] = ACTIONS(4652),
    [sym_delegate] = ACTIONS(4652),
    [sym_delete] = ACTIONS(4652),
    [sym_do] = ACTIONS(4652),
    [sym_else] = ACTIONS(4652),
    [sym_finally] = ACTIONS(4652),
    [sym_function] = ACTIONS(4652),
    [sym_immutable] = ACTIONS(4652),
    [sym_import] = ACTIONS(4652),
    [sym_in] = ACTIONS(4652),
    [sym_inout] = ACTIONS(4652),
    [sym_is] = ACTIONS(4652),
    [sym_mixin] = ACTIONS(4652),
    [sym_new] = ACTIONS(4652),
    [sym_out] = ACTIONS(4652),
    [sym_ref] = ACTIONS(4652),
    [sym_shared] = ACTIONS(4652),
    [sym_throw] = ACTIONS(4652),
    [sym_typeid] = ACTIONS(4652),
    [sym_typeof] = ACTIONS(4652),
    [sym_traits] = ACTIONS(4652),
    [sym_vector] = ACTIONS(4652),
    [sym_void] = ACTIONS(4652),
    [anon_sym_BQUOTE] = ACTIONS(4654),
    [anon_sym_r_DQUOTE] = ACTIONS(4654),
    [anon_sym_x_DQUOTE] = ACTIONS(4654),
    [anon_sym_DQUOTE] = ACTIONS(4654),
    [anon_sym_i_BQUOTE] = ACTIONS(4654),
    [anon_sym_i_DQUOTE] = ACTIONS(4654),
    [anon_sym_iq_LBRACE] = ACTIONS(4654),
    [aux_sym_char_literal_token1] = ACTIONS(4654),
    [anon_sym_SQUOTE] = ACTIONS(4652),
    [anon_sym___DATE__] = ACTIONS(4652),
    [anon_sym___FILE__] = ACTIONS(4652),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4652),
    [anon_sym___FUNCTION__] = ACTIONS(4652),
    [anon_sym___LINE__] = ACTIONS(4652),
    [anon_sym___MODULE__] = ACTIONS(4652),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4652),
    [anon_sym___TIME__] = ACTIONS(4652),
    [anon_sym___TIMESTAMP__] = ACTIONS(4652),
    [anon_sym___VENDOR__] = ACTIONS(4652),
    [anon_sym___VERSION__] = ACTIONS(4652),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4654),
    [sym_float_literal] = ACTIONS(4654),
    [sym__string] = ACTIONS(4654),
  },
  [2083] = {
    [sym_identifier] = ACTIONS(4646),
    [anon_sym_q_LBRACE] = ACTIONS(4649),
    [anon_sym_LBRACE] = ACTIONS(4649),
    [anon_sym_DOT] = ACTIONS(4649),
    [anon_sym_AMP] = ACTIONS(4649),
    [anon_sym_DASH] = ACTIONS(4646),
    [anon_sym_DASH_DASH] = ACTIONS(4649),
    [anon_sym_PLUS] = ACTIONS(4646),
    [anon_sym_PLUS_PLUS] = ACTIONS(4649),
    [anon_sym_BANG] = ACTIONS(4649),
    [anon_sym_LPAREN] = ACTIONS(4649),
    [anon_sym_RPAREN] = ACTIONS(4649),
    [anon_sym_LBRACK] = ACTIONS(4649),
    [anon_sym_SEMI] = ACTIONS(4649),
    [anon_sym_DOLLAR] = ACTIONS(4649),
    [anon_sym_STAR] = ACTIONS(4649),
    [anon_sym_TILDE] = ACTIONS(4649),
    [sym_bool] = ACTIONS(4646),
    [sym_byte] = ACTIONS(4646),
    [sym_ubyte] = ACTIONS(4646),
    [sym_char] = ACTIONS(4646),
    [sym_short] = ACTIONS(4646),
    [sym_ushort] = ACTIONS(4646),
    [sym_int] = ACTIONS(4646),
    [sym_uint] = ACTIONS(4646),
    [sym_long] = ACTIONS(4646),
    [sym_ulong] = ACTIONS(4646),
    [sym_cent] = ACTIONS(4646),
    [sym_ucent] = ACTIONS(4646),
    [sym_wchar] = ACTIONS(4646),
    [sym_dchar] = ACTIONS(4646),
    [sym_float] = ACTIONS(4646),
    [sym_double] = ACTIONS(4646),
    [sym_real] = ACTIONS(4646),
    [sym_ifloat] = ACTIONS(4646),
    [sym_idouble] = ACTIONS(4646),
    [sym_ireal] = ACTIONS(4646),
    [sym_cfloat] = ACTIONS(4646),
    [sym_cdouble] = ACTIONS(4646),
    [sym_creal] = ACTIONS(4646),
    [sym_size_t] = ACTIONS(4646),
    [sym_ptrdiff_t] = ACTIONS(4646),
    [sym_string] = ACTIONS(4646),
    [sym_cstring] = ACTIONS(4646),
    [sym_dstring] = ACTIONS(4646),
    [sym_wstring] = ACTIONS(4646),
    [sym_noreturn] = ACTIONS(4646),
    [sym_true] = ACTIONS(4646),
    [sym_false] = ACTIONS(4646),
    [sym_null] = ACTIONS(4646),
    [sym_super] = ACTIONS(4646),
    [sym_this] = ACTIONS(4646),
    [sym_assert] = ACTIONS(4646),
    [sym_auto] = ACTIONS(4646),
    [sym_cast] = ACTIONS(4646),
    [sym_catch] = ACTIONS(4646),
    [sym_const] = ACTIONS(4646),
    [sym_delegate] = ACTIONS(4646),
    [sym_delete] = ACTIONS(4646),
    [sym_do] = ACTIONS(4646),
    [sym_else] = ACTIONS(4646),
    [sym_finally] = ACTIONS(4646),
    [sym_function] = ACTIONS(4646),
    [sym_immutable] = ACTIONS(4646),
    [sym_import] = ACTIONS(4646),
    [sym_in] = ACTIONS(4646),
    [sym_inout] = ACTIONS(4646),
    [sym_is] = ACTIONS(4646),
    [sym_mixin] = ACTIONS(4646),
    [sym_new] = ACTIONS(4646),
    [sym_out] = ACTIONS(4646),
    [sym_ref] = ACTIONS(4646),
    [sym_shared] = ACTIONS(4646),
    [sym_throw] = ACTIONS(4646),
    [sym_typeid] = ACTIONS(4646),
    [sym_typeof] = ACTIONS(4646),
    [sym_traits] = ACTIONS(4646),
    [sym_vector] = ACTIONS(4646),
    [sym_void] = ACTIONS(4646),
    [anon_sym_BQUOTE] = ACTIONS(4649),
    [anon_sym_r_DQUOTE] = ACTIONS(4649),
    [anon_sym_x_DQUOTE] = ACTIONS(4649),
    [anon_sym_DQUOTE] = ACTIONS(4649),
    [anon_sym_i_BQUOTE] = ACTIONS(4649),
    [anon_sym_i_DQUOTE] = ACTIONS(4649),
    [anon_sym_iq_LBRACE] = ACTIONS(4649),
    [aux_sym_char_literal_token1] = ACTIONS(4649),
    [anon_sym_SQUOTE] = ACTIONS(4646),
    [anon_sym___DATE__] = ACTIONS(4646),
    [anon_sym___FILE__] = ACTIONS(4646),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4646),
    [anon_sym___FUNCTION__] = ACTIONS(4646),
    [anon_sym___LINE__] = ACTIONS(4646),
    [anon_sym___MODULE__] = ACTIONS(4646),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4646),
    [anon_sym___TIME__] = ACTIONS(4646),
    [anon_sym___TIMESTAMP__] = ACTIONS(4646),
    [anon_sym___VENDOR__] = ACTIONS(4646),
    [anon_sym___VERSION__] = ACTIONS(4646),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4649),
    [sym_float_literal] = ACTIONS(4649),
    [sym__string] = ACTIONS(4649),
  },
  [2084] = {
    [sym_identifier] = ACTIONS(4642),
    [anon_sym_q_LBRACE] = ACTIONS(4644),
    [anon_sym_LBRACE] = ACTIONS(4644),
    [anon_sym_DOT] = ACTIONS(4644),
    [anon_sym_AMP] = ACTIONS(4644),
    [anon_sym_DASH] = ACTIONS(4642),
    [anon_sym_DASH_DASH] = ACTIONS(4644),
    [anon_sym_PLUS] = ACTIONS(4642),
    [anon_sym_PLUS_PLUS] = ACTIONS(4644),
    [anon_sym_BANG] = ACTIONS(4644),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_RPAREN] = ACTIONS(4644),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_SEMI] = ACTIONS(4644),
    [anon_sym_DOLLAR] = ACTIONS(4644),
    [anon_sym_STAR] = ACTIONS(4644),
    [anon_sym_TILDE] = ACTIONS(4644),
    [sym_bool] = ACTIONS(4642),
    [sym_byte] = ACTIONS(4642),
    [sym_ubyte] = ACTIONS(4642),
    [sym_char] = ACTIONS(4642),
    [sym_short] = ACTIONS(4642),
    [sym_ushort] = ACTIONS(4642),
    [sym_int] = ACTIONS(4642),
    [sym_uint] = ACTIONS(4642),
    [sym_long] = ACTIONS(4642),
    [sym_ulong] = ACTIONS(4642),
    [sym_cent] = ACTIONS(4642),
    [sym_ucent] = ACTIONS(4642),
    [sym_wchar] = ACTIONS(4642),
    [sym_dchar] = ACTIONS(4642),
    [sym_float] = ACTIONS(4642),
    [sym_double] = ACTIONS(4642),
    [sym_real] = ACTIONS(4642),
    [sym_ifloat] = ACTIONS(4642),
    [sym_idouble] = ACTIONS(4642),
    [sym_ireal] = ACTIONS(4642),
    [sym_cfloat] = ACTIONS(4642),
    [sym_cdouble] = ACTIONS(4642),
    [sym_creal] = ACTIONS(4642),
    [sym_size_t] = ACTIONS(4642),
    [sym_ptrdiff_t] = ACTIONS(4642),
    [sym_string] = ACTIONS(4642),
    [sym_cstring] = ACTIONS(4642),
    [sym_dstring] = ACTIONS(4642),
    [sym_wstring] = ACTIONS(4642),
    [sym_noreturn] = ACTIONS(4642),
    [sym_true] = ACTIONS(4642),
    [sym_false] = ACTIONS(4642),
    [sym_null] = ACTIONS(4642),
    [sym_super] = ACTIONS(4642),
    [sym_this] = ACTIONS(4642),
    [sym_assert] = ACTIONS(4642),
    [sym_auto] = ACTIONS(4642),
    [sym_cast] = ACTIONS(4642),
    [sym_catch] = ACTIONS(4642),
    [sym_const] = ACTIONS(4642),
    [sym_delegate] = ACTIONS(4642),
    [sym_delete] = ACTIONS(4642),
    [sym_do] = ACTIONS(4642),
    [sym_else] = ACTIONS(4642),
    [sym_finally] = ACTIONS(4642),
    [sym_function] = ACTIONS(4642),
    [sym_immutable] = ACTIONS(4642),
    [sym_import] = ACTIONS(4642),
    [sym_in] = ACTIONS(4642),
    [sym_inout] = ACTIONS(4642),
    [sym_is] = ACTIONS(4642),
    [sym_mixin] = ACTIONS(4642),
    [sym_new] = ACTIONS(4642),
    [sym_out] = ACTIONS(4642),
    [sym_ref] = ACTIONS(4642),
    [sym_shared] = ACTIONS(4642),
    [sym_throw] = ACTIONS(4642),
    [sym_typeid] = ACTIONS(4642),
    [sym_typeof] = ACTIONS(4642),
    [sym_traits] = ACTIONS(4642),
    [sym_vector] = ACTIONS(4642),
    [sym_void] = ACTIONS(4642),
    [anon_sym_BQUOTE] = ACTIONS(4644),
    [anon_sym_r_DQUOTE] = ACTIONS(4644),
    [anon_sym_x_DQUOTE] = ACTIONS(4644),
    [anon_sym_DQUOTE] = ACTIONS(4644),
    [anon_sym_i_BQUOTE] = ACTIONS(4644),
    [anon_sym_i_DQUOTE] = ACTIONS(4644),
    [anon_sym_iq_LBRACE] = ACTIONS(4644),
    [aux_sym_char_literal_token1] = ACTIONS(4644),
    [anon_sym_SQUOTE] = ACTIONS(4642),
    [anon_sym___DATE__] = ACTIONS(4642),
    [anon_sym___FILE__] = ACTIONS(4642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4642),
    [anon_sym___FUNCTION__] = ACTIONS(4642),
    [anon_sym___LINE__] = ACTIONS(4642),
    [anon_sym___MODULE__] = ACTIONS(4642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4642),
    [anon_sym___TIME__] = ACTIONS(4642),
    [anon_sym___TIMESTAMP__] = ACTIONS(4642),
    [anon_sym___VENDOR__] = ACTIONS(4642),
    [anon_sym___VERSION__] = ACTIONS(4642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4644),
    [sym_float_literal] = ACTIONS(4644),
    [sym__string] = ACTIONS(4644),
  },
  [2085] = {
    [sym_identifier] = ACTIONS(4638),
    [anon_sym_q_LBRACE] = ACTIONS(4640),
    [anon_sym_LBRACE] = ACTIONS(4640),
    [anon_sym_DOT] = ACTIONS(4640),
    [anon_sym_AMP] = ACTIONS(4640),
    [anon_sym_DASH] = ACTIONS(4638),
    [anon_sym_DASH_DASH] = ACTIONS(4640),
    [anon_sym_PLUS] = ACTIONS(4638),
    [anon_sym_PLUS_PLUS] = ACTIONS(4640),
    [anon_sym_BANG] = ACTIONS(4640),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_RPAREN] = ACTIONS(4640),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_SEMI] = ACTIONS(4640),
    [anon_sym_DOLLAR] = ACTIONS(4640),
    [anon_sym_STAR] = ACTIONS(4640),
    [anon_sym_TILDE] = ACTIONS(4640),
    [sym_bool] = ACTIONS(4638),
    [sym_byte] = ACTIONS(4638),
    [sym_ubyte] = ACTIONS(4638),
    [sym_char] = ACTIONS(4638),
    [sym_short] = ACTIONS(4638),
    [sym_ushort] = ACTIONS(4638),
    [sym_int] = ACTIONS(4638),
    [sym_uint] = ACTIONS(4638),
    [sym_long] = ACTIONS(4638),
    [sym_ulong] = ACTIONS(4638),
    [sym_cent] = ACTIONS(4638),
    [sym_ucent] = ACTIONS(4638),
    [sym_wchar] = ACTIONS(4638),
    [sym_dchar] = ACTIONS(4638),
    [sym_float] = ACTIONS(4638),
    [sym_double] = ACTIONS(4638),
    [sym_real] = ACTIONS(4638),
    [sym_ifloat] = ACTIONS(4638),
    [sym_idouble] = ACTIONS(4638),
    [sym_ireal] = ACTIONS(4638),
    [sym_cfloat] = ACTIONS(4638),
    [sym_cdouble] = ACTIONS(4638),
    [sym_creal] = ACTIONS(4638),
    [sym_size_t] = ACTIONS(4638),
    [sym_ptrdiff_t] = ACTIONS(4638),
    [sym_string] = ACTIONS(4638),
    [sym_cstring] = ACTIONS(4638),
    [sym_dstring] = ACTIONS(4638),
    [sym_wstring] = ACTIONS(4638),
    [sym_noreturn] = ACTIONS(4638),
    [sym_true] = ACTIONS(4638),
    [sym_false] = ACTIONS(4638),
    [sym_null] = ACTIONS(4638),
    [sym_super] = ACTIONS(4638),
    [sym_this] = ACTIONS(4638),
    [sym_assert] = ACTIONS(4638),
    [sym_auto] = ACTIONS(4638),
    [sym_cast] = ACTIONS(4638),
    [sym_catch] = ACTIONS(4638),
    [sym_const] = ACTIONS(4638),
    [sym_delegate] = ACTIONS(4638),
    [sym_delete] = ACTIONS(4638),
    [sym_do] = ACTIONS(4638),
    [sym_else] = ACTIONS(4638),
    [sym_finally] = ACTIONS(4638),
    [sym_function] = ACTIONS(4638),
    [sym_immutable] = ACTIONS(4638),
    [sym_import] = ACTIONS(4638),
    [sym_in] = ACTIONS(4638),
    [sym_inout] = ACTIONS(4638),
    [sym_is] = ACTIONS(4638),
    [sym_mixin] = ACTIONS(4638),
    [sym_new] = ACTIONS(4638),
    [sym_out] = ACTIONS(4638),
    [sym_ref] = ACTIONS(4638),
    [sym_shared] = ACTIONS(4638),
    [sym_throw] = ACTIONS(4638),
    [sym_typeid] = ACTIONS(4638),
    [sym_typeof] = ACTIONS(4638),
    [sym_traits] = ACTIONS(4638),
    [sym_vector] = ACTIONS(4638),
    [sym_void] = ACTIONS(4638),
    [anon_sym_BQUOTE] = ACTIONS(4640),
    [anon_sym_r_DQUOTE] = ACTIONS(4640),
    [anon_sym_x_DQUOTE] = ACTIONS(4640),
    [anon_sym_DQUOTE] = ACTIONS(4640),
    [anon_sym_i_BQUOTE] = ACTIONS(4640),
    [anon_sym_i_DQUOTE] = ACTIONS(4640),
    [anon_sym_iq_LBRACE] = ACTIONS(4640),
    [aux_sym_char_literal_token1] = ACTIONS(4640),
    [anon_sym_SQUOTE] = ACTIONS(4638),
    [anon_sym___DATE__] = ACTIONS(4638),
    [anon_sym___FILE__] = ACTIONS(4638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4638),
    [anon_sym___FUNCTION__] = ACTIONS(4638),
    [anon_sym___LINE__] = ACTIONS(4638),
    [anon_sym___MODULE__] = ACTIONS(4638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4638),
    [anon_sym___TIME__] = ACTIONS(4638),
    [anon_sym___TIMESTAMP__] = ACTIONS(4638),
    [anon_sym___VENDOR__] = ACTIONS(4638),
    [anon_sym___VERSION__] = ACTIONS(4638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4640),
    [sym_float_literal] = ACTIONS(4640),
    [sym__string] = ACTIONS(4640),
  },
  [2086] = {
    [sym_identifier] = ACTIONS(4630),
    [anon_sym_q_LBRACE] = ACTIONS(4632),
    [anon_sym_LBRACE] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(4632),
    [anon_sym_AMP] = ACTIONS(4632),
    [anon_sym_DASH] = ACTIONS(4630),
    [anon_sym_DASH_DASH] = ACTIONS(4632),
    [anon_sym_PLUS] = ACTIONS(4630),
    [anon_sym_PLUS_PLUS] = ACTIONS(4632),
    [anon_sym_BANG] = ACTIONS(4632),
    [anon_sym_LPAREN] = ACTIONS(4632),
    [anon_sym_RPAREN] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(4632),
    [anon_sym_SEMI] = ACTIONS(4632),
    [anon_sym_DOLLAR] = ACTIONS(4632),
    [anon_sym_STAR] = ACTIONS(4632),
    [anon_sym_TILDE] = ACTIONS(4632),
    [sym_bool] = ACTIONS(4630),
    [sym_byte] = ACTIONS(4630),
    [sym_ubyte] = ACTIONS(4630),
    [sym_char] = ACTIONS(4630),
    [sym_short] = ACTIONS(4630),
    [sym_ushort] = ACTIONS(4630),
    [sym_int] = ACTIONS(4630),
    [sym_uint] = ACTIONS(4630),
    [sym_long] = ACTIONS(4630),
    [sym_ulong] = ACTIONS(4630),
    [sym_cent] = ACTIONS(4630),
    [sym_ucent] = ACTIONS(4630),
    [sym_wchar] = ACTIONS(4630),
    [sym_dchar] = ACTIONS(4630),
    [sym_float] = ACTIONS(4630),
    [sym_double] = ACTIONS(4630),
    [sym_real] = ACTIONS(4630),
    [sym_ifloat] = ACTIONS(4630),
    [sym_idouble] = ACTIONS(4630),
    [sym_ireal] = ACTIONS(4630),
    [sym_cfloat] = ACTIONS(4630),
    [sym_cdouble] = ACTIONS(4630),
    [sym_creal] = ACTIONS(4630),
    [sym_size_t] = ACTIONS(4630),
    [sym_ptrdiff_t] = ACTIONS(4630),
    [sym_string] = ACTIONS(4630),
    [sym_cstring] = ACTIONS(4630),
    [sym_dstring] = ACTIONS(4630),
    [sym_wstring] = ACTIONS(4630),
    [sym_noreturn] = ACTIONS(4630),
    [sym_true] = ACTIONS(4630),
    [sym_false] = ACTIONS(4630),
    [sym_null] = ACTIONS(4630),
    [sym_super] = ACTIONS(4630),
    [sym_this] = ACTIONS(4630),
    [sym_assert] = ACTIONS(4630),
    [sym_auto] = ACTIONS(4630),
    [sym_cast] = ACTIONS(4630),
    [sym_catch] = ACTIONS(4630),
    [sym_const] = ACTIONS(4630),
    [sym_delegate] = ACTIONS(4630),
    [sym_delete] = ACTIONS(4630),
    [sym_do] = ACTIONS(4630),
    [sym_else] = ACTIONS(4630),
    [sym_finally] = ACTIONS(4630),
    [sym_function] = ACTIONS(4630),
    [sym_immutable] = ACTIONS(4630),
    [sym_import] = ACTIONS(4630),
    [sym_in] = ACTIONS(4630),
    [sym_inout] = ACTIONS(4630),
    [sym_is] = ACTIONS(4630),
    [sym_mixin] = ACTIONS(4630),
    [sym_new] = ACTIONS(4630),
    [sym_out] = ACTIONS(4630),
    [sym_ref] = ACTIONS(4630),
    [sym_shared] = ACTIONS(4630),
    [sym_throw] = ACTIONS(4630),
    [sym_typeid] = ACTIONS(4630),
    [sym_typeof] = ACTIONS(4630),
    [sym_traits] = ACTIONS(4630),
    [sym_vector] = ACTIONS(4630),
    [sym_void] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(4632),
    [anon_sym_r_DQUOTE] = ACTIONS(4632),
    [anon_sym_x_DQUOTE] = ACTIONS(4632),
    [anon_sym_DQUOTE] = ACTIONS(4632),
    [anon_sym_i_BQUOTE] = ACTIONS(4632),
    [anon_sym_i_DQUOTE] = ACTIONS(4632),
    [anon_sym_iq_LBRACE] = ACTIONS(4632),
    [aux_sym_char_literal_token1] = ACTIONS(4632),
    [anon_sym_SQUOTE] = ACTIONS(4630),
    [anon_sym___DATE__] = ACTIONS(4630),
    [anon_sym___FILE__] = ACTIONS(4630),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4630),
    [anon_sym___FUNCTION__] = ACTIONS(4630),
    [anon_sym___LINE__] = ACTIONS(4630),
    [anon_sym___MODULE__] = ACTIONS(4630),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4630),
    [anon_sym___TIME__] = ACTIONS(4630),
    [anon_sym___TIMESTAMP__] = ACTIONS(4630),
    [anon_sym___VENDOR__] = ACTIONS(4630),
    [anon_sym___VERSION__] = ACTIONS(4630),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4632),
    [sym_float_literal] = ACTIONS(4632),
    [sym__string] = ACTIONS(4632),
  },
  [2087] = {
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_q_LBRACE] = ACTIONS(4472),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_DOT] = ACTIONS(4472),
    [anon_sym_AMP] = ACTIONS(4472),
    [anon_sym_DASH] = ACTIONS(4470),
    [anon_sym_DASH_DASH] = ACTIONS(4472),
    [anon_sym_PLUS] = ACTIONS(4470),
    [anon_sym_PLUS_PLUS] = ACTIONS(4472),
    [anon_sym_BANG] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_RPAREN] = ACTIONS(4472),
    [anon_sym_LBRACK] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_DOLLAR] = ACTIONS(4472),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [sym_bool] = ACTIONS(4470),
    [sym_byte] = ACTIONS(4470),
    [sym_ubyte] = ACTIONS(4470),
    [sym_char] = ACTIONS(4470),
    [sym_short] = ACTIONS(4470),
    [sym_ushort] = ACTIONS(4470),
    [sym_int] = ACTIONS(4470),
    [sym_uint] = ACTIONS(4470),
    [sym_long] = ACTIONS(4470),
    [sym_ulong] = ACTIONS(4470),
    [sym_cent] = ACTIONS(4470),
    [sym_ucent] = ACTIONS(4470),
    [sym_wchar] = ACTIONS(4470),
    [sym_dchar] = ACTIONS(4470),
    [sym_float] = ACTIONS(4470),
    [sym_double] = ACTIONS(4470),
    [sym_real] = ACTIONS(4470),
    [sym_ifloat] = ACTIONS(4470),
    [sym_idouble] = ACTIONS(4470),
    [sym_ireal] = ACTIONS(4470),
    [sym_cfloat] = ACTIONS(4470),
    [sym_cdouble] = ACTIONS(4470),
    [sym_creal] = ACTIONS(4470),
    [sym_size_t] = ACTIONS(4470),
    [sym_ptrdiff_t] = ACTIONS(4470),
    [sym_string] = ACTIONS(4470),
    [sym_cstring] = ACTIONS(4470),
    [sym_dstring] = ACTIONS(4470),
    [sym_wstring] = ACTIONS(4470),
    [sym_noreturn] = ACTIONS(4470),
    [sym_true] = ACTIONS(4470),
    [sym_false] = ACTIONS(4470),
    [sym_null] = ACTIONS(4470),
    [sym_super] = ACTIONS(4470),
    [sym_this] = ACTIONS(4470),
    [sym_assert] = ACTIONS(4470),
    [sym_auto] = ACTIONS(4470),
    [sym_cast] = ACTIONS(4470),
    [sym_catch] = ACTIONS(4470),
    [sym_const] = ACTIONS(4470),
    [sym_delegate] = ACTIONS(4470),
    [sym_delete] = ACTIONS(4470),
    [sym_do] = ACTIONS(4470),
    [sym_else] = ACTIONS(4470),
    [sym_finally] = ACTIONS(4470),
    [sym_function] = ACTIONS(4470),
    [sym_immutable] = ACTIONS(4470),
    [sym_import] = ACTIONS(4470),
    [sym_in] = ACTIONS(4470),
    [sym_inout] = ACTIONS(4470),
    [sym_is] = ACTIONS(4470),
    [sym_mixin] = ACTIONS(4470),
    [sym_new] = ACTIONS(4470),
    [sym_out] = ACTIONS(4470),
    [sym_ref] = ACTIONS(4470),
    [sym_shared] = ACTIONS(4470),
    [sym_throw] = ACTIONS(4470),
    [sym_typeid] = ACTIONS(4470),
    [sym_typeof] = ACTIONS(4470),
    [sym_traits] = ACTIONS(4470),
    [sym_vector] = ACTIONS(4470),
    [sym_void] = ACTIONS(4470),
    [anon_sym_BQUOTE] = ACTIONS(4472),
    [anon_sym_r_DQUOTE] = ACTIONS(4472),
    [anon_sym_x_DQUOTE] = ACTIONS(4472),
    [anon_sym_DQUOTE] = ACTIONS(4472),
    [anon_sym_i_BQUOTE] = ACTIONS(4472),
    [anon_sym_i_DQUOTE] = ACTIONS(4472),
    [anon_sym_iq_LBRACE] = ACTIONS(4472),
    [aux_sym_char_literal_token1] = ACTIONS(4472),
    [anon_sym_SQUOTE] = ACTIONS(4470),
    [anon_sym___DATE__] = ACTIONS(4470),
    [anon_sym___FILE__] = ACTIONS(4470),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4470),
    [anon_sym___FUNCTION__] = ACTIONS(4470),
    [anon_sym___LINE__] = ACTIONS(4470),
    [anon_sym___MODULE__] = ACTIONS(4470),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4470),
    [anon_sym___TIME__] = ACTIONS(4470),
    [anon_sym___TIMESTAMP__] = ACTIONS(4470),
    [anon_sym___VENDOR__] = ACTIONS(4470),
    [anon_sym___VERSION__] = ACTIONS(4470),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4472),
    [sym_float_literal] = ACTIONS(4472),
    [sym__string] = ACTIONS(4472),
  },
  [2088] = {
    [sym_identifier] = ACTIONS(4626),
    [anon_sym_q_LBRACE] = ACTIONS(4628),
    [anon_sym_LBRACE] = ACTIONS(4628),
    [anon_sym_DOT] = ACTIONS(4628),
    [anon_sym_AMP] = ACTIONS(4628),
    [anon_sym_DASH] = ACTIONS(4626),
    [anon_sym_DASH_DASH] = ACTIONS(4628),
    [anon_sym_PLUS] = ACTIONS(4626),
    [anon_sym_PLUS_PLUS] = ACTIONS(4628),
    [anon_sym_BANG] = ACTIONS(4628),
    [anon_sym_LPAREN] = ACTIONS(4628),
    [anon_sym_RPAREN] = ACTIONS(4628),
    [anon_sym_LBRACK] = ACTIONS(4628),
    [anon_sym_SEMI] = ACTIONS(4628),
    [anon_sym_DOLLAR] = ACTIONS(4628),
    [anon_sym_STAR] = ACTIONS(4628),
    [anon_sym_TILDE] = ACTIONS(4628),
    [sym_bool] = ACTIONS(4626),
    [sym_byte] = ACTIONS(4626),
    [sym_ubyte] = ACTIONS(4626),
    [sym_char] = ACTIONS(4626),
    [sym_short] = ACTIONS(4626),
    [sym_ushort] = ACTIONS(4626),
    [sym_int] = ACTIONS(4626),
    [sym_uint] = ACTIONS(4626),
    [sym_long] = ACTIONS(4626),
    [sym_ulong] = ACTIONS(4626),
    [sym_cent] = ACTIONS(4626),
    [sym_ucent] = ACTIONS(4626),
    [sym_wchar] = ACTIONS(4626),
    [sym_dchar] = ACTIONS(4626),
    [sym_float] = ACTIONS(4626),
    [sym_double] = ACTIONS(4626),
    [sym_real] = ACTIONS(4626),
    [sym_ifloat] = ACTIONS(4626),
    [sym_idouble] = ACTIONS(4626),
    [sym_ireal] = ACTIONS(4626),
    [sym_cfloat] = ACTIONS(4626),
    [sym_cdouble] = ACTIONS(4626),
    [sym_creal] = ACTIONS(4626),
    [sym_size_t] = ACTIONS(4626),
    [sym_ptrdiff_t] = ACTIONS(4626),
    [sym_string] = ACTIONS(4626),
    [sym_cstring] = ACTIONS(4626),
    [sym_dstring] = ACTIONS(4626),
    [sym_wstring] = ACTIONS(4626),
    [sym_noreturn] = ACTIONS(4626),
    [sym_true] = ACTIONS(4626),
    [sym_false] = ACTIONS(4626),
    [sym_null] = ACTIONS(4626),
    [sym_super] = ACTIONS(4626),
    [sym_this] = ACTIONS(4626),
    [sym_assert] = ACTIONS(4626),
    [sym_auto] = ACTIONS(4626),
    [sym_cast] = ACTIONS(4626),
    [sym_catch] = ACTIONS(4626),
    [sym_const] = ACTIONS(4626),
    [sym_delegate] = ACTIONS(4626),
    [sym_delete] = ACTIONS(4626),
    [sym_do] = ACTIONS(4626),
    [sym_else] = ACTIONS(4626),
    [sym_finally] = ACTIONS(4626),
    [sym_function] = ACTIONS(4626),
    [sym_immutable] = ACTIONS(4626),
    [sym_import] = ACTIONS(4626),
    [sym_in] = ACTIONS(4626),
    [sym_inout] = ACTIONS(4626),
    [sym_is] = ACTIONS(4626),
    [sym_mixin] = ACTIONS(4626),
    [sym_new] = ACTIONS(4626),
    [sym_out] = ACTIONS(4626),
    [sym_ref] = ACTIONS(4626),
    [sym_shared] = ACTIONS(4626),
    [sym_throw] = ACTIONS(4626),
    [sym_typeid] = ACTIONS(4626),
    [sym_typeof] = ACTIONS(4626),
    [sym_traits] = ACTIONS(4626),
    [sym_vector] = ACTIONS(4626),
    [sym_void] = ACTIONS(4626),
    [anon_sym_BQUOTE] = ACTIONS(4628),
    [anon_sym_r_DQUOTE] = ACTIONS(4628),
    [anon_sym_x_DQUOTE] = ACTIONS(4628),
    [anon_sym_DQUOTE] = ACTIONS(4628),
    [anon_sym_i_BQUOTE] = ACTIONS(4628),
    [anon_sym_i_DQUOTE] = ACTIONS(4628),
    [anon_sym_iq_LBRACE] = ACTIONS(4628),
    [aux_sym_char_literal_token1] = ACTIONS(4628),
    [anon_sym_SQUOTE] = ACTIONS(4626),
    [anon_sym___DATE__] = ACTIONS(4626),
    [anon_sym___FILE__] = ACTIONS(4626),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4626),
    [anon_sym___FUNCTION__] = ACTIONS(4626),
    [anon_sym___LINE__] = ACTIONS(4626),
    [anon_sym___MODULE__] = ACTIONS(4626),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4626),
    [anon_sym___TIME__] = ACTIONS(4626),
    [anon_sym___TIMESTAMP__] = ACTIONS(4626),
    [anon_sym___VENDOR__] = ACTIONS(4626),
    [anon_sym___VERSION__] = ACTIONS(4626),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4628),
    [sym_float_literal] = ACTIONS(4628),
    [sym__string] = ACTIONS(4628),
  },
  [2089] = {
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_q_LBRACE] = ACTIONS(4709),
    [anon_sym_LBRACE] = ACTIONS(4709),
    [anon_sym_DOT] = ACTIONS(4709),
    [anon_sym_AMP] = ACTIONS(4709),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_DASH_DASH] = ACTIONS(4709),
    [anon_sym_PLUS] = ACTIONS(4707),
    [anon_sym_PLUS_PLUS] = ACTIONS(4709),
    [anon_sym_BANG] = ACTIONS(4709),
    [anon_sym_LPAREN] = ACTIONS(4709),
    [anon_sym_RPAREN] = ACTIONS(4709),
    [anon_sym_LBRACK] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym_DOLLAR] = ACTIONS(4709),
    [anon_sym_STAR] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [sym_bool] = ACTIONS(4707),
    [sym_byte] = ACTIONS(4707),
    [sym_ubyte] = ACTIONS(4707),
    [sym_char] = ACTIONS(4707),
    [sym_short] = ACTIONS(4707),
    [sym_ushort] = ACTIONS(4707),
    [sym_int] = ACTIONS(4707),
    [sym_uint] = ACTIONS(4707),
    [sym_long] = ACTIONS(4707),
    [sym_ulong] = ACTIONS(4707),
    [sym_cent] = ACTIONS(4707),
    [sym_ucent] = ACTIONS(4707),
    [sym_wchar] = ACTIONS(4707),
    [sym_dchar] = ACTIONS(4707),
    [sym_float] = ACTIONS(4707),
    [sym_double] = ACTIONS(4707),
    [sym_real] = ACTIONS(4707),
    [sym_ifloat] = ACTIONS(4707),
    [sym_idouble] = ACTIONS(4707),
    [sym_ireal] = ACTIONS(4707),
    [sym_cfloat] = ACTIONS(4707),
    [sym_cdouble] = ACTIONS(4707),
    [sym_creal] = ACTIONS(4707),
    [sym_size_t] = ACTIONS(4707),
    [sym_ptrdiff_t] = ACTIONS(4707),
    [sym_string] = ACTIONS(4707),
    [sym_cstring] = ACTIONS(4707),
    [sym_dstring] = ACTIONS(4707),
    [sym_wstring] = ACTIONS(4707),
    [sym_noreturn] = ACTIONS(4707),
    [sym_true] = ACTIONS(4707),
    [sym_false] = ACTIONS(4707),
    [sym_null] = ACTIONS(4707),
    [sym_super] = ACTIONS(4707),
    [sym_this] = ACTIONS(4707),
    [sym_assert] = ACTIONS(4707),
    [sym_auto] = ACTIONS(4707),
    [sym_cast] = ACTIONS(4707),
    [sym_catch] = ACTIONS(4707),
    [sym_const] = ACTIONS(4707),
    [sym_delegate] = ACTIONS(4707),
    [sym_delete] = ACTIONS(4707),
    [sym_do] = ACTIONS(4707),
    [sym_else] = ACTIONS(4707),
    [sym_finally] = ACTIONS(4707),
    [sym_function] = ACTIONS(4707),
    [sym_immutable] = ACTIONS(4707),
    [sym_import] = ACTIONS(4707),
    [sym_in] = ACTIONS(4707),
    [sym_inout] = ACTIONS(4707),
    [sym_is] = ACTIONS(4707),
    [sym_mixin] = ACTIONS(4707),
    [sym_new] = ACTIONS(4707),
    [sym_out] = ACTIONS(4707),
    [sym_ref] = ACTIONS(4707),
    [sym_shared] = ACTIONS(4707),
    [sym_throw] = ACTIONS(4707),
    [sym_typeid] = ACTIONS(4707),
    [sym_typeof] = ACTIONS(4707),
    [sym_traits] = ACTIONS(4707),
    [sym_vector] = ACTIONS(4707),
    [sym_void] = ACTIONS(4707),
    [anon_sym_BQUOTE] = ACTIONS(4709),
    [anon_sym_r_DQUOTE] = ACTIONS(4709),
    [anon_sym_x_DQUOTE] = ACTIONS(4709),
    [anon_sym_DQUOTE] = ACTIONS(4709),
    [anon_sym_i_BQUOTE] = ACTIONS(4709),
    [anon_sym_i_DQUOTE] = ACTIONS(4709),
    [anon_sym_iq_LBRACE] = ACTIONS(4709),
    [aux_sym_char_literal_token1] = ACTIONS(4709),
    [anon_sym_SQUOTE] = ACTIONS(4707),
    [anon_sym___DATE__] = ACTIONS(4707),
    [anon_sym___FILE__] = ACTIONS(4707),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4707),
    [anon_sym___FUNCTION__] = ACTIONS(4707),
    [anon_sym___LINE__] = ACTIONS(4707),
    [anon_sym___MODULE__] = ACTIONS(4707),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4707),
    [anon_sym___TIME__] = ACTIONS(4707),
    [anon_sym___TIMESTAMP__] = ACTIONS(4707),
    [anon_sym___VENDOR__] = ACTIONS(4707),
    [anon_sym___VERSION__] = ACTIONS(4707),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4709),
    [sym_float_literal] = ACTIONS(4709),
    [sym__string] = ACTIONS(4709),
  },
  [2090] = {
    [sym_identifier] = ACTIONS(4697),
    [anon_sym_q_LBRACE] = ACTIONS(4699),
    [anon_sym_LBRACE] = ACTIONS(4699),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_AMP] = ACTIONS(4699),
    [anon_sym_DASH] = ACTIONS(4697),
    [anon_sym_DASH_DASH] = ACTIONS(4699),
    [anon_sym_PLUS] = ACTIONS(4697),
    [anon_sym_PLUS_PLUS] = ACTIONS(4699),
    [anon_sym_BANG] = ACTIONS(4699),
    [anon_sym_LPAREN] = ACTIONS(4699),
    [anon_sym_RPAREN] = ACTIONS(4699),
    [anon_sym_LBRACK] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4699),
    [anon_sym_DOLLAR] = ACTIONS(4699),
    [anon_sym_STAR] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4699),
    [sym_bool] = ACTIONS(4697),
    [sym_byte] = ACTIONS(4697),
    [sym_ubyte] = ACTIONS(4697),
    [sym_char] = ACTIONS(4697),
    [sym_short] = ACTIONS(4697),
    [sym_ushort] = ACTIONS(4697),
    [sym_int] = ACTIONS(4697),
    [sym_uint] = ACTIONS(4697),
    [sym_long] = ACTIONS(4697),
    [sym_ulong] = ACTIONS(4697),
    [sym_cent] = ACTIONS(4697),
    [sym_ucent] = ACTIONS(4697),
    [sym_wchar] = ACTIONS(4697),
    [sym_dchar] = ACTIONS(4697),
    [sym_float] = ACTIONS(4697),
    [sym_double] = ACTIONS(4697),
    [sym_real] = ACTIONS(4697),
    [sym_ifloat] = ACTIONS(4697),
    [sym_idouble] = ACTIONS(4697),
    [sym_ireal] = ACTIONS(4697),
    [sym_cfloat] = ACTIONS(4697),
    [sym_cdouble] = ACTIONS(4697),
    [sym_creal] = ACTIONS(4697),
    [sym_size_t] = ACTIONS(4697),
    [sym_ptrdiff_t] = ACTIONS(4697),
    [sym_string] = ACTIONS(4697),
    [sym_cstring] = ACTIONS(4697),
    [sym_dstring] = ACTIONS(4697),
    [sym_wstring] = ACTIONS(4697),
    [sym_noreturn] = ACTIONS(4697),
    [sym_true] = ACTIONS(4697),
    [sym_false] = ACTIONS(4697),
    [sym_null] = ACTIONS(4697),
    [sym_super] = ACTIONS(4697),
    [sym_this] = ACTIONS(4697),
    [sym_assert] = ACTIONS(4697),
    [sym_auto] = ACTIONS(4697),
    [sym_cast] = ACTIONS(4697),
    [sym_catch] = ACTIONS(4697),
    [sym_const] = ACTIONS(4697),
    [sym_delegate] = ACTIONS(4697),
    [sym_delete] = ACTIONS(4697),
    [sym_do] = ACTIONS(4697),
    [sym_else] = ACTIONS(4697),
    [sym_finally] = ACTIONS(4697),
    [sym_function] = ACTIONS(4697),
    [sym_immutable] = ACTIONS(4697),
    [sym_import] = ACTIONS(4697),
    [sym_in] = ACTIONS(4697),
    [sym_inout] = ACTIONS(4697),
    [sym_is] = ACTIONS(4697),
    [sym_mixin] = ACTIONS(4697),
    [sym_new] = ACTIONS(4697),
    [sym_out] = ACTIONS(4697),
    [sym_ref] = ACTIONS(4697),
    [sym_shared] = ACTIONS(4697),
    [sym_throw] = ACTIONS(4697),
    [sym_typeid] = ACTIONS(4697),
    [sym_typeof] = ACTIONS(4697),
    [sym_traits] = ACTIONS(4697),
    [sym_vector] = ACTIONS(4697),
    [sym_void] = ACTIONS(4697),
    [anon_sym_BQUOTE] = ACTIONS(4699),
    [anon_sym_r_DQUOTE] = ACTIONS(4699),
    [anon_sym_x_DQUOTE] = ACTIONS(4699),
    [anon_sym_DQUOTE] = ACTIONS(4699),
    [anon_sym_i_BQUOTE] = ACTIONS(4699),
    [anon_sym_i_DQUOTE] = ACTIONS(4699),
    [anon_sym_iq_LBRACE] = ACTIONS(4699),
    [aux_sym_char_literal_token1] = ACTIONS(4699),
    [anon_sym_SQUOTE] = ACTIONS(4697),
    [anon_sym___DATE__] = ACTIONS(4697),
    [anon_sym___FILE__] = ACTIONS(4697),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4697),
    [anon_sym___FUNCTION__] = ACTIONS(4697),
    [anon_sym___LINE__] = ACTIONS(4697),
    [anon_sym___MODULE__] = ACTIONS(4697),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4697),
    [anon_sym___TIME__] = ACTIONS(4697),
    [anon_sym___TIMESTAMP__] = ACTIONS(4697),
    [anon_sym___VENDOR__] = ACTIONS(4697),
    [anon_sym___VERSION__] = ACTIONS(4697),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4699),
    [sym_float_literal] = ACTIONS(4699),
    [sym__string] = ACTIONS(4699),
  },
  [2091] = {
    [sym_identifier] = ACTIONS(4660),
    [anon_sym_q_LBRACE] = ACTIONS(4662),
    [anon_sym_LBRACE] = ACTIONS(4662),
    [anon_sym_DOT] = ACTIONS(4662),
    [anon_sym_AMP] = ACTIONS(4662),
    [anon_sym_DASH] = ACTIONS(4660),
    [anon_sym_DASH_DASH] = ACTIONS(4662),
    [anon_sym_PLUS] = ACTIONS(4660),
    [anon_sym_PLUS_PLUS] = ACTIONS(4662),
    [anon_sym_BANG] = ACTIONS(4662),
    [anon_sym_LPAREN] = ACTIONS(4662),
    [anon_sym_RPAREN] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(4662),
    [anon_sym_SEMI] = ACTIONS(4662),
    [anon_sym_DOLLAR] = ACTIONS(4662),
    [anon_sym_STAR] = ACTIONS(4662),
    [anon_sym_TILDE] = ACTIONS(4662),
    [sym_bool] = ACTIONS(4660),
    [sym_byte] = ACTIONS(4660),
    [sym_ubyte] = ACTIONS(4660),
    [sym_char] = ACTIONS(4660),
    [sym_short] = ACTIONS(4660),
    [sym_ushort] = ACTIONS(4660),
    [sym_int] = ACTIONS(4660),
    [sym_uint] = ACTIONS(4660),
    [sym_long] = ACTIONS(4660),
    [sym_ulong] = ACTIONS(4660),
    [sym_cent] = ACTIONS(4660),
    [sym_ucent] = ACTIONS(4660),
    [sym_wchar] = ACTIONS(4660),
    [sym_dchar] = ACTIONS(4660),
    [sym_float] = ACTIONS(4660),
    [sym_double] = ACTIONS(4660),
    [sym_real] = ACTIONS(4660),
    [sym_ifloat] = ACTIONS(4660),
    [sym_idouble] = ACTIONS(4660),
    [sym_ireal] = ACTIONS(4660),
    [sym_cfloat] = ACTIONS(4660),
    [sym_cdouble] = ACTIONS(4660),
    [sym_creal] = ACTIONS(4660),
    [sym_size_t] = ACTIONS(4660),
    [sym_ptrdiff_t] = ACTIONS(4660),
    [sym_string] = ACTIONS(4660),
    [sym_cstring] = ACTIONS(4660),
    [sym_dstring] = ACTIONS(4660),
    [sym_wstring] = ACTIONS(4660),
    [sym_noreturn] = ACTIONS(4660),
    [sym_true] = ACTIONS(4660),
    [sym_false] = ACTIONS(4660),
    [sym_null] = ACTIONS(4660),
    [sym_super] = ACTIONS(4660),
    [sym_this] = ACTIONS(4660),
    [sym_assert] = ACTIONS(4660),
    [sym_auto] = ACTIONS(4660),
    [sym_cast] = ACTIONS(4660),
    [sym_catch] = ACTIONS(4660),
    [sym_const] = ACTIONS(4660),
    [sym_delegate] = ACTIONS(4660),
    [sym_delete] = ACTIONS(4660),
    [sym_do] = ACTIONS(4660),
    [sym_else] = ACTIONS(4660),
    [sym_finally] = ACTIONS(4660),
    [sym_function] = ACTIONS(4660),
    [sym_immutable] = ACTIONS(4660),
    [sym_import] = ACTIONS(4660),
    [sym_in] = ACTIONS(4660),
    [sym_inout] = ACTIONS(4660),
    [sym_is] = ACTIONS(4660),
    [sym_mixin] = ACTIONS(4660),
    [sym_new] = ACTIONS(4660),
    [sym_out] = ACTIONS(4660),
    [sym_ref] = ACTIONS(4660),
    [sym_shared] = ACTIONS(4660),
    [sym_throw] = ACTIONS(4660),
    [sym_typeid] = ACTIONS(4660),
    [sym_typeof] = ACTIONS(4660),
    [sym_traits] = ACTIONS(4660),
    [sym_vector] = ACTIONS(4660),
    [sym_void] = ACTIONS(4660),
    [anon_sym_BQUOTE] = ACTIONS(4662),
    [anon_sym_r_DQUOTE] = ACTIONS(4662),
    [anon_sym_x_DQUOTE] = ACTIONS(4662),
    [anon_sym_DQUOTE] = ACTIONS(4662),
    [anon_sym_i_BQUOTE] = ACTIONS(4662),
    [anon_sym_i_DQUOTE] = ACTIONS(4662),
    [anon_sym_iq_LBRACE] = ACTIONS(4662),
    [aux_sym_char_literal_token1] = ACTIONS(4662),
    [anon_sym_SQUOTE] = ACTIONS(4660),
    [anon_sym___DATE__] = ACTIONS(4660),
    [anon_sym___FILE__] = ACTIONS(4660),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4660),
    [anon_sym___FUNCTION__] = ACTIONS(4660),
    [anon_sym___LINE__] = ACTIONS(4660),
    [anon_sym___MODULE__] = ACTIONS(4660),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4660),
    [anon_sym___TIME__] = ACTIONS(4660),
    [anon_sym___TIMESTAMP__] = ACTIONS(4660),
    [anon_sym___VENDOR__] = ACTIONS(4660),
    [anon_sym___VERSION__] = ACTIONS(4660),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4662),
    [sym_float_literal] = ACTIONS(4662),
    [sym__string] = ACTIONS(4662),
  },
  [2092] = {
    [sym_identifier] = ACTIONS(4634),
    [anon_sym_q_LBRACE] = ACTIONS(4636),
    [anon_sym_LBRACE] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4636),
    [anon_sym_AMP] = ACTIONS(4636),
    [anon_sym_DASH] = ACTIONS(4634),
    [anon_sym_DASH_DASH] = ACTIONS(4636),
    [anon_sym_PLUS] = ACTIONS(4634),
    [anon_sym_PLUS_PLUS] = ACTIONS(4636),
    [anon_sym_BANG] = ACTIONS(4636),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_RPAREN] = ACTIONS(4636),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_DOLLAR] = ACTIONS(4636),
    [anon_sym_STAR] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [sym_bool] = ACTIONS(4634),
    [sym_byte] = ACTIONS(4634),
    [sym_ubyte] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_short] = ACTIONS(4634),
    [sym_ushort] = ACTIONS(4634),
    [sym_int] = ACTIONS(4634),
    [sym_uint] = ACTIONS(4634),
    [sym_long] = ACTIONS(4634),
    [sym_ulong] = ACTIONS(4634),
    [sym_cent] = ACTIONS(4634),
    [sym_ucent] = ACTIONS(4634),
    [sym_wchar] = ACTIONS(4634),
    [sym_dchar] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_double] = ACTIONS(4634),
    [sym_real] = ACTIONS(4634),
    [sym_ifloat] = ACTIONS(4634),
    [sym_idouble] = ACTIONS(4634),
    [sym_ireal] = ACTIONS(4634),
    [sym_cfloat] = ACTIONS(4634),
    [sym_cdouble] = ACTIONS(4634),
    [sym_creal] = ACTIONS(4634),
    [sym_size_t] = ACTIONS(4634),
    [sym_ptrdiff_t] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym_cstring] = ACTIONS(4634),
    [sym_dstring] = ACTIONS(4634),
    [sym_wstring] = ACTIONS(4634),
    [sym_noreturn] = ACTIONS(4634),
    [sym_true] = ACTIONS(4634),
    [sym_false] = ACTIONS(4634),
    [sym_null] = ACTIONS(4634),
    [sym_super] = ACTIONS(4634),
    [sym_this] = ACTIONS(4634),
    [sym_assert] = ACTIONS(4634),
    [sym_auto] = ACTIONS(4634),
    [sym_cast] = ACTIONS(4634),
    [sym_catch] = ACTIONS(4634),
    [sym_const] = ACTIONS(4634),
    [sym_delegate] = ACTIONS(4634),
    [sym_delete] = ACTIONS(4634),
    [sym_do] = ACTIONS(4634),
    [sym_else] = ACTIONS(4634),
    [sym_finally] = ACTIONS(4634),
    [sym_function] = ACTIONS(4634),
    [sym_immutable] = ACTIONS(4634),
    [sym_import] = ACTIONS(4634),
    [sym_in] = ACTIONS(4634),
    [sym_inout] = ACTIONS(4634),
    [sym_is] = ACTIONS(4634),
    [sym_mixin] = ACTIONS(4634),
    [sym_new] = ACTIONS(4634),
    [sym_out] = ACTIONS(4634),
    [sym_ref] = ACTIONS(4634),
    [sym_shared] = ACTIONS(4634),
    [sym_throw] = ACTIONS(4634),
    [sym_typeid] = ACTIONS(4634),
    [sym_typeof] = ACTIONS(4634),
    [sym_traits] = ACTIONS(4634),
    [sym_vector] = ACTIONS(4634),
    [sym_void] = ACTIONS(4634),
    [anon_sym_BQUOTE] = ACTIONS(4636),
    [anon_sym_r_DQUOTE] = ACTIONS(4636),
    [anon_sym_x_DQUOTE] = ACTIONS(4636),
    [anon_sym_DQUOTE] = ACTIONS(4636),
    [anon_sym_i_BQUOTE] = ACTIONS(4636),
    [anon_sym_i_DQUOTE] = ACTIONS(4636),
    [anon_sym_iq_LBRACE] = ACTIONS(4636),
    [aux_sym_char_literal_token1] = ACTIONS(4636),
    [anon_sym_SQUOTE] = ACTIONS(4634),
    [anon_sym___DATE__] = ACTIONS(4634),
    [anon_sym___FILE__] = ACTIONS(4634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4634),
    [anon_sym___FUNCTION__] = ACTIONS(4634),
    [anon_sym___LINE__] = ACTIONS(4634),
    [anon_sym___MODULE__] = ACTIONS(4634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4634),
    [anon_sym___TIME__] = ACTIONS(4634),
    [anon_sym___TIMESTAMP__] = ACTIONS(4634),
    [anon_sym___VENDOR__] = ACTIONS(4634),
    [anon_sym___VERSION__] = ACTIONS(4634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4636),
    [sym_float_literal] = ACTIONS(4636),
    [sym__string] = ACTIONS(4636),
  },
  [2093] = {
    [sym_identifier] = ACTIONS(4598),
    [anon_sym_q_LBRACE] = ACTIONS(4600),
    [anon_sym_LBRACE] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4600),
    [anon_sym_AMP] = ACTIONS(4600),
    [anon_sym_DASH] = ACTIONS(4598),
    [anon_sym_DASH_DASH] = ACTIONS(4600),
    [anon_sym_PLUS] = ACTIONS(4598),
    [anon_sym_PLUS_PLUS] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4600),
    [anon_sym_LPAREN] = ACTIONS(4600),
    [anon_sym_RPAREN] = ACTIONS(4600),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_DOLLAR] = ACTIONS(4600),
    [anon_sym_STAR] = ACTIONS(4600),
    [anon_sym_TILDE] = ACTIONS(4600),
    [sym_bool] = ACTIONS(4598),
    [sym_byte] = ACTIONS(4598),
    [sym_ubyte] = ACTIONS(4598),
    [sym_char] = ACTIONS(4598),
    [sym_short] = ACTIONS(4598),
    [sym_ushort] = ACTIONS(4598),
    [sym_int] = ACTIONS(4598),
    [sym_uint] = ACTIONS(4598),
    [sym_long] = ACTIONS(4598),
    [sym_ulong] = ACTIONS(4598),
    [sym_cent] = ACTIONS(4598),
    [sym_ucent] = ACTIONS(4598),
    [sym_wchar] = ACTIONS(4598),
    [sym_dchar] = ACTIONS(4598),
    [sym_float] = ACTIONS(4598),
    [sym_double] = ACTIONS(4598),
    [sym_real] = ACTIONS(4598),
    [sym_ifloat] = ACTIONS(4598),
    [sym_idouble] = ACTIONS(4598),
    [sym_ireal] = ACTIONS(4598),
    [sym_cfloat] = ACTIONS(4598),
    [sym_cdouble] = ACTIONS(4598),
    [sym_creal] = ACTIONS(4598),
    [sym_size_t] = ACTIONS(4598),
    [sym_ptrdiff_t] = ACTIONS(4598),
    [sym_string] = ACTIONS(4598),
    [sym_cstring] = ACTIONS(4598),
    [sym_dstring] = ACTIONS(4598),
    [sym_wstring] = ACTIONS(4598),
    [sym_noreturn] = ACTIONS(4598),
    [sym_true] = ACTIONS(4598),
    [sym_false] = ACTIONS(4598),
    [sym_null] = ACTIONS(4598),
    [sym_super] = ACTIONS(4598),
    [sym_this] = ACTIONS(4598),
    [sym_assert] = ACTIONS(4598),
    [sym_auto] = ACTIONS(4598),
    [sym_cast] = ACTIONS(4598),
    [sym_catch] = ACTIONS(4598),
    [sym_const] = ACTIONS(4598),
    [sym_delegate] = ACTIONS(4598),
    [sym_delete] = ACTIONS(4598),
    [sym_do] = ACTIONS(4598),
    [sym_else] = ACTIONS(4598),
    [sym_finally] = ACTIONS(4598),
    [sym_function] = ACTIONS(4598),
    [sym_immutable] = ACTIONS(4598),
    [sym_import] = ACTIONS(4598),
    [sym_in] = ACTIONS(4598),
    [sym_inout] = ACTIONS(4598),
    [sym_is] = ACTIONS(4598),
    [sym_mixin] = ACTIONS(4598),
    [sym_new] = ACTIONS(4598),
    [sym_out] = ACTIONS(4598),
    [sym_ref] = ACTIONS(4598),
    [sym_shared] = ACTIONS(4598),
    [sym_throw] = ACTIONS(4598),
    [sym_typeid] = ACTIONS(4598),
    [sym_typeof] = ACTIONS(4598),
    [sym_traits] = ACTIONS(4598),
    [sym_vector] = ACTIONS(4598),
    [sym_void] = ACTIONS(4598),
    [anon_sym_BQUOTE] = ACTIONS(4600),
    [anon_sym_r_DQUOTE] = ACTIONS(4600),
    [anon_sym_x_DQUOTE] = ACTIONS(4600),
    [anon_sym_DQUOTE] = ACTIONS(4600),
    [anon_sym_i_BQUOTE] = ACTIONS(4600),
    [anon_sym_i_DQUOTE] = ACTIONS(4600),
    [anon_sym_iq_LBRACE] = ACTIONS(4600),
    [aux_sym_char_literal_token1] = ACTIONS(4600),
    [anon_sym_SQUOTE] = ACTIONS(4598),
    [anon_sym___DATE__] = ACTIONS(4598),
    [anon_sym___FILE__] = ACTIONS(4598),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4598),
    [anon_sym___FUNCTION__] = ACTIONS(4598),
    [anon_sym___LINE__] = ACTIONS(4598),
    [anon_sym___MODULE__] = ACTIONS(4598),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4598),
    [anon_sym___TIME__] = ACTIONS(4598),
    [anon_sym___TIMESTAMP__] = ACTIONS(4598),
    [anon_sym___VENDOR__] = ACTIONS(4598),
    [anon_sym___VERSION__] = ACTIONS(4598),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4600),
    [sym_float_literal] = ACTIONS(4600),
    [sym__string] = ACTIONS(4600),
  },
  [2094] = {
    [sym_identifier] = ACTIONS(4614),
    [anon_sym_q_LBRACE] = ACTIONS(4616),
    [anon_sym_LBRACE] = ACTIONS(4616),
    [anon_sym_DOT] = ACTIONS(4616),
    [anon_sym_AMP] = ACTIONS(4616),
    [anon_sym_DASH] = ACTIONS(4614),
    [anon_sym_DASH_DASH] = ACTIONS(4616),
    [anon_sym_PLUS] = ACTIONS(4614),
    [anon_sym_PLUS_PLUS] = ACTIONS(4616),
    [anon_sym_BANG] = ACTIONS(4616),
    [anon_sym_LPAREN] = ACTIONS(4616),
    [anon_sym_RPAREN] = ACTIONS(4616),
    [anon_sym_LBRACK] = ACTIONS(4616),
    [anon_sym_SEMI] = ACTIONS(4616),
    [anon_sym_DOLLAR] = ACTIONS(4616),
    [anon_sym_STAR] = ACTIONS(4616),
    [anon_sym_TILDE] = ACTIONS(4616),
    [sym_bool] = ACTIONS(4614),
    [sym_byte] = ACTIONS(4614),
    [sym_ubyte] = ACTIONS(4614),
    [sym_char] = ACTIONS(4614),
    [sym_short] = ACTIONS(4614),
    [sym_ushort] = ACTIONS(4614),
    [sym_int] = ACTIONS(4614),
    [sym_uint] = ACTIONS(4614),
    [sym_long] = ACTIONS(4614),
    [sym_ulong] = ACTIONS(4614),
    [sym_cent] = ACTIONS(4614),
    [sym_ucent] = ACTIONS(4614),
    [sym_wchar] = ACTIONS(4614),
    [sym_dchar] = ACTIONS(4614),
    [sym_float] = ACTIONS(4614),
    [sym_double] = ACTIONS(4614),
    [sym_real] = ACTIONS(4614),
    [sym_ifloat] = ACTIONS(4614),
    [sym_idouble] = ACTIONS(4614),
    [sym_ireal] = ACTIONS(4614),
    [sym_cfloat] = ACTIONS(4614),
    [sym_cdouble] = ACTIONS(4614),
    [sym_creal] = ACTIONS(4614),
    [sym_size_t] = ACTIONS(4614),
    [sym_ptrdiff_t] = ACTIONS(4614),
    [sym_string] = ACTIONS(4614),
    [sym_cstring] = ACTIONS(4614),
    [sym_dstring] = ACTIONS(4614),
    [sym_wstring] = ACTIONS(4614),
    [sym_noreturn] = ACTIONS(4614),
    [sym_true] = ACTIONS(4614),
    [sym_false] = ACTIONS(4614),
    [sym_null] = ACTIONS(4614),
    [sym_super] = ACTIONS(4614),
    [sym_this] = ACTIONS(4614),
    [sym_assert] = ACTIONS(4614),
    [sym_auto] = ACTIONS(4614),
    [sym_cast] = ACTIONS(4614),
    [sym_catch] = ACTIONS(4614),
    [sym_const] = ACTIONS(4614),
    [sym_delegate] = ACTIONS(4614),
    [sym_delete] = ACTIONS(4614),
    [sym_do] = ACTIONS(4614),
    [sym_else] = ACTIONS(4614),
    [sym_finally] = ACTIONS(4614),
    [sym_function] = ACTIONS(4614),
    [sym_immutable] = ACTIONS(4614),
    [sym_import] = ACTIONS(4614),
    [sym_in] = ACTIONS(4614),
    [sym_inout] = ACTIONS(4614),
    [sym_is] = ACTIONS(4614),
    [sym_mixin] = ACTIONS(4614),
    [sym_new] = ACTIONS(4614),
    [sym_out] = ACTIONS(4614),
    [sym_ref] = ACTIONS(4614),
    [sym_shared] = ACTIONS(4614),
    [sym_throw] = ACTIONS(4614),
    [sym_typeid] = ACTIONS(4614),
    [sym_typeof] = ACTIONS(4614),
    [sym_traits] = ACTIONS(4614),
    [sym_vector] = ACTIONS(4614),
    [sym_void] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4616),
    [anon_sym_r_DQUOTE] = ACTIONS(4616),
    [anon_sym_x_DQUOTE] = ACTIONS(4616),
    [anon_sym_DQUOTE] = ACTIONS(4616),
    [anon_sym_i_BQUOTE] = ACTIONS(4616),
    [anon_sym_i_DQUOTE] = ACTIONS(4616),
    [anon_sym_iq_LBRACE] = ACTIONS(4616),
    [aux_sym_char_literal_token1] = ACTIONS(4616),
    [anon_sym_SQUOTE] = ACTIONS(4614),
    [anon_sym___DATE__] = ACTIONS(4614),
    [anon_sym___FILE__] = ACTIONS(4614),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4614),
    [anon_sym___FUNCTION__] = ACTIONS(4614),
    [anon_sym___LINE__] = ACTIONS(4614),
    [anon_sym___MODULE__] = ACTIONS(4614),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4614),
    [anon_sym___TIME__] = ACTIONS(4614),
    [anon_sym___TIMESTAMP__] = ACTIONS(4614),
    [anon_sym___VENDOR__] = ACTIONS(4614),
    [anon_sym___VERSION__] = ACTIONS(4614),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4616),
    [sym_float_literal] = ACTIONS(4616),
    [sym__string] = ACTIONS(4616),
  },
  [2095] = {
    [sym_identifier] = ACTIONS(4602),
    [anon_sym_q_LBRACE] = ACTIONS(4604),
    [anon_sym_LBRACE] = ACTIONS(4604),
    [anon_sym_DOT] = ACTIONS(4604),
    [anon_sym_AMP] = ACTIONS(4604),
    [anon_sym_DASH] = ACTIONS(4602),
    [anon_sym_DASH_DASH] = ACTIONS(4604),
    [anon_sym_PLUS] = ACTIONS(4602),
    [anon_sym_PLUS_PLUS] = ACTIONS(4604),
    [anon_sym_BANG] = ACTIONS(4604),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_SEMI] = ACTIONS(4604),
    [anon_sym_DOLLAR] = ACTIONS(4604),
    [anon_sym_STAR] = ACTIONS(4604),
    [anon_sym_TILDE] = ACTIONS(4604),
    [sym_bool] = ACTIONS(4602),
    [sym_byte] = ACTIONS(4602),
    [sym_ubyte] = ACTIONS(4602),
    [sym_char] = ACTIONS(4602),
    [sym_short] = ACTIONS(4602),
    [sym_ushort] = ACTIONS(4602),
    [sym_int] = ACTIONS(4602),
    [sym_uint] = ACTIONS(4602),
    [sym_long] = ACTIONS(4602),
    [sym_ulong] = ACTIONS(4602),
    [sym_cent] = ACTIONS(4602),
    [sym_ucent] = ACTIONS(4602),
    [sym_wchar] = ACTIONS(4602),
    [sym_dchar] = ACTIONS(4602),
    [sym_float] = ACTIONS(4602),
    [sym_double] = ACTIONS(4602),
    [sym_real] = ACTIONS(4602),
    [sym_ifloat] = ACTIONS(4602),
    [sym_idouble] = ACTIONS(4602),
    [sym_ireal] = ACTIONS(4602),
    [sym_cfloat] = ACTIONS(4602),
    [sym_cdouble] = ACTIONS(4602),
    [sym_creal] = ACTIONS(4602),
    [sym_size_t] = ACTIONS(4602),
    [sym_ptrdiff_t] = ACTIONS(4602),
    [sym_string] = ACTIONS(4602),
    [sym_cstring] = ACTIONS(4602),
    [sym_dstring] = ACTIONS(4602),
    [sym_wstring] = ACTIONS(4602),
    [sym_noreturn] = ACTIONS(4602),
    [sym_true] = ACTIONS(4602),
    [sym_false] = ACTIONS(4602),
    [sym_null] = ACTIONS(4602),
    [sym_super] = ACTIONS(4602),
    [sym_this] = ACTIONS(4602),
    [sym_assert] = ACTIONS(4602),
    [sym_auto] = ACTIONS(4602),
    [sym_cast] = ACTIONS(4602),
    [sym_catch] = ACTIONS(4602),
    [sym_const] = ACTIONS(4602),
    [sym_delegate] = ACTIONS(4602),
    [sym_delete] = ACTIONS(4602),
    [sym_do] = ACTIONS(4602),
    [sym_else] = ACTIONS(4602),
    [sym_finally] = ACTIONS(4602),
    [sym_function] = ACTIONS(4602),
    [sym_immutable] = ACTIONS(4602),
    [sym_import] = ACTIONS(4602),
    [sym_in] = ACTIONS(4602),
    [sym_inout] = ACTIONS(4602),
    [sym_is] = ACTIONS(4602),
    [sym_mixin] = ACTIONS(4602),
    [sym_new] = ACTIONS(4602),
    [sym_out] = ACTIONS(4602),
    [sym_ref] = ACTIONS(4602),
    [sym_shared] = ACTIONS(4602),
    [sym_throw] = ACTIONS(4602),
    [sym_typeid] = ACTIONS(4602),
    [sym_typeof] = ACTIONS(4602),
    [sym_traits] = ACTIONS(4602),
    [sym_vector] = ACTIONS(4602),
    [sym_void] = ACTIONS(4602),
    [anon_sym_BQUOTE] = ACTIONS(4604),
    [anon_sym_r_DQUOTE] = ACTIONS(4604),
    [anon_sym_x_DQUOTE] = ACTIONS(4604),
    [anon_sym_DQUOTE] = ACTIONS(4604),
    [anon_sym_i_BQUOTE] = ACTIONS(4604),
    [anon_sym_i_DQUOTE] = ACTIONS(4604),
    [anon_sym_iq_LBRACE] = ACTIONS(4604),
    [aux_sym_char_literal_token1] = ACTIONS(4604),
    [anon_sym_SQUOTE] = ACTIONS(4602),
    [anon_sym___DATE__] = ACTIONS(4602),
    [anon_sym___FILE__] = ACTIONS(4602),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4602),
    [anon_sym___FUNCTION__] = ACTIONS(4602),
    [anon_sym___LINE__] = ACTIONS(4602),
    [anon_sym___MODULE__] = ACTIONS(4602),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4602),
    [anon_sym___TIME__] = ACTIONS(4602),
    [anon_sym___TIMESTAMP__] = ACTIONS(4602),
    [anon_sym___VENDOR__] = ACTIONS(4602),
    [anon_sym___VERSION__] = ACTIONS(4602),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4604),
    [sym_float_literal] = ACTIONS(4604),
    [sym__string] = ACTIONS(4604),
  },
  [2096] = {
    [sym_identifier] = ACTIONS(4594),
    [anon_sym_q_LBRACE] = ACTIONS(4596),
    [anon_sym_LBRACE] = ACTIONS(4596),
    [anon_sym_DOT] = ACTIONS(4596),
    [anon_sym_AMP] = ACTIONS(4596),
    [anon_sym_DASH] = ACTIONS(4594),
    [anon_sym_DASH_DASH] = ACTIONS(4596),
    [anon_sym_PLUS] = ACTIONS(4594),
    [anon_sym_PLUS_PLUS] = ACTIONS(4596),
    [anon_sym_BANG] = ACTIONS(4596),
    [anon_sym_LPAREN] = ACTIONS(4596),
    [anon_sym_RPAREN] = ACTIONS(4596),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_DOLLAR] = ACTIONS(4596),
    [anon_sym_STAR] = ACTIONS(4596),
    [anon_sym_TILDE] = ACTIONS(4596),
    [sym_bool] = ACTIONS(4594),
    [sym_byte] = ACTIONS(4594),
    [sym_ubyte] = ACTIONS(4594),
    [sym_char] = ACTIONS(4594),
    [sym_short] = ACTIONS(4594),
    [sym_ushort] = ACTIONS(4594),
    [sym_int] = ACTIONS(4594),
    [sym_uint] = ACTIONS(4594),
    [sym_long] = ACTIONS(4594),
    [sym_ulong] = ACTIONS(4594),
    [sym_cent] = ACTIONS(4594),
    [sym_ucent] = ACTIONS(4594),
    [sym_wchar] = ACTIONS(4594),
    [sym_dchar] = ACTIONS(4594),
    [sym_float] = ACTIONS(4594),
    [sym_double] = ACTIONS(4594),
    [sym_real] = ACTIONS(4594),
    [sym_ifloat] = ACTIONS(4594),
    [sym_idouble] = ACTIONS(4594),
    [sym_ireal] = ACTIONS(4594),
    [sym_cfloat] = ACTIONS(4594),
    [sym_cdouble] = ACTIONS(4594),
    [sym_creal] = ACTIONS(4594),
    [sym_size_t] = ACTIONS(4594),
    [sym_ptrdiff_t] = ACTIONS(4594),
    [sym_string] = ACTIONS(4594),
    [sym_cstring] = ACTIONS(4594),
    [sym_dstring] = ACTIONS(4594),
    [sym_wstring] = ACTIONS(4594),
    [sym_noreturn] = ACTIONS(4594),
    [sym_true] = ACTIONS(4594),
    [sym_false] = ACTIONS(4594),
    [sym_null] = ACTIONS(4594),
    [sym_super] = ACTIONS(4594),
    [sym_this] = ACTIONS(4594),
    [sym_assert] = ACTIONS(4594),
    [sym_auto] = ACTIONS(4594),
    [sym_cast] = ACTIONS(4594),
    [sym_catch] = ACTIONS(4594),
    [sym_const] = ACTIONS(4594),
    [sym_delegate] = ACTIONS(4594),
    [sym_delete] = ACTIONS(4594),
    [sym_do] = ACTIONS(4594),
    [sym_else] = ACTIONS(4594),
    [sym_finally] = ACTIONS(4594),
    [sym_function] = ACTIONS(4594),
    [sym_immutable] = ACTIONS(4594),
    [sym_import] = ACTIONS(4594),
    [sym_in] = ACTIONS(4594),
    [sym_inout] = ACTIONS(4594),
    [sym_is] = ACTIONS(4594),
    [sym_mixin] = ACTIONS(4594),
    [sym_new] = ACTIONS(4594),
    [sym_out] = ACTIONS(4594),
    [sym_ref] = ACTIONS(4594),
    [sym_shared] = ACTIONS(4594),
    [sym_throw] = ACTIONS(4594),
    [sym_typeid] = ACTIONS(4594),
    [sym_typeof] = ACTIONS(4594),
    [sym_traits] = ACTIONS(4594),
    [sym_vector] = ACTIONS(4594),
    [sym_void] = ACTIONS(4594),
    [anon_sym_BQUOTE] = ACTIONS(4596),
    [anon_sym_r_DQUOTE] = ACTIONS(4596),
    [anon_sym_x_DQUOTE] = ACTIONS(4596),
    [anon_sym_DQUOTE] = ACTIONS(4596),
    [anon_sym_i_BQUOTE] = ACTIONS(4596),
    [anon_sym_i_DQUOTE] = ACTIONS(4596),
    [anon_sym_iq_LBRACE] = ACTIONS(4596),
    [aux_sym_char_literal_token1] = ACTIONS(4596),
    [anon_sym_SQUOTE] = ACTIONS(4594),
    [anon_sym___DATE__] = ACTIONS(4594),
    [anon_sym___FILE__] = ACTIONS(4594),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4594),
    [anon_sym___FUNCTION__] = ACTIONS(4594),
    [anon_sym___LINE__] = ACTIONS(4594),
    [anon_sym___MODULE__] = ACTIONS(4594),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4594),
    [anon_sym___TIME__] = ACTIONS(4594),
    [anon_sym___TIMESTAMP__] = ACTIONS(4594),
    [anon_sym___VENDOR__] = ACTIONS(4594),
    [anon_sym___VERSION__] = ACTIONS(4594),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4596),
    [sym_float_literal] = ACTIONS(4596),
    [sym__string] = ACTIONS(4596),
  },
  [2097] = {
    [sym_identifier] = ACTIONS(4466),
    [anon_sym_q_LBRACE] = ACTIONS(4468),
    [anon_sym_LBRACE] = ACTIONS(4468),
    [anon_sym_DOT] = ACTIONS(4468),
    [anon_sym_AMP] = ACTIONS(4468),
    [anon_sym_DASH] = ACTIONS(4466),
    [anon_sym_DASH_DASH] = ACTIONS(4468),
    [anon_sym_PLUS] = ACTIONS(4466),
    [anon_sym_PLUS_PLUS] = ACTIONS(4468),
    [anon_sym_BANG] = ACTIONS(4468),
    [anon_sym_LPAREN] = ACTIONS(4468),
    [anon_sym_RPAREN] = ACTIONS(4468),
    [anon_sym_LBRACK] = ACTIONS(4468),
    [anon_sym_SEMI] = ACTIONS(4468),
    [anon_sym_DOLLAR] = ACTIONS(4468),
    [anon_sym_STAR] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [sym_bool] = ACTIONS(4466),
    [sym_byte] = ACTIONS(4466),
    [sym_ubyte] = ACTIONS(4466),
    [sym_char] = ACTIONS(4466),
    [sym_short] = ACTIONS(4466),
    [sym_ushort] = ACTIONS(4466),
    [sym_int] = ACTIONS(4466),
    [sym_uint] = ACTIONS(4466),
    [sym_long] = ACTIONS(4466),
    [sym_ulong] = ACTIONS(4466),
    [sym_cent] = ACTIONS(4466),
    [sym_ucent] = ACTIONS(4466),
    [sym_wchar] = ACTIONS(4466),
    [sym_dchar] = ACTIONS(4466),
    [sym_float] = ACTIONS(4466),
    [sym_double] = ACTIONS(4466),
    [sym_real] = ACTIONS(4466),
    [sym_ifloat] = ACTIONS(4466),
    [sym_idouble] = ACTIONS(4466),
    [sym_ireal] = ACTIONS(4466),
    [sym_cfloat] = ACTIONS(4466),
    [sym_cdouble] = ACTIONS(4466),
    [sym_creal] = ACTIONS(4466),
    [sym_size_t] = ACTIONS(4466),
    [sym_ptrdiff_t] = ACTIONS(4466),
    [sym_string] = ACTIONS(4466),
    [sym_cstring] = ACTIONS(4466),
    [sym_dstring] = ACTIONS(4466),
    [sym_wstring] = ACTIONS(4466),
    [sym_noreturn] = ACTIONS(4466),
    [sym_true] = ACTIONS(4466),
    [sym_false] = ACTIONS(4466),
    [sym_null] = ACTIONS(4466),
    [sym_super] = ACTIONS(4466),
    [sym_this] = ACTIONS(4466),
    [sym_assert] = ACTIONS(4466),
    [sym_auto] = ACTIONS(4466),
    [sym_cast] = ACTIONS(4466),
    [sym_catch] = ACTIONS(4466),
    [sym_const] = ACTIONS(4466),
    [sym_delegate] = ACTIONS(4466),
    [sym_delete] = ACTIONS(4466),
    [sym_do] = ACTIONS(4466),
    [sym_else] = ACTIONS(4466),
    [sym_finally] = ACTIONS(4466),
    [sym_function] = ACTIONS(4466),
    [sym_immutable] = ACTIONS(4466),
    [sym_import] = ACTIONS(4466),
    [sym_in] = ACTIONS(4466),
    [sym_inout] = ACTIONS(4466),
    [sym_is] = ACTIONS(4466),
    [sym_mixin] = ACTIONS(4466),
    [sym_new] = ACTIONS(4466),
    [sym_out] = ACTIONS(4466),
    [sym_ref] = ACTIONS(4466),
    [sym_shared] = ACTIONS(4466),
    [sym_throw] = ACTIONS(4466),
    [sym_typeid] = ACTIONS(4466),
    [sym_typeof] = ACTIONS(4466),
    [sym_traits] = ACTIONS(4466),
    [sym_vector] = ACTIONS(4466),
    [sym_void] = ACTIONS(4466),
    [anon_sym_BQUOTE] = ACTIONS(4468),
    [anon_sym_r_DQUOTE] = ACTIONS(4468),
    [anon_sym_x_DQUOTE] = ACTIONS(4468),
    [anon_sym_DQUOTE] = ACTIONS(4468),
    [anon_sym_i_BQUOTE] = ACTIONS(4468),
    [anon_sym_i_DQUOTE] = ACTIONS(4468),
    [anon_sym_iq_LBRACE] = ACTIONS(4468),
    [aux_sym_char_literal_token1] = ACTIONS(4468),
    [anon_sym_SQUOTE] = ACTIONS(4466),
    [anon_sym___DATE__] = ACTIONS(4466),
    [anon_sym___FILE__] = ACTIONS(4466),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4466),
    [anon_sym___FUNCTION__] = ACTIONS(4466),
    [anon_sym___LINE__] = ACTIONS(4466),
    [anon_sym___MODULE__] = ACTIONS(4466),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4466),
    [anon_sym___TIME__] = ACTIONS(4466),
    [anon_sym___TIMESTAMP__] = ACTIONS(4466),
    [anon_sym___VENDOR__] = ACTIONS(4466),
    [anon_sym___VERSION__] = ACTIONS(4466),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4468),
    [sym_float_literal] = ACTIONS(4468),
    [sym__string] = ACTIONS(4468),
  },
  [2098] = {
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_q_LBRACE] = ACTIONS(4592),
    [anon_sym_LBRACE] = ACTIONS(4592),
    [anon_sym_DOT] = ACTIONS(4592),
    [anon_sym_AMP] = ACTIONS(4592),
    [anon_sym_DASH] = ACTIONS(4590),
    [anon_sym_DASH_DASH] = ACTIONS(4592),
    [anon_sym_PLUS] = ACTIONS(4590),
    [anon_sym_PLUS_PLUS] = ACTIONS(4592),
    [anon_sym_BANG] = ACTIONS(4592),
    [anon_sym_LPAREN] = ACTIONS(4592),
    [anon_sym_RPAREN] = ACTIONS(4592),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_DOLLAR] = ACTIONS(4592),
    [anon_sym_STAR] = ACTIONS(4592),
    [anon_sym_TILDE] = ACTIONS(4592),
    [sym_bool] = ACTIONS(4590),
    [sym_byte] = ACTIONS(4590),
    [sym_ubyte] = ACTIONS(4590),
    [sym_char] = ACTIONS(4590),
    [sym_short] = ACTIONS(4590),
    [sym_ushort] = ACTIONS(4590),
    [sym_int] = ACTIONS(4590),
    [sym_uint] = ACTIONS(4590),
    [sym_long] = ACTIONS(4590),
    [sym_ulong] = ACTIONS(4590),
    [sym_cent] = ACTIONS(4590),
    [sym_ucent] = ACTIONS(4590),
    [sym_wchar] = ACTIONS(4590),
    [sym_dchar] = ACTIONS(4590),
    [sym_float] = ACTIONS(4590),
    [sym_double] = ACTIONS(4590),
    [sym_real] = ACTIONS(4590),
    [sym_ifloat] = ACTIONS(4590),
    [sym_idouble] = ACTIONS(4590),
    [sym_ireal] = ACTIONS(4590),
    [sym_cfloat] = ACTIONS(4590),
    [sym_cdouble] = ACTIONS(4590),
    [sym_creal] = ACTIONS(4590),
    [sym_size_t] = ACTIONS(4590),
    [sym_ptrdiff_t] = ACTIONS(4590),
    [sym_string] = ACTIONS(4590),
    [sym_cstring] = ACTIONS(4590),
    [sym_dstring] = ACTIONS(4590),
    [sym_wstring] = ACTIONS(4590),
    [sym_noreturn] = ACTIONS(4590),
    [sym_true] = ACTIONS(4590),
    [sym_false] = ACTIONS(4590),
    [sym_null] = ACTIONS(4590),
    [sym_super] = ACTIONS(4590),
    [sym_this] = ACTIONS(4590),
    [sym_assert] = ACTIONS(4590),
    [sym_auto] = ACTIONS(4590),
    [sym_cast] = ACTIONS(4590),
    [sym_catch] = ACTIONS(4590),
    [sym_const] = ACTIONS(4590),
    [sym_delegate] = ACTIONS(4590),
    [sym_delete] = ACTIONS(4590),
    [sym_do] = ACTIONS(4590),
    [sym_else] = ACTIONS(4590),
    [sym_finally] = ACTIONS(4590),
    [sym_function] = ACTIONS(4590),
    [sym_immutable] = ACTIONS(4590),
    [sym_import] = ACTIONS(4590),
    [sym_in] = ACTIONS(4590),
    [sym_inout] = ACTIONS(4590),
    [sym_is] = ACTIONS(4590),
    [sym_mixin] = ACTIONS(4590),
    [sym_new] = ACTIONS(4590),
    [sym_out] = ACTIONS(4590),
    [sym_ref] = ACTIONS(4590),
    [sym_shared] = ACTIONS(4590),
    [sym_throw] = ACTIONS(4590),
    [sym_typeid] = ACTIONS(4590),
    [sym_typeof] = ACTIONS(4590),
    [sym_traits] = ACTIONS(4590),
    [sym_vector] = ACTIONS(4590),
    [sym_void] = ACTIONS(4590),
    [anon_sym_BQUOTE] = ACTIONS(4592),
    [anon_sym_r_DQUOTE] = ACTIONS(4592),
    [anon_sym_x_DQUOTE] = ACTIONS(4592),
    [anon_sym_DQUOTE] = ACTIONS(4592),
    [anon_sym_i_BQUOTE] = ACTIONS(4592),
    [anon_sym_i_DQUOTE] = ACTIONS(4592),
    [anon_sym_iq_LBRACE] = ACTIONS(4592),
    [aux_sym_char_literal_token1] = ACTIONS(4592),
    [anon_sym_SQUOTE] = ACTIONS(4590),
    [anon_sym___DATE__] = ACTIONS(4590),
    [anon_sym___FILE__] = ACTIONS(4590),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4590),
    [anon_sym___FUNCTION__] = ACTIONS(4590),
    [anon_sym___LINE__] = ACTIONS(4590),
    [anon_sym___MODULE__] = ACTIONS(4590),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4590),
    [anon_sym___TIME__] = ACTIONS(4590),
    [anon_sym___TIMESTAMP__] = ACTIONS(4590),
    [anon_sym___VENDOR__] = ACTIONS(4590),
    [anon_sym___VERSION__] = ACTIONS(4590),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4592),
    [sym_float_literal] = ACTIONS(4592),
    [sym__string] = ACTIONS(4592),
  },
  [2099] = {
    [sym_identifier] = ACTIONS(4578),
    [anon_sym_q_LBRACE] = ACTIONS(4580),
    [anon_sym_LBRACE] = ACTIONS(4580),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_AMP] = ACTIONS(4580),
    [anon_sym_DASH] = ACTIONS(4578),
    [anon_sym_DASH_DASH] = ACTIONS(4580),
    [anon_sym_PLUS] = ACTIONS(4578),
    [anon_sym_PLUS_PLUS] = ACTIONS(4580),
    [anon_sym_BANG] = ACTIONS(4580),
    [anon_sym_LPAREN] = ACTIONS(4580),
    [anon_sym_RPAREN] = ACTIONS(4580),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_DOLLAR] = ACTIONS(4580),
    [anon_sym_STAR] = ACTIONS(4580),
    [anon_sym_TILDE] = ACTIONS(4580),
    [sym_bool] = ACTIONS(4578),
    [sym_byte] = ACTIONS(4578),
    [sym_ubyte] = ACTIONS(4578),
    [sym_char] = ACTIONS(4578),
    [sym_short] = ACTIONS(4578),
    [sym_ushort] = ACTIONS(4578),
    [sym_int] = ACTIONS(4578),
    [sym_uint] = ACTIONS(4578),
    [sym_long] = ACTIONS(4578),
    [sym_ulong] = ACTIONS(4578),
    [sym_cent] = ACTIONS(4578),
    [sym_ucent] = ACTIONS(4578),
    [sym_wchar] = ACTIONS(4578),
    [sym_dchar] = ACTIONS(4578),
    [sym_float] = ACTIONS(4578),
    [sym_double] = ACTIONS(4578),
    [sym_real] = ACTIONS(4578),
    [sym_ifloat] = ACTIONS(4578),
    [sym_idouble] = ACTIONS(4578),
    [sym_ireal] = ACTIONS(4578),
    [sym_cfloat] = ACTIONS(4578),
    [sym_cdouble] = ACTIONS(4578),
    [sym_creal] = ACTIONS(4578),
    [sym_size_t] = ACTIONS(4578),
    [sym_ptrdiff_t] = ACTIONS(4578),
    [sym_string] = ACTIONS(4578),
    [sym_cstring] = ACTIONS(4578),
    [sym_dstring] = ACTIONS(4578),
    [sym_wstring] = ACTIONS(4578),
    [sym_noreturn] = ACTIONS(4578),
    [sym_true] = ACTIONS(4578),
    [sym_false] = ACTIONS(4578),
    [sym_null] = ACTIONS(4578),
    [sym_super] = ACTIONS(4578),
    [sym_this] = ACTIONS(4578),
    [sym_assert] = ACTIONS(4578),
    [sym_auto] = ACTIONS(4578),
    [sym_cast] = ACTIONS(4578),
    [sym_catch] = ACTIONS(4578),
    [sym_const] = ACTIONS(4578),
    [sym_delegate] = ACTIONS(4578),
    [sym_delete] = ACTIONS(4578),
    [sym_do] = ACTIONS(4578),
    [sym_else] = ACTIONS(4578),
    [sym_finally] = ACTIONS(4578),
    [sym_function] = ACTIONS(4578),
    [sym_immutable] = ACTIONS(4578),
    [sym_import] = ACTIONS(4578),
    [sym_in] = ACTIONS(4578),
    [sym_inout] = ACTIONS(4578),
    [sym_is] = ACTIONS(4578),
    [sym_mixin] = ACTIONS(4578),
    [sym_new] = ACTIONS(4578),
    [sym_out] = ACTIONS(4578),
    [sym_ref] = ACTIONS(4578),
    [sym_shared] = ACTIONS(4578),
    [sym_throw] = ACTIONS(4578),
    [sym_typeid] = ACTIONS(4578),
    [sym_typeof] = ACTIONS(4578),
    [sym_traits] = ACTIONS(4578),
    [sym_vector] = ACTIONS(4578),
    [sym_void] = ACTIONS(4578),
    [anon_sym_BQUOTE] = ACTIONS(4580),
    [anon_sym_r_DQUOTE] = ACTIONS(4580),
    [anon_sym_x_DQUOTE] = ACTIONS(4580),
    [anon_sym_DQUOTE] = ACTIONS(4580),
    [anon_sym_i_BQUOTE] = ACTIONS(4580),
    [anon_sym_i_DQUOTE] = ACTIONS(4580),
    [anon_sym_iq_LBRACE] = ACTIONS(4580),
    [aux_sym_char_literal_token1] = ACTIONS(4580),
    [anon_sym_SQUOTE] = ACTIONS(4578),
    [anon_sym___DATE__] = ACTIONS(4578),
    [anon_sym___FILE__] = ACTIONS(4578),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4578),
    [anon_sym___FUNCTION__] = ACTIONS(4578),
    [anon_sym___LINE__] = ACTIONS(4578),
    [anon_sym___MODULE__] = ACTIONS(4578),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4578),
    [anon_sym___TIME__] = ACTIONS(4578),
    [anon_sym___TIMESTAMP__] = ACTIONS(4578),
    [anon_sym___VENDOR__] = ACTIONS(4578),
    [anon_sym___VERSION__] = ACTIONS(4578),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4580),
    [sym_float_literal] = ACTIONS(4580),
    [sym__string] = ACTIONS(4580),
  },
  [2100] = {
    [sym_identifier] = ACTIONS(4546),
    [anon_sym_q_LBRACE] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(4548),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_AMP] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_DASH_DASH] = ACTIONS(4548),
    [anon_sym_PLUS] = ACTIONS(4546),
    [anon_sym_PLUS_PLUS] = ACTIONS(4548),
    [anon_sym_BANG] = ACTIONS(4548),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4548),
    [anon_sym_LBRACK] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_STAR] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [sym_bool] = ACTIONS(4546),
    [sym_byte] = ACTIONS(4546),
    [sym_ubyte] = ACTIONS(4546),
    [sym_char] = ACTIONS(4546),
    [sym_short] = ACTIONS(4546),
    [sym_ushort] = ACTIONS(4546),
    [sym_int] = ACTIONS(4546),
    [sym_uint] = ACTIONS(4546),
    [sym_long] = ACTIONS(4546),
    [sym_ulong] = ACTIONS(4546),
    [sym_cent] = ACTIONS(4546),
    [sym_ucent] = ACTIONS(4546),
    [sym_wchar] = ACTIONS(4546),
    [sym_dchar] = ACTIONS(4546),
    [sym_float] = ACTIONS(4546),
    [sym_double] = ACTIONS(4546),
    [sym_real] = ACTIONS(4546),
    [sym_ifloat] = ACTIONS(4546),
    [sym_idouble] = ACTIONS(4546),
    [sym_ireal] = ACTIONS(4546),
    [sym_cfloat] = ACTIONS(4546),
    [sym_cdouble] = ACTIONS(4546),
    [sym_creal] = ACTIONS(4546),
    [sym_size_t] = ACTIONS(4546),
    [sym_ptrdiff_t] = ACTIONS(4546),
    [sym_string] = ACTIONS(4546),
    [sym_cstring] = ACTIONS(4546),
    [sym_dstring] = ACTIONS(4546),
    [sym_wstring] = ACTIONS(4546),
    [sym_noreturn] = ACTIONS(4546),
    [sym_true] = ACTIONS(4546),
    [sym_false] = ACTIONS(4546),
    [sym_null] = ACTIONS(4546),
    [sym_super] = ACTIONS(4546),
    [sym_this] = ACTIONS(4546),
    [sym_assert] = ACTIONS(4546),
    [sym_auto] = ACTIONS(4546),
    [sym_cast] = ACTIONS(4546),
    [sym_catch] = ACTIONS(4546),
    [sym_const] = ACTIONS(4546),
    [sym_delegate] = ACTIONS(4546),
    [sym_delete] = ACTIONS(4546),
    [sym_do] = ACTIONS(4546),
    [sym_else] = ACTIONS(4546),
    [sym_finally] = ACTIONS(4546),
    [sym_function] = ACTIONS(4546),
    [sym_immutable] = ACTIONS(4546),
    [sym_import] = ACTIONS(4546),
    [sym_in] = ACTIONS(4546),
    [sym_inout] = ACTIONS(4546),
    [sym_is] = ACTIONS(4546),
    [sym_mixin] = ACTIONS(4546),
    [sym_new] = ACTIONS(4546),
    [sym_out] = ACTIONS(4546),
    [sym_ref] = ACTIONS(4546),
    [sym_shared] = ACTIONS(4546),
    [sym_throw] = ACTIONS(4546),
    [sym_typeid] = ACTIONS(4546),
    [sym_typeof] = ACTIONS(4546),
    [sym_traits] = ACTIONS(4546),
    [sym_vector] = ACTIONS(4546),
    [sym_void] = ACTIONS(4546),
    [anon_sym_BQUOTE] = ACTIONS(4548),
    [anon_sym_r_DQUOTE] = ACTIONS(4548),
    [anon_sym_x_DQUOTE] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4548),
    [anon_sym_i_BQUOTE] = ACTIONS(4548),
    [anon_sym_i_DQUOTE] = ACTIONS(4548),
    [anon_sym_iq_LBRACE] = ACTIONS(4548),
    [aux_sym_char_literal_token1] = ACTIONS(4548),
    [anon_sym_SQUOTE] = ACTIONS(4546),
    [anon_sym___DATE__] = ACTIONS(4546),
    [anon_sym___FILE__] = ACTIONS(4546),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4546),
    [anon_sym___FUNCTION__] = ACTIONS(4546),
    [anon_sym___LINE__] = ACTIONS(4546),
    [anon_sym___MODULE__] = ACTIONS(4546),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4546),
    [anon_sym___TIME__] = ACTIONS(4546),
    [anon_sym___TIMESTAMP__] = ACTIONS(4546),
    [anon_sym___VENDOR__] = ACTIONS(4546),
    [anon_sym___VERSION__] = ACTIONS(4546),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4548),
    [sym_float_literal] = ACTIONS(4548),
    [sym__string] = ACTIONS(4548),
  },
  [2101] = {
    [sym_identifier] = ACTIONS(4542),
    [anon_sym_q_LBRACE] = ACTIONS(4544),
    [anon_sym_LBRACE] = ACTIONS(4544),
    [anon_sym_DOT] = ACTIONS(4544),
    [anon_sym_AMP] = ACTIONS(4544),
    [anon_sym_DASH] = ACTIONS(4542),
    [anon_sym_DASH_DASH] = ACTIONS(4544),
    [anon_sym_PLUS] = ACTIONS(4542),
    [anon_sym_PLUS_PLUS] = ACTIONS(4544),
    [anon_sym_BANG] = ACTIONS(4544),
    [anon_sym_LPAREN] = ACTIONS(4544),
    [anon_sym_RPAREN] = ACTIONS(4544),
    [anon_sym_LBRACK] = ACTIONS(4544),
    [anon_sym_SEMI] = ACTIONS(4544),
    [anon_sym_DOLLAR] = ACTIONS(4544),
    [anon_sym_STAR] = ACTIONS(4544),
    [anon_sym_TILDE] = ACTIONS(4544),
    [sym_bool] = ACTIONS(4542),
    [sym_byte] = ACTIONS(4542),
    [sym_ubyte] = ACTIONS(4542),
    [sym_char] = ACTIONS(4542),
    [sym_short] = ACTIONS(4542),
    [sym_ushort] = ACTIONS(4542),
    [sym_int] = ACTIONS(4542),
    [sym_uint] = ACTIONS(4542),
    [sym_long] = ACTIONS(4542),
    [sym_ulong] = ACTIONS(4542),
    [sym_cent] = ACTIONS(4542),
    [sym_ucent] = ACTIONS(4542),
    [sym_wchar] = ACTIONS(4542),
    [sym_dchar] = ACTIONS(4542),
    [sym_float] = ACTIONS(4542),
    [sym_double] = ACTIONS(4542),
    [sym_real] = ACTIONS(4542),
    [sym_ifloat] = ACTIONS(4542),
    [sym_idouble] = ACTIONS(4542),
    [sym_ireal] = ACTIONS(4542),
    [sym_cfloat] = ACTIONS(4542),
    [sym_cdouble] = ACTIONS(4542),
    [sym_creal] = ACTIONS(4542),
    [sym_size_t] = ACTIONS(4542),
    [sym_ptrdiff_t] = ACTIONS(4542),
    [sym_string] = ACTIONS(4542),
    [sym_cstring] = ACTIONS(4542),
    [sym_dstring] = ACTIONS(4542),
    [sym_wstring] = ACTIONS(4542),
    [sym_noreturn] = ACTIONS(4542),
    [sym_true] = ACTIONS(4542),
    [sym_false] = ACTIONS(4542),
    [sym_null] = ACTIONS(4542),
    [sym_super] = ACTIONS(4542),
    [sym_this] = ACTIONS(4542),
    [sym_assert] = ACTIONS(4542),
    [sym_auto] = ACTIONS(4542),
    [sym_cast] = ACTIONS(4542),
    [sym_catch] = ACTIONS(4542),
    [sym_const] = ACTIONS(4542),
    [sym_delegate] = ACTIONS(4542),
    [sym_delete] = ACTIONS(4542),
    [sym_do] = ACTIONS(4542),
    [sym_else] = ACTIONS(4542),
    [sym_finally] = ACTIONS(4542),
    [sym_function] = ACTIONS(4542),
    [sym_immutable] = ACTIONS(4542),
    [sym_import] = ACTIONS(4542),
    [sym_in] = ACTIONS(4542),
    [sym_inout] = ACTIONS(4542),
    [sym_is] = ACTIONS(4542),
    [sym_mixin] = ACTIONS(4542),
    [sym_new] = ACTIONS(4542),
    [sym_out] = ACTIONS(4542),
    [sym_ref] = ACTIONS(4542),
    [sym_shared] = ACTIONS(4542),
    [sym_throw] = ACTIONS(4542),
    [sym_typeid] = ACTIONS(4542),
    [sym_typeof] = ACTIONS(4542),
    [sym_traits] = ACTIONS(4542),
    [sym_vector] = ACTIONS(4542),
    [sym_void] = ACTIONS(4542),
    [anon_sym_BQUOTE] = ACTIONS(4544),
    [anon_sym_r_DQUOTE] = ACTIONS(4544),
    [anon_sym_x_DQUOTE] = ACTIONS(4544),
    [anon_sym_DQUOTE] = ACTIONS(4544),
    [anon_sym_i_BQUOTE] = ACTIONS(4544),
    [anon_sym_i_DQUOTE] = ACTIONS(4544),
    [anon_sym_iq_LBRACE] = ACTIONS(4544),
    [aux_sym_char_literal_token1] = ACTIONS(4544),
    [anon_sym_SQUOTE] = ACTIONS(4542),
    [anon_sym___DATE__] = ACTIONS(4542),
    [anon_sym___FILE__] = ACTIONS(4542),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4542),
    [anon_sym___FUNCTION__] = ACTIONS(4542),
    [anon_sym___LINE__] = ACTIONS(4542),
    [anon_sym___MODULE__] = ACTIONS(4542),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4542),
    [anon_sym___TIME__] = ACTIONS(4542),
    [anon_sym___TIMESTAMP__] = ACTIONS(4542),
    [anon_sym___VENDOR__] = ACTIONS(4542),
    [anon_sym___VERSION__] = ACTIONS(4542),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4544),
    [sym_float_literal] = ACTIONS(4544),
    [sym__string] = ACTIONS(4544),
  },
  [2102] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_q_LBRACE] = ACTIONS(4532),
    [anon_sym_LBRACE] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4532),
    [anon_sym_AMP] = ACTIONS(4532),
    [anon_sym_DASH] = ACTIONS(4530),
    [anon_sym_DASH_DASH] = ACTIONS(4532),
    [anon_sym_PLUS] = ACTIONS(4530),
    [anon_sym_PLUS_PLUS] = ACTIONS(4532),
    [anon_sym_BANG] = ACTIONS(4532),
    [anon_sym_LPAREN] = ACTIONS(4532),
    [anon_sym_RPAREN] = ACTIONS(4532),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym_DOLLAR] = ACTIONS(4532),
    [anon_sym_STAR] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [sym_bool] = ACTIONS(4530),
    [sym_byte] = ACTIONS(4530),
    [sym_ubyte] = ACTIONS(4530),
    [sym_char] = ACTIONS(4530),
    [sym_short] = ACTIONS(4530),
    [sym_ushort] = ACTIONS(4530),
    [sym_int] = ACTIONS(4530),
    [sym_uint] = ACTIONS(4530),
    [sym_long] = ACTIONS(4530),
    [sym_ulong] = ACTIONS(4530),
    [sym_cent] = ACTIONS(4530),
    [sym_ucent] = ACTIONS(4530),
    [sym_wchar] = ACTIONS(4530),
    [sym_dchar] = ACTIONS(4530),
    [sym_float] = ACTIONS(4530),
    [sym_double] = ACTIONS(4530),
    [sym_real] = ACTIONS(4530),
    [sym_ifloat] = ACTIONS(4530),
    [sym_idouble] = ACTIONS(4530),
    [sym_ireal] = ACTIONS(4530),
    [sym_cfloat] = ACTIONS(4530),
    [sym_cdouble] = ACTIONS(4530),
    [sym_creal] = ACTIONS(4530),
    [sym_size_t] = ACTIONS(4530),
    [sym_ptrdiff_t] = ACTIONS(4530),
    [sym_string] = ACTIONS(4530),
    [sym_cstring] = ACTIONS(4530),
    [sym_dstring] = ACTIONS(4530),
    [sym_wstring] = ACTIONS(4530),
    [sym_noreturn] = ACTIONS(4530),
    [sym_true] = ACTIONS(4530),
    [sym_false] = ACTIONS(4530),
    [sym_null] = ACTIONS(4530),
    [sym_super] = ACTIONS(4530),
    [sym_this] = ACTIONS(4530),
    [sym_assert] = ACTIONS(4530),
    [sym_auto] = ACTIONS(4530),
    [sym_cast] = ACTIONS(4530),
    [sym_catch] = ACTIONS(4530),
    [sym_const] = ACTIONS(4530),
    [sym_delegate] = ACTIONS(4530),
    [sym_delete] = ACTIONS(4530),
    [sym_do] = ACTIONS(4530),
    [sym_else] = ACTIONS(4530),
    [sym_finally] = ACTIONS(4530),
    [sym_function] = ACTIONS(4530),
    [sym_immutable] = ACTIONS(4530),
    [sym_import] = ACTIONS(4530),
    [sym_in] = ACTIONS(4530),
    [sym_inout] = ACTIONS(4530),
    [sym_is] = ACTIONS(4530),
    [sym_mixin] = ACTIONS(4530),
    [sym_new] = ACTIONS(4530),
    [sym_out] = ACTIONS(4530),
    [sym_ref] = ACTIONS(4530),
    [sym_shared] = ACTIONS(4530),
    [sym_throw] = ACTIONS(4530),
    [sym_typeid] = ACTIONS(4530),
    [sym_typeof] = ACTIONS(4530),
    [sym_traits] = ACTIONS(4530),
    [sym_vector] = ACTIONS(4530),
    [sym_void] = ACTIONS(4530),
    [anon_sym_BQUOTE] = ACTIONS(4532),
    [anon_sym_r_DQUOTE] = ACTIONS(4532),
    [anon_sym_x_DQUOTE] = ACTIONS(4532),
    [anon_sym_DQUOTE] = ACTIONS(4532),
    [anon_sym_i_BQUOTE] = ACTIONS(4532),
    [anon_sym_i_DQUOTE] = ACTIONS(4532),
    [anon_sym_iq_LBRACE] = ACTIONS(4532),
    [aux_sym_char_literal_token1] = ACTIONS(4532),
    [anon_sym_SQUOTE] = ACTIONS(4530),
    [anon_sym___DATE__] = ACTIONS(4530),
    [anon_sym___FILE__] = ACTIONS(4530),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4530),
    [anon_sym___FUNCTION__] = ACTIONS(4530),
    [anon_sym___LINE__] = ACTIONS(4530),
    [anon_sym___MODULE__] = ACTIONS(4530),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4530),
    [anon_sym___TIME__] = ACTIONS(4530),
    [anon_sym___TIMESTAMP__] = ACTIONS(4530),
    [anon_sym___VENDOR__] = ACTIONS(4530),
    [anon_sym___VERSION__] = ACTIONS(4530),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4532),
    [sym_float_literal] = ACTIONS(4532),
    [sym__string] = ACTIONS(4532),
  },
  [2103] = {
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_q_LBRACE] = ACTIONS(4418),
    [anon_sym_LBRACE] = ACTIONS(4418),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_AMP] = ACTIONS(4418),
    [anon_sym_DASH] = ACTIONS(4416),
    [anon_sym_DASH_DASH] = ACTIONS(4418),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_PLUS_PLUS] = ACTIONS(4418),
    [anon_sym_BANG] = ACTIONS(4418),
    [anon_sym_LPAREN] = ACTIONS(4418),
    [anon_sym_RPAREN] = ACTIONS(4418),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym_DOLLAR] = ACTIONS(4418),
    [anon_sym_STAR] = ACTIONS(4418),
    [anon_sym_TILDE] = ACTIONS(4418),
    [sym_bool] = ACTIONS(4416),
    [sym_byte] = ACTIONS(4416),
    [sym_ubyte] = ACTIONS(4416),
    [sym_char] = ACTIONS(4416),
    [sym_short] = ACTIONS(4416),
    [sym_ushort] = ACTIONS(4416),
    [sym_int] = ACTIONS(4416),
    [sym_uint] = ACTIONS(4416),
    [sym_long] = ACTIONS(4416),
    [sym_ulong] = ACTIONS(4416),
    [sym_cent] = ACTIONS(4416),
    [sym_ucent] = ACTIONS(4416),
    [sym_wchar] = ACTIONS(4416),
    [sym_dchar] = ACTIONS(4416),
    [sym_float] = ACTIONS(4416),
    [sym_double] = ACTIONS(4416),
    [sym_real] = ACTIONS(4416),
    [sym_ifloat] = ACTIONS(4416),
    [sym_idouble] = ACTIONS(4416),
    [sym_ireal] = ACTIONS(4416),
    [sym_cfloat] = ACTIONS(4416),
    [sym_cdouble] = ACTIONS(4416),
    [sym_creal] = ACTIONS(4416),
    [sym_size_t] = ACTIONS(4416),
    [sym_ptrdiff_t] = ACTIONS(4416),
    [sym_string] = ACTIONS(4416),
    [sym_cstring] = ACTIONS(4416),
    [sym_dstring] = ACTIONS(4416),
    [sym_wstring] = ACTIONS(4416),
    [sym_noreturn] = ACTIONS(4416),
    [sym_true] = ACTIONS(4416),
    [sym_false] = ACTIONS(4416),
    [sym_null] = ACTIONS(4416),
    [sym_super] = ACTIONS(4416),
    [sym_this] = ACTIONS(4416),
    [sym_assert] = ACTIONS(4416),
    [sym_auto] = ACTIONS(4416),
    [sym_cast] = ACTIONS(4416),
    [sym_catch] = ACTIONS(4416),
    [sym_const] = ACTIONS(4416),
    [sym_delegate] = ACTIONS(4416),
    [sym_delete] = ACTIONS(4416),
    [sym_do] = ACTIONS(4416),
    [sym_else] = ACTIONS(4416),
    [sym_finally] = ACTIONS(4416),
    [sym_function] = ACTIONS(4416),
    [sym_immutable] = ACTIONS(4416),
    [sym_import] = ACTIONS(4416),
    [sym_in] = ACTIONS(4416),
    [sym_inout] = ACTIONS(4416),
    [sym_is] = ACTIONS(4416),
    [sym_mixin] = ACTIONS(4416),
    [sym_new] = ACTIONS(4416),
    [sym_out] = ACTIONS(4416),
    [sym_ref] = ACTIONS(4416),
    [sym_shared] = ACTIONS(4416),
    [sym_throw] = ACTIONS(4416),
    [sym_typeid] = ACTIONS(4416),
    [sym_typeof] = ACTIONS(4416),
    [sym_traits] = ACTIONS(4416),
    [sym_vector] = ACTIONS(4416),
    [sym_void] = ACTIONS(4416),
    [anon_sym_BQUOTE] = ACTIONS(4418),
    [anon_sym_r_DQUOTE] = ACTIONS(4418),
    [anon_sym_x_DQUOTE] = ACTIONS(4418),
    [anon_sym_DQUOTE] = ACTIONS(4418),
    [anon_sym_i_BQUOTE] = ACTIONS(4418),
    [anon_sym_i_DQUOTE] = ACTIONS(4418),
    [anon_sym_iq_LBRACE] = ACTIONS(4418),
    [aux_sym_char_literal_token1] = ACTIONS(4418),
    [anon_sym_SQUOTE] = ACTIONS(4416),
    [anon_sym___DATE__] = ACTIONS(4416),
    [anon_sym___FILE__] = ACTIONS(4416),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4416),
    [anon_sym___FUNCTION__] = ACTIONS(4416),
    [anon_sym___LINE__] = ACTIONS(4416),
    [anon_sym___MODULE__] = ACTIONS(4416),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4416),
    [anon_sym___TIME__] = ACTIONS(4416),
    [anon_sym___TIMESTAMP__] = ACTIONS(4416),
    [anon_sym___VENDOR__] = ACTIONS(4416),
    [anon_sym___VERSION__] = ACTIONS(4416),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4418),
    [sym_float_literal] = ACTIONS(4418),
    [sym__string] = ACTIONS(4418),
  },
  [2104] = {
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_q_LBRACE] = ACTIONS(2640),
    [anon_sym_LBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_AMP] = ACTIONS(2640),
    [anon_sym_DASH] = ACTIONS(2642),
    [anon_sym_DASH_DASH] = ACTIONS(2640),
    [anon_sym_PLUS] = ACTIONS(2642),
    [anon_sym_PLUS_PLUS] = ACTIONS(2640),
    [anon_sym_BANG] = ACTIONS(2640),
    [anon_sym_LPAREN] = ACTIONS(2640),
    [anon_sym_RPAREN] = ACTIONS(2640),
    [anon_sym_LBRACK] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_DOLLAR] = ACTIONS(2640),
    [anon_sym_STAR] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [sym_bool] = ACTIONS(2642),
    [sym_byte] = ACTIONS(2642),
    [sym_ubyte] = ACTIONS(2642),
    [sym_char] = ACTIONS(2642),
    [sym_short] = ACTIONS(2642),
    [sym_ushort] = ACTIONS(2642),
    [sym_int] = ACTIONS(2642),
    [sym_uint] = ACTIONS(2642),
    [sym_long] = ACTIONS(2642),
    [sym_ulong] = ACTIONS(2642),
    [sym_cent] = ACTIONS(2642),
    [sym_ucent] = ACTIONS(2642),
    [sym_wchar] = ACTIONS(2642),
    [sym_dchar] = ACTIONS(2642),
    [sym_float] = ACTIONS(2642),
    [sym_double] = ACTIONS(2642),
    [sym_real] = ACTIONS(2642),
    [sym_ifloat] = ACTIONS(2642),
    [sym_idouble] = ACTIONS(2642),
    [sym_ireal] = ACTIONS(2642),
    [sym_cfloat] = ACTIONS(2642),
    [sym_cdouble] = ACTIONS(2642),
    [sym_creal] = ACTIONS(2642),
    [sym_size_t] = ACTIONS(2642),
    [sym_ptrdiff_t] = ACTIONS(2642),
    [sym_string] = ACTIONS(2642),
    [sym_cstring] = ACTIONS(2642),
    [sym_dstring] = ACTIONS(2642),
    [sym_wstring] = ACTIONS(2642),
    [sym_noreturn] = ACTIONS(2642),
    [sym_true] = ACTIONS(2642),
    [sym_false] = ACTIONS(2642),
    [sym_null] = ACTIONS(2642),
    [sym_super] = ACTIONS(2642),
    [sym_this] = ACTIONS(2642),
    [sym_assert] = ACTIONS(2642),
    [sym_auto] = ACTIONS(2642),
    [sym_cast] = ACTIONS(2642),
    [sym_catch] = ACTIONS(2642),
    [sym_const] = ACTIONS(2642),
    [sym_delegate] = ACTIONS(2642),
    [sym_delete] = ACTIONS(2642),
    [sym_do] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_finally] = ACTIONS(2642),
    [sym_function] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(2642),
    [sym_import] = ACTIONS(2642),
    [sym_in] = ACTIONS(2642),
    [sym_inout] = ACTIONS(2642),
    [sym_is] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2642),
    [sym_new] = ACTIONS(2642),
    [sym_out] = ACTIONS(2642),
    [sym_ref] = ACTIONS(2642),
    [sym_shared] = ACTIONS(2642),
    [sym_throw] = ACTIONS(2642),
    [sym_typeid] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(2642),
    [sym_traits] = ACTIONS(2642),
    [sym_vector] = ACTIONS(2642),
    [sym_void] = ACTIONS(2642),
    [anon_sym_BQUOTE] = ACTIONS(2640),
    [anon_sym_r_DQUOTE] = ACTIONS(2640),
    [anon_sym_x_DQUOTE] = ACTIONS(2640),
    [anon_sym_DQUOTE] = ACTIONS(2640),
    [anon_sym_i_BQUOTE] = ACTIONS(2640),
    [anon_sym_i_DQUOTE] = ACTIONS(2640),
    [anon_sym_iq_LBRACE] = ACTIONS(2640),
    [aux_sym_char_literal_token1] = ACTIONS(2640),
    [anon_sym_SQUOTE] = ACTIONS(2642),
    [anon_sym___DATE__] = ACTIONS(2642),
    [anon_sym___FILE__] = ACTIONS(2642),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2642),
    [anon_sym___FUNCTION__] = ACTIONS(2642),
    [anon_sym___LINE__] = ACTIONS(2642),
    [anon_sym___MODULE__] = ACTIONS(2642),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2642),
    [anon_sym___TIME__] = ACTIONS(2642),
    [anon_sym___TIMESTAMP__] = ACTIONS(2642),
    [anon_sym___VENDOR__] = ACTIONS(2642),
    [anon_sym___VERSION__] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2640),
    [sym_float_literal] = ACTIONS(2640),
    [sym__string] = ACTIONS(2640),
  },
  [2105] = {
    [sym_identifier] = ACTIONS(4502),
    [anon_sym_q_LBRACE] = ACTIONS(4504),
    [anon_sym_LBRACE] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4504),
    [anon_sym_AMP] = ACTIONS(4504),
    [anon_sym_DASH] = ACTIONS(4502),
    [anon_sym_DASH_DASH] = ACTIONS(4504),
    [anon_sym_PLUS] = ACTIONS(4502),
    [anon_sym_PLUS_PLUS] = ACTIONS(4504),
    [anon_sym_BANG] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4504),
    [anon_sym_RPAREN] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4504),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_DOLLAR] = ACTIONS(4504),
    [anon_sym_STAR] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4504),
    [sym_bool] = ACTIONS(4502),
    [sym_byte] = ACTIONS(4502),
    [sym_ubyte] = ACTIONS(4502),
    [sym_char] = ACTIONS(4502),
    [sym_short] = ACTIONS(4502),
    [sym_ushort] = ACTIONS(4502),
    [sym_int] = ACTIONS(4502),
    [sym_uint] = ACTIONS(4502),
    [sym_long] = ACTIONS(4502),
    [sym_ulong] = ACTIONS(4502),
    [sym_cent] = ACTIONS(4502),
    [sym_ucent] = ACTIONS(4502),
    [sym_wchar] = ACTIONS(4502),
    [sym_dchar] = ACTIONS(4502),
    [sym_float] = ACTIONS(4502),
    [sym_double] = ACTIONS(4502),
    [sym_real] = ACTIONS(4502),
    [sym_ifloat] = ACTIONS(4502),
    [sym_idouble] = ACTIONS(4502),
    [sym_ireal] = ACTIONS(4502),
    [sym_cfloat] = ACTIONS(4502),
    [sym_cdouble] = ACTIONS(4502),
    [sym_creal] = ACTIONS(4502),
    [sym_size_t] = ACTIONS(4502),
    [sym_ptrdiff_t] = ACTIONS(4502),
    [sym_string] = ACTIONS(4502),
    [sym_cstring] = ACTIONS(4502),
    [sym_dstring] = ACTIONS(4502),
    [sym_wstring] = ACTIONS(4502),
    [sym_noreturn] = ACTIONS(4502),
    [sym_true] = ACTIONS(4502),
    [sym_false] = ACTIONS(4502),
    [sym_null] = ACTIONS(4502),
    [sym_super] = ACTIONS(4502),
    [sym_this] = ACTIONS(4502),
    [sym_assert] = ACTIONS(4502),
    [sym_auto] = ACTIONS(4502),
    [sym_cast] = ACTIONS(4502),
    [sym_catch] = ACTIONS(4502),
    [sym_const] = ACTIONS(4502),
    [sym_delegate] = ACTIONS(4502),
    [sym_delete] = ACTIONS(4502),
    [sym_do] = ACTIONS(4502),
    [sym_else] = ACTIONS(4502),
    [sym_finally] = ACTIONS(4502),
    [sym_function] = ACTIONS(4502),
    [sym_immutable] = ACTIONS(4502),
    [sym_import] = ACTIONS(4502),
    [sym_in] = ACTIONS(4502),
    [sym_inout] = ACTIONS(4502),
    [sym_is] = ACTIONS(4502),
    [sym_mixin] = ACTIONS(4502),
    [sym_new] = ACTIONS(4502),
    [sym_out] = ACTIONS(4502),
    [sym_ref] = ACTIONS(4502),
    [sym_shared] = ACTIONS(4502),
    [sym_throw] = ACTIONS(4502),
    [sym_typeid] = ACTIONS(4502),
    [sym_typeof] = ACTIONS(4502),
    [sym_traits] = ACTIONS(4502),
    [sym_vector] = ACTIONS(4502),
    [sym_void] = ACTIONS(4502),
    [anon_sym_BQUOTE] = ACTIONS(4504),
    [anon_sym_r_DQUOTE] = ACTIONS(4504),
    [anon_sym_x_DQUOTE] = ACTIONS(4504),
    [anon_sym_DQUOTE] = ACTIONS(4504),
    [anon_sym_i_BQUOTE] = ACTIONS(4504),
    [anon_sym_i_DQUOTE] = ACTIONS(4504),
    [anon_sym_iq_LBRACE] = ACTIONS(4504),
    [aux_sym_char_literal_token1] = ACTIONS(4504),
    [anon_sym_SQUOTE] = ACTIONS(4502),
    [anon_sym___DATE__] = ACTIONS(4502),
    [anon_sym___FILE__] = ACTIONS(4502),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4502),
    [anon_sym___FUNCTION__] = ACTIONS(4502),
    [anon_sym___LINE__] = ACTIONS(4502),
    [anon_sym___MODULE__] = ACTIONS(4502),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4502),
    [anon_sym___TIME__] = ACTIONS(4502),
    [anon_sym___TIMESTAMP__] = ACTIONS(4502),
    [anon_sym___VENDOR__] = ACTIONS(4502),
    [anon_sym___VERSION__] = ACTIONS(4502),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4504),
    [sym_float_literal] = ACTIONS(4504),
    [sym__string] = ACTIONS(4504),
  },
  [2106] = {
    [sym_identifier] = ACTIONS(4498),
    [anon_sym_q_LBRACE] = ACTIONS(4500),
    [anon_sym_LBRACE] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4500),
    [anon_sym_AMP] = ACTIONS(4500),
    [anon_sym_DASH] = ACTIONS(4498),
    [anon_sym_DASH_DASH] = ACTIONS(4500),
    [anon_sym_PLUS] = ACTIONS(4498),
    [anon_sym_PLUS_PLUS] = ACTIONS(4500),
    [anon_sym_BANG] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4500),
    [anon_sym_RPAREN] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4500),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_DOLLAR] = ACTIONS(4500),
    [anon_sym_STAR] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4500),
    [sym_bool] = ACTIONS(4498),
    [sym_byte] = ACTIONS(4498),
    [sym_ubyte] = ACTIONS(4498),
    [sym_char] = ACTIONS(4498),
    [sym_short] = ACTIONS(4498),
    [sym_ushort] = ACTIONS(4498),
    [sym_int] = ACTIONS(4498),
    [sym_uint] = ACTIONS(4498),
    [sym_long] = ACTIONS(4498),
    [sym_ulong] = ACTIONS(4498),
    [sym_cent] = ACTIONS(4498),
    [sym_ucent] = ACTIONS(4498),
    [sym_wchar] = ACTIONS(4498),
    [sym_dchar] = ACTIONS(4498),
    [sym_float] = ACTIONS(4498),
    [sym_double] = ACTIONS(4498),
    [sym_real] = ACTIONS(4498),
    [sym_ifloat] = ACTIONS(4498),
    [sym_idouble] = ACTIONS(4498),
    [sym_ireal] = ACTIONS(4498),
    [sym_cfloat] = ACTIONS(4498),
    [sym_cdouble] = ACTIONS(4498),
    [sym_creal] = ACTIONS(4498),
    [sym_size_t] = ACTIONS(4498),
    [sym_ptrdiff_t] = ACTIONS(4498),
    [sym_string] = ACTIONS(4498),
    [sym_cstring] = ACTIONS(4498),
    [sym_dstring] = ACTIONS(4498),
    [sym_wstring] = ACTIONS(4498),
    [sym_noreturn] = ACTIONS(4498),
    [sym_true] = ACTIONS(4498),
    [sym_false] = ACTIONS(4498),
    [sym_null] = ACTIONS(4498),
    [sym_super] = ACTIONS(4498),
    [sym_this] = ACTIONS(4498),
    [sym_assert] = ACTIONS(4498),
    [sym_auto] = ACTIONS(4498),
    [sym_cast] = ACTIONS(4498),
    [sym_catch] = ACTIONS(4498),
    [sym_const] = ACTIONS(4498),
    [sym_delegate] = ACTIONS(4498),
    [sym_delete] = ACTIONS(4498),
    [sym_do] = ACTIONS(4498),
    [sym_else] = ACTIONS(4498),
    [sym_finally] = ACTIONS(4498),
    [sym_function] = ACTIONS(4498),
    [sym_immutable] = ACTIONS(4498),
    [sym_import] = ACTIONS(4498),
    [sym_in] = ACTIONS(4498),
    [sym_inout] = ACTIONS(4498),
    [sym_is] = ACTIONS(4498),
    [sym_mixin] = ACTIONS(4498),
    [sym_new] = ACTIONS(4498),
    [sym_out] = ACTIONS(4498),
    [sym_ref] = ACTIONS(4498),
    [sym_shared] = ACTIONS(4498),
    [sym_throw] = ACTIONS(4498),
    [sym_typeid] = ACTIONS(4498),
    [sym_typeof] = ACTIONS(4498),
    [sym_traits] = ACTIONS(4498),
    [sym_vector] = ACTIONS(4498),
    [sym_void] = ACTIONS(4498),
    [anon_sym_BQUOTE] = ACTIONS(4500),
    [anon_sym_r_DQUOTE] = ACTIONS(4500),
    [anon_sym_x_DQUOTE] = ACTIONS(4500),
    [anon_sym_DQUOTE] = ACTIONS(4500),
    [anon_sym_i_BQUOTE] = ACTIONS(4500),
    [anon_sym_i_DQUOTE] = ACTIONS(4500),
    [anon_sym_iq_LBRACE] = ACTIONS(4500),
    [aux_sym_char_literal_token1] = ACTIONS(4500),
    [anon_sym_SQUOTE] = ACTIONS(4498),
    [anon_sym___DATE__] = ACTIONS(4498),
    [anon_sym___FILE__] = ACTIONS(4498),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4498),
    [anon_sym___FUNCTION__] = ACTIONS(4498),
    [anon_sym___LINE__] = ACTIONS(4498),
    [anon_sym___MODULE__] = ACTIONS(4498),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4498),
    [anon_sym___TIME__] = ACTIONS(4498),
    [anon_sym___TIMESTAMP__] = ACTIONS(4498),
    [anon_sym___VENDOR__] = ACTIONS(4498),
    [anon_sym___VERSION__] = ACTIONS(4498),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4500),
    [sym_float_literal] = ACTIONS(4500),
    [sym__string] = ACTIONS(4500),
  },
  [2107] = {
    [sym_identifier] = ACTIONS(4388),
    [anon_sym_q_LBRACE] = ACTIONS(4390),
    [anon_sym_LBRACE] = ACTIONS(4390),
    [anon_sym_DOT] = ACTIONS(4390),
    [anon_sym_AMP] = ACTIONS(4390),
    [anon_sym_DASH] = ACTIONS(4388),
    [anon_sym_DASH_DASH] = ACTIONS(4390),
    [anon_sym_PLUS] = ACTIONS(4388),
    [anon_sym_PLUS_PLUS] = ACTIONS(4390),
    [anon_sym_BANG] = ACTIONS(4390),
    [anon_sym_LPAREN] = ACTIONS(4390),
    [anon_sym_RPAREN] = ACTIONS(4390),
    [anon_sym_LBRACK] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4390),
    [anon_sym_DOLLAR] = ACTIONS(4390),
    [anon_sym_STAR] = ACTIONS(4390),
    [anon_sym_TILDE] = ACTIONS(4390),
    [sym_bool] = ACTIONS(4388),
    [sym_byte] = ACTIONS(4388),
    [sym_ubyte] = ACTIONS(4388),
    [sym_char] = ACTIONS(4388),
    [sym_short] = ACTIONS(4388),
    [sym_ushort] = ACTIONS(4388),
    [sym_int] = ACTIONS(4388),
    [sym_uint] = ACTIONS(4388),
    [sym_long] = ACTIONS(4388),
    [sym_ulong] = ACTIONS(4388),
    [sym_cent] = ACTIONS(4388),
    [sym_ucent] = ACTIONS(4388),
    [sym_wchar] = ACTIONS(4388),
    [sym_dchar] = ACTIONS(4388),
    [sym_float] = ACTIONS(4388),
    [sym_double] = ACTIONS(4388),
    [sym_real] = ACTIONS(4388),
    [sym_ifloat] = ACTIONS(4388),
    [sym_idouble] = ACTIONS(4388),
    [sym_ireal] = ACTIONS(4388),
    [sym_cfloat] = ACTIONS(4388),
    [sym_cdouble] = ACTIONS(4388),
    [sym_creal] = ACTIONS(4388),
    [sym_size_t] = ACTIONS(4388),
    [sym_ptrdiff_t] = ACTIONS(4388),
    [sym_string] = ACTIONS(4388),
    [sym_cstring] = ACTIONS(4388),
    [sym_dstring] = ACTIONS(4388),
    [sym_wstring] = ACTIONS(4388),
    [sym_noreturn] = ACTIONS(4388),
    [sym_true] = ACTIONS(4388),
    [sym_false] = ACTIONS(4388),
    [sym_null] = ACTIONS(4388),
    [sym_super] = ACTIONS(4388),
    [sym_this] = ACTIONS(4388),
    [sym_assert] = ACTIONS(4388),
    [sym_auto] = ACTIONS(4388),
    [sym_cast] = ACTIONS(4388),
    [sym_catch] = ACTIONS(4388),
    [sym_const] = ACTIONS(4388),
    [sym_delegate] = ACTIONS(4388),
    [sym_delete] = ACTIONS(4388),
    [sym_do] = ACTIONS(4388),
    [sym_else] = ACTIONS(4388),
    [sym_finally] = ACTIONS(4388),
    [sym_function] = ACTIONS(4388),
    [sym_immutable] = ACTIONS(4388),
    [sym_import] = ACTIONS(4388),
    [sym_in] = ACTIONS(4388),
    [sym_inout] = ACTIONS(4388),
    [sym_is] = ACTIONS(4388),
    [sym_mixin] = ACTIONS(4388),
    [sym_new] = ACTIONS(4388),
    [sym_out] = ACTIONS(4388),
    [sym_ref] = ACTIONS(4388),
    [sym_shared] = ACTIONS(4388),
    [sym_throw] = ACTIONS(4388),
    [sym_typeid] = ACTIONS(4388),
    [sym_typeof] = ACTIONS(4388),
    [sym_traits] = ACTIONS(4388),
    [sym_vector] = ACTIONS(4388),
    [sym_void] = ACTIONS(4388),
    [anon_sym_BQUOTE] = ACTIONS(4390),
    [anon_sym_r_DQUOTE] = ACTIONS(4390),
    [anon_sym_x_DQUOTE] = ACTIONS(4390),
    [anon_sym_DQUOTE] = ACTIONS(4390),
    [anon_sym_i_BQUOTE] = ACTIONS(4390),
    [anon_sym_i_DQUOTE] = ACTIONS(4390),
    [anon_sym_iq_LBRACE] = ACTIONS(4390),
    [aux_sym_char_literal_token1] = ACTIONS(4390),
    [anon_sym_SQUOTE] = ACTIONS(4388),
    [anon_sym___DATE__] = ACTIONS(4388),
    [anon_sym___FILE__] = ACTIONS(4388),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4388),
    [anon_sym___FUNCTION__] = ACTIONS(4388),
    [anon_sym___LINE__] = ACTIONS(4388),
    [anon_sym___MODULE__] = ACTIONS(4388),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4388),
    [anon_sym___TIME__] = ACTIONS(4388),
    [anon_sym___TIMESTAMP__] = ACTIONS(4388),
    [anon_sym___VENDOR__] = ACTIONS(4388),
    [anon_sym___VERSION__] = ACTIONS(4388),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4390),
    [sym_float_literal] = ACTIONS(4390),
    [sym__string] = ACTIONS(4390),
  },
  [2108] = {
    [sym_identifier] = ACTIONS(4494),
    [anon_sym_q_LBRACE] = ACTIONS(4496),
    [anon_sym_LBRACE] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_AMP] = ACTIONS(4496),
    [anon_sym_DASH] = ACTIONS(4494),
    [anon_sym_DASH_DASH] = ACTIONS(4496),
    [anon_sym_PLUS] = ACTIONS(4494),
    [anon_sym_PLUS_PLUS] = ACTIONS(4496),
    [anon_sym_BANG] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4496),
    [anon_sym_RPAREN] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_STAR] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [sym_bool] = ACTIONS(4494),
    [sym_byte] = ACTIONS(4494),
    [sym_ubyte] = ACTIONS(4494),
    [sym_char] = ACTIONS(4494),
    [sym_short] = ACTIONS(4494),
    [sym_ushort] = ACTIONS(4494),
    [sym_int] = ACTIONS(4494),
    [sym_uint] = ACTIONS(4494),
    [sym_long] = ACTIONS(4494),
    [sym_ulong] = ACTIONS(4494),
    [sym_cent] = ACTIONS(4494),
    [sym_ucent] = ACTIONS(4494),
    [sym_wchar] = ACTIONS(4494),
    [sym_dchar] = ACTIONS(4494),
    [sym_float] = ACTIONS(4494),
    [sym_double] = ACTIONS(4494),
    [sym_real] = ACTIONS(4494),
    [sym_ifloat] = ACTIONS(4494),
    [sym_idouble] = ACTIONS(4494),
    [sym_ireal] = ACTIONS(4494),
    [sym_cfloat] = ACTIONS(4494),
    [sym_cdouble] = ACTIONS(4494),
    [sym_creal] = ACTIONS(4494),
    [sym_size_t] = ACTIONS(4494),
    [sym_ptrdiff_t] = ACTIONS(4494),
    [sym_string] = ACTIONS(4494),
    [sym_cstring] = ACTIONS(4494),
    [sym_dstring] = ACTIONS(4494),
    [sym_wstring] = ACTIONS(4494),
    [sym_noreturn] = ACTIONS(4494),
    [sym_true] = ACTIONS(4494),
    [sym_false] = ACTIONS(4494),
    [sym_null] = ACTIONS(4494),
    [sym_super] = ACTIONS(4494),
    [sym_this] = ACTIONS(4494),
    [sym_assert] = ACTIONS(4494),
    [sym_auto] = ACTIONS(4494),
    [sym_cast] = ACTIONS(4494),
    [sym_catch] = ACTIONS(4494),
    [sym_const] = ACTIONS(4494),
    [sym_delegate] = ACTIONS(4494),
    [sym_delete] = ACTIONS(4494),
    [sym_do] = ACTIONS(4494),
    [sym_else] = ACTIONS(4494),
    [sym_finally] = ACTIONS(4494),
    [sym_function] = ACTIONS(4494),
    [sym_immutable] = ACTIONS(4494),
    [sym_import] = ACTIONS(4494),
    [sym_in] = ACTIONS(4494),
    [sym_inout] = ACTIONS(4494),
    [sym_is] = ACTIONS(4494),
    [sym_mixin] = ACTIONS(4494),
    [sym_new] = ACTIONS(4494),
    [sym_out] = ACTIONS(4494),
    [sym_ref] = ACTIONS(4494),
    [sym_shared] = ACTIONS(4494),
    [sym_throw] = ACTIONS(4494),
    [sym_typeid] = ACTIONS(4494),
    [sym_typeof] = ACTIONS(4494),
    [sym_traits] = ACTIONS(4494),
    [sym_vector] = ACTIONS(4494),
    [sym_void] = ACTIONS(4494),
    [anon_sym_BQUOTE] = ACTIONS(4496),
    [anon_sym_r_DQUOTE] = ACTIONS(4496),
    [anon_sym_x_DQUOTE] = ACTIONS(4496),
    [anon_sym_DQUOTE] = ACTIONS(4496),
    [anon_sym_i_BQUOTE] = ACTIONS(4496),
    [anon_sym_i_DQUOTE] = ACTIONS(4496),
    [anon_sym_iq_LBRACE] = ACTIONS(4496),
    [aux_sym_char_literal_token1] = ACTIONS(4496),
    [anon_sym_SQUOTE] = ACTIONS(4494),
    [anon_sym___DATE__] = ACTIONS(4494),
    [anon_sym___FILE__] = ACTIONS(4494),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4494),
    [anon_sym___FUNCTION__] = ACTIONS(4494),
    [anon_sym___LINE__] = ACTIONS(4494),
    [anon_sym___MODULE__] = ACTIONS(4494),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4494),
    [anon_sym___TIME__] = ACTIONS(4494),
    [anon_sym___TIMESTAMP__] = ACTIONS(4494),
    [anon_sym___VENDOR__] = ACTIONS(4494),
    [anon_sym___VERSION__] = ACTIONS(4494),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4496),
    [sym_float_literal] = ACTIONS(4496),
    [sym__string] = ACTIONS(4496),
  },
  [2109] = {
    [sym_identifier] = ACTIONS(4490),
    [anon_sym_q_LBRACE] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4492),
    [anon_sym_DOT] = ACTIONS(4492),
    [anon_sym_AMP] = ACTIONS(4492),
    [anon_sym_DASH] = ACTIONS(4490),
    [anon_sym_DASH_DASH] = ACTIONS(4492),
    [anon_sym_PLUS] = ACTIONS(4490),
    [anon_sym_PLUS_PLUS] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4492),
    [anon_sym_LPAREN] = ACTIONS(4492),
    [anon_sym_RPAREN] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_SEMI] = ACTIONS(4492),
    [anon_sym_DOLLAR] = ACTIONS(4492),
    [anon_sym_STAR] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4492),
    [sym_bool] = ACTIONS(4490),
    [sym_byte] = ACTIONS(4490),
    [sym_ubyte] = ACTIONS(4490),
    [sym_char] = ACTIONS(4490),
    [sym_short] = ACTIONS(4490),
    [sym_ushort] = ACTIONS(4490),
    [sym_int] = ACTIONS(4490),
    [sym_uint] = ACTIONS(4490),
    [sym_long] = ACTIONS(4490),
    [sym_ulong] = ACTIONS(4490),
    [sym_cent] = ACTIONS(4490),
    [sym_ucent] = ACTIONS(4490),
    [sym_wchar] = ACTIONS(4490),
    [sym_dchar] = ACTIONS(4490),
    [sym_float] = ACTIONS(4490),
    [sym_double] = ACTIONS(4490),
    [sym_real] = ACTIONS(4490),
    [sym_ifloat] = ACTIONS(4490),
    [sym_idouble] = ACTIONS(4490),
    [sym_ireal] = ACTIONS(4490),
    [sym_cfloat] = ACTIONS(4490),
    [sym_cdouble] = ACTIONS(4490),
    [sym_creal] = ACTIONS(4490),
    [sym_size_t] = ACTIONS(4490),
    [sym_ptrdiff_t] = ACTIONS(4490),
    [sym_string] = ACTIONS(4490),
    [sym_cstring] = ACTIONS(4490),
    [sym_dstring] = ACTIONS(4490),
    [sym_wstring] = ACTIONS(4490),
    [sym_noreturn] = ACTIONS(4490),
    [sym_true] = ACTIONS(4490),
    [sym_false] = ACTIONS(4490),
    [sym_null] = ACTIONS(4490),
    [sym_super] = ACTIONS(4490),
    [sym_this] = ACTIONS(4490),
    [sym_assert] = ACTIONS(4490),
    [sym_auto] = ACTIONS(4490),
    [sym_cast] = ACTIONS(4490),
    [sym_catch] = ACTIONS(4490),
    [sym_const] = ACTIONS(4490),
    [sym_delegate] = ACTIONS(4490),
    [sym_delete] = ACTIONS(4490),
    [sym_do] = ACTIONS(4490),
    [sym_else] = ACTIONS(4490),
    [sym_finally] = ACTIONS(4490),
    [sym_function] = ACTIONS(4490),
    [sym_immutable] = ACTIONS(4490),
    [sym_import] = ACTIONS(4490),
    [sym_in] = ACTIONS(4490),
    [sym_inout] = ACTIONS(4490),
    [sym_is] = ACTIONS(4490),
    [sym_mixin] = ACTIONS(4490),
    [sym_new] = ACTIONS(4490),
    [sym_out] = ACTIONS(4490),
    [sym_ref] = ACTIONS(4490),
    [sym_shared] = ACTIONS(4490),
    [sym_throw] = ACTIONS(4490),
    [sym_typeid] = ACTIONS(4490),
    [sym_typeof] = ACTIONS(4490),
    [sym_traits] = ACTIONS(4490),
    [sym_vector] = ACTIONS(4490),
    [sym_void] = ACTIONS(4490),
    [anon_sym_BQUOTE] = ACTIONS(4492),
    [anon_sym_r_DQUOTE] = ACTIONS(4492),
    [anon_sym_x_DQUOTE] = ACTIONS(4492),
    [anon_sym_DQUOTE] = ACTIONS(4492),
    [anon_sym_i_BQUOTE] = ACTIONS(4492),
    [anon_sym_i_DQUOTE] = ACTIONS(4492),
    [anon_sym_iq_LBRACE] = ACTIONS(4492),
    [aux_sym_char_literal_token1] = ACTIONS(4492),
    [anon_sym_SQUOTE] = ACTIONS(4490),
    [anon_sym___DATE__] = ACTIONS(4490),
    [anon_sym___FILE__] = ACTIONS(4490),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4490),
    [anon_sym___FUNCTION__] = ACTIONS(4490),
    [anon_sym___LINE__] = ACTIONS(4490),
    [anon_sym___MODULE__] = ACTIONS(4490),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4490),
    [anon_sym___TIME__] = ACTIONS(4490),
    [anon_sym___TIMESTAMP__] = ACTIONS(4490),
    [anon_sym___VENDOR__] = ACTIONS(4490),
    [anon_sym___VERSION__] = ACTIONS(4490),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4492),
    [sym_float_literal] = ACTIONS(4492),
    [sym__string] = ACTIONS(4492),
  },
  [2110] = {
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_q_LBRACE] = ACTIONS(4484),
    [anon_sym_LBRACE] = ACTIONS(4484),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_AMP] = ACTIONS(4484),
    [anon_sym_DASH] = ACTIONS(4482),
    [anon_sym_DASH_DASH] = ACTIONS(4484),
    [anon_sym_PLUS] = ACTIONS(4482),
    [anon_sym_PLUS_PLUS] = ACTIONS(4484),
    [anon_sym_BANG] = ACTIONS(4484),
    [anon_sym_LPAREN] = ACTIONS(4484),
    [anon_sym_RPAREN] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_DOLLAR] = ACTIONS(4484),
    [anon_sym_STAR] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4484),
    [sym_bool] = ACTIONS(4482),
    [sym_byte] = ACTIONS(4482),
    [sym_ubyte] = ACTIONS(4482),
    [sym_char] = ACTIONS(4482),
    [sym_short] = ACTIONS(4482),
    [sym_ushort] = ACTIONS(4482),
    [sym_int] = ACTIONS(4482),
    [sym_uint] = ACTIONS(4482),
    [sym_long] = ACTIONS(4482),
    [sym_ulong] = ACTIONS(4482),
    [sym_cent] = ACTIONS(4482),
    [sym_ucent] = ACTIONS(4482),
    [sym_wchar] = ACTIONS(4482),
    [sym_dchar] = ACTIONS(4482),
    [sym_float] = ACTIONS(4482),
    [sym_double] = ACTIONS(4482),
    [sym_real] = ACTIONS(4482),
    [sym_ifloat] = ACTIONS(4482),
    [sym_idouble] = ACTIONS(4482),
    [sym_ireal] = ACTIONS(4482),
    [sym_cfloat] = ACTIONS(4482),
    [sym_cdouble] = ACTIONS(4482),
    [sym_creal] = ACTIONS(4482),
    [sym_size_t] = ACTIONS(4482),
    [sym_ptrdiff_t] = ACTIONS(4482),
    [sym_string] = ACTIONS(4482),
    [sym_cstring] = ACTIONS(4482),
    [sym_dstring] = ACTIONS(4482),
    [sym_wstring] = ACTIONS(4482),
    [sym_noreturn] = ACTIONS(4482),
    [sym_true] = ACTIONS(4482),
    [sym_false] = ACTIONS(4482),
    [sym_null] = ACTIONS(4482),
    [sym_super] = ACTIONS(4482),
    [sym_this] = ACTIONS(4482),
    [sym_assert] = ACTIONS(4482),
    [sym_auto] = ACTIONS(4482),
    [sym_cast] = ACTIONS(4482),
    [sym_catch] = ACTIONS(4482),
    [sym_const] = ACTIONS(4482),
    [sym_delegate] = ACTIONS(4482),
    [sym_delete] = ACTIONS(4482),
    [sym_do] = ACTIONS(4482),
    [sym_else] = ACTIONS(4482),
    [sym_finally] = ACTIONS(4482),
    [sym_function] = ACTIONS(4482),
    [sym_immutable] = ACTIONS(4482),
    [sym_import] = ACTIONS(4482),
    [sym_in] = ACTIONS(4482),
    [sym_inout] = ACTIONS(4482),
    [sym_is] = ACTIONS(4482),
    [sym_mixin] = ACTIONS(4482),
    [sym_new] = ACTIONS(4482),
    [sym_out] = ACTIONS(4482),
    [sym_ref] = ACTIONS(4482),
    [sym_shared] = ACTIONS(4482),
    [sym_throw] = ACTIONS(4482),
    [sym_typeid] = ACTIONS(4482),
    [sym_typeof] = ACTIONS(4482),
    [sym_traits] = ACTIONS(4482),
    [sym_vector] = ACTIONS(4482),
    [sym_void] = ACTIONS(4482),
    [anon_sym_BQUOTE] = ACTIONS(4484),
    [anon_sym_r_DQUOTE] = ACTIONS(4484),
    [anon_sym_x_DQUOTE] = ACTIONS(4484),
    [anon_sym_DQUOTE] = ACTIONS(4484),
    [anon_sym_i_BQUOTE] = ACTIONS(4484),
    [anon_sym_i_DQUOTE] = ACTIONS(4484),
    [anon_sym_iq_LBRACE] = ACTIONS(4484),
    [aux_sym_char_literal_token1] = ACTIONS(4484),
    [anon_sym_SQUOTE] = ACTIONS(4482),
    [anon_sym___DATE__] = ACTIONS(4482),
    [anon_sym___FILE__] = ACTIONS(4482),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4482),
    [anon_sym___FUNCTION__] = ACTIONS(4482),
    [anon_sym___LINE__] = ACTIONS(4482),
    [anon_sym___MODULE__] = ACTIONS(4482),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4482),
    [anon_sym___TIME__] = ACTIONS(4482),
    [anon_sym___TIMESTAMP__] = ACTIONS(4482),
    [anon_sym___VENDOR__] = ACTIONS(4482),
    [anon_sym___VERSION__] = ACTIONS(4482),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4484),
    [sym_float_literal] = ACTIONS(4484),
    [sym__string] = ACTIONS(4484),
  },
  [2111] = {
    [sym_identifier] = ACTIONS(4322),
    [anon_sym_q_LBRACE] = ACTIONS(4324),
    [anon_sym_LBRACE] = ACTIONS(4324),
    [anon_sym_DOT] = ACTIONS(4324),
    [anon_sym_AMP] = ACTIONS(4324),
    [anon_sym_DASH] = ACTIONS(4322),
    [anon_sym_DASH_DASH] = ACTIONS(4324),
    [anon_sym_PLUS] = ACTIONS(4322),
    [anon_sym_PLUS_PLUS] = ACTIONS(4324),
    [anon_sym_BANG] = ACTIONS(4324),
    [anon_sym_LPAREN] = ACTIONS(4324),
    [anon_sym_RPAREN] = ACTIONS(4324),
    [anon_sym_LBRACK] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_DOLLAR] = ACTIONS(4324),
    [anon_sym_STAR] = ACTIONS(4324),
    [anon_sym_TILDE] = ACTIONS(4324),
    [sym_bool] = ACTIONS(4322),
    [sym_byte] = ACTIONS(4322),
    [sym_ubyte] = ACTIONS(4322),
    [sym_char] = ACTIONS(4322),
    [sym_short] = ACTIONS(4322),
    [sym_ushort] = ACTIONS(4322),
    [sym_int] = ACTIONS(4322),
    [sym_uint] = ACTIONS(4322),
    [sym_long] = ACTIONS(4322),
    [sym_ulong] = ACTIONS(4322),
    [sym_cent] = ACTIONS(4322),
    [sym_ucent] = ACTIONS(4322),
    [sym_wchar] = ACTIONS(4322),
    [sym_dchar] = ACTIONS(4322),
    [sym_float] = ACTIONS(4322),
    [sym_double] = ACTIONS(4322),
    [sym_real] = ACTIONS(4322),
    [sym_ifloat] = ACTIONS(4322),
    [sym_idouble] = ACTIONS(4322),
    [sym_ireal] = ACTIONS(4322),
    [sym_cfloat] = ACTIONS(4322),
    [sym_cdouble] = ACTIONS(4322),
    [sym_creal] = ACTIONS(4322),
    [sym_size_t] = ACTIONS(4322),
    [sym_ptrdiff_t] = ACTIONS(4322),
    [sym_string] = ACTIONS(4322),
    [sym_cstring] = ACTIONS(4322),
    [sym_dstring] = ACTIONS(4322),
    [sym_wstring] = ACTIONS(4322),
    [sym_noreturn] = ACTIONS(4322),
    [sym_true] = ACTIONS(4322),
    [sym_false] = ACTIONS(4322),
    [sym_null] = ACTIONS(4322),
    [sym_super] = ACTIONS(4322),
    [sym_this] = ACTIONS(4322),
    [sym_assert] = ACTIONS(4322),
    [sym_auto] = ACTIONS(4322),
    [sym_cast] = ACTIONS(4322),
    [sym_catch] = ACTIONS(4322),
    [sym_const] = ACTIONS(4322),
    [sym_delegate] = ACTIONS(4322),
    [sym_delete] = ACTIONS(4322),
    [sym_do] = ACTIONS(4322),
    [sym_else] = ACTIONS(4322),
    [sym_finally] = ACTIONS(4322),
    [sym_function] = ACTIONS(4322),
    [sym_immutable] = ACTIONS(4322),
    [sym_import] = ACTIONS(4322),
    [sym_in] = ACTIONS(4322),
    [sym_inout] = ACTIONS(4322),
    [sym_is] = ACTIONS(4322),
    [sym_mixin] = ACTIONS(4322),
    [sym_new] = ACTIONS(4322),
    [sym_out] = ACTIONS(4322),
    [sym_ref] = ACTIONS(4322),
    [sym_shared] = ACTIONS(4322),
    [sym_throw] = ACTIONS(4322),
    [sym_typeid] = ACTIONS(4322),
    [sym_typeof] = ACTIONS(4322),
    [sym_traits] = ACTIONS(4322),
    [sym_vector] = ACTIONS(4322),
    [sym_void] = ACTIONS(4322),
    [anon_sym_BQUOTE] = ACTIONS(4324),
    [anon_sym_r_DQUOTE] = ACTIONS(4324),
    [anon_sym_x_DQUOTE] = ACTIONS(4324),
    [anon_sym_DQUOTE] = ACTIONS(4324),
    [anon_sym_i_BQUOTE] = ACTIONS(4324),
    [anon_sym_i_DQUOTE] = ACTIONS(4324),
    [anon_sym_iq_LBRACE] = ACTIONS(4324),
    [aux_sym_char_literal_token1] = ACTIONS(4324),
    [anon_sym_SQUOTE] = ACTIONS(4322),
    [anon_sym___DATE__] = ACTIONS(4322),
    [anon_sym___FILE__] = ACTIONS(4322),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4322),
    [anon_sym___FUNCTION__] = ACTIONS(4322),
    [anon_sym___LINE__] = ACTIONS(4322),
    [anon_sym___MODULE__] = ACTIONS(4322),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4322),
    [anon_sym___TIME__] = ACTIONS(4322),
    [anon_sym___TIMESTAMP__] = ACTIONS(4322),
    [anon_sym___VENDOR__] = ACTIONS(4322),
    [anon_sym___VERSION__] = ACTIONS(4322),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4324),
    [sym_float_literal] = ACTIONS(4324),
    [sym__string] = ACTIONS(4324),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(4656),
    [anon_sym_q_LBRACE] = ACTIONS(4658),
    [anon_sym_LBRACE] = ACTIONS(4658),
    [anon_sym_DOT] = ACTIONS(4658),
    [anon_sym_AMP] = ACTIONS(4658),
    [anon_sym_DASH] = ACTIONS(4656),
    [anon_sym_DASH_DASH] = ACTIONS(4658),
    [anon_sym_PLUS] = ACTIONS(4656),
    [anon_sym_PLUS_PLUS] = ACTIONS(4658),
    [anon_sym_BANG] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(4658),
    [anon_sym_RPAREN] = ACTIONS(4658),
    [anon_sym_LBRACK] = ACTIONS(4658),
    [anon_sym_SEMI] = ACTIONS(4658),
    [anon_sym_DOLLAR] = ACTIONS(4658),
    [anon_sym_STAR] = ACTIONS(4658),
    [anon_sym_TILDE] = ACTIONS(4658),
    [sym_bool] = ACTIONS(4656),
    [sym_byte] = ACTIONS(4656),
    [sym_ubyte] = ACTIONS(4656),
    [sym_char] = ACTIONS(4656),
    [sym_short] = ACTIONS(4656),
    [sym_ushort] = ACTIONS(4656),
    [sym_int] = ACTIONS(4656),
    [sym_uint] = ACTIONS(4656),
    [sym_long] = ACTIONS(4656),
    [sym_ulong] = ACTIONS(4656),
    [sym_cent] = ACTIONS(4656),
    [sym_ucent] = ACTIONS(4656),
    [sym_wchar] = ACTIONS(4656),
    [sym_dchar] = ACTIONS(4656),
    [sym_float] = ACTIONS(4656),
    [sym_double] = ACTIONS(4656),
    [sym_real] = ACTIONS(4656),
    [sym_ifloat] = ACTIONS(4656),
    [sym_idouble] = ACTIONS(4656),
    [sym_ireal] = ACTIONS(4656),
    [sym_cfloat] = ACTIONS(4656),
    [sym_cdouble] = ACTIONS(4656),
    [sym_creal] = ACTIONS(4656),
    [sym_size_t] = ACTIONS(4656),
    [sym_ptrdiff_t] = ACTIONS(4656),
    [sym_string] = ACTIONS(4656),
    [sym_cstring] = ACTIONS(4656),
    [sym_dstring] = ACTIONS(4656),
    [sym_wstring] = ACTIONS(4656),
    [sym_noreturn] = ACTIONS(4656),
    [sym_true] = ACTIONS(4656),
    [sym_false] = ACTIONS(4656),
    [sym_null] = ACTIONS(4656),
    [sym_super] = ACTIONS(4656),
    [sym_this] = ACTIONS(4656),
    [sym_assert] = ACTIONS(4656),
    [sym_auto] = ACTIONS(4656),
    [sym_cast] = ACTIONS(4656),
    [sym_catch] = ACTIONS(4656),
    [sym_const] = ACTIONS(4656),
    [sym_delegate] = ACTIONS(4656),
    [sym_delete] = ACTIONS(4656),
    [sym_do] = ACTIONS(4656),
    [sym_else] = ACTIONS(4656),
    [sym_finally] = ACTIONS(4656),
    [sym_function] = ACTIONS(4656),
    [sym_immutable] = ACTIONS(4656),
    [sym_import] = ACTIONS(4656),
    [sym_in] = ACTIONS(4656),
    [sym_inout] = ACTIONS(4656),
    [sym_is] = ACTIONS(4656),
    [sym_mixin] = ACTIONS(4656),
    [sym_new] = ACTIONS(4656),
    [sym_out] = ACTIONS(4656),
    [sym_ref] = ACTIONS(4656),
    [sym_shared] = ACTIONS(4656),
    [sym_throw] = ACTIONS(4656),
    [sym_typeid] = ACTIONS(4656),
    [sym_typeof] = ACTIONS(4656),
    [sym_traits] = ACTIONS(4656),
    [sym_vector] = ACTIONS(4656),
    [sym_void] = ACTIONS(4656),
    [anon_sym_BQUOTE] = ACTIONS(4658),
    [anon_sym_r_DQUOTE] = ACTIONS(4658),
    [anon_sym_x_DQUOTE] = ACTIONS(4658),
    [anon_sym_DQUOTE] = ACTIONS(4658),
    [anon_sym_i_BQUOTE] = ACTIONS(4658),
    [anon_sym_i_DQUOTE] = ACTIONS(4658),
    [anon_sym_iq_LBRACE] = ACTIONS(4658),
    [aux_sym_char_literal_token1] = ACTIONS(4658),
    [anon_sym_SQUOTE] = ACTIONS(4656),
    [anon_sym___DATE__] = ACTIONS(4656),
    [anon_sym___FILE__] = ACTIONS(4656),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4656),
    [anon_sym___FUNCTION__] = ACTIONS(4656),
    [anon_sym___LINE__] = ACTIONS(4656),
    [anon_sym___MODULE__] = ACTIONS(4656),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4656),
    [anon_sym___TIME__] = ACTIONS(4656),
    [anon_sym___TIMESTAMP__] = ACTIONS(4656),
    [anon_sym___VENDOR__] = ACTIONS(4656),
    [anon_sym___VERSION__] = ACTIONS(4656),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4658),
    [sym_float_literal] = ACTIONS(4658),
    [sym__string] = ACTIONS(4658),
  },
  [2113] = {
    [sym_identifier] = ACTIONS(4562),
    [anon_sym_q_LBRACE] = ACTIONS(4564),
    [anon_sym_LBRACE] = ACTIONS(4564),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_AMP] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4562),
    [anon_sym_DASH_DASH] = ACTIONS(4564),
    [anon_sym_PLUS] = ACTIONS(4562),
    [anon_sym_PLUS_PLUS] = ACTIONS(4564),
    [anon_sym_BANG] = ACTIONS(4564),
    [anon_sym_LPAREN] = ACTIONS(4564),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_LBRACK] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_DOLLAR] = ACTIONS(4564),
    [anon_sym_STAR] = ACTIONS(4564),
    [anon_sym_TILDE] = ACTIONS(4564),
    [sym_bool] = ACTIONS(4562),
    [sym_byte] = ACTIONS(4562),
    [sym_ubyte] = ACTIONS(4562),
    [sym_char] = ACTIONS(4562),
    [sym_short] = ACTIONS(4562),
    [sym_ushort] = ACTIONS(4562),
    [sym_int] = ACTIONS(4562),
    [sym_uint] = ACTIONS(4562),
    [sym_long] = ACTIONS(4562),
    [sym_ulong] = ACTIONS(4562),
    [sym_cent] = ACTIONS(4562),
    [sym_ucent] = ACTIONS(4562),
    [sym_wchar] = ACTIONS(4562),
    [sym_dchar] = ACTIONS(4562),
    [sym_float] = ACTIONS(4562),
    [sym_double] = ACTIONS(4562),
    [sym_real] = ACTIONS(4562),
    [sym_ifloat] = ACTIONS(4562),
    [sym_idouble] = ACTIONS(4562),
    [sym_ireal] = ACTIONS(4562),
    [sym_cfloat] = ACTIONS(4562),
    [sym_cdouble] = ACTIONS(4562),
    [sym_creal] = ACTIONS(4562),
    [sym_size_t] = ACTIONS(4562),
    [sym_ptrdiff_t] = ACTIONS(4562),
    [sym_string] = ACTIONS(4562),
    [sym_cstring] = ACTIONS(4562),
    [sym_dstring] = ACTIONS(4562),
    [sym_wstring] = ACTIONS(4562),
    [sym_noreturn] = ACTIONS(4562),
    [sym_true] = ACTIONS(4562),
    [sym_false] = ACTIONS(4562),
    [sym_null] = ACTIONS(4562),
    [sym_super] = ACTIONS(4562),
    [sym_this] = ACTIONS(4562),
    [sym_assert] = ACTIONS(4562),
    [sym_auto] = ACTIONS(4562),
    [sym_cast] = ACTIONS(4562),
    [sym_catch] = ACTIONS(4562),
    [sym_const] = ACTIONS(4562),
    [sym_delegate] = ACTIONS(4562),
    [sym_delete] = ACTIONS(4562),
    [sym_do] = ACTIONS(4562),
    [sym_else] = ACTIONS(4562),
    [sym_finally] = ACTIONS(4562),
    [sym_function] = ACTIONS(4562),
    [sym_immutable] = ACTIONS(4562),
    [sym_import] = ACTIONS(4562),
    [sym_in] = ACTIONS(4562),
    [sym_inout] = ACTIONS(4562),
    [sym_is] = ACTIONS(4562),
    [sym_mixin] = ACTIONS(4562),
    [sym_new] = ACTIONS(4562),
    [sym_out] = ACTIONS(4562),
    [sym_ref] = ACTIONS(4562),
    [sym_shared] = ACTIONS(4562),
    [sym_throw] = ACTIONS(4562),
    [sym_typeid] = ACTIONS(4562),
    [sym_typeof] = ACTIONS(4562),
    [sym_traits] = ACTIONS(4562),
    [sym_vector] = ACTIONS(4562),
    [sym_void] = ACTIONS(4562),
    [anon_sym_BQUOTE] = ACTIONS(4564),
    [anon_sym_r_DQUOTE] = ACTIONS(4564),
    [anon_sym_x_DQUOTE] = ACTIONS(4564),
    [anon_sym_DQUOTE] = ACTIONS(4564),
    [anon_sym_i_BQUOTE] = ACTIONS(4564),
    [anon_sym_i_DQUOTE] = ACTIONS(4564),
    [anon_sym_iq_LBRACE] = ACTIONS(4564),
    [aux_sym_char_literal_token1] = ACTIONS(4564),
    [anon_sym_SQUOTE] = ACTIONS(4562),
    [anon_sym___DATE__] = ACTIONS(4562),
    [anon_sym___FILE__] = ACTIONS(4562),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4562),
    [anon_sym___FUNCTION__] = ACTIONS(4562),
    [anon_sym___LINE__] = ACTIONS(4562),
    [anon_sym___MODULE__] = ACTIONS(4562),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4562),
    [anon_sym___TIME__] = ACTIONS(4562),
    [anon_sym___TIMESTAMP__] = ACTIONS(4562),
    [anon_sym___VENDOR__] = ACTIONS(4562),
    [anon_sym___VERSION__] = ACTIONS(4562),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4564),
    [sym_float_literal] = ACTIONS(4564),
    [sym__string] = ACTIONS(4564),
  },
  [2114] = {
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_q_LBRACE] = ACTIONS(4608),
    [anon_sym_LBRACE] = ACTIONS(4608),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_AMP] = ACTIONS(4608),
    [anon_sym_DASH] = ACTIONS(4606),
    [anon_sym_DASH_DASH] = ACTIONS(4608),
    [anon_sym_PLUS] = ACTIONS(4606),
    [anon_sym_PLUS_PLUS] = ACTIONS(4608),
    [anon_sym_BANG] = ACTIONS(4608),
    [anon_sym_LPAREN] = ACTIONS(4608),
    [anon_sym_RPAREN] = ACTIONS(4608),
    [anon_sym_LBRACK] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4608),
    [anon_sym_DOLLAR] = ACTIONS(4608),
    [anon_sym_STAR] = ACTIONS(4608),
    [anon_sym_TILDE] = ACTIONS(4608),
    [sym_bool] = ACTIONS(4606),
    [sym_byte] = ACTIONS(4606),
    [sym_ubyte] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_short] = ACTIONS(4606),
    [sym_ushort] = ACTIONS(4606),
    [sym_int] = ACTIONS(4606),
    [sym_uint] = ACTIONS(4606),
    [sym_long] = ACTIONS(4606),
    [sym_ulong] = ACTIONS(4606),
    [sym_cent] = ACTIONS(4606),
    [sym_ucent] = ACTIONS(4606),
    [sym_wchar] = ACTIONS(4606),
    [sym_dchar] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_double] = ACTIONS(4606),
    [sym_real] = ACTIONS(4606),
    [sym_ifloat] = ACTIONS(4606),
    [sym_idouble] = ACTIONS(4606),
    [sym_ireal] = ACTIONS(4606),
    [sym_cfloat] = ACTIONS(4606),
    [sym_cdouble] = ACTIONS(4606),
    [sym_creal] = ACTIONS(4606),
    [sym_size_t] = ACTIONS(4606),
    [sym_ptrdiff_t] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym_cstring] = ACTIONS(4606),
    [sym_dstring] = ACTIONS(4606),
    [sym_wstring] = ACTIONS(4606),
    [sym_noreturn] = ACTIONS(4606),
    [sym_true] = ACTIONS(4606),
    [sym_false] = ACTIONS(4606),
    [sym_null] = ACTIONS(4606),
    [sym_super] = ACTIONS(4606),
    [sym_this] = ACTIONS(4606),
    [sym_assert] = ACTIONS(4606),
    [sym_auto] = ACTIONS(4606),
    [sym_cast] = ACTIONS(4606),
    [sym_catch] = ACTIONS(4606),
    [sym_const] = ACTIONS(4606),
    [sym_delegate] = ACTIONS(4606),
    [sym_delete] = ACTIONS(4606),
    [sym_do] = ACTIONS(4606),
    [sym_else] = ACTIONS(4606),
    [sym_finally] = ACTIONS(4606),
    [sym_function] = ACTIONS(4606),
    [sym_immutable] = ACTIONS(4606),
    [sym_import] = ACTIONS(4606),
    [sym_in] = ACTIONS(4606),
    [sym_inout] = ACTIONS(4606),
    [sym_is] = ACTIONS(4606),
    [sym_mixin] = ACTIONS(4606),
    [sym_new] = ACTIONS(4606),
    [sym_out] = ACTIONS(4606),
    [sym_ref] = ACTIONS(4606),
    [sym_shared] = ACTIONS(4606),
    [sym_throw] = ACTIONS(4606),
    [sym_typeid] = ACTIONS(4606),
    [sym_typeof] = ACTIONS(4606),
    [sym_traits] = ACTIONS(4606),
    [sym_vector] = ACTIONS(4606),
    [sym_void] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(4608),
    [anon_sym_r_DQUOTE] = ACTIONS(4608),
    [anon_sym_x_DQUOTE] = ACTIONS(4608),
    [anon_sym_DQUOTE] = ACTIONS(4608),
    [anon_sym_i_BQUOTE] = ACTIONS(4608),
    [anon_sym_i_DQUOTE] = ACTIONS(4608),
    [anon_sym_iq_LBRACE] = ACTIONS(4608),
    [aux_sym_char_literal_token1] = ACTIONS(4608),
    [anon_sym_SQUOTE] = ACTIONS(4606),
    [anon_sym___DATE__] = ACTIONS(4606),
    [anon_sym___FILE__] = ACTIONS(4606),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4606),
    [anon_sym___FUNCTION__] = ACTIONS(4606),
    [anon_sym___LINE__] = ACTIONS(4606),
    [anon_sym___MODULE__] = ACTIONS(4606),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4606),
    [anon_sym___TIME__] = ACTIONS(4606),
    [anon_sym___TIMESTAMP__] = ACTIONS(4606),
    [anon_sym___VENDOR__] = ACTIONS(4606),
    [anon_sym___VERSION__] = ACTIONS(4606),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4608),
    [sym_float_literal] = ACTIONS(4608),
    [sym__string] = ACTIONS(4608),
  },
  [2115] = {
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_q_LBRACE] = ACTIONS(4624),
    [anon_sym_LBRACE] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4624),
    [anon_sym_DASH] = ACTIONS(4622),
    [anon_sym_DASH_DASH] = ACTIONS(4624),
    [anon_sym_PLUS] = ACTIONS(4622),
    [anon_sym_PLUS_PLUS] = ACTIONS(4624),
    [anon_sym_BANG] = ACTIONS(4624),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_DOLLAR] = ACTIONS(4624),
    [anon_sym_STAR] = ACTIONS(4624),
    [anon_sym_TILDE] = ACTIONS(4624),
    [sym_bool] = ACTIONS(4622),
    [sym_byte] = ACTIONS(4622),
    [sym_ubyte] = ACTIONS(4622),
    [sym_char] = ACTIONS(4622),
    [sym_short] = ACTIONS(4622),
    [sym_ushort] = ACTIONS(4622),
    [sym_int] = ACTIONS(4622),
    [sym_uint] = ACTIONS(4622),
    [sym_long] = ACTIONS(4622),
    [sym_ulong] = ACTIONS(4622),
    [sym_cent] = ACTIONS(4622),
    [sym_ucent] = ACTIONS(4622),
    [sym_wchar] = ACTIONS(4622),
    [sym_dchar] = ACTIONS(4622),
    [sym_float] = ACTIONS(4622),
    [sym_double] = ACTIONS(4622),
    [sym_real] = ACTIONS(4622),
    [sym_ifloat] = ACTIONS(4622),
    [sym_idouble] = ACTIONS(4622),
    [sym_ireal] = ACTIONS(4622),
    [sym_cfloat] = ACTIONS(4622),
    [sym_cdouble] = ACTIONS(4622),
    [sym_creal] = ACTIONS(4622),
    [sym_size_t] = ACTIONS(4622),
    [sym_ptrdiff_t] = ACTIONS(4622),
    [sym_string] = ACTIONS(4622),
    [sym_cstring] = ACTIONS(4622),
    [sym_dstring] = ACTIONS(4622),
    [sym_wstring] = ACTIONS(4622),
    [sym_noreturn] = ACTIONS(4622),
    [sym_true] = ACTIONS(4622),
    [sym_false] = ACTIONS(4622),
    [sym_null] = ACTIONS(4622),
    [sym_super] = ACTIONS(4622),
    [sym_this] = ACTIONS(4622),
    [sym_assert] = ACTIONS(4622),
    [sym_auto] = ACTIONS(4622),
    [sym_cast] = ACTIONS(4622),
    [sym_catch] = ACTIONS(4622),
    [sym_const] = ACTIONS(4622),
    [sym_delegate] = ACTIONS(4622),
    [sym_delete] = ACTIONS(4622),
    [sym_do] = ACTIONS(4622),
    [sym_else] = ACTIONS(4622),
    [sym_finally] = ACTIONS(4622),
    [sym_function] = ACTIONS(4622),
    [sym_immutable] = ACTIONS(4622),
    [sym_import] = ACTIONS(4622),
    [sym_in] = ACTIONS(4622),
    [sym_inout] = ACTIONS(4622),
    [sym_is] = ACTIONS(4622),
    [sym_mixin] = ACTIONS(4622),
    [sym_new] = ACTIONS(4622),
    [sym_out] = ACTIONS(4622),
    [sym_ref] = ACTIONS(4622),
    [sym_shared] = ACTIONS(4622),
    [sym_throw] = ACTIONS(4622),
    [sym_typeid] = ACTIONS(4622),
    [sym_typeof] = ACTIONS(4622),
    [sym_traits] = ACTIONS(4622),
    [sym_vector] = ACTIONS(4622),
    [sym_void] = ACTIONS(4622),
    [anon_sym_BQUOTE] = ACTIONS(4624),
    [anon_sym_r_DQUOTE] = ACTIONS(4624),
    [anon_sym_x_DQUOTE] = ACTIONS(4624),
    [anon_sym_DQUOTE] = ACTIONS(4624),
    [anon_sym_i_BQUOTE] = ACTIONS(4624),
    [anon_sym_i_DQUOTE] = ACTIONS(4624),
    [anon_sym_iq_LBRACE] = ACTIONS(4624),
    [aux_sym_char_literal_token1] = ACTIONS(4624),
    [anon_sym_SQUOTE] = ACTIONS(4622),
    [anon_sym___DATE__] = ACTIONS(4622),
    [anon_sym___FILE__] = ACTIONS(4622),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4622),
    [anon_sym___FUNCTION__] = ACTIONS(4622),
    [anon_sym___LINE__] = ACTIONS(4622),
    [anon_sym___MODULE__] = ACTIONS(4622),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4622),
    [anon_sym___TIME__] = ACTIONS(4622),
    [anon_sym___TIMESTAMP__] = ACTIONS(4622),
    [anon_sym___VENDOR__] = ACTIONS(4622),
    [anon_sym___VERSION__] = ACTIONS(4622),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4624),
    [sym_float_literal] = ACTIONS(4624),
    [sym__string] = ACTIONS(4624),
  },
  [2116] = {
    [sym_identifier] = ACTIONS(4664),
    [anon_sym_q_LBRACE] = ACTIONS(4666),
    [anon_sym_LBRACE] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4666),
    [anon_sym_AMP] = ACTIONS(4666),
    [anon_sym_DASH] = ACTIONS(4664),
    [anon_sym_DASH_DASH] = ACTIONS(4666),
    [anon_sym_PLUS] = ACTIONS(4664),
    [anon_sym_PLUS_PLUS] = ACTIONS(4666),
    [anon_sym_BANG] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4666),
    [anon_sym_RPAREN] = ACTIONS(4666),
    [anon_sym_LBRACK] = ACTIONS(4666),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_DOLLAR] = ACTIONS(4666),
    [anon_sym_STAR] = ACTIONS(4666),
    [anon_sym_TILDE] = ACTIONS(4666),
    [sym_bool] = ACTIONS(4664),
    [sym_byte] = ACTIONS(4664),
    [sym_ubyte] = ACTIONS(4664),
    [sym_char] = ACTIONS(4664),
    [sym_short] = ACTIONS(4664),
    [sym_ushort] = ACTIONS(4664),
    [sym_int] = ACTIONS(4664),
    [sym_uint] = ACTIONS(4664),
    [sym_long] = ACTIONS(4664),
    [sym_ulong] = ACTIONS(4664),
    [sym_cent] = ACTIONS(4664),
    [sym_ucent] = ACTIONS(4664),
    [sym_wchar] = ACTIONS(4664),
    [sym_dchar] = ACTIONS(4664),
    [sym_float] = ACTIONS(4664),
    [sym_double] = ACTIONS(4664),
    [sym_real] = ACTIONS(4664),
    [sym_ifloat] = ACTIONS(4664),
    [sym_idouble] = ACTIONS(4664),
    [sym_ireal] = ACTIONS(4664),
    [sym_cfloat] = ACTIONS(4664),
    [sym_cdouble] = ACTIONS(4664),
    [sym_creal] = ACTIONS(4664),
    [sym_size_t] = ACTIONS(4664),
    [sym_ptrdiff_t] = ACTIONS(4664),
    [sym_string] = ACTIONS(4664),
    [sym_cstring] = ACTIONS(4664),
    [sym_dstring] = ACTIONS(4664),
    [sym_wstring] = ACTIONS(4664),
    [sym_noreturn] = ACTIONS(4664),
    [sym_true] = ACTIONS(4664),
    [sym_false] = ACTIONS(4664),
    [sym_null] = ACTIONS(4664),
    [sym_super] = ACTIONS(4664),
    [sym_this] = ACTIONS(4664),
    [sym_assert] = ACTIONS(4664),
    [sym_auto] = ACTIONS(4664),
    [sym_cast] = ACTIONS(4664),
    [sym_catch] = ACTIONS(4664),
    [sym_const] = ACTIONS(4664),
    [sym_delegate] = ACTIONS(4664),
    [sym_delete] = ACTIONS(4664),
    [sym_do] = ACTIONS(4664),
    [sym_else] = ACTIONS(4664),
    [sym_finally] = ACTIONS(4664),
    [sym_function] = ACTIONS(4664),
    [sym_immutable] = ACTIONS(4664),
    [sym_import] = ACTIONS(4664),
    [sym_in] = ACTIONS(4664),
    [sym_inout] = ACTIONS(4664),
    [sym_is] = ACTIONS(4664),
    [sym_mixin] = ACTIONS(4664),
    [sym_new] = ACTIONS(4664),
    [sym_out] = ACTIONS(4664),
    [sym_ref] = ACTIONS(4664),
    [sym_shared] = ACTIONS(4664),
    [sym_throw] = ACTIONS(4664),
    [sym_typeid] = ACTIONS(4664),
    [sym_typeof] = ACTIONS(4664),
    [sym_traits] = ACTIONS(4664),
    [sym_vector] = ACTIONS(4664),
    [sym_void] = ACTIONS(4664),
    [anon_sym_BQUOTE] = ACTIONS(4666),
    [anon_sym_r_DQUOTE] = ACTIONS(4666),
    [anon_sym_x_DQUOTE] = ACTIONS(4666),
    [anon_sym_DQUOTE] = ACTIONS(4666),
    [anon_sym_i_BQUOTE] = ACTIONS(4666),
    [anon_sym_i_DQUOTE] = ACTIONS(4666),
    [anon_sym_iq_LBRACE] = ACTIONS(4666),
    [aux_sym_char_literal_token1] = ACTIONS(4666),
    [anon_sym_SQUOTE] = ACTIONS(4664),
    [anon_sym___DATE__] = ACTIONS(4664),
    [anon_sym___FILE__] = ACTIONS(4664),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4664),
    [anon_sym___FUNCTION__] = ACTIONS(4664),
    [anon_sym___LINE__] = ACTIONS(4664),
    [anon_sym___MODULE__] = ACTIONS(4664),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4664),
    [anon_sym___TIME__] = ACTIONS(4664),
    [anon_sym___TIMESTAMP__] = ACTIONS(4664),
    [anon_sym___VENDOR__] = ACTIONS(4664),
    [anon_sym___VERSION__] = ACTIONS(4664),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4666),
    [sym_float_literal] = ACTIONS(4666),
    [sym__string] = ACTIONS(4666),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(4514),
    [anon_sym_q_LBRACE] = ACTIONS(4516),
    [anon_sym_LBRACE] = ACTIONS(4516),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_AMP] = ACTIONS(4516),
    [anon_sym_DASH] = ACTIONS(4514),
    [anon_sym_DASH_DASH] = ACTIONS(4516),
    [anon_sym_PLUS] = ACTIONS(4514),
    [anon_sym_PLUS_PLUS] = ACTIONS(4516),
    [anon_sym_BANG] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4516),
    [anon_sym_RPAREN] = ACTIONS(4516),
    [anon_sym_LBRACK] = ACTIONS(4516),
    [anon_sym_SEMI] = ACTIONS(4516),
    [anon_sym_DOLLAR] = ACTIONS(4516),
    [anon_sym_STAR] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4516),
    [sym_bool] = ACTIONS(4514),
    [sym_byte] = ACTIONS(4514),
    [sym_ubyte] = ACTIONS(4514),
    [sym_char] = ACTIONS(4514),
    [sym_short] = ACTIONS(4514),
    [sym_ushort] = ACTIONS(4514),
    [sym_int] = ACTIONS(4514),
    [sym_uint] = ACTIONS(4514),
    [sym_long] = ACTIONS(4514),
    [sym_ulong] = ACTIONS(4514),
    [sym_cent] = ACTIONS(4514),
    [sym_ucent] = ACTIONS(4514),
    [sym_wchar] = ACTIONS(4514),
    [sym_dchar] = ACTIONS(4514),
    [sym_float] = ACTIONS(4514),
    [sym_double] = ACTIONS(4514),
    [sym_real] = ACTIONS(4514),
    [sym_ifloat] = ACTIONS(4514),
    [sym_idouble] = ACTIONS(4514),
    [sym_ireal] = ACTIONS(4514),
    [sym_cfloat] = ACTIONS(4514),
    [sym_cdouble] = ACTIONS(4514),
    [sym_creal] = ACTIONS(4514),
    [sym_size_t] = ACTIONS(4514),
    [sym_ptrdiff_t] = ACTIONS(4514),
    [sym_string] = ACTIONS(4514),
    [sym_cstring] = ACTIONS(4514),
    [sym_dstring] = ACTIONS(4514),
    [sym_wstring] = ACTIONS(4514),
    [sym_noreturn] = ACTIONS(4514),
    [sym_true] = ACTIONS(4514),
    [sym_false] = ACTIONS(4514),
    [sym_null] = ACTIONS(4514),
    [sym_super] = ACTIONS(4514),
    [sym_this] = ACTIONS(4514),
    [sym_assert] = ACTIONS(4514),
    [sym_auto] = ACTIONS(4514),
    [sym_cast] = ACTIONS(4514),
    [sym_catch] = ACTIONS(4514),
    [sym_const] = ACTIONS(4514),
    [sym_delegate] = ACTIONS(4514),
    [sym_delete] = ACTIONS(4514),
    [sym_do] = ACTIONS(4514),
    [sym_else] = ACTIONS(4514),
    [sym_finally] = ACTIONS(4514),
    [sym_function] = ACTIONS(4514),
    [sym_immutable] = ACTIONS(4514),
    [sym_import] = ACTIONS(4514),
    [sym_in] = ACTIONS(4514),
    [sym_inout] = ACTIONS(4514),
    [sym_is] = ACTIONS(4514),
    [sym_mixin] = ACTIONS(4514),
    [sym_new] = ACTIONS(4514),
    [sym_out] = ACTIONS(4514),
    [sym_ref] = ACTIONS(4514),
    [sym_shared] = ACTIONS(4514),
    [sym_throw] = ACTIONS(4514),
    [sym_typeid] = ACTIONS(4514),
    [sym_typeof] = ACTIONS(4514),
    [sym_traits] = ACTIONS(4514),
    [sym_vector] = ACTIONS(4514),
    [sym_void] = ACTIONS(4514),
    [anon_sym_BQUOTE] = ACTIONS(4516),
    [anon_sym_r_DQUOTE] = ACTIONS(4516),
    [anon_sym_x_DQUOTE] = ACTIONS(4516),
    [anon_sym_DQUOTE] = ACTIONS(4516),
    [anon_sym_i_BQUOTE] = ACTIONS(4516),
    [anon_sym_i_DQUOTE] = ACTIONS(4516),
    [anon_sym_iq_LBRACE] = ACTIONS(4516),
    [aux_sym_char_literal_token1] = ACTIONS(4516),
    [anon_sym_SQUOTE] = ACTIONS(4514),
    [anon_sym___DATE__] = ACTIONS(4514),
    [anon_sym___FILE__] = ACTIONS(4514),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4514),
    [anon_sym___FUNCTION__] = ACTIONS(4514),
    [anon_sym___LINE__] = ACTIONS(4514),
    [anon_sym___MODULE__] = ACTIONS(4514),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4514),
    [anon_sym___TIME__] = ACTIONS(4514),
    [anon_sym___TIMESTAMP__] = ACTIONS(4514),
    [anon_sym___VENDOR__] = ACTIONS(4514),
    [anon_sym___VERSION__] = ACTIONS(4514),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4516),
    [sym_float_literal] = ACTIONS(4516),
    [sym__string] = ACTIONS(4516),
  },
  [2118] = {
    [sym_identifier] = ACTIONS(4574),
    [anon_sym_q_LBRACE] = ACTIONS(4576),
    [anon_sym_LBRACE] = ACTIONS(4576),
    [anon_sym_DOT] = ACTIONS(4576),
    [anon_sym_AMP] = ACTIONS(4576),
    [anon_sym_DASH] = ACTIONS(4574),
    [anon_sym_DASH_DASH] = ACTIONS(4576),
    [anon_sym_PLUS] = ACTIONS(4574),
    [anon_sym_PLUS_PLUS] = ACTIONS(4576),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_LPAREN] = ACTIONS(4576),
    [anon_sym_RPAREN] = ACTIONS(4576),
    [anon_sym_LBRACK] = ACTIONS(4576),
    [anon_sym_SEMI] = ACTIONS(4576),
    [anon_sym_DOLLAR] = ACTIONS(4576),
    [anon_sym_STAR] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_bool] = ACTIONS(4574),
    [sym_byte] = ACTIONS(4574),
    [sym_ubyte] = ACTIONS(4574),
    [sym_char] = ACTIONS(4574),
    [sym_short] = ACTIONS(4574),
    [sym_ushort] = ACTIONS(4574),
    [sym_int] = ACTIONS(4574),
    [sym_uint] = ACTIONS(4574),
    [sym_long] = ACTIONS(4574),
    [sym_ulong] = ACTIONS(4574),
    [sym_cent] = ACTIONS(4574),
    [sym_ucent] = ACTIONS(4574),
    [sym_wchar] = ACTIONS(4574),
    [sym_dchar] = ACTIONS(4574),
    [sym_float] = ACTIONS(4574),
    [sym_double] = ACTIONS(4574),
    [sym_real] = ACTIONS(4574),
    [sym_ifloat] = ACTIONS(4574),
    [sym_idouble] = ACTIONS(4574),
    [sym_ireal] = ACTIONS(4574),
    [sym_cfloat] = ACTIONS(4574),
    [sym_cdouble] = ACTIONS(4574),
    [sym_creal] = ACTIONS(4574),
    [sym_size_t] = ACTIONS(4574),
    [sym_ptrdiff_t] = ACTIONS(4574),
    [sym_string] = ACTIONS(4574),
    [sym_cstring] = ACTIONS(4574),
    [sym_dstring] = ACTIONS(4574),
    [sym_wstring] = ACTIONS(4574),
    [sym_noreturn] = ACTIONS(4574),
    [sym_true] = ACTIONS(4574),
    [sym_false] = ACTIONS(4574),
    [sym_null] = ACTIONS(4574),
    [sym_super] = ACTIONS(4574),
    [sym_this] = ACTIONS(4574),
    [sym_assert] = ACTIONS(4574),
    [sym_auto] = ACTIONS(4574),
    [sym_cast] = ACTIONS(4574),
    [sym_catch] = ACTIONS(4574),
    [sym_const] = ACTIONS(4574),
    [sym_delegate] = ACTIONS(4574),
    [sym_delete] = ACTIONS(4574),
    [sym_do] = ACTIONS(4574),
    [sym_else] = ACTIONS(4574),
    [sym_finally] = ACTIONS(4574),
    [sym_function] = ACTIONS(4574),
    [sym_immutable] = ACTIONS(4574),
    [sym_import] = ACTIONS(4574),
    [sym_in] = ACTIONS(4574),
    [sym_inout] = ACTIONS(4574),
    [sym_is] = ACTIONS(4574),
    [sym_mixin] = ACTIONS(4574),
    [sym_new] = ACTIONS(4574),
    [sym_out] = ACTIONS(4574),
    [sym_ref] = ACTIONS(4574),
    [sym_shared] = ACTIONS(4574),
    [sym_throw] = ACTIONS(4574),
    [sym_typeid] = ACTIONS(4574),
    [sym_typeof] = ACTIONS(4574),
    [sym_traits] = ACTIONS(4574),
    [sym_vector] = ACTIONS(4574),
    [sym_void] = ACTIONS(4574),
    [anon_sym_BQUOTE] = ACTIONS(4576),
    [anon_sym_r_DQUOTE] = ACTIONS(4576),
    [anon_sym_x_DQUOTE] = ACTIONS(4576),
    [anon_sym_DQUOTE] = ACTIONS(4576),
    [anon_sym_i_BQUOTE] = ACTIONS(4576),
    [anon_sym_i_DQUOTE] = ACTIONS(4576),
    [anon_sym_iq_LBRACE] = ACTIONS(4576),
    [aux_sym_char_literal_token1] = ACTIONS(4576),
    [anon_sym_SQUOTE] = ACTIONS(4574),
    [anon_sym___DATE__] = ACTIONS(4574),
    [anon_sym___FILE__] = ACTIONS(4574),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4574),
    [anon_sym___FUNCTION__] = ACTIONS(4574),
    [anon_sym___LINE__] = ACTIONS(4574),
    [anon_sym___MODULE__] = ACTIONS(4574),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4574),
    [anon_sym___TIME__] = ACTIONS(4574),
    [anon_sym___TIMESTAMP__] = ACTIONS(4574),
    [anon_sym___VENDOR__] = ACTIONS(4574),
    [anon_sym___VERSION__] = ACTIONS(4574),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4576),
    [sym_float_literal] = ACTIONS(4576),
    [sym__string] = ACTIONS(4576),
  },
  [2119] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_finally] = ACTIONS(2505),
    [sym_function] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [2120] = {
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_q_LBRACE] = ACTIONS(2636),
    [anon_sym_LBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_AMP] = ACTIONS(2636),
    [anon_sym_DASH] = ACTIONS(2638),
    [anon_sym_DASH_DASH] = ACTIONS(2636),
    [anon_sym_PLUS] = ACTIONS(2638),
    [anon_sym_PLUS_PLUS] = ACTIONS(2636),
    [anon_sym_BANG] = ACTIONS(2636),
    [anon_sym_LPAREN] = ACTIONS(2636),
    [anon_sym_RPAREN] = ACTIONS(2636),
    [anon_sym_LBRACK] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_DOLLAR] = ACTIONS(2636),
    [anon_sym_STAR] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2636),
    [sym_bool] = ACTIONS(2638),
    [sym_byte] = ACTIONS(2638),
    [sym_ubyte] = ACTIONS(2638),
    [sym_char] = ACTIONS(2638),
    [sym_short] = ACTIONS(2638),
    [sym_ushort] = ACTIONS(2638),
    [sym_int] = ACTIONS(2638),
    [sym_uint] = ACTIONS(2638),
    [sym_long] = ACTIONS(2638),
    [sym_ulong] = ACTIONS(2638),
    [sym_cent] = ACTIONS(2638),
    [sym_ucent] = ACTIONS(2638),
    [sym_wchar] = ACTIONS(2638),
    [sym_dchar] = ACTIONS(2638),
    [sym_float] = ACTIONS(2638),
    [sym_double] = ACTIONS(2638),
    [sym_real] = ACTIONS(2638),
    [sym_ifloat] = ACTIONS(2638),
    [sym_idouble] = ACTIONS(2638),
    [sym_ireal] = ACTIONS(2638),
    [sym_cfloat] = ACTIONS(2638),
    [sym_cdouble] = ACTIONS(2638),
    [sym_creal] = ACTIONS(2638),
    [sym_size_t] = ACTIONS(2638),
    [sym_ptrdiff_t] = ACTIONS(2638),
    [sym_string] = ACTIONS(2638),
    [sym_cstring] = ACTIONS(2638),
    [sym_dstring] = ACTIONS(2638),
    [sym_wstring] = ACTIONS(2638),
    [sym_noreturn] = ACTIONS(2638),
    [sym_true] = ACTIONS(2638),
    [sym_false] = ACTIONS(2638),
    [sym_null] = ACTIONS(2638),
    [sym_super] = ACTIONS(2638),
    [sym_this] = ACTIONS(2638),
    [sym_assert] = ACTIONS(2638),
    [sym_auto] = ACTIONS(2638),
    [sym_cast] = ACTIONS(2638),
    [sym_catch] = ACTIONS(2638),
    [sym_const] = ACTIONS(2638),
    [sym_delegate] = ACTIONS(2638),
    [sym_delete] = ACTIONS(2638),
    [sym_do] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_finally] = ACTIONS(2638),
    [sym_function] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(2638),
    [sym_import] = ACTIONS(2638),
    [sym_in] = ACTIONS(2638),
    [sym_inout] = ACTIONS(2638),
    [sym_is] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2638),
    [sym_new] = ACTIONS(2638),
    [sym_out] = ACTIONS(2638),
    [sym_ref] = ACTIONS(2638),
    [sym_shared] = ACTIONS(2638),
    [sym_throw] = ACTIONS(2638),
    [sym_typeid] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(2638),
    [sym_traits] = ACTIONS(2638),
    [sym_vector] = ACTIONS(2638),
    [sym_void] = ACTIONS(2638),
    [anon_sym_BQUOTE] = ACTIONS(2636),
    [anon_sym_r_DQUOTE] = ACTIONS(2636),
    [anon_sym_x_DQUOTE] = ACTIONS(2636),
    [anon_sym_DQUOTE] = ACTIONS(2636),
    [anon_sym_i_BQUOTE] = ACTIONS(2636),
    [anon_sym_i_DQUOTE] = ACTIONS(2636),
    [anon_sym_iq_LBRACE] = ACTIONS(2636),
    [aux_sym_char_literal_token1] = ACTIONS(2636),
    [anon_sym_SQUOTE] = ACTIONS(2638),
    [anon_sym___DATE__] = ACTIONS(2638),
    [anon_sym___FILE__] = ACTIONS(2638),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2638),
    [anon_sym___FUNCTION__] = ACTIONS(2638),
    [anon_sym___LINE__] = ACTIONS(2638),
    [anon_sym___MODULE__] = ACTIONS(2638),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2638),
    [anon_sym___TIME__] = ACTIONS(2638),
    [anon_sym___TIMESTAMP__] = ACTIONS(2638),
    [anon_sym___VENDOR__] = ACTIONS(2638),
    [anon_sym___VERSION__] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2636),
    [sym_float_literal] = ACTIONS(2636),
    [sym__string] = ACTIONS(2636),
  },
  [2121] = {
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_q_LBRACE] = ACTIONS(4731),
    [anon_sym_LBRACE] = ACTIONS(4731),
    [anon_sym_DOT] = ACTIONS(4731),
    [anon_sym_AMP] = ACTIONS(4731),
    [anon_sym_DASH] = ACTIONS(4729),
    [anon_sym_DASH_DASH] = ACTIONS(4731),
    [anon_sym_PLUS] = ACTIONS(4729),
    [anon_sym_PLUS_PLUS] = ACTIONS(4731),
    [anon_sym_BANG] = ACTIONS(4731),
    [anon_sym_LPAREN] = ACTIONS(4731),
    [anon_sym_RPAREN] = ACTIONS(4731),
    [anon_sym_LBRACK] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_DOLLAR] = ACTIONS(4731),
    [anon_sym_STAR] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [sym_bool] = ACTIONS(4729),
    [sym_byte] = ACTIONS(4729),
    [sym_ubyte] = ACTIONS(4729),
    [sym_char] = ACTIONS(4729),
    [sym_short] = ACTIONS(4729),
    [sym_ushort] = ACTIONS(4729),
    [sym_int] = ACTIONS(4729),
    [sym_uint] = ACTIONS(4729),
    [sym_long] = ACTIONS(4729),
    [sym_ulong] = ACTIONS(4729),
    [sym_cent] = ACTIONS(4729),
    [sym_ucent] = ACTIONS(4729),
    [sym_wchar] = ACTIONS(4729),
    [sym_dchar] = ACTIONS(4729),
    [sym_float] = ACTIONS(4729),
    [sym_double] = ACTIONS(4729),
    [sym_real] = ACTIONS(4729),
    [sym_ifloat] = ACTIONS(4729),
    [sym_idouble] = ACTIONS(4729),
    [sym_ireal] = ACTIONS(4729),
    [sym_cfloat] = ACTIONS(4729),
    [sym_cdouble] = ACTIONS(4729),
    [sym_creal] = ACTIONS(4729),
    [sym_size_t] = ACTIONS(4729),
    [sym_ptrdiff_t] = ACTIONS(4729),
    [sym_string] = ACTIONS(4729),
    [sym_cstring] = ACTIONS(4729),
    [sym_dstring] = ACTIONS(4729),
    [sym_wstring] = ACTIONS(4729),
    [sym_noreturn] = ACTIONS(4729),
    [sym_true] = ACTIONS(4729),
    [sym_false] = ACTIONS(4729),
    [sym_null] = ACTIONS(4729),
    [sym_super] = ACTIONS(4729),
    [sym_this] = ACTIONS(4729),
    [sym_assert] = ACTIONS(4729),
    [sym_auto] = ACTIONS(4729),
    [sym_cast] = ACTIONS(4729),
    [sym_catch] = ACTIONS(4729),
    [sym_const] = ACTIONS(4729),
    [sym_delegate] = ACTIONS(4729),
    [sym_delete] = ACTIONS(4729),
    [sym_do] = ACTIONS(4729),
    [sym_else] = ACTIONS(4729),
    [sym_finally] = ACTIONS(4729),
    [sym_function] = ACTIONS(4729),
    [sym_immutable] = ACTIONS(4729),
    [sym_import] = ACTIONS(4729),
    [sym_in] = ACTIONS(4729),
    [sym_inout] = ACTIONS(4729),
    [sym_is] = ACTIONS(4729),
    [sym_mixin] = ACTIONS(4729),
    [sym_new] = ACTIONS(4729),
    [sym_out] = ACTIONS(4729),
    [sym_ref] = ACTIONS(4729),
    [sym_shared] = ACTIONS(4729),
    [sym_throw] = ACTIONS(4729),
    [sym_typeid] = ACTIONS(4729),
    [sym_typeof] = ACTIONS(4729),
    [sym_traits] = ACTIONS(4729),
    [sym_vector] = ACTIONS(4729),
    [sym_void] = ACTIONS(4729),
    [anon_sym_BQUOTE] = ACTIONS(4731),
    [anon_sym_r_DQUOTE] = ACTIONS(4731),
    [anon_sym_x_DQUOTE] = ACTIONS(4731),
    [anon_sym_DQUOTE] = ACTIONS(4731),
    [anon_sym_i_BQUOTE] = ACTIONS(4731),
    [anon_sym_i_DQUOTE] = ACTIONS(4731),
    [anon_sym_iq_LBRACE] = ACTIONS(4731),
    [aux_sym_char_literal_token1] = ACTIONS(4731),
    [anon_sym_SQUOTE] = ACTIONS(4729),
    [anon_sym___DATE__] = ACTIONS(4729),
    [anon_sym___FILE__] = ACTIONS(4729),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4729),
    [anon_sym___FUNCTION__] = ACTIONS(4729),
    [anon_sym___LINE__] = ACTIONS(4729),
    [anon_sym___MODULE__] = ACTIONS(4729),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4729),
    [anon_sym___TIME__] = ACTIONS(4729),
    [anon_sym___TIMESTAMP__] = ACTIONS(4729),
    [anon_sym___VENDOR__] = ACTIONS(4729),
    [anon_sym___VERSION__] = ACTIONS(4729),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4731),
    [sym_float_literal] = ACTIONS(4731),
    [sym__string] = ACTIONS(4731),
  },
  [2122] = {
    [sym_identifier] = ACTIONS(4384),
    [anon_sym_q_LBRACE] = ACTIONS(4386),
    [anon_sym_LBRACE] = ACTIONS(4386),
    [anon_sym_DOT] = ACTIONS(4386),
    [anon_sym_AMP] = ACTIONS(4386),
    [anon_sym_DASH] = ACTIONS(4384),
    [anon_sym_DASH_DASH] = ACTIONS(4386),
    [anon_sym_PLUS] = ACTIONS(4384),
    [anon_sym_PLUS_PLUS] = ACTIONS(4386),
    [anon_sym_BANG] = ACTIONS(4386),
    [anon_sym_LPAREN] = ACTIONS(4386),
    [anon_sym_RPAREN] = ACTIONS(4386),
    [anon_sym_LBRACK] = ACTIONS(4386),
    [anon_sym_SEMI] = ACTIONS(4386),
    [anon_sym_DOLLAR] = ACTIONS(4386),
    [anon_sym_STAR] = ACTIONS(4386),
    [anon_sym_TILDE] = ACTIONS(4386),
    [sym_bool] = ACTIONS(4384),
    [sym_byte] = ACTIONS(4384),
    [sym_ubyte] = ACTIONS(4384),
    [sym_char] = ACTIONS(4384),
    [sym_short] = ACTIONS(4384),
    [sym_ushort] = ACTIONS(4384),
    [sym_int] = ACTIONS(4384),
    [sym_uint] = ACTIONS(4384),
    [sym_long] = ACTIONS(4384),
    [sym_ulong] = ACTIONS(4384),
    [sym_cent] = ACTIONS(4384),
    [sym_ucent] = ACTIONS(4384),
    [sym_wchar] = ACTIONS(4384),
    [sym_dchar] = ACTIONS(4384),
    [sym_float] = ACTIONS(4384),
    [sym_double] = ACTIONS(4384),
    [sym_real] = ACTIONS(4384),
    [sym_ifloat] = ACTIONS(4384),
    [sym_idouble] = ACTIONS(4384),
    [sym_ireal] = ACTIONS(4384),
    [sym_cfloat] = ACTIONS(4384),
    [sym_cdouble] = ACTIONS(4384),
    [sym_creal] = ACTIONS(4384),
    [sym_size_t] = ACTIONS(4384),
    [sym_ptrdiff_t] = ACTIONS(4384),
    [sym_string] = ACTIONS(4384),
    [sym_cstring] = ACTIONS(4384),
    [sym_dstring] = ACTIONS(4384),
    [sym_wstring] = ACTIONS(4384),
    [sym_noreturn] = ACTIONS(4384),
    [sym_true] = ACTIONS(4384),
    [sym_false] = ACTIONS(4384),
    [sym_null] = ACTIONS(4384),
    [sym_super] = ACTIONS(4384),
    [sym_this] = ACTIONS(4384),
    [sym_assert] = ACTIONS(4384),
    [sym_auto] = ACTIONS(4384),
    [sym_cast] = ACTIONS(4384),
    [sym_catch] = ACTIONS(4384),
    [sym_const] = ACTIONS(4384),
    [sym_delegate] = ACTIONS(4384),
    [sym_delete] = ACTIONS(4384),
    [sym_do] = ACTIONS(4384),
    [sym_else] = ACTIONS(4384),
    [sym_finally] = ACTIONS(4384),
    [sym_function] = ACTIONS(4384),
    [sym_immutable] = ACTIONS(4384),
    [sym_import] = ACTIONS(4384),
    [sym_in] = ACTIONS(4384),
    [sym_inout] = ACTIONS(4384),
    [sym_is] = ACTIONS(4384),
    [sym_mixin] = ACTIONS(4384),
    [sym_new] = ACTIONS(4384),
    [sym_out] = ACTIONS(4384),
    [sym_ref] = ACTIONS(4384),
    [sym_shared] = ACTIONS(4384),
    [sym_throw] = ACTIONS(4384),
    [sym_typeid] = ACTIONS(4384),
    [sym_typeof] = ACTIONS(4384),
    [sym_traits] = ACTIONS(4384),
    [sym_vector] = ACTIONS(4384),
    [sym_void] = ACTIONS(4384),
    [anon_sym_BQUOTE] = ACTIONS(4386),
    [anon_sym_r_DQUOTE] = ACTIONS(4386),
    [anon_sym_x_DQUOTE] = ACTIONS(4386),
    [anon_sym_DQUOTE] = ACTIONS(4386),
    [anon_sym_i_BQUOTE] = ACTIONS(4386),
    [anon_sym_i_DQUOTE] = ACTIONS(4386),
    [anon_sym_iq_LBRACE] = ACTIONS(4386),
    [aux_sym_char_literal_token1] = ACTIONS(4386),
    [anon_sym_SQUOTE] = ACTIONS(4384),
    [anon_sym___DATE__] = ACTIONS(4384),
    [anon_sym___FILE__] = ACTIONS(4384),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4384),
    [anon_sym___FUNCTION__] = ACTIONS(4384),
    [anon_sym___LINE__] = ACTIONS(4384),
    [anon_sym___MODULE__] = ACTIONS(4384),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4384),
    [anon_sym___TIME__] = ACTIONS(4384),
    [anon_sym___TIMESTAMP__] = ACTIONS(4384),
    [anon_sym___VENDOR__] = ACTIONS(4384),
    [anon_sym___VERSION__] = ACTIONS(4384),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4386),
    [sym_float_literal] = ACTIONS(4386),
    [sym__string] = ACTIONS(4386),
  },
  [2123] = {
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_q_LBRACE] = ACTIONS(4749),
    [anon_sym_LBRACE] = ACTIONS(4749),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_AMP] = ACTIONS(4749),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_DASH_DASH] = ACTIONS(4749),
    [anon_sym_PLUS] = ACTIONS(4747),
    [anon_sym_PLUS_PLUS] = ACTIONS(4749),
    [anon_sym_BANG] = ACTIONS(4749),
    [anon_sym_LPAREN] = ACTIONS(4749),
    [anon_sym_RPAREN] = ACTIONS(4749),
    [anon_sym_LBRACK] = ACTIONS(4749),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_DOLLAR] = ACTIONS(4749),
    [anon_sym_STAR] = ACTIONS(4749),
    [anon_sym_TILDE] = ACTIONS(4749),
    [sym_bool] = ACTIONS(4747),
    [sym_byte] = ACTIONS(4747),
    [sym_ubyte] = ACTIONS(4747),
    [sym_char] = ACTIONS(4747),
    [sym_short] = ACTIONS(4747),
    [sym_ushort] = ACTIONS(4747),
    [sym_int] = ACTIONS(4747),
    [sym_uint] = ACTIONS(4747),
    [sym_long] = ACTIONS(4747),
    [sym_ulong] = ACTIONS(4747),
    [sym_cent] = ACTIONS(4747),
    [sym_ucent] = ACTIONS(4747),
    [sym_wchar] = ACTIONS(4747),
    [sym_dchar] = ACTIONS(4747),
    [sym_float] = ACTIONS(4747),
    [sym_double] = ACTIONS(4747),
    [sym_real] = ACTIONS(4747),
    [sym_ifloat] = ACTIONS(4747),
    [sym_idouble] = ACTIONS(4747),
    [sym_ireal] = ACTIONS(4747),
    [sym_cfloat] = ACTIONS(4747),
    [sym_cdouble] = ACTIONS(4747),
    [sym_creal] = ACTIONS(4747),
    [sym_size_t] = ACTIONS(4747),
    [sym_ptrdiff_t] = ACTIONS(4747),
    [sym_string] = ACTIONS(4747),
    [sym_cstring] = ACTIONS(4747),
    [sym_dstring] = ACTIONS(4747),
    [sym_wstring] = ACTIONS(4747),
    [sym_noreturn] = ACTIONS(4747),
    [sym_true] = ACTIONS(4747),
    [sym_false] = ACTIONS(4747),
    [sym_null] = ACTIONS(4747),
    [sym_super] = ACTIONS(4747),
    [sym_this] = ACTIONS(4747),
    [sym_assert] = ACTIONS(4747),
    [sym_auto] = ACTIONS(4747),
    [sym_cast] = ACTIONS(4747),
    [sym_catch] = ACTIONS(4747),
    [sym_const] = ACTIONS(4747),
    [sym_delegate] = ACTIONS(4747),
    [sym_delete] = ACTIONS(4747),
    [sym_do] = ACTIONS(4747),
    [sym_else] = ACTIONS(4747),
    [sym_finally] = ACTIONS(4747),
    [sym_function] = ACTIONS(4747),
    [sym_immutable] = ACTIONS(4747),
    [sym_import] = ACTIONS(4747),
    [sym_in] = ACTIONS(4747),
    [sym_inout] = ACTIONS(4747),
    [sym_is] = ACTIONS(4747),
    [sym_mixin] = ACTIONS(4747),
    [sym_new] = ACTIONS(4747),
    [sym_out] = ACTIONS(4747),
    [sym_ref] = ACTIONS(4747),
    [sym_shared] = ACTIONS(4747),
    [sym_throw] = ACTIONS(4747),
    [sym_typeid] = ACTIONS(4747),
    [sym_typeof] = ACTIONS(4747),
    [sym_traits] = ACTIONS(4747),
    [sym_vector] = ACTIONS(4747),
    [sym_void] = ACTIONS(4747),
    [anon_sym_BQUOTE] = ACTIONS(4749),
    [anon_sym_r_DQUOTE] = ACTIONS(4749),
    [anon_sym_x_DQUOTE] = ACTIONS(4749),
    [anon_sym_DQUOTE] = ACTIONS(4749),
    [anon_sym_i_BQUOTE] = ACTIONS(4749),
    [anon_sym_i_DQUOTE] = ACTIONS(4749),
    [anon_sym_iq_LBRACE] = ACTIONS(4749),
    [aux_sym_char_literal_token1] = ACTIONS(4749),
    [anon_sym_SQUOTE] = ACTIONS(4747),
    [anon_sym___DATE__] = ACTIONS(4747),
    [anon_sym___FILE__] = ACTIONS(4747),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4747),
    [anon_sym___FUNCTION__] = ACTIONS(4747),
    [anon_sym___LINE__] = ACTIONS(4747),
    [anon_sym___MODULE__] = ACTIONS(4747),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4747),
    [anon_sym___TIME__] = ACTIONS(4747),
    [anon_sym___TIMESTAMP__] = ACTIONS(4747),
    [anon_sym___VENDOR__] = ACTIONS(4747),
    [anon_sym___VERSION__] = ACTIONS(4747),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4749),
    [sym_float_literal] = ACTIONS(4749),
    [sym__string] = ACTIONS(4749),
  },
  [2124] = {
    [sym_identifier] = ACTIONS(4773),
    [anon_sym_q_LBRACE] = ACTIONS(4775),
    [anon_sym_LBRACE] = ACTIONS(4775),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_AMP] = ACTIONS(4775),
    [anon_sym_DASH] = ACTIONS(4773),
    [anon_sym_DASH_DASH] = ACTIONS(4775),
    [anon_sym_PLUS] = ACTIONS(4773),
    [anon_sym_PLUS_PLUS] = ACTIONS(4775),
    [anon_sym_BANG] = ACTIONS(4775),
    [anon_sym_LPAREN] = ACTIONS(4775),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_LBRACK] = ACTIONS(4775),
    [anon_sym_SEMI] = ACTIONS(4775),
    [anon_sym_DOLLAR] = ACTIONS(4775),
    [anon_sym_STAR] = ACTIONS(4775),
    [anon_sym_TILDE] = ACTIONS(4775),
    [sym_bool] = ACTIONS(4773),
    [sym_byte] = ACTIONS(4773),
    [sym_ubyte] = ACTIONS(4773),
    [sym_char] = ACTIONS(4773),
    [sym_short] = ACTIONS(4773),
    [sym_ushort] = ACTIONS(4773),
    [sym_int] = ACTIONS(4773),
    [sym_uint] = ACTIONS(4773),
    [sym_long] = ACTIONS(4773),
    [sym_ulong] = ACTIONS(4773),
    [sym_cent] = ACTIONS(4773),
    [sym_ucent] = ACTIONS(4773),
    [sym_wchar] = ACTIONS(4773),
    [sym_dchar] = ACTIONS(4773),
    [sym_float] = ACTIONS(4773),
    [sym_double] = ACTIONS(4773),
    [sym_real] = ACTIONS(4773),
    [sym_ifloat] = ACTIONS(4773),
    [sym_idouble] = ACTIONS(4773),
    [sym_ireal] = ACTIONS(4773),
    [sym_cfloat] = ACTIONS(4773),
    [sym_cdouble] = ACTIONS(4773),
    [sym_creal] = ACTIONS(4773),
    [sym_size_t] = ACTIONS(4773),
    [sym_ptrdiff_t] = ACTIONS(4773),
    [sym_string] = ACTIONS(4773),
    [sym_cstring] = ACTIONS(4773),
    [sym_dstring] = ACTIONS(4773),
    [sym_wstring] = ACTIONS(4773),
    [sym_noreturn] = ACTIONS(4773),
    [sym_true] = ACTIONS(4773),
    [sym_false] = ACTIONS(4773),
    [sym_null] = ACTIONS(4773),
    [sym_super] = ACTIONS(4773),
    [sym_this] = ACTIONS(4773),
    [sym_assert] = ACTIONS(4773),
    [sym_auto] = ACTIONS(4773),
    [sym_cast] = ACTIONS(4773),
    [sym_catch] = ACTIONS(4773),
    [sym_const] = ACTIONS(4773),
    [sym_delegate] = ACTIONS(4773),
    [sym_delete] = ACTIONS(4773),
    [sym_do] = ACTIONS(4773),
    [sym_else] = ACTIONS(4773),
    [sym_finally] = ACTIONS(4773),
    [sym_function] = ACTIONS(4773),
    [sym_immutable] = ACTIONS(4773),
    [sym_import] = ACTIONS(4773),
    [sym_in] = ACTIONS(4773),
    [sym_inout] = ACTIONS(4773),
    [sym_is] = ACTIONS(4773),
    [sym_mixin] = ACTIONS(4773),
    [sym_new] = ACTIONS(4773),
    [sym_out] = ACTIONS(4773),
    [sym_ref] = ACTIONS(4773),
    [sym_shared] = ACTIONS(4773),
    [sym_throw] = ACTIONS(4773),
    [sym_typeid] = ACTIONS(4773),
    [sym_typeof] = ACTIONS(4773),
    [sym_traits] = ACTIONS(4773),
    [sym_vector] = ACTIONS(4773),
    [sym_void] = ACTIONS(4773),
    [anon_sym_BQUOTE] = ACTIONS(4775),
    [anon_sym_r_DQUOTE] = ACTIONS(4775),
    [anon_sym_x_DQUOTE] = ACTIONS(4775),
    [anon_sym_DQUOTE] = ACTIONS(4775),
    [anon_sym_i_BQUOTE] = ACTIONS(4775),
    [anon_sym_i_DQUOTE] = ACTIONS(4775),
    [anon_sym_iq_LBRACE] = ACTIONS(4775),
    [aux_sym_char_literal_token1] = ACTIONS(4775),
    [anon_sym_SQUOTE] = ACTIONS(4773),
    [anon_sym___DATE__] = ACTIONS(4773),
    [anon_sym___FILE__] = ACTIONS(4773),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4773),
    [anon_sym___FUNCTION__] = ACTIONS(4773),
    [anon_sym___LINE__] = ACTIONS(4773),
    [anon_sym___MODULE__] = ACTIONS(4773),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4773),
    [anon_sym___TIME__] = ACTIONS(4773),
    [anon_sym___TIMESTAMP__] = ACTIONS(4773),
    [anon_sym___VENDOR__] = ACTIONS(4773),
    [anon_sym___VERSION__] = ACTIONS(4773),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4775),
    [sym_float_literal] = ACTIONS(4775),
    [sym__string] = ACTIONS(4775),
  },
  [2125] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_q_LBRACE] = ACTIONS(2503),
    [anon_sym_LBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_AMP] = ACTIONS(2503),
    [anon_sym_DASH] = ACTIONS(2505),
    [anon_sym_DASH_DASH] = ACTIONS(2503),
    [anon_sym_PLUS] = ACTIONS(2505),
    [anon_sym_PLUS_PLUS] = ACTIONS(2503),
    [anon_sym_BANG] = ACTIONS(2503),
    [anon_sym_LPAREN] = ACTIONS(2503),
    [anon_sym_RPAREN] = ACTIONS(2503),
    [anon_sym_LBRACK] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_DOLLAR] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_true] = ACTIONS(2505),
    [sym_false] = ACTIONS(2505),
    [sym_null] = ACTIONS(2505),
    [sym_super] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_assert] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_cast] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_delegate] = ACTIONS(2505),
    [sym_delete] = ACTIONS(2505),
    [sym_do] = ACTIONS(2505),
    [sym_else] = ACTIONS(5873),
    [sym_function] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_in] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_is] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_new] = ACTIONS(2505),
    [sym_out] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_throw] = ACTIONS(2505),
    [sym_typeid] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [anon_sym_BQUOTE] = ACTIONS(2503),
    [anon_sym_r_DQUOTE] = ACTIONS(2503),
    [anon_sym_x_DQUOTE] = ACTIONS(2503),
    [anon_sym_DQUOTE] = ACTIONS(2503),
    [anon_sym_i_BQUOTE] = ACTIONS(2503),
    [anon_sym_i_DQUOTE] = ACTIONS(2503),
    [anon_sym_iq_LBRACE] = ACTIONS(2503),
    [aux_sym_char_literal_token1] = ACTIONS(2503),
    [anon_sym_SQUOTE] = ACTIONS(2505),
    [anon_sym___DATE__] = ACTIONS(2505),
    [anon_sym___FILE__] = ACTIONS(2505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2505),
    [anon_sym___FUNCTION__] = ACTIONS(2505),
    [anon_sym___LINE__] = ACTIONS(2505),
    [anon_sym___MODULE__] = ACTIONS(2505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2505),
    [anon_sym___TIME__] = ACTIONS(2505),
    [anon_sym___TIMESTAMP__] = ACTIONS(2505),
    [anon_sym___VENDOR__] = ACTIONS(2505),
    [anon_sym___VERSION__] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2503),
    [sym_float_literal] = ACTIONS(2503),
    [sym__string] = ACTIONS(2503),
  },
  [2126] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(5875),
    [sym_function] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [2127] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(5877),
    [sym_function] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [2128] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(5879),
    [sym_function] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [2129] = {
    [sym_identifier] = ACTIONS(4366),
    [anon_sym_q_LBRACE] = ACTIONS(4368),
    [anon_sym_LBRACE] = ACTIONS(4368),
    [anon_sym_DOT] = ACTIONS(4368),
    [anon_sym_AMP] = ACTIONS(4368),
    [anon_sym_DASH] = ACTIONS(4366),
    [anon_sym_DASH_DASH] = ACTIONS(4368),
    [anon_sym_PLUS] = ACTIONS(4366),
    [anon_sym_PLUS_PLUS] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4368),
    [anon_sym_RPAREN] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4368),
    [anon_sym_SEMI] = ACTIONS(4368),
    [anon_sym_DOLLAR] = ACTIONS(4368),
    [anon_sym_STAR] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4368),
    [sym_bool] = ACTIONS(4366),
    [sym_byte] = ACTIONS(4366),
    [sym_ubyte] = ACTIONS(4366),
    [sym_char] = ACTIONS(4366),
    [sym_short] = ACTIONS(4366),
    [sym_ushort] = ACTIONS(4366),
    [sym_int] = ACTIONS(4366),
    [sym_uint] = ACTIONS(4366),
    [sym_long] = ACTIONS(4366),
    [sym_ulong] = ACTIONS(4366),
    [sym_cent] = ACTIONS(4366),
    [sym_ucent] = ACTIONS(4366),
    [sym_wchar] = ACTIONS(4366),
    [sym_dchar] = ACTIONS(4366),
    [sym_float] = ACTIONS(4366),
    [sym_double] = ACTIONS(4366),
    [sym_real] = ACTIONS(4366),
    [sym_ifloat] = ACTIONS(4366),
    [sym_idouble] = ACTIONS(4366),
    [sym_ireal] = ACTIONS(4366),
    [sym_cfloat] = ACTIONS(4366),
    [sym_cdouble] = ACTIONS(4366),
    [sym_creal] = ACTIONS(4366),
    [sym_size_t] = ACTIONS(4366),
    [sym_ptrdiff_t] = ACTIONS(4366),
    [sym_string] = ACTIONS(4366),
    [sym_cstring] = ACTIONS(4366),
    [sym_dstring] = ACTIONS(4366),
    [sym_wstring] = ACTIONS(4366),
    [sym_noreturn] = ACTIONS(4366),
    [sym_true] = ACTIONS(4366),
    [sym_false] = ACTIONS(4366),
    [sym_null] = ACTIONS(4366),
    [sym_super] = ACTIONS(4366),
    [sym_this] = ACTIONS(4366),
    [sym_assert] = ACTIONS(4366),
    [sym_auto] = ACTIONS(4366),
    [sym_cast] = ACTIONS(4366),
    [sym_const] = ACTIONS(4366),
    [sym_delegate] = ACTIONS(4366),
    [sym_delete] = ACTIONS(4366),
    [sym_do] = ACTIONS(4366),
    [sym_else] = ACTIONS(5882),
    [sym_function] = ACTIONS(4366),
    [sym_immutable] = ACTIONS(4366),
    [sym_import] = ACTIONS(4366),
    [sym_in] = ACTIONS(4366),
    [sym_inout] = ACTIONS(4366),
    [sym_is] = ACTIONS(4366),
    [sym_mixin] = ACTIONS(4366),
    [sym_new] = ACTIONS(4366),
    [sym_out] = ACTIONS(4366),
    [sym_ref] = ACTIONS(4366),
    [sym_shared] = ACTIONS(4366),
    [sym_throw] = ACTIONS(4366),
    [sym_typeid] = ACTIONS(4366),
    [sym_typeof] = ACTIONS(4366),
    [sym_traits] = ACTIONS(4366),
    [sym_vector] = ACTIONS(4366),
    [sym_void] = ACTIONS(4366),
    [anon_sym_BQUOTE] = ACTIONS(4368),
    [anon_sym_r_DQUOTE] = ACTIONS(4368),
    [anon_sym_x_DQUOTE] = ACTIONS(4368),
    [anon_sym_DQUOTE] = ACTIONS(4368),
    [anon_sym_i_BQUOTE] = ACTIONS(4368),
    [anon_sym_i_DQUOTE] = ACTIONS(4368),
    [anon_sym_iq_LBRACE] = ACTIONS(4368),
    [aux_sym_char_literal_token1] = ACTIONS(4368),
    [anon_sym_SQUOTE] = ACTIONS(4366),
    [anon_sym___DATE__] = ACTIONS(4366),
    [anon_sym___FILE__] = ACTIONS(4366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4366),
    [anon_sym___FUNCTION__] = ACTIONS(4366),
    [anon_sym___LINE__] = ACTIONS(4366),
    [anon_sym___MODULE__] = ACTIONS(4366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4366),
    [anon_sym___TIME__] = ACTIONS(4366),
    [anon_sym___TIMESTAMP__] = ACTIONS(4366),
    [anon_sym___VENDOR__] = ACTIONS(4366),
    [anon_sym___VERSION__] = ACTIONS(4366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4368),
    [sym_float_literal] = ACTIONS(4368),
    [sym__string] = ACTIONS(4368),
  },
  [2130] = {
    [sym_identifier] = ACTIONS(4741),
    [anon_sym_q_LBRACE] = ACTIONS(4743),
    [anon_sym_LBRACE] = ACTIONS(4743),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_AMP] = ACTIONS(4743),
    [anon_sym_DASH] = ACTIONS(4741),
    [anon_sym_DASH_DASH] = ACTIONS(4743),
    [anon_sym_PLUS] = ACTIONS(4741),
    [anon_sym_PLUS_PLUS] = ACTIONS(4743),
    [anon_sym_BANG] = ACTIONS(4743),
    [anon_sym_LPAREN] = ACTIONS(4743),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [anon_sym_LBRACK] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_DOLLAR] = ACTIONS(4743),
    [anon_sym_STAR] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [sym_bool] = ACTIONS(4741),
    [sym_byte] = ACTIONS(4741),
    [sym_ubyte] = ACTIONS(4741),
    [sym_char] = ACTIONS(4741),
    [sym_short] = ACTIONS(4741),
    [sym_ushort] = ACTIONS(4741),
    [sym_int] = ACTIONS(4741),
    [sym_uint] = ACTIONS(4741),
    [sym_long] = ACTIONS(4741),
    [sym_ulong] = ACTIONS(4741),
    [sym_cent] = ACTIONS(4741),
    [sym_ucent] = ACTIONS(4741),
    [sym_wchar] = ACTIONS(4741),
    [sym_dchar] = ACTIONS(4741),
    [sym_float] = ACTIONS(4741),
    [sym_double] = ACTIONS(4741),
    [sym_real] = ACTIONS(4741),
    [sym_ifloat] = ACTIONS(4741),
    [sym_idouble] = ACTIONS(4741),
    [sym_ireal] = ACTIONS(4741),
    [sym_cfloat] = ACTIONS(4741),
    [sym_cdouble] = ACTIONS(4741),
    [sym_creal] = ACTIONS(4741),
    [sym_size_t] = ACTIONS(4741),
    [sym_ptrdiff_t] = ACTIONS(4741),
    [sym_string] = ACTIONS(4741),
    [sym_cstring] = ACTIONS(4741),
    [sym_dstring] = ACTIONS(4741),
    [sym_wstring] = ACTIONS(4741),
    [sym_noreturn] = ACTIONS(4741),
    [sym_true] = ACTIONS(4741),
    [sym_false] = ACTIONS(4741),
    [sym_null] = ACTIONS(4741),
    [sym_super] = ACTIONS(4741),
    [sym_this] = ACTIONS(4741),
    [sym_assert] = ACTIONS(4741),
    [sym_auto] = ACTIONS(4741),
    [sym_cast] = ACTIONS(4741),
    [sym_const] = ACTIONS(4741),
    [sym_delegate] = ACTIONS(4741),
    [sym_delete] = ACTIONS(4741),
    [sym_do] = ACTIONS(4741),
    [sym_else] = ACTIONS(5884),
    [sym_function] = ACTIONS(4741),
    [sym_immutable] = ACTIONS(4741),
    [sym_import] = ACTIONS(4741),
    [sym_in] = ACTIONS(4741),
    [sym_inout] = ACTIONS(4741),
    [sym_is] = ACTIONS(4741),
    [sym_mixin] = ACTIONS(4741),
    [sym_new] = ACTIONS(4741),
    [sym_out] = ACTIONS(4741),
    [sym_ref] = ACTIONS(4741),
    [sym_shared] = ACTIONS(4741),
    [sym_throw] = ACTIONS(4741),
    [sym_typeid] = ACTIONS(4741),
    [sym_typeof] = ACTIONS(4741),
    [sym_traits] = ACTIONS(4741),
    [sym_vector] = ACTIONS(4741),
    [sym_void] = ACTIONS(4741),
    [anon_sym_BQUOTE] = ACTIONS(4743),
    [anon_sym_r_DQUOTE] = ACTIONS(4743),
    [anon_sym_x_DQUOTE] = ACTIONS(4743),
    [anon_sym_DQUOTE] = ACTIONS(4743),
    [anon_sym_i_BQUOTE] = ACTIONS(4743),
    [anon_sym_i_DQUOTE] = ACTIONS(4743),
    [anon_sym_iq_LBRACE] = ACTIONS(4743),
    [aux_sym_char_literal_token1] = ACTIONS(4743),
    [anon_sym_SQUOTE] = ACTIONS(4741),
    [anon_sym___DATE__] = ACTIONS(4741),
    [anon_sym___FILE__] = ACTIONS(4741),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4741),
    [anon_sym___FUNCTION__] = ACTIONS(4741),
    [anon_sym___LINE__] = ACTIONS(4741),
    [anon_sym___MODULE__] = ACTIONS(4741),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4741),
    [anon_sym___TIME__] = ACTIONS(4741),
    [anon_sym___TIMESTAMP__] = ACTIONS(4741),
    [anon_sym___VENDOR__] = ACTIONS(4741),
    [anon_sym___VERSION__] = ACTIONS(4741),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4743),
    [sym_float_literal] = ACTIONS(4743),
    [sym__string] = ACTIONS(4743),
  },
  [2131] = {
    [sym_identifier] = ACTIONS(4682),
    [anon_sym_q_LBRACE] = ACTIONS(4684),
    [anon_sym_LBRACE] = ACTIONS(4684),
    [anon_sym_DOT] = ACTIONS(4684),
    [anon_sym_AMP] = ACTIONS(4684),
    [anon_sym_DASH] = ACTIONS(4682),
    [anon_sym_DASH_DASH] = ACTIONS(4684),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_PLUS_PLUS] = ACTIONS(4684),
    [anon_sym_BANG] = ACTIONS(4684),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_RPAREN] = ACTIONS(4684),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_SEMI] = ACTIONS(4684),
    [anon_sym_DOLLAR] = ACTIONS(4684),
    [anon_sym_STAR] = ACTIONS(4684),
    [anon_sym_TILDE] = ACTIONS(4684),
    [sym_bool] = ACTIONS(4682),
    [sym_byte] = ACTIONS(4682),
    [sym_ubyte] = ACTIONS(4682),
    [sym_char] = ACTIONS(4682),
    [sym_short] = ACTIONS(4682),
    [sym_ushort] = ACTIONS(4682),
    [sym_int] = ACTIONS(4682),
    [sym_uint] = ACTIONS(4682),
    [sym_long] = ACTIONS(4682),
    [sym_ulong] = ACTIONS(4682),
    [sym_cent] = ACTIONS(4682),
    [sym_ucent] = ACTIONS(4682),
    [sym_wchar] = ACTIONS(4682),
    [sym_dchar] = ACTIONS(4682),
    [sym_float] = ACTIONS(4682),
    [sym_double] = ACTIONS(4682),
    [sym_real] = ACTIONS(4682),
    [sym_ifloat] = ACTIONS(4682),
    [sym_idouble] = ACTIONS(4682),
    [sym_ireal] = ACTIONS(4682),
    [sym_cfloat] = ACTIONS(4682),
    [sym_cdouble] = ACTIONS(4682),
    [sym_creal] = ACTIONS(4682),
    [sym_size_t] = ACTIONS(4682),
    [sym_ptrdiff_t] = ACTIONS(4682),
    [sym_string] = ACTIONS(4682),
    [sym_cstring] = ACTIONS(4682),
    [sym_dstring] = ACTIONS(4682),
    [sym_wstring] = ACTIONS(4682),
    [sym_noreturn] = ACTIONS(4682),
    [sym_true] = ACTIONS(4682),
    [sym_false] = ACTIONS(4682),
    [sym_null] = ACTIONS(4682),
    [sym_super] = ACTIONS(4682),
    [sym_this] = ACTIONS(4682),
    [sym_assert] = ACTIONS(4682),
    [sym_auto] = ACTIONS(4682),
    [sym_cast] = ACTIONS(4682),
    [sym_const] = ACTIONS(4682),
    [sym_delegate] = ACTIONS(4682),
    [sym_delete] = ACTIONS(4682),
    [sym_do] = ACTIONS(4682),
    [sym_else] = ACTIONS(5886),
    [sym_function] = ACTIONS(4682),
    [sym_immutable] = ACTIONS(4682),
    [sym_import] = ACTIONS(4682),
    [sym_in] = ACTIONS(4682),
    [sym_inout] = ACTIONS(4682),
    [sym_is] = ACTIONS(4682),
    [sym_mixin] = ACTIONS(4682),
    [sym_new] = ACTIONS(4682),
    [sym_out] = ACTIONS(4682),
    [sym_ref] = ACTIONS(4682),
    [sym_shared] = ACTIONS(4682),
    [sym_throw] = ACTIONS(4682),
    [sym_typeid] = ACTIONS(4682),
    [sym_typeof] = ACTIONS(4682),
    [sym_traits] = ACTIONS(4682),
    [sym_vector] = ACTIONS(4682),
    [sym_void] = ACTIONS(4682),
    [anon_sym_BQUOTE] = ACTIONS(4684),
    [anon_sym_r_DQUOTE] = ACTIONS(4684),
    [anon_sym_x_DQUOTE] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(4684),
    [anon_sym_i_BQUOTE] = ACTIONS(4684),
    [anon_sym_i_DQUOTE] = ACTIONS(4684),
    [anon_sym_iq_LBRACE] = ACTIONS(4684),
    [aux_sym_char_literal_token1] = ACTIONS(4684),
    [anon_sym_SQUOTE] = ACTIONS(4682),
    [anon_sym___DATE__] = ACTIONS(4682),
    [anon_sym___FILE__] = ACTIONS(4682),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4682),
    [anon_sym___FUNCTION__] = ACTIONS(4682),
    [anon_sym___LINE__] = ACTIONS(4682),
    [anon_sym___MODULE__] = ACTIONS(4682),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4682),
    [anon_sym___TIME__] = ACTIONS(4682),
    [anon_sym___TIMESTAMP__] = ACTIONS(4682),
    [anon_sym___VENDOR__] = ACTIONS(4682),
    [anon_sym___VERSION__] = ACTIONS(4682),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4684),
    [sym_float_literal] = ACTIONS(4684),
    [sym__string] = ACTIONS(4684),
  },
  [2132] = {
    [sym_identifier] = ACTIONS(4688),
    [anon_sym_q_LBRACE] = ACTIONS(4691),
    [anon_sym_LBRACE] = ACTIONS(4691),
    [anon_sym_DOT] = ACTIONS(4691),
    [anon_sym_AMP] = ACTIONS(4691),
    [anon_sym_DASH] = ACTIONS(4688),
    [anon_sym_DASH_DASH] = ACTIONS(4691),
    [anon_sym_PLUS] = ACTIONS(4688),
    [anon_sym_PLUS_PLUS] = ACTIONS(4691),
    [anon_sym_BANG] = ACTIONS(4691),
    [anon_sym_LPAREN] = ACTIONS(4691),
    [anon_sym_RPAREN] = ACTIONS(4691),
    [anon_sym_LBRACK] = ACTIONS(4691),
    [anon_sym_SEMI] = ACTIONS(4691),
    [anon_sym_DOLLAR] = ACTIONS(4691),
    [anon_sym_STAR] = ACTIONS(4691),
    [anon_sym_TILDE] = ACTIONS(4691),
    [sym_bool] = ACTIONS(4688),
    [sym_byte] = ACTIONS(4688),
    [sym_ubyte] = ACTIONS(4688),
    [sym_char] = ACTIONS(4688),
    [sym_short] = ACTIONS(4688),
    [sym_ushort] = ACTIONS(4688),
    [sym_int] = ACTIONS(4688),
    [sym_uint] = ACTIONS(4688),
    [sym_long] = ACTIONS(4688),
    [sym_ulong] = ACTIONS(4688),
    [sym_cent] = ACTIONS(4688),
    [sym_ucent] = ACTIONS(4688),
    [sym_wchar] = ACTIONS(4688),
    [sym_dchar] = ACTIONS(4688),
    [sym_float] = ACTIONS(4688),
    [sym_double] = ACTIONS(4688),
    [sym_real] = ACTIONS(4688),
    [sym_ifloat] = ACTIONS(4688),
    [sym_idouble] = ACTIONS(4688),
    [sym_ireal] = ACTIONS(4688),
    [sym_cfloat] = ACTIONS(4688),
    [sym_cdouble] = ACTIONS(4688),
    [sym_creal] = ACTIONS(4688),
    [sym_size_t] = ACTIONS(4688),
    [sym_ptrdiff_t] = ACTIONS(4688),
    [sym_string] = ACTIONS(4688),
    [sym_cstring] = ACTIONS(4688),
    [sym_dstring] = ACTIONS(4688),
    [sym_wstring] = ACTIONS(4688),
    [sym_noreturn] = ACTIONS(4688),
    [sym_true] = ACTIONS(4688),
    [sym_false] = ACTIONS(4688),
    [sym_null] = ACTIONS(4688),
    [sym_super] = ACTIONS(4688),
    [sym_this] = ACTIONS(4688),
    [sym_assert] = ACTIONS(4688),
    [sym_auto] = ACTIONS(4688),
    [sym_cast] = ACTIONS(4688),
    [sym_const] = ACTIONS(4688),
    [sym_delegate] = ACTIONS(4688),
    [sym_delete] = ACTIONS(4688),
    [sym_do] = ACTIONS(4688),
    [sym_else] = ACTIONS(5888),
    [sym_function] = ACTIONS(4688),
    [sym_immutable] = ACTIONS(4688),
    [sym_import] = ACTIONS(4688),
    [sym_in] = ACTIONS(4688),
    [sym_inout] = ACTIONS(4688),
    [sym_is] = ACTIONS(4688),
    [sym_mixin] = ACTIONS(4688),
    [sym_new] = ACTIONS(4688),
    [sym_out] = ACTIONS(4688),
    [sym_ref] = ACTIONS(4688),
    [sym_shared] = ACTIONS(4688),
    [sym_throw] = ACTIONS(4688),
    [sym_typeid] = ACTIONS(4688),
    [sym_typeof] = ACTIONS(4688),
    [sym_traits] = ACTIONS(4688),
    [sym_vector] = ACTIONS(4688),
    [sym_void] = ACTIONS(4688),
    [anon_sym_BQUOTE] = ACTIONS(4691),
    [anon_sym_r_DQUOTE] = ACTIONS(4691),
    [anon_sym_x_DQUOTE] = ACTIONS(4691),
    [anon_sym_DQUOTE] = ACTIONS(4691),
    [anon_sym_i_BQUOTE] = ACTIONS(4691),
    [anon_sym_i_DQUOTE] = ACTIONS(4691),
    [anon_sym_iq_LBRACE] = ACTIONS(4691),
    [aux_sym_char_literal_token1] = ACTIONS(4691),
    [anon_sym_SQUOTE] = ACTIONS(4688),
    [anon_sym___DATE__] = ACTIONS(4688),
    [anon_sym___FILE__] = ACTIONS(4688),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(4688),
    [anon_sym___FUNCTION__] = ACTIONS(4688),
    [anon_sym___LINE__] = ACTIONS(4688),
    [anon_sym___MODULE__] = ACTIONS(4688),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(4688),
    [anon_sym___TIME__] = ACTIONS(4688),
    [anon_sym___TIMESTAMP__] = ACTIONS(4688),
    [anon_sym___VENDOR__] = ACTIONS(4688),
    [anon_sym___VERSION__] = ACTIONS(4688),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(4691),
    [sym_float_literal] = ACTIONS(4691),
    [sym__string] = ACTIONS(4691),
  },
  [2133] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_q_LBRACE] = ACTIONS(2632),
    [anon_sym_LBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_AMP] = ACTIONS(2632),
    [anon_sym_DASH] = ACTIONS(2634),
    [anon_sym_DASH_DASH] = ACTIONS(2632),
    [anon_sym_PLUS] = ACTIONS(2634),
    [anon_sym_PLUS_PLUS] = ACTIONS(2632),
    [anon_sym_BANG] = ACTIONS(2632),
    [anon_sym_LPAREN] = ACTIONS(2632),
    [anon_sym_RPAREN] = ACTIONS(2632),
    [anon_sym_LBRACK] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_DOLLAR] = ACTIONS(2632),
    [anon_sym_STAR] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [sym_bool] = ACTIONS(2634),
    [sym_byte] = ACTIONS(2634),
    [sym_ubyte] = ACTIONS(2634),
    [sym_char] = ACTIONS(2634),
    [sym_short] = ACTIONS(2634),
    [sym_ushort] = ACTIONS(2634),
    [sym_int] = ACTIONS(2634),
    [sym_uint] = ACTIONS(2634),
    [sym_long] = ACTIONS(2634),
    [sym_ulong] = ACTIONS(2634),
    [sym_cent] = ACTIONS(2634),
    [sym_ucent] = ACTIONS(2634),
    [sym_wchar] = ACTIONS(2634),
    [sym_dchar] = ACTIONS(2634),
    [sym_float] = ACTIONS(2634),
    [sym_double] = ACTIONS(2634),
    [sym_real] = ACTIONS(2634),
    [sym_ifloat] = ACTIONS(2634),
    [sym_idouble] = ACTIONS(2634),
    [sym_ireal] = ACTIONS(2634),
    [sym_cfloat] = ACTIONS(2634),
    [sym_cdouble] = ACTIONS(2634),
    [sym_creal] = ACTIONS(2634),
    [sym_size_t] = ACTIONS(2634),
    [sym_ptrdiff_t] = ACTIONS(2634),
    [sym_string] = ACTIONS(2634),
    [sym_cstring] = ACTIONS(2634),
    [sym_dstring] = ACTIONS(2634),
    [sym_wstring] = ACTIONS(2634),
    [sym_noreturn] = ACTIONS(2634),
    [sym_true] = ACTIONS(2634),
    [sym_false] = ACTIONS(2634),
    [sym_null] = ACTIONS(2634),
    [sym_super] = ACTIONS(2634),
    [sym_this] = ACTIONS(2634),
    [sym_assert] = ACTIONS(2634),
    [sym_auto] = ACTIONS(2634),
    [sym_cast] = ACTIONS(2634),
    [sym_const] = ACTIONS(2634),
    [sym_delegate] = ACTIONS(2634),
    [sym_delete] = ACTIONS(2634),
    [sym_do] = ACTIONS(2634),
    [sym_else] = ACTIONS(5892),
    [sym_function] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(2634),
    [sym_import] = ACTIONS(2634),
    [sym_in] = ACTIONS(2634),
    [sym_inout] = ACTIONS(2634),
    [sym_is] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2634),
    [sym_new] = ACTIONS(2634),
    [sym_out] = ACTIONS(2634),
    [sym_ref] = ACTIONS(2634),
    [sym_shared] = ACTIONS(2634),
    [sym_throw] = ACTIONS(2634),
    [sym_typeid] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(2634),
    [sym_traits] = ACTIONS(2634),
    [sym_vector] = ACTIONS(2634),
    [sym_void] = ACTIONS(2634),
    [anon_sym_BQUOTE] = ACTIONS(2632),
    [anon_sym_r_DQUOTE] = ACTIONS(2632),
    [anon_sym_x_DQUOTE] = ACTIONS(2632),
    [anon_sym_DQUOTE] = ACTIONS(2632),
    [anon_sym_i_BQUOTE] = ACTIONS(2632),
    [anon_sym_i_DQUOTE] = ACTIONS(2632),
    [anon_sym_iq_LBRACE] = ACTIONS(2632),
    [aux_sym_char_literal_token1] = ACTIONS(2632),
    [anon_sym_SQUOTE] = ACTIONS(2634),
    [anon_sym___DATE__] = ACTIONS(2634),
    [anon_sym___FILE__] = ACTIONS(2634),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(2634),
    [anon_sym___FUNCTION__] = ACTIONS(2634),
    [anon_sym___LINE__] = ACTIONS(2634),
    [anon_sym___MODULE__] = ACTIONS(2634),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(2634),
    [anon_sym___TIME__] = ACTIONS(2634),
    [anon_sym___TIMESTAMP__] = ACTIONS(2634),
    [anon_sym___VENDOR__] = ACTIONS(2634),
    [anon_sym___VERSION__] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(2632),
    [sym_float_literal] = ACTIONS(2632),
    [sym__string] = ACTIONS(2632),
  },
  [2134] = {
    [sym_storage_class] = STATE(2141),
    [sym_type] = STATE(4658),
    [sym_type_ctor] = STATE(2704),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(5361),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2141),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5908),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5914),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2135] = {
    [sym_storage_class] = STATE(2552),
    [sym_type] = STATE(5161),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(6526),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2552),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5918),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2136] = {
    [sym_storage_class] = STATE(2551),
    [sym_type] = STATE(5173),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(5644),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2551),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5918),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2137] = {
    [sym_storage_class] = STATE(2550),
    [sym_type] = STATE(4750),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(5868),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2550),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5918),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2138] = {
    [sym_storage_class] = STATE(2564),
    [sym_type] = STATE(4893),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(6273),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2564),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5918),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2139] = {
    [sym_storage_class] = STATE(2554),
    [sym_type] = STATE(4827),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(6155),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2554),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5918),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2140] = {
    [sym_storage_class] = STATE(2142),
    [sym_type] = STATE(4689),
    [sym_type_ctor] = STATE(2704),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(5392),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2142),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5908),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5914),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2141] = {
    [sym_storage_class] = STATE(2607),
    [sym_type] = STATE(4689),
    [sym_type_ctor] = STATE(2704),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(5392),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2607),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5908),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5914),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2142] = {
    [sym_storage_class] = STATE(2607),
    [sym_type] = STATE(4633),
    [sym_type_ctor] = STATE(2704),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_function_literal] = STATE(5555),
    [sym__parameter_with_member_attributes] = STATE(4179),
    [sym_block_statement] = STATE(5342),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5342),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2607),
    [aux_sym_type_repeat1] = STATE(3238),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5902),
    [sym_const] = ACTIONS(2125),
    [sym_delegate] = ACTIONS(5904),
    [sym_deprecated] = ACTIONS(5900),
    [sym_do] = ACTIONS(5906),
    [sym_extern] = ACTIONS(5908),
    [sym_final] = ACTIONS(5900),
    [sym_function] = ACTIONS(5910),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_out] = ACTIONS(167),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5914),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2143] = {
    [sym_identifier] = ACTIONS(5920),
    [anon_sym_LBRACE] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_BANG] = ACTIONS(5922),
    [anon_sym_LPAREN] = ACTIONS(5922),
    [anon_sym_RPAREN] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_RBRACK] = ACTIONS(5922),
    [anon_sym_COMMA] = ACTIONS(5922),
    [anon_sym_SEMI] = ACTIONS(5922),
    [anon_sym_COLON] = ACTIONS(5922),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5922),
    [anon_sym_AT] = ACTIONS(5922),
    [sym_bool] = ACTIONS(5920),
    [sym_byte] = ACTIONS(5920),
    [sym_ubyte] = ACTIONS(5920),
    [sym_char] = ACTIONS(5920),
    [sym_short] = ACTIONS(5920),
    [sym_ushort] = ACTIONS(5920),
    [sym_int] = ACTIONS(5920),
    [sym_uint] = ACTIONS(5920),
    [sym_long] = ACTIONS(5920),
    [sym_ulong] = ACTIONS(5920),
    [sym_cent] = ACTIONS(5920),
    [sym_ucent] = ACTIONS(5920),
    [sym_wchar] = ACTIONS(5920),
    [sym_dchar] = ACTIONS(5920),
    [sym_float] = ACTIONS(5920),
    [sym_double] = ACTIONS(5920),
    [sym_real] = ACTIONS(5920),
    [sym_ifloat] = ACTIONS(5920),
    [sym_idouble] = ACTIONS(5920),
    [sym_ireal] = ACTIONS(5920),
    [sym_cfloat] = ACTIONS(5920),
    [sym_cdouble] = ACTIONS(5920),
    [sym_creal] = ACTIONS(5920),
    [sym_size_t] = ACTIONS(5920),
    [sym_ptrdiff_t] = ACTIONS(5920),
    [sym_string] = ACTIONS(5920),
    [sym_cstring] = ACTIONS(5920),
    [sym_dstring] = ACTIONS(5920),
    [sym_wstring] = ACTIONS(5920),
    [sym_noreturn] = ACTIONS(5920),
    [sym_this] = ACTIONS(5920),
    [sym_abstract] = ACTIONS(5920),
    [sym_alias] = ACTIONS(5920),
    [sym_align] = ACTIONS(5920),
    [sym_auto] = ACTIONS(5920),
    [sym_class] = ACTIONS(5920),
    [sym_const] = ACTIONS(5920),
    [sym_debug] = ACTIONS(5920),
    [sym_delegate] = ACTIONS(5920),
    [sym_deprecated] = ACTIONS(5920),
    [sym_enum] = ACTIONS(5920),
    [sym_export] = ACTIONS(5920),
    [sym_extern] = ACTIONS(5920),
    [sym_final] = ACTIONS(5920),
    [sym_function] = ACTIONS(5920),
    [sym_immutable] = ACTIONS(5920),
    [sym_import] = ACTIONS(5920),
    [sym_inout] = ACTIONS(5920),
    [sym_interface] = ACTIONS(5920),
    [sym_invariant] = ACTIONS(5920),
    [sym_mixin] = ACTIONS(5920),
    [sym_module] = ACTIONS(5920),
    [sym_nothrow] = ACTIONS(5920),
    [sym_override] = ACTIONS(5920),
    [sym_package] = ACTIONS(5920),
    [sym_pragma] = ACTIONS(5920),
    [sym_private] = ACTIONS(5920),
    [sym_protected] = ACTIONS(5920),
    [sym_public] = ACTIONS(5920),
    [sym_pure] = ACTIONS(5920),
    [sym_ref] = ACTIONS(5920),
    [sym_return] = ACTIONS(5920),
    [sym_scope] = ACTIONS(5920),
    [sym_shared] = ACTIONS(5920),
    [sym_static] = ACTIONS(5920),
    [sym_struct] = ACTIONS(5920),
    [sym_synchronized] = ACTIONS(5920),
    [sym_template] = ACTIONS(5920),
    [sym_typeof] = ACTIONS(5920),
    [sym_union] = ACTIONS(5920),
    [sym_unittest] = ACTIONS(5920),
    [sym_version] = ACTIONS(5920),
    [sym_gshared] = ACTIONS(5920),
    [sym_traits] = ACTIONS(5920),
    [sym_vector] = ACTIONS(5920),
    [sym_void] = ACTIONS(5920),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2144] = {
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_BANG] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_RBRACK] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [sym_bool] = ACTIONS(3053),
    [sym_byte] = ACTIONS(3053),
    [sym_ubyte] = ACTIONS(3053),
    [sym_char] = ACTIONS(3053),
    [sym_short] = ACTIONS(3053),
    [sym_ushort] = ACTIONS(3053),
    [sym_int] = ACTIONS(3053),
    [sym_uint] = ACTIONS(3053),
    [sym_long] = ACTIONS(3053),
    [sym_ulong] = ACTIONS(3053),
    [sym_cent] = ACTIONS(3053),
    [sym_ucent] = ACTIONS(3053),
    [sym_wchar] = ACTIONS(3053),
    [sym_dchar] = ACTIONS(3053),
    [sym_float] = ACTIONS(3053),
    [sym_double] = ACTIONS(3053),
    [sym_real] = ACTIONS(3053),
    [sym_ifloat] = ACTIONS(3053),
    [sym_idouble] = ACTIONS(3053),
    [sym_ireal] = ACTIONS(3053),
    [sym_cfloat] = ACTIONS(3053),
    [sym_cdouble] = ACTIONS(3053),
    [sym_creal] = ACTIONS(3053),
    [sym_size_t] = ACTIONS(3053),
    [sym_ptrdiff_t] = ACTIONS(3053),
    [sym_string] = ACTIONS(3053),
    [sym_cstring] = ACTIONS(3053),
    [sym_dstring] = ACTIONS(3053),
    [sym_wstring] = ACTIONS(3053),
    [sym_noreturn] = ACTIONS(3053),
    [sym_this] = ACTIONS(3053),
    [sym_abstract] = ACTIONS(3053),
    [sym_alias] = ACTIONS(3053),
    [sym_align] = ACTIONS(3053),
    [sym_auto] = ACTIONS(3053),
    [sym_class] = ACTIONS(3053),
    [sym_const] = ACTIONS(3053),
    [sym_debug] = ACTIONS(3053),
    [sym_delegate] = ACTIONS(3053),
    [sym_deprecated] = ACTIONS(3053),
    [sym_enum] = ACTIONS(3053),
    [sym_export] = ACTIONS(3053),
    [sym_extern] = ACTIONS(3053),
    [sym_final] = ACTIONS(3053),
    [sym_function] = ACTIONS(3053),
    [sym_immutable] = ACTIONS(3053),
    [sym_import] = ACTIONS(3053),
    [sym_inout] = ACTIONS(3053),
    [sym_interface] = ACTIONS(3053),
    [sym_invariant] = ACTIONS(3053),
    [sym_mixin] = ACTIONS(3053),
    [sym_module] = ACTIONS(3053),
    [sym_nothrow] = ACTIONS(3053),
    [sym_override] = ACTIONS(3053),
    [sym_package] = ACTIONS(3053),
    [sym_pragma] = ACTIONS(3053),
    [sym_private] = ACTIONS(3053),
    [sym_protected] = ACTIONS(3053),
    [sym_public] = ACTIONS(3053),
    [sym_pure] = ACTIONS(3053),
    [sym_ref] = ACTIONS(3053),
    [sym_return] = ACTIONS(3053),
    [sym_scope] = ACTIONS(3053),
    [sym_shared] = ACTIONS(3053),
    [sym_static] = ACTIONS(3053),
    [sym_struct] = ACTIONS(3053),
    [sym_synchronized] = ACTIONS(3053),
    [sym_template] = ACTIONS(3053),
    [sym_typeof] = ACTIONS(3053),
    [sym_union] = ACTIONS(3053),
    [sym_unittest] = ACTIONS(3053),
    [sym_version] = ACTIONS(3053),
    [sym_gshared] = ACTIONS(3053),
    [sym_traits] = ACTIONS(3053),
    [sym_vector] = ACTIONS(3053),
    [sym_void] = ACTIONS(3053),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2145] = {
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_BANG] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_EQ_EQ] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [sym_bool] = ACTIONS(3117),
    [sym_byte] = ACTIONS(3117),
    [sym_ubyte] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_short] = ACTIONS(3117),
    [sym_ushort] = ACTIONS(3117),
    [sym_int] = ACTIONS(3117),
    [sym_uint] = ACTIONS(3117),
    [sym_long] = ACTIONS(3117),
    [sym_ulong] = ACTIONS(3117),
    [sym_cent] = ACTIONS(3117),
    [sym_ucent] = ACTIONS(3117),
    [sym_wchar] = ACTIONS(3117),
    [sym_dchar] = ACTIONS(3117),
    [sym_float] = ACTIONS(3117),
    [sym_double] = ACTIONS(3117),
    [sym_real] = ACTIONS(3117),
    [sym_ifloat] = ACTIONS(3117),
    [sym_idouble] = ACTIONS(3117),
    [sym_ireal] = ACTIONS(3117),
    [sym_cfloat] = ACTIONS(3117),
    [sym_cdouble] = ACTIONS(3117),
    [sym_creal] = ACTIONS(3117),
    [sym_size_t] = ACTIONS(3117),
    [sym_ptrdiff_t] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym_cstring] = ACTIONS(3117),
    [sym_dstring] = ACTIONS(3117),
    [sym_wstring] = ACTIONS(3117),
    [sym_noreturn] = ACTIONS(3117),
    [sym_this] = ACTIONS(3117),
    [sym_abstract] = ACTIONS(3117),
    [sym_alias] = ACTIONS(3117),
    [sym_align] = ACTIONS(3117),
    [sym_auto] = ACTIONS(3117),
    [sym_class] = ACTIONS(3117),
    [sym_const] = ACTIONS(3117),
    [sym_debug] = ACTIONS(3117),
    [sym_delegate] = ACTIONS(3117),
    [sym_deprecated] = ACTIONS(3117),
    [sym_enum] = ACTIONS(3117),
    [sym_export] = ACTIONS(3117),
    [sym_extern] = ACTIONS(3117),
    [sym_final] = ACTIONS(3117),
    [sym_function] = ACTIONS(3117),
    [sym_immutable] = ACTIONS(3117),
    [sym_import] = ACTIONS(3117),
    [sym_inout] = ACTIONS(3117),
    [sym_interface] = ACTIONS(3117),
    [sym_invariant] = ACTIONS(3117),
    [sym_mixin] = ACTIONS(3117),
    [sym_module] = ACTIONS(3117),
    [sym_nothrow] = ACTIONS(3117),
    [sym_override] = ACTIONS(3117),
    [sym_package] = ACTIONS(3117),
    [sym_pragma] = ACTIONS(3117),
    [sym_private] = ACTIONS(3117),
    [sym_protected] = ACTIONS(3117),
    [sym_public] = ACTIONS(3117),
    [sym_pure] = ACTIONS(3117),
    [sym_ref] = ACTIONS(3117),
    [sym_return] = ACTIONS(3117),
    [sym_scope] = ACTIONS(3117),
    [sym_shared] = ACTIONS(3117),
    [sym_static] = ACTIONS(3117),
    [sym_struct] = ACTIONS(3117),
    [sym_synchronized] = ACTIONS(3117),
    [sym_template] = ACTIONS(3117),
    [sym_typeof] = ACTIONS(3117),
    [sym_union] = ACTIONS(3117),
    [sym_unittest] = ACTIONS(3117),
    [sym_version] = ACTIONS(3117),
    [sym_gshared] = ACTIONS(3117),
    [sym_traits] = ACTIONS(3117),
    [sym_vector] = ACTIONS(3117),
    [sym_void] = ACTIONS(3117),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_BANG] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3115),
    [sym_bool] = ACTIONS(3113),
    [sym_byte] = ACTIONS(3113),
    [sym_ubyte] = ACTIONS(3113),
    [sym_char] = ACTIONS(3113),
    [sym_short] = ACTIONS(3113),
    [sym_ushort] = ACTIONS(3113),
    [sym_int] = ACTIONS(3113),
    [sym_uint] = ACTIONS(3113),
    [sym_long] = ACTIONS(3113),
    [sym_ulong] = ACTIONS(3113),
    [sym_cent] = ACTIONS(3113),
    [sym_ucent] = ACTIONS(3113),
    [sym_wchar] = ACTIONS(3113),
    [sym_dchar] = ACTIONS(3113),
    [sym_float] = ACTIONS(3113),
    [sym_double] = ACTIONS(3113),
    [sym_real] = ACTIONS(3113),
    [sym_ifloat] = ACTIONS(3113),
    [sym_idouble] = ACTIONS(3113),
    [sym_ireal] = ACTIONS(3113),
    [sym_cfloat] = ACTIONS(3113),
    [sym_cdouble] = ACTIONS(3113),
    [sym_creal] = ACTIONS(3113),
    [sym_size_t] = ACTIONS(3113),
    [sym_ptrdiff_t] = ACTIONS(3113),
    [sym_string] = ACTIONS(3113),
    [sym_cstring] = ACTIONS(3113),
    [sym_dstring] = ACTIONS(3113),
    [sym_wstring] = ACTIONS(3113),
    [sym_noreturn] = ACTIONS(3113),
    [sym_this] = ACTIONS(3113),
    [sym_abstract] = ACTIONS(3113),
    [sym_alias] = ACTIONS(3113),
    [sym_align] = ACTIONS(3113),
    [sym_auto] = ACTIONS(3113),
    [sym_class] = ACTIONS(3113),
    [sym_const] = ACTIONS(3113),
    [sym_debug] = ACTIONS(3113),
    [sym_delegate] = ACTIONS(3113),
    [sym_deprecated] = ACTIONS(3113),
    [sym_enum] = ACTIONS(3113),
    [sym_export] = ACTIONS(3113),
    [sym_extern] = ACTIONS(3113),
    [sym_final] = ACTIONS(3113),
    [sym_function] = ACTIONS(3113),
    [sym_immutable] = ACTIONS(3113),
    [sym_import] = ACTIONS(3113),
    [sym_inout] = ACTIONS(3113),
    [sym_interface] = ACTIONS(3113),
    [sym_invariant] = ACTIONS(3113),
    [sym_mixin] = ACTIONS(3113),
    [sym_module] = ACTIONS(3113),
    [sym_nothrow] = ACTIONS(3113),
    [sym_override] = ACTIONS(3113),
    [sym_package] = ACTIONS(3113),
    [sym_pragma] = ACTIONS(3113),
    [sym_private] = ACTIONS(3113),
    [sym_protected] = ACTIONS(3113),
    [sym_public] = ACTIONS(3113),
    [sym_pure] = ACTIONS(3113),
    [sym_ref] = ACTIONS(3113),
    [sym_return] = ACTIONS(3113),
    [sym_scope] = ACTIONS(3113),
    [sym_shared] = ACTIONS(3113),
    [sym_static] = ACTIONS(3113),
    [sym_struct] = ACTIONS(3113),
    [sym_synchronized] = ACTIONS(3113),
    [sym_template] = ACTIONS(3113),
    [sym_typeof] = ACTIONS(3113),
    [sym_union] = ACTIONS(3113),
    [sym_unittest] = ACTIONS(3113),
    [sym_version] = ACTIONS(3113),
    [sym_gshared] = ACTIONS(3113),
    [sym_traits] = ACTIONS(3113),
    [sym_vector] = ACTIONS(3113),
    [sym_void] = ACTIONS(3113),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2147] = {
    [sym_arguments] = STATE(2167),
    [sym_template_arguments] = STATE(2151),
    [sym_identifier] = ACTIONS(5924),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5926),
    [anon_sym_BANG] = ACTIONS(5928),
    [anon_sym_LPAREN] = ACTIONS(5930),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_bool] = ACTIONS(5924),
    [sym_byte] = ACTIONS(5924),
    [sym_ubyte] = ACTIONS(5924),
    [sym_char] = ACTIONS(5924),
    [sym_short] = ACTIONS(5924),
    [sym_ushort] = ACTIONS(5924),
    [sym_int] = ACTIONS(5924),
    [sym_uint] = ACTIONS(5924),
    [sym_long] = ACTIONS(5924),
    [sym_ulong] = ACTIONS(5924),
    [sym_cent] = ACTIONS(5924),
    [sym_ucent] = ACTIONS(5924),
    [sym_wchar] = ACTIONS(5924),
    [sym_dchar] = ACTIONS(5924),
    [sym_float] = ACTIONS(5924),
    [sym_double] = ACTIONS(5924),
    [sym_real] = ACTIONS(5924),
    [sym_ifloat] = ACTIONS(5924),
    [sym_idouble] = ACTIONS(5924),
    [sym_ireal] = ACTIONS(5924),
    [sym_cfloat] = ACTIONS(5924),
    [sym_cdouble] = ACTIONS(5924),
    [sym_creal] = ACTIONS(5924),
    [sym_size_t] = ACTIONS(5924),
    [sym_ptrdiff_t] = ACTIONS(5924),
    [sym_string] = ACTIONS(5924),
    [sym_cstring] = ACTIONS(5924),
    [sym_dstring] = ACTIONS(5924),
    [sym_wstring] = ACTIONS(5924),
    [sym_noreturn] = ACTIONS(5924),
    [sym_this] = ACTIONS(5924),
    [sym_abstract] = ACTIONS(5924),
    [sym_alias] = ACTIONS(5924),
    [sym_align] = ACTIONS(5924),
    [sym_auto] = ACTIONS(5924),
    [sym_class] = ACTIONS(5924),
    [sym_const] = ACTIONS(5924),
    [sym_debug] = ACTIONS(5924),
    [sym_delegate] = ACTIONS(5924),
    [sym_deprecated] = ACTIONS(5924),
    [sym_enum] = ACTIONS(5924),
    [sym_export] = ACTIONS(5924),
    [sym_extern] = ACTIONS(5924),
    [sym_final] = ACTIONS(5924),
    [sym_function] = ACTIONS(5924),
    [sym_immutable] = ACTIONS(5924),
    [sym_import] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5924),
    [sym_interface] = ACTIONS(5924),
    [sym_invariant] = ACTIONS(5924),
    [sym_mixin] = ACTIONS(5924),
    [sym_module] = ACTIONS(5924),
    [sym_nothrow] = ACTIONS(5924),
    [sym_override] = ACTIONS(5924),
    [sym_package] = ACTIONS(5924),
    [sym_pragma] = ACTIONS(5924),
    [sym_private] = ACTIONS(5924),
    [sym_protected] = ACTIONS(5924),
    [sym_public] = ACTIONS(5924),
    [sym_pure] = ACTIONS(5924),
    [sym_ref] = ACTIONS(5924),
    [sym_return] = ACTIONS(5924),
    [sym_scope] = ACTIONS(5924),
    [sym_shared] = ACTIONS(5924),
    [sym_static] = ACTIONS(5924),
    [sym_struct] = ACTIONS(5924),
    [sym_synchronized] = ACTIONS(5924),
    [sym_template] = ACTIONS(5924),
    [sym_typeof] = ACTIONS(5924),
    [sym_union] = ACTIONS(5924),
    [sym_unittest] = ACTIONS(5924),
    [sym_version] = ACTIONS(5924),
    [sym_gshared] = ACTIONS(5924),
    [sym_traits] = ACTIONS(5924),
    [sym_vector] = ACTIONS(5924),
    [sym_void] = ACTIONS(5924),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2148] = {
    [sym_arguments] = STATE(2167),
    [sym_identifier] = ACTIONS(5924),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(5930),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_bool] = ACTIONS(5924),
    [sym_byte] = ACTIONS(5924),
    [sym_ubyte] = ACTIONS(5924),
    [sym_char] = ACTIONS(5924),
    [sym_short] = ACTIONS(5924),
    [sym_ushort] = ACTIONS(5924),
    [sym_int] = ACTIONS(5924),
    [sym_uint] = ACTIONS(5924),
    [sym_long] = ACTIONS(5924),
    [sym_ulong] = ACTIONS(5924),
    [sym_cent] = ACTIONS(5924),
    [sym_ucent] = ACTIONS(5924),
    [sym_wchar] = ACTIONS(5924),
    [sym_dchar] = ACTIONS(5924),
    [sym_float] = ACTIONS(5924),
    [sym_double] = ACTIONS(5924),
    [sym_real] = ACTIONS(5924),
    [sym_ifloat] = ACTIONS(5924),
    [sym_idouble] = ACTIONS(5924),
    [sym_ireal] = ACTIONS(5924),
    [sym_cfloat] = ACTIONS(5924),
    [sym_cdouble] = ACTIONS(5924),
    [sym_creal] = ACTIONS(5924),
    [sym_size_t] = ACTIONS(5924),
    [sym_ptrdiff_t] = ACTIONS(5924),
    [sym_string] = ACTIONS(5924),
    [sym_cstring] = ACTIONS(5924),
    [sym_dstring] = ACTIONS(5924),
    [sym_wstring] = ACTIONS(5924),
    [sym_noreturn] = ACTIONS(5924),
    [sym_this] = ACTIONS(5924),
    [sym_abstract] = ACTIONS(5924),
    [sym_alias] = ACTIONS(5924),
    [sym_align] = ACTIONS(5924),
    [sym_auto] = ACTIONS(5924),
    [sym_class] = ACTIONS(5924),
    [sym_const] = ACTIONS(5924),
    [sym_debug] = ACTIONS(5924),
    [sym_delegate] = ACTIONS(5924),
    [sym_deprecated] = ACTIONS(5924),
    [sym_enum] = ACTIONS(5924),
    [sym_export] = ACTIONS(5924),
    [sym_extern] = ACTIONS(5924),
    [sym_final] = ACTIONS(5924),
    [sym_function] = ACTIONS(5924),
    [sym_immutable] = ACTIONS(5924),
    [sym_import] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5924),
    [sym_interface] = ACTIONS(5924),
    [sym_invariant] = ACTIONS(5924),
    [sym_mixin] = ACTIONS(5924),
    [sym_module] = ACTIONS(5924),
    [sym_nothrow] = ACTIONS(5924),
    [sym_override] = ACTIONS(5924),
    [sym_package] = ACTIONS(5924),
    [sym_pragma] = ACTIONS(5924),
    [sym_private] = ACTIONS(5924),
    [sym_protected] = ACTIONS(5924),
    [sym_public] = ACTIONS(5924),
    [sym_pure] = ACTIONS(5924),
    [sym_ref] = ACTIONS(5924),
    [sym_return] = ACTIONS(5924),
    [sym_scope] = ACTIONS(5924),
    [sym_shared] = ACTIONS(5924),
    [sym_static] = ACTIONS(5924),
    [sym_struct] = ACTIONS(5924),
    [sym_synchronized] = ACTIONS(5924),
    [sym_template] = ACTIONS(5924),
    [sym_typeof] = ACTIONS(5924),
    [sym_union] = ACTIONS(5924),
    [sym_unittest] = ACTIONS(5924),
    [sym_version] = ACTIONS(5924),
    [sym_gshared] = ACTIONS(5924),
    [sym_traits] = ACTIONS(5924),
    [sym_vector] = ACTIONS(5924),
    [sym_void] = ACTIONS(5924),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2149] = {
    [sym_identifier] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_BANG] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_RBRACK] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_EQ_EQ] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(3111),
    [sym_bool] = ACTIONS(3109),
    [sym_byte] = ACTIONS(3109),
    [sym_ubyte] = ACTIONS(3109),
    [sym_char] = ACTIONS(3109),
    [sym_short] = ACTIONS(3109),
    [sym_ushort] = ACTIONS(3109),
    [sym_int] = ACTIONS(3109),
    [sym_uint] = ACTIONS(3109),
    [sym_long] = ACTIONS(3109),
    [sym_ulong] = ACTIONS(3109),
    [sym_cent] = ACTIONS(3109),
    [sym_ucent] = ACTIONS(3109),
    [sym_wchar] = ACTIONS(3109),
    [sym_dchar] = ACTIONS(3109),
    [sym_float] = ACTIONS(3109),
    [sym_double] = ACTIONS(3109),
    [sym_real] = ACTIONS(3109),
    [sym_ifloat] = ACTIONS(3109),
    [sym_idouble] = ACTIONS(3109),
    [sym_ireal] = ACTIONS(3109),
    [sym_cfloat] = ACTIONS(3109),
    [sym_cdouble] = ACTIONS(3109),
    [sym_creal] = ACTIONS(3109),
    [sym_size_t] = ACTIONS(3109),
    [sym_ptrdiff_t] = ACTIONS(3109),
    [sym_string] = ACTIONS(3109),
    [sym_cstring] = ACTIONS(3109),
    [sym_dstring] = ACTIONS(3109),
    [sym_wstring] = ACTIONS(3109),
    [sym_noreturn] = ACTIONS(3109),
    [sym_this] = ACTIONS(3109),
    [sym_abstract] = ACTIONS(3109),
    [sym_alias] = ACTIONS(3109),
    [sym_align] = ACTIONS(3109),
    [sym_auto] = ACTIONS(3109),
    [sym_class] = ACTIONS(3109),
    [sym_const] = ACTIONS(3109),
    [sym_debug] = ACTIONS(3109),
    [sym_delegate] = ACTIONS(3109),
    [sym_deprecated] = ACTIONS(3109),
    [sym_enum] = ACTIONS(3109),
    [sym_export] = ACTIONS(3109),
    [sym_extern] = ACTIONS(3109),
    [sym_final] = ACTIONS(3109),
    [sym_function] = ACTIONS(3109),
    [sym_immutable] = ACTIONS(3109),
    [sym_import] = ACTIONS(3109),
    [sym_inout] = ACTIONS(3109),
    [sym_interface] = ACTIONS(3109),
    [sym_invariant] = ACTIONS(3109),
    [sym_mixin] = ACTIONS(3109),
    [sym_module] = ACTIONS(3109),
    [sym_nothrow] = ACTIONS(3109),
    [sym_override] = ACTIONS(3109),
    [sym_package] = ACTIONS(3109),
    [sym_pragma] = ACTIONS(3109),
    [sym_private] = ACTIONS(3109),
    [sym_protected] = ACTIONS(3109),
    [sym_public] = ACTIONS(3109),
    [sym_pure] = ACTIONS(3109),
    [sym_ref] = ACTIONS(3109),
    [sym_return] = ACTIONS(3109),
    [sym_scope] = ACTIONS(3109),
    [sym_shared] = ACTIONS(3109),
    [sym_static] = ACTIONS(3109),
    [sym_struct] = ACTIONS(3109),
    [sym_synchronized] = ACTIONS(3109),
    [sym_template] = ACTIONS(3109),
    [sym_typeof] = ACTIONS(3109),
    [sym_union] = ACTIONS(3109),
    [sym_unittest] = ACTIONS(3109),
    [sym_version] = ACTIONS(3109),
    [sym_gshared] = ACTIONS(3109),
    [sym_traits] = ACTIONS(3109),
    [sym_vector] = ACTIONS(3109),
    [sym_void] = ACTIONS(3109),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2150] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_BANG] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3043),
    [anon_sym_AT] = ACTIONS(3043),
    [sym_bool] = ACTIONS(3041),
    [sym_byte] = ACTIONS(3041),
    [sym_ubyte] = ACTIONS(3041),
    [sym_char] = ACTIONS(3041),
    [sym_short] = ACTIONS(3041),
    [sym_ushort] = ACTIONS(3041),
    [sym_int] = ACTIONS(3041),
    [sym_uint] = ACTIONS(3041),
    [sym_long] = ACTIONS(3041),
    [sym_ulong] = ACTIONS(3041),
    [sym_cent] = ACTIONS(3041),
    [sym_ucent] = ACTIONS(3041),
    [sym_wchar] = ACTIONS(3041),
    [sym_dchar] = ACTIONS(3041),
    [sym_float] = ACTIONS(3041),
    [sym_double] = ACTIONS(3041),
    [sym_real] = ACTIONS(3041),
    [sym_ifloat] = ACTIONS(3041),
    [sym_idouble] = ACTIONS(3041),
    [sym_ireal] = ACTIONS(3041),
    [sym_cfloat] = ACTIONS(3041),
    [sym_cdouble] = ACTIONS(3041),
    [sym_creal] = ACTIONS(3041),
    [sym_size_t] = ACTIONS(3041),
    [sym_ptrdiff_t] = ACTIONS(3041),
    [sym_string] = ACTIONS(3041),
    [sym_cstring] = ACTIONS(3041),
    [sym_dstring] = ACTIONS(3041),
    [sym_wstring] = ACTIONS(3041),
    [sym_noreturn] = ACTIONS(3041),
    [sym_this] = ACTIONS(3041),
    [sym_abstract] = ACTIONS(3041),
    [sym_alias] = ACTIONS(3041),
    [sym_align] = ACTIONS(3041),
    [sym_auto] = ACTIONS(3041),
    [sym_class] = ACTIONS(3041),
    [sym_const] = ACTIONS(3041),
    [sym_debug] = ACTIONS(3041),
    [sym_delegate] = ACTIONS(3041),
    [sym_deprecated] = ACTIONS(3041),
    [sym_enum] = ACTIONS(3041),
    [sym_export] = ACTIONS(3041),
    [sym_extern] = ACTIONS(3041),
    [sym_final] = ACTIONS(3041),
    [sym_function] = ACTIONS(3041),
    [sym_immutable] = ACTIONS(3041),
    [sym_import] = ACTIONS(3041),
    [sym_inout] = ACTIONS(3041),
    [sym_interface] = ACTIONS(3041),
    [sym_invariant] = ACTIONS(3041),
    [sym_mixin] = ACTIONS(3041),
    [sym_module] = ACTIONS(3041),
    [sym_nothrow] = ACTIONS(3041),
    [sym_override] = ACTIONS(3041),
    [sym_package] = ACTIONS(3041),
    [sym_pragma] = ACTIONS(3041),
    [sym_private] = ACTIONS(3041),
    [sym_protected] = ACTIONS(3041),
    [sym_public] = ACTIONS(3041),
    [sym_pure] = ACTIONS(3041),
    [sym_ref] = ACTIONS(3041),
    [sym_return] = ACTIONS(3041),
    [sym_scope] = ACTIONS(3041),
    [sym_shared] = ACTIONS(3041),
    [sym_static] = ACTIONS(3041),
    [sym_struct] = ACTIONS(3041),
    [sym_synchronized] = ACTIONS(3041),
    [sym_template] = ACTIONS(3041),
    [sym_typeof] = ACTIONS(3041),
    [sym_union] = ACTIONS(3041),
    [sym_unittest] = ACTIONS(3041),
    [sym_version] = ACTIONS(3041),
    [sym_gshared] = ACTIONS(3041),
    [sym_traits] = ACTIONS(3041),
    [sym_vector] = ACTIONS(3041),
    [sym_void] = ACTIONS(3041),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2151] = {
    [sym_identifier] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5934),
    [anon_sym_BANG] = ACTIONS(5934),
    [anon_sym_LPAREN] = ACTIONS(5934),
    [anon_sym_RPAREN] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5934),
    [anon_sym_RBRACK] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_SEMI] = ACTIONS(5934),
    [anon_sym_COLON] = ACTIONS(5934),
    [anon_sym_EQ_EQ] = ACTIONS(5934),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5934),
    [anon_sym_AT] = ACTIONS(5934),
    [sym_bool] = ACTIONS(5932),
    [sym_byte] = ACTIONS(5932),
    [sym_ubyte] = ACTIONS(5932),
    [sym_char] = ACTIONS(5932),
    [sym_short] = ACTIONS(5932),
    [sym_ushort] = ACTIONS(5932),
    [sym_int] = ACTIONS(5932),
    [sym_uint] = ACTIONS(5932),
    [sym_long] = ACTIONS(5932),
    [sym_ulong] = ACTIONS(5932),
    [sym_cent] = ACTIONS(5932),
    [sym_ucent] = ACTIONS(5932),
    [sym_wchar] = ACTIONS(5932),
    [sym_dchar] = ACTIONS(5932),
    [sym_float] = ACTIONS(5932),
    [sym_double] = ACTIONS(5932),
    [sym_real] = ACTIONS(5932),
    [sym_ifloat] = ACTIONS(5932),
    [sym_idouble] = ACTIONS(5932),
    [sym_ireal] = ACTIONS(5932),
    [sym_cfloat] = ACTIONS(5932),
    [sym_cdouble] = ACTIONS(5932),
    [sym_creal] = ACTIONS(5932),
    [sym_size_t] = ACTIONS(5932),
    [sym_ptrdiff_t] = ACTIONS(5932),
    [sym_string] = ACTIONS(5932),
    [sym_cstring] = ACTIONS(5932),
    [sym_dstring] = ACTIONS(5932),
    [sym_wstring] = ACTIONS(5932),
    [sym_noreturn] = ACTIONS(5932),
    [sym_this] = ACTIONS(5932),
    [sym_abstract] = ACTIONS(5932),
    [sym_alias] = ACTIONS(5932),
    [sym_align] = ACTIONS(5932),
    [sym_auto] = ACTIONS(5932),
    [sym_class] = ACTIONS(5932),
    [sym_const] = ACTIONS(5932),
    [sym_debug] = ACTIONS(5932),
    [sym_delegate] = ACTIONS(5932),
    [sym_deprecated] = ACTIONS(5932),
    [sym_enum] = ACTIONS(5932),
    [sym_export] = ACTIONS(5932),
    [sym_extern] = ACTIONS(5932),
    [sym_final] = ACTIONS(5932),
    [sym_function] = ACTIONS(5932),
    [sym_immutable] = ACTIONS(5932),
    [sym_import] = ACTIONS(5932),
    [sym_inout] = ACTIONS(5932),
    [sym_interface] = ACTIONS(5932),
    [sym_invariant] = ACTIONS(5932),
    [sym_mixin] = ACTIONS(5932),
    [sym_module] = ACTIONS(5932),
    [sym_nothrow] = ACTIONS(5932),
    [sym_override] = ACTIONS(5932),
    [sym_package] = ACTIONS(5932),
    [sym_pragma] = ACTIONS(5932),
    [sym_private] = ACTIONS(5932),
    [sym_protected] = ACTIONS(5932),
    [sym_public] = ACTIONS(5932),
    [sym_pure] = ACTIONS(5932),
    [sym_ref] = ACTIONS(5932),
    [sym_return] = ACTIONS(5932),
    [sym_scope] = ACTIONS(5932),
    [sym_shared] = ACTIONS(5932),
    [sym_static] = ACTIONS(5932),
    [sym_struct] = ACTIONS(5932),
    [sym_synchronized] = ACTIONS(5932),
    [sym_template] = ACTIONS(5932),
    [sym_typeof] = ACTIONS(5932),
    [sym_union] = ACTIONS(5932),
    [sym_unittest] = ACTIONS(5932),
    [sym_version] = ACTIONS(5932),
    [sym_gshared] = ACTIONS(5932),
    [sym_traits] = ACTIONS(5932),
    [sym_vector] = ACTIONS(5932),
    [sym_void] = ACTIONS(5932),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2152] = {
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_BANG] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_RBRACK] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_EQ_EQ] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [sym_bool] = ACTIONS(3105),
    [sym_byte] = ACTIONS(3105),
    [sym_ubyte] = ACTIONS(3105),
    [sym_char] = ACTIONS(3105),
    [sym_short] = ACTIONS(3105),
    [sym_ushort] = ACTIONS(3105),
    [sym_int] = ACTIONS(3105),
    [sym_uint] = ACTIONS(3105),
    [sym_long] = ACTIONS(3105),
    [sym_ulong] = ACTIONS(3105),
    [sym_cent] = ACTIONS(3105),
    [sym_ucent] = ACTIONS(3105),
    [sym_wchar] = ACTIONS(3105),
    [sym_dchar] = ACTIONS(3105),
    [sym_float] = ACTIONS(3105),
    [sym_double] = ACTIONS(3105),
    [sym_real] = ACTIONS(3105),
    [sym_ifloat] = ACTIONS(3105),
    [sym_idouble] = ACTIONS(3105),
    [sym_ireal] = ACTIONS(3105),
    [sym_cfloat] = ACTIONS(3105),
    [sym_cdouble] = ACTIONS(3105),
    [sym_creal] = ACTIONS(3105),
    [sym_size_t] = ACTIONS(3105),
    [sym_ptrdiff_t] = ACTIONS(3105),
    [sym_string] = ACTIONS(3105),
    [sym_cstring] = ACTIONS(3105),
    [sym_dstring] = ACTIONS(3105),
    [sym_wstring] = ACTIONS(3105),
    [sym_noreturn] = ACTIONS(3105),
    [sym_this] = ACTIONS(3105),
    [sym_abstract] = ACTIONS(3105),
    [sym_alias] = ACTIONS(3105),
    [sym_align] = ACTIONS(3105),
    [sym_auto] = ACTIONS(3105),
    [sym_class] = ACTIONS(3105),
    [sym_const] = ACTIONS(3105),
    [sym_debug] = ACTIONS(3105),
    [sym_delegate] = ACTIONS(3105),
    [sym_deprecated] = ACTIONS(3105),
    [sym_enum] = ACTIONS(3105),
    [sym_export] = ACTIONS(3105),
    [sym_extern] = ACTIONS(3105),
    [sym_final] = ACTIONS(3105),
    [sym_function] = ACTIONS(3105),
    [sym_immutable] = ACTIONS(3105),
    [sym_import] = ACTIONS(3105),
    [sym_inout] = ACTIONS(3105),
    [sym_interface] = ACTIONS(3105),
    [sym_invariant] = ACTIONS(3105),
    [sym_mixin] = ACTIONS(3105),
    [sym_module] = ACTIONS(3105),
    [sym_nothrow] = ACTIONS(3105),
    [sym_override] = ACTIONS(3105),
    [sym_package] = ACTIONS(3105),
    [sym_pragma] = ACTIONS(3105),
    [sym_private] = ACTIONS(3105),
    [sym_protected] = ACTIONS(3105),
    [sym_public] = ACTIONS(3105),
    [sym_pure] = ACTIONS(3105),
    [sym_ref] = ACTIONS(3105),
    [sym_return] = ACTIONS(3105),
    [sym_scope] = ACTIONS(3105),
    [sym_shared] = ACTIONS(3105),
    [sym_static] = ACTIONS(3105),
    [sym_struct] = ACTIONS(3105),
    [sym_synchronized] = ACTIONS(3105),
    [sym_template] = ACTIONS(3105),
    [sym_typeof] = ACTIONS(3105),
    [sym_union] = ACTIONS(3105),
    [sym_unittest] = ACTIONS(3105),
    [sym_version] = ACTIONS(3105),
    [sym_gshared] = ACTIONS(3105),
    [sym_traits] = ACTIONS(3105),
    [sym_vector] = ACTIONS(3105),
    [sym_void] = ACTIONS(3105),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2153] = {
    [sym_identifier] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_BANG] = ACTIONS(5938),
    [anon_sym_LPAREN] = ACTIONS(5938),
    [anon_sym_RPAREN] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5938),
    [anon_sym_RBRACK] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_SEMI] = ACTIONS(5938),
    [anon_sym_COLON] = ACTIONS(5938),
    [anon_sym_EQ_EQ] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5938),
    [anon_sym_AT] = ACTIONS(5938),
    [sym_bool] = ACTIONS(5936),
    [sym_byte] = ACTIONS(5936),
    [sym_ubyte] = ACTIONS(5936),
    [sym_char] = ACTIONS(5936),
    [sym_short] = ACTIONS(5936),
    [sym_ushort] = ACTIONS(5936),
    [sym_int] = ACTIONS(5936),
    [sym_uint] = ACTIONS(5936),
    [sym_long] = ACTIONS(5936),
    [sym_ulong] = ACTIONS(5936),
    [sym_cent] = ACTIONS(5936),
    [sym_ucent] = ACTIONS(5936),
    [sym_wchar] = ACTIONS(5936),
    [sym_dchar] = ACTIONS(5936),
    [sym_float] = ACTIONS(5936),
    [sym_double] = ACTIONS(5936),
    [sym_real] = ACTIONS(5936),
    [sym_ifloat] = ACTIONS(5936),
    [sym_idouble] = ACTIONS(5936),
    [sym_ireal] = ACTIONS(5936),
    [sym_cfloat] = ACTIONS(5936),
    [sym_cdouble] = ACTIONS(5936),
    [sym_creal] = ACTIONS(5936),
    [sym_size_t] = ACTIONS(5936),
    [sym_ptrdiff_t] = ACTIONS(5936),
    [sym_string] = ACTIONS(5936),
    [sym_cstring] = ACTIONS(5936),
    [sym_dstring] = ACTIONS(5936),
    [sym_wstring] = ACTIONS(5936),
    [sym_noreturn] = ACTIONS(5936),
    [sym_this] = ACTIONS(5936),
    [sym_abstract] = ACTIONS(5936),
    [sym_alias] = ACTIONS(5936),
    [sym_align] = ACTIONS(5936),
    [sym_auto] = ACTIONS(5936),
    [sym_class] = ACTIONS(5936),
    [sym_const] = ACTIONS(5936),
    [sym_debug] = ACTIONS(5936),
    [sym_delegate] = ACTIONS(5936),
    [sym_deprecated] = ACTIONS(5936),
    [sym_enum] = ACTIONS(5936),
    [sym_export] = ACTIONS(5936),
    [sym_extern] = ACTIONS(5936),
    [sym_final] = ACTIONS(5936),
    [sym_function] = ACTIONS(5936),
    [sym_immutable] = ACTIONS(5936),
    [sym_import] = ACTIONS(5936),
    [sym_inout] = ACTIONS(5936),
    [sym_interface] = ACTIONS(5936),
    [sym_invariant] = ACTIONS(5936),
    [sym_mixin] = ACTIONS(5936),
    [sym_module] = ACTIONS(5936),
    [sym_nothrow] = ACTIONS(5936),
    [sym_override] = ACTIONS(5936),
    [sym_package] = ACTIONS(5936),
    [sym_pragma] = ACTIONS(5936),
    [sym_private] = ACTIONS(5936),
    [sym_protected] = ACTIONS(5936),
    [sym_public] = ACTIONS(5936),
    [sym_pure] = ACTIONS(5936),
    [sym_ref] = ACTIONS(5936),
    [sym_return] = ACTIONS(5936),
    [sym_scope] = ACTIONS(5936),
    [sym_shared] = ACTIONS(5936),
    [sym_static] = ACTIONS(5936),
    [sym_struct] = ACTIONS(5936),
    [sym_synchronized] = ACTIONS(5936),
    [sym_template] = ACTIONS(5936),
    [sym_typeof] = ACTIONS(5936),
    [sym_union] = ACTIONS(5936),
    [sym_unittest] = ACTIONS(5936),
    [sym_version] = ACTIONS(5936),
    [sym_gshared] = ACTIONS(5936),
    [sym_traits] = ACTIONS(5936),
    [sym_vector] = ACTIONS(5936),
    [sym_void] = ACTIONS(5936),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2154] = {
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_BANG] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3087),
    [sym_bool] = ACTIONS(3085),
    [sym_byte] = ACTIONS(3085),
    [sym_ubyte] = ACTIONS(3085),
    [sym_char] = ACTIONS(3085),
    [sym_short] = ACTIONS(3085),
    [sym_ushort] = ACTIONS(3085),
    [sym_int] = ACTIONS(3085),
    [sym_uint] = ACTIONS(3085),
    [sym_long] = ACTIONS(3085),
    [sym_ulong] = ACTIONS(3085),
    [sym_cent] = ACTIONS(3085),
    [sym_ucent] = ACTIONS(3085),
    [sym_wchar] = ACTIONS(3085),
    [sym_dchar] = ACTIONS(3085),
    [sym_float] = ACTIONS(3085),
    [sym_double] = ACTIONS(3085),
    [sym_real] = ACTIONS(3085),
    [sym_ifloat] = ACTIONS(3085),
    [sym_idouble] = ACTIONS(3085),
    [sym_ireal] = ACTIONS(3085),
    [sym_cfloat] = ACTIONS(3085),
    [sym_cdouble] = ACTIONS(3085),
    [sym_creal] = ACTIONS(3085),
    [sym_size_t] = ACTIONS(3085),
    [sym_ptrdiff_t] = ACTIONS(3085),
    [sym_string] = ACTIONS(3085),
    [sym_cstring] = ACTIONS(3085),
    [sym_dstring] = ACTIONS(3085),
    [sym_wstring] = ACTIONS(3085),
    [sym_noreturn] = ACTIONS(3085),
    [sym_this] = ACTIONS(3085),
    [sym_abstract] = ACTIONS(3085),
    [sym_alias] = ACTIONS(3085),
    [sym_align] = ACTIONS(3085),
    [sym_auto] = ACTIONS(3085),
    [sym_class] = ACTIONS(3085),
    [sym_const] = ACTIONS(3085),
    [sym_debug] = ACTIONS(3085),
    [sym_delegate] = ACTIONS(3085),
    [sym_deprecated] = ACTIONS(3085),
    [sym_enum] = ACTIONS(3085),
    [sym_export] = ACTIONS(3085),
    [sym_extern] = ACTIONS(3085),
    [sym_final] = ACTIONS(3085),
    [sym_function] = ACTIONS(3085),
    [sym_immutable] = ACTIONS(3085),
    [sym_import] = ACTIONS(3085),
    [sym_inout] = ACTIONS(3085),
    [sym_interface] = ACTIONS(3085),
    [sym_invariant] = ACTIONS(3085),
    [sym_mixin] = ACTIONS(3085),
    [sym_module] = ACTIONS(3085),
    [sym_nothrow] = ACTIONS(3085),
    [sym_override] = ACTIONS(3085),
    [sym_package] = ACTIONS(3085),
    [sym_pragma] = ACTIONS(3085),
    [sym_private] = ACTIONS(3085),
    [sym_protected] = ACTIONS(3085),
    [sym_public] = ACTIONS(3085),
    [sym_pure] = ACTIONS(3085),
    [sym_ref] = ACTIONS(3085),
    [sym_return] = ACTIONS(3085),
    [sym_scope] = ACTIONS(3085),
    [sym_shared] = ACTIONS(3085),
    [sym_static] = ACTIONS(3085),
    [sym_struct] = ACTIONS(3085),
    [sym_synchronized] = ACTIONS(3085),
    [sym_template] = ACTIONS(3085),
    [sym_typeof] = ACTIONS(3085),
    [sym_union] = ACTIONS(3085),
    [sym_unittest] = ACTIONS(3085),
    [sym_version] = ACTIONS(3085),
    [sym_gshared] = ACTIONS(3085),
    [sym_traits] = ACTIONS(3085),
    [sym_vector] = ACTIONS(3085),
    [sym_void] = ACTIONS(3085),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2155] = {
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_BANG] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_EQ_EQ] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3095),
    [sym_bool] = ACTIONS(3093),
    [sym_byte] = ACTIONS(3093),
    [sym_ubyte] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_short] = ACTIONS(3093),
    [sym_ushort] = ACTIONS(3093),
    [sym_int] = ACTIONS(3093),
    [sym_uint] = ACTIONS(3093),
    [sym_long] = ACTIONS(3093),
    [sym_ulong] = ACTIONS(3093),
    [sym_cent] = ACTIONS(3093),
    [sym_ucent] = ACTIONS(3093),
    [sym_wchar] = ACTIONS(3093),
    [sym_dchar] = ACTIONS(3093),
    [sym_float] = ACTIONS(3093),
    [sym_double] = ACTIONS(3093),
    [sym_real] = ACTIONS(3093),
    [sym_ifloat] = ACTIONS(3093),
    [sym_idouble] = ACTIONS(3093),
    [sym_ireal] = ACTIONS(3093),
    [sym_cfloat] = ACTIONS(3093),
    [sym_cdouble] = ACTIONS(3093),
    [sym_creal] = ACTIONS(3093),
    [sym_size_t] = ACTIONS(3093),
    [sym_ptrdiff_t] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym_cstring] = ACTIONS(3093),
    [sym_dstring] = ACTIONS(3093),
    [sym_wstring] = ACTIONS(3093),
    [sym_noreturn] = ACTIONS(3093),
    [sym_this] = ACTIONS(3093),
    [sym_abstract] = ACTIONS(3093),
    [sym_alias] = ACTIONS(3093),
    [sym_align] = ACTIONS(3093),
    [sym_auto] = ACTIONS(3093),
    [sym_class] = ACTIONS(3093),
    [sym_const] = ACTIONS(3093),
    [sym_debug] = ACTIONS(3093),
    [sym_delegate] = ACTIONS(3093),
    [sym_deprecated] = ACTIONS(3093),
    [sym_enum] = ACTIONS(3093),
    [sym_export] = ACTIONS(3093),
    [sym_extern] = ACTIONS(3093),
    [sym_final] = ACTIONS(3093),
    [sym_function] = ACTIONS(3093),
    [sym_immutable] = ACTIONS(3093),
    [sym_import] = ACTIONS(3093),
    [sym_inout] = ACTIONS(3093),
    [sym_interface] = ACTIONS(3093),
    [sym_invariant] = ACTIONS(3093),
    [sym_mixin] = ACTIONS(3093),
    [sym_module] = ACTIONS(3093),
    [sym_nothrow] = ACTIONS(3093),
    [sym_override] = ACTIONS(3093),
    [sym_package] = ACTIONS(3093),
    [sym_pragma] = ACTIONS(3093),
    [sym_private] = ACTIONS(3093),
    [sym_protected] = ACTIONS(3093),
    [sym_public] = ACTIONS(3093),
    [sym_pure] = ACTIONS(3093),
    [sym_ref] = ACTIONS(3093),
    [sym_return] = ACTIONS(3093),
    [sym_scope] = ACTIONS(3093),
    [sym_shared] = ACTIONS(3093),
    [sym_static] = ACTIONS(3093),
    [sym_struct] = ACTIONS(3093),
    [sym_synchronized] = ACTIONS(3093),
    [sym_template] = ACTIONS(3093),
    [sym_typeof] = ACTIONS(3093),
    [sym_union] = ACTIONS(3093),
    [sym_unittest] = ACTIONS(3093),
    [sym_version] = ACTIONS(3093),
    [sym_gshared] = ACTIONS(3093),
    [sym_traits] = ACTIONS(3093),
    [sym_vector] = ACTIONS(3093),
    [sym_void] = ACTIONS(3093),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2156] = {
    [sym_identifier] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_BANG] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_RBRACK] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_EQ_EQ] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3079),
    [sym_bool] = ACTIONS(3077),
    [sym_byte] = ACTIONS(3077),
    [sym_ubyte] = ACTIONS(3077),
    [sym_char] = ACTIONS(3077),
    [sym_short] = ACTIONS(3077),
    [sym_ushort] = ACTIONS(3077),
    [sym_int] = ACTIONS(3077),
    [sym_uint] = ACTIONS(3077),
    [sym_long] = ACTIONS(3077),
    [sym_ulong] = ACTIONS(3077),
    [sym_cent] = ACTIONS(3077),
    [sym_ucent] = ACTIONS(3077),
    [sym_wchar] = ACTIONS(3077),
    [sym_dchar] = ACTIONS(3077),
    [sym_float] = ACTIONS(3077),
    [sym_double] = ACTIONS(3077),
    [sym_real] = ACTIONS(3077),
    [sym_ifloat] = ACTIONS(3077),
    [sym_idouble] = ACTIONS(3077),
    [sym_ireal] = ACTIONS(3077),
    [sym_cfloat] = ACTIONS(3077),
    [sym_cdouble] = ACTIONS(3077),
    [sym_creal] = ACTIONS(3077),
    [sym_size_t] = ACTIONS(3077),
    [sym_ptrdiff_t] = ACTIONS(3077),
    [sym_string] = ACTIONS(3077),
    [sym_cstring] = ACTIONS(3077),
    [sym_dstring] = ACTIONS(3077),
    [sym_wstring] = ACTIONS(3077),
    [sym_noreturn] = ACTIONS(3077),
    [sym_this] = ACTIONS(3077),
    [sym_abstract] = ACTIONS(3077),
    [sym_alias] = ACTIONS(3077),
    [sym_align] = ACTIONS(3077),
    [sym_auto] = ACTIONS(3077),
    [sym_class] = ACTIONS(3077),
    [sym_const] = ACTIONS(3077),
    [sym_debug] = ACTIONS(3077),
    [sym_delegate] = ACTIONS(3077),
    [sym_deprecated] = ACTIONS(3077),
    [sym_enum] = ACTIONS(3077),
    [sym_export] = ACTIONS(3077),
    [sym_extern] = ACTIONS(3077),
    [sym_final] = ACTIONS(3077),
    [sym_function] = ACTIONS(3077),
    [sym_immutable] = ACTIONS(3077),
    [sym_import] = ACTIONS(3077),
    [sym_inout] = ACTIONS(3077),
    [sym_interface] = ACTIONS(3077),
    [sym_invariant] = ACTIONS(3077),
    [sym_mixin] = ACTIONS(3077),
    [sym_module] = ACTIONS(3077),
    [sym_nothrow] = ACTIONS(3077),
    [sym_override] = ACTIONS(3077),
    [sym_package] = ACTIONS(3077),
    [sym_pragma] = ACTIONS(3077),
    [sym_private] = ACTIONS(3077),
    [sym_protected] = ACTIONS(3077),
    [sym_public] = ACTIONS(3077),
    [sym_pure] = ACTIONS(3077),
    [sym_ref] = ACTIONS(3077),
    [sym_return] = ACTIONS(3077),
    [sym_scope] = ACTIONS(3077),
    [sym_shared] = ACTIONS(3077),
    [sym_static] = ACTIONS(3077),
    [sym_struct] = ACTIONS(3077),
    [sym_synchronized] = ACTIONS(3077),
    [sym_template] = ACTIONS(3077),
    [sym_typeof] = ACTIONS(3077),
    [sym_union] = ACTIONS(3077),
    [sym_unittest] = ACTIONS(3077),
    [sym_version] = ACTIONS(3077),
    [sym_gshared] = ACTIONS(3077),
    [sym_traits] = ACTIONS(3077),
    [sym_vector] = ACTIONS(3077),
    [sym_void] = ACTIONS(3077),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2157] = {
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3067),
    [sym_bool] = ACTIONS(3065),
    [sym_byte] = ACTIONS(3065),
    [sym_ubyte] = ACTIONS(3065),
    [sym_char] = ACTIONS(3065),
    [sym_short] = ACTIONS(3065),
    [sym_ushort] = ACTIONS(3065),
    [sym_int] = ACTIONS(3065),
    [sym_uint] = ACTIONS(3065),
    [sym_long] = ACTIONS(3065),
    [sym_ulong] = ACTIONS(3065),
    [sym_cent] = ACTIONS(3065),
    [sym_ucent] = ACTIONS(3065),
    [sym_wchar] = ACTIONS(3065),
    [sym_dchar] = ACTIONS(3065),
    [sym_float] = ACTIONS(3065),
    [sym_double] = ACTIONS(3065),
    [sym_real] = ACTIONS(3065),
    [sym_ifloat] = ACTIONS(3065),
    [sym_idouble] = ACTIONS(3065),
    [sym_ireal] = ACTIONS(3065),
    [sym_cfloat] = ACTIONS(3065),
    [sym_cdouble] = ACTIONS(3065),
    [sym_creal] = ACTIONS(3065),
    [sym_size_t] = ACTIONS(3065),
    [sym_ptrdiff_t] = ACTIONS(3065),
    [sym_string] = ACTIONS(3065),
    [sym_cstring] = ACTIONS(3065),
    [sym_dstring] = ACTIONS(3065),
    [sym_wstring] = ACTIONS(3065),
    [sym_noreturn] = ACTIONS(3065),
    [sym_this] = ACTIONS(3065),
    [sym_abstract] = ACTIONS(3065),
    [sym_alias] = ACTIONS(3065),
    [sym_align] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [sym_class] = ACTIONS(3065),
    [sym_const] = ACTIONS(3065),
    [sym_debug] = ACTIONS(3065),
    [sym_delegate] = ACTIONS(3065),
    [sym_deprecated] = ACTIONS(3065),
    [sym_enum] = ACTIONS(3065),
    [sym_export] = ACTIONS(3065),
    [sym_extern] = ACTIONS(3065),
    [sym_final] = ACTIONS(3065),
    [sym_function] = ACTIONS(3065),
    [sym_immutable] = ACTIONS(3065),
    [sym_import] = ACTIONS(3065),
    [sym_inout] = ACTIONS(3065),
    [sym_interface] = ACTIONS(3065),
    [sym_invariant] = ACTIONS(3065),
    [sym_mixin] = ACTIONS(3065),
    [sym_module] = ACTIONS(3065),
    [sym_nothrow] = ACTIONS(3065),
    [sym_override] = ACTIONS(3065),
    [sym_package] = ACTIONS(3065),
    [sym_pragma] = ACTIONS(3065),
    [sym_private] = ACTIONS(3065),
    [sym_protected] = ACTIONS(3065),
    [sym_public] = ACTIONS(3065),
    [sym_pure] = ACTIONS(3065),
    [sym_ref] = ACTIONS(3065),
    [sym_return] = ACTIONS(3065),
    [sym_scope] = ACTIONS(3065),
    [sym_shared] = ACTIONS(3065),
    [sym_static] = ACTIONS(3065),
    [sym_struct] = ACTIONS(3065),
    [sym_synchronized] = ACTIONS(3065),
    [sym_template] = ACTIONS(3065),
    [sym_typeof] = ACTIONS(3065),
    [sym_union] = ACTIONS(3065),
    [sym_unittest] = ACTIONS(3065),
    [sym_version] = ACTIONS(3065),
    [sym_gshared] = ACTIONS(3065),
    [sym_traits] = ACTIONS(3065),
    [sym_vector] = ACTIONS(3065),
    [sym_void] = ACTIONS(3065),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2158] = {
    [sym_identifier] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_BANG] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [sym_bool] = ACTIONS(3057),
    [sym_byte] = ACTIONS(3057),
    [sym_ubyte] = ACTIONS(3057),
    [sym_char] = ACTIONS(3057),
    [sym_short] = ACTIONS(3057),
    [sym_ushort] = ACTIONS(3057),
    [sym_int] = ACTIONS(3057),
    [sym_uint] = ACTIONS(3057),
    [sym_long] = ACTIONS(3057),
    [sym_ulong] = ACTIONS(3057),
    [sym_cent] = ACTIONS(3057),
    [sym_ucent] = ACTIONS(3057),
    [sym_wchar] = ACTIONS(3057),
    [sym_dchar] = ACTIONS(3057),
    [sym_float] = ACTIONS(3057),
    [sym_double] = ACTIONS(3057),
    [sym_real] = ACTIONS(3057),
    [sym_ifloat] = ACTIONS(3057),
    [sym_idouble] = ACTIONS(3057),
    [sym_ireal] = ACTIONS(3057),
    [sym_cfloat] = ACTIONS(3057),
    [sym_cdouble] = ACTIONS(3057),
    [sym_creal] = ACTIONS(3057),
    [sym_size_t] = ACTIONS(3057),
    [sym_ptrdiff_t] = ACTIONS(3057),
    [sym_string] = ACTIONS(3057),
    [sym_cstring] = ACTIONS(3057),
    [sym_dstring] = ACTIONS(3057),
    [sym_wstring] = ACTIONS(3057),
    [sym_noreturn] = ACTIONS(3057),
    [sym_this] = ACTIONS(3057),
    [sym_abstract] = ACTIONS(3057),
    [sym_alias] = ACTIONS(3057),
    [sym_align] = ACTIONS(3057),
    [sym_auto] = ACTIONS(3057),
    [sym_class] = ACTIONS(3057),
    [sym_const] = ACTIONS(3057),
    [sym_debug] = ACTIONS(3057),
    [sym_delegate] = ACTIONS(3057),
    [sym_deprecated] = ACTIONS(3057),
    [sym_enum] = ACTIONS(3057),
    [sym_export] = ACTIONS(3057),
    [sym_extern] = ACTIONS(3057),
    [sym_final] = ACTIONS(3057),
    [sym_function] = ACTIONS(3057),
    [sym_immutable] = ACTIONS(3057),
    [sym_import] = ACTIONS(3057),
    [sym_inout] = ACTIONS(3057),
    [sym_interface] = ACTIONS(3057),
    [sym_invariant] = ACTIONS(3057),
    [sym_mixin] = ACTIONS(3057),
    [sym_module] = ACTIONS(3057),
    [sym_nothrow] = ACTIONS(3057),
    [sym_override] = ACTIONS(3057),
    [sym_package] = ACTIONS(3057),
    [sym_pragma] = ACTIONS(3057),
    [sym_private] = ACTIONS(3057),
    [sym_protected] = ACTIONS(3057),
    [sym_public] = ACTIONS(3057),
    [sym_pure] = ACTIONS(3057),
    [sym_ref] = ACTIONS(3057),
    [sym_return] = ACTIONS(3057),
    [sym_scope] = ACTIONS(3057),
    [sym_shared] = ACTIONS(3057),
    [sym_static] = ACTIONS(3057),
    [sym_struct] = ACTIONS(3057),
    [sym_synchronized] = ACTIONS(3057),
    [sym_template] = ACTIONS(3057),
    [sym_typeof] = ACTIONS(3057),
    [sym_union] = ACTIONS(3057),
    [sym_unittest] = ACTIONS(3057),
    [sym_version] = ACTIONS(3057),
    [sym_gshared] = ACTIONS(3057),
    [sym_traits] = ACTIONS(3057),
    [sym_vector] = ACTIONS(3057),
    [sym_void] = ACTIONS(3057),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2159] = {
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_BANG] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [sym_bool] = ACTIONS(3061),
    [sym_byte] = ACTIONS(3061),
    [sym_ubyte] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_short] = ACTIONS(3061),
    [sym_ushort] = ACTIONS(3061),
    [sym_int] = ACTIONS(3061),
    [sym_uint] = ACTIONS(3061),
    [sym_long] = ACTIONS(3061),
    [sym_ulong] = ACTIONS(3061),
    [sym_cent] = ACTIONS(3061),
    [sym_ucent] = ACTIONS(3061),
    [sym_wchar] = ACTIONS(3061),
    [sym_dchar] = ACTIONS(3061),
    [sym_float] = ACTIONS(3061),
    [sym_double] = ACTIONS(3061),
    [sym_real] = ACTIONS(3061),
    [sym_ifloat] = ACTIONS(3061),
    [sym_idouble] = ACTIONS(3061),
    [sym_ireal] = ACTIONS(3061),
    [sym_cfloat] = ACTIONS(3061),
    [sym_cdouble] = ACTIONS(3061),
    [sym_creal] = ACTIONS(3061),
    [sym_size_t] = ACTIONS(3061),
    [sym_ptrdiff_t] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym_cstring] = ACTIONS(3061),
    [sym_dstring] = ACTIONS(3061),
    [sym_wstring] = ACTIONS(3061),
    [sym_noreturn] = ACTIONS(3061),
    [sym_this] = ACTIONS(3061),
    [sym_abstract] = ACTIONS(3061),
    [sym_alias] = ACTIONS(3061),
    [sym_align] = ACTIONS(3061),
    [sym_auto] = ACTIONS(3061),
    [sym_class] = ACTIONS(3061),
    [sym_const] = ACTIONS(3061),
    [sym_debug] = ACTIONS(3061),
    [sym_delegate] = ACTIONS(3061),
    [sym_deprecated] = ACTIONS(3061),
    [sym_enum] = ACTIONS(3061),
    [sym_export] = ACTIONS(3061),
    [sym_extern] = ACTIONS(3061),
    [sym_final] = ACTIONS(3061),
    [sym_function] = ACTIONS(3061),
    [sym_immutable] = ACTIONS(3061),
    [sym_import] = ACTIONS(3061),
    [sym_inout] = ACTIONS(3061),
    [sym_interface] = ACTIONS(3061),
    [sym_invariant] = ACTIONS(3061),
    [sym_mixin] = ACTIONS(3061),
    [sym_module] = ACTIONS(3061),
    [sym_nothrow] = ACTIONS(3061),
    [sym_override] = ACTIONS(3061),
    [sym_package] = ACTIONS(3061),
    [sym_pragma] = ACTIONS(3061),
    [sym_private] = ACTIONS(3061),
    [sym_protected] = ACTIONS(3061),
    [sym_public] = ACTIONS(3061),
    [sym_pure] = ACTIONS(3061),
    [sym_ref] = ACTIONS(3061),
    [sym_return] = ACTIONS(3061),
    [sym_scope] = ACTIONS(3061),
    [sym_shared] = ACTIONS(3061),
    [sym_static] = ACTIONS(3061),
    [sym_struct] = ACTIONS(3061),
    [sym_synchronized] = ACTIONS(3061),
    [sym_template] = ACTIONS(3061),
    [sym_typeof] = ACTIONS(3061),
    [sym_union] = ACTIONS(3061),
    [sym_unittest] = ACTIONS(3061),
    [sym_version] = ACTIONS(3061),
    [sym_gshared] = ACTIONS(3061),
    [sym_traits] = ACTIONS(3061),
    [sym_vector] = ACTIONS(3061),
    [sym_void] = ACTIONS(3061),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2160] = {
    [sym_identifier] = ACTIONS(5940),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5942),
    [anon_sym_BANG] = ACTIONS(5942),
    [anon_sym_LPAREN] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5942),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_EQ_EQ] = ACTIONS(5942),
    [anon_sym_STAR] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5942),
    [anon_sym_AT] = ACTIONS(5942),
    [sym_bool] = ACTIONS(5940),
    [sym_byte] = ACTIONS(5940),
    [sym_ubyte] = ACTIONS(5940),
    [sym_char] = ACTIONS(5940),
    [sym_short] = ACTIONS(5940),
    [sym_ushort] = ACTIONS(5940),
    [sym_int] = ACTIONS(5940),
    [sym_uint] = ACTIONS(5940),
    [sym_long] = ACTIONS(5940),
    [sym_ulong] = ACTIONS(5940),
    [sym_cent] = ACTIONS(5940),
    [sym_ucent] = ACTIONS(5940),
    [sym_wchar] = ACTIONS(5940),
    [sym_dchar] = ACTIONS(5940),
    [sym_float] = ACTIONS(5940),
    [sym_double] = ACTIONS(5940),
    [sym_real] = ACTIONS(5940),
    [sym_ifloat] = ACTIONS(5940),
    [sym_idouble] = ACTIONS(5940),
    [sym_ireal] = ACTIONS(5940),
    [sym_cfloat] = ACTIONS(5940),
    [sym_cdouble] = ACTIONS(5940),
    [sym_creal] = ACTIONS(5940),
    [sym_size_t] = ACTIONS(5940),
    [sym_ptrdiff_t] = ACTIONS(5940),
    [sym_string] = ACTIONS(5940),
    [sym_cstring] = ACTIONS(5940),
    [sym_dstring] = ACTIONS(5940),
    [sym_wstring] = ACTIONS(5940),
    [sym_noreturn] = ACTIONS(5940),
    [sym_this] = ACTIONS(5940),
    [sym_abstract] = ACTIONS(5940),
    [sym_alias] = ACTIONS(5940),
    [sym_align] = ACTIONS(5940),
    [sym_auto] = ACTIONS(5940),
    [sym_class] = ACTIONS(5940),
    [sym_const] = ACTIONS(5940),
    [sym_debug] = ACTIONS(5940),
    [sym_delegate] = ACTIONS(5940),
    [sym_deprecated] = ACTIONS(5940),
    [sym_enum] = ACTIONS(5940),
    [sym_export] = ACTIONS(5940),
    [sym_extern] = ACTIONS(5940),
    [sym_final] = ACTIONS(5940),
    [sym_function] = ACTIONS(5940),
    [sym_immutable] = ACTIONS(5940),
    [sym_import] = ACTIONS(5940),
    [sym_inout] = ACTIONS(5940),
    [sym_interface] = ACTIONS(5940),
    [sym_invariant] = ACTIONS(5940),
    [sym_mixin] = ACTIONS(5940),
    [sym_module] = ACTIONS(5940),
    [sym_nothrow] = ACTIONS(5940),
    [sym_override] = ACTIONS(5940),
    [sym_package] = ACTIONS(5940),
    [sym_pragma] = ACTIONS(5940),
    [sym_private] = ACTIONS(5940),
    [sym_protected] = ACTIONS(5940),
    [sym_public] = ACTIONS(5940),
    [sym_pure] = ACTIONS(5940),
    [sym_ref] = ACTIONS(5940),
    [sym_return] = ACTIONS(5940),
    [sym_scope] = ACTIONS(5940),
    [sym_shared] = ACTIONS(5940),
    [sym_static] = ACTIONS(5940),
    [sym_struct] = ACTIONS(5940),
    [sym_synchronized] = ACTIONS(5940),
    [sym_template] = ACTIONS(5940),
    [sym_typeof] = ACTIONS(5940),
    [sym_union] = ACTIONS(5940),
    [sym_unittest] = ACTIONS(5940),
    [sym_version] = ACTIONS(5940),
    [sym_gshared] = ACTIONS(5940),
    [sym_traits] = ACTIONS(5940),
    [sym_vector] = ACTIONS(5940),
    [sym_void] = ACTIONS(5940),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2161] = {
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_BANG] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [sym_bool] = ACTIONS(3069),
    [sym_byte] = ACTIONS(3069),
    [sym_ubyte] = ACTIONS(3069),
    [sym_char] = ACTIONS(3069),
    [sym_short] = ACTIONS(3069),
    [sym_ushort] = ACTIONS(3069),
    [sym_int] = ACTIONS(3069),
    [sym_uint] = ACTIONS(3069),
    [sym_long] = ACTIONS(3069),
    [sym_ulong] = ACTIONS(3069),
    [sym_cent] = ACTIONS(3069),
    [sym_ucent] = ACTIONS(3069),
    [sym_wchar] = ACTIONS(3069),
    [sym_dchar] = ACTIONS(3069),
    [sym_float] = ACTIONS(3069),
    [sym_double] = ACTIONS(3069),
    [sym_real] = ACTIONS(3069),
    [sym_ifloat] = ACTIONS(3069),
    [sym_idouble] = ACTIONS(3069),
    [sym_ireal] = ACTIONS(3069),
    [sym_cfloat] = ACTIONS(3069),
    [sym_cdouble] = ACTIONS(3069),
    [sym_creal] = ACTIONS(3069),
    [sym_size_t] = ACTIONS(3069),
    [sym_ptrdiff_t] = ACTIONS(3069),
    [sym_string] = ACTIONS(3069),
    [sym_cstring] = ACTIONS(3069),
    [sym_dstring] = ACTIONS(3069),
    [sym_wstring] = ACTIONS(3069),
    [sym_noreturn] = ACTIONS(3069),
    [sym_this] = ACTIONS(3069),
    [sym_abstract] = ACTIONS(3069),
    [sym_alias] = ACTIONS(3069),
    [sym_align] = ACTIONS(3069),
    [sym_auto] = ACTIONS(3069),
    [sym_class] = ACTIONS(3069),
    [sym_const] = ACTIONS(3069),
    [sym_debug] = ACTIONS(3069),
    [sym_delegate] = ACTIONS(3069),
    [sym_deprecated] = ACTIONS(3069),
    [sym_enum] = ACTIONS(3069),
    [sym_export] = ACTIONS(3069),
    [sym_extern] = ACTIONS(3069),
    [sym_final] = ACTIONS(3069),
    [sym_function] = ACTIONS(3069),
    [sym_immutable] = ACTIONS(3069),
    [sym_import] = ACTIONS(3069),
    [sym_inout] = ACTIONS(3069),
    [sym_interface] = ACTIONS(3069),
    [sym_invariant] = ACTIONS(3069),
    [sym_mixin] = ACTIONS(3069),
    [sym_module] = ACTIONS(3069),
    [sym_nothrow] = ACTIONS(3069),
    [sym_override] = ACTIONS(3069),
    [sym_package] = ACTIONS(3069),
    [sym_pragma] = ACTIONS(3069),
    [sym_private] = ACTIONS(3069),
    [sym_protected] = ACTIONS(3069),
    [sym_public] = ACTIONS(3069),
    [sym_pure] = ACTIONS(3069),
    [sym_ref] = ACTIONS(3069),
    [sym_return] = ACTIONS(3069),
    [sym_scope] = ACTIONS(3069),
    [sym_shared] = ACTIONS(3069),
    [sym_static] = ACTIONS(3069),
    [sym_struct] = ACTIONS(3069),
    [sym_synchronized] = ACTIONS(3069),
    [sym_template] = ACTIONS(3069),
    [sym_typeof] = ACTIONS(3069),
    [sym_union] = ACTIONS(3069),
    [sym_unittest] = ACTIONS(3069),
    [sym_version] = ACTIONS(3069),
    [sym_gshared] = ACTIONS(3069),
    [sym_traits] = ACTIONS(3069),
    [sym_vector] = ACTIONS(3069),
    [sym_void] = ACTIONS(3069),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2162] = {
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_EQ_EQ] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3099),
    [sym_bool] = ACTIONS(3097),
    [sym_byte] = ACTIONS(3097),
    [sym_ubyte] = ACTIONS(3097),
    [sym_char] = ACTIONS(3097),
    [sym_short] = ACTIONS(3097),
    [sym_ushort] = ACTIONS(3097),
    [sym_int] = ACTIONS(3097),
    [sym_uint] = ACTIONS(3097),
    [sym_long] = ACTIONS(3097),
    [sym_ulong] = ACTIONS(3097),
    [sym_cent] = ACTIONS(3097),
    [sym_ucent] = ACTIONS(3097),
    [sym_wchar] = ACTIONS(3097),
    [sym_dchar] = ACTIONS(3097),
    [sym_float] = ACTIONS(3097),
    [sym_double] = ACTIONS(3097),
    [sym_real] = ACTIONS(3097),
    [sym_ifloat] = ACTIONS(3097),
    [sym_idouble] = ACTIONS(3097),
    [sym_ireal] = ACTIONS(3097),
    [sym_cfloat] = ACTIONS(3097),
    [sym_cdouble] = ACTIONS(3097),
    [sym_creal] = ACTIONS(3097),
    [sym_size_t] = ACTIONS(3097),
    [sym_ptrdiff_t] = ACTIONS(3097),
    [sym_string] = ACTIONS(3097),
    [sym_cstring] = ACTIONS(3097),
    [sym_dstring] = ACTIONS(3097),
    [sym_wstring] = ACTIONS(3097),
    [sym_noreturn] = ACTIONS(3097),
    [sym_this] = ACTIONS(3097),
    [sym_abstract] = ACTIONS(3097),
    [sym_alias] = ACTIONS(3097),
    [sym_align] = ACTIONS(3097),
    [sym_auto] = ACTIONS(3097),
    [sym_class] = ACTIONS(3097),
    [sym_const] = ACTIONS(3097),
    [sym_debug] = ACTIONS(3097),
    [sym_delegate] = ACTIONS(3097),
    [sym_deprecated] = ACTIONS(3097),
    [sym_enum] = ACTIONS(3097),
    [sym_export] = ACTIONS(3097),
    [sym_extern] = ACTIONS(3097),
    [sym_final] = ACTIONS(3097),
    [sym_function] = ACTIONS(3097),
    [sym_immutable] = ACTIONS(3097),
    [sym_import] = ACTIONS(3097),
    [sym_inout] = ACTIONS(3097),
    [sym_interface] = ACTIONS(3097),
    [sym_invariant] = ACTIONS(3097),
    [sym_mixin] = ACTIONS(3097),
    [sym_module] = ACTIONS(3097),
    [sym_nothrow] = ACTIONS(3097),
    [sym_override] = ACTIONS(3097),
    [sym_package] = ACTIONS(3097),
    [sym_pragma] = ACTIONS(3097),
    [sym_private] = ACTIONS(3097),
    [sym_protected] = ACTIONS(3097),
    [sym_public] = ACTIONS(3097),
    [sym_pure] = ACTIONS(3097),
    [sym_ref] = ACTIONS(3097),
    [sym_return] = ACTIONS(3097),
    [sym_scope] = ACTIONS(3097),
    [sym_shared] = ACTIONS(3097),
    [sym_static] = ACTIONS(3097),
    [sym_struct] = ACTIONS(3097),
    [sym_synchronized] = ACTIONS(3097),
    [sym_template] = ACTIONS(3097),
    [sym_typeof] = ACTIONS(3097),
    [sym_union] = ACTIONS(3097),
    [sym_unittest] = ACTIONS(3097),
    [sym_version] = ACTIONS(3097),
    [sym_gshared] = ACTIONS(3097),
    [sym_traits] = ACTIONS(3097),
    [sym_vector] = ACTIONS(3097),
    [sym_void] = ACTIONS(3097),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_BANG] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_EQ_EQ] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3039),
    [anon_sym_AT] = ACTIONS(3039),
    [sym_bool] = ACTIONS(3037),
    [sym_byte] = ACTIONS(3037),
    [sym_ubyte] = ACTIONS(3037),
    [sym_char] = ACTIONS(3037),
    [sym_short] = ACTIONS(3037),
    [sym_ushort] = ACTIONS(3037),
    [sym_int] = ACTIONS(3037),
    [sym_uint] = ACTIONS(3037),
    [sym_long] = ACTIONS(3037),
    [sym_ulong] = ACTIONS(3037),
    [sym_cent] = ACTIONS(3037),
    [sym_ucent] = ACTIONS(3037),
    [sym_wchar] = ACTIONS(3037),
    [sym_dchar] = ACTIONS(3037),
    [sym_float] = ACTIONS(3037),
    [sym_double] = ACTIONS(3037),
    [sym_real] = ACTIONS(3037),
    [sym_ifloat] = ACTIONS(3037),
    [sym_idouble] = ACTIONS(3037),
    [sym_ireal] = ACTIONS(3037),
    [sym_cfloat] = ACTIONS(3037),
    [sym_cdouble] = ACTIONS(3037),
    [sym_creal] = ACTIONS(3037),
    [sym_size_t] = ACTIONS(3037),
    [sym_ptrdiff_t] = ACTIONS(3037),
    [sym_string] = ACTIONS(3037),
    [sym_cstring] = ACTIONS(3037),
    [sym_dstring] = ACTIONS(3037),
    [sym_wstring] = ACTIONS(3037),
    [sym_noreturn] = ACTIONS(3037),
    [sym_this] = ACTIONS(3037),
    [sym_abstract] = ACTIONS(3037),
    [sym_alias] = ACTIONS(3037),
    [sym_align] = ACTIONS(3037),
    [sym_auto] = ACTIONS(3037),
    [sym_class] = ACTIONS(3037),
    [sym_const] = ACTIONS(3037),
    [sym_debug] = ACTIONS(3037),
    [sym_delegate] = ACTIONS(3037),
    [sym_deprecated] = ACTIONS(3037),
    [sym_enum] = ACTIONS(3037),
    [sym_export] = ACTIONS(3037),
    [sym_extern] = ACTIONS(3037),
    [sym_final] = ACTIONS(3037),
    [sym_function] = ACTIONS(3037),
    [sym_immutable] = ACTIONS(3037),
    [sym_import] = ACTIONS(3037),
    [sym_inout] = ACTIONS(3037),
    [sym_interface] = ACTIONS(3037),
    [sym_invariant] = ACTIONS(3037),
    [sym_mixin] = ACTIONS(3037),
    [sym_module] = ACTIONS(3037),
    [sym_nothrow] = ACTIONS(3037),
    [sym_override] = ACTIONS(3037),
    [sym_package] = ACTIONS(3037),
    [sym_pragma] = ACTIONS(3037),
    [sym_private] = ACTIONS(3037),
    [sym_protected] = ACTIONS(3037),
    [sym_public] = ACTIONS(3037),
    [sym_pure] = ACTIONS(3037),
    [sym_ref] = ACTIONS(3037),
    [sym_return] = ACTIONS(3037),
    [sym_scope] = ACTIONS(3037),
    [sym_shared] = ACTIONS(3037),
    [sym_static] = ACTIONS(3037),
    [sym_struct] = ACTIONS(3037),
    [sym_synchronized] = ACTIONS(3037),
    [sym_template] = ACTIONS(3037),
    [sym_typeof] = ACTIONS(3037),
    [sym_union] = ACTIONS(3037),
    [sym_unittest] = ACTIONS(3037),
    [sym_version] = ACTIONS(3037),
    [sym_gshared] = ACTIONS(3037),
    [sym_traits] = ACTIONS(3037),
    [sym_vector] = ACTIONS(3037),
    [sym_void] = ACTIONS(3037),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2164] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_BANG] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_EQ_EQ] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3103),
    [sym_bool] = ACTIONS(3101),
    [sym_byte] = ACTIONS(3101),
    [sym_ubyte] = ACTIONS(3101),
    [sym_char] = ACTIONS(3101),
    [sym_short] = ACTIONS(3101),
    [sym_ushort] = ACTIONS(3101),
    [sym_int] = ACTIONS(3101),
    [sym_uint] = ACTIONS(3101),
    [sym_long] = ACTIONS(3101),
    [sym_ulong] = ACTIONS(3101),
    [sym_cent] = ACTIONS(3101),
    [sym_ucent] = ACTIONS(3101),
    [sym_wchar] = ACTIONS(3101),
    [sym_dchar] = ACTIONS(3101),
    [sym_float] = ACTIONS(3101),
    [sym_double] = ACTIONS(3101),
    [sym_real] = ACTIONS(3101),
    [sym_ifloat] = ACTIONS(3101),
    [sym_idouble] = ACTIONS(3101),
    [sym_ireal] = ACTIONS(3101),
    [sym_cfloat] = ACTIONS(3101),
    [sym_cdouble] = ACTIONS(3101),
    [sym_creal] = ACTIONS(3101),
    [sym_size_t] = ACTIONS(3101),
    [sym_ptrdiff_t] = ACTIONS(3101),
    [sym_string] = ACTIONS(3101),
    [sym_cstring] = ACTIONS(3101),
    [sym_dstring] = ACTIONS(3101),
    [sym_wstring] = ACTIONS(3101),
    [sym_noreturn] = ACTIONS(3101),
    [sym_this] = ACTIONS(3101),
    [sym_abstract] = ACTIONS(3101),
    [sym_alias] = ACTIONS(3101),
    [sym_align] = ACTIONS(3101),
    [sym_auto] = ACTIONS(3101),
    [sym_class] = ACTIONS(3101),
    [sym_const] = ACTIONS(3101),
    [sym_debug] = ACTIONS(3101),
    [sym_delegate] = ACTIONS(3101),
    [sym_deprecated] = ACTIONS(3101),
    [sym_enum] = ACTIONS(3101),
    [sym_export] = ACTIONS(3101),
    [sym_extern] = ACTIONS(3101),
    [sym_final] = ACTIONS(3101),
    [sym_function] = ACTIONS(3101),
    [sym_immutable] = ACTIONS(3101),
    [sym_import] = ACTIONS(3101),
    [sym_inout] = ACTIONS(3101),
    [sym_interface] = ACTIONS(3101),
    [sym_invariant] = ACTIONS(3101),
    [sym_mixin] = ACTIONS(3101),
    [sym_module] = ACTIONS(3101),
    [sym_nothrow] = ACTIONS(3101),
    [sym_override] = ACTIONS(3101),
    [sym_package] = ACTIONS(3101),
    [sym_pragma] = ACTIONS(3101),
    [sym_private] = ACTIONS(3101),
    [sym_protected] = ACTIONS(3101),
    [sym_public] = ACTIONS(3101),
    [sym_pure] = ACTIONS(3101),
    [sym_ref] = ACTIONS(3101),
    [sym_return] = ACTIONS(3101),
    [sym_scope] = ACTIONS(3101),
    [sym_shared] = ACTIONS(3101),
    [sym_static] = ACTIONS(3101),
    [sym_struct] = ACTIONS(3101),
    [sym_synchronized] = ACTIONS(3101),
    [sym_template] = ACTIONS(3101),
    [sym_typeof] = ACTIONS(3101),
    [sym_union] = ACTIONS(3101),
    [sym_unittest] = ACTIONS(3101),
    [sym_version] = ACTIONS(3101),
    [sym_gshared] = ACTIONS(3101),
    [sym_traits] = ACTIONS(3101),
    [sym_vector] = ACTIONS(3101),
    [sym_void] = ACTIONS(3101),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2165] = {
    [sym_identifier] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(5946),
    [anon_sym_DOT] = ACTIONS(5946),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(5946),
    [anon_sym_RBRACK] = ACTIONS(5946),
    [anon_sym_COMMA] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(5946),
    [anon_sym_COLON] = ACTIONS(5946),
    [anon_sym_EQ_EQ] = ACTIONS(5946),
    [anon_sym_STAR] = ACTIONS(5946),
    [anon_sym_TILDE] = ACTIONS(5946),
    [anon_sym_AT] = ACTIONS(5946),
    [sym_bool] = ACTIONS(5944),
    [sym_byte] = ACTIONS(5944),
    [sym_ubyte] = ACTIONS(5944),
    [sym_char] = ACTIONS(5944),
    [sym_short] = ACTIONS(5944),
    [sym_ushort] = ACTIONS(5944),
    [sym_int] = ACTIONS(5944),
    [sym_uint] = ACTIONS(5944),
    [sym_long] = ACTIONS(5944),
    [sym_ulong] = ACTIONS(5944),
    [sym_cent] = ACTIONS(5944),
    [sym_ucent] = ACTIONS(5944),
    [sym_wchar] = ACTIONS(5944),
    [sym_dchar] = ACTIONS(5944),
    [sym_float] = ACTIONS(5944),
    [sym_double] = ACTIONS(5944),
    [sym_real] = ACTIONS(5944),
    [sym_ifloat] = ACTIONS(5944),
    [sym_idouble] = ACTIONS(5944),
    [sym_ireal] = ACTIONS(5944),
    [sym_cfloat] = ACTIONS(5944),
    [sym_cdouble] = ACTIONS(5944),
    [sym_creal] = ACTIONS(5944),
    [sym_size_t] = ACTIONS(5944),
    [sym_ptrdiff_t] = ACTIONS(5944),
    [sym_string] = ACTIONS(5944),
    [sym_cstring] = ACTIONS(5944),
    [sym_dstring] = ACTIONS(5944),
    [sym_wstring] = ACTIONS(5944),
    [sym_noreturn] = ACTIONS(5944),
    [sym_this] = ACTIONS(5944),
    [sym_abstract] = ACTIONS(5944),
    [sym_alias] = ACTIONS(5944),
    [sym_align] = ACTIONS(5944),
    [sym_auto] = ACTIONS(5944),
    [sym_class] = ACTIONS(5944),
    [sym_const] = ACTIONS(5944),
    [sym_debug] = ACTIONS(5944),
    [sym_delegate] = ACTIONS(5944),
    [sym_deprecated] = ACTIONS(5944),
    [sym_enum] = ACTIONS(5944),
    [sym_export] = ACTIONS(5944),
    [sym_extern] = ACTIONS(5944),
    [sym_final] = ACTIONS(5944),
    [sym_function] = ACTIONS(5944),
    [sym_immutable] = ACTIONS(5944),
    [sym_import] = ACTIONS(5944),
    [sym_inout] = ACTIONS(5944),
    [sym_interface] = ACTIONS(5944),
    [sym_invariant] = ACTIONS(5944),
    [sym_mixin] = ACTIONS(5944),
    [sym_module] = ACTIONS(5944),
    [sym_nothrow] = ACTIONS(5944),
    [sym_override] = ACTIONS(5944),
    [sym_package] = ACTIONS(5944),
    [sym_pragma] = ACTIONS(5944),
    [sym_private] = ACTIONS(5944),
    [sym_protected] = ACTIONS(5944),
    [sym_public] = ACTIONS(5944),
    [sym_pure] = ACTIONS(5944),
    [sym_ref] = ACTIONS(5944),
    [sym_return] = ACTIONS(5944),
    [sym_scope] = ACTIONS(5944),
    [sym_shared] = ACTIONS(5944),
    [sym_static] = ACTIONS(5944),
    [sym_struct] = ACTIONS(5944),
    [sym_synchronized] = ACTIONS(5944),
    [sym_template] = ACTIONS(5944),
    [sym_typeof] = ACTIONS(5944),
    [sym_union] = ACTIONS(5944),
    [sym_unittest] = ACTIONS(5944),
    [sym_version] = ACTIONS(5944),
    [sym_gshared] = ACTIONS(5944),
    [sym_traits] = ACTIONS(5944),
    [sym_vector] = ACTIONS(5944),
    [sym_void] = ACTIONS(5944),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2166] = {
    [sym_identifier] = ACTIONS(5948),
    [anon_sym_LBRACE] = ACTIONS(5950),
    [anon_sym_DOT] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(5950),
    [anon_sym_RPAREN] = ACTIONS(5950),
    [anon_sym_LBRACK] = ACTIONS(5950),
    [anon_sym_RBRACK] = ACTIONS(5950),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_SEMI] = ACTIONS(5950),
    [anon_sym_COLON] = ACTIONS(5950),
    [anon_sym_EQ_EQ] = ACTIONS(5950),
    [anon_sym_STAR] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5950),
    [anon_sym_AT] = ACTIONS(5950),
    [sym_bool] = ACTIONS(5948),
    [sym_byte] = ACTIONS(5948),
    [sym_ubyte] = ACTIONS(5948),
    [sym_char] = ACTIONS(5948),
    [sym_short] = ACTIONS(5948),
    [sym_ushort] = ACTIONS(5948),
    [sym_int] = ACTIONS(5948),
    [sym_uint] = ACTIONS(5948),
    [sym_long] = ACTIONS(5948),
    [sym_ulong] = ACTIONS(5948),
    [sym_cent] = ACTIONS(5948),
    [sym_ucent] = ACTIONS(5948),
    [sym_wchar] = ACTIONS(5948),
    [sym_dchar] = ACTIONS(5948),
    [sym_float] = ACTIONS(5948),
    [sym_double] = ACTIONS(5948),
    [sym_real] = ACTIONS(5948),
    [sym_ifloat] = ACTIONS(5948),
    [sym_idouble] = ACTIONS(5948),
    [sym_ireal] = ACTIONS(5948),
    [sym_cfloat] = ACTIONS(5948),
    [sym_cdouble] = ACTIONS(5948),
    [sym_creal] = ACTIONS(5948),
    [sym_size_t] = ACTIONS(5948),
    [sym_ptrdiff_t] = ACTIONS(5948),
    [sym_string] = ACTIONS(5948),
    [sym_cstring] = ACTIONS(5948),
    [sym_dstring] = ACTIONS(5948),
    [sym_wstring] = ACTIONS(5948),
    [sym_noreturn] = ACTIONS(5948),
    [sym_this] = ACTIONS(5948),
    [sym_abstract] = ACTIONS(5948),
    [sym_alias] = ACTIONS(5948),
    [sym_align] = ACTIONS(5948),
    [sym_auto] = ACTIONS(5948),
    [sym_class] = ACTIONS(5948),
    [sym_const] = ACTIONS(5948),
    [sym_debug] = ACTIONS(5948),
    [sym_delegate] = ACTIONS(5948),
    [sym_deprecated] = ACTIONS(5948),
    [sym_enum] = ACTIONS(5948),
    [sym_export] = ACTIONS(5948),
    [sym_extern] = ACTIONS(5948),
    [sym_final] = ACTIONS(5948),
    [sym_function] = ACTIONS(5948),
    [sym_immutable] = ACTIONS(5948),
    [sym_import] = ACTIONS(5948),
    [sym_inout] = ACTIONS(5948),
    [sym_interface] = ACTIONS(5948),
    [sym_invariant] = ACTIONS(5948),
    [sym_mixin] = ACTIONS(5948),
    [sym_module] = ACTIONS(5948),
    [sym_nothrow] = ACTIONS(5948),
    [sym_override] = ACTIONS(5948),
    [sym_package] = ACTIONS(5948),
    [sym_pragma] = ACTIONS(5948),
    [sym_private] = ACTIONS(5948),
    [sym_protected] = ACTIONS(5948),
    [sym_public] = ACTIONS(5948),
    [sym_pure] = ACTIONS(5948),
    [sym_ref] = ACTIONS(5948),
    [sym_return] = ACTIONS(5948),
    [sym_scope] = ACTIONS(5948),
    [sym_shared] = ACTIONS(5948),
    [sym_static] = ACTIONS(5948),
    [sym_struct] = ACTIONS(5948),
    [sym_synchronized] = ACTIONS(5948),
    [sym_template] = ACTIONS(5948),
    [sym_typeof] = ACTIONS(5948),
    [sym_union] = ACTIONS(5948),
    [sym_unittest] = ACTIONS(5948),
    [sym_version] = ACTIONS(5948),
    [sym_gshared] = ACTIONS(5948),
    [sym_traits] = ACTIONS(5948),
    [sym_vector] = ACTIONS(5948),
    [sym_void] = ACTIONS(5948),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2167] = {
    [sym_identifier] = ACTIONS(5952),
    [anon_sym_LBRACE] = ACTIONS(5954),
    [anon_sym_DOT] = ACTIONS(5954),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_SEMI] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_EQ_EQ] = ACTIONS(5954),
    [anon_sym_STAR] = ACTIONS(5954),
    [anon_sym_TILDE] = ACTIONS(5954),
    [anon_sym_AT] = ACTIONS(5954),
    [sym_bool] = ACTIONS(5952),
    [sym_byte] = ACTIONS(5952),
    [sym_ubyte] = ACTIONS(5952),
    [sym_char] = ACTIONS(5952),
    [sym_short] = ACTIONS(5952),
    [sym_ushort] = ACTIONS(5952),
    [sym_int] = ACTIONS(5952),
    [sym_uint] = ACTIONS(5952),
    [sym_long] = ACTIONS(5952),
    [sym_ulong] = ACTIONS(5952),
    [sym_cent] = ACTIONS(5952),
    [sym_ucent] = ACTIONS(5952),
    [sym_wchar] = ACTIONS(5952),
    [sym_dchar] = ACTIONS(5952),
    [sym_float] = ACTIONS(5952),
    [sym_double] = ACTIONS(5952),
    [sym_real] = ACTIONS(5952),
    [sym_ifloat] = ACTIONS(5952),
    [sym_idouble] = ACTIONS(5952),
    [sym_ireal] = ACTIONS(5952),
    [sym_cfloat] = ACTIONS(5952),
    [sym_cdouble] = ACTIONS(5952),
    [sym_creal] = ACTIONS(5952),
    [sym_size_t] = ACTIONS(5952),
    [sym_ptrdiff_t] = ACTIONS(5952),
    [sym_string] = ACTIONS(5952),
    [sym_cstring] = ACTIONS(5952),
    [sym_dstring] = ACTIONS(5952),
    [sym_wstring] = ACTIONS(5952),
    [sym_noreturn] = ACTIONS(5952),
    [sym_this] = ACTIONS(5952),
    [sym_abstract] = ACTIONS(5952),
    [sym_alias] = ACTIONS(5952),
    [sym_align] = ACTIONS(5952),
    [sym_auto] = ACTIONS(5952),
    [sym_class] = ACTIONS(5952),
    [sym_const] = ACTIONS(5952),
    [sym_debug] = ACTIONS(5952),
    [sym_delegate] = ACTIONS(5952),
    [sym_deprecated] = ACTIONS(5952),
    [sym_enum] = ACTIONS(5952),
    [sym_export] = ACTIONS(5952),
    [sym_extern] = ACTIONS(5952),
    [sym_final] = ACTIONS(5952),
    [sym_function] = ACTIONS(5952),
    [sym_immutable] = ACTIONS(5952),
    [sym_import] = ACTIONS(5952),
    [sym_inout] = ACTIONS(5952),
    [sym_interface] = ACTIONS(5952),
    [sym_invariant] = ACTIONS(5952),
    [sym_mixin] = ACTIONS(5952),
    [sym_module] = ACTIONS(5952),
    [sym_nothrow] = ACTIONS(5952),
    [sym_override] = ACTIONS(5952),
    [sym_package] = ACTIONS(5952),
    [sym_pragma] = ACTIONS(5952),
    [sym_private] = ACTIONS(5952),
    [sym_protected] = ACTIONS(5952),
    [sym_public] = ACTIONS(5952),
    [sym_pure] = ACTIONS(5952),
    [sym_ref] = ACTIONS(5952),
    [sym_return] = ACTIONS(5952),
    [sym_scope] = ACTIONS(5952),
    [sym_shared] = ACTIONS(5952),
    [sym_static] = ACTIONS(5952),
    [sym_struct] = ACTIONS(5952),
    [sym_synchronized] = ACTIONS(5952),
    [sym_template] = ACTIONS(5952),
    [sym_typeof] = ACTIONS(5952),
    [sym_union] = ACTIONS(5952),
    [sym_unittest] = ACTIONS(5952),
    [sym_version] = ACTIONS(5952),
    [sym_gshared] = ACTIONS(5952),
    [sym_traits] = ACTIONS(5952),
    [sym_vector] = ACTIONS(5952),
    [sym_void] = ACTIONS(5952),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2168] = {
    [sym_identifier] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_SEMI] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_EQ_EQ] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_TILDE] = ACTIONS(5958),
    [anon_sym_AT] = ACTIONS(5958),
    [sym_bool] = ACTIONS(5956),
    [sym_byte] = ACTIONS(5956),
    [sym_ubyte] = ACTIONS(5956),
    [sym_char] = ACTIONS(5956),
    [sym_short] = ACTIONS(5956),
    [sym_ushort] = ACTIONS(5956),
    [sym_int] = ACTIONS(5956),
    [sym_uint] = ACTIONS(5956),
    [sym_long] = ACTIONS(5956),
    [sym_ulong] = ACTIONS(5956),
    [sym_cent] = ACTIONS(5956),
    [sym_ucent] = ACTIONS(5956),
    [sym_wchar] = ACTIONS(5956),
    [sym_dchar] = ACTIONS(5956),
    [sym_float] = ACTIONS(5956),
    [sym_double] = ACTIONS(5956),
    [sym_real] = ACTIONS(5956),
    [sym_ifloat] = ACTIONS(5956),
    [sym_idouble] = ACTIONS(5956),
    [sym_ireal] = ACTIONS(5956),
    [sym_cfloat] = ACTIONS(5956),
    [sym_cdouble] = ACTIONS(5956),
    [sym_creal] = ACTIONS(5956),
    [sym_size_t] = ACTIONS(5956),
    [sym_ptrdiff_t] = ACTIONS(5956),
    [sym_string] = ACTIONS(5956),
    [sym_cstring] = ACTIONS(5956),
    [sym_dstring] = ACTIONS(5956),
    [sym_wstring] = ACTIONS(5956),
    [sym_noreturn] = ACTIONS(5956),
    [sym_this] = ACTIONS(5956),
    [sym_abstract] = ACTIONS(5956),
    [sym_alias] = ACTIONS(5956),
    [sym_align] = ACTIONS(5956),
    [sym_auto] = ACTIONS(5956),
    [sym_class] = ACTIONS(5956),
    [sym_const] = ACTIONS(5956),
    [sym_debug] = ACTIONS(5956),
    [sym_delegate] = ACTIONS(5956),
    [sym_deprecated] = ACTIONS(5956),
    [sym_enum] = ACTIONS(5956),
    [sym_export] = ACTIONS(5956),
    [sym_extern] = ACTIONS(5956),
    [sym_final] = ACTIONS(5956),
    [sym_function] = ACTIONS(5956),
    [sym_immutable] = ACTIONS(5956),
    [sym_import] = ACTIONS(5956),
    [sym_inout] = ACTIONS(5956),
    [sym_interface] = ACTIONS(5956),
    [sym_invariant] = ACTIONS(5956),
    [sym_mixin] = ACTIONS(5956),
    [sym_module] = ACTIONS(5956),
    [sym_nothrow] = ACTIONS(5956),
    [sym_override] = ACTIONS(5956),
    [sym_package] = ACTIONS(5956),
    [sym_pragma] = ACTIONS(5956),
    [sym_private] = ACTIONS(5956),
    [sym_protected] = ACTIONS(5956),
    [sym_public] = ACTIONS(5956),
    [sym_pure] = ACTIONS(5956),
    [sym_ref] = ACTIONS(5956),
    [sym_return] = ACTIONS(5956),
    [sym_scope] = ACTIONS(5956),
    [sym_shared] = ACTIONS(5956),
    [sym_static] = ACTIONS(5956),
    [sym_struct] = ACTIONS(5956),
    [sym_synchronized] = ACTIONS(5956),
    [sym_template] = ACTIONS(5956),
    [sym_typeof] = ACTIONS(5956),
    [sym_union] = ACTIONS(5956),
    [sym_unittest] = ACTIONS(5956),
    [sym_version] = ACTIONS(5956),
    [sym_gshared] = ACTIONS(5956),
    [sym_traits] = ACTIONS(5956),
    [sym_vector] = ACTIONS(5956),
    [sym_void] = ACTIONS(5956),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2169] = {
    [sym_type_ctor] = STATE(2169),
    [sym_align_attribute] = STATE(2169),
    [sym_deprecated_attribute] = STATE(2169),
    [sym__attribute] = STATE(2169),
    [sym_at_attribute] = STATE(2169),
    [sym__function_attribute_kwd] = STATE(2169),
    [sym_linkage_attribute] = STATE(2169),
    [sym_pragma_expression] = STATE(2169),
    [aux_sym__declaration_repeat1] = STATE(2169),
    [sym_identifier] = ACTIONS(5960),
    [anon_sym_LBRACE] = ACTIONS(5962),
    [anon_sym_DOT] = ACTIONS(5962),
    [anon_sym_SEMI] = ACTIONS(5962),
    [anon_sym_TILDE] = ACTIONS(5962),
    [anon_sym_AT] = ACTIONS(5964),
    [sym_bool] = ACTIONS(5960),
    [sym_byte] = ACTIONS(5960),
    [sym_ubyte] = ACTIONS(5960),
    [sym_char] = ACTIONS(5960),
    [sym_short] = ACTIONS(5960),
    [sym_ushort] = ACTIONS(5960),
    [sym_int] = ACTIONS(5960),
    [sym_uint] = ACTIONS(5960),
    [sym_long] = ACTIONS(5960),
    [sym_ulong] = ACTIONS(5960),
    [sym_cent] = ACTIONS(5960),
    [sym_ucent] = ACTIONS(5960),
    [sym_wchar] = ACTIONS(5960),
    [sym_dchar] = ACTIONS(5960),
    [sym_float] = ACTIONS(5960),
    [sym_double] = ACTIONS(5960),
    [sym_real] = ACTIONS(5960),
    [sym_ifloat] = ACTIONS(5960),
    [sym_idouble] = ACTIONS(5960),
    [sym_ireal] = ACTIONS(5960),
    [sym_cfloat] = ACTIONS(5960),
    [sym_cdouble] = ACTIONS(5960),
    [sym_creal] = ACTIONS(5960),
    [sym_size_t] = ACTIONS(5960),
    [sym_ptrdiff_t] = ACTIONS(5960),
    [sym_string] = ACTIONS(5960),
    [sym_cstring] = ACTIONS(5960),
    [sym_dstring] = ACTIONS(5960),
    [sym_wstring] = ACTIONS(5960),
    [sym_noreturn] = ACTIONS(5960),
    [sym_this] = ACTIONS(5960),
    [sym_abstract] = ACTIONS(5967),
    [sym_alias] = ACTIONS(5960),
    [sym_align] = ACTIONS(5970),
    [sym_auto] = ACTIONS(5967),
    [sym_class] = ACTIONS(5960),
    [sym_const] = ACTIONS(5973),
    [sym_debug] = ACTIONS(5960),
    [sym_deprecated] = ACTIONS(5976),
    [sym_enum] = ACTIONS(5960),
    [sym_export] = ACTIONS(5967),
    [sym_extern] = ACTIONS(5979),
    [sym_final] = ACTIONS(5967),
    [sym_immutable] = ACTIONS(5973),
    [sym_import] = ACTIONS(5960),
    [sym_inout] = ACTIONS(5973),
    [sym_interface] = ACTIONS(5960),
    [sym_invariant] = ACTIONS(5960),
    [sym_mixin] = ACTIONS(5960),
    [sym_nothrow] = ACTIONS(5967),
    [sym_override] = ACTIONS(5967),
    [sym_package] = ACTIONS(5982),
    [sym_pragma] = ACTIONS(5985),
    [sym_private] = ACTIONS(5967),
    [sym_protected] = ACTIONS(5967),
    [sym_public] = ACTIONS(5967),
    [sym_pure] = ACTIONS(5967),
    [sym_ref] = ACTIONS(5967),
    [sym_return] = ACTIONS(5967),
    [sym_scope] = ACTIONS(5967),
    [sym_shared] = ACTIONS(5973),
    [sym_static] = ACTIONS(5967),
    [sym_struct] = ACTIONS(5960),
    [sym_synchronized] = ACTIONS(5967),
    [sym_template] = ACTIONS(5960),
    [sym_typeof] = ACTIONS(5960),
    [sym_union] = ACTIONS(5960),
    [sym_unittest] = ACTIONS(5960),
    [sym_version] = ACTIONS(5960),
    [sym_gshared] = ACTIONS(5967),
    [sym_traits] = ACTIONS(5960),
    [sym_vector] = ACTIONS(5960),
    [sym_void] = ACTIONS(5960),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2170] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6552),
    [sym_foreach_statement] = STATE(2030),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6000),
    [sym_foreach_reverse] = ACTIONS(6000),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2171] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6550),
    [sym_foreach_statement] = STATE(2030),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6004),
    [sym_foreach_reverse] = ACTIONS(6004),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2172] = {
    [sym_assert_expression] = STATE(6532),
    [sym__foreach] = STATE(6433),
    [sym_foreach_statement] = STATE(1569),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6006),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6008),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6010),
    [sym_foreach_reverse] = ACTIONS(6010),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2173] = {
    [sym_assert_expression] = STATE(6281),
    [sym__foreach] = STATE(6544),
    [sym_foreach_statement] = STATE(1497),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6012),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6014),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6016),
    [sym_foreach_reverse] = ACTIONS(6016),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2174] = {
    [ts_builtin_sym_end] = ACTIONS(3165),
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_RBRACE] = ACTIONS(3165),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_COMMA] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_abstract] = ACTIONS(3163),
    [sym_alias] = ACTIONS(3163),
    [sym_align] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_class] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_debug] = ACTIONS(3163),
    [sym_deprecated] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_enum] = ACTIONS(3163),
    [sym_export] = ACTIONS(3163),
    [sym_extern] = ACTIONS(3163),
    [sym_final] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_interface] = ACTIONS(3163),
    [sym_invariant] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_nothrow] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_override] = ACTIONS(3163),
    [sym_package] = ACTIONS(3163),
    [sym_pragma] = ACTIONS(3163),
    [sym_private] = ACTIONS(3163),
    [sym_protected] = ACTIONS(3163),
    [sym_public] = ACTIONS(3163),
    [sym_pure] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_return] = ACTIONS(3163),
    [sym_scope] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_static] = ACTIONS(3163),
    [sym_struct] = ACTIONS(3163),
    [sym_synchronized] = ACTIONS(3163),
    [sym_template] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_union] = ACTIONS(3163),
    [sym_unittest] = ACTIONS(3163),
    [sym_version] = ACTIONS(3163),
    [sym_while] = ACTIONS(3163),
    [sym_gshared] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2175] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6542),
    [sym_foreach_statement] = STATE(2030),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6018),
    [sym_foreach_reverse] = ACTIONS(6018),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2176] = {
    [sym_assert_expression] = STATE(6281),
    [sym__foreach] = STATE(6534),
    [sym_foreach_statement] = STATE(1497),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6012),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6014),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6020),
    [sym_foreach_reverse] = ACTIONS(6020),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2177] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6548),
    [sym_foreach_statement] = STATE(2030),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6022),
    [sym_foreach_reverse] = ACTIONS(6022),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2178] = {
    [sym_assert_expression] = STATE(5625),
    [sym__foreach] = STATE(6546),
    [sym_foreach_statement] = STATE(4683),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6024),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6026),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6028),
    [sym_foreach_reverse] = ACTIONS(6028),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2179] = {
    [ts_builtin_sym_end] = ACTIONS(3178),
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_RBRACE] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_COMMA] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_abstract] = ACTIONS(3176),
    [sym_alias] = ACTIONS(3176),
    [sym_align] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_class] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_debug] = ACTIONS(3176),
    [sym_deprecated] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_enum] = ACTIONS(3176),
    [sym_export] = ACTIONS(3176),
    [sym_extern] = ACTIONS(3176),
    [sym_final] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_interface] = ACTIONS(3176),
    [sym_invariant] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_nothrow] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_override] = ACTIONS(3176),
    [sym_package] = ACTIONS(3176),
    [sym_pragma] = ACTIONS(3176),
    [sym_private] = ACTIONS(3176),
    [sym_protected] = ACTIONS(3176),
    [sym_public] = ACTIONS(3176),
    [sym_pure] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_return] = ACTIONS(3176),
    [sym_scope] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_static] = ACTIONS(3176),
    [sym_struct] = ACTIONS(3176),
    [sym_synchronized] = ACTIONS(3176),
    [sym_template] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_union] = ACTIONS(3176),
    [sym_unittest] = ACTIONS(3176),
    [sym_version] = ACTIONS(3176),
    [sym_while] = ACTIONS(3176),
    [sym_gshared] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2180] = {
    [sym_assert_expression] = STATE(5625),
    [sym__foreach] = STATE(6540),
    [sym_foreach_statement] = STATE(4683),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6024),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6026),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6030),
    [sym_foreach_reverse] = ACTIONS(6030),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2181] = {
    [ts_builtin_sym_end] = ACTIONS(3129),
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_RBRACE] = ACTIONS(3129),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_COMMA] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2182] = {
    [sym_assert_expression] = STATE(6532),
    [sym__foreach] = STATE(6538),
    [sym_foreach_statement] = STATE(1569),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6006),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6008),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6032),
    [sym_foreach_reverse] = ACTIONS(6032),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2183] = {
    [sym_assert_expression] = STATE(6326),
    [sym__foreach] = STATE(6489),
    [sym_foreach_statement] = STATE(4683),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6034),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6036),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6038),
    [sym_foreach_reverse] = ACTIONS(6038),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2184] = {
    [sym_assert_expression] = STATE(6326),
    [sym__foreach] = STATE(6507),
    [sym_foreach_statement] = STATE(4683),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6034),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6036),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6040),
    [sym_foreach_reverse] = ACTIONS(6040),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(4514),
    [anon_sym_LBRACE] = ACTIONS(4516),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_SEMI] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4516),
    [anon_sym_AT] = ACTIONS(4516),
    [sym_bool] = ACTIONS(4514),
    [sym_byte] = ACTIONS(4514),
    [sym_ubyte] = ACTIONS(4514),
    [sym_char] = ACTIONS(4514),
    [sym_short] = ACTIONS(4514),
    [sym_ushort] = ACTIONS(4514),
    [sym_int] = ACTIONS(4514),
    [sym_uint] = ACTIONS(4514),
    [sym_long] = ACTIONS(4514),
    [sym_ulong] = ACTIONS(4514),
    [sym_cent] = ACTIONS(4514),
    [sym_ucent] = ACTIONS(4514),
    [sym_wchar] = ACTIONS(4514),
    [sym_dchar] = ACTIONS(4514),
    [sym_float] = ACTIONS(4514),
    [sym_double] = ACTIONS(4514),
    [sym_real] = ACTIONS(4514),
    [sym_ifloat] = ACTIONS(4514),
    [sym_idouble] = ACTIONS(4514),
    [sym_ireal] = ACTIONS(4514),
    [sym_cfloat] = ACTIONS(4514),
    [sym_cdouble] = ACTIONS(4514),
    [sym_creal] = ACTIONS(4514),
    [sym_size_t] = ACTIONS(4514),
    [sym_ptrdiff_t] = ACTIONS(4514),
    [sym_string] = ACTIONS(4514),
    [sym_cstring] = ACTIONS(4514),
    [sym_dstring] = ACTIONS(4514),
    [sym_wstring] = ACTIONS(4514),
    [sym_noreturn] = ACTIONS(4514),
    [sym_this] = ACTIONS(4514),
    [sym_abstract] = ACTIONS(4514),
    [sym_alias] = ACTIONS(4514),
    [sym_align] = ACTIONS(4514),
    [sym_auto] = ACTIONS(4514),
    [sym_catch] = ACTIONS(4514),
    [sym_class] = ACTIONS(4514),
    [sym_const] = ACTIONS(4514),
    [sym_debug] = ACTIONS(4514),
    [sym_deprecated] = ACTIONS(4514),
    [sym_do] = ACTIONS(4514),
    [sym_else] = ACTIONS(4514),
    [sym_enum] = ACTIONS(4514),
    [sym_export] = ACTIONS(4514),
    [sym_extern] = ACTIONS(4514),
    [sym_final] = ACTIONS(4514),
    [sym_finally] = ACTIONS(4514),
    [sym_immutable] = ACTIONS(4514),
    [sym_import] = ACTIONS(4514),
    [sym_in] = ACTIONS(4514),
    [sym_inout] = ACTIONS(4514),
    [sym_interface] = ACTIONS(4514),
    [sym_invariant] = ACTIONS(4514),
    [sym_mixin] = ACTIONS(4514),
    [sym_nothrow] = ACTIONS(4514),
    [sym_out] = ACTIONS(4514),
    [sym_override] = ACTIONS(4514),
    [sym_package] = ACTIONS(4514),
    [sym_pragma] = ACTIONS(4514),
    [sym_private] = ACTIONS(4514),
    [sym_protected] = ACTIONS(4514),
    [sym_public] = ACTIONS(4514),
    [sym_pure] = ACTIONS(4514),
    [sym_ref] = ACTIONS(4514),
    [sym_return] = ACTIONS(4514),
    [sym_scope] = ACTIONS(4514),
    [sym_shared] = ACTIONS(4514),
    [sym_static] = ACTIONS(4514),
    [sym_struct] = ACTIONS(4514),
    [sym_synchronized] = ACTIONS(4514),
    [sym_template] = ACTIONS(4514),
    [sym_typeof] = ACTIONS(4514),
    [sym_union] = ACTIONS(4514),
    [sym_unittest] = ACTIONS(4514),
    [sym_version] = ACTIONS(4514),
    [sym_while] = ACTIONS(4514),
    [sym_gshared] = ACTIONS(4514),
    [sym_traits] = ACTIONS(4514),
    [sym_vector] = ACTIONS(4514),
    [sym_void] = ACTIONS(4514),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2186] = {
    [ts_builtin_sym_end] = ACTIONS(4783),
    [sym_identifier] = ACTIONS(4781),
    [anon_sym_RBRACE] = ACTIONS(4783),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_AT] = ACTIONS(4783),
    [sym_bool] = ACTIONS(4781),
    [sym_byte] = ACTIONS(4781),
    [sym_ubyte] = ACTIONS(4781),
    [sym_char] = ACTIONS(4781),
    [sym_short] = ACTIONS(4781),
    [sym_ushort] = ACTIONS(4781),
    [sym_int] = ACTIONS(4781),
    [sym_uint] = ACTIONS(4781),
    [sym_long] = ACTIONS(4781),
    [sym_ulong] = ACTIONS(4781),
    [sym_cent] = ACTIONS(4781),
    [sym_ucent] = ACTIONS(4781),
    [sym_wchar] = ACTIONS(4781),
    [sym_dchar] = ACTIONS(4781),
    [sym_float] = ACTIONS(4781),
    [sym_double] = ACTIONS(4781),
    [sym_real] = ACTIONS(4781),
    [sym_ifloat] = ACTIONS(4781),
    [sym_idouble] = ACTIONS(4781),
    [sym_ireal] = ACTIONS(4781),
    [sym_cfloat] = ACTIONS(4781),
    [sym_cdouble] = ACTIONS(4781),
    [sym_creal] = ACTIONS(4781),
    [sym_size_t] = ACTIONS(4781),
    [sym_ptrdiff_t] = ACTIONS(4781),
    [sym_string] = ACTIONS(4781),
    [sym_cstring] = ACTIONS(4781),
    [sym_dstring] = ACTIONS(4781),
    [sym_wstring] = ACTIONS(4781),
    [sym_noreturn] = ACTIONS(4781),
    [sym_this] = ACTIONS(4781),
    [sym_abstract] = ACTIONS(4781),
    [sym_alias] = ACTIONS(4781),
    [sym_align] = ACTIONS(4781),
    [sym_auto] = ACTIONS(4781),
    [sym_class] = ACTIONS(4781),
    [sym_const] = ACTIONS(4781),
    [sym_debug] = ACTIONS(4781),
    [sym_deprecated] = ACTIONS(4781),
    [sym_do] = ACTIONS(4781),
    [sym_else] = ACTIONS(4781),
    [sym_enum] = ACTIONS(4781),
    [sym_export] = ACTIONS(4781),
    [sym_extern] = ACTIONS(4781),
    [sym_final] = ACTIONS(4781),
    [sym_immutable] = ACTIONS(4781),
    [sym_import] = ACTIONS(4781),
    [sym_in] = ACTIONS(4781),
    [sym_inout] = ACTIONS(4781),
    [sym_interface] = ACTIONS(4781),
    [sym_invariant] = ACTIONS(4781),
    [sym_mixin] = ACTIONS(4781),
    [sym_nothrow] = ACTIONS(4781),
    [sym_out] = ACTIONS(4781),
    [sym_override] = ACTIONS(4781),
    [sym_package] = ACTIONS(4781),
    [sym_pragma] = ACTIONS(4781),
    [sym_private] = ACTIONS(4781),
    [sym_protected] = ACTIONS(4781),
    [sym_public] = ACTIONS(4781),
    [sym_pure] = ACTIONS(4781),
    [sym_ref] = ACTIONS(4781),
    [sym_return] = ACTIONS(4781),
    [sym_scope] = ACTIONS(4781),
    [sym_shared] = ACTIONS(4781),
    [sym_static] = ACTIONS(4781),
    [sym_struct] = ACTIONS(4781),
    [sym_synchronized] = ACTIONS(4781),
    [sym_template] = ACTIONS(4781),
    [sym_typeof] = ACTIONS(4781),
    [sym_union] = ACTIONS(4781),
    [sym_unittest] = ACTIONS(4781),
    [sym_version] = ACTIONS(4781),
    [sym_while] = ACTIONS(4781),
    [sym_gshared] = ACTIONS(4781),
    [sym_traits] = ACTIONS(4781),
    [sym_vector] = ACTIONS(4781),
    [sym_void] = ACTIONS(4781),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(4781),
    [anon_sym_LBRACE] = ACTIONS(4783),
    [anon_sym_DOT] = ACTIONS(4783),
    [anon_sym_SEMI] = ACTIONS(4783),
    [anon_sym_TILDE] = ACTIONS(4783),
    [anon_sym_AT] = ACTIONS(4783),
    [sym_bool] = ACTIONS(4781),
    [sym_byte] = ACTIONS(4781),
    [sym_ubyte] = ACTIONS(4781),
    [sym_char] = ACTIONS(4781),
    [sym_short] = ACTIONS(4781),
    [sym_ushort] = ACTIONS(4781),
    [sym_int] = ACTIONS(4781),
    [sym_uint] = ACTIONS(4781),
    [sym_long] = ACTIONS(4781),
    [sym_ulong] = ACTIONS(4781),
    [sym_cent] = ACTIONS(4781),
    [sym_ucent] = ACTIONS(4781),
    [sym_wchar] = ACTIONS(4781),
    [sym_dchar] = ACTIONS(4781),
    [sym_float] = ACTIONS(4781),
    [sym_double] = ACTIONS(4781),
    [sym_real] = ACTIONS(4781),
    [sym_ifloat] = ACTIONS(4781),
    [sym_idouble] = ACTIONS(4781),
    [sym_ireal] = ACTIONS(4781),
    [sym_cfloat] = ACTIONS(4781),
    [sym_cdouble] = ACTIONS(4781),
    [sym_creal] = ACTIONS(4781),
    [sym_size_t] = ACTIONS(4781),
    [sym_ptrdiff_t] = ACTIONS(4781),
    [sym_string] = ACTIONS(4781),
    [sym_cstring] = ACTIONS(4781),
    [sym_dstring] = ACTIONS(4781),
    [sym_wstring] = ACTIONS(4781),
    [sym_noreturn] = ACTIONS(4781),
    [sym_this] = ACTIONS(4781),
    [sym_abstract] = ACTIONS(4781),
    [sym_alias] = ACTIONS(4781),
    [sym_align] = ACTIONS(4781),
    [sym_auto] = ACTIONS(4781),
    [sym_catch] = ACTIONS(4781),
    [sym_class] = ACTIONS(4781),
    [sym_const] = ACTIONS(4781),
    [sym_debug] = ACTIONS(4781),
    [sym_deprecated] = ACTIONS(4781),
    [sym_do] = ACTIONS(4781),
    [sym_else] = ACTIONS(4781),
    [sym_enum] = ACTIONS(4781),
    [sym_export] = ACTIONS(4781),
    [sym_extern] = ACTIONS(4781),
    [sym_final] = ACTIONS(4781),
    [sym_finally] = ACTIONS(4781),
    [sym_immutable] = ACTIONS(4781),
    [sym_import] = ACTIONS(4781),
    [sym_in] = ACTIONS(4781),
    [sym_inout] = ACTIONS(4781),
    [sym_interface] = ACTIONS(4781),
    [sym_invariant] = ACTIONS(4781),
    [sym_mixin] = ACTIONS(4781),
    [sym_nothrow] = ACTIONS(4781),
    [sym_out] = ACTIONS(4781),
    [sym_override] = ACTIONS(4781),
    [sym_package] = ACTIONS(4781),
    [sym_pragma] = ACTIONS(4781),
    [sym_private] = ACTIONS(4781),
    [sym_protected] = ACTIONS(4781),
    [sym_public] = ACTIONS(4781),
    [sym_pure] = ACTIONS(4781),
    [sym_ref] = ACTIONS(4781),
    [sym_return] = ACTIONS(4781),
    [sym_scope] = ACTIONS(4781),
    [sym_shared] = ACTIONS(4781),
    [sym_static] = ACTIONS(4781),
    [sym_struct] = ACTIONS(4781),
    [sym_synchronized] = ACTIONS(4781),
    [sym_template] = ACTIONS(4781),
    [sym_typeof] = ACTIONS(4781),
    [sym_union] = ACTIONS(4781),
    [sym_unittest] = ACTIONS(4781),
    [sym_version] = ACTIONS(4781),
    [sym_while] = ACTIONS(4781),
    [sym_gshared] = ACTIONS(4781),
    [sym_traits] = ACTIONS(4781),
    [sym_vector] = ACTIONS(4781),
    [sym_void] = ACTIONS(4781),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2188] = {
    [sym_identifier] = ACTIONS(4777),
    [anon_sym_LBRACE] = ACTIONS(4779),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4779),
    [anon_sym_TILDE] = ACTIONS(4779),
    [anon_sym_AT] = ACTIONS(4779),
    [sym_bool] = ACTIONS(4777),
    [sym_byte] = ACTIONS(4777),
    [sym_ubyte] = ACTIONS(4777),
    [sym_char] = ACTIONS(4777),
    [sym_short] = ACTIONS(4777),
    [sym_ushort] = ACTIONS(4777),
    [sym_int] = ACTIONS(4777),
    [sym_uint] = ACTIONS(4777),
    [sym_long] = ACTIONS(4777),
    [sym_ulong] = ACTIONS(4777),
    [sym_cent] = ACTIONS(4777),
    [sym_ucent] = ACTIONS(4777),
    [sym_wchar] = ACTIONS(4777),
    [sym_dchar] = ACTIONS(4777),
    [sym_float] = ACTIONS(4777),
    [sym_double] = ACTIONS(4777),
    [sym_real] = ACTIONS(4777),
    [sym_ifloat] = ACTIONS(4777),
    [sym_idouble] = ACTIONS(4777),
    [sym_ireal] = ACTIONS(4777),
    [sym_cfloat] = ACTIONS(4777),
    [sym_cdouble] = ACTIONS(4777),
    [sym_creal] = ACTIONS(4777),
    [sym_size_t] = ACTIONS(4777),
    [sym_ptrdiff_t] = ACTIONS(4777),
    [sym_string] = ACTIONS(4777),
    [sym_cstring] = ACTIONS(4777),
    [sym_dstring] = ACTIONS(4777),
    [sym_wstring] = ACTIONS(4777),
    [sym_noreturn] = ACTIONS(4777),
    [sym_this] = ACTIONS(4777),
    [sym_abstract] = ACTIONS(4777),
    [sym_alias] = ACTIONS(4777),
    [sym_align] = ACTIONS(4777),
    [sym_auto] = ACTIONS(4777),
    [sym_catch] = ACTIONS(4777),
    [sym_class] = ACTIONS(4777),
    [sym_const] = ACTIONS(4777),
    [sym_debug] = ACTIONS(4777),
    [sym_deprecated] = ACTIONS(4777),
    [sym_do] = ACTIONS(4777),
    [sym_else] = ACTIONS(4777),
    [sym_enum] = ACTIONS(4777),
    [sym_export] = ACTIONS(4777),
    [sym_extern] = ACTIONS(4777),
    [sym_final] = ACTIONS(4777),
    [sym_finally] = ACTIONS(4777),
    [sym_immutable] = ACTIONS(4777),
    [sym_import] = ACTIONS(4777),
    [sym_in] = ACTIONS(4777),
    [sym_inout] = ACTIONS(4777),
    [sym_interface] = ACTIONS(4777),
    [sym_invariant] = ACTIONS(4777),
    [sym_mixin] = ACTIONS(4777),
    [sym_nothrow] = ACTIONS(4777),
    [sym_out] = ACTIONS(4777),
    [sym_override] = ACTIONS(4777),
    [sym_package] = ACTIONS(4777),
    [sym_pragma] = ACTIONS(4777),
    [sym_private] = ACTIONS(4777),
    [sym_protected] = ACTIONS(4777),
    [sym_public] = ACTIONS(4777),
    [sym_pure] = ACTIONS(4777),
    [sym_ref] = ACTIONS(4777),
    [sym_return] = ACTIONS(4777),
    [sym_scope] = ACTIONS(4777),
    [sym_shared] = ACTIONS(4777),
    [sym_static] = ACTIONS(4777),
    [sym_struct] = ACTIONS(4777),
    [sym_synchronized] = ACTIONS(4777),
    [sym_template] = ACTIONS(4777),
    [sym_typeof] = ACTIONS(4777),
    [sym_union] = ACTIONS(4777),
    [sym_unittest] = ACTIONS(4777),
    [sym_version] = ACTIONS(4777),
    [sym_while] = ACTIONS(4777),
    [sym_gshared] = ACTIONS(4777),
    [sym_traits] = ACTIONS(4777),
    [sym_vector] = ACTIONS(4777),
    [sym_void] = ACTIONS(4777),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2189] = {
    [sym_assert_expression] = STATE(6326),
    [sym__foreach] = STATE(6325),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6042),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6044),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6046),
    [sym_foreach_reverse] = ACTIONS(6046),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2190] = {
    [sym_assert_expression] = STATE(6326),
    [sym__foreach] = STATE(6553),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6034),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6036),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6050),
    [sym_foreach_reverse] = ACTIONS(6050),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2191] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6522),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6052),
    [sym_foreach_reverse] = ACTIONS(6052),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2192] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_catch] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_do] = ACTIONS(6056),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_finally] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(6056),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_out] = ACTIONS(6056),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2193] = {
    [ts_builtin_sym_end] = ACTIONS(4779),
    [sym_identifier] = ACTIONS(4777),
    [anon_sym_RBRACE] = ACTIONS(4779),
    [anon_sym_LBRACE] = ACTIONS(4779),
    [anon_sym_DOT] = ACTIONS(4779),
    [anon_sym_SEMI] = ACTIONS(4779),
    [anon_sym_TILDE] = ACTIONS(4779),
    [anon_sym_AT] = ACTIONS(4779),
    [sym_bool] = ACTIONS(4777),
    [sym_byte] = ACTIONS(4777),
    [sym_ubyte] = ACTIONS(4777),
    [sym_char] = ACTIONS(4777),
    [sym_short] = ACTIONS(4777),
    [sym_ushort] = ACTIONS(4777),
    [sym_int] = ACTIONS(4777),
    [sym_uint] = ACTIONS(4777),
    [sym_long] = ACTIONS(4777),
    [sym_ulong] = ACTIONS(4777),
    [sym_cent] = ACTIONS(4777),
    [sym_ucent] = ACTIONS(4777),
    [sym_wchar] = ACTIONS(4777),
    [sym_dchar] = ACTIONS(4777),
    [sym_float] = ACTIONS(4777),
    [sym_double] = ACTIONS(4777),
    [sym_real] = ACTIONS(4777),
    [sym_ifloat] = ACTIONS(4777),
    [sym_idouble] = ACTIONS(4777),
    [sym_ireal] = ACTIONS(4777),
    [sym_cfloat] = ACTIONS(4777),
    [sym_cdouble] = ACTIONS(4777),
    [sym_creal] = ACTIONS(4777),
    [sym_size_t] = ACTIONS(4777),
    [sym_ptrdiff_t] = ACTIONS(4777),
    [sym_string] = ACTIONS(4777),
    [sym_cstring] = ACTIONS(4777),
    [sym_dstring] = ACTIONS(4777),
    [sym_wstring] = ACTIONS(4777),
    [sym_noreturn] = ACTIONS(4777),
    [sym_this] = ACTIONS(4777),
    [sym_abstract] = ACTIONS(4777),
    [sym_alias] = ACTIONS(4777),
    [sym_align] = ACTIONS(4777),
    [sym_auto] = ACTIONS(4777),
    [sym_class] = ACTIONS(4777),
    [sym_const] = ACTIONS(4777),
    [sym_debug] = ACTIONS(4777),
    [sym_deprecated] = ACTIONS(4777),
    [sym_do] = ACTIONS(4777),
    [sym_else] = ACTIONS(4777),
    [sym_enum] = ACTIONS(4777),
    [sym_export] = ACTIONS(4777),
    [sym_extern] = ACTIONS(4777),
    [sym_final] = ACTIONS(4777),
    [sym_immutable] = ACTIONS(4777),
    [sym_import] = ACTIONS(4777),
    [sym_in] = ACTIONS(4777),
    [sym_inout] = ACTIONS(4777),
    [sym_interface] = ACTIONS(4777),
    [sym_invariant] = ACTIONS(4777),
    [sym_mixin] = ACTIONS(4777),
    [sym_nothrow] = ACTIONS(4777),
    [sym_out] = ACTIONS(4777),
    [sym_override] = ACTIONS(4777),
    [sym_package] = ACTIONS(4777),
    [sym_pragma] = ACTIONS(4777),
    [sym_private] = ACTIONS(4777),
    [sym_protected] = ACTIONS(4777),
    [sym_public] = ACTIONS(4777),
    [sym_pure] = ACTIONS(4777),
    [sym_ref] = ACTIONS(4777),
    [sym_return] = ACTIONS(4777),
    [sym_scope] = ACTIONS(4777),
    [sym_shared] = ACTIONS(4777),
    [sym_static] = ACTIONS(4777),
    [sym_struct] = ACTIONS(4777),
    [sym_synchronized] = ACTIONS(4777),
    [sym_template] = ACTIONS(4777),
    [sym_typeof] = ACTIONS(4777),
    [sym_union] = ACTIONS(4777),
    [sym_unittest] = ACTIONS(4777),
    [sym_version] = ACTIONS(4777),
    [sym_while] = ACTIONS(4777),
    [sym_gshared] = ACTIONS(4777),
    [sym_traits] = ACTIONS(4777),
    [sym_vector] = ACTIONS(4777),
    [sym_void] = ACTIONS(4777),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2194] = {
    [sym_assert_expression] = STATE(6281),
    [sym__foreach] = STATE(6502),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6012),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6014),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6058),
    [sym_foreach_reverse] = ACTIONS(6058),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2195] = {
    [sym_assert_expression] = STATE(6532),
    [sym__foreach] = STATE(6483),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6006),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6008),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6060),
    [sym_foreach_reverse] = ACTIONS(6060),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2196] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6519),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6062),
    [sym_foreach_reverse] = ACTIONS(6062),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2197] = {
    [sym_assert_expression] = STATE(5625),
    [sym__foreach] = STATE(6511),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6024),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6026),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6064),
    [sym_foreach_reverse] = ACTIONS(6064),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2198] = {
    [ts_builtin_sym_end] = ACTIONS(4516),
    [sym_identifier] = ACTIONS(4514),
    [anon_sym_RBRACE] = ACTIONS(4516),
    [anon_sym_LBRACE] = ACTIONS(4516),
    [anon_sym_DOT] = ACTIONS(4516),
    [anon_sym_SEMI] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4516),
    [anon_sym_AT] = ACTIONS(4516),
    [sym_bool] = ACTIONS(4514),
    [sym_byte] = ACTIONS(4514),
    [sym_ubyte] = ACTIONS(4514),
    [sym_char] = ACTIONS(4514),
    [sym_short] = ACTIONS(4514),
    [sym_ushort] = ACTIONS(4514),
    [sym_int] = ACTIONS(4514),
    [sym_uint] = ACTIONS(4514),
    [sym_long] = ACTIONS(4514),
    [sym_ulong] = ACTIONS(4514),
    [sym_cent] = ACTIONS(4514),
    [sym_ucent] = ACTIONS(4514),
    [sym_wchar] = ACTIONS(4514),
    [sym_dchar] = ACTIONS(4514),
    [sym_float] = ACTIONS(4514),
    [sym_double] = ACTIONS(4514),
    [sym_real] = ACTIONS(4514),
    [sym_ifloat] = ACTIONS(4514),
    [sym_idouble] = ACTIONS(4514),
    [sym_ireal] = ACTIONS(4514),
    [sym_cfloat] = ACTIONS(4514),
    [sym_cdouble] = ACTIONS(4514),
    [sym_creal] = ACTIONS(4514),
    [sym_size_t] = ACTIONS(4514),
    [sym_ptrdiff_t] = ACTIONS(4514),
    [sym_string] = ACTIONS(4514),
    [sym_cstring] = ACTIONS(4514),
    [sym_dstring] = ACTIONS(4514),
    [sym_wstring] = ACTIONS(4514),
    [sym_noreturn] = ACTIONS(4514),
    [sym_this] = ACTIONS(4514),
    [sym_abstract] = ACTIONS(4514),
    [sym_alias] = ACTIONS(4514),
    [sym_align] = ACTIONS(4514),
    [sym_auto] = ACTIONS(4514),
    [sym_class] = ACTIONS(4514),
    [sym_const] = ACTIONS(4514),
    [sym_debug] = ACTIONS(4514),
    [sym_deprecated] = ACTIONS(4514),
    [sym_do] = ACTIONS(4514),
    [sym_else] = ACTIONS(4514),
    [sym_enum] = ACTIONS(4514),
    [sym_export] = ACTIONS(4514),
    [sym_extern] = ACTIONS(4514),
    [sym_final] = ACTIONS(4514),
    [sym_immutable] = ACTIONS(4514),
    [sym_import] = ACTIONS(4514),
    [sym_in] = ACTIONS(4514),
    [sym_inout] = ACTIONS(4514),
    [sym_interface] = ACTIONS(4514),
    [sym_invariant] = ACTIONS(4514),
    [sym_mixin] = ACTIONS(4514),
    [sym_nothrow] = ACTIONS(4514),
    [sym_out] = ACTIONS(4514),
    [sym_override] = ACTIONS(4514),
    [sym_package] = ACTIONS(4514),
    [sym_pragma] = ACTIONS(4514),
    [sym_private] = ACTIONS(4514),
    [sym_protected] = ACTIONS(4514),
    [sym_public] = ACTIONS(4514),
    [sym_pure] = ACTIONS(4514),
    [sym_ref] = ACTIONS(4514),
    [sym_return] = ACTIONS(4514),
    [sym_scope] = ACTIONS(4514),
    [sym_shared] = ACTIONS(4514),
    [sym_static] = ACTIONS(4514),
    [sym_struct] = ACTIONS(4514),
    [sym_synchronized] = ACTIONS(4514),
    [sym_template] = ACTIONS(4514),
    [sym_typeof] = ACTIONS(4514),
    [sym_union] = ACTIONS(4514),
    [sym_unittest] = ACTIONS(4514),
    [sym_version] = ACTIONS(4514),
    [sym_while] = ACTIONS(4514),
    [sym_gshared] = ACTIONS(4514),
    [sym_traits] = ACTIONS(4514),
    [sym_vector] = ACTIONS(4514),
    [sym_void] = ACTIONS(4514),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2199] = {
    [ts_builtin_sym_end] = ACTIONS(4881),
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4965),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_do] = ACTIONS(6056),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_in] = ACTIONS(6056),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_out] = ACTIONS(6056),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2200] = {
    [sym_identifier] = ACTIONS(3127),
    [anon_sym_LBRACE] = ACTIONS(3129),
    [anon_sym_DOT] = ACTIONS(3129),
    [anon_sym_SEMI] = ACTIONS(3129),
    [anon_sym_TILDE] = ACTIONS(3129),
    [anon_sym_AT] = ACTIONS(3129),
    [sym_bool] = ACTIONS(3127),
    [sym_byte] = ACTIONS(3127),
    [sym_ubyte] = ACTIONS(3127),
    [sym_char] = ACTIONS(3127),
    [sym_short] = ACTIONS(3127),
    [sym_ushort] = ACTIONS(3127),
    [sym_int] = ACTIONS(3127),
    [sym_uint] = ACTIONS(3127),
    [sym_long] = ACTIONS(3127),
    [sym_ulong] = ACTIONS(3127),
    [sym_cent] = ACTIONS(3127),
    [sym_ucent] = ACTIONS(3127),
    [sym_wchar] = ACTIONS(3127),
    [sym_dchar] = ACTIONS(3127),
    [sym_float] = ACTIONS(3127),
    [sym_double] = ACTIONS(3127),
    [sym_real] = ACTIONS(3127),
    [sym_ifloat] = ACTIONS(3127),
    [sym_idouble] = ACTIONS(3127),
    [sym_ireal] = ACTIONS(3127),
    [sym_cfloat] = ACTIONS(3127),
    [sym_cdouble] = ACTIONS(3127),
    [sym_creal] = ACTIONS(3127),
    [sym_size_t] = ACTIONS(3127),
    [sym_ptrdiff_t] = ACTIONS(3127),
    [sym_string] = ACTIONS(3127),
    [sym_cstring] = ACTIONS(3127),
    [sym_dstring] = ACTIONS(3127),
    [sym_wstring] = ACTIONS(3127),
    [sym_noreturn] = ACTIONS(3127),
    [sym_this] = ACTIONS(3127),
    [sym_abstract] = ACTIONS(3127),
    [sym_alias] = ACTIONS(3127),
    [sym_align] = ACTIONS(3127),
    [sym_auto] = ACTIONS(3127),
    [sym_catch] = ACTIONS(3127),
    [sym_class] = ACTIONS(3127),
    [sym_const] = ACTIONS(3127),
    [sym_debug] = ACTIONS(3127),
    [sym_deprecated] = ACTIONS(3127),
    [sym_do] = ACTIONS(3127),
    [sym_else] = ACTIONS(3127),
    [sym_enum] = ACTIONS(3127),
    [sym_export] = ACTIONS(3127),
    [sym_extern] = ACTIONS(3127),
    [sym_final] = ACTIONS(3127),
    [sym_finally] = ACTIONS(3127),
    [sym_immutable] = ACTIONS(3127),
    [sym_import] = ACTIONS(3127),
    [sym_in] = ACTIONS(3127),
    [sym_inout] = ACTIONS(3127),
    [sym_interface] = ACTIONS(3127),
    [sym_invariant] = ACTIONS(3127),
    [sym_mixin] = ACTIONS(3127),
    [sym_nothrow] = ACTIONS(3127),
    [sym_out] = ACTIONS(3127),
    [sym_override] = ACTIONS(3127),
    [sym_package] = ACTIONS(3127),
    [sym_pragma] = ACTIONS(3127),
    [sym_private] = ACTIONS(3127),
    [sym_protected] = ACTIONS(3127),
    [sym_public] = ACTIONS(3127),
    [sym_pure] = ACTIONS(3127),
    [sym_ref] = ACTIONS(3127),
    [sym_return] = ACTIONS(3127),
    [sym_scope] = ACTIONS(3127),
    [sym_shared] = ACTIONS(3127),
    [sym_static] = ACTIONS(3127),
    [sym_struct] = ACTIONS(3127),
    [sym_synchronized] = ACTIONS(3127),
    [sym_template] = ACTIONS(3127),
    [sym_typeof] = ACTIONS(3127),
    [sym_union] = ACTIONS(3127),
    [sym_unittest] = ACTIONS(3127),
    [sym_version] = ACTIONS(3127),
    [sym_while] = ACTIONS(3127),
    [sym_gshared] = ACTIONS(3127),
    [sym_traits] = ACTIONS(3127),
    [sym_vector] = ACTIONS(3127),
    [sym_void] = ACTIONS(3127),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2201] = {
    [sym_assert_expression] = STATE(5625),
    [sym__foreach] = STATE(6516),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(6066),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(6068),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_foreach] = ACTIONS(6070),
    [sym_foreach_reverse] = ACTIONS(6070),
    [sym_if] = ACTIONS(6048),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2202] = {
    [ts_builtin_sym_end] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_do] = ACTIONS(6056),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(6056),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_out] = ACTIONS(6056),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2203] = {
    [sym_identifier] = ACTIONS(3163),
    [anon_sym_LBRACE] = ACTIONS(3165),
    [anon_sym_DOT] = ACTIONS(3165),
    [anon_sym_SEMI] = ACTIONS(3165),
    [anon_sym_TILDE] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [sym_bool] = ACTIONS(3163),
    [sym_byte] = ACTIONS(3163),
    [sym_ubyte] = ACTIONS(3163),
    [sym_char] = ACTIONS(3163),
    [sym_short] = ACTIONS(3163),
    [sym_ushort] = ACTIONS(3163),
    [sym_int] = ACTIONS(3163),
    [sym_uint] = ACTIONS(3163),
    [sym_long] = ACTIONS(3163),
    [sym_ulong] = ACTIONS(3163),
    [sym_cent] = ACTIONS(3163),
    [sym_ucent] = ACTIONS(3163),
    [sym_wchar] = ACTIONS(3163),
    [sym_dchar] = ACTIONS(3163),
    [sym_float] = ACTIONS(3163),
    [sym_double] = ACTIONS(3163),
    [sym_real] = ACTIONS(3163),
    [sym_ifloat] = ACTIONS(3163),
    [sym_idouble] = ACTIONS(3163),
    [sym_ireal] = ACTIONS(3163),
    [sym_cfloat] = ACTIONS(3163),
    [sym_cdouble] = ACTIONS(3163),
    [sym_creal] = ACTIONS(3163),
    [sym_size_t] = ACTIONS(3163),
    [sym_ptrdiff_t] = ACTIONS(3163),
    [sym_string] = ACTIONS(3163),
    [sym_cstring] = ACTIONS(3163),
    [sym_dstring] = ACTIONS(3163),
    [sym_wstring] = ACTIONS(3163),
    [sym_noreturn] = ACTIONS(3163),
    [sym_this] = ACTIONS(3163),
    [sym_abstract] = ACTIONS(3163),
    [sym_alias] = ACTIONS(3163),
    [sym_align] = ACTIONS(3163),
    [sym_auto] = ACTIONS(3163),
    [sym_catch] = ACTIONS(3163),
    [sym_class] = ACTIONS(3163),
    [sym_const] = ACTIONS(3163),
    [sym_debug] = ACTIONS(3163),
    [sym_deprecated] = ACTIONS(3163),
    [sym_do] = ACTIONS(3163),
    [sym_else] = ACTIONS(3163),
    [sym_enum] = ACTIONS(3163),
    [sym_export] = ACTIONS(3163),
    [sym_extern] = ACTIONS(3163),
    [sym_final] = ACTIONS(3163),
    [sym_finally] = ACTIONS(3163),
    [sym_immutable] = ACTIONS(3163),
    [sym_import] = ACTIONS(3163),
    [sym_in] = ACTIONS(3163),
    [sym_inout] = ACTIONS(3163),
    [sym_interface] = ACTIONS(3163),
    [sym_invariant] = ACTIONS(3163),
    [sym_mixin] = ACTIONS(3163),
    [sym_nothrow] = ACTIONS(3163),
    [sym_out] = ACTIONS(3163),
    [sym_override] = ACTIONS(3163),
    [sym_package] = ACTIONS(3163),
    [sym_pragma] = ACTIONS(3163),
    [sym_private] = ACTIONS(3163),
    [sym_protected] = ACTIONS(3163),
    [sym_public] = ACTIONS(3163),
    [sym_pure] = ACTIONS(3163),
    [sym_ref] = ACTIONS(3163),
    [sym_return] = ACTIONS(3163),
    [sym_scope] = ACTIONS(3163),
    [sym_shared] = ACTIONS(3163),
    [sym_static] = ACTIONS(3163),
    [sym_struct] = ACTIONS(3163),
    [sym_synchronized] = ACTIONS(3163),
    [sym_template] = ACTIONS(3163),
    [sym_typeof] = ACTIONS(3163),
    [sym_union] = ACTIONS(3163),
    [sym_unittest] = ACTIONS(3163),
    [sym_version] = ACTIONS(3163),
    [sym_while] = ACTIONS(3163),
    [sym_gshared] = ACTIONS(3163),
    [sym_traits] = ACTIONS(3163),
    [sym_vector] = ACTIONS(3163),
    [sym_void] = ACTIONS(3163),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2204] = {
    [sym_identifier] = ACTIONS(3176),
    [anon_sym_LBRACE] = ACTIONS(3178),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_SEMI] = ACTIONS(3178),
    [anon_sym_TILDE] = ACTIONS(3178),
    [anon_sym_AT] = ACTIONS(3178),
    [sym_bool] = ACTIONS(3176),
    [sym_byte] = ACTIONS(3176),
    [sym_ubyte] = ACTIONS(3176),
    [sym_char] = ACTIONS(3176),
    [sym_short] = ACTIONS(3176),
    [sym_ushort] = ACTIONS(3176),
    [sym_int] = ACTIONS(3176),
    [sym_uint] = ACTIONS(3176),
    [sym_long] = ACTIONS(3176),
    [sym_ulong] = ACTIONS(3176),
    [sym_cent] = ACTIONS(3176),
    [sym_ucent] = ACTIONS(3176),
    [sym_wchar] = ACTIONS(3176),
    [sym_dchar] = ACTIONS(3176),
    [sym_float] = ACTIONS(3176),
    [sym_double] = ACTIONS(3176),
    [sym_real] = ACTIONS(3176),
    [sym_ifloat] = ACTIONS(3176),
    [sym_idouble] = ACTIONS(3176),
    [sym_ireal] = ACTIONS(3176),
    [sym_cfloat] = ACTIONS(3176),
    [sym_cdouble] = ACTIONS(3176),
    [sym_creal] = ACTIONS(3176),
    [sym_size_t] = ACTIONS(3176),
    [sym_ptrdiff_t] = ACTIONS(3176),
    [sym_string] = ACTIONS(3176),
    [sym_cstring] = ACTIONS(3176),
    [sym_dstring] = ACTIONS(3176),
    [sym_wstring] = ACTIONS(3176),
    [sym_noreturn] = ACTIONS(3176),
    [sym_this] = ACTIONS(3176),
    [sym_abstract] = ACTIONS(3176),
    [sym_alias] = ACTIONS(3176),
    [sym_align] = ACTIONS(3176),
    [sym_auto] = ACTIONS(3176),
    [sym_catch] = ACTIONS(3176),
    [sym_class] = ACTIONS(3176),
    [sym_const] = ACTIONS(3176),
    [sym_debug] = ACTIONS(3176),
    [sym_deprecated] = ACTIONS(3176),
    [sym_do] = ACTIONS(3176),
    [sym_else] = ACTIONS(3176),
    [sym_enum] = ACTIONS(3176),
    [sym_export] = ACTIONS(3176),
    [sym_extern] = ACTIONS(3176),
    [sym_final] = ACTIONS(3176),
    [sym_finally] = ACTIONS(3176),
    [sym_immutable] = ACTIONS(3176),
    [sym_import] = ACTIONS(3176),
    [sym_in] = ACTIONS(3176),
    [sym_inout] = ACTIONS(3176),
    [sym_interface] = ACTIONS(3176),
    [sym_invariant] = ACTIONS(3176),
    [sym_mixin] = ACTIONS(3176),
    [sym_nothrow] = ACTIONS(3176),
    [sym_out] = ACTIONS(3176),
    [sym_override] = ACTIONS(3176),
    [sym_package] = ACTIONS(3176),
    [sym_pragma] = ACTIONS(3176),
    [sym_private] = ACTIONS(3176),
    [sym_protected] = ACTIONS(3176),
    [sym_public] = ACTIONS(3176),
    [sym_pure] = ACTIONS(3176),
    [sym_ref] = ACTIONS(3176),
    [sym_return] = ACTIONS(3176),
    [sym_scope] = ACTIONS(3176),
    [sym_shared] = ACTIONS(3176),
    [sym_static] = ACTIONS(3176),
    [sym_struct] = ACTIONS(3176),
    [sym_synchronized] = ACTIONS(3176),
    [sym_template] = ACTIONS(3176),
    [sym_typeof] = ACTIONS(3176),
    [sym_union] = ACTIONS(3176),
    [sym_unittest] = ACTIONS(3176),
    [sym_version] = ACTIONS(3176),
    [sym_while] = ACTIONS(3176),
    [sym_gshared] = ACTIONS(3176),
    [sym_traits] = ACTIONS(3176),
    [sym_vector] = ACTIONS(3176),
    [sym_void] = ACTIONS(3176),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2205] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_LBRACE] = ACTIONS(6054),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4759),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_catch] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_do] = ACTIONS(6056),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_finally] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_in] = ACTIONS(6056),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_out] = ACTIONS(6056),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2206] = {
    [sym_at_attribute] = STATE(4659),
    [aux_sym_module_declaration_repeat1] = STATE(4659),
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(6072),
    [sym_bool] = ACTIONS(3019),
    [sym_byte] = ACTIONS(3019),
    [sym_ubyte] = ACTIONS(3019),
    [sym_char] = ACTIONS(3019),
    [sym_short] = ACTIONS(3019),
    [sym_ushort] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_uint] = ACTIONS(3019),
    [sym_long] = ACTIONS(3019),
    [sym_ulong] = ACTIONS(3019),
    [sym_cent] = ACTIONS(3019),
    [sym_ucent] = ACTIONS(3019),
    [sym_wchar] = ACTIONS(3019),
    [sym_dchar] = ACTIONS(3019),
    [sym_float] = ACTIONS(3019),
    [sym_double] = ACTIONS(3019),
    [sym_real] = ACTIONS(3019),
    [sym_ifloat] = ACTIONS(3019),
    [sym_idouble] = ACTIONS(3019),
    [sym_ireal] = ACTIONS(3019),
    [sym_cfloat] = ACTIONS(3019),
    [sym_cdouble] = ACTIONS(3019),
    [sym_creal] = ACTIONS(3019),
    [sym_size_t] = ACTIONS(3019),
    [sym_ptrdiff_t] = ACTIONS(3019),
    [sym_string] = ACTIONS(3019),
    [sym_cstring] = ACTIONS(3019),
    [sym_dstring] = ACTIONS(3019),
    [sym_wstring] = ACTIONS(3019),
    [sym_noreturn] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_auto] = ACTIONS(3019),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(3019),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(3019),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_immutable] = ACTIONS(3019),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(3019),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(3019),
    [sym_module] = ACTIONS(6074),
    [sym_nothrow] = ACTIONS(3019),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3019),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(3019),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(3019),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(3019),
    [sym_vector] = ACTIONS(3019),
    [sym_void] = ACTIONS(3019),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2207] = {
    [sym__parameter_with_member_attributes] = STATE(4133),
    [sym__parameters] = STATE(3945),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2208] = {
    [ts_builtin_sym_end] = ACTIONS(4718),
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_RBRACE] = ACTIONS(4718),
    [anon_sym_DOT] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_AT] = ACTIONS(4718),
    [sym_bool] = ACTIONS(4715),
    [sym_byte] = ACTIONS(4715),
    [sym_ubyte] = ACTIONS(4715),
    [sym_char] = ACTIONS(4715),
    [sym_short] = ACTIONS(4715),
    [sym_ushort] = ACTIONS(4715),
    [sym_int] = ACTIONS(4715),
    [sym_uint] = ACTIONS(4715),
    [sym_long] = ACTIONS(4715),
    [sym_ulong] = ACTIONS(4715),
    [sym_cent] = ACTIONS(4715),
    [sym_ucent] = ACTIONS(4715),
    [sym_wchar] = ACTIONS(4715),
    [sym_dchar] = ACTIONS(4715),
    [sym_float] = ACTIONS(4715),
    [sym_double] = ACTIONS(4715),
    [sym_real] = ACTIONS(4715),
    [sym_ifloat] = ACTIONS(4715),
    [sym_idouble] = ACTIONS(4715),
    [sym_ireal] = ACTIONS(4715),
    [sym_cfloat] = ACTIONS(4715),
    [sym_cdouble] = ACTIONS(4715),
    [sym_creal] = ACTIONS(4715),
    [sym_size_t] = ACTIONS(4715),
    [sym_ptrdiff_t] = ACTIONS(4715),
    [sym_string] = ACTIONS(4715),
    [sym_cstring] = ACTIONS(4715),
    [sym_dstring] = ACTIONS(4715),
    [sym_wstring] = ACTIONS(4715),
    [sym_noreturn] = ACTIONS(4715),
    [sym_this] = ACTIONS(4715),
    [sym_abstract] = ACTIONS(4715),
    [sym_alias] = ACTIONS(4715),
    [sym_align] = ACTIONS(4715),
    [sym_auto] = ACTIONS(4715),
    [sym_class] = ACTIONS(4715),
    [sym_const] = ACTIONS(4715),
    [sym_debug] = ACTIONS(4715),
    [sym_deprecated] = ACTIONS(4715),
    [sym_else] = ACTIONS(4715),
    [sym_enum] = ACTIONS(4715),
    [sym_export] = ACTIONS(4715),
    [sym_extern] = ACTIONS(4715),
    [sym_final] = ACTIONS(4715),
    [sym_immutable] = ACTIONS(4715),
    [sym_import] = ACTIONS(4715),
    [sym_inout] = ACTIONS(4715),
    [sym_interface] = ACTIONS(4715),
    [sym_invariant] = ACTIONS(4715),
    [sym_mixin] = ACTIONS(4715),
    [sym_nothrow] = ACTIONS(4715),
    [sym_override] = ACTIONS(4715),
    [sym_package] = ACTIONS(4715),
    [sym_pragma] = ACTIONS(4715),
    [sym_private] = ACTIONS(4715),
    [sym_protected] = ACTIONS(4715),
    [sym_public] = ACTIONS(4715),
    [sym_pure] = ACTIONS(4715),
    [sym_ref] = ACTIONS(4715),
    [sym_return] = ACTIONS(4715),
    [sym_scope] = ACTIONS(4715),
    [sym_shared] = ACTIONS(4715),
    [sym_static] = ACTIONS(4715),
    [sym_struct] = ACTIONS(4715),
    [sym_synchronized] = ACTIONS(4715),
    [sym_template] = ACTIONS(4715),
    [sym_typeof] = ACTIONS(4715),
    [sym_union] = ACTIONS(4715),
    [sym_unittest] = ACTIONS(4715),
    [sym_version] = ACTIONS(4715),
    [sym_while] = ACTIONS(4715),
    [sym_gshared] = ACTIONS(4715),
    [sym_traits] = ACTIONS(4715),
    [sym_vector] = ACTIONS(4715),
    [sym_void] = ACTIONS(4715),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2209] = {
    [sym_identifier] = ACTIONS(4598),
    [anon_sym_DOT] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_TILDE] = ACTIONS(4600),
    [anon_sym_AT] = ACTIONS(4600),
    [sym_bool] = ACTIONS(4598),
    [sym_byte] = ACTIONS(4598),
    [sym_ubyte] = ACTIONS(4598),
    [sym_char] = ACTIONS(4598),
    [sym_short] = ACTIONS(4598),
    [sym_ushort] = ACTIONS(4598),
    [sym_int] = ACTIONS(4598),
    [sym_uint] = ACTIONS(4598),
    [sym_long] = ACTIONS(4598),
    [sym_ulong] = ACTIONS(4598),
    [sym_cent] = ACTIONS(4598),
    [sym_ucent] = ACTIONS(4598),
    [sym_wchar] = ACTIONS(4598),
    [sym_dchar] = ACTIONS(4598),
    [sym_float] = ACTIONS(4598),
    [sym_double] = ACTIONS(4598),
    [sym_real] = ACTIONS(4598),
    [sym_ifloat] = ACTIONS(4598),
    [sym_idouble] = ACTIONS(4598),
    [sym_ireal] = ACTIONS(4598),
    [sym_cfloat] = ACTIONS(4598),
    [sym_cdouble] = ACTIONS(4598),
    [sym_creal] = ACTIONS(4598),
    [sym_size_t] = ACTIONS(4598),
    [sym_ptrdiff_t] = ACTIONS(4598),
    [sym_string] = ACTIONS(4598),
    [sym_cstring] = ACTIONS(4598),
    [sym_dstring] = ACTIONS(4598),
    [sym_wstring] = ACTIONS(4598),
    [sym_noreturn] = ACTIONS(4598),
    [sym_this] = ACTIONS(4598),
    [sym_abstract] = ACTIONS(4598),
    [sym_alias] = ACTIONS(4598),
    [sym_align] = ACTIONS(4598),
    [sym_auto] = ACTIONS(4598),
    [sym_catch] = ACTIONS(4598),
    [sym_class] = ACTIONS(4598),
    [sym_const] = ACTIONS(4598),
    [sym_debug] = ACTIONS(4598),
    [sym_deprecated] = ACTIONS(4598),
    [sym_else] = ACTIONS(4598),
    [sym_enum] = ACTIONS(4598),
    [sym_export] = ACTIONS(4598),
    [sym_extern] = ACTIONS(4598),
    [sym_final] = ACTIONS(4598),
    [sym_finally] = ACTIONS(4598),
    [sym_immutable] = ACTIONS(4598),
    [sym_import] = ACTIONS(4598),
    [sym_inout] = ACTIONS(4598),
    [sym_interface] = ACTIONS(4598),
    [sym_invariant] = ACTIONS(4598),
    [sym_mixin] = ACTIONS(4598),
    [sym_nothrow] = ACTIONS(4598),
    [sym_override] = ACTIONS(4598),
    [sym_package] = ACTIONS(4598),
    [sym_pragma] = ACTIONS(4598),
    [sym_private] = ACTIONS(4598),
    [sym_protected] = ACTIONS(4598),
    [sym_public] = ACTIONS(4598),
    [sym_pure] = ACTIONS(4598),
    [sym_ref] = ACTIONS(4598),
    [sym_return] = ACTIONS(4598),
    [sym_scope] = ACTIONS(4598),
    [sym_shared] = ACTIONS(4598),
    [sym_static] = ACTIONS(4598),
    [sym_struct] = ACTIONS(4598),
    [sym_synchronized] = ACTIONS(4598),
    [sym_template] = ACTIONS(4598),
    [sym_typeof] = ACTIONS(4598),
    [sym_union] = ACTIONS(4598),
    [sym_unittest] = ACTIONS(4598),
    [sym_version] = ACTIONS(4598),
    [sym_while] = ACTIONS(4598),
    [sym_gshared] = ACTIONS(4598),
    [sym_traits] = ACTIONS(4598),
    [sym_vector] = ACTIONS(4598),
    [sym_void] = ACTIONS(4598),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2210] = {
    [ts_builtin_sym_end] = ACTIONS(4885),
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [anon_sym_AT] = ACTIONS(4885),
    [sym_bool] = ACTIONS(4883),
    [sym_byte] = ACTIONS(4883),
    [sym_ubyte] = ACTIONS(4883),
    [sym_char] = ACTIONS(4883),
    [sym_short] = ACTIONS(4883),
    [sym_ushort] = ACTIONS(4883),
    [sym_int] = ACTIONS(4883),
    [sym_uint] = ACTIONS(4883),
    [sym_long] = ACTIONS(4883),
    [sym_ulong] = ACTIONS(4883),
    [sym_cent] = ACTIONS(4883),
    [sym_ucent] = ACTIONS(4883),
    [sym_wchar] = ACTIONS(4883),
    [sym_dchar] = ACTIONS(4883),
    [sym_float] = ACTIONS(4883),
    [sym_double] = ACTIONS(4883),
    [sym_real] = ACTIONS(4883),
    [sym_ifloat] = ACTIONS(4883),
    [sym_idouble] = ACTIONS(4883),
    [sym_ireal] = ACTIONS(4883),
    [sym_cfloat] = ACTIONS(4883),
    [sym_cdouble] = ACTIONS(4883),
    [sym_creal] = ACTIONS(4883),
    [sym_size_t] = ACTIONS(4883),
    [sym_ptrdiff_t] = ACTIONS(4883),
    [sym_string] = ACTIONS(4883),
    [sym_cstring] = ACTIONS(4883),
    [sym_dstring] = ACTIONS(4883),
    [sym_wstring] = ACTIONS(4883),
    [sym_noreturn] = ACTIONS(4883),
    [sym_this] = ACTIONS(4883),
    [sym_abstract] = ACTIONS(4883),
    [sym_alias] = ACTIONS(4883),
    [sym_align] = ACTIONS(4883),
    [sym_auto] = ACTIONS(4883),
    [sym_class] = ACTIONS(4883),
    [sym_const] = ACTIONS(4883),
    [sym_debug] = ACTIONS(4883),
    [sym_deprecated] = ACTIONS(4883),
    [sym_else] = ACTIONS(4883),
    [sym_enum] = ACTIONS(4883),
    [sym_export] = ACTIONS(4883),
    [sym_extern] = ACTIONS(4883),
    [sym_final] = ACTIONS(4883),
    [sym_immutable] = ACTIONS(4883),
    [sym_import] = ACTIONS(4883),
    [sym_inout] = ACTIONS(4883),
    [sym_interface] = ACTIONS(4883),
    [sym_invariant] = ACTIONS(4883),
    [sym_mixin] = ACTIONS(4883),
    [sym_nothrow] = ACTIONS(4883),
    [sym_override] = ACTIONS(4883),
    [sym_package] = ACTIONS(4883),
    [sym_pragma] = ACTIONS(4883),
    [sym_private] = ACTIONS(4883),
    [sym_protected] = ACTIONS(4883),
    [sym_public] = ACTIONS(4883),
    [sym_pure] = ACTIONS(4883),
    [sym_ref] = ACTIONS(4883),
    [sym_return] = ACTIONS(4883),
    [sym_scope] = ACTIONS(4883),
    [sym_shared] = ACTIONS(4883),
    [sym_static] = ACTIONS(4883),
    [sym_struct] = ACTIONS(4883),
    [sym_synchronized] = ACTIONS(4883),
    [sym_template] = ACTIONS(4883),
    [sym_typeof] = ACTIONS(4883),
    [sym_union] = ACTIONS(4883),
    [sym_unittest] = ACTIONS(4883),
    [sym_version] = ACTIONS(4883),
    [sym_while] = ACTIONS(4883),
    [sym_gshared] = ACTIONS(4883),
    [sym_traits] = ACTIONS(4883),
    [sym_vector] = ACTIONS(4883),
    [sym_void] = ACTIONS(4883),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2211] = {
    [ts_builtin_sym_end] = ACTIONS(4735),
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_RBRACE] = ACTIONS(4735),
    [anon_sym_DOT] = ACTIONS(4735),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [anon_sym_AT] = ACTIONS(4735),
    [sym_bool] = ACTIONS(4733),
    [sym_byte] = ACTIONS(4733),
    [sym_ubyte] = ACTIONS(4733),
    [sym_char] = ACTIONS(4733),
    [sym_short] = ACTIONS(4733),
    [sym_ushort] = ACTIONS(4733),
    [sym_int] = ACTIONS(4733),
    [sym_uint] = ACTIONS(4733),
    [sym_long] = ACTIONS(4733),
    [sym_ulong] = ACTIONS(4733),
    [sym_cent] = ACTIONS(4733),
    [sym_ucent] = ACTIONS(4733),
    [sym_wchar] = ACTIONS(4733),
    [sym_dchar] = ACTIONS(4733),
    [sym_float] = ACTIONS(4733),
    [sym_double] = ACTIONS(4733),
    [sym_real] = ACTIONS(4733),
    [sym_ifloat] = ACTIONS(4733),
    [sym_idouble] = ACTIONS(4733),
    [sym_ireal] = ACTIONS(4733),
    [sym_cfloat] = ACTIONS(4733),
    [sym_cdouble] = ACTIONS(4733),
    [sym_creal] = ACTIONS(4733),
    [sym_size_t] = ACTIONS(4733),
    [sym_ptrdiff_t] = ACTIONS(4733),
    [sym_string] = ACTIONS(4733),
    [sym_cstring] = ACTIONS(4733),
    [sym_dstring] = ACTIONS(4733),
    [sym_wstring] = ACTIONS(4733),
    [sym_noreturn] = ACTIONS(4733),
    [sym_this] = ACTIONS(4733),
    [sym_abstract] = ACTIONS(4733),
    [sym_alias] = ACTIONS(4733),
    [sym_align] = ACTIONS(4733),
    [sym_auto] = ACTIONS(4733),
    [sym_class] = ACTIONS(4733),
    [sym_const] = ACTIONS(4733),
    [sym_debug] = ACTIONS(4733),
    [sym_deprecated] = ACTIONS(4733),
    [sym_else] = ACTIONS(4733),
    [sym_enum] = ACTIONS(4733),
    [sym_export] = ACTIONS(4733),
    [sym_extern] = ACTIONS(4733),
    [sym_final] = ACTIONS(4733),
    [sym_immutable] = ACTIONS(4733),
    [sym_import] = ACTIONS(4733),
    [sym_inout] = ACTIONS(4733),
    [sym_interface] = ACTIONS(4733),
    [sym_invariant] = ACTIONS(4733),
    [sym_mixin] = ACTIONS(4733),
    [sym_nothrow] = ACTIONS(4733),
    [sym_override] = ACTIONS(4733),
    [sym_package] = ACTIONS(4733),
    [sym_pragma] = ACTIONS(4733),
    [sym_private] = ACTIONS(4733),
    [sym_protected] = ACTIONS(4733),
    [sym_public] = ACTIONS(4733),
    [sym_pure] = ACTIONS(4733),
    [sym_ref] = ACTIONS(4733),
    [sym_return] = ACTIONS(4733),
    [sym_scope] = ACTIONS(4733),
    [sym_shared] = ACTIONS(4733),
    [sym_static] = ACTIONS(4733),
    [sym_struct] = ACTIONS(4733),
    [sym_synchronized] = ACTIONS(4733),
    [sym_template] = ACTIONS(4733),
    [sym_typeof] = ACTIONS(4733),
    [sym_union] = ACTIONS(4733),
    [sym_unittest] = ACTIONS(4733),
    [sym_version] = ACTIONS(4733),
    [sym_while] = ACTIONS(4733),
    [sym_gshared] = ACTIONS(4733),
    [sym_traits] = ACTIONS(4733),
    [sym_vector] = ACTIONS(4733),
    [sym_void] = ACTIONS(4733),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2212] = {
    [ts_builtin_sym_end] = ACTIONS(4881),
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_RBRACE] = ACTIONS(4881),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2213] = {
    [ts_builtin_sym_end] = ACTIONS(4757),
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_RBRACE] = ACTIONS(4757),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2214] = {
    [ts_builtin_sym_end] = ACTIONS(4438),
    [sym_identifier] = ACTIONS(4436),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_DOT] = ACTIONS(4438),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_TILDE] = ACTIONS(4438),
    [anon_sym_AT] = ACTIONS(4438),
    [sym_bool] = ACTIONS(4436),
    [sym_byte] = ACTIONS(4436),
    [sym_ubyte] = ACTIONS(4436),
    [sym_char] = ACTIONS(4436),
    [sym_short] = ACTIONS(4436),
    [sym_ushort] = ACTIONS(4436),
    [sym_int] = ACTIONS(4436),
    [sym_uint] = ACTIONS(4436),
    [sym_long] = ACTIONS(4436),
    [sym_ulong] = ACTIONS(4436),
    [sym_cent] = ACTIONS(4436),
    [sym_ucent] = ACTIONS(4436),
    [sym_wchar] = ACTIONS(4436),
    [sym_dchar] = ACTIONS(4436),
    [sym_float] = ACTIONS(4436),
    [sym_double] = ACTIONS(4436),
    [sym_real] = ACTIONS(4436),
    [sym_ifloat] = ACTIONS(4436),
    [sym_idouble] = ACTIONS(4436),
    [sym_ireal] = ACTIONS(4436),
    [sym_cfloat] = ACTIONS(4436),
    [sym_cdouble] = ACTIONS(4436),
    [sym_creal] = ACTIONS(4436),
    [sym_size_t] = ACTIONS(4436),
    [sym_ptrdiff_t] = ACTIONS(4436),
    [sym_string] = ACTIONS(4436),
    [sym_cstring] = ACTIONS(4436),
    [sym_dstring] = ACTIONS(4436),
    [sym_wstring] = ACTIONS(4436),
    [sym_noreturn] = ACTIONS(4436),
    [sym_this] = ACTIONS(4436),
    [sym_abstract] = ACTIONS(4436),
    [sym_alias] = ACTIONS(4436),
    [sym_align] = ACTIONS(4436),
    [sym_auto] = ACTIONS(4436),
    [sym_class] = ACTIONS(4436),
    [sym_const] = ACTIONS(4436),
    [sym_debug] = ACTIONS(4436),
    [sym_deprecated] = ACTIONS(4436),
    [sym_else] = ACTIONS(4436),
    [sym_enum] = ACTIONS(4436),
    [sym_export] = ACTIONS(4436),
    [sym_extern] = ACTIONS(4436),
    [sym_final] = ACTIONS(4436),
    [sym_immutable] = ACTIONS(4436),
    [sym_import] = ACTIONS(4436),
    [sym_inout] = ACTIONS(4436),
    [sym_interface] = ACTIONS(4436),
    [sym_invariant] = ACTIONS(4436),
    [sym_mixin] = ACTIONS(4436),
    [sym_nothrow] = ACTIONS(4436),
    [sym_override] = ACTIONS(4436),
    [sym_package] = ACTIONS(4436),
    [sym_pragma] = ACTIONS(4436),
    [sym_private] = ACTIONS(4436),
    [sym_protected] = ACTIONS(4436),
    [sym_public] = ACTIONS(4436),
    [sym_pure] = ACTIONS(4436),
    [sym_ref] = ACTIONS(4436),
    [sym_return] = ACTIONS(4436),
    [sym_scope] = ACTIONS(4436),
    [sym_shared] = ACTIONS(4436),
    [sym_static] = ACTIONS(4436),
    [sym_struct] = ACTIONS(4436),
    [sym_synchronized] = ACTIONS(4436),
    [sym_template] = ACTIONS(4436),
    [sym_typeof] = ACTIONS(4436),
    [sym_union] = ACTIONS(4436),
    [sym_unittest] = ACTIONS(4436),
    [sym_version] = ACTIONS(4436),
    [sym_while] = ACTIONS(4436),
    [sym_gshared] = ACTIONS(4436),
    [sym_traits] = ACTIONS(4436),
    [sym_vector] = ACTIONS(4436),
    [sym_void] = ACTIONS(4436),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2215] = {
    [ts_builtin_sym_end] = ACTIONS(4897),
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_RBRACE] = ACTIONS(4897),
    [anon_sym_DOT] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [anon_sym_AT] = ACTIONS(4897),
    [sym_bool] = ACTIONS(4895),
    [sym_byte] = ACTIONS(4895),
    [sym_ubyte] = ACTIONS(4895),
    [sym_char] = ACTIONS(4895),
    [sym_short] = ACTIONS(4895),
    [sym_ushort] = ACTIONS(4895),
    [sym_int] = ACTIONS(4895),
    [sym_uint] = ACTIONS(4895),
    [sym_long] = ACTIONS(4895),
    [sym_ulong] = ACTIONS(4895),
    [sym_cent] = ACTIONS(4895),
    [sym_ucent] = ACTIONS(4895),
    [sym_wchar] = ACTIONS(4895),
    [sym_dchar] = ACTIONS(4895),
    [sym_float] = ACTIONS(4895),
    [sym_double] = ACTIONS(4895),
    [sym_real] = ACTIONS(4895),
    [sym_ifloat] = ACTIONS(4895),
    [sym_idouble] = ACTIONS(4895),
    [sym_ireal] = ACTIONS(4895),
    [sym_cfloat] = ACTIONS(4895),
    [sym_cdouble] = ACTIONS(4895),
    [sym_creal] = ACTIONS(4895),
    [sym_size_t] = ACTIONS(4895),
    [sym_ptrdiff_t] = ACTIONS(4895),
    [sym_string] = ACTIONS(4895),
    [sym_cstring] = ACTIONS(4895),
    [sym_dstring] = ACTIONS(4895),
    [sym_wstring] = ACTIONS(4895),
    [sym_noreturn] = ACTIONS(4895),
    [sym_this] = ACTIONS(4895),
    [sym_abstract] = ACTIONS(4895),
    [sym_alias] = ACTIONS(4895),
    [sym_align] = ACTIONS(4895),
    [sym_auto] = ACTIONS(4895),
    [sym_class] = ACTIONS(4895),
    [sym_const] = ACTIONS(4895),
    [sym_debug] = ACTIONS(4895),
    [sym_deprecated] = ACTIONS(4895),
    [sym_else] = ACTIONS(4895),
    [sym_enum] = ACTIONS(4895),
    [sym_export] = ACTIONS(4895),
    [sym_extern] = ACTIONS(4895),
    [sym_final] = ACTIONS(4895),
    [sym_immutable] = ACTIONS(4895),
    [sym_import] = ACTIONS(4895),
    [sym_inout] = ACTIONS(4895),
    [sym_interface] = ACTIONS(4895),
    [sym_invariant] = ACTIONS(4895),
    [sym_mixin] = ACTIONS(4895),
    [sym_nothrow] = ACTIONS(4895),
    [sym_override] = ACTIONS(4895),
    [sym_package] = ACTIONS(4895),
    [sym_pragma] = ACTIONS(4895),
    [sym_private] = ACTIONS(4895),
    [sym_protected] = ACTIONS(4895),
    [sym_public] = ACTIONS(4895),
    [sym_pure] = ACTIONS(4895),
    [sym_ref] = ACTIONS(4895),
    [sym_return] = ACTIONS(4895),
    [sym_scope] = ACTIONS(4895),
    [sym_shared] = ACTIONS(4895),
    [sym_static] = ACTIONS(4895),
    [sym_struct] = ACTIONS(4895),
    [sym_synchronized] = ACTIONS(4895),
    [sym_template] = ACTIONS(4895),
    [sym_typeof] = ACTIONS(4895),
    [sym_union] = ACTIONS(4895),
    [sym_unittest] = ACTIONS(4895),
    [sym_version] = ACTIONS(4895),
    [sym_while] = ACTIONS(4895),
    [sym_gshared] = ACTIONS(4895),
    [sym_traits] = ACTIONS(4895),
    [sym_vector] = ACTIONS(4895),
    [sym_void] = ACTIONS(4895),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2216] = {
    [ts_builtin_sym_end] = ACTIONS(4422),
    [sym_identifier] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4422),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_TILDE] = ACTIONS(4422),
    [anon_sym_AT] = ACTIONS(4422),
    [sym_bool] = ACTIONS(4420),
    [sym_byte] = ACTIONS(4420),
    [sym_ubyte] = ACTIONS(4420),
    [sym_char] = ACTIONS(4420),
    [sym_short] = ACTIONS(4420),
    [sym_ushort] = ACTIONS(4420),
    [sym_int] = ACTIONS(4420),
    [sym_uint] = ACTIONS(4420),
    [sym_long] = ACTIONS(4420),
    [sym_ulong] = ACTIONS(4420),
    [sym_cent] = ACTIONS(4420),
    [sym_ucent] = ACTIONS(4420),
    [sym_wchar] = ACTIONS(4420),
    [sym_dchar] = ACTIONS(4420),
    [sym_float] = ACTIONS(4420),
    [sym_double] = ACTIONS(4420),
    [sym_real] = ACTIONS(4420),
    [sym_ifloat] = ACTIONS(4420),
    [sym_idouble] = ACTIONS(4420),
    [sym_ireal] = ACTIONS(4420),
    [sym_cfloat] = ACTIONS(4420),
    [sym_cdouble] = ACTIONS(4420),
    [sym_creal] = ACTIONS(4420),
    [sym_size_t] = ACTIONS(4420),
    [sym_ptrdiff_t] = ACTIONS(4420),
    [sym_string] = ACTIONS(4420),
    [sym_cstring] = ACTIONS(4420),
    [sym_dstring] = ACTIONS(4420),
    [sym_wstring] = ACTIONS(4420),
    [sym_noreturn] = ACTIONS(4420),
    [sym_this] = ACTIONS(4420),
    [sym_abstract] = ACTIONS(4420),
    [sym_alias] = ACTIONS(4420),
    [sym_align] = ACTIONS(4420),
    [sym_auto] = ACTIONS(4420),
    [sym_class] = ACTIONS(4420),
    [sym_const] = ACTIONS(4420),
    [sym_debug] = ACTIONS(4420),
    [sym_deprecated] = ACTIONS(4420),
    [sym_else] = ACTIONS(4420),
    [sym_enum] = ACTIONS(4420),
    [sym_export] = ACTIONS(4420),
    [sym_extern] = ACTIONS(4420),
    [sym_final] = ACTIONS(4420),
    [sym_immutable] = ACTIONS(4420),
    [sym_import] = ACTIONS(4420),
    [sym_inout] = ACTIONS(4420),
    [sym_interface] = ACTIONS(4420),
    [sym_invariant] = ACTIONS(4420),
    [sym_mixin] = ACTIONS(4420),
    [sym_nothrow] = ACTIONS(4420),
    [sym_override] = ACTIONS(4420),
    [sym_package] = ACTIONS(4420),
    [sym_pragma] = ACTIONS(4420),
    [sym_private] = ACTIONS(4420),
    [sym_protected] = ACTIONS(4420),
    [sym_public] = ACTIONS(4420),
    [sym_pure] = ACTIONS(4420),
    [sym_ref] = ACTIONS(4420),
    [sym_return] = ACTIONS(4420),
    [sym_scope] = ACTIONS(4420),
    [sym_shared] = ACTIONS(4420),
    [sym_static] = ACTIONS(4420),
    [sym_struct] = ACTIONS(4420),
    [sym_synchronized] = ACTIONS(4420),
    [sym_template] = ACTIONS(4420),
    [sym_typeof] = ACTIONS(4420),
    [sym_union] = ACTIONS(4420),
    [sym_unittest] = ACTIONS(4420),
    [sym_version] = ACTIONS(4420),
    [sym_while] = ACTIONS(4420),
    [sym_gshared] = ACTIONS(4420),
    [sym_traits] = ACTIONS(4420),
    [sym_vector] = ACTIONS(4420),
    [sym_void] = ACTIONS(4420),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2217] = {
    [ts_builtin_sym_end] = ACTIONS(4414),
    [sym_identifier] = ACTIONS(4412),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_AT] = ACTIONS(4414),
    [sym_bool] = ACTIONS(4412),
    [sym_byte] = ACTIONS(4412),
    [sym_ubyte] = ACTIONS(4412),
    [sym_char] = ACTIONS(4412),
    [sym_short] = ACTIONS(4412),
    [sym_ushort] = ACTIONS(4412),
    [sym_int] = ACTIONS(4412),
    [sym_uint] = ACTIONS(4412),
    [sym_long] = ACTIONS(4412),
    [sym_ulong] = ACTIONS(4412),
    [sym_cent] = ACTIONS(4412),
    [sym_ucent] = ACTIONS(4412),
    [sym_wchar] = ACTIONS(4412),
    [sym_dchar] = ACTIONS(4412),
    [sym_float] = ACTIONS(4412),
    [sym_double] = ACTIONS(4412),
    [sym_real] = ACTIONS(4412),
    [sym_ifloat] = ACTIONS(4412),
    [sym_idouble] = ACTIONS(4412),
    [sym_ireal] = ACTIONS(4412),
    [sym_cfloat] = ACTIONS(4412),
    [sym_cdouble] = ACTIONS(4412),
    [sym_creal] = ACTIONS(4412),
    [sym_size_t] = ACTIONS(4412),
    [sym_ptrdiff_t] = ACTIONS(4412),
    [sym_string] = ACTIONS(4412),
    [sym_cstring] = ACTIONS(4412),
    [sym_dstring] = ACTIONS(4412),
    [sym_wstring] = ACTIONS(4412),
    [sym_noreturn] = ACTIONS(4412),
    [sym_this] = ACTIONS(4412),
    [sym_abstract] = ACTIONS(4412),
    [sym_alias] = ACTIONS(4412),
    [sym_align] = ACTIONS(4412),
    [sym_auto] = ACTIONS(4412),
    [sym_class] = ACTIONS(4412),
    [sym_const] = ACTIONS(4412),
    [sym_debug] = ACTIONS(4412),
    [sym_deprecated] = ACTIONS(4412),
    [sym_else] = ACTIONS(4412),
    [sym_enum] = ACTIONS(4412),
    [sym_export] = ACTIONS(4412),
    [sym_extern] = ACTIONS(4412),
    [sym_final] = ACTIONS(4412),
    [sym_immutable] = ACTIONS(4412),
    [sym_import] = ACTIONS(4412),
    [sym_inout] = ACTIONS(4412),
    [sym_interface] = ACTIONS(4412),
    [sym_invariant] = ACTIONS(4412),
    [sym_mixin] = ACTIONS(4412),
    [sym_nothrow] = ACTIONS(4412),
    [sym_override] = ACTIONS(4412),
    [sym_package] = ACTIONS(4412),
    [sym_pragma] = ACTIONS(4412),
    [sym_private] = ACTIONS(4412),
    [sym_protected] = ACTIONS(4412),
    [sym_public] = ACTIONS(4412),
    [sym_pure] = ACTIONS(4412),
    [sym_ref] = ACTIONS(4412),
    [sym_return] = ACTIONS(4412),
    [sym_scope] = ACTIONS(4412),
    [sym_shared] = ACTIONS(4412),
    [sym_static] = ACTIONS(4412),
    [sym_struct] = ACTIONS(4412),
    [sym_synchronized] = ACTIONS(4412),
    [sym_template] = ACTIONS(4412),
    [sym_typeof] = ACTIONS(4412),
    [sym_union] = ACTIONS(4412),
    [sym_unittest] = ACTIONS(4412),
    [sym_version] = ACTIONS(4412),
    [sym_while] = ACTIONS(4412),
    [sym_gshared] = ACTIONS(4412),
    [sym_traits] = ACTIONS(4412),
    [sym_vector] = ACTIONS(4412),
    [sym_void] = ACTIONS(4412),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2218] = {
    [ts_builtin_sym_end] = ACTIONS(4877),
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_RBRACE] = ACTIONS(4877),
    [anon_sym_DOT] = ACTIONS(4877),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_TILDE] = ACTIONS(4877),
    [anon_sym_AT] = ACTIONS(4877),
    [sym_bool] = ACTIONS(4875),
    [sym_byte] = ACTIONS(4875),
    [sym_ubyte] = ACTIONS(4875),
    [sym_char] = ACTIONS(4875),
    [sym_short] = ACTIONS(4875),
    [sym_ushort] = ACTIONS(4875),
    [sym_int] = ACTIONS(4875),
    [sym_uint] = ACTIONS(4875),
    [sym_long] = ACTIONS(4875),
    [sym_ulong] = ACTIONS(4875),
    [sym_cent] = ACTIONS(4875),
    [sym_ucent] = ACTIONS(4875),
    [sym_wchar] = ACTIONS(4875),
    [sym_dchar] = ACTIONS(4875),
    [sym_float] = ACTIONS(4875),
    [sym_double] = ACTIONS(4875),
    [sym_real] = ACTIONS(4875),
    [sym_ifloat] = ACTIONS(4875),
    [sym_idouble] = ACTIONS(4875),
    [sym_ireal] = ACTIONS(4875),
    [sym_cfloat] = ACTIONS(4875),
    [sym_cdouble] = ACTIONS(4875),
    [sym_creal] = ACTIONS(4875),
    [sym_size_t] = ACTIONS(4875),
    [sym_ptrdiff_t] = ACTIONS(4875),
    [sym_string] = ACTIONS(4875),
    [sym_cstring] = ACTIONS(4875),
    [sym_dstring] = ACTIONS(4875),
    [sym_wstring] = ACTIONS(4875),
    [sym_noreturn] = ACTIONS(4875),
    [sym_this] = ACTIONS(4875),
    [sym_abstract] = ACTIONS(4875),
    [sym_alias] = ACTIONS(4875),
    [sym_align] = ACTIONS(4875),
    [sym_auto] = ACTIONS(4875),
    [sym_class] = ACTIONS(4875),
    [sym_const] = ACTIONS(4875),
    [sym_debug] = ACTIONS(4875),
    [sym_deprecated] = ACTIONS(4875),
    [sym_else] = ACTIONS(4875),
    [sym_enum] = ACTIONS(4875),
    [sym_export] = ACTIONS(4875),
    [sym_extern] = ACTIONS(4875),
    [sym_final] = ACTIONS(4875),
    [sym_immutable] = ACTIONS(4875),
    [sym_import] = ACTIONS(4875),
    [sym_inout] = ACTIONS(4875),
    [sym_interface] = ACTIONS(4875),
    [sym_invariant] = ACTIONS(4875),
    [sym_mixin] = ACTIONS(4875),
    [sym_nothrow] = ACTIONS(4875),
    [sym_override] = ACTIONS(4875),
    [sym_package] = ACTIONS(4875),
    [sym_pragma] = ACTIONS(4875),
    [sym_private] = ACTIONS(4875),
    [sym_protected] = ACTIONS(4875),
    [sym_public] = ACTIONS(4875),
    [sym_pure] = ACTIONS(4875),
    [sym_ref] = ACTIONS(4875),
    [sym_return] = ACTIONS(4875),
    [sym_scope] = ACTIONS(4875),
    [sym_shared] = ACTIONS(4875),
    [sym_static] = ACTIONS(4875),
    [sym_struct] = ACTIONS(4875),
    [sym_synchronized] = ACTIONS(4875),
    [sym_template] = ACTIONS(4875),
    [sym_typeof] = ACTIONS(4875),
    [sym_union] = ACTIONS(4875),
    [sym_unittest] = ACTIONS(4875),
    [sym_version] = ACTIONS(4875),
    [sym_while] = ACTIONS(4875),
    [sym_gshared] = ACTIONS(4875),
    [sym_traits] = ACTIONS(4875),
    [sym_vector] = ACTIONS(4875),
    [sym_void] = ACTIONS(4875),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2219] = {
    [sym_switch_statement] = STATE(1495),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(796),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2220] = {
    [sym_identifier] = ACTIONS(4322),
    [anon_sym_DOT] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_TILDE] = ACTIONS(4324),
    [anon_sym_AT] = ACTIONS(4324),
    [sym_bool] = ACTIONS(4322),
    [sym_byte] = ACTIONS(4322),
    [sym_ubyte] = ACTIONS(4322),
    [sym_char] = ACTIONS(4322),
    [sym_short] = ACTIONS(4322),
    [sym_ushort] = ACTIONS(4322),
    [sym_int] = ACTIONS(4322),
    [sym_uint] = ACTIONS(4322),
    [sym_long] = ACTIONS(4322),
    [sym_ulong] = ACTIONS(4322),
    [sym_cent] = ACTIONS(4322),
    [sym_ucent] = ACTIONS(4322),
    [sym_wchar] = ACTIONS(4322),
    [sym_dchar] = ACTIONS(4322),
    [sym_float] = ACTIONS(4322),
    [sym_double] = ACTIONS(4322),
    [sym_real] = ACTIONS(4322),
    [sym_ifloat] = ACTIONS(4322),
    [sym_idouble] = ACTIONS(4322),
    [sym_ireal] = ACTIONS(4322),
    [sym_cfloat] = ACTIONS(4322),
    [sym_cdouble] = ACTIONS(4322),
    [sym_creal] = ACTIONS(4322),
    [sym_size_t] = ACTIONS(4322),
    [sym_ptrdiff_t] = ACTIONS(4322),
    [sym_string] = ACTIONS(4322),
    [sym_cstring] = ACTIONS(4322),
    [sym_dstring] = ACTIONS(4322),
    [sym_wstring] = ACTIONS(4322),
    [sym_noreturn] = ACTIONS(4322),
    [sym_this] = ACTIONS(4322),
    [sym_abstract] = ACTIONS(4322),
    [sym_alias] = ACTIONS(4322),
    [sym_align] = ACTIONS(4322),
    [sym_auto] = ACTIONS(4322),
    [sym_catch] = ACTIONS(4322),
    [sym_class] = ACTIONS(4322),
    [sym_const] = ACTIONS(4322),
    [sym_debug] = ACTIONS(4322),
    [sym_deprecated] = ACTIONS(4322),
    [sym_else] = ACTIONS(4322),
    [sym_enum] = ACTIONS(4322),
    [sym_export] = ACTIONS(4322),
    [sym_extern] = ACTIONS(4322),
    [sym_final] = ACTIONS(4322),
    [sym_finally] = ACTIONS(4322),
    [sym_immutable] = ACTIONS(4322),
    [sym_import] = ACTIONS(4322),
    [sym_inout] = ACTIONS(4322),
    [sym_interface] = ACTIONS(4322),
    [sym_invariant] = ACTIONS(4322),
    [sym_mixin] = ACTIONS(4322),
    [sym_nothrow] = ACTIONS(4322),
    [sym_override] = ACTIONS(4322),
    [sym_package] = ACTIONS(4322),
    [sym_pragma] = ACTIONS(4322),
    [sym_private] = ACTIONS(4322),
    [sym_protected] = ACTIONS(4322),
    [sym_public] = ACTIONS(4322),
    [sym_pure] = ACTIONS(4322),
    [sym_ref] = ACTIONS(4322),
    [sym_return] = ACTIONS(4322),
    [sym_scope] = ACTIONS(4322),
    [sym_shared] = ACTIONS(4322),
    [sym_static] = ACTIONS(4322),
    [sym_struct] = ACTIONS(4322),
    [sym_synchronized] = ACTIONS(4322),
    [sym_template] = ACTIONS(4322),
    [sym_typeof] = ACTIONS(4322),
    [sym_union] = ACTIONS(4322),
    [sym_unittest] = ACTIONS(4322),
    [sym_version] = ACTIONS(4322),
    [sym_while] = ACTIONS(4322),
    [sym_gshared] = ACTIONS(4322),
    [sym_traits] = ACTIONS(4322),
    [sym_vector] = ACTIONS(4322),
    [sym_void] = ACTIONS(4322),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2221] = {
    [ts_builtin_sym_end] = ACTIONS(4410),
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_AT] = ACTIONS(4410),
    [sym_bool] = ACTIONS(4408),
    [sym_byte] = ACTIONS(4408),
    [sym_ubyte] = ACTIONS(4408),
    [sym_char] = ACTIONS(4408),
    [sym_short] = ACTIONS(4408),
    [sym_ushort] = ACTIONS(4408),
    [sym_int] = ACTIONS(4408),
    [sym_uint] = ACTIONS(4408),
    [sym_long] = ACTIONS(4408),
    [sym_ulong] = ACTIONS(4408),
    [sym_cent] = ACTIONS(4408),
    [sym_ucent] = ACTIONS(4408),
    [sym_wchar] = ACTIONS(4408),
    [sym_dchar] = ACTIONS(4408),
    [sym_float] = ACTIONS(4408),
    [sym_double] = ACTIONS(4408),
    [sym_real] = ACTIONS(4408),
    [sym_ifloat] = ACTIONS(4408),
    [sym_idouble] = ACTIONS(4408),
    [sym_ireal] = ACTIONS(4408),
    [sym_cfloat] = ACTIONS(4408),
    [sym_cdouble] = ACTIONS(4408),
    [sym_creal] = ACTIONS(4408),
    [sym_size_t] = ACTIONS(4408),
    [sym_ptrdiff_t] = ACTIONS(4408),
    [sym_string] = ACTIONS(4408),
    [sym_cstring] = ACTIONS(4408),
    [sym_dstring] = ACTIONS(4408),
    [sym_wstring] = ACTIONS(4408),
    [sym_noreturn] = ACTIONS(4408),
    [sym_this] = ACTIONS(4408),
    [sym_abstract] = ACTIONS(4408),
    [sym_alias] = ACTIONS(4408),
    [sym_align] = ACTIONS(4408),
    [sym_auto] = ACTIONS(4408),
    [sym_class] = ACTIONS(4408),
    [sym_const] = ACTIONS(4408),
    [sym_debug] = ACTIONS(4408),
    [sym_deprecated] = ACTIONS(4408),
    [sym_else] = ACTIONS(4408),
    [sym_enum] = ACTIONS(4408),
    [sym_export] = ACTIONS(4408),
    [sym_extern] = ACTIONS(4408),
    [sym_final] = ACTIONS(4408),
    [sym_immutable] = ACTIONS(4408),
    [sym_import] = ACTIONS(4408),
    [sym_inout] = ACTIONS(4408),
    [sym_interface] = ACTIONS(4408),
    [sym_invariant] = ACTIONS(4408),
    [sym_mixin] = ACTIONS(4408),
    [sym_nothrow] = ACTIONS(4408),
    [sym_override] = ACTIONS(4408),
    [sym_package] = ACTIONS(4408),
    [sym_pragma] = ACTIONS(4408),
    [sym_private] = ACTIONS(4408),
    [sym_protected] = ACTIONS(4408),
    [sym_public] = ACTIONS(4408),
    [sym_pure] = ACTIONS(4408),
    [sym_ref] = ACTIONS(4408),
    [sym_return] = ACTIONS(4408),
    [sym_scope] = ACTIONS(4408),
    [sym_shared] = ACTIONS(4408),
    [sym_static] = ACTIONS(4408),
    [sym_struct] = ACTIONS(4408),
    [sym_synchronized] = ACTIONS(4408),
    [sym_template] = ACTIONS(4408),
    [sym_typeof] = ACTIONS(4408),
    [sym_union] = ACTIONS(4408),
    [sym_unittest] = ACTIONS(4408),
    [sym_version] = ACTIONS(4408),
    [sym_while] = ACTIONS(4408),
    [sym_gshared] = ACTIONS(4408),
    [sym_traits] = ACTIONS(4408),
    [sym_vector] = ACTIONS(4408),
    [sym_void] = ACTIONS(4408),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2222] = {
    [ts_builtin_sym_end] = ACTIONS(4406),
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_AT] = ACTIONS(4406),
    [sym_bool] = ACTIONS(4404),
    [sym_byte] = ACTIONS(4404),
    [sym_ubyte] = ACTIONS(4404),
    [sym_char] = ACTIONS(4404),
    [sym_short] = ACTIONS(4404),
    [sym_ushort] = ACTIONS(4404),
    [sym_int] = ACTIONS(4404),
    [sym_uint] = ACTIONS(4404),
    [sym_long] = ACTIONS(4404),
    [sym_ulong] = ACTIONS(4404),
    [sym_cent] = ACTIONS(4404),
    [sym_ucent] = ACTIONS(4404),
    [sym_wchar] = ACTIONS(4404),
    [sym_dchar] = ACTIONS(4404),
    [sym_float] = ACTIONS(4404),
    [sym_double] = ACTIONS(4404),
    [sym_real] = ACTIONS(4404),
    [sym_ifloat] = ACTIONS(4404),
    [sym_idouble] = ACTIONS(4404),
    [sym_ireal] = ACTIONS(4404),
    [sym_cfloat] = ACTIONS(4404),
    [sym_cdouble] = ACTIONS(4404),
    [sym_creal] = ACTIONS(4404),
    [sym_size_t] = ACTIONS(4404),
    [sym_ptrdiff_t] = ACTIONS(4404),
    [sym_string] = ACTIONS(4404),
    [sym_cstring] = ACTIONS(4404),
    [sym_dstring] = ACTIONS(4404),
    [sym_wstring] = ACTIONS(4404),
    [sym_noreturn] = ACTIONS(4404),
    [sym_this] = ACTIONS(4404),
    [sym_abstract] = ACTIONS(4404),
    [sym_alias] = ACTIONS(4404),
    [sym_align] = ACTIONS(4404),
    [sym_auto] = ACTIONS(4404),
    [sym_class] = ACTIONS(4404),
    [sym_const] = ACTIONS(4404),
    [sym_debug] = ACTIONS(4404),
    [sym_deprecated] = ACTIONS(4404),
    [sym_else] = ACTIONS(4404),
    [sym_enum] = ACTIONS(4404),
    [sym_export] = ACTIONS(4404),
    [sym_extern] = ACTIONS(4404),
    [sym_final] = ACTIONS(4404),
    [sym_immutable] = ACTIONS(4404),
    [sym_import] = ACTIONS(4404),
    [sym_inout] = ACTIONS(4404),
    [sym_interface] = ACTIONS(4404),
    [sym_invariant] = ACTIONS(4404),
    [sym_mixin] = ACTIONS(4404),
    [sym_nothrow] = ACTIONS(4404),
    [sym_override] = ACTIONS(4404),
    [sym_package] = ACTIONS(4404),
    [sym_pragma] = ACTIONS(4404),
    [sym_private] = ACTIONS(4404),
    [sym_protected] = ACTIONS(4404),
    [sym_public] = ACTIONS(4404),
    [sym_pure] = ACTIONS(4404),
    [sym_ref] = ACTIONS(4404),
    [sym_return] = ACTIONS(4404),
    [sym_scope] = ACTIONS(4404),
    [sym_shared] = ACTIONS(4404),
    [sym_static] = ACTIONS(4404),
    [sym_struct] = ACTIONS(4404),
    [sym_synchronized] = ACTIONS(4404),
    [sym_template] = ACTIONS(4404),
    [sym_typeof] = ACTIONS(4404),
    [sym_union] = ACTIONS(4404),
    [sym_unittest] = ACTIONS(4404),
    [sym_version] = ACTIONS(4404),
    [sym_while] = ACTIONS(4404),
    [sym_gshared] = ACTIONS(4404),
    [sym_traits] = ACTIONS(4404),
    [sym_vector] = ACTIONS(4404),
    [sym_void] = ACTIONS(4404),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(4656),
    [anon_sym_DOT] = ACTIONS(4658),
    [anon_sym_SEMI] = ACTIONS(4658),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_AT] = ACTIONS(4658),
    [sym_bool] = ACTIONS(4656),
    [sym_byte] = ACTIONS(4656),
    [sym_ubyte] = ACTIONS(4656),
    [sym_char] = ACTIONS(4656),
    [sym_short] = ACTIONS(4656),
    [sym_ushort] = ACTIONS(4656),
    [sym_int] = ACTIONS(4656),
    [sym_uint] = ACTIONS(4656),
    [sym_long] = ACTIONS(4656),
    [sym_ulong] = ACTIONS(4656),
    [sym_cent] = ACTIONS(4656),
    [sym_ucent] = ACTIONS(4656),
    [sym_wchar] = ACTIONS(4656),
    [sym_dchar] = ACTIONS(4656),
    [sym_float] = ACTIONS(4656),
    [sym_double] = ACTIONS(4656),
    [sym_real] = ACTIONS(4656),
    [sym_ifloat] = ACTIONS(4656),
    [sym_idouble] = ACTIONS(4656),
    [sym_ireal] = ACTIONS(4656),
    [sym_cfloat] = ACTIONS(4656),
    [sym_cdouble] = ACTIONS(4656),
    [sym_creal] = ACTIONS(4656),
    [sym_size_t] = ACTIONS(4656),
    [sym_ptrdiff_t] = ACTIONS(4656),
    [sym_string] = ACTIONS(4656),
    [sym_cstring] = ACTIONS(4656),
    [sym_dstring] = ACTIONS(4656),
    [sym_wstring] = ACTIONS(4656),
    [sym_noreturn] = ACTIONS(4656),
    [sym_this] = ACTIONS(4656),
    [sym_abstract] = ACTIONS(4656),
    [sym_alias] = ACTIONS(4656),
    [sym_align] = ACTIONS(4656),
    [sym_auto] = ACTIONS(4656),
    [sym_catch] = ACTIONS(4656),
    [sym_class] = ACTIONS(4656),
    [sym_const] = ACTIONS(4656),
    [sym_debug] = ACTIONS(4656),
    [sym_deprecated] = ACTIONS(4656),
    [sym_else] = ACTIONS(4656),
    [sym_enum] = ACTIONS(4656),
    [sym_export] = ACTIONS(4656),
    [sym_extern] = ACTIONS(4656),
    [sym_final] = ACTIONS(4656),
    [sym_finally] = ACTIONS(4656),
    [sym_immutable] = ACTIONS(4656),
    [sym_import] = ACTIONS(4656),
    [sym_inout] = ACTIONS(4656),
    [sym_interface] = ACTIONS(4656),
    [sym_invariant] = ACTIONS(4656),
    [sym_mixin] = ACTIONS(4656),
    [sym_nothrow] = ACTIONS(4656),
    [sym_override] = ACTIONS(4656),
    [sym_package] = ACTIONS(4656),
    [sym_pragma] = ACTIONS(4656),
    [sym_private] = ACTIONS(4656),
    [sym_protected] = ACTIONS(4656),
    [sym_public] = ACTIONS(4656),
    [sym_pure] = ACTIONS(4656),
    [sym_ref] = ACTIONS(4656),
    [sym_return] = ACTIONS(4656),
    [sym_scope] = ACTIONS(4656),
    [sym_shared] = ACTIONS(4656),
    [sym_static] = ACTIONS(4656),
    [sym_struct] = ACTIONS(4656),
    [sym_synchronized] = ACTIONS(4656),
    [sym_template] = ACTIONS(4656),
    [sym_typeof] = ACTIONS(4656),
    [sym_union] = ACTIONS(4656),
    [sym_unittest] = ACTIONS(4656),
    [sym_version] = ACTIONS(4656),
    [sym_while] = ACTIONS(4656),
    [sym_gshared] = ACTIONS(4656),
    [sym_traits] = ACTIONS(4656),
    [sym_vector] = ACTIONS(4656),
    [sym_void] = ACTIONS(4656),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2224] = {
    [ts_builtin_sym_end] = ACTIONS(4402),
    [sym_identifier] = ACTIONS(4400),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_AT] = ACTIONS(4402),
    [sym_bool] = ACTIONS(4400),
    [sym_byte] = ACTIONS(4400),
    [sym_ubyte] = ACTIONS(4400),
    [sym_char] = ACTIONS(4400),
    [sym_short] = ACTIONS(4400),
    [sym_ushort] = ACTIONS(4400),
    [sym_int] = ACTIONS(4400),
    [sym_uint] = ACTIONS(4400),
    [sym_long] = ACTIONS(4400),
    [sym_ulong] = ACTIONS(4400),
    [sym_cent] = ACTIONS(4400),
    [sym_ucent] = ACTIONS(4400),
    [sym_wchar] = ACTIONS(4400),
    [sym_dchar] = ACTIONS(4400),
    [sym_float] = ACTIONS(4400),
    [sym_double] = ACTIONS(4400),
    [sym_real] = ACTIONS(4400),
    [sym_ifloat] = ACTIONS(4400),
    [sym_idouble] = ACTIONS(4400),
    [sym_ireal] = ACTIONS(4400),
    [sym_cfloat] = ACTIONS(4400),
    [sym_cdouble] = ACTIONS(4400),
    [sym_creal] = ACTIONS(4400),
    [sym_size_t] = ACTIONS(4400),
    [sym_ptrdiff_t] = ACTIONS(4400),
    [sym_string] = ACTIONS(4400),
    [sym_cstring] = ACTIONS(4400),
    [sym_dstring] = ACTIONS(4400),
    [sym_wstring] = ACTIONS(4400),
    [sym_noreturn] = ACTIONS(4400),
    [sym_this] = ACTIONS(4400),
    [sym_abstract] = ACTIONS(4400),
    [sym_alias] = ACTIONS(4400),
    [sym_align] = ACTIONS(4400),
    [sym_auto] = ACTIONS(4400),
    [sym_class] = ACTIONS(4400),
    [sym_const] = ACTIONS(4400),
    [sym_debug] = ACTIONS(4400),
    [sym_deprecated] = ACTIONS(4400),
    [sym_else] = ACTIONS(4400),
    [sym_enum] = ACTIONS(4400),
    [sym_export] = ACTIONS(4400),
    [sym_extern] = ACTIONS(4400),
    [sym_final] = ACTIONS(4400),
    [sym_immutable] = ACTIONS(4400),
    [sym_import] = ACTIONS(4400),
    [sym_inout] = ACTIONS(4400),
    [sym_interface] = ACTIONS(4400),
    [sym_invariant] = ACTIONS(4400),
    [sym_mixin] = ACTIONS(4400),
    [sym_nothrow] = ACTIONS(4400),
    [sym_override] = ACTIONS(4400),
    [sym_package] = ACTIONS(4400),
    [sym_pragma] = ACTIONS(4400),
    [sym_private] = ACTIONS(4400),
    [sym_protected] = ACTIONS(4400),
    [sym_public] = ACTIONS(4400),
    [sym_pure] = ACTIONS(4400),
    [sym_ref] = ACTIONS(4400),
    [sym_return] = ACTIONS(4400),
    [sym_scope] = ACTIONS(4400),
    [sym_shared] = ACTIONS(4400),
    [sym_static] = ACTIONS(4400),
    [sym_struct] = ACTIONS(4400),
    [sym_synchronized] = ACTIONS(4400),
    [sym_template] = ACTIONS(4400),
    [sym_typeof] = ACTIONS(4400),
    [sym_union] = ACTIONS(4400),
    [sym_unittest] = ACTIONS(4400),
    [sym_version] = ACTIONS(4400),
    [sym_while] = ACTIONS(4400),
    [sym_gshared] = ACTIONS(4400),
    [sym_traits] = ACTIONS(4400),
    [sym_vector] = ACTIONS(4400),
    [sym_void] = ACTIONS(4400),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2225] = {
    [sym_identifier] = ACTIONS(4562),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_TILDE] = ACTIONS(4564),
    [anon_sym_AT] = ACTIONS(4564),
    [sym_bool] = ACTIONS(4562),
    [sym_byte] = ACTIONS(4562),
    [sym_ubyte] = ACTIONS(4562),
    [sym_char] = ACTIONS(4562),
    [sym_short] = ACTIONS(4562),
    [sym_ushort] = ACTIONS(4562),
    [sym_int] = ACTIONS(4562),
    [sym_uint] = ACTIONS(4562),
    [sym_long] = ACTIONS(4562),
    [sym_ulong] = ACTIONS(4562),
    [sym_cent] = ACTIONS(4562),
    [sym_ucent] = ACTIONS(4562),
    [sym_wchar] = ACTIONS(4562),
    [sym_dchar] = ACTIONS(4562),
    [sym_float] = ACTIONS(4562),
    [sym_double] = ACTIONS(4562),
    [sym_real] = ACTIONS(4562),
    [sym_ifloat] = ACTIONS(4562),
    [sym_idouble] = ACTIONS(4562),
    [sym_ireal] = ACTIONS(4562),
    [sym_cfloat] = ACTIONS(4562),
    [sym_cdouble] = ACTIONS(4562),
    [sym_creal] = ACTIONS(4562),
    [sym_size_t] = ACTIONS(4562),
    [sym_ptrdiff_t] = ACTIONS(4562),
    [sym_string] = ACTIONS(4562),
    [sym_cstring] = ACTIONS(4562),
    [sym_dstring] = ACTIONS(4562),
    [sym_wstring] = ACTIONS(4562),
    [sym_noreturn] = ACTIONS(4562),
    [sym_this] = ACTIONS(4562),
    [sym_abstract] = ACTIONS(4562),
    [sym_alias] = ACTIONS(4562),
    [sym_align] = ACTIONS(4562),
    [sym_auto] = ACTIONS(4562),
    [sym_catch] = ACTIONS(4562),
    [sym_class] = ACTIONS(4562),
    [sym_const] = ACTIONS(4562),
    [sym_debug] = ACTIONS(4562),
    [sym_deprecated] = ACTIONS(4562),
    [sym_else] = ACTIONS(4562),
    [sym_enum] = ACTIONS(4562),
    [sym_export] = ACTIONS(4562),
    [sym_extern] = ACTIONS(4562),
    [sym_final] = ACTIONS(4562),
    [sym_finally] = ACTIONS(4562),
    [sym_immutable] = ACTIONS(4562),
    [sym_import] = ACTIONS(4562),
    [sym_inout] = ACTIONS(4562),
    [sym_interface] = ACTIONS(4562),
    [sym_invariant] = ACTIONS(4562),
    [sym_mixin] = ACTIONS(4562),
    [sym_nothrow] = ACTIONS(4562),
    [sym_override] = ACTIONS(4562),
    [sym_package] = ACTIONS(4562),
    [sym_pragma] = ACTIONS(4562),
    [sym_private] = ACTIONS(4562),
    [sym_protected] = ACTIONS(4562),
    [sym_public] = ACTIONS(4562),
    [sym_pure] = ACTIONS(4562),
    [sym_ref] = ACTIONS(4562),
    [sym_return] = ACTIONS(4562),
    [sym_scope] = ACTIONS(4562),
    [sym_shared] = ACTIONS(4562),
    [sym_static] = ACTIONS(4562),
    [sym_struct] = ACTIONS(4562),
    [sym_synchronized] = ACTIONS(4562),
    [sym_template] = ACTIONS(4562),
    [sym_typeof] = ACTIONS(4562),
    [sym_union] = ACTIONS(4562),
    [sym_unittest] = ACTIONS(4562),
    [sym_version] = ACTIONS(4562),
    [sym_while] = ACTIONS(4562),
    [sym_gshared] = ACTIONS(4562),
    [sym_traits] = ACTIONS(4562),
    [sym_vector] = ACTIONS(4562),
    [sym_void] = ACTIONS(4562),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2226] = {
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4608),
    [anon_sym_TILDE] = ACTIONS(4608),
    [anon_sym_AT] = ACTIONS(4608),
    [sym_bool] = ACTIONS(4606),
    [sym_byte] = ACTIONS(4606),
    [sym_ubyte] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_short] = ACTIONS(4606),
    [sym_ushort] = ACTIONS(4606),
    [sym_int] = ACTIONS(4606),
    [sym_uint] = ACTIONS(4606),
    [sym_long] = ACTIONS(4606),
    [sym_ulong] = ACTIONS(4606),
    [sym_cent] = ACTIONS(4606),
    [sym_ucent] = ACTIONS(4606),
    [sym_wchar] = ACTIONS(4606),
    [sym_dchar] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_double] = ACTIONS(4606),
    [sym_real] = ACTIONS(4606),
    [sym_ifloat] = ACTIONS(4606),
    [sym_idouble] = ACTIONS(4606),
    [sym_ireal] = ACTIONS(4606),
    [sym_cfloat] = ACTIONS(4606),
    [sym_cdouble] = ACTIONS(4606),
    [sym_creal] = ACTIONS(4606),
    [sym_size_t] = ACTIONS(4606),
    [sym_ptrdiff_t] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym_cstring] = ACTIONS(4606),
    [sym_dstring] = ACTIONS(4606),
    [sym_wstring] = ACTIONS(4606),
    [sym_noreturn] = ACTIONS(4606),
    [sym_this] = ACTIONS(4606),
    [sym_abstract] = ACTIONS(4606),
    [sym_alias] = ACTIONS(4606),
    [sym_align] = ACTIONS(4606),
    [sym_auto] = ACTIONS(4606),
    [sym_catch] = ACTIONS(4606),
    [sym_class] = ACTIONS(4606),
    [sym_const] = ACTIONS(4606),
    [sym_debug] = ACTIONS(4606),
    [sym_deprecated] = ACTIONS(4606),
    [sym_else] = ACTIONS(4606),
    [sym_enum] = ACTIONS(4606),
    [sym_export] = ACTIONS(4606),
    [sym_extern] = ACTIONS(4606),
    [sym_final] = ACTIONS(4606),
    [sym_finally] = ACTIONS(4606),
    [sym_immutable] = ACTIONS(4606),
    [sym_import] = ACTIONS(4606),
    [sym_inout] = ACTIONS(4606),
    [sym_interface] = ACTIONS(4606),
    [sym_invariant] = ACTIONS(4606),
    [sym_mixin] = ACTIONS(4606),
    [sym_nothrow] = ACTIONS(4606),
    [sym_override] = ACTIONS(4606),
    [sym_package] = ACTIONS(4606),
    [sym_pragma] = ACTIONS(4606),
    [sym_private] = ACTIONS(4606),
    [sym_protected] = ACTIONS(4606),
    [sym_public] = ACTIONS(4606),
    [sym_pure] = ACTIONS(4606),
    [sym_ref] = ACTIONS(4606),
    [sym_return] = ACTIONS(4606),
    [sym_scope] = ACTIONS(4606),
    [sym_shared] = ACTIONS(4606),
    [sym_static] = ACTIONS(4606),
    [sym_struct] = ACTIONS(4606),
    [sym_synchronized] = ACTIONS(4606),
    [sym_template] = ACTIONS(4606),
    [sym_typeof] = ACTIONS(4606),
    [sym_union] = ACTIONS(4606),
    [sym_unittest] = ACTIONS(4606),
    [sym_version] = ACTIONS(4606),
    [sym_while] = ACTIONS(4606),
    [sym_gshared] = ACTIONS(4606),
    [sym_traits] = ACTIONS(4606),
    [sym_vector] = ACTIONS(4606),
    [sym_void] = ACTIONS(4606),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2227] = {
    [ts_builtin_sym_end] = ACTIONS(4398),
    [sym_identifier] = ACTIONS(4396),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_TILDE] = ACTIONS(4398),
    [anon_sym_AT] = ACTIONS(4398),
    [sym_bool] = ACTIONS(4396),
    [sym_byte] = ACTIONS(4396),
    [sym_ubyte] = ACTIONS(4396),
    [sym_char] = ACTIONS(4396),
    [sym_short] = ACTIONS(4396),
    [sym_ushort] = ACTIONS(4396),
    [sym_int] = ACTIONS(4396),
    [sym_uint] = ACTIONS(4396),
    [sym_long] = ACTIONS(4396),
    [sym_ulong] = ACTIONS(4396),
    [sym_cent] = ACTIONS(4396),
    [sym_ucent] = ACTIONS(4396),
    [sym_wchar] = ACTIONS(4396),
    [sym_dchar] = ACTIONS(4396),
    [sym_float] = ACTIONS(4396),
    [sym_double] = ACTIONS(4396),
    [sym_real] = ACTIONS(4396),
    [sym_ifloat] = ACTIONS(4396),
    [sym_idouble] = ACTIONS(4396),
    [sym_ireal] = ACTIONS(4396),
    [sym_cfloat] = ACTIONS(4396),
    [sym_cdouble] = ACTIONS(4396),
    [sym_creal] = ACTIONS(4396),
    [sym_size_t] = ACTIONS(4396),
    [sym_ptrdiff_t] = ACTIONS(4396),
    [sym_string] = ACTIONS(4396),
    [sym_cstring] = ACTIONS(4396),
    [sym_dstring] = ACTIONS(4396),
    [sym_wstring] = ACTIONS(4396),
    [sym_noreturn] = ACTIONS(4396),
    [sym_this] = ACTIONS(4396),
    [sym_abstract] = ACTIONS(4396),
    [sym_alias] = ACTIONS(4396),
    [sym_align] = ACTIONS(4396),
    [sym_auto] = ACTIONS(4396),
    [sym_class] = ACTIONS(4396),
    [sym_const] = ACTIONS(4396),
    [sym_debug] = ACTIONS(4396),
    [sym_deprecated] = ACTIONS(4396),
    [sym_else] = ACTIONS(4396),
    [sym_enum] = ACTIONS(4396),
    [sym_export] = ACTIONS(4396),
    [sym_extern] = ACTIONS(4396),
    [sym_final] = ACTIONS(4396),
    [sym_immutable] = ACTIONS(4396),
    [sym_import] = ACTIONS(4396),
    [sym_inout] = ACTIONS(4396),
    [sym_interface] = ACTIONS(4396),
    [sym_invariant] = ACTIONS(4396),
    [sym_mixin] = ACTIONS(4396),
    [sym_nothrow] = ACTIONS(4396),
    [sym_override] = ACTIONS(4396),
    [sym_package] = ACTIONS(4396),
    [sym_pragma] = ACTIONS(4396),
    [sym_private] = ACTIONS(4396),
    [sym_protected] = ACTIONS(4396),
    [sym_public] = ACTIONS(4396),
    [sym_pure] = ACTIONS(4396),
    [sym_ref] = ACTIONS(4396),
    [sym_return] = ACTIONS(4396),
    [sym_scope] = ACTIONS(4396),
    [sym_shared] = ACTIONS(4396),
    [sym_static] = ACTIONS(4396),
    [sym_struct] = ACTIONS(4396),
    [sym_synchronized] = ACTIONS(4396),
    [sym_template] = ACTIONS(4396),
    [sym_typeof] = ACTIONS(4396),
    [sym_union] = ACTIONS(4396),
    [sym_unittest] = ACTIONS(4396),
    [sym_version] = ACTIONS(4396),
    [sym_while] = ACTIONS(4396),
    [sym_gshared] = ACTIONS(4396),
    [sym_traits] = ACTIONS(4396),
    [sym_vector] = ACTIONS(4396),
    [sym_void] = ACTIONS(4396),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2228] = {
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_DOT] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_AT] = ACTIONS(4624),
    [sym_bool] = ACTIONS(4622),
    [sym_byte] = ACTIONS(4622),
    [sym_ubyte] = ACTIONS(4622),
    [sym_char] = ACTIONS(4622),
    [sym_short] = ACTIONS(4622),
    [sym_ushort] = ACTIONS(4622),
    [sym_int] = ACTIONS(4622),
    [sym_uint] = ACTIONS(4622),
    [sym_long] = ACTIONS(4622),
    [sym_ulong] = ACTIONS(4622),
    [sym_cent] = ACTIONS(4622),
    [sym_ucent] = ACTIONS(4622),
    [sym_wchar] = ACTIONS(4622),
    [sym_dchar] = ACTIONS(4622),
    [sym_float] = ACTIONS(4622),
    [sym_double] = ACTIONS(4622),
    [sym_real] = ACTIONS(4622),
    [sym_ifloat] = ACTIONS(4622),
    [sym_idouble] = ACTIONS(4622),
    [sym_ireal] = ACTIONS(4622),
    [sym_cfloat] = ACTIONS(4622),
    [sym_cdouble] = ACTIONS(4622),
    [sym_creal] = ACTIONS(4622),
    [sym_size_t] = ACTIONS(4622),
    [sym_ptrdiff_t] = ACTIONS(4622),
    [sym_string] = ACTIONS(4622),
    [sym_cstring] = ACTIONS(4622),
    [sym_dstring] = ACTIONS(4622),
    [sym_wstring] = ACTIONS(4622),
    [sym_noreturn] = ACTIONS(4622),
    [sym_this] = ACTIONS(4622),
    [sym_abstract] = ACTIONS(4622),
    [sym_alias] = ACTIONS(4622),
    [sym_align] = ACTIONS(4622),
    [sym_auto] = ACTIONS(4622),
    [sym_catch] = ACTIONS(4622),
    [sym_class] = ACTIONS(4622),
    [sym_const] = ACTIONS(4622),
    [sym_debug] = ACTIONS(4622),
    [sym_deprecated] = ACTIONS(4622),
    [sym_else] = ACTIONS(4622),
    [sym_enum] = ACTIONS(4622),
    [sym_export] = ACTIONS(4622),
    [sym_extern] = ACTIONS(4622),
    [sym_final] = ACTIONS(4622),
    [sym_finally] = ACTIONS(4622),
    [sym_immutable] = ACTIONS(4622),
    [sym_import] = ACTIONS(4622),
    [sym_inout] = ACTIONS(4622),
    [sym_interface] = ACTIONS(4622),
    [sym_invariant] = ACTIONS(4622),
    [sym_mixin] = ACTIONS(4622),
    [sym_nothrow] = ACTIONS(4622),
    [sym_override] = ACTIONS(4622),
    [sym_package] = ACTIONS(4622),
    [sym_pragma] = ACTIONS(4622),
    [sym_private] = ACTIONS(4622),
    [sym_protected] = ACTIONS(4622),
    [sym_public] = ACTIONS(4622),
    [sym_pure] = ACTIONS(4622),
    [sym_ref] = ACTIONS(4622),
    [sym_return] = ACTIONS(4622),
    [sym_scope] = ACTIONS(4622),
    [sym_shared] = ACTIONS(4622),
    [sym_static] = ACTIONS(4622),
    [sym_struct] = ACTIONS(4622),
    [sym_synchronized] = ACTIONS(4622),
    [sym_template] = ACTIONS(4622),
    [sym_typeof] = ACTIONS(4622),
    [sym_union] = ACTIONS(4622),
    [sym_unittest] = ACTIONS(4622),
    [sym_version] = ACTIONS(4622),
    [sym_while] = ACTIONS(4622),
    [sym_gshared] = ACTIONS(4622),
    [sym_traits] = ACTIONS(4622),
    [sym_vector] = ACTIONS(4622),
    [sym_void] = ACTIONS(4622),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2229] = {
    [ts_builtin_sym_end] = ACTIONS(4442),
    [sym_identifier] = ACTIONS(4440),
    [anon_sym_RBRACE] = ACTIONS(4442),
    [anon_sym_DOT] = ACTIONS(4442),
    [anon_sym_SEMI] = ACTIONS(4442),
    [anon_sym_TILDE] = ACTIONS(4442),
    [anon_sym_AT] = ACTIONS(4442),
    [sym_bool] = ACTIONS(4440),
    [sym_byte] = ACTIONS(4440),
    [sym_ubyte] = ACTIONS(4440),
    [sym_char] = ACTIONS(4440),
    [sym_short] = ACTIONS(4440),
    [sym_ushort] = ACTIONS(4440),
    [sym_int] = ACTIONS(4440),
    [sym_uint] = ACTIONS(4440),
    [sym_long] = ACTIONS(4440),
    [sym_ulong] = ACTIONS(4440),
    [sym_cent] = ACTIONS(4440),
    [sym_ucent] = ACTIONS(4440),
    [sym_wchar] = ACTIONS(4440),
    [sym_dchar] = ACTIONS(4440),
    [sym_float] = ACTIONS(4440),
    [sym_double] = ACTIONS(4440),
    [sym_real] = ACTIONS(4440),
    [sym_ifloat] = ACTIONS(4440),
    [sym_idouble] = ACTIONS(4440),
    [sym_ireal] = ACTIONS(4440),
    [sym_cfloat] = ACTIONS(4440),
    [sym_cdouble] = ACTIONS(4440),
    [sym_creal] = ACTIONS(4440),
    [sym_size_t] = ACTIONS(4440),
    [sym_ptrdiff_t] = ACTIONS(4440),
    [sym_string] = ACTIONS(4440),
    [sym_cstring] = ACTIONS(4440),
    [sym_dstring] = ACTIONS(4440),
    [sym_wstring] = ACTIONS(4440),
    [sym_noreturn] = ACTIONS(4440),
    [sym_this] = ACTIONS(4440),
    [sym_abstract] = ACTIONS(4440),
    [sym_alias] = ACTIONS(4440),
    [sym_align] = ACTIONS(4440),
    [sym_auto] = ACTIONS(4440),
    [sym_class] = ACTIONS(4440),
    [sym_const] = ACTIONS(4440),
    [sym_debug] = ACTIONS(4440),
    [sym_deprecated] = ACTIONS(4440),
    [sym_else] = ACTIONS(4440),
    [sym_enum] = ACTIONS(4440),
    [sym_export] = ACTIONS(4440),
    [sym_extern] = ACTIONS(4440),
    [sym_final] = ACTIONS(4440),
    [sym_immutable] = ACTIONS(4440),
    [sym_import] = ACTIONS(4440),
    [sym_inout] = ACTIONS(4440),
    [sym_interface] = ACTIONS(4440),
    [sym_invariant] = ACTIONS(4440),
    [sym_mixin] = ACTIONS(4440),
    [sym_nothrow] = ACTIONS(4440),
    [sym_override] = ACTIONS(4440),
    [sym_package] = ACTIONS(4440),
    [sym_pragma] = ACTIONS(4440),
    [sym_private] = ACTIONS(4440),
    [sym_protected] = ACTIONS(4440),
    [sym_public] = ACTIONS(4440),
    [sym_pure] = ACTIONS(4440),
    [sym_ref] = ACTIONS(4440),
    [sym_return] = ACTIONS(4440),
    [sym_scope] = ACTIONS(4440),
    [sym_shared] = ACTIONS(4440),
    [sym_static] = ACTIONS(4440),
    [sym_struct] = ACTIONS(4440),
    [sym_synchronized] = ACTIONS(4440),
    [sym_template] = ACTIONS(4440),
    [sym_typeof] = ACTIONS(4440),
    [sym_union] = ACTIONS(4440),
    [sym_unittest] = ACTIONS(4440),
    [sym_version] = ACTIONS(4440),
    [sym_while] = ACTIONS(4440),
    [sym_gshared] = ACTIONS(4440),
    [sym_traits] = ACTIONS(4440),
    [sym_vector] = ACTIONS(4440),
    [sym_void] = ACTIONS(4440),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(4664),
    [anon_sym_DOT] = ACTIONS(4666),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_TILDE] = ACTIONS(4666),
    [anon_sym_AT] = ACTIONS(4666),
    [sym_bool] = ACTIONS(4664),
    [sym_byte] = ACTIONS(4664),
    [sym_ubyte] = ACTIONS(4664),
    [sym_char] = ACTIONS(4664),
    [sym_short] = ACTIONS(4664),
    [sym_ushort] = ACTIONS(4664),
    [sym_int] = ACTIONS(4664),
    [sym_uint] = ACTIONS(4664),
    [sym_long] = ACTIONS(4664),
    [sym_ulong] = ACTIONS(4664),
    [sym_cent] = ACTIONS(4664),
    [sym_ucent] = ACTIONS(4664),
    [sym_wchar] = ACTIONS(4664),
    [sym_dchar] = ACTIONS(4664),
    [sym_float] = ACTIONS(4664),
    [sym_double] = ACTIONS(4664),
    [sym_real] = ACTIONS(4664),
    [sym_ifloat] = ACTIONS(4664),
    [sym_idouble] = ACTIONS(4664),
    [sym_ireal] = ACTIONS(4664),
    [sym_cfloat] = ACTIONS(4664),
    [sym_cdouble] = ACTIONS(4664),
    [sym_creal] = ACTIONS(4664),
    [sym_size_t] = ACTIONS(4664),
    [sym_ptrdiff_t] = ACTIONS(4664),
    [sym_string] = ACTIONS(4664),
    [sym_cstring] = ACTIONS(4664),
    [sym_dstring] = ACTIONS(4664),
    [sym_wstring] = ACTIONS(4664),
    [sym_noreturn] = ACTIONS(4664),
    [sym_this] = ACTIONS(4664),
    [sym_abstract] = ACTIONS(4664),
    [sym_alias] = ACTIONS(4664),
    [sym_align] = ACTIONS(4664),
    [sym_auto] = ACTIONS(4664),
    [sym_catch] = ACTIONS(4664),
    [sym_class] = ACTIONS(4664),
    [sym_const] = ACTIONS(4664),
    [sym_debug] = ACTIONS(4664),
    [sym_deprecated] = ACTIONS(4664),
    [sym_else] = ACTIONS(4664),
    [sym_enum] = ACTIONS(4664),
    [sym_export] = ACTIONS(4664),
    [sym_extern] = ACTIONS(4664),
    [sym_final] = ACTIONS(4664),
    [sym_finally] = ACTIONS(4664),
    [sym_immutable] = ACTIONS(4664),
    [sym_import] = ACTIONS(4664),
    [sym_inout] = ACTIONS(4664),
    [sym_interface] = ACTIONS(4664),
    [sym_invariant] = ACTIONS(4664),
    [sym_mixin] = ACTIONS(4664),
    [sym_nothrow] = ACTIONS(4664),
    [sym_override] = ACTIONS(4664),
    [sym_package] = ACTIONS(4664),
    [sym_pragma] = ACTIONS(4664),
    [sym_private] = ACTIONS(4664),
    [sym_protected] = ACTIONS(4664),
    [sym_public] = ACTIONS(4664),
    [sym_pure] = ACTIONS(4664),
    [sym_ref] = ACTIONS(4664),
    [sym_return] = ACTIONS(4664),
    [sym_scope] = ACTIONS(4664),
    [sym_shared] = ACTIONS(4664),
    [sym_static] = ACTIONS(4664),
    [sym_struct] = ACTIONS(4664),
    [sym_synchronized] = ACTIONS(4664),
    [sym_template] = ACTIONS(4664),
    [sym_typeof] = ACTIONS(4664),
    [sym_union] = ACTIONS(4664),
    [sym_unittest] = ACTIONS(4664),
    [sym_version] = ACTIONS(4664),
    [sym_while] = ACTIONS(4664),
    [sym_gshared] = ACTIONS(4664),
    [sym_traits] = ACTIONS(4664),
    [sym_vector] = ACTIONS(4664),
    [sym_void] = ACTIONS(4664),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2231] = {
    [ts_builtin_sym_end] = ACTIONS(4799),
    [sym_identifier] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_TILDE] = ACTIONS(4799),
    [anon_sym_AT] = ACTIONS(4799),
    [sym_bool] = ACTIONS(4797),
    [sym_byte] = ACTIONS(4797),
    [sym_ubyte] = ACTIONS(4797),
    [sym_char] = ACTIONS(4797),
    [sym_short] = ACTIONS(4797),
    [sym_ushort] = ACTIONS(4797),
    [sym_int] = ACTIONS(4797),
    [sym_uint] = ACTIONS(4797),
    [sym_long] = ACTIONS(4797),
    [sym_ulong] = ACTIONS(4797),
    [sym_cent] = ACTIONS(4797),
    [sym_ucent] = ACTIONS(4797),
    [sym_wchar] = ACTIONS(4797),
    [sym_dchar] = ACTIONS(4797),
    [sym_float] = ACTIONS(4797),
    [sym_double] = ACTIONS(4797),
    [sym_real] = ACTIONS(4797),
    [sym_ifloat] = ACTIONS(4797),
    [sym_idouble] = ACTIONS(4797),
    [sym_ireal] = ACTIONS(4797),
    [sym_cfloat] = ACTIONS(4797),
    [sym_cdouble] = ACTIONS(4797),
    [sym_creal] = ACTIONS(4797),
    [sym_size_t] = ACTIONS(4797),
    [sym_ptrdiff_t] = ACTIONS(4797),
    [sym_string] = ACTIONS(4797),
    [sym_cstring] = ACTIONS(4797),
    [sym_dstring] = ACTIONS(4797),
    [sym_wstring] = ACTIONS(4797),
    [sym_noreturn] = ACTIONS(4797),
    [sym_this] = ACTIONS(4797),
    [sym_abstract] = ACTIONS(4797),
    [sym_alias] = ACTIONS(4797),
    [sym_align] = ACTIONS(4797),
    [sym_auto] = ACTIONS(4797),
    [sym_class] = ACTIONS(4797),
    [sym_const] = ACTIONS(4797),
    [sym_debug] = ACTIONS(4797),
    [sym_deprecated] = ACTIONS(4797),
    [sym_else] = ACTIONS(4797),
    [sym_enum] = ACTIONS(4797),
    [sym_export] = ACTIONS(4797),
    [sym_extern] = ACTIONS(4797),
    [sym_final] = ACTIONS(4797),
    [sym_immutable] = ACTIONS(4797),
    [sym_import] = ACTIONS(4797),
    [sym_inout] = ACTIONS(4797),
    [sym_interface] = ACTIONS(4797),
    [sym_invariant] = ACTIONS(4797),
    [sym_mixin] = ACTIONS(4797),
    [sym_nothrow] = ACTIONS(4797),
    [sym_override] = ACTIONS(4797),
    [sym_package] = ACTIONS(4797),
    [sym_pragma] = ACTIONS(4797),
    [sym_private] = ACTIONS(4797),
    [sym_protected] = ACTIONS(4797),
    [sym_public] = ACTIONS(4797),
    [sym_pure] = ACTIONS(4797),
    [sym_ref] = ACTIONS(4797),
    [sym_return] = ACTIONS(4797),
    [sym_scope] = ACTIONS(4797),
    [sym_shared] = ACTIONS(4797),
    [sym_static] = ACTIONS(4797),
    [sym_struct] = ACTIONS(4797),
    [sym_synchronized] = ACTIONS(4797),
    [sym_template] = ACTIONS(4797),
    [sym_typeof] = ACTIONS(4797),
    [sym_union] = ACTIONS(4797),
    [sym_unittest] = ACTIONS(4797),
    [sym_version] = ACTIONS(4797),
    [sym_while] = ACTIONS(4797),
    [sym_gshared] = ACTIONS(4797),
    [sym_traits] = ACTIONS(4797),
    [sym_vector] = ACTIONS(4797),
    [sym_void] = ACTIONS(4797),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2232] = {
    [ts_builtin_sym_end] = ACTIONS(4670),
    [sym_identifier] = ACTIONS(4668),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(4670),
    [anon_sym_AT] = ACTIONS(4670),
    [sym_bool] = ACTIONS(4668),
    [sym_byte] = ACTIONS(4668),
    [sym_ubyte] = ACTIONS(4668),
    [sym_char] = ACTIONS(4668),
    [sym_short] = ACTIONS(4668),
    [sym_ushort] = ACTIONS(4668),
    [sym_int] = ACTIONS(4668),
    [sym_uint] = ACTIONS(4668),
    [sym_long] = ACTIONS(4668),
    [sym_ulong] = ACTIONS(4668),
    [sym_cent] = ACTIONS(4668),
    [sym_ucent] = ACTIONS(4668),
    [sym_wchar] = ACTIONS(4668),
    [sym_dchar] = ACTIONS(4668),
    [sym_float] = ACTIONS(4668),
    [sym_double] = ACTIONS(4668),
    [sym_real] = ACTIONS(4668),
    [sym_ifloat] = ACTIONS(4668),
    [sym_idouble] = ACTIONS(4668),
    [sym_ireal] = ACTIONS(4668),
    [sym_cfloat] = ACTIONS(4668),
    [sym_cdouble] = ACTIONS(4668),
    [sym_creal] = ACTIONS(4668),
    [sym_size_t] = ACTIONS(4668),
    [sym_ptrdiff_t] = ACTIONS(4668),
    [sym_string] = ACTIONS(4668),
    [sym_cstring] = ACTIONS(4668),
    [sym_dstring] = ACTIONS(4668),
    [sym_wstring] = ACTIONS(4668),
    [sym_noreturn] = ACTIONS(4668),
    [sym_this] = ACTIONS(4668),
    [sym_abstract] = ACTIONS(4668),
    [sym_alias] = ACTIONS(4668),
    [sym_align] = ACTIONS(4668),
    [sym_auto] = ACTIONS(4668),
    [sym_class] = ACTIONS(4668),
    [sym_const] = ACTIONS(4668),
    [sym_debug] = ACTIONS(4668),
    [sym_deprecated] = ACTIONS(4668),
    [sym_else] = ACTIONS(4668),
    [sym_enum] = ACTIONS(4668),
    [sym_export] = ACTIONS(4668),
    [sym_extern] = ACTIONS(4668),
    [sym_final] = ACTIONS(4668),
    [sym_immutable] = ACTIONS(4668),
    [sym_import] = ACTIONS(4668),
    [sym_inout] = ACTIONS(4668),
    [sym_interface] = ACTIONS(4668),
    [sym_invariant] = ACTIONS(4668),
    [sym_mixin] = ACTIONS(4668),
    [sym_nothrow] = ACTIONS(4668),
    [sym_override] = ACTIONS(4668),
    [sym_package] = ACTIONS(4668),
    [sym_pragma] = ACTIONS(4668),
    [sym_private] = ACTIONS(4668),
    [sym_protected] = ACTIONS(4668),
    [sym_public] = ACTIONS(4668),
    [sym_pure] = ACTIONS(4668),
    [sym_ref] = ACTIONS(4668),
    [sym_return] = ACTIONS(4668),
    [sym_scope] = ACTIONS(4668),
    [sym_shared] = ACTIONS(4668),
    [sym_static] = ACTIONS(4668),
    [sym_struct] = ACTIONS(4668),
    [sym_synchronized] = ACTIONS(4668),
    [sym_template] = ACTIONS(4668),
    [sym_typeof] = ACTIONS(4668),
    [sym_union] = ACTIONS(4668),
    [sym_unittest] = ACTIONS(4668),
    [sym_version] = ACTIONS(4668),
    [sym_while] = ACTIONS(4668),
    [sym_gshared] = ACTIONS(4668),
    [sym_traits] = ACTIONS(4668),
    [sym_vector] = ACTIONS(4668),
    [sym_void] = ACTIONS(4668),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2233] = {
    [ts_builtin_sym_end] = ACTIONS(4592),
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_DOT] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_TILDE] = ACTIONS(4592),
    [anon_sym_AT] = ACTIONS(4592),
    [sym_bool] = ACTIONS(4590),
    [sym_byte] = ACTIONS(4590),
    [sym_ubyte] = ACTIONS(4590),
    [sym_char] = ACTIONS(4590),
    [sym_short] = ACTIONS(4590),
    [sym_ushort] = ACTIONS(4590),
    [sym_int] = ACTIONS(4590),
    [sym_uint] = ACTIONS(4590),
    [sym_long] = ACTIONS(4590),
    [sym_ulong] = ACTIONS(4590),
    [sym_cent] = ACTIONS(4590),
    [sym_ucent] = ACTIONS(4590),
    [sym_wchar] = ACTIONS(4590),
    [sym_dchar] = ACTIONS(4590),
    [sym_float] = ACTIONS(4590),
    [sym_double] = ACTIONS(4590),
    [sym_real] = ACTIONS(4590),
    [sym_ifloat] = ACTIONS(4590),
    [sym_idouble] = ACTIONS(4590),
    [sym_ireal] = ACTIONS(4590),
    [sym_cfloat] = ACTIONS(4590),
    [sym_cdouble] = ACTIONS(4590),
    [sym_creal] = ACTIONS(4590),
    [sym_size_t] = ACTIONS(4590),
    [sym_ptrdiff_t] = ACTIONS(4590),
    [sym_string] = ACTIONS(4590),
    [sym_cstring] = ACTIONS(4590),
    [sym_dstring] = ACTIONS(4590),
    [sym_wstring] = ACTIONS(4590),
    [sym_noreturn] = ACTIONS(4590),
    [sym_this] = ACTIONS(4590),
    [sym_abstract] = ACTIONS(4590),
    [sym_alias] = ACTIONS(4590),
    [sym_align] = ACTIONS(4590),
    [sym_auto] = ACTIONS(4590),
    [sym_class] = ACTIONS(4590),
    [sym_const] = ACTIONS(4590),
    [sym_debug] = ACTIONS(4590),
    [sym_deprecated] = ACTIONS(4590),
    [sym_else] = ACTIONS(4590),
    [sym_enum] = ACTIONS(4590),
    [sym_export] = ACTIONS(4590),
    [sym_extern] = ACTIONS(4590),
    [sym_final] = ACTIONS(4590),
    [sym_immutable] = ACTIONS(4590),
    [sym_import] = ACTIONS(4590),
    [sym_inout] = ACTIONS(4590),
    [sym_interface] = ACTIONS(4590),
    [sym_invariant] = ACTIONS(4590),
    [sym_mixin] = ACTIONS(4590),
    [sym_nothrow] = ACTIONS(4590),
    [sym_override] = ACTIONS(4590),
    [sym_package] = ACTIONS(4590),
    [sym_pragma] = ACTIONS(4590),
    [sym_private] = ACTIONS(4590),
    [sym_protected] = ACTIONS(4590),
    [sym_public] = ACTIONS(4590),
    [sym_pure] = ACTIONS(4590),
    [sym_ref] = ACTIONS(4590),
    [sym_return] = ACTIONS(4590),
    [sym_scope] = ACTIONS(4590),
    [sym_shared] = ACTIONS(4590),
    [sym_static] = ACTIONS(4590),
    [sym_struct] = ACTIONS(4590),
    [sym_synchronized] = ACTIONS(4590),
    [sym_template] = ACTIONS(4590),
    [sym_typeof] = ACTIONS(4590),
    [sym_union] = ACTIONS(4590),
    [sym_unittest] = ACTIONS(4590),
    [sym_version] = ACTIONS(4590),
    [sym_while] = ACTIONS(4590),
    [sym_gshared] = ACTIONS(4590),
    [sym_traits] = ACTIONS(4590),
    [sym_vector] = ACTIONS(4590),
    [sym_void] = ACTIONS(4590),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2234] = {
    [ts_builtin_sym_end] = ACTIONS(4893),
    [sym_identifier] = ACTIONS(4891),
    [anon_sym_RBRACE] = ACTIONS(4893),
    [anon_sym_DOT] = ACTIONS(4893),
    [anon_sym_SEMI] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4893),
    [anon_sym_AT] = ACTIONS(4893),
    [sym_bool] = ACTIONS(4891),
    [sym_byte] = ACTIONS(4891),
    [sym_ubyte] = ACTIONS(4891),
    [sym_char] = ACTIONS(4891),
    [sym_short] = ACTIONS(4891),
    [sym_ushort] = ACTIONS(4891),
    [sym_int] = ACTIONS(4891),
    [sym_uint] = ACTIONS(4891),
    [sym_long] = ACTIONS(4891),
    [sym_ulong] = ACTIONS(4891),
    [sym_cent] = ACTIONS(4891),
    [sym_ucent] = ACTIONS(4891),
    [sym_wchar] = ACTIONS(4891),
    [sym_dchar] = ACTIONS(4891),
    [sym_float] = ACTIONS(4891),
    [sym_double] = ACTIONS(4891),
    [sym_real] = ACTIONS(4891),
    [sym_ifloat] = ACTIONS(4891),
    [sym_idouble] = ACTIONS(4891),
    [sym_ireal] = ACTIONS(4891),
    [sym_cfloat] = ACTIONS(4891),
    [sym_cdouble] = ACTIONS(4891),
    [sym_creal] = ACTIONS(4891),
    [sym_size_t] = ACTIONS(4891),
    [sym_ptrdiff_t] = ACTIONS(4891),
    [sym_string] = ACTIONS(4891),
    [sym_cstring] = ACTIONS(4891),
    [sym_dstring] = ACTIONS(4891),
    [sym_wstring] = ACTIONS(4891),
    [sym_noreturn] = ACTIONS(4891),
    [sym_this] = ACTIONS(4891),
    [sym_abstract] = ACTIONS(4891),
    [sym_alias] = ACTIONS(4891),
    [sym_align] = ACTIONS(4891),
    [sym_auto] = ACTIONS(4891),
    [sym_class] = ACTIONS(4891),
    [sym_const] = ACTIONS(4891),
    [sym_debug] = ACTIONS(4891),
    [sym_deprecated] = ACTIONS(4891),
    [sym_else] = ACTIONS(4891),
    [sym_enum] = ACTIONS(4891),
    [sym_export] = ACTIONS(4891),
    [sym_extern] = ACTIONS(4891),
    [sym_final] = ACTIONS(4891),
    [sym_immutable] = ACTIONS(4891),
    [sym_import] = ACTIONS(4891),
    [sym_inout] = ACTIONS(4891),
    [sym_interface] = ACTIONS(4891),
    [sym_invariant] = ACTIONS(4891),
    [sym_mixin] = ACTIONS(4891),
    [sym_nothrow] = ACTIONS(4891),
    [sym_override] = ACTIONS(4891),
    [sym_package] = ACTIONS(4891),
    [sym_pragma] = ACTIONS(4891),
    [sym_private] = ACTIONS(4891),
    [sym_protected] = ACTIONS(4891),
    [sym_public] = ACTIONS(4891),
    [sym_pure] = ACTIONS(4891),
    [sym_ref] = ACTIONS(4891),
    [sym_return] = ACTIONS(4891),
    [sym_scope] = ACTIONS(4891),
    [sym_shared] = ACTIONS(4891),
    [sym_static] = ACTIONS(4891),
    [sym_struct] = ACTIONS(4891),
    [sym_synchronized] = ACTIONS(4891),
    [sym_template] = ACTIONS(4891),
    [sym_typeof] = ACTIONS(4891),
    [sym_union] = ACTIONS(4891),
    [sym_unittest] = ACTIONS(4891),
    [sym_version] = ACTIONS(4891),
    [sym_while] = ACTIONS(4891),
    [sym_gshared] = ACTIONS(4891),
    [sym_traits] = ACTIONS(4891),
    [sym_vector] = ACTIONS(4891),
    [sym_void] = ACTIONS(4891),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2235] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(6076),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5042),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2236] = {
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [sym_bool] = ACTIONS(2638),
    [sym_byte] = ACTIONS(2638),
    [sym_ubyte] = ACTIONS(2638),
    [sym_char] = ACTIONS(2638),
    [sym_short] = ACTIONS(2638),
    [sym_ushort] = ACTIONS(2638),
    [sym_int] = ACTIONS(2638),
    [sym_uint] = ACTIONS(2638),
    [sym_long] = ACTIONS(2638),
    [sym_ulong] = ACTIONS(2638),
    [sym_cent] = ACTIONS(2638),
    [sym_ucent] = ACTIONS(2638),
    [sym_wchar] = ACTIONS(2638),
    [sym_dchar] = ACTIONS(2638),
    [sym_float] = ACTIONS(2638),
    [sym_double] = ACTIONS(2638),
    [sym_real] = ACTIONS(2638),
    [sym_ifloat] = ACTIONS(2638),
    [sym_idouble] = ACTIONS(2638),
    [sym_ireal] = ACTIONS(2638),
    [sym_cfloat] = ACTIONS(2638),
    [sym_cdouble] = ACTIONS(2638),
    [sym_creal] = ACTIONS(2638),
    [sym_size_t] = ACTIONS(2638),
    [sym_ptrdiff_t] = ACTIONS(2638),
    [sym_string] = ACTIONS(2638),
    [sym_cstring] = ACTIONS(2638),
    [sym_dstring] = ACTIONS(2638),
    [sym_wstring] = ACTIONS(2638),
    [sym_noreturn] = ACTIONS(2638),
    [sym_this] = ACTIONS(2638),
    [sym_abstract] = ACTIONS(2638),
    [sym_alias] = ACTIONS(2638),
    [sym_align] = ACTIONS(2638),
    [sym_auto] = ACTIONS(2638),
    [sym_catch] = ACTIONS(2638),
    [sym_class] = ACTIONS(2638),
    [sym_const] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(2638),
    [sym_export] = ACTIONS(2638),
    [sym_extern] = ACTIONS(2638),
    [sym_final] = ACTIONS(2638),
    [sym_finally] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(2638),
    [sym_import] = ACTIONS(2638),
    [sym_inout] = ACTIONS(2638),
    [sym_interface] = ACTIONS(2638),
    [sym_invariant] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(2638),
    [sym_override] = ACTIONS(2638),
    [sym_package] = ACTIONS(2638),
    [sym_pragma] = ACTIONS(2638),
    [sym_private] = ACTIONS(2638),
    [sym_protected] = ACTIONS(2638),
    [sym_public] = ACTIONS(2638),
    [sym_pure] = ACTIONS(2638),
    [sym_ref] = ACTIONS(2638),
    [sym_return] = ACTIONS(2638),
    [sym_scope] = ACTIONS(2638),
    [sym_shared] = ACTIONS(2638),
    [sym_static] = ACTIONS(2638),
    [sym_struct] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(2638),
    [sym_template] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(2638),
    [sym_union] = ACTIONS(2638),
    [sym_unittest] = ACTIONS(2638),
    [sym_version] = ACTIONS(2638),
    [sym_while] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(2638),
    [sym_traits] = ACTIONS(2638),
    [sym_vector] = ACTIONS(2638),
    [sym_void] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2237] = {
    [ts_builtin_sym_end] = ACTIONS(4446),
    [sym_identifier] = ACTIONS(4444),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_AT] = ACTIONS(4446),
    [sym_bool] = ACTIONS(4444),
    [sym_byte] = ACTIONS(4444),
    [sym_ubyte] = ACTIONS(4444),
    [sym_char] = ACTIONS(4444),
    [sym_short] = ACTIONS(4444),
    [sym_ushort] = ACTIONS(4444),
    [sym_int] = ACTIONS(4444),
    [sym_uint] = ACTIONS(4444),
    [sym_long] = ACTIONS(4444),
    [sym_ulong] = ACTIONS(4444),
    [sym_cent] = ACTIONS(4444),
    [sym_ucent] = ACTIONS(4444),
    [sym_wchar] = ACTIONS(4444),
    [sym_dchar] = ACTIONS(4444),
    [sym_float] = ACTIONS(4444),
    [sym_double] = ACTIONS(4444),
    [sym_real] = ACTIONS(4444),
    [sym_ifloat] = ACTIONS(4444),
    [sym_idouble] = ACTIONS(4444),
    [sym_ireal] = ACTIONS(4444),
    [sym_cfloat] = ACTIONS(4444),
    [sym_cdouble] = ACTIONS(4444),
    [sym_creal] = ACTIONS(4444),
    [sym_size_t] = ACTIONS(4444),
    [sym_ptrdiff_t] = ACTIONS(4444),
    [sym_string] = ACTIONS(4444),
    [sym_cstring] = ACTIONS(4444),
    [sym_dstring] = ACTIONS(4444),
    [sym_wstring] = ACTIONS(4444),
    [sym_noreturn] = ACTIONS(4444),
    [sym_this] = ACTIONS(4444),
    [sym_abstract] = ACTIONS(4444),
    [sym_alias] = ACTIONS(4444),
    [sym_align] = ACTIONS(4444),
    [sym_auto] = ACTIONS(4444),
    [sym_class] = ACTIONS(4444),
    [sym_const] = ACTIONS(4444),
    [sym_debug] = ACTIONS(4444),
    [sym_deprecated] = ACTIONS(4444),
    [sym_else] = ACTIONS(4444),
    [sym_enum] = ACTIONS(4444),
    [sym_export] = ACTIONS(4444),
    [sym_extern] = ACTIONS(4444),
    [sym_final] = ACTIONS(4444),
    [sym_immutable] = ACTIONS(4444),
    [sym_import] = ACTIONS(4444),
    [sym_inout] = ACTIONS(4444),
    [sym_interface] = ACTIONS(4444),
    [sym_invariant] = ACTIONS(4444),
    [sym_mixin] = ACTIONS(4444),
    [sym_nothrow] = ACTIONS(4444),
    [sym_override] = ACTIONS(4444),
    [sym_package] = ACTIONS(4444),
    [sym_pragma] = ACTIONS(4444),
    [sym_private] = ACTIONS(4444),
    [sym_protected] = ACTIONS(4444),
    [sym_public] = ACTIONS(4444),
    [sym_pure] = ACTIONS(4444),
    [sym_ref] = ACTIONS(4444),
    [sym_return] = ACTIONS(4444),
    [sym_scope] = ACTIONS(4444),
    [sym_shared] = ACTIONS(4444),
    [sym_static] = ACTIONS(4444),
    [sym_struct] = ACTIONS(4444),
    [sym_synchronized] = ACTIONS(4444),
    [sym_template] = ACTIONS(4444),
    [sym_typeof] = ACTIONS(4444),
    [sym_union] = ACTIONS(4444),
    [sym_unittest] = ACTIONS(4444),
    [sym_version] = ACTIONS(4444),
    [sym_while] = ACTIONS(4444),
    [sym_gshared] = ACTIONS(4444),
    [sym_traits] = ACTIONS(4444),
    [sym_vector] = ACTIONS(4444),
    [sym_void] = ACTIONS(4444),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2238] = {
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4484),
    [anon_sym_AT] = ACTIONS(4484),
    [sym_bool] = ACTIONS(4482),
    [sym_byte] = ACTIONS(4482),
    [sym_ubyte] = ACTIONS(4482),
    [sym_char] = ACTIONS(4482),
    [sym_short] = ACTIONS(4482),
    [sym_ushort] = ACTIONS(4482),
    [sym_int] = ACTIONS(4482),
    [sym_uint] = ACTIONS(4482),
    [sym_long] = ACTIONS(4482),
    [sym_ulong] = ACTIONS(4482),
    [sym_cent] = ACTIONS(4482),
    [sym_ucent] = ACTIONS(4482),
    [sym_wchar] = ACTIONS(4482),
    [sym_dchar] = ACTIONS(4482),
    [sym_float] = ACTIONS(4482),
    [sym_double] = ACTIONS(4482),
    [sym_real] = ACTIONS(4482),
    [sym_ifloat] = ACTIONS(4482),
    [sym_idouble] = ACTIONS(4482),
    [sym_ireal] = ACTIONS(4482),
    [sym_cfloat] = ACTIONS(4482),
    [sym_cdouble] = ACTIONS(4482),
    [sym_creal] = ACTIONS(4482),
    [sym_size_t] = ACTIONS(4482),
    [sym_ptrdiff_t] = ACTIONS(4482),
    [sym_string] = ACTIONS(4482),
    [sym_cstring] = ACTIONS(4482),
    [sym_dstring] = ACTIONS(4482),
    [sym_wstring] = ACTIONS(4482),
    [sym_noreturn] = ACTIONS(4482),
    [sym_this] = ACTIONS(4482),
    [sym_abstract] = ACTIONS(4482),
    [sym_alias] = ACTIONS(4482),
    [sym_align] = ACTIONS(4482),
    [sym_auto] = ACTIONS(4482),
    [sym_catch] = ACTIONS(4482),
    [sym_class] = ACTIONS(4482),
    [sym_const] = ACTIONS(4482),
    [sym_debug] = ACTIONS(4482),
    [sym_deprecated] = ACTIONS(4482),
    [sym_else] = ACTIONS(4482),
    [sym_enum] = ACTIONS(4482),
    [sym_export] = ACTIONS(4482),
    [sym_extern] = ACTIONS(4482),
    [sym_final] = ACTIONS(4482),
    [sym_finally] = ACTIONS(4482),
    [sym_immutable] = ACTIONS(4482),
    [sym_import] = ACTIONS(4482),
    [sym_inout] = ACTIONS(4482),
    [sym_interface] = ACTIONS(4482),
    [sym_invariant] = ACTIONS(4482),
    [sym_mixin] = ACTIONS(4482),
    [sym_nothrow] = ACTIONS(4482),
    [sym_override] = ACTIONS(4482),
    [sym_package] = ACTIONS(4482),
    [sym_pragma] = ACTIONS(4482),
    [sym_private] = ACTIONS(4482),
    [sym_protected] = ACTIONS(4482),
    [sym_public] = ACTIONS(4482),
    [sym_pure] = ACTIONS(4482),
    [sym_ref] = ACTIONS(4482),
    [sym_return] = ACTIONS(4482),
    [sym_scope] = ACTIONS(4482),
    [sym_shared] = ACTIONS(4482),
    [sym_static] = ACTIONS(4482),
    [sym_struct] = ACTIONS(4482),
    [sym_synchronized] = ACTIONS(4482),
    [sym_template] = ACTIONS(4482),
    [sym_typeof] = ACTIONS(4482),
    [sym_union] = ACTIONS(4482),
    [sym_unittest] = ACTIONS(4482),
    [sym_version] = ACTIONS(4482),
    [sym_while] = ACTIONS(4482),
    [sym_gshared] = ACTIONS(4482),
    [sym_traits] = ACTIONS(4482),
    [sym_vector] = ACTIONS(4482),
    [sym_void] = ACTIONS(4482),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2239] = {
    [ts_builtin_sym_end] = ACTIONS(4352),
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_RBRACE] = ACTIONS(4352),
    [anon_sym_DOT] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4352),
    [anon_sym_AT] = ACTIONS(4352),
    [sym_bool] = ACTIONS(4350),
    [sym_byte] = ACTIONS(4350),
    [sym_ubyte] = ACTIONS(4350),
    [sym_char] = ACTIONS(4350),
    [sym_short] = ACTIONS(4350),
    [sym_ushort] = ACTIONS(4350),
    [sym_int] = ACTIONS(4350),
    [sym_uint] = ACTIONS(4350),
    [sym_long] = ACTIONS(4350),
    [sym_ulong] = ACTIONS(4350),
    [sym_cent] = ACTIONS(4350),
    [sym_ucent] = ACTIONS(4350),
    [sym_wchar] = ACTIONS(4350),
    [sym_dchar] = ACTIONS(4350),
    [sym_float] = ACTIONS(4350),
    [sym_double] = ACTIONS(4350),
    [sym_real] = ACTIONS(4350),
    [sym_ifloat] = ACTIONS(4350),
    [sym_idouble] = ACTIONS(4350),
    [sym_ireal] = ACTIONS(4350),
    [sym_cfloat] = ACTIONS(4350),
    [sym_cdouble] = ACTIONS(4350),
    [sym_creal] = ACTIONS(4350),
    [sym_size_t] = ACTIONS(4350),
    [sym_ptrdiff_t] = ACTIONS(4350),
    [sym_string] = ACTIONS(4350),
    [sym_cstring] = ACTIONS(4350),
    [sym_dstring] = ACTIONS(4350),
    [sym_wstring] = ACTIONS(4350),
    [sym_noreturn] = ACTIONS(4350),
    [sym_this] = ACTIONS(4350),
    [sym_abstract] = ACTIONS(4350),
    [sym_alias] = ACTIONS(4350),
    [sym_align] = ACTIONS(4350),
    [sym_auto] = ACTIONS(4350),
    [sym_class] = ACTIONS(4350),
    [sym_const] = ACTIONS(4350),
    [sym_debug] = ACTIONS(4350),
    [sym_deprecated] = ACTIONS(4350),
    [sym_else] = ACTIONS(4350),
    [sym_enum] = ACTIONS(4350),
    [sym_export] = ACTIONS(4350),
    [sym_extern] = ACTIONS(4350),
    [sym_final] = ACTIONS(4350),
    [sym_immutable] = ACTIONS(4350),
    [sym_import] = ACTIONS(4350),
    [sym_inout] = ACTIONS(4350),
    [sym_interface] = ACTIONS(4350),
    [sym_invariant] = ACTIONS(4350),
    [sym_mixin] = ACTIONS(4350),
    [sym_nothrow] = ACTIONS(4350),
    [sym_override] = ACTIONS(4350),
    [sym_package] = ACTIONS(4350),
    [sym_pragma] = ACTIONS(4350),
    [sym_private] = ACTIONS(4350),
    [sym_protected] = ACTIONS(4350),
    [sym_public] = ACTIONS(4350),
    [sym_pure] = ACTIONS(4350),
    [sym_ref] = ACTIONS(4350),
    [sym_return] = ACTIONS(4350),
    [sym_scope] = ACTIONS(4350),
    [sym_shared] = ACTIONS(4350),
    [sym_static] = ACTIONS(4350),
    [sym_struct] = ACTIONS(4350),
    [sym_synchronized] = ACTIONS(4350),
    [sym_template] = ACTIONS(4350),
    [sym_typeof] = ACTIONS(4350),
    [sym_union] = ACTIONS(4350),
    [sym_unittest] = ACTIONS(4350),
    [sym_version] = ACTIONS(4350),
    [sym_while] = ACTIONS(4350),
    [sym_gshared] = ACTIONS(4350),
    [sym_traits] = ACTIONS(4350),
    [sym_vector] = ACTIONS(4350),
    [sym_void] = ACTIONS(4350),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2240] = {
    [ts_builtin_sym_end] = ACTIONS(4450),
    [sym_identifier] = ACTIONS(4448),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_DOT] = ACTIONS(4450),
    [anon_sym_SEMI] = ACTIONS(4450),
    [anon_sym_TILDE] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4450),
    [sym_bool] = ACTIONS(4448),
    [sym_byte] = ACTIONS(4448),
    [sym_ubyte] = ACTIONS(4448),
    [sym_char] = ACTIONS(4448),
    [sym_short] = ACTIONS(4448),
    [sym_ushort] = ACTIONS(4448),
    [sym_int] = ACTIONS(4448),
    [sym_uint] = ACTIONS(4448),
    [sym_long] = ACTIONS(4448),
    [sym_ulong] = ACTIONS(4448),
    [sym_cent] = ACTIONS(4448),
    [sym_ucent] = ACTIONS(4448),
    [sym_wchar] = ACTIONS(4448),
    [sym_dchar] = ACTIONS(4448),
    [sym_float] = ACTIONS(4448),
    [sym_double] = ACTIONS(4448),
    [sym_real] = ACTIONS(4448),
    [sym_ifloat] = ACTIONS(4448),
    [sym_idouble] = ACTIONS(4448),
    [sym_ireal] = ACTIONS(4448),
    [sym_cfloat] = ACTIONS(4448),
    [sym_cdouble] = ACTIONS(4448),
    [sym_creal] = ACTIONS(4448),
    [sym_size_t] = ACTIONS(4448),
    [sym_ptrdiff_t] = ACTIONS(4448),
    [sym_string] = ACTIONS(4448),
    [sym_cstring] = ACTIONS(4448),
    [sym_dstring] = ACTIONS(4448),
    [sym_wstring] = ACTIONS(4448),
    [sym_noreturn] = ACTIONS(4448),
    [sym_this] = ACTIONS(4448),
    [sym_abstract] = ACTIONS(4448),
    [sym_alias] = ACTIONS(4448),
    [sym_align] = ACTIONS(4448),
    [sym_auto] = ACTIONS(4448),
    [sym_class] = ACTIONS(4448),
    [sym_const] = ACTIONS(4448),
    [sym_debug] = ACTIONS(4448),
    [sym_deprecated] = ACTIONS(4448),
    [sym_else] = ACTIONS(4448),
    [sym_enum] = ACTIONS(4448),
    [sym_export] = ACTIONS(4448),
    [sym_extern] = ACTIONS(4448),
    [sym_final] = ACTIONS(4448),
    [sym_immutable] = ACTIONS(4448),
    [sym_import] = ACTIONS(4448),
    [sym_inout] = ACTIONS(4448),
    [sym_interface] = ACTIONS(4448),
    [sym_invariant] = ACTIONS(4448),
    [sym_mixin] = ACTIONS(4448),
    [sym_nothrow] = ACTIONS(4448),
    [sym_override] = ACTIONS(4448),
    [sym_package] = ACTIONS(4448),
    [sym_pragma] = ACTIONS(4448),
    [sym_private] = ACTIONS(4448),
    [sym_protected] = ACTIONS(4448),
    [sym_public] = ACTIONS(4448),
    [sym_pure] = ACTIONS(4448),
    [sym_ref] = ACTIONS(4448),
    [sym_return] = ACTIONS(4448),
    [sym_scope] = ACTIONS(4448),
    [sym_shared] = ACTIONS(4448),
    [sym_static] = ACTIONS(4448),
    [sym_struct] = ACTIONS(4448),
    [sym_synchronized] = ACTIONS(4448),
    [sym_template] = ACTIONS(4448),
    [sym_typeof] = ACTIONS(4448),
    [sym_union] = ACTIONS(4448),
    [sym_unittest] = ACTIONS(4448),
    [sym_version] = ACTIONS(4448),
    [sym_while] = ACTIONS(4448),
    [sym_gshared] = ACTIONS(4448),
    [sym_traits] = ACTIONS(4448),
    [sym_vector] = ACTIONS(4448),
    [sym_void] = ACTIONS(4448),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2241] = {
    [ts_builtin_sym_end] = ACTIONS(4348),
    [sym_identifier] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4348),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4348),
    [anon_sym_AT] = ACTIONS(4348),
    [sym_bool] = ACTIONS(4346),
    [sym_byte] = ACTIONS(4346),
    [sym_ubyte] = ACTIONS(4346),
    [sym_char] = ACTIONS(4346),
    [sym_short] = ACTIONS(4346),
    [sym_ushort] = ACTIONS(4346),
    [sym_int] = ACTIONS(4346),
    [sym_uint] = ACTIONS(4346),
    [sym_long] = ACTIONS(4346),
    [sym_ulong] = ACTIONS(4346),
    [sym_cent] = ACTIONS(4346),
    [sym_ucent] = ACTIONS(4346),
    [sym_wchar] = ACTIONS(4346),
    [sym_dchar] = ACTIONS(4346),
    [sym_float] = ACTIONS(4346),
    [sym_double] = ACTIONS(4346),
    [sym_real] = ACTIONS(4346),
    [sym_ifloat] = ACTIONS(4346),
    [sym_idouble] = ACTIONS(4346),
    [sym_ireal] = ACTIONS(4346),
    [sym_cfloat] = ACTIONS(4346),
    [sym_cdouble] = ACTIONS(4346),
    [sym_creal] = ACTIONS(4346),
    [sym_size_t] = ACTIONS(4346),
    [sym_ptrdiff_t] = ACTIONS(4346),
    [sym_string] = ACTIONS(4346),
    [sym_cstring] = ACTIONS(4346),
    [sym_dstring] = ACTIONS(4346),
    [sym_wstring] = ACTIONS(4346),
    [sym_noreturn] = ACTIONS(4346),
    [sym_this] = ACTIONS(4346),
    [sym_abstract] = ACTIONS(4346),
    [sym_alias] = ACTIONS(4346),
    [sym_align] = ACTIONS(4346),
    [sym_auto] = ACTIONS(4346),
    [sym_class] = ACTIONS(4346),
    [sym_const] = ACTIONS(4346),
    [sym_debug] = ACTIONS(4346),
    [sym_deprecated] = ACTIONS(4346),
    [sym_else] = ACTIONS(4346),
    [sym_enum] = ACTIONS(4346),
    [sym_export] = ACTIONS(4346),
    [sym_extern] = ACTIONS(4346),
    [sym_final] = ACTIONS(4346),
    [sym_immutable] = ACTIONS(4346),
    [sym_import] = ACTIONS(4346),
    [sym_inout] = ACTIONS(4346),
    [sym_interface] = ACTIONS(4346),
    [sym_invariant] = ACTIONS(4346),
    [sym_mixin] = ACTIONS(4346),
    [sym_nothrow] = ACTIONS(4346),
    [sym_override] = ACTIONS(4346),
    [sym_package] = ACTIONS(4346),
    [sym_pragma] = ACTIONS(4346),
    [sym_private] = ACTIONS(4346),
    [sym_protected] = ACTIONS(4346),
    [sym_public] = ACTIONS(4346),
    [sym_pure] = ACTIONS(4346),
    [sym_ref] = ACTIONS(4346),
    [sym_return] = ACTIONS(4346),
    [sym_scope] = ACTIONS(4346),
    [sym_shared] = ACTIONS(4346),
    [sym_static] = ACTIONS(4346),
    [sym_struct] = ACTIONS(4346),
    [sym_synchronized] = ACTIONS(4346),
    [sym_template] = ACTIONS(4346),
    [sym_typeof] = ACTIONS(4346),
    [sym_union] = ACTIONS(4346),
    [sym_unittest] = ACTIONS(4346),
    [sym_version] = ACTIONS(4346),
    [sym_while] = ACTIONS(4346),
    [sym_gshared] = ACTIONS(4346),
    [sym_traits] = ACTIONS(4346),
    [sym_vector] = ACTIONS(4346),
    [sym_void] = ACTIONS(4346),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2242] = {
    [sym_identifier] = ACTIONS(4490),
    [anon_sym_DOT] = ACTIONS(4492),
    [anon_sym_SEMI] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4492),
    [anon_sym_AT] = ACTIONS(4492),
    [sym_bool] = ACTIONS(4490),
    [sym_byte] = ACTIONS(4490),
    [sym_ubyte] = ACTIONS(4490),
    [sym_char] = ACTIONS(4490),
    [sym_short] = ACTIONS(4490),
    [sym_ushort] = ACTIONS(4490),
    [sym_int] = ACTIONS(4490),
    [sym_uint] = ACTIONS(4490),
    [sym_long] = ACTIONS(4490),
    [sym_ulong] = ACTIONS(4490),
    [sym_cent] = ACTIONS(4490),
    [sym_ucent] = ACTIONS(4490),
    [sym_wchar] = ACTIONS(4490),
    [sym_dchar] = ACTIONS(4490),
    [sym_float] = ACTIONS(4490),
    [sym_double] = ACTIONS(4490),
    [sym_real] = ACTIONS(4490),
    [sym_ifloat] = ACTIONS(4490),
    [sym_idouble] = ACTIONS(4490),
    [sym_ireal] = ACTIONS(4490),
    [sym_cfloat] = ACTIONS(4490),
    [sym_cdouble] = ACTIONS(4490),
    [sym_creal] = ACTIONS(4490),
    [sym_size_t] = ACTIONS(4490),
    [sym_ptrdiff_t] = ACTIONS(4490),
    [sym_string] = ACTIONS(4490),
    [sym_cstring] = ACTIONS(4490),
    [sym_dstring] = ACTIONS(4490),
    [sym_wstring] = ACTIONS(4490),
    [sym_noreturn] = ACTIONS(4490),
    [sym_this] = ACTIONS(4490),
    [sym_abstract] = ACTIONS(4490),
    [sym_alias] = ACTIONS(4490),
    [sym_align] = ACTIONS(4490),
    [sym_auto] = ACTIONS(4490),
    [sym_catch] = ACTIONS(4490),
    [sym_class] = ACTIONS(4490),
    [sym_const] = ACTIONS(4490),
    [sym_debug] = ACTIONS(4490),
    [sym_deprecated] = ACTIONS(4490),
    [sym_else] = ACTIONS(4490),
    [sym_enum] = ACTIONS(4490),
    [sym_export] = ACTIONS(4490),
    [sym_extern] = ACTIONS(4490),
    [sym_final] = ACTIONS(4490),
    [sym_finally] = ACTIONS(4490),
    [sym_immutable] = ACTIONS(4490),
    [sym_import] = ACTIONS(4490),
    [sym_inout] = ACTIONS(4490),
    [sym_interface] = ACTIONS(4490),
    [sym_invariant] = ACTIONS(4490),
    [sym_mixin] = ACTIONS(4490),
    [sym_nothrow] = ACTIONS(4490),
    [sym_override] = ACTIONS(4490),
    [sym_package] = ACTIONS(4490),
    [sym_pragma] = ACTIONS(4490),
    [sym_private] = ACTIONS(4490),
    [sym_protected] = ACTIONS(4490),
    [sym_public] = ACTIONS(4490),
    [sym_pure] = ACTIONS(4490),
    [sym_ref] = ACTIONS(4490),
    [sym_return] = ACTIONS(4490),
    [sym_scope] = ACTIONS(4490),
    [sym_shared] = ACTIONS(4490),
    [sym_static] = ACTIONS(4490),
    [sym_struct] = ACTIONS(4490),
    [sym_synchronized] = ACTIONS(4490),
    [sym_template] = ACTIONS(4490),
    [sym_typeof] = ACTIONS(4490),
    [sym_union] = ACTIONS(4490),
    [sym_unittest] = ACTIONS(4490),
    [sym_version] = ACTIONS(4490),
    [sym_while] = ACTIONS(4490),
    [sym_gshared] = ACTIONS(4490),
    [sym_traits] = ACTIONS(4490),
    [sym_vector] = ACTIONS(4490),
    [sym_void] = ACTIONS(4490),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2243] = {
    [ts_builtin_sym_end] = ACTIONS(4454),
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_RBRACE] = ACTIONS(4454),
    [anon_sym_DOT] = ACTIONS(4454),
    [anon_sym_SEMI] = ACTIONS(4454),
    [anon_sym_TILDE] = ACTIONS(4454),
    [anon_sym_AT] = ACTIONS(4454),
    [sym_bool] = ACTIONS(4452),
    [sym_byte] = ACTIONS(4452),
    [sym_ubyte] = ACTIONS(4452),
    [sym_char] = ACTIONS(4452),
    [sym_short] = ACTIONS(4452),
    [sym_ushort] = ACTIONS(4452),
    [sym_int] = ACTIONS(4452),
    [sym_uint] = ACTIONS(4452),
    [sym_long] = ACTIONS(4452),
    [sym_ulong] = ACTIONS(4452),
    [sym_cent] = ACTIONS(4452),
    [sym_ucent] = ACTIONS(4452),
    [sym_wchar] = ACTIONS(4452),
    [sym_dchar] = ACTIONS(4452),
    [sym_float] = ACTIONS(4452),
    [sym_double] = ACTIONS(4452),
    [sym_real] = ACTIONS(4452),
    [sym_ifloat] = ACTIONS(4452),
    [sym_idouble] = ACTIONS(4452),
    [sym_ireal] = ACTIONS(4452),
    [sym_cfloat] = ACTIONS(4452),
    [sym_cdouble] = ACTIONS(4452),
    [sym_creal] = ACTIONS(4452),
    [sym_size_t] = ACTIONS(4452),
    [sym_ptrdiff_t] = ACTIONS(4452),
    [sym_string] = ACTIONS(4452),
    [sym_cstring] = ACTIONS(4452),
    [sym_dstring] = ACTIONS(4452),
    [sym_wstring] = ACTIONS(4452),
    [sym_noreturn] = ACTIONS(4452),
    [sym_this] = ACTIONS(4452),
    [sym_abstract] = ACTIONS(4452),
    [sym_alias] = ACTIONS(4452),
    [sym_align] = ACTIONS(4452),
    [sym_auto] = ACTIONS(4452),
    [sym_class] = ACTIONS(4452),
    [sym_const] = ACTIONS(4452),
    [sym_debug] = ACTIONS(4452),
    [sym_deprecated] = ACTIONS(4452),
    [sym_else] = ACTIONS(4452),
    [sym_enum] = ACTIONS(4452),
    [sym_export] = ACTIONS(4452),
    [sym_extern] = ACTIONS(4452),
    [sym_final] = ACTIONS(4452),
    [sym_immutable] = ACTIONS(4452),
    [sym_import] = ACTIONS(4452),
    [sym_inout] = ACTIONS(4452),
    [sym_interface] = ACTIONS(4452),
    [sym_invariant] = ACTIONS(4452),
    [sym_mixin] = ACTIONS(4452),
    [sym_nothrow] = ACTIONS(4452),
    [sym_override] = ACTIONS(4452),
    [sym_package] = ACTIONS(4452),
    [sym_pragma] = ACTIONS(4452),
    [sym_private] = ACTIONS(4452),
    [sym_protected] = ACTIONS(4452),
    [sym_public] = ACTIONS(4452),
    [sym_pure] = ACTIONS(4452),
    [sym_ref] = ACTIONS(4452),
    [sym_return] = ACTIONS(4452),
    [sym_scope] = ACTIONS(4452),
    [sym_shared] = ACTIONS(4452),
    [sym_static] = ACTIONS(4452),
    [sym_struct] = ACTIONS(4452),
    [sym_synchronized] = ACTIONS(4452),
    [sym_template] = ACTIONS(4452),
    [sym_typeof] = ACTIONS(4452),
    [sym_union] = ACTIONS(4452),
    [sym_unittest] = ACTIONS(4452),
    [sym_version] = ACTIONS(4452),
    [sym_while] = ACTIONS(4452),
    [sym_gshared] = ACTIONS(4452),
    [sym_traits] = ACTIONS(4452),
    [sym_vector] = ACTIONS(4452),
    [sym_void] = ACTIONS(4452),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2244] = {
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_DOT] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [anon_sym_AT] = ACTIONS(4731),
    [sym_bool] = ACTIONS(4729),
    [sym_byte] = ACTIONS(4729),
    [sym_ubyte] = ACTIONS(4729),
    [sym_char] = ACTIONS(4729),
    [sym_short] = ACTIONS(4729),
    [sym_ushort] = ACTIONS(4729),
    [sym_int] = ACTIONS(4729),
    [sym_uint] = ACTIONS(4729),
    [sym_long] = ACTIONS(4729),
    [sym_ulong] = ACTIONS(4729),
    [sym_cent] = ACTIONS(4729),
    [sym_ucent] = ACTIONS(4729),
    [sym_wchar] = ACTIONS(4729),
    [sym_dchar] = ACTIONS(4729),
    [sym_float] = ACTIONS(4729),
    [sym_double] = ACTIONS(4729),
    [sym_real] = ACTIONS(4729),
    [sym_ifloat] = ACTIONS(4729),
    [sym_idouble] = ACTIONS(4729),
    [sym_ireal] = ACTIONS(4729),
    [sym_cfloat] = ACTIONS(4729),
    [sym_cdouble] = ACTIONS(4729),
    [sym_creal] = ACTIONS(4729),
    [sym_size_t] = ACTIONS(4729),
    [sym_ptrdiff_t] = ACTIONS(4729),
    [sym_string] = ACTIONS(4729),
    [sym_cstring] = ACTIONS(4729),
    [sym_dstring] = ACTIONS(4729),
    [sym_wstring] = ACTIONS(4729),
    [sym_noreturn] = ACTIONS(4729),
    [sym_this] = ACTIONS(4729),
    [sym_abstract] = ACTIONS(4729),
    [sym_alias] = ACTIONS(4729),
    [sym_align] = ACTIONS(4729),
    [sym_auto] = ACTIONS(4729),
    [sym_catch] = ACTIONS(4729),
    [sym_class] = ACTIONS(4729),
    [sym_const] = ACTIONS(4729),
    [sym_debug] = ACTIONS(4729),
    [sym_deprecated] = ACTIONS(4729),
    [sym_else] = ACTIONS(4729),
    [sym_enum] = ACTIONS(4729),
    [sym_export] = ACTIONS(4729),
    [sym_extern] = ACTIONS(4729),
    [sym_final] = ACTIONS(4729),
    [sym_finally] = ACTIONS(4729),
    [sym_immutable] = ACTIONS(4729),
    [sym_import] = ACTIONS(4729),
    [sym_inout] = ACTIONS(4729),
    [sym_interface] = ACTIONS(4729),
    [sym_invariant] = ACTIONS(4729),
    [sym_mixin] = ACTIONS(4729),
    [sym_nothrow] = ACTIONS(4729),
    [sym_override] = ACTIONS(4729),
    [sym_package] = ACTIONS(4729),
    [sym_pragma] = ACTIONS(4729),
    [sym_private] = ACTIONS(4729),
    [sym_protected] = ACTIONS(4729),
    [sym_public] = ACTIONS(4729),
    [sym_pure] = ACTIONS(4729),
    [sym_ref] = ACTIONS(4729),
    [sym_return] = ACTIONS(4729),
    [sym_scope] = ACTIONS(4729),
    [sym_shared] = ACTIONS(4729),
    [sym_static] = ACTIONS(4729),
    [sym_struct] = ACTIONS(4729),
    [sym_synchronized] = ACTIONS(4729),
    [sym_template] = ACTIONS(4729),
    [sym_typeof] = ACTIONS(4729),
    [sym_union] = ACTIONS(4729),
    [sym_unittest] = ACTIONS(4729),
    [sym_version] = ACTIONS(4729),
    [sym_while] = ACTIONS(4729),
    [sym_gshared] = ACTIONS(4729),
    [sym_traits] = ACTIONS(4729),
    [sym_vector] = ACTIONS(4729),
    [sym_void] = ACTIONS(4729),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2245] = {
    [sym_identifier] = ACTIONS(4494),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AT] = ACTIONS(4496),
    [sym_bool] = ACTIONS(4494),
    [sym_byte] = ACTIONS(4494),
    [sym_ubyte] = ACTIONS(4494),
    [sym_char] = ACTIONS(4494),
    [sym_short] = ACTIONS(4494),
    [sym_ushort] = ACTIONS(4494),
    [sym_int] = ACTIONS(4494),
    [sym_uint] = ACTIONS(4494),
    [sym_long] = ACTIONS(4494),
    [sym_ulong] = ACTIONS(4494),
    [sym_cent] = ACTIONS(4494),
    [sym_ucent] = ACTIONS(4494),
    [sym_wchar] = ACTIONS(4494),
    [sym_dchar] = ACTIONS(4494),
    [sym_float] = ACTIONS(4494),
    [sym_double] = ACTIONS(4494),
    [sym_real] = ACTIONS(4494),
    [sym_ifloat] = ACTIONS(4494),
    [sym_idouble] = ACTIONS(4494),
    [sym_ireal] = ACTIONS(4494),
    [sym_cfloat] = ACTIONS(4494),
    [sym_cdouble] = ACTIONS(4494),
    [sym_creal] = ACTIONS(4494),
    [sym_size_t] = ACTIONS(4494),
    [sym_ptrdiff_t] = ACTIONS(4494),
    [sym_string] = ACTIONS(4494),
    [sym_cstring] = ACTIONS(4494),
    [sym_dstring] = ACTIONS(4494),
    [sym_wstring] = ACTIONS(4494),
    [sym_noreturn] = ACTIONS(4494),
    [sym_this] = ACTIONS(4494),
    [sym_abstract] = ACTIONS(4494),
    [sym_alias] = ACTIONS(4494),
    [sym_align] = ACTIONS(4494),
    [sym_auto] = ACTIONS(4494),
    [sym_catch] = ACTIONS(4494),
    [sym_class] = ACTIONS(4494),
    [sym_const] = ACTIONS(4494),
    [sym_debug] = ACTIONS(4494),
    [sym_deprecated] = ACTIONS(4494),
    [sym_else] = ACTIONS(4494),
    [sym_enum] = ACTIONS(4494),
    [sym_export] = ACTIONS(4494),
    [sym_extern] = ACTIONS(4494),
    [sym_final] = ACTIONS(4494),
    [sym_finally] = ACTIONS(4494),
    [sym_immutable] = ACTIONS(4494),
    [sym_import] = ACTIONS(4494),
    [sym_inout] = ACTIONS(4494),
    [sym_interface] = ACTIONS(4494),
    [sym_invariant] = ACTIONS(4494),
    [sym_mixin] = ACTIONS(4494),
    [sym_nothrow] = ACTIONS(4494),
    [sym_override] = ACTIONS(4494),
    [sym_package] = ACTIONS(4494),
    [sym_pragma] = ACTIONS(4494),
    [sym_private] = ACTIONS(4494),
    [sym_protected] = ACTIONS(4494),
    [sym_public] = ACTIONS(4494),
    [sym_pure] = ACTIONS(4494),
    [sym_ref] = ACTIONS(4494),
    [sym_return] = ACTIONS(4494),
    [sym_scope] = ACTIONS(4494),
    [sym_shared] = ACTIONS(4494),
    [sym_static] = ACTIONS(4494),
    [sym_struct] = ACTIONS(4494),
    [sym_synchronized] = ACTIONS(4494),
    [sym_template] = ACTIONS(4494),
    [sym_typeof] = ACTIONS(4494),
    [sym_union] = ACTIONS(4494),
    [sym_unittest] = ACTIONS(4494),
    [sym_version] = ACTIONS(4494),
    [sym_while] = ACTIONS(4494),
    [sym_gshared] = ACTIONS(4494),
    [sym_traits] = ACTIONS(4494),
    [sym_vector] = ACTIONS(4494),
    [sym_void] = ACTIONS(4494),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2246] = {
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_TILDE] = ACTIONS(4749),
    [anon_sym_AT] = ACTIONS(4749),
    [sym_bool] = ACTIONS(4747),
    [sym_byte] = ACTIONS(4747),
    [sym_ubyte] = ACTIONS(4747),
    [sym_char] = ACTIONS(4747),
    [sym_short] = ACTIONS(4747),
    [sym_ushort] = ACTIONS(4747),
    [sym_int] = ACTIONS(4747),
    [sym_uint] = ACTIONS(4747),
    [sym_long] = ACTIONS(4747),
    [sym_ulong] = ACTIONS(4747),
    [sym_cent] = ACTIONS(4747),
    [sym_ucent] = ACTIONS(4747),
    [sym_wchar] = ACTIONS(4747),
    [sym_dchar] = ACTIONS(4747),
    [sym_float] = ACTIONS(4747),
    [sym_double] = ACTIONS(4747),
    [sym_real] = ACTIONS(4747),
    [sym_ifloat] = ACTIONS(4747),
    [sym_idouble] = ACTIONS(4747),
    [sym_ireal] = ACTIONS(4747),
    [sym_cfloat] = ACTIONS(4747),
    [sym_cdouble] = ACTIONS(4747),
    [sym_creal] = ACTIONS(4747),
    [sym_size_t] = ACTIONS(4747),
    [sym_ptrdiff_t] = ACTIONS(4747),
    [sym_string] = ACTIONS(4747),
    [sym_cstring] = ACTIONS(4747),
    [sym_dstring] = ACTIONS(4747),
    [sym_wstring] = ACTIONS(4747),
    [sym_noreturn] = ACTIONS(4747),
    [sym_this] = ACTIONS(4747),
    [sym_abstract] = ACTIONS(4747),
    [sym_alias] = ACTIONS(4747),
    [sym_align] = ACTIONS(4747),
    [sym_auto] = ACTIONS(4747),
    [sym_catch] = ACTIONS(4747),
    [sym_class] = ACTIONS(4747),
    [sym_const] = ACTIONS(4747),
    [sym_debug] = ACTIONS(4747),
    [sym_deprecated] = ACTIONS(4747),
    [sym_else] = ACTIONS(4747),
    [sym_enum] = ACTIONS(4747),
    [sym_export] = ACTIONS(4747),
    [sym_extern] = ACTIONS(4747),
    [sym_final] = ACTIONS(4747),
    [sym_finally] = ACTIONS(4747),
    [sym_immutable] = ACTIONS(4747),
    [sym_import] = ACTIONS(4747),
    [sym_inout] = ACTIONS(4747),
    [sym_interface] = ACTIONS(4747),
    [sym_invariant] = ACTIONS(4747),
    [sym_mixin] = ACTIONS(4747),
    [sym_nothrow] = ACTIONS(4747),
    [sym_override] = ACTIONS(4747),
    [sym_package] = ACTIONS(4747),
    [sym_pragma] = ACTIONS(4747),
    [sym_private] = ACTIONS(4747),
    [sym_protected] = ACTIONS(4747),
    [sym_public] = ACTIONS(4747),
    [sym_pure] = ACTIONS(4747),
    [sym_ref] = ACTIONS(4747),
    [sym_return] = ACTIONS(4747),
    [sym_scope] = ACTIONS(4747),
    [sym_shared] = ACTIONS(4747),
    [sym_static] = ACTIONS(4747),
    [sym_struct] = ACTIONS(4747),
    [sym_synchronized] = ACTIONS(4747),
    [sym_template] = ACTIONS(4747),
    [sym_typeof] = ACTIONS(4747),
    [sym_union] = ACTIONS(4747),
    [sym_unittest] = ACTIONS(4747),
    [sym_version] = ACTIONS(4747),
    [sym_while] = ACTIONS(4747),
    [sym_gshared] = ACTIONS(4747),
    [sym_traits] = ACTIONS(4747),
    [sym_vector] = ACTIONS(4747),
    [sym_void] = ACTIONS(4747),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2247] = {
    [ts_builtin_sym_end] = ACTIONS(4803),
    [sym_identifier] = ACTIONS(4801),
    [anon_sym_RBRACE] = ACTIONS(4803),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [anon_sym_AT] = ACTIONS(4803),
    [sym_bool] = ACTIONS(4801),
    [sym_byte] = ACTIONS(4801),
    [sym_ubyte] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_short] = ACTIONS(4801),
    [sym_ushort] = ACTIONS(4801),
    [sym_int] = ACTIONS(4801),
    [sym_uint] = ACTIONS(4801),
    [sym_long] = ACTIONS(4801),
    [sym_ulong] = ACTIONS(4801),
    [sym_cent] = ACTIONS(4801),
    [sym_ucent] = ACTIONS(4801),
    [sym_wchar] = ACTIONS(4801),
    [sym_dchar] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_double] = ACTIONS(4801),
    [sym_real] = ACTIONS(4801),
    [sym_ifloat] = ACTIONS(4801),
    [sym_idouble] = ACTIONS(4801),
    [sym_ireal] = ACTIONS(4801),
    [sym_cfloat] = ACTIONS(4801),
    [sym_cdouble] = ACTIONS(4801),
    [sym_creal] = ACTIONS(4801),
    [sym_size_t] = ACTIONS(4801),
    [sym_ptrdiff_t] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym_cstring] = ACTIONS(4801),
    [sym_dstring] = ACTIONS(4801),
    [sym_wstring] = ACTIONS(4801),
    [sym_noreturn] = ACTIONS(4801),
    [sym_this] = ACTIONS(4801),
    [sym_abstract] = ACTIONS(4801),
    [sym_alias] = ACTIONS(4801),
    [sym_align] = ACTIONS(4801),
    [sym_auto] = ACTIONS(4801),
    [sym_class] = ACTIONS(4801),
    [sym_const] = ACTIONS(4801),
    [sym_debug] = ACTIONS(4801),
    [sym_deprecated] = ACTIONS(4801),
    [sym_else] = ACTIONS(4801),
    [sym_enum] = ACTIONS(4801),
    [sym_export] = ACTIONS(4801),
    [sym_extern] = ACTIONS(4801),
    [sym_final] = ACTIONS(4801),
    [sym_immutable] = ACTIONS(4801),
    [sym_import] = ACTIONS(4801),
    [sym_inout] = ACTIONS(4801),
    [sym_interface] = ACTIONS(4801),
    [sym_invariant] = ACTIONS(4801),
    [sym_mixin] = ACTIONS(4801),
    [sym_nothrow] = ACTIONS(4801),
    [sym_override] = ACTIONS(4801),
    [sym_package] = ACTIONS(4801),
    [sym_pragma] = ACTIONS(4801),
    [sym_private] = ACTIONS(4801),
    [sym_protected] = ACTIONS(4801),
    [sym_public] = ACTIONS(4801),
    [sym_pure] = ACTIONS(4801),
    [sym_ref] = ACTIONS(4801),
    [sym_return] = ACTIONS(4801),
    [sym_scope] = ACTIONS(4801),
    [sym_shared] = ACTIONS(4801),
    [sym_static] = ACTIONS(4801),
    [sym_struct] = ACTIONS(4801),
    [sym_synchronized] = ACTIONS(4801),
    [sym_template] = ACTIONS(4801),
    [sym_typeof] = ACTIONS(4801),
    [sym_union] = ACTIONS(4801),
    [sym_unittest] = ACTIONS(4801),
    [sym_version] = ACTIONS(4801),
    [sym_while] = ACTIONS(4801),
    [sym_gshared] = ACTIONS(4801),
    [sym_traits] = ACTIONS(4801),
    [sym_vector] = ACTIONS(4801),
    [sym_void] = ACTIONS(4801),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2248] = {
    [ts_builtin_sym_end] = ACTIONS(4901),
    [sym_identifier] = ACTIONS(4899),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_DOT] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_TILDE] = ACTIONS(4901),
    [anon_sym_AT] = ACTIONS(4901),
    [sym_bool] = ACTIONS(4899),
    [sym_byte] = ACTIONS(4899),
    [sym_ubyte] = ACTIONS(4899),
    [sym_char] = ACTIONS(4899),
    [sym_short] = ACTIONS(4899),
    [sym_ushort] = ACTIONS(4899),
    [sym_int] = ACTIONS(4899),
    [sym_uint] = ACTIONS(4899),
    [sym_long] = ACTIONS(4899),
    [sym_ulong] = ACTIONS(4899),
    [sym_cent] = ACTIONS(4899),
    [sym_ucent] = ACTIONS(4899),
    [sym_wchar] = ACTIONS(4899),
    [sym_dchar] = ACTIONS(4899),
    [sym_float] = ACTIONS(4899),
    [sym_double] = ACTIONS(4899),
    [sym_real] = ACTIONS(4899),
    [sym_ifloat] = ACTIONS(4899),
    [sym_idouble] = ACTIONS(4899),
    [sym_ireal] = ACTIONS(4899),
    [sym_cfloat] = ACTIONS(4899),
    [sym_cdouble] = ACTIONS(4899),
    [sym_creal] = ACTIONS(4899),
    [sym_size_t] = ACTIONS(4899),
    [sym_ptrdiff_t] = ACTIONS(4899),
    [sym_string] = ACTIONS(4899),
    [sym_cstring] = ACTIONS(4899),
    [sym_dstring] = ACTIONS(4899),
    [sym_wstring] = ACTIONS(4899),
    [sym_noreturn] = ACTIONS(4899),
    [sym_this] = ACTIONS(4899),
    [sym_abstract] = ACTIONS(4899),
    [sym_alias] = ACTIONS(4899),
    [sym_align] = ACTIONS(4899),
    [sym_auto] = ACTIONS(4899),
    [sym_class] = ACTIONS(4899),
    [sym_const] = ACTIONS(4899),
    [sym_debug] = ACTIONS(4899),
    [sym_deprecated] = ACTIONS(4899),
    [sym_else] = ACTIONS(4899),
    [sym_enum] = ACTIONS(4899),
    [sym_export] = ACTIONS(4899),
    [sym_extern] = ACTIONS(4899),
    [sym_final] = ACTIONS(4899),
    [sym_immutable] = ACTIONS(4899),
    [sym_import] = ACTIONS(4899),
    [sym_inout] = ACTIONS(4899),
    [sym_interface] = ACTIONS(4899),
    [sym_invariant] = ACTIONS(4899),
    [sym_mixin] = ACTIONS(4899),
    [sym_nothrow] = ACTIONS(4899),
    [sym_override] = ACTIONS(4899),
    [sym_package] = ACTIONS(4899),
    [sym_pragma] = ACTIONS(4899),
    [sym_private] = ACTIONS(4899),
    [sym_protected] = ACTIONS(4899),
    [sym_public] = ACTIONS(4899),
    [sym_pure] = ACTIONS(4899),
    [sym_ref] = ACTIONS(4899),
    [sym_return] = ACTIONS(4899),
    [sym_scope] = ACTIONS(4899),
    [sym_shared] = ACTIONS(4899),
    [sym_static] = ACTIONS(4899),
    [sym_struct] = ACTIONS(4899),
    [sym_synchronized] = ACTIONS(4899),
    [sym_template] = ACTIONS(4899),
    [sym_typeof] = ACTIONS(4899),
    [sym_union] = ACTIONS(4899),
    [sym_unittest] = ACTIONS(4899),
    [sym_version] = ACTIONS(4899),
    [sym_while] = ACTIONS(4899),
    [sym_gshared] = ACTIONS(4899),
    [sym_traits] = ACTIONS(4899),
    [sym_vector] = ACTIONS(4899),
    [sym_void] = ACTIONS(4899),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2249] = {
    [sym_identifier] = ACTIONS(4498),
    [anon_sym_DOT] = ACTIONS(4500),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4500),
    [anon_sym_AT] = ACTIONS(4500),
    [sym_bool] = ACTIONS(4498),
    [sym_byte] = ACTIONS(4498),
    [sym_ubyte] = ACTIONS(4498),
    [sym_char] = ACTIONS(4498),
    [sym_short] = ACTIONS(4498),
    [sym_ushort] = ACTIONS(4498),
    [sym_int] = ACTIONS(4498),
    [sym_uint] = ACTIONS(4498),
    [sym_long] = ACTIONS(4498),
    [sym_ulong] = ACTIONS(4498),
    [sym_cent] = ACTIONS(4498),
    [sym_ucent] = ACTIONS(4498),
    [sym_wchar] = ACTIONS(4498),
    [sym_dchar] = ACTIONS(4498),
    [sym_float] = ACTIONS(4498),
    [sym_double] = ACTIONS(4498),
    [sym_real] = ACTIONS(4498),
    [sym_ifloat] = ACTIONS(4498),
    [sym_idouble] = ACTIONS(4498),
    [sym_ireal] = ACTIONS(4498),
    [sym_cfloat] = ACTIONS(4498),
    [sym_cdouble] = ACTIONS(4498),
    [sym_creal] = ACTIONS(4498),
    [sym_size_t] = ACTIONS(4498),
    [sym_ptrdiff_t] = ACTIONS(4498),
    [sym_string] = ACTIONS(4498),
    [sym_cstring] = ACTIONS(4498),
    [sym_dstring] = ACTIONS(4498),
    [sym_wstring] = ACTIONS(4498),
    [sym_noreturn] = ACTIONS(4498),
    [sym_this] = ACTIONS(4498),
    [sym_abstract] = ACTIONS(4498),
    [sym_alias] = ACTIONS(4498),
    [sym_align] = ACTIONS(4498),
    [sym_auto] = ACTIONS(4498),
    [sym_catch] = ACTIONS(4498),
    [sym_class] = ACTIONS(4498),
    [sym_const] = ACTIONS(4498),
    [sym_debug] = ACTIONS(4498),
    [sym_deprecated] = ACTIONS(4498),
    [sym_else] = ACTIONS(4498),
    [sym_enum] = ACTIONS(4498),
    [sym_export] = ACTIONS(4498),
    [sym_extern] = ACTIONS(4498),
    [sym_final] = ACTIONS(4498),
    [sym_finally] = ACTIONS(4498),
    [sym_immutable] = ACTIONS(4498),
    [sym_import] = ACTIONS(4498),
    [sym_inout] = ACTIONS(4498),
    [sym_interface] = ACTIONS(4498),
    [sym_invariant] = ACTIONS(4498),
    [sym_mixin] = ACTIONS(4498),
    [sym_nothrow] = ACTIONS(4498),
    [sym_override] = ACTIONS(4498),
    [sym_package] = ACTIONS(4498),
    [sym_pragma] = ACTIONS(4498),
    [sym_private] = ACTIONS(4498),
    [sym_protected] = ACTIONS(4498),
    [sym_public] = ACTIONS(4498),
    [sym_pure] = ACTIONS(4498),
    [sym_ref] = ACTIONS(4498),
    [sym_return] = ACTIONS(4498),
    [sym_scope] = ACTIONS(4498),
    [sym_shared] = ACTIONS(4498),
    [sym_static] = ACTIONS(4498),
    [sym_struct] = ACTIONS(4498),
    [sym_synchronized] = ACTIONS(4498),
    [sym_template] = ACTIONS(4498),
    [sym_typeof] = ACTIONS(4498),
    [sym_union] = ACTIONS(4498),
    [sym_unittest] = ACTIONS(4498),
    [sym_version] = ACTIONS(4498),
    [sym_while] = ACTIONS(4498),
    [sym_gshared] = ACTIONS(4498),
    [sym_traits] = ACTIONS(4498),
    [sym_vector] = ACTIONS(4498),
    [sym_void] = ACTIONS(4498),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2250] = {
    [sym_identifier] = ACTIONS(4502),
    [anon_sym_DOT] = ACTIONS(4504),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4504),
    [anon_sym_AT] = ACTIONS(4504),
    [sym_bool] = ACTIONS(4502),
    [sym_byte] = ACTIONS(4502),
    [sym_ubyte] = ACTIONS(4502),
    [sym_char] = ACTIONS(4502),
    [sym_short] = ACTIONS(4502),
    [sym_ushort] = ACTIONS(4502),
    [sym_int] = ACTIONS(4502),
    [sym_uint] = ACTIONS(4502),
    [sym_long] = ACTIONS(4502),
    [sym_ulong] = ACTIONS(4502),
    [sym_cent] = ACTIONS(4502),
    [sym_ucent] = ACTIONS(4502),
    [sym_wchar] = ACTIONS(4502),
    [sym_dchar] = ACTIONS(4502),
    [sym_float] = ACTIONS(4502),
    [sym_double] = ACTIONS(4502),
    [sym_real] = ACTIONS(4502),
    [sym_ifloat] = ACTIONS(4502),
    [sym_idouble] = ACTIONS(4502),
    [sym_ireal] = ACTIONS(4502),
    [sym_cfloat] = ACTIONS(4502),
    [sym_cdouble] = ACTIONS(4502),
    [sym_creal] = ACTIONS(4502),
    [sym_size_t] = ACTIONS(4502),
    [sym_ptrdiff_t] = ACTIONS(4502),
    [sym_string] = ACTIONS(4502),
    [sym_cstring] = ACTIONS(4502),
    [sym_dstring] = ACTIONS(4502),
    [sym_wstring] = ACTIONS(4502),
    [sym_noreturn] = ACTIONS(4502),
    [sym_this] = ACTIONS(4502),
    [sym_abstract] = ACTIONS(4502),
    [sym_alias] = ACTIONS(4502),
    [sym_align] = ACTIONS(4502),
    [sym_auto] = ACTIONS(4502),
    [sym_catch] = ACTIONS(4502),
    [sym_class] = ACTIONS(4502),
    [sym_const] = ACTIONS(4502),
    [sym_debug] = ACTIONS(4502),
    [sym_deprecated] = ACTIONS(4502),
    [sym_else] = ACTIONS(4502),
    [sym_enum] = ACTIONS(4502),
    [sym_export] = ACTIONS(4502),
    [sym_extern] = ACTIONS(4502),
    [sym_final] = ACTIONS(4502),
    [sym_finally] = ACTIONS(4502),
    [sym_immutable] = ACTIONS(4502),
    [sym_import] = ACTIONS(4502),
    [sym_inout] = ACTIONS(4502),
    [sym_interface] = ACTIONS(4502),
    [sym_invariant] = ACTIONS(4502),
    [sym_mixin] = ACTIONS(4502),
    [sym_nothrow] = ACTIONS(4502),
    [sym_override] = ACTIONS(4502),
    [sym_package] = ACTIONS(4502),
    [sym_pragma] = ACTIONS(4502),
    [sym_private] = ACTIONS(4502),
    [sym_protected] = ACTIONS(4502),
    [sym_public] = ACTIONS(4502),
    [sym_pure] = ACTIONS(4502),
    [sym_ref] = ACTIONS(4502),
    [sym_return] = ACTIONS(4502),
    [sym_scope] = ACTIONS(4502),
    [sym_shared] = ACTIONS(4502),
    [sym_static] = ACTIONS(4502),
    [sym_struct] = ACTIONS(4502),
    [sym_synchronized] = ACTIONS(4502),
    [sym_template] = ACTIONS(4502),
    [sym_typeof] = ACTIONS(4502),
    [sym_union] = ACTIONS(4502),
    [sym_unittest] = ACTIONS(4502),
    [sym_version] = ACTIONS(4502),
    [sym_while] = ACTIONS(4502),
    [sym_gshared] = ACTIONS(4502),
    [sym_traits] = ACTIONS(4502),
    [sym_vector] = ACTIONS(4502),
    [sym_void] = ACTIONS(4502),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2251] = {
    [ts_builtin_sym_end] = ACTIONS(4905),
    [sym_identifier] = ACTIONS(4903),
    [anon_sym_RBRACE] = ACTIONS(4905),
    [anon_sym_DOT] = ACTIONS(4905),
    [anon_sym_SEMI] = ACTIONS(4905),
    [anon_sym_TILDE] = ACTIONS(4905),
    [anon_sym_AT] = ACTIONS(4905),
    [sym_bool] = ACTIONS(4903),
    [sym_byte] = ACTIONS(4903),
    [sym_ubyte] = ACTIONS(4903),
    [sym_char] = ACTIONS(4903),
    [sym_short] = ACTIONS(4903),
    [sym_ushort] = ACTIONS(4903),
    [sym_int] = ACTIONS(4903),
    [sym_uint] = ACTIONS(4903),
    [sym_long] = ACTIONS(4903),
    [sym_ulong] = ACTIONS(4903),
    [sym_cent] = ACTIONS(4903),
    [sym_ucent] = ACTIONS(4903),
    [sym_wchar] = ACTIONS(4903),
    [sym_dchar] = ACTIONS(4903),
    [sym_float] = ACTIONS(4903),
    [sym_double] = ACTIONS(4903),
    [sym_real] = ACTIONS(4903),
    [sym_ifloat] = ACTIONS(4903),
    [sym_idouble] = ACTIONS(4903),
    [sym_ireal] = ACTIONS(4903),
    [sym_cfloat] = ACTIONS(4903),
    [sym_cdouble] = ACTIONS(4903),
    [sym_creal] = ACTIONS(4903),
    [sym_size_t] = ACTIONS(4903),
    [sym_ptrdiff_t] = ACTIONS(4903),
    [sym_string] = ACTIONS(4903),
    [sym_cstring] = ACTIONS(4903),
    [sym_dstring] = ACTIONS(4903),
    [sym_wstring] = ACTIONS(4903),
    [sym_noreturn] = ACTIONS(4903),
    [sym_this] = ACTIONS(4903),
    [sym_abstract] = ACTIONS(4903),
    [sym_alias] = ACTIONS(4903),
    [sym_align] = ACTIONS(4903),
    [sym_auto] = ACTIONS(4903),
    [sym_class] = ACTIONS(4903),
    [sym_const] = ACTIONS(4903),
    [sym_debug] = ACTIONS(4903),
    [sym_deprecated] = ACTIONS(4903),
    [sym_else] = ACTIONS(4903),
    [sym_enum] = ACTIONS(4903),
    [sym_export] = ACTIONS(4903),
    [sym_extern] = ACTIONS(4903),
    [sym_final] = ACTIONS(4903),
    [sym_immutable] = ACTIONS(4903),
    [sym_import] = ACTIONS(4903),
    [sym_inout] = ACTIONS(4903),
    [sym_interface] = ACTIONS(4903),
    [sym_invariant] = ACTIONS(4903),
    [sym_mixin] = ACTIONS(4903),
    [sym_nothrow] = ACTIONS(4903),
    [sym_override] = ACTIONS(4903),
    [sym_package] = ACTIONS(4903),
    [sym_pragma] = ACTIONS(4903),
    [sym_private] = ACTIONS(4903),
    [sym_protected] = ACTIONS(4903),
    [sym_public] = ACTIONS(4903),
    [sym_pure] = ACTIONS(4903),
    [sym_ref] = ACTIONS(4903),
    [sym_return] = ACTIONS(4903),
    [sym_scope] = ACTIONS(4903),
    [sym_shared] = ACTIONS(4903),
    [sym_static] = ACTIONS(4903),
    [sym_struct] = ACTIONS(4903),
    [sym_synchronized] = ACTIONS(4903),
    [sym_template] = ACTIONS(4903),
    [sym_typeof] = ACTIONS(4903),
    [sym_union] = ACTIONS(4903),
    [sym_unittest] = ACTIONS(4903),
    [sym_version] = ACTIONS(4903),
    [sym_while] = ACTIONS(4903),
    [sym_gshared] = ACTIONS(4903),
    [sym_traits] = ACTIONS(4903),
    [sym_vector] = ACTIONS(4903),
    [sym_void] = ACTIONS(4903),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2252] = {
    [sym_identifier] = ACTIONS(4773),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_SEMI] = ACTIONS(4775),
    [anon_sym_TILDE] = ACTIONS(4775),
    [anon_sym_AT] = ACTIONS(4775),
    [sym_bool] = ACTIONS(4773),
    [sym_byte] = ACTIONS(4773),
    [sym_ubyte] = ACTIONS(4773),
    [sym_char] = ACTIONS(4773),
    [sym_short] = ACTIONS(4773),
    [sym_ushort] = ACTIONS(4773),
    [sym_int] = ACTIONS(4773),
    [sym_uint] = ACTIONS(4773),
    [sym_long] = ACTIONS(4773),
    [sym_ulong] = ACTIONS(4773),
    [sym_cent] = ACTIONS(4773),
    [sym_ucent] = ACTIONS(4773),
    [sym_wchar] = ACTIONS(4773),
    [sym_dchar] = ACTIONS(4773),
    [sym_float] = ACTIONS(4773),
    [sym_double] = ACTIONS(4773),
    [sym_real] = ACTIONS(4773),
    [sym_ifloat] = ACTIONS(4773),
    [sym_idouble] = ACTIONS(4773),
    [sym_ireal] = ACTIONS(4773),
    [sym_cfloat] = ACTIONS(4773),
    [sym_cdouble] = ACTIONS(4773),
    [sym_creal] = ACTIONS(4773),
    [sym_size_t] = ACTIONS(4773),
    [sym_ptrdiff_t] = ACTIONS(4773),
    [sym_string] = ACTIONS(4773),
    [sym_cstring] = ACTIONS(4773),
    [sym_dstring] = ACTIONS(4773),
    [sym_wstring] = ACTIONS(4773),
    [sym_noreturn] = ACTIONS(4773),
    [sym_this] = ACTIONS(4773),
    [sym_abstract] = ACTIONS(4773),
    [sym_alias] = ACTIONS(4773),
    [sym_align] = ACTIONS(4773),
    [sym_auto] = ACTIONS(4773),
    [sym_catch] = ACTIONS(4773),
    [sym_class] = ACTIONS(4773),
    [sym_const] = ACTIONS(4773),
    [sym_debug] = ACTIONS(4773),
    [sym_deprecated] = ACTIONS(4773),
    [sym_else] = ACTIONS(4773),
    [sym_enum] = ACTIONS(4773),
    [sym_export] = ACTIONS(4773),
    [sym_extern] = ACTIONS(4773),
    [sym_final] = ACTIONS(4773),
    [sym_finally] = ACTIONS(4773),
    [sym_immutable] = ACTIONS(4773),
    [sym_import] = ACTIONS(4773),
    [sym_inout] = ACTIONS(4773),
    [sym_interface] = ACTIONS(4773),
    [sym_invariant] = ACTIONS(4773),
    [sym_mixin] = ACTIONS(4773),
    [sym_nothrow] = ACTIONS(4773),
    [sym_override] = ACTIONS(4773),
    [sym_package] = ACTIONS(4773),
    [sym_pragma] = ACTIONS(4773),
    [sym_private] = ACTIONS(4773),
    [sym_protected] = ACTIONS(4773),
    [sym_public] = ACTIONS(4773),
    [sym_pure] = ACTIONS(4773),
    [sym_ref] = ACTIONS(4773),
    [sym_return] = ACTIONS(4773),
    [sym_scope] = ACTIONS(4773),
    [sym_shared] = ACTIONS(4773),
    [sym_static] = ACTIONS(4773),
    [sym_struct] = ACTIONS(4773),
    [sym_synchronized] = ACTIONS(4773),
    [sym_template] = ACTIONS(4773),
    [sym_typeof] = ACTIONS(4773),
    [sym_union] = ACTIONS(4773),
    [sym_unittest] = ACTIONS(4773),
    [sym_version] = ACTIONS(4773),
    [sym_while] = ACTIONS(4773),
    [sym_gshared] = ACTIONS(4773),
    [sym_traits] = ACTIONS(4773),
    [sym_vector] = ACTIONS(4773),
    [sym_void] = ACTIONS(4773),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2253] = {
    [sym_switch_statement] = STATE(4686),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1764),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2254] = {
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_DOT] = ACTIONS(4915),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_TILDE] = ACTIONS(4915),
    [anon_sym_AT] = ACTIONS(4915),
    [sym_bool] = ACTIONS(4913),
    [sym_byte] = ACTIONS(4913),
    [sym_ubyte] = ACTIONS(4913),
    [sym_char] = ACTIONS(4913),
    [sym_short] = ACTIONS(4913),
    [sym_ushort] = ACTIONS(4913),
    [sym_int] = ACTIONS(4913),
    [sym_uint] = ACTIONS(4913),
    [sym_long] = ACTIONS(4913),
    [sym_ulong] = ACTIONS(4913),
    [sym_cent] = ACTIONS(4913),
    [sym_ucent] = ACTIONS(4913),
    [sym_wchar] = ACTIONS(4913),
    [sym_dchar] = ACTIONS(4913),
    [sym_float] = ACTIONS(4913),
    [sym_double] = ACTIONS(4913),
    [sym_real] = ACTIONS(4913),
    [sym_ifloat] = ACTIONS(4913),
    [sym_idouble] = ACTIONS(4913),
    [sym_ireal] = ACTIONS(4913),
    [sym_cfloat] = ACTIONS(4913),
    [sym_cdouble] = ACTIONS(4913),
    [sym_creal] = ACTIONS(4913),
    [sym_size_t] = ACTIONS(4913),
    [sym_ptrdiff_t] = ACTIONS(4913),
    [sym_string] = ACTIONS(4913),
    [sym_cstring] = ACTIONS(4913),
    [sym_dstring] = ACTIONS(4913),
    [sym_wstring] = ACTIONS(4913),
    [sym_noreturn] = ACTIONS(4913),
    [sym_this] = ACTIONS(4913),
    [sym_abstract] = ACTIONS(4913),
    [sym_alias] = ACTIONS(4913),
    [sym_align] = ACTIONS(4913),
    [sym_auto] = ACTIONS(4913),
    [sym_catch] = ACTIONS(4913),
    [sym_class] = ACTIONS(4913),
    [sym_const] = ACTIONS(4913),
    [sym_debug] = ACTIONS(4913),
    [sym_deprecated] = ACTIONS(4913),
    [sym_else] = ACTIONS(4913),
    [sym_enum] = ACTIONS(4913),
    [sym_export] = ACTIONS(4913),
    [sym_extern] = ACTIONS(4913),
    [sym_final] = ACTIONS(4913),
    [sym_finally] = ACTIONS(4913),
    [sym_immutable] = ACTIONS(4913),
    [sym_import] = ACTIONS(4913),
    [sym_inout] = ACTIONS(4913),
    [sym_interface] = ACTIONS(4913),
    [sym_invariant] = ACTIONS(4913),
    [sym_mixin] = ACTIONS(4913),
    [sym_nothrow] = ACTIONS(4913),
    [sym_override] = ACTIONS(4913),
    [sym_package] = ACTIONS(4913),
    [sym_pragma] = ACTIONS(4913),
    [sym_private] = ACTIONS(4913),
    [sym_protected] = ACTIONS(4913),
    [sym_public] = ACTIONS(4913),
    [sym_pure] = ACTIONS(4913),
    [sym_ref] = ACTIONS(4913),
    [sym_return] = ACTIONS(4913),
    [sym_scope] = ACTIONS(4913),
    [sym_shared] = ACTIONS(4913),
    [sym_static] = ACTIONS(4913),
    [sym_struct] = ACTIONS(4913),
    [sym_synchronized] = ACTIONS(4913),
    [sym_template] = ACTIONS(4913),
    [sym_typeof] = ACTIONS(4913),
    [sym_union] = ACTIONS(4913),
    [sym_unittest] = ACTIONS(4913),
    [sym_version] = ACTIONS(4913),
    [sym_while] = ACTIONS(4913),
    [sym_gshared] = ACTIONS(4913),
    [sym_traits] = ACTIONS(4913),
    [sym_vector] = ACTIONS(4913),
    [sym_void] = ACTIONS(4913),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2255] = {
    [ts_builtin_sym_end] = ACTIONS(4340),
    [sym_identifier] = ACTIONS(4338),
    [anon_sym_RBRACE] = ACTIONS(4340),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_TILDE] = ACTIONS(4340),
    [anon_sym_AT] = ACTIONS(4340),
    [sym_bool] = ACTIONS(4338),
    [sym_byte] = ACTIONS(4338),
    [sym_ubyte] = ACTIONS(4338),
    [sym_char] = ACTIONS(4338),
    [sym_short] = ACTIONS(4338),
    [sym_ushort] = ACTIONS(4338),
    [sym_int] = ACTIONS(4338),
    [sym_uint] = ACTIONS(4338),
    [sym_long] = ACTIONS(4338),
    [sym_ulong] = ACTIONS(4338),
    [sym_cent] = ACTIONS(4338),
    [sym_ucent] = ACTIONS(4338),
    [sym_wchar] = ACTIONS(4338),
    [sym_dchar] = ACTIONS(4338),
    [sym_float] = ACTIONS(4338),
    [sym_double] = ACTIONS(4338),
    [sym_real] = ACTIONS(4338),
    [sym_ifloat] = ACTIONS(4338),
    [sym_idouble] = ACTIONS(4338),
    [sym_ireal] = ACTIONS(4338),
    [sym_cfloat] = ACTIONS(4338),
    [sym_cdouble] = ACTIONS(4338),
    [sym_creal] = ACTIONS(4338),
    [sym_size_t] = ACTIONS(4338),
    [sym_ptrdiff_t] = ACTIONS(4338),
    [sym_string] = ACTIONS(4338),
    [sym_cstring] = ACTIONS(4338),
    [sym_dstring] = ACTIONS(4338),
    [sym_wstring] = ACTIONS(4338),
    [sym_noreturn] = ACTIONS(4338),
    [sym_this] = ACTIONS(4338),
    [sym_abstract] = ACTIONS(4338),
    [sym_alias] = ACTIONS(4338),
    [sym_align] = ACTIONS(4338),
    [sym_auto] = ACTIONS(4338),
    [sym_class] = ACTIONS(4338),
    [sym_const] = ACTIONS(4338),
    [sym_debug] = ACTIONS(4338),
    [sym_deprecated] = ACTIONS(4338),
    [sym_else] = ACTIONS(4338),
    [sym_enum] = ACTIONS(4338),
    [sym_export] = ACTIONS(4338),
    [sym_extern] = ACTIONS(4338),
    [sym_final] = ACTIONS(4338),
    [sym_immutable] = ACTIONS(4338),
    [sym_import] = ACTIONS(4338),
    [sym_inout] = ACTIONS(4338),
    [sym_interface] = ACTIONS(4338),
    [sym_invariant] = ACTIONS(4338),
    [sym_mixin] = ACTIONS(4338),
    [sym_nothrow] = ACTIONS(4338),
    [sym_override] = ACTIONS(4338),
    [sym_package] = ACTIONS(4338),
    [sym_pragma] = ACTIONS(4338),
    [sym_private] = ACTIONS(4338),
    [sym_protected] = ACTIONS(4338),
    [sym_public] = ACTIONS(4338),
    [sym_pure] = ACTIONS(4338),
    [sym_ref] = ACTIONS(4338),
    [sym_return] = ACTIONS(4338),
    [sym_scope] = ACTIONS(4338),
    [sym_shared] = ACTIONS(4338),
    [sym_static] = ACTIONS(4338),
    [sym_struct] = ACTIONS(4338),
    [sym_synchronized] = ACTIONS(4338),
    [sym_template] = ACTIONS(4338),
    [sym_typeof] = ACTIONS(4338),
    [sym_union] = ACTIONS(4338),
    [sym_unittest] = ACTIONS(4338),
    [sym_version] = ACTIONS(4338),
    [sym_while] = ACTIONS(4338),
    [sym_gshared] = ACTIONS(4338),
    [sym_traits] = ACTIONS(4338),
    [sym_vector] = ACTIONS(4338),
    [sym_void] = ACTIONS(4338),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2256] = {
    [ts_builtin_sym_end] = ACTIONS(4336),
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_RBRACE] = ACTIONS(4336),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4336),
    [anon_sym_AT] = ACTIONS(4336),
    [sym_bool] = ACTIONS(4334),
    [sym_byte] = ACTIONS(4334),
    [sym_ubyte] = ACTIONS(4334),
    [sym_char] = ACTIONS(4334),
    [sym_short] = ACTIONS(4334),
    [sym_ushort] = ACTIONS(4334),
    [sym_int] = ACTIONS(4334),
    [sym_uint] = ACTIONS(4334),
    [sym_long] = ACTIONS(4334),
    [sym_ulong] = ACTIONS(4334),
    [sym_cent] = ACTIONS(4334),
    [sym_ucent] = ACTIONS(4334),
    [sym_wchar] = ACTIONS(4334),
    [sym_dchar] = ACTIONS(4334),
    [sym_float] = ACTIONS(4334),
    [sym_double] = ACTIONS(4334),
    [sym_real] = ACTIONS(4334),
    [sym_ifloat] = ACTIONS(4334),
    [sym_idouble] = ACTIONS(4334),
    [sym_ireal] = ACTIONS(4334),
    [sym_cfloat] = ACTIONS(4334),
    [sym_cdouble] = ACTIONS(4334),
    [sym_creal] = ACTIONS(4334),
    [sym_size_t] = ACTIONS(4334),
    [sym_ptrdiff_t] = ACTIONS(4334),
    [sym_string] = ACTIONS(4334),
    [sym_cstring] = ACTIONS(4334),
    [sym_dstring] = ACTIONS(4334),
    [sym_wstring] = ACTIONS(4334),
    [sym_noreturn] = ACTIONS(4334),
    [sym_this] = ACTIONS(4334),
    [sym_abstract] = ACTIONS(4334),
    [sym_alias] = ACTIONS(4334),
    [sym_align] = ACTIONS(4334),
    [sym_auto] = ACTIONS(4334),
    [sym_class] = ACTIONS(4334),
    [sym_const] = ACTIONS(4334),
    [sym_debug] = ACTIONS(4334),
    [sym_deprecated] = ACTIONS(4334),
    [sym_else] = ACTIONS(4334),
    [sym_enum] = ACTIONS(4334),
    [sym_export] = ACTIONS(4334),
    [sym_extern] = ACTIONS(4334),
    [sym_final] = ACTIONS(4334),
    [sym_immutable] = ACTIONS(4334),
    [sym_import] = ACTIONS(4334),
    [sym_inout] = ACTIONS(4334),
    [sym_interface] = ACTIONS(4334),
    [sym_invariant] = ACTIONS(4334),
    [sym_mixin] = ACTIONS(4334),
    [sym_nothrow] = ACTIONS(4334),
    [sym_override] = ACTIONS(4334),
    [sym_package] = ACTIONS(4334),
    [sym_pragma] = ACTIONS(4334),
    [sym_private] = ACTIONS(4334),
    [sym_protected] = ACTIONS(4334),
    [sym_public] = ACTIONS(4334),
    [sym_pure] = ACTIONS(4334),
    [sym_ref] = ACTIONS(4334),
    [sym_return] = ACTIONS(4334),
    [sym_scope] = ACTIONS(4334),
    [sym_shared] = ACTIONS(4334),
    [sym_static] = ACTIONS(4334),
    [sym_struct] = ACTIONS(4334),
    [sym_synchronized] = ACTIONS(4334),
    [sym_template] = ACTIONS(4334),
    [sym_typeof] = ACTIONS(4334),
    [sym_union] = ACTIONS(4334),
    [sym_unittest] = ACTIONS(4334),
    [sym_version] = ACTIONS(4334),
    [sym_while] = ACTIONS(4334),
    [sym_gshared] = ACTIONS(4334),
    [sym_traits] = ACTIONS(4334),
    [sym_vector] = ACTIONS(4334),
    [sym_void] = ACTIONS(4334),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2257] = {
    [ts_builtin_sym_end] = ACTIONS(4332),
    [sym_identifier] = ACTIONS(4330),
    [anon_sym_RBRACE] = ACTIONS(4332),
    [anon_sym_DOT] = ACTIONS(4332),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_AT] = ACTIONS(4332),
    [sym_bool] = ACTIONS(4330),
    [sym_byte] = ACTIONS(4330),
    [sym_ubyte] = ACTIONS(4330),
    [sym_char] = ACTIONS(4330),
    [sym_short] = ACTIONS(4330),
    [sym_ushort] = ACTIONS(4330),
    [sym_int] = ACTIONS(4330),
    [sym_uint] = ACTIONS(4330),
    [sym_long] = ACTIONS(4330),
    [sym_ulong] = ACTIONS(4330),
    [sym_cent] = ACTIONS(4330),
    [sym_ucent] = ACTIONS(4330),
    [sym_wchar] = ACTIONS(4330),
    [sym_dchar] = ACTIONS(4330),
    [sym_float] = ACTIONS(4330),
    [sym_double] = ACTIONS(4330),
    [sym_real] = ACTIONS(4330),
    [sym_ifloat] = ACTIONS(4330),
    [sym_idouble] = ACTIONS(4330),
    [sym_ireal] = ACTIONS(4330),
    [sym_cfloat] = ACTIONS(4330),
    [sym_cdouble] = ACTIONS(4330),
    [sym_creal] = ACTIONS(4330),
    [sym_size_t] = ACTIONS(4330),
    [sym_ptrdiff_t] = ACTIONS(4330),
    [sym_string] = ACTIONS(4330),
    [sym_cstring] = ACTIONS(4330),
    [sym_dstring] = ACTIONS(4330),
    [sym_wstring] = ACTIONS(4330),
    [sym_noreturn] = ACTIONS(4330),
    [sym_this] = ACTIONS(4330),
    [sym_abstract] = ACTIONS(4330),
    [sym_alias] = ACTIONS(4330),
    [sym_align] = ACTIONS(4330),
    [sym_auto] = ACTIONS(4330),
    [sym_class] = ACTIONS(4330),
    [sym_const] = ACTIONS(4330),
    [sym_debug] = ACTIONS(4330),
    [sym_deprecated] = ACTIONS(4330),
    [sym_else] = ACTIONS(4330),
    [sym_enum] = ACTIONS(4330),
    [sym_export] = ACTIONS(4330),
    [sym_extern] = ACTIONS(4330),
    [sym_final] = ACTIONS(4330),
    [sym_immutable] = ACTIONS(4330),
    [sym_import] = ACTIONS(4330),
    [sym_inout] = ACTIONS(4330),
    [sym_interface] = ACTIONS(4330),
    [sym_invariant] = ACTIONS(4330),
    [sym_mixin] = ACTIONS(4330),
    [sym_nothrow] = ACTIONS(4330),
    [sym_override] = ACTIONS(4330),
    [sym_package] = ACTIONS(4330),
    [sym_pragma] = ACTIONS(4330),
    [sym_private] = ACTIONS(4330),
    [sym_protected] = ACTIONS(4330),
    [sym_public] = ACTIONS(4330),
    [sym_pure] = ACTIONS(4330),
    [sym_ref] = ACTIONS(4330),
    [sym_return] = ACTIONS(4330),
    [sym_scope] = ACTIONS(4330),
    [sym_shared] = ACTIONS(4330),
    [sym_static] = ACTIONS(4330),
    [sym_struct] = ACTIONS(4330),
    [sym_synchronized] = ACTIONS(4330),
    [sym_template] = ACTIONS(4330),
    [sym_typeof] = ACTIONS(4330),
    [sym_union] = ACTIONS(4330),
    [sym_unittest] = ACTIONS(4330),
    [sym_version] = ACTIONS(4330),
    [sym_while] = ACTIONS(4330),
    [sym_gshared] = ACTIONS(4330),
    [sym_traits] = ACTIONS(4330),
    [sym_vector] = ACTIONS(4330),
    [sym_void] = ACTIONS(4330),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2258] = {
    [sym_identifier] = ACTIONS(4917),
    [anon_sym_DOT] = ACTIONS(4919),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_TILDE] = ACTIONS(4919),
    [anon_sym_AT] = ACTIONS(4919),
    [sym_bool] = ACTIONS(4917),
    [sym_byte] = ACTIONS(4917),
    [sym_ubyte] = ACTIONS(4917),
    [sym_char] = ACTIONS(4917),
    [sym_short] = ACTIONS(4917),
    [sym_ushort] = ACTIONS(4917),
    [sym_int] = ACTIONS(4917),
    [sym_uint] = ACTIONS(4917),
    [sym_long] = ACTIONS(4917),
    [sym_ulong] = ACTIONS(4917),
    [sym_cent] = ACTIONS(4917),
    [sym_ucent] = ACTIONS(4917),
    [sym_wchar] = ACTIONS(4917),
    [sym_dchar] = ACTIONS(4917),
    [sym_float] = ACTIONS(4917),
    [sym_double] = ACTIONS(4917),
    [sym_real] = ACTIONS(4917),
    [sym_ifloat] = ACTIONS(4917),
    [sym_idouble] = ACTIONS(4917),
    [sym_ireal] = ACTIONS(4917),
    [sym_cfloat] = ACTIONS(4917),
    [sym_cdouble] = ACTIONS(4917),
    [sym_creal] = ACTIONS(4917),
    [sym_size_t] = ACTIONS(4917),
    [sym_ptrdiff_t] = ACTIONS(4917),
    [sym_string] = ACTIONS(4917),
    [sym_cstring] = ACTIONS(4917),
    [sym_dstring] = ACTIONS(4917),
    [sym_wstring] = ACTIONS(4917),
    [sym_noreturn] = ACTIONS(4917),
    [sym_this] = ACTIONS(4917),
    [sym_abstract] = ACTIONS(4917),
    [sym_alias] = ACTIONS(4917),
    [sym_align] = ACTIONS(4917),
    [sym_auto] = ACTIONS(4917),
    [sym_catch] = ACTIONS(4917),
    [sym_class] = ACTIONS(4917),
    [sym_const] = ACTIONS(4917),
    [sym_debug] = ACTIONS(4917),
    [sym_deprecated] = ACTIONS(4917),
    [sym_else] = ACTIONS(4917),
    [sym_enum] = ACTIONS(4917),
    [sym_export] = ACTIONS(4917),
    [sym_extern] = ACTIONS(4917),
    [sym_final] = ACTIONS(4917),
    [sym_finally] = ACTIONS(4917),
    [sym_immutable] = ACTIONS(4917),
    [sym_import] = ACTIONS(4917),
    [sym_inout] = ACTIONS(4917),
    [sym_interface] = ACTIONS(4917),
    [sym_invariant] = ACTIONS(4917),
    [sym_mixin] = ACTIONS(4917),
    [sym_nothrow] = ACTIONS(4917),
    [sym_override] = ACTIONS(4917),
    [sym_package] = ACTIONS(4917),
    [sym_pragma] = ACTIONS(4917),
    [sym_private] = ACTIONS(4917),
    [sym_protected] = ACTIONS(4917),
    [sym_public] = ACTIONS(4917),
    [sym_pure] = ACTIONS(4917),
    [sym_ref] = ACTIONS(4917),
    [sym_return] = ACTIONS(4917),
    [sym_scope] = ACTIONS(4917),
    [sym_shared] = ACTIONS(4917),
    [sym_static] = ACTIONS(4917),
    [sym_struct] = ACTIONS(4917),
    [sym_synchronized] = ACTIONS(4917),
    [sym_template] = ACTIONS(4917),
    [sym_typeof] = ACTIONS(4917),
    [sym_union] = ACTIONS(4917),
    [sym_unittest] = ACTIONS(4917),
    [sym_version] = ACTIONS(4917),
    [sym_while] = ACTIONS(4917),
    [sym_gshared] = ACTIONS(4917),
    [sym_traits] = ACTIONS(4917),
    [sym_vector] = ACTIONS(4917),
    [sym_void] = ACTIONS(4917),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2259] = {
    [sym_identifier] = ACTIONS(4961),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [anon_sym_AT] = ACTIONS(4963),
    [sym_bool] = ACTIONS(4961),
    [sym_byte] = ACTIONS(4961),
    [sym_ubyte] = ACTIONS(4961),
    [sym_char] = ACTIONS(4961),
    [sym_short] = ACTIONS(4961),
    [sym_ushort] = ACTIONS(4961),
    [sym_int] = ACTIONS(4961),
    [sym_uint] = ACTIONS(4961),
    [sym_long] = ACTIONS(4961),
    [sym_ulong] = ACTIONS(4961),
    [sym_cent] = ACTIONS(4961),
    [sym_ucent] = ACTIONS(4961),
    [sym_wchar] = ACTIONS(4961),
    [sym_dchar] = ACTIONS(4961),
    [sym_float] = ACTIONS(4961),
    [sym_double] = ACTIONS(4961),
    [sym_real] = ACTIONS(4961),
    [sym_ifloat] = ACTIONS(4961),
    [sym_idouble] = ACTIONS(4961),
    [sym_ireal] = ACTIONS(4961),
    [sym_cfloat] = ACTIONS(4961),
    [sym_cdouble] = ACTIONS(4961),
    [sym_creal] = ACTIONS(4961),
    [sym_size_t] = ACTIONS(4961),
    [sym_ptrdiff_t] = ACTIONS(4961),
    [sym_string] = ACTIONS(4961),
    [sym_cstring] = ACTIONS(4961),
    [sym_dstring] = ACTIONS(4961),
    [sym_wstring] = ACTIONS(4961),
    [sym_noreturn] = ACTIONS(4961),
    [sym_this] = ACTIONS(4961),
    [sym_abstract] = ACTIONS(4961),
    [sym_alias] = ACTIONS(4961),
    [sym_align] = ACTIONS(4961),
    [sym_auto] = ACTIONS(4961),
    [sym_catch] = ACTIONS(4961),
    [sym_class] = ACTIONS(4961),
    [sym_const] = ACTIONS(4961),
    [sym_debug] = ACTIONS(4961),
    [sym_deprecated] = ACTIONS(4961),
    [sym_else] = ACTIONS(4961),
    [sym_enum] = ACTIONS(4961),
    [sym_export] = ACTIONS(4961),
    [sym_extern] = ACTIONS(4961),
    [sym_final] = ACTIONS(4961),
    [sym_finally] = ACTIONS(4961),
    [sym_immutable] = ACTIONS(4961),
    [sym_import] = ACTIONS(4961),
    [sym_inout] = ACTIONS(4961),
    [sym_interface] = ACTIONS(4961),
    [sym_invariant] = ACTIONS(4961),
    [sym_mixin] = ACTIONS(4961),
    [sym_nothrow] = ACTIONS(4961),
    [sym_override] = ACTIONS(4961),
    [sym_package] = ACTIONS(4961),
    [sym_pragma] = ACTIONS(4961),
    [sym_private] = ACTIONS(4961),
    [sym_protected] = ACTIONS(4961),
    [sym_public] = ACTIONS(4961),
    [sym_pure] = ACTIONS(4961),
    [sym_ref] = ACTIONS(4961),
    [sym_return] = ACTIONS(4961),
    [sym_scope] = ACTIONS(4961),
    [sym_shared] = ACTIONS(4961),
    [sym_static] = ACTIONS(4961),
    [sym_struct] = ACTIONS(4961),
    [sym_synchronized] = ACTIONS(4961),
    [sym_template] = ACTIONS(4961),
    [sym_typeof] = ACTIONS(4961),
    [sym_union] = ACTIONS(4961),
    [sym_unittest] = ACTIONS(4961),
    [sym_version] = ACTIONS(4961),
    [sym_while] = ACTIONS(4961),
    [sym_gshared] = ACTIONS(4961),
    [sym_traits] = ACTIONS(4961),
    [sym_vector] = ACTIONS(4961),
    [sym_void] = ACTIONS(4961),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2260] = {
    [ts_builtin_sym_end] = ACTIONS(4923),
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_DOT] = ACTIONS(4923),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4923),
    [anon_sym_AT] = ACTIONS(4923),
    [sym_bool] = ACTIONS(4921),
    [sym_byte] = ACTIONS(4921),
    [sym_ubyte] = ACTIONS(4921),
    [sym_char] = ACTIONS(4921),
    [sym_short] = ACTIONS(4921),
    [sym_ushort] = ACTIONS(4921),
    [sym_int] = ACTIONS(4921),
    [sym_uint] = ACTIONS(4921),
    [sym_long] = ACTIONS(4921),
    [sym_ulong] = ACTIONS(4921),
    [sym_cent] = ACTIONS(4921),
    [sym_ucent] = ACTIONS(4921),
    [sym_wchar] = ACTIONS(4921),
    [sym_dchar] = ACTIONS(4921),
    [sym_float] = ACTIONS(4921),
    [sym_double] = ACTIONS(4921),
    [sym_real] = ACTIONS(4921),
    [sym_ifloat] = ACTIONS(4921),
    [sym_idouble] = ACTIONS(4921),
    [sym_ireal] = ACTIONS(4921),
    [sym_cfloat] = ACTIONS(4921),
    [sym_cdouble] = ACTIONS(4921),
    [sym_creal] = ACTIONS(4921),
    [sym_size_t] = ACTIONS(4921),
    [sym_ptrdiff_t] = ACTIONS(4921),
    [sym_string] = ACTIONS(4921),
    [sym_cstring] = ACTIONS(4921),
    [sym_dstring] = ACTIONS(4921),
    [sym_wstring] = ACTIONS(4921),
    [sym_noreturn] = ACTIONS(4921),
    [sym_this] = ACTIONS(4921),
    [sym_abstract] = ACTIONS(4921),
    [sym_alias] = ACTIONS(4921),
    [sym_align] = ACTIONS(4921),
    [sym_auto] = ACTIONS(4921),
    [sym_class] = ACTIONS(4921),
    [sym_const] = ACTIONS(4921),
    [sym_debug] = ACTIONS(4921),
    [sym_deprecated] = ACTIONS(4921),
    [sym_else] = ACTIONS(4921),
    [sym_enum] = ACTIONS(4921),
    [sym_export] = ACTIONS(4921),
    [sym_extern] = ACTIONS(4921),
    [sym_final] = ACTIONS(4921),
    [sym_immutable] = ACTIONS(4921),
    [sym_import] = ACTIONS(4921),
    [sym_inout] = ACTIONS(4921),
    [sym_interface] = ACTIONS(4921),
    [sym_invariant] = ACTIONS(4921),
    [sym_mixin] = ACTIONS(4921),
    [sym_nothrow] = ACTIONS(4921),
    [sym_override] = ACTIONS(4921),
    [sym_package] = ACTIONS(4921),
    [sym_pragma] = ACTIONS(4921),
    [sym_private] = ACTIONS(4921),
    [sym_protected] = ACTIONS(4921),
    [sym_public] = ACTIONS(4921),
    [sym_pure] = ACTIONS(4921),
    [sym_ref] = ACTIONS(4921),
    [sym_return] = ACTIONS(4921),
    [sym_scope] = ACTIONS(4921),
    [sym_shared] = ACTIONS(4921),
    [sym_static] = ACTIONS(4921),
    [sym_struct] = ACTIONS(4921),
    [sym_synchronized] = ACTIONS(4921),
    [sym_template] = ACTIONS(4921),
    [sym_typeof] = ACTIONS(4921),
    [sym_union] = ACTIONS(4921),
    [sym_unittest] = ACTIONS(4921),
    [sym_version] = ACTIONS(4921),
    [sym_while] = ACTIONS(4921),
    [sym_gshared] = ACTIONS(4921),
    [sym_traits] = ACTIONS(4921),
    [sym_vector] = ACTIONS(4921),
    [sym_void] = ACTIONS(4921),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2261] = {
    [ts_builtin_sym_end] = ACTIONS(4927),
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_RBRACE] = ACTIONS(4927),
    [anon_sym_DOT] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(4927),
    [sym_bool] = ACTIONS(4925),
    [sym_byte] = ACTIONS(4925),
    [sym_ubyte] = ACTIONS(4925),
    [sym_char] = ACTIONS(4925),
    [sym_short] = ACTIONS(4925),
    [sym_ushort] = ACTIONS(4925),
    [sym_int] = ACTIONS(4925),
    [sym_uint] = ACTIONS(4925),
    [sym_long] = ACTIONS(4925),
    [sym_ulong] = ACTIONS(4925),
    [sym_cent] = ACTIONS(4925),
    [sym_ucent] = ACTIONS(4925),
    [sym_wchar] = ACTIONS(4925),
    [sym_dchar] = ACTIONS(4925),
    [sym_float] = ACTIONS(4925),
    [sym_double] = ACTIONS(4925),
    [sym_real] = ACTIONS(4925),
    [sym_ifloat] = ACTIONS(4925),
    [sym_idouble] = ACTIONS(4925),
    [sym_ireal] = ACTIONS(4925),
    [sym_cfloat] = ACTIONS(4925),
    [sym_cdouble] = ACTIONS(4925),
    [sym_creal] = ACTIONS(4925),
    [sym_size_t] = ACTIONS(4925),
    [sym_ptrdiff_t] = ACTIONS(4925),
    [sym_string] = ACTIONS(4925),
    [sym_cstring] = ACTIONS(4925),
    [sym_dstring] = ACTIONS(4925),
    [sym_wstring] = ACTIONS(4925),
    [sym_noreturn] = ACTIONS(4925),
    [sym_this] = ACTIONS(4925),
    [sym_abstract] = ACTIONS(4925),
    [sym_alias] = ACTIONS(4925),
    [sym_align] = ACTIONS(4925),
    [sym_auto] = ACTIONS(4925),
    [sym_class] = ACTIONS(4925),
    [sym_const] = ACTIONS(4925),
    [sym_debug] = ACTIONS(4925),
    [sym_deprecated] = ACTIONS(4925),
    [sym_else] = ACTIONS(4925),
    [sym_enum] = ACTIONS(4925),
    [sym_export] = ACTIONS(4925),
    [sym_extern] = ACTIONS(4925),
    [sym_final] = ACTIONS(4925),
    [sym_immutable] = ACTIONS(4925),
    [sym_import] = ACTIONS(4925),
    [sym_inout] = ACTIONS(4925),
    [sym_interface] = ACTIONS(4925),
    [sym_invariant] = ACTIONS(4925),
    [sym_mixin] = ACTIONS(4925),
    [sym_nothrow] = ACTIONS(4925),
    [sym_override] = ACTIONS(4925),
    [sym_package] = ACTIONS(4925),
    [sym_pragma] = ACTIONS(4925),
    [sym_private] = ACTIONS(4925),
    [sym_protected] = ACTIONS(4925),
    [sym_public] = ACTIONS(4925),
    [sym_pure] = ACTIONS(4925),
    [sym_ref] = ACTIONS(4925),
    [sym_return] = ACTIONS(4925),
    [sym_scope] = ACTIONS(4925),
    [sym_shared] = ACTIONS(4925),
    [sym_static] = ACTIONS(4925),
    [sym_struct] = ACTIONS(4925),
    [sym_synchronized] = ACTIONS(4925),
    [sym_template] = ACTIONS(4925),
    [sym_typeof] = ACTIONS(4925),
    [sym_union] = ACTIONS(4925),
    [sym_unittest] = ACTIONS(4925),
    [sym_version] = ACTIONS(4925),
    [sym_while] = ACTIONS(4925),
    [sym_gshared] = ACTIONS(4925),
    [sym_traits] = ACTIONS(4925),
    [sym_vector] = ACTIONS(4925),
    [sym_void] = ACTIONS(4925),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2262] = {
    [sym_identifier] = ACTIONS(4971),
    [anon_sym_DOT] = ACTIONS(4973),
    [anon_sym_SEMI] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_AT] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4971),
    [sym_byte] = ACTIONS(4971),
    [sym_ubyte] = ACTIONS(4971),
    [sym_char] = ACTIONS(4971),
    [sym_short] = ACTIONS(4971),
    [sym_ushort] = ACTIONS(4971),
    [sym_int] = ACTIONS(4971),
    [sym_uint] = ACTIONS(4971),
    [sym_long] = ACTIONS(4971),
    [sym_ulong] = ACTIONS(4971),
    [sym_cent] = ACTIONS(4971),
    [sym_ucent] = ACTIONS(4971),
    [sym_wchar] = ACTIONS(4971),
    [sym_dchar] = ACTIONS(4971),
    [sym_float] = ACTIONS(4971),
    [sym_double] = ACTIONS(4971),
    [sym_real] = ACTIONS(4971),
    [sym_ifloat] = ACTIONS(4971),
    [sym_idouble] = ACTIONS(4971),
    [sym_ireal] = ACTIONS(4971),
    [sym_cfloat] = ACTIONS(4971),
    [sym_cdouble] = ACTIONS(4971),
    [sym_creal] = ACTIONS(4971),
    [sym_size_t] = ACTIONS(4971),
    [sym_ptrdiff_t] = ACTIONS(4971),
    [sym_string] = ACTIONS(4971),
    [sym_cstring] = ACTIONS(4971),
    [sym_dstring] = ACTIONS(4971),
    [sym_wstring] = ACTIONS(4971),
    [sym_noreturn] = ACTIONS(4971),
    [sym_this] = ACTIONS(4971),
    [sym_abstract] = ACTIONS(4971),
    [sym_alias] = ACTIONS(4971),
    [sym_align] = ACTIONS(4971),
    [sym_auto] = ACTIONS(4971),
    [sym_catch] = ACTIONS(4971),
    [sym_class] = ACTIONS(4971),
    [sym_const] = ACTIONS(4971),
    [sym_debug] = ACTIONS(4971),
    [sym_deprecated] = ACTIONS(4971),
    [sym_else] = ACTIONS(4971),
    [sym_enum] = ACTIONS(4971),
    [sym_export] = ACTIONS(4971),
    [sym_extern] = ACTIONS(4971),
    [sym_final] = ACTIONS(4971),
    [sym_finally] = ACTIONS(4971),
    [sym_immutable] = ACTIONS(4971),
    [sym_import] = ACTIONS(4971),
    [sym_inout] = ACTIONS(4971),
    [sym_interface] = ACTIONS(4971),
    [sym_invariant] = ACTIONS(4971),
    [sym_mixin] = ACTIONS(4971),
    [sym_nothrow] = ACTIONS(4971),
    [sym_override] = ACTIONS(4971),
    [sym_package] = ACTIONS(4971),
    [sym_pragma] = ACTIONS(4971),
    [sym_private] = ACTIONS(4971),
    [sym_protected] = ACTIONS(4971),
    [sym_public] = ACTIONS(4971),
    [sym_pure] = ACTIONS(4971),
    [sym_ref] = ACTIONS(4971),
    [sym_return] = ACTIONS(4971),
    [sym_scope] = ACTIONS(4971),
    [sym_shared] = ACTIONS(4971),
    [sym_static] = ACTIONS(4971),
    [sym_struct] = ACTIONS(4971),
    [sym_synchronized] = ACTIONS(4971),
    [sym_template] = ACTIONS(4971),
    [sym_typeof] = ACTIONS(4971),
    [sym_union] = ACTIONS(4971),
    [sym_unittest] = ACTIONS(4971),
    [sym_version] = ACTIONS(4971),
    [sym_while] = ACTIONS(4971),
    [sym_gshared] = ACTIONS(4971),
    [sym_traits] = ACTIONS(4971),
    [sym_vector] = ACTIONS(4971),
    [sym_void] = ACTIONS(4971),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2263] = {
    [sym_identifier] = ACTIONS(4765),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_TILDE] = ACTIONS(4767),
    [anon_sym_AT] = ACTIONS(4767),
    [sym_bool] = ACTIONS(4765),
    [sym_byte] = ACTIONS(4765),
    [sym_ubyte] = ACTIONS(4765),
    [sym_char] = ACTIONS(4765),
    [sym_short] = ACTIONS(4765),
    [sym_ushort] = ACTIONS(4765),
    [sym_int] = ACTIONS(4765),
    [sym_uint] = ACTIONS(4765),
    [sym_long] = ACTIONS(4765),
    [sym_ulong] = ACTIONS(4765),
    [sym_cent] = ACTIONS(4765),
    [sym_ucent] = ACTIONS(4765),
    [sym_wchar] = ACTIONS(4765),
    [sym_dchar] = ACTIONS(4765),
    [sym_float] = ACTIONS(4765),
    [sym_double] = ACTIONS(4765),
    [sym_real] = ACTIONS(4765),
    [sym_ifloat] = ACTIONS(4765),
    [sym_idouble] = ACTIONS(4765),
    [sym_ireal] = ACTIONS(4765),
    [sym_cfloat] = ACTIONS(4765),
    [sym_cdouble] = ACTIONS(4765),
    [sym_creal] = ACTIONS(4765),
    [sym_size_t] = ACTIONS(4765),
    [sym_ptrdiff_t] = ACTIONS(4765),
    [sym_string] = ACTIONS(4765),
    [sym_cstring] = ACTIONS(4765),
    [sym_dstring] = ACTIONS(4765),
    [sym_wstring] = ACTIONS(4765),
    [sym_noreturn] = ACTIONS(4765),
    [sym_this] = ACTIONS(4765),
    [sym_abstract] = ACTIONS(4765),
    [sym_alias] = ACTIONS(4765),
    [sym_align] = ACTIONS(4765),
    [sym_auto] = ACTIONS(4765),
    [sym_catch] = ACTIONS(4765),
    [sym_class] = ACTIONS(4765),
    [sym_const] = ACTIONS(4765),
    [sym_debug] = ACTIONS(4765),
    [sym_deprecated] = ACTIONS(4765),
    [sym_else] = ACTIONS(4765),
    [sym_enum] = ACTIONS(4765),
    [sym_export] = ACTIONS(4765),
    [sym_extern] = ACTIONS(4765),
    [sym_final] = ACTIONS(4765),
    [sym_finally] = ACTIONS(4765),
    [sym_immutable] = ACTIONS(4765),
    [sym_import] = ACTIONS(4765),
    [sym_inout] = ACTIONS(4765),
    [sym_interface] = ACTIONS(4765),
    [sym_invariant] = ACTIONS(4765),
    [sym_mixin] = ACTIONS(4765),
    [sym_nothrow] = ACTIONS(4765),
    [sym_override] = ACTIONS(4765),
    [sym_package] = ACTIONS(4765),
    [sym_pragma] = ACTIONS(4765),
    [sym_private] = ACTIONS(4765),
    [sym_protected] = ACTIONS(4765),
    [sym_public] = ACTIONS(4765),
    [sym_pure] = ACTIONS(4765),
    [sym_ref] = ACTIONS(4765),
    [sym_return] = ACTIONS(4765),
    [sym_scope] = ACTIONS(4765),
    [sym_shared] = ACTIONS(4765),
    [sym_static] = ACTIONS(4765),
    [sym_struct] = ACTIONS(4765),
    [sym_synchronized] = ACTIONS(4765),
    [sym_template] = ACTIONS(4765),
    [sym_typeof] = ACTIONS(4765),
    [sym_union] = ACTIONS(4765),
    [sym_unittest] = ACTIONS(4765),
    [sym_version] = ACTIONS(4765),
    [sym_while] = ACTIONS(4765),
    [sym_gshared] = ACTIONS(4765),
    [sym_traits] = ACTIONS(4765),
    [sym_vector] = ACTIONS(4765),
    [sym_void] = ACTIONS(4765),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2264] = {
    [sym_identifier] = ACTIONS(4991),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_AT] = ACTIONS(4993),
    [sym_bool] = ACTIONS(4991),
    [sym_byte] = ACTIONS(4991),
    [sym_ubyte] = ACTIONS(4991),
    [sym_char] = ACTIONS(4991),
    [sym_short] = ACTIONS(4991),
    [sym_ushort] = ACTIONS(4991),
    [sym_int] = ACTIONS(4991),
    [sym_uint] = ACTIONS(4991),
    [sym_long] = ACTIONS(4991),
    [sym_ulong] = ACTIONS(4991),
    [sym_cent] = ACTIONS(4991),
    [sym_ucent] = ACTIONS(4991),
    [sym_wchar] = ACTIONS(4991),
    [sym_dchar] = ACTIONS(4991),
    [sym_float] = ACTIONS(4991),
    [sym_double] = ACTIONS(4991),
    [sym_real] = ACTIONS(4991),
    [sym_ifloat] = ACTIONS(4991),
    [sym_idouble] = ACTIONS(4991),
    [sym_ireal] = ACTIONS(4991),
    [sym_cfloat] = ACTIONS(4991),
    [sym_cdouble] = ACTIONS(4991),
    [sym_creal] = ACTIONS(4991),
    [sym_size_t] = ACTIONS(4991),
    [sym_ptrdiff_t] = ACTIONS(4991),
    [sym_string] = ACTIONS(4991),
    [sym_cstring] = ACTIONS(4991),
    [sym_dstring] = ACTIONS(4991),
    [sym_wstring] = ACTIONS(4991),
    [sym_noreturn] = ACTIONS(4991),
    [sym_this] = ACTIONS(4991),
    [sym_abstract] = ACTIONS(4991),
    [sym_alias] = ACTIONS(4991),
    [sym_align] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [sym_catch] = ACTIONS(4991),
    [sym_class] = ACTIONS(4991),
    [sym_const] = ACTIONS(4991),
    [sym_debug] = ACTIONS(4991),
    [sym_deprecated] = ACTIONS(4991),
    [sym_else] = ACTIONS(4991),
    [sym_enum] = ACTIONS(4991),
    [sym_export] = ACTIONS(4991),
    [sym_extern] = ACTIONS(4991),
    [sym_final] = ACTIONS(4991),
    [sym_finally] = ACTIONS(4991),
    [sym_immutable] = ACTIONS(4991),
    [sym_import] = ACTIONS(4991),
    [sym_inout] = ACTIONS(4991),
    [sym_interface] = ACTIONS(4991),
    [sym_invariant] = ACTIONS(4991),
    [sym_mixin] = ACTIONS(4991),
    [sym_nothrow] = ACTIONS(4991),
    [sym_override] = ACTIONS(4991),
    [sym_package] = ACTIONS(4991),
    [sym_pragma] = ACTIONS(4991),
    [sym_private] = ACTIONS(4991),
    [sym_protected] = ACTIONS(4991),
    [sym_public] = ACTIONS(4991),
    [sym_pure] = ACTIONS(4991),
    [sym_ref] = ACTIONS(4991),
    [sym_return] = ACTIONS(4991),
    [sym_scope] = ACTIONS(4991),
    [sym_shared] = ACTIONS(4991),
    [sym_static] = ACTIONS(4991),
    [sym_struct] = ACTIONS(4991),
    [sym_synchronized] = ACTIONS(4991),
    [sym_template] = ACTIONS(4991),
    [sym_typeof] = ACTIONS(4991),
    [sym_union] = ACTIONS(4991),
    [sym_unittest] = ACTIONS(4991),
    [sym_version] = ACTIONS(4991),
    [sym_while] = ACTIONS(4991),
    [sym_gshared] = ACTIONS(4991),
    [sym_traits] = ACTIONS(4991),
    [sym_vector] = ACTIONS(4991),
    [sym_void] = ACTIONS(4991),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2265] = {
    [sym_identifier] = ACTIONS(4999),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_SEMI] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5001),
    [anon_sym_AT] = ACTIONS(5001),
    [sym_bool] = ACTIONS(4999),
    [sym_byte] = ACTIONS(4999),
    [sym_ubyte] = ACTIONS(4999),
    [sym_char] = ACTIONS(4999),
    [sym_short] = ACTIONS(4999),
    [sym_ushort] = ACTIONS(4999),
    [sym_int] = ACTIONS(4999),
    [sym_uint] = ACTIONS(4999),
    [sym_long] = ACTIONS(4999),
    [sym_ulong] = ACTIONS(4999),
    [sym_cent] = ACTIONS(4999),
    [sym_ucent] = ACTIONS(4999),
    [sym_wchar] = ACTIONS(4999),
    [sym_dchar] = ACTIONS(4999),
    [sym_float] = ACTIONS(4999),
    [sym_double] = ACTIONS(4999),
    [sym_real] = ACTIONS(4999),
    [sym_ifloat] = ACTIONS(4999),
    [sym_idouble] = ACTIONS(4999),
    [sym_ireal] = ACTIONS(4999),
    [sym_cfloat] = ACTIONS(4999),
    [sym_cdouble] = ACTIONS(4999),
    [sym_creal] = ACTIONS(4999),
    [sym_size_t] = ACTIONS(4999),
    [sym_ptrdiff_t] = ACTIONS(4999),
    [sym_string] = ACTIONS(4999),
    [sym_cstring] = ACTIONS(4999),
    [sym_dstring] = ACTIONS(4999),
    [sym_wstring] = ACTIONS(4999),
    [sym_noreturn] = ACTIONS(4999),
    [sym_this] = ACTIONS(4999),
    [sym_abstract] = ACTIONS(4999),
    [sym_alias] = ACTIONS(4999),
    [sym_align] = ACTIONS(4999),
    [sym_auto] = ACTIONS(4999),
    [sym_catch] = ACTIONS(4999),
    [sym_class] = ACTIONS(4999),
    [sym_const] = ACTIONS(4999),
    [sym_debug] = ACTIONS(4999),
    [sym_deprecated] = ACTIONS(4999),
    [sym_else] = ACTIONS(4999),
    [sym_enum] = ACTIONS(4999),
    [sym_export] = ACTIONS(4999),
    [sym_extern] = ACTIONS(4999),
    [sym_final] = ACTIONS(4999),
    [sym_finally] = ACTIONS(4999),
    [sym_immutable] = ACTIONS(4999),
    [sym_import] = ACTIONS(4999),
    [sym_inout] = ACTIONS(4999),
    [sym_interface] = ACTIONS(4999),
    [sym_invariant] = ACTIONS(4999),
    [sym_mixin] = ACTIONS(4999),
    [sym_nothrow] = ACTIONS(4999),
    [sym_override] = ACTIONS(4999),
    [sym_package] = ACTIONS(4999),
    [sym_pragma] = ACTIONS(4999),
    [sym_private] = ACTIONS(4999),
    [sym_protected] = ACTIONS(4999),
    [sym_public] = ACTIONS(4999),
    [sym_pure] = ACTIONS(4999),
    [sym_ref] = ACTIONS(4999),
    [sym_return] = ACTIONS(4999),
    [sym_scope] = ACTIONS(4999),
    [sym_shared] = ACTIONS(4999),
    [sym_static] = ACTIONS(4999),
    [sym_struct] = ACTIONS(4999),
    [sym_synchronized] = ACTIONS(4999),
    [sym_template] = ACTIONS(4999),
    [sym_typeof] = ACTIONS(4999),
    [sym_union] = ACTIONS(4999),
    [sym_unittest] = ACTIONS(4999),
    [sym_version] = ACTIONS(4999),
    [sym_while] = ACTIONS(4999),
    [sym_gshared] = ACTIONS(4999),
    [sym_traits] = ACTIONS(4999),
    [sym_vector] = ACTIONS(4999),
    [sym_void] = ACTIONS(4999),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2266] = {
    [ts_builtin_sym_end] = ACTIONS(4931),
    [sym_identifier] = ACTIONS(4929),
    [anon_sym_RBRACE] = ACTIONS(4931),
    [anon_sym_DOT] = ACTIONS(4931),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4931),
    [anon_sym_AT] = ACTIONS(4931),
    [sym_bool] = ACTIONS(4929),
    [sym_byte] = ACTIONS(4929),
    [sym_ubyte] = ACTIONS(4929),
    [sym_char] = ACTIONS(4929),
    [sym_short] = ACTIONS(4929),
    [sym_ushort] = ACTIONS(4929),
    [sym_int] = ACTIONS(4929),
    [sym_uint] = ACTIONS(4929),
    [sym_long] = ACTIONS(4929),
    [sym_ulong] = ACTIONS(4929),
    [sym_cent] = ACTIONS(4929),
    [sym_ucent] = ACTIONS(4929),
    [sym_wchar] = ACTIONS(4929),
    [sym_dchar] = ACTIONS(4929),
    [sym_float] = ACTIONS(4929),
    [sym_double] = ACTIONS(4929),
    [sym_real] = ACTIONS(4929),
    [sym_ifloat] = ACTIONS(4929),
    [sym_idouble] = ACTIONS(4929),
    [sym_ireal] = ACTIONS(4929),
    [sym_cfloat] = ACTIONS(4929),
    [sym_cdouble] = ACTIONS(4929),
    [sym_creal] = ACTIONS(4929),
    [sym_size_t] = ACTIONS(4929),
    [sym_ptrdiff_t] = ACTIONS(4929),
    [sym_string] = ACTIONS(4929),
    [sym_cstring] = ACTIONS(4929),
    [sym_dstring] = ACTIONS(4929),
    [sym_wstring] = ACTIONS(4929),
    [sym_noreturn] = ACTIONS(4929),
    [sym_this] = ACTIONS(4929),
    [sym_abstract] = ACTIONS(4929),
    [sym_alias] = ACTIONS(4929),
    [sym_align] = ACTIONS(4929),
    [sym_auto] = ACTIONS(4929),
    [sym_class] = ACTIONS(4929),
    [sym_const] = ACTIONS(4929),
    [sym_debug] = ACTIONS(4929),
    [sym_deprecated] = ACTIONS(4929),
    [sym_else] = ACTIONS(4929),
    [sym_enum] = ACTIONS(4929),
    [sym_export] = ACTIONS(4929),
    [sym_extern] = ACTIONS(4929),
    [sym_final] = ACTIONS(4929),
    [sym_immutable] = ACTIONS(4929),
    [sym_import] = ACTIONS(4929),
    [sym_inout] = ACTIONS(4929),
    [sym_interface] = ACTIONS(4929),
    [sym_invariant] = ACTIONS(4929),
    [sym_mixin] = ACTIONS(4929),
    [sym_nothrow] = ACTIONS(4929),
    [sym_override] = ACTIONS(4929),
    [sym_package] = ACTIONS(4929),
    [sym_pragma] = ACTIONS(4929),
    [sym_private] = ACTIONS(4929),
    [sym_protected] = ACTIONS(4929),
    [sym_public] = ACTIONS(4929),
    [sym_pure] = ACTIONS(4929),
    [sym_ref] = ACTIONS(4929),
    [sym_return] = ACTIONS(4929),
    [sym_scope] = ACTIONS(4929),
    [sym_shared] = ACTIONS(4929),
    [sym_static] = ACTIONS(4929),
    [sym_struct] = ACTIONS(4929),
    [sym_synchronized] = ACTIONS(4929),
    [sym_template] = ACTIONS(4929),
    [sym_typeof] = ACTIONS(4929),
    [sym_union] = ACTIONS(4929),
    [sym_unittest] = ACTIONS(4929),
    [sym_version] = ACTIONS(4929),
    [sym_while] = ACTIONS(4929),
    [sym_gshared] = ACTIONS(4929),
    [sym_traits] = ACTIONS(4929),
    [sym_vector] = ACTIONS(4929),
    [sym_void] = ACTIONS(4929),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2267] = {
    [sym_identifier] = ACTIONS(5003),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5005),
    [anon_sym_AT] = ACTIONS(5005),
    [sym_bool] = ACTIONS(5003),
    [sym_byte] = ACTIONS(5003),
    [sym_ubyte] = ACTIONS(5003),
    [sym_char] = ACTIONS(5003),
    [sym_short] = ACTIONS(5003),
    [sym_ushort] = ACTIONS(5003),
    [sym_int] = ACTIONS(5003),
    [sym_uint] = ACTIONS(5003),
    [sym_long] = ACTIONS(5003),
    [sym_ulong] = ACTIONS(5003),
    [sym_cent] = ACTIONS(5003),
    [sym_ucent] = ACTIONS(5003),
    [sym_wchar] = ACTIONS(5003),
    [sym_dchar] = ACTIONS(5003),
    [sym_float] = ACTIONS(5003),
    [sym_double] = ACTIONS(5003),
    [sym_real] = ACTIONS(5003),
    [sym_ifloat] = ACTIONS(5003),
    [sym_idouble] = ACTIONS(5003),
    [sym_ireal] = ACTIONS(5003),
    [sym_cfloat] = ACTIONS(5003),
    [sym_cdouble] = ACTIONS(5003),
    [sym_creal] = ACTIONS(5003),
    [sym_size_t] = ACTIONS(5003),
    [sym_ptrdiff_t] = ACTIONS(5003),
    [sym_string] = ACTIONS(5003),
    [sym_cstring] = ACTIONS(5003),
    [sym_dstring] = ACTIONS(5003),
    [sym_wstring] = ACTIONS(5003),
    [sym_noreturn] = ACTIONS(5003),
    [sym_this] = ACTIONS(5003),
    [sym_abstract] = ACTIONS(5003),
    [sym_alias] = ACTIONS(5003),
    [sym_align] = ACTIONS(5003),
    [sym_auto] = ACTIONS(5003),
    [sym_catch] = ACTIONS(5003),
    [sym_class] = ACTIONS(5003),
    [sym_const] = ACTIONS(5003),
    [sym_debug] = ACTIONS(5003),
    [sym_deprecated] = ACTIONS(5003),
    [sym_else] = ACTIONS(5003),
    [sym_enum] = ACTIONS(5003),
    [sym_export] = ACTIONS(5003),
    [sym_extern] = ACTIONS(5003),
    [sym_final] = ACTIONS(5003),
    [sym_finally] = ACTIONS(5003),
    [sym_immutable] = ACTIONS(5003),
    [sym_import] = ACTIONS(5003),
    [sym_inout] = ACTIONS(5003),
    [sym_interface] = ACTIONS(5003),
    [sym_invariant] = ACTIONS(5003),
    [sym_mixin] = ACTIONS(5003),
    [sym_nothrow] = ACTIONS(5003),
    [sym_override] = ACTIONS(5003),
    [sym_package] = ACTIONS(5003),
    [sym_pragma] = ACTIONS(5003),
    [sym_private] = ACTIONS(5003),
    [sym_protected] = ACTIONS(5003),
    [sym_public] = ACTIONS(5003),
    [sym_pure] = ACTIONS(5003),
    [sym_ref] = ACTIONS(5003),
    [sym_return] = ACTIONS(5003),
    [sym_scope] = ACTIONS(5003),
    [sym_shared] = ACTIONS(5003),
    [sym_static] = ACTIONS(5003),
    [sym_struct] = ACTIONS(5003),
    [sym_synchronized] = ACTIONS(5003),
    [sym_template] = ACTIONS(5003),
    [sym_typeof] = ACTIONS(5003),
    [sym_union] = ACTIONS(5003),
    [sym_unittest] = ACTIONS(5003),
    [sym_version] = ACTIONS(5003),
    [sym_while] = ACTIONS(5003),
    [sym_gshared] = ACTIONS(5003),
    [sym_traits] = ACTIONS(5003),
    [sym_vector] = ACTIONS(5003),
    [sym_void] = ACTIONS(5003),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2268] = {
    [ts_builtin_sym_end] = ACTIONS(2523),
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_DOT] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2523),
    [sym_bool] = ACTIONS(2525),
    [sym_byte] = ACTIONS(2525),
    [sym_ubyte] = ACTIONS(2525),
    [sym_char] = ACTIONS(2525),
    [sym_short] = ACTIONS(2525),
    [sym_ushort] = ACTIONS(2525),
    [sym_int] = ACTIONS(2525),
    [sym_uint] = ACTIONS(2525),
    [sym_long] = ACTIONS(2525),
    [sym_ulong] = ACTIONS(2525),
    [sym_cent] = ACTIONS(2525),
    [sym_ucent] = ACTIONS(2525),
    [sym_wchar] = ACTIONS(2525),
    [sym_dchar] = ACTIONS(2525),
    [sym_float] = ACTIONS(2525),
    [sym_double] = ACTIONS(2525),
    [sym_real] = ACTIONS(2525),
    [sym_ifloat] = ACTIONS(2525),
    [sym_idouble] = ACTIONS(2525),
    [sym_ireal] = ACTIONS(2525),
    [sym_cfloat] = ACTIONS(2525),
    [sym_cdouble] = ACTIONS(2525),
    [sym_creal] = ACTIONS(2525),
    [sym_size_t] = ACTIONS(2525),
    [sym_ptrdiff_t] = ACTIONS(2525),
    [sym_string] = ACTIONS(2525),
    [sym_cstring] = ACTIONS(2525),
    [sym_dstring] = ACTIONS(2525),
    [sym_wstring] = ACTIONS(2525),
    [sym_noreturn] = ACTIONS(2525),
    [sym_this] = ACTIONS(2525),
    [sym_abstract] = ACTIONS(2525),
    [sym_alias] = ACTIONS(2525),
    [sym_align] = ACTIONS(2525),
    [sym_auto] = ACTIONS(2525),
    [sym_class] = ACTIONS(2525),
    [sym_const] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(2525),
    [sym_export] = ACTIONS(2525),
    [sym_extern] = ACTIONS(2525),
    [sym_final] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(2525),
    [sym_import] = ACTIONS(2525),
    [sym_inout] = ACTIONS(2525),
    [sym_interface] = ACTIONS(2525),
    [sym_invariant] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(2525),
    [sym_override] = ACTIONS(2525),
    [sym_package] = ACTIONS(2525),
    [sym_pragma] = ACTIONS(2525),
    [sym_private] = ACTIONS(2525),
    [sym_protected] = ACTIONS(2525),
    [sym_public] = ACTIONS(2525),
    [sym_pure] = ACTIONS(2525),
    [sym_ref] = ACTIONS(2525),
    [sym_return] = ACTIONS(2525),
    [sym_scope] = ACTIONS(2525),
    [sym_shared] = ACTIONS(2525),
    [sym_static] = ACTIONS(2525),
    [sym_struct] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(2525),
    [sym_template] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(2525),
    [sym_union] = ACTIONS(2525),
    [sym_unittest] = ACTIONS(2525),
    [sym_version] = ACTIONS(2525),
    [sym_while] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(2525),
    [sym_traits] = ACTIONS(2525),
    [sym_vector] = ACTIONS(2525),
    [sym_void] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2269] = {
    [sym_identifier] = ACTIONS(5007),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_SEMI] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5009),
    [anon_sym_AT] = ACTIONS(5009),
    [sym_bool] = ACTIONS(5007),
    [sym_byte] = ACTIONS(5007),
    [sym_ubyte] = ACTIONS(5007),
    [sym_char] = ACTIONS(5007),
    [sym_short] = ACTIONS(5007),
    [sym_ushort] = ACTIONS(5007),
    [sym_int] = ACTIONS(5007),
    [sym_uint] = ACTIONS(5007),
    [sym_long] = ACTIONS(5007),
    [sym_ulong] = ACTIONS(5007),
    [sym_cent] = ACTIONS(5007),
    [sym_ucent] = ACTIONS(5007),
    [sym_wchar] = ACTIONS(5007),
    [sym_dchar] = ACTIONS(5007),
    [sym_float] = ACTIONS(5007),
    [sym_double] = ACTIONS(5007),
    [sym_real] = ACTIONS(5007),
    [sym_ifloat] = ACTIONS(5007),
    [sym_idouble] = ACTIONS(5007),
    [sym_ireal] = ACTIONS(5007),
    [sym_cfloat] = ACTIONS(5007),
    [sym_cdouble] = ACTIONS(5007),
    [sym_creal] = ACTIONS(5007),
    [sym_size_t] = ACTIONS(5007),
    [sym_ptrdiff_t] = ACTIONS(5007),
    [sym_string] = ACTIONS(5007),
    [sym_cstring] = ACTIONS(5007),
    [sym_dstring] = ACTIONS(5007),
    [sym_wstring] = ACTIONS(5007),
    [sym_noreturn] = ACTIONS(5007),
    [sym_this] = ACTIONS(5007),
    [sym_abstract] = ACTIONS(5007),
    [sym_alias] = ACTIONS(5007),
    [sym_align] = ACTIONS(5007),
    [sym_auto] = ACTIONS(5007),
    [sym_catch] = ACTIONS(5007),
    [sym_class] = ACTIONS(5007),
    [sym_const] = ACTIONS(5007),
    [sym_debug] = ACTIONS(5007),
    [sym_deprecated] = ACTIONS(5007),
    [sym_else] = ACTIONS(5007),
    [sym_enum] = ACTIONS(5007),
    [sym_export] = ACTIONS(5007),
    [sym_extern] = ACTIONS(5007),
    [sym_final] = ACTIONS(5007),
    [sym_finally] = ACTIONS(5007),
    [sym_immutable] = ACTIONS(5007),
    [sym_import] = ACTIONS(5007),
    [sym_inout] = ACTIONS(5007),
    [sym_interface] = ACTIONS(5007),
    [sym_invariant] = ACTIONS(5007),
    [sym_mixin] = ACTIONS(5007),
    [sym_nothrow] = ACTIONS(5007),
    [sym_override] = ACTIONS(5007),
    [sym_package] = ACTIONS(5007),
    [sym_pragma] = ACTIONS(5007),
    [sym_private] = ACTIONS(5007),
    [sym_protected] = ACTIONS(5007),
    [sym_public] = ACTIONS(5007),
    [sym_pure] = ACTIONS(5007),
    [sym_ref] = ACTIONS(5007),
    [sym_return] = ACTIONS(5007),
    [sym_scope] = ACTIONS(5007),
    [sym_shared] = ACTIONS(5007),
    [sym_static] = ACTIONS(5007),
    [sym_struct] = ACTIONS(5007),
    [sym_synchronized] = ACTIONS(5007),
    [sym_template] = ACTIONS(5007),
    [sym_typeof] = ACTIONS(5007),
    [sym_union] = ACTIONS(5007),
    [sym_unittest] = ACTIONS(5007),
    [sym_version] = ACTIONS(5007),
    [sym_while] = ACTIONS(5007),
    [sym_gshared] = ACTIONS(5007),
    [sym_traits] = ACTIONS(5007),
    [sym_vector] = ACTIONS(5007),
    [sym_void] = ACTIONS(5007),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2270] = {
    [sym_identifier] = ACTIONS(4668),
    [anon_sym_DOT] = ACTIONS(4670),
    [anon_sym_SEMI] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(4670),
    [anon_sym_AT] = ACTIONS(4670),
    [sym_bool] = ACTIONS(4668),
    [sym_byte] = ACTIONS(4668),
    [sym_ubyte] = ACTIONS(4668),
    [sym_char] = ACTIONS(4668),
    [sym_short] = ACTIONS(4668),
    [sym_ushort] = ACTIONS(4668),
    [sym_int] = ACTIONS(4668),
    [sym_uint] = ACTIONS(4668),
    [sym_long] = ACTIONS(4668),
    [sym_ulong] = ACTIONS(4668),
    [sym_cent] = ACTIONS(4668),
    [sym_ucent] = ACTIONS(4668),
    [sym_wchar] = ACTIONS(4668),
    [sym_dchar] = ACTIONS(4668),
    [sym_float] = ACTIONS(4668),
    [sym_double] = ACTIONS(4668),
    [sym_real] = ACTIONS(4668),
    [sym_ifloat] = ACTIONS(4668),
    [sym_idouble] = ACTIONS(4668),
    [sym_ireal] = ACTIONS(4668),
    [sym_cfloat] = ACTIONS(4668),
    [sym_cdouble] = ACTIONS(4668),
    [sym_creal] = ACTIONS(4668),
    [sym_size_t] = ACTIONS(4668),
    [sym_ptrdiff_t] = ACTIONS(4668),
    [sym_string] = ACTIONS(4668),
    [sym_cstring] = ACTIONS(4668),
    [sym_dstring] = ACTIONS(4668),
    [sym_wstring] = ACTIONS(4668),
    [sym_noreturn] = ACTIONS(4668),
    [sym_this] = ACTIONS(4668),
    [sym_abstract] = ACTIONS(4668),
    [sym_alias] = ACTIONS(4668),
    [sym_align] = ACTIONS(4668),
    [sym_auto] = ACTIONS(4668),
    [sym_catch] = ACTIONS(4668),
    [sym_class] = ACTIONS(4668),
    [sym_const] = ACTIONS(4668),
    [sym_debug] = ACTIONS(4668),
    [sym_deprecated] = ACTIONS(4668),
    [sym_else] = ACTIONS(4668),
    [sym_enum] = ACTIONS(4668),
    [sym_export] = ACTIONS(4668),
    [sym_extern] = ACTIONS(4668),
    [sym_final] = ACTIONS(4668),
    [sym_finally] = ACTIONS(4668),
    [sym_immutable] = ACTIONS(4668),
    [sym_import] = ACTIONS(4668),
    [sym_inout] = ACTIONS(4668),
    [sym_interface] = ACTIONS(4668),
    [sym_invariant] = ACTIONS(4668),
    [sym_mixin] = ACTIONS(4668),
    [sym_nothrow] = ACTIONS(4668),
    [sym_override] = ACTIONS(4668),
    [sym_package] = ACTIONS(4668),
    [sym_pragma] = ACTIONS(4668),
    [sym_private] = ACTIONS(4668),
    [sym_protected] = ACTIONS(4668),
    [sym_public] = ACTIONS(4668),
    [sym_pure] = ACTIONS(4668),
    [sym_ref] = ACTIONS(4668),
    [sym_return] = ACTIONS(4668),
    [sym_scope] = ACTIONS(4668),
    [sym_shared] = ACTIONS(4668),
    [sym_static] = ACTIONS(4668),
    [sym_struct] = ACTIONS(4668),
    [sym_synchronized] = ACTIONS(4668),
    [sym_template] = ACTIONS(4668),
    [sym_typeof] = ACTIONS(4668),
    [sym_union] = ACTIONS(4668),
    [sym_unittest] = ACTIONS(4668),
    [sym_version] = ACTIONS(4668),
    [sym_while] = ACTIONS(4668),
    [sym_gshared] = ACTIONS(4668),
    [sym_traits] = ACTIONS(4668),
    [sym_vector] = ACTIONS(4668),
    [sym_void] = ACTIONS(4668),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2271] = {
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(2640),
    [sym_bool] = ACTIONS(2642),
    [sym_byte] = ACTIONS(2642),
    [sym_ubyte] = ACTIONS(2642),
    [sym_char] = ACTIONS(2642),
    [sym_short] = ACTIONS(2642),
    [sym_ushort] = ACTIONS(2642),
    [sym_int] = ACTIONS(2642),
    [sym_uint] = ACTIONS(2642),
    [sym_long] = ACTIONS(2642),
    [sym_ulong] = ACTIONS(2642),
    [sym_cent] = ACTIONS(2642),
    [sym_ucent] = ACTIONS(2642),
    [sym_wchar] = ACTIONS(2642),
    [sym_dchar] = ACTIONS(2642),
    [sym_float] = ACTIONS(2642),
    [sym_double] = ACTIONS(2642),
    [sym_real] = ACTIONS(2642),
    [sym_ifloat] = ACTIONS(2642),
    [sym_idouble] = ACTIONS(2642),
    [sym_ireal] = ACTIONS(2642),
    [sym_cfloat] = ACTIONS(2642),
    [sym_cdouble] = ACTIONS(2642),
    [sym_creal] = ACTIONS(2642),
    [sym_size_t] = ACTIONS(2642),
    [sym_ptrdiff_t] = ACTIONS(2642),
    [sym_string] = ACTIONS(2642),
    [sym_cstring] = ACTIONS(2642),
    [sym_dstring] = ACTIONS(2642),
    [sym_wstring] = ACTIONS(2642),
    [sym_noreturn] = ACTIONS(2642),
    [sym_this] = ACTIONS(2642),
    [sym_abstract] = ACTIONS(2642),
    [sym_alias] = ACTIONS(2642),
    [sym_align] = ACTIONS(2642),
    [sym_auto] = ACTIONS(2642),
    [sym_catch] = ACTIONS(2642),
    [sym_class] = ACTIONS(2642),
    [sym_const] = ACTIONS(2642),
    [sym_debug] = ACTIONS(2642),
    [sym_deprecated] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(2642),
    [sym_export] = ACTIONS(2642),
    [sym_extern] = ACTIONS(2642),
    [sym_final] = ACTIONS(2642),
    [sym_finally] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(2642),
    [sym_import] = ACTIONS(2642),
    [sym_inout] = ACTIONS(2642),
    [sym_interface] = ACTIONS(2642),
    [sym_invariant] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2642),
    [sym_nothrow] = ACTIONS(2642),
    [sym_override] = ACTIONS(2642),
    [sym_package] = ACTIONS(2642),
    [sym_pragma] = ACTIONS(2642),
    [sym_private] = ACTIONS(2642),
    [sym_protected] = ACTIONS(2642),
    [sym_public] = ACTIONS(2642),
    [sym_pure] = ACTIONS(2642),
    [sym_ref] = ACTIONS(2642),
    [sym_return] = ACTIONS(2642),
    [sym_scope] = ACTIONS(2642),
    [sym_shared] = ACTIONS(2642),
    [sym_static] = ACTIONS(2642),
    [sym_struct] = ACTIONS(2642),
    [sym_synchronized] = ACTIONS(2642),
    [sym_template] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(2642),
    [sym_union] = ACTIONS(2642),
    [sym_unittest] = ACTIONS(2642),
    [sym_version] = ACTIONS(2642),
    [sym_while] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(2642),
    [sym_traits] = ACTIONS(2642),
    [sym_vector] = ACTIONS(2642),
    [sym_void] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2272] = {
    [ts_builtin_sym_end] = ACTIONS(4344),
    [sym_identifier] = ACTIONS(4342),
    [anon_sym_RBRACE] = ACTIONS(4344),
    [anon_sym_DOT] = ACTIONS(4344),
    [anon_sym_SEMI] = ACTIONS(4344),
    [anon_sym_TILDE] = ACTIONS(4344),
    [anon_sym_AT] = ACTIONS(4344),
    [sym_bool] = ACTIONS(4342),
    [sym_byte] = ACTIONS(4342),
    [sym_ubyte] = ACTIONS(4342),
    [sym_char] = ACTIONS(4342),
    [sym_short] = ACTIONS(4342),
    [sym_ushort] = ACTIONS(4342),
    [sym_int] = ACTIONS(4342),
    [sym_uint] = ACTIONS(4342),
    [sym_long] = ACTIONS(4342),
    [sym_ulong] = ACTIONS(4342),
    [sym_cent] = ACTIONS(4342),
    [sym_ucent] = ACTIONS(4342),
    [sym_wchar] = ACTIONS(4342),
    [sym_dchar] = ACTIONS(4342),
    [sym_float] = ACTIONS(4342),
    [sym_double] = ACTIONS(4342),
    [sym_real] = ACTIONS(4342),
    [sym_ifloat] = ACTIONS(4342),
    [sym_idouble] = ACTIONS(4342),
    [sym_ireal] = ACTIONS(4342),
    [sym_cfloat] = ACTIONS(4342),
    [sym_cdouble] = ACTIONS(4342),
    [sym_creal] = ACTIONS(4342),
    [sym_size_t] = ACTIONS(4342),
    [sym_ptrdiff_t] = ACTIONS(4342),
    [sym_string] = ACTIONS(4342),
    [sym_cstring] = ACTIONS(4342),
    [sym_dstring] = ACTIONS(4342),
    [sym_wstring] = ACTIONS(4342),
    [sym_noreturn] = ACTIONS(4342),
    [sym_this] = ACTIONS(4342),
    [sym_abstract] = ACTIONS(4342),
    [sym_alias] = ACTIONS(4342),
    [sym_align] = ACTIONS(4342),
    [sym_auto] = ACTIONS(4342),
    [sym_class] = ACTIONS(4342),
    [sym_const] = ACTIONS(4342),
    [sym_debug] = ACTIONS(4342),
    [sym_deprecated] = ACTIONS(4342),
    [sym_else] = ACTIONS(4342),
    [sym_enum] = ACTIONS(4342),
    [sym_export] = ACTIONS(4342),
    [sym_extern] = ACTIONS(4342),
    [sym_final] = ACTIONS(4342),
    [sym_immutable] = ACTIONS(4342),
    [sym_import] = ACTIONS(4342),
    [sym_inout] = ACTIONS(4342),
    [sym_interface] = ACTIONS(4342),
    [sym_invariant] = ACTIONS(4342),
    [sym_mixin] = ACTIONS(4342),
    [sym_nothrow] = ACTIONS(4342),
    [sym_override] = ACTIONS(4342),
    [sym_package] = ACTIONS(4342),
    [sym_pragma] = ACTIONS(4342),
    [sym_private] = ACTIONS(4342),
    [sym_protected] = ACTIONS(4342),
    [sym_public] = ACTIONS(4342),
    [sym_pure] = ACTIONS(4342),
    [sym_ref] = ACTIONS(4342),
    [sym_return] = ACTIONS(4342),
    [sym_scope] = ACTIONS(4342),
    [sym_shared] = ACTIONS(4342),
    [sym_static] = ACTIONS(4342),
    [sym_struct] = ACTIONS(4342),
    [sym_synchronized] = ACTIONS(4342),
    [sym_template] = ACTIONS(4342),
    [sym_typeof] = ACTIONS(4342),
    [sym_union] = ACTIONS(4342),
    [sym_unittest] = ACTIONS(4342),
    [sym_version] = ACTIONS(4342),
    [sym_while] = ACTIONS(4342),
    [sym_gshared] = ACTIONS(4342),
    [sym_traits] = ACTIONS(4342),
    [sym_vector] = ACTIONS(4342),
    [sym_void] = ACTIONS(4342),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2273] = {
    [ts_builtin_sym_end] = ACTIONS(4791),
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_RBRACE] = ACTIONS(4791),
    [anon_sym_DOT] = ACTIONS(4791),
    [anon_sym_SEMI] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [anon_sym_AT] = ACTIONS(4791),
    [sym_bool] = ACTIONS(4789),
    [sym_byte] = ACTIONS(4789),
    [sym_ubyte] = ACTIONS(4789),
    [sym_char] = ACTIONS(4789),
    [sym_short] = ACTIONS(4789),
    [sym_ushort] = ACTIONS(4789),
    [sym_int] = ACTIONS(4789),
    [sym_uint] = ACTIONS(4789),
    [sym_long] = ACTIONS(4789),
    [sym_ulong] = ACTIONS(4789),
    [sym_cent] = ACTIONS(4789),
    [sym_ucent] = ACTIONS(4789),
    [sym_wchar] = ACTIONS(4789),
    [sym_dchar] = ACTIONS(4789),
    [sym_float] = ACTIONS(4789),
    [sym_double] = ACTIONS(4789),
    [sym_real] = ACTIONS(4789),
    [sym_ifloat] = ACTIONS(4789),
    [sym_idouble] = ACTIONS(4789),
    [sym_ireal] = ACTIONS(4789),
    [sym_cfloat] = ACTIONS(4789),
    [sym_cdouble] = ACTIONS(4789),
    [sym_creal] = ACTIONS(4789),
    [sym_size_t] = ACTIONS(4789),
    [sym_ptrdiff_t] = ACTIONS(4789),
    [sym_string] = ACTIONS(4789),
    [sym_cstring] = ACTIONS(4789),
    [sym_dstring] = ACTIONS(4789),
    [sym_wstring] = ACTIONS(4789),
    [sym_noreturn] = ACTIONS(4789),
    [sym_this] = ACTIONS(4789),
    [sym_abstract] = ACTIONS(4789),
    [sym_alias] = ACTIONS(4789),
    [sym_align] = ACTIONS(4789),
    [sym_auto] = ACTIONS(4789),
    [sym_class] = ACTIONS(4789),
    [sym_const] = ACTIONS(4789),
    [sym_debug] = ACTIONS(4789),
    [sym_deprecated] = ACTIONS(4789),
    [sym_else] = ACTIONS(4789),
    [sym_enum] = ACTIONS(4789),
    [sym_export] = ACTIONS(4789),
    [sym_extern] = ACTIONS(4789),
    [sym_final] = ACTIONS(4789),
    [sym_immutable] = ACTIONS(4789),
    [sym_import] = ACTIONS(4789),
    [sym_inout] = ACTIONS(4789),
    [sym_interface] = ACTIONS(4789),
    [sym_invariant] = ACTIONS(4789),
    [sym_mixin] = ACTIONS(4789),
    [sym_nothrow] = ACTIONS(4789),
    [sym_override] = ACTIONS(4789),
    [sym_package] = ACTIONS(4789),
    [sym_pragma] = ACTIONS(4789),
    [sym_private] = ACTIONS(4789),
    [sym_protected] = ACTIONS(4789),
    [sym_public] = ACTIONS(4789),
    [sym_pure] = ACTIONS(4789),
    [sym_ref] = ACTIONS(4789),
    [sym_return] = ACTIONS(4789),
    [sym_scope] = ACTIONS(4789),
    [sym_shared] = ACTIONS(4789),
    [sym_static] = ACTIONS(4789),
    [sym_struct] = ACTIONS(4789),
    [sym_synchronized] = ACTIONS(4789),
    [sym_template] = ACTIONS(4789),
    [sym_typeof] = ACTIONS(4789),
    [sym_union] = ACTIONS(4789),
    [sym_unittest] = ACTIONS(4789),
    [sym_version] = ACTIONS(4789),
    [sym_while] = ACTIONS(4789),
    [sym_gshared] = ACTIONS(4789),
    [sym_traits] = ACTIONS(4789),
    [sym_vector] = ACTIONS(4789),
    [sym_void] = ACTIONS(4789),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2274] = {
    [sym_identifier] = ACTIONS(4558),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_SEMI] = ACTIONS(4560),
    [anon_sym_TILDE] = ACTIONS(4560),
    [anon_sym_AT] = ACTIONS(4560),
    [sym_bool] = ACTIONS(4558),
    [sym_byte] = ACTIONS(4558),
    [sym_ubyte] = ACTIONS(4558),
    [sym_char] = ACTIONS(4558),
    [sym_short] = ACTIONS(4558),
    [sym_ushort] = ACTIONS(4558),
    [sym_int] = ACTIONS(4558),
    [sym_uint] = ACTIONS(4558),
    [sym_long] = ACTIONS(4558),
    [sym_ulong] = ACTIONS(4558),
    [sym_cent] = ACTIONS(4558),
    [sym_ucent] = ACTIONS(4558),
    [sym_wchar] = ACTIONS(4558),
    [sym_dchar] = ACTIONS(4558),
    [sym_float] = ACTIONS(4558),
    [sym_double] = ACTIONS(4558),
    [sym_real] = ACTIONS(4558),
    [sym_ifloat] = ACTIONS(4558),
    [sym_idouble] = ACTIONS(4558),
    [sym_ireal] = ACTIONS(4558),
    [sym_cfloat] = ACTIONS(4558),
    [sym_cdouble] = ACTIONS(4558),
    [sym_creal] = ACTIONS(4558),
    [sym_size_t] = ACTIONS(4558),
    [sym_ptrdiff_t] = ACTIONS(4558),
    [sym_string] = ACTIONS(4558),
    [sym_cstring] = ACTIONS(4558),
    [sym_dstring] = ACTIONS(4558),
    [sym_wstring] = ACTIONS(4558),
    [sym_noreturn] = ACTIONS(4558),
    [sym_this] = ACTIONS(4558),
    [sym_abstract] = ACTIONS(4558),
    [sym_alias] = ACTIONS(4558),
    [sym_align] = ACTIONS(4558),
    [sym_auto] = ACTIONS(4558),
    [sym_catch] = ACTIONS(4558),
    [sym_class] = ACTIONS(4558),
    [sym_const] = ACTIONS(4558),
    [sym_debug] = ACTIONS(4558),
    [sym_deprecated] = ACTIONS(4558),
    [sym_else] = ACTIONS(4558),
    [sym_enum] = ACTIONS(4558),
    [sym_export] = ACTIONS(4558),
    [sym_extern] = ACTIONS(4558),
    [sym_final] = ACTIONS(4558),
    [sym_finally] = ACTIONS(4558),
    [sym_immutable] = ACTIONS(4558),
    [sym_import] = ACTIONS(4558),
    [sym_inout] = ACTIONS(4558),
    [sym_interface] = ACTIONS(4558),
    [sym_invariant] = ACTIONS(4558),
    [sym_mixin] = ACTIONS(4558),
    [sym_nothrow] = ACTIONS(4558),
    [sym_override] = ACTIONS(4558),
    [sym_package] = ACTIONS(4558),
    [sym_pragma] = ACTIONS(4558),
    [sym_private] = ACTIONS(4558),
    [sym_protected] = ACTIONS(4558),
    [sym_public] = ACTIONS(4558),
    [sym_pure] = ACTIONS(4558),
    [sym_ref] = ACTIONS(4558),
    [sym_return] = ACTIONS(4558),
    [sym_scope] = ACTIONS(4558),
    [sym_shared] = ACTIONS(4558),
    [sym_static] = ACTIONS(4558),
    [sym_struct] = ACTIONS(4558),
    [sym_synchronized] = ACTIONS(4558),
    [sym_template] = ACTIONS(4558),
    [sym_typeof] = ACTIONS(4558),
    [sym_union] = ACTIONS(4558),
    [sym_unittest] = ACTIONS(4558),
    [sym_version] = ACTIONS(4558),
    [sym_while] = ACTIONS(4558),
    [sym_gshared] = ACTIONS(4558),
    [sym_traits] = ACTIONS(4558),
    [sym_vector] = ACTIONS(4558),
    [sym_void] = ACTIONS(4558),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2275] = {
    [sym_identifier] = ACTIONS(4358),
    [anon_sym_DOT] = ACTIONS(4360),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_TILDE] = ACTIONS(4360),
    [anon_sym_AT] = ACTIONS(4360),
    [sym_bool] = ACTIONS(4358),
    [sym_byte] = ACTIONS(4358),
    [sym_ubyte] = ACTIONS(4358),
    [sym_char] = ACTIONS(4358),
    [sym_short] = ACTIONS(4358),
    [sym_ushort] = ACTIONS(4358),
    [sym_int] = ACTIONS(4358),
    [sym_uint] = ACTIONS(4358),
    [sym_long] = ACTIONS(4358),
    [sym_ulong] = ACTIONS(4358),
    [sym_cent] = ACTIONS(4358),
    [sym_ucent] = ACTIONS(4358),
    [sym_wchar] = ACTIONS(4358),
    [sym_dchar] = ACTIONS(4358),
    [sym_float] = ACTIONS(4358),
    [sym_double] = ACTIONS(4358),
    [sym_real] = ACTIONS(4358),
    [sym_ifloat] = ACTIONS(4358),
    [sym_idouble] = ACTIONS(4358),
    [sym_ireal] = ACTIONS(4358),
    [sym_cfloat] = ACTIONS(4358),
    [sym_cdouble] = ACTIONS(4358),
    [sym_creal] = ACTIONS(4358),
    [sym_size_t] = ACTIONS(4358),
    [sym_ptrdiff_t] = ACTIONS(4358),
    [sym_string] = ACTIONS(4358),
    [sym_cstring] = ACTIONS(4358),
    [sym_dstring] = ACTIONS(4358),
    [sym_wstring] = ACTIONS(4358),
    [sym_noreturn] = ACTIONS(4358),
    [sym_this] = ACTIONS(4358),
    [sym_abstract] = ACTIONS(4358),
    [sym_alias] = ACTIONS(4358),
    [sym_align] = ACTIONS(4358),
    [sym_auto] = ACTIONS(4358),
    [sym_catch] = ACTIONS(4358),
    [sym_class] = ACTIONS(4358),
    [sym_const] = ACTIONS(4358),
    [sym_debug] = ACTIONS(4358),
    [sym_deprecated] = ACTIONS(4358),
    [sym_else] = ACTIONS(4358),
    [sym_enum] = ACTIONS(4358),
    [sym_export] = ACTIONS(4358),
    [sym_extern] = ACTIONS(4358),
    [sym_final] = ACTIONS(4358),
    [sym_finally] = ACTIONS(4358),
    [sym_immutable] = ACTIONS(4358),
    [sym_import] = ACTIONS(4358),
    [sym_inout] = ACTIONS(4358),
    [sym_interface] = ACTIONS(4358),
    [sym_invariant] = ACTIONS(4358),
    [sym_mixin] = ACTIONS(4358),
    [sym_nothrow] = ACTIONS(4358),
    [sym_override] = ACTIONS(4358),
    [sym_package] = ACTIONS(4358),
    [sym_pragma] = ACTIONS(4358),
    [sym_private] = ACTIONS(4358),
    [sym_protected] = ACTIONS(4358),
    [sym_public] = ACTIONS(4358),
    [sym_pure] = ACTIONS(4358),
    [sym_ref] = ACTIONS(4358),
    [sym_return] = ACTIONS(4358),
    [sym_scope] = ACTIONS(4358),
    [sym_shared] = ACTIONS(4358),
    [sym_static] = ACTIONS(4358),
    [sym_struct] = ACTIONS(4358),
    [sym_synchronized] = ACTIONS(4358),
    [sym_template] = ACTIONS(4358),
    [sym_typeof] = ACTIONS(4358),
    [sym_union] = ACTIONS(4358),
    [sym_unittest] = ACTIONS(4358),
    [sym_version] = ACTIONS(4358),
    [sym_while] = ACTIONS(4358),
    [sym_gshared] = ACTIONS(4358),
    [sym_traits] = ACTIONS(4358),
    [sym_vector] = ACTIONS(4358),
    [sym_void] = ACTIONS(4358),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2276] = {
    [sym_identifier] = ACTIONS(4941),
    [anon_sym_DOT] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4943),
    [anon_sym_AT] = ACTIONS(4943),
    [sym_bool] = ACTIONS(4941),
    [sym_byte] = ACTIONS(4941),
    [sym_ubyte] = ACTIONS(4941),
    [sym_char] = ACTIONS(4941),
    [sym_short] = ACTIONS(4941),
    [sym_ushort] = ACTIONS(4941),
    [sym_int] = ACTIONS(4941),
    [sym_uint] = ACTIONS(4941),
    [sym_long] = ACTIONS(4941),
    [sym_ulong] = ACTIONS(4941),
    [sym_cent] = ACTIONS(4941),
    [sym_ucent] = ACTIONS(4941),
    [sym_wchar] = ACTIONS(4941),
    [sym_dchar] = ACTIONS(4941),
    [sym_float] = ACTIONS(4941),
    [sym_double] = ACTIONS(4941),
    [sym_real] = ACTIONS(4941),
    [sym_ifloat] = ACTIONS(4941),
    [sym_idouble] = ACTIONS(4941),
    [sym_ireal] = ACTIONS(4941),
    [sym_cfloat] = ACTIONS(4941),
    [sym_cdouble] = ACTIONS(4941),
    [sym_creal] = ACTIONS(4941),
    [sym_size_t] = ACTIONS(4941),
    [sym_ptrdiff_t] = ACTIONS(4941),
    [sym_string] = ACTIONS(4941),
    [sym_cstring] = ACTIONS(4941),
    [sym_dstring] = ACTIONS(4941),
    [sym_wstring] = ACTIONS(4941),
    [sym_noreturn] = ACTIONS(4941),
    [sym_this] = ACTIONS(4941),
    [sym_abstract] = ACTIONS(4941),
    [sym_alias] = ACTIONS(4941),
    [sym_align] = ACTIONS(4941),
    [sym_auto] = ACTIONS(4941),
    [sym_catch] = ACTIONS(4941),
    [sym_class] = ACTIONS(4941),
    [sym_const] = ACTIONS(4941),
    [sym_debug] = ACTIONS(4941),
    [sym_deprecated] = ACTIONS(4941),
    [sym_else] = ACTIONS(4941),
    [sym_enum] = ACTIONS(4941),
    [sym_export] = ACTIONS(4941),
    [sym_extern] = ACTIONS(4941),
    [sym_final] = ACTIONS(4941),
    [sym_finally] = ACTIONS(4941),
    [sym_immutable] = ACTIONS(4941),
    [sym_import] = ACTIONS(4941),
    [sym_inout] = ACTIONS(4941),
    [sym_interface] = ACTIONS(4941),
    [sym_invariant] = ACTIONS(4941),
    [sym_mixin] = ACTIONS(4941),
    [sym_nothrow] = ACTIONS(4941),
    [sym_override] = ACTIONS(4941),
    [sym_package] = ACTIONS(4941),
    [sym_pragma] = ACTIONS(4941),
    [sym_private] = ACTIONS(4941),
    [sym_protected] = ACTIONS(4941),
    [sym_public] = ACTIONS(4941),
    [sym_pure] = ACTIONS(4941),
    [sym_ref] = ACTIONS(4941),
    [sym_return] = ACTIONS(4941),
    [sym_scope] = ACTIONS(4941),
    [sym_shared] = ACTIONS(4941),
    [sym_static] = ACTIONS(4941),
    [sym_struct] = ACTIONS(4941),
    [sym_synchronized] = ACTIONS(4941),
    [sym_template] = ACTIONS(4941),
    [sym_typeof] = ACTIONS(4941),
    [sym_union] = ACTIONS(4941),
    [sym_unittest] = ACTIONS(4941),
    [sym_version] = ACTIONS(4941),
    [sym_while] = ACTIONS(4941),
    [sym_gshared] = ACTIONS(4941),
    [sym_traits] = ACTIONS(4941),
    [sym_vector] = ACTIONS(4941),
    [sym_void] = ACTIONS(4941),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2277] = {
    [ts_builtin_sym_end] = ACTIONS(4508),
    [sym_identifier] = ACTIONS(4506),
    [anon_sym_RBRACE] = ACTIONS(4508),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_SEMI] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4508),
    [anon_sym_AT] = ACTIONS(4508),
    [sym_bool] = ACTIONS(4506),
    [sym_byte] = ACTIONS(4506),
    [sym_ubyte] = ACTIONS(4506),
    [sym_char] = ACTIONS(4506),
    [sym_short] = ACTIONS(4506),
    [sym_ushort] = ACTIONS(4506),
    [sym_int] = ACTIONS(4506),
    [sym_uint] = ACTIONS(4506),
    [sym_long] = ACTIONS(4506),
    [sym_ulong] = ACTIONS(4506),
    [sym_cent] = ACTIONS(4506),
    [sym_ucent] = ACTIONS(4506),
    [sym_wchar] = ACTIONS(4506),
    [sym_dchar] = ACTIONS(4506),
    [sym_float] = ACTIONS(4506),
    [sym_double] = ACTIONS(4506),
    [sym_real] = ACTIONS(4506),
    [sym_ifloat] = ACTIONS(4506),
    [sym_idouble] = ACTIONS(4506),
    [sym_ireal] = ACTIONS(4506),
    [sym_cfloat] = ACTIONS(4506),
    [sym_cdouble] = ACTIONS(4506),
    [sym_creal] = ACTIONS(4506),
    [sym_size_t] = ACTIONS(4506),
    [sym_ptrdiff_t] = ACTIONS(4506),
    [sym_string] = ACTIONS(4506),
    [sym_cstring] = ACTIONS(4506),
    [sym_dstring] = ACTIONS(4506),
    [sym_wstring] = ACTIONS(4506),
    [sym_noreturn] = ACTIONS(4506),
    [sym_this] = ACTIONS(4506),
    [sym_abstract] = ACTIONS(4506),
    [sym_alias] = ACTIONS(4506),
    [sym_align] = ACTIONS(4506),
    [sym_auto] = ACTIONS(4506),
    [sym_class] = ACTIONS(4506),
    [sym_const] = ACTIONS(4506),
    [sym_debug] = ACTIONS(4506),
    [sym_deprecated] = ACTIONS(4506),
    [sym_else] = ACTIONS(4506),
    [sym_enum] = ACTIONS(4506),
    [sym_export] = ACTIONS(4506),
    [sym_extern] = ACTIONS(4506),
    [sym_final] = ACTIONS(4506),
    [sym_immutable] = ACTIONS(4506),
    [sym_import] = ACTIONS(4506),
    [sym_inout] = ACTIONS(4506),
    [sym_interface] = ACTIONS(4506),
    [sym_invariant] = ACTIONS(4506),
    [sym_mixin] = ACTIONS(4506),
    [sym_nothrow] = ACTIONS(4506),
    [sym_override] = ACTIONS(4506),
    [sym_package] = ACTIONS(4506),
    [sym_pragma] = ACTIONS(4506),
    [sym_private] = ACTIONS(4506),
    [sym_protected] = ACTIONS(4506),
    [sym_public] = ACTIONS(4506),
    [sym_pure] = ACTIONS(4506),
    [sym_ref] = ACTIONS(4506),
    [sym_return] = ACTIONS(4506),
    [sym_scope] = ACTIONS(4506),
    [sym_shared] = ACTIONS(4506),
    [sym_static] = ACTIONS(4506),
    [sym_struct] = ACTIONS(4506),
    [sym_synchronized] = ACTIONS(4506),
    [sym_template] = ACTIONS(4506),
    [sym_typeof] = ACTIONS(4506),
    [sym_union] = ACTIONS(4506),
    [sym_unittest] = ACTIONS(4506),
    [sym_version] = ACTIONS(4506),
    [sym_while] = ACTIONS(4506),
    [sym_gshared] = ACTIONS(4506),
    [sym_traits] = ACTIONS(4506),
    [sym_vector] = ACTIONS(4506),
    [sym_void] = ACTIONS(4506),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2278] = {
    [ts_builtin_sym_end] = ACTIONS(4807),
    [sym_identifier] = ACTIONS(4805),
    [anon_sym_RBRACE] = ACTIONS(4807),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_SEMI] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [anon_sym_AT] = ACTIONS(4807),
    [sym_bool] = ACTIONS(4805),
    [sym_byte] = ACTIONS(4805),
    [sym_ubyte] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_short] = ACTIONS(4805),
    [sym_ushort] = ACTIONS(4805),
    [sym_int] = ACTIONS(4805),
    [sym_uint] = ACTIONS(4805),
    [sym_long] = ACTIONS(4805),
    [sym_ulong] = ACTIONS(4805),
    [sym_cent] = ACTIONS(4805),
    [sym_ucent] = ACTIONS(4805),
    [sym_wchar] = ACTIONS(4805),
    [sym_dchar] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_double] = ACTIONS(4805),
    [sym_real] = ACTIONS(4805),
    [sym_ifloat] = ACTIONS(4805),
    [sym_idouble] = ACTIONS(4805),
    [sym_ireal] = ACTIONS(4805),
    [sym_cfloat] = ACTIONS(4805),
    [sym_cdouble] = ACTIONS(4805),
    [sym_creal] = ACTIONS(4805),
    [sym_size_t] = ACTIONS(4805),
    [sym_ptrdiff_t] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym_cstring] = ACTIONS(4805),
    [sym_dstring] = ACTIONS(4805),
    [sym_wstring] = ACTIONS(4805),
    [sym_noreturn] = ACTIONS(4805),
    [sym_this] = ACTIONS(4805),
    [sym_abstract] = ACTIONS(4805),
    [sym_alias] = ACTIONS(4805),
    [sym_align] = ACTIONS(4805),
    [sym_auto] = ACTIONS(4805),
    [sym_class] = ACTIONS(4805),
    [sym_const] = ACTIONS(4805),
    [sym_debug] = ACTIONS(4805),
    [sym_deprecated] = ACTIONS(4805),
    [sym_else] = ACTIONS(4805),
    [sym_enum] = ACTIONS(4805),
    [sym_export] = ACTIONS(4805),
    [sym_extern] = ACTIONS(4805),
    [sym_final] = ACTIONS(4805),
    [sym_immutable] = ACTIONS(4805),
    [sym_import] = ACTIONS(4805),
    [sym_inout] = ACTIONS(4805),
    [sym_interface] = ACTIONS(4805),
    [sym_invariant] = ACTIONS(4805),
    [sym_mixin] = ACTIONS(4805),
    [sym_nothrow] = ACTIONS(4805),
    [sym_override] = ACTIONS(4805),
    [sym_package] = ACTIONS(4805),
    [sym_pragma] = ACTIONS(4805),
    [sym_private] = ACTIONS(4805),
    [sym_protected] = ACTIONS(4805),
    [sym_public] = ACTIONS(4805),
    [sym_pure] = ACTIONS(4805),
    [sym_ref] = ACTIONS(4805),
    [sym_return] = ACTIONS(4805),
    [sym_scope] = ACTIONS(4805),
    [sym_shared] = ACTIONS(4805),
    [sym_static] = ACTIONS(4805),
    [sym_struct] = ACTIONS(4805),
    [sym_synchronized] = ACTIONS(4805),
    [sym_template] = ACTIONS(4805),
    [sym_typeof] = ACTIONS(4805),
    [sym_union] = ACTIONS(4805),
    [sym_unittest] = ACTIONS(4805),
    [sym_version] = ACTIONS(4805),
    [sym_while] = ACTIONS(4805),
    [sym_gshared] = ACTIONS(4805),
    [sym_traits] = ACTIONS(4805),
    [sym_vector] = ACTIONS(4805),
    [sym_void] = ACTIONS(4805),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2279] = {
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym_TILDE] = ACTIONS(4418),
    [anon_sym_AT] = ACTIONS(4418),
    [sym_bool] = ACTIONS(4416),
    [sym_byte] = ACTIONS(4416),
    [sym_ubyte] = ACTIONS(4416),
    [sym_char] = ACTIONS(4416),
    [sym_short] = ACTIONS(4416),
    [sym_ushort] = ACTIONS(4416),
    [sym_int] = ACTIONS(4416),
    [sym_uint] = ACTIONS(4416),
    [sym_long] = ACTIONS(4416),
    [sym_ulong] = ACTIONS(4416),
    [sym_cent] = ACTIONS(4416),
    [sym_ucent] = ACTIONS(4416),
    [sym_wchar] = ACTIONS(4416),
    [sym_dchar] = ACTIONS(4416),
    [sym_float] = ACTIONS(4416),
    [sym_double] = ACTIONS(4416),
    [sym_real] = ACTIONS(4416),
    [sym_ifloat] = ACTIONS(4416),
    [sym_idouble] = ACTIONS(4416),
    [sym_ireal] = ACTIONS(4416),
    [sym_cfloat] = ACTIONS(4416),
    [sym_cdouble] = ACTIONS(4416),
    [sym_creal] = ACTIONS(4416),
    [sym_size_t] = ACTIONS(4416),
    [sym_ptrdiff_t] = ACTIONS(4416),
    [sym_string] = ACTIONS(4416),
    [sym_cstring] = ACTIONS(4416),
    [sym_dstring] = ACTIONS(4416),
    [sym_wstring] = ACTIONS(4416),
    [sym_noreturn] = ACTIONS(4416),
    [sym_this] = ACTIONS(4416),
    [sym_abstract] = ACTIONS(4416),
    [sym_alias] = ACTIONS(4416),
    [sym_align] = ACTIONS(4416),
    [sym_auto] = ACTIONS(4416),
    [sym_catch] = ACTIONS(4416),
    [sym_class] = ACTIONS(4416),
    [sym_const] = ACTIONS(4416),
    [sym_debug] = ACTIONS(4416),
    [sym_deprecated] = ACTIONS(4416),
    [sym_else] = ACTIONS(4416),
    [sym_enum] = ACTIONS(4416),
    [sym_export] = ACTIONS(4416),
    [sym_extern] = ACTIONS(4416),
    [sym_final] = ACTIONS(4416),
    [sym_finally] = ACTIONS(4416),
    [sym_immutable] = ACTIONS(4416),
    [sym_import] = ACTIONS(4416),
    [sym_inout] = ACTIONS(4416),
    [sym_interface] = ACTIONS(4416),
    [sym_invariant] = ACTIONS(4416),
    [sym_mixin] = ACTIONS(4416),
    [sym_nothrow] = ACTIONS(4416),
    [sym_override] = ACTIONS(4416),
    [sym_package] = ACTIONS(4416),
    [sym_pragma] = ACTIONS(4416),
    [sym_private] = ACTIONS(4416),
    [sym_protected] = ACTIONS(4416),
    [sym_public] = ACTIONS(4416),
    [sym_pure] = ACTIONS(4416),
    [sym_ref] = ACTIONS(4416),
    [sym_return] = ACTIONS(4416),
    [sym_scope] = ACTIONS(4416),
    [sym_shared] = ACTIONS(4416),
    [sym_static] = ACTIONS(4416),
    [sym_struct] = ACTIONS(4416),
    [sym_synchronized] = ACTIONS(4416),
    [sym_template] = ACTIONS(4416),
    [sym_typeof] = ACTIONS(4416),
    [sym_union] = ACTIONS(4416),
    [sym_unittest] = ACTIONS(4416),
    [sym_version] = ACTIONS(4416),
    [sym_while] = ACTIONS(4416),
    [sym_gshared] = ACTIONS(4416),
    [sym_traits] = ACTIONS(4416),
    [sym_vector] = ACTIONS(4416),
    [sym_void] = ACTIONS(4416),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2280] = {
    [ts_builtin_sym_end] = ACTIONS(4488),
    [sym_identifier] = ACTIONS(4486),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4488),
    [anon_sym_AT] = ACTIONS(4488),
    [sym_bool] = ACTIONS(4486),
    [sym_byte] = ACTIONS(4486),
    [sym_ubyte] = ACTIONS(4486),
    [sym_char] = ACTIONS(4486),
    [sym_short] = ACTIONS(4486),
    [sym_ushort] = ACTIONS(4486),
    [sym_int] = ACTIONS(4486),
    [sym_uint] = ACTIONS(4486),
    [sym_long] = ACTIONS(4486),
    [sym_ulong] = ACTIONS(4486),
    [sym_cent] = ACTIONS(4486),
    [sym_ucent] = ACTIONS(4486),
    [sym_wchar] = ACTIONS(4486),
    [sym_dchar] = ACTIONS(4486),
    [sym_float] = ACTIONS(4486),
    [sym_double] = ACTIONS(4486),
    [sym_real] = ACTIONS(4486),
    [sym_ifloat] = ACTIONS(4486),
    [sym_idouble] = ACTIONS(4486),
    [sym_ireal] = ACTIONS(4486),
    [sym_cfloat] = ACTIONS(4486),
    [sym_cdouble] = ACTIONS(4486),
    [sym_creal] = ACTIONS(4486),
    [sym_size_t] = ACTIONS(4486),
    [sym_ptrdiff_t] = ACTIONS(4486),
    [sym_string] = ACTIONS(4486),
    [sym_cstring] = ACTIONS(4486),
    [sym_dstring] = ACTIONS(4486),
    [sym_wstring] = ACTIONS(4486),
    [sym_noreturn] = ACTIONS(4486),
    [sym_this] = ACTIONS(4486),
    [sym_abstract] = ACTIONS(4486),
    [sym_alias] = ACTIONS(4486),
    [sym_align] = ACTIONS(4486),
    [sym_auto] = ACTIONS(4486),
    [sym_class] = ACTIONS(4486),
    [sym_const] = ACTIONS(4486),
    [sym_debug] = ACTIONS(4486),
    [sym_deprecated] = ACTIONS(4486),
    [sym_else] = ACTIONS(4486),
    [sym_enum] = ACTIONS(4486),
    [sym_export] = ACTIONS(4486),
    [sym_extern] = ACTIONS(4486),
    [sym_final] = ACTIONS(4486),
    [sym_immutable] = ACTIONS(4486),
    [sym_import] = ACTIONS(4486),
    [sym_inout] = ACTIONS(4486),
    [sym_interface] = ACTIONS(4486),
    [sym_invariant] = ACTIONS(4486),
    [sym_mixin] = ACTIONS(4486),
    [sym_nothrow] = ACTIONS(4486),
    [sym_override] = ACTIONS(4486),
    [sym_package] = ACTIONS(4486),
    [sym_pragma] = ACTIONS(4486),
    [sym_private] = ACTIONS(4486),
    [sym_protected] = ACTIONS(4486),
    [sym_public] = ACTIONS(4486),
    [sym_pure] = ACTIONS(4486),
    [sym_ref] = ACTIONS(4486),
    [sym_return] = ACTIONS(4486),
    [sym_scope] = ACTIONS(4486),
    [sym_shared] = ACTIONS(4486),
    [sym_static] = ACTIONS(4486),
    [sym_struct] = ACTIONS(4486),
    [sym_synchronized] = ACTIONS(4486),
    [sym_template] = ACTIONS(4486),
    [sym_typeof] = ACTIONS(4486),
    [sym_union] = ACTIONS(4486),
    [sym_unittest] = ACTIONS(4486),
    [sym_version] = ACTIONS(4486),
    [sym_while] = ACTIONS(4486),
    [sym_gshared] = ACTIONS(4486),
    [sym_traits] = ACTIONS(4486),
    [sym_vector] = ACTIONS(4486),
    [sym_void] = ACTIONS(4486),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2281] = {
    [ts_builtin_sym_end] = ACTIONS(4943),
    [sym_identifier] = ACTIONS(4941),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_DOT] = ACTIONS(4943),
    [anon_sym_SEMI] = ACTIONS(4943),
    [anon_sym_TILDE] = ACTIONS(4943),
    [anon_sym_AT] = ACTIONS(4943),
    [sym_bool] = ACTIONS(4941),
    [sym_byte] = ACTIONS(4941),
    [sym_ubyte] = ACTIONS(4941),
    [sym_char] = ACTIONS(4941),
    [sym_short] = ACTIONS(4941),
    [sym_ushort] = ACTIONS(4941),
    [sym_int] = ACTIONS(4941),
    [sym_uint] = ACTIONS(4941),
    [sym_long] = ACTIONS(4941),
    [sym_ulong] = ACTIONS(4941),
    [sym_cent] = ACTIONS(4941),
    [sym_ucent] = ACTIONS(4941),
    [sym_wchar] = ACTIONS(4941),
    [sym_dchar] = ACTIONS(4941),
    [sym_float] = ACTIONS(4941),
    [sym_double] = ACTIONS(4941),
    [sym_real] = ACTIONS(4941),
    [sym_ifloat] = ACTIONS(4941),
    [sym_idouble] = ACTIONS(4941),
    [sym_ireal] = ACTIONS(4941),
    [sym_cfloat] = ACTIONS(4941),
    [sym_cdouble] = ACTIONS(4941),
    [sym_creal] = ACTIONS(4941),
    [sym_size_t] = ACTIONS(4941),
    [sym_ptrdiff_t] = ACTIONS(4941),
    [sym_string] = ACTIONS(4941),
    [sym_cstring] = ACTIONS(4941),
    [sym_dstring] = ACTIONS(4941),
    [sym_wstring] = ACTIONS(4941),
    [sym_noreturn] = ACTIONS(4941),
    [sym_this] = ACTIONS(4941),
    [sym_abstract] = ACTIONS(4941),
    [sym_alias] = ACTIONS(4941),
    [sym_align] = ACTIONS(4941),
    [sym_auto] = ACTIONS(4941),
    [sym_class] = ACTIONS(4941),
    [sym_const] = ACTIONS(4941),
    [sym_debug] = ACTIONS(4941),
    [sym_deprecated] = ACTIONS(4941),
    [sym_else] = ACTIONS(4941),
    [sym_enum] = ACTIONS(4941),
    [sym_export] = ACTIONS(4941),
    [sym_extern] = ACTIONS(4941),
    [sym_final] = ACTIONS(4941),
    [sym_immutable] = ACTIONS(4941),
    [sym_import] = ACTIONS(4941),
    [sym_inout] = ACTIONS(4941),
    [sym_interface] = ACTIONS(4941),
    [sym_invariant] = ACTIONS(4941),
    [sym_mixin] = ACTIONS(4941),
    [sym_nothrow] = ACTIONS(4941),
    [sym_override] = ACTIONS(4941),
    [sym_package] = ACTIONS(4941),
    [sym_pragma] = ACTIONS(4941),
    [sym_private] = ACTIONS(4941),
    [sym_protected] = ACTIONS(4941),
    [sym_public] = ACTIONS(4941),
    [sym_pure] = ACTIONS(4941),
    [sym_ref] = ACTIONS(4941),
    [sym_return] = ACTIONS(4941),
    [sym_scope] = ACTIONS(4941),
    [sym_shared] = ACTIONS(4941),
    [sym_static] = ACTIONS(4941),
    [sym_struct] = ACTIONS(4941),
    [sym_synchronized] = ACTIONS(4941),
    [sym_template] = ACTIONS(4941),
    [sym_typeof] = ACTIONS(4941),
    [sym_union] = ACTIONS(4941),
    [sym_unittest] = ACTIONS(4941),
    [sym_version] = ACTIONS(4941),
    [sym_while] = ACTIONS(4941),
    [sym_gshared] = ACTIONS(4941),
    [sym_traits] = ACTIONS(4941),
    [sym_vector] = ACTIONS(4941),
    [sym_void] = ACTIONS(4941),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2282] = {
    [ts_builtin_sym_end] = ACTIONS(4360),
    [sym_identifier] = ACTIONS(4358),
    [anon_sym_RBRACE] = ACTIONS(4360),
    [anon_sym_DOT] = ACTIONS(4360),
    [anon_sym_SEMI] = ACTIONS(4360),
    [anon_sym_TILDE] = ACTIONS(4360),
    [anon_sym_AT] = ACTIONS(4360),
    [sym_bool] = ACTIONS(4358),
    [sym_byte] = ACTIONS(4358),
    [sym_ubyte] = ACTIONS(4358),
    [sym_char] = ACTIONS(4358),
    [sym_short] = ACTIONS(4358),
    [sym_ushort] = ACTIONS(4358),
    [sym_int] = ACTIONS(4358),
    [sym_uint] = ACTIONS(4358),
    [sym_long] = ACTIONS(4358),
    [sym_ulong] = ACTIONS(4358),
    [sym_cent] = ACTIONS(4358),
    [sym_ucent] = ACTIONS(4358),
    [sym_wchar] = ACTIONS(4358),
    [sym_dchar] = ACTIONS(4358),
    [sym_float] = ACTIONS(4358),
    [sym_double] = ACTIONS(4358),
    [sym_real] = ACTIONS(4358),
    [sym_ifloat] = ACTIONS(4358),
    [sym_idouble] = ACTIONS(4358),
    [sym_ireal] = ACTIONS(4358),
    [sym_cfloat] = ACTIONS(4358),
    [sym_cdouble] = ACTIONS(4358),
    [sym_creal] = ACTIONS(4358),
    [sym_size_t] = ACTIONS(4358),
    [sym_ptrdiff_t] = ACTIONS(4358),
    [sym_string] = ACTIONS(4358),
    [sym_cstring] = ACTIONS(4358),
    [sym_dstring] = ACTIONS(4358),
    [sym_wstring] = ACTIONS(4358),
    [sym_noreturn] = ACTIONS(4358),
    [sym_this] = ACTIONS(4358),
    [sym_abstract] = ACTIONS(4358),
    [sym_alias] = ACTIONS(4358),
    [sym_align] = ACTIONS(4358),
    [sym_auto] = ACTIONS(4358),
    [sym_class] = ACTIONS(4358),
    [sym_const] = ACTIONS(4358),
    [sym_debug] = ACTIONS(4358),
    [sym_deprecated] = ACTIONS(4358),
    [sym_else] = ACTIONS(4358),
    [sym_enum] = ACTIONS(4358),
    [sym_export] = ACTIONS(4358),
    [sym_extern] = ACTIONS(4358),
    [sym_final] = ACTIONS(4358),
    [sym_immutable] = ACTIONS(4358),
    [sym_import] = ACTIONS(4358),
    [sym_inout] = ACTIONS(4358),
    [sym_interface] = ACTIONS(4358),
    [sym_invariant] = ACTIONS(4358),
    [sym_mixin] = ACTIONS(4358),
    [sym_nothrow] = ACTIONS(4358),
    [sym_override] = ACTIONS(4358),
    [sym_package] = ACTIONS(4358),
    [sym_pragma] = ACTIONS(4358),
    [sym_private] = ACTIONS(4358),
    [sym_protected] = ACTIONS(4358),
    [sym_public] = ACTIONS(4358),
    [sym_pure] = ACTIONS(4358),
    [sym_ref] = ACTIONS(4358),
    [sym_return] = ACTIONS(4358),
    [sym_scope] = ACTIONS(4358),
    [sym_shared] = ACTIONS(4358),
    [sym_static] = ACTIONS(4358),
    [sym_struct] = ACTIONS(4358),
    [sym_synchronized] = ACTIONS(4358),
    [sym_template] = ACTIONS(4358),
    [sym_typeof] = ACTIONS(4358),
    [sym_union] = ACTIONS(4358),
    [sym_unittest] = ACTIONS(4358),
    [sym_version] = ACTIONS(4358),
    [sym_while] = ACTIONS(4358),
    [sym_gshared] = ACTIONS(4358),
    [sym_traits] = ACTIONS(4358),
    [sym_vector] = ACTIONS(4358),
    [sym_void] = ACTIONS(4358),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2283] = {
    [ts_builtin_sym_end] = ACTIONS(4476),
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_RBRACE] = ACTIONS(4476),
    [anon_sym_DOT] = ACTIONS(4476),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4476),
    [anon_sym_AT] = ACTIONS(4476),
    [sym_bool] = ACTIONS(4474),
    [sym_byte] = ACTIONS(4474),
    [sym_ubyte] = ACTIONS(4474),
    [sym_char] = ACTIONS(4474),
    [sym_short] = ACTIONS(4474),
    [sym_ushort] = ACTIONS(4474),
    [sym_int] = ACTIONS(4474),
    [sym_uint] = ACTIONS(4474),
    [sym_long] = ACTIONS(4474),
    [sym_ulong] = ACTIONS(4474),
    [sym_cent] = ACTIONS(4474),
    [sym_ucent] = ACTIONS(4474),
    [sym_wchar] = ACTIONS(4474),
    [sym_dchar] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_double] = ACTIONS(4474),
    [sym_real] = ACTIONS(4474),
    [sym_ifloat] = ACTIONS(4474),
    [sym_idouble] = ACTIONS(4474),
    [sym_ireal] = ACTIONS(4474),
    [sym_cfloat] = ACTIONS(4474),
    [sym_cdouble] = ACTIONS(4474),
    [sym_creal] = ACTIONS(4474),
    [sym_size_t] = ACTIONS(4474),
    [sym_ptrdiff_t] = ACTIONS(4474),
    [sym_string] = ACTIONS(4474),
    [sym_cstring] = ACTIONS(4474),
    [sym_dstring] = ACTIONS(4474),
    [sym_wstring] = ACTIONS(4474),
    [sym_noreturn] = ACTIONS(4474),
    [sym_this] = ACTIONS(4474),
    [sym_abstract] = ACTIONS(4474),
    [sym_alias] = ACTIONS(4474),
    [sym_align] = ACTIONS(4474),
    [sym_auto] = ACTIONS(4474),
    [sym_class] = ACTIONS(4474),
    [sym_const] = ACTIONS(4474),
    [sym_debug] = ACTIONS(4474),
    [sym_deprecated] = ACTIONS(4474),
    [sym_else] = ACTIONS(4474),
    [sym_enum] = ACTIONS(4474),
    [sym_export] = ACTIONS(4474),
    [sym_extern] = ACTIONS(4474),
    [sym_final] = ACTIONS(4474),
    [sym_immutable] = ACTIONS(4474),
    [sym_import] = ACTIONS(4474),
    [sym_inout] = ACTIONS(4474),
    [sym_interface] = ACTIONS(4474),
    [sym_invariant] = ACTIONS(4474),
    [sym_mixin] = ACTIONS(4474),
    [sym_nothrow] = ACTIONS(4474),
    [sym_override] = ACTIONS(4474),
    [sym_package] = ACTIONS(4474),
    [sym_pragma] = ACTIONS(4474),
    [sym_private] = ACTIONS(4474),
    [sym_protected] = ACTIONS(4474),
    [sym_public] = ACTIONS(4474),
    [sym_pure] = ACTIONS(4474),
    [sym_ref] = ACTIONS(4474),
    [sym_return] = ACTIONS(4474),
    [sym_scope] = ACTIONS(4474),
    [sym_shared] = ACTIONS(4474),
    [sym_static] = ACTIONS(4474),
    [sym_struct] = ACTIONS(4474),
    [sym_synchronized] = ACTIONS(4474),
    [sym_template] = ACTIONS(4474),
    [sym_typeof] = ACTIONS(4474),
    [sym_union] = ACTIONS(4474),
    [sym_unittest] = ACTIONS(4474),
    [sym_version] = ACTIONS(4474),
    [sym_while] = ACTIONS(4474),
    [sym_gshared] = ACTIONS(4474),
    [sym_traits] = ACTIONS(4474),
    [sym_vector] = ACTIONS(4474),
    [sym_void] = ACTIONS(4474),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2284] = {
    [ts_builtin_sym_end] = ACTIONS(4472),
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_RBRACE] = ACTIONS(4472),
    [anon_sym_DOT] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [anon_sym_AT] = ACTIONS(4472),
    [sym_bool] = ACTIONS(4470),
    [sym_byte] = ACTIONS(4470),
    [sym_ubyte] = ACTIONS(4470),
    [sym_char] = ACTIONS(4470),
    [sym_short] = ACTIONS(4470),
    [sym_ushort] = ACTIONS(4470),
    [sym_int] = ACTIONS(4470),
    [sym_uint] = ACTIONS(4470),
    [sym_long] = ACTIONS(4470),
    [sym_ulong] = ACTIONS(4470),
    [sym_cent] = ACTIONS(4470),
    [sym_ucent] = ACTIONS(4470),
    [sym_wchar] = ACTIONS(4470),
    [sym_dchar] = ACTIONS(4470),
    [sym_float] = ACTIONS(4470),
    [sym_double] = ACTIONS(4470),
    [sym_real] = ACTIONS(4470),
    [sym_ifloat] = ACTIONS(4470),
    [sym_idouble] = ACTIONS(4470),
    [sym_ireal] = ACTIONS(4470),
    [sym_cfloat] = ACTIONS(4470),
    [sym_cdouble] = ACTIONS(4470),
    [sym_creal] = ACTIONS(4470),
    [sym_size_t] = ACTIONS(4470),
    [sym_ptrdiff_t] = ACTIONS(4470),
    [sym_string] = ACTIONS(4470),
    [sym_cstring] = ACTIONS(4470),
    [sym_dstring] = ACTIONS(4470),
    [sym_wstring] = ACTIONS(4470),
    [sym_noreturn] = ACTIONS(4470),
    [sym_this] = ACTIONS(4470),
    [sym_abstract] = ACTIONS(4470),
    [sym_alias] = ACTIONS(4470),
    [sym_align] = ACTIONS(4470),
    [sym_auto] = ACTIONS(4470),
    [sym_class] = ACTIONS(4470),
    [sym_const] = ACTIONS(4470),
    [sym_debug] = ACTIONS(4470),
    [sym_deprecated] = ACTIONS(4470),
    [sym_else] = ACTIONS(4470),
    [sym_enum] = ACTIONS(4470),
    [sym_export] = ACTIONS(4470),
    [sym_extern] = ACTIONS(4470),
    [sym_final] = ACTIONS(4470),
    [sym_immutable] = ACTIONS(4470),
    [sym_import] = ACTIONS(4470),
    [sym_inout] = ACTIONS(4470),
    [sym_interface] = ACTIONS(4470),
    [sym_invariant] = ACTIONS(4470),
    [sym_mixin] = ACTIONS(4470),
    [sym_nothrow] = ACTIONS(4470),
    [sym_override] = ACTIONS(4470),
    [sym_package] = ACTIONS(4470),
    [sym_pragma] = ACTIONS(4470),
    [sym_private] = ACTIONS(4470),
    [sym_protected] = ACTIONS(4470),
    [sym_public] = ACTIONS(4470),
    [sym_pure] = ACTIONS(4470),
    [sym_ref] = ACTIONS(4470),
    [sym_return] = ACTIONS(4470),
    [sym_scope] = ACTIONS(4470),
    [sym_shared] = ACTIONS(4470),
    [sym_static] = ACTIONS(4470),
    [sym_struct] = ACTIONS(4470),
    [sym_synchronized] = ACTIONS(4470),
    [sym_template] = ACTIONS(4470),
    [sym_typeof] = ACTIONS(4470),
    [sym_union] = ACTIONS(4470),
    [sym_unittest] = ACTIONS(4470),
    [sym_version] = ACTIONS(4470),
    [sym_while] = ACTIONS(4470),
    [sym_gshared] = ACTIONS(4470),
    [sym_traits] = ACTIONS(4470),
    [sym_vector] = ACTIONS(4470),
    [sym_void] = ACTIONS(4470),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2285] = {
    [ts_builtin_sym_end] = ACTIONS(4560),
    [sym_identifier] = ACTIONS(4558),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_DOT] = ACTIONS(4560),
    [anon_sym_SEMI] = ACTIONS(4560),
    [anon_sym_TILDE] = ACTIONS(4560),
    [anon_sym_AT] = ACTIONS(4560),
    [sym_bool] = ACTIONS(4558),
    [sym_byte] = ACTIONS(4558),
    [sym_ubyte] = ACTIONS(4558),
    [sym_char] = ACTIONS(4558),
    [sym_short] = ACTIONS(4558),
    [sym_ushort] = ACTIONS(4558),
    [sym_int] = ACTIONS(4558),
    [sym_uint] = ACTIONS(4558),
    [sym_long] = ACTIONS(4558),
    [sym_ulong] = ACTIONS(4558),
    [sym_cent] = ACTIONS(4558),
    [sym_ucent] = ACTIONS(4558),
    [sym_wchar] = ACTIONS(4558),
    [sym_dchar] = ACTIONS(4558),
    [sym_float] = ACTIONS(4558),
    [sym_double] = ACTIONS(4558),
    [sym_real] = ACTIONS(4558),
    [sym_ifloat] = ACTIONS(4558),
    [sym_idouble] = ACTIONS(4558),
    [sym_ireal] = ACTIONS(4558),
    [sym_cfloat] = ACTIONS(4558),
    [sym_cdouble] = ACTIONS(4558),
    [sym_creal] = ACTIONS(4558),
    [sym_size_t] = ACTIONS(4558),
    [sym_ptrdiff_t] = ACTIONS(4558),
    [sym_string] = ACTIONS(4558),
    [sym_cstring] = ACTIONS(4558),
    [sym_dstring] = ACTIONS(4558),
    [sym_wstring] = ACTIONS(4558),
    [sym_noreturn] = ACTIONS(4558),
    [sym_this] = ACTIONS(4558),
    [sym_abstract] = ACTIONS(4558),
    [sym_alias] = ACTIONS(4558),
    [sym_align] = ACTIONS(4558),
    [sym_auto] = ACTIONS(4558),
    [sym_class] = ACTIONS(4558),
    [sym_const] = ACTIONS(4558),
    [sym_debug] = ACTIONS(4558),
    [sym_deprecated] = ACTIONS(4558),
    [sym_else] = ACTIONS(4558),
    [sym_enum] = ACTIONS(4558),
    [sym_export] = ACTIONS(4558),
    [sym_extern] = ACTIONS(4558),
    [sym_final] = ACTIONS(4558),
    [sym_immutable] = ACTIONS(4558),
    [sym_import] = ACTIONS(4558),
    [sym_inout] = ACTIONS(4558),
    [sym_interface] = ACTIONS(4558),
    [sym_invariant] = ACTIONS(4558),
    [sym_mixin] = ACTIONS(4558),
    [sym_nothrow] = ACTIONS(4558),
    [sym_override] = ACTIONS(4558),
    [sym_package] = ACTIONS(4558),
    [sym_pragma] = ACTIONS(4558),
    [sym_private] = ACTIONS(4558),
    [sym_protected] = ACTIONS(4558),
    [sym_public] = ACTIONS(4558),
    [sym_pure] = ACTIONS(4558),
    [sym_ref] = ACTIONS(4558),
    [sym_return] = ACTIONS(4558),
    [sym_scope] = ACTIONS(4558),
    [sym_shared] = ACTIONS(4558),
    [sym_static] = ACTIONS(4558),
    [sym_struct] = ACTIONS(4558),
    [sym_synchronized] = ACTIONS(4558),
    [sym_template] = ACTIONS(4558),
    [sym_typeof] = ACTIONS(4558),
    [sym_union] = ACTIONS(4558),
    [sym_unittest] = ACTIONS(4558),
    [sym_version] = ACTIONS(4558),
    [sym_while] = ACTIONS(4558),
    [sym_gshared] = ACTIONS(4558),
    [sym_traits] = ACTIONS(4558),
    [sym_vector] = ACTIONS(4558),
    [sym_void] = ACTIONS(4558),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2286] = {
    [sym_identifier] = ACTIONS(4789),
    [anon_sym_DOT] = ACTIONS(4791),
    [anon_sym_SEMI] = ACTIONS(4791),
    [anon_sym_TILDE] = ACTIONS(4791),
    [anon_sym_AT] = ACTIONS(4791),
    [sym_bool] = ACTIONS(4789),
    [sym_byte] = ACTIONS(4789),
    [sym_ubyte] = ACTIONS(4789),
    [sym_char] = ACTIONS(4789),
    [sym_short] = ACTIONS(4789),
    [sym_ushort] = ACTIONS(4789),
    [sym_int] = ACTIONS(4789),
    [sym_uint] = ACTIONS(4789),
    [sym_long] = ACTIONS(4789),
    [sym_ulong] = ACTIONS(4789),
    [sym_cent] = ACTIONS(4789),
    [sym_ucent] = ACTIONS(4789),
    [sym_wchar] = ACTIONS(4789),
    [sym_dchar] = ACTIONS(4789),
    [sym_float] = ACTIONS(4789),
    [sym_double] = ACTIONS(4789),
    [sym_real] = ACTIONS(4789),
    [sym_ifloat] = ACTIONS(4789),
    [sym_idouble] = ACTIONS(4789),
    [sym_ireal] = ACTIONS(4789),
    [sym_cfloat] = ACTIONS(4789),
    [sym_cdouble] = ACTIONS(4789),
    [sym_creal] = ACTIONS(4789),
    [sym_size_t] = ACTIONS(4789),
    [sym_ptrdiff_t] = ACTIONS(4789),
    [sym_string] = ACTIONS(4789),
    [sym_cstring] = ACTIONS(4789),
    [sym_dstring] = ACTIONS(4789),
    [sym_wstring] = ACTIONS(4789),
    [sym_noreturn] = ACTIONS(4789),
    [sym_this] = ACTIONS(4789),
    [sym_abstract] = ACTIONS(4789),
    [sym_alias] = ACTIONS(4789),
    [sym_align] = ACTIONS(4789),
    [sym_auto] = ACTIONS(4789),
    [sym_catch] = ACTIONS(4789),
    [sym_class] = ACTIONS(4789),
    [sym_const] = ACTIONS(4789),
    [sym_debug] = ACTIONS(4789),
    [sym_deprecated] = ACTIONS(4789),
    [sym_else] = ACTIONS(4789),
    [sym_enum] = ACTIONS(4789),
    [sym_export] = ACTIONS(4789),
    [sym_extern] = ACTIONS(4789),
    [sym_final] = ACTIONS(4789),
    [sym_finally] = ACTIONS(4789),
    [sym_immutable] = ACTIONS(4789),
    [sym_import] = ACTIONS(4789),
    [sym_inout] = ACTIONS(4789),
    [sym_interface] = ACTIONS(4789),
    [sym_invariant] = ACTIONS(4789),
    [sym_mixin] = ACTIONS(4789),
    [sym_nothrow] = ACTIONS(4789),
    [sym_override] = ACTIONS(4789),
    [sym_package] = ACTIONS(4789),
    [sym_pragma] = ACTIONS(4789),
    [sym_private] = ACTIONS(4789),
    [sym_protected] = ACTIONS(4789),
    [sym_public] = ACTIONS(4789),
    [sym_pure] = ACTIONS(4789),
    [sym_ref] = ACTIONS(4789),
    [sym_return] = ACTIONS(4789),
    [sym_scope] = ACTIONS(4789),
    [sym_shared] = ACTIONS(4789),
    [sym_static] = ACTIONS(4789),
    [sym_struct] = ACTIONS(4789),
    [sym_synchronized] = ACTIONS(4789),
    [sym_template] = ACTIONS(4789),
    [sym_typeof] = ACTIONS(4789),
    [sym_union] = ACTIONS(4789),
    [sym_unittest] = ACTIONS(4789),
    [sym_version] = ACTIONS(4789),
    [sym_while] = ACTIONS(4789),
    [sym_gshared] = ACTIONS(4789),
    [sym_traits] = ACTIONS(4789),
    [sym_vector] = ACTIONS(4789),
    [sym_void] = ACTIONS(4789),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2287] = {
    [ts_builtin_sym_end] = ACTIONS(4709),
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_DOT] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_AT] = ACTIONS(4709),
    [sym_bool] = ACTIONS(4707),
    [sym_byte] = ACTIONS(4707),
    [sym_ubyte] = ACTIONS(4707),
    [sym_char] = ACTIONS(4707),
    [sym_short] = ACTIONS(4707),
    [sym_ushort] = ACTIONS(4707),
    [sym_int] = ACTIONS(4707),
    [sym_uint] = ACTIONS(4707),
    [sym_long] = ACTIONS(4707),
    [sym_ulong] = ACTIONS(4707),
    [sym_cent] = ACTIONS(4707),
    [sym_ucent] = ACTIONS(4707),
    [sym_wchar] = ACTIONS(4707),
    [sym_dchar] = ACTIONS(4707),
    [sym_float] = ACTIONS(4707),
    [sym_double] = ACTIONS(4707),
    [sym_real] = ACTIONS(4707),
    [sym_ifloat] = ACTIONS(4707),
    [sym_idouble] = ACTIONS(4707),
    [sym_ireal] = ACTIONS(4707),
    [sym_cfloat] = ACTIONS(4707),
    [sym_cdouble] = ACTIONS(4707),
    [sym_creal] = ACTIONS(4707),
    [sym_size_t] = ACTIONS(4707),
    [sym_ptrdiff_t] = ACTIONS(4707),
    [sym_string] = ACTIONS(4707),
    [sym_cstring] = ACTIONS(4707),
    [sym_dstring] = ACTIONS(4707),
    [sym_wstring] = ACTIONS(4707),
    [sym_noreturn] = ACTIONS(4707),
    [sym_this] = ACTIONS(4707),
    [sym_abstract] = ACTIONS(4707),
    [sym_alias] = ACTIONS(4707),
    [sym_align] = ACTIONS(4707),
    [sym_auto] = ACTIONS(4707),
    [sym_class] = ACTIONS(4707),
    [sym_const] = ACTIONS(4707),
    [sym_debug] = ACTIONS(4707),
    [sym_deprecated] = ACTIONS(4707),
    [sym_else] = ACTIONS(4707),
    [sym_enum] = ACTIONS(4707),
    [sym_export] = ACTIONS(4707),
    [sym_extern] = ACTIONS(4707),
    [sym_final] = ACTIONS(4707),
    [sym_immutable] = ACTIONS(4707),
    [sym_import] = ACTIONS(4707),
    [sym_inout] = ACTIONS(4707),
    [sym_interface] = ACTIONS(4707),
    [sym_invariant] = ACTIONS(4707),
    [sym_mixin] = ACTIONS(4707),
    [sym_nothrow] = ACTIONS(4707),
    [sym_override] = ACTIONS(4707),
    [sym_package] = ACTIONS(4707),
    [sym_pragma] = ACTIONS(4707),
    [sym_private] = ACTIONS(4707),
    [sym_protected] = ACTIONS(4707),
    [sym_public] = ACTIONS(4707),
    [sym_pure] = ACTIONS(4707),
    [sym_ref] = ACTIONS(4707),
    [sym_return] = ACTIONS(4707),
    [sym_scope] = ACTIONS(4707),
    [sym_shared] = ACTIONS(4707),
    [sym_static] = ACTIONS(4707),
    [sym_struct] = ACTIONS(4707),
    [sym_synchronized] = ACTIONS(4707),
    [sym_template] = ACTIONS(4707),
    [sym_typeof] = ACTIONS(4707),
    [sym_union] = ACTIONS(4707),
    [sym_unittest] = ACTIONS(4707),
    [sym_version] = ACTIONS(4707),
    [sym_while] = ACTIONS(4707),
    [sym_gshared] = ACTIONS(4707),
    [sym_traits] = ACTIONS(4707),
    [sym_vector] = ACTIONS(4707),
    [sym_void] = ACTIONS(4707),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2288] = {
    [ts_builtin_sym_end] = ACTIONS(4811),
    [sym_identifier] = ACTIONS(4809),
    [anon_sym_RBRACE] = ACTIONS(4811),
    [anon_sym_DOT] = ACTIONS(4811),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_TILDE] = ACTIONS(4811),
    [anon_sym_AT] = ACTIONS(4811),
    [sym_bool] = ACTIONS(4809),
    [sym_byte] = ACTIONS(4809),
    [sym_ubyte] = ACTIONS(4809),
    [sym_char] = ACTIONS(4809),
    [sym_short] = ACTIONS(4809),
    [sym_ushort] = ACTIONS(4809),
    [sym_int] = ACTIONS(4809),
    [sym_uint] = ACTIONS(4809),
    [sym_long] = ACTIONS(4809),
    [sym_ulong] = ACTIONS(4809),
    [sym_cent] = ACTIONS(4809),
    [sym_ucent] = ACTIONS(4809),
    [sym_wchar] = ACTIONS(4809),
    [sym_dchar] = ACTIONS(4809),
    [sym_float] = ACTIONS(4809),
    [sym_double] = ACTIONS(4809),
    [sym_real] = ACTIONS(4809),
    [sym_ifloat] = ACTIONS(4809),
    [sym_idouble] = ACTIONS(4809),
    [sym_ireal] = ACTIONS(4809),
    [sym_cfloat] = ACTIONS(4809),
    [sym_cdouble] = ACTIONS(4809),
    [sym_creal] = ACTIONS(4809),
    [sym_size_t] = ACTIONS(4809),
    [sym_ptrdiff_t] = ACTIONS(4809),
    [sym_string] = ACTIONS(4809),
    [sym_cstring] = ACTIONS(4809),
    [sym_dstring] = ACTIONS(4809),
    [sym_wstring] = ACTIONS(4809),
    [sym_noreturn] = ACTIONS(4809),
    [sym_this] = ACTIONS(4809),
    [sym_abstract] = ACTIONS(4809),
    [sym_alias] = ACTIONS(4809),
    [sym_align] = ACTIONS(4809),
    [sym_auto] = ACTIONS(4809),
    [sym_class] = ACTIONS(4809),
    [sym_const] = ACTIONS(4809),
    [sym_debug] = ACTIONS(4809),
    [sym_deprecated] = ACTIONS(4809),
    [sym_else] = ACTIONS(4809),
    [sym_enum] = ACTIONS(4809),
    [sym_export] = ACTIONS(4809),
    [sym_extern] = ACTIONS(4809),
    [sym_final] = ACTIONS(4809),
    [sym_immutable] = ACTIONS(4809),
    [sym_import] = ACTIONS(4809),
    [sym_inout] = ACTIONS(4809),
    [sym_interface] = ACTIONS(4809),
    [sym_invariant] = ACTIONS(4809),
    [sym_mixin] = ACTIONS(4809),
    [sym_nothrow] = ACTIONS(4809),
    [sym_override] = ACTIONS(4809),
    [sym_package] = ACTIONS(4809),
    [sym_pragma] = ACTIONS(4809),
    [sym_private] = ACTIONS(4809),
    [sym_protected] = ACTIONS(4809),
    [sym_public] = ACTIONS(4809),
    [sym_pure] = ACTIONS(4809),
    [sym_ref] = ACTIONS(4809),
    [sym_return] = ACTIONS(4809),
    [sym_scope] = ACTIONS(4809),
    [sym_shared] = ACTIONS(4809),
    [sym_static] = ACTIONS(4809),
    [sym_struct] = ACTIONS(4809),
    [sym_synchronized] = ACTIONS(4809),
    [sym_template] = ACTIONS(4809),
    [sym_typeof] = ACTIONS(4809),
    [sym_union] = ACTIONS(4809),
    [sym_unittest] = ACTIONS(4809),
    [sym_version] = ACTIONS(4809),
    [sym_while] = ACTIONS(4809),
    [sym_gshared] = ACTIONS(4809),
    [sym_traits] = ACTIONS(4809),
    [sym_vector] = ACTIONS(4809),
    [sym_void] = ACTIONS(4809),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2289] = {
    [sym_identifier] = ACTIONS(2525),
    [anon_sym_DOT] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(2523),
    [anon_sym_TILDE] = ACTIONS(2523),
    [anon_sym_AT] = ACTIONS(2523),
    [sym_bool] = ACTIONS(2525),
    [sym_byte] = ACTIONS(2525),
    [sym_ubyte] = ACTIONS(2525),
    [sym_char] = ACTIONS(2525),
    [sym_short] = ACTIONS(2525),
    [sym_ushort] = ACTIONS(2525),
    [sym_int] = ACTIONS(2525),
    [sym_uint] = ACTIONS(2525),
    [sym_long] = ACTIONS(2525),
    [sym_ulong] = ACTIONS(2525),
    [sym_cent] = ACTIONS(2525),
    [sym_ucent] = ACTIONS(2525),
    [sym_wchar] = ACTIONS(2525),
    [sym_dchar] = ACTIONS(2525),
    [sym_float] = ACTIONS(2525),
    [sym_double] = ACTIONS(2525),
    [sym_real] = ACTIONS(2525),
    [sym_ifloat] = ACTIONS(2525),
    [sym_idouble] = ACTIONS(2525),
    [sym_ireal] = ACTIONS(2525),
    [sym_cfloat] = ACTIONS(2525),
    [sym_cdouble] = ACTIONS(2525),
    [sym_creal] = ACTIONS(2525),
    [sym_size_t] = ACTIONS(2525),
    [sym_ptrdiff_t] = ACTIONS(2525),
    [sym_string] = ACTIONS(2525),
    [sym_cstring] = ACTIONS(2525),
    [sym_dstring] = ACTIONS(2525),
    [sym_wstring] = ACTIONS(2525),
    [sym_noreturn] = ACTIONS(2525),
    [sym_this] = ACTIONS(2525),
    [sym_abstract] = ACTIONS(2525),
    [sym_alias] = ACTIONS(2525),
    [sym_align] = ACTIONS(2525),
    [sym_auto] = ACTIONS(2525),
    [sym_catch] = ACTIONS(2525),
    [sym_class] = ACTIONS(2525),
    [sym_const] = ACTIONS(2525),
    [sym_debug] = ACTIONS(2525),
    [sym_deprecated] = ACTIONS(2525),
    [sym_else] = ACTIONS(2525),
    [sym_enum] = ACTIONS(2525),
    [sym_export] = ACTIONS(2525),
    [sym_extern] = ACTIONS(2525),
    [sym_final] = ACTIONS(2525),
    [sym_finally] = ACTIONS(2525),
    [sym_immutable] = ACTIONS(2525),
    [sym_import] = ACTIONS(2525),
    [sym_inout] = ACTIONS(2525),
    [sym_interface] = ACTIONS(2525),
    [sym_invariant] = ACTIONS(2525),
    [sym_mixin] = ACTIONS(2525),
    [sym_nothrow] = ACTIONS(2525),
    [sym_override] = ACTIONS(2525),
    [sym_package] = ACTIONS(2525),
    [sym_pragma] = ACTIONS(2525),
    [sym_private] = ACTIONS(2525),
    [sym_protected] = ACTIONS(2525),
    [sym_public] = ACTIONS(2525),
    [sym_pure] = ACTIONS(2525),
    [sym_ref] = ACTIONS(2525),
    [sym_return] = ACTIONS(2525),
    [sym_scope] = ACTIONS(2525),
    [sym_shared] = ACTIONS(2525),
    [sym_static] = ACTIONS(2525),
    [sym_struct] = ACTIONS(2525),
    [sym_synchronized] = ACTIONS(2525),
    [sym_template] = ACTIONS(2525),
    [sym_typeof] = ACTIONS(2525),
    [sym_union] = ACTIONS(2525),
    [sym_unittest] = ACTIONS(2525),
    [sym_version] = ACTIONS(2525),
    [sym_while] = ACTIONS(2525),
    [sym_gshared] = ACTIONS(2525),
    [sym_traits] = ACTIONS(2525),
    [sym_vector] = ACTIONS(2525),
    [sym_void] = ACTIONS(2525),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2290] = {
    [ts_builtin_sym_end] = ACTIONS(4699),
    [sym_identifier] = ACTIONS(4697),
    [anon_sym_RBRACE] = ACTIONS(4699),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4699),
    [anon_sym_AT] = ACTIONS(4699),
    [sym_bool] = ACTIONS(4697),
    [sym_byte] = ACTIONS(4697),
    [sym_ubyte] = ACTIONS(4697),
    [sym_char] = ACTIONS(4697),
    [sym_short] = ACTIONS(4697),
    [sym_ushort] = ACTIONS(4697),
    [sym_int] = ACTIONS(4697),
    [sym_uint] = ACTIONS(4697),
    [sym_long] = ACTIONS(4697),
    [sym_ulong] = ACTIONS(4697),
    [sym_cent] = ACTIONS(4697),
    [sym_ucent] = ACTIONS(4697),
    [sym_wchar] = ACTIONS(4697),
    [sym_dchar] = ACTIONS(4697),
    [sym_float] = ACTIONS(4697),
    [sym_double] = ACTIONS(4697),
    [sym_real] = ACTIONS(4697),
    [sym_ifloat] = ACTIONS(4697),
    [sym_idouble] = ACTIONS(4697),
    [sym_ireal] = ACTIONS(4697),
    [sym_cfloat] = ACTIONS(4697),
    [sym_cdouble] = ACTIONS(4697),
    [sym_creal] = ACTIONS(4697),
    [sym_size_t] = ACTIONS(4697),
    [sym_ptrdiff_t] = ACTIONS(4697),
    [sym_string] = ACTIONS(4697),
    [sym_cstring] = ACTIONS(4697),
    [sym_dstring] = ACTIONS(4697),
    [sym_wstring] = ACTIONS(4697),
    [sym_noreturn] = ACTIONS(4697),
    [sym_this] = ACTIONS(4697),
    [sym_abstract] = ACTIONS(4697),
    [sym_alias] = ACTIONS(4697),
    [sym_align] = ACTIONS(4697),
    [sym_auto] = ACTIONS(4697),
    [sym_class] = ACTIONS(4697),
    [sym_const] = ACTIONS(4697),
    [sym_debug] = ACTIONS(4697),
    [sym_deprecated] = ACTIONS(4697),
    [sym_else] = ACTIONS(4697),
    [sym_enum] = ACTIONS(4697),
    [sym_export] = ACTIONS(4697),
    [sym_extern] = ACTIONS(4697),
    [sym_final] = ACTIONS(4697),
    [sym_immutable] = ACTIONS(4697),
    [sym_import] = ACTIONS(4697),
    [sym_inout] = ACTIONS(4697),
    [sym_interface] = ACTIONS(4697),
    [sym_invariant] = ACTIONS(4697),
    [sym_mixin] = ACTIONS(4697),
    [sym_nothrow] = ACTIONS(4697),
    [sym_override] = ACTIONS(4697),
    [sym_package] = ACTIONS(4697),
    [sym_pragma] = ACTIONS(4697),
    [sym_private] = ACTIONS(4697),
    [sym_protected] = ACTIONS(4697),
    [sym_public] = ACTIONS(4697),
    [sym_pure] = ACTIONS(4697),
    [sym_ref] = ACTIONS(4697),
    [sym_return] = ACTIONS(4697),
    [sym_scope] = ACTIONS(4697),
    [sym_shared] = ACTIONS(4697),
    [sym_static] = ACTIONS(4697),
    [sym_struct] = ACTIONS(4697),
    [sym_synchronized] = ACTIONS(4697),
    [sym_template] = ACTIONS(4697),
    [sym_typeof] = ACTIONS(4697),
    [sym_union] = ACTIONS(4697),
    [sym_unittest] = ACTIONS(4697),
    [sym_version] = ACTIONS(4697),
    [sym_while] = ACTIONS(4697),
    [sym_gshared] = ACTIONS(4697),
    [sym_traits] = ACTIONS(4697),
    [sym_vector] = ACTIONS(4697),
    [sym_void] = ACTIONS(4697),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2291] = {
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_DOT] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_AT] = ACTIONS(4532),
    [sym_bool] = ACTIONS(4530),
    [sym_byte] = ACTIONS(4530),
    [sym_ubyte] = ACTIONS(4530),
    [sym_char] = ACTIONS(4530),
    [sym_short] = ACTIONS(4530),
    [sym_ushort] = ACTIONS(4530),
    [sym_int] = ACTIONS(4530),
    [sym_uint] = ACTIONS(4530),
    [sym_long] = ACTIONS(4530),
    [sym_ulong] = ACTIONS(4530),
    [sym_cent] = ACTIONS(4530),
    [sym_ucent] = ACTIONS(4530),
    [sym_wchar] = ACTIONS(4530),
    [sym_dchar] = ACTIONS(4530),
    [sym_float] = ACTIONS(4530),
    [sym_double] = ACTIONS(4530),
    [sym_real] = ACTIONS(4530),
    [sym_ifloat] = ACTIONS(4530),
    [sym_idouble] = ACTIONS(4530),
    [sym_ireal] = ACTIONS(4530),
    [sym_cfloat] = ACTIONS(4530),
    [sym_cdouble] = ACTIONS(4530),
    [sym_creal] = ACTIONS(4530),
    [sym_size_t] = ACTIONS(4530),
    [sym_ptrdiff_t] = ACTIONS(4530),
    [sym_string] = ACTIONS(4530),
    [sym_cstring] = ACTIONS(4530),
    [sym_dstring] = ACTIONS(4530),
    [sym_wstring] = ACTIONS(4530),
    [sym_noreturn] = ACTIONS(4530),
    [sym_this] = ACTIONS(4530),
    [sym_abstract] = ACTIONS(4530),
    [sym_alias] = ACTIONS(4530),
    [sym_align] = ACTIONS(4530),
    [sym_auto] = ACTIONS(4530),
    [sym_catch] = ACTIONS(4530),
    [sym_class] = ACTIONS(4530),
    [sym_const] = ACTIONS(4530),
    [sym_debug] = ACTIONS(4530),
    [sym_deprecated] = ACTIONS(4530),
    [sym_else] = ACTIONS(4530),
    [sym_enum] = ACTIONS(4530),
    [sym_export] = ACTIONS(4530),
    [sym_extern] = ACTIONS(4530),
    [sym_final] = ACTIONS(4530),
    [sym_finally] = ACTIONS(4530),
    [sym_immutable] = ACTIONS(4530),
    [sym_import] = ACTIONS(4530),
    [sym_inout] = ACTIONS(4530),
    [sym_interface] = ACTIONS(4530),
    [sym_invariant] = ACTIONS(4530),
    [sym_mixin] = ACTIONS(4530),
    [sym_nothrow] = ACTIONS(4530),
    [sym_override] = ACTIONS(4530),
    [sym_package] = ACTIONS(4530),
    [sym_pragma] = ACTIONS(4530),
    [sym_private] = ACTIONS(4530),
    [sym_protected] = ACTIONS(4530),
    [sym_public] = ACTIONS(4530),
    [sym_pure] = ACTIONS(4530),
    [sym_ref] = ACTIONS(4530),
    [sym_return] = ACTIONS(4530),
    [sym_scope] = ACTIONS(4530),
    [sym_shared] = ACTIONS(4530),
    [sym_static] = ACTIONS(4530),
    [sym_struct] = ACTIONS(4530),
    [sym_synchronized] = ACTIONS(4530),
    [sym_template] = ACTIONS(4530),
    [sym_typeof] = ACTIONS(4530),
    [sym_union] = ACTIONS(4530),
    [sym_unittest] = ACTIONS(4530),
    [sym_version] = ACTIONS(4530),
    [sym_while] = ACTIONS(4530),
    [sym_gshared] = ACTIONS(4530),
    [sym_traits] = ACTIONS(4530),
    [sym_vector] = ACTIONS(4530),
    [sym_void] = ACTIONS(4530),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2292] = {
    [ts_builtin_sym_end] = ACTIONS(4871),
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_RBRACE] = ACTIONS(4871),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4871),
    [anon_sym_AT] = ACTIONS(4871),
    [sym_bool] = ACTIONS(4869),
    [sym_byte] = ACTIONS(4869),
    [sym_ubyte] = ACTIONS(4869),
    [sym_char] = ACTIONS(4869),
    [sym_short] = ACTIONS(4869),
    [sym_ushort] = ACTIONS(4869),
    [sym_int] = ACTIONS(4869),
    [sym_uint] = ACTIONS(4869),
    [sym_long] = ACTIONS(4869),
    [sym_ulong] = ACTIONS(4869),
    [sym_cent] = ACTIONS(4869),
    [sym_ucent] = ACTIONS(4869),
    [sym_wchar] = ACTIONS(4869),
    [sym_dchar] = ACTIONS(4869),
    [sym_float] = ACTIONS(4869),
    [sym_double] = ACTIONS(4869),
    [sym_real] = ACTIONS(4869),
    [sym_ifloat] = ACTIONS(4869),
    [sym_idouble] = ACTIONS(4869),
    [sym_ireal] = ACTIONS(4869),
    [sym_cfloat] = ACTIONS(4869),
    [sym_cdouble] = ACTIONS(4869),
    [sym_creal] = ACTIONS(4869),
    [sym_size_t] = ACTIONS(4869),
    [sym_ptrdiff_t] = ACTIONS(4869),
    [sym_string] = ACTIONS(4869),
    [sym_cstring] = ACTIONS(4869),
    [sym_dstring] = ACTIONS(4869),
    [sym_wstring] = ACTIONS(4869),
    [sym_noreturn] = ACTIONS(4869),
    [sym_this] = ACTIONS(4869),
    [sym_abstract] = ACTIONS(4869),
    [sym_alias] = ACTIONS(4869),
    [sym_align] = ACTIONS(4869),
    [sym_auto] = ACTIONS(4869),
    [sym_class] = ACTIONS(4869),
    [sym_const] = ACTIONS(4869),
    [sym_debug] = ACTIONS(4869),
    [sym_deprecated] = ACTIONS(4869),
    [sym_else] = ACTIONS(4869),
    [sym_enum] = ACTIONS(4869),
    [sym_export] = ACTIONS(4869),
    [sym_extern] = ACTIONS(4869),
    [sym_final] = ACTIONS(4869),
    [sym_immutable] = ACTIONS(4869),
    [sym_import] = ACTIONS(4869),
    [sym_inout] = ACTIONS(4869),
    [sym_interface] = ACTIONS(4869),
    [sym_invariant] = ACTIONS(4869),
    [sym_mixin] = ACTIONS(4869),
    [sym_nothrow] = ACTIONS(4869),
    [sym_override] = ACTIONS(4869),
    [sym_package] = ACTIONS(4869),
    [sym_pragma] = ACTIONS(4869),
    [sym_private] = ACTIONS(4869),
    [sym_protected] = ACTIONS(4869),
    [sym_public] = ACTIONS(4869),
    [sym_pure] = ACTIONS(4869),
    [sym_ref] = ACTIONS(4869),
    [sym_return] = ACTIONS(4869),
    [sym_scope] = ACTIONS(4869),
    [sym_shared] = ACTIONS(4869),
    [sym_static] = ACTIONS(4869),
    [sym_struct] = ACTIONS(4869),
    [sym_synchronized] = ACTIONS(4869),
    [sym_template] = ACTIONS(4869),
    [sym_typeof] = ACTIONS(4869),
    [sym_union] = ACTIONS(4869),
    [sym_unittest] = ACTIONS(4869),
    [sym_version] = ACTIONS(4869),
    [sym_while] = ACTIONS(4869),
    [sym_gshared] = ACTIONS(4869),
    [sym_traits] = ACTIONS(4869),
    [sym_vector] = ACTIONS(4869),
    [sym_void] = ACTIONS(4869),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2293] = {
    [sym_identifier] = ACTIONS(4542),
    [anon_sym_DOT] = ACTIONS(4544),
    [anon_sym_SEMI] = ACTIONS(4544),
    [anon_sym_TILDE] = ACTIONS(4544),
    [anon_sym_AT] = ACTIONS(4544),
    [sym_bool] = ACTIONS(4542),
    [sym_byte] = ACTIONS(4542),
    [sym_ubyte] = ACTIONS(4542),
    [sym_char] = ACTIONS(4542),
    [sym_short] = ACTIONS(4542),
    [sym_ushort] = ACTIONS(4542),
    [sym_int] = ACTIONS(4542),
    [sym_uint] = ACTIONS(4542),
    [sym_long] = ACTIONS(4542),
    [sym_ulong] = ACTIONS(4542),
    [sym_cent] = ACTIONS(4542),
    [sym_ucent] = ACTIONS(4542),
    [sym_wchar] = ACTIONS(4542),
    [sym_dchar] = ACTIONS(4542),
    [sym_float] = ACTIONS(4542),
    [sym_double] = ACTIONS(4542),
    [sym_real] = ACTIONS(4542),
    [sym_ifloat] = ACTIONS(4542),
    [sym_idouble] = ACTIONS(4542),
    [sym_ireal] = ACTIONS(4542),
    [sym_cfloat] = ACTIONS(4542),
    [sym_cdouble] = ACTIONS(4542),
    [sym_creal] = ACTIONS(4542),
    [sym_size_t] = ACTIONS(4542),
    [sym_ptrdiff_t] = ACTIONS(4542),
    [sym_string] = ACTIONS(4542),
    [sym_cstring] = ACTIONS(4542),
    [sym_dstring] = ACTIONS(4542),
    [sym_wstring] = ACTIONS(4542),
    [sym_noreturn] = ACTIONS(4542),
    [sym_this] = ACTIONS(4542),
    [sym_abstract] = ACTIONS(4542),
    [sym_alias] = ACTIONS(4542),
    [sym_align] = ACTIONS(4542),
    [sym_auto] = ACTIONS(4542),
    [sym_catch] = ACTIONS(4542),
    [sym_class] = ACTIONS(4542),
    [sym_const] = ACTIONS(4542),
    [sym_debug] = ACTIONS(4542),
    [sym_deprecated] = ACTIONS(4542),
    [sym_else] = ACTIONS(4542),
    [sym_enum] = ACTIONS(4542),
    [sym_export] = ACTIONS(4542),
    [sym_extern] = ACTIONS(4542),
    [sym_final] = ACTIONS(4542),
    [sym_finally] = ACTIONS(4542),
    [sym_immutable] = ACTIONS(4542),
    [sym_import] = ACTIONS(4542),
    [sym_inout] = ACTIONS(4542),
    [sym_interface] = ACTIONS(4542),
    [sym_invariant] = ACTIONS(4542),
    [sym_mixin] = ACTIONS(4542),
    [sym_nothrow] = ACTIONS(4542),
    [sym_override] = ACTIONS(4542),
    [sym_package] = ACTIONS(4542),
    [sym_pragma] = ACTIONS(4542),
    [sym_private] = ACTIONS(4542),
    [sym_protected] = ACTIONS(4542),
    [sym_public] = ACTIONS(4542),
    [sym_pure] = ACTIONS(4542),
    [sym_ref] = ACTIONS(4542),
    [sym_return] = ACTIONS(4542),
    [sym_scope] = ACTIONS(4542),
    [sym_shared] = ACTIONS(4542),
    [sym_static] = ACTIONS(4542),
    [sym_struct] = ACTIONS(4542),
    [sym_synchronized] = ACTIONS(4542),
    [sym_template] = ACTIONS(4542),
    [sym_typeof] = ACTIONS(4542),
    [sym_union] = ACTIONS(4542),
    [sym_unittest] = ACTIONS(4542),
    [sym_version] = ACTIONS(4542),
    [sym_while] = ACTIONS(4542),
    [sym_gshared] = ACTIONS(4542),
    [sym_traits] = ACTIONS(4542),
    [sym_vector] = ACTIONS(4542),
    [sym_void] = ACTIONS(4542),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2294] = {
    [ts_builtin_sym_end] = ACTIONS(5009),
    [sym_identifier] = ACTIONS(5007),
    [anon_sym_RBRACE] = ACTIONS(5009),
    [anon_sym_DOT] = ACTIONS(5009),
    [anon_sym_SEMI] = ACTIONS(5009),
    [anon_sym_TILDE] = ACTIONS(5009),
    [anon_sym_AT] = ACTIONS(5009),
    [sym_bool] = ACTIONS(5007),
    [sym_byte] = ACTIONS(5007),
    [sym_ubyte] = ACTIONS(5007),
    [sym_char] = ACTIONS(5007),
    [sym_short] = ACTIONS(5007),
    [sym_ushort] = ACTIONS(5007),
    [sym_int] = ACTIONS(5007),
    [sym_uint] = ACTIONS(5007),
    [sym_long] = ACTIONS(5007),
    [sym_ulong] = ACTIONS(5007),
    [sym_cent] = ACTIONS(5007),
    [sym_ucent] = ACTIONS(5007),
    [sym_wchar] = ACTIONS(5007),
    [sym_dchar] = ACTIONS(5007),
    [sym_float] = ACTIONS(5007),
    [sym_double] = ACTIONS(5007),
    [sym_real] = ACTIONS(5007),
    [sym_ifloat] = ACTIONS(5007),
    [sym_idouble] = ACTIONS(5007),
    [sym_ireal] = ACTIONS(5007),
    [sym_cfloat] = ACTIONS(5007),
    [sym_cdouble] = ACTIONS(5007),
    [sym_creal] = ACTIONS(5007),
    [sym_size_t] = ACTIONS(5007),
    [sym_ptrdiff_t] = ACTIONS(5007),
    [sym_string] = ACTIONS(5007),
    [sym_cstring] = ACTIONS(5007),
    [sym_dstring] = ACTIONS(5007),
    [sym_wstring] = ACTIONS(5007),
    [sym_noreturn] = ACTIONS(5007),
    [sym_this] = ACTIONS(5007),
    [sym_abstract] = ACTIONS(5007),
    [sym_alias] = ACTIONS(5007),
    [sym_align] = ACTIONS(5007),
    [sym_auto] = ACTIONS(5007),
    [sym_class] = ACTIONS(5007),
    [sym_const] = ACTIONS(5007),
    [sym_debug] = ACTIONS(5007),
    [sym_deprecated] = ACTIONS(5007),
    [sym_else] = ACTIONS(5007),
    [sym_enum] = ACTIONS(5007),
    [sym_export] = ACTIONS(5007),
    [sym_extern] = ACTIONS(5007),
    [sym_final] = ACTIONS(5007),
    [sym_immutable] = ACTIONS(5007),
    [sym_import] = ACTIONS(5007),
    [sym_inout] = ACTIONS(5007),
    [sym_interface] = ACTIONS(5007),
    [sym_invariant] = ACTIONS(5007),
    [sym_mixin] = ACTIONS(5007),
    [sym_nothrow] = ACTIONS(5007),
    [sym_override] = ACTIONS(5007),
    [sym_package] = ACTIONS(5007),
    [sym_pragma] = ACTIONS(5007),
    [sym_private] = ACTIONS(5007),
    [sym_protected] = ACTIONS(5007),
    [sym_public] = ACTIONS(5007),
    [sym_pure] = ACTIONS(5007),
    [sym_ref] = ACTIONS(5007),
    [sym_return] = ACTIONS(5007),
    [sym_scope] = ACTIONS(5007),
    [sym_shared] = ACTIONS(5007),
    [sym_static] = ACTIONS(5007),
    [sym_struct] = ACTIONS(5007),
    [sym_synchronized] = ACTIONS(5007),
    [sym_template] = ACTIONS(5007),
    [sym_typeof] = ACTIONS(5007),
    [sym_union] = ACTIONS(5007),
    [sym_unittest] = ACTIONS(5007),
    [sym_version] = ACTIONS(5007),
    [sym_while] = ACTIONS(5007),
    [sym_gshared] = ACTIONS(5007),
    [sym_traits] = ACTIONS(5007),
    [sym_vector] = ACTIONS(5007),
    [sym_void] = ACTIONS(5007),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2295] = {
    [sym_identifier] = ACTIONS(4330),
    [anon_sym_DOT] = ACTIONS(4332),
    [anon_sym_SEMI] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4332),
    [anon_sym_AT] = ACTIONS(4332),
    [sym_bool] = ACTIONS(4330),
    [sym_byte] = ACTIONS(4330),
    [sym_ubyte] = ACTIONS(4330),
    [sym_char] = ACTIONS(4330),
    [sym_short] = ACTIONS(4330),
    [sym_ushort] = ACTIONS(4330),
    [sym_int] = ACTIONS(4330),
    [sym_uint] = ACTIONS(4330),
    [sym_long] = ACTIONS(4330),
    [sym_ulong] = ACTIONS(4330),
    [sym_cent] = ACTIONS(4330),
    [sym_ucent] = ACTIONS(4330),
    [sym_wchar] = ACTIONS(4330),
    [sym_dchar] = ACTIONS(4330),
    [sym_float] = ACTIONS(4330),
    [sym_double] = ACTIONS(4330),
    [sym_real] = ACTIONS(4330),
    [sym_ifloat] = ACTIONS(4330),
    [sym_idouble] = ACTIONS(4330),
    [sym_ireal] = ACTIONS(4330),
    [sym_cfloat] = ACTIONS(4330),
    [sym_cdouble] = ACTIONS(4330),
    [sym_creal] = ACTIONS(4330),
    [sym_size_t] = ACTIONS(4330),
    [sym_ptrdiff_t] = ACTIONS(4330),
    [sym_string] = ACTIONS(4330),
    [sym_cstring] = ACTIONS(4330),
    [sym_dstring] = ACTIONS(4330),
    [sym_wstring] = ACTIONS(4330),
    [sym_noreturn] = ACTIONS(4330),
    [sym_this] = ACTIONS(4330),
    [sym_abstract] = ACTIONS(4330),
    [sym_alias] = ACTIONS(4330),
    [sym_align] = ACTIONS(4330),
    [sym_auto] = ACTIONS(4330),
    [sym_catch] = ACTIONS(4330),
    [sym_class] = ACTIONS(4330),
    [sym_const] = ACTIONS(4330),
    [sym_debug] = ACTIONS(4330),
    [sym_deprecated] = ACTIONS(4330),
    [sym_else] = ACTIONS(4330),
    [sym_enum] = ACTIONS(4330),
    [sym_export] = ACTIONS(4330),
    [sym_extern] = ACTIONS(4330),
    [sym_final] = ACTIONS(4330),
    [sym_finally] = ACTIONS(4330),
    [sym_immutable] = ACTIONS(4330),
    [sym_import] = ACTIONS(4330),
    [sym_inout] = ACTIONS(4330),
    [sym_interface] = ACTIONS(4330),
    [sym_invariant] = ACTIONS(4330),
    [sym_mixin] = ACTIONS(4330),
    [sym_nothrow] = ACTIONS(4330),
    [sym_override] = ACTIONS(4330),
    [sym_package] = ACTIONS(4330),
    [sym_pragma] = ACTIONS(4330),
    [sym_private] = ACTIONS(4330),
    [sym_protected] = ACTIONS(4330),
    [sym_public] = ACTIONS(4330),
    [sym_pure] = ACTIONS(4330),
    [sym_ref] = ACTIONS(4330),
    [sym_return] = ACTIONS(4330),
    [sym_scope] = ACTIONS(4330),
    [sym_shared] = ACTIONS(4330),
    [sym_static] = ACTIONS(4330),
    [sym_struct] = ACTIONS(4330),
    [sym_synchronized] = ACTIONS(4330),
    [sym_template] = ACTIONS(4330),
    [sym_typeof] = ACTIONS(4330),
    [sym_union] = ACTIONS(4330),
    [sym_unittest] = ACTIONS(4330),
    [sym_version] = ACTIONS(4330),
    [sym_while] = ACTIONS(4330),
    [sym_gshared] = ACTIONS(4330),
    [sym_traits] = ACTIONS(4330),
    [sym_vector] = ACTIONS(4330),
    [sym_void] = ACTIONS(4330),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2296] = {
    [sym_identifier] = ACTIONS(4334),
    [anon_sym_DOT] = ACTIONS(4336),
    [anon_sym_SEMI] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4336),
    [anon_sym_AT] = ACTIONS(4336),
    [sym_bool] = ACTIONS(4334),
    [sym_byte] = ACTIONS(4334),
    [sym_ubyte] = ACTIONS(4334),
    [sym_char] = ACTIONS(4334),
    [sym_short] = ACTIONS(4334),
    [sym_ushort] = ACTIONS(4334),
    [sym_int] = ACTIONS(4334),
    [sym_uint] = ACTIONS(4334),
    [sym_long] = ACTIONS(4334),
    [sym_ulong] = ACTIONS(4334),
    [sym_cent] = ACTIONS(4334),
    [sym_ucent] = ACTIONS(4334),
    [sym_wchar] = ACTIONS(4334),
    [sym_dchar] = ACTIONS(4334),
    [sym_float] = ACTIONS(4334),
    [sym_double] = ACTIONS(4334),
    [sym_real] = ACTIONS(4334),
    [sym_ifloat] = ACTIONS(4334),
    [sym_idouble] = ACTIONS(4334),
    [sym_ireal] = ACTIONS(4334),
    [sym_cfloat] = ACTIONS(4334),
    [sym_cdouble] = ACTIONS(4334),
    [sym_creal] = ACTIONS(4334),
    [sym_size_t] = ACTIONS(4334),
    [sym_ptrdiff_t] = ACTIONS(4334),
    [sym_string] = ACTIONS(4334),
    [sym_cstring] = ACTIONS(4334),
    [sym_dstring] = ACTIONS(4334),
    [sym_wstring] = ACTIONS(4334),
    [sym_noreturn] = ACTIONS(4334),
    [sym_this] = ACTIONS(4334),
    [sym_abstract] = ACTIONS(4334),
    [sym_alias] = ACTIONS(4334),
    [sym_align] = ACTIONS(4334),
    [sym_auto] = ACTIONS(4334),
    [sym_catch] = ACTIONS(4334),
    [sym_class] = ACTIONS(4334),
    [sym_const] = ACTIONS(4334),
    [sym_debug] = ACTIONS(4334),
    [sym_deprecated] = ACTIONS(4334),
    [sym_else] = ACTIONS(4334),
    [sym_enum] = ACTIONS(4334),
    [sym_export] = ACTIONS(4334),
    [sym_extern] = ACTIONS(4334),
    [sym_final] = ACTIONS(4334),
    [sym_finally] = ACTIONS(4334),
    [sym_immutable] = ACTIONS(4334),
    [sym_import] = ACTIONS(4334),
    [sym_inout] = ACTIONS(4334),
    [sym_interface] = ACTIONS(4334),
    [sym_invariant] = ACTIONS(4334),
    [sym_mixin] = ACTIONS(4334),
    [sym_nothrow] = ACTIONS(4334),
    [sym_override] = ACTIONS(4334),
    [sym_package] = ACTIONS(4334),
    [sym_pragma] = ACTIONS(4334),
    [sym_private] = ACTIONS(4334),
    [sym_protected] = ACTIONS(4334),
    [sym_public] = ACTIONS(4334),
    [sym_pure] = ACTIONS(4334),
    [sym_ref] = ACTIONS(4334),
    [sym_return] = ACTIONS(4334),
    [sym_scope] = ACTIONS(4334),
    [sym_shared] = ACTIONS(4334),
    [sym_static] = ACTIONS(4334),
    [sym_struct] = ACTIONS(4334),
    [sym_synchronized] = ACTIONS(4334),
    [sym_template] = ACTIONS(4334),
    [sym_typeof] = ACTIONS(4334),
    [sym_union] = ACTIONS(4334),
    [sym_unittest] = ACTIONS(4334),
    [sym_version] = ACTIONS(4334),
    [sym_while] = ACTIONS(4334),
    [sym_gshared] = ACTIONS(4334),
    [sym_traits] = ACTIONS(4334),
    [sym_vector] = ACTIONS(4334),
    [sym_void] = ACTIONS(4334),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2297] = {
    [ts_builtin_sym_end] = ACTIONS(5005),
    [sym_identifier] = ACTIONS(5003),
    [anon_sym_RBRACE] = ACTIONS(5005),
    [anon_sym_DOT] = ACTIONS(5005),
    [anon_sym_SEMI] = ACTIONS(5005),
    [anon_sym_TILDE] = ACTIONS(5005),
    [anon_sym_AT] = ACTIONS(5005),
    [sym_bool] = ACTIONS(5003),
    [sym_byte] = ACTIONS(5003),
    [sym_ubyte] = ACTIONS(5003),
    [sym_char] = ACTIONS(5003),
    [sym_short] = ACTIONS(5003),
    [sym_ushort] = ACTIONS(5003),
    [sym_int] = ACTIONS(5003),
    [sym_uint] = ACTIONS(5003),
    [sym_long] = ACTIONS(5003),
    [sym_ulong] = ACTIONS(5003),
    [sym_cent] = ACTIONS(5003),
    [sym_ucent] = ACTIONS(5003),
    [sym_wchar] = ACTIONS(5003),
    [sym_dchar] = ACTIONS(5003),
    [sym_float] = ACTIONS(5003),
    [sym_double] = ACTIONS(5003),
    [sym_real] = ACTIONS(5003),
    [sym_ifloat] = ACTIONS(5003),
    [sym_idouble] = ACTIONS(5003),
    [sym_ireal] = ACTIONS(5003),
    [sym_cfloat] = ACTIONS(5003),
    [sym_cdouble] = ACTIONS(5003),
    [sym_creal] = ACTIONS(5003),
    [sym_size_t] = ACTIONS(5003),
    [sym_ptrdiff_t] = ACTIONS(5003),
    [sym_string] = ACTIONS(5003),
    [sym_cstring] = ACTIONS(5003),
    [sym_dstring] = ACTIONS(5003),
    [sym_wstring] = ACTIONS(5003),
    [sym_noreturn] = ACTIONS(5003),
    [sym_this] = ACTIONS(5003),
    [sym_abstract] = ACTIONS(5003),
    [sym_alias] = ACTIONS(5003),
    [sym_align] = ACTIONS(5003),
    [sym_auto] = ACTIONS(5003),
    [sym_class] = ACTIONS(5003),
    [sym_const] = ACTIONS(5003),
    [sym_debug] = ACTIONS(5003),
    [sym_deprecated] = ACTIONS(5003),
    [sym_else] = ACTIONS(5003),
    [sym_enum] = ACTIONS(5003),
    [sym_export] = ACTIONS(5003),
    [sym_extern] = ACTIONS(5003),
    [sym_final] = ACTIONS(5003),
    [sym_immutable] = ACTIONS(5003),
    [sym_import] = ACTIONS(5003),
    [sym_inout] = ACTIONS(5003),
    [sym_interface] = ACTIONS(5003),
    [sym_invariant] = ACTIONS(5003),
    [sym_mixin] = ACTIONS(5003),
    [sym_nothrow] = ACTIONS(5003),
    [sym_override] = ACTIONS(5003),
    [sym_package] = ACTIONS(5003),
    [sym_pragma] = ACTIONS(5003),
    [sym_private] = ACTIONS(5003),
    [sym_protected] = ACTIONS(5003),
    [sym_public] = ACTIONS(5003),
    [sym_pure] = ACTIONS(5003),
    [sym_ref] = ACTIONS(5003),
    [sym_return] = ACTIONS(5003),
    [sym_scope] = ACTIONS(5003),
    [sym_shared] = ACTIONS(5003),
    [sym_static] = ACTIONS(5003),
    [sym_struct] = ACTIONS(5003),
    [sym_synchronized] = ACTIONS(5003),
    [sym_template] = ACTIONS(5003),
    [sym_typeof] = ACTIONS(5003),
    [sym_union] = ACTIONS(5003),
    [sym_unittest] = ACTIONS(5003),
    [sym_version] = ACTIONS(5003),
    [sym_while] = ACTIONS(5003),
    [sym_gshared] = ACTIONS(5003),
    [sym_traits] = ACTIONS(5003),
    [sym_vector] = ACTIONS(5003),
    [sym_void] = ACTIONS(5003),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2298] = {
    [sym_identifier] = ACTIONS(4338),
    [anon_sym_DOT] = ACTIONS(4340),
    [anon_sym_SEMI] = ACTIONS(4340),
    [anon_sym_TILDE] = ACTIONS(4340),
    [anon_sym_AT] = ACTIONS(4340),
    [sym_bool] = ACTIONS(4338),
    [sym_byte] = ACTIONS(4338),
    [sym_ubyte] = ACTIONS(4338),
    [sym_char] = ACTIONS(4338),
    [sym_short] = ACTIONS(4338),
    [sym_ushort] = ACTIONS(4338),
    [sym_int] = ACTIONS(4338),
    [sym_uint] = ACTIONS(4338),
    [sym_long] = ACTIONS(4338),
    [sym_ulong] = ACTIONS(4338),
    [sym_cent] = ACTIONS(4338),
    [sym_ucent] = ACTIONS(4338),
    [sym_wchar] = ACTIONS(4338),
    [sym_dchar] = ACTIONS(4338),
    [sym_float] = ACTIONS(4338),
    [sym_double] = ACTIONS(4338),
    [sym_real] = ACTIONS(4338),
    [sym_ifloat] = ACTIONS(4338),
    [sym_idouble] = ACTIONS(4338),
    [sym_ireal] = ACTIONS(4338),
    [sym_cfloat] = ACTIONS(4338),
    [sym_cdouble] = ACTIONS(4338),
    [sym_creal] = ACTIONS(4338),
    [sym_size_t] = ACTIONS(4338),
    [sym_ptrdiff_t] = ACTIONS(4338),
    [sym_string] = ACTIONS(4338),
    [sym_cstring] = ACTIONS(4338),
    [sym_dstring] = ACTIONS(4338),
    [sym_wstring] = ACTIONS(4338),
    [sym_noreturn] = ACTIONS(4338),
    [sym_this] = ACTIONS(4338),
    [sym_abstract] = ACTIONS(4338),
    [sym_alias] = ACTIONS(4338),
    [sym_align] = ACTIONS(4338),
    [sym_auto] = ACTIONS(4338),
    [sym_catch] = ACTIONS(4338),
    [sym_class] = ACTIONS(4338),
    [sym_const] = ACTIONS(4338),
    [sym_debug] = ACTIONS(4338),
    [sym_deprecated] = ACTIONS(4338),
    [sym_else] = ACTIONS(4338),
    [sym_enum] = ACTIONS(4338),
    [sym_export] = ACTIONS(4338),
    [sym_extern] = ACTIONS(4338),
    [sym_final] = ACTIONS(4338),
    [sym_finally] = ACTIONS(4338),
    [sym_immutable] = ACTIONS(4338),
    [sym_import] = ACTIONS(4338),
    [sym_inout] = ACTIONS(4338),
    [sym_interface] = ACTIONS(4338),
    [sym_invariant] = ACTIONS(4338),
    [sym_mixin] = ACTIONS(4338),
    [sym_nothrow] = ACTIONS(4338),
    [sym_override] = ACTIONS(4338),
    [sym_package] = ACTIONS(4338),
    [sym_pragma] = ACTIONS(4338),
    [sym_private] = ACTIONS(4338),
    [sym_protected] = ACTIONS(4338),
    [sym_public] = ACTIONS(4338),
    [sym_pure] = ACTIONS(4338),
    [sym_ref] = ACTIONS(4338),
    [sym_return] = ACTIONS(4338),
    [sym_scope] = ACTIONS(4338),
    [sym_shared] = ACTIONS(4338),
    [sym_static] = ACTIONS(4338),
    [sym_struct] = ACTIONS(4338),
    [sym_synchronized] = ACTIONS(4338),
    [sym_template] = ACTIONS(4338),
    [sym_typeof] = ACTIONS(4338),
    [sym_union] = ACTIONS(4338),
    [sym_unittest] = ACTIONS(4338),
    [sym_version] = ACTIONS(4338),
    [sym_while] = ACTIONS(4338),
    [sym_gshared] = ACTIONS(4338),
    [sym_traits] = ACTIONS(4338),
    [sym_vector] = ACTIONS(4338),
    [sym_void] = ACTIONS(4338),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2299] = {
    [sym_identifier] = ACTIONS(4342),
    [anon_sym_DOT] = ACTIONS(4344),
    [anon_sym_SEMI] = ACTIONS(4344),
    [anon_sym_TILDE] = ACTIONS(4344),
    [anon_sym_AT] = ACTIONS(4344),
    [sym_bool] = ACTIONS(4342),
    [sym_byte] = ACTIONS(4342),
    [sym_ubyte] = ACTIONS(4342),
    [sym_char] = ACTIONS(4342),
    [sym_short] = ACTIONS(4342),
    [sym_ushort] = ACTIONS(4342),
    [sym_int] = ACTIONS(4342),
    [sym_uint] = ACTIONS(4342),
    [sym_long] = ACTIONS(4342),
    [sym_ulong] = ACTIONS(4342),
    [sym_cent] = ACTIONS(4342),
    [sym_ucent] = ACTIONS(4342),
    [sym_wchar] = ACTIONS(4342),
    [sym_dchar] = ACTIONS(4342),
    [sym_float] = ACTIONS(4342),
    [sym_double] = ACTIONS(4342),
    [sym_real] = ACTIONS(4342),
    [sym_ifloat] = ACTIONS(4342),
    [sym_idouble] = ACTIONS(4342),
    [sym_ireal] = ACTIONS(4342),
    [sym_cfloat] = ACTIONS(4342),
    [sym_cdouble] = ACTIONS(4342),
    [sym_creal] = ACTIONS(4342),
    [sym_size_t] = ACTIONS(4342),
    [sym_ptrdiff_t] = ACTIONS(4342),
    [sym_string] = ACTIONS(4342),
    [sym_cstring] = ACTIONS(4342),
    [sym_dstring] = ACTIONS(4342),
    [sym_wstring] = ACTIONS(4342),
    [sym_noreturn] = ACTIONS(4342),
    [sym_this] = ACTIONS(4342),
    [sym_abstract] = ACTIONS(4342),
    [sym_alias] = ACTIONS(4342),
    [sym_align] = ACTIONS(4342),
    [sym_auto] = ACTIONS(4342),
    [sym_catch] = ACTIONS(4342),
    [sym_class] = ACTIONS(4342),
    [sym_const] = ACTIONS(4342),
    [sym_debug] = ACTIONS(4342),
    [sym_deprecated] = ACTIONS(4342),
    [sym_else] = ACTIONS(4342),
    [sym_enum] = ACTIONS(4342),
    [sym_export] = ACTIONS(4342),
    [sym_extern] = ACTIONS(4342),
    [sym_final] = ACTIONS(4342),
    [sym_finally] = ACTIONS(4342),
    [sym_immutable] = ACTIONS(4342),
    [sym_import] = ACTIONS(4342),
    [sym_inout] = ACTIONS(4342),
    [sym_interface] = ACTIONS(4342),
    [sym_invariant] = ACTIONS(4342),
    [sym_mixin] = ACTIONS(4342),
    [sym_nothrow] = ACTIONS(4342),
    [sym_override] = ACTIONS(4342),
    [sym_package] = ACTIONS(4342),
    [sym_pragma] = ACTIONS(4342),
    [sym_private] = ACTIONS(4342),
    [sym_protected] = ACTIONS(4342),
    [sym_public] = ACTIONS(4342),
    [sym_pure] = ACTIONS(4342),
    [sym_ref] = ACTIONS(4342),
    [sym_return] = ACTIONS(4342),
    [sym_scope] = ACTIONS(4342),
    [sym_shared] = ACTIONS(4342),
    [sym_static] = ACTIONS(4342),
    [sym_struct] = ACTIONS(4342),
    [sym_synchronized] = ACTIONS(4342),
    [sym_template] = ACTIONS(4342),
    [sym_typeof] = ACTIONS(4342),
    [sym_union] = ACTIONS(4342),
    [sym_unittest] = ACTIONS(4342),
    [sym_version] = ACTIONS(4342),
    [sym_while] = ACTIONS(4342),
    [sym_gshared] = ACTIONS(4342),
    [sym_traits] = ACTIONS(4342),
    [sym_vector] = ACTIONS(4342),
    [sym_void] = ACTIONS(4342),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2300] = {
    [sym_identifier] = ACTIONS(4546),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AT] = ACTIONS(4548),
    [sym_bool] = ACTIONS(4546),
    [sym_byte] = ACTIONS(4546),
    [sym_ubyte] = ACTIONS(4546),
    [sym_char] = ACTIONS(4546),
    [sym_short] = ACTIONS(4546),
    [sym_ushort] = ACTIONS(4546),
    [sym_int] = ACTIONS(4546),
    [sym_uint] = ACTIONS(4546),
    [sym_long] = ACTIONS(4546),
    [sym_ulong] = ACTIONS(4546),
    [sym_cent] = ACTIONS(4546),
    [sym_ucent] = ACTIONS(4546),
    [sym_wchar] = ACTIONS(4546),
    [sym_dchar] = ACTIONS(4546),
    [sym_float] = ACTIONS(4546),
    [sym_double] = ACTIONS(4546),
    [sym_real] = ACTIONS(4546),
    [sym_ifloat] = ACTIONS(4546),
    [sym_idouble] = ACTIONS(4546),
    [sym_ireal] = ACTIONS(4546),
    [sym_cfloat] = ACTIONS(4546),
    [sym_cdouble] = ACTIONS(4546),
    [sym_creal] = ACTIONS(4546),
    [sym_size_t] = ACTIONS(4546),
    [sym_ptrdiff_t] = ACTIONS(4546),
    [sym_string] = ACTIONS(4546),
    [sym_cstring] = ACTIONS(4546),
    [sym_dstring] = ACTIONS(4546),
    [sym_wstring] = ACTIONS(4546),
    [sym_noreturn] = ACTIONS(4546),
    [sym_this] = ACTIONS(4546),
    [sym_abstract] = ACTIONS(4546),
    [sym_alias] = ACTIONS(4546),
    [sym_align] = ACTIONS(4546),
    [sym_auto] = ACTIONS(4546),
    [sym_catch] = ACTIONS(4546),
    [sym_class] = ACTIONS(4546),
    [sym_const] = ACTIONS(4546),
    [sym_debug] = ACTIONS(4546),
    [sym_deprecated] = ACTIONS(4546),
    [sym_else] = ACTIONS(4546),
    [sym_enum] = ACTIONS(4546),
    [sym_export] = ACTIONS(4546),
    [sym_extern] = ACTIONS(4546),
    [sym_final] = ACTIONS(4546),
    [sym_finally] = ACTIONS(4546),
    [sym_immutable] = ACTIONS(4546),
    [sym_import] = ACTIONS(4546),
    [sym_inout] = ACTIONS(4546),
    [sym_interface] = ACTIONS(4546),
    [sym_invariant] = ACTIONS(4546),
    [sym_mixin] = ACTIONS(4546),
    [sym_nothrow] = ACTIONS(4546),
    [sym_override] = ACTIONS(4546),
    [sym_package] = ACTIONS(4546),
    [sym_pragma] = ACTIONS(4546),
    [sym_private] = ACTIONS(4546),
    [sym_protected] = ACTIONS(4546),
    [sym_public] = ACTIONS(4546),
    [sym_pure] = ACTIONS(4546),
    [sym_ref] = ACTIONS(4546),
    [sym_return] = ACTIONS(4546),
    [sym_scope] = ACTIONS(4546),
    [sym_shared] = ACTIONS(4546),
    [sym_static] = ACTIONS(4546),
    [sym_struct] = ACTIONS(4546),
    [sym_synchronized] = ACTIONS(4546),
    [sym_template] = ACTIONS(4546),
    [sym_typeof] = ACTIONS(4546),
    [sym_union] = ACTIONS(4546),
    [sym_unittest] = ACTIONS(4546),
    [sym_version] = ACTIONS(4546),
    [sym_while] = ACTIONS(4546),
    [sym_gshared] = ACTIONS(4546),
    [sym_traits] = ACTIONS(4546),
    [sym_vector] = ACTIONS(4546),
    [sym_void] = ACTIONS(4546),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2301] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(6076),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5044),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2302] = {
    [sym_identifier] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4348),
    [anon_sym_AT] = ACTIONS(4348),
    [sym_bool] = ACTIONS(4346),
    [sym_byte] = ACTIONS(4346),
    [sym_ubyte] = ACTIONS(4346),
    [sym_char] = ACTIONS(4346),
    [sym_short] = ACTIONS(4346),
    [sym_ushort] = ACTIONS(4346),
    [sym_int] = ACTIONS(4346),
    [sym_uint] = ACTIONS(4346),
    [sym_long] = ACTIONS(4346),
    [sym_ulong] = ACTIONS(4346),
    [sym_cent] = ACTIONS(4346),
    [sym_ucent] = ACTIONS(4346),
    [sym_wchar] = ACTIONS(4346),
    [sym_dchar] = ACTIONS(4346),
    [sym_float] = ACTIONS(4346),
    [sym_double] = ACTIONS(4346),
    [sym_real] = ACTIONS(4346),
    [sym_ifloat] = ACTIONS(4346),
    [sym_idouble] = ACTIONS(4346),
    [sym_ireal] = ACTIONS(4346),
    [sym_cfloat] = ACTIONS(4346),
    [sym_cdouble] = ACTIONS(4346),
    [sym_creal] = ACTIONS(4346),
    [sym_size_t] = ACTIONS(4346),
    [sym_ptrdiff_t] = ACTIONS(4346),
    [sym_string] = ACTIONS(4346),
    [sym_cstring] = ACTIONS(4346),
    [sym_dstring] = ACTIONS(4346),
    [sym_wstring] = ACTIONS(4346),
    [sym_noreturn] = ACTIONS(4346),
    [sym_this] = ACTIONS(4346),
    [sym_abstract] = ACTIONS(4346),
    [sym_alias] = ACTIONS(4346),
    [sym_align] = ACTIONS(4346),
    [sym_auto] = ACTIONS(4346),
    [sym_catch] = ACTIONS(4346),
    [sym_class] = ACTIONS(4346),
    [sym_const] = ACTIONS(4346),
    [sym_debug] = ACTIONS(4346),
    [sym_deprecated] = ACTIONS(4346),
    [sym_else] = ACTIONS(4346),
    [sym_enum] = ACTIONS(4346),
    [sym_export] = ACTIONS(4346),
    [sym_extern] = ACTIONS(4346),
    [sym_final] = ACTIONS(4346),
    [sym_finally] = ACTIONS(4346),
    [sym_immutable] = ACTIONS(4346),
    [sym_import] = ACTIONS(4346),
    [sym_inout] = ACTIONS(4346),
    [sym_interface] = ACTIONS(4346),
    [sym_invariant] = ACTIONS(4346),
    [sym_mixin] = ACTIONS(4346),
    [sym_nothrow] = ACTIONS(4346),
    [sym_override] = ACTIONS(4346),
    [sym_package] = ACTIONS(4346),
    [sym_pragma] = ACTIONS(4346),
    [sym_private] = ACTIONS(4346),
    [sym_protected] = ACTIONS(4346),
    [sym_public] = ACTIONS(4346),
    [sym_pure] = ACTIONS(4346),
    [sym_ref] = ACTIONS(4346),
    [sym_return] = ACTIONS(4346),
    [sym_scope] = ACTIONS(4346),
    [sym_shared] = ACTIONS(4346),
    [sym_static] = ACTIONS(4346),
    [sym_struct] = ACTIONS(4346),
    [sym_synchronized] = ACTIONS(4346),
    [sym_template] = ACTIONS(4346),
    [sym_typeof] = ACTIONS(4346),
    [sym_union] = ACTIONS(4346),
    [sym_unittest] = ACTIONS(4346),
    [sym_version] = ACTIONS(4346),
    [sym_while] = ACTIONS(4346),
    [sym_gshared] = ACTIONS(4346),
    [sym_traits] = ACTIONS(4346),
    [sym_vector] = ACTIONS(4346),
    [sym_void] = ACTIONS(4346),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2303] = {
    [sym_identifier] = ACTIONS(4350),
    [anon_sym_DOT] = ACTIONS(4352),
    [anon_sym_SEMI] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4352),
    [anon_sym_AT] = ACTIONS(4352),
    [sym_bool] = ACTIONS(4350),
    [sym_byte] = ACTIONS(4350),
    [sym_ubyte] = ACTIONS(4350),
    [sym_char] = ACTIONS(4350),
    [sym_short] = ACTIONS(4350),
    [sym_ushort] = ACTIONS(4350),
    [sym_int] = ACTIONS(4350),
    [sym_uint] = ACTIONS(4350),
    [sym_long] = ACTIONS(4350),
    [sym_ulong] = ACTIONS(4350),
    [sym_cent] = ACTIONS(4350),
    [sym_ucent] = ACTIONS(4350),
    [sym_wchar] = ACTIONS(4350),
    [sym_dchar] = ACTIONS(4350),
    [sym_float] = ACTIONS(4350),
    [sym_double] = ACTIONS(4350),
    [sym_real] = ACTIONS(4350),
    [sym_ifloat] = ACTIONS(4350),
    [sym_idouble] = ACTIONS(4350),
    [sym_ireal] = ACTIONS(4350),
    [sym_cfloat] = ACTIONS(4350),
    [sym_cdouble] = ACTIONS(4350),
    [sym_creal] = ACTIONS(4350),
    [sym_size_t] = ACTIONS(4350),
    [sym_ptrdiff_t] = ACTIONS(4350),
    [sym_string] = ACTIONS(4350),
    [sym_cstring] = ACTIONS(4350),
    [sym_dstring] = ACTIONS(4350),
    [sym_wstring] = ACTIONS(4350),
    [sym_noreturn] = ACTIONS(4350),
    [sym_this] = ACTIONS(4350),
    [sym_abstract] = ACTIONS(4350),
    [sym_alias] = ACTIONS(4350),
    [sym_align] = ACTIONS(4350),
    [sym_auto] = ACTIONS(4350),
    [sym_catch] = ACTIONS(4350),
    [sym_class] = ACTIONS(4350),
    [sym_const] = ACTIONS(4350),
    [sym_debug] = ACTIONS(4350),
    [sym_deprecated] = ACTIONS(4350),
    [sym_else] = ACTIONS(4350),
    [sym_enum] = ACTIONS(4350),
    [sym_export] = ACTIONS(4350),
    [sym_extern] = ACTIONS(4350),
    [sym_final] = ACTIONS(4350),
    [sym_finally] = ACTIONS(4350),
    [sym_immutable] = ACTIONS(4350),
    [sym_import] = ACTIONS(4350),
    [sym_inout] = ACTIONS(4350),
    [sym_interface] = ACTIONS(4350),
    [sym_invariant] = ACTIONS(4350),
    [sym_mixin] = ACTIONS(4350),
    [sym_nothrow] = ACTIONS(4350),
    [sym_override] = ACTIONS(4350),
    [sym_package] = ACTIONS(4350),
    [sym_pragma] = ACTIONS(4350),
    [sym_private] = ACTIONS(4350),
    [sym_protected] = ACTIONS(4350),
    [sym_public] = ACTIONS(4350),
    [sym_pure] = ACTIONS(4350),
    [sym_ref] = ACTIONS(4350),
    [sym_return] = ACTIONS(4350),
    [sym_scope] = ACTIONS(4350),
    [sym_shared] = ACTIONS(4350),
    [sym_static] = ACTIONS(4350),
    [sym_struct] = ACTIONS(4350),
    [sym_synchronized] = ACTIONS(4350),
    [sym_template] = ACTIONS(4350),
    [sym_typeof] = ACTIONS(4350),
    [sym_union] = ACTIONS(4350),
    [sym_unittest] = ACTIONS(4350),
    [sym_version] = ACTIONS(4350),
    [sym_while] = ACTIONS(4350),
    [sym_gshared] = ACTIONS(4350),
    [sym_traits] = ACTIONS(4350),
    [sym_vector] = ACTIONS(4350),
    [sym_void] = ACTIONS(4350),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2304] = {
    [ts_builtin_sym_end] = ACTIONS(4867),
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_RBRACE] = ACTIONS(4867),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_SEMI] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4867),
    [anon_sym_AT] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4865),
    [sym_byte] = ACTIONS(4865),
    [sym_ubyte] = ACTIONS(4865),
    [sym_char] = ACTIONS(4865),
    [sym_short] = ACTIONS(4865),
    [sym_ushort] = ACTIONS(4865),
    [sym_int] = ACTIONS(4865),
    [sym_uint] = ACTIONS(4865),
    [sym_long] = ACTIONS(4865),
    [sym_ulong] = ACTIONS(4865),
    [sym_cent] = ACTIONS(4865),
    [sym_ucent] = ACTIONS(4865),
    [sym_wchar] = ACTIONS(4865),
    [sym_dchar] = ACTIONS(4865),
    [sym_float] = ACTIONS(4865),
    [sym_double] = ACTIONS(4865),
    [sym_real] = ACTIONS(4865),
    [sym_ifloat] = ACTIONS(4865),
    [sym_idouble] = ACTIONS(4865),
    [sym_ireal] = ACTIONS(4865),
    [sym_cfloat] = ACTIONS(4865),
    [sym_cdouble] = ACTIONS(4865),
    [sym_creal] = ACTIONS(4865),
    [sym_size_t] = ACTIONS(4865),
    [sym_ptrdiff_t] = ACTIONS(4865),
    [sym_string] = ACTIONS(4865),
    [sym_cstring] = ACTIONS(4865),
    [sym_dstring] = ACTIONS(4865),
    [sym_wstring] = ACTIONS(4865),
    [sym_noreturn] = ACTIONS(4865),
    [sym_this] = ACTIONS(4865),
    [sym_abstract] = ACTIONS(4865),
    [sym_alias] = ACTIONS(4865),
    [sym_align] = ACTIONS(4865),
    [sym_auto] = ACTIONS(4865),
    [sym_class] = ACTIONS(4865),
    [sym_const] = ACTIONS(4865),
    [sym_debug] = ACTIONS(4865),
    [sym_deprecated] = ACTIONS(4865),
    [sym_else] = ACTIONS(4865),
    [sym_enum] = ACTIONS(4865),
    [sym_export] = ACTIONS(4865),
    [sym_extern] = ACTIONS(4865),
    [sym_final] = ACTIONS(4865),
    [sym_immutable] = ACTIONS(4865),
    [sym_import] = ACTIONS(4865),
    [sym_inout] = ACTIONS(4865),
    [sym_interface] = ACTIONS(4865),
    [sym_invariant] = ACTIONS(4865),
    [sym_mixin] = ACTIONS(4865),
    [sym_nothrow] = ACTIONS(4865),
    [sym_override] = ACTIONS(4865),
    [sym_package] = ACTIONS(4865),
    [sym_pragma] = ACTIONS(4865),
    [sym_private] = ACTIONS(4865),
    [sym_protected] = ACTIONS(4865),
    [sym_public] = ACTIONS(4865),
    [sym_pure] = ACTIONS(4865),
    [sym_ref] = ACTIONS(4865),
    [sym_return] = ACTIONS(4865),
    [sym_scope] = ACTIONS(4865),
    [sym_shared] = ACTIONS(4865),
    [sym_static] = ACTIONS(4865),
    [sym_struct] = ACTIONS(4865),
    [sym_synchronized] = ACTIONS(4865),
    [sym_template] = ACTIONS(4865),
    [sym_typeof] = ACTIONS(4865),
    [sym_union] = ACTIONS(4865),
    [sym_unittest] = ACTIONS(4865),
    [sym_version] = ACTIONS(4865),
    [sym_while] = ACTIONS(4865),
    [sym_gshared] = ACTIONS(4865),
    [sym_traits] = ACTIONS(4865),
    [sym_vector] = ACTIONS(4865),
    [sym_void] = ACTIONS(4865),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2305] = {
    [ts_builtin_sym_end] = ACTIONS(4815),
    [sym_identifier] = ACTIONS(4813),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_SEMI] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4815),
    [anon_sym_AT] = ACTIONS(4815),
    [sym_bool] = ACTIONS(4813),
    [sym_byte] = ACTIONS(4813),
    [sym_ubyte] = ACTIONS(4813),
    [sym_char] = ACTIONS(4813),
    [sym_short] = ACTIONS(4813),
    [sym_ushort] = ACTIONS(4813),
    [sym_int] = ACTIONS(4813),
    [sym_uint] = ACTIONS(4813),
    [sym_long] = ACTIONS(4813),
    [sym_ulong] = ACTIONS(4813),
    [sym_cent] = ACTIONS(4813),
    [sym_ucent] = ACTIONS(4813),
    [sym_wchar] = ACTIONS(4813),
    [sym_dchar] = ACTIONS(4813),
    [sym_float] = ACTIONS(4813),
    [sym_double] = ACTIONS(4813),
    [sym_real] = ACTIONS(4813),
    [sym_ifloat] = ACTIONS(4813),
    [sym_idouble] = ACTIONS(4813),
    [sym_ireal] = ACTIONS(4813),
    [sym_cfloat] = ACTIONS(4813),
    [sym_cdouble] = ACTIONS(4813),
    [sym_creal] = ACTIONS(4813),
    [sym_size_t] = ACTIONS(4813),
    [sym_ptrdiff_t] = ACTIONS(4813),
    [sym_string] = ACTIONS(4813),
    [sym_cstring] = ACTIONS(4813),
    [sym_dstring] = ACTIONS(4813),
    [sym_wstring] = ACTIONS(4813),
    [sym_noreturn] = ACTIONS(4813),
    [sym_this] = ACTIONS(4813),
    [sym_abstract] = ACTIONS(4813),
    [sym_alias] = ACTIONS(4813),
    [sym_align] = ACTIONS(4813),
    [sym_auto] = ACTIONS(4813),
    [sym_class] = ACTIONS(4813),
    [sym_const] = ACTIONS(4813),
    [sym_debug] = ACTIONS(4813),
    [sym_deprecated] = ACTIONS(4813),
    [sym_else] = ACTIONS(4813),
    [sym_enum] = ACTIONS(4813),
    [sym_export] = ACTIONS(4813),
    [sym_extern] = ACTIONS(4813),
    [sym_final] = ACTIONS(4813),
    [sym_immutable] = ACTIONS(4813),
    [sym_import] = ACTIONS(4813),
    [sym_inout] = ACTIONS(4813),
    [sym_interface] = ACTIONS(4813),
    [sym_invariant] = ACTIONS(4813),
    [sym_mixin] = ACTIONS(4813),
    [sym_nothrow] = ACTIONS(4813),
    [sym_override] = ACTIONS(4813),
    [sym_package] = ACTIONS(4813),
    [sym_pragma] = ACTIONS(4813),
    [sym_private] = ACTIONS(4813),
    [sym_protected] = ACTIONS(4813),
    [sym_public] = ACTIONS(4813),
    [sym_pure] = ACTIONS(4813),
    [sym_ref] = ACTIONS(4813),
    [sym_return] = ACTIONS(4813),
    [sym_scope] = ACTIONS(4813),
    [sym_shared] = ACTIONS(4813),
    [sym_static] = ACTIONS(4813),
    [sym_struct] = ACTIONS(4813),
    [sym_synchronized] = ACTIONS(4813),
    [sym_template] = ACTIONS(4813),
    [sym_typeof] = ACTIONS(4813),
    [sym_union] = ACTIONS(4813),
    [sym_unittest] = ACTIONS(4813),
    [sym_version] = ACTIONS(4813),
    [sym_while] = ACTIONS(4813),
    [sym_gshared] = ACTIONS(4813),
    [sym_traits] = ACTIONS(4813),
    [sym_vector] = ACTIONS(4813),
    [sym_void] = ACTIONS(4813),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2306] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(6076),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5040),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2307] = {
    [ts_builtin_sym_end] = ACTIONS(4636),
    [sym_identifier] = ACTIONS(4634),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_DOT] = ACTIONS(4636),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [anon_sym_AT] = ACTIONS(4636),
    [sym_bool] = ACTIONS(4634),
    [sym_byte] = ACTIONS(4634),
    [sym_ubyte] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_short] = ACTIONS(4634),
    [sym_ushort] = ACTIONS(4634),
    [sym_int] = ACTIONS(4634),
    [sym_uint] = ACTIONS(4634),
    [sym_long] = ACTIONS(4634),
    [sym_ulong] = ACTIONS(4634),
    [sym_cent] = ACTIONS(4634),
    [sym_ucent] = ACTIONS(4634),
    [sym_wchar] = ACTIONS(4634),
    [sym_dchar] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_double] = ACTIONS(4634),
    [sym_real] = ACTIONS(4634),
    [sym_ifloat] = ACTIONS(4634),
    [sym_idouble] = ACTIONS(4634),
    [sym_ireal] = ACTIONS(4634),
    [sym_cfloat] = ACTIONS(4634),
    [sym_cdouble] = ACTIONS(4634),
    [sym_creal] = ACTIONS(4634),
    [sym_size_t] = ACTIONS(4634),
    [sym_ptrdiff_t] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym_cstring] = ACTIONS(4634),
    [sym_dstring] = ACTIONS(4634),
    [sym_wstring] = ACTIONS(4634),
    [sym_noreturn] = ACTIONS(4634),
    [sym_this] = ACTIONS(4634),
    [sym_abstract] = ACTIONS(4634),
    [sym_alias] = ACTIONS(4634),
    [sym_align] = ACTIONS(4634),
    [sym_auto] = ACTIONS(4634),
    [sym_class] = ACTIONS(4634),
    [sym_const] = ACTIONS(4634),
    [sym_debug] = ACTIONS(4634),
    [sym_deprecated] = ACTIONS(4634),
    [sym_else] = ACTIONS(4634),
    [sym_enum] = ACTIONS(4634),
    [sym_export] = ACTIONS(4634),
    [sym_extern] = ACTIONS(4634),
    [sym_final] = ACTIONS(4634),
    [sym_immutable] = ACTIONS(4634),
    [sym_import] = ACTIONS(4634),
    [sym_inout] = ACTIONS(4634),
    [sym_interface] = ACTIONS(4634),
    [sym_invariant] = ACTIONS(4634),
    [sym_mixin] = ACTIONS(4634),
    [sym_nothrow] = ACTIONS(4634),
    [sym_override] = ACTIONS(4634),
    [sym_package] = ACTIONS(4634),
    [sym_pragma] = ACTIONS(4634),
    [sym_private] = ACTIONS(4634),
    [sym_protected] = ACTIONS(4634),
    [sym_public] = ACTIONS(4634),
    [sym_pure] = ACTIONS(4634),
    [sym_ref] = ACTIONS(4634),
    [sym_return] = ACTIONS(4634),
    [sym_scope] = ACTIONS(4634),
    [sym_shared] = ACTIONS(4634),
    [sym_static] = ACTIONS(4634),
    [sym_struct] = ACTIONS(4634),
    [sym_synchronized] = ACTIONS(4634),
    [sym_template] = ACTIONS(4634),
    [sym_typeof] = ACTIONS(4634),
    [sym_union] = ACTIONS(4634),
    [sym_unittest] = ACTIONS(4634),
    [sym_version] = ACTIONS(4634),
    [sym_while] = ACTIONS(4634),
    [sym_gshared] = ACTIONS(4634),
    [sym_traits] = ACTIONS(4634),
    [sym_vector] = ACTIONS(4634),
    [sym_void] = ACTIONS(4634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2308] = {
    [ts_builtin_sym_end] = ACTIONS(4819),
    [sym_identifier] = ACTIONS(4817),
    [anon_sym_RBRACE] = ACTIONS(4819),
    [anon_sym_DOT] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_AT] = ACTIONS(4819),
    [sym_bool] = ACTIONS(4817),
    [sym_byte] = ACTIONS(4817),
    [sym_ubyte] = ACTIONS(4817),
    [sym_char] = ACTIONS(4817),
    [sym_short] = ACTIONS(4817),
    [sym_ushort] = ACTIONS(4817),
    [sym_int] = ACTIONS(4817),
    [sym_uint] = ACTIONS(4817),
    [sym_long] = ACTIONS(4817),
    [sym_ulong] = ACTIONS(4817),
    [sym_cent] = ACTIONS(4817),
    [sym_ucent] = ACTIONS(4817),
    [sym_wchar] = ACTIONS(4817),
    [sym_dchar] = ACTIONS(4817),
    [sym_float] = ACTIONS(4817),
    [sym_double] = ACTIONS(4817),
    [sym_real] = ACTIONS(4817),
    [sym_ifloat] = ACTIONS(4817),
    [sym_idouble] = ACTIONS(4817),
    [sym_ireal] = ACTIONS(4817),
    [sym_cfloat] = ACTIONS(4817),
    [sym_cdouble] = ACTIONS(4817),
    [sym_creal] = ACTIONS(4817),
    [sym_size_t] = ACTIONS(4817),
    [sym_ptrdiff_t] = ACTIONS(4817),
    [sym_string] = ACTIONS(4817),
    [sym_cstring] = ACTIONS(4817),
    [sym_dstring] = ACTIONS(4817),
    [sym_wstring] = ACTIONS(4817),
    [sym_noreturn] = ACTIONS(4817),
    [sym_this] = ACTIONS(4817),
    [sym_abstract] = ACTIONS(4817),
    [sym_alias] = ACTIONS(4817),
    [sym_align] = ACTIONS(4817),
    [sym_auto] = ACTIONS(4817),
    [sym_class] = ACTIONS(4817),
    [sym_const] = ACTIONS(4817),
    [sym_debug] = ACTIONS(4817),
    [sym_deprecated] = ACTIONS(4817),
    [sym_else] = ACTIONS(4817),
    [sym_enum] = ACTIONS(4817),
    [sym_export] = ACTIONS(4817),
    [sym_extern] = ACTIONS(4817),
    [sym_final] = ACTIONS(4817),
    [sym_immutable] = ACTIONS(4817),
    [sym_import] = ACTIONS(4817),
    [sym_inout] = ACTIONS(4817),
    [sym_interface] = ACTIONS(4817),
    [sym_invariant] = ACTIONS(4817),
    [sym_mixin] = ACTIONS(4817),
    [sym_nothrow] = ACTIONS(4817),
    [sym_override] = ACTIONS(4817),
    [sym_package] = ACTIONS(4817),
    [sym_pragma] = ACTIONS(4817),
    [sym_private] = ACTIONS(4817),
    [sym_protected] = ACTIONS(4817),
    [sym_public] = ACTIONS(4817),
    [sym_pure] = ACTIONS(4817),
    [sym_ref] = ACTIONS(4817),
    [sym_return] = ACTIONS(4817),
    [sym_scope] = ACTIONS(4817),
    [sym_shared] = ACTIONS(4817),
    [sym_static] = ACTIONS(4817),
    [sym_struct] = ACTIONS(4817),
    [sym_synchronized] = ACTIONS(4817),
    [sym_template] = ACTIONS(4817),
    [sym_typeof] = ACTIONS(4817),
    [sym_union] = ACTIONS(4817),
    [sym_unittest] = ACTIONS(4817),
    [sym_version] = ACTIONS(4817),
    [sym_while] = ACTIONS(4817),
    [sym_gshared] = ACTIONS(4817),
    [sym_traits] = ACTIONS(4817),
    [sym_vector] = ACTIONS(4817),
    [sym_void] = ACTIONS(4817),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2309] = {
    [ts_builtin_sym_end] = ACTIONS(4823),
    [sym_identifier] = ACTIONS(4821),
    [anon_sym_RBRACE] = ACTIONS(4823),
    [anon_sym_DOT] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(4823),
    [sym_bool] = ACTIONS(4821),
    [sym_byte] = ACTIONS(4821),
    [sym_ubyte] = ACTIONS(4821),
    [sym_char] = ACTIONS(4821),
    [sym_short] = ACTIONS(4821),
    [sym_ushort] = ACTIONS(4821),
    [sym_int] = ACTIONS(4821),
    [sym_uint] = ACTIONS(4821),
    [sym_long] = ACTIONS(4821),
    [sym_ulong] = ACTIONS(4821),
    [sym_cent] = ACTIONS(4821),
    [sym_ucent] = ACTIONS(4821),
    [sym_wchar] = ACTIONS(4821),
    [sym_dchar] = ACTIONS(4821),
    [sym_float] = ACTIONS(4821),
    [sym_double] = ACTIONS(4821),
    [sym_real] = ACTIONS(4821),
    [sym_ifloat] = ACTIONS(4821),
    [sym_idouble] = ACTIONS(4821),
    [sym_ireal] = ACTIONS(4821),
    [sym_cfloat] = ACTIONS(4821),
    [sym_cdouble] = ACTIONS(4821),
    [sym_creal] = ACTIONS(4821),
    [sym_size_t] = ACTIONS(4821),
    [sym_ptrdiff_t] = ACTIONS(4821),
    [sym_string] = ACTIONS(4821),
    [sym_cstring] = ACTIONS(4821),
    [sym_dstring] = ACTIONS(4821),
    [sym_wstring] = ACTIONS(4821),
    [sym_noreturn] = ACTIONS(4821),
    [sym_this] = ACTIONS(4821),
    [sym_abstract] = ACTIONS(4821),
    [sym_alias] = ACTIONS(4821),
    [sym_align] = ACTIONS(4821),
    [sym_auto] = ACTIONS(4821),
    [sym_class] = ACTIONS(4821),
    [sym_const] = ACTIONS(4821),
    [sym_debug] = ACTIONS(4821),
    [sym_deprecated] = ACTIONS(4821),
    [sym_else] = ACTIONS(4821),
    [sym_enum] = ACTIONS(4821),
    [sym_export] = ACTIONS(4821),
    [sym_extern] = ACTIONS(4821),
    [sym_final] = ACTIONS(4821),
    [sym_immutable] = ACTIONS(4821),
    [sym_import] = ACTIONS(4821),
    [sym_inout] = ACTIONS(4821),
    [sym_interface] = ACTIONS(4821),
    [sym_invariant] = ACTIONS(4821),
    [sym_mixin] = ACTIONS(4821),
    [sym_nothrow] = ACTIONS(4821),
    [sym_override] = ACTIONS(4821),
    [sym_package] = ACTIONS(4821),
    [sym_pragma] = ACTIONS(4821),
    [sym_private] = ACTIONS(4821),
    [sym_protected] = ACTIONS(4821),
    [sym_public] = ACTIONS(4821),
    [sym_pure] = ACTIONS(4821),
    [sym_ref] = ACTIONS(4821),
    [sym_return] = ACTIONS(4821),
    [sym_scope] = ACTIONS(4821),
    [sym_shared] = ACTIONS(4821),
    [sym_static] = ACTIONS(4821),
    [sym_struct] = ACTIONS(4821),
    [sym_synchronized] = ACTIONS(4821),
    [sym_template] = ACTIONS(4821),
    [sym_typeof] = ACTIONS(4821),
    [sym_union] = ACTIONS(4821),
    [sym_unittest] = ACTIONS(4821),
    [sym_version] = ACTIONS(4821),
    [sym_while] = ACTIONS(4821),
    [sym_gshared] = ACTIONS(4821),
    [sym_traits] = ACTIONS(4821),
    [sym_vector] = ACTIONS(4821),
    [sym_void] = ACTIONS(4821),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2310] = {
    [ts_builtin_sym_end] = ACTIONS(4600),
    [sym_identifier] = ACTIONS(4598),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_DOT] = ACTIONS(4600),
    [anon_sym_SEMI] = ACTIONS(4600),
    [anon_sym_TILDE] = ACTIONS(4600),
    [anon_sym_AT] = ACTIONS(4600),
    [sym_bool] = ACTIONS(4598),
    [sym_byte] = ACTIONS(4598),
    [sym_ubyte] = ACTIONS(4598),
    [sym_char] = ACTIONS(4598),
    [sym_short] = ACTIONS(4598),
    [sym_ushort] = ACTIONS(4598),
    [sym_int] = ACTIONS(4598),
    [sym_uint] = ACTIONS(4598),
    [sym_long] = ACTIONS(4598),
    [sym_ulong] = ACTIONS(4598),
    [sym_cent] = ACTIONS(4598),
    [sym_ucent] = ACTIONS(4598),
    [sym_wchar] = ACTIONS(4598),
    [sym_dchar] = ACTIONS(4598),
    [sym_float] = ACTIONS(4598),
    [sym_double] = ACTIONS(4598),
    [sym_real] = ACTIONS(4598),
    [sym_ifloat] = ACTIONS(4598),
    [sym_idouble] = ACTIONS(4598),
    [sym_ireal] = ACTIONS(4598),
    [sym_cfloat] = ACTIONS(4598),
    [sym_cdouble] = ACTIONS(4598),
    [sym_creal] = ACTIONS(4598),
    [sym_size_t] = ACTIONS(4598),
    [sym_ptrdiff_t] = ACTIONS(4598),
    [sym_string] = ACTIONS(4598),
    [sym_cstring] = ACTIONS(4598),
    [sym_dstring] = ACTIONS(4598),
    [sym_wstring] = ACTIONS(4598),
    [sym_noreturn] = ACTIONS(4598),
    [sym_this] = ACTIONS(4598),
    [sym_abstract] = ACTIONS(4598),
    [sym_alias] = ACTIONS(4598),
    [sym_align] = ACTIONS(4598),
    [sym_auto] = ACTIONS(4598),
    [sym_class] = ACTIONS(4598),
    [sym_const] = ACTIONS(4598),
    [sym_debug] = ACTIONS(4598),
    [sym_deprecated] = ACTIONS(4598),
    [sym_else] = ACTIONS(4598),
    [sym_enum] = ACTIONS(4598),
    [sym_export] = ACTIONS(4598),
    [sym_extern] = ACTIONS(4598),
    [sym_final] = ACTIONS(4598),
    [sym_immutable] = ACTIONS(4598),
    [sym_import] = ACTIONS(4598),
    [sym_inout] = ACTIONS(4598),
    [sym_interface] = ACTIONS(4598),
    [sym_invariant] = ACTIONS(4598),
    [sym_mixin] = ACTIONS(4598),
    [sym_nothrow] = ACTIONS(4598),
    [sym_override] = ACTIONS(4598),
    [sym_package] = ACTIONS(4598),
    [sym_pragma] = ACTIONS(4598),
    [sym_private] = ACTIONS(4598),
    [sym_protected] = ACTIONS(4598),
    [sym_public] = ACTIONS(4598),
    [sym_pure] = ACTIONS(4598),
    [sym_ref] = ACTIONS(4598),
    [sym_return] = ACTIONS(4598),
    [sym_scope] = ACTIONS(4598),
    [sym_shared] = ACTIONS(4598),
    [sym_static] = ACTIONS(4598),
    [sym_struct] = ACTIONS(4598),
    [sym_synchronized] = ACTIONS(4598),
    [sym_template] = ACTIONS(4598),
    [sym_typeof] = ACTIONS(4598),
    [sym_union] = ACTIONS(4598),
    [sym_unittest] = ACTIONS(4598),
    [sym_version] = ACTIONS(4598),
    [sym_while] = ACTIONS(4598),
    [sym_gshared] = ACTIONS(4598),
    [sym_traits] = ACTIONS(4598),
    [sym_vector] = ACTIONS(4598),
    [sym_void] = ACTIONS(4598),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2311] = {
    [sym_identifier] = ACTIONS(4518),
    [anon_sym_DOT] = ACTIONS(4520),
    [anon_sym_SEMI] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4520),
    [anon_sym_AT] = ACTIONS(4520),
    [sym_bool] = ACTIONS(4518),
    [sym_byte] = ACTIONS(4518),
    [sym_ubyte] = ACTIONS(4518),
    [sym_char] = ACTIONS(4518),
    [sym_short] = ACTIONS(4518),
    [sym_ushort] = ACTIONS(4518),
    [sym_int] = ACTIONS(4518),
    [sym_uint] = ACTIONS(4518),
    [sym_long] = ACTIONS(4518),
    [sym_ulong] = ACTIONS(4518),
    [sym_cent] = ACTIONS(4518),
    [sym_ucent] = ACTIONS(4518),
    [sym_wchar] = ACTIONS(4518),
    [sym_dchar] = ACTIONS(4518),
    [sym_float] = ACTIONS(4518),
    [sym_double] = ACTIONS(4518),
    [sym_real] = ACTIONS(4518),
    [sym_ifloat] = ACTIONS(4518),
    [sym_idouble] = ACTIONS(4518),
    [sym_ireal] = ACTIONS(4518),
    [sym_cfloat] = ACTIONS(4518),
    [sym_cdouble] = ACTIONS(4518),
    [sym_creal] = ACTIONS(4518),
    [sym_size_t] = ACTIONS(4518),
    [sym_ptrdiff_t] = ACTIONS(4518),
    [sym_string] = ACTIONS(4518),
    [sym_cstring] = ACTIONS(4518),
    [sym_dstring] = ACTIONS(4518),
    [sym_wstring] = ACTIONS(4518),
    [sym_noreturn] = ACTIONS(4518),
    [sym_this] = ACTIONS(4518),
    [sym_abstract] = ACTIONS(4518),
    [sym_alias] = ACTIONS(4518),
    [sym_align] = ACTIONS(4518),
    [sym_auto] = ACTIONS(4518),
    [sym_catch] = ACTIONS(4518),
    [sym_class] = ACTIONS(4518),
    [sym_const] = ACTIONS(4518),
    [sym_debug] = ACTIONS(4518),
    [sym_deprecated] = ACTIONS(4518),
    [sym_else] = ACTIONS(4518),
    [sym_enum] = ACTIONS(4518),
    [sym_export] = ACTIONS(4518),
    [sym_extern] = ACTIONS(4518),
    [sym_final] = ACTIONS(4518),
    [sym_finally] = ACTIONS(4518),
    [sym_immutable] = ACTIONS(4518),
    [sym_import] = ACTIONS(4518),
    [sym_inout] = ACTIONS(4518),
    [sym_interface] = ACTIONS(4518),
    [sym_invariant] = ACTIONS(4518),
    [sym_mixin] = ACTIONS(4518),
    [sym_nothrow] = ACTIONS(4518),
    [sym_override] = ACTIONS(4518),
    [sym_package] = ACTIONS(4518),
    [sym_pragma] = ACTIONS(4518),
    [sym_private] = ACTIONS(4518),
    [sym_protected] = ACTIONS(4518),
    [sym_public] = ACTIONS(4518),
    [sym_pure] = ACTIONS(4518),
    [sym_ref] = ACTIONS(4518),
    [sym_return] = ACTIONS(4518),
    [sym_scope] = ACTIONS(4518),
    [sym_shared] = ACTIONS(4518),
    [sym_static] = ACTIONS(4518),
    [sym_struct] = ACTIONS(4518),
    [sym_synchronized] = ACTIONS(4518),
    [sym_template] = ACTIONS(4518),
    [sym_typeof] = ACTIONS(4518),
    [sym_union] = ACTIONS(4518),
    [sym_unittest] = ACTIONS(4518),
    [sym_version] = ACTIONS(4518),
    [sym_while] = ACTIONS(4518),
    [sym_gshared] = ACTIONS(4518),
    [sym_traits] = ACTIONS(4518),
    [sym_vector] = ACTIONS(4518),
    [sym_void] = ACTIONS(4518),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2312] = {
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_DOT] = ACTIONS(4528),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_TILDE] = ACTIONS(4528),
    [anon_sym_AT] = ACTIONS(4528),
    [sym_bool] = ACTIONS(4526),
    [sym_byte] = ACTIONS(4526),
    [sym_ubyte] = ACTIONS(4526),
    [sym_char] = ACTIONS(4526),
    [sym_short] = ACTIONS(4526),
    [sym_ushort] = ACTIONS(4526),
    [sym_int] = ACTIONS(4526),
    [sym_uint] = ACTIONS(4526),
    [sym_long] = ACTIONS(4526),
    [sym_ulong] = ACTIONS(4526),
    [sym_cent] = ACTIONS(4526),
    [sym_ucent] = ACTIONS(4526),
    [sym_wchar] = ACTIONS(4526),
    [sym_dchar] = ACTIONS(4526),
    [sym_float] = ACTIONS(4526),
    [sym_double] = ACTIONS(4526),
    [sym_real] = ACTIONS(4526),
    [sym_ifloat] = ACTIONS(4526),
    [sym_idouble] = ACTIONS(4526),
    [sym_ireal] = ACTIONS(4526),
    [sym_cfloat] = ACTIONS(4526),
    [sym_cdouble] = ACTIONS(4526),
    [sym_creal] = ACTIONS(4526),
    [sym_size_t] = ACTIONS(4526),
    [sym_ptrdiff_t] = ACTIONS(4526),
    [sym_string] = ACTIONS(4526),
    [sym_cstring] = ACTIONS(4526),
    [sym_dstring] = ACTIONS(4526),
    [sym_wstring] = ACTIONS(4526),
    [sym_noreturn] = ACTIONS(4526),
    [sym_this] = ACTIONS(4526),
    [sym_abstract] = ACTIONS(4526),
    [sym_alias] = ACTIONS(4526),
    [sym_align] = ACTIONS(4526),
    [sym_auto] = ACTIONS(4526),
    [sym_catch] = ACTIONS(4526),
    [sym_class] = ACTIONS(4526),
    [sym_const] = ACTIONS(4526),
    [sym_debug] = ACTIONS(4526),
    [sym_deprecated] = ACTIONS(4526),
    [sym_else] = ACTIONS(4526),
    [sym_enum] = ACTIONS(4526),
    [sym_export] = ACTIONS(4526),
    [sym_extern] = ACTIONS(4526),
    [sym_final] = ACTIONS(4526),
    [sym_finally] = ACTIONS(4526),
    [sym_immutable] = ACTIONS(4526),
    [sym_import] = ACTIONS(4526),
    [sym_inout] = ACTIONS(4526),
    [sym_interface] = ACTIONS(4526),
    [sym_invariant] = ACTIONS(4526),
    [sym_mixin] = ACTIONS(4526),
    [sym_nothrow] = ACTIONS(4526),
    [sym_override] = ACTIONS(4526),
    [sym_package] = ACTIONS(4526),
    [sym_pragma] = ACTIONS(4526),
    [sym_private] = ACTIONS(4526),
    [sym_protected] = ACTIONS(4526),
    [sym_public] = ACTIONS(4526),
    [sym_pure] = ACTIONS(4526),
    [sym_ref] = ACTIONS(4526),
    [sym_return] = ACTIONS(4526),
    [sym_scope] = ACTIONS(4526),
    [sym_shared] = ACTIONS(4526),
    [sym_static] = ACTIONS(4526),
    [sym_struct] = ACTIONS(4526),
    [sym_synchronized] = ACTIONS(4526),
    [sym_template] = ACTIONS(4526),
    [sym_typeof] = ACTIONS(4526),
    [sym_union] = ACTIONS(4526),
    [sym_unittest] = ACTIONS(4526),
    [sym_version] = ACTIONS(4526),
    [sym_while] = ACTIONS(4526),
    [sym_gshared] = ACTIONS(4526),
    [sym_traits] = ACTIONS(4526),
    [sym_vector] = ACTIONS(4526),
    [sym_void] = ACTIONS(4526),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2313] = {
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AT] = ACTIONS(4536),
    [sym_bool] = ACTIONS(4534),
    [sym_byte] = ACTIONS(4534),
    [sym_ubyte] = ACTIONS(4534),
    [sym_char] = ACTIONS(4534),
    [sym_short] = ACTIONS(4534),
    [sym_ushort] = ACTIONS(4534),
    [sym_int] = ACTIONS(4534),
    [sym_uint] = ACTIONS(4534),
    [sym_long] = ACTIONS(4534),
    [sym_ulong] = ACTIONS(4534),
    [sym_cent] = ACTIONS(4534),
    [sym_ucent] = ACTIONS(4534),
    [sym_wchar] = ACTIONS(4534),
    [sym_dchar] = ACTIONS(4534),
    [sym_float] = ACTIONS(4534),
    [sym_double] = ACTIONS(4534),
    [sym_real] = ACTIONS(4534),
    [sym_ifloat] = ACTIONS(4534),
    [sym_idouble] = ACTIONS(4534),
    [sym_ireal] = ACTIONS(4534),
    [sym_cfloat] = ACTIONS(4534),
    [sym_cdouble] = ACTIONS(4534),
    [sym_creal] = ACTIONS(4534),
    [sym_size_t] = ACTIONS(4534),
    [sym_ptrdiff_t] = ACTIONS(4534),
    [sym_string] = ACTIONS(4534),
    [sym_cstring] = ACTIONS(4534),
    [sym_dstring] = ACTIONS(4534),
    [sym_wstring] = ACTIONS(4534),
    [sym_noreturn] = ACTIONS(4534),
    [sym_this] = ACTIONS(4534),
    [sym_abstract] = ACTIONS(4534),
    [sym_alias] = ACTIONS(4534),
    [sym_align] = ACTIONS(4534),
    [sym_auto] = ACTIONS(4534),
    [sym_catch] = ACTIONS(4534),
    [sym_class] = ACTIONS(4534),
    [sym_const] = ACTIONS(4534),
    [sym_debug] = ACTIONS(4534),
    [sym_deprecated] = ACTIONS(4534),
    [sym_else] = ACTIONS(4534),
    [sym_enum] = ACTIONS(4534),
    [sym_export] = ACTIONS(4534),
    [sym_extern] = ACTIONS(4534),
    [sym_final] = ACTIONS(4534),
    [sym_finally] = ACTIONS(4534),
    [sym_immutable] = ACTIONS(4534),
    [sym_import] = ACTIONS(4534),
    [sym_inout] = ACTIONS(4534),
    [sym_interface] = ACTIONS(4534),
    [sym_invariant] = ACTIONS(4534),
    [sym_mixin] = ACTIONS(4534),
    [sym_nothrow] = ACTIONS(4534),
    [sym_override] = ACTIONS(4534),
    [sym_package] = ACTIONS(4534),
    [sym_pragma] = ACTIONS(4534),
    [sym_private] = ACTIONS(4534),
    [sym_protected] = ACTIONS(4534),
    [sym_public] = ACTIONS(4534),
    [sym_pure] = ACTIONS(4534),
    [sym_ref] = ACTIONS(4534),
    [sym_return] = ACTIONS(4534),
    [sym_scope] = ACTIONS(4534),
    [sym_shared] = ACTIONS(4534),
    [sym_static] = ACTIONS(4534),
    [sym_struct] = ACTIONS(4534),
    [sym_synchronized] = ACTIONS(4534),
    [sym_template] = ACTIONS(4534),
    [sym_typeof] = ACTIONS(4534),
    [sym_union] = ACTIONS(4534),
    [sym_unittest] = ACTIONS(4534),
    [sym_version] = ACTIONS(4534),
    [sym_while] = ACTIONS(4534),
    [sym_gshared] = ACTIONS(4534),
    [sym_traits] = ACTIONS(4534),
    [sym_vector] = ACTIONS(4534),
    [sym_void] = ACTIONS(4534),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2314] = {
    [sym_identifier] = ACTIONS(4582),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_TILDE] = ACTIONS(4584),
    [anon_sym_AT] = ACTIONS(4584),
    [sym_bool] = ACTIONS(4582),
    [sym_byte] = ACTIONS(4582),
    [sym_ubyte] = ACTIONS(4582),
    [sym_char] = ACTIONS(4582),
    [sym_short] = ACTIONS(4582),
    [sym_ushort] = ACTIONS(4582),
    [sym_int] = ACTIONS(4582),
    [sym_uint] = ACTIONS(4582),
    [sym_long] = ACTIONS(4582),
    [sym_ulong] = ACTIONS(4582),
    [sym_cent] = ACTIONS(4582),
    [sym_ucent] = ACTIONS(4582),
    [sym_wchar] = ACTIONS(4582),
    [sym_dchar] = ACTIONS(4582),
    [sym_float] = ACTIONS(4582),
    [sym_double] = ACTIONS(4582),
    [sym_real] = ACTIONS(4582),
    [sym_ifloat] = ACTIONS(4582),
    [sym_idouble] = ACTIONS(4582),
    [sym_ireal] = ACTIONS(4582),
    [sym_cfloat] = ACTIONS(4582),
    [sym_cdouble] = ACTIONS(4582),
    [sym_creal] = ACTIONS(4582),
    [sym_size_t] = ACTIONS(4582),
    [sym_ptrdiff_t] = ACTIONS(4582),
    [sym_string] = ACTIONS(4582),
    [sym_cstring] = ACTIONS(4582),
    [sym_dstring] = ACTIONS(4582),
    [sym_wstring] = ACTIONS(4582),
    [sym_noreturn] = ACTIONS(4582),
    [sym_this] = ACTIONS(4582),
    [sym_abstract] = ACTIONS(4582),
    [sym_alias] = ACTIONS(4582),
    [sym_align] = ACTIONS(4582),
    [sym_auto] = ACTIONS(4582),
    [sym_catch] = ACTIONS(4582),
    [sym_class] = ACTIONS(4582),
    [sym_const] = ACTIONS(4582),
    [sym_debug] = ACTIONS(4582),
    [sym_deprecated] = ACTIONS(4582),
    [sym_else] = ACTIONS(4582),
    [sym_enum] = ACTIONS(4582),
    [sym_export] = ACTIONS(4582),
    [sym_extern] = ACTIONS(4582),
    [sym_final] = ACTIONS(4582),
    [sym_finally] = ACTIONS(4582),
    [sym_immutable] = ACTIONS(4582),
    [sym_import] = ACTIONS(4582),
    [sym_inout] = ACTIONS(4582),
    [sym_interface] = ACTIONS(4582),
    [sym_invariant] = ACTIONS(4582),
    [sym_mixin] = ACTIONS(4582),
    [sym_nothrow] = ACTIONS(4582),
    [sym_override] = ACTIONS(4582),
    [sym_package] = ACTIONS(4582),
    [sym_pragma] = ACTIONS(4582),
    [sym_private] = ACTIONS(4582),
    [sym_protected] = ACTIONS(4582),
    [sym_public] = ACTIONS(4582),
    [sym_pure] = ACTIONS(4582),
    [sym_ref] = ACTIONS(4582),
    [sym_return] = ACTIONS(4582),
    [sym_scope] = ACTIONS(4582),
    [sym_shared] = ACTIONS(4582),
    [sym_static] = ACTIONS(4582),
    [sym_struct] = ACTIONS(4582),
    [sym_synchronized] = ACTIONS(4582),
    [sym_template] = ACTIONS(4582),
    [sym_typeof] = ACTIONS(4582),
    [sym_union] = ACTIONS(4582),
    [sym_unittest] = ACTIONS(4582),
    [sym_version] = ACTIONS(4582),
    [sym_while] = ACTIONS(4582),
    [sym_gshared] = ACTIONS(4582),
    [sym_traits] = ACTIONS(4582),
    [sym_vector] = ACTIONS(4582),
    [sym_void] = ACTIONS(4582),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2315] = {
    [sym_identifier] = ACTIONS(4586),
    [anon_sym_DOT] = ACTIONS(4588),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_TILDE] = ACTIONS(4588),
    [anon_sym_AT] = ACTIONS(4588),
    [sym_bool] = ACTIONS(4586),
    [sym_byte] = ACTIONS(4586),
    [sym_ubyte] = ACTIONS(4586),
    [sym_char] = ACTIONS(4586),
    [sym_short] = ACTIONS(4586),
    [sym_ushort] = ACTIONS(4586),
    [sym_int] = ACTIONS(4586),
    [sym_uint] = ACTIONS(4586),
    [sym_long] = ACTIONS(4586),
    [sym_ulong] = ACTIONS(4586),
    [sym_cent] = ACTIONS(4586),
    [sym_ucent] = ACTIONS(4586),
    [sym_wchar] = ACTIONS(4586),
    [sym_dchar] = ACTIONS(4586),
    [sym_float] = ACTIONS(4586),
    [sym_double] = ACTIONS(4586),
    [sym_real] = ACTIONS(4586),
    [sym_ifloat] = ACTIONS(4586),
    [sym_idouble] = ACTIONS(4586),
    [sym_ireal] = ACTIONS(4586),
    [sym_cfloat] = ACTIONS(4586),
    [sym_cdouble] = ACTIONS(4586),
    [sym_creal] = ACTIONS(4586),
    [sym_size_t] = ACTIONS(4586),
    [sym_ptrdiff_t] = ACTIONS(4586),
    [sym_string] = ACTIONS(4586),
    [sym_cstring] = ACTIONS(4586),
    [sym_dstring] = ACTIONS(4586),
    [sym_wstring] = ACTIONS(4586),
    [sym_noreturn] = ACTIONS(4586),
    [sym_this] = ACTIONS(4586),
    [sym_abstract] = ACTIONS(4586),
    [sym_alias] = ACTIONS(4586),
    [sym_align] = ACTIONS(4586),
    [sym_auto] = ACTIONS(4586),
    [sym_catch] = ACTIONS(4586),
    [sym_class] = ACTIONS(4586),
    [sym_const] = ACTIONS(4586),
    [sym_debug] = ACTIONS(4586),
    [sym_deprecated] = ACTIONS(4586),
    [sym_else] = ACTIONS(4586),
    [sym_enum] = ACTIONS(4586),
    [sym_export] = ACTIONS(4586),
    [sym_extern] = ACTIONS(4586),
    [sym_final] = ACTIONS(4586),
    [sym_finally] = ACTIONS(4586),
    [sym_immutable] = ACTIONS(4586),
    [sym_import] = ACTIONS(4586),
    [sym_inout] = ACTIONS(4586),
    [sym_interface] = ACTIONS(4586),
    [sym_invariant] = ACTIONS(4586),
    [sym_mixin] = ACTIONS(4586),
    [sym_nothrow] = ACTIONS(4586),
    [sym_override] = ACTIONS(4586),
    [sym_package] = ACTIONS(4586),
    [sym_pragma] = ACTIONS(4586),
    [sym_private] = ACTIONS(4586),
    [sym_protected] = ACTIONS(4586),
    [sym_public] = ACTIONS(4586),
    [sym_pure] = ACTIONS(4586),
    [sym_ref] = ACTIONS(4586),
    [sym_return] = ACTIONS(4586),
    [sym_scope] = ACTIONS(4586),
    [sym_shared] = ACTIONS(4586),
    [sym_static] = ACTIONS(4586),
    [sym_struct] = ACTIONS(4586),
    [sym_synchronized] = ACTIONS(4586),
    [sym_template] = ACTIONS(4586),
    [sym_typeof] = ACTIONS(4586),
    [sym_union] = ACTIONS(4586),
    [sym_unittest] = ACTIONS(4586),
    [sym_version] = ACTIONS(4586),
    [sym_while] = ACTIONS(4586),
    [sym_gshared] = ACTIONS(4586),
    [sym_traits] = ACTIONS(4586),
    [sym_vector] = ACTIONS(4586),
    [sym_void] = ACTIONS(4586),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2316] = {
    [sym_identifier] = ACTIONS(4396),
    [anon_sym_DOT] = ACTIONS(4398),
    [anon_sym_SEMI] = ACTIONS(4398),
    [anon_sym_TILDE] = ACTIONS(4398),
    [anon_sym_AT] = ACTIONS(4398),
    [sym_bool] = ACTIONS(4396),
    [sym_byte] = ACTIONS(4396),
    [sym_ubyte] = ACTIONS(4396),
    [sym_char] = ACTIONS(4396),
    [sym_short] = ACTIONS(4396),
    [sym_ushort] = ACTIONS(4396),
    [sym_int] = ACTIONS(4396),
    [sym_uint] = ACTIONS(4396),
    [sym_long] = ACTIONS(4396),
    [sym_ulong] = ACTIONS(4396),
    [sym_cent] = ACTIONS(4396),
    [sym_ucent] = ACTIONS(4396),
    [sym_wchar] = ACTIONS(4396),
    [sym_dchar] = ACTIONS(4396),
    [sym_float] = ACTIONS(4396),
    [sym_double] = ACTIONS(4396),
    [sym_real] = ACTIONS(4396),
    [sym_ifloat] = ACTIONS(4396),
    [sym_idouble] = ACTIONS(4396),
    [sym_ireal] = ACTIONS(4396),
    [sym_cfloat] = ACTIONS(4396),
    [sym_cdouble] = ACTIONS(4396),
    [sym_creal] = ACTIONS(4396),
    [sym_size_t] = ACTIONS(4396),
    [sym_ptrdiff_t] = ACTIONS(4396),
    [sym_string] = ACTIONS(4396),
    [sym_cstring] = ACTIONS(4396),
    [sym_dstring] = ACTIONS(4396),
    [sym_wstring] = ACTIONS(4396),
    [sym_noreturn] = ACTIONS(4396),
    [sym_this] = ACTIONS(4396),
    [sym_abstract] = ACTIONS(4396),
    [sym_alias] = ACTIONS(4396),
    [sym_align] = ACTIONS(4396),
    [sym_auto] = ACTIONS(4396),
    [sym_catch] = ACTIONS(4396),
    [sym_class] = ACTIONS(4396),
    [sym_const] = ACTIONS(4396),
    [sym_debug] = ACTIONS(4396),
    [sym_deprecated] = ACTIONS(4396),
    [sym_else] = ACTIONS(4396),
    [sym_enum] = ACTIONS(4396),
    [sym_export] = ACTIONS(4396),
    [sym_extern] = ACTIONS(4396),
    [sym_final] = ACTIONS(4396),
    [sym_finally] = ACTIONS(4396),
    [sym_immutable] = ACTIONS(4396),
    [sym_import] = ACTIONS(4396),
    [sym_inout] = ACTIONS(4396),
    [sym_interface] = ACTIONS(4396),
    [sym_invariant] = ACTIONS(4396),
    [sym_mixin] = ACTIONS(4396),
    [sym_nothrow] = ACTIONS(4396),
    [sym_override] = ACTIONS(4396),
    [sym_package] = ACTIONS(4396),
    [sym_pragma] = ACTIONS(4396),
    [sym_private] = ACTIONS(4396),
    [sym_protected] = ACTIONS(4396),
    [sym_public] = ACTIONS(4396),
    [sym_pure] = ACTIONS(4396),
    [sym_ref] = ACTIONS(4396),
    [sym_return] = ACTIONS(4396),
    [sym_scope] = ACTIONS(4396),
    [sym_shared] = ACTIONS(4396),
    [sym_static] = ACTIONS(4396),
    [sym_struct] = ACTIONS(4396),
    [sym_synchronized] = ACTIONS(4396),
    [sym_template] = ACTIONS(4396),
    [sym_typeof] = ACTIONS(4396),
    [sym_union] = ACTIONS(4396),
    [sym_unittest] = ACTIONS(4396),
    [sym_version] = ACTIONS(4396),
    [sym_while] = ACTIONS(4396),
    [sym_gshared] = ACTIONS(4396),
    [sym_traits] = ACTIONS(4396),
    [sym_vector] = ACTIONS(4396),
    [sym_void] = ACTIONS(4396),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2317] = {
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_DOT] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4713),
    [anon_sym_AT] = ACTIONS(4713),
    [sym_bool] = ACTIONS(4711),
    [sym_byte] = ACTIONS(4711),
    [sym_ubyte] = ACTIONS(4711),
    [sym_char] = ACTIONS(4711),
    [sym_short] = ACTIONS(4711),
    [sym_ushort] = ACTIONS(4711),
    [sym_int] = ACTIONS(4711),
    [sym_uint] = ACTIONS(4711),
    [sym_long] = ACTIONS(4711),
    [sym_ulong] = ACTIONS(4711),
    [sym_cent] = ACTIONS(4711),
    [sym_ucent] = ACTIONS(4711),
    [sym_wchar] = ACTIONS(4711),
    [sym_dchar] = ACTIONS(4711),
    [sym_float] = ACTIONS(4711),
    [sym_double] = ACTIONS(4711),
    [sym_real] = ACTIONS(4711),
    [sym_ifloat] = ACTIONS(4711),
    [sym_idouble] = ACTIONS(4711),
    [sym_ireal] = ACTIONS(4711),
    [sym_cfloat] = ACTIONS(4711),
    [sym_cdouble] = ACTIONS(4711),
    [sym_creal] = ACTIONS(4711),
    [sym_size_t] = ACTIONS(4711),
    [sym_ptrdiff_t] = ACTIONS(4711),
    [sym_string] = ACTIONS(4711),
    [sym_cstring] = ACTIONS(4711),
    [sym_dstring] = ACTIONS(4711),
    [sym_wstring] = ACTIONS(4711),
    [sym_noreturn] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [sym_abstract] = ACTIONS(4711),
    [sym_alias] = ACTIONS(4711),
    [sym_align] = ACTIONS(4711),
    [sym_auto] = ACTIONS(4711),
    [sym_catch] = ACTIONS(4711),
    [sym_class] = ACTIONS(4711),
    [sym_const] = ACTIONS(4711),
    [sym_debug] = ACTIONS(4711),
    [sym_deprecated] = ACTIONS(4711),
    [sym_else] = ACTIONS(4711),
    [sym_enum] = ACTIONS(4711),
    [sym_export] = ACTIONS(4711),
    [sym_extern] = ACTIONS(4711),
    [sym_final] = ACTIONS(4711),
    [sym_finally] = ACTIONS(4711),
    [sym_immutable] = ACTIONS(4711),
    [sym_import] = ACTIONS(4711),
    [sym_inout] = ACTIONS(4711),
    [sym_interface] = ACTIONS(4711),
    [sym_invariant] = ACTIONS(4711),
    [sym_mixin] = ACTIONS(4711),
    [sym_nothrow] = ACTIONS(4711),
    [sym_override] = ACTIONS(4711),
    [sym_package] = ACTIONS(4711),
    [sym_pragma] = ACTIONS(4711),
    [sym_private] = ACTIONS(4711),
    [sym_protected] = ACTIONS(4711),
    [sym_public] = ACTIONS(4711),
    [sym_pure] = ACTIONS(4711),
    [sym_ref] = ACTIONS(4711),
    [sym_return] = ACTIONS(4711),
    [sym_scope] = ACTIONS(4711),
    [sym_shared] = ACTIONS(4711),
    [sym_static] = ACTIONS(4711),
    [sym_struct] = ACTIONS(4711),
    [sym_synchronized] = ACTIONS(4711),
    [sym_template] = ACTIONS(4711),
    [sym_typeof] = ACTIONS(4711),
    [sym_union] = ACTIONS(4711),
    [sym_unittest] = ACTIONS(4711),
    [sym_version] = ACTIONS(4711),
    [sym_while] = ACTIONS(4711),
    [sym_gshared] = ACTIONS(4711),
    [sym_traits] = ACTIONS(4711),
    [sym_vector] = ACTIONS(4711),
    [sym_void] = ACTIONS(4711),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2318] = {
    [sym_identifier] = ACTIONS(4715),
    [anon_sym_DOT] = ACTIONS(4718),
    [anon_sym_SEMI] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4718),
    [anon_sym_AT] = ACTIONS(4718),
    [sym_bool] = ACTIONS(4715),
    [sym_byte] = ACTIONS(4715),
    [sym_ubyte] = ACTIONS(4715),
    [sym_char] = ACTIONS(4715),
    [sym_short] = ACTIONS(4715),
    [sym_ushort] = ACTIONS(4715),
    [sym_int] = ACTIONS(4715),
    [sym_uint] = ACTIONS(4715),
    [sym_long] = ACTIONS(4715),
    [sym_ulong] = ACTIONS(4715),
    [sym_cent] = ACTIONS(4715),
    [sym_ucent] = ACTIONS(4715),
    [sym_wchar] = ACTIONS(4715),
    [sym_dchar] = ACTIONS(4715),
    [sym_float] = ACTIONS(4715),
    [sym_double] = ACTIONS(4715),
    [sym_real] = ACTIONS(4715),
    [sym_ifloat] = ACTIONS(4715),
    [sym_idouble] = ACTIONS(4715),
    [sym_ireal] = ACTIONS(4715),
    [sym_cfloat] = ACTIONS(4715),
    [sym_cdouble] = ACTIONS(4715),
    [sym_creal] = ACTIONS(4715),
    [sym_size_t] = ACTIONS(4715),
    [sym_ptrdiff_t] = ACTIONS(4715),
    [sym_string] = ACTIONS(4715),
    [sym_cstring] = ACTIONS(4715),
    [sym_dstring] = ACTIONS(4715),
    [sym_wstring] = ACTIONS(4715),
    [sym_noreturn] = ACTIONS(4715),
    [sym_this] = ACTIONS(4715),
    [sym_abstract] = ACTIONS(4715),
    [sym_alias] = ACTIONS(4715),
    [sym_align] = ACTIONS(4715),
    [sym_auto] = ACTIONS(4715),
    [sym_catch] = ACTIONS(4715),
    [sym_class] = ACTIONS(4715),
    [sym_const] = ACTIONS(4715),
    [sym_debug] = ACTIONS(4715),
    [sym_deprecated] = ACTIONS(4715),
    [sym_else] = ACTIONS(4715),
    [sym_enum] = ACTIONS(4715),
    [sym_export] = ACTIONS(4715),
    [sym_extern] = ACTIONS(4715),
    [sym_final] = ACTIONS(4715),
    [sym_finally] = ACTIONS(4715),
    [sym_immutable] = ACTIONS(4715),
    [sym_import] = ACTIONS(4715),
    [sym_inout] = ACTIONS(4715),
    [sym_interface] = ACTIONS(4715),
    [sym_invariant] = ACTIONS(4715),
    [sym_mixin] = ACTIONS(4715),
    [sym_nothrow] = ACTIONS(4715),
    [sym_override] = ACTIONS(4715),
    [sym_package] = ACTIONS(4715),
    [sym_pragma] = ACTIONS(4715),
    [sym_private] = ACTIONS(4715),
    [sym_protected] = ACTIONS(4715),
    [sym_public] = ACTIONS(4715),
    [sym_pure] = ACTIONS(4715),
    [sym_ref] = ACTIONS(4715),
    [sym_return] = ACTIONS(4715),
    [sym_scope] = ACTIONS(4715),
    [sym_shared] = ACTIONS(4715),
    [sym_static] = ACTIONS(4715),
    [sym_struct] = ACTIONS(4715),
    [sym_synchronized] = ACTIONS(4715),
    [sym_template] = ACTIONS(4715),
    [sym_typeof] = ACTIONS(4715),
    [sym_union] = ACTIONS(4715),
    [sym_unittest] = ACTIONS(4715),
    [sym_version] = ACTIONS(4715),
    [sym_while] = ACTIONS(4715),
    [sym_gshared] = ACTIONS(4715),
    [sym_traits] = ACTIONS(4715),
    [sym_vector] = ACTIONS(4715),
    [sym_void] = ACTIONS(4715),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2319] = {
    [sym_identifier] = ACTIONS(4721),
    [anon_sym_DOT] = ACTIONS(4723),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [anon_sym_AT] = ACTIONS(4723),
    [sym_bool] = ACTIONS(4721),
    [sym_byte] = ACTIONS(4721),
    [sym_ubyte] = ACTIONS(4721),
    [sym_char] = ACTIONS(4721),
    [sym_short] = ACTIONS(4721),
    [sym_ushort] = ACTIONS(4721),
    [sym_int] = ACTIONS(4721),
    [sym_uint] = ACTIONS(4721),
    [sym_long] = ACTIONS(4721),
    [sym_ulong] = ACTIONS(4721),
    [sym_cent] = ACTIONS(4721),
    [sym_ucent] = ACTIONS(4721),
    [sym_wchar] = ACTIONS(4721),
    [sym_dchar] = ACTIONS(4721),
    [sym_float] = ACTIONS(4721),
    [sym_double] = ACTIONS(4721),
    [sym_real] = ACTIONS(4721),
    [sym_ifloat] = ACTIONS(4721),
    [sym_idouble] = ACTIONS(4721),
    [sym_ireal] = ACTIONS(4721),
    [sym_cfloat] = ACTIONS(4721),
    [sym_cdouble] = ACTIONS(4721),
    [sym_creal] = ACTIONS(4721),
    [sym_size_t] = ACTIONS(4721),
    [sym_ptrdiff_t] = ACTIONS(4721),
    [sym_string] = ACTIONS(4721),
    [sym_cstring] = ACTIONS(4721),
    [sym_dstring] = ACTIONS(4721),
    [sym_wstring] = ACTIONS(4721),
    [sym_noreturn] = ACTIONS(4721),
    [sym_this] = ACTIONS(4721),
    [sym_abstract] = ACTIONS(4721),
    [sym_alias] = ACTIONS(4721),
    [sym_align] = ACTIONS(4721),
    [sym_auto] = ACTIONS(4721),
    [sym_catch] = ACTIONS(4721),
    [sym_class] = ACTIONS(4721),
    [sym_const] = ACTIONS(4721),
    [sym_debug] = ACTIONS(4721),
    [sym_deprecated] = ACTIONS(4721),
    [sym_else] = ACTIONS(4721),
    [sym_enum] = ACTIONS(4721),
    [sym_export] = ACTIONS(4721),
    [sym_extern] = ACTIONS(4721),
    [sym_final] = ACTIONS(4721),
    [sym_finally] = ACTIONS(4721),
    [sym_immutable] = ACTIONS(4721),
    [sym_import] = ACTIONS(4721),
    [sym_inout] = ACTIONS(4721),
    [sym_interface] = ACTIONS(4721),
    [sym_invariant] = ACTIONS(4721),
    [sym_mixin] = ACTIONS(4721),
    [sym_nothrow] = ACTIONS(4721),
    [sym_override] = ACTIONS(4721),
    [sym_package] = ACTIONS(4721),
    [sym_pragma] = ACTIONS(4721),
    [sym_private] = ACTIONS(4721),
    [sym_protected] = ACTIONS(4721),
    [sym_public] = ACTIONS(4721),
    [sym_pure] = ACTIONS(4721),
    [sym_ref] = ACTIONS(4721),
    [sym_return] = ACTIONS(4721),
    [sym_scope] = ACTIONS(4721),
    [sym_shared] = ACTIONS(4721),
    [sym_static] = ACTIONS(4721),
    [sym_struct] = ACTIONS(4721),
    [sym_synchronized] = ACTIONS(4721),
    [sym_template] = ACTIONS(4721),
    [sym_typeof] = ACTIONS(4721),
    [sym_union] = ACTIONS(4721),
    [sym_unittest] = ACTIONS(4721),
    [sym_version] = ACTIONS(4721),
    [sym_while] = ACTIONS(4721),
    [sym_gshared] = ACTIONS(4721),
    [sym_traits] = ACTIONS(4721),
    [sym_vector] = ACTIONS(4721),
    [sym_void] = ACTIONS(4721),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2320] = {
    [sym_identifier] = ACTIONS(4737),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_TILDE] = ACTIONS(4739),
    [anon_sym_AT] = ACTIONS(4739),
    [sym_bool] = ACTIONS(4737),
    [sym_byte] = ACTIONS(4737),
    [sym_ubyte] = ACTIONS(4737),
    [sym_char] = ACTIONS(4737),
    [sym_short] = ACTIONS(4737),
    [sym_ushort] = ACTIONS(4737),
    [sym_int] = ACTIONS(4737),
    [sym_uint] = ACTIONS(4737),
    [sym_long] = ACTIONS(4737),
    [sym_ulong] = ACTIONS(4737),
    [sym_cent] = ACTIONS(4737),
    [sym_ucent] = ACTIONS(4737),
    [sym_wchar] = ACTIONS(4737),
    [sym_dchar] = ACTIONS(4737),
    [sym_float] = ACTIONS(4737),
    [sym_double] = ACTIONS(4737),
    [sym_real] = ACTIONS(4737),
    [sym_ifloat] = ACTIONS(4737),
    [sym_idouble] = ACTIONS(4737),
    [sym_ireal] = ACTIONS(4737),
    [sym_cfloat] = ACTIONS(4737),
    [sym_cdouble] = ACTIONS(4737),
    [sym_creal] = ACTIONS(4737),
    [sym_size_t] = ACTIONS(4737),
    [sym_ptrdiff_t] = ACTIONS(4737),
    [sym_string] = ACTIONS(4737),
    [sym_cstring] = ACTIONS(4737),
    [sym_dstring] = ACTIONS(4737),
    [sym_wstring] = ACTIONS(4737),
    [sym_noreturn] = ACTIONS(4737),
    [sym_this] = ACTIONS(4737),
    [sym_abstract] = ACTIONS(4737),
    [sym_alias] = ACTIONS(4737),
    [sym_align] = ACTIONS(4737),
    [sym_auto] = ACTIONS(4737),
    [sym_catch] = ACTIONS(4737),
    [sym_class] = ACTIONS(4737),
    [sym_const] = ACTIONS(4737),
    [sym_debug] = ACTIONS(4737),
    [sym_deprecated] = ACTIONS(4737),
    [sym_else] = ACTIONS(4737),
    [sym_enum] = ACTIONS(4737),
    [sym_export] = ACTIONS(4737),
    [sym_extern] = ACTIONS(4737),
    [sym_final] = ACTIONS(4737),
    [sym_finally] = ACTIONS(4737),
    [sym_immutable] = ACTIONS(4737),
    [sym_import] = ACTIONS(4737),
    [sym_inout] = ACTIONS(4737),
    [sym_interface] = ACTIONS(4737),
    [sym_invariant] = ACTIONS(4737),
    [sym_mixin] = ACTIONS(4737),
    [sym_nothrow] = ACTIONS(4737),
    [sym_override] = ACTIONS(4737),
    [sym_package] = ACTIONS(4737),
    [sym_pragma] = ACTIONS(4737),
    [sym_private] = ACTIONS(4737),
    [sym_protected] = ACTIONS(4737),
    [sym_public] = ACTIONS(4737),
    [sym_pure] = ACTIONS(4737),
    [sym_ref] = ACTIONS(4737),
    [sym_return] = ACTIONS(4737),
    [sym_scope] = ACTIONS(4737),
    [sym_shared] = ACTIONS(4737),
    [sym_static] = ACTIONS(4737),
    [sym_struct] = ACTIONS(4737),
    [sym_synchronized] = ACTIONS(4737),
    [sym_template] = ACTIONS(4737),
    [sym_typeof] = ACTIONS(4737),
    [sym_union] = ACTIONS(4737),
    [sym_unittest] = ACTIONS(4737),
    [sym_version] = ACTIONS(4737),
    [sym_while] = ACTIONS(4737),
    [sym_gshared] = ACTIONS(4737),
    [sym_traits] = ACTIONS(4737),
    [sym_vector] = ACTIONS(4737),
    [sym_void] = ACTIONS(4737),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2321] = {
    [sym_identifier] = ACTIONS(4400),
    [anon_sym_DOT] = ACTIONS(4402),
    [anon_sym_SEMI] = ACTIONS(4402),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_AT] = ACTIONS(4402),
    [sym_bool] = ACTIONS(4400),
    [sym_byte] = ACTIONS(4400),
    [sym_ubyte] = ACTIONS(4400),
    [sym_char] = ACTIONS(4400),
    [sym_short] = ACTIONS(4400),
    [sym_ushort] = ACTIONS(4400),
    [sym_int] = ACTIONS(4400),
    [sym_uint] = ACTIONS(4400),
    [sym_long] = ACTIONS(4400),
    [sym_ulong] = ACTIONS(4400),
    [sym_cent] = ACTIONS(4400),
    [sym_ucent] = ACTIONS(4400),
    [sym_wchar] = ACTIONS(4400),
    [sym_dchar] = ACTIONS(4400),
    [sym_float] = ACTIONS(4400),
    [sym_double] = ACTIONS(4400),
    [sym_real] = ACTIONS(4400),
    [sym_ifloat] = ACTIONS(4400),
    [sym_idouble] = ACTIONS(4400),
    [sym_ireal] = ACTIONS(4400),
    [sym_cfloat] = ACTIONS(4400),
    [sym_cdouble] = ACTIONS(4400),
    [sym_creal] = ACTIONS(4400),
    [sym_size_t] = ACTIONS(4400),
    [sym_ptrdiff_t] = ACTIONS(4400),
    [sym_string] = ACTIONS(4400),
    [sym_cstring] = ACTIONS(4400),
    [sym_dstring] = ACTIONS(4400),
    [sym_wstring] = ACTIONS(4400),
    [sym_noreturn] = ACTIONS(4400),
    [sym_this] = ACTIONS(4400),
    [sym_abstract] = ACTIONS(4400),
    [sym_alias] = ACTIONS(4400),
    [sym_align] = ACTIONS(4400),
    [sym_auto] = ACTIONS(4400),
    [sym_catch] = ACTIONS(4400),
    [sym_class] = ACTIONS(4400),
    [sym_const] = ACTIONS(4400),
    [sym_debug] = ACTIONS(4400),
    [sym_deprecated] = ACTIONS(4400),
    [sym_else] = ACTIONS(4400),
    [sym_enum] = ACTIONS(4400),
    [sym_export] = ACTIONS(4400),
    [sym_extern] = ACTIONS(4400),
    [sym_final] = ACTIONS(4400),
    [sym_finally] = ACTIONS(4400),
    [sym_immutable] = ACTIONS(4400),
    [sym_import] = ACTIONS(4400),
    [sym_inout] = ACTIONS(4400),
    [sym_interface] = ACTIONS(4400),
    [sym_invariant] = ACTIONS(4400),
    [sym_mixin] = ACTIONS(4400),
    [sym_nothrow] = ACTIONS(4400),
    [sym_override] = ACTIONS(4400),
    [sym_package] = ACTIONS(4400),
    [sym_pragma] = ACTIONS(4400),
    [sym_private] = ACTIONS(4400),
    [sym_protected] = ACTIONS(4400),
    [sym_public] = ACTIONS(4400),
    [sym_pure] = ACTIONS(4400),
    [sym_ref] = ACTIONS(4400),
    [sym_return] = ACTIONS(4400),
    [sym_scope] = ACTIONS(4400),
    [sym_shared] = ACTIONS(4400),
    [sym_static] = ACTIONS(4400),
    [sym_struct] = ACTIONS(4400),
    [sym_synchronized] = ACTIONS(4400),
    [sym_template] = ACTIONS(4400),
    [sym_typeof] = ACTIONS(4400),
    [sym_union] = ACTIONS(4400),
    [sym_unittest] = ACTIONS(4400),
    [sym_version] = ACTIONS(4400),
    [sym_while] = ACTIONS(4400),
    [sym_gshared] = ACTIONS(4400),
    [sym_traits] = ACTIONS(4400),
    [sym_vector] = ACTIONS(4400),
    [sym_void] = ACTIONS(4400),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2322] = {
    [sym_identifier] = ACTIONS(4404),
    [anon_sym_DOT] = ACTIONS(4406),
    [anon_sym_SEMI] = ACTIONS(4406),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_AT] = ACTIONS(4406),
    [sym_bool] = ACTIONS(4404),
    [sym_byte] = ACTIONS(4404),
    [sym_ubyte] = ACTIONS(4404),
    [sym_char] = ACTIONS(4404),
    [sym_short] = ACTIONS(4404),
    [sym_ushort] = ACTIONS(4404),
    [sym_int] = ACTIONS(4404),
    [sym_uint] = ACTIONS(4404),
    [sym_long] = ACTIONS(4404),
    [sym_ulong] = ACTIONS(4404),
    [sym_cent] = ACTIONS(4404),
    [sym_ucent] = ACTIONS(4404),
    [sym_wchar] = ACTIONS(4404),
    [sym_dchar] = ACTIONS(4404),
    [sym_float] = ACTIONS(4404),
    [sym_double] = ACTIONS(4404),
    [sym_real] = ACTIONS(4404),
    [sym_ifloat] = ACTIONS(4404),
    [sym_idouble] = ACTIONS(4404),
    [sym_ireal] = ACTIONS(4404),
    [sym_cfloat] = ACTIONS(4404),
    [sym_cdouble] = ACTIONS(4404),
    [sym_creal] = ACTIONS(4404),
    [sym_size_t] = ACTIONS(4404),
    [sym_ptrdiff_t] = ACTIONS(4404),
    [sym_string] = ACTIONS(4404),
    [sym_cstring] = ACTIONS(4404),
    [sym_dstring] = ACTIONS(4404),
    [sym_wstring] = ACTIONS(4404),
    [sym_noreturn] = ACTIONS(4404),
    [sym_this] = ACTIONS(4404),
    [sym_abstract] = ACTIONS(4404),
    [sym_alias] = ACTIONS(4404),
    [sym_align] = ACTIONS(4404),
    [sym_auto] = ACTIONS(4404),
    [sym_catch] = ACTIONS(4404),
    [sym_class] = ACTIONS(4404),
    [sym_const] = ACTIONS(4404),
    [sym_debug] = ACTIONS(4404),
    [sym_deprecated] = ACTIONS(4404),
    [sym_else] = ACTIONS(4404),
    [sym_enum] = ACTIONS(4404),
    [sym_export] = ACTIONS(4404),
    [sym_extern] = ACTIONS(4404),
    [sym_final] = ACTIONS(4404),
    [sym_finally] = ACTIONS(4404),
    [sym_immutable] = ACTIONS(4404),
    [sym_import] = ACTIONS(4404),
    [sym_inout] = ACTIONS(4404),
    [sym_interface] = ACTIONS(4404),
    [sym_invariant] = ACTIONS(4404),
    [sym_mixin] = ACTIONS(4404),
    [sym_nothrow] = ACTIONS(4404),
    [sym_override] = ACTIONS(4404),
    [sym_package] = ACTIONS(4404),
    [sym_pragma] = ACTIONS(4404),
    [sym_private] = ACTIONS(4404),
    [sym_protected] = ACTIONS(4404),
    [sym_public] = ACTIONS(4404),
    [sym_pure] = ACTIONS(4404),
    [sym_ref] = ACTIONS(4404),
    [sym_return] = ACTIONS(4404),
    [sym_scope] = ACTIONS(4404),
    [sym_shared] = ACTIONS(4404),
    [sym_static] = ACTIONS(4404),
    [sym_struct] = ACTIONS(4404),
    [sym_synchronized] = ACTIONS(4404),
    [sym_template] = ACTIONS(4404),
    [sym_typeof] = ACTIONS(4404),
    [sym_union] = ACTIONS(4404),
    [sym_unittest] = ACTIONS(4404),
    [sym_version] = ACTIONS(4404),
    [sym_while] = ACTIONS(4404),
    [sym_gshared] = ACTIONS(4404),
    [sym_traits] = ACTIONS(4404),
    [sym_vector] = ACTIONS(4404),
    [sym_void] = ACTIONS(4404),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2323] = {
    [ts_builtin_sym_end] = ACTIONS(5001),
    [sym_identifier] = ACTIONS(4999),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_DOT] = ACTIONS(5001),
    [anon_sym_SEMI] = ACTIONS(5001),
    [anon_sym_TILDE] = ACTIONS(5001),
    [anon_sym_AT] = ACTIONS(5001),
    [sym_bool] = ACTIONS(4999),
    [sym_byte] = ACTIONS(4999),
    [sym_ubyte] = ACTIONS(4999),
    [sym_char] = ACTIONS(4999),
    [sym_short] = ACTIONS(4999),
    [sym_ushort] = ACTIONS(4999),
    [sym_int] = ACTIONS(4999),
    [sym_uint] = ACTIONS(4999),
    [sym_long] = ACTIONS(4999),
    [sym_ulong] = ACTIONS(4999),
    [sym_cent] = ACTIONS(4999),
    [sym_ucent] = ACTIONS(4999),
    [sym_wchar] = ACTIONS(4999),
    [sym_dchar] = ACTIONS(4999),
    [sym_float] = ACTIONS(4999),
    [sym_double] = ACTIONS(4999),
    [sym_real] = ACTIONS(4999),
    [sym_ifloat] = ACTIONS(4999),
    [sym_idouble] = ACTIONS(4999),
    [sym_ireal] = ACTIONS(4999),
    [sym_cfloat] = ACTIONS(4999),
    [sym_cdouble] = ACTIONS(4999),
    [sym_creal] = ACTIONS(4999),
    [sym_size_t] = ACTIONS(4999),
    [sym_ptrdiff_t] = ACTIONS(4999),
    [sym_string] = ACTIONS(4999),
    [sym_cstring] = ACTIONS(4999),
    [sym_dstring] = ACTIONS(4999),
    [sym_wstring] = ACTIONS(4999),
    [sym_noreturn] = ACTIONS(4999),
    [sym_this] = ACTIONS(4999),
    [sym_abstract] = ACTIONS(4999),
    [sym_alias] = ACTIONS(4999),
    [sym_align] = ACTIONS(4999),
    [sym_auto] = ACTIONS(4999),
    [sym_class] = ACTIONS(4999),
    [sym_const] = ACTIONS(4999),
    [sym_debug] = ACTIONS(4999),
    [sym_deprecated] = ACTIONS(4999),
    [sym_else] = ACTIONS(4999),
    [sym_enum] = ACTIONS(4999),
    [sym_export] = ACTIONS(4999),
    [sym_extern] = ACTIONS(4999),
    [sym_final] = ACTIONS(4999),
    [sym_immutable] = ACTIONS(4999),
    [sym_import] = ACTIONS(4999),
    [sym_inout] = ACTIONS(4999),
    [sym_interface] = ACTIONS(4999),
    [sym_invariant] = ACTIONS(4999),
    [sym_mixin] = ACTIONS(4999),
    [sym_nothrow] = ACTIONS(4999),
    [sym_override] = ACTIONS(4999),
    [sym_package] = ACTIONS(4999),
    [sym_pragma] = ACTIONS(4999),
    [sym_private] = ACTIONS(4999),
    [sym_protected] = ACTIONS(4999),
    [sym_public] = ACTIONS(4999),
    [sym_pure] = ACTIONS(4999),
    [sym_ref] = ACTIONS(4999),
    [sym_return] = ACTIONS(4999),
    [sym_scope] = ACTIONS(4999),
    [sym_shared] = ACTIONS(4999),
    [sym_static] = ACTIONS(4999),
    [sym_struct] = ACTIONS(4999),
    [sym_synchronized] = ACTIONS(4999),
    [sym_template] = ACTIONS(4999),
    [sym_typeof] = ACTIONS(4999),
    [sym_union] = ACTIONS(4999),
    [sym_unittest] = ACTIONS(4999),
    [sym_version] = ACTIONS(4999),
    [sym_while] = ACTIONS(4999),
    [sym_gshared] = ACTIONS(4999),
    [sym_traits] = ACTIONS(4999),
    [sym_vector] = ACTIONS(4999),
    [sym_void] = ACTIONS(4999),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2324] = {
    [sym_identifier] = ACTIONS(4769),
    [anon_sym_DOT] = ACTIONS(4771),
    [anon_sym_SEMI] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [anon_sym_AT] = ACTIONS(4771),
    [sym_bool] = ACTIONS(4769),
    [sym_byte] = ACTIONS(4769),
    [sym_ubyte] = ACTIONS(4769),
    [sym_char] = ACTIONS(4769),
    [sym_short] = ACTIONS(4769),
    [sym_ushort] = ACTIONS(4769),
    [sym_int] = ACTIONS(4769),
    [sym_uint] = ACTIONS(4769),
    [sym_long] = ACTIONS(4769),
    [sym_ulong] = ACTIONS(4769),
    [sym_cent] = ACTIONS(4769),
    [sym_ucent] = ACTIONS(4769),
    [sym_wchar] = ACTIONS(4769),
    [sym_dchar] = ACTIONS(4769),
    [sym_float] = ACTIONS(4769),
    [sym_double] = ACTIONS(4769),
    [sym_real] = ACTIONS(4769),
    [sym_ifloat] = ACTIONS(4769),
    [sym_idouble] = ACTIONS(4769),
    [sym_ireal] = ACTIONS(4769),
    [sym_cfloat] = ACTIONS(4769),
    [sym_cdouble] = ACTIONS(4769),
    [sym_creal] = ACTIONS(4769),
    [sym_size_t] = ACTIONS(4769),
    [sym_ptrdiff_t] = ACTIONS(4769),
    [sym_string] = ACTIONS(4769),
    [sym_cstring] = ACTIONS(4769),
    [sym_dstring] = ACTIONS(4769),
    [sym_wstring] = ACTIONS(4769),
    [sym_noreturn] = ACTIONS(4769),
    [sym_this] = ACTIONS(4769),
    [sym_abstract] = ACTIONS(4769),
    [sym_alias] = ACTIONS(4769),
    [sym_align] = ACTIONS(4769),
    [sym_auto] = ACTIONS(4769),
    [sym_catch] = ACTIONS(4769),
    [sym_class] = ACTIONS(4769),
    [sym_const] = ACTIONS(4769),
    [sym_debug] = ACTIONS(4769),
    [sym_deprecated] = ACTIONS(4769),
    [sym_else] = ACTIONS(4769),
    [sym_enum] = ACTIONS(4769),
    [sym_export] = ACTIONS(4769),
    [sym_extern] = ACTIONS(4769),
    [sym_final] = ACTIONS(4769),
    [sym_finally] = ACTIONS(4769),
    [sym_immutable] = ACTIONS(4769),
    [sym_import] = ACTIONS(4769),
    [sym_inout] = ACTIONS(4769),
    [sym_interface] = ACTIONS(4769),
    [sym_invariant] = ACTIONS(4769),
    [sym_mixin] = ACTIONS(4769),
    [sym_nothrow] = ACTIONS(4769),
    [sym_override] = ACTIONS(4769),
    [sym_package] = ACTIONS(4769),
    [sym_pragma] = ACTIONS(4769),
    [sym_private] = ACTIONS(4769),
    [sym_protected] = ACTIONS(4769),
    [sym_public] = ACTIONS(4769),
    [sym_pure] = ACTIONS(4769),
    [sym_ref] = ACTIONS(4769),
    [sym_return] = ACTIONS(4769),
    [sym_scope] = ACTIONS(4769),
    [sym_shared] = ACTIONS(4769),
    [sym_static] = ACTIONS(4769),
    [sym_struct] = ACTIONS(4769),
    [sym_synchronized] = ACTIONS(4769),
    [sym_template] = ACTIONS(4769),
    [sym_typeof] = ACTIONS(4769),
    [sym_union] = ACTIONS(4769),
    [sym_unittest] = ACTIONS(4769),
    [sym_version] = ACTIONS(4769),
    [sym_while] = ACTIONS(4769),
    [sym_gshared] = ACTIONS(4769),
    [sym_traits] = ACTIONS(4769),
    [sym_vector] = ACTIONS(4769),
    [sym_void] = ACTIONS(4769),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2325] = {
    [sym_identifier] = ACTIONS(4408),
    [anon_sym_DOT] = ACTIONS(4410),
    [anon_sym_SEMI] = ACTIONS(4410),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_AT] = ACTIONS(4410),
    [sym_bool] = ACTIONS(4408),
    [sym_byte] = ACTIONS(4408),
    [sym_ubyte] = ACTIONS(4408),
    [sym_char] = ACTIONS(4408),
    [sym_short] = ACTIONS(4408),
    [sym_ushort] = ACTIONS(4408),
    [sym_int] = ACTIONS(4408),
    [sym_uint] = ACTIONS(4408),
    [sym_long] = ACTIONS(4408),
    [sym_ulong] = ACTIONS(4408),
    [sym_cent] = ACTIONS(4408),
    [sym_ucent] = ACTIONS(4408),
    [sym_wchar] = ACTIONS(4408),
    [sym_dchar] = ACTIONS(4408),
    [sym_float] = ACTIONS(4408),
    [sym_double] = ACTIONS(4408),
    [sym_real] = ACTIONS(4408),
    [sym_ifloat] = ACTIONS(4408),
    [sym_idouble] = ACTIONS(4408),
    [sym_ireal] = ACTIONS(4408),
    [sym_cfloat] = ACTIONS(4408),
    [sym_cdouble] = ACTIONS(4408),
    [sym_creal] = ACTIONS(4408),
    [sym_size_t] = ACTIONS(4408),
    [sym_ptrdiff_t] = ACTIONS(4408),
    [sym_string] = ACTIONS(4408),
    [sym_cstring] = ACTIONS(4408),
    [sym_dstring] = ACTIONS(4408),
    [sym_wstring] = ACTIONS(4408),
    [sym_noreturn] = ACTIONS(4408),
    [sym_this] = ACTIONS(4408),
    [sym_abstract] = ACTIONS(4408),
    [sym_alias] = ACTIONS(4408),
    [sym_align] = ACTIONS(4408),
    [sym_auto] = ACTIONS(4408),
    [sym_catch] = ACTIONS(4408),
    [sym_class] = ACTIONS(4408),
    [sym_const] = ACTIONS(4408),
    [sym_debug] = ACTIONS(4408),
    [sym_deprecated] = ACTIONS(4408),
    [sym_else] = ACTIONS(4408),
    [sym_enum] = ACTIONS(4408),
    [sym_export] = ACTIONS(4408),
    [sym_extern] = ACTIONS(4408),
    [sym_final] = ACTIONS(4408),
    [sym_finally] = ACTIONS(4408),
    [sym_immutable] = ACTIONS(4408),
    [sym_import] = ACTIONS(4408),
    [sym_inout] = ACTIONS(4408),
    [sym_interface] = ACTIONS(4408),
    [sym_invariant] = ACTIONS(4408),
    [sym_mixin] = ACTIONS(4408),
    [sym_nothrow] = ACTIONS(4408),
    [sym_override] = ACTIONS(4408),
    [sym_package] = ACTIONS(4408),
    [sym_pragma] = ACTIONS(4408),
    [sym_private] = ACTIONS(4408),
    [sym_protected] = ACTIONS(4408),
    [sym_public] = ACTIONS(4408),
    [sym_pure] = ACTIONS(4408),
    [sym_ref] = ACTIONS(4408),
    [sym_return] = ACTIONS(4408),
    [sym_scope] = ACTIONS(4408),
    [sym_shared] = ACTIONS(4408),
    [sym_static] = ACTIONS(4408),
    [sym_struct] = ACTIONS(4408),
    [sym_synchronized] = ACTIONS(4408),
    [sym_template] = ACTIONS(4408),
    [sym_typeof] = ACTIONS(4408),
    [sym_union] = ACTIONS(4408),
    [sym_unittest] = ACTIONS(4408),
    [sym_version] = ACTIONS(4408),
    [sym_while] = ACTIONS(4408),
    [sym_gshared] = ACTIONS(4408),
    [sym_traits] = ACTIONS(4408),
    [sym_vector] = ACTIONS(4408),
    [sym_void] = ACTIONS(4408),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2326] = {
    [sym_identifier] = ACTIONS(4412),
    [anon_sym_DOT] = ACTIONS(4414),
    [anon_sym_SEMI] = ACTIONS(4414),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_AT] = ACTIONS(4414),
    [sym_bool] = ACTIONS(4412),
    [sym_byte] = ACTIONS(4412),
    [sym_ubyte] = ACTIONS(4412),
    [sym_char] = ACTIONS(4412),
    [sym_short] = ACTIONS(4412),
    [sym_ushort] = ACTIONS(4412),
    [sym_int] = ACTIONS(4412),
    [sym_uint] = ACTIONS(4412),
    [sym_long] = ACTIONS(4412),
    [sym_ulong] = ACTIONS(4412),
    [sym_cent] = ACTIONS(4412),
    [sym_ucent] = ACTIONS(4412),
    [sym_wchar] = ACTIONS(4412),
    [sym_dchar] = ACTIONS(4412),
    [sym_float] = ACTIONS(4412),
    [sym_double] = ACTIONS(4412),
    [sym_real] = ACTIONS(4412),
    [sym_ifloat] = ACTIONS(4412),
    [sym_idouble] = ACTIONS(4412),
    [sym_ireal] = ACTIONS(4412),
    [sym_cfloat] = ACTIONS(4412),
    [sym_cdouble] = ACTIONS(4412),
    [sym_creal] = ACTIONS(4412),
    [sym_size_t] = ACTIONS(4412),
    [sym_ptrdiff_t] = ACTIONS(4412),
    [sym_string] = ACTIONS(4412),
    [sym_cstring] = ACTIONS(4412),
    [sym_dstring] = ACTIONS(4412),
    [sym_wstring] = ACTIONS(4412),
    [sym_noreturn] = ACTIONS(4412),
    [sym_this] = ACTIONS(4412),
    [sym_abstract] = ACTIONS(4412),
    [sym_alias] = ACTIONS(4412),
    [sym_align] = ACTIONS(4412),
    [sym_auto] = ACTIONS(4412),
    [sym_catch] = ACTIONS(4412),
    [sym_class] = ACTIONS(4412),
    [sym_const] = ACTIONS(4412),
    [sym_debug] = ACTIONS(4412),
    [sym_deprecated] = ACTIONS(4412),
    [sym_else] = ACTIONS(4412),
    [sym_enum] = ACTIONS(4412),
    [sym_export] = ACTIONS(4412),
    [sym_extern] = ACTIONS(4412),
    [sym_final] = ACTIONS(4412),
    [sym_finally] = ACTIONS(4412),
    [sym_immutable] = ACTIONS(4412),
    [sym_import] = ACTIONS(4412),
    [sym_inout] = ACTIONS(4412),
    [sym_interface] = ACTIONS(4412),
    [sym_invariant] = ACTIONS(4412),
    [sym_mixin] = ACTIONS(4412),
    [sym_nothrow] = ACTIONS(4412),
    [sym_override] = ACTIONS(4412),
    [sym_package] = ACTIONS(4412),
    [sym_pragma] = ACTIONS(4412),
    [sym_private] = ACTIONS(4412),
    [sym_protected] = ACTIONS(4412),
    [sym_public] = ACTIONS(4412),
    [sym_pure] = ACTIONS(4412),
    [sym_ref] = ACTIONS(4412),
    [sym_return] = ACTIONS(4412),
    [sym_scope] = ACTIONS(4412),
    [sym_shared] = ACTIONS(4412),
    [sym_static] = ACTIONS(4412),
    [sym_struct] = ACTIONS(4412),
    [sym_synchronized] = ACTIONS(4412),
    [sym_template] = ACTIONS(4412),
    [sym_typeof] = ACTIONS(4412),
    [sym_union] = ACTIONS(4412),
    [sym_unittest] = ACTIONS(4412),
    [sym_version] = ACTIONS(4412),
    [sym_while] = ACTIONS(4412),
    [sym_gshared] = ACTIONS(4412),
    [sym_traits] = ACTIONS(4412),
    [sym_vector] = ACTIONS(4412),
    [sym_void] = ACTIONS(4412),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2327] = {
    [sym_identifier] = ACTIONS(4420),
    [anon_sym_DOT] = ACTIONS(4422),
    [anon_sym_SEMI] = ACTIONS(4422),
    [anon_sym_TILDE] = ACTIONS(4422),
    [anon_sym_AT] = ACTIONS(4422),
    [sym_bool] = ACTIONS(4420),
    [sym_byte] = ACTIONS(4420),
    [sym_ubyte] = ACTIONS(4420),
    [sym_char] = ACTIONS(4420),
    [sym_short] = ACTIONS(4420),
    [sym_ushort] = ACTIONS(4420),
    [sym_int] = ACTIONS(4420),
    [sym_uint] = ACTIONS(4420),
    [sym_long] = ACTIONS(4420),
    [sym_ulong] = ACTIONS(4420),
    [sym_cent] = ACTIONS(4420),
    [sym_ucent] = ACTIONS(4420),
    [sym_wchar] = ACTIONS(4420),
    [sym_dchar] = ACTIONS(4420),
    [sym_float] = ACTIONS(4420),
    [sym_double] = ACTIONS(4420),
    [sym_real] = ACTIONS(4420),
    [sym_ifloat] = ACTIONS(4420),
    [sym_idouble] = ACTIONS(4420),
    [sym_ireal] = ACTIONS(4420),
    [sym_cfloat] = ACTIONS(4420),
    [sym_cdouble] = ACTIONS(4420),
    [sym_creal] = ACTIONS(4420),
    [sym_size_t] = ACTIONS(4420),
    [sym_ptrdiff_t] = ACTIONS(4420),
    [sym_string] = ACTIONS(4420),
    [sym_cstring] = ACTIONS(4420),
    [sym_dstring] = ACTIONS(4420),
    [sym_wstring] = ACTIONS(4420),
    [sym_noreturn] = ACTIONS(4420),
    [sym_this] = ACTIONS(4420),
    [sym_abstract] = ACTIONS(4420),
    [sym_alias] = ACTIONS(4420),
    [sym_align] = ACTIONS(4420),
    [sym_auto] = ACTIONS(4420),
    [sym_catch] = ACTIONS(4420),
    [sym_class] = ACTIONS(4420),
    [sym_const] = ACTIONS(4420),
    [sym_debug] = ACTIONS(4420),
    [sym_deprecated] = ACTIONS(4420),
    [sym_else] = ACTIONS(4420),
    [sym_enum] = ACTIONS(4420),
    [sym_export] = ACTIONS(4420),
    [sym_extern] = ACTIONS(4420),
    [sym_final] = ACTIONS(4420),
    [sym_finally] = ACTIONS(4420),
    [sym_immutable] = ACTIONS(4420),
    [sym_import] = ACTIONS(4420),
    [sym_inout] = ACTIONS(4420),
    [sym_interface] = ACTIONS(4420),
    [sym_invariant] = ACTIONS(4420),
    [sym_mixin] = ACTIONS(4420),
    [sym_nothrow] = ACTIONS(4420),
    [sym_override] = ACTIONS(4420),
    [sym_package] = ACTIONS(4420),
    [sym_pragma] = ACTIONS(4420),
    [sym_private] = ACTIONS(4420),
    [sym_protected] = ACTIONS(4420),
    [sym_public] = ACTIONS(4420),
    [sym_pure] = ACTIONS(4420),
    [sym_ref] = ACTIONS(4420),
    [sym_return] = ACTIONS(4420),
    [sym_scope] = ACTIONS(4420),
    [sym_shared] = ACTIONS(4420),
    [sym_static] = ACTIONS(4420),
    [sym_struct] = ACTIONS(4420),
    [sym_synchronized] = ACTIONS(4420),
    [sym_template] = ACTIONS(4420),
    [sym_typeof] = ACTIONS(4420),
    [sym_union] = ACTIONS(4420),
    [sym_unittest] = ACTIONS(4420),
    [sym_version] = ACTIONS(4420),
    [sym_while] = ACTIONS(4420),
    [sym_gshared] = ACTIONS(4420),
    [sym_traits] = ACTIONS(4420),
    [sym_vector] = ACTIONS(4420),
    [sym_void] = ACTIONS(4420),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2328] = {
    [sym_identifier] = ACTIONS(4436),
    [anon_sym_DOT] = ACTIONS(4438),
    [anon_sym_SEMI] = ACTIONS(4438),
    [anon_sym_TILDE] = ACTIONS(4438),
    [anon_sym_AT] = ACTIONS(4438),
    [sym_bool] = ACTIONS(4436),
    [sym_byte] = ACTIONS(4436),
    [sym_ubyte] = ACTIONS(4436),
    [sym_char] = ACTIONS(4436),
    [sym_short] = ACTIONS(4436),
    [sym_ushort] = ACTIONS(4436),
    [sym_int] = ACTIONS(4436),
    [sym_uint] = ACTIONS(4436),
    [sym_long] = ACTIONS(4436),
    [sym_ulong] = ACTIONS(4436),
    [sym_cent] = ACTIONS(4436),
    [sym_ucent] = ACTIONS(4436),
    [sym_wchar] = ACTIONS(4436),
    [sym_dchar] = ACTIONS(4436),
    [sym_float] = ACTIONS(4436),
    [sym_double] = ACTIONS(4436),
    [sym_real] = ACTIONS(4436),
    [sym_ifloat] = ACTIONS(4436),
    [sym_idouble] = ACTIONS(4436),
    [sym_ireal] = ACTIONS(4436),
    [sym_cfloat] = ACTIONS(4436),
    [sym_cdouble] = ACTIONS(4436),
    [sym_creal] = ACTIONS(4436),
    [sym_size_t] = ACTIONS(4436),
    [sym_ptrdiff_t] = ACTIONS(4436),
    [sym_string] = ACTIONS(4436),
    [sym_cstring] = ACTIONS(4436),
    [sym_dstring] = ACTIONS(4436),
    [sym_wstring] = ACTIONS(4436),
    [sym_noreturn] = ACTIONS(4436),
    [sym_this] = ACTIONS(4436),
    [sym_abstract] = ACTIONS(4436),
    [sym_alias] = ACTIONS(4436),
    [sym_align] = ACTIONS(4436),
    [sym_auto] = ACTIONS(4436),
    [sym_catch] = ACTIONS(4436),
    [sym_class] = ACTIONS(4436),
    [sym_const] = ACTIONS(4436),
    [sym_debug] = ACTIONS(4436),
    [sym_deprecated] = ACTIONS(4436),
    [sym_else] = ACTIONS(4436),
    [sym_enum] = ACTIONS(4436),
    [sym_export] = ACTIONS(4436),
    [sym_extern] = ACTIONS(4436),
    [sym_final] = ACTIONS(4436),
    [sym_finally] = ACTIONS(4436),
    [sym_immutable] = ACTIONS(4436),
    [sym_import] = ACTIONS(4436),
    [sym_inout] = ACTIONS(4436),
    [sym_interface] = ACTIONS(4436),
    [sym_invariant] = ACTIONS(4436),
    [sym_mixin] = ACTIONS(4436),
    [sym_nothrow] = ACTIONS(4436),
    [sym_override] = ACTIONS(4436),
    [sym_package] = ACTIONS(4436),
    [sym_pragma] = ACTIONS(4436),
    [sym_private] = ACTIONS(4436),
    [sym_protected] = ACTIONS(4436),
    [sym_public] = ACTIONS(4436),
    [sym_pure] = ACTIONS(4436),
    [sym_ref] = ACTIONS(4436),
    [sym_return] = ACTIONS(4436),
    [sym_scope] = ACTIONS(4436),
    [sym_shared] = ACTIONS(4436),
    [sym_static] = ACTIONS(4436),
    [sym_struct] = ACTIONS(4436),
    [sym_synchronized] = ACTIONS(4436),
    [sym_template] = ACTIONS(4436),
    [sym_typeof] = ACTIONS(4436),
    [sym_union] = ACTIONS(4436),
    [sym_unittest] = ACTIONS(4436),
    [sym_version] = ACTIONS(4436),
    [sym_while] = ACTIONS(4436),
    [sym_gshared] = ACTIONS(4436),
    [sym_traits] = ACTIONS(4436),
    [sym_vector] = ACTIONS(4436),
    [sym_void] = ACTIONS(4436),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2329] = {
    [sym_switch_statement] = STATE(1635),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1382),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2330] = {
    [sym_identifier] = ACTIONS(4578),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_TILDE] = ACTIONS(4580),
    [anon_sym_AT] = ACTIONS(4580),
    [sym_bool] = ACTIONS(4578),
    [sym_byte] = ACTIONS(4578),
    [sym_ubyte] = ACTIONS(4578),
    [sym_char] = ACTIONS(4578),
    [sym_short] = ACTIONS(4578),
    [sym_ushort] = ACTIONS(4578),
    [sym_int] = ACTIONS(4578),
    [sym_uint] = ACTIONS(4578),
    [sym_long] = ACTIONS(4578),
    [sym_ulong] = ACTIONS(4578),
    [sym_cent] = ACTIONS(4578),
    [sym_ucent] = ACTIONS(4578),
    [sym_wchar] = ACTIONS(4578),
    [sym_dchar] = ACTIONS(4578),
    [sym_float] = ACTIONS(4578),
    [sym_double] = ACTIONS(4578),
    [sym_real] = ACTIONS(4578),
    [sym_ifloat] = ACTIONS(4578),
    [sym_idouble] = ACTIONS(4578),
    [sym_ireal] = ACTIONS(4578),
    [sym_cfloat] = ACTIONS(4578),
    [sym_cdouble] = ACTIONS(4578),
    [sym_creal] = ACTIONS(4578),
    [sym_size_t] = ACTIONS(4578),
    [sym_ptrdiff_t] = ACTIONS(4578),
    [sym_string] = ACTIONS(4578),
    [sym_cstring] = ACTIONS(4578),
    [sym_dstring] = ACTIONS(4578),
    [sym_wstring] = ACTIONS(4578),
    [sym_noreturn] = ACTIONS(4578),
    [sym_this] = ACTIONS(4578),
    [sym_abstract] = ACTIONS(4578),
    [sym_alias] = ACTIONS(4578),
    [sym_align] = ACTIONS(4578),
    [sym_auto] = ACTIONS(4578),
    [sym_catch] = ACTIONS(4578),
    [sym_class] = ACTIONS(4578),
    [sym_const] = ACTIONS(4578),
    [sym_debug] = ACTIONS(4578),
    [sym_deprecated] = ACTIONS(4578),
    [sym_else] = ACTIONS(4578),
    [sym_enum] = ACTIONS(4578),
    [sym_export] = ACTIONS(4578),
    [sym_extern] = ACTIONS(4578),
    [sym_final] = ACTIONS(4578),
    [sym_finally] = ACTIONS(4578),
    [sym_immutable] = ACTIONS(4578),
    [sym_import] = ACTIONS(4578),
    [sym_inout] = ACTIONS(4578),
    [sym_interface] = ACTIONS(4578),
    [sym_invariant] = ACTIONS(4578),
    [sym_mixin] = ACTIONS(4578),
    [sym_nothrow] = ACTIONS(4578),
    [sym_override] = ACTIONS(4578),
    [sym_package] = ACTIONS(4578),
    [sym_pragma] = ACTIONS(4578),
    [sym_private] = ACTIONS(4578),
    [sym_protected] = ACTIONS(4578),
    [sym_public] = ACTIONS(4578),
    [sym_pure] = ACTIONS(4578),
    [sym_ref] = ACTIONS(4578),
    [sym_return] = ACTIONS(4578),
    [sym_scope] = ACTIONS(4578),
    [sym_shared] = ACTIONS(4578),
    [sym_static] = ACTIONS(4578),
    [sym_struct] = ACTIONS(4578),
    [sym_synchronized] = ACTIONS(4578),
    [sym_template] = ACTIONS(4578),
    [sym_typeof] = ACTIONS(4578),
    [sym_union] = ACTIONS(4578),
    [sym_unittest] = ACTIONS(4578),
    [sym_version] = ACTIONS(4578),
    [sym_while] = ACTIONS(4578),
    [sym_gshared] = ACTIONS(4578),
    [sym_traits] = ACTIONS(4578),
    [sym_vector] = ACTIONS(4578),
    [sym_void] = ACTIONS(4578),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2331] = {
    [sym_identifier] = ACTIONS(4733),
    [anon_sym_DOT] = ACTIONS(4735),
    [anon_sym_SEMI] = ACTIONS(4735),
    [anon_sym_TILDE] = ACTIONS(4735),
    [anon_sym_AT] = ACTIONS(4735),
    [sym_bool] = ACTIONS(4733),
    [sym_byte] = ACTIONS(4733),
    [sym_ubyte] = ACTIONS(4733),
    [sym_char] = ACTIONS(4733),
    [sym_short] = ACTIONS(4733),
    [sym_ushort] = ACTIONS(4733),
    [sym_int] = ACTIONS(4733),
    [sym_uint] = ACTIONS(4733),
    [sym_long] = ACTIONS(4733),
    [sym_ulong] = ACTIONS(4733),
    [sym_cent] = ACTIONS(4733),
    [sym_ucent] = ACTIONS(4733),
    [sym_wchar] = ACTIONS(4733),
    [sym_dchar] = ACTIONS(4733),
    [sym_float] = ACTIONS(4733),
    [sym_double] = ACTIONS(4733),
    [sym_real] = ACTIONS(4733),
    [sym_ifloat] = ACTIONS(4733),
    [sym_idouble] = ACTIONS(4733),
    [sym_ireal] = ACTIONS(4733),
    [sym_cfloat] = ACTIONS(4733),
    [sym_cdouble] = ACTIONS(4733),
    [sym_creal] = ACTIONS(4733),
    [sym_size_t] = ACTIONS(4733),
    [sym_ptrdiff_t] = ACTIONS(4733),
    [sym_string] = ACTIONS(4733),
    [sym_cstring] = ACTIONS(4733),
    [sym_dstring] = ACTIONS(4733),
    [sym_wstring] = ACTIONS(4733),
    [sym_noreturn] = ACTIONS(4733),
    [sym_this] = ACTIONS(4733),
    [sym_abstract] = ACTIONS(4733),
    [sym_alias] = ACTIONS(4733),
    [sym_align] = ACTIONS(4733),
    [sym_auto] = ACTIONS(4733),
    [sym_catch] = ACTIONS(4733),
    [sym_class] = ACTIONS(4733),
    [sym_const] = ACTIONS(4733),
    [sym_debug] = ACTIONS(4733),
    [sym_deprecated] = ACTIONS(4733),
    [sym_else] = ACTIONS(4733),
    [sym_enum] = ACTIONS(4733),
    [sym_export] = ACTIONS(4733),
    [sym_extern] = ACTIONS(4733),
    [sym_final] = ACTIONS(4733),
    [sym_finally] = ACTIONS(4733),
    [sym_immutable] = ACTIONS(4733),
    [sym_import] = ACTIONS(4733),
    [sym_inout] = ACTIONS(4733),
    [sym_interface] = ACTIONS(4733),
    [sym_invariant] = ACTIONS(4733),
    [sym_mixin] = ACTIONS(4733),
    [sym_nothrow] = ACTIONS(4733),
    [sym_override] = ACTIONS(4733),
    [sym_package] = ACTIONS(4733),
    [sym_pragma] = ACTIONS(4733),
    [sym_private] = ACTIONS(4733),
    [sym_protected] = ACTIONS(4733),
    [sym_public] = ACTIONS(4733),
    [sym_pure] = ACTIONS(4733),
    [sym_ref] = ACTIONS(4733),
    [sym_return] = ACTIONS(4733),
    [sym_scope] = ACTIONS(4733),
    [sym_shared] = ACTIONS(4733),
    [sym_static] = ACTIONS(4733),
    [sym_struct] = ACTIONS(4733),
    [sym_synchronized] = ACTIONS(4733),
    [sym_template] = ACTIONS(4733),
    [sym_typeof] = ACTIONS(4733),
    [sym_union] = ACTIONS(4733),
    [sym_unittest] = ACTIONS(4733),
    [sym_version] = ACTIONS(4733),
    [sym_while] = ACTIONS(4733),
    [sym_gshared] = ACTIONS(4733),
    [sym_traits] = ACTIONS(4733),
    [sym_vector] = ACTIONS(4733),
    [sym_void] = ACTIONS(4733),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2332] = {
    [ts_builtin_sym_end] = ACTIONS(4468),
    [sym_identifier] = ACTIONS(4466),
    [anon_sym_RBRACE] = ACTIONS(4468),
    [anon_sym_DOT] = ACTIONS(4468),
    [anon_sym_SEMI] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [anon_sym_AT] = ACTIONS(4468),
    [sym_bool] = ACTIONS(4466),
    [sym_byte] = ACTIONS(4466),
    [sym_ubyte] = ACTIONS(4466),
    [sym_char] = ACTIONS(4466),
    [sym_short] = ACTIONS(4466),
    [sym_ushort] = ACTIONS(4466),
    [sym_int] = ACTIONS(4466),
    [sym_uint] = ACTIONS(4466),
    [sym_long] = ACTIONS(4466),
    [sym_ulong] = ACTIONS(4466),
    [sym_cent] = ACTIONS(4466),
    [sym_ucent] = ACTIONS(4466),
    [sym_wchar] = ACTIONS(4466),
    [sym_dchar] = ACTIONS(4466),
    [sym_float] = ACTIONS(4466),
    [sym_double] = ACTIONS(4466),
    [sym_real] = ACTIONS(4466),
    [sym_ifloat] = ACTIONS(4466),
    [sym_idouble] = ACTIONS(4466),
    [sym_ireal] = ACTIONS(4466),
    [sym_cfloat] = ACTIONS(4466),
    [sym_cdouble] = ACTIONS(4466),
    [sym_creal] = ACTIONS(4466),
    [sym_size_t] = ACTIONS(4466),
    [sym_ptrdiff_t] = ACTIONS(4466),
    [sym_string] = ACTIONS(4466),
    [sym_cstring] = ACTIONS(4466),
    [sym_dstring] = ACTIONS(4466),
    [sym_wstring] = ACTIONS(4466),
    [sym_noreturn] = ACTIONS(4466),
    [sym_this] = ACTIONS(4466),
    [sym_abstract] = ACTIONS(4466),
    [sym_alias] = ACTIONS(4466),
    [sym_align] = ACTIONS(4466),
    [sym_auto] = ACTIONS(4466),
    [sym_class] = ACTIONS(4466),
    [sym_const] = ACTIONS(4466),
    [sym_debug] = ACTIONS(4466),
    [sym_deprecated] = ACTIONS(4466),
    [sym_else] = ACTIONS(4466),
    [sym_enum] = ACTIONS(4466),
    [sym_export] = ACTIONS(4466),
    [sym_extern] = ACTIONS(4466),
    [sym_final] = ACTIONS(4466),
    [sym_immutable] = ACTIONS(4466),
    [sym_import] = ACTIONS(4466),
    [sym_inout] = ACTIONS(4466),
    [sym_interface] = ACTIONS(4466),
    [sym_invariant] = ACTIONS(4466),
    [sym_mixin] = ACTIONS(4466),
    [sym_nothrow] = ACTIONS(4466),
    [sym_override] = ACTIONS(4466),
    [sym_package] = ACTIONS(4466),
    [sym_pragma] = ACTIONS(4466),
    [sym_private] = ACTIONS(4466),
    [sym_protected] = ACTIONS(4466),
    [sym_public] = ACTIONS(4466),
    [sym_pure] = ACTIONS(4466),
    [sym_ref] = ACTIONS(4466),
    [sym_return] = ACTIONS(4466),
    [sym_scope] = ACTIONS(4466),
    [sym_shared] = ACTIONS(4466),
    [sym_static] = ACTIONS(4466),
    [sym_struct] = ACTIONS(4466),
    [sym_synchronized] = ACTIONS(4466),
    [sym_template] = ACTIONS(4466),
    [sym_typeof] = ACTIONS(4466),
    [sym_union] = ACTIONS(4466),
    [sym_unittest] = ACTIONS(4466),
    [sym_version] = ACTIONS(4466),
    [sym_while] = ACTIONS(4466),
    [sym_gshared] = ACTIONS(4466),
    [sym_traits] = ACTIONS(4466),
    [sym_vector] = ACTIONS(4466),
    [sym_void] = ACTIONS(4466),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2333] = {
    [sym_identifier] = ACTIONS(4440),
    [anon_sym_DOT] = ACTIONS(4442),
    [anon_sym_SEMI] = ACTIONS(4442),
    [anon_sym_TILDE] = ACTIONS(4442),
    [anon_sym_AT] = ACTIONS(4442),
    [sym_bool] = ACTIONS(4440),
    [sym_byte] = ACTIONS(4440),
    [sym_ubyte] = ACTIONS(4440),
    [sym_char] = ACTIONS(4440),
    [sym_short] = ACTIONS(4440),
    [sym_ushort] = ACTIONS(4440),
    [sym_int] = ACTIONS(4440),
    [sym_uint] = ACTIONS(4440),
    [sym_long] = ACTIONS(4440),
    [sym_ulong] = ACTIONS(4440),
    [sym_cent] = ACTIONS(4440),
    [sym_ucent] = ACTIONS(4440),
    [sym_wchar] = ACTIONS(4440),
    [sym_dchar] = ACTIONS(4440),
    [sym_float] = ACTIONS(4440),
    [sym_double] = ACTIONS(4440),
    [sym_real] = ACTIONS(4440),
    [sym_ifloat] = ACTIONS(4440),
    [sym_idouble] = ACTIONS(4440),
    [sym_ireal] = ACTIONS(4440),
    [sym_cfloat] = ACTIONS(4440),
    [sym_cdouble] = ACTIONS(4440),
    [sym_creal] = ACTIONS(4440),
    [sym_size_t] = ACTIONS(4440),
    [sym_ptrdiff_t] = ACTIONS(4440),
    [sym_string] = ACTIONS(4440),
    [sym_cstring] = ACTIONS(4440),
    [sym_dstring] = ACTIONS(4440),
    [sym_wstring] = ACTIONS(4440),
    [sym_noreturn] = ACTIONS(4440),
    [sym_this] = ACTIONS(4440),
    [sym_abstract] = ACTIONS(4440),
    [sym_alias] = ACTIONS(4440),
    [sym_align] = ACTIONS(4440),
    [sym_auto] = ACTIONS(4440),
    [sym_catch] = ACTIONS(4440),
    [sym_class] = ACTIONS(4440),
    [sym_const] = ACTIONS(4440),
    [sym_debug] = ACTIONS(4440),
    [sym_deprecated] = ACTIONS(4440),
    [sym_else] = ACTIONS(4440),
    [sym_enum] = ACTIONS(4440),
    [sym_export] = ACTIONS(4440),
    [sym_extern] = ACTIONS(4440),
    [sym_final] = ACTIONS(4440),
    [sym_finally] = ACTIONS(4440),
    [sym_immutable] = ACTIONS(4440),
    [sym_import] = ACTIONS(4440),
    [sym_inout] = ACTIONS(4440),
    [sym_interface] = ACTIONS(4440),
    [sym_invariant] = ACTIONS(4440),
    [sym_mixin] = ACTIONS(4440),
    [sym_nothrow] = ACTIONS(4440),
    [sym_override] = ACTIONS(4440),
    [sym_package] = ACTIONS(4440),
    [sym_pragma] = ACTIONS(4440),
    [sym_private] = ACTIONS(4440),
    [sym_protected] = ACTIONS(4440),
    [sym_public] = ACTIONS(4440),
    [sym_pure] = ACTIONS(4440),
    [sym_ref] = ACTIONS(4440),
    [sym_return] = ACTIONS(4440),
    [sym_scope] = ACTIONS(4440),
    [sym_shared] = ACTIONS(4440),
    [sym_static] = ACTIONS(4440),
    [sym_struct] = ACTIONS(4440),
    [sym_synchronized] = ACTIONS(4440),
    [sym_template] = ACTIONS(4440),
    [sym_typeof] = ACTIONS(4440),
    [sym_union] = ACTIONS(4440),
    [sym_unittest] = ACTIONS(4440),
    [sym_version] = ACTIONS(4440),
    [sym_while] = ACTIONS(4440),
    [sym_gshared] = ACTIONS(4440),
    [sym_traits] = ACTIONS(4440),
    [sym_vector] = ACTIONS(4440),
    [sym_void] = ACTIONS(4440),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2334] = {
    [sym_identifier] = ACTIONS(4590),
    [anon_sym_DOT] = ACTIONS(4592),
    [anon_sym_SEMI] = ACTIONS(4592),
    [anon_sym_TILDE] = ACTIONS(4592),
    [anon_sym_AT] = ACTIONS(4592),
    [sym_bool] = ACTIONS(4590),
    [sym_byte] = ACTIONS(4590),
    [sym_ubyte] = ACTIONS(4590),
    [sym_char] = ACTIONS(4590),
    [sym_short] = ACTIONS(4590),
    [sym_ushort] = ACTIONS(4590),
    [sym_int] = ACTIONS(4590),
    [sym_uint] = ACTIONS(4590),
    [sym_long] = ACTIONS(4590),
    [sym_ulong] = ACTIONS(4590),
    [sym_cent] = ACTIONS(4590),
    [sym_ucent] = ACTIONS(4590),
    [sym_wchar] = ACTIONS(4590),
    [sym_dchar] = ACTIONS(4590),
    [sym_float] = ACTIONS(4590),
    [sym_double] = ACTIONS(4590),
    [sym_real] = ACTIONS(4590),
    [sym_ifloat] = ACTIONS(4590),
    [sym_idouble] = ACTIONS(4590),
    [sym_ireal] = ACTIONS(4590),
    [sym_cfloat] = ACTIONS(4590),
    [sym_cdouble] = ACTIONS(4590),
    [sym_creal] = ACTIONS(4590),
    [sym_size_t] = ACTIONS(4590),
    [sym_ptrdiff_t] = ACTIONS(4590),
    [sym_string] = ACTIONS(4590),
    [sym_cstring] = ACTIONS(4590),
    [sym_dstring] = ACTIONS(4590),
    [sym_wstring] = ACTIONS(4590),
    [sym_noreturn] = ACTIONS(4590),
    [sym_this] = ACTIONS(4590),
    [sym_abstract] = ACTIONS(4590),
    [sym_alias] = ACTIONS(4590),
    [sym_align] = ACTIONS(4590),
    [sym_auto] = ACTIONS(4590),
    [sym_catch] = ACTIONS(4590),
    [sym_class] = ACTIONS(4590),
    [sym_const] = ACTIONS(4590),
    [sym_debug] = ACTIONS(4590),
    [sym_deprecated] = ACTIONS(4590),
    [sym_else] = ACTIONS(4590),
    [sym_enum] = ACTIONS(4590),
    [sym_export] = ACTIONS(4590),
    [sym_extern] = ACTIONS(4590),
    [sym_final] = ACTIONS(4590),
    [sym_finally] = ACTIONS(4590),
    [sym_immutable] = ACTIONS(4590),
    [sym_import] = ACTIONS(4590),
    [sym_inout] = ACTIONS(4590),
    [sym_interface] = ACTIONS(4590),
    [sym_invariant] = ACTIONS(4590),
    [sym_mixin] = ACTIONS(4590),
    [sym_nothrow] = ACTIONS(4590),
    [sym_override] = ACTIONS(4590),
    [sym_package] = ACTIONS(4590),
    [sym_pragma] = ACTIONS(4590),
    [sym_private] = ACTIONS(4590),
    [sym_protected] = ACTIONS(4590),
    [sym_public] = ACTIONS(4590),
    [sym_pure] = ACTIONS(4590),
    [sym_ref] = ACTIONS(4590),
    [sym_return] = ACTIONS(4590),
    [sym_scope] = ACTIONS(4590),
    [sym_shared] = ACTIONS(4590),
    [sym_static] = ACTIONS(4590),
    [sym_struct] = ACTIONS(4590),
    [sym_synchronized] = ACTIONS(4590),
    [sym_template] = ACTIONS(4590),
    [sym_typeof] = ACTIONS(4590),
    [sym_union] = ACTIONS(4590),
    [sym_unittest] = ACTIONS(4590),
    [sym_version] = ACTIONS(4590),
    [sym_while] = ACTIONS(4590),
    [sym_gshared] = ACTIONS(4590),
    [sym_traits] = ACTIONS(4590),
    [sym_vector] = ACTIONS(4590),
    [sym_void] = ACTIONS(4590),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2335] = {
    [ts_builtin_sym_end] = ACTIONS(2636),
    [sym_identifier] = ACTIONS(2638),
    [anon_sym_RBRACE] = ACTIONS(2636),
    [anon_sym_DOT] = ACTIONS(2636),
    [anon_sym_SEMI] = ACTIONS(2636),
    [anon_sym_TILDE] = ACTIONS(2636),
    [anon_sym_AT] = ACTIONS(2636),
    [sym_bool] = ACTIONS(2638),
    [sym_byte] = ACTIONS(2638),
    [sym_ubyte] = ACTIONS(2638),
    [sym_char] = ACTIONS(2638),
    [sym_short] = ACTIONS(2638),
    [sym_ushort] = ACTIONS(2638),
    [sym_int] = ACTIONS(2638),
    [sym_uint] = ACTIONS(2638),
    [sym_long] = ACTIONS(2638),
    [sym_ulong] = ACTIONS(2638),
    [sym_cent] = ACTIONS(2638),
    [sym_ucent] = ACTIONS(2638),
    [sym_wchar] = ACTIONS(2638),
    [sym_dchar] = ACTIONS(2638),
    [sym_float] = ACTIONS(2638),
    [sym_double] = ACTIONS(2638),
    [sym_real] = ACTIONS(2638),
    [sym_ifloat] = ACTIONS(2638),
    [sym_idouble] = ACTIONS(2638),
    [sym_ireal] = ACTIONS(2638),
    [sym_cfloat] = ACTIONS(2638),
    [sym_cdouble] = ACTIONS(2638),
    [sym_creal] = ACTIONS(2638),
    [sym_size_t] = ACTIONS(2638),
    [sym_ptrdiff_t] = ACTIONS(2638),
    [sym_string] = ACTIONS(2638),
    [sym_cstring] = ACTIONS(2638),
    [sym_dstring] = ACTIONS(2638),
    [sym_wstring] = ACTIONS(2638),
    [sym_noreturn] = ACTIONS(2638),
    [sym_this] = ACTIONS(2638),
    [sym_abstract] = ACTIONS(2638),
    [sym_alias] = ACTIONS(2638),
    [sym_align] = ACTIONS(2638),
    [sym_auto] = ACTIONS(2638),
    [sym_class] = ACTIONS(2638),
    [sym_const] = ACTIONS(2638),
    [sym_debug] = ACTIONS(2638),
    [sym_deprecated] = ACTIONS(2638),
    [sym_else] = ACTIONS(2638),
    [sym_enum] = ACTIONS(2638),
    [sym_export] = ACTIONS(2638),
    [sym_extern] = ACTIONS(2638),
    [sym_final] = ACTIONS(2638),
    [sym_immutable] = ACTIONS(2638),
    [sym_import] = ACTIONS(2638),
    [sym_inout] = ACTIONS(2638),
    [sym_interface] = ACTIONS(2638),
    [sym_invariant] = ACTIONS(2638),
    [sym_mixin] = ACTIONS(2638),
    [sym_nothrow] = ACTIONS(2638),
    [sym_override] = ACTIONS(2638),
    [sym_package] = ACTIONS(2638),
    [sym_pragma] = ACTIONS(2638),
    [sym_private] = ACTIONS(2638),
    [sym_protected] = ACTIONS(2638),
    [sym_public] = ACTIONS(2638),
    [sym_pure] = ACTIONS(2638),
    [sym_ref] = ACTIONS(2638),
    [sym_return] = ACTIONS(2638),
    [sym_scope] = ACTIONS(2638),
    [sym_shared] = ACTIONS(2638),
    [sym_static] = ACTIONS(2638),
    [sym_struct] = ACTIONS(2638),
    [sym_synchronized] = ACTIONS(2638),
    [sym_template] = ACTIONS(2638),
    [sym_typeof] = ACTIONS(2638),
    [sym_union] = ACTIONS(2638),
    [sym_unittest] = ACTIONS(2638),
    [sym_version] = ACTIONS(2638),
    [sym_while] = ACTIONS(2638),
    [sym_gshared] = ACTIONS(2638),
    [sym_traits] = ACTIONS(2638),
    [sym_vector] = ACTIONS(2638),
    [sym_void] = ACTIONS(2638),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2336] = {
    [ts_builtin_sym_end] = ACTIONS(2632),
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_RBRACE] = ACTIONS(2632),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [sym_bool] = ACTIONS(2634),
    [sym_byte] = ACTIONS(2634),
    [sym_ubyte] = ACTIONS(2634),
    [sym_char] = ACTIONS(2634),
    [sym_short] = ACTIONS(2634),
    [sym_ushort] = ACTIONS(2634),
    [sym_int] = ACTIONS(2634),
    [sym_uint] = ACTIONS(2634),
    [sym_long] = ACTIONS(2634),
    [sym_ulong] = ACTIONS(2634),
    [sym_cent] = ACTIONS(2634),
    [sym_ucent] = ACTIONS(2634),
    [sym_wchar] = ACTIONS(2634),
    [sym_dchar] = ACTIONS(2634),
    [sym_float] = ACTIONS(2634),
    [sym_double] = ACTIONS(2634),
    [sym_real] = ACTIONS(2634),
    [sym_ifloat] = ACTIONS(2634),
    [sym_idouble] = ACTIONS(2634),
    [sym_ireal] = ACTIONS(2634),
    [sym_cfloat] = ACTIONS(2634),
    [sym_cdouble] = ACTIONS(2634),
    [sym_creal] = ACTIONS(2634),
    [sym_size_t] = ACTIONS(2634),
    [sym_ptrdiff_t] = ACTIONS(2634),
    [sym_string] = ACTIONS(2634),
    [sym_cstring] = ACTIONS(2634),
    [sym_dstring] = ACTIONS(2634),
    [sym_wstring] = ACTIONS(2634),
    [sym_noreturn] = ACTIONS(2634),
    [sym_this] = ACTIONS(2634),
    [sym_abstract] = ACTIONS(2634),
    [sym_alias] = ACTIONS(2634),
    [sym_align] = ACTIONS(2634),
    [sym_auto] = ACTIONS(2634),
    [sym_class] = ACTIONS(2634),
    [sym_const] = ACTIONS(2634),
    [sym_debug] = ACTIONS(2634),
    [sym_deprecated] = ACTIONS(2634),
    [sym_else] = ACTIONS(6078),
    [sym_enum] = ACTIONS(2634),
    [sym_export] = ACTIONS(2634),
    [sym_extern] = ACTIONS(2634),
    [sym_final] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(2634),
    [sym_import] = ACTIONS(2634),
    [sym_inout] = ACTIONS(2634),
    [sym_interface] = ACTIONS(2634),
    [sym_invariant] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2634),
    [sym_nothrow] = ACTIONS(2634),
    [sym_override] = ACTIONS(2634),
    [sym_package] = ACTIONS(2634),
    [sym_pragma] = ACTIONS(2634),
    [sym_private] = ACTIONS(2634),
    [sym_protected] = ACTIONS(2634),
    [sym_public] = ACTIONS(2634),
    [sym_pure] = ACTIONS(2634),
    [sym_ref] = ACTIONS(2634),
    [sym_return] = ACTIONS(2634),
    [sym_scope] = ACTIONS(2634),
    [sym_shared] = ACTIONS(2634),
    [sym_static] = ACTIONS(2634),
    [sym_struct] = ACTIONS(2634),
    [sym_synchronized] = ACTIONS(2634),
    [sym_template] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(2634),
    [sym_union] = ACTIONS(2634),
    [sym_unittest] = ACTIONS(2634),
    [sym_version] = ACTIONS(2634),
    [sym_while] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(2634),
    [sym_traits] = ACTIONS(2634),
    [sym_vector] = ACTIONS(2634),
    [sym_void] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2337] = {
    [ts_builtin_sym_end] = ACTIONS(4973),
    [sym_identifier] = ACTIONS(4971),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_DOT] = ACTIONS(4973),
    [anon_sym_SEMI] = ACTIONS(4973),
    [anon_sym_TILDE] = ACTIONS(4973),
    [anon_sym_AT] = ACTIONS(4973),
    [sym_bool] = ACTIONS(4971),
    [sym_byte] = ACTIONS(4971),
    [sym_ubyte] = ACTIONS(4971),
    [sym_char] = ACTIONS(4971),
    [sym_short] = ACTIONS(4971),
    [sym_ushort] = ACTIONS(4971),
    [sym_int] = ACTIONS(4971),
    [sym_uint] = ACTIONS(4971),
    [sym_long] = ACTIONS(4971),
    [sym_ulong] = ACTIONS(4971),
    [sym_cent] = ACTIONS(4971),
    [sym_ucent] = ACTIONS(4971),
    [sym_wchar] = ACTIONS(4971),
    [sym_dchar] = ACTIONS(4971),
    [sym_float] = ACTIONS(4971),
    [sym_double] = ACTIONS(4971),
    [sym_real] = ACTIONS(4971),
    [sym_ifloat] = ACTIONS(4971),
    [sym_idouble] = ACTIONS(4971),
    [sym_ireal] = ACTIONS(4971),
    [sym_cfloat] = ACTIONS(4971),
    [sym_cdouble] = ACTIONS(4971),
    [sym_creal] = ACTIONS(4971),
    [sym_size_t] = ACTIONS(4971),
    [sym_ptrdiff_t] = ACTIONS(4971),
    [sym_string] = ACTIONS(4971),
    [sym_cstring] = ACTIONS(4971),
    [sym_dstring] = ACTIONS(4971),
    [sym_wstring] = ACTIONS(4971),
    [sym_noreturn] = ACTIONS(4971),
    [sym_this] = ACTIONS(4971),
    [sym_abstract] = ACTIONS(4971),
    [sym_alias] = ACTIONS(4971),
    [sym_align] = ACTIONS(4971),
    [sym_auto] = ACTIONS(4971),
    [sym_class] = ACTIONS(4971),
    [sym_const] = ACTIONS(4971),
    [sym_debug] = ACTIONS(4971),
    [sym_deprecated] = ACTIONS(4971),
    [sym_else] = ACTIONS(4971),
    [sym_enum] = ACTIONS(4971),
    [sym_export] = ACTIONS(4971),
    [sym_extern] = ACTIONS(4971),
    [sym_final] = ACTIONS(4971),
    [sym_immutable] = ACTIONS(4971),
    [sym_import] = ACTIONS(4971),
    [sym_inout] = ACTIONS(4971),
    [sym_interface] = ACTIONS(4971),
    [sym_invariant] = ACTIONS(4971),
    [sym_mixin] = ACTIONS(4971),
    [sym_nothrow] = ACTIONS(4971),
    [sym_override] = ACTIONS(4971),
    [sym_package] = ACTIONS(4971),
    [sym_pragma] = ACTIONS(4971),
    [sym_private] = ACTIONS(4971),
    [sym_protected] = ACTIONS(4971),
    [sym_public] = ACTIONS(4971),
    [sym_pure] = ACTIONS(4971),
    [sym_ref] = ACTIONS(4971),
    [sym_return] = ACTIONS(4971),
    [sym_scope] = ACTIONS(4971),
    [sym_shared] = ACTIONS(4971),
    [sym_static] = ACTIONS(4971),
    [sym_struct] = ACTIONS(4971),
    [sym_synchronized] = ACTIONS(4971),
    [sym_template] = ACTIONS(4971),
    [sym_typeof] = ACTIONS(4971),
    [sym_union] = ACTIONS(4971),
    [sym_unittest] = ACTIONS(4971),
    [sym_version] = ACTIONS(4971),
    [sym_while] = ACTIONS(4971),
    [sym_gshared] = ACTIONS(4971),
    [sym_traits] = ACTIONS(4971),
    [sym_vector] = ACTIONS(4971),
    [sym_void] = ACTIONS(4971),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2338] = {
    [ts_builtin_sym_end] = ACTIONS(4963),
    [sym_identifier] = ACTIONS(4961),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [anon_sym_DOT] = ACTIONS(4963),
    [anon_sym_SEMI] = ACTIONS(4963),
    [anon_sym_TILDE] = ACTIONS(4963),
    [anon_sym_AT] = ACTIONS(4963),
    [sym_bool] = ACTIONS(4961),
    [sym_byte] = ACTIONS(4961),
    [sym_ubyte] = ACTIONS(4961),
    [sym_char] = ACTIONS(4961),
    [sym_short] = ACTIONS(4961),
    [sym_ushort] = ACTIONS(4961),
    [sym_int] = ACTIONS(4961),
    [sym_uint] = ACTIONS(4961),
    [sym_long] = ACTIONS(4961),
    [sym_ulong] = ACTIONS(4961),
    [sym_cent] = ACTIONS(4961),
    [sym_ucent] = ACTIONS(4961),
    [sym_wchar] = ACTIONS(4961),
    [sym_dchar] = ACTIONS(4961),
    [sym_float] = ACTIONS(4961),
    [sym_double] = ACTIONS(4961),
    [sym_real] = ACTIONS(4961),
    [sym_ifloat] = ACTIONS(4961),
    [sym_idouble] = ACTIONS(4961),
    [sym_ireal] = ACTIONS(4961),
    [sym_cfloat] = ACTIONS(4961),
    [sym_cdouble] = ACTIONS(4961),
    [sym_creal] = ACTIONS(4961),
    [sym_size_t] = ACTIONS(4961),
    [sym_ptrdiff_t] = ACTIONS(4961),
    [sym_string] = ACTIONS(4961),
    [sym_cstring] = ACTIONS(4961),
    [sym_dstring] = ACTIONS(4961),
    [sym_wstring] = ACTIONS(4961),
    [sym_noreturn] = ACTIONS(4961),
    [sym_this] = ACTIONS(4961),
    [sym_abstract] = ACTIONS(4961),
    [sym_alias] = ACTIONS(4961),
    [sym_align] = ACTIONS(4961),
    [sym_auto] = ACTIONS(4961),
    [sym_class] = ACTIONS(4961),
    [sym_const] = ACTIONS(4961),
    [sym_debug] = ACTIONS(4961),
    [sym_deprecated] = ACTIONS(4961),
    [sym_else] = ACTIONS(4961),
    [sym_enum] = ACTIONS(4961),
    [sym_export] = ACTIONS(4961),
    [sym_extern] = ACTIONS(4961),
    [sym_final] = ACTIONS(4961),
    [sym_immutable] = ACTIONS(4961),
    [sym_import] = ACTIONS(4961),
    [sym_inout] = ACTIONS(4961),
    [sym_interface] = ACTIONS(4961),
    [sym_invariant] = ACTIONS(4961),
    [sym_mixin] = ACTIONS(4961),
    [sym_nothrow] = ACTIONS(4961),
    [sym_override] = ACTIONS(4961),
    [sym_package] = ACTIONS(4961),
    [sym_pragma] = ACTIONS(4961),
    [sym_private] = ACTIONS(4961),
    [sym_protected] = ACTIONS(4961),
    [sym_public] = ACTIONS(4961),
    [sym_pure] = ACTIONS(4961),
    [sym_ref] = ACTIONS(4961),
    [sym_return] = ACTIONS(4961),
    [sym_scope] = ACTIONS(4961),
    [sym_shared] = ACTIONS(4961),
    [sym_static] = ACTIONS(4961),
    [sym_struct] = ACTIONS(4961),
    [sym_synchronized] = ACTIONS(4961),
    [sym_template] = ACTIONS(4961),
    [sym_typeof] = ACTIONS(4961),
    [sym_union] = ACTIONS(4961),
    [sym_unittest] = ACTIONS(4961),
    [sym_version] = ACTIONS(4961),
    [sym_while] = ACTIONS(4961),
    [sym_gshared] = ACTIONS(4961),
    [sym_traits] = ACTIONS(4961),
    [sym_vector] = ACTIONS(4961),
    [sym_void] = ACTIONS(4961),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2339] = {
    [ts_builtin_sym_end] = ACTIONS(4861),
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [anon_sym_DOT] = ACTIONS(4861),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_AT] = ACTIONS(4861),
    [sym_bool] = ACTIONS(4859),
    [sym_byte] = ACTIONS(4859),
    [sym_ubyte] = ACTIONS(4859),
    [sym_char] = ACTIONS(4859),
    [sym_short] = ACTIONS(4859),
    [sym_ushort] = ACTIONS(4859),
    [sym_int] = ACTIONS(4859),
    [sym_uint] = ACTIONS(4859),
    [sym_long] = ACTIONS(4859),
    [sym_ulong] = ACTIONS(4859),
    [sym_cent] = ACTIONS(4859),
    [sym_ucent] = ACTIONS(4859),
    [sym_wchar] = ACTIONS(4859),
    [sym_dchar] = ACTIONS(4859),
    [sym_float] = ACTIONS(4859),
    [sym_double] = ACTIONS(4859),
    [sym_real] = ACTIONS(4859),
    [sym_ifloat] = ACTIONS(4859),
    [sym_idouble] = ACTIONS(4859),
    [sym_ireal] = ACTIONS(4859),
    [sym_cfloat] = ACTIONS(4859),
    [sym_cdouble] = ACTIONS(4859),
    [sym_creal] = ACTIONS(4859),
    [sym_size_t] = ACTIONS(4859),
    [sym_ptrdiff_t] = ACTIONS(4859),
    [sym_string] = ACTIONS(4859),
    [sym_cstring] = ACTIONS(4859),
    [sym_dstring] = ACTIONS(4859),
    [sym_wstring] = ACTIONS(4859),
    [sym_noreturn] = ACTIONS(4859),
    [sym_this] = ACTIONS(4859),
    [sym_abstract] = ACTIONS(4859),
    [sym_alias] = ACTIONS(4859),
    [sym_align] = ACTIONS(4859),
    [sym_auto] = ACTIONS(4859),
    [sym_class] = ACTIONS(4859),
    [sym_const] = ACTIONS(4859),
    [sym_debug] = ACTIONS(4859),
    [sym_deprecated] = ACTIONS(4859),
    [sym_else] = ACTIONS(4859),
    [sym_enum] = ACTIONS(4859),
    [sym_export] = ACTIONS(4859),
    [sym_extern] = ACTIONS(4859),
    [sym_final] = ACTIONS(4859),
    [sym_immutable] = ACTIONS(4859),
    [sym_import] = ACTIONS(4859),
    [sym_inout] = ACTIONS(4859),
    [sym_interface] = ACTIONS(4859),
    [sym_invariant] = ACTIONS(4859),
    [sym_mixin] = ACTIONS(4859),
    [sym_nothrow] = ACTIONS(4859),
    [sym_override] = ACTIONS(4859),
    [sym_package] = ACTIONS(4859),
    [sym_pragma] = ACTIONS(4859),
    [sym_private] = ACTIONS(4859),
    [sym_protected] = ACTIONS(4859),
    [sym_public] = ACTIONS(4859),
    [sym_pure] = ACTIONS(4859),
    [sym_ref] = ACTIONS(4859),
    [sym_return] = ACTIONS(4859),
    [sym_scope] = ACTIONS(4859),
    [sym_shared] = ACTIONS(4859),
    [sym_static] = ACTIONS(4859),
    [sym_struct] = ACTIONS(4859),
    [sym_synchronized] = ACTIONS(4859),
    [sym_template] = ACTIONS(4859),
    [sym_typeof] = ACTIONS(4859),
    [sym_union] = ACTIONS(4859),
    [sym_unittest] = ACTIONS(4859),
    [sym_version] = ACTIONS(4859),
    [sym_while] = ACTIONS(4859),
    [sym_gshared] = ACTIONS(4859),
    [sym_traits] = ACTIONS(4859),
    [sym_vector] = ACTIONS(4859),
    [sym_void] = ACTIONS(4859),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2340] = {
    [sym_switch_statement] = STATE(1495),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(361),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2341] = {
    [sym_identifier] = ACTIONS(4755),
    [anon_sym_DOT] = ACTIONS(4757),
    [anon_sym_SEMI] = ACTIONS(4757),
    [anon_sym_TILDE] = ACTIONS(4757),
    [anon_sym_AT] = ACTIONS(4757),
    [sym_bool] = ACTIONS(4755),
    [sym_byte] = ACTIONS(4755),
    [sym_ubyte] = ACTIONS(4755),
    [sym_char] = ACTIONS(4755),
    [sym_short] = ACTIONS(4755),
    [sym_ushort] = ACTIONS(4755),
    [sym_int] = ACTIONS(4755),
    [sym_uint] = ACTIONS(4755),
    [sym_long] = ACTIONS(4755),
    [sym_ulong] = ACTIONS(4755),
    [sym_cent] = ACTIONS(4755),
    [sym_ucent] = ACTIONS(4755),
    [sym_wchar] = ACTIONS(4755),
    [sym_dchar] = ACTIONS(4755),
    [sym_float] = ACTIONS(4755),
    [sym_double] = ACTIONS(4755),
    [sym_real] = ACTIONS(4755),
    [sym_ifloat] = ACTIONS(4755),
    [sym_idouble] = ACTIONS(4755),
    [sym_ireal] = ACTIONS(4755),
    [sym_cfloat] = ACTIONS(4755),
    [sym_cdouble] = ACTIONS(4755),
    [sym_creal] = ACTIONS(4755),
    [sym_size_t] = ACTIONS(4755),
    [sym_ptrdiff_t] = ACTIONS(4755),
    [sym_string] = ACTIONS(4755),
    [sym_cstring] = ACTIONS(4755),
    [sym_dstring] = ACTIONS(4755),
    [sym_wstring] = ACTIONS(4755),
    [sym_noreturn] = ACTIONS(4755),
    [sym_this] = ACTIONS(4755),
    [sym_abstract] = ACTIONS(4755),
    [sym_alias] = ACTIONS(4755),
    [sym_align] = ACTIONS(4755),
    [sym_auto] = ACTIONS(4755),
    [sym_catch] = ACTIONS(4755),
    [sym_class] = ACTIONS(4755),
    [sym_const] = ACTIONS(4755),
    [sym_debug] = ACTIONS(4755),
    [sym_deprecated] = ACTIONS(4755),
    [sym_else] = ACTIONS(4755),
    [sym_enum] = ACTIONS(4755),
    [sym_export] = ACTIONS(4755),
    [sym_extern] = ACTIONS(4755),
    [sym_final] = ACTIONS(4755),
    [sym_finally] = ACTIONS(4755),
    [sym_immutable] = ACTIONS(4755),
    [sym_import] = ACTIONS(4755),
    [sym_inout] = ACTIONS(4755),
    [sym_interface] = ACTIONS(4755),
    [sym_invariant] = ACTIONS(4755),
    [sym_mixin] = ACTIONS(4755),
    [sym_nothrow] = ACTIONS(4755),
    [sym_override] = ACTIONS(4755),
    [sym_package] = ACTIONS(4755),
    [sym_pragma] = ACTIONS(4755),
    [sym_private] = ACTIONS(4755),
    [sym_protected] = ACTIONS(4755),
    [sym_public] = ACTIONS(4755),
    [sym_pure] = ACTIONS(4755),
    [sym_ref] = ACTIONS(4755),
    [sym_return] = ACTIONS(4755),
    [sym_scope] = ACTIONS(4755),
    [sym_shared] = ACTIONS(4755),
    [sym_static] = ACTIONS(4755),
    [sym_struct] = ACTIONS(4755),
    [sym_synchronized] = ACTIONS(4755),
    [sym_template] = ACTIONS(4755),
    [sym_typeof] = ACTIONS(4755),
    [sym_union] = ACTIONS(4755),
    [sym_unittest] = ACTIONS(4755),
    [sym_version] = ACTIONS(4755),
    [sym_while] = ACTIONS(4755),
    [sym_gshared] = ACTIONS(4755),
    [sym_traits] = ACTIONS(4755),
    [sym_vector] = ACTIONS(4755),
    [sym_void] = ACTIONS(4755),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2342] = {
    [sym_switch_statement] = STATE(2025),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1322),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2343] = {
    [sym_identifier] = ACTIONS(4797),
    [anon_sym_DOT] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4799),
    [anon_sym_TILDE] = ACTIONS(4799),
    [anon_sym_AT] = ACTIONS(4799),
    [sym_bool] = ACTIONS(4797),
    [sym_byte] = ACTIONS(4797),
    [sym_ubyte] = ACTIONS(4797),
    [sym_char] = ACTIONS(4797),
    [sym_short] = ACTIONS(4797),
    [sym_ushort] = ACTIONS(4797),
    [sym_int] = ACTIONS(4797),
    [sym_uint] = ACTIONS(4797),
    [sym_long] = ACTIONS(4797),
    [sym_ulong] = ACTIONS(4797),
    [sym_cent] = ACTIONS(4797),
    [sym_ucent] = ACTIONS(4797),
    [sym_wchar] = ACTIONS(4797),
    [sym_dchar] = ACTIONS(4797),
    [sym_float] = ACTIONS(4797),
    [sym_double] = ACTIONS(4797),
    [sym_real] = ACTIONS(4797),
    [sym_ifloat] = ACTIONS(4797),
    [sym_idouble] = ACTIONS(4797),
    [sym_ireal] = ACTIONS(4797),
    [sym_cfloat] = ACTIONS(4797),
    [sym_cdouble] = ACTIONS(4797),
    [sym_creal] = ACTIONS(4797),
    [sym_size_t] = ACTIONS(4797),
    [sym_ptrdiff_t] = ACTIONS(4797),
    [sym_string] = ACTIONS(4797),
    [sym_cstring] = ACTIONS(4797),
    [sym_dstring] = ACTIONS(4797),
    [sym_wstring] = ACTIONS(4797),
    [sym_noreturn] = ACTIONS(4797),
    [sym_this] = ACTIONS(4797),
    [sym_abstract] = ACTIONS(4797),
    [sym_alias] = ACTIONS(4797),
    [sym_align] = ACTIONS(4797),
    [sym_auto] = ACTIONS(4797),
    [sym_catch] = ACTIONS(4797),
    [sym_class] = ACTIONS(4797),
    [sym_const] = ACTIONS(4797),
    [sym_debug] = ACTIONS(4797),
    [sym_deprecated] = ACTIONS(4797),
    [sym_else] = ACTIONS(4797),
    [sym_enum] = ACTIONS(4797),
    [sym_export] = ACTIONS(4797),
    [sym_extern] = ACTIONS(4797),
    [sym_final] = ACTIONS(4797),
    [sym_finally] = ACTIONS(4797),
    [sym_immutable] = ACTIONS(4797),
    [sym_import] = ACTIONS(4797),
    [sym_inout] = ACTIONS(4797),
    [sym_interface] = ACTIONS(4797),
    [sym_invariant] = ACTIONS(4797),
    [sym_mixin] = ACTIONS(4797),
    [sym_nothrow] = ACTIONS(4797),
    [sym_override] = ACTIONS(4797),
    [sym_package] = ACTIONS(4797),
    [sym_pragma] = ACTIONS(4797),
    [sym_private] = ACTIONS(4797),
    [sym_protected] = ACTIONS(4797),
    [sym_public] = ACTIONS(4797),
    [sym_pure] = ACTIONS(4797),
    [sym_ref] = ACTIONS(4797),
    [sym_return] = ACTIONS(4797),
    [sym_scope] = ACTIONS(4797),
    [sym_shared] = ACTIONS(4797),
    [sym_static] = ACTIONS(4797),
    [sym_struct] = ACTIONS(4797),
    [sym_synchronized] = ACTIONS(4797),
    [sym_template] = ACTIONS(4797),
    [sym_typeof] = ACTIONS(4797),
    [sym_union] = ACTIONS(4797),
    [sym_unittest] = ACTIONS(4797),
    [sym_version] = ACTIONS(4797),
    [sym_while] = ACTIONS(4797),
    [sym_gshared] = ACTIONS(4797),
    [sym_traits] = ACTIONS(4797),
    [sym_vector] = ACTIONS(4797),
    [sym_void] = ACTIONS(4797),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2344] = {
    [sym_identifier] = ACTIONS(4594),
    [anon_sym_DOT] = ACTIONS(4596),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_TILDE] = ACTIONS(4596),
    [anon_sym_AT] = ACTIONS(4596),
    [sym_bool] = ACTIONS(4594),
    [sym_byte] = ACTIONS(4594),
    [sym_ubyte] = ACTIONS(4594),
    [sym_char] = ACTIONS(4594),
    [sym_short] = ACTIONS(4594),
    [sym_ushort] = ACTIONS(4594),
    [sym_int] = ACTIONS(4594),
    [sym_uint] = ACTIONS(4594),
    [sym_long] = ACTIONS(4594),
    [sym_ulong] = ACTIONS(4594),
    [sym_cent] = ACTIONS(4594),
    [sym_ucent] = ACTIONS(4594),
    [sym_wchar] = ACTIONS(4594),
    [sym_dchar] = ACTIONS(4594),
    [sym_float] = ACTIONS(4594),
    [sym_double] = ACTIONS(4594),
    [sym_real] = ACTIONS(4594),
    [sym_ifloat] = ACTIONS(4594),
    [sym_idouble] = ACTIONS(4594),
    [sym_ireal] = ACTIONS(4594),
    [sym_cfloat] = ACTIONS(4594),
    [sym_cdouble] = ACTIONS(4594),
    [sym_creal] = ACTIONS(4594),
    [sym_size_t] = ACTIONS(4594),
    [sym_ptrdiff_t] = ACTIONS(4594),
    [sym_string] = ACTIONS(4594),
    [sym_cstring] = ACTIONS(4594),
    [sym_dstring] = ACTIONS(4594),
    [sym_wstring] = ACTIONS(4594),
    [sym_noreturn] = ACTIONS(4594),
    [sym_this] = ACTIONS(4594),
    [sym_abstract] = ACTIONS(4594),
    [sym_alias] = ACTIONS(4594),
    [sym_align] = ACTIONS(4594),
    [sym_auto] = ACTIONS(4594),
    [sym_catch] = ACTIONS(4594),
    [sym_class] = ACTIONS(4594),
    [sym_const] = ACTIONS(4594),
    [sym_debug] = ACTIONS(4594),
    [sym_deprecated] = ACTIONS(4594),
    [sym_else] = ACTIONS(4594),
    [sym_enum] = ACTIONS(4594),
    [sym_export] = ACTIONS(4594),
    [sym_extern] = ACTIONS(4594),
    [sym_final] = ACTIONS(4594),
    [sym_finally] = ACTIONS(4594),
    [sym_immutable] = ACTIONS(4594),
    [sym_import] = ACTIONS(4594),
    [sym_inout] = ACTIONS(4594),
    [sym_interface] = ACTIONS(4594),
    [sym_invariant] = ACTIONS(4594),
    [sym_mixin] = ACTIONS(4594),
    [sym_nothrow] = ACTIONS(4594),
    [sym_override] = ACTIONS(4594),
    [sym_package] = ACTIONS(4594),
    [sym_pragma] = ACTIONS(4594),
    [sym_private] = ACTIONS(4594),
    [sym_protected] = ACTIONS(4594),
    [sym_public] = ACTIONS(4594),
    [sym_pure] = ACTIONS(4594),
    [sym_ref] = ACTIONS(4594),
    [sym_return] = ACTIONS(4594),
    [sym_scope] = ACTIONS(4594),
    [sym_shared] = ACTIONS(4594),
    [sym_static] = ACTIONS(4594),
    [sym_struct] = ACTIONS(4594),
    [sym_synchronized] = ACTIONS(4594),
    [sym_template] = ACTIONS(4594),
    [sym_typeof] = ACTIONS(4594),
    [sym_union] = ACTIONS(4594),
    [sym_unittest] = ACTIONS(4594),
    [sym_version] = ACTIONS(4594),
    [sym_while] = ACTIONS(4594),
    [sym_gshared] = ACTIONS(4594),
    [sym_traits] = ACTIONS(4594),
    [sym_vector] = ACTIONS(4594),
    [sym_void] = ACTIONS(4594),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2345] = {
    [ts_builtin_sym_end] = ACTIONS(4919),
    [sym_identifier] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym_DOT] = ACTIONS(4919),
    [anon_sym_SEMI] = ACTIONS(4919),
    [anon_sym_TILDE] = ACTIONS(4919),
    [anon_sym_AT] = ACTIONS(4919),
    [sym_bool] = ACTIONS(4917),
    [sym_byte] = ACTIONS(4917),
    [sym_ubyte] = ACTIONS(4917),
    [sym_char] = ACTIONS(4917),
    [sym_short] = ACTIONS(4917),
    [sym_ushort] = ACTIONS(4917),
    [sym_int] = ACTIONS(4917),
    [sym_uint] = ACTIONS(4917),
    [sym_long] = ACTIONS(4917),
    [sym_ulong] = ACTIONS(4917),
    [sym_cent] = ACTIONS(4917),
    [sym_ucent] = ACTIONS(4917),
    [sym_wchar] = ACTIONS(4917),
    [sym_dchar] = ACTIONS(4917),
    [sym_float] = ACTIONS(4917),
    [sym_double] = ACTIONS(4917),
    [sym_real] = ACTIONS(4917),
    [sym_ifloat] = ACTIONS(4917),
    [sym_idouble] = ACTIONS(4917),
    [sym_ireal] = ACTIONS(4917),
    [sym_cfloat] = ACTIONS(4917),
    [sym_cdouble] = ACTIONS(4917),
    [sym_creal] = ACTIONS(4917),
    [sym_size_t] = ACTIONS(4917),
    [sym_ptrdiff_t] = ACTIONS(4917),
    [sym_string] = ACTIONS(4917),
    [sym_cstring] = ACTIONS(4917),
    [sym_dstring] = ACTIONS(4917),
    [sym_wstring] = ACTIONS(4917),
    [sym_noreturn] = ACTIONS(4917),
    [sym_this] = ACTIONS(4917),
    [sym_abstract] = ACTIONS(4917),
    [sym_alias] = ACTIONS(4917),
    [sym_align] = ACTIONS(4917),
    [sym_auto] = ACTIONS(4917),
    [sym_class] = ACTIONS(4917),
    [sym_const] = ACTIONS(4917),
    [sym_debug] = ACTIONS(4917),
    [sym_deprecated] = ACTIONS(4917),
    [sym_else] = ACTIONS(4917),
    [sym_enum] = ACTIONS(4917),
    [sym_export] = ACTIONS(4917),
    [sym_extern] = ACTIONS(4917),
    [sym_final] = ACTIONS(4917),
    [sym_immutable] = ACTIONS(4917),
    [sym_import] = ACTIONS(4917),
    [sym_inout] = ACTIONS(4917),
    [sym_interface] = ACTIONS(4917),
    [sym_invariant] = ACTIONS(4917),
    [sym_mixin] = ACTIONS(4917),
    [sym_nothrow] = ACTIONS(4917),
    [sym_override] = ACTIONS(4917),
    [sym_package] = ACTIONS(4917),
    [sym_pragma] = ACTIONS(4917),
    [sym_private] = ACTIONS(4917),
    [sym_protected] = ACTIONS(4917),
    [sym_public] = ACTIONS(4917),
    [sym_pure] = ACTIONS(4917),
    [sym_ref] = ACTIONS(4917),
    [sym_return] = ACTIONS(4917),
    [sym_scope] = ACTIONS(4917),
    [sym_shared] = ACTIONS(4917),
    [sym_static] = ACTIONS(4917),
    [sym_struct] = ACTIONS(4917),
    [sym_synchronized] = ACTIONS(4917),
    [sym_template] = ACTIONS(4917),
    [sym_typeof] = ACTIONS(4917),
    [sym_union] = ACTIONS(4917),
    [sym_unittest] = ACTIONS(4917),
    [sym_version] = ACTIONS(4917),
    [sym_while] = ACTIONS(4917),
    [sym_gshared] = ACTIONS(4917),
    [sym_traits] = ACTIONS(4917),
    [sym_vector] = ACTIONS(4917),
    [sym_void] = ACTIONS(4917),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2346] = {
    [sym_identifier] = ACTIONS(4444),
    [anon_sym_DOT] = ACTIONS(4446),
    [anon_sym_SEMI] = ACTIONS(4446),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_AT] = ACTIONS(4446),
    [sym_bool] = ACTIONS(4444),
    [sym_byte] = ACTIONS(4444),
    [sym_ubyte] = ACTIONS(4444),
    [sym_char] = ACTIONS(4444),
    [sym_short] = ACTIONS(4444),
    [sym_ushort] = ACTIONS(4444),
    [sym_int] = ACTIONS(4444),
    [sym_uint] = ACTIONS(4444),
    [sym_long] = ACTIONS(4444),
    [sym_ulong] = ACTIONS(4444),
    [sym_cent] = ACTIONS(4444),
    [sym_ucent] = ACTIONS(4444),
    [sym_wchar] = ACTIONS(4444),
    [sym_dchar] = ACTIONS(4444),
    [sym_float] = ACTIONS(4444),
    [sym_double] = ACTIONS(4444),
    [sym_real] = ACTIONS(4444),
    [sym_ifloat] = ACTIONS(4444),
    [sym_idouble] = ACTIONS(4444),
    [sym_ireal] = ACTIONS(4444),
    [sym_cfloat] = ACTIONS(4444),
    [sym_cdouble] = ACTIONS(4444),
    [sym_creal] = ACTIONS(4444),
    [sym_size_t] = ACTIONS(4444),
    [sym_ptrdiff_t] = ACTIONS(4444),
    [sym_string] = ACTIONS(4444),
    [sym_cstring] = ACTIONS(4444),
    [sym_dstring] = ACTIONS(4444),
    [sym_wstring] = ACTIONS(4444),
    [sym_noreturn] = ACTIONS(4444),
    [sym_this] = ACTIONS(4444),
    [sym_abstract] = ACTIONS(4444),
    [sym_alias] = ACTIONS(4444),
    [sym_align] = ACTIONS(4444),
    [sym_auto] = ACTIONS(4444),
    [sym_catch] = ACTIONS(4444),
    [sym_class] = ACTIONS(4444),
    [sym_const] = ACTIONS(4444),
    [sym_debug] = ACTIONS(4444),
    [sym_deprecated] = ACTIONS(4444),
    [sym_else] = ACTIONS(4444),
    [sym_enum] = ACTIONS(4444),
    [sym_export] = ACTIONS(4444),
    [sym_extern] = ACTIONS(4444),
    [sym_final] = ACTIONS(4444),
    [sym_finally] = ACTIONS(4444),
    [sym_immutable] = ACTIONS(4444),
    [sym_import] = ACTIONS(4444),
    [sym_inout] = ACTIONS(4444),
    [sym_interface] = ACTIONS(4444),
    [sym_invariant] = ACTIONS(4444),
    [sym_mixin] = ACTIONS(4444),
    [sym_nothrow] = ACTIONS(4444),
    [sym_override] = ACTIONS(4444),
    [sym_package] = ACTIONS(4444),
    [sym_pragma] = ACTIONS(4444),
    [sym_private] = ACTIONS(4444),
    [sym_protected] = ACTIONS(4444),
    [sym_public] = ACTIONS(4444),
    [sym_pure] = ACTIONS(4444),
    [sym_ref] = ACTIONS(4444),
    [sym_return] = ACTIONS(4444),
    [sym_scope] = ACTIONS(4444),
    [sym_shared] = ACTIONS(4444),
    [sym_static] = ACTIONS(4444),
    [sym_struct] = ACTIONS(4444),
    [sym_synchronized] = ACTIONS(4444),
    [sym_template] = ACTIONS(4444),
    [sym_typeof] = ACTIONS(4444),
    [sym_union] = ACTIONS(4444),
    [sym_unittest] = ACTIONS(4444),
    [sym_version] = ACTIONS(4444),
    [sym_while] = ACTIONS(4444),
    [sym_gshared] = ACTIONS(4444),
    [sym_traits] = ACTIONS(4444),
    [sym_vector] = ACTIONS(4444),
    [sym_void] = ACTIONS(4444),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2347] = {
    [sym_identifier] = ACTIONS(4801),
    [anon_sym_DOT] = ACTIONS(4803),
    [anon_sym_SEMI] = ACTIONS(4803),
    [anon_sym_TILDE] = ACTIONS(4803),
    [anon_sym_AT] = ACTIONS(4803),
    [sym_bool] = ACTIONS(4801),
    [sym_byte] = ACTIONS(4801),
    [sym_ubyte] = ACTIONS(4801),
    [sym_char] = ACTIONS(4801),
    [sym_short] = ACTIONS(4801),
    [sym_ushort] = ACTIONS(4801),
    [sym_int] = ACTIONS(4801),
    [sym_uint] = ACTIONS(4801),
    [sym_long] = ACTIONS(4801),
    [sym_ulong] = ACTIONS(4801),
    [sym_cent] = ACTIONS(4801),
    [sym_ucent] = ACTIONS(4801),
    [sym_wchar] = ACTIONS(4801),
    [sym_dchar] = ACTIONS(4801),
    [sym_float] = ACTIONS(4801),
    [sym_double] = ACTIONS(4801),
    [sym_real] = ACTIONS(4801),
    [sym_ifloat] = ACTIONS(4801),
    [sym_idouble] = ACTIONS(4801),
    [sym_ireal] = ACTIONS(4801),
    [sym_cfloat] = ACTIONS(4801),
    [sym_cdouble] = ACTIONS(4801),
    [sym_creal] = ACTIONS(4801),
    [sym_size_t] = ACTIONS(4801),
    [sym_ptrdiff_t] = ACTIONS(4801),
    [sym_string] = ACTIONS(4801),
    [sym_cstring] = ACTIONS(4801),
    [sym_dstring] = ACTIONS(4801),
    [sym_wstring] = ACTIONS(4801),
    [sym_noreturn] = ACTIONS(4801),
    [sym_this] = ACTIONS(4801),
    [sym_abstract] = ACTIONS(4801),
    [sym_alias] = ACTIONS(4801),
    [sym_align] = ACTIONS(4801),
    [sym_auto] = ACTIONS(4801),
    [sym_catch] = ACTIONS(4801),
    [sym_class] = ACTIONS(4801),
    [sym_const] = ACTIONS(4801),
    [sym_debug] = ACTIONS(4801),
    [sym_deprecated] = ACTIONS(4801),
    [sym_else] = ACTIONS(4801),
    [sym_enum] = ACTIONS(4801),
    [sym_export] = ACTIONS(4801),
    [sym_extern] = ACTIONS(4801),
    [sym_final] = ACTIONS(4801),
    [sym_finally] = ACTIONS(4801),
    [sym_immutable] = ACTIONS(4801),
    [sym_import] = ACTIONS(4801),
    [sym_inout] = ACTIONS(4801),
    [sym_interface] = ACTIONS(4801),
    [sym_invariant] = ACTIONS(4801),
    [sym_mixin] = ACTIONS(4801),
    [sym_nothrow] = ACTIONS(4801),
    [sym_override] = ACTIONS(4801),
    [sym_package] = ACTIONS(4801),
    [sym_pragma] = ACTIONS(4801),
    [sym_private] = ACTIONS(4801),
    [sym_protected] = ACTIONS(4801),
    [sym_public] = ACTIONS(4801),
    [sym_pure] = ACTIONS(4801),
    [sym_ref] = ACTIONS(4801),
    [sym_return] = ACTIONS(4801),
    [sym_scope] = ACTIONS(4801),
    [sym_shared] = ACTIONS(4801),
    [sym_static] = ACTIONS(4801),
    [sym_struct] = ACTIONS(4801),
    [sym_synchronized] = ACTIONS(4801),
    [sym_template] = ACTIONS(4801),
    [sym_typeof] = ACTIONS(4801),
    [sym_union] = ACTIONS(4801),
    [sym_unittest] = ACTIONS(4801),
    [sym_version] = ACTIONS(4801),
    [sym_while] = ACTIONS(4801),
    [sym_gshared] = ACTIONS(4801),
    [sym_traits] = ACTIONS(4801),
    [sym_vector] = ACTIONS(4801),
    [sym_void] = ACTIONS(4801),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2348] = {
    [sym_identifier] = ACTIONS(4805),
    [anon_sym_DOT] = ACTIONS(4807),
    [anon_sym_SEMI] = ACTIONS(4807),
    [anon_sym_TILDE] = ACTIONS(4807),
    [anon_sym_AT] = ACTIONS(4807),
    [sym_bool] = ACTIONS(4805),
    [sym_byte] = ACTIONS(4805),
    [sym_ubyte] = ACTIONS(4805),
    [sym_char] = ACTIONS(4805),
    [sym_short] = ACTIONS(4805),
    [sym_ushort] = ACTIONS(4805),
    [sym_int] = ACTIONS(4805),
    [sym_uint] = ACTIONS(4805),
    [sym_long] = ACTIONS(4805),
    [sym_ulong] = ACTIONS(4805),
    [sym_cent] = ACTIONS(4805),
    [sym_ucent] = ACTIONS(4805),
    [sym_wchar] = ACTIONS(4805),
    [sym_dchar] = ACTIONS(4805),
    [sym_float] = ACTIONS(4805),
    [sym_double] = ACTIONS(4805),
    [sym_real] = ACTIONS(4805),
    [sym_ifloat] = ACTIONS(4805),
    [sym_idouble] = ACTIONS(4805),
    [sym_ireal] = ACTIONS(4805),
    [sym_cfloat] = ACTIONS(4805),
    [sym_cdouble] = ACTIONS(4805),
    [sym_creal] = ACTIONS(4805),
    [sym_size_t] = ACTIONS(4805),
    [sym_ptrdiff_t] = ACTIONS(4805),
    [sym_string] = ACTIONS(4805),
    [sym_cstring] = ACTIONS(4805),
    [sym_dstring] = ACTIONS(4805),
    [sym_wstring] = ACTIONS(4805),
    [sym_noreturn] = ACTIONS(4805),
    [sym_this] = ACTIONS(4805),
    [sym_abstract] = ACTIONS(4805),
    [sym_alias] = ACTIONS(4805),
    [sym_align] = ACTIONS(4805),
    [sym_auto] = ACTIONS(4805),
    [sym_catch] = ACTIONS(4805),
    [sym_class] = ACTIONS(4805),
    [sym_const] = ACTIONS(4805),
    [sym_debug] = ACTIONS(4805),
    [sym_deprecated] = ACTIONS(4805),
    [sym_else] = ACTIONS(4805),
    [sym_enum] = ACTIONS(4805),
    [sym_export] = ACTIONS(4805),
    [sym_extern] = ACTIONS(4805),
    [sym_final] = ACTIONS(4805),
    [sym_finally] = ACTIONS(4805),
    [sym_immutable] = ACTIONS(4805),
    [sym_import] = ACTIONS(4805),
    [sym_inout] = ACTIONS(4805),
    [sym_interface] = ACTIONS(4805),
    [sym_invariant] = ACTIONS(4805),
    [sym_mixin] = ACTIONS(4805),
    [sym_nothrow] = ACTIONS(4805),
    [sym_override] = ACTIONS(4805),
    [sym_package] = ACTIONS(4805),
    [sym_pragma] = ACTIONS(4805),
    [sym_private] = ACTIONS(4805),
    [sym_protected] = ACTIONS(4805),
    [sym_public] = ACTIONS(4805),
    [sym_pure] = ACTIONS(4805),
    [sym_ref] = ACTIONS(4805),
    [sym_return] = ACTIONS(4805),
    [sym_scope] = ACTIONS(4805),
    [sym_shared] = ACTIONS(4805),
    [sym_static] = ACTIONS(4805),
    [sym_struct] = ACTIONS(4805),
    [sym_synchronized] = ACTIONS(4805),
    [sym_template] = ACTIONS(4805),
    [sym_typeof] = ACTIONS(4805),
    [sym_union] = ACTIONS(4805),
    [sym_unittest] = ACTIONS(4805),
    [sym_version] = ACTIONS(4805),
    [sym_while] = ACTIONS(4805),
    [sym_gshared] = ACTIONS(4805),
    [sym_traits] = ACTIONS(4805),
    [sym_vector] = ACTIONS(4805),
    [sym_void] = ACTIONS(4805),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2349] = {
    [sym_identifier] = ACTIONS(4809),
    [anon_sym_DOT] = ACTIONS(4811),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_TILDE] = ACTIONS(4811),
    [anon_sym_AT] = ACTIONS(4811),
    [sym_bool] = ACTIONS(4809),
    [sym_byte] = ACTIONS(4809),
    [sym_ubyte] = ACTIONS(4809),
    [sym_char] = ACTIONS(4809),
    [sym_short] = ACTIONS(4809),
    [sym_ushort] = ACTIONS(4809),
    [sym_int] = ACTIONS(4809),
    [sym_uint] = ACTIONS(4809),
    [sym_long] = ACTIONS(4809),
    [sym_ulong] = ACTIONS(4809),
    [sym_cent] = ACTIONS(4809),
    [sym_ucent] = ACTIONS(4809),
    [sym_wchar] = ACTIONS(4809),
    [sym_dchar] = ACTIONS(4809),
    [sym_float] = ACTIONS(4809),
    [sym_double] = ACTIONS(4809),
    [sym_real] = ACTIONS(4809),
    [sym_ifloat] = ACTIONS(4809),
    [sym_idouble] = ACTIONS(4809),
    [sym_ireal] = ACTIONS(4809),
    [sym_cfloat] = ACTIONS(4809),
    [sym_cdouble] = ACTIONS(4809),
    [sym_creal] = ACTIONS(4809),
    [sym_size_t] = ACTIONS(4809),
    [sym_ptrdiff_t] = ACTIONS(4809),
    [sym_string] = ACTIONS(4809),
    [sym_cstring] = ACTIONS(4809),
    [sym_dstring] = ACTIONS(4809),
    [sym_wstring] = ACTIONS(4809),
    [sym_noreturn] = ACTIONS(4809),
    [sym_this] = ACTIONS(4809),
    [sym_abstract] = ACTIONS(4809),
    [sym_alias] = ACTIONS(4809),
    [sym_align] = ACTIONS(4809),
    [sym_auto] = ACTIONS(4809),
    [sym_catch] = ACTIONS(4809),
    [sym_class] = ACTIONS(4809),
    [sym_const] = ACTIONS(4809),
    [sym_debug] = ACTIONS(4809),
    [sym_deprecated] = ACTIONS(4809),
    [sym_else] = ACTIONS(4809),
    [sym_enum] = ACTIONS(4809),
    [sym_export] = ACTIONS(4809),
    [sym_extern] = ACTIONS(4809),
    [sym_final] = ACTIONS(4809),
    [sym_finally] = ACTIONS(4809),
    [sym_immutable] = ACTIONS(4809),
    [sym_import] = ACTIONS(4809),
    [sym_inout] = ACTIONS(4809),
    [sym_interface] = ACTIONS(4809),
    [sym_invariant] = ACTIONS(4809),
    [sym_mixin] = ACTIONS(4809),
    [sym_nothrow] = ACTIONS(4809),
    [sym_override] = ACTIONS(4809),
    [sym_package] = ACTIONS(4809),
    [sym_pragma] = ACTIONS(4809),
    [sym_private] = ACTIONS(4809),
    [sym_protected] = ACTIONS(4809),
    [sym_public] = ACTIONS(4809),
    [sym_pure] = ACTIONS(4809),
    [sym_ref] = ACTIONS(4809),
    [sym_return] = ACTIONS(4809),
    [sym_scope] = ACTIONS(4809),
    [sym_shared] = ACTIONS(4809),
    [sym_static] = ACTIONS(4809),
    [sym_struct] = ACTIONS(4809),
    [sym_synchronized] = ACTIONS(4809),
    [sym_template] = ACTIONS(4809),
    [sym_typeof] = ACTIONS(4809),
    [sym_union] = ACTIONS(4809),
    [sym_unittest] = ACTIONS(4809),
    [sym_version] = ACTIONS(4809),
    [sym_while] = ACTIONS(4809),
    [sym_gshared] = ACTIONS(4809),
    [sym_traits] = ACTIONS(4809),
    [sym_vector] = ACTIONS(4809),
    [sym_void] = ACTIONS(4809),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2350] = {
    [sym_identifier] = ACTIONS(4813),
    [anon_sym_DOT] = ACTIONS(4815),
    [anon_sym_SEMI] = ACTIONS(4815),
    [anon_sym_TILDE] = ACTIONS(4815),
    [anon_sym_AT] = ACTIONS(4815),
    [sym_bool] = ACTIONS(4813),
    [sym_byte] = ACTIONS(4813),
    [sym_ubyte] = ACTIONS(4813),
    [sym_char] = ACTIONS(4813),
    [sym_short] = ACTIONS(4813),
    [sym_ushort] = ACTIONS(4813),
    [sym_int] = ACTIONS(4813),
    [sym_uint] = ACTIONS(4813),
    [sym_long] = ACTIONS(4813),
    [sym_ulong] = ACTIONS(4813),
    [sym_cent] = ACTIONS(4813),
    [sym_ucent] = ACTIONS(4813),
    [sym_wchar] = ACTIONS(4813),
    [sym_dchar] = ACTIONS(4813),
    [sym_float] = ACTIONS(4813),
    [sym_double] = ACTIONS(4813),
    [sym_real] = ACTIONS(4813),
    [sym_ifloat] = ACTIONS(4813),
    [sym_idouble] = ACTIONS(4813),
    [sym_ireal] = ACTIONS(4813),
    [sym_cfloat] = ACTIONS(4813),
    [sym_cdouble] = ACTIONS(4813),
    [sym_creal] = ACTIONS(4813),
    [sym_size_t] = ACTIONS(4813),
    [sym_ptrdiff_t] = ACTIONS(4813),
    [sym_string] = ACTIONS(4813),
    [sym_cstring] = ACTIONS(4813),
    [sym_dstring] = ACTIONS(4813),
    [sym_wstring] = ACTIONS(4813),
    [sym_noreturn] = ACTIONS(4813),
    [sym_this] = ACTIONS(4813),
    [sym_abstract] = ACTIONS(4813),
    [sym_alias] = ACTIONS(4813),
    [sym_align] = ACTIONS(4813),
    [sym_auto] = ACTIONS(4813),
    [sym_catch] = ACTIONS(4813),
    [sym_class] = ACTIONS(4813),
    [sym_const] = ACTIONS(4813),
    [sym_debug] = ACTIONS(4813),
    [sym_deprecated] = ACTIONS(4813),
    [sym_else] = ACTIONS(4813),
    [sym_enum] = ACTIONS(4813),
    [sym_export] = ACTIONS(4813),
    [sym_extern] = ACTIONS(4813),
    [sym_final] = ACTIONS(4813),
    [sym_finally] = ACTIONS(4813),
    [sym_immutable] = ACTIONS(4813),
    [sym_import] = ACTIONS(4813),
    [sym_inout] = ACTIONS(4813),
    [sym_interface] = ACTIONS(4813),
    [sym_invariant] = ACTIONS(4813),
    [sym_mixin] = ACTIONS(4813),
    [sym_nothrow] = ACTIONS(4813),
    [sym_override] = ACTIONS(4813),
    [sym_package] = ACTIONS(4813),
    [sym_pragma] = ACTIONS(4813),
    [sym_private] = ACTIONS(4813),
    [sym_protected] = ACTIONS(4813),
    [sym_public] = ACTIONS(4813),
    [sym_pure] = ACTIONS(4813),
    [sym_ref] = ACTIONS(4813),
    [sym_return] = ACTIONS(4813),
    [sym_scope] = ACTIONS(4813),
    [sym_shared] = ACTIONS(4813),
    [sym_static] = ACTIONS(4813),
    [sym_struct] = ACTIONS(4813),
    [sym_synchronized] = ACTIONS(4813),
    [sym_template] = ACTIONS(4813),
    [sym_typeof] = ACTIONS(4813),
    [sym_union] = ACTIONS(4813),
    [sym_unittest] = ACTIONS(4813),
    [sym_version] = ACTIONS(4813),
    [sym_while] = ACTIONS(4813),
    [sym_gshared] = ACTIONS(4813),
    [sym_traits] = ACTIONS(4813),
    [sym_vector] = ACTIONS(4813),
    [sym_void] = ACTIONS(4813),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2351] = {
    [sym_identifier] = ACTIONS(4817),
    [anon_sym_DOT] = ACTIONS(4819),
    [anon_sym_SEMI] = ACTIONS(4819),
    [anon_sym_TILDE] = ACTIONS(4819),
    [anon_sym_AT] = ACTIONS(4819),
    [sym_bool] = ACTIONS(4817),
    [sym_byte] = ACTIONS(4817),
    [sym_ubyte] = ACTIONS(4817),
    [sym_char] = ACTIONS(4817),
    [sym_short] = ACTIONS(4817),
    [sym_ushort] = ACTIONS(4817),
    [sym_int] = ACTIONS(4817),
    [sym_uint] = ACTIONS(4817),
    [sym_long] = ACTIONS(4817),
    [sym_ulong] = ACTIONS(4817),
    [sym_cent] = ACTIONS(4817),
    [sym_ucent] = ACTIONS(4817),
    [sym_wchar] = ACTIONS(4817),
    [sym_dchar] = ACTIONS(4817),
    [sym_float] = ACTIONS(4817),
    [sym_double] = ACTIONS(4817),
    [sym_real] = ACTIONS(4817),
    [sym_ifloat] = ACTIONS(4817),
    [sym_idouble] = ACTIONS(4817),
    [sym_ireal] = ACTIONS(4817),
    [sym_cfloat] = ACTIONS(4817),
    [sym_cdouble] = ACTIONS(4817),
    [sym_creal] = ACTIONS(4817),
    [sym_size_t] = ACTIONS(4817),
    [sym_ptrdiff_t] = ACTIONS(4817),
    [sym_string] = ACTIONS(4817),
    [sym_cstring] = ACTIONS(4817),
    [sym_dstring] = ACTIONS(4817),
    [sym_wstring] = ACTIONS(4817),
    [sym_noreturn] = ACTIONS(4817),
    [sym_this] = ACTIONS(4817),
    [sym_abstract] = ACTIONS(4817),
    [sym_alias] = ACTIONS(4817),
    [sym_align] = ACTIONS(4817),
    [sym_auto] = ACTIONS(4817),
    [sym_catch] = ACTIONS(4817),
    [sym_class] = ACTIONS(4817),
    [sym_const] = ACTIONS(4817),
    [sym_debug] = ACTIONS(4817),
    [sym_deprecated] = ACTIONS(4817),
    [sym_else] = ACTIONS(4817),
    [sym_enum] = ACTIONS(4817),
    [sym_export] = ACTIONS(4817),
    [sym_extern] = ACTIONS(4817),
    [sym_final] = ACTIONS(4817),
    [sym_finally] = ACTIONS(4817),
    [sym_immutable] = ACTIONS(4817),
    [sym_import] = ACTIONS(4817),
    [sym_inout] = ACTIONS(4817),
    [sym_interface] = ACTIONS(4817),
    [sym_invariant] = ACTIONS(4817),
    [sym_mixin] = ACTIONS(4817),
    [sym_nothrow] = ACTIONS(4817),
    [sym_override] = ACTIONS(4817),
    [sym_package] = ACTIONS(4817),
    [sym_pragma] = ACTIONS(4817),
    [sym_private] = ACTIONS(4817),
    [sym_protected] = ACTIONS(4817),
    [sym_public] = ACTIONS(4817),
    [sym_pure] = ACTIONS(4817),
    [sym_ref] = ACTIONS(4817),
    [sym_return] = ACTIONS(4817),
    [sym_scope] = ACTIONS(4817),
    [sym_shared] = ACTIONS(4817),
    [sym_static] = ACTIONS(4817),
    [sym_struct] = ACTIONS(4817),
    [sym_synchronized] = ACTIONS(4817),
    [sym_template] = ACTIONS(4817),
    [sym_typeof] = ACTIONS(4817),
    [sym_union] = ACTIONS(4817),
    [sym_unittest] = ACTIONS(4817),
    [sym_version] = ACTIONS(4817),
    [sym_while] = ACTIONS(4817),
    [sym_gshared] = ACTIONS(4817),
    [sym_traits] = ACTIONS(4817),
    [sym_vector] = ACTIONS(4817),
    [sym_void] = ACTIONS(4817),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2352] = {
    [sym_identifier] = ACTIONS(4821),
    [anon_sym_DOT] = ACTIONS(4823),
    [anon_sym_SEMI] = ACTIONS(4823),
    [anon_sym_TILDE] = ACTIONS(4823),
    [anon_sym_AT] = ACTIONS(4823),
    [sym_bool] = ACTIONS(4821),
    [sym_byte] = ACTIONS(4821),
    [sym_ubyte] = ACTIONS(4821),
    [sym_char] = ACTIONS(4821),
    [sym_short] = ACTIONS(4821),
    [sym_ushort] = ACTIONS(4821),
    [sym_int] = ACTIONS(4821),
    [sym_uint] = ACTIONS(4821),
    [sym_long] = ACTIONS(4821),
    [sym_ulong] = ACTIONS(4821),
    [sym_cent] = ACTIONS(4821),
    [sym_ucent] = ACTIONS(4821),
    [sym_wchar] = ACTIONS(4821),
    [sym_dchar] = ACTIONS(4821),
    [sym_float] = ACTIONS(4821),
    [sym_double] = ACTIONS(4821),
    [sym_real] = ACTIONS(4821),
    [sym_ifloat] = ACTIONS(4821),
    [sym_idouble] = ACTIONS(4821),
    [sym_ireal] = ACTIONS(4821),
    [sym_cfloat] = ACTIONS(4821),
    [sym_cdouble] = ACTIONS(4821),
    [sym_creal] = ACTIONS(4821),
    [sym_size_t] = ACTIONS(4821),
    [sym_ptrdiff_t] = ACTIONS(4821),
    [sym_string] = ACTIONS(4821),
    [sym_cstring] = ACTIONS(4821),
    [sym_dstring] = ACTIONS(4821),
    [sym_wstring] = ACTIONS(4821),
    [sym_noreturn] = ACTIONS(4821),
    [sym_this] = ACTIONS(4821),
    [sym_abstract] = ACTIONS(4821),
    [sym_alias] = ACTIONS(4821),
    [sym_align] = ACTIONS(4821),
    [sym_auto] = ACTIONS(4821),
    [sym_catch] = ACTIONS(4821),
    [sym_class] = ACTIONS(4821),
    [sym_const] = ACTIONS(4821),
    [sym_debug] = ACTIONS(4821),
    [sym_deprecated] = ACTIONS(4821),
    [sym_else] = ACTIONS(4821),
    [sym_enum] = ACTIONS(4821),
    [sym_export] = ACTIONS(4821),
    [sym_extern] = ACTIONS(4821),
    [sym_final] = ACTIONS(4821),
    [sym_finally] = ACTIONS(4821),
    [sym_immutable] = ACTIONS(4821),
    [sym_import] = ACTIONS(4821),
    [sym_inout] = ACTIONS(4821),
    [sym_interface] = ACTIONS(4821),
    [sym_invariant] = ACTIONS(4821),
    [sym_mixin] = ACTIONS(4821),
    [sym_nothrow] = ACTIONS(4821),
    [sym_override] = ACTIONS(4821),
    [sym_package] = ACTIONS(4821),
    [sym_pragma] = ACTIONS(4821),
    [sym_private] = ACTIONS(4821),
    [sym_protected] = ACTIONS(4821),
    [sym_public] = ACTIONS(4821),
    [sym_pure] = ACTIONS(4821),
    [sym_ref] = ACTIONS(4821),
    [sym_return] = ACTIONS(4821),
    [sym_scope] = ACTIONS(4821),
    [sym_shared] = ACTIONS(4821),
    [sym_static] = ACTIONS(4821),
    [sym_struct] = ACTIONS(4821),
    [sym_synchronized] = ACTIONS(4821),
    [sym_template] = ACTIONS(4821),
    [sym_typeof] = ACTIONS(4821),
    [sym_union] = ACTIONS(4821),
    [sym_unittest] = ACTIONS(4821),
    [sym_version] = ACTIONS(4821),
    [sym_while] = ACTIONS(4821),
    [sym_gshared] = ACTIONS(4821),
    [sym_traits] = ACTIONS(4821),
    [sym_vector] = ACTIONS(4821),
    [sym_void] = ACTIONS(4821),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2353] = {
    [ts_builtin_sym_end] = ACTIONS(4596),
    [sym_identifier] = ACTIONS(4594),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_DOT] = ACTIONS(4596),
    [anon_sym_SEMI] = ACTIONS(4596),
    [anon_sym_TILDE] = ACTIONS(4596),
    [anon_sym_AT] = ACTIONS(4596),
    [sym_bool] = ACTIONS(4594),
    [sym_byte] = ACTIONS(4594),
    [sym_ubyte] = ACTIONS(4594),
    [sym_char] = ACTIONS(4594),
    [sym_short] = ACTIONS(4594),
    [sym_ushort] = ACTIONS(4594),
    [sym_int] = ACTIONS(4594),
    [sym_uint] = ACTIONS(4594),
    [sym_long] = ACTIONS(4594),
    [sym_ulong] = ACTIONS(4594),
    [sym_cent] = ACTIONS(4594),
    [sym_ucent] = ACTIONS(4594),
    [sym_wchar] = ACTIONS(4594),
    [sym_dchar] = ACTIONS(4594),
    [sym_float] = ACTIONS(4594),
    [sym_double] = ACTIONS(4594),
    [sym_real] = ACTIONS(4594),
    [sym_ifloat] = ACTIONS(4594),
    [sym_idouble] = ACTIONS(4594),
    [sym_ireal] = ACTIONS(4594),
    [sym_cfloat] = ACTIONS(4594),
    [sym_cdouble] = ACTIONS(4594),
    [sym_creal] = ACTIONS(4594),
    [sym_size_t] = ACTIONS(4594),
    [sym_ptrdiff_t] = ACTIONS(4594),
    [sym_string] = ACTIONS(4594),
    [sym_cstring] = ACTIONS(4594),
    [sym_dstring] = ACTIONS(4594),
    [sym_wstring] = ACTIONS(4594),
    [sym_noreturn] = ACTIONS(4594),
    [sym_this] = ACTIONS(4594),
    [sym_abstract] = ACTIONS(4594),
    [sym_alias] = ACTIONS(4594),
    [sym_align] = ACTIONS(4594),
    [sym_auto] = ACTIONS(4594),
    [sym_class] = ACTIONS(4594),
    [sym_const] = ACTIONS(4594),
    [sym_debug] = ACTIONS(4594),
    [sym_deprecated] = ACTIONS(4594),
    [sym_else] = ACTIONS(4594),
    [sym_enum] = ACTIONS(4594),
    [sym_export] = ACTIONS(4594),
    [sym_extern] = ACTIONS(4594),
    [sym_final] = ACTIONS(4594),
    [sym_immutable] = ACTIONS(4594),
    [sym_import] = ACTIONS(4594),
    [sym_inout] = ACTIONS(4594),
    [sym_interface] = ACTIONS(4594),
    [sym_invariant] = ACTIONS(4594),
    [sym_mixin] = ACTIONS(4594),
    [sym_nothrow] = ACTIONS(4594),
    [sym_override] = ACTIONS(4594),
    [sym_package] = ACTIONS(4594),
    [sym_pragma] = ACTIONS(4594),
    [sym_private] = ACTIONS(4594),
    [sym_protected] = ACTIONS(4594),
    [sym_public] = ACTIONS(4594),
    [sym_pure] = ACTIONS(4594),
    [sym_ref] = ACTIONS(4594),
    [sym_return] = ACTIONS(4594),
    [sym_scope] = ACTIONS(4594),
    [sym_shared] = ACTIONS(4594),
    [sym_static] = ACTIONS(4594),
    [sym_struct] = ACTIONS(4594),
    [sym_synchronized] = ACTIONS(4594),
    [sym_template] = ACTIONS(4594),
    [sym_typeof] = ACTIONS(4594),
    [sym_union] = ACTIONS(4594),
    [sym_unittest] = ACTIONS(4594),
    [sym_version] = ACTIONS(4594),
    [sym_while] = ACTIONS(4594),
    [sym_gshared] = ACTIONS(4594),
    [sym_traits] = ACTIONS(4594),
    [sym_vector] = ACTIONS(4594),
    [sym_void] = ACTIONS(4594),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2354] = {
    [sym_identifier] = ACTIONS(4448),
    [anon_sym_DOT] = ACTIONS(4450),
    [anon_sym_SEMI] = ACTIONS(4450),
    [anon_sym_TILDE] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4450),
    [sym_bool] = ACTIONS(4448),
    [sym_byte] = ACTIONS(4448),
    [sym_ubyte] = ACTIONS(4448),
    [sym_char] = ACTIONS(4448),
    [sym_short] = ACTIONS(4448),
    [sym_ushort] = ACTIONS(4448),
    [sym_int] = ACTIONS(4448),
    [sym_uint] = ACTIONS(4448),
    [sym_long] = ACTIONS(4448),
    [sym_ulong] = ACTIONS(4448),
    [sym_cent] = ACTIONS(4448),
    [sym_ucent] = ACTIONS(4448),
    [sym_wchar] = ACTIONS(4448),
    [sym_dchar] = ACTIONS(4448),
    [sym_float] = ACTIONS(4448),
    [sym_double] = ACTIONS(4448),
    [sym_real] = ACTIONS(4448),
    [sym_ifloat] = ACTIONS(4448),
    [sym_idouble] = ACTIONS(4448),
    [sym_ireal] = ACTIONS(4448),
    [sym_cfloat] = ACTIONS(4448),
    [sym_cdouble] = ACTIONS(4448),
    [sym_creal] = ACTIONS(4448),
    [sym_size_t] = ACTIONS(4448),
    [sym_ptrdiff_t] = ACTIONS(4448),
    [sym_string] = ACTIONS(4448),
    [sym_cstring] = ACTIONS(4448),
    [sym_dstring] = ACTIONS(4448),
    [sym_wstring] = ACTIONS(4448),
    [sym_noreturn] = ACTIONS(4448),
    [sym_this] = ACTIONS(4448),
    [sym_abstract] = ACTIONS(4448),
    [sym_alias] = ACTIONS(4448),
    [sym_align] = ACTIONS(4448),
    [sym_auto] = ACTIONS(4448),
    [sym_catch] = ACTIONS(4448),
    [sym_class] = ACTIONS(4448),
    [sym_const] = ACTIONS(4448),
    [sym_debug] = ACTIONS(4448),
    [sym_deprecated] = ACTIONS(4448),
    [sym_else] = ACTIONS(4448),
    [sym_enum] = ACTIONS(4448),
    [sym_export] = ACTIONS(4448),
    [sym_extern] = ACTIONS(4448),
    [sym_final] = ACTIONS(4448),
    [sym_finally] = ACTIONS(4448),
    [sym_immutable] = ACTIONS(4448),
    [sym_import] = ACTIONS(4448),
    [sym_inout] = ACTIONS(4448),
    [sym_interface] = ACTIONS(4448),
    [sym_invariant] = ACTIONS(4448),
    [sym_mixin] = ACTIONS(4448),
    [sym_nothrow] = ACTIONS(4448),
    [sym_override] = ACTIONS(4448),
    [sym_package] = ACTIONS(4448),
    [sym_pragma] = ACTIONS(4448),
    [sym_private] = ACTIONS(4448),
    [sym_protected] = ACTIONS(4448),
    [sym_public] = ACTIONS(4448),
    [sym_pure] = ACTIONS(4448),
    [sym_ref] = ACTIONS(4448),
    [sym_return] = ACTIONS(4448),
    [sym_scope] = ACTIONS(4448),
    [sym_shared] = ACTIONS(4448),
    [sym_static] = ACTIONS(4448),
    [sym_struct] = ACTIONS(4448),
    [sym_synchronized] = ACTIONS(4448),
    [sym_template] = ACTIONS(4448),
    [sym_typeof] = ACTIONS(4448),
    [sym_union] = ACTIONS(4448),
    [sym_unittest] = ACTIONS(4448),
    [sym_version] = ACTIONS(4448),
    [sym_while] = ACTIONS(4448),
    [sym_gshared] = ACTIONS(4448),
    [sym_traits] = ACTIONS(4448),
    [sym_vector] = ACTIONS(4448),
    [sym_void] = ACTIONS(4448),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2355] = {
    [sym_identifier] = ACTIONS(4452),
    [anon_sym_DOT] = ACTIONS(4454),
    [anon_sym_SEMI] = ACTIONS(4454),
    [anon_sym_TILDE] = ACTIONS(4454),
    [anon_sym_AT] = ACTIONS(4454),
    [sym_bool] = ACTIONS(4452),
    [sym_byte] = ACTIONS(4452),
    [sym_ubyte] = ACTIONS(4452),
    [sym_char] = ACTIONS(4452),
    [sym_short] = ACTIONS(4452),
    [sym_ushort] = ACTIONS(4452),
    [sym_int] = ACTIONS(4452),
    [sym_uint] = ACTIONS(4452),
    [sym_long] = ACTIONS(4452),
    [sym_ulong] = ACTIONS(4452),
    [sym_cent] = ACTIONS(4452),
    [sym_ucent] = ACTIONS(4452),
    [sym_wchar] = ACTIONS(4452),
    [sym_dchar] = ACTIONS(4452),
    [sym_float] = ACTIONS(4452),
    [sym_double] = ACTIONS(4452),
    [sym_real] = ACTIONS(4452),
    [sym_ifloat] = ACTIONS(4452),
    [sym_idouble] = ACTIONS(4452),
    [sym_ireal] = ACTIONS(4452),
    [sym_cfloat] = ACTIONS(4452),
    [sym_cdouble] = ACTIONS(4452),
    [sym_creal] = ACTIONS(4452),
    [sym_size_t] = ACTIONS(4452),
    [sym_ptrdiff_t] = ACTIONS(4452),
    [sym_string] = ACTIONS(4452),
    [sym_cstring] = ACTIONS(4452),
    [sym_dstring] = ACTIONS(4452),
    [sym_wstring] = ACTIONS(4452),
    [sym_noreturn] = ACTIONS(4452),
    [sym_this] = ACTIONS(4452),
    [sym_abstract] = ACTIONS(4452),
    [sym_alias] = ACTIONS(4452),
    [sym_align] = ACTIONS(4452),
    [sym_auto] = ACTIONS(4452),
    [sym_catch] = ACTIONS(4452),
    [sym_class] = ACTIONS(4452),
    [sym_const] = ACTIONS(4452),
    [sym_debug] = ACTIONS(4452),
    [sym_deprecated] = ACTIONS(4452),
    [sym_else] = ACTIONS(4452),
    [sym_enum] = ACTIONS(4452),
    [sym_export] = ACTIONS(4452),
    [sym_extern] = ACTIONS(4452),
    [sym_final] = ACTIONS(4452),
    [sym_finally] = ACTIONS(4452),
    [sym_immutable] = ACTIONS(4452),
    [sym_import] = ACTIONS(4452),
    [sym_inout] = ACTIONS(4452),
    [sym_interface] = ACTIONS(4452),
    [sym_invariant] = ACTIONS(4452),
    [sym_mixin] = ACTIONS(4452),
    [sym_nothrow] = ACTIONS(4452),
    [sym_override] = ACTIONS(4452),
    [sym_package] = ACTIONS(4452),
    [sym_pragma] = ACTIONS(4452),
    [sym_private] = ACTIONS(4452),
    [sym_protected] = ACTIONS(4452),
    [sym_public] = ACTIONS(4452),
    [sym_pure] = ACTIONS(4452),
    [sym_ref] = ACTIONS(4452),
    [sym_return] = ACTIONS(4452),
    [sym_scope] = ACTIONS(4452),
    [sym_shared] = ACTIONS(4452),
    [sym_static] = ACTIONS(4452),
    [sym_struct] = ACTIONS(4452),
    [sym_synchronized] = ACTIONS(4452),
    [sym_template] = ACTIONS(4452),
    [sym_typeof] = ACTIONS(4452),
    [sym_union] = ACTIONS(4452),
    [sym_unittest] = ACTIONS(4452),
    [sym_version] = ACTIONS(4452),
    [sym_while] = ACTIONS(4452),
    [sym_gshared] = ACTIONS(4452),
    [sym_traits] = ACTIONS(4452),
    [sym_vector] = ACTIONS(4452),
    [sym_void] = ACTIONS(4452),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2356] = {
    [sym_identifier] = ACTIONS(4831),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4833),
    [anon_sym_TILDE] = ACTIONS(4833),
    [anon_sym_AT] = ACTIONS(4833),
    [sym_bool] = ACTIONS(4831),
    [sym_byte] = ACTIONS(4831),
    [sym_ubyte] = ACTIONS(4831),
    [sym_char] = ACTIONS(4831),
    [sym_short] = ACTIONS(4831),
    [sym_ushort] = ACTIONS(4831),
    [sym_int] = ACTIONS(4831),
    [sym_uint] = ACTIONS(4831),
    [sym_long] = ACTIONS(4831),
    [sym_ulong] = ACTIONS(4831),
    [sym_cent] = ACTIONS(4831),
    [sym_ucent] = ACTIONS(4831),
    [sym_wchar] = ACTIONS(4831),
    [sym_dchar] = ACTIONS(4831),
    [sym_float] = ACTIONS(4831),
    [sym_double] = ACTIONS(4831),
    [sym_real] = ACTIONS(4831),
    [sym_ifloat] = ACTIONS(4831),
    [sym_idouble] = ACTIONS(4831),
    [sym_ireal] = ACTIONS(4831),
    [sym_cfloat] = ACTIONS(4831),
    [sym_cdouble] = ACTIONS(4831),
    [sym_creal] = ACTIONS(4831),
    [sym_size_t] = ACTIONS(4831),
    [sym_ptrdiff_t] = ACTIONS(4831),
    [sym_string] = ACTIONS(4831),
    [sym_cstring] = ACTIONS(4831),
    [sym_dstring] = ACTIONS(4831),
    [sym_wstring] = ACTIONS(4831),
    [sym_noreturn] = ACTIONS(4831),
    [sym_this] = ACTIONS(4831),
    [sym_abstract] = ACTIONS(4831),
    [sym_alias] = ACTIONS(4831),
    [sym_align] = ACTIONS(4831),
    [sym_auto] = ACTIONS(4831),
    [sym_catch] = ACTIONS(4831),
    [sym_class] = ACTIONS(4831),
    [sym_const] = ACTIONS(4831),
    [sym_debug] = ACTIONS(4831),
    [sym_deprecated] = ACTIONS(4831),
    [sym_else] = ACTIONS(4831),
    [sym_enum] = ACTIONS(4831),
    [sym_export] = ACTIONS(4831),
    [sym_extern] = ACTIONS(4831),
    [sym_final] = ACTIONS(4831),
    [sym_finally] = ACTIONS(4831),
    [sym_immutable] = ACTIONS(4831),
    [sym_import] = ACTIONS(4831),
    [sym_inout] = ACTIONS(4831),
    [sym_interface] = ACTIONS(4831),
    [sym_invariant] = ACTIONS(4831),
    [sym_mixin] = ACTIONS(4831),
    [sym_nothrow] = ACTIONS(4831),
    [sym_override] = ACTIONS(4831),
    [sym_package] = ACTIONS(4831),
    [sym_pragma] = ACTIONS(4831),
    [sym_private] = ACTIONS(4831),
    [sym_protected] = ACTIONS(4831),
    [sym_public] = ACTIONS(4831),
    [sym_pure] = ACTIONS(4831),
    [sym_ref] = ACTIONS(4831),
    [sym_return] = ACTIONS(4831),
    [sym_scope] = ACTIONS(4831),
    [sym_shared] = ACTIONS(4831),
    [sym_static] = ACTIONS(4831),
    [sym_struct] = ACTIONS(4831),
    [sym_synchronized] = ACTIONS(4831),
    [sym_template] = ACTIONS(4831),
    [sym_typeof] = ACTIONS(4831),
    [sym_union] = ACTIONS(4831),
    [sym_unittest] = ACTIONS(4831),
    [sym_version] = ACTIONS(4831),
    [sym_while] = ACTIONS(4831),
    [sym_gshared] = ACTIONS(4831),
    [sym_traits] = ACTIONS(4831),
    [sym_vector] = ACTIONS(4831),
    [sym_void] = ACTIONS(4831),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2357] = {
    [sym_identifier] = ACTIONS(4835),
    [anon_sym_DOT] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym_TILDE] = ACTIONS(4837),
    [anon_sym_AT] = ACTIONS(4837),
    [sym_bool] = ACTIONS(4835),
    [sym_byte] = ACTIONS(4835),
    [sym_ubyte] = ACTIONS(4835),
    [sym_char] = ACTIONS(4835),
    [sym_short] = ACTIONS(4835),
    [sym_ushort] = ACTIONS(4835),
    [sym_int] = ACTIONS(4835),
    [sym_uint] = ACTIONS(4835),
    [sym_long] = ACTIONS(4835),
    [sym_ulong] = ACTIONS(4835),
    [sym_cent] = ACTIONS(4835),
    [sym_ucent] = ACTIONS(4835),
    [sym_wchar] = ACTIONS(4835),
    [sym_dchar] = ACTIONS(4835),
    [sym_float] = ACTIONS(4835),
    [sym_double] = ACTIONS(4835),
    [sym_real] = ACTIONS(4835),
    [sym_ifloat] = ACTIONS(4835),
    [sym_idouble] = ACTIONS(4835),
    [sym_ireal] = ACTIONS(4835),
    [sym_cfloat] = ACTIONS(4835),
    [sym_cdouble] = ACTIONS(4835),
    [sym_creal] = ACTIONS(4835),
    [sym_size_t] = ACTIONS(4835),
    [sym_ptrdiff_t] = ACTIONS(4835),
    [sym_string] = ACTIONS(4835),
    [sym_cstring] = ACTIONS(4835),
    [sym_dstring] = ACTIONS(4835),
    [sym_wstring] = ACTIONS(4835),
    [sym_noreturn] = ACTIONS(4835),
    [sym_this] = ACTIONS(4835),
    [sym_abstract] = ACTIONS(4835),
    [sym_alias] = ACTIONS(4835),
    [sym_align] = ACTIONS(4835),
    [sym_auto] = ACTIONS(4835),
    [sym_catch] = ACTIONS(4835),
    [sym_class] = ACTIONS(4835),
    [sym_const] = ACTIONS(4835),
    [sym_debug] = ACTIONS(4835),
    [sym_deprecated] = ACTIONS(4835),
    [sym_else] = ACTIONS(4835),
    [sym_enum] = ACTIONS(4835),
    [sym_export] = ACTIONS(4835),
    [sym_extern] = ACTIONS(4835),
    [sym_final] = ACTIONS(4835),
    [sym_finally] = ACTIONS(4835),
    [sym_immutable] = ACTIONS(4835),
    [sym_import] = ACTIONS(4835),
    [sym_inout] = ACTIONS(4835),
    [sym_interface] = ACTIONS(4835),
    [sym_invariant] = ACTIONS(4835),
    [sym_mixin] = ACTIONS(4835),
    [sym_nothrow] = ACTIONS(4835),
    [sym_override] = ACTIONS(4835),
    [sym_package] = ACTIONS(4835),
    [sym_pragma] = ACTIONS(4835),
    [sym_private] = ACTIONS(4835),
    [sym_protected] = ACTIONS(4835),
    [sym_public] = ACTIONS(4835),
    [sym_pure] = ACTIONS(4835),
    [sym_ref] = ACTIONS(4835),
    [sym_return] = ACTIONS(4835),
    [sym_scope] = ACTIONS(4835),
    [sym_shared] = ACTIONS(4835),
    [sym_static] = ACTIONS(4835),
    [sym_struct] = ACTIONS(4835),
    [sym_synchronized] = ACTIONS(4835),
    [sym_template] = ACTIONS(4835),
    [sym_typeof] = ACTIONS(4835),
    [sym_union] = ACTIONS(4835),
    [sym_unittest] = ACTIONS(4835),
    [sym_version] = ACTIONS(4835),
    [sym_while] = ACTIONS(4835),
    [sym_gshared] = ACTIONS(4835),
    [sym_traits] = ACTIONS(4835),
    [sym_vector] = ACTIONS(4835),
    [sym_void] = ACTIONS(4835),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2358] = {
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_DOT] = ACTIONS(4841),
    [anon_sym_SEMI] = ACTIONS(4841),
    [anon_sym_TILDE] = ACTIONS(4841),
    [anon_sym_AT] = ACTIONS(4841),
    [sym_bool] = ACTIONS(4839),
    [sym_byte] = ACTIONS(4839),
    [sym_ubyte] = ACTIONS(4839),
    [sym_char] = ACTIONS(4839),
    [sym_short] = ACTIONS(4839),
    [sym_ushort] = ACTIONS(4839),
    [sym_int] = ACTIONS(4839),
    [sym_uint] = ACTIONS(4839),
    [sym_long] = ACTIONS(4839),
    [sym_ulong] = ACTIONS(4839),
    [sym_cent] = ACTIONS(4839),
    [sym_ucent] = ACTIONS(4839),
    [sym_wchar] = ACTIONS(4839),
    [sym_dchar] = ACTIONS(4839),
    [sym_float] = ACTIONS(4839),
    [sym_double] = ACTIONS(4839),
    [sym_real] = ACTIONS(4839),
    [sym_ifloat] = ACTIONS(4839),
    [sym_idouble] = ACTIONS(4839),
    [sym_ireal] = ACTIONS(4839),
    [sym_cfloat] = ACTIONS(4839),
    [sym_cdouble] = ACTIONS(4839),
    [sym_creal] = ACTIONS(4839),
    [sym_size_t] = ACTIONS(4839),
    [sym_ptrdiff_t] = ACTIONS(4839),
    [sym_string] = ACTIONS(4839),
    [sym_cstring] = ACTIONS(4839),
    [sym_dstring] = ACTIONS(4839),
    [sym_wstring] = ACTIONS(4839),
    [sym_noreturn] = ACTIONS(4839),
    [sym_this] = ACTIONS(4839),
    [sym_abstract] = ACTIONS(4839),
    [sym_alias] = ACTIONS(4839),
    [sym_align] = ACTIONS(4839),
    [sym_auto] = ACTIONS(4839),
    [sym_catch] = ACTIONS(4839),
    [sym_class] = ACTIONS(4839),
    [sym_const] = ACTIONS(4839),
    [sym_debug] = ACTIONS(4839),
    [sym_deprecated] = ACTIONS(4839),
    [sym_else] = ACTIONS(4839),
    [sym_enum] = ACTIONS(4839),
    [sym_export] = ACTIONS(4839),
    [sym_extern] = ACTIONS(4839),
    [sym_final] = ACTIONS(4839),
    [sym_finally] = ACTIONS(4839),
    [sym_immutable] = ACTIONS(4839),
    [sym_import] = ACTIONS(4839),
    [sym_inout] = ACTIONS(4839),
    [sym_interface] = ACTIONS(4839),
    [sym_invariant] = ACTIONS(4839),
    [sym_mixin] = ACTIONS(4839),
    [sym_nothrow] = ACTIONS(4839),
    [sym_override] = ACTIONS(4839),
    [sym_package] = ACTIONS(4839),
    [sym_pragma] = ACTIONS(4839),
    [sym_private] = ACTIONS(4839),
    [sym_protected] = ACTIONS(4839),
    [sym_public] = ACTIONS(4839),
    [sym_pure] = ACTIONS(4839),
    [sym_ref] = ACTIONS(4839),
    [sym_return] = ACTIONS(4839),
    [sym_scope] = ACTIONS(4839),
    [sym_shared] = ACTIONS(4839),
    [sym_static] = ACTIONS(4839),
    [sym_struct] = ACTIONS(4839),
    [sym_synchronized] = ACTIONS(4839),
    [sym_template] = ACTIONS(4839),
    [sym_typeof] = ACTIONS(4839),
    [sym_union] = ACTIONS(4839),
    [sym_unittest] = ACTIONS(4839),
    [sym_version] = ACTIONS(4839),
    [sym_while] = ACTIONS(4839),
    [sym_gshared] = ACTIONS(4839),
    [sym_traits] = ACTIONS(4839),
    [sym_vector] = ACTIONS(4839),
    [sym_void] = ACTIONS(4839),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2359] = {
    [sym_switch_statement] = STATE(4686),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(914),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2360] = {
    [sym_identifier] = ACTIONS(4843),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_AT] = ACTIONS(4845),
    [sym_bool] = ACTIONS(4843),
    [sym_byte] = ACTIONS(4843),
    [sym_ubyte] = ACTIONS(4843),
    [sym_char] = ACTIONS(4843),
    [sym_short] = ACTIONS(4843),
    [sym_ushort] = ACTIONS(4843),
    [sym_int] = ACTIONS(4843),
    [sym_uint] = ACTIONS(4843),
    [sym_long] = ACTIONS(4843),
    [sym_ulong] = ACTIONS(4843),
    [sym_cent] = ACTIONS(4843),
    [sym_ucent] = ACTIONS(4843),
    [sym_wchar] = ACTIONS(4843),
    [sym_dchar] = ACTIONS(4843),
    [sym_float] = ACTIONS(4843),
    [sym_double] = ACTIONS(4843),
    [sym_real] = ACTIONS(4843),
    [sym_ifloat] = ACTIONS(4843),
    [sym_idouble] = ACTIONS(4843),
    [sym_ireal] = ACTIONS(4843),
    [sym_cfloat] = ACTIONS(4843),
    [sym_cdouble] = ACTIONS(4843),
    [sym_creal] = ACTIONS(4843),
    [sym_size_t] = ACTIONS(4843),
    [sym_ptrdiff_t] = ACTIONS(4843),
    [sym_string] = ACTIONS(4843),
    [sym_cstring] = ACTIONS(4843),
    [sym_dstring] = ACTIONS(4843),
    [sym_wstring] = ACTIONS(4843),
    [sym_noreturn] = ACTIONS(4843),
    [sym_this] = ACTIONS(4843),
    [sym_abstract] = ACTIONS(4843),
    [sym_alias] = ACTIONS(4843),
    [sym_align] = ACTIONS(4843),
    [sym_auto] = ACTIONS(4843),
    [sym_catch] = ACTIONS(4843),
    [sym_class] = ACTIONS(4843),
    [sym_const] = ACTIONS(4843),
    [sym_debug] = ACTIONS(4843),
    [sym_deprecated] = ACTIONS(4843),
    [sym_else] = ACTIONS(4843),
    [sym_enum] = ACTIONS(4843),
    [sym_export] = ACTIONS(4843),
    [sym_extern] = ACTIONS(4843),
    [sym_final] = ACTIONS(4843),
    [sym_finally] = ACTIONS(4843),
    [sym_immutable] = ACTIONS(4843),
    [sym_import] = ACTIONS(4843),
    [sym_inout] = ACTIONS(4843),
    [sym_interface] = ACTIONS(4843),
    [sym_invariant] = ACTIONS(4843),
    [sym_mixin] = ACTIONS(4843),
    [sym_nothrow] = ACTIONS(4843),
    [sym_override] = ACTIONS(4843),
    [sym_package] = ACTIONS(4843),
    [sym_pragma] = ACTIONS(4843),
    [sym_private] = ACTIONS(4843),
    [sym_protected] = ACTIONS(4843),
    [sym_public] = ACTIONS(4843),
    [sym_pure] = ACTIONS(4843),
    [sym_ref] = ACTIONS(4843),
    [sym_return] = ACTIONS(4843),
    [sym_scope] = ACTIONS(4843),
    [sym_shared] = ACTIONS(4843),
    [sym_static] = ACTIONS(4843),
    [sym_struct] = ACTIONS(4843),
    [sym_synchronized] = ACTIONS(4843),
    [sym_template] = ACTIONS(4843),
    [sym_typeof] = ACTIONS(4843),
    [sym_union] = ACTIONS(4843),
    [sym_unittest] = ACTIONS(4843),
    [sym_version] = ACTIONS(4843),
    [sym_while] = ACTIONS(4843),
    [sym_gshared] = ACTIONS(4843),
    [sym_traits] = ACTIONS(4843),
    [sym_vector] = ACTIONS(4843),
    [sym_void] = ACTIONS(4843),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2361] = {
    [ts_builtin_sym_end] = ACTIONS(4580),
    [sym_identifier] = ACTIONS(4578),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_DOT] = ACTIONS(4580),
    [anon_sym_SEMI] = ACTIONS(4580),
    [anon_sym_TILDE] = ACTIONS(4580),
    [anon_sym_AT] = ACTIONS(4580),
    [sym_bool] = ACTIONS(4578),
    [sym_byte] = ACTIONS(4578),
    [sym_ubyte] = ACTIONS(4578),
    [sym_char] = ACTIONS(4578),
    [sym_short] = ACTIONS(4578),
    [sym_ushort] = ACTIONS(4578),
    [sym_int] = ACTIONS(4578),
    [sym_uint] = ACTIONS(4578),
    [sym_long] = ACTIONS(4578),
    [sym_ulong] = ACTIONS(4578),
    [sym_cent] = ACTIONS(4578),
    [sym_ucent] = ACTIONS(4578),
    [sym_wchar] = ACTIONS(4578),
    [sym_dchar] = ACTIONS(4578),
    [sym_float] = ACTIONS(4578),
    [sym_double] = ACTIONS(4578),
    [sym_real] = ACTIONS(4578),
    [sym_ifloat] = ACTIONS(4578),
    [sym_idouble] = ACTIONS(4578),
    [sym_ireal] = ACTIONS(4578),
    [sym_cfloat] = ACTIONS(4578),
    [sym_cdouble] = ACTIONS(4578),
    [sym_creal] = ACTIONS(4578),
    [sym_size_t] = ACTIONS(4578),
    [sym_ptrdiff_t] = ACTIONS(4578),
    [sym_string] = ACTIONS(4578),
    [sym_cstring] = ACTIONS(4578),
    [sym_dstring] = ACTIONS(4578),
    [sym_wstring] = ACTIONS(4578),
    [sym_noreturn] = ACTIONS(4578),
    [sym_this] = ACTIONS(4578),
    [sym_abstract] = ACTIONS(4578),
    [sym_alias] = ACTIONS(4578),
    [sym_align] = ACTIONS(4578),
    [sym_auto] = ACTIONS(4578),
    [sym_class] = ACTIONS(4578),
    [sym_const] = ACTIONS(4578),
    [sym_debug] = ACTIONS(4578),
    [sym_deprecated] = ACTIONS(4578),
    [sym_else] = ACTIONS(4578),
    [sym_enum] = ACTIONS(4578),
    [sym_export] = ACTIONS(4578),
    [sym_extern] = ACTIONS(4578),
    [sym_final] = ACTIONS(4578),
    [sym_immutable] = ACTIONS(4578),
    [sym_import] = ACTIONS(4578),
    [sym_inout] = ACTIONS(4578),
    [sym_interface] = ACTIONS(4578),
    [sym_invariant] = ACTIONS(4578),
    [sym_mixin] = ACTIONS(4578),
    [sym_nothrow] = ACTIONS(4578),
    [sym_override] = ACTIONS(4578),
    [sym_package] = ACTIONS(4578),
    [sym_pragma] = ACTIONS(4578),
    [sym_private] = ACTIONS(4578),
    [sym_protected] = ACTIONS(4578),
    [sym_public] = ACTIONS(4578),
    [sym_pure] = ACTIONS(4578),
    [sym_ref] = ACTIONS(4578),
    [sym_return] = ACTIONS(4578),
    [sym_scope] = ACTIONS(4578),
    [sym_shared] = ACTIONS(4578),
    [sym_static] = ACTIONS(4578),
    [sym_struct] = ACTIONS(4578),
    [sym_synchronized] = ACTIONS(4578),
    [sym_template] = ACTIONS(4578),
    [sym_typeof] = ACTIONS(4578),
    [sym_union] = ACTIONS(4578),
    [sym_unittest] = ACTIONS(4578),
    [sym_version] = ACTIONS(4578),
    [sym_while] = ACTIONS(4578),
    [sym_gshared] = ACTIONS(4578),
    [sym_traits] = ACTIONS(4578),
    [sym_vector] = ACTIONS(4578),
    [sym_void] = ACTIONS(4578),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2362] = {
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_DOT] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym_TILDE] = ACTIONS(4857),
    [anon_sym_AT] = ACTIONS(4857),
    [sym_bool] = ACTIONS(4855),
    [sym_byte] = ACTIONS(4855),
    [sym_ubyte] = ACTIONS(4855),
    [sym_char] = ACTIONS(4855),
    [sym_short] = ACTIONS(4855),
    [sym_ushort] = ACTIONS(4855),
    [sym_int] = ACTIONS(4855),
    [sym_uint] = ACTIONS(4855),
    [sym_long] = ACTIONS(4855),
    [sym_ulong] = ACTIONS(4855),
    [sym_cent] = ACTIONS(4855),
    [sym_ucent] = ACTIONS(4855),
    [sym_wchar] = ACTIONS(4855),
    [sym_dchar] = ACTIONS(4855),
    [sym_float] = ACTIONS(4855),
    [sym_double] = ACTIONS(4855),
    [sym_real] = ACTIONS(4855),
    [sym_ifloat] = ACTIONS(4855),
    [sym_idouble] = ACTIONS(4855),
    [sym_ireal] = ACTIONS(4855),
    [sym_cfloat] = ACTIONS(4855),
    [sym_cdouble] = ACTIONS(4855),
    [sym_creal] = ACTIONS(4855),
    [sym_size_t] = ACTIONS(4855),
    [sym_ptrdiff_t] = ACTIONS(4855),
    [sym_string] = ACTIONS(4855),
    [sym_cstring] = ACTIONS(4855),
    [sym_dstring] = ACTIONS(4855),
    [sym_wstring] = ACTIONS(4855),
    [sym_noreturn] = ACTIONS(4855),
    [sym_this] = ACTIONS(4855),
    [sym_abstract] = ACTIONS(4855),
    [sym_alias] = ACTIONS(4855),
    [sym_align] = ACTIONS(4855),
    [sym_auto] = ACTIONS(4855),
    [sym_catch] = ACTIONS(4855),
    [sym_class] = ACTIONS(4855),
    [sym_const] = ACTIONS(4855),
    [sym_debug] = ACTIONS(4855),
    [sym_deprecated] = ACTIONS(4855),
    [sym_else] = ACTIONS(4855),
    [sym_enum] = ACTIONS(4855),
    [sym_export] = ACTIONS(4855),
    [sym_extern] = ACTIONS(4855),
    [sym_final] = ACTIONS(4855),
    [sym_finally] = ACTIONS(4855),
    [sym_immutable] = ACTIONS(4855),
    [sym_import] = ACTIONS(4855),
    [sym_inout] = ACTIONS(4855),
    [sym_interface] = ACTIONS(4855),
    [sym_invariant] = ACTIONS(4855),
    [sym_mixin] = ACTIONS(4855),
    [sym_nothrow] = ACTIONS(4855),
    [sym_override] = ACTIONS(4855),
    [sym_package] = ACTIONS(4855),
    [sym_pragma] = ACTIONS(4855),
    [sym_private] = ACTIONS(4855),
    [sym_protected] = ACTIONS(4855),
    [sym_public] = ACTIONS(4855),
    [sym_pure] = ACTIONS(4855),
    [sym_ref] = ACTIONS(4855),
    [sym_return] = ACTIONS(4855),
    [sym_scope] = ACTIONS(4855),
    [sym_shared] = ACTIONS(4855),
    [sym_static] = ACTIONS(4855),
    [sym_struct] = ACTIONS(4855),
    [sym_synchronized] = ACTIONS(4855),
    [sym_template] = ACTIONS(4855),
    [sym_typeof] = ACTIONS(4855),
    [sym_union] = ACTIONS(4855),
    [sym_unittest] = ACTIONS(4855),
    [sym_version] = ACTIONS(4855),
    [sym_while] = ACTIONS(4855),
    [sym_gshared] = ACTIONS(4855),
    [sym_traits] = ACTIONS(4855),
    [sym_vector] = ACTIONS(4855),
    [sym_void] = ACTIONS(4855),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2363] = {
    [ts_builtin_sym_end] = ACTIONS(4915),
    [sym_identifier] = ACTIONS(4913),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [anon_sym_DOT] = ACTIONS(4915),
    [anon_sym_SEMI] = ACTIONS(4915),
    [anon_sym_TILDE] = ACTIONS(4915),
    [anon_sym_AT] = ACTIONS(4915),
    [sym_bool] = ACTIONS(4913),
    [sym_byte] = ACTIONS(4913),
    [sym_ubyte] = ACTIONS(4913),
    [sym_char] = ACTIONS(4913),
    [sym_short] = ACTIONS(4913),
    [sym_ushort] = ACTIONS(4913),
    [sym_int] = ACTIONS(4913),
    [sym_uint] = ACTIONS(4913),
    [sym_long] = ACTIONS(4913),
    [sym_ulong] = ACTIONS(4913),
    [sym_cent] = ACTIONS(4913),
    [sym_ucent] = ACTIONS(4913),
    [sym_wchar] = ACTIONS(4913),
    [sym_dchar] = ACTIONS(4913),
    [sym_float] = ACTIONS(4913),
    [sym_double] = ACTIONS(4913),
    [sym_real] = ACTIONS(4913),
    [sym_ifloat] = ACTIONS(4913),
    [sym_idouble] = ACTIONS(4913),
    [sym_ireal] = ACTIONS(4913),
    [sym_cfloat] = ACTIONS(4913),
    [sym_cdouble] = ACTIONS(4913),
    [sym_creal] = ACTIONS(4913),
    [sym_size_t] = ACTIONS(4913),
    [sym_ptrdiff_t] = ACTIONS(4913),
    [sym_string] = ACTIONS(4913),
    [sym_cstring] = ACTIONS(4913),
    [sym_dstring] = ACTIONS(4913),
    [sym_wstring] = ACTIONS(4913),
    [sym_noreturn] = ACTIONS(4913),
    [sym_this] = ACTIONS(4913),
    [sym_abstract] = ACTIONS(4913),
    [sym_alias] = ACTIONS(4913),
    [sym_align] = ACTIONS(4913),
    [sym_auto] = ACTIONS(4913),
    [sym_class] = ACTIONS(4913),
    [sym_const] = ACTIONS(4913),
    [sym_debug] = ACTIONS(4913),
    [sym_deprecated] = ACTIONS(4913),
    [sym_else] = ACTIONS(4913),
    [sym_enum] = ACTIONS(4913),
    [sym_export] = ACTIONS(4913),
    [sym_extern] = ACTIONS(4913),
    [sym_final] = ACTIONS(4913),
    [sym_immutable] = ACTIONS(4913),
    [sym_import] = ACTIONS(4913),
    [sym_inout] = ACTIONS(4913),
    [sym_interface] = ACTIONS(4913),
    [sym_invariant] = ACTIONS(4913),
    [sym_mixin] = ACTIONS(4913),
    [sym_nothrow] = ACTIONS(4913),
    [sym_override] = ACTIONS(4913),
    [sym_package] = ACTIONS(4913),
    [sym_pragma] = ACTIONS(4913),
    [sym_private] = ACTIONS(4913),
    [sym_protected] = ACTIONS(4913),
    [sym_public] = ACTIONS(4913),
    [sym_pure] = ACTIONS(4913),
    [sym_ref] = ACTIONS(4913),
    [sym_return] = ACTIONS(4913),
    [sym_scope] = ACTIONS(4913),
    [sym_shared] = ACTIONS(4913),
    [sym_static] = ACTIONS(4913),
    [sym_struct] = ACTIONS(4913),
    [sym_synchronized] = ACTIONS(4913),
    [sym_template] = ACTIONS(4913),
    [sym_typeof] = ACTIONS(4913),
    [sym_union] = ACTIONS(4913),
    [sym_unittest] = ACTIONS(4913),
    [sym_version] = ACTIONS(4913),
    [sym_while] = ACTIONS(4913),
    [sym_gshared] = ACTIONS(4913),
    [sym_traits] = ACTIONS(4913),
    [sym_vector] = ACTIONS(4913),
    [sym_void] = ACTIONS(4913),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2364] = {
    [ts_builtin_sym_end] = ACTIONS(4993),
    [sym_identifier] = ACTIONS(4991),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_DOT] = ACTIONS(4993),
    [anon_sym_SEMI] = ACTIONS(4993),
    [anon_sym_TILDE] = ACTIONS(4993),
    [anon_sym_AT] = ACTIONS(4993),
    [sym_bool] = ACTIONS(4991),
    [sym_byte] = ACTIONS(4991),
    [sym_ubyte] = ACTIONS(4991),
    [sym_char] = ACTIONS(4991),
    [sym_short] = ACTIONS(4991),
    [sym_ushort] = ACTIONS(4991),
    [sym_int] = ACTIONS(4991),
    [sym_uint] = ACTIONS(4991),
    [sym_long] = ACTIONS(4991),
    [sym_ulong] = ACTIONS(4991),
    [sym_cent] = ACTIONS(4991),
    [sym_ucent] = ACTIONS(4991),
    [sym_wchar] = ACTIONS(4991),
    [sym_dchar] = ACTIONS(4991),
    [sym_float] = ACTIONS(4991),
    [sym_double] = ACTIONS(4991),
    [sym_real] = ACTIONS(4991),
    [sym_ifloat] = ACTIONS(4991),
    [sym_idouble] = ACTIONS(4991),
    [sym_ireal] = ACTIONS(4991),
    [sym_cfloat] = ACTIONS(4991),
    [sym_cdouble] = ACTIONS(4991),
    [sym_creal] = ACTIONS(4991),
    [sym_size_t] = ACTIONS(4991),
    [sym_ptrdiff_t] = ACTIONS(4991),
    [sym_string] = ACTIONS(4991),
    [sym_cstring] = ACTIONS(4991),
    [sym_dstring] = ACTIONS(4991),
    [sym_wstring] = ACTIONS(4991),
    [sym_noreturn] = ACTIONS(4991),
    [sym_this] = ACTIONS(4991),
    [sym_abstract] = ACTIONS(4991),
    [sym_alias] = ACTIONS(4991),
    [sym_align] = ACTIONS(4991),
    [sym_auto] = ACTIONS(4991),
    [sym_class] = ACTIONS(4991),
    [sym_const] = ACTIONS(4991),
    [sym_debug] = ACTIONS(4991),
    [sym_deprecated] = ACTIONS(4991),
    [sym_else] = ACTIONS(4991),
    [sym_enum] = ACTIONS(4991),
    [sym_export] = ACTIONS(4991),
    [sym_extern] = ACTIONS(4991),
    [sym_final] = ACTIONS(4991),
    [sym_immutable] = ACTIONS(4991),
    [sym_import] = ACTIONS(4991),
    [sym_inout] = ACTIONS(4991),
    [sym_interface] = ACTIONS(4991),
    [sym_invariant] = ACTIONS(4991),
    [sym_mixin] = ACTIONS(4991),
    [sym_nothrow] = ACTIONS(4991),
    [sym_override] = ACTIONS(4991),
    [sym_package] = ACTIONS(4991),
    [sym_pragma] = ACTIONS(4991),
    [sym_private] = ACTIONS(4991),
    [sym_protected] = ACTIONS(4991),
    [sym_public] = ACTIONS(4991),
    [sym_pure] = ACTIONS(4991),
    [sym_ref] = ACTIONS(4991),
    [sym_return] = ACTIONS(4991),
    [sym_scope] = ACTIONS(4991),
    [sym_shared] = ACTIONS(4991),
    [sym_static] = ACTIONS(4991),
    [sym_struct] = ACTIONS(4991),
    [sym_synchronized] = ACTIONS(4991),
    [sym_template] = ACTIONS(4991),
    [sym_typeof] = ACTIONS(4991),
    [sym_union] = ACTIONS(4991),
    [sym_unittest] = ACTIONS(4991),
    [sym_version] = ACTIONS(4991),
    [sym_while] = ACTIONS(4991),
    [sym_gshared] = ACTIONS(4991),
    [sym_traits] = ACTIONS(4991),
    [sym_vector] = ACTIONS(4991),
    [sym_void] = ACTIONS(4991),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2365] = {
    [ts_builtin_sym_end] = ACTIONS(4564),
    [sym_identifier] = ACTIONS(4562),
    [anon_sym_RBRACE] = ACTIONS(4564),
    [anon_sym_DOT] = ACTIONS(4564),
    [anon_sym_SEMI] = ACTIONS(4564),
    [anon_sym_TILDE] = ACTIONS(4564),
    [anon_sym_AT] = ACTIONS(4564),
    [sym_bool] = ACTIONS(4562),
    [sym_byte] = ACTIONS(4562),
    [sym_ubyte] = ACTIONS(4562),
    [sym_char] = ACTIONS(4562),
    [sym_short] = ACTIONS(4562),
    [sym_ushort] = ACTIONS(4562),
    [sym_int] = ACTIONS(4562),
    [sym_uint] = ACTIONS(4562),
    [sym_long] = ACTIONS(4562),
    [sym_ulong] = ACTIONS(4562),
    [sym_cent] = ACTIONS(4562),
    [sym_ucent] = ACTIONS(4562),
    [sym_wchar] = ACTIONS(4562),
    [sym_dchar] = ACTIONS(4562),
    [sym_float] = ACTIONS(4562),
    [sym_double] = ACTIONS(4562),
    [sym_real] = ACTIONS(4562),
    [sym_ifloat] = ACTIONS(4562),
    [sym_idouble] = ACTIONS(4562),
    [sym_ireal] = ACTIONS(4562),
    [sym_cfloat] = ACTIONS(4562),
    [sym_cdouble] = ACTIONS(4562),
    [sym_creal] = ACTIONS(4562),
    [sym_size_t] = ACTIONS(4562),
    [sym_ptrdiff_t] = ACTIONS(4562),
    [sym_string] = ACTIONS(4562),
    [sym_cstring] = ACTIONS(4562),
    [sym_dstring] = ACTIONS(4562),
    [sym_wstring] = ACTIONS(4562),
    [sym_noreturn] = ACTIONS(4562),
    [sym_this] = ACTIONS(4562),
    [sym_abstract] = ACTIONS(4562),
    [sym_alias] = ACTIONS(4562),
    [sym_align] = ACTIONS(4562),
    [sym_auto] = ACTIONS(4562),
    [sym_class] = ACTIONS(4562),
    [sym_const] = ACTIONS(4562),
    [sym_debug] = ACTIONS(4562),
    [sym_deprecated] = ACTIONS(4562),
    [sym_else] = ACTIONS(4562),
    [sym_enum] = ACTIONS(4562),
    [sym_export] = ACTIONS(4562),
    [sym_extern] = ACTIONS(4562),
    [sym_final] = ACTIONS(4562),
    [sym_immutable] = ACTIONS(4562),
    [sym_import] = ACTIONS(4562),
    [sym_inout] = ACTIONS(4562),
    [sym_interface] = ACTIONS(4562),
    [sym_invariant] = ACTIONS(4562),
    [sym_mixin] = ACTIONS(4562),
    [sym_nothrow] = ACTIONS(4562),
    [sym_override] = ACTIONS(4562),
    [sym_package] = ACTIONS(4562),
    [sym_pragma] = ACTIONS(4562),
    [sym_private] = ACTIONS(4562),
    [sym_protected] = ACTIONS(4562),
    [sym_public] = ACTIONS(4562),
    [sym_pure] = ACTIONS(4562),
    [sym_ref] = ACTIONS(4562),
    [sym_return] = ACTIONS(4562),
    [sym_scope] = ACTIONS(4562),
    [sym_shared] = ACTIONS(4562),
    [sym_static] = ACTIONS(4562),
    [sym_struct] = ACTIONS(4562),
    [sym_synchronized] = ACTIONS(4562),
    [sym_template] = ACTIONS(4562),
    [sym_typeof] = ACTIONS(4562),
    [sym_union] = ACTIONS(4562),
    [sym_unittest] = ACTIONS(4562),
    [sym_version] = ACTIONS(4562),
    [sym_while] = ACTIONS(4562),
    [sym_gshared] = ACTIONS(4562),
    [sym_traits] = ACTIONS(4562),
    [sym_vector] = ACTIONS(4562),
    [sym_void] = ACTIONS(4562),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2366] = {
    [sym_switch_statement] = STATE(1635),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(183),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2367] = {
    [ts_builtin_sym_end] = ACTIONS(4857),
    [sym_identifier] = ACTIONS(4855),
    [anon_sym_RBRACE] = ACTIONS(4857),
    [anon_sym_DOT] = ACTIONS(4857),
    [anon_sym_SEMI] = ACTIONS(4857),
    [anon_sym_TILDE] = ACTIONS(4857),
    [anon_sym_AT] = ACTIONS(4857),
    [sym_bool] = ACTIONS(4855),
    [sym_byte] = ACTIONS(4855),
    [sym_ubyte] = ACTIONS(4855),
    [sym_char] = ACTIONS(4855),
    [sym_short] = ACTIONS(4855),
    [sym_ushort] = ACTIONS(4855),
    [sym_int] = ACTIONS(4855),
    [sym_uint] = ACTIONS(4855),
    [sym_long] = ACTIONS(4855),
    [sym_ulong] = ACTIONS(4855),
    [sym_cent] = ACTIONS(4855),
    [sym_ucent] = ACTIONS(4855),
    [sym_wchar] = ACTIONS(4855),
    [sym_dchar] = ACTIONS(4855),
    [sym_float] = ACTIONS(4855),
    [sym_double] = ACTIONS(4855),
    [sym_real] = ACTIONS(4855),
    [sym_ifloat] = ACTIONS(4855),
    [sym_idouble] = ACTIONS(4855),
    [sym_ireal] = ACTIONS(4855),
    [sym_cfloat] = ACTIONS(4855),
    [sym_cdouble] = ACTIONS(4855),
    [sym_creal] = ACTIONS(4855),
    [sym_size_t] = ACTIONS(4855),
    [sym_ptrdiff_t] = ACTIONS(4855),
    [sym_string] = ACTIONS(4855),
    [sym_cstring] = ACTIONS(4855),
    [sym_dstring] = ACTIONS(4855),
    [sym_wstring] = ACTIONS(4855),
    [sym_noreturn] = ACTIONS(4855),
    [sym_this] = ACTIONS(4855),
    [sym_abstract] = ACTIONS(4855),
    [sym_alias] = ACTIONS(4855),
    [sym_align] = ACTIONS(4855),
    [sym_auto] = ACTIONS(4855),
    [sym_class] = ACTIONS(4855),
    [sym_const] = ACTIONS(4855),
    [sym_debug] = ACTIONS(4855),
    [sym_deprecated] = ACTIONS(4855),
    [sym_else] = ACTIONS(4855),
    [sym_enum] = ACTIONS(4855),
    [sym_export] = ACTIONS(4855),
    [sym_extern] = ACTIONS(4855),
    [sym_final] = ACTIONS(4855),
    [sym_immutable] = ACTIONS(4855),
    [sym_import] = ACTIONS(4855),
    [sym_inout] = ACTIONS(4855),
    [sym_interface] = ACTIONS(4855),
    [sym_invariant] = ACTIONS(4855),
    [sym_mixin] = ACTIONS(4855),
    [sym_nothrow] = ACTIONS(4855),
    [sym_override] = ACTIONS(4855),
    [sym_package] = ACTIONS(4855),
    [sym_pragma] = ACTIONS(4855),
    [sym_private] = ACTIONS(4855),
    [sym_protected] = ACTIONS(4855),
    [sym_public] = ACTIONS(4855),
    [sym_pure] = ACTIONS(4855),
    [sym_ref] = ACTIONS(4855),
    [sym_return] = ACTIONS(4855),
    [sym_scope] = ACTIONS(4855),
    [sym_shared] = ACTIONS(4855),
    [sym_static] = ACTIONS(4855),
    [sym_struct] = ACTIONS(4855),
    [sym_synchronized] = ACTIONS(4855),
    [sym_template] = ACTIONS(4855),
    [sym_typeof] = ACTIONS(4855),
    [sym_union] = ACTIONS(4855),
    [sym_unittest] = ACTIONS(4855),
    [sym_version] = ACTIONS(4855),
    [sym_while] = ACTIONS(4855),
    [sym_gshared] = ACTIONS(4855),
    [sym_traits] = ACTIONS(4855),
    [sym_vector] = ACTIONS(4855),
    [sym_void] = ACTIONS(4855),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2368] = {
    [sym_identifier] = ACTIONS(4859),
    [anon_sym_DOT] = ACTIONS(4861),
    [anon_sym_SEMI] = ACTIONS(4861),
    [anon_sym_TILDE] = ACTIONS(4861),
    [anon_sym_AT] = ACTIONS(4861),
    [sym_bool] = ACTIONS(4859),
    [sym_byte] = ACTIONS(4859),
    [sym_ubyte] = ACTIONS(4859),
    [sym_char] = ACTIONS(4859),
    [sym_short] = ACTIONS(4859),
    [sym_ushort] = ACTIONS(4859),
    [sym_int] = ACTIONS(4859),
    [sym_uint] = ACTIONS(4859),
    [sym_long] = ACTIONS(4859),
    [sym_ulong] = ACTIONS(4859),
    [sym_cent] = ACTIONS(4859),
    [sym_ucent] = ACTIONS(4859),
    [sym_wchar] = ACTIONS(4859),
    [sym_dchar] = ACTIONS(4859),
    [sym_float] = ACTIONS(4859),
    [sym_double] = ACTIONS(4859),
    [sym_real] = ACTIONS(4859),
    [sym_ifloat] = ACTIONS(4859),
    [sym_idouble] = ACTIONS(4859),
    [sym_ireal] = ACTIONS(4859),
    [sym_cfloat] = ACTIONS(4859),
    [sym_cdouble] = ACTIONS(4859),
    [sym_creal] = ACTIONS(4859),
    [sym_size_t] = ACTIONS(4859),
    [sym_ptrdiff_t] = ACTIONS(4859),
    [sym_string] = ACTIONS(4859),
    [sym_cstring] = ACTIONS(4859),
    [sym_dstring] = ACTIONS(4859),
    [sym_wstring] = ACTIONS(4859),
    [sym_noreturn] = ACTIONS(4859),
    [sym_this] = ACTIONS(4859),
    [sym_abstract] = ACTIONS(4859),
    [sym_alias] = ACTIONS(4859),
    [sym_align] = ACTIONS(4859),
    [sym_auto] = ACTIONS(4859),
    [sym_catch] = ACTIONS(4859),
    [sym_class] = ACTIONS(4859),
    [sym_const] = ACTIONS(4859),
    [sym_debug] = ACTIONS(4859),
    [sym_deprecated] = ACTIONS(4859),
    [sym_else] = ACTIONS(4859),
    [sym_enum] = ACTIONS(4859),
    [sym_export] = ACTIONS(4859),
    [sym_extern] = ACTIONS(4859),
    [sym_final] = ACTIONS(4859),
    [sym_finally] = ACTIONS(4859),
    [sym_immutable] = ACTIONS(4859),
    [sym_import] = ACTIONS(4859),
    [sym_inout] = ACTIONS(4859),
    [sym_interface] = ACTIONS(4859),
    [sym_invariant] = ACTIONS(4859),
    [sym_mixin] = ACTIONS(4859),
    [sym_nothrow] = ACTIONS(4859),
    [sym_override] = ACTIONS(4859),
    [sym_package] = ACTIONS(4859),
    [sym_pragma] = ACTIONS(4859),
    [sym_private] = ACTIONS(4859),
    [sym_protected] = ACTIONS(4859),
    [sym_public] = ACTIONS(4859),
    [sym_pure] = ACTIONS(4859),
    [sym_ref] = ACTIONS(4859),
    [sym_return] = ACTIONS(4859),
    [sym_scope] = ACTIONS(4859),
    [sym_shared] = ACTIONS(4859),
    [sym_static] = ACTIONS(4859),
    [sym_struct] = ACTIONS(4859),
    [sym_synchronized] = ACTIONS(4859),
    [sym_template] = ACTIONS(4859),
    [sym_typeof] = ACTIONS(4859),
    [sym_union] = ACTIONS(4859),
    [sym_unittest] = ACTIONS(4859),
    [sym_version] = ACTIONS(4859),
    [sym_while] = ACTIONS(4859),
    [sym_gshared] = ACTIONS(4859),
    [sym_traits] = ACTIONS(4859),
    [sym_vector] = ACTIONS(4859),
    [sym_void] = ACTIONS(4859),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2369] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_else] = ACTIONS(6080),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_finally] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2370] = {
    [ts_builtin_sym_end] = ACTIONS(4548),
    [sym_identifier] = ACTIONS(4546),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_DOT] = ACTIONS(4548),
    [anon_sym_SEMI] = ACTIONS(4548),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_AT] = ACTIONS(4548),
    [sym_bool] = ACTIONS(4546),
    [sym_byte] = ACTIONS(4546),
    [sym_ubyte] = ACTIONS(4546),
    [sym_char] = ACTIONS(4546),
    [sym_short] = ACTIONS(4546),
    [sym_ushort] = ACTIONS(4546),
    [sym_int] = ACTIONS(4546),
    [sym_uint] = ACTIONS(4546),
    [sym_long] = ACTIONS(4546),
    [sym_ulong] = ACTIONS(4546),
    [sym_cent] = ACTIONS(4546),
    [sym_ucent] = ACTIONS(4546),
    [sym_wchar] = ACTIONS(4546),
    [sym_dchar] = ACTIONS(4546),
    [sym_float] = ACTIONS(4546),
    [sym_double] = ACTIONS(4546),
    [sym_real] = ACTIONS(4546),
    [sym_ifloat] = ACTIONS(4546),
    [sym_idouble] = ACTIONS(4546),
    [sym_ireal] = ACTIONS(4546),
    [sym_cfloat] = ACTIONS(4546),
    [sym_cdouble] = ACTIONS(4546),
    [sym_creal] = ACTIONS(4546),
    [sym_size_t] = ACTIONS(4546),
    [sym_ptrdiff_t] = ACTIONS(4546),
    [sym_string] = ACTIONS(4546),
    [sym_cstring] = ACTIONS(4546),
    [sym_dstring] = ACTIONS(4546),
    [sym_wstring] = ACTIONS(4546),
    [sym_noreturn] = ACTIONS(4546),
    [sym_this] = ACTIONS(4546),
    [sym_abstract] = ACTIONS(4546),
    [sym_alias] = ACTIONS(4546),
    [sym_align] = ACTIONS(4546),
    [sym_auto] = ACTIONS(4546),
    [sym_class] = ACTIONS(4546),
    [sym_const] = ACTIONS(4546),
    [sym_debug] = ACTIONS(4546),
    [sym_deprecated] = ACTIONS(4546),
    [sym_else] = ACTIONS(4546),
    [sym_enum] = ACTIONS(4546),
    [sym_export] = ACTIONS(4546),
    [sym_extern] = ACTIONS(4546),
    [sym_final] = ACTIONS(4546),
    [sym_immutable] = ACTIONS(4546),
    [sym_import] = ACTIONS(4546),
    [sym_inout] = ACTIONS(4546),
    [sym_interface] = ACTIONS(4546),
    [sym_invariant] = ACTIONS(4546),
    [sym_mixin] = ACTIONS(4546),
    [sym_nothrow] = ACTIONS(4546),
    [sym_override] = ACTIONS(4546),
    [sym_package] = ACTIONS(4546),
    [sym_pragma] = ACTIONS(4546),
    [sym_private] = ACTIONS(4546),
    [sym_protected] = ACTIONS(4546),
    [sym_public] = ACTIONS(4546),
    [sym_pure] = ACTIONS(4546),
    [sym_ref] = ACTIONS(4546),
    [sym_return] = ACTIONS(4546),
    [sym_scope] = ACTIONS(4546),
    [sym_shared] = ACTIONS(4546),
    [sym_static] = ACTIONS(4546),
    [sym_struct] = ACTIONS(4546),
    [sym_synchronized] = ACTIONS(4546),
    [sym_template] = ACTIONS(4546),
    [sym_typeof] = ACTIONS(4546),
    [sym_union] = ACTIONS(4546),
    [sym_unittest] = ACTIONS(4546),
    [sym_version] = ACTIONS(4546),
    [sym_while] = ACTIONS(4546),
    [sym_gshared] = ACTIONS(4546),
    [sym_traits] = ACTIONS(4546),
    [sym_vector] = ACTIONS(4546),
    [sym_void] = ACTIONS(4546),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2371] = {
    [sym_identifier] = ACTIONS(4634),
    [anon_sym_DOT] = ACTIONS(4636),
    [anon_sym_SEMI] = ACTIONS(4636),
    [anon_sym_TILDE] = ACTIONS(4636),
    [anon_sym_AT] = ACTIONS(4636),
    [sym_bool] = ACTIONS(4634),
    [sym_byte] = ACTIONS(4634),
    [sym_ubyte] = ACTIONS(4634),
    [sym_char] = ACTIONS(4634),
    [sym_short] = ACTIONS(4634),
    [sym_ushort] = ACTIONS(4634),
    [sym_int] = ACTIONS(4634),
    [sym_uint] = ACTIONS(4634),
    [sym_long] = ACTIONS(4634),
    [sym_ulong] = ACTIONS(4634),
    [sym_cent] = ACTIONS(4634),
    [sym_ucent] = ACTIONS(4634),
    [sym_wchar] = ACTIONS(4634),
    [sym_dchar] = ACTIONS(4634),
    [sym_float] = ACTIONS(4634),
    [sym_double] = ACTIONS(4634),
    [sym_real] = ACTIONS(4634),
    [sym_ifloat] = ACTIONS(4634),
    [sym_idouble] = ACTIONS(4634),
    [sym_ireal] = ACTIONS(4634),
    [sym_cfloat] = ACTIONS(4634),
    [sym_cdouble] = ACTIONS(4634),
    [sym_creal] = ACTIONS(4634),
    [sym_size_t] = ACTIONS(4634),
    [sym_ptrdiff_t] = ACTIONS(4634),
    [sym_string] = ACTIONS(4634),
    [sym_cstring] = ACTIONS(4634),
    [sym_dstring] = ACTIONS(4634),
    [sym_wstring] = ACTIONS(4634),
    [sym_noreturn] = ACTIONS(4634),
    [sym_this] = ACTIONS(4634),
    [sym_abstract] = ACTIONS(4634),
    [sym_alias] = ACTIONS(4634),
    [sym_align] = ACTIONS(4634),
    [sym_auto] = ACTIONS(4634),
    [sym_catch] = ACTIONS(4634),
    [sym_class] = ACTIONS(4634),
    [sym_const] = ACTIONS(4634),
    [sym_debug] = ACTIONS(4634),
    [sym_deprecated] = ACTIONS(4634),
    [sym_else] = ACTIONS(4634),
    [sym_enum] = ACTIONS(4634),
    [sym_export] = ACTIONS(4634),
    [sym_extern] = ACTIONS(4634),
    [sym_final] = ACTIONS(4634),
    [sym_finally] = ACTIONS(4634),
    [sym_immutable] = ACTIONS(4634),
    [sym_import] = ACTIONS(4634),
    [sym_inout] = ACTIONS(4634),
    [sym_interface] = ACTIONS(4634),
    [sym_invariant] = ACTIONS(4634),
    [sym_mixin] = ACTIONS(4634),
    [sym_nothrow] = ACTIONS(4634),
    [sym_override] = ACTIONS(4634),
    [sym_package] = ACTIONS(4634),
    [sym_pragma] = ACTIONS(4634),
    [sym_private] = ACTIONS(4634),
    [sym_protected] = ACTIONS(4634),
    [sym_public] = ACTIONS(4634),
    [sym_pure] = ACTIONS(4634),
    [sym_ref] = ACTIONS(4634),
    [sym_return] = ACTIONS(4634),
    [sym_scope] = ACTIONS(4634),
    [sym_shared] = ACTIONS(4634),
    [sym_static] = ACTIONS(4634),
    [sym_struct] = ACTIONS(4634),
    [sym_synchronized] = ACTIONS(4634),
    [sym_template] = ACTIONS(4634),
    [sym_typeof] = ACTIONS(4634),
    [sym_union] = ACTIONS(4634),
    [sym_unittest] = ACTIONS(4634),
    [sym_version] = ACTIONS(4634),
    [sym_while] = ACTIONS(4634),
    [sym_gshared] = ACTIONS(4634),
    [sym_traits] = ACTIONS(4634),
    [sym_vector] = ACTIONS(4634),
    [sym_void] = ACTIONS(4634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2372] = {
    [sym_identifier] = ACTIONS(4865),
    [anon_sym_DOT] = ACTIONS(4867),
    [anon_sym_SEMI] = ACTIONS(4867),
    [anon_sym_TILDE] = ACTIONS(4867),
    [anon_sym_AT] = ACTIONS(4867),
    [sym_bool] = ACTIONS(4865),
    [sym_byte] = ACTIONS(4865),
    [sym_ubyte] = ACTIONS(4865),
    [sym_char] = ACTIONS(4865),
    [sym_short] = ACTIONS(4865),
    [sym_ushort] = ACTIONS(4865),
    [sym_int] = ACTIONS(4865),
    [sym_uint] = ACTIONS(4865),
    [sym_long] = ACTIONS(4865),
    [sym_ulong] = ACTIONS(4865),
    [sym_cent] = ACTIONS(4865),
    [sym_ucent] = ACTIONS(4865),
    [sym_wchar] = ACTIONS(4865),
    [sym_dchar] = ACTIONS(4865),
    [sym_float] = ACTIONS(4865),
    [sym_double] = ACTIONS(4865),
    [sym_real] = ACTIONS(4865),
    [sym_ifloat] = ACTIONS(4865),
    [sym_idouble] = ACTIONS(4865),
    [sym_ireal] = ACTIONS(4865),
    [sym_cfloat] = ACTIONS(4865),
    [sym_cdouble] = ACTIONS(4865),
    [sym_creal] = ACTIONS(4865),
    [sym_size_t] = ACTIONS(4865),
    [sym_ptrdiff_t] = ACTIONS(4865),
    [sym_string] = ACTIONS(4865),
    [sym_cstring] = ACTIONS(4865),
    [sym_dstring] = ACTIONS(4865),
    [sym_wstring] = ACTIONS(4865),
    [sym_noreturn] = ACTIONS(4865),
    [sym_this] = ACTIONS(4865),
    [sym_abstract] = ACTIONS(4865),
    [sym_alias] = ACTIONS(4865),
    [sym_align] = ACTIONS(4865),
    [sym_auto] = ACTIONS(4865),
    [sym_catch] = ACTIONS(4865),
    [sym_class] = ACTIONS(4865),
    [sym_const] = ACTIONS(4865),
    [sym_debug] = ACTIONS(4865),
    [sym_deprecated] = ACTIONS(4865),
    [sym_else] = ACTIONS(4865),
    [sym_enum] = ACTIONS(4865),
    [sym_export] = ACTIONS(4865),
    [sym_extern] = ACTIONS(4865),
    [sym_final] = ACTIONS(4865),
    [sym_finally] = ACTIONS(4865),
    [sym_immutable] = ACTIONS(4865),
    [sym_import] = ACTIONS(4865),
    [sym_inout] = ACTIONS(4865),
    [sym_interface] = ACTIONS(4865),
    [sym_invariant] = ACTIONS(4865),
    [sym_mixin] = ACTIONS(4865),
    [sym_nothrow] = ACTIONS(4865),
    [sym_override] = ACTIONS(4865),
    [sym_package] = ACTIONS(4865),
    [sym_pragma] = ACTIONS(4865),
    [sym_private] = ACTIONS(4865),
    [sym_protected] = ACTIONS(4865),
    [sym_public] = ACTIONS(4865),
    [sym_pure] = ACTIONS(4865),
    [sym_ref] = ACTIONS(4865),
    [sym_return] = ACTIONS(4865),
    [sym_scope] = ACTIONS(4865),
    [sym_shared] = ACTIONS(4865),
    [sym_static] = ACTIONS(4865),
    [sym_struct] = ACTIONS(4865),
    [sym_synchronized] = ACTIONS(4865),
    [sym_template] = ACTIONS(4865),
    [sym_typeof] = ACTIONS(4865),
    [sym_union] = ACTIONS(4865),
    [sym_unittest] = ACTIONS(4865),
    [sym_version] = ACTIONS(4865),
    [sym_while] = ACTIONS(4865),
    [sym_gshared] = ACTIONS(4865),
    [sym_traits] = ACTIONS(4865),
    [sym_vector] = ACTIONS(4865),
    [sym_void] = ACTIONS(4865),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2373] = {
    [sym_identifier] = ACTIONS(4869),
    [anon_sym_DOT] = ACTIONS(4871),
    [anon_sym_SEMI] = ACTIONS(4871),
    [anon_sym_TILDE] = ACTIONS(4871),
    [anon_sym_AT] = ACTIONS(4871),
    [sym_bool] = ACTIONS(4869),
    [sym_byte] = ACTIONS(4869),
    [sym_ubyte] = ACTIONS(4869),
    [sym_char] = ACTIONS(4869),
    [sym_short] = ACTIONS(4869),
    [sym_ushort] = ACTIONS(4869),
    [sym_int] = ACTIONS(4869),
    [sym_uint] = ACTIONS(4869),
    [sym_long] = ACTIONS(4869),
    [sym_ulong] = ACTIONS(4869),
    [sym_cent] = ACTIONS(4869),
    [sym_ucent] = ACTIONS(4869),
    [sym_wchar] = ACTIONS(4869),
    [sym_dchar] = ACTIONS(4869),
    [sym_float] = ACTIONS(4869),
    [sym_double] = ACTIONS(4869),
    [sym_real] = ACTIONS(4869),
    [sym_ifloat] = ACTIONS(4869),
    [sym_idouble] = ACTIONS(4869),
    [sym_ireal] = ACTIONS(4869),
    [sym_cfloat] = ACTIONS(4869),
    [sym_cdouble] = ACTIONS(4869),
    [sym_creal] = ACTIONS(4869),
    [sym_size_t] = ACTIONS(4869),
    [sym_ptrdiff_t] = ACTIONS(4869),
    [sym_string] = ACTIONS(4869),
    [sym_cstring] = ACTIONS(4869),
    [sym_dstring] = ACTIONS(4869),
    [sym_wstring] = ACTIONS(4869),
    [sym_noreturn] = ACTIONS(4869),
    [sym_this] = ACTIONS(4869),
    [sym_abstract] = ACTIONS(4869),
    [sym_alias] = ACTIONS(4869),
    [sym_align] = ACTIONS(4869),
    [sym_auto] = ACTIONS(4869),
    [sym_catch] = ACTIONS(4869),
    [sym_class] = ACTIONS(4869),
    [sym_const] = ACTIONS(4869),
    [sym_debug] = ACTIONS(4869),
    [sym_deprecated] = ACTIONS(4869),
    [sym_else] = ACTIONS(4869),
    [sym_enum] = ACTIONS(4869),
    [sym_export] = ACTIONS(4869),
    [sym_extern] = ACTIONS(4869),
    [sym_final] = ACTIONS(4869),
    [sym_finally] = ACTIONS(4869),
    [sym_immutable] = ACTIONS(4869),
    [sym_import] = ACTIONS(4869),
    [sym_inout] = ACTIONS(4869),
    [sym_interface] = ACTIONS(4869),
    [sym_invariant] = ACTIONS(4869),
    [sym_mixin] = ACTIONS(4869),
    [sym_nothrow] = ACTIONS(4869),
    [sym_override] = ACTIONS(4869),
    [sym_package] = ACTIONS(4869),
    [sym_pragma] = ACTIONS(4869),
    [sym_private] = ACTIONS(4869),
    [sym_protected] = ACTIONS(4869),
    [sym_public] = ACTIONS(4869),
    [sym_pure] = ACTIONS(4869),
    [sym_ref] = ACTIONS(4869),
    [sym_return] = ACTIONS(4869),
    [sym_scope] = ACTIONS(4869),
    [sym_shared] = ACTIONS(4869),
    [sym_static] = ACTIONS(4869),
    [sym_struct] = ACTIONS(4869),
    [sym_synchronized] = ACTIONS(4869),
    [sym_template] = ACTIONS(4869),
    [sym_typeof] = ACTIONS(4869),
    [sym_union] = ACTIONS(4869),
    [sym_unittest] = ACTIONS(4869),
    [sym_version] = ACTIONS(4869),
    [sym_while] = ACTIONS(4869),
    [sym_gshared] = ACTIONS(4869),
    [sym_traits] = ACTIONS(4869),
    [sym_vector] = ACTIONS(4869),
    [sym_void] = ACTIONS(4869),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2374] = {
    [ts_builtin_sym_end] = ACTIONS(4775),
    [sym_identifier] = ACTIONS(4773),
    [anon_sym_RBRACE] = ACTIONS(4775),
    [anon_sym_DOT] = ACTIONS(4775),
    [anon_sym_SEMI] = ACTIONS(4775),
    [anon_sym_TILDE] = ACTIONS(4775),
    [anon_sym_AT] = ACTIONS(4775),
    [sym_bool] = ACTIONS(4773),
    [sym_byte] = ACTIONS(4773),
    [sym_ubyte] = ACTIONS(4773),
    [sym_char] = ACTIONS(4773),
    [sym_short] = ACTIONS(4773),
    [sym_ushort] = ACTIONS(4773),
    [sym_int] = ACTIONS(4773),
    [sym_uint] = ACTIONS(4773),
    [sym_long] = ACTIONS(4773),
    [sym_ulong] = ACTIONS(4773),
    [sym_cent] = ACTIONS(4773),
    [sym_ucent] = ACTIONS(4773),
    [sym_wchar] = ACTIONS(4773),
    [sym_dchar] = ACTIONS(4773),
    [sym_float] = ACTIONS(4773),
    [sym_double] = ACTIONS(4773),
    [sym_real] = ACTIONS(4773),
    [sym_ifloat] = ACTIONS(4773),
    [sym_idouble] = ACTIONS(4773),
    [sym_ireal] = ACTIONS(4773),
    [sym_cfloat] = ACTIONS(4773),
    [sym_cdouble] = ACTIONS(4773),
    [sym_creal] = ACTIONS(4773),
    [sym_size_t] = ACTIONS(4773),
    [sym_ptrdiff_t] = ACTIONS(4773),
    [sym_string] = ACTIONS(4773),
    [sym_cstring] = ACTIONS(4773),
    [sym_dstring] = ACTIONS(4773),
    [sym_wstring] = ACTIONS(4773),
    [sym_noreturn] = ACTIONS(4773),
    [sym_this] = ACTIONS(4773),
    [sym_abstract] = ACTIONS(4773),
    [sym_alias] = ACTIONS(4773),
    [sym_align] = ACTIONS(4773),
    [sym_auto] = ACTIONS(4773),
    [sym_class] = ACTIONS(4773),
    [sym_const] = ACTIONS(4773),
    [sym_debug] = ACTIONS(4773),
    [sym_deprecated] = ACTIONS(4773),
    [sym_else] = ACTIONS(4773),
    [sym_enum] = ACTIONS(4773),
    [sym_export] = ACTIONS(4773),
    [sym_extern] = ACTIONS(4773),
    [sym_final] = ACTIONS(4773),
    [sym_immutable] = ACTIONS(4773),
    [sym_import] = ACTIONS(4773),
    [sym_inout] = ACTIONS(4773),
    [sym_interface] = ACTIONS(4773),
    [sym_invariant] = ACTIONS(4773),
    [sym_mixin] = ACTIONS(4773),
    [sym_nothrow] = ACTIONS(4773),
    [sym_override] = ACTIONS(4773),
    [sym_package] = ACTIONS(4773),
    [sym_pragma] = ACTIONS(4773),
    [sym_private] = ACTIONS(4773),
    [sym_protected] = ACTIONS(4773),
    [sym_public] = ACTIONS(4773),
    [sym_pure] = ACTIONS(4773),
    [sym_ref] = ACTIONS(4773),
    [sym_return] = ACTIONS(4773),
    [sym_scope] = ACTIONS(4773),
    [sym_shared] = ACTIONS(4773),
    [sym_static] = ACTIONS(4773),
    [sym_struct] = ACTIONS(4773),
    [sym_synchronized] = ACTIONS(4773),
    [sym_template] = ACTIONS(4773),
    [sym_typeof] = ACTIONS(4773),
    [sym_union] = ACTIONS(4773),
    [sym_unittest] = ACTIONS(4773),
    [sym_version] = ACTIONS(4773),
    [sym_while] = ACTIONS(4773),
    [sym_gshared] = ACTIONS(4773),
    [sym_traits] = ACTIONS(4773),
    [sym_vector] = ACTIONS(4773),
    [sym_void] = ACTIONS(4773),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2375] = {
    [sym_switch_statement] = STATE(4686),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1036),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2376] = {
    [sym_switch_statement] = STATE(4686),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1796),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2377] = {
    [ts_builtin_sym_end] = ACTIONS(4544),
    [sym_identifier] = ACTIONS(4542),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_DOT] = ACTIONS(4544),
    [anon_sym_SEMI] = ACTIONS(4544),
    [anon_sym_TILDE] = ACTIONS(4544),
    [anon_sym_AT] = ACTIONS(4544),
    [sym_bool] = ACTIONS(4542),
    [sym_byte] = ACTIONS(4542),
    [sym_ubyte] = ACTIONS(4542),
    [sym_char] = ACTIONS(4542),
    [sym_short] = ACTIONS(4542),
    [sym_ushort] = ACTIONS(4542),
    [sym_int] = ACTIONS(4542),
    [sym_uint] = ACTIONS(4542),
    [sym_long] = ACTIONS(4542),
    [sym_ulong] = ACTIONS(4542),
    [sym_cent] = ACTIONS(4542),
    [sym_ucent] = ACTIONS(4542),
    [sym_wchar] = ACTIONS(4542),
    [sym_dchar] = ACTIONS(4542),
    [sym_float] = ACTIONS(4542),
    [sym_double] = ACTIONS(4542),
    [sym_real] = ACTIONS(4542),
    [sym_ifloat] = ACTIONS(4542),
    [sym_idouble] = ACTIONS(4542),
    [sym_ireal] = ACTIONS(4542),
    [sym_cfloat] = ACTIONS(4542),
    [sym_cdouble] = ACTIONS(4542),
    [sym_creal] = ACTIONS(4542),
    [sym_size_t] = ACTIONS(4542),
    [sym_ptrdiff_t] = ACTIONS(4542),
    [sym_string] = ACTIONS(4542),
    [sym_cstring] = ACTIONS(4542),
    [sym_dstring] = ACTIONS(4542),
    [sym_wstring] = ACTIONS(4542),
    [sym_noreturn] = ACTIONS(4542),
    [sym_this] = ACTIONS(4542),
    [sym_abstract] = ACTIONS(4542),
    [sym_alias] = ACTIONS(4542),
    [sym_align] = ACTIONS(4542),
    [sym_auto] = ACTIONS(4542),
    [sym_class] = ACTIONS(4542),
    [sym_const] = ACTIONS(4542),
    [sym_debug] = ACTIONS(4542),
    [sym_deprecated] = ACTIONS(4542),
    [sym_else] = ACTIONS(4542),
    [sym_enum] = ACTIONS(4542),
    [sym_export] = ACTIONS(4542),
    [sym_extern] = ACTIONS(4542),
    [sym_final] = ACTIONS(4542),
    [sym_immutable] = ACTIONS(4542),
    [sym_import] = ACTIONS(4542),
    [sym_inout] = ACTIONS(4542),
    [sym_interface] = ACTIONS(4542),
    [sym_invariant] = ACTIONS(4542),
    [sym_mixin] = ACTIONS(4542),
    [sym_nothrow] = ACTIONS(4542),
    [sym_override] = ACTIONS(4542),
    [sym_package] = ACTIONS(4542),
    [sym_pragma] = ACTIONS(4542),
    [sym_private] = ACTIONS(4542),
    [sym_protected] = ACTIONS(4542),
    [sym_public] = ACTIONS(4542),
    [sym_pure] = ACTIONS(4542),
    [sym_ref] = ACTIONS(4542),
    [sym_return] = ACTIONS(4542),
    [sym_scope] = ACTIONS(4542),
    [sym_shared] = ACTIONS(4542),
    [sym_static] = ACTIONS(4542),
    [sym_struct] = ACTIONS(4542),
    [sym_synchronized] = ACTIONS(4542),
    [sym_template] = ACTIONS(4542),
    [sym_typeof] = ACTIONS(4542),
    [sym_union] = ACTIONS(4542),
    [sym_unittest] = ACTIONS(4542),
    [sym_version] = ACTIONS(4542),
    [sym_while] = ACTIONS(4542),
    [sym_gshared] = ACTIONS(4542),
    [sym_traits] = ACTIONS(4542),
    [sym_vector] = ACTIONS(4542),
    [sym_void] = ACTIONS(4542),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2378] = {
    [sym_switch_statement] = STATE(2025),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1092),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2379] = {
    [sym_switch_statement] = STATE(2025),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(1158),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2380] = {
    [sym_identifier] = ACTIONS(2634),
    [anon_sym_DOT] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [anon_sym_TILDE] = ACTIONS(2632),
    [anon_sym_AT] = ACTIONS(2632),
    [sym_bool] = ACTIONS(2634),
    [sym_byte] = ACTIONS(2634),
    [sym_ubyte] = ACTIONS(2634),
    [sym_char] = ACTIONS(2634),
    [sym_short] = ACTIONS(2634),
    [sym_ushort] = ACTIONS(2634),
    [sym_int] = ACTIONS(2634),
    [sym_uint] = ACTIONS(2634),
    [sym_long] = ACTIONS(2634),
    [sym_ulong] = ACTIONS(2634),
    [sym_cent] = ACTIONS(2634),
    [sym_ucent] = ACTIONS(2634),
    [sym_wchar] = ACTIONS(2634),
    [sym_dchar] = ACTIONS(2634),
    [sym_float] = ACTIONS(2634),
    [sym_double] = ACTIONS(2634),
    [sym_real] = ACTIONS(2634),
    [sym_ifloat] = ACTIONS(2634),
    [sym_idouble] = ACTIONS(2634),
    [sym_ireal] = ACTIONS(2634),
    [sym_cfloat] = ACTIONS(2634),
    [sym_cdouble] = ACTIONS(2634),
    [sym_creal] = ACTIONS(2634),
    [sym_size_t] = ACTIONS(2634),
    [sym_ptrdiff_t] = ACTIONS(2634),
    [sym_string] = ACTIONS(2634),
    [sym_cstring] = ACTIONS(2634),
    [sym_dstring] = ACTIONS(2634),
    [sym_wstring] = ACTIONS(2634),
    [sym_noreturn] = ACTIONS(2634),
    [sym_this] = ACTIONS(2634),
    [sym_abstract] = ACTIONS(2634),
    [sym_alias] = ACTIONS(2634),
    [sym_align] = ACTIONS(2634),
    [sym_auto] = ACTIONS(2634),
    [sym_catch] = ACTIONS(2634),
    [sym_class] = ACTIONS(2634),
    [sym_const] = ACTIONS(2634),
    [sym_debug] = ACTIONS(2634),
    [sym_deprecated] = ACTIONS(2634),
    [sym_else] = ACTIONS(6082),
    [sym_enum] = ACTIONS(2634),
    [sym_export] = ACTIONS(2634),
    [sym_extern] = ACTIONS(2634),
    [sym_final] = ACTIONS(2634),
    [sym_finally] = ACTIONS(2634),
    [sym_immutable] = ACTIONS(2634),
    [sym_import] = ACTIONS(2634),
    [sym_inout] = ACTIONS(2634),
    [sym_interface] = ACTIONS(2634),
    [sym_invariant] = ACTIONS(2634),
    [sym_mixin] = ACTIONS(2634),
    [sym_nothrow] = ACTIONS(2634),
    [sym_override] = ACTIONS(2634),
    [sym_package] = ACTIONS(2634),
    [sym_pragma] = ACTIONS(2634),
    [sym_private] = ACTIONS(2634),
    [sym_protected] = ACTIONS(2634),
    [sym_public] = ACTIONS(2634),
    [sym_pure] = ACTIONS(2634),
    [sym_ref] = ACTIONS(2634),
    [sym_return] = ACTIONS(2634),
    [sym_scope] = ACTIONS(2634),
    [sym_shared] = ACTIONS(2634),
    [sym_static] = ACTIONS(2634),
    [sym_struct] = ACTIONS(2634),
    [sym_synchronized] = ACTIONS(2634),
    [sym_template] = ACTIONS(2634),
    [sym_typeof] = ACTIONS(2634),
    [sym_union] = ACTIONS(2634),
    [sym_unittest] = ACTIONS(2634),
    [sym_version] = ACTIONS(2634),
    [sym_while] = ACTIONS(2634),
    [sym_gshared] = ACTIONS(2634),
    [sym_traits] = ACTIONS(2634),
    [sym_vector] = ACTIONS(2634),
    [sym_void] = ACTIONS(2634),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2381] = {
    [sym_identifier] = ACTIONS(4741),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [anon_sym_AT] = ACTIONS(4743),
    [sym_bool] = ACTIONS(4741),
    [sym_byte] = ACTIONS(4741),
    [sym_ubyte] = ACTIONS(4741),
    [sym_char] = ACTIONS(4741),
    [sym_short] = ACTIONS(4741),
    [sym_ushort] = ACTIONS(4741),
    [sym_int] = ACTIONS(4741),
    [sym_uint] = ACTIONS(4741),
    [sym_long] = ACTIONS(4741),
    [sym_ulong] = ACTIONS(4741),
    [sym_cent] = ACTIONS(4741),
    [sym_ucent] = ACTIONS(4741),
    [sym_wchar] = ACTIONS(4741),
    [sym_dchar] = ACTIONS(4741),
    [sym_float] = ACTIONS(4741),
    [sym_double] = ACTIONS(4741),
    [sym_real] = ACTIONS(4741),
    [sym_ifloat] = ACTIONS(4741),
    [sym_idouble] = ACTIONS(4741),
    [sym_ireal] = ACTIONS(4741),
    [sym_cfloat] = ACTIONS(4741),
    [sym_cdouble] = ACTIONS(4741),
    [sym_creal] = ACTIONS(4741),
    [sym_size_t] = ACTIONS(4741),
    [sym_ptrdiff_t] = ACTIONS(4741),
    [sym_string] = ACTIONS(4741),
    [sym_cstring] = ACTIONS(4741),
    [sym_dstring] = ACTIONS(4741),
    [sym_wstring] = ACTIONS(4741),
    [sym_noreturn] = ACTIONS(4741),
    [sym_this] = ACTIONS(4741),
    [sym_abstract] = ACTIONS(4741),
    [sym_alias] = ACTIONS(4741),
    [sym_align] = ACTIONS(4741),
    [sym_auto] = ACTIONS(4741),
    [sym_catch] = ACTIONS(4741),
    [sym_class] = ACTIONS(4741),
    [sym_const] = ACTIONS(4741),
    [sym_debug] = ACTIONS(4741),
    [sym_deprecated] = ACTIONS(4741),
    [sym_else] = ACTIONS(6084),
    [sym_enum] = ACTIONS(4741),
    [sym_export] = ACTIONS(4741),
    [sym_extern] = ACTIONS(4741),
    [sym_final] = ACTIONS(4741),
    [sym_finally] = ACTIONS(4741),
    [sym_immutable] = ACTIONS(4741),
    [sym_import] = ACTIONS(4741),
    [sym_inout] = ACTIONS(4741),
    [sym_interface] = ACTIONS(4741),
    [sym_invariant] = ACTIONS(4741),
    [sym_mixin] = ACTIONS(4741),
    [sym_nothrow] = ACTIONS(4741),
    [sym_override] = ACTIONS(4741),
    [sym_package] = ACTIONS(4741),
    [sym_pragma] = ACTIONS(4741),
    [sym_private] = ACTIONS(4741),
    [sym_protected] = ACTIONS(4741),
    [sym_public] = ACTIONS(4741),
    [sym_pure] = ACTIONS(4741),
    [sym_ref] = ACTIONS(4741),
    [sym_return] = ACTIONS(4741),
    [sym_scope] = ACTIONS(4741),
    [sym_shared] = ACTIONS(4741),
    [sym_static] = ACTIONS(4741),
    [sym_struct] = ACTIONS(4741),
    [sym_synchronized] = ACTIONS(4741),
    [sym_template] = ACTIONS(4741),
    [sym_typeof] = ACTIONS(4741),
    [sym_union] = ACTIONS(4741),
    [sym_unittest] = ACTIONS(4741),
    [sym_version] = ACTIONS(4741),
    [sym_while] = ACTIONS(4741),
    [sym_gshared] = ACTIONS(4741),
    [sym_traits] = ACTIONS(4741),
    [sym_vector] = ACTIONS(4741),
    [sym_void] = ACTIONS(4741),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2382] = {
    [ts_builtin_sym_end] = ACTIONS(4532),
    [sym_identifier] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_DOT] = ACTIONS(4532),
    [anon_sym_SEMI] = ACTIONS(4532),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_AT] = ACTIONS(4532),
    [sym_bool] = ACTIONS(4530),
    [sym_byte] = ACTIONS(4530),
    [sym_ubyte] = ACTIONS(4530),
    [sym_char] = ACTIONS(4530),
    [sym_short] = ACTIONS(4530),
    [sym_ushort] = ACTIONS(4530),
    [sym_int] = ACTIONS(4530),
    [sym_uint] = ACTIONS(4530),
    [sym_long] = ACTIONS(4530),
    [sym_ulong] = ACTIONS(4530),
    [sym_cent] = ACTIONS(4530),
    [sym_ucent] = ACTIONS(4530),
    [sym_wchar] = ACTIONS(4530),
    [sym_dchar] = ACTIONS(4530),
    [sym_float] = ACTIONS(4530),
    [sym_double] = ACTIONS(4530),
    [sym_real] = ACTIONS(4530),
    [sym_ifloat] = ACTIONS(4530),
    [sym_idouble] = ACTIONS(4530),
    [sym_ireal] = ACTIONS(4530),
    [sym_cfloat] = ACTIONS(4530),
    [sym_cdouble] = ACTIONS(4530),
    [sym_creal] = ACTIONS(4530),
    [sym_size_t] = ACTIONS(4530),
    [sym_ptrdiff_t] = ACTIONS(4530),
    [sym_string] = ACTIONS(4530),
    [sym_cstring] = ACTIONS(4530),
    [sym_dstring] = ACTIONS(4530),
    [sym_wstring] = ACTIONS(4530),
    [sym_noreturn] = ACTIONS(4530),
    [sym_this] = ACTIONS(4530),
    [sym_abstract] = ACTIONS(4530),
    [sym_alias] = ACTIONS(4530),
    [sym_align] = ACTIONS(4530),
    [sym_auto] = ACTIONS(4530),
    [sym_class] = ACTIONS(4530),
    [sym_const] = ACTIONS(4530),
    [sym_debug] = ACTIONS(4530),
    [sym_deprecated] = ACTIONS(4530),
    [sym_else] = ACTIONS(4530),
    [sym_enum] = ACTIONS(4530),
    [sym_export] = ACTIONS(4530),
    [sym_extern] = ACTIONS(4530),
    [sym_final] = ACTIONS(4530),
    [sym_immutable] = ACTIONS(4530),
    [sym_import] = ACTIONS(4530),
    [sym_inout] = ACTIONS(4530),
    [sym_interface] = ACTIONS(4530),
    [sym_invariant] = ACTIONS(4530),
    [sym_mixin] = ACTIONS(4530),
    [sym_nothrow] = ACTIONS(4530),
    [sym_override] = ACTIONS(4530),
    [sym_package] = ACTIONS(4530),
    [sym_pragma] = ACTIONS(4530),
    [sym_private] = ACTIONS(4530),
    [sym_protected] = ACTIONS(4530),
    [sym_public] = ACTIONS(4530),
    [sym_pure] = ACTIONS(4530),
    [sym_ref] = ACTIONS(4530),
    [sym_return] = ACTIONS(4530),
    [sym_scope] = ACTIONS(4530),
    [sym_shared] = ACTIONS(4530),
    [sym_static] = ACTIONS(4530),
    [sym_struct] = ACTIONS(4530),
    [sym_synchronized] = ACTIONS(4530),
    [sym_template] = ACTIONS(4530),
    [sym_typeof] = ACTIONS(4530),
    [sym_union] = ACTIONS(4530),
    [sym_unittest] = ACTIONS(4530),
    [sym_version] = ACTIONS(4530),
    [sym_while] = ACTIONS(4530),
    [sym_gshared] = ACTIONS(4530),
    [sym_traits] = ACTIONS(4530),
    [sym_vector] = ACTIONS(4530),
    [sym_void] = ACTIONS(4530),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2383] = {
    [sym_identifier] = ACTIONS(4660),
    [anon_sym_DOT] = ACTIONS(4662),
    [anon_sym_SEMI] = ACTIONS(4662),
    [anon_sym_TILDE] = ACTIONS(4662),
    [anon_sym_AT] = ACTIONS(4662),
    [sym_bool] = ACTIONS(4660),
    [sym_byte] = ACTIONS(4660),
    [sym_ubyte] = ACTIONS(4660),
    [sym_char] = ACTIONS(4660),
    [sym_short] = ACTIONS(4660),
    [sym_ushort] = ACTIONS(4660),
    [sym_int] = ACTIONS(4660),
    [sym_uint] = ACTIONS(4660),
    [sym_long] = ACTIONS(4660),
    [sym_ulong] = ACTIONS(4660),
    [sym_cent] = ACTIONS(4660),
    [sym_ucent] = ACTIONS(4660),
    [sym_wchar] = ACTIONS(4660),
    [sym_dchar] = ACTIONS(4660),
    [sym_float] = ACTIONS(4660),
    [sym_double] = ACTIONS(4660),
    [sym_real] = ACTIONS(4660),
    [sym_ifloat] = ACTIONS(4660),
    [sym_idouble] = ACTIONS(4660),
    [sym_ireal] = ACTIONS(4660),
    [sym_cfloat] = ACTIONS(4660),
    [sym_cdouble] = ACTIONS(4660),
    [sym_creal] = ACTIONS(4660),
    [sym_size_t] = ACTIONS(4660),
    [sym_ptrdiff_t] = ACTIONS(4660),
    [sym_string] = ACTIONS(4660),
    [sym_cstring] = ACTIONS(4660),
    [sym_dstring] = ACTIONS(4660),
    [sym_wstring] = ACTIONS(4660),
    [sym_noreturn] = ACTIONS(4660),
    [sym_this] = ACTIONS(4660),
    [sym_abstract] = ACTIONS(4660),
    [sym_alias] = ACTIONS(4660),
    [sym_align] = ACTIONS(4660),
    [sym_auto] = ACTIONS(4660),
    [sym_catch] = ACTIONS(4660),
    [sym_class] = ACTIONS(4660),
    [sym_const] = ACTIONS(4660),
    [sym_debug] = ACTIONS(4660),
    [sym_deprecated] = ACTIONS(4660),
    [sym_else] = ACTIONS(4660),
    [sym_enum] = ACTIONS(4660),
    [sym_export] = ACTIONS(4660),
    [sym_extern] = ACTIONS(4660),
    [sym_final] = ACTIONS(4660),
    [sym_finally] = ACTIONS(4660),
    [sym_immutable] = ACTIONS(4660),
    [sym_import] = ACTIONS(4660),
    [sym_inout] = ACTIONS(4660),
    [sym_interface] = ACTIONS(4660),
    [sym_invariant] = ACTIONS(4660),
    [sym_mixin] = ACTIONS(4660),
    [sym_nothrow] = ACTIONS(4660),
    [sym_override] = ACTIONS(4660),
    [sym_package] = ACTIONS(4660),
    [sym_pragma] = ACTIONS(4660),
    [sym_private] = ACTIONS(4660),
    [sym_protected] = ACTIONS(4660),
    [sym_public] = ACTIONS(4660),
    [sym_pure] = ACTIONS(4660),
    [sym_ref] = ACTIONS(4660),
    [sym_return] = ACTIONS(4660),
    [sym_scope] = ACTIONS(4660),
    [sym_shared] = ACTIONS(4660),
    [sym_static] = ACTIONS(4660),
    [sym_struct] = ACTIONS(4660),
    [sym_synchronized] = ACTIONS(4660),
    [sym_template] = ACTIONS(4660),
    [sym_typeof] = ACTIONS(4660),
    [sym_union] = ACTIONS(4660),
    [sym_unittest] = ACTIONS(4660),
    [sym_version] = ACTIONS(4660),
    [sym_while] = ACTIONS(4660),
    [sym_gshared] = ACTIONS(4660),
    [sym_traits] = ACTIONS(4660),
    [sym_vector] = ACTIONS(4660),
    [sym_void] = ACTIONS(4660),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2384] = {
    [ts_builtin_sym_end] = ACTIONS(4749),
    [sym_identifier] = ACTIONS(4747),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_DOT] = ACTIONS(4749),
    [anon_sym_SEMI] = ACTIONS(4749),
    [anon_sym_TILDE] = ACTIONS(4749),
    [anon_sym_AT] = ACTIONS(4749),
    [sym_bool] = ACTIONS(4747),
    [sym_byte] = ACTIONS(4747),
    [sym_ubyte] = ACTIONS(4747),
    [sym_char] = ACTIONS(4747),
    [sym_short] = ACTIONS(4747),
    [sym_ushort] = ACTIONS(4747),
    [sym_int] = ACTIONS(4747),
    [sym_uint] = ACTIONS(4747),
    [sym_long] = ACTIONS(4747),
    [sym_ulong] = ACTIONS(4747),
    [sym_cent] = ACTIONS(4747),
    [sym_ucent] = ACTIONS(4747),
    [sym_wchar] = ACTIONS(4747),
    [sym_dchar] = ACTIONS(4747),
    [sym_float] = ACTIONS(4747),
    [sym_double] = ACTIONS(4747),
    [sym_real] = ACTIONS(4747),
    [sym_ifloat] = ACTIONS(4747),
    [sym_idouble] = ACTIONS(4747),
    [sym_ireal] = ACTIONS(4747),
    [sym_cfloat] = ACTIONS(4747),
    [sym_cdouble] = ACTIONS(4747),
    [sym_creal] = ACTIONS(4747),
    [sym_size_t] = ACTIONS(4747),
    [sym_ptrdiff_t] = ACTIONS(4747),
    [sym_string] = ACTIONS(4747),
    [sym_cstring] = ACTIONS(4747),
    [sym_dstring] = ACTIONS(4747),
    [sym_wstring] = ACTIONS(4747),
    [sym_noreturn] = ACTIONS(4747),
    [sym_this] = ACTIONS(4747),
    [sym_abstract] = ACTIONS(4747),
    [sym_alias] = ACTIONS(4747),
    [sym_align] = ACTIONS(4747),
    [sym_auto] = ACTIONS(4747),
    [sym_class] = ACTIONS(4747),
    [sym_const] = ACTIONS(4747),
    [sym_debug] = ACTIONS(4747),
    [sym_deprecated] = ACTIONS(4747),
    [sym_else] = ACTIONS(4747),
    [sym_enum] = ACTIONS(4747),
    [sym_export] = ACTIONS(4747),
    [sym_extern] = ACTIONS(4747),
    [sym_final] = ACTIONS(4747),
    [sym_immutable] = ACTIONS(4747),
    [sym_import] = ACTIONS(4747),
    [sym_inout] = ACTIONS(4747),
    [sym_interface] = ACTIONS(4747),
    [sym_invariant] = ACTIONS(4747),
    [sym_mixin] = ACTIONS(4747),
    [sym_nothrow] = ACTIONS(4747),
    [sym_override] = ACTIONS(4747),
    [sym_package] = ACTIONS(4747),
    [sym_pragma] = ACTIONS(4747),
    [sym_private] = ACTIONS(4747),
    [sym_protected] = ACTIONS(4747),
    [sym_public] = ACTIONS(4747),
    [sym_pure] = ACTIONS(4747),
    [sym_ref] = ACTIONS(4747),
    [sym_return] = ACTIONS(4747),
    [sym_scope] = ACTIONS(4747),
    [sym_shared] = ACTIONS(4747),
    [sym_static] = ACTIONS(4747),
    [sym_struct] = ACTIONS(4747),
    [sym_synchronized] = ACTIONS(4747),
    [sym_template] = ACTIONS(4747),
    [sym_typeof] = ACTIONS(4747),
    [sym_union] = ACTIONS(4747),
    [sym_unittest] = ACTIONS(4747),
    [sym_version] = ACTIONS(4747),
    [sym_while] = ACTIONS(4747),
    [sym_gshared] = ACTIONS(4747),
    [sym_traits] = ACTIONS(4747),
    [sym_vector] = ACTIONS(4747),
    [sym_void] = ACTIONS(4747),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2385] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(6076),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5038),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2386] = {
    [ts_builtin_sym_end] = ACTIONS(4731),
    [sym_identifier] = ACTIONS(4729),
    [anon_sym_RBRACE] = ACTIONS(4731),
    [anon_sym_DOT] = ACTIONS(4731),
    [anon_sym_SEMI] = ACTIONS(4731),
    [anon_sym_TILDE] = ACTIONS(4731),
    [anon_sym_AT] = ACTIONS(4731),
    [sym_bool] = ACTIONS(4729),
    [sym_byte] = ACTIONS(4729),
    [sym_ubyte] = ACTIONS(4729),
    [sym_char] = ACTIONS(4729),
    [sym_short] = ACTIONS(4729),
    [sym_ushort] = ACTIONS(4729),
    [sym_int] = ACTIONS(4729),
    [sym_uint] = ACTIONS(4729),
    [sym_long] = ACTIONS(4729),
    [sym_ulong] = ACTIONS(4729),
    [sym_cent] = ACTIONS(4729),
    [sym_ucent] = ACTIONS(4729),
    [sym_wchar] = ACTIONS(4729),
    [sym_dchar] = ACTIONS(4729),
    [sym_float] = ACTIONS(4729),
    [sym_double] = ACTIONS(4729),
    [sym_real] = ACTIONS(4729),
    [sym_ifloat] = ACTIONS(4729),
    [sym_idouble] = ACTIONS(4729),
    [sym_ireal] = ACTIONS(4729),
    [sym_cfloat] = ACTIONS(4729),
    [sym_cdouble] = ACTIONS(4729),
    [sym_creal] = ACTIONS(4729),
    [sym_size_t] = ACTIONS(4729),
    [sym_ptrdiff_t] = ACTIONS(4729),
    [sym_string] = ACTIONS(4729),
    [sym_cstring] = ACTIONS(4729),
    [sym_dstring] = ACTIONS(4729),
    [sym_wstring] = ACTIONS(4729),
    [sym_noreturn] = ACTIONS(4729),
    [sym_this] = ACTIONS(4729),
    [sym_abstract] = ACTIONS(4729),
    [sym_alias] = ACTIONS(4729),
    [sym_align] = ACTIONS(4729),
    [sym_auto] = ACTIONS(4729),
    [sym_class] = ACTIONS(4729),
    [sym_const] = ACTIONS(4729),
    [sym_debug] = ACTIONS(4729),
    [sym_deprecated] = ACTIONS(4729),
    [sym_else] = ACTIONS(4729),
    [sym_enum] = ACTIONS(4729),
    [sym_export] = ACTIONS(4729),
    [sym_extern] = ACTIONS(4729),
    [sym_final] = ACTIONS(4729),
    [sym_immutable] = ACTIONS(4729),
    [sym_import] = ACTIONS(4729),
    [sym_inout] = ACTIONS(4729),
    [sym_interface] = ACTIONS(4729),
    [sym_invariant] = ACTIONS(4729),
    [sym_mixin] = ACTIONS(4729),
    [sym_nothrow] = ACTIONS(4729),
    [sym_override] = ACTIONS(4729),
    [sym_package] = ACTIONS(4729),
    [sym_pragma] = ACTIONS(4729),
    [sym_private] = ACTIONS(4729),
    [sym_protected] = ACTIONS(4729),
    [sym_public] = ACTIONS(4729),
    [sym_pure] = ACTIONS(4729),
    [sym_ref] = ACTIONS(4729),
    [sym_return] = ACTIONS(4729),
    [sym_scope] = ACTIONS(4729),
    [sym_shared] = ACTIONS(4729),
    [sym_static] = ACTIONS(4729),
    [sym_struct] = ACTIONS(4729),
    [sym_synchronized] = ACTIONS(4729),
    [sym_template] = ACTIONS(4729),
    [sym_typeof] = ACTIONS(4729),
    [sym_union] = ACTIONS(4729),
    [sym_unittest] = ACTIONS(4729),
    [sym_version] = ACTIONS(4729),
    [sym_while] = ACTIONS(4729),
    [sym_gshared] = ACTIONS(4729),
    [sym_traits] = ACTIONS(4729),
    [sym_vector] = ACTIONS(4729),
    [sym_void] = ACTIONS(4729),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2387] = {
    [ts_builtin_sym_end] = ACTIONS(4512),
    [sym_identifier] = ACTIONS(4510),
    [anon_sym_RBRACE] = ACTIONS(4512),
    [anon_sym_DOT] = ACTIONS(4512),
    [anon_sym_SEMI] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4512),
    [anon_sym_AT] = ACTIONS(4512),
    [sym_bool] = ACTIONS(4510),
    [sym_byte] = ACTIONS(4510),
    [sym_ubyte] = ACTIONS(4510),
    [sym_char] = ACTIONS(4510),
    [sym_short] = ACTIONS(4510),
    [sym_ushort] = ACTIONS(4510),
    [sym_int] = ACTIONS(4510),
    [sym_uint] = ACTIONS(4510),
    [sym_long] = ACTIONS(4510),
    [sym_ulong] = ACTIONS(4510),
    [sym_cent] = ACTIONS(4510),
    [sym_ucent] = ACTIONS(4510),
    [sym_wchar] = ACTIONS(4510),
    [sym_dchar] = ACTIONS(4510),
    [sym_float] = ACTIONS(4510),
    [sym_double] = ACTIONS(4510),
    [sym_real] = ACTIONS(4510),
    [sym_ifloat] = ACTIONS(4510),
    [sym_idouble] = ACTIONS(4510),
    [sym_ireal] = ACTIONS(4510),
    [sym_cfloat] = ACTIONS(4510),
    [sym_cdouble] = ACTIONS(4510),
    [sym_creal] = ACTIONS(4510),
    [sym_size_t] = ACTIONS(4510),
    [sym_ptrdiff_t] = ACTIONS(4510),
    [sym_string] = ACTIONS(4510),
    [sym_cstring] = ACTIONS(4510),
    [sym_dstring] = ACTIONS(4510),
    [sym_wstring] = ACTIONS(4510),
    [sym_noreturn] = ACTIONS(4510),
    [sym_this] = ACTIONS(4510),
    [sym_abstract] = ACTIONS(4510),
    [sym_alias] = ACTIONS(4510),
    [sym_align] = ACTIONS(4510),
    [sym_auto] = ACTIONS(4510),
    [sym_class] = ACTIONS(4510),
    [sym_const] = ACTIONS(4510),
    [sym_debug] = ACTIONS(4510),
    [sym_deprecated] = ACTIONS(4510),
    [sym_else] = ACTIONS(4510),
    [sym_enum] = ACTIONS(4510),
    [sym_export] = ACTIONS(4510),
    [sym_extern] = ACTIONS(4510),
    [sym_final] = ACTIONS(4510),
    [sym_immutable] = ACTIONS(4510),
    [sym_import] = ACTIONS(4510),
    [sym_inout] = ACTIONS(4510),
    [sym_interface] = ACTIONS(4510),
    [sym_invariant] = ACTIONS(4510),
    [sym_mixin] = ACTIONS(4510),
    [sym_nothrow] = ACTIONS(4510),
    [sym_override] = ACTIONS(4510),
    [sym_package] = ACTIONS(4510),
    [sym_pragma] = ACTIONS(4510),
    [sym_private] = ACTIONS(4510),
    [sym_protected] = ACTIONS(4510),
    [sym_public] = ACTIONS(4510),
    [sym_pure] = ACTIONS(4510),
    [sym_ref] = ACTIONS(4510),
    [sym_return] = ACTIONS(4510),
    [sym_scope] = ACTIONS(4510),
    [sym_shared] = ACTIONS(4510),
    [sym_static] = ACTIONS(4510),
    [sym_struct] = ACTIONS(4510),
    [sym_synchronized] = ACTIONS(4510),
    [sym_template] = ACTIONS(4510),
    [sym_typeof] = ACTIONS(4510),
    [sym_union] = ACTIONS(4510),
    [sym_unittest] = ACTIONS(4510),
    [sym_version] = ACTIONS(4510),
    [sym_while] = ACTIONS(4510),
    [sym_gshared] = ACTIONS(4510),
    [sym_traits] = ACTIONS(4510),
    [sym_vector] = ACTIONS(4510),
    [sym_void] = ACTIONS(4510),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2388] = {
    [ts_builtin_sym_end] = ACTIONS(4743),
    [sym_identifier] = ACTIONS(4741),
    [anon_sym_RBRACE] = ACTIONS(4743),
    [anon_sym_DOT] = ACTIONS(4743),
    [anon_sym_SEMI] = ACTIONS(4743),
    [anon_sym_TILDE] = ACTIONS(4743),
    [anon_sym_AT] = ACTIONS(4743),
    [sym_bool] = ACTIONS(4741),
    [sym_byte] = ACTIONS(4741),
    [sym_ubyte] = ACTIONS(4741),
    [sym_char] = ACTIONS(4741),
    [sym_short] = ACTIONS(4741),
    [sym_ushort] = ACTIONS(4741),
    [sym_int] = ACTIONS(4741),
    [sym_uint] = ACTIONS(4741),
    [sym_long] = ACTIONS(4741),
    [sym_ulong] = ACTIONS(4741),
    [sym_cent] = ACTIONS(4741),
    [sym_ucent] = ACTIONS(4741),
    [sym_wchar] = ACTIONS(4741),
    [sym_dchar] = ACTIONS(4741),
    [sym_float] = ACTIONS(4741),
    [sym_double] = ACTIONS(4741),
    [sym_real] = ACTIONS(4741),
    [sym_ifloat] = ACTIONS(4741),
    [sym_idouble] = ACTIONS(4741),
    [sym_ireal] = ACTIONS(4741),
    [sym_cfloat] = ACTIONS(4741),
    [sym_cdouble] = ACTIONS(4741),
    [sym_creal] = ACTIONS(4741),
    [sym_size_t] = ACTIONS(4741),
    [sym_ptrdiff_t] = ACTIONS(4741),
    [sym_string] = ACTIONS(4741),
    [sym_cstring] = ACTIONS(4741),
    [sym_dstring] = ACTIONS(4741),
    [sym_wstring] = ACTIONS(4741),
    [sym_noreturn] = ACTIONS(4741),
    [sym_this] = ACTIONS(4741),
    [sym_abstract] = ACTIONS(4741),
    [sym_alias] = ACTIONS(4741),
    [sym_align] = ACTIONS(4741),
    [sym_auto] = ACTIONS(4741),
    [sym_class] = ACTIONS(4741),
    [sym_const] = ACTIONS(4741),
    [sym_debug] = ACTIONS(4741),
    [sym_deprecated] = ACTIONS(4741),
    [sym_else] = ACTIONS(6086),
    [sym_enum] = ACTIONS(4741),
    [sym_export] = ACTIONS(4741),
    [sym_extern] = ACTIONS(4741),
    [sym_final] = ACTIONS(4741),
    [sym_immutable] = ACTIONS(4741),
    [sym_import] = ACTIONS(4741),
    [sym_inout] = ACTIONS(4741),
    [sym_interface] = ACTIONS(4741),
    [sym_invariant] = ACTIONS(4741),
    [sym_mixin] = ACTIONS(4741),
    [sym_nothrow] = ACTIONS(4741),
    [sym_override] = ACTIONS(4741),
    [sym_package] = ACTIONS(4741),
    [sym_pragma] = ACTIONS(4741),
    [sym_private] = ACTIONS(4741),
    [sym_protected] = ACTIONS(4741),
    [sym_public] = ACTIONS(4741),
    [sym_pure] = ACTIONS(4741),
    [sym_ref] = ACTIONS(4741),
    [sym_return] = ACTIONS(4741),
    [sym_scope] = ACTIONS(4741),
    [sym_shared] = ACTIONS(4741),
    [sym_static] = ACTIONS(4741),
    [sym_struct] = ACTIONS(4741),
    [sym_synchronized] = ACTIONS(4741),
    [sym_template] = ACTIONS(4741),
    [sym_typeof] = ACTIONS(4741),
    [sym_union] = ACTIONS(4741),
    [sym_unittest] = ACTIONS(4741),
    [sym_version] = ACTIONS(4741),
    [sym_while] = ACTIONS(4741),
    [sym_gshared] = ACTIONS(4741),
    [sym_traits] = ACTIONS(4741),
    [sym_vector] = ACTIONS(4741),
    [sym_void] = ACTIONS(4741),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2389] = {
    [sym_identifier] = ACTIONS(4697),
    [anon_sym_DOT] = ACTIONS(4699),
    [anon_sym_SEMI] = ACTIONS(4699),
    [anon_sym_TILDE] = ACTIONS(4699),
    [anon_sym_AT] = ACTIONS(4699),
    [sym_bool] = ACTIONS(4697),
    [sym_byte] = ACTIONS(4697),
    [sym_ubyte] = ACTIONS(4697),
    [sym_char] = ACTIONS(4697),
    [sym_short] = ACTIONS(4697),
    [sym_ushort] = ACTIONS(4697),
    [sym_int] = ACTIONS(4697),
    [sym_uint] = ACTIONS(4697),
    [sym_long] = ACTIONS(4697),
    [sym_ulong] = ACTIONS(4697),
    [sym_cent] = ACTIONS(4697),
    [sym_ucent] = ACTIONS(4697),
    [sym_wchar] = ACTIONS(4697),
    [sym_dchar] = ACTIONS(4697),
    [sym_float] = ACTIONS(4697),
    [sym_double] = ACTIONS(4697),
    [sym_real] = ACTIONS(4697),
    [sym_ifloat] = ACTIONS(4697),
    [sym_idouble] = ACTIONS(4697),
    [sym_ireal] = ACTIONS(4697),
    [sym_cfloat] = ACTIONS(4697),
    [sym_cdouble] = ACTIONS(4697),
    [sym_creal] = ACTIONS(4697),
    [sym_size_t] = ACTIONS(4697),
    [sym_ptrdiff_t] = ACTIONS(4697),
    [sym_string] = ACTIONS(4697),
    [sym_cstring] = ACTIONS(4697),
    [sym_dstring] = ACTIONS(4697),
    [sym_wstring] = ACTIONS(4697),
    [sym_noreturn] = ACTIONS(4697),
    [sym_this] = ACTIONS(4697),
    [sym_abstract] = ACTIONS(4697),
    [sym_alias] = ACTIONS(4697),
    [sym_align] = ACTIONS(4697),
    [sym_auto] = ACTIONS(4697),
    [sym_catch] = ACTIONS(4697),
    [sym_class] = ACTIONS(4697),
    [sym_const] = ACTIONS(4697),
    [sym_debug] = ACTIONS(4697),
    [sym_deprecated] = ACTIONS(4697),
    [sym_else] = ACTIONS(4697),
    [sym_enum] = ACTIONS(4697),
    [sym_export] = ACTIONS(4697),
    [sym_extern] = ACTIONS(4697),
    [sym_final] = ACTIONS(4697),
    [sym_finally] = ACTIONS(4697),
    [sym_immutable] = ACTIONS(4697),
    [sym_import] = ACTIONS(4697),
    [sym_inout] = ACTIONS(4697),
    [sym_interface] = ACTIONS(4697),
    [sym_invariant] = ACTIONS(4697),
    [sym_mixin] = ACTIONS(4697),
    [sym_nothrow] = ACTIONS(4697),
    [sym_override] = ACTIONS(4697),
    [sym_package] = ACTIONS(4697),
    [sym_pragma] = ACTIONS(4697),
    [sym_private] = ACTIONS(4697),
    [sym_protected] = ACTIONS(4697),
    [sym_public] = ACTIONS(4697),
    [sym_pure] = ACTIONS(4697),
    [sym_ref] = ACTIONS(4697),
    [sym_return] = ACTIONS(4697),
    [sym_scope] = ACTIONS(4697),
    [sym_shared] = ACTIONS(4697),
    [sym_static] = ACTIONS(4697),
    [sym_struct] = ACTIONS(4697),
    [sym_synchronized] = ACTIONS(4697),
    [sym_template] = ACTIONS(4697),
    [sym_typeof] = ACTIONS(4697),
    [sym_union] = ACTIONS(4697),
    [sym_unittest] = ACTIONS(4697),
    [sym_version] = ACTIONS(4697),
    [sym_while] = ACTIONS(4697),
    [sym_gshared] = ACTIONS(4697),
    [sym_traits] = ACTIONS(4697),
    [sym_vector] = ACTIONS(4697),
    [sym_void] = ACTIONS(4697),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2390] = {
    [sym_switch_statement] = STATE(2025),
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_switch] = ACTIONS(754),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2391] = {
    [ts_builtin_sym_end] = ACTIONS(4418),
    [sym_identifier] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4418),
    [anon_sym_DOT] = ACTIONS(4418),
    [anon_sym_SEMI] = ACTIONS(4418),
    [anon_sym_TILDE] = ACTIONS(4418),
    [anon_sym_AT] = ACTIONS(4418),
    [sym_bool] = ACTIONS(4416),
    [sym_byte] = ACTIONS(4416),
    [sym_ubyte] = ACTIONS(4416),
    [sym_char] = ACTIONS(4416),
    [sym_short] = ACTIONS(4416),
    [sym_ushort] = ACTIONS(4416),
    [sym_int] = ACTIONS(4416),
    [sym_uint] = ACTIONS(4416),
    [sym_long] = ACTIONS(4416),
    [sym_ulong] = ACTIONS(4416),
    [sym_cent] = ACTIONS(4416),
    [sym_ucent] = ACTIONS(4416),
    [sym_wchar] = ACTIONS(4416),
    [sym_dchar] = ACTIONS(4416),
    [sym_float] = ACTIONS(4416),
    [sym_double] = ACTIONS(4416),
    [sym_real] = ACTIONS(4416),
    [sym_ifloat] = ACTIONS(4416),
    [sym_idouble] = ACTIONS(4416),
    [sym_ireal] = ACTIONS(4416),
    [sym_cfloat] = ACTIONS(4416),
    [sym_cdouble] = ACTIONS(4416),
    [sym_creal] = ACTIONS(4416),
    [sym_size_t] = ACTIONS(4416),
    [sym_ptrdiff_t] = ACTIONS(4416),
    [sym_string] = ACTIONS(4416),
    [sym_cstring] = ACTIONS(4416),
    [sym_dstring] = ACTIONS(4416),
    [sym_wstring] = ACTIONS(4416),
    [sym_noreturn] = ACTIONS(4416),
    [sym_this] = ACTIONS(4416),
    [sym_abstract] = ACTIONS(4416),
    [sym_alias] = ACTIONS(4416),
    [sym_align] = ACTIONS(4416),
    [sym_auto] = ACTIONS(4416),
    [sym_class] = ACTIONS(4416),
    [sym_const] = ACTIONS(4416),
    [sym_debug] = ACTIONS(4416),
    [sym_deprecated] = ACTIONS(4416),
    [sym_else] = ACTIONS(4416),
    [sym_enum] = ACTIONS(4416),
    [sym_export] = ACTIONS(4416),
    [sym_extern] = ACTIONS(4416),
    [sym_final] = ACTIONS(4416),
    [sym_immutable] = ACTIONS(4416),
    [sym_import] = ACTIONS(4416),
    [sym_inout] = ACTIONS(4416),
    [sym_interface] = ACTIONS(4416),
    [sym_invariant] = ACTIONS(4416),
    [sym_mixin] = ACTIONS(4416),
    [sym_nothrow] = ACTIONS(4416),
    [sym_override] = ACTIONS(4416),
    [sym_package] = ACTIONS(4416),
    [sym_pragma] = ACTIONS(4416),
    [sym_private] = ACTIONS(4416),
    [sym_protected] = ACTIONS(4416),
    [sym_public] = ACTIONS(4416),
    [sym_pure] = ACTIONS(4416),
    [sym_ref] = ACTIONS(4416),
    [sym_return] = ACTIONS(4416),
    [sym_scope] = ACTIONS(4416),
    [sym_shared] = ACTIONS(4416),
    [sym_static] = ACTIONS(4416),
    [sym_struct] = ACTIONS(4416),
    [sym_synchronized] = ACTIONS(4416),
    [sym_template] = ACTIONS(4416),
    [sym_typeof] = ACTIONS(4416),
    [sym_union] = ACTIONS(4416),
    [sym_unittest] = ACTIONS(4416),
    [sym_version] = ACTIONS(4416),
    [sym_while] = ACTIONS(4416),
    [sym_gshared] = ACTIONS(4416),
    [sym_traits] = ACTIONS(4416),
    [sym_vector] = ACTIONS(4416),
    [sym_void] = ACTIONS(4416),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2392] = {
    [ts_builtin_sym_end] = ACTIONS(2640),
    [sym_identifier] = ACTIONS(2642),
    [anon_sym_RBRACE] = ACTIONS(2640),
    [anon_sym_DOT] = ACTIONS(2640),
    [anon_sym_SEMI] = ACTIONS(2640),
    [anon_sym_TILDE] = ACTIONS(2640),
    [anon_sym_AT] = ACTIONS(2640),
    [sym_bool] = ACTIONS(2642),
    [sym_byte] = ACTIONS(2642),
    [sym_ubyte] = ACTIONS(2642),
    [sym_char] = ACTIONS(2642),
    [sym_short] = ACTIONS(2642),
    [sym_ushort] = ACTIONS(2642),
    [sym_int] = ACTIONS(2642),
    [sym_uint] = ACTIONS(2642),
    [sym_long] = ACTIONS(2642),
    [sym_ulong] = ACTIONS(2642),
    [sym_cent] = ACTIONS(2642),
    [sym_ucent] = ACTIONS(2642),
    [sym_wchar] = ACTIONS(2642),
    [sym_dchar] = ACTIONS(2642),
    [sym_float] = ACTIONS(2642),
    [sym_double] = ACTIONS(2642),
    [sym_real] = ACTIONS(2642),
    [sym_ifloat] = ACTIONS(2642),
    [sym_idouble] = ACTIONS(2642),
    [sym_ireal] = ACTIONS(2642),
    [sym_cfloat] = ACTIONS(2642),
    [sym_cdouble] = ACTIONS(2642),
    [sym_creal] = ACTIONS(2642),
    [sym_size_t] = ACTIONS(2642),
    [sym_ptrdiff_t] = ACTIONS(2642),
    [sym_string] = ACTIONS(2642),
    [sym_cstring] = ACTIONS(2642),
    [sym_dstring] = ACTIONS(2642),
    [sym_wstring] = ACTIONS(2642),
    [sym_noreturn] = ACTIONS(2642),
    [sym_this] = ACTIONS(2642),
    [sym_abstract] = ACTIONS(2642),
    [sym_alias] = ACTIONS(2642),
    [sym_align] = ACTIONS(2642),
    [sym_auto] = ACTIONS(2642),
    [sym_class] = ACTIONS(2642),
    [sym_const] = ACTIONS(2642),
    [sym_debug] = ACTIONS(2642),
    [sym_deprecated] = ACTIONS(2642),
    [sym_else] = ACTIONS(2642),
    [sym_enum] = ACTIONS(2642),
    [sym_export] = ACTIONS(2642),
    [sym_extern] = ACTIONS(2642),
    [sym_final] = ACTIONS(2642),
    [sym_immutable] = ACTIONS(2642),
    [sym_import] = ACTIONS(2642),
    [sym_inout] = ACTIONS(2642),
    [sym_interface] = ACTIONS(2642),
    [sym_invariant] = ACTIONS(2642),
    [sym_mixin] = ACTIONS(2642),
    [sym_nothrow] = ACTIONS(2642),
    [sym_override] = ACTIONS(2642),
    [sym_package] = ACTIONS(2642),
    [sym_pragma] = ACTIONS(2642),
    [sym_private] = ACTIONS(2642),
    [sym_protected] = ACTIONS(2642),
    [sym_public] = ACTIONS(2642),
    [sym_pure] = ACTIONS(2642),
    [sym_ref] = ACTIONS(2642),
    [sym_return] = ACTIONS(2642),
    [sym_scope] = ACTIONS(2642),
    [sym_shared] = ACTIONS(2642),
    [sym_static] = ACTIONS(2642),
    [sym_struct] = ACTIONS(2642),
    [sym_synchronized] = ACTIONS(2642),
    [sym_template] = ACTIONS(2642),
    [sym_typeof] = ACTIONS(2642),
    [sym_union] = ACTIONS(2642),
    [sym_unittest] = ACTIONS(2642),
    [sym_version] = ACTIONS(2642),
    [sym_while] = ACTIONS(2642),
    [sym_gshared] = ACTIONS(2642),
    [sym_traits] = ACTIONS(2642),
    [sym_vector] = ACTIONS(2642),
    [sym_void] = ACTIONS(2642),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2393] = {
    [ts_builtin_sym_end] = ACTIONS(4845),
    [sym_identifier] = ACTIONS(4843),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_DOT] = ACTIONS(4845),
    [anon_sym_SEMI] = ACTIONS(4845),
    [anon_sym_TILDE] = ACTIONS(4845),
    [anon_sym_AT] = ACTIONS(4845),
    [sym_bool] = ACTIONS(4843),
    [sym_byte] = ACTIONS(4843),
    [sym_ubyte] = ACTIONS(4843),
    [sym_char] = ACTIONS(4843),
    [sym_short] = ACTIONS(4843),
    [sym_ushort] = ACTIONS(4843),
    [sym_int] = ACTIONS(4843),
    [sym_uint] = ACTIONS(4843),
    [sym_long] = ACTIONS(4843),
    [sym_ulong] = ACTIONS(4843),
    [sym_cent] = ACTIONS(4843),
    [sym_ucent] = ACTIONS(4843),
    [sym_wchar] = ACTIONS(4843),
    [sym_dchar] = ACTIONS(4843),
    [sym_float] = ACTIONS(4843),
    [sym_double] = ACTIONS(4843),
    [sym_real] = ACTIONS(4843),
    [sym_ifloat] = ACTIONS(4843),
    [sym_idouble] = ACTIONS(4843),
    [sym_ireal] = ACTIONS(4843),
    [sym_cfloat] = ACTIONS(4843),
    [sym_cdouble] = ACTIONS(4843),
    [sym_creal] = ACTIONS(4843),
    [sym_size_t] = ACTIONS(4843),
    [sym_ptrdiff_t] = ACTIONS(4843),
    [sym_string] = ACTIONS(4843),
    [sym_cstring] = ACTIONS(4843),
    [sym_dstring] = ACTIONS(4843),
    [sym_wstring] = ACTIONS(4843),
    [sym_noreturn] = ACTIONS(4843),
    [sym_this] = ACTIONS(4843),
    [sym_abstract] = ACTIONS(4843),
    [sym_alias] = ACTIONS(4843),
    [sym_align] = ACTIONS(4843),
    [sym_auto] = ACTIONS(4843),
    [sym_class] = ACTIONS(4843),
    [sym_const] = ACTIONS(4843),
    [sym_debug] = ACTIONS(4843),
    [sym_deprecated] = ACTIONS(4843),
    [sym_else] = ACTIONS(4843),
    [sym_enum] = ACTIONS(4843),
    [sym_export] = ACTIONS(4843),
    [sym_extern] = ACTIONS(4843),
    [sym_final] = ACTIONS(4843),
    [sym_immutable] = ACTIONS(4843),
    [sym_import] = ACTIONS(4843),
    [sym_inout] = ACTIONS(4843),
    [sym_interface] = ACTIONS(4843),
    [sym_invariant] = ACTIONS(4843),
    [sym_mixin] = ACTIONS(4843),
    [sym_nothrow] = ACTIONS(4843),
    [sym_override] = ACTIONS(4843),
    [sym_package] = ACTIONS(4843),
    [sym_pragma] = ACTIONS(4843),
    [sym_private] = ACTIONS(4843),
    [sym_protected] = ACTIONS(4843),
    [sym_public] = ACTIONS(4843),
    [sym_pure] = ACTIONS(4843),
    [sym_ref] = ACTIONS(4843),
    [sym_return] = ACTIONS(4843),
    [sym_scope] = ACTIONS(4843),
    [sym_shared] = ACTIONS(4843),
    [sym_static] = ACTIONS(4843),
    [sym_struct] = ACTIONS(4843),
    [sym_synchronized] = ACTIONS(4843),
    [sym_template] = ACTIONS(4843),
    [sym_typeof] = ACTIONS(4843),
    [sym_union] = ACTIONS(4843),
    [sym_unittest] = ACTIONS(4843),
    [sym_version] = ACTIONS(4843),
    [sym_while] = ACTIONS(4843),
    [sym_gshared] = ACTIONS(4843),
    [sym_traits] = ACTIONS(4843),
    [sym_vector] = ACTIONS(4843),
    [sym_void] = ACTIONS(4843),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2394] = {
    [ts_builtin_sym_end] = ACTIONS(4320),
    [sym_identifier] = ACTIONS(4318),
    [anon_sym_RBRACE] = ACTIONS(4320),
    [anon_sym_DOT] = ACTIONS(4320),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_TILDE] = ACTIONS(4320),
    [anon_sym_AT] = ACTIONS(4320),
    [sym_bool] = ACTIONS(4318),
    [sym_byte] = ACTIONS(4318),
    [sym_ubyte] = ACTIONS(4318),
    [sym_char] = ACTIONS(4318),
    [sym_short] = ACTIONS(4318),
    [sym_ushort] = ACTIONS(4318),
    [sym_int] = ACTIONS(4318),
    [sym_uint] = ACTIONS(4318),
    [sym_long] = ACTIONS(4318),
    [sym_ulong] = ACTIONS(4318),
    [sym_cent] = ACTIONS(4318),
    [sym_ucent] = ACTIONS(4318),
    [sym_wchar] = ACTIONS(4318),
    [sym_dchar] = ACTIONS(4318),
    [sym_float] = ACTIONS(4318),
    [sym_double] = ACTIONS(4318),
    [sym_real] = ACTIONS(4318),
    [sym_ifloat] = ACTIONS(4318),
    [sym_idouble] = ACTIONS(4318),
    [sym_ireal] = ACTIONS(4318),
    [sym_cfloat] = ACTIONS(4318),
    [sym_cdouble] = ACTIONS(4318),
    [sym_creal] = ACTIONS(4318),
    [sym_size_t] = ACTIONS(4318),
    [sym_ptrdiff_t] = ACTIONS(4318),
    [sym_string] = ACTIONS(4318),
    [sym_cstring] = ACTIONS(4318),
    [sym_dstring] = ACTIONS(4318),
    [sym_wstring] = ACTIONS(4318),
    [sym_noreturn] = ACTIONS(4318),
    [sym_this] = ACTIONS(4318),
    [sym_abstract] = ACTIONS(4318),
    [sym_alias] = ACTIONS(4318),
    [sym_align] = ACTIONS(4318),
    [sym_auto] = ACTIONS(4318),
    [sym_class] = ACTIONS(4318),
    [sym_const] = ACTIONS(4318),
    [sym_debug] = ACTIONS(4318),
    [sym_deprecated] = ACTIONS(4318),
    [sym_else] = ACTIONS(4318),
    [sym_enum] = ACTIONS(4318),
    [sym_export] = ACTIONS(4318),
    [sym_extern] = ACTIONS(4318),
    [sym_final] = ACTIONS(4318),
    [sym_immutable] = ACTIONS(4318),
    [sym_import] = ACTIONS(4318),
    [sym_inout] = ACTIONS(4318),
    [sym_interface] = ACTIONS(4318),
    [sym_invariant] = ACTIONS(4318),
    [sym_mixin] = ACTIONS(4318),
    [sym_nothrow] = ACTIONS(4318),
    [sym_override] = ACTIONS(4318),
    [sym_package] = ACTIONS(4318),
    [sym_pragma] = ACTIONS(4318),
    [sym_private] = ACTIONS(4318),
    [sym_protected] = ACTIONS(4318),
    [sym_public] = ACTIONS(4318),
    [sym_pure] = ACTIONS(4318),
    [sym_ref] = ACTIONS(4318),
    [sym_return] = ACTIONS(4318),
    [sym_scope] = ACTIONS(4318),
    [sym_shared] = ACTIONS(4318),
    [sym_static] = ACTIONS(4318),
    [sym_struct] = ACTIONS(4318),
    [sym_synchronized] = ACTIONS(4318),
    [sym_template] = ACTIONS(4318),
    [sym_typeof] = ACTIONS(4318),
    [sym_union] = ACTIONS(4318),
    [sym_unittest] = ACTIONS(4318),
    [sym_version] = ACTIONS(4318),
    [sym_while] = ACTIONS(4318),
    [sym_gshared] = ACTIONS(4318),
    [sym_traits] = ACTIONS(4318),
    [sym_vector] = ACTIONS(4318),
    [sym_void] = ACTIONS(4318),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2395] = {
    [ts_builtin_sym_end] = ACTIONS(4540),
    [sym_identifier] = ACTIONS(4538),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_DOT] = ACTIONS(4540),
    [anon_sym_SEMI] = ACTIONS(4540),
    [anon_sym_TILDE] = ACTIONS(4540),
    [anon_sym_AT] = ACTIONS(4540),
    [sym_bool] = ACTIONS(4538),
    [sym_byte] = ACTIONS(4538),
    [sym_ubyte] = ACTIONS(4538),
    [sym_char] = ACTIONS(4538),
    [sym_short] = ACTIONS(4538),
    [sym_ushort] = ACTIONS(4538),
    [sym_int] = ACTIONS(4538),
    [sym_uint] = ACTIONS(4538),
    [sym_long] = ACTIONS(4538),
    [sym_ulong] = ACTIONS(4538),
    [sym_cent] = ACTIONS(4538),
    [sym_ucent] = ACTIONS(4538),
    [sym_wchar] = ACTIONS(4538),
    [sym_dchar] = ACTIONS(4538),
    [sym_float] = ACTIONS(4538),
    [sym_double] = ACTIONS(4538),
    [sym_real] = ACTIONS(4538),
    [sym_ifloat] = ACTIONS(4538),
    [sym_idouble] = ACTIONS(4538),
    [sym_ireal] = ACTIONS(4538),
    [sym_cfloat] = ACTIONS(4538),
    [sym_cdouble] = ACTIONS(4538),
    [sym_creal] = ACTIONS(4538),
    [sym_size_t] = ACTIONS(4538),
    [sym_ptrdiff_t] = ACTIONS(4538),
    [sym_string] = ACTIONS(4538),
    [sym_cstring] = ACTIONS(4538),
    [sym_dstring] = ACTIONS(4538),
    [sym_wstring] = ACTIONS(4538),
    [sym_noreturn] = ACTIONS(4538),
    [sym_this] = ACTIONS(4538),
    [sym_abstract] = ACTIONS(4538),
    [sym_alias] = ACTIONS(4538),
    [sym_align] = ACTIONS(4538),
    [sym_auto] = ACTIONS(4538),
    [sym_class] = ACTIONS(4538),
    [sym_const] = ACTIONS(4538),
    [sym_debug] = ACTIONS(4538),
    [sym_deprecated] = ACTIONS(4538),
    [sym_else] = ACTIONS(4538),
    [sym_enum] = ACTIONS(4538),
    [sym_export] = ACTIONS(4538),
    [sym_extern] = ACTIONS(4538),
    [sym_final] = ACTIONS(4538),
    [sym_immutable] = ACTIONS(4538),
    [sym_import] = ACTIONS(4538),
    [sym_inout] = ACTIONS(4538),
    [sym_interface] = ACTIONS(4538),
    [sym_invariant] = ACTIONS(4538),
    [sym_mixin] = ACTIONS(4538),
    [sym_nothrow] = ACTIONS(4538),
    [sym_override] = ACTIONS(4538),
    [sym_package] = ACTIONS(4538),
    [sym_pragma] = ACTIONS(4538),
    [sym_private] = ACTIONS(4538),
    [sym_protected] = ACTIONS(4538),
    [sym_public] = ACTIONS(4538),
    [sym_pure] = ACTIONS(4538),
    [sym_ref] = ACTIONS(4538),
    [sym_return] = ACTIONS(4538),
    [sym_scope] = ACTIONS(4538),
    [sym_shared] = ACTIONS(4538),
    [sym_static] = ACTIONS(4538),
    [sym_struct] = ACTIONS(4538),
    [sym_synchronized] = ACTIONS(4538),
    [sym_template] = ACTIONS(4538),
    [sym_typeof] = ACTIONS(4538),
    [sym_union] = ACTIONS(4538),
    [sym_unittest] = ACTIONS(4538),
    [sym_version] = ACTIONS(4538),
    [sym_while] = ACTIONS(4538),
    [sym_gshared] = ACTIONS(4538),
    [sym_traits] = ACTIONS(4538),
    [sym_vector] = ACTIONS(4538),
    [sym_void] = ACTIONS(4538),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2396] = {
    [ts_builtin_sym_end] = ACTIONS(4458),
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_RBRACE] = ACTIONS(4458),
    [anon_sym_DOT] = ACTIONS(4458),
    [anon_sym_SEMI] = ACTIONS(4458),
    [anon_sym_TILDE] = ACTIONS(4458),
    [anon_sym_AT] = ACTIONS(4458),
    [sym_bool] = ACTIONS(4456),
    [sym_byte] = ACTIONS(4456),
    [sym_ubyte] = ACTIONS(4456),
    [sym_char] = ACTIONS(4456),
    [sym_short] = ACTIONS(4456),
    [sym_ushort] = ACTIONS(4456),
    [sym_int] = ACTIONS(4456),
    [sym_uint] = ACTIONS(4456),
    [sym_long] = ACTIONS(4456),
    [sym_ulong] = ACTIONS(4456),
    [sym_cent] = ACTIONS(4456),
    [sym_ucent] = ACTIONS(4456),
    [sym_wchar] = ACTIONS(4456),
    [sym_dchar] = ACTIONS(4456),
    [sym_float] = ACTIONS(4456),
    [sym_double] = ACTIONS(4456),
    [sym_real] = ACTIONS(4456),
    [sym_ifloat] = ACTIONS(4456),
    [sym_idouble] = ACTIONS(4456),
    [sym_ireal] = ACTIONS(4456),
    [sym_cfloat] = ACTIONS(4456),
    [sym_cdouble] = ACTIONS(4456),
    [sym_creal] = ACTIONS(4456),
    [sym_size_t] = ACTIONS(4456),
    [sym_ptrdiff_t] = ACTIONS(4456),
    [sym_string] = ACTIONS(4456),
    [sym_cstring] = ACTIONS(4456),
    [sym_dstring] = ACTIONS(4456),
    [sym_wstring] = ACTIONS(4456),
    [sym_noreturn] = ACTIONS(4456),
    [sym_this] = ACTIONS(4456),
    [sym_abstract] = ACTIONS(4456),
    [sym_alias] = ACTIONS(4456),
    [sym_align] = ACTIONS(4456),
    [sym_auto] = ACTIONS(4456),
    [sym_class] = ACTIONS(4456),
    [sym_const] = ACTIONS(4456),
    [sym_debug] = ACTIONS(4456),
    [sym_deprecated] = ACTIONS(4456),
    [sym_else] = ACTIONS(4456),
    [sym_enum] = ACTIONS(4456),
    [sym_export] = ACTIONS(4456),
    [sym_extern] = ACTIONS(4456),
    [sym_final] = ACTIONS(4456),
    [sym_immutable] = ACTIONS(4456),
    [sym_import] = ACTIONS(4456),
    [sym_inout] = ACTIONS(4456),
    [sym_interface] = ACTIONS(4456),
    [sym_invariant] = ACTIONS(4456),
    [sym_mixin] = ACTIONS(4456),
    [sym_nothrow] = ACTIONS(4456),
    [sym_override] = ACTIONS(4456),
    [sym_package] = ACTIONS(4456),
    [sym_pragma] = ACTIONS(4456),
    [sym_private] = ACTIONS(4456),
    [sym_protected] = ACTIONS(4456),
    [sym_public] = ACTIONS(4456),
    [sym_pure] = ACTIONS(4456),
    [sym_ref] = ACTIONS(4456),
    [sym_return] = ACTIONS(4456),
    [sym_scope] = ACTIONS(4456),
    [sym_shared] = ACTIONS(4456),
    [sym_static] = ACTIONS(4456),
    [sym_struct] = ACTIONS(4456),
    [sym_synchronized] = ACTIONS(4456),
    [sym_template] = ACTIONS(4456),
    [sym_typeof] = ACTIONS(4456),
    [sym_union] = ACTIONS(4456),
    [sym_unittest] = ACTIONS(4456),
    [sym_version] = ACTIONS(4456),
    [sym_while] = ACTIONS(4456),
    [sym_gshared] = ACTIONS(4456),
    [sym_traits] = ACTIONS(4456),
    [sym_vector] = ACTIONS(4456),
    [sym_void] = ACTIONS(4456),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2397] = {
    [ts_builtin_sym_end] = ACTIONS(4504),
    [sym_identifier] = ACTIONS(4502),
    [anon_sym_RBRACE] = ACTIONS(4504),
    [anon_sym_DOT] = ACTIONS(4504),
    [anon_sym_SEMI] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4504),
    [anon_sym_AT] = ACTIONS(4504),
    [sym_bool] = ACTIONS(4502),
    [sym_byte] = ACTIONS(4502),
    [sym_ubyte] = ACTIONS(4502),
    [sym_char] = ACTIONS(4502),
    [sym_short] = ACTIONS(4502),
    [sym_ushort] = ACTIONS(4502),
    [sym_int] = ACTIONS(4502),
    [sym_uint] = ACTIONS(4502),
    [sym_long] = ACTIONS(4502),
    [sym_ulong] = ACTIONS(4502),
    [sym_cent] = ACTIONS(4502),
    [sym_ucent] = ACTIONS(4502),
    [sym_wchar] = ACTIONS(4502),
    [sym_dchar] = ACTIONS(4502),
    [sym_float] = ACTIONS(4502),
    [sym_double] = ACTIONS(4502),
    [sym_real] = ACTIONS(4502),
    [sym_ifloat] = ACTIONS(4502),
    [sym_idouble] = ACTIONS(4502),
    [sym_ireal] = ACTIONS(4502),
    [sym_cfloat] = ACTIONS(4502),
    [sym_cdouble] = ACTIONS(4502),
    [sym_creal] = ACTIONS(4502),
    [sym_size_t] = ACTIONS(4502),
    [sym_ptrdiff_t] = ACTIONS(4502),
    [sym_string] = ACTIONS(4502),
    [sym_cstring] = ACTIONS(4502),
    [sym_dstring] = ACTIONS(4502),
    [sym_wstring] = ACTIONS(4502),
    [sym_noreturn] = ACTIONS(4502),
    [sym_this] = ACTIONS(4502),
    [sym_abstract] = ACTIONS(4502),
    [sym_alias] = ACTIONS(4502),
    [sym_align] = ACTIONS(4502),
    [sym_auto] = ACTIONS(4502),
    [sym_class] = ACTIONS(4502),
    [sym_const] = ACTIONS(4502),
    [sym_debug] = ACTIONS(4502),
    [sym_deprecated] = ACTIONS(4502),
    [sym_else] = ACTIONS(4502),
    [sym_enum] = ACTIONS(4502),
    [sym_export] = ACTIONS(4502),
    [sym_extern] = ACTIONS(4502),
    [sym_final] = ACTIONS(4502),
    [sym_immutable] = ACTIONS(4502),
    [sym_import] = ACTIONS(4502),
    [sym_inout] = ACTIONS(4502),
    [sym_interface] = ACTIONS(4502),
    [sym_invariant] = ACTIONS(4502),
    [sym_mixin] = ACTIONS(4502),
    [sym_nothrow] = ACTIONS(4502),
    [sym_override] = ACTIONS(4502),
    [sym_package] = ACTIONS(4502),
    [sym_pragma] = ACTIONS(4502),
    [sym_private] = ACTIONS(4502),
    [sym_protected] = ACTIONS(4502),
    [sym_public] = ACTIONS(4502),
    [sym_pure] = ACTIONS(4502),
    [sym_ref] = ACTIONS(4502),
    [sym_return] = ACTIONS(4502),
    [sym_scope] = ACTIONS(4502),
    [sym_shared] = ACTIONS(4502),
    [sym_static] = ACTIONS(4502),
    [sym_struct] = ACTIONS(4502),
    [sym_synchronized] = ACTIONS(4502),
    [sym_template] = ACTIONS(4502),
    [sym_typeof] = ACTIONS(4502),
    [sym_union] = ACTIONS(4502),
    [sym_unittest] = ACTIONS(4502),
    [sym_version] = ACTIONS(4502),
    [sym_while] = ACTIONS(4502),
    [sym_gshared] = ACTIONS(4502),
    [sym_traits] = ACTIONS(4502),
    [sym_vector] = ACTIONS(4502),
    [sym_void] = ACTIONS(4502),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2398] = {
    [ts_builtin_sym_end] = ACTIONS(4462),
    [sym_identifier] = ACTIONS(4460),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_DOT] = ACTIONS(4462),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_TILDE] = ACTIONS(4462),
    [anon_sym_AT] = ACTIONS(4462),
    [sym_bool] = ACTIONS(4460),
    [sym_byte] = ACTIONS(4460),
    [sym_ubyte] = ACTIONS(4460),
    [sym_char] = ACTIONS(4460),
    [sym_short] = ACTIONS(4460),
    [sym_ushort] = ACTIONS(4460),
    [sym_int] = ACTIONS(4460),
    [sym_uint] = ACTIONS(4460),
    [sym_long] = ACTIONS(4460),
    [sym_ulong] = ACTIONS(4460),
    [sym_cent] = ACTIONS(4460),
    [sym_ucent] = ACTIONS(4460),
    [sym_wchar] = ACTIONS(4460),
    [sym_dchar] = ACTIONS(4460),
    [sym_float] = ACTIONS(4460),
    [sym_double] = ACTIONS(4460),
    [sym_real] = ACTIONS(4460),
    [sym_ifloat] = ACTIONS(4460),
    [sym_idouble] = ACTIONS(4460),
    [sym_ireal] = ACTIONS(4460),
    [sym_cfloat] = ACTIONS(4460),
    [sym_cdouble] = ACTIONS(4460),
    [sym_creal] = ACTIONS(4460),
    [sym_size_t] = ACTIONS(4460),
    [sym_ptrdiff_t] = ACTIONS(4460),
    [sym_string] = ACTIONS(4460),
    [sym_cstring] = ACTIONS(4460),
    [sym_dstring] = ACTIONS(4460),
    [sym_wstring] = ACTIONS(4460),
    [sym_noreturn] = ACTIONS(4460),
    [sym_this] = ACTIONS(4460),
    [sym_abstract] = ACTIONS(4460),
    [sym_alias] = ACTIONS(4460),
    [sym_align] = ACTIONS(4460),
    [sym_auto] = ACTIONS(4460),
    [sym_class] = ACTIONS(4460),
    [sym_const] = ACTIONS(4460),
    [sym_debug] = ACTIONS(4460),
    [sym_deprecated] = ACTIONS(4460),
    [sym_else] = ACTIONS(4460),
    [sym_enum] = ACTIONS(4460),
    [sym_export] = ACTIONS(4460),
    [sym_extern] = ACTIONS(4460),
    [sym_final] = ACTIONS(4460),
    [sym_immutable] = ACTIONS(4460),
    [sym_import] = ACTIONS(4460),
    [sym_inout] = ACTIONS(4460),
    [sym_interface] = ACTIONS(4460),
    [sym_invariant] = ACTIONS(4460),
    [sym_mixin] = ACTIONS(4460),
    [sym_nothrow] = ACTIONS(4460),
    [sym_override] = ACTIONS(4460),
    [sym_package] = ACTIONS(4460),
    [sym_pragma] = ACTIONS(4460),
    [sym_private] = ACTIONS(4460),
    [sym_protected] = ACTIONS(4460),
    [sym_public] = ACTIONS(4460),
    [sym_pure] = ACTIONS(4460),
    [sym_ref] = ACTIONS(4460),
    [sym_return] = ACTIONS(4460),
    [sym_scope] = ACTIONS(4460),
    [sym_shared] = ACTIONS(4460),
    [sym_static] = ACTIONS(4460),
    [sym_struct] = ACTIONS(4460),
    [sym_synchronized] = ACTIONS(4460),
    [sym_template] = ACTIONS(4460),
    [sym_typeof] = ACTIONS(4460),
    [sym_union] = ACTIONS(4460),
    [sym_unittest] = ACTIONS(4460),
    [sym_version] = ACTIONS(4460),
    [sym_while] = ACTIONS(4460),
    [sym_gshared] = ACTIONS(4460),
    [sym_traits] = ACTIONS(4460),
    [sym_vector] = ACTIONS(4460),
    [sym_void] = ACTIONS(4460),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2399] = {
    [ts_builtin_sym_end] = ACTIONS(2503),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2400] = {
    [ts_builtin_sym_end] = ACTIONS(4767),
    [sym_identifier] = ACTIONS(4765),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym_DOT] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4767),
    [anon_sym_TILDE] = ACTIONS(4767),
    [anon_sym_AT] = ACTIONS(4767),
    [sym_bool] = ACTIONS(4765),
    [sym_byte] = ACTIONS(4765),
    [sym_ubyte] = ACTIONS(4765),
    [sym_char] = ACTIONS(4765),
    [sym_short] = ACTIONS(4765),
    [sym_ushort] = ACTIONS(4765),
    [sym_int] = ACTIONS(4765),
    [sym_uint] = ACTIONS(4765),
    [sym_long] = ACTIONS(4765),
    [sym_ulong] = ACTIONS(4765),
    [sym_cent] = ACTIONS(4765),
    [sym_ucent] = ACTIONS(4765),
    [sym_wchar] = ACTIONS(4765),
    [sym_dchar] = ACTIONS(4765),
    [sym_float] = ACTIONS(4765),
    [sym_double] = ACTIONS(4765),
    [sym_real] = ACTIONS(4765),
    [sym_ifloat] = ACTIONS(4765),
    [sym_idouble] = ACTIONS(4765),
    [sym_ireal] = ACTIONS(4765),
    [sym_cfloat] = ACTIONS(4765),
    [sym_cdouble] = ACTIONS(4765),
    [sym_creal] = ACTIONS(4765),
    [sym_size_t] = ACTIONS(4765),
    [sym_ptrdiff_t] = ACTIONS(4765),
    [sym_string] = ACTIONS(4765),
    [sym_cstring] = ACTIONS(4765),
    [sym_dstring] = ACTIONS(4765),
    [sym_wstring] = ACTIONS(4765),
    [sym_noreturn] = ACTIONS(4765),
    [sym_this] = ACTIONS(4765),
    [sym_abstract] = ACTIONS(4765),
    [sym_alias] = ACTIONS(4765),
    [sym_align] = ACTIONS(4765),
    [sym_auto] = ACTIONS(4765),
    [sym_class] = ACTIONS(4765),
    [sym_const] = ACTIONS(4765),
    [sym_debug] = ACTIONS(4765),
    [sym_deprecated] = ACTIONS(4765),
    [sym_else] = ACTIONS(4765),
    [sym_enum] = ACTIONS(4765),
    [sym_export] = ACTIONS(4765),
    [sym_extern] = ACTIONS(4765),
    [sym_final] = ACTIONS(4765),
    [sym_immutable] = ACTIONS(4765),
    [sym_import] = ACTIONS(4765),
    [sym_inout] = ACTIONS(4765),
    [sym_interface] = ACTIONS(4765),
    [sym_invariant] = ACTIONS(4765),
    [sym_mixin] = ACTIONS(4765),
    [sym_nothrow] = ACTIONS(4765),
    [sym_override] = ACTIONS(4765),
    [sym_package] = ACTIONS(4765),
    [sym_pragma] = ACTIONS(4765),
    [sym_private] = ACTIONS(4765),
    [sym_protected] = ACTIONS(4765),
    [sym_public] = ACTIONS(4765),
    [sym_pure] = ACTIONS(4765),
    [sym_ref] = ACTIONS(4765),
    [sym_return] = ACTIONS(4765),
    [sym_scope] = ACTIONS(4765),
    [sym_shared] = ACTIONS(4765),
    [sym_static] = ACTIONS(4765),
    [sym_struct] = ACTIONS(4765),
    [sym_synchronized] = ACTIONS(4765),
    [sym_template] = ACTIONS(4765),
    [sym_typeof] = ACTIONS(4765),
    [sym_union] = ACTIONS(4765),
    [sym_unittest] = ACTIONS(4765),
    [sym_version] = ACTIONS(4765),
    [sym_while] = ACTIONS(4765),
    [sym_gshared] = ACTIONS(4765),
    [sym_traits] = ACTIONS(4765),
    [sym_vector] = ACTIONS(4765),
    [sym_void] = ACTIONS(4765),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2401] = {
    [ts_builtin_sym_end] = ACTIONS(4662),
    [sym_identifier] = ACTIONS(4660),
    [anon_sym_RBRACE] = ACTIONS(4662),
    [anon_sym_DOT] = ACTIONS(4662),
    [anon_sym_SEMI] = ACTIONS(4662),
    [anon_sym_TILDE] = ACTIONS(4662),
    [anon_sym_AT] = ACTIONS(4662),
    [sym_bool] = ACTIONS(4660),
    [sym_byte] = ACTIONS(4660),
    [sym_ubyte] = ACTIONS(4660),
    [sym_char] = ACTIONS(4660),
    [sym_short] = ACTIONS(4660),
    [sym_ushort] = ACTIONS(4660),
    [sym_int] = ACTIONS(4660),
    [sym_uint] = ACTIONS(4660),
    [sym_long] = ACTIONS(4660),
    [sym_ulong] = ACTIONS(4660),
    [sym_cent] = ACTIONS(4660),
    [sym_ucent] = ACTIONS(4660),
    [sym_wchar] = ACTIONS(4660),
    [sym_dchar] = ACTIONS(4660),
    [sym_float] = ACTIONS(4660),
    [sym_double] = ACTIONS(4660),
    [sym_real] = ACTIONS(4660),
    [sym_ifloat] = ACTIONS(4660),
    [sym_idouble] = ACTIONS(4660),
    [sym_ireal] = ACTIONS(4660),
    [sym_cfloat] = ACTIONS(4660),
    [sym_cdouble] = ACTIONS(4660),
    [sym_creal] = ACTIONS(4660),
    [sym_size_t] = ACTIONS(4660),
    [sym_ptrdiff_t] = ACTIONS(4660),
    [sym_string] = ACTIONS(4660),
    [sym_cstring] = ACTIONS(4660),
    [sym_dstring] = ACTIONS(4660),
    [sym_wstring] = ACTIONS(4660),
    [sym_noreturn] = ACTIONS(4660),
    [sym_this] = ACTIONS(4660),
    [sym_abstract] = ACTIONS(4660),
    [sym_alias] = ACTIONS(4660),
    [sym_align] = ACTIONS(4660),
    [sym_auto] = ACTIONS(4660),
    [sym_class] = ACTIONS(4660),
    [sym_const] = ACTIONS(4660),
    [sym_debug] = ACTIONS(4660),
    [sym_deprecated] = ACTIONS(4660),
    [sym_else] = ACTIONS(4660),
    [sym_enum] = ACTIONS(4660),
    [sym_export] = ACTIONS(4660),
    [sym_extern] = ACTIONS(4660),
    [sym_final] = ACTIONS(4660),
    [sym_immutable] = ACTIONS(4660),
    [sym_import] = ACTIONS(4660),
    [sym_inout] = ACTIONS(4660),
    [sym_interface] = ACTIONS(4660),
    [sym_invariant] = ACTIONS(4660),
    [sym_mixin] = ACTIONS(4660),
    [sym_nothrow] = ACTIONS(4660),
    [sym_override] = ACTIONS(4660),
    [sym_package] = ACTIONS(4660),
    [sym_pragma] = ACTIONS(4660),
    [sym_private] = ACTIONS(4660),
    [sym_protected] = ACTIONS(4660),
    [sym_public] = ACTIONS(4660),
    [sym_pure] = ACTIONS(4660),
    [sym_ref] = ACTIONS(4660),
    [sym_return] = ACTIONS(4660),
    [sym_scope] = ACTIONS(4660),
    [sym_shared] = ACTIONS(4660),
    [sym_static] = ACTIONS(4660),
    [sym_struct] = ACTIONS(4660),
    [sym_synchronized] = ACTIONS(4660),
    [sym_template] = ACTIONS(4660),
    [sym_typeof] = ACTIONS(4660),
    [sym_union] = ACTIONS(4660),
    [sym_unittest] = ACTIONS(4660),
    [sym_version] = ACTIONS(4660),
    [sym_while] = ACTIONS(4660),
    [sym_gshared] = ACTIONS(4660),
    [sym_traits] = ACTIONS(4660),
    [sym_vector] = ACTIONS(4660),
    [sym_void] = ACTIONS(4660),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2402] = {
    [ts_builtin_sym_end] = ACTIONS(2503),
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_RBRACE] = ACTIONS(2503),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_else] = ACTIONS(6088),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2403] = {
    [sym_identifier] = ACTIONS(4875),
    [anon_sym_DOT] = ACTIONS(4877),
    [anon_sym_SEMI] = ACTIONS(4877),
    [anon_sym_TILDE] = ACTIONS(4877),
    [anon_sym_AT] = ACTIONS(4877),
    [sym_bool] = ACTIONS(4875),
    [sym_byte] = ACTIONS(4875),
    [sym_ubyte] = ACTIONS(4875),
    [sym_char] = ACTIONS(4875),
    [sym_short] = ACTIONS(4875),
    [sym_ushort] = ACTIONS(4875),
    [sym_int] = ACTIONS(4875),
    [sym_uint] = ACTIONS(4875),
    [sym_long] = ACTIONS(4875),
    [sym_ulong] = ACTIONS(4875),
    [sym_cent] = ACTIONS(4875),
    [sym_ucent] = ACTIONS(4875),
    [sym_wchar] = ACTIONS(4875),
    [sym_dchar] = ACTIONS(4875),
    [sym_float] = ACTIONS(4875),
    [sym_double] = ACTIONS(4875),
    [sym_real] = ACTIONS(4875),
    [sym_ifloat] = ACTIONS(4875),
    [sym_idouble] = ACTIONS(4875),
    [sym_ireal] = ACTIONS(4875),
    [sym_cfloat] = ACTIONS(4875),
    [sym_cdouble] = ACTIONS(4875),
    [sym_creal] = ACTIONS(4875),
    [sym_size_t] = ACTIONS(4875),
    [sym_ptrdiff_t] = ACTIONS(4875),
    [sym_string] = ACTIONS(4875),
    [sym_cstring] = ACTIONS(4875),
    [sym_dstring] = ACTIONS(4875),
    [sym_wstring] = ACTIONS(4875),
    [sym_noreturn] = ACTIONS(4875),
    [sym_this] = ACTIONS(4875),
    [sym_abstract] = ACTIONS(4875),
    [sym_alias] = ACTIONS(4875),
    [sym_align] = ACTIONS(4875),
    [sym_auto] = ACTIONS(4875),
    [sym_catch] = ACTIONS(4875),
    [sym_class] = ACTIONS(4875),
    [sym_const] = ACTIONS(4875),
    [sym_debug] = ACTIONS(4875),
    [sym_deprecated] = ACTIONS(4875),
    [sym_else] = ACTIONS(4875),
    [sym_enum] = ACTIONS(4875),
    [sym_export] = ACTIONS(4875),
    [sym_extern] = ACTIONS(4875),
    [sym_final] = ACTIONS(4875),
    [sym_finally] = ACTIONS(4875),
    [sym_immutable] = ACTIONS(4875),
    [sym_import] = ACTIONS(4875),
    [sym_inout] = ACTIONS(4875),
    [sym_interface] = ACTIONS(4875),
    [sym_invariant] = ACTIONS(4875),
    [sym_mixin] = ACTIONS(4875),
    [sym_nothrow] = ACTIONS(4875),
    [sym_override] = ACTIONS(4875),
    [sym_package] = ACTIONS(4875),
    [sym_pragma] = ACTIONS(4875),
    [sym_private] = ACTIONS(4875),
    [sym_protected] = ACTIONS(4875),
    [sym_public] = ACTIONS(4875),
    [sym_pure] = ACTIONS(4875),
    [sym_ref] = ACTIONS(4875),
    [sym_return] = ACTIONS(4875),
    [sym_scope] = ACTIONS(4875),
    [sym_shared] = ACTIONS(4875),
    [sym_static] = ACTIONS(4875),
    [sym_struct] = ACTIONS(4875),
    [sym_synchronized] = ACTIONS(4875),
    [sym_template] = ACTIONS(4875),
    [sym_typeof] = ACTIONS(4875),
    [sym_union] = ACTIONS(4875),
    [sym_unittest] = ACTIONS(4875),
    [sym_version] = ACTIONS(4875),
    [sym_while] = ACTIONS(4875),
    [sym_gshared] = ACTIONS(4875),
    [sym_traits] = ACTIONS(4875),
    [sym_vector] = ACTIONS(4875),
    [sym_void] = ACTIONS(4875),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2404] = {
    [ts_builtin_sym_end] = ACTIONS(4841),
    [sym_identifier] = ACTIONS(4839),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [anon_sym_DOT] = ACTIONS(4841),
    [anon_sym_SEMI] = ACTIONS(4841),
    [anon_sym_TILDE] = ACTIONS(4841),
    [anon_sym_AT] = ACTIONS(4841),
    [sym_bool] = ACTIONS(4839),
    [sym_byte] = ACTIONS(4839),
    [sym_ubyte] = ACTIONS(4839),
    [sym_char] = ACTIONS(4839),
    [sym_short] = ACTIONS(4839),
    [sym_ushort] = ACTIONS(4839),
    [sym_int] = ACTIONS(4839),
    [sym_uint] = ACTIONS(4839),
    [sym_long] = ACTIONS(4839),
    [sym_ulong] = ACTIONS(4839),
    [sym_cent] = ACTIONS(4839),
    [sym_ucent] = ACTIONS(4839),
    [sym_wchar] = ACTIONS(4839),
    [sym_dchar] = ACTIONS(4839),
    [sym_float] = ACTIONS(4839),
    [sym_double] = ACTIONS(4839),
    [sym_real] = ACTIONS(4839),
    [sym_ifloat] = ACTIONS(4839),
    [sym_idouble] = ACTIONS(4839),
    [sym_ireal] = ACTIONS(4839),
    [sym_cfloat] = ACTIONS(4839),
    [sym_cdouble] = ACTIONS(4839),
    [sym_creal] = ACTIONS(4839),
    [sym_size_t] = ACTIONS(4839),
    [sym_ptrdiff_t] = ACTIONS(4839),
    [sym_string] = ACTIONS(4839),
    [sym_cstring] = ACTIONS(4839),
    [sym_dstring] = ACTIONS(4839),
    [sym_wstring] = ACTIONS(4839),
    [sym_noreturn] = ACTIONS(4839),
    [sym_this] = ACTIONS(4839),
    [sym_abstract] = ACTIONS(4839),
    [sym_alias] = ACTIONS(4839),
    [sym_align] = ACTIONS(4839),
    [sym_auto] = ACTIONS(4839),
    [sym_class] = ACTIONS(4839),
    [sym_const] = ACTIONS(4839),
    [sym_debug] = ACTIONS(4839),
    [sym_deprecated] = ACTIONS(4839),
    [sym_else] = ACTIONS(4839),
    [sym_enum] = ACTIONS(4839),
    [sym_export] = ACTIONS(4839),
    [sym_extern] = ACTIONS(4839),
    [sym_final] = ACTIONS(4839),
    [sym_immutable] = ACTIONS(4839),
    [sym_import] = ACTIONS(4839),
    [sym_inout] = ACTIONS(4839),
    [sym_interface] = ACTIONS(4839),
    [sym_invariant] = ACTIONS(4839),
    [sym_mixin] = ACTIONS(4839),
    [sym_nothrow] = ACTIONS(4839),
    [sym_override] = ACTIONS(4839),
    [sym_package] = ACTIONS(4839),
    [sym_pragma] = ACTIONS(4839),
    [sym_private] = ACTIONS(4839),
    [sym_protected] = ACTIONS(4839),
    [sym_public] = ACTIONS(4839),
    [sym_pure] = ACTIONS(4839),
    [sym_ref] = ACTIONS(4839),
    [sym_return] = ACTIONS(4839),
    [sym_scope] = ACTIONS(4839),
    [sym_shared] = ACTIONS(4839),
    [sym_static] = ACTIONS(4839),
    [sym_struct] = ACTIONS(4839),
    [sym_synchronized] = ACTIONS(4839),
    [sym_template] = ACTIONS(4839),
    [sym_typeof] = ACTIONS(4839),
    [sym_union] = ACTIONS(4839),
    [sym_unittest] = ACTIONS(4839),
    [sym_version] = ACTIONS(4839),
    [sym_while] = ACTIONS(4839),
    [sym_gshared] = ACTIONS(4839),
    [sym_traits] = ACTIONS(4839),
    [sym_vector] = ACTIONS(4839),
    [sym_void] = ACTIONS(4839),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2405] = {
    [ts_builtin_sym_end] = ACTIONS(4837),
    [sym_identifier] = ACTIONS(4835),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_DOT] = ACTIONS(4837),
    [anon_sym_SEMI] = ACTIONS(4837),
    [anon_sym_TILDE] = ACTIONS(4837),
    [anon_sym_AT] = ACTIONS(4837),
    [sym_bool] = ACTIONS(4835),
    [sym_byte] = ACTIONS(4835),
    [sym_ubyte] = ACTIONS(4835),
    [sym_char] = ACTIONS(4835),
    [sym_short] = ACTIONS(4835),
    [sym_ushort] = ACTIONS(4835),
    [sym_int] = ACTIONS(4835),
    [sym_uint] = ACTIONS(4835),
    [sym_long] = ACTIONS(4835),
    [sym_ulong] = ACTIONS(4835),
    [sym_cent] = ACTIONS(4835),
    [sym_ucent] = ACTIONS(4835),
    [sym_wchar] = ACTIONS(4835),
    [sym_dchar] = ACTIONS(4835),
    [sym_float] = ACTIONS(4835),
    [sym_double] = ACTIONS(4835),
    [sym_real] = ACTIONS(4835),
    [sym_ifloat] = ACTIONS(4835),
    [sym_idouble] = ACTIONS(4835),
    [sym_ireal] = ACTIONS(4835),
    [sym_cfloat] = ACTIONS(4835),
    [sym_cdouble] = ACTIONS(4835),
    [sym_creal] = ACTIONS(4835),
    [sym_size_t] = ACTIONS(4835),
    [sym_ptrdiff_t] = ACTIONS(4835),
    [sym_string] = ACTIONS(4835),
    [sym_cstring] = ACTIONS(4835),
    [sym_dstring] = ACTIONS(4835),
    [sym_wstring] = ACTIONS(4835),
    [sym_noreturn] = ACTIONS(4835),
    [sym_this] = ACTIONS(4835),
    [sym_abstract] = ACTIONS(4835),
    [sym_alias] = ACTIONS(4835),
    [sym_align] = ACTIONS(4835),
    [sym_auto] = ACTIONS(4835),
    [sym_class] = ACTIONS(4835),
    [sym_const] = ACTIONS(4835),
    [sym_debug] = ACTIONS(4835),
    [sym_deprecated] = ACTIONS(4835),
    [sym_else] = ACTIONS(4835),
    [sym_enum] = ACTIONS(4835),
    [sym_export] = ACTIONS(4835),
    [sym_extern] = ACTIONS(4835),
    [sym_final] = ACTIONS(4835),
    [sym_immutable] = ACTIONS(4835),
    [sym_import] = ACTIONS(4835),
    [sym_inout] = ACTIONS(4835),
    [sym_interface] = ACTIONS(4835),
    [sym_invariant] = ACTIONS(4835),
    [sym_mixin] = ACTIONS(4835),
    [sym_nothrow] = ACTIONS(4835),
    [sym_override] = ACTIONS(4835),
    [sym_package] = ACTIONS(4835),
    [sym_pragma] = ACTIONS(4835),
    [sym_private] = ACTIONS(4835),
    [sym_protected] = ACTIONS(4835),
    [sym_public] = ACTIONS(4835),
    [sym_pure] = ACTIONS(4835),
    [sym_ref] = ACTIONS(4835),
    [sym_return] = ACTIONS(4835),
    [sym_scope] = ACTIONS(4835),
    [sym_shared] = ACTIONS(4835),
    [sym_static] = ACTIONS(4835),
    [sym_struct] = ACTIONS(4835),
    [sym_synchronized] = ACTIONS(4835),
    [sym_template] = ACTIONS(4835),
    [sym_typeof] = ACTIONS(4835),
    [sym_union] = ACTIONS(4835),
    [sym_unittest] = ACTIONS(4835),
    [sym_version] = ACTIONS(4835),
    [sym_while] = ACTIONS(4835),
    [sym_gshared] = ACTIONS(4835),
    [sym_traits] = ACTIONS(4835),
    [sym_vector] = ACTIONS(4835),
    [sym_void] = ACTIONS(4835),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2406] = {
    [ts_builtin_sym_end] = ACTIONS(4520),
    [sym_identifier] = ACTIONS(4518),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_DOT] = ACTIONS(4520),
    [anon_sym_SEMI] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4520),
    [anon_sym_AT] = ACTIONS(4520),
    [sym_bool] = ACTIONS(4518),
    [sym_byte] = ACTIONS(4518),
    [sym_ubyte] = ACTIONS(4518),
    [sym_char] = ACTIONS(4518),
    [sym_short] = ACTIONS(4518),
    [sym_ushort] = ACTIONS(4518),
    [sym_int] = ACTIONS(4518),
    [sym_uint] = ACTIONS(4518),
    [sym_long] = ACTIONS(4518),
    [sym_ulong] = ACTIONS(4518),
    [sym_cent] = ACTIONS(4518),
    [sym_ucent] = ACTIONS(4518),
    [sym_wchar] = ACTIONS(4518),
    [sym_dchar] = ACTIONS(4518),
    [sym_float] = ACTIONS(4518),
    [sym_double] = ACTIONS(4518),
    [sym_real] = ACTIONS(4518),
    [sym_ifloat] = ACTIONS(4518),
    [sym_idouble] = ACTIONS(4518),
    [sym_ireal] = ACTIONS(4518),
    [sym_cfloat] = ACTIONS(4518),
    [sym_cdouble] = ACTIONS(4518),
    [sym_creal] = ACTIONS(4518),
    [sym_size_t] = ACTIONS(4518),
    [sym_ptrdiff_t] = ACTIONS(4518),
    [sym_string] = ACTIONS(4518),
    [sym_cstring] = ACTIONS(4518),
    [sym_dstring] = ACTIONS(4518),
    [sym_wstring] = ACTIONS(4518),
    [sym_noreturn] = ACTIONS(4518),
    [sym_this] = ACTIONS(4518),
    [sym_abstract] = ACTIONS(4518),
    [sym_alias] = ACTIONS(4518),
    [sym_align] = ACTIONS(4518),
    [sym_auto] = ACTIONS(4518),
    [sym_class] = ACTIONS(4518),
    [sym_const] = ACTIONS(4518),
    [sym_debug] = ACTIONS(4518),
    [sym_deprecated] = ACTIONS(4518),
    [sym_else] = ACTIONS(4518),
    [sym_enum] = ACTIONS(4518),
    [sym_export] = ACTIONS(4518),
    [sym_extern] = ACTIONS(4518),
    [sym_final] = ACTIONS(4518),
    [sym_immutable] = ACTIONS(4518),
    [sym_import] = ACTIONS(4518),
    [sym_inout] = ACTIONS(4518),
    [sym_interface] = ACTIONS(4518),
    [sym_invariant] = ACTIONS(4518),
    [sym_mixin] = ACTIONS(4518),
    [sym_nothrow] = ACTIONS(4518),
    [sym_override] = ACTIONS(4518),
    [sym_package] = ACTIONS(4518),
    [sym_pragma] = ACTIONS(4518),
    [sym_private] = ACTIONS(4518),
    [sym_protected] = ACTIONS(4518),
    [sym_public] = ACTIONS(4518),
    [sym_pure] = ACTIONS(4518),
    [sym_ref] = ACTIONS(4518),
    [sym_return] = ACTIONS(4518),
    [sym_scope] = ACTIONS(4518),
    [sym_shared] = ACTIONS(4518),
    [sym_static] = ACTIONS(4518),
    [sym_struct] = ACTIONS(4518),
    [sym_synchronized] = ACTIONS(4518),
    [sym_template] = ACTIONS(4518),
    [sym_typeof] = ACTIONS(4518),
    [sym_union] = ACTIONS(4518),
    [sym_unittest] = ACTIONS(4518),
    [sym_version] = ACTIONS(4518),
    [sym_while] = ACTIONS(4518),
    [sym_gshared] = ACTIONS(4518),
    [sym_traits] = ACTIONS(4518),
    [sym_vector] = ACTIONS(4518),
    [sym_void] = ACTIONS(4518),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2407] = {
    [sym_identifier] = ACTIONS(4456),
    [anon_sym_DOT] = ACTIONS(4458),
    [anon_sym_SEMI] = ACTIONS(4458),
    [anon_sym_TILDE] = ACTIONS(4458),
    [anon_sym_AT] = ACTIONS(4458),
    [sym_bool] = ACTIONS(4456),
    [sym_byte] = ACTIONS(4456),
    [sym_ubyte] = ACTIONS(4456),
    [sym_char] = ACTIONS(4456),
    [sym_short] = ACTIONS(4456),
    [sym_ushort] = ACTIONS(4456),
    [sym_int] = ACTIONS(4456),
    [sym_uint] = ACTIONS(4456),
    [sym_long] = ACTIONS(4456),
    [sym_ulong] = ACTIONS(4456),
    [sym_cent] = ACTIONS(4456),
    [sym_ucent] = ACTIONS(4456),
    [sym_wchar] = ACTIONS(4456),
    [sym_dchar] = ACTIONS(4456),
    [sym_float] = ACTIONS(4456),
    [sym_double] = ACTIONS(4456),
    [sym_real] = ACTIONS(4456),
    [sym_ifloat] = ACTIONS(4456),
    [sym_idouble] = ACTIONS(4456),
    [sym_ireal] = ACTIONS(4456),
    [sym_cfloat] = ACTIONS(4456),
    [sym_cdouble] = ACTIONS(4456),
    [sym_creal] = ACTIONS(4456),
    [sym_size_t] = ACTIONS(4456),
    [sym_ptrdiff_t] = ACTIONS(4456),
    [sym_string] = ACTIONS(4456),
    [sym_cstring] = ACTIONS(4456),
    [sym_dstring] = ACTIONS(4456),
    [sym_wstring] = ACTIONS(4456),
    [sym_noreturn] = ACTIONS(4456),
    [sym_this] = ACTIONS(4456),
    [sym_abstract] = ACTIONS(4456),
    [sym_alias] = ACTIONS(4456),
    [sym_align] = ACTIONS(4456),
    [sym_auto] = ACTIONS(4456),
    [sym_catch] = ACTIONS(4456),
    [sym_class] = ACTIONS(4456),
    [sym_const] = ACTIONS(4456),
    [sym_debug] = ACTIONS(4456),
    [sym_deprecated] = ACTIONS(4456),
    [sym_else] = ACTIONS(4456),
    [sym_enum] = ACTIONS(4456),
    [sym_export] = ACTIONS(4456),
    [sym_extern] = ACTIONS(4456),
    [sym_final] = ACTIONS(4456),
    [sym_finally] = ACTIONS(4456),
    [sym_immutable] = ACTIONS(4456),
    [sym_import] = ACTIONS(4456),
    [sym_inout] = ACTIONS(4456),
    [sym_interface] = ACTIONS(4456),
    [sym_invariant] = ACTIONS(4456),
    [sym_mixin] = ACTIONS(4456),
    [sym_nothrow] = ACTIONS(4456),
    [sym_override] = ACTIONS(4456),
    [sym_package] = ACTIONS(4456),
    [sym_pragma] = ACTIONS(4456),
    [sym_private] = ACTIONS(4456),
    [sym_protected] = ACTIONS(4456),
    [sym_public] = ACTIONS(4456),
    [sym_pure] = ACTIONS(4456),
    [sym_ref] = ACTIONS(4456),
    [sym_return] = ACTIONS(4456),
    [sym_scope] = ACTIONS(4456),
    [sym_shared] = ACTIONS(4456),
    [sym_static] = ACTIONS(4456),
    [sym_struct] = ACTIONS(4456),
    [sym_synchronized] = ACTIONS(4456),
    [sym_template] = ACTIONS(4456),
    [sym_typeof] = ACTIONS(4456),
    [sym_union] = ACTIONS(4456),
    [sym_unittest] = ACTIONS(4456),
    [sym_version] = ACTIONS(4456),
    [sym_while] = ACTIONS(4456),
    [sym_gshared] = ACTIONS(4456),
    [sym_traits] = ACTIONS(4456),
    [sym_vector] = ACTIONS(4456),
    [sym_void] = ACTIONS(4456),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2408] = {
    [sym_identifier] = ACTIONS(4460),
    [anon_sym_DOT] = ACTIONS(4462),
    [anon_sym_SEMI] = ACTIONS(4462),
    [anon_sym_TILDE] = ACTIONS(4462),
    [anon_sym_AT] = ACTIONS(4462),
    [sym_bool] = ACTIONS(4460),
    [sym_byte] = ACTIONS(4460),
    [sym_ubyte] = ACTIONS(4460),
    [sym_char] = ACTIONS(4460),
    [sym_short] = ACTIONS(4460),
    [sym_ushort] = ACTIONS(4460),
    [sym_int] = ACTIONS(4460),
    [sym_uint] = ACTIONS(4460),
    [sym_long] = ACTIONS(4460),
    [sym_ulong] = ACTIONS(4460),
    [sym_cent] = ACTIONS(4460),
    [sym_ucent] = ACTIONS(4460),
    [sym_wchar] = ACTIONS(4460),
    [sym_dchar] = ACTIONS(4460),
    [sym_float] = ACTIONS(4460),
    [sym_double] = ACTIONS(4460),
    [sym_real] = ACTIONS(4460),
    [sym_ifloat] = ACTIONS(4460),
    [sym_idouble] = ACTIONS(4460),
    [sym_ireal] = ACTIONS(4460),
    [sym_cfloat] = ACTIONS(4460),
    [sym_cdouble] = ACTIONS(4460),
    [sym_creal] = ACTIONS(4460),
    [sym_size_t] = ACTIONS(4460),
    [sym_ptrdiff_t] = ACTIONS(4460),
    [sym_string] = ACTIONS(4460),
    [sym_cstring] = ACTIONS(4460),
    [sym_dstring] = ACTIONS(4460),
    [sym_wstring] = ACTIONS(4460),
    [sym_noreturn] = ACTIONS(4460),
    [sym_this] = ACTIONS(4460),
    [sym_abstract] = ACTIONS(4460),
    [sym_alias] = ACTIONS(4460),
    [sym_align] = ACTIONS(4460),
    [sym_auto] = ACTIONS(4460),
    [sym_catch] = ACTIONS(4460),
    [sym_class] = ACTIONS(4460),
    [sym_const] = ACTIONS(4460),
    [sym_debug] = ACTIONS(4460),
    [sym_deprecated] = ACTIONS(4460),
    [sym_else] = ACTIONS(4460),
    [sym_enum] = ACTIONS(4460),
    [sym_export] = ACTIONS(4460),
    [sym_extern] = ACTIONS(4460),
    [sym_final] = ACTIONS(4460),
    [sym_finally] = ACTIONS(4460),
    [sym_immutable] = ACTIONS(4460),
    [sym_import] = ACTIONS(4460),
    [sym_inout] = ACTIONS(4460),
    [sym_interface] = ACTIONS(4460),
    [sym_invariant] = ACTIONS(4460),
    [sym_mixin] = ACTIONS(4460),
    [sym_nothrow] = ACTIONS(4460),
    [sym_override] = ACTIONS(4460),
    [sym_package] = ACTIONS(4460),
    [sym_pragma] = ACTIONS(4460),
    [sym_private] = ACTIONS(4460),
    [sym_protected] = ACTIONS(4460),
    [sym_public] = ACTIONS(4460),
    [sym_pure] = ACTIONS(4460),
    [sym_ref] = ACTIONS(4460),
    [sym_return] = ACTIONS(4460),
    [sym_scope] = ACTIONS(4460),
    [sym_shared] = ACTIONS(4460),
    [sym_static] = ACTIONS(4460),
    [sym_struct] = ACTIONS(4460),
    [sym_synchronized] = ACTIONS(4460),
    [sym_template] = ACTIONS(4460),
    [sym_typeof] = ACTIONS(4460),
    [sym_union] = ACTIONS(4460),
    [sym_unittest] = ACTIONS(4460),
    [sym_version] = ACTIONS(4460),
    [sym_while] = ACTIONS(4460),
    [sym_gshared] = ACTIONS(4460),
    [sym_traits] = ACTIONS(4460),
    [sym_vector] = ACTIONS(4460),
    [sym_void] = ACTIONS(4460),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2409] = {
    [sym_identifier] = ACTIONS(4879),
    [anon_sym_DOT] = ACTIONS(4881),
    [anon_sym_SEMI] = ACTIONS(4881),
    [anon_sym_TILDE] = ACTIONS(4881),
    [anon_sym_AT] = ACTIONS(4881),
    [sym_bool] = ACTIONS(4879),
    [sym_byte] = ACTIONS(4879),
    [sym_ubyte] = ACTIONS(4879),
    [sym_char] = ACTIONS(4879),
    [sym_short] = ACTIONS(4879),
    [sym_ushort] = ACTIONS(4879),
    [sym_int] = ACTIONS(4879),
    [sym_uint] = ACTIONS(4879),
    [sym_long] = ACTIONS(4879),
    [sym_ulong] = ACTIONS(4879),
    [sym_cent] = ACTIONS(4879),
    [sym_ucent] = ACTIONS(4879),
    [sym_wchar] = ACTIONS(4879),
    [sym_dchar] = ACTIONS(4879),
    [sym_float] = ACTIONS(4879),
    [sym_double] = ACTIONS(4879),
    [sym_real] = ACTIONS(4879),
    [sym_ifloat] = ACTIONS(4879),
    [sym_idouble] = ACTIONS(4879),
    [sym_ireal] = ACTIONS(4879),
    [sym_cfloat] = ACTIONS(4879),
    [sym_cdouble] = ACTIONS(4879),
    [sym_creal] = ACTIONS(4879),
    [sym_size_t] = ACTIONS(4879),
    [sym_ptrdiff_t] = ACTIONS(4879),
    [sym_string] = ACTIONS(4879),
    [sym_cstring] = ACTIONS(4879),
    [sym_dstring] = ACTIONS(4879),
    [sym_wstring] = ACTIONS(4879),
    [sym_noreturn] = ACTIONS(4879),
    [sym_this] = ACTIONS(4879),
    [sym_abstract] = ACTIONS(4879),
    [sym_alias] = ACTIONS(4879),
    [sym_align] = ACTIONS(4879),
    [sym_auto] = ACTIONS(4879),
    [sym_catch] = ACTIONS(4879),
    [sym_class] = ACTIONS(4879),
    [sym_const] = ACTIONS(4879),
    [sym_debug] = ACTIONS(4879),
    [sym_deprecated] = ACTIONS(4879),
    [sym_else] = ACTIONS(4879),
    [sym_enum] = ACTIONS(4879),
    [sym_export] = ACTIONS(4879),
    [sym_extern] = ACTIONS(4879),
    [sym_final] = ACTIONS(4879),
    [sym_finally] = ACTIONS(4879),
    [sym_immutable] = ACTIONS(4879),
    [sym_import] = ACTIONS(4879),
    [sym_inout] = ACTIONS(4879),
    [sym_interface] = ACTIONS(4879),
    [sym_invariant] = ACTIONS(4879),
    [sym_mixin] = ACTIONS(4879),
    [sym_nothrow] = ACTIONS(4879),
    [sym_override] = ACTIONS(4879),
    [sym_package] = ACTIONS(4879),
    [sym_pragma] = ACTIONS(4879),
    [sym_private] = ACTIONS(4879),
    [sym_protected] = ACTIONS(4879),
    [sym_public] = ACTIONS(4879),
    [sym_pure] = ACTIONS(4879),
    [sym_ref] = ACTIONS(4879),
    [sym_return] = ACTIONS(4879),
    [sym_scope] = ACTIONS(4879),
    [sym_shared] = ACTIONS(4879),
    [sym_static] = ACTIONS(4879),
    [sym_struct] = ACTIONS(4879),
    [sym_synchronized] = ACTIONS(4879),
    [sym_template] = ACTIONS(4879),
    [sym_typeof] = ACTIONS(4879),
    [sym_union] = ACTIONS(4879),
    [sym_unittest] = ACTIONS(4879),
    [sym_version] = ACTIONS(4879),
    [sym_while] = ACTIONS(4879),
    [sym_gshared] = ACTIONS(4879),
    [sym_traits] = ACTIONS(4879),
    [sym_vector] = ACTIONS(4879),
    [sym_void] = ACTIONS(4879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2410] = {
    [sym_identifier] = ACTIONS(4883),
    [anon_sym_DOT] = ACTIONS(4885),
    [anon_sym_SEMI] = ACTIONS(4885),
    [anon_sym_TILDE] = ACTIONS(4885),
    [anon_sym_AT] = ACTIONS(4885),
    [sym_bool] = ACTIONS(4883),
    [sym_byte] = ACTIONS(4883),
    [sym_ubyte] = ACTIONS(4883),
    [sym_char] = ACTIONS(4883),
    [sym_short] = ACTIONS(4883),
    [sym_ushort] = ACTIONS(4883),
    [sym_int] = ACTIONS(4883),
    [sym_uint] = ACTIONS(4883),
    [sym_long] = ACTIONS(4883),
    [sym_ulong] = ACTIONS(4883),
    [sym_cent] = ACTIONS(4883),
    [sym_ucent] = ACTIONS(4883),
    [sym_wchar] = ACTIONS(4883),
    [sym_dchar] = ACTIONS(4883),
    [sym_float] = ACTIONS(4883),
    [sym_double] = ACTIONS(4883),
    [sym_real] = ACTIONS(4883),
    [sym_ifloat] = ACTIONS(4883),
    [sym_idouble] = ACTIONS(4883),
    [sym_ireal] = ACTIONS(4883),
    [sym_cfloat] = ACTIONS(4883),
    [sym_cdouble] = ACTIONS(4883),
    [sym_creal] = ACTIONS(4883),
    [sym_size_t] = ACTIONS(4883),
    [sym_ptrdiff_t] = ACTIONS(4883),
    [sym_string] = ACTIONS(4883),
    [sym_cstring] = ACTIONS(4883),
    [sym_dstring] = ACTIONS(4883),
    [sym_wstring] = ACTIONS(4883),
    [sym_noreturn] = ACTIONS(4883),
    [sym_this] = ACTIONS(4883),
    [sym_abstract] = ACTIONS(4883),
    [sym_alias] = ACTIONS(4883),
    [sym_align] = ACTIONS(4883),
    [sym_auto] = ACTIONS(4883),
    [sym_catch] = ACTIONS(4883),
    [sym_class] = ACTIONS(4883),
    [sym_const] = ACTIONS(4883),
    [sym_debug] = ACTIONS(4883),
    [sym_deprecated] = ACTIONS(4883),
    [sym_else] = ACTIONS(4883),
    [sym_enum] = ACTIONS(4883),
    [sym_export] = ACTIONS(4883),
    [sym_extern] = ACTIONS(4883),
    [sym_final] = ACTIONS(4883),
    [sym_finally] = ACTIONS(4883),
    [sym_immutable] = ACTIONS(4883),
    [sym_import] = ACTIONS(4883),
    [sym_inout] = ACTIONS(4883),
    [sym_interface] = ACTIONS(4883),
    [sym_invariant] = ACTIONS(4883),
    [sym_mixin] = ACTIONS(4883),
    [sym_nothrow] = ACTIONS(4883),
    [sym_override] = ACTIONS(4883),
    [sym_package] = ACTIONS(4883),
    [sym_pragma] = ACTIONS(4883),
    [sym_private] = ACTIONS(4883),
    [sym_protected] = ACTIONS(4883),
    [sym_public] = ACTIONS(4883),
    [sym_pure] = ACTIONS(4883),
    [sym_ref] = ACTIONS(4883),
    [sym_return] = ACTIONS(4883),
    [sym_scope] = ACTIONS(4883),
    [sym_shared] = ACTIONS(4883),
    [sym_static] = ACTIONS(4883),
    [sym_struct] = ACTIONS(4883),
    [sym_synchronized] = ACTIONS(4883),
    [sym_template] = ACTIONS(4883),
    [sym_typeof] = ACTIONS(4883),
    [sym_union] = ACTIONS(4883),
    [sym_unittest] = ACTIONS(4883),
    [sym_version] = ACTIONS(4883),
    [sym_while] = ACTIONS(4883),
    [sym_gshared] = ACTIONS(4883),
    [sym_traits] = ACTIONS(4883),
    [sym_vector] = ACTIONS(4883),
    [sym_void] = ACTIONS(4883),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2411] = {
    [sym_identifier] = ACTIONS(6090),
    [anon_sym_LBRACE] = ACTIONS(6093),
    [anon_sym_DOT] = ACTIONS(6095),
    [anon_sym_LPAREN] = ACTIONS(6098),
    [anon_sym_SEMI] = ACTIONS(6093),
    [anon_sym_COLON] = ACTIONS(6093),
    [anon_sym_TILDE] = ACTIONS(6093),
    [anon_sym_AT] = ACTIONS(6095),
    [sym_bool] = ACTIONS(6090),
    [sym_byte] = ACTIONS(6090),
    [sym_ubyte] = ACTIONS(6090),
    [sym_char] = ACTIONS(6090),
    [sym_short] = ACTIONS(6090),
    [sym_ushort] = ACTIONS(6090),
    [sym_int] = ACTIONS(6090),
    [sym_uint] = ACTIONS(6090),
    [sym_long] = ACTIONS(6090),
    [sym_ulong] = ACTIONS(6090),
    [sym_cent] = ACTIONS(6090),
    [sym_ucent] = ACTIONS(6090),
    [sym_wchar] = ACTIONS(6090),
    [sym_dchar] = ACTIONS(6090),
    [sym_float] = ACTIONS(6090),
    [sym_double] = ACTIONS(6090),
    [sym_real] = ACTIONS(6090),
    [sym_ifloat] = ACTIONS(6090),
    [sym_idouble] = ACTIONS(6090),
    [sym_ireal] = ACTIONS(6090),
    [sym_cfloat] = ACTIONS(6090),
    [sym_cdouble] = ACTIONS(6090),
    [sym_creal] = ACTIONS(6090),
    [sym_size_t] = ACTIONS(6090),
    [sym_ptrdiff_t] = ACTIONS(6090),
    [sym_string] = ACTIONS(6090),
    [sym_cstring] = ACTIONS(6090),
    [sym_dstring] = ACTIONS(6090),
    [sym_wstring] = ACTIONS(6090),
    [sym_noreturn] = ACTIONS(6090),
    [sym_this] = ACTIONS(6100),
    [sym_abstract] = ACTIONS(6090),
    [sym_alias] = ACTIONS(6100),
    [sym_align] = ACTIONS(6090),
    [sym_auto] = ACTIONS(6090),
    [sym_class] = ACTIONS(6100),
    [sym_const] = ACTIONS(6090),
    [sym_debug] = ACTIONS(6100),
    [sym_deprecated] = ACTIONS(6090),
    [sym_enum] = ACTIONS(6090),
    [sym_export] = ACTIONS(6100),
    [sym_extern] = ACTIONS(6090),
    [sym_final] = ACTIONS(6090),
    [sym_immutable] = ACTIONS(6090),
    [sym_import] = ACTIONS(6100),
    [sym_inout] = ACTIONS(6090),
    [sym_interface] = ACTIONS(6100),
    [sym_invariant] = ACTIONS(6100),
    [sym_mixin] = ACTIONS(6090),
    [sym_module] = ACTIONS(6100),
    [sym_nothrow] = ACTIONS(6090),
    [sym_override] = ACTIONS(6090),
    [sym_package] = ACTIONS(6100),
    [sym_pragma] = ACTIONS(6100),
    [sym_private] = ACTIONS(6100),
    [sym_protected] = ACTIONS(6100),
    [sym_public] = ACTIONS(6100),
    [sym_pure] = ACTIONS(6090),
    [sym_ref] = ACTIONS(6090),
    [sym_return] = ACTIONS(6100),
    [sym_scope] = ACTIONS(6090),
    [sym_shared] = ACTIONS(6090),
    [sym_static] = ACTIONS(6090),
    [sym_struct] = ACTIONS(6100),
    [sym_synchronized] = ACTIONS(6090),
    [sym_template] = ACTIONS(6100),
    [sym_typeof] = ACTIONS(6090),
    [sym_union] = ACTIONS(6100),
    [sym_unittest] = ACTIONS(6100),
    [sym_version] = ACTIONS(6100),
    [sym_gshared] = ACTIONS(6090),
    [sym_traits] = ACTIONS(6090),
    [sym_vector] = ACTIONS(6090),
    [sym_void] = ACTIONS(6090),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2412] = {
    [sym_identifier] = ACTIONS(2505),
    [anon_sym_DOT] = ACTIONS(2503),
    [anon_sym_SEMI] = ACTIONS(2503),
    [anon_sym_TILDE] = ACTIONS(2503),
    [anon_sym_AT] = ACTIONS(2503),
    [sym_bool] = ACTIONS(2505),
    [sym_byte] = ACTIONS(2505),
    [sym_ubyte] = ACTIONS(2505),
    [sym_char] = ACTIONS(2505),
    [sym_short] = ACTIONS(2505),
    [sym_ushort] = ACTIONS(2505),
    [sym_int] = ACTIONS(2505),
    [sym_uint] = ACTIONS(2505),
    [sym_long] = ACTIONS(2505),
    [sym_ulong] = ACTIONS(2505),
    [sym_cent] = ACTIONS(2505),
    [sym_ucent] = ACTIONS(2505),
    [sym_wchar] = ACTIONS(2505),
    [sym_dchar] = ACTIONS(2505),
    [sym_float] = ACTIONS(2505),
    [sym_double] = ACTIONS(2505),
    [sym_real] = ACTIONS(2505),
    [sym_ifloat] = ACTIONS(2505),
    [sym_idouble] = ACTIONS(2505),
    [sym_ireal] = ACTIONS(2505),
    [sym_cfloat] = ACTIONS(2505),
    [sym_cdouble] = ACTIONS(2505),
    [sym_creal] = ACTIONS(2505),
    [sym_size_t] = ACTIONS(2505),
    [sym_ptrdiff_t] = ACTIONS(2505),
    [sym_string] = ACTIONS(2505),
    [sym_cstring] = ACTIONS(2505),
    [sym_dstring] = ACTIONS(2505),
    [sym_wstring] = ACTIONS(2505),
    [sym_noreturn] = ACTIONS(2505),
    [sym_this] = ACTIONS(2505),
    [sym_abstract] = ACTIONS(2505),
    [sym_alias] = ACTIONS(2505),
    [sym_align] = ACTIONS(2505),
    [sym_auto] = ACTIONS(2505),
    [sym_catch] = ACTIONS(2505),
    [sym_class] = ACTIONS(2505),
    [sym_const] = ACTIONS(2505),
    [sym_debug] = ACTIONS(2505),
    [sym_deprecated] = ACTIONS(2505),
    [sym_else] = ACTIONS(2505),
    [sym_enum] = ACTIONS(2505),
    [sym_export] = ACTIONS(2505),
    [sym_extern] = ACTIONS(2505),
    [sym_final] = ACTIONS(2505),
    [sym_finally] = ACTIONS(2505),
    [sym_immutable] = ACTIONS(2505),
    [sym_import] = ACTIONS(2505),
    [sym_inout] = ACTIONS(2505),
    [sym_interface] = ACTIONS(2505),
    [sym_invariant] = ACTIONS(2505),
    [sym_mixin] = ACTIONS(2505),
    [sym_nothrow] = ACTIONS(2505),
    [sym_override] = ACTIONS(2505),
    [sym_package] = ACTIONS(2505),
    [sym_pragma] = ACTIONS(2505),
    [sym_private] = ACTIONS(2505),
    [sym_protected] = ACTIONS(2505),
    [sym_public] = ACTIONS(2505),
    [sym_pure] = ACTIONS(2505),
    [sym_ref] = ACTIONS(2505),
    [sym_return] = ACTIONS(2505),
    [sym_scope] = ACTIONS(2505),
    [sym_shared] = ACTIONS(2505),
    [sym_static] = ACTIONS(2505),
    [sym_struct] = ACTIONS(2505),
    [sym_synchronized] = ACTIONS(2505),
    [sym_template] = ACTIONS(2505),
    [sym_typeof] = ACTIONS(2505),
    [sym_union] = ACTIONS(2505),
    [sym_unittest] = ACTIONS(2505),
    [sym_version] = ACTIONS(2505),
    [sym_while] = ACTIONS(2505),
    [sym_gshared] = ACTIONS(2505),
    [sym_traits] = ACTIONS(2505),
    [sym_vector] = ACTIONS(2505),
    [sym_void] = ACTIONS(2505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2413] = {
    [ts_builtin_sym_end] = ACTIONS(4771),
    [sym_identifier] = ACTIONS(4769),
    [anon_sym_RBRACE] = ACTIONS(4771),
    [anon_sym_DOT] = ACTIONS(4771),
    [anon_sym_SEMI] = ACTIONS(4771),
    [anon_sym_TILDE] = ACTIONS(4771),
    [anon_sym_AT] = ACTIONS(4771),
    [sym_bool] = ACTIONS(4769),
    [sym_byte] = ACTIONS(4769),
    [sym_ubyte] = ACTIONS(4769),
    [sym_char] = ACTIONS(4769),
    [sym_short] = ACTIONS(4769),
    [sym_ushort] = ACTIONS(4769),
    [sym_int] = ACTIONS(4769),
    [sym_uint] = ACTIONS(4769),
    [sym_long] = ACTIONS(4769),
    [sym_ulong] = ACTIONS(4769),
    [sym_cent] = ACTIONS(4769),
    [sym_ucent] = ACTIONS(4769),
    [sym_wchar] = ACTIONS(4769),
    [sym_dchar] = ACTIONS(4769),
    [sym_float] = ACTIONS(4769),
    [sym_double] = ACTIONS(4769),
    [sym_real] = ACTIONS(4769),
    [sym_ifloat] = ACTIONS(4769),
    [sym_idouble] = ACTIONS(4769),
    [sym_ireal] = ACTIONS(4769),
    [sym_cfloat] = ACTIONS(4769),
    [sym_cdouble] = ACTIONS(4769),
    [sym_creal] = ACTIONS(4769),
    [sym_size_t] = ACTIONS(4769),
    [sym_ptrdiff_t] = ACTIONS(4769),
    [sym_string] = ACTIONS(4769),
    [sym_cstring] = ACTIONS(4769),
    [sym_dstring] = ACTIONS(4769),
    [sym_wstring] = ACTIONS(4769),
    [sym_noreturn] = ACTIONS(4769),
    [sym_this] = ACTIONS(4769),
    [sym_abstract] = ACTIONS(4769),
    [sym_alias] = ACTIONS(4769),
    [sym_align] = ACTIONS(4769),
    [sym_auto] = ACTIONS(4769),
    [sym_class] = ACTIONS(4769),
    [sym_const] = ACTIONS(4769),
    [sym_debug] = ACTIONS(4769),
    [sym_deprecated] = ACTIONS(4769),
    [sym_else] = ACTIONS(4769),
    [sym_enum] = ACTIONS(4769),
    [sym_export] = ACTIONS(4769),
    [sym_extern] = ACTIONS(4769),
    [sym_final] = ACTIONS(4769),
    [sym_immutable] = ACTIONS(4769),
    [sym_import] = ACTIONS(4769),
    [sym_inout] = ACTIONS(4769),
    [sym_interface] = ACTIONS(4769),
    [sym_invariant] = ACTIONS(4769),
    [sym_mixin] = ACTIONS(4769),
    [sym_nothrow] = ACTIONS(4769),
    [sym_override] = ACTIONS(4769),
    [sym_package] = ACTIONS(4769),
    [sym_pragma] = ACTIONS(4769),
    [sym_private] = ACTIONS(4769),
    [sym_protected] = ACTIONS(4769),
    [sym_public] = ACTIONS(4769),
    [sym_pure] = ACTIONS(4769),
    [sym_ref] = ACTIONS(4769),
    [sym_return] = ACTIONS(4769),
    [sym_scope] = ACTIONS(4769),
    [sym_shared] = ACTIONS(4769),
    [sym_static] = ACTIONS(4769),
    [sym_struct] = ACTIONS(4769),
    [sym_synchronized] = ACTIONS(4769),
    [sym_template] = ACTIONS(4769),
    [sym_typeof] = ACTIONS(4769),
    [sym_union] = ACTIONS(4769),
    [sym_unittest] = ACTIONS(4769),
    [sym_version] = ACTIONS(4769),
    [sym_while] = ACTIONS(4769),
    [sym_gshared] = ACTIONS(4769),
    [sym_traits] = ACTIONS(4769),
    [sym_vector] = ACTIONS(4769),
    [sym_void] = ACTIONS(4769),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2414] = {
    [ts_builtin_sym_end] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4494),
    [anon_sym_RBRACE] = ACTIONS(4496),
    [anon_sym_DOT] = ACTIONS(4496),
    [anon_sym_SEMI] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4496),
    [anon_sym_AT] = ACTIONS(4496),
    [sym_bool] = ACTIONS(4494),
    [sym_byte] = ACTIONS(4494),
    [sym_ubyte] = ACTIONS(4494),
    [sym_char] = ACTIONS(4494),
    [sym_short] = ACTIONS(4494),
    [sym_ushort] = ACTIONS(4494),
    [sym_int] = ACTIONS(4494),
    [sym_uint] = ACTIONS(4494),
    [sym_long] = ACTIONS(4494),
    [sym_ulong] = ACTIONS(4494),
    [sym_cent] = ACTIONS(4494),
    [sym_ucent] = ACTIONS(4494),
    [sym_wchar] = ACTIONS(4494),
    [sym_dchar] = ACTIONS(4494),
    [sym_float] = ACTIONS(4494),
    [sym_double] = ACTIONS(4494),
    [sym_real] = ACTIONS(4494),
    [sym_ifloat] = ACTIONS(4494),
    [sym_idouble] = ACTIONS(4494),
    [sym_ireal] = ACTIONS(4494),
    [sym_cfloat] = ACTIONS(4494),
    [sym_cdouble] = ACTIONS(4494),
    [sym_creal] = ACTIONS(4494),
    [sym_size_t] = ACTIONS(4494),
    [sym_ptrdiff_t] = ACTIONS(4494),
    [sym_string] = ACTIONS(4494),
    [sym_cstring] = ACTIONS(4494),
    [sym_dstring] = ACTIONS(4494),
    [sym_wstring] = ACTIONS(4494),
    [sym_noreturn] = ACTIONS(4494),
    [sym_this] = ACTIONS(4494),
    [sym_abstract] = ACTIONS(4494),
    [sym_alias] = ACTIONS(4494),
    [sym_align] = ACTIONS(4494),
    [sym_auto] = ACTIONS(4494),
    [sym_class] = ACTIONS(4494),
    [sym_const] = ACTIONS(4494),
    [sym_debug] = ACTIONS(4494),
    [sym_deprecated] = ACTIONS(4494),
    [sym_else] = ACTIONS(4494),
    [sym_enum] = ACTIONS(4494),
    [sym_export] = ACTIONS(4494),
    [sym_extern] = ACTIONS(4494),
    [sym_final] = ACTIONS(4494),
    [sym_immutable] = ACTIONS(4494),
    [sym_import] = ACTIONS(4494),
    [sym_inout] = ACTIONS(4494),
    [sym_interface] = ACTIONS(4494),
    [sym_invariant] = ACTIONS(4494),
    [sym_mixin] = ACTIONS(4494),
    [sym_nothrow] = ACTIONS(4494),
    [sym_override] = ACTIONS(4494),
    [sym_package] = ACTIONS(4494),
    [sym_pragma] = ACTIONS(4494),
    [sym_private] = ACTIONS(4494),
    [sym_protected] = ACTIONS(4494),
    [sym_public] = ACTIONS(4494),
    [sym_pure] = ACTIONS(4494),
    [sym_ref] = ACTIONS(4494),
    [sym_return] = ACTIONS(4494),
    [sym_scope] = ACTIONS(4494),
    [sym_shared] = ACTIONS(4494),
    [sym_static] = ACTIONS(4494),
    [sym_struct] = ACTIONS(4494),
    [sym_synchronized] = ACTIONS(4494),
    [sym_template] = ACTIONS(4494),
    [sym_typeof] = ACTIONS(4494),
    [sym_union] = ACTIONS(4494),
    [sym_unittest] = ACTIONS(4494),
    [sym_version] = ACTIONS(4494),
    [sym_while] = ACTIONS(4494),
    [sym_gshared] = ACTIONS(4494),
    [sym_traits] = ACTIONS(4494),
    [sym_vector] = ACTIONS(4494),
    [sym_void] = ACTIONS(4494),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2415] = {
    [ts_builtin_sym_end] = ACTIONS(4528),
    [sym_identifier] = ACTIONS(4526),
    [anon_sym_RBRACE] = ACTIONS(4528),
    [anon_sym_DOT] = ACTIONS(4528),
    [anon_sym_SEMI] = ACTIONS(4528),
    [anon_sym_TILDE] = ACTIONS(4528),
    [anon_sym_AT] = ACTIONS(4528),
    [sym_bool] = ACTIONS(4526),
    [sym_byte] = ACTIONS(4526),
    [sym_ubyte] = ACTIONS(4526),
    [sym_char] = ACTIONS(4526),
    [sym_short] = ACTIONS(4526),
    [sym_ushort] = ACTIONS(4526),
    [sym_int] = ACTIONS(4526),
    [sym_uint] = ACTIONS(4526),
    [sym_long] = ACTIONS(4526),
    [sym_ulong] = ACTIONS(4526),
    [sym_cent] = ACTIONS(4526),
    [sym_ucent] = ACTIONS(4526),
    [sym_wchar] = ACTIONS(4526),
    [sym_dchar] = ACTIONS(4526),
    [sym_float] = ACTIONS(4526),
    [sym_double] = ACTIONS(4526),
    [sym_real] = ACTIONS(4526),
    [sym_ifloat] = ACTIONS(4526),
    [sym_idouble] = ACTIONS(4526),
    [sym_ireal] = ACTIONS(4526),
    [sym_cfloat] = ACTIONS(4526),
    [sym_cdouble] = ACTIONS(4526),
    [sym_creal] = ACTIONS(4526),
    [sym_size_t] = ACTIONS(4526),
    [sym_ptrdiff_t] = ACTIONS(4526),
    [sym_string] = ACTIONS(4526),
    [sym_cstring] = ACTIONS(4526),
    [sym_dstring] = ACTIONS(4526),
    [sym_wstring] = ACTIONS(4526),
    [sym_noreturn] = ACTIONS(4526),
    [sym_this] = ACTIONS(4526),
    [sym_abstract] = ACTIONS(4526),
    [sym_alias] = ACTIONS(4526),
    [sym_align] = ACTIONS(4526),
    [sym_auto] = ACTIONS(4526),
    [sym_class] = ACTIONS(4526),
    [sym_const] = ACTIONS(4526),
    [sym_debug] = ACTIONS(4526),
    [sym_deprecated] = ACTIONS(4526),
    [sym_else] = ACTIONS(4526),
    [sym_enum] = ACTIONS(4526),
    [sym_export] = ACTIONS(4526),
    [sym_extern] = ACTIONS(4526),
    [sym_final] = ACTIONS(4526),
    [sym_immutable] = ACTIONS(4526),
    [sym_import] = ACTIONS(4526),
    [sym_inout] = ACTIONS(4526),
    [sym_interface] = ACTIONS(4526),
    [sym_invariant] = ACTIONS(4526),
    [sym_mixin] = ACTIONS(4526),
    [sym_nothrow] = ACTIONS(4526),
    [sym_override] = ACTIONS(4526),
    [sym_package] = ACTIONS(4526),
    [sym_pragma] = ACTIONS(4526),
    [sym_private] = ACTIONS(4526),
    [sym_protected] = ACTIONS(4526),
    [sym_public] = ACTIONS(4526),
    [sym_pure] = ACTIONS(4526),
    [sym_ref] = ACTIONS(4526),
    [sym_return] = ACTIONS(4526),
    [sym_scope] = ACTIONS(4526),
    [sym_shared] = ACTIONS(4526),
    [sym_static] = ACTIONS(4526),
    [sym_struct] = ACTIONS(4526),
    [sym_synchronized] = ACTIONS(4526),
    [sym_template] = ACTIONS(4526),
    [sym_typeof] = ACTIONS(4526),
    [sym_union] = ACTIONS(4526),
    [sym_unittest] = ACTIONS(4526),
    [sym_version] = ACTIONS(4526),
    [sym_while] = ACTIONS(4526),
    [sym_gshared] = ACTIONS(4526),
    [sym_traits] = ACTIONS(4526),
    [sym_vector] = ACTIONS(4526),
    [sym_void] = ACTIONS(4526),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2416] = {
    [sym_identifier] = ACTIONS(4891),
    [anon_sym_DOT] = ACTIONS(4893),
    [anon_sym_SEMI] = ACTIONS(4893),
    [anon_sym_TILDE] = ACTIONS(4893),
    [anon_sym_AT] = ACTIONS(4893),
    [sym_bool] = ACTIONS(4891),
    [sym_byte] = ACTIONS(4891),
    [sym_ubyte] = ACTIONS(4891),
    [sym_char] = ACTIONS(4891),
    [sym_short] = ACTIONS(4891),
    [sym_ushort] = ACTIONS(4891),
    [sym_int] = ACTIONS(4891),
    [sym_uint] = ACTIONS(4891),
    [sym_long] = ACTIONS(4891),
    [sym_ulong] = ACTIONS(4891),
    [sym_cent] = ACTIONS(4891),
    [sym_ucent] = ACTIONS(4891),
    [sym_wchar] = ACTIONS(4891),
    [sym_dchar] = ACTIONS(4891),
    [sym_float] = ACTIONS(4891),
    [sym_double] = ACTIONS(4891),
    [sym_real] = ACTIONS(4891),
    [sym_ifloat] = ACTIONS(4891),
    [sym_idouble] = ACTIONS(4891),
    [sym_ireal] = ACTIONS(4891),
    [sym_cfloat] = ACTIONS(4891),
    [sym_cdouble] = ACTIONS(4891),
    [sym_creal] = ACTIONS(4891),
    [sym_size_t] = ACTIONS(4891),
    [sym_ptrdiff_t] = ACTIONS(4891),
    [sym_string] = ACTIONS(4891),
    [sym_cstring] = ACTIONS(4891),
    [sym_dstring] = ACTIONS(4891),
    [sym_wstring] = ACTIONS(4891),
    [sym_noreturn] = ACTIONS(4891),
    [sym_this] = ACTIONS(4891),
    [sym_abstract] = ACTIONS(4891),
    [sym_alias] = ACTIONS(4891),
    [sym_align] = ACTIONS(4891),
    [sym_auto] = ACTIONS(4891),
    [sym_catch] = ACTIONS(4891),
    [sym_class] = ACTIONS(4891),
    [sym_const] = ACTIONS(4891),
    [sym_debug] = ACTIONS(4891),
    [sym_deprecated] = ACTIONS(4891),
    [sym_else] = ACTIONS(4891),
    [sym_enum] = ACTIONS(4891),
    [sym_export] = ACTIONS(4891),
    [sym_extern] = ACTIONS(4891),
    [sym_final] = ACTIONS(4891),
    [sym_finally] = ACTIONS(4891),
    [sym_immutable] = ACTIONS(4891),
    [sym_import] = ACTIONS(4891),
    [sym_inout] = ACTIONS(4891),
    [sym_interface] = ACTIONS(4891),
    [sym_invariant] = ACTIONS(4891),
    [sym_mixin] = ACTIONS(4891),
    [sym_nothrow] = ACTIONS(4891),
    [sym_override] = ACTIONS(4891),
    [sym_package] = ACTIONS(4891),
    [sym_pragma] = ACTIONS(4891),
    [sym_private] = ACTIONS(4891),
    [sym_protected] = ACTIONS(4891),
    [sym_public] = ACTIONS(4891),
    [sym_pure] = ACTIONS(4891),
    [sym_ref] = ACTIONS(4891),
    [sym_return] = ACTIONS(4891),
    [sym_scope] = ACTIONS(4891),
    [sym_shared] = ACTIONS(4891),
    [sym_static] = ACTIONS(4891),
    [sym_struct] = ACTIONS(4891),
    [sym_synchronized] = ACTIONS(4891),
    [sym_template] = ACTIONS(4891),
    [sym_typeof] = ACTIONS(4891),
    [sym_union] = ACTIONS(4891),
    [sym_unittest] = ACTIONS(4891),
    [sym_version] = ACTIONS(4891),
    [sym_while] = ACTIONS(4891),
    [sym_gshared] = ACTIONS(4891),
    [sym_traits] = ACTIONS(4891),
    [sym_vector] = ACTIONS(4891),
    [sym_void] = ACTIONS(4891),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2417] = {
    [sym_identifier] = ACTIONS(4895),
    [anon_sym_DOT] = ACTIONS(4897),
    [anon_sym_SEMI] = ACTIONS(4897),
    [anon_sym_TILDE] = ACTIONS(4897),
    [anon_sym_AT] = ACTIONS(4897),
    [sym_bool] = ACTIONS(4895),
    [sym_byte] = ACTIONS(4895),
    [sym_ubyte] = ACTIONS(4895),
    [sym_char] = ACTIONS(4895),
    [sym_short] = ACTIONS(4895),
    [sym_ushort] = ACTIONS(4895),
    [sym_int] = ACTIONS(4895),
    [sym_uint] = ACTIONS(4895),
    [sym_long] = ACTIONS(4895),
    [sym_ulong] = ACTIONS(4895),
    [sym_cent] = ACTIONS(4895),
    [sym_ucent] = ACTIONS(4895),
    [sym_wchar] = ACTIONS(4895),
    [sym_dchar] = ACTIONS(4895),
    [sym_float] = ACTIONS(4895),
    [sym_double] = ACTIONS(4895),
    [sym_real] = ACTIONS(4895),
    [sym_ifloat] = ACTIONS(4895),
    [sym_idouble] = ACTIONS(4895),
    [sym_ireal] = ACTIONS(4895),
    [sym_cfloat] = ACTIONS(4895),
    [sym_cdouble] = ACTIONS(4895),
    [sym_creal] = ACTIONS(4895),
    [sym_size_t] = ACTIONS(4895),
    [sym_ptrdiff_t] = ACTIONS(4895),
    [sym_string] = ACTIONS(4895),
    [sym_cstring] = ACTIONS(4895),
    [sym_dstring] = ACTIONS(4895),
    [sym_wstring] = ACTIONS(4895),
    [sym_noreturn] = ACTIONS(4895),
    [sym_this] = ACTIONS(4895),
    [sym_abstract] = ACTIONS(4895),
    [sym_alias] = ACTIONS(4895),
    [sym_align] = ACTIONS(4895),
    [sym_auto] = ACTIONS(4895),
    [sym_catch] = ACTIONS(4895),
    [sym_class] = ACTIONS(4895),
    [sym_const] = ACTIONS(4895),
    [sym_debug] = ACTIONS(4895),
    [sym_deprecated] = ACTIONS(4895),
    [sym_else] = ACTIONS(4895),
    [sym_enum] = ACTIONS(4895),
    [sym_export] = ACTIONS(4895),
    [sym_extern] = ACTIONS(4895),
    [sym_final] = ACTIONS(4895),
    [sym_finally] = ACTIONS(4895),
    [sym_immutable] = ACTIONS(4895),
    [sym_import] = ACTIONS(4895),
    [sym_inout] = ACTIONS(4895),
    [sym_interface] = ACTIONS(4895),
    [sym_invariant] = ACTIONS(4895),
    [sym_mixin] = ACTIONS(4895),
    [sym_nothrow] = ACTIONS(4895),
    [sym_override] = ACTIONS(4895),
    [sym_package] = ACTIONS(4895),
    [sym_pragma] = ACTIONS(4895),
    [sym_private] = ACTIONS(4895),
    [sym_protected] = ACTIONS(4895),
    [sym_public] = ACTIONS(4895),
    [sym_pure] = ACTIONS(4895),
    [sym_ref] = ACTIONS(4895),
    [sym_return] = ACTIONS(4895),
    [sym_scope] = ACTIONS(4895),
    [sym_shared] = ACTIONS(4895),
    [sym_static] = ACTIONS(4895),
    [sym_struct] = ACTIONS(4895),
    [sym_synchronized] = ACTIONS(4895),
    [sym_template] = ACTIONS(4895),
    [sym_typeof] = ACTIONS(4895),
    [sym_union] = ACTIONS(4895),
    [sym_unittest] = ACTIONS(4895),
    [sym_version] = ACTIONS(4895),
    [sym_while] = ACTIONS(4895),
    [sym_gshared] = ACTIONS(4895),
    [sym_traits] = ACTIONS(4895),
    [sym_vector] = ACTIONS(4895),
    [sym_void] = ACTIONS(4895),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2418] = {
    [sym_identifier] = ACTIONS(4899),
    [anon_sym_DOT] = ACTIONS(4901),
    [anon_sym_SEMI] = ACTIONS(4901),
    [anon_sym_TILDE] = ACTIONS(4901),
    [anon_sym_AT] = ACTIONS(4901),
    [sym_bool] = ACTIONS(4899),
    [sym_byte] = ACTIONS(4899),
    [sym_ubyte] = ACTIONS(4899),
    [sym_char] = ACTIONS(4899),
    [sym_short] = ACTIONS(4899),
    [sym_ushort] = ACTIONS(4899),
    [sym_int] = ACTIONS(4899),
    [sym_uint] = ACTIONS(4899),
    [sym_long] = ACTIONS(4899),
    [sym_ulong] = ACTIONS(4899),
    [sym_cent] = ACTIONS(4899),
    [sym_ucent] = ACTIONS(4899),
    [sym_wchar] = ACTIONS(4899),
    [sym_dchar] = ACTIONS(4899),
    [sym_float] = ACTIONS(4899),
    [sym_double] = ACTIONS(4899),
    [sym_real] = ACTIONS(4899),
    [sym_ifloat] = ACTIONS(4899),
    [sym_idouble] = ACTIONS(4899),
    [sym_ireal] = ACTIONS(4899),
    [sym_cfloat] = ACTIONS(4899),
    [sym_cdouble] = ACTIONS(4899),
    [sym_creal] = ACTIONS(4899),
    [sym_size_t] = ACTIONS(4899),
    [sym_ptrdiff_t] = ACTIONS(4899),
    [sym_string] = ACTIONS(4899),
    [sym_cstring] = ACTIONS(4899),
    [sym_dstring] = ACTIONS(4899),
    [sym_wstring] = ACTIONS(4899),
    [sym_noreturn] = ACTIONS(4899),
    [sym_this] = ACTIONS(4899),
    [sym_abstract] = ACTIONS(4899),
    [sym_alias] = ACTIONS(4899),
    [sym_align] = ACTIONS(4899),
    [sym_auto] = ACTIONS(4899),
    [sym_catch] = ACTIONS(4899),
    [sym_class] = ACTIONS(4899),
    [sym_const] = ACTIONS(4899),
    [sym_debug] = ACTIONS(4899),
    [sym_deprecated] = ACTIONS(4899),
    [sym_else] = ACTIONS(4899),
    [sym_enum] = ACTIONS(4899),
    [sym_export] = ACTIONS(4899),
    [sym_extern] = ACTIONS(4899),
    [sym_final] = ACTIONS(4899),
    [sym_finally] = ACTIONS(4899),
    [sym_immutable] = ACTIONS(4899),
    [sym_import] = ACTIONS(4899),
    [sym_inout] = ACTIONS(4899),
    [sym_interface] = ACTIONS(4899),
    [sym_invariant] = ACTIONS(4899),
    [sym_mixin] = ACTIONS(4899),
    [sym_nothrow] = ACTIONS(4899),
    [sym_override] = ACTIONS(4899),
    [sym_package] = ACTIONS(4899),
    [sym_pragma] = ACTIONS(4899),
    [sym_private] = ACTIONS(4899),
    [sym_protected] = ACTIONS(4899),
    [sym_public] = ACTIONS(4899),
    [sym_pure] = ACTIONS(4899),
    [sym_ref] = ACTIONS(4899),
    [sym_return] = ACTIONS(4899),
    [sym_scope] = ACTIONS(4899),
    [sym_shared] = ACTIONS(4899),
    [sym_static] = ACTIONS(4899),
    [sym_struct] = ACTIONS(4899),
    [sym_synchronized] = ACTIONS(4899),
    [sym_template] = ACTIONS(4899),
    [sym_typeof] = ACTIONS(4899),
    [sym_union] = ACTIONS(4899),
    [sym_unittest] = ACTIONS(4899),
    [sym_version] = ACTIONS(4899),
    [sym_while] = ACTIONS(4899),
    [sym_gshared] = ACTIONS(4899),
    [sym_traits] = ACTIONS(4899),
    [sym_vector] = ACTIONS(4899),
    [sym_void] = ACTIONS(4899),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2419] = {
    [sym_identifier] = ACTIONS(4903),
    [anon_sym_DOT] = ACTIONS(4905),
    [anon_sym_SEMI] = ACTIONS(4905),
    [anon_sym_TILDE] = ACTIONS(4905),
    [anon_sym_AT] = ACTIONS(4905),
    [sym_bool] = ACTIONS(4903),
    [sym_byte] = ACTIONS(4903),
    [sym_ubyte] = ACTIONS(4903),
    [sym_char] = ACTIONS(4903),
    [sym_short] = ACTIONS(4903),
    [sym_ushort] = ACTIONS(4903),
    [sym_int] = ACTIONS(4903),
    [sym_uint] = ACTIONS(4903),
    [sym_long] = ACTIONS(4903),
    [sym_ulong] = ACTIONS(4903),
    [sym_cent] = ACTIONS(4903),
    [sym_ucent] = ACTIONS(4903),
    [sym_wchar] = ACTIONS(4903),
    [sym_dchar] = ACTIONS(4903),
    [sym_float] = ACTIONS(4903),
    [sym_double] = ACTIONS(4903),
    [sym_real] = ACTIONS(4903),
    [sym_ifloat] = ACTIONS(4903),
    [sym_idouble] = ACTIONS(4903),
    [sym_ireal] = ACTIONS(4903),
    [sym_cfloat] = ACTIONS(4903),
    [sym_cdouble] = ACTIONS(4903),
    [sym_creal] = ACTIONS(4903),
    [sym_size_t] = ACTIONS(4903),
    [sym_ptrdiff_t] = ACTIONS(4903),
    [sym_string] = ACTIONS(4903),
    [sym_cstring] = ACTIONS(4903),
    [sym_dstring] = ACTIONS(4903),
    [sym_wstring] = ACTIONS(4903),
    [sym_noreturn] = ACTIONS(4903),
    [sym_this] = ACTIONS(4903),
    [sym_abstract] = ACTIONS(4903),
    [sym_alias] = ACTIONS(4903),
    [sym_align] = ACTIONS(4903),
    [sym_auto] = ACTIONS(4903),
    [sym_catch] = ACTIONS(4903),
    [sym_class] = ACTIONS(4903),
    [sym_const] = ACTIONS(4903),
    [sym_debug] = ACTIONS(4903),
    [sym_deprecated] = ACTIONS(4903),
    [sym_else] = ACTIONS(4903),
    [sym_enum] = ACTIONS(4903),
    [sym_export] = ACTIONS(4903),
    [sym_extern] = ACTIONS(4903),
    [sym_final] = ACTIONS(4903),
    [sym_finally] = ACTIONS(4903),
    [sym_immutable] = ACTIONS(4903),
    [sym_import] = ACTIONS(4903),
    [sym_inout] = ACTIONS(4903),
    [sym_interface] = ACTIONS(4903),
    [sym_invariant] = ACTIONS(4903),
    [sym_mixin] = ACTIONS(4903),
    [sym_nothrow] = ACTIONS(4903),
    [sym_override] = ACTIONS(4903),
    [sym_package] = ACTIONS(4903),
    [sym_pragma] = ACTIONS(4903),
    [sym_private] = ACTIONS(4903),
    [sym_protected] = ACTIONS(4903),
    [sym_public] = ACTIONS(4903),
    [sym_pure] = ACTIONS(4903),
    [sym_ref] = ACTIONS(4903),
    [sym_return] = ACTIONS(4903),
    [sym_scope] = ACTIONS(4903),
    [sym_shared] = ACTIONS(4903),
    [sym_static] = ACTIONS(4903),
    [sym_struct] = ACTIONS(4903),
    [sym_synchronized] = ACTIONS(4903),
    [sym_template] = ACTIONS(4903),
    [sym_typeof] = ACTIONS(4903),
    [sym_union] = ACTIONS(4903),
    [sym_unittest] = ACTIONS(4903),
    [sym_version] = ACTIONS(4903),
    [sym_while] = ACTIONS(4903),
    [sym_gshared] = ACTIONS(4903),
    [sym_traits] = ACTIONS(4903),
    [sym_vector] = ACTIONS(4903),
    [sym_void] = ACTIONS(4903),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2420] = {
    [sym_identifier] = ACTIONS(4921),
    [anon_sym_DOT] = ACTIONS(4923),
    [anon_sym_SEMI] = ACTIONS(4923),
    [anon_sym_TILDE] = ACTIONS(4923),
    [anon_sym_AT] = ACTIONS(4923),
    [sym_bool] = ACTIONS(4921),
    [sym_byte] = ACTIONS(4921),
    [sym_ubyte] = ACTIONS(4921),
    [sym_char] = ACTIONS(4921),
    [sym_short] = ACTIONS(4921),
    [sym_ushort] = ACTIONS(4921),
    [sym_int] = ACTIONS(4921),
    [sym_uint] = ACTIONS(4921),
    [sym_long] = ACTIONS(4921),
    [sym_ulong] = ACTIONS(4921),
    [sym_cent] = ACTIONS(4921),
    [sym_ucent] = ACTIONS(4921),
    [sym_wchar] = ACTIONS(4921),
    [sym_dchar] = ACTIONS(4921),
    [sym_float] = ACTIONS(4921),
    [sym_double] = ACTIONS(4921),
    [sym_real] = ACTIONS(4921),
    [sym_ifloat] = ACTIONS(4921),
    [sym_idouble] = ACTIONS(4921),
    [sym_ireal] = ACTIONS(4921),
    [sym_cfloat] = ACTIONS(4921),
    [sym_cdouble] = ACTIONS(4921),
    [sym_creal] = ACTIONS(4921),
    [sym_size_t] = ACTIONS(4921),
    [sym_ptrdiff_t] = ACTIONS(4921),
    [sym_string] = ACTIONS(4921),
    [sym_cstring] = ACTIONS(4921),
    [sym_dstring] = ACTIONS(4921),
    [sym_wstring] = ACTIONS(4921),
    [sym_noreturn] = ACTIONS(4921),
    [sym_this] = ACTIONS(4921),
    [sym_abstract] = ACTIONS(4921),
    [sym_alias] = ACTIONS(4921),
    [sym_align] = ACTIONS(4921),
    [sym_auto] = ACTIONS(4921),
    [sym_catch] = ACTIONS(4921),
    [sym_class] = ACTIONS(4921),
    [sym_const] = ACTIONS(4921),
    [sym_debug] = ACTIONS(4921),
    [sym_deprecated] = ACTIONS(4921),
    [sym_else] = ACTIONS(4921),
    [sym_enum] = ACTIONS(4921),
    [sym_export] = ACTIONS(4921),
    [sym_extern] = ACTIONS(4921),
    [sym_final] = ACTIONS(4921),
    [sym_finally] = ACTIONS(4921),
    [sym_immutable] = ACTIONS(4921),
    [sym_import] = ACTIONS(4921),
    [sym_inout] = ACTIONS(4921),
    [sym_interface] = ACTIONS(4921),
    [sym_invariant] = ACTIONS(4921),
    [sym_mixin] = ACTIONS(4921),
    [sym_nothrow] = ACTIONS(4921),
    [sym_override] = ACTIONS(4921),
    [sym_package] = ACTIONS(4921),
    [sym_pragma] = ACTIONS(4921),
    [sym_private] = ACTIONS(4921),
    [sym_protected] = ACTIONS(4921),
    [sym_public] = ACTIONS(4921),
    [sym_pure] = ACTIONS(4921),
    [sym_ref] = ACTIONS(4921),
    [sym_return] = ACTIONS(4921),
    [sym_scope] = ACTIONS(4921),
    [sym_shared] = ACTIONS(4921),
    [sym_static] = ACTIONS(4921),
    [sym_struct] = ACTIONS(4921),
    [sym_synchronized] = ACTIONS(4921),
    [sym_template] = ACTIONS(4921),
    [sym_typeof] = ACTIONS(4921),
    [sym_union] = ACTIONS(4921),
    [sym_unittest] = ACTIONS(4921),
    [sym_version] = ACTIONS(4921),
    [sym_while] = ACTIONS(4921),
    [sym_gshared] = ACTIONS(4921),
    [sym_traits] = ACTIONS(4921),
    [sym_vector] = ACTIONS(4921),
    [sym_void] = ACTIONS(4921),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2421] = {
    [sym_identifier] = ACTIONS(4925),
    [anon_sym_DOT] = ACTIONS(4927),
    [anon_sym_SEMI] = ACTIONS(4927),
    [anon_sym_TILDE] = ACTIONS(4927),
    [anon_sym_AT] = ACTIONS(4927),
    [sym_bool] = ACTIONS(4925),
    [sym_byte] = ACTIONS(4925),
    [sym_ubyte] = ACTIONS(4925),
    [sym_char] = ACTIONS(4925),
    [sym_short] = ACTIONS(4925),
    [sym_ushort] = ACTIONS(4925),
    [sym_int] = ACTIONS(4925),
    [sym_uint] = ACTIONS(4925),
    [sym_long] = ACTIONS(4925),
    [sym_ulong] = ACTIONS(4925),
    [sym_cent] = ACTIONS(4925),
    [sym_ucent] = ACTIONS(4925),
    [sym_wchar] = ACTIONS(4925),
    [sym_dchar] = ACTIONS(4925),
    [sym_float] = ACTIONS(4925),
    [sym_double] = ACTIONS(4925),
    [sym_real] = ACTIONS(4925),
    [sym_ifloat] = ACTIONS(4925),
    [sym_idouble] = ACTIONS(4925),
    [sym_ireal] = ACTIONS(4925),
    [sym_cfloat] = ACTIONS(4925),
    [sym_cdouble] = ACTIONS(4925),
    [sym_creal] = ACTIONS(4925),
    [sym_size_t] = ACTIONS(4925),
    [sym_ptrdiff_t] = ACTIONS(4925),
    [sym_string] = ACTIONS(4925),
    [sym_cstring] = ACTIONS(4925),
    [sym_dstring] = ACTIONS(4925),
    [sym_wstring] = ACTIONS(4925),
    [sym_noreturn] = ACTIONS(4925),
    [sym_this] = ACTIONS(4925),
    [sym_abstract] = ACTIONS(4925),
    [sym_alias] = ACTIONS(4925),
    [sym_align] = ACTIONS(4925),
    [sym_auto] = ACTIONS(4925),
    [sym_catch] = ACTIONS(4925),
    [sym_class] = ACTIONS(4925),
    [sym_const] = ACTIONS(4925),
    [sym_debug] = ACTIONS(4925),
    [sym_deprecated] = ACTIONS(4925),
    [sym_else] = ACTIONS(4925),
    [sym_enum] = ACTIONS(4925),
    [sym_export] = ACTIONS(4925),
    [sym_extern] = ACTIONS(4925),
    [sym_final] = ACTIONS(4925),
    [sym_finally] = ACTIONS(4925),
    [sym_immutable] = ACTIONS(4925),
    [sym_import] = ACTIONS(4925),
    [sym_inout] = ACTIONS(4925),
    [sym_interface] = ACTIONS(4925),
    [sym_invariant] = ACTIONS(4925),
    [sym_mixin] = ACTIONS(4925),
    [sym_nothrow] = ACTIONS(4925),
    [sym_override] = ACTIONS(4925),
    [sym_package] = ACTIONS(4925),
    [sym_pragma] = ACTIONS(4925),
    [sym_private] = ACTIONS(4925),
    [sym_protected] = ACTIONS(4925),
    [sym_public] = ACTIONS(4925),
    [sym_pure] = ACTIONS(4925),
    [sym_ref] = ACTIONS(4925),
    [sym_return] = ACTIONS(4925),
    [sym_scope] = ACTIONS(4925),
    [sym_shared] = ACTIONS(4925),
    [sym_static] = ACTIONS(4925),
    [sym_struct] = ACTIONS(4925),
    [sym_synchronized] = ACTIONS(4925),
    [sym_template] = ACTIONS(4925),
    [sym_typeof] = ACTIONS(4925),
    [sym_union] = ACTIONS(4925),
    [sym_unittest] = ACTIONS(4925),
    [sym_version] = ACTIONS(4925),
    [sym_while] = ACTIONS(4925),
    [sym_gshared] = ACTIONS(4925),
    [sym_traits] = ACTIONS(4925),
    [sym_vector] = ACTIONS(4925),
    [sym_void] = ACTIONS(4925),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2422] = {
    [sym_identifier] = ACTIONS(4929),
    [anon_sym_DOT] = ACTIONS(4931),
    [anon_sym_SEMI] = ACTIONS(4931),
    [anon_sym_TILDE] = ACTIONS(4931),
    [anon_sym_AT] = ACTIONS(4931),
    [sym_bool] = ACTIONS(4929),
    [sym_byte] = ACTIONS(4929),
    [sym_ubyte] = ACTIONS(4929),
    [sym_char] = ACTIONS(4929),
    [sym_short] = ACTIONS(4929),
    [sym_ushort] = ACTIONS(4929),
    [sym_int] = ACTIONS(4929),
    [sym_uint] = ACTIONS(4929),
    [sym_long] = ACTIONS(4929),
    [sym_ulong] = ACTIONS(4929),
    [sym_cent] = ACTIONS(4929),
    [sym_ucent] = ACTIONS(4929),
    [sym_wchar] = ACTIONS(4929),
    [sym_dchar] = ACTIONS(4929),
    [sym_float] = ACTIONS(4929),
    [sym_double] = ACTIONS(4929),
    [sym_real] = ACTIONS(4929),
    [sym_ifloat] = ACTIONS(4929),
    [sym_idouble] = ACTIONS(4929),
    [sym_ireal] = ACTIONS(4929),
    [sym_cfloat] = ACTIONS(4929),
    [sym_cdouble] = ACTIONS(4929),
    [sym_creal] = ACTIONS(4929),
    [sym_size_t] = ACTIONS(4929),
    [sym_ptrdiff_t] = ACTIONS(4929),
    [sym_string] = ACTIONS(4929),
    [sym_cstring] = ACTIONS(4929),
    [sym_dstring] = ACTIONS(4929),
    [sym_wstring] = ACTIONS(4929),
    [sym_noreturn] = ACTIONS(4929),
    [sym_this] = ACTIONS(4929),
    [sym_abstract] = ACTIONS(4929),
    [sym_alias] = ACTIONS(4929),
    [sym_align] = ACTIONS(4929),
    [sym_auto] = ACTIONS(4929),
    [sym_catch] = ACTIONS(4929),
    [sym_class] = ACTIONS(4929),
    [sym_const] = ACTIONS(4929),
    [sym_debug] = ACTIONS(4929),
    [sym_deprecated] = ACTIONS(4929),
    [sym_else] = ACTIONS(4929),
    [sym_enum] = ACTIONS(4929),
    [sym_export] = ACTIONS(4929),
    [sym_extern] = ACTIONS(4929),
    [sym_final] = ACTIONS(4929),
    [sym_finally] = ACTIONS(4929),
    [sym_immutable] = ACTIONS(4929),
    [sym_import] = ACTIONS(4929),
    [sym_inout] = ACTIONS(4929),
    [sym_interface] = ACTIONS(4929),
    [sym_invariant] = ACTIONS(4929),
    [sym_mixin] = ACTIONS(4929),
    [sym_nothrow] = ACTIONS(4929),
    [sym_override] = ACTIONS(4929),
    [sym_package] = ACTIONS(4929),
    [sym_pragma] = ACTIONS(4929),
    [sym_private] = ACTIONS(4929),
    [sym_protected] = ACTIONS(4929),
    [sym_public] = ACTIONS(4929),
    [sym_pure] = ACTIONS(4929),
    [sym_ref] = ACTIONS(4929),
    [sym_return] = ACTIONS(4929),
    [sym_scope] = ACTIONS(4929),
    [sym_shared] = ACTIONS(4929),
    [sym_static] = ACTIONS(4929),
    [sym_struct] = ACTIONS(4929),
    [sym_synchronized] = ACTIONS(4929),
    [sym_template] = ACTIONS(4929),
    [sym_typeof] = ACTIONS(4929),
    [sym_union] = ACTIONS(4929),
    [sym_unittest] = ACTIONS(4929),
    [sym_version] = ACTIONS(4929),
    [sym_while] = ACTIONS(4929),
    [sym_gshared] = ACTIONS(4929),
    [sym_traits] = ACTIONS(4929),
    [sym_vector] = ACTIONS(4929),
    [sym_void] = ACTIONS(4929),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2423] = {
    [ts_builtin_sym_end] = ACTIONS(4666),
    [sym_identifier] = ACTIONS(4664),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_DOT] = ACTIONS(4666),
    [anon_sym_SEMI] = ACTIONS(4666),
    [anon_sym_TILDE] = ACTIONS(4666),
    [anon_sym_AT] = ACTIONS(4666),
    [sym_bool] = ACTIONS(4664),
    [sym_byte] = ACTIONS(4664),
    [sym_ubyte] = ACTIONS(4664),
    [sym_char] = ACTIONS(4664),
    [sym_short] = ACTIONS(4664),
    [sym_ushort] = ACTIONS(4664),
    [sym_int] = ACTIONS(4664),
    [sym_uint] = ACTIONS(4664),
    [sym_long] = ACTIONS(4664),
    [sym_ulong] = ACTIONS(4664),
    [sym_cent] = ACTIONS(4664),
    [sym_ucent] = ACTIONS(4664),
    [sym_wchar] = ACTIONS(4664),
    [sym_dchar] = ACTIONS(4664),
    [sym_float] = ACTIONS(4664),
    [sym_double] = ACTIONS(4664),
    [sym_real] = ACTIONS(4664),
    [sym_ifloat] = ACTIONS(4664),
    [sym_idouble] = ACTIONS(4664),
    [sym_ireal] = ACTIONS(4664),
    [sym_cfloat] = ACTIONS(4664),
    [sym_cdouble] = ACTIONS(4664),
    [sym_creal] = ACTIONS(4664),
    [sym_size_t] = ACTIONS(4664),
    [sym_ptrdiff_t] = ACTIONS(4664),
    [sym_string] = ACTIONS(4664),
    [sym_cstring] = ACTIONS(4664),
    [sym_dstring] = ACTIONS(4664),
    [sym_wstring] = ACTIONS(4664),
    [sym_noreturn] = ACTIONS(4664),
    [sym_this] = ACTIONS(4664),
    [sym_abstract] = ACTIONS(4664),
    [sym_alias] = ACTIONS(4664),
    [sym_align] = ACTIONS(4664),
    [sym_auto] = ACTIONS(4664),
    [sym_class] = ACTIONS(4664),
    [sym_const] = ACTIONS(4664),
    [sym_debug] = ACTIONS(4664),
    [sym_deprecated] = ACTIONS(4664),
    [sym_else] = ACTIONS(4664),
    [sym_enum] = ACTIONS(4664),
    [sym_export] = ACTIONS(4664),
    [sym_extern] = ACTIONS(4664),
    [sym_final] = ACTIONS(4664),
    [sym_immutable] = ACTIONS(4664),
    [sym_import] = ACTIONS(4664),
    [sym_inout] = ACTIONS(4664),
    [sym_interface] = ACTIONS(4664),
    [sym_invariant] = ACTIONS(4664),
    [sym_mixin] = ACTIONS(4664),
    [sym_nothrow] = ACTIONS(4664),
    [sym_override] = ACTIONS(4664),
    [sym_package] = ACTIONS(4664),
    [sym_pragma] = ACTIONS(4664),
    [sym_private] = ACTIONS(4664),
    [sym_protected] = ACTIONS(4664),
    [sym_public] = ACTIONS(4664),
    [sym_pure] = ACTIONS(4664),
    [sym_ref] = ACTIONS(4664),
    [sym_return] = ACTIONS(4664),
    [sym_scope] = ACTIONS(4664),
    [sym_shared] = ACTIONS(4664),
    [sym_static] = ACTIONS(4664),
    [sym_struct] = ACTIONS(4664),
    [sym_synchronized] = ACTIONS(4664),
    [sym_template] = ACTIONS(4664),
    [sym_typeof] = ACTIONS(4664),
    [sym_union] = ACTIONS(4664),
    [sym_unittest] = ACTIONS(4664),
    [sym_version] = ACTIONS(4664),
    [sym_while] = ACTIONS(4664),
    [sym_gshared] = ACTIONS(4664),
    [sym_traits] = ACTIONS(4664),
    [sym_vector] = ACTIONS(4664),
    [sym_void] = ACTIONS(4664),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2424] = {
    [sym_identifier] = ACTIONS(4466),
    [anon_sym_DOT] = ACTIONS(4468),
    [anon_sym_SEMI] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4468),
    [anon_sym_AT] = ACTIONS(4468),
    [sym_bool] = ACTIONS(4466),
    [sym_byte] = ACTIONS(4466),
    [sym_ubyte] = ACTIONS(4466),
    [sym_char] = ACTIONS(4466),
    [sym_short] = ACTIONS(4466),
    [sym_ushort] = ACTIONS(4466),
    [sym_int] = ACTIONS(4466),
    [sym_uint] = ACTIONS(4466),
    [sym_long] = ACTIONS(4466),
    [sym_ulong] = ACTIONS(4466),
    [sym_cent] = ACTIONS(4466),
    [sym_ucent] = ACTIONS(4466),
    [sym_wchar] = ACTIONS(4466),
    [sym_dchar] = ACTIONS(4466),
    [sym_float] = ACTIONS(4466),
    [sym_double] = ACTIONS(4466),
    [sym_real] = ACTIONS(4466),
    [sym_ifloat] = ACTIONS(4466),
    [sym_idouble] = ACTIONS(4466),
    [sym_ireal] = ACTIONS(4466),
    [sym_cfloat] = ACTIONS(4466),
    [sym_cdouble] = ACTIONS(4466),
    [sym_creal] = ACTIONS(4466),
    [sym_size_t] = ACTIONS(4466),
    [sym_ptrdiff_t] = ACTIONS(4466),
    [sym_string] = ACTIONS(4466),
    [sym_cstring] = ACTIONS(4466),
    [sym_dstring] = ACTIONS(4466),
    [sym_wstring] = ACTIONS(4466),
    [sym_noreturn] = ACTIONS(4466),
    [sym_this] = ACTIONS(4466),
    [sym_abstract] = ACTIONS(4466),
    [sym_alias] = ACTIONS(4466),
    [sym_align] = ACTIONS(4466),
    [sym_auto] = ACTIONS(4466),
    [sym_catch] = ACTIONS(4466),
    [sym_class] = ACTIONS(4466),
    [sym_const] = ACTIONS(4466),
    [sym_debug] = ACTIONS(4466),
    [sym_deprecated] = ACTIONS(4466),
    [sym_else] = ACTIONS(4466),
    [sym_enum] = ACTIONS(4466),
    [sym_export] = ACTIONS(4466),
    [sym_extern] = ACTIONS(4466),
    [sym_final] = ACTIONS(4466),
    [sym_finally] = ACTIONS(4466),
    [sym_immutable] = ACTIONS(4466),
    [sym_import] = ACTIONS(4466),
    [sym_inout] = ACTIONS(4466),
    [sym_interface] = ACTIONS(4466),
    [sym_invariant] = ACTIONS(4466),
    [sym_mixin] = ACTIONS(4466),
    [sym_nothrow] = ACTIONS(4466),
    [sym_override] = ACTIONS(4466),
    [sym_package] = ACTIONS(4466),
    [sym_pragma] = ACTIONS(4466),
    [sym_private] = ACTIONS(4466),
    [sym_protected] = ACTIONS(4466),
    [sym_public] = ACTIONS(4466),
    [sym_pure] = ACTIONS(4466),
    [sym_ref] = ACTIONS(4466),
    [sym_return] = ACTIONS(4466),
    [sym_scope] = ACTIONS(4466),
    [sym_shared] = ACTIONS(4466),
    [sym_static] = ACTIONS(4466),
    [sym_struct] = ACTIONS(4466),
    [sym_synchronized] = ACTIONS(4466),
    [sym_template] = ACTIONS(4466),
    [sym_typeof] = ACTIONS(4466),
    [sym_union] = ACTIONS(4466),
    [sym_unittest] = ACTIONS(4466),
    [sym_version] = ACTIONS(4466),
    [sym_while] = ACTIONS(4466),
    [sym_gshared] = ACTIONS(4466),
    [sym_traits] = ACTIONS(4466),
    [sym_vector] = ACTIONS(4466),
    [sym_void] = ACTIONS(4466),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2425] = {
    [sym_identifier] = ACTIONS(4707),
    [anon_sym_DOT] = ACTIONS(4709),
    [anon_sym_SEMI] = ACTIONS(4709),
    [anon_sym_TILDE] = ACTIONS(4709),
    [anon_sym_AT] = ACTIONS(4709),
    [sym_bool] = ACTIONS(4707),
    [sym_byte] = ACTIONS(4707),
    [sym_ubyte] = ACTIONS(4707),
    [sym_char] = ACTIONS(4707),
    [sym_short] = ACTIONS(4707),
    [sym_ushort] = ACTIONS(4707),
    [sym_int] = ACTIONS(4707),
    [sym_uint] = ACTIONS(4707),
    [sym_long] = ACTIONS(4707),
    [sym_ulong] = ACTIONS(4707),
    [sym_cent] = ACTIONS(4707),
    [sym_ucent] = ACTIONS(4707),
    [sym_wchar] = ACTIONS(4707),
    [sym_dchar] = ACTIONS(4707),
    [sym_float] = ACTIONS(4707),
    [sym_double] = ACTIONS(4707),
    [sym_real] = ACTIONS(4707),
    [sym_ifloat] = ACTIONS(4707),
    [sym_idouble] = ACTIONS(4707),
    [sym_ireal] = ACTIONS(4707),
    [sym_cfloat] = ACTIONS(4707),
    [sym_cdouble] = ACTIONS(4707),
    [sym_creal] = ACTIONS(4707),
    [sym_size_t] = ACTIONS(4707),
    [sym_ptrdiff_t] = ACTIONS(4707),
    [sym_string] = ACTIONS(4707),
    [sym_cstring] = ACTIONS(4707),
    [sym_dstring] = ACTIONS(4707),
    [sym_wstring] = ACTIONS(4707),
    [sym_noreturn] = ACTIONS(4707),
    [sym_this] = ACTIONS(4707),
    [sym_abstract] = ACTIONS(4707),
    [sym_alias] = ACTIONS(4707),
    [sym_align] = ACTIONS(4707),
    [sym_auto] = ACTIONS(4707),
    [sym_catch] = ACTIONS(4707),
    [sym_class] = ACTIONS(4707),
    [sym_const] = ACTIONS(4707),
    [sym_debug] = ACTIONS(4707),
    [sym_deprecated] = ACTIONS(4707),
    [sym_else] = ACTIONS(4707),
    [sym_enum] = ACTIONS(4707),
    [sym_export] = ACTIONS(4707),
    [sym_extern] = ACTIONS(4707),
    [sym_final] = ACTIONS(4707),
    [sym_finally] = ACTIONS(4707),
    [sym_immutable] = ACTIONS(4707),
    [sym_import] = ACTIONS(4707),
    [sym_inout] = ACTIONS(4707),
    [sym_interface] = ACTIONS(4707),
    [sym_invariant] = ACTIONS(4707),
    [sym_mixin] = ACTIONS(4707),
    [sym_nothrow] = ACTIONS(4707),
    [sym_override] = ACTIONS(4707),
    [sym_package] = ACTIONS(4707),
    [sym_pragma] = ACTIONS(4707),
    [sym_private] = ACTIONS(4707),
    [sym_protected] = ACTIONS(4707),
    [sym_public] = ACTIONS(4707),
    [sym_pure] = ACTIONS(4707),
    [sym_ref] = ACTIONS(4707),
    [sym_return] = ACTIONS(4707),
    [sym_scope] = ACTIONS(4707),
    [sym_shared] = ACTIONS(4707),
    [sym_static] = ACTIONS(4707),
    [sym_struct] = ACTIONS(4707),
    [sym_synchronized] = ACTIONS(4707),
    [sym_template] = ACTIONS(4707),
    [sym_typeof] = ACTIONS(4707),
    [sym_union] = ACTIONS(4707),
    [sym_unittest] = ACTIONS(4707),
    [sym_version] = ACTIONS(4707),
    [sym_while] = ACTIONS(4707),
    [sym_gshared] = ACTIONS(4707),
    [sym_traits] = ACTIONS(4707),
    [sym_vector] = ACTIONS(4707),
    [sym_void] = ACTIONS(4707),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2426] = {
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(5034),
    [anon_sym_DOT] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(6076),
    [anon_sym_SEMI] = ACTIONS(5034),
    [anon_sym_COLON] = ACTIONS(5034),
    [anon_sym_EQ] = ACTIONS(5046),
    [anon_sym_TILDE] = ACTIONS(5034),
    [anon_sym_AT] = ACTIONS(5034),
    [sym_bool] = ACTIONS(5032),
    [sym_byte] = ACTIONS(5032),
    [sym_ubyte] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_short] = ACTIONS(5032),
    [sym_ushort] = ACTIONS(5032),
    [sym_int] = ACTIONS(5032),
    [sym_uint] = ACTIONS(5032),
    [sym_long] = ACTIONS(5032),
    [sym_ulong] = ACTIONS(5032),
    [sym_cent] = ACTIONS(5032),
    [sym_ucent] = ACTIONS(5032),
    [sym_wchar] = ACTIONS(5032),
    [sym_dchar] = ACTIONS(5032),
    [sym_float] = ACTIONS(5032),
    [sym_double] = ACTIONS(5032),
    [sym_real] = ACTIONS(5032),
    [sym_ifloat] = ACTIONS(5032),
    [sym_idouble] = ACTIONS(5032),
    [sym_ireal] = ACTIONS(5032),
    [sym_cfloat] = ACTIONS(5032),
    [sym_cdouble] = ACTIONS(5032),
    [sym_creal] = ACTIONS(5032),
    [sym_size_t] = ACTIONS(5032),
    [sym_ptrdiff_t] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym_cstring] = ACTIONS(5032),
    [sym_dstring] = ACTIONS(5032),
    [sym_wstring] = ACTIONS(5032),
    [sym_noreturn] = ACTIONS(5032),
    [sym_this] = ACTIONS(5032),
    [sym_abstract] = ACTIONS(5032),
    [sym_alias] = ACTIONS(5032),
    [sym_align] = ACTIONS(5032),
    [sym_auto] = ACTIONS(5032),
    [sym_class] = ACTIONS(5032),
    [sym_const] = ACTIONS(5032),
    [sym_debug] = ACTIONS(5032),
    [sym_deprecated] = ACTIONS(5032),
    [sym_enum] = ACTIONS(5032),
    [sym_export] = ACTIONS(5032),
    [sym_extern] = ACTIONS(5032),
    [sym_final] = ACTIONS(5032),
    [sym_immutable] = ACTIONS(5032),
    [sym_import] = ACTIONS(5032),
    [sym_inout] = ACTIONS(5032),
    [sym_interface] = ACTIONS(5032),
    [sym_invariant] = ACTIONS(5032),
    [sym_mixin] = ACTIONS(5032),
    [sym_nothrow] = ACTIONS(5032),
    [sym_override] = ACTIONS(5032),
    [sym_package] = ACTIONS(5032),
    [sym_pragma] = ACTIONS(5032),
    [sym_private] = ACTIONS(5032),
    [sym_protected] = ACTIONS(5032),
    [sym_public] = ACTIONS(5032),
    [sym_pure] = ACTIONS(5032),
    [sym_ref] = ACTIONS(5032),
    [sym_return] = ACTIONS(5032),
    [sym_scope] = ACTIONS(5032),
    [sym_shared] = ACTIONS(5032),
    [sym_static] = ACTIONS(5032),
    [sym_struct] = ACTIONS(5032),
    [sym_synchronized] = ACTIONS(5032),
    [sym_template] = ACTIONS(5032),
    [sym_typeof] = ACTIONS(5032),
    [sym_union] = ACTIONS(5032),
    [sym_unittest] = ACTIONS(5032),
    [sym_version] = ACTIONS(5032),
    [sym_gshared] = ACTIONS(5032),
    [sym_traits] = ACTIONS(5032),
    [sym_vector] = ACTIONS(5032),
    [sym_void] = ACTIONS(5032),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2427] = {
    [ts_builtin_sym_end] = ACTIONS(4833),
    [sym_identifier] = ACTIONS(4831),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_DOT] = ACTIONS(4833),
    [anon_sym_SEMI] = ACTIONS(4833),
    [anon_sym_TILDE] = ACTIONS(4833),
    [anon_sym_AT] = ACTIONS(4833),
    [sym_bool] = ACTIONS(4831),
    [sym_byte] = ACTIONS(4831),
    [sym_ubyte] = ACTIONS(4831),
    [sym_char] = ACTIONS(4831),
    [sym_short] = ACTIONS(4831),
    [sym_ushort] = ACTIONS(4831),
    [sym_int] = ACTIONS(4831),
    [sym_uint] = ACTIONS(4831),
    [sym_long] = ACTIONS(4831),
    [sym_ulong] = ACTIONS(4831),
    [sym_cent] = ACTIONS(4831),
    [sym_ucent] = ACTIONS(4831),
    [sym_wchar] = ACTIONS(4831),
    [sym_dchar] = ACTIONS(4831),
    [sym_float] = ACTIONS(4831),
    [sym_double] = ACTIONS(4831),
    [sym_real] = ACTIONS(4831),
    [sym_ifloat] = ACTIONS(4831),
    [sym_idouble] = ACTIONS(4831),
    [sym_ireal] = ACTIONS(4831),
    [sym_cfloat] = ACTIONS(4831),
    [sym_cdouble] = ACTIONS(4831),
    [sym_creal] = ACTIONS(4831),
    [sym_size_t] = ACTIONS(4831),
    [sym_ptrdiff_t] = ACTIONS(4831),
    [sym_string] = ACTIONS(4831),
    [sym_cstring] = ACTIONS(4831),
    [sym_dstring] = ACTIONS(4831),
    [sym_wstring] = ACTIONS(4831),
    [sym_noreturn] = ACTIONS(4831),
    [sym_this] = ACTIONS(4831),
    [sym_abstract] = ACTIONS(4831),
    [sym_alias] = ACTIONS(4831),
    [sym_align] = ACTIONS(4831),
    [sym_auto] = ACTIONS(4831),
    [sym_class] = ACTIONS(4831),
    [sym_const] = ACTIONS(4831),
    [sym_debug] = ACTIONS(4831),
    [sym_deprecated] = ACTIONS(4831),
    [sym_else] = ACTIONS(4831),
    [sym_enum] = ACTIONS(4831),
    [sym_export] = ACTIONS(4831),
    [sym_extern] = ACTIONS(4831),
    [sym_final] = ACTIONS(4831),
    [sym_immutable] = ACTIONS(4831),
    [sym_import] = ACTIONS(4831),
    [sym_inout] = ACTIONS(4831),
    [sym_interface] = ACTIONS(4831),
    [sym_invariant] = ACTIONS(4831),
    [sym_mixin] = ACTIONS(4831),
    [sym_nothrow] = ACTIONS(4831),
    [sym_override] = ACTIONS(4831),
    [sym_package] = ACTIONS(4831),
    [sym_pragma] = ACTIONS(4831),
    [sym_private] = ACTIONS(4831),
    [sym_protected] = ACTIONS(4831),
    [sym_public] = ACTIONS(4831),
    [sym_pure] = ACTIONS(4831),
    [sym_ref] = ACTIONS(4831),
    [sym_return] = ACTIONS(4831),
    [sym_scope] = ACTIONS(4831),
    [sym_shared] = ACTIONS(4831),
    [sym_static] = ACTIONS(4831),
    [sym_struct] = ACTIONS(4831),
    [sym_synchronized] = ACTIONS(4831),
    [sym_template] = ACTIONS(4831),
    [sym_typeof] = ACTIONS(4831),
    [sym_union] = ACTIONS(4831),
    [sym_unittest] = ACTIONS(4831),
    [sym_version] = ACTIONS(4831),
    [sym_while] = ACTIONS(4831),
    [sym_gshared] = ACTIONS(4831),
    [sym_traits] = ACTIONS(4831),
    [sym_vector] = ACTIONS(4831),
    [sym_void] = ACTIONS(4831),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2428] = {
    [ts_builtin_sym_end] = ACTIONS(4492),
    [sym_identifier] = ACTIONS(4490),
    [anon_sym_RBRACE] = ACTIONS(4492),
    [anon_sym_DOT] = ACTIONS(4492),
    [anon_sym_SEMI] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4492),
    [anon_sym_AT] = ACTIONS(4492),
    [sym_bool] = ACTIONS(4490),
    [sym_byte] = ACTIONS(4490),
    [sym_ubyte] = ACTIONS(4490),
    [sym_char] = ACTIONS(4490),
    [sym_short] = ACTIONS(4490),
    [sym_ushort] = ACTIONS(4490),
    [sym_int] = ACTIONS(4490),
    [sym_uint] = ACTIONS(4490),
    [sym_long] = ACTIONS(4490),
    [sym_ulong] = ACTIONS(4490),
    [sym_cent] = ACTIONS(4490),
    [sym_ucent] = ACTIONS(4490),
    [sym_wchar] = ACTIONS(4490),
    [sym_dchar] = ACTIONS(4490),
    [sym_float] = ACTIONS(4490),
    [sym_double] = ACTIONS(4490),
    [sym_real] = ACTIONS(4490),
    [sym_ifloat] = ACTIONS(4490),
    [sym_idouble] = ACTIONS(4490),
    [sym_ireal] = ACTIONS(4490),
    [sym_cfloat] = ACTIONS(4490),
    [sym_cdouble] = ACTIONS(4490),
    [sym_creal] = ACTIONS(4490),
    [sym_size_t] = ACTIONS(4490),
    [sym_ptrdiff_t] = ACTIONS(4490),
    [sym_string] = ACTIONS(4490),
    [sym_cstring] = ACTIONS(4490),
    [sym_dstring] = ACTIONS(4490),
    [sym_wstring] = ACTIONS(4490),
    [sym_noreturn] = ACTIONS(4490),
    [sym_this] = ACTIONS(4490),
    [sym_abstract] = ACTIONS(4490),
    [sym_alias] = ACTIONS(4490),
    [sym_align] = ACTIONS(4490),
    [sym_auto] = ACTIONS(4490),
    [sym_class] = ACTIONS(4490),
    [sym_const] = ACTIONS(4490),
    [sym_debug] = ACTIONS(4490),
    [sym_deprecated] = ACTIONS(4490),
    [sym_else] = ACTIONS(4490),
    [sym_enum] = ACTIONS(4490),
    [sym_export] = ACTIONS(4490),
    [sym_extern] = ACTIONS(4490),
    [sym_final] = ACTIONS(4490),
    [sym_immutable] = ACTIONS(4490),
    [sym_import] = ACTIONS(4490),
    [sym_inout] = ACTIONS(4490),
    [sym_interface] = ACTIONS(4490),
    [sym_invariant] = ACTIONS(4490),
    [sym_mixin] = ACTIONS(4490),
    [sym_nothrow] = ACTIONS(4490),
    [sym_override] = ACTIONS(4490),
    [sym_package] = ACTIONS(4490),
    [sym_pragma] = ACTIONS(4490),
    [sym_private] = ACTIONS(4490),
    [sym_protected] = ACTIONS(4490),
    [sym_public] = ACTIONS(4490),
    [sym_pure] = ACTIONS(4490),
    [sym_ref] = ACTIONS(4490),
    [sym_return] = ACTIONS(4490),
    [sym_scope] = ACTIONS(4490),
    [sym_shared] = ACTIONS(4490),
    [sym_static] = ACTIONS(4490),
    [sym_struct] = ACTIONS(4490),
    [sym_synchronized] = ACTIONS(4490),
    [sym_template] = ACTIONS(4490),
    [sym_typeof] = ACTIONS(4490),
    [sym_union] = ACTIONS(4490),
    [sym_unittest] = ACTIONS(4490),
    [sym_version] = ACTIONS(4490),
    [sym_while] = ACTIONS(4490),
    [sym_gshared] = ACTIONS(4490),
    [sym_traits] = ACTIONS(4490),
    [sym_vector] = ACTIONS(4490),
    [sym_void] = ACTIONS(4490),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2429] = {
    [ts_builtin_sym_end] = ACTIONS(4500),
    [sym_identifier] = ACTIONS(4498),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_DOT] = ACTIONS(4500),
    [anon_sym_SEMI] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4500),
    [anon_sym_AT] = ACTIONS(4500),
    [sym_bool] = ACTIONS(4498),
    [sym_byte] = ACTIONS(4498),
    [sym_ubyte] = ACTIONS(4498),
    [sym_char] = ACTIONS(4498),
    [sym_short] = ACTIONS(4498),
    [sym_ushort] = ACTIONS(4498),
    [sym_int] = ACTIONS(4498),
    [sym_uint] = ACTIONS(4498),
    [sym_long] = ACTIONS(4498),
    [sym_ulong] = ACTIONS(4498),
    [sym_cent] = ACTIONS(4498),
    [sym_ucent] = ACTIONS(4498),
    [sym_wchar] = ACTIONS(4498),
    [sym_dchar] = ACTIONS(4498),
    [sym_float] = ACTIONS(4498),
    [sym_double] = ACTIONS(4498),
    [sym_real] = ACTIONS(4498),
    [sym_ifloat] = ACTIONS(4498),
    [sym_idouble] = ACTIONS(4498),
    [sym_ireal] = ACTIONS(4498),
    [sym_cfloat] = ACTIONS(4498),
    [sym_cdouble] = ACTIONS(4498),
    [sym_creal] = ACTIONS(4498),
    [sym_size_t] = ACTIONS(4498),
    [sym_ptrdiff_t] = ACTIONS(4498),
    [sym_string] = ACTIONS(4498),
    [sym_cstring] = ACTIONS(4498),
    [sym_dstring] = ACTIONS(4498),
    [sym_wstring] = ACTIONS(4498),
    [sym_noreturn] = ACTIONS(4498),
    [sym_this] = ACTIONS(4498),
    [sym_abstract] = ACTIONS(4498),
    [sym_alias] = ACTIONS(4498),
    [sym_align] = ACTIONS(4498),
    [sym_auto] = ACTIONS(4498),
    [sym_class] = ACTIONS(4498),
    [sym_const] = ACTIONS(4498),
    [sym_debug] = ACTIONS(4498),
    [sym_deprecated] = ACTIONS(4498),
    [sym_else] = ACTIONS(4498),
    [sym_enum] = ACTIONS(4498),
    [sym_export] = ACTIONS(4498),
    [sym_extern] = ACTIONS(4498),
    [sym_final] = ACTIONS(4498),
    [sym_immutable] = ACTIONS(4498),
    [sym_import] = ACTIONS(4498),
    [sym_inout] = ACTIONS(4498),
    [sym_interface] = ACTIONS(4498),
    [sym_invariant] = ACTIONS(4498),
    [sym_mixin] = ACTIONS(4498),
    [sym_nothrow] = ACTIONS(4498),
    [sym_override] = ACTIONS(4498),
    [sym_package] = ACTIONS(4498),
    [sym_pragma] = ACTIONS(4498),
    [sym_private] = ACTIONS(4498),
    [sym_protected] = ACTIONS(4498),
    [sym_public] = ACTIONS(4498),
    [sym_pure] = ACTIONS(4498),
    [sym_ref] = ACTIONS(4498),
    [sym_return] = ACTIONS(4498),
    [sym_scope] = ACTIONS(4498),
    [sym_shared] = ACTIONS(4498),
    [sym_static] = ACTIONS(4498),
    [sym_struct] = ACTIONS(4498),
    [sym_synchronized] = ACTIONS(4498),
    [sym_template] = ACTIONS(4498),
    [sym_typeof] = ACTIONS(4498),
    [sym_union] = ACTIONS(4498),
    [sym_unittest] = ACTIONS(4498),
    [sym_version] = ACTIONS(4498),
    [sym_while] = ACTIONS(4498),
    [sym_gshared] = ACTIONS(4498),
    [sym_traits] = ACTIONS(4498),
    [sym_vector] = ACTIONS(4498),
    [sym_void] = ACTIONS(4498),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2430] = {
    [ts_builtin_sym_end] = ACTIONS(4536),
    [sym_identifier] = ACTIONS(4534),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_DOT] = ACTIONS(4536),
    [anon_sym_SEMI] = ACTIONS(4536),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_AT] = ACTIONS(4536),
    [sym_bool] = ACTIONS(4534),
    [sym_byte] = ACTIONS(4534),
    [sym_ubyte] = ACTIONS(4534),
    [sym_char] = ACTIONS(4534),
    [sym_short] = ACTIONS(4534),
    [sym_ushort] = ACTIONS(4534),
    [sym_int] = ACTIONS(4534),
    [sym_uint] = ACTIONS(4534),
    [sym_long] = ACTIONS(4534),
    [sym_ulong] = ACTIONS(4534),
    [sym_cent] = ACTIONS(4534),
    [sym_ucent] = ACTIONS(4534),
    [sym_wchar] = ACTIONS(4534),
    [sym_dchar] = ACTIONS(4534),
    [sym_float] = ACTIONS(4534),
    [sym_double] = ACTIONS(4534),
    [sym_real] = ACTIONS(4534),
    [sym_ifloat] = ACTIONS(4534),
    [sym_idouble] = ACTIONS(4534),
    [sym_ireal] = ACTIONS(4534),
    [sym_cfloat] = ACTIONS(4534),
    [sym_cdouble] = ACTIONS(4534),
    [sym_creal] = ACTIONS(4534),
    [sym_size_t] = ACTIONS(4534),
    [sym_ptrdiff_t] = ACTIONS(4534),
    [sym_string] = ACTIONS(4534),
    [sym_cstring] = ACTIONS(4534),
    [sym_dstring] = ACTIONS(4534),
    [sym_wstring] = ACTIONS(4534),
    [sym_noreturn] = ACTIONS(4534),
    [sym_this] = ACTIONS(4534),
    [sym_abstract] = ACTIONS(4534),
    [sym_alias] = ACTIONS(4534),
    [sym_align] = ACTIONS(4534),
    [sym_auto] = ACTIONS(4534),
    [sym_class] = ACTIONS(4534),
    [sym_const] = ACTIONS(4534),
    [sym_debug] = ACTIONS(4534),
    [sym_deprecated] = ACTIONS(4534),
    [sym_else] = ACTIONS(4534),
    [sym_enum] = ACTIONS(4534),
    [sym_export] = ACTIONS(4534),
    [sym_extern] = ACTIONS(4534),
    [sym_final] = ACTIONS(4534),
    [sym_immutable] = ACTIONS(4534),
    [sym_import] = ACTIONS(4534),
    [sym_inout] = ACTIONS(4534),
    [sym_interface] = ACTIONS(4534),
    [sym_invariant] = ACTIONS(4534),
    [sym_mixin] = ACTIONS(4534),
    [sym_nothrow] = ACTIONS(4534),
    [sym_override] = ACTIONS(4534),
    [sym_package] = ACTIONS(4534),
    [sym_pragma] = ACTIONS(4534),
    [sym_private] = ACTIONS(4534),
    [sym_protected] = ACTIONS(4534),
    [sym_public] = ACTIONS(4534),
    [sym_pure] = ACTIONS(4534),
    [sym_ref] = ACTIONS(4534),
    [sym_return] = ACTIONS(4534),
    [sym_scope] = ACTIONS(4534),
    [sym_shared] = ACTIONS(4534),
    [sym_static] = ACTIONS(4534),
    [sym_struct] = ACTIONS(4534),
    [sym_synchronized] = ACTIONS(4534),
    [sym_template] = ACTIONS(4534),
    [sym_typeof] = ACTIONS(4534),
    [sym_union] = ACTIONS(4534),
    [sym_unittest] = ACTIONS(4534),
    [sym_version] = ACTIONS(4534),
    [sym_while] = ACTIONS(4534),
    [sym_gshared] = ACTIONS(4534),
    [sym_traits] = ACTIONS(4534),
    [sym_vector] = ACTIONS(4534),
    [sym_void] = ACTIONS(4534),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2431] = {
    [ts_builtin_sym_end] = ACTIONS(4624),
    [sym_identifier] = ACTIONS(4622),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_DOT] = ACTIONS(4624),
    [anon_sym_SEMI] = ACTIONS(4624),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_AT] = ACTIONS(4624),
    [sym_bool] = ACTIONS(4622),
    [sym_byte] = ACTIONS(4622),
    [sym_ubyte] = ACTIONS(4622),
    [sym_char] = ACTIONS(4622),
    [sym_short] = ACTIONS(4622),
    [sym_ushort] = ACTIONS(4622),
    [sym_int] = ACTIONS(4622),
    [sym_uint] = ACTIONS(4622),
    [sym_long] = ACTIONS(4622),
    [sym_ulong] = ACTIONS(4622),
    [sym_cent] = ACTIONS(4622),
    [sym_ucent] = ACTIONS(4622),
    [sym_wchar] = ACTIONS(4622),
    [sym_dchar] = ACTIONS(4622),
    [sym_float] = ACTIONS(4622),
    [sym_double] = ACTIONS(4622),
    [sym_real] = ACTIONS(4622),
    [sym_ifloat] = ACTIONS(4622),
    [sym_idouble] = ACTIONS(4622),
    [sym_ireal] = ACTIONS(4622),
    [sym_cfloat] = ACTIONS(4622),
    [sym_cdouble] = ACTIONS(4622),
    [sym_creal] = ACTIONS(4622),
    [sym_size_t] = ACTIONS(4622),
    [sym_ptrdiff_t] = ACTIONS(4622),
    [sym_string] = ACTIONS(4622),
    [sym_cstring] = ACTIONS(4622),
    [sym_dstring] = ACTIONS(4622),
    [sym_wstring] = ACTIONS(4622),
    [sym_noreturn] = ACTIONS(4622),
    [sym_this] = ACTIONS(4622),
    [sym_abstract] = ACTIONS(4622),
    [sym_alias] = ACTIONS(4622),
    [sym_align] = ACTIONS(4622),
    [sym_auto] = ACTIONS(4622),
    [sym_class] = ACTIONS(4622),
    [sym_const] = ACTIONS(4622),
    [sym_debug] = ACTIONS(4622),
    [sym_deprecated] = ACTIONS(4622),
    [sym_else] = ACTIONS(4622),
    [sym_enum] = ACTIONS(4622),
    [sym_export] = ACTIONS(4622),
    [sym_extern] = ACTIONS(4622),
    [sym_final] = ACTIONS(4622),
    [sym_immutable] = ACTIONS(4622),
    [sym_import] = ACTIONS(4622),
    [sym_inout] = ACTIONS(4622),
    [sym_interface] = ACTIONS(4622),
    [sym_invariant] = ACTIONS(4622),
    [sym_mixin] = ACTIONS(4622),
    [sym_nothrow] = ACTIONS(4622),
    [sym_override] = ACTIONS(4622),
    [sym_package] = ACTIONS(4622),
    [sym_pragma] = ACTIONS(4622),
    [sym_private] = ACTIONS(4622),
    [sym_protected] = ACTIONS(4622),
    [sym_public] = ACTIONS(4622),
    [sym_pure] = ACTIONS(4622),
    [sym_ref] = ACTIONS(4622),
    [sym_return] = ACTIONS(4622),
    [sym_scope] = ACTIONS(4622),
    [sym_shared] = ACTIONS(4622),
    [sym_static] = ACTIONS(4622),
    [sym_struct] = ACTIONS(4622),
    [sym_synchronized] = ACTIONS(4622),
    [sym_template] = ACTIONS(4622),
    [sym_typeof] = ACTIONS(4622),
    [sym_union] = ACTIONS(4622),
    [sym_unittest] = ACTIONS(4622),
    [sym_version] = ACTIONS(4622),
    [sym_while] = ACTIONS(4622),
    [sym_gshared] = ACTIONS(4622),
    [sym_traits] = ACTIONS(4622),
    [sym_vector] = ACTIONS(4622),
    [sym_void] = ACTIONS(4622),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2432] = {
    [ts_builtin_sym_end] = ACTIONS(4608),
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [anon_sym_DOT] = ACTIONS(4608),
    [anon_sym_SEMI] = ACTIONS(4608),
    [anon_sym_TILDE] = ACTIONS(4608),
    [anon_sym_AT] = ACTIONS(4608),
    [sym_bool] = ACTIONS(4606),
    [sym_byte] = ACTIONS(4606),
    [sym_ubyte] = ACTIONS(4606),
    [sym_char] = ACTIONS(4606),
    [sym_short] = ACTIONS(4606),
    [sym_ushort] = ACTIONS(4606),
    [sym_int] = ACTIONS(4606),
    [sym_uint] = ACTIONS(4606),
    [sym_long] = ACTIONS(4606),
    [sym_ulong] = ACTIONS(4606),
    [sym_cent] = ACTIONS(4606),
    [sym_ucent] = ACTIONS(4606),
    [sym_wchar] = ACTIONS(4606),
    [sym_dchar] = ACTIONS(4606),
    [sym_float] = ACTIONS(4606),
    [sym_double] = ACTIONS(4606),
    [sym_real] = ACTIONS(4606),
    [sym_ifloat] = ACTIONS(4606),
    [sym_idouble] = ACTIONS(4606),
    [sym_ireal] = ACTIONS(4606),
    [sym_cfloat] = ACTIONS(4606),
    [sym_cdouble] = ACTIONS(4606),
    [sym_creal] = ACTIONS(4606),
    [sym_size_t] = ACTIONS(4606),
    [sym_ptrdiff_t] = ACTIONS(4606),
    [sym_string] = ACTIONS(4606),
    [sym_cstring] = ACTIONS(4606),
    [sym_dstring] = ACTIONS(4606),
    [sym_wstring] = ACTIONS(4606),
    [sym_noreturn] = ACTIONS(4606),
    [sym_this] = ACTIONS(4606),
    [sym_abstract] = ACTIONS(4606),
    [sym_alias] = ACTIONS(4606),
    [sym_align] = ACTIONS(4606),
    [sym_auto] = ACTIONS(4606),
    [sym_class] = ACTIONS(4606),
    [sym_const] = ACTIONS(4606),
    [sym_debug] = ACTIONS(4606),
    [sym_deprecated] = ACTIONS(4606),
    [sym_else] = ACTIONS(4606),
    [sym_enum] = ACTIONS(4606),
    [sym_export] = ACTIONS(4606),
    [sym_extern] = ACTIONS(4606),
    [sym_final] = ACTIONS(4606),
    [sym_immutable] = ACTIONS(4606),
    [sym_import] = ACTIONS(4606),
    [sym_inout] = ACTIONS(4606),
    [sym_interface] = ACTIONS(4606),
    [sym_invariant] = ACTIONS(4606),
    [sym_mixin] = ACTIONS(4606),
    [sym_nothrow] = ACTIONS(4606),
    [sym_override] = ACTIONS(4606),
    [sym_package] = ACTIONS(4606),
    [sym_pragma] = ACTIONS(4606),
    [sym_private] = ACTIONS(4606),
    [sym_protected] = ACTIONS(4606),
    [sym_public] = ACTIONS(4606),
    [sym_pure] = ACTIONS(4606),
    [sym_ref] = ACTIONS(4606),
    [sym_return] = ACTIONS(4606),
    [sym_scope] = ACTIONS(4606),
    [sym_shared] = ACTIONS(4606),
    [sym_static] = ACTIONS(4606),
    [sym_struct] = ACTIONS(4606),
    [sym_synchronized] = ACTIONS(4606),
    [sym_template] = ACTIONS(4606),
    [sym_typeof] = ACTIONS(4606),
    [sym_union] = ACTIONS(4606),
    [sym_unittest] = ACTIONS(4606),
    [sym_version] = ACTIONS(4606),
    [sym_while] = ACTIONS(4606),
    [sym_gshared] = ACTIONS(4606),
    [sym_traits] = ACTIONS(4606),
    [sym_vector] = ACTIONS(4606),
    [sym_void] = ACTIONS(4606),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2433] = {
    [ts_builtin_sym_end] = ACTIONS(4584),
    [sym_identifier] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_DOT] = ACTIONS(4584),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_TILDE] = ACTIONS(4584),
    [anon_sym_AT] = ACTIONS(4584),
    [sym_bool] = ACTIONS(4582),
    [sym_byte] = ACTIONS(4582),
    [sym_ubyte] = ACTIONS(4582),
    [sym_char] = ACTIONS(4582),
    [sym_short] = ACTIONS(4582),
    [sym_ushort] = ACTIONS(4582),
    [sym_int] = ACTIONS(4582),
    [sym_uint] = ACTIONS(4582),
    [sym_long] = ACTIONS(4582),
    [sym_ulong] = ACTIONS(4582),
    [sym_cent] = ACTIONS(4582),
    [sym_ucent] = ACTIONS(4582),
    [sym_wchar] = ACTIONS(4582),
    [sym_dchar] = ACTIONS(4582),
    [sym_float] = ACTIONS(4582),
    [sym_double] = ACTIONS(4582),
    [sym_real] = ACTIONS(4582),
    [sym_ifloat] = ACTIONS(4582),
    [sym_idouble] = ACTIONS(4582),
    [sym_ireal] = ACTIONS(4582),
    [sym_cfloat] = ACTIONS(4582),
    [sym_cdouble] = ACTIONS(4582),
    [sym_creal] = ACTIONS(4582),
    [sym_size_t] = ACTIONS(4582),
    [sym_ptrdiff_t] = ACTIONS(4582),
    [sym_string] = ACTIONS(4582),
    [sym_cstring] = ACTIONS(4582),
    [sym_dstring] = ACTIONS(4582),
    [sym_wstring] = ACTIONS(4582),
    [sym_noreturn] = ACTIONS(4582),
    [sym_this] = ACTIONS(4582),
    [sym_abstract] = ACTIONS(4582),
    [sym_alias] = ACTIONS(4582),
    [sym_align] = ACTIONS(4582),
    [sym_auto] = ACTIONS(4582),
    [sym_class] = ACTIONS(4582),
    [sym_const] = ACTIONS(4582),
    [sym_debug] = ACTIONS(4582),
    [sym_deprecated] = ACTIONS(4582),
    [sym_else] = ACTIONS(4582),
    [sym_enum] = ACTIONS(4582),
    [sym_export] = ACTIONS(4582),
    [sym_extern] = ACTIONS(4582),
    [sym_final] = ACTIONS(4582),
    [sym_immutable] = ACTIONS(4582),
    [sym_import] = ACTIONS(4582),
    [sym_inout] = ACTIONS(4582),
    [sym_interface] = ACTIONS(4582),
    [sym_invariant] = ACTIONS(4582),
    [sym_mixin] = ACTIONS(4582),
    [sym_nothrow] = ACTIONS(4582),
    [sym_override] = ACTIONS(4582),
    [sym_package] = ACTIONS(4582),
    [sym_pragma] = ACTIONS(4582),
    [sym_private] = ACTIONS(4582),
    [sym_protected] = ACTIONS(4582),
    [sym_public] = ACTIONS(4582),
    [sym_pure] = ACTIONS(4582),
    [sym_ref] = ACTIONS(4582),
    [sym_return] = ACTIONS(4582),
    [sym_scope] = ACTIONS(4582),
    [sym_shared] = ACTIONS(4582),
    [sym_static] = ACTIONS(4582),
    [sym_struct] = ACTIONS(4582),
    [sym_synchronized] = ACTIONS(4582),
    [sym_template] = ACTIONS(4582),
    [sym_typeof] = ACTIONS(4582),
    [sym_union] = ACTIONS(4582),
    [sym_unittest] = ACTIONS(4582),
    [sym_version] = ACTIONS(4582),
    [sym_while] = ACTIONS(4582),
    [sym_gshared] = ACTIONS(4582),
    [sym_traits] = ACTIONS(4582),
    [sym_vector] = ACTIONS(4582),
    [sym_void] = ACTIONS(4582),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2434] = {
    [ts_builtin_sym_end] = ACTIONS(4588),
    [sym_identifier] = ACTIONS(4586),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_DOT] = ACTIONS(4588),
    [anon_sym_SEMI] = ACTIONS(4588),
    [anon_sym_TILDE] = ACTIONS(4588),
    [anon_sym_AT] = ACTIONS(4588),
    [sym_bool] = ACTIONS(4586),
    [sym_byte] = ACTIONS(4586),
    [sym_ubyte] = ACTIONS(4586),
    [sym_char] = ACTIONS(4586),
    [sym_short] = ACTIONS(4586),
    [sym_ushort] = ACTIONS(4586),
    [sym_int] = ACTIONS(4586),
    [sym_uint] = ACTIONS(4586),
    [sym_long] = ACTIONS(4586),
    [sym_ulong] = ACTIONS(4586),
    [sym_cent] = ACTIONS(4586),
    [sym_ucent] = ACTIONS(4586),
    [sym_wchar] = ACTIONS(4586),
    [sym_dchar] = ACTIONS(4586),
    [sym_float] = ACTIONS(4586),
    [sym_double] = ACTIONS(4586),
    [sym_real] = ACTIONS(4586),
    [sym_ifloat] = ACTIONS(4586),
    [sym_idouble] = ACTIONS(4586),
    [sym_ireal] = ACTIONS(4586),
    [sym_cfloat] = ACTIONS(4586),
    [sym_cdouble] = ACTIONS(4586),
    [sym_creal] = ACTIONS(4586),
    [sym_size_t] = ACTIONS(4586),
    [sym_ptrdiff_t] = ACTIONS(4586),
    [sym_string] = ACTIONS(4586),
    [sym_cstring] = ACTIONS(4586),
    [sym_dstring] = ACTIONS(4586),
    [sym_wstring] = ACTIONS(4586),
    [sym_noreturn] = ACTIONS(4586),
    [sym_this] = ACTIONS(4586),
    [sym_abstract] = ACTIONS(4586),
    [sym_alias] = ACTIONS(4586),
    [sym_align] = ACTIONS(4586),
    [sym_auto] = ACTIONS(4586),
    [sym_class] = ACTIONS(4586),
    [sym_const] = ACTIONS(4586),
    [sym_debug] = ACTIONS(4586),
    [sym_deprecated] = ACTIONS(4586),
    [sym_else] = ACTIONS(4586),
    [sym_enum] = ACTIONS(4586),
    [sym_export] = ACTIONS(4586),
    [sym_extern] = ACTIONS(4586),
    [sym_final] = ACTIONS(4586),
    [sym_immutable] = ACTIONS(4586),
    [sym_import] = ACTIONS(4586),
    [sym_inout] = ACTIONS(4586),
    [sym_interface] = ACTIONS(4586),
    [sym_invariant] = ACTIONS(4586),
    [sym_mixin] = ACTIONS(4586),
    [sym_nothrow] = ACTIONS(4586),
    [sym_override] = ACTIONS(4586),
    [sym_package] = ACTIONS(4586),
    [sym_pragma] = ACTIONS(4586),
    [sym_private] = ACTIONS(4586),
    [sym_protected] = ACTIONS(4586),
    [sym_public] = ACTIONS(4586),
    [sym_pure] = ACTIONS(4586),
    [sym_ref] = ACTIONS(4586),
    [sym_return] = ACTIONS(4586),
    [sym_scope] = ACTIONS(4586),
    [sym_shared] = ACTIONS(4586),
    [sym_static] = ACTIONS(4586),
    [sym_struct] = ACTIONS(4586),
    [sym_synchronized] = ACTIONS(4586),
    [sym_template] = ACTIONS(4586),
    [sym_typeof] = ACTIONS(4586),
    [sym_union] = ACTIONS(4586),
    [sym_unittest] = ACTIONS(4586),
    [sym_version] = ACTIONS(4586),
    [sym_while] = ACTIONS(4586),
    [sym_gshared] = ACTIONS(4586),
    [sym_traits] = ACTIONS(4586),
    [sym_vector] = ACTIONS(4586),
    [sym_void] = ACTIONS(4586),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2435] = {
    [sym_identifier] = ACTIONS(4470),
    [anon_sym_DOT] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [anon_sym_AT] = ACTIONS(4472),
    [sym_bool] = ACTIONS(4470),
    [sym_byte] = ACTIONS(4470),
    [sym_ubyte] = ACTIONS(4470),
    [sym_char] = ACTIONS(4470),
    [sym_short] = ACTIONS(4470),
    [sym_ushort] = ACTIONS(4470),
    [sym_int] = ACTIONS(4470),
    [sym_uint] = ACTIONS(4470),
    [sym_long] = ACTIONS(4470),
    [sym_ulong] = ACTIONS(4470),
    [sym_cent] = ACTIONS(4470),
    [sym_ucent] = ACTIONS(4470),
    [sym_wchar] = ACTIONS(4470),
    [sym_dchar] = ACTIONS(4470),
    [sym_float] = ACTIONS(4470),
    [sym_double] = ACTIONS(4470),
    [sym_real] = ACTIONS(4470),
    [sym_ifloat] = ACTIONS(4470),
    [sym_idouble] = ACTIONS(4470),
    [sym_ireal] = ACTIONS(4470),
    [sym_cfloat] = ACTIONS(4470),
    [sym_cdouble] = ACTIONS(4470),
    [sym_creal] = ACTIONS(4470),
    [sym_size_t] = ACTIONS(4470),
    [sym_ptrdiff_t] = ACTIONS(4470),
    [sym_string] = ACTIONS(4470),
    [sym_cstring] = ACTIONS(4470),
    [sym_dstring] = ACTIONS(4470),
    [sym_wstring] = ACTIONS(4470),
    [sym_noreturn] = ACTIONS(4470),
    [sym_this] = ACTIONS(4470),
    [sym_abstract] = ACTIONS(4470),
    [sym_alias] = ACTIONS(4470),
    [sym_align] = ACTIONS(4470),
    [sym_auto] = ACTIONS(4470),
    [sym_catch] = ACTIONS(4470),
    [sym_class] = ACTIONS(4470),
    [sym_const] = ACTIONS(4470),
    [sym_debug] = ACTIONS(4470),
    [sym_deprecated] = ACTIONS(4470),
    [sym_else] = ACTIONS(4470),
    [sym_enum] = ACTIONS(4470),
    [sym_export] = ACTIONS(4470),
    [sym_extern] = ACTIONS(4470),
    [sym_final] = ACTIONS(4470),
    [sym_finally] = ACTIONS(4470),
    [sym_immutable] = ACTIONS(4470),
    [sym_import] = ACTIONS(4470),
    [sym_inout] = ACTIONS(4470),
    [sym_interface] = ACTIONS(4470),
    [sym_invariant] = ACTIONS(4470),
    [sym_mixin] = ACTIONS(4470),
    [sym_nothrow] = ACTIONS(4470),
    [sym_override] = ACTIONS(4470),
    [sym_package] = ACTIONS(4470),
    [sym_pragma] = ACTIONS(4470),
    [sym_private] = ACTIONS(4470),
    [sym_protected] = ACTIONS(4470),
    [sym_public] = ACTIONS(4470),
    [sym_pure] = ACTIONS(4470),
    [sym_ref] = ACTIONS(4470),
    [sym_return] = ACTIONS(4470),
    [sym_scope] = ACTIONS(4470),
    [sym_shared] = ACTIONS(4470),
    [sym_static] = ACTIONS(4470),
    [sym_struct] = ACTIONS(4470),
    [sym_synchronized] = ACTIONS(4470),
    [sym_template] = ACTIONS(4470),
    [sym_typeof] = ACTIONS(4470),
    [sym_union] = ACTIONS(4470),
    [sym_unittest] = ACTIONS(4470),
    [sym_version] = ACTIONS(4470),
    [sym_while] = ACTIONS(4470),
    [sym_gshared] = ACTIONS(4470),
    [sym_traits] = ACTIONS(4470),
    [sym_vector] = ACTIONS(4470),
    [sym_void] = ACTIONS(4470),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2436] = {
    [ts_builtin_sym_end] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4656),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [anon_sym_DOT] = ACTIONS(4658),
    [anon_sym_SEMI] = ACTIONS(4658),
    [anon_sym_TILDE] = ACTIONS(4658),
    [anon_sym_AT] = ACTIONS(4658),
    [sym_bool] = ACTIONS(4656),
    [sym_byte] = ACTIONS(4656),
    [sym_ubyte] = ACTIONS(4656),
    [sym_char] = ACTIONS(4656),
    [sym_short] = ACTIONS(4656),
    [sym_ushort] = ACTIONS(4656),
    [sym_int] = ACTIONS(4656),
    [sym_uint] = ACTIONS(4656),
    [sym_long] = ACTIONS(4656),
    [sym_ulong] = ACTIONS(4656),
    [sym_cent] = ACTIONS(4656),
    [sym_ucent] = ACTIONS(4656),
    [sym_wchar] = ACTIONS(4656),
    [sym_dchar] = ACTIONS(4656),
    [sym_float] = ACTIONS(4656),
    [sym_double] = ACTIONS(4656),
    [sym_real] = ACTIONS(4656),
    [sym_ifloat] = ACTIONS(4656),
    [sym_idouble] = ACTIONS(4656),
    [sym_ireal] = ACTIONS(4656),
    [sym_cfloat] = ACTIONS(4656),
    [sym_cdouble] = ACTIONS(4656),
    [sym_creal] = ACTIONS(4656),
    [sym_size_t] = ACTIONS(4656),
    [sym_ptrdiff_t] = ACTIONS(4656),
    [sym_string] = ACTIONS(4656),
    [sym_cstring] = ACTIONS(4656),
    [sym_dstring] = ACTIONS(4656),
    [sym_wstring] = ACTIONS(4656),
    [sym_noreturn] = ACTIONS(4656),
    [sym_this] = ACTIONS(4656),
    [sym_abstract] = ACTIONS(4656),
    [sym_alias] = ACTIONS(4656),
    [sym_align] = ACTIONS(4656),
    [sym_auto] = ACTIONS(4656),
    [sym_class] = ACTIONS(4656),
    [sym_const] = ACTIONS(4656),
    [sym_debug] = ACTIONS(4656),
    [sym_deprecated] = ACTIONS(4656),
    [sym_else] = ACTIONS(4656),
    [sym_enum] = ACTIONS(4656),
    [sym_export] = ACTIONS(4656),
    [sym_extern] = ACTIONS(4656),
    [sym_final] = ACTIONS(4656),
    [sym_immutable] = ACTIONS(4656),
    [sym_import] = ACTIONS(4656),
    [sym_inout] = ACTIONS(4656),
    [sym_interface] = ACTIONS(4656),
    [sym_invariant] = ACTIONS(4656),
    [sym_mixin] = ACTIONS(4656),
    [sym_nothrow] = ACTIONS(4656),
    [sym_override] = ACTIONS(4656),
    [sym_package] = ACTIONS(4656),
    [sym_pragma] = ACTIONS(4656),
    [sym_private] = ACTIONS(4656),
    [sym_protected] = ACTIONS(4656),
    [sym_public] = ACTIONS(4656),
    [sym_pure] = ACTIONS(4656),
    [sym_ref] = ACTIONS(4656),
    [sym_return] = ACTIONS(4656),
    [sym_scope] = ACTIONS(4656),
    [sym_shared] = ACTIONS(4656),
    [sym_static] = ACTIONS(4656),
    [sym_struct] = ACTIONS(4656),
    [sym_synchronized] = ACTIONS(4656),
    [sym_template] = ACTIONS(4656),
    [sym_typeof] = ACTIONS(4656),
    [sym_union] = ACTIONS(4656),
    [sym_unittest] = ACTIONS(4656),
    [sym_version] = ACTIONS(4656),
    [sym_while] = ACTIONS(4656),
    [sym_gshared] = ACTIONS(4656),
    [sym_traits] = ACTIONS(4656),
    [sym_vector] = ACTIONS(4656),
    [sym_void] = ACTIONS(4656),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2437] = {
    [ts_builtin_sym_end] = ACTIONS(4739),
    [sym_identifier] = ACTIONS(4737),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_DOT] = ACTIONS(4739),
    [anon_sym_SEMI] = ACTIONS(4739),
    [anon_sym_TILDE] = ACTIONS(4739),
    [anon_sym_AT] = ACTIONS(4739),
    [sym_bool] = ACTIONS(4737),
    [sym_byte] = ACTIONS(4737),
    [sym_ubyte] = ACTIONS(4737),
    [sym_char] = ACTIONS(4737),
    [sym_short] = ACTIONS(4737),
    [sym_ushort] = ACTIONS(4737),
    [sym_int] = ACTIONS(4737),
    [sym_uint] = ACTIONS(4737),
    [sym_long] = ACTIONS(4737),
    [sym_ulong] = ACTIONS(4737),
    [sym_cent] = ACTIONS(4737),
    [sym_ucent] = ACTIONS(4737),
    [sym_wchar] = ACTIONS(4737),
    [sym_dchar] = ACTIONS(4737),
    [sym_float] = ACTIONS(4737),
    [sym_double] = ACTIONS(4737),
    [sym_real] = ACTIONS(4737),
    [sym_ifloat] = ACTIONS(4737),
    [sym_idouble] = ACTIONS(4737),
    [sym_ireal] = ACTIONS(4737),
    [sym_cfloat] = ACTIONS(4737),
    [sym_cdouble] = ACTIONS(4737),
    [sym_creal] = ACTIONS(4737),
    [sym_size_t] = ACTIONS(4737),
    [sym_ptrdiff_t] = ACTIONS(4737),
    [sym_string] = ACTIONS(4737),
    [sym_cstring] = ACTIONS(4737),
    [sym_dstring] = ACTIONS(4737),
    [sym_wstring] = ACTIONS(4737),
    [sym_noreturn] = ACTIONS(4737),
    [sym_this] = ACTIONS(4737),
    [sym_abstract] = ACTIONS(4737),
    [sym_alias] = ACTIONS(4737),
    [sym_align] = ACTIONS(4737),
    [sym_auto] = ACTIONS(4737),
    [sym_class] = ACTIONS(4737),
    [sym_const] = ACTIONS(4737),
    [sym_debug] = ACTIONS(4737),
    [sym_deprecated] = ACTIONS(4737),
    [sym_else] = ACTIONS(4737),
    [sym_enum] = ACTIONS(4737),
    [sym_export] = ACTIONS(4737),
    [sym_extern] = ACTIONS(4737),
    [sym_final] = ACTIONS(4737),
    [sym_immutable] = ACTIONS(4737),
    [sym_import] = ACTIONS(4737),
    [sym_inout] = ACTIONS(4737),
    [sym_interface] = ACTIONS(4737),
    [sym_invariant] = ACTIONS(4737),
    [sym_mixin] = ACTIONS(4737),
    [sym_nothrow] = ACTIONS(4737),
    [sym_override] = ACTIONS(4737),
    [sym_package] = ACTIONS(4737),
    [sym_pragma] = ACTIONS(4737),
    [sym_private] = ACTIONS(4737),
    [sym_protected] = ACTIONS(4737),
    [sym_public] = ACTIONS(4737),
    [sym_pure] = ACTIONS(4737),
    [sym_ref] = ACTIONS(4737),
    [sym_return] = ACTIONS(4737),
    [sym_scope] = ACTIONS(4737),
    [sym_shared] = ACTIONS(4737),
    [sym_static] = ACTIONS(4737),
    [sym_struct] = ACTIONS(4737),
    [sym_synchronized] = ACTIONS(4737),
    [sym_template] = ACTIONS(4737),
    [sym_typeof] = ACTIONS(4737),
    [sym_union] = ACTIONS(4737),
    [sym_unittest] = ACTIONS(4737),
    [sym_version] = ACTIONS(4737),
    [sym_while] = ACTIONS(4737),
    [sym_gshared] = ACTIONS(4737),
    [sym_traits] = ACTIONS(4737),
    [sym_vector] = ACTIONS(4737),
    [sym_void] = ACTIONS(4737),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2438] = {
    [sym_identifier] = ACTIONS(4474),
    [anon_sym_DOT] = ACTIONS(4476),
    [anon_sym_SEMI] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4476),
    [anon_sym_AT] = ACTIONS(4476),
    [sym_bool] = ACTIONS(4474),
    [sym_byte] = ACTIONS(4474),
    [sym_ubyte] = ACTIONS(4474),
    [sym_char] = ACTIONS(4474),
    [sym_short] = ACTIONS(4474),
    [sym_ushort] = ACTIONS(4474),
    [sym_int] = ACTIONS(4474),
    [sym_uint] = ACTIONS(4474),
    [sym_long] = ACTIONS(4474),
    [sym_ulong] = ACTIONS(4474),
    [sym_cent] = ACTIONS(4474),
    [sym_ucent] = ACTIONS(4474),
    [sym_wchar] = ACTIONS(4474),
    [sym_dchar] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_double] = ACTIONS(4474),
    [sym_real] = ACTIONS(4474),
    [sym_ifloat] = ACTIONS(4474),
    [sym_idouble] = ACTIONS(4474),
    [sym_ireal] = ACTIONS(4474),
    [sym_cfloat] = ACTIONS(4474),
    [sym_cdouble] = ACTIONS(4474),
    [sym_creal] = ACTIONS(4474),
    [sym_size_t] = ACTIONS(4474),
    [sym_ptrdiff_t] = ACTIONS(4474),
    [sym_string] = ACTIONS(4474),
    [sym_cstring] = ACTIONS(4474),
    [sym_dstring] = ACTIONS(4474),
    [sym_wstring] = ACTIONS(4474),
    [sym_noreturn] = ACTIONS(4474),
    [sym_this] = ACTIONS(4474),
    [sym_abstract] = ACTIONS(4474),
    [sym_alias] = ACTIONS(4474),
    [sym_align] = ACTIONS(4474),
    [sym_auto] = ACTIONS(4474),
    [sym_catch] = ACTIONS(4474),
    [sym_class] = ACTIONS(4474),
    [sym_const] = ACTIONS(4474),
    [sym_debug] = ACTIONS(4474),
    [sym_deprecated] = ACTIONS(4474),
    [sym_else] = ACTIONS(4474),
    [sym_enum] = ACTIONS(4474),
    [sym_export] = ACTIONS(4474),
    [sym_extern] = ACTIONS(4474),
    [sym_final] = ACTIONS(4474),
    [sym_finally] = ACTIONS(4474),
    [sym_immutable] = ACTIONS(4474),
    [sym_import] = ACTIONS(4474),
    [sym_inout] = ACTIONS(4474),
    [sym_interface] = ACTIONS(4474),
    [sym_invariant] = ACTIONS(4474),
    [sym_mixin] = ACTIONS(4474),
    [sym_nothrow] = ACTIONS(4474),
    [sym_override] = ACTIONS(4474),
    [sym_package] = ACTIONS(4474),
    [sym_pragma] = ACTIONS(4474),
    [sym_private] = ACTIONS(4474),
    [sym_protected] = ACTIONS(4474),
    [sym_public] = ACTIONS(4474),
    [sym_pure] = ACTIONS(4474),
    [sym_ref] = ACTIONS(4474),
    [sym_return] = ACTIONS(4474),
    [sym_scope] = ACTIONS(4474),
    [sym_shared] = ACTIONS(4474),
    [sym_static] = ACTIONS(4474),
    [sym_struct] = ACTIONS(4474),
    [sym_synchronized] = ACTIONS(4474),
    [sym_template] = ACTIONS(4474),
    [sym_typeof] = ACTIONS(4474),
    [sym_union] = ACTIONS(4474),
    [sym_unittest] = ACTIONS(4474),
    [sym_version] = ACTIONS(4474),
    [sym_while] = ACTIONS(4474),
    [sym_gshared] = ACTIONS(4474),
    [sym_traits] = ACTIONS(4474),
    [sym_vector] = ACTIONS(4474),
    [sym_void] = ACTIONS(4474),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2439] = {
    [sym_identifier] = ACTIONS(4318),
    [anon_sym_DOT] = ACTIONS(4320),
    [anon_sym_SEMI] = ACTIONS(4320),
    [anon_sym_TILDE] = ACTIONS(4320),
    [anon_sym_AT] = ACTIONS(4320),
    [sym_bool] = ACTIONS(4318),
    [sym_byte] = ACTIONS(4318),
    [sym_ubyte] = ACTIONS(4318),
    [sym_char] = ACTIONS(4318),
    [sym_short] = ACTIONS(4318),
    [sym_ushort] = ACTIONS(4318),
    [sym_int] = ACTIONS(4318),
    [sym_uint] = ACTIONS(4318),
    [sym_long] = ACTIONS(4318),
    [sym_ulong] = ACTIONS(4318),
    [sym_cent] = ACTIONS(4318),
    [sym_ucent] = ACTIONS(4318),
    [sym_wchar] = ACTIONS(4318),
    [sym_dchar] = ACTIONS(4318),
    [sym_float] = ACTIONS(4318),
    [sym_double] = ACTIONS(4318),
    [sym_real] = ACTIONS(4318),
    [sym_ifloat] = ACTIONS(4318),
    [sym_idouble] = ACTIONS(4318),
    [sym_ireal] = ACTIONS(4318),
    [sym_cfloat] = ACTIONS(4318),
    [sym_cdouble] = ACTIONS(4318),
    [sym_creal] = ACTIONS(4318),
    [sym_size_t] = ACTIONS(4318),
    [sym_ptrdiff_t] = ACTIONS(4318),
    [sym_string] = ACTIONS(4318),
    [sym_cstring] = ACTIONS(4318),
    [sym_dstring] = ACTIONS(4318),
    [sym_wstring] = ACTIONS(4318),
    [sym_noreturn] = ACTIONS(4318),
    [sym_this] = ACTIONS(4318),
    [sym_abstract] = ACTIONS(4318),
    [sym_alias] = ACTIONS(4318),
    [sym_align] = ACTIONS(4318),
    [sym_auto] = ACTIONS(4318),
    [sym_catch] = ACTIONS(4318),
    [sym_class] = ACTIONS(4318),
    [sym_const] = ACTIONS(4318),
    [sym_debug] = ACTIONS(4318),
    [sym_deprecated] = ACTIONS(4318),
    [sym_else] = ACTIONS(4318),
    [sym_enum] = ACTIONS(4318),
    [sym_export] = ACTIONS(4318),
    [sym_extern] = ACTIONS(4318),
    [sym_final] = ACTIONS(4318),
    [sym_finally] = ACTIONS(4318),
    [sym_immutable] = ACTIONS(4318),
    [sym_import] = ACTIONS(4318),
    [sym_inout] = ACTIONS(4318),
    [sym_interface] = ACTIONS(4318),
    [sym_invariant] = ACTIONS(4318),
    [sym_mixin] = ACTIONS(4318),
    [sym_nothrow] = ACTIONS(4318),
    [sym_override] = ACTIONS(4318),
    [sym_package] = ACTIONS(4318),
    [sym_pragma] = ACTIONS(4318),
    [sym_private] = ACTIONS(4318),
    [sym_protected] = ACTIONS(4318),
    [sym_public] = ACTIONS(4318),
    [sym_pure] = ACTIONS(4318),
    [sym_ref] = ACTIONS(4318),
    [sym_return] = ACTIONS(4318),
    [sym_scope] = ACTIONS(4318),
    [sym_shared] = ACTIONS(4318),
    [sym_static] = ACTIONS(4318),
    [sym_struct] = ACTIONS(4318),
    [sym_synchronized] = ACTIONS(4318),
    [sym_template] = ACTIONS(4318),
    [sym_typeof] = ACTIONS(4318),
    [sym_union] = ACTIONS(4318),
    [sym_unittest] = ACTIONS(4318),
    [sym_version] = ACTIONS(4318),
    [sym_while] = ACTIONS(4318),
    [sym_gshared] = ACTIONS(4318),
    [sym_traits] = ACTIONS(4318),
    [sym_vector] = ACTIONS(4318),
    [sym_void] = ACTIONS(4318),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2440] = {
    [sym_identifier] = ACTIONS(4538),
    [anon_sym_DOT] = ACTIONS(4540),
    [anon_sym_SEMI] = ACTIONS(4540),
    [anon_sym_TILDE] = ACTIONS(4540),
    [anon_sym_AT] = ACTIONS(4540),
    [sym_bool] = ACTIONS(4538),
    [sym_byte] = ACTIONS(4538),
    [sym_ubyte] = ACTIONS(4538),
    [sym_char] = ACTIONS(4538),
    [sym_short] = ACTIONS(4538),
    [sym_ushort] = ACTIONS(4538),
    [sym_int] = ACTIONS(4538),
    [sym_uint] = ACTIONS(4538),
    [sym_long] = ACTIONS(4538),
    [sym_ulong] = ACTIONS(4538),
    [sym_cent] = ACTIONS(4538),
    [sym_ucent] = ACTIONS(4538),
    [sym_wchar] = ACTIONS(4538),
    [sym_dchar] = ACTIONS(4538),
    [sym_float] = ACTIONS(4538),
    [sym_double] = ACTIONS(4538),
    [sym_real] = ACTIONS(4538),
    [sym_ifloat] = ACTIONS(4538),
    [sym_idouble] = ACTIONS(4538),
    [sym_ireal] = ACTIONS(4538),
    [sym_cfloat] = ACTIONS(4538),
    [sym_cdouble] = ACTIONS(4538),
    [sym_creal] = ACTIONS(4538),
    [sym_size_t] = ACTIONS(4538),
    [sym_ptrdiff_t] = ACTIONS(4538),
    [sym_string] = ACTIONS(4538),
    [sym_cstring] = ACTIONS(4538),
    [sym_dstring] = ACTIONS(4538),
    [sym_wstring] = ACTIONS(4538),
    [sym_noreturn] = ACTIONS(4538),
    [sym_this] = ACTIONS(4538),
    [sym_abstract] = ACTIONS(4538),
    [sym_alias] = ACTIONS(4538),
    [sym_align] = ACTIONS(4538),
    [sym_auto] = ACTIONS(4538),
    [sym_catch] = ACTIONS(4538),
    [sym_class] = ACTIONS(4538),
    [sym_const] = ACTIONS(4538),
    [sym_debug] = ACTIONS(4538),
    [sym_deprecated] = ACTIONS(4538),
    [sym_else] = ACTIONS(4538),
    [sym_enum] = ACTIONS(4538),
    [sym_export] = ACTIONS(4538),
    [sym_extern] = ACTIONS(4538),
    [sym_final] = ACTIONS(4538),
    [sym_finally] = ACTIONS(4538),
    [sym_immutable] = ACTIONS(4538),
    [sym_import] = ACTIONS(4538),
    [sym_inout] = ACTIONS(4538),
    [sym_interface] = ACTIONS(4538),
    [sym_invariant] = ACTIONS(4538),
    [sym_mixin] = ACTIONS(4538),
    [sym_nothrow] = ACTIONS(4538),
    [sym_override] = ACTIONS(4538),
    [sym_package] = ACTIONS(4538),
    [sym_pragma] = ACTIONS(4538),
    [sym_private] = ACTIONS(4538),
    [sym_protected] = ACTIONS(4538),
    [sym_public] = ACTIONS(4538),
    [sym_pure] = ACTIONS(4538),
    [sym_ref] = ACTIONS(4538),
    [sym_return] = ACTIONS(4538),
    [sym_scope] = ACTIONS(4538),
    [sym_shared] = ACTIONS(4538),
    [sym_static] = ACTIONS(4538),
    [sym_struct] = ACTIONS(4538),
    [sym_synchronized] = ACTIONS(4538),
    [sym_template] = ACTIONS(4538),
    [sym_typeof] = ACTIONS(4538),
    [sym_union] = ACTIONS(4538),
    [sym_unittest] = ACTIONS(4538),
    [sym_version] = ACTIONS(4538),
    [sym_while] = ACTIONS(4538),
    [sym_gshared] = ACTIONS(4538),
    [sym_traits] = ACTIONS(4538),
    [sym_vector] = ACTIONS(4538),
    [sym_void] = ACTIONS(4538),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2441] = {
    [ts_builtin_sym_end] = ACTIONS(4324),
    [sym_identifier] = ACTIONS(4322),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_DOT] = ACTIONS(4324),
    [anon_sym_SEMI] = ACTIONS(4324),
    [anon_sym_TILDE] = ACTIONS(4324),
    [anon_sym_AT] = ACTIONS(4324),
    [sym_bool] = ACTIONS(4322),
    [sym_byte] = ACTIONS(4322),
    [sym_ubyte] = ACTIONS(4322),
    [sym_char] = ACTIONS(4322),
    [sym_short] = ACTIONS(4322),
    [sym_ushort] = ACTIONS(4322),
    [sym_int] = ACTIONS(4322),
    [sym_uint] = ACTIONS(4322),
    [sym_long] = ACTIONS(4322),
    [sym_ulong] = ACTIONS(4322),
    [sym_cent] = ACTIONS(4322),
    [sym_ucent] = ACTIONS(4322),
    [sym_wchar] = ACTIONS(4322),
    [sym_dchar] = ACTIONS(4322),
    [sym_float] = ACTIONS(4322),
    [sym_double] = ACTIONS(4322),
    [sym_real] = ACTIONS(4322),
    [sym_ifloat] = ACTIONS(4322),
    [sym_idouble] = ACTIONS(4322),
    [sym_ireal] = ACTIONS(4322),
    [sym_cfloat] = ACTIONS(4322),
    [sym_cdouble] = ACTIONS(4322),
    [sym_creal] = ACTIONS(4322),
    [sym_size_t] = ACTIONS(4322),
    [sym_ptrdiff_t] = ACTIONS(4322),
    [sym_string] = ACTIONS(4322),
    [sym_cstring] = ACTIONS(4322),
    [sym_dstring] = ACTIONS(4322),
    [sym_wstring] = ACTIONS(4322),
    [sym_noreturn] = ACTIONS(4322),
    [sym_this] = ACTIONS(4322),
    [sym_abstract] = ACTIONS(4322),
    [sym_alias] = ACTIONS(4322),
    [sym_align] = ACTIONS(4322),
    [sym_auto] = ACTIONS(4322),
    [sym_class] = ACTIONS(4322),
    [sym_const] = ACTIONS(4322),
    [sym_debug] = ACTIONS(4322),
    [sym_deprecated] = ACTIONS(4322),
    [sym_else] = ACTIONS(4322),
    [sym_enum] = ACTIONS(4322),
    [sym_export] = ACTIONS(4322),
    [sym_extern] = ACTIONS(4322),
    [sym_final] = ACTIONS(4322),
    [sym_immutable] = ACTIONS(4322),
    [sym_import] = ACTIONS(4322),
    [sym_inout] = ACTIONS(4322),
    [sym_interface] = ACTIONS(4322),
    [sym_invariant] = ACTIONS(4322),
    [sym_mixin] = ACTIONS(4322),
    [sym_nothrow] = ACTIONS(4322),
    [sym_override] = ACTIONS(4322),
    [sym_package] = ACTIONS(4322),
    [sym_pragma] = ACTIONS(4322),
    [sym_private] = ACTIONS(4322),
    [sym_protected] = ACTIONS(4322),
    [sym_public] = ACTIONS(4322),
    [sym_pure] = ACTIONS(4322),
    [sym_ref] = ACTIONS(4322),
    [sym_return] = ACTIONS(4322),
    [sym_scope] = ACTIONS(4322),
    [sym_shared] = ACTIONS(4322),
    [sym_static] = ACTIONS(4322),
    [sym_struct] = ACTIONS(4322),
    [sym_synchronized] = ACTIONS(4322),
    [sym_template] = ACTIONS(4322),
    [sym_typeof] = ACTIONS(4322),
    [sym_union] = ACTIONS(4322),
    [sym_unittest] = ACTIONS(4322),
    [sym_version] = ACTIONS(4322),
    [sym_while] = ACTIONS(4322),
    [sym_gshared] = ACTIONS(4322),
    [sym_traits] = ACTIONS(4322),
    [sym_vector] = ACTIONS(4322),
    [sym_void] = ACTIONS(4322),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2442] = {
    [ts_builtin_sym_end] = ACTIONS(4723),
    [sym_identifier] = ACTIONS(4721),
    [anon_sym_RBRACE] = ACTIONS(4723),
    [anon_sym_DOT] = ACTIONS(4723),
    [anon_sym_SEMI] = ACTIONS(4723),
    [anon_sym_TILDE] = ACTIONS(4723),
    [anon_sym_AT] = ACTIONS(4723),
    [sym_bool] = ACTIONS(4721),
    [sym_byte] = ACTIONS(4721),
    [sym_ubyte] = ACTIONS(4721),
    [sym_char] = ACTIONS(4721),
    [sym_short] = ACTIONS(4721),
    [sym_ushort] = ACTIONS(4721),
    [sym_int] = ACTIONS(4721),
    [sym_uint] = ACTIONS(4721),
    [sym_long] = ACTIONS(4721),
    [sym_ulong] = ACTIONS(4721),
    [sym_cent] = ACTIONS(4721),
    [sym_ucent] = ACTIONS(4721),
    [sym_wchar] = ACTIONS(4721),
    [sym_dchar] = ACTIONS(4721),
    [sym_float] = ACTIONS(4721),
    [sym_double] = ACTIONS(4721),
    [sym_real] = ACTIONS(4721),
    [sym_ifloat] = ACTIONS(4721),
    [sym_idouble] = ACTIONS(4721),
    [sym_ireal] = ACTIONS(4721),
    [sym_cfloat] = ACTIONS(4721),
    [sym_cdouble] = ACTIONS(4721),
    [sym_creal] = ACTIONS(4721),
    [sym_size_t] = ACTIONS(4721),
    [sym_ptrdiff_t] = ACTIONS(4721),
    [sym_string] = ACTIONS(4721),
    [sym_cstring] = ACTIONS(4721),
    [sym_dstring] = ACTIONS(4721),
    [sym_wstring] = ACTIONS(4721),
    [sym_noreturn] = ACTIONS(4721),
    [sym_this] = ACTIONS(4721),
    [sym_abstract] = ACTIONS(4721),
    [sym_alias] = ACTIONS(4721),
    [sym_align] = ACTIONS(4721),
    [sym_auto] = ACTIONS(4721),
    [sym_class] = ACTIONS(4721),
    [sym_const] = ACTIONS(4721),
    [sym_debug] = ACTIONS(4721),
    [sym_deprecated] = ACTIONS(4721),
    [sym_else] = ACTIONS(4721),
    [sym_enum] = ACTIONS(4721),
    [sym_export] = ACTIONS(4721),
    [sym_extern] = ACTIONS(4721),
    [sym_final] = ACTIONS(4721),
    [sym_immutable] = ACTIONS(4721),
    [sym_import] = ACTIONS(4721),
    [sym_inout] = ACTIONS(4721),
    [sym_interface] = ACTIONS(4721),
    [sym_invariant] = ACTIONS(4721),
    [sym_mixin] = ACTIONS(4721),
    [sym_nothrow] = ACTIONS(4721),
    [sym_override] = ACTIONS(4721),
    [sym_package] = ACTIONS(4721),
    [sym_pragma] = ACTIONS(4721),
    [sym_private] = ACTIONS(4721),
    [sym_protected] = ACTIONS(4721),
    [sym_public] = ACTIONS(4721),
    [sym_pure] = ACTIONS(4721),
    [sym_ref] = ACTIONS(4721),
    [sym_return] = ACTIONS(4721),
    [sym_scope] = ACTIONS(4721),
    [sym_shared] = ACTIONS(4721),
    [sym_static] = ACTIONS(4721),
    [sym_struct] = ACTIONS(4721),
    [sym_synchronized] = ACTIONS(4721),
    [sym_template] = ACTIONS(4721),
    [sym_typeof] = ACTIONS(4721),
    [sym_union] = ACTIONS(4721),
    [sym_unittest] = ACTIONS(4721),
    [sym_version] = ACTIONS(4721),
    [sym_while] = ACTIONS(4721),
    [sym_gshared] = ACTIONS(4721),
    [sym_traits] = ACTIONS(4721),
    [sym_vector] = ACTIONS(4721),
    [sym_void] = ACTIONS(4721),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2443] = {
    [sym_identifier] = ACTIONS(4510),
    [anon_sym_DOT] = ACTIONS(4512),
    [anon_sym_SEMI] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4512),
    [anon_sym_AT] = ACTIONS(4512),
    [sym_bool] = ACTIONS(4510),
    [sym_byte] = ACTIONS(4510),
    [sym_ubyte] = ACTIONS(4510),
    [sym_char] = ACTIONS(4510),
    [sym_short] = ACTIONS(4510),
    [sym_ushort] = ACTIONS(4510),
    [sym_int] = ACTIONS(4510),
    [sym_uint] = ACTIONS(4510),
    [sym_long] = ACTIONS(4510),
    [sym_ulong] = ACTIONS(4510),
    [sym_cent] = ACTIONS(4510),
    [sym_ucent] = ACTIONS(4510),
    [sym_wchar] = ACTIONS(4510),
    [sym_dchar] = ACTIONS(4510),
    [sym_float] = ACTIONS(4510),
    [sym_double] = ACTIONS(4510),
    [sym_real] = ACTIONS(4510),
    [sym_ifloat] = ACTIONS(4510),
    [sym_idouble] = ACTIONS(4510),
    [sym_ireal] = ACTIONS(4510),
    [sym_cfloat] = ACTIONS(4510),
    [sym_cdouble] = ACTIONS(4510),
    [sym_creal] = ACTIONS(4510),
    [sym_size_t] = ACTIONS(4510),
    [sym_ptrdiff_t] = ACTIONS(4510),
    [sym_string] = ACTIONS(4510),
    [sym_cstring] = ACTIONS(4510),
    [sym_dstring] = ACTIONS(4510),
    [sym_wstring] = ACTIONS(4510),
    [sym_noreturn] = ACTIONS(4510),
    [sym_this] = ACTIONS(4510),
    [sym_abstract] = ACTIONS(4510),
    [sym_alias] = ACTIONS(4510),
    [sym_align] = ACTIONS(4510),
    [sym_auto] = ACTIONS(4510),
    [sym_catch] = ACTIONS(4510),
    [sym_class] = ACTIONS(4510),
    [sym_const] = ACTIONS(4510),
    [sym_debug] = ACTIONS(4510),
    [sym_deprecated] = ACTIONS(4510),
    [sym_else] = ACTIONS(4510),
    [sym_enum] = ACTIONS(4510),
    [sym_export] = ACTIONS(4510),
    [sym_extern] = ACTIONS(4510),
    [sym_final] = ACTIONS(4510),
    [sym_finally] = ACTIONS(4510),
    [sym_immutable] = ACTIONS(4510),
    [sym_import] = ACTIONS(4510),
    [sym_inout] = ACTIONS(4510),
    [sym_interface] = ACTIONS(4510),
    [sym_invariant] = ACTIONS(4510),
    [sym_mixin] = ACTIONS(4510),
    [sym_nothrow] = ACTIONS(4510),
    [sym_override] = ACTIONS(4510),
    [sym_package] = ACTIONS(4510),
    [sym_pragma] = ACTIONS(4510),
    [sym_private] = ACTIONS(4510),
    [sym_protected] = ACTIONS(4510),
    [sym_public] = ACTIONS(4510),
    [sym_pure] = ACTIONS(4510),
    [sym_ref] = ACTIONS(4510),
    [sym_return] = ACTIONS(4510),
    [sym_scope] = ACTIONS(4510),
    [sym_shared] = ACTIONS(4510),
    [sym_static] = ACTIONS(4510),
    [sym_struct] = ACTIONS(4510),
    [sym_synchronized] = ACTIONS(4510),
    [sym_template] = ACTIONS(4510),
    [sym_typeof] = ACTIONS(4510),
    [sym_union] = ACTIONS(4510),
    [sym_unittest] = ACTIONS(4510),
    [sym_version] = ACTIONS(4510),
    [sym_while] = ACTIONS(4510),
    [sym_gshared] = ACTIONS(4510),
    [sym_traits] = ACTIONS(4510),
    [sym_vector] = ACTIONS(4510),
    [sym_void] = ACTIONS(4510),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2444] = {
    [ts_builtin_sym_end] = ACTIONS(4484),
    [sym_identifier] = ACTIONS(4482),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_DOT] = ACTIONS(4484),
    [anon_sym_SEMI] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4484),
    [anon_sym_AT] = ACTIONS(4484),
    [sym_bool] = ACTIONS(4482),
    [sym_byte] = ACTIONS(4482),
    [sym_ubyte] = ACTIONS(4482),
    [sym_char] = ACTIONS(4482),
    [sym_short] = ACTIONS(4482),
    [sym_ushort] = ACTIONS(4482),
    [sym_int] = ACTIONS(4482),
    [sym_uint] = ACTIONS(4482),
    [sym_long] = ACTIONS(4482),
    [sym_ulong] = ACTIONS(4482),
    [sym_cent] = ACTIONS(4482),
    [sym_ucent] = ACTIONS(4482),
    [sym_wchar] = ACTIONS(4482),
    [sym_dchar] = ACTIONS(4482),
    [sym_float] = ACTIONS(4482),
    [sym_double] = ACTIONS(4482),
    [sym_real] = ACTIONS(4482),
    [sym_ifloat] = ACTIONS(4482),
    [sym_idouble] = ACTIONS(4482),
    [sym_ireal] = ACTIONS(4482),
    [sym_cfloat] = ACTIONS(4482),
    [sym_cdouble] = ACTIONS(4482),
    [sym_creal] = ACTIONS(4482),
    [sym_size_t] = ACTIONS(4482),
    [sym_ptrdiff_t] = ACTIONS(4482),
    [sym_string] = ACTIONS(4482),
    [sym_cstring] = ACTIONS(4482),
    [sym_dstring] = ACTIONS(4482),
    [sym_wstring] = ACTIONS(4482),
    [sym_noreturn] = ACTIONS(4482),
    [sym_this] = ACTIONS(4482),
    [sym_abstract] = ACTIONS(4482),
    [sym_alias] = ACTIONS(4482),
    [sym_align] = ACTIONS(4482),
    [sym_auto] = ACTIONS(4482),
    [sym_class] = ACTIONS(4482),
    [sym_const] = ACTIONS(4482),
    [sym_debug] = ACTIONS(4482),
    [sym_deprecated] = ACTIONS(4482),
    [sym_else] = ACTIONS(4482),
    [sym_enum] = ACTIONS(4482),
    [sym_export] = ACTIONS(4482),
    [sym_extern] = ACTIONS(4482),
    [sym_final] = ACTIONS(4482),
    [sym_immutable] = ACTIONS(4482),
    [sym_import] = ACTIONS(4482),
    [sym_inout] = ACTIONS(4482),
    [sym_interface] = ACTIONS(4482),
    [sym_invariant] = ACTIONS(4482),
    [sym_mixin] = ACTIONS(4482),
    [sym_nothrow] = ACTIONS(4482),
    [sym_override] = ACTIONS(4482),
    [sym_package] = ACTIONS(4482),
    [sym_pragma] = ACTIONS(4482),
    [sym_private] = ACTIONS(4482),
    [sym_protected] = ACTIONS(4482),
    [sym_public] = ACTIONS(4482),
    [sym_pure] = ACTIONS(4482),
    [sym_ref] = ACTIONS(4482),
    [sym_return] = ACTIONS(4482),
    [sym_scope] = ACTIONS(4482),
    [sym_shared] = ACTIONS(4482),
    [sym_static] = ACTIONS(4482),
    [sym_struct] = ACTIONS(4482),
    [sym_synchronized] = ACTIONS(4482),
    [sym_template] = ACTIONS(4482),
    [sym_typeof] = ACTIONS(4482),
    [sym_union] = ACTIONS(4482),
    [sym_unittest] = ACTIONS(4482),
    [sym_version] = ACTIONS(4482),
    [sym_while] = ACTIONS(4482),
    [sym_gshared] = ACTIONS(4482),
    [sym_traits] = ACTIONS(4482),
    [sym_vector] = ACTIONS(4482),
    [sym_void] = ACTIONS(4482),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2445] = {
    [ts_builtin_sym_end] = ACTIONS(4713),
    [sym_identifier] = ACTIONS(4711),
    [anon_sym_RBRACE] = ACTIONS(4713),
    [anon_sym_DOT] = ACTIONS(4713),
    [anon_sym_SEMI] = ACTIONS(4713),
    [anon_sym_TILDE] = ACTIONS(4713),
    [anon_sym_AT] = ACTIONS(4713),
    [sym_bool] = ACTIONS(4711),
    [sym_byte] = ACTIONS(4711),
    [sym_ubyte] = ACTIONS(4711),
    [sym_char] = ACTIONS(4711),
    [sym_short] = ACTIONS(4711),
    [sym_ushort] = ACTIONS(4711),
    [sym_int] = ACTIONS(4711),
    [sym_uint] = ACTIONS(4711),
    [sym_long] = ACTIONS(4711),
    [sym_ulong] = ACTIONS(4711),
    [sym_cent] = ACTIONS(4711),
    [sym_ucent] = ACTIONS(4711),
    [sym_wchar] = ACTIONS(4711),
    [sym_dchar] = ACTIONS(4711),
    [sym_float] = ACTIONS(4711),
    [sym_double] = ACTIONS(4711),
    [sym_real] = ACTIONS(4711),
    [sym_ifloat] = ACTIONS(4711),
    [sym_idouble] = ACTIONS(4711),
    [sym_ireal] = ACTIONS(4711),
    [sym_cfloat] = ACTIONS(4711),
    [sym_cdouble] = ACTIONS(4711),
    [sym_creal] = ACTIONS(4711),
    [sym_size_t] = ACTIONS(4711),
    [sym_ptrdiff_t] = ACTIONS(4711),
    [sym_string] = ACTIONS(4711),
    [sym_cstring] = ACTIONS(4711),
    [sym_dstring] = ACTIONS(4711),
    [sym_wstring] = ACTIONS(4711),
    [sym_noreturn] = ACTIONS(4711),
    [sym_this] = ACTIONS(4711),
    [sym_abstract] = ACTIONS(4711),
    [sym_alias] = ACTIONS(4711),
    [sym_align] = ACTIONS(4711),
    [sym_auto] = ACTIONS(4711),
    [sym_class] = ACTIONS(4711),
    [sym_const] = ACTIONS(4711),
    [sym_debug] = ACTIONS(4711),
    [sym_deprecated] = ACTIONS(4711),
    [sym_else] = ACTIONS(4711),
    [sym_enum] = ACTIONS(4711),
    [sym_export] = ACTIONS(4711),
    [sym_extern] = ACTIONS(4711),
    [sym_final] = ACTIONS(4711),
    [sym_immutable] = ACTIONS(4711),
    [sym_import] = ACTIONS(4711),
    [sym_inout] = ACTIONS(4711),
    [sym_interface] = ACTIONS(4711),
    [sym_invariant] = ACTIONS(4711),
    [sym_mixin] = ACTIONS(4711),
    [sym_nothrow] = ACTIONS(4711),
    [sym_override] = ACTIONS(4711),
    [sym_package] = ACTIONS(4711),
    [sym_pragma] = ACTIONS(4711),
    [sym_private] = ACTIONS(4711),
    [sym_protected] = ACTIONS(4711),
    [sym_public] = ACTIONS(4711),
    [sym_pure] = ACTIONS(4711),
    [sym_ref] = ACTIONS(4711),
    [sym_return] = ACTIONS(4711),
    [sym_scope] = ACTIONS(4711),
    [sym_shared] = ACTIONS(4711),
    [sym_static] = ACTIONS(4711),
    [sym_struct] = ACTIONS(4711),
    [sym_synchronized] = ACTIONS(4711),
    [sym_template] = ACTIONS(4711),
    [sym_typeof] = ACTIONS(4711),
    [sym_union] = ACTIONS(4711),
    [sym_unittest] = ACTIONS(4711),
    [sym_version] = ACTIONS(4711),
    [sym_while] = ACTIONS(4711),
    [sym_gshared] = ACTIONS(4711),
    [sym_traits] = ACTIONS(4711),
    [sym_vector] = ACTIONS(4711),
    [sym_void] = ACTIONS(4711),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2446] = {
    [sym_identifier] = ACTIONS(4506),
    [anon_sym_DOT] = ACTIONS(4508),
    [anon_sym_SEMI] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4508),
    [anon_sym_AT] = ACTIONS(4508),
    [sym_bool] = ACTIONS(4506),
    [sym_byte] = ACTIONS(4506),
    [sym_ubyte] = ACTIONS(4506),
    [sym_char] = ACTIONS(4506),
    [sym_short] = ACTIONS(4506),
    [sym_ushort] = ACTIONS(4506),
    [sym_int] = ACTIONS(4506),
    [sym_uint] = ACTIONS(4506),
    [sym_long] = ACTIONS(4506),
    [sym_ulong] = ACTIONS(4506),
    [sym_cent] = ACTIONS(4506),
    [sym_ucent] = ACTIONS(4506),
    [sym_wchar] = ACTIONS(4506),
    [sym_dchar] = ACTIONS(4506),
    [sym_float] = ACTIONS(4506),
    [sym_double] = ACTIONS(4506),
    [sym_real] = ACTIONS(4506),
    [sym_ifloat] = ACTIONS(4506),
    [sym_idouble] = ACTIONS(4506),
    [sym_ireal] = ACTIONS(4506),
    [sym_cfloat] = ACTIONS(4506),
    [sym_cdouble] = ACTIONS(4506),
    [sym_creal] = ACTIONS(4506),
    [sym_size_t] = ACTIONS(4506),
    [sym_ptrdiff_t] = ACTIONS(4506),
    [sym_string] = ACTIONS(4506),
    [sym_cstring] = ACTIONS(4506),
    [sym_dstring] = ACTIONS(4506),
    [sym_wstring] = ACTIONS(4506),
    [sym_noreturn] = ACTIONS(4506),
    [sym_this] = ACTIONS(4506),
    [sym_abstract] = ACTIONS(4506),
    [sym_alias] = ACTIONS(4506),
    [sym_align] = ACTIONS(4506),
    [sym_auto] = ACTIONS(4506),
    [sym_catch] = ACTIONS(4506),
    [sym_class] = ACTIONS(4506),
    [sym_const] = ACTIONS(4506),
    [sym_debug] = ACTIONS(4506),
    [sym_deprecated] = ACTIONS(4506),
    [sym_else] = ACTIONS(4506),
    [sym_enum] = ACTIONS(4506),
    [sym_export] = ACTIONS(4506),
    [sym_extern] = ACTIONS(4506),
    [sym_final] = ACTIONS(4506),
    [sym_finally] = ACTIONS(4506),
    [sym_immutable] = ACTIONS(4506),
    [sym_import] = ACTIONS(4506),
    [sym_inout] = ACTIONS(4506),
    [sym_interface] = ACTIONS(4506),
    [sym_invariant] = ACTIONS(4506),
    [sym_mixin] = ACTIONS(4506),
    [sym_nothrow] = ACTIONS(4506),
    [sym_override] = ACTIONS(4506),
    [sym_package] = ACTIONS(4506),
    [sym_pragma] = ACTIONS(4506),
    [sym_private] = ACTIONS(4506),
    [sym_protected] = ACTIONS(4506),
    [sym_public] = ACTIONS(4506),
    [sym_pure] = ACTIONS(4506),
    [sym_ref] = ACTIONS(4506),
    [sym_return] = ACTIONS(4506),
    [sym_scope] = ACTIONS(4506),
    [sym_shared] = ACTIONS(4506),
    [sym_static] = ACTIONS(4506),
    [sym_struct] = ACTIONS(4506),
    [sym_synchronized] = ACTIONS(4506),
    [sym_template] = ACTIONS(4506),
    [sym_typeof] = ACTIONS(4506),
    [sym_union] = ACTIONS(4506),
    [sym_unittest] = ACTIONS(4506),
    [sym_version] = ACTIONS(4506),
    [sym_while] = ACTIONS(4506),
    [sym_gshared] = ACTIONS(4506),
    [sym_traits] = ACTIONS(4506),
    [sym_vector] = ACTIONS(4506),
    [sym_void] = ACTIONS(4506),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2447] = {
    [sym_identifier] = ACTIONS(4486),
    [anon_sym_DOT] = ACTIONS(4488),
    [anon_sym_SEMI] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4488),
    [anon_sym_AT] = ACTIONS(4488),
    [sym_bool] = ACTIONS(4486),
    [sym_byte] = ACTIONS(4486),
    [sym_ubyte] = ACTIONS(4486),
    [sym_char] = ACTIONS(4486),
    [sym_short] = ACTIONS(4486),
    [sym_ushort] = ACTIONS(4486),
    [sym_int] = ACTIONS(4486),
    [sym_uint] = ACTIONS(4486),
    [sym_long] = ACTIONS(4486),
    [sym_ulong] = ACTIONS(4486),
    [sym_cent] = ACTIONS(4486),
    [sym_ucent] = ACTIONS(4486),
    [sym_wchar] = ACTIONS(4486),
    [sym_dchar] = ACTIONS(4486),
    [sym_float] = ACTIONS(4486),
    [sym_double] = ACTIONS(4486),
    [sym_real] = ACTIONS(4486),
    [sym_ifloat] = ACTIONS(4486),
    [sym_idouble] = ACTIONS(4486),
    [sym_ireal] = ACTIONS(4486),
    [sym_cfloat] = ACTIONS(4486),
    [sym_cdouble] = ACTIONS(4486),
    [sym_creal] = ACTIONS(4486),
    [sym_size_t] = ACTIONS(4486),
    [sym_ptrdiff_t] = ACTIONS(4486),
    [sym_string] = ACTIONS(4486),
    [sym_cstring] = ACTIONS(4486),
    [sym_dstring] = ACTIONS(4486),
    [sym_wstring] = ACTIONS(4486),
    [sym_noreturn] = ACTIONS(4486),
    [sym_this] = ACTIONS(4486),
    [sym_abstract] = ACTIONS(4486),
    [sym_alias] = ACTIONS(4486),
    [sym_align] = ACTIONS(4486),
    [sym_auto] = ACTIONS(4486),
    [sym_catch] = ACTIONS(4486),
    [sym_class] = ACTIONS(4486),
    [sym_const] = ACTIONS(4486),
    [sym_debug] = ACTIONS(4486),
    [sym_deprecated] = ACTIONS(4486),
    [sym_else] = ACTIONS(4486),
    [sym_enum] = ACTIONS(4486),
    [sym_export] = ACTIONS(4486),
    [sym_extern] = ACTIONS(4486),
    [sym_final] = ACTIONS(4486),
    [sym_finally] = ACTIONS(4486),
    [sym_immutable] = ACTIONS(4486),
    [sym_import] = ACTIONS(4486),
    [sym_inout] = ACTIONS(4486),
    [sym_interface] = ACTIONS(4486),
    [sym_invariant] = ACTIONS(4486),
    [sym_mixin] = ACTIONS(4486),
    [sym_nothrow] = ACTIONS(4486),
    [sym_override] = ACTIONS(4486),
    [sym_package] = ACTIONS(4486),
    [sym_pragma] = ACTIONS(4486),
    [sym_private] = ACTIONS(4486),
    [sym_protected] = ACTIONS(4486),
    [sym_public] = ACTIONS(4486),
    [sym_pure] = ACTIONS(4486),
    [sym_ref] = ACTIONS(4486),
    [sym_return] = ACTIONS(4486),
    [sym_scope] = ACTIONS(4486),
    [sym_shared] = ACTIONS(4486),
    [sym_static] = ACTIONS(4486),
    [sym_struct] = ACTIONS(4486),
    [sym_synchronized] = ACTIONS(4486),
    [sym_template] = ACTIONS(4486),
    [sym_typeof] = ACTIONS(4486),
    [sym_union] = ACTIONS(4486),
    [sym_unittest] = ACTIONS(4486),
    [sym_version] = ACTIONS(4486),
    [sym_while] = ACTIONS(4486),
    [sym_gshared] = ACTIONS(4486),
    [sym_traits] = ACTIONS(4486),
    [sym_vector] = ACTIONS(4486),
    [sym_void] = ACTIONS(4486),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2448] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6102),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2449] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6104),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2450] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6107),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2451] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(6109),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(6113),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_module] = ACTIONS(6117),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2452] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6119),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2453] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(3073),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2454] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6122),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2455] = {
    [sym_identifier] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(6093),
    [anon_sym_DOT] = ACTIONS(6093),
    [anon_sym_LPAREN] = ACTIONS(6098),
    [anon_sym_SEMI] = ACTIONS(6093),
    [anon_sym_TILDE] = ACTIONS(6093),
    [anon_sym_AT] = ACTIONS(6093),
    [sym_bool] = ACTIONS(6100),
    [sym_byte] = ACTIONS(6100),
    [sym_ubyte] = ACTIONS(6100),
    [sym_char] = ACTIONS(6100),
    [sym_short] = ACTIONS(6100),
    [sym_ushort] = ACTIONS(6100),
    [sym_int] = ACTIONS(6100),
    [sym_uint] = ACTIONS(6100),
    [sym_long] = ACTIONS(6100),
    [sym_ulong] = ACTIONS(6100),
    [sym_cent] = ACTIONS(6100),
    [sym_ucent] = ACTIONS(6100),
    [sym_wchar] = ACTIONS(6100),
    [sym_dchar] = ACTIONS(6100),
    [sym_float] = ACTIONS(6100),
    [sym_double] = ACTIONS(6100),
    [sym_real] = ACTIONS(6100),
    [sym_ifloat] = ACTIONS(6100),
    [sym_idouble] = ACTIONS(6100),
    [sym_ireal] = ACTIONS(6100),
    [sym_cfloat] = ACTIONS(6100),
    [sym_cdouble] = ACTIONS(6100),
    [sym_creal] = ACTIONS(6100),
    [sym_size_t] = ACTIONS(6100),
    [sym_ptrdiff_t] = ACTIONS(6100),
    [sym_string] = ACTIONS(6100),
    [sym_cstring] = ACTIONS(6100),
    [sym_dstring] = ACTIONS(6100),
    [sym_wstring] = ACTIONS(6100),
    [sym_noreturn] = ACTIONS(6100),
    [sym_this] = ACTIONS(6100),
    [sym_abstract] = ACTIONS(6100),
    [sym_alias] = ACTIONS(6100),
    [sym_align] = ACTIONS(6100),
    [sym_auto] = ACTIONS(6100),
    [sym_class] = ACTIONS(6100),
    [sym_const] = ACTIONS(6100),
    [sym_debug] = ACTIONS(6100),
    [sym_deprecated] = ACTIONS(6100),
    [sym_enum] = ACTIONS(6100),
    [sym_export] = ACTIONS(6100),
    [sym_extern] = ACTIONS(6100),
    [sym_final] = ACTIONS(6100),
    [sym_immutable] = ACTIONS(6100),
    [sym_import] = ACTIONS(6100),
    [sym_inout] = ACTIONS(6100),
    [sym_interface] = ACTIONS(6100),
    [sym_invariant] = ACTIONS(6100),
    [sym_mixin] = ACTIONS(6100),
    [sym_module] = ACTIONS(6100),
    [sym_nothrow] = ACTIONS(6100),
    [sym_override] = ACTIONS(6100),
    [sym_package] = ACTIONS(6100),
    [sym_pragma] = ACTIONS(6100),
    [sym_private] = ACTIONS(6100),
    [sym_protected] = ACTIONS(6100),
    [sym_public] = ACTIONS(6100),
    [sym_pure] = ACTIONS(6100),
    [sym_ref] = ACTIONS(6100),
    [sym_return] = ACTIONS(6100),
    [sym_scope] = ACTIONS(6100),
    [sym_shared] = ACTIONS(6100),
    [sym_static] = ACTIONS(6100),
    [sym_struct] = ACTIONS(6100),
    [sym_synchronized] = ACTIONS(6100),
    [sym_template] = ACTIONS(6100),
    [sym_typeof] = ACTIONS(6100),
    [sym_union] = ACTIONS(6100),
    [sym_unittest] = ACTIONS(6100),
    [sym_version] = ACTIONS(6100),
    [sym_gshared] = ACTIONS(6100),
    [sym_traits] = ACTIONS(6100),
    [sym_vector] = ACTIONS(6100),
    [sym_void] = ACTIONS(6100),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2456] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6124),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2457] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6126),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2458] = {
    [sym_identifier] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6137),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(6129),
    [sym_byte] = ACTIONS(6129),
    [sym_ubyte] = ACTIONS(6129),
    [sym_char] = ACTIONS(6129),
    [sym_short] = ACTIONS(6129),
    [sym_ushort] = ACTIONS(6129),
    [sym_int] = ACTIONS(6129),
    [sym_uint] = ACTIONS(6129),
    [sym_long] = ACTIONS(6129),
    [sym_ulong] = ACTIONS(6129),
    [sym_cent] = ACTIONS(6129),
    [sym_ucent] = ACTIONS(6129),
    [sym_wchar] = ACTIONS(6129),
    [sym_dchar] = ACTIONS(6129),
    [sym_float] = ACTIONS(6129),
    [sym_double] = ACTIONS(6129),
    [sym_real] = ACTIONS(6129),
    [sym_ifloat] = ACTIONS(6129),
    [sym_idouble] = ACTIONS(6129),
    [sym_ireal] = ACTIONS(6129),
    [sym_cfloat] = ACTIONS(6129),
    [sym_cdouble] = ACTIONS(6129),
    [sym_creal] = ACTIONS(6129),
    [sym_size_t] = ACTIONS(6129),
    [sym_ptrdiff_t] = ACTIONS(6129),
    [sym_string] = ACTIONS(6129),
    [sym_cstring] = ACTIONS(6129),
    [sym_dstring] = ACTIONS(6129),
    [sym_wstring] = ACTIONS(6129),
    [sym_noreturn] = ACTIONS(6129),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(6129),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(6129),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(6129),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(6129),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(6129),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(6129),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(6129),
    [sym_vector] = ACTIONS(6129),
    [sym_void] = ACTIONS(6129),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2459] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6139),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2460] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6141),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2461] = {
    [sym_identifier] = ACTIONS(6143),
    [anon_sym_LBRACE] = ACTIONS(6145),
    [anon_sym_DOT] = ACTIONS(6145),
    [anon_sym_SEMI] = ACTIONS(6145),
    [anon_sym_COLON] = ACTIONS(6145),
    [anon_sym_TILDE] = ACTIONS(6145),
    [anon_sym_AT] = ACTIONS(6145),
    [sym_bool] = ACTIONS(6143),
    [sym_byte] = ACTIONS(6143),
    [sym_ubyte] = ACTIONS(6143),
    [sym_char] = ACTIONS(6143),
    [sym_short] = ACTIONS(6143),
    [sym_ushort] = ACTIONS(6143),
    [sym_int] = ACTIONS(6143),
    [sym_uint] = ACTIONS(6143),
    [sym_long] = ACTIONS(6143),
    [sym_ulong] = ACTIONS(6143),
    [sym_cent] = ACTIONS(6143),
    [sym_ucent] = ACTIONS(6143),
    [sym_wchar] = ACTIONS(6143),
    [sym_dchar] = ACTIONS(6143),
    [sym_float] = ACTIONS(6143),
    [sym_double] = ACTIONS(6143),
    [sym_real] = ACTIONS(6143),
    [sym_ifloat] = ACTIONS(6143),
    [sym_idouble] = ACTIONS(6143),
    [sym_ireal] = ACTIONS(6143),
    [sym_cfloat] = ACTIONS(6143),
    [sym_cdouble] = ACTIONS(6143),
    [sym_creal] = ACTIONS(6143),
    [sym_size_t] = ACTIONS(6143),
    [sym_ptrdiff_t] = ACTIONS(6143),
    [sym_string] = ACTIONS(6143),
    [sym_cstring] = ACTIONS(6143),
    [sym_dstring] = ACTIONS(6143),
    [sym_wstring] = ACTIONS(6143),
    [sym_noreturn] = ACTIONS(6143),
    [sym_this] = ACTIONS(6143),
    [sym_abstract] = ACTIONS(6143),
    [sym_alias] = ACTIONS(6143),
    [sym_align] = ACTIONS(6143),
    [sym_auto] = ACTIONS(6143),
    [sym_class] = ACTIONS(6143),
    [sym_const] = ACTIONS(6143),
    [sym_debug] = ACTIONS(6143),
    [sym_deprecated] = ACTIONS(6143),
    [sym_enum] = ACTIONS(6143),
    [sym_export] = ACTIONS(6143),
    [sym_extern] = ACTIONS(6143),
    [sym_final] = ACTIONS(6143),
    [sym_immutable] = ACTIONS(6143),
    [sym_import] = ACTIONS(6143),
    [sym_inout] = ACTIONS(6143),
    [sym_interface] = ACTIONS(6143),
    [sym_invariant] = ACTIONS(6143),
    [sym_mixin] = ACTIONS(6143),
    [sym_module] = ACTIONS(6143),
    [sym_nothrow] = ACTIONS(6143),
    [sym_override] = ACTIONS(6143),
    [sym_package] = ACTIONS(6143),
    [sym_pragma] = ACTIONS(6143),
    [sym_private] = ACTIONS(6143),
    [sym_protected] = ACTIONS(6143),
    [sym_public] = ACTIONS(6143),
    [sym_pure] = ACTIONS(6143),
    [sym_ref] = ACTIONS(6143),
    [sym_return] = ACTIONS(6143),
    [sym_scope] = ACTIONS(6143),
    [sym_shared] = ACTIONS(6143),
    [sym_static] = ACTIONS(6143),
    [sym_struct] = ACTIONS(6143),
    [sym_synchronized] = ACTIONS(6143),
    [sym_template] = ACTIONS(6143),
    [sym_typeof] = ACTIONS(6143),
    [sym_union] = ACTIONS(6143),
    [sym_unittest] = ACTIONS(6143),
    [sym_version] = ACTIONS(6143),
    [sym_gshared] = ACTIONS(6143),
    [sym_traits] = ACTIONS(6143),
    [sym_vector] = ACTIONS(6143),
    [sym_void] = ACTIONS(6143),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2462] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6147),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2463] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6150),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2464] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2465] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6154),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2466] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6156),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2467] = {
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6162),
    [anon_sym_SEMI] = ACTIONS(6160),
    [anon_sym_COLON] = ACTIONS(6160),
    [anon_sym_TILDE] = ACTIONS(6160),
    [anon_sym_AT] = ACTIONS(6160),
    [sym_bool] = ACTIONS(6158),
    [sym_byte] = ACTIONS(6158),
    [sym_ubyte] = ACTIONS(6158),
    [sym_char] = ACTIONS(6158),
    [sym_short] = ACTIONS(6158),
    [sym_ushort] = ACTIONS(6158),
    [sym_int] = ACTIONS(6158),
    [sym_uint] = ACTIONS(6158),
    [sym_long] = ACTIONS(6158),
    [sym_ulong] = ACTIONS(6158),
    [sym_cent] = ACTIONS(6158),
    [sym_ucent] = ACTIONS(6158),
    [sym_wchar] = ACTIONS(6158),
    [sym_dchar] = ACTIONS(6158),
    [sym_float] = ACTIONS(6158),
    [sym_double] = ACTIONS(6158),
    [sym_real] = ACTIONS(6158),
    [sym_ifloat] = ACTIONS(6158),
    [sym_idouble] = ACTIONS(6158),
    [sym_ireal] = ACTIONS(6158),
    [sym_cfloat] = ACTIONS(6158),
    [sym_cdouble] = ACTIONS(6158),
    [sym_creal] = ACTIONS(6158),
    [sym_size_t] = ACTIONS(6158),
    [sym_ptrdiff_t] = ACTIONS(6158),
    [sym_string] = ACTIONS(6158),
    [sym_cstring] = ACTIONS(6158),
    [sym_dstring] = ACTIONS(6158),
    [sym_wstring] = ACTIONS(6158),
    [sym_noreturn] = ACTIONS(6158),
    [sym_this] = ACTIONS(6158),
    [sym_abstract] = ACTIONS(6158),
    [sym_alias] = ACTIONS(6158),
    [sym_align] = ACTIONS(6158),
    [sym_auto] = ACTIONS(6158),
    [sym_class] = ACTIONS(6158),
    [sym_const] = ACTIONS(6158),
    [sym_debug] = ACTIONS(6158),
    [sym_deprecated] = ACTIONS(6158),
    [sym_enum] = ACTIONS(6158),
    [sym_export] = ACTIONS(6158),
    [sym_extern] = ACTIONS(6158),
    [sym_final] = ACTIONS(6158),
    [sym_immutable] = ACTIONS(6158),
    [sym_import] = ACTIONS(6158),
    [sym_inout] = ACTIONS(6158),
    [sym_interface] = ACTIONS(6158),
    [sym_invariant] = ACTIONS(6158),
    [sym_mixin] = ACTIONS(6158),
    [sym_nothrow] = ACTIONS(6158),
    [sym_override] = ACTIONS(6158),
    [sym_package] = ACTIONS(6158),
    [sym_pragma] = ACTIONS(6158),
    [sym_private] = ACTIONS(6158),
    [sym_protected] = ACTIONS(6158),
    [sym_public] = ACTIONS(6158),
    [sym_pure] = ACTIONS(6158),
    [sym_ref] = ACTIONS(6158),
    [sym_return] = ACTIONS(6158),
    [sym_scope] = ACTIONS(6158),
    [sym_shared] = ACTIONS(6158),
    [sym_static] = ACTIONS(6158),
    [sym_struct] = ACTIONS(6158),
    [sym_synchronized] = ACTIONS(6158),
    [sym_template] = ACTIONS(6158),
    [sym_typeof] = ACTIONS(6158),
    [sym_union] = ACTIONS(6158),
    [sym_unittest] = ACTIONS(6158),
    [sym_version] = ACTIONS(6158),
    [sym_gshared] = ACTIONS(6158),
    [sym_traits] = ACTIONS(6158),
    [sym_vector] = ACTIONS(6158),
    [sym_void] = ACTIONS(6158),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2468] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6164),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2469] = {
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(6166),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(669),
    [sym_bool] = ACTIONS(3019),
    [sym_byte] = ACTIONS(3019),
    [sym_ubyte] = ACTIONS(3019),
    [sym_char] = ACTIONS(3019),
    [sym_short] = ACTIONS(3019),
    [sym_ushort] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_uint] = ACTIONS(3019),
    [sym_long] = ACTIONS(3019),
    [sym_ulong] = ACTIONS(3019),
    [sym_cent] = ACTIONS(3019),
    [sym_ucent] = ACTIONS(3019),
    [sym_wchar] = ACTIONS(3019),
    [sym_dchar] = ACTIONS(3019),
    [sym_float] = ACTIONS(3019),
    [sym_double] = ACTIONS(3019),
    [sym_real] = ACTIONS(3019),
    [sym_ifloat] = ACTIONS(3019),
    [sym_idouble] = ACTIONS(3019),
    [sym_ireal] = ACTIONS(3019),
    [sym_cfloat] = ACTIONS(3019),
    [sym_cdouble] = ACTIONS(3019),
    [sym_creal] = ACTIONS(3019),
    [sym_size_t] = ACTIONS(3019),
    [sym_ptrdiff_t] = ACTIONS(3019),
    [sym_string] = ACTIONS(3019),
    [sym_cstring] = ACTIONS(3019),
    [sym_dstring] = ACTIONS(3019),
    [sym_wstring] = ACTIONS(3019),
    [sym_noreturn] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_auto] = ACTIONS(3019),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(3019),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(3019),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_immutable] = ACTIONS(3019),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(3019),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(3019),
    [sym_nothrow] = ACTIONS(3019),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3019),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(3019),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(3019),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(3019),
    [sym_vector] = ACTIONS(3019),
    [sym_void] = ACTIONS(3019),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2470] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6168),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2471] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6170),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2472] = {
    [sym_identifier] = ACTIONS(6129),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(6133),
    [anon_sym_LPAREN] = ACTIONS(6173),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(6129),
    [sym_byte] = ACTIONS(6129),
    [sym_ubyte] = ACTIONS(6129),
    [sym_char] = ACTIONS(6129),
    [sym_short] = ACTIONS(6129),
    [sym_ushort] = ACTIONS(6129),
    [sym_int] = ACTIONS(6129),
    [sym_uint] = ACTIONS(6129),
    [sym_long] = ACTIONS(6129),
    [sym_ulong] = ACTIONS(6129),
    [sym_cent] = ACTIONS(6129),
    [sym_ucent] = ACTIONS(6129),
    [sym_wchar] = ACTIONS(6129),
    [sym_dchar] = ACTIONS(6129),
    [sym_float] = ACTIONS(6129),
    [sym_double] = ACTIONS(6129),
    [sym_real] = ACTIONS(6129),
    [sym_ifloat] = ACTIONS(6129),
    [sym_idouble] = ACTIONS(6129),
    [sym_ireal] = ACTIONS(6129),
    [sym_cfloat] = ACTIONS(6129),
    [sym_cdouble] = ACTIONS(6129),
    [sym_creal] = ACTIONS(6129),
    [sym_size_t] = ACTIONS(6129),
    [sym_ptrdiff_t] = ACTIONS(6129),
    [sym_string] = ACTIONS(6129),
    [sym_cstring] = ACTIONS(6129),
    [sym_dstring] = ACTIONS(6129),
    [sym_wstring] = ACTIONS(6129),
    [sym_noreturn] = ACTIONS(6129),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(6129),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(6129),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(6129),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(6129),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(6129),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(6129),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(6129),
    [sym_vector] = ACTIONS(6129),
    [sym_void] = ACTIONS(6129),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2473] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_LPAREN] = ACTIONS(6175),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2474] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6177),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2475] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_TILDE] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_this] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_class] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_debug] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_export] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_import] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_interface] = ACTIONS(3073),
    [sym_invariant] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_package] = ACTIONS(3073),
    [sym_pragma] = ACTIONS(3073),
    [sym_private] = ACTIONS(3073),
    [sym_protected] = ACTIONS(3073),
    [sym_public] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(6180),
    [sym_struct] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_template] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_union] = ACTIONS(3073),
    [sym_unittest] = ACTIONS(3073),
    [sym_version] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2476] = {
    [sym_identifier] = ACTIONS(5066),
    [anon_sym_LBRACE] = ACTIONS(5068),
    [anon_sym_DOT] = ACTIONS(5068),
    [anon_sym_SEMI] = ACTIONS(5068),
    [anon_sym_COLON] = ACTIONS(5068),
    [anon_sym_TILDE] = ACTIONS(5068),
    [anon_sym_AT] = ACTIONS(5068),
    [sym_bool] = ACTIONS(5066),
    [sym_byte] = ACTIONS(5066),
    [sym_ubyte] = ACTIONS(5066),
    [sym_char] = ACTIONS(5066),
    [sym_short] = ACTIONS(5066),
    [sym_ushort] = ACTIONS(5066),
    [sym_int] = ACTIONS(5066),
    [sym_uint] = ACTIONS(5066),
    [sym_long] = ACTIONS(5066),
    [sym_ulong] = ACTIONS(5066),
    [sym_cent] = ACTIONS(5066),
    [sym_ucent] = ACTIONS(5066),
    [sym_wchar] = ACTIONS(5066),
    [sym_dchar] = ACTIONS(5066),
    [sym_float] = ACTIONS(5066),
    [sym_double] = ACTIONS(5066),
    [sym_real] = ACTIONS(5066),
    [sym_ifloat] = ACTIONS(5066),
    [sym_idouble] = ACTIONS(5066),
    [sym_ireal] = ACTIONS(5066),
    [sym_cfloat] = ACTIONS(5066),
    [sym_cdouble] = ACTIONS(5066),
    [sym_creal] = ACTIONS(5066),
    [sym_size_t] = ACTIONS(5066),
    [sym_ptrdiff_t] = ACTIONS(5066),
    [sym_string] = ACTIONS(5066),
    [sym_cstring] = ACTIONS(5066),
    [sym_dstring] = ACTIONS(5066),
    [sym_wstring] = ACTIONS(5066),
    [sym_noreturn] = ACTIONS(5066),
    [sym_this] = ACTIONS(5066),
    [sym_abstract] = ACTIONS(5066),
    [sym_alias] = ACTIONS(5066),
    [sym_align] = ACTIONS(5066),
    [sym_auto] = ACTIONS(5066),
    [sym_class] = ACTIONS(5066),
    [sym_const] = ACTIONS(5066),
    [sym_debug] = ACTIONS(5066),
    [sym_deprecated] = ACTIONS(5066),
    [sym_enum] = ACTIONS(5066),
    [sym_export] = ACTIONS(5066),
    [sym_extern] = ACTIONS(5066),
    [sym_final] = ACTIONS(5066),
    [sym_immutable] = ACTIONS(5066),
    [sym_import] = ACTIONS(5066),
    [sym_inout] = ACTIONS(5066),
    [sym_interface] = ACTIONS(5066),
    [sym_invariant] = ACTIONS(5066),
    [sym_mixin] = ACTIONS(5066),
    [sym_nothrow] = ACTIONS(5066),
    [sym_override] = ACTIONS(5066),
    [sym_package] = ACTIONS(5066),
    [sym_pragma] = ACTIONS(5066),
    [sym_private] = ACTIONS(5066),
    [sym_protected] = ACTIONS(5066),
    [sym_public] = ACTIONS(5066),
    [sym_pure] = ACTIONS(5066),
    [sym_ref] = ACTIONS(5066),
    [sym_return] = ACTIONS(5066),
    [sym_scope] = ACTIONS(5066),
    [sym_shared] = ACTIONS(5066),
    [sym_static] = ACTIONS(5066),
    [sym_struct] = ACTIONS(5066),
    [sym_synchronized] = ACTIONS(5066),
    [sym_template] = ACTIONS(5066),
    [sym_typeof] = ACTIONS(5066),
    [sym_union] = ACTIONS(5066),
    [sym_unittest] = ACTIONS(5066),
    [sym_version] = ACTIONS(5066),
    [sym_gshared] = ACTIONS(5066),
    [sym_traits] = ACTIONS(5066),
    [sym_vector] = ACTIONS(5066),
    [sym_void] = ACTIONS(5066),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2477] = {
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6187),
    [anon_sym_TILDE] = ACTIONS(6185),
    [anon_sym_AT] = ACTIONS(6185),
    [sym_bool] = ACTIONS(6183),
    [sym_byte] = ACTIONS(6183),
    [sym_ubyte] = ACTIONS(6183),
    [sym_char] = ACTIONS(6183),
    [sym_short] = ACTIONS(6183),
    [sym_ushort] = ACTIONS(6183),
    [sym_int] = ACTIONS(6183),
    [sym_uint] = ACTIONS(6183),
    [sym_long] = ACTIONS(6183),
    [sym_ulong] = ACTIONS(6183),
    [sym_cent] = ACTIONS(6183),
    [sym_ucent] = ACTIONS(6183),
    [sym_wchar] = ACTIONS(6183),
    [sym_dchar] = ACTIONS(6183),
    [sym_float] = ACTIONS(6183),
    [sym_double] = ACTIONS(6183),
    [sym_real] = ACTIONS(6183),
    [sym_ifloat] = ACTIONS(6183),
    [sym_idouble] = ACTIONS(6183),
    [sym_ireal] = ACTIONS(6183),
    [sym_cfloat] = ACTIONS(6183),
    [sym_cdouble] = ACTIONS(6183),
    [sym_creal] = ACTIONS(6183),
    [sym_size_t] = ACTIONS(6183),
    [sym_ptrdiff_t] = ACTIONS(6183),
    [sym_string] = ACTIONS(6183),
    [sym_cstring] = ACTIONS(6183),
    [sym_dstring] = ACTIONS(6183),
    [sym_wstring] = ACTIONS(6183),
    [sym_noreturn] = ACTIONS(6183),
    [sym_this] = ACTIONS(6183),
    [sym_abstract] = ACTIONS(6183),
    [sym_alias] = ACTIONS(6183),
    [sym_align] = ACTIONS(6183),
    [sym_auto] = ACTIONS(6183),
    [sym_class] = ACTIONS(6183),
    [sym_const] = ACTIONS(6183),
    [sym_debug] = ACTIONS(6183),
    [sym_deprecated] = ACTIONS(6183),
    [sym_enum] = ACTIONS(6183),
    [sym_export] = ACTIONS(6183),
    [sym_extern] = ACTIONS(6183),
    [sym_final] = ACTIONS(6183),
    [sym_immutable] = ACTIONS(6183),
    [sym_import] = ACTIONS(6183),
    [sym_inout] = ACTIONS(6183),
    [sym_interface] = ACTIONS(6183),
    [sym_invariant] = ACTIONS(6183),
    [sym_mixin] = ACTIONS(6183),
    [sym_nothrow] = ACTIONS(6183),
    [sym_override] = ACTIONS(6183),
    [sym_package] = ACTIONS(6183),
    [sym_pragma] = ACTIONS(6183),
    [sym_private] = ACTIONS(6183),
    [sym_protected] = ACTIONS(6183),
    [sym_public] = ACTIONS(6183),
    [sym_pure] = ACTIONS(6183),
    [sym_ref] = ACTIONS(6183),
    [sym_return] = ACTIONS(6183),
    [sym_scope] = ACTIONS(6183),
    [sym_shared] = ACTIONS(6183),
    [sym_static] = ACTIONS(6183),
    [sym_struct] = ACTIONS(6183),
    [sym_synchronized] = ACTIONS(6183),
    [sym_template] = ACTIONS(6183),
    [sym_typeof] = ACTIONS(6183),
    [sym_union] = ACTIONS(6183),
    [sym_unittest] = ACTIONS(6183),
    [sym_version] = ACTIONS(6183),
    [sym_gshared] = ACTIONS(6183),
    [sym_traits] = ACTIONS(6183),
    [sym_vector] = ACTIONS(6183),
    [sym_void] = ACTIONS(6183),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2478] = {
    [sym_identifier] = ACTIONS(6189),
    [anon_sym_LBRACE] = ACTIONS(6191),
    [anon_sym_DOT] = ACTIONS(6191),
    [anon_sym_SEMI] = ACTIONS(6191),
    [anon_sym_COLON] = ACTIONS(6191),
    [anon_sym_TILDE] = ACTIONS(6191),
    [anon_sym_AT] = ACTIONS(6191),
    [sym_bool] = ACTIONS(6189),
    [sym_byte] = ACTIONS(6189),
    [sym_ubyte] = ACTIONS(6189),
    [sym_char] = ACTIONS(6189),
    [sym_short] = ACTIONS(6189),
    [sym_ushort] = ACTIONS(6189),
    [sym_int] = ACTIONS(6189),
    [sym_uint] = ACTIONS(6189),
    [sym_long] = ACTIONS(6189),
    [sym_ulong] = ACTIONS(6189),
    [sym_cent] = ACTIONS(6189),
    [sym_ucent] = ACTIONS(6189),
    [sym_wchar] = ACTIONS(6189),
    [sym_dchar] = ACTIONS(6189),
    [sym_float] = ACTIONS(6189),
    [sym_double] = ACTIONS(6189),
    [sym_real] = ACTIONS(6189),
    [sym_ifloat] = ACTIONS(6189),
    [sym_idouble] = ACTIONS(6189),
    [sym_ireal] = ACTIONS(6189),
    [sym_cfloat] = ACTIONS(6189),
    [sym_cdouble] = ACTIONS(6189),
    [sym_creal] = ACTIONS(6189),
    [sym_size_t] = ACTIONS(6189),
    [sym_ptrdiff_t] = ACTIONS(6189),
    [sym_string] = ACTIONS(6189),
    [sym_cstring] = ACTIONS(6189),
    [sym_dstring] = ACTIONS(6189),
    [sym_wstring] = ACTIONS(6189),
    [sym_noreturn] = ACTIONS(6189),
    [sym_this] = ACTIONS(6189),
    [sym_abstract] = ACTIONS(6189),
    [sym_alias] = ACTIONS(6189),
    [sym_align] = ACTIONS(6189),
    [sym_auto] = ACTIONS(6189),
    [sym_class] = ACTIONS(6189),
    [sym_const] = ACTIONS(6189),
    [sym_debug] = ACTIONS(6189),
    [sym_deprecated] = ACTIONS(6189),
    [sym_enum] = ACTIONS(6189),
    [sym_export] = ACTIONS(6189),
    [sym_extern] = ACTIONS(6189),
    [sym_final] = ACTIONS(6189),
    [sym_immutable] = ACTIONS(6189),
    [sym_import] = ACTIONS(6189),
    [sym_inout] = ACTIONS(6189),
    [sym_interface] = ACTIONS(6189),
    [sym_invariant] = ACTIONS(6189),
    [sym_mixin] = ACTIONS(6189),
    [sym_nothrow] = ACTIONS(6189),
    [sym_override] = ACTIONS(6189),
    [sym_package] = ACTIONS(6189),
    [sym_pragma] = ACTIONS(6189),
    [sym_private] = ACTIONS(6189),
    [sym_protected] = ACTIONS(6189),
    [sym_public] = ACTIONS(6189),
    [sym_pure] = ACTIONS(6189),
    [sym_ref] = ACTIONS(6189),
    [sym_return] = ACTIONS(6189),
    [sym_scope] = ACTIONS(6189),
    [sym_shared] = ACTIONS(6189),
    [sym_static] = ACTIONS(6189),
    [sym_struct] = ACTIONS(6189),
    [sym_synchronized] = ACTIONS(6189),
    [sym_template] = ACTIONS(6189),
    [sym_typeof] = ACTIONS(6189),
    [sym_union] = ACTIONS(6189),
    [sym_unittest] = ACTIONS(6189),
    [sym_version] = ACTIONS(6189),
    [sym_gshared] = ACTIONS(6189),
    [sym_traits] = ACTIONS(6189),
    [sym_vector] = ACTIONS(6189),
    [sym_void] = ACTIONS(6189),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2479] = {
    [sym_identifier] = ACTIONS(5078),
    [anon_sym_LBRACE] = ACTIONS(5080),
    [anon_sym_DOT] = ACTIONS(5080),
    [anon_sym_SEMI] = ACTIONS(5080),
    [anon_sym_COLON] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5080),
    [anon_sym_AT] = ACTIONS(5080),
    [sym_bool] = ACTIONS(5078),
    [sym_byte] = ACTIONS(5078),
    [sym_ubyte] = ACTIONS(5078),
    [sym_char] = ACTIONS(5078),
    [sym_short] = ACTIONS(5078),
    [sym_ushort] = ACTIONS(5078),
    [sym_int] = ACTIONS(5078),
    [sym_uint] = ACTIONS(5078),
    [sym_long] = ACTIONS(5078),
    [sym_ulong] = ACTIONS(5078),
    [sym_cent] = ACTIONS(5078),
    [sym_ucent] = ACTIONS(5078),
    [sym_wchar] = ACTIONS(5078),
    [sym_dchar] = ACTIONS(5078),
    [sym_float] = ACTIONS(5078),
    [sym_double] = ACTIONS(5078),
    [sym_real] = ACTIONS(5078),
    [sym_ifloat] = ACTIONS(5078),
    [sym_idouble] = ACTIONS(5078),
    [sym_ireal] = ACTIONS(5078),
    [sym_cfloat] = ACTIONS(5078),
    [sym_cdouble] = ACTIONS(5078),
    [sym_creal] = ACTIONS(5078),
    [sym_size_t] = ACTIONS(5078),
    [sym_ptrdiff_t] = ACTIONS(5078),
    [sym_string] = ACTIONS(5078),
    [sym_cstring] = ACTIONS(5078),
    [sym_dstring] = ACTIONS(5078),
    [sym_wstring] = ACTIONS(5078),
    [sym_noreturn] = ACTIONS(5078),
    [sym_this] = ACTIONS(5078),
    [sym_abstract] = ACTIONS(5078),
    [sym_alias] = ACTIONS(5078),
    [sym_align] = ACTIONS(5078),
    [sym_auto] = ACTIONS(5078),
    [sym_class] = ACTIONS(5078),
    [sym_const] = ACTIONS(5078),
    [sym_debug] = ACTIONS(5078),
    [sym_deprecated] = ACTIONS(5078),
    [sym_enum] = ACTIONS(5078),
    [sym_export] = ACTIONS(5078),
    [sym_extern] = ACTIONS(5078),
    [sym_final] = ACTIONS(5078),
    [sym_immutable] = ACTIONS(5078),
    [sym_import] = ACTIONS(5078),
    [sym_inout] = ACTIONS(5078),
    [sym_interface] = ACTIONS(5078),
    [sym_invariant] = ACTIONS(5078),
    [sym_mixin] = ACTIONS(5078),
    [sym_nothrow] = ACTIONS(5078),
    [sym_override] = ACTIONS(5078),
    [sym_package] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(5078),
    [sym_private] = ACTIONS(5078),
    [sym_protected] = ACTIONS(5078),
    [sym_public] = ACTIONS(5078),
    [sym_pure] = ACTIONS(5078),
    [sym_ref] = ACTIONS(5078),
    [sym_return] = ACTIONS(5078),
    [sym_scope] = ACTIONS(5078),
    [sym_shared] = ACTIONS(5078),
    [sym_static] = ACTIONS(5078),
    [sym_struct] = ACTIONS(5078),
    [sym_synchronized] = ACTIONS(5078),
    [sym_template] = ACTIONS(5078),
    [sym_typeof] = ACTIONS(5078),
    [sym_union] = ACTIONS(5078),
    [sym_unittest] = ACTIONS(5078),
    [sym_version] = ACTIONS(5078),
    [sym_gshared] = ACTIONS(5078),
    [sym_traits] = ACTIONS(5078),
    [sym_vector] = ACTIONS(5078),
    [sym_void] = ACTIONS(5078),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2480] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(6193),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2481] = {
    [sym_identifier] = ACTIONS(6197),
    [anon_sym_LBRACE] = ACTIONS(6199),
    [anon_sym_DOT] = ACTIONS(6199),
    [anon_sym_SEMI] = ACTIONS(6199),
    [anon_sym_COLON] = ACTIONS(6199),
    [anon_sym_TILDE] = ACTIONS(6199),
    [anon_sym_AT] = ACTIONS(6199),
    [sym_bool] = ACTIONS(6197),
    [sym_byte] = ACTIONS(6197),
    [sym_ubyte] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_short] = ACTIONS(6197),
    [sym_ushort] = ACTIONS(6197),
    [sym_int] = ACTIONS(6197),
    [sym_uint] = ACTIONS(6197),
    [sym_long] = ACTIONS(6197),
    [sym_ulong] = ACTIONS(6197),
    [sym_cent] = ACTIONS(6197),
    [sym_ucent] = ACTIONS(6197),
    [sym_wchar] = ACTIONS(6197),
    [sym_dchar] = ACTIONS(6197),
    [sym_float] = ACTIONS(6197),
    [sym_double] = ACTIONS(6197),
    [sym_real] = ACTIONS(6197),
    [sym_ifloat] = ACTIONS(6197),
    [sym_idouble] = ACTIONS(6197),
    [sym_ireal] = ACTIONS(6197),
    [sym_cfloat] = ACTIONS(6197),
    [sym_cdouble] = ACTIONS(6197),
    [sym_creal] = ACTIONS(6197),
    [sym_size_t] = ACTIONS(6197),
    [sym_ptrdiff_t] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym_cstring] = ACTIONS(6197),
    [sym_dstring] = ACTIONS(6197),
    [sym_wstring] = ACTIONS(6197),
    [sym_noreturn] = ACTIONS(6197),
    [sym_this] = ACTIONS(6197),
    [sym_abstract] = ACTIONS(6197),
    [sym_alias] = ACTIONS(6197),
    [sym_align] = ACTIONS(6197),
    [sym_auto] = ACTIONS(6197),
    [sym_class] = ACTIONS(6197),
    [sym_const] = ACTIONS(6197),
    [sym_debug] = ACTIONS(6197),
    [sym_deprecated] = ACTIONS(6197),
    [sym_enum] = ACTIONS(6197),
    [sym_export] = ACTIONS(6197),
    [sym_extern] = ACTIONS(6197),
    [sym_final] = ACTIONS(6197),
    [sym_immutable] = ACTIONS(6197),
    [sym_import] = ACTIONS(6197),
    [sym_inout] = ACTIONS(6197),
    [sym_interface] = ACTIONS(6197),
    [sym_invariant] = ACTIONS(6197),
    [sym_mixin] = ACTIONS(6197),
    [sym_nothrow] = ACTIONS(6197),
    [sym_override] = ACTIONS(6197),
    [sym_package] = ACTIONS(6197),
    [sym_pragma] = ACTIONS(6197),
    [sym_private] = ACTIONS(6197),
    [sym_protected] = ACTIONS(6197),
    [sym_public] = ACTIONS(6197),
    [sym_pure] = ACTIONS(6197),
    [sym_ref] = ACTIONS(6197),
    [sym_return] = ACTIONS(6197),
    [sym_scope] = ACTIONS(6197),
    [sym_shared] = ACTIONS(6197),
    [sym_static] = ACTIONS(6197),
    [sym_struct] = ACTIONS(6197),
    [sym_synchronized] = ACTIONS(6197),
    [sym_template] = ACTIONS(6197),
    [sym_typeof] = ACTIONS(6197),
    [sym_union] = ACTIONS(6197),
    [sym_unittest] = ACTIONS(6197),
    [sym_version] = ACTIONS(6197),
    [sym_gshared] = ACTIONS(6197),
    [sym_traits] = ACTIONS(6197),
    [sym_vector] = ACTIONS(6197),
    [sym_void] = ACTIONS(6197),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2482] = {
    [sym_identifier] = ACTIONS(5048),
    [anon_sym_LBRACE] = ACTIONS(5050),
    [anon_sym_DOT] = ACTIONS(5050),
    [anon_sym_SEMI] = ACTIONS(5050),
    [anon_sym_COLON] = ACTIONS(5050),
    [anon_sym_TILDE] = ACTIONS(5050),
    [anon_sym_AT] = ACTIONS(5050),
    [sym_bool] = ACTIONS(5048),
    [sym_byte] = ACTIONS(5048),
    [sym_ubyte] = ACTIONS(5048),
    [sym_char] = ACTIONS(5048),
    [sym_short] = ACTIONS(5048),
    [sym_ushort] = ACTIONS(5048),
    [sym_int] = ACTIONS(5048),
    [sym_uint] = ACTIONS(5048),
    [sym_long] = ACTIONS(5048),
    [sym_ulong] = ACTIONS(5048),
    [sym_cent] = ACTIONS(5048),
    [sym_ucent] = ACTIONS(5048),
    [sym_wchar] = ACTIONS(5048),
    [sym_dchar] = ACTIONS(5048),
    [sym_float] = ACTIONS(5048),
    [sym_double] = ACTIONS(5048),
    [sym_real] = ACTIONS(5048),
    [sym_ifloat] = ACTIONS(5048),
    [sym_idouble] = ACTIONS(5048),
    [sym_ireal] = ACTIONS(5048),
    [sym_cfloat] = ACTIONS(5048),
    [sym_cdouble] = ACTIONS(5048),
    [sym_creal] = ACTIONS(5048),
    [sym_size_t] = ACTIONS(5048),
    [sym_ptrdiff_t] = ACTIONS(5048),
    [sym_string] = ACTIONS(5048),
    [sym_cstring] = ACTIONS(5048),
    [sym_dstring] = ACTIONS(5048),
    [sym_wstring] = ACTIONS(5048),
    [sym_noreturn] = ACTIONS(5048),
    [sym_this] = ACTIONS(5048),
    [sym_abstract] = ACTIONS(5048),
    [sym_alias] = ACTIONS(5048),
    [sym_align] = ACTIONS(5048),
    [sym_auto] = ACTIONS(5048),
    [sym_class] = ACTIONS(5048),
    [sym_const] = ACTIONS(5048),
    [sym_debug] = ACTIONS(5048),
    [sym_deprecated] = ACTIONS(5048),
    [sym_enum] = ACTIONS(5048),
    [sym_export] = ACTIONS(5048),
    [sym_extern] = ACTIONS(5048),
    [sym_final] = ACTIONS(5048),
    [sym_immutable] = ACTIONS(5048),
    [sym_import] = ACTIONS(5048),
    [sym_inout] = ACTIONS(5048),
    [sym_interface] = ACTIONS(5048),
    [sym_invariant] = ACTIONS(5048),
    [sym_mixin] = ACTIONS(5048),
    [sym_nothrow] = ACTIONS(5048),
    [sym_override] = ACTIONS(5048),
    [sym_package] = ACTIONS(5048),
    [sym_pragma] = ACTIONS(5048),
    [sym_private] = ACTIONS(5048),
    [sym_protected] = ACTIONS(5048),
    [sym_public] = ACTIONS(5048),
    [sym_pure] = ACTIONS(5048),
    [sym_ref] = ACTIONS(5048),
    [sym_return] = ACTIONS(5048),
    [sym_scope] = ACTIONS(5048),
    [sym_shared] = ACTIONS(5048),
    [sym_static] = ACTIONS(5048),
    [sym_struct] = ACTIONS(5048),
    [sym_synchronized] = ACTIONS(5048),
    [sym_template] = ACTIONS(5048),
    [sym_typeof] = ACTIONS(5048),
    [sym_union] = ACTIONS(5048),
    [sym_unittest] = ACTIONS(5048),
    [sym_version] = ACTIONS(5048),
    [sym_gshared] = ACTIONS(5048),
    [sym_traits] = ACTIONS(5048),
    [sym_vector] = ACTIONS(5048),
    [sym_void] = ACTIONS(5048),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2483] = {
    [sym_identifier] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_DOT] = ACTIONS(6203),
    [anon_sym_SEMI] = ACTIONS(6203),
    [anon_sym_COLON] = ACTIONS(6203),
    [anon_sym_TILDE] = ACTIONS(6203),
    [anon_sym_AT] = ACTIONS(6203),
    [sym_bool] = ACTIONS(6201),
    [sym_byte] = ACTIONS(6201),
    [sym_ubyte] = ACTIONS(6201),
    [sym_char] = ACTIONS(6201),
    [sym_short] = ACTIONS(6201),
    [sym_ushort] = ACTIONS(6201),
    [sym_int] = ACTIONS(6201),
    [sym_uint] = ACTIONS(6201),
    [sym_long] = ACTIONS(6201),
    [sym_ulong] = ACTIONS(6201),
    [sym_cent] = ACTIONS(6201),
    [sym_ucent] = ACTIONS(6201),
    [sym_wchar] = ACTIONS(6201),
    [sym_dchar] = ACTIONS(6201),
    [sym_float] = ACTIONS(6201),
    [sym_double] = ACTIONS(6201),
    [sym_real] = ACTIONS(6201),
    [sym_ifloat] = ACTIONS(6201),
    [sym_idouble] = ACTIONS(6201),
    [sym_ireal] = ACTIONS(6201),
    [sym_cfloat] = ACTIONS(6201),
    [sym_cdouble] = ACTIONS(6201),
    [sym_creal] = ACTIONS(6201),
    [sym_size_t] = ACTIONS(6201),
    [sym_ptrdiff_t] = ACTIONS(6201),
    [sym_string] = ACTIONS(6201),
    [sym_cstring] = ACTIONS(6201),
    [sym_dstring] = ACTIONS(6201),
    [sym_wstring] = ACTIONS(6201),
    [sym_noreturn] = ACTIONS(6201),
    [sym_this] = ACTIONS(6201),
    [sym_abstract] = ACTIONS(6201),
    [sym_alias] = ACTIONS(6201),
    [sym_align] = ACTIONS(6201),
    [sym_auto] = ACTIONS(6201),
    [sym_class] = ACTIONS(6201),
    [sym_const] = ACTIONS(6201),
    [sym_debug] = ACTIONS(6201),
    [sym_deprecated] = ACTIONS(6201),
    [sym_enum] = ACTIONS(6201),
    [sym_export] = ACTIONS(6201),
    [sym_extern] = ACTIONS(6201),
    [sym_final] = ACTIONS(6201),
    [sym_immutable] = ACTIONS(6201),
    [sym_import] = ACTIONS(6201),
    [sym_inout] = ACTIONS(6201),
    [sym_interface] = ACTIONS(6201),
    [sym_invariant] = ACTIONS(6201),
    [sym_mixin] = ACTIONS(6201),
    [sym_nothrow] = ACTIONS(6201),
    [sym_override] = ACTIONS(6201),
    [sym_package] = ACTIONS(6201),
    [sym_pragma] = ACTIONS(6201),
    [sym_private] = ACTIONS(6201),
    [sym_protected] = ACTIONS(6201),
    [sym_public] = ACTIONS(6201),
    [sym_pure] = ACTIONS(6201),
    [sym_ref] = ACTIONS(6201),
    [sym_return] = ACTIONS(6201),
    [sym_scope] = ACTIONS(6201),
    [sym_shared] = ACTIONS(6201),
    [sym_static] = ACTIONS(6201),
    [sym_struct] = ACTIONS(6201),
    [sym_synchronized] = ACTIONS(6201),
    [sym_template] = ACTIONS(6201),
    [sym_typeof] = ACTIONS(6201),
    [sym_union] = ACTIONS(6201),
    [sym_unittest] = ACTIONS(6201),
    [sym_version] = ACTIONS(6201),
    [sym_gshared] = ACTIONS(6201),
    [sym_traits] = ACTIONS(6201),
    [sym_vector] = ACTIONS(6201),
    [sym_void] = ACTIONS(6201),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2484] = {
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6205),
    [anon_sym_TILDE] = ACTIONS(6185),
    [anon_sym_AT] = ACTIONS(6185),
    [sym_bool] = ACTIONS(6183),
    [sym_byte] = ACTIONS(6183),
    [sym_ubyte] = ACTIONS(6183),
    [sym_char] = ACTIONS(6183),
    [sym_short] = ACTIONS(6183),
    [sym_ushort] = ACTIONS(6183),
    [sym_int] = ACTIONS(6183),
    [sym_uint] = ACTIONS(6183),
    [sym_long] = ACTIONS(6183),
    [sym_ulong] = ACTIONS(6183),
    [sym_cent] = ACTIONS(6183),
    [sym_ucent] = ACTIONS(6183),
    [sym_wchar] = ACTIONS(6183),
    [sym_dchar] = ACTIONS(6183),
    [sym_float] = ACTIONS(6183),
    [sym_double] = ACTIONS(6183),
    [sym_real] = ACTIONS(6183),
    [sym_ifloat] = ACTIONS(6183),
    [sym_idouble] = ACTIONS(6183),
    [sym_ireal] = ACTIONS(6183),
    [sym_cfloat] = ACTIONS(6183),
    [sym_cdouble] = ACTIONS(6183),
    [sym_creal] = ACTIONS(6183),
    [sym_size_t] = ACTIONS(6183),
    [sym_ptrdiff_t] = ACTIONS(6183),
    [sym_string] = ACTIONS(6183),
    [sym_cstring] = ACTIONS(6183),
    [sym_dstring] = ACTIONS(6183),
    [sym_wstring] = ACTIONS(6183),
    [sym_noreturn] = ACTIONS(6183),
    [sym_this] = ACTIONS(6183),
    [sym_abstract] = ACTIONS(6183),
    [sym_alias] = ACTIONS(6183),
    [sym_align] = ACTIONS(6183),
    [sym_auto] = ACTIONS(6183),
    [sym_class] = ACTIONS(6183),
    [sym_const] = ACTIONS(6183),
    [sym_debug] = ACTIONS(6183),
    [sym_deprecated] = ACTIONS(6183),
    [sym_enum] = ACTIONS(6183),
    [sym_export] = ACTIONS(6183),
    [sym_extern] = ACTIONS(6183),
    [sym_final] = ACTIONS(6183),
    [sym_immutable] = ACTIONS(6183),
    [sym_import] = ACTIONS(6183),
    [sym_inout] = ACTIONS(6183),
    [sym_interface] = ACTIONS(6183),
    [sym_invariant] = ACTIONS(6183),
    [sym_mixin] = ACTIONS(6183),
    [sym_nothrow] = ACTIONS(6183),
    [sym_override] = ACTIONS(6183),
    [sym_package] = ACTIONS(6183),
    [sym_pragma] = ACTIONS(6183),
    [sym_private] = ACTIONS(6183),
    [sym_protected] = ACTIONS(6183),
    [sym_public] = ACTIONS(6183),
    [sym_pure] = ACTIONS(6183),
    [sym_ref] = ACTIONS(6183),
    [sym_return] = ACTIONS(6183),
    [sym_scope] = ACTIONS(6183),
    [sym_shared] = ACTIONS(6183),
    [sym_static] = ACTIONS(6183),
    [sym_struct] = ACTIONS(6183),
    [sym_synchronized] = ACTIONS(6183),
    [sym_template] = ACTIONS(6183),
    [sym_typeof] = ACTIONS(6183),
    [sym_union] = ACTIONS(6183),
    [sym_unittest] = ACTIONS(6183),
    [sym_version] = ACTIONS(6183),
    [sym_gshared] = ACTIONS(6183),
    [sym_traits] = ACTIONS(6183),
    [sym_vector] = ACTIONS(6183),
    [sym_void] = ACTIONS(6183),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2485] = {
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6207),
    [anon_sym_TILDE] = ACTIONS(6185),
    [anon_sym_AT] = ACTIONS(6185),
    [sym_bool] = ACTIONS(6183),
    [sym_byte] = ACTIONS(6183),
    [sym_ubyte] = ACTIONS(6183),
    [sym_char] = ACTIONS(6183),
    [sym_short] = ACTIONS(6183),
    [sym_ushort] = ACTIONS(6183),
    [sym_int] = ACTIONS(6183),
    [sym_uint] = ACTIONS(6183),
    [sym_long] = ACTIONS(6183),
    [sym_ulong] = ACTIONS(6183),
    [sym_cent] = ACTIONS(6183),
    [sym_ucent] = ACTIONS(6183),
    [sym_wchar] = ACTIONS(6183),
    [sym_dchar] = ACTIONS(6183),
    [sym_float] = ACTIONS(6183),
    [sym_double] = ACTIONS(6183),
    [sym_real] = ACTIONS(6183),
    [sym_ifloat] = ACTIONS(6183),
    [sym_idouble] = ACTIONS(6183),
    [sym_ireal] = ACTIONS(6183),
    [sym_cfloat] = ACTIONS(6183),
    [sym_cdouble] = ACTIONS(6183),
    [sym_creal] = ACTIONS(6183),
    [sym_size_t] = ACTIONS(6183),
    [sym_ptrdiff_t] = ACTIONS(6183),
    [sym_string] = ACTIONS(6183),
    [sym_cstring] = ACTIONS(6183),
    [sym_dstring] = ACTIONS(6183),
    [sym_wstring] = ACTIONS(6183),
    [sym_noreturn] = ACTIONS(6183),
    [sym_this] = ACTIONS(6183),
    [sym_abstract] = ACTIONS(6183),
    [sym_alias] = ACTIONS(6183),
    [sym_align] = ACTIONS(6183),
    [sym_auto] = ACTIONS(6183),
    [sym_class] = ACTIONS(6183),
    [sym_const] = ACTIONS(6183),
    [sym_debug] = ACTIONS(6183),
    [sym_deprecated] = ACTIONS(6183),
    [sym_enum] = ACTIONS(6183),
    [sym_export] = ACTIONS(6183),
    [sym_extern] = ACTIONS(6183),
    [sym_final] = ACTIONS(6183),
    [sym_immutable] = ACTIONS(6183),
    [sym_import] = ACTIONS(6183),
    [sym_inout] = ACTIONS(6183),
    [sym_interface] = ACTIONS(6183),
    [sym_invariant] = ACTIONS(6183),
    [sym_mixin] = ACTIONS(6183),
    [sym_nothrow] = ACTIONS(6183),
    [sym_override] = ACTIONS(6183),
    [sym_package] = ACTIONS(6183),
    [sym_pragma] = ACTIONS(6183),
    [sym_private] = ACTIONS(6183),
    [sym_protected] = ACTIONS(6183),
    [sym_public] = ACTIONS(6183),
    [sym_pure] = ACTIONS(6183),
    [sym_ref] = ACTIONS(6183),
    [sym_return] = ACTIONS(6183),
    [sym_scope] = ACTIONS(6183),
    [sym_shared] = ACTIONS(6183),
    [sym_static] = ACTIONS(6183),
    [sym_struct] = ACTIONS(6183),
    [sym_synchronized] = ACTIONS(6183),
    [sym_template] = ACTIONS(6183),
    [sym_typeof] = ACTIONS(6183),
    [sym_union] = ACTIONS(6183),
    [sym_unittest] = ACTIONS(6183),
    [sym_version] = ACTIONS(6183),
    [sym_gshared] = ACTIONS(6183),
    [sym_traits] = ACTIONS(6183),
    [sym_vector] = ACTIONS(6183),
    [sym_void] = ACTIONS(6183),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2486] = {
    [sym_identifier] = ACTIONS(6209),
    [anon_sym_LBRACE] = ACTIONS(6211),
    [anon_sym_DOT] = ACTIONS(6211),
    [anon_sym_SEMI] = ACTIONS(6211),
    [anon_sym_COLON] = ACTIONS(6211),
    [anon_sym_TILDE] = ACTIONS(6211),
    [anon_sym_AT] = ACTIONS(6211),
    [sym_bool] = ACTIONS(6209),
    [sym_byte] = ACTIONS(6209),
    [sym_ubyte] = ACTIONS(6209),
    [sym_char] = ACTIONS(6209),
    [sym_short] = ACTIONS(6209),
    [sym_ushort] = ACTIONS(6209),
    [sym_int] = ACTIONS(6209),
    [sym_uint] = ACTIONS(6209),
    [sym_long] = ACTIONS(6209),
    [sym_ulong] = ACTIONS(6209),
    [sym_cent] = ACTIONS(6209),
    [sym_ucent] = ACTIONS(6209),
    [sym_wchar] = ACTIONS(6209),
    [sym_dchar] = ACTIONS(6209),
    [sym_float] = ACTIONS(6209),
    [sym_double] = ACTIONS(6209),
    [sym_real] = ACTIONS(6209),
    [sym_ifloat] = ACTIONS(6209),
    [sym_idouble] = ACTIONS(6209),
    [sym_ireal] = ACTIONS(6209),
    [sym_cfloat] = ACTIONS(6209),
    [sym_cdouble] = ACTIONS(6209),
    [sym_creal] = ACTIONS(6209),
    [sym_size_t] = ACTIONS(6209),
    [sym_ptrdiff_t] = ACTIONS(6209),
    [sym_string] = ACTIONS(6209),
    [sym_cstring] = ACTIONS(6209),
    [sym_dstring] = ACTIONS(6209),
    [sym_wstring] = ACTIONS(6209),
    [sym_noreturn] = ACTIONS(6209),
    [sym_this] = ACTIONS(6209),
    [sym_abstract] = ACTIONS(6209),
    [sym_alias] = ACTIONS(6209),
    [sym_align] = ACTIONS(6209),
    [sym_auto] = ACTIONS(6209),
    [sym_class] = ACTIONS(6209),
    [sym_const] = ACTIONS(6209),
    [sym_debug] = ACTIONS(6209),
    [sym_deprecated] = ACTIONS(6209),
    [sym_enum] = ACTIONS(6209),
    [sym_export] = ACTIONS(6209),
    [sym_extern] = ACTIONS(6209),
    [sym_final] = ACTIONS(6209),
    [sym_immutable] = ACTIONS(6209),
    [sym_import] = ACTIONS(6209),
    [sym_inout] = ACTIONS(6209),
    [sym_interface] = ACTIONS(6209),
    [sym_invariant] = ACTIONS(6209),
    [sym_mixin] = ACTIONS(6209),
    [sym_nothrow] = ACTIONS(6209),
    [sym_override] = ACTIONS(6209),
    [sym_package] = ACTIONS(6209),
    [sym_pragma] = ACTIONS(6209),
    [sym_private] = ACTIONS(6209),
    [sym_protected] = ACTIONS(6209),
    [sym_public] = ACTIONS(6209),
    [sym_pure] = ACTIONS(6209),
    [sym_ref] = ACTIONS(6209),
    [sym_return] = ACTIONS(6209),
    [sym_scope] = ACTIONS(6209),
    [sym_shared] = ACTIONS(6209),
    [sym_static] = ACTIONS(6209),
    [sym_struct] = ACTIONS(6209),
    [sym_synchronized] = ACTIONS(6209),
    [sym_template] = ACTIONS(6209),
    [sym_typeof] = ACTIONS(6209),
    [sym_union] = ACTIONS(6209),
    [sym_unittest] = ACTIONS(6209),
    [sym_version] = ACTIONS(6209),
    [sym_gshared] = ACTIONS(6209),
    [sym_traits] = ACTIONS(6209),
    [sym_vector] = ACTIONS(6209),
    [sym_void] = ACTIONS(6209),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2487] = {
    [ts_builtin_sym_end] = ACTIONS(6213),
    [sym_identifier] = ACTIONS(6215),
    [anon_sym_DOT] = ACTIONS(6213),
    [anon_sym_SEMI] = ACTIONS(6213),
    [anon_sym_TILDE] = ACTIONS(6213),
    [anon_sym_AT] = ACTIONS(6213),
    [sym_bool] = ACTIONS(6215),
    [sym_byte] = ACTIONS(6215),
    [sym_ubyte] = ACTIONS(6215),
    [sym_char] = ACTIONS(6215),
    [sym_short] = ACTIONS(6215),
    [sym_ushort] = ACTIONS(6215),
    [sym_int] = ACTIONS(6215),
    [sym_uint] = ACTIONS(6215),
    [sym_long] = ACTIONS(6215),
    [sym_ulong] = ACTIONS(6215),
    [sym_cent] = ACTIONS(6215),
    [sym_ucent] = ACTIONS(6215),
    [sym_wchar] = ACTIONS(6215),
    [sym_dchar] = ACTIONS(6215),
    [sym_float] = ACTIONS(6215),
    [sym_double] = ACTIONS(6215),
    [sym_real] = ACTIONS(6215),
    [sym_ifloat] = ACTIONS(6215),
    [sym_idouble] = ACTIONS(6215),
    [sym_ireal] = ACTIONS(6215),
    [sym_cfloat] = ACTIONS(6215),
    [sym_cdouble] = ACTIONS(6215),
    [sym_creal] = ACTIONS(6215),
    [sym_size_t] = ACTIONS(6215),
    [sym_ptrdiff_t] = ACTIONS(6215),
    [sym_string] = ACTIONS(6215),
    [sym_cstring] = ACTIONS(6215),
    [sym_dstring] = ACTIONS(6215),
    [sym_wstring] = ACTIONS(6215),
    [sym_noreturn] = ACTIONS(6215),
    [sym_this] = ACTIONS(6215),
    [sym_abstract] = ACTIONS(6215),
    [sym_alias] = ACTIONS(6215),
    [sym_align] = ACTIONS(6215),
    [sym_auto] = ACTIONS(6215),
    [sym_class] = ACTIONS(6215),
    [sym_const] = ACTIONS(6215),
    [sym_debug] = ACTIONS(6215),
    [sym_deprecated] = ACTIONS(6215),
    [sym_enum] = ACTIONS(6215),
    [sym_export] = ACTIONS(6215),
    [sym_extern] = ACTIONS(6215),
    [sym_final] = ACTIONS(6215),
    [sym_immutable] = ACTIONS(6215),
    [sym_import] = ACTIONS(6215),
    [sym_inout] = ACTIONS(6215),
    [sym_interface] = ACTIONS(6215),
    [sym_invariant] = ACTIONS(6215),
    [sym_mixin] = ACTIONS(6215),
    [sym_module] = ACTIONS(6215),
    [sym_nothrow] = ACTIONS(6215),
    [sym_override] = ACTIONS(6215),
    [sym_package] = ACTIONS(6215),
    [sym_pragma] = ACTIONS(6215),
    [sym_private] = ACTIONS(6215),
    [sym_protected] = ACTIONS(6215),
    [sym_public] = ACTIONS(6215),
    [sym_pure] = ACTIONS(6215),
    [sym_ref] = ACTIONS(6215),
    [sym_return] = ACTIONS(6215),
    [sym_scope] = ACTIONS(6215),
    [sym_shared] = ACTIONS(6215),
    [sym_static] = ACTIONS(6215),
    [sym_struct] = ACTIONS(6215),
    [sym_synchronized] = ACTIONS(6215),
    [sym_template] = ACTIONS(6215),
    [sym_typeof] = ACTIONS(6215),
    [sym_union] = ACTIONS(6215),
    [sym_unittest] = ACTIONS(6215),
    [sym_version] = ACTIONS(6215),
    [sym_gshared] = ACTIONS(6215),
    [sym_traits] = ACTIONS(6215),
    [sym_vector] = ACTIONS(6215),
    [sym_void] = ACTIONS(6215),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2488] = {
    [sym_identifier] = ACTIONS(5062),
    [anon_sym_LBRACE] = ACTIONS(5064),
    [anon_sym_DOT] = ACTIONS(5064),
    [anon_sym_SEMI] = ACTIONS(5064),
    [anon_sym_COLON] = ACTIONS(5064),
    [anon_sym_TILDE] = ACTIONS(5064),
    [anon_sym_AT] = ACTIONS(5064),
    [sym_bool] = ACTIONS(5062),
    [sym_byte] = ACTIONS(5062),
    [sym_ubyte] = ACTIONS(5062),
    [sym_char] = ACTIONS(5062),
    [sym_short] = ACTIONS(5062),
    [sym_ushort] = ACTIONS(5062),
    [sym_int] = ACTIONS(5062),
    [sym_uint] = ACTIONS(5062),
    [sym_long] = ACTIONS(5062),
    [sym_ulong] = ACTIONS(5062),
    [sym_cent] = ACTIONS(5062),
    [sym_ucent] = ACTIONS(5062),
    [sym_wchar] = ACTIONS(5062),
    [sym_dchar] = ACTIONS(5062),
    [sym_float] = ACTIONS(5062),
    [sym_double] = ACTIONS(5062),
    [sym_real] = ACTIONS(5062),
    [sym_ifloat] = ACTIONS(5062),
    [sym_idouble] = ACTIONS(5062),
    [sym_ireal] = ACTIONS(5062),
    [sym_cfloat] = ACTIONS(5062),
    [sym_cdouble] = ACTIONS(5062),
    [sym_creal] = ACTIONS(5062),
    [sym_size_t] = ACTIONS(5062),
    [sym_ptrdiff_t] = ACTIONS(5062),
    [sym_string] = ACTIONS(5062),
    [sym_cstring] = ACTIONS(5062),
    [sym_dstring] = ACTIONS(5062),
    [sym_wstring] = ACTIONS(5062),
    [sym_noreturn] = ACTIONS(5062),
    [sym_this] = ACTIONS(5062),
    [sym_abstract] = ACTIONS(5062),
    [sym_alias] = ACTIONS(5062),
    [sym_align] = ACTIONS(5062),
    [sym_auto] = ACTIONS(5062),
    [sym_class] = ACTIONS(5062),
    [sym_const] = ACTIONS(5062),
    [sym_debug] = ACTIONS(5062),
    [sym_deprecated] = ACTIONS(5062),
    [sym_enum] = ACTIONS(5062),
    [sym_export] = ACTIONS(5062),
    [sym_extern] = ACTIONS(5062),
    [sym_final] = ACTIONS(5062),
    [sym_immutable] = ACTIONS(5062),
    [sym_import] = ACTIONS(5062),
    [sym_inout] = ACTIONS(5062),
    [sym_interface] = ACTIONS(5062),
    [sym_invariant] = ACTIONS(5062),
    [sym_mixin] = ACTIONS(5062),
    [sym_nothrow] = ACTIONS(5062),
    [sym_override] = ACTIONS(5062),
    [sym_package] = ACTIONS(5062),
    [sym_pragma] = ACTIONS(5062),
    [sym_private] = ACTIONS(5062),
    [sym_protected] = ACTIONS(5062),
    [sym_public] = ACTIONS(5062),
    [sym_pure] = ACTIONS(5062),
    [sym_ref] = ACTIONS(5062),
    [sym_return] = ACTIONS(5062),
    [sym_scope] = ACTIONS(5062),
    [sym_shared] = ACTIONS(5062),
    [sym_static] = ACTIONS(5062),
    [sym_struct] = ACTIONS(5062),
    [sym_synchronized] = ACTIONS(5062),
    [sym_template] = ACTIONS(5062),
    [sym_typeof] = ACTIONS(5062),
    [sym_union] = ACTIONS(5062),
    [sym_unittest] = ACTIONS(5062),
    [sym_version] = ACTIONS(5062),
    [sym_gshared] = ACTIONS(5062),
    [sym_traits] = ACTIONS(5062),
    [sym_vector] = ACTIONS(5062),
    [sym_void] = ACTIONS(5062),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2489] = {
    [sym_identifier] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(5072),
    [anon_sym_DOT] = ACTIONS(5072),
    [anon_sym_SEMI] = ACTIONS(5072),
    [anon_sym_COLON] = ACTIONS(5072),
    [anon_sym_TILDE] = ACTIONS(5072),
    [anon_sym_AT] = ACTIONS(5072),
    [sym_bool] = ACTIONS(5070),
    [sym_byte] = ACTIONS(5070),
    [sym_ubyte] = ACTIONS(5070),
    [sym_char] = ACTIONS(5070),
    [sym_short] = ACTIONS(5070),
    [sym_ushort] = ACTIONS(5070),
    [sym_int] = ACTIONS(5070),
    [sym_uint] = ACTIONS(5070),
    [sym_long] = ACTIONS(5070),
    [sym_ulong] = ACTIONS(5070),
    [sym_cent] = ACTIONS(5070),
    [sym_ucent] = ACTIONS(5070),
    [sym_wchar] = ACTIONS(5070),
    [sym_dchar] = ACTIONS(5070),
    [sym_float] = ACTIONS(5070),
    [sym_double] = ACTIONS(5070),
    [sym_real] = ACTIONS(5070),
    [sym_ifloat] = ACTIONS(5070),
    [sym_idouble] = ACTIONS(5070),
    [sym_ireal] = ACTIONS(5070),
    [sym_cfloat] = ACTIONS(5070),
    [sym_cdouble] = ACTIONS(5070),
    [sym_creal] = ACTIONS(5070),
    [sym_size_t] = ACTIONS(5070),
    [sym_ptrdiff_t] = ACTIONS(5070),
    [sym_string] = ACTIONS(5070),
    [sym_cstring] = ACTIONS(5070),
    [sym_dstring] = ACTIONS(5070),
    [sym_wstring] = ACTIONS(5070),
    [sym_noreturn] = ACTIONS(5070),
    [sym_this] = ACTIONS(5070),
    [sym_abstract] = ACTIONS(5070),
    [sym_alias] = ACTIONS(5070),
    [sym_align] = ACTIONS(5070),
    [sym_auto] = ACTIONS(5070),
    [sym_class] = ACTIONS(5070),
    [sym_const] = ACTIONS(5070),
    [sym_debug] = ACTIONS(5070),
    [sym_deprecated] = ACTIONS(5070),
    [sym_enum] = ACTIONS(5070),
    [sym_export] = ACTIONS(5070),
    [sym_extern] = ACTIONS(5070),
    [sym_final] = ACTIONS(5070),
    [sym_immutable] = ACTIONS(5070),
    [sym_import] = ACTIONS(5070),
    [sym_inout] = ACTIONS(5070),
    [sym_interface] = ACTIONS(5070),
    [sym_invariant] = ACTIONS(5070),
    [sym_mixin] = ACTIONS(5070),
    [sym_nothrow] = ACTIONS(5070),
    [sym_override] = ACTIONS(5070),
    [sym_package] = ACTIONS(5070),
    [sym_pragma] = ACTIONS(5070),
    [sym_private] = ACTIONS(5070),
    [sym_protected] = ACTIONS(5070),
    [sym_public] = ACTIONS(5070),
    [sym_pure] = ACTIONS(5070),
    [sym_ref] = ACTIONS(5070),
    [sym_return] = ACTIONS(5070),
    [sym_scope] = ACTIONS(5070),
    [sym_shared] = ACTIONS(5070),
    [sym_static] = ACTIONS(5070),
    [sym_struct] = ACTIONS(5070),
    [sym_synchronized] = ACTIONS(5070),
    [sym_template] = ACTIONS(5070),
    [sym_typeof] = ACTIONS(5070),
    [sym_union] = ACTIONS(5070),
    [sym_unittest] = ACTIONS(5070),
    [sym_version] = ACTIONS(5070),
    [sym_gshared] = ACTIONS(5070),
    [sym_traits] = ACTIONS(5070),
    [sym_vector] = ACTIONS(5070),
    [sym_void] = ACTIONS(5070),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2490] = {
    [sym_identifier] = ACTIONS(6217),
    [anon_sym_LBRACE] = ACTIONS(6219),
    [anon_sym_DOT] = ACTIONS(6219),
    [anon_sym_SEMI] = ACTIONS(6219),
    [anon_sym_COLON] = ACTIONS(6219),
    [anon_sym_TILDE] = ACTIONS(6219),
    [anon_sym_AT] = ACTIONS(6219),
    [sym_bool] = ACTIONS(6217),
    [sym_byte] = ACTIONS(6217),
    [sym_ubyte] = ACTIONS(6217),
    [sym_char] = ACTIONS(6217),
    [sym_short] = ACTIONS(6217),
    [sym_ushort] = ACTIONS(6217),
    [sym_int] = ACTIONS(6217),
    [sym_uint] = ACTIONS(6217),
    [sym_long] = ACTIONS(6217),
    [sym_ulong] = ACTIONS(6217),
    [sym_cent] = ACTIONS(6217),
    [sym_ucent] = ACTIONS(6217),
    [sym_wchar] = ACTIONS(6217),
    [sym_dchar] = ACTIONS(6217),
    [sym_float] = ACTIONS(6217),
    [sym_double] = ACTIONS(6217),
    [sym_real] = ACTIONS(6217),
    [sym_ifloat] = ACTIONS(6217),
    [sym_idouble] = ACTIONS(6217),
    [sym_ireal] = ACTIONS(6217),
    [sym_cfloat] = ACTIONS(6217),
    [sym_cdouble] = ACTIONS(6217),
    [sym_creal] = ACTIONS(6217),
    [sym_size_t] = ACTIONS(6217),
    [sym_ptrdiff_t] = ACTIONS(6217),
    [sym_string] = ACTIONS(6217),
    [sym_cstring] = ACTIONS(6217),
    [sym_dstring] = ACTIONS(6217),
    [sym_wstring] = ACTIONS(6217),
    [sym_noreturn] = ACTIONS(6217),
    [sym_this] = ACTIONS(6217),
    [sym_abstract] = ACTIONS(6217),
    [sym_alias] = ACTIONS(6217),
    [sym_align] = ACTIONS(6217),
    [sym_auto] = ACTIONS(6217),
    [sym_class] = ACTIONS(6217),
    [sym_const] = ACTIONS(6217),
    [sym_debug] = ACTIONS(6217),
    [sym_deprecated] = ACTIONS(6217),
    [sym_enum] = ACTIONS(6217),
    [sym_export] = ACTIONS(6217),
    [sym_extern] = ACTIONS(6217),
    [sym_final] = ACTIONS(6217),
    [sym_immutable] = ACTIONS(6217),
    [sym_import] = ACTIONS(6217),
    [sym_inout] = ACTIONS(6217),
    [sym_interface] = ACTIONS(6217),
    [sym_invariant] = ACTIONS(6217),
    [sym_mixin] = ACTIONS(6217),
    [sym_nothrow] = ACTIONS(6217),
    [sym_override] = ACTIONS(6217),
    [sym_package] = ACTIONS(6217),
    [sym_pragma] = ACTIONS(6217),
    [sym_private] = ACTIONS(6217),
    [sym_protected] = ACTIONS(6217),
    [sym_public] = ACTIONS(6217),
    [sym_pure] = ACTIONS(6217),
    [sym_ref] = ACTIONS(6217),
    [sym_return] = ACTIONS(6217),
    [sym_scope] = ACTIONS(6217),
    [sym_shared] = ACTIONS(6217),
    [sym_static] = ACTIONS(6217),
    [sym_struct] = ACTIONS(6217),
    [sym_synchronized] = ACTIONS(6217),
    [sym_template] = ACTIONS(6217),
    [sym_typeof] = ACTIONS(6217),
    [sym_union] = ACTIONS(6217),
    [sym_unittest] = ACTIONS(6217),
    [sym_version] = ACTIONS(6217),
    [sym_gshared] = ACTIONS(6217),
    [sym_traits] = ACTIONS(6217),
    [sym_vector] = ACTIONS(6217),
    [sym_void] = ACTIONS(6217),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2491] = {
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6221),
    [anon_sym_TILDE] = ACTIONS(6185),
    [anon_sym_AT] = ACTIONS(6185),
    [sym_bool] = ACTIONS(6183),
    [sym_byte] = ACTIONS(6183),
    [sym_ubyte] = ACTIONS(6183),
    [sym_char] = ACTIONS(6183),
    [sym_short] = ACTIONS(6183),
    [sym_ushort] = ACTIONS(6183),
    [sym_int] = ACTIONS(6183),
    [sym_uint] = ACTIONS(6183),
    [sym_long] = ACTIONS(6183),
    [sym_ulong] = ACTIONS(6183),
    [sym_cent] = ACTIONS(6183),
    [sym_ucent] = ACTIONS(6183),
    [sym_wchar] = ACTIONS(6183),
    [sym_dchar] = ACTIONS(6183),
    [sym_float] = ACTIONS(6183),
    [sym_double] = ACTIONS(6183),
    [sym_real] = ACTIONS(6183),
    [sym_ifloat] = ACTIONS(6183),
    [sym_idouble] = ACTIONS(6183),
    [sym_ireal] = ACTIONS(6183),
    [sym_cfloat] = ACTIONS(6183),
    [sym_cdouble] = ACTIONS(6183),
    [sym_creal] = ACTIONS(6183),
    [sym_size_t] = ACTIONS(6183),
    [sym_ptrdiff_t] = ACTIONS(6183),
    [sym_string] = ACTIONS(6183),
    [sym_cstring] = ACTIONS(6183),
    [sym_dstring] = ACTIONS(6183),
    [sym_wstring] = ACTIONS(6183),
    [sym_noreturn] = ACTIONS(6183),
    [sym_this] = ACTIONS(6183),
    [sym_abstract] = ACTIONS(6183),
    [sym_alias] = ACTIONS(6183),
    [sym_align] = ACTIONS(6183),
    [sym_auto] = ACTIONS(6183),
    [sym_class] = ACTIONS(6183),
    [sym_const] = ACTIONS(6183),
    [sym_debug] = ACTIONS(6183),
    [sym_deprecated] = ACTIONS(6183),
    [sym_enum] = ACTIONS(6183),
    [sym_export] = ACTIONS(6183),
    [sym_extern] = ACTIONS(6183),
    [sym_final] = ACTIONS(6183),
    [sym_immutable] = ACTIONS(6183),
    [sym_import] = ACTIONS(6183),
    [sym_inout] = ACTIONS(6183),
    [sym_interface] = ACTIONS(6183),
    [sym_invariant] = ACTIONS(6183),
    [sym_mixin] = ACTIONS(6183),
    [sym_nothrow] = ACTIONS(6183),
    [sym_override] = ACTIONS(6183),
    [sym_package] = ACTIONS(6183),
    [sym_pragma] = ACTIONS(6183),
    [sym_private] = ACTIONS(6183),
    [sym_protected] = ACTIONS(6183),
    [sym_public] = ACTIONS(6183),
    [sym_pure] = ACTIONS(6183),
    [sym_ref] = ACTIONS(6183),
    [sym_return] = ACTIONS(6183),
    [sym_scope] = ACTIONS(6183),
    [sym_shared] = ACTIONS(6183),
    [sym_static] = ACTIONS(6183),
    [sym_struct] = ACTIONS(6183),
    [sym_synchronized] = ACTIONS(6183),
    [sym_template] = ACTIONS(6183),
    [sym_typeof] = ACTIONS(6183),
    [sym_union] = ACTIONS(6183),
    [sym_unittest] = ACTIONS(6183),
    [sym_version] = ACTIONS(6183),
    [sym_gshared] = ACTIONS(6183),
    [sym_traits] = ACTIONS(6183),
    [sym_vector] = ACTIONS(6183),
    [sym_void] = ACTIONS(6183),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2492] = {
    [sym_identifier] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(5076),
    [anon_sym_DOT] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5076),
    [anon_sym_COLON] = ACTIONS(5076),
    [anon_sym_TILDE] = ACTIONS(5076),
    [anon_sym_AT] = ACTIONS(5076),
    [sym_bool] = ACTIONS(5074),
    [sym_byte] = ACTIONS(5074),
    [sym_ubyte] = ACTIONS(5074),
    [sym_char] = ACTIONS(5074),
    [sym_short] = ACTIONS(5074),
    [sym_ushort] = ACTIONS(5074),
    [sym_int] = ACTIONS(5074),
    [sym_uint] = ACTIONS(5074),
    [sym_long] = ACTIONS(5074),
    [sym_ulong] = ACTIONS(5074),
    [sym_cent] = ACTIONS(5074),
    [sym_ucent] = ACTIONS(5074),
    [sym_wchar] = ACTIONS(5074),
    [sym_dchar] = ACTIONS(5074),
    [sym_float] = ACTIONS(5074),
    [sym_double] = ACTIONS(5074),
    [sym_real] = ACTIONS(5074),
    [sym_ifloat] = ACTIONS(5074),
    [sym_idouble] = ACTIONS(5074),
    [sym_ireal] = ACTIONS(5074),
    [sym_cfloat] = ACTIONS(5074),
    [sym_cdouble] = ACTIONS(5074),
    [sym_creal] = ACTIONS(5074),
    [sym_size_t] = ACTIONS(5074),
    [sym_ptrdiff_t] = ACTIONS(5074),
    [sym_string] = ACTIONS(5074),
    [sym_cstring] = ACTIONS(5074),
    [sym_dstring] = ACTIONS(5074),
    [sym_wstring] = ACTIONS(5074),
    [sym_noreturn] = ACTIONS(5074),
    [sym_this] = ACTIONS(5074),
    [sym_abstract] = ACTIONS(5074),
    [sym_alias] = ACTIONS(5074),
    [sym_align] = ACTIONS(5074),
    [sym_auto] = ACTIONS(5074),
    [sym_class] = ACTIONS(5074),
    [sym_const] = ACTIONS(5074),
    [sym_debug] = ACTIONS(5074),
    [sym_deprecated] = ACTIONS(5074),
    [sym_enum] = ACTIONS(5074),
    [sym_export] = ACTIONS(5074),
    [sym_extern] = ACTIONS(5074),
    [sym_final] = ACTIONS(5074),
    [sym_immutable] = ACTIONS(5074),
    [sym_import] = ACTIONS(5074),
    [sym_inout] = ACTIONS(5074),
    [sym_interface] = ACTIONS(5074),
    [sym_invariant] = ACTIONS(5074),
    [sym_mixin] = ACTIONS(5074),
    [sym_nothrow] = ACTIONS(5074),
    [sym_override] = ACTIONS(5074),
    [sym_package] = ACTIONS(5074),
    [sym_pragma] = ACTIONS(5074),
    [sym_private] = ACTIONS(5074),
    [sym_protected] = ACTIONS(5074),
    [sym_public] = ACTIONS(5074),
    [sym_pure] = ACTIONS(5074),
    [sym_ref] = ACTIONS(5074),
    [sym_return] = ACTIONS(5074),
    [sym_scope] = ACTIONS(5074),
    [sym_shared] = ACTIONS(5074),
    [sym_static] = ACTIONS(5074),
    [sym_struct] = ACTIONS(5074),
    [sym_synchronized] = ACTIONS(5074),
    [sym_template] = ACTIONS(5074),
    [sym_typeof] = ACTIONS(5074),
    [sym_union] = ACTIONS(5074),
    [sym_unittest] = ACTIONS(5074),
    [sym_version] = ACTIONS(5074),
    [sym_gshared] = ACTIONS(5074),
    [sym_traits] = ACTIONS(5074),
    [sym_vector] = ACTIONS(5074),
    [sym_void] = ACTIONS(5074),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2493] = {
    [sym_identifier] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(669),
    [anon_sym_LPAREN] = ACTIONS(6152),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(669),
    [sym_bool] = ACTIONS(3019),
    [sym_byte] = ACTIONS(3019),
    [sym_ubyte] = ACTIONS(3019),
    [sym_char] = ACTIONS(3019),
    [sym_short] = ACTIONS(3019),
    [sym_ushort] = ACTIONS(3019),
    [sym_int] = ACTIONS(3019),
    [sym_uint] = ACTIONS(3019),
    [sym_long] = ACTIONS(3019),
    [sym_ulong] = ACTIONS(3019),
    [sym_cent] = ACTIONS(3019),
    [sym_ucent] = ACTIONS(3019),
    [sym_wchar] = ACTIONS(3019),
    [sym_dchar] = ACTIONS(3019),
    [sym_float] = ACTIONS(3019),
    [sym_double] = ACTIONS(3019),
    [sym_real] = ACTIONS(3019),
    [sym_ifloat] = ACTIONS(3019),
    [sym_idouble] = ACTIONS(3019),
    [sym_ireal] = ACTIONS(3019),
    [sym_cfloat] = ACTIONS(3019),
    [sym_cdouble] = ACTIONS(3019),
    [sym_creal] = ACTIONS(3019),
    [sym_size_t] = ACTIONS(3019),
    [sym_ptrdiff_t] = ACTIONS(3019),
    [sym_string] = ACTIONS(3019),
    [sym_cstring] = ACTIONS(3019),
    [sym_dstring] = ACTIONS(3019),
    [sym_wstring] = ACTIONS(3019),
    [sym_noreturn] = ACTIONS(3019),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(3019),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(3019),
    [sym_auto] = ACTIONS(3019),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(3019),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(3019),
    [sym_enum] = ACTIONS(3019),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(3019),
    [sym_final] = ACTIONS(3019),
    [sym_immutable] = ACTIONS(3019),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(3019),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(3019),
    [sym_nothrow] = ACTIONS(3019),
    [sym_override] = ACTIONS(3019),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(3019),
    [sym_ref] = ACTIONS(3019),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(3019),
    [sym_shared] = ACTIONS(3019),
    [sym_static] = ACTIONS(3019),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(3019),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(3019),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(3019),
    [sym_traits] = ACTIONS(3019),
    [sym_vector] = ACTIONS(3019),
    [sym_void] = ACTIONS(3019),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2494] = {
    [sym_identifier] = ACTIONS(6223),
    [anon_sym_LBRACE] = ACTIONS(6225),
    [anon_sym_DOT] = ACTIONS(6225),
    [anon_sym_SEMI] = ACTIONS(6225),
    [anon_sym_COLON] = ACTIONS(6225),
    [anon_sym_TILDE] = ACTIONS(6225),
    [anon_sym_AT] = ACTIONS(6225),
    [sym_bool] = ACTIONS(6223),
    [sym_byte] = ACTIONS(6223),
    [sym_ubyte] = ACTIONS(6223),
    [sym_char] = ACTIONS(6223),
    [sym_short] = ACTIONS(6223),
    [sym_ushort] = ACTIONS(6223),
    [sym_int] = ACTIONS(6223),
    [sym_uint] = ACTIONS(6223),
    [sym_long] = ACTIONS(6223),
    [sym_ulong] = ACTIONS(6223),
    [sym_cent] = ACTIONS(6223),
    [sym_ucent] = ACTIONS(6223),
    [sym_wchar] = ACTIONS(6223),
    [sym_dchar] = ACTIONS(6223),
    [sym_float] = ACTIONS(6223),
    [sym_double] = ACTIONS(6223),
    [sym_real] = ACTIONS(6223),
    [sym_ifloat] = ACTIONS(6223),
    [sym_idouble] = ACTIONS(6223),
    [sym_ireal] = ACTIONS(6223),
    [sym_cfloat] = ACTIONS(6223),
    [sym_cdouble] = ACTIONS(6223),
    [sym_creal] = ACTIONS(6223),
    [sym_size_t] = ACTIONS(6223),
    [sym_ptrdiff_t] = ACTIONS(6223),
    [sym_string] = ACTIONS(6223),
    [sym_cstring] = ACTIONS(6223),
    [sym_dstring] = ACTIONS(6223),
    [sym_wstring] = ACTIONS(6223),
    [sym_noreturn] = ACTIONS(6223),
    [sym_this] = ACTIONS(6223),
    [sym_abstract] = ACTIONS(6223),
    [sym_alias] = ACTIONS(6223),
    [sym_align] = ACTIONS(6223),
    [sym_auto] = ACTIONS(6223),
    [sym_class] = ACTIONS(6223),
    [sym_const] = ACTIONS(6223),
    [sym_debug] = ACTIONS(6223),
    [sym_deprecated] = ACTIONS(6223),
    [sym_enum] = ACTIONS(6223),
    [sym_export] = ACTIONS(6223),
    [sym_extern] = ACTIONS(6223),
    [sym_final] = ACTIONS(6223),
    [sym_immutable] = ACTIONS(6223),
    [sym_import] = ACTIONS(6223),
    [sym_inout] = ACTIONS(6223),
    [sym_interface] = ACTIONS(6223),
    [sym_invariant] = ACTIONS(6223),
    [sym_mixin] = ACTIONS(6223),
    [sym_nothrow] = ACTIONS(6223),
    [sym_override] = ACTIONS(6223),
    [sym_package] = ACTIONS(6223),
    [sym_pragma] = ACTIONS(6223),
    [sym_private] = ACTIONS(6223),
    [sym_protected] = ACTIONS(6223),
    [sym_public] = ACTIONS(6223),
    [sym_pure] = ACTIONS(6223),
    [sym_ref] = ACTIONS(6223),
    [sym_return] = ACTIONS(6223),
    [sym_scope] = ACTIONS(6223),
    [sym_shared] = ACTIONS(6223),
    [sym_static] = ACTIONS(6223),
    [sym_struct] = ACTIONS(6223),
    [sym_synchronized] = ACTIONS(6223),
    [sym_template] = ACTIONS(6223),
    [sym_typeof] = ACTIONS(6223),
    [sym_union] = ACTIONS(6223),
    [sym_unittest] = ACTIONS(6223),
    [sym_version] = ACTIONS(6223),
    [sym_gshared] = ACTIONS(6223),
    [sym_traits] = ACTIONS(6223),
    [sym_vector] = ACTIONS(6223),
    [sym_void] = ACTIONS(6223),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2495] = {
    [sym_identifier] = ACTIONS(6183),
    [anon_sym_LBRACE] = ACTIONS(6185),
    [anon_sym_DOT] = ACTIONS(6185),
    [anon_sym_SEMI] = ACTIONS(6185),
    [anon_sym_COLON] = ACTIONS(6227),
    [anon_sym_TILDE] = ACTIONS(6185),
    [anon_sym_AT] = ACTIONS(6185),
    [sym_bool] = ACTIONS(6183),
    [sym_byte] = ACTIONS(6183),
    [sym_ubyte] = ACTIONS(6183),
    [sym_char] = ACTIONS(6183),
    [sym_short] = ACTIONS(6183),
    [sym_ushort] = ACTIONS(6183),
    [sym_int] = ACTIONS(6183),
    [sym_uint] = ACTIONS(6183),
    [sym_long] = ACTIONS(6183),
    [sym_ulong] = ACTIONS(6183),
    [sym_cent] = ACTIONS(6183),
    [sym_ucent] = ACTIONS(6183),
    [sym_wchar] = ACTIONS(6183),
    [sym_dchar] = ACTIONS(6183),
    [sym_float] = ACTIONS(6183),
    [sym_double] = ACTIONS(6183),
    [sym_real] = ACTIONS(6183),
    [sym_ifloat] = ACTIONS(6183),
    [sym_idouble] = ACTIONS(6183),
    [sym_ireal] = ACTIONS(6183),
    [sym_cfloat] = ACTIONS(6183),
    [sym_cdouble] = ACTIONS(6183),
    [sym_creal] = ACTIONS(6183),
    [sym_size_t] = ACTIONS(6183),
    [sym_ptrdiff_t] = ACTIONS(6183),
    [sym_string] = ACTIONS(6183),
    [sym_cstring] = ACTIONS(6183),
    [sym_dstring] = ACTIONS(6183),
    [sym_wstring] = ACTIONS(6183),
    [sym_noreturn] = ACTIONS(6183),
    [sym_this] = ACTIONS(6183),
    [sym_abstract] = ACTIONS(6183),
    [sym_alias] = ACTIONS(6183),
    [sym_align] = ACTIONS(6183),
    [sym_auto] = ACTIONS(6183),
    [sym_class] = ACTIONS(6183),
    [sym_const] = ACTIONS(6183),
    [sym_debug] = ACTIONS(6183),
    [sym_deprecated] = ACTIONS(6183),
    [sym_enum] = ACTIONS(6183),
    [sym_export] = ACTIONS(6183),
    [sym_extern] = ACTIONS(6183),
    [sym_final] = ACTIONS(6183),
    [sym_immutable] = ACTIONS(6183),
    [sym_import] = ACTIONS(6183),
    [sym_inout] = ACTIONS(6183),
    [sym_interface] = ACTIONS(6183),
    [sym_invariant] = ACTIONS(6183),
    [sym_mixin] = ACTIONS(6183),
    [sym_nothrow] = ACTIONS(6183),
    [sym_override] = ACTIONS(6183),
    [sym_package] = ACTIONS(6183),
    [sym_pragma] = ACTIONS(6183),
    [sym_private] = ACTIONS(6183),
    [sym_protected] = ACTIONS(6183),
    [sym_public] = ACTIONS(6183),
    [sym_pure] = ACTIONS(6183),
    [sym_ref] = ACTIONS(6183),
    [sym_return] = ACTIONS(6183),
    [sym_scope] = ACTIONS(6183),
    [sym_shared] = ACTIONS(6183),
    [sym_static] = ACTIONS(6183),
    [sym_struct] = ACTIONS(6183),
    [sym_synchronized] = ACTIONS(6183),
    [sym_template] = ACTIONS(6183),
    [sym_typeof] = ACTIONS(6183),
    [sym_union] = ACTIONS(6183),
    [sym_unittest] = ACTIONS(6183),
    [sym_version] = ACTIONS(6183),
    [sym_gshared] = ACTIONS(6183),
    [sym_traits] = ACTIONS(6183),
    [sym_vector] = ACTIONS(6183),
    [sym_void] = ACTIONS(6183),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2496] = {
    [sym_identifier] = ACTIONS(5988),
    [anon_sym_LBRACE] = ACTIONS(669),
    [anon_sym_DOT] = ACTIONS(5991),
    [anon_sym_SEMI] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_AT] = ACTIONS(5991),
    [sym_bool] = ACTIONS(5988),
    [sym_byte] = ACTIONS(5988),
    [sym_ubyte] = ACTIONS(5988),
    [sym_char] = ACTIONS(5988),
    [sym_short] = ACTIONS(5988),
    [sym_ushort] = ACTIONS(5988),
    [sym_int] = ACTIONS(5988),
    [sym_uint] = ACTIONS(5988),
    [sym_long] = ACTIONS(5988),
    [sym_ulong] = ACTIONS(5988),
    [sym_cent] = ACTIONS(5988),
    [sym_ucent] = ACTIONS(5988),
    [sym_wchar] = ACTIONS(5988),
    [sym_dchar] = ACTIONS(5988),
    [sym_float] = ACTIONS(5988),
    [sym_double] = ACTIONS(5988),
    [sym_real] = ACTIONS(5988),
    [sym_ifloat] = ACTIONS(5988),
    [sym_idouble] = ACTIONS(5988),
    [sym_ireal] = ACTIONS(5988),
    [sym_cfloat] = ACTIONS(5988),
    [sym_cdouble] = ACTIONS(5988),
    [sym_creal] = ACTIONS(5988),
    [sym_size_t] = ACTIONS(5988),
    [sym_ptrdiff_t] = ACTIONS(5988),
    [sym_string] = ACTIONS(5988),
    [sym_cstring] = ACTIONS(5988),
    [sym_dstring] = ACTIONS(5988),
    [sym_wstring] = ACTIONS(5988),
    [sym_noreturn] = ACTIONS(5988),
    [sym_this] = ACTIONS(3019),
    [sym_abstract] = ACTIONS(5988),
    [sym_alias] = ACTIONS(3019),
    [sym_align] = ACTIONS(5988),
    [sym_auto] = ACTIONS(5988),
    [sym_class] = ACTIONS(3019),
    [sym_const] = ACTIONS(5988),
    [sym_debug] = ACTIONS(3019),
    [sym_deprecated] = ACTIONS(5988),
    [sym_enum] = ACTIONS(5988),
    [sym_export] = ACTIONS(3019),
    [sym_extern] = ACTIONS(5988),
    [sym_final] = ACTIONS(5988),
    [sym_immutable] = ACTIONS(5988),
    [sym_import] = ACTIONS(3019),
    [sym_inout] = ACTIONS(5988),
    [sym_interface] = ACTIONS(3019),
    [sym_invariant] = ACTIONS(3019),
    [sym_mixin] = ACTIONS(5988),
    [sym_nothrow] = ACTIONS(5988),
    [sym_override] = ACTIONS(5988),
    [sym_package] = ACTIONS(3019),
    [sym_pragma] = ACTIONS(3019),
    [sym_private] = ACTIONS(3019),
    [sym_protected] = ACTIONS(3019),
    [sym_public] = ACTIONS(3019),
    [sym_pure] = ACTIONS(5988),
    [sym_ref] = ACTIONS(5988),
    [sym_return] = ACTIONS(3019),
    [sym_scope] = ACTIONS(5988),
    [sym_shared] = ACTIONS(5988),
    [sym_static] = ACTIONS(5988),
    [sym_struct] = ACTIONS(3019),
    [sym_synchronized] = ACTIONS(5988),
    [sym_template] = ACTIONS(3019),
    [sym_typeof] = ACTIONS(5988),
    [sym_union] = ACTIONS(3019),
    [sym_unittest] = ACTIONS(3019),
    [sym_version] = ACTIONS(3019),
    [sym_gshared] = ACTIONS(5988),
    [sym_traits] = ACTIONS(5988),
    [sym_vector] = ACTIONS(5988),
    [sym_void] = ACTIONS(5988),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2497] = {
    [sym_identifier] = ACTIONS(6229),
    [anon_sym_LBRACE] = ACTIONS(6231),
    [anon_sym_DOT] = ACTIONS(6231),
    [anon_sym_SEMI] = ACTIONS(6231),
    [anon_sym_COLON] = ACTIONS(6231),
    [anon_sym_TILDE] = ACTIONS(6231),
    [anon_sym_AT] = ACTIONS(6231),
    [sym_bool] = ACTIONS(6229),
    [sym_byte] = ACTIONS(6229),
    [sym_ubyte] = ACTIONS(6229),
    [sym_char] = ACTIONS(6229),
    [sym_short] = ACTIONS(6229),
    [sym_ushort] = ACTIONS(6229),
    [sym_int] = ACTIONS(6229),
    [sym_uint] = ACTIONS(6229),
    [sym_long] = ACTIONS(6229),
    [sym_ulong] = ACTIONS(6229),
    [sym_cent] = ACTIONS(6229),
    [sym_ucent] = ACTIONS(6229),
    [sym_wchar] = ACTIONS(6229),
    [sym_dchar] = ACTIONS(6229),
    [sym_float] = ACTIONS(6229),
    [sym_double] = ACTIONS(6229),
    [sym_real] = ACTIONS(6229),
    [sym_ifloat] = ACTIONS(6229),
    [sym_idouble] = ACTIONS(6229),
    [sym_ireal] = ACTIONS(6229),
    [sym_cfloat] = ACTIONS(6229),
    [sym_cdouble] = ACTIONS(6229),
    [sym_creal] = ACTIONS(6229),
    [sym_size_t] = ACTIONS(6229),
    [sym_ptrdiff_t] = ACTIONS(6229),
    [sym_string] = ACTIONS(6229),
    [sym_cstring] = ACTIONS(6229),
    [sym_dstring] = ACTIONS(6229),
    [sym_wstring] = ACTIONS(6229),
    [sym_noreturn] = ACTIONS(6229),
    [sym_this] = ACTIONS(6229),
    [sym_abstract] = ACTIONS(6229),
    [sym_alias] = ACTIONS(6229),
    [sym_align] = ACTIONS(6229),
    [sym_auto] = ACTIONS(6229),
    [sym_class] = ACTIONS(6229),
    [sym_const] = ACTIONS(6229),
    [sym_debug] = ACTIONS(6229),
    [sym_deprecated] = ACTIONS(6229),
    [sym_enum] = ACTIONS(6229),
    [sym_export] = ACTIONS(6229),
    [sym_extern] = ACTIONS(6229),
    [sym_final] = ACTIONS(6229),
    [sym_immutable] = ACTIONS(6229),
    [sym_import] = ACTIONS(6229),
    [sym_inout] = ACTIONS(6229),
    [sym_interface] = ACTIONS(6229),
    [sym_invariant] = ACTIONS(6229),
    [sym_mixin] = ACTIONS(6229),
    [sym_nothrow] = ACTIONS(6229),
    [sym_override] = ACTIONS(6229),
    [sym_package] = ACTIONS(6229),
    [sym_pragma] = ACTIONS(6229),
    [sym_private] = ACTIONS(6229),
    [sym_protected] = ACTIONS(6229),
    [sym_public] = ACTIONS(6229),
    [sym_pure] = ACTIONS(6229),
    [sym_ref] = ACTIONS(6229),
    [sym_return] = ACTIONS(6229),
    [sym_scope] = ACTIONS(6229),
    [sym_shared] = ACTIONS(6229),
    [sym_static] = ACTIONS(6229),
    [sym_struct] = ACTIONS(6229),
    [sym_synchronized] = ACTIONS(6229),
    [sym_template] = ACTIONS(6229),
    [sym_typeof] = ACTIONS(6229),
    [sym_union] = ACTIONS(6229),
    [sym_unittest] = ACTIONS(6229),
    [sym_version] = ACTIONS(6229),
    [sym_gshared] = ACTIONS(6229),
    [sym_traits] = ACTIONS(6229),
    [sym_vector] = ACTIONS(6229),
    [sym_void] = ACTIONS(6229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2498] = {
    [ts_builtin_sym_end] = ACTIONS(6233),
    [sym_identifier] = ACTIONS(6235),
    [anon_sym_DOT] = ACTIONS(6233),
    [anon_sym_SEMI] = ACTIONS(6233),
    [anon_sym_TILDE] = ACTIONS(6233),
    [anon_sym_AT] = ACTIONS(6233),
    [sym_bool] = ACTIONS(6235),
    [sym_byte] = ACTIONS(6235),
    [sym_ubyte] = ACTIONS(6235),
    [sym_char] = ACTIONS(6235),
    [sym_short] = ACTIONS(6235),
    [sym_ushort] = ACTIONS(6235),
    [sym_int] = ACTIONS(6235),
    [sym_uint] = ACTIONS(6235),
    [sym_long] = ACTIONS(6235),
    [sym_ulong] = ACTIONS(6235),
    [sym_cent] = ACTIONS(6235),
    [sym_ucent] = ACTIONS(6235),
    [sym_wchar] = ACTIONS(6235),
    [sym_dchar] = ACTIONS(6235),
    [sym_float] = ACTIONS(6235),
    [sym_double] = ACTIONS(6235),
    [sym_real] = ACTIONS(6235),
    [sym_ifloat] = ACTIONS(6235),
    [sym_idouble] = ACTIONS(6235),
    [sym_ireal] = ACTIONS(6235),
    [sym_cfloat] = ACTIONS(6235),
    [sym_cdouble] = ACTIONS(6235),
    [sym_creal] = ACTIONS(6235),
    [sym_size_t] = ACTIONS(6235),
    [sym_ptrdiff_t] = ACTIONS(6235),
    [sym_string] = ACTIONS(6235),
    [sym_cstring] = ACTIONS(6235),
    [sym_dstring] = ACTIONS(6235),
    [sym_wstring] = ACTIONS(6235),
    [sym_noreturn] = ACTIONS(6235),
    [sym_this] = ACTIONS(6235),
    [sym_abstract] = ACTIONS(6235),
    [sym_alias] = ACTIONS(6235),
    [sym_align] = ACTIONS(6235),
    [sym_auto] = ACTIONS(6235),
    [sym_class] = ACTIONS(6235),
    [sym_const] = ACTIONS(6235),
    [sym_debug] = ACTIONS(6235),
    [sym_deprecated] = ACTIONS(6235),
    [sym_enum] = ACTIONS(6235),
    [sym_export] = ACTIONS(6235),
    [sym_extern] = ACTIONS(6235),
    [sym_final] = ACTIONS(6235),
    [sym_immutable] = ACTIONS(6235),
    [sym_import] = ACTIONS(6235),
    [sym_inout] = ACTIONS(6235),
    [sym_interface] = ACTIONS(6235),
    [sym_invariant] = ACTIONS(6235),
    [sym_mixin] = ACTIONS(6235),
    [sym_nothrow] = ACTIONS(6235),
    [sym_override] = ACTIONS(6235),
    [sym_package] = ACTIONS(6235),
    [sym_pragma] = ACTIONS(6235),
    [sym_private] = ACTIONS(6235),
    [sym_protected] = ACTIONS(6235),
    [sym_public] = ACTIONS(6235),
    [sym_pure] = ACTIONS(6235),
    [sym_ref] = ACTIONS(6235),
    [sym_return] = ACTIONS(6235),
    [sym_scope] = ACTIONS(6235),
    [sym_shared] = ACTIONS(6235),
    [sym_static] = ACTIONS(6235),
    [sym_struct] = ACTIONS(6235),
    [sym_synchronized] = ACTIONS(6235),
    [sym_template] = ACTIONS(6235),
    [sym_typeof] = ACTIONS(6235),
    [sym_union] = ACTIONS(6235),
    [sym_unittest] = ACTIONS(6235),
    [sym_version] = ACTIONS(6235),
    [sym_gshared] = ACTIONS(6235),
    [sym_traits] = ACTIONS(6235),
    [sym_vector] = ACTIONS(6235),
    [sym_void] = ACTIONS(6235),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2499] = {
    [ts_builtin_sym_end] = ACTIONS(6237),
    [sym_identifier] = ACTIONS(6239),
    [anon_sym_DOT] = ACTIONS(6237),
    [anon_sym_SEMI] = ACTIONS(6237),
    [anon_sym_TILDE] = ACTIONS(6237),
    [anon_sym_AT] = ACTIONS(6237),
    [sym_bool] = ACTIONS(6239),
    [sym_byte] = ACTIONS(6239),
    [sym_ubyte] = ACTIONS(6239),
    [sym_char] = ACTIONS(6239),
    [sym_short] = ACTIONS(6239),
    [sym_ushort] = ACTIONS(6239),
    [sym_int] = ACTIONS(6239),
    [sym_uint] = ACTIONS(6239),
    [sym_long] = ACTIONS(6239),
    [sym_ulong] = ACTIONS(6239),
    [sym_cent] = ACTIONS(6239),
    [sym_ucent] = ACTIONS(6239),
    [sym_wchar] = ACTIONS(6239),
    [sym_dchar] = ACTIONS(6239),
    [sym_float] = ACTIONS(6239),
    [sym_double] = ACTIONS(6239),
    [sym_real] = ACTIONS(6239),
    [sym_ifloat] = ACTIONS(6239),
    [sym_idouble] = ACTIONS(6239),
    [sym_ireal] = ACTIONS(6239),
    [sym_cfloat] = ACTIONS(6239),
    [sym_cdouble] = ACTIONS(6239),
    [sym_creal] = ACTIONS(6239),
    [sym_size_t] = ACTIONS(6239),
    [sym_ptrdiff_t] = ACTIONS(6239),
    [sym_string] = ACTIONS(6239),
    [sym_cstring] = ACTIONS(6239),
    [sym_dstring] = ACTIONS(6239),
    [sym_wstring] = ACTIONS(6239),
    [sym_noreturn] = ACTIONS(6239),
    [sym_this] = ACTIONS(6239),
    [sym_abstract] = ACTIONS(6239),
    [sym_alias] = ACTIONS(6239),
    [sym_align] = ACTIONS(6239),
    [sym_auto] = ACTIONS(6239),
    [sym_class] = ACTIONS(6239),
    [sym_const] = ACTIONS(6239),
    [sym_debug] = ACTIONS(6239),
    [sym_deprecated] = ACTIONS(6239),
    [sym_enum] = ACTIONS(6239),
    [sym_export] = ACTIONS(6239),
    [sym_extern] = ACTIONS(6239),
    [sym_final] = ACTIONS(6239),
    [sym_immutable] = ACTIONS(6239),
    [sym_import] = ACTIONS(6239),
    [sym_inout] = ACTIONS(6239),
    [sym_interface] = ACTIONS(6239),
    [sym_invariant] = ACTIONS(6239),
    [sym_mixin] = ACTIONS(6239),
    [sym_nothrow] = ACTIONS(6239),
    [sym_override] = ACTIONS(6239),
    [sym_package] = ACTIONS(6239),
    [sym_pragma] = ACTIONS(6239),
    [sym_private] = ACTIONS(6239),
    [sym_protected] = ACTIONS(6239),
    [sym_public] = ACTIONS(6239),
    [sym_pure] = ACTIONS(6239),
    [sym_ref] = ACTIONS(6239),
    [sym_return] = ACTIONS(6239),
    [sym_scope] = ACTIONS(6239),
    [sym_shared] = ACTIONS(6239),
    [sym_static] = ACTIONS(6239),
    [sym_struct] = ACTIONS(6239),
    [sym_synchronized] = ACTIONS(6239),
    [sym_template] = ACTIONS(6239),
    [sym_typeof] = ACTIONS(6239),
    [sym_union] = ACTIONS(6239),
    [sym_unittest] = ACTIONS(6239),
    [sym_version] = ACTIONS(6239),
    [sym_gshared] = ACTIONS(6239),
    [sym_traits] = ACTIONS(6239),
    [sym_vector] = ACTIONS(6239),
    [sym_void] = ACTIONS(6239),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2500] = {
    [ts_builtin_sym_end] = ACTIONS(6241),
    [sym_identifier] = ACTIONS(6243),
    [anon_sym_DOT] = ACTIONS(6241),
    [anon_sym_SEMI] = ACTIONS(6241),
    [anon_sym_TILDE] = ACTIONS(6241),
    [anon_sym_AT] = ACTIONS(6241),
    [sym_bool] = ACTIONS(6243),
    [sym_byte] = ACTIONS(6243),
    [sym_ubyte] = ACTIONS(6243),
    [sym_char] = ACTIONS(6243),
    [sym_short] = ACTIONS(6243),
    [sym_ushort] = ACTIONS(6243),
    [sym_int] = ACTIONS(6243),
    [sym_uint] = ACTIONS(6243),
    [sym_long] = ACTIONS(6243),
    [sym_ulong] = ACTIONS(6243),
    [sym_cent] = ACTIONS(6243),
    [sym_ucent] = ACTIONS(6243),
    [sym_wchar] = ACTIONS(6243),
    [sym_dchar] = ACTIONS(6243),
    [sym_float] = ACTIONS(6243),
    [sym_double] = ACTIONS(6243),
    [sym_real] = ACTIONS(6243),
    [sym_ifloat] = ACTIONS(6243),
    [sym_idouble] = ACTIONS(6243),
    [sym_ireal] = ACTIONS(6243),
    [sym_cfloat] = ACTIONS(6243),
    [sym_cdouble] = ACTIONS(6243),
    [sym_creal] = ACTIONS(6243),
    [sym_size_t] = ACTIONS(6243),
    [sym_ptrdiff_t] = ACTIONS(6243),
    [sym_string] = ACTIONS(6243),
    [sym_cstring] = ACTIONS(6243),
    [sym_dstring] = ACTIONS(6243),
    [sym_wstring] = ACTIONS(6243),
    [sym_noreturn] = ACTIONS(6243),
    [sym_this] = ACTIONS(6243),
    [sym_abstract] = ACTIONS(6243),
    [sym_alias] = ACTIONS(6243),
    [sym_align] = ACTIONS(6243),
    [sym_auto] = ACTIONS(6243),
    [sym_class] = ACTIONS(6243),
    [sym_const] = ACTIONS(6243),
    [sym_debug] = ACTIONS(6243),
    [sym_deprecated] = ACTIONS(6243),
    [sym_enum] = ACTIONS(6243),
    [sym_export] = ACTIONS(6243),
    [sym_extern] = ACTIONS(6243),
    [sym_final] = ACTIONS(6243),
    [sym_immutable] = ACTIONS(6243),
    [sym_import] = ACTIONS(6243),
    [sym_inout] = ACTIONS(6243),
    [sym_interface] = ACTIONS(6243),
    [sym_invariant] = ACTIONS(6243),
    [sym_mixin] = ACTIONS(6243),
    [sym_nothrow] = ACTIONS(6243),
    [sym_override] = ACTIONS(6243),
    [sym_package] = ACTIONS(6243),
    [sym_pragma] = ACTIONS(6243),
    [sym_private] = ACTIONS(6243),
    [sym_protected] = ACTIONS(6243),
    [sym_public] = ACTIONS(6243),
    [sym_pure] = ACTIONS(6243),
    [sym_ref] = ACTIONS(6243),
    [sym_return] = ACTIONS(6243),
    [sym_scope] = ACTIONS(6243),
    [sym_shared] = ACTIONS(6243),
    [sym_static] = ACTIONS(6243),
    [sym_struct] = ACTIONS(6243),
    [sym_synchronized] = ACTIONS(6243),
    [sym_template] = ACTIONS(6243),
    [sym_typeof] = ACTIONS(6243),
    [sym_union] = ACTIONS(6243),
    [sym_unittest] = ACTIONS(6243),
    [sym_version] = ACTIONS(6243),
    [sym_gshared] = ACTIONS(6243),
    [sym_traits] = ACTIONS(6243),
    [sym_vector] = ACTIONS(6243),
    [sym_void] = ACTIONS(6243),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2501] = {
    [ts_builtin_sym_end] = ACTIONS(6245),
    [sym_identifier] = ACTIONS(6247),
    [anon_sym_DOT] = ACTIONS(6245),
    [anon_sym_SEMI] = ACTIONS(6245),
    [anon_sym_TILDE] = ACTIONS(6245),
    [anon_sym_AT] = ACTIONS(6245),
    [sym_bool] = ACTIONS(6247),
    [sym_byte] = ACTIONS(6247),
    [sym_ubyte] = ACTIONS(6247),
    [sym_char] = ACTIONS(6247),
    [sym_short] = ACTIONS(6247),
    [sym_ushort] = ACTIONS(6247),
    [sym_int] = ACTIONS(6247),
    [sym_uint] = ACTIONS(6247),
    [sym_long] = ACTIONS(6247),
    [sym_ulong] = ACTIONS(6247),
    [sym_cent] = ACTIONS(6247),
    [sym_ucent] = ACTIONS(6247),
    [sym_wchar] = ACTIONS(6247),
    [sym_dchar] = ACTIONS(6247),
    [sym_float] = ACTIONS(6247),
    [sym_double] = ACTIONS(6247),
    [sym_real] = ACTIONS(6247),
    [sym_ifloat] = ACTIONS(6247),
    [sym_idouble] = ACTIONS(6247),
    [sym_ireal] = ACTIONS(6247),
    [sym_cfloat] = ACTIONS(6247),
    [sym_cdouble] = ACTIONS(6247),
    [sym_creal] = ACTIONS(6247),
    [sym_size_t] = ACTIONS(6247),
    [sym_ptrdiff_t] = ACTIONS(6247),
    [sym_string] = ACTIONS(6247),
    [sym_cstring] = ACTIONS(6247),
    [sym_dstring] = ACTIONS(6247),
    [sym_wstring] = ACTIONS(6247),
    [sym_noreturn] = ACTIONS(6247),
    [sym_this] = ACTIONS(6247),
    [sym_abstract] = ACTIONS(6247),
    [sym_alias] = ACTIONS(6247),
    [sym_align] = ACTIONS(6247),
    [sym_auto] = ACTIONS(6247),
    [sym_class] = ACTIONS(6247),
    [sym_const] = ACTIONS(6247),
    [sym_debug] = ACTIONS(6247),
    [sym_deprecated] = ACTIONS(6247),
    [sym_enum] = ACTIONS(6247),
    [sym_export] = ACTIONS(6247),
    [sym_extern] = ACTIONS(6247),
    [sym_final] = ACTIONS(6247),
    [sym_immutable] = ACTIONS(6247),
    [sym_import] = ACTIONS(6247),
    [sym_inout] = ACTIONS(6247),
    [sym_interface] = ACTIONS(6247),
    [sym_invariant] = ACTIONS(6247),
    [sym_mixin] = ACTIONS(6247),
    [sym_nothrow] = ACTIONS(6247),
    [sym_override] = ACTIONS(6247),
    [sym_package] = ACTIONS(6247),
    [sym_pragma] = ACTIONS(6247),
    [sym_private] = ACTIONS(6247),
    [sym_protected] = ACTIONS(6247),
    [sym_public] = ACTIONS(6247),
    [sym_pure] = ACTIONS(6247),
    [sym_ref] = ACTIONS(6247),
    [sym_return] = ACTIONS(6247),
    [sym_scope] = ACTIONS(6247),
    [sym_shared] = ACTIONS(6247),
    [sym_static] = ACTIONS(6247),
    [sym_struct] = ACTIONS(6247),
    [sym_synchronized] = ACTIONS(6247),
    [sym_template] = ACTIONS(6247),
    [sym_typeof] = ACTIONS(6247),
    [sym_union] = ACTIONS(6247),
    [sym_unittest] = ACTIONS(6247),
    [sym_version] = ACTIONS(6247),
    [sym_gshared] = ACTIONS(6247),
    [sym_traits] = ACTIONS(6247),
    [sym_vector] = ACTIONS(6247),
    [sym_void] = ACTIONS(6247),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2502] = {
    [sym_manifest_declarator] = STATE(4991),
    [sym_storage_class] = STATE(2534),
    [sym_type] = STATE(5267),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2534),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6249),
    [anon_sym_LBRACE] = ACTIONS(6251),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(6253),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2503] = {
    [sym_manifest_declarator] = STATE(5136),
    [sym_storage_class] = STATE(2525),
    [sym_type] = STATE(5537),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2525),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6255),
    [anon_sym_LBRACE] = ACTIONS(6257),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(6259),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2504] = {
    [sym_manifest_declarator] = STATE(5181),
    [sym_storage_class] = STATE(2519),
    [sym_type] = STATE(5244),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2519),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6261),
    [anon_sym_LBRACE] = ACTIONS(6263),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(6265),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2505] = {
    [sym_manifest_declarator] = STATE(4765),
    [sym_storage_class] = STATE(2539),
    [sym_type] = STATE(5594),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2539),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6267),
    [anon_sym_LBRACE] = ACTIONS(6269),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(6271),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2506] = {
    [sym_manifest_declarator] = STATE(4910),
    [sym_storage_class] = STATE(2520),
    [sym_type] = STATE(5494),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2520),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6273),
    [anon_sym_LBRACE] = ACTIONS(6275),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(6277),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2507] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(5155),
    [sym_type] = STATE(4711),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6279),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6281),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2508] = {
    [sym_storage_class] = STATE(2563),
    [sym_alias_initializer] = STATE(5183),
    [sym_type] = STATE(6472),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2563),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6283),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(6285),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2509] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(4762),
    [sym_type] = STATE(4645),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6287),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6289),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2510] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(4953),
    [sym_type] = STATE(4674),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6291),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6293),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2511] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(5174),
    [sym_type] = STATE(4714),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6295),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6297),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2512] = {
    [sym_storage_class] = STATE(2545),
    [sym_alias_initializer] = STATE(4766),
    [sym_type] = STATE(5665),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2545),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6299),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(6301),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2513] = {
    [sym_storage_class] = STATE(2558),
    [sym_alias_initializer] = STATE(5132),
    [sym_type] = STATE(5781),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2558),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6303),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(6305),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2514] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(4901),
    [sym_type] = STATE(4716),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6307),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6309),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2515] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(4953),
    [sym_type] = STATE(4674),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6311),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6293),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2516] = {
    [sym_storage_class] = STATE(2562),
    [sym_alias_initializer] = STATE(4997),
    [sym_type] = STATE(6367),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2562),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6313),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(6315),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2517] = {
    [sym_storage_class] = STATE(2557),
    [sym_alias_initializer] = STATE(4911),
    [sym_type] = STATE(5847),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2557),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6317),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_this] = ACTIONS(6319),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2518] = {
    [sym_storage_class] = STATE(2698),
    [sym__auto_assignment] = STATE(4762),
    [sym_type] = STATE(4645),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6321),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_enum] = ACTIONS(6289),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2519] = {
    [sym_manifest_declarator] = STATE(5150),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5245),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2520] = {
    [sym_manifest_declarator] = STATE(4882),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5524),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2521] = {
    [sym_manifest_declarator] = STATE(5204),
    [sym_storage_class] = STATE(2524),
    [sym_type] = STATE(5516),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2524),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2522] = {
    [sym_manifest_declarator] = STATE(4882),
    [sym_storage_class] = STATE(2526),
    [sym_type] = STATE(5524),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2526),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2523] = {
    [sym_manifest_declarator] = STATE(4742),
    [sym_storage_class] = STATE(2535),
    [sym_type] = STATE(5577),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2535),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2524] = {
    [sym_manifest_declarator] = STATE(5081),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5500),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2525] = {
    [sym_manifest_declarator] = STATE(5204),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5516),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2526] = {
    [sym_manifest_declarator] = STATE(4833),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5568),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2527] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6333),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2528] = {
    [sym_manifest_declarator] = STATE(5062),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5317),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2529] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6339),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2530] = {
    [sym_manifest_declarator] = STATE(5150),
    [sym_storage_class] = STATE(2528),
    [sym_type] = STATE(5245),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2528),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2531] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6341),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2532] = {
    [sym_manifest_declarator] = STATE(4791),
    [sym_storage_class] = STATE(2533),
    [sym_type] = STATE(5441),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2533),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2533] = {
    [sym_manifest_declarator] = STATE(5122),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5283),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2534] = {
    [sym_manifest_declarator] = STATE(4791),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5441),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2535] = {
    [sym_manifest_declarator] = STATE(4931),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5560),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2536] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6343),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2537] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6345),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2538] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6347),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2539] = {
    [sym_manifest_declarator] = STATE(4742),
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5577),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6323),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2540] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6349),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2541] = {
    [sym_type] = STATE(4474),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_template_parameter] = STATE(4812),
    [sym__template_parameter_list] = STATE(6126),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6325),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6329),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_this] = ACTIONS(6351),
    [sym_alias] = ACTIONS(6335),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2542] = {
    [sym_token_string] = STATE(2713),
    [sym__builtin_type] = STATE(2729),
    [sym_raw_string] = STATE(2713),
    [sym_hex_string] = STATE(2713),
    [sym_quoted_string] = STATE(2713),
    [sym_interpolated_raw_string] = STATE(2713),
    [sym_interpolated_quoted_string] = STATE(2713),
    [sym_interpolated_token_string] = STATE(2713),
    [sym_string_literal] = STATE(2729),
    [sym_char_literal] = STATE(2729),
    [sym_special_keyword] = STATE(2729),
    [sym__template_single_arg] = STATE(2729),
    [sym_identifier] = ACTIONS(6353),
    [anon_sym_q_LBRACE] = ACTIONS(6355),
    [anon_sym_LPAREN] = ACTIONS(6357),
    [sym_bool] = ACTIONS(6353),
    [sym_byte] = ACTIONS(6353),
    [sym_ubyte] = ACTIONS(6353),
    [sym_char] = ACTIONS(6353),
    [sym_short] = ACTIONS(6353),
    [sym_ushort] = ACTIONS(6353),
    [sym_int] = ACTIONS(6353),
    [sym_uint] = ACTIONS(6353),
    [sym_long] = ACTIONS(6353),
    [sym_ulong] = ACTIONS(6353),
    [sym_cent] = ACTIONS(6353),
    [sym_ucent] = ACTIONS(6353),
    [sym_wchar] = ACTIONS(6353),
    [sym_dchar] = ACTIONS(6353),
    [sym_float] = ACTIONS(6353),
    [sym_double] = ACTIONS(6353),
    [sym_real] = ACTIONS(6353),
    [sym_ifloat] = ACTIONS(6353),
    [sym_idouble] = ACTIONS(6353),
    [sym_ireal] = ACTIONS(6353),
    [sym_cfloat] = ACTIONS(6353),
    [sym_cdouble] = ACTIONS(6353),
    [sym_creal] = ACTIONS(6353),
    [sym_size_t] = ACTIONS(6353),
    [sym_ptrdiff_t] = ACTIONS(6353),
    [sym_string] = ACTIONS(6353),
    [sym_cstring] = ACTIONS(6353),
    [sym_dstring] = ACTIONS(6353),
    [sym_wstring] = ACTIONS(6353),
    [sym_noreturn] = ACTIONS(6353),
    [sym_true] = ACTIONS(6353),
    [sym_false] = ACTIONS(6353),
    [sym_null] = ACTIONS(6353),
    [sym_this] = ACTIONS(6353),
    [sym_void] = ACTIONS(6353),
    [anon_sym_BQUOTE] = ACTIONS(6359),
    [anon_sym_r_DQUOTE] = ACTIONS(6361),
    [anon_sym_x_DQUOTE] = ACTIONS(6363),
    [anon_sym_DQUOTE] = ACTIONS(6365),
    [anon_sym_i_BQUOTE] = ACTIONS(6367),
    [anon_sym_i_DQUOTE] = ACTIONS(6369),
    [anon_sym_iq_LBRACE] = ACTIONS(6371),
    [aux_sym_char_literal_token1] = ACTIONS(6373),
    [anon_sym_SQUOTE] = ACTIONS(6375),
    [anon_sym___DATE__] = ACTIONS(6377),
    [anon_sym___FILE__] = ACTIONS(6377),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6377),
    [anon_sym___FUNCTION__] = ACTIONS(6377),
    [anon_sym___LINE__] = ACTIONS(6377),
    [anon_sym___MODULE__] = ACTIONS(6377),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6377),
    [anon_sym___TIME__] = ACTIONS(6377),
    [anon_sym___TIMESTAMP__] = ACTIONS(6377),
    [anon_sym___VENDOR__] = ACTIONS(6377),
    [anon_sym___VERSION__] = ACTIONS(6377),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6379),
    [sym_float_literal] = ACTIONS(6379),
    [sym__string] = ACTIONS(6381),
  },
  [2543] = {
    [sym_token_string] = STATE(2800),
    [sym__builtin_type] = STATE(2773),
    [sym_raw_string] = STATE(2800),
    [sym_hex_string] = STATE(2800),
    [sym_quoted_string] = STATE(2800),
    [sym_interpolated_raw_string] = STATE(2800),
    [sym_interpolated_quoted_string] = STATE(2800),
    [sym_interpolated_token_string] = STATE(2800),
    [sym_string_literal] = STATE(2773),
    [sym_char_literal] = STATE(2773),
    [sym_special_keyword] = STATE(2773),
    [sym__template_single_arg] = STATE(2773),
    [sym_identifier] = ACTIONS(6383),
    [anon_sym_q_LBRACE] = ACTIONS(6385),
    [anon_sym_LPAREN] = ACTIONS(6387),
    [sym_bool] = ACTIONS(6383),
    [sym_byte] = ACTIONS(6383),
    [sym_ubyte] = ACTIONS(6383),
    [sym_char] = ACTIONS(6383),
    [sym_short] = ACTIONS(6383),
    [sym_ushort] = ACTIONS(6383),
    [sym_int] = ACTIONS(6383),
    [sym_uint] = ACTIONS(6383),
    [sym_long] = ACTIONS(6383),
    [sym_ulong] = ACTIONS(6383),
    [sym_cent] = ACTIONS(6383),
    [sym_ucent] = ACTIONS(6383),
    [sym_wchar] = ACTIONS(6383),
    [sym_dchar] = ACTIONS(6383),
    [sym_float] = ACTIONS(6383),
    [sym_double] = ACTIONS(6383),
    [sym_real] = ACTIONS(6383),
    [sym_ifloat] = ACTIONS(6383),
    [sym_idouble] = ACTIONS(6383),
    [sym_ireal] = ACTIONS(6383),
    [sym_cfloat] = ACTIONS(6383),
    [sym_cdouble] = ACTIONS(6383),
    [sym_creal] = ACTIONS(6383),
    [sym_size_t] = ACTIONS(6383),
    [sym_ptrdiff_t] = ACTIONS(6383),
    [sym_string] = ACTIONS(6383),
    [sym_cstring] = ACTIONS(6383),
    [sym_dstring] = ACTIONS(6383),
    [sym_wstring] = ACTIONS(6383),
    [sym_noreturn] = ACTIONS(6383),
    [sym_true] = ACTIONS(6383),
    [sym_false] = ACTIONS(6383),
    [sym_null] = ACTIONS(6383),
    [sym_this] = ACTIONS(6383),
    [sym_void] = ACTIONS(6383),
    [anon_sym_BQUOTE] = ACTIONS(6389),
    [anon_sym_r_DQUOTE] = ACTIONS(6391),
    [anon_sym_x_DQUOTE] = ACTIONS(6393),
    [anon_sym_DQUOTE] = ACTIONS(6395),
    [anon_sym_i_BQUOTE] = ACTIONS(6397),
    [anon_sym_i_DQUOTE] = ACTIONS(6399),
    [anon_sym_iq_LBRACE] = ACTIONS(6401),
    [aux_sym_char_literal_token1] = ACTIONS(6403),
    [anon_sym_SQUOTE] = ACTIONS(6405),
    [anon_sym___DATE__] = ACTIONS(6407),
    [anon_sym___FILE__] = ACTIONS(6407),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6407),
    [anon_sym___FUNCTION__] = ACTIONS(6407),
    [anon_sym___LINE__] = ACTIONS(6407),
    [anon_sym___MODULE__] = ACTIONS(6407),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6407),
    [anon_sym___TIME__] = ACTIONS(6407),
    [anon_sym___TIMESTAMP__] = ACTIONS(6407),
    [anon_sym___VENDOR__] = ACTIONS(6407),
    [anon_sym___VERSION__] = ACTIONS(6407),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6409),
    [sym_float_literal] = ACTIONS(6409),
    [sym__string] = ACTIONS(6411),
  },
  [2544] = {
    [sym_token_string] = STATE(2822),
    [sym__builtin_type] = STATE(2830),
    [sym_raw_string] = STATE(2822),
    [sym_hex_string] = STATE(2822),
    [sym_quoted_string] = STATE(2822),
    [sym_interpolated_raw_string] = STATE(2822),
    [sym_interpolated_quoted_string] = STATE(2822),
    [sym_interpolated_token_string] = STATE(2822),
    [sym_string_literal] = STATE(2830),
    [sym_char_literal] = STATE(2830),
    [sym_special_keyword] = STATE(2830),
    [sym__template_single_arg] = STATE(2830),
    [sym_identifier] = ACTIONS(6413),
    [anon_sym_q_LBRACE] = ACTIONS(6415),
    [anon_sym_LPAREN] = ACTIONS(6417),
    [sym_bool] = ACTIONS(6413),
    [sym_byte] = ACTIONS(6413),
    [sym_ubyte] = ACTIONS(6413),
    [sym_char] = ACTIONS(6413),
    [sym_short] = ACTIONS(6413),
    [sym_ushort] = ACTIONS(6413),
    [sym_int] = ACTIONS(6413),
    [sym_uint] = ACTIONS(6413),
    [sym_long] = ACTIONS(6413),
    [sym_ulong] = ACTIONS(6413),
    [sym_cent] = ACTIONS(6413),
    [sym_ucent] = ACTIONS(6413),
    [sym_wchar] = ACTIONS(6413),
    [sym_dchar] = ACTIONS(6413),
    [sym_float] = ACTIONS(6413),
    [sym_double] = ACTIONS(6413),
    [sym_real] = ACTIONS(6413),
    [sym_ifloat] = ACTIONS(6413),
    [sym_idouble] = ACTIONS(6413),
    [sym_ireal] = ACTIONS(6413),
    [sym_cfloat] = ACTIONS(6413),
    [sym_cdouble] = ACTIONS(6413),
    [sym_creal] = ACTIONS(6413),
    [sym_size_t] = ACTIONS(6413),
    [sym_ptrdiff_t] = ACTIONS(6413),
    [sym_string] = ACTIONS(6413),
    [sym_cstring] = ACTIONS(6413),
    [sym_dstring] = ACTIONS(6413),
    [sym_wstring] = ACTIONS(6413),
    [sym_noreturn] = ACTIONS(6413),
    [sym_true] = ACTIONS(6413),
    [sym_false] = ACTIONS(6413),
    [sym_null] = ACTIONS(6413),
    [sym_this] = ACTIONS(6413),
    [sym_void] = ACTIONS(6413),
    [anon_sym_BQUOTE] = ACTIONS(6419),
    [anon_sym_r_DQUOTE] = ACTIONS(6421),
    [anon_sym_x_DQUOTE] = ACTIONS(6423),
    [anon_sym_DQUOTE] = ACTIONS(6425),
    [anon_sym_i_BQUOTE] = ACTIONS(6427),
    [anon_sym_i_DQUOTE] = ACTIONS(6429),
    [anon_sym_iq_LBRACE] = ACTIONS(6431),
    [aux_sym_char_literal_token1] = ACTIONS(6433),
    [anon_sym_SQUOTE] = ACTIONS(6435),
    [anon_sym___DATE__] = ACTIONS(6437),
    [anon_sym___FILE__] = ACTIONS(6437),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6437),
    [anon_sym___FUNCTION__] = ACTIONS(6437),
    [anon_sym___LINE__] = ACTIONS(6437),
    [anon_sym___MODULE__] = ACTIONS(6437),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6437),
    [anon_sym___TIME__] = ACTIONS(6437),
    [anon_sym___TIMESTAMP__] = ACTIONS(6437),
    [anon_sym___VENDOR__] = ACTIONS(6437),
    [anon_sym___VERSION__] = ACTIONS(6437),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6439),
    [sym_float_literal] = ACTIONS(6439),
    [sym__string] = ACTIONS(6441),
  },
  [2545] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5692),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2546] = {
    [sym_token_string] = STATE(2161),
    [sym__builtin_type] = STATE(2143),
    [sym_raw_string] = STATE(2161),
    [sym_hex_string] = STATE(2161),
    [sym_quoted_string] = STATE(2161),
    [sym_interpolated_raw_string] = STATE(2161),
    [sym_interpolated_quoted_string] = STATE(2161),
    [sym_interpolated_token_string] = STATE(2161),
    [sym_string_literal] = STATE(2143),
    [sym_char_literal] = STATE(2143),
    [sym_special_keyword] = STATE(2143),
    [sym__template_single_arg] = STATE(2143),
    [sym_identifier] = ACTIONS(6445),
    [anon_sym_q_LBRACE] = ACTIONS(6447),
    [anon_sym_LPAREN] = ACTIONS(6449),
    [sym_bool] = ACTIONS(6445),
    [sym_byte] = ACTIONS(6445),
    [sym_ubyte] = ACTIONS(6445),
    [sym_char] = ACTIONS(6445),
    [sym_short] = ACTIONS(6445),
    [sym_ushort] = ACTIONS(6445),
    [sym_int] = ACTIONS(6445),
    [sym_uint] = ACTIONS(6445),
    [sym_long] = ACTIONS(6445),
    [sym_ulong] = ACTIONS(6445),
    [sym_cent] = ACTIONS(6445),
    [sym_ucent] = ACTIONS(6445),
    [sym_wchar] = ACTIONS(6445),
    [sym_dchar] = ACTIONS(6445),
    [sym_float] = ACTIONS(6445),
    [sym_double] = ACTIONS(6445),
    [sym_real] = ACTIONS(6445),
    [sym_ifloat] = ACTIONS(6445),
    [sym_idouble] = ACTIONS(6445),
    [sym_ireal] = ACTIONS(6445),
    [sym_cfloat] = ACTIONS(6445),
    [sym_cdouble] = ACTIONS(6445),
    [sym_creal] = ACTIONS(6445),
    [sym_size_t] = ACTIONS(6445),
    [sym_ptrdiff_t] = ACTIONS(6445),
    [sym_string] = ACTIONS(6445),
    [sym_cstring] = ACTIONS(6445),
    [sym_dstring] = ACTIONS(6445),
    [sym_wstring] = ACTIONS(6445),
    [sym_noreturn] = ACTIONS(6445),
    [sym_true] = ACTIONS(6445),
    [sym_false] = ACTIONS(6445),
    [sym_null] = ACTIONS(6445),
    [sym_this] = ACTIONS(6445),
    [sym_void] = ACTIONS(6445),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_r_DQUOTE] = ACTIONS(6453),
    [anon_sym_x_DQUOTE] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [anon_sym_i_BQUOTE] = ACTIONS(6459),
    [anon_sym_i_DQUOTE] = ACTIONS(6461),
    [anon_sym_iq_LBRACE] = ACTIONS(6463),
    [aux_sym_char_literal_token1] = ACTIONS(6465),
    [anon_sym_SQUOTE] = ACTIONS(6467),
    [anon_sym___DATE__] = ACTIONS(6469),
    [anon_sym___FILE__] = ACTIONS(6469),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6469),
    [anon_sym___FUNCTION__] = ACTIONS(6469),
    [anon_sym___LINE__] = ACTIONS(6469),
    [anon_sym___MODULE__] = ACTIONS(6469),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6469),
    [anon_sym___TIME__] = ACTIONS(6469),
    [anon_sym___TIMESTAMP__] = ACTIONS(6469),
    [anon_sym___VENDOR__] = ACTIONS(6469),
    [anon_sym___VERSION__] = ACTIONS(6469),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6471),
    [sym_float_literal] = ACTIONS(6471),
    [sym__string] = ACTIONS(6473),
  },
  [2547] = {
    [sym_token_string] = STATE(2976),
    [sym__builtin_type] = STATE(2956),
    [sym_raw_string] = STATE(2976),
    [sym_hex_string] = STATE(2976),
    [sym_quoted_string] = STATE(2976),
    [sym_interpolated_raw_string] = STATE(2976),
    [sym_interpolated_quoted_string] = STATE(2976),
    [sym_interpolated_token_string] = STATE(2976),
    [sym_string_literal] = STATE(2956),
    [sym_char_literal] = STATE(2956),
    [sym_special_keyword] = STATE(2956),
    [sym__template_single_arg] = STATE(2956),
    [sym_identifier] = ACTIONS(6475),
    [anon_sym_q_LBRACE] = ACTIONS(3706),
    [anon_sym_LPAREN] = ACTIONS(6477),
    [sym_bool] = ACTIONS(6475),
    [sym_byte] = ACTIONS(6475),
    [sym_ubyte] = ACTIONS(6475),
    [sym_char] = ACTIONS(6475),
    [sym_short] = ACTIONS(6475),
    [sym_ushort] = ACTIONS(6475),
    [sym_int] = ACTIONS(6475),
    [sym_uint] = ACTIONS(6475),
    [sym_long] = ACTIONS(6475),
    [sym_ulong] = ACTIONS(6475),
    [sym_cent] = ACTIONS(6475),
    [sym_ucent] = ACTIONS(6475),
    [sym_wchar] = ACTIONS(6475),
    [sym_dchar] = ACTIONS(6475),
    [sym_float] = ACTIONS(6475),
    [sym_double] = ACTIONS(6475),
    [sym_real] = ACTIONS(6475),
    [sym_ifloat] = ACTIONS(6475),
    [sym_idouble] = ACTIONS(6475),
    [sym_ireal] = ACTIONS(6475),
    [sym_cfloat] = ACTIONS(6475),
    [sym_cdouble] = ACTIONS(6475),
    [sym_creal] = ACTIONS(6475),
    [sym_size_t] = ACTIONS(6475),
    [sym_ptrdiff_t] = ACTIONS(6475),
    [sym_string] = ACTIONS(6475),
    [sym_cstring] = ACTIONS(6475),
    [sym_dstring] = ACTIONS(6475),
    [sym_wstring] = ACTIONS(6475),
    [sym_noreturn] = ACTIONS(6475),
    [sym_true] = ACTIONS(6475),
    [sym_false] = ACTIONS(6475),
    [sym_null] = ACTIONS(6475),
    [sym_this] = ACTIONS(6475),
    [sym_void] = ACTIONS(6475),
    [anon_sym_BQUOTE] = ACTIONS(3752),
    [anon_sym_r_DQUOTE] = ACTIONS(3754),
    [anon_sym_x_DQUOTE] = ACTIONS(3756),
    [anon_sym_DQUOTE] = ACTIONS(3758),
    [anon_sym_i_BQUOTE] = ACTIONS(3760),
    [anon_sym_i_DQUOTE] = ACTIONS(3762),
    [anon_sym_iq_LBRACE] = ACTIONS(3764),
    [aux_sym_char_literal_token1] = ACTIONS(3766),
    [anon_sym_SQUOTE] = ACTIONS(3768),
    [anon_sym___DATE__] = ACTIONS(3770),
    [anon_sym___FILE__] = ACTIONS(3770),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3770),
    [anon_sym___FUNCTION__] = ACTIONS(3770),
    [anon_sym___LINE__] = ACTIONS(3770),
    [anon_sym___MODULE__] = ACTIONS(3770),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3770),
    [anon_sym___TIME__] = ACTIONS(3770),
    [anon_sym___TIMESTAMP__] = ACTIONS(3770),
    [anon_sym___VENDOR__] = ACTIONS(3770),
    [anon_sym___VERSION__] = ACTIONS(3770),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6479),
    [sym_float_literal] = ACTIONS(6479),
    [sym__string] = ACTIONS(3774),
  },
  [2548] = {
    [sym_token_string] = STATE(2161),
    [sym__builtin_type] = STATE(2143),
    [sym_raw_string] = STATE(2161),
    [sym_hex_string] = STATE(2161),
    [sym_quoted_string] = STATE(2161),
    [sym_interpolated_raw_string] = STATE(2161),
    [sym_interpolated_quoted_string] = STATE(2161),
    [sym_interpolated_token_string] = STATE(2161),
    [sym_string_literal] = STATE(2143),
    [sym_char_literal] = STATE(2143),
    [sym_special_keyword] = STATE(2143),
    [sym__template_single_arg] = STATE(2143),
    [sym_identifier] = ACTIONS(6445),
    [anon_sym_q_LBRACE] = ACTIONS(6447),
    [anon_sym_LPAREN] = ACTIONS(6449),
    [sym_bool] = ACTIONS(6445),
    [sym_byte] = ACTIONS(6445),
    [sym_ubyte] = ACTIONS(6445),
    [sym_char] = ACTIONS(6445),
    [sym_short] = ACTIONS(6445),
    [sym_ushort] = ACTIONS(6445),
    [sym_int] = ACTIONS(6445),
    [sym_uint] = ACTIONS(6445),
    [sym_long] = ACTIONS(6445),
    [sym_ulong] = ACTIONS(6445),
    [sym_cent] = ACTIONS(6445),
    [sym_ucent] = ACTIONS(6445),
    [sym_wchar] = ACTIONS(6445),
    [sym_dchar] = ACTIONS(6445),
    [sym_float] = ACTIONS(6445),
    [sym_double] = ACTIONS(6445),
    [sym_real] = ACTIONS(6445),
    [sym_ifloat] = ACTIONS(6445),
    [sym_idouble] = ACTIONS(6445),
    [sym_ireal] = ACTIONS(6445),
    [sym_cfloat] = ACTIONS(6445),
    [sym_cdouble] = ACTIONS(6445),
    [sym_creal] = ACTIONS(6445),
    [sym_size_t] = ACTIONS(6445),
    [sym_ptrdiff_t] = ACTIONS(6445),
    [sym_string] = ACTIONS(6445),
    [sym_cstring] = ACTIONS(6445),
    [sym_dstring] = ACTIONS(6445),
    [sym_wstring] = ACTIONS(6445),
    [sym_noreturn] = ACTIONS(6445),
    [sym_true] = ACTIONS(6445),
    [sym_false] = ACTIONS(6445),
    [sym_null] = ACTIONS(6445),
    [sym_this] = ACTIONS(6445),
    [sym_void] = ACTIONS(6445),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_r_DQUOTE] = ACTIONS(6453),
    [anon_sym_x_DQUOTE] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [anon_sym_i_BQUOTE] = ACTIONS(6459),
    [anon_sym_i_DQUOTE] = ACTIONS(6461),
    [anon_sym_iq_LBRACE] = ACTIONS(6463),
    [aux_sym_char_literal_token1] = ACTIONS(6465),
    [anon_sym_SQUOTE] = ACTIONS(6467),
    [anon_sym___DATE__] = ACTIONS(6469),
    [anon_sym___FILE__] = ACTIONS(6469),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6469),
    [anon_sym___FUNCTION__] = ACTIONS(6469),
    [anon_sym___LINE__] = ACTIONS(6469),
    [anon_sym___MODULE__] = ACTIONS(6469),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6469),
    [anon_sym___TIME__] = ACTIONS(6469),
    [anon_sym___TIMESTAMP__] = ACTIONS(6469),
    [anon_sym___VENDOR__] = ACTIONS(6469),
    [anon_sym___VERSION__] = ACTIONS(6469),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6471),
    [sym_float_literal] = ACTIONS(6471),
    [sym__string] = ACTIONS(6473),
  },
  [2549] = {
    [sym_token_string] = STATE(3871),
    [sym__builtin_type] = STATE(3880),
    [sym_raw_string] = STATE(3871),
    [sym_hex_string] = STATE(3871),
    [sym_quoted_string] = STATE(3871),
    [sym_interpolated_raw_string] = STATE(3871),
    [sym_interpolated_quoted_string] = STATE(3871),
    [sym_interpolated_token_string] = STATE(3871),
    [sym_string_literal] = STATE(3880),
    [sym_char_literal] = STATE(3880),
    [sym_special_keyword] = STATE(3880),
    [sym__template_single_arg] = STATE(3880),
    [sym_identifier] = ACTIONS(6481),
    [anon_sym_q_LBRACE] = ACTIONS(6483),
    [anon_sym_LPAREN] = ACTIONS(6485),
    [sym_bool] = ACTIONS(6481),
    [sym_byte] = ACTIONS(6481),
    [sym_ubyte] = ACTIONS(6481),
    [sym_char] = ACTIONS(6481),
    [sym_short] = ACTIONS(6481),
    [sym_ushort] = ACTIONS(6481),
    [sym_int] = ACTIONS(6481),
    [sym_uint] = ACTIONS(6481),
    [sym_long] = ACTIONS(6481),
    [sym_ulong] = ACTIONS(6481),
    [sym_cent] = ACTIONS(6481),
    [sym_ucent] = ACTIONS(6481),
    [sym_wchar] = ACTIONS(6481),
    [sym_dchar] = ACTIONS(6481),
    [sym_float] = ACTIONS(6481),
    [sym_double] = ACTIONS(6481),
    [sym_real] = ACTIONS(6481),
    [sym_ifloat] = ACTIONS(6481),
    [sym_idouble] = ACTIONS(6481),
    [sym_ireal] = ACTIONS(6481),
    [sym_cfloat] = ACTIONS(6481),
    [sym_cdouble] = ACTIONS(6481),
    [sym_creal] = ACTIONS(6481),
    [sym_size_t] = ACTIONS(6481),
    [sym_ptrdiff_t] = ACTIONS(6481),
    [sym_string] = ACTIONS(6481),
    [sym_cstring] = ACTIONS(6481),
    [sym_dstring] = ACTIONS(6481),
    [sym_wstring] = ACTIONS(6481),
    [sym_noreturn] = ACTIONS(6481),
    [sym_true] = ACTIONS(6481),
    [sym_false] = ACTIONS(6481),
    [sym_null] = ACTIONS(6481),
    [sym_this] = ACTIONS(6481),
    [sym_void] = ACTIONS(6481),
    [anon_sym_BQUOTE] = ACTIONS(6487),
    [anon_sym_r_DQUOTE] = ACTIONS(6489),
    [anon_sym_x_DQUOTE] = ACTIONS(6491),
    [anon_sym_DQUOTE] = ACTIONS(6493),
    [anon_sym_i_BQUOTE] = ACTIONS(6495),
    [anon_sym_i_DQUOTE] = ACTIONS(6497),
    [anon_sym_iq_LBRACE] = ACTIONS(6499),
    [aux_sym_char_literal_token1] = ACTIONS(6501),
    [anon_sym_SQUOTE] = ACTIONS(6503),
    [anon_sym___DATE__] = ACTIONS(6505),
    [anon_sym___FILE__] = ACTIONS(6505),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6505),
    [anon_sym___FUNCTION__] = ACTIONS(6505),
    [anon_sym___LINE__] = ACTIONS(6505),
    [anon_sym___MODULE__] = ACTIONS(6505),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6505),
    [anon_sym___TIME__] = ACTIONS(6505),
    [anon_sym___TIMESTAMP__] = ACTIONS(6505),
    [anon_sym___VENDOR__] = ACTIONS(6505),
    [anon_sym___VERSION__] = ACTIONS(6505),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6507),
    [sym_float_literal] = ACTIONS(6507),
    [sym__string] = ACTIONS(6509),
  },
  [2550] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(4912),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2551] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5135),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2552] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5076),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2553] = {
    [sym_token_string] = STATE(3988),
    [sym__builtin_type] = STATE(4066),
    [sym_raw_string] = STATE(3988),
    [sym_hex_string] = STATE(3988),
    [sym_quoted_string] = STATE(3988),
    [sym_interpolated_raw_string] = STATE(3988),
    [sym_interpolated_quoted_string] = STATE(3988),
    [sym_interpolated_token_string] = STATE(3988),
    [sym_string_literal] = STATE(4066),
    [sym_char_literal] = STATE(4066),
    [sym_special_keyword] = STATE(4066),
    [sym__template_single_arg] = STATE(4066),
    [sym_identifier] = ACTIONS(6511),
    [anon_sym_q_LBRACE] = ACTIONS(6513),
    [anon_sym_LPAREN] = ACTIONS(6515),
    [sym_bool] = ACTIONS(6511),
    [sym_byte] = ACTIONS(6511),
    [sym_ubyte] = ACTIONS(6511),
    [sym_char] = ACTIONS(6511),
    [sym_short] = ACTIONS(6511),
    [sym_ushort] = ACTIONS(6511),
    [sym_int] = ACTIONS(6511),
    [sym_uint] = ACTIONS(6511),
    [sym_long] = ACTIONS(6511),
    [sym_ulong] = ACTIONS(6511),
    [sym_cent] = ACTIONS(6511),
    [sym_ucent] = ACTIONS(6511),
    [sym_wchar] = ACTIONS(6511),
    [sym_dchar] = ACTIONS(6511),
    [sym_float] = ACTIONS(6511),
    [sym_double] = ACTIONS(6511),
    [sym_real] = ACTIONS(6511),
    [sym_ifloat] = ACTIONS(6511),
    [sym_idouble] = ACTIONS(6511),
    [sym_ireal] = ACTIONS(6511),
    [sym_cfloat] = ACTIONS(6511),
    [sym_cdouble] = ACTIONS(6511),
    [sym_creal] = ACTIONS(6511),
    [sym_size_t] = ACTIONS(6511),
    [sym_ptrdiff_t] = ACTIONS(6511),
    [sym_string] = ACTIONS(6511),
    [sym_cstring] = ACTIONS(6511),
    [sym_dstring] = ACTIONS(6511),
    [sym_wstring] = ACTIONS(6511),
    [sym_noreturn] = ACTIONS(6511),
    [sym_true] = ACTIONS(6511),
    [sym_false] = ACTIONS(6511),
    [sym_null] = ACTIONS(6511),
    [sym_this] = ACTIONS(6511),
    [sym_void] = ACTIONS(6511),
    [anon_sym_BQUOTE] = ACTIONS(6517),
    [anon_sym_r_DQUOTE] = ACTIONS(6519),
    [anon_sym_x_DQUOTE] = ACTIONS(6521),
    [anon_sym_DQUOTE] = ACTIONS(6523),
    [anon_sym_i_BQUOTE] = ACTIONS(6525),
    [anon_sym_i_DQUOTE] = ACTIONS(6527),
    [anon_sym_iq_LBRACE] = ACTIONS(6529),
    [aux_sym_char_literal_token1] = ACTIONS(6531),
    [anon_sym_SQUOTE] = ACTIONS(6533),
    [anon_sym___DATE__] = ACTIONS(6535),
    [anon_sym___FILE__] = ACTIONS(6535),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6535),
    [anon_sym___FUNCTION__] = ACTIONS(6535),
    [anon_sym___LINE__] = ACTIONS(6535),
    [anon_sym___MODULE__] = ACTIONS(6535),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6535),
    [anon_sym___TIME__] = ACTIONS(6535),
    [anon_sym___TIMESTAMP__] = ACTIONS(6535),
    [anon_sym___VENDOR__] = ACTIONS(6535),
    [anon_sym___VERSION__] = ACTIONS(6535),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6537),
    [sym_float_literal] = ACTIONS(6537),
    [sym__string] = ACTIONS(6539),
  },
  [2554] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(4823),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2555] = {
    [sym_token_string] = STATE(2574),
    [sym__builtin_type] = STATE(2571),
    [sym_raw_string] = STATE(2574),
    [sym_hex_string] = STATE(2574),
    [sym_quoted_string] = STATE(2574),
    [sym_interpolated_raw_string] = STATE(2574),
    [sym_interpolated_quoted_string] = STATE(2574),
    [sym_interpolated_token_string] = STATE(2574),
    [sym_string_literal] = STATE(2571),
    [sym_char_literal] = STATE(2571),
    [sym_special_keyword] = STATE(2571),
    [sym__template_single_arg] = STATE(2571),
    [sym_identifier] = ACTIONS(6541),
    [anon_sym_q_LBRACE] = ACTIONS(6543),
    [anon_sym_LPAREN] = ACTIONS(6545),
    [sym_bool] = ACTIONS(6541),
    [sym_byte] = ACTIONS(6541),
    [sym_ubyte] = ACTIONS(6541),
    [sym_char] = ACTIONS(6541),
    [sym_short] = ACTIONS(6541),
    [sym_ushort] = ACTIONS(6541),
    [sym_int] = ACTIONS(6541),
    [sym_uint] = ACTIONS(6541),
    [sym_long] = ACTIONS(6541),
    [sym_ulong] = ACTIONS(6541),
    [sym_cent] = ACTIONS(6541),
    [sym_ucent] = ACTIONS(6541),
    [sym_wchar] = ACTIONS(6541),
    [sym_dchar] = ACTIONS(6541),
    [sym_float] = ACTIONS(6541),
    [sym_double] = ACTIONS(6541),
    [sym_real] = ACTIONS(6541),
    [sym_ifloat] = ACTIONS(6541),
    [sym_idouble] = ACTIONS(6541),
    [sym_ireal] = ACTIONS(6541),
    [sym_cfloat] = ACTIONS(6541),
    [sym_cdouble] = ACTIONS(6541),
    [sym_creal] = ACTIONS(6541),
    [sym_size_t] = ACTIONS(6541),
    [sym_ptrdiff_t] = ACTIONS(6541),
    [sym_string] = ACTIONS(6541),
    [sym_cstring] = ACTIONS(6541),
    [sym_dstring] = ACTIONS(6541),
    [sym_wstring] = ACTIONS(6541),
    [sym_noreturn] = ACTIONS(6541),
    [sym_true] = ACTIONS(6541),
    [sym_false] = ACTIONS(6541),
    [sym_null] = ACTIONS(6541),
    [sym_this] = ACTIONS(6541),
    [sym_void] = ACTIONS(6541),
    [anon_sym_BQUOTE] = ACTIONS(6547),
    [anon_sym_r_DQUOTE] = ACTIONS(6549),
    [anon_sym_x_DQUOTE] = ACTIONS(6551),
    [anon_sym_DQUOTE] = ACTIONS(6553),
    [anon_sym_i_BQUOTE] = ACTIONS(6555),
    [anon_sym_i_DQUOTE] = ACTIONS(6557),
    [anon_sym_iq_LBRACE] = ACTIONS(6559),
    [aux_sym_char_literal_token1] = ACTIONS(6561),
    [anon_sym_SQUOTE] = ACTIONS(6563),
    [anon_sym___DATE__] = ACTIONS(6565),
    [anon_sym___FILE__] = ACTIONS(6565),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6565),
    [anon_sym___FUNCTION__] = ACTIONS(6565),
    [anon_sym___LINE__] = ACTIONS(6565),
    [anon_sym___MODULE__] = ACTIONS(6565),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6565),
    [anon_sym___TIME__] = ACTIONS(6565),
    [anon_sym___TIMESTAMP__] = ACTIONS(6565),
    [anon_sym___VENDOR__] = ACTIONS(6565),
    [anon_sym___VERSION__] = ACTIONS(6565),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6567),
    [sym_float_literal] = ACTIONS(6567),
    [sym__string] = ACTIONS(6569),
  },
  [2556] = {
    [sym_token_string] = STATE(2971),
    [sym__builtin_type] = STATE(2975),
    [sym_raw_string] = STATE(2971),
    [sym_hex_string] = STATE(2971),
    [sym_quoted_string] = STATE(2971),
    [sym_interpolated_raw_string] = STATE(2971),
    [sym_interpolated_quoted_string] = STATE(2971),
    [sym_interpolated_token_string] = STATE(2971),
    [sym_string_literal] = STATE(2975),
    [sym_char_literal] = STATE(2975),
    [sym_special_keyword] = STATE(2975),
    [sym__template_single_arg] = STATE(2975),
    [sym_identifier] = ACTIONS(6571),
    [anon_sym_q_LBRACE] = ACTIONS(3294),
    [anon_sym_LPAREN] = ACTIONS(6573),
    [sym_bool] = ACTIONS(6571),
    [sym_byte] = ACTIONS(6571),
    [sym_ubyte] = ACTIONS(6571),
    [sym_char] = ACTIONS(6571),
    [sym_short] = ACTIONS(6571),
    [sym_ushort] = ACTIONS(6571),
    [sym_int] = ACTIONS(6571),
    [sym_uint] = ACTIONS(6571),
    [sym_long] = ACTIONS(6571),
    [sym_ulong] = ACTIONS(6571),
    [sym_cent] = ACTIONS(6571),
    [sym_ucent] = ACTIONS(6571),
    [sym_wchar] = ACTIONS(6571),
    [sym_dchar] = ACTIONS(6571),
    [sym_float] = ACTIONS(6571),
    [sym_double] = ACTIONS(6571),
    [sym_real] = ACTIONS(6571),
    [sym_ifloat] = ACTIONS(6571),
    [sym_idouble] = ACTIONS(6571),
    [sym_ireal] = ACTIONS(6571),
    [sym_cfloat] = ACTIONS(6571),
    [sym_cdouble] = ACTIONS(6571),
    [sym_creal] = ACTIONS(6571),
    [sym_size_t] = ACTIONS(6571),
    [sym_ptrdiff_t] = ACTIONS(6571),
    [sym_string] = ACTIONS(6571),
    [sym_cstring] = ACTIONS(6571),
    [sym_dstring] = ACTIONS(6571),
    [sym_wstring] = ACTIONS(6571),
    [sym_noreturn] = ACTIONS(6571),
    [sym_true] = ACTIONS(6571),
    [sym_false] = ACTIONS(6571),
    [sym_null] = ACTIONS(6571),
    [sym_this] = ACTIONS(6571),
    [sym_void] = ACTIONS(6571),
    [anon_sym_BQUOTE] = ACTIONS(3348),
    [anon_sym_r_DQUOTE] = ACTIONS(3350),
    [anon_sym_x_DQUOTE] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [anon_sym_i_BQUOTE] = ACTIONS(3356),
    [anon_sym_i_DQUOTE] = ACTIONS(3358),
    [anon_sym_iq_LBRACE] = ACTIONS(3360),
    [aux_sym_char_literal_token1] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(3364),
    [anon_sym___DATE__] = ACTIONS(3366),
    [anon_sym___FILE__] = ACTIONS(3366),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(3366),
    [anon_sym___FUNCTION__] = ACTIONS(3366),
    [anon_sym___LINE__] = ACTIONS(3366),
    [anon_sym___MODULE__] = ACTIONS(3366),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(3366),
    [anon_sym___TIME__] = ACTIONS(3366),
    [anon_sym___TIMESTAMP__] = ACTIONS(3366),
    [anon_sym___VENDOR__] = ACTIONS(3366),
    [anon_sym___VERSION__] = ACTIONS(3366),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6575),
    [sym_float_literal] = ACTIONS(6575),
    [sym__string] = ACTIONS(3370),
  },
  [2557] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5809),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2558] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(5808),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2559] = {
    [sym_token_string] = STATE(2161),
    [sym__builtin_type] = STATE(2143),
    [sym_raw_string] = STATE(2161),
    [sym_hex_string] = STATE(2161),
    [sym_quoted_string] = STATE(2161),
    [sym_interpolated_raw_string] = STATE(2161),
    [sym_interpolated_quoted_string] = STATE(2161),
    [sym_interpolated_token_string] = STATE(2161),
    [sym_string_literal] = STATE(2143),
    [sym_char_literal] = STATE(2143),
    [sym_special_keyword] = STATE(2143),
    [sym__template_single_arg] = STATE(2143),
    [sym_identifier] = ACTIONS(6445),
    [anon_sym_q_LBRACE] = ACTIONS(6447),
    [anon_sym_LPAREN] = ACTIONS(6449),
    [sym_bool] = ACTIONS(6445),
    [sym_byte] = ACTIONS(6445),
    [sym_ubyte] = ACTIONS(6445),
    [sym_char] = ACTIONS(6445),
    [sym_short] = ACTIONS(6445),
    [sym_ushort] = ACTIONS(6445),
    [sym_int] = ACTIONS(6445),
    [sym_uint] = ACTIONS(6445),
    [sym_long] = ACTIONS(6445),
    [sym_ulong] = ACTIONS(6445),
    [sym_cent] = ACTIONS(6445),
    [sym_ucent] = ACTIONS(6445),
    [sym_wchar] = ACTIONS(6445),
    [sym_dchar] = ACTIONS(6445),
    [sym_float] = ACTIONS(6445),
    [sym_double] = ACTIONS(6445),
    [sym_real] = ACTIONS(6445),
    [sym_ifloat] = ACTIONS(6445),
    [sym_idouble] = ACTIONS(6445),
    [sym_ireal] = ACTIONS(6445),
    [sym_cfloat] = ACTIONS(6445),
    [sym_cdouble] = ACTIONS(6445),
    [sym_creal] = ACTIONS(6445),
    [sym_size_t] = ACTIONS(6445),
    [sym_ptrdiff_t] = ACTIONS(6445),
    [sym_string] = ACTIONS(6445),
    [sym_cstring] = ACTIONS(6445),
    [sym_dstring] = ACTIONS(6445),
    [sym_wstring] = ACTIONS(6445),
    [sym_noreturn] = ACTIONS(6445),
    [sym_true] = ACTIONS(6445),
    [sym_false] = ACTIONS(6445),
    [sym_null] = ACTIONS(6445),
    [sym_this] = ACTIONS(6445),
    [sym_void] = ACTIONS(6445),
    [anon_sym_BQUOTE] = ACTIONS(6451),
    [anon_sym_r_DQUOTE] = ACTIONS(6453),
    [anon_sym_x_DQUOTE] = ACTIONS(6455),
    [anon_sym_DQUOTE] = ACTIONS(6457),
    [anon_sym_i_BQUOTE] = ACTIONS(6459),
    [anon_sym_i_DQUOTE] = ACTIONS(6461),
    [anon_sym_iq_LBRACE] = ACTIONS(6463),
    [aux_sym_char_literal_token1] = ACTIONS(6465),
    [anon_sym_SQUOTE] = ACTIONS(6467),
    [anon_sym___DATE__] = ACTIONS(6469),
    [anon_sym___FILE__] = ACTIONS(6469),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6469),
    [anon_sym___FUNCTION__] = ACTIONS(6469),
    [anon_sym___LINE__] = ACTIONS(6469),
    [anon_sym___MODULE__] = ACTIONS(6469),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6469),
    [anon_sym___TIME__] = ACTIONS(6469),
    [anon_sym___TIMESTAMP__] = ACTIONS(6469),
    [anon_sym___VENDOR__] = ACTIONS(6469),
    [anon_sym___VERSION__] = ACTIONS(6469),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6471),
    [sym_float_literal] = ACTIONS(6471),
    [sym__string] = ACTIONS(6473),
  },
  [2560] = {
    [sym_arguments] = STATE(2578),
    [sym_identifier] = ACTIONS(5924),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(6577),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_bool] = ACTIONS(5924),
    [sym_byte] = ACTIONS(5924),
    [sym_ubyte] = ACTIONS(5924),
    [sym_char] = ACTIONS(5924),
    [sym_short] = ACTIONS(5924),
    [sym_ushort] = ACTIONS(5924),
    [sym_int] = ACTIONS(5924),
    [sym_uint] = ACTIONS(5924),
    [sym_long] = ACTIONS(5924),
    [sym_ulong] = ACTIONS(5924),
    [sym_cent] = ACTIONS(5924),
    [sym_ucent] = ACTIONS(5924),
    [sym_wchar] = ACTIONS(5924),
    [sym_dchar] = ACTIONS(5924),
    [sym_float] = ACTIONS(5924),
    [sym_double] = ACTIONS(5924),
    [sym_real] = ACTIONS(5924),
    [sym_ifloat] = ACTIONS(5924),
    [sym_idouble] = ACTIONS(5924),
    [sym_ireal] = ACTIONS(5924),
    [sym_cfloat] = ACTIONS(5924),
    [sym_cdouble] = ACTIONS(5924),
    [sym_creal] = ACTIONS(5924),
    [sym_size_t] = ACTIONS(5924),
    [sym_ptrdiff_t] = ACTIONS(5924),
    [sym_string] = ACTIONS(5924),
    [sym_cstring] = ACTIONS(5924),
    [sym_dstring] = ACTIONS(5924),
    [sym_wstring] = ACTIONS(5924),
    [sym_noreturn] = ACTIONS(5924),
    [sym_abstract] = ACTIONS(5924),
    [sym_align] = ACTIONS(5924),
    [sym_auto] = ACTIONS(5924),
    [sym_const] = ACTIONS(5924),
    [sym_delegate] = ACTIONS(5924),
    [sym_deprecated] = ACTIONS(5924),
    [sym_do] = ACTIONS(5924),
    [sym_enum] = ACTIONS(5924),
    [sym_extern] = ACTIONS(5924),
    [sym_final] = ACTIONS(5924),
    [sym_function] = ACTIONS(5924),
    [sym_immutable] = ACTIONS(5924),
    [sym_in] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5924),
    [sym_lazy] = ACTIONS(5924),
    [sym_mixin] = ACTIONS(5924),
    [sym_nothrow] = ACTIONS(5924),
    [sym_out] = ACTIONS(5924),
    [sym_override] = ACTIONS(5924),
    [sym_pure] = ACTIONS(5924),
    [sym_ref] = ACTIONS(5924),
    [sym_return] = ACTIONS(5924),
    [sym_scope] = ACTIONS(5924),
    [sym_shared] = ACTIONS(5924),
    [sym_static] = ACTIONS(5924),
    [sym_synchronized] = ACTIONS(5924),
    [sym_typeof] = ACTIONS(5924),
    [sym_gshared] = ACTIONS(5924),
    [sym_traits] = ACTIONS(5924),
    [sym_vector] = ACTIONS(5924),
    [sym_void] = ACTIONS(5924),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2561] = {
    [sym_token_string] = STATE(4081),
    [sym__builtin_type] = STATE(4083),
    [sym_raw_string] = STATE(4081),
    [sym_hex_string] = STATE(4081),
    [sym_quoted_string] = STATE(4081),
    [sym_interpolated_raw_string] = STATE(4081),
    [sym_interpolated_quoted_string] = STATE(4081),
    [sym_interpolated_token_string] = STATE(4081),
    [sym_string_literal] = STATE(4083),
    [sym_char_literal] = STATE(4083),
    [sym_special_keyword] = STATE(4083),
    [sym__template_single_arg] = STATE(4083),
    [sym_identifier] = ACTIONS(6579),
    [anon_sym_q_LBRACE] = ACTIONS(6581),
    [anon_sym_LPAREN] = ACTIONS(6583),
    [sym_bool] = ACTIONS(6579),
    [sym_byte] = ACTIONS(6579),
    [sym_ubyte] = ACTIONS(6579),
    [sym_char] = ACTIONS(6579),
    [sym_short] = ACTIONS(6579),
    [sym_ushort] = ACTIONS(6579),
    [sym_int] = ACTIONS(6579),
    [sym_uint] = ACTIONS(6579),
    [sym_long] = ACTIONS(6579),
    [sym_ulong] = ACTIONS(6579),
    [sym_cent] = ACTIONS(6579),
    [sym_ucent] = ACTIONS(6579),
    [sym_wchar] = ACTIONS(6579),
    [sym_dchar] = ACTIONS(6579),
    [sym_float] = ACTIONS(6579),
    [sym_double] = ACTIONS(6579),
    [sym_real] = ACTIONS(6579),
    [sym_ifloat] = ACTIONS(6579),
    [sym_idouble] = ACTIONS(6579),
    [sym_ireal] = ACTIONS(6579),
    [sym_cfloat] = ACTIONS(6579),
    [sym_cdouble] = ACTIONS(6579),
    [sym_creal] = ACTIONS(6579),
    [sym_size_t] = ACTIONS(6579),
    [sym_ptrdiff_t] = ACTIONS(6579),
    [sym_string] = ACTIONS(6579),
    [sym_cstring] = ACTIONS(6579),
    [sym_dstring] = ACTIONS(6579),
    [sym_wstring] = ACTIONS(6579),
    [sym_noreturn] = ACTIONS(6579),
    [sym_true] = ACTIONS(6579),
    [sym_false] = ACTIONS(6579),
    [sym_null] = ACTIONS(6579),
    [sym_this] = ACTIONS(6579),
    [sym_void] = ACTIONS(6579),
    [anon_sym_BQUOTE] = ACTIONS(6585),
    [anon_sym_r_DQUOTE] = ACTIONS(6587),
    [anon_sym_x_DQUOTE] = ACTIONS(6589),
    [anon_sym_DQUOTE] = ACTIONS(6591),
    [anon_sym_i_BQUOTE] = ACTIONS(6593),
    [anon_sym_i_DQUOTE] = ACTIONS(6595),
    [anon_sym_iq_LBRACE] = ACTIONS(6597),
    [aux_sym_char_literal_token1] = ACTIONS(6599),
    [anon_sym_SQUOTE] = ACTIONS(6601),
    [anon_sym___DATE__] = ACTIONS(6603),
    [anon_sym___FILE__] = ACTIONS(6603),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(6603),
    [anon_sym___FUNCTION__] = ACTIONS(6603),
    [anon_sym___LINE__] = ACTIONS(6603),
    [anon_sym___MODULE__] = ACTIONS(6603),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(6603),
    [anon_sym___TIME__] = ACTIONS(6603),
    [anon_sym___TIMESTAMP__] = ACTIONS(6603),
    [anon_sym___VENDOR__] = ACTIONS(6603),
    [anon_sym___VERSION__] = ACTIONS(6603),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6605),
    [sym_float_literal] = ACTIONS(6605),
    [sym__string] = ACTIONS(6607),
  },
  [2562] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(6032),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2563] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(6446),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2564] = {
    [sym_storage_class] = STATE(2698),
    [sym_type] = STATE(4850),
    [sym_type_ctor] = STATE(2877),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [sym_mixin_expression] = STATE(4223),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_abstract] = ACTIONS(5900),
    [sym_align] = ACTIONS(2121),
    [sym_auto] = ACTIONS(5900),
    [sym_const] = ACTIONS(2125),
    [sym_deprecated] = ACTIONS(5900),
    [sym_extern] = ACTIONS(5916),
    [sym_final] = ACTIONS(5900),
    [sym_immutable] = ACTIONS(2125),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_nothrow] = ACTIONS(5900),
    [sym_override] = ACTIONS(5900),
    [sym_pure] = ACTIONS(5900),
    [sym_ref] = ACTIONS(5900),
    [sym_scope] = ACTIONS(5900),
    [sym_shared] = ACTIONS(2125),
    [sym_static] = ACTIONS(5900),
    [sym_synchronized] = ACTIONS(5900),
    [sym_typeof] = ACTIONS(67),
    [sym_gshared] = ACTIONS(5900),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2565] = {
    [sym_token_string] = STATE(2906),
    [sym__builtin_type] = STATE(2898),
    [sym_raw_string] = STATE(2906),
    [sym_hex_string] = STATE(2906),
    [sym_quoted_string] = STATE(2906),
    [sym_interpolated_raw_string] = STATE(2906),
    [sym_interpolated_quoted_string] = STATE(2906),
    [sym_interpolated_token_string] = STATE(2906),
    [sym_string_literal] = STATE(2898),
    [sym_char_literal] = STATE(2898),
    [sym_special_keyword] = STATE(2898),
    [sym__template_single_arg] = STATE(2898),
    [sym_identifier] = ACTIONS(6609),
    [anon_sym_q_LBRACE] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(6611),
    [sym_bool] = ACTIONS(6609),
    [sym_byte] = ACTIONS(6609),
    [sym_ubyte] = ACTIONS(6609),
    [sym_char] = ACTIONS(6609),
    [sym_short] = ACTIONS(6609),
    [sym_ushort] = ACTIONS(6609),
    [sym_int] = ACTIONS(6609),
    [sym_uint] = ACTIONS(6609),
    [sym_long] = ACTIONS(6609),
    [sym_ulong] = ACTIONS(6609),
    [sym_cent] = ACTIONS(6609),
    [sym_ucent] = ACTIONS(6609),
    [sym_wchar] = ACTIONS(6609),
    [sym_dchar] = ACTIONS(6609),
    [sym_float] = ACTIONS(6609),
    [sym_double] = ACTIONS(6609),
    [sym_real] = ACTIONS(6609),
    [sym_ifloat] = ACTIONS(6609),
    [sym_idouble] = ACTIONS(6609),
    [sym_ireal] = ACTIONS(6609),
    [sym_cfloat] = ACTIONS(6609),
    [sym_cdouble] = ACTIONS(6609),
    [sym_creal] = ACTIONS(6609),
    [sym_size_t] = ACTIONS(6609),
    [sym_ptrdiff_t] = ACTIONS(6609),
    [sym_string] = ACTIONS(6609),
    [sym_cstring] = ACTIONS(6609),
    [sym_dstring] = ACTIONS(6609),
    [sym_wstring] = ACTIONS(6609),
    [sym_noreturn] = ACTIONS(6609),
    [sym_true] = ACTIONS(6609),
    [sym_false] = ACTIONS(6609),
    [sym_null] = ACTIONS(6609),
    [sym_this] = ACTIONS(6609),
    [sym_void] = ACTIONS(6609),
    [anon_sym_BQUOTE] = ACTIONS(211),
    [anon_sym_r_DQUOTE] = ACTIONS(213),
    [anon_sym_x_DQUOTE] = ACTIONS(215),
    [anon_sym_DQUOTE] = ACTIONS(217),
    [anon_sym_i_BQUOTE] = ACTIONS(219),
    [anon_sym_i_DQUOTE] = ACTIONS(221),
    [anon_sym_iq_LBRACE] = ACTIONS(223),
    [aux_sym_char_literal_token1] = ACTIONS(225),
    [anon_sym_SQUOTE] = ACTIONS(227),
    [anon_sym___DATE__] = ACTIONS(229),
    [anon_sym___FILE__] = ACTIONS(229),
    [anon_sym___FILE_FULL_PATH__] = ACTIONS(229),
    [anon_sym___FUNCTION__] = ACTIONS(229),
    [anon_sym___LINE__] = ACTIONS(229),
    [anon_sym___MODULE__] = ACTIONS(229),
    [anon_sym___PRETTY_FUNCTION__] = ACTIONS(229),
    [anon_sym___TIME__] = ACTIONS(229),
    [anon_sym___TIMESTAMP__] = ACTIONS(229),
    [anon_sym___VENDOR__] = ACTIONS(229),
    [anon_sym___VERSION__] = ACTIONS(229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_int_literal] = ACTIONS(6613),
    [sym_float_literal] = ACTIONS(6613),
    [sym__string] = ACTIONS(233),
  },
  [2566] = {
    [sym_identifier] = ACTIONS(3041),
    [anon_sym_LBRACE] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3043),
    [anon_sym_AT] = ACTIONS(3043),
    [sym_bool] = ACTIONS(3041),
    [sym_byte] = ACTIONS(3041),
    [sym_ubyte] = ACTIONS(3041),
    [sym_char] = ACTIONS(3041),
    [sym_short] = ACTIONS(3041),
    [sym_ushort] = ACTIONS(3041),
    [sym_int] = ACTIONS(3041),
    [sym_uint] = ACTIONS(3041),
    [sym_long] = ACTIONS(3041),
    [sym_ulong] = ACTIONS(3041),
    [sym_cent] = ACTIONS(3041),
    [sym_ucent] = ACTIONS(3041),
    [sym_wchar] = ACTIONS(3041),
    [sym_dchar] = ACTIONS(3041),
    [sym_float] = ACTIONS(3041),
    [sym_double] = ACTIONS(3041),
    [sym_real] = ACTIONS(3041),
    [sym_ifloat] = ACTIONS(3041),
    [sym_idouble] = ACTIONS(3041),
    [sym_ireal] = ACTIONS(3041),
    [sym_cfloat] = ACTIONS(3041),
    [sym_cdouble] = ACTIONS(3041),
    [sym_creal] = ACTIONS(3041),
    [sym_size_t] = ACTIONS(3041),
    [sym_ptrdiff_t] = ACTIONS(3041),
    [sym_string] = ACTIONS(3041),
    [sym_cstring] = ACTIONS(3041),
    [sym_dstring] = ACTIONS(3041),
    [sym_wstring] = ACTIONS(3041),
    [sym_noreturn] = ACTIONS(3041),
    [sym_abstract] = ACTIONS(3041),
    [sym_align] = ACTIONS(3041),
    [sym_auto] = ACTIONS(3041),
    [sym_const] = ACTIONS(3041),
    [sym_delegate] = ACTIONS(3041),
    [sym_deprecated] = ACTIONS(3041),
    [sym_do] = ACTIONS(3041),
    [sym_enum] = ACTIONS(3041),
    [sym_extern] = ACTIONS(3041),
    [sym_final] = ACTIONS(3041),
    [sym_function] = ACTIONS(3041),
    [sym_immutable] = ACTIONS(3041),
    [sym_in] = ACTIONS(3041),
    [sym_inout] = ACTIONS(3041),
    [sym_lazy] = ACTIONS(3041),
    [sym_mixin] = ACTIONS(3041),
    [sym_nothrow] = ACTIONS(3041),
    [sym_out] = ACTIONS(3041),
    [sym_override] = ACTIONS(3041),
    [sym_pure] = ACTIONS(3041),
    [sym_ref] = ACTIONS(3041),
    [sym_return] = ACTIONS(3041),
    [sym_scope] = ACTIONS(3041),
    [sym_shared] = ACTIONS(3041),
    [sym_static] = ACTIONS(3041),
    [sym_synchronized] = ACTIONS(3041),
    [sym_typeof] = ACTIONS(3041),
    [sym_gshared] = ACTIONS(3041),
    [sym_traits] = ACTIONS(3041),
    [sym_vector] = ACTIONS(3041),
    [sym_void] = ACTIONS(3041),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2567] = {
    [sym_identifier] = ACTIONS(5944),
    [anon_sym_LBRACE] = ACTIONS(5946),
    [anon_sym_DOT] = ACTIONS(5946),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(5946),
    [anon_sym_COMMA] = ACTIONS(5946),
    [anon_sym_COLON] = ACTIONS(5946),
    [anon_sym_EQ] = ACTIONS(5946),
    [anon_sym_STAR] = ACTIONS(5946),
    [anon_sym_AT] = ACTIONS(5946),
    [sym_bool] = ACTIONS(5944),
    [sym_byte] = ACTIONS(5944),
    [sym_ubyte] = ACTIONS(5944),
    [sym_char] = ACTIONS(5944),
    [sym_short] = ACTIONS(5944),
    [sym_ushort] = ACTIONS(5944),
    [sym_int] = ACTIONS(5944),
    [sym_uint] = ACTIONS(5944),
    [sym_long] = ACTIONS(5944),
    [sym_ulong] = ACTIONS(5944),
    [sym_cent] = ACTIONS(5944),
    [sym_ucent] = ACTIONS(5944),
    [sym_wchar] = ACTIONS(5944),
    [sym_dchar] = ACTIONS(5944),
    [sym_float] = ACTIONS(5944),
    [sym_double] = ACTIONS(5944),
    [sym_real] = ACTIONS(5944),
    [sym_ifloat] = ACTIONS(5944),
    [sym_idouble] = ACTIONS(5944),
    [sym_ireal] = ACTIONS(5944),
    [sym_cfloat] = ACTIONS(5944),
    [sym_cdouble] = ACTIONS(5944),
    [sym_creal] = ACTIONS(5944),
    [sym_size_t] = ACTIONS(5944),
    [sym_ptrdiff_t] = ACTIONS(5944),
    [sym_string] = ACTIONS(5944),
    [sym_cstring] = ACTIONS(5944),
    [sym_dstring] = ACTIONS(5944),
    [sym_wstring] = ACTIONS(5944),
    [sym_noreturn] = ACTIONS(5944),
    [sym_abstract] = ACTIONS(5944),
    [sym_align] = ACTIONS(5944),
    [sym_auto] = ACTIONS(5944),
    [sym_const] = ACTIONS(5944),
    [sym_delegate] = ACTIONS(5944),
    [sym_deprecated] = ACTIONS(5944),
    [sym_do] = ACTIONS(5944),
    [sym_enum] = ACTIONS(5944),
    [sym_extern] = ACTIONS(5944),
    [sym_final] = ACTIONS(5944),
    [sym_function] = ACTIONS(5944),
    [sym_immutable] = ACTIONS(5944),
    [sym_in] = ACTIONS(5944),
    [sym_inout] = ACTIONS(5944),
    [sym_lazy] = ACTIONS(5944),
    [sym_mixin] = ACTIONS(5944),
    [sym_nothrow] = ACTIONS(5944),
    [sym_out] = ACTIONS(5944),
    [sym_override] = ACTIONS(5944),
    [sym_pure] = ACTIONS(5944),
    [sym_ref] = ACTIONS(5944),
    [sym_return] = ACTIONS(5944),
    [sym_scope] = ACTIONS(5944),
    [sym_shared] = ACTIONS(5944),
    [sym_static] = ACTIONS(5944),
    [sym_synchronized] = ACTIONS(5944),
    [sym_typeof] = ACTIONS(5944),
    [sym_gshared] = ACTIONS(5944),
    [sym_traits] = ACTIONS(5944),
    [sym_vector] = ACTIONS(5944),
    [sym_void] = ACTIONS(5944),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2568] = {
    [sym_identifier] = ACTIONS(5948),
    [anon_sym_LBRACE] = ACTIONS(5950),
    [anon_sym_DOT] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(5950),
    [anon_sym_RPAREN] = ACTIONS(5950),
    [anon_sym_LBRACK] = ACTIONS(5950),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_COLON] = ACTIONS(5950),
    [anon_sym_EQ] = ACTIONS(5950),
    [anon_sym_STAR] = ACTIONS(5950),
    [anon_sym_AT] = ACTIONS(5950),
    [sym_bool] = ACTIONS(5948),
    [sym_byte] = ACTIONS(5948),
    [sym_ubyte] = ACTIONS(5948),
    [sym_char] = ACTIONS(5948),
    [sym_short] = ACTIONS(5948),
    [sym_ushort] = ACTIONS(5948),
    [sym_int] = ACTIONS(5948),
    [sym_uint] = ACTIONS(5948),
    [sym_long] = ACTIONS(5948),
    [sym_ulong] = ACTIONS(5948),
    [sym_cent] = ACTIONS(5948),
    [sym_ucent] = ACTIONS(5948),
    [sym_wchar] = ACTIONS(5948),
    [sym_dchar] = ACTIONS(5948),
    [sym_float] = ACTIONS(5948),
    [sym_double] = ACTIONS(5948),
    [sym_real] = ACTIONS(5948),
    [sym_ifloat] = ACTIONS(5948),
    [sym_idouble] = ACTIONS(5948),
    [sym_ireal] = ACTIONS(5948),
    [sym_cfloat] = ACTIONS(5948),
    [sym_cdouble] = ACTIONS(5948),
    [sym_creal] = ACTIONS(5948),
    [sym_size_t] = ACTIONS(5948),
    [sym_ptrdiff_t] = ACTIONS(5948),
    [sym_string] = ACTIONS(5948),
    [sym_cstring] = ACTIONS(5948),
    [sym_dstring] = ACTIONS(5948),
    [sym_wstring] = ACTIONS(5948),
    [sym_noreturn] = ACTIONS(5948),
    [sym_abstract] = ACTIONS(5948),
    [sym_align] = ACTIONS(5948),
    [sym_auto] = ACTIONS(5948),
    [sym_const] = ACTIONS(5948),
    [sym_delegate] = ACTIONS(5948),
    [sym_deprecated] = ACTIONS(5948),
    [sym_do] = ACTIONS(5948),
    [sym_enum] = ACTIONS(5948),
    [sym_extern] = ACTIONS(5948),
    [sym_final] = ACTIONS(5948),
    [sym_function] = ACTIONS(5948),
    [sym_immutable] = ACTIONS(5948),
    [sym_in] = ACTIONS(5948),
    [sym_inout] = ACTIONS(5948),
    [sym_lazy] = ACTIONS(5948),
    [sym_mixin] = ACTIONS(5948),
    [sym_nothrow] = ACTIONS(5948),
    [sym_out] = ACTIONS(5948),
    [sym_override] = ACTIONS(5948),
    [sym_pure] = ACTIONS(5948),
    [sym_ref] = ACTIONS(5948),
    [sym_return] = ACTIONS(5948),
    [sym_scope] = ACTIONS(5948),
    [sym_shared] = ACTIONS(5948),
    [sym_static] = ACTIONS(5948),
    [sym_synchronized] = ACTIONS(5948),
    [sym_typeof] = ACTIONS(5948),
    [sym_gshared] = ACTIONS(5948),
    [sym_traits] = ACTIONS(5948),
    [sym_vector] = ACTIONS(5948),
    [sym_void] = ACTIONS(5948),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2569] = {
    [sym_identifier] = ACTIONS(5956),
    [anon_sym_LBRACE] = ACTIONS(5958),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5958),
    [anon_sym_AT] = ACTIONS(5958),
    [sym_bool] = ACTIONS(5956),
    [sym_byte] = ACTIONS(5956),
    [sym_ubyte] = ACTIONS(5956),
    [sym_char] = ACTIONS(5956),
    [sym_short] = ACTIONS(5956),
    [sym_ushort] = ACTIONS(5956),
    [sym_int] = ACTIONS(5956),
    [sym_uint] = ACTIONS(5956),
    [sym_long] = ACTIONS(5956),
    [sym_ulong] = ACTIONS(5956),
    [sym_cent] = ACTIONS(5956),
    [sym_ucent] = ACTIONS(5956),
    [sym_wchar] = ACTIONS(5956),
    [sym_dchar] = ACTIONS(5956),
    [sym_float] = ACTIONS(5956),
    [sym_double] = ACTIONS(5956),
    [sym_real] = ACTIONS(5956),
    [sym_ifloat] = ACTIONS(5956),
    [sym_idouble] = ACTIONS(5956),
    [sym_ireal] = ACTIONS(5956),
    [sym_cfloat] = ACTIONS(5956),
    [sym_cdouble] = ACTIONS(5956),
    [sym_creal] = ACTIONS(5956),
    [sym_size_t] = ACTIONS(5956),
    [sym_ptrdiff_t] = ACTIONS(5956),
    [sym_string] = ACTIONS(5956),
    [sym_cstring] = ACTIONS(5956),
    [sym_dstring] = ACTIONS(5956),
    [sym_wstring] = ACTIONS(5956),
    [sym_noreturn] = ACTIONS(5956),
    [sym_abstract] = ACTIONS(5956),
    [sym_align] = ACTIONS(5956),
    [sym_auto] = ACTIONS(5956),
    [sym_const] = ACTIONS(5956),
    [sym_delegate] = ACTIONS(5956),
    [sym_deprecated] = ACTIONS(5956),
    [sym_do] = ACTIONS(5956),
    [sym_enum] = ACTIONS(5956),
    [sym_extern] = ACTIONS(5956),
    [sym_final] = ACTIONS(5956),
    [sym_function] = ACTIONS(5956),
    [sym_immutable] = ACTIONS(5956),
    [sym_in] = ACTIONS(5956),
    [sym_inout] = ACTIONS(5956),
    [sym_lazy] = ACTIONS(5956),
    [sym_mixin] = ACTIONS(5956),
    [sym_nothrow] = ACTIONS(5956),
    [sym_out] = ACTIONS(5956),
    [sym_override] = ACTIONS(5956),
    [sym_pure] = ACTIONS(5956),
    [sym_ref] = ACTIONS(5956),
    [sym_return] = ACTIONS(5956),
    [sym_scope] = ACTIONS(5956),
    [sym_shared] = ACTIONS(5956),
    [sym_static] = ACTIONS(5956),
    [sym_synchronized] = ACTIONS(5956),
    [sym_typeof] = ACTIONS(5956),
    [sym_gshared] = ACTIONS(5956),
    [sym_traits] = ACTIONS(5956),
    [sym_vector] = ACTIONS(5956),
    [sym_void] = ACTIONS(5956),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2570] = {
    [sym_identifier] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5934),
    [anon_sym_LPAREN] = ACTIONS(5934),
    [anon_sym_RPAREN] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_COLON] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(5934),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_AT] = ACTIONS(5934),
    [sym_bool] = ACTIONS(5932),
    [sym_byte] = ACTIONS(5932),
    [sym_ubyte] = ACTIONS(5932),
    [sym_char] = ACTIONS(5932),
    [sym_short] = ACTIONS(5932),
    [sym_ushort] = ACTIONS(5932),
    [sym_int] = ACTIONS(5932),
    [sym_uint] = ACTIONS(5932),
    [sym_long] = ACTIONS(5932),
    [sym_ulong] = ACTIONS(5932),
    [sym_cent] = ACTIONS(5932),
    [sym_ucent] = ACTIONS(5932),
    [sym_wchar] = ACTIONS(5932),
    [sym_dchar] = ACTIONS(5932),
    [sym_float] = ACTIONS(5932),
    [sym_double] = ACTIONS(5932),
    [sym_real] = ACTIONS(5932),
    [sym_ifloat] = ACTIONS(5932),
    [sym_idouble] = ACTIONS(5932),
    [sym_ireal] = ACTIONS(5932),
    [sym_cfloat] = ACTIONS(5932),
    [sym_cdouble] = ACTIONS(5932),
    [sym_creal] = ACTIONS(5932),
    [sym_size_t] = ACTIONS(5932),
    [sym_ptrdiff_t] = ACTIONS(5932),
    [sym_string] = ACTIONS(5932),
    [sym_cstring] = ACTIONS(5932),
    [sym_dstring] = ACTIONS(5932),
    [sym_wstring] = ACTIONS(5932),
    [sym_noreturn] = ACTIONS(5932),
    [sym_abstract] = ACTIONS(5932),
    [sym_align] = ACTIONS(5932),
    [sym_auto] = ACTIONS(5932),
    [sym_const] = ACTIONS(5932),
    [sym_delegate] = ACTIONS(5932),
    [sym_deprecated] = ACTIONS(5932),
    [sym_do] = ACTIONS(5932),
    [sym_enum] = ACTIONS(5932),
    [sym_extern] = ACTIONS(5932),
    [sym_final] = ACTIONS(5932),
    [sym_function] = ACTIONS(5932),
    [sym_immutable] = ACTIONS(5932),
    [sym_in] = ACTIONS(5932),
    [sym_inout] = ACTIONS(5932),
    [sym_lazy] = ACTIONS(5932),
    [sym_mixin] = ACTIONS(5932),
    [sym_nothrow] = ACTIONS(5932),
    [sym_out] = ACTIONS(5932),
    [sym_override] = ACTIONS(5932),
    [sym_pure] = ACTIONS(5932),
    [sym_ref] = ACTIONS(5932),
    [sym_return] = ACTIONS(5932),
    [sym_scope] = ACTIONS(5932),
    [sym_shared] = ACTIONS(5932),
    [sym_static] = ACTIONS(5932),
    [sym_synchronized] = ACTIONS(5932),
    [sym_typeof] = ACTIONS(5932),
    [sym_gshared] = ACTIONS(5932),
    [sym_traits] = ACTIONS(5932),
    [sym_vector] = ACTIONS(5932),
    [sym_void] = ACTIONS(5932),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2571] = {
    [sym_identifier] = ACTIONS(5920),
    [anon_sym_LBRACE] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_LPAREN] = ACTIONS(5922),
    [anon_sym_RPAREN] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_COMMA] = ACTIONS(5922),
    [anon_sym_COLON] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5922),
    [anon_sym_AT] = ACTIONS(5922),
    [sym_bool] = ACTIONS(5920),
    [sym_byte] = ACTIONS(5920),
    [sym_ubyte] = ACTIONS(5920),
    [sym_char] = ACTIONS(5920),
    [sym_short] = ACTIONS(5920),
    [sym_ushort] = ACTIONS(5920),
    [sym_int] = ACTIONS(5920),
    [sym_uint] = ACTIONS(5920),
    [sym_long] = ACTIONS(5920),
    [sym_ulong] = ACTIONS(5920),
    [sym_cent] = ACTIONS(5920),
    [sym_ucent] = ACTIONS(5920),
    [sym_wchar] = ACTIONS(5920),
    [sym_dchar] = ACTIONS(5920),
    [sym_float] = ACTIONS(5920),
    [sym_double] = ACTIONS(5920),
    [sym_real] = ACTIONS(5920),
    [sym_ifloat] = ACTIONS(5920),
    [sym_idouble] = ACTIONS(5920),
    [sym_ireal] = ACTIONS(5920),
    [sym_cfloat] = ACTIONS(5920),
    [sym_cdouble] = ACTIONS(5920),
    [sym_creal] = ACTIONS(5920),
    [sym_size_t] = ACTIONS(5920),
    [sym_ptrdiff_t] = ACTIONS(5920),
    [sym_string] = ACTIONS(5920),
    [sym_cstring] = ACTIONS(5920),
    [sym_dstring] = ACTIONS(5920),
    [sym_wstring] = ACTIONS(5920),
    [sym_noreturn] = ACTIONS(5920),
    [sym_abstract] = ACTIONS(5920),
    [sym_align] = ACTIONS(5920),
    [sym_auto] = ACTIONS(5920),
    [sym_const] = ACTIONS(5920),
    [sym_delegate] = ACTIONS(5920),
    [sym_deprecated] = ACTIONS(5920),
    [sym_do] = ACTIONS(5920),
    [sym_enum] = ACTIONS(5920),
    [sym_extern] = ACTIONS(5920),
    [sym_final] = ACTIONS(5920),
    [sym_function] = ACTIONS(5920),
    [sym_immutable] = ACTIONS(5920),
    [sym_in] = ACTIONS(5920),
    [sym_inout] = ACTIONS(5920),
    [sym_lazy] = ACTIONS(5920),
    [sym_mixin] = ACTIONS(5920),
    [sym_nothrow] = ACTIONS(5920),
    [sym_out] = ACTIONS(5920),
    [sym_override] = ACTIONS(5920),
    [sym_pure] = ACTIONS(5920),
    [sym_ref] = ACTIONS(5920),
    [sym_return] = ACTIONS(5920),
    [sym_scope] = ACTIONS(5920),
    [sym_shared] = ACTIONS(5920),
    [sym_static] = ACTIONS(5920),
    [sym_synchronized] = ACTIONS(5920),
    [sym_typeof] = ACTIONS(5920),
    [sym_gshared] = ACTIONS(5920),
    [sym_traits] = ACTIONS(5920),
    [sym_vector] = ACTIONS(5920),
    [sym_void] = ACTIONS(5920),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2572] = {
    [sym_identifier] = ACTIONS(3065),
    [anon_sym_LBRACE] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3067),
    [sym_bool] = ACTIONS(3065),
    [sym_byte] = ACTIONS(3065),
    [sym_ubyte] = ACTIONS(3065),
    [sym_char] = ACTIONS(3065),
    [sym_short] = ACTIONS(3065),
    [sym_ushort] = ACTIONS(3065),
    [sym_int] = ACTIONS(3065),
    [sym_uint] = ACTIONS(3065),
    [sym_long] = ACTIONS(3065),
    [sym_ulong] = ACTIONS(3065),
    [sym_cent] = ACTIONS(3065),
    [sym_ucent] = ACTIONS(3065),
    [sym_wchar] = ACTIONS(3065),
    [sym_dchar] = ACTIONS(3065),
    [sym_float] = ACTIONS(3065),
    [sym_double] = ACTIONS(3065),
    [sym_real] = ACTIONS(3065),
    [sym_ifloat] = ACTIONS(3065),
    [sym_idouble] = ACTIONS(3065),
    [sym_ireal] = ACTIONS(3065),
    [sym_cfloat] = ACTIONS(3065),
    [sym_cdouble] = ACTIONS(3065),
    [sym_creal] = ACTIONS(3065),
    [sym_size_t] = ACTIONS(3065),
    [sym_ptrdiff_t] = ACTIONS(3065),
    [sym_string] = ACTIONS(3065),
    [sym_cstring] = ACTIONS(3065),
    [sym_dstring] = ACTIONS(3065),
    [sym_wstring] = ACTIONS(3065),
    [sym_noreturn] = ACTIONS(3065),
    [sym_abstract] = ACTIONS(3065),
    [sym_align] = ACTIONS(3065),
    [sym_auto] = ACTIONS(3065),
    [sym_const] = ACTIONS(3065),
    [sym_delegate] = ACTIONS(3065),
    [sym_deprecated] = ACTIONS(3065),
    [sym_do] = ACTIONS(3065),
    [sym_enum] = ACTIONS(3065),
    [sym_extern] = ACTIONS(3065),
    [sym_final] = ACTIONS(3065),
    [sym_function] = ACTIONS(3065),
    [sym_immutable] = ACTIONS(3065),
    [sym_in] = ACTIONS(3065),
    [sym_inout] = ACTIONS(3065),
    [sym_lazy] = ACTIONS(3065),
    [sym_mixin] = ACTIONS(3065),
    [sym_nothrow] = ACTIONS(3065),
    [sym_out] = ACTIONS(3065),
    [sym_override] = ACTIONS(3065),
    [sym_pure] = ACTIONS(3065),
    [sym_ref] = ACTIONS(3065),
    [sym_return] = ACTIONS(3065),
    [sym_scope] = ACTIONS(3065),
    [sym_shared] = ACTIONS(3065),
    [sym_static] = ACTIONS(3065),
    [sym_synchronized] = ACTIONS(3065),
    [sym_typeof] = ACTIONS(3065),
    [sym_gshared] = ACTIONS(3065),
    [sym_traits] = ACTIONS(3065),
    [sym_vector] = ACTIONS(3065),
    [sym_void] = ACTIONS(3065),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2573] = {
    [sym_identifier] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_LPAREN] = ACTIONS(5938),
    [anon_sym_RPAREN] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_COLON] = ACTIONS(5938),
    [anon_sym_EQ] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5938),
    [anon_sym_AT] = ACTIONS(5938),
    [sym_bool] = ACTIONS(5936),
    [sym_byte] = ACTIONS(5936),
    [sym_ubyte] = ACTIONS(5936),
    [sym_char] = ACTIONS(5936),
    [sym_short] = ACTIONS(5936),
    [sym_ushort] = ACTIONS(5936),
    [sym_int] = ACTIONS(5936),
    [sym_uint] = ACTIONS(5936),
    [sym_long] = ACTIONS(5936),
    [sym_ulong] = ACTIONS(5936),
    [sym_cent] = ACTIONS(5936),
    [sym_ucent] = ACTIONS(5936),
    [sym_wchar] = ACTIONS(5936),
    [sym_dchar] = ACTIONS(5936),
    [sym_float] = ACTIONS(5936),
    [sym_double] = ACTIONS(5936),
    [sym_real] = ACTIONS(5936),
    [sym_ifloat] = ACTIONS(5936),
    [sym_idouble] = ACTIONS(5936),
    [sym_ireal] = ACTIONS(5936),
    [sym_cfloat] = ACTIONS(5936),
    [sym_cdouble] = ACTIONS(5936),
    [sym_creal] = ACTIONS(5936),
    [sym_size_t] = ACTIONS(5936),
    [sym_ptrdiff_t] = ACTIONS(5936),
    [sym_string] = ACTIONS(5936),
    [sym_cstring] = ACTIONS(5936),
    [sym_dstring] = ACTIONS(5936),
    [sym_wstring] = ACTIONS(5936),
    [sym_noreturn] = ACTIONS(5936),
    [sym_abstract] = ACTIONS(5936),
    [sym_align] = ACTIONS(5936),
    [sym_auto] = ACTIONS(5936),
    [sym_const] = ACTIONS(5936),
    [sym_delegate] = ACTIONS(5936),
    [sym_deprecated] = ACTIONS(5936),
    [sym_do] = ACTIONS(5936),
    [sym_enum] = ACTIONS(5936),
    [sym_extern] = ACTIONS(5936),
    [sym_final] = ACTIONS(5936),
    [sym_function] = ACTIONS(5936),
    [sym_immutable] = ACTIONS(5936),
    [sym_in] = ACTIONS(5936),
    [sym_inout] = ACTIONS(5936),
    [sym_lazy] = ACTIONS(5936),
    [sym_mixin] = ACTIONS(5936),
    [sym_nothrow] = ACTIONS(5936),
    [sym_out] = ACTIONS(5936),
    [sym_override] = ACTIONS(5936),
    [sym_pure] = ACTIONS(5936),
    [sym_ref] = ACTIONS(5936),
    [sym_return] = ACTIONS(5936),
    [sym_scope] = ACTIONS(5936),
    [sym_shared] = ACTIONS(5936),
    [sym_static] = ACTIONS(5936),
    [sym_synchronized] = ACTIONS(5936),
    [sym_typeof] = ACTIONS(5936),
    [sym_gshared] = ACTIONS(5936),
    [sym_traits] = ACTIONS(5936),
    [sym_vector] = ACTIONS(5936),
    [sym_void] = ACTIONS(5936),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2574] = {
    [sym_identifier] = ACTIONS(3069),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [sym_bool] = ACTIONS(3069),
    [sym_byte] = ACTIONS(3069),
    [sym_ubyte] = ACTIONS(3069),
    [sym_char] = ACTIONS(3069),
    [sym_short] = ACTIONS(3069),
    [sym_ushort] = ACTIONS(3069),
    [sym_int] = ACTIONS(3069),
    [sym_uint] = ACTIONS(3069),
    [sym_long] = ACTIONS(3069),
    [sym_ulong] = ACTIONS(3069),
    [sym_cent] = ACTIONS(3069),
    [sym_ucent] = ACTIONS(3069),
    [sym_wchar] = ACTIONS(3069),
    [sym_dchar] = ACTIONS(3069),
    [sym_float] = ACTIONS(3069),
    [sym_double] = ACTIONS(3069),
    [sym_real] = ACTIONS(3069),
    [sym_ifloat] = ACTIONS(3069),
    [sym_idouble] = ACTIONS(3069),
    [sym_ireal] = ACTIONS(3069),
    [sym_cfloat] = ACTIONS(3069),
    [sym_cdouble] = ACTIONS(3069),
    [sym_creal] = ACTIONS(3069),
    [sym_size_t] = ACTIONS(3069),
    [sym_ptrdiff_t] = ACTIONS(3069),
    [sym_string] = ACTIONS(3069),
    [sym_cstring] = ACTIONS(3069),
    [sym_dstring] = ACTIONS(3069),
    [sym_wstring] = ACTIONS(3069),
    [sym_noreturn] = ACTIONS(3069),
    [sym_abstract] = ACTIONS(3069),
    [sym_align] = ACTIONS(3069),
    [sym_auto] = ACTIONS(3069),
    [sym_const] = ACTIONS(3069),
    [sym_delegate] = ACTIONS(3069),
    [sym_deprecated] = ACTIONS(3069),
    [sym_do] = ACTIONS(3069),
    [sym_enum] = ACTIONS(3069),
    [sym_extern] = ACTIONS(3069),
    [sym_final] = ACTIONS(3069),
    [sym_function] = ACTIONS(3069),
    [sym_immutable] = ACTIONS(3069),
    [sym_in] = ACTIONS(3069),
    [sym_inout] = ACTIONS(3069),
    [sym_lazy] = ACTIONS(3069),
    [sym_mixin] = ACTIONS(3069),
    [sym_nothrow] = ACTIONS(3069),
    [sym_out] = ACTIONS(3069),
    [sym_override] = ACTIONS(3069),
    [sym_pure] = ACTIONS(3069),
    [sym_ref] = ACTIONS(3069),
    [sym_return] = ACTIONS(3069),
    [sym_scope] = ACTIONS(3069),
    [sym_shared] = ACTIONS(3069),
    [sym_static] = ACTIONS(3069),
    [sym_synchronized] = ACTIONS(3069),
    [sym_typeof] = ACTIONS(3069),
    [sym_gshared] = ACTIONS(3069),
    [sym_traits] = ACTIONS(3069),
    [sym_vector] = ACTIONS(3069),
    [sym_void] = ACTIONS(3069),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2575] = {
    [sym_identifier] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [sym_bool] = ACTIONS(3061),
    [sym_byte] = ACTIONS(3061),
    [sym_ubyte] = ACTIONS(3061),
    [sym_char] = ACTIONS(3061),
    [sym_short] = ACTIONS(3061),
    [sym_ushort] = ACTIONS(3061),
    [sym_int] = ACTIONS(3061),
    [sym_uint] = ACTIONS(3061),
    [sym_long] = ACTIONS(3061),
    [sym_ulong] = ACTIONS(3061),
    [sym_cent] = ACTIONS(3061),
    [sym_ucent] = ACTIONS(3061),
    [sym_wchar] = ACTIONS(3061),
    [sym_dchar] = ACTIONS(3061),
    [sym_float] = ACTIONS(3061),
    [sym_double] = ACTIONS(3061),
    [sym_real] = ACTIONS(3061),
    [sym_ifloat] = ACTIONS(3061),
    [sym_idouble] = ACTIONS(3061),
    [sym_ireal] = ACTIONS(3061),
    [sym_cfloat] = ACTIONS(3061),
    [sym_cdouble] = ACTIONS(3061),
    [sym_creal] = ACTIONS(3061),
    [sym_size_t] = ACTIONS(3061),
    [sym_ptrdiff_t] = ACTIONS(3061),
    [sym_string] = ACTIONS(3061),
    [sym_cstring] = ACTIONS(3061),
    [sym_dstring] = ACTIONS(3061),
    [sym_wstring] = ACTIONS(3061),
    [sym_noreturn] = ACTIONS(3061),
    [sym_abstract] = ACTIONS(3061),
    [sym_align] = ACTIONS(3061),
    [sym_auto] = ACTIONS(3061),
    [sym_const] = ACTIONS(3061),
    [sym_delegate] = ACTIONS(3061),
    [sym_deprecated] = ACTIONS(3061),
    [sym_do] = ACTIONS(3061),
    [sym_enum] = ACTIONS(3061),
    [sym_extern] = ACTIONS(3061),
    [sym_final] = ACTIONS(3061),
    [sym_function] = ACTIONS(3061),
    [sym_immutable] = ACTIONS(3061),
    [sym_in] = ACTIONS(3061),
    [sym_inout] = ACTIONS(3061),
    [sym_lazy] = ACTIONS(3061),
    [sym_mixin] = ACTIONS(3061),
    [sym_nothrow] = ACTIONS(3061),
    [sym_out] = ACTIONS(3061),
    [sym_override] = ACTIONS(3061),
    [sym_pure] = ACTIONS(3061),
    [sym_ref] = ACTIONS(3061),
    [sym_return] = ACTIONS(3061),
    [sym_scope] = ACTIONS(3061),
    [sym_shared] = ACTIONS(3061),
    [sym_static] = ACTIONS(3061),
    [sym_synchronized] = ACTIONS(3061),
    [sym_typeof] = ACTIONS(3061),
    [sym_gshared] = ACTIONS(3061),
    [sym_traits] = ACTIONS(3061),
    [sym_vector] = ACTIONS(3061),
    [sym_void] = ACTIONS(3061),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2576] = {
    [sym_identifier] = ACTIONS(3085),
    [anon_sym_LBRACE] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3087),
    [sym_bool] = ACTIONS(3085),
    [sym_byte] = ACTIONS(3085),
    [sym_ubyte] = ACTIONS(3085),
    [sym_char] = ACTIONS(3085),
    [sym_short] = ACTIONS(3085),
    [sym_ushort] = ACTIONS(3085),
    [sym_int] = ACTIONS(3085),
    [sym_uint] = ACTIONS(3085),
    [sym_long] = ACTIONS(3085),
    [sym_ulong] = ACTIONS(3085),
    [sym_cent] = ACTIONS(3085),
    [sym_ucent] = ACTIONS(3085),
    [sym_wchar] = ACTIONS(3085),
    [sym_dchar] = ACTIONS(3085),
    [sym_float] = ACTIONS(3085),
    [sym_double] = ACTIONS(3085),
    [sym_real] = ACTIONS(3085),
    [sym_ifloat] = ACTIONS(3085),
    [sym_idouble] = ACTIONS(3085),
    [sym_ireal] = ACTIONS(3085),
    [sym_cfloat] = ACTIONS(3085),
    [sym_cdouble] = ACTIONS(3085),
    [sym_creal] = ACTIONS(3085),
    [sym_size_t] = ACTIONS(3085),
    [sym_ptrdiff_t] = ACTIONS(3085),
    [sym_string] = ACTIONS(3085),
    [sym_cstring] = ACTIONS(3085),
    [sym_dstring] = ACTIONS(3085),
    [sym_wstring] = ACTIONS(3085),
    [sym_noreturn] = ACTIONS(3085),
    [sym_abstract] = ACTIONS(3085),
    [sym_align] = ACTIONS(3085),
    [sym_auto] = ACTIONS(3085),
    [sym_const] = ACTIONS(3085),
    [sym_delegate] = ACTIONS(3085),
    [sym_deprecated] = ACTIONS(3085),
    [sym_do] = ACTIONS(3085),
    [sym_enum] = ACTIONS(3085),
    [sym_extern] = ACTIONS(3085),
    [sym_final] = ACTIONS(3085),
    [sym_function] = ACTIONS(3085),
    [sym_immutable] = ACTIONS(3085),
    [sym_in] = ACTIONS(3085),
    [sym_inout] = ACTIONS(3085),
    [sym_lazy] = ACTIONS(3085),
    [sym_mixin] = ACTIONS(3085),
    [sym_nothrow] = ACTIONS(3085),
    [sym_out] = ACTIONS(3085),
    [sym_override] = ACTIONS(3085),
    [sym_pure] = ACTIONS(3085),
    [sym_ref] = ACTIONS(3085),
    [sym_return] = ACTIONS(3085),
    [sym_scope] = ACTIONS(3085),
    [sym_shared] = ACTIONS(3085),
    [sym_static] = ACTIONS(3085),
    [sym_synchronized] = ACTIONS(3085),
    [sym_typeof] = ACTIONS(3085),
    [sym_gshared] = ACTIONS(3085),
    [sym_traits] = ACTIONS(3085),
    [sym_vector] = ACTIONS(3085),
    [sym_void] = ACTIONS(3085),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2577] = {
    [sym_identifier] = ACTIONS(3057),
    [anon_sym_LBRACE] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [sym_bool] = ACTIONS(3057),
    [sym_byte] = ACTIONS(3057),
    [sym_ubyte] = ACTIONS(3057),
    [sym_char] = ACTIONS(3057),
    [sym_short] = ACTIONS(3057),
    [sym_ushort] = ACTIONS(3057),
    [sym_int] = ACTIONS(3057),
    [sym_uint] = ACTIONS(3057),
    [sym_long] = ACTIONS(3057),
    [sym_ulong] = ACTIONS(3057),
    [sym_cent] = ACTIONS(3057),
    [sym_ucent] = ACTIONS(3057),
    [sym_wchar] = ACTIONS(3057),
    [sym_dchar] = ACTIONS(3057),
    [sym_float] = ACTIONS(3057),
    [sym_double] = ACTIONS(3057),
    [sym_real] = ACTIONS(3057),
    [sym_ifloat] = ACTIONS(3057),
    [sym_idouble] = ACTIONS(3057),
    [sym_ireal] = ACTIONS(3057),
    [sym_cfloat] = ACTIONS(3057),
    [sym_cdouble] = ACTIONS(3057),
    [sym_creal] = ACTIONS(3057),
    [sym_size_t] = ACTIONS(3057),
    [sym_ptrdiff_t] = ACTIONS(3057),
    [sym_string] = ACTIONS(3057),
    [sym_cstring] = ACTIONS(3057),
    [sym_dstring] = ACTIONS(3057),
    [sym_wstring] = ACTIONS(3057),
    [sym_noreturn] = ACTIONS(3057),
    [sym_abstract] = ACTIONS(3057),
    [sym_align] = ACTIONS(3057),
    [sym_auto] = ACTIONS(3057),
    [sym_const] = ACTIONS(3057),
    [sym_delegate] = ACTIONS(3057),
    [sym_deprecated] = ACTIONS(3057),
    [sym_do] = ACTIONS(3057),
    [sym_enum] = ACTIONS(3057),
    [sym_extern] = ACTIONS(3057),
    [sym_final] = ACTIONS(3057),
    [sym_function] = ACTIONS(3057),
    [sym_immutable] = ACTIONS(3057),
    [sym_in] = ACTIONS(3057),
    [sym_inout] = ACTIONS(3057),
    [sym_lazy] = ACTIONS(3057),
    [sym_mixin] = ACTIONS(3057),
    [sym_nothrow] = ACTIONS(3057),
    [sym_out] = ACTIONS(3057),
    [sym_override] = ACTIONS(3057),
    [sym_pure] = ACTIONS(3057),
    [sym_ref] = ACTIONS(3057),
    [sym_return] = ACTIONS(3057),
    [sym_scope] = ACTIONS(3057),
    [sym_shared] = ACTIONS(3057),
    [sym_static] = ACTIONS(3057),
    [sym_synchronized] = ACTIONS(3057),
    [sym_typeof] = ACTIONS(3057),
    [sym_gshared] = ACTIONS(3057),
    [sym_traits] = ACTIONS(3057),
    [sym_vector] = ACTIONS(3057),
    [sym_void] = ACTIONS(3057),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2578] = {
    [sym_identifier] = ACTIONS(5952),
    [anon_sym_LBRACE] = ACTIONS(5954),
    [anon_sym_DOT] = ACTIONS(5954),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_EQ] = ACTIONS(5954),
    [anon_sym_STAR] = ACTIONS(5954),
    [anon_sym_AT] = ACTIONS(5954),
    [sym_bool] = ACTIONS(5952),
    [sym_byte] = ACTIONS(5952),
    [sym_ubyte] = ACTIONS(5952),
    [sym_char] = ACTIONS(5952),
    [sym_short] = ACTIONS(5952),
    [sym_ushort] = ACTIONS(5952),
    [sym_int] = ACTIONS(5952),
    [sym_uint] = ACTIONS(5952),
    [sym_long] = ACTIONS(5952),
    [sym_ulong] = ACTIONS(5952),
    [sym_cent] = ACTIONS(5952),
    [sym_ucent] = ACTIONS(5952),
    [sym_wchar] = ACTIONS(5952),
    [sym_dchar] = ACTIONS(5952),
    [sym_float] = ACTIONS(5952),
    [sym_double] = ACTIONS(5952),
    [sym_real] = ACTIONS(5952),
    [sym_ifloat] = ACTIONS(5952),
    [sym_idouble] = ACTIONS(5952),
    [sym_ireal] = ACTIONS(5952),
    [sym_cfloat] = ACTIONS(5952),
    [sym_cdouble] = ACTIONS(5952),
    [sym_creal] = ACTIONS(5952),
    [sym_size_t] = ACTIONS(5952),
    [sym_ptrdiff_t] = ACTIONS(5952),
    [sym_string] = ACTIONS(5952),
    [sym_cstring] = ACTIONS(5952),
    [sym_dstring] = ACTIONS(5952),
    [sym_wstring] = ACTIONS(5952),
    [sym_noreturn] = ACTIONS(5952),
    [sym_abstract] = ACTIONS(5952),
    [sym_align] = ACTIONS(5952),
    [sym_auto] = ACTIONS(5952),
    [sym_const] = ACTIONS(5952),
    [sym_delegate] = ACTIONS(5952),
    [sym_deprecated] = ACTIONS(5952),
    [sym_do] = ACTIONS(5952),
    [sym_enum] = ACTIONS(5952),
    [sym_extern] = ACTIONS(5952),
    [sym_final] = ACTIONS(5952),
    [sym_function] = ACTIONS(5952),
    [sym_immutable] = ACTIONS(5952),
    [sym_in] = ACTIONS(5952),
    [sym_inout] = ACTIONS(5952),
    [sym_lazy] = ACTIONS(5952),
    [sym_mixin] = ACTIONS(5952),
    [sym_nothrow] = ACTIONS(5952),
    [sym_out] = ACTIONS(5952),
    [sym_override] = ACTIONS(5952),
    [sym_pure] = ACTIONS(5952),
    [sym_ref] = ACTIONS(5952),
    [sym_return] = ACTIONS(5952),
    [sym_scope] = ACTIONS(5952),
    [sym_shared] = ACTIONS(5952),
    [sym_static] = ACTIONS(5952),
    [sym_synchronized] = ACTIONS(5952),
    [sym_typeof] = ACTIONS(5952),
    [sym_gshared] = ACTIONS(5952),
    [sym_traits] = ACTIONS(5952),
    [sym_vector] = ACTIONS(5952),
    [sym_void] = ACTIONS(5952),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2579] = {
    [sym_identifier] = ACTIONS(5940),
    [anon_sym_LBRACE] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5942),
    [anon_sym_LPAREN] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_EQ] = ACTIONS(5942),
    [anon_sym_STAR] = ACTIONS(5942),
    [anon_sym_AT] = ACTIONS(5942),
    [sym_bool] = ACTIONS(5940),
    [sym_byte] = ACTIONS(5940),
    [sym_ubyte] = ACTIONS(5940),
    [sym_char] = ACTIONS(5940),
    [sym_short] = ACTIONS(5940),
    [sym_ushort] = ACTIONS(5940),
    [sym_int] = ACTIONS(5940),
    [sym_uint] = ACTIONS(5940),
    [sym_long] = ACTIONS(5940),
    [sym_ulong] = ACTIONS(5940),
    [sym_cent] = ACTIONS(5940),
    [sym_ucent] = ACTIONS(5940),
    [sym_wchar] = ACTIONS(5940),
    [sym_dchar] = ACTIONS(5940),
    [sym_float] = ACTIONS(5940),
    [sym_double] = ACTIONS(5940),
    [sym_real] = ACTIONS(5940),
    [sym_ifloat] = ACTIONS(5940),
    [sym_idouble] = ACTIONS(5940),
    [sym_ireal] = ACTIONS(5940),
    [sym_cfloat] = ACTIONS(5940),
    [sym_cdouble] = ACTIONS(5940),
    [sym_creal] = ACTIONS(5940),
    [sym_size_t] = ACTIONS(5940),
    [sym_ptrdiff_t] = ACTIONS(5940),
    [sym_string] = ACTIONS(5940),
    [sym_cstring] = ACTIONS(5940),
    [sym_dstring] = ACTIONS(5940),
    [sym_wstring] = ACTIONS(5940),
    [sym_noreturn] = ACTIONS(5940),
    [sym_abstract] = ACTIONS(5940),
    [sym_align] = ACTIONS(5940),
    [sym_auto] = ACTIONS(5940),
    [sym_const] = ACTIONS(5940),
    [sym_delegate] = ACTIONS(5940),
    [sym_deprecated] = ACTIONS(5940),
    [sym_do] = ACTIONS(5940),
    [sym_enum] = ACTIONS(5940),
    [sym_extern] = ACTIONS(5940),
    [sym_final] = ACTIONS(5940),
    [sym_function] = ACTIONS(5940),
    [sym_immutable] = ACTIONS(5940),
    [sym_in] = ACTIONS(5940),
    [sym_inout] = ACTIONS(5940),
    [sym_lazy] = ACTIONS(5940),
    [sym_mixin] = ACTIONS(5940),
    [sym_nothrow] = ACTIONS(5940),
    [sym_out] = ACTIONS(5940),
    [sym_override] = ACTIONS(5940),
    [sym_pure] = ACTIONS(5940),
    [sym_ref] = ACTIONS(5940),
    [sym_return] = ACTIONS(5940),
    [sym_scope] = ACTIONS(5940),
    [sym_shared] = ACTIONS(5940),
    [sym_static] = ACTIONS(5940),
    [sym_synchronized] = ACTIONS(5940),
    [sym_typeof] = ACTIONS(5940),
    [sym_gshared] = ACTIONS(5940),
    [sym_traits] = ACTIONS(5940),
    [sym_vector] = ACTIONS(5940),
    [sym_void] = ACTIONS(5940),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2580] = {
    [sym_identifier] = ACTIONS(3053),
    [anon_sym_LBRACE] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [sym_bool] = ACTIONS(3053),
    [sym_byte] = ACTIONS(3053),
    [sym_ubyte] = ACTIONS(3053),
    [sym_char] = ACTIONS(3053),
    [sym_short] = ACTIONS(3053),
    [sym_ushort] = ACTIONS(3053),
    [sym_int] = ACTIONS(3053),
    [sym_uint] = ACTIONS(3053),
    [sym_long] = ACTIONS(3053),
    [sym_ulong] = ACTIONS(3053),
    [sym_cent] = ACTIONS(3053),
    [sym_ucent] = ACTIONS(3053),
    [sym_wchar] = ACTIONS(3053),
    [sym_dchar] = ACTIONS(3053),
    [sym_float] = ACTIONS(3053),
    [sym_double] = ACTIONS(3053),
    [sym_real] = ACTIONS(3053),
    [sym_ifloat] = ACTIONS(3053),
    [sym_idouble] = ACTIONS(3053),
    [sym_ireal] = ACTIONS(3053),
    [sym_cfloat] = ACTIONS(3053),
    [sym_cdouble] = ACTIONS(3053),
    [sym_creal] = ACTIONS(3053),
    [sym_size_t] = ACTIONS(3053),
    [sym_ptrdiff_t] = ACTIONS(3053),
    [sym_string] = ACTIONS(3053),
    [sym_cstring] = ACTIONS(3053),
    [sym_dstring] = ACTIONS(3053),
    [sym_wstring] = ACTIONS(3053),
    [sym_noreturn] = ACTIONS(3053),
    [sym_abstract] = ACTIONS(3053),
    [sym_align] = ACTIONS(3053),
    [sym_auto] = ACTIONS(3053),
    [sym_const] = ACTIONS(3053),
    [sym_delegate] = ACTIONS(3053),
    [sym_deprecated] = ACTIONS(3053),
    [sym_do] = ACTIONS(3053),
    [sym_enum] = ACTIONS(3053),
    [sym_extern] = ACTIONS(3053),
    [sym_final] = ACTIONS(3053),
    [sym_function] = ACTIONS(3053),
    [sym_immutable] = ACTIONS(3053),
    [sym_in] = ACTIONS(3053),
    [sym_inout] = ACTIONS(3053),
    [sym_lazy] = ACTIONS(3053),
    [sym_mixin] = ACTIONS(3053),
    [sym_nothrow] = ACTIONS(3053),
    [sym_out] = ACTIONS(3053),
    [sym_override] = ACTIONS(3053),
    [sym_pure] = ACTIONS(3053),
    [sym_ref] = ACTIONS(3053),
    [sym_return] = ACTIONS(3053),
    [sym_scope] = ACTIONS(3053),
    [sym_shared] = ACTIONS(3053),
    [sym_static] = ACTIONS(3053),
    [sym_synchronized] = ACTIONS(3053),
    [sym_typeof] = ACTIONS(3053),
    [sym_gshared] = ACTIONS(3053),
    [sym_traits] = ACTIONS(3053),
    [sym_vector] = ACTIONS(3053),
    [sym_void] = ACTIONS(3053),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2581] = {
    [sym_identifier] = ACTIONS(3097),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3099),
    [sym_bool] = ACTIONS(3097),
    [sym_byte] = ACTIONS(3097),
    [sym_ubyte] = ACTIONS(3097),
    [sym_char] = ACTIONS(3097),
    [sym_short] = ACTIONS(3097),
    [sym_ushort] = ACTIONS(3097),
    [sym_int] = ACTIONS(3097),
    [sym_uint] = ACTIONS(3097),
    [sym_long] = ACTIONS(3097),
    [sym_ulong] = ACTIONS(3097),
    [sym_cent] = ACTIONS(3097),
    [sym_ucent] = ACTIONS(3097),
    [sym_wchar] = ACTIONS(3097),
    [sym_dchar] = ACTIONS(3097),
    [sym_float] = ACTIONS(3097),
    [sym_double] = ACTIONS(3097),
    [sym_real] = ACTIONS(3097),
    [sym_ifloat] = ACTIONS(3097),
    [sym_idouble] = ACTIONS(3097),
    [sym_ireal] = ACTIONS(3097),
    [sym_cfloat] = ACTIONS(3097),
    [sym_cdouble] = ACTIONS(3097),
    [sym_creal] = ACTIONS(3097),
    [sym_size_t] = ACTIONS(3097),
    [sym_ptrdiff_t] = ACTIONS(3097),
    [sym_string] = ACTIONS(3097),
    [sym_cstring] = ACTIONS(3097),
    [sym_dstring] = ACTIONS(3097),
    [sym_wstring] = ACTIONS(3097),
    [sym_noreturn] = ACTIONS(3097),
    [sym_abstract] = ACTIONS(3097),
    [sym_align] = ACTIONS(3097),
    [sym_auto] = ACTIONS(3097),
    [sym_const] = ACTIONS(3097),
    [sym_delegate] = ACTIONS(3097),
    [sym_deprecated] = ACTIONS(3097),
    [sym_do] = ACTIONS(3097),
    [sym_enum] = ACTIONS(3097),
    [sym_extern] = ACTIONS(3097),
    [sym_final] = ACTIONS(3097),
    [sym_function] = ACTIONS(3097),
    [sym_immutable] = ACTIONS(3097),
    [sym_in] = ACTIONS(3097),
    [sym_inout] = ACTIONS(3097),
    [sym_lazy] = ACTIONS(3097),
    [sym_mixin] = ACTIONS(3097),
    [sym_nothrow] = ACTIONS(3097),
    [sym_out] = ACTIONS(3097),
    [sym_override] = ACTIONS(3097),
    [sym_pure] = ACTIONS(3097),
    [sym_ref] = ACTIONS(3097),
    [sym_return] = ACTIONS(3097),
    [sym_scope] = ACTIONS(3097),
    [sym_shared] = ACTIONS(3097),
    [sym_static] = ACTIONS(3097),
    [sym_synchronized] = ACTIONS(3097),
    [sym_typeof] = ACTIONS(3097),
    [sym_gshared] = ACTIONS(3097),
    [sym_traits] = ACTIONS(3097),
    [sym_vector] = ACTIONS(3097),
    [sym_void] = ACTIONS(3097),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2582] = {
    [sym_identifier] = ACTIONS(3037),
    [anon_sym_LBRACE] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3039),
    [anon_sym_AT] = ACTIONS(3039),
    [sym_bool] = ACTIONS(3037),
    [sym_byte] = ACTIONS(3037),
    [sym_ubyte] = ACTIONS(3037),
    [sym_char] = ACTIONS(3037),
    [sym_short] = ACTIONS(3037),
    [sym_ushort] = ACTIONS(3037),
    [sym_int] = ACTIONS(3037),
    [sym_uint] = ACTIONS(3037),
    [sym_long] = ACTIONS(3037),
    [sym_ulong] = ACTIONS(3037),
    [sym_cent] = ACTIONS(3037),
    [sym_ucent] = ACTIONS(3037),
    [sym_wchar] = ACTIONS(3037),
    [sym_dchar] = ACTIONS(3037),
    [sym_float] = ACTIONS(3037),
    [sym_double] = ACTIONS(3037),
    [sym_real] = ACTIONS(3037),
    [sym_ifloat] = ACTIONS(3037),
    [sym_idouble] = ACTIONS(3037),
    [sym_ireal] = ACTIONS(3037),
    [sym_cfloat] = ACTIONS(3037),
    [sym_cdouble] = ACTIONS(3037),
    [sym_creal] = ACTIONS(3037),
    [sym_size_t] = ACTIONS(3037),
    [sym_ptrdiff_t] = ACTIONS(3037),
    [sym_string] = ACTIONS(3037),
    [sym_cstring] = ACTIONS(3037),
    [sym_dstring] = ACTIONS(3037),
    [sym_wstring] = ACTIONS(3037),
    [sym_noreturn] = ACTIONS(3037),
    [sym_abstract] = ACTIONS(3037),
    [sym_align] = ACTIONS(3037),
    [sym_auto] = ACTIONS(3037),
    [sym_const] = ACTIONS(3037),
    [sym_delegate] = ACTIONS(3037),
    [sym_deprecated] = ACTIONS(3037),
    [sym_do] = ACTIONS(3037),
    [sym_enum] = ACTIONS(3037),
    [sym_extern] = ACTIONS(3037),
    [sym_final] = ACTIONS(3037),
    [sym_function] = ACTIONS(3037),
    [sym_immutable] = ACTIONS(3037),
    [sym_in] = ACTIONS(3037),
    [sym_inout] = ACTIONS(3037),
    [sym_lazy] = ACTIONS(3037),
    [sym_mixin] = ACTIONS(3037),
    [sym_nothrow] = ACTIONS(3037),
    [sym_out] = ACTIONS(3037),
    [sym_override] = ACTIONS(3037),
    [sym_pure] = ACTIONS(3037),
    [sym_ref] = ACTIONS(3037),
    [sym_return] = ACTIONS(3037),
    [sym_scope] = ACTIONS(3037),
    [sym_shared] = ACTIONS(3037),
    [sym_static] = ACTIONS(3037),
    [sym_synchronized] = ACTIONS(3037),
    [sym_typeof] = ACTIONS(3037),
    [sym_gshared] = ACTIONS(3037),
    [sym_traits] = ACTIONS(3037),
    [sym_vector] = ACTIONS(3037),
    [sym_void] = ACTIONS(3037),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2583] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3103),
    [sym_bool] = ACTIONS(3101),
    [sym_byte] = ACTIONS(3101),
    [sym_ubyte] = ACTIONS(3101),
    [sym_char] = ACTIONS(3101),
    [sym_short] = ACTIONS(3101),
    [sym_ushort] = ACTIONS(3101),
    [sym_int] = ACTIONS(3101),
    [sym_uint] = ACTIONS(3101),
    [sym_long] = ACTIONS(3101),
    [sym_ulong] = ACTIONS(3101),
    [sym_cent] = ACTIONS(3101),
    [sym_ucent] = ACTIONS(3101),
    [sym_wchar] = ACTIONS(3101),
    [sym_dchar] = ACTIONS(3101),
    [sym_float] = ACTIONS(3101),
    [sym_double] = ACTIONS(3101),
    [sym_real] = ACTIONS(3101),
    [sym_ifloat] = ACTIONS(3101),
    [sym_idouble] = ACTIONS(3101),
    [sym_ireal] = ACTIONS(3101),
    [sym_cfloat] = ACTIONS(3101),
    [sym_cdouble] = ACTIONS(3101),
    [sym_creal] = ACTIONS(3101),
    [sym_size_t] = ACTIONS(3101),
    [sym_ptrdiff_t] = ACTIONS(3101),
    [sym_string] = ACTIONS(3101),
    [sym_cstring] = ACTIONS(3101),
    [sym_dstring] = ACTIONS(3101),
    [sym_wstring] = ACTIONS(3101),
    [sym_noreturn] = ACTIONS(3101),
    [sym_abstract] = ACTIONS(3101),
    [sym_align] = ACTIONS(3101),
    [sym_auto] = ACTIONS(3101),
    [sym_const] = ACTIONS(3101),
    [sym_delegate] = ACTIONS(3101),
    [sym_deprecated] = ACTIONS(3101),
    [sym_do] = ACTIONS(3101),
    [sym_enum] = ACTIONS(3101),
    [sym_extern] = ACTIONS(3101),
    [sym_final] = ACTIONS(3101),
    [sym_function] = ACTIONS(3101),
    [sym_immutable] = ACTIONS(3101),
    [sym_in] = ACTIONS(3101),
    [sym_inout] = ACTIONS(3101),
    [sym_lazy] = ACTIONS(3101),
    [sym_mixin] = ACTIONS(3101),
    [sym_nothrow] = ACTIONS(3101),
    [sym_out] = ACTIONS(3101),
    [sym_override] = ACTIONS(3101),
    [sym_pure] = ACTIONS(3101),
    [sym_ref] = ACTIONS(3101),
    [sym_return] = ACTIONS(3101),
    [sym_scope] = ACTIONS(3101),
    [sym_shared] = ACTIONS(3101),
    [sym_static] = ACTIONS(3101),
    [sym_synchronized] = ACTIONS(3101),
    [sym_typeof] = ACTIONS(3101),
    [sym_gshared] = ACTIONS(3101),
    [sym_traits] = ACTIONS(3101),
    [sym_vector] = ACTIONS(3101),
    [sym_void] = ACTIONS(3101),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2584] = {
    [sym_identifier] = ACTIONS(3093),
    [anon_sym_LBRACE] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3095),
    [sym_bool] = ACTIONS(3093),
    [sym_byte] = ACTIONS(3093),
    [sym_ubyte] = ACTIONS(3093),
    [sym_char] = ACTIONS(3093),
    [sym_short] = ACTIONS(3093),
    [sym_ushort] = ACTIONS(3093),
    [sym_int] = ACTIONS(3093),
    [sym_uint] = ACTIONS(3093),
    [sym_long] = ACTIONS(3093),
    [sym_ulong] = ACTIONS(3093),
    [sym_cent] = ACTIONS(3093),
    [sym_ucent] = ACTIONS(3093),
    [sym_wchar] = ACTIONS(3093),
    [sym_dchar] = ACTIONS(3093),
    [sym_float] = ACTIONS(3093),
    [sym_double] = ACTIONS(3093),
    [sym_real] = ACTIONS(3093),
    [sym_ifloat] = ACTIONS(3093),
    [sym_idouble] = ACTIONS(3093),
    [sym_ireal] = ACTIONS(3093),
    [sym_cfloat] = ACTIONS(3093),
    [sym_cdouble] = ACTIONS(3093),
    [sym_creal] = ACTIONS(3093),
    [sym_size_t] = ACTIONS(3093),
    [sym_ptrdiff_t] = ACTIONS(3093),
    [sym_string] = ACTIONS(3093),
    [sym_cstring] = ACTIONS(3093),
    [sym_dstring] = ACTIONS(3093),
    [sym_wstring] = ACTIONS(3093),
    [sym_noreturn] = ACTIONS(3093),
    [sym_abstract] = ACTIONS(3093),
    [sym_align] = ACTIONS(3093),
    [sym_auto] = ACTIONS(3093),
    [sym_const] = ACTIONS(3093),
    [sym_delegate] = ACTIONS(3093),
    [sym_deprecated] = ACTIONS(3093),
    [sym_do] = ACTIONS(3093),
    [sym_enum] = ACTIONS(3093),
    [sym_extern] = ACTIONS(3093),
    [sym_final] = ACTIONS(3093),
    [sym_function] = ACTIONS(3093),
    [sym_immutable] = ACTIONS(3093),
    [sym_in] = ACTIONS(3093),
    [sym_inout] = ACTIONS(3093),
    [sym_lazy] = ACTIONS(3093),
    [sym_mixin] = ACTIONS(3093),
    [sym_nothrow] = ACTIONS(3093),
    [sym_out] = ACTIONS(3093),
    [sym_override] = ACTIONS(3093),
    [sym_pure] = ACTIONS(3093),
    [sym_ref] = ACTIONS(3093),
    [sym_return] = ACTIONS(3093),
    [sym_scope] = ACTIONS(3093),
    [sym_shared] = ACTIONS(3093),
    [sym_static] = ACTIONS(3093),
    [sym_synchronized] = ACTIONS(3093),
    [sym_typeof] = ACTIONS(3093),
    [sym_gshared] = ACTIONS(3093),
    [sym_traits] = ACTIONS(3093),
    [sym_vector] = ACTIONS(3093),
    [sym_void] = ACTIONS(3093),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2585] = {
    [sym_identifier] = ACTIONS(3105),
    [anon_sym_LBRACE] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [sym_bool] = ACTIONS(3105),
    [sym_byte] = ACTIONS(3105),
    [sym_ubyte] = ACTIONS(3105),
    [sym_char] = ACTIONS(3105),
    [sym_short] = ACTIONS(3105),
    [sym_ushort] = ACTIONS(3105),
    [sym_int] = ACTIONS(3105),
    [sym_uint] = ACTIONS(3105),
    [sym_long] = ACTIONS(3105),
    [sym_ulong] = ACTIONS(3105),
    [sym_cent] = ACTIONS(3105),
    [sym_ucent] = ACTIONS(3105),
    [sym_wchar] = ACTIONS(3105),
    [sym_dchar] = ACTIONS(3105),
    [sym_float] = ACTIONS(3105),
    [sym_double] = ACTIONS(3105),
    [sym_real] = ACTIONS(3105),
    [sym_ifloat] = ACTIONS(3105),
    [sym_idouble] = ACTIONS(3105),
    [sym_ireal] = ACTIONS(3105),
    [sym_cfloat] = ACTIONS(3105),
    [sym_cdouble] = ACTIONS(3105),
    [sym_creal] = ACTIONS(3105),
    [sym_size_t] = ACTIONS(3105),
    [sym_ptrdiff_t] = ACTIONS(3105),
    [sym_string] = ACTIONS(3105),
    [sym_cstring] = ACTIONS(3105),
    [sym_dstring] = ACTIONS(3105),
    [sym_wstring] = ACTIONS(3105),
    [sym_noreturn] = ACTIONS(3105),
    [sym_abstract] = ACTIONS(3105),
    [sym_align] = ACTIONS(3105),
    [sym_auto] = ACTIONS(3105),
    [sym_const] = ACTIONS(3105),
    [sym_delegate] = ACTIONS(3105),
    [sym_deprecated] = ACTIONS(3105),
    [sym_do] = ACTIONS(3105),
    [sym_enum] = ACTIONS(3105),
    [sym_extern] = ACTIONS(3105),
    [sym_final] = ACTIONS(3105),
    [sym_function] = ACTIONS(3105),
    [sym_immutable] = ACTIONS(3105),
    [sym_in] = ACTIONS(3105),
    [sym_inout] = ACTIONS(3105),
    [sym_lazy] = ACTIONS(3105),
    [sym_mixin] = ACTIONS(3105),
    [sym_nothrow] = ACTIONS(3105),
    [sym_out] = ACTIONS(3105),
    [sym_override] = ACTIONS(3105),
    [sym_pure] = ACTIONS(3105),
    [sym_ref] = ACTIONS(3105),
    [sym_return] = ACTIONS(3105),
    [sym_scope] = ACTIONS(3105),
    [sym_shared] = ACTIONS(3105),
    [sym_static] = ACTIONS(3105),
    [sym_synchronized] = ACTIONS(3105),
    [sym_typeof] = ACTIONS(3105),
    [sym_gshared] = ACTIONS(3105),
    [sym_traits] = ACTIONS(3105),
    [sym_vector] = ACTIONS(3105),
    [sym_void] = ACTIONS(3105),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2586] = {
    [sym_identifier] = ACTIONS(3109),
    [anon_sym_LBRACE] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(3111),
    [sym_bool] = ACTIONS(3109),
    [sym_byte] = ACTIONS(3109),
    [sym_ubyte] = ACTIONS(3109),
    [sym_char] = ACTIONS(3109),
    [sym_short] = ACTIONS(3109),
    [sym_ushort] = ACTIONS(3109),
    [sym_int] = ACTIONS(3109),
    [sym_uint] = ACTIONS(3109),
    [sym_long] = ACTIONS(3109),
    [sym_ulong] = ACTIONS(3109),
    [sym_cent] = ACTIONS(3109),
    [sym_ucent] = ACTIONS(3109),
    [sym_wchar] = ACTIONS(3109),
    [sym_dchar] = ACTIONS(3109),
    [sym_float] = ACTIONS(3109),
    [sym_double] = ACTIONS(3109),
    [sym_real] = ACTIONS(3109),
    [sym_ifloat] = ACTIONS(3109),
    [sym_idouble] = ACTIONS(3109),
    [sym_ireal] = ACTIONS(3109),
    [sym_cfloat] = ACTIONS(3109),
    [sym_cdouble] = ACTIONS(3109),
    [sym_creal] = ACTIONS(3109),
    [sym_size_t] = ACTIONS(3109),
    [sym_ptrdiff_t] = ACTIONS(3109),
    [sym_string] = ACTIONS(3109),
    [sym_cstring] = ACTIONS(3109),
    [sym_dstring] = ACTIONS(3109),
    [sym_wstring] = ACTIONS(3109),
    [sym_noreturn] = ACTIONS(3109),
    [sym_abstract] = ACTIONS(3109),
    [sym_align] = ACTIONS(3109),
    [sym_auto] = ACTIONS(3109),
    [sym_const] = ACTIONS(3109),
    [sym_delegate] = ACTIONS(3109),
    [sym_deprecated] = ACTIONS(3109),
    [sym_do] = ACTIONS(3109),
    [sym_enum] = ACTIONS(3109),
    [sym_extern] = ACTIONS(3109),
    [sym_final] = ACTIONS(3109),
    [sym_function] = ACTIONS(3109),
    [sym_immutable] = ACTIONS(3109),
    [sym_in] = ACTIONS(3109),
    [sym_inout] = ACTIONS(3109),
    [sym_lazy] = ACTIONS(3109),
    [sym_mixin] = ACTIONS(3109),
    [sym_nothrow] = ACTIONS(3109),
    [sym_out] = ACTIONS(3109),
    [sym_override] = ACTIONS(3109),
    [sym_pure] = ACTIONS(3109),
    [sym_ref] = ACTIONS(3109),
    [sym_return] = ACTIONS(3109),
    [sym_scope] = ACTIONS(3109),
    [sym_shared] = ACTIONS(3109),
    [sym_static] = ACTIONS(3109),
    [sym_synchronized] = ACTIONS(3109),
    [sym_typeof] = ACTIONS(3109),
    [sym_gshared] = ACTIONS(3109),
    [sym_traits] = ACTIONS(3109),
    [sym_vector] = ACTIONS(3109),
    [sym_void] = ACTIONS(3109),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2587] = {
    [sym_identifier] = ACTIONS(3117),
    [anon_sym_LBRACE] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [sym_bool] = ACTIONS(3117),
    [sym_byte] = ACTIONS(3117),
    [sym_ubyte] = ACTIONS(3117),
    [sym_char] = ACTIONS(3117),
    [sym_short] = ACTIONS(3117),
    [sym_ushort] = ACTIONS(3117),
    [sym_int] = ACTIONS(3117),
    [sym_uint] = ACTIONS(3117),
    [sym_long] = ACTIONS(3117),
    [sym_ulong] = ACTIONS(3117),
    [sym_cent] = ACTIONS(3117),
    [sym_ucent] = ACTIONS(3117),
    [sym_wchar] = ACTIONS(3117),
    [sym_dchar] = ACTIONS(3117),
    [sym_float] = ACTIONS(3117),
    [sym_double] = ACTIONS(3117),
    [sym_real] = ACTIONS(3117),
    [sym_ifloat] = ACTIONS(3117),
    [sym_idouble] = ACTIONS(3117),
    [sym_ireal] = ACTIONS(3117),
    [sym_cfloat] = ACTIONS(3117),
    [sym_cdouble] = ACTIONS(3117),
    [sym_creal] = ACTIONS(3117),
    [sym_size_t] = ACTIONS(3117),
    [sym_ptrdiff_t] = ACTIONS(3117),
    [sym_string] = ACTIONS(3117),
    [sym_cstring] = ACTIONS(3117),
    [sym_dstring] = ACTIONS(3117),
    [sym_wstring] = ACTIONS(3117),
    [sym_noreturn] = ACTIONS(3117),
    [sym_abstract] = ACTIONS(3117),
    [sym_align] = ACTIONS(3117),
    [sym_auto] = ACTIONS(3117),
    [sym_const] = ACTIONS(3117),
    [sym_delegate] = ACTIONS(3117),
    [sym_deprecated] = ACTIONS(3117),
    [sym_do] = ACTIONS(3117),
    [sym_enum] = ACTIONS(3117),
    [sym_extern] = ACTIONS(3117),
    [sym_final] = ACTIONS(3117),
    [sym_function] = ACTIONS(3117),
    [sym_immutable] = ACTIONS(3117),
    [sym_in] = ACTIONS(3117),
    [sym_inout] = ACTIONS(3117),
    [sym_lazy] = ACTIONS(3117),
    [sym_mixin] = ACTIONS(3117),
    [sym_nothrow] = ACTIONS(3117),
    [sym_out] = ACTIONS(3117),
    [sym_override] = ACTIONS(3117),
    [sym_pure] = ACTIONS(3117),
    [sym_ref] = ACTIONS(3117),
    [sym_return] = ACTIONS(3117),
    [sym_scope] = ACTIONS(3117),
    [sym_shared] = ACTIONS(3117),
    [sym_static] = ACTIONS(3117),
    [sym_synchronized] = ACTIONS(3117),
    [sym_typeof] = ACTIONS(3117),
    [sym_gshared] = ACTIONS(3117),
    [sym_traits] = ACTIONS(3117),
    [sym_vector] = ACTIONS(3117),
    [sym_void] = ACTIONS(3117),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2588] = {
    [sym_identifier] = ACTIONS(3113),
    [anon_sym_LBRACE] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3115),
    [sym_bool] = ACTIONS(3113),
    [sym_byte] = ACTIONS(3113),
    [sym_ubyte] = ACTIONS(3113),
    [sym_char] = ACTIONS(3113),
    [sym_short] = ACTIONS(3113),
    [sym_ushort] = ACTIONS(3113),
    [sym_int] = ACTIONS(3113),
    [sym_uint] = ACTIONS(3113),
    [sym_long] = ACTIONS(3113),
    [sym_ulong] = ACTIONS(3113),
    [sym_cent] = ACTIONS(3113),
    [sym_ucent] = ACTIONS(3113),
    [sym_wchar] = ACTIONS(3113),
    [sym_dchar] = ACTIONS(3113),
    [sym_float] = ACTIONS(3113),
    [sym_double] = ACTIONS(3113),
    [sym_real] = ACTIONS(3113),
    [sym_ifloat] = ACTIONS(3113),
    [sym_idouble] = ACTIONS(3113),
    [sym_ireal] = ACTIONS(3113),
    [sym_cfloat] = ACTIONS(3113),
    [sym_cdouble] = ACTIONS(3113),
    [sym_creal] = ACTIONS(3113),
    [sym_size_t] = ACTIONS(3113),
    [sym_ptrdiff_t] = ACTIONS(3113),
    [sym_string] = ACTIONS(3113),
    [sym_cstring] = ACTIONS(3113),
    [sym_dstring] = ACTIONS(3113),
    [sym_wstring] = ACTIONS(3113),
    [sym_noreturn] = ACTIONS(3113),
    [sym_abstract] = ACTIONS(3113),
    [sym_align] = ACTIONS(3113),
    [sym_auto] = ACTIONS(3113),
    [sym_const] = ACTIONS(3113),
    [sym_delegate] = ACTIONS(3113),
    [sym_deprecated] = ACTIONS(3113),
    [sym_do] = ACTIONS(3113),
    [sym_enum] = ACTIONS(3113),
    [sym_extern] = ACTIONS(3113),
    [sym_final] = ACTIONS(3113),
    [sym_function] = ACTIONS(3113),
    [sym_immutable] = ACTIONS(3113),
    [sym_in] = ACTIONS(3113),
    [sym_inout] = ACTIONS(3113),
    [sym_lazy] = ACTIONS(3113),
    [sym_mixin] = ACTIONS(3113),
    [sym_nothrow] = ACTIONS(3113),
    [sym_out] = ACTIONS(3113),
    [sym_override] = ACTIONS(3113),
    [sym_pure] = ACTIONS(3113),
    [sym_ref] = ACTIONS(3113),
    [sym_return] = ACTIONS(3113),
    [sym_scope] = ACTIONS(3113),
    [sym_shared] = ACTIONS(3113),
    [sym_static] = ACTIONS(3113),
    [sym_synchronized] = ACTIONS(3113),
    [sym_typeof] = ACTIONS(3113),
    [sym_gshared] = ACTIONS(3113),
    [sym_traits] = ACTIONS(3113),
    [sym_vector] = ACTIONS(3113),
    [sym_void] = ACTIONS(3113),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2589] = {
    [sym_identifier] = ACTIONS(3077),
    [anon_sym_LBRACE] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3079),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3079),
    [sym_bool] = ACTIONS(3077),
    [sym_byte] = ACTIONS(3077),
    [sym_ubyte] = ACTIONS(3077),
    [sym_char] = ACTIONS(3077),
    [sym_short] = ACTIONS(3077),
    [sym_ushort] = ACTIONS(3077),
    [sym_int] = ACTIONS(3077),
    [sym_uint] = ACTIONS(3077),
    [sym_long] = ACTIONS(3077),
    [sym_ulong] = ACTIONS(3077),
    [sym_cent] = ACTIONS(3077),
    [sym_ucent] = ACTIONS(3077),
    [sym_wchar] = ACTIONS(3077),
    [sym_dchar] = ACTIONS(3077),
    [sym_float] = ACTIONS(3077),
    [sym_double] = ACTIONS(3077),
    [sym_real] = ACTIONS(3077),
    [sym_ifloat] = ACTIONS(3077),
    [sym_idouble] = ACTIONS(3077),
    [sym_ireal] = ACTIONS(3077),
    [sym_cfloat] = ACTIONS(3077),
    [sym_cdouble] = ACTIONS(3077),
    [sym_creal] = ACTIONS(3077),
    [sym_size_t] = ACTIONS(3077),
    [sym_ptrdiff_t] = ACTIONS(3077),
    [sym_string] = ACTIONS(3077),
    [sym_cstring] = ACTIONS(3077),
    [sym_dstring] = ACTIONS(3077),
    [sym_wstring] = ACTIONS(3077),
    [sym_noreturn] = ACTIONS(3077),
    [sym_abstract] = ACTIONS(3077),
    [sym_align] = ACTIONS(3077),
    [sym_auto] = ACTIONS(3077),
    [sym_const] = ACTIONS(3077),
    [sym_delegate] = ACTIONS(3077),
    [sym_deprecated] = ACTIONS(3077),
    [sym_do] = ACTIONS(3077),
    [sym_enum] = ACTIONS(3077),
    [sym_extern] = ACTIONS(3077),
    [sym_final] = ACTIONS(3077),
    [sym_function] = ACTIONS(3077),
    [sym_immutable] = ACTIONS(3077),
    [sym_in] = ACTIONS(3077),
    [sym_inout] = ACTIONS(3077),
    [sym_lazy] = ACTIONS(3077),
    [sym_mixin] = ACTIONS(3077),
    [sym_nothrow] = ACTIONS(3077),
    [sym_out] = ACTIONS(3077),
    [sym_override] = ACTIONS(3077),
    [sym_pure] = ACTIONS(3077),
    [sym_ref] = ACTIONS(3077),
    [sym_return] = ACTIONS(3077),
    [sym_scope] = ACTIONS(3077),
    [sym_shared] = ACTIONS(3077),
    [sym_static] = ACTIONS(3077),
    [sym_synchronized] = ACTIONS(3077),
    [sym_typeof] = ACTIONS(3077),
    [sym_gshared] = ACTIONS(3077),
    [sym_traits] = ACTIONS(3077),
    [sym_vector] = ACTIONS(3077),
    [sym_void] = ACTIONS(3077),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2590] = {
    [sym_type] = STATE(4038),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4136),
    [sym_block_statement] = STATE(5304),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(5304),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6623),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(5906),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6625),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2591] = {
    [sym_type] = STATE(4036),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4136),
    [sym_block_statement] = STATE(5304),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5304),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6627),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(5906),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6629),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2592] = {
    [sym_type] = STATE(4059),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4133),
    [sym_block_statement] = STATE(3174),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3174),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6631),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6633),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2593] = {
    [sym_type] = STATE(4053),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4180),
    [sym_block_statement] = STATE(3434),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3434),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6635),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3736),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6637),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2594] = {
    [sym_type] = STATE(4051),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4180),
    [sym_block_statement] = STATE(3434),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3434),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6639),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3736),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6641),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2595] = {
    [sym_type] = STATE(4031),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4120),
    [sym_block_statement] = STATE(3366),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3366),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6643),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6645),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2596] = {
    [sym_type] = STATE(3985),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4133),
    [sym_block_statement] = STATE(3174),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3174),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6647),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6649),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2597] = {
    [sym_type] = STATE(4044),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4188),
    [sym_block_statement] = STATE(3366),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3366),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6651),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6653),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2598] = {
    [sym_type] = STATE(4062),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4188),
    [sym_block_statement] = STATE(3366),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3366),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6655),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6657),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2599] = {
    [sym_type] = STATE(4017),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4170),
    [sym_block_statement] = STATE(3174),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3174),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6659),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6661),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2600] = {
    [sym_type] = STATE(4032),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4120),
    [sym_block_statement] = STATE(3366),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3366),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6663),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6665),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2601] = {
    [sym_type] = STATE(4021),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4170),
    [sym_block_statement] = STATE(3174),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3174),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6667),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6669),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2602] = {
    [sym_type] = STATE(4011),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4150),
    [sym_block_statement] = STATE(3174),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3174),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6671),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6673),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2603] = {
    [sym_type] = STATE(4010),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4150),
    [sym_block_statement] = STATE(3174),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3174),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_auto] = ACTIONS(6675),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_ref] = ACTIONS(6677),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2604] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5915),
    [aux_sym__variadic_arguments_attributes] = STATE(4340),
    [sym_variadic_arguments_attribute] = STATE(4340),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6681),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2605] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4814),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6132),
    [aux_sym__variadic_arguments_attributes] = STATE(4343),
    [sym_variadic_arguments_attribute] = STATE(4343),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6683),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2606] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5009),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6178),
    [aux_sym__variadic_arguments_attributes] = STATE(4323),
    [sym_variadic_arguments_attribute] = STATE(4323),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6685),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2607] = {
    [sym_storage_class] = STATE(2607),
    [sym_type_ctor] = STATE(2696),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [aux_sym_variable_declaration_repeat1] = STATE(2607),
    [sym_identifier] = ACTIONS(6687),
    [anon_sym_LBRACE] = ACTIONS(6689),
    [anon_sym_DOT] = ACTIONS(6689),
    [anon_sym_LPAREN] = ACTIONS(6689),
    [anon_sym_AT] = ACTIONS(6691),
    [sym_bool] = ACTIONS(6687),
    [sym_byte] = ACTIONS(6687),
    [sym_ubyte] = ACTIONS(6687),
    [sym_char] = ACTIONS(6687),
    [sym_short] = ACTIONS(6687),
    [sym_ushort] = ACTIONS(6687),
    [sym_int] = ACTIONS(6687),
    [sym_uint] = ACTIONS(6687),
    [sym_long] = ACTIONS(6687),
    [sym_ulong] = ACTIONS(6687),
    [sym_cent] = ACTIONS(6687),
    [sym_ucent] = ACTIONS(6687),
    [sym_wchar] = ACTIONS(6687),
    [sym_dchar] = ACTIONS(6687),
    [sym_float] = ACTIONS(6687),
    [sym_double] = ACTIONS(6687),
    [sym_real] = ACTIONS(6687),
    [sym_ifloat] = ACTIONS(6687),
    [sym_idouble] = ACTIONS(6687),
    [sym_ireal] = ACTIONS(6687),
    [sym_cfloat] = ACTIONS(6687),
    [sym_cdouble] = ACTIONS(6687),
    [sym_creal] = ACTIONS(6687),
    [sym_size_t] = ACTIONS(6687),
    [sym_ptrdiff_t] = ACTIONS(6687),
    [sym_string] = ACTIONS(6687),
    [sym_cstring] = ACTIONS(6687),
    [sym_dstring] = ACTIONS(6687),
    [sym_wstring] = ACTIONS(6687),
    [sym_noreturn] = ACTIONS(6687),
    [sym_abstract] = ACTIONS(6694),
    [sym_align] = ACTIONS(6697),
    [sym_auto] = ACTIONS(6694),
    [sym_const] = ACTIONS(6700),
    [sym_delegate] = ACTIONS(6687),
    [sym_deprecated] = ACTIONS(6694),
    [sym_do] = ACTIONS(6687),
    [sym_extern] = ACTIONS(6703),
    [sym_final] = ACTIONS(6694),
    [sym_function] = ACTIONS(6687),
    [sym_immutable] = ACTIONS(6700),
    [sym_in] = ACTIONS(6687),
    [sym_inout] = ACTIONS(6700),
    [sym_mixin] = ACTIONS(6687),
    [sym_nothrow] = ACTIONS(6694),
    [sym_out] = ACTIONS(6687),
    [sym_override] = ACTIONS(6694),
    [sym_pure] = ACTIONS(6694),
    [sym_ref] = ACTIONS(6694),
    [sym_scope] = ACTIONS(6694),
    [sym_shared] = ACTIONS(6700),
    [sym_static] = ACTIONS(6694),
    [sym_synchronized] = ACTIONS(6694),
    [sym_typeof] = ACTIONS(6687),
    [sym_gshared] = ACTIONS(6694),
    [sym_traits] = ACTIONS(6687),
    [sym_vector] = ACTIONS(6687),
    [sym_void] = ACTIONS(6687),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2608] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5925),
    [aux_sym__variadic_arguments_attributes] = STATE(4356),
    [sym_variadic_arguments_attribute] = STATE(4356),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6706),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2609] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5752),
    [aux_sym__variadic_arguments_attributes] = STATE(4358),
    [sym_variadic_arguments_attribute] = STATE(4358),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6708),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2610] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6401),
    [aux_sym__variadic_arguments_attributes] = STATE(4320),
    [sym_variadic_arguments_attribute] = STATE(4320),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6710),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2611] = {
    [sym_arguments] = STATE(2578),
    [sym_template_arguments] = STATE(2570),
    [sym_identifier] = ACTIONS(5924),
    [anon_sym_LBRACE] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5926),
    [anon_sym_BANG] = ACTIONS(6712),
    [anon_sym_LPAREN] = ACTIONS(6577),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_bool] = ACTIONS(5924),
    [sym_byte] = ACTIONS(5924),
    [sym_ubyte] = ACTIONS(5924),
    [sym_char] = ACTIONS(5924),
    [sym_short] = ACTIONS(5924),
    [sym_ushort] = ACTIONS(5924),
    [sym_int] = ACTIONS(5924),
    [sym_uint] = ACTIONS(5924),
    [sym_long] = ACTIONS(5924),
    [sym_ulong] = ACTIONS(5924),
    [sym_cent] = ACTIONS(5924),
    [sym_ucent] = ACTIONS(5924),
    [sym_wchar] = ACTIONS(5924),
    [sym_dchar] = ACTIONS(5924),
    [sym_float] = ACTIONS(5924),
    [sym_double] = ACTIONS(5924),
    [sym_real] = ACTIONS(5924),
    [sym_ifloat] = ACTIONS(5924),
    [sym_idouble] = ACTIONS(5924),
    [sym_ireal] = ACTIONS(5924),
    [sym_cfloat] = ACTIONS(5924),
    [sym_cdouble] = ACTIONS(5924),
    [sym_creal] = ACTIONS(5924),
    [sym_size_t] = ACTIONS(5924),
    [sym_ptrdiff_t] = ACTIONS(5924),
    [sym_string] = ACTIONS(5924),
    [sym_cstring] = ACTIONS(5924),
    [sym_dstring] = ACTIONS(5924),
    [sym_wstring] = ACTIONS(5924),
    [sym_noreturn] = ACTIONS(5924),
    [sym_abstract] = ACTIONS(5924),
    [sym_align] = ACTIONS(5924),
    [sym_auto] = ACTIONS(5924),
    [sym_const] = ACTIONS(5924),
    [sym_delegate] = ACTIONS(5924),
    [sym_deprecated] = ACTIONS(5924),
    [sym_do] = ACTIONS(5924),
    [sym_enum] = ACTIONS(5924),
    [sym_extern] = ACTIONS(5924),
    [sym_final] = ACTIONS(5924),
    [sym_function] = ACTIONS(5924),
    [sym_immutable] = ACTIONS(5924),
    [sym_in] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5924),
    [sym_lazy] = ACTIONS(5924),
    [sym_mixin] = ACTIONS(5924),
    [sym_nothrow] = ACTIONS(5924),
    [sym_out] = ACTIONS(5924),
    [sym_override] = ACTIONS(5924),
    [sym_pure] = ACTIONS(5924),
    [sym_ref] = ACTIONS(5924),
    [sym_return] = ACTIONS(5924),
    [sym_scope] = ACTIONS(5924),
    [sym_shared] = ACTIONS(5924),
    [sym_static] = ACTIONS(5924),
    [sym_synchronized] = ACTIONS(5924),
    [sym_typeof] = ACTIONS(5924),
    [sym_gshared] = ACTIONS(5924),
    [sym_traits] = ACTIONS(5924),
    [sym_vector] = ACTIONS(5924),
    [sym_void] = ACTIONS(5924),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2612] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6109),
    [aux_sym__variadic_arguments_attributes] = STATE(4339),
    [sym_variadic_arguments_attribute] = STATE(4339),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6714),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2613] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6291),
    [aux_sym__variadic_arguments_attributes] = STATE(4315),
    [sym_variadic_arguments_attribute] = STATE(4315),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6716),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2614] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5671),
    [aux_sym__variadic_arguments_attributes] = STATE(4330),
    [sym_variadic_arguments_attribute] = STATE(4330),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6718),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2615] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6138),
    [aux_sym__variadic_arguments_attributes] = STATE(4345),
    [sym_variadic_arguments_attribute] = STATE(4345),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6720),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2616] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5702),
    [aux_sym__variadic_arguments_attributes] = STATE(4332),
    [sym_variadic_arguments_attribute] = STATE(4332),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6722),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2617] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5186),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5640),
    [aux_sym__variadic_arguments_attributes] = STATE(4327),
    [sym_variadic_arguments_attribute] = STATE(4327),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6724),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2618] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4876),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6041),
    [aux_sym__variadic_arguments_attributes] = STATE(4363),
    [sym_variadic_arguments_attribute] = STATE(4363),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6726),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2619] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6360),
    [aux_sym__variadic_arguments_attributes] = STATE(4333),
    [sym_variadic_arguments_attribute] = STATE(4333),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6728),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2620] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4890),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6265),
    [aux_sym__variadic_arguments_attributes] = STATE(4309),
    [sym_variadic_arguments_attribute] = STATE(4309),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6730),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2621] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6198),
    [aux_sym__variadic_arguments_attributes] = STATE(4329),
    [sym_variadic_arguments_attribute] = STATE(4329),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6732),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2622] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6292),
    [aux_sym__variadic_arguments_attributes] = STATE(4310),
    [sym_variadic_arguments_attribute] = STATE(4310),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6734),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2623] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6091),
    [aux_sym__variadic_arguments_attributes] = STATE(4364),
    [sym_variadic_arguments_attribute] = STATE(4364),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6736),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2624] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4746),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5841),
    [aux_sym__variadic_arguments_attributes] = STATE(4352),
    [sym_variadic_arguments_attribute] = STATE(4352),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6738),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2625] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4780),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5854),
    [aux_sym__variadic_arguments_attributes] = STATE(4328),
    [sym_variadic_arguments_attribute] = STATE(4328),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6740),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2626] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6093),
    [aux_sym__variadic_arguments_attributes] = STATE(4367),
    [sym_variadic_arguments_attribute] = STATE(4367),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6742),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2627] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5681),
    [aux_sym__variadic_arguments_attributes] = STATE(4321),
    [sym_variadic_arguments_attribute] = STATE(4321),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6744),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2628] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6194),
    [aux_sym__variadic_arguments_attributes] = STATE(4336),
    [sym_variadic_arguments_attribute] = STATE(4336),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6746),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2629] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6105),
    [aux_sym__variadic_arguments_attributes] = STATE(4354),
    [sym_variadic_arguments_attribute] = STATE(4354),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6748),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2630] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(5791),
    [aux_sym__variadic_arguments_attributes] = STATE(4355),
    [sym_variadic_arguments_attribute] = STATE(4355),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6750),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2631] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(4946),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6108),
    [aux_sym__variadic_arguments_attributes] = STATE(4337),
    [sym_variadic_arguments_attribute] = STATE(4337),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6752),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2632] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5159),
    [sym_parameter_attribute] = STATE(2697),
    [sym_ellipses] = STATE(6520),
    [aux_sym__variadic_arguments_attributes] = STATE(4359),
    [sym_variadic_arguments_attribute] = STATE(4359),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6754),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2633] = {
    [sym_type] = STATE(4033),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4148),
    [sym_block_statement] = STATE(3182),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3182),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2634] = {
    [sym_type] = STATE(4072),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4153),
    [sym_block_statement] = STATE(5294),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(5294),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(5906),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2635] = {
    [sym_type] = STATE(4056),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4144),
    [sym_block_statement] = STATE(5313),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(5313),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(5906),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2636] = {
    [sym_type] = STATE(4055),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4144),
    [sym_block_statement] = STATE(5313),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5313),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(5906),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2637] = {
    [sym_type] = STATE(4034),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4147),
    [sym_block_statement] = STATE(3350),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3350),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2638] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(5654),
    [aux_sym__variadic_arguments_attributes] = STATE(4311),
    [sym_variadic_arguments_attribute] = STATE(4311),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6756),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2639] = {
    [sym_type] = STATE(4043),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4155),
    [sym_block_statement] = STATE(3224),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3224),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2640] = {
    [sym_type] = STATE(4054),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4197),
    [sym_block_statement] = STATE(3386),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3386),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2641] = {
    [sym_type] = STATE(4064),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4135),
    [sym_block_statement] = STATE(3386),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3386),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2642] = {
    [sym_type] = STATE(4057),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4135),
    [sym_block_statement] = STATE(3386),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3386),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2643] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(5968),
    [aux_sym__variadic_arguments_attributes] = STATE(4334),
    [sym_variadic_arguments_attribute] = STATE(4334),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6758),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2644] = {
    [sym_type] = STATE(4069),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4147),
    [sym_block_statement] = STATE(3350),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3350),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2645] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(6021),
    [aux_sym__variadic_arguments_attributes] = STATE(4353),
    [sym_variadic_arguments_attribute] = STATE(4353),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6760),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2646] = {
    [sym_type] = STATE(4050),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4197),
    [sym_block_statement] = STATE(3386),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3386),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2647] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(6057),
    [aux_sym__variadic_arguments_attributes] = STATE(4324),
    [sym_variadic_arguments_attribute] = STATE(4324),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6762),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2648] = {
    [sym_type] = STATE(4016),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4131),
    [sym_block_statement] = STATE(3182),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3182),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2649] = {
    [sym_type] = STATE(4024),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4145),
    [sym_block_statement] = STATE(3483),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3483),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3736),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2650] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(5840),
    [aux_sym__variadic_arguments_attributes] = STATE(4322),
    [sym_variadic_arguments_attribute] = STATE(4322),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6764),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2651] = {
    [sym_type] = STATE(4025),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4145),
    [sym_block_statement] = STATE(3483),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3483),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3736),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2652] = {
    [sym_type] = STATE(4071),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4153),
    [sym_block_statement] = STATE(5294),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(5294),
    [sym__function_contract] = STATE(4238),
    [sym__in_out_contract_expression] = STATE(4238),
    [sym__in_out_statement] = STATE(4238),
    [sym_in_contract_expression] = STATE(4238),
    [sym_out_contract_expression] = STATE(4238),
    [sym_in_statement] = STATE(4238),
    [sym_out_statement] = STATE(4238),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4238),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(5896),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(5906),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2653] = {
    [sym_type] = STATE(4018),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4134),
    [sym_block_statement] = STATE(3224),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3224),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2654] = {
    [sym_type] = STATE(4045),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4155),
    [sym_block_statement] = STATE(3224),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3224),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2655] = {
    [sym_type] = STATE(4020),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4134),
    [sym_block_statement] = STATE(3224),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3224),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2656] = {
    [sym_type] = STATE(4067),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4195),
    [sym_block_statement] = STATE(3350),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3350),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2657] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(5937),
    [aux_sym__variadic_arguments_attributes] = STATE(4365),
    [sym_variadic_arguments_attribute] = STATE(4365),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6766),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2658] = {
    [sym_type] = STATE(4068),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4195),
    [sym_block_statement] = STATE(3350),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3350),
    [sym__function_contract] = STATE(4246),
    [sym__in_out_contract_expression] = STATE(4246),
    [sym__in_out_statement] = STATE(4246),
    [sym_in_contract_expression] = STATE(4246),
    [sym_out_contract_expression] = STATE(4246),
    [sym_in_statement] = STATE(4246),
    [sym_out_statement] = STATE(4246),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4246),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3296),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3326),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2659] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_ellipses] = STATE(5829),
    [aux_sym__variadic_arguments_attributes] = STATE(4319),
    [sym_variadic_arguments_attribute] = STATE(4319),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(6768),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2660] = {
    [sym_type] = STATE(3976),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4148),
    [sym_block_statement] = STATE(3182),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3182),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2661] = {
    [sym_type] = STATE(4040),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4124),
    [sym_block_statement] = STATE(3224),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3224),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2662] = {
    [sym_type] = STATE(3997),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4184),
    [sym_block_statement] = STATE(3182),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3182),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2663] = {
    [sym_type] = STATE(3999),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4184),
    [sym_block_statement] = STATE(3182),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3182),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2664] = {
    [sym_type] = STATE(4037),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4124),
    [sym_block_statement] = STATE(3224),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3224),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2665] = {
    [sym_type] = STATE(3977),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_attributes] = STATE(4105),
    [sym_block_statement] = STATE(3459),
    [sym_parameters] = STATE(4267),
    [sym__specified_function_body] = STATE(3459),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(6619),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3736),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2666] = {
    [sym_type] = STATE(4041),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4105),
    [sym_block_statement] = STATE(3459),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3459),
    [sym__function_contract] = STATE(4232),
    [sym__in_out_contract_expression] = STATE(4232),
    [sym__in_out_statement] = STATE(4232),
    [sym_in_contract_expression] = STATE(4232),
    [sym_out_contract_expression] = STATE(4232),
    [sym_in_statement] = STATE(4232),
    [sym_out_statement] = STATE(4232),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4232),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(3708),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3736),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2667] = {
    [sym_type] = STATE(4015),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4270),
    [sym_vector_type] = STATE(4270),
    [sym__builtin_type] = STATE(4270),
    [sym__qualified_id] = STATE(4270),
    [sym_typeof_expression] = STATE(4263),
    [sym_mixin_expression] = STATE(4270),
    [sym__parameter_with_member_attributes] = STATE(4131),
    [sym_block_statement] = STATE(3182),
    [sym__parameters] = STATE(3945),
    [sym__specified_function_body] = STATE(3182),
    [sym__function_contract] = STATE(4243),
    [sym__in_out_contract_expression] = STATE(4243),
    [sym__in_out_statement] = STATE(4243),
    [sym_in_contract_expression] = STATE(4243),
    [sym_out_contract_expression] = STATE(4243),
    [sym_in_statement] = STATE(4243),
    [sym_out_statement] = STATE(4243),
    [sym_template_instance] = STATE(4262),
    [sym_traits_expression] = STATE(4270),
    [aux_sym_type_repeat1] = STATE(3249),
    [aux_sym_function_body_repeat1] = STATE(4243),
    [sym_identifier] = ACTIONS(6615),
    [anon_sym_LBRACE] = ACTIONS(814),
    [anon_sym_DOT] = ACTIONS(6617),
    [anon_sym_LPAREN] = ACTIONS(5898),
    [sym_bool] = ACTIONS(6621),
    [sym_byte] = ACTIONS(6621),
    [sym_ubyte] = ACTIONS(6621),
    [sym_char] = ACTIONS(6621),
    [sym_short] = ACTIONS(6621),
    [sym_ushort] = ACTIONS(6621),
    [sym_int] = ACTIONS(6621),
    [sym_uint] = ACTIONS(6621),
    [sym_long] = ACTIONS(6621),
    [sym_ulong] = ACTIONS(6621),
    [sym_cent] = ACTIONS(6621),
    [sym_ucent] = ACTIONS(6621),
    [sym_wchar] = ACTIONS(6621),
    [sym_dchar] = ACTIONS(6621),
    [sym_float] = ACTIONS(6621),
    [sym_double] = ACTIONS(6621),
    [sym_real] = ACTIONS(6621),
    [sym_ifloat] = ACTIONS(6621),
    [sym_idouble] = ACTIONS(6621),
    [sym_ireal] = ACTIONS(6621),
    [sym_cfloat] = ACTIONS(6621),
    [sym_cdouble] = ACTIONS(6621),
    [sym_creal] = ACTIONS(6621),
    [sym_size_t] = ACTIONS(6621),
    [sym_ptrdiff_t] = ACTIONS(6621),
    [sym_string] = ACTIONS(6621),
    [sym_cstring] = ACTIONS(6621),
    [sym_dstring] = ACTIONS(6621),
    [sym_wstring] = ACTIONS(6621),
    [sym_noreturn] = ACTIONS(6621),
    [sym_const] = ACTIONS(2125),
    [sym_do] = ACTIONS(3023),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(155),
    [sym_inout] = ACTIONS(2125),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(167),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(67),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(77),
    [sym_void] = ACTIONS(6621),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2668] = {
    [sym_type] = STATE(4437),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2694),
    [sym_ellipses] = STATE(5729),
    [aux_sym__variadic_arguments_attributes] = STATE(4366),
    [sym_variadic_arguments_attribute] = STATE(4366),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2694),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6327),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_RPAREN] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(3200),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(3200),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3212),
    [sym_scope] = ACTIONS(3212),
    [sym_shared] = ACTIONS(3200),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2669] = {
    [sym_identifier] = ACTIONS(3073),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_AT] = ACTIONS(3075),
    [sym_bool] = ACTIONS(3073),
    [sym_byte] = ACTIONS(3073),
    [sym_ubyte] = ACTIONS(3073),
    [sym_char] = ACTIONS(3073),
    [sym_short] = ACTIONS(3073),
    [sym_ushort] = ACTIONS(3073),
    [sym_int] = ACTIONS(3073),
    [sym_uint] = ACTIONS(3073),
    [sym_long] = ACTIONS(3073),
    [sym_ulong] = ACTIONS(3073),
    [sym_cent] = ACTIONS(3073),
    [sym_ucent] = ACTIONS(3073),
    [sym_wchar] = ACTIONS(3073),
    [sym_dchar] = ACTIONS(3073),
    [sym_float] = ACTIONS(3073),
    [sym_double] = ACTIONS(3073),
    [sym_real] = ACTIONS(3073),
    [sym_ifloat] = ACTIONS(3073),
    [sym_idouble] = ACTIONS(3073),
    [sym_ireal] = ACTIONS(3073),
    [sym_cfloat] = ACTIONS(3073),
    [sym_cdouble] = ACTIONS(3073),
    [sym_creal] = ACTIONS(3073),
    [sym_size_t] = ACTIONS(3073),
    [sym_ptrdiff_t] = ACTIONS(3073),
    [sym_string] = ACTIONS(3073),
    [sym_cstring] = ACTIONS(3073),
    [sym_dstring] = ACTIONS(3073),
    [sym_wstring] = ACTIONS(3073),
    [sym_noreturn] = ACTIONS(3073),
    [sym_abstract] = ACTIONS(3073),
    [sym_alias] = ACTIONS(3073),
    [sym_align] = ACTIONS(3073),
    [sym_auto] = ACTIONS(3073),
    [sym_const] = ACTIONS(3073),
    [sym_delegate] = ACTIONS(3073),
    [sym_deprecated] = ACTIONS(3073),
    [sym_do] = ACTIONS(3073),
    [sym_enum] = ACTIONS(3073),
    [sym_extern] = ACTIONS(3073),
    [sym_final] = ACTIONS(3073),
    [sym_function] = ACTIONS(3073),
    [sym_immutable] = ACTIONS(3073),
    [sym_in] = ACTIONS(3073),
    [sym_inout] = ACTIONS(3073),
    [sym_lazy] = ACTIONS(3073),
    [sym_mixin] = ACTIONS(3073),
    [sym_nothrow] = ACTIONS(3073),
    [sym_out] = ACTIONS(3073),
    [sym_override] = ACTIONS(3073),
    [sym_pure] = ACTIONS(3073),
    [sym_ref] = ACTIONS(3073),
    [sym_return] = ACTIONS(3073),
    [sym_scope] = ACTIONS(3073),
    [sym_shared] = ACTIONS(3073),
    [sym_static] = ACTIONS(3073),
    [sym_synchronized] = ACTIONS(3073),
    [sym_typeof] = ACTIONS(3073),
    [sym_gshared] = ACTIONS(3073),
    [sym_traits] = ACTIONS(3073),
    [sym_vector] = ACTIONS(3073),
    [sym_void] = ACTIONS(3073),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2670] = {
    [sym_at_attribute] = STATE(2716),
    [sym__function_attribute_kwd] = STATE(2716),
    [sym__function_attribute] = STATE(2716),
    [sym_member_function_attribute] = STATE(2672),
    [aux_sym_alias_declaration_repeat2] = STATE(2672),
    [anon_sym_RBRACE] = ACTIONS(6770),
    [anon_sym_SLASH] = ACTIONS(6772),
    [anon_sym_SLASH_EQ] = ACTIONS(6770),
    [anon_sym_DOT] = ACTIONS(6770),
    [anon_sym_AMP] = ACTIONS(6772),
    [anon_sym_AMP_EQ] = ACTIONS(6770),
    [anon_sym_AMP_AMP] = ACTIONS(6770),
    [anon_sym_PIPE] = ACTIONS(6772),
    [anon_sym_PIPE_EQ] = ACTIONS(6770),
    [anon_sym_PIPE_PIPE] = ACTIONS(6770),
    [anon_sym_DASH] = ACTIONS(6772),
    [anon_sym_DASH_EQ] = ACTIONS(6770),
    [anon_sym_DASH_DASH] = ACTIONS(6770),
    [anon_sym_PLUS] = ACTIONS(6772),
    [anon_sym_PLUS_EQ] = ACTIONS(6770),
    [anon_sym_PLUS_PLUS] = ACTIONS(6770),
    [anon_sym_LT] = ACTIONS(6772),
    [anon_sym_LT_EQ] = ACTIONS(6770),
    [anon_sym_LT_LT] = ACTIONS(6772),
    [anon_sym_LT_LT_EQ] = ACTIONS(6770),
    [anon_sym_GT] = ACTIONS(6772),
    [anon_sym_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT] = ACTIONS(6772),
    [anon_sym_GT_GT_GT] = ACTIONS(6772),
    [anon_sym_BANG_EQ] = ACTIONS(6770),
    [anon_sym_LPAREN] = ACTIONS(6770),
    [anon_sym_RPAREN] = ACTIONS(6770),
    [anon_sym_LBRACK] = ACTIONS(6770),
    [anon_sym_RBRACK] = ACTIONS(6770),
    [anon_sym_QMARK] = ACTIONS(6770),
    [anon_sym_COMMA] = ACTIONS(6770),
    [anon_sym_SEMI] = ACTIONS(6770),
    [anon_sym_COLON] = ACTIONS(6770),
    [anon_sym_EQ] = ACTIONS(6772),
    [anon_sym_EQ_EQ] = ACTIONS(6770),
    [anon_sym_STAR] = ACTIONS(6772),
    [anon_sym_STAR_EQ] = ACTIONS(6770),
    [anon_sym_PERCENT] = ACTIONS(6772),
    [anon_sym_PERCENT_EQ] = ACTIONS(6770),
    [anon_sym_CARET] = ACTIONS(6772),
    [anon_sym_CARET_EQ] = ACTIONS(6770),
    [anon_sym_CARET_CARET] = ACTIONS(6772),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6770),
    [anon_sym_TILDE] = ACTIONS(6772),
    [anon_sym_TILDE_EQ] = ACTIONS(6770),
    [anon_sym_AT] = ACTIONS(6774),
    [sym_const] = ACTIONS(6776),
    [sym_delegate] = ACTIONS(6770),
    [sym_function] = ACTIONS(6770),
    [sym_immutable] = ACTIONS(6776),
    [sym_in] = ACTIONS(6772),
    [sym_inout] = ACTIONS(6776),
    [sym_is] = ACTIONS(6770),
    [sym_nothrow] = ACTIONS(6776),
    [sym_pure] = ACTIONS(6776),
    [sym_return] = ACTIONS(6776),
    [sym_scope] = ACTIONS(6776),
    [sym_shared] = ACTIONS(6776),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6770),
    [sym_not_is] = ACTIONS(6770),
  },
  [2671] = {
    [sym_assert_expression] = STATE(5649),
    [sym__foreach] = STATE(6542),
    [sym_foreach_statement] = STATE(2030),
    [sym_identifier] = ACTIONS(6778),
    [anon_sym_DOT] = ACTIONS(6780),
    [anon_sym_COLON] = ACTIONS(669),
    [anon_sym_TILDE] = ACTIONS(5994),
    [anon_sym_AT] = ACTIONS(6780),
    [sym_bool] = ACTIONS(6778),
    [sym_byte] = ACTIONS(6778),
    [sym_ubyte] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_short] = ACTIONS(6778),
    [sym_ushort] = ACTIONS(6778),
    [sym_int] = ACTIONS(6778),
    [sym_uint] = ACTIONS(6778),
    [sym_long] = ACTIONS(6778),
    [sym_ulong] = ACTIONS(6778),
    [sym_cent] = ACTIONS(6778),
    [sym_ucent] = ACTIONS(6778),
    [sym_wchar] = ACTIONS(6778),
    [sym_dchar] = ACTIONS(6778),
    [sym_float] = ACTIONS(6778),
    [sym_double] = ACTIONS(6778),
    [sym_real] = ACTIONS(6778),
    [sym_ifloat] = ACTIONS(6778),
    [sym_idouble] = ACTIONS(6778),
    [sym_ireal] = ACTIONS(6778),
    [sym_cfloat] = ACTIONS(6778),
    [sym_cdouble] = ACTIONS(6778),
    [sym_creal] = ACTIONS(6778),
    [sym_size_t] = ACTIONS(6778),
    [sym_ptrdiff_t] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym_cstring] = ACTIONS(6778),
    [sym_dstring] = ACTIONS(6778),
    [sym_wstring] = ACTIONS(6778),
    [sym_noreturn] = ACTIONS(6778),
    [sym_this] = ACTIONS(5996),
    [sym_abstract] = ACTIONS(6778),
    [sym_align] = ACTIONS(6778),
    [sym_assert] = ACTIONS(5998),
    [sym_auto] = ACTIONS(6778),
    [sym_const] = ACTIONS(6778),
    [sym_deprecated] = ACTIONS(6778),
    [sym_enum] = ACTIONS(6778),
    [sym_extern] = ACTIONS(6778),
    [sym_final] = ACTIONS(6778),
    [sym_foreach] = ACTIONS(6018),
    [sym_foreach_reverse] = ACTIONS(6018),
    [sym_if] = ACTIONS(6002),
    [sym_immutable] = ACTIONS(6778),
    [sym_inout] = ACTIONS(6778),
    [sym_mixin] = ACTIONS(6778),
    [sym_nothrow] = ACTIONS(6778),
    [sym_override] = ACTIONS(6778),
    [sym_pure] = ACTIONS(6778),
    [sym_ref] = ACTIONS(6778),
    [sym_scope] = ACTIONS(6778),
    [sym_shared] = ACTIONS(6778),
    [sym_static] = ACTIONS(6778),
    [sym_synchronized] = ACTIONS(6778),
    [sym_typeof] = ACTIONS(6778),
    [sym_gshared] = ACTIONS(6778),
    [sym_traits] = ACTIONS(6778),
    [sym_vector] = ACTIONS(6778),
    [sym_void] = ACTIONS(6778),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2672] = {
    [sym_at_attribute] = STATE(2716),
    [sym__function_attribute_kwd] = STATE(2716),
    [sym__function_attribute] = STATE(2716),
    [sym_member_function_attribute] = STATE(2672),
    [aux_sym_alias_declaration_repeat2] = STATE(2672),
    [anon_sym_RBRACE] = ACTIONS(6782),
    [anon_sym_SLASH] = ACTIONS(6784),
    [anon_sym_SLASH_EQ] = ACTIONS(6782),
    [anon_sym_DOT] = ACTIONS(6782),
    [anon_sym_AMP] = ACTIONS(6784),
    [anon_sym_AMP_EQ] = ACTIONS(6782),
    [anon_sym_AMP_AMP] = ACTIONS(6782),
    [anon_sym_PIPE] = ACTIONS(6784),
    [anon_sym_PIPE_EQ] = ACTIONS(6782),
    [anon_sym_PIPE_PIPE] = ACTIONS(6782),
    [anon_sym_DASH] = ACTIONS(6784),
    [anon_sym_DASH_EQ] = ACTIONS(6782),
    [anon_sym_DASH_DASH] = ACTIONS(6782),
    [anon_sym_PLUS] = ACTIONS(6784),
    [anon_sym_PLUS_EQ] = ACTIONS(6782),
    [anon_sym_PLUS_PLUS] = ACTIONS(6782),
    [anon_sym_LT] = ACTIONS(6784),
    [anon_sym_LT_EQ] = ACTIONS(6782),
    [anon_sym_LT_LT] = ACTIONS(6784),
    [anon_sym_LT_LT_EQ] = ACTIONS(6782),
    [anon_sym_GT] = ACTIONS(6784),
    [anon_sym_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT] = ACTIONS(6784),
    [anon_sym_GT_GT_GT] = ACTIONS(6784),
    [anon_sym_BANG_EQ] = ACTIONS(6782),
    [anon_sym_LPAREN] = ACTIONS(6782),
    [anon_sym_RPAREN] = ACTIONS(6782),
    [anon_sym_LBRACK] = ACTIONS(6782),
    [anon_sym_RBRACK] = ACTIONS(6782),
    [anon_sym_QMARK] = ACTIONS(6782),
    [anon_sym_COMMA] = ACTIONS(6782),
    [anon_sym_SEMI] = ACTIONS(6782),
    [anon_sym_COLON] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(6784),
    [anon_sym_EQ_EQ] = ACTIONS(6782),
    [anon_sym_STAR] = ACTIONS(6784),
    [anon_sym_STAR_EQ] = ACTIONS(6782),
    [anon_sym_PERCENT] = ACTIONS(6784),
    [anon_sym_PERCENT_EQ] = ACTIONS(6782),
    [anon_sym_CARET] = ACTIONS(6784),
    [anon_sym_CARET_EQ] = ACTIONS(6782),
    [anon_sym_CARET_CARET] = ACTIONS(6784),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6782),
    [anon_sym_TILDE] = ACTIONS(6784),
    [anon_sym_TILDE_EQ] = ACTIONS(6782),
    [anon_sym_AT] = ACTIONS(6786),
    [sym_const] = ACTIONS(6789),
    [sym_delegate] = ACTIONS(6782),
    [sym_function] = ACTIONS(6782),
    [sym_immutable] = ACTIONS(6789),
    [sym_in] = ACTIONS(6784),
    [sym_inout] = ACTIONS(6789),
    [sym_is] = ACTIONS(6782),
    [sym_nothrow] = ACTIONS(6789),
    [sym_pure] = ACTIONS(6789),
    [sym_return] = ACTIONS(6789),
    [sym_scope] = ACTIONS(6789),
    [sym_shared] = ACTIONS(6789),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6782),
    [sym_not_is] = ACTIONS(6782),
  },
  [2673] = {
    [sym_at_attribute] = STATE(2716),
    [sym__function_attribute_kwd] = STATE(2716),
    [sym__function_attribute] = STATE(2716),
    [sym_member_function_attribute] = STATE(2670),
    [aux_sym_alias_declaration_repeat2] = STATE(2670),
    [anon_sym_RBRACE] = ACTIONS(6792),
    [anon_sym_SLASH] = ACTIONS(6794),
    [anon_sym_SLASH_EQ] = ACTIONS(6792),
    [anon_sym_DOT] = ACTIONS(6792),
    [anon_sym_AMP] = ACTIONS(6794),
    [anon_sym_AMP_EQ] = ACTIONS(6792),
    [anon_sym_AMP_AMP] = ACTIONS(6792),
    [anon_sym_PIPE] = ACTIONS(6794),
    [anon_sym_PIPE_EQ] = ACTIONS(6792),
    [anon_sym_PIPE_PIPE] = ACTIONS(6792),
    [anon_sym_DASH] = ACTIONS(6794),
    [anon_sym_DASH_EQ] = ACTIONS(6792),
    [anon_sym_DASH_DASH] = ACTIONS(6792),
    [anon_sym_PLUS] = ACTIONS(6794),
    [anon_sym_PLUS_EQ] = ACTIONS(6792),
    [anon_sym_PLUS_PLUS] = ACTIONS(6792),
    [anon_sym_LT] = ACTIONS(6794),
    [anon_sym_LT_EQ] = ACTIONS(6792),
    [anon_sym_LT_LT] = ACTIONS(6794),
    [anon_sym_LT_LT_EQ] = ACTIONS(6792),
    [anon_sym_GT] = ACTIONS(6794),
    [anon_sym_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_GT_GT_GT] = ACTIONS(6794),
    [anon_sym_BANG_EQ] = ACTIONS(6792),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [anon_sym_RPAREN] = ACTIONS(6792),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_RBRACK] = ACTIONS(6792),
    [anon_sym_QMARK] = ACTIONS(6792),
    [anon_sym_COMMA] = ACTIONS(6792),
    [anon_sym_SEMI] = ACTIONS(6792),
    [anon_sym_COLON] = ACTIONS(6792),
    [anon_sym_EQ] = ACTIONS(6794),
    [anon_sym_EQ_EQ] = ACTIONS(6792),
    [anon_sym_STAR] = ACTIONS(6794),
    [anon_sym_STAR_EQ] = ACTIONS(6792),
    [anon_sym_PERCENT] = ACTIONS(6794),
    [anon_sym_PERCENT_EQ] = ACTIONS(6792),
    [anon_sym_CARET] = ACTIONS(6794),
    [anon_sym_CARET_EQ] = ACTIONS(6792),
    [anon_sym_CARET_CARET] = ACTIONS(6794),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6792),
    [anon_sym_TILDE] = ACTIONS(6794),
    [anon_sym_TILDE_EQ] = ACTIONS(6792),
    [anon_sym_AT] = ACTIONS(6774),
    [sym_const] = ACTIONS(6776),
    [sym_delegate] = ACTIONS(6792),
    [sym_function] = ACTIONS(6792),
    [sym_immutable] = ACTIONS(6776),
    [sym_in] = ACTIONS(6794),
    [sym_inout] = ACTIONS(6776),
    [sym_is] = ACTIONS(6792),
    [sym_nothrow] = ACTIONS(6776),
    [sym_pure] = ACTIONS(6776),
    [sym_return] = ACTIONS(6776),
    [sym_scope] = ACTIONS(6776),
    [sym_shared] = ACTIONS(6776),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6792),
    [sym_not_is] = ACTIONS(6792),
  },
  [2674] = {
    [sym_type] = STATE(5611),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_mixin_expression] = STATE(4223),
    [sym_type_specialization] = STATE(5465),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_super] = ACTIONS(6796),
    [sym_class] = ACTIONS(6796),
    [sym_const] = ACTIONS(6798),
    [sym_delegate] = ACTIONS(6796),
    [sym_enum] = ACTIONS(6796),
    [sym_function] = ACTIONS(6796),
    [sym_immutable] = ACTIONS(6798),
    [sym_inout] = ACTIONS(6798),
    [sym_interface] = ACTIONS(6796),
    [sym_mixin] = ACTIONS(5912),
    [sym_module] = ACTIONS(6796),
    [sym_package] = ACTIONS(6796),
    [sym_return] = ACTIONS(6796),
    [sym_shared] = ACTIONS(6798),
    [sym_struct] = ACTIONS(6796),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(6796),
    [sym_parameters_] = ACTIONS(6796),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(6800),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2675] = {
    [sym_arguments] = STATE(2726),
    [sym_template_arguments] = STATE(2725),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_SLASH] = ACTIONS(5924),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5924),
    [anon_sym_AMP_EQ] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5924),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_DASH_EQ] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [anon_sym_PLUS_EQ] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_LT_LT_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5924),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_BANG] = ACTIONS(6802),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(6804),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_STAR_EQ] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_PERCENT_EQ] = ACTIONS(5926),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_CARET_EQ] = ACTIONS(5926),
    [anon_sym_CARET_CARET] = ACTIONS(5924),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_TILDE_EQ] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_const] = ACTIONS(5926),
    [sym_delegate] = ACTIONS(5926),
    [sym_function] = ACTIONS(5926),
    [sym_immutable] = ACTIONS(5926),
    [sym_in] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5926),
    [sym_is] = ACTIONS(5926),
    [sym_nothrow] = ACTIONS(5926),
    [sym_pure] = ACTIONS(5926),
    [sym_return] = ACTIONS(5926),
    [sym_scope] = ACTIONS(5926),
    [sym_shared] = ACTIONS(5926),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5926),
    [sym_not_is] = ACTIONS(5926),
  },
  [2676] = {
    [sym_identifier] = ACTIONS(6201),
    [anon_sym_LBRACE] = ACTIONS(6203),
    [anon_sym_DOT] = ACTIONS(6203),
    [anon_sym_LPAREN] = ACTIONS(6203),
    [anon_sym_COLON] = ACTIONS(6203),
    [anon_sym_AT] = ACTIONS(6203),
    [sym_bool] = ACTIONS(6201),
    [sym_byte] = ACTIONS(6201),
    [sym_ubyte] = ACTIONS(6201),
    [sym_char] = ACTIONS(6201),
    [sym_short] = ACTIONS(6201),
    [sym_ushort] = ACTIONS(6201),
    [sym_int] = ACTIONS(6201),
    [sym_uint] = ACTIONS(6201),
    [sym_long] = ACTIONS(6201),
    [sym_ulong] = ACTIONS(6201),
    [sym_cent] = ACTIONS(6201),
    [sym_ucent] = ACTIONS(6201),
    [sym_wchar] = ACTIONS(6201),
    [sym_dchar] = ACTIONS(6201),
    [sym_float] = ACTIONS(6201),
    [sym_double] = ACTIONS(6201),
    [sym_real] = ACTIONS(6201),
    [sym_ifloat] = ACTIONS(6201),
    [sym_idouble] = ACTIONS(6201),
    [sym_ireal] = ACTIONS(6201),
    [sym_cfloat] = ACTIONS(6201),
    [sym_cdouble] = ACTIONS(6201),
    [sym_creal] = ACTIONS(6201),
    [sym_size_t] = ACTIONS(6201),
    [sym_ptrdiff_t] = ACTIONS(6201),
    [sym_string] = ACTIONS(6201),
    [sym_cstring] = ACTIONS(6201),
    [sym_dstring] = ACTIONS(6201),
    [sym_wstring] = ACTIONS(6201),
    [sym_noreturn] = ACTIONS(6201),
    [sym_abstract] = ACTIONS(6201),
    [sym_align] = ACTIONS(6201),
    [sym_auto] = ACTIONS(6201),
    [sym_const] = ACTIONS(6201),
    [sym_delegate] = ACTIONS(6201),
    [sym_deprecated] = ACTIONS(6201),
    [sym_do] = ACTIONS(6201),
    [sym_enum] = ACTIONS(6201),
    [sym_extern] = ACTIONS(6201),
    [sym_final] = ACTIONS(6201),
    [sym_function] = ACTIONS(6201),
    [sym_immutable] = ACTIONS(6201),
    [sym_in] = ACTIONS(6201),
    [sym_inout] = ACTIONS(6201),
    [sym_mixin] = ACTIONS(6201),
    [sym_nothrow] = ACTIONS(6201),
    [sym_out] = ACTIONS(6201),
    [sym_override] = ACTIONS(6201),
    [sym_pure] = ACTIONS(6201),
    [sym_ref] = ACTIONS(6201),
    [sym_scope] = ACTIONS(6201),
    [sym_shared] = ACTIONS(6201),
    [sym_static] = ACTIONS(6201),
    [sym_synchronized] = ACTIONS(6201),
    [sym_typeof] = ACTIONS(6201),
    [sym_gshared] = ACTIONS(6201),
    [sym_traits] = ACTIONS(6201),
    [sym_vector] = ACTIONS(6201),
    [sym_void] = ACTIONS(6201),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2677] = {
    [sym_at_attribute] = STATE(2771),
    [sym__function_attribute_kwd] = STATE(2771),
    [sym__function_attribute] = STATE(2771),
    [sym_member_function_attribute] = STATE(2685),
    [aux_sym_alias_declaration_repeat2] = STATE(2685),
    [anon_sym_SLASH] = ACTIONS(6794),
    [anon_sym_SLASH_EQ] = ACTIONS(6792),
    [anon_sym_DOT] = ACTIONS(6794),
    [anon_sym_DOT_DOT] = ACTIONS(6792),
    [anon_sym_AMP] = ACTIONS(6794),
    [anon_sym_AMP_EQ] = ACTIONS(6792),
    [anon_sym_AMP_AMP] = ACTIONS(6792),
    [anon_sym_PIPE] = ACTIONS(6794),
    [anon_sym_PIPE_EQ] = ACTIONS(6792),
    [anon_sym_PIPE_PIPE] = ACTIONS(6792),
    [anon_sym_DASH] = ACTIONS(6794),
    [anon_sym_DASH_EQ] = ACTIONS(6792),
    [anon_sym_DASH_DASH] = ACTIONS(6792),
    [anon_sym_PLUS] = ACTIONS(6794),
    [anon_sym_PLUS_EQ] = ACTIONS(6792),
    [anon_sym_PLUS_PLUS] = ACTIONS(6792),
    [anon_sym_LT] = ACTIONS(6794),
    [anon_sym_LT_EQ] = ACTIONS(6792),
    [anon_sym_LT_LT] = ACTIONS(6794),
    [anon_sym_LT_LT_EQ] = ACTIONS(6792),
    [anon_sym_GT] = ACTIONS(6794),
    [anon_sym_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_GT_GT_GT] = ACTIONS(6794),
    [anon_sym_BANG_EQ] = ACTIONS(6792),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [anon_sym_RPAREN] = ACTIONS(6792),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_RBRACK] = ACTIONS(6792),
    [anon_sym_QMARK] = ACTIONS(6792),
    [anon_sym_COMMA] = ACTIONS(6792),
    [anon_sym_EQ] = ACTIONS(6794),
    [anon_sym_EQ_EQ] = ACTIONS(6792),
    [anon_sym_STAR] = ACTIONS(6794),
    [anon_sym_STAR_EQ] = ACTIONS(6792),
    [anon_sym_PERCENT] = ACTIONS(6794),
    [anon_sym_PERCENT_EQ] = ACTIONS(6792),
    [anon_sym_CARET] = ACTIONS(6794),
    [anon_sym_CARET_EQ] = ACTIONS(6792),
    [anon_sym_CARET_CARET] = ACTIONS(6794),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6792),
    [anon_sym_TILDE] = ACTIONS(6794),
    [anon_sym_TILDE_EQ] = ACTIONS(6792),
    [anon_sym_AT] = ACTIONS(6806),
    [sym_const] = ACTIONS(6808),
    [sym_delegate] = ACTIONS(6792),
    [sym_function] = ACTIONS(6792),
    [sym_immutable] = ACTIONS(6808),
    [sym_in] = ACTIONS(6794),
    [sym_inout] = ACTIONS(6808),
    [sym_is] = ACTIONS(6792),
    [sym_nothrow] = ACTIONS(6808),
    [sym_pure] = ACTIONS(6808),
    [sym_return] = ACTIONS(6808),
    [sym_scope] = ACTIONS(6808),
    [sym_shared] = ACTIONS(6808),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6792),
    [sym_not_is] = ACTIONS(6792),
  },
  [2678] = {
    [sym_at_attribute] = STATE(2771),
    [sym__function_attribute_kwd] = STATE(2771),
    [sym__function_attribute] = STATE(2771),
    [sym_member_function_attribute] = STATE(2678),
    [aux_sym_alias_declaration_repeat2] = STATE(2678),
    [anon_sym_SLASH] = ACTIONS(6784),
    [anon_sym_SLASH_EQ] = ACTIONS(6782),
    [anon_sym_DOT] = ACTIONS(6784),
    [anon_sym_DOT_DOT] = ACTIONS(6782),
    [anon_sym_AMP] = ACTIONS(6784),
    [anon_sym_AMP_EQ] = ACTIONS(6782),
    [anon_sym_AMP_AMP] = ACTIONS(6782),
    [anon_sym_PIPE] = ACTIONS(6784),
    [anon_sym_PIPE_EQ] = ACTIONS(6782),
    [anon_sym_PIPE_PIPE] = ACTIONS(6782),
    [anon_sym_DASH] = ACTIONS(6784),
    [anon_sym_DASH_EQ] = ACTIONS(6782),
    [anon_sym_DASH_DASH] = ACTIONS(6782),
    [anon_sym_PLUS] = ACTIONS(6784),
    [anon_sym_PLUS_EQ] = ACTIONS(6782),
    [anon_sym_PLUS_PLUS] = ACTIONS(6782),
    [anon_sym_LT] = ACTIONS(6784),
    [anon_sym_LT_EQ] = ACTIONS(6782),
    [anon_sym_LT_LT] = ACTIONS(6784),
    [anon_sym_LT_LT_EQ] = ACTIONS(6782),
    [anon_sym_GT] = ACTIONS(6784),
    [anon_sym_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT] = ACTIONS(6784),
    [anon_sym_GT_GT_GT] = ACTIONS(6784),
    [anon_sym_BANG_EQ] = ACTIONS(6782),
    [anon_sym_LPAREN] = ACTIONS(6782),
    [anon_sym_RPAREN] = ACTIONS(6782),
    [anon_sym_LBRACK] = ACTIONS(6782),
    [anon_sym_RBRACK] = ACTIONS(6782),
    [anon_sym_QMARK] = ACTIONS(6782),
    [anon_sym_COMMA] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(6784),
    [anon_sym_EQ_EQ] = ACTIONS(6782),
    [anon_sym_STAR] = ACTIONS(6784),
    [anon_sym_STAR_EQ] = ACTIONS(6782),
    [anon_sym_PERCENT] = ACTIONS(6784),
    [anon_sym_PERCENT_EQ] = ACTIONS(6782),
    [anon_sym_CARET] = ACTIONS(6784),
    [anon_sym_CARET_EQ] = ACTIONS(6782),
    [anon_sym_CARET_CARET] = ACTIONS(6784),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6782),
    [anon_sym_TILDE] = ACTIONS(6784),
    [anon_sym_TILDE_EQ] = ACTIONS(6782),
    [anon_sym_AT] = ACTIONS(6810),
    [sym_const] = ACTIONS(6813),
    [sym_delegate] = ACTIONS(6782),
    [sym_function] = ACTIONS(6782),
    [sym_immutable] = ACTIONS(6813),
    [sym_in] = ACTIONS(6784),
    [sym_inout] = ACTIONS(6813),
    [sym_is] = ACTIONS(6782),
    [sym_nothrow] = ACTIONS(6813),
    [sym_pure] = ACTIONS(6813),
    [sym_return] = ACTIONS(6813),
    [sym_scope] = ACTIONS(6813),
    [sym_shared] = ACTIONS(6813),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6782),
    [sym_not_is] = ACTIONS(6782),
  },
  [2679] = {
    [sym_identifier] = ACTIONS(6209),
    [anon_sym_LBRACE] = ACTIONS(6211),
    [anon_sym_DOT] = ACTIONS(6211),
    [anon_sym_LPAREN] = ACTIONS(6211),
    [anon_sym_COLON] = ACTIONS(6211),
    [anon_sym_AT] = ACTIONS(6211),
    [sym_bool] = ACTIONS(6209),
    [sym_byte] = ACTIONS(6209),
    [sym_ubyte] = ACTIONS(6209),
    [sym_char] = ACTIONS(6209),
    [sym_short] = ACTIONS(6209),
    [sym_ushort] = ACTIONS(6209),
    [sym_int] = ACTIONS(6209),
    [sym_uint] = ACTIONS(6209),
    [sym_long] = ACTIONS(6209),
    [sym_ulong] = ACTIONS(6209),
    [sym_cent] = ACTIONS(6209),
    [sym_ucent] = ACTIONS(6209),
    [sym_wchar] = ACTIONS(6209),
    [sym_dchar] = ACTIONS(6209),
    [sym_float] = ACTIONS(6209),
    [sym_double] = ACTIONS(6209),
    [sym_real] = ACTIONS(6209),
    [sym_ifloat] = ACTIONS(6209),
    [sym_idouble] = ACTIONS(6209),
    [sym_ireal] = ACTIONS(6209),
    [sym_cfloat] = ACTIONS(6209),
    [sym_cdouble] = ACTIONS(6209),
    [sym_creal] = ACTIONS(6209),
    [sym_size_t] = ACTIONS(6209),
    [sym_ptrdiff_t] = ACTIONS(6209),
    [sym_string] = ACTIONS(6209),
    [sym_cstring] = ACTIONS(6209),
    [sym_dstring] = ACTIONS(6209),
    [sym_wstring] = ACTIONS(6209),
    [sym_noreturn] = ACTIONS(6209),
    [sym_abstract] = ACTIONS(6209),
    [sym_align] = ACTIONS(6209),
    [sym_auto] = ACTIONS(6209),
    [sym_const] = ACTIONS(6209),
    [sym_delegate] = ACTIONS(6209),
    [sym_deprecated] = ACTIONS(6209),
    [sym_do] = ACTIONS(6209),
    [sym_enum] = ACTIONS(6209),
    [sym_extern] = ACTIONS(6209),
    [sym_final] = ACTIONS(6209),
    [sym_function] = ACTIONS(6209),
    [sym_immutable] = ACTIONS(6209),
    [sym_in] = ACTIONS(6209),
    [sym_inout] = ACTIONS(6209),
    [sym_mixin] = ACTIONS(6209),
    [sym_nothrow] = ACTIONS(6209),
    [sym_out] = ACTIONS(6209),
    [sym_override] = ACTIONS(6209),
    [sym_pure] = ACTIONS(6209),
    [sym_ref] = ACTIONS(6209),
    [sym_scope] = ACTIONS(6209),
    [sym_shared] = ACTIONS(6209),
    [sym_static] = ACTIONS(6209),
    [sym_synchronized] = ACTIONS(6209),
    [sym_typeof] = ACTIONS(6209),
    [sym_gshared] = ACTIONS(6209),
    [sym_traits] = ACTIONS(6209),
    [sym_vector] = ACTIONS(6209),
    [sym_void] = ACTIONS(6209),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2680] = {
    [sym_type] = STATE(5611),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_mixin_expression] = STATE(4223),
    [sym_type_specialization] = STATE(5408),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_super] = ACTIONS(6796),
    [sym_class] = ACTIONS(6796),
    [sym_const] = ACTIONS(6798),
    [sym_delegate] = ACTIONS(6796),
    [sym_enum] = ACTIONS(6796),
    [sym_function] = ACTIONS(6796),
    [sym_immutable] = ACTIONS(6798),
    [sym_inout] = ACTIONS(6798),
    [sym_interface] = ACTIONS(6796),
    [sym_mixin] = ACTIONS(5912),
    [sym_module] = ACTIONS(6796),
    [sym_package] = ACTIONS(6796),
    [sym_return] = ACTIONS(6796),
    [sym_shared] = ACTIONS(6798),
    [sym_struct] = ACTIONS(6796),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(6796),
    [sym_parameters_] = ACTIONS(6796),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(6800),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2681] = {
    [sym_identifier] = ACTIONS(6223),
    [anon_sym_LBRACE] = ACTIONS(6225),
    [anon_sym_DOT] = ACTIONS(6225),
    [anon_sym_LPAREN] = ACTIONS(6225),
    [anon_sym_COLON] = ACTIONS(6225),
    [anon_sym_AT] = ACTIONS(6225),
    [sym_bool] = ACTIONS(6223),
    [sym_byte] = ACTIONS(6223),
    [sym_ubyte] = ACTIONS(6223),
    [sym_char] = ACTIONS(6223),
    [sym_short] = ACTIONS(6223),
    [sym_ushort] = ACTIONS(6223),
    [sym_int] = ACTIONS(6223),
    [sym_uint] = ACTIONS(6223),
    [sym_long] = ACTIONS(6223),
    [sym_ulong] = ACTIONS(6223),
    [sym_cent] = ACTIONS(6223),
    [sym_ucent] = ACTIONS(6223),
    [sym_wchar] = ACTIONS(6223),
    [sym_dchar] = ACTIONS(6223),
    [sym_float] = ACTIONS(6223),
    [sym_double] = ACTIONS(6223),
    [sym_real] = ACTIONS(6223),
    [sym_ifloat] = ACTIONS(6223),
    [sym_idouble] = ACTIONS(6223),
    [sym_ireal] = ACTIONS(6223),
    [sym_cfloat] = ACTIONS(6223),
    [sym_cdouble] = ACTIONS(6223),
    [sym_creal] = ACTIONS(6223),
    [sym_size_t] = ACTIONS(6223),
    [sym_ptrdiff_t] = ACTIONS(6223),
    [sym_string] = ACTIONS(6223),
    [sym_cstring] = ACTIONS(6223),
    [sym_dstring] = ACTIONS(6223),
    [sym_wstring] = ACTIONS(6223),
    [sym_noreturn] = ACTIONS(6223),
    [sym_abstract] = ACTIONS(6223),
    [sym_align] = ACTIONS(6223),
    [sym_auto] = ACTIONS(6223),
    [sym_const] = ACTIONS(6223),
    [sym_delegate] = ACTIONS(6223),
    [sym_deprecated] = ACTIONS(6223),
    [sym_do] = ACTIONS(6223),
    [sym_enum] = ACTIONS(6223),
    [sym_extern] = ACTIONS(6223),
    [sym_final] = ACTIONS(6223),
    [sym_function] = ACTIONS(6223),
    [sym_immutable] = ACTIONS(6223),
    [sym_in] = ACTIONS(6223),
    [sym_inout] = ACTIONS(6223),
    [sym_mixin] = ACTIONS(6223),
    [sym_nothrow] = ACTIONS(6223),
    [sym_out] = ACTIONS(6223),
    [sym_override] = ACTIONS(6223),
    [sym_pure] = ACTIONS(6223),
    [sym_ref] = ACTIONS(6223),
    [sym_scope] = ACTIONS(6223),
    [sym_shared] = ACTIONS(6223),
    [sym_static] = ACTIONS(6223),
    [sym_synchronized] = ACTIONS(6223),
    [sym_typeof] = ACTIONS(6223),
    [sym_gshared] = ACTIONS(6223),
    [sym_traits] = ACTIONS(6223),
    [sym_vector] = ACTIONS(6223),
    [sym_void] = ACTIONS(6223),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2682] = {
    [sym_type] = STATE(5611),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_mixin_expression] = STATE(4223),
    [sym_type_specialization] = STATE(5272),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_super] = ACTIONS(6796),
    [sym_class] = ACTIONS(6796),
    [sym_const] = ACTIONS(6798),
    [sym_delegate] = ACTIONS(6796),
    [sym_enum] = ACTIONS(6796),
    [sym_function] = ACTIONS(6796),
    [sym_immutable] = ACTIONS(6798),
    [sym_inout] = ACTIONS(6798),
    [sym_interface] = ACTIONS(6796),
    [sym_mixin] = ACTIONS(5912),
    [sym_module] = ACTIONS(6796),
    [sym_package] = ACTIONS(6796),
    [sym_return] = ACTIONS(6796),
    [sym_shared] = ACTIONS(6798),
    [sym_struct] = ACTIONS(6796),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(6796),
    [sym_parameters_] = ACTIONS(6796),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(6800),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2683] = {
    [sym_identifier] = ACTIONS(6217),
    [anon_sym_LBRACE] = ACTIONS(6219),
    [anon_sym_DOT] = ACTIONS(6219),
    [anon_sym_LPAREN] = ACTIONS(6219),
    [anon_sym_COLON] = ACTIONS(6219),
    [anon_sym_AT] = ACTIONS(6219),
    [sym_bool] = ACTIONS(6217),
    [sym_byte] = ACTIONS(6217),
    [sym_ubyte] = ACTIONS(6217),
    [sym_char] = ACTIONS(6217),
    [sym_short] = ACTIONS(6217),
    [sym_ushort] = ACTIONS(6217),
    [sym_int] = ACTIONS(6217),
    [sym_uint] = ACTIONS(6217),
    [sym_long] = ACTIONS(6217),
    [sym_ulong] = ACTIONS(6217),
    [sym_cent] = ACTIONS(6217),
    [sym_ucent] = ACTIONS(6217),
    [sym_wchar] = ACTIONS(6217),
    [sym_dchar] = ACTIONS(6217),
    [sym_float] = ACTIONS(6217),
    [sym_double] = ACTIONS(6217),
    [sym_real] = ACTIONS(6217),
    [sym_ifloat] = ACTIONS(6217),
    [sym_idouble] = ACTIONS(6217),
    [sym_ireal] = ACTIONS(6217),
    [sym_cfloat] = ACTIONS(6217),
    [sym_cdouble] = ACTIONS(6217),
    [sym_creal] = ACTIONS(6217),
    [sym_size_t] = ACTIONS(6217),
    [sym_ptrdiff_t] = ACTIONS(6217),
    [sym_string] = ACTIONS(6217),
    [sym_cstring] = ACTIONS(6217),
    [sym_dstring] = ACTIONS(6217),
    [sym_wstring] = ACTIONS(6217),
    [sym_noreturn] = ACTIONS(6217),
    [sym_abstract] = ACTIONS(6217),
    [sym_align] = ACTIONS(6217),
    [sym_auto] = ACTIONS(6217),
    [sym_const] = ACTIONS(6217),
    [sym_delegate] = ACTIONS(6217),
    [sym_deprecated] = ACTIONS(6217),
    [sym_do] = ACTIONS(6217),
    [sym_enum] = ACTIONS(6217),
    [sym_extern] = ACTIONS(6217),
    [sym_final] = ACTIONS(6217),
    [sym_function] = ACTIONS(6217),
    [sym_immutable] = ACTIONS(6217),
    [sym_in] = ACTIONS(6217),
    [sym_inout] = ACTIONS(6217),
    [sym_mixin] = ACTIONS(6217),
    [sym_nothrow] = ACTIONS(6217),
    [sym_out] = ACTIONS(6217),
    [sym_override] = ACTIONS(6217),
    [sym_pure] = ACTIONS(6217),
    [sym_ref] = ACTIONS(6217),
    [sym_scope] = ACTIONS(6217),
    [sym_shared] = ACTIONS(6217),
    [sym_static] = ACTIONS(6217),
    [sym_synchronized] = ACTIONS(6217),
    [sym_typeof] = ACTIONS(6217),
    [sym_gshared] = ACTIONS(6217),
    [sym_traits] = ACTIONS(6217),
    [sym_vector] = ACTIONS(6217),
    [sym_void] = ACTIONS(6217),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2684] = {
    [sym_identifier] = ACTIONS(6229),
    [anon_sym_LBRACE] = ACTIONS(6231),
    [anon_sym_DOT] = ACTIONS(6231),
    [anon_sym_LPAREN] = ACTIONS(6231),
    [anon_sym_COLON] = ACTIONS(6231),
    [anon_sym_AT] = ACTIONS(6231),
    [sym_bool] = ACTIONS(6229),
    [sym_byte] = ACTIONS(6229),
    [sym_ubyte] = ACTIONS(6229),
    [sym_char] = ACTIONS(6229),
    [sym_short] = ACTIONS(6229),
    [sym_ushort] = ACTIONS(6229),
    [sym_int] = ACTIONS(6229),
    [sym_uint] = ACTIONS(6229),
    [sym_long] = ACTIONS(6229),
    [sym_ulong] = ACTIONS(6229),
    [sym_cent] = ACTIONS(6229),
    [sym_ucent] = ACTIONS(6229),
    [sym_wchar] = ACTIONS(6229),
    [sym_dchar] = ACTIONS(6229),
    [sym_float] = ACTIONS(6229),
    [sym_double] = ACTIONS(6229),
    [sym_real] = ACTIONS(6229),
    [sym_ifloat] = ACTIONS(6229),
    [sym_idouble] = ACTIONS(6229),
    [sym_ireal] = ACTIONS(6229),
    [sym_cfloat] = ACTIONS(6229),
    [sym_cdouble] = ACTIONS(6229),
    [sym_creal] = ACTIONS(6229),
    [sym_size_t] = ACTIONS(6229),
    [sym_ptrdiff_t] = ACTIONS(6229),
    [sym_string] = ACTIONS(6229),
    [sym_cstring] = ACTIONS(6229),
    [sym_dstring] = ACTIONS(6229),
    [sym_wstring] = ACTIONS(6229),
    [sym_noreturn] = ACTIONS(6229),
    [sym_abstract] = ACTIONS(6229),
    [sym_align] = ACTIONS(6229),
    [sym_auto] = ACTIONS(6229),
    [sym_const] = ACTIONS(6229),
    [sym_delegate] = ACTIONS(6229),
    [sym_deprecated] = ACTIONS(6229),
    [sym_do] = ACTIONS(6229),
    [sym_enum] = ACTIONS(6229),
    [sym_extern] = ACTIONS(6229),
    [sym_final] = ACTIONS(6229),
    [sym_function] = ACTIONS(6229),
    [sym_immutable] = ACTIONS(6229),
    [sym_in] = ACTIONS(6229),
    [sym_inout] = ACTIONS(6229),
    [sym_mixin] = ACTIONS(6229),
    [sym_nothrow] = ACTIONS(6229),
    [sym_out] = ACTIONS(6229),
    [sym_override] = ACTIONS(6229),
    [sym_pure] = ACTIONS(6229),
    [sym_ref] = ACTIONS(6229),
    [sym_scope] = ACTIONS(6229),
    [sym_shared] = ACTIONS(6229),
    [sym_static] = ACTIONS(6229),
    [sym_synchronized] = ACTIONS(6229),
    [sym_typeof] = ACTIONS(6229),
    [sym_gshared] = ACTIONS(6229),
    [sym_traits] = ACTIONS(6229),
    [sym_vector] = ACTIONS(6229),
    [sym_void] = ACTIONS(6229),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2685] = {
    [sym_at_attribute] = STATE(2771),
    [sym__function_attribute_kwd] = STATE(2771),
    [sym__function_attribute] = STATE(2771),
    [sym_member_function_attribute] = STATE(2678),
    [aux_sym_alias_declaration_repeat2] = STATE(2678),
    [anon_sym_SLASH] = ACTIONS(6772),
    [anon_sym_SLASH_EQ] = ACTIONS(6770),
    [anon_sym_DOT] = ACTIONS(6772),
    [anon_sym_DOT_DOT] = ACTIONS(6770),
    [anon_sym_AMP] = ACTIONS(6772),
    [anon_sym_AMP_EQ] = ACTIONS(6770),
    [anon_sym_AMP_AMP] = ACTIONS(6770),
    [anon_sym_PIPE] = ACTIONS(6772),
    [anon_sym_PIPE_EQ] = ACTIONS(6770),
    [anon_sym_PIPE_PIPE] = ACTIONS(6770),
    [anon_sym_DASH] = ACTIONS(6772),
    [anon_sym_DASH_EQ] = ACTIONS(6770),
    [anon_sym_DASH_DASH] = ACTIONS(6770),
    [anon_sym_PLUS] = ACTIONS(6772),
    [anon_sym_PLUS_EQ] = ACTIONS(6770),
    [anon_sym_PLUS_PLUS] = ACTIONS(6770),
    [anon_sym_LT] = ACTIONS(6772),
    [anon_sym_LT_EQ] = ACTIONS(6770),
    [anon_sym_LT_LT] = ACTIONS(6772),
    [anon_sym_LT_LT_EQ] = ACTIONS(6770),
    [anon_sym_GT] = ACTIONS(6772),
    [anon_sym_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT] = ACTIONS(6772),
    [anon_sym_GT_GT_GT] = ACTIONS(6772),
    [anon_sym_BANG_EQ] = ACTIONS(6770),
    [anon_sym_LPAREN] = ACTIONS(6770),
    [anon_sym_RPAREN] = ACTIONS(6770),
    [anon_sym_LBRACK] = ACTIONS(6770),
    [anon_sym_RBRACK] = ACTIONS(6770),
    [anon_sym_QMARK] = ACTIONS(6770),
    [anon_sym_COMMA] = ACTIONS(6770),
    [anon_sym_EQ] = ACTIONS(6772),
    [anon_sym_EQ_EQ] = ACTIONS(6770),
    [anon_sym_STAR] = ACTIONS(6772),
    [anon_sym_STAR_EQ] = ACTIONS(6770),
    [anon_sym_PERCENT] = ACTIONS(6772),
    [anon_sym_PERCENT_EQ] = ACTIONS(6770),
    [anon_sym_CARET] = ACTIONS(6772),
    [anon_sym_CARET_EQ] = ACTIONS(6770),
    [anon_sym_CARET_CARET] = ACTIONS(6772),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6770),
    [anon_sym_TILDE] = ACTIONS(6772),
    [anon_sym_TILDE_EQ] = ACTIONS(6770),
    [anon_sym_AT] = ACTIONS(6806),
    [sym_const] = ACTIONS(6808),
    [sym_delegate] = ACTIONS(6770),
    [sym_function] = ACTIONS(6770),
    [sym_immutable] = ACTIONS(6808),
    [sym_in] = ACTIONS(6772),
    [sym_inout] = ACTIONS(6808),
    [sym_is] = ACTIONS(6770),
    [sym_nothrow] = ACTIONS(6808),
    [sym_pure] = ACTIONS(6808),
    [sym_return] = ACTIONS(6808),
    [sym_scope] = ACTIONS(6808),
    [sym_shared] = ACTIONS(6808),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6770),
    [sym_not_is] = ACTIONS(6770),
  },
  [2686] = {
    [sym_identifier] = ACTIONS(6158),
    [anon_sym_LBRACE] = ACTIONS(6160),
    [anon_sym_DOT] = ACTIONS(6160),
    [anon_sym_LPAREN] = ACTIONS(6816),
    [anon_sym_COLON] = ACTIONS(6160),
    [anon_sym_AT] = ACTIONS(6160),
    [sym_bool] = ACTIONS(6158),
    [sym_byte] = ACTIONS(6158),
    [sym_ubyte] = ACTIONS(6158),
    [sym_char] = ACTIONS(6158),
    [sym_short] = ACTIONS(6158),
    [sym_ushort] = ACTIONS(6158),
    [sym_int] = ACTIONS(6158),
    [sym_uint] = ACTIONS(6158),
    [sym_long] = ACTIONS(6158),
    [sym_ulong] = ACTIONS(6158),
    [sym_cent] = ACTIONS(6158),
    [sym_ucent] = ACTIONS(6158),
    [sym_wchar] = ACTIONS(6158),
    [sym_dchar] = ACTIONS(6158),
    [sym_float] = ACTIONS(6158),
    [sym_double] = ACTIONS(6158),
    [sym_real] = ACTIONS(6158),
    [sym_ifloat] = ACTIONS(6158),
    [sym_idouble] = ACTIONS(6158),
    [sym_ireal] = ACTIONS(6158),
    [sym_cfloat] = ACTIONS(6158),
    [sym_cdouble] = ACTIONS(6158),
    [sym_creal] = ACTIONS(6158),
    [sym_size_t] = ACTIONS(6158),
    [sym_ptrdiff_t] = ACTIONS(6158),
    [sym_string] = ACTIONS(6158),
    [sym_cstring] = ACTIONS(6158),
    [sym_dstring] = ACTIONS(6158),
    [sym_wstring] = ACTIONS(6158),
    [sym_noreturn] = ACTIONS(6158),
    [sym_abstract] = ACTIONS(6158),
    [sym_align] = ACTIONS(6158),
    [sym_auto] = ACTIONS(6158),
    [sym_const] = ACTIONS(6158),
    [sym_delegate] = ACTIONS(6158),
    [sym_deprecated] = ACTIONS(6158),
    [sym_do] = ACTIONS(6158),
    [sym_enum] = ACTIONS(6158),
    [sym_extern] = ACTIONS(6158),
    [sym_final] = ACTIONS(6158),
    [sym_function] = ACTIONS(6158),
    [sym_immutable] = ACTIONS(6158),
    [sym_in] = ACTIONS(6158),
    [sym_inout] = ACTIONS(6158),
    [sym_mixin] = ACTIONS(6158),
    [sym_nothrow] = ACTIONS(6158),
    [sym_out] = ACTIONS(6158),
    [sym_override] = ACTIONS(6158),
    [sym_pure] = ACTIONS(6158),
    [sym_ref] = ACTIONS(6158),
    [sym_scope] = ACTIONS(6158),
    [sym_shared] = ACTIONS(6158),
    [sym_static] = ACTIONS(6158),
    [sym_synchronized] = ACTIONS(6158),
    [sym_typeof] = ACTIONS(6158),
    [sym_gshared] = ACTIONS(6158),
    [sym_traits] = ACTIONS(6158),
    [sym_vector] = ACTIONS(6158),
    [sym_void] = ACTIONS(6158),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2687] = {
    [sym__parameter_with_member_attributes] = STATE(4136),
    [sym__parameters] = STATE(3945),
    [sym_identifier] = ACTIONS(6778),
    [anon_sym_LBRACE] = ACTIONS(6780),
    [anon_sym_DOT] = ACTIONS(6780),
    [anon_sym_LPAREN] = ACTIONS(6818),
    [anon_sym_AT] = ACTIONS(6780),
    [sym_bool] = ACTIONS(6778),
    [sym_byte] = ACTIONS(6778),
    [sym_ubyte] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_short] = ACTIONS(6778),
    [sym_ushort] = ACTIONS(6778),
    [sym_int] = ACTIONS(6778),
    [sym_uint] = ACTIONS(6778),
    [sym_long] = ACTIONS(6778),
    [sym_ulong] = ACTIONS(6778),
    [sym_cent] = ACTIONS(6778),
    [sym_ucent] = ACTIONS(6778),
    [sym_wchar] = ACTIONS(6778),
    [sym_dchar] = ACTIONS(6778),
    [sym_float] = ACTIONS(6778),
    [sym_double] = ACTIONS(6778),
    [sym_real] = ACTIONS(6778),
    [sym_ifloat] = ACTIONS(6778),
    [sym_idouble] = ACTIONS(6778),
    [sym_ireal] = ACTIONS(6778),
    [sym_cfloat] = ACTIONS(6778),
    [sym_cdouble] = ACTIONS(6778),
    [sym_creal] = ACTIONS(6778),
    [sym_size_t] = ACTIONS(6778),
    [sym_ptrdiff_t] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym_cstring] = ACTIONS(6778),
    [sym_dstring] = ACTIONS(6778),
    [sym_wstring] = ACTIONS(6778),
    [sym_noreturn] = ACTIONS(6778),
    [sym_abstract] = ACTIONS(6778),
    [sym_align] = ACTIONS(6778),
    [sym_auto] = ACTIONS(6778),
    [sym_const] = ACTIONS(6778),
    [sym_delegate] = ACTIONS(6778),
    [sym_deprecated] = ACTIONS(6778),
    [sym_do] = ACTIONS(6778),
    [sym_extern] = ACTIONS(6778),
    [sym_final] = ACTIONS(6778),
    [sym_function] = ACTIONS(6778),
    [sym_immutable] = ACTIONS(6778),
    [sym_in] = ACTIONS(6778),
    [sym_inout] = ACTIONS(6778),
    [sym_mixin] = ACTIONS(6778),
    [sym_nothrow] = ACTIONS(6778),
    [sym_out] = ACTIONS(6778),
    [sym_override] = ACTIONS(6778),
    [sym_pure] = ACTIONS(6778),
    [sym_ref] = ACTIONS(6778),
    [sym_scope] = ACTIONS(6778),
    [sym_shared] = ACTIONS(6778),
    [sym_static] = ACTIONS(6778),
    [sym_synchronized] = ACTIONS(6778),
    [sym_typeof] = ACTIONS(6778),
    [sym_gshared] = ACTIONS(6778),
    [sym_traits] = ACTIONS(6778),
    [sym_vector] = ACTIONS(6778),
    [sym_void] = ACTIONS(6778),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2688] = {
    [sym_type] = STATE(5611),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_mixin_expression] = STATE(4223),
    [sym_type_specialization] = STATE(5601),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_super] = ACTIONS(6796),
    [sym_class] = ACTIONS(6796),
    [sym_const] = ACTIONS(6798),
    [sym_delegate] = ACTIONS(6796),
    [sym_enum] = ACTIONS(6796),
    [sym_function] = ACTIONS(6796),
    [sym_immutable] = ACTIONS(6798),
    [sym_inout] = ACTIONS(6798),
    [sym_interface] = ACTIONS(6796),
    [sym_mixin] = ACTIONS(5912),
    [sym_module] = ACTIONS(6796),
    [sym_package] = ACTIONS(6796),
    [sym_return] = ACTIONS(6796),
    [sym_shared] = ACTIONS(6798),
    [sym_struct] = ACTIONS(6796),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(6796),
    [sym_parameters_] = ACTIONS(6796),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(6800),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2689] = {
    [sym_identifier] = ACTIONS(6197),
    [anon_sym_LBRACE] = ACTIONS(6199),
    [anon_sym_DOT] = ACTIONS(6199),
    [anon_sym_LPAREN] = ACTIONS(6199),
    [anon_sym_COLON] = ACTIONS(6199),
    [anon_sym_AT] = ACTIONS(6199),
    [sym_bool] = ACTIONS(6197),
    [sym_byte] = ACTIONS(6197),
    [sym_ubyte] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_short] = ACTIONS(6197),
    [sym_ushort] = ACTIONS(6197),
    [sym_int] = ACTIONS(6197),
    [sym_uint] = ACTIONS(6197),
    [sym_long] = ACTIONS(6197),
    [sym_ulong] = ACTIONS(6197),
    [sym_cent] = ACTIONS(6197),
    [sym_ucent] = ACTIONS(6197),
    [sym_wchar] = ACTIONS(6197),
    [sym_dchar] = ACTIONS(6197),
    [sym_float] = ACTIONS(6197),
    [sym_double] = ACTIONS(6197),
    [sym_real] = ACTIONS(6197),
    [sym_ifloat] = ACTIONS(6197),
    [sym_idouble] = ACTIONS(6197),
    [sym_ireal] = ACTIONS(6197),
    [sym_cfloat] = ACTIONS(6197),
    [sym_cdouble] = ACTIONS(6197),
    [sym_creal] = ACTIONS(6197),
    [sym_size_t] = ACTIONS(6197),
    [sym_ptrdiff_t] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym_cstring] = ACTIONS(6197),
    [sym_dstring] = ACTIONS(6197),
    [sym_wstring] = ACTIONS(6197),
    [sym_noreturn] = ACTIONS(6197),
    [sym_abstract] = ACTIONS(6197),
    [sym_align] = ACTIONS(6197),
    [sym_auto] = ACTIONS(6197),
    [sym_const] = ACTIONS(6197),
    [sym_delegate] = ACTIONS(6197),
    [sym_deprecated] = ACTIONS(6197),
    [sym_do] = ACTIONS(6197),
    [sym_enum] = ACTIONS(6197),
    [sym_extern] = ACTIONS(6197),
    [sym_final] = ACTIONS(6197),
    [sym_function] = ACTIONS(6197),
    [sym_immutable] = ACTIONS(6197),
    [sym_in] = ACTIONS(6197),
    [sym_inout] = ACTIONS(6197),
    [sym_mixin] = ACTIONS(6197),
    [sym_nothrow] = ACTIONS(6197),
    [sym_out] = ACTIONS(6197),
    [sym_override] = ACTIONS(6197),
    [sym_pure] = ACTIONS(6197),
    [sym_ref] = ACTIONS(6197),
    [sym_scope] = ACTIONS(6197),
    [sym_shared] = ACTIONS(6197),
    [sym_static] = ACTIONS(6197),
    [sym_synchronized] = ACTIONS(6197),
    [sym_typeof] = ACTIONS(6197),
    [sym_gshared] = ACTIONS(6197),
    [sym_traits] = ACTIONS(6197),
    [sym_vector] = ACTIONS(6197),
    [sym_void] = ACTIONS(6197),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2690] = {
    [sym_type] = STATE(5611),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_mixin_expression] = STATE(4223),
    [sym_type_specialization] = STATE(5289),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_super] = ACTIONS(6796),
    [sym_class] = ACTIONS(6796),
    [sym_const] = ACTIONS(6798),
    [sym_delegate] = ACTIONS(6796),
    [sym_enum] = ACTIONS(6796),
    [sym_function] = ACTIONS(6796),
    [sym_immutable] = ACTIONS(6798),
    [sym_inout] = ACTIONS(6798),
    [sym_interface] = ACTIONS(6796),
    [sym_mixin] = ACTIONS(5912),
    [sym_module] = ACTIONS(6796),
    [sym_package] = ACTIONS(6796),
    [sym_return] = ACTIONS(6796),
    [sym_shared] = ACTIONS(6798),
    [sym_struct] = ACTIONS(6796),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(6796),
    [sym_parameters_] = ACTIONS(6796),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(6800),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2691] = {
    [sym_type] = STATE(4539),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter] = STATE(5384),
    [sym_parameter_attribute] = STATE(2697),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2697),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(2125),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3202),
    [sym_scope] = ACTIONS(3202),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2692] = {
    [sym_type] = STATE(5611),
    [sym_type_ctor] = STATE(3651),
    [sym__type2] = STATE(4223),
    [sym_vector_type] = STATE(4223),
    [sym__builtin_type] = STATE(4223),
    [sym__qualified_id] = STATE(4223),
    [sym_typeof_expression] = STATE(4242),
    [sym_mixin_expression] = STATE(4223),
    [sym_type_specialization] = STATE(5398),
    [sym_template_instance] = STATE(4235),
    [sym_traits_expression] = STATE(4223),
    [aux_sym_type_repeat1] = STATE(3238),
    [sym_identifier] = ACTIONS(6443),
    [anon_sym_DOT] = ACTIONS(13),
    [sym_bool] = ACTIONS(21),
    [sym_byte] = ACTIONS(21),
    [sym_ubyte] = ACTIONS(21),
    [sym_char] = ACTIONS(21),
    [sym_short] = ACTIONS(21),
    [sym_ushort] = ACTIONS(21),
    [sym_int] = ACTIONS(21),
    [sym_uint] = ACTIONS(21),
    [sym_long] = ACTIONS(21),
    [sym_ulong] = ACTIONS(21),
    [sym_cent] = ACTIONS(21),
    [sym_ucent] = ACTIONS(21),
    [sym_wchar] = ACTIONS(21),
    [sym_dchar] = ACTIONS(21),
    [sym_float] = ACTIONS(21),
    [sym_double] = ACTIONS(21),
    [sym_real] = ACTIONS(21),
    [sym_ifloat] = ACTIONS(21),
    [sym_idouble] = ACTIONS(21),
    [sym_ireal] = ACTIONS(21),
    [sym_cfloat] = ACTIONS(21),
    [sym_cdouble] = ACTIONS(21),
    [sym_creal] = ACTIONS(21),
    [sym_size_t] = ACTIONS(21),
    [sym_ptrdiff_t] = ACTIONS(21),
    [sym_string] = ACTIONS(21),
    [sym_cstring] = ACTIONS(21),
    [sym_dstring] = ACTIONS(21),
    [sym_wstring] = ACTIONS(21),
    [sym_noreturn] = ACTIONS(21),
    [sym_super] = ACTIONS(6796),
    [sym_class] = ACTIONS(6796),
    [sym_const] = ACTIONS(6798),
    [sym_delegate] = ACTIONS(6796),
    [sym_enum] = ACTIONS(6796),
    [sym_function] = ACTIONS(6796),
    [sym_immutable] = ACTIONS(6798),
    [sym_inout] = ACTIONS(6798),
    [sym_interface] = ACTIONS(6796),
    [sym_mixin] = ACTIONS(5912),
    [sym_module] = ACTIONS(6796),
    [sym_package] = ACTIONS(6796),
    [sym_return] = ACTIONS(6796),
    [sym_shared] = ACTIONS(6798),
    [sym_struct] = ACTIONS(6796),
    [sym_typeof] = ACTIONS(67),
    [sym_union] = ACTIONS(6796),
    [sym_parameters_] = ACTIONS(6796),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(6800),
    [sym_void] = ACTIONS(21),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2693] = {
    [sym_type] = STATE(4520),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2701),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2701),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(2125),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3202),
    [sym_scope] = ACTIONS(3202),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2694] = {
    [sym_type] = STATE(4457),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2967),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2967),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(2125),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3202),
    [sym_scope] = ACTIONS(3202),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2695] = {
    [sym_at_attribute] = STATE(2826),
    [sym__function_attribute_kwd] = STATE(2826),
    [sym__function_attribute] = STATE(2826),
    [sym_member_function_attribute] = STATE(2699),
    [aux_sym_alias_declaration_repeat2] = STATE(2699),
    [anon_sym_SLASH] = ACTIONS(6794),
    [anon_sym_SLASH_EQ] = ACTIONS(6792),
    [anon_sym_DOT] = ACTIONS(6794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6792),
    [anon_sym_AMP] = ACTIONS(6794),
    [anon_sym_AMP_EQ] = ACTIONS(6792),
    [anon_sym_AMP_AMP] = ACTIONS(6792),
    [anon_sym_PIPE] = ACTIONS(6794),
    [anon_sym_PIPE_EQ] = ACTIONS(6792),
    [anon_sym_PIPE_PIPE] = ACTIONS(6792),
    [anon_sym_DASH] = ACTIONS(6794),
    [anon_sym_DASH_EQ] = ACTIONS(6792),
    [anon_sym_DASH_DASH] = ACTIONS(6792),
    [anon_sym_PLUS] = ACTIONS(6794),
    [anon_sym_PLUS_EQ] = ACTIONS(6792),
    [anon_sym_PLUS_PLUS] = ACTIONS(6792),
    [anon_sym_LT] = ACTIONS(6794),
    [anon_sym_LT_EQ] = ACTIONS(6792),
    [anon_sym_LT_LT] = ACTIONS(6794),
    [anon_sym_LT_LT_EQ] = ACTIONS(6792),
    [anon_sym_GT] = ACTIONS(6794),
    [anon_sym_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6792),
    [anon_sym_GT_GT] = ACTIONS(6794),
    [anon_sym_GT_GT_GT] = ACTIONS(6794),
    [anon_sym_BANG_EQ] = ACTIONS(6792),
    [anon_sym_LPAREN] = ACTIONS(6792),
    [anon_sym_RPAREN] = ACTIONS(6792),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_QMARK] = ACTIONS(6792),
    [anon_sym_COMMA] = ACTIONS(6792),
    [anon_sym_EQ] = ACTIONS(6794),
    [anon_sym_EQ_EQ] = ACTIONS(6792),
    [anon_sym_STAR] = ACTIONS(6794),
    [anon_sym_STAR_EQ] = ACTIONS(6792),
    [anon_sym_PERCENT] = ACTIONS(6794),
    [anon_sym_PERCENT_EQ] = ACTIONS(6792),
    [anon_sym_CARET] = ACTIONS(6794),
    [anon_sym_CARET_EQ] = ACTIONS(6792),
    [anon_sym_CARET_CARET] = ACTIONS(6794),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6792),
    [anon_sym_TILDE] = ACTIONS(6794),
    [anon_sym_TILDE_EQ] = ACTIONS(6792),
    [anon_sym_AT] = ACTIONS(6823),
    [sym_const] = ACTIONS(6825),
    [sym_delegate] = ACTIONS(6792),
    [sym_function] = ACTIONS(6792),
    [sym_immutable] = ACTIONS(6825),
    [sym_in] = ACTIONS(6794),
    [sym_inout] = ACTIONS(6825),
    [sym_is] = ACTIONS(6792),
    [sym_nothrow] = ACTIONS(6825),
    [sym_pure] = ACTIONS(6825),
    [sym_return] = ACTIONS(6825),
    [sym_scope] = ACTIONS(6825),
    [sym_shared] = ACTIONS(6825),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6792),
    [sym_not_is] = ACTIONS(6792),
  },
  [2696] = {
    [sym_identifier] = ACTIONS(6778),
    [anon_sym_LBRACE] = ACTIONS(6780),
    [anon_sym_DOT] = ACTIONS(6780),
    [anon_sym_LPAREN] = ACTIONS(6780),
    [anon_sym_AT] = ACTIONS(6780),
    [sym_bool] = ACTIONS(6778),
    [sym_byte] = ACTIONS(6778),
    [sym_ubyte] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_short] = ACTIONS(6778),
    [sym_ushort] = ACTIONS(6778),
    [sym_int] = ACTIONS(6778),
    [sym_uint] = ACTIONS(6778),
    [sym_long] = ACTIONS(6778),
    [sym_ulong] = ACTIONS(6778),
    [sym_cent] = ACTIONS(6778),
    [sym_ucent] = ACTIONS(6778),
    [sym_wchar] = ACTIONS(6778),
    [sym_dchar] = ACTIONS(6778),
    [sym_float] = ACTIONS(6778),
    [sym_double] = ACTIONS(6778),
    [sym_real] = ACTIONS(6778),
    [sym_ifloat] = ACTIONS(6778),
    [sym_idouble] = ACTIONS(6778),
    [sym_ireal] = ACTIONS(6778),
    [sym_cfloat] = ACTIONS(6778),
    [sym_cdouble] = ACTIONS(6778),
    [sym_creal] = ACTIONS(6778),
    [sym_size_t] = ACTIONS(6778),
    [sym_ptrdiff_t] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym_cstring] = ACTIONS(6778),
    [sym_dstring] = ACTIONS(6778),
    [sym_wstring] = ACTIONS(6778),
    [sym_noreturn] = ACTIONS(6778),
    [sym_abstract] = ACTIONS(6778),
    [sym_align] = ACTIONS(6778),
    [sym_auto] = ACTIONS(6778),
    [sym_const] = ACTIONS(6778),
    [sym_delegate] = ACTIONS(6778),
    [sym_deprecated] = ACTIONS(6778),
    [sym_do] = ACTIONS(6778),
    [sym_enum] = ACTIONS(6778),
    [sym_extern] = ACTIONS(6778),
    [sym_final] = ACTIONS(6778),
    [sym_function] = ACTIONS(6778),
    [sym_immutable] = ACTIONS(6778),
    [sym_in] = ACTIONS(6778),
    [sym_inout] = ACTIONS(6778),
    [sym_mixin] = ACTIONS(6778),
    [sym_nothrow] = ACTIONS(6778),
    [sym_out] = ACTIONS(6778),
    [sym_override] = ACTIONS(6778),
    [sym_pure] = ACTIONS(6778),
    [sym_ref] = ACTIONS(6778),
    [sym_scope] = ACTIONS(6778),
    [sym_shared] = ACTIONS(6778),
    [sym_static] = ACTIONS(6778),
    [sym_synchronized] = ACTIONS(6778),
    [sym_typeof] = ACTIONS(6778),
    [sym_gshared] = ACTIONS(6778),
    [sym_traits] = ACTIONS(6778),
    [sym_vector] = ACTIONS(6778),
    [sym_void] = ACTIONS(6778),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2697] = {
    [sym_type] = STATE(4564),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2967),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2967),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(2125),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3202),
    [sym_scope] = ACTIONS(3202),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2698] = {
    [sym_storage_class] = STATE(2698),
    [sym_type_ctor] = STATE(2696),
    [sym_align_attribute] = STATE(2696),
    [sym_at_attribute] = STATE(2696),
    [sym__function_attribute_kwd] = STATE(2696),
    [sym_linkage_attribute] = STATE(2696),
    [aux_sym_variable_declaration_repeat1] = STATE(2698),
    [sym_identifier] = ACTIONS(6687),
    [anon_sym_DOT] = ACTIONS(6689),
    [anon_sym_AT] = ACTIONS(6691),
    [sym_bool] = ACTIONS(6687),
    [sym_byte] = ACTIONS(6687),
    [sym_ubyte] = ACTIONS(6687),
    [sym_char] = ACTIONS(6687),
    [sym_short] = ACTIONS(6687),
    [sym_ushort] = ACTIONS(6687),
    [sym_int] = ACTIONS(6687),
    [sym_uint] = ACTIONS(6687),
    [sym_long] = ACTIONS(6687),
    [sym_ulong] = ACTIONS(6687),
    [sym_cent] = ACTIONS(6687),
    [sym_ucent] = ACTIONS(6687),
    [sym_wchar] = ACTIONS(6687),
    [sym_dchar] = ACTIONS(6687),
    [sym_float] = ACTIONS(6687),
    [sym_double] = ACTIONS(6687),
    [sym_real] = ACTIONS(6687),
    [sym_ifloat] = ACTIONS(6687),
    [sym_idouble] = ACTIONS(6687),
    [sym_ireal] = ACTIONS(6687),
    [sym_cfloat] = ACTIONS(6687),
    [sym_cdouble] = ACTIONS(6687),
    [sym_creal] = ACTIONS(6687),
    [sym_size_t] = ACTIONS(6687),
    [sym_ptrdiff_t] = ACTIONS(6687),
    [sym_string] = ACTIONS(6687),
    [sym_cstring] = ACTIONS(6687),
    [sym_dstring] = ACTIONS(6687),
    [sym_wstring] = ACTIONS(6687),
    [sym_noreturn] = ACTIONS(6687),
    [sym_abstract] = ACTIONS(6694),
    [sym_align] = ACTIONS(6697),
    [sym_auto] = ACTIONS(6694),
    [sym_const] = ACTIONS(6700),
    [sym_deprecated] = ACTIONS(6694),
    [sym_enum] = ACTIONS(6687),
    [sym_extern] = ACTIONS(6827),
    [sym_final] = ACTIONS(6694),
    [sym_immutable] = ACTIONS(6700),
    [sym_inout] = ACTIONS(6700),
    [sym_mixin] = ACTIONS(6687),
    [sym_nothrow] = ACTIONS(6694),
    [sym_override] = ACTIONS(6694),
    [sym_pure] = ACTIONS(6694),
    [sym_ref] = ACTIONS(6694),
    [sym_scope] = ACTIONS(6694),
    [sym_shared] = ACTIONS(6700),
    [sym_static] = ACTIONS(6694),
    [sym_synchronized] = ACTIONS(6694),
    [sym_typeof] = ACTIONS(6687),
    [sym_gshared] = ACTIONS(6694),
    [sym_traits] = ACTIONS(6687),
    [sym_vector] = ACTIONS(6687),
    [sym_void] = ACTIONS(6687),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2699] = {
    [sym_at_attribute] = STATE(2826),
    [sym__function_attribute_kwd] = STATE(2826),
    [sym__function_attribute] = STATE(2826),
    [sym_member_function_attribute] = STATE(2700),
    [aux_sym_alias_declaration_repeat2] = STATE(2700),
    [anon_sym_SLASH] = ACTIONS(6772),
    [anon_sym_SLASH_EQ] = ACTIONS(6770),
    [anon_sym_DOT] = ACTIONS(6772),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6770),
    [anon_sym_AMP] = ACTIONS(6772),
    [anon_sym_AMP_EQ] = ACTIONS(6770),
    [anon_sym_AMP_AMP] = ACTIONS(6770),
    [anon_sym_PIPE] = ACTIONS(6772),
    [anon_sym_PIPE_EQ] = ACTIONS(6770),
    [anon_sym_PIPE_PIPE] = ACTIONS(6770),
    [anon_sym_DASH] = ACTIONS(6772),
    [anon_sym_DASH_EQ] = ACTIONS(6770),
    [anon_sym_DASH_DASH] = ACTIONS(6770),
    [anon_sym_PLUS] = ACTIONS(6772),
    [anon_sym_PLUS_EQ] = ACTIONS(6770),
    [anon_sym_PLUS_PLUS] = ACTIONS(6770),
    [anon_sym_LT] = ACTIONS(6772),
    [anon_sym_LT_EQ] = ACTIONS(6770),
    [anon_sym_LT_LT] = ACTIONS(6772),
    [anon_sym_LT_LT_EQ] = ACTIONS(6770),
    [anon_sym_GT] = ACTIONS(6772),
    [anon_sym_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6770),
    [anon_sym_GT_GT] = ACTIONS(6772),
    [anon_sym_GT_GT_GT] = ACTIONS(6772),
    [anon_sym_BANG_EQ] = ACTIONS(6770),
    [anon_sym_LPAREN] = ACTIONS(6770),
    [anon_sym_RPAREN] = ACTIONS(6770),
    [anon_sym_LBRACK] = ACTIONS(6770),
    [anon_sym_QMARK] = ACTIONS(6770),
    [anon_sym_COMMA] = ACTIONS(6770),
    [anon_sym_EQ] = ACTIONS(6772),
    [anon_sym_EQ_EQ] = ACTIONS(6770),
    [anon_sym_STAR] = ACTIONS(6772),
    [anon_sym_STAR_EQ] = ACTIONS(6770),
    [anon_sym_PERCENT] = ACTIONS(6772),
    [anon_sym_PERCENT_EQ] = ACTIONS(6770),
    [anon_sym_CARET] = ACTIONS(6772),
    [anon_sym_CARET_EQ] = ACTIONS(6770),
    [anon_sym_CARET_CARET] = ACTIONS(6772),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6770),
    [anon_sym_TILDE] = ACTIONS(6772),
    [anon_sym_TILDE_EQ] = ACTIONS(6770),
    [anon_sym_AT] = ACTIONS(6823),
    [sym_const] = ACTIONS(6825),
    [sym_delegate] = ACTIONS(6770),
    [sym_function] = ACTIONS(6770),
    [sym_immutable] = ACTIONS(6825),
    [sym_in] = ACTIONS(6772),
    [sym_inout] = ACTIONS(6825),
    [sym_is] = ACTIONS(6770),
    [sym_nothrow] = ACTIONS(6825),
    [sym_pure] = ACTIONS(6825),
    [sym_return] = ACTIONS(6825),
    [sym_scope] = ACTIONS(6825),
    [sym_shared] = ACTIONS(6825),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6770),
    [sym_not_is] = ACTIONS(6770),
  },
  [2700] = {
    [sym_at_attribute] = STATE(2826),
    [sym__function_attribute_kwd] = STATE(2826),
    [sym__function_attribute] = STATE(2826),
    [sym_member_function_attribute] = STATE(2700),
    [aux_sym_alias_declaration_repeat2] = STATE(2700),
    [anon_sym_SLASH] = ACTIONS(6784),
    [anon_sym_SLASH_EQ] = ACTIONS(6782),
    [anon_sym_DOT] = ACTIONS(6784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6782),
    [anon_sym_AMP] = ACTIONS(6784),
    [anon_sym_AMP_EQ] = ACTIONS(6782),
    [anon_sym_AMP_AMP] = ACTIONS(6782),
    [anon_sym_PIPE] = ACTIONS(6784),
    [anon_sym_PIPE_EQ] = ACTIONS(6782),
    [anon_sym_PIPE_PIPE] = ACTIONS(6782),
    [anon_sym_DASH] = ACTIONS(6784),
    [anon_sym_DASH_EQ] = ACTIONS(6782),
    [anon_sym_DASH_DASH] = ACTIONS(6782),
    [anon_sym_PLUS] = ACTIONS(6784),
    [anon_sym_PLUS_EQ] = ACTIONS(6782),
    [anon_sym_PLUS_PLUS] = ACTIONS(6782),
    [anon_sym_LT] = ACTIONS(6784),
    [anon_sym_LT_EQ] = ACTIONS(6782),
    [anon_sym_LT_LT] = ACTIONS(6784),
    [anon_sym_LT_LT_EQ] = ACTIONS(6782),
    [anon_sym_GT] = ACTIONS(6784),
    [anon_sym_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6782),
    [anon_sym_GT_GT] = ACTIONS(6784),
    [anon_sym_GT_GT_GT] = ACTIONS(6784),
    [anon_sym_BANG_EQ] = ACTIONS(6782),
    [anon_sym_LPAREN] = ACTIONS(6782),
    [anon_sym_RPAREN] = ACTIONS(6782),
    [anon_sym_LBRACK] = ACTIONS(6782),
    [anon_sym_QMARK] = ACTIONS(6782),
    [anon_sym_COMMA] = ACTIONS(6782),
    [anon_sym_EQ] = ACTIONS(6784),
    [anon_sym_EQ_EQ] = ACTIONS(6782),
    [anon_sym_STAR] = ACTIONS(6784),
    [anon_sym_STAR_EQ] = ACTIONS(6782),
    [anon_sym_PERCENT] = ACTIONS(6784),
    [anon_sym_PERCENT_EQ] = ACTIONS(6782),
    [anon_sym_CARET] = ACTIONS(6784),
    [anon_sym_CARET_EQ] = ACTIONS(6782),
    [anon_sym_CARET_CARET] = ACTIONS(6784),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6782),
    [anon_sym_TILDE] = ACTIONS(6784),
    [anon_sym_TILDE_EQ] = ACTIONS(6782),
    [anon_sym_AT] = ACTIONS(6830),
    [sym_const] = ACTIONS(6833),
    [sym_delegate] = ACTIONS(6782),
    [sym_function] = ACTIONS(6782),
    [sym_immutable] = ACTIONS(6833),
    [sym_in] = ACTIONS(6784),
    [sym_inout] = ACTIONS(6833),
    [sym_is] = ACTIONS(6782),
    [sym_nothrow] = ACTIONS(6833),
    [sym_pure] = ACTIONS(6833),
    [sym_return] = ACTIONS(6833),
    [sym_scope] = ACTIONS(6833),
    [sym_shared] = ACTIONS(6833),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6782),
    [sym_not_is] = ACTIONS(6782),
  },
  [2701] = {
    [sym_type] = STATE(4492),
    [sym_type_ctor] = STATE(3206),
    [sym__type2] = STATE(4264),
    [sym_vector_type] = STATE(4264),
    [sym__builtin_type] = STATE(4264),
    [sym__qualified_id] = STATE(4264),
    [sym_typeof_expression] = STATE(4282),
    [sym_at_attribute] = STATE(3306),
    [sym_mixin_expression] = STATE(4264),
    [sym_parameter_attribute] = STATE(2967),
    [sym_template_instance] = STATE(4275),
    [sym_traits_expression] = STATE(4264),
    [aux_sym_type_repeat1] = STATE(3231),
    [aux_sym__parameter_repeat1] = STATE(2967),
    [sym_identifier] = ACTIONS(6679),
    [anon_sym_DOT] = ACTIONS(6821),
    [anon_sym_AT] = ACTIONS(2117),
    [sym_bool] = ACTIONS(6331),
    [sym_byte] = ACTIONS(6331),
    [sym_ubyte] = ACTIONS(6331),
    [sym_char] = ACTIONS(6331),
    [sym_short] = ACTIONS(6331),
    [sym_ushort] = ACTIONS(6331),
    [sym_int] = ACTIONS(6331),
    [sym_uint] = ACTIONS(6331),
    [sym_long] = ACTIONS(6331),
    [sym_ulong] = ACTIONS(6331),
    [sym_cent] = ACTIONS(6331),
    [sym_ucent] = ACTIONS(6331),
    [sym_wchar] = ACTIONS(6331),
    [sym_dchar] = ACTIONS(6331),
    [sym_float] = ACTIONS(6331),
    [sym_double] = ACTIONS(6331),
    [sym_real] = ACTIONS(6331),
    [sym_ifloat] = ACTIONS(6331),
    [sym_idouble] = ACTIONS(6331),
    [sym_ireal] = ACTIONS(6331),
    [sym_cfloat] = ACTIONS(6331),
    [sym_cdouble] = ACTIONS(6331),
    [sym_creal] = ACTIONS(6331),
    [sym_size_t] = ACTIONS(6331),
    [sym_ptrdiff_t] = ACTIONS(6331),
    [sym_string] = ACTIONS(6331),
    [sym_cstring] = ACTIONS(6331),
    [sym_dstring] = ACTIONS(6331),
    [sym_wstring] = ACTIONS(6331),
    [sym_noreturn] = ACTIONS(6331),
    [sym_auto] = ACTIONS(3202),
    [sym_const] = ACTIONS(2125),
    [sym_final] = ACTIONS(3202),
    [sym_immutable] = ACTIONS(2125),
    [sym_in] = ACTIONS(3202),
    [sym_inout] = ACTIONS(2125),
    [sym_lazy] = ACTIONS(3202),
    [sym_mixin] = ACTIONS(5912),
    [sym_out] = ACTIONS(3202),
    [sym_ref] = ACTIONS(3202),
    [sym_return] = ACTIONS(3202),
    [sym_scope] = ACTIONS(3202),
    [sym_shared] = ACTIONS(2125),
    [sym_typeof] = ACTIONS(6337),
    [sym_traits] = ACTIONS(75),
    [sym_vector] = ACTIONS(3218),
    [sym_void] = ACTIONS(6331),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2702] = {
    [sym_identifier] = ACTIONS(6778),
    [anon_sym_LBRACE] = ACTIONS(6780),
    [anon_sym_DOT] = ACTIONS(6780),
    [anon_sym_LPAREN] = ACTIONS(6836),
    [anon_sym_AT] = ACTIONS(6780),
    [sym_bool] = ACTIONS(6778),
    [sym_byte] = ACTIONS(6778),
    [sym_ubyte] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_short] = ACTIONS(6778),
    [sym_ushort] = ACTIONS(6778),
    [sym_int] = ACTIONS(6778),
    [sym_uint] = ACTIONS(6778),
    [sym_long] = ACTIONS(6778),
    [sym_ulong] = ACTIONS(6778),
    [sym_cent] = ACTIONS(6778),
    [sym_ucent] = ACTIONS(6778),
    [sym_wchar] = ACTIONS(6778),
    [sym_dchar] = ACTIONS(6778),
    [sym_float] = ACTIONS(6778),
    [sym_double] = ACTIONS(6778),
    [sym_real] = ACTIONS(6778),
    [sym_ifloat] = ACTIONS(6778),
    [sym_idouble] = ACTIONS(6778),
    [sym_ireal] = ACTIONS(6778),
    [sym_cfloat] = ACTIONS(6778),
    [sym_cdouble] = ACTIONS(6778),
    [sym_creal] = ACTIONS(6778),
    [sym_size_t] = ACTIONS(6778),
    [sym_ptrdiff_t] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym_cstring] = ACTIONS(6778),
    [sym_dstring] = ACTIONS(6778),
    [sym_wstring] = ACTIONS(6778),
    [sym_noreturn] = ACTIONS(6778),
    [sym_abstract] = ACTIONS(6778),
    [sym_align] = ACTIONS(6778),
    [sym_auto] = ACTIONS(6778),
    [sym_const] = ACTIONS(6778),
    [sym_delegate] = ACTIONS(6778),
    [sym_deprecated] = ACTIONS(6778),
    [sym_do] = ACTIONS(6778),
    [sym_extern] = ACTIONS(6778),
    [sym_final] = ACTIONS(6778),
    [sym_function] = ACTIONS(6778),
    [sym_immutable] = ACTIONS(6778),
    [sym_in] = ACTIONS(6778),
    [sym_inout] = ACTIONS(6778),
    [sym_mixin] = ACTIONS(6778),
    [sym_nothrow] = ACTIONS(6778),
    [sym_out] = ACTIONS(6778),
    [sym_override] = ACTIONS(6778),
    [sym_pure] = ACTIONS(6778),
    [sym_ref] = ACTIONS(6778),
    [sym_scope] = ACTIONS(6778),
    [sym_shared] = ACTIONS(6778),
    [sym_static] = ACTIONS(6778),
    [sym_synchronized] = ACTIONS(6778),
    [sym_typeof] = ACTIONS(6778),
    [sym_gshared] = ACTIONS(6778),
    [sym_traits] = ACTIONS(6778),
    [sym_vector] = ACTIONS(6778),
    [sym_void] = ACTIONS(6778),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2703] = {
    [sym_arguments] = STATE(2726),
    [anon_sym_RBRACE] = ACTIONS(5926),
    [anon_sym_SLASH] = ACTIONS(5924),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5924),
    [anon_sym_AMP_EQ] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5924),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_DASH_EQ] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [anon_sym_PLUS_EQ] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_LT_LT_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5924),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(6804),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_SEMI] = ACTIONS(5926),
    [anon_sym_COLON] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_STAR_EQ] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_PERCENT_EQ] = ACTIONS(5926),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_CARET_EQ] = ACTIONS(5926),
    [anon_sym_CARET_CARET] = ACTIONS(5924),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_TILDE_EQ] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_const] = ACTIONS(5926),
    [sym_delegate] = ACTIONS(5926),
    [sym_function] = ACTIONS(5926),
    [sym_immutable] = ACTIONS(5926),
    [sym_in] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5926),
    [sym_is] = ACTIONS(5926),
    [sym_nothrow] = ACTIONS(5926),
    [sym_pure] = ACTIONS(5926),
    [sym_return] = ACTIONS(5926),
    [sym_scope] = ACTIONS(5926),
    [sym_shared] = ACTIONS(5926),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5926),
    [sym_not_is] = ACTIONS(5926),
  },
  [2704] = {
    [sym_identifier] = ACTIONS(6839),
    [anon_sym_LBRACE] = ACTIONS(6780),
    [anon_sym_DOT] = ACTIONS(6842),
    [anon_sym_LPAREN] = ACTIONS(6845),
    [anon_sym_AT] = ACTIONS(6780),
    [sym_bool] = ACTIONS(6839),
    [sym_byte] = ACTIONS(6839),
    [sym_ubyte] = ACTIONS(6839),
    [sym_char] = ACTIONS(6839),
    [sym_short] = ACTIONS(6839),
    [sym_ushort] = ACTIONS(6839),
    [sym_int] = ACTIONS(6839),
    [sym_uint] = ACTIONS(6839),
    [sym_long] = ACTIONS(6839),
    [sym_ulong] = ACTIONS(6839),
    [sym_cent] = ACTIONS(6839),
    [sym_ucent] = ACTIONS(6839),
    [sym_wchar] = ACTIONS(6839),
    [sym_dchar] = ACTIONS(6839),
    [sym_float] = ACTIONS(6839),
    [sym_double] = ACTIONS(6839),
    [sym_real] = ACTIONS(6839),
    [sym_ifloat] = ACTIONS(6839),
    [sym_idouble] = ACTIONS(6839),
    [sym_ireal] = ACTIONS(6839),
    [sym_cfloat] = ACTIONS(6839),
    [sym_cdouble] = ACTIONS(6839),
    [sym_creal] = ACTIONS(6839),
    [sym_size_t] = ACTIONS(6839),
    [sym_ptrdiff_t] = ACTIONS(6839),
    [sym_string] = ACTIONS(6839),
    [sym_cstring] = ACTIONS(6839),
    [sym_dstring] = ACTIONS(6839),
    [sym_wstring] = ACTIONS(6839),
    [sym_noreturn] = ACTIONS(6839),
    [sym_abstract] = ACTIONS(6778),
    [sym_align] = ACTIONS(6778),
    [sym_auto] = ACTIONS(6778),
    [sym_const] = ACTIONS(6839),
    [sym_delegate] = ACTIONS(6778),
    [sym_deprecated] = ACTIONS(6778),
    [sym_do] = ACTIONS(6778),
    [sym_extern] = ACTIONS(6778),
    [sym_final] = ACTIONS(6778),
    [sym_function] = ACTIONS(6778),
    [sym_immutable] = ACTIONS(6839),
    [sym_in] = ACTIONS(6778),
    [sym_inout] = ACTIONS(6839),
    [sym_mixin] = ACTIONS(6839),
    [sym_nothrow] = ACTIONS(6778),
    [sym_out] = ACTIONS(6778),
    [sym_override] = ACTIONS(6778),
    [sym_pure] = ACTIONS(6778),
    [sym_ref] = ACTIONS(6778),
    [sym_scope] = ACTIONS(6778),
    [sym_shared] = ACTIONS(6839),
    [sym_static] = ACTIONS(6778),
    [sym_synchronized] = ACTIONS(6778),
    [sym_typeof] = ACTIONS(6839),
    [sym_gshared] = ACTIONS(6778),
    [sym_traits] = ACTIONS(6839),
    [sym_vector] = ACTIONS(6839),
    [sym_void] = ACTIONS(6839),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2705] = {
    [sym_arguments] = STATE(2772),
    [sym_template_arguments] = STATE(2775),
    [anon_sym_SLASH] = ACTIONS(5924),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_DOT_DOT] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5924),
    [anon_sym_AMP_EQ] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5924),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_DASH_EQ] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [anon_sym_PLUS_EQ] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_LT_LT_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5924),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_BANG] = ACTIONS(6848),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(6850),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_RBRACK] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_STAR_EQ] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_PERCENT_EQ] = ACTIONS(5926),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_CARET_EQ] = ACTIONS(5926),
    [anon_sym_CARET_CARET] = ACTIONS(5924),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_TILDE_EQ] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_const] = ACTIONS(5926),
    [sym_delegate] = ACTIONS(5926),
    [sym_function] = ACTIONS(5926),
    [sym_immutable] = ACTIONS(5926),
    [sym_in] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5926),
    [sym_is] = ACTIONS(5926),
    [sym_nothrow] = ACTIONS(5926),
    [sym_pure] = ACTIONS(5926),
    [sym_return] = ACTIONS(5926),
    [sym_scope] = ACTIONS(5926),
    [sym_shared] = ACTIONS(5926),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5926),
    [sym_not_is] = ACTIONS(5926),
  },
  [2706] = {
    [sym_identifier] = ACTIONS(6778),
    [anon_sym_LBRACE] = ACTIONS(6780),
    [anon_sym_DOT] = ACTIONS(6780),
    [anon_sym_LPAREN] = ACTIONS(6780),
    [anon_sym_AT] = ACTIONS(6780),
    [sym_bool] = ACTIONS(6778),
    [sym_byte] = ACTIONS(6778),
    [sym_ubyte] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_short] = ACTIONS(6778),
    [sym_ushort] = ACTIONS(6778),
    [sym_int] = ACTIONS(6778),
    [sym_uint] = ACTIONS(6778),
    [sym_long] = ACTIONS(6778),
    [sym_ulong] = ACTIONS(6778),
    [sym_cent] = ACTIONS(6778),
    [sym_ucent] = ACTIONS(6778),
    [sym_wchar] = ACTIONS(6778),
    [sym_dchar] = ACTIONS(6778),
    [sym_float] = ACTIONS(6778),
    [sym_double] = ACTIONS(6778),
    [sym_real] = ACTIONS(6778),
    [sym_ifloat] = ACTIONS(6778),
    [sym_idouble] = ACTIONS(6778),
    [sym_ireal] = ACTIONS(6778),
    [sym_cfloat] = ACTIONS(6778),
    [sym_cdouble] = ACTIONS(6778),
    [sym_creal] = ACTIONS(6778),
    [sym_size_t] = ACTIONS(6778),
    [sym_ptrdiff_t] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym_cstring] = ACTIONS(6778),
    [sym_dstring] = ACTIONS(6778),
    [sym_wstring] = ACTIONS(6778),
    [sym_noreturn] = ACTIONS(6778),
    [sym_abstract] = ACTIONS(6778),
    [sym_align] = ACTIONS(6778),
    [sym_auto] = ACTIONS(6778),
    [sym_const] = ACTIONS(6778),
    [sym_delegate] = ACTIONS(6778),
    [sym_deprecated] = ACTIONS(6778),
    [sym_do] = ACTIONS(6778),
    [sym_extern] = ACTIONS(6778),
    [sym_final] = ACTIONS(6778),
    [sym_function] = ACTIONS(6778),
    [sym_immutable] = ACTIONS(6778),
    [sym_in] = ACTIONS(6778),
    [sym_inout] = ACTIONS(6778),
    [sym_mixin] = ACTIONS(6778),
    [sym_nothrow] = ACTIONS(6778),
    [sym_out] = ACTIONS(6778),
    [sym_override] = ACTIONS(6778),
    [sym_pure] = ACTIONS(6778),
    [sym_ref] = ACTIONS(6852),
    [sym_scope] = ACTIONS(6778),
    [sym_shared] = ACTIONS(6778),
    [sym_static] = ACTIONS(6778),
    [sym_synchronized] = ACTIONS(6778),
    [sym_typeof] = ACTIONS(6778),
    [sym_gshared] = ACTIONS(6778),
    [sym_traits] = ACTIONS(6778),
    [sym_vector] = ACTIONS(6778),
    [sym_void] = ACTIONS(6778),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
  },
  [2707] = {
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_SLASH] = ACTIONS(3117),
    [anon_sym_SLASH_EQ] = ACTIONS(3119),
    [anon_sym_DOT] = ACTIONS(3119),
    [anon_sym_AMP] = ACTIONS(3117),
    [anon_sym_AMP_EQ] = ACTIONS(3119),
    [anon_sym_AMP_AMP] = ACTIONS(3119),
    [anon_sym_PIPE] = ACTIONS(3117),
    [anon_sym_PIPE_EQ] = ACTIONS(3119),
    [anon_sym_PIPE_PIPE] = ACTIONS(3119),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_DASH_EQ] = ACTIONS(3119),
    [anon_sym_DASH_DASH] = ACTIONS(3119),
    [anon_sym_PLUS] = ACTIONS(3117),
    [anon_sym_PLUS_EQ] = ACTIONS(3119),
    [anon_sym_PLUS_PLUS] = ACTIONS(3119),
    [anon_sym_LT] = ACTIONS(3117),
    [anon_sym_LT_EQ] = ACTIONS(3119),
    [anon_sym_LT_LT] = ACTIONS(3117),
    [anon_sym_LT_LT_EQ] = ACTIONS(3119),
    [anon_sym_GT] = ACTIONS(3117),
    [anon_sym_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3119),
    [anon_sym_GT_GT] = ACTIONS(3117),
    [anon_sym_GT_GT_GT] = ACTIONS(3117),
    [anon_sym_BANG_EQ] = ACTIONS(3119),
    [anon_sym_LPAREN] = ACTIONS(3119),
    [anon_sym_RPAREN] = ACTIONS(3119),
    [anon_sym_LBRACK] = ACTIONS(3119),
    [anon_sym_RBRACK] = ACTIONS(3119),
    [anon_sym_QMARK] = ACTIONS(3119),
    [anon_sym_COMMA] = ACTIONS(3119),
    [anon_sym_SEMI] = ACTIONS(3119),
    [anon_sym_COLON] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_EQ_EQ] = ACTIONS(3119),
    [anon_sym_STAR] = ACTIONS(3117),
    [anon_sym_STAR_EQ] = ACTIONS(3119),
    [anon_sym_PERCENT] = ACTIONS(3117),
    [anon_sym_PERCENT_EQ] = ACTIONS(3119),
    [anon_sym_CARET] = ACTIONS(3117),
    [anon_sym_CARET_EQ] = ACTIONS(3119),
    [anon_sym_CARET_CARET] = ACTIONS(3117),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3119),
    [anon_sym_TILDE] = ACTIONS(3117),
    [anon_sym_TILDE_EQ] = ACTIONS(3119),
    [anon_sym_AT] = ACTIONS(3119),
    [sym_const] = ACTIONS(3119),
    [sym_delegate] = ACTIONS(3119),
    [sym_function] = ACTIONS(3119),
    [sym_immutable] = ACTIONS(3119),
    [sym_in] = ACTIONS(3117),
    [sym_inout] = ACTIONS(3119),
    [sym_is] = ACTIONS(3119),
    [sym_nothrow] = ACTIONS(3119),
    [sym_pure] = ACTIONS(3119),
    [sym_return] = ACTIONS(3119),
    [sym_scope] = ACTIONS(3119),
    [sym_shared] = ACTIONS(3119),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3119),
    [sym_not_is] = ACTIONS(3119),
  },
  [2708] = {
    [anon_sym_RBRACE] = ACTIONS(5950),
    [anon_sym_SLASH] = ACTIONS(5948),
    [anon_sym_SLASH_EQ] = ACTIONS(5950),
    [anon_sym_DOT] = ACTIONS(5950),
    [anon_sym_AMP] = ACTIONS(5948),
    [anon_sym_AMP_EQ] = ACTIONS(5950),
    [anon_sym_AMP_AMP] = ACTIONS(5950),
    [anon_sym_PIPE] = ACTIONS(5948),
    [anon_sym_PIPE_EQ] = ACTIONS(5950),
    [anon_sym_PIPE_PIPE] = ACTIONS(5950),
    [anon_sym_DASH] = ACTIONS(5948),
    [anon_sym_DASH_EQ] = ACTIONS(5950),
    [anon_sym_DASH_DASH] = ACTIONS(5950),
    [anon_sym_PLUS] = ACTIONS(5948),
    [anon_sym_PLUS_EQ] = ACTIONS(5950),
    [anon_sym_PLUS_PLUS] = ACTIONS(5950),
    [anon_sym_LT] = ACTIONS(5948),
    [anon_sym_LT_EQ] = ACTIONS(5950),
    [anon_sym_LT_LT] = ACTIONS(5948),
    [anon_sym_LT_LT_EQ] = ACTIONS(5950),
    [anon_sym_GT] = ACTIONS(5948),
    [anon_sym_GT_EQ] = ACTIONS(5950),
    [anon_sym_GT_GT_EQ] = ACTIONS(5950),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5950),
    [anon_sym_GT_GT] = ACTIONS(5948),
    [anon_sym_GT_GT_GT] = ACTIONS(5948),
    [anon_sym_BANG_EQ] = ACTIONS(5950),
    [anon_sym_LPAREN] = ACTIONS(5950),
    [anon_sym_RPAREN] = ACTIONS(5950),
    [anon_sym_LBRACK] = ACTIONS(5950),
    [anon_sym_RBRACK] = ACTIONS(5950),
    [anon_sym_QMARK] = ACTIONS(5950),
    [anon_sym_COMMA] = ACTIONS(5950),
    [anon_sym_SEMI] = ACTIONS(5950),
    [anon_sym_COLON] = ACTIONS(5950),
    [anon_sym_EQ] = ACTIONS(5948),
    [anon_sym_EQ_EQ] = ACTIONS(5950),
    [anon_sym_STAR] = ACTIONS(5948),
    [anon_sym_STAR_EQ] = ACTIONS(5950),
    [anon_sym_PERCENT] = ACTIONS(5948),
    [anon_sym_PERCENT_EQ] = ACTIONS(5950),
    [anon_sym_CARET] = ACTIONS(5948),
    [anon_sym_CARET_EQ] = ACTIONS(5950),
    [anon_sym_CARET_CARET] = ACTIONS(5948),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5948),
    [anon_sym_TILDE_EQ] = ACTIONS(5950),
    [anon_sym_AT] = ACTIONS(5950),
    [sym_const] = ACTIONS(5950),
    [sym_delegate] = ACTIONS(5950),
    [sym_function] = ACTIONS(5950),
    [sym_immutable] = ACTIONS(5950),
    [sym_in] = ACTIONS(5948),
    [sym_inout] = ACTIONS(5950),
    [sym_is] = ACTIONS(5950),
    [sym_nothrow] = ACTIONS(5950),
    [sym_pure] = ACTIONS(5950),
    [sym_return] = ACTIONS(5950),
    [sym_scope] = ACTIONS(5950),
    [sym_shared] = ACTIONS(5950),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5950),
    [sym_not_is] = ACTIONS(5950),
  },
  [2709] = {
    [anon_sym_RBRACE] = ACTIONS(3087),
    [anon_sym_SLASH] = ACTIONS(3085),
    [anon_sym_SLASH_EQ] = ACTIONS(3087),
    [anon_sym_DOT] = ACTIONS(3087),
    [anon_sym_AMP] = ACTIONS(3085),
    [anon_sym_AMP_EQ] = ACTIONS(3087),
    [anon_sym_AMP_AMP] = ACTIONS(3087),
    [anon_sym_PIPE] = ACTIONS(3085),
    [anon_sym_PIPE_EQ] = ACTIONS(3087),
    [anon_sym_PIPE_PIPE] = ACTIONS(3087),
    [anon_sym_DASH] = ACTIONS(3085),
    [anon_sym_DASH_EQ] = ACTIONS(3087),
    [anon_sym_DASH_DASH] = ACTIONS(3087),
    [anon_sym_PLUS] = ACTIONS(3085),
    [anon_sym_PLUS_EQ] = ACTIONS(3087),
    [anon_sym_PLUS_PLUS] = ACTIONS(3087),
    [anon_sym_LT] = ACTIONS(3085),
    [anon_sym_LT_EQ] = ACTIONS(3087),
    [anon_sym_LT_LT] = ACTIONS(3085),
    [anon_sym_LT_LT_EQ] = ACTIONS(3087),
    [anon_sym_GT] = ACTIONS(3085),
    [anon_sym_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3087),
    [anon_sym_GT_GT] = ACTIONS(3085),
    [anon_sym_GT_GT_GT] = ACTIONS(3085),
    [anon_sym_BANG_EQ] = ACTIONS(3087),
    [anon_sym_LPAREN] = ACTIONS(3087),
    [anon_sym_RPAREN] = ACTIONS(3087),
    [anon_sym_LBRACK] = ACTIONS(3087),
    [anon_sym_RBRACK] = ACTIONS(3087),
    [anon_sym_QMARK] = ACTIONS(3087),
    [anon_sym_COMMA] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3087),
    [anon_sym_COLON] = ACTIONS(3087),
    [anon_sym_EQ] = ACTIONS(3085),
    [anon_sym_EQ_EQ] = ACTIONS(3087),
    [anon_sym_STAR] = ACTIONS(3085),
    [anon_sym_STAR_EQ] = ACTIONS(3087),
    [anon_sym_PERCENT] = ACTIONS(3085),
    [anon_sym_PERCENT_EQ] = ACTIONS(3087),
    [anon_sym_CARET] = ACTIONS(3085),
    [anon_sym_CARET_EQ] = ACTIONS(3087),
    [anon_sym_CARET_CARET] = ACTIONS(3085),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3087),
    [anon_sym_TILDE] = ACTIONS(3085),
    [anon_sym_TILDE_EQ] = ACTIONS(3087),
    [anon_sym_AT] = ACTIONS(3087),
    [sym_const] = ACTIONS(3087),
    [sym_delegate] = ACTIONS(3087),
    [sym_function] = ACTIONS(3087),
    [sym_immutable] = ACTIONS(3087),
    [sym_in] = ACTIONS(3085),
    [sym_inout] = ACTIONS(3087),
    [sym_is] = ACTIONS(3087),
    [sym_nothrow] = ACTIONS(3087),
    [sym_pure] = ACTIONS(3087),
    [sym_return] = ACTIONS(3087),
    [sym_scope] = ACTIONS(3087),
    [sym_shared] = ACTIONS(3087),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3087),
    [sym_not_is] = ACTIONS(3087),
  },
  [2710] = {
    [anon_sym_RBRACE] = ACTIONS(6855),
    [anon_sym_SLASH] = ACTIONS(6857),
    [anon_sym_SLASH_EQ] = ACTIONS(6855),
    [anon_sym_DOT] = ACTIONS(6855),
    [anon_sym_AMP] = ACTIONS(6857),
    [anon_sym_AMP_EQ] = ACTIONS(6855),
    [anon_sym_AMP_AMP] = ACTIONS(6855),
    [anon_sym_PIPE] = ACTIONS(6857),
    [anon_sym_PIPE_EQ] = ACTIONS(6855),
    [anon_sym_PIPE_PIPE] = ACTIONS(6855),
    [anon_sym_DASH] = ACTIONS(6857),
    [anon_sym_DASH_EQ] = ACTIONS(6855),
    [anon_sym_DASH_DASH] = ACTIONS(6855),
    [anon_sym_PLUS] = ACTIONS(6857),
    [anon_sym_PLUS_EQ] = ACTIONS(6855),
    [anon_sym_PLUS_PLUS] = ACTIONS(6855),
    [anon_sym_LT] = ACTIONS(6857),
    [anon_sym_LT_EQ] = ACTIONS(6855),
    [anon_sym_LT_LT] = ACTIONS(6857),
    [anon_sym_LT_LT_EQ] = ACTIONS(6855),
    [anon_sym_GT] = ACTIONS(6857),
    [anon_sym_GT_EQ] = ACTIONS(6855),
    [anon_sym_GT_GT_EQ] = ACTIONS(6855),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6855),
    [anon_sym_GT_GT] = ACTIONS(6857),
    [anon_sym_GT_GT_GT] = ACTIONS(6857),
    [anon_sym_BANG_EQ] = ACTIONS(6855),
    [anon_sym_LPAREN] = ACTIONS(6855),
    [anon_sym_RPAREN] = ACTIONS(6855),
    [anon_sym_LBRACK] = ACTIONS(6855),
    [anon_sym_RBRACK] = ACTIONS(6855),
    [anon_sym_QMARK] = ACTIONS(6855),
    [anon_sym_COMMA] = ACTIONS(6855),
    [anon_sym_SEMI] = ACTIONS(6855),
    [anon_sym_COLON] = ACTIONS(6855),
    [anon_sym_EQ] = ACTIONS(6857),
    [anon_sym_EQ_EQ] = ACTIONS(6855),
    [anon_sym_STAR] = ACTIONS(6857),
    [anon_sym_STAR_EQ] = ACTIONS(6855),
    [anon_sym_PERCENT] = ACTIONS(6857),
    [anon_sym_PERCENT_EQ] = ACTIONS(6855),
    [anon_sym_CARET] = ACTIONS(6857),
    [anon_sym_CARET_EQ] = ACTIONS(6855),
    [anon_sym_CARET_CARET] = ACTIONS(6857),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6855),
    [anon_sym_TILDE] = ACTIONS(6857),
    [anon_sym_TILDE_EQ] = ACTIONS(6855),
    [anon_sym_AT] = ACTIONS(6855),
    [sym_const] = ACTIONS(6855),
    [sym_delegate] = ACTIONS(6855),
    [sym_function] = ACTIONS(6855),
    [sym_immutable] = ACTIONS(6855),
    [sym_in] = ACTIONS(6857),
    [sym_inout] = ACTIONS(6855),
    [sym_is] = ACTIONS(6855),
    [sym_nothrow] = ACTIONS(6855),
    [sym_pure] = ACTIONS(6855),
    [sym_return] = ACTIONS(6855),
    [sym_scope] = ACTIONS(6855),
    [sym_shared] = ACTIONS(6855),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6855),
    [sym_not_is] = ACTIONS(6855),
  },
  [2711] = {
    [anon_sym_RBRACE] = ACTIONS(3111),
    [anon_sym_SLASH] = ACTIONS(3109),
    [anon_sym_SLASH_EQ] = ACTIONS(3111),
    [anon_sym_DOT] = ACTIONS(3111),
    [anon_sym_AMP] = ACTIONS(3109),
    [anon_sym_AMP_EQ] = ACTIONS(3111),
    [anon_sym_AMP_AMP] = ACTIONS(3111),
    [anon_sym_PIPE] = ACTIONS(3109),
    [anon_sym_PIPE_EQ] = ACTIONS(3111),
    [anon_sym_PIPE_PIPE] = ACTIONS(3111),
    [anon_sym_DASH] = ACTIONS(3109),
    [anon_sym_DASH_EQ] = ACTIONS(3111),
    [anon_sym_DASH_DASH] = ACTIONS(3111),
    [anon_sym_PLUS] = ACTIONS(3109),
    [anon_sym_PLUS_EQ] = ACTIONS(3111),
    [anon_sym_PLUS_PLUS] = ACTIONS(3111),
    [anon_sym_LT] = ACTIONS(3109),
    [anon_sym_LT_EQ] = ACTIONS(3111),
    [anon_sym_LT_LT] = ACTIONS(3109),
    [anon_sym_LT_LT_EQ] = ACTIONS(3111),
    [anon_sym_GT] = ACTIONS(3109),
    [anon_sym_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3111),
    [anon_sym_GT_GT] = ACTIONS(3109),
    [anon_sym_GT_GT_GT] = ACTIONS(3109),
    [anon_sym_BANG_EQ] = ACTIONS(3111),
    [anon_sym_LPAREN] = ACTIONS(3111),
    [anon_sym_RPAREN] = ACTIONS(3111),
    [anon_sym_LBRACK] = ACTIONS(3111),
    [anon_sym_RBRACK] = ACTIONS(3111),
    [anon_sym_QMARK] = ACTIONS(3111),
    [anon_sym_COMMA] = ACTIONS(3111),
    [anon_sym_SEMI] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3111),
    [anon_sym_EQ] = ACTIONS(3109),
    [anon_sym_EQ_EQ] = ACTIONS(3111),
    [anon_sym_STAR] = ACTIONS(3109),
    [anon_sym_STAR_EQ] = ACTIONS(3111),
    [anon_sym_PERCENT] = ACTIONS(3109),
    [anon_sym_PERCENT_EQ] = ACTIONS(3111),
    [anon_sym_CARET] = ACTIONS(3109),
    [anon_sym_CARET_EQ] = ACTIONS(3111),
    [anon_sym_CARET_CARET] = ACTIONS(3109),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3111),
    [anon_sym_TILDE] = ACTIONS(3109),
    [anon_sym_TILDE_EQ] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(3111),
    [sym_const] = ACTIONS(3111),
    [sym_delegate] = ACTIONS(3111),
    [sym_function] = ACTIONS(3111),
    [sym_immutable] = ACTIONS(3111),
    [sym_in] = ACTIONS(3109),
    [sym_inout] = ACTIONS(3111),
    [sym_is] = ACTIONS(3111),
    [sym_nothrow] = ACTIONS(3111),
    [sym_pure] = ACTIONS(3111),
    [sym_return] = ACTIONS(3111),
    [sym_scope] = ACTIONS(3111),
    [sym_shared] = ACTIONS(3111),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3111),
    [sym_not_is] = ACTIONS(3111),
  },
  [2712] = {
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_SLASH_EQ] = ACTIONS(3063),
    [anon_sym_DOT] = ACTIONS(3063),
    [anon_sym_AMP] = ACTIONS(3061),
    [anon_sym_AMP_EQ] = ACTIONS(3063),
    [anon_sym_AMP_AMP] = ACTIONS(3063),
    [anon_sym_PIPE] = ACTIONS(3061),
    [anon_sym_PIPE_EQ] = ACTIONS(3063),
    [anon_sym_PIPE_PIPE] = ACTIONS(3063),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_DASH_EQ] = ACTIONS(3063),
    [anon_sym_DASH_DASH] = ACTIONS(3063),
    [anon_sym_PLUS] = ACTIONS(3061),
    [anon_sym_PLUS_EQ] = ACTIONS(3063),
    [anon_sym_PLUS_PLUS] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3061),
    [anon_sym_LT_EQ] = ACTIONS(3063),
    [anon_sym_LT_LT] = ACTIONS(3061),
    [anon_sym_LT_LT_EQ] = ACTIONS(3063),
    [anon_sym_GT] = ACTIONS(3061),
    [anon_sym_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3063),
    [anon_sym_GT_GT] = ACTIONS(3061),
    [anon_sym_GT_GT_GT] = ACTIONS(3061),
    [anon_sym_BANG_EQ] = ACTIONS(3063),
    [anon_sym_LPAREN] = ACTIONS(3063),
    [anon_sym_RPAREN] = ACTIONS(3063),
    [anon_sym_LBRACK] = ACTIONS(3063),
    [anon_sym_RBRACK] = ACTIONS(3063),
    [anon_sym_QMARK] = ACTIONS(3063),
    [anon_sym_COMMA] = ACTIONS(3063),
    [anon_sym_SEMI] = ACTIONS(3063),
    [anon_sym_COLON] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_EQ_EQ] = ACTIONS(3063),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_STAR_EQ] = ACTIONS(3063),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_PERCENT_EQ] = ACTIONS(3063),
    [anon_sym_CARET] = ACTIONS(3061),
    [anon_sym_CARET_EQ] = ACTIONS(3063),
    [anon_sym_CARET_CARET] = ACTIONS(3061),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3063),
    [anon_sym_TILDE] = ACTIONS(3061),
    [anon_sym_TILDE_EQ] = ACTIONS(3063),
    [anon_sym_AT] = ACTIONS(3063),
    [sym_const] = ACTIONS(3063),
    [sym_delegate] = ACTIONS(3063),
    [sym_function] = ACTIONS(3063),
    [sym_immutable] = ACTIONS(3063),
    [sym_in] = ACTIONS(3061),
    [sym_inout] = ACTIONS(3063),
    [sym_is] = ACTIONS(3063),
    [sym_nothrow] = ACTIONS(3063),
    [sym_pure] = ACTIONS(3063),
    [sym_return] = ACTIONS(3063),
    [sym_scope] = ACTIONS(3063),
    [sym_shared] = ACTIONS(3063),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3063),
    [sym_not_is] = ACTIONS(3063),
  },
  [2713] = {
    [anon_sym_RBRACE] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3069),
    [anon_sym_SLASH_EQ] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_AMP] = ACTIONS(3069),
    [anon_sym_AMP_EQ] = ACTIONS(3071),
    [anon_sym_AMP_AMP] = ACTIONS(3071),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_PIPE_EQ] = ACTIONS(3071),
    [anon_sym_PIPE_PIPE] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3069),
    [anon_sym_DASH_EQ] = ACTIONS(3071),
    [anon_sym_DASH_DASH] = ACTIONS(3071),
    [anon_sym_PLUS] = ACTIONS(3069),
    [anon_sym_PLUS_EQ] = ACTIONS(3071),
    [anon_sym_PLUS_PLUS] = ACTIONS(3071),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_LT_EQ] = ACTIONS(3071),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_LT_LT_EQ] = ACTIONS(3071),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3071),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_GT_GT_GT] = ACTIONS(3069),
    [anon_sym_BANG_EQ] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3069),
    [anon_sym_EQ_EQ] = ACTIONS(3071),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_STAR_EQ] = ACTIONS(3071),
    [anon_sym_PERCENT] = ACTIONS(3069),
    [anon_sym_PERCENT_EQ] = ACTIONS(3071),
    [anon_sym_CARET] = ACTIONS(3069),
    [anon_sym_CARET_EQ] = ACTIONS(3071),
    [anon_sym_CARET_CARET] = ACTIONS(3069),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3071),
    [anon_sym_TILDE] = ACTIONS(3069),
    [anon_sym_TILDE_EQ] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [sym_const] = ACTIONS(3071),
    [sym_delegate] = ACTIONS(3071),
    [sym_function] = ACTIONS(3071),
    [sym_immutable] = ACTIONS(3071),
    [sym_in] = ACTIONS(3069),
    [sym_inout] = ACTIONS(3071),
    [sym_is] = ACTIONS(3071),
    [sym_nothrow] = ACTIONS(3071),
    [sym_pure] = ACTIONS(3071),
    [sym_return] = ACTIONS(3071),
    [sym_scope] = ACTIONS(3071),
    [sym_shared] = ACTIONS(3071),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3071),
    [sym_not_is] = ACTIONS(3071),
  },
  [2714] = {
    [anon_sym_RBRACE] = ACTIONS(5946),
    [anon_sym_SLASH] = ACTIONS(5944),
    [anon_sym_SLASH_EQ] = ACTIONS(5946),
    [anon_sym_DOT] = ACTIONS(5946),
    [anon_sym_AMP] = ACTIONS(5944),
    [anon_sym_AMP_EQ] = ACTIONS(5946),
    [anon_sym_AMP_AMP] = ACTIONS(5946),
    [anon_sym_PIPE] = ACTIONS(5944),
    [anon_sym_PIPE_EQ] = ACTIONS(5946),
    [anon_sym_PIPE_PIPE] = ACTIONS(5946),
    [anon_sym_DASH] = ACTIONS(5944),
    [anon_sym_DASH_EQ] = ACTIONS(5946),
    [anon_sym_DASH_DASH] = ACTIONS(5946),
    [anon_sym_PLUS] = ACTIONS(5944),
    [anon_sym_PLUS_EQ] = ACTIONS(5946),
    [anon_sym_PLUS_PLUS] = ACTIONS(5946),
    [anon_sym_LT] = ACTIONS(5944),
    [anon_sym_LT_EQ] = ACTIONS(5946),
    [anon_sym_LT_LT] = ACTIONS(5944),
    [anon_sym_LT_LT_EQ] = ACTIONS(5946),
    [anon_sym_GT] = ACTIONS(5944),
    [anon_sym_GT_EQ] = ACTIONS(5946),
    [anon_sym_GT_GT_EQ] = ACTIONS(5946),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5946),
    [anon_sym_GT_GT] = ACTIONS(5944),
    [anon_sym_GT_GT_GT] = ACTIONS(5944),
    [anon_sym_BANG_EQ] = ACTIONS(5946),
    [anon_sym_LPAREN] = ACTIONS(5946),
    [anon_sym_RPAREN] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(5946),
    [anon_sym_RBRACK] = ACTIONS(5946),
    [anon_sym_QMARK] = ACTIONS(5946),
    [anon_sym_COMMA] = ACTIONS(5946),
    [anon_sym_SEMI] = ACTIONS(5946),
    [anon_sym_COLON] = ACTIONS(5946),
    [anon_sym_EQ] = ACTIONS(5944),
    [anon_sym_EQ_EQ] = ACTIONS(5946),
    [anon_sym_STAR] = ACTIONS(5944),
    [anon_sym_STAR_EQ] = ACTIONS(5946),
    [anon_sym_PERCENT] = ACTIONS(5944),
    [anon_sym_PERCENT_EQ] = ACTIONS(5946),
    [anon_sym_CARET] = ACTIONS(5944),
    [anon_sym_CARET_EQ] = ACTIONS(5946),
    [anon_sym_CARET_CARET] = ACTIONS(5944),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5946),
    [anon_sym_TILDE] = ACTIONS(5944),
    [anon_sym_TILDE_EQ] = ACTIONS(5946),
    [anon_sym_AT] = ACTIONS(5946),
    [sym_const] = ACTIONS(5946),
    [sym_delegate] = ACTIONS(5946),
    [sym_function] = ACTIONS(5946),
    [sym_immutable] = ACTIONS(5946),
    [sym_in] = ACTIONS(5944),
    [sym_inout] = ACTIONS(5946),
    [sym_is] = ACTIONS(5946),
    [sym_nothrow] = ACTIONS(5946),
    [sym_pure] = ACTIONS(5946),
    [sym_return] = ACTIONS(5946),
    [sym_scope] = ACTIONS(5946),
    [sym_shared] = ACTIONS(5946),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5946),
    [sym_not_is] = ACTIONS(5946),
  },
  [2715] = {
    [anon_sym_RBRACE] = ACTIONS(3107),
    [anon_sym_SLASH] = ACTIONS(3105),
    [anon_sym_SLASH_EQ] = ACTIONS(3107),
    [anon_sym_DOT] = ACTIONS(3107),
    [anon_sym_AMP] = ACTIONS(3105),
    [anon_sym_AMP_EQ] = ACTIONS(3107),
    [anon_sym_AMP_AMP] = ACTIONS(3107),
    [anon_sym_PIPE] = ACTIONS(3105),
    [anon_sym_PIPE_EQ] = ACTIONS(3107),
    [anon_sym_PIPE_PIPE] = ACTIONS(3107),
    [anon_sym_DASH] = ACTIONS(3105),
    [anon_sym_DASH_EQ] = ACTIONS(3107),
    [anon_sym_DASH_DASH] = ACTIONS(3107),
    [anon_sym_PLUS] = ACTIONS(3105),
    [anon_sym_PLUS_EQ] = ACTIONS(3107),
    [anon_sym_PLUS_PLUS] = ACTIONS(3107),
    [anon_sym_LT] = ACTIONS(3105),
    [anon_sym_LT_EQ] = ACTIONS(3107),
    [anon_sym_LT_LT] = ACTIONS(3105),
    [anon_sym_LT_LT_EQ] = ACTIONS(3107),
    [anon_sym_GT] = ACTIONS(3105),
    [anon_sym_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3107),
    [anon_sym_GT_GT] = ACTIONS(3105),
    [anon_sym_GT_GT_GT] = ACTIONS(3105),
    [anon_sym_BANG_EQ] = ACTIONS(3107),
    [anon_sym_LPAREN] = ACTIONS(3107),
    [anon_sym_RPAREN] = ACTIONS(3107),
    [anon_sym_LBRACK] = ACTIONS(3107),
    [anon_sym_RBRACK] = ACTIONS(3107),
    [anon_sym_QMARK] = ACTIONS(3107),
    [anon_sym_COMMA] = ACTIONS(3107),
    [anon_sym_SEMI] = ACTIONS(3107),
    [anon_sym_COLON] = ACTIONS(3107),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_EQ_EQ] = ACTIONS(3107),
    [anon_sym_STAR] = ACTIONS(3105),
    [anon_sym_STAR_EQ] = ACTIONS(3107),
    [anon_sym_PERCENT] = ACTIONS(3105),
    [anon_sym_PERCENT_EQ] = ACTIONS(3107),
    [anon_sym_CARET] = ACTIONS(3105),
    [anon_sym_CARET_EQ] = ACTIONS(3107),
    [anon_sym_CARET_CARET] = ACTIONS(3105),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3107),
    [anon_sym_TILDE] = ACTIONS(3105),
    [anon_sym_TILDE_EQ] = ACTIONS(3107),
    [anon_sym_AT] = ACTIONS(3107),
    [sym_const] = ACTIONS(3107),
    [sym_delegate] = ACTIONS(3107),
    [sym_function] = ACTIONS(3107),
    [sym_immutable] = ACTIONS(3107),
    [sym_in] = ACTIONS(3105),
    [sym_inout] = ACTIONS(3107),
    [sym_is] = ACTIONS(3107),
    [sym_nothrow] = ACTIONS(3107),
    [sym_pure] = ACTIONS(3107),
    [sym_return] = ACTIONS(3107),
    [sym_scope] = ACTIONS(3107),
    [sym_shared] = ACTIONS(3107),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3107),
    [sym_not_is] = ACTIONS(3107),
  },
  [2716] = {
    [anon_sym_RBRACE] = ACTIONS(6859),
    [anon_sym_SLASH] = ACTIONS(6861),
    [anon_sym_SLASH_EQ] = ACTIONS(6859),
    [anon_sym_DOT] = ACTIONS(6859),
    [anon_sym_AMP] = ACTIONS(6861),
    [anon_sym_AMP_EQ] = ACTIONS(6859),
    [anon_sym_AMP_AMP] = ACTIONS(6859),
    [anon_sym_PIPE] = ACTIONS(6861),
    [anon_sym_PIPE_EQ] = ACTIONS(6859),
    [anon_sym_PIPE_PIPE] = ACTIONS(6859),
    [anon_sym_DASH] = ACTIONS(6861),
    [anon_sym_DASH_EQ] = ACTIONS(6859),
    [anon_sym_DASH_DASH] = ACTIONS(6859),
    [anon_sym_PLUS] = ACTIONS(6861),
    [anon_sym_PLUS_EQ] = ACTIONS(6859),
    [anon_sym_PLUS_PLUS] = ACTIONS(6859),
    [anon_sym_LT] = ACTIONS(6861),
    [anon_sym_LT_EQ] = ACTIONS(6859),
    [anon_sym_LT_LT] = ACTIONS(6861),
    [anon_sym_LT_LT_EQ] = ACTIONS(6859),
    [anon_sym_GT] = ACTIONS(6861),
    [anon_sym_GT_EQ] = ACTIONS(6859),
    [anon_sym_GT_GT_EQ] = ACTIONS(6859),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6859),
    [anon_sym_GT_GT] = ACTIONS(6861),
    [anon_sym_GT_GT_GT] = ACTIONS(6861),
    [anon_sym_BANG_EQ] = ACTIONS(6859),
    [anon_sym_LPAREN] = ACTIONS(6859),
    [anon_sym_RPAREN] = ACTIONS(6859),
    [anon_sym_LBRACK] = ACTIONS(6859),
    [anon_sym_RBRACK] = ACTIONS(6859),
    [anon_sym_QMARK] = ACTIONS(6859),
    [anon_sym_COMMA] = ACTIONS(6859),
    [anon_sym_SEMI] = ACTIONS(6859),
    [anon_sym_COLON] = ACTIONS(6859),
    [anon_sym_EQ] = ACTIONS(6861),
    [anon_sym_EQ_EQ] = ACTIONS(6859),
    [anon_sym_STAR] = ACTIONS(6861),
    [anon_sym_STAR_EQ] = ACTIONS(6859),
    [anon_sym_PERCENT] = ACTIONS(6861),
    [anon_sym_PERCENT_EQ] = ACTIONS(6859),
    [anon_sym_CARET] = ACTIONS(6861),
    [anon_sym_CARET_EQ] = ACTIONS(6859),
    [anon_sym_CARET_CARET] = ACTIONS(6861),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6859),
    [anon_sym_TILDE] = ACTIONS(6861),
    [anon_sym_TILDE_EQ] = ACTIONS(6859),
    [anon_sym_AT] = ACTIONS(6859),
    [sym_const] = ACTIONS(6859),
    [sym_delegate] = ACTIONS(6859),
    [sym_function] = ACTIONS(6859),
    [sym_immutable] = ACTIONS(6859),
    [sym_in] = ACTIONS(6861),
    [sym_inout] = ACTIONS(6859),
    [sym_is] = ACTIONS(6859),
    [sym_nothrow] = ACTIONS(6859),
    [sym_pure] = ACTIONS(6859),
    [sym_return] = ACTIONS(6859),
    [sym_scope] = ACTIONS(6859),
    [sym_shared] = ACTIONS(6859),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6859),
    [sym_not_is] = ACTIONS(6859),
  },
  [2717] = {
    [anon_sym_RBRACE] = ACTIONS(5958),
    [anon_sym_SLASH] = ACTIONS(5956),
    [anon_sym_SLASH_EQ] = ACTIONS(5958),
    [anon_sym_DOT] = ACTIONS(5958),
    [anon_sym_AMP] = ACTIONS(5956),
    [anon_sym_AMP_EQ] = ACTIONS(5958),
    [anon_sym_AMP_AMP] = ACTIONS(5958),
    [anon_sym_PIPE] = ACTIONS(5956),
    [anon_sym_PIPE_EQ] = ACTIONS(5958),
    [anon_sym_PIPE_PIPE] = ACTIONS(5958),
    [anon_sym_DASH] = ACTIONS(5956),
    [anon_sym_DASH_EQ] = ACTIONS(5958),
    [anon_sym_DASH_DASH] = ACTIONS(5958),
    [anon_sym_PLUS] = ACTIONS(5956),
    [anon_sym_PLUS_EQ] = ACTIONS(5958),
    [anon_sym_PLUS_PLUS] = ACTIONS(5958),
    [anon_sym_LT] = ACTIONS(5956),
    [anon_sym_LT_EQ] = ACTIONS(5958),
    [anon_sym_LT_LT] = ACTIONS(5956),
    [anon_sym_LT_LT_EQ] = ACTIONS(5958),
    [anon_sym_GT] = ACTIONS(5956),
    [anon_sym_GT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5958),
    [anon_sym_GT_GT] = ACTIONS(5956),
    [anon_sym_GT_GT_GT] = ACTIONS(5956),
    [anon_sym_BANG_EQ] = ACTIONS(5958),
    [anon_sym_LPAREN] = ACTIONS(5958),
    [anon_sym_RPAREN] = ACTIONS(5958),
    [anon_sym_LBRACK] = ACTIONS(5958),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_QMARK] = ACTIONS(5958),
    [anon_sym_COMMA] = ACTIONS(5958),
    [anon_sym_SEMI] = ACTIONS(5958),
    [anon_sym_COLON] = ACTIONS(5958),
    [anon_sym_EQ] = ACTIONS(5956),
    [anon_sym_EQ_EQ] = ACTIONS(5958),
    [anon_sym_STAR] = ACTIONS(5956),
    [anon_sym_STAR_EQ] = ACTIONS(5958),
    [anon_sym_PERCENT] = ACTIONS(5956),
    [anon_sym_PERCENT_EQ] = ACTIONS(5958),
    [anon_sym_CARET] = ACTIONS(5956),
    [anon_sym_CARET_EQ] = ACTIONS(5958),
    [anon_sym_CARET_CARET] = ACTIONS(5956),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5958),
    [anon_sym_TILDE] = ACTIONS(5956),
    [anon_sym_TILDE_EQ] = ACTIONS(5958),
    [anon_sym_AT] = ACTIONS(5958),
    [sym_const] = ACTIONS(5958),
    [sym_delegate] = ACTIONS(5958),
    [sym_function] = ACTIONS(5958),
    [sym_immutable] = ACTIONS(5958),
    [sym_in] = ACTIONS(5956),
    [sym_inout] = ACTIONS(5958),
    [sym_is] = ACTIONS(5958),
    [sym_nothrow] = ACTIONS(5958),
    [sym_pure] = ACTIONS(5958),
    [sym_return] = ACTIONS(5958),
    [sym_scope] = ACTIONS(5958),
    [sym_shared] = ACTIONS(5958),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5958),
    [sym_not_is] = ACTIONS(5958),
  },
  [2718] = {
    [sym_arguments] = STATE(2829),
    [sym_template_arguments] = STATE(2835),
    [anon_sym_SLASH] = ACTIONS(5924),
    [anon_sym_SLASH_EQ] = ACTIONS(5926),
    [anon_sym_DOT] = ACTIONS(5924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5926),
    [anon_sym_AMP] = ACTIONS(5924),
    [anon_sym_AMP_EQ] = ACTIONS(5926),
    [anon_sym_AMP_AMP] = ACTIONS(5926),
    [anon_sym_PIPE] = ACTIONS(5924),
    [anon_sym_PIPE_EQ] = ACTIONS(5926),
    [anon_sym_PIPE_PIPE] = ACTIONS(5926),
    [anon_sym_DASH] = ACTIONS(5924),
    [anon_sym_DASH_EQ] = ACTIONS(5926),
    [anon_sym_DASH_DASH] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5924),
    [anon_sym_PLUS_EQ] = ACTIONS(5926),
    [anon_sym_PLUS_PLUS] = ACTIONS(5926),
    [anon_sym_LT] = ACTIONS(5924),
    [anon_sym_LT_EQ] = ACTIONS(5926),
    [anon_sym_LT_LT] = ACTIONS(5924),
    [anon_sym_LT_LT_EQ] = ACTIONS(5926),
    [anon_sym_GT] = ACTIONS(5924),
    [anon_sym_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5926),
    [anon_sym_GT_GT] = ACTIONS(5924),
    [anon_sym_GT_GT_GT] = ACTIONS(5924),
    [anon_sym_BANG] = ACTIONS(6863),
    [anon_sym_BANG_EQ] = ACTIONS(5926),
    [anon_sym_LPAREN] = ACTIONS(6865),
    [anon_sym_RPAREN] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5926),
    [anon_sym_QMARK] = ACTIONS(5926),
    [anon_sym_COMMA] = ACTIONS(5926),
    [anon_sym_EQ] = ACTIONS(5924),
    [anon_sym_EQ_EQ] = ACTIONS(5926),
    [anon_sym_STAR] = ACTIONS(5924),
    [anon_sym_STAR_EQ] = ACTIONS(5926),
    [anon_sym_PERCENT] = ACTIONS(5924),
    [anon_sym_PERCENT_EQ] = ACTIONS(5926),
    [anon_sym_CARET] = ACTIONS(5924),
    [anon_sym_CARET_EQ] = ACTIONS(5926),
    [anon_sym_CARET_CARET] = ACTIONS(5924),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5926),
    [anon_sym_TILDE] = ACTIONS(5924),
    [anon_sym_TILDE_EQ] = ACTIONS(5926),
    [anon_sym_AT] = ACTIONS(5926),
    [sym_const] = ACTIONS(5926),
    [sym_delegate] = ACTIONS(5926),
    [sym_function] = ACTIONS(5926),
    [sym_immutable] = ACTIONS(5926),
    [sym_in] = ACTIONS(5924),
    [sym_inout] = ACTIONS(5926),
    [sym_is] = ACTIONS(5926),
    [sym_nothrow] = ACTIONS(5926),
    [sym_pure] = ACTIONS(5926),
    [sym_return] = ACTIONS(5926),
    [sym_scope] = ACTIONS(5926),
    [sym_shared] = ACTIONS(5926),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5926),
    [sym_not_is] = ACTIONS(5926),
  },
  [2719] = {
    [anon_sym_RBRACE] = ACTIONS(6867),
    [anon_sym_SLASH] = ACTIONS(6869),
    [anon_sym_SLASH_EQ] = ACTIONS(6867),
    [anon_sym_DOT] = ACTIONS(6867),
    [anon_sym_AMP] = ACTIONS(6869),
    [anon_sym_AMP_EQ] = ACTIONS(6867),
    [anon_sym_AMP_AMP] = ACTIONS(6867),
    [anon_sym_PIPE] = ACTIONS(6869),
    [anon_sym_PIPE_EQ] = ACTIONS(6867),
    [anon_sym_PIPE_PIPE] = ACTIONS(6867),
    [anon_sym_DASH] = ACTIONS(6869),
    [anon_sym_DASH_EQ] = ACTIONS(6867),
    [anon_sym_DASH_DASH] = ACTIONS(6867),
    [anon_sym_PLUS] = ACTIONS(6869),
    [anon_sym_PLUS_EQ] = ACTIONS(6867),
    [anon_sym_PLUS_PLUS] = ACTIONS(6867),
    [anon_sym_LT] = ACTIONS(6869),
    [anon_sym_LT_EQ] = ACTIONS(6867),
    [anon_sym_LT_LT] = ACTIONS(6869),
    [anon_sym_LT_LT_EQ] = ACTIONS(6867),
    [anon_sym_GT] = ACTIONS(6869),
    [anon_sym_GT_EQ] = ACTIONS(6867),
    [anon_sym_GT_GT_EQ] = ACTIONS(6867),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6867),
    [anon_sym_GT_GT] = ACTIONS(6869),
    [anon_sym_GT_GT_GT] = ACTIONS(6869),
    [anon_sym_BANG_EQ] = ACTIONS(6867),
    [anon_sym_LPAREN] = ACTIONS(6867),
    [anon_sym_RPAREN] = ACTIONS(6867),
    [anon_sym_LBRACK] = ACTIONS(6867),
    [anon_sym_RBRACK] = ACTIONS(6867),
    [anon_sym_QMARK] = ACTIONS(6867),
    [anon_sym_COMMA] = ACTIONS(6867),
    [anon_sym_SEMI] = ACTIONS(6867),
    [anon_sym_COLON] = ACTIONS(6867),
    [anon_sym_EQ] = ACTIONS(6869),
    [anon_sym_EQ_EQ] = ACTIONS(6867),
    [anon_sym_STAR] = ACTIONS(6869),
    [anon_sym_STAR_EQ] = ACTIONS(6867),
    [anon_sym_PERCENT] = ACTIONS(6869),
    [anon_sym_PERCENT_EQ] = ACTIONS(6867),
    [anon_sym_CARET] = ACTIONS(6869),
    [anon_sym_CARET_EQ] = ACTIONS(6867),
    [anon_sym_CARET_CARET] = ACTIONS(6869),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6867),
    [anon_sym_TILDE] = ACTIONS(6869),
    [anon_sym_TILDE_EQ] = ACTIONS(6867),
    [anon_sym_AT] = ACTIONS(6867),
    [sym_const] = ACTIONS(6867),
    [sym_delegate] = ACTIONS(6867),
    [sym_function] = ACTIONS(6867),
    [sym_immutable] = ACTIONS(6867),
    [sym_in] = ACTIONS(6869),
    [sym_inout] = ACTIONS(6867),
    [sym_is] = ACTIONS(6867),
    [sym_nothrow] = ACTIONS(6867),
    [sym_pure] = ACTIONS(6867),
    [sym_return] = ACTIONS(6867),
    [sym_scope] = ACTIONS(6867),
    [sym_shared] = ACTIONS(6867),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6867),
    [sym_not_is] = ACTIONS(6867),
  },
  [2720] = {
    [anon_sym_RBRACE] = ACTIONS(6871),
    [anon_sym_SLASH] = ACTIONS(6873),
    [anon_sym_SLASH_EQ] = ACTIONS(6871),
    [anon_sym_DOT] = ACTIONS(6871),
    [anon_sym_AMP] = ACTIONS(6873),
    [anon_sym_AMP_EQ] = ACTIONS(6871),
    [anon_sym_AMP_AMP] = ACTIONS(6871),
    [anon_sym_PIPE] = ACTIONS(6873),
    [anon_sym_PIPE_EQ] = ACTIONS(6871),
    [anon_sym_PIPE_PIPE] = ACTIONS(6871),
    [anon_sym_DASH] = ACTIONS(6873),
    [anon_sym_DASH_EQ] = ACTIONS(6871),
    [anon_sym_DASH_DASH] = ACTIONS(6871),
    [anon_sym_PLUS] = ACTIONS(6873),
    [anon_sym_PLUS_EQ] = ACTIONS(6871),
    [anon_sym_PLUS_PLUS] = ACTIONS(6871),
    [anon_sym_LT] = ACTIONS(6873),
    [anon_sym_LT_EQ] = ACTIONS(6871),
    [anon_sym_LT_LT] = ACTIONS(6873),
    [anon_sym_LT_LT_EQ] = ACTIONS(6871),
    [anon_sym_GT] = ACTIONS(6873),
    [anon_sym_GT_EQ] = ACTIONS(6871),
    [anon_sym_GT_GT_EQ] = ACTIONS(6871),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6871),
    [anon_sym_GT_GT] = ACTIONS(6873),
    [anon_sym_GT_GT_GT] = ACTIONS(6873),
    [anon_sym_BANG_EQ] = ACTIONS(6871),
    [anon_sym_LPAREN] = ACTIONS(6871),
    [anon_sym_RPAREN] = ACTIONS(6871),
    [anon_sym_LBRACK] = ACTIONS(6871),
    [anon_sym_RBRACK] = ACTIONS(6871),
    [anon_sym_QMARK] = ACTIONS(6871),
    [anon_sym_COMMA] = ACTIONS(6871),
    [anon_sym_SEMI] = ACTIONS(6871),
    [anon_sym_COLON] = ACTIONS(6871),
    [anon_sym_EQ] = ACTIONS(6873),
    [anon_sym_EQ_EQ] = ACTIONS(6871),
    [anon_sym_STAR] = ACTIONS(6873),
    [anon_sym_STAR_EQ] = ACTIONS(6871),
    [anon_sym_PERCENT] = ACTIONS(6873),
    [anon_sym_PERCENT_EQ] = ACTIONS(6871),
    [anon_sym_CARET] = ACTIONS(6873),
    [anon_sym_CARET_EQ] = ACTIONS(6871),
    [anon_sym_CARET_CARET] = ACTIONS(6873),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6871),
    [anon_sym_TILDE] = ACTIONS(6873),
    [anon_sym_TILDE_EQ] = ACTIONS(6871),
    [anon_sym_AT] = ACTIONS(6871),
    [sym_const] = ACTIONS(6871),
    [sym_delegate] = ACTIONS(6871),
    [sym_function] = ACTIONS(6871),
    [sym_immutable] = ACTIONS(6871),
    [sym_in] = ACTIONS(6873),
    [sym_inout] = ACTIONS(6871),
    [sym_is] = ACTIONS(6871),
    [sym_nothrow] = ACTIONS(6871),
    [sym_pure] = ACTIONS(6871),
    [sym_return] = ACTIONS(6871),
    [sym_scope] = ACTIONS(6871),
    [sym_shared] = ACTIONS(6871),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6871),
    [sym_not_is] = ACTIONS(6871),
  },
  [2721] = {
    [anon_sym_RBRACE] = ACTIONS(3095),
    [anon_sym_SLASH] = ACTIONS(3093),
    [anon_sym_SLASH_EQ] = ACTIONS(3095),
    [anon_sym_DOT] = ACTIONS(3095),
    [anon_sym_AMP] = ACTIONS(3093),
    [anon_sym_AMP_EQ] = ACTIONS(3095),
    [anon_sym_AMP_AMP] = ACTIONS(3095),
    [anon_sym_PIPE] = ACTIONS(3093),
    [anon_sym_PIPE_EQ] = ACTIONS(3095),
    [anon_sym_PIPE_PIPE] = ACTIONS(3095),
    [anon_sym_DASH] = ACTIONS(3093),
    [anon_sym_DASH_EQ] = ACTIONS(3095),
    [anon_sym_DASH_DASH] = ACTIONS(3095),
    [anon_sym_PLUS] = ACTIONS(3093),
    [anon_sym_PLUS_EQ] = ACTIONS(3095),
    [anon_sym_PLUS_PLUS] = ACTIONS(3095),
    [anon_sym_LT] = ACTIONS(3093),
    [anon_sym_LT_EQ] = ACTIONS(3095),
    [anon_sym_LT_LT] = ACTIONS(3093),
    [anon_sym_LT_LT_EQ] = ACTIONS(3095),
    [anon_sym_GT] = ACTIONS(3093),
    [anon_sym_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3095),
    [anon_sym_GT_GT] = ACTIONS(3093),
    [anon_sym_GT_GT_GT] = ACTIONS(3093),
    [anon_sym_BANG_EQ] = ACTIONS(3095),
    [anon_sym_LPAREN] = ACTIONS(3095),
    [anon_sym_RPAREN] = ACTIONS(3095),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_RBRACK] = ACTIONS(3095),
    [anon_sym_QMARK] = ACTIONS(3095),
    [anon_sym_COMMA] = ACTIONS(3095),
    [anon_sym_SEMI] = ACTIONS(3095),
    [anon_sym_COLON] = ACTIONS(3095),
    [anon_sym_EQ] = ACTIONS(3093),
    [anon_sym_EQ_EQ] = ACTIONS(3095),
    [anon_sym_STAR] = ACTIONS(3093),
    [anon_sym_STAR_EQ] = ACTIONS(3095),
    [anon_sym_PERCENT] = ACTIONS(3093),
    [anon_sym_PERCENT_EQ] = ACTIONS(3095),
    [anon_sym_CARET] = ACTIONS(3093),
    [anon_sym_CARET_EQ] = ACTIONS(3095),
    [anon_sym_CARET_CARET] = ACTIONS(3093),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3095),
    [anon_sym_TILDE] = ACTIONS(3093),
    [anon_sym_TILDE_EQ] = ACTIONS(3095),
    [anon_sym_AT] = ACTIONS(3095),
    [sym_const] = ACTIONS(3095),
    [sym_delegate] = ACTIONS(3095),
    [sym_function] = ACTIONS(3095),
    [sym_immutable] = ACTIONS(3095),
    [sym_in] = ACTIONS(3093),
    [sym_inout] = ACTIONS(3095),
    [sym_is] = ACTIONS(3095),
    [sym_nothrow] = ACTIONS(3095),
    [sym_pure] = ACTIONS(3095),
    [sym_return] = ACTIONS(3095),
    [sym_scope] = ACTIONS(3095),
    [sym_shared] = ACTIONS(3095),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3095),
    [sym_not_is] = ACTIONS(3095),
  },
  [2722] = {
    [anon_sym_RBRACE] = ACTIONS(6875),
    [anon_sym_SLASH] = ACTIONS(6877),
    [anon_sym_SLASH_EQ] = ACTIONS(6875),
    [anon_sym_DOT] = ACTIONS(6875),
    [anon_sym_AMP] = ACTIONS(6877),
    [anon_sym_AMP_EQ] = ACTIONS(6875),
    [anon_sym_AMP_AMP] = ACTIONS(6875),
    [anon_sym_PIPE] = ACTIONS(6877),
    [anon_sym_PIPE_EQ] = ACTIONS(6875),
    [anon_sym_PIPE_PIPE] = ACTIONS(6875),
    [anon_sym_DASH] = ACTIONS(6877),
    [anon_sym_DASH_EQ] = ACTIONS(6875),
    [anon_sym_DASH_DASH] = ACTIONS(6875),
    [anon_sym_PLUS] = ACTIONS(6877),
    [anon_sym_PLUS_EQ] = ACTIONS(6875),
    [anon_sym_PLUS_PLUS] = ACTIONS(6875),
    [anon_sym_LT] = ACTIONS(6877),
    [anon_sym_LT_EQ] = ACTIONS(6875),
    [anon_sym_LT_LT] = ACTIONS(6877),
    [anon_sym_LT_LT_EQ] = ACTIONS(6875),
    [anon_sym_GT] = ACTIONS(6877),
    [anon_sym_GT_EQ] = ACTIONS(6875),
    [anon_sym_GT_GT_EQ] = ACTIONS(6875),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6875),
    [anon_sym_GT_GT] = ACTIONS(6877),
    [anon_sym_GT_GT_GT] = ACTIONS(6877),
    [anon_sym_BANG_EQ] = ACTIONS(6875),
    [anon_sym_LPAREN] = ACTIONS(6875),
    [anon_sym_RPAREN] = ACTIONS(6875),
    [anon_sym_LBRACK] = ACTIONS(6875),
    [anon_sym_RBRACK] = ACTIONS(6875),
    [anon_sym_QMARK] = ACTIONS(6875),
    [anon_sym_COMMA] = ACTIONS(6875),
    [anon_sym_SEMI] = ACTIONS(6875),
    [anon_sym_COLON] = ACTIONS(6875),
    [anon_sym_EQ] = ACTIONS(6877),
    [anon_sym_EQ_EQ] = ACTIONS(6875),
    [anon_sym_STAR] = ACTIONS(6877),
    [anon_sym_STAR_EQ] = ACTIONS(6875),
    [anon_sym_PERCENT] = ACTIONS(6877),
    [anon_sym_PERCENT_EQ] = ACTIONS(6875),
    [anon_sym_CARET] = ACTIONS(6877),
    [anon_sym_CARET_EQ] = ACTIONS(6875),
    [anon_sym_CARET_CARET] = ACTIONS(6877),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6875),
    [anon_sym_TILDE] = ACTIONS(6877),
    [anon_sym_TILDE_EQ] = ACTIONS(6875),
    [anon_sym_AT] = ACTIONS(6875),
    [sym_const] = ACTIONS(6875),
    [sym_delegate] = ACTIONS(6875),
    [sym_function] = ACTIONS(6875),
    [sym_immutable] = ACTIONS(6875),
    [sym_in] = ACTIONS(6877),
    [sym_inout] = ACTIONS(6875),
    [sym_is] = ACTIONS(6875),
    [sym_nothrow] = ACTIONS(6875),
    [sym_pure] = ACTIONS(6875),
    [sym_return] = ACTIONS(6875),
    [sym_scope] = ACTIONS(6875),
    [sym_shared] = ACTIONS(6875),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6875),
    [sym_not_is] = ACTIONS(6875),
  },
  [2723] = {
    [anon_sym_RBRACE] = ACTIONS(6879),
    [anon_sym_SLASH] = ACTIONS(6881),
    [anon_sym_SLASH_EQ] = ACTIONS(6879),
    [anon_sym_DOT] = ACTIONS(6879),
    [anon_sym_AMP] = ACTIONS(6881),
    [anon_sym_AMP_EQ] = ACTIONS(6879),
    [anon_sym_AMP_AMP] = ACTIONS(6879),
    [anon_sym_PIPE] = ACTIONS(6881),
    [anon_sym_PIPE_EQ] = ACTIONS(6879),
    [anon_sym_PIPE_PIPE] = ACTIONS(6879),
    [anon_sym_DASH] = ACTIONS(6881),
    [anon_sym_DASH_EQ] = ACTIONS(6879),
    [anon_sym_DASH_DASH] = ACTIONS(6879),
    [anon_sym_PLUS] = ACTIONS(6881),
    [anon_sym_PLUS_EQ] = ACTIONS(6879),
    [anon_sym_PLUS_PLUS] = ACTIONS(6879),
    [anon_sym_LT] = ACTIONS(6881),
    [anon_sym_LT_EQ] = ACTIONS(6879),
    [anon_sym_LT_LT] = ACTIONS(6881),
    [anon_sym_LT_LT_EQ] = ACTIONS(6879),
    [anon_sym_GT] = ACTIONS(6881),
    [anon_sym_GT_EQ] = ACTIONS(6879),
    [anon_sym_GT_GT_EQ] = ACTIONS(6879),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6879),
    [anon_sym_GT_GT] = ACTIONS(6881),
    [anon_sym_GT_GT_GT] = ACTIONS(6881),
    [anon_sym_BANG_EQ] = ACTIONS(6879),
    [anon_sym_LPAREN] = ACTIONS(6879),
    [anon_sym_RPAREN] = ACTIONS(6879),
    [anon_sym_LBRACK] = ACTIONS(6879),
    [anon_sym_RBRACK] = ACTIONS(6879),
    [anon_sym_QMARK] = ACTIONS(6879),
    [anon_sym_COMMA] = ACTIONS(6879),
    [anon_sym_SEMI] = ACTIONS(6879),
    [anon_sym_COLON] = ACTIONS(6879),
    [anon_sym_EQ] = ACTIONS(6881),
    [anon_sym_EQ_EQ] = ACTIONS(6879),
    [anon_sym_STAR] = ACTIONS(6881),
    [anon_sym_STAR_EQ] = ACTIONS(6879),
    [anon_sym_PERCENT] = ACTIONS(6881),
    [anon_sym_PERCENT_EQ] = ACTIONS(6879),
    [anon_sym_CARET] = ACTIONS(6881),
    [anon_sym_CARET_EQ] = ACTIONS(6879),
    [anon_sym_CARET_CARET] = ACTIONS(6881),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6879),
    [anon_sym_TILDE] = ACTIONS(6881),
    [anon_sym_TILDE_EQ] = ACTIONS(6879),
    [anon_sym_AT] = ACTIONS(6879),
    [sym_const] = ACTIONS(6879),
    [sym_delegate] = ACTIONS(6879),
    [sym_function] = ACTIONS(6879),
    [sym_immutable] = ACTIONS(6879),
    [sym_in] = ACTIONS(6881),
    [sym_inout] = ACTIONS(6879),
    [sym_is] = ACTIONS(6879),
    [sym_nothrow] = ACTIONS(6879),
    [sym_pure] = ACTIONS(6879),
    [sym_return] = ACTIONS(6879),
    [sym_scope] = ACTIONS(6879),
    [sym_shared] = ACTIONS(6879),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6879),
    [sym_not_is] = ACTIONS(6879),
  },
  [2724] = {
    [anon_sym_RBRACE] = ACTIONS(6883),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_SLASH_EQ] = ACTIONS(6883),
    [anon_sym_DOT] = ACTIONS(6883),
    [anon_sym_AMP] = ACTIONS(6885),
    [anon_sym_AMP_EQ] = ACTIONS(6883),
    [anon_sym_AMP_AMP] = ACTIONS(6883),
    [anon_sym_PIPE] = ACTIONS(6885),
    [anon_sym_PIPE_EQ] = ACTIONS(6883),
    [anon_sym_PIPE_PIPE] = ACTIONS(6883),
    [anon_sym_DASH] = ACTIONS(6885),
    [anon_sym_DASH_EQ] = ACTIONS(6883),
    [anon_sym_DASH_DASH] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6885),
    [anon_sym_PLUS_EQ] = ACTIONS(6883),
    [anon_sym_PLUS_PLUS] = ACTIONS(6883),
    [anon_sym_LT] = ACTIONS(6885),
    [anon_sym_LT_EQ] = ACTIONS(6883),
    [anon_sym_LT_LT] = ACTIONS(6885),
    [anon_sym_LT_LT_EQ] = ACTIONS(6883),
    [anon_sym_GT] = ACTIONS(6885),
    [anon_sym_GT_EQ] = ACTIONS(6883),
    [anon_sym_GT_GT_EQ] = ACTIONS(6883),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(6883),
    [anon_sym_GT_GT] = ACTIONS(6885),
    [anon_sym_GT_GT_GT] = ACTIONS(6885),
    [anon_sym_BANG_EQ] = ACTIONS(6883),
    [anon_sym_LPAREN] = ACTIONS(6883),
    [anon_sym_RPAREN] = ACTIONS(6883),
    [anon_sym_LBRACK] = ACTIONS(6883),
    [anon_sym_RBRACK] = ACTIONS(6883),
    [anon_sym_QMARK] = ACTIONS(6883),
    [anon_sym_COMMA] = ACTIONS(6883),
    [anon_sym_SEMI] = ACTIONS(6883),
    [anon_sym_COLON] = ACTIONS(6883),
    [anon_sym_EQ] = ACTIONS(6885),
    [anon_sym_EQ_EQ] = ACTIONS(6883),
    [anon_sym_STAR] = ACTIONS(6885),
    [anon_sym_STAR_EQ] = ACTIONS(6883),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [anon_sym_PERCENT_EQ] = ACTIONS(6883),
    [anon_sym_CARET] = ACTIONS(6885),
    [anon_sym_CARET_EQ] = ACTIONS(6883),
    [anon_sym_CARET_CARET] = ACTIONS(6885),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(6883),
    [anon_sym_TILDE] = ACTIONS(6885),
    [anon_sym_TILDE_EQ] = ACTIONS(6883),
    [anon_sym_AT] = ACTIONS(6883),
    [sym_const] = ACTIONS(6883),
    [sym_delegate] = ACTIONS(6883),
    [sym_function] = ACTIONS(6883),
    [sym_immutable] = ACTIONS(6883),
    [sym_in] = ACTIONS(6885),
    [sym_inout] = ACTIONS(6883),
    [sym_is] = ACTIONS(6883),
    [sym_nothrow] = ACTIONS(6883),
    [sym_pure] = ACTIONS(6883),
    [sym_return] = ACTIONS(6883),
    [sym_scope] = ACTIONS(6883),
    [sym_shared] = ACTIONS(6883),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(6883),
    [sym_not_is] = ACTIONS(6883),
  },
  [2725] = {
    [anon_sym_RBRACE] = ACTIONS(5934),
    [anon_sym_SLASH] = ACTIONS(5932),
    [anon_sym_SLASH_EQ] = ACTIONS(5934),
    [anon_sym_DOT] = ACTIONS(5934),
    [anon_sym_AMP] = ACTIONS(5932),
    [anon_sym_AMP_EQ] = ACTIONS(5934),
    [anon_sym_AMP_AMP] = ACTIONS(5934),
    [anon_sym_PIPE] = ACTIONS(5932),
    [anon_sym_PIPE_EQ] = ACTIONS(5934),
    [anon_sym_PIPE_PIPE] = ACTIONS(5934),
    [anon_sym_DASH] = ACTIONS(5932),
    [anon_sym_DASH_EQ] = ACTIONS(5934),
    [anon_sym_DASH_DASH] = ACTIONS(5934),
    [anon_sym_PLUS] = ACTIONS(5932),
    [anon_sym_PLUS_EQ] = ACTIONS(5934),
    [anon_sym_PLUS_PLUS] = ACTIONS(5934),
    [anon_sym_LT] = ACTIONS(5932),
    [anon_sym_LT_EQ] = ACTIONS(5934),
    [anon_sym_LT_LT] = ACTIONS(5932),
    [anon_sym_LT_LT_EQ] = ACTIONS(5934),
    [anon_sym_GT] = ACTIONS(5932),
    [anon_sym_GT_EQ] = ACTIONS(5934),
    [anon_sym_GT_GT_EQ] = ACTIONS(5934),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5934),
    [anon_sym_GT_GT] = ACTIONS(5932),
    [anon_sym_GT_GT_GT] = ACTIONS(5932),
    [anon_sym_BANG_EQ] = ACTIONS(5934),
    [anon_sym_LPAREN] = ACTIONS(5934),
    [anon_sym_RPAREN] = ACTIONS(5934),
    [anon_sym_LBRACK] = ACTIONS(5934),
    [anon_sym_RBRACK] = ACTIONS(5934),
    [anon_sym_QMARK] = ACTIONS(5934),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_SEMI] = ACTIONS(5934),
    [anon_sym_COLON] = ACTIONS(5934),
    [anon_sym_EQ] = ACTIONS(5932),
    [anon_sym_EQ_EQ] = ACTIONS(5934),
    [anon_sym_STAR] = ACTIONS(5932),
    [anon_sym_STAR_EQ] = ACTIONS(5934),
    [anon_sym_PERCENT] = ACTIONS(5932),
    [anon_sym_PERCENT_EQ] = ACTIONS(5934),
    [anon_sym_CARET] = ACTIONS(5932),
    [anon_sym_CARET_EQ] = ACTIONS(5934),
    [anon_sym_CARET_CARET] = ACTIONS(5932),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5934),
    [anon_sym_TILDE] = ACTIONS(5932),
    [anon_sym_TILDE_EQ] = ACTIONS(5934),
    [anon_sym_AT] = ACTIONS(5934),
    [sym_const] = ACTIONS(5934),
    [sym_delegate] = ACTIONS(5934),
    [sym_function] = ACTIONS(5934),
    [sym_immutable] = ACTIONS(5934),
    [sym_in] = ACTIONS(5932),
    [sym_inout] = ACTIONS(5934),
    [sym_is] = ACTIONS(5934),
    [sym_nothrow] = ACTIONS(5934),
    [sym_pure] = ACTIONS(5934),
    [sym_return] = ACTIONS(5934),
    [sym_scope] = ACTIONS(5934),
    [sym_shared] = ACTIONS(5934),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5934),
    [sym_not_is] = ACTIONS(5934),
  },
  [2726] = {
    [anon_sym_RBRACE] = ACTIONS(5954),
    [anon_sym_SLASH] = ACTIONS(5952),
    [anon_sym_SLASH_EQ] = ACTIONS(5954),
    [anon_sym_DOT] = ACTIONS(5954),
    [anon_sym_AMP] = ACTIONS(5952),
    [anon_sym_AMP_EQ] = ACTIONS(5954),
    [anon_sym_AMP_AMP] = ACTIONS(5954),
    [anon_sym_PIPE] = ACTIONS(5952),
    [anon_sym_PIPE_EQ] = ACTIONS(5954),
    [anon_sym_PIPE_PIPE] = ACTIONS(5954),
    [anon_sym_DASH] = ACTIONS(5952),
    [anon_sym_DASH_EQ] = ACTIONS(5954),
    [anon_sym_DASH_DASH] = ACTIONS(5954),
    [anon_sym_PLUS] = ACTIONS(5952),
    [anon_sym_PLUS_EQ] = ACTIONS(5954),
    [anon_sym_PLUS_PLUS] = ACTIONS(5954),
    [anon_sym_LT] = ACTIONS(5952),
    [anon_sym_LT_EQ] = ACTIONS(5954),
    [anon_sym_LT_LT] = ACTIONS(5952),
    [anon_sym_LT_LT_EQ] = ACTIONS(5954),
    [anon_sym_GT] = ACTIONS(5952),
    [anon_sym_GT_EQ] = ACTIONS(5954),
    [anon_sym_GT_GT_EQ] = ACTIONS(5954),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5954),
    [anon_sym_GT_GT] = ACTIONS(5952),
    [anon_sym_GT_GT_GT] = ACTIONS(5952),
    [anon_sym_BANG_EQ] = ACTIONS(5954),
    [anon_sym_LPAREN] = ACTIONS(5954),
    [anon_sym_RPAREN] = ACTIONS(5954),
    [anon_sym_LBRACK] = ACTIONS(5954),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_QMARK] = ACTIONS(5954),
    [anon_sym_COMMA] = ACTIONS(5954),
    [anon_sym_SEMI] = ACTIONS(5954),
    [anon_sym_COLON] = ACTIONS(5954),
    [anon_sym_EQ] = ACTIONS(5952),
    [anon_sym_EQ_EQ] = ACTIONS(5954),
    [anon_sym_STAR] = ACTIONS(5952),
    [anon_sym_STAR_EQ] = ACTIONS(5954),
    [anon_sym_PERCENT] = ACTIONS(5952),
    [anon_sym_PERCENT_EQ] = ACTIONS(5954),
    [anon_sym_CARET] = ACTIONS(5952),
    [anon_sym_CARET_EQ] = ACTIONS(5954),
    [anon_sym_CARET_CARET] = ACTIONS(5952),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5954),
    [anon_sym_TILDE] = ACTIONS(5952),
    [anon_sym_TILDE_EQ] = ACTIONS(5954),
    [anon_sym_AT] = ACTIONS(5954),
    [sym_const] = ACTIONS(5954),
    [sym_delegate] = ACTIONS(5954),
    [sym_function] = ACTIONS(5954),
    [sym_immutable] = ACTIONS(5954),
    [sym_in] = ACTIONS(5952),
    [sym_inout] = ACTIONS(5954),
    [sym_is] = ACTIONS(5954),
    [sym_nothrow] = ACTIONS(5954),
    [sym_pure] = ACTIONS(5954),
    [sym_return] = ACTIONS(5954),
    [sym_scope] = ACTIONS(5954),
    [sym_shared] = ACTIONS(5954),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5954),
    [sym_not_is] = ACTIONS(5954),
  },
  [2727] = {
    [anon_sym_RBRACE] = ACTIONS(3115),
    [anon_sym_SLASH] = ACTIONS(3113),
    [anon_sym_SLASH_EQ] = ACTIONS(3115),
    [anon_sym_DOT] = ACTIONS(3115),
    [anon_sym_AMP] = ACTIONS(3113),
    [anon_sym_AMP_EQ] = ACTIONS(3115),
    [anon_sym_AMP_AMP] = ACTIONS(3115),
    [anon_sym_PIPE] = ACTIONS(3113),
    [anon_sym_PIPE_EQ] = ACTIONS(3115),
    [anon_sym_PIPE_PIPE] = ACTIONS(3115),
    [anon_sym_DASH] = ACTIONS(3113),
    [anon_sym_DASH_EQ] = ACTIONS(3115),
    [anon_sym_DASH_DASH] = ACTIONS(3115),
    [anon_sym_PLUS] = ACTIONS(3113),
    [anon_sym_PLUS_EQ] = ACTIONS(3115),
    [anon_sym_PLUS_PLUS] = ACTIONS(3115),
    [anon_sym_LT] = ACTIONS(3113),
    [anon_sym_LT_EQ] = ACTIONS(3115),
    [anon_sym_LT_LT] = ACTIONS(3113),
    [anon_sym_LT_LT_EQ] = ACTIONS(3115),
    [anon_sym_GT] = ACTIONS(3113),
    [anon_sym_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3115),
    [anon_sym_GT_GT] = ACTIONS(3113),
    [anon_sym_GT_GT_GT] = ACTIONS(3113),
    [anon_sym_BANG_EQ] = ACTIONS(3115),
    [anon_sym_LPAREN] = ACTIONS(3115),
    [anon_sym_RPAREN] = ACTIONS(3115),
    [anon_sym_LBRACK] = ACTIONS(3115),
    [anon_sym_RBRACK] = ACTIONS(3115),
    [anon_sym_QMARK] = ACTIONS(3115),
    [anon_sym_COMMA] = ACTIONS(3115),
    [anon_sym_SEMI] = ACTIONS(3115),
    [anon_sym_COLON] = ACTIONS(3115),
    [anon_sym_EQ] = ACTIONS(3113),
    [anon_sym_EQ_EQ] = ACTIONS(3115),
    [anon_sym_STAR] = ACTIONS(3113),
    [anon_sym_STAR_EQ] = ACTIONS(3115),
    [anon_sym_PERCENT] = ACTIONS(3113),
    [anon_sym_PERCENT_EQ] = ACTIONS(3115),
    [anon_sym_CARET] = ACTIONS(3113),
    [anon_sym_CARET_EQ] = ACTIONS(3115),
    [anon_sym_CARET_CARET] = ACTIONS(3113),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3115),
    [anon_sym_TILDE] = ACTIONS(3113),
    [anon_sym_TILDE_EQ] = ACTIONS(3115),
    [anon_sym_AT] = ACTIONS(3115),
    [sym_const] = ACTIONS(3115),
    [sym_delegate] = ACTIONS(3115),
    [sym_function] = ACTIONS(3115),
    [sym_immutable] = ACTIONS(3115),
    [sym_in] = ACTIONS(3113),
    [sym_inout] = ACTIONS(3115),
    [sym_is] = ACTIONS(3115),
    [sym_nothrow] = ACTIONS(3115),
    [sym_pure] = ACTIONS(3115),
    [sym_return] = ACTIONS(3115),
    [sym_scope] = ACTIONS(3115),
    [sym_shared] = ACTIONS(3115),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3115),
    [sym_not_is] = ACTIONS(3115),
  },
  [2728] = {
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_DOT] = ACTIONS(3059),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_GT_GT_GT] = ACTIONS(3057),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3059),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_CARET_CARET] = ACTIONS(3057),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3059),
    [anon_sym_TILDE] = ACTIONS(3057),
    [anon_sym_TILDE_EQ] = ACTIONS(3059),
    [anon_sym_AT] = ACTIONS(3059),
    [sym_const] = ACTIONS(3059),
    [sym_delegate] = ACTIONS(3059),
    [sym_function] = ACTIONS(3059),
    [sym_immutable] = ACTIONS(3059),
    [sym_in] = ACTIONS(3057),
    [sym_inout] = ACTIONS(3059),
    [sym_is] = ACTIONS(3059),
    [sym_nothrow] = ACTIONS(3059),
    [sym_pure] = ACTIONS(3059),
    [sym_return] = ACTIONS(3059),
    [sym_scope] = ACTIONS(3059),
    [sym_shared] = ACTIONS(3059),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3059),
    [sym_not_is] = ACTIONS(3059),
  },
  [2729] = {
    [anon_sym_RBRACE] = ACTIONS(5922),
    [anon_sym_SLASH] = ACTIONS(5920),
    [anon_sym_SLASH_EQ] = ACTIONS(5922),
    [anon_sym_DOT] = ACTIONS(5922),
    [anon_sym_AMP] = ACTIONS(5920),
    [anon_sym_AMP_EQ] = ACTIONS(5922),
    [anon_sym_AMP_AMP] = ACTIONS(5922),
    [anon_sym_PIPE] = ACTIONS(5920),
    [anon_sym_PIPE_EQ] = ACTIONS(5922),
    [anon_sym_PIPE_PIPE] = ACTIONS(5922),
    [anon_sym_DASH] = ACTIONS(5920),
    [anon_sym_DASH_EQ] = ACTIONS(5922),
    [anon_sym_DASH_DASH] = ACTIONS(5922),
    [anon_sym_PLUS] = ACTIONS(5920),
    [anon_sym_PLUS_EQ] = ACTIONS(5922),
    [anon_sym_PLUS_PLUS] = ACTIONS(5922),
    [anon_sym_LT] = ACTIONS(5920),
    [anon_sym_LT_EQ] = ACTIONS(5922),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_LT_LT_EQ] = ACTIONS(5922),
    [anon_sym_GT] = ACTIONS(5920),
    [anon_sym_GT_EQ] = ACTIONS(5922),
    [anon_sym_GT_GT_EQ] = ACTIONS(5922),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5922),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_GT_GT_GT] = ACTIONS(5920),
    [anon_sym_BANG_EQ] = ACTIONS(5922),
    [anon_sym_LPAREN] = ACTIONS(5922),
    [anon_sym_RPAREN] = ACTIONS(5922),
    [anon_sym_LBRACK] = ACTIONS(5922),
    [anon_sym_RBRACK] = ACTIONS(5922),
    [anon_sym_QMARK] = ACTIONS(5922),
    [anon_sym_COMMA] = ACTIONS(5922),
    [anon_sym_SEMI] = ACTIONS(5922),
    [anon_sym_COLON] = ACTIONS(5922),
    [anon_sym_EQ] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_STAR] = ACTIONS(5920),
    [anon_sym_STAR_EQ] = ACTIONS(5922),
    [anon_sym_PERCENT] = ACTIONS(5920),
    [anon_sym_PERCENT_EQ] = ACTIONS(5922),
    [anon_sym_CARET] = ACTIONS(5920),
    [anon_sym_CARET_EQ] = ACTIONS(5922),
    [anon_sym_CARET_CARET] = ACTIONS(5920),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5922),
    [anon_sym_TILDE] = ACTIONS(5920),
    [anon_sym_TILDE_EQ] = ACTIONS(5922),
    [anon_sym_AT] = ACTIONS(5922),
    [sym_const] = ACTIONS(5922),
    [sym_delegate] = ACTIONS(5922),
    [sym_function] = ACTIONS(5922),
    [sym_immutable] = ACTIONS(5922),
    [sym_in] = ACTIONS(5920),
    [sym_inout] = ACTIONS(5922),
    [sym_is] = ACTIONS(5922),
    [sym_nothrow] = ACTIONS(5922),
    [sym_pure] = ACTIONS(5922),
    [sym_return] = ACTIONS(5922),
    [sym_scope] = ACTIONS(5922),
    [sym_shared] = ACTIONS(5922),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5922),
    [sym_not_is] = ACTIONS(5922),
  },
  [2730] = {
    [anon_sym_RBRACE] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3065),
    [anon_sym_SLASH_EQ] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3065),
    [anon_sym_AMP_EQ] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3065),
    [anon_sym_PIPE_EQ] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3065),
    [anon_sym_DASH_EQ] = ACTIONS(3067),
    [anon_sym_DASH_DASH] = ACTIONS(3067),
    [anon_sym_PLUS] = ACTIONS(3065),
    [anon_sym_PLUS_EQ] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3065),
    [anon_sym_LT_EQ] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3065),
    [anon_sym_LT_LT_EQ] = ACTIONS(3067),
    [anon_sym_GT] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3065),
    [anon_sym_GT_GT_GT] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3067),
    [anon_sym_LPAREN] = ACTIONS(3067),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3067),
    [anon_sym_RBRACK] = ACTIONS(3067),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3067),
    [anon_sym_SEMI] = ACTIONS(3067),
    [anon_sym_COLON] = ACTIONS(3067),
    [anon_sym_EQ] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3065),
    [anon_sym_STAR_EQ] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3065),
    [anon_sym_PERCENT_EQ] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3065),
    [anon_sym_CARET_EQ] = ACTIONS(3067),
    [anon_sym_CARET_CARET] = ACTIONS(3065),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3067),
    [anon_sym_TILDE] = ACTIONS(3065),
    [anon_sym_TILDE_EQ] = ACTIONS(3067),
    [anon_sym_AT] = ACTIONS(3067),
    [sym_const] = ACTIONS(3067),
    [sym_delegate] = ACTIONS(3067),
    [sym_function] = ACTIONS(3067),
    [sym_immutable] = ACTIONS(3067),
    [sym_in] = ACTIONS(3065),
    [sym_inout] = ACTIONS(3067),
    [sym_is] = ACTIONS(3067),
    [sym_nothrow] = ACTIONS(3067),
    [sym_pure] = ACTIONS(3067),
    [sym_return] = ACTIONS(3067),
    [sym_scope] = ACTIONS(3067),
    [sym_shared] = ACTIONS(3067),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3067),
    [sym_not_is] = ACTIONS(3067),
  },
  [2731] = {
    [anon_sym_RBRACE] = ACTIONS(3043),
    [anon_sym_SLASH] = ACTIONS(3041),
    [anon_sym_SLASH_EQ] = ACTIONS(3043),
    [anon_sym_DOT] = ACTIONS(3043),
    [anon_sym_AMP] = ACTIONS(3041),
    [anon_sym_AMP_EQ] = ACTIONS(3043),
    [anon_sym_AMP_AMP] = ACTIONS(3043),
    [anon_sym_PIPE] = ACTIONS(3041),
    [anon_sym_PIPE_EQ] = ACTIONS(3043),
    [anon_sym_PIPE_PIPE] = ACTIONS(3043),
    [anon_sym_DASH] = ACTIONS(3041),
    [anon_sym_DASH_EQ] = ACTIONS(3043),
    [anon_sym_DASH_DASH] = ACTIONS(3043),
    [anon_sym_PLUS] = ACTIONS(3041),
    [anon_sym_PLUS_EQ] = ACTIONS(3043),
    [anon_sym_PLUS_PLUS] = ACTIONS(3043),
    [anon_sym_LT] = ACTIONS(3041),
    [anon_sym_LT_EQ] = ACTIONS(3043),
    [anon_sym_LT_LT] = ACTIONS(3041),
    [anon_sym_LT_LT_EQ] = ACTIONS(3043),
    [anon_sym_GT] = ACTIONS(3041),
    [anon_sym_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3043),
    [anon_sym_GT_GT] = ACTIONS(3041),
    [anon_sym_GT_GT_GT] = ACTIONS(3041),
    [anon_sym_BANG_EQ] = ACTIONS(3043),
    [anon_sym_LPAREN] = ACTIONS(3043),
    [anon_sym_RPAREN] = ACTIONS(3043),
    [anon_sym_LBRACK] = ACTIONS(3043),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [anon_sym_QMARK] = ACTIONS(3043),
    [anon_sym_COMMA] = ACTIONS(3043),
    [anon_sym_SEMI] = ACTIONS(3043),
    [anon_sym_COLON] = ACTIONS(3043),
    [anon_sym_EQ] = ACTIONS(3041),
    [anon_sym_EQ_EQ] = ACTIONS(3043),
    [anon_sym_STAR] = ACTIONS(3041),
    [anon_sym_STAR_EQ] = ACTIONS(3043),
    [anon_sym_PERCENT] = ACTIONS(3041),
    [anon_sym_PERCENT_EQ] = ACTIONS(3043),
    [anon_sym_CARET] = ACTIONS(3041),
    [anon_sym_CARET_EQ] = ACTIONS(3043),
    [anon_sym_CARET_CARET] = ACTIONS(3041),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3043),
    [anon_sym_TILDE] = ACTIONS(3041),
    [anon_sym_TILDE_EQ] = ACTIONS(3043),
    [anon_sym_AT] = ACTIONS(3043),
    [sym_const] = ACTIONS(3043),
    [sym_delegate] = ACTIONS(3043),
    [sym_function] = ACTIONS(3043),
    [sym_immutable] = ACTIONS(3043),
    [sym_in] = ACTIONS(3041),
    [sym_inout] = ACTIONS(3043),
    [sym_is] = ACTIONS(3043),
    [sym_nothrow] = ACTIONS(3043),
    [sym_pure] = ACTIONS(3043),
    [sym_return] = ACTIONS(3043),
    [sym_scope] = ACTIONS(3043),
    [sym_shared] = ACTIONS(3043),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3043),
    [sym_not_is] = ACTIONS(3043),
  },
  [2732] = {
    [anon_sym_RBRACE] = ACTIONS(3055),
    [anon_sym_SLASH] = ACTIONS(3053),
    [anon_sym_SLASH_EQ] = ACTIONS(3055),
    [anon_sym_DOT] = ACTIONS(3055),
    [anon_sym_AMP] = ACTIONS(3053),
    [anon_sym_AMP_EQ] = ACTIONS(3055),
    [anon_sym_AMP_AMP] = ACTIONS(3055),
    [anon_sym_PIPE] = ACTIONS(3053),
    [anon_sym_PIPE_EQ] = ACTIONS(3055),
    [anon_sym_PIPE_PIPE] = ACTIONS(3055),
    [anon_sym_DASH] = ACTIONS(3053),
    [anon_sym_DASH_EQ] = ACTIONS(3055),
    [anon_sym_DASH_DASH] = ACTIONS(3055),
    [anon_sym_PLUS] = ACTIONS(3053),
    [anon_sym_PLUS_EQ] = ACTIONS(3055),
    [anon_sym_PLUS_PLUS] = ACTIONS(3055),
    [anon_sym_LT] = ACTIONS(3053),
    [anon_sym_LT_EQ] = ACTIONS(3055),
    [anon_sym_LT_LT] = ACTIONS(3053),
    [anon_sym_LT_LT_EQ] = ACTIONS(3055),
    [anon_sym_GT] = ACTIONS(3053),
    [anon_sym_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3055),
    [anon_sym_GT_GT] = ACTIONS(3053),
    [anon_sym_GT_GT_GT] = ACTIONS(3053),
    [anon_sym_BANG_EQ] = ACTIONS(3055),
    [anon_sym_LPAREN] = ACTIONS(3055),
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_LBRACK] = ACTIONS(3055),
    [anon_sym_RBRACK] = ACTIONS(3055),
    [anon_sym_QMARK] = ACTIONS(3055),
    [anon_sym_COMMA] = ACTIONS(3055),
    [anon_sym_SEMI] = ACTIONS(3055),
    [anon_sym_COLON] = ACTIONS(3055),
    [anon_sym_EQ] = ACTIONS(3053),
    [anon_sym_EQ_EQ] = ACTIONS(3055),
    [anon_sym_STAR] = ACTIONS(3053),
    [anon_sym_STAR_EQ] = ACTIONS(3055),
    [anon_sym_PERCENT] = ACTIONS(3053),
    [anon_sym_PERCENT_EQ] = ACTIONS(3055),
    [anon_sym_CARET] = ACTIONS(3053),
    [anon_sym_CARET_EQ] = ACTIONS(3055),
    [anon_sym_CARET_CARET] = ACTIONS(3053),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3055),
    [anon_sym_TILDE] = ACTIONS(3053),
    [anon_sym_TILDE_EQ] = ACTIONS(3055),
    [anon_sym_AT] = ACTIONS(3055),
    [sym_const] = ACTIONS(3055),
    [sym_delegate] = ACTIONS(3055),
    [sym_function] = ACTIONS(3055),
    [sym_immutable] = ACTIONS(3055),
    [sym_in] = ACTIONS(3053),
    [sym_inout] = ACTIONS(3055),
    [sym_is] = ACTIONS(3055),
    [sym_nothrow] = ACTIONS(3055),
    [sym_pure] = ACTIONS(3055),
    [sym_return] = ACTIONS(3055),
    [sym_scope] = ACTIONS(3055),
    [sym_shared] = ACTIONS(3055),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3055),
    [sym_not_is] = ACTIONS(3055),
  },
  [2733] = {
    [anon_sym_RBRACE] = ACTIONS(5942),
    [anon_sym_SLASH] = ACTIONS(5940),
    [anon_sym_SLASH_EQ] = ACTIONS(5942),
    [anon_sym_DOT] = ACTIONS(5942),
    [anon_sym_AMP] = ACTIONS(5940),
    [anon_sym_AMP_EQ] = ACTIONS(5942),
    [anon_sym_AMP_AMP] = ACTIONS(5942),
    [anon_sym_PIPE] = ACTIONS(5940),
    [anon_sym_PIPE_EQ] = ACTIONS(5942),
    [anon_sym_PIPE_PIPE] = ACTIONS(5942),
    [anon_sym_DASH] = ACTIONS(5940),
    [anon_sym_DASH_EQ] = ACTIONS(5942),
    [anon_sym_DASH_DASH] = ACTIONS(5942),
    [anon_sym_PLUS] = ACTIONS(5940),
    [anon_sym_PLUS_EQ] = ACTIONS(5942),
    [anon_sym_PLUS_PLUS] = ACTIONS(5942),
    [anon_sym_LT] = ACTIONS(5940),
    [anon_sym_LT_EQ] = ACTIONS(5942),
    [anon_sym_LT_LT] = ACTIONS(5940),
    [anon_sym_LT_LT_EQ] = ACTIONS(5942),
    [anon_sym_GT] = ACTIONS(5940),
    [anon_sym_GT_EQ] = ACTIONS(5942),
    [anon_sym_GT_GT_EQ] = ACTIONS(5942),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5942),
    [anon_sym_GT_GT] = ACTIONS(5940),
    [anon_sym_GT_GT_GT] = ACTIONS(5940),
    [anon_sym_BANG_EQ] = ACTIONS(5942),
    [anon_sym_LPAREN] = ACTIONS(5942),
    [anon_sym_RPAREN] = ACTIONS(5942),
    [anon_sym_LBRACK] = ACTIONS(5942),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_QMARK] = ACTIONS(5942),
    [anon_sym_COMMA] = ACTIONS(5942),
    [anon_sym_SEMI] = ACTIONS(5942),
    [anon_sym_COLON] = ACTIONS(5942),
    [anon_sym_EQ] = ACTIONS(5940),
    [anon_sym_EQ_EQ] = ACTIONS(5942),
    [anon_sym_STAR] = ACTIONS(5940),
    [anon_sym_STAR_EQ] = ACTIONS(5942),
    [anon_sym_PERCENT] = ACTIONS(5940),
    [anon_sym_PERCENT_EQ] = ACTIONS(5942),
    [anon_sym_CARET] = ACTIONS(5940),
    [anon_sym_CARET_EQ] = ACTIONS(5942),
    [anon_sym_CARET_CARET] = ACTIONS(5940),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5942),
    [anon_sym_TILDE] = ACTIONS(5940),
    [anon_sym_TILDE_EQ] = ACTIONS(5942),
    [anon_sym_AT] = ACTIONS(5942),
    [sym_const] = ACTIONS(5942),
    [sym_delegate] = ACTIONS(5942),
    [sym_function] = ACTIONS(5942),
    [sym_immutable] = ACTIONS(5942),
    [sym_in] = ACTIONS(5940),
    [sym_inout] = ACTIONS(5942),
    [sym_is] = ACTIONS(5942),
    [sym_nothrow] = ACTIONS(5942),
    [sym_pure] = ACTIONS(5942),
    [sym_return] = ACTIONS(5942),
    [sym_scope] = ACTIONS(5942),
    [sym_shared] = ACTIONS(5942),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5942),
    [sym_not_is] = ACTIONS(5942),
  },
  [2734] = {
    [anon_sym_RBRACE] = ACTIONS(3079),
    [anon_sym_SLASH] = ACTIONS(3077),
    [anon_sym_SLASH_EQ] = ACTIONS(3079),
    [anon_sym_DOT] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_AMP_EQ] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_PIPE] = ACTIONS(3077),
    [anon_sym_PIPE_EQ] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [anon_sym_DASH] = ACTIONS(3077),
    [anon_sym_DASH_EQ] = ACTIONS(3079),
    [anon_sym_DASH_DASH] = ACTIONS(3079),
    [anon_sym_PLUS] = ACTIONS(3077),
    [anon_sym_PLUS_EQ] = ACTIONS(3079),
    [anon_sym_PLUS_PLUS] = ACTIONS(3079),
    [anon_sym_LT] = ACTIONS(3077),
    [anon_sym_LT_EQ] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3077),
    [anon_sym_LT_LT_EQ] = ACTIONS(3079),
    [anon_sym_GT] = ACTIONS(3077),
    [anon_sym_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3079),
    [anon_sym_GT_GT] = ACTIONS(3077),
    [anon_sym_GT_GT_GT] = ACTIONS(3077),
    [anon_sym_BANG_EQ] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(3079),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_LBRACK] = ACTIONS(3079),
    [anon_sym_RBRACK] = ACTIONS(3079),
    [anon_sym_QMARK] = ACTIONS(3079),
    [anon_sym_COMMA] = ACTIONS(3079),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_COLON] = ACTIONS(3079),
    [anon_sym_EQ] = ACTIONS(3077),
    [anon_sym_EQ_EQ] = ACTIONS(3079),
    [anon_sym_STAR] = ACTIONS(3077),
    [anon_sym_STAR_EQ] = ACTIONS(3079),
    [anon_sym_PERCENT] = ACTIONS(3077),
    [anon_sym_PERCENT_EQ] = ACTIONS(3079),
    [anon_sym_CARET] = ACTIONS(3077),
    [anon_sym_CARET_EQ] = ACTIONS(3079),
    [anon_sym_CARET_CARET] = ACTIONS(3077),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3079),
    [anon_sym_TILDE] = ACTIONS(3077),
    [anon_sym_TILDE_EQ] = ACTIONS(3079),
    [anon_sym_AT] = ACTIONS(3079),
    [sym_const] = ACTIONS(3079),
    [sym_delegate] = ACTIONS(3079),
    [sym_function] = ACTIONS(3079),
    [sym_immutable] = ACTIONS(3079),
    [sym_in] = ACTIONS(3077),
    [sym_inout] = ACTIONS(3079),
    [sym_is] = ACTIONS(3079),
    [sym_nothrow] = ACTIONS(3079),
    [sym_pure] = ACTIONS(3079),
    [sym_return] = ACTIONS(3079),
    [sym_scope] = ACTIONS(3079),
    [sym_shared] = ACTIONS(3079),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3079),
    [sym_not_is] = ACTIONS(3079),
  },
  [2735] = {
    [anon_sym_RBRACE] = ACTIONS(3103),
    [anon_sym_SLASH] = ACTIONS(3101),
    [anon_sym_SLASH_EQ] = ACTIONS(3103),
    [anon_sym_DOT] = ACTIONS(3103),
    [anon_sym_AMP] = ACTIONS(3101),
    [anon_sym_AMP_EQ] = ACTIONS(3103),
    [anon_sym_AMP_AMP] = ACTIONS(3103),
    [anon_sym_PIPE] = ACTIONS(3101),
    [anon_sym_PIPE_EQ] = ACTIONS(3103),
    [anon_sym_PIPE_PIPE] = ACTIONS(3103),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_DASH_EQ] = ACTIONS(3103),
    [anon_sym_DASH_DASH] = ACTIONS(3103),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_PLUS_EQ] = ACTIONS(3103),
    [anon_sym_PLUS_PLUS] = ACTIONS(3103),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_LT_EQ] = ACTIONS(3103),
    [anon_sym_LT_LT] = ACTIONS(3101),
    [anon_sym_LT_LT_EQ] = ACTIONS(3103),
    [anon_sym_GT] = ACTIONS(3101),
    [anon_sym_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3103),
    [anon_sym_GT_GT] = ACTIONS(3101),
    [anon_sym_GT_GT_GT] = ACTIONS(3101),
    [anon_sym_BANG_EQ] = ACTIONS(3103),
    [anon_sym_LPAREN] = ACTIONS(3103),
    [anon_sym_RPAREN] = ACTIONS(3103),
    [anon_sym_LBRACK] = ACTIONS(3103),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [anon_sym_QMARK] = ACTIONS(3103),
    [anon_sym_COMMA] = ACTIONS(3103),
    [anon_sym_SEMI] = ACTIONS(3103),
    [anon_sym_COLON] = ACTIONS(3103),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_EQ_EQ] = ACTIONS(3103),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_STAR_EQ] = ACTIONS(3103),
    [anon_sym_PERCENT] = ACTIONS(3101),
    [anon_sym_PERCENT_EQ] = ACTIONS(3103),
    [anon_sym_CARET] = ACTIONS(3101),
    [anon_sym_CARET_EQ] = ACTIONS(3103),
    [anon_sym_CARET_CARET] = ACTIONS(3101),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3103),
    [anon_sym_TILDE] = ACTIONS(3101),
    [anon_sym_TILDE_EQ] = ACTIONS(3103),
    [anon_sym_AT] = ACTIONS(3103),
    [sym_const] = ACTIONS(3103),
    [sym_delegate] = ACTIONS(3103),
    [sym_function] = ACTIONS(3103),
    [sym_immutable] = ACTIONS(3103),
    [sym_in] = ACTIONS(3101),
    [sym_inout] = ACTIONS(3103),
    [sym_is] = ACTIONS(3103),
    [sym_nothrow] = ACTIONS(3103),
    [sym_pure] = ACTIONS(3103),
    [sym_return] = ACTIONS(3103),
    [sym_scope] = ACTIONS(3103),
    [sym_shared] = ACTIONS(3103),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3103),
    [sym_not_is] = ACTIONS(3103),
  },
  [2736] = {
    [anon_sym_RBRACE] = ACTIONS(5938),
    [anon_sym_SLASH] = ACTIONS(5936),
    [anon_sym_SLASH_EQ] = ACTIONS(5938),
    [anon_sym_DOT] = ACTIONS(5938),
    [anon_sym_AMP] = ACTIONS(5936),
    [anon_sym_AMP_EQ] = ACTIONS(5938),
    [anon_sym_AMP_AMP] = ACTIONS(5938),
    [anon_sym_PIPE] = ACTIONS(5936),
    [anon_sym_PIPE_EQ] = ACTIONS(5938),
    [anon_sym_PIPE_PIPE] = ACTIONS(5938),
    [anon_sym_DASH] = ACTIONS(5936),
    [anon_sym_DASH_EQ] = ACTIONS(5938),
    [anon_sym_DASH_DASH] = ACTIONS(5938),
    [anon_sym_PLUS] = ACTIONS(5936),
    [anon_sym_PLUS_EQ] = ACTIONS(5938),
    [anon_sym_PLUS_PLUS] = ACTIONS(5938),
    [anon_sym_LT] = ACTIONS(5936),
    [anon_sym_LT_EQ] = ACTIONS(5938),
    [anon_sym_LT_LT] = ACTIONS(5936),
    [anon_sym_LT_LT_EQ] = ACTIONS(5938),
    [anon_sym_GT] = ACTIONS(5936),
    [anon_sym_GT_EQ] = ACTIONS(5938),
    [anon_sym_GT_GT_EQ] = ACTIONS(5938),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5938),
    [anon_sym_GT_GT] = ACTIONS(5936),
    [anon_sym_GT_GT_GT] = ACTIONS(5936),
    [anon_sym_BANG_EQ] = ACTIONS(5938),
    [anon_sym_LPAREN] = ACTIONS(5938),
    [anon_sym_RPAREN] = ACTIONS(5938),
    [anon_sym_LBRACK] = ACTIONS(5938),
    [anon_sym_RBRACK] = ACTIONS(5938),
    [anon_sym_QMARK] = ACTIONS(5938),
    [anon_sym_COMMA] = ACTIONS(5938),
    [anon_sym_SEMI] = ACTIONS(5938),
    [anon_sym_COLON] = ACTIONS(5938),
    [anon_sym_EQ] = ACTIONS(5936),
    [anon_sym_EQ_EQ] = ACTIONS(5938),
    [anon_sym_STAR] = ACTIONS(5936),
    [anon_sym_STAR_EQ] = ACTIONS(5938),
    [anon_sym_PERCENT] = ACTIONS(5936),
    [anon_sym_PERCENT_EQ] = ACTIONS(5938),
    [anon_sym_CARET] = ACTIONS(5936),
    [anon_sym_CARET_EQ] = ACTIONS(5938),
    [anon_sym_CARET_CARET] = ACTIONS(5936),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(5938),
    [anon_sym_TILDE] = ACTIONS(5936),
    [anon_sym_TILDE_EQ] = ACTIONS(5938),
    [anon_sym_AT] = ACTIONS(5938),
    [sym_const] = ACTIONS(5938),
    [sym_delegate] = ACTIONS(5938),
    [sym_function] = ACTIONS(5938),
    [sym_immutable] = ACTIONS(5938),
    [sym_in] = ACTIONS(5936),
    [sym_inout] = ACTIONS(5938),
    [sym_is] = ACTIONS(5938),
    [sym_nothrow] = ACTIONS(5938),
    [sym_pure] = ACTIONS(5938),
    [sym_return] = ACTIONS(5938),
    [sym_scope] = ACTIONS(5938),
    [sym_shared] = ACTIONS(5938),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(5938),
    [sym_not_is] = ACTIONS(5938),
  },
  [2737] = {
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_SLASH] = ACTIONS(3097),
    [anon_sym_SLASH_EQ] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(3097),
    [anon_sym_AMP_EQ] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(3097),
    [anon_sym_PIPE_EQ] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3097),
    [anon_sym_DASH_EQ] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3097),
    [anon_sym_PLUS_EQ] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_LT] = ACTIONS(3097),
    [anon_sym_LT_EQ] = ACTIONS(3099),
    [anon_sym_LT_LT] = ACTIONS(3097),
    [anon_sym_LT_LT_EQ] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(3097),
    [anon_sym_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3099),
    [anon_sym_GT_GT] = ACTIONS(3097),
    [anon_sym_GT_GT_GT] = ACTIONS(3097),
    [anon_sym_BANG_EQ] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3097),
    [anon_sym_EQ_EQ] = ACTIONS(3099),
    [anon_sym_STAR] = ACTIONS(3097),
    [anon_sym_STAR_EQ] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3097),
    [anon_sym_PERCENT_EQ] = ACTIONS(3099),
    [anon_sym_CARET] = ACTIONS(3097),
    [anon_sym_CARET_EQ] = ACTIONS(3099),
    [anon_sym_CARET_CARET] = ACTIONS(3097),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3099),
    [anon_sym_TILDE] = ACTIONS(3097),
    [anon_sym_TILDE_EQ] = ACTIONS(3099),
    [anon_sym_AT] = ACTIONS(3099),
    [sym_const] = ACTIONS(3099),
    [sym_delegate] = ACTIONS(3099),
    [sym_function] = ACTIONS(3099),
    [sym_immutable] = ACTIONS(3099),
    [sym_in] = ACTIONS(3097),
    [sym_inout] = ACTIONS(3099),
    [sym_is] = ACTIONS(3099),
    [sym_nothrow] = ACTIONS(3099),
    [sym_pure] = ACTIONS(3099),
    [sym_return] = ACTIONS(3099),
    [sym_scope] = ACTIONS(3099),
    [sym_shared] = ACTIONS(3099),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3099),
    [sym_not_is] = ACTIONS(3099),
  },
  [2738] = {
    [anon_sym_RBRACE] = ACTIONS(3039),
    [anon_sym_SLASH] = ACTIONS(3037),
    [anon_sym_SLASH_EQ] = ACTIONS(3039),
    [anon_sym_DOT] = ACTIONS(3039),
    [anon_sym_AMP] = ACTIONS(3037),
    [anon_sym_AMP_EQ] = ACTIONS(3039),
    [anon_sym_AMP_AMP] = ACTIONS(3039),
    [anon_sym_PIPE] = ACTIONS(3037),
    [anon_sym_PIPE_EQ] = ACTIONS(3039),
    [anon_sym_PIPE_PIPE] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(3037),
    [anon_sym_DASH_EQ] = ACTIONS(3039),
    [anon_sym_DASH_DASH] = ACTIONS(3039),
    [anon_sym_PLUS] = ACTIONS(3037),
    [anon_sym_PLUS_EQ] = ACTIONS(3039),
    [anon_sym_PLUS_PLUS] = ACTIONS(3039),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3039),
    [anon_sym_LT_LT] = ACTIONS(3037),
    [anon_sym_LT_LT_EQ] = ACTIONS(3039),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(3039),
    [anon_sym_GT_GT] = ACTIONS(3037),
    [anon_sym_GT_GT_GT] = ACTIONS(3037),
    [anon_sym_BANG_EQ] = ACTIONS(3039),
    [anon_sym_LPAREN] = ACTIONS(3039),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_LBRACK] = ACTIONS(3039),
    [anon_sym_RBRACK] = ACTIONS(3039),
    [anon_sym_QMARK] = ACTIONS(3039),
    [anon_sym_COMMA] = ACTIONS(3039),
    [anon_sym_SEMI] = ACTIONS(3039),
    [anon_sym_COLON] = ACTIONS(3039),
    [anon_sym_EQ] = ACTIONS(3037),
    [anon_sym_EQ_EQ] = ACTIONS(3039),
    [anon_sym_STAR] = ACTIONS(3037),
    [anon_sym_STAR_EQ] = ACTIONS(3039),
    [anon_sym_PERCENT] = ACTIONS(3037),
    [anon_sym_PERCENT_EQ] = ACTIONS(3039),
    [anon_sym_CARET] = ACTIONS(3037),
    [anon_sym_CARET_EQ] = ACTIONS(3039),
    [anon_sym_CARET_CARET] = ACTIONS(3037),
    [anon_sym_CARET_CARET_EQ] = ACTIONS(3039),
    [anon_sym_TILDE] = ACTIONS(3037),
    [anon_sym_TILDE_EQ] = ACTIONS(3039),
    [anon_sym_AT] = ACTIONS(3039),
    [sym_const] = ACTIONS(3039),
    [sym_delegate] = ACTIONS(3039),
    [sym_function] = ACTIONS(3039),
    [sym_immutable] = ACTIONS(3039),
    [sym_in] = ACTIONS(3037),
    [sym_inout] = ACTIONS(3039),
    [sym_is] = ACTIONS(3039),
    [sym_nothrow] = ACTIONS(3039),
    [sym_pure] = ACTIONS(3039),
    [sym_return] = ACTIONS(3039),
    [sym_scope] = ACTIONS(3039),
    [sym_shared] = ACTIONS(3039),
    [sym_end_file] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_directive] = ACTIONS(3),
    [sym_not_in] = ACTIONS(3039),
    [sym_not_is] = ACTIONS(3039),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6889), 1,
      anon_sym_RBRACE,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [105] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6893), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [210] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6895), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [315] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6897), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [420] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6899), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [525] = 7,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4133), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [604] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6901), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [709] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6903), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [814] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6905), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [919] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6907), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1024] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6909), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1129] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6911), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1234] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6913), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1339] = 5,
    ACTIONS(6850), 1,
      anon_sym_LPAREN,
    STATE(2772), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5926), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [1414] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6915), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1519] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6917), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1624] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6919), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1729] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6921), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1834] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6923), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [1939] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6925), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [2044] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6927), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [2149] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(6929), 1,
      anon_sym_RBRACE,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [2254] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3061), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3063), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2324] = 5,
    ACTIONS(6865), 1,
      anon_sym_LPAREN,
    STATE(2829), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5926), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2398] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5948), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5950), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2468] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4977), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [2570] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6877), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6875), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2640] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5936), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5938), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2710] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5944), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5946), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2780] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6885), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6883), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2850] = 6,
    ACTIONS(6931), 1,
      anon_sym_AT,
    ACTIONS(6933), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2795), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6794), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6792), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [2926] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5940), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5942), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [2996] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6861), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6859), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3066] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5952), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5954), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3136] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5920), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5922), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3206] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5152), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [3308] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5932), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5934), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3378] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5016), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [3480] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3065), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3067), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3550] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5196), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [3652] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3077), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3079), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3722] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3113), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3115), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3792] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3041), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3043), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [3862] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4794), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [3964] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3117), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3119), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4034] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(5401), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [4136] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3109), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3111), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4206] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3105), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3107), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4276] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6857), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6855), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4346] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6881), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6879), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4416] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6873), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6871), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4486] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6869), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6867), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4556] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3093), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3095), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [4626] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4884), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [4728] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4816), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [4830] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4744), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [4932] = 6,
    ACTIONS(6931), 1,
      anon_sym_AT,
    ACTIONS(6935), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2803), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6772), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6770), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [5008] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3057), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3059), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5078] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5956), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5958), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5148] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4960), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [5250] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6887), 1,
      sym_identifier,
    ACTIONS(6891), 1,
      sym_deprecated,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5984), 1,
      sym_type,
    STATE(4887), 2,
      sym_enum_member,
      sym_anonymous_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [5352] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3069), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3071), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5422] = 6,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(754), 1,
      sym_switch,
    STATE(2025), 1,
      sym_switch_statement,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [5498] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3085), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3087), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5568] = 6,
    ACTIONS(6941), 1,
      anon_sym_AT,
    ACTIONS(6944), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2803), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6939), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6937), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [5644] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3101), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3103), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5714] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3037), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3039), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5784] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3097), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3099), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5854] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3053), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3055), 42,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5924] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6877), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6875), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [5993] = 4,
    ACTIONS(6104), 1,
      sym_static,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3075), 4,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_AT,
    ACTIONS(3073), 54,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [6064] = 7,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(6949), 1,
      anon_sym_LPAREN,
    STATE(2900), 1,
      sym_template_arguments,
    STATE(2918), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5926), 39,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [6141] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6885), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6883), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6210] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3065), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3067), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6279] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3077), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3079), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6348] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3113), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3115), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6417] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6881), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6879), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6486] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5940), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5942), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6555] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3085), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3087), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6624] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3041), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3043), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6693] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3117), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3119), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6762] = 5,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(6154), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [6835] = 7,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 1,
      anon_sym_AT,
    ACTIONS(6842), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 15,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_static,
      sym_synchronized,
      sym_gshared,
    ACTIONS(6839), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [6912] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3069), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3071), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [6981] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5956), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5958), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7050] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3061), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3063), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7119] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6873), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6871), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7188] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6861), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6859), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7257] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6857), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6855), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7326] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5936), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5938), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7395] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5952), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5954), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7464] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5920), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5922), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7533] = 6,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4136), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 54,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [7608] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3109), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3111), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7677] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3105), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3107), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7746] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3093), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3095), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7815] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5932), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5934), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7884] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3053), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3055), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [7953] = 5,
    ACTIONS(6093), 1,
      anon_sym_COLON,
    ACTIONS(6098), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [8026] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3057), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3059), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8095] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3097), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3099), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8164] = 5,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(6951), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [8237] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3037), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3039), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8306] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6869), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(6867), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8375] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5944), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5946), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8444] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5948), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(5950), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8513] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3101), 18,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
    ACTIONS(3103), 41,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_is,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [8582] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4809), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [8680] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5620), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [8778] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5078), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [8876] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4941), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [8974] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4898), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9072] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4822), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9170] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5045), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9268] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5098), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9366] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5044), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9464] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4840), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9562] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4852), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9660] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5026), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9758] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5024), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9856] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4846), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [9954] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4845), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10052] = 6,
    ACTIONS(6957), 1,
      anon_sym_AT,
    ACTIONS(6959), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2867), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6794), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6792), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [10126] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5002), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10224] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5000), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10322] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5096), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10420] = 5,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(6961), 1,
      sym_ref,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 54,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [10492] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5072), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10590] = 6,
    ACTIONS(6957), 1,
      anon_sym_AT,
    ACTIONS(6964), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2883), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6772), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6770), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [10664] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5068), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10762] = 4,
    ACTIONS(6951), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [10832] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5055), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [10930] = 4,
    ACTIONS(669), 1,
      anon_sym_COLON,
    ACTIONS(6780), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 55,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_const,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_shared,
      sym_static,
      sym_synchronized,
      sym_typeof,
      sym_gshared,
      sym_traits,
      sym_vector,
      sym_void,
  [11000] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4807), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11098] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5125), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11196] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5134), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11294] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4804), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11392] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5103), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11490] = 6,
    ACTIONS(6137), 1,
      anon_sym_LPAREN,
    ACTIONS(6780), 1,
      anon_sym_AT,
    ACTIONS(6842), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6778), 15,
      sym_abstract,
      sym_align,
      sym_auto,
      sym_deprecated,
      sym_enum,
      sym_extern,
      sym_final,
      sym_nothrow,
      sym_override,
      sym_pure,
      sym_ref,
      sym_scope,
      sym_static,
      sym_synchronized,
      sym_gshared,
    ACTIONS(6839), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [11564] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4967), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11662] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5145), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11760] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5052), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11858] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5129), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [11956] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5137), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [12054] = 6,
    ACTIONS(6966), 1,
      anon_sym_AT,
    ACTIONS(6969), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2883), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6939), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6937), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [12128] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5143), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [12226] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6953), 1,
      sym_identifier,
    STATE(2901), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5121), 1,
      sym_foreach_type,
    STATE(6344), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6955), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [12324] = 7,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(6974), 1,
      anon_sym_LPAREN,
    STATE(2965), 1,
      sym_template_arguments,
    STATE(2984), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5926), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [12399] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3093), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3095), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12466] = 5,
    ACTIONS(6949), 1,
      anon_sym_LPAREN,
    STATE(2918), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5926), 39,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [12537] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3037), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3039), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12604] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3065), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3067), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12671] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3077), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3079), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12738] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3113), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3115), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12805] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3101), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3103), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12872] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3041), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3043), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [12939] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3117), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3119), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13006] = 6,
    ACTIONS(6976), 1,
      anon_sym_AT,
    ACTIONS(6979), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2896), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6939), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6937), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [13079] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3085), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3087), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13146] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5920), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5922), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13213] = 6,
    ACTIONS(6982), 1,
      anon_sym_AT,
    ACTIONS(6984), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2896), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6772), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6770), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [13286] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5932), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5934), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13353] = 17,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6986), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3498), 1,
      aux_sym_foreach_type_repeat1,
    STATE(3533), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5928), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(6988), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [13448] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5940), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5942), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13515] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3057), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3059), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13582] = 20,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    ACTIONS(6992), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(6126), 1,
      sym__template_parameter_list,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [13683] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3061), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3063), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13750] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3069), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3071), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13817] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3053), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3055), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13884] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3109), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3111), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [13951] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3105), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3107), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [14018] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5936), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5938), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [14085] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3097), 23,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3099), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [14152] = 6,
    ACTIONS(6982), 1,
      anon_sym_AT,
    ACTIONS(6994), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2899), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6794), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6792), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [14225] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6873), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6871), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [14291] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(5944), 1,
      sym__template_parameter_list,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [14389] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(6149), 1,
      sym_type,
    STATE(6302), 1,
      sym__template_parameter_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [14487] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    ACTIONS(6996), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5386), 1,
      sym_template_parameter,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [14585] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6869), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6867), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [14651] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5952), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5954), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [14717] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(5991), 1,
      sym__template_parameter_list,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [14815] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    STATE(2957), 1,
      sym_arguments,
    STATE(3179), 1,
      sym_aggregate_body,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5250), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [14913] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(5989), 1,
      sym__template_parameter_list,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [15011] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5944), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5946), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [15077] = 11,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [15159] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(7023), 1,
      anon_sym_LBRACE,
    STATE(2980), 1,
      sym_arguments,
    STATE(3368), 1,
      sym_aggregate_body,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5315), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [15257] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5948), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5950), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [15323] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6881), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6879), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [15389] = 11,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7029), 1,
      anon_sym_DOT,
    ACTIONS(7032), 1,
      anon_sym_LPAREN,
    ACTIONS(7035), 1,
      anon_sym_LBRACK,
    ACTIONS(7039), 1,
      anon_sym_COLON,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7027), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [15471] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5956), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5958), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [15537] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6877), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6875), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [15603] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(6149), 1,
      sym_type,
    STATE(6306), 1,
      sym__template_parameter_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [15701] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4812), 1,
      sym_template_parameter,
    STATE(5962), 1,
      sym__template_parameter_list,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [15799] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    ACTIONS(7044), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5386), 1,
      sym_template_parameter,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [15897] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(7046), 1,
      anon_sym_LBRACE,
    STATE(2969), 1,
      sym_arguments,
    STATE(3453), 1,
      sym_aggregate_body,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5369), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [15995] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6857), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6855), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [16061] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6885), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6883), 40,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [16127] = 7,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    ACTIONS(7050), 1,
      anon_sym_LPAREN,
    STATE(2954), 1,
      sym_template_arguments,
    STATE(3029), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5926), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [16201] = 8,
    ACTIONS(7056), 1,
      anon_sym_LBRACK,
    ACTIONS(7058), 1,
      anon_sym_STAR,
    ACTIONS(7060), 1,
      sym_delegate,
    ACTIONS(7062), 1,
      sym_function,
    STATE(2946), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7054), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7052), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [16276] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3176), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3178), 39,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_catch,
      sym_else,
      sym_finally,
      sym_in,
      sym_is,
      sym_while,
  [16341] = 5,
    ACTIONS(6974), 1,
      anon_sym_LPAREN,
    STATE(2984), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5926), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [16410] = 18,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6335), 1,
      sym_alias,
    ACTIONS(6341), 1,
      sym_this,
    ACTIONS(6990), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5386), 1,
      sym_template_parameter,
    STATE(6149), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [16505] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3163), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3165), 39,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_catch,
      sym_else,
      sym_finally,
      sym_in,
      sym_is,
      sym_while,
  [16570] = 8,
    ACTIONS(7056), 1,
      anon_sym_LBRACK,
    ACTIONS(7060), 1,
      sym_delegate,
    ACTIONS(7062), 1,
      sym_function,
    ACTIONS(7064), 1,
      anon_sym_STAR,
    STATE(2947), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7054), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7052), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [16645] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 39,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_catch,
      sym_else,
      sym_finally,
      sym_in,
      sym_is,
      sym_while,
  [16710] = 13,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7066), 1,
      anon_sym_COLON,
    ACTIONS(7068), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [16795] = 8,
    ACTIONS(7056), 1,
      anon_sym_LBRACK,
    ACTIONS(7060), 1,
      sym_delegate,
    ACTIONS(7062), 1,
      sym_function,
    ACTIONS(7075), 1,
      anon_sym_STAR,
    STATE(2942), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7073), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7071), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [16870] = 8,
    ACTIONS(7056), 1,
      anon_sym_LBRACK,
    ACTIONS(7060), 1,
      sym_delegate,
    ACTIONS(7062), 1,
      sym_function,
    ACTIONS(7064), 1,
      anon_sym_STAR,
    STATE(2947), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7079), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7077), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [16945] = 8,
    ACTIONS(7085), 1,
      anon_sym_LBRACK,
    ACTIONS(7088), 1,
      anon_sym_STAR,
    ACTIONS(7091), 1,
      sym_delegate,
    ACTIONS(7094), 1,
      sym_function,
    STATE(2947), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7083), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7081), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [17020] = 7,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7097), 1,
      anon_sym_DOT,
    ACTIONS(7099), 1,
      anon_sym_LBRACK,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7039), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [17093] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6869), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6867), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [17157] = 7,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [17229] = 5,
    ACTIONS(7050), 1,
      anon_sym_LPAREN,
    STATE(3029), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5926), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [17297] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7111), 1,
      anon_sym_RPAREN,
    ACTIONS(7115), 1,
      sym_immutable,
    ACTIONS(7117), 1,
      sym_shared,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5742), 1,
      sym_type,
    STATE(5743), 1,
      sym_cast_qualifier,
    ACTIONS(7113), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [17393] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      sym_immutable,
    ACTIONS(7117), 1,
      sym_shared,
    ACTIONS(7119), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6297), 1,
      sym_cast_qualifier,
    STATE(6299), 1,
      sym_type,
    ACTIONS(7113), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [17489] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5932), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5934), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [17553] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      sym_immutable,
    ACTIONS(7117), 1,
      sym_shared,
    ACTIONS(7121), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5711), 1,
      sym_cast_qualifier,
    STATE(5712), 1,
      sym_type,
    ACTIONS(7113), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [17649] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5920), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5922), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [17713] = 17,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    STATE(3177), 1,
      sym_aggregate_body,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5256), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [17805] = 12,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7039), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    ACTIONS(7123), 1,
      anon_sym_DOT,
    ACTIONS(7126), 1,
      anon_sym_LBRACK,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(7018), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7011), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 24,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [17887] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5948), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5950), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [17951] = 13,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7068), 1,
      anon_sym_EQ,
    ACTIONS(7130), 1,
      anon_sym_COLON,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [18035] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5940), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5942), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [18099] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6873), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6871), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [18163] = 13,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7130), 1,
      anon_sym_COLON,
    ACTIONS(7132), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [18247] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      sym_immutable,
    ACTIONS(7117), 1,
      sym_shared,
    ACTIONS(7135), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5905), 1,
      sym_type,
    STATE(5910), 1,
      sym_cast_qualifier,
    ACTIONS(7113), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [18343] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5932), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5934), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [18407] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7137), 21,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7139), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [18471] = 8,
    ACTIONS(7143), 1,
      anon_sym_DOT,
    ACTIONS(7145), 1,
      anon_sym_AT,
    STATE(2967), 2,
      sym_parameter_attribute,
      aux_sym__parameter_repeat1,
    STATE(3306), 2,
      sym_type_ctor,
      sym_at_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7151), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(7148), 8,
      sym_auto,
      sym_final,
      sym_in,
      sym_lazy,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
    ACTIONS(7141), 36,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_mixin,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [18545] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7154), 21,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7156), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [18609] = 17,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7046), 1,
      anon_sym_LBRACE,
    STATE(3447), 1,
      sym_aggregate_body,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5376), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [18701] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5936), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(5938), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [18765] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3069), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3071), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [18829] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3061), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3063), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [18893] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3085), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3087), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [18957] = 13,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7130), 1,
      anon_sym_COLON,
    ACTIONS(7158), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [19041] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5920), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5922), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [19105] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3069), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3071), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [19169] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3061), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3063), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [19233] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3085), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3087), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [19297] = 8,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7161), 1,
      anon_sym_DOT,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [19371] = 17,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7023), 1,
      anon_sym_LBRACE,
    STATE(3356), 1,
      sym_aggregate_body,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5506), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [19463] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      sym_immutable,
    ACTIONS(7117), 1,
      sym_shared,
    ACTIONS(7164), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6147), 1,
      sym_cast_qualifier,
    STATE(6156), 1,
      sym_type,
    ACTIONS(7113), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [19559] = 8,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7039), 1,
      anon_sym_COLON,
    ACTIONS(7011), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [19633] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6857), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6855), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [19697] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5952), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5954), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [19761] = 13,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7130), 1,
      anon_sym_COLON,
    ACTIONS(7166), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [19845] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7169), 21,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7171), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [19909] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7173), 21,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7175), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [19973] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3057), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3059), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [20037] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6885), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6883), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20101] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3053), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3055), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [20165] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3097), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3099), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [20229] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3037), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3039), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [20293] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3101), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3103), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [20357] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3057), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3059), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20421] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5940), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5942), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20485] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3053), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3055), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20549] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5944), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5946), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20613] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3097), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3099), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20677] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6877), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6875), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20741] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3037), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3039), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20805] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3101), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3103), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [20869] = 19,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    ACTIONS(7115), 1,
      sym_immutable,
    ACTIONS(7117), 1,
      sym_shared,
    ACTIONS(7177), 1,
      anon_sym_RPAREN,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6414), 1,
      sym_cast_qualifier,
    STATE(6416), 1,
      sym_type,
    ACTIONS(7113), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [20965] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3065), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3067), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21029] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3077), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3079), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21093] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3093), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3095), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21157] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3113), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3115), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21221] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3105), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3107), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21285] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3109), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3111), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21349] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3117), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3119), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21413] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3041), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3043), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21477] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3113), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3115), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21541] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3077), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3079), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21605] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3065), 24,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
    ACTIONS(3067), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
  [21669] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6881), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6879), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21733] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3041), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3043), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21797] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3117), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3119), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21861] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3109), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3111), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21925] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3105), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3107), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [21989] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5956), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5958), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [22053] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5936), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5938), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [22117] = 8,
    ACTIONS(7029), 1,
      anon_sym_DOT,
    ACTIONS(7039), 1,
      anon_sym_COLON,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7032), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7027), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [22191] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3093), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3095), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [22255] = 13,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7130), 1,
      anon_sym_COLON,
    ACTIONS(7179), 1,
      anon_sym_EQ,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [22339] = 4,
    ACTIONS(7097), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7039), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [22404] = 6,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    STATE(4331), 1,
      sym_block_statement,
    ACTIONS(7186), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 48,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_const,
      sym_final,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [22473] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5956), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5958), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [22536] = 8,
    ACTIONS(7190), 1,
      anon_sym_LBRACK,
    ACTIONS(7192), 1,
      anon_sym_STAR,
    ACTIONS(7194), 1,
      sym_delegate,
    ACTIONS(7196), 1,
      sym_function,
    STATE(3042), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7079), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7077), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [22609] = 6,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(7198), 1,
      anon_sym_LPAREN,
    STATE(4307), 1,
      sym_block_statement,
    ACTIONS(7186), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 48,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_const,
      sym_final,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [22678] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5952), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5954), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [22741] = 6,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4133), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(7186), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 48,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_const,
      sym_final,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [22810] = 12,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7200), 1,
      anon_sym_COLON,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [22891] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7204), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7202), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [22954] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5944), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5946), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [23017] = 5,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7208), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7206), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [23084] = 11,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7210), 1,
      anon_sym_EQ_GT,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [23163] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7212), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [23226] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7216), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [23289] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5948), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(5950), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [23352] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7222), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7220), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [23415] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6885), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6883), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [23478] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6881), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6879), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [23541] = 8,
    ACTIONS(7224), 1,
      anon_sym_LBRACK,
    ACTIONS(7227), 1,
      anon_sym_STAR,
    ACTIONS(7230), 1,
      sym_delegate,
    ACTIONS(7233), 1,
      sym_function,
    STATE(3042), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7083), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7081), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [23614] = 16,
    ACTIONS(3206), 1,
      sym_mixin,
    ACTIONS(3214), 1,
      sym_typeof,
    ACTIONS(3216), 1,
      sym_traits,
    ACTIONS(7236), 1,
      sym_identifier,
    ACTIONS(7238), 1,
      anon_sym_DOT,
    ACTIONS(7242), 1,
      sym_class,
    ACTIONS(7244), 1,
      sym_vector,
    STATE(3200), 1,
      aux_sym_type_repeat1,
    STATE(3289), 1,
      sym_template_instance,
    STATE(3295), 1,
      sym_typeof_expression,
    STATE(3329), 1,
      sym_type,
    STATE(3639), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(3086), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7240), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [23703] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6877), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6875), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [23766] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7248), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7246), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [23829] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6857), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6855), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [23892] = 4,
    ACTIONS(7250), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7212), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [23957] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7254), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7252), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [24020] = 16,
    ACTIONS(3334), 1,
      sym_mixin,
    ACTIONS(3344), 1,
      sym_typeof,
    ACTIONS(3346), 1,
      sym_traits,
    ACTIONS(7256), 1,
      sym_identifier,
    ACTIONS(7258), 1,
      anon_sym_DOT,
    ACTIONS(7262), 1,
      sym_class,
    ACTIONS(7264), 1,
      sym_vector,
    STATE(3185), 1,
      sym_typeof_expression,
    STATE(3187), 1,
      sym_template_instance,
    STATE(3190), 1,
      aux_sym_type_repeat1,
    STATE(3262), 1,
      sym_type,
    STATE(3614), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(3057), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7260), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [24109] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6792), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [24172] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6869), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6867), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [24235] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6873), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6871), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_AT,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
      sym_nothrow,
      sym_pure,
  [24298] = 11,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7269), 1,
      anon_sym_EQ_GT,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [24377] = 12,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7271), 1,
      anon_sym_COLON,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [24458] = 5,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7276), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7273), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [24525] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6770), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [24588] = 8,
    ACTIONS(7190), 1,
      anon_sym_LBRACK,
    ACTIONS(7194), 1,
      sym_delegate,
    ACTIONS(7196), 1,
      sym_function,
    ACTIONS(7279), 1,
      anon_sym_STAR,
    STATE(3059), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7073), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7071), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [24661] = 8,
    ACTIONS(7190), 1,
      anon_sym_LBRACK,
    ACTIONS(7194), 1,
      sym_delegate,
    ACTIONS(7196), 1,
      sym_function,
    ACTIONS(7281), 1,
      anon_sym_STAR,
    STATE(3027), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7054), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7052), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [24734] = 8,
    ACTIONS(7190), 1,
      anon_sym_LBRACK,
    ACTIONS(7192), 1,
      anon_sym_STAR,
    ACTIONS(7194), 1,
      sym_delegate,
    ACTIONS(7196), 1,
      sym_function,
    STATE(3042), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7054), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7052), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [24807] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7285), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7283), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [24870] = 16,
    ACTIONS(195), 1,
      sym_typeof,
    ACTIONS(207), 1,
      sym_traits,
    ACTIONS(3027), 1,
      sym_mixin,
    ACTIONS(7287), 1,
      sym_identifier,
    ACTIONS(7289), 1,
      anon_sym_DOT,
    ACTIONS(7293), 1,
      sym_class,
    ACTIONS(7295), 1,
      sym_vector,
    STATE(3024), 1,
      sym_template_instance,
    STATE(3065), 1,
      sym_typeof_expression,
    STATE(3162), 1,
      sym_type,
    STATE(3229), 1,
      aux_sym_type_repeat1,
    STATE(3641), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(2945), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7291), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [24959] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7299), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7297), 37,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [25022] = 11,
    ACTIONS(7039), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    ACTIONS(7301), 1,
      anon_sym_DOT,
    ACTIONS(7304), 1,
      anon_sym_LBRACK,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(7041), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7032), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7027), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7025), 24,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [25101] = 11,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7308), 1,
      anon_sym_EQ_GT,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [25180] = 4,
    ACTIONS(7310), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7106), 36,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [25245] = 7,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(7312), 1,
      anon_sym_DOT,
    ACTIONS(7314), 1,
      anon_sym_LBRACK,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7039), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [25316] = 15,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(3218), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(7316), 1,
      sym_identifier,
    ACTIONS(7318), 1,
      anon_sym_DOT,
    ACTIONS(7322), 1,
      sym_typeof,
    STATE(3210), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4317), 1,
      sym_template_instance,
    STATE(4318), 1,
      sym_typeof_expression,
    STATE(4969), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4305), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7320), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [25402] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5086), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [25488] = 10,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7029), 1,
      anon_sym_DOT,
    ACTIONS(7032), 1,
      anon_sym_LPAREN,
    ACTIONS(7035), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [25564] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5597), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [25650] = 11,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(7324), 1,
      anon_sym_DOT,
    ACTIONS(7327), 1,
      anon_sym_LBRACK,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7018), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7011), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7006), 14,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [25728] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5354), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [25814] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4733), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [25900] = 8,
    ACTIONS(7335), 1,
      anon_sym_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(7341), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(7337), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7333), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7331), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [25972] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5970), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [26058] = 7,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    ACTIONS(7343), 1,
      anon_sym_DOT,
    ACTIONS(7345), 1,
      anon_sym_LBRACK,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7039), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [26128] = 8,
    ACTIONS(7335), 1,
      anon_sym_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(7341), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(7337), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7349), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7347), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [26200] = 8,
    ACTIONS(7335), 1,
      anon_sym_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(7341), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(7337), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7353), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7351), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [26272] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4631), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [26358] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6087), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [26444] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6116), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [26530] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(7355), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5988), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [26616] = 5,
    ACTIONS(7357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3075), 2,
      anon_sym_LPAREN,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7359), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
    ACTIONS(3073), 44,
      sym_identifier,
      anon_sym_DOT,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_final,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_ref,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [26682] = 11,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7362), 1,
      anon_sym_EQ_GT,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [26760] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5358), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [26846] = 8,
    ACTIONS(7364), 1,
      anon_sym_LBRACK,
    ACTIONS(7366), 1,
      anon_sym_STAR,
    ACTIONS(7368), 1,
      sym_delegate,
    ACTIONS(7370), 1,
      sym_function,
    STATE(3133), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7073), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7071), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [26918] = 11,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7011), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [26996] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6229), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27082] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5331), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27168] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5033), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27254] = 10,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(7035), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7372), 1,
      anon_sym_DOT,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(7032), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [27330] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5239), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27416] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6471), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27502] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(7375), 1,
      sym_identifier,
    ACTIONS(7377), 1,
      anon_sym_DOT,
    ACTIONS(7381), 1,
      sym_mixin,
    ACTIONS(7383), 1,
      sym_traits,
    STATE(3214), 1,
      aux_sym_type_repeat1,
    STATE(3638), 1,
      sym_type_ctor,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4357), 1,
      sym_typeof_expression,
    STATE(4622), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4297), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7379), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27588] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5371), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27674] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4632), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27760] = 8,
    ACTIONS(7364), 1,
      anon_sym_LBRACK,
    ACTIONS(7368), 1,
      sym_delegate,
    ACTIONS(7370), 1,
      sym_function,
    ACTIONS(7385), 1,
      anon_sym_STAR,
    STATE(3100), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7079), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7077), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [27832] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6470), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [27918] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5872), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28004] = 8,
    ACTIONS(7387), 1,
      anon_sym_LBRACK,
    ACTIONS(7390), 1,
      anon_sym_STAR,
    ACTIONS(7393), 1,
      sym_delegate,
    ACTIONS(7396), 1,
      sym_function,
    STATE(3100), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7083), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7081), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [28076] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6221), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28162] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4694), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28248] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6214), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28334] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5528), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28420] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4705), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28506] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4675), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28592] = 10,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(7032), 1,
      anon_sym_LPAREN,
    ACTIONS(7035), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7372), 1,
      anon_sym_DOT,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [28668] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4654), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28754] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5243), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28840] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(7375), 1,
      sym_identifier,
    ACTIONS(7377), 1,
      anon_sym_DOT,
    ACTIONS(7381), 1,
      sym_mixin,
    ACTIONS(7383), 1,
      sym_traits,
    STATE(3214), 1,
      aux_sym_type_repeat1,
    STATE(3638), 1,
      sym_type_ctor,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4357), 1,
      sym_typeof_expression,
    STATE(4627), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4297), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7379), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [28926] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4648), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29012] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5740), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29098] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5600), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29184] = 8,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7399), 1,
      anon_sym_SEMI,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [29256] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5566), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29342] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6406), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29428] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5567), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29514] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5679), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29600] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5677), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29686] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5579), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29772] = 10,
    ACTIONS(7032), 1,
      anon_sym_LPAREN,
    ACTIONS(7035), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    ACTIONS(7372), 1,
      anon_sym_DOT,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [29848] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4641), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [29934] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5716), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30020] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6180), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30106] = 8,
    ACTIONS(7364), 1,
      anon_sym_LBRACK,
    ACTIONS(7368), 1,
      sym_delegate,
    ACTIONS(7370), 1,
      sym_function,
    ACTIONS(7402), 1,
      anon_sym_STAR,
    STATE(3097), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7054), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7052), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [30178] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5548), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30264] = 11,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7308), 1,
      anon_sym_EQ_GT,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(7011), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [30342] = 15,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(3218), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(7316), 1,
      sym_identifier,
    ACTIONS(7318), 1,
      anon_sym_DOT,
    ACTIONS(7322), 1,
      sym_typeof,
    STATE(3210), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4317), 1,
      sym_template_instance,
    STATE(4318), 1,
      sym_typeof_expression,
    STATE(4824), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4305), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7320), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30428] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5481), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30514] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5345), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30600] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5583), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30686] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4838), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30772] = 8,
    ACTIONS(7364), 1,
      anon_sym_LBRACK,
    ACTIONS(7368), 1,
      sym_delegate,
    ACTIONS(7370), 1,
      sym_function,
    ACTIONS(7385), 1,
      anon_sym_STAR,
    STATE(3100), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7054), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7052), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [30844] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5353), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [30930] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4644), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31016] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4656), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31102] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4664), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31188] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6266), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31274] = 8,
    ACTIONS(7335), 1,
      anon_sym_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(7341), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(7337), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7406), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7404), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [31346] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5556), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31432] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5460), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31518] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(4928), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31604] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5554), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31690] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(7375), 1,
      sym_identifier,
    ACTIONS(7377), 1,
      anon_sym_DOT,
    ACTIONS(7381), 1,
      sym_mixin,
    ACTIONS(7383), 1,
      sym_traits,
    STATE(3214), 1,
      aux_sym_type_repeat1,
    STATE(3638), 1,
      sym_type_ctor,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4357), 1,
      sym_typeof_expression,
    STATE(4718), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4297), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7379), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31776] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5724), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31862] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6212), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [31948] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5794), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32034] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4735), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32120] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5517), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32206] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4723), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32292] = 4,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7410), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7408), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [32356] = 8,
    ACTIONS(7335), 1,
      anon_sym_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(7341), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(7337), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7410), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7408), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [32428] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5240), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32514] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5510), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32600] = 15,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(4616), 1,
      sym_base_class,
    STATE(4726), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32686] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5266), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32772] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5010), 1,
      sym_base_class,
    STATE(5381), 1,
      sym__base_class_list,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [32858] = 8,
    ACTIONS(7335), 1,
      anon_sym_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(7341), 1,
      anon_sym_LBRACK,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(7337), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7414), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7412), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [32930] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(6196), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [33016] = 4,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7418), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7416), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33080] = 10,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7029), 1,
      anon_sym_DOT,
    ACTIONS(7035), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7032), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33156] = 4,
    STATE(3179), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7422), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7420), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33220] = 4,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7426), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7424), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33284] = 15,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3238), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5065), 1,
      sym_type,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4223), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(21), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [33370] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7254), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7252), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [33431] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7430), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7428), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33492] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7285), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7283), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [33553] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7434), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7432), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33614] = 8,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7436), 1,
      anon_sym_SEMI,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [33685] = 4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3154), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33748] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7441), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7439), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33809] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7445), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7443), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33870] = 5,
    ACTIONS(7447), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3170), 3,
      sym_catch,
      sym_finally,
      sym_while,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33935] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7452), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7450), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [33996] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7456), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7454), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34057] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7460), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7458), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34118] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7464), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7462), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34179] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7468), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7466), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34240] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7472), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7470), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34301] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7248), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7246), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [34362] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7476), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7474), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34423] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7480), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7478), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34484] = 4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3133), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(3135), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3137), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34547] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4765), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(4767), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34608] = 4,
    ACTIONS(7482), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7106), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [34671] = 5,
    ACTIONS(7484), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3170), 3,
      sym_catch,
      sym_finally,
      sym_while,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34736] = 4,
    ACTIONS(7312), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7039), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [34799] = 4,
    ACTIONS(7488), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7212), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [34862] = 5,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7208), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7206), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [34927] = 14,
    ACTIONS(3334), 1,
      sym_mixin,
    ACTIONS(3344), 1,
      sym_typeof,
    ACTIONS(3346), 1,
      sym_traits,
    ACTIONS(7256), 1,
      sym_identifier,
    ACTIONS(7258), 1,
      anon_sym_DOT,
    ACTIONS(7264), 1,
      sym_vector,
    STATE(3185), 1,
      sym_typeof_expression,
    STATE(3187), 1,
      sym_template_instance,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3614), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(3058), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7490), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [35010] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7173), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7175), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [35071] = 8,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7492), 1,
      anon_sym_SEMI,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [35142] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7497), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7495), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35203] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7501), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7499), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35264] = 11,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7011), 1,
      anon_sym_LPAREN,
    ACTIONS(7014), 1,
      anon_sym_LBRACK,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7503), 1,
      anon_sym_EQ_GT,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35341] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7173), 22,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7175), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [35402] = 8,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7505), 1,
      anon_sym_SEMI,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [35473] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7276), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7273), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35534] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7510), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7508), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35595] = 14,
    ACTIONS(3206), 1,
      sym_mixin,
    ACTIONS(3214), 1,
      sym_typeof,
    ACTIONS(3216), 1,
      sym_traits,
    ACTIONS(7236), 1,
      sym_identifier,
    ACTIONS(7238), 1,
      anon_sym_DOT,
    ACTIONS(7244), 1,
      sym_vector,
    STATE(3289), 1,
      sym_template_instance,
    STATE(3295), 1,
      sym_typeof_expression,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3639), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(3125), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7512), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [35678] = 14,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(7514), 1,
      sym_identifier,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4200), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7516), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [35761] = 4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3160), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35824] = 4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3148), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [35887] = 5,
    ACTIONS(7186), 1,
      anon_sym_AT,
    ACTIONS(7357), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7518), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
    ACTIONS(7182), 44,
      sym_identifier,
      anon_sym_DOT,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_final,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_ref,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [35952] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6792), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [36013] = 6,
    ACTIONS(6137), 1,
      anon_sym_LPAREN,
    ACTIONS(7186), 1,
      anon_sym_AT,
    ACTIONS(7524), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 8,
      sym_auto,
      sym_final,
      sym_in,
      sym_lazy,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
    ACTIONS(7521), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [36080] = 4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3124), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36143] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7529), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7527), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36204] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7533), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7531), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36265] = 14,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(3218), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(7316), 1,
      sym_identifier,
    ACTIONS(7318), 1,
      anon_sym_DOT,
    ACTIONS(7322), 1,
      sym_typeof,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4317), 1,
      sym_template_instance,
    STATE(4318), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4303), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7535), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [36348] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7539), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7537), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36409] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7543), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7541), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36470] = 10,
    ACTIONS(6947), 1,
      anon_sym_BANG,
    ACTIONS(7545), 1,
      anon_sym_DOT,
    ACTIONS(7548), 1,
      anon_sym_LBRACK,
    STATE(2900), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(7041), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7032), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7027), 14,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36545] = 14,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(7375), 1,
      sym_identifier,
    ACTIONS(7377), 1,
      anon_sym_DOT,
    ACTIONS(7381), 1,
      sym_mixin,
    ACTIONS(7383), 1,
      sym_traits,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3638), 1,
      sym_type_ctor,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4357), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4293), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7552), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [36628] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7556), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7554), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36689] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7560), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7558), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36750] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7564), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7562), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36811] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7208), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7206), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [36872] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7222), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7220), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [36933] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7154), 22,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7156), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [36994] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7568), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7566), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37055] = 8,
    ACTIONS(7106), 1,
      anon_sym_COLON,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7570), 1,
      anon_sym_SEMI,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [37126] = 14,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    STATE(5053), 1,
      sym_base_class,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [37209] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7575), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7573), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37270] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7579), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7577), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37331] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7583), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7581), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37392] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7587), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7585), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37453] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7204), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7202), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [37514] = 14,
    ACTIONS(195), 1,
      sym_typeof,
    ACTIONS(207), 1,
      sym_traits,
    ACTIONS(3027), 1,
      sym_mixin,
    ACTIONS(7287), 1,
      sym_identifier,
    ACTIONS(7289), 1,
      anon_sym_DOT,
    ACTIONS(7295), 1,
      sym_vector,
    STATE(3024), 1,
      sym_template_instance,
    STATE(3065), 1,
      sym_typeof_expression,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3641), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(2937), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7589), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [37597] = 8,
    ACTIONS(7039), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7123), 1,
      anon_sym_DOT,
    ACTIONS(7018), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7011), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 24,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [37668] = 14,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(3218), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6337), 1,
      sym_typeof,
    ACTIONS(6679), 1,
      sym_identifier,
    ACTIONS(6821), 1,
      anon_sym_DOT,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4275), 1,
      sym_template_instance,
    STATE(4282), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4261), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7591), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [37751] = 7,
    ACTIONS(7106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7108), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7103), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 24,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [37820] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7595), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7593), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37881] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7599), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7597), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [37942] = 8,
    ACTIONS(7039), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7301), 1,
      anon_sym_DOT,
    ACTIONS(7041), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7032), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7027), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7025), 24,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [38013] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7603), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7601), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [38074] = 6,
    ACTIONS(7186), 1,
      anon_sym_AT,
    ACTIONS(7524), 1,
      anon_sym_DOT,
    ACTIONS(7605), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 8,
      sym_auto,
      sym_final,
      sym_in,
      sym_lazy,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
    ACTIONS(7521), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [38141] = 14,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4200), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7516), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [38224] = 14,
    ACTIONS(13), 1,
      anon_sym_DOT,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6443), 1,
      sym_identifier,
    STATE(4235), 1,
      sym_template_instance,
    STATE(4242), 1,
      sym_typeof_expression,
    STATE(5053), 1,
      sym_base_class,
    STATE(6216), 1,
      sym_type_ctor,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(33), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(5007), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7000), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [38307] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7609), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7607), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [38368] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6770), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [38429] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7216), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [38490] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7299), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7297), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [38551] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7137), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7139), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [38612] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7137), 22,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7139), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [38673] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7154), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7156), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [38734] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7169), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7171), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [38795] = 8,
    ACTIONS(7106), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7611), 1,
      anon_sym_DOT,
    ACTIONS(7108), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7103), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_in,
      sym_is,
    ACTIONS(7004), 24,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [38866] = 14,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(75), 1,
      sym_traits,
    ACTIONS(77), 1,
      sym_vector,
    ACTIONS(5912), 1,
      sym_mixin,
    ACTIONS(6615), 1,
      sym_identifier,
    ACTIONS(6617), 1,
      anon_sym_DOT,
    STATE(3609), 1,
      aux_sym_type_repeat1,
    STATE(3651), 1,
      sym_type_ctor,
    STATE(4262), 1,
      sym_template_instance,
    STATE(4263), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2125), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    STATE(4277), 6,
      sym__type2,
      sym_vector_type,
      sym__builtin_type,
      sym__qualified_id,
      sym_mixin_expression,
      sym_traits_expression,
    ACTIONS(7614), 31,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_void,
  [38949] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7618), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7616), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39010] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7622), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7620), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39071] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7626), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7624), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39132] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7630), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7628), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39193] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7634), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7632), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39254] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7638), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7636), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39315] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7169), 22,
      sym_identifier,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
    ACTIONS(7171), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [39376] = 5,
    ACTIONS(6972), 1,
      anon_sym_BANG,
    STATE(2965), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7276), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7273), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39441] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7212), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [39502] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4668), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(4670), 35,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39563] = 7,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7011), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39631] = 6,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7103), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39697] = 4,
    STATE(3368), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7422), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7420), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39759] = 7,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39827] = 4,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7426), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7424), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39889] = 4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3223), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [39951] = 7,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7652), 1,
      anon_sym_DOT,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40019] = 7,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7161), 1,
      anon_sym_DOT,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7103), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40087] = 4,
    ACTIONS(7655), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7212), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [40149] = 7,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7372), 1,
      anon_sym_DOT,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7032), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40217] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7299), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7297), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [40277] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7285), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7283), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [40337] = 7,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7652), 1,
      anon_sym_DOT,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7103), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40405] = 7,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7011), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40473] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7204), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7202), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [40533] = 8,
    ACTIONS(7657), 1,
      anon_sym_DOT,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      anon_sym_LBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(7659), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7333), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7331), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40603] = 6,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40669] = 5,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7208), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7206), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40733] = 4,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7410), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7408), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40795] = 4,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7418), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7416), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40857] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7212), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [40917] = 7,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7372), 1,
      anon_sym_DOT,
    ACTIONS(7032), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [40985] = 7,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7372), 1,
      anon_sym_DOT,
    ACTIONS(7032), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [41053] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7216), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [41113] = 7,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7011), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [41181] = 5,
    ACTIONS(7048), 1,
      anon_sym_BANG,
    STATE(2954), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7276), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7273), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [41245] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7222), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7220), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [41305] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6770), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [41365] = 12,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 26,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [41443] = 4,
    ACTIONS(7343), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7039), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [41505] = 17,
    ACTIONS(7575), 1,
      anon_sym_EQ,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7573), 23,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [41593] = 17,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7691), 1,
      anon_sym_EQ,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7689), 23,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [41681] = 17,
    ACTIONS(7539), 1,
      anon_sym_EQ,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7537), 23,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [41769] = 6,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7103), 3,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [41835] = 7,
    ACTIONS(7029), 1,
      anon_sym_DOT,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7032), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [41903] = 4,
    ACTIONS(7693), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7106), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [41965] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7248), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7246), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [42025] = 8,
    ACTIONS(7657), 1,
      anon_sym_DOT,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      anon_sym_LBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(7659), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7406), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7404), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42095] = 7,
    ACTIONS(7008), 1,
      anon_sym_DOT,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7011), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42163] = 6,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42229] = 5,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42293] = 8,
    ACTIONS(7657), 1,
      anon_sym_DOT,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      anon_sym_LBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(7659), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7349), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7347), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42363] = 7,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7161), 1,
      anon_sym_DOT,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42431] = 6,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42497] = 8,
    ACTIONS(7657), 1,
      anon_sym_DOT,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      anon_sym_LBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(7659), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7353), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7351), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42567] = 7,
    ACTIONS(7108), 1,
      anon_sym_STAR,
    ACTIONS(7652), 1,
      anon_sym_DOT,
    ACTIONS(7103), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42635] = 3,
    ACTIONS(7186), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 48,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_const,
      sym_final,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_ref,
      sym_return,
      sym_scope,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [42695] = 7,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42763] = 14,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 26,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [42845] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(6792), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [42905] = 4,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [42967] = 17,
    ACTIONS(7480), 1,
      anon_sym_EQ,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7478), 23,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [43055] = 18,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7715), 1,
      anon_sym_EQ,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 10,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7713), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [43145] = 6,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [43211] = 4,
    ACTIONS(7721), 1,
      sym_ref,
    ACTIONS(7186), 2,
      anon_sym_DOT,
      anon_sym_AT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7182), 47,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_auto,
      sym_const,
      sym_final,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_lazy,
      sym_mixin,
      sym_out,
      sym_return,
      sym_scope,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [43273] = 8,
    ACTIONS(7657), 1,
      anon_sym_DOT,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      anon_sym_LBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(7659), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7414), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7412), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [43343] = 8,
    ACTIONS(7657), 1,
      anon_sym_DOT,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(7663), 1,
      anon_sym_LBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(7659), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7410), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7408), 28,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [43413] = 6,
    ACTIONS(7724), 1,
      anon_sym_LPAREN,
    STATE(3742), 1,
      sym_parameters,
    STATE(5211), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [43479] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7254), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7252), 33,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_delegate,
      sym_function,
      sym_in,
      sym_is,
  [43539] = 7,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 34,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [43607] = 17,
    ACTIONS(7497), 1,
      anon_sym_EQ,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7495), 23,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [43695] = 7,
    ACTIONS(7018), 1,
      anon_sym_STAR,
    ACTIONS(7266), 1,
      anon_sym_DOT,
    ACTIONS(7011), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [43763] = 15,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 25,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [43847] = 18,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7679), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7681), 1,
      anon_sym_PIPE,
    ACTIONS(7683), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7685), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7715), 1,
      anon_sym_EQ,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 10,
      anon_sym_RBRACE,
      anon_sym_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7713), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [43937] = 7,
    ACTIONS(7029), 1,
      anon_sym_DOT,
    ACTIONS(7041), 1,
      anon_sym_STAR,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7032), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7027), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44005] = 11,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7737), 26,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [44081] = 13,
    ACTIONS(7650), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7667), 1,
      anon_sym_AMP,
    ACTIONS(7687), 1,
      anon_sym_CARET,
    ACTIONS(7671), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7673), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7675), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7642), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7646), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7648), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7677), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 26,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [44161] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7468), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7466), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44220] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4668), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(4670), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44279] = 4,
    STATE(3453), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7422), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7420), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44340] = 4,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7418), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7416), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44401] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7634), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7632), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44460] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7609), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7607), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44519] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7630), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7628), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44578] = 4,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7426), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7424), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44639] = 6,
    ACTIONS(7745), 1,
      anon_sym_LPAREN,
    STATE(3802), 1,
      sym_parameters,
    STATE(5232), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44704] = 6,
    ACTIONS(7748), 1,
      anon_sym_LPAREN,
    STATE(3725), 1,
      sym_parameters,
    STATE(5307), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44769] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7533), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7531), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44828] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7626), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7624), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44887] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7497), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7495), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [44946] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7543), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7541), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45005] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7595), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7593), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45064] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7564), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7562), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45123] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7208), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7206), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45182] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4765), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(4767), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45241] = 8,
    ACTIONS(7751), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7757), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(7753), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7410), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7408), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45310] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7434), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7432), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45369] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7441), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7439), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45428] = 5,
    ACTIONS(3170), 1,
      sym_while,
    ACTIONS(7759), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45491] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3176), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3178), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45550] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7575), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7573), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45609] = 8,
    ACTIONS(7751), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7757), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(7753), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7349), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7347), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45678] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7456), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7454), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45737] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7603), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7601), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45796] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7460), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7458), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45855] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7618), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7616), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45914] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7464), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7462), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [45973] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7579), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7577), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46032] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7445), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7443), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46091] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7599), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7597), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46150] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7556), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7554), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46209] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7539), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7537), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46268] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3127), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46327] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7501), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7499), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46386] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7476), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7474), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46445] = 8,
    ACTIONS(7751), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7757), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(7753), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7414), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7412), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46514] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7452), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7450), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46573] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7583), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7581), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46632] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7472), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7470), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46691] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7529), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7527), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46750] = 8,
    ACTIONS(7751), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7757), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(7753), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7333), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7331), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46819] = 5,
    ACTIONS(3133), 1,
      sym_while,
    ACTIONS(7443), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7762), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7765), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46882] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3163), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3165), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [46941] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7568), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7566), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47000] = 6,
    ACTIONS(7768), 1,
      anon_sym_LPAREN,
    STATE(3792), 1,
      sym_parameters,
    STATE(5613), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47065] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7638), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7636), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47124] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7276), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7273), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47183] = 8,
    ACTIONS(7751), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7757), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(7753), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7406), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7404), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47252] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7587), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7585), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47311] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7560), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7558), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47370] = 5,
    ACTIONS(3170), 1,
      sym_while,
    ACTIONS(7771), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3127), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47433] = 8,
    ACTIONS(7751), 1,
      anon_sym_DOT,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    ACTIONS(7757), 1,
      anon_sym_LBRACK,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(7753), 2,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7353), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7351), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47502] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7622), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7620), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47561] = 6,
    ACTIONS(7775), 1,
      anon_sym_LPAREN,
    STATE(3732), 1,
      sym_parameters,
    STATE(5466), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47626] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7510), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7508), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47685] = 7,
    ACTIONS(7545), 1,
      anon_sym_DOT,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(7041), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7032), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7027), 14,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7025), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47752] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7480), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7478), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47811] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7430), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7428), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47870] = 7,
    ACTIONS(7778), 1,
      anon_sym_DOT,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(7108), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7103), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 14,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [47937] = 7,
    ACTIONS(7324), 1,
      anon_sym_DOT,
    ACTIONS(7018), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(7039), 2,
      sym_delegate,
      sym_function,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7011), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 14,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48004] = 4,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7410), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7408), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48065] = 6,
    ACTIONS(7106), 2,
      sym_delegate,
      sym_function,
    ACTIONS(7108), 2,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7103), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7006), 14,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48130] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7599), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7597), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48188] = 6,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 10,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48252] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7533), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7531), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48310] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7529), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7527), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48368] = 4,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48428] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7476), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7474), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48486] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4765), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(4767), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48544] = 7,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48610] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3163), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3165), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48668] = 17,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7539), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7537), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [48754] = 17,
    ACTIONS(7480), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7478), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [48840] = 12,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7669), 4,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [48916] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7568), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7566), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [48974] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7543), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7541), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49032] = 18,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7857), 1,
      anon_sym_EQ,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 8,
      anon_sym_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7855), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49120] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4668), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(4670), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49178] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7595), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7593), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49236] = 17,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7480), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7478), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49322] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7560), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7558), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49380] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7430), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7428), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49438] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7556), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7554), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49496] = 13,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7743), 3,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49574] = 17,
    ACTIONS(7691), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7689), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49660] = 17,
    ACTIONS(7497), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7495), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49746] = 15,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7733), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49828] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7441), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7439), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [49886] = 14,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7705), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [49966] = 12,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 24,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50042] = 15,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7733), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50124] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7468), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7466), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50182] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7434), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7432), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50240] = 6,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 10,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50304] = 5,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 13,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50366] = 7,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50432] = 11,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7739), 5,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7737), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50506] = 7,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50572] = 11,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 24,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50646] = 17,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7575), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7573), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50732] = 7,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [50798] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50880] = 11,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7739), 5,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7737), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [50954] = 17,
    ACTIONS(7539), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7537), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [51040] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7452), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7450), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51098] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7445), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7443), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51156] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3127), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3129), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51214] = 19,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7873), 1,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7865), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [51304] = 19,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7877), 1,
      anon_sym_DOT,
    ACTIONS(7879), 1,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 7,
      anon_sym_DOT_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(7875), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [51394] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7603), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7601), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51452] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7609), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7607), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51510] = 13,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7743), 3,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [51588] = 4,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51648] = 4,
    ACTIONS(7881), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51708] = 7,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [51774] = 17,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7691), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7689), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [51860] = 19,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    ACTIONS(7879), 1,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 7,
      anon_sym_DOT_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(7875), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [51950] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7464), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7462), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52008] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7539), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7537), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52066] = 13,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 24,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [52144] = 17,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7575), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7573), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [52230] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7579), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7577), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52288] = 17,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7691), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7689), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [52374] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7472), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7470), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52432] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3176), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(3178), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52490] = 7,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52556] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7618), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7616), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52614] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7638), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7636), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52672] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 24,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [52752] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7480), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7478), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52810] = 5,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52872] = 7,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52938] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7456), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7454), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [52996] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7276), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7273), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53054] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7583), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7581), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53112] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7626), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7624), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53170] = 17,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7539), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7537), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [53256] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7634), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7632), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53314] = 7,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53380] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7460), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7458), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53438] = 17,
    ACTIONS(7575), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7573), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [53524] = 17,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7793), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7795), 1,
      anon_sym_PIPE,
    ACTIONS(7797), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7809), 1,
      anon_sym_QMARK,
    ACTIONS(7811), 1,
      anon_sym_CARET,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7497), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7495), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [53610] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7587), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7585), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53668] = 5,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 13,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [53730] = 17,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7480), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7478), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [53816] = 18,
    ACTIONS(7819), 1,
      anon_sym_AMP,
    ACTIONS(7821), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7823), 1,
      anon_sym_PIPE,
    ACTIONS(7825), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7837), 1,
      anon_sym_QMARK,
    ACTIONS(7839), 1,
      anon_sym_CARET,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7857), 1,
      anon_sym_EQ,
    ACTIONS(7829), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7831), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7835), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7843), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 8,
      anon_sym_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(7855), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [53904] = 19,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7873), 1,
      anon_sym_EQ,
    ACTIONS(7877), 1,
      anon_sym_DOT,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
    ACTIONS(7865), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [53994] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7564), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7562), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54052] = 6,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54116] = 14,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7705), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [54196] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7208), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7206), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54254] = 7,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7817), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7827), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7833), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54320] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7510), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7508), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54378] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7575), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7573), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54436] = 4,
    ACTIONS(7841), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 32,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54496] = 17,
    ACTIONS(7785), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7845), 1,
      anon_sym_AMP,
    ACTIONS(7859), 1,
      anon_sym_PIPE,
    ACTIONS(7861), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7863), 1,
      anon_sym_CARET,
    ACTIONS(7869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7871), 1,
      anon_sym_QMARK,
    ACTIONS(7497), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7847), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7849), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7851), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7781), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7783), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7787), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7853), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7495), 20,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [54582] = 12,
    ACTIONS(7791), 1,
      anon_sym_AMP,
    ACTIONS(7813), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7801), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7803), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7807), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7789), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7799), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7805), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7669), 4,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7815), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 23,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [54658] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7630), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7628), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54716] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7497), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7495), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54774] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7622), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7620), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54832] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7501), 17,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7499), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54890] = 4,
    ACTIONS(7884), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [54949] = 17,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7497), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7495), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55034] = 4,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 16,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [55093] = 19,
    ACTIONS(7877), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7917), 1,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 6,
      anon_sym_DOT_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(7915), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55182] = 17,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7575), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7573), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55267] = 11,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7739), 5,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7737), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55340] = 7,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [55405] = 6,
    ACTIONS(7921), 1,
      anon_sym_DOT,
    STATE(3498), 2,
      sym_type_ctor,
      aux_sym_foreach_type_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7923), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    ACTIONS(7926), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(7919), 36,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_mixin,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [55468] = 17,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7691), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7689), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55553] = 17,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7480), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7478), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55638] = 19,
    ACTIONS(7867), 1,
      anon_sym_DOT,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7917), 1,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 6,
      anon_sym_DOT_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
    ACTIONS(7915), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55727] = 15,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7733), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55808] = 4,
    ACTIONS(7929), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [55867] = 17,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7891), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7895), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7907), 1,
      anon_sym_QMARK,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7539), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7537), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [55952] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7618), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7616), 31,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56009] = 13,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7743), 3,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [56086] = 12,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7669), 4,
      anon_sym_DOT,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [56161] = 7,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56226] = 4,
    ACTIONS(7932), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56285] = 4,
    ACTIONS(7935), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7006), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7004), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56344] = 14,
    ACTIONS(7889), 1,
      anon_sym_AMP,
    ACTIONS(7893), 1,
      anon_sym_PIPE,
    ACTIONS(7909), 1,
      anon_sym_CARET,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7705), 2,
      anon_sym_DOT,
      anon_sym_EQ,
    ACTIONS(7899), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7901), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7905), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7913), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [56423] = 6,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 10,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56486] = 5,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 13,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56547] = 7,
    ACTIONS(7911), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7887), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7897), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7903), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 7,
      anon_sym_DOT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56612] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 21,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [56692] = 13,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [56768] = 17,
    ACTIONS(7497), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7495), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [56852] = 6,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [56914] = 18,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7968), 1,
      anon_sym_EQ,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 6,
      anon_sym_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(7966), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57000] = 17,
    ACTIONS(7480), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7478), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57084] = 12,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57158] = 17,
    ACTIONS(7691), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7689), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57242] = 7,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [57306] = 17,
    ACTIONS(7539), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7537), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57390] = 4,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [57448] = 7,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [57512] = 5,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [57572] = 18,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7968), 1,
      anon_sym_EQ,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 6,
      anon_sym_DOT,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_PLUS,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
    ACTIONS(7966), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57658] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57736] = 11,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 22,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57808] = 17,
    ACTIONS(7575), 1,
      anon_sym_EQ,
    ACTIONS(7940), 1,
      anon_sym_AMP,
    ACTIONS(7942), 1,
      anon_sym_PIPE,
    ACTIONS(7944), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7956), 1,
      anon_sym_CARET,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7962), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7964), 1,
      anon_sym_QMARK,
    ACTIONS(7948), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7950), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7954), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7960), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7573), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [57892] = 7,
    ACTIONS(7958), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7938), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7946), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7952), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 30,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [57956] = 5,
    ACTIONS(6137), 1,
      anon_sym_LPAREN,
    ACTIONS(7973), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7976), 4,
      sym_alias,
      sym_enum,
      sym_ref,
      sym_scope,
    ACTIONS(7970), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [58016] = 11,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 21,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58087] = 7,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [58150] = 22,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6768), 1,
      anon_sym_RPAREN,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8018), 1,
      anon_sym_COMMA,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(4747), 1,
      sym_ellipses,
    STATE(4760), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58243] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 20,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58322] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7735), 5,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58407] = 13,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 21,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58482] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 21,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58559] = 12,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 21,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58632] = 4,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [58689] = 7,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [58752] = 6,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [58813] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7711), 5,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [58898] = 7,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [58961] = 5,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 29,
      sym_not_in,
      sym_not_is,
      anon_sym_RBRACE,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [59020] = 22,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6756), 1,
      anon_sym_RPAREN,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8044), 1,
      anon_sym_COMMA,
    STATE(5037), 1,
      sym_ellipses,
    STATE(5038), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59113] = 22,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8046), 1,
      anon_sym_COMMA,
    STATE(4785), 1,
      sym_ellipses,
    STATE(4841), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59206] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5409), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8048), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59294] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5526), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8050), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59382] = 20,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8054), 1,
      anon_sym_COMMA,
    STATE(4697), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8052), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59470] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5439), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8056), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59558] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5426), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8058), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59646] = 4,
    ACTIONS(3075), 2,
      anon_sym_DOT,
      anon_sym_LPAREN,
    ACTIONS(8060), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3073), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [59702] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8062), 4,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59786] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5564), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8064), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59874] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5458), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [59962] = 20,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    STATE(5564), 1,
      sym_ellipses,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8068), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60050] = 20,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8052), 1,
      anon_sym_SEMI,
    STATE(4697), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8071), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60138] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 19,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60213] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8095), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60296] = 18,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_PIPE,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_QMARK,
    ACTIONS(8121), 1,
      anon_sym_EQ,
    ACTIONS(8123), 1,
      anon_sym_CARET,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7711), 3,
      anon_sym_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8099), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60379] = 18,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_PIPE,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_QMARK,
    ACTIONS(8121), 1,
      anon_sym_EQ,
    ACTIONS(8123), 1,
      anon_sym_CARET,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7735), 3,
      anon_sym_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8099), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60462] = 11,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60531] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8105), 1,
      anon_sym_PIPE,
    ACTIONS(8123), 1,
      anon_sym_CARET,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60606] = 5,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [60663] = 7,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [60724] = 7,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [60785] = 20,
    ACTIONS(8052), 1,
      anon_sym_COLON,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8131), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8135), 1,
      anon_sym_QMARK,
    ACTIONS(8137), 1,
      anon_sym_COMMA,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    STATE(5049), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8129), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [60872] = 6,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [60931] = 7,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [60992] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8105), 1,
      anon_sym_PIPE,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8123), 1,
      anon_sym_CARET,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 18,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61069] = 13,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61142] = 12,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61213] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 18,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61290] = 13,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 19,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61363] = 19,
    ACTIONS(8062), 1,
      anon_sym_COLON,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8131), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8135), 1,
      anon_sym_QMARK,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8141), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8129), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61448] = 12,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61519] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61594] = 7,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [61655] = 5,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [61712] = 7,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [61773] = 6,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [61832] = 7,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [61893] = 13,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8123), 1,
      anon_sym_CARET,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [61966] = 12,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 19,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62037] = 18,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8131), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8135), 1,
      anon_sym_QMARK,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7735), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8129), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62120] = 18,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7735), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62203] = 20,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8131), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8135), 1,
      anon_sym_QMARK,
    ACTIONS(8137), 1,
      anon_sym_COMMA,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    ACTIONS(8143), 1,
      anon_sym_COLON,
    STATE(5049), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8129), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62290] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8071), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62373] = 18,
    ACTIONS(8101), 1,
      anon_sym_AMP,
    ACTIONS(8103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8105), 1,
      anon_sym_PIPE,
    ACTIONS(8107), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8119), 1,
      anon_sym_QMARK,
    ACTIONS(8121), 1,
      anon_sym_EQ,
    ACTIONS(8123), 1,
      anon_sym_CARET,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8111), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8113), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8117), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8062), 3,
      anon_sym_DOT_DOT,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(8097), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8109), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8115), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8127), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8099), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62456] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 18,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62533] = 6,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [62592] = 11,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 19,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62661] = 18,
    ACTIONS(7998), 1,
      anon_sym_AMP,
    ACTIONS(8000), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8002), 1,
      anon_sym_PIPE,
    ACTIONS(8004), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8016), 1,
      anon_sym_QMARK,
    ACTIONS(8020), 1,
      anon_sym_EQ,
    ACTIONS(8022), 1,
      anon_sym_CARET,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8008), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8010), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8014), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7711), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8026), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7996), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62744] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7618), 16,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_CARET_CARET,
      anon_sym_TILDE,
    ACTIONS(7616), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [62797] = 4,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [62852] = 20,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8054), 1,
      anon_sym_COMMA,
    ACTIONS(8143), 1,
      anon_sym_RPAREN,
    STATE(4697), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [62939] = 7,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [63000] = 5,
    ACTIONS(8146), 1,
      anon_sym_RPAREN,
    ACTIONS(3075), 2,
      anon_sym_DOT,
      anon_sym_LPAREN,
    ACTIONS(8148), 2,
      sym_const,
      sym_inout,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3073), 38,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_immutable,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [63057] = 5,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [63114] = 4,
    ACTIONS(8146), 1,
      anon_sym_RPAREN,
    ACTIONS(3075), 2,
      anon_sym_DOT,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3073), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [63169] = 5,
    ACTIONS(8146), 1,
      anon_sym_RPAREN,
    ACTIONS(8148), 1,
      sym_shared,
    ACTIONS(3075), 2,
      anon_sym_DOT,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3073), 39,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [63226] = 4,
    ACTIONS(8125), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [63281] = 4,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [63336] = 11,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 19,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [63405] = 7,
    ACTIONS(8024), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7994), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8006), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8012), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [63466] = 5,
    ACTIONS(8153), 1,
      anon_sym_DOT,
    STATE(3609), 2,
      sym_type_ctor,
      aux_sym_type_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8155), 4,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_shared,
    ACTIONS(8151), 36,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_mixin,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [63523] = 18,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8131), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8135), 1,
      anon_sym_QMARK,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7711), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8129), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [63606] = 7,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 27,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [63667] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8160), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8158), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [63749] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8162), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [63831] = 4,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(8168), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [63885] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7537), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [63967] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8170), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64049] = 13,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8186), 1,
      anon_sym_CARET,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 18,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64121] = 5,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [64177] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8186), 1,
      anon_sym_CARET,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8192), 1,
      anon_sym_PIPE,
    ACTIONS(8194), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 17,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64253] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8196), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64335] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7478), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64417] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8200), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64499] = 11,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 18,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64567] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8071), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64649] = 18,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8186), 1,
      anon_sym_CARET,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8192), 1,
      anon_sym_PIPE,
    ACTIONS(8194), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8204), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8206), 1,
      anon_sym_QMARK,
    ACTIONS(8208), 1,
      anon_sym_EQ,
    ACTIONS(7711), 2,
      anon_sym_DOT_DOT,
      anon_sym_RPAREN,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8202), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64731] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7573), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64813] = 4,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(8210), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [64867] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [64949] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8212), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65031] = 4,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [65085] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8214), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65167] = 4,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(8216), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [65221] = 4,
    ACTIONS(6173), 1,
      anon_sym_LPAREN,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [65275] = 7,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [65335] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8186), 1,
      anon_sym_CARET,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8192), 1,
      anon_sym_PIPE,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 18,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65409] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8218), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65491] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8218), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65573] = 4,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(8220), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [65627] = 4,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(8222), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [65681] = 18,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8186), 1,
      anon_sym_CARET,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8192), 1,
      anon_sym_PIPE,
    ACTIONS(8194), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8204), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8206), 1,
      anon_sym_QMARK,
    ACTIONS(8208), 1,
      anon_sym_EQ,
    ACTIONS(8062), 2,
      anon_sym_DOT_DOT,
      anon_sym_RPAREN,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8202), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65763] = 4,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(8224), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [65817] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8226), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65899] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8230), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8228), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [65981] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8232), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66063] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7495), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66145] = 18,
    ACTIONS(8075), 1,
      anon_sym_AMP,
    ACTIONS(8077), 1,
      anon_sym_PIPE,
    ACTIONS(8089), 1,
      anon_sym_CARET,
    ACTIONS(8091), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8131), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8133), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8135), 1,
      anon_sym_QMARK,
    ACTIONS(8139), 1,
      anon_sym_EQ,
    ACTIONS(8081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8083), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8087), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8095), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8073), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8079), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8085), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8093), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8129), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66227] = 7,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [66287] = 6,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [66345] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7689), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66427] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8232), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66509] = 4,
    ACTIONS(6137), 1,
      anon_sym_LPAREN,
    ACTIONS(8166), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8164), 40,
      sym_identifier,
      sym_bool,
      sym_byte,
      sym_ubyte,
      sym_char,
      sym_short,
      sym_ushort,
      sym_int,
      sym_uint,
      sym_long,
      sym_ulong,
      sym_cent,
      sym_ucent,
      sym_wchar,
      sym_dchar,
      sym_float,
      sym_double,
      sym_real,
      sym_ifloat,
      sym_idouble,
      sym_ireal,
      sym_cfloat,
      sym_cdouble,
      sym_creal,
      sym_size_t,
      sym_ptrdiff_t,
      sym_string,
      sym_cstring,
      sym_dstring,
      sym_wstring,
      sym_noreturn,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_mixin,
      sym_shared,
      sym_typeof,
      sym_traits,
      sym_vector,
      sym_void,
  [66563] = 7,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 26,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [66623] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8228), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66705] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(8234), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66787] = 12,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 18,
      anon_sym_SLASH_EQ,
      anon_sym_DOT_DOT,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66857] = 18,
    ACTIONS(8174), 1,
      anon_sym_AMP,
    ACTIONS(8186), 1,
      anon_sym_CARET,
    ACTIONS(8188), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8192), 1,
      anon_sym_PIPE,
    ACTIONS(8194), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8204), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8206), 1,
      anon_sym_QMARK,
    ACTIONS(8208), 1,
      anon_sym_EQ,
    ACTIONS(7735), 2,
      anon_sym_DOT_DOT,
      anon_sym_RPAREN,
    ACTIONS(8178), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8180), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8184), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8172), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8176), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8182), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8190), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8202), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [66939] = 14,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8240), 1,
      anon_sym_PIPE,
    ACTIONS(8252), 1,
      anon_sym_CARET,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7703), 17,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67012] = 18,
    ACTIONS(8062), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8240), 1,
      anon_sym_PIPE,
    ACTIONS(8252), 1,
      anon_sym_CARET,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8264), 1,
      anon_sym_QMARK,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8258), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67093] = 5,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7697), 12,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7695), 25,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [67148] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8268), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67229] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8270), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67310] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8272), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67391] = 13,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8252), 1,
      anon_sym_CARET,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(7743), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7741), 17,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67462] = 15,
    ACTIONS(7733), 1,
      anon_sym_EQ,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8240), 1,
      anon_sym_PIPE,
    ACTIONS(8252), 1,
      anon_sym_CARET,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7731), 16,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67537] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8274), 1,
      anon_sym_RPAREN,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67618] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8276), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67699] = 18,
    ACTIONS(7735), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8240), 1,
      anon_sym_PIPE,
    ACTIONS(8252), 1,
      anon_sym_CARET,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8264), 1,
      anon_sym_QMARK,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8258), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [67780] = 4,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7709), 15,
      anon_sym_SLASH,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_TILDE,
    ACTIONS(7707), 25,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [67833] = 7,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7701), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7699), 25,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [67892] = 7,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7729), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7727), 25,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [67951] = 18,
    ACTIONS(7711), 1,
      anon_sym_COLON,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8240), 1,
      anon_sym_PIPE,
    ACTIONS(8252), 1,
      anon_sym_CARET,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8264), 1,
      anon_sym_QMARK,
    ACTIONS(8266), 1,
      anon_sym_EQ,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8258), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68032] = 6,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7719), 9,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_LT_LT,
      anon_sym_GT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7717), 25,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [68089] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8278), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68170] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8280), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68251] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8282), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68332] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8284), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68413] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8286), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68494] = 7,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7644), 6,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(7640), 25,
      sym_not_in,
      sym_not_is,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
      sym_in,
      sym_is,
  [68553] = 11,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7739), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7737), 17,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68620] = 12,
    ACTIONS(8238), 1,
      anon_sym_AMP,
    ACTIONS(8254), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(8246), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(8250), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7669), 3,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_CARET,
    ACTIONS(8236), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(8242), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(8248), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(8256), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(7665), 17,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_QMARK,
      anon_sym_COLON,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68689] = 18,
    ACTIONS(7990), 1,
      anon_sym_CARET_CARET,
    ACTIONS(8028), 1,
      anon_sym_AMP,
    ACTIONS(8030), 1,
      anon_sym_PIPE,
    ACTIONS(8032), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8034), 1,
      anon_sym_CARET,
    ACTIONS(8038), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8040), 1,
      anon_sym_QMARK,
    ACTIONS(8042), 1,
      anon_sym_EQ,
    ACTIONS(8288), 1,
      anon_sym_SEMI,
    ACTIONS(7982), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7984), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(7988), 2,
      anon_sym_BANG_EQ,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7978), 3,
      anon_sym_SLASH,
      anon_sym_STAR,
      anon_sym_PERCENT,
    ACTIONS(7980), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(7986), 3,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
    ACTIONS(7992), 4,
      sym_not_in,
      sym_not_is,
      sym_in,
      sym_is,
    ACTIONS(8036), 13,
      anon_sym_SLASH_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_DASH_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_STAR_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_CARET_CARET_EQ,
      anon_sym_TILDE_EQ,
  [68770] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2386), 1,
      sym_function_body,
    STATE(4073), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [68845] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2050), 1,
      sym_function_body,
    STATE(4022), 1,
      sym_constraint,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3695), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [68920] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1553), 1,
      sym_function_body,
    STATE(4026), 1,
      sym_constraint,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [68995] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1337), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(3982), 1,
      sym_constraint,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3709), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69070] = 19,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2386), 1,
      sym_function_body,
    STATE(4013), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69145] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1438), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4035), 1,
      sym_constraint,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69220] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(1976), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4047), 1,
      sym_constraint,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3702), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69295] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2410), 1,
      sym_function_body,
    STATE(3987), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3691), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69370] = 19,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2211), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(3981), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69445] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2331), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(3998), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69520] = 19,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2257), 1,
      sym_function_body,
    STATE(4023), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3686), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69595] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1610), 1,
      sym_function_body,
    STATE(4065), 1,
      sym_constraint,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69670] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2295), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4027), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3696), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69745] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2121), 1,
      sym_function_body,
    STATE(3979), 1,
      sym_constraint,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69820] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2244), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4029), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69895] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2295), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4009), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3705), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [69970] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2210), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4046), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3707), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70045] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1588), 1,
      sym_function_body,
    STATE(3984), 1,
      sym_constraint,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3684), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70120] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2331), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4012), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70195] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2410), 1,
      sym_function_body,
    STATE(4052), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3700), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70270] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(1958), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(3986), 1,
      sym_constraint,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70345] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1666), 1,
      sym_function_body,
    STATE(4061), 1,
      sym_constraint,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3693), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70420] = 19,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2210), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4058), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3690), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70495] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2244), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4063), 1,
      sym_constraint,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70570] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2257), 1,
      sym_function_body,
    STATE(4070), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3682), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70645] = 19,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2211), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4060), 1,
      sym_constraint,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70720] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1452), 1,
      sym_block_statement,
    STATE(1478), 1,
      sym_function_body,
    STATE(4049), 1,
      sym_constraint,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3687), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70795] = 19,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1437), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(3991), 1,
      sym_constraint,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70870] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2346), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3772), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [70939] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2066), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3820), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71008] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2331), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3744), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71077] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2285), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71146] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2282), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71215] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2438), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3805), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71284] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1337), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71353] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2297), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3751), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71422] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2428), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3821), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71491] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2414), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71560] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2237), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3819), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71629] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1374), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3716), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71698] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2428), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71767] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2334), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71836] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2242), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71905] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1452), 1,
      sym_block_statement,
    STATE(1453), 1,
      sym_function_body,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3727), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [71974] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2245), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72043] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1452), 1,
      sym_block_statement,
    STATE(1478), 1,
      sym_function_body,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72112] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1344), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72181] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2069), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72250] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1666), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72319] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2257), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72388] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2343), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3738), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72457] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1553), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3814), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72526] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1549), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72595] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1365), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3739), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72664] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2282), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72733] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2070), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72802] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2410), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72871] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1396), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [72940] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2211), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3794), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73009] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1438), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3788), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73078] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1514), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3768), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73147] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2410), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73216] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2267), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73285] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2438), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3764), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73354] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(1976), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73423] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2108), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73492] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2354), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3778), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73561] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2428), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3755), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73630] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(1982), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3729), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73699] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2414), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73768] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2428), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73837] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1617), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3800), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73906] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1632), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3799), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [73975] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2233), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74044] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2275), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3724), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74113] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2283), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3813), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74182] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2267), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3726), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74251] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2354), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3766), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74320] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2346), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3767), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74389] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2341), 1,
      sym_block_statement,
    STATE(2343), 1,
      sym_function_body,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3743), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74458] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2231), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3806), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74527] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2331), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3771), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74596] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2295), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74665] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1566), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74734] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2275), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74803] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2274), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74872] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1588), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [74941] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2267), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3776), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75010] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2275), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3777), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75079] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2267), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75148] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2274), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75217] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1565), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75286] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2109), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3796), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75355] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2242), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3779), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75424] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2245), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75493] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2242), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75562] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2275), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75631] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8352), 1,
      sym_in,
    ACTIONS(8354), 1,
      sym_out,
    STATE(2334), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75700] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(1974), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3737), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75769] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2282), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3752), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75838] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2297), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75907] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2297), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3719), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [75976] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2210), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76045] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1378), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76114] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1452), 1,
      sym_block_statement,
    STATE(1507), 1,
      sym_function_body,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3789), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76183] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1344), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3785), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76252] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1452), 1,
      sym_block_statement,
    STATE(1507), 1,
      sym_function_body,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76321] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1379), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76390] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2242), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3723), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76459] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2109), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76528] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2013), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3746), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76597] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2282), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3722), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76666] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2297), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76735] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1378), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3808), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76804] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2098), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76873] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2240), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3736), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [76942] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2076), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3747), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77011] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1656), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77080] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1655), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77149] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2069), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3791), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77218] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2231), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3784), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77287] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2237), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3713), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77356] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2211), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3782), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77425] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    STATE(2295), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77494] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2210), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77563] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2076), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77632] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1404), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77701] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2240), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3714), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77770] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2283), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3731), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77839] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1566), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3734), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77908] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1636), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3730), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [77977] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2257), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78046] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1648), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78115] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1656), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3765), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78184] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(1958), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3807), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78253] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8324), 1,
      sym_in,
    ACTIONS(8326), 1,
      sym_out,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1648), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3773), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78322] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8336), 1,
      sym_in,
    ACTIONS(8338), 1,
      sym_out,
    STATE(1366), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3728), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78391] = 17,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8340), 1,
      sym_in,
    ACTIONS(8342), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2285), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78460] = 17,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8312), 1,
      sym_in,
    ACTIONS(8314), 1,
      sym_out,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2050), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78529] = 17,
    ACTIONS(155), 1,
      sym_in,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2233), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78598] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6875), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6877), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78635] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6883), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6885), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78672] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6859), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6861), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78709] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6879), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6881), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78746] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6867), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6869), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78783] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6855), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6857), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78820] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6871), 12,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
    ACTIONS(6873), 15,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [78857] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8368), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8362), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8366), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3855), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [78905] = 7,
    ACTIONS(8370), 1,
      anon_sym_AT,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8372), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
    ACTIONS(6770), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [78949] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8374), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [78997] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8384), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8380), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8382), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3849), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79045] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8386), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79093] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8392), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8388), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8390), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3846), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79141] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8398), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8394), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8396), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3843), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79189] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8400), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79237] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8402), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79285] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8404), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79333] = 7,
    ACTIONS(8406), 1,
      anon_sym_AT,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6784), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8409), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
    ACTIONS(6782), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [79377] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8416), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8412), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8414), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3857), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79425] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8422), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8418), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8420), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3837), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79473] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8428), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8424), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8426), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3838), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79521] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8430), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79569] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8436), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8432), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8434), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3852), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79617] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8442), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8438), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8440), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3833), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79665] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8444), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79713] = 9,
    ACTIONS(8446), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8454), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8460), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8452), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8457), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8449), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79761] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8463), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79809] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8465), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79857] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8471), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8467), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8469), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3836), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79905] = 7,
    ACTIONS(8370), 1,
      anon_sym_AT,
    STATE(3830), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8372), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
    ACTIONS(6792), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [79949] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8473), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [79997] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8479), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8475), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8477), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3848), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [80045] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8485), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8481), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8483), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3831), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [80093] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8487), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [80141] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8489), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [80189] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8378), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8376), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(8491), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3847), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [80237] = 9,
    ACTIONS(8358), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8364), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(8497), 1,
      aux_sym_interpolated_quoted_string_token1,
    STATE(3895), 1,
      sym_htmlentity,
    ACTIONS(8493), 2,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_DQUOTE,
    ACTIONS(8495), 2,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3856), 3,
      sym_escape_sequence,
      sym_interpolation_expression,
      aux_sym_interpolated_quoted_string_repeat1,
    ACTIONS(8360), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [80285] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3111), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3109), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80319] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3095), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3093), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80353] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3103), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3101), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80387] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3067), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3065), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80421] = 7,
    ACTIONS(8499), 1,
      anon_sym_AT,
    STATE(3882), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3946), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6770), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(8501), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80463] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3079), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3077), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80497] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5934), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5932), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80531] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3039), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3037), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80565] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3115), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3113), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80599] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3059), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3057), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80633] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3087), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3085), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80667] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3055), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3053), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80701] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3071), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3069), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80735] = 7,
    ACTIONS(8499), 1,
      anon_sym_AT,
    STATE(3863), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3946), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6792), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(8501), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80777] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5942), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5940), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80811] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3063), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3061), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80845] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5938), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5936), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80879] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3099), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3097), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80913] = 7,
    ACTIONS(5930), 1,
      anon_sym_LPAREN,
    ACTIONS(8503), 1,
      anon_sym_BANG,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(2167), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 9,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5924), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80955] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3107), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3105), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [80989] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3043), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3041), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81023] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5922), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5920), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81057] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3119), 9,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(3117), 15,
      sym_identifier,
      anon_sym_DOT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_in,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81091] = 7,
    ACTIONS(8505), 1,
      anon_sym_AT,
    STATE(3882), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6784), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3946), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6782), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
    ACTIONS(8508), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81133] = 7,
    ACTIONS(6772), 1,
      sym_in,
    ACTIONS(8511), 1,
      anon_sym_AT,
    STATE(3885), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6770), 8,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_out,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81174] = 7,
    ACTIONS(6794), 1,
      sym_in,
    ACTIONS(8511), 1,
      anon_sym_AT,
    STATE(3883), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6792), 8,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_out,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81215] = 7,
    ACTIONS(6784), 1,
      sym_in,
    ACTIONS(8513), 1,
      anon_sym_AT,
    STATE(3885), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6782), 8,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_out,
    ACTIONS(8516), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81256] = 3,
    ACTIONS(3047), 1,
      aux_sym_interpolated_quoted_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3045), 21,
      aux_sym_htmlentity_token1,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LPAREN,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
      anon_sym_DOLLAR_DQUOTE,
  [81288] = 7,
    ACTIONS(8519), 1,
      anon_sym_BANG,
    ACTIONS(8521), 1,
      anon_sym_LPAREN,
    STATE(3865), 1,
      sym_template_arguments,
    STATE(3944), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5924), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81328] = 6,
    ACTIONS(8523), 1,
      anon_sym_AT,
    STATE(3888), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3946), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6782), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
    ACTIONS(8526), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81366] = 7,
    ACTIONS(19), 1,
      anon_sym_AT,
    STATE(3893), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6770), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
    ACTIONS(8372), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81406] = 3,
    ACTIONS(8531), 1,
      aux_sym_interpolated_quoted_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8529), 21,
      aux_sym_htmlentity_token1,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LPAREN,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
      anon_sym_DOLLAR_DQUOTE,
  [81438] = 5,
    ACTIONS(5924), 1,
      sym_in,
    ACTIONS(8533), 1,
      anon_sym_LPAREN,
    STATE(3921), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 19,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81474] = 6,
    ACTIONS(8535), 1,
      anon_sym_AT,
    STATE(3888), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3946), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6770), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
    ACTIONS(8537), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81512] = 7,
    ACTIONS(8539), 1,
      anon_sym_AT,
    STATE(3893), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6784), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6782), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
    ACTIONS(8409), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81552] = 6,
    ACTIONS(8535), 1,
      anon_sym_AT,
    STATE(3892), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3946), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6792), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
    ACTIONS(8537), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81590] = 3,
    ACTIONS(8544), 1,
      aux_sym_interpolated_quoted_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8542), 21,
      aux_sym_htmlentity_token1,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
      anon_sym_DQUOTE,
      anon_sym_DOLLAR_LPAREN,
      sym_interpolated_escape,
      aux_sym_interpolated_quoted_string_token2,
      anon_sym_DOLLAR_DQUOTE,
  [81622] = 7,
    ACTIONS(19), 1,
      anon_sym_AT,
    STATE(3889), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6792), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
    ACTIONS(8372), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [81662] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8550), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81701] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8554), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8556), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3909), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81740] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8558), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8560), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3906), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81779] = 7,
    ACTIONS(8562), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8568), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8570), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8565), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81818] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8573), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8575), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3913), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81857] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8577), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81896] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8579), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8581), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3905), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81935] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8583), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8585), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3917), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [81974] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8587), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82013] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8589), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82052] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8591), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8593), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3922), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82091] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8595), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82130] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8597), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82169] = 7,
    ACTIONS(6784), 1,
      sym_in,
    ACTIONS(8599), 1,
      anon_sym_AT,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(6782), 6,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      sym_do,
      sym_if,
      sym_out,
    ACTIONS(8516), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [82208] = 3,
    ACTIONS(5948), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5950), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [82239] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8602), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8604), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3908), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82278] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8606), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82317] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8608), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8610), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3916), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82356] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8612), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8614), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3902), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82395] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8616), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82434] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8618), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82473] = 7,
    ACTIONS(5924), 1,
      sym_in,
    ACTIONS(8519), 1,
      anon_sym_BANG,
    ACTIONS(8533), 1,
      anon_sym_LPAREN,
    STATE(3865), 1,
      sym_template_arguments,
    STATE(3921), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 16,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [82512] = 3,
    ACTIONS(5956), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5958), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [82543] = 7,
    ACTIONS(5930), 1,
      anon_sym_LPAREN,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(2167), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5924), 7,
      sym_identifier,
      sym_delegate,
      sym_deprecated,
      sym_function,
      sym_module,
      sym_nothrow,
      sym_pure,
    ACTIONS(5926), 10,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
      anon_sym_AT,
  [82582] = 3,
    ACTIONS(5952), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5954), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [82613] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8622), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82652] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8624), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8626), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3897), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82691] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8628), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8630), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3928), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82730] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8632), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8634), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3927), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82769] = 3,
    ACTIONS(5944), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5946), 20,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [82800] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8636), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82839] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8638), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82878] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8640), 1,
      aux_sym_raw_string_token4,
    ACTIONS(8642), 1,
      aux_sym_quoted_string_token1,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3930), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82917] = 7,
    ACTIONS(8546), 1,
      aux_sym_htmlentity_token1,
    ACTIONS(8552), 1,
      aux_sym_quoted_string_token1,
    ACTIONS(8644), 1,
      aux_sym_raw_string_token4,
    STATE(3952), 1,
      sym_htmlentity,
    STATE(3900), 2,
      sym_escape_sequence,
      aux_sym_quoted_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8548), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [82956] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(8646), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3933), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6792), 10,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [82992] = 7,
    ACTIONS(5924), 1,
      sym_in,
    ACTIONS(8533), 1,
      anon_sym_LPAREN,
    ACTIONS(8648), 1,
      anon_sym_BANG,
    STATE(3921), 1,
      sym_arguments,
    STATE(4019), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 15,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83030] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(8650), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3936), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6770), 10,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [83066] = 6,
    ACTIONS(6577), 1,
      anon_sym_LPAREN,
    ACTIONS(8519), 1,
      anon_sym_BANG,
    STATE(2578), 1,
      sym_arguments,
    STATE(3865), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 16,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83102] = 5,
    ACTIONS(8521), 1,
      anon_sym_LPAREN,
    STATE(3944), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5924), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83136] = 6,
    ACTIONS(8652), 1,
      anon_sym_AT,
    ACTIONS(8655), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6939), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3936), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6937), 10,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [83172] = 7,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8660), 1,
      sym_in,
    STATE(3910), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8658), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      sym_do,
      sym_out,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83209] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6879), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6881), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83238] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6855), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6857), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83267] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5950), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5948), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83296] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6871), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6873), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83325] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6875), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6877), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83354] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6867), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6869), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83383] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5954), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5952), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83412] = 7,
    ACTIONS(8292), 1,
      anon_sym_AT,
    ACTIONS(8664), 1,
      sym_in,
    STATE(3937), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8662), 4,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      sym_do,
      sym_out,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83449] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6859), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6861), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83478] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6883), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(6885), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83507] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5946), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5944), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83536] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5958), 8,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_AT,
    ACTIONS(5956), 11,
      sym_identifier,
      sym_const,
      sym_delegate,
      sym_function,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [83565] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7204), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7202), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [83593] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7154), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7156), 11,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [83621] = 3,
    ACTIONS(8544), 2,
      aux_sym_raw_string_token4,
      aux_sym_quoted_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8542), 16,
      aux_sym_htmlentity_token1,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83649] = 3,
    ACTIONS(8531), 2,
      aux_sym_raw_string_token4,
      aux_sym_quoted_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8529), 16,
      aux_sym_htmlentity_token1,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83677] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6074), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83709] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7212), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [83737] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6163), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83769] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6269), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83801] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6316), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83833] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6364), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83865] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6529), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83897] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6481), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83929] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(5892), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83961] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6206), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [83993] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(5703), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [84025] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7285), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7283), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84053] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7248), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7246), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84081] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7216), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84109] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(6457), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [84141] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(5767), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [84173] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7169), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7171), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84201] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7173), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7175), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84229] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7137), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7139), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84257] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7222), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7220), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [84285] = 5,
    ACTIONS(8666), 1,
      aux_sym_htmlentity_token1,
    STATE(5668), 1,
      sym_escape_sequence,
    STATE(6556), 1,
      sym_htmlentity,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8668), 15,
      anon_sym_BSLASH_SQUOTE,
      anon_sym_BSLASH_DQUOTE,
      anon_sym_BSLASH_QMARK,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASHa,
      anon_sym_BSLASHb,
      anon_sym_BSLASHf,
      anon_sym_BSLASHn,
      anon_sym_BSLASHr,
      anon_sym_BSLASHt,
      anon_sym_BSLASHv,
      aux_sym_escape_sequence_token1,
      aux_sym_escape_sequence_token2,
      aux_sym_escape_sequence_token3,
      aux_sym_escape_sequence_token4,
  [84317] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7299), 7,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
    ACTIONS(7297), 11,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [84345] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4124), 1,
      sym__parameter_with_member_attributes,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [84386] = 10,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(4145), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3483), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [84427] = 6,
    ACTIONS(8499), 1,
      anon_sym_AT,
    ACTIONS(8676), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(4039), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6770), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [84460] = 13,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8314), 1,
      sym_out,
    ACTIONS(8678), 1,
      sym_in,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2105), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84507] = 3,
    ACTIONS(5940), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5942), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [84534] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8342), 1,
      sym_out,
    ACTIONS(8680), 1,
      sym_in,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2297), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84581] = 13,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8338), 1,
      sym_out,
    ACTIONS(8682), 1,
      sym_in,
    STATE(1437), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84628] = 3,
    ACTIONS(5936), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5938), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [84655] = 13,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8326), 1,
      sym_out,
    ACTIONS(8684), 1,
      sym_in,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1553), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84702] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4184), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [84743] = 13,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8314), 1,
      sym_out,
    ACTIONS(8678), 1,
      sym_in,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2076), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84790] = 13,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8354), 1,
      sym_out,
    ACTIONS(8686), 1,
      sym_in,
    STATE(2331), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84837] = 3,
    ACTIONS(3069), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3071), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [84864] = 3,
    ACTIONS(3061), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3063), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [84891] = 3,
    ACTIONS(3085), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3087), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [84918] = 13,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8338), 1,
      sym_out,
    ACTIONS(8682), 1,
      sym_in,
    STATE(1381), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [84965] = 3,
    ACTIONS(3057), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3059), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [84992] = 3,
    ACTIONS(3053), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3055), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85019] = 3,
    ACTIONS(3097), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3099), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85046] = 3,
    ACTIONS(3037), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3039), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85073] = 3,
    ACTIONS(3101), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3103), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85100] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4155), 1,
      sym__parameter_with_member_attributes,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85141] = 13,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8354), 1,
      sym_out,
    ACTIONS(8686), 1,
      sym_in,
    STATE(2267), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [85188] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4155), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85229] = 5,
    ACTIONS(6869), 1,
      sym_in,
    ACTIONS(8688), 1,
      anon_sym_LPAREN,
    ACTIONS(8690), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6867), 14,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85260] = 3,
    ACTIONS(3093), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3095), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85287] = 3,
    ACTIONS(3105), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3107), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85314] = 3,
    ACTIONS(3109), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3111), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85341] = 3,
    ACTIONS(3117), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3119), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85368] = 3,
    ACTIONS(3041), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3043), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85395] = 3,
    ACTIONS(3113), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3115), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85422] = 3,
    ACTIONS(3077), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3079), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85449] = 3,
    ACTIONS(3065), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3067), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85476] = 13,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2244), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [85523] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4131), 1,
      sym__parameter_with_member_attributes,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85564] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4131), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85605] = 13,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2267), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [85652] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8342), 1,
      sym_out,
    ACTIONS(8680), 1,
      sym_in,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2397), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [85699] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7254), 6,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_out,
    ACTIONS(7252), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [85726] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4134), 1,
      sym__parameter_with_member_attributes,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85767] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4134), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85808] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4148), 1,
      sym__parameter_with_member_attributes,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85849] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4168), 1,
      sym__parameter_with_member_attributes,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85890] = 3,
    ACTIONS(5932), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5934), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [85917] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4168), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85958] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4148), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [85999] = 13,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8314), 1,
      sym_out,
    ACTIONS(8678), 1,
      sym_in,
    STATE(2014), 1,
      sym_block_statement,
    STATE(2121), 1,
      sym_function_body,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [86046] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8342), 1,
      sym_out,
    ACTIONS(8680), 1,
      sym_in,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2386), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [86093] = 10,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(4190), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3448), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86134] = 10,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4190), 1,
      sym__parameter_with_member_attributes,
    STATE(3448), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86175] = 13,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8326), 1,
      sym_out,
    ACTIONS(8684), 1,
      sym_in,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1648), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [86222] = 13,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8354), 1,
      sym_out,
    ACTIONS(8686), 1,
      sym_in,
    STATE(2244), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [86269] = 6,
    ACTIONS(8499), 1,
      anon_sym_AT,
    ACTIONS(8692), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(3978), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6792), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [86302] = 13,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      sym_do,
    ACTIONS(8354), 1,
      sym_out,
    ACTIONS(8686), 1,
      sym_in,
    STATE(2250), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4206), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2205), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [86349] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 6,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_out,
    ACTIONS(6770), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [86376] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4135), 1,
      sym__parameter_with_member_attributes,
    STATE(3386), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86417] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(4135), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3386), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86458] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4124), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86499] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4157), 1,
      sym__parameter_with_member_attributes,
    STATE(3361), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86540] = 13,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8338), 1,
      sym_out,
    ACTIONS(8682), 1,
      sym_in,
    STATE(1452), 1,
      sym_block_statement,
    STATE(1507), 1,
      sym_function_body,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [86587] = 10,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4144), 1,
      sym__parameter_with_member_attributes,
    STATE(5313), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86628] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4108), 1,
      sym__parameter_with_member_attributes,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86669] = 10,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    STATE(4144), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(5313), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86710] = 6,
    ACTIONS(8698), 1,
      anon_sym_AT,
    ACTIONS(8701), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6939), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    STATE(4039), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6937), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [86743] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4108), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86784] = 10,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4145), 1,
      sym__parameter_with_member_attributes,
    STATE(3483), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86825] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 6,
      sym_identifier,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_out,
    ACTIONS(6792), 11,
      anon_sym_LBRACE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [86852] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4163), 1,
      sym__parameter_with_member_attributes,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86893] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4197), 1,
      sym__parameter_with_member_attributes,
    STATE(3386), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86934] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(4163), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [86975] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2211), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87022] = 13,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8306), 1,
      anon_sym_SEMI,
    ACTIONS(8308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8310), 1,
      sym_do,
    ACTIONS(8314), 1,
      sym_out,
    ACTIONS(8678), 1,
      sym_in,
    STATE(1958), 1,
      sym_function_body,
    STATE(2014), 1,
      sym_block_statement,
    STATE(4445), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4213), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2009), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87069] = 5,
    ACTIONS(8704), 1,
      anon_sym_AT,
    ACTIONS(8707), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4048), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6937), 10,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_out,
  [87100] = 13,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8330), 1,
      anon_sym_SEMI,
    ACTIONS(8332), 1,
      anon_sym_EQ_GT,
    ACTIONS(8334), 1,
      sym_do,
    ACTIONS(8338), 1,
      sym_out,
    ACTIONS(8682), 1,
      sym_in,
    STATE(1438), 1,
      sym_function_body,
    STATE(1452), 1,
      sym_block_statement,
    STATE(4421), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4215), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1443), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87147] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4147), 1,
      sym__parameter_with_member_attributes,
    STATE(3350), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87188] = 10,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(4105), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3459), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87229] = 13,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2331), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87276] = 10,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4105), 1,
      sym__parameter_with_member_attributes,
    STATE(3459), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87317] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(4147), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3350), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87358] = 10,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4153), 1,
      sym__parameter_with_member_attributes,
    STATE(5294), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87399] = 10,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    STATE(4153), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(5294), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87440] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4195), 1,
      sym__parameter_with_member_attributes,
    STATE(3350), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87481] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8342), 1,
      sym_out,
    ACTIONS(8680), 1,
      sym_in,
    STATE(2211), 1,
      sym_function_body,
    STATE(2213), 1,
      sym_block_statement,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4205), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2202), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87528] = 10,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3945), 1,
      sym__parameters,
    STATE(4184), 1,
      sym__parameter_with_member_attributes,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87569] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2297), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87616] = 13,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8326), 1,
      sym_out,
    ACTIONS(8684), 1,
      sym_in,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1610), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87663] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(4197), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3386), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87704] = 13,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8346), 1,
      anon_sym_SEMI,
    ACTIONS(8348), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2250), 1,
      sym_function_body,
    STATE(2341), 1,
      sym_block_statement,
    STATE(4426), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4224), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87751] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(4195), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3350), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87792] = 13,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      anon_sym_EQ_GT,
    ACTIONS(8322), 1,
      sym_do,
    ACTIONS(8326), 1,
      sym_out,
    ACTIONS(8684), 1,
      sym_in,
    STATE(1512), 1,
      sym_block_statement,
    STATE(1563), 1,
      sym_function_body,
    STATE(4413), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4220), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1515), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [87839] = 3,
    ACTIONS(5920), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5922), 16,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_if,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [87866] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4189), 1,
      sym__parameter_with_member_attributes,
    STATE(3361), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87907] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(4189), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3361), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87948] = 10,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(4157), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(3361), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [87989] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2386), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [88036] = 10,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    STATE(3945), 1,
      sym__parameters,
    STATE(4194), 1,
      sym__parameter_with_member_attributes,
    STATE(5255), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [88077] = 10,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    STATE(4194), 1,
      sym__parameter_with_attributes,
    STATE(4267), 1,
      sym_parameters,
    STATE(5255), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [88118] = 13,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8290), 1,
      anon_sym_SEMI,
    ACTIONS(8294), 1,
      anon_sym_EQ_GT,
    ACTIONS(8298), 1,
      sym_do,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    STATE(2213), 1,
      sym_block_statement,
    STATE(2397), 1,
      sym_function_body,
    STATE(4452), 1,
      aux_sym__in_out_contract_expressions,
    STATE(4202), 2,
      sym__function_contract,
      aux_sym_function_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4338), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4471), 3,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [88165] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3099), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88189] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3115), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88213] = 5,
    ACTIONS(8710), 1,
      anon_sym_AT,
    ACTIONS(8712), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4048), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6770), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_out,
  [88243] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3059), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88267] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8714), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(4099), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88299] = 5,
    ACTIONS(8710), 1,
      anon_sym_AT,
    ACTIONS(8716), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4076), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6792), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_out,
  [88329] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8714), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88361] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3071), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88385] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5934), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88409] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5922), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88433] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3039), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88457] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5942), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88481] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8718), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88513] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3055), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88537] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3063), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88561] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8718), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(4080), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88593] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3087), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88617] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3067), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88641] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3079), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88665] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5938), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88689] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3043), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88713] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3119), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88737] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8720), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(4086), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88769] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3111), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88793] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3107), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88817] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8722), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88849] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3095), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88873] = 6,
    ACTIONS(8724), 1,
      anon_sym_BANG,
    ACTIONS(8726), 1,
      anon_sym_LPAREN,
    STATE(4082), 1,
      sym_template_arguments,
    STATE(4239), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88905] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3103), 16,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [88929] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7039), 8,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [88962] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8732), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [88993] = 8,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    ACTIONS(8734), 1,
      anon_sym_EQ_GT,
    STATE(3483), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89028] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8736), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89059] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8738), 1,
      anon_sym_SEMI,
    STATE(4142), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89090] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8740), 1,
      anon_sym_EQ_GT,
    STATE(3193), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89125] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8742), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89156] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8744), 1,
      anon_sym_SEMI,
    STATE(4174), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89187] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8742), 1,
      anon_sym_SEMI,
    STATE(4146), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89218] = 14,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8746), 1,
      anon_sym_LBRACE,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8750), 1,
      anon_sym_SEMI,
    ACTIONS(8752), 1,
      anon_sym_COLON,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    STATE(1521), 1,
      sym__enum_body,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [89265] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8756), 1,
      anon_sym_SEMI,
    STATE(4192), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89296] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    STATE(4104), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89327] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8760), 1,
      anon_sym_SEMI,
    STATE(4182), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89358] = 14,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    ACTIONS(8762), 1,
      anon_sym_LBRACE,
    ACTIONS(8764), 1,
      anon_sym_SEMI,
    ACTIONS(8766), 1,
      anon_sym_COLON,
    STATE(1456), 1,
      sym__enum_body,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [89405] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(7308), 1,
      anon_sym_EQ_GT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3366), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89440] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8768), 1,
      anon_sym_SEMI,
    STATE(4106), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89471] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8768), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89502] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8770), 1,
      anon_sym_EQ_GT,
    STATE(3386), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89537] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8772), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89568] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8760), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89599] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8774), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89630] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8776), 1,
      anon_sym_EQ_GT,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89665] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8778), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89696] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8778), 1,
      anon_sym_SEMI,
    STATE(4149), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89727] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8780), 1,
      anon_sym_SEMI,
    STATE(4125), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89758] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(7021), 1,
      anon_sym_EQ_GT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3174), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89793] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89824] = 4,
    ACTIONS(8786), 1,
      anon_sym_DOT,
    ACTIONS(8788), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8784), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89851] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8790), 1,
      anon_sym_EQ_GT,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89886] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    STATE(4164), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [89917] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8792), 1,
      anon_sym_EQ_GT,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89952] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8794), 1,
      anon_sym_EQ_GT,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [89987] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8796), 1,
      anon_sym_EQ_GT,
    STATE(3350), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90022] = 8,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    ACTIONS(8798), 1,
      anon_sym_EQ_GT,
    STATE(5313), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90057] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8800), 1,
      anon_sym_SEMI,
    STATE(4119), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90088] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8800), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90119] = 4,
    ACTIONS(8788), 1,
      sym_in,
    ACTIONS(8802), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8784), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90146] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8804), 1,
      anon_sym_SEMI,
    STATE(4121), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90177] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8804), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90208] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8744), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90239] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8806), 1,
      anon_sym_SEMI,
    STATE(4183), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90270] = 8,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    ACTIONS(8808), 1,
      anon_sym_EQ_GT,
    STATE(5294), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90305] = 8,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    ACTIONS(8810), 1,
      anon_sym_EQ_GT,
    STATE(3448), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90340] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8812), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90371] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8814), 1,
      anon_sym_EQ_GT,
    STATE(3361), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90406] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8816), 1,
      anon_sym_EQ_GT,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90441] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8818), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90472] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8820), 1,
      anon_sym_EQ_GT,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90507] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8756), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90538] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8818), 1,
      anon_sym_SEMI,
    STATE(4185), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90569] = 8,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    ACTIONS(8822), 1,
      anon_sym_EQ_GT,
    STATE(5255), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90604] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8824), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90635] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8826), 1,
      anon_sym_EQ_GT,
    STATE(3211), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90670] = 5,
    ACTIONS(8828), 1,
      anon_sym_AT,
    ACTIONS(8831), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4156), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6937), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [90699] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8834), 1,
      anon_sym_EQ_GT,
    STATE(3339), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90734] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8836), 1,
      anon_sym_SEMI,
    STATE(4154), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90765] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(7210), 1,
      anon_sym_EQ_GT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3174), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90800] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90831] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    STATE(4129), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90862] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8840), 1,
      anon_sym_SEMI,
    STATE(4122), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90893] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8842), 1,
      anon_sym_EQ_GT,
    STATE(3193), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [90928] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8836), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [90959] = 5,
    ACTIONS(8535), 1,
      anon_sym_AT,
    ACTIONS(8844), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4156), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6770), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [90988] = 4,
    ACTIONS(8788), 1,
      sym_in,
    ACTIONS(8846), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8784), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91015] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8732), 1,
      anon_sym_SEMI,
    STATE(4199), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91046] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8848), 1,
      anon_sym_EQ_GT,
    STATE(3193), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91081] = 5,
    ACTIONS(8535), 1,
      anon_sym_AT,
    ACTIONS(8850), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4165), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(6792), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [91110] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8852), 1,
      anon_sym_EQ_GT,
    STATE(3182), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91145] = 8,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(7269), 1,
      anon_sym_EQ_GT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    STATE(3434), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91180] = 14,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    ACTIONS(8854), 1,
      anon_sym_LBRACE,
    ACTIONS(8856), 1,
      anon_sym_SEMI,
    ACTIONS(8858), 1,
      anon_sym_COLON,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(2288), 1,
      sym__enum_body,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [91227] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8860), 1,
      anon_sym_SEMI,
    STATE(4109), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91258] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8862), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91289] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(7362), 1,
      anon_sym_EQ_GT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    STATE(3366), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91324] = 14,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    ACTIONS(8864), 1,
      anon_sym_LBRACE,
    ACTIONS(8866), 1,
      anon_sym_SEMI,
    ACTIONS(8868), 1,
      anon_sym_COLON,
    STATE(2001), 1,
      sym__enum_body,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [91371] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8870), 1,
      anon_sym_SEMI,
    STATE(4151), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91402] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8872), 1,
      anon_sym_SEMI,
    STATE(4160), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91433] = 8,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    ACTIONS(8874), 1,
      anon_sym_EQ_GT,
    STATE(5304), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91468] = 8,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    ACTIONS(8876), 1,
      anon_sym_EQ_GT,
    STATE(3459), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91503] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(7503), 1,
      anon_sym_EQ_GT,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    STATE(3174), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91538] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8878), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91569] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8880), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91600] = 8,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8670), 1,
      sym_do,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8882), 1,
      anon_sym_EQ_GT,
    STATE(3224), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4243), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91635] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8884), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91666] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8886), 1,
      anon_sym_SEMI,
    STATE(4141), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91697] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8888), 1,
      anon_sym_SEMI,
    STATE(4123), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91728] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8890), 1,
      anon_sym_EQ_GT,
    STATE(3386), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91763] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8892), 1,
      anon_sym_EQ_GT,
    STATE(3339), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91798] = 8,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8674), 1,
      sym_do,
    ACTIONS(8894), 1,
      anon_sym_EQ_GT,
    STATE(3488), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4232), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91833] = 14,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    ACTIONS(8896), 1,
      anon_sym_LBRACE,
    ACTIONS(8898), 1,
      anon_sym_SEMI,
    ACTIONS(8900), 1,
      anon_sym_COLON,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(2349), 1,
      sym__enum_body,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [91880] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8806), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91911] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8888), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [91942] = 8,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8696), 1,
      sym_do,
    ACTIONS(8902), 1,
      anon_sym_EQ_GT,
    STATE(5268), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4238), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [91977] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8904), 1,
      anon_sym_EQ_GT,
    STATE(3361), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [92012] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8906), 1,
      anon_sym_SEMI,
    STATE(4193), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92043] = 8,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8694), 1,
      sym_do,
    ACTIONS(8908), 1,
      anon_sym_EQ_GT,
    STATE(3350), 2,
      sym_block_statement,
      sym__specified_function_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4246), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [92078] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
    STATE(4138), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92109] = 6,
    ACTIONS(8370), 1,
      anon_sym_AT,
    ACTIONS(8912), 1,
      anon_sym_SEMI,
    STATE(3839), 2,
      sym_member_function_attribute,
      aux_sym_alias_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3824), 3,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
    ACTIONS(8296), 8,
      sym_const,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92140] = 8,
    ACTIONS(7054), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(8916), 1,
      anon_sym_STAR,
    ACTIONS(8918), 1,
      sym_delegate,
    ACTIONS(8920), 1,
      sym_function,
    STATE(4217), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 7,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [92174] = 3,
    ACTIONS(8924), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8922), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92198] = 9,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8926), 1,
      anon_sym_SEMI,
    ACTIONS(8928), 1,
      sym_do,
    STATE(2212), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4346), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92234] = 3,
    ACTIONS(8932), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8930), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92258] = 8,
    ACTIONS(7083), 1,
      sym_identifier,
    ACTIONS(8934), 1,
      anon_sym_LBRACK,
    ACTIONS(8937), 1,
      anon_sym_STAR,
    ACTIONS(8940), 1,
      sym_delegate,
    ACTIONS(8943), 1,
      sym_function,
    STATE(4204), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7081), 7,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [92292] = 9,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8342), 1,
      sym_out,
    ACTIONS(8680), 1,
      sym_in,
    ACTIONS(8926), 1,
      anon_sym_SEMI,
    ACTIONS(8928), 1,
      sym_do,
    STATE(2212), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2199), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92328] = 9,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(8354), 1,
      sym_out,
    ACTIONS(8686), 1,
      sym_in,
    ACTIONS(8946), 1,
      anon_sym_SEMI,
    ACTIONS(8948), 1,
      sym_do,
    STATE(2409), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(2192), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92364] = 6,
    ACTIONS(8724), 1,
      anon_sym_BANG,
    ACTIONS(8950), 1,
      anon_sym_DOT,
    ACTIONS(8952), 1,
      anon_sym_LBRACK,
    STATE(4082), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7039), 10,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
  [92394] = 3,
    ACTIONS(8956), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8954), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92418] = 3,
    ACTIONS(8960), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8958), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92442] = 3,
    ACTIONS(8964), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8962), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92466] = 3,
    ACTIONS(8968), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8966), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92490] = 3,
    ACTIONS(8972), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8970), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92514] = 9,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(8314), 1,
      sym_out,
    ACTIONS(8678), 1,
      sym_in,
    ACTIONS(8974), 1,
      anon_sym_SEMI,
    ACTIONS(8976), 1,
      sym_do,
    STATE(1975), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1977), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92550] = 3,
    ACTIONS(8980), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8978), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92574] = 9,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(8338), 1,
      sym_out,
    ACTIONS(8682), 1,
      sym_in,
    ACTIONS(8982), 1,
      anon_sym_SEMI,
    ACTIONS(8984), 1,
      sym_do,
    STATE(1477), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1499), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92610] = 3,
    ACTIONS(8788), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8784), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92634] = 8,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(8918), 1,
      sym_delegate,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(8986), 1,
      anon_sym_STAR,
    STATE(4204), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7077), 7,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [92668] = 4,
    ACTIONS(8726), 1,
      anon_sym_LPAREN,
    STATE(4239), 1,
      sym_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5926), 12,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [92694] = 3,
    ACTIONS(8990), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8988), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92718] = 9,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(8326), 1,
      sym_out,
    ACTIONS(8684), 1,
      sym_in,
    ACTIONS(8992), 1,
      anon_sym_SEMI,
    ACTIONS(8994), 1,
      sym_do,
    STATE(1587), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(1590), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92754] = 3,
    ACTIONS(8998), 1,
      sym_in,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8996), 13,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_const,
      sym_do,
      sym_immutable,
      sym_inout,
      sym_nothrow,
      sym_out,
      sym_pure,
      sym_return,
      sym_scope,
      sym_shared,
  [92778] = 8,
    ACTIONS(7054), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(8918), 1,
      sym_delegate,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(8986), 1,
      anon_sym_STAR,
    STATE(4204), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 7,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [92812] = 8,
    ACTIONS(7073), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(8918), 1,
      sym_delegate,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(9000), 1,
      anon_sym_STAR,
    STATE(4222), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7071), 7,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [92846] = 9,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(8946), 1,
      anon_sym_SEMI,
    ACTIONS(9002), 1,
      sym_do,
    STATE(2409), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4346), 3,
      sym__in_out_statement,
      sym_in_statement,
      sym_out_statement,
    STATE(4227), 5,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
      aux_sym_function_body_repeat1,
  [92882] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9004), 1,
      anon_sym_DOT,
    ACTIONS(9006), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9010), 1,
      anon_sym_COLON,
    ACTIONS(9012), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(9008), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [92921] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3711), 1,
      sym_parameters,
    STATE(5182), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [92960] = 5,
    ACTIONS(9020), 1,
      sym_in,
    ACTIONS(9023), 1,
      sym_out,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9018), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_do,
    STATE(4227), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [92987] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3757), 1,
      sym_parameters,
    STATE(4994), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93026] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6855), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93047] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3810), 1,
      sym_parameters,
    STATE(5124), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93086] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6875), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93107] = 7,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(9026), 1,
      sym_do,
    STATE(3435), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4227), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [93138] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6883), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93159] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3812), 1,
      sym_parameters,
    STATE(5110), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93198] = 4,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7039), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [93223] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5946), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93244] = 4,
    ACTIONS(9028), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7212), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [93269] = 7,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(9030), 1,
      sym_do,
    STATE(5303), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4227), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [93300] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5954), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93321] = 7,
    ACTIONS(8519), 1,
      anon_sym_BANG,
    ACTIONS(9032), 1,
      anon_sym_DOT,
    ACTIONS(9034), 1,
      anon_sym_LBRACK,
    STATE(3865), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7039), 6,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [93352] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3745), 1,
      sym_parameters,
    STATE(4789), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93391] = 4,
    ACTIONS(9036), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 9,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_STAR,
  [93416] = 7,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(9038), 1,
      sym_do,
    STATE(3172), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4227), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [93447] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8519), 1,
      anon_sym_BANG,
    ACTIONS(9006), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9010), 1,
      anon_sym_COLON,
    ACTIONS(9012), 1,
      anon_sym_EQ,
    ACTIONS(9032), 1,
      anon_sym_DOT,
    ACTIONS(9034), 1,
      anon_sym_LBRACK,
    STATE(3865), 1,
      sym_template_arguments,
    ACTIONS(9040), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93486] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5950), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93507] = 7,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_out,
    ACTIONS(8672), 1,
      sym_in,
    ACTIONS(9043), 1,
      sym_do,
    STATE(3358), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4227), 8,
      sym__function_contract,
      sym__in_out_contract_expression,
      sym__in_out_statement,
      sym_in_contract_expression,
      sym_out_contract_expression,
      sym_in_statement,
      sym_out_statement,
      aux_sym_function_body_repeat1,
  [93538] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5958), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93559] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3721), 1,
      sym_parameters,
    STATE(4862), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93598] = 11,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(3715), 1,
      sym_parameters,
    STATE(4879), 1,
      sym_template_parameters,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93637] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6879), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93658] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6871), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93679] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6867), 13,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_EQ_GT,
      sym_delegate,
      sym_do,
      sym_function,
      sym_in,
      sym_nothrow,
      sym_out,
      sym_pure,
  [93700] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9045), 1,
      anon_sym_EQ,
    ACTIONS(9047), 1,
      sym_this,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(6069), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93738] = 8,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_STAR,
    ACTIONS(9051), 1,
      sym_delegate,
    ACTIONS(9053), 1,
      sym_function,
    STATE(4257), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7077), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [93770] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9045), 1,
      anon_sym_EQ,
    ACTIONS(9055), 1,
      sym_this,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(6069), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93808] = 8,
    ACTIONS(7054), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9049), 1,
      anon_sym_STAR,
    ACTIONS(9051), 1,
      sym_delegate,
    ACTIONS(9053), 1,
      sym_function,
    STATE(4257), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [93840] = 8,
    ACTIONS(7083), 1,
      sym_identifier,
    ACTIONS(8934), 1,
      anon_sym_LBRACK,
    ACTIONS(9057), 1,
      anon_sym_STAR,
    ACTIONS(9060), 1,
      sym_delegate,
    ACTIONS(9063), 1,
      sym_function,
    STATE(4257), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7081), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [93872] = 10,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9068), 1,
      anon_sym_COLON,
    ACTIONS(9070), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(9066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93908] = 3,
    ACTIONS(9072), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7212), 11,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
  [93930] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9045), 1,
      anon_sym_EQ,
    ACTIONS(9074), 1,
      sym_this,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(6069), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [93968] = 8,
    ACTIONS(7054), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9051), 1,
      sym_delegate,
    ACTIONS(9053), 1,
      sym_function,
    ACTIONS(9076), 1,
      anon_sym_STAR,
    STATE(4254), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [94000] = 3,
    ACTIONS(8950), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7039), 11,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
  [94022] = 3,
    ACTIONS(9078), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7106), 11,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_STAR,
      sym_delegate,
      sym_do,
      sym_function,
      sym_if,
      sym_in,
      sym_out,
  [94044] = 8,
    ACTIONS(7073), 1,
      sym_identifier,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9051), 1,
      sym_delegate,
    ACTIONS(9053), 1,
      sym_function,
    ACTIONS(9080), 1,
      anon_sym_STAR,
    STATE(4256), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7071), 5,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [94076] = 5,
    ACTIONS(8710), 1,
      anon_sym_AT,
    ACTIONS(8712), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4048), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(9082), 5,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      sym_do,
      sym_in,
      sym_out,
  [94102] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9045), 1,
      anon_sym_EQ,
    ACTIONS(9084), 1,
      sym_this,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(6069), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94140] = 5,
    ACTIONS(8710), 1,
      anon_sym_AT,
    ACTIONS(9088), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4265), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
    ACTIONS(9086), 5,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      sym_do,
      sym_in,
      sym_out,
  [94166] = 11,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9045), 1,
      anon_sym_EQ,
    ACTIONS(9090), 1,
      sym_this,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(6069), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94204] = 4,
    ACTIONS(9092), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7216), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94227] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9094), 1,
      anon_sym_STAR,
    ACTIONS(9096), 1,
      sym_delegate,
    ACTIONS(9098), 1,
      sym_function,
    STATE(4283), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7071), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      sym_do,
      sym_in,
      sym_out,
  [94256] = 4,
    ACTIONS(9100), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7216), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [94279] = 9,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9104), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(9102), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94312] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7154), 4,
      sym_identifier,
      anon_sym_DOT,
      sym_delegate,
      sym_function,
    ACTIONS(7156), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94333] = 4,
    ACTIONS(9106), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7212), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94356] = 4,
    ACTIONS(9032), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7039), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94379] = 4,
    ACTIONS(9108), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR,
  [94402] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9096), 1,
      sym_delegate,
    ACTIONS(9098), 1,
      sym_function,
    ACTIONS(9110), 1,
      anon_sym_STAR,
    STATE(4288), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      sym_do,
      sym_in,
      sym_out,
  [94431] = 10,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94466] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7299), 4,
      sym_identifier,
      anon_sym_DOT,
      sym_delegate,
      sym_function,
    ACTIONS(7297), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94487] = 5,
    ACTIONS(9108), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(8071), 3,
      anon_sym_RBRACE,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(7106), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
  [94512] = 7,
    ACTIONS(8934), 1,
      anon_sym_LBRACK,
    ACTIONS(9112), 1,
      anon_sym_STAR,
    ACTIONS(9115), 1,
      sym_delegate,
    ACTIONS(9118), 1,
      sym_function,
    STATE(4281), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7081), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      sym_do,
      sym_in,
      sym_out,
  [94541] = 4,
    ACTIONS(9121), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94564] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9096), 1,
      sym_delegate,
    ACTIONS(9098), 1,
      sym_function,
    ACTIONS(9123), 1,
      anon_sym_STAR,
    STATE(4281), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      sym_do,
      sym_in,
      sym_out,
  [94593] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9125), 1,
      anon_sym_DOT,
    ACTIONS(9127), 1,
      anon_sym_LBRACK,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7039), 4,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [94622] = 4,
    ACTIONS(9129), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 7,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
  [94645] = 6,
    ACTIONS(6712), 1,
      anon_sym_BANG,
    ACTIONS(9131), 1,
      anon_sym_DOT,
    ACTIONS(9133), 1,
      anon_sym_LBRACK,
    STATE(2570), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7039), 7,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [94672] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(8874), 1,
      anon_sym_EQ_GT,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7039), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [94701] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9096), 1,
      sym_delegate,
    ACTIONS(9098), 1,
      sym_function,
    ACTIONS(9123), 1,
      anon_sym_STAR,
    STATE(4281), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7077), 5,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      sym_do,
      sym_in,
      sym_out,
  [94730] = 8,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9135), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94760] = 7,
    ACTIONS(8934), 1,
      anon_sym_LBRACK,
    ACTIONS(9137), 1,
      anon_sym_STAR,
    ACTIONS(9140), 1,
      sym_delegate,
    ACTIONS(9143), 1,
      sym_function,
    STATE(4290), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7081), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [94788] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9146), 1,
      anon_sym_STAR,
    ACTIONS(9148), 1,
      sym_delegate,
    ACTIONS(9150), 1,
      sym_function,
    STATE(4290), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7077), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [94816] = 8,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9152), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94846] = 8,
    ACTIONS(7054), 1,
      sym_identifier,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(9154), 1,
      anon_sym_LBRACK,
    ACTIONS(9156), 1,
      anon_sym_STAR,
    ACTIONS(9158), 1,
      sym_delegate,
    STATE(4296), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
  [94876] = 8,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9160), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94906] = 8,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9162), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [94936] = 8,
    ACTIONS(7079), 1,
      sym_identifier,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(9154), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      sym_delegate,
    ACTIONS(9164), 1,
      anon_sym_STAR,
    STATE(4299), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7077), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
  [94966] = 8,
    ACTIONS(7073), 1,
      sym_identifier,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(9154), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      sym_delegate,
    ACTIONS(9166), 1,
      anon_sym_STAR,
    STATE(4304), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7071), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
  [94996] = 8,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9168), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [95026] = 8,
    ACTIONS(7083), 1,
      sym_identifier,
    ACTIONS(8943), 1,
      sym_function,
    ACTIONS(9170), 1,
      anon_sym_LBRACK,
    ACTIONS(9173), 1,
      anon_sym_STAR,
    ACTIONS(9176), 1,
      sym_delegate,
    STATE(4299), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7081), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
  [95056] = 8,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    ACTIONS(9179), 1,
      anon_sym_EQ,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(7039), 2,
      anon_sym_COLON,
      anon_sym_STAR,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [95086] = 8,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(9181), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [95116] = 8,
    ACTIONS(7039), 1,
      anon_sym_STAR,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(8728), 1,
      anon_sym_DOT,
    ACTIONS(8730), 1,
      anon_sym_LBRACK,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(9183), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
  [95146] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9148), 1,
      sym_delegate,
    ACTIONS(9150), 1,
      sym_function,
    ACTIONS(9185), 1,
      anon_sym_STAR,
    STATE(4291), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [95174] = 8,
    ACTIONS(7054), 1,
      sym_identifier,
    ACTIONS(8920), 1,
      sym_function,
    ACTIONS(9154), 1,
      anon_sym_LBRACK,
    ACTIONS(9158), 1,
      sym_delegate,
    ACTIONS(9164), 1,
      anon_sym_STAR,
    STATE(4299), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
  [95204] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9148), 1,
      sym_delegate,
    ACTIONS(9150), 1,
      sym_function,
    ACTIONS(9187), 1,
      anon_sym_STAR,
    STATE(4306), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7071), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [95232] = 7,
    ACTIONS(8914), 1,
      anon_sym_LBRACK,
    ACTIONS(9146), 1,
      anon_sym_STAR,
    ACTIONS(9148), 1,
      sym_delegate,
    ACTIONS(9150), 1,
      sym_function,
    STATE(4290), 2,
      sym__type_suffix,
      aux_sym_type_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7052), 4,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [95260] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4783), 9,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_catch,
      sym_do,
      sym_else,
      sym_finally,
      sym_in,
      sym_out,
      sym_while,
  [95277] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9191), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [95304] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6199), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95327] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6296), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95350] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5829), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95373] = 4,
    ACTIONS(9195), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7212), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [95394] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4516), 9,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_catch,
      sym_do,
      sym_else,
      sym_finally,
      sym_in,
      sym_out,
      sym_while,
  [95411] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9197), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [95438] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6292), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95461] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9199), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [95488] = 3,
    ACTIONS(9131), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7039), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [95507] = 3,
    ACTIONS(9201), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7106), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [95526] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5937), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95549] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6360), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95572] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5661), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95595] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5654), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95618] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6274), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95641] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6065), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95664] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9203), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [95691] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3178), 9,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_catch,
      sym_do,
      sym_else,
      sym_finally,
      sym_in,
      sym_out,
      sym_while,
  [95708] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5704), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95731] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5895), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95754] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6331), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95777] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5664), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95800] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4779), 9,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_catch,
      sym_do,
      sym_else,
      sym_finally,
      sym_in,
      sym_out,
      sym_while,
  [95817] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5681), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95840] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6341), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95863] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6021), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95886] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9205), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [95913] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6198), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95936] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6050), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [95959] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4757), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(6054), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_do,
      sym_in,
      sym_out,
  [95978] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6086), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96001] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5925), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96024] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9207), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96051] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7156), 9,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [96068] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6090), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96091] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7297), 9,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [96108] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6109), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96131] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4881), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
    ACTIONS(6054), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_do,
      sym_in,
      sym_out,
  [96150] = 10,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9211), 1,
      anon_sym_RPAREN,
    ACTIONS(9213), 1,
      anon_sym_COMMA,
    ACTIONS(9215), 1,
      anon_sym_EQ,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(5069), 1,
      aux_sym__parameters_repeat1,
    STATE(5071), 1,
      sym_ellipses,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [96183] = 4,
    ACTIONS(9125), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7002), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7039), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [96204] = 10,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9213), 1,
      anon_sym_COMMA,
    ACTIONS(9215), 1,
      anon_sym_EQ,
    ACTIONS(9217), 1,
      anon_sym_RPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(5069), 1,
      aux_sym__parameters_repeat1,
    STATE(5071), 1,
      sym_ellipses,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [96237] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9219), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96264] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9221), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96291] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5753), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96314] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6057), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96337] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5671), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96360] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5806), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96383] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5932), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96406] = 4,
    ACTIONS(9223), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [96427] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5791), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96450] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6450), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96473] = 10,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9213), 1,
      anon_sym_COMMA,
    ACTIONS(9215), 1,
      anon_sym_EQ,
    ACTIONS(9225), 1,
      anon_sym_RPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(5069), 1,
      aux_sym__parameters_repeat1,
    STATE(5071), 1,
      sym_ellipses,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [96506] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9227), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96533] = 3,
    ACTIONS(9229), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7212), 8,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [96552] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6080), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96575] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6093), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96598] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(5968), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96621] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6300), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96644] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(6100), 1,
      sym_ellipses,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9193), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96667] = 7,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    ACTIONS(9231), 1,
      anon_sym_RBRACE,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96694] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3129), 9,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_catch,
      sym_do,
      sym_else,
      sym_finally,
      sym_in,
      sym_out,
      sym_while,
  [96711] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3165), 9,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_catch,
      sym_do,
      sym_else,
      sym_finally,
      sym_in,
      sym_out,
      sym_while,
  [96728] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9233), 1,
      anon_sym_LBRACE,
    ACTIONS(9235), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3936), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [96750] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(1042), 1,
      sym_template,
    ACTIONS(9237), 1,
      sym_identifier,
    ACTIONS(9239), 1,
      anon_sym_DOT,
    ACTIONS(9241), 1,
      anon_sym_LPAREN,
    STATE(2312), 1,
      sym_template_declaration,
    STATE(4465), 1,
      sym_template_instance,
    STATE(6222), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [96780] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9243), 1,
      anon_sym_LBRACE,
    ACTIONS(9245), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4371), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [96802] = 4,
    ACTIONS(9247), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(4374), 2,
      aux_sym__variadic_arguments_attributes,
      sym_variadic_arguments_attribute,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9249), 5,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [96822] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(759), 1,
      sym_template,
    ACTIONS(9241), 1,
      anon_sym_LPAREN,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_DOT,
    STATE(2053), 1,
      sym_template_declaration,
    STATE(4504), 1,
      sym_template_instance,
    STATE(6260), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [96852] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(5066), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96876] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7137), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7139), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [96894] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(4927), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96918] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(5584), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [96942] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7254), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7252), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [96960] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7248), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7246), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [96978] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9256), 1,
      anon_sym_LBRACE,
    ACTIONS(9258), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4393), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [97000] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(365), 1,
      sym_template,
    ACTIONS(9260), 1,
      sym_identifier,
    ACTIONS(9262), 1,
      anon_sym_DOT,
    ACTIONS(9264), 1,
      anon_sym_LPAREN,
    STATE(1388), 1,
      sym_template_declaration,
    STATE(4494), 1,
      sym_template_instance,
    STATE(6169), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97030] = 9,
    ACTIONS(65), 1,
      sym_template,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(9264), 1,
      anon_sym_LPAREN,
    ACTIONS(9266), 1,
      sym_identifier,
    ACTIONS(9268), 1,
      anon_sym_DOT,
    STATE(2415), 1,
      sym_template_declaration,
    STATE(4508), 1,
      sym_template_instance,
    STATE(6339), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97060] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(759), 1,
      sym_template,
    ACTIONS(9252), 1,
      sym_identifier,
    ACTIONS(9254), 1,
      anon_sym_DOT,
    ACTIONS(9264), 1,
      anon_sym_LPAREN,
    STATE(2053), 1,
      sym_template_declaration,
    STATE(4504), 1,
      sym_template_instance,
    STATE(6260), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97090] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9270), 1,
      anon_sym_LBRACE,
    ACTIONS(9235), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3936), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [97112] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7218), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7216), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97130] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(365), 1,
      sym_template,
    ACTIONS(9241), 1,
      anon_sym_LPAREN,
    ACTIONS(9260), 1,
      sym_identifier,
    ACTIONS(9262), 1,
      anon_sym_DOT,
    STATE(1388), 1,
      sym_template_declaration,
    STATE(4494), 1,
      sym_template_instance,
    STATE(6169), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97160] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7214), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7212), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97178] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7173), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7175), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97196] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7204), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7202), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97214] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7169), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7171), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97232] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9272), 1,
      anon_sym_LBRACE,
    ACTIONS(9235), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3936), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [97254] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6772), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(6770), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97272] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9274), 1,
      anon_sym_LBRACE,
    ACTIONS(9235), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(3936), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [97294] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(5087), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [97318] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(4842), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [97342] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9276), 1,
      anon_sym_LBRACE,
    ACTIONS(9278), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4395), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [97364] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(1042), 1,
      sym_template,
    ACTIONS(9237), 1,
      sym_identifier,
    ACTIONS(9239), 1,
      anon_sym_DOT,
    ACTIONS(9264), 1,
      anon_sym_LPAREN,
    STATE(2312), 1,
      sym_template_declaration,
    STATE(4465), 1,
      sym_template_instance,
    STATE(6222), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97394] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9280), 1,
      anon_sym_LBRACE,
    ACTIONS(9282), 2,
      sym_nothrow,
      sym_pure,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4386), 4,
      sym_at_attribute,
      sym__function_attribute_kwd,
      sym__function_attribute,
      aux_sym__type_suffix_repeat1,
  [97416] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7222), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7220), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97434] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6794), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(6792), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97452] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(187), 1,
      sym_template,
    ACTIONS(9241), 1,
      anon_sym_LPAREN,
    ACTIONS(9284), 1,
      sym_identifier,
    ACTIONS(9286), 1,
      anon_sym_DOT,
    STATE(1586), 1,
      sym_template_declaration,
    STATE(4477), 1,
      sym_template_instance,
    STATE(6073), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97482] = 3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7285), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7283), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_STAR,
  [97500] = 9,
    ACTIONS(65), 1,
      sym_template,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(9241), 1,
      anon_sym_LPAREN,
    ACTIONS(9266), 1,
      sym_identifier,
    ACTIONS(9268), 1,
      anon_sym_DOT,
    STATE(2415), 1,
      sym_template_declaration,
    STATE(4508), 1,
      sym_template_instance,
    STATE(6339), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97530] = 9,
    ACTIONS(67), 1,
      sym_typeof,
    ACTIONS(187), 1,
      sym_template,
    ACTIONS(9264), 1,
      anon_sym_LPAREN,
    ACTIONS(9284), 1,
      sym_identifier,
    ACTIONS(9286), 1,
      anon_sym_DOT,
    STATE(1586), 1,
      sym_template_declaration,
    STATE(4477), 1,
      sym_template_instance,
    STATE(6073), 1,
      sym_typeof_expression,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97560] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9189), 1,
      sym_identifier,
    STATE(5032), 1,
      sym_enum_member,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4412), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [97584] = 6,
    ACTIONS(9288), 1,
      sym_catch,
    ACTIONS(9290), 1,
      sym_finally,
    STATE(4647), 1,
      sym_finally_statement,
    ACTIONS(4192), 2,
      sym_else,
      sym_while,
    STATE(4532), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97607] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9296), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9298), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9292), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4411), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97630] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9300), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97653] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9306), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97676] = 5,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(6891), 1,
      sym_deprecated,
    ACTIONS(9308), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4427), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [97697] = 5,
    ACTIONS(9310), 1,
      anon_sym_EQ_GT,
    ACTIONS(9312), 1,
      sym_in,
    ACTIONS(9314), 1,
      sym_out,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4419), 4,
      aux_sym__in_out_contract_expressions,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [97718] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9316), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97741] = 6,
    ACTIONS(9320), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9323), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9326), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9318), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97764] = 6,
    ACTIONS(9288), 1,
      sym_catch,
    ACTIONS(9329), 1,
      sym_finally,
    STATE(4666), 1,
      sym_finally_statement,
    ACTIONS(4184), 2,
      sym_else,
      sym_while,
    STATE(4422), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97787] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9331), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97810] = 6,
    ACTIONS(9288), 1,
      sym_catch,
    ACTIONS(9290), 1,
      sym_finally,
    STATE(4666), 1,
      sym_finally_statement,
    ACTIONS(4184), 2,
      sym_else,
      sym_while,
    STATE(4408), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97833] = 5,
    ACTIONS(9333), 1,
      anon_sym_EQ_GT,
    ACTIONS(9335), 1,
      sym_in,
    ACTIONS(9338), 1,
      sym_out,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4419), 4,
      aux_sym__in_out_contract_expressions,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [97854] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9343), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9345), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9341), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4423), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97877] = 5,
    ACTIONS(9312), 1,
      sym_in,
    ACTIONS(9314), 1,
      sym_out,
    ACTIONS(9347), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4419), 4,
      aux_sym__in_out_contract_expressions,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [97898] = 6,
    ACTIONS(9288), 1,
      sym_catch,
    ACTIONS(9329), 1,
      sym_finally,
    STATE(4647), 1,
      sym_finally_statement,
    ACTIONS(4192), 2,
      sym_else,
      sym_while,
    STATE(4532), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97921] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9349), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97944] = 3,
    ACTIONS(9351), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7106), 6,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [97961] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9353), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [97984] = 5,
    ACTIONS(9312), 1,
      sym_in,
    ACTIONS(9314), 1,
      sym_out,
    ACTIONS(9355), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4419), 4,
      aux_sym__in_out_contract_expressions,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [98005] = 5,
    ACTIONS(9357), 1,
      sym_identifier,
    ACTIONS(9359), 1,
      anon_sym_AT,
    ACTIONS(9362), 1,
      sym_deprecated,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4427), 4,
      sym_deprecated_attribute,
      sym_at_attribute,
      sym__enum_member_attribute,
      aux_sym_enum_member_repeat1,
  [98026] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9367), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9369), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9365), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4417), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98049] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9373), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9375), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9371), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4447), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98072] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9379), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9381), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9377), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4444), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98095] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9385), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9387), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9383), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4410), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98118] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3721), 1,
      sym_parameters,
    STATE(4865), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98143] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3757), 1,
      sym_parameters,
    STATE(4935), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98168] = 4,
    ACTIONS(9395), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 3,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
  [98187] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9399), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9401), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9397), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4414), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98210] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9405), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9407), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9403), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4442), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98233] = 8,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9209), 1,
      sym_identifier,
    ACTIONS(9213), 1,
      anon_sym_COMMA,
    ACTIONS(9215), 1,
      anon_sym_EQ,
    ACTIONS(9409), 1,
      anon_sym_RPAREN,
    STATE(5069), 1,
      aux_sym__parameters_repeat1,
    STATE(5071), 1,
      sym_ellipses,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98260] = 4,
    ACTIONS(9411), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 3,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
  [98279] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9413), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98302] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3745), 1,
      sym_parameters,
    STATE(4787), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98327] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3715), 1,
      sym_parameters,
    STATE(4853), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98352] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9415), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98375] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3711), 1,
      sym_parameters,
    STATE(5203), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98400] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9417), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98423] = 5,
    ACTIONS(9312), 1,
      sym_in,
    ACTIONS(9314), 1,
      sym_out,
    ACTIONS(9419), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4419), 4,
      aux_sym__in_out_contract_expressions,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [98444] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9423), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9425), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9421), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4453), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98467] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9427), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98490] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9431), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9433), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9429), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4458), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98513] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3810), 1,
      sym_parameters,
    STATE(5126), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98538] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9435), 7,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ_GT,
      sym_do,
      sym_in,
      sym_out,
  [98553] = 4,
    ACTIONS(9437), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 3,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
  [98572] = 5,
    ACTIONS(9312), 1,
      sym_in,
    ACTIONS(9314), 1,
      sym_out,
    ACTIONS(9439), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    STATE(4419), 4,
      aux_sym__in_out_contract_expressions,
      sym__in_out_contract_expression,
      sym_in_contract_expression,
      sym_out_contract_expression,
  [98593] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9441), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98616] = 4,
    ACTIONS(9443), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 3,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
  [98635] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9447), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9449), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9445), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4425), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98658] = 4,
    ACTIONS(9451), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7101), 3,
      sym_identifier,
      sym_delegate,
      sym_function,
    ACTIONS(7106), 3,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_STAR,
  [98677] = 8,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6764), 1,
      anon_sym_RPAREN,
    ACTIONS(9453), 1,
      sym_identifier,
    ACTIONS(9455), 1,
      anon_sym_COMMA,
    ACTIONS(9457), 1,
      anon_sym_EQ,
    STATE(4768), 1,
      aux_sym__parameters_repeat1,
    STATE(4772), 1,
      sym_ellipses,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98704] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9459), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98727] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9302), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9304), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9461), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4415), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98750] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9465), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9467), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9463), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4459), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98773] = 3,
    ACTIONS(9469), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7216), 6,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [98790] = 6,
    ACTIONS(9294), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(9473), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(9475), 1,
      aux_sym_interpolated_raw_string_token2,
    ACTIONS(9471), 2,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_BQUOTE,
    STATE(4439), 2,
      sym_interpolation_expression,
      aux_sym_interpolated_raw_string_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98813] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(3812), 1,
      sym_parameters,
    STATE(5123), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98838] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9477), 1,
      sym_identifier,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9481), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5206), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98862] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9483), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      anon_sym_SEMI,
    STATE(4483), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5519), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98886] = 7,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4137), 1,
      sym_parameters,
    STATE(4957), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5557), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98910] = 6,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9489), 1,
      sym_deprecated,
    ACTIONS(9491), 1,
      sym_module,
    STATE(4660), 1,
      sym_deprecated_attribute,
    STATE(4605), 2,
      sym_at_attribute,
      aux_sym_module_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98932] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9495), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5252), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98956] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9497), 1,
      sym_identifier,
    ACTIONS(9499), 1,
      anon_sym_SEMI,
    STATE(4523), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4708), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [98980] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9495), 1,
      anon_sym_SEMI,
    STATE(4464), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5252), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99004] = 4,
    ACTIONS(9501), 1,
      anon_sym_EQ_GT,
    ACTIONS(9503), 2,
      sym_in,
      sym_out,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(6054), 3,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      sym_do,
  [99022] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9506), 1,
      sym_identifier,
    ACTIONS(9508), 1,
      anon_sym_SEMI,
    STATE(4515), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5222), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99046] = 3,
    ACTIONS(9510), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7106), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [99062] = 6,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9512), 1,
      sym_identifier,
    ACTIONS(9516), 1,
      anon_sym_EQ,
    STATE(5425), 1,
      sym_ellipses,
    ACTIONS(9514), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99084] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9506), 1,
      sym_identifier,
    ACTIONS(9508), 1,
      anon_sym_SEMI,
    STATE(4515), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4699), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99108] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9506), 1,
      sym_identifier,
    ACTIONS(9508), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5222), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99132] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9518), 1,
      sym_identifier,
    ACTIONS(9520), 1,
      anon_sym_SEMI,
    STATE(4534), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5230), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99156] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9518), 1,
      sym_identifier,
    ACTIONS(9520), 1,
      anon_sym_SEMI,
    STATE(4534), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4708), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99180] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9524), 1,
      anon_sym_SEMI,
    ACTIONS(9526), 1,
      anon_sym_COLON,
    STATE(1524), 1,
      sym_aggregate_body,
    STATE(4592), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99204] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9528), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      anon_sym_SEMI,
    STATE(4509), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5562), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99228] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9532), 1,
      anon_sym_SEMI,
    ACTIONS(9534), 1,
      anon_sym_COLON,
    STATE(1520), 1,
      sym_aggregate_body,
    STATE(4521), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99252] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9528), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      anon_sym_SEMI,
    STATE(4509), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4699), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99276] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9528), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5562), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99300] = 7,
    ACTIONS(8780), 1,
      anon_sym_SEMI,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4126), 1,
      sym_parameters,
    STATE(4985), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5496), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99324] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9538), 1,
      anon_sym_SEMI,
    ACTIONS(9540), 1,
      anon_sym_COLON,
    STATE(1455), 1,
      sym_aggregate_body,
    STATE(4514), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99348] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9542), 6,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      sym_do,
      sym_in,
      sym_out,
  [99362] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9544), 1,
      sym_identifier,
    ACTIONS(9546), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5395), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99386] = 7,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9550), 1,
      anon_sym_SEMI,
    ACTIONS(9552), 1,
      anon_sym_COLON,
    STATE(2418), 1,
      sym_aggregate_body,
    STATE(4926), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99410] = 6,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9554), 1,
      sym_identifier,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(4905), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99432] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    ACTIONS(9558), 1,
      anon_sym_SEMI,
    STATE(4198), 1,
      sym_parameters,
    STATE(4925), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5563), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99456] = 7,
    ACTIONS(8872), 1,
      anon_sym_SEMI,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4114), 1,
      sym_parameters,
    STATE(4964), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5326), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99480] = 6,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9560), 1,
      sym_identifier,
    ACTIONS(9564), 1,
      anon_sym_EQ,
    STATE(5525), 1,
      sym_ellipses,
    ACTIONS(9562), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99502] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9566), 6,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_if,
  [99516] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9497), 1,
      sym_identifier,
    ACTIONS(9499), 1,
      anon_sym_SEMI,
    STATE(4523), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5333), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99540] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9495), 1,
      anon_sym_SEMI,
    STATE(4464), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4717), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99564] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9570), 1,
      anon_sym_SEMI,
    ACTIONS(9572), 1,
      anon_sym_COLON,
    STATE(2278), 1,
      sym_aggregate_body,
    STATE(4540), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99588] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9576), 1,
      anon_sym_SEMI,
    ACTIONS(9578), 1,
      anon_sym_COLON,
    STATE(2005), 1,
      sym_aggregate_body,
    STATE(4545), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99612] = 7,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6756), 1,
      anon_sym_RPAREN,
    ACTIONS(8044), 1,
      anon_sym_COMMA,
    ACTIONS(9580), 1,
      anon_sym_EQ,
    STATE(5037), 1,
      sym_ellipses,
    STATE(5038), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99636] = 5,
    ACTIONS(9582), 1,
      anon_sym_DOT,
    ACTIONS(9586), 1,
      anon_sym_EQ,
    STATE(4550), 1,
      aux_sym_module_fqn_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9584), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [99656] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9588), 1,
      sym_identifier,
    ACTIONS(9590), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5543), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99680] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9592), 1,
      anon_sym_SEMI,
    ACTIONS(9594), 1,
      anon_sym_COLON,
    STATE(1994), 1,
      sym_aggregate_body,
    STATE(4566), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99704] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9596), 1,
      anon_sym_SEMI,
    ACTIONS(9598), 1,
      anon_sym_COLON,
    STATE(2309), 1,
      sym_aggregate_body,
    STATE(4577), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99728] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      sym_identifier,
    ACTIONS(9602), 1,
      anon_sym_SEMI,
    STATE(4559), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4708), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99752] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9600), 1,
      sym_identifier,
    ACTIONS(9602), 1,
      anon_sym_SEMI,
    STATE(4559), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5599), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99776] = 7,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(6764), 1,
      anon_sym_RPAREN,
    ACTIONS(9455), 1,
      anon_sym_COMMA,
    ACTIONS(9457), 1,
      anon_sym_EQ,
    STATE(4768), 1,
      aux_sym__parameters_repeat1,
    STATE(4772), 1,
      sym_ellipses,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99800] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9588), 1,
      sym_identifier,
    ACTIONS(9590), 1,
      anon_sym_SEMI,
    STATE(4556), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4717), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99824] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9604), 1,
      sym_identifier,
    ACTIONS(9606), 1,
      anon_sym_SEMI,
    STATE(4476), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4708), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99848] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9604), 1,
      sym_identifier,
    ACTIONS(9606), 1,
      anon_sym_SEMI,
    STATE(4476), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5540), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99872] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9608), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5578), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99896] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9608), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_SEMI,
    STATE(4552), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4717), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99920] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    ACTIONS(9612), 1,
      anon_sym_SEMI,
    STATE(4178), 1,
      sym_parameters,
    STATE(5070), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5291), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99944] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9608), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_SEMI,
    STATE(4552), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5578), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99968] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    ACTIONS(9614), 1,
      anon_sym_SEMI,
    STATE(4161), 1,
      sym_parameters,
    STATE(4844), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5553), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [99992] = 7,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9616), 1,
      anon_sym_SEMI,
    ACTIONS(9618), 1,
      anon_sym_COLON,
    STATE(1482), 1,
      sym_aggregate_body,
    STATE(4843), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100016] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9620), 1,
      sym_identifier,
    ACTIONS(9622), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5432), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100040] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9483), 1,
      sym_identifier,
    ACTIONS(9485), 1,
      anon_sym_SEMI,
    STATE(4483), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4708), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100064] = 4,
    ACTIONS(9582), 1,
      anon_sym_DOT,
    STATE(4550), 1,
      aux_sym_module_fqn_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9584), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [100082] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9624), 1,
      anon_sym_SEMI,
    ACTIONS(9626), 1,
      anon_sym_COLON,
    STATE(2352), 1,
      sym_aggregate_body,
    STATE(4576), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100106] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9628), 1,
      anon_sym_SEMI,
    ACTIONS(9630), 1,
      anon_sym_COLON,
    STATE(2348), 1,
      sym_aggregate_body,
    STATE(4488), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100130] = 6,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9632), 1,
      sym_identifier,
    ACTIONS(9636), 1,
      anon_sym_EQ,
    STATE(5602), 1,
      sym_ellipses,
    ACTIONS(9634), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100152] = 7,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9638), 1,
      anon_sym_SEMI,
    ACTIONS(9640), 1,
      anon_sym_COLON,
    STATE(1597), 1,
      sym_aggregate_body,
    STATE(5067), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100176] = 6,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(5176), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100198] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9646), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5404), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100222] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9646), 1,
      anon_sym_SEMI,
    STATE(4541), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4699), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100246] = 7,
    ACTIONS(8870), 1,
      anon_sym_SEMI,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4113), 1,
      sym_parameters,
    STATE(4915), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5394), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100270] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9588), 1,
      sym_identifier,
    ACTIONS(9590), 1,
      anon_sym_SEMI,
    STATE(4556), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5543), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100294] = 3,
    ACTIONS(9648), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7216), 5,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      sym_delegate,
      sym_function,
  [100310] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9650), 6,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      sym_do,
      sym_in,
      sym_out,
  [100324] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9646), 1,
      anon_sym_SEMI,
    STATE(4541), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5404), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100348] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9620), 1,
      sym_identifier,
    ACTIONS(9622), 1,
      anon_sym_SEMI,
    STATE(4565), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4717), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100372] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9620), 1,
      sym_identifier,
    ACTIONS(9622), 1,
      anon_sym_SEMI,
    STATE(4565), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5432), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100396] = 4,
    ACTIONS(9652), 1,
      sym_catch,
    STATE(4532), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4198), 3,
      sym_else,
      sym_finally,
      sym_while,
  [100414] = 6,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9655), 1,
      sym_identifier,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(4970), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100436] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9657), 1,
      sym_identifier,
    ACTIONS(9659), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5249), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100460] = 6,
    ACTIONS(4184), 1,
      sym_while,
    ACTIONS(9661), 1,
      sym_catch,
    ACTIONS(9663), 1,
      sym_finally,
    STATE(4666), 1,
      sym_finally_statement,
    STATE(4555), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100482] = 6,
    ACTIONS(4192), 1,
      sym_while,
    ACTIONS(9661), 1,
      sym_catch,
    ACTIONS(9665), 1,
      sym_finally,
    STATE(4647), 1,
      sym_finally_statement,
    STATE(4608), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100504] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9667), 1,
      sym_identifier,
    ACTIONS(9669), 1,
      anon_sym_SEMI,
    STATE(4487), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5373), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100528] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9667), 1,
      sym_identifier,
    ACTIONS(9669), 1,
      anon_sym_SEMI,
    STATE(4487), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4717), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100552] = 6,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9516), 1,
      anon_sym_EQ,
    ACTIONS(9671), 1,
      sym_identifier,
    STATE(5425), 1,
      sym_ellipses,
    ACTIONS(9514), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100574] = 7,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9673), 1,
      anon_sym_SEMI,
    ACTIONS(9675), 1,
      anon_sym_COLON,
    STATE(2248), 1,
      sym_aggregate_body,
    STATE(5030), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100598] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9667), 1,
      sym_identifier,
    ACTIONS(9669), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5373), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100622] = 6,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9677), 1,
      sym_identifier,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(5148), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100644] = 6,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9679), 1,
      sym_identifier,
    STATE(3255), 1,
      sym_named_arguments,
    STATE(4763), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100666] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    ACTIONS(9681), 1,
      anon_sym_SEMI,
    STATE(4127), 1,
      sym_parameters,
    STATE(5094), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5507), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100690] = 7,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9683), 1,
      anon_sym_SEMI,
    ACTIONS(9685), 1,
      anon_sym_COLON,
    STATE(1986), 1,
      sym_aggregate_body,
    STATE(5088), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100714] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9687), 6,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_EQ_GT,
      sym_do,
      sym_in,
      sym_out,
  [100728] = 7,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    ACTIONS(9689), 1,
      anon_sym_SEMI,
    STATE(4177), 1,
      sym_parameters,
    STATE(4971), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5349), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100752] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9391), 1,
      anon_sym_COLON,
    ACTIONS(9393), 1,
      anon_sym_EQ,
    STATE(6323), 1,
      sym_template_parameters,
    ACTIONS(9389), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100774] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9657), 1,
      sym_identifier,
    ACTIONS(9659), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4699), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100798] = 4,
    ACTIONS(9582), 1,
      anon_sym_DOT,
    STATE(4558), 1,
      aux_sym_module_fqn_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9691), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [100816] = 6,
    ACTIONS(4184), 1,
      sym_while,
    ACTIONS(9661), 1,
      sym_catch,
    ACTIONS(9665), 1,
      sym_finally,
    STATE(4666), 1,
      sym_finally_statement,
    STATE(4536), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100838] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9693), 1,
      sym_identifier,
    ACTIONS(9695), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5624), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100862] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9657), 1,
      sym_identifier,
    ACTIONS(9659), 1,
      anon_sym_SEMI,
    STATE(4468), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5249), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100886] = 7,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9697), 1,
      anon_sym_SEMI,
    ACTIONS(9699), 1,
      anon_sym_COLON,
    STATE(1459), 1,
      sym_aggregate_body,
    STATE(4586), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100910] = 6,
    ACTIONS(4192), 1,
      sym_while,
    ACTIONS(9661), 1,
      sym_catch,
    ACTIONS(9663), 1,
      sym_finally,
    STATE(4647), 1,
      sym_finally_statement,
    STATE(4608), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100932] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9701), 1,
      sym_identifier,
    ACTIONS(9703), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5523), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100956] = 6,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9708), 1,
      anon_sym_COLON,
    ACTIONS(9710), 1,
      anon_sym_EQ,
    STATE(5379), 1,
      sym_ellipses,
    ACTIONS(9705), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [100978] = 4,
    ACTIONS(9712), 1,
      anon_sym_DOT,
    STATE(4558), 1,
      aux_sym_module_fqn_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9715), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [100996] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9717), 1,
      sym_identifier,
    ACTIONS(9719), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5558), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101020] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9717), 1,
      sym_identifier,
    ACTIONS(9719), 1,
      anon_sym_SEMI,
    STATE(4500), 1,
      aux_sym_template_mixin_repeat1,
    STATE(4699), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101044] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9717), 1,
      sym_identifier,
    ACTIONS(9719), 1,
      anon_sym_SEMI,
    STATE(4500), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5558), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101068] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(7357), 6,
      anon_sym_DOT_DOT_DOT,
      sym_const,
      sym_immutable,
      sym_return,
      sym_scope,
      sym_shared,
  [101082] = 7,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    ACTIONS(9014), 1,
      anon_sym_LPAREN,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4132), 1,
      sym_parameters,
    STATE(4784), 1,
      aux_sym__declarator_identifier_list_repeat1,
    STATE(5572), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101106] = 6,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9721), 1,
      sym_identifier,
    ACTIONS(9725), 1,
      anon_sym_EQ,
    STATE(5379), 1,
      sym_ellipses,
    ACTIONS(9723), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101128] = 7,
    ACTIONS(8620), 1,
      anon_sym_BANG,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_SEMI,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    STATE(5618), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101152] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9731), 1,
      anon_sym_COLON,
    STATE(1992), 1,
      sym_aggregate_body,
    STATE(4951), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101173] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9733), 1,
      anon_sym_SEMI,
    STATE(2387), 1,
      sym_aggregate_body,
    STATE(5116), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101194] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_SEMI,
    STATE(1999), 1,
      sym_aggregate_body,
    STATE(5020), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101215] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9737), 1,
      anon_sym_SEMI,
    STATE(1970), 1,
      sym_aggregate_body,
    STATE(4588), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101236] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9739), 1,
      anon_sym_SEMI,
    STATE(1973), 1,
      sym_aggregate_body,
    STATE(4568), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101257] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9741), 1,
      anon_sym_SEMI,
    STATE(2358), 1,
      sym_aggregate_body,
    STATE(4579), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101278] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9743), 1,
      anon_sym_SEMI,
    STATE(2360), 1,
      sym_aggregate_body,
    STATE(4580), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101299] = 3,
    ACTIONS(3047), 1,
      aux_sym_interpolated_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(3045), 4,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LPAREN,
      aux_sym_interpolated_raw_string_token2,
      anon_sym_DOLLAR_BQUOTE,
  [101314] = 6,
    ACTIONS(9745), 1,
      sym_identifier,
    ACTIONS(9747), 1,
      anon_sym_LPAREN,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6536), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101335] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9749), 1,
      anon_sym_EQ,
    STATE(5439), 1,
      sym_ellipses,
    ACTIONS(8056), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101354] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9751), 1,
      anon_sym_COLON,
    STATE(2422), 1,
      sym_aggregate_body,
    STATE(4933), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101375] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9753), 1,
      anon_sym_COLON,
    STATE(2266), 1,
      sym_aggregate_body,
    STATE(5197), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101396] = 5,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9755), 1,
      anon_sym_EQ,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8228), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101415] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9757), 1,
      anon_sym_SEMI,
    STATE(2443), 1,
      sym_aggregate_body,
    STATE(4940), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101436] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9759), 1,
      anon_sym_SEMI,
    STATE(2446), 1,
      sym_aggregate_body,
    STATE(4947), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101457] = 4,
    ACTIONS(9761), 1,
      anon_sym_C,
    ACTIONS(9765), 1,
      anon_sym_Objective,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9763), 3,
      anon_sym_D,
      anon_sym_Windows,
      anon_sym_System,
  [101474] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9767), 1,
      anon_sym_SEMI,
    STATE(1382), 1,
      sym_aggregate_body,
    STATE(4829), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101495] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9769), 1,
      anon_sym_SEMI,
    STATE(1530), 1,
      sym_aggregate_body,
    STATE(4595), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101516] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9771), 1,
      anon_sym_SEMI,
    STATE(1532), 1,
      sym_aggregate_body,
    STATE(4596), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101537] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9773), 1,
      anon_sym_SEMI,
    STATE(1384), 1,
      sym_aggregate_body,
    STATE(4830), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101558] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9775), 1,
      anon_sym_COLON,
    STATE(1490), 1,
      sym_aggregate_body,
    STATE(4832), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101579] = 4,
    ACTIONS(9779), 1,
      anon_sym_BANG,
    STATE(2151), 1,
      sym_template_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9777), 3,
      sym_identifier,
      anon_sym_DOT,
      anon_sym_SEMI,
  [101596] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(9782), 1,
      anon_sym_SEMI,
    STATE(2033), 1,
      sym_aggregate_body,
    STATE(5018), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101617] = 4,
    ACTIONS(9784), 1,
      anon_sym_DOT,
    STATE(4589), 1,
      aux_sym_template_mixin_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9777), 3,
      sym_identifier,
      anon_sym_BANG,
      anon_sym_SEMI,
  [101634] = 5,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(9787), 1,
      anon_sym_EQ,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101653] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9789), 1,
      anon_sym_SEMI,
    STATE(1464), 1,
      sym_aggregate_body,
    STATE(4582), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101674] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9791), 1,
      anon_sym_COLON,
    STATE(1603), 1,
      sym_aggregate_body,
    STATE(5060), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101695] = 6,
    ACTIONS(9745), 1,
      sym_identifier,
    ACTIONS(9747), 1,
      anon_sym_LPAREN,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6346), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101716] = 6,
    ACTIONS(9745), 1,
      sym_identifier,
    ACTIONS(9747), 1,
      anon_sym_LPAREN,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6282), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101737] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9793), 1,
      anon_sym_SEMI,
    STATE(1628), 1,
      sym_aggregate_body,
    STATE(5043), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101758] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(9795), 1,
      anon_sym_SEMI,
    STATE(1631), 1,
      sym_aggregate_body,
    STATE(5042), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101779] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9715), 5,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [101792] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(9797), 1,
      anon_sym_SEMI,
    STATE(1463), 1,
      sym_aggregate_body,
    STATE(4585), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101813] = 6,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9799), 1,
      anon_sym_SEMI,
    STATE(2277), 1,
      sym_aggregate_body,
    STATE(5112), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101834] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9725), 1,
      anon_sym_EQ,
    STATE(5379), 1,
      sym_ellipses,
    ACTIONS(9723), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101853] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9801), 1,
      anon_sym_EQ,
    STATE(5526), 1,
      sym_ellipses,
    ACTIONS(8050), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101872] = 6,
    ACTIONS(9745), 1,
      sym_identifier,
    ACTIONS(9747), 1,
      anon_sym_LPAREN,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(5884), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101893] = 6,
    ACTIONS(9745), 1,
      sym_identifier,
    ACTIONS(9747), 1,
      anon_sym_LPAREN,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(5651), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101914] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(8688), 5,
      anon_sym_LBRACE,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_if,
  [101927] = 4,
    ACTIONS(9803), 1,
      anon_sym_AT,
    ACTIONS(9806), 2,
      sym_deprecated,
      sym_module,
    STATE(4605), 2,
      sym_at_attribute,
      aux_sym_module_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101944] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9808), 1,
      anon_sym_SEMI,
    STATE(2393), 1,
      sym_aggregate_body,
    STATE(4599), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101965] = 6,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(9810), 1,
      anon_sym_SEMI,
    STATE(2404), 1,
      sym_aggregate_body,
    STATE(4567), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [101986] = 4,
    ACTIONS(9812), 1,
      sym_catch,
    ACTIONS(4198), 2,
      sym_finally,
      sym_while,
    STATE(4608), 2,
      sym_catch_statement,
      aux_sym_try_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102003] = 4,
    ACTIONS(9815), 1,
      anon_sym_C,
    ACTIONS(9819), 1,
      anon_sym_Objective,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9817), 3,
      anon_sym_D,
      anon_sym_Windows,
      anon_sym_System,
  [102020] = 5,
    ACTIONS(3192), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(9564), 1,
      anon_sym_EQ,
    STATE(5525), 1,
      sym_ellipses,
    ACTIONS(9562), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102039] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4628), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102051] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4620), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102063] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4616), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102075] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4604), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102087] = 4,
    ACTIONS(165), 1,
      sym_new,
    ACTIONS(9821), 1,
      sym_identifier,
    STATE(3218), 2,
      sym_new_expression,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102103] = 4,
    ACTIONS(9825), 1,
      anon_sym_COMMA,
    STATE(4630), 1,
      aux_sym__base_class_list_repeat1,
    ACTIONS(9823), 2,
      anon_sym_LBRACE,
      sym_if,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102119] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4572), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102131] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4568), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102143] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4556), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102155] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4552), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102167] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4480), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102179] = 4,
    ACTIONS(9827), 1,
      sym_identifier,
    ACTIONS(9829), 1,
      anon_sym_RPAREN,
    ACTIONS(9831), 2,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102195] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4434), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102207] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4524), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102219] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4430), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102231] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9833), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [102243] = 4,
    ACTIONS(9835), 1,
      sym_identifier,
    ACTIONS(9837), 1,
      anon_sym_RPAREN,
    ACTIONS(9839), 2,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102259] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4576), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102271] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8214), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102287] = 4,
    ACTIONS(9825), 1,
      anon_sym_COMMA,
    STATE(4640), 1,
      aux_sym__base_class_list_repeat1,
    ACTIONS(9841), 2,
      anon_sym_LBRACE,
      sym_if,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102303] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1645), 1,
      sym_aggregate_body,
    STATE(5262), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102321] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1637), 1,
      sym_aggregate_body,
    STATE(5266), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102339] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4078), 1,
      sym_parameters,
    ACTIONS(8718), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102355] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4727), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102367] = 5,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(5884), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102385] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4394), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102397] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9679), 1,
      sym_identifier,
    STATE(4763), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102413] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4378), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102425] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4328), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102437] = 4,
    ACTIONS(9847), 1,
      anon_sym_COMMA,
    STATE(4640), 1,
      aux_sym__base_class_list_repeat1,
    ACTIONS(9845), 2,
      anon_sym_LBRACE,
      sym_if,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102453] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1591), 1,
      sym_aggregate_body,
    STATE(5275), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102471] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4632), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102483] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4787), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102495] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_aggregate_body,
    STATE(5616), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102513] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9850), 1,
      sym_identifier,
    STATE(4902), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102529] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4640), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102541] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4795), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102553] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2079), 1,
      sym_aggregate_body,
    STATE(5529), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102571] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4849), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102583] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4853), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102595] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4911), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102607] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4644), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102619] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4649), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102631] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2061), 1,
      sym_aggregate_body,
    STATE(5528), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102649] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8228), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102665] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2254), 1,
      sym_aggregate_body,
    STATE(5583), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102683] = 3,
    ACTIONS(9854), 1,
      sym_int_literal,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9852), 3,
      sym_identifier,
      sym_assert,
      sym_unittest,
  [102697] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4096), 1,
      sym_parameters,
    ACTIONS(9856), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102713] = 4,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9858), 1,
      sym_module,
    STATE(4605), 2,
      sym_at_attribute,
      aux_sym_module_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102729] = 4,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9858), 1,
      sym_module,
    STATE(4662), 2,
      sym_at_attribute,
      aux_sym_module_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102745] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4612), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102757] = 4,
    ACTIONS(6072), 1,
      anon_sym_AT,
    ACTIONS(9860), 1,
      sym_module,
    STATE(4605), 2,
      sym_at_attribute,
      aux_sym_module_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102773] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4356), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102785] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2264), 1,
      sym_aggregate_body,
    STATE(5582), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102803] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4654), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102815] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4192), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102827] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4364), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102839] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9862), 1,
      sym_identifier,
    STATE(4970), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102855] = 5,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6346), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102873] = 4,
    ACTIONS(9866), 1,
      anon_sym_COLON,
    ACTIONS(9868), 1,
      anon_sym_EQ,
    ACTIONS(9864), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102889] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4374), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102901] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4386), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102913] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4390), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102925] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9850), 1,
      sym_identifier,
    STATE(5012), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102941] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2114), 1,
      sym_aggregate_body,
    STATE(5518), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [102959] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4753), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102971] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4997), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102983] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4989), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [102995] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4983), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103007] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9850), 1,
      sym_identifier,
    STATE(5278), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103023] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4977), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103035] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4675), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103047] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4959), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103059] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4955), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103071] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4680), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103083] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4951), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103095] = 4,
    ACTIONS(9708), 1,
      anon_sym_COLON,
    ACTIONS(9870), 1,
      anon_sym_EQ,
    ACTIONS(9066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103111] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4939), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103123] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4089), 1,
      sym_parameters,
    ACTIONS(8720), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103139] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4704), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103151] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103167] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4935), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103179] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4382), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103191] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2364), 1,
      sym_aggregate_body,
    STATE(5561), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103209] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4426), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103221] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9677), 1,
      sym_identifier,
    STATE(5148), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103237] = 4,
    ACTIONS(8054), 1,
      anon_sym_COMMA,
    STATE(4712), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(9872), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103253] = 5,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(5651), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103271] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5934), 4,
      sym_identifier,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_SEMI,
  [103283] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9874), 1,
      sym_identifier,
    STATE(4763), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103299] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4828), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103311] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9777), 4,
      sym_identifier,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_SEMI,
  [103323] = 3,
    ACTIONS(9876), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4684), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103337] = 5,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6536), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103355] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2363), 1,
      sym_aggregate_body,
    STATE(5600), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103373] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9642), 1,
      sym_identifier,
    STATE(5176), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103389] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4947), 4,
      sym_catch,
      sym_else,
      sym_finally,
      sym_while,
  [103401] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5934), 4,
      sym_identifier,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_SEMI,
  [103413] = 4,
    ACTIONS(3744), 1,
      sym_new,
    ACTIONS(9878), 1,
      sym_identifier,
    STATE(3480), 2,
      sym_new_expression,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103429] = 3,
    ACTIONS(9880), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4368), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103443] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9850), 1,
      sym_identifier,
    STATE(5178), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103459] = 4,
    ACTIONS(9882), 1,
      anon_sym_COMMA,
    STATE(4712), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(8095), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103475] = 3,
    ACTIONS(9887), 1,
      sym_int_literal,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9885), 3,
      sym_identifier,
      sym_assert,
      sym_unittest,
  [103489] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9850), 1,
      sym_identifier,
    STATE(5107), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103505] = 4,
    ACTIONS(9889), 1,
      anon_sym_COLON,
    ACTIONS(9891), 1,
      anon_sym_EQ,
    ACTIONS(9066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103521] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9850), 1,
      sym_identifier,
    STATE(4857), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103537] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(5934), 4,
      sym_identifier,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_SEMI,
  [103549] = 4,
    ACTIONS(9893), 1,
      sym_identifier,
    ACTIONS(9895), 1,
      anon_sym_RPAREN,
    ACTIONS(9897), 2,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103565] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8232), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103581] = 3,
    ACTIONS(9899), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4691), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103595] = 3,
    ACTIONS(9903), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4743), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103609] = 3,
    ACTIONS(9905), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4691), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103623] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1486), 1,
      sym_aggregate_body,
    STATE(5381), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103641] = 5,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6373), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103659] = 4,
    ACTIONS(3336), 1,
      sym_new,
    ACTIONS(9908), 1,
      sym_identifier,
    STATE(3343), 2,
      sym_new_expression,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103675] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1408), 1,
      sym_aggregate_body,
    STATE(5407), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103693] = 4,
    ACTIONS(9554), 1,
      sym_identifier,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    STATE(4905), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103709] = 3,
    ACTIONS(9910), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4684), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103723] = 3,
    ACTIONS(9912), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2632), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103737] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9914), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103749] = 3,
    ACTIONS(9916), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(2503), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103763] = 3,
    ACTIONS(9918), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(4368), 3,
      sym_catch,
      sym_finally,
      sym_while,
  [103777] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2432), 1,
      sym_aggregate_body,
    STATE(5541), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103795] = 4,
    ACTIONS(9556), 1,
      anon_sym_COLON,
    ACTIONS(9655), 1,
      sym_identifier,
    STATE(4970), 2,
      sym_declarator,
      sym_bitfield_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103811] = 5,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1504), 1,
      sym_aggregate_body,
    STATE(5380), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103829] = 5,
    ACTIONS(9745), 1,
      sym_identifier,
    STATE(4987), 1,
      sym_imported,
    STATE(4989), 1,
      sym_module_fqn,
    STATE(6282), 1,
      sym__import_list,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103847] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(8218), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103863] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9920), 4,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [103875] = 4,
    ACTIONS(6748), 1,
      anon_sym_RPAREN,
    ACTIONS(9922), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103890] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4197), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103905] = 3,
    ACTIONS(9924), 1,
      anon_sym_RPAREN,
    ACTIONS(9926), 2,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103918] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(9930), 1,
      anon_sym_SEMI,
    STATE(4930), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103933] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(9930), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103948] = 4,
    ACTIONS(9932), 1,
      anon_sym_RBRACE,
    ACTIONS(9934), 1,
      anon_sym_COMMA,
    STATE(4929), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103963] = 4,
    ACTIONS(9558), 1,
      anon_sym_SEMI,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    STATE(4966), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103978] = 4,
    ACTIONS(9938), 1,
      anon_sym_RPAREN,
    ACTIONS(9940), 1,
      anon_sym_COMMA,
    STATE(4923), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [103993] = 4,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    ACTIONS(8046), 1,
      anon_sym_COMMA,
    STATE(4841), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104008] = 3,
    ACTIONS(9944), 1,
      sym_case,
    ACTIONS(9942), 2,
      sym_identifier,
      sym_default,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104021] = 4,
    ACTIONS(9946), 1,
      anon_sym_RBRACK,
    ACTIONS(9948), 1,
      anon_sym_COMMA,
    STATE(4749), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104036] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(9951), 1,
      anon_sym_SEMI,
    STATE(4186), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104051] = 4,
    ACTIONS(9953), 1,
      anon_sym_LPAREN,
    STATE(3761), 1,
      sym_parameters,
    STATE(5498), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104066] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(9955), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104081] = 4,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(9957), 1,
      anon_sym_LPAREN,
    STATE(1448), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104096] = 4,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    STATE(1447), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104111] = 4,
    ACTIONS(3282), 1,
      anon_sym_RBRACE,
    ACTIONS(9959), 1,
      anon_sym_COMMA,
    STATE(5036), 1,
      aux_sym_aggregate_initializer_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104126] = 4,
    ACTIONS(9634), 1,
      anon_sym_RPAREN,
    ACTIONS(9961), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104141] = 4,
    ACTIONS(9964), 1,
      sym_identifier,
    STATE(3281), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104156] = 4,
    ACTIONS(9966), 1,
      sym_identifier,
    STATE(3950), 1,
      sym__qualified_id,
    STATE(4317), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104171] = 4,
    ACTIONS(9968), 1,
      sym_identifier,
    ACTIONS(9970), 1,
      anon_sym_LPAREN,
    STATE(3935), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104186] = 4,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    ACTIONS(8046), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104201] = 4,
    ACTIONS(9966), 1,
      sym_identifier,
    STATE(3965), 1,
      sym__qualified_id,
    STATE(4317), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104216] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(9974), 1,
      anon_sym_SEMI,
    STATE(4880), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104231] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(9978), 1,
      anon_sym_SEMI,
    STATE(4867), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104246] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4150), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104261] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(9980), 1,
      anon_sym_SEMI,
    STATE(4743), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104276] = 4,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    ACTIONS(9982), 1,
      anon_sym_SEMI,
    STATE(4745), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104291] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4135), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104306] = 4,
    ACTIONS(6756), 1,
      anon_sym_RPAREN,
    ACTIONS(8044), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104321] = 4,
    ACTIONS(9984), 1,
      sym_identifier,
    STATE(3024), 1,
      sym_template_instance,
    STATE(3060), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104336] = 4,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9986), 1,
      sym_identifier,
    STATE(2314), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104351] = 4,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(9988), 1,
      sym_identifier,
    STATE(2313), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104366] = 4,
    ACTIONS(6756), 1,
      anon_sym_RPAREN,
    ACTIONS(8044), 1,
      anon_sym_COMMA,
    STATE(5038), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104381] = 4,
    ACTIONS(9990), 1,
      sym_identifier,
    STATE(3294), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104396] = 4,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    STATE(2188), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104411] = 4,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(9992), 1,
      anon_sym_LPAREN,
    STATE(2187), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104426] = 4,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(9994), 1,
      anon_sym_LPAREN,
    STATE(2311), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104441] = 4,
    ACTIONS(9996), 1,
      sym_identifier,
    ACTIONS(9998), 1,
      anon_sym_LPAREN,
    STATE(3891), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104456] = 4,
    ACTIONS(9984), 1,
      sym_identifier,
    STATE(3024), 1,
      sym_template_instance,
    STATE(3032), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104471] = 4,
    ACTIONS(9966), 1,
      sym_identifier,
    STATE(3966), 1,
      sym__qualified_id,
    STATE(4317), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104486] = 4,
    ACTIONS(10000), 1,
      anon_sym_RPAREN,
    ACTIONS(10002), 1,
      anon_sym_COMMA,
    STATE(4800), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104501] = 4,
    ACTIONS(10004), 1,
      anon_sym_LPAREN,
    STATE(3792), 1,
      sym_parameters,
    STATE(5613), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104516] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4131), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104531] = 4,
    ACTIONS(10006), 1,
      anon_sym_RPAREN,
    ACTIONS(10008), 1,
      anon_sym_COMMA,
    STATE(4783), 1,
      aux_sym__template_argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104546] = 4,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104561] = 4,
    ACTIONS(6758), 1,
      anon_sym_RPAREN,
    ACTIONS(10011), 1,
      anon_sym_COMMA,
    STATE(4795), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104576] = 4,
    ACTIONS(10013), 1,
      anon_sym_LPAREN,
    STATE(3802), 1,
      sym_parameters,
    STATE(5232), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104591] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3694), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104606] = 4,
    ACTIONS(9966), 1,
      sym_identifier,
    STATE(3973), 1,
      sym__qualified_id,
    STATE(4317), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104621] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3694), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104636] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10019), 1,
      anon_sym_SEMI,
    STATE(5050), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104651] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10021), 1,
      anon_sym_SEMI,
    STATE(5115), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104666] = 4,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_EQ,
    STATE(5993), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104681] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10021), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104696] = 4,
    ACTIONS(10023), 1,
      anon_sym_RBRACE,
    ACTIONS(10025), 1,
      anon_sym_COMMA,
    STATE(5048), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104711] = 4,
    ACTIONS(6760), 1,
      anon_sym_RPAREN,
    ACTIONS(10027), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104726] = 4,
    ACTIONS(9689), 1,
      anon_sym_SEMI,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    STATE(4966), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104741] = 4,
    ACTIONS(10029), 1,
      sym_identifier,
    ACTIONS(10031), 1,
      anon_sym_LPAREN,
    STATE(2148), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104756] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10033), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104771] = 4,
    ACTIONS(6901), 1,
      anon_sym_RBRACE,
    ACTIONS(10035), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104786] = 4,
    ACTIONS(6681), 1,
      anon_sym_RPAREN,
    ACTIONS(10037), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104801] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10039), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [104812] = 4,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    ACTIONS(10041), 1,
      anon_sym_LPAREN,
    STATE(2311), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104827] = 4,
    ACTIONS(3442), 1,
      anon_sym_RBRACK,
    ACTIONS(10043), 1,
      anon_sym_COMMA,
    STATE(4979), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104842] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10047), 1,
      anon_sym_SEMI,
    STATE(4808), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104857] = 3,
    ACTIONS(10049), 1,
      anon_sym_RPAREN,
    ACTIONS(10051), 2,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104870] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10053), 1,
      anon_sym_SEMI,
    STATE(4798), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104885] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10055), 1,
      anon_sym_SEMI,
    STATE(4810), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104900] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10057), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104915] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10059), 1,
      anon_sym_SEMI,
    STATE(4813), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104930] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10061), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104945] = 4,
    ACTIONS(10063), 1,
      sym_identifier,
    STATE(3973), 1,
      sym__qualified_id,
    STATE(4275), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104960] = 4,
    ACTIONS(10065), 1,
      anon_sym_RPAREN,
    ACTIONS(10067), 1,
      anon_sym_COMMA,
    STATE(4909), 1,
      aux_sym__template_parameter_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104975] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10069), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [104990] = 4,
    ACTIONS(10071), 1,
      anon_sym_RPAREN,
    ACTIONS(10073), 1,
      anon_sym_COMMA,
    STATE(4739), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105005] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10053), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105020] = 4,
    ACTIONS(6905), 1,
      anon_sym_RBRACE,
    ACTIONS(10075), 1,
      anon_sym_COMMA,
    STATE(4799), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105035] = 4,
    ACTIONS(9205), 1,
      anon_sym_RBRACE,
    ACTIONS(10077), 1,
      anon_sym_COMMA,
    STATE(5188), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105050] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(10079), 1,
      anon_sym_RPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105065] = 4,
    ACTIONS(10081), 1,
      anon_sym_RBRACK,
    ACTIONS(10083), 1,
      anon_sym_COMMA,
    STATE(4803), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105080] = 4,
    ACTIONS(10085), 1,
      sym_identifier,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4381), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105095] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10087), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105110] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10089), 1,
      anon_sym_SEMI,
    STATE(4877), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105125] = 4,
    ACTIONS(8906), 1,
      anon_sym_SEMI,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4187), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105140] = 3,
    ACTIONS(10091), 1,
      anon_sym_EQ,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105153] = 4,
    ACTIONS(10093), 1,
      anon_sym_RPAREN,
    ACTIONS(10095), 1,
      anon_sym_COMMA,
    STATE(4881), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105168] = 4,
    ACTIONS(10097), 1,
      anon_sym_RBRACK,
    ACTIONS(10099), 1,
      anon_sym_COMMA,
    STATE(4749), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105183] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    STATE(4196), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105198] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10103), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105213] = 4,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(10105), 1,
      anon_sym_SEMI,
    STATE(1338), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105228] = 4,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(10107), 1,
      anon_sym_SEMI,
    STATE(1340), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105243] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10109), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [105254] = 4,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(10111), 1,
      anon_sym_COLON,
    STATE(1353), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105269] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10113), 1,
      anon_sym_SEMI,
    STATE(4815), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105284] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10113), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105299] = 4,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(10115), 1,
      anon_sym_LBRACE,
    STATE(5833), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105314] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10117), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105329] = 4,
    ACTIONS(6893), 1,
      anon_sym_RBRACE,
    ACTIONS(10119), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105344] = 4,
    ACTIONS(8762), 1,
      anon_sym_LBRACE,
    ACTIONS(10121), 1,
      anon_sym_SEMI,
    STATE(1356), 1,
      sym__enum_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105359] = 4,
    ACTIONS(10123), 1,
      anon_sym_RPAREN,
    ACTIONS(10125), 1,
      anon_sym_COMMA,
    STATE(5105), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105374] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10127), 1,
      anon_sym_SEMI,
    STATE(5106), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105389] = 4,
    ACTIONS(6758), 1,
      anon_sym_RPAREN,
    ACTIONS(10011), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105404] = 4,
    ACTIONS(10129), 1,
      anon_sym_RBRACE,
    ACTIONS(10131), 1,
      anon_sym_COMMA,
    STATE(4817), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105419] = 4,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(10133), 1,
      anon_sym_COLON,
    STATE(1359), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105434] = 4,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105449] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10135), 1,
      anon_sym_SEMI,
    STATE(4849), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105464] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10137), 1,
      anon_sym_SEMI,
    STATE(4855), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105479] = 4,
    ACTIONS(6720), 1,
      anon_sym_RPAREN,
    ACTIONS(10139), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105494] = 4,
    ACTIONS(3392), 1,
      anon_sym_RPAREN,
    ACTIONS(10141), 1,
      anon_sym_COMMA,
    STATE(4993), 1,
      aux_sym__named_argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105509] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10143), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105524] = 4,
    ACTIONS(8738), 1,
      anon_sym_SEMI,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4110), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105539] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(10145), 1,
      sym_identifier,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105554] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10147), 1,
      anon_sym_SEMI,
    STATE(4856), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105569] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3697), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105584] = 4,
    ACTIONS(10149), 1,
      anon_sym_RBRACK,
    ACTIONS(10151), 1,
      anon_sym_COMMA,
    STATE(4826), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105599] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10153), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105614] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10155), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105629] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10157), 1,
      anon_sym_SEMI,
    STATE(4828), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105644] = 4,
    ACTIONS(10159), 1,
      sym_identifier,
    STATE(3274), 1,
      sym__qualified_id,
    STATE(3289), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105659] = 4,
    ACTIONS(9998), 1,
      anon_sym_LPAREN,
    ACTIONS(10161), 1,
      sym_identifier,
    STATE(3891), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105674] = 4,
    ACTIONS(10159), 1,
      sym_identifier,
    STATE(3271), 1,
      sym__qualified_id,
    STATE(3289), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105689] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10163), 1,
      anon_sym_SEMI,
    STATE(5093), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105704] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3685), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105719] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10165), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105734] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10157), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105749] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3685), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105764] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10167), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105779] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10169), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105794] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10171), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105809] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4188), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105824] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10173), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [105835] = 4,
    ACTIONS(3388), 1,
      anon_sym_RBRACK,
    ACTIONS(10175), 1,
      anon_sym_COMMA,
    STATE(4979), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105850] = 4,
    ACTIONS(10177), 1,
      sym_identifier,
    STATE(3282), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105865] = 4,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(7198), 1,
      anon_sym_LPAREN,
    STATE(4307), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105880] = 4,
    ACTIONS(10179), 1,
      anon_sym_COMMA,
    ACTIONS(10181), 1,
      anon_sym_SEMI,
    STATE(5079), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105895] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10183), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [105906] = 4,
    ACTIONS(10185), 1,
      anon_sym_RPAREN,
    ACTIONS(10187), 1,
      anon_sym_COMMA,
    STATE(4897), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105921] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10189), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105936] = 4,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    STATE(4331), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105951] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3697), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105966] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10191), 1,
      anon_sym_SEMI,
    STATE(5093), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105981] = 4,
    ACTIONS(3626), 1,
      anon_sym_RPAREN,
    ACTIONS(10193), 1,
      anon_sym_COMMA,
    STATE(4973), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [105996] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10195), 1,
      anon_sym_SEMI,
    STATE(4834), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106011] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10019), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106026] = 4,
    ACTIONS(6917), 1,
      anon_sym_RBRACE,
    ACTIONS(10197), 1,
      anon_sym_COMMA,
    STATE(5205), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106041] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4170), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106056] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10195), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106071] = 4,
    ACTIONS(10199), 1,
      anon_sym_RBRACE,
    ACTIONS(10201), 1,
      anon_sym_COMMA,
    STATE(4837), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106086] = 4,
    ACTIONS(9614), 1,
      anon_sym_SEMI,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    STATE(4966), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106101] = 4,
    ACTIONS(10203), 1,
      sym_identifier,
    STATE(3269), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106116] = 4,
    ACTIONS(10205), 1,
      anon_sym_RPAREN,
    ACTIONS(10207), 1,
      anon_sym_COMMA,
    STATE(4847), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106131] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10209), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [106142] = 4,
    ACTIONS(10211), 1,
      anon_sym_RBRACE,
    ACTIONS(10213), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106157] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10216), 1,
      anon_sym_SEMI,
    STATE(4107), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106172] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10218), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106187] = 4,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(10220), 1,
      anon_sym_LPAREN,
    STATE(1541), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106202] = 4,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    STATE(1537), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106217] = 4,
    ACTIONS(6736), 1,
      anon_sym_RPAREN,
    ACTIONS(10222), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106232] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10224), 1,
      anon_sym_SEMI,
    STATE(4904), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106247] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(10226), 1,
      anon_sym_RPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106262] = 4,
    ACTIONS(10228), 1,
      sym_identifier,
    STATE(3324), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106277] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10230), 1,
      anon_sym_SEMI,
    STATE(4861), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106292] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10169), 1,
      anon_sym_SEMI,
    STATE(4948), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106307] = 4,
    ACTIONS(10085), 1,
      sym_identifier,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4401), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106322] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10232), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106337] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10234), 1,
      anon_sym_SEMI,
    STATE(4864), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106352] = 4,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(10236), 1,
      anon_sym_LBRACE,
    STATE(5726), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106367] = 4,
    ACTIONS(9191), 1,
      anon_sym_RBRACE,
    ACTIONS(10238), 1,
      anon_sym_COMMA,
    STATE(5188), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106382] = 4,
    ACTIONS(10240), 1,
      anon_sym_LPAREN,
    STATE(3732), 1,
      sym_parameters,
    STATE(5466), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106397] = 4,
    ACTIONS(6996), 1,
      anon_sym_RPAREN,
    ACTIONS(10242), 1,
      anon_sym_COMMA,
    STATE(4932), 1,
      aux_sym__template_parameter_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106412] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10244), 1,
      anon_sym_SEMI,
    STATE(4886), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106427] = 4,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    ACTIONS(10246), 1,
      anon_sym_SEMI,
    STATE(4888), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106442] = 4,
    ACTIONS(8886), 1,
      anon_sym_SEMI,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4140), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106457] = 4,
    ACTIONS(9841), 1,
      anon_sym_LBRACE,
    ACTIONS(10248), 1,
      anon_sym_COMMA,
    STATE(5059), 1,
      aux_sym__base_class_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106472] = 4,
    ACTIONS(10250), 1,
      sym_identifier,
    STATE(3167), 1,
      sym__qualified_id,
    STATE(3187), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106487] = 4,
    ACTIONS(8756), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106502] = 4,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(10252), 1,
      sym_identifier,
    STATE(1402), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106517] = 4,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    ACTIONS(10254), 1,
      sym_identifier,
    STATE(1390), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106532] = 4,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    ACTIONS(10256), 1,
      anon_sym_LPAREN,
    STATE(1386), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106547] = 4,
    ACTIONS(10258), 1,
      anon_sym_COMMA,
    ACTIONS(10261), 1,
      anon_sym_SEMI,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106562] = 4,
    ACTIONS(10031), 1,
      anon_sym_LPAREN,
    ACTIONS(10263), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106577] = 4,
    ACTIONS(10250), 1,
      sym_identifier,
    STATE(3187), 1,
      sym_template_instance,
    STATE(3228), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106592] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4120), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106607] = 4,
    ACTIONS(6722), 1,
      anon_sym_RPAREN,
    ACTIONS(10265), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106622] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10267), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106637] = 4,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106652] = 4,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(10269), 1,
      anon_sym_COLON,
    STATE(2327), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106667] = 4,
    ACTIONS(10271), 1,
      anon_sym_RBRACE,
    ACTIONS(10273), 1,
      anon_sym_COMMA,
    STATE(4958), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106682] = 4,
    ACTIONS(8896), 1,
      anon_sym_LBRACE,
    ACTIONS(10275), 1,
      anon_sym_SEMI,
    STATE(2325), 1,
      sym__enum_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106697] = 4,
    ACTIONS(6915), 1,
      anon_sym_RBRACE,
    ACTIONS(10277), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106712] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10279), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106727] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10279), 1,
      anon_sym_SEMI,
    STATE(4962), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106742] = 4,
    ACTIONS(10281), 1,
      anon_sym_RPAREN,
    ACTIONS(10283), 1,
      anon_sym_COMMA,
    STATE(4932), 1,
      aux_sym__template_parameter_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106757] = 4,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(10286), 1,
      anon_sym_COLON,
    STATE(2316), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106772] = 4,
    ACTIONS(10288), 1,
      sym_identifier,
    ACTIONS(10290), 1,
      anon_sym_LPAREN,
    STATE(2752), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106787] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3692), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106802] = 4,
    ACTIONS(10292), 1,
      anon_sym_RPAREN,
    ACTIONS(10294), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106817] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10297), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106832] = 4,
    ACTIONS(6899), 1,
      anon_sym_RBRACE,
    ACTIONS(10299), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106847] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4148), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106862] = 4,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(10301), 1,
      anon_sym_SEMI,
    STATE(2299), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106877] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10303), 1,
      anon_sym_SEMI,
    STATE(4945), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106892] = 4,
    ACTIONS(10063), 1,
      sym_identifier,
    STATE(3966), 1,
      sym__qualified_id,
    STATE(4275), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106907] = 4,
    ACTIONS(10305), 1,
      sym_identifier,
    STATE(3385), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106922] = 4,
    ACTIONS(9984), 1,
      sym_identifier,
    STATE(3024), 1,
      sym_template_instance,
    STATE(3045), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106937] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10307), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106952] = 4,
    ACTIONS(10309), 1,
      anon_sym_RPAREN,
    ACTIONS(10311), 1,
      anon_sym_COMMA,
    STATE(4965), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106967] = 4,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    ACTIONS(10313), 1,
      anon_sym_SEMI,
    STATE(2296), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106982] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10315), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [106997] = 4,
    ACTIONS(9984), 1,
      sym_identifier,
    STATE(3024), 1,
      sym_template_instance,
    STATE(3039), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107012] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10317), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [107023] = 4,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(10319), 1,
      anon_sym_COLON,
    STATE(2016), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107038] = 3,
    ACTIONS(10323), 1,
      sym_case,
    ACTIONS(10321), 2,
      sym_identifier,
      sym_default,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107051] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10325), 1,
      anon_sym_SEMI,
    STATE(5006), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107066] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10327), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107081] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10329), 1,
      anon_sym_SEMI,
    STATE(4924), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107096] = 3,
    ACTIONS(10333), 1,
      sym_case,
    ACTIONS(10331), 2,
      sym_identifier,
      sym_default,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107109] = 4,
    ACTIONS(8800), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107124] = 4,
    ACTIONS(9231), 1,
      anon_sym_RBRACE,
    ACTIONS(10335), 1,
      anon_sym_COMMA,
    STATE(5188), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107139] = 4,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(10337), 1,
      anon_sym_LBRACE,
    STATE(5713), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107154] = 4,
    ACTIONS(6897), 1,
      anon_sym_RBRACE,
    ACTIONS(10339), 1,
      anon_sym_COMMA,
    STATE(4990), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107169] = 4,
    ACTIONS(10341), 1,
      sym_identifier,
    STATE(3973), 1,
      sym__qualified_id,
    STATE(4235), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107184] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10343), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107199] = 4,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9045), 1,
      anon_sym_EQ,
    STATE(6069), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107214] = 4,
    ACTIONS(8758), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107229] = 4,
    ACTIONS(6746), 1,
      anon_sym_RPAREN,
    ACTIONS(10345), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107244] = 4,
    ACTIONS(10347), 1,
      anon_sym_COMMA,
    ACTIONS(10350), 1,
      anon_sym_SEMI,
    STATE(4966), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107259] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10352), 1,
      anon_sym_SEMI,
    STATE(4968), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107274] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10354), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107289] = 3,
    ACTIONS(10356), 1,
      anon_sym_EQ,
    ACTIONS(9864), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107302] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10358), 1,
      anon_sym_SEMI,
    STATE(4937), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107317] = 4,
    ACTIONS(8870), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107332] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4105), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107347] = 4,
    ACTIONS(10360), 1,
      anon_sym_RPAREN,
    ACTIONS(10362), 1,
      anon_sym_COMMA,
    STATE(4973), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107362] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10365), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [107373] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4184), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107388] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10329), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107403] = 4,
    ACTIONS(6895), 1,
      anon_sym_RBRACE,
    ACTIONS(10367), 1,
      anon_sym_COMMA,
    STATE(4938), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107418] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10369), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [107429] = 4,
    ACTIONS(10371), 1,
      anon_sym_RBRACK,
    ACTIONS(10373), 1,
      anon_sym_COMMA,
    STATE(4979), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107444] = 4,
    ACTIONS(10376), 1,
      anon_sym_RBRACK,
    ACTIONS(10378), 1,
      anon_sym_COMMA,
    STATE(4871), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107459] = 3,
    ACTIONS(10380), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10382), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107472] = 4,
    ACTIONS(9221), 1,
      anon_sym_RBRACE,
    ACTIONS(10384), 1,
      anon_sym_COMMA,
    STATE(5188), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107487] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10386), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107502] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4180), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107517] = 4,
    ACTIONS(8778), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107532] = 4,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(10388), 1,
      anon_sym_LBRACE,
    STATE(6340), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107547] = 4,
    ACTIONS(10390), 1,
      anon_sym_COMMA,
    ACTIONS(10392), 1,
      anon_sym_SEMI,
    ACTIONS(10394), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107562] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10396), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [107573] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10398), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [107584] = 4,
    ACTIONS(6889), 1,
      anon_sym_RBRACE,
    ACTIONS(10400), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107599] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10402), 1,
      anon_sym_SEMI,
    STATE(4793), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107614] = 4,
    ACTIONS(6913), 1,
      anon_sym_RBRACE,
    ACTIONS(10404), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107629] = 4,
    ACTIONS(10406), 1,
      anon_sym_RPAREN,
    ACTIONS(10408), 1,
      anon_sym_COMMA,
    STATE(4993), 1,
      aux_sym__named_argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107644] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3692), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107659] = 4,
    ACTIONS(3408), 1,
      anon_sym_RBRACK,
    ACTIONS(10411), 1,
      anon_sym_COMMA,
    STATE(4979), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107674] = 3,
    ACTIONS(10413), 1,
      anon_sym_RPAREN,
    ACTIONS(10415), 2,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107687] = 4,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    ACTIONS(10417), 1,
      anon_sym_SEMI,
    STATE(4796), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107702] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10419), 1,
      anon_sym_SEMI,
    STATE(4983), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107717] = 4,
    ACTIONS(10421), 1,
      sym_identifier,
    ACTIONS(10423), 1,
      anon_sym_LPAREN,
    STATE(2939), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107732] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10425), 1,
      anon_sym_SEMI,
    STATE(5003), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107747] = 4,
    ACTIONS(10341), 1,
      sym_identifier,
    STATE(3966), 1,
      sym__qualified_id,
    STATE(4235), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107762] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10427), 1,
      anon_sym_SEMI,
    STATE(5005), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107777] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10429), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107792] = 4,
    ACTIONS(8095), 1,
      anon_sym_COLON,
    ACTIONS(10431), 1,
      anon_sym_COMMA,
    STATE(5004), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107807] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10434), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107822] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10436), 1,
      anon_sym_SEMI,
    STATE(5093), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107837] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10438), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      sym_if,
  [107848] = 4,
    ACTIONS(10440), 1,
      anon_sym_RBRACK,
    ACTIONS(10442), 1,
      anon_sym_COMMA,
    STATE(5054), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107863] = 4,
    ACTIONS(10444), 1,
      anon_sym_RPAREN,
    ACTIONS(10446), 1,
      anon_sym_COMMA,
    STATE(5027), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107878] = 4,
    ACTIONS(9823), 1,
      anon_sym_LBRACE,
    ACTIONS(10248), 1,
      anon_sym_COMMA,
    STATE(4913), 1,
      aux_sym__base_class_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107893] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10448), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107908] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10297), 1,
      anon_sym_SEMI,
    STATE(5091), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107923] = 4,
    ACTIONS(10450), 1,
      anon_sym_RPAREN,
    ACTIONS(10452), 1,
      anon_sym_COMMA,
    STATE(4848), 1,
      aux_sym__named_argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107938] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10454), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107953] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10419), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107968] = 4,
    ACTIONS(6921), 1,
      anon_sym_RBRACE,
    ACTIONS(10456), 1,
      anon_sym_COMMA,
    STATE(4992), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107983] = 4,
    ACTIONS(9197), 1,
      anon_sym_RBRACE,
    ACTIONS(10458), 1,
      anon_sym_COMMA,
    STATE(5188), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [107998] = 4,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(10460), 1,
      anon_sym_SEMI,
    STATE(2049), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108013] = 3,
    ACTIONS(10462), 1,
      anon_sym_LPAREN,
    ACTIONS(8060), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108026] = 4,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(10464), 1,
      anon_sym_SEMI,
    STATE(2038), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108041] = 4,
    ACTIONS(10341), 1,
      sym_identifier,
    STATE(3965), 1,
      sym__qualified_id,
    STATE(4235), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108056] = 4,
    ACTIONS(10466), 1,
      anon_sym_RBRACK,
    ACTIONS(10468), 1,
      anon_sym_COMMA,
    STATE(4995), 1,
      aux_sym_index_expression_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108071] = 4,
    ACTIONS(10470), 1,
      sym_identifier,
    STATE(3966), 1,
      sym__qualified_id,
    STATE(4262), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108086] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10472), 1,
      anon_sym_SEMI,
    STATE(5029), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108101] = 4,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    ACTIONS(10474), 1,
      anon_sym_RPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108116] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10476), 1,
      anon_sym_SEMI,
    STATE(5034), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108131] = 4,
    ACTIONS(6716), 1,
      anon_sym_RPAREN,
    ACTIONS(10478), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108146] = 4,
    ACTIONS(10480), 1,
      anon_sym_LPAREN,
    STATE(3725), 1,
      sym_parameters,
    STATE(5307), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108161] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10482), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108176] = 4,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(10484), 1,
      anon_sym_COLON,
    STATE(2216), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108191] = 3,
    ACTIONS(9104), 1,
      anon_sym_EQ,
    ACTIONS(9102), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108204] = 4,
    ACTIONS(10486), 1,
      anon_sym_RBRACE,
    ACTIONS(10488), 1,
      anon_sym_COMMA,
    STATE(4907), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108219] = 4,
    ACTIONS(8854), 1,
      anon_sym_LBRACE,
    ACTIONS(10490), 1,
      anon_sym_SEMI,
    STATE(2221), 1,
      sym__enum_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108234] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10492), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108249] = 4,
    ACTIONS(10494), 1,
      anon_sym_RBRACK,
    ACTIONS(10496), 1,
      anon_sym_COMMA,
    STATE(4749), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108264] = 4,
    ACTIONS(10498), 1,
      anon_sym_RBRACE,
    ACTIONS(10500), 1,
      anon_sym_COMMA,
    STATE(5036), 1,
      aux_sym_aggregate_initializer_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108279] = 4,
    ACTIONS(6768), 1,
      anon_sym_RPAREN,
    ACTIONS(8018), 1,
      anon_sym_COMMA,
    STATE(4760), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108294] = 4,
    ACTIONS(6768), 1,
      anon_sym_RPAREN,
    ACTIONS(8018), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108309] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10503), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108324] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10505), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [108335] = 4,
    ACTIONS(10159), 1,
      sym_identifier,
    STATE(3286), 1,
      sym__qualified_id,
    STATE(3289), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108350] = 4,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(10507), 1,
      anon_sym_SEMI,
    STATE(1672), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108365] = 4,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(10509), 1,
      anon_sym_SEMI,
    STATE(1674), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108380] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10511), 1,
      anon_sym_SEMI,
    STATE(5046), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108395] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10513), 1,
      anon_sym_SEMI,
    STATE(5047), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108410] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10515), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108425] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10517), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108440] = 4,
    ACTIONS(6923), 1,
      anon_sym_RBRACE,
    ACTIONS(10519), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108455] = 4,
    ACTIONS(8137), 1,
      anon_sym_COMMA,
    ACTIONS(9872), 1,
      anon_sym_COLON,
    STATE(5004), 1,
      aux_sym_expression_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108470] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10521), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108485] = 4,
    ACTIONS(10523), 1,
      anon_sym_COMMA,
    ACTIONS(10526), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108500] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10528), 1,
      anon_sym_SEMI,
    STATE(5057), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108515] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(9845), 3,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      sym_if,
  [108526] = 4,
    ACTIONS(10530), 1,
      anon_sym_RBRACK,
    ACTIONS(10532), 1,
      anon_sym_COMMA,
    STATE(4749), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108541] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10534), 1,
      anon_sym_SEMI,
    STATE(5058), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108556] = 4,
    ACTIONS(10536), 1,
      anon_sym_RBRACE,
    ACTIONS(10538), 1,
      anon_sym_COMMA,
    STATE(4755), 1,
      aux_sym_aggregate_initializer_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108571] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10540), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108586] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10542), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108601] = 4,
    ACTIONS(9845), 1,
      anon_sym_LBRACE,
    ACTIONS(10544), 1,
      anon_sym_COMMA,
    STATE(5059), 1,
      aux_sym__base_class_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108616] = 4,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(10547), 1,
      anon_sym_COLON,
    STATE(1681), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108631] = 4,
    ACTIONS(10549), 1,
      sym_identifier,
    ACTIONS(10551), 1,
      anon_sym_LPAREN,
    STATE(2703), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108646] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10553), 1,
      anon_sym_SEMI,
    STATE(5015), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108661] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10553), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108676] = 4,
    ACTIONS(6927), 1,
      anon_sym_RBRACE,
    ACTIONS(10555), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108691] = 4,
    ACTIONS(8746), 1,
      anon_sym_LBRACE,
    ACTIONS(10557), 1,
      anon_sym_SEMI,
    STATE(1679), 1,
      sym__enum_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108706] = 4,
    ACTIONS(10559), 1,
      anon_sym_RBRACE,
    ACTIONS(10561), 1,
      anon_sym_COMMA,
    STATE(5017), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108721] = 4,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(10563), 1,
      anon_sym_COLON,
    STATE(1516), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108736] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10565), 1,
      anon_sym_SEMI,
    STATE(5073), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108751] = 4,
    ACTIONS(6764), 1,
      anon_sym_RPAREN,
    ACTIONS(9455), 1,
      anon_sym_COMMA,
    STATE(4756), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108766] = 4,
    ACTIONS(8872), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108781] = 4,
    ACTIONS(6764), 1,
      anon_sym_RPAREN,
    ACTIONS(9455), 1,
      anon_sym_COMMA,
    STATE(4768), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108796] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10567), 1,
      anon_sym_SEMI,
    STATE(5074), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108811] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10569), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108826] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10571), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108841] = 4,
    ACTIONS(6710), 1,
      anon_sym_RPAREN,
    ACTIONS(10573), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108856] = 4,
    ACTIONS(8840), 1,
      anon_sym_SEMI,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4115), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108871] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10575), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [108882] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10577), 1,
      anon_sym_SEMI,
    STATE(5117), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108897] = 4,
    ACTIONS(10579), 1,
      anon_sym_COMMA,
    ACTIONS(10582), 1,
      anon_sym_SEMI,
    STATE(5079), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108912] = 4,
    ACTIONS(10159), 1,
      sym_identifier,
    STATE(3289), 1,
      sym_template_instance,
    STATE(3296), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108927] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10584), 1,
      anon_sym_SEMI,
    STATE(4976), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108942] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10584), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108957] = 3,
    ACTIONS(10588), 1,
      anon_sym_EQ,
    ACTIONS(10586), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108970] = 4,
    ACTIONS(6919), 1,
      anon_sym_RBRACE,
    ACTIONS(10590), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [108985] = 4,
    ACTIONS(10085), 1,
      sym_identifier,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4391), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109000] = 4,
    ACTIONS(8864), 1,
      anon_sym_LBRACE,
    ACTIONS(10592), 1,
      anon_sym_SEMI,
    STATE(1953), 1,
      sym__enum_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109015] = 4,
    ACTIONS(10594), 1,
      anon_sym_RBRACE,
    ACTIONS(10596), 1,
      anon_sym_COMMA,
    STATE(4982), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109030] = 4,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(10598), 1,
      anon_sym_COLON,
    STATE(1951), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109045] = 4,
    ACTIONS(10600), 1,
      sym_identifier,
    ACTIONS(10602), 1,
      anon_sym_LPAREN,
    STATE(4218), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109060] = 4,
    ACTIONS(3560), 1,
      anon_sym_RPAREN,
    ACTIONS(10604), 1,
      anon_sym_COMMA,
    STATE(4783), 1,
      aux_sym__template_argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109075] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10606), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109090] = 4,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(10608), 1,
      anon_sym_LPAREN,
    STATE(2004), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109105] = 4,
    ACTIONS(10610), 1,
      anon_sym_COMMA,
    ACTIONS(10613), 1,
      anon_sym_SEMI,
    STATE(5093), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109120] = 4,
    ACTIONS(8780), 1,
      anon_sym_SEMI,
    ACTIONS(9487), 1,
      anon_sym_COMMA,
    STATE(4919), 1,
      aux_sym__declarator_identifier_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109135] = 4,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    ACTIONS(9016), 1,
      anon_sym_EQ,
    STATE(5877), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109150] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10615), 1,
      anon_sym_SEMI,
    STATE(5099), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109165] = 4,
    ACTIONS(10617), 1,
      anon_sym_RBRACK,
    ACTIONS(10619), 1,
      anon_sym_COMMA,
    STATE(5035), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109180] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10621), 1,
      anon_sym_SEMI,
    STATE(5100), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109195] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10623), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109210] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10625), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109225] = 4,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(10627), 1,
      sym_identifier,
    STATE(2052), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109240] = 4,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    ACTIONS(10629), 1,
      sym_identifier,
    STATE(2048), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109255] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10631), 1,
      anon_sym_SEMI,
    STATE(5119), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109270] = 4,
    ACTIONS(10633), 1,
      anon_sym_COMMA,
    ACTIONS(10636), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109285] = 4,
    ACTIONS(3530), 1,
      anon_sym_RPAREN,
    ACTIONS(10638), 1,
      anon_sym_COMMA,
    STATE(4973), 1,
      aux_sym__argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109300] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10640), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109315] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10642), 1,
      anon_sym_SEMI,
    STATE(5039), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109330] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4144), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109345] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10644), 1,
      anon_sym_SEMI,
    STATE(5093), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109360] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3703), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109375] = 4,
    ACTIONS(10085), 1,
      sym_identifier,
    STATE(4348), 1,
      sym_template_instance,
    STATE(4404), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109390] = 4,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(10646), 1,
      anon_sym_SEMI,
    STATE(2256), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109405] = 4,
    ACTIONS(10648), 1,
      sym_identifier,
    ACTIONS(10650), 1,
      anon_sym_LPAREN,
    STATE(2888), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109420] = 4,
    ACTIONS(6708), 1,
      anon_sym_RPAREN,
    ACTIONS(10652), 1,
      anon_sym_COMMA,
    STATE(4936), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109435] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10654), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109450] = 4,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(10656), 1,
      anon_sym_SEMI,
    STATE(2272), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109465] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10658), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109480] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10660), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109495] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10662), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109510] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10642), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109525] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10664), 1,
      anon_sym_SEMI,
    STATE(4821), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109540] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10654), 1,
      anon_sym_SEMI,
    STATE(4883), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109555] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3703), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109570] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3706), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109585] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10666), 1,
      anon_sym_SEMI,
    STATE(5130), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109600] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3706), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109615] = 4,
    ACTIONS(8300), 1,
      sym_if,
    ACTIONS(10668), 1,
      anon_sym_LBRACE,
    STATE(6276), 1,
      sym_constraint,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109630] = 4,
    ACTIONS(10670), 1,
      anon_sym_RPAREN,
    ACTIONS(10672), 1,
      anon_sym_COMMA,
    STATE(5090), 1,
      aux_sym__template_argument_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109645] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10674), 1,
      anon_sym_SEMI,
    STATE(5131), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109660] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10676), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109675] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10678), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109690] = 4,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    ACTIONS(10680), 1,
      anon_sym_SEMI,
    STATE(5194), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109705] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10682), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_COLON,
  [109716] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10684), 1,
      anon_sym_SEMI,
    STATE(5141), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109731] = 4,
    ACTIONS(8860), 1,
      anon_sym_SEMI,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4111), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109746] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10686), 1,
      anon_sym_SEMI,
    STATE(5201), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109761] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10688), 1,
      anon_sym_SEMI,
    STATE(5142), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109776] = 3,
    ACTIONS(10692), 1,
      sym_case,
    ACTIONS(10690), 2,
      sym_identifier,
      sym_default,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109789] = 4,
    ACTIONS(10694), 1,
      sym_identifier,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    STATE(2560), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109804] = 3,
    ACTIONS(10700), 1,
      anon_sym_EQ,
    ACTIONS(10698), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109817] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10702), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109832] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10704), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109847] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10706), 1,
      anon_sym_SEMI,
    STATE(5144), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109862] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10708), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109877] = 4,
    ACTIONS(10045), 1,
      anon_sym_COMMA,
    ACTIONS(10710), 1,
      anon_sym_SEMI,
    STATE(4836), 1,
      aux_sym_foreach_statement_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109892] = 4,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(10712), 1,
      sym_identifier,
    STATE(2433), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109907] = 4,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(10714), 1,
      sym_identifier,
    STATE(2430), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109922] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10716), 1,
      anon_sym_SEMI,
    STATE(5202), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109937] = 4,
    ACTIONS(10179), 1,
      anon_sym_COMMA,
    ACTIONS(10718), 1,
      anon_sym_SEMI,
    STATE(4874), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109952] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10720), 1,
      anon_sym_SEMI,
    STATE(5063), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109967] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10720), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109982] = 4,
    ACTIONS(10722), 1,
      anon_sym_RBRACE,
    ACTIONS(10724), 1,
      anon_sym_COMMA,
    STATE(5064), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [109997] = 4,
    ACTIONS(9612), 1,
      anon_sym_SEMI,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    STATE(4966), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110012] = 4,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(10726), 1,
      anon_sym_LPAREN,
    STATE(2406), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110027] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10728), 1,
      anon_sym_SEMI,
    STATE(5180), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110042] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10343), 1,
      anon_sym_SEMI,
    STATE(5011), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110057] = 4,
    ACTIONS(10730), 1,
      sym_identifier,
    STATE(3235), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110072] = 4,
    ACTIONS(10732), 1,
      sym_identifier,
    ACTIONS(10734), 1,
      anon_sym_LPAREN,
    STATE(2762), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110087] = 4,
    ACTIONS(10736), 1,
      anon_sym_RPAREN,
    ACTIONS(10738), 1,
      anon_sym_COMMA,
    STATE(5075), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110102] = 4,
    ACTIONS(10250), 1,
      sym_identifier,
    STATE(3187), 1,
      sym_template_instance,
    STATE(3219), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110117] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10740), 1,
      anon_sym_SEMI,
    STATE(4162), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110132] = 4,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    STATE(1959), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110147] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10742), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110162] = 4,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(10744), 1,
      anon_sym_LPAREN,
    STATE(2186), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110177] = 4,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    STATE(2193), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110192] = 4,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    ACTIONS(10746), 1,
      anon_sym_LPAREN,
    STATE(1967), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110207] = 4,
    ACTIONS(10748), 1,
      sym_identifier,
    ACTIONS(10750), 1,
      anon_sym_LPAREN,
    STATE(2951), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110222] = 4,
    ACTIONS(10470), 1,
      sym_identifier,
    STATE(3950), 1,
      sym__qualified_id,
    STATE(4262), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110237] = 4,
    ACTIONS(10752), 1,
      anon_sym_LPAREN,
    STATE(3742), 1,
      sym_parameters,
    STATE(5211), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110252] = 4,
    ACTIONS(10754), 1,
      sym_identifier,
    STATE(3021), 1,
      sym_template_instance,
    STATE(3950), 1,
      sym__qualified_id,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110267] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10756), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110282] = 4,
    ACTIONS(10758), 1,
      anon_sym_COMMA,
    ACTIONS(10761), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110297] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10763), 1,
      anon_sym_SEMI,
    STATE(4173), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110312] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10765), 1,
      anon_sym_SEMI,
    STATE(5109), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110327] = 4,
    ACTIONS(10470), 1,
      sym_identifier,
    STATE(3973), 1,
      sym__qualified_id,
    STATE(4262), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110342] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10767), 1,
      anon_sym_SEMI,
    STATE(5120), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110357] = 2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
    ACTIONS(10769), 3,
      anon_sym_exit,
      anon_sym_success,
      anon_sym_failure,
  [110368] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10771), 1,
      anon_sym_SEMI,
    STATE(5014), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110383] = 4,
    ACTIONS(10470), 1,
      sym_identifier,
    STATE(3965), 1,
      sym__qualified_id,
    STATE(4262), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110398] = 4,
    ACTIONS(9972), 1,
      anon_sym_COMMA,
    ACTIONS(10773), 1,
      anon_sym_SEMI,
    STATE(5093), 1,
      aux_sym_auto_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110413] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10775), 1,
      anon_sym_SEMI,
    STATE(5151), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110428] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    STATE(3683), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110443] = 4,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    ACTIONS(10777), 1,
      anon_sym_SEMI,
    STATE(5153), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110458] = 4,
    ACTIONS(10341), 1,
      sym_identifier,
    STATE(3950), 1,
      sym__qualified_id,
    STATE(4235), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110473] = 4,
    ACTIONS(10063), 1,
      sym_identifier,
    STATE(3965), 1,
      sym__qualified_id,
    STATE(4275), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110488] = 4,
    ACTIONS(10779), 1,
      anon_sym_RPAREN,
    ACTIONS(10781), 1,
      anon_sym_COMMA,
    STATE(5114), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110503] = 4,
    ACTIONS(10783), 1,
      anon_sym_LPAREN,
    STATE(3762), 1,
      sym_parameters,
    STATE(5251), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110518] = 4,
    ACTIONS(10785), 1,
      anon_sym_RBRACE,
    ACTIONS(10787), 1,
      anon_sym_COMMA,
    STATE(5188), 1,
      aux_sym__enum_body_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110533] = 4,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(10790), 1,
      sym_identifier,
    STATE(1582), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110548] = 4,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    ACTIONS(10792), 1,
      sym_identifier,
    STATE(1585), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110563] = 4,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    ACTIONS(10794), 1,
      anon_sym_LPAREN,
    STATE(1589), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110578] = 4,
    ACTIONS(10696), 1,
      anon_sym_LPAREN,
    ACTIONS(10796), 1,
      sym_identifier,
    STATE(2560), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110593] = 4,
    ACTIONS(10063), 1,
      sym_identifier,
    STATE(3950), 1,
      sym__qualified_id,
    STATE(4275), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110608] = 4,
    ACTIONS(9681), 1,
      anon_sym_SEMI,
    ACTIONS(9936), 1,
      anon_sym_COMMA,
    STATE(4966), 1,
      aux_sym_alias_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110623] = 4,
    ACTIONS(10031), 1,
      anon_sym_LPAREN,
    ACTIONS(10798), 1,
      sym_identifier,
    STATE(2148), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110638] = 4,
    ACTIONS(10800), 1,
      anon_sym_RBRACE,
    ACTIONS(10802), 1,
      anon_sym_COMMA,
    STATE(5084), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110653] = 4,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    ACTIONS(10804), 1,
      anon_sym_COLON,
    STATE(2227), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110668] = 4,
    ACTIONS(10250), 1,
      sym_identifier,
    STATE(3180), 1,
      sym__qualified_id,
    STATE(3187), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110683] = 4,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    ACTIONS(10806), 1,
      anon_sym_RBRACK,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110698] = 4,
    ACTIONS(5898), 1,
      anon_sym_LPAREN,
    STATE(3945), 1,
      sym__parameters,
    STATE(4133), 1,
      sym__parameter_with_member_attributes,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110713] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10808), 1,
      anon_sym_SEMI,
    STATE(5172), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110728] = 4,
    ACTIONS(9976), 1,
      anon_sym_COMMA,
    ACTIONS(10771), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      aux_sym_variable_declaration_repeat2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110743] = 4,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    STATE(3683), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110758] = 4,
    ACTIONS(9928), 1,
      anon_sym_COMMA,
    ACTIONS(10808), 1,
      anon_sym_SEMI,
    STATE(5082), 1,
      aux_sym_manifest_constant_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110773] = 4,
    ACTIONS(6929), 1,
      anon_sym_RBRACE,
    ACTIONS(10810), 1,
      anon_sym_COMMA,
    STATE(4892), 1,
      aux_sym_anonymous_enum_declaration_repeat1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110788] = 3,
    ACTIONS(10812), 1,
      sym_identifier,
    ACTIONS(10814), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110800] = 3,
    ACTIONS(10816), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10818), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110812] = 3,
    ACTIONS(4691), 1,
      sym_while,
    ACTIONS(10820), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110824] = 3,
    ACTIONS(10824), 1,
      anon_sym_COMMA,
    ACTIONS(10826), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110836] = 3,
    ACTIONS(10828), 1,
      sym_identifier,
    STATE(4553), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110848] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3699), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110860] = 3,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    STATE(3872), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110872] = 3,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    STATE(4028), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110884] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(5303), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110896] = 3,
    ACTIONS(10816), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10832), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110908] = 2,
    ACTIONS(10834), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110918] = 3,
    ACTIONS(7661), 1,
      anon_sym_LPAREN,
    STATE(3375), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110930] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(10838), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110942] = 3,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    STATE(1587), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110954] = 3,
    ACTIONS(10840), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(10842), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110966] = 3,
    ACTIONS(10844), 1,
      sym_identifier,
    STATE(6336), 1,
      sym_module_fqn,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110978] = 3,
    ACTIONS(9620), 1,
      sym_identifier,
    ACTIONS(9622), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [110990] = 3,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    STATE(1580), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111002] = 3,
    ACTIONS(10846), 1,
      sym_identifier,
    ACTIONS(10848), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111014] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(223), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111026] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(222), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111038] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(2434), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111050] = 3,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    STATE(1623), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111062] = 3,
    ACTIONS(10852), 1,
      anon_sym_LPAREN,
    ACTIONS(10854), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111074] = 3,
    ACTIONS(9657), 1,
      sym_identifier,
    ACTIONS(9659), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111086] = 3,
    ACTIONS(10856), 1,
      anon_sym_RPAREN,
    ACTIONS(10858), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111098] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3698), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111110] = 3,
    ACTIONS(10860), 1,
      anon_sym_RPAREN,
    ACTIONS(10862), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111122] = 3,
    ACTIONS(10660), 1,
      anon_sym_RBRACK,
    ACTIONS(10864), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111134] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(5298), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111146] = 3,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    STATE(1598), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111158] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(10866), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111170] = 2,
    ACTIONS(10868), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111180] = 3,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2227), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111192] = 3,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1516), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111204] = 3,
    ACTIONS(10870), 1,
      anon_sym_RPAREN,
    ACTIONS(10872), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111216] = 2,
    ACTIONS(10874), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111226] = 3,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1681), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111238] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5150), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111250] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5062), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111262] = 2,
    ACTIONS(10878), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111272] = 3,
    ACTIONS(10880), 1,
      anon_sym_COMMA,
    ACTIONS(10882), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111284] = 3,
    ACTIONS(10884), 1,
      sym_identifier,
    ACTIONS(10886), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111296] = 3,
    ACTIONS(9493), 1,
      sym_identifier,
    ACTIONS(9495), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111308] = 3,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    STATE(3177), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111320] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3704), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111332] = 3,
    ACTIONS(9477), 1,
      sym_identifier,
    ACTIONS(9481), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111344] = 3,
    ACTIONS(10888), 1,
      sym_identifier,
    STATE(3198), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111356] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(296), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111368] = 2,
    ACTIONS(7537), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111378] = 3,
    ACTIONS(6998), 1,
      anon_sym_LBRACE,
    STATE(3209), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111390] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111402] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(284), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111414] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(2198), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111426] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3896), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111438] = 3,
    ACTIONS(10890), 1,
      anon_sym_TILDE,
    ACTIONS(10892), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111450] = 3,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1591), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111462] = 3,
    ACTIONS(10894), 1,
      sym_identifier,
    STATE(4470), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111474] = 2,
    ACTIONS(10896), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111484] = 2,
    ACTIONS(10898), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111494] = 3,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1570), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111506] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4791), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111518] = 2,
    ACTIONS(7495), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111528] = 3,
    ACTIONS(10900), 1,
      anon_sym_RPAREN,
    ACTIONS(10902), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111540] = 3,
    ACTIONS(10904), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10906), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111552] = 3,
    ACTIONS(10908), 1,
      anon_sym_RPAREN,
    ACTIONS(10910), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111564] = 3,
    ACTIONS(10912), 1,
      anon_sym_RPAREN,
    ACTIONS(10914), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111576] = 3,
    ACTIONS(10852), 1,
      anon_sym_LPAREN,
    ACTIONS(10916), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111588] = 3,
    ACTIONS(10918), 1,
      sym_identifier,
    STATE(4472), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111600] = 3,
    ACTIONS(9522), 1,
      anon_sym_LBRACE,
    STATE(1555), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111612] = 3,
    ACTIONS(10844), 1,
      sym_identifier,
    STATE(5773), 1,
      sym_module_fqn,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111624] = 3,
    ACTIONS(10920), 1,
      anon_sym_TILDE,
    ACTIONS(10922), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111636] = 2,
    ACTIONS(10636), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111646] = 3,
    ACTIONS(10852), 1,
      anon_sym_LPAREN,
    ACTIONS(10924), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111658] = 3,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    STATE(4986), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111670] = 3,
    ACTIONS(10844), 1,
      sym_identifier,
    STATE(5896), 1,
      sym_module_fqn,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111682] = 2,
    ACTIONS(10926), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111692] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4790), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111704] = 2,
    ACTIONS(10761), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111714] = 2,
    ACTIONS(10928), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111724] = 3,
    ACTIONS(10930), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10932), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111736] = 3,
    ACTIONS(10852), 1,
      anon_sym_LPAREN,
    ACTIONS(10934), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111748] = 2,
    ACTIONS(10936), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111758] = 3,
    ACTIONS(10938), 1,
      anon_sym_RPAREN,
    ACTIONS(10940), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111770] = 3,
    ACTIONS(10942), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10944), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111782] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4114), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111794] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3851), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111806] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3931), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111818] = 2,
    ACTIONS(7573), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111828] = 3,
    ACTIONS(10916), 1,
      anon_sym_EQ,
    ACTIONS(10946), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111840] = 3,
    ACTIONS(10948), 1,
      anon_sym_RPAREN,
    ACTIONS(10950), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111852] = 3,
    ACTIONS(4368), 1,
      sym_while,
    ACTIONS(10952), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111864] = 2,
    ACTIONS(7593), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111874] = 3,
    ACTIONS(10954), 1,
      anon_sym_COMMA,
    ACTIONS(10956), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111886] = 2,
    ACTIONS(10958), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111896] = 3,
    ACTIONS(4684), 1,
      sym_while,
    ACTIONS(10960), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111908] = 3,
    ACTIONS(4691), 1,
      sym_while,
    ACTIONS(10962), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111920] = 2,
    ACTIONS(7443), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111930] = 2,
    ACTIONS(7450), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111940] = 3,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    STATE(1403), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111952] = 2,
    ACTIONS(10965), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111962] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3708), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111974] = 3,
    ACTIONS(10967), 1,
      sym_identifier,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111986] = 3,
    ACTIONS(10971), 1,
      anon_sym_TILDE,
    ACTIONS(10973), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [111998] = 3,
    ACTIONS(10924), 1,
      anon_sym_EQ,
    ACTIONS(10946), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112010] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3884), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112022] = 3,
    ACTIONS(6619), 1,
      anon_sym_LPAREN,
    STATE(4079), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112034] = 2,
    ACTIONS(7478), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112044] = 3,
    ACTIONS(10975), 1,
      anon_sym_DOT_DOT,
    ACTIONS(10977), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112056] = 3,
    ACTIONS(7023), 1,
      anon_sym_LBRACE,
    STATE(3356), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112068] = 3,
    ACTIONS(10979), 1,
      anon_sym_RPAREN,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112080] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4998), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112092] = 3,
    ACTIONS(7755), 1,
      anon_sym_LPAREN,
    STATE(3457), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112104] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(10983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112116] = 3,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(10985), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112128] = 3,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    STATE(4835), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112140] = 3,
    ACTIONS(10987), 1,
      anon_sym_TILDE,
    ACTIONS(10989), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112152] = 3,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(10991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112164] = 3,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    STATE(1477), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112176] = 3,
    ACTIONS(10852), 1,
      anon_sym_LPAREN,
    ACTIONS(10993), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112188] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4167), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112200] = 3,
    ACTIONS(10995), 1,
      sym_identifier,
    ACTIONS(10997), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112212] = 3,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    STATE(3358), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112224] = 3,
    ACTIONS(10999), 1,
      sym_identifier,
    ACTIONS(11001), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112236] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(189), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112248] = 3,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2216), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112260] = 3,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    STATE(1334), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112272] = 3,
    ACTIONS(9644), 1,
      sym_identifier,
    ACTIONS(9646), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112284] = 3,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(11003), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112296] = 3,
    ACTIONS(11005), 1,
      anon_sym_RPAREN,
    ACTIONS(11007), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112308] = 3,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    STATE(4906), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112320] = 3,
    ACTIONS(11009), 1,
      anon_sym_TILDE,
    ACTIONS(11011), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112332] = 3,
    ACTIONS(10934), 1,
      anon_sym_EQ,
    ACTIONS(10946), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112344] = 3,
    ACTIONS(10165), 1,
      anon_sym_RBRACK,
    ACTIONS(11013), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112356] = 2,
    ACTIONS(11015), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112366] = 3,
    ACTIONS(10816), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11017), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112378] = 2,
    ACTIONS(7607), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112388] = 3,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    STATE(3233), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112400] = 3,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    STATE(1364), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112412] = 3,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1359), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112424] = 3,
    ACTIONS(11019), 1,
      anon_sym_RPAREN,
    ACTIONS(11021), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112436] = 2,
    ACTIONS(10360), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112446] = 3,
    ACTIONS(11023), 1,
      anon_sym_RPAREN,
    ACTIONS(11025), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112458] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4113), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112470] = 3,
    ACTIONS(814), 1,
      anon_sym_LBRACE,
    STATE(3172), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112482] = 3,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(11027), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112494] = 3,
    ACTIONS(10844), 1,
      sym_identifier,
    STATE(5672), 1,
      sym_module_fqn,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112506] = 3,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1353), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112518] = 2,
    ACTIONS(9864), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112528] = 3,
    ACTIONS(11029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11031), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112540] = 2,
    ACTIONS(10350), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112550] = 3,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    STATE(4959), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112562] = 3,
    ACTIONS(11033), 1,
      sym_identifier,
    ACTIONS(11035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112574] = 3,
    ACTIONS(11037), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112586] = 3,
    ACTIONS(11041), 1,
      anon_sym_TILDE,
    ACTIONS(11043), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112598] = 2,
    ACTIONS(9856), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112608] = 3,
    ACTIONS(10854), 1,
      anon_sym_EQ,
    ACTIONS(10946), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112620] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(221), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112632] = 3,
    ACTIONS(7339), 1,
      anon_sym_LPAREN,
    STATE(3255), 1,
      sym_named_arguments,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112644] = 3,
    ACTIONS(11045), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112656] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(233), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112668] = 3,
    ACTIONS(11049), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112680] = 2,
    ACTIONS(11053), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112690] = 3,
    ACTIONS(7046), 1,
      anon_sym_LBRACE,
    STATE(3447), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112702] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(11055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112714] = 3,
    ACTIONS(11057), 1,
      sym_identifier,
    ACTIONS(11059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112726] = 3,
    ACTIONS(11061), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112738] = 3,
    ACTIONS(9544), 1,
      sym_identifier,
    ACTIONS(9546), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112750] = 3,
    ACTIONS(11065), 1,
      sym_identifier,
    STATE(3463), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112762] = 3,
    ACTIONS(2503), 1,
      sym_while,
    ACTIONS(11067), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112774] = 3,
    ACTIONS(7046), 1,
      anon_sym_LBRACE,
    STATE(3394), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112786] = 3,
    ACTIONS(8316), 1,
      anon_sym_LBRACE,
    STATE(1560), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112798] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(2212), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112810] = 2,
    ACTIONS(8050), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112820] = 3,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1408), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112832] = 3,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1335), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112844] = 3,
    ACTIONS(11069), 1,
      anon_sym_RPAREN,
    ACTIONS(11071), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112856] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(2229), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112868] = 2,
    ACTIONS(10292), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112878] = 3,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(11073), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112890] = 2,
    ACTIONS(10281), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112900] = 3,
    ACTIONS(4684), 1,
      sym_while,
    ACTIONS(11075), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112912] = 3,
    ACTIONS(11077), 1,
      anon_sym_RPAREN,
    ACTIONS(11079), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112924] = 3,
    ACTIONS(2632), 1,
      sym_while,
    ACTIONS(11081), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112936] = 3,
    ACTIONS(4368), 1,
      sym_while,
    ACTIONS(11083), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112948] = 3,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(11085), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112960] = 2,
    ACTIONS(8720), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112970] = 2,
    ACTIONS(10261), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112980] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4143), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [112992] = 3,
    ACTIONS(11087), 1,
      sym_identifier,
    ACTIONS(11089), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113004] = 3,
    ACTIONS(11091), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113016] = 2,
    ACTIONS(11095), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113026] = 3,
    ACTIONS(11097), 1,
      anon_sym_RPAREN,
    ACTIONS(11099), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113038] = 3,
    ACTIONS(10816), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11101), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113050] = 3,
    ACTIONS(4743), 1,
      sym_while,
    ACTIONS(11103), 1,
      sym_else,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113062] = 2,
    ACTIONS(10211), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113072] = 3,
    ACTIONS(8748), 1,
      anon_sym_LPAREN,
    STATE(5127), 1,
      sym_template_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113084] = 3,
    ACTIONS(11105), 1,
      anon_sym_TILDE,
    ACTIONS(11107), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113096] = 3,
    ACTIONS(9667), 1,
      sym_identifier,
    ACTIONS(9669), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113108] = 3,
    ACTIONS(10946), 1,
      anon_sym_LPAREN,
    ACTIONS(10993), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113120] = 3,
    ACTIONS(11109), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113132] = 3,
    ACTIONS(9536), 1,
      anon_sym_LBRACE,
    STATE(1392), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113144] = 3,
    ACTIONS(11113), 1,
      anon_sym_RPAREN,
    ACTIONS(11115), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113156] = 2,
    ACTIONS(11117), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113166] = 3,
    ACTIONS(11119), 1,
      sym_identifier,
    STATE(5622), 1,
      sym_import_bind,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113178] = 3,
    ACTIONS(11121), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113190] = 3,
    ACTIONS(11125), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113202] = 3,
    ACTIONS(11129), 1,
      anon_sym_RPAREN,
    ACTIONS(11131), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113214] = 3,
    ACTIONS(11133), 1,
      anon_sym_LPAREN,
    STATE(2912), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113226] = 3,
    ACTIONS(11135), 1,
      anon_sym_LPAREN,
    STATE(2695), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113238] = 3,
    ACTIONS(11137), 1,
      anon_sym_RPAREN,
    ACTIONS(11139), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113250] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(227), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113262] = 3,
    ACTIONS(11141), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113274] = 3,
    ACTIONS(11145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113286] = 3,
    ACTIONS(11149), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113298] = 3,
    ACTIONS(11153), 1,
      sym_identifier,
    ACTIONS(11155), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113310] = 3,
    ACTIONS(11157), 1,
      anon_sym_RPAREN,
    ACTIONS(11159), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113322] = 3,
    ACTIONS(11161), 1,
      anon_sym_RPAREN,
    ACTIONS(11163), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113334] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(300), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113346] = 2,
    ACTIONS(9723), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113356] = 2,
    ACTIONS(8048), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113366] = 3,
    ACTIONS(11165), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113378] = 3,
    ACTIONS(11169), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113390] = 3,
    ACTIONS(11173), 1,
      anon_sym_RPAREN,
    ACTIONS(11175), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113402] = 3,
    ACTIONS(11177), 1,
      anon_sym_RPAREN,
    ACTIONS(11179), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113414] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5284), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113426] = 3,
    ACTIONS(9727), 1,
      sym_identifier,
    ACTIONS(9729), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113438] = 3,
    ACTIONS(11181), 1,
      anon_sym_COMMA,
    ACTIONS(11183), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113450] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(389), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113462] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(483), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113474] = 3,
    ACTIONS(11185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113486] = 3,
    ACTIONS(11189), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113498] = 2,
    ACTIONS(9066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113508] = 2,
    ACTIONS(8058), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113518] = 3,
    ACTIONS(11193), 1,
      anon_sym_RPAREN,
    ACTIONS(11195), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113530] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5122), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113542] = 3,
    ACTIONS(11197), 1,
      anon_sym_RPAREN,
    ACTIONS(11199), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113554] = 3,
    ACTIONS(11201), 1,
      anon_sym_PLUS_PLUS,
    ACTIONS(11203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113566] = 2,
    ACTIONS(9183), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113576] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(488), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113588] = 3,
    ACTIONS(11205), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113600] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(395), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113612] = 3,
    ACTIONS(11209), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113624] = 3,
    ACTIONS(11213), 1,
      sym_identifier,
    STATE(5356), 1,
      sym_alias_initializer,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113636] = 3,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    STATE(2185), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113648] = 3,
    ACTIONS(11215), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113660] = 2,
    ACTIONS(11219), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113670] = 3,
    ACTIONS(11221), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113682] = 3,
    ACTIONS(10844), 1,
      sym_identifier,
    STATE(5133), 1,
      sym_module_fqn,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113694] = 3,
    ACTIONS(11225), 1,
      anon_sym_RPAREN,
    ACTIONS(11227), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113706] = 3,
    ACTIONS(11119), 1,
      sym_identifier,
    STATE(5149), 1,
      sym_import_bind,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113718] = 3,
    ACTIONS(11229), 1,
      anon_sym_RPAREN,
    ACTIONS(11231), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113730] = 2,
    ACTIONS(11233), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113740] = 3,
    ACTIONS(3296), 1,
      anon_sym_LBRACE,
    STATE(3341), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113752] = 2,
    ACTIONS(8218), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113762] = 3,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    STATE(2315), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113774] = 3,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    STATE(2315), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113786] = 3,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(11235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113798] = 3,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    STATE(2409), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113810] = 3,
    ACTIONS(11237), 1,
      anon_sym_RPAREN,
    ACTIONS(11239), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113822] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3701), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113834] = 2,
    ACTIONS(11241), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113844] = 3,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    STATE(2439), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113856] = 3,
    ACTIONS(8344), 1,
      anon_sym_LBRACE,
    STATE(2333), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113868] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(444), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113880] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(482), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113892] = 3,
    ACTIONS(11243), 1,
      anon_sym_LPAREN,
    STATE(2677), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113904] = 3,
    ACTIONS(11245), 1,
      anon_sym_LPAREN,
    STATE(2861), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113916] = 3,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    STATE(3435), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113928] = 3,
    ACTIONS(11247), 1,
      sym_identifier,
    ACTIONS(11249), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113940] = 3,
    ACTIONS(11251), 1,
      sym_identifier,
    ACTIONS(11253), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113952] = 3,
    ACTIONS(11255), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11257), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113964] = 3,
    ACTIONS(11259), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113976] = 3,
    ACTIONS(11263), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113988] = 2,
    ACTIONS(10006), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [113998] = 3,
    ACTIONS(11267), 1,
      sym_identifier,
    ACTIONS(11269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114010] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(235), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114022] = 3,
    ACTIONS(11271), 1,
      anon_sym_RPAREN,
    ACTIONS(11273), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114034] = 3,
    ACTIONS(10969), 1,
      anon_sym_SEMI,
    ACTIONS(11275), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114046] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(11277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114058] = 3,
    ACTIONS(11279), 1,
      anon_sym_RPAREN,
    ACTIONS(11281), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114070] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(11283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114082] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(228), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114094] = 3,
    ACTIONS(11285), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11287), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114106] = 3,
    ACTIONS(11289), 1,
      sym_identifier,
    STATE(3376), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114118] = 3,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    STATE(2409), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114130] = 2,
    ACTIONS(11291), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114140] = 3,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    STATE(4169), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114152] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4882), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114164] = 3,
    ACTIONS(10830), 1,
      anon_sym_LPAREN,
    STATE(3894), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114176] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4152), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114188] = 3,
    ACTIONS(11293), 1,
      sym_identifier,
    STATE(4529), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114200] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3689), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114212] = 3,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(11295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114224] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4955), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114236] = 2,
    ACTIONS(11297), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114246] = 3,
    ACTIONS(11299), 1,
      sym_identifier,
    ACTIONS(11301), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114258] = 2,
    ACTIONS(8226), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114268] = 2,
    ACTIONS(11303), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114278] = 3,
    ACTIONS(11305), 1,
      sym_identifier,
    ACTIONS(11307), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114290] = 3,
    ACTIONS(7023), 1,
      anon_sym_LBRACE,
    STATE(3337), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114302] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4126), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114314] = 3,
    ACTIONS(11309), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114326] = 3,
    ACTIONS(5896), 1,
      anon_sym_LBRACE,
    STATE(2394), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114338] = 3,
    ACTIONS(11313), 1,
      sym_identifier,
    ACTIONS(11315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114350] = 3,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    STATE(4313), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114362] = 3,
    ACTIONS(11317), 1,
      sym_identifier,
    STATE(4526), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114374] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(396), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114386] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(443), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114398] = 3,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    STATE(2439), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114410] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5081), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114422] = 2,
    ACTIONS(8198), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114432] = 3,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2101), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114444] = 3,
    ACTIONS(9528), 1,
      sym_identifier,
    ACTIONS(9530), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114456] = 3,
    ACTIONS(11319), 1,
      anon_sym_RPAREN,
    ACTIONS(11321), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114468] = 3,
    ACTIONS(11323), 1,
      anon_sym_RPAREN,
    ACTIONS(11325), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114480] = 3,
    ACTIONS(11327), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114492] = 3,
    ACTIONS(11331), 1,
      sym_identifier,
    ACTIONS(11333), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114504] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4833), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114516] = 2,
    ACTIONS(8056), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114526] = 2,
    ACTIONS(8064), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114536] = 2,
    ACTIONS(11335), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114546] = 3,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2111), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114558] = 3,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2114), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114570] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(252), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114582] = 3,
    ACTIONS(11337), 1,
      sym_identifier,
    STATE(4702), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114594] = 3,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    STATE(2117), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114606] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(253), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114618] = 3,
    ACTIONS(10171), 1,
      anon_sym_RBRACK,
    ACTIONS(11339), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114630] = 3,
    ACTIONS(11341), 1,
      sym_identifier,
    STATE(4561), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114642] = 3,
    ACTIONS(11343), 1,
      sym_identifier,
    STATE(4537), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114654] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5204), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114666] = 2,
    ACTIONS(11345), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114676] = 3,
    ACTIONS(11347), 1,
      sym_identifier,
    STATE(4531), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114688] = 3,
    ACTIONS(9506), 1,
      sym_identifier,
    ACTIONS(9508), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114700] = 3,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2377), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114712] = 3,
    ACTIONS(11349), 1,
      anon_sym_RPAREN,
    ACTIONS(11351), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114724] = 3,
    ACTIONS(9701), 1,
      sym_identifier,
    ACTIONS(9703), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114736] = 3,
    ACTIONS(3708), 1,
      anon_sym_LBRACE,
    STATE(3408), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114748] = 3,
    ACTIONS(11353), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114760] = 2,
    ACTIONS(8141), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114770] = 3,
    ACTIONS(11357), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114782] = 3,
    ACTIONS(11361), 1,
      sym_identifier,
    ACTIONS(11363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114794] = 3,
    ACTIONS(7184), 1,
      anon_sym_LBRACE,
    STATE(2333), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114806] = 3,
    ACTIONS(11365), 1,
      anon_sym_RPAREN,
    ACTIONS(11367), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114818] = 3,
    ACTIONS(11369), 1,
      anon_sym_RPAREN,
    ACTIONS(11371), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114830] = 3,
    ACTIONS(11373), 1,
      anon_sym_RPAREN,
    ACTIONS(11375), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114842] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4132), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114854] = 3,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2327), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114866] = 2,
    ACTIONS(8718), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114876] = 3,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2316), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114888] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4118), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114900] = 3,
    ACTIONS(9588), 1,
      sym_identifier,
    ACTIONS(9590), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114912] = 3,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(11377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114924] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(5156), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114936] = 3,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2432), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114948] = 3,
    ACTIONS(9608), 1,
      sym_identifier,
    ACTIONS(9610), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114960] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4137), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114972] = 2,
    ACTIONS(8066), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114982] = 3,
    ACTIONS(11379), 1,
      sym_identifier,
    STATE(4512), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [114994] = 3,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(2016), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115006] = 3,
    ACTIONS(9574), 1,
      anon_sym_LBRACE,
    STATE(1951), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115018] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4806), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115030] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(340), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115042] = 3,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(11381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115054] = 3,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    STATE(1971), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115066] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(4158), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115078] = 3,
    ACTIONS(10327), 1,
      anon_sym_RBRACK,
    ACTIONS(11383), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115090] = 2,
    ACTIONS(11385), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115100] = 3,
    ACTIONS(10850), 1,
      anon_sym_LPAREN,
    STATE(339), 1,
      sym_if_condition,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115112] = 3,
    ACTIONS(11387), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115124] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4931), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115136] = 3,
    ACTIONS(9693), 1,
      sym_identifier,
    ACTIONS(9695), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115148] = 2,
    ACTIONS(8228), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115158] = 2,
    ACTIONS(10371), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115168] = 3,
    ACTIONS(8328), 1,
      anon_sym_LBRACE,
    STATE(1385), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115180] = 3,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115192] = 3,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2220), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115204] = 2,
    ACTIONS(10785), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115214] = 3,
    ACTIONS(11391), 1,
      anon_sym_RPAREN,
    ACTIONS(11393), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115226] = 3,
    ACTIONS(10806), 1,
      anon_sym_RBRACK,
    ACTIONS(11395), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115238] = 3,
    ACTIONS(11397), 1,
      anon_sym_RPAREN,
    ACTIONS(11399), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115250] = 2,
    ACTIONS(11401), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115260] = 2,
    ACTIONS(11403), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115270] = 3,
    ACTIONS(11405), 1,
      anon_sym_RPAREN,
    ACTIONS(11407), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115282] = 3,
    ACTIONS(11409), 1,
      sym_identifier,
    STATE(4480), 1,
      sym_template_instance,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115294] = 3,
    ACTIONS(10844), 1,
      sym_identifier,
    STATE(6335), 1,
      sym_module_fqn,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115306] = 2,
    ACTIONS(10406), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115316] = 3,
    ACTIONS(10876), 1,
      sym_identifier,
    STATE(4742), 1,
      sym_manifest_declarator,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115328] = 2,
    ACTIONS(11411), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115338] = 2,
    ACTIONS(11413), 2,
      sym_int_literal,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115348] = 3,
    ACTIONS(11415), 1,
      sym_identifier,
    ACTIONS(11417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115360] = 3,
    ACTIONS(11419), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115372] = 3,
    ACTIONS(9717), 1,
      sym_identifier,
    ACTIONS(9719), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115384] = 3,
    ACTIONS(9568), 1,
      anon_sym_LBRACE,
    STATE(2441), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115396] = 3,
    ACTIONS(11423), 1,
      anon_sym_RPAREN,
    ACTIONS(11425), 1,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115408] = 2,
    ACTIONS(9562), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115418] = 3,
    ACTIONS(11427), 1,
      anon_sym_RPAREN,
    ACTIONS(11429), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115430] = 3,
    ACTIONS(11431), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115442] = 3,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    STATE(1997), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115454] = 3,
    ACTIONS(11435), 1,
      anon_sym_LPAREN,
    STATE(2769), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115466] = 3,
    ACTIONS(11437), 1,
      anon_sym_LPAREN,
    STATE(2673), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115478] = 2,
    ACTIONS(11439), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115488] = 2,
    ACTIONS(10498), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115498] = 3,
    ACTIONS(11441), 1,
      sym_identifier,
    STATE(5285), 1,
      sym__auto_assignment,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115510] = 2,
    ACTIONS(8060), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115520] = 3,
    ACTIONS(11443), 1,
      anon_sym_DOT_DOT,
    ACTIONS(11445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115532] = 3,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(3688), 1,
      sym_parameters,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115544] = 2,
    ACTIONS(11447), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115554] = 3,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    STATE(2047), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115566] = 3,
    ACTIONS(9548), 1,
      anon_sym_LBRACE,
    STATE(2293), 1,
      sym_aggregate_body,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115578] = 3,
    ACTIONS(8304), 1,
      anon_sym_LBRACE,
    STATE(1975), 1,
      sym_block_statement,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115590] = 3,
    ACTIONS(11449), 1,
      sym_identifier,
    ACTIONS(11451), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115602] = 3,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(11453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115614] = 2,
    ACTIONS(10526), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115624] = 3,
    ACTIONS(11455), 1,
      anon_sym_RPAREN,
    ACTIONS(11457), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115636] = 2,
    ACTIONS(10582), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115646] = 2,
    ACTIONS(11459), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115656] = 3,
    ACTIONS(11461), 1,
      sym_identifier,
    ACTIONS(11463), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115668] = 2,
    ACTIONS(11465), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115677] = 2,
    ACTIONS(11467), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115686] = 2,
    ACTIONS(9719), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115695] = 2,
    ACTIONS(11469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115704] = 2,
    ACTIONS(11471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115713] = 2,
    ACTIONS(11473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115722] = 2,
    ACTIONS(11475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115731] = 2,
    ACTIONS(11477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115740] = 2,
    ACTIONS(11479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115749] = 2,
    ACTIONS(11481), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115758] = 2,
    ACTIONS(11483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115767] = 2,
    ACTIONS(11485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115776] = 2,
    ACTIONS(11487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115785] = 2,
    ACTIONS(11489), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115794] = 2,
    ACTIONS(11491), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115803] = 2,
    ACTIONS(10779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115812] = 2,
    ACTIONS(11493), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115821] = 2,
    ACTIONS(11495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115830] = 2,
    ACTIONS(11497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115839] = 2,
    ACTIONS(10763), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115848] = 2,
    ACTIONS(11499), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115857] = 2,
    ACTIONS(11501), 1,
      sym_case,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115866] = 2,
    ACTIONS(9168), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115875] = 2,
    ACTIONS(11493), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115884] = 2,
    ACTIONS(11503), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115893] = 2,
    ACTIONS(11505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115902] = 2,
    ACTIONS(11507), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115911] = 2,
    ACTIONS(11451), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115920] = 2,
    ACTIONS(11463), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115929] = 2,
    ACTIONS(6768), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115938] = 2,
    ACTIONS(11509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115947] = 2,
    ACTIONS(11511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115956] = 2,
    ACTIONS(11513), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115965] = 2,
    ACTIONS(11515), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115974] = 2,
    ACTIONS(11517), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115983] = 2,
    ACTIONS(11519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [115992] = 2,
    ACTIONS(11521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116001] = 2,
    ACTIONS(11523), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116010] = 2,
    ACTIONS(11525), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116019] = 2,
    ACTIONS(11527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116028] = 2,
    ACTIONS(11529), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116037] = 2,
    ACTIONS(11531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116046] = 2,
    ACTIONS(11533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116055] = 2,
    ACTIONS(11535), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116064] = 2,
    ACTIONS(11537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116073] = 2,
    ACTIONS(11539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116082] = 2,
    ACTIONS(11541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116091] = 2,
    ACTIONS(11543), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116100] = 2,
    ACTIONS(11545), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116109] = 2,
    ACTIONS(11547), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116118] = 2,
    ACTIONS(11549), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116127] = 2,
    ACTIONS(11551), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116136] = 2,
    ACTIONS(11553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116145] = 2,
    ACTIONS(11555), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116154] = 2,
    ACTIONS(11557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116163] = 2,
    ACTIONS(11559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116172] = 2,
    ACTIONS(11561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116181] = 2,
    ACTIONS(11563), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116190] = 2,
    ACTIONS(11565), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116199] = 2,
    ACTIONS(11567), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116208] = 2,
    ACTIONS(11569), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116217] = 2,
    ACTIONS(11571), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116226] = 2,
    ACTIONS(11569), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116235] = 2,
    ACTIONS(11573), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116244] = 2,
    ACTIONS(11575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116253] = 2,
    ACTIONS(9508), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116262] = 2,
    ACTIONS(11577), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116271] = 2,
    ACTIONS(11579), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116280] = 2,
    ACTIONS(11581), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116289] = 2,
    ACTIONS(11583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116298] = 2,
    ACTIONS(11585), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116307] = 2,
    ACTIONS(11587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116316] = 2,
    ACTIONS(9695), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116325] = 2,
    ACTIONS(11589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116334] = 2,
    ACTIONS(11591), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116343] = 2,
    ACTIONS(2887), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116352] = 2,
    ACTIONS(11593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116361] = 2,
    ACTIONS(6744), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116370] = 2,
    ACTIONS(11595), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116379] = 2,
    ACTIONS(6708), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116388] = 2,
    ACTIONS(11597), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116397] = 2,
    ACTIONS(11599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116406] = 2,
    ACTIONS(8780), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116415] = 2,
    ACTIONS(11601), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116424] = 2,
    ACTIONS(11603), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116433] = 2,
    ACTIONS(11605), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116442] = 2,
    ACTIONS(11607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116451] = 2,
    ACTIONS(11609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116460] = 2,
    ACTIONS(11611), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116469] = 2,
    ACTIONS(11613), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116478] = 2,
    ACTIONS(11615), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116487] = 2,
    ACTIONS(11617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116496] = 2,
    ACTIONS(11619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116505] = 2,
    ACTIONS(11621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116514] = 2,
    ACTIONS(11623), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116523] = 2,
    ACTIONS(11625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116532] = 2,
    ACTIONS(11627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116541] = 2,
    ACTIONS(9610), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116550] = 2,
    ACTIONS(11629), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116559] = 2,
    ACTIONS(11631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116568] = 2,
    ACTIONS(11633), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116577] = 2,
    ACTIONS(11635), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116586] = 2,
    ACTIONS(11637), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116595] = 2,
    ACTIONS(3586), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116604] = 2,
    ACTIONS(9409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116613] = 2,
    ACTIONS(11639), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116622] = 2,
    ACTIONS(11641), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116631] = 2,
    ACTIONS(9590), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116640] = 2,
    ACTIONS(11643), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116649] = 2,
    ACTIONS(11645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116658] = 2,
    ACTIONS(11647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116667] = 2,
    ACTIONS(11649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116676] = 2,
    ACTIONS(11651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116685] = 2,
    ACTIONS(11653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116694] = 2,
    ACTIONS(11655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116703] = 2,
    ACTIONS(11657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116712] = 2,
    ACTIONS(8910), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116721] = 2,
    ACTIONS(11659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116730] = 2,
    ACTIONS(11661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116739] = 2,
    ACTIONS(11663), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116748] = 2,
    ACTIONS(11665), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116757] = 2,
    ACTIONS(11667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116766] = 2,
    ACTIONS(11669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116775] = 2,
    ACTIONS(11671), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116784] = 2,
    ACTIONS(11673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116793] = 2,
    ACTIONS(11675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116802] = 2,
    ACTIONS(11677), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116811] = 2,
    ACTIONS(6750), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116820] = 2,
    ACTIONS(6722), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116829] = 2,
    ACTIONS(11679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116838] = 2,
    ACTIONS(11681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116847] = 2,
    ACTIONS(9703), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116856] = 2,
    ACTIONS(11683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116865] = 2,
    ACTIONS(11685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116874] = 2,
    ACTIONS(11687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116883] = 2,
    ACTIONS(11689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116892] = 2,
    ACTIONS(11691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116901] = 2,
    ACTIONS(11693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116910] = 2,
    ACTIONS(11695), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116919] = 2,
    ACTIONS(11697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116928] = 2,
    ACTIONS(11699), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116937] = 2,
    ACTIONS(11701), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116946] = 2,
    ACTIONS(11703), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116955] = 2,
    ACTIONS(11705), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116964] = 2,
    ACTIONS(11707), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116973] = 2,
    ACTIONS(11709), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116982] = 2,
    ACTIONS(11711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [116991] = 2,
    ACTIONS(11713), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117000] = 2,
    ACTIONS(11715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117009] = 2,
    ACTIONS(11717), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117018] = 2,
    ACTIONS(11719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117027] = 2,
    ACTIONS(10981), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117036] = 2,
    ACTIONS(11721), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117045] = 2,
    ACTIONS(11723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117054] = 2,
    ACTIONS(11725), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117063] = 2,
    ACTIONS(11725), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117072] = 2,
    ACTIONS(11727), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117081] = 2,
    ACTIONS(11729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117090] = 2,
    ACTIONS(11731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117099] = 2,
    ACTIONS(11733), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117108] = 2,
    ACTIONS(11735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117117] = 2,
    ACTIONS(11737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117126] = 2,
    ACTIONS(11739), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117135] = 2,
    ACTIONS(11741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117144] = 2,
    ACTIONS(11743), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117153] = 2,
    ACTIONS(11745), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117162] = 2,
    ACTIONS(11747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117171] = 2,
    ACTIONS(11749), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117180] = 2,
    ACTIONS(11751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117189] = 2,
    ACTIONS(11753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117198] = 2,
    ACTIONS(11755), 1,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117207] = 2,
    ACTIONS(11333), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117216] = 2,
    ACTIONS(11757), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117225] = 2,
    ACTIONS(11759), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117234] = 2,
    ACTIONS(11761), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117243] = 2,
    ACTIONS(11763), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117252] = 2,
    ACTIONS(11765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117261] = 2,
    ACTIONS(11767), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117270] = 2,
    ACTIONS(11769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117279] = 2,
    ACTIONS(11771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117288] = 2,
    ACTIONS(11773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117297] = 2,
    ACTIONS(11775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117306] = 2,
    ACTIONS(11777), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117315] = 2,
    ACTIONS(11779), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117324] = 2,
    ACTIONS(11781), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117333] = 2,
    ACTIONS(11783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117342] = 2,
    ACTIONS(9530), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117351] = 2,
    ACTIONS(11785), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117360] = 2,
    ACTIONS(11787), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117369] = 2,
    ACTIONS(11789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117378] = 2,
    ACTIONS(11791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117387] = 2,
    ACTIONS(11793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117396] = 2,
    ACTIONS(11795), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117405] = 2,
    ACTIONS(11797), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117414] = 2,
    ACTIONS(11799), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117423] = 2,
    ACTIONS(11801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117432] = 2,
    ACTIONS(11803), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117441] = 2,
    ACTIONS(11805), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117450] = 2,
    ACTIONS(11807), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117459] = 2,
    ACTIONS(11809), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117468] = 2,
    ACTIONS(11811), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117477] = 2,
    ACTIONS(11813), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117486] = 2,
    ACTIONS(11815), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117495] = 2,
    ACTIONS(11817), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117504] = 2,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117513] = 2,
    ACTIONS(11819), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117522] = 2,
    ACTIONS(11821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117531] = 2,
    ACTIONS(11823), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117540] = 2,
    ACTIONS(11825), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117549] = 2,
    ACTIONS(11827), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117558] = 2,
    ACTIONS(11829), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117567] = 2,
    ACTIONS(11831), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117576] = 2,
    ACTIONS(11833), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117585] = 2,
    ACTIONS(11835), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117594] = 2,
    ACTIONS(11837), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117603] = 2,
    ACTIONS(6756), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117612] = 2,
    ACTIONS(9938), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117621] = 2,
    ACTIONS(11839), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117630] = 2,
    ACTIONS(11841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117639] = 2,
    ACTIONS(11843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117648] = 2,
    ACTIONS(11845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117657] = 2,
    ACTIONS(11847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117666] = 2,
    ACTIONS(11849), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117675] = 2,
    ACTIONS(11851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117684] = 2,
    ACTIONS(11853), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117693] = 2,
    ACTIONS(11855), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117702] = 2,
    ACTIONS(11857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117711] = 2,
    ACTIONS(11859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117720] = 2,
    ACTIONS(11861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117729] = 2,
    ACTIONS(10000), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117738] = 2,
    ACTIONS(11863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117747] = 2,
    ACTIONS(11865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117756] = 2,
    ACTIONS(3230), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117765] = 2,
    ACTIONS(11867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117774] = 2,
    ACTIONS(11869), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117783] = 2,
    ACTIONS(11871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117792] = 2,
    ACTIONS(11873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117801] = 2,
    ACTIONS(11875), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117810] = 2,
    ACTIONS(11877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117819] = 2,
    ACTIONS(11879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117828] = 2,
    ACTIONS(11881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117837] = 2,
    ACTIONS(11883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117846] = 2,
    ACTIONS(11885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117855] = 2,
    ACTIONS(9951), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117864] = 2,
    ACTIONS(11887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117873] = 2,
    ACTIONS(11889), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117882] = 2,
    ACTIONS(11891), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117891] = 2,
    ACTIONS(11893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117900] = 2,
    ACTIONS(11895), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117909] = 2,
    ACTIONS(11627), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117918] = 2,
    ACTIONS(11897), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117927] = 2,
    ACTIONS(11899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117936] = 2,
    ACTIONS(10017), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117945] = 2,
    ACTIONS(11901), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117954] = 2,
    ACTIONS(11903), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117963] = 2,
    ACTIONS(11905), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117972] = 2,
    ACTIONS(11907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117981] = 2,
    ACTIONS(11909), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117990] = 2,
    ACTIONS(11911), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [117999] = 2,
    ACTIONS(11913), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118008] = 2,
    ACTIONS(11915), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118017] = 2,
    ACTIONS(11915), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118026] = 2,
    ACTIONS(11917), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118035] = 2,
    ACTIONS(11919), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118044] = 2,
    ACTIONS(11921), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118053] = 2,
    ACTIONS(11923), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118062] = 2,
    ACTIONS(11925), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118071] = 2,
    ACTIONS(11927), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118080] = 2,
    ACTIONS(11929), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118089] = 2,
    ACTIONS(11931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118098] = 2,
    ACTIONS(6681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118107] = 2,
    ACTIONS(11933), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118116] = 2,
    ACTIONS(11935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118125] = 2,
    ACTIONS(11937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118134] = 2,
    ACTIONS(11939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118143] = 2,
    ACTIONS(11941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118152] = 2,
    ACTIONS(11943), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118161] = 2,
    ACTIONS(11945), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118170] = 2,
    ACTIONS(11947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118179] = 2,
    ACTIONS(11949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118188] = 2,
    ACTIONS(11951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118197] = 2,
    ACTIONS(11953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118206] = 2,
    ACTIONS(11955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118215] = 2,
    ACTIONS(11957), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118224] = 2,
    ACTIONS(11959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118233] = 2,
    ACTIONS(11961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118242] = 2,
    ACTIONS(11963), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118251] = 2,
    ACTIONS(11965), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118260] = 2,
    ACTIONS(11967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118269] = 2,
    ACTIONS(11969), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118278] = 2,
    ACTIONS(6706), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118287] = 2,
    ACTIONS(11971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118296] = 2,
    ACTIONS(11973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118305] = 2,
    ACTIONS(11975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118314] = 2,
    ACTIONS(11977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118323] = 2,
    ACTIONS(11979), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118332] = 2,
    ACTIONS(10145), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118341] = 2,
    ACTIONS(11981), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118350] = 2,
    ACTIONS(11983), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118359] = 2,
    ACTIONS(11985), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118368] = 2,
    ACTIONS(11987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118377] = 2,
    ACTIONS(11989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118386] = 2,
    ACTIONS(11991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118395] = 2,
    ACTIONS(11993), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118404] = 2,
    ACTIONS(11995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118413] = 2,
    ACTIONS(11203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118422] = 2,
    ACTIONS(11997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118431] = 2,
    ACTIONS(11999), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118440] = 2,
    ACTIONS(12001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118449] = 2,
    ACTIONS(12003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118458] = 2,
    ACTIONS(12005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118467] = 2,
    ACTIONS(12007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118476] = 2,
    ACTIONS(6758), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118485] = 2,
    ACTIONS(7597), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118494] = 2,
    ACTIONS(12009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118503] = 2,
    ACTIONS(12011), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118512] = 2,
    ACTIONS(12013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118521] = 2,
    ACTIONS(12015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118530] = 2,
    ACTIONS(12017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118539] = 2,
    ACTIONS(12019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118548] = 2,
    ACTIONS(12021), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118557] = 2,
    ACTIONS(12023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118566] = 2,
    ACTIONS(12025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118575] = 2,
    ACTIONS(12027), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118584] = 2,
    ACTIONS(12029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118593] = 2,
    ACTIONS(12031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118602] = 2,
    ACTIONS(12033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118611] = 2,
    ACTIONS(12035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118620] = 2,
    ACTIONS(12037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118629] = 2,
    ACTIONS(12039), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118638] = 2,
    ACTIONS(12041), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118647] = 2,
    ACTIONS(12043), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118656] = 2,
    ACTIONS(12045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118665] = 2,
    ACTIONS(12047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118674] = 2,
    ACTIONS(12049), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118683] = 2,
    ACTIONS(12051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118692] = 2,
    ACTIONS(12053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118701] = 2,
    ACTIONS(12055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118710] = 2,
    ACTIONS(12057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118719] = 2,
    ACTIONS(12059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118728] = 2,
    ACTIONS(12061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118737] = 2,
    ACTIONS(12063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118746] = 2,
    ACTIONS(12065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118755] = 2,
    ACTIONS(6760), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118764] = 2,
    ACTIONS(9729), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118773] = 2,
    ACTIONS(12067), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118782] = 2,
    ACTIONS(12069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118791] = 2,
    ACTIONS(12071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118800] = 2,
    ACTIONS(12073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118809] = 2,
    ACTIONS(12075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118818] = 2,
    ACTIONS(12077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118827] = 2,
    ACTIONS(12079), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118836] = 2,
    ACTIONS(12081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118845] = 2,
    ACTIONS(12083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118854] = 2,
    ACTIONS(12085), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118863] = 2,
    ACTIONS(12087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118872] = 2,
    ACTIONS(12089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118881] = 2,
    ACTIONS(12091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118890] = 2,
    ACTIONS(12093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118899] = 2,
    ACTIONS(12095), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118908] = 2,
    ACTIONS(12097), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118917] = 2,
    ACTIONS(12099), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118926] = 2,
    ACTIONS(12101), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118935] = 2,
    ACTIONS(12103), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118944] = 2,
    ACTIONS(12105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118953] = 2,
    ACTIONS(12107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118962] = 2,
    ACTIONS(12109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118971] = 2,
    ACTIONS(12111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118980] = 2,
    ACTIONS(12113), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118989] = 2,
    ACTIONS(12115), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [118998] = 2,
    ACTIONS(12117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119007] = 2,
    ACTIONS(12119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119016] = 2,
    ACTIONS(12121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119025] = 2,
    ACTIONS(12123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119034] = 2,
    ACTIONS(12125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119043] = 2,
    ACTIONS(12127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119052] = 2,
    ACTIONS(12129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119061] = 2,
    ACTIONS(12131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119070] = 2,
    ACTIONS(12133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119079] = 2,
    ACTIONS(12135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119088] = 2,
    ACTIONS(12137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119097] = 2,
    ACTIONS(12139), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119106] = 2,
    ACTIONS(12141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119115] = 2,
    ACTIONS(12143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119124] = 2,
    ACTIONS(6221), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119133] = 2,
    ACTIONS(12145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119142] = 2,
    ACTIONS(12147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119151] = 2,
    ACTIONS(12149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119160] = 2,
    ACTIONS(12151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119169] = 2,
    ACTIONS(12153), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119178] = 2,
    ACTIONS(12155), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119187] = 2,
    ACTIONS(12157), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119196] = 2,
    ACTIONS(12159), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119205] = 2,
    ACTIONS(12161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119214] = 2,
    ACTIONS(12163), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119223] = 2,
    ACTIONS(12165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119232] = 2,
    ACTIONS(6762), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119241] = 2,
    ACTIONS(12167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119250] = 2,
    ACTIONS(12169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119259] = 2,
    ACTIONS(12171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119268] = 2,
    ACTIONS(12173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119277] = 2,
    ACTIONS(12175), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119286] = 2,
    ACTIONS(12177), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119295] = 2,
    ACTIONS(12179), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119304] = 2,
    ACTIONS(12181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119313] = 2,
    ACTIONS(12183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119322] = 2,
    ACTIONS(12185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119331] = 2,
    ACTIONS(12187), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119340] = 2,
    ACTIONS(2891), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119349] = 2,
    ACTIONS(12189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119358] = 2,
    ACTIONS(12191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119367] = 2,
    ACTIONS(12193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119376] = 2,
    ACTIONS(12195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119385] = 2,
    ACTIONS(12197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119394] = 2,
    ACTIONS(12199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119403] = 2,
    ACTIONS(12201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119412] = 2,
    ACTIONS(10185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119421] = 2,
    ACTIONS(12203), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119430] = 2,
    ACTIONS(12205), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119439] = 2,
    ACTIONS(12207), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119448] = 2,
    ACTIONS(12209), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119457] = 2,
    ACTIONS(12211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119466] = 2,
    ACTIONS(12213), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119475] = 2,
    ACTIONS(12215), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119484] = 2,
    ACTIONS(12217), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119493] = 2,
    ACTIONS(6746), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119502] = 2,
    ACTIONS(12219), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119511] = 2,
    ACTIONS(12221), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119520] = 2,
    ACTIONS(12223), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119529] = 2,
    ACTIONS(12225), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119538] = 2,
    ACTIONS(12227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119547] = 2,
    ACTIONS(12229), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119556] = 2,
    ACTIONS(12231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119565] = 2,
    ACTIONS(12233), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119574] = 2,
    ACTIONS(12235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119583] = 2,
    ACTIONS(12237), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119592] = 2,
    ACTIONS(12239), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119601] = 2,
    ACTIONS(12225), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119610] = 2,
    ACTIONS(12241), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119619] = 2,
    ACTIONS(12243), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119628] = 2,
    ACTIONS(12245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119637] = 2,
    ACTIONS(12247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119646] = 2,
    ACTIONS(12249), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119655] = 2,
    ACTIONS(12251), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119664] = 2,
    ACTIONS(12253), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119673] = 2,
    ACTIONS(12255), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119682] = 2,
    ACTIONS(12257), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119691] = 2,
    ACTIONS(12259), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119700] = 2,
    ACTIONS(12261), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119709] = 2,
    ACTIONS(12263), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119718] = 2,
    ACTIONS(12265), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119727] = 2,
    ACTIONS(12267), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119736] = 2,
    ACTIONS(12269), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119745] = 2,
    ACTIONS(12271), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119754] = 2,
    ACTIONS(12273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119763] = 2,
    ACTIONS(6736), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119772] = 2,
    ACTIONS(12275), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119781] = 2,
    ACTIONS(9747), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119790] = 2,
    ACTIONS(12277), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119799] = 2,
    ACTIONS(12279), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119808] = 2,
    ACTIONS(12281), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119817] = 2,
    ACTIONS(12283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119826] = 2,
    ACTIONS(12285), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119835] = 2,
    ACTIONS(12287), 1,
      anon_sym_DASH,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119844] = 2,
    ACTIONS(12289), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119853] = 2,
    ACTIONS(6748), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119862] = 2,
    ACTIONS(6742), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119871] = 2,
    ACTIONS(12291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119880] = 2,
    ACTIONS(12293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119889] = 2,
    ACTIONS(12295), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119898] = 2,
    ACTIONS(12297), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119907] = 2,
    ACTIONS(12299), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119916] = 2,
    ACTIONS(12301), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119925] = 2,
    ACTIONS(12303), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119934] = 2,
    ACTIONS(11089), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119943] = 2,
    ACTIONS(12305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119952] = 2,
    ACTIONS(7188), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119961] = 2,
    ACTIONS(12307), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119970] = 2,
    ACTIONS(12309), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119979] = 2,
    ACTIONS(12311), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119988] = 2,
    ACTIONS(6718), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [119997] = 2,
    ACTIONS(12313), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120006] = 2,
    ACTIONS(12315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120015] = 2,
    ACTIONS(10309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120024] = 2,
    ACTIONS(12317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120033] = 2,
    ACTIONS(12319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120042] = 2,
    ACTIONS(12321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120051] = 2,
    ACTIONS(12323), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120060] = 2,
    ACTIONS(12325), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120069] = 2,
    ACTIONS(12327), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120078] = 2,
    ACTIONS(12329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120087] = 2,
    ACTIONS(12331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120096] = 2,
    ACTIONS(12333), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120105] = 2,
    ACTIONS(12335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120114] = 2,
    ACTIONS(12337), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120123] = 2,
    ACTIONS(12339), 1,
      sym_case,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120132] = 2,
    ACTIONS(12341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120141] = 2,
    ACTIONS(12343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120150] = 2,
    ACTIONS(12345), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120159] = 2,
    ACTIONS(9546), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120168] = 2,
    ACTIONS(12345), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120177] = 2,
    ACTIONS(12347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120186] = 2,
    ACTIONS(12349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120195] = 2,
    ACTIONS(12351), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120204] = 2,
    ACTIONS(12353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120213] = 2,
    ACTIONS(12355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120222] = 2,
    ACTIONS(12357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120231] = 2,
    ACTIONS(10071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120240] = 2,
    ACTIONS(12359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120249] = 2,
    ACTIONS(12361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120258] = 2,
    ACTIONS(12363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120267] = 2,
    ACTIONS(12365), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120276] = 2,
    ACTIONS(2897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120285] = 2,
    ACTIONS(6714), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120294] = 2,
    ACTIONS(12367), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120303] = 2,
    ACTIONS(12369), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120312] = 2,
    ACTIONS(12371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120321] = 2,
    ACTIONS(10079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120330] = 2,
    ACTIONS(12373), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120339] = 2,
    ACTIONS(10836), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120348] = 2,
    ACTIONS(12375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120357] = 2,
    ACTIONS(12377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120366] = 2,
    ACTIONS(12379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120375] = 2,
    ACTIONS(12381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120384] = 2,
    ACTIONS(12383), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120393] = 2,
    ACTIONS(12385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120402] = 2,
    ACTIONS(12387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120411] = 2,
    ACTIONS(12389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120420] = 2,
    ACTIONS(12391), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120429] = 2,
    ACTIONS(12393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120438] = 2,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120447] = 2,
    ACTIONS(12395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120456] = 2,
    ACTIONS(12397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120465] = 2,
    ACTIONS(12399), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120474] = 2,
    ACTIONS(12401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120483] = 2,
    ACTIONS(12403), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120492] = 2,
    ACTIONS(12405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120501] = 2,
    ACTIONS(12407), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120510] = 2,
    ACTIONS(12409), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120519] = 2,
    ACTIONS(12411), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120528] = 2,
    ACTIONS(12413), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120537] = 2,
    ACTIONS(12415), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120546] = 2,
    ACTIONS(9241), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120555] = 2,
    ACTIONS(12417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120564] = 2,
    ACTIONS(12419), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120573] = 2,
    ACTIONS(12421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120582] = 2,
    ACTIONS(12423), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120591] = 2,
    ACTIONS(12425), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120600] = 2,
    ACTIONS(8870), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120609] = 2,
    ACTIONS(12427), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120618] = 2,
    ACTIONS(12429), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120627] = 2,
    ACTIONS(12431), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120636] = 2,
    ACTIONS(12433), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120645] = 2,
    ACTIONS(10444), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120654] = 2,
    ACTIONS(12435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120663] = 2,
    ACTIONS(12437), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120672] = 2,
    ACTIONS(9669), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120681] = 2,
    ACTIONS(12439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120690] = 2,
    ACTIONS(12441), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120699] = 2,
    ACTIONS(12443), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120708] = 2,
    ACTIONS(12445), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120717] = 2,
    ACTIONS(12447), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120726] = 2,
    ACTIONS(12449), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120735] = 2,
    ACTIONS(12451), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120744] = 2,
    ACTIONS(12453), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120753] = 2,
    ACTIONS(3584), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120762] = 2,
    ACTIONS(12455), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120771] = 2,
    ACTIONS(12457), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120780] = 2,
    ACTIONS(12459), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120789] = 2,
    ACTIONS(6732), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120798] = 2,
    ACTIONS(8838), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120807] = 2,
    ACTIONS(12461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120816] = 2,
    ACTIONS(12463), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120825] = 2,
    ACTIONS(12465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120834] = 2,
    ACTIONS(6720), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120843] = 2,
    ACTIONS(12467), 1,
      sym_case,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120852] = 2,
    ACTIONS(12469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120861] = 2,
    ACTIONS(12471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120870] = 2,
    ACTIONS(12473), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120879] = 2,
    ACTIONS(12475), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120888] = 2,
    ACTIONS(12475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120897] = 2,
    ACTIONS(12477), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120906] = 2,
    ACTIONS(12479), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120915] = 2,
    ACTIONS(12481), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120924] = 2,
    ACTIONS(12483), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120933] = 2,
    ACTIONS(12481), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120942] = 2,
    ACTIONS(12485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120951] = 2,
    ACTIONS(12487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120960] = 2,
    ACTIONS(12489), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120969] = 2,
    ACTIONS(12491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120978] = 2,
    ACTIONS(12493), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120987] = 2,
    ACTIONS(6137), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [120996] = 2,
    ACTIONS(12495), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121005] = 2,
    ACTIONS(12497), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121014] = 2,
    ACTIONS(12499), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121023] = 2,
    ACTIONS(12501), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121032] = 2,
    ACTIONS(12503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121041] = 2,
    ACTIONS(12505), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121050] = 2,
    ACTIONS(12507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121059] = 2,
    ACTIONS(12509), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121068] = 2,
    ACTIONS(12511), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121077] = 2,
    ACTIONS(12513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121086] = 2,
    ACTIONS(12515), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121095] = 2,
    ACTIONS(12517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121104] = 2,
    ACTIONS(12519), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121113] = 2,
    ACTIONS(12521), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121122] = 2,
    ACTIONS(12523), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121131] = 2,
    ACTIONS(12525), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121140] = 2,
    ACTIONS(12527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121149] = 2,
    ACTIONS(12529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121158] = 2,
    ACTIONS(12531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121167] = 2,
    ACTIONS(12533), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121176] = 2,
    ACTIONS(12535), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121185] = 2,
    ACTIONS(12537), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121194] = 2,
    ACTIONS(9646), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121203] = 2,
    ACTIONS(12539), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121212] = 2,
    ACTIONS(12541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121221] = 2,
    ACTIONS(12543), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121230] = 2,
    ACTIONS(12545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121239] = 2,
    ACTIONS(12547), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121248] = 2,
    ACTIONS(12549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121257] = 2,
    ACTIONS(12551), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121266] = 2,
    ACTIONS(12553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121275] = 2,
    ACTIONS(12555), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121284] = 2,
    ACTIONS(12557), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121293] = 2,
    ACTIONS(12559), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121302] = 2,
    ACTIONS(12561), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121311] = 2,
    ACTIONS(12563), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121320] = 2,
    ACTIONS(12565), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121329] = 2,
    ACTIONS(12567), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121338] = 2,
    ACTIONS(12569), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121347] = 2,
    ACTIONS(12571), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121356] = 2,
    ACTIONS(12573), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121365] = 2,
    ACTIONS(12575), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121374] = 2,
    ACTIONS(12567), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121383] = 2,
    ACTIONS(12577), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121392] = 2,
    ACTIONS(12579), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121401] = 2,
    ACTIONS(12581), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121410] = 2,
    ACTIONS(12583), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121419] = 2,
    ACTIONS(12585), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121428] = 2,
    ACTIONS(10205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121437] = 2,
    ACTIONS(12587), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121446] = 2,
    ACTIONS(12589), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121455] = 2,
    ACTIONS(10226), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121464] = 2,
    ACTIONS(12591), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121473] = 2,
    ACTIONS(12593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121482] = 2,
    ACTIONS(12595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121491] = 2,
    ACTIONS(12597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121500] = 2,
    ACTIONS(10216), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121509] = 2,
    ACTIONS(6716), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121518] = 2,
    ACTIONS(12599), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121527] = 2,
    ACTIONS(12601), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121536] = 2,
    ACTIONS(12603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121545] = 2,
    ACTIONS(12605), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121554] = 2,
    ACTIONS(12607), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121563] = 2,
    ACTIONS(12609), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121572] = 2,
    ACTIONS(12611), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121581] = 2,
    ACTIONS(12613), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121590] = 2,
    ACTIONS(12615), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121599] = 2,
    ACTIONS(12617), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121608] = 2,
    ACTIONS(12619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121617] = 2,
    ACTIONS(12621), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121626] = 2,
    ACTIONS(12623), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121635] = 2,
    ACTIONS(12625), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121644] = 2,
    ACTIONS(12627), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121653] = 2,
    ACTIONS(12629), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121662] = 2,
    ACTIONS(6734), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121671] = 2,
    ACTIONS(12631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121680] = 2,
    ACTIONS(12633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121689] = 2,
    ACTIONS(12635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121698] = 2,
    ACTIONS(12637), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121707] = 2,
    ACTIONS(12639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121716] = 2,
    ACTIONS(12641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121725] = 2,
    ACTIONS(12643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121734] = 2,
    ACTIONS(12645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121743] = 2,
    ACTIONS(6764), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121752] = 2,
    ACTIONS(12647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121761] = 2,
    ACTIONS(12649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121770] = 2,
    ACTIONS(12651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121779] = 2,
    ACTIONS(12653), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121788] = 2,
    ACTIONS(12655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121797] = 2,
    ACTIONS(12657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121806] = 2,
    ACTIONS(12659), 1,
      anon_sym_C,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121815] = 2,
    ACTIONS(12661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121824] = 2,
    ACTIONS(12663), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121833] = 2,
    ACTIONS(12663), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121842] = 2,
    ACTIONS(12665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121851] = 2,
    ACTIONS(12667), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121860] = 2,
    ACTIONS(12669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121869] = 2,
    ACTIONS(12671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121878] = 2,
    ACTIONS(12673), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121887] = 2,
    ACTIONS(12675), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121896] = 2,
    ACTIONS(12677), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121905] = 2,
    ACTIONS(12679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121914] = 2,
    ACTIONS(12681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121923] = 2,
    ACTIONS(12683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121932] = 2,
    ACTIONS(12685), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121941] = 2,
    ACTIONS(12687), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121950] = 2,
    ACTIONS(10015), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121959] = 2,
    ACTIONS(12689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121968] = 2,
    ACTIONS(12691), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121977] = 2,
    ACTIONS(12693), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121986] = 2,
    ACTIONS(12695), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [121995] = 2,
    ACTIONS(12697), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122004] = 2,
    ACTIONS(12699), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122013] = 2,
    ACTIONS(12701), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122022] = 2,
    ACTIONS(12703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122031] = 2,
    ACTIONS(12705), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122040] = 2,
    ACTIONS(12707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122049] = 2,
    ACTIONS(12709), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122058] = 2,
    ACTIONS(12711), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122067] = 2,
    ACTIONS(12713), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122076] = 2,
    ACTIONS(12715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122085] = 2,
    ACTIONS(12717), 1,
      sym_ref,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122094] = 2,
    ACTIONS(12719), 1,
      anon_sym_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122103] = 2,
    ACTIONS(12721), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122112] = 2,
    ACTIONS(12723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122121] = 2,
    ACTIONS(12725), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122130] = 2,
    ACTIONS(12727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122139] = 2,
    ACTIONS(12729), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122148] = 2,
    ACTIONS(12731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122157] = 2,
    ACTIONS(12733), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122166] = 2,
    ACTIONS(10814), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122175] = 2,
    ACTIONS(12735), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122184] = 2,
    ACTIONS(12735), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122193] = 2,
    ACTIONS(12737), 1,
      anon_sym_C,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122202] = 2,
    ACTIONS(12739), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122211] = 2,
    ACTIONS(12741), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122220] = 2,
    ACTIONS(12743), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122229] = 2,
    ACTIONS(12745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122238] = 2,
    ACTIONS(12747), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122247] = 2,
    ACTIONS(12749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122256] = 2,
    ACTIONS(12751), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122265] = 2,
    ACTIONS(12753), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122274] = 2,
    ACTIONS(12755), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122283] = 2,
    ACTIONS(12757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122292] = 2,
    ACTIONS(12759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122301] = 2,
    ACTIONS(12761), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122310] = 2,
    ACTIONS(12763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122319] = 2,
    ACTIONS(12765), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122328] = 2,
    ACTIONS(12767), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122337] = 2,
    ACTIONS(12769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122346] = 2,
    ACTIONS(12771), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122355] = 2,
    ACTIONS(12773), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122364] = 2,
    ACTIONS(12775), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122373] = 2,
    ACTIONS(12777), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122382] = 2,
    ACTIONS(12779), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122391] = 2,
    ACTIONS(12781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122400] = 2,
    ACTIONS(10718), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122409] = 2,
    ACTIONS(12783), 1,
      sym_while,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122418] = 2,
    ACTIONS(12785), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122427] = 2,
    ACTIONS(12787), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122436] = 2,
    ACTIONS(12789), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122445] = 2,
    ACTIONS(12791), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122454] = 2,
    ACTIONS(12793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122463] = 2,
    ACTIONS(9264), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122472] = 2,
    ACTIONS(12795), 1,
      sym_case,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122481] = 2,
    ACTIONS(12797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122490] = 2,
    ACTIONS(12799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122499] = 2,
    ACTIONS(12801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122508] = 2,
    ACTIONS(9481), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122517] = 2,
    ACTIONS(12803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122526] = 2,
    ACTIONS(12805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122535] = 2,
    ACTIONS(12807), 1,
      anon_sym_EQ,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122544] = 2,
    ACTIONS(12809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122553] = 2,
    ACTIONS(12811), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122562] = 2,
    ACTIONS(12813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122571] = 2,
    ACTIONS(12815), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122580] = 2,
    ACTIONS(12817), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122589] = 2,
    ACTIONS(12819), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122598] = 2,
    ACTIONS(12821), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122607] = 2,
    ACTIONS(2883), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122616] = 2,
    ACTIONS(12823), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122625] = 2,
    ACTIONS(3226), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122634] = 2,
    ACTIONS(12825), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122643] = 2,
    ACTIONS(12827), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122652] = 2,
    ACTIONS(6728), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122661] = 2,
    ACTIONS(12829), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122670] = 2,
    ACTIONS(12831), 1,
      sym_while,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122679] = 2,
    ACTIONS(12833), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122688] = 2,
    ACTIONS(12835), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122697] = 2,
    ACTIONS(12837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122706] = 2,
    ACTIONS(12839), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122715] = 2,
    ACTIONS(12841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122724] = 2,
    ACTIONS(10474), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122733] = 2,
    ACTIONS(12843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122742] = 2,
    ACTIONS(12845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122751] = 2,
    ACTIONS(5722), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122760] = 2,
    ACTIONS(12847), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122769] = 2,
    ACTIONS(12849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122778] = 2,
    ACTIONS(12851), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122787] = 2,
    ACTIONS(12853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122796] = 2,
    ACTIONS(12855), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122805] = 2,
    ACTIONS(12857), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122814] = 2,
    ACTIONS(12859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122823] = 2,
    ACTIONS(12861), 1,
      sym_while,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122832] = 2,
    ACTIONS(12863), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122841] = 2,
    ACTIONS(12865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122850] = 2,
    ACTIONS(12867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122859] = 2,
    ACTIONS(12869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122868] = 2,
    ACTIONS(12871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122877] = 2,
    ACTIONS(12873), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122886] = 2,
    ACTIONS(12875), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122895] = 2,
    ACTIONS(9495), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122904] = 2,
    ACTIONS(12877), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122913] = 2,
    ACTIONS(12879), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122922] = 2,
    ACTIONS(12881), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122931] = 2,
    ACTIONS(12883), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122940] = 2,
    ACTIONS(12885), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122949] = 2,
    ACTIONS(12887), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122958] = 2,
    ACTIONS(12889), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122967] = 2,
    ACTIONS(3572), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122976] = 2,
    ACTIONS(12891), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122985] = 2,
    ACTIONS(12653), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [122994] = 2,
    ACTIONS(12893), 1,
      aux_sym_shebang_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123003] = 2,
    ACTIONS(12895), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123012] = 2,
    ACTIONS(12897), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123021] = 2,
    ACTIONS(12899), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123030] = 2,
    ACTIONS(12901), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123039] = 2,
    ACTIONS(12903), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123048] = 2,
    ACTIONS(12905), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123057] = 2,
    ACTIONS(12907), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123066] = 2,
    ACTIONS(8872), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123075] = 2,
    ACTIONS(12909), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123084] = 2,
    ACTIONS(12911), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123093] = 2,
    ACTIONS(6710), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123102] = 2,
    ACTIONS(12913), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123111] = 2,
    ACTIONS(12915), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123120] = 2,
    ACTIONS(12917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123129] = 2,
    ACTIONS(12919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123138] = 2,
    ACTIONS(12921), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123147] = 2,
    ACTIONS(12921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123156] = 2,
    ACTIONS(12923), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123165] = 2,
    ACTIONS(12925), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123174] = 2,
    ACTIONS(12927), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123183] = 2,
    ACTIONS(12929), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123192] = 2,
    ACTIONS(12931), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123201] = 2,
    ACTIONS(12933), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123210] = 2,
    ACTIONS(12933), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123219] = 2,
    ACTIONS(12935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123228] = 2,
    ACTIONS(12937), 1,
      aux_sym_raw_string_token4,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123237] = 2,
    ACTIONS(12939), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123246] = 2,
    ACTIONS(5090), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123255] = 2,
    ACTIONS(12941), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123264] = 2,
    ACTIONS(12943), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123273] = 2,
    ACTIONS(12945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123282] = 2,
    ACTIONS(12947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123291] = 2,
    ACTIONS(12949), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123300] = 2,
    ACTIONS(12951), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123309] = 2,
    ACTIONS(12953), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123318] = 2,
    ACTIONS(12955), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123327] = 2,
    ACTIONS(12957), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123336] = 2,
    ACTIONS(12959), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123345] = 2,
    ACTIONS(12961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123354] = 2,
    ACTIONS(12963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123363] = 2,
    ACTIONS(12965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123372] = 2,
    ACTIONS(12967), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123381] = 2,
    ACTIONS(10462), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123390] = 2,
    ACTIONS(12969), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123399] = 2,
    ACTIONS(12971), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123408] = 2,
    ACTIONS(12973), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123417] = 2,
    ACTIONS(12975), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123426] = 2,
    ACTIONS(12977), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123435] = 2,
    ACTIONS(12979), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123444] = 2,
    ACTIONS(12981), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123453] = 2,
    ACTIONS(12983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123462] = 2,
    ACTIONS(9659), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123471] = 2,
    ACTIONS(12985), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123480] = 2,
    ACTIONS(12937), 1,
      aux_sym_raw_string_token2,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123489] = 2,
    ACTIONS(12987), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123498] = 2,
    ACTIONS(12989), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123507] = 2,
    ACTIONS(12991), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123516] = 2,
    ACTIONS(12993), 1,
      aux_sym_hex_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123525] = 2,
    ACTIONS(12995), 1,
      aux_sym_raw_string_token3,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123534] = 2,
    ACTIONS(12997), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123543] = 2,
    ACTIONS(12999), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123552] = 2,
    ACTIONS(13001), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123561] = 2,
    ACTIONS(13003), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123570] = 2,
    ACTIONS(13005), 1,
      aux_sym_raw_string_token1,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123579] = 2,
    ACTIONS(13007), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123588] = 2,
    ACTIONS(13009), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123597] = 2,
    ACTIONS(13011), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123606] = 2,
    ACTIONS(13013), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123615] = 2,
    ACTIONS(13015), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123624] = 2,
    ACTIONS(10842), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123633] = 2,
    ACTIONS(13017), 1,
      sym_while,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123642] = 2,
    ACTIONS(13019), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123651] = 2,
    ACTIONS(9622), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123660] = 2,
    ACTIONS(13021), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123669] = 2,
    ACTIONS(13023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123678] = 2,
    ACTIONS(13025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123687] = 2,
    ACTIONS(13027), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123696] = 2,
    ACTIONS(13029), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123705] = 2,
    ACTIONS(13031), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123714] = 2,
    ACTIONS(13033), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123723] = 2,
    ACTIONS(10736), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123732] = 2,
    ACTIONS(3518), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123741] = 2,
    ACTIONS(13035), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123750] = 2,
    ACTIONS(13037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123759] = 2,
    ACTIONS(13039), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123768] = 2,
    ACTIONS(13041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123777] = 2,
    ACTIONS(10740), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123786] = 2,
    ACTIONS(13043), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123795] = 2,
    ACTIONS(13045), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123804] = 2,
    ACTIONS(13047), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123813] = 2,
    ACTIONS(13049), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123822] = 2,
    ACTIONS(13051), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123831] = 2,
    ACTIONS(13053), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123840] = 2,
    ACTIONS(13055), 1,
      anon_sym_COLON,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123849] = 2,
    ACTIONS(13057), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123858] = 2,
    ACTIONS(13059), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123867] = 2,
    ACTIONS(13061), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123876] = 2,
    ACTIONS(13063), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123885] = 2,
    ACTIONS(13065), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123894] = 2,
    ACTIONS(13067), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123903] = 2,
    ACTIONS(13069), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123912] = 2,
    ACTIONS(13071), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123921] = 2,
    ACTIONS(13073), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123930] = 2,
    ACTIONS(13075), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123939] = 2,
    ACTIONS(13077), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123948] = 2,
    ACTIONS(13079), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123957] = 2,
    ACTIONS(13081), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123966] = 2,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123975] = 2,
    ACTIONS(13085), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123984] = 2,
    ACTIONS(13087), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [123993] = 2,
    ACTIONS(13089), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124002] = 2,
    ACTIONS(13091), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124011] = 2,
    ACTIONS(13093), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124020] = 2,
    ACTIONS(13095), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124029] = 2,
    ACTIONS(13097), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124038] = 2,
    ACTIONS(13099), 1,
      sym_identifier,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124047] = 2,
    ACTIONS(8544), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124056] = 2,
    ACTIONS(13101), 1,
      sym_this,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124065] = 2,
    ACTIONS(8531), 1,
      anon_sym_SQUOTE,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
  [124074] = 2,
    ACTIONS(13103), 1,
      anon_sym_SEMI,
    ACTIONS(3), 3,
      sym_end_file,
      sym_comment,
      sym_directive,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2739)] = 0,
  [SMALL_STATE(2740)] = 105,
  [SMALL_STATE(2741)] = 210,
  [SMALL_STATE(2742)] = 315,
  [SMALL_STATE(2743)] = 420,
  [SMALL_STATE(2744)] = 525,
  [SMALL_STATE(2745)] = 604,
  [SMALL_STATE(2746)] = 709,
  [SMALL_STATE(2747)] = 814,
  [SMALL_STATE(2748)] = 919,
  [SMALL_STATE(2749)] = 1024,
  [SMALL_STATE(2750)] = 1129,
  [SMALL_STATE(2751)] = 1234,
  [SMALL_STATE(2752)] = 1339,
  [SMALL_STATE(2753)] = 1414,
  [SMALL_STATE(2754)] = 1519,
  [SMALL_STATE(2755)] = 1624,
  [SMALL_STATE(2756)] = 1729,
  [SMALL_STATE(2757)] = 1834,
  [SMALL_STATE(2758)] = 1939,
  [SMALL_STATE(2759)] = 2044,
  [SMALL_STATE(2760)] = 2149,
  [SMALL_STATE(2761)] = 2254,
  [SMALL_STATE(2762)] = 2324,
  [SMALL_STATE(2763)] = 2398,
  [SMALL_STATE(2764)] = 2468,
  [SMALL_STATE(2765)] = 2570,
  [SMALL_STATE(2766)] = 2640,
  [SMALL_STATE(2767)] = 2710,
  [SMALL_STATE(2768)] = 2780,
  [SMALL_STATE(2769)] = 2850,
  [SMALL_STATE(2770)] = 2926,
  [SMALL_STATE(2771)] = 2996,
  [SMALL_STATE(2772)] = 3066,
  [SMALL_STATE(2773)] = 3136,
  [SMALL_STATE(2774)] = 3206,
  [SMALL_STATE(2775)] = 3308,
  [SMALL_STATE(2776)] = 3378,
  [SMALL_STATE(2777)] = 3480,
  [SMALL_STATE(2778)] = 3550,
  [SMALL_STATE(2779)] = 3652,
  [SMALL_STATE(2780)] = 3722,
  [SMALL_STATE(2781)] = 3792,
  [SMALL_STATE(2782)] = 3862,
  [SMALL_STATE(2783)] = 3964,
  [SMALL_STATE(2784)] = 4034,
  [SMALL_STATE(2785)] = 4136,
  [SMALL_STATE(2786)] = 4206,
  [SMALL_STATE(2787)] = 4276,
  [SMALL_STATE(2788)] = 4346,
  [SMALL_STATE(2789)] = 4416,
  [SMALL_STATE(2790)] = 4486,
  [SMALL_STATE(2791)] = 4556,
  [SMALL_STATE(2792)] = 4626,
  [SMALL_STATE(2793)] = 4728,
  [SMALL_STATE(2794)] = 4830,
  [SMALL_STATE(2795)] = 4932,
  [SMALL_STATE(2796)] = 5008,
  [SMALL_STATE(2797)] = 5078,
  [SMALL_STATE(2798)] = 5148,
  [SMALL_STATE(2799)] = 5250,
  [SMALL_STATE(2800)] = 5352,
  [SMALL_STATE(2801)] = 5422,
  [SMALL_STATE(2802)] = 5498,
  [SMALL_STATE(2803)] = 5568,
  [SMALL_STATE(2804)] = 5644,
  [SMALL_STATE(2805)] = 5714,
  [SMALL_STATE(2806)] = 5784,
  [SMALL_STATE(2807)] = 5854,
  [SMALL_STATE(2808)] = 5924,
  [SMALL_STATE(2809)] = 5993,
  [SMALL_STATE(2810)] = 6064,
  [SMALL_STATE(2811)] = 6141,
  [SMALL_STATE(2812)] = 6210,
  [SMALL_STATE(2813)] = 6279,
  [SMALL_STATE(2814)] = 6348,
  [SMALL_STATE(2815)] = 6417,
  [SMALL_STATE(2816)] = 6486,
  [SMALL_STATE(2817)] = 6555,
  [SMALL_STATE(2818)] = 6624,
  [SMALL_STATE(2819)] = 6693,
  [SMALL_STATE(2820)] = 6762,
  [SMALL_STATE(2821)] = 6835,
  [SMALL_STATE(2822)] = 6912,
  [SMALL_STATE(2823)] = 6981,
  [SMALL_STATE(2824)] = 7050,
  [SMALL_STATE(2825)] = 7119,
  [SMALL_STATE(2826)] = 7188,
  [SMALL_STATE(2827)] = 7257,
  [SMALL_STATE(2828)] = 7326,
  [SMALL_STATE(2829)] = 7395,
  [SMALL_STATE(2830)] = 7464,
  [SMALL_STATE(2831)] = 7533,
  [SMALL_STATE(2832)] = 7608,
  [SMALL_STATE(2833)] = 7677,
  [SMALL_STATE(2834)] = 7746,
  [SMALL_STATE(2835)] = 7815,
  [SMALL_STATE(2836)] = 7884,
  [SMALL_STATE(2837)] = 7953,
  [SMALL_STATE(2838)] = 8026,
  [SMALL_STATE(2839)] = 8095,
  [SMALL_STATE(2840)] = 8164,
  [SMALL_STATE(2841)] = 8237,
  [SMALL_STATE(2842)] = 8306,
  [SMALL_STATE(2843)] = 8375,
  [SMALL_STATE(2844)] = 8444,
  [SMALL_STATE(2845)] = 8513,
  [SMALL_STATE(2846)] = 8582,
  [SMALL_STATE(2847)] = 8680,
  [SMALL_STATE(2848)] = 8778,
  [SMALL_STATE(2849)] = 8876,
  [SMALL_STATE(2850)] = 8974,
  [SMALL_STATE(2851)] = 9072,
  [SMALL_STATE(2852)] = 9170,
  [SMALL_STATE(2853)] = 9268,
  [SMALL_STATE(2854)] = 9366,
  [SMALL_STATE(2855)] = 9464,
  [SMALL_STATE(2856)] = 9562,
  [SMALL_STATE(2857)] = 9660,
  [SMALL_STATE(2858)] = 9758,
  [SMALL_STATE(2859)] = 9856,
  [SMALL_STATE(2860)] = 9954,
  [SMALL_STATE(2861)] = 10052,
  [SMALL_STATE(2862)] = 10126,
  [SMALL_STATE(2863)] = 10224,
  [SMALL_STATE(2864)] = 10322,
  [SMALL_STATE(2865)] = 10420,
  [SMALL_STATE(2866)] = 10492,
  [SMALL_STATE(2867)] = 10590,
  [SMALL_STATE(2868)] = 10664,
  [SMALL_STATE(2869)] = 10762,
  [SMALL_STATE(2870)] = 10832,
  [SMALL_STATE(2871)] = 10930,
  [SMALL_STATE(2872)] = 11000,
  [SMALL_STATE(2873)] = 11098,
  [SMALL_STATE(2874)] = 11196,
  [SMALL_STATE(2875)] = 11294,
  [SMALL_STATE(2876)] = 11392,
  [SMALL_STATE(2877)] = 11490,
  [SMALL_STATE(2878)] = 11564,
  [SMALL_STATE(2879)] = 11662,
  [SMALL_STATE(2880)] = 11760,
  [SMALL_STATE(2881)] = 11858,
  [SMALL_STATE(2882)] = 11956,
  [SMALL_STATE(2883)] = 12054,
  [SMALL_STATE(2884)] = 12128,
  [SMALL_STATE(2885)] = 12226,
  [SMALL_STATE(2886)] = 12324,
  [SMALL_STATE(2887)] = 12399,
  [SMALL_STATE(2888)] = 12466,
  [SMALL_STATE(2889)] = 12537,
  [SMALL_STATE(2890)] = 12604,
  [SMALL_STATE(2891)] = 12671,
  [SMALL_STATE(2892)] = 12738,
  [SMALL_STATE(2893)] = 12805,
  [SMALL_STATE(2894)] = 12872,
  [SMALL_STATE(2895)] = 12939,
  [SMALL_STATE(2896)] = 13006,
  [SMALL_STATE(2897)] = 13079,
  [SMALL_STATE(2898)] = 13146,
  [SMALL_STATE(2899)] = 13213,
  [SMALL_STATE(2900)] = 13286,
  [SMALL_STATE(2901)] = 13353,
  [SMALL_STATE(2902)] = 13448,
  [SMALL_STATE(2903)] = 13515,
  [SMALL_STATE(2904)] = 13582,
  [SMALL_STATE(2905)] = 13683,
  [SMALL_STATE(2906)] = 13750,
  [SMALL_STATE(2907)] = 13817,
  [SMALL_STATE(2908)] = 13884,
  [SMALL_STATE(2909)] = 13951,
  [SMALL_STATE(2910)] = 14018,
  [SMALL_STATE(2911)] = 14085,
  [SMALL_STATE(2912)] = 14152,
  [SMALL_STATE(2913)] = 14225,
  [SMALL_STATE(2914)] = 14291,
  [SMALL_STATE(2915)] = 14389,
  [SMALL_STATE(2916)] = 14487,
  [SMALL_STATE(2917)] = 14585,
  [SMALL_STATE(2918)] = 14651,
  [SMALL_STATE(2919)] = 14717,
  [SMALL_STATE(2920)] = 14815,
  [SMALL_STATE(2921)] = 14913,
  [SMALL_STATE(2922)] = 15011,
  [SMALL_STATE(2923)] = 15077,
  [SMALL_STATE(2924)] = 15159,
  [SMALL_STATE(2925)] = 15257,
  [SMALL_STATE(2926)] = 15323,
  [SMALL_STATE(2927)] = 15389,
  [SMALL_STATE(2928)] = 15471,
  [SMALL_STATE(2929)] = 15537,
  [SMALL_STATE(2930)] = 15603,
  [SMALL_STATE(2931)] = 15701,
  [SMALL_STATE(2932)] = 15799,
  [SMALL_STATE(2933)] = 15897,
  [SMALL_STATE(2934)] = 15995,
  [SMALL_STATE(2935)] = 16061,
  [SMALL_STATE(2936)] = 16127,
  [SMALL_STATE(2937)] = 16201,
  [SMALL_STATE(2938)] = 16276,
  [SMALL_STATE(2939)] = 16341,
  [SMALL_STATE(2940)] = 16410,
  [SMALL_STATE(2941)] = 16505,
  [SMALL_STATE(2942)] = 16570,
  [SMALL_STATE(2943)] = 16645,
  [SMALL_STATE(2944)] = 16710,
  [SMALL_STATE(2945)] = 16795,
  [SMALL_STATE(2946)] = 16870,
  [SMALL_STATE(2947)] = 16945,
  [SMALL_STATE(2948)] = 17020,
  [SMALL_STATE(2949)] = 17093,
  [SMALL_STATE(2950)] = 17157,
  [SMALL_STATE(2951)] = 17229,
  [SMALL_STATE(2952)] = 17297,
  [SMALL_STATE(2953)] = 17393,
  [SMALL_STATE(2954)] = 17489,
  [SMALL_STATE(2955)] = 17553,
  [SMALL_STATE(2956)] = 17649,
  [SMALL_STATE(2957)] = 17713,
  [SMALL_STATE(2958)] = 17805,
  [SMALL_STATE(2959)] = 17887,
  [SMALL_STATE(2960)] = 17951,
  [SMALL_STATE(2961)] = 18035,
  [SMALL_STATE(2962)] = 18099,
  [SMALL_STATE(2963)] = 18163,
  [SMALL_STATE(2964)] = 18247,
  [SMALL_STATE(2965)] = 18343,
  [SMALL_STATE(2966)] = 18407,
  [SMALL_STATE(2967)] = 18471,
  [SMALL_STATE(2968)] = 18545,
  [SMALL_STATE(2969)] = 18609,
  [SMALL_STATE(2970)] = 18701,
  [SMALL_STATE(2971)] = 18765,
  [SMALL_STATE(2972)] = 18829,
  [SMALL_STATE(2973)] = 18893,
  [SMALL_STATE(2974)] = 18957,
  [SMALL_STATE(2975)] = 19041,
  [SMALL_STATE(2976)] = 19105,
  [SMALL_STATE(2977)] = 19169,
  [SMALL_STATE(2978)] = 19233,
  [SMALL_STATE(2979)] = 19297,
  [SMALL_STATE(2980)] = 19371,
  [SMALL_STATE(2981)] = 19463,
  [SMALL_STATE(2982)] = 19559,
  [SMALL_STATE(2983)] = 19633,
  [SMALL_STATE(2984)] = 19697,
  [SMALL_STATE(2985)] = 19761,
  [SMALL_STATE(2986)] = 19845,
  [SMALL_STATE(2987)] = 19909,
  [SMALL_STATE(2988)] = 19973,
  [SMALL_STATE(2989)] = 20037,
  [SMALL_STATE(2990)] = 20101,
  [SMALL_STATE(2991)] = 20165,
  [SMALL_STATE(2992)] = 20229,
  [SMALL_STATE(2993)] = 20293,
  [SMALL_STATE(2994)] = 20357,
  [SMALL_STATE(2995)] = 20421,
  [SMALL_STATE(2996)] = 20485,
  [SMALL_STATE(2997)] = 20549,
  [SMALL_STATE(2998)] = 20613,
  [SMALL_STATE(2999)] = 20677,
  [SMALL_STATE(3000)] = 20741,
  [SMALL_STATE(3001)] = 20805,
  [SMALL_STATE(3002)] = 20869,
  [SMALL_STATE(3003)] = 20965,
  [SMALL_STATE(3004)] = 21029,
  [SMALL_STATE(3005)] = 21093,
  [SMALL_STATE(3006)] = 21157,
  [SMALL_STATE(3007)] = 21221,
  [SMALL_STATE(3008)] = 21285,
  [SMALL_STATE(3009)] = 21349,
  [SMALL_STATE(3010)] = 21413,
  [SMALL_STATE(3011)] = 21477,
  [SMALL_STATE(3012)] = 21541,
  [SMALL_STATE(3013)] = 21605,
  [SMALL_STATE(3014)] = 21669,
  [SMALL_STATE(3015)] = 21733,
  [SMALL_STATE(3016)] = 21797,
  [SMALL_STATE(3017)] = 21861,
  [SMALL_STATE(3018)] = 21925,
  [SMALL_STATE(3019)] = 21989,
  [SMALL_STATE(3020)] = 22053,
  [SMALL_STATE(3021)] = 22117,
  [SMALL_STATE(3022)] = 22191,
  [SMALL_STATE(3023)] = 22255,
  [SMALL_STATE(3024)] = 22339,
  [SMALL_STATE(3025)] = 22404,
  [SMALL_STATE(3026)] = 22473,
  [SMALL_STATE(3027)] = 22536,
  [SMALL_STATE(3028)] = 22609,
  [SMALL_STATE(3029)] = 22678,
  [SMALL_STATE(3030)] = 22741,
  [SMALL_STATE(3031)] = 22810,
  [SMALL_STATE(3032)] = 22891,
  [SMALL_STATE(3033)] = 22954,
  [SMALL_STATE(3034)] = 23017,
  [SMALL_STATE(3035)] = 23084,
  [SMALL_STATE(3036)] = 23163,
  [SMALL_STATE(3037)] = 23226,
  [SMALL_STATE(3038)] = 23289,
  [SMALL_STATE(3039)] = 23352,
  [SMALL_STATE(3040)] = 23415,
  [SMALL_STATE(3041)] = 23478,
  [SMALL_STATE(3042)] = 23541,
  [SMALL_STATE(3043)] = 23614,
  [SMALL_STATE(3044)] = 23703,
  [SMALL_STATE(3045)] = 23766,
  [SMALL_STATE(3046)] = 23829,
  [SMALL_STATE(3047)] = 23892,
  [SMALL_STATE(3048)] = 23957,
  [SMALL_STATE(3049)] = 24020,
  [SMALL_STATE(3050)] = 24109,
  [SMALL_STATE(3051)] = 24172,
  [SMALL_STATE(3052)] = 24235,
  [SMALL_STATE(3053)] = 24298,
  [SMALL_STATE(3054)] = 24377,
  [SMALL_STATE(3055)] = 24458,
  [SMALL_STATE(3056)] = 24525,
  [SMALL_STATE(3057)] = 24588,
  [SMALL_STATE(3058)] = 24661,
  [SMALL_STATE(3059)] = 24734,
  [SMALL_STATE(3060)] = 24807,
  [SMALL_STATE(3061)] = 24870,
  [SMALL_STATE(3062)] = 24959,
  [SMALL_STATE(3063)] = 25022,
  [SMALL_STATE(3064)] = 25101,
  [SMALL_STATE(3065)] = 25180,
  [SMALL_STATE(3066)] = 25245,
  [SMALL_STATE(3067)] = 25316,
  [SMALL_STATE(3068)] = 25402,
  [SMALL_STATE(3069)] = 25488,
  [SMALL_STATE(3070)] = 25564,
  [SMALL_STATE(3071)] = 25650,
  [SMALL_STATE(3072)] = 25728,
  [SMALL_STATE(3073)] = 25814,
  [SMALL_STATE(3074)] = 25900,
  [SMALL_STATE(3075)] = 25972,
  [SMALL_STATE(3076)] = 26058,
  [SMALL_STATE(3077)] = 26128,
  [SMALL_STATE(3078)] = 26200,
  [SMALL_STATE(3079)] = 26272,
  [SMALL_STATE(3080)] = 26358,
  [SMALL_STATE(3081)] = 26444,
  [SMALL_STATE(3082)] = 26530,
  [SMALL_STATE(3083)] = 26616,
  [SMALL_STATE(3084)] = 26682,
  [SMALL_STATE(3085)] = 26760,
  [SMALL_STATE(3086)] = 26846,
  [SMALL_STATE(3087)] = 26918,
  [SMALL_STATE(3088)] = 26996,
  [SMALL_STATE(3089)] = 27082,
  [SMALL_STATE(3090)] = 27168,
  [SMALL_STATE(3091)] = 27254,
  [SMALL_STATE(3092)] = 27330,
  [SMALL_STATE(3093)] = 27416,
  [SMALL_STATE(3094)] = 27502,
  [SMALL_STATE(3095)] = 27588,
  [SMALL_STATE(3096)] = 27674,
  [SMALL_STATE(3097)] = 27760,
  [SMALL_STATE(3098)] = 27832,
  [SMALL_STATE(3099)] = 27918,
  [SMALL_STATE(3100)] = 28004,
  [SMALL_STATE(3101)] = 28076,
  [SMALL_STATE(3102)] = 28162,
  [SMALL_STATE(3103)] = 28248,
  [SMALL_STATE(3104)] = 28334,
  [SMALL_STATE(3105)] = 28420,
  [SMALL_STATE(3106)] = 28506,
  [SMALL_STATE(3107)] = 28592,
  [SMALL_STATE(3108)] = 28668,
  [SMALL_STATE(3109)] = 28754,
  [SMALL_STATE(3110)] = 28840,
  [SMALL_STATE(3111)] = 28926,
  [SMALL_STATE(3112)] = 29012,
  [SMALL_STATE(3113)] = 29098,
  [SMALL_STATE(3114)] = 29184,
  [SMALL_STATE(3115)] = 29256,
  [SMALL_STATE(3116)] = 29342,
  [SMALL_STATE(3117)] = 29428,
  [SMALL_STATE(3118)] = 29514,
  [SMALL_STATE(3119)] = 29600,
  [SMALL_STATE(3120)] = 29686,
  [SMALL_STATE(3121)] = 29772,
  [SMALL_STATE(3122)] = 29848,
  [SMALL_STATE(3123)] = 29934,
  [SMALL_STATE(3124)] = 30020,
  [SMALL_STATE(3125)] = 30106,
  [SMALL_STATE(3126)] = 30178,
  [SMALL_STATE(3127)] = 30264,
  [SMALL_STATE(3128)] = 30342,
  [SMALL_STATE(3129)] = 30428,
  [SMALL_STATE(3130)] = 30514,
  [SMALL_STATE(3131)] = 30600,
  [SMALL_STATE(3132)] = 30686,
  [SMALL_STATE(3133)] = 30772,
  [SMALL_STATE(3134)] = 30844,
  [SMALL_STATE(3135)] = 30930,
  [SMALL_STATE(3136)] = 31016,
  [SMALL_STATE(3137)] = 31102,
  [SMALL_STATE(3138)] = 31188,
  [SMALL_STATE(3139)] = 31274,
  [SMALL_STATE(3140)] = 31346,
  [SMALL_STATE(3141)] = 31432,
  [SMALL_STATE(3142)] = 31518,
  [SMALL_STATE(3143)] = 31604,
  [SMALL_STATE(3144)] = 31690,
  [SMALL_STATE(3145)] = 31776,
  [SMALL_STATE(3146)] = 31862,
  [SMALL_STATE(3147)] = 31948,
  [SMALL_STATE(3148)] = 32034,
  [SMALL_STATE(3149)] = 32120,
  [SMALL_STATE(3150)] = 32206,
  [SMALL_STATE(3151)] = 32292,
  [SMALL_STATE(3152)] = 32356,
  [SMALL_STATE(3153)] = 32428,
  [SMALL_STATE(3154)] = 32514,
  [SMALL_STATE(3155)] = 32600,
  [SMALL_STATE(3156)] = 32686,
  [SMALL_STATE(3157)] = 32772,
  [SMALL_STATE(3158)] = 32858,
  [SMALL_STATE(3159)] = 32930,
  [SMALL_STATE(3160)] = 33016,
  [SMALL_STATE(3161)] = 33080,
  [SMALL_STATE(3162)] = 33156,
  [SMALL_STATE(3163)] = 33220,
  [SMALL_STATE(3164)] = 33284,
  [SMALL_STATE(3165)] = 33370,
  [SMALL_STATE(3166)] = 33431,
  [SMALL_STATE(3167)] = 33492,
  [SMALL_STATE(3168)] = 33553,
  [SMALL_STATE(3169)] = 33614,
  [SMALL_STATE(3170)] = 33685,
  [SMALL_STATE(3171)] = 33748,
  [SMALL_STATE(3172)] = 33809,
  [SMALL_STATE(3173)] = 33870,
  [SMALL_STATE(3174)] = 33935,
  [SMALL_STATE(3175)] = 33996,
  [SMALL_STATE(3176)] = 34057,
  [SMALL_STATE(3177)] = 34118,
  [SMALL_STATE(3178)] = 34179,
  [SMALL_STATE(3179)] = 34240,
  [SMALL_STATE(3180)] = 34301,
  [SMALL_STATE(3181)] = 34362,
  [SMALL_STATE(3182)] = 34423,
  [SMALL_STATE(3183)] = 34484,
  [SMALL_STATE(3184)] = 34547,
  [SMALL_STATE(3185)] = 34608,
  [SMALL_STATE(3186)] = 34671,
  [SMALL_STATE(3187)] = 34736,
  [SMALL_STATE(3188)] = 34799,
  [SMALL_STATE(3189)] = 34862,
  [SMALL_STATE(3190)] = 34927,
  [SMALL_STATE(3191)] = 35010,
  [SMALL_STATE(3192)] = 35071,
  [SMALL_STATE(3193)] = 35142,
  [SMALL_STATE(3194)] = 35203,
  [SMALL_STATE(3195)] = 35264,
  [SMALL_STATE(3196)] = 35341,
  [SMALL_STATE(3197)] = 35402,
  [SMALL_STATE(3198)] = 35473,
  [SMALL_STATE(3199)] = 35534,
  [SMALL_STATE(3200)] = 35595,
  [SMALL_STATE(3201)] = 35678,
  [SMALL_STATE(3202)] = 35761,
  [SMALL_STATE(3203)] = 35824,
  [SMALL_STATE(3204)] = 35887,
  [SMALL_STATE(3205)] = 35952,
  [SMALL_STATE(3206)] = 36013,
  [SMALL_STATE(3207)] = 36080,
  [SMALL_STATE(3208)] = 36143,
  [SMALL_STATE(3209)] = 36204,
  [SMALL_STATE(3210)] = 36265,
  [SMALL_STATE(3211)] = 36348,
  [SMALL_STATE(3212)] = 36409,
  [SMALL_STATE(3213)] = 36470,
  [SMALL_STATE(3214)] = 36545,
  [SMALL_STATE(3215)] = 36628,
  [SMALL_STATE(3216)] = 36689,
  [SMALL_STATE(3217)] = 36750,
  [SMALL_STATE(3218)] = 36811,
  [SMALL_STATE(3219)] = 36872,
  [SMALL_STATE(3220)] = 36933,
  [SMALL_STATE(3221)] = 36994,
  [SMALL_STATE(3222)] = 37055,
  [SMALL_STATE(3223)] = 37126,
  [SMALL_STATE(3224)] = 37209,
  [SMALL_STATE(3225)] = 37270,
  [SMALL_STATE(3226)] = 37331,
  [SMALL_STATE(3227)] = 37392,
  [SMALL_STATE(3228)] = 37453,
  [SMALL_STATE(3229)] = 37514,
  [SMALL_STATE(3230)] = 37597,
  [SMALL_STATE(3231)] = 37668,
  [SMALL_STATE(3232)] = 37751,
  [SMALL_STATE(3233)] = 37820,
  [SMALL_STATE(3234)] = 37881,
  [SMALL_STATE(3235)] = 37942,
  [SMALL_STATE(3236)] = 38013,
  [SMALL_STATE(3237)] = 38074,
  [SMALL_STATE(3238)] = 38141,
  [SMALL_STATE(3239)] = 38224,
  [SMALL_STATE(3240)] = 38307,
  [SMALL_STATE(3241)] = 38368,
  [SMALL_STATE(3242)] = 38429,
  [SMALL_STATE(3243)] = 38490,
  [SMALL_STATE(3244)] = 38551,
  [SMALL_STATE(3245)] = 38612,
  [SMALL_STATE(3246)] = 38673,
  [SMALL_STATE(3247)] = 38734,
  [SMALL_STATE(3248)] = 38795,
  [SMALL_STATE(3249)] = 38866,
  [SMALL_STATE(3250)] = 38949,
  [SMALL_STATE(3251)] = 39010,
  [SMALL_STATE(3252)] = 39071,
  [SMALL_STATE(3253)] = 39132,
  [SMALL_STATE(3254)] = 39193,
  [SMALL_STATE(3255)] = 39254,
  [SMALL_STATE(3256)] = 39315,
  [SMALL_STATE(3257)] = 39376,
  [SMALL_STATE(3258)] = 39441,
  [SMALL_STATE(3259)] = 39502,
  [SMALL_STATE(3260)] = 39563,
  [SMALL_STATE(3261)] = 39631,
  [SMALL_STATE(3262)] = 39697,
  [SMALL_STATE(3263)] = 39759,
  [SMALL_STATE(3264)] = 39827,
  [SMALL_STATE(3265)] = 39889,
  [SMALL_STATE(3266)] = 39951,
  [SMALL_STATE(3267)] = 40019,
  [SMALL_STATE(3268)] = 40087,
  [SMALL_STATE(3269)] = 40149,
  [SMALL_STATE(3270)] = 40217,
  [SMALL_STATE(3271)] = 40277,
  [SMALL_STATE(3272)] = 40337,
  [SMALL_STATE(3273)] = 40405,
  [SMALL_STATE(3274)] = 40473,
  [SMALL_STATE(3275)] = 40533,
  [SMALL_STATE(3276)] = 40603,
  [SMALL_STATE(3277)] = 40669,
  [SMALL_STATE(3278)] = 40733,
  [SMALL_STATE(3279)] = 40795,
  [SMALL_STATE(3280)] = 40857,
  [SMALL_STATE(3281)] = 40917,
  [SMALL_STATE(3282)] = 40985,
  [SMALL_STATE(3283)] = 41053,
  [SMALL_STATE(3284)] = 41113,
  [SMALL_STATE(3285)] = 41181,
  [SMALL_STATE(3286)] = 41245,
  [SMALL_STATE(3287)] = 41305,
  [SMALL_STATE(3288)] = 41365,
  [SMALL_STATE(3289)] = 41443,
  [SMALL_STATE(3290)] = 41505,
  [SMALL_STATE(3291)] = 41593,
  [SMALL_STATE(3292)] = 41681,
  [SMALL_STATE(3293)] = 41769,
  [SMALL_STATE(3294)] = 41835,
  [SMALL_STATE(3295)] = 41903,
  [SMALL_STATE(3296)] = 41965,
  [SMALL_STATE(3297)] = 42025,
  [SMALL_STATE(3298)] = 42095,
  [SMALL_STATE(3299)] = 42163,
  [SMALL_STATE(3300)] = 42229,
  [SMALL_STATE(3301)] = 42293,
  [SMALL_STATE(3302)] = 42363,
  [SMALL_STATE(3303)] = 42431,
  [SMALL_STATE(3304)] = 42497,
  [SMALL_STATE(3305)] = 42567,
  [SMALL_STATE(3306)] = 42635,
  [SMALL_STATE(3307)] = 42695,
  [SMALL_STATE(3308)] = 42763,
  [SMALL_STATE(3309)] = 42845,
  [SMALL_STATE(3310)] = 42905,
  [SMALL_STATE(3311)] = 42967,
  [SMALL_STATE(3312)] = 43055,
  [SMALL_STATE(3313)] = 43145,
  [SMALL_STATE(3314)] = 43211,
  [SMALL_STATE(3315)] = 43273,
  [SMALL_STATE(3316)] = 43343,
  [SMALL_STATE(3317)] = 43413,
  [SMALL_STATE(3318)] = 43479,
  [SMALL_STATE(3319)] = 43539,
  [SMALL_STATE(3320)] = 43607,
  [SMALL_STATE(3321)] = 43695,
  [SMALL_STATE(3322)] = 43763,
  [SMALL_STATE(3323)] = 43847,
  [SMALL_STATE(3324)] = 43937,
  [SMALL_STATE(3325)] = 44005,
  [SMALL_STATE(3326)] = 44081,
  [SMALL_STATE(3327)] = 44161,
  [SMALL_STATE(3328)] = 44220,
  [SMALL_STATE(3329)] = 44279,
  [SMALL_STATE(3330)] = 44340,
  [SMALL_STATE(3331)] = 44401,
  [SMALL_STATE(3332)] = 44460,
  [SMALL_STATE(3333)] = 44519,
  [SMALL_STATE(3334)] = 44578,
  [SMALL_STATE(3335)] = 44639,
  [SMALL_STATE(3336)] = 44704,
  [SMALL_STATE(3337)] = 44769,
  [SMALL_STATE(3338)] = 44828,
  [SMALL_STATE(3339)] = 44887,
  [SMALL_STATE(3340)] = 44946,
  [SMALL_STATE(3341)] = 45005,
  [SMALL_STATE(3342)] = 45064,
  [SMALL_STATE(3343)] = 45123,
  [SMALL_STATE(3344)] = 45182,
  [SMALL_STATE(3345)] = 45241,
  [SMALL_STATE(3346)] = 45310,
  [SMALL_STATE(3347)] = 45369,
  [SMALL_STATE(3348)] = 45428,
  [SMALL_STATE(3349)] = 45491,
  [SMALL_STATE(3350)] = 45550,
  [SMALL_STATE(3351)] = 45609,
  [SMALL_STATE(3352)] = 45678,
  [SMALL_STATE(3353)] = 45737,
  [SMALL_STATE(3354)] = 45796,
  [SMALL_STATE(3355)] = 45855,
  [SMALL_STATE(3356)] = 45914,
  [SMALL_STATE(3357)] = 45973,
  [SMALL_STATE(3358)] = 46032,
  [SMALL_STATE(3359)] = 46091,
  [SMALL_STATE(3360)] = 46150,
  [SMALL_STATE(3361)] = 46209,
  [SMALL_STATE(3362)] = 46268,
  [SMALL_STATE(3363)] = 46327,
  [SMALL_STATE(3364)] = 46386,
  [SMALL_STATE(3365)] = 46445,
  [SMALL_STATE(3366)] = 46514,
  [SMALL_STATE(3367)] = 46573,
  [SMALL_STATE(3368)] = 46632,
  [SMALL_STATE(3369)] = 46691,
  [SMALL_STATE(3370)] = 46750,
  [SMALL_STATE(3371)] = 46819,
  [SMALL_STATE(3372)] = 46882,
  [SMALL_STATE(3373)] = 46941,
  [SMALL_STATE(3374)] = 47000,
  [SMALL_STATE(3375)] = 47065,
  [SMALL_STATE(3376)] = 47124,
  [SMALL_STATE(3377)] = 47183,
  [SMALL_STATE(3378)] = 47252,
  [SMALL_STATE(3379)] = 47311,
  [SMALL_STATE(3380)] = 47370,
  [SMALL_STATE(3381)] = 47433,
  [SMALL_STATE(3382)] = 47502,
  [SMALL_STATE(3383)] = 47561,
  [SMALL_STATE(3384)] = 47626,
  [SMALL_STATE(3385)] = 47685,
  [SMALL_STATE(3386)] = 47752,
  [SMALL_STATE(3387)] = 47811,
  [SMALL_STATE(3388)] = 47870,
  [SMALL_STATE(3389)] = 47937,
  [SMALL_STATE(3390)] = 48004,
  [SMALL_STATE(3391)] = 48065,
  [SMALL_STATE(3392)] = 48130,
  [SMALL_STATE(3393)] = 48188,
  [SMALL_STATE(3394)] = 48252,
  [SMALL_STATE(3395)] = 48310,
  [SMALL_STATE(3396)] = 48368,
  [SMALL_STATE(3397)] = 48428,
  [SMALL_STATE(3398)] = 48486,
  [SMALL_STATE(3399)] = 48544,
  [SMALL_STATE(3400)] = 48610,
  [SMALL_STATE(3401)] = 48668,
  [SMALL_STATE(3402)] = 48754,
  [SMALL_STATE(3403)] = 48840,
  [SMALL_STATE(3404)] = 48916,
  [SMALL_STATE(3405)] = 48974,
  [SMALL_STATE(3406)] = 49032,
  [SMALL_STATE(3407)] = 49120,
  [SMALL_STATE(3408)] = 49178,
  [SMALL_STATE(3409)] = 49236,
  [SMALL_STATE(3410)] = 49322,
  [SMALL_STATE(3411)] = 49380,
  [SMALL_STATE(3412)] = 49438,
  [SMALL_STATE(3413)] = 49496,
  [SMALL_STATE(3414)] = 49574,
  [SMALL_STATE(3415)] = 49660,
  [SMALL_STATE(3416)] = 49746,
  [SMALL_STATE(3417)] = 49828,
  [SMALL_STATE(3418)] = 49886,
  [SMALL_STATE(3419)] = 49966,
  [SMALL_STATE(3420)] = 50042,
  [SMALL_STATE(3421)] = 50124,
  [SMALL_STATE(3422)] = 50182,
  [SMALL_STATE(3423)] = 50240,
  [SMALL_STATE(3424)] = 50304,
  [SMALL_STATE(3425)] = 50366,
  [SMALL_STATE(3426)] = 50432,
  [SMALL_STATE(3427)] = 50506,
  [SMALL_STATE(3428)] = 50572,
  [SMALL_STATE(3429)] = 50646,
  [SMALL_STATE(3430)] = 50732,
  [SMALL_STATE(3431)] = 50798,
  [SMALL_STATE(3432)] = 50880,
  [SMALL_STATE(3433)] = 50954,
  [SMALL_STATE(3434)] = 51040,
  [SMALL_STATE(3435)] = 51098,
  [SMALL_STATE(3436)] = 51156,
  [SMALL_STATE(3437)] = 51214,
  [SMALL_STATE(3438)] = 51304,
  [SMALL_STATE(3439)] = 51394,
  [SMALL_STATE(3440)] = 51452,
  [SMALL_STATE(3441)] = 51510,
  [SMALL_STATE(3442)] = 51588,
  [SMALL_STATE(3443)] = 51648,
  [SMALL_STATE(3444)] = 51708,
  [SMALL_STATE(3445)] = 51774,
  [SMALL_STATE(3446)] = 51860,
  [SMALL_STATE(3447)] = 51950,
  [SMALL_STATE(3448)] = 52008,
  [SMALL_STATE(3449)] = 52066,
  [SMALL_STATE(3450)] = 52144,
  [SMALL_STATE(3451)] = 52230,
  [SMALL_STATE(3452)] = 52288,
  [SMALL_STATE(3453)] = 52374,
  [SMALL_STATE(3454)] = 52432,
  [SMALL_STATE(3455)] = 52490,
  [SMALL_STATE(3456)] = 52556,
  [SMALL_STATE(3457)] = 52614,
  [SMALL_STATE(3458)] = 52672,
  [SMALL_STATE(3459)] = 52752,
  [SMALL_STATE(3460)] = 52810,
  [SMALL_STATE(3461)] = 52872,
  [SMALL_STATE(3462)] = 52938,
  [SMALL_STATE(3463)] = 52996,
  [SMALL_STATE(3464)] = 53054,
  [SMALL_STATE(3465)] = 53112,
  [SMALL_STATE(3466)] = 53170,
  [SMALL_STATE(3467)] = 53256,
  [SMALL_STATE(3468)] = 53314,
  [SMALL_STATE(3469)] = 53380,
  [SMALL_STATE(3470)] = 53438,
  [SMALL_STATE(3471)] = 53524,
  [SMALL_STATE(3472)] = 53610,
  [SMALL_STATE(3473)] = 53668,
  [SMALL_STATE(3474)] = 53730,
  [SMALL_STATE(3475)] = 53816,
  [SMALL_STATE(3476)] = 53904,
  [SMALL_STATE(3477)] = 53994,
  [SMALL_STATE(3478)] = 54052,
  [SMALL_STATE(3479)] = 54116,
  [SMALL_STATE(3480)] = 54196,
  [SMALL_STATE(3481)] = 54254,
  [SMALL_STATE(3482)] = 54320,
  [SMALL_STATE(3483)] = 54378,
  [SMALL_STATE(3484)] = 54436,
  [SMALL_STATE(3485)] = 54496,
  [SMALL_STATE(3486)] = 54582,
  [SMALL_STATE(3487)] = 54658,
  [SMALL_STATE(3488)] = 54716,
  [SMALL_STATE(3489)] = 54774,
  [SMALL_STATE(3490)] = 54832,
  [SMALL_STATE(3491)] = 54890,
  [SMALL_STATE(3492)] = 54949,
  [SMALL_STATE(3493)] = 55034,
  [SMALL_STATE(3494)] = 55093,
  [SMALL_STATE(3495)] = 55182,
  [SMALL_STATE(3496)] = 55267,
  [SMALL_STATE(3497)] = 55340,
  [SMALL_STATE(3498)] = 55405,
  [SMALL_STATE(3499)] = 55468,
  [SMALL_STATE(3500)] = 55553,
  [SMALL_STATE(3501)] = 55638,
  [SMALL_STATE(3502)] = 55727,
  [SMALL_STATE(3503)] = 55808,
  [SMALL_STATE(3504)] = 55867,
  [SMALL_STATE(3505)] = 55952,
  [SMALL_STATE(3506)] = 56009,
  [SMALL_STATE(3507)] = 56086,
  [SMALL_STATE(3508)] = 56161,
  [SMALL_STATE(3509)] = 56226,
  [SMALL_STATE(3510)] = 56285,
  [SMALL_STATE(3511)] = 56344,
  [SMALL_STATE(3512)] = 56423,
  [SMALL_STATE(3513)] = 56486,
  [SMALL_STATE(3514)] = 56547,
  [SMALL_STATE(3515)] = 56612,
  [SMALL_STATE(3516)] = 56692,
  [SMALL_STATE(3517)] = 56768,
  [SMALL_STATE(3518)] = 56852,
  [SMALL_STATE(3519)] = 56914,
  [SMALL_STATE(3520)] = 57000,
  [SMALL_STATE(3521)] = 57084,
  [SMALL_STATE(3522)] = 57158,
  [SMALL_STATE(3523)] = 57242,
  [SMALL_STATE(3524)] = 57306,
  [SMALL_STATE(3525)] = 57390,
  [SMALL_STATE(3526)] = 57448,
  [SMALL_STATE(3527)] = 57512,
  [SMALL_STATE(3528)] = 57572,
  [SMALL_STATE(3529)] = 57658,
  [SMALL_STATE(3530)] = 57736,
  [SMALL_STATE(3531)] = 57808,
  [SMALL_STATE(3532)] = 57892,
  [SMALL_STATE(3533)] = 57956,
  [SMALL_STATE(3534)] = 58016,
  [SMALL_STATE(3535)] = 58087,
  [SMALL_STATE(3536)] = 58150,
  [SMALL_STATE(3537)] = 58243,
  [SMALL_STATE(3538)] = 58322,
  [SMALL_STATE(3539)] = 58407,
  [SMALL_STATE(3540)] = 58482,
  [SMALL_STATE(3541)] = 58559,
  [SMALL_STATE(3542)] = 58632,
  [SMALL_STATE(3543)] = 58689,
  [SMALL_STATE(3544)] = 58752,
  [SMALL_STATE(3545)] = 58813,
  [SMALL_STATE(3546)] = 58898,
  [SMALL_STATE(3547)] = 58961,
  [SMALL_STATE(3548)] = 59020,
  [SMALL_STATE(3549)] = 59113,
  [SMALL_STATE(3550)] = 59206,
  [SMALL_STATE(3551)] = 59294,
  [SMALL_STATE(3552)] = 59382,
  [SMALL_STATE(3553)] = 59470,
  [SMALL_STATE(3554)] = 59558,
  [SMALL_STATE(3555)] = 59646,
  [SMALL_STATE(3556)] = 59702,
  [SMALL_STATE(3557)] = 59786,
  [SMALL_STATE(3558)] = 59874,
  [SMALL_STATE(3559)] = 59962,
  [SMALL_STATE(3560)] = 60050,
  [SMALL_STATE(3561)] = 60138,
  [SMALL_STATE(3562)] = 60213,
  [SMALL_STATE(3563)] = 60296,
  [SMALL_STATE(3564)] = 60379,
  [SMALL_STATE(3565)] = 60462,
  [SMALL_STATE(3566)] = 60531,
  [SMALL_STATE(3567)] = 60606,
  [SMALL_STATE(3568)] = 60663,
  [SMALL_STATE(3569)] = 60724,
  [SMALL_STATE(3570)] = 60785,
  [SMALL_STATE(3571)] = 60872,
  [SMALL_STATE(3572)] = 60931,
  [SMALL_STATE(3573)] = 60992,
  [SMALL_STATE(3574)] = 61069,
  [SMALL_STATE(3575)] = 61142,
  [SMALL_STATE(3576)] = 61213,
  [SMALL_STATE(3577)] = 61290,
  [SMALL_STATE(3578)] = 61363,
  [SMALL_STATE(3579)] = 61448,
  [SMALL_STATE(3580)] = 61519,
  [SMALL_STATE(3581)] = 61594,
  [SMALL_STATE(3582)] = 61655,
  [SMALL_STATE(3583)] = 61712,
  [SMALL_STATE(3584)] = 61773,
  [SMALL_STATE(3585)] = 61832,
  [SMALL_STATE(3586)] = 61893,
  [SMALL_STATE(3587)] = 61966,
  [SMALL_STATE(3588)] = 62037,
  [SMALL_STATE(3589)] = 62120,
  [SMALL_STATE(3590)] = 62203,
  [SMALL_STATE(3591)] = 62290,
  [SMALL_STATE(3592)] = 62373,
  [SMALL_STATE(3593)] = 62456,
  [SMALL_STATE(3594)] = 62533,
  [SMALL_STATE(3595)] = 62592,
  [SMALL_STATE(3596)] = 62661,
  [SMALL_STATE(3597)] = 62744,
  [SMALL_STATE(3598)] = 62797,
  [SMALL_STATE(3599)] = 62852,
  [SMALL_STATE(3600)] = 62939,
  [SMALL_STATE(3601)] = 63000,
  [SMALL_STATE(3602)] = 63057,
  [SMALL_STATE(3603)] = 63114,
  [SMALL_STATE(3604)] = 63169,
  [SMALL_STATE(3605)] = 63226,
  [SMALL_STATE(3606)] = 63281,
  [SMALL_STATE(3607)] = 63336,
  [SMALL_STATE(3608)] = 63405,
  [SMALL_STATE(3609)] = 63466,
  [SMALL_STATE(3610)] = 63523,
  [SMALL_STATE(3611)] = 63606,
  [SMALL_STATE(3612)] = 63667,
  [SMALL_STATE(3613)] = 63749,
  [SMALL_STATE(3614)] = 63831,
  [SMALL_STATE(3615)] = 63885,
  [SMALL_STATE(3616)] = 63967,
  [SMALL_STATE(3617)] = 64049,
  [SMALL_STATE(3618)] = 64121,
  [SMALL_STATE(3619)] = 64177,
  [SMALL_STATE(3620)] = 64253,
  [SMALL_STATE(3621)] = 64335,
  [SMALL_STATE(3622)] = 64417,
  [SMALL_STATE(3623)] = 64499,
  [SMALL_STATE(3624)] = 64567,
  [SMALL_STATE(3625)] = 64649,
  [SMALL_STATE(3626)] = 64731,
  [SMALL_STATE(3627)] = 64813,
  [SMALL_STATE(3628)] = 64867,
  [SMALL_STATE(3629)] = 64949,
  [SMALL_STATE(3630)] = 65031,
  [SMALL_STATE(3631)] = 65085,
  [SMALL_STATE(3632)] = 65167,
  [SMALL_STATE(3633)] = 65221,
  [SMALL_STATE(3634)] = 65275,
  [SMALL_STATE(3635)] = 65335,
  [SMALL_STATE(3636)] = 65409,
  [SMALL_STATE(3637)] = 65491,
  [SMALL_STATE(3638)] = 65573,
  [SMALL_STATE(3639)] = 65627,
  [SMALL_STATE(3640)] = 65681,
  [SMALL_STATE(3641)] = 65763,
  [SMALL_STATE(3642)] = 65817,
  [SMALL_STATE(3643)] = 65899,
  [SMALL_STATE(3644)] = 65981,
  [SMALL_STATE(3645)] = 66063,
  [SMALL_STATE(3646)] = 66145,
  [SMALL_STATE(3647)] = 66227,
  [SMALL_STATE(3648)] = 66287,
  [SMALL_STATE(3649)] = 66345,
  [SMALL_STATE(3650)] = 66427,
  [SMALL_STATE(3651)] = 66509,
  [SMALL_STATE(3652)] = 66563,
  [SMALL_STATE(3653)] = 66623,
  [SMALL_STATE(3654)] = 66705,
  [SMALL_STATE(3655)] = 66787,
  [SMALL_STATE(3656)] = 66857,
  [SMALL_STATE(3657)] = 66939,
  [SMALL_STATE(3658)] = 67012,
  [SMALL_STATE(3659)] = 67093,
  [SMALL_STATE(3660)] = 67148,
  [SMALL_STATE(3661)] = 67229,
  [SMALL_STATE(3662)] = 67310,
  [SMALL_STATE(3663)] = 67391,
  [SMALL_STATE(3664)] = 67462,
  [SMALL_STATE(3665)] = 67537,
  [SMALL_STATE(3666)] = 67618,
  [SMALL_STATE(3667)] = 67699,
  [SMALL_STATE(3668)] = 67780,
  [SMALL_STATE(3669)] = 67833,
  [SMALL_STATE(3670)] = 67892,
  [SMALL_STATE(3671)] = 67951,
  [SMALL_STATE(3672)] = 68032,
  [SMALL_STATE(3673)] = 68089,
  [SMALL_STATE(3674)] = 68170,
  [SMALL_STATE(3675)] = 68251,
  [SMALL_STATE(3676)] = 68332,
  [SMALL_STATE(3677)] = 68413,
  [SMALL_STATE(3678)] = 68494,
  [SMALL_STATE(3679)] = 68553,
  [SMALL_STATE(3680)] = 68620,
  [SMALL_STATE(3681)] = 68689,
  [SMALL_STATE(3682)] = 68770,
  [SMALL_STATE(3683)] = 68845,
  [SMALL_STATE(3684)] = 68920,
  [SMALL_STATE(3685)] = 68995,
  [SMALL_STATE(3686)] = 69070,
  [SMALL_STATE(3687)] = 69145,
  [SMALL_STATE(3688)] = 69220,
  [SMALL_STATE(3689)] = 69295,
  [SMALL_STATE(3690)] = 69370,
  [SMALL_STATE(3691)] = 69445,
  [SMALL_STATE(3692)] = 69520,
  [SMALL_STATE(3693)] = 69595,
  [SMALL_STATE(3694)] = 69670,
  [SMALL_STATE(3695)] = 69745,
  [SMALL_STATE(3696)] = 69820,
  [SMALL_STATE(3697)] = 69895,
  [SMALL_STATE(3698)] = 69970,
  [SMALL_STATE(3699)] = 70045,
  [SMALL_STATE(3700)] = 70120,
  [SMALL_STATE(3701)] = 70195,
  [SMALL_STATE(3702)] = 70270,
  [SMALL_STATE(3703)] = 70345,
  [SMALL_STATE(3704)] = 70420,
  [SMALL_STATE(3705)] = 70495,
  [SMALL_STATE(3706)] = 70570,
  [SMALL_STATE(3707)] = 70645,
  [SMALL_STATE(3708)] = 70720,
  [SMALL_STATE(3709)] = 70795,
  [SMALL_STATE(3710)] = 70870,
  [SMALL_STATE(3711)] = 70939,
  [SMALL_STATE(3712)] = 71008,
  [SMALL_STATE(3713)] = 71077,
  [SMALL_STATE(3714)] = 71146,
  [SMALL_STATE(3715)] = 71215,
  [SMALL_STATE(3716)] = 71284,
  [SMALL_STATE(3717)] = 71353,
  [SMALL_STATE(3718)] = 71422,
  [SMALL_STATE(3719)] = 71491,
  [SMALL_STATE(3720)] = 71560,
  [SMALL_STATE(3721)] = 71629,
  [SMALL_STATE(3722)] = 71698,
  [SMALL_STATE(3723)] = 71767,
  [SMALL_STATE(3724)] = 71836,
  [SMALL_STATE(3725)] = 71905,
  [SMALL_STATE(3726)] = 71974,
  [SMALL_STATE(3727)] = 72043,
  [SMALL_STATE(3728)] = 72112,
  [SMALL_STATE(3729)] = 72181,
  [SMALL_STATE(3730)] = 72250,
  [SMALL_STATE(3731)] = 72319,
  [SMALL_STATE(3732)] = 72388,
  [SMALL_STATE(3733)] = 72457,
  [SMALL_STATE(3734)] = 72526,
  [SMALL_STATE(3735)] = 72595,
  [SMALL_STATE(3736)] = 72664,
  [SMALL_STATE(3737)] = 72733,
  [SMALL_STATE(3738)] = 72802,
  [SMALL_STATE(3739)] = 72871,
  [SMALL_STATE(3740)] = 72940,
  [SMALL_STATE(3741)] = 73009,
  [SMALL_STATE(3742)] = 73078,
  [SMALL_STATE(3743)] = 73147,
  [SMALL_STATE(3744)] = 73216,
  [SMALL_STATE(3745)] = 73285,
  [SMALL_STATE(3746)] = 73354,
  [SMALL_STATE(3747)] = 73423,
  [SMALL_STATE(3748)] = 73492,
  [SMALL_STATE(3749)] = 73561,
  [SMALL_STATE(3750)] = 73630,
  [SMALL_STATE(3751)] = 73699,
  [SMALL_STATE(3752)] = 73768,
  [SMALL_STATE(3753)] = 73837,
  [SMALL_STATE(3754)] = 73906,
  [SMALL_STATE(3755)] = 73975,
  [SMALL_STATE(3756)] = 74044,
  [SMALL_STATE(3757)] = 74113,
  [SMALL_STATE(3758)] = 74182,
  [SMALL_STATE(3759)] = 74251,
  [SMALL_STATE(3760)] = 74320,
  [SMALL_STATE(3761)] = 74389,
  [SMALL_STATE(3762)] = 74458,
  [SMALL_STATE(3763)] = 74527,
  [SMALL_STATE(3764)] = 74596,
  [SMALL_STATE(3765)] = 74665,
  [SMALL_STATE(3766)] = 74734,
  [SMALL_STATE(3767)] = 74803,
  [SMALL_STATE(3768)] = 74872,
  [SMALL_STATE(3769)] = 74941,
  [SMALL_STATE(3770)] = 75010,
  [SMALL_STATE(3771)] = 75079,
  [SMALL_STATE(3772)] = 75148,
  [SMALL_STATE(3773)] = 75217,
  [SMALL_STATE(3774)] = 75286,
  [SMALL_STATE(3775)] = 75355,
  [SMALL_STATE(3776)] = 75424,
  [SMALL_STATE(3777)] = 75493,
  [SMALL_STATE(3778)] = 75562,
  [SMALL_STATE(3779)] = 75631,
  [SMALL_STATE(3780)] = 75700,
  [SMALL_STATE(3781)] = 75769,
  [SMALL_STATE(3782)] = 75838,
  [SMALL_STATE(3783)] = 75907,
  [SMALL_STATE(3784)] = 75976,
  [SMALL_STATE(3785)] = 76045,
  [SMALL_STATE(3786)] = 76114,
  [SMALL_STATE(3787)] = 76183,
  [SMALL_STATE(3788)] = 76252,
  [SMALL_STATE(3789)] = 76321,
  [SMALL_STATE(3790)] = 76390,
  [SMALL_STATE(3791)] = 76459,
  [SMALL_STATE(3792)] = 76528,
  [SMALL_STATE(3793)] = 76597,
  [SMALL_STATE(3794)] = 76666,
  [SMALL_STATE(3795)] = 76735,
  [SMALL_STATE(3796)] = 76804,
  [SMALL_STATE(3797)] = 76873,
  [SMALL_STATE(3798)] = 76942,
  [SMALL_STATE(3799)] = 77011,
  [SMALL_STATE(3800)] = 77080,
  [SMALL_STATE(3801)] = 77149,
  [SMALL_STATE(3802)] = 77218,
  [SMALL_STATE(3803)] = 77287,
  [SMALL_STATE(3804)] = 77356,
  [SMALL_STATE(3805)] = 77425,
  [SMALL_STATE(3806)] = 77494,
  [SMALL_STATE(3807)] = 77563,
  [SMALL_STATE(3808)] = 77632,
  [SMALL_STATE(3809)] = 77701,
  [SMALL_STATE(3810)] = 77770,
  [SMALL_STATE(3811)] = 77839,
  [SMALL_STATE(3812)] = 77908,
  [SMALL_STATE(3813)] = 77977,
  [SMALL_STATE(3814)] = 78046,
  [SMALL_STATE(3815)] = 78115,
  [SMALL_STATE(3816)] = 78184,
  [SMALL_STATE(3817)] = 78253,
  [SMALL_STATE(3818)] = 78322,
  [SMALL_STATE(3819)] = 78391,
  [SMALL_STATE(3820)] = 78460,
  [SMALL_STATE(3821)] = 78529,
  [SMALL_STATE(3822)] = 78598,
  [SMALL_STATE(3823)] = 78635,
  [SMALL_STATE(3824)] = 78672,
  [SMALL_STATE(3825)] = 78709,
  [SMALL_STATE(3826)] = 78746,
  [SMALL_STATE(3827)] = 78783,
  [SMALL_STATE(3828)] = 78820,
  [SMALL_STATE(3829)] = 78857,
  [SMALL_STATE(3830)] = 78905,
  [SMALL_STATE(3831)] = 78949,
  [SMALL_STATE(3832)] = 78997,
  [SMALL_STATE(3833)] = 79045,
  [SMALL_STATE(3834)] = 79093,
  [SMALL_STATE(3835)] = 79141,
  [SMALL_STATE(3836)] = 79189,
  [SMALL_STATE(3837)] = 79237,
  [SMALL_STATE(3838)] = 79285,
  [SMALL_STATE(3839)] = 79333,
  [SMALL_STATE(3840)] = 79377,
  [SMALL_STATE(3841)] = 79425,
  [SMALL_STATE(3842)] = 79473,
  [SMALL_STATE(3843)] = 79521,
  [SMALL_STATE(3844)] = 79569,
  [SMALL_STATE(3845)] = 79617,
  [SMALL_STATE(3846)] = 79665,
  [SMALL_STATE(3847)] = 79713,
  [SMALL_STATE(3848)] = 79761,
  [SMALL_STATE(3849)] = 79809,
  [SMALL_STATE(3850)] = 79857,
  [SMALL_STATE(3851)] = 79905,
  [SMALL_STATE(3852)] = 79949,
  [SMALL_STATE(3853)] = 79997,
  [SMALL_STATE(3854)] = 80045,
  [SMALL_STATE(3855)] = 80093,
  [SMALL_STATE(3856)] = 80141,
  [SMALL_STATE(3857)] = 80189,
  [SMALL_STATE(3858)] = 80237,
  [SMALL_STATE(3859)] = 80285,
  [SMALL_STATE(3860)] = 80319,
  [SMALL_STATE(3861)] = 80353,
  [SMALL_STATE(3862)] = 80387,
  [SMALL_STATE(3863)] = 80421,
  [SMALL_STATE(3864)] = 80463,
  [SMALL_STATE(3865)] = 80497,
  [SMALL_STATE(3866)] = 80531,
  [SMALL_STATE(3867)] = 80565,
  [SMALL_STATE(3868)] = 80599,
  [SMALL_STATE(3869)] = 80633,
  [SMALL_STATE(3870)] = 80667,
  [SMALL_STATE(3871)] = 80701,
  [SMALL_STATE(3872)] = 80735,
  [SMALL_STATE(3873)] = 80777,
  [SMALL_STATE(3874)] = 80811,
  [SMALL_STATE(3875)] = 80845,
  [SMALL_STATE(3876)] = 80879,
  [SMALL_STATE(3877)] = 80913,
  [SMALL_STATE(3878)] = 80955,
  [SMALL_STATE(3879)] = 80989,
  [SMALL_STATE(3880)] = 81023,
  [SMALL_STATE(3881)] = 81057,
  [SMALL_STATE(3882)] = 81091,
  [SMALL_STATE(3883)] = 81133,
  [SMALL_STATE(3884)] = 81174,
  [SMALL_STATE(3885)] = 81215,
  [SMALL_STATE(3886)] = 81256,
  [SMALL_STATE(3887)] = 81288,
  [SMALL_STATE(3888)] = 81328,
  [SMALL_STATE(3889)] = 81366,
  [SMALL_STATE(3890)] = 81406,
  [SMALL_STATE(3891)] = 81438,
  [SMALL_STATE(3892)] = 81474,
  [SMALL_STATE(3893)] = 81512,
  [SMALL_STATE(3894)] = 81552,
  [SMALL_STATE(3895)] = 81590,
  [SMALL_STATE(3896)] = 81622,
  [SMALL_STATE(3897)] = 81662,
  [SMALL_STATE(3898)] = 81701,
  [SMALL_STATE(3899)] = 81740,
  [SMALL_STATE(3900)] = 81779,
  [SMALL_STATE(3901)] = 81818,
  [SMALL_STATE(3902)] = 81857,
  [SMALL_STATE(3903)] = 81896,
  [SMALL_STATE(3904)] = 81935,
  [SMALL_STATE(3905)] = 81974,
  [SMALL_STATE(3906)] = 82013,
  [SMALL_STATE(3907)] = 82052,
  [SMALL_STATE(3908)] = 82091,
  [SMALL_STATE(3909)] = 82130,
  [SMALL_STATE(3910)] = 82169,
  [SMALL_STATE(3911)] = 82208,
  [SMALL_STATE(3912)] = 82239,
  [SMALL_STATE(3913)] = 82278,
  [SMALL_STATE(3914)] = 82317,
  [SMALL_STATE(3915)] = 82356,
  [SMALL_STATE(3916)] = 82395,
  [SMALL_STATE(3917)] = 82434,
  [SMALL_STATE(3918)] = 82473,
  [SMALL_STATE(3919)] = 82512,
  [SMALL_STATE(3920)] = 82543,
  [SMALL_STATE(3921)] = 82582,
  [SMALL_STATE(3922)] = 82613,
  [SMALL_STATE(3923)] = 82652,
  [SMALL_STATE(3924)] = 82691,
  [SMALL_STATE(3925)] = 82730,
  [SMALL_STATE(3926)] = 82769,
  [SMALL_STATE(3927)] = 82800,
  [SMALL_STATE(3928)] = 82839,
  [SMALL_STATE(3929)] = 82878,
  [SMALL_STATE(3930)] = 82917,
  [SMALL_STATE(3931)] = 82956,
  [SMALL_STATE(3932)] = 82992,
  [SMALL_STATE(3933)] = 83030,
  [SMALL_STATE(3934)] = 83066,
  [SMALL_STATE(3935)] = 83102,
  [SMALL_STATE(3936)] = 83136,
  [SMALL_STATE(3937)] = 83172,
  [SMALL_STATE(3938)] = 83209,
  [SMALL_STATE(3939)] = 83238,
  [SMALL_STATE(3940)] = 83267,
  [SMALL_STATE(3941)] = 83296,
  [SMALL_STATE(3942)] = 83325,
  [SMALL_STATE(3943)] = 83354,
  [SMALL_STATE(3944)] = 83383,
  [SMALL_STATE(3945)] = 83412,
  [SMALL_STATE(3946)] = 83449,
  [SMALL_STATE(3947)] = 83478,
  [SMALL_STATE(3948)] = 83507,
  [SMALL_STATE(3949)] = 83536,
  [SMALL_STATE(3950)] = 83565,
  [SMALL_STATE(3951)] = 83593,
  [SMALL_STATE(3952)] = 83621,
  [SMALL_STATE(3953)] = 83649,
  [SMALL_STATE(3954)] = 83677,
  [SMALL_STATE(3955)] = 83709,
  [SMALL_STATE(3956)] = 83737,
  [SMALL_STATE(3957)] = 83769,
  [SMALL_STATE(3958)] = 83801,
  [SMALL_STATE(3959)] = 83833,
  [SMALL_STATE(3960)] = 83865,
  [SMALL_STATE(3961)] = 83897,
  [SMALL_STATE(3962)] = 83929,
  [SMALL_STATE(3963)] = 83961,
  [SMALL_STATE(3964)] = 83993,
  [SMALL_STATE(3965)] = 84025,
  [SMALL_STATE(3966)] = 84053,
  [SMALL_STATE(3967)] = 84081,
  [SMALL_STATE(3968)] = 84109,
  [SMALL_STATE(3969)] = 84141,
  [SMALL_STATE(3970)] = 84173,
  [SMALL_STATE(3971)] = 84201,
  [SMALL_STATE(3972)] = 84229,
  [SMALL_STATE(3973)] = 84257,
  [SMALL_STATE(3974)] = 84285,
  [SMALL_STATE(3975)] = 84317,
  [SMALL_STATE(3976)] = 84345,
  [SMALL_STATE(3977)] = 84386,
  [SMALL_STATE(3978)] = 84427,
  [SMALL_STATE(3979)] = 84460,
  [SMALL_STATE(3980)] = 84507,
  [SMALL_STATE(3981)] = 84534,
  [SMALL_STATE(3982)] = 84581,
  [SMALL_STATE(3983)] = 84628,
  [SMALL_STATE(3984)] = 84655,
  [SMALL_STATE(3985)] = 84702,
  [SMALL_STATE(3986)] = 84743,
  [SMALL_STATE(3987)] = 84790,
  [SMALL_STATE(3988)] = 84837,
  [SMALL_STATE(3989)] = 84864,
  [SMALL_STATE(3990)] = 84891,
  [SMALL_STATE(3991)] = 84918,
  [SMALL_STATE(3992)] = 84965,
  [SMALL_STATE(3993)] = 84992,
  [SMALL_STATE(3994)] = 85019,
  [SMALL_STATE(3995)] = 85046,
  [SMALL_STATE(3996)] = 85073,
  [SMALL_STATE(3997)] = 85100,
  [SMALL_STATE(3998)] = 85141,
  [SMALL_STATE(3999)] = 85188,
  [SMALL_STATE(4000)] = 85229,
  [SMALL_STATE(4001)] = 85260,
  [SMALL_STATE(4002)] = 85287,
  [SMALL_STATE(4003)] = 85314,
  [SMALL_STATE(4004)] = 85341,
  [SMALL_STATE(4005)] = 85368,
  [SMALL_STATE(4006)] = 85395,
  [SMALL_STATE(4007)] = 85422,
  [SMALL_STATE(4008)] = 85449,
  [SMALL_STATE(4009)] = 85476,
  [SMALL_STATE(4010)] = 85523,
  [SMALL_STATE(4011)] = 85564,
  [SMALL_STATE(4012)] = 85605,
  [SMALL_STATE(4013)] = 85652,
  [SMALL_STATE(4014)] = 85699,
  [SMALL_STATE(4015)] = 85726,
  [SMALL_STATE(4016)] = 85767,
  [SMALL_STATE(4017)] = 85808,
  [SMALL_STATE(4018)] = 85849,
  [SMALL_STATE(4019)] = 85890,
  [SMALL_STATE(4020)] = 85917,
  [SMALL_STATE(4021)] = 85958,
  [SMALL_STATE(4022)] = 85999,
  [SMALL_STATE(4023)] = 86046,
  [SMALL_STATE(4024)] = 86093,
  [SMALL_STATE(4025)] = 86134,
  [SMALL_STATE(4026)] = 86175,
  [SMALL_STATE(4027)] = 86222,
  [SMALL_STATE(4028)] = 86269,
  [SMALL_STATE(4029)] = 86302,
  [SMALL_STATE(4030)] = 86349,
  [SMALL_STATE(4031)] = 86376,
  [SMALL_STATE(4032)] = 86417,
  [SMALL_STATE(4033)] = 86458,
  [SMALL_STATE(4034)] = 86499,
  [SMALL_STATE(4035)] = 86540,
  [SMALL_STATE(4036)] = 86587,
  [SMALL_STATE(4037)] = 86628,
  [SMALL_STATE(4038)] = 86669,
  [SMALL_STATE(4039)] = 86710,
  [SMALL_STATE(4040)] = 86743,
  [SMALL_STATE(4041)] = 86784,
  [SMALL_STATE(4042)] = 86825,
  [SMALL_STATE(4043)] = 86852,
  [SMALL_STATE(4044)] = 86893,
  [SMALL_STATE(4045)] = 86934,
  [SMALL_STATE(4046)] = 86975,
  [SMALL_STATE(4047)] = 87022,
  [SMALL_STATE(4048)] = 87069,
  [SMALL_STATE(4049)] = 87100,
  [SMALL_STATE(4050)] = 87147,
  [SMALL_STATE(4051)] = 87188,
  [SMALL_STATE(4052)] = 87229,
  [SMALL_STATE(4053)] = 87276,
  [SMALL_STATE(4054)] = 87317,
  [SMALL_STATE(4055)] = 87358,
  [SMALL_STATE(4056)] = 87399,
  [SMALL_STATE(4057)] = 87440,
  [SMALL_STATE(4058)] = 87481,
  [SMALL_STATE(4059)] = 87528,
  [SMALL_STATE(4060)] = 87569,
  [SMALL_STATE(4061)] = 87616,
  [SMALL_STATE(4062)] = 87663,
  [SMALL_STATE(4063)] = 87704,
  [SMALL_STATE(4064)] = 87751,
  [SMALL_STATE(4065)] = 87792,
  [SMALL_STATE(4066)] = 87839,
  [SMALL_STATE(4067)] = 87866,
  [SMALL_STATE(4068)] = 87907,
  [SMALL_STATE(4069)] = 87948,
  [SMALL_STATE(4070)] = 87989,
  [SMALL_STATE(4071)] = 88036,
  [SMALL_STATE(4072)] = 88077,
  [SMALL_STATE(4073)] = 88118,
  [SMALL_STATE(4074)] = 88165,
  [SMALL_STATE(4075)] = 88189,
  [SMALL_STATE(4076)] = 88213,
  [SMALL_STATE(4077)] = 88243,
  [SMALL_STATE(4078)] = 88267,
  [SMALL_STATE(4079)] = 88299,
  [SMALL_STATE(4080)] = 88329,
  [SMALL_STATE(4081)] = 88361,
  [SMALL_STATE(4082)] = 88385,
  [SMALL_STATE(4083)] = 88409,
  [SMALL_STATE(4084)] = 88433,
  [SMALL_STATE(4085)] = 88457,
  [SMALL_STATE(4086)] = 88481,
  [SMALL_STATE(4087)] = 88513,
  [SMALL_STATE(4088)] = 88537,
  [SMALL_STATE(4089)] = 88561,
  [SMALL_STATE(4090)] = 88593,
  [SMALL_STATE(4091)] = 88617,
  [SMALL_STATE(4092)] = 88641,
  [SMALL_STATE(4093)] = 88665,
  [SMALL_STATE(4094)] = 88689,
  [SMALL_STATE(4095)] = 88713,
  [SMALL_STATE(4096)] = 88737,
  [SMALL_STATE(4097)] = 88769,
  [SMALL_STATE(4098)] = 88793,
  [SMALL_STATE(4099)] = 88817,
  [SMALL_STATE(4100)] = 88849,
  [SMALL_STATE(4101)] = 88873,
  [SMALL_STATE(4102)] = 88905,
  [SMALL_STATE(4103)] = 88929,
  [SMALL_STATE(4104)] = 88962,
  [SMALL_STATE(4105)] = 88993,
  [SMALL_STATE(4106)] = 89028,
  [SMALL_STATE(4107)] = 89059,
  [SMALL_STATE(4108)] = 89090,
  [SMALL_STATE(4109)] = 89125,
  [SMALL_STATE(4110)] = 89156,
  [SMALL_STATE(4111)] = 89187,
  [SMALL_STATE(4112)] = 89218,
  [SMALL_STATE(4113)] = 89265,
  [SMALL_STATE(4114)] = 89296,
  [SMALL_STATE(4115)] = 89327,
  [SMALL_STATE(4116)] = 89358,
  [SMALL_STATE(4117)] = 89405,
  [SMALL_STATE(4118)] = 89440,
  [SMALL_STATE(4119)] = 89471,
  [SMALL_STATE(4120)] = 89502,
  [SMALL_STATE(4121)] = 89537,
  [SMALL_STATE(4122)] = 89568,
  [SMALL_STATE(4123)] = 89599,
  [SMALL_STATE(4124)] = 89630,
  [SMALL_STATE(4125)] = 89665,
  [SMALL_STATE(4126)] = 89696,
  [SMALL_STATE(4127)] = 89727,
  [SMALL_STATE(4128)] = 89758,
  [SMALL_STATE(4129)] = 89793,
  [SMALL_STATE(4130)] = 89824,
  [SMALL_STATE(4131)] = 89851,
  [SMALL_STATE(4132)] = 89886,
  [SMALL_STATE(4133)] = 89917,
  [SMALL_STATE(4134)] = 89952,
  [SMALL_STATE(4135)] = 89987,
  [SMALL_STATE(4136)] = 90022,
  [SMALL_STATE(4137)] = 90057,
  [SMALL_STATE(4138)] = 90088,
  [SMALL_STATE(4139)] = 90119,
  [SMALL_STATE(4140)] = 90146,
  [SMALL_STATE(4141)] = 90177,
  [SMALL_STATE(4142)] = 90208,
  [SMALL_STATE(4143)] = 90239,
  [SMALL_STATE(4144)] = 90270,
  [SMALL_STATE(4145)] = 90305,
  [SMALL_STATE(4146)] = 90340,
  [SMALL_STATE(4147)] = 90371,
  [SMALL_STATE(4148)] = 90406,
  [SMALL_STATE(4149)] = 90441,
  [SMALL_STATE(4150)] = 90472,
  [SMALL_STATE(4151)] = 90507,
  [SMALL_STATE(4152)] = 90538,
  [SMALL_STATE(4153)] = 90569,
  [SMALL_STATE(4154)] = 90604,
  [SMALL_STATE(4155)] = 90635,
  [SMALL_STATE(4156)] = 90670,
  [SMALL_STATE(4157)] = 90699,
  [SMALL_STATE(4158)] = 90734,
  [SMALL_STATE(4159)] = 90765,
  [SMALL_STATE(4160)] = 90800,
  [SMALL_STATE(4161)] = 90831,
  [SMALL_STATE(4162)] = 90862,
  [SMALL_STATE(4163)] = 90893,
  [SMALL_STATE(4164)] = 90928,
  [SMALL_STATE(4165)] = 90959,
  [SMALL_STATE(4166)] = 90988,
  [SMALL_STATE(4167)] = 91015,
  [SMALL_STATE(4168)] = 91046,
  [SMALL_STATE(4169)] = 91081,
  [SMALL_STATE(4170)] = 91110,
  [SMALL_STATE(4171)] = 91145,
  [SMALL_STATE(4172)] = 91180,
  [SMALL_STATE(4173)] = 91227,
  [SMALL_STATE(4174)] = 91258,
  [SMALL_STATE(4175)] = 91289,
  [SMALL_STATE(4176)] = 91324,
  [SMALL_STATE(4177)] = 91371,
  [SMALL_STATE(4178)] = 91402,
  [SMALL_STATE(4179)] = 91433,
  [SMALL_STATE(4180)] = 91468,
  [SMALL_STATE(4181)] = 91503,
  [SMALL_STATE(4182)] = 91538,
  [SMALL_STATE(4183)] = 91569,
  [SMALL_STATE(4184)] = 91600,
  [SMALL_STATE(4185)] = 91635,
  [SMALL_STATE(4186)] = 91666,
  [SMALL_STATE(4187)] = 91697,
  [SMALL_STATE(4188)] = 91728,
  [SMALL_STATE(4189)] = 91763,
  [SMALL_STATE(4190)] = 91798,
  [SMALL_STATE(4191)] = 91833,
  [SMALL_STATE(4192)] = 91880,
  [SMALL_STATE(4193)] = 91911,
  [SMALL_STATE(4194)] = 91942,
  [SMALL_STATE(4195)] = 91977,
  [SMALL_STATE(4196)] = 92012,
  [SMALL_STATE(4197)] = 92043,
  [SMALL_STATE(4198)] = 92078,
  [SMALL_STATE(4199)] = 92109,
  [SMALL_STATE(4200)] = 92140,
  [SMALL_STATE(4201)] = 92174,
  [SMALL_STATE(4202)] = 92198,
  [SMALL_STATE(4203)] = 92234,
  [SMALL_STATE(4204)] = 92258,
  [SMALL_STATE(4205)] = 92292,
  [SMALL_STATE(4206)] = 92328,
  [SMALL_STATE(4207)] = 92364,
  [SMALL_STATE(4208)] = 92394,
  [SMALL_STATE(4209)] = 92418,
  [SMALL_STATE(4210)] = 92442,
  [SMALL_STATE(4211)] = 92466,
  [SMALL_STATE(4212)] = 92490,
  [SMALL_STATE(4213)] = 92514,
  [SMALL_STATE(4214)] = 92550,
  [SMALL_STATE(4215)] = 92574,
  [SMALL_STATE(4216)] = 92610,
  [SMALL_STATE(4217)] = 92634,
  [SMALL_STATE(4218)] = 92668,
  [SMALL_STATE(4219)] = 92694,
  [SMALL_STATE(4220)] = 92718,
  [SMALL_STATE(4221)] = 92754,
  [SMALL_STATE(4222)] = 92778,
  [SMALL_STATE(4223)] = 92812,
  [SMALL_STATE(4224)] = 92846,
  [SMALL_STATE(4225)] = 92882,
  [SMALL_STATE(4226)] = 92921,
  [SMALL_STATE(4227)] = 92960,
  [SMALL_STATE(4228)] = 92987,
  [SMALL_STATE(4229)] = 93026,
  [SMALL_STATE(4230)] = 93047,
  [SMALL_STATE(4231)] = 93086,
  [SMALL_STATE(4232)] = 93107,
  [SMALL_STATE(4233)] = 93138,
  [SMALL_STATE(4234)] = 93159,
  [SMALL_STATE(4235)] = 93198,
  [SMALL_STATE(4236)] = 93223,
  [SMALL_STATE(4237)] = 93244,
  [SMALL_STATE(4238)] = 93269,
  [SMALL_STATE(4239)] = 93300,
  [SMALL_STATE(4240)] = 93321,
  [SMALL_STATE(4241)] = 93352,
  [SMALL_STATE(4242)] = 93391,
  [SMALL_STATE(4243)] = 93416,
  [SMALL_STATE(4244)] = 93447,
  [SMALL_STATE(4245)] = 93486,
  [SMALL_STATE(4246)] = 93507,
  [SMALL_STATE(4247)] = 93538,
  [SMALL_STATE(4248)] = 93559,
  [SMALL_STATE(4249)] = 93598,
  [SMALL_STATE(4250)] = 93637,
  [SMALL_STATE(4251)] = 93658,
  [SMALL_STATE(4252)] = 93679,
  [SMALL_STATE(4253)] = 93700,
  [SMALL_STATE(4254)] = 93738,
  [SMALL_STATE(4255)] = 93770,
  [SMALL_STATE(4256)] = 93808,
  [SMALL_STATE(4257)] = 93840,
  [SMALL_STATE(4258)] = 93872,
  [SMALL_STATE(4259)] = 93908,
  [SMALL_STATE(4260)] = 93930,
  [SMALL_STATE(4261)] = 93968,
  [SMALL_STATE(4262)] = 94000,
  [SMALL_STATE(4263)] = 94022,
  [SMALL_STATE(4264)] = 94044,
  [SMALL_STATE(4265)] = 94076,
  [SMALL_STATE(4266)] = 94102,
  [SMALL_STATE(4267)] = 94140,
  [SMALL_STATE(4268)] = 94166,
  [SMALL_STATE(4269)] = 94204,
  [SMALL_STATE(4270)] = 94227,
  [SMALL_STATE(4271)] = 94256,
  [SMALL_STATE(4272)] = 94279,
  [SMALL_STATE(4273)] = 94312,
  [SMALL_STATE(4274)] = 94333,
  [SMALL_STATE(4275)] = 94356,
  [SMALL_STATE(4276)] = 94379,
  [SMALL_STATE(4277)] = 94402,
  [SMALL_STATE(4278)] = 94431,
  [SMALL_STATE(4279)] = 94466,
  [SMALL_STATE(4280)] = 94487,
  [SMALL_STATE(4281)] = 94512,
  [SMALL_STATE(4282)] = 94541,
  [SMALL_STATE(4283)] = 94564,
  [SMALL_STATE(4284)] = 94593,
  [SMALL_STATE(4285)] = 94622,
  [SMALL_STATE(4286)] = 94645,
  [SMALL_STATE(4287)] = 94672,
  [SMALL_STATE(4288)] = 94701,
  [SMALL_STATE(4289)] = 94730,
  [SMALL_STATE(4290)] = 94760,
  [SMALL_STATE(4291)] = 94788,
  [SMALL_STATE(4292)] = 94816,
  [SMALL_STATE(4293)] = 94846,
  [SMALL_STATE(4294)] = 94876,
  [SMALL_STATE(4295)] = 94906,
  [SMALL_STATE(4296)] = 94936,
  [SMALL_STATE(4297)] = 94966,
  [SMALL_STATE(4298)] = 94996,
  [SMALL_STATE(4299)] = 95026,
  [SMALL_STATE(4300)] = 95056,
  [SMALL_STATE(4301)] = 95086,
  [SMALL_STATE(4302)] = 95116,
  [SMALL_STATE(4303)] = 95146,
  [SMALL_STATE(4304)] = 95174,
  [SMALL_STATE(4305)] = 95204,
  [SMALL_STATE(4306)] = 95232,
  [SMALL_STATE(4307)] = 95260,
  [SMALL_STATE(4308)] = 95277,
  [SMALL_STATE(4309)] = 95304,
  [SMALL_STATE(4310)] = 95327,
  [SMALL_STATE(4311)] = 95350,
  [SMALL_STATE(4312)] = 95373,
  [SMALL_STATE(4313)] = 95394,
  [SMALL_STATE(4314)] = 95411,
  [SMALL_STATE(4315)] = 95438,
  [SMALL_STATE(4316)] = 95461,
  [SMALL_STATE(4317)] = 95488,
  [SMALL_STATE(4318)] = 95507,
  [SMALL_STATE(4319)] = 95526,
  [SMALL_STATE(4320)] = 95549,
  [SMALL_STATE(4321)] = 95572,
  [SMALL_STATE(4322)] = 95595,
  [SMALL_STATE(4323)] = 95618,
  [SMALL_STATE(4324)] = 95641,
  [SMALL_STATE(4325)] = 95664,
  [SMALL_STATE(4326)] = 95691,
  [SMALL_STATE(4327)] = 95708,
  [SMALL_STATE(4328)] = 95731,
  [SMALL_STATE(4329)] = 95754,
  [SMALL_STATE(4330)] = 95777,
  [SMALL_STATE(4331)] = 95800,
  [SMALL_STATE(4332)] = 95817,
  [SMALL_STATE(4333)] = 95840,
  [SMALL_STATE(4334)] = 95863,
  [SMALL_STATE(4335)] = 95886,
  [SMALL_STATE(4336)] = 95913,
  [SMALL_STATE(4337)] = 95936,
  [SMALL_STATE(4338)] = 95959,
  [SMALL_STATE(4339)] = 95978,
  [SMALL_STATE(4340)] = 96001,
  [SMALL_STATE(4341)] = 96024,
  [SMALL_STATE(4342)] = 96051,
  [SMALL_STATE(4343)] = 96068,
  [SMALL_STATE(4344)] = 96091,
  [SMALL_STATE(4345)] = 96108,
  [SMALL_STATE(4346)] = 96131,
  [SMALL_STATE(4347)] = 96150,
  [SMALL_STATE(4348)] = 96183,
  [SMALL_STATE(4349)] = 96204,
  [SMALL_STATE(4350)] = 96237,
  [SMALL_STATE(4351)] = 96264,
  [SMALL_STATE(4352)] = 96291,
  [SMALL_STATE(4353)] = 96314,
  [SMALL_STATE(4354)] = 96337,
  [SMALL_STATE(4355)] = 96360,
  [SMALL_STATE(4356)] = 96383,
  [SMALL_STATE(4357)] = 96406,
  [SMALL_STATE(4358)] = 96427,
  [SMALL_STATE(4359)] = 96450,
  [SMALL_STATE(4360)] = 96473,
  [SMALL_STATE(4361)] = 96506,
  [SMALL_STATE(4362)] = 96533,
  [SMALL_STATE(4363)] = 96552,
  [SMALL_STATE(4364)] = 96575,
  [SMALL_STATE(4365)] = 96598,
  [SMALL_STATE(4366)] = 96621,
  [SMALL_STATE(4367)] = 96644,
  [SMALL_STATE(4368)] = 96667,
  [SMALL_STATE(4369)] = 96694,
  [SMALL_STATE(4370)] = 96711,
  [SMALL_STATE(4371)] = 96728,
  [SMALL_STATE(4372)] = 96750,
  [SMALL_STATE(4373)] = 96780,
  [SMALL_STATE(4374)] = 96802,
  [SMALL_STATE(4375)] = 96822,
  [SMALL_STATE(4376)] = 96852,
  [SMALL_STATE(4377)] = 96876,
  [SMALL_STATE(4378)] = 96894,
  [SMALL_STATE(4379)] = 96918,
  [SMALL_STATE(4380)] = 96942,
  [SMALL_STATE(4381)] = 96960,
  [SMALL_STATE(4382)] = 96978,
  [SMALL_STATE(4383)] = 97000,
  [SMALL_STATE(4384)] = 97030,
  [SMALL_STATE(4385)] = 97060,
  [SMALL_STATE(4386)] = 97090,
  [SMALL_STATE(4387)] = 97112,
  [SMALL_STATE(4388)] = 97130,
  [SMALL_STATE(4389)] = 97160,
  [SMALL_STATE(4390)] = 97178,
  [SMALL_STATE(4391)] = 97196,
  [SMALL_STATE(4392)] = 97214,
  [SMALL_STATE(4393)] = 97232,
  [SMALL_STATE(4394)] = 97254,
  [SMALL_STATE(4395)] = 97272,
  [SMALL_STATE(4396)] = 97294,
  [SMALL_STATE(4397)] = 97318,
  [SMALL_STATE(4398)] = 97342,
  [SMALL_STATE(4399)] = 97364,
  [SMALL_STATE(4400)] = 97394,
  [SMALL_STATE(4401)] = 97416,
  [SMALL_STATE(4402)] = 97434,
  [SMALL_STATE(4403)] = 97452,
  [SMALL_STATE(4404)] = 97482,
  [SMALL_STATE(4405)] = 97500,
  [SMALL_STATE(4406)] = 97530,
  [SMALL_STATE(4407)] = 97560,
  [SMALL_STATE(4408)] = 97584,
  [SMALL_STATE(4409)] = 97607,
  [SMALL_STATE(4410)] = 97630,
  [SMALL_STATE(4411)] = 97653,
  [SMALL_STATE(4412)] = 97676,
  [SMALL_STATE(4413)] = 97697,
  [SMALL_STATE(4414)] = 97718,
  [SMALL_STATE(4415)] = 97741,
  [SMALL_STATE(4416)] = 97764,
  [SMALL_STATE(4417)] = 97787,
  [SMALL_STATE(4418)] = 97810,
  [SMALL_STATE(4419)] = 97833,
  [SMALL_STATE(4420)] = 97854,
  [SMALL_STATE(4421)] = 97877,
  [SMALL_STATE(4422)] = 97898,
  [SMALL_STATE(4423)] = 97921,
  [SMALL_STATE(4424)] = 97944,
  [SMALL_STATE(4425)] = 97961,
  [SMALL_STATE(4426)] = 97984,
  [SMALL_STATE(4427)] = 98005,
  [SMALL_STATE(4428)] = 98026,
  [SMALL_STATE(4429)] = 98049,
  [SMALL_STATE(4430)] = 98072,
  [SMALL_STATE(4431)] = 98095,
  [SMALL_STATE(4432)] = 98118,
  [SMALL_STATE(4433)] = 98143,
  [SMALL_STATE(4434)] = 98168,
  [SMALL_STATE(4435)] = 98187,
  [SMALL_STATE(4436)] = 98210,
  [SMALL_STATE(4437)] = 98233,
  [SMALL_STATE(4438)] = 98260,
  [SMALL_STATE(4439)] = 98279,
  [SMALL_STATE(4440)] = 98302,
  [SMALL_STATE(4441)] = 98327,
  [SMALL_STATE(4442)] = 98352,
  [SMALL_STATE(4443)] = 98375,
  [SMALL_STATE(4444)] = 98400,
  [SMALL_STATE(4445)] = 98423,
  [SMALL_STATE(4446)] = 98444,
  [SMALL_STATE(4447)] = 98467,
  [SMALL_STATE(4448)] = 98490,
  [SMALL_STATE(4449)] = 98513,
  [SMALL_STATE(4450)] = 98538,
  [SMALL_STATE(4451)] = 98553,
  [SMALL_STATE(4452)] = 98572,
  [SMALL_STATE(4453)] = 98593,
  [SMALL_STATE(4454)] = 98616,
  [SMALL_STATE(4455)] = 98635,
  [SMALL_STATE(4456)] = 98658,
  [SMALL_STATE(4457)] = 98677,
  [SMALL_STATE(4458)] = 98704,
  [SMALL_STATE(4459)] = 98727,
  [SMALL_STATE(4460)] = 98750,
  [SMALL_STATE(4461)] = 98773,
  [SMALL_STATE(4462)] = 98790,
  [SMALL_STATE(4463)] = 98813,
  [SMALL_STATE(4464)] = 98838,
  [SMALL_STATE(4465)] = 98862,
  [SMALL_STATE(4466)] = 98886,
  [SMALL_STATE(4467)] = 98910,
  [SMALL_STATE(4468)] = 98932,
  [SMALL_STATE(4469)] = 98956,
  [SMALL_STATE(4470)] = 98980,
  [SMALL_STATE(4471)] = 99004,
  [SMALL_STATE(4472)] = 99022,
  [SMALL_STATE(4473)] = 99046,
  [SMALL_STATE(4474)] = 99062,
  [SMALL_STATE(4475)] = 99084,
  [SMALL_STATE(4476)] = 99108,
  [SMALL_STATE(4477)] = 99132,
  [SMALL_STATE(4478)] = 99156,
  [SMALL_STATE(4479)] = 99180,
  [SMALL_STATE(4480)] = 99204,
  [SMALL_STATE(4481)] = 99228,
  [SMALL_STATE(4482)] = 99252,
  [SMALL_STATE(4483)] = 99276,
  [SMALL_STATE(4484)] = 99300,
  [SMALL_STATE(4485)] = 99324,
  [SMALL_STATE(4486)] = 99348,
  [SMALL_STATE(4487)] = 99362,
  [SMALL_STATE(4488)] = 99386,
  [SMALL_STATE(4489)] = 99410,
  [SMALL_STATE(4490)] = 99432,
  [SMALL_STATE(4491)] = 99456,
  [SMALL_STATE(4492)] = 99480,
  [SMALL_STATE(4493)] = 99502,
  [SMALL_STATE(4494)] = 99516,
  [SMALL_STATE(4495)] = 99540,
  [SMALL_STATE(4496)] = 99564,
  [SMALL_STATE(4497)] = 99588,
  [SMALL_STATE(4498)] = 99612,
  [SMALL_STATE(4499)] = 99636,
  [SMALL_STATE(4500)] = 99656,
  [SMALL_STATE(4501)] = 99680,
  [SMALL_STATE(4502)] = 99704,
  [SMALL_STATE(4503)] = 99728,
  [SMALL_STATE(4504)] = 99752,
  [SMALL_STATE(4505)] = 99776,
  [SMALL_STATE(4506)] = 99800,
  [SMALL_STATE(4507)] = 99824,
  [SMALL_STATE(4508)] = 99848,
  [SMALL_STATE(4509)] = 99872,
  [SMALL_STATE(4510)] = 99896,
  [SMALL_STATE(4511)] = 99920,
  [SMALL_STATE(4512)] = 99944,
  [SMALL_STATE(4513)] = 99968,
  [SMALL_STATE(4514)] = 99992,
  [SMALL_STATE(4515)] = 100016,
  [SMALL_STATE(4516)] = 100040,
  [SMALL_STATE(4517)] = 100064,
  [SMALL_STATE(4518)] = 100082,
  [SMALL_STATE(4519)] = 100106,
  [SMALL_STATE(4520)] = 100130,
  [SMALL_STATE(4521)] = 100152,
  [SMALL_STATE(4522)] = 100176,
  [SMALL_STATE(4523)] = 100198,
  [SMALL_STATE(4524)] = 100222,
  [SMALL_STATE(4525)] = 100246,
  [SMALL_STATE(4526)] = 100270,
  [SMALL_STATE(4527)] = 100294,
  [SMALL_STATE(4528)] = 100310,
  [SMALL_STATE(4529)] = 100324,
  [SMALL_STATE(4530)] = 100348,
  [SMALL_STATE(4531)] = 100372,
  [SMALL_STATE(4532)] = 100396,
  [SMALL_STATE(4533)] = 100414,
  [SMALL_STATE(4534)] = 100436,
  [SMALL_STATE(4535)] = 100460,
  [SMALL_STATE(4536)] = 100482,
  [SMALL_STATE(4537)] = 100504,
  [SMALL_STATE(4538)] = 100528,
  [SMALL_STATE(4539)] = 100552,
  [SMALL_STATE(4540)] = 100574,
  [SMALL_STATE(4541)] = 100598,
  [SMALL_STATE(4542)] = 100622,
  [SMALL_STATE(4543)] = 100644,
  [SMALL_STATE(4544)] = 100666,
  [SMALL_STATE(4545)] = 100690,
  [SMALL_STATE(4546)] = 100714,
  [SMALL_STATE(4547)] = 100728,
  [SMALL_STATE(4548)] = 100752,
  [SMALL_STATE(4549)] = 100774,
  [SMALL_STATE(4550)] = 100798,
  [SMALL_STATE(4551)] = 100816,
  [SMALL_STATE(4552)] = 100838,
  [SMALL_STATE(4553)] = 100862,
  [SMALL_STATE(4554)] = 100886,
  [SMALL_STATE(4555)] = 100910,
  [SMALL_STATE(4556)] = 100932,
  [SMALL_STATE(4557)] = 100956,
  [SMALL_STATE(4558)] = 100978,
  [SMALL_STATE(4559)] = 100996,
  [SMALL_STATE(4560)] = 101020,
  [SMALL_STATE(4561)] = 101044,
  [SMALL_STATE(4562)] = 101068,
  [SMALL_STATE(4563)] = 101082,
  [SMALL_STATE(4564)] = 101106,
  [SMALL_STATE(4565)] = 101128,
  [SMALL_STATE(4566)] = 101152,
  [SMALL_STATE(4567)] = 101173,
  [SMALL_STATE(4568)] = 101194,
  [SMALL_STATE(4569)] = 101215,
  [SMALL_STATE(4570)] = 101236,
  [SMALL_STATE(4571)] = 101257,
  [SMALL_STATE(4572)] = 101278,
  [SMALL_STATE(4573)] = 101299,
  [SMALL_STATE(4574)] = 101314,
  [SMALL_STATE(4575)] = 101335,
  [SMALL_STATE(4576)] = 101354,
  [SMALL_STATE(4577)] = 101375,
  [SMALL_STATE(4578)] = 101396,
  [SMALL_STATE(4579)] = 101415,
  [SMALL_STATE(4580)] = 101436,
  [SMALL_STATE(4581)] = 101457,
  [SMALL_STATE(4582)] = 101474,
  [SMALL_STATE(4583)] = 101495,
  [SMALL_STATE(4584)] = 101516,
  [SMALL_STATE(4585)] = 101537,
  [SMALL_STATE(4586)] = 101558,
  [SMALL_STATE(4587)] = 101579,
  [SMALL_STATE(4588)] = 101596,
  [SMALL_STATE(4589)] = 101617,
  [SMALL_STATE(4590)] = 101634,
  [SMALL_STATE(4591)] = 101653,
  [SMALL_STATE(4592)] = 101674,
  [SMALL_STATE(4593)] = 101695,
  [SMALL_STATE(4594)] = 101716,
  [SMALL_STATE(4595)] = 101737,
  [SMALL_STATE(4596)] = 101758,
  [SMALL_STATE(4597)] = 101779,
  [SMALL_STATE(4598)] = 101792,
  [SMALL_STATE(4599)] = 101813,
  [SMALL_STATE(4600)] = 101834,
  [SMALL_STATE(4601)] = 101853,
  [SMALL_STATE(4602)] = 101872,
  [SMALL_STATE(4603)] = 101893,
  [SMALL_STATE(4604)] = 101914,
  [SMALL_STATE(4605)] = 101927,
  [SMALL_STATE(4606)] = 101944,
  [SMALL_STATE(4607)] = 101965,
  [SMALL_STATE(4608)] = 101986,
  [SMALL_STATE(4609)] = 102003,
  [SMALL_STATE(4610)] = 102020,
  [SMALL_STATE(4611)] = 102039,
  [SMALL_STATE(4612)] = 102051,
  [SMALL_STATE(4613)] = 102063,
  [SMALL_STATE(4614)] = 102075,
  [SMALL_STATE(4615)] = 102087,
  [SMALL_STATE(4616)] = 102103,
  [SMALL_STATE(4617)] = 102119,
  [SMALL_STATE(4618)] = 102131,
  [SMALL_STATE(4619)] = 102143,
  [SMALL_STATE(4620)] = 102155,
  [SMALL_STATE(4621)] = 102167,
  [SMALL_STATE(4622)] = 102179,
  [SMALL_STATE(4623)] = 102195,
  [SMALL_STATE(4624)] = 102207,
  [SMALL_STATE(4625)] = 102219,
  [SMALL_STATE(4626)] = 102231,
  [SMALL_STATE(4627)] = 102243,
  [SMALL_STATE(4628)] = 102259,
  [SMALL_STATE(4629)] = 102271,
  [SMALL_STATE(4630)] = 102287,
  [SMALL_STATE(4631)] = 102303,
  [SMALL_STATE(4632)] = 102321,
  [SMALL_STATE(4633)] = 102339,
  [SMALL_STATE(4634)] = 102355,
  [SMALL_STATE(4635)] = 102367,
  [SMALL_STATE(4636)] = 102385,
  [SMALL_STATE(4637)] = 102397,
  [SMALL_STATE(4638)] = 102413,
  [SMALL_STATE(4639)] = 102425,
  [SMALL_STATE(4640)] = 102437,
  [SMALL_STATE(4641)] = 102453,
  [SMALL_STATE(4642)] = 102471,
  [SMALL_STATE(4643)] = 102483,
  [SMALL_STATE(4644)] = 102495,
  [SMALL_STATE(4645)] = 102513,
  [SMALL_STATE(4646)] = 102529,
  [SMALL_STATE(4647)] = 102541,
  [SMALL_STATE(4648)] = 102553,
  [SMALL_STATE(4649)] = 102571,
  [SMALL_STATE(4650)] = 102583,
  [SMALL_STATE(4651)] = 102595,
  [SMALL_STATE(4652)] = 102607,
  [SMALL_STATE(4653)] = 102619,
  [SMALL_STATE(4654)] = 102631,
  [SMALL_STATE(4655)] = 102649,
  [SMALL_STATE(4656)] = 102665,
  [SMALL_STATE(4657)] = 102683,
  [SMALL_STATE(4658)] = 102697,
  [SMALL_STATE(4659)] = 102713,
  [SMALL_STATE(4660)] = 102729,
  [SMALL_STATE(4661)] = 102745,
  [SMALL_STATE(4662)] = 102757,
  [SMALL_STATE(4663)] = 102773,
  [SMALL_STATE(4664)] = 102785,
  [SMALL_STATE(4665)] = 102803,
  [SMALL_STATE(4666)] = 102815,
  [SMALL_STATE(4667)] = 102827,
  [SMALL_STATE(4668)] = 102839,
  [SMALL_STATE(4669)] = 102855,
  [SMALL_STATE(4670)] = 102873,
  [SMALL_STATE(4671)] = 102889,
  [SMALL_STATE(4672)] = 102901,
  [SMALL_STATE(4673)] = 102913,
  [SMALL_STATE(4674)] = 102925,
  [SMALL_STATE(4675)] = 102941,
  [SMALL_STATE(4676)] = 102959,
  [SMALL_STATE(4677)] = 102971,
  [SMALL_STATE(4678)] = 102983,
  [SMALL_STATE(4679)] = 102995,
  [SMALL_STATE(4680)] = 103007,
  [SMALL_STATE(4681)] = 103023,
  [SMALL_STATE(4682)] = 103035,
  [SMALL_STATE(4683)] = 103047,
  [SMALL_STATE(4684)] = 103059,
  [SMALL_STATE(4685)] = 103071,
  [SMALL_STATE(4686)] = 103083,
  [SMALL_STATE(4687)] = 103095,
  [SMALL_STATE(4688)] = 103111,
  [SMALL_STATE(4689)] = 103123,
  [SMALL_STATE(4690)] = 103139,
  [SMALL_STATE(4691)] = 103151,
  [SMALL_STATE(4692)] = 103167,
  [SMALL_STATE(4693)] = 103179,
  [SMALL_STATE(4694)] = 103191,
  [SMALL_STATE(4695)] = 103209,
  [SMALL_STATE(4696)] = 103221,
  [SMALL_STATE(4697)] = 103237,
  [SMALL_STATE(4698)] = 103253,
  [SMALL_STATE(4699)] = 103271,
  [SMALL_STATE(4700)] = 103283,
  [SMALL_STATE(4701)] = 103299,
  [SMALL_STATE(4702)] = 103311,
  [SMALL_STATE(4703)] = 103323,
  [SMALL_STATE(4704)] = 103337,
  [SMALL_STATE(4705)] = 103355,
  [SMALL_STATE(4706)] = 103373,
  [SMALL_STATE(4707)] = 103389,
  [SMALL_STATE(4708)] = 103401,
  [SMALL_STATE(4709)] = 103413,
  [SMALL_STATE(4710)] = 103429,
  [SMALL_STATE(4711)] = 103443,
  [SMALL_STATE(4712)] = 103459,
  [SMALL_STATE(4713)] = 103475,
  [SMALL_STATE(4714)] = 103489,
  [SMALL_STATE(4715)] = 103505,
  [SMALL_STATE(4716)] = 103521,
  [SMALL_STATE(4717)] = 103537,
  [SMALL_STATE(4718)] = 103549,
  [SMALL_STATE(4719)] = 103565,
  [SMALL_STATE(4720)] = 103581,
  [SMALL_STATE(4721)] = 103595,
  [SMALL_STATE(4722)] = 103609,
  [SMALL_STATE(4723)] = 103623,
  [SMALL_STATE(4724)] = 103641,
  [SMALL_STATE(4725)] = 103659,
  [SMALL_STATE(4726)] = 103675,
  [SMALL_STATE(4727)] = 103693,
  [SMALL_STATE(4728)] = 103709,
  [SMALL_STATE(4729)] = 103723,
  [SMALL_STATE(4730)] = 103737,
  [SMALL_STATE(4731)] = 103749,
  [SMALL_STATE(4732)] = 103763,
  [SMALL_STATE(4733)] = 103777,
  [SMALL_STATE(4734)] = 103795,
  [SMALL_STATE(4735)] = 103811,
  [SMALL_STATE(4736)] = 103829,
  [SMALL_STATE(4737)] = 103847,
  [SMALL_STATE(4738)] = 103863,
  [SMALL_STATE(4739)] = 103875,
  [SMALL_STATE(4740)] = 103890,
  [SMALL_STATE(4741)] = 103905,
  [SMALL_STATE(4742)] = 103918,
  [SMALL_STATE(4743)] = 103933,
  [SMALL_STATE(4744)] = 103948,
  [SMALL_STATE(4745)] = 103963,
  [SMALL_STATE(4746)] = 103978,
  [SMALL_STATE(4747)] = 103993,
  [SMALL_STATE(4748)] = 104008,
  [SMALL_STATE(4749)] = 104021,
  [SMALL_STATE(4750)] = 104036,
  [SMALL_STATE(4751)] = 104051,
  [SMALL_STATE(4752)] = 104066,
  [SMALL_STATE(4753)] = 104081,
  [SMALL_STATE(4754)] = 104096,
  [SMALL_STATE(4755)] = 104111,
  [SMALL_STATE(4756)] = 104126,
  [SMALL_STATE(4757)] = 104141,
  [SMALL_STATE(4758)] = 104156,
  [SMALL_STATE(4759)] = 104171,
  [SMALL_STATE(4760)] = 104186,
  [SMALL_STATE(4761)] = 104201,
  [SMALL_STATE(4762)] = 104216,
  [SMALL_STATE(4763)] = 104231,
  [SMALL_STATE(4764)] = 104246,
  [SMALL_STATE(4765)] = 104261,
  [SMALL_STATE(4766)] = 104276,
  [SMALL_STATE(4767)] = 104291,
  [SMALL_STATE(4768)] = 104306,
  [SMALL_STATE(4769)] = 104321,
  [SMALL_STATE(4770)] = 104336,
  [SMALL_STATE(4771)] = 104351,
  [SMALL_STATE(4772)] = 104366,
  [SMALL_STATE(4773)] = 104381,
  [SMALL_STATE(4774)] = 104396,
  [SMALL_STATE(4775)] = 104411,
  [SMALL_STATE(4776)] = 104426,
  [SMALL_STATE(4777)] = 104441,
  [SMALL_STATE(4778)] = 104456,
  [SMALL_STATE(4779)] = 104471,
  [SMALL_STATE(4780)] = 104486,
  [SMALL_STATE(4781)] = 104501,
  [SMALL_STATE(4782)] = 104516,
  [SMALL_STATE(4783)] = 104531,
  [SMALL_STATE(4784)] = 104546,
  [SMALL_STATE(4785)] = 104561,
  [SMALL_STATE(4786)] = 104576,
  [SMALL_STATE(4787)] = 104591,
  [SMALL_STATE(4788)] = 104606,
  [SMALL_STATE(4789)] = 104621,
  [SMALL_STATE(4790)] = 104636,
  [SMALL_STATE(4791)] = 104651,
  [SMALL_STATE(4792)] = 104666,
  [SMALL_STATE(4793)] = 104681,
  [SMALL_STATE(4794)] = 104696,
  [SMALL_STATE(4795)] = 104711,
  [SMALL_STATE(4796)] = 104726,
  [SMALL_STATE(4797)] = 104741,
  [SMALL_STATE(4798)] = 104756,
  [SMALL_STATE(4799)] = 104771,
  [SMALL_STATE(4800)] = 104786,
  [SMALL_STATE(4801)] = 104801,
  [SMALL_STATE(4802)] = 104812,
  [SMALL_STATE(4803)] = 104827,
  [SMALL_STATE(4804)] = 104842,
  [SMALL_STATE(4805)] = 104857,
  [SMALL_STATE(4806)] = 104870,
  [SMALL_STATE(4807)] = 104885,
  [SMALL_STATE(4808)] = 104900,
  [SMALL_STATE(4809)] = 104915,
  [SMALL_STATE(4810)] = 104930,
  [SMALL_STATE(4811)] = 104945,
  [SMALL_STATE(4812)] = 104960,
  [SMALL_STATE(4813)] = 104975,
  [SMALL_STATE(4814)] = 104990,
  [SMALL_STATE(4815)] = 105005,
  [SMALL_STATE(4816)] = 105020,
  [SMALL_STATE(4817)] = 105035,
  [SMALL_STATE(4818)] = 105050,
  [SMALL_STATE(4819)] = 105065,
  [SMALL_STATE(4820)] = 105080,
  [SMALL_STATE(4821)] = 105095,
  [SMALL_STATE(4822)] = 105110,
  [SMALL_STATE(4823)] = 105125,
  [SMALL_STATE(4824)] = 105140,
  [SMALL_STATE(4825)] = 105153,
  [SMALL_STATE(4826)] = 105168,
  [SMALL_STATE(4827)] = 105183,
  [SMALL_STATE(4828)] = 105198,
  [SMALL_STATE(4829)] = 105213,
  [SMALL_STATE(4830)] = 105228,
  [SMALL_STATE(4831)] = 105243,
  [SMALL_STATE(4832)] = 105254,
  [SMALL_STATE(4833)] = 105269,
  [SMALL_STATE(4834)] = 105284,
  [SMALL_STATE(4835)] = 105299,
  [SMALL_STATE(4836)] = 105314,
  [SMALL_STATE(4837)] = 105329,
  [SMALL_STATE(4838)] = 105344,
  [SMALL_STATE(4839)] = 105359,
  [SMALL_STATE(4840)] = 105374,
  [SMALL_STATE(4841)] = 105389,
  [SMALL_STATE(4842)] = 105404,
  [SMALL_STATE(4843)] = 105419,
  [SMALL_STATE(4844)] = 105434,
  [SMALL_STATE(4845)] = 105449,
  [SMALL_STATE(4846)] = 105464,
  [SMALL_STATE(4847)] = 105479,
  [SMALL_STATE(4848)] = 105494,
  [SMALL_STATE(4849)] = 105509,
  [SMALL_STATE(4850)] = 105524,
  [SMALL_STATE(4851)] = 105539,
  [SMALL_STATE(4852)] = 105554,
  [SMALL_STATE(4853)] = 105569,
  [SMALL_STATE(4854)] = 105584,
  [SMALL_STATE(4855)] = 105599,
  [SMALL_STATE(4856)] = 105614,
  [SMALL_STATE(4857)] = 105629,
  [SMALL_STATE(4858)] = 105644,
  [SMALL_STATE(4859)] = 105659,
  [SMALL_STATE(4860)] = 105674,
  [SMALL_STATE(4861)] = 105689,
  [SMALL_STATE(4862)] = 105704,
  [SMALL_STATE(4863)] = 105719,
  [SMALL_STATE(4864)] = 105734,
  [SMALL_STATE(4865)] = 105749,
  [SMALL_STATE(4866)] = 105764,
  [SMALL_STATE(4867)] = 105779,
  [SMALL_STATE(4868)] = 105794,
  [SMALL_STATE(4869)] = 105809,
  [SMALL_STATE(4870)] = 105824,
  [SMALL_STATE(4871)] = 105835,
  [SMALL_STATE(4872)] = 105850,
  [SMALL_STATE(4873)] = 105865,
  [SMALL_STATE(4874)] = 105880,
  [SMALL_STATE(4875)] = 105895,
  [SMALL_STATE(4876)] = 105906,
  [SMALL_STATE(4877)] = 105921,
  [SMALL_STATE(4878)] = 105936,
  [SMALL_STATE(4879)] = 105951,
  [SMALL_STATE(4880)] = 105966,
  [SMALL_STATE(4881)] = 105981,
  [SMALL_STATE(4882)] = 105996,
  [SMALL_STATE(4883)] = 106011,
  [SMALL_STATE(4884)] = 106026,
  [SMALL_STATE(4885)] = 106041,
  [SMALL_STATE(4886)] = 106056,
  [SMALL_STATE(4887)] = 106071,
  [SMALL_STATE(4888)] = 106086,
  [SMALL_STATE(4889)] = 106101,
  [SMALL_STATE(4890)] = 106116,
  [SMALL_STATE(4891)] = 106131,
  [SMALL_STATE(4892)] = 106142,
  [SMALL_STATE(4893)] = 106157,
  [SMALL_STATE(4894)] = 106172,
  [SMALL_STATE(4895)] = 106187,
  [SMALL_STATE(4896)] = 106202,
  [SMALL_STATE(4897)] = 106217,
  [SMALL_STATE(4898)] = 106232,
  [SMALL_STATE(4899)] = 106247,
  [SMALL_STATE(4900)] = 106262,
  [SMALL_STATE(4901)] = 106277,
  [SMALL_STATE(4902)] = 106292,
  [SMALL_STATE(4903)] = 106307,
  [SMALL_STATE(4904)] = 106322,
  [SMALL_STATE(4905)] = 106337,
  [SMALL_STATE(4906)] = 106352,
  [SMALL_STATE(4907)] = 106367,
  [SMALL_STATE(4908)] = 106382,
  [SMALL_STATE(4909)] = 106397,
  [SMALL_STATE(4910)] = 106412,
  [SMALL_STATE(4911)] = 106427,
  [SMALL_STATE(4912)] = 106442,
  [SMALL_STATE(4913)] = 106457,
  [SMALL_STATE(4914)] = 106472,
  [SMALL_STATE(4915)] = 106487,
  [SMALL_STATE(4916)] = 106502,
  [SMALL_STATE(4917)] = 106517,
  [SMALL_STATE(4918)] = 106532,
  [SMALL_STATE(4919)] = 106547,
  [SMALL_STATE(4920)] = 106562,
  [SMALL_STATE(4921)] = 106577,
  [SMALL_STATE(4922)] = 106592,
  [SMALL_STATE(4923)] = 106607,
  [SMALL_STATE(4924)] = 106622,
  [SMALL_STATE(4925)] = 106637,
  [SMALL_STATE(4926)] = 106652,
  [SMALL_STATE(4927)] = 106667,
  [SMALL_STATE(4928)] = 106682,
  [SMALL_STATE(4929)] = 106697,
  [SMALL_STATE(4930)] = 106712,
  [SMALL_STATE(4931)] = 106727,
  [SMALL_STATE(4932)] = 106742,
  [SMALL_STATE(4933)] = 106757,
  [SMALL_STATE(4934)] = 106772,
  [SMALL_STATE(4935)] = 106787,
  [SMALL_STATE(4936)] = 106802,
  [SMALL_STATE(4937)] = 106817,
  [SMALL_STATE(4938)] = 106832,
  [SMALL_STATE(4939)] = 106847,
  [SMALL_STATE(4940)] = 106862,
  [SMALL_STATE(4941)] = 106877,
  [SMALL_STATE(4942)] = 106892,
  [SMALL_STATE(4943)] = 106907,
  [SMALL_STATE(4944)] = 106922,
  [SMALL_STATE(4945)] = 106937,
  [SMALL_STATE(4946)] = 106952,
  [SMALL_STATE(4947)] = 106967,
  [SMALL_STATE(4948)] = 106982,
  [SMALL_STATE(4949)] = 106997,
  [SMALL_STATE(4950)] = 107012,
  [SMALL_STATE(4951)] = 107023,
  [SMALL_STATE(4952)] = 107038,
  [SMALL_STATE(4953)] = 107051,
  [SMALL_STATE(4954)] = 107066,
  [SMALL_STATE(4955)] = 107081,
  [SMALL_STATE(4956)] = 107096,
  [SMALL_STATE(4957)] = 107109,
  [SMALL_STATE(4958)] = 107124,
  [SMALL_STATE(4959)] = 107139,
  [SMALL_STATE(4960)] = 107154,
  [SMALL_STATE(4961)] = 107169,
  [SMALL_STATE(4962)] = 107184,
  [SMALL_STATE(4963)] = 107199,
  [SMALL_STATE(4964)] = 107214,
  [SMALL_STATE(4965)] = 107229,
  [SMALL_STATE(4966)] = 107244,
  [SMALL_STATE(4967)] = 107259,
  [SMALL_STATE(4968)] = 107274,
  [SMALL_STATE(4969)] = 107289,
  [SMALL_STATE(4970)] = 107302,
  [SMALL_STATE(4971)] = 107317,
  [SMALL_STATE(4972)] = 107332,
  [SMALL_STATE(4973)] = 107347,
  [SMALL_STATE(4974)] = 107362,
  [SMALL_STATE(4975)] = 107373,
  [SMALL_STATE(4976)] = 107388,
  [SMALL_STATE(4977)] = 107403,
  [SMALL_STATE(4978)] = 107418,
  [SMALL_STATE(4979)] = 107429,
  [SMALL_STATE(4980)] = 107444,
  [SMALL_STATE(4981)] = 107459,
  [SMALL_STATE(4982)] = 107472,
  [SMALL_STATE(4983)] = 107487,
  [SMALL_STATE(4984)] = 107502,
  [SMALL_STATE(4985)] = 107517,
  [SMALL_STATE(4986)] = 107532,
  [SMALL_STATE(4987)] = 107547,
  [SMALL_STATE(4988)] = 107562,
  [SMALL_STATE(4989)] = 107573,
  [SMALL_STATE(4990)] = 107584,
  [SMALL_STATE(4991)] = 107599,
  [SMALL_STATE(4992)] = 107614,
  [SMALL_STATE(4993)] = 107629,
  [SMALL_STATE(4994)] = 107644,
  [SMALL_STATE(4995)] = 107659,
  [SMALL_STATE(4996)] = 107674,
  [SMALL_STATE(4997)] = 107687,
  [SMALL_STATE(4998)] = 107702,
  [SMALL_STATE(4999)] = 107717,
  [SMALL_STATE(5000)] = 107732,
  [SMALL_STATE(5001)] = 107747,
  [SMALL_STATE(5002)] = 107762,
  [SMALL_STATE(5003)] = 107777,
  [SMALL_STATE(5004)] = 107792,
  [SMALL_STATE(5005)] = 107807,
  [SMALL_STATE(5006)] = 107822,
  [SMALL_STATE(5007)] = 107837,
  [SMALL_STATE(5008)] = 107848,
  [SMALL_STATE(5009)] = 107863,
  [SMALL_STATE(5010)] = 107878,
  [SMALL_STATE(5011)] = 107893,
  [SMALL_STATE(5012)] = 107908,
  [SMALL_STATE(5013)] = 107923,
  [SMALL_STATE(5014)] = 107938,
  [SMALL_STATE(5015)] = 107953,
  [SMALL_STATE(5016)] = 107968,
  [SMALL_STATE(5017)] = 107983,
  [SMALL_STATE(5018)] = 107998,
  [SMALL_STATE(5019)] = 108013,
  [SMALL_STATE(5020)] = 108026,
  [SMALL_STATE(5021)] = 108041,
  [SMALL_STATE(5022)] = 108056,
  [SMALL_STATE(5023)] = 108071,
  [SMALL_STATE(5024)] = 108086,
  [SMALL_STATE(5025)] = 108101,
  [SMALL_STATE(5026)] = 108116,
  [SMALL_STATE(5027)] = 108131,
  [SMALL_STATE(5028)] = 108146,
  [SMALL_STATE(5029)] = 108161,
  [SMALL_STATE(5030)] = 108176,
  [SMALL_STATE(5031)] = 108191,
  [SMALL_STATE(5032)] = 108204,
  [SMALL_STATE(5033)] = 108219,
  [SMALL_STATE(5034)] = 108234,
  [SMALL_STATE(5035)] = 108249,
  [SMALL_STATE(5036)] = 108264,
  [SMALL_STATE(5037)] = 108279,
  [SMALL_STATE(5038)] = 108294,
  [SMALL_STATE(5039)] = 108309,
  [SMALL_STATE(5040)] = 108324,
  [SMALL_STATE(5041)] = 108335,
  [SMALL_STATE(5042)] = 108350,
  [SMALL_STATE(5043)] = 108365,
  [SMALL_STATE(5044)] = 108380,
  [SMALL_STATE(5045)] = 108395,
  [SMALL_STATE(5046)] = 108410,
  [SMALL_STATE(5047)] = 108425,
  [SMALL_STATE(5048)] = 108440,
  [SMALL_STATE(5049)] = 108455,
  [SMALL_STATE(5050)] = 108470,
  [SMALL_STATE(5051)] = 108485,
  [SMALL_STATE(5052)] = 108500,
  [SMALL_STATE(5053)] = 108515,
  [SMALL_STATE(5054)] = 108526,
  [SMALL_STATE(5055)] = 108541,
  [SMALL_STATE(5056)] = 108556,
  [SMALL_STATE(5057)] = 108571,
  [SMALL_STATE(5058)] = 108586,
  [SMALL_STATE(5059)] = 108601,
  [SMALL_STATE(5060)] = 108616,
  [SMALL_STATE(5061)] = 108631,
  [SMALL_STATE(5062)] = 108646,
  [SMALL_STATE(5063)] = 108661,
  [SMALL_STATE(5064)] = 108676,
  [SMALL_STATE(5065)] = 108691,
  [SMALL_STATE(5066)] = 108706,
  [SMALL_STATE(5067)] = 108721,
  [SMALL_STATE(5068)] = 108736,
  [SMALL_STATE(5069)] = 108751,
  [SMALL_STATE(5070)] = 108766,
  [SMALL_STATE(5071)] = 108781,
  [SMALL_STATE(5072)] = 108796,
  [SMALL_STATE(5073)] = 108811,
  [SMALL_STATE(5074)] = 108826,
  [SMALL_STATE(5075)] = 108841,
  [SMALL_STATE(5076)] = 108856,
  [SMALL_STATE(5077)] = 108871,
  [SMALL_STATE(5078)] = 108882,
  [SMALL_STATE(5079)] = 108897,
  [SMALL_STATE(5080)] = 108912,
  [SMALL_STATE(5081)] = 108927,
  [SMALL_STATE(5082)] = 108942,
  [SMALL_STATE(5083)] = 108957,
  [SMALL_STATE(5084)] = 108970,
  [SMALL_STATE(5085)] = 108985,
  [SMALL_STATE(5086)] = 109000,
  [SMALL_STATE(5087)] = 109015,
  [SMALL_STATE(5088)] = 109030,
  [SMALL_STATE(5089)] = 109045,
  [SMALL_STATE(5090)] = 109060,
  [SMALL_STATE(5091)] = 109075,
  [SMALL_STATE(5092)] = 109090,
  [SMALL_STATE(5093)] = 109105,
  [SMALL_STATE(5094)] = 109120,
  [SMALL_STATE(5095)] = 109135,
  [SMALL_STATE(5096)] = 109150,
  [SMALL_STATE(5097)] = 109165,
  [SMALL_STATE(5098)] = 109180,
  [SMALL_STATE(5099)] = 109195,
  [SMALL_STATE(5100)] = 109210,
  [SMALL_STATE(5101)] = 109225,
  [SMALL_STATE(5102)] = 109240,
  [SMALL_STATE(5103)] = 109255,
  [SMALL_STATE(5104)] = 109270,
  [SMALL_STATE(5105)] = 109285,
  [SMALL_STATE(5106)] = 109300,
  [SMALL_STATE(5107)] = 109315,
  [SMALL_STATE(5108)] = 109330,
  [SMALL_STATE(5109)] = 109345,
  [SMALL_STATE(5110)] = 109360,
  [SMALL_STATE(5111)] = 109375,
  [SMALL_STATE(5112)] = 109390,
  [SMALL_STATE(5113)] = 109405,
  [SMALL_STATE(5114)] = 109420,
  [SMALL_STATE(5115)] = 109435,
  [SMALL_STATE(5116)] = 109450,
  [SMALL_STATE(5117)] = 109465,
  [SMALL_STATE(5118)] = 109480,
  [SMALL_STATE(5119)] = 109495,
  [SMALL_STATE(5120)] = 109510,
  [SMALL_STATE(5121)] = 109525,
  [SMALL_STATE(5122)] = 109540,
  [SMALL_STATE(5123)] = 109555,
  [SMALL_STATE(5124)] = 109570,
  [SMALL_STATE(5125)] = 109585,
  [SMALL_STATE(5126)] = 109600,
  [SMALL_STATE(5127)] = 109615,
  [SMALL_STATE(5128)] = 109630,
  [SMALL_STATE(5129)] = 109645,
  [SMALL_STATE(5130)] = 109660,
  [SMALL_STATE(5131)] = 109675,
  [SMALL_STATE(5132)] = 109690,
  [SMALL_STATE(5133)] = 109705,
  [SMALL_STATE(5134)] = 109716,
  [SMALL_STATE(5135)] = 109731,
  [SMALL_STATE(5136)] = 109746,
  [SMALL_STATE(5137)] = 109761,
  [SMALL_STATE(5138)] = 109776,
  [SMALL_STATE(5139)] = 109789,
  [SMALL_STATE(5140)] = 109804,
  [SMALL_STATE(5141)] = 109817,
  [SMALL_STATE(5142)] = 109832,
  [SMALL_STATE(5143)] = 109847,
  [SMALL_STATE(5144)] = 109862,
  [SMALL_STATE(5145)] = 109877,
  [SMALL_STATE(5146)] = 109892,
  [SMALL_STATE(5147)] = 109907,
  [SMALL_STATE(5148)] = 109922,
  [SMALL_STATE(5149)] = 109937,
  [SMALL_STATE(5150)] = 109952,
  [SMALL_STATE(5151)] = 109967,
  [SMALL_STATE(5152)] = 109982,
  [SMALL_STATE(5153)] = 109997,
  [SMALL_STATE(5154)] = 110012,
  [SMALL_STATE(5155)] = 110027,
  [SMALL_STATE(5156)] = 110042,
  [SMALL_STATE(5157)] = 110057,
  [SMALL_STATE(5158)] = 110072,
  [SMALL_STATE(5159)] = 110087,
  [SMALL_STATE(5160)] = 110102,
  [SMALL_STATE(5161)] = 110117,
  [SMALL_STATE(5162)] = 110132,
  [SMALL_STATE(5163)] = 110147,
  [SMALL_STATE(5164)] = 110162,
  [SMALL_STATE(5165)] = 110177,
  [SMALL_STATE(5166)] = 110192,
  [SMALL_STATE(5167)] = 110207,
  [SMALL_STATE(5168)] = 110222,
  [SMALL_STATE(5169)] = 110237,
  [SMALL_STATE(5170)] = 110252,
  [SMALL_STATE(5171)] = 110267,
  [SMALL_STATE(5172)] = 110282,
  [SMALL_STATE(5173)] = 110297,
  [SMALL_STATE(5174)] = 110312,
  [SMALL_STATE(5175)] = 110327,
  [SMALL_STATE(5176)] = 110342,
  [SMALL_STATE(5177)] = 110357,
  [SMALL_STATE(5178)] = 110368,
  [SMALL_STATE(5179)] = 110383,
  [SMALL_STATE(5180)] = 110398,
  [SMALL_STATE(5181)] = 110413,
  [SMALL_STATE(5182)] = 110428,
  [SMALL_STATE(5183)] = 110443,
  [SMALL_STATE(5184)] = 110458,
  [SMALL_STATE(5185)] = 110473,
  [SMALL_STATE(5186)] = 110488,
  [SMALL_STATE(5187)] = 110503,
  [SMALL_STATE(5188)] = 110518,
  [SMALL_STATE(5189)] = 110533,
  [SMALL_STATE(5190)] = 110548,
  [SMALL_STATE(5191)] = 110563,
  [SMALL_STATE(5192)] = 110578,
  [SMALL_STATE(5193)] = 110593,
  [SMALL_STATE(5194)] = 110608,
  [SMALL_STATE(5195)] = 110623,
  [SMALL_STATE(5196)] = 110638,
  [SMALL_STATE(5197)] = 110653,
  [SMALL_STATE(5198)] = 110668,
  [SMALL_STATE(5199)] = 110683,
  [SMALL_STATE(5200)] = 110698,
  [SMALL_STATE(5201)] = 110713,
  [SMALL_STATE(5202)] = 110728,
  [SMALL_STATE(5203)] = 110743,
  [SMALL_STATE(5204)] = 110758,
  [SMALL_STATE(5205)] = 110773,
  [SMALL_STATE(5206)] = 110788,
  [SMALL_STATE(5207)] = 110800,
  [SMALL_STATE(5208)] = 110812,
  [SMALL_STATE(5209)] = 110824,
  [SMALL_STATE(5210)] = 110836,
  [SMALL_STATE(5211)] = 110848,
  [SMALL_STATE(5212)] = 110860,
  [SMALL_STATE(5213)] = 110872,
  [SMALL_STATE(5214)] = 110884,
  [SMALL_STATE(5215)] = 110896,
  [SMALL_STATE(5216)] = 110908,
  [SMALL_STATE(5217)] = 110918,
  [SMALL_STATE(5218)] = 110930,
  [SMALL_STATE(5219)] = 110942,
  [SMALL_STATE(5220)] = 110954,
  [SMALL_STATE(5221)] = 110966,
  [SMALL_STATE(5222)] = 110978,
  [SMALL_STATE(5223)] = 110990,
  [SMALL_STATE(5224)] = 111002,
  [SMALL_STATE(5225)] = 111014,
  [SMALL_STATE(5226)] = 111026,
  [SMALL_STATE(5227)] = 111038,
  [SMALL_STATE(5228)] = 111050,
  [SMALL_STATE(5229)] = 111062,
  [SMALL_STATE(5230)] = 111074,
  [SMALL_STATE(5231)] = 111086,
  [SMALL_STATE(5232)] = 111098,
  [SMALL_STATE(5233)] = 111110,
  [SMALL_STATE(5234)] = 111122,
  [SMALL_STATE(5235)] = 111134,
  [SMALL_STATE(5236)] = 111146,
  [SMALL_STATE(5237)] = 111158,
  [SMALL_STATE(5238)] = 111170,
  [SMALL_STATE(5239)] = 111180,
  [SMALL_STATE(5240)] = 111192,
  [SMALL_STATE(5241)] = 111204,
  [SMALL_STATE(5242)] = 111216,
  [SMALL_STATE(5243)] = 111226,
  [SMALL_STATE(5244)] = 111238,
  [SMALL_STATE(5245)] = 111250,
  [SMALL_STATE(5246)] = 111262,
  [SMALL_STATE(5247)] = 111272,
  [SMALL_STATE(5248)] = 111284,
  [SMALL_STATE(5249)] = 111296,
  [SMALL_STATE(5250)] = 111308,
  [SMALL_STATE(5251)] = 111320,
  [SMALL_STATE(5252)] = 111332,
  [SMALL_STATE(5253)] = 111344,
  [SMALL_STATE(5254)] = 111356,
  [SMALL_STATE(5255)] = 111368,
  [SMALL_STATE(5256)] = 111378,
  [SMALL_STATE(5257)] = 111390,
  [SMALL_STATE(5258)] = 111402,
  [SMALL_STATE(5259)] = 111414,
  [SMALL_STATE(5260)] = 111426,
  [SMALL_STATE(5261)] = 111438,
  [SMALL_STATE(5262)] = 111450,
  [SMALL_STATE(5263)] = 111462,
  [SMALL_STATE(5264)] = 111474,
  [SMALL_STATE(5265)] = 111484,
  [SMALL_STATE(5266)] = 111494,
  [SMALL_STATE(5267)] = 111506,
  [SMALL_STATE(5268)] = 111518,
  [SMALL_STATE(5269)] = 111528,
  [SMALL_STATE(5270)] = 111540,
  [SMALL_STATE(5271)] = 111552,
  [SMALL_STATE(5272)] = 111564,
  [SMALL_STATE(5273)] = 111576,
  [SMALL_STATE(5274)] = 111588,
  [SMALL_STATE(5275)] = 111600,
  [SMALL_STATE(5276)] = 111612,
  [SMALL_STATE(5277)] = 111624,
  [SMALL_STATE(5278)] = 111636,
  [SMALL_STATE(5279)] = 111646,
  [SMALL_STATE(5280)] = 111658,
  [SMALL_STATE(5281)] = 111670,
  [SMALL_STATE(5282)] = 111682,
  [SMALL_STATE(5283)] = 111692,
  [SMALL_STATE(5284)] = 111704,
  [SMALL_STATE(5285)] = 111714,
  [SMALL_STATE(5286)] = 111724,
  [SMALL_STATE(5287)] = 111736,
  [SMALL_STATE(5288)] = 111748,
  [SMALL_STATE(5289)] = 111758,
  [SMALL_STATE(5290)] = 111770,
  [SMALL_STATE(5291)] = 111782,
  [SMALL_STATE(5292)] = 111794,
  [SMALL_STATE(5293)] = 111806,
  [SMALL_STATE(5294)] = 111818,
  [SMALL_STATE(5295)] = 111828,
  [SMALL_STATE(5296)] = 111840,
  [SMALL_STATE(5297)] = 111852,
  [SMALL_STATE(5298)] = 111864,
  [SMALL_STATE(5299)] = 111874,
  [SMALL_STATE(5300)] = 111886,
  [SMALL_STATE(5301)] = 111896,
  [SMALL_STATE(5302)] = 111908,
  [SMALL_STATE(5303)] = 111920,
  [SMALL_STATE(5304)] = 111930,
  [SMALL_STATE(5305)] = 111940,
  [SMALL_STATE(5306)] = 111952,
  [SMALL_STATE(5307)] = 111962,
  [SMALL_STATE(5308)] = 111974,
  [SMALL_STATE(5309)] = 111986,
  [SMALL_STATE(5310)] = 111998,
  [SMALL_STATE(5311)] = 112010,
  [SMALL_STATE(5312)] = 112022,
  [SMALL_STATE(5313)] = 112034,
  [SMALL_STATE(5314)] = 112044,
  [SMALL_STATE(5315)] = 112056,
  [SMALL_STATE(5316)] = 112068,
  [SMALL_STATE(5317)] = 112080,
  [SMALL_STATE(5318)] = 112092,
  [SMALL_STATE(5319)] = 112104,
  [SMALL_STATE(5320)] = 112116,
  [SMALL_STATE(5321)] = 112128,
  [SMALL_STATE(5322)] = 112140,
  [SMALL_STATE(5323)] = 112152,
  [SMALL_STATE(5324)] = 112164,
  [SMALL_STATE(5325)] = 112176,
  [SMALL_STATE(5326)] = 112188,
  [SMALL_STATE(5327)] = 112200,
  [SMALL_STATE(5328)] = 112212,
  [SMALL_STATE(5329)] = 112224,
  [SMALL_STATE(5330)] = 112236,
  [SMALL_STATE(5331)] = 112248,
  [SMALL_STATE(5332)] = 112260,
  [SMALL_STATE(5333)] = 112272,
  [SMALL_STATE(5334)] = 112284,
  [SMALL_STATE(5335)] = 112296,
  [SMALL_STATE(5336)] = 112308,
  [SMALL_STATE(5337)] = 112320,
  [SMALL_STATE(5338)] = 112332,
  [SMALL_STATE(5339)] = 112344,
  [SMALL_STATE(5340)] = 112356,
  [SMALL_STATE(5341)] = 112366,
  [SMALL_STATE(5342)] = 112378,
  [SMALL_STATE(5343)] = 112388,
  [SMALL_STATE(5344)] = 112400,
  [SMALL_STATE(5345)] = 112412,
  [SMALL_STATE(5346)] = 112424,
  [SMALL_STATE(5347)] = 112436,
  [SMALL_STATE(5348)] = 112446,
  [SMALL_STATE(5349)] = 112458,
  [SMALL_STATE(5350)] = 112470,
  [SMALL_STATE(5351)] = 112482,
  [SMALL_STATE(5352)] = 112494,
  [SMALL_STATE(5353)] = 112506,
  [SMALL_STATE(5354)] = 112518,
  [SMALL_STATE(5355)] = 112528,
  [SMALL_STATE(5356)] = 112540,
  [SMALL_STATE(5357)] = 112550,
  [SMALL_STATE(5358)] = 112562,
  [SMALL_STATE(5359)] = 112574,
  [SMALL_STATE(5360)] = 112586,
  [SMALL_STATE(5361)] = 112598,
  [SMALL_STATE(5362)] = 112608,
  [SMALL_STATE(5363)] = 112620,
  [SMALL_STATE(5364)] = 112632,
  [SMALL_STATE(5365)] = 112644,
  [SMALL_STATE(5366)] = 112656,
  [SMALL_STATE(5367)] = 112668,
  [SMALL_STATE(5368)] = 112680,
  [SMALL_STATE(5369)] = 112690,
  [SMALL_STATE(5370)] = 112702,
  [SMALL_STATE(5371)] = 112714,
  [SMALL_STATE(5372)] = 112726,
  [SMALL_STATE(5373)] = 112738,
  [SMALL_STATE(5374)] = 112750,
  [SMALL_STATE(5375)] = 112762,
  [SMALL_STATE(5376)] = 112774,
  [SMALL_STATE(5377)] = 112786,
  [SMALL_STATE(5378)] = 112798,
  [SMALL_STATE(5379)] = 112810,
  [SMALL_STATE(5380)] = 112820,
  [SMALL_STATE(5381)] = 112832,
  [SMALL_STATE(5382)] = 112844,
  [SMALL_STATE(5383)] = 112856,
  [SMALL_STATE(5384)] = 112868,
  [SMALL_STATE(5385)] = 112878,
  [SMALL_STATE(5386)] = 112890,
  [SMALL_STATE(5387)] = 112900,
  [SMALL_STATE(5388)] = 112912,
  [SMALL_STATE(5389)] = 112924,
  [SMALL_STATE(5390)] = 112936,
  [SMALL_STATE(5391)] = 112948,
  [SMALL_STATE(5392)] = 112960,
  [SMALL_STATE(5393)] = 112970,
  [SMALL_STATE(5394)] = 112980,
  [SMALL_STATE(5395)] = 112992,
  [SMALL_STATE(5396)] = 113004,
  [SMALL_STATE(5397)] = 113016,
  [SMALL_STATE(5398)] = 113026,
  [SMALL_STATE(5399)] = 113038,
  [SMALL_STATE(5400)] = 113050,
  [SMALL_STATE(5401)] = 113062,
  [SMALL_STATE(5402)] = 113072,
  [SMALL_STATE(5403)] = 113084,
  [SMALL_STATE(5404)] = 113096,
  [SMALL_STATE(5405)] = 113108,
  [SMALL_STATE(5406)] = 113120,
  [SMALL_STATE(5407)] = 113132,
  [SMALL_STATE(5408)] = 113144,
  [SMALL_STATE(5409)] = 113156,
  [SMALL_STATE(5410)] = 113166,
  [SMALL_STATE(5411)] = 113178,
  [SMALL_STATE(5412)] = 113190,
  [SMALL_STATE(5413)] = 113202,
  [SMALL_STATE(5414)] = 113214,
  [SMALL_STATE(5415)] = 113226,
  [SMALL_STATE(5416)] = 113238,
  [SMALL_STATE(5417)] = 113250,
  [SMALL_STATE(5418)] = 113262,
  [SMALL_STATE(5419)] = 113274,
  [SMALL_STATE(5420)] = 113286,
  [SMALL_STATE(5421)] = 113298,
  [SMALL_STATE(5422)] = 113310,
  [SMALL_STATE(5423)] = 113322,
  [SMALL_STATE(5424)] = 113334,
  [SMALL_STATE(5425)] = 113346,
  [SMALL_STATE(5426)] = 113356,
  [SMALL_STATE(5427)] = 113366,
  [SMALL_STATE(5428)] = 113378,
  [SMALL_STATE(5429)] = 113390,
  [SMALL_STATE(5430)] = 113402,
  [SMALL_STATE(5431)] = 113414,
  [SMALL_STATE(5432)] = 113426,
  [SMALL_STATE(5433)] = 113438,
  [SMALL_STATE(5434)] = 113450,
  [SMALL_STATE(5435)] = 113462,
  [SMALL_STATE(5436)] = 113474,
  [SMALL_STATE(5437)] = 113486,
  [SMALL_STATE(5438)] = 113498,
  [SMALL_STATE(5439)] = 113508,
  [SMALL_STATE(5440)] = 113518,
  [SMALL_STATE(5441)] = 113530,
  [SMALL_STATE(5442)] = 113542,
  [SMALL_STATE(5443)] = 113554,
  [SMALL_STATE(5444)] = 113566,
  [SMALL_STATE(5445)] = 113576,
  [SMALL_STATE(5446)] = 113588,
  [SMALL_STATE(5447)] = 113600,
  [SMALL_STATE(5448)] = 113612,
  [SMALL_STATE(5449)] = 113624,
  [SMALL_STATE(5450)] = 113636,
  [SMALL_STATE(5451)] = 113648,
  [SMALL_STATE(5452)] = 113660,
  [SMALL_STATE(5453)] = 113670,
  [SMALL_STATE(5454)] = 113682,
  [SMALL_STATE(5455)] = 113694,
  [SMALL_STATE(5456)] = 113706,
  [SMALL_STATE(5457)] = 113718,
  [SMALL_STATE(5458)] = 113730,
  [SMALL_STATE(5459)] = 113740,
  [SMALL_STATE(5460)] = 113752,
  [SMALL_STATE(5461)] = 113762,
  [SMALL_STATE(5462)] = 113774,
  [SMALL_STATE(5463)] = 113786,
  [SMALL_STATE(5464)] = 113798,
  [SMALL_STATE(5465)] = 113810,
  [SMALL_STATE(5466)] = 113822,
  [SMALL_STATE(5467)] = 113834,
  [SMALL_STATE(5468)] = 113844,
  [SMALL_STATE(5469)] = 113856,
  [SMALL_STATE(5470)] = 113868,
  [SMALL_STATE(5471)] = 113880,
  [SMALL_STATE(5472)] = 113892,
  [SMALL_STATE(5473)] = 113904,
  [SMALL_STATE(5474)] = 113916,
  [SMALL_STATE(5475)] = 113928,
  [SMALL_STATE(5476)] = 113940,
  [SMALL_STATE(5477)] = 113952,
  [SMALL_STATE(5478)] = 113964,
  [SMALL_STATE(5479)] = 113976,
  [SMALL_STATE(5480)] = 113988,
  [SMALL_STATE(5481)] = 113998,
  [SMALL_STATE(5482)] = 114010,
  [SMALL_STATE(5483)] = 114022,
  [SMALL_STATE(5484)] = 114034,
  [SMALL_STATE(5485)] = 114046,
  [SMALL_STATE(5486)] = 114058,
  [SMALL_STATE(5487)] = 114070,
  [SMALL_STATE(5488)] = 114082,
  [SMALL_STATE(5489)] = 114094,
  [SMALL_STATE(5490)] = 114106,
  [SMALL_STATE(5491)] = 114118,
  [SMALL_STATE(5492)] = 114130,
  [SMALL_STATE(5493)] = 114140,
  [SMALL_STATE(5494)] = 114152,
  [SMALL_STATE(5495)] = 114164,
  [SMALL_STATE(5496)] = 114176,
  [SMALL_STATE(5497)] = 114188,
  [SMALL_STATE(5498)] = 114200,
  [SMALL_STATE(5499)] = 114212,
  [SMALL_STATE(5500)] = 114224,
  [SMALL_STATE(5501)] = 114236,
  [SMALL_STATE(5502)] = 114246,
  [SMALL_STATE(5503)] = 114258,
  [SMALL_STATE(5504)] = 114268,
  [SMALL_STATE(5505)] = 114278,
  [SMALL_STATE(5506)] = 114290,
  [SMALL_STATE(5507)] = 114302,
  [SMALL_STATE(5508)] = 114314,
  [SMALL_STATE(5509)] = 114326,
  [SMALL_STATE(5510)] = 114338,
  [SMALL_STATE(5511)] = 114350,
  [SMALL_STATE(5512)] = 114362,
  [SMALL_STATE(5513)] = 114374,
  [SMALL_STATE(5514)] = 114386,
  [SMALL_STATE(5515)] = 114398,
  [SMALL_STATE(5516)] = 114410,
  [SMALL_STATE(5517)] = 114422,
  [SMALL_STATE(5518)] = 114432,
  [SMALL_STATE(5519)] = 114444,
  [SMALL_STATE(5520)] = 114456,
  [SMALL_STATE(5521)] = 114468,
  [SMALL_STATE(5522)] = 114480,
  [SMALL_STATE(5523)] = 114492,
  [SMALL_STATE(5524)] = 114504,
  [SMALL_STATE(5525)] = 114516,
  [SMALL_STATE(5526)] = 114526,
  [SMALL_STATE(5527)] = 114536,
  [SMALL_STATE(5528)] = 114546,
  [SMALL_STATE(5529)] = 114558,
  [SMALL_STATE(5530)] = 114570,
  [SMALL_STATE(5531)] = 114582,
  [SMALL_STATE(5532)] = 114594,
  [SMALL_STATE(5533)] = 114606,
  [SMALL_STATE(5534)] = 114618,
  [SMALL_STATE(5535)] = 114630,
  [SMALL_STATE(5536)] = 114642,
  [SMALL_STATE(5537)] = 114654,
  [SMALL_STATE(5538)] = 114666,
  [SMALL_STATE(5539)] = 114676,
  [SMALL_STATE(5540)] = 114688,
  [SMALL_STATE(5541)] = 114700,
  [SMALL_STATE(5542)] = 114712,
  [SMALL_STATE(5543)] = 114724,
  [SMALL_STATE(5544)] = 114736,
  [SMALL_STATE(5545)] = 114748,
  [SMALL_STATE(5546)] = 114760,
  [SMALL_STATE(5547)] = 114770,
  [SMALL_STATE(5548)] = 114782,
  [SMALL_STATE(5549)] = 114794,
  [SMALL_STATE(5550)] = 114806,
  [SMALL_STATE(5551)] = 114818,
  [SMALL_STATE(5552)] = 114830,
  [SMALL_STATE(5553)] = 114842,
  [SMALL_STATE(5554)] = 114854,
  [SMALL_STATE(5555)] = 114866,
  [SMALL_STATE(5556)] = 114876,
  [SMALL_STATE(5557)] = 114888,
  [SMALL_STATE(5558)] = 114900,
  [SMALL_STATE(5559)] = 114912,
  [SMALL_STATE(5560)] = 114924,
  [SMALL_STATE(5561)] = 114936,
  [SMALL_STATE(5562)] = 114948,
  [SMALL_STATE(5563)] = 114960,
  [SMALL_STATE(5564)] = 114972,
  [SMALL_STATE(5565)] = 114982,
  [SMALL_STATE(5566)] = 114994,
  [SMALL_STATE(5567)] = 115006,
  [SMALL_STATE(5568)] = 115018,
  [SMALL_STATE(5569)] = 115030,
  [SMALL_STATE(5570)] = 115042,
  [SMALL_STATE(5571)] = 115054,
  [SMALL_STATE(5572)] = 115066,
  [SMALL_STATE(5573)] = 115078,
  [SMALL_STATE(5574)] = 115090,
  [SMALL_STATE(5575)] = 115100,
  [SMALL_STATE(5576)] = 115112,
  [SMALL_STATE(5577)] = 115124,
  [SMALL_STATE(5578)] = 115136,
  [SMALL_STATE(5579)] = 115148,
  [SMALL_STATE(5580)] = 115158,
  [SMALL_STATE(5581)] = 115168,
  [SMALL_STATE(5582)] = 115180,
  [SMALL_STATE(5583)] = 115192,
  [SMALL_STATE(5584)] = 115204,
  [SMALL_STATE(5585)] = 115214,
  [SMALL_STATE(5586)] = 115226,
  [SMALL_STATE(5587)] = 115238,
  [SMALL_STATE(5588)] = 115250,
  [SMALL_STATE(5589)] = 115260,
  [SMALL_STATE(5590)] = 115270,
  [SMALL_STATE(5591)] = 115282,
  [SMALL_STATE(5592)] = 115294,
  [SMALL_STATE(5593)] = 115306,
  [SMALL_STATE(5594)] = 115316,
  [SMALL_STATE(5595)] = 115328,
  [SMALL_STATE(5596)] = 115338,
  [SMALL_STATE(5597)] = 115348,
  [SMALL_STATE(5598)] = 115360,
  [SMALL_STATE(5599)] = 115372,
  [SMALL_STATE(5600)] = 115384,
  [SMALL_STATE(5601)] = 115396,
  [SMALL_STATE(5602)] = 115408,
  [SMALL_STATE(5603)] = 115418,
  [SMALL_STATE(5604)] = 115430,
  [SMALL_STATE(5605)] = 115442,
  [SMALL_STATE(5606)] = 115454,
  [SMALL_STATE(5607)] = 115466,
  [SMALL_STATE(5608)] = 115478,
  [SMALL_STATE(5609)] = 115488,
  [SMALL_STATE(5610)] = 115498,
  [SMALL_STATE(5611)] = 115510,
  [SMALL_STATE(5612)] = 115520,
  [SMALL_STATE(5613)] = 115532,
  [SMALL_STATE(5614)] = 115544,
  [SMALL_STATE(5615)] = 115554,
  [SMALL_STATE(5616)] = 115566,
  [SMALL_STATE(5617)] = 115578,
  [SMALL_STATE(5618)] = 115590,
  [SMALL_STATE(5619)] = 115602,
  [SMALL_STATE(5620)] = 115614,
  [SMALL_STATE(5621)] = 115624,
  [SMALL_STATE(5622)] = 115636,
  [SMALL_STATE(5623)] = 115646,
  [SMALL_STATE(5624)] = 115656,
  [SMALL_STATE(5625)] = 115668,
  [SMALL_STATE(5626)] = 115677,
  [SMALL_STATE(5627)] = 115686,
  [SMALL_STATE(5628)] = 115695,
  [SMALL_STATE(5629)] = 115704,
  [SMALL_STATE(5630)] = 115713,
  [SMALL_STATE(5631)] = 115722,
  [SMALL_STATE(5632)] = 115731,
  [SMALL_STATE(5633)] = 115740,
  [SMALL_STATE(5634)] = 115749,
  [SMALL_STATE(5635)] = 115758,
  [SMALL_STATE(5636)] = 115767,
  [SMALL_STATE(5637)] = 115776,
  [SMALL_STATE(5638)] = 115785,
  [SMALL_STATE(5639)] = 115794,
  [SMALL_STATE(5640)] = 115803,
  [SMALL_STATE(5641)] = 115812,
  [SMALL_STATE(5642)] = 115821,
  [SMALL_STATE(5643)] = 115830,
  [SMALL_STATE(5644)] = 115839,
  [SMALL_STATE(5645)] = 115848,
  [SMALL_STATE(5646)] = 115857,
  [SMALL_STATE(5647)] = 115866,
  [SMALL_STATE(5648)] = 115875,
  [SMALL_STATE(5649)] = 115884,
  [SMALL_STATE(5650)] = 115893,
  [SMALL_STATE(5651)] = 115902,
  [SMALL_STATE(5652)] = 115911,
  [SMALL_STATE(5653)] = 115920,
  [SMALL_STATE(5654)] = 115929,
  [SMALL_STATE(5655)] = 115938,
  [SMALL_STATE(5656)] = 115947,
  [SMALL_STATE(5657)] = 115956,
  [SMALL_STATE(5658)] = 115965,
  [SMALL_STATE(5659)] = 115974,
  [SMALL_STATE(5660)] = 115983,
  [SMALL_STATE(5661)] = 115992,
  [SMALL_STATE(5662)] = 116001,
  [SMALL_STATE(5663)] = 116010,
  [SMALL_STATE(5664)] = 116019,
  [SMALL_STATE(5665)] = 116028,
  [SMALL_STATE(5666)] = 116037,
  [SMALL_STATE(5667)] = 116046,
  [SMALL_STATE(5668)] = 116055,
  [SMALL_STATE(5669)] = 116064,
  [SMALL_STATE(5670)] = 116073,
  [SMALL_STATE(5671)] = 116082,
  [SMALL_STATE(5672)] = 116091,
  [SMALL_STATE(5673)] = 116100,
  [SMALL_STATE(5674)] = 116109,
  [SMALL_STATE(5675)] = 116118,
  [SMALL_STATE(5676)] = 116127,
  [SMALL_STATE(5677)] = 116136,
  [SMALL_STATE(5678)] = 116145,
  [SMALL_STATE(5679)] = 116154,
  [SMALL_STATE(5680)] = 116163,
  [SMALL_STATE(5681)] = 116172,
  [SMALL_STATE(5682)] = 116181,
  [SMALL_STATE(5683)] = 116190,
  [SMALL_STATE(5684)] = 116199,
  [SMALL_STATE(5685)] = 116208,
  [SMALL_STATE(5686)] = 116217,
  [SMALL_STATE(5687)] = 116226,
  [SMALL_STATE(5688)] = 116235,
  [SMALL_STATE(5689)] = 116244,
  [SMALL_STATE(5690)] = 116253,
  [SMALL_STATE(5691)] = 116262,
  [SMALL_STATE(5692)] = 116271,
  [SMALL_STATE(5693)] = 116280,
  [SMALL_STATE(5694)] = 116289,
  [SMALL_STATE(5695)] = 116298,
  [SMALL_STATE(5696)] = 116307,
  [SMALL_STATE(5697)] = 116316,
  [SMALL_STATE(5698)] = 116325,
  [SMALL_STATE(5699)] = 116334,
  [SMALL_STATE(5700)] = 116343,
  [SMALL_STATE(5701)] = 116352,
  [SMALL_STATE(5702)] = 116361,
  [SMALL_STATE(5703)] = 116370,
  [SMALL_STATE(5704)] = 116379,
  [SMALL_STATE(5705)] = 116388,
  [SMALL_STATE(5706)] = 116397,
  [SMALL_STATE(5707)] = 116406,
  [SMALL_STATE(5708)] = 116415,
  [SMALL_STATE(5709)] = 116424,
  [SMALL_STATE(5710)] = 116433,
  [SMALL_STATE(5711)] = 116442,
  [SMALL_STATE(5712)] = 116451,
  [SMALL_STATE(5713)] = 116460,
  [SMALL_STATE(5714)] = 116469,
  [SMALL_STATE(5715)] = 116478,
  [SMALL_STATE(5716)] = 116487,
  [SMALL_STATE(5717)] = 116496,
  [SMALL_STATE(5718)] = 116505,
  [SMALL_STATE(5719)] = 116514,
  [SMALL_STATE(5720)] = 116523,
  [SMALL_STATE(5721)] = 116532,
  [SMALL_STATE(5722)] = 116541,
  [SMALL_STATE(5723)] = 116550,
  [SMALL_STATE(5724)] = 116559,
  [SMALL_STATE(5725)] = 116568,
  [SMALL_STATE(5726)] = 116577,
  [SMALL_STATE(5727)] = 116586,
  [SMALL_STATE(5728)] = 116595,
  [SMALL_STATE(5729)] = 116604,
  [SMALL_STATE(5730)] = 116613,
  [SMALL_STATE(5731)] = 116622,
  [SMALL_STATE(5732)] = 116631,
  [SMALL_STATE(5733)] = 116640,
  [SMALL_STATE(5734)] = 116649,
  [SMALL_STATE(5735)] = 116658,
  [SMALL_STATE(5736)] = 116667,
  [SMALL_STATE(5737)] = 116676,
  [SMALL_STATE(5738)] = 116685,
  [SMALL_STATE(5739)] = 116694,
  [SMALL_STATE(5740)] = 116703,
  [SMALL_STATE(5741)] = 116712,
  [SMALL_STATE(5742)] = 116721,
  [SMALL_STATE(5743)] = 116730,
  [SMALL_STATE(5744)] = 116739,
  [SMALL_STATE(5745)] = 116748,
  [SMALL_STATE(5746)] = 116757,
  [SMALL_STATE(5747)] = 116766,
  [SMALL_STATE(5748)] = 116775,
  [SMALL_STATE(5749)] = 116784,
  [SMALL_STATE(5750)] = 116793,
  [SMALL_STATE(5751)] = 116802,
  [SMALL_STATE(5752)] = 116811,
  [SMALL_STATE(5753)] = 116820,
  [SMALL_STATE(5754)] = 116829,
  [SMALL_STATE(5755)] = 116838,
  [SMALL_STATE(5756)] = 116847,
  [SMALL_STATE(5757)] = 116856,
  [SMALL_STATE(5758)] = 116865,
  [SMALL_STATE(5759)] = 116874,
  [SMALL_STATE(5760)] = 116883,
  [SMALL_STATE(5761)] = 116892,
  [SMALL_STATE(5762)] = 116901,
  [SMALL_STATE(5763)] = 116910,
  [SMALL_STATE(5764)] = 116919,
  [SMALL_STATE(5765)] = 116928,
  [SMALL_STATE(5766)] = 116937,
  [SMALL_STATE(5767)] = 116946,
  [SMALL_STATE(5768)] = 116955,
  [SMALL_STATE(5769)] = 116964,
  [SMALL_STATE(5770)] = 116973,
  [SMALL_STATE(5771)] = 116982,
  [SMALL_STATE(5772)] = 116991,
  [SMALL_STATE(5773)] = 117000,
  [SMALL_STATE(5774)] = 117009,
  [SMALL_STATE(5775)] = 117018,
  [SMALL_STATE(5776)] = 117027,
  [SMALL_STATE(5777)] = 117036,
  [SMALL_STATE(5778)] = 117045,
  [SMALL_STATE(5779)] = 117054,
  [SMALL_STATE(5780)] = 117063,
  [SMALL_STATE(5781)] = 117072,
  [SMALL_STATE(5782)] = 117081,
  [SMALL_STATE(5783)] = 117090,
  [SMALL_STATE(5784)] = 117099,
  [SMALL_STATE(5785)] = 117108,
  [SMALL_STATE(5786)] = 117117,
  [SMALL_STATE(5787)] = 117126,
  [SMALL_STATE(5788)] = 117135,
  [SMALL_STATE(5789)] = 117144,
  [SMALL_STATE(5790)] = 117153,
  [SMALL_STATE(5791)] = 117162,
  [SMALL_STATE(5792)] = 117171,
  [SMALL_STATE(5793)] = 117180,
  [SMALL_STATE(5794)] = 117189,
  [SMALL_STATE(5795)] = 117198,
  [SMALL_STATE(5796)] = 117207,
  [SMALL_STATE(5797)] = 117216,
  [SMALL_STATE(5798)] = 117225,
  [SMALL_STATE(5799)] = 117234,
  [SMALL_STATE(5800)] = 117243,
  [SMALL_STATE(5801)] = 117252,
  [SMALL_STATE(5802)] = 117261,
  [SMALL_STATE(5803)] = 117270,
  [SMALL_STATE(5804)] = 117279,
  [SMALL_STATE(5805)] = 117288,
  [SMALL_STATE(5806)] = 117297,
  [SMALL_STATE(5807)] = 117306,
  [SMALL_STATE(5808)] = 117315,
  [SMALL_STATE(5809)] = 117324,
  [SMALL_STATE(5810)] = 117333,
  [SMALL_STATE(5811)] = 117342,
  [SMALL_STATE(5812)] = 117351,
  [SMALL_STATE(5813)] = 117360,
  [SMALL_STATE(5814)] = 117369,
  [SMALL_STATE(5815)] = 117378,
  [SMALL_STATE(5816)] = 117387,
  [SMALL_STATE(5817)] = 117396,
  [SMALL_STATE(5818)] = 117405,
  [SMALL_STATE(5819)] = 117414,
  [SMALL_STATE(5820)] = 117423,
  [SMALL_STATE(5821)] = 117432,
  [SMALL_STATE(5822)] = 117441,
  [SMALL_STATE(5823)] = 117450,
  [SMALL_STATE(5824)] = 117459,
  [SMALL_STATE(5825)] = 117468,
  [SMALL_STATE(5826)] = 117477,
  [SMALL_STATE(5827)] = 117486,
  [SMALL_STATE(5828)] = 117495,
  [SMALL_STATE(5829)] = 117504,
  [SMALL_STATE(5830)] = 117513,
  [SMALL_STATE(5831)] = 117522,
  [SMALL_STATE(5832)] = 117531,
  [SMALL_STATE(5833)] = 117540,
  [SMALL_STATE(5834)] = 117549,
  [SMALL_STATE(5835)] = 117558,
  [SMALL_STATE(5836)] = 117567,
  [SMALL_STATE(5837)] = 117576,
  [SMALL_STATE(5838)] = 117585,
  [SMALL_STATE(5839)] = 117594,
  [SMALL_STATE(5840)] = 117603,
  [SMALL_STATE(5841)] = 117612,
  [SMALL_STATE(5842)] = 117621,
  [SMALL_STATE(5843)] = 117630,
  [SMALL_STATE(5844)] = 117639,
  [SMALL_STATE(5845)] = 117648,
  [SMALL_STATE(5846)] = 117657,
  [SMALL_STATE(5847)] = 117666,
  [SMALL_STATE(5848)] = 117675,
  [SMALL_STATE(5849)] = 117684,
  [SMALL_STATE(5850)] = 117693,
  [SMALL_STATE(5851)] = 117702,
  [SMALL_STATE(5852)] = 117711,
  [SMALL_STATE(5853)] = 117720,
  [SMALL_STATE(5854)] = 117729,
  [SMALL_STATE(5855)] = 117738,
  [SMALL_STATE(5856)] = 117747,
  [SMALL_STATE(5857)] = 117756,
  [SMALL_STATE(5858)] = 117765,
  [SMALL_STATE(5859)] = 117774,
  [SMALL_STATE(5860)] = 117783,
  [SMALL_STATE(5861)] = 117792,
  [SMALL_STATE(5862)] = 117801,
  [SMALL_STATE(5863)] = 117810,
  [SMALL_STATE(5864)] = 117819,
  [SMALL_STATE(5865)] = 117828,
  [SMALL_STATE(5866)] = 117837,
  [SMALL_STATE(5867)] = 117846,
  [SMALL_STATE(5868)] = 117855,
  [SMALL_STATE(5869)] = 117864,
  [SMALL_STATE(5870)] = 117873,
  [SMALL_STATE(5871)] = 117882,
  [SMALL_STATE(5872)] = 117891,
  [SMALL_STATE(5873)] = 117900,
  [SMALL_STATE(5874)] = 117909,
  [SMALL_STATE(5875)] = 117918,
  [SMALL_STATE(5876)] = 117927,
  [SMALL_STATE(5877)] = 117936,
  [SMALL_STATE(5878)] = 117945,
  [SMALL_STATE(5879)] = 117954,
  [SMALL_STATE(5880)] = 117963,
  [SMALL_STATE(5881)] = 117972,
  [SMALL_STATE(5882)] = 117981,
  [SMALL_STATE(5883)] = 117990,
  [SMALL_STATE(5884)] = 117999,
  [SMALL_STATE(5885)] = 118008,
  [SMALL_STATE(5886)] = 118017,
  [SMALL_STATE(5887)] = 118026,
  [SMALL_STATE(5888)] = 118035,
  [SMALL_STATE(5889)] = 118044,
  [SMALL_STATE(5890)] = 118053,
  [SMALL_STATE(5891)] = 118062,
  [SMALL_STATE(5892)] = 118071,
  [SMALL_STATE(5893)] = 118080,
  [SMALL_STATE(5894)] = 118089,
  [SMALL_STATE(5895)] = 118098,
  [SMALL_STATE(5896)] = 118107,
  [SMALL_STATE(5897)] = 118116,
  [SMALL_STATE(5898)] = 118125,
  [SMALL_STATE(5899)] = 118134,
  [SMALL_STATE(5900)] = 118143,
  [SMALL_STATE(5901)] = 118152,
  [SMALL_STATE(5902)] = 118161,
  [SMALL_STATE(5903)] = 118170,
  [SMALL_STATE(5904)] = 118179,
  [SMALL_STATE(5905)] = 118188,
  [SMALL_STATE(5906)] = 118197,
  [SMALL_STATE(5907)] = 118206,
  [SMALL_STATE(5908)] = 118215,
  [SMALL_STATE(5909)] = 118224,
  [SMALL_STATE(5910)] = 118233,
  [SMALL_STATE(5911)] = 118242,
  [SMALL_STATE(5912)] = 118251,
  [SMALL_STATE(5913)] = 118260,
  [SMALL_STATE(5914)] = 118269,
  [SMALL_STATE(5915)] = 118278,
  [SMALL_STATE(5916)] = 118287,
  [SMALL_STATE(5917)] = 118296,
  [SMALL_STATE(5918)] = 118305,
  [SMALL_STATE(5919)] = 118314,
  [SMALL_STATE(5920)] = 118323,
  [SMALL_STATE(5921)] = 118332,
  [SMALL_STATE(5922)] = 118341,
  [SMALL_STATE(5923)] = 118350,
  [SMALL_STATE(5924)] = 118359,
  [SMALL_STATE(5925)] = 118368,
  [SMALL_STATE(5926)] = 118377,
  [SMALL_STATE(5927)] = 118386,
  [SMALL_STATE(5928)] = 118395,
  [SMALL_STATE(5929)] = 118404,
  [SMALL_STATE(5930)] = 118413,
  [SMALL_STATE(5931)] = 118422,
  [SMALL_STATE(5932)] = 118431,
  [SMALL_STATE(5933)] = 118440,
  [SMALL_STATE(5934)] = 118449,
  [SMALL_STATE(5935)] = 118458,
  [SMALL_STATE(5936)] = 118467,
  [SMALL_STATE(5937)] = 118476,
  [SMALL_STATE(5938)] = 118485,
  [SMALL_STATE(5939)] = 118494,
  [SMALL_STATE(5940)] = 118503,
  [SMALL_STATE(5941)] = 118512,
  [SMALL_STATE(5942)] = 118521,
  [SMALL_STATE(5943)] = 118530,
  [SMALL_STATE(5944)] = 118539,
  [SMALL_STATE(5945)] = 118548,
  [SMALL_STATE(5946)] = 118557,
  [SMALL_STATE(5947)] = 118566,
  [SMALL_STATE(5948)] = 118575,
  [SMALL_STATE(5949)] = 118584,
  [SMALL_STATE(5950)] = 118593,
  [SMALL_STATE(5951)] = 118602,
  [SMALL_STATE(5952)] = 118611,
  [SMALL_STATE(5953)] = 118620,
  [SMALL_STATE(5954)] = 118629,
  [SMALL_STATE(5955)] = 118638,
  [SMALL_STATE(5956)] = 118647,
  [SMALL_STATE(5957)] = 118656,
  [SMALL_STATE(5958)] = 118665,
  [SMALL_STATE(5959)] = 118674,
  [SMALL_STATE(5960)] = 118683,
  [SMALL_STATE(5961)] = 118692,
  [SMALL_STATE(5962)] = 118701,
  [SMALL_STATE(5963)] = 118710,
  [SMALL_STATE(5964)] = 118719,
  [SMALL_STATE(5965)] = 118728,
  [SMALL_STATE(5966)] = 118737,
  [SMALL_STATE(5967)] = 118746,
  [SMALL_STATE(5968)] = 118755,
  [SMALL_STATE(5969)] = 118764,
  [SMALL_STATE(5970)] = 118773,
  [SMALL_STATE(5971)] = 118782,
  [SMALL_STATE(5972)] = 118791,
  [SMALL_STATE(5973)] = 118800,
  [SMALL_STATE(5974)] = 118809,
  [SMALL_STATE(5975)] = 118818,
  [SMALL_STATE(5976)] = 118827,
  [SMALL_STATE(5977)] = 118836,
  [SMALL_STATE(5978)] = 118845,
  [SMALL_STATE(5979)] = 118854,
  [SMALL_STATE(5980)] = 118863,
  [SMALL_STATE(5981)] = 118872,
  [SMALL_STATE(5982)] = 118881,
  [SMALL_STATE(5983)] = 118890,
  [SMALL_STATE(5984)] = 118899,
  [SMALL_STATE(5985)] = 118908,
  [SMALL_STATE(5986)] = 118917,
  [SMALL_STATE(5987)] = 118926,
  [SMALL_STATE(5988)] = 118935,
  [SMALL_STATE(5989)] = 118944,
  [SMALL_STATE(5990)] = 118953,
  [SMALL_STATE(5991)] = 118962,
  [SMALL_STATE(5992)] = 118971,
  [SMALL_STATE(5993)] = 118980,
  [SMALL_STATE(5994)] = 118989,
  [SMALL_STATE(5995)] = 118998,
  [SMALL_STATE(5996)] = 119007,
  [SMALL_STATE(5997)] = 119016,
  [SMALL_STATE(5998)] = 119025,
  [SMALL_STATE(5999)] = 119034,
  [SMALL_STATE(6000)] = 119043,
  [SMALL_STATE(6001)] = 119052,
  [SMALL_STATE(6002)] = 119061,
  [SMALL_STATE(6003)] = 119070,
  [SMALL_STATE(6004)] = 119079,
  [SMALL_STATE(6005)] = 119088,
  [SMALL_STATE(6006)] = 119097,
  [SMALL_STATE(6007)] = 119106,
  [SMALL_STATE(6008)] = 119115,
  [SMALL_STATE(6009)] = 119124,
  [SMALL_STATE(6010)] = 119133,
  [SMALL_STATE(6011)] = 119142,
  [SMALL_STATE(6012)] = 119151,
  [SMALL_STATE(6013)] = 119160,
  [SMALL_STATE(6014)] = 119169,
  [SMALL_STATE(6015)] = 119178,
  [SMALL_STATE(6016)] = 119187,
  [SMALL_STATE(6017)] = 119196,
  [SMALL_STATE(6018)] = 119205,
  [SMALL_STATE(6019)] = 119214,
  [SMALL_STATE(6020)] = 119223,
  [SMALL_STATE(6021)] = 119232,
  [SMALL_STATE(6022)] = 119241,
  [SMALL_STATE(6023)] = 119250,
  [SMALL_STATE(6024)] = 119259,
  [SMALL_STATE(6025)] = 119268,
  [SMALL_STATE(6026)] = 119277,
  [SMALL_STATE(6027)] = 119286,
  [SMALL_STATE(6028)] = 119295,
  [SMALL_STATE(6029)] = 119304,
  [SMALL_STATE(6030)] = 119313,
  [SMALL_STATE(6031)] = 119322,
  [SMALL_STATE(6032)] = 119331,
  [SMALL_STATE(6033)] = 119340,
  [SMALL_STATE(6034)] = 119349,
  [SMALL_STATE(6035)] = 119358,
  [SMALL_STATE(6036)] = 119367,
  [SMALL_STATE(6037)] = 119376,
  [SMALL_STATE(6038)] = 119385,
  [SMALL_STATE(6039)] = 119394,
  [SMALL_STATE(6040)] = 119403,
  [SMALL_STATE(6041)] = 119412,
  [SMALL_STATE(6042)] = 119421,
  [SMALL_STATE(6043)] = 119430,
  [SMALL_STATE(6044)] = 119439,
  [SMALL_STATE(6045)] = 119448,
  [SMALL_STATE(6046)] = 119457,
  [SMALL_STATE(6047)] = 119466,
  [SMALL_STATE(6048)] = 119475,
  [SMALL_STATE(6049)] = 119484,
  [SMALL_STATE(6050)] = 119493,
  [SMALL_STATE(6051)] = 119502,
  [SMALL_STATE(6052)] = 119511,
  [SMALL_STATE(6053)] = 119520,
  [SMALL_STATE(6054)] = 119529,
  [SMALL_STATE(6055)] = 119538,
  [SMALL_STATE(6056)] = 119547,
  [SMALL_STATE(6057)] = 119556,
  [SMALL_STATE(6058)] = 119565,
  [SMALL_STATE(6059)] = 119574,
  [SMALL_STATE(6060)] = 119583,
  [SMALL_STATE(6061)] = 119592,
  [SMALL_STATE(6062)] = 119601,
  [SMALL_STATE(6063)] = 119610,
  [SMALL_STATE(6064)] = 119619,
  [SMALL_STATE(6065)] = 119628,
  [SMALL_STATE(6066)] = 119637,
  [SMALL_STATE(6067)] = 119646,
  [SMALL_STATE(6068)] = 119655,
  [SMALL_STATE(6069)] = 119664,
  [SMALL_STATE(6070)] = 119673,
  [SMALL_STATE(6071)] = 119682,
  [SMALL_STATE(6072)] = 119691,
  [SMALL_STATE(6073)] = 119700,
  [SMALL_STATE(6074)] = 119709,
  [SMALL_STATE(6075)] = 119718,
  [SMALL_STATE(6076)] = 119727,
  [SMALL_STATE(6077)] = 119736,
  [SMALL_STATE(6078)] = 119745,
  [SMALL_STATE(6079)] = 119754,
  [SMALL_STATE(6080)] = 119763,
  [SMALL_STATE(6081)] = 119772,
  [SMALL_STATE(6082)] = 119781,
  [SMALL_STATE(6083)] = 119790,
  [SMALL_STATE(6084)] = 119799,
  [SMALL_STATE(6085)] = 119808,
  [SMALL_STATE(6086)] = 119817,
  [SMALL_STATE(6087)] = 119826,
  [SMALL_STATE(6088)] = 119835,
  [SMALL_STATE(6089)] = 119844,
  [SMALL_STATE(6090)] = 119853,
  [SMALL_STATE(6091)] = 119862,
  [SMALL_STATE(6092)] = 119871,
  [SMALL_STATE(6093)] = 119880,
  [SMALL_STATE(6094)] = 119889,
  [SMALL_STATE(6095)] = 119898,
  [SMALL_STATE(6096)] = 119907,
  [SMALL_STATE(6097)] = 119916,
  [SMALL_STATE(6098)] = 119925,
  [SMALL_STATE(6099)] = 119934,
  [SMALL_STATE(6100)] = 119943,
  [SMALL_STATE(6101)] = 119952,
  [SMALL_STATE(6102)] = 119961,
  [SMALL_STATE(6103)] = 119970,
  [SMALL_STATE(6104)] = 119979,
  [SMALL_STATE(6105)] = 119988,
  [SMALL_STATE(6106)] = 119997,
  [SMALL_STATE(6107)] = 120006,
  [SMALL_STATE(6108)] = 120015,
  [SMALL_STATE(6109)] = 120024,
  [SMALL_STATE(6110)] = 120033,
  [SMALL_STATE(6111)] = 120042,
  [SMALL_STATE(6112)] = 120051,
  [SMALL_STATE(6113)] = 120060,
  [SMALL_STATE(6114)] = 120069,
  [SMALL_STATE(6115)] = 120078,
  [SMALL_STATE(6116)] = 120087,
  [SMALL_STATE(6117)] = 120096,
  [SMALL_STATE(6118)] = 120105,
  [SMALL_STATE(6119)] = 120114,
  [SMALL_STATE(6120)] = 120123,
  [SMALL_STATE(6121)] = 120132,
  [SMALL_STATE(6122)] = 120141,
  [SMALL_STATE(6123)] = 120150,
  [SMALL_STATE(6124)] = 120159,
  [SMALL_STATE(6125)] = 120168,
  [SMALL_STATE(6126)] = 120177,
  [SMALL_STATE(6127)] = 120186,
  [SMALL_STATE(6128)] = 120195,
  [SMALL_STATE(6129)] = 120204,
  [SMALL_STATE(6130)] = 120213,
  [SMALL_STATE(6131)] = 120222,
  [SMALL_STATE(6132)] = 120231,
  [SMALL_STATE(6133)] = 120240,
  [SMALL_STATE(6134)] = 120249,
  [SMALL_STATE(6135)] = 120258,
  [SMALL_STATE(6136)] = 120267,
  [SMALL_STATE(6137)] = 120276,
  [SMALL_STATE(6138)] = 120285,
  [SMALL_STATE(6139)] = 120294,
  [SMALL_STATE(6140)] = 120303,
  [SMALL_STATE(6141)] = 120312,
  [SMALL_STATE(6142)] = 120321,
  [SMALL_STATE(6143)] = 120330,
  [SMALL_STATE(6144)] = 120339,
  [SMALL_STATE(6145)] = 120348,
  [SMALL_STATE(6146)] = 120357,
  [SMALL_STATE(6147)] = 120366,
  [SMALL_STATE(6148)] = 120375,
  [SMALL_STATE(6149)] = 120384,
  [SMALL_STATE(6150)] = 120393,
  [SMALL_STATE(6151)] = 120402,
  [SMALL_STATE(6152)] = 120411,
  [SMALL_STATE(6153)] = 120420,
  [SMALL_STATE(6154)] = 120429,
  [SMALL_STATE(6155)] = 120438,
  [SMALL_STATE(6156)] = 120447,
  [SMALL_STATE(6157)] = 120456,
  [SMALL_STATE(6158)] = 120465,
  [SMALL_STATE(6159)] = 120474,
  [SMALL_STATE(6160)] = 120483,
  [SMALL_STATE(6161)] = 120492,
  [SMALL_STATE(6162)] = 120501,
  [SMALL_STATE(6163)] = 120510,
  [SMALL_STATE(6164)] = 120519,
  [SMALL_STATE(6165)] = 120528,
  [SMALL_STATE(6166)] = 120537,
  [SMALL_STATE(6167)] = 120546,
  [SMALL_STATE(6168)] = 120555,
  [SMALL_STATE(6169)] = 120564,
  [SMALL_STATE(6170)] = 120573,
  [SMALL_STATE(6171)] = 120582,
  [SMALL_STATE(6172)] = 120591,
  [SMALL_STATE(6173)] = 120600,
  [SMALL_STATE(6174)] = 120609,
  [SMALL_STATE(6175)] = 120618,
  [SMALL_STATE(6176)] = 120627,
  [SMALL_STATE(6177)] = 120636,
  [SMALL_STATE(6178)] = 120645,
  [SMALL_STATE(6179)] = 120654,
  [SMALL_STATE(6180)] = 120663,
  [SMALL_STATE(6181)] = 120672,
  [SMALL_STATE(6182)] = 120681,
  [SMALL_STATE(6183)] = 120690,
  [SMALL_STATE(6184)] = 120699,
  [SMALL_STATE(6185)] = 120708,
  [SMALL_STATE(6186)] = 120717,
  [SMALL_STATE(6187)] = 120726,
  [SMALL_STATE(6188)] = 120735,
  [SMALL_STATE(6189)] = 120744,
  [SMALL_STATE(6190)] = 120753,
  [SMALL_STATE(6191)] = 120762,
  [SMALL_STATE(6192)] = 120771,
  [SMALL_STATE(6193)] = 120780,
  [SMALL_STATE(6194)] = 120789,
  [SMALL_STATE(6195)] = 120798,
  [SMALL_STATE(6196)] = 120807,
  [SMALL_STATE(6197)] = 120816,
  [SMALL_STATE(6198)] = 120825,
  [SMALL_STATE(6199)] = 120834,
  [SMALL_STATE(6200)] = 120843,
  [SMALL_STATE(6201)] = 120852,
  [SMALL_STATE(6202)] = 120861,
  [SMALL_STATE(6203)] = 120870,
  [SMALL_STATE(6204)] = 120879,
  [SMALL_STATE(6205)] = 120888,
  [SMALL_STATE(6206)] = 120897,
  [SMALL_STATE(6207)] = 120906,
  [SMALL_STATE(6208)] = 120915,
  [SMALL_STATE(6209)] = 120924,
  [SMALL_STATE(6210)] = 120933,
  [SMALL_STATE(6211)] = 120942,
  [SMALL_STATE(6212)] = 120951,
  [SMALL_STATE(6213)] = 120960,
  [SMALL_STATE(6214)] = 120969,
  [SMALL_STATE(6215)] = 120978,
  [SMALL_STATE(6216)] = 120987,
  [SMALL_STATE(6217)] = 120996,
  [SMALL_STATE(6218)] = 121005,
  [SMALL_STATE(6219)] = 121014,
  [SMALL_STATE(6220)] = 121023,
  [SMALL_STATE(6221)] = 121032,
  [SMALL_STATE(6222)] = 121041,
  [SMALL_STATE(6223)] = 121050,
  [SMALL_STATE(6224)] = 121059,
  [SMALL_STATE(6225)] = 121068,
  [SMALL_STATE(6226)] = 121077,
  [SMALL_STATE(6227)] = 121086,
  [SMALL_STATE(6228)] = 121095,
  [SMALL_STATE(6229)] = 121104,
  [SMALL_STATE(6230)] = 121113,
  [SMALL_STATE(6231)] = 121122,
  [SMALL_STATE(6232)] = 121131,
  [SMALL_STATE(6233)] = 121140,
  [SMALL_STATE(6234)] = 121149,
  [SMALL_STATE(6235)] = 121158,
  [SMALL_STATE(6236)] = 121167,
  [SMALL_STATE(6237)] = 121176,
  [SMALL_STATE(6238)] = 121185,
  [SMALL_STATE(6239)] = 121194,
  [SMALL_STATE(6240)] = 121203,
  [SMALL_STATE(6241)] = 121212,
  [SMALL_STATE(6242)] = 121221,
  [SMALL_STATE(6243)] = 121230,
  [SMALL_STATE(6244)] = 121239,
  [SMALL_STATE(6245)] = 121248,
  [SMALL_STATE(6246)] = 121257,
  [SMALL_STATE(6247)] = 121266,
  [SMALL_STATE(6248)] = 121275,
  [SMALL_STATE(6249)] = 121284,
  [SMALL_STATE(6250)] = 121293,
  [SMALL_STATE(6251)] = 121302,
  [SMALL_STATE(6252)] = 121311,
  [SMALL_STATE(6253)] = 121320,
  [SMALL_STATE(6254)] = 121329,
  [SMALL_STATE(6255)] = 121338,
  [SMALL_STATE(6256)] = 121347,
  [SMALL_STATE(6257)] = 121356,
  [SMALL_STATE(6258)] = 121365,
  [SMALL_STATE(6259)] = 121374,
  [SMALL_STATE(6260)] = 121383,
  [SMALL_STATE(6261)] = 121392,
  [SMALL_STATE(6262)] = 121401,
  [SMALL_STATE(6263)] = 121410,
  [SMALL_STATE(6264)] = 121419,
  [SMALL_STATE(6265)] = 121428,
  [SMALL_STATE(6266)] = 121437,
  [SMALL_STATE(6267)] = 121446,
  [SMALL_STATE(6268)] = 121455,
  [SMALL_STATE(6269)] = 121464,
  [SMALL_STATE(6270)] = 121473,
  [SMALL_STATE(6271)] = 121482,
  [SMALL_STATE(6272)] = 121491,
  [SMALL_STATE(6273)] = 121500,
  [SMALL_STATE(6274)] = 121509,
  [SMALL_STATE(6275)] = 121518,
  [SMALL_STATE(6276)] = 121527,
  [SMALL_STATE(6277)] = 121536,
  [SMALL_STATE(6278)] = 121545,
  [SMALL_STATE(6279)] = 121554,
  [SMALL_STATE(6280)] = 121563,
  [SMALL_STATE(6281)] = 121572,
  [SMALL_STATE(6282)] = 121581,
  [SMALL_STATE(6283)] = 121590,
  [SMALL_STATE(6284)] = 121599,
  [SMALL_STATE(6285)] = 121608,
  [SMALL_STATE(6286)] = 121617,
  [SMALL_STATE(6287)] = 121626,
  [SMALL_STATE(6288)] = 121635,
  [SMALL_STATE(6289)] = 121644,
  [SMALL_STATE(6290)] = 121653,
  [SMALL_STATE(6291)] = 121662,
  [SMALL_STATE(6292)] = 121671,
  [SMALL_STATE(6293)] = 121680,
  [SMALL_STATE(6294)] = 121689,
  [SMALL_STATE(6295)] = 121698,
  [SMALL_STATE(6296)] = 121707,
  [SMALL_STATE(6297)] = 121716,
  [SMALL_STATE(6298)] = 121725,
  [SMALL_STATE(6299)] = 121734,
  [SMALL_STATE(6300)] = 121743,
  [SMALL_STATE(6301)] = 121752,
  [SMALL_STATE(6302)] = 121761,
  [SMALL_STATE(6303)] = 121770,
  [SMALL_STATE(6304)] = 121779,
  [SMALL_STATE(6305)] = 121788,
  [SMALL_STATE(6306)] = 121797,
  [SMALL_STATE(6307)] = 121806,
  [SMALL_STATE(6308)] = 121815,
  [SMALL_STATE(6309)] = 121824,
  [SMALL_STATE(6310)] = 121833,
  [SMALL_STATE(6311)] = 121842,
  [SMALL_STATE(6312)] = 121851,
  [SMALL_STATE(6313)] = 121860,
  [SMALL_STATE(6314)] = 121869,
  [SMALL_STATE(6315)] = 121878,
  [SMALL_STATE(6316)] = 121887,
  [SMALL_STATE(6317)] = 121896,
  [SMALL_STATE(6318)] = 121905,
  [SMALL_STATE(6319)] = 121914,
  [SMALL_STATE(6320)] = 121923,
  [SMALL_STATE(6321)] = 121932,
  [SMALL_STATE(6322)] = 121941,
  [SMALL_STATE(6323)] = 121950,
  [SMALL_STATE(6324)] = 121959,
  [SMALL_STATE(6325)] = 121968,
  [SMALL_STATE(6326)] = 121977,
  [SMALL_STATE(6327)] = 121986,
  [SMALL_STATE(6328)] = 121995,
  [SMALL_STATE(6329)] = 122004,
  [SMALL_STATE(6330)] = 122013,
  [SMALL_STATE(6331)] = 122022,
  [SMALL_STATE(6332)] = 122031,
  [SMALL_STATE(6333)] = 122040,
  [SMALL_STATE(6334)] = 122049,
  [SMALL_STATE(6335)] = 122058,
  [SMALL_STATE(6336)] = 122067,
  [SMALL_STATE(6337)] = 122076,
  [SMALL_STATE(6338)] = 122085,
  [SMALL_STATE(6339)] = 122094,
  [SMALL_STATE(6340)] = 122103,
  [SMALL_STATE(6341)] = 122112,
  [SMALL_STATE(6342)] = 122121,
  [SMALL_STATE(6343)] = 122130,
  [SMALL_STATE(6344)] = 122139,
  [SMALL_STATE(6345)] = 122148,
  [SMALL_STATE(6346)] = 122157,
  [SMALL_STATE(6347)] = 122166,
  [SMALL_STATE(6348)] = 122175,
  [SMALL_STATE(6349)] = 122184,
  [SMALL_STATE(6350)] = 122193,
  [SMALL_STATE(6351)] = 122202,
  [SMALL_STATE(6352)] = 122211,
  [SMALL_STATE(6353)] = 122220,
  [SMALL_STATE(6354)] = 122229,
  [SMALL_STATE(6355)] = 122238,
  [SMALL_STATE(6356)] = 122247,
  [SMALL_STATE(6357)] = 122256,
  [SMALL_STATE(6358)] = 122265,
  [SMALL_STATE(6359)] = 122274,
  [SMALL_STATE(6360)] = 122283,
  [SMALL_STATE(6361)] = 122292,
  [SMALL_STATE(6362)] = 122301,
  [SMALL_STATE(6363)] = 122310,
  [SMALL_STATE(6364)] = 122319,
  [SMALL_STATE(6365)] = 122328,
  [SMALL_STATE(6366)] = 122337,
  [SMALL_STATE(6367)] = 122346,
  [SMALL_STATE(6368)] = 122355,
  [SMALL_STATE(6369)] = 122364,
  [SMALL_STATE(6370)] = 122373,
  [SMALL_STATE(6371)] = 122382,
  [SMALL_STATE(6372)] = 122391,
  [SMALL_STATE(6373)] = 122400,
  [SMALL_STATE(6374)] = 122409,
  [SMALL_STATE(6375)] = 122418,
  [SMALL_STATE(6376)] = 122427,
  [SMALL_STATE(6377)] = 122436,
  [SMALL_STATE(6378)] = 122445,
  [SMALL_STATE(6379)] = 122454,
  [SMALL_STATE(6380)] = 122463,
  [SMALL_STATE(6381)] = 122472,
  [SMALL_STATE(6382)] = 122481,
  [SMALL_STATE(6383)] = 122490,
  [SMALL_STATE(6384)] = 122499,
  [SMALL_STATE(6385)] = 122508,
  [SMALL_STATE(6386)] = 122517,
  [SMALL_STATE(6387)] = 122526,
  [SMALL_STATE(6388)] = 122535,
  [SMALL_STATE(6389)] = 122544,
  [SMALL_STATE(6390)] = 122553,
  [SMALL_STATE(6391)] = 122562,
  [SMALL_STATE(6392)] = 122571,
  [SMALL_STATE(6393)] = 122580,
  [SMALL_STATE(6394)] = 122589,
  [SMALL_STATE(6395)] = 122598,
  [SMALL_STATE(6396)] = 122607,
  [SMALL_STATE(6397)] = 122616,
  [SMALL_STATE(6398)] = 122625,
  [SMALL_STATE(6399)] = 122634,
  [SMALL_STATE(6400)] = 122643,
  [SMALL_STATE(6401)] = 122652,
  [SMALL_STATE(6402)] = 122661,
  [SMALL_STATE(6403)] = 122670,
  [SMALL_STATE(6404)] = 122679,
  [SMALL_STATE(6405)] = 122688,
  [SMALL_STATE(6406)] = 122697,
  [SMALL_STATE(6407)] = 122706,
  [SMALL_STATE(6408)] = 122715,
  [SMALL_STATE(6409)] = 122724,
  [SMALL_STATE(6410)] = 122733,
  [SMALL_STATE(6411)] = 122742,
  [SMALL_STATE(6412)] = 122751,
  [SMALL_STATE(6413)] = 122760,
  [SMALL_STATE(6414)] = 122769,
  [SMALL_STATE(6415)] = 122778,
  [SMALL_STATE(6416)] = 122787,
  [SMALL_STATE(6417)] = 122796,
  [SMALL_STATE(6418)] = 122805,
  [SMALL_STATE(6419)] = 122814,
  [SMALL_STATE(6420)] = 122823,
  [SMALL_STATE(6421)] = 122832,
  [SMALL_STATE(6422)] = 122841,
  [SMALL_STATE(6423)] = 122850,
  [SMALL_STATE(6424)] = 122859,
  [SMALL_STATE(6425)] = 122868,
  [SMALL_STATE(6426)] = 122877,
  [SMALL_STATE(6427)] = 122886,
  [SMALL_STATE(6428)] = 122895,
  [SMALL_STATE(6429)] = 122904,
  [SMALL_STATE(6430)] = 122913,
  [SMALL_STATE(6431)] = 122922,
  [SMALL_STATE(6432)] = 122931,
  [SMALL_STATE(6433)] = 122940,
  [SMALL_STATE(6434)] = 122949,
  [SMALL_STATE(6435)] = 122958,
  [SMALL_STATE(6436)] = 122967,
  [SMALL_STATE(6437)] = 122976,
  [SMALL_STATE(6438)] = 122985,
  [SMALL_STATE(6439)] = 122994,
  [SMALL_STATE(6440)] = 123003,
  [SMALL_STATE(6441)] = 123012,
  [SMALL_STATE(6442)] = 123021,
  [SMALL_STATE(6443)] = 123030,
  [SMALL_STATE(6444)] = 123039,
  [SMALL_STATE(6445)] = 123048,
  [SMALL_STATE(6446)] = 123057,
  [SMALL_STATE(6447)] = 123066,
  [SMALL_STATE(6448)] = 123075,
  [SMALL_STATE(6449)] = 123084,
  [SMALL_STATE(6450)] = 123093,
  [SMALL_STATE(6451)] = 123102,
  [SMALL_STATE(6452)] = 123111,
  [SMALL_STATE(6453)] = 123120,
  [SMALL_STATE(6454)] = 123129,
  [SMALL_STATE(6455)] = 123138,
  [SMALL_STATE(6456)] = 123147,
  [SMALL_STATE(6457)] = 123156,
  [SMALL_STATE(6458)] = 123165,
  [SMALL_STATE(6459)] = 123174,
  [SMALL_STATE(6460)] = 123183,
  [SMALL_STATE(6461)] = 123192,
  [SMALL_STATE(6462)] = 123201,
  [SMALL_STATE(6463)] = 123210,
  [SMALL_STATE(6464)] = 123219,
  [SMALL_STATE(6465)] = 123228,
  [SMALL_STATE(6466)] = 123237,
  [SMALL_STATE(6467)] = 123246,
  [SMALL_STATE(6468)] = 123255,
  [SMALL_STATE(6469)] = 123264,
  [SMALL_STATE(6470)] = 123273,
  [SMALL_STATE(6471)] = 123282,
  [SMALL_STATE(6472)] = 123291,
  [SMALL_STATE(6473)] = 123300,
  [SMALL_STATE(6474)] = 123309,
  [SMALL_STATE(6475)] = 123318,
  [SMALL_STATE(6476)] = 123327,
  [SMALL_STATE(6477)] = 123336,
  [SMALL_STATE(6478)] = 123345,
  [SMALL_STATE(6479)] = 123354,
  [SMALL_STATE(6480)] = 123363,
  [SMALL_STATE(6481)] = 123372,
  [SMALL_STATE(6482)] = 123381,
  [SMALL_STATE(6483)] = 123390,
  [SMALL_STATE(6484)] = 123399,
  [SMALL_STATE(6485)] = 123408,
  [SMALL_STATE(6486)] = 123417,
  [SMALL_STATE(6487)] = 123426,
  [SMALL_STATE(6488)] = 123435,
  [SMALL_STATE(6489)] = 123444,
  [SMALL_STATE(6490)] = 123453,
  [SMALL_STATE(6491)] = 123462,
  [SMALL_STATE(6492)] = 123471,
  [SMALL_STATE(6493)] = 123480,
  [SMALL_STATE(6494)] = 123489,
  [SMALL_STATE(6495)] = 123498,
  [SMALL_STATE(6496)] = 123507,
  [SMALL_STATE(6497)] = 123516,
  [SMALL_STATE(6498)] = 123525,
  [SMALL_STATE(6499)] = 123534,
  [SMALL_STATE(6500)] = 123543,
  [SMALL_STATE(6501)] = 123552,
  [SMALL_STATE(6502)] = 123561,
  [SMALL_STATE(6503)] = 123570,
  [SMALL_STATE(6504)] = 123579,
  [SMALL_STATE(6505)] = 123588,
  [SMALL_STATE(6506)] = 123597,
  [SMALL_STATE(6507)] = 123606,
  [SMALL_STATE(6508)] = 123615,
  [SMALL_STATE(6509)] = 123624,
  [SMALL_STATE(6510)] = 123633,
  [SMALL_STATE(6511)] = 123642,
  [SMALL_STATE(6512)] = 123651,
  [SMALL_STATE(6513)] = 123660,
  [SMALL_STATE(6514)] = 123669,
  [SMALL_STATE(6515)] = 123678,
  [SMALL_STATE(6516)] = 123687,
  [SMALL_STATE(6517)] = 123696,
  [SMALL_STATE(6518)] = 123705,
  [SMALL_STATE(6519)] = 123714,
  [SMALL_STATE(6520)] = 123723,
  [SMALL_STATE(6521)] = 123732,
  [SMALL_STATE(6522)] = 123741,
  [SMALL_STATE(6523)] = 123750,
  [SMALL_STATE(6524)] = 123759,
  [SMALL_STATE(6525)] = 123768,
  [SMALL_STATE(6526)] = 123777,
  [SMALL_STATE(6527)] = 123786,
  [SMALL_STATE(6528)] = 123795,
  [SMALL_STATE(6529)] = 123804,
  [SMALL_STATE(6530)] = 123813,
  [SMALL_STATE(6531)] = 123822,
  [SMALL_STATE(6532)] = 123831,
  [SMALL_STATE(6533)] = 123840,
  [SMALL_STATE(6534)] = 123849,
  [SMALL_STATE(6535)] = 123858,
  [SMALL_STATE(6536)] = 123867,
  [SMALL_STATE(6537)] = 123876,
  [SMALL_STATE(6538)] = 123885,
  [SMALL_STATE(6539)] = 123894,
  [SMALL_STATE(6540)] = 123903,
  [SMALL_STATE(6541)] = 123912,
  [SMALL_STATE(6542)] = 123921,
  [SMALL_STATE(6543)] = 123930,
  [SMALL_STATE(6544)] = 123939,
  [SMALL_STATE(6545)] = 123948,
  [SMALL_STATE(6546)] = 123957,
  [SMALL_STATE(6547)] = 123966,
  [SMALL_STATE(6548)] = 123975,
  [SMALL_STATE(6549)] = 123984,
  [SMALL_STATE(6550)] = 123993,
  [SMALL_STATE(6551)] = 124002,
  [SMALL_STATE(6552)] = 124011,
  [SMALL_STATE(6553)] = 124020,
  [SMALL_STATE(6554)] = 124029,
  [SMALL_STATE(6555)] = 124038,
  [SMALL_STATE(6556)] = 124047,
  [SMALL_STATE(6557)] = 124056,
  [SMALL_STATE(6558)] = 124065,
  [SMALL_STATE(6559)] = 124074,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4292),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5195),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4223),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5187),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2496),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2516),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2467),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6554),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2453),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2426),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2411),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2502),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2495),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2464),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4669),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6535),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5154),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4384),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2469),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6504),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2471),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2189),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5147),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6500),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6499),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5146),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5227),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5229),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6482),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4276),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2508),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4400),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6172),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2480),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6518),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5476),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5870),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2592),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2484),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5825),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2596),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5482),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4878),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5191),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6083),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6060),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2207),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2459),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2474),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2172),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5190),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5850),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6358),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6084),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6162),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5189),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5223),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5405),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5488),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5842),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3963),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2906),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3207),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3203),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 2),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4382),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5327),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 2),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5873),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2506),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2477),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6543),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5514),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4594),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5862),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4918),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4388),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2450),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2462),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2173),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4917),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6442),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6395),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5305),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5338),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5470),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6443),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 3),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 3),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 4),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 4),
  [393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2963),
  [396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(565),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(56),
  [404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5170),
  [407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1287),
  [410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1287),
  [413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(685),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(695),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(41),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3236),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1286),
  [428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5195),
  [431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4276),
  [434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3074),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3336),
  [440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2496),
  [443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2517),
  [446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2467),
  [449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4382),
  [452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6172),
  [455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2480),
  [458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5327),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2),
  [463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6486),
  [466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5873),
  [469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2453),
  [472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5329),
  [475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1686),
  [478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2592),
  [481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1284),
  [484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2411),
  [487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(230),
  [490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2506),
  [493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2477),
  [496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2464),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2340),
  [502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6440),
  [505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6543),
  [508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2596),
  [511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4952),
  [514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5514),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4594),
  [520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4878),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5862),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4918),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6083),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4388),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3061),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4873),
  [541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2469),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6060),
  [547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2207),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(610),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2450),
  [556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2462),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2173),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4917),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6442),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(49),
  [571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6395),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1283),
  [577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(385),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6084),
  [583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6162),
  [586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4916),
  [589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5305),
  [592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5338),
  [595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5470),
  [598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6443),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6164),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6482),
  [607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5828),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5822),
  [613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5821),
  [616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3904),
  [619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4428),
  [622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3834),
  [625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(526),
  [628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2905),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3963),
  [634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2897),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3074),
  [640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2906),
  [643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 5),
  [645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 5),
  [647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 7),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 7),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_statement, 8),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_statement, 8),
  [657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2985),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), SHIFT(5170),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 1),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), SHIFT(5195),
  [676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(4276),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [681] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2496),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2513),
  [686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2467),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4373),
  [691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2480),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5502),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5769),
  [698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2453),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1683),
  [705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2411),
  [708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2503),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2491),
  [715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2464),
  [718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2390),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6429),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6541),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5575),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5772),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5092),
  [735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(4375),
  [738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2207),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2465),
  [746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2449),
  [749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(2175),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5101),
  [754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6431),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(96),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6427),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(6162),
  [766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5102),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5615),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5295),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5513),
  [774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6432),
  [776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(6164),
  [779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(6482),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2219),
  [786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6365),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6531),
  [790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5254),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2470),
  [794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2176),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6368),
  [798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5258),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [810] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(3023),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [816] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(5170),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [826] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(5195),
  [830] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4276),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3335),
  [836] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2496),
  [840] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2467),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4398),
  [846] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2480),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5248),
  [852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [854] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2453),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6390),
  [864] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2411),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [870] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2502),
  [874] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2464),
  [878] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2359),
  [882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6183),
  [884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6505),
  [886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5138),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5366),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4593),
  [892] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4405),
  [896] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2207),
  [900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [902] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2468),
  [906] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2475),
  [910] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2184),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6185),
  [916] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(48),
  [920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [922] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(6162),
  [926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5362),
  [928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6186),
  [932] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(6164),
  [936] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(6482),
  [940] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2963),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5976),
  [952] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2506),
  [956] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2340),
  [960] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4388),
  [964] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2450),
  [968] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2462),
  [972] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2173),
  [976] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(49),
  [980] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2974),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2512),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5657),
  [994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [996] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2505),
  [1000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2485),
  [1002] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2375),
  [1006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6449),
  [1008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6545),
  [1010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5471),
  [1012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4602),
  [1014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5659),
  [1016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4776),
  [1018] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4372),
  [1022] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2460),
  [1026] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2457),
  [1030] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2178),
  [1034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4771),
  [1036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6451),
  [1038] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(50),
  [1042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6413),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4770),
  [1048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5461),
  [1050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [1052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5445),
  [1054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6452),
  [1056] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2985),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1062] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2503),
  [1066] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2378),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6466),
  [1072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6549),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5435),
  [1076] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4375),
  [1080] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2473),
  [1084] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2449),
  [1088] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2171),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6468),
  [1094] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(51),
  [1098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5424),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6469),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [1116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2505),
  [1118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4372),
  [1122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2460),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2178),
  [1128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1140] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2379),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6474),
  [1146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6551),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5363),
  [1150] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2448),
  [1154] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2170),
  [1158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6476),
  [1160] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(57),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [1168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6477),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [1182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(63),
  [1187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2219),
  [1190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6365),
  [1193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6531),
  [1196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5254),
  [1199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2470),
  [1202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2176),
  [1205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6368),
  [1208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(71),
  [1211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(286),
  [1214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5258),
  [1217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6369),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2503),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2379),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4375),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2448),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2449),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2170),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [1264] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2219),
  [1268] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2470),
  [1272] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2176),
  [1276] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(71),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [1288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2473),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2171),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1304] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2342),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6458),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6547),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5447),
  [1314] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2466),
  [1318] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2177),
  [1322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6460),
  [1324] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(78),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6461),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [1346] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2960),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1352] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2504),
  [1356] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2329),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6397),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6537),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5257),
  [1366] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4403),
  [1370] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2463),
  [1374] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2474),
  [1378] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2182),
  [1382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6399),
  [1384] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(84),
  [1388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5533),
  [1392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6400),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2329),
  [1406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2463),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4722),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1424] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2366),
  [1428] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2459),
  [1432] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2172),
  [1436] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(94),
  [1440] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2390),
  [1444] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2465),
  [1448] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2175),
  [1452] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(96),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [1470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2960),
  [1473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(565),
  [1476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2),
  [1478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(97),
  [1481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5170),
  [1484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(1287),
  [1487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(1287),
  [1490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(685),
  [1493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(695),
  [1496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(103),
  [1499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3236),
  [1502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(1311),
  [1505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5195),
  [1508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4276),
  [1511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3074),
  [1514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3317),
  [1517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2496),
  [1520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2508),
  [1523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2467),
  [1526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4400),
  [1529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6172),
  [1532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2480),
  [1535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5475),
  [1538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(830),
  [1541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6486),
  [1544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6518),
  [1547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2453),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5476),
  [1553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(1685),
  [1556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5870),
  [1559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2592),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(1284),
  [1565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2411),
  [1568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(311),
  [1571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2504),
  [1574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2484),
  [1577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2464),
  [1580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2366),
  [1583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5859),
  [1586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5825),
  [1589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2596),
  [1592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4748),
  [1595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5482),
  [1598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4574),
  [1601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4878),
  [1604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6496),
  [1607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5191),
  [1610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6083),
  [1613] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4403),
  [1616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3061),
  [1619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4873),
  [1622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2469),
  [1625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6060),
  [1628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2207),
  [1631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(608),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2459),
  [1637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2474),
  [1640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2172),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5190),
  [1646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5850),
  [1649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(94),
  [1652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6358),
  [1655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(1283),
  [1658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(323),
  [1661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6084),
  [1664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6162),
  [1667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5189),
  [1670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5223),
  [1673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5405),
  [1676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5488),
  [1679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5842),
  [1682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6164),
  [1685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(6482),
  [1688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5828),
  [1691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5822),
  [1694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(5821),
  [1697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3904),
  [1700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(4428),
  [1703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3834),
  [1706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(526),
  [1709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2905),
  [1712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3963),
  [1715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2897),
  [1718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(3074),
  [1721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarations_and_statements, 2), SHIFT_REPEAT(2906),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1746] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2253),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6415),
  [1752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6539),
  [1754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5530),
  [1756] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2454),
  [1760] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2180),
  [1764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6417),
  [1766] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(114),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [1772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5569),
  [1774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6418),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1778] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2376),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5626),
  [1784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6487),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5225),
  [1788] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2456),
  [1792] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(2183),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6094),
  [1798] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(115),
  [1802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5226),
  [1806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6095),
  [1808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [1816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2359),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [1820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2468),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2475),
  [1824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [1826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [1848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [1850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2456),
  [1852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2960),
  [1859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(97),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(146),
  [1865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1311),
  [1868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(3317),
  [1871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2508),
  [1874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4400),
  [1877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5475),
  [1880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6518),
  [1883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5476),
  [1886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1685),
  [1889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(311),
  [1892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2504),
  [1895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2484),
  [1898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2329),
  [1901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6397),
  [1904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6537),
  [1907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4748),
  [1910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5257),
  [1913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4574),
  [1916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6496),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5191),
  [1922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(4403),
  [1925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(608),
  [1928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2463),
  [1931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2474),
  [1934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2182),
  [1937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5190),
  [1940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6399),
  [1943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(84),
  [1946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6358),
  [1949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(459),
  [1952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5189),
  [1955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5223),
  [1958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5405),
  [1961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5533),
  [1964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(6400),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2454),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2466),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [2021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2390),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2465),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2175),
  [2049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(499),
  [2078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2366),
  [2081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5859),
  [2084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5825),
  [2087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5482),
  [2090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2459),
  [2093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2172),
  [2096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5850),
  [2099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(94),
  [2102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(323),
  [2105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5488),
  [2108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(5842),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2686),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2865),
  [2125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2669),
  [2127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6009),
  [2131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2840),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2801),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [2137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [2141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2809),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(2923),
  [2172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(565),
  [2175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_label, 2),
  [2177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(2),
  [2180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(5170),
  [2183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(1287),
  [2186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(1287),
  [2189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(685),
  [2192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(695),
  [2195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(3236),
  [2198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(4276),
  [2201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(3074),
  [2204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_label, 2),
  [2206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6172),
  [2209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6081),
  [2212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6486),
  [2215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(2669),
  [2218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(2592),
  [2221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(1284),
  [2224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(5350),
  [2227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(2596),
  [2230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6082),
  [2233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(4878),
  [2236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6083),
  [2239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6167),
  [2242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(3061),
  [2245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(4873),
  [2248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(5200),
  [2251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(1283),
  [2254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6084),
  [2257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6162),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6164),
  [2263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(6482),
  [2266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(4280),
  [2269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(5828),
  [2272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(5822),
  [2275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(5821),
  [2278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(3904),
  [2281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(4428),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(3834),
  [2287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(526),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(2905),
  [2293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(3963),
  [2296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_label, 2), SHIFT(2897),
  [2299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(3074),
  [2302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_label, 2), SHIFT(2906),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3964),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(623),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2891),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [2351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2735),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2734),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [2435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(546),
  [2438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(569),
  [2441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2),
  [2443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(561),
  [2446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(546),
  [2449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(622),
  [2452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(620),
  [2455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(5798),
  [2458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(5799),
  [2461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(5800),
  [2464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(3929),
  [2467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(966),
  [2470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(4436),
  [2473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(3840),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(542),
  [2479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(617),
  [2482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(3964),
  [2485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(623),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__i_token_string_tokens, 2), SHIFT_REPEAT(619),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [2503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 4),
  [2505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 4),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [2515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4736),
  [2517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4383),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 5),
  [2525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 5),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4295),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [2534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5184),
  [2537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [2539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(552),
  [2542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6160),
  [2545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5195),
  [2548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4223),
  [2551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5028),
  [2554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2496),
  [2557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2517),
  [2560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2467),
  [2563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5873),
  [2566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2453),
  [2569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2301),
  [2572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2411),
  [2575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2506),
  [2578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2477),
  [2581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2464),
  [2584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4736),
  [2587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5862),
  [2590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4918),
  [2593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4383),
  [2596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2469),
  [2599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6504),
  [2602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2462),
  [2605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2194),
  [2608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4917),
  [2611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6395),
  [2614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6499),
  [2617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4916),
  [2620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5305),
  [2623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5287),
  [2626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6485),
  [2629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6482),
  [2632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 3),
  [2634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 3),
  [2636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 6),
  [2638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 6),
  [2640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 7),
  [2642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 7),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [2664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [2672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [2674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [2678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [2686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [2700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [2722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [2728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [2740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(574),
  [2749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(582),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2),
  [2754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(568),
  [2757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(574),
  [2760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(649),
  [2763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(644),
  [2766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(5682),
  [2769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(5683),
  [2772] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(5684),
  [2775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(3925),
  [2778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(4448),
  [2781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(3853),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(541),
  [2787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(640),
  [2790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(3969),
  [2793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(639),
  [2796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__token_string_tokens, 2), SHIFT_REPEAT(641),
  [2799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [2825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [2841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4300),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5169),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [2869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5325),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [2899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4300),
  [2902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(604),
  [2905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6056),
  [2908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5169),
  [2911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2508),
  [2914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6518),
  [2917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2235),
  [2920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2504),
  [2923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2484),
  [2926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4704),
  [2929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6496),
  [2932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5191),
  [2935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4406),
  [2938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2474),
  [2941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2195),
  [2944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5190),
  [2947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6358),
  [2950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5189),
  [2953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5223),
  [2956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5325),
  [2959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(605),
  [2962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(582),
  [2965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2),
  [2967] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(605),
  [2970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(649),
  [2973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(644),
  [2976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(5682),
  [2979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(5683),
  [2982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(5684),
  [2985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(3925),
  [2988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(4448),
  [2991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(3853),
  [2994] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(541),
  [2997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(640),
  [3000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(3969),
  [3003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(639),
  [3006] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_asm_inline_repeat1, 2), SHIFT_REPEAT(641),
  [3009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_inline, 1),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 1),
  [3021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [3023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6082),
  [3027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6167),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5200),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [3037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_quoted_string, 2),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_quoted_string, 2),
  [3041] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_raw_string, 3),
  [3043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_raw_string, 3),
  [3045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation_expression, 3),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_expression, 3),
  [3049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_string_token, 3),
  [3051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_string_token, 3),
  [3053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_string, 2),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_string, 2),
  [3057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_string, 2),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_string, 2),
  [3061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 1),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 1),
  [3065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_char_literal, 3),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_char_literal, 3),
  [3069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1),
  [3073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_ctor, 1),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_ctor, 1),
  [3077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_token_string, 3),
  [3079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_token_string, 3),
  [3081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_keyword, 1),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword, 1),
  [3085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_special_keyword, 1),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_special_keyword, 1),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_string_token, 2),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_string_token, 2),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_string, 3),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_string, 3),
  [3097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_raw_string, 2),
  [3099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_raw_string, 2),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_token_string, 2),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_token_string, 2),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_raw_string, 3),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raw_string, 3),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hex_string, 3),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hex_string, 3),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_quoted_string, 3),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_quoted_string, 3),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quoted_string, 3),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quoted_string, 3),
  [3121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_static_foreach_declaration, 9),
  [3124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_static_foreach_declaration, 9),
  [3127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 2),
  [3129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 2),
  [3131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_no_case_no_default, 1),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_no_case_no_default, 1),
  [3135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specified_function_body, 1),
  [3137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specified_function_body, 1),
  [3139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__statement_no_case_no_default, 1), REDUCE(sym__specified_function_body, 1),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__statement_no_case_no_default, 1), REDUCE(sym__specified_function_body, 1),
  [3145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_pragma_declaration, 3),
  [3148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_pragma_declaration, 3),
  [3151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_static_foreach_declaration, 11),
  [3154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_static_foreach_declaration, 11),
  [3157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_static_foreach_declaration, 10),
  [3160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_static_foreach_declaration, 10),
  [3163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 3),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 3),
  [3167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3),
  [3170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3),
  [3173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), SHIFT(1720),
  [3176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 4),
  [3178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 4),
  [3180] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3), SHIFT(1720),
  [3184] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3), SHIFT(1771),
  [3188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4285),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3083),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6220),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6253),
  [3216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6217),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6064),
  [3220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), SHIFT(1771),
  [3223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_aggregate_initializer, 2),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6354),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5631),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [3246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6174),
  [3248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5817),
  [3250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1327),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [3256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4885),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3054),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [3280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [3292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4424),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6077),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6248),
  [3322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2597),
  [3324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [3328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2598),
  [3330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6244),
  [3332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6238),
  [3334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6071),
  [3336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6231),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6061),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6063),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [3364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3968),
  [3366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [3372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [3392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 2),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [3438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 3),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3217),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3127),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [3528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__template_argument_list, 3),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_arguments, 4),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [3538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [3558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6234),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__template_argument_list, 2),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5869),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [3574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_arguments, 2),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5670),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 3),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [3588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5750),
  [3590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5801),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4042),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [3620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_arguments, 5),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [3626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 2),
  [3628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3084),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [3634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [3636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5802),
  [3638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2595),
  [3640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [3642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [3644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4922),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [3648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [3652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [3654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [3656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [3658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [3660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [3662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2602),
  [3664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [3666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [3668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [3670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5921),
  [3672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [3676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [3680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [3684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [3688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [3692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [3696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [3700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [3704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [3714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [3722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4473),
  [3724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [3726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [3728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6227),
  [3730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5686),
  [3732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [3734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [3736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5474),
  [3738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2594),
  [3740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6175),
  [3742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6176),
  [3744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [3746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4984),
  [3748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [3750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6177),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [3768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [3770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [3776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [3780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [3782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [3786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [3790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [3794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [3798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [3802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3502),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [3806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [3810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [3814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [3818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [3822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [3826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [3830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [3834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [3838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3500),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3416),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [3874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [3902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [3906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3475),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [3930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [3938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [3950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3307),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3449),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3310),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3312),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [3978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3444),
  [3982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [3990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3455),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3450),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3413),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3325),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [4030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3418),
  [4034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [4038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3424),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3319),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3311),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3263),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3288),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3433),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3528),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3515),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [4140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [4144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3532),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [4182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 6),
  [4184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 6),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6494),
  [4188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [4190] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 6),
  [4192] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 6),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [4196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [4198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [4200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(6494),
  [4203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5979),
  [4205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(186),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [4209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [4215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [4219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [4223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [4227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3163),
  [4229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [4231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3160),
  [4235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [4239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [4241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [4249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [4253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [4257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3390),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [4261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [4265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3365),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [4273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3264),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [4277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [4281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [4285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [4287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3297),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [4291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(5979),
  [4294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3151),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [4300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3377),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3304),
  [4310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [4312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3139),
  [4314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [4318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invariant_declaration, 4),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invariant_declaration, 4),
  [4322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7),
  [4324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7),
  [4326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_statement, 5),
  [4328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_statement, 5),
  [4330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5),
  [4332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5),
  [4334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 5),
  [4336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 5),
  [4338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 5),
  [4340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 5),
  [4342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5),
  [4344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5),
  [4346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_mixin, 5),
  [4348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_mixin, 5),
  [4350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invariant_declaration, 5),
  [4352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invariant_declaration, 5),
  [4354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 13),
  [4356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 13),
  [4358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor, 6),
  [4360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor, 6),
  [4362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [4364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [4366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 12),
  [4368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 12),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [4372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3),
  [4374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3),
  [4376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 23),
  [4378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 23),
  [4380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3),
  [4382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3),
  [4384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3),
  [4386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3),
  [4388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_statement, 3),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_statement, 3),
  [4392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, .production_id = 24),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, .production_id = 24),
  [4396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5),
  [4398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5),
  [4400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_manifest_constant, 5),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_constant, 5),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_enum_declaration, 5),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_enum_declaration, 5),
  [4408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5),
  [4410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5),
  [4412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_body, 3),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_body, 3),
  [4416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_manifest_constant, 7),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_constant, 7),
  [4420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5),
  [4422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5),
  [4424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_guard_statement, 5, .production_id = 23),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_guard_statement, 5, .production_id = 23),
  [4428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, .production_id = 23),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, .production_id = 23),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_synchronized_statement, 5),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_synchronized_statement, 5),
  [4436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 5),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 5),
  [4440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3),
  [4444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postblit, 5),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postblit, 5),
  [4448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor, 5),
  [4450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor, 5),
  [4452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_reassign, 5, .dynamic_precedence = -1),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_reassign, 5, .dynamic_precedence = -1),
  [4456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_auto_declaration, 4, .production_id = 9),
  [4458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_auto_declaration, 4, .production_id = 9),
  [4460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 4),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 4),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [4466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_declaration, 4),
  [4468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_declaration, 4),
  [4470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [4472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [4474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4),
  [4476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4),
  [4478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5),
  [4480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5),
  [4482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_mixin, 7),
  [4484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_mixin, 7),
  [4486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_version_specification, 4),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_version_specification, 4),
  [4490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor, 7),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor, 7),
  [4494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 7),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 7),
  [4498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 7),
  [4500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 7),
  [4502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 7),
  [4504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 7),
  [4506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 4),
  [4508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 4),
  [4510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4),
  [4512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4),
  [4514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_out_statement, 5),
  [4516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_out_statement, 5),
  [4518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invariant_declaration, 2),
  [4520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invariant_declaration, 2),
  [4522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_statement, 5, .production_id = 23),
  [4524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_statement, 5, .production_id = 23),
  [4526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_template_declaration, 2),
  [4528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_template_declaration, 2),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 8),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 8),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 2),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 2),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_mixin, 4),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_mixin, 4),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8),
  [4544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8),
  [4546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_enum_declaration, 8),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_enum_declaration, 8),
  [4550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 6, .production_id = 26),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 6, .production_id = 26),
  [4554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 27),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 27),
  [4558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postblit, 6),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postblit, 6),
  [4562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_body, 5),
  [4564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_body, 5),
  [4566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 28),
  [4568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 28),
  [4570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 29),
  [4572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 29),
  [4574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 30),
  [4576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 30),
  [4578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_mixin, 8),
  [4580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_mixin, 8),
  [4582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 2),
  [4584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 2),
  [4586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unittest_declaration, 2),
  [4588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unittest_declaration, 2),
  [4590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor, 8),
  [4592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor, 8),
  [4594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_foreach_declaration, 8),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_foreach_declaration, 8),
  [4598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 8),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 8),
  [4602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 31),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 31),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7),
  [4608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7),
  [4610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_statement, 6, .production_id = 27),
  [4612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_statement, 6, .production_id = 27),
  [4614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 32),
  [4616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 32),
  [4618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 33),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 33),
  [4622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 7),
  [4624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 7),
  [4626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 34),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 34),
  [4630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 7, .production_id = 35),
  [4632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 7, .production_id = 35),
  [4634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_foreach_declaration, 9),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_foreach_declaration, 9),
  [4638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 36),
  [4640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 36),
  [4642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 37),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 37),
  [4646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_static_foreach_declaration, 8),
  [4649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_static_foreach_declaration, 8),
  [4652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 8, .production_id = 38),
  [4654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 8, .production_id = 38),
  [4656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_enum_declaration, 7),
  [4658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_enum_declaration, 7),
  [4660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_foreach_declaration, 10),
  [4662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_foreach_declaration, 10),
  [4664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_reassign, 7, .dynamic_precedence = -1),
  [4666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_reassign, 7, .dynamic_precedence = -1),
  [4668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate_body, 3),
  [4670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate_body, 3),
  [4672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_static_foreach_declaration, 9),
  [4675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_static_foreach_declaration, 9),
  [4678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_statement, 9, .production_id = 39),
  [4680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_statement, 9, .production_id = 39),
  [4682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 2, .production_id = 7),
  [4684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 2, .production_id = 7),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [4688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2),
  [4691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2),
  [4694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), SHIFT(1822),
  [4697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_foreach_declaration, 11),
  [4699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_foreach_declaration, 11),
  [4701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_static_foreach_declaration, 10),
  [4704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_static_foreach_declaration, 10),
  [4707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_foreach_declaration, 12),
  [4709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_foreach_declaration, 12),
  [4711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_declaration, 2),
  [4713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_declaration, 2),
  [4715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration2, 1), REDUCE(sym_pragma_declaration, 2),
  [4718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration2, 1), REDUCE(sym_pragma_declaration, 2),
  [4721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_declaration, 2),
  [4723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_declaration, 2),
  [4725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 25),
  [4727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 25),
  [4729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6),
  [4731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6),
  [4733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 5),
  [4735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 5),
  [4737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_declaration, 2),
  [4739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_declaration, 2),
  [4741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_declaration, 2),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_declaration, 2),
  [4745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1822),
  [4747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_declaration, 6),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_declaration, 6),
  [4751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 2, .production_id = 6),
  [4753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 2, .production_id = 6),
  [4755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 1),
  [4757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 1),
  [4759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_function_body, 1), REDUCE(sym__function_contract, 1),
  [4762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_function_body, 1), REDUCE(sym__function_contract, 1),
  [4765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_aggregate_body, 2),
  [4767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate_body, 2),
  [4769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 2),
  [4771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 2),
  [4773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_mixin, 6),
  [4775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_mixin, 6),
  [4777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_in_statement, 2),
  [4779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_statement, 2),
  [4781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_out_statement, 2),
  [4783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_out_statement, 2),
  [4785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_statement, 4, .production_id = 19),
  [4787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_statement, 4, .production_id = 19),
  [4789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 5),
  [4791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 5),
  [4793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 6),
  [4795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 6),
  [4797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 3),
  [4799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 3),
  [4801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 3),
  [4803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 3),
  [4805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3),
  [4807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3),
  [4809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3),
  [4811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3),
  [4813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_manifest_constant, 3),
  [4815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_constant, 3),
  [4817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_declaration, 3),
  [4819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_declaration, 3),
  [4821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3),
  [4823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3),
  [4825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration2, 1), REDUCE(sym__statement_no_case_no_default, 1),
  [4828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration2, 1), REDUCE(sym__statement_no_case_no_default, 1),
  [4831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_mixin, 3),
  [4833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_mixin, 3),
  [4835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_assert, 3),
  [4837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_assert, 3),
  [4839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3),
  [4841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3),
  [4843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_declaration, 3),
  [4845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_declaration, 3),
  [4847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_statement, 2, .production_id = 6),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_statement, 2, .production_id = 6),
  [4851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 4),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 4),
  [4855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [4857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [4859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_declaration, 3),
  [4861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_declaration, 3),
  [4863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1720),
  [4865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 3),
  [4867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 3),
  [4869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_auto_declaration, 3, .production_id = 1),
  [4871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_auto_declaration, 3, .production_id = 1),
  [4873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [4875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_reassign, 4, .dynamic_precedence = -1),
  [4877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_reassign, 4, .dynamic_precedence = -1),
  [4879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2),
  [4881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2),
  [4883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 4),
  [4885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 4),
  [4887] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2), SHIFT(1822),
  [4891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_this, 4),
  [4893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_this, 4),
  [4895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 4),
  [4897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 4),
  [4899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4),
  [4901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4),
  [4903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debug_specification, 4),
  [4905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debug_specification, 4),
  [4907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [4909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_asm_statement, 4),
  [4911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_asm_statement, 4),
  [4913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6),
  [4915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6),
  [4917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_manifest_constant, 6),
  [4919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_constant, 6),
  [4921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_enum_declaration, 4),
  [4923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_enum_declaration, 4),
  [4925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_manifest_constant, 4),
  [4927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_constant, 4),
  [4929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4),
  [4931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4),
  [4933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [4935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [4937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [4939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [4941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_reassign, 6, .dynamic_precedence = -1),
  [4943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_reassign, 6, .dynamic_precedence = -1),
  [4945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scope_statement, 1),
  [4947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scope_statement, 1),
  [4949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_final_switch_statement, 2),
  [4951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_final_switch_statement, 2),
  [4953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [4955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [4957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_foreach_statement, 2),
  [4959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_foreach_statement, 2),
  [4961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_enum_declaration, 6),
  [4963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_enum_declaration, 6),
  [4965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_contract, 1), REDUCE(sym_function_body, 2),
  [4968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__function_contract, 1), REDUCE(sym_function_body, 2),
  [4971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__enum_body, 4),
  [4973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__enum_body, 4),
  [4975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_synchronized_statement, 2),
  [4977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_synchronized_statement, 2),
  [4979] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declaration2, 1), REDUCE(sym_pragma_declaration, 2), REDUCE(sym_pragma_statement, 2),
  [4983] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declaration2, 1), REDUCE(sym_pragma_declaration, 2), REDUCE(sym_pragma_statement, 2),
  [4987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_statement, 2),
  [4989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_statement, 2),
  [4991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6),
  [4993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6),
  [4995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [4997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [4999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_declaration, 6),
  [5001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_declaration, 6),
  [5003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 6),
  [5005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 6),
  [5007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 4),
  [5009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 4),
  [5011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [5013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1771),
  [5015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), SHIFT(1865),
  [5018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [5020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1865),
  [5022] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2), SHIFT(1865),
  [5026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [5028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [5030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [5032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debug_condition, 1),
  [5034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debug_condition, 1),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [5042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [5048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_if_condition, 5),
  [5050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_if_condition, 5),
  [5052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(aux_sym_source_file_repeat1, 1),
  [5055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1),
  [5057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(aux_sym_source_file_repeat1, 1),
  [5060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1),
  [5062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_version_condition, 4),
  [5064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_version_condition, 4),
  [5066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_expression, 4),
  [5068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_expression, 4),
  [5070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_expression, 6),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_expression, 6),
  [5074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition, 1),
  [5076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition, 1),
  [5078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debug_condition, 4),
  [5080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debug_condition, 4),
  [5082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 6),
  [5084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 6),
  [5086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 3),
  [5088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 3),
  [5090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [5094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4294),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [5100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4751),
  [5102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [5104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4635),
  [5106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4802),
  [5108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4399),
  [5110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5462),
  [5116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5279),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [5122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4294),
  [5125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1703),
  [5128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6251),
  [5131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4751),
  [5134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2512),
  [5137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5657),
  [5140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2306),
  [5143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2505),
  [5146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2485),
  [5149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4635),
  [5152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5659),
  [5155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4802),
  [5158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4399),
  [5161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2452),
  [5164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2201),
  [5167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4771),
  [5170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6413),
  [5173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4770),
  [5176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5462),
  [5179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5279),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [5190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4292),
  [5193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1710),
  [5196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6557),
  [5199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5187),
  [5202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2516),
  [5205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6554),
  [5208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2426),
  [5211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2502),
  [5214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2495),
  [5217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4669),
  [5220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6535),
  [5223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5154),
  [5226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4384),
  [5229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2471),
  [5232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2189),
  [5235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5147),
  [5238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(6500),
  [5241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5146),
  [5244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5227),
  [5247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5229),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [5258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4786),
  [5260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2190),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6213),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4908),
  [5280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [5292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [5302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4781),
  [5304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [5306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4698),
  [5308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4385),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [5312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5273),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [5320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1854),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [5432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_def, 2),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [5490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [5492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [5494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [5532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [5548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [5552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [5568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [5572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [5586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [5588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [5592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [5596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [5600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [5602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [5626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [5628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1828),
  [5630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [5654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [5660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [5662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [5664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [5668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [5670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [5672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [5674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [5678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [5680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [5682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [5692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [5694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [5696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [5698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [5702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [5704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [5706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [5708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [5710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [5712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_def, 1),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [5722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2),
  [5724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [5726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [5742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [5750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [5756] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3), SHIFT(1741),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [5762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [5764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [5766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [5770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), SHIFT(1741),
  [5773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [5775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [5777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [5779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [5781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [5783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [5785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [5801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [5805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [5807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [5809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [5821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [5823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [5825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [5827] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3), SHIFT(1737),
  [5831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block_statement, 2), SHIFT(1737),
  [5834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6434),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [5838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [5840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6421),
  [5842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [5844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [5846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(6434),
  [5849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(6421),
  [5852] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2), SHIFT(1723),
  [5856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [5858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [5860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), SHIFT(1723),
  [5863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [5865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [5867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [5869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1723),
  [5871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [5873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1842),
  [5875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [5877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [5879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), SHIFT(1725),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [5886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [5888] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2), SHIFT(1725),
  [5892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1737),
  [5894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4287),
  [5896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [5898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2696),
  [5902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [5904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2591),
  [5906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5214),
  [5908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [5910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2590),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [5916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [5920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_arguments, 2),
  [5922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_arguments, 2),
  [5924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_at_attribute, 2),
  [5926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_attribute, 2),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [5930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [5932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_instance, 2),
  [5934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_instance, 2),
  [5936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_arguments, 4),
  [5938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_arguments, 4),
  [5940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_arguments, 3),
  [5942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_arguments, 3),
  [5944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_at_attribute, 4),
  [5946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_attribute, 4),
  [5948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [5950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [5952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_at_attribute, 3),
  [5954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_attribute, 3),
  [5956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [5958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [5960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2),
  [5962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2),
  [5964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(5195),
  [5967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(2169),
  [5970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(2467),
  [5973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(2453),
  [5976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(2455),
  [5979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(2493),
  [5982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(2469),
  [5985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(6504),
  [5988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1),
  [5991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5789),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6328),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6552),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6078),
  [6004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6550),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [6008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6530),
  [6010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6433),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5839),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6544),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6542),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6534),
  [6022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6548),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5673),
  [6028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6546),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6540),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6538),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6362),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6076),
  [6038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6489),
  [6040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6507),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6329),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6325),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6327),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6553),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6522),
  [6054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_contract, 1),
  [6056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_contract, 1),
  [6058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [6064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6511),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [6068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5875),
  [6070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6516),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [6074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5352),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [6078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1870),
  [6082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1879),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1864),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1716),
  [6090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym_deprecated_attribute, 1),
  [6093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deprecated_attribute, 1),
  [6095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(sym_deprecated_attribute, 1),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [6100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deprecated_attribute, 1),
  [6102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [6104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5322),
  [6107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [6109] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), REDUCE(aux_sym_module_declaration_repeat1, 1),
  [6113] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), REDUCE(aux_sym_module_declaration_repeat1, 1),
  [6117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_module_declaration_repeat1, 1),
  [6119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5309),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [6126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5337),
  [6129] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), REDUCE(aux_sym_type_repeat1, 1),
  [6133] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), REDUCE(aux_sym_type_repeat1, 1),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [6139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [6143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_deprecated_attribute, 4),
  [6145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deprecated_attribute, 4),
  [6147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5360),
  [6150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4891),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [6158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_align_attribute, 1),
  [6160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_align_attribute, 1),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [6170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5277),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [6177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5403),
  [6180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(5261),
  [6183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 1),
  [6185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 1),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [6189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 4),
  [6191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 4),
  [6193] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(sym__attribute, 1), SHIFT(4975),
  [6197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_attribute, 6),
  [6199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_attribute, 6),
  [6201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_attribute, 5),
  [6203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_attribute, 5),
  [6205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [6209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_attribute, 4),
  [6211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_attribute, 4),
  [6213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shebang, 2),
  [6215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shebang, 2),
  [6217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_align_attribute, 4),
  [6219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_align_attribute, 4),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [6223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_attribute, 7, .production_id = 22),
  [6225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_attribute, 7, .production_id = 22),
  [6227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [6229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_linkage_attribute, 7),
  [6231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_linkage_attribute, 7),
  [6233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 4),
  [6235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 4),
  [6237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 5),
  [6239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 5),
  [6241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 3),
  [6243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 3),
  [6245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_declaration, 6),
  [6247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_declaration, 6),
  [6249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4172),
  [6251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [6253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [6255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4176),
  [6257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [6259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [6261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4112),
  [6263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [6265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [6267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4191),
  [6269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [6271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [6273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [6275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [6277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [6279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4226),
  [6281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [6283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4266),
  [6285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6070),
  [6287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [6289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2523),
  [6291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [6293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2532),
  [6295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4234),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [6299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4268),
  [6301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6219),
  [6303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4260),
  [6305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6257),
  [6307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4248),
  [6309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2522),
  [6311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [6313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4253),
  [6315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6388),
  [6317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4255),
  [6319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6166),
  [6321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [6323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4278),
  [6325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4244),
  [6327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5193),
  [6329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4000),
  [6331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4264),
  [6333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5237),
  [6335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3082),
  [6337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6215),
  [6339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5619),
  [6341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6144),
  [6343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [6345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [6347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5485),
  [6349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5218),
  [6351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5487),
  [6353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2729),
  [6355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [6357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [6361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [6363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [6365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [6367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [6369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [6371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [6373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [6375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [6377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [6379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [6381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2713),
  [6383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [6385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [6387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [6389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [6391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [6393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6044),
  [6395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [6397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [6399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [6401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [6403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [6405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3959),
  [6407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [6409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [6411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [6413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2830),
  [6415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [6417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [6419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [6421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [6423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [6425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [6427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [6429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [6431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [6433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [6435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [6437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [6439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [6441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [6443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [6445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [6447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [6449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [6451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [6453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [6455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [6457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [6459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [6461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [6463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [6465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [6467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [6469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2154),
  [6471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [6473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [6475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [6477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [6479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [6481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3880),
  [6483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [6485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [6487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [6489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [6491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [6493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [6495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [6497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [6499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [6501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [6505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [6507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [6511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [6513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [6521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6017),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [6531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3989),
  [6533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3958),
  [6535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [6541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [6549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3923),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [6559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [6563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [6565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2576),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2571),
  [6569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [6571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2975),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [6577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [6579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4083),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [6587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [6591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [6597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [6601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3957),
  [6603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4090),
  [6605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [6609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2898),
  [6615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4207),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [6619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4270),
  [6623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [6625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [6627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [6629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2636),
  [6631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2662),
  [6635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5823),
  [6637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2666),
  [6639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5824),
  [6641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6102),
  [6645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2642),
  [6647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5763),
  [6649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2663),
  [6651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5945),
  [6653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5837),
  [6657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2640),
  [6659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5714),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [6663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6103),
  [6665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5715),
  [6669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [6671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5891),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2648),
  [6675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5890),
  [6677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [6679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4240),
  [6681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [6687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [6691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(5192),
  [6694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2696),
  [6697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2686),
  [6700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2669),
  [6703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2702),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2808),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2790),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2765),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4252),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [6770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_suffix, 3),
  [6772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_suffix, 3),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [6778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_storage_class, 1),
  [6780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_storage_class, 1),
  [6782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2),
  [6784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_alias_declaration_repeat2, 2),
  [6786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(5061),
  [6789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(2716),
  [6792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_suffix, 2),
  [6794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_suffix, 2),
  [6796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5611),
  [6798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3555),
  [6800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5019),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2542),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [6810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(4934),
  [6813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(2771),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [6818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), SHIFT(2668),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [6825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [6827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(2869),
  [6830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(5158),
  [6833] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(2826),
  [6836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), SHIFT(4581),
  [6839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), REDUCE(aux_sym_type_repeat1, 1),
  [6842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), REDUCE(aux_sym_type_repeat1, 1),
  [6845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_storage_class, 1), SHIFT(3123),
  [6848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2543),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [6852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(5108),
  [6855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4),
  [6857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4),
  [6859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_function_attribute, 1),
  [6861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_function_attribute, 1),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [6867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [6869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [6871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [6873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [6875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5),
  [6877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5),
  [6879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 6),
  [6881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 6),
  [6883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 7),
  [6885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 7),
  [6887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4272),
  [6889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [6891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2455),
  [6893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1988),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [6899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [6901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [6905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [6937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2),
  [6939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_suffix_repeat1, 2),
  [6941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(5113),
  [6944] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(2803),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2565),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [6953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4301),
  [6955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [6961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_storage_class, 1), SHIFT(4975),
  [6964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [6966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(4999),
  [6969] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(2883),
  [6972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2556),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [6976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(5167),
  [6979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(2896),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [6986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4302),
  [6988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [6990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4225),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2899),
  [6996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__template_parameter_list, 2),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [7000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5007),
  [7002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_id, 1),
  [7004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expr, 1),
  [7006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expr, 1),
  [7008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(5021),
  [7011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 1),
  [7014] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 1), SHIFT(864),
  [7018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 1),
  [7021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [7025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expr, 2),
  [7027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expr, 2),
  [7029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 2), SHIFT(5021),
  [7032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 2),
  [7035] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 2), SHIFT(864),
  [7039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_id, 1),
  [7041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 2),
  [7044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__template_parameter_list, 3),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [7048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [7052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2),
  [7054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 2),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [7058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [7064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [7068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(2135),
  [7071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [7073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1),
  [7075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [7077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3),
  [7079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 3),
  [7081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2),
  [7083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2),
  [7085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(854),
  [7088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(2947),
  [7091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5607),
  [7094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5606),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [7101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type2, 1),
  [7103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type2, 1), REDUCE(sym__primary_expr, 1),
  [7106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type2, 1),
  [7108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1), REDUCE(sym__primary_expr, 1),
  [7111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [7113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [7115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3603),
  [7117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3601),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [7123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(5185),
  [7126] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 1), SHIFT(774),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [7132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(2138),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [7137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_traits_expression, 4),
  [7139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_traits_expression, 4),
  [7141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__parameter_repeat1, 2),
  [7143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_repeat1, 2),
  [7145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_repeat1, 2), SHIFT_REPEAT(5192),
  [7148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parameter_repeat1, 2), SHIFT_REPEAT(3306),
  [7151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__parameter_repeat1, 2), SHIFT_REPEAT(2669),
  [7154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeof_expression, 4),
  [7156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeof_expression, 4),
  [7158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(2137),
  [7161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(4961),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [7166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(2136),
  [7169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mixin_expression, 4),
  [7171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mixin_expression, 4),
  [7173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_traits_expression, 6),
  [7175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_traits_expression, 6),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [7179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(2139),
  [7182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameter_attribute, 1),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [7186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_attribute, 1),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [7192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [7202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type2, 2),
  [7204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type2, 2),
  [7206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_expression, 3),
  [7208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_expression, 3),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [7212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_id, 4),
  [7214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_id, 4),
  [7216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type2, 4),
  [7218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type2, 4),
  [7220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type2, 3),
  [7222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type2, 3),
  [7224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(804),
  [7227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(3042),
  [7230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5472),
  [7233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5473),
  [7236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3076),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [7240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3086),
  [7242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [7244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6286),
  [7246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_id, 6),
  [7248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_id, 6),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [7252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_suffix, 5),
  [7254] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_suffix, 5),
  [7256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [7260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [7264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6165),
  [7266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(5021),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [7273] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 5), REDUCE(sym_property_expression, 5),
  [7276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 5), REDUCE(sym_property_expression, 5),
  [7279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [7281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [7283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qualified_id, 3),
  [7285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qualified_id, 3),
  [7287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [7291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [7293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [7297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_type, 4),
  [7299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_type, 4),
  [7301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 2), SHIFT(5185),
  [7304] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 2), SHIFT(774),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [7312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4914),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [7316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4286),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4758),
  [7320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4305),
  [7322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6284),
  [7324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(4761),
  [7327] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 1), SHIFT(814),
  [7331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1),
  [7333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [7341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [7343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4860),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [7347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5, .production_id = 20),
  [7349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5, .production_id = 20),
  [7351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 5),
  [7353] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 5),
  [7355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4258),
  [7357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_arguments_attribute, 1),
  [7359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), REDUCE(sym_variadic_arguments_attribute, 1),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [7366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3133),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [7372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 2), SHIFT(5021),
  [7375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4284),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [7379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4297),
  [7381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6258),
  [7383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6255),
  [7385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [7387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(766),
  [7390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(3100),
  [7393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5415),
  [7396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5414),
  [7399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(1575),
  [7402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [7404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 18),
  [7406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 18),
  [7408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_power_expression, 3, .production_id = 4),
  [7410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_power_expression, 3, .production_id = 4),
  [7412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 2),
  [7414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 2),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_expression, 2),
  [7418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delete_expression, 2),
  [7420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2),
  [7422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2),
  [7424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2),
  [7426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2),
  [7428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 9),
  [7430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 9),
  [7432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 4, .production_id = 11),
  [7434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 4, .production_id = 11),
  [7436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2437),
  [7439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 4, .production_id = 16),
  [7441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 4, .production_id = 16),
  [7443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specified_function_body, 2),
  [7445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specified_function_body, 2),
  [7447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), SHIFT(1758),
  [7450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 2),
  [7452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 2),
  [7454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_expression, 4),
  [7456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_expression, 4),
  [7458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 4),
  [7460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 4),
  [7462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 4),
  [7464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 4),
  [7466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typeid_expression, 4),
  [7468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typeid_expression, 4),
  [7470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3),
  [7472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3),
  [7474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4),
  [7476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4),
  [7478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 3),
  [7480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 3),
  [7482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5160),
  [7484] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3), SHIFT(1758),
  [7488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [7490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [7492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(1439),
  [7495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 6),
  [7497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 6),
  [7499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 3),
  [7501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_arguments, 3),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [7505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2320),
  [7508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 5, .production_id = 16),
  [7510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 5, .production_id = 16),
  [7512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [7514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4298),
  [7516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4200),
  [7518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_attribute, 1), REDUCE(sym_variadic_arguments_attribute, 1),
  [7521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_attribute, 1), REDUCE(aux_sym_type_repeat1, 1),
  [7524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter_attribute, 1), REDUCE(aux_sym_type_repeat1, 1),
  [7527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 5),
  [7529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 5),
  [7531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 5),
  [7533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 5),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4303),
  [7537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 5),
  [7539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 5),
  [7541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 2),
  [7543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 2),
  [7545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 2), SHIFT(4761),
  [7548] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym__primary_expr, 2), SHIFT(814),
  [7552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4293),
  [7554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 5),
  [7556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 5),
  [7558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 8),
  [7560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 8),
  [7562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 3),
  [7564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 3),
  [7566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 7),
  [7568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 7),
  [7570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2021),
  [7573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 4),
  [7575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 4),
  [7577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 2),
  [7579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_arguments, 2),
  [7581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 3, .production_id = 11),
  [7583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 3, .production_id = 11),
  [7585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 3),
  [7587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 3),
  [7589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [7591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4261),
  [7593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specified_function_body, 3),
  [7595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specified_function_body, 3),
  [7597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_expression, 4),
  [7599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assert_expression, 4),
  [7601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dollar, 1),
  [7603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dollar, 1),
  [7605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [7607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 1),
  [7609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 1),
  [7611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(4811),
  [7614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4277),
  [7616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 1),
  [7618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 1),
  [7620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_expression, 2, .production_id = 4),
  [7622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_expression, 2, .production_id = 4),
  [7624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 6),
  [7626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 6),
  [7628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 6),
  [7630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 6),
  [7632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 6),
  [7634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 6),
  [7636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2),
  [7638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2),
  [7640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equal_expression, 3, .production_id = 4),
  [7642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [7644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_equal_expression, 3, .production_id = 4),
  [7646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [7648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [7650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [7652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expr, 1), SHIFT(4961),
  [7655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [7657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [7659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3382),
  [7661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [7665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_xor_expression, 3, .production_id = 4),
  [7667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1187),
  [7669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_xor_expression, 3, .production_id = 4),
  [7671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [7673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [7675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [7681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [7687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [7689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_literal, 7),
  [7691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_literal, 7),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5041),
  [7695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_expression, 3, .production_id = 4),
  [7697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_add_expression, 3, .production_id = 4),
  [7699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identity_expression, 3),
  [7701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identity_expression, 3),
  [7703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_or_expression, 3, .production_id = 4),
  [7705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_or_expression, 3, .production_id = 4),
  [7707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mul_expression, 3, .production_id = 4),
  [7709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mul_expression, 3, .production_id = 4),
  [7711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 4),
  [7713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [7715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [7717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shift_expression, 3, .production_id = 4),
  [7719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shift_expression, 3, .production_id = 4),
  [7721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parameter_attribute, 1), SHIFT(4975),
  [7724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2540),
  [7727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rel_expression, 3, .production_id = 4),
  [7729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rel_expression, 3, .production_id = 4),
  [7731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_and_expression, 3, .production_id = 4),
  [7733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_and_expression, 3, .production_id = 4),
  [7735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 21),
  [7737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_and_expression, 3, .production_id = 4),
  [7739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_and_expression, 3, .production_id = 4),
  [7741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_expression, 3, .production_id = 4),
  [7743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_expression, 3, .production_id = 4),
  [7745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2527),
  [7748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2537),
  [7751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [7759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block_statement, 2), SHIFT(1744),
  [7762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__specified_function_body, 1), REDUCE(sym__specified_function_body, 2),
  [7765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__specified_function_body, 1), REDUCE(sym__specified_function_body, 2),
  [7768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2529),
  [7771] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_block_statement, 2), REDUCE(sym_conditional_declaration, 3), SHIFT(1744),
  [7775] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(2541),
  [7778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(4788),
  [7781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [7783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [7785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [7787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [7789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [7791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [7795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [7799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [7801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [7805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [7811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [7813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1310),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [7817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [7819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [7823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [7827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [7829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1161),
  [7831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [7833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [7835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [7837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [7839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [7841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [7843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [7845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1130),
  [7847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [7849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [7851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [7853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [7855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [7857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [7859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1126),
  [7861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [7863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [7865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [7867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, .production_id = 21),
  [7869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [7871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [7873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1131),
  [7875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [7877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 4),
  [7879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [7881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(6525),
  [7884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(6272),
  [7887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [7889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [7891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [7893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [7895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [7897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [7899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [7901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [7903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [7909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [7917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [7919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_foreach_type_repeat1, 2),
  [7921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_foreach_type_repeat1, 2),
  [7923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_foreach_type_repeat1, 2), SHIFT_REPEAT(3498),
  [7926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_foreach_type_repeat1, 2), SHIFT_REPEAT(2669),
  [7929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(5643),
  [7932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(5856),
  [7935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expr, 1), SHIFT(6454),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [7940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [7942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [7946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [7948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [7952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [7958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [7968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [7970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 1), REDUCE(aux_sym_foreach_type_repeat1, 1),
  [7973] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 1), REDUCE(aux_sym_foreach_type_repeat1, 1),
  [7976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_foreach_type_repeat1, 1),
  [7978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [7980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [7982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [7986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [7990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [7994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [7998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [8002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [8006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [8008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [8012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [8020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [8022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [8024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [8028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [8030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [8034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [8042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [8048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 6),
  [8050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3),
  [8052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [8056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 4),
  [8058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 5),
  [8060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_specialization, 1),
  [8062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [8064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4),
  [8066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5),
  [8068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 4), REDUCE(sym_template_parameter, 4),
  [8071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 1),
  [8073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [8075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [8077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [8079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1188),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1186),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [8089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [8091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [8095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2),
  [8097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1247),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [8101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [8105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [8109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [8111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [8115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [8121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [8123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [8125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [8129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [8139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [8141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_member_init, 1, .production_id = 3),
  [8143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_list, 1), REDUCE(sym_expression, 1),
  [8146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_qualifier, 1),
  [8148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_ctor, 1), SHIFT(6003),
  [8151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 2),
  [8153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 2),
  [8155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 2), SHIFT_REPEAT(2669),
  [8158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_declarator, 3),
  [8160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [8162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_declarator, 2),
  [8164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_repeat1, 1),
  [8166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_repeat1, 1),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [8170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 4),
  [8172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [8174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [8176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [8178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [8182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [8186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [8188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [8192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [8196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_enum_member, 4),
  [8198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 4),
  [8200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [8208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [8212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [8214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_argument, 1),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [8218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 6),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [8226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_member_init, 3, .production_id = 15),
  [8228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 5),
  [8230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [8232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 7),
  [8234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 3),
  [8236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [8238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [8240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [8242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [8244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [8248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [8252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [8254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [8266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [8312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5162),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [8324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4896),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [8336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [8340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5165),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [8352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5491),
  [8358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [8360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3895),
  [8362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3995),
  [8364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [8366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [8372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3824),
  [8374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2588),
  [8376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3847),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [8380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [8382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [8386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [8388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4084),
  [8396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3843),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [8400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [8402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3006),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [8406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(4797),
  [8409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(3824),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [8414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [8418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [8420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [8424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [8426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [8430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [8432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2841),
  [8434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3852),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [8438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [8440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3833),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [8444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [8446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_quoted_string_repeat1, 2), SHIFT_REPEAT(3890),
  [8449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_quoted_string_repeat1, 2), SHIFT_REPEAT(3895),
  [8452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpolated_quoted_string_repeat1, 2),
  [8454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_quoted_string_repeat1, 2), SHIFT_REPEAT(963),
  [8457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_quoted_string_repeat1, 2), SHIFT_REPEAT(3847),
  [8460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_quoted_string_repeat1, 2), SHIFT_REPEAT(3847),
  [8463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [8465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [8467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [8469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [8471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [8473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [8475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [8477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [8479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [8481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2582),
  [8483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [8485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [8487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [8489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [8491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [8493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [8495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [8501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [8505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(4759),
  [8508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(3946),
  [8511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [8513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(4859),
  [8516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(3824),
  [8519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2549),
  [8521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [8523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(5139),
  [8526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(3946),
  [8529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_htmlentity, 1),
  [8531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_htmlentity, 1),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [8537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [8539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(5195),
  [8542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_escape_sequence, 1),
  [8544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_escape_sequence, 1),
  [8546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [8548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [8562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quoted_string_repeat1, 2), SHIFT_REPEAT(3953),
  [8565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_quoted_string_repeat1, 2), SHIFT_REPEAT(3952),
  [8568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_quoted_string_repeat1, 2),
  [8570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_quoted_string_repeat1, 2), SHIFT_REPEAT(3900),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [8577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [8579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [8581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [8583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2907),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [8593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [8599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat2, 2), SHIFT_REPEAT(4777),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3933),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [8650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [8652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(4920),
  [8655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(3936),
  [8658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_member_attributes, 2),
  [8660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_with_member_attributes, 2),
  [8662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_member_attributes, 1),
  [8664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_with_member_attributes, 1),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [8676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4039),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [8688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameters, 2),
  [8690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_parameters, 2),
  [8692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [8698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(4759),
  [8701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(4039),
  [8704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(5089),
  [8707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(4048),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [8714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_initializer, 6),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [8718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_initializer, 5),
  [8720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_initializer, 4),
  [8722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_initializer, 7),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2904),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [8784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [8788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 3),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [8828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(5139),
  [8831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_suffix_repeat1, 2), SHIFT_REPEAT(4156),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [8854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [8860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [8908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [8916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [8918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [8920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5293),
  [8922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 9),
  [8924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 9),
  [8926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [8930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 11),
  [8932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 11),
  [8934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(855),
  [8937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(4204),
  [8940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5292),
  [8943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5293),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [8948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [8954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 8),
  [8956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 8),
  [8958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 6),
  [8960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 6),
  [8962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 10),
  [8964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 10),
  [8966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 12),
  [8968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 12),
  [8970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 7),
  [8972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 7),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [8978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 5),
  [8980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 5),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [8988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2),
  [8990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 2),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [8996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 4),
  [8998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 4),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [9004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [9008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 1),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [9012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [9018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2),
  [9020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(4878),
  [9023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_body_repeat1, 2), SHIFT_REPEAT(4873),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [9030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [9032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5185),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [9036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [9040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__qualified_id, 1), REDUCE(sym_template_parameter, 1),
  [9043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [9045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [9047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6072),
  [9049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4257),
  [9051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5212),
  [9053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5213),
  [9055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6252),
  [9057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(4257),
  [9060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5212),
  [9063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5213),
  [9066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 2),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [9070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [9074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5639),
  [9076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [9082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_attributes, 2),
  [9084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6517),
  [9086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_with_attributes, 1),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [9090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [9092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6342),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [9102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 1),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [9106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [9112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(4281),
  [9115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5311),
  [9118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5312),
  [9121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [9123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [9125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [9127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [9129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6455),
  [9131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [9133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [9135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [9137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(4290),
  [9140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5495),
  [9143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5493),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [9158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5260),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [9170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(856),
  [9173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(4299),
  [9176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_repeat2, 2), SHIFT_REPEAT(5260),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [9181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_type, 1),
  [9183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_type, 2),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [9187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [9189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [9191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [9193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [9195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [9197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [9205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [9209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [9213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [9215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [9219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [9221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [9223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4779),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [9237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4516),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [9247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variadic_arguments_attributes, 2),
  [9249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variadic_arguments_attributes, 2), SHIFT_REPEAT(4562),
  [9252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4503),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [9256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [9260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4469),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [9264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [9266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4507),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [9272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [9276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4478),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6407),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [9292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [9294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [9298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [9300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [9304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4415),
  [9306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [9308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [9310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [9314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [9316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3879),
  [9318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpolated_raw_string_repeat1, 2),
  [9320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_raw_string_repeat1, 2), SHIFT_REPEAT(1032),
  [9323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_raw_string_repeat1, 2), SHIFT_REPEAT(4415),
  [9326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_raw_string_repeat1, 2), SHIFT_REPEAT(4415),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [9331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [9333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__in_out_contract_expressions, 2),
  [9335] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__in_out_contract_expressions, 2), SHIFT_REPEAT(6101),
  [9338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__in_out_contract_expressions, 2), SHIFT_REPEAT(6104),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [9345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4423),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [9349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [9353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [9357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_member_repeat1, 2),
  [9359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_member_repeat1, 2), SHIFT_REPEAT(4920),
  [9362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_enum_member_repeat1, 2), SHIFT_REPEAT(2455),
  [9365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2911),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [9369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4417),
  [9371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2991),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [9375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [9377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [9381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4444),
  [9383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [9387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4410),
  [9389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarator, 1),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [9393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [9397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [9401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4414),
  [9403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [9405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [9407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4442),
  [9409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [9411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [9413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [9415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [9417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2731),
  [9419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [9421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [9423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [9425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4453),
  [9427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [9429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [9431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [9433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4458),
  [9435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 4),
  [9437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [9439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [9441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [9443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [9445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [9447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [9449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [9451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [9453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [9455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2638),
  [9457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [9459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [9461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4094),
  [9463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [9467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5674),
  [9471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [9475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4439),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [9481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [9483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [9487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [9491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [9493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [9495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [9497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [9499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [9501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__in_out_contract_expressions, 1),
  [9503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__function_contract, 1), REDUCE(aux_sym__in_out_contract_expressions, 1),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6204),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [9514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1),
  [9516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6491),
  [9520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [9522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [9524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [9538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [9540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [9542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_in_contract_expression, 4),
  [9544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [9546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [9548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [9550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [9552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [9554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [9560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [9562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 3),
  [9564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [9566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameters, 3),
  [9568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [9570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [9572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [9582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [9584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_fqn, 1),
  [9586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [9588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [9590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [9592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [9594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [9596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [9604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [9606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [9608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [9610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [9612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [9614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [9620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [9622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [9634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2),
  [9636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [9642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [9644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [9646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [9648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [9650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_out_contract_expression, 6),
  [9652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(6407),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [9663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [9665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [9675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [9677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [9681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [9683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [9685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [9687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_out_contract_expression, 5),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [9691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_fqn, 2),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [9705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2), REDUCE(sym_template_parameter, 2),
  [9708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [9710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [9712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_fqn_repeat1, 2), SHIFT_REPEAT(5912),
  [9715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_fqn_repeat1, 2),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [9723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [9737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [9763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [9765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [9769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [9771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [9775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [9777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_mixin_repeat1, 2),
  [9779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_mixin_repeat1, 2), SHIFT(2548),
  [9782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [9784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_mixin_repeat1, 2), SHIFT_REPEAT(5531),
  [9787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [9795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [9803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_declaration_repeat1, 2), SHIFT_REPEAT(4920),
  [9806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_declaration_repeat1, 2),
  [9808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [9810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [9812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(6378),
  [9815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [9821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [9823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__base_class_list, 1),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [9833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate_initializer, 4),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4996),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [9841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__base_class_list, 2),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [9845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__base_class_list_repeat1, 2),
  [9847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__base_class_list_repeat1, 2), SHIFT_REPEAT(3223),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [9852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5746),
  [9854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [9856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_initializer, 3),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [9860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [9862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [9864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_parameter, 3),
  [9866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [9872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [9874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [9876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [9878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [9880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [9882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(1129),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2692),
  [9899] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2), SHIFT(1820),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [9905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), SHIFT(1820),
  [9908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [9912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [9914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate_initializer, 5),
  [9916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [9918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [9920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aggregate_initializer, 3),
  [9922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [9924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [9926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [9928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [9930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [9932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [9934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [9942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6521),
  [9944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [9946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2, .production_id = 17),
  [9948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2, .production_id = 17), SHIFT_REPEAT(741),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [9961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(2693),
  [9964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [9966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [9968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [9970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [9978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [9980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [9982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [9984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [9986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [9988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [9990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [9992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [9994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [9996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [9998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [10002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [10004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [10006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__template_argument_list_repeat1, 2),
  [10008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__template_argument_list_repeat1, 2), SHIFT_REPEAT(982),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [10065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__template_parameter_list, 1),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [10073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [10083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [10093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__argument_list, 1),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [10119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [10121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [10123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_arguments, 3),
  [10125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [10127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [10129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [10131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [10133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [10135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [10137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [10139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [10141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [10143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [10151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [10159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [10161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [10163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [10165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [10167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [10169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [10171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [10173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [10175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [10177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [10179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [10181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 4),
  [10183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [10185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [10187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [10189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [10191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [10193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [10195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [10197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [10199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [10201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [10203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [10205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [10207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [10209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [10211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_enum_declaration_repeat1, 2),
  [10213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_enum_declaration_repeat1, 2), SHIFT_REPEAT(2784),
  [10216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [10222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [10224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [10230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [10236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [10246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [10248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [10250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [10252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [10254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [10256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [10258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declarator_identifier_list_repeat1, 2), SHIFT_REPEAT(6189),
  [10261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declarator_identifier_list_repeat1, 2),
  [10263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [10265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2627),
  [10267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [10269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [10271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [10273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [10275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [10277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [10279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [10281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__template_parameter_list_repeat1, 2),
  [10283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__template_parameter_list_repeat1, 2), SHIFT_REPEAT(2940),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [10292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2),
  [10294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(2691),
  [10297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [10299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2758),
  [10301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [10303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [10305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [10307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [10309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [10311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [10313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [10315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [10317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5933),
  [10319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [10321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [10323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5728),
  [10333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [10343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [10345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [10347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat1, 2), SHIFT_REPEAT(5449),
  [10350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alias_declaration_repeat1, 2),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [10356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [10358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [10360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat1, 2),
  [10362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__argument_list_repeat1, 2), SHIFT_REPEAT(1035),
  [10365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [10371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_index_expression_repeat1, 2),
  [10373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_index_expression_repeat1, 2), SHIFT_REPEAT(842),
  [10376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [10378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [10380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [10382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 1),
  [10384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [10386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [10388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [10390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [10392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1),
  [10394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [10398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imported, 1),
  [10400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2746),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [10406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__named_argument_list_repeat1, 2),
  [10408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__named_argument_list_repeat1, 2), SHIFT_REPEAT(843),
  [10411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [10413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [10415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [10417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [10419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [10421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [10423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [10425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [10427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [10429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [10431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_list_repeat1, 2), SHIFT_REPEAT(1219),
  [10434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [10436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [10438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_class, 1),
  [10440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [10442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [10444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [10446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [10448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [10450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 1),
  [10452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [10454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [10456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [10458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [10460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [10462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [10464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [10466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [10468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [10470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [10472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [10474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [10476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [10478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [10480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [10482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [10484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [10486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [10488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [10490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [10492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [10494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [10496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [10498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_aggregate_initializer_repeat1, 2),
  [10500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_aggregate_initializer_repeat1, 2), SHIFT_REPEAT(718),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [10507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [10509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [10511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [10513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [10521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [10523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_foreach_statement_repeat1, 2), SHIFT_REPEAT(2847),
  [10526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_foreach_statement_repeat1, 2),
  [10528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [10530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [10532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [10534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [10536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [10538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [10540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [10542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [10544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__base_class_list_repeat1, 2), SHIFT_REPEAT(3239),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [10563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [10579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(5410),
  [10582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2),
  [10584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [10586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 2),
  [10588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [10590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [10592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [10594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [10596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4351),
  [10598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [10600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [10602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [10604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [10606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [10608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [10610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_auto_declaration_repeat1, 2, .production_id = 10), SHIFT_REPEAT(5610),
  [10613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_auto_declaration_repeat1, 2, .production_id = 10),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3226),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [10625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [10627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [10633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat2, 2), SHIFT_REPEAT(4680),
  [10636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat2, 2),
  [10638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [10640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [10642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [10644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [10650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [10652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [10654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [10656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [10658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [10660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [10662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [10664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [10666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [10668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [10670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__template_argument_list, 1),
  [10672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [10674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [10676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [10678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [10680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [10682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imported, 3, .production_id = 5),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [10688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [10690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6436),
  [10692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [10694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [10696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [10698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_bind, 1),
  [10700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [10702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [10704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [10706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [10708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [10710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [10712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [10714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [10716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [10718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3),
  [10720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [10722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [10724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [10726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [10728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [10730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [10732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [10734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [10736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [10738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [10740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [10742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [10744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [10746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [10748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [10750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [10752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [10754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [10756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [10758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_manifest_constant_repeat1, 2), SHIFT_REPEAT(5431),
  [10761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_manifest_constant_repeat1, 2),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [10765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [10767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6001),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [10773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [10785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__enum_body_repeat1, 2),
  [10787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__enum_body_repeat1, 2), SHIFT_REPEAT(4379),
  [10790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [10796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [10804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [10806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [10808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [10810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [10812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [10814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [10816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [10818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [10820] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), REDUCE(sym_conditional_declaration, 2), SHIFT(1873),
  [10824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6028),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [10828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [10830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4715),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [10840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [10842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [10846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [10848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [10872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [10876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [10878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarator, 3),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [10882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [10884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [10886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [10888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [10890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [10896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [10910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [10924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [10926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__auto_assignment, 3, .production_id = 8),
  [10928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_auto_declaration_repeat1, 2, .production_id = 1),
  [10930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [10932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [10934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [10936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [10938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3221),
  [10940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [10942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [10944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [10946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [10948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [10950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [10952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [10954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [10956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [10958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_initializer, 1),
  [10960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [10962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__declaration_or_statement, 1), SHIFT(1873),
  [10965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_declarator, 3),
  [10967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [10969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [10971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [10973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [10975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [10977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [10979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [10981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [10983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [10985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [10987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [10989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [10991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [10993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [10995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [10997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [11001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [11003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [11005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [11007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [11009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [11011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [11013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [11015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 1),
  [11017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [11019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [11025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [11033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [11037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [11039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [11043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5787),
  [11045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [11047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [11049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [11051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [11053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ellipses, 1),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [11089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [11093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [11095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest_declarator, 4),
  [11097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [11099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [11101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [11103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [11105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [11107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [11109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [11111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [11113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [11115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [11117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 7),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [11125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [11127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [11129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [11131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [11133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [11135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2631),
  [11137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [11141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [11145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [11147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [11153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5647),
  [11155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4975),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [11171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [11173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [11175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [11177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [11179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [11181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [11183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [11185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [11187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [11189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [11191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [11193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [11195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [11197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [11199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [11201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [11203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [11205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [11207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [11209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [11211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [11213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [11215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [11217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [11219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declarator, 4),
  [11221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [11223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [11225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [11227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [11229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [11231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [11233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 6),
  [11235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [11237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [11239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [11241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__auto_assignment, 4, .production_id = 14),
  [11243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [11245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [11247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [11249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [11251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [11253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [11255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [11257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [11259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [11261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [11263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [11265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [11267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [11269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [11271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [11273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5316),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [11285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [11287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [11289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [11291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6250),
  [11293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [11295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [11297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [11299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [11301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [11303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2, .production_id = 11),
  [11305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [11307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2023),
  [11309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [11311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [11317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [11319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_arguments, 1),
  [11321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [11323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [11325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [11327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [11329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [11331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [11333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [11335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [11337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [11339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [11341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [11343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [11345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [11347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [11349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [11351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [11353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [11355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [11357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [11359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [11361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [11363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [11365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [11367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [11369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [11371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [11373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [11375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [11385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bitfield_declarator, 5),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [11401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 3),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [11411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 3),
  [11413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [11415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [11417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [11419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [11421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [11423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [11425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [11427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [11429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [11431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [11433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [11435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [11437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [11439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_initializer, 3),
  [11441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [11443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [11445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [11447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_bind, 3),
  [11449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [11451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [11453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [11455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [11457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [11459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_type, 3),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5658),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [11487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [11489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [11491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1978),
  [11493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [11495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [11497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [11499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [11501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [11507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [11511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [11517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [11519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [11521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [11523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [11525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5856),
  [11527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3823),
  [11529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [11531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [11533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [11535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [11537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [11539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3220),
  [11541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [11543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [11545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [11547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [11549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [11551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [11553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [11555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [11557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [11559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [11561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [11563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [11565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [11567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [11569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [11571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [11575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [11577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5718),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6122),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5694),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [11643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [11647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6384),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [11739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6184),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [11803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5335),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [11845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6272),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2767),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [11863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [11867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [11883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [11903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5904),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3859),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [11929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [11979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2723),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [12011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [12033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [12055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [12059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2792),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [12093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [12099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [12109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [12133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_qualifier, 2),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [12141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [12143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [12145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [12149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [12153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [12157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [12161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [12165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [12259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [12263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [12279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [12289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [12295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2714),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [12325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [12341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3795),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [12363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [12441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [12469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2890),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [12487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [12499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [12503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [12505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [12507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [12509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [12541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [12557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4740),
  [12559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [12561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [12563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [12565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [12567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4098),
  [12569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5792),
  [12571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [12573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [12575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [12577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [12579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [12585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [12587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2764),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [12593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [12595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [12597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [12599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [12601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [12603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [12605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [12607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [12609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [12611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [12613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [12615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [12617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [12627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4782),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [12651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2715),
  [12655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [12657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [12677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [12681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [12683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [12691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2885),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [12695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [12697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [12699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [12701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [12703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [12705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [12707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2652),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [12733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6068),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6424),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6425),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2777),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [12771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [12773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [12775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6112),
  [12779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [12781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [12783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [12789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3191),
  [12795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [12797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [12799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [12801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [12803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [12805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [12815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [12817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [12819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [12821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [12823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [12825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [12827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [12829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [12831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [12833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [12835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [12843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5940),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [12883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [12909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6447),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [12913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3242),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [12955] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [12983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6381),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6462),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [12999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [13001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [13003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [13005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [13007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [13009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [13011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [13013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [13015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [13017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [13019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [13021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [13023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [13025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [13027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [13029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [13031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [13033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [13035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [13037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [13039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [13041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [13043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [13045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [13047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [13049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [13051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [13053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [13055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [13057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [13059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [13061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [13063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [13065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [13067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [13069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2852),
  [13071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2880),
  [13073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [13075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [13077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [13079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [13081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [13083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [13085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [13087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [13089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [13091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [13093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2882),
  [13095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2884),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [13101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [13103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token_end_file = 0,
  ts_external_token_comment = 1,
  ts_external_token_directive = 2,
  ts_external_token_int_literal = 3,
  ts_external_token_float_literal = 4,
  ts_external_token__string = 5,
  ts_external_token_not_in = 6,
  ts_external_token_not_is = 7,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_end_file] = sym_end_file,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_directive] = sym_directive,
  [ts_external_token_int_literal] = sym_int_literal,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token__string] = sym__string,
  [ts_external_token_not_in] = sym_not_in,
  [ts_external_token_not_is] = sym_not_is,
};

static const bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_end_file] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_directive] = true,
    [ts_external_token_int_literal] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token__string] = true,
    [ts_external_token_not_in] = true,
    [ts_external_token_not_is] = true,
  },
  [2] = {
    [ts_external_token_end_file] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_directive] = true,
  },
  [3] = {
    [ts_external_token_end_file] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_directive] = true,
    [ts_external_token_int_literal] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token__string] = true,
  },
  [4] = {
    [ts_external_token_end_file] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_directive] = true,
    [ts_external_token_not_in] = true,
    [ts_external_token_not_is] = true,
  },
  [5] = {
    [ts_external_token_end_file] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_directive] = true,
    [ts_external_token_int_literal] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_d_external_scanner_create(void);
void tree_sitter_d_external_scanner_destroy(void *);
bool tree_sitter_d_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_d_external_scanner_serialize(void *, char *);
void tree_sitter_d_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_d() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_d_external_scanner_create,
      tree_sitter_d_external_scanner_destroy,
      tree_sitter_d_external_scanner_scan,
      tree_sitter_d_external_scanner_serialize,
      tree_sitter_d_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
